update PMS_EVENT$PMS P
set    P.ROOM_OWNERSHIP_PERCENT = (select RO.OWNERSHIP_PERCENT
                                   from   ROOM_OWNER$PMS RO
                                   where  RO.ID_OWNER = P.ID_OWNER
                                          and RO.ID_ROOM_CONTRACT = P.ID_ROOM_CONTRACT)
where  P.ID_OWNER is not null
       and P.ID_ROOM_CONTRACT is not null;


delete from SALE_TAXATION_TAX t
where  not exists (select *
                   from   SALE_TAXATION st
                   where  st.ID_SALE_TAXATION = t.ID_SALE_TAXATION);


set term ^;


create or alter procedure TMP_RESERV_PREPOST_REGEN
AS
declare variable rd_dbkey char(8);
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable selection_id integer;
declare variable id_reserv_detail integer;
begin
  selection_id = gen_id(SELECTION_GEN,1);
  update RESERV_DETAIL RD
  set    rd.SELECTION_ID = :selection_id
  where  RD.CHECK_STATUS < 0
         and ((RD.POSTING_TRANSACTION_UUID is null) or (RD.POSTING_TRANSACTION_UUID = '__invalid__'))
         and rd.is_anul = 0
         and exists (select count(rp.ID_RESERV_PREPOST)
                     from   RESERV_PREPOST rp
                     where  rp.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                            and rp.IS_BASE = 1
                     group by rp.ID_RESERV_DETAIL, rp.ID_GUEST, rp.DATE_POST
                     having count(rp.ID_RESERV_PREPOST) > 1);

  for
    select  rd.RDB$DB_KEY, rd.ID_RESERV_DETAIL
    from    RESERV_DETAIL rd
    where   rd.SELECTION_ID = :selection_id
    into    :rd_dbkey, :id_reserv_detail
  do begin
    delete from RESERV_PREPOST p
    where  p.ID_RESERV_DETAIL = :id_reserv_detail;

    begin
      execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
      returning_values  :err_code, :err_text;
      if (:err_code < 0) then exception BOOKING_EXCEPTION :err_code || ' - '|| :err_text;
  
      when any do begin end
    end

    delete from TAR_CALC_POST$TMP;
  end
end
^


set term ;^

execute procedure TMP_RESERV_PREPOST_REGEN;

drop procedure TMP_RESERV_PREPOST_REGEN;

commit work;
