/* Drop: UNQ_SERVICES_EXT_CODE (TIdxData) */
DROP INDEX UNQ_SERVICES_EXT_CODE;

RECONNECT;

/* Drop: UNQ_SERVICES_NAME_IDX (TIdxData) */
DROP INDEX UNQ_SERVICES_NAME_IDX;

commit work;


set term ^;

create procedure TMP_UNQ_SRV_NAME_FIX
as
  declare variable srv_name varchar(30);
  declare variable id_hotel integer;
  declare variable cnt integer;
  declare variable min_srv_id integer;
  declare variable id_service integer;
begin
  for
    select s.SERVICE_NAME, s.ID_HOTEL, min(s.ID_SERVICE)
    from   SERVICES s
    where  s.IS_BASE = 0
    group by s.SERVICE_NAME, s.ID_HOTEL
    having count(*) > 1
    into   :srv_name, :id_hotel, :min_srv_id
  do begin
    cnt = 1;
    for
      select ss.ID_SERVICE
      from   SERVICES ss
      where  ss.SERVICE_NAME = :srv_name
             and ss.ID_HOTEL = :id_hotel
             and ss.IS_BASE = 0
             and ss.ID_SERVICE > :min_srv_id
      order by ss.ID_SERVICE asc
      into   :id_service
    do begin
      update SERVICES su
      set    su.SERVICE_NAME = substring(su.SERVICE_NAME || :cnt from 1 for 30),
             su.TMP$ORIG_ID = -:id_service
      where  su.ID_SERVICE = :id_service;
      cnt = :cnt + 1;
    end 
  end 
end
^

set term ;^

execute procedure TMP_UNQ_SRV_NAME_FIX;
commit work;

drop procedure TMP_UNQ_SRV_NAME_FIX;
commit work;

RECONNECT;

ALTER TABLE SERVICES ADD SERVICE_NAME_UNQ_HASH UUID;

/* Create Unique... */
ALTER TABLE SERVICES ADD CONSTRAINT UNQ_SERVICES_NAME_HASH UNIQUE (SERVICE_NAME_UNQ_HASH);

/* Creating trigger... */
SET TERM ^ ;

CREATE TRIGGER SERVICES_BIU1 FOR SERVICES
ACTIVE BEFORE INSERT OR UPDATE POSITION 1 
AS
begin
  new.SERVICE_NAME_UNQ_HASH = MD5HASH(new.service_name|| '-' || new.id_hotel || '-' || iif(new.is_base = 0, 0, new.id_service));
end
^


SET TERM ; ^

ALTER TABLE SERVICES ALTER COLUMN ID_SERVICE POSITION 1;

ALTER TABLE SERVICES ALTER COLUMN ID_SERVICE_GROUP POSITION 2;

ALTER TABLE SERVICES ALTER COLUMN ID_HOTEL POSITION 3;

ALTER TABLE SERVICES ALTER COLUMN SERVICE_NAME POSITION 4;

ALTER TABLE SERVICES ALTER COLUMN SERVICE_TYPE POSITION 5;

ALTER TABLE SERVICES ALTER COLUMN IS_MANUAL_PRICE POSITION 6;

ALTER TABLE SERVICES ALTER COLUMN IS_RATE_PRICE POSITION 7;

ALTER TABLE SERVICES ALTER COLUMN IS_DETAILS POSITION 8;

ALTER TABLE SERVICES ALTER COLUMN IS_DELETED POSITION 9;

ALTER TABLE SERVICES ALTER COLUMN REVENUE_GROUP POSITION 10;

ALTER TABLE SERVICES ALTER COLUMN REVENUE_ACCOUNT POSITION 11;

ALTER TABLE SERVICES ALTER COLUMN ACCOUNT_NAME POSITION 12;

ALTER TABLE SERVICES ALTER COLUMN VAUCHER_PACKET POSITION 13;

ALTER TABLE SERVICES ALTER COLUMN EXTRA_PACKET_NAME POSITION 14;

ALTER TABLE SERVICES ALTER COLUMN EXT_CODE POSITION 15;

ALTER TABLE SERVICES ALTER COLUMN UUID POSITION 16;

ALTER TABLE SERVICES ALTER COLUMN SUBSCRIBER_ID POSITION 17;

ALTER TABLE SERVICES ALTER COLUMN PRICE POSITION 18;

ALTER TABLE SERVICES ALTER COLUMN PRICE_CURR POSITION 19;

ALTER TABLE SERVICES ALTER COLUMN ID_SERVICE_PACKET POSITION 20;

ALTER TABLE SERVICES ALTER COLUMN IS_BASE POSITION 21;

ALTER TABLE SERVICES ALTER COLUMN IS_ACC_POST_ITEM POSITION 22;

ALTER TABLE SERVICES ALTER COLUMN TMP$ORIG_ID POSITION 23;

ALTER TABLE SERVICES ALTER COLUMN TMP$ORIG_TYPE_HRANA POSITION 24;

ALTER TABLE SERVICES ALTER COLUMN TMP$ORIG_TYPE_STAY POSITION 25;

ALTER TABLE SERVICES ALTER COLUMN TMP$ORIG_ROOM_TYPE POSITION 26;

ALTER TABLE SERVICES ALTER COLUMN SERVICE_NAME_UNQ_HASH POSITION 27;

update services s
set    s.SERVICE_NAME_UNQ_HASH = s.SERVICE_NAME_UNQ_HASH;

commit work;
