set term ^;

create procedure TMP_WRONG_CORRECTIONS_FIX
as
declare variable dbkey char(8);
begin

  for
    select c.RDB$DB_KEY
    from   account_post ap
           join ACCOUNT_POST_CORRECTION c on c.ID_ACCOUNT_POST = ap.ID_ACCOUNT_POST
    where  ap.IS_ANUL = 1
           and c.DATETIME_CREATED > (ap.ANUL_DATETIME + cast(10 as double precision)/60/60/24)
           and c.ID_END_WORK is null
    into   :dbkey
  do begin
    delete from ACCOUNT_POST_CORRECTION pc
    where  pc.RDB$DB_KEY = :dbkey;
  end

  insert into ACCOUNT_POST_CORRECTION (ID_ACCOUNT_POST, ID_ACCOUNT, ID_SERVICE, ID_SALE_TAXATION,
         ID_GUEST, CORRECTION_DATE, DATE_POST_ORIG, OLD_QTY, OLD_PRICE, OLD_CURR_POST,
         OLD_RATE_POST, OLD_POST_NET_VALUE, OLD_POST_GROSS_VALUE, NEW_QTY, NEW_PRICE,
         NEW_CURR_POST, NEW_RATE_POST, NEW_POST_NET_VALUE, NEW_POST_GROSS_VALUE,
         IS_QTY_CORRECT, QTY_CORRECT, EXTRA_QTY_CORRECT, IS_PRICE_CORRECT, PRICE_CORRECT,
         IS_POSITIVE, IS_OPEN, ID_DOC_HEAD, REASON_OF_CORRECT, USER_CORRECT,
         DATETIME_CREATED, ID_END_WORK)
  select c.ID_ACCOUNT_POST, c.ID_ACCOUNT, c.ID_SERVICE, c.ID_SALE_TAXATION,
         c.ID_GUEST, h.SYSTEM_DATE, c.DATE_POST_ORIG,
         c.NEW_QTY, c.NEW_PRICE, c.OLD_CURR_POST, c.OLD_RATE_POST, c.NEW_POST_NET_VALUE, c.NEW_POST_GROSS_VALUE,
         c.OLD_QTY, c.OLD_PRICE, c.NEW_CURR_POST, c.NEW_RATE_POST, c.OLD_POST_NET_VALUE, c.OLD_POST_GROSS_VALUE,
         c.IS_QTY_CORRECT, -c.QTY_CORRECT, -c.EXTRA_QTY_CORRECT, c.IS_PRICE_CORRECT, -c.PRICE_CORRECT,
         1-c.IS_POSITIVE, c.IS_OPEN, c.ID_DOC_HEAD, '$$$SYSTEM - bug3914 fix$$$', current_user, current_timestamp, null
  from   account_post ap
         join ACCOUNT_POST_CORRECTION c on c.ID_ACCOUNT_POST = ap.ID_ACCOUNT_POST
         join account a on a.ID_ACCOUNT = c.ID_ACCOUNT
         join hotel h on h.ID_HOTEL = a.ID_HOTEL
  where  ap.IS_ANUL = 1
         and c.DATETIME_CREATED > (ap.ANUL_DATETIME + cast(10 as double precision)/60/60/24)
         and c.ID_END_WORK is not null
  order by c.ID_ACC_POST_CORRECT asc;
end
^

set term ;^

execute procedure TMP_WRONG_CORRECTIONS_FIX;

commit work;

drop procedure TMP_WRONG_CORRECTIONS_FIX;

commit work;

