update RESOURCE_RESERVATION r
set r.STATUS = 'CHECKED_IN'
where r.STATUS = 'RESERVED'
      and exists (select od.ID_RESOURCE_OCCUPANCY_DATA
                  from   RESOURCE_OCCUPANCY_DATA od
                         join safes s on s.ID_SAFE = od.ID_RESOURCE
                  where  od.ID_RESOURCE_OCCUPANCY_DATA = r.ID_RESOURCE_OCCUPANCY_DATA);

update RESERV_DETAIL rd
set    rd.ID_AGENT_PAYMENT =
       coalesce((select np.ID_PAYMENT_TYPE
                 from   PAYMENT_TYPE cp                
                        join PAYMENT_TYPE np on np.PAYMENT_TYPE = cp.PAYMENT_TYPE and np.ID_HOTEL = rd.ID_HOTEL
                 where  cp.ID_PAYMENT_TYPE = rd.ID_AGENT_PAYMENT),
                rd.ID_AGENT_PAYMENT)
where  rd.ID_AGENT_PAYMENT is not null
       and not exists (select pt.ID_PAYMENT_TYPE
                       from   PAYMENT_TYPE pt
                       where  pt.ID_PAYMENT_TYPE = rd.ID_AGENT_PAYMENT
                              and pt.ID_HOTEL = rd.ID_HOTEL);

update RESERV_DETAIL rd
set    rd.ID_PERSON_PAYMENT =
       coalesce((select np.ID_PAYMENT_TYPE
                 from   PAYMENT_TYPE cp                
                        join PAYMENT_TYPE np on np.PAYMENT_TYPE = cp.PAYMENT_TYPE and np.ID_HOTEL = rd.ID_HOTEL
                 where  cp.ID_PAYMENT_TYPE = rd.ID_PERSON_PAYMENT),
                rd.ID_PERSON_PAYMENT)
where  rd.ID_PERSON_PAYMENT is not null
       and not exists (select pt.ID_PAYMENT_TYPE
                       from   PAYMENT_TYPE pt
                       where  pt.ID_PAYMENT_TYPE = rd.ID_PERSON_PAYMENT
                              and pt.ID_HOTEL = rd.ID_HOTEL);

