set term ^;

create or alter procedure TMP_DOC_TAXES_REASON_REGEN
as
declare variable id_doc_head type of ID_REF;
declare variable diff_vat_reason type of TDESCRIPTION_LONG;
declare variable d_dbkey char(8);
begin
  for
    select DH.ID_DOC_HEAD, DH.DIFF_VAT_REASON
    from   DOC_HEAD$INT DH
    into   :id_doc_head, :diff_vat_reason
  do begin
    d_dbkey = null;
    select   first 1 DT.RDB$DB_KEY
    from     DOC_TAXES DT
    where    DT.ID_DOC_HEAD = :id_doc_head
    order by DT.TAX_PERCENT
    into     :d_dbkey;

    update DOC_TAXES DT
    set    DT.TAXATION_REASON = :diff_vat_reason
    where  DT.RDB$DB_KEY = :d_dbkey;
  end
end
^

create procedure TMP_ROOM_PERIOD_FIX
as
declare variable id_room integer;
begin
  for
    select r.ID_ROOM
    from   ROOMS r
    into   :id_room
  do begin
    execute procedure ROOM_PERIOD_TODATE$INT (:id_room);
  end 
end
^


set term ;^

execute procedure TMP_DOC_TAXES_REASON_REGEN;

drop procedure TMP_DOC_TAXES_REASON_REGEN;

commit work;

execute procedure TMP_ROOM_PERIOD_FIX;

drop procedure TMP_ROOM_PERIOD_FIX;

commit work;


INSERT INTO ERROR_CODES (ERR_CODE, LANG_CODE, ERR_TEXT, ERR_TYPE, IS_SYSTEM) VALUES (-60, 'bg', '       -    !', 1, 0);

INSERT INTO SYSTEM_ENUM (GROUP_, KEY_, DEFAULT_CAPTION, ORDER_TAG) VALUES ('log.SALE_TAX', 'TAX_REASON_CHANGED', '     %1  %2', NULL);


UPDATE RIGHTS
SET    DEF_DESCRIPTION = '  '
WHERE (RIGHT_CODE = 'SAFE_BOOKING_ACCESS');


UPDATE RIGHTS
SET    DEF_DESCRIPTION = '  '
WHERE (RIGHT_CODE = 'SAFE_BOOKING_CANCEL');

commit work;

update hotel set last_known_uuid=uuid;
commit work;

UPDATE REPORT_COMPOSITE
SET    NAME = cast('  ' as varchar(255) CHARACTER set win1251),
       NOTE = cast('  ' as varchar(255) CHARACTER set win1251)
WHERE  CLASS = 'RESERV_CONFIRMATION';
commit work;

