INSERT INTO RIGHTS (RIGHT_CODE, RIGHT_GROUP, DEF_DESCRIPTION)
VALUES ('MASK_DIFF_FROM_DEF', 'REPORT', '              ');

insert into RIGHTS_GROUPS_LINES (ID_RIGHT_GROUP, RIGHT_CODE)
select RG.ID_RIGHT_GROUP, 'MASK_DIFF_FROM_DEF'
from   RIGHTS_GROUPS RG;


/* reverse deleted rooms ids (remnants of old versions) to preserve FK constraint crashes on next update */
update ROOM_MAGIC rm
set    rm.ID_ROOM = -(1000000000 + rm.ID_ROOM)
where  rm.ID_ROOM > 0
       and not exists (select *
                       from   ROOMS r
                       where  r.ID_ROOM = rm.ID_ROOM);

update ROOM_MAGIC rm
set    rm.ROOM_STATUS = (select  rp.STATUS
                        from    ROOM_PERIOD$PMS rp
                        where   rp.ID_ROOM = rm.ID_ROOM$INT
                                and rp.FROM_DATE <= rm.BUSY_DATE
                                and rp.TO_DATE >= rm.BUSY_DATE);


insert into DOC_PAY_USAGE (ID_DOC_HEAD, ID_ACCOUNT_PAYMENT, PAY_AMOUNT, PAY_RATE, DOC_AMOUNT, DOC_RATE, EQUAL_PAY_DOC_RATE)
select DP.ID_DOC_HEAD, DP.ID_ACCOUNT_PAYMENT, DP.PAY_AMOUNT, DP.PAY_RATE, DP.DOC_AMOUNT, DP.DOC_RATE, DP.EQUAL_PAY_DOC_RATE
from   DOC_PAYMENTS DP;

set term ^;


create procedure TMP_ROOM_COUNT_EXPORT
as
declare variable id_hotel integer;
declare variable id_allotment integer;
declare variable cnt_rooms integer;
begin
  for
    select  h.ID_HOTEL, h.ID_PHYSICAL_ALLOTMENT,
            (select count(r.ID_ROOM)
             from   ROOMS r
             where  r.ID_HOTEL = h.ID_HOTEL)
    from    HOTEL h
    where   h.IS_USE = 1
    into    :id_hotel, :id_allotment, :cnt_rooms
  do begin

    if (:cnt_rooms > 0) then begin
      execute procedure EXPORT_LOG_FORCE$EXC(1);
      execute procedure EXPORT_LOG_INSERT$EXC ('ALLOTMENT', :id_allotment, :id_hotel, 0);
    end
  end 
end
^

set term ;^

execute procedure TMP_ROOM_COUNT_EXPORT;

commit work;

drop procedure TMP_ROOM_COUNT_EXPORT;

commit work;

