
delete from TAR_UI_PARAMS_RELATION
where  INTERNAL_PARAM_NAME = 'IN_BASE_PRICE'
       and BO_TYPE = 'DISCOUNT';

delete from  TAR_UI_DEFINE_COLUMNS dc
where  dc.TAR_PARAM = 'IN_BASE_PRICE'
       and dc.TAR_BUSINESS_OBJECT = 'DISCOUNT';


delete from RIGHTS_USER_GROUPS rug
where  rug.USER_NAME = 'SYSDBA';


UPDATE SETTING
SET    DEF_DESCRIPTION = '   ( ); : ":"'
WHERE (SETTING_CODE = 'CHECK_IN_HOUR');


UPDATE SETTING
SET    DEF_DESCRIPTION = '   ( ); : ":"'
WHERE (SETTING_CODE = 'CHECK_OUT_HOUR');

-- http://bugzilla.clockbs.com/show_bug.cgi?id=4384  fix
update ACCOUNT_POST_CORRECTION c
set    c.ID_DOC_HEAD = coalesce((select first 1 d.ID_DOC
                        from   DOC_LINE_POST_VALUES pv
                               left join DOC_LINE dl on pv.ID_DOC_LINE = dl.ID_DOC_LINE
                               left join DOC_HEAD d on dl.ID_DOC_HEAD = d.ID_DOC
                        where  d.ID_DOC > c.ID_DOC_HEAD
                               and d.IS_ANUL = 0
                               and d.IS_STORNED = 0
                               and d.IS_STORNO = 0
                               and pv.ID_ACCOUNT_POST = c.ID_ACCOUNT_POST
                        order by d.ID_DOC asc), -1)

where  /*c.ID_END_WORK is null
       and*/ c.ID_DOC_HEAD >  0
       and exists (select dr.ID_DOC
                   from   DOC_HEAD dr
                   where  dr.ID_DOC = c.ID_DOC_HEAD
                          and ((dr.IS_ANUL = 1) or (dr.IS_STORNED = 1)));

commit work;

set term ^;

create or alter procedure TMP_SEC_CURR_VALUES_REMAKE
AS
  declare variable id_doc integer;
  declare variable id_sale_taxation integer;
  declare variable id_sale_tax integer;
  declare variable doc_net_value numeric(15,4);
  declare variable sec_curr_net_value numeric(15,4);
  declare variable sec_curr_gross_value numeric(15,4);
  declare variable value_wot_tax numeric(15,4);
  declare variable taxable_value numeric(15,4);
  declare variable tax_value numeric(15,4);
  declare variable round_to numeric(15,4);
  declare variable cross_rate double precision;
begin
  update DOC_HEAD$INT dd
  set    dd.DOC_NET_VALUE = 0,
         dd.SECOND_CURR_NET_VALUE = 0,
         dd.SECOND_CURR_GROSS_VALUE = 0
  where  dd.SECOND_CURRENCY is not null;

  update DOC_TAXES dt
  set    dt.SEC_CURR_NONTAXABLE_VALUE = null,
         dt.SEC_CURR_TAXABLE_VALUE = null,
         dt.SEC_CURR_TAX_VALUE = null;

  for
    select d.ID_DOC_HEAD, c.ROUND_TO, d.DOC_RATE / d.SECOND_CURR_RATE
    from   DOC_HEAD$INT d
           join CURRS c on c.CURR = d.SECOND_CURRENCY
    into   :id_doc, :round_to, :cross_rate
  do begin
    for
      select  dl.ID_SALE_TAXATION, sum(dl.WOT_VAT), sum(dl.SEC_CURR_NET_VALUE), sum(dl.SEC_CURR_GROSS_VALUE)
      from    DOC_LINE dl
      where   dl.ID_DOC_HEAD = :id_doc
      group by dl.ID_SALE_TAXATION
      into    :id_sale_taxation, :doc_net_value, :sec_curr_net_value, :sec_curr_gross_value
    do begin
      for
        select td.ID_SALE_TAX, sum(td.VALUE_WOT_TAX), sum(td.TAXABLE_VALUE), sum(td.TAX_VALUE)
        from   TAX_VALUE_DEDUCT (:sec_curr_gross_value, :round_to, :id_sale_taxation, 1) td
        group by 1
        into   :id_sale_tax, :value_wot_tax, :taxable_value, :tax_value
      do begin
        update DOC_TAXES DT
        set    dt.SEC_CURR_NONTAXABLE_VALUE = coalesce(dt.SEC_CURR_NONTAXABLE_VALUE, 0) + :value_wot_tax - :taxable_value,
               dt.SEC_CURR_TAXABLE_VALUE = coalesce(dt.SEC_CURR_TAXABLE_VALUE, 0) + :taxable_value,
               dt.SEC_CURR_TAX_VALUE = coalesce(dt.SEC_CURR_TAX_VALUE, 0) + :tax_value
        where  DT.ID_DOC_HEAD = :id_doc
               and dt.ID_SALE_TAX = :id_sale_tax;
      end
  
      update DOC_HEAD$INT dh
      set    dh.DOC_NET_VALUE = coalesce(dh.DOC_NET_VALUE, 0) + :doc_net_value,
             dh.SECOND_CURR_NET_VALUE = coalesce(dh.SECOND_CURR_NET_VALUE, 0) + :sec_curr_net_value,
             dh.SECOND_CURR_GROSS_VALUE = coalesce(dh.SECOND_CURR_GROSS_VALUE, 0) + :sec_curr_gross_value
      where  dh.ID_DOC_HEAD = :id_doc;
    end

    update DOC_FOOTER DF
    set    df.SECOND_CURR_DISCOUNT_VALUE = df.FOOTER_VALUE * :cross_rate,      
           df.SECOND_CURR_DISCOUNTABLE_VALUE = df.TAXABLE_VALUE * :cross_rate
    where  df.ID_DOC_HEAD = :id_doc;
  end
end
^

set term ;^

execute procedure TMP_SEC_CURR_VALUES_REMAKE;

commit work;

drop procedure TMP_SEC_CURR_VALUES_REMAKE;

commit work;

