
INSERT INTO SYSTEM_ENUM (GROUP_, KEY_, DEFAULT_CAPTION, ORDER_TAG) VALUES ('list_group', 'EU countries (ISO ALPHA 2)', '     (   )', NULL);

insert into LISTS_ITEMS(LIST_GROUP, LIST_ITEM)
select 'EU countries (ISO ALPHA 2)', c.COUNTRY_CODE
from   COUNTRY c
where  c.COUNTRY_CODE in ('BG', 'BE', 'FR', 'DE', 'IT', 'LU', 'NL', 'DK', 'IE',  'GB', 'GR', 'PT', 'ES', 'AT', 'FI', 'SE', 'PL', 'CZ', 'HU', 'LT', 'LV', 'EE', 'MT', 'SK', 'SI', 'CY', 'RO', 'NO', 'IS', 'LI', 'CH', 'HR')
       and not exists (select l.LIST_ITEM
                       from   LISTS_ITEMS l
                       where  l.LIST_GROUP = 'EU countries (ISO ALPHA 2)');

commit work;

set term ^;

create procedure TMP_FIX_PAYMENT_TRANSFERS
as
  declare variable dbkey char(8);
  declare variable pay_rate numeric(15,6);
  declare variable pay_amount double precision;
  declare variable acc_rate numeric(15,6);
begin
  for
    select ap.RDB$DB_KEY, ap.PAY_AMOUNT, ap.PAY_RATE, pp.ACC_RATE
    from   ACCOUNT_PAYMENTS AP
           join ACCOUNT_PAYMENT_TRANSFER t on t.ID_ACCOUNT_PAYMENT_SOURCE = ap.ID_ACCOUNT_PAYMENT
           left outer join ACCOUNT_PAYMENTS PP on pp.ID_ACCOUNT = ap.ID_ACCOUNT
                                                  and pp.ID_PAYMENT_HEAD = ap.ID_PAYMENT_HEAD
                                                  and pp.IS_INITIAL_PAYMENT = 1
                                                  and pp.ACC_RATE <> ap.ACC_RATE
    where  pp.ID_ACCOUNT_PAYMENT is distinct from null
    into   :dbkey, :pay_amount, :pay_rate, :acc_rate
  do begin
    update ACCOUNT_PAYMENTS P
    set    p.ACC_RATE = :acc_rate,
           p.ACC_AMOUNT = round_f(:pay_amount * :pay_rate / :acc_rate, 0.0001)
    where  p.RDB$DB_KEY = :dbkey;
  end

end
^

set term ;^

execute procedure TMP_FIX_PAYMENT_TRANSFERS;

commit work;

drop procedure TMP_FIX_PAYMENT_TRANSFERS;

update RIGHTS_GROUPS_REPORTS rr
set    rr.REPORT_NAME = trim(rr.REPORT_NAME);

commit work;

delete
from   SALE_DISCOUNT_SERVICES sds
where  not exists (select sg.ID_SERVICE_GROUP
                   from   SERVICE_GROUPS sg,
                          SALE_DISCOUNT sd
                   where  sg.ID_SERVICE_GROUP = sds.ID_SERVICE_GROUP
                          and sd.ID_SALE_DISCOUNT = sds.ID_SALE_DISCOUNT
                          and sd.ID_HOTEL = sg.ID_HOTEL);
commit work;

update AR_OWING_PAYMENT_POST p
set    p.ID_PROFILE = (select ao.ID_PROFILE
                       from   AR_OWING ao
                       where  ao.ID_AR_OWING = p.ID_AR_OWING)
where  not exists(select o.ID_PROFILE
                       from   AR_OWING o
                       where  o.ID_AR_OWING = p.ID_AR_OWING
                              and o.ID_PROFILE = p.ID_PROFILE);
commit work;

