
UPDATE ERROR_CODES
SET    ERR_TEXT = ' %1        %2!'
WHERE (ERR_CODE = -9) AND (LANG_CODE = 'bg');

UPDATE RIGHTS
SET    DEF_DESCRIPTION = '    '
WHERE (RIGHT_CODE = 'RESERV_TOTAL_OVERBOOK');

commit work;

UPDATE TAR_UI_PARAMS
SET    DELPHI_IMPLEMENT =
'unit services;
implementation
uses default_handlers;
procedure local_ValidateControls(spObject: TSPObject);
begin
end;
procedure local_GetScript(spObject: TSPObject; var strValue: string);
begin
  strValue := Copy(spObject.values,1,Pos('';'',spObject.values)-1);
end;
procedure local_BeforeRender(spObject: TSPObject; pHplder: TWinControl);
var
  pDS: TDataSource;
  tmpS: String;
begin
  spObject.releaseControls;
  spObject.addControl(''lookupcb'', TRxDBLookupCombo.create(spObject));
  TRxDBLookupCombo(spObject.getControl(''lookupcb'')).DropDownWidth := 200;
  tmpS := tmpS + ''select cast(0 as integer) as ID_SERVICE, cast(@TAR_RES_HELPER  as varchar(100)) as SERVICE_NAME, cast(1 as integer) '';
  tmpS := tmpS + ''from   DUMMY '';
  tmpS := tmpS + '' '';
  tmpS := tmpS + ''union '';
  tmpS := tmpS + '' '';
  tmpS := tmpS + '' select S.ID_SERVICE, cast(S.SERVICE_NAME as varchar(100)), cast(2 as integer) from SERVICES S '';
  tmpS := tmpS + '' where S.IS_DELETED=0 and S.IS_BASE=0 and s.SERVICE_TYPE in (''''EXTRA'''', ''''MEAL'''') and s.ID_HOTEL = @ID_HOTEL '';
  tmpS := tmpS + '' '';
  tmpS := tmpS + ''order by 3,  2'';
  pDS := spObject.getDataSource(''SERVICES'', tmpS);
  if nil <> pDS then begin
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupSource := pDS;
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupField := ''ID_SERVICE'';
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupDisplay := ''SERVICE_NAME'';
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).OnKeyDown := local_KeyDown;
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).DisplayEmpty := '' '';
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).EmptyValue := '''';
  end;
  TRxDBLookupCombo(spObject.getControl(''lookupcb'')).value := Copy(spObject.values,1,Pos('';'',spObject.values)-1);
end;
procedure local_RenderControl(strControlName: string; pControl: TControl; pHolder: TWinControl; pRectHolder: TRectHolder; var bDone: Boolean);
begin
  pControl.Top := pRectHolder.getTop - 1;
  pControl.left := pRectHolder.getLeft - 1;
  pControl.Width := pRectHolder.getRight - pRectHolder.getLeft + 2;
  pHolder.InsertControl(pControl);
  pControl.OnExit := spExitControls;
  pControl.SetFocus;
  bDone := true;
end;
procedure local_SynchronValues(spObject: TSPObject);
begin
  try
    spObject.values := TRxDBLookupCombo(spObject.getControl(''lookupcb'')).value + '';'' + TRxDBLookupCombo(spObject.getControl(''lookupcb'')).Text;
  except
  end;
end;
procedure local_SetKChar(spObject: TSPObject; Ch: char);
begin
  if TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupSource.DataSet.Locate(TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupDisplay,UpperCase(Ch),[loCaseInsensitive, loPartialKey]) then
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).value := TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupSource.DataSet.FieldByName(TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupField).AsString;
  TRxDBLookupCombo(spObject.getControl(''lookupcb'')).DropDown;
end;
procedure local_GetVisibleData(spObject: TSPObject; KeyValue: String; var strValues: String);
begin
  strValues := '''';
  if Pos('';'',KeyValue) > 0 then
    strValues := Copy(KeyValue,Pos('';'',KeyValue)+1,length(KeyValue));
end;
procedure local_KeyDown(Sender: TObject; var key: Word;
  Shift: TShiftState);
begin
  if not TRxDBLookupCombo(Sender).IsDropDown then
    if (Shift = []) and (key = 13) then
      if TControl(Sender).Owner <> nil then
        TControl(Sender).Parent.SetFocus
      else
    else if (Shift = []) and (key = 27) then
      if TControl(Sender).Owner <> nil then begin
        TSPObject(TControl(Sender).Owner).CancelGetValues := True;
        TControl(Sender).Parent.SetFocus;
      end;
end;

function expandGUID(spObject: TSPObject): String;
var key: String;
begin
  key := TRxDBLookupCombo(spObject.getControl(''lookupcb'')).Value;
  if StrToIntDef(key,0) > 0 then
    key := ''@{SERVICES.'' + key + '';'' + TRxDBLookupCombo(spObject.getControl(''lookupcb'')).Text + ''}'';
  Result := key;
end;

procedure localGetInterfaceValuesUID(spObject: TSPObject; var strValues: string);
begin
  try
    strValues := expandGUID(spObject) + '';'' + TRxDBLookupCombo(spObject.getControl(''lookupcb'')).Text;
  except
  end;
end;

procedure localGetScriptUID(spObject: TSPObject; var strValues: string);
begin
  try
    strValues := expandGUID(spObject);
  except
  end;
end;

function main: TSPObject;
begin
  Result := TSPObject.create(nil);
  Result.OnGetInterfaceValues := spGetInterfaceValues;
  Result.OnSetInterfaceValues := spSetInterfaceValues;
  Result.OnGetScript := local_GetScript;
  Result.OnRenderControl := local_RenderControl;
  Result.BeforeRender := local_BeforeRender;
  Result.OnValidateControls := local_ValidateControls;
  Result.OnSynchronValues := local_SynchronValues;
  Result.BeforeRemoveControls := spBeforeRemoveControls;
  Result.OnSetKChar := local_SetKChar;
  Result.OnGetVisibleData := local_GetVisibleData;
  Result.OnGetInterfaceValuesUID := localGetInterfaceValuesUID;
  Result.OnGetScriptUID := localGetScriptUID;
end;
end.'
WHERE INTERNAL_PARAM_NAME = 'SERVICE';

commit work;

UPDATE TAR_UI_PARAMS
SET    DELPHI_IMPLEMENT =
'unit board;
implementation
procedure board_ValidateControls(spObject: TSPObject);
begin
end;
procedure board_GetScript(spObject: TSPObject; var strValue: string);
begin
  strValue := Copy(spObject.Values,1,Pos('';'',spObject.Values)-1);
  if strValue = ''-1'' then strValue := '''';
end;
procedure board_BeforeRender(spObject: TSPObject; pHplder: TWinControl);
var
  pDS: TDataSource;
begin
  spObject.releaseControls;
  spObject.addControl(''lookupcb'', TRxDBLookupCombo.Create(spObject));
  TRxDBLookupCombo(spObject.getControl(''lookupcb'')).DropDownWidth := 200;
  pDS := spObject.getDataSource(''BOARDS'', ''select m.NAME as TYPE_HRANA, m.ID_SERVICE as ID_TYPE_HRANA from   MEALS m where  m.IS_BOARD = 1 and m.ID_HOTEL = @ID_HOTEL and m.IS_ARCHIVE = 0 order by m.WEIGHT_TAG'');
  if nil <> pDS then begin
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupSource := pDS;
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupField := ''ID_TYPE_HRANA'';
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupDisplay := ''TYPE_HRANA'';
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).OnKeyDown := board_KeyDown;
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).EmptyValue := '''';
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).DisplayEmpty := '''';
  end;
  TRxDBLookupCombo(spObject.getControl(''lookupcb'')).Value := Copy(spObject.Values,1,Pos('';'',spObject.Values)-1);
end;
procedure board_RenderControl(strControlName: string; pControl: TControl; pHolder: TWinControl; pRectHolder: TRectHolder; var bDone: Boolean);
begin
  pControl.Top := pRectHolder.getTop - 1;
  pControl.Left := pRectHolder.getLeft - 1;
  pControl.Width := pRectHolder.getRight - pRectHolder.getLeft + 2;
  pHolder.InsertControl(pControl);
  pControl.OnExit := spExitControls;
  pControl.SetFocus;
  bDone := true;
end;
procedure board_SynchronValues(spObject: TSPObject);
begin
  try
    spObject.Values := TRxDBLookupCombo(spObject.getControl(''lookupcb'')).Value + '';'' + TRxDBLookupCombo(spObject.getControl(''lookupcb'')).Text;
  except
  end;
end;
procedure board_SetKChar(spObject: TSPObject; Ch: Char);
begin
  if TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupSource.DataSet.Locate(TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupDisplay,UpperCase(Ch),[loCaseInsensitive, loPartialKey]) then
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).Value := TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupSource.DataSet.FieldByName(TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupField).AsString;
  TRxDBLookupCombo(spObject.getControl(''lookupcb'')).DropDown;
end;
procedure board_KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if not TRxDBLookupCombo(Sender).IsDropDown then
    if (Shift = []) and (Key = 13) then
      if TControl(Sender).Owner <> nil then
        TControl(Sender).Parent.SetFocus
      else
    else if (Shift = []) and (Key = 27) then
      if TControl(Sender).Owner <> nil then begin
        TSPObject(TControl(Sender).Owner).CancelGetValues := True;
        TControl(Sender).Parent.SetFocus;
      end;
end;
procedure board_GetVisibleData(spObject: TSPObject; KeyValue: String; var strValues: String);
begin
  strValues := Copy(KeyValue,Pos('';'',KeyValue)+1,Length(KeyValue));
end;

function boardexpandGUID(spObject: TSPObject): String;
var key: String;
begin
  key := TRxDBLookupCombo(spObject.getControl(''lookupcb'')).Value;
  if StrToIntDef(key,0) > 0 then
    key := ''@{BOARDS.'' + key + '';'' + TRxDBLookupCombo(spObject.getControl(''lookupcb'')).Text + ''}'';
  Result := key;
end;

procedure boardGetInterfaceValuesUID(spObject: TSPObject; var strValues: string);
begin
  try
    strValues := boardexpandGUID(spObject) + '';'' + TRxDBLookupCombo(spObject.getControl(''lookupcb'')).Text;
  except
  end;
end;

procedure boardGetScriptUID(spObject: TSPObject; var strValues: string);
begin
  try
    strValues := boardexpandGUID(spObject);
  except
  end;
end;


end.'
WHERE INTERNAL_PARAM_NAME = 'board';

commit work;
