update or insert into CHANNEL (NAME) values ('ParityRate') matching (NAME);
update or insert into CHANNEL (NAME) values ('ClockWRS') matching (NAME);
update or insert into CHANNEL (NAME) values ('RoomCloud') matching (NAME);

update or insert into CHANNEL_SCHEDULE$EXC (CHANNEL_NAME) values ('ParityRate') matching (CHANNEL_NAME);
update or insert into CHANNEL_SCHEDULE$EXC (CHANNEL_NAME) values ('ClockWRS') matching (CHANNEL_NAME);
update or insert into CHANNEL_SCHEDULE$EXC (CHANNEL_NAME) values ('RoomCloud') matching (CHANNEL_NAME);
commit work;


INSERT INTO RIGHTS (RIGHT_CODE, RIGHT_GROUP, DEF_DESCRIPTION) VALUES ('RIGHTS_AUDIT_MANAGE', 'SETTING', '/   ');
INSERT INTO RIGHTS (RIGHT_CODE, RIGHT_GROUP, DEF_DESCRIPTION) VALUES ('DOC_ANNUL_CORR_DOC', 'DOCUMENT', '   ');

insert into RIGHTS_GROUPS (GROUP_NAME, GROUP_DESCRIPTION)
values ('_AUDITORS_', 'AUDITORS GROUP');

insert into RIGHTS_GROUPS_LINES(ID_RIGHT_GROUP, RIGHT_CODE)
select g.ID_RIGHT_GROUP, sp.ITEM
from   RIGHTS_GROUPS g
       left outer join SYSTEM_STRING_PARSER('DOC_PAY_GROUP_1,DOC_PAY_GROUP_2,DOCS_FIND,ACC_BALANCES,BALANCES_PRINT,OPEN_BOOKING_INBOX,AR_PREVIEW,CURR,USERSEDIT,CHECKEDOUT_RESERV_PREVIEW,WAITING_RESERV_PREVIEW,RESERV_LIST,ACC_FIND_ARCHIVE,ACC_SET_CREDIT,ACCSECURLEVEL1,ANALIZ_AGENT,RPT.*,RPT.EXPORT,SYSTEM_LOG,PERSON_PROFILE_STATISTIC,MASK_DIFF_FROM_DEF,ARCHIVE_PHONE_LINES,FIND_PHONECALLS,MONITOR_TCREPS,PMS_OWNERS,RIGHTSEDIT,TARIFIEDIT,MONITOR_PAGE4,MONITOR_PAGE3,MONITOR_PAGE7,MONITOR_PAGE1,REPORT_HOTEL_REGISTER,ROOMS,OTHER_NOM,PROFILE_GUEST_EDIT,SERVICES,DOC_PAY_TYPES,PROFILE_AGENT_EDIT,EXPORT') sp on 1=1
where  g.GROUP_NAME = '_AUDITORS_';


--INSERT INTO SYSTEM_ENUM (GROUP_, KEY_, DEFAULT_CAPTION, ORDER_TAG) VALUES ('log.ACCOUNT', 'POST_PERC_UPDATE', '. .  %1  %2   %3  %4  %5, : %6', NULL);
INSERT INTO SYSTEM_ENUM (GROUP_, KEY_, DEFAULT_CAPTION, ORDER_TAG) VALUES ('log.CONTRAGENT', 'CONTRAGENT_CHANGED', '     %1', NULL);
INSERT INTO SYSTEM_ENUM (GROUP_, KEY_, DEFAULT_CAPTION, ORDER_TAG) VALUES ('log_class', 'CONTRAGENT', '', NULL);
INSERT INTO SYSTEM_ENUM (GROUP_, KEY_, DEFAULT_CAPTION, ORDER_TAG) VALUES ('log_class', 'SERVICE', '', NULL);
INSERT INTO SYSTEM_ENUM (GROUP_, KEY_, DEFAULT_CAPTION, ORDER_TAG) VALUES ('log.SERVICE', 'SERVICE_CHANGED', '   %1', NULL);
INSERT INTO SYSTEM_ENUM (GROUP_, KEY_, DEFAULT_CAPTION, ORDER_TAG) VALUES ('log.PAYMENT_TYPE', 'PAYMENT_TYPE_CHANGED', '     %1', NULL);
INSERT INTO SYSTEM_ENUM (GROUP_, KEY_, DEFAULT_CAPTION, ORDER_TAG) VALUES ('log.DOC_TYPE', 'DOC_TYPE_CHANGED', '    %1', NULL);
INSERT INTO SYSTEM_ENUM (GROUP_, KEY_, DEFAULT_CAPTION, ORDER_TAG) VALUES ('log.HOTEL', 'HOTEL_CHANGED', '    ', NULL);
INSERT INTO SYSTEM_ENUM (GROUP_, KEY_, DEFAULT_CAPTION, ORDER_TAG) VALUES ('log_class', 'DOC_TYPE', ' ', NULL);
INSERT INTO SYSTEM_ENUM (GROUP_, KEY_, DEFAULT_CAPTION, ORDER_TAG) VALUES ('log_class', 'PAYMENT_TYPE', ' ', NULL);
INSERT INTO SYSTEM_ENUM (GROUP_, KEY_, DEFAULT_CAPTION, ORDER_TAG) VALUES ('log.DOC_TYPE', 'DELETE', '   ', NULL);
INSERT INTO SYSTEM_ENUM (GROUP_, KEY_, DEFAULT_CAPTION, ORDER_TAG) VALUES ('log.PAYMENT_TYPE', 'DELETE', '    ', NULL);
INSERT INTO SYSTEM_ENUM (GROUP_, KEY_, DEFAULT_CAPTION, ORDER_TAG) VALUES ('log.DOCUMENT', 'RE-FISCALIZE', '   - (  )', NULL);

INSERT INTO ERROR_CODES (ERR_CODE, LANG_CODE, ERR_TEXT, ERR_TYPE, IS_SYSTEM) VALUES (-705, 'bg', '        !      !', 1, 0);
INSERT INTO ERROR_CODES (ERR_CODE, LANG_CODE, ERR_TEXT, ERR_TYPE, IS_SYSTEM) VALUES (-706, 'bg', '    !       !', 1, 0);
INSERT INTO ERROR_CODES (ERR_CODE, LANG_CODE, ERR_TEXT, ERR_TYPE, IS_SYSTEM) VALUES (-707, 'bg', '  ,    !', 1, 0);
INSERT INTO ERROR_CODES (ERR_CODE, LANG_CODE, ERR_TEXT, ERR_TYPE, IS_SYSTEM) VALUES (-68, 'bg', '    %1     %2        .', 1, 0);
INSERT INTO ERROR_CODES (ERR_CODE, LANG_CODE, ERR_TEXT, ERR_TYPE, IS_SYSTEM) VALUES (-708, 'bg', '   !', 1, 0);
INSERT INTO ERROR_CODES (ERR_CODE, LANG_CODE, ERR_TEXT, ERR_TYPE, IS_SYSTEM) VALUES (-709, 'bg', '      !', 1, 0);
INSERT INTO ERROR_CODES (ERR_CODE, LANG_CODE, ERR_TEXT, ERR_TYPE, IS_SYSTEM) VALUES (-710, 'bg', '      !', 1, 0);
INSERT INTO ERROR_CODES (ERR_CODE, LANG_CODE, ERR_TEXT, ERR_TYPE, IS_SYSTEM) VALUES (-711, 'bg', '     !', 1, 0);
INSERT INTO ERROR_CODES (ERR_CODE, LANG_CODE, ERR_TEXT, ERR_TYPE, IS_SYSTEM) VALUES (-88, 'bg', '    ( 4 ) !', 1, 0);
INSERT INTO ERROR_CODES (ERR_CODE, LANG_CODE, ERR_TEXT, ERR_TYPE, IS_SYSTEM) VALUES (-601, 'bg', '                - ExternalRevenue  Complimentary !', 1, 0);
INSERT INTO ERROR_CODES (ERR_CODE, LANG_CODE, ERR_TEXT, ERR_TYPE, IS_SYSTEM) VALUES (-712, 'bg', '         !', 1, 0);

set term ^;

create or alter procedure TMP_DOC_SALES_NUM_GEN
AS
  declare variable id_doc integer;
  declare variable id_sale_num integer;
  declare variable unique_sales_number varchar(30);
  declare variable created_at timestamp;
begin
  select min(d.DATETIME_CREATED)
  from   DOC_HEAD D
  into   :created_at;

  if (:created_at is null) then exit ;

  unique_sales_number = 'XXXXXXXX-0000-0000000';
  insert into SALE_NUM (UNIQUE_SALES_NUMBER, CREATED_AT)
  values (:UNIQUE_SALES_NUMBER, :created_at)
  returning id_sale_num
  into      :id_sale_num;

  for
    select d.ID_DOC
    from   DOC_HEAD d
    where  d.DOC_SUB_TYPE = 0
           and d.ID_SALE_NUM is null
    order by d.DATETIME_CREATED asc
    into   :id_doc
  do begin
    update DOC_COMPLETION dc
    set    dc.ID_SALE_NUM = :id_sale_num
    where  dc.ID_DOC_HEAD = :id_doc;
  end

  update DOC_COMPLETION dc
  set    dc.ID_SALE_NUM = (select bd.ID_SALE_NUM
                           from   DOC_HEAD d
                                  join doc_HEAD bd on bd.ID_DOC = d.ID_BASE_DOC
                           where  d.ID_DOC = dc.ID_DOC_HEAD)
  where  dc.ID_SALE_NUM is null;
end
^

set term ;^

execute procedure TMP_DOC_SALES_NUM_GEN;
commit work;

drop procedure TMP_DOC_SALES_NUM_GEN;
commit work;

update HOTEL h
set    h.ACCOMODATION_PLACE_UIN = (select e.CFG_VALUE
                                   from   EXT_ESTI_CONFIG e
                                   where  e.CFG_KEY = 'accomodation_place_uin.' || h.ID_HOTEL);
commit work;

