update RIGHTS_USERS ru
set    ru.IS_ACTIVE = 0
where  ru.USER_NAME = '_AUDITOR_';

commit work;

update DOC_FISCAL_DATA fd
set    fd.ID_FISCAL_DATA = fd.ID_DOC_HEAD
where  fd.ID_FISCAL_DATA is null;

commit work;

select gen_id(GEN_DOC_FISCAL_DATA_ID, gen_id(DOC_SELECTED_GEN, 0))
from   dummy;

commit work;

INSERT INTO ERROR_CODES (ERR_CODE, LANG_CODE, ERR_TEXT, ERR_TYPE, IS_SYSTEM) VALUES (-713, 'bg', '        -        -  !        .        -!.', 1, 0);
INSERT INTO ERROR_CODES (ERR_CODE, LANG_CODE, ERR_TEXT, ERR_TYPE, IS_SYSTEM) VALUES (-714, 'bg', '      -       !        .', 1, 0);

commit work;

set term ^;

create or alter procedure TMP_REMAKE_FISC_AMOUNT_AND_GRPS
AS
  declare variable id_fiscal_data integer;
  declare variable fisc_amount numeric(15,4);
  declare variable fisc_groups varchar(50);
begin
  for
    select fd.ID_FISCAL_DATA
    from   DOC_FISCAL_DATA fd
    where  fd.FISCAL_AMOUNT is null
    into   :id_fiscal_data
  do begin
    select sum(fl.FISC_QTY * fl.FISC_PRICE), list(distinct fl.FISC_GRP)
    from   FISCALIZE_LINE$FISC (:id_fiscal_data) fl
    into   :fisc_amount, :fisc_groups;

    update DOC_FISCAL_DATA ufd
    set    ufd.FISCAL_AMOUNT = :fisc_amount,
           ufd.FISCAL_GROUP_LIST = :fisc_groups
    where  ufd.ID_FISCAL_DATA = :id_fiscal_data;
  end 
end
^

set term ;^

execute procedure TMP_REMAKE_FISC_AMOUNT_AND_GRPS;

commit work;

drop procedure TMP_REMAKE_FISC_AMOUNT_AND_GRPS;

commit work;

