/* Server version: WI-V6.3.3.18185 Firebird 2.1 
   SQLDialect: 3. ODS: 11.1. Forced writes: On. Sweep inteval: 20000.
   Page size: 8192. Cache pages: 8192 (65536 Kb). Read-only: False. */
SET SQL DIALECT 3;


ALTER TABLE HOTEL_BORICA_CFG$WBE DROP CONSTRAINT FK_HOTEL_BORICA_CFG$WBE;

/* Drop View... */
DROP VIEW ENA_DOC_DISCOUNT;

DROP VIEW ENA_DOC_HEAD;

DROP VIEW ENA_DOC_LINE;


/* Create Table... */
CREATE TABLE HOTEL_T_COM_PAYWAY_CFG$WBE(ID ID NOT NULL,
HOTEL_ID ID_REF NOT NULL,
SHOP_ID TBANK_CODE,
SECRET_KEY TDESCRIPTION_LONG,
INTEGRATION_PAGE_URL TURL);



ALTER TABLE EXT_BAVEL_SERVICE_MAP ADD IS_DISCOUNT TCOUNT NOT NULL;

ALTER TABLE HOTEL_BORICA_CFG$WBE ADD TERMINAL_ID NAME_20;

ALTER TABLE HOTEL_BORICA_CFG$WBE ADD HTTPS_CER TNOTE_BLOB;

ALTER TABLE HOTEL_BORICA_CFG$WBE ADD HTTPS_KEY TNOTE_BLOB;

ALTER TABLE HOTEL_BORICA_CFG$WBE ADD APGW_KEY TNOTE_BLOB;

ALTER TABLE HOTEL_BORICA_CFG$WBE ADD WEB_CERT TNOTE_BLOB;

ALTER TABLE SYSTEM_INFO_UPDATE ADD PRODUCT_VERSION TOBJECT_NAME;

ALTER TABLE HOTEL_BORICA_CFG$WBE ALTER COLUMN HOTEL_ID TYPE ID_REF;

/* Alter Field (Null / Not Null)... */
UPDATE RDB$RELATION_FIELDS SET RDB$NULL_FLAG = NULL WHERE RDB$FIELD_NAME='ID_CURRENCY' AND RDB$RELATION_NAME='OWNER$PMS';


/* Drop table-fields... */
ALTER TABLE EXT_BAVEL_SERVICE_MAP DROP BAVEL_SERVICE_SUBTYPE;

ALTER TABLE HOTEL_BORICA_CFG$WBE DROP PRIVATE_KEY;

ALTER TABLE HOTEL_BORICA_CFG$WBE DROP PUBLIC_KEY;


/* Create Procedure... */
SET TERM ^ ;

CREATE PROCEDURE EXT_BAVEL_SERVICE_MAP_MODIFY(ID_SERVICE INTEGER,
IS_DISCOUNT INTEGER,
BAVEL_SERVICE_TYPE VARCHAR(50))
 AS
 BEGIN EXIT; END
^


/* Create Views... */
/* Create view: ENA_ACCOUNT_POST_HISTORY (ViwData.CreateDependDef) */
SET TERM ; ^

CREATE VIEW ENA_ACCOUNT_POST_HISTORY(
ID_HOTEL,
ID_ACCOUNT_POST_HISTORY,
ID_ACCOUNT_POST,
ID_SERVICE,
ID_SALE_TAXATION,
SYSTEM_DATE,
POST_DATE,
POST_CURR,
POST_AMOUNT,
NAT_NET_VALUE,
NAT_GROSS_VALUE,
POST_TYPE,
ID_GUEST,
REVENUE_GROUP,
REVENUE_ACCOUNT,
REVENUE_SUB_ACCOUNT)
 AS 
select AD.ID_HOTEL,
       AD.ID_ACCOUNT_DEBT,
       AD.ID_ACCOUNT_POST,
       AD.ID_SERVICE,
       AD.ID_SALE_TAXATION,
       AD.DEBT_DATE,
       AD.POST_DATE,
       AD.POST_CURR,
       AD.POST_AMOUNT,
       AD.NAT_NET_VALUE,
       AD.NAT_GROSS_VALUE,
       AD.POST_TYPE,
       AD.ID_GUEST,
       AD.REVENUE_GROUP,
       AD.REVENUE_ACCOUNT,
       AD.REVENUE_SUB_ACCOUNT
from   ACCOUNT_DEBT ad
;

/* Create view: ENA_ADVANCE_TRANSFER (ViwData.CreateDependDef) */
CREATE VIEW ENA_ADVANCE_TRANSFER(
ID_HOTEL,
ID_DOC_HEAD,
SYSTEM_DATE,
PAYMENT_DATE,
SRC_ID_ACCOUNT,
SRC_ACCOUNT_NAME,
SRC_EXT_CODE,
SRC_ID_PROFILE,
SRC_PROFILE_NAME,
SRC_PROFILE_ACCOUNT_NO,
DEST_ID_ACCOUNT,
DEST_ACCOUNT_NAME,
DEST_EXT_CODE,
DEST_ID_PROFILE,
DEST_PROFILE_NAME,
DEST_PROFILE_ACCOUNT_NO,
PAY_AMOUNT,
PAY_CURRENCY,
USER_CREATED,
DATETIME_CREATED)
 AS 
select sa.ID_HOTEL,
       p.ID_DOC_HEAD,
       sPM.TRANSACTION_DATE,
       P.PAYMENT_DATE,
       sA.ID_ACCOUNT,
       sA.ACCOUNT_NAME,
       sA.EXT_CODE,
       sp.ID_PROFILE,
       sp.PROFILE_NAME,
       sp.ACCOUNT_NO,
       dA.ID_ACCOUNT,
       dA.ACCOUNT_NAME,
       dA.EXT_CODE,
       dp.ID_PROFILE,
       dp.PROFILE_NAME,
       dp.ACCOUNT_NO,
       dpm.PAY_AMOUNT,
       P.PAY_CURRENCY,
       SL.ACTION_USER,
       SL.ACTION_DATETIME
from   ACCOUNT_PAYMENT_TRANSFER T
       join ACCOUNT_PAYMENTS sPm on spm.ID_ACCOUNT_PAYMENT = t.ID_ACCOUNT_PAYMENT_SOURCE
       join ACCOUNT sA on sA.ID_ACCOUNT = spm.ID_ACCOUNT
       join DEPOSIT sD on sD.ID_DEPOSIT = sPm.ID_DEPOSIT
       join PROFILE sP on sp.ID_PROFILE = sa.ID_PROFILE
       join ACCOUNT_PAYMENTS dPm on dpm.ID_ACCOUNT_PAYMENT = t.ID_ACCOUNT_PAYMENT_DEST
       join ACCOUNT dA on dA.ID_ACCOUNT = dpm.ID_ACCOUNT
       join DEPOSIT dD on dD.ID_DEPOSIT = dPm.ID_DEPOSIT
       join PROFILE dP on dp.ID_PROFILE = da.ID_PROFILE
       join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = sPm.ID_PAYMENT_HEAD and p.ID_DOC_HEAD is not null
       left outer join SYSTEM_LOG_EVENT SL on SL.ID_SYSTEM_LOG = t.ID_SYSTEM_LOG
;

/* Create view: ENA_DOC_DEPOSIT_CONSUMPTION (ViwData.CreateDependDef) */
CREATE VIEW ENA_DOC_DEPOSIT_CONSUMPTION(
ID_DOC_HEAD,
ID_DOC_TYPE,
DOC_TYPE_NAME,
PAYMENT_NUM,
PAYMENT_TYPE,
PAYMENT_DATE,
PAY_CURRENCY,
DESCRIPTION,
PAY_VALUE,
PAY_RATE,
PAY_DOC_RATE,
EQUAL_DOC_VALUE,
NAT_VALUE,
ID_DEPOSIT_PAYMENT)
 AS 
select
   DP.ID_DOC_HEAD,
   p.ID_DOC_TYPE,
   P.DOC_TYPE_NAME,
   P.PAYMENT_NUM,
   PT.PAYMENT_TYPE,
   P.PAYMENT_DATE,
   P.PAY_CURRENCY,
   P.DESCRIPTION,
   DP.PAY_AMOUNT as INIT_PAY_VALUE,
   DP.PAY_RATE as INIT_PAY_RATE,
   cast(DP.PAY_RATE / dp.DOC_RATE as double precision) as PAY_DOC_RATE,
   cast(DP.DOC_AMOUNT as numeric(15,4)) as EQUAL_DOC_VALUE,
   cast(DP.DOC_AMOUNT * Dh.DOC_RATE as numeric(15,4)) as NAT_VALUE,
   p.ID_PAYMENT_HEAD
from
   DOC_PAYMENTS DP
   join DOC_HEAD dh on dh.ID_DOC = dp.ID_DOC_HEAD
   join ACCOUNT A on A.ID_ACCOUNT = dh.ID_ACCOUNT
   join ACCOUNT_PAYMENTS AP on AP.ID_ACCOUNT_PAYMENT = DP.ID_ACCOUNT_PAYMENT
   join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = ap.ID_PAYMENT_HEAD
   join PAYMENT_TYPE pt on pt.ID_PAYMENT_TYPE = p.ID_PAYMENT_TYPE
where P.ID_DOC_HEAD is null
;

COMMENT ON VIEW ENA_DOC_DEPOSIT_CONSUMPTION IS
' !!!!!!    ID_DOC_TYPE - za mapowe.';

/* Create view: ENA_DOC_HEAD_ADVANCE (ViwData.CreateDependDef) */
CREATE VIEW ENA_DOC_HEAD_ADVANCE(
ID_HOTEL,
ID_DOC,
ID_BASE_DOC,
ID_DOC_TYPE,
DOC_SUB_TYPE,
DOC_TYPE_NAME,
DOC_TYPE_EXPORT_TAG,
DOC_TYPE_DESCRIPTION,
DOC_NUM,
DOC_DATE,
SYSTEM_DATE,
IS_ANUL,
DOC_FISC_STATUS,
DOC_CURRENCY,
DOC_TOTAL_VALUE,
DOC_RATE,
DOC_ACC_RATE,
TAX_EVENT_DATE,
DOC_DESCRIPTION,
ONE_LINE_TEXT,
DIFF_VAT_REASON,
DOC_SECOND_CURRENCY,
DOC_SECOND_CURR_RATE,
CLIENT_IS_LEGAL_ENTITY,
CLIENT_NAME,
CLIENT_IDENT_NO,
CLIENT_TAX_REG_NUM,
CLIENT_COUNTRY_CODE,
CLIENT_POST_ADDRESS,
CLIENT_ZIP_CODE,
CLIENT_MOL,
CLIENT_RECIPIENT_NAME,
CLIENT_BANK_NAME,
CLIENT_BIC,
CLIENT_IBAN,
CLIENT_EMAIL,
SUPPLIER_SEND_NAME,
ACCOUNT_ID,
ACCOUNT_NAME,
ACCOUNT_EXT_CODE,
PROFILE_ID,
PROFILE_NAME,
PROFILE_ACCOUNT_NO,
PROFILE_TYPE,
PROFILE_HOUSE_TYPE,
ANNUL_PROT_NUM)
 AS 
select
       A.ID_HOTEL,
       dh.ID_DOC_HEAD,
       dh.ID_BASE_DOC,
       dh.ID_DOC_TYPE,
       dh.DOC_SUB_TYPE,
       dh.DOC_TYPE_NAME,
       dt.EXPORT_TAG,
       dt.DESCRIPTION,
       dh.DOC_NUM,
       dh.DOC_DATE,
       rd.RELEASE_DATE,
       iif((RD.VALUE_CORR_INDEX = -1) or (m.TAG = 1), 1, 0),
       dc.FISC_STATUS,
       dh.DOC_CURRENCY,
       dh.DOC_VALUE_A,
       dh.DOC_RATE,
       dh.DOC_ACC_RATE,
       dc.TAX_EVENT_DATE,
       dh.DESCRIPTION,
       dh.ONE_LINE_TEXT,
       dh.DIFF_VAT_REASON,
       dh.SECOND_CURRENCY,
       dh.SECOND_CURR_RATE,
       c.IS_JURIDICAL_PERSON,
       c.CONTRAGENT_NAME,
       c.IDENT_NO,
       c.VAT_REG_NUM,
       c.COUNTRY_CODE,
       c.POST_ADDRESS,
       c.ZIP_CODE,
       c.MOL,
       c.RECIPIENT_NAME,
       c.BANK_NAME,
       c.BIC,
       c.IBAN,
       c.EMAIL,
       ds.SEND_NAME,
       a.ID_ACCOUNT,
       a.ACCOUNT_NAME,
       a.EXT_CODE,
       p.ID_PROFILE,
       p.PROFILE_NAME,
       p.ACCOUNT_NO,
       p.PROFILE_TYPE,
       ph.HOUSE_TYPE,
       da.PROT_DOC_NUM
from DOC_HEAD$INT dh
     join DOC_COMPLETION dc on dc.ID_DOC_HEAD = dh.ID_DOC_HEAD
     join DOC_RELEASE_DATE rd on rd.ID_DOC_HEAD = dh.ID_DOC_HEAD
     join ACCOUNT a on a.ID_ACCOUNT = dh.ID_ACCOUNT
     join PROFILE p on p.ID_PROFILE = a.ID_PROFILE
     join DOC_TYPE dt on dt.ID_DOC_TYPE = dh.ID_DOC_TYPE
     join DOC_SUPPLIER ds on ds.ID_DOC_SUPPLIER = dh.ID_DOC_SUPPLIER
     join DOC_CONTRAGENT c on c.ID_DOC_CONTRAGENT = dh.ID_DOC_CONTRAGENT
     left outer join RECORD_MULTIPLIER m on 0 = rd.VALUE_CORR_INDEX
     left outer join PROFILE_HOUSE ph on ph.ID_PROFILE = p.ID_PROFILE
     left outer join DOC_ANNULMENT da on da.ID_DOC_HEAD = dh.ID_DOC_HEAD
                                         and ((RD.VALUE_CORR_INDEX = -1) or (m.TAG = 1))
where dh.FOR_DEPOSIT = 1
;

COMMENT ON VIEW ENA_DOC_HEAD_ADVANCE IS
'!      ';

/* Create view: ENA_DOC_HEAD_SERVICE (ViwData.CreateDependDef) */
CREATE VIEW ENA_DOC_HEAD_SERVICE(
ID_HOTEL,
ID_DOC,
ID_BASE_DOC,
ID_DOC_TYPE,
DOC_SUB_TYPE,
DOC_TYPE_NAME,
DOC_TYPE_EXPORT_TAG,
DOC_TYPE_DESCRIPTION,
DOC_NUM,
DOC_DATE,
SYSTEM_DATE,
IS_ANUL,
DOC_FISC_STATUS,
DOC_CURRENCY,
DOC_TOTAL_VALUE,
DOC_RATE,
DOC_ACC_RATE,
TAX_EVENT_DATE,
DOC_DESCRIPTION,
ONE_LINE_TEXT,
DIFF_VAT_REASON,
DOC_SECOND_CURRENCY,
DOC_SECOND_CURR_RATE,
DOC_PROFORMA_DATE,
DOC_PROFORMA_NUM,
CLIENT_IS_LEGAL_ENTITY,
CLIENT_NAME,
CLIENT_IDENT_NO,
CLIENT_TAX_REG_NUM,
CLIENT_COUNTRY_CODE,
CLIENT_POST_ADDRESS,
CLIENT_ZIP_CODE,
CLIENT_MOL,
CLIENT_RECIPIENT_NAME,
CLIENT_BANK_NAME,
CLIENT_BIC,
CLIENT_IBAN,
CLIENT_EMAIL,
SUPPLIER_SEND_NAME,
ACCOUNT_ID,
ACCOUNT_NAME,
ACCOUNT_EXT_CODE,
PROFILE_ID,
PROFILE_NAME,
PROFILE_ACCOUNT_NO,
PROFILE_TYPE,
PROFILE_HOUSE_TYPE,
ANNUL_PROT_NUM)
 AS 
select
       A.ID_HOTEL,
       dh.ID_DOC_HEAD,
       dh.ID_BASE_DOC,
       dh.ID_DOC_TYPE,
       dh.DOC_SUB_TYPE,
       dh.DOC_TYPE_NAME,
       dt.EXPORT_TAG,
       dt.DESCRIPTION,
       dh.DOC_NUM,
       dh.DOC_DATE,
       rd.RELEASE_DATE,
       iif((RD.VALUE_CORR_INDEX = -1) or (m.TAG = 1), 1, 0),
       dc.FISC_STATUS,
       dh.DOC_CURRENCY,
       dh.DOC_VALUE_A,
       dh.DOC_RATE,
       dh.DOC_ACC_RATE,
       dc.TAX_EVENT_DATE,
       dh.DESCRIPTION,
       dh.ONE_LINE_TEXT,
       dh.DIFF_VAT_REASON,
       dh.SECOND_CURRENCY,
       dh.SECOND_CURR_RATE,
       di.DOC_DATE,
       di.DOC_NUM,
       c.IS_JURIDICAL_PERSON,
       c.CONTRAGENT_NAME,
       c.IDENT_NO,
       c.VAT_REG_NUM,
       c.COUNTRY_CODE,
       c.POST_ADDRESS,
       c.ZIP_CODE,
       c.MOL,
       c.RECIPIENT_NAME,
       c.BANK_NAME,
       c.BIC,
       c.IBAN,
       c.EMAIL,
       ds.SEND_NAME,
       a.ID_ACCOUNT,
       a.ACCOUNT_NAME,
       a.EXT_CODE,
       p.ID_PROFILE,
       p.PROFILE_NAME,
       p.ACCOUNT_NO,
       p.PROFILE_TYPE,
       ph.HOUSE_TYPE,
       da.PROT_DOC_NUM
from DOC_HEAD$INT dh
     join DOC_COMPLETION dc on dc.ID_DOC_HEAD = dh.ID_DOC_HEAD
     join DOC_RELEASE_DATE rd on rd.ID_DOC_HEAD = dh.ID_DOC_HEAD
     join ACCOUNT a on a.ID_ACCOUNT = dh.ID_ACCOUNT
     join PROFILE p on p.ID_PROFILE = a.ID_PROFILE
     join DOC_TYPE dt on dt.ID_DOC_TYPE = dh.ID_DOC_TYPE
     join DOC_SUPPLIER ds on ds.ID_DOC_SUPPLIER = dh.ID_DOC_SUPPLIER
     join DOC_CONTRAGENT c on c.ID_DOC_CONTRAGENT = dh.ID_DOC_CONTRAGENT
     left outer join RECORD_MULTIPLIER m on 0 = rd.VALUE_CORR_INDEX
     left outer join DOC_HEAD$INT di on di.ID_DOC_HEAD = dc.ID_DOC_PROFORMA
     left outer join PROFILE_HOUSE ph on ph.ID_PROFILE = p.ID_PROFILE
     left outer join DOC_ANNULMENT da on da.ID_DOC_HEAD = dh.ID_DOC_HEAD
                                         and ((RD.VALUE_CORR_INDEX = -1) or (m.TAG = 1))
where dh.FOR_DEPOSIT = 0
;

/* Create view: ENA_DOC_LINE_ADVANCE (ViwData.CreateDependDef) */
CREATE VIEW ENA_DOC_LINE_ADVANCE(
ID_DOC_HEAD,
ID_SERVICE,
ID_SALE_TAXATION,
TAXATION_NAME,
TAXATION_ACCOUNT_NAME,
VAT_PERCENT,
QTY_POST,
SINGLE_VALUE,
SINGLE_WOT_VAT,
WOT_VAT,
LINE_NAME,
DATE_POST,
NAT_NET_VALUE,
NAT_GROSS_VALUE,
SEC_CURR_NET_VALUE,
SEC_CURR_GROSS_VALUE)
 AS 
select
    dl.ID_DOC_HEAD,
    dl.ID_SERVICE,
    dl.ID_SALE_TAXATION,
    st.NAME,
    st.ACCOUNT_NAME,
    dl.VAT_PERCENT,
    dl.QTY_POST,
    dl.SINGLE_VALUE,
    dl.SINGLE_WOT_VAT,
    dl.WOT_VAT,
    dl.LINE_NAME,
    dl.DATE_POST,
    dl.NAT_NET_VALUE,
    dl.NAT_GROSS_VALUE,
    dl.SEC_CURR_NET_VALUE,
    dl.SEC_CURR_GROSS_VALUE
from DOC_LINE dl
     join DOC_HEAD dh on dh.ID_DOC = dl.ID_DOC_HEAD
     join SALE_TAXATION st on st.ID_SALE_TAXATION = dl.ID_SALE_TAXATION
     join ACCOUNT A on a.ID_ACCOUNT = dh.ID_ACCOUNT
     join DOC_LINE_DEP_VALUES dv on dv.ID_DOC_LINE = dl.ID_DOC_LINE
;

/* Create view: ENA_DOC_LINE_AGENT_DISCOUNT (ViwData.CreateDependDef) */
CREATE VIEW ENA_DOC_LINE_AGENT_DISCOUNT(
ID_DOC_HEAD,
ID_SERVICE,
ID_SALE_TAXATION,
TAXATION_NAME,
TAXATION_ACCOUNT_NAME,
VAT_PERCENT,
QTY_POST,
SINGLE_VALUE,
SINGLE_WOT_VAT,
WOT_VAT,
LINE_NAME,
NAT_NET_VALUE,
NAT_GROSS_VALUE,
SEC_CURR_NET_VALUE,
SEC_CURR_GROSS_VALUE)
 AS 
select
    dl.ID_DOC_HEAD,
    dl.ID_SERVICE,
    dl.ID_SALE_TAXATION,
    st.NAME,
    st.ACCOUNT_NAME,
    dl.VAT_PERCENT,
    dl.QTY_POST,
    dl.SINGLE_VALUE,
    dl.SINGLE_WOT_VAT,
    dl.WOT_VAT,
    dl.LINE_NAME,
    dl.NAT_NET_VALUE,
    dl.NAT_GROSS_VALUE,
    dl.SEC_CURR_NET_VALUE,
    dl.SEC_CURR_GROSS_VALUE
from DOC_LINE dl
     join DOC_FOOTER DF on df.ID_DOC_LINE = dl.ID_DOC_LINE
     join DOC_HEAD dh on dh.ID_DOC = dl.ID_DOC_HEAD
     join SALE_TAXATION st on st.ID_SALE_TAXATION = dl.ID_SALE_TAXATION
     join ACCOUNT A on a.ID_ACCOUNT = dh.ID_ACCOUNT
;

/* Create view: ENA_DOC_LINE_SERVICE (ViwData.CreateDependDef) */
CREATE VIEW ENA_DOC_LINE_SERVICE(
ID_DOC_HEAD,
ID_SERVICE,
ID_SALE_TAXATION,
TAXATION_NAME,
TAXATION_ACCOUNT_NAME,
VAT_PERCENT,
QTY_POST,
SINGLE_VALUE,
SINGLE_WOT_VAT,
WOT_VAT,
IS_CORRECT,
LINE_NAME,
ID_GUEST,
DATE_POST,
ROOM_NAME,
NAT_NET_VALUE,
NAT_GROSS_VALUE,
SEC_CURR_NET_VALUE,
SEC_CURR_GROSS_VALUE,
ID_ACCOUNT_POST,
ACCOUNT_PRICE)
 AS 
select
    dl.ID_DOC_HEAD,
    dl.ID_SERVICE,
    dl.ID_SALE_TAXATION,
    st.NAME,
    st.ACCOUNT_NAME,
    dl.VAT_PERCENT,
    dl.QTY_POST,
    dl.SINGLE_VALUE,
    dl.SINGLE_WOT_VAT,
    dl.WOT_VAT,
    dl.IS_CORRECT,
    dl.LINE_NAME,
    dl.ID_GUEST,
    dl.DATE_POST,
    dl.ROOM_NAME,
    dl.NAT_NET_VALUE,
    dl.NAT_GROSS_VALUE,
    dl.SEC_CURR_NET_VALUE,
    dl.SEC_CURR_GROSS_VALUE,
    pv.ID_ACCOUNT_POST,
    pv.ACCOUNT_PRICE
from DOC_LINE dl
     join DOC_LINE_POST_VALUES pv on pv.ID_DOC_LINE = dl.ID_DOC_LINE
     join DOC_HEAD dh on dh.ID_DOC = dl.ID_DOC_HEAD
     join SALE_TAXATION st on st.ID_SALE_TAXATION = dl.ID_SALE_TAXATION
     join ACCOUNT A on a.ID_ACCOUNT = dh.ID_ACCOUNT
;

/* Create view: ENA_DOC_LINE_SURGARGE (ViwData.CreateDependDef) */
CREATE VIEW ENA_DOC_LINE_SURGARGE(
ID_DOC_HEAD,
ID_SERVICE,
ID_SALE_TAXATION,
TAXATION_NAME,
TAXATION_ACCOUNT_NAME,
VAT_PERCENT,
QTY_POST,
SINGLE_VALUE,
SINGLE_WOT_VAT,
WOT_VAT,
LINE_NAME,
NAT_NET_VALUE,
NAT_GROSS_VALUE,
SEC_CURR_NET_VALUE,
SEC_CURR_GROSS_VALUE)
 AS 
select
    dl.ID_DOC_HEAD,
    dl.ID_SERVICE,
    dl.ID_SALE_TAXATION,
    st.NAME,
    st.ACCOUNT_NAME,
    dl.VAT_PERCENT,
    dl.QTY_POST,
    dl.SINGLE_VALUE,
    dl.SINGLE_WOT_VAT,
    dl.WOT_VAT,
    dl.LINE_NAME,
    dl.NAT_NET_VALUE,
    dl.NAT_GROSS_VALUE,
    dl.SEC_CURR_NET_VALUE,
    dl.SEC_CURR_GROSS_VALUE
from DOC_LINE dl
     join PAYMENT_FOOTER PF on pf.ID_DOC_LINE = dl.ID_DOC_LINE
     join DOC_HEAD dh on dh.ID_DOC = dl.ID_DOC_HEAD
     join SALE_TAXATION st on st.ID_SALE_TAXATION = dl.ID_SALE_TAXATION
     join ACCOUNT A on a.ID_ACCOUNT = dh.ID_ACCOUNT
;

/* Create view: ENA_DOC_PAYMENT_DISCOUNT (ViwData.CreateDependDef) */
CREATE VIEW ENA_DOC_PAYMENT_DISCOUNT(
ID_DOC_HEAD,
DESCRIPTION,
DISCOUNT_VALUE,
DISCOUNTABLE_VALUE,
IS_PERCENT_DISCOUNT,
FIXED_DISCOUNT_CURRENCY,
DISCOUNT_PERCENT_OR_AMOUNT)
 AS 
select df.ID_DOC_HEAD,
       df.DESCRIPTION,
       df.FOOTER_VALUE as discount_value,
       df.TAXABLE_VALUE,
       iif(sd.DISCOUNT_CALC_METHOD = 'fixedValue', 0, 1),
       sd.FIXED_DISCOUNT_CURRENCY ,
       sd.DISCOUNT_VALUE
from   DOC_FOOTER df
       join SALE_DISCOUNT sd on sd.ID_SALE_DISCOUNT = df.ID_TAX
       join DOC_HEAD d on d.ID_DOC = df.ID_DOC_HEAD
       join ACCOUNT A on a.ID_ACCOUNT = d.ID_ACCOUNT
where  df.ID_DOC_LINE is null
;


/* Alter View (Drop, Create)... */
/* Drop altered view: ENA_ACCOUNT_POST */
DROP VIEW ENA_ACCOUNT_POST;

/* Create altered view: ENA_ACCOUNT_POST */
/* Create view: ENA_ACCOUNT_POST (ViwData.CreateDependDef) */
CREATE VIEW ENA_ACCOUNT_POST(
ID_HOTEL,
ID_ACCOUNT_POST,
ID_SERVICE,
ID_GUEST,
ID_ACCOUNT,
ID_MASTER_ACCOUNT_POST,
ID_PACK_SERVICE,
POST_DATE,
ACCOUNT_ID,
ACCOUNT_NAME,
ACCOUNT_EXT_CODE,
PROFILE_ID,
PROFILE_NAME,
PROFILE_ACCOUNT_NO,
PROFILE_TYPE,
PROFILE_HOUSE_TYPE)
 AS 
select A.ID_HOTEL,
       AP.ID_ACCOUNT_POST,
       AP.ID_SERVICE,
       AP.ID_GUEST,
       a.ID_ACCOUNT,
       ap.ID_MASTER_ADDINS_ACC_POST,
       ap.ID_PACK_SERVICE,
       AP.DATE_POST,
       a.ID_ACCOUNT,
       a.ACCOUNT_NAME,
       a.EXT_CODE,
       p.ID_PROFILE,
       p.PROFILE_NAME,
       p.ACCOUNT_NO,
       p.PROFILE_TYPE,
       (select ph.HOUSE_TYPE from PROFILE_HOUSE ph where ph.ID_PROFILE = p.ID_PROFILE)
from   ACCOUNT_POST ap
    join ACCOUNT a on a.ID_ACCOUNT = ap.ID_ACCOUNT
    join PROFILE p on p.ID_PROFILE = a.ID_PROFILE
;

COMMENT ON VIEW ENA_ACCOUNT_POST IS
'      ,      .     .       acaunt_post  acount_post_amounts';

/* Drop altered view: ENA_DEPOSIT */
DROP VIEW ENA_DEPOSIT;

/* Create altered view: ENA_DEPOSIT */
/* Create view: ENA_DEPOSIT (ViwData.CreateDependDef) */
CREATE VIEW ENA_DEPOSIT(
ID_HOTEL,
ID_DEPOSIT_PAYMENT,
PAYMENT_DATE,
SYSTEM_DATE,
PAYMENT_NUM,
DOC_DIRECTION,
DOC_TYPE_NAME,
DESCRIPTION,
ID_ACCOUNT,
ACCOUNT_NAME,
ACCOUNT_EXT_CODE,
ID_PROFILE,
PROFILE_NAME,
PROFILE_ACCOUNT_NO,
PROFILE_TYPE,
PAY_AMOUNT,
PAY_CURRENCY,
IS_ANUL,
USER_CREATED,
DATETIME_CREATED,
USER_ANNUL,
DATETIME_ANNUL)
 AS 
select a.ID_HOTEL,
       p.ID_PAYMENT_HEAD,
       p.PAYMENT_DATE,
       ap.TRANSACTION_DATE,
       p.PAYMENT_NUM,
       dtp.DOC_DIRECTION,
       p.DOC_TYPE_NAME,
       D.DESCRIPTION,
       a.ID_ACCOUNT,
       a.ACCOUNT_NAME,
       a.EXT_CODE,
       prf.ID_PROFILE,
       Prf.PROFILE_NAME,
       prf.ACCOUNT_NO,
       Prf.PROFILE_TYPE,
       iif(ap.IS_INITIAL_PAYMENT = 1, ap.PAY_AMOUNT, -ap.PAY_AMOUNT),
       P.PAY_CURRENCY,
       iif(ap.IS_INITIAL_PAYMENT = 1, 0, p.IS_ANUL) as IS_ANUL,
       P.USER_CREATED as USER_CREATED,
       P.DATETIME_CREATED as DATETIME_CREATED,
       SL.ACTION_USER as USER_ANNUL,
       SL.ACTION_DATETIME as DATETIME_ANNUL
from   ACCOUNT_PAYMENTS AP
       join DEPOSIT D on D.ID_DEPOSIT = AP.ID_DEPOSIT
       join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
       join PROFILE PRF on PRF.ID_PROFILE = A.ID_PROFILE
       join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = aP.ID_PAYMENT_HEAD and p.ID_DOC_HEAD is null
       join DOC_TYPE_PAY dtp on dtp.ID_DOC_TYPE = p.ID_DOC_TYPE
       left outer join SYSTEM_LOG_EVENT SL on SL.ID_SYSTEM_LOG = P.ID_LOG_EVENT_ANNUL and ap.IS_INITIAL_PAYMENT is distinct from 1
where  not exists (select tr.ID_ACCOUNT_PAYMENT_SOURCE
                   from   ACCOUNT_PAYMENT_TRANSFER tr
                   where  (tr.ID_ACCOUNT_PAYMENT_SOURCE = ap.ID_ACCOUNT_PAYMENT)
                          or (tr.ID_ACCOUNT_PAYMENT_DEST = ap.ID_ACCOUNT_PAYMENT))
;

COMMENT ON COLUMN ENA_DEPOSIT.ID_HOTEL IS
'   ,    . .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_DEPOSIT_PAYMENT IS
'  .         . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_DATE IS
'        .            . .';

COMMENT ON COLUMN ENA_DEPOSIT.SYSTEM_DATE IS
'   .         PAYMENT_DATE.        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_NUM IS
'           .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_DIRECTION IS
'0 -   , 1 -   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_TYPE_NAME IS
'       .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_ACCOUNT IS
'        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.ACCOUNT_NAME IS
'        . .';

COMMENT ON COLUMN ENA_DEPOSIT.ACCOUNT_EXT_CODE IS
'             . . -        .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_PROFILE IS
'           . .';

COMMENT ON COLUMN ENA_DEPOSIT.PROFILE_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DEPOSIT.PROFILE_ACCOUNT_NO IS
'             .  -    .';

COMMENT ON COLUMN ENA_DEPOSIT.PROFILE_TYPE IS
'       .  : AGENT -  , PERSON -  , HOUSE -    .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_AMOUNT IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DEPOSIT.IS_ANUL IS
'   . 0 - , 1 - .           /    .     IS_ANUL = 0,    1.           ID_DEPOSIT.  .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_CREATED IS
'     .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_CREATED IS
'       . .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_ANNUL IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_ANNUL IS
'     .  .';

/* Drop altered view: ENA_DEPOSIT_TRANSFER */
DROP VIEW ENA_DEPOSIT_TRANSFER;

/* Create altered view: ENA_DEPOSIT_TRANSFER */
/* Create view: ENA_DEPOSIT_TRANSFER (ViwData.CreateDependDef) */
CREATE VIEW ENA_DEPOSIT_TRANSFER(
ID_HOTEL,
ID_DEPOSIT_PAYMENT,
SYSTEM_DATE,
PAYMENT_DATE,
SRC_ID_ACCOUNT,
SRC_ACCOUNT_NAME,
SRC_EXT_CODE,
SRC_ID_PROFILE,
SRC_PROFILE_NAME,
SRC_PROFILE_ACCOUNT_NO,
DEST_ID_ACCOUNT,
DEST_ACCOUNT_NAME,
DEST_EXT_CODE,
DEST_ID_PROFILE,
DEST_PROFILE_NAME,
DEST_PROFILE_ACCOUNT_NO,
PAY_AMOUNT,
PAY_CURRENCY,
USER_CREATED,
DATETIME_CREATED)
 AS 
select sa.ID_HOTEL,
       P.ID_PAYMENT_HEAD,
       sPM.TRANSACTION_DATE,
       P.PAYMENT_DATE,
       sA.ID_ACCOUNT,
       sA.ACCOUNT_NAME,
       sA.EXT_CODE,
       sp.ID_PROFILE,
       sp.PROFILE_NAME,
       sp.ACCOUNT_NO,
       dA.ID_ACCOUNT,
       dA.ACCOUNT_NAME,
       dA.EXT_CODE,
       dp.ID_PROFILE,
       dp.PROFILE_NAME,
       dp.ACCOUNT_NO,
       dpm.PAY_AMOUNT,
       P.PAY_CURRENCY,
       SL.ACTION_USER,
       SL.ACTION_DATETIME
from   ACCOUNT_PAYMENT_TRANSFER T
       join ACCOUNT_PAYMENTS sPm on spm.ID_ACCOUNT_PAYMENT = t.ID_ACCOUNT_PAYMENT_SOURCE
       join ACCOUNT sA on sA.ID_ACCOUNT = spm.ID_ACCOUNT
       join DEPOSIT sD on sD.ID_DEPOSIT = sPm.ID_DEPOSIT
       join PROFILE sP on sp.ID_PROFILE = sa.ID_PROFILE
       join ACCOUNT_PAYMENTS dPm on dpm.ID_ACCOUNT_PAYMENT = t.ID_ACCOUNT_PAYMENT_DEST
       join ACCOUNT dA on dA.ID_ACCOUNT = dpm.ID_ACCOUNT
       join DEPOSIT dD on dD.ID_DEPOSIT = dPm.ID_DEPOSIT
       join PROFILE dP on dp.ID_PROFILE = da.ID_PROFILE
       join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = sPm.ID_PAYMENT_HEAD and p.ID_DOC_HEAD is null
       left outer join SYSTEM_LOG_EVENT SL on SL.ID_SYSTEM_LOG = t.ID_SYSTEM_LOG
;

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.ID_HOTEL IS
'       .  .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.ID_DEPOSIT_PAYMENT IS
'   ,   .  ENA_DEPOSIT.ID_DEPOSIT_PAYMENT. .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SYSTEM_DATE IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAYMENT_DATE IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SRC_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SRC_ACCOUNT_NAME IS
'   . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SRC_EXT_CODE IS
'    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SRC_ID_PROFILE IS
' .        . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SRC_PROFILE_NAME IS
'   . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SRC_PROFILE_ACCOUNT_NO IS
'    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DEST_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DEST_ACCOUNT_NAME IS
'   . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DEST_EXT_CODE IS
'    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DEST_ID_PROFILE IS
' .    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DEST_PROFILE_NAME IS
'   . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DEST_PROFILE_ACCOUNT_NO IS
'    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAY_AMOUNT IS
' .        . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAY_CURRENCY IS
' . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.USER_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DATETIME_CREATED IS
'     . .';

/* Drop altered view: ENA_DOC_PAYMENT */
DROP VIEW ENA_DOC_PAYMENT;

/* Create altered view: ENA_DOC_PAYMENT */
/* Create view: ENA_DOC_PAYMENT (ViwData.CreateDependDef) */
CREATE VIEW ENA_DOC_PAYMENT(
ID_DOC_HEAD,
DOC_TYPE_NAME,
PAYMENT_NUM,
PAYMENT_TYPE,
PAYMENT_DATE,
PAY_CURRENCY,
DESCRIPTION,
DUE_DATE,
PAY_VALUE,
PAY_RATE,
PAY_DOC_RATE,
EQUAL_DOC_VALUE,
NAT_VALUE)
 AS 
select
   DP.ID_DOC_HEAD,
   P.DOC_TYPE_NAME,
   P.PAYMENT_NUM,
   PT.PAYMENT_TYPE,
   P.PAYMENT_DATE,
   P.PAY_CURRENCY,
   P.DESCRIPTION,
   P.DUE_DATE,
   DP.PAY_AMOUNT as INIT_PAY_VALUE,
   DP.PAY_RATE as INIT_PAY_RATE,
   cast(DP.PAY_RATE / dp.DOC_RATE as double precision) as PAY_DOC_RATE,
   cast(DP.DOC_AMOUNT as numeric(15,4)) as EQUAL_DOC_VALUE,
   cast(DP.DOC_AMOUNT * Dh.DOC_RATE as numeric(15,4)) as NAT_VALUE
from
   DOC_PAYMENTS DP
   join DOC_HEAD dh on dh.ID_DOC = dp.ID_DOC_HEAD
   join ACCOUNT A on A.ID_ACCOUNT = dh.ID_ACCOUNT
   join ACCOUNT_PAYMENTS AP on AP.ID_ACCOUNT_PAYMENT = DP.ID_ACCOUNT_PAYMENT
   join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = ap.ID_PAYMENT_HEAD and p.ID_DOC_HEAD = dp.ID_DOC_HEAD
   join PAYMENT_TYPE pt on pt.ID_PAYMENT_TYPE = p.ID_PAYMENT_TYPE
;

COMMENT ON VIEW ENA_DOC_PAYMENT IS
'   ,     .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.ID_DOC_HEAD IS
'  ( ENA_DOC_HEAD.ID_DOC)      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DOC_TYPE_NAME IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_NUM IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_DATE IS
'     .        ,                 . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_CURRENCY IS
'  .        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DUE_DATE IS
'       .          ,      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_VALUE IS
'           . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_DOC_RATE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.EQUAL_DOC_VALUE IS
'      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.NAT_VALUE IS
'     . .';

/* Drop altered view: ENA_DOC_TAX */
DROP VIEW ENA_DOC_TAX;

/* Create altered view: ENA_DOC_TAX */
/* Create view: ENA_DOC_TAX (ViwData.CreateDependDef) */
CREATE VIEW ENA_DOC_TAX(
ID_DOC_HEAD,
ID_SALE_TAX,
NONTAXABLE_VALUE,
TAXABLE_VALUE,
TAX_VALUE,
TAX_NAME,
TAX_PERCENT,
FISCAL_CODE,
ACCOUNT_NAME)
 AS 
select T.ID_DOC_HEAD,
       T.ID_SALE_TAX,
       T.NONTAXABLE_VALUE,
       T.TAXABLE_VALUE,
       T.TAX_VALUE,
       T.TAX_NAME,
       T.TAX_PERCENT,
       st.FISCAL_CODE,
       st.ACCOUNT_NAME
from   DOC_TAXES T
       join SALE_TAXES st on st.ID_SALE_TAX = t.ID_SALE_TAX
       join DOC_HEAD d on d.ID_DOC = t.ID_DOC_HEAD
       join ACCOUNT A on a.ID_ACCOUNT = d.ID_ACCOUNT
;

COMMENT ON COLUMN ENA_DOC_TAX.ID_DOC_HEAD IS
'         ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_TAX.ID_SALE_TAX IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.NONTAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_VALUE IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_NAME IS
'  .  -        .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_PERCENT IS
'   ().  .';

COMMENT ON COLUMN ENA_DOC_TAX.FISCAL_CODE IS
' .        .  -      .';

COMMENT ON COLUMN ENA_DOC_TAX.ACCOUNT_NAME IS
' .              . .';

COMMENT ON COLUMN ENA_GUEST.ID_GUEST IS
'   ( )   . .';

COMMENT ON COLUMN ENA_GUEST.ID_RESERV_DETAIL IS
'        ( ENA_RESERV_DETAIL.ID_RESERV_DETAIL). .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME2 IS
'      . .';

COMMENT ON COLUMN ENA_GUEST.IS_CHILD IS
'   . 0 - ; 1 - . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE IS
'    . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_TEXT IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.RATING_AGE IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.COUNTRY_CODE IS
'    .        ISO. .';

COMMENT ON COLUMN ENA_GUEST.MASK IS
'  .         . .';

COMMENT ON COLUMN ENA_HOTEL.ID_HOTEL IS
'  . .';

COMMENT ON COLUMN ENA_HOTEL.HOTEL_NAME IS
'  . .';

COMMENT ON COLUMN ENA_HOTEL.CODE IS
'   . .';

COMMENT ON COLUMN ENA_HOTEL.SYSTEM_DATE IS
'     .                  ENA.                . .';

COMMENT ON COLUMN ENA_HOTEL.IS_USE IS
'    (  ). 0 -   , 1 -  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_RESERV_DETAIL IS
'   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NUMBER IS
'  .    (   ). .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_GUEST_MAIN IS
'      .      .  -     .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME IS
'    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME2 IS
'       . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.FROM_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.TO_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NIGHTS IS
'. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ADULT_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHILD_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_EATING_OBJECT IS
'          . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHECK_STATUS IS
'  . -3 =  ; -2 =   ; -1 =  ; 0 =  ; 1 =  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.IS_ANUL IS
'   . 0 - , 1 - .  -       0  1.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ID IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_NAME IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_TYPE IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ACCOUNT_NO IS
'             .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SEGMENT_CODE IS
'   ''segment''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SOURCE_CODE IS
'   ''source''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_CHANNEL_CODE IS
'   ''channel''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_HEAR_CODE IS
'   ''hear reason''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_COME_CODE IS
'   ''come reason''.   . .';

COMMENT ON COLUMN ENA_SERVICES.ID_HOTEL IS
'       . .';

COMMENT ON COLUMN ENA_SERVICES.ID_SERVICE IS
'   . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_NAME IS
'  . .';

COMMENT ON COLUMN ENA_SERVICES.GROUP_NAME IS
'    .            a       . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_TYPE IS
'  .  : ''BASE'',''EXTRA'',''COMMISSION'',''MEAL''. ''BASE'' -    ,     ,''EXTRA'' -  , ''MEAL'' - , ''COMMISSION'' - ,        (  ). .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_GROUP IS
'       .  : ''ROOMS'', ''Food and Beverage'', ''Other Operated Departments'', ''Rentals and Other Income''. .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_ACCOUNT IS
' -      . .';

COMMENT ON COLUMN ENA_SERVICES.ACCOUNT_NAME IS
'      (. ),      .          . .';

COMMENT ON COLUMN ENA_SERVICES.EXT_CODE IS
'         . .';

COMMENT ON COLUMN ENA_SERVICES.IS_BREAKFAST IS
'   . 0 - , 1 - .    1,   SERVICE_TYPE e ''BASE''  ''MEAL''.  -          .';

COMMENT ON COLUMN ENA_SERVICES.ID_ROOM_TYPE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ). .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  -             .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM_EXT_CODE IS
'    ( )     ,      .  -        .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_STAY_CODE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  : ''ALONE'' -      , ''BED'' -            , ''EXTRA_BED'' -      . .';

/* Drop altered view: RESOURCE */
DROP VIEW RESOURCE;

/* Create altered view: RESOURCE */
/* Create view: RESOURCE (ViwData.CreateDependDef) */
CREATE VIEW RESOURCE(
ID_RESOURCE,
ID_RESOURCE_TYPE,
RESOURCE_NAME,
ID_WORKING_TIME,
OFFER_BY_DEFAULT,
IS_VIRTUAL,
ID_HOTEL)
 AS 
select r.ID_RESOURCE,
       r.ID_RESOURCE_TYPE,
       r.RESOURCE_NAME,
       rh.ID_WORKING_TIME,
       rh.OFFER_BY_DEFAULT,
       rh.IS_VIRTUAL,
       r.ID_HOTEL

from   RESOURCE$INT r
       join EXTRA_RESOURCE rh on rh.ID_RESOURCE = r.ID_RESOURCE
;
;

/* Drop altered view: RESOURCE_TYPE */
DROP VIEW RESOURCE_TYPE;

/* Create altered view: RESOURCE_TYPE */
/* Create view: RESOURCE_TYPE (ViwData.CreateDependDef) */
CREATE VIEW RESOURCE_TYPE(
ID_RESOURCE_TYPE,
RESOURCE_TYPE_NAME,
ID_HOTEL,
ID_POST_SERVICE_GROUP)
 AS 
select rt.ID_RESOURCE_TYPE, rt.RESOURCE_TYPE_NAME, rt.ID_HOTEL, er.ID_POST_SERVICE_GROUP
from   RESOURCE_TYPE$INT rt
       join EXTRA_RESOURCE_TYPE er on er.ID_RESOURCE_TYPE = rt.ID_RESOURCE_TYPE
;
;

/* Drop altered view: SAFE_TYPES */
SET TERM ^ ;

ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE /* TYPE OF ID */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP VIEW SAFE_TYPES;

/* Create altered view: SAFE_TYPES */
/* Create view: SAFE_TYPES (ViwData.CreateDependDef) */
CREATE VIEW SAFE_TYPES(
ID_SAFE_TYPE,
TYPE_NAME,
SHORT_CODE,
ID_RESOURCE_RATE,
EXPIRE_TOLLERANCE,
ID_HOTEL)
 AS 
select st.ID_SAFE_TYPE,
       rt.RESOURCE_TYPE_NAME,
       st.SHORT_CODE,
       st.ID_RESOURCE_RATE,
       st.EXPIRE_TOLERANCE,
       rt.ID_HOTEL
from   SAFE_TYPE st
       join RESOURCE_TYPE$INT rt on rt.ID_RESOURCE_TYPE = st.ID_SAFE_TYPE
;
;

/* Drop altered view: SAFES */
SET TERM ^ ;

ALTER PROCEDURE RES_CHECK_OUT_CHECK$RSV(SELECTION_ID INTEGER)
 RETURNS(IS_EARLY_CHECK_OUT SMALLINT,
EARLY_CHECK_OUT_DEP_DATE DATE,
CHECK_OUT_DATE DATE)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE /* TYPE OF ID */ INTEGER,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100))
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE /* TYPE OF ID */ INTEGER,
FROM_DATETIME /* TDATETIME */ TIMESTAMP,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100),
BOOKING_NUMBER /* TYPE OF TRES_NUMBER */ VARCHAR(62),
ID_EXTERNAL_CLIENT_ACCCOUNT /* TYPE OF ID_REF */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER,
ID_RESOURCE_RESERVATION /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE SYSTEM_LOG_OBJECT_INFO_GET(OBJECT_CLASS VARCHAR(30),
OBJECT_ID INTEGER)
 RETURNS(OBJECT_DESCRIPTION VARCHAR(100),
HOTEL_CODE VARCHAR(10))
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP VIEW SAFES;

/* Create altered view: SAFES */
/* Create view: SAFES (ViwData.CreateDependDef) */
CREATE VIEW SAFES(
ID_SAFE,
ID_SAFE_TYPE,
ID_HOTEL,
SAFE_NAME,
IS_ARCHIVE,
SORT_ORDER,
IS_OCCUPIED,
ID_CURRENT_OCCUPANCY)
 AS 
select ID_SAFE, ID_RESOURCE_TYPE, ID_HOTEL, RESOURCE_NAME, IS_ARCHIVE, SORT_ORDER, IS_OCCUPIED, ID_CURRENT_OCCUPANCY
  from   SAFE s
         join RESOURCE$INT rt on rt.ID_RESOURCE = s.ID_SAFE
;
;

/* Create index... */
CREATE INDEX DOC_HEAD$INT_IDX2 ON DOC_HEAD$INT(DOC_NUM);


/* Create generator... */
CREATE GENERATOR GEN_T_COM_PAYWAY_CFG$WBE_ID;


/* Create Primary Key... */
ALTER TABLE HOTEL_BORICA_CFG$WBE ADD CONSTRAINT PK_HOTEL_BORICA_CFG$WBE PRIMARY KEY (ID);

ALTER TABLE HOTEL_T_COM_PAYWAY_CFG$WBE ADD CONSTRAINT PK_HOTEL_T_COM_PAYWAY_CFG$WBE PRIMARY KEY (ID);

/* Create Foreign Key... */
RECONNECT;

ALTER TABLE HOTEL_BORICA_CFG$WBE ADD CONSTRAINT FK_HOTEL_BORICA_CFG$WBE_1 FOREIGN KEY (HOTEL_ID) REFERENCES HOTEL (ID_HOTEL);

ALTER TABLE HOTEL_T_COM_PAYWAY_CFG$WBE ADD CONSTRAINT FK_HOTEL_T_COM_PAYWAY_CFG$WBE_1 FOREIGN KEY (HOTEL_ID) REFERENCES HOTEL (ID_HOTEL);


/*  Empty DEPOSIT_REFUND$DOC for DOCUMENT_VALIDATE$DOC(param list change)  */
SET TERM ^ ;

ALTER PROCEDURE DEPOSIT_REFUND$DOC(ID_DEPOSIT INTEGER,
REFUND_AMOUNT NUMERIC(15,4),
REFUND_CURRENCY VARCHAR(3),
ID_PAY_DOC_TYPE INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_REFUND_PAYMENT INTEGER,
ID_STORNO_DOC INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty TEST_DOC for DOCUMENT_VALIDATE$DOC(param list change)  */
ALTER PROCEDURE TEST_DOC(ID_ACCOUNT INTEGER,
DOC_SELECTED INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty POST_TELECOUNT_CALL$INT for POST_PREPARE_ON_ACCOUNT$POST(param list change)  */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure DOCUMENT_VALIDATE$DOC with new param-list */
ALTER PROCEDURE DOCUMENT_VALIDATE$DOC(ID_DOC_HEAD TYPE OF ID_REF)
 RETURNS(FIRM_DATA TYPE OF TNOTE_BLOB,
WARN_CODE TYPE OF TRANGE,
NEW_DOC_DATE TYPE OF TDATE)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure POST_PREPARE_ON_ACCOUNT$POST with new param-list */
ALTER PROCEDURE POST_PREPARE_ON_ACCOUNT$POST(ID_ACCOUNT ID_REF,
ID_SERVICE ID_REF,
QTY TQTY,
ID_SEQUENCE TRANGE,
PRICE_POST TPRICE,
CURR_POST TCURRENCY,
POST_TEXT TOBJECT_TEXT,
FROM_DATE TDATE,
TO_DATE TDATE,
ID_PHONECALL ID_REF = null)
 RETURNS(NEW_FROM_DATE TYPE OF TDATE)
 AS
 BEGIN SUSPEND; END
^

/* Alter Procedure... */
/* Alter (ALLOTMENT_SET$AVL) */
ALTER PROCEDURE ALLOTMENT_SET$AVL(ID_ALLOTMENT INTEGER,
ID_ROOM_TYPE INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
CNT_ROOMS INTEGER,
ACTIVE_FRAME_BEGIN INTEGER = 0,
ACTIVE_FRAME_END INTEGER = 0)
 RETURNS(ID_ALLOTMENT_DETAIL INTEGER,
NEW_FROM_DATE TYPE OF TDATE,
NEW_TO_DATE TYPE OF TDATE)
 AS
begin
  execute procedure sys_dbg('occ ID_ALLOTMENT = '||coalesce(:id_allotment, 'null'));
  execute procedure sys_dbg('occ ID_ROOM_TYPE = '||coalesce(:ID_ROOM_TYPE, 'null'));
  execute procedure sys_dbg('occ FROM_DATE = '||coalesce(:FROM_DATE, 'null'));
  execute procedure sys_dbg('occ TO_DATE = '||coalesce(:TO_DATE, 'null'));
  execute procedure sys_dbg('occ ACTIVE_FRAME_BEGIN = '||coalesce(:ACTIVE_FRAME_BEGIN, 'null'));
  execute procedure sys_dbg('occ ACTIVE_FRAME_END = '||coalesce(:ACTIVE_FRAME_END, 'null'));
  -- USED FOR CONTINGENTS
  if (:cnt_rooms < 0) then exception ASSERT 'Room count must be greater than 0';
  if (:to_date < :from_date) then exception ASSERT '-501';

  execute procedure ALLOTMENT_SET_ROOMS$INT(:id_allotment, :id_room_type, :from_date, :to_date, :cnt_rooms);

  execute procedure ALLOTMENT_SET_DAYS$INT(:id_allotment, :id_room_type, :from_date, :to_date, :active_frame_begin, :active_frame_end);

  select first 1 AD.ID_ALLOTMENT_DETAIL
  from   ALLOTMENT_DETAIL AD
  where  AD.ID_ALLOTMENT = :id_allotment
         and AD.ID_ROOM_TYPE = :id_room_type
         and AD.FROM_DATE <= :to_date
         and AD.TO_DATE >= :from_date
  into   :id_allotment_detail;

  select cast('31.12.1899' as date) + count(distinct ad.ID_ALLOTMENT),
         cast('31.12.1899' as date) + count(ad.ID_ALLOTMENT_DETAIL)
  from   ALLOTMENT_DETAIL ad
  where  ad.ID_ALLOTMENT is not null
  into   :NEW_FROM_DATE, :NEW_TO_DATE;

end
^

/* Alter (BLOCK_CREATE$BLK) */
ALTER PROCEDURE BLOCK_CREATE$BLK(ROOM_NAMES TYPE OF TDESCRIPTION_LONG,
ID_HOTEL TYPE OF ID,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
BLOCK_GRP TYPE OF TRANGE,
REASON TYPE OF TREASON,
NOTE TYPE OF TDESCRIPTION_LONG,
IS_FULL_FROM TYPE OF TRANGE,
IS_FULL_TO TYPE OF TRANGE)
 RETURNS(NEW_ID_BLOCK_ROOM TYPE OF ID,
SHARE_TRANSACTION_ID TYPE OF ID,
SHARE_ERR_CODE TYPE OF ID,
ERR_TEXT VARCHAR(255),
WARN_CODE TYPE OF ID,
NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable room_name varchar(50);
  declare variable id_room integer;
  declare variable action_text varchar(255);
  declare variable block_name varchar(30);
begin
  id_room = null;
  warn_code = null;
  SHARE_ERR_CODE = 0;

  for
    select ITEM
    from   SYSTEM_STRING_PARSER(:room_names, ',')
    into   :room_name
  do begin
    id_room = null;
    select R.ID_ROOM
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ROOM_NAME = :room_name
           and RT.ID_HOTEL = :id_hotel
    into   :id_room;

    if (:id_room is null) then exception BLOCK_EXCEPTION '-5' || f_character(31) || :room_name;

    execute procedure BLOCK_MODIFY$INT(null, :id_room, :from_date, :to_date, :block_grp,
                      :reason, :note, 'add')
    returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :err_text, :warn_code;

    block_name = iif(:block_grp = 18, 'OUT OF ORDER', 'OUT OF INVENTORY');
    action_text = f_character(29) || :room_name
                  || f_character(28) || formatdate(:from_date, 'D;dd.mm.yyyy') || '-' || formatdate(:to_date, 'D;dd.mm.yyyy')
                  || f_character(28) || :block_name;
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :new_id_block_room, 'BLOCK_ROOM', :action_text);

  end

  select cast('31.12.1899' as date) + count(b.ID_BLOCK_ROOM)
  from   BLOCK_ROOM b
  where  b.ID_ROOM is not null
  into   :NEW_FROM_DATE;
end
^

/* empty dependent procedure body */
/* Clear: CREDIT_CARD_MODIFY$WBE for: CREDIT_CARD_MODIFY$RSV */
ALTER PROCEDURE CREDIT_CARD_MODIFY$WBE(ID_RESERV_DETAIL INTEGER,
ID_CC_TYPE INTEGER,
CARD_CODE VARCHAR(50),
HOLDER_NAME VARCHAR(100),
HOLDER_ADDRESS VARCHAR(100),
VALIDITY_YEAR INTEGER,
VALIDITY_MONTH INTEGER,
VERIFICTION_CODE VARCHAR(50),
OPERATION VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* Alter (CREDIT_CARD_MODIFY$RSV) */
ALTER PROCEDURE CREDIT_CARD_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
ID_CC_TYPE INTEGER,
CARD_CODE VARCHAR(50),
HOLDER_NAME VARCHAR(100),
HOLDER_ADDRESS VARCHAR(100),
VALIDITY_YEAR INTEGER,
VALIDITY_MONTH INTEGER,
VERIFICTION_CODE VARCHAR(50),
OPERATION VARCHAR(20))
 AS
declare variable card_code_preview varchar(50);
declare variable id_agent_profile integer;
declare variable id_person_profile integer;
declare variable card_code_orig varchar(50);
BEGIN
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'set, del');

  card_code_orig = :CARD_CODE;  -- to preserve orig value, because of encoding
  execute procedure CREDIT_CARD_ENCODE (:card_code)
  returning_values :card_code, :card_code_preview;

  if (:operation = 'set') then begin
    update RESERV_DETAIL_CREDIT_CARD
    set    CARD_CODE = :card_code,
           CARD_CODE_PREVIEW = :card_code_preview,
           ID_CC_TYPE = :id_cc_type,
           HOLDER_NAME = :holder_name,
           HOLDER_ADDRESS = :holder_address,
           VALIDITY_YEAR = :validity_year,
           VALIDITY_MONTH = :validity_month,
           VERIFICTION_CODE = :verifiction_code
    where  ID_RESERV_DETAIL = :id_reserv_detail;

    if (row_count = 0) then begin
      insert into RESERV_DETAIL_CREDIT_CARD (ID_RESERV_DETAIL, CARD_CODE, ID_CC_TYPE,
             HOLDER_NAME, HOLDER_ADDRESS, VALIDITY_YEAR, VALIDITY_MONTH, VERIFICTION_CODE, CARD_CODE_PREVIEW)
      values (:id_reserv_detail, :card_code, :id_cc_type,
             :holder_name, :holder_address, :validity_year, :validity_month, :verifiction_code, :card_code_preview);
    end

    select rd.ID_AGENT_PROFILE, rd.ID_PERSON_PROFILE
    from   reserv_detail RD
    where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :id_agent_profile, :id_person_profile;
  
    execute procedure CREDIT_CARD_MODIFY$PROFILE (coalesce(:id_agent_profile, :id_person_profile),
            :ID_CC_TYPE, :card_code_orig, :HOLDER_NAME, :HOLDER_ADDRESS, :VALIDITY_YEAR, :VALIDITY_MONTH,
            :VERIFICTION_CODE, :OPERATION);

  end else if (:operation = 'del') then begin
    delete
    from  RESERV_DETAIL_CREDIT_CARD PCC
    where PCC.ID_RESERV_DETAIL = :id_reserv_detail;
  end

END
^

/* Alter (CREDIT_CARD_MODIFY$WBE) */
ALTER PROCEDURE CREDIT_CARD_MODIFY$WBE(ID_RESERV_DETAIL INTEGER,
ID_CC_TYPE INTEGER,
CARD_CODE VARCHAR(50),
HOLDER_NAME VARCHAR(100),
HOLDER_ADDRESS VARCHAR(100),
VALIDITY_YEAR INTEGER,
VALIDITY_MONTH INTEGER,
VERIFICTION_CODE VARCHAR(50),
OPERATION VARCHAR(20))
 AS
declare variable cc_code_preview varchar(50);
declare variable cc_code varchar(50);
BEGIN
  execute procedure CREDIT_CARD_ENCODE (:verifiction_code)
  returning_values :cc_code, :cc_code_preview;

  execute procedure CREDIT_CARD_MODIFY$RSV (
      :id_reserv_detail,
      :id_cc_type,
      :card_code, :holder_name, :holder_address, :validity_year, :validity_month, :cc_code,
      :operation);
END
^

ALTER PROCEDURE DOCUMENT_VALIDATE$DOC(ID_DOC_HEAD TYPE OF ID_REF)
 RETURNS(FIRM_DATA TYPE OF TNOTE_BLOB,
WARN_CODE TYPE OF TRANGE,
NEW_DOC_DATE TYPE OF TDATE)
 AS
declare variable no_use varchar(255);
  declare variable doc_value numeric(15,4);
  declare variable rest_value numeric(15,4);
  declare variable lines_value numeric(15,4);
  declare variable lines_wot_vat numeric(15,4);
  declare variable tax_value numeric(15,4);
  declare variable taxable_value numeric(15,4);
  declare variable round_to numeric(15,4);
  declare variable id_doc_contragent integer;
  declare variable id_doc_supplier integer;
  declare variable for_deposit integer;
  declare variable id_profile integer;
  declare variable dbkey char(8);
  declare variable id_contragent integer;
  declare variable ident_no varchar(20) ;
  declare variable action_text varchar(255);
  declare variable doc_currency varchar(3);
  declare variable is_juridical_person smallint;
  declare variable vat_ident_no varchar(30);
  declare variable id_doc_type integer;
  declare variable doc_sub_type integer;
  declare variable required_ident_no smallint;
  declare variable required_vat_no smallint;
  declare variable required_egn smallint;
  declare variable required_recipient_name smallint;
  declare variable lines_count integer;
  declare variable recipient_name varchar(100);
  declare variable id_doc_completed integer;
  declare variable action_code varchar(50);
begin

  select D.RDB$DB_KEY, D.DOC_VALUE_A, C.ROUND_TO,
         D.ID_DOC_CONTRAGENT, D.ID_DOC_SUPPLIER, D.FOR_DEPOSIT,
         A.ID_PROFILE, D.DOC_CURRENCY, D.TAXABLE_VALUE, d.ID_DOC_TYPE, d.DOC_SUB_TYPE,
         dc.ID_DOC_HEAD, ds.FIRM_DATA
  from   DOC_HEAD$INT D
         join CURRS C on C.CURR = D.DOC_CURRENCY
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         left outer join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
         left outer join DOC_SUPPLIER ds on ds.ID_DOC_SUPPLIER = d.ID_DOC_SUPPLIER
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :dbkey, :doc_value, :round_to,
         :id_doc_contragent, :id_doc_supplier, :for_deposit,
         :id_profile, :doc_currency, :taxable_value, :id_doc_type, :doc_sub_type,
         :id_doc_completed, :FIRM_DATA;

  if (:id_doc_contragent is null) then
    exception DOCUMENT_EXCEPTION '-356'; --'Contragent is not set!';

  if (:id_doc_supplier is null) then
    exception DOCUMENT_EXCEPTION '-357'; --'Supplier is not set!';

  select sum(DT.TAX_VALUE)
  from   DOC_TAXES DT
  where  DT.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :tax_value;

  /*if (round_f(:doc_value - :total_value, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Total value is not correct!';
  */
  select round_f(sum(DL.SINGLE_VALUE * DL.QTY_POST), :round_to),
         round_f(sum(DL.WOT_VAT), :round_to),
         count(*)
  from   DOC_LINE DL
  where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :lines_value, :lines_wot_vat, :lines_count;
 
  if (:lines_count = 0) then
    exception INTERNAL_DOC_EXCEPTION 'Document is empty! Not exists sale lines!';

  if (round_f(:doc_value - :lines_value, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines total value is not correct!' || :doc_value ||  ' / ' || :lines_value || ' ; '|| (:doc_value - :tax_value) ||  ' / ' || :lines_wot_vat;

  if (round_f(:doc_value - :tax_value - :lines_wot_vat, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines wot tax value is not correct!';

  if (round_f(abs(:lines_wot_vat) - abs(:taxable_value), :round_to) < 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines wot tax value is less than total taxable value!';

  if (:id_doc_completed is not null) then begin
    select DV.PAYABLE_VALUE
    from   DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, null) DV
    into   :rest_value;
  
    if (round_f(:rest_value, :round_to) <> 0) then
      exception DOCUMENT_EXCEPTION '-371'; --'Insufficient amount of payments !';
  end

  /* Validate contragent data */
  select dt.REQUIRED_IDENT_NO, dt.REQUIRED_VAT_NO, dt.REQUIRED_EGN, dt.REQUIRED_RECIPIENT_NAME
  from   DOC_TYPE_INV DT
  where  dt.ID_DOC_TYPE = :id_doc_type
  into   :required_ident_no, :required_vat_no, :required_egn, :required_recipient_name;

  select dc.ID_CONTRAGENT, dc.IS_JURIDICAL_PERSON,
         trim(coalesce(dc.IDENT_NO, '')), trim(coalesce(dc.VAT_REG_NUM, '')),
         trim(coalesce(dc.RECIPIENT_NAME, ''))
  from   DOC_CONTRAGENT dc
  where  dc.ID_DOC_CONTRAGENT = :id_doc_contragent
  into   :id_contragent, :is_juridical_person, :ident_no, :vat_ident_no, :recipient_name;

  if (:doc_sub_type = 0 and :required_ident_no = 1 and :is_juridical_person = 1 and :ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-324'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_egn = 1 and :is_juridical_person = 0 and :ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-324'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_vat_no = 1 and :is_juridical_person = 1 and :vat_ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-326'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_recipient_name = 1 and :recipient_name = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-327'; --'Recipient_name is empty.';
  /*if (:post_address = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-325'; --'Contragent address is empty.';
  /* save contragent link for profile */
  if (:id_contragent is not null) then begin
    update PROFILE P
    set    P.ID_DEF_CONTRAGENT = :id_contragent
    where  P.ID_PROFILE = :id_profile
           and P.ID_DEF_CONTRAGENT is null;
  end

  /*  */
  execute procedure DOC_CHECK_FISCAL$INT(:dbkey);
  /*  */
  execute procedure DOCUMENT_SET_NUMBER$INT (:dbkey)
  returning_values (:no_use, :no_use);
  /*  */
  if (:id_doc_completed is not null) then begin
    if (:for_deposit = 0) then begin
      /* check used deposits and create storno docs if necessary */
      /*execute procedure DOCUMENT_DEPOSIT_DOC_APPLY$INT (:ID_DOC_HEAD)
      returning_values  (:RESULT_DOC_LIST);  */
      /* update account posts */
      execute procedure ACCOUNT_POSTING_DOC_UPDATE$INT (:dbkey)
      returning_values :WARN_CODE;
    end

    execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT (:dbkey, null, 1, null);
    /* ... */
    execute procedure DOCUMENT_BONUSPOINTS_APPLY$CL (:ID_DOC_HEAD);
    /* ... */
  end
  /*  */
  action_text = f_character(29) || formatfloat(:doc_value, 'F;0.00') || ' ' || :doc_currency;
  action_code = iif(:id_doc_completed is null,  'PROFORMA_CREATE', 'CREATE');
  execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :ID_DOC_HEAD, :action_code, :action_text);

  select cast('31.12.1899' as date) + count(d.ID_DOC_HEAD)
  from   DOC_HEAD$INT d
  where  d.DOC_DATE is not null
  into   :NEW_DOC_DATE;

end
^

/* Alter (DEPOSIT_REFUND$DOC) */
ALTER PROCEDURE DEPOSIT_REFUND$DOC(ID_DEPOSIT INTEGER,
REFUND_AMOUNT NUMERIC(15,4),
REFUND_CURRENCY VARCHAR(3),
ID_PAY_DOC_TYPE INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_REFUND_PAYMENT INTEGER,
ID_STORNO_DOC INTEGER)
 AS
declare variable no_use varchar(2000);
  declare variable id_account integer;
  declare variable avail_value numeric(15,4);
  declare variable id_doc_head integer;
  declare variable pay_currency varchar(3);
  declare variable pay_rate numeric(15,6);
  declare variable sys_date date;
  declare variable round_to numeric(15,4);
  declare variable p_dbkey char(8);
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable id_account_payment integer;
  declare variable id_doc_type integer;
  declare variable account_curr varchar(3);
  declare variable account_rate numeric(15,6);
  declare variable id_reserv_detail integer;
  declare variable is_posting_stopped integer;
  declare variable firm_data type of tnote_blob;
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_REFUND');

  select D.ID_ACCOUNT, DH.ID_DOC, dh.ID_DOC_TYPE, c.ROUND_TO, d.ID_RESERV_DETAIL,
         D.AVAIL_VALUE, D.PAY_CURRENCY, D.PAY_RATE, A.ID_HOTEL, A.ACCOUNT_CURR
  from   DEPOSIT_AVAILABLE D
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join CURRS C on c.CURR = d.PAY_CURRENCY
         left outer join DOC_HEAD DH on DH.ID_DOC = D.ID_DOC_HEAD
                                        and DH.IS_STORNED = 0
                                        and DH.IS_ANUL = 0
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_account, :id_doc_head, :id_doc_type, :round_to, :id_reserv_detail,
         :avail_value, :pay_currency, :pay_rate, :id_hotel, :account_curr;

  if (:pay_currency is distinct from :refund_currency) then exception PAYMENT_EXCEPTION 'Currency mismatch!';

  if (round_f(:avail_value - :REFUND_AMOUNT, :round_to) < 0) then exception PAYMENT_EXCEPTION '-305';
  --'Issued value is more than available deposit amount.';

  select r.IS_POSTING_STOPPED
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :is_posting_stopped;

  if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';

  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET(:id_hotel) SD
  into   :sys_date;

  select first 1 ap.ACC_RATE
  from   ACCOUNT_PAYMENTS ap
  where  ap.ID_DEPOSIT = :ID_DEPOSIT
  order by ap.ID_ACCOUNT_PAYMENT asc
  into   :account_rate;

  execute procedure PAYMENT_CREATE$INT (:ID_PAY_DOC_TYPE, :ID_ACCOUNT, :SYS_DATE,
          -:REFUND_AMOUNT, :PAY_CURRENCY, :PAY_RATE, :account_curr, :account_rate, :DESCRIPTION)
  returning_values  (:id_refund_payment, :id_account_payment, :no_use);

  insert into DEPOSIT_REFUND (ID_DEPOSIT, ID_PAYMENT_HEAD, DESCRIPTION)
  values (:ID_DEPOSIT, :ID_REFUND_PAYMENT, :DESCRIPTION);

  update ACCOUNT_PAYMENTS AP
  set    AP.ID_DEPOSIT = :ID_DEPOSIT
  where  ap.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT;

  if (:ID_DOC_HEAD is not null) then begin
    execute procedure DOC_TYPE_EVALUATE$INT (:id_doc_type, :id_hotel, 0, :ID_REFUND_PAYMENT);

    execute procedure DOCUMENT_ADVANCE_STORNO$INT (:ID_DEPOSIT, :REFUND_AMOUNT, :DESCRIPTION)
    returning_values  (:ID_STORNO_DOC);

    execute procedure DOCUMENT_ATTACH_PAYMENT$INT (:ID_STORNO_DOC, :id_account_payment, :pay_rate, null)
    returning_values :no_use;
     
    update  PAYMENT_HEAD P
    set     P.ID_DOC_HEAD = :ID_STORNO_DOC
    where   P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT;

    execute procedure DOCUMENT_VALIDATE$DOC (:ID_STORNO_DOC)
    returning_values (:firm_data, :no_use, :no_use);
  end else begin
    select P.RDB$DB_KEY
    from   PAYMENT_HEAD P
    where  P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT
    into   :P_DBKEY;
     
    execute procedure PAYMENT_SET_NUMBER$INT (:P_DBKEY);
  end

  action_text = F_CHARACTER(29) || :REFUND_AMOUNT || ' ' || :PAY_CURRENCY;
  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'REFUND', :ACTION_TEXT);
end
^

/* Alter (OWNER_MODIFY$PMS) */
ALTER PROCEDURE OWNER_MODIFY$PMS(ID_OWNER INTEGER,
WEB_NAME VARCHAR(30),
WEB_PASSWORD VARCHAR(50),
WEB_DESCRIPTION VARCHAR(2000),
BANK_NAME VARCHAR(50),
BANK_CODE VARCHAR(30),
ACCOUNT_CODE VARCHAR(30),
TITULAR VARCHAR(100),
BILLING_CYCLE VARCHAR(50),
BILLING_FIRST_DATE DATE,
ID_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PMS INTEGER,
PMS_MARKERS BLOB SUB_TYPE 1 SEGMENT SIZE 100,
ID_RENTAL_POOL_UNIT INTEGER,
STATEMENT_LANG VARCHAR(5),
OPERATION VARCHAR(20))
 AS
declare variable old_curr varchar(3);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:BILLING_FIRST_DATE = '30.12.1899') then BILLING_FIRST_DATE = null; --exception WRONG_PARAM_VALUE;
  if (coalesce(:WEB_NAME,'')='') then WEB_NAME = :ID_OWNER;
  WEB_PASSWORD = coalesce(:WEB_PASSWORD,'');
  if ( coalesce(trim(:STATEMENT_LANG), '') = '' ) then begin
    execute procedure SYSTEM_INFO_GET('BASE_LANG')
    returning_values  :STATEMENT_LANG;
  end

  if (:OPERATION in ('add', 'mod') and not exists (select c.CURR from CURRS c where c.CURR = :ID_CURRENCY)) then
    exception PMS_EXCEPTION '-627';

  if (:operation = 'add') then begin
    insert into OWNER$PMS (ID_OWNER, WEB_NAME, WEB_PASSWORD, WEB_DESCRIPTION, BILLING_CYCLE,
           BANK_NAME, BANK_CODE, ACCOUNT_CODE, TITULAR, BILLING_FIRST_DATE, ID_CURRENCY,
           LAST_BILLING_DATE, ID_ACC_TEMPLATE_PMS, PMS_MARKERS, ID_RENTAL_POOL_UNIT, STATEMENT_LANG)
    values (:ID_OWNER, :WEB_NAME, :WEB_PASSWORD, :WEB_DESCRIPTION, :BILLING_CYCLE,
           :BANK_NAME, :BANK_CODE, :ACCOUNT_CODE, :TITULAR, :BILLING_FIRST_DATE, :ID_CURRENCY,
           null, :ID_ACC_TEMPLATE_PMS, :PMS_MARKERS, :ID_RENTAL_POOL_UNIT, :STATEMENT_LANG);

    --execute procedure PMS_ACCOUNT_CREATE$INT(:ID_OWNER, :ID_RENTAL_POOL_UNIT, null); -- account must be created on demand
  end else if (:operation = 'mod') then begin
    select O.ID_CURRENCY
    from   OWNER$PMS O
    where  O.ID_OWNER = :ID_OWNER
    into   :old_curr;

    if (:OLD_CURR <> :ID_CURRENCY) then begin
      if ( (exists (select *
                    from   ACCOUNT_POST AP
                           join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
                    where  A.IS_PMS_ACCOUNT = 1
                           and A.ID_PROFILE = :ID_OWNER
                           and AP.IS_ANUL = 0  ))
               or
           (exists (select *
                    from   ACCOUNT_POST$PMS APP
                    where  APP.ID_OWNER = :ID_OWNER
                           and APP.LINE_STATUS < 22  ))   ) then
      begin
        --ID_CURRENCY = :OLD_CURR;
        exception PMS_EXCEPTION '-617';
      end
    end

    update OWNER$PMS A
    set WEB_NAME = :WEB_NAME,
        WEB_PASSWORD = :WEB_PASSWORD,
        WEB_DESCRIPTION = :WEB_DESCRIPTION,
        BILLING_CYCLE = :BILLING_CYCLE,
        BANK_NAME = :BANK_NAME,
        BANK_CODE = :BANK_CODE,
        ACCOUNT_CODE = :ACCOUNT_CODE,
        TITULAR = :TITULAR,
        BILLING_FIRST_DATE = :BILLING_FIRST_DATE,
        ID_CURRENCY = :ID_CURRENCY,
        ID_ACC_TEMPLATE_PMS = :ID_ACC_TEMPLATE_PMS,
        PMS_MARKERS = :PMS_MARKERS,
        ID_RENTAL_POOL_UNIT = :ID_RENTAL_POOL_UNIT,
        STATEMENT_LANG = :STATEMENT_LANG
    where (ID_OWNER = :ID_OWNER);
  end else if (:operation = 'del') then begin
    delete from OWNER$PMS
    where (ID_OWNER = :ID_OWNER);
  end

  execute procedure SYSTEM_CACHE_APPLY('OWNER$PMS');
end
^

/* Alter (POST_PREPARE_ON_ACCOUNT$POST) */
ALTER PROCEDURE POST_PREPARE_ON_ACCOUNT$POST(ID_ACCOUNT ID_REF,
ID_SERVICE ID_REF,
QTY TQTY,
ID_SEQUENCE TRANGE,
PRICE_POST TPRICE,
CURR_POST TCURRENCY,
POST_TEXT TOBJECT_TEXT,
FROM_DATE TDATE,
TO_DATE TDATE,
ID_PHONECALL ID_REF = null)
 RETURNS(NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable id_hotel id_ref;
declare variable date_post tdate;
begin

  execute procedure POST_PRICE_CHECK$INT (:QTY, :PRICE_POST, :CURR_POST);

  if (:FROM_DATE is null) then begin
    select A.ID_HOTEL
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :ID_ACCOUNT
    into   :id_hotel;

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :FROM_DATE;
    TO_DATE = :FROM_DATE;
  end

  for
    select sp.OUT_DATE
    from   SYSTEM_LOOP_PERIOD (:FROM_DATE, :TO_DATE) sp
    into   :date_post
  do begin
    insert into TMP_SERVICE_POST (ID_SERVICE, ID_ACCOUNT, ID_GUEST,
           PRICE_POST, CURR_POST, QTY_POST, DATE_POST, ID_SEQUENCE, POST_TEXT, ID_PHONECALL)
    values (:ID_SERVICE, :ID_ACCOUNT, null,
           :PRICE_POST, :CURR_POST, :QTY, :date_post, :ID_SEQUENCE, :POST_TEXT, :ID_PHONECALL);
  end

  select cast('31.12.1899' as date) + count(ap.ID_ACCOUNT_POST)
  from   ACCOUNT_POST ap
  where  ap.DATE_POST is not null
  into   :NEW_FROM_DATE;

end
^

/* Alter (POST_PREPARE_ON_GUEST$POST) */
ALTER PROCEDURE POST_PREPARE_ON_GUEST$POST(ID_GUEST ID_REF,
ID_SERVICE ID_REF,
QTY TQTY,
ID_SEQUENCE TRANGE,
PRICE_POST TPRICE,
CURR_POST TCURRENCY,
POST_TEXT TOBJECT_TEXT,
FROM_DATE TDATE,
TO_DATE TDATE)
 RETURNS(NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable dbg varchar(1000);
declare variable date_post tdate;
begin
  execute procedure POST_PRICE_CHECK$INT (:QTY, :PRICE_POST, :CURR_POST);
  /* check if exists available posting account for guest */
  execute procedure GUEST_GET_POSTING_ACCOUNT$INT (:ID_GUEST, '')
  returning_values  (:dbg, :dbg);

  for
    select sp.OUT_DATE
    from   SYSTEM_LOOP_PERIOD (:FROM_DATE, :TO_DATE) sp
    into   :date_post
  do begin
    insert into TMP_SERVICE_POST (ID_SERVICE, ID_ACCOUNT, ID_GUEST,
           PRICE_POST, CURR_POST, QTY_POST, DATE_POST, ID_SEQUENCE, POST_TEXT)
    values (:ID_SERVICE, null, :ID_GUEST,
           :PRICE_POST, :CURR_POST, :QTY, :date_post, :ID_SEQUENCE, :POST_TEXT);
  end

  select cast('31.12.1899' as date) + count(ap.ID_ACCOUNT_POST)
  from   ACCOUNT_POST ap
  where  ap.DATE_POST is not null
  into   :NEW_FROM_DATE;

end
^

/* empty dependent procedure body */
/* Clear: EAI_TELECOUNT_TRANSFER for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALL_POST$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL /* ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALLS_POST_TO_ACCOUNT$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_TELECOUNT_TRANSFER$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_TELECOUNT_CALL$INT) */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ext_ifc_name varchar(20);
  declare variable room_name varchar(30);
  declare variable datetime_call timestamp;
  declare variable price numeric(15,2);
  declare variable dial_number varchar(50);
  declare variable units integer;
  declare variable pc_id_service integer;
  declare variable def_manual_curr char(3);
  declare variable post_text varchar(50);
  declare variable id_account_post integer;
  declare variable is_archive integer;
  declare variable id_account integer;
  declare variable new_id_account_post integer;
  declare variable pc_tag varchar(20);
  declare variable number_zone varchar(50);
  declare variable id_hotel integer;
  declare variable id_phonecall integer;
  declare variable no_use varchar(255);
begin
  /* Description:
  || POST_TO_TYPE = 0 - ACCOUNT, 1 - GUEST, 2 - RESERV_DETAIL, 3 - JUST PREPARE, FOR EXTERNAL CLIENT
  */
  err_code = 0;
  err_text = '';
  ext_ifc_name = 'TELECOUNT';

  select PC.ID_PHONECALL, PC.ROOM_NAME, PC.DATETIME_CALL, PC.PRICE, PC.DIAL_NUMBER, PC.UNITS,
         PC.ID_ACCOUNT_POST, PC.IS_ARCHIVE, PC.TAG, substring(PC.NUMBER_ZONE from 1 for 30), pc.ID_HOTEL
  from   PHONECALLS PC 
  where  PC.rdb$db_key = :ph_dbkey
  into   :id_phonecall, :room_name, :datetime_call, :price, :dial_number, :units,
         :id_account_post, :is_archive, :pc_tag, :number_zone, :id_hotel;

  if ((:is_archive = 1) or (coalesce(:id_account_post, 0) > 0)) then exit;

  if ((:pc_tag is null) or (:pc_tag = '')) then pc_tag = 'TELECOUNT_DEFAULT';
  else pc_tag = 'TELECOUNT_' || :pc_tag;

  execute procedure EAI_MAP_SERVICE(:pc_tag, :number_zone, :ext_ifc_name, :id_hotel)
  returning_values  :err_code, :err_text, :pc_id_service;
  if (:err_code < 0) then exit;

  post_text = substring(:dial_number || ', impulses ' || :units from 1 for 50);

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :def_manual_curr;

  new_id_account_post = null;
  if (:post_to_type = 0) then begin
    id_account = :post_to_id;
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name)
    returning_values :err_code, :err_text, :new_id_account_post;
  end else if (:post_to_type = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:post_to_id, :pc_id_service, 1, -1, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name, '')
    returning_values :err_code, :err_text, :id_account, :new_id_account_post;
  end else if (:post_to_type = 2) then begin
    execute procedure POST_SERVICE_ON_RESERVATION$INT(:post_to_id, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name)
    returning_values :err_code, :err_text, :id_account, :new_id_account_post;
  end else if (:post_to_type = 3) then begin
    execute procedure POST_PREPARE_ON_ACCOUNT$POST (:post_to_id, :pc_id_service,
      1, :ID_SEQUENCE, :price, :def_manual_curr, :post_text, null, :ID_PHONECALL)
    returning_values :no_use;
  end
  if (:err_code < 0) then exit;

  if (:new_id_account_post is not null) then begin
    update PHONECALLS PC
    set    PC.ID_ACCOUNT_POST = :new_id_account_post,
           pc.POSTING_ERROR = null
    where  PC.rdb$db_key = :ph_dbkey;
  end

end
^

/* Alter (POST_TELECOUNT_TRANSFER$TC) */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ph_dbkey char(8);
  declare variable id_account_post integer;
  declare variable account_name varchar(50);
begin
  err_code = 0;
  err_text = '';

  for
    select PC.RDB$DB_KEY, PC.ID_ACCOUNT_POST
    from   PHONECALLS PC
    where  PC.SELECTION_ID = :selection_id
    into   :ph_dbkey, :id_account_post
  do begin
    if ((:id_account_post is not null) and (:id_account_post <> -1)) then begin
      err_code = -117;
      select A.ACCOUNT_NAME
      from   ACCOUNT_POST AP
             join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
      where  AP.ID_ACCOUNT_POST = :id_account_post
      into   :account_name;
      err_text = f_character(29) || :account_name;
      exit;
    end

    execute procedure POST_TELECOUNT_CALL$INT(2, :id_reserv_detail, :ph_dbkey, 0)
    returning_values :err_code, :err_text;
    if (:err_code < 0) then exit;
  end
end
^

/* empty dependent procedure body */
/* Clear: EAI_RES_CHECK_OUT_FAST for: RES_CHECK_OUT_CHECK$RSV */
ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_CHECK_OUT_CHECK$RSV) */
ALTER PROCEDURE RES_CHECK_OUT_CHECK$RSV(SELECTION_ID INTEGER)
 RETURNS(IS_EARLY_CHECK_OUT SMALLINT,
EARLY_CHECK_OUT_DEP_DATE DATE,
CHECK_OUT_DATE DATE)
 AS
declare variable max_to_date date;
  declare variable cnt_early_dates integer;
  declare variable min_check_status integer;
  declare variable max_check_status integer;
  declare variable id_hotel integer;
  declare variable hotels_cnt integer;
  declare variable booking_number varchar(62);
  declare variable safe_name varchar(50);
begin
  is_early_check_out = 0;
  early_check_out_dep_date = null;
  select min(RD.ID_HOTEL), count(distinct RD.ID_HOTEL)
  from   RESERV_DETAIL RD
  where  RD.SELECTION_ID = :SELECTION_ID
  into   :id_hotel, :hotels_cnt;

  if (:hotels_cnt > 1) then exception RESERV_CHECK_OUT_EXCEPTION '-1020';

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values  :check_out_date;

  for
    select max(G.TO_DATE),
           count(distinct case when RD.CHECK_STATUS = 0 and RD.TO_DATE > :check_out_date then RD.TO_DATE else null end),
           min(RD.CHECK_STATUS), max(RD.CHECK_STATUS)
    from   RESERV_DETAIL RD
           left outer join GUEST G on G.ID_RESERV_DETAIL = RD.ID_RESERV_DETAIL
                                      and G.CHECK_STATUS >= 0 /* checked in guests */
    where  RD.SELECTION_ID = :selection_id
    into   :max_to_date, :cnt_early_dates, :min_check_status, :max_check_status
  do begin
    if (:max_check_status > 0) then
        exception RESERV_CHECK_OUT_EXCEPTION '-1013'; --'Reservation is already checked out.';

    if ((:min_check_status is null) or (:min_check_status < 0)) then
        exception RESERV_CHECK_OUT_EXCEPTION '-1006'; --'Can not check out not checked in reservation.';

    if (:max_to_date > :CHECK_OUT_DATE) then begin
      if (:cnt_early_dates > 1) then begin
        exception RESERV_CHECK_OUT_EXCEPTION '-1014'; --'In selection has different departure dates for early check out.';

      end else if (:max_to_date > :CHECK_OUT_DATE) then begin
        execute procedure RIGHTS_CHECK_GRANTED$INT('CHECK_OUT_EARLY');
      
        is_early_check_out = 1;
        early_check_out_dep_date = :max_to_date;
      end
    end
  end 

  for
    select rd.NUMBER, s.SAFE_NAME
    from   RESERV_DETAIL RD
           join RESOURCE_RESERVATION rr on rr.BOOKING_NUMBER = rd.NUMBER
           join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
           join SAFES s on s.ID_CURRENT_OCCUPANCY = rr.ID_RESOURCE_RESERVATION
    where  rd.SELECTION_ID = :SELECTION_ID
           and s.IS_OCCUPIED = 1
    into   :booking_number, :safe_name
  do begin
    execute procedure ERROR_LOG_ADD (-1060, f_character(29) || :booking_number || f_character(28) || :safe_name);
  end 
end
^

/* Alter (RES_CREATE_SET$RSV) */
ALTER PROCEDURE RES_CREATE_SET$RSV(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
SUPPRESS_WARNINGS INTEGER,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER,
NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable rd_dbkey char(8);
begin
  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, :check_status, :arrival_date, :departure_date,
                    :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff, :PACKET_ITEM_IDS,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
                    :guarantee_deposit, :guarantee_currency, :split_on_checkin, null, null, :ID_ACC_TEMPLATE_PERSON,
                    :ID_GUARANTEE_POLICY, null, :ID_EATING_OBJECT)
  returning_values  :rd_dbkey, :new_id_reserv_detail;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :ERR_TEXT, :share_transaction_id, :warn_code;

  if (:suppress_warnings = 1) then begin
    delete from SYSTEM_WARNINGS W
    where W.ID_TRANSACTION = :warn_code;
    warn_code = null;
  end

  update RESERV_DETAIL RD
  set    RD.NOTE_REMINDERS = :note_reminders
  where  RD.RDB$DB_KEY = :rd_dbkey;

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;

end
^

/* Alter (RES_DELETE$RSV) */
ALTER PROCEDURE RES_DELETE$RSV(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT,
NEW_FROM_DATE TYPE OF TDATE)
 AS
begin

  execute procedure RES_DELETE$INT(:ID_RESERV_DETAIL, :REASON)
  returning_values :WARN_CODE, :EXTRA_POSTS_LEFT;

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;
end
^

/* Alter (RESMULTI_CREATE$RSV) */
ALTER PROCEDURE RESMULTI_CREATE$RSV(ID_HOTEL INTEGER,
ID_ROOM_TYPE INTEGER,
TRANSFER_OUT_TIME TIME,
TRANSFER_IN_TIME TIME,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
TRANSFER_OUT_NOTE VARCHAR(50),
TRANSFER_IN_NOTE VARCHAR(50),
NOTE VARCHAR(255),
ID_BOARD INTEGER,
VOUCHER_DATE DATE,
VOUCHER_NUMBER VARCHAR(20),
VOUCHER_TEXT VARCHAR(30),
CHECK_STATUS INTEGER,
ID_TARIFF INTEGER,
COUNTRY_CODE VARCHAR(20),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
NOTE_REMINDERS VARCHAR(50),
TITULAR_NAME VARCHAR(100),
SPLIT_ON_CHECKIN INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
NUMBER VARCHAR(62),
NEW_ID_TITULAR INTEGER,
NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable rd_dbkey char(8);
  declare variable id_person_profile integer;
  declare variable pd_dbkey char(8);
  declare variable id_acc_template_person integer;
  declare variable first_name varchar(30);
  declare variable surname varchar(30);
  declare variable family_name varchar(30);
begin

  select sv.SETTING_VALUE
  from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :ID_HOTEL) sv
  into   :id_acc_template_person;

  execute procedure RES_CREATE_SET$INT(:id_agent_profile, null, :check_status, :arrival_date, :departure_date,
                    :adult_count, :children_count, :id_room_type, null, :id_board, :id_tariff, null,
                    null, null, :voucher_number, :voucher_date, :voucher_text, '',
                    null, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    1, 0, 0, :country_code, :code_first_food, '',
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    '', :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders, null, null,
                    :split_on_checkin, null, null, :id_acc_template_person, null, null, :ID_EATING_OBJECT)
  returning_values  :rd_dbkey, :new_id_reserv_detail;

  select RD.NUMBER, RD.ID_PERSON_PROFILE, RD.ID_TITULAR
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :number, :id_person_profile, :new_id_titular;

  if (:titular_name <> '') then begin
    select PD.RDB$DB_KEY
    from   PROFILE P
           join PROFILE_PERSON PP on PP.ID_PROFILE = P.ID_PROFILE
           join PERSON_DATA PD on PD.ID_PERSON_DATA = PP.ID_PERSON_DATA
    where  P.ID_PROFILE = :id_person_profile
    into   :pd_dbkey;

    select PP.FIRST_NAME, PP.SURNAME, PP.FAMILY_NAME
    from   PERSON_NAME_PARSE$INT (:TITULAR_NAME) PP
    into   :first_name, :surname, :family_name;

    update PERSON_DATA PD
    set    PD.PERSON_NAME2 = :titular_name,
           PD.FIRST_NAME = :first_name,
           PD.SURNAME = :surname,
           PD.FAMILY_NAME = :family_name
    where  PD.RDB$DB_KEY = :pd_dbkey;
  end

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;
end
^

/* Alter (RIGHTS_REGRANT) */
ALTER PROCEDURE RIGHTS_REGRANT AS
declare variable relation_name char(31);
  declare variable ui_role_name char(31);
  declare variable ena_role_name char(31);
begin
  ui_role_name = 'CLOCKBS_ROLE';
  ena_role_name = 'HTTPDBA_ROLE';

  /* PRIVILEGES GIVEN DIRECTLY TO SOME DB USER MUST BE PRESERVED.
  || AUTOGRANTS ARE MADE ONLY TO THE 'UI' and 'ENA' ROLES AND 'PUBLIC' USER.
  */
  delete from RDB$USER_PRIVILEGES UP
  where  (UP.RDB$USER_TYPE not in (8 /* user*/, 13 /* role */));

  delete from RDB$USER_PRIVILEGES UP
  where  (UP.RDB$USER = :ui_role_name)
         or (UP.RDB$USER = :ena_role_name)
         or (UP.RDB$USER = 'PUBLIC');

  /* THE 'UI' ROLE MUST HAVE ALL PRIVILIGES LIKE THE USER 'SYSDBA'.
  || ONLY NATIVE CLOCKBS APPLICATIONS ARE USING THIS ROLE.
  */
  insert into RDB$USER_PRIVILEGES (RDB$USER, RDB$GRANTOR, RDB$PRIVILEGE, RDB$GRANT_OPTION,
         RDB$RELATION_NAME, RDB$FIELD_NAME, RDB$USER_TYPE, RDB$OBJECT_TYPE)
  select :ui_role_name, 'SYSDBA', U.RDB$PRIVILEGE, 0,
         U.RDB$RELATION_NAME, U.RDB$FIELD_NAME, 13, U.RDB$OBJECT_TYPE
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = 'SYSDBA'
         and (not exists (select u2.RDB$PRIVILEGE
                          from   RDB$USER_PRIVILEGES u2
                          where  u2.RDB$USER = :ui_role_name
                                 and u2.RDB$PRIVILEGE = U.RDB$PRIVILEGE 
                                 and u2.RDB$RELATION_NAME = u.RDB$RELATION_NAME))
         and U.RDB$PRIVILEGE <> 'M' /* MEMBERSHIP */;

  insert into RDB$USER_PRIVILEGES (RDB$USER, RDB$GRANTOR, RDB$PRIVILEGE, RDB$GRANT_OPTION,
         RDB$RELATION_NAME, RDB$FIELD_NAME, RDB$USER_TYPE, RDB$OBJECT_TYPE)
  select :ena_role_name, 'SYSDBA', U.RDB$PRIVILEGE, 0,
         U.RDB$RELATION_NAME, U.RDB$FIELD_NAME, 13, U.RDB$OBJECT_TYPE
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = 'SYSDBA'
         and u.RDB$RELATION_NAME starting with 'ENA_'
         and (not exists (select u2.RDB$PRIVILEGE
                          from   RDB$USER_PRIVILEGES u2
                          where  u2.RDB$USER = :ena_role_name
                                 and u2.RDB$PRIVILEGE = U.RDB$PRIVILEGE 
                                 and u2.RDB$RELATION_NAME = u.RDB$RELATION_NAME))
         and U.RDB$PRIVILEGE in ('S') /* Select (and Reference ??) */;

  /* GRANT REFERENCE RIGHT TO 'PUBLIC' FOR ALL TABLES THAT ARE REFERENCED WITH
  || FOREIGN KEYS.
  */
  insert into RDB$USER_PRIVILEGES (RDB$USER, RDB$GRANTOR, RDB$PRIVILEGE, RDB$GRANT_OPTION,
         RDB$RELATION_NAME, RDB$FIELD_NAME, RDB$USER_TYPE, RDB$OBJECT_TYPE)
  select distinct
         'PUBLIC', 'SYSDBA', 'R', 0, RC2.RDB$RELATION_NAME, null, 8, 0
  from   RDB$RELATION_CONSTRAINTS RC
         join RDB$REF_CONSTRAINTS C on C.RDB$CONSTRAINT_NAME = RC.RDB$CONSTRAINT_NAME
         join RDB$RELATION_CONSTRAINTS RC2 on RC2.RDB$CONSTRAINT_NAME = C.RDB$CONST_NAME_UQ
  where  RC.RDB$CONSTRAINT_TYPE = 'FOREIGN KEY';

  /* ALL EXTERNAL INTERFACES FROM OTHER VENDORS ARE NOT USING ROLES, SO
  || THEY WILL TAKE THE PRIVILEDGES OF THE 'PUBLIC' USER. THEY MUST HAVE
  || ACCESS ONLY TO THEIR SPECIFIC PROCEDURES OR OTHER METADATA OBJECTS WICH
  || MUST BE ENUMERATED HERE.
  */
  for
    select R.RDB$RELATION_NAME
    from   RDB$RELATIONS R
    where  (R.RDB$RELATION_NAME starting with 'EAI_')
           or (R.RDB$RELATION_NAME in ('SYSTEM_INFO_MODULE','PHONECALLS'))
    union

    select R.RDB$PROCEDURE_NAME
    from   RDB$PROCEDURES R
    where  (R.RDB$PROCEDURE_NAME starting with 'EAI_')
           or (R.RDB$PROCEDURE_NAME in ('SYSTEM_INFO_GET', 'RDB$F_SP'))
    into   :relation_name
  do begin
    execute procedure RIGHTS_REGRANT_SUB('PUBLIC', :relation_name, 8);
  end
end
^

/* Alter (SAFE_CHECK_OUT) */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE TYPE OF ID)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
WARN_CODE TYPE OF ID_REF)
 AS
declare variable to_dt timestamp;
  declare variable is_occupied integer;
  declare variable expire_tollerance integer;
  declare variable occupant_name varchar(100);
  declare variable id_resource_reservation integer;
  declare variable id_account_post integer;
begin
  DOC_SELECTED = null;
  select s.IS_OCCUPIED, od.TO_DATETIME,
         st.EXPIRE_TOLLERANCE, rr.OCCUPANT_NAME, rr.ID_RESOURCE_RESERVATION, rp.ID_ACCOUNNT_POST
  from   SAFE s
         join RESOURCE$INT r on r.ID_RESOURCE = s.ID_SAFE
         join SAFE_TYPES st on st.ID_SAFE_TYPE = r.ID_RESOURCE_TYPE
         join RESOURCE_RESERVATION rr on rr.ID_RESOURCE_RESERVATION = s.ID_CURRENT_OCCUPANCY
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join RESOURCE_OCCUPANCY ro on ro.ID_RESOURCE_OCCUPANCY_DATA = od.ID_RESOURCE_OCCUPANCY_DATA
         join RESOURCE_RESERV_POST rp on rp.ID_RESOURCE_RESERVATION = rr.ID_RESOURCE_RESERVATION
  where  s.ID_SAFE = :ID_SAFE
  into   :is_occupied, :to_dt, :expire_tollerance, :occupant_name, :id_resource_reservation, :id_account_post;

  if (:is_occupied = 0) then exit;
  expire_tollerance = coalesce(:expire_tollerance, 0);

  if (current_timestamp > (:to_dt + cast(:expire_tollerance as double precision) / 60 / 24)) then begin
    execute procedure SAFE_OCCUPANCY_MODIFY (:id_safe, current_timestamp, :occupant_name)
    returning_values  :doc_selected;

    execute procedure SYSTEM_WARNING_ADD (-1066, f_character(29) || :expire_tollerance || f_character(28) || formatdate(:to_dt + cast(:expire_tollerance as double precision) / 60 / 24, 'D;dd/mm/yyyy HH:MM'))
    returning_values (:WARN_CODE);

  end else begin
    update ACCOUNT_POST AP
    set    ap.DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1)
    where  ap.ID_ACCOUNT_POST = :id_account_post
           and ap.ac = '00'
    returning new.doc_selected
    into   :DOC_SELECTED;
  end

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = null
  where  s.ID_SAFE = :ID_SAFE;

  update RESOURCE_RESERVATION rr
  set    rr.STATUS = 'CHECKED_OUT'
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_CHECKED_OUT', :occupant_name);
end
^

/* Alter (SAFE_OCCUPANCY_MODIFY) */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE TYPE OF ID,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable id_account_post id_ref;
  declare variable old_booking_number tres_number;
  declare variable id_resource_reservation id_ref;
  declare variable from_datetime tdatetime;
  declare variable action_text tdescription_long;
  declare variable old_occupant varchar(100);
  declare variable old_to_dt timestamp;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, S.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  select rr.BOOKING_NUMBER, od.FROM_DATETIME, rrp.ID_ACCOUNNT_POST, RR.OCCUPANT_NAME, od.TO_DATETIME,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESOURCE_RESERV_POST rrp on rrp.ID_RESOURCE_RESERVATION = rr.ID_RESOURCE_RESERVATION
         left outer join RESERV_DETAIL rd on rd.NUMBER = rr.BOOKING_NUMBER and rd.IS_ANUL = 0
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :old_booking_number, :from_datetime, :id_account_post, :old_occupant, :old_to_dt, :id_agent_profile;

  --if (:old_booking_number <> :BOOKING_NUMBER) then exception ASSERT 'Can not change booking number!';
  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  update SAFE_RESOURCE_RESERV rr
  set    rr.PRICE_DESCRIPTION = :price_description,
         rr.ID_RATE_PRICE_PROFILE = :id_agent_profile,
         rr.RATING_UNITS = :rating_units,
         rr.RATE_PRICE = :price,
         rr.RATE_CURR = :currency
  where  rr.ID_RESOURCE_RESERV = :id_resource_reservation;

  execute procedure RESOURCE_RESERVATION_MODIFY (:id_resource_reservation, :ID_SAFE, :from_datetime,
          :TO_DATETIME, :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :old_booking_number, 'mod')
  returning_values :id_resource_reservation, :no_use;

  execute procedure ACCOUNT_POSTING_UPDATE (:id_account_post, :id_service, null, null, 1, 0,
          :price, :currency, null, null, 'RESOURCE');

  if ((:old_occupant <> :OCCUPANT_NAME) or (:old_to_dt <> :TO_DATETIME)) then begin
    action_text = f_character(29) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                  || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                  || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');
  
    execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_CHANGED', :action_text);
  end

  DOC_SELECTED = null;
  update ACCOUNT_POST AP
  set    ap.DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1)
  where  ap.ID_ACCOUNT_POST = :id_account_post
         and ap.ac = '00'
  returning new.doc_selected
  into   :DOC_SELECTED;

  update or insert into ACCOUNT_POSTING_DET
  values(:id_account_post, :safe_name ||' / '||formatdate(:from_datetime, 'D;dd.mm.yy(hh:mm)')||' - '||formatdate(:to_datetime, 'D;dd.mm.yy(hh:mm)')||' / '
          ||substring(replace(:price_description, F_CRLF(), ';') from 1 for 100), 1, :from_datetime, :to_datetime, :safe_name, null);
end
^

/* Alter (SAFE_OCCUPANCY_NEW) */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE TYPE OF ID,
FROM_DATETIME TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME,
BOOKING_NUMBER TYPE OF TRES_NUMBER,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
ID_RESOURCE_RESERVATION TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable id_account id_ref;
  declare variable id_account_post id_ref;
  declare variable err_code integer;
  declare variable err_text varchar(255) ;
  declare variable action_text tdescription_long;
  declare variable id_reserv_detail integer;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, s.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  if (:id_resource_reservation is not null) then exception ASSERT '-1064'|| f_character(31) || f_character(29) || :safe_name;

  select rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESERV_DETAIL rd
  where  rd.NUMBER = :BOOKING_NUMBER
         and rd.IS_ANUL = 0
  into   :id_reserv_detail, :id_agent_profile;

  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  execute procedure  RESOURCE_RESERVATION_MODIFY (null, :ID_SAFE, :FROM_DATETIME, :TO_DATETIME,
          :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :BOOKING_NUMBER, 'add')
  returning_values (:id_resource_reservation, :no_use) ;

  insert into SAFE_RESOURCE_RESERV (ID_RESOURCE_RESERV, PRICE_DESCRIPTION, ID_RATE_PRICE_PROFILE,
         RATING_UNITS, RATE_PRICE, RATE_CURR)
  values (:id_resource_reservation, :price_description, :id_agent_profile,
         :rating_units, :price, :currency);

  if (:id_reserv_detail is not null) then begin
    execute procedure POST_SERVICE_ON_RESERVATION$INT (:id_reserv_detail, :id_service, 1, 0,
            1, :price, :currency, :from_datetime, :to_datetime,
            '', '', cast(:from_datetime as date), 'RESOURCE', null)
    returning_values (:ERR_CODE, :ERR_TEXT, :id_account, :id_account_post);
    if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || :err_text;
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT (:ID_EXTERNAL_CLIENT_ACCCOUNT, :id_service,
            1, 0, 1, :price, :currency, :from_datetime, :TO_DATETIME, '', '',
            cast(:from_datetime as date), 'RESOURCE', null, null)
    returning_values (:err_code, :err_text, :id_account_post);
    if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || :err_text;
  end

  update or insert into ACCOUNT_POSTING_DET
  values(:id_account_post, :safe_name ||' / '||formatdate(:from_datetime, 'D;dd.mm.yy(hh:mm)')||' - '||formatdate(:to_datetime, 'D;dd.mm.yy(hh:mm)')||' / '
          ||substring(replace(:price_description, F_CRLF(), ';') from 1 for 100), 1, :from_datetime, :to_datetime, :safe_name, null);

  insert into RESOURCE_RESERV_POST (ID_RESOURCE_RESERVATION, ID_ACCOUNNT_POST)
  values (:id_resource_reservation, :id_account_post);

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = 'CHECKED_IN'
  where  RR.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = :id_resource_reservation
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                || f_character(28) || coalesce(:BOOKING_NUMBER, '')
                || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUPIED', :action_text);

  DOC_SELECTED = null;
  update ACCOUNT_POST AP
  set    ap.DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1)
  where  ap.ID_ACCOUNT_POST = :id_account_post
         and ap.ac = '00'
  returning new.doc_selected
  into   :DOC_SELECTED;
end
^

/* Alter (SAFE_TYPE_MODIFY) */
ALTER PROCEDURE SAFE_TYPE_MODIFY(ID_SAFE_TYPE TYPE OF ID,
SAFE_TYPE_NAME TYPE OF TOBJECT_NAME,
ID_HOTEL TYPE OF ID_REF,
SHORT_CODE TYPE OF TCHAR_1,
EXPIRE_TOLERANCE TYPE OF TRANGE,
RATE_CURRENCY TYPE OF TCURRENCY,
ID_RATE_SERVICE TYPE OF ID_REF,
OPERATION VARCHAR(10))
 RETURNS(NEW_ID_SAFE_TYPE TYPE OF ID,
NEW_ID_RESOURCE_RATE TYPE OF ID_REF)
 AS
declare variable id_resource_rate integer;
begin
  if (:OPERATION = 'del') then begin
    select st.ID_RESOURCE_RATE
    from   SAFE_TYPE st
    where  st.ID_SAFE_TYPE = :ID_SAFE_TYPE
    into   :id_resource_rate;
  end

  execute procedure RESOURCE_TYPE_MODIFY$INT (:ID_SAFE_TYPE, :SAFE_TYPE_NAME, :ID_HOTEL,:OPERATION)
  returning_values (:NEW_ID_SAFE_TYPE);

  if (:OPERATION = 'add') then begin
      insert into RESOURCE_RATE (CURRENCY, ID_SERVICE)
      values (:RATE_CURRENCY, :ID_RATE_SERVICE)
      returning ID_RESOURCE_RATE
      into      :NEW_ID_RESOURCE_RATE;

      insert into SAFE_TYPE (ID_SAFE_TYPE, ID_RESOURCE_RATE, SHORT_CODE, EXPIRE_TOLERANCE)
      values (:NEW_ID_SAFE_TYPE, :NEW_ID_RESOURCE_RATE, :SHORT_CODE, coalesce(:EXPIRE_TOLERANCE, 0));
  end else if (:OPERATION = 'mod') then begin
    update  SAFE_TYPE st
    set     st.SHORT_CODE = :SHORT_CODE,
            st.EXPIRE_TOLERANCE = coalesce(:EXPIRE_TOLERANCE, 0)
    where   st.ID_SAFE_TYPE = :NEW_ID_SAFE_TYPE
    returning new.ID_RESOURCE_RATE
    into      :NEW_ID_RESOURCE_RATE;

    update RESOURCE_RATE rr
    set    rr.CURRENCY = :RATE_CURRENCY,
           rr.ID_SERVICE = :ID_RATE_SERVICE
    where  rr.ID_RESOURCE_RATE = :NEW_ID_RESOURCE_RATE;
  end else if (:OPERATION = 'del') then begin
    delete from RESOURCE_RATE r
    where  r.ID_RESOURCE_RATE = :id_resource_rate;
  end

end
^

/* Alter (SAFE_USAGE_RATING) */
ALTER PROCEDURE SAFE_USAGE_RATING(ID_SAFE_TYPE TYPE OF ID,
FROM_DATETIME TYPE OF TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
ID_AGENT_PROFILE TYPE OF ID_REF)
 RETURNS(ID_SERVICE TYPE OF ID,
PRICE TYPE OF TPRICE,
CURRENCY TYPE OF TCURRENCY,
RATING_UNITS TYPE OF TQTY,
PRICE_DESCRIPTION TDESCRIPTION_LONG)
 AS
declare variable expire_tolerance integer;
  declare variable usage_duration double precision;
  declare variable remain_units numeric(15,2);
  declare variable expire double precision;
  declare variable id_resource_rate integer;
  declare variable units_price tprice;
  declare variable units TRANGE;
  declare variable id_resource_rate_price integer;
  declare variable id_rrp_list varchar(255);
  declare variable units_cnt integer;
begin
  PRICE = null;
  id_rrp_list = null;

  select rr.ID_SERVICE, rr.CURRENCY, rt.EXPIRE_TOLERANCE, rt.ID_RESOURCE_RATE
  from   SAFE_TYPE RT
         join RESOURCE_RATE rr on rr.ID_RESOURCE_RATE = rt.ID_RESOURCE_RATE
  where  rt.ID_SAFE_TYPE = :ID_SAFE_TYPE
  into   :ID_SERVICE, :CURRENCY, :expire_tolerance, :id_resource_rate;

  expire_tolerance = coalesce(:EXPIRE_TOLERANCE, 0);
  usage_duration = :TO_DATETIME - :FROM_DATETIME;
  if (:usage_duration < 0) then exception ASSERT '-1063';

  rating_units = floor(:usage_duration);
  expire = floor((:usage_duration - :rating_units) * 24 * 60);
  if ((:expire > :expire_tolerance) or (:RATING_UNITS = 0)) then rating_units = :rating_units + 1;

  remain_units = :RATING_UNITS;
  while (:remain_units > 0) do begin
    units_price = null;
    -- get first smaller unit pack price
    select first 1 rp.UNITS, rp.PRICE, RP.ID_RESOURCE_RATE_PRICE
    from   RESOURCE_RATE_PRICE rp
    where  rp.ID_RESOURCE_RATE = :id_resource_rate
           and ((rp.ID_AGENT_PROFILE = :ID_AGENT_PROFILE) or (rp.ID_AGENT_PROFILE is null))
           and rp.UNITS <= :remain_units
    order by rp.ID_AGENT_PROFILE asc nulls last, rp.UNITS desc
    into   :units, :units_price, :id_resource_rate_price;

    if (:units_price is null) then begin
      -- get first greater unit pack price
      select first 1 rp.UNITS, rp.PRICE, RP.ID_RESOURCE_RATE_PRICE
      from   RESOURCE_RATE_PRICE rp
      where  rp.ID_RESOURCE_RATE = :id_resource_rate
             and ((rp.ID_AGENT_PROFILE = :ID_AGENT_PROFILE) or (rp.ID_AGENT_PROFILE is null))
             and rp.UNITS > :remain_units
      order by rp.ID_AGENT_PROFILE asc nulls last, rp.UNITS asc
      into   :units, :units_price, :id_resource_rate_price;
    end
    if (:units_price is null) then exception ASSERT '-1063';

    id_rrp_list = coalesce(:id_rrp_list || ',', '') || :id_resource_rate_price;
    price = coalesce(:PRICE, 0) + :units_price;
    --PRICE_DESCRIPTION = substring(coalesce(:PRICE_DESCRIPTION || F_CRLF(), '') || :units || ' = ' || :units_price || ' ' || :CURRENCY from 1 for 255);
    remain_units = :remain_units - coalesce(:units, 0);
  end

  for
    select   RP.ID_RESOURCE_RATE_PRICE,
             sum(1),
             min(RP.PRICE)
    from     SYSTEM_STRING_PARSER(:id_rrp_list, ',') SP
             join RESOURCE_RATE_PRICE RP on RP.ID_RESOURCE_RATE_PRICE = SP.ITEM
    group by 1
    order by 2 desc
    into   :id_resource_rate_price, :units_cnt, :units_price
  do begin
    PRICE_DESCRIPTION = substring(coalesce(:PRICE_DESCRIPTION || F_CRLF(), '') || :units_cnt || ' x ' || formatfloat(:units_price, 'F;0.00') || ' ' || :CURRENCY from 1 for 255);
  end

  suspend;
end
^

/* empty dependent procedure body */
/* Clear: SYSTEM_EVENT_LOG$INT for: SYSTEM_LOG_OBJECT_INFO_GET */
ALTER PROCEDURE SYSTEM_EVENT_LOG$INT(OBJECT_CLASS VARCHAR(30),
OBJECT_ID INTEGER,
EVENT_CODE VARCHAR(50),
EVENT_TEXT VARCHAR(255),
EXTRA_DATA VARCHAR(255) = null)
 RETURNS(NEW_ID_SYSTEM_LOG INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SYSTEM_LOG_OBJECT_INFO_GET) */
ALTER PROCEDURE SYSTEM_LOG_OBJECT_INFO_GET(OBJECT_CLASS VARCHAR(30),
OBJECT_ID INTEGER)
 RETURNS(OBJECT_DESCRIPTION VARCHAR(100),
HOTEL_CODE VARCHAR(10))
 AS
declare variable id_hotel integer;
begin
  object_description = null;
  id_hotel = null;
  hotel_code = null;

  if (:OBJECT_CLASS = 'RES_DETAIL') then begin
    select substring(RD.NUMBER || ', '
           || coalesce(rt.TYPE_ROOM, '') || ', '
           || formatdate(rd.FROM_DATE, 'D;dd/mm') || '-'
           || formatdate(rd.TO_DATE, 'D;dd/mm/yy') || ', '
           || coalesce(P.PROFILE_NAME, '') from 1 for 100), RD.ID_HOTEL
    from   RESERV_DETAIL RD
           join PROFILE P on P.ID_PROFILE = RD.ID_PERSON_PROFILE
           left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = rd.ID_ROOM_TYPE
    where  RD.ID_RESERV_DETAIL = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'GUEST') then begin
    select pd.PERSON_NAME, rd.ID_HOTEL
    from   GUEST G
           join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
           join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  G.ID_GUEST = :OBJECT_ID
    into   :OBJECT_DESCRIPTION, :id_hotel;
  end else if (:OBJECT_CLASS = 'DOCUMENT') then begin
    select substring(d.DOC_TYPE_NAME || ' ' || D.DOC_NUM || '/' || formatdate(D.DOC_DATE, 'D;dd.mm.yyyy') from 1 for 100), A.ID_HOTEL
    from   DOC_HEAD D
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  D.ID_DOC = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'DEPOSIT') then begin
    select substring(D.DESCRIPTION || ', ' || P.DOC_TYPE_NAME || ' ' || P.PAYMENT_NUM || '/' || formatdate(P.PAYMENT_DATE, 'D;dd.mm.yyyy') from 1 for 100), A.ID_HOTEL
    from   DEPOSIT D
           join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  D.ID_DEPOSIT = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'ACCOUNT') then begin
    select A.ACCOUNT_NAME, A.ID_HOTEL
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'ACC_TEMPLATE') then begin
    select A.TEMPLATE_NAME, A.ID_HOTEL
    from   ACC_TEMPLATE A
    where  A.ID_ACC_TEMPLATE = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'TAX_POLICY') then begin
    select t.POLICY_NAME, t.ID_HOTEL
    from   TAX_POLICY t
    where  t.ID_TAX_POLICY = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'SALE_TAX') then begin
    select st.TAX_NAME, st.ID_HOTEL
    from   SALE_TAXES st
    where  st.ID_SALE_TAX = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'PROFILE') then begin
    select P.PROFILE_NAME, null
    from   PROFILE P
    where  P.ID_PROFILE = :OBJECT_ID
    into   :OBJECT_DESCRIPTION, :id_hotel;
  end else if (:OBJECT_CLASS = 'BLOCK') then begin
    select substring(R.ROOM_NAME || ' (' || H.CODE || ')' from 1 for 100), H.ID_HOTEL
    from   BLOCK_ROOM BR     
           join ROOMS R on R.ID_ROOM = BR.ID_ROOM
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
           join HOTEL H on H.ID_HOTEL = R.ID_HOTEL
    where  BR.ID_BLOCK_ROOM = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'PAYMENT') then begin
    select substring(p.DOC_TYPE_NAME || ' ' || P.PAYMENT_NUM || '/' || formatdate(P.PAYMENT_DATE, 'D;dd.mm.yyyy') from 1 for 100), A.ID_HOTEL
    from   PAYMENT_HEAD P
           join ACCOUNT A on A.ID_ACCOUNT = P.ID_ACCOUNT
    where  P.ID_PAYMENT_HEAD = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'ROOM') then begin
    select r.ROOM_NAME, r.ID_HOTEL
    from   ROOMS R
    where  R.ID_ROOM = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'CONTRACT') then begin
    select substring(r.ROOM_NAME || ' {' || formatdate(rp.FROM_DATE, 'D;dd.mm.yyyy') || '-' || iif(extract(year from rp.TO_DATE) = 2500, '~', formatdate(rp.TO_DATE, 'dd.mm.yyyy')) || '}' from 1 for 255), r.ID_HOTEL
    from   ROOM_CONTRACT$PMS RC
           join ROOM_PERIOD$PMS rp on rp.ID_ROOM_PERIOD = rc.ID_ROOM_PERIOD
           join ROOMS R on r.ID_ROOM = rp.ID_ROOM
    where  Rc.ID_ROOM_CONTRACT = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'CURRENCY') then begin
    select c.CURR, c.ID_HOTEL
    from   CURR_RATES c
    where  c.ID_CURR_RATE = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'HOTEL') then begin
    select H.HOTEL_NAME, H.ID_HOTEL
    from   HOTEL H
    where  H.ID_HOTEL = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'SAFE') then begin
    select c.SAFE_NAME, c.ID_HOTEL
    from   SAFES c
    where  c.ID_SAFE = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'ACTIVITY_OFFER') then begin
     select ao.id_activity_offer, ao.id_hotel
     from   ACTIVITY_OFFER AO
     where  AO.ID_ACTIVITY_OFFER = :OBJECT_ID
     into   :object_description, :id_hotel;
  end

  if (:OBJECT_DESCRIPTION is null) then begin
    select SLD.DESCRIPTION, sld.HOTEL_CODE
    from   SYSTEM_LOG_DELETED SLD
    where  SLD.LOG_OBJECT_CLASS = :OBJECT_CLASS
           and SLD.LOG_OBJECT_ID = :OBJECT_ID
    into   :OBJECT_DESCRIPTION, :HOTEL_CODE;
  end

  if (:id_hotel is not null) then
    select H.CODE
    from   HOTEL H
    where  H.ID_HOTEL = :id_hotel
    into   :hotel_code;

  suspend;
end
^

/* Alter (SYSTEM_LOGON_SYSTEM) */
ALTER PROCEDURE SYSTEM_LOGON_SYSTEM(USER_NAME VARCHAR(30),
USER_PASS VARCHAR(30),
CLIENT_KIND VARCHAR(30))
 RETURNS(IS_MISSING_ROLE INTEGER,
CURRENT_SERVER_TIME DATE,
ADJUT_TIME_TOLERANCE VARCHAR(20))
 AS
declare variable found_user_password varchar(30);
begin
  /*  Description:
  ||  THIS PROCEDURE IS CALLED BY 'SYSDBA'
  ||  client_kind = 'FRONT', 'FRONT_CRS' - OUT OF USE!!!
  */
  is_missing_role = 0;

  found_user_password = null;
  select RU.USER_PASSWORD
  from   RIGHTS_USERS RU
  where  RU.USER_NAME = :user_name
         and RU.IS_ACTIVE = 1
  into   :found_user_password;

  if (:found_user_password is null) then begin
    exception USER_SERVER_ERROR '-113';
  end else begin
    if (:user_pass is distinct from :found_user_password) then exception USER_SERVER_ERROR '-113';

    if (not exists(
      select *
      from   RDB$USER_PRIVILEGES
      where  RDB$USER = :user_name
             and RDB$PRIVILEGE = 'M'
             and RDB$RELATION_NAME = 'CLOCKBS_ROLE'
    )) then is_missing_role = 1;
  end

  current_server_time = null;
end
^

/* Alter (TEST_DOC) */
ALTER PROCEDURE TEST_DOC(ID_ACCOUNT INTEGER,
DOC_SELECTED INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER)
 AS
declare variable is_dep_doc integer;
  declare variable id_hotel integer;
  declare variable dummy varchar(255);
begin
  is_dep_doc = 0;

  execute procedure DOCUMENT_INITIALIZE$DOC (:id_account, :doc_selected, null)
  returning_values (:id_doc_head, :id_hotel);

  execute procedure DOCUMENT_ADD_DEF_PAYMENT$DOC (:id_doc_head, null);

  execute procedure DOCUMENT_VALIDATE$DOC (:id_doc_head)
  returning_values :dummy, :dummy, :dummy;
  suspend;
end
^

/* Restore proc. body: EAI_RES_CHECK_OUT_FAST */
ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
declare variable selection_id integer;
  declare variable is_early_check_out smallint;
  declare variable early_check_out_dep_date date;
  declare variable check_out_date date;
begin
  selection_id = gen_id(selection_gen, 1);

  update RESERV_DETAIL RD
  set RD.SELECTION_ID = :SELECTION_ID
  where RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL;

  execute procedure RES_CHECK_OUT_CHECK$RSV(:selection_id)
  returning_values :is_early_check_out, :early_check_out_dep_date, :check_out_date;

  if (:is_early_check_out = 1) then
    exception BOOKING_EXCEPTION '-1043';

  execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id, 0);
end
^

/* Restore proc. body: EAI_TELECOUNT_TRANSFER */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* Restore proc. body: EXT_BAVEL_SERVICE_MAP_MODIFY */
ALTER PROCEDURE EXT_BAVEL_SERVICE_MAP_MODIFY(ID_SERVICE INTEGER,
IS_DISCOUNT INTEGER,
BAVEL_SERVICE_TYPE VARCHAR(50))
 AS
begin
  if (BAVEL_SERVICE_TYPE <> '') then begin
    if (exists (select bsm.ID_SERVICE from EXT_BAVEL_SERVICE_MAP bsm where bsm.ID_SERVICE = :ID_SERVICE)) then begin
      update EXT_BAVEL_SERVICE_MAP bsm
        set bsm.IS_DISCOUNT = :IS_DISCOUNT,
            bsm.BAVEL_SERVICE_TYPE = :BAVEL_SERVICE_TYPE
        where bsm.ID_SERVICE = :ID_SERVICE;
    end else begin
      insert into EXT_BAVEL_SERVICE_MAP (ID_SERVICE, IS_DISCOUNT, BAVEL_SERVICE_TYPE)
      values (:ID_SERVICE, :IS_DISCOUNT, :BAVEL_SERVICE_TYPE);
    end
  end else begin
    delete from EXT_BAVEL_SERVICE_MAP bsm
      where bsm.ID_SERVICE = :ID_SERVICE;
  end
end
^

/* Restore proc. body: PHONECALL_POST$TC */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Restore proc. body: PHONECALLS_POST_TO_ACCOUNT$TC */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* Restore proc. body: SYSTEM_EVENT_LOG$INT */
ALTER PROCEDURE SYSTEM_EVENT_LOG$INT(OBJECT_CLASS VARCHAR(30),
OBJECT_ID INTEGER,
EVENT_CODE VARCHAR(50),
EVENT_TEXT VARCHAR(255),
EXTRA_DATA VARCHAR(255) = null)
 RETURNS(NEW_ID_SYSTEM_LOG INTEGER)
 AS
declare variable machine_name varchar(30);
  declare variable log_object_class varchar(30);
  declare variable log_object_id integer;
  declare variable action_ctx varchar(50);
begin
  if (RDB$GET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE') = 'disable') then EXIT;

  action_ctx = RDB$GET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX');

  execute procedure SYSTEM_SESSION_GET('MACHINE_NAME')
  returning_values  :machine_name;

  object_id = coalesce(object_id,0);
  log_object_class = :object_class;
  log_object_id = :object_id;


  new_id_system_log = gen_id(gen_system_log_id, 1);

  insert into SYSTEM_LOG_EVENT (ID_SYSTEM_LOG, LOG_OBJECT_CLASS, LOG_OBJECT_ID, ACTION_CODE,
         ACTION_DATETIME, ACTION_USER, MACHINE_NAME, ACTION_TEXT, ACTION_CTX)
  values (:new_id_system_log, :log_object_class, :log_object_id, :event_code,
         current_timestamp, current_user, :machine_name, :event_text, :action_ctx);

  -- get related bookings
  if (:OBJECT_CLASS = 'RES_DETAIL') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    values (:OBJECT_ID, :new_id_system_log);
  end else if (:OBJECT_CLASS = 'GUEST') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select G.ID_RESERV_DETAIL, :new_id_system_log
    from   GUEST G
    where  G.ID_GUEST = :OBJECT_ID;
  end else if (:OBJECT_CLASS = 'DOCUMENT') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select A.ID_RESERV_DETAIL, :new_id_system_log
    from   DOC_HEAD D
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  D.ID_DOC = :OBJECT_ID
           and A.ID_RESERV_DETAIL is not null;
  end else if (:OBJECT_CLASS = 'DEPOSIT') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select A.ID_RESERV_DETAIL, :new_id_system_log
    from   DEPOSIT D
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  D.ID_DEPOSIT = :OBJECT_ID
           and A.ID_RESERV_DETAIL is not null;
  end else if (:OBJECT_CLASS = 'PAYMENT') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select distinct A.ID_RESERV_DETAIL, :new_id_system_log
    from   PAYMENT_HEAD P
           join DEPOSIT D on D.ID_PAYMENT_HEAD = P.ID_PAYMENT_HEAD
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  P.ID_PAYMENT_HEAD = :OBJECT_ID
           and A.ID_RESERV_DETAIL is not null;
  end else if (:OBJECT_CLASS = 'ACCOUNT') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select A.ID_RESERV_DETAIL, :new_id_system_log
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :OBJECT_ID
           and A.ID_RESERV_DETAIL is not null;
  end

  if (:EVENT_CODE = 'DELETE') then begin
    insert into SYSTEM_LOG_DELETED (LOG_OBJECT_CLASS, LOG_OBJECT_ID, DESCRIPTION, HOTEL_CODE)
    select :log_object_class, :log_object_id, SL.OBJECT_DESCRIPTION, SL.HOTEL_CODE
    from   SYSTEM_LOG_OBJECT_INFO_GET (:OBJECT_CLASS, :OBJECT_ID) SL;
  end

  if (:EXTRA_DATA is not null) then begin
    insert into SYSTEM_LOG_EXTRA (ID_SYSTEM_LOG, EXTRA_DATA)
    values (:new_id_system_log, :EXTRA_DATA);
  end

  if (exists(
    select *
    from   EAI_EVENTQ_PUBLISH P
    where  P.ACTION_CODE = :EVENT_CODE
  )) then post_event 'EAI_EVENTQ';

end
^

/* Create Views... */
SET TERM ; ^

COMMENT ON VIEW ENA_DOC_DEPOSIT_CONSUMPTION IS
' !!!!!!    ID_DOC_TYPE - za mapowe.';

COMMENT ON VIEW ENA_DOC_HEAD_ADVANCE IS
'!      ';


/* Alter Procedure... */
/* Alter (EAI_RES_CHECK_OUT_FAST) */
SET TERM ^ ;

ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
declare variable selection_id integer;
  declare variable is_early_check_out smallint;
  declare variable early_check_out_dep_date date;
  declare variable check_out_date date;
begin
  selection_id = gen_id(selection_gen, 1);

  update RESERV_DETAIL RD
  set RD.SELECTION_ID = :SELECTION_ID
  where RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL;

  execute procedure RES_CHECK_OUT_CHECK$RSV(:selection_id)
  returning_values :is_early_check_out, :early_check_out_dep_date, :check_out_date;

  if (:is_early_check_out = 1) then
    exception BOOKING_EXCEPTION '-1043';

  execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id, 0);
end
^

/* Alter (EAI_TELECOUNT_TRANSFER) */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* Alter (PHONECALL_POST$TC) */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Alter (PHONECALLS_POST_TO_ACCOUNT$TC) */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_TRANSFER$INT for: SYSTEM_EVENT_LOG$INT */
ALTER PROCEDURE DEPOSIT_TRANSFER$INT(ID_DEPOSIT /* TYPE OF ID */ INTEGER,
ID_DEST_ACCOUNT /* TYPE OF ID */ INTEGER,
SPLIT_AMOUNT /* TYPE OF TPRICE */ NUMERIC(15,4),
DEPOSIT_DESCRIPTION /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
TRANSFER_REASON /* TYPE OF TREASON */ VARCHAR(50) = null)
 RETURNS(NEW_ID_DEPOSIT /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ANUL$DOC for: SYSTEM_EVENT_LOG$INT */
ALTER PROCEDURE DOCUMENT_ANUL$DOC(ID_DOC_HEAD INTEGER,
ANUL_REASON VARCHAR(100),
MAKE_ANNUL_REPORT SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PAYMENT_ANUL$INT for: SYSTEM_EVENT_LOG$INT */
ALTER PROCEDURE PAYMENT_ANUL$INT(ID_PAYMENT_HEAD INTEGER,
ANUL_REASON VARCHAR(100))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_LOG$INT for: SYSTEM_EVENT_LOG$INT */
ALTER PROCEDURE RES_CREATE_LOG$INT(RD_DBKEY CHAR(8))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SYSTEM_LOG_ADD for: SYSTEM_EVENT_LOG$INT */
ALTER PROCEDURE SYSTEM_LOG_ADD(OBJECT_CLASS VARCHAR(30),
OBJECT_ID INTEGER,
ACTION_CODE VARCHAR(50),
ACTION_TEXT VARCHAR(255),
EXTRA_DATA VARCHAR(255) = null)
 AS
 BEGIN EXIT; END
^

/* Alter (SYSTEM_EVENT_LOG$INT) */
ALTER PROCEDURE SYSTEM_EVENT_LOG$INT(OBJECT_CLASS VARCHAR(30),
OBJECT_ID INTEGER,
EVENT_CODE VARCHAR(50),
EVENT_TEXT VARCHAR(255),
EXTRA_DATA VARCHAR(255) = null)
 RETURNS(NEW_ID_SYSTEM_LOG INTEGER)
 AS
declare variable machine_name varchar(30);
  declare variable log_object_class varchar(30);
  declare variable log_object_id integer;
  declare variable action_ctx varchar(50);
begin
  if (RDB$GET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE') = 'disable') then EXIT;

  action_ctx = RDB$GET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX');

  execute procedure SYSTEM_SESSION_GET('MACHINE_NAME')
  returning_values  :machine_name;

  object_id = coalesce(object_id,0);
  log_object_class = :object_class;
  log_object_id = :object_id;


  new_id_system_log = gen_id(gen_system_log_id, 1);

  insert into SYSTEM_LOG_EVENT (ID_SYSTEM_LOG, LOG_OBJECT_CLASS, LOG_OBJECT_ID, ACTION_CODE,
         ACTION_DATETIME, ACTION_USER, MACHINE_NAME, ACTION_TEXT, ACTION_CTX)
  values (:new_id_system_log, :log_object_class, :log_object_id, :event_code,
         current_timestamp, current_user, :machine_name, :event_text, :action_ctx);

  -- get related bookings
  if (:OBJECT_CLASS = 'RES_DETAIL') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    values (:OBJECT_ID, :new_id_system_log);
  end else if (:OBJECT_CLASS = 'GUEST') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select G.ID_RESERV_DETAIL, :new_id_system_log
    from   GUEST G
    where  G.ID_GUEST = :OBJECT_ID;
  end else if (:OBJECT_CLASS = 'DOCUMENT') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select A.ID_RESERV_DETAIL, :new_id_system_log
    from   DOC_HEAD D
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  D.ID_DOC = :OBJECT_ID
           and A.ID_RESERV_DETAIL is not null;
  end else if (:OBJECT_CLASS = 'DEPOSIT') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select A.ID_RESERV_DETAIL, :new_id_system_log
    from   DEPOSIT D
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  D.ID_DEPOSIT = :OBJECT_ID
           and A.ID_RESERV_DETAIL is not null;
  end else if (:OBJECT_CLASS = 'PAYMENT') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select distinct A.ID_RESERV_DETAIL, :new_id_system_log
    from   PAYMENT_HEAD P
           join DEPOSIT D on D.ID_PAYMENT_HEAD = P.ID_PAYMENT_HEAD
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  P.ID_PAYMENT_HEAD = :OBJECT_ID
           and A.ID_RESERV_DETAIL is not null;
  end else if (:OBJECT_CLASS = 'ACCOUNT') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select A.ID_RESERV_DETAIL, :new_id_system_log
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :OBJECT_ID
           and A.ID_RESERV_DETAIL is not null;
  end

  if (:EVENT_CODE = 'DELETE') then begin
    insert into SYSTEM_LOG_DELETED (LOG_OBJECT_CLASS, LOG_OBJECT_ID, DESCRIPTION, HOTEL_CODE)
    select :log_object_class, :log_object_id, SL.OBJECT_DESCRIPTION, SL.HOTEL_CODE
    from   SYSTEM_LOG_OBJECT_INFO_GET (:OBJECT_CLASS, :OBJECT_ID) SL;
  end

  if (:EXTRA_DATA is not null) then begin
    insert into SYSTEM_LOG_EXTRA (ID_SYSTEM_LOG, EXTRA_DATA)
    values (:new_id_system_log, :EXTRA_DATA);
  end

  if (exists(
    select *
    from   EAI_EVENTQ_PUBLISH P
    where  P.ACTION_CODE = :EVENT_CODE
  )) then post_event 'EAI_EVENTQ';

end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_MODIFY$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACCOUNT_MODIFY$INT(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL /* TYPE OF ID_REF */ INTEGER,
IS_PMS_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_MODIFY_TEMPLATE$PROFILE for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACCOUNT_MODIFY_TEMPLATE$PROFILE(ID_ACC_TEMPLATE INTEGER,
TEMPLATE_NAME VARCHAR(40),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,4),
SECURITY_LEVEL INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
ID_TAX_POLICY INTEGER,
IS_ARCHIVE INTEGER,
OPERATION VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(NEW_ID_ACC_TEMPLATE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_ANUL for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACCOUNT_POSTING_ANUL(IN_ID_ACCOUNT_POST INTEGER,
IN_ANUL_REASON VARCHAR(70))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_DOC_UPDATE$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACCOUNT_POSTING_DOC_UPDATE$INT(DH_DBKEY /* TYPE OF TDB_KEY */ CHAR(8))
 RETURNS(WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_MULTIANUL for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACCOUNT_POSTING_MULTIANUL(AP_LIST VARCHAR(4096),
ANUL_REASON VARCHAR(70))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_TRANSFER$ACC for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_SET_ARCHIVE_STATUS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACCOUNT_SET_ARCHIVE_STATUS(ID_ACCOUNT INTEGER,
IS_ARCHIVE SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_SET_CREDIT_STATUS$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACCOUNT_SET_CREDIT_STATUS$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
IS_CREDIT_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT,
CREDIT_LIMIT /* TYPE OF TPRICE */ NUMERIC(15,4),
SET_UNCONDITIONAL /* TYPE OF TLOGICAL */ SMALLINT = 0)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_SET_CURRENCY$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACCOUNT_SET_CURRENCY$INT(A_DBKEY CHAR(8),
NEW_CURR CHAR(3))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACTIVITY_OFFER_COPY for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACTIVITY_OFFER_COPY(ID_ACTIVITY_OFFER /* TYPE OF ID */ INTEGER)
 RETURNS(NEW_ID_ACTIVITY_OFFER /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: AR_OWING_ADD$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE AR_OWING_ADD$INT(ID_PROFILE /* TYPE OF ID */ INTEGER,
SUM_OWING /* TYPE OF TPRICE */ NUMERIC(15,4),
CURR_OWING /* TYPE OF TCURRENCY */ CHAR(3),
ID_DOC_HEAD /* TYPE OF ID_REF */ INTEGER,
DUE_DATE /* TYPE OF TDATE */ DATE,
SYSTEM_DATE /* TYPE OF TDATE */ DATE,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_AR_TYPE /* TYPE OF ID */ INTEGER,
ID_HOTEL /* TYPE OF ID */ INTEGER)
 RETURNS(NEW_ID_AR_OWING /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: AR_OWING_ANUL$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE AR_OWING_ANUL$INT(ID_AR_OWING /* TYPE OF ID */ INTEGER,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IS_MANUAL_ANUL /* TYPE OF TLOGICAL */ SMALLINT = 1)
 RETURNS(NEW_ID_AR_OWING /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: AR_OWING_PAYMENT_ADD$AR for: SYSTEM_LOG_ADD */
ALTER PROCEDURE AR_OWING_PAYMENT_ADD$AR(ID_AR_OWING INTEGER,
ID_AR_PAYMENT INTEGER,
SUM_OWING NUMERIC(15,4),
SUM_PAYMENT NUMERIC(15,4),
PAYMENT_RATE_TO_BGN NUMERIC(15,6),
OWING_RATE_TO_BGN NUMERIC(15,6),
DESCRIPTION VARCHAR(255))
 RETURNS(NEW_ID_AR_OWING_PAYMENT_POST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: AR_OWING_PAYMENT_ANUL$AR for: SYSTEM_LOG_ADD */
ALTER PROCEDURE AR_OWING_PAYMENT_ANUL$AR(ID_AR_OWING_PAYMENT_POST INTEGER,
DESCRIPTION VARCHAR(255))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: AR_PAYMENT_ADD$AR for: SYSTEM_LOG_ADD */
ALTER PROCEDURE AR_PAYMENT_ADD$AR(ID_PROFILE INTEGER,
ID_AR_PAYMENT_TYPE INTEGER,
ID_AR_PAYMENT_ACCOUNT INTEGER,
SUM_PAYMENT NUMERIC(15,4),
CURR_PAYMENT VARCHAR(3),
DESCRIPTION VARCHAR(255),
DATE_PAYMENT DATE,
ID_HOTEL INTEGER)
 RETURNS(NEW_ID_AR_PAYMENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: AR_PAYMENT_ANUL$AR for: SYSTEM_LOG_ADD */
ALTER PROCEDURE AR_PAYMENT_ANUL$AR(ID_AR_PAYMENT INTEGER,
DESCRIPTION VARCHAR(255))
 RETURNS(NEW_ID_AR_PAYMENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: BLOCK_ANNUL$BLK for: SYSTEM_LOG_ADD */
ALTER PROCEDURE BLOCK_ANNUL$BLK(ID_BLOCK_ROOM INTEGER,
OPERATION VARCHAR(30))
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: BLOCK_CREATE$BLK for: SYSTEM_LOG_ADD */
ALTER PROCEDURE BLOCK_CREATE$BLK(ROOM_NAMES VARCHAR(255),
ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
BLOCK_GRP INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
IS_FULL_FROM INTEGER,
IS_FULL_TO INTEGER)
 RETURNS(NEW_ID_BLOCK_ROOM INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: BLOCK_MODIFY$BLK for: SYSTEM_LOG_ADD */
ALTER PROCEDURE BLOCK_MODIFY$BLK(ID_BLOCK_ROOM INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
BLOCK_GRP INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
IS_FULL_FROM INTEGER,
IS_FULL_TO INTEGER)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: CONTRACT_CALENDAR_MODIFY$PMS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE CONTRACT_CALENDAR_MODIFY$PMS(ID_CONTRACT_CALENDAR_POST /* TYPE OF ID */ INTEGER,
ID_ROOM_CONTRACT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
IS_INCOME /* TYPE OF TLOGICAL */ SMALLINT,
SERVICE_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
ID_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
IS_ACC_POST_ITEM /* TYPE OF TLOGICAL */ SMALLINT,
POSTING_DATE_LIST /* TYPE OF TTEXT_EXTENDED */ VARCHAR(2000),
POSTING_PERIOD_DURATION /* TYPE OF TCOUNT */ INTEGER,
MONTH_NEXT_DATE /* TYPE OF TDATE */ DATE,
IS_FIXED_DATE /* TYPE OF TLOGICAL */ SMALLINT,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_CALENDAR_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: CONTRACT_EXPENSE_MODIFY$PMS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE CONTRACT_EXPENSE_MODIFY$PMS(ID_CONTRACT_EXPENSE /* TYPE OF ID */ INTEGER,
ID_CONTRACT /* TYPE OF ID */ INTEGER,
SUB_CONTRACT /* TYPE OF TSUB_CONTRACT */ VARCHAR(10),
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
SERVICE_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
CONTRACT_EXPENSE_TYPE VARCHAR(50),
MULTIPLIER_TYPE VARCHAR(50),
ORDER_TAG /* TYPE OF TCOUNT */ INTEGER,
IS_ACC_POST_ITEM /* TYPE OF TLOGICAL */ SMALLINT,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_EXPENSE /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: CONTRACT_MANAGEMENT_MODIFY$PMS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE CONTRACT_MANAGEMENT_MODIFY$PMS(ID_CONTRACT_MANAGEMENT /* TYPE OF ID */ INTEGER,
ID_CONTRACT /* TYPE OF ID */ INTEGER,
SUB_CONTRACT /* TYPE OF TSUB_CONTRACT */ VARCHAR(10),
ID_SERVICE /* TYPE OF ID */ INTEGER,
MIN_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
MIN_VALUE_CURR /* TYPE OF TCURRENCY */ CHAR(3),
MAX_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
MAX_VALUE_CURR /* TYPE OF TCURRENCY */ CHAR(3),
NIGHT_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
NIGHT_PRICE_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IS_NETO /* TYPE OF TLOGICAL */ SMALLINT,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_MANAGEMENT /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: CURR_RATE_MODIFY for: SYSTEM_LOG_ADD */
ALTER PROCEDURE CURR_RATE_MODIFY(CURR CHAR(3),
ID_HOTEL INTEGER,
RATE NUMERIC(15,6),
FOR_DATE DATE = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_ANUL$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE DEPOSIT_ANUL$INT(ID_DEPOSIT INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_PAYMENT_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_NEW$DOC for: SYSTEM_LOG_ADD */
ALTER PROCEDURE DEPOSIT_NEW$DOC(ID_ACCOUNT INTEGER,
ID_DOC_TYPE INTEGER,
PAY_VALUE NUMERIC(15,4),
PAY_CURRENCY VARCHAR(3),
DESCRIPTION VARCHAR(100),
ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_DEPOSIT INTEGER,
ID_PAYMENT_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_REFUND_PAY_ANNUL$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE DEPOSIT_REFUND_PAY_ANNUL$INT(ID_REFUND_PAYMENT INTEGER,
ANNUL_REASON VARCHAR(255) = '')
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_DELETE$DOC for: SYSTEM_LOG_ADD */
ALTER PROCEDURE DOCUMENT_DELETE$DOC(ID_DOC_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_PRENUMERATE$DOC for: SYSTEM_LOG_ADD */
ALTER PROCEDURE DOCUMENT_PRENUMERATE$DOC(SELECTION_ID INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_STORNO$DOC for: SYSTEM_LOG_ADD */
ALTER PROCEDURE DOCUMENT_STORNO$DOC(ID_DOC_HEAD INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_STORNO_DOC INTEGER,
ID_HOTEL INTEGER,
ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: EAI_AIRCONDITION_SMARTSTART for: SYSTEM_LOG_ADD */
ALTER PROCEDURE EAI_AIRCONDITION_SMARTSTART AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: EAI_EVENTQ_ADD for: SYSTEM_LOG_ADD */
ALTER PROCEDURE EAI_EVENTQ_ADD(EAI_IFC VARCHAR(50),
EVENT_CODE VARCHAR(50),
OBJECT_ID INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: END_WORK for: SYSTEM_LOG_ADD */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: GUEST_ADDRESSCARD_SET$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$RSV(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
EGN VARCHAR(30),
COUNTRY VARCHAR(10),
ID_STAY_REASON INTEGER,
IS_REGISTRED INTEGER,
PASS_PLACE VARCHAR(20),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_PLACE VARCHAR(30),
SEX CHAR,
MASK VARCHAR(10),
IS_CHILD INTEGER,
CAR VARCHAR(30),
KPP INTEGER,
KPP_DATE DATE,
PASS_EXP_DATE DATE,
AGE INTEGER,
BIRTH_DAY DATE,
VISA /* TDESCRIPTION_SHORT */ VARCHAR(100),
RATING_AGE INTEGER = null,
TITLE VARCHAR(10) = null,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: OCCUPANCY_SUMMARY_REMAKE$SYS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE OCCUPANCY_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PERSON_DATA_SET$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE PERSON_DATA_SET$INT(P_DBKEY CHAR(8),
PD_DBKEY CHAR(8),
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
COUNTRY VARCHAR(10),
BIRTH_DAY DATE,
BIRTHDAY_INTERNAL DATE,
TITLE VARCHAR(10) = NULL)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONE_LINE_CONVERT_MODIFY$CFG for: SYSTEM_LOG_ADD */
ALTER PROCEDURE PHONE_LINE_CONVERT_MODIFY$CFG(ID INTEGER,
LINE VARCHAR(30),
ROOM_NAME VARCHAR(30),
IS_TAXABLE SMALLINT,
IS_ARCHIVE SMALLINT,
PRICE_INDEX NUMERIC(15,4),
ID_HOTEL INTEGER,
ID_ACCOUNT INTEGER,
OPERATION VARCHAR(10))
 RETURNS(NEW_ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_ACCOUNT$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
QTY /* TYPE OF TQTY */ NUMERIC(15,2),
ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
DATE_POST /* TYPE OF TDATE */ DATE,
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ROOM /* TYPE OF ID */ INTEGER = null,
POST_DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_GUEST$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ACCOUNT_ROUTING /* TYPE OF TSHORT_CODE */ VARCHAR(10),
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_AGENT_MODIFY$PROFILE for: SYSTEM_LOG_ADD */
ALTER PROCEDURE PROFILE_AGENT_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
IS_ARCHIVE INTEGER,
AGENT_GROUP VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IATA_NUMBER VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null,
THRESHOLD_NOTE VARCHAR(255) = null,
THRESHOLD_AMOUNT NUMERIC(15,4) = null,
THRESHOLD_CURR CHAR(3) = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_COMMON_MODIFY$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE PROFILE_COMMON_MODIFY$INT(ID_PROFILE INTEGER,
PROFILE_TYPE VARCHAR(20),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
IS_ARCHIVE INTEGER,
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_DELETE$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE PROFILE_DELETE$INT(ID_PROFILE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_HOUSE_MODIFY$PROFILE for: SYSTEM_LOG_ADD */
ALTER PROCEDURE PROFILE_HOUSE_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(20),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
IS_ARCHIVE INTEGER,
HOUSE_TYPE VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_MERGE$PROFILE for: SYSTEM_LOG_ADD */
ALTER PROCEDURE PROFILE_MERGE$PROFILE(ID_SOURCE INTEGER,
ID_TARGET INTEGER,
OPERATION VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_PERSON_CREATEQ$PROFILE for: SYSTEM_LOG_ADD */
ALTER PROCEDURE PROFILE_PERSON_CREATEQ$PROFILE(PROFILE_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100),
PHONE /* TYPE OF TPHONE */ VARCHAR(50),
ID_PASSPORT_TYPE /* TYPE OF ID */ INTEGER,
PASS_NUM /* TYPE OF NAME_20 */ VARCHAR(20),
EGN /* TYPE OF TTEXT_SHORT */ VARCHAR(30),
COUNTRY_CODE /* TYPE OF TSHORT_CODE */ VARCHAR(10),
CARD_CODE /* TYPE OF TCARD_CODE */ VARCHAR(50),
ID_PERSON_DATA /* TYPE OF ID_REF */ INTEGER = null,
TITLE /* TYPE OF TSHORT_CODE */ VARCHAR(10) = null,
ID_HOTEL /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_PROFILE /* TYPE OF ID */ INTEGER,
P_DBKEY /* TYPE OF TDB_KEY */ CHAR(8),
PD_DBKEY /* TYPE OF TDB_KEY */ CHAR(8))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_ANUL_DETAIL$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_ANUL_DETAIL$INT(RD_DBKEY CHAR(8),
REASON VARCHAR(50),
CANCELATION_NUMBER /* TYPE OF NAME_20 */ VARCHAR(20) = null)
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_CHECK_OUT_GUESTS$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_CHECK_OUT_GUESTS$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND SMALLINT = 0)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_CHECKIN$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_DELETE$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_DELETE$INT(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_ADD$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_GUEST_ADD$RSV(ID_RESERV_DETAIL INTEGER,
IS_CHILD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_GUEST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_CHANGE$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_DEL$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_GUEST_DEL$INT(ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50) = null)
 RETURNS(EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_SAVE_BOARD$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_GUEST_SAVE_BOARD$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_BOARD INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_SAVE_OTHER$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_GUEST_SAVE_OTHER$RSV(ID_GUEST INTEGER,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_SAVE_RATE$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_GUEST_SAVE_RATE$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TARIFF INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_SAVE_ROOMTYPE$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_GUEST_SAVE_ROOMTYPE$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TAR_ROOM_TYPE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_SAVE_STAY$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_GUEST_SAVE_STAY$RSV(ID_GUEST INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_SAVE_TYPESTAY$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_GUEST_SAVE_TYPESTAY$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TYPE_STAY INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_RECALC$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_RECALC$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_RECALC$RSV(ID_RESERV_DETAIL INTEGER,
FORCE_POSTING SMALLINT = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTING$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTS_FINALIZE$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_ACCOUNTS_FINALIZE$INT(ID_RESERV_DETAIL INTEGER,
OLD_ID_BASE_ACCOUNT INTEGER,
OLD_ID_EXTRA_ACCOUNT INTEGER,
NEW_ID_BASE_ACCOUNT INTEGER,
NEW_ID_EXTRA_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_BOARD$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_BOARD$INT(RD_DBKEY CHAR(8),
ID_BOARD INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_GUARANTEE$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_GUARANTEE$RSV(ID_RESERV_DETAIL INTEGER,
IS_VIP SMALLINT,
CHECK_STATUS INTEGER,
ID_GUARANTEE_POLICY INTEGER,
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_MARKETING$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_MARKETING$RSV(ID_RESERV_DETAIL INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_PRICE$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_PRICE$RSV(ID_RESERV_DETAIL INTEGER,
FOR_DATE DATE,
PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_RATE$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_RATE$INT(RD_DBKEY CHAR(8),
ID_RATE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_RATE$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_RATE$RSV(ID_RESERV_DETAIL INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
IS_DIFFERENT_TARIFF INTEGER,
IS_DIFFERENT_PRICE INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ROOM_LOG$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_ROOM_LOG$INT(RD_DBKEY CHAR(8),
OLD_ID_ROOM INTEGER,
OLD_ID_RES_ROOM_TYPE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_STATUS$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_STATUS$INT(RD_DBKEY CHAR(8),
CHECK_STATUS INTEGER,
CONFIRMATION_NUMBER /* TYPE OF NAME_20 */ VARCHAR(20) = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_STAY$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_STAY$INT(RD_DBKEY CHAR(8),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_VOUCHER$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_VOUCHER$INT(RD_DBKEY CHAR(8),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_MULTI$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SET_ROOM_MULTI$RSV(OPERATION VARCHAR(20),
FROM_ROOM VARCHAR(20),
SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESERV_DETAIL_EXTERNAL_MOD$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RESERV_DETAIL_EXTERNAL_MOD$RSV(ID_RESERV_DETAIL INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
LOCATOR VARCHAR(100))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RESERVS_EXPIRE$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RESERVS_EXPIRE$INT(CLEAR_TODATE DATE,
ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RESGRP_SAVE_OTHER$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RESGRP_SAVE_OTHER$INT(RD_DBKEY CHAR(8),
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: REVENUE_SUMMARY_REMAKE$SYS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE REVENUE_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
STATISTIC_ONLY SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RIGHTS_GROUP_MODIFY for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RIGHTS_GROUP_MODIFY(ID_RIGHT_GROUP INTEGER,
GROUP_NAME VARCHAR(20),
GROUP_DESCRIPTION VARCHAR(100),
OPERATION VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
NEW_ID_RIGHT_GROUP INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RIGHTS_GROUP_REPORTS_MODIFY for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RIGHTS_GROUP_REPORTS_MODIFY(ID_RIGHT_GROUP INTEGER,
REPORT_NAME VARCHAR(200),
OPERATION VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RIGHTS_GROUP_RIGHTS_MODIFY for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RIGHTS_GROUP_RIGHTS_MODIFY(ID_RIGHT_GROUP INTEGER,
RIGHT_CODE VARCHAR(30),
VALUE_CODE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RIGHTS_GROUP_USER_MODIFY for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RIGHTS_GROUP_USER_MODIFY(USER_NAME VARCHAR(30),
ID_RIGHT_GROUP INTEGER,
OPERATION VARCHAR(50))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RIGHTS_MODIFY_USER for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RIGHTS_MODIFY_USER(IN_USER_NAME VARCHAR(30),
IN_USER_NAME_LONG VARCHAR(30),
IN_NEW_PASSWORD VARCHAR(8),
LANG_UI VARCHAR(10),
FISCAL_ID INTEGER,
IS_ACTIVE INTEGER,
OPERATION VARCHAR(20),
CODE VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_CONTRACT_MODIFY$PMS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ROOM_CONTRACT_MODIFY$PMS(ID_ROOM_CONTRACT INTEGER,
ID_ROOM_PERIOD INTEGER,
CONTRACT_TYPE VARCHAR(50),
PMS_MARKERS BLOB SUB_TYPE 1 SEGMENT SIZE 100,
IMPORT_INCOME_WITH_VAT SMALLINT,
ID_RENTAL_POOL INTEGER,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_CONTRACT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_MODIFY$PMS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ROOM_MODIFY$PMS(ID_ROOM INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
BEDS INTEGER,
EXTRA_BEDS INTEGER,
SECTOR INTEGER,
SORT_ORDER INTEGER,
FEATURES BLOB SUB_TYPE 1 SEGMENT SIZE 100,
EXTERNAL_NAME VARCHAR(10),
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER,
OPERATION VARCHAR(20))
 RETURNS(OVERRULE_NEED SMALLINT,
OVERRULE_CONTEXT VARCHAR(255),
NEW_ID_ROOM INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_OWNER_MODIFY$PMS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ROOM_OWNER_MODIFY$PMS(ID_ROOM_OWNER INTEGER,
ID_ROOM_CONTRACT INTEGER,
ID_OWNER INTEGER,
OWNERSHIP_PERCENT NUMERIC(15,4),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_OWNER INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_PERIOD_MODIFY$PMS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ROOM_PERIOD_MODIFY$PMS(ID_ROOM_PERIOD INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
STATUS VARCHAR(30),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_PERIOD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_ANNUL for: SYSTEM_LOG_ADD */
ALTER PROCEDURE SAFE_OCCUPANCY_ANNUL(ID_SAFE /* TYPE OF ID */ INTEGER,
REASON /* TYPE OF TREASON */ VARCHAR(50))
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SALE_TAX_MODIFY$CFG for: SYSTEM_LOG_ADD */
ALTER PROCEDURE SALE_TAX_MODIFY$CFG(ID_SALE_TAX INTEGER,
TAX_NAME VARCHAR(50),
TAX_PERCENT NUMERIC(15,4),
TAXABLE_BASE_PERCENT NUMERIC(15,4),
TAX_VALUE NUMERIC(15,4),
REVENUE_DEDUCTION_TAX SMALLINT,
REPORT_IN_DOCUMENT SMALLINT,
FISCAL_CODE VARCHAR(30),
ACCOUNT_NAME VARCHAR(50),
OPERATION VARCHAR(10),
ID_HOTEL /* TYPE OF ID */ INTEGER)
 RETURNS(NEW_ID_SALE_TAX INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SALE_TAXATION_MODIFY$CFG for: SYSTEM_LOG_ADD */
ALTER PROCEDURE SALE_TAXATION_MODIFY$CFG(ID_SALE_TAXATION /* TYPE OF ID */ INTEGER,
NAME /* TYPE OF TOBJECT_NAME */ VARCHAR(50),
TAXES VARCHAR(250),
ACCOUNT_NAME /* TYPE OF TOBJECT_NAME */ VARCHAR(50),
OPERATION VARCHAR(10),
ID_HOTEL /* TYPE OF ID */ INTEGER)
 RETURNS(NEW_ID_SALE_TAXATION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SERVICE_TAXATION_MODIFY$CFG for: SYSTEM_LOG_ADD */
ALTER PROCEDURE SERVICE_TAXATION_MODIFY$CFG(ID_TAX_POLICY /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_SALE_TAXATION /* TYPE OF ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SETTINGS_MODIFY_VALUE for: SYSTEM_LOG_ADD */
ALTER PROCEDURE SETTINGS_MODIFY_VALUE(SETTING_CODE /* TYPE OF TSEARCH_CODE */ VARCHAR(30),
SETTING_VALUE /* TYPE OF TOBJECT_TEXT */ VARCHAR(50),
ID_HOTEL /* TYPE OF ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SYSTEM_LOGON_USER for: SYSTEM_LOG_ADD */
ALTER PROCEDURE SYSTEM_LOGON_USER(OPERATION VARCHAR(20),
MACHINE_NAME VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE for: SYSTEM_LOG_ADD */
ALTER PROCEDURE TAR_SAVE(ID_TAR_HEAD INTEGER,
PERIOD_DEPEND_ON_CHECKIN INTEGER,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BASE_BOARDS_LIST VARCHAR(255),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
BO_TYPE VARCHAR(20),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TASK_MODIFY for: SYSTEM_LOG_ADD */
ALTER PROCEDURE TASK_MODIFY(ID_TASK INTEGER,
DESCRIPTION VARCHAR(255),
DT_ACTIVATE TIMESTAMP,
STATUS SMALLINT,
TYPE_ SMALLINT,
PRIORITY SMALLINT,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_TASK INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAX_POLICY_MODIFY$CFG for: SYSTEM_LOG_ADD */
ALTER PROCEDURE TAX_POLICY_MODIFY$CFG(ID_TAX_POLICY /* TYPE OF ID */ INTEGER,
POLICY_NAME /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
IS_ARCHIVE /* TYPE OF TLOGICAL */ SMALLINT,
TAXATION_REASON /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
OPERATION VARCHAR(10),
ID_HOTEL /* TYPE OF ID */ INTEGER)
 RETURNS(NEW_ID_TAX_POLICY INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SYSTEM_LOG_ADD) */
ALTER PROCEDURE SYSTEM_LOG_ADD(OBJECT_CLASS VARCHAR(30),
OBJECT_ID INTEGER,
ACTION_CODE VARCHAR(50),
ACTION_TEXT VARCHAR(255),
EXTRA_DATA VARCHAR(255) = null)
 AS
declare variable new_id_system_log integer;
begin
  -- Description: fasade without output parameter (id)
  execute procedure SYSTEM_EVENT_LOG$INT(:OBJECT_CLASS, :OBJECT_ID, :ACTION_CODE, :ACTION_TEXT, :EXTRA_DATA)
  returning_values  :new_id_system_log;

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_LOG_ID', :new_id_system_log);
end
^

/* Alter (SYSTEM_LOGON_USER) */
ALTER PROCEDURE SYSTEM_LOGON_USER(OPERATION VARCHAR(20),
MACHINE_NAME VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable dbg varchar(2000);
  declare variable fmt_current_timestamp varchar(30);
  declare variable id_log_logon varchar(20);
begin
  err_code = 0;
  err_text = '';
  fmt_current_timestamp = substring(FormatDate(current_timestamp, 'D;dd.mm.yyyy hh:mm:ss') from 1 for 30);
  if (:operation = 'log_on') then begin
    id_log_logon = gen_id(gen_system_log_id, 1);
    execute procedure SYSTEM_LOG_ADD ('SYSTEM', 0, 'APP_LOG_ON', '');

    /*insert into SYSTEM_LOG (ID_SYSTEM_LOG, LOG_OBJECT_CLASS, LOG_OBJECT_ID, ACTION_CODE,
           ACTION_DATETIME, ACTION_USER, MACHINE_NAME, ACTION_TEXT)
    values (:id_log_logon, 'SYSTEM', current_connection, 'APP_LOG_ON',
           current_timestamp, current_user, :machine_name, '');*/
    execute procedure SYSTEM_SESSION_SET('LOGON_ID', id_log_logon)
    returning_values  :err_code, :err_text;

  end else if (:operation = 'log_off') then begin
    execute procedure SYSTEM_LOG_ADD ('SYSTEM', 0, 'APP_LOG_OFF', '');

    execute procedure SYSTEM_SESSION_GET('LOGON_ID')
    returning_values  :id_log_logon;

/*    if ((:id_log_logon is not null) and (:id_log_logon <> '')) then begin
      update SYSTEM_LOG SL
      set    SL.NEW_VALUE = :fmt_current_timestamp
      where  SL.ID_SYSTEM_LOG = :id_log_logon;
    end*/
  end
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_RATE_RECORD_RELINK$EXC for: TAR_SAVE */
ALTER PROCEDURE IMPORT_RATE_RECORD_RELINK$EXC(ID_RATE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_SAVE) */
ALTER PROCEDURE TAR_SAVE(ID_TAR_HEAD INTEGER,
PERIOD_DEPEND_ON_CHECKIN INTEGER,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BASE_BOARDS_LIST VARCHAR(255),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
BO_TYPE VARCHAR(20),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable delim integer;
  declare variable id_hotel integer;
  declare variable action_text varchar(255);
begin
  if (:base_boards_list is null) then base_boards_list = '';
  if (:board_type not in ('BOARD', 'HRANI')) then begin
    if (:board_type = '0') then board_type = 'BOARD';
    else board_type = 'HRANI';
  end
  err_code = 0;
  err_text = '';
  execute procedure SETTING_GET_VALUE('RANGE_DATA_DELIMETER', null)
  returning_values  :delim;

  -- TAR_BO_PRICES are never cleared
  delete from TAR_BO_SEASON
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_BASE_POSITION
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_BOARD
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_EXTRA_GUEST
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_DISCOUNT
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_PACK
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_PARAMS
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_DISCOUNT_STAY
  where  ID_TAR_HEAD = :id_tar_head;
  update TAR_HEAD TH
  set    PERIOD_DEPEND_ON_CHECKIN = :period_depend_on_checkin,
         CNT_DAYS_PRICE_BP        = :cnt_days_price_bp,
         CNT_DAYS_PRICE_BOARD     = :cnt_days_price_board,
         BASE_BOARDS_LIST         = f_character(:delim)||:base_boards_list||f_character(:delim),
         BOARD_TYPE               = :board_type,
         LOCK_STAMP               = current_timestamp
  where  TH.ID_TAR_HEAD = :id_tar_head;
  update TARIFA T
  set    T.IS_BASE = 1
  where  T.ID_TARIFA = :id_tar_head;
  bo_type = 'SEASON';
  execute procedure TAR_SAVE_BO_SEASON(:id_tar_head)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'BASE';
  execute procedure TAR_SAVE_BO_BP(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'BOARD';
  execute procedure TAR_SAVE_BO_BOARD(:id_tar_head, :bo_type, :board_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'EXTRA_GUEST';
  execute procedure TAR_SAVE_BO_EG(:id_tar_head, :bo_type, :board_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'PACK';
  execute procedure TAR_SAVE_BO_PACK(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'DISCOUNT';
  execute procedure TAR_SAVE_BO_DISC(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'DISCOUNT_PERIOD';
  execute procedure TAR_SAVE_BO_DISC_PERIOD(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end

  select f_character(29) || T.TARIFA_NAME, T.id_hotel
  from   TARIFA T
  where  T.ID_TARIFA = :ID_TAR_HEAD
  into   :action_text, :id_hotel;

  execute procedure EXPORT_LOG_INSERT$EXC ('RATE_BASE', :id_tar_head, :id_hotel, 0);

  execute procedure SYSTEM_LOG_ADD ('RATE', :ID_TAR_HEAD, 'RATE_CHANGED', :action_text);

  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||'NONE'||', '||:err_text;
--    suspend;
    exception;
  end
end
^

/* Alter (TASK_MODIFY) */
ALTER PROCEDURE TASK_MODIFY(ID_TASK INTEGER,
DESCRIPTION VARCHAR(255),
DT_ACTIVATE TIMESTAMP,
STATUS SMALLINT,
TYPE_ SMALLINT,
PRIORITY SMALLINT,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_TASK INTEGER)
 AS
declare variable oldStatus smallint;
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del, undel, complete, snooze');

  if ((:id_task is null) or (:id_task <= 0)) then
    new_id_task = gen_id(GEN_TASK_ID, 1);
  else new_id_task = :id_task;
                              
  if (:operation = 'add') then begin
    insert into TASK (ID_TASK, DESCRIPTION, DT_ACTIVATE, DT_CREATE, USER_CREATE, STATUS, PRIORITY, IS_DELETED, TYPE_)
    values (:new_id_task, :description, :dt_activate, current_timestamp, current_user, :status, :priority, 0, :type_);
  end else if (:operation = 'mod') then begin
    select STATUS
    from  TASK
    where  ID_TASK = :id_task
    into :oldStatus;

    update TASK
    set    DESCRIPTION = :description,
           DT_ACTIVATE = :dt_activate,
           STATUS = :status,
           PRIORITY = :priority,
           TYPE_ = :type_
    where  ID_TASK = :id_task;

    if (:oldStatus <> :status) then
      if (status = 1) then begin
        execute procedure TASK_MODIFY (:id_task, :description, :dt_activate, :status, :type_, priority, 'complete')
        returning_values :new_id_task;
      end
  end else if (:operation = 'del') then begin
    update TASK
    set    IS_DELETED = 1,
           USER_DELETED = current_user,
           DT_DELETED = current_timestamp
    where  ID_TASK = :id_task;
  end else if (:operation = 'undel') then begin
    update TASK
    set    IS_DELETED = 0
    where  ID_TASK = :id_task;
  end else if (:operation = 'complete') then begin
    update TASK
    set    STATUS = 1,
           USER_COMPLETED = current_user,
           DT_COMPLETED = current_timestamp
    where  ID_TASK = :id_task;
  end else if (:operation = 'snooze') then begin
    update TASK
    set    STATUS = 0,
           DT_ACTIVATE = ADDMINUTE(current_timestamp,extract(minute from :dt_activate)+extract(hour from :dt_activate)*60)
    where  ID_TASK = :id_task;
  end
  post_event 'invalidate.task';
  post_event 'invalidate.task_lm';

  execute procedure SYSTEM_LOG_ADD('SYSTEM', :new_id_task, 'TASK_CHANGED', '');
end
^

/* Alter (TAX_POLICY_MODIFY$CFG) */
ALTER PROCEDURE TAX_POLICY_MODIFY$CFG(ID_TAX_POLICY TYPE OF ID,
POLICY_NAME TYPE OF TDESCRIPTION_SHORT,
IS_ARCHIVE TYPE OF TLOGICAL,
TAXATION_REASON TYPE OF TDESCRIPTION_LONG,
OPERATION VARCHAR(10),
ID_HOTEL TYPE OF ID)
 RETURNS(NEW_ID_TAX_POLICY INTEGER)
 AS
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation = 'add') then begin
    insert into TAX_POLICY (ID_TAX_POLICY, POLICY_NAME, IS_ARCHIVE, TAXATION_REASON, ID_HOTEL)
    values (nullif(:ID_TAX_POLICY, -1), :POLICY_NAME, :IS_ARCHIVE, :TAXATION_REASON, :ID_HOTEL)
    returning ID_TAX_POLICY
    into      :NEW_ID_TAX_POLICY;

  end else if (:operation = 'mod') then begin
    update TAX_POLICY TP
    set    TP.POLICY_NAME = :POLICY_NAME,
           TP.IS_ARCHIVE = :is_archive,
           TP.TAXATION_REASON = :TAXATION_REASON
    where  TP.ID_TAX_POLICY = :ID_TAX_POLICY;

    NEW_ID_TAX_POLICY = :ID_TAX_POLICY;
  end else if (:operation = 'del') then begin
    execute procedure SYSTEM_LOG_ADD ('TAX_POLICY', :ID_TAX_POLICY, 'DELETE', '');
    delete from TAX_POLICY TP
    where  TP.ID_TAX_POLICY = :ID_TAX_POLICY;

    NEW_ID_TAX_POLICY = null;
  end

  execute procedure SYSTEM_CACHE_APPLY('TAX_POLICY');
end
^

/* Restore proc. body: ACCOUNT_MODIFY$INT */
ALTER PROCEDURE ACCOUNT_MODIFY$INT(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL TYPE OF ID_REF,
IS_PMS_ACCOUNT TYPE OF TLOGICAL,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
declare variable a_dbkey char(8);
  declare variable old_sec_level integer;
  declare variable action_text varchar(255);
  declare variable old_acc_name varchar(50);
  declare variable old_acc_curr varchar(3);
  declare variable old_tax_policy integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, archive');

  new_id_account = :id_account;
  if (:operation = 'add') then begin
    if ((:new_id_account is null) or (:new_id_account <= 0)) then new_id_account = gen_id(ID_ACCOUNT_GEN, 1);

    insert into ACCOUNT(ID_ACCOUNT, ACCOUNT_CURR, ACCOUNT_NAME, IS_CREDIT_ACCOUNT, CREDIT_LIMIT,
           ID_TYPE_PAYMENT, NOTE, IS_BLOCKED, BLOCK_TEXT, SECURITY_LEVEL, IS_BASE, IS_EXTRA,
           IS_ALOWED_POS_INTERFACE, POS_INTERFACE_NOTE, EXT_CODE, ID_TAX_POLICY, ID_PROFILE,
           ID_HOTEL, IS_DEFAULT, IS_PMS_ACCOUNT, ID_RESERV_DETAIL)
    values (:new_id_account, :account_curr, :account_name, 0, null,
           :id_type_payment, :note, :is_blocked, :block_text, :security_level, :is_base, :is_extra,
           :is_alowed_pos_interface, :pos_interface_note, :ext_code, :id_tax_policy, :id_profile,
           :id_hotel, :is_default, coalesce(:IS_PMS_ACCOUNT, 0), :ID_RESERV_DETAIL)
    returning RDB$DB_KEY
    into   :a_dbkey;

    action_text = f_character(29) || :new_id_account || '/' || :account_name;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'ADD_ACCOUNT', :action_text);

    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:NEW_ID_ACCOUNT, :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT);
    -- check special right and log event

  end else begin
    ID_RESERV_DETAIL = null;
    select A.RDB$DB_KEY, A.ID_RESERV_DETAIL, A.SECURITY_LEVEL,
           A.ACCOUNT_NAME, A.ACCOUNT_CURR, A.ID_TAX_POLICY
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :a_dbkey, :id_reserv_detail, :old_sec_level,
           :old_acc_name, :old_acc_curr, :old_tax_policy;
    if (:operation = 'mod') then begin
  
      update ACCOUNT A
      set    A.ACCOUNT_NAME = :account_name,
             A.ID_TYPE_PAYMENT = :id_type_payment,
             A.NOTE = :note,
             A.IS_BLOCKED = :is_blocked,
             A.BLOCK_TEXT = :block_text,
             A.SECURITY_LEVEL = :security_level,
             A.IS_BASE = :is_base,
             A.IS_EXTRA = :is_extra,
             A.IS_ALOWED_POS_INTERFACE = :is_alowed_pos_interface,
             A.POS_INTERFACE_NOTE = :pos_interface_note,
             A.EXT_CODE = :ext_code,
             A.ID_TAX_POLICY = :id_tax_policy,
             A.IS_DEFAULT = :is_default
      where  A.RDB$DB_KEY = :a_dbkey;
  
      execute procedure ACCOUNT_SET_CURRENCY$INT (:a_dbkey, :account_curr);
  
      if (:old_acc_name <> :account_name) then begin
        action_text = f_character(29 ) || :ID_ACCOUNT || '/' || :old_acc_name || ', ' || :old_acc_curr
                      || f_character(28) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME || ', ' || :ACCOUNT_CURR;
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'EDIT_ACCOUNT', :action_text);
      end
  
      if (:old_sec_level <> :SECURITY_LEVEL) then begin
        action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME
                      || f_character(28) || :SECURITY_LEVEL;
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'SET_ACC_SEC_LEVEL', :action_text);
      end
  
      if (:old_tax_policy <> :id_tax_policy) then begin
        execute procedure ACCOUNT_TAXATION_RECALC$INT (:ID_ACCOUNT, :ID_TAX_POLICY);
  
        action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME;                        
  
        select :action_text || f_character(28) || OTP.POLICY_NAME
        from   TAX_POLICY OTP
        where  OTP.ID_TAX_POLICY = :old_tax_policy
        into   :action_text;
        select :action_text || f_character(28) || NTP.POLICY_NAME
        from   TAX_POLICY NTP
        where  NTP.ID_TAX_POLICY = :ID_TAX_POLICY
        into   :action_text;
         
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'VAT_POLICY_CHNG', :action_text);
      end
  
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:ID_ACCOUNT, :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT); -- check special right and log event
  
    end else if (:operation = 'archive') then begin
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 1);

    end
  end

  if ((:id_reserv_detail is null) and (:IS_CREDIT_ACCOUNT = 0)) then begin
    exception ACCOUNT_EXCEPTION '-1010';
    -- The account must have active credit status
    exit;
  end

  if (:is_default = 1) then begin
    update ACCOUNT A
    set    A.IS_DEFAULT = 0
    where  A.ID_HOTEL = :id_hotel
           and A.ID_PROFILE = :id_profile
           and A.ID_ACCOUNT <> :new_id_account;
  end
end
^

/* Restore proc. body: ACCOUNT_MODIFY_TEMPLATE$PROFILE */
ALTER PROCEDURE ACCOUNT_MODIFY_TEMPLATE$PROFILE(ID_ACC_TEMPLATE INTEGER,
TEMPLATE_NAME VARCHAR(40),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,4),
SECURITY_LEVEL INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
ID_TAX_POLICY INTEGER,
IS_ARCHIVE INTEGER,
OPERATION VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(NEW_ID_ACC_TEMPLATE INTEGER)
 AS
declare variable action_text varchar(255);
declare variable tax_policy_name varchar(100);
declare variable old_template_name varchar(50);
declare variable old_security_level integer;
declare variable old_is_credit_account smallint;
declare variable old_credit_limit numeric(15,4);
declare variable old_is_alowed_pos_interface smallint;
declare variable old_id_tax_policy integer;
declare variable old_is_archive integer;
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  new_id_acc_template = :id_acc_template;
  if (:operation = 'add') then begin
    if ((:new_id_acc_template is null) or (:new_id_acc_template <= 0)) then new_id_acc_template = gen_id(ID_ACCOUNT_GEN, 1);

    insert into ACC_TEMPLATE (ID_ACC_TEMPLATE, TEMPLATE_NAME, SECURITY_LEVEL, IS_CREDIT_ACCOUNT, CREDIT_LIMIT,
           IS_ALOWED_POS_INTERFACE, ID_TAX_POLICY, IS_ARCHIVE, ID_HOTEL)
    values (:new_id_acc_template, :template_name, :security_level, :is_credit_account, :credit_limit,
           :is_alowed_pos_interface, :id_tax_policy, 0, :ID_HOTEL);

    action_text = f_character(29) || :template_name;
    execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACCOUNT_TEMPLATE_CREATE', :action_text);

  end else if (:operation = 'mod') then begin
    select act.template_name,
           act.security_level,
           act.is_credit_account,
           act.credit_limit,
           act.is_alowed_pos_interface,
           act.id_tax_policy,
           act.is_archive
    from   ACC_TEMPLATE act
    where  act.id_acc_template = :id_acc_template
    into   :old_template_name, :old_security_level, :old_is_credit_account, :old_credit_limit, :old_is_alowed_pos_interface,
           :old_id_tax_policy, :old_is_archive;
    if (:template_name <> :old_template_name) then begin
      action_text = f_character(29) || :old_template_name || f_character(28) || :template_name;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_NAME_CHANGED', :action_text);
    end
    if (:security_level <> :old_security_level) then begin
      action_text = f_character(29) || :old_security_level || f_character(28) || :security_level;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_SEC_LEVEL_CHANGED', :action_text);
    end
    if (:is_credit_account <> :old_is_credit_account) then begin
      action_text = f_character(29) || :old_is_credit_account || f_character(28) || :is_credit_account;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_CR_ACC_CHANGED', :action_text);
    end
    if (coalesce(:credit_limit, 0) <> coalesce(:old_credit_limit, 0)) then begin
      action_text = f_character(29) || formatfloat(:old_credit_limit, '0.00') || f_character(28) || formatfloat(:credit_limit, '0.00');
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_CR_LIM_CHANGED', :action_text);
    end
    if (:is_alowed_pos_interface <> :old_is_alowed_pos_interface) then begin
      action_text = f_character(29) || :old_is_alowed_pos_interface || f_character(28) || :is_alowed_pos_interface;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_POS_CHANGED', :action_text);
    end
    if (:id_tax_policy <> :old_id_tax_policy) then begin
      select f_character(29) || policy_name
      from tax_policy
      where id_tax_policy = :old_id_tax_policy
      into :action_text;
      select f_character(28) || policy_name
      from tax_policy
      where id_tax_policy = :id_tax_policy
      into :tax_policy_name;
      action_text = :action_text || :tax_policy_name;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_TAX_POL_CHANGED', :action_text);
    end
    if (:is_archive <> :old_is_archive) then begin
      action_text = f_character(29) || :old_is_archive|| f_character(28) || :is_archive;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_IS_ARCH_CHANGED', :action_text);
    end
    update ACC_TEMPLATE
    set    TEMPLATE_NAME = :template_name,
           SECURITY_LEVEL = :security_level,
           IS_CREDIT_ACCOUNT = :is_credit_account,
           CREDIT_LIMIT = :credit_limit,
           IS_ALOWED_POS_INTERFACE = :is_alowed_pos_interface,
           ID_TAX_POLICY = :id_tax_policy,
           IS_ARCHIVE = :is_archive
    where  ID_ACC_TEMPLATE = :id_acc_template;
  end else if (:operation = 'del') then begin
    select template_name
    from   ACC_TEMPLATE
    where  ID_ACC_TEMPLATE = :id_acc_template
    into   :old_template_name;

    execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'DELETE', '');

    delete from ACC_TEMPLATE
    where  ID_ACC_TEMPLATE = :id_acc_template;

  --  action_text = f_character(29) || :old_template_name;
  --  execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_DELETED', :action_text);
  end

end
^

/* Restore proc. body: ACCOUNT_POSTING_ANUL */
ALTER PROCEDURE ACCOUNT_POSTING_ANUL(IN_ID_ACCOUNT_POST INTEGER,
IN_ANUL_REASON VARCHAR(70))
 AS
declare variable action_text varchar(255);
  declare variable id_account integer;
  declare variable qty_post numeric(15,2);
  declare variable price_post double precision;
  declare variable date_post date;
  declare variable id_service integer;
  declare variable curr_post varchar(3);
  declare variable ap_dbkey char(8);
begin
  /* called only from GUI - manual anullment */
  select AP.RDB$DB_KEY, AP.ID_ACCOUNT, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST
  from   ACCOUNT_POST AP
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :ap_dbkey, :id_account, :qty_post, :price_post,
         :date_post, :id_service, :curr_post;

  execute procedure ACCOUNT_POSTING_ANUL$INT (:ap_dbkey, :IN_ANUL_REASON);

  select S.SERVICE_NAME
  from   SERVICES S
  where  S.ID_SERVICE = :id_service
  into   :action_text;

  action_text = f_character(29) || :action_text
                || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:qty_post * :price_post, 'F;0.00') || ' ' || :curr_post
                || f_character(28) || f_replstr(:IN_ANUL_REASON, 'MANUAL', '');
  execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_ANUL', :action_text);
end
^

/* Restore proc. body: ACCOUNT_POSTING_DOC_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_DOC_UPDATE$INT(DH_DBKEY TYPE OF TDB_KEY)
 RETURNS(WARN_CODE TYPE OF TRANGE)
 AS
declare variable date_post date;
  declare variable old_date_post date;
  declare variable curr_post varchar(3);
  declare variable old_curr_post varchar(3);
  declare variable rate_post numeric(15,6);
  declare variable curr_orig varchar(3);
  declare variable old_curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable dbkey char(8);
  declare variable id_account_post integer;
  declare variable doc_date date;
  declare variable doc_release_ap integer;
  declare variable qty_post numeric(15,2);
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable price_orig numeric(15,4);
  declare variable price_post double precision;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable id_sale_taxation integer;
  declare variable id_base_doc integer;
  declare variable doc_operation varchar(10);
  declare variable is_anul_doc integer;
  declare variable is_storno integer;
  declare variable id_doc_head integer;
  declare variable posts_value double precision;
  declare variable line_value double precision ;
  declare variable action_text varchar(255);
  declare variable action_code varchar(30);
  declare variable account_curr varchar(3);
  declare variable id_ap_base_doc integer;
  declare variable new_is_anul integer;
  declare variable new_is_closed integer;
  declare variable doc_qty numeric(15,2);
  declare variable doc_price double precision;
  declare variable id_hotel integer;
  declare variable round_to numeric(15,4);
  declare variable proforma_dt_created timestamp;
  declare variable new_ac varchar(2);
begin

  select D.ID_DOC_HEAD, iif(D.IS_ANUL = 0, D.DOC_DATE, DA.ANNULMENT_DATE),
         D.ID_BASE_DOC, D.IS_ANUL, D.IS_STORNO,
         A.ID_ACCOUNT, A.ACCOUNT_CURR, a.id_hotel, pd.DATETIME_CREATED
  from   DOC_HEAD$INT D
         join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         left outer join DOC_ANNULMENT DA on DA.ID_DOC_HEAD = D.ID_DOC_HEAD
         left outer join DOC_HEAD$INT pd on pd.ID_DOC_HEAD = dc.ID_DOC_PROFORMA
  where  D.RDB$DB_KEY = :DH_DBKEY
  into   :id_doc_head, :doc_date, :id_base_doc, :is_anul_doc, :is_storno,
         :id_account, :account_curr, :id_hotel, :proforma_dt_created;

  if (:id_doc_head is null) then exit;

  doc_operation = case when :is_anul_doc = 1 then 'anul'
                       when :is_storno   = 1 then 'storno'
                       else 'new'
                  end;

  doc_release_ap = -gen_id(DOC_SELECTED_GEN, 1);
  /*   */
  posts_value = 0;
  if (:doc_operation = 'new') then begin
    for
      select AP.RDB$DB_KEY, AP.ID_ACCOUNT_POST, DL.QTY_POST, PV.ACCOUNT_PRICE,
             ap.QTY_POST, ap.PRICE_POST, c.ROUND_TO
      from   ACCOUNT_POST AP
             join DOC_LINE_POST_VALUES PV on PV.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
             join DOC_LINE DL on DL.ID_DOC_LINE = PV.ID_DOC_LINE
             join CURRS C on c.CURR = ap.CURR_POST
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
      into   :dbkey, :id_account_post, :doc_qty, :doc_price,
             :qty_post, :price_post, :round_to
    do begin
      /*  if (:is_anul = 1) - annul corrective document, else - new valid document */
      /* annulment/storno of base document is in other case - operation "anul"  */
      if (:proforma_dt_created is not null) then begin
        new_is_anul = 0;
        new_is_closed = iif(cast(round_f(:qty_post - :doc_qty, :round_to) as numeric(15,2)) = 0
                            and cast(round_f(:price_post - :doc_price, :round_to) as numeric(15,2)) = 0,
                            1,
                            0);
      end else begin
        new_is_anul = 0;
        new_is_closed = 1;
        doc_qty = :qty_post;
        doc_price = :price_post;
      end

      update ACCOUNT_POST AP
      set    AP.ID_BASE_DOC   = :id_base_doc,
             AP.IN_DOC_QTY    = :doc_qty,
             AP.IN_DOC_VALUE  = :doc_price,
             AP.IS_ANUL       = :new_is_anul,
             AP.AC            = :new_is_anul || :new_is_closed,
             AP.DOC_SELECTED  = :doc_release_ap,
             AP.DATETIME_CHANGED = current_timestamp
      where  AP.RDB$DB_KEY = :DBKEY
      returning ap.ac into :new_ac;
      if (:new_ac = '00') then begin
        execute procedure SYSTEM_WARNING_ADD (-1061, '')
        returning_values (:warn_code);
      end

      update ACCOUNT_POST_CORRECTION APCU
      set    APCU.ID_DOC_HEAD  = iif(apcu.DATETIME_CREATED < coalesce(:proforma_dt_created, current_timestamp), :ID_DOC_HEAD, -1),
             APCU.IS_OPEN      = iif(apcu.DATETIME_CREATED < coalesce(:proforma_dt_created, current_timestamp), 0, 1)
      where  APCU.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
             and coalesce(APCU.ID_DOC_HEAD, -1) = -1;

      posts_value = :posts_value + :doc_price * :doc_qty;
    end

    action_text = f_character(29) || formatfloat(abs(:posts_value), 'F;0.00') || ' ' || :account_curr;
    action_code = 'CLOSE_POSTINGS';
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, :action_code, :action_text);

  end else if (:doc_operation in ('anul', 'storno')) then begin
    /* annulment/storno of base document - release all postings */
    /*   */
    old_date_post = '01.01.1900';
    old_curr_post = '';
    old_curr_orig = '';
    posts_value = 0;
    /*   */
    for
      select distinct AP.RDB$DB_KEY, AP.ID_ACCOUNT, AP.ID_GUEST, AP.ID_SALE_TAXATION, AP.ID_BASE_DOC,
             AP.QTY_POST, AP.PRICE_POST, AP.DATE_POST, AP.CURR_POST, AP.CURR_ORIG, AP.PRICE_ORIG,
             AP.ID_ACCOUNT_POST, AP.POST_NET_VALUE, AP.POST_GROSS_VALUE, AP.RATE_POST, AP.RATE_ORIG,
             PV.ACCOUNT_PRICE * DL.QTY_POST, c.ROUND_TO
      from   ACCOUNT_POST AP
             join DOC_LINE_POST_VALUES PV on PV.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
             join DOC_LINE DL on DL.ID_DOC_LINE = PV.ID_DOC_LINE
             join CURRS C on c.CURR = ap.CURR_POST
             --left outer join SERVICE_TAXATION TP on TP.ID_SERVICE = AP.ID_SERVICE and TP.ID_TAX_POLICY = :id_tax_policy
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
      order by AP.DATE_POST, AP.CURR_POST, AP.CURR_ORIG
      into   :dbkey, :id_account, :id_guest, :id_sale_taxation, :id_ap_base_doc,
             :qty_post, :price_post, :date_post, :curr_post, :curr_orig, :price_orig,
             :id_account_post, :post_net_value, :post_gross_value, :rate_post, :rate_orig,
             :line_value, :round_to
    do begin
      if (:id_ap_base_doc is not null and :id_ap_base_doc is distinct from :id_base_doc) then
        exception DOCUMENT_EXCEPTION '-365';

      doc_qty = null;
      doc_price = 0;
      if (:DOC_OPERATION = 'anul') then begin
        select sum(DL.QTY_POST * (1 - DL.IS_CORRECT)) as DOC_QTY,
               sum(DLP.ACCOUNT_PRICE * DL.QTY_POST) /* / sum(DL.QTY_POST * (1 - DL.IS_CORRECT))*/ as DOC_VALUE
        from   DOC_HEAD DH
               join DOC_LINE DL on DL.ID_DOC_HEAD = DH.ID_DOC
               join DOC_LINE_POST_VALUES DLP on dlp.ID_DOC_LINE = dl.ID_DOC_LINE
        where  DH.IS_ANUL = 0
               and DLP.ID_ACCOUNT_POST = :id_account_post
               and DH.ID_BASE_DOC = :id_base_doc
        into   :doc_qty, :doc_price;
        if (:doc_qty = 0) then doc_price = 0;
        else doc_price = :doc_price / :doc_qty;
      end

      if (:date_post >= :doc_date and :doc_qty is null) then begin
        /* update rates for prepaid postings (date_post >= doc_date) if base doc is annul */
        if ((:old_date_post <> :date_post) or (:old_curr_post <> :curr_post) ) then begin
          execute procedure ACCOUNT_POSTING_RATE_GET (:id_hotel, :curr_post, :date_post, :id_guest)
          returning_values  :RATE_POST;
        end
  
        if ((:OLD_DATE_POST <> :DATE_POST) or (:OLD_CURR_ORIG <> :CURR_ORIG) ) then begin
          execute procedure ACCOUNT_POSTING_RATE_GET (:id_hotel, :curr_orig, :date_post, :id_guest)
          returning_values  :rate_orig;
        end

        execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:QTY_POST, :PRICE_ORIG,
                          :RATE_ORIG, :RATE_POST, :id_sale_taxation)
        returning_values  :PRICE_POST, :POST_NET_VALUE, :POST_GROSS_VALUE;
      end  /* if date_post...  */

      new_is_anul = iif(:qty_post = 0 and :doc_qty is null, 1, 0);
      new_is_closed = iif(:doc_qty is not null
                          and cast(round_f(:qty_post - :doc_qty, :round_to) as numeric(15,2)) = 0
                          and cast(round_f(:price_post - :doc_price, :round_to)  as numeric(15,2)) = 0,
                          1,
                          0);

      update ACCOUNT_POST AP
      set    AP.IN_DOC_VALUE  = iif(:doc_qty is null, 0, :doc_price),
             AP.IN_DOC_QTY    = iif(:doc_qty is null, 0, :doc_qty),
             AP.RATE_ORIG     = :rate_orig,
             AP.RATE_POST     = :rate_post,
             AP.PRICE_POST    = :price_post,
             AP.POST_NET_VALUE = :post_net_value,
             AP.POST_GROSS_VALUE = :post_gross_value,
             --AP.ID_SALE_TAXATION  = :id_sale_taxation,
             AP.ID_BASE_DOC   = iif(:doc_qty is null, null, :ID_BASE_DOC),
             AP.IS_ANUL       = :new_is_anul,
             AP.AC            = :new_is_anul || :new_is_closed,
             AP.ANUL_DATETIME = iif(:new_is_anul = 1, current_timestamp, ap.anul_datetime),
             AP.DATETIME_CHANGED = current_timestamp
      where  AP.RDB$DB_KEY = :DBKEY;

      if (:DOC_QTY is not null) then begin
        update ACCOUNT_POST_CORRECTION APCU
        set    APCU.ID_DOC_HEAD  = -1,
               APCU.IS_OPEN      = 1
        where  APCU.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and APCU.ID_DOC_HEAD = :ID_DOC_HEAD
               and APCU.IS_OPEN = 0;
      end
      old_curr_post = :curr_post;
      old_curr_orig = :curr_orig;

      posts_value = :posts_value + :line_value;
    end  /* for select ... do begin  */

    action_text = f_character(29) || formatfloat(abs(:posts_value), 'F;0.00') || ' ' || :account_curr;
    action_code = 'OPEN_POSTINGS';
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, :action_code, :action_text);
  end  /* call type in (STORNO, ANUL)  */
end
^

/* Restore proc. body: ACCOUNT_POSTING_MULTIANUL */
ALTER PROCEDURE ACCOUNT_POSTING_MULTIANUL(AP_LIST VARCHAR(4096),
ANUL_REASON VARCHAR(70))
 AS
declare variable ap_dbkey char(8);
  declare variable id_account integer;
  declare variable prev_id_account integer;
  declare variable curr_post varchar(3);
  declare variable post_value double precision;
  declare variable log_curr varchar(3);
  declare variable log_value double precision;
  declare variable action_text varchar(255);
begin
  prev_id_account = null;
  log_value = 0;
  for
    select AP.RDB$DB_KEY, AP.ID_ACCOUNT, AP.CURR_POST, AP.QTY_POST * AP.PRICE_POST
    from   SYSTEM_STRING_PARSER(:ap_list, ',') SP
           left outer join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = SP.ITEM
    order by AP.ID_ACCOUNT asc
    into   :ap_dbkey, :id_account, :curr_post, :post_value
  do begin
    execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_dbkey,  :anul_reason);

    if (:prev_id_account is not null and :prev_id_account <> :id_account) then begin
      action_text = f_character(29) || formatfloat(:log_value, 'F;0.00') || ' ' || :log_curr
                    || f_character(28) || f_replstr(:ANUL_REASON, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_MULTIANUL', :action_text);
    end
    log_value = :log_value + :post_value;
    log_curr = :curr_post;
    prev_id_account = :id_account;
  end

  if (:id_account is not null) then begin
    action_text = f_character(29) || formatfloat(:log_value, 'F;0.00') || ' ' || :log_curr
                  || f_character(28) || f_replstr(:ANUL_REASON, 'MANUAL', '');
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_MULTIANUL', :action_text);
 end
end
^

/* Restore proc. body: ACCOUNT_POSTING_TRANSFER$ACC */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
declare variable ap_dbkey char(8);
  declare variable transfer_value double precision;
  declare variable post_value double precision;
  declare variable id_account integer;
  declare variable tmp_id_account integer;
  declare variable curr_post varchar(3);
  declare variable acc_name varchar(50);
  declare variable action_text varchar(255);
  declare variable is_pms_account integer;
  declare variable dest_acc_name varchar(50);
begin

  id_account = null;
  transfer_value = 0;

  select ACC.ACCOUNT_NAME, acc.IS_PMS_ACCOUNT
  from   ACCOUNT ACC
  where  ACC.ID_ACCOUNT = :ID_DEST_ACCOUNT
  into   :dest_acc_name, is_pms_account;

  if (:is_pms_account = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('PMS_TRANSFER_POSTINGS');
  end

  for
    select AP.RDB$DB_KEY, AP.ID_ACCOUNT, ap.PRICE_POST * ap.QTY_POST
    from   ACCOUNT_POST AP
    where  AP.DOC_SELECTED = :DOC_SELECTED
           and AP.ID_ACCOUNT = coalesce(:ID_SRC_ACCOUNT, AP.ID_ACCOUNT)
           and AP.ID_ACCOUNT is distinct from :ID_DEST_ACCOUNT
    order by AP.ID_ACCOUNT asc
    into   :ap_dbkey, :tmp_id_account, :post_value
  do begin
    execute procedure ACCOUNT_POSTING_TRANSFER$INT (:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:id_account is null) then id_account = :tmp_id_account;

    /* update from/to pms account */
    execute procedure PMS_ACCOUNT_POST_TRANSFER$INT(:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:tmp_id_account is distinct from :id_account) then begin
      select A.ACCOUNT_NAME, A.ACCOUNT_CURR
      from   ACCOUNT A
      where  A.ID_ACCOUNT = :id_account
      into   :acc_name, :curr_post;

      action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                    f_character(28) || :id_account || '/' || :acc_name ||
                    f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
      execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
      id_account = :tmp_id_account;
      transfer_value = 0;
    end
    transfer_value = :transfer_value + :post_value;
  end

  if (:id_account is not null) then begin
    select A.ACCOUNT_NAME, A.ACCOUNT_CURR
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :acc_name, :curr_post;
  
    action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                  f_character(28) || :id_account || '/' || :acc_name ||
                  f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
  end
end
^

/* Restore proc. body: ACCOUNT_POSTING_UPDATE */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable err_code integer;
  declare variable err_text varchar(100);
  declare variable in_db_key char(8);
begin
  /* called only from GUI - manual update */
  select AP.ID_ACCOUNT, AP.ID_GUEST, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :id_guest, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :id_account, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date)
  returning_values  (:err_code, :err_text, :new_qty_post, :new_price_post, :new_ac);

  if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
   
  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    if (coalesce(:id_guest, 0) > 0) then begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || :id_account
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'POST_UPDATE', :action_text);
    end else begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
    end
  end

end
^

/* Restore proc. body: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE ACCOUNT_SET_ARCHIVE_STATUS(ID_ACCOUNT INTEGER,
IS_ARCHIVE SMALLINT)
 AS
declare variable post_sum numeric (15,2);
  declare variable dep_sum numeric (15,2);
  declare variable open_charges integer;
  declare variable already_archived integer;
  declare variable id_profile integer;
  declare variable id_hotel integer;
  declare variable p_dbkey char(8);
  declare variable acc_dbkey char(8);
  declare variable archived_date date;
  declare variable is_used integer;
  declare variable action_text varchar(255);
  declare variable account_name varchar(50);
begin

  select A.RDB$DB_KEY, A.IS_ARCHIVE, A.ID_PROFILE, A.ID_HOTEL, A.ACCOUNT_NAME
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :acc_dbkey, :already_archived, :id_profile, :id_hotel, :account_name;

  if (:IS_ARCHIVE = 0) then begin -- unarchive
    update ACCOUNT A
    set    A.IS_ARCHIVE = 0
    where  A.RDB$DB_KEY = :acc_dbkey;

    p_dbkey = null;
    select P.IS_ARCHIVE, P.RDB$DB_KEY
    from   PROFILE P
    where  P.ID_PROFILE = :id_profile
    into   :already_archived, :p_dbkey;

    if (:p_dbkey is not null and :already_archived = 1) then begin
      /* restore profile active status */
      execute procedure PROFILE_SET_ARCHIVE$INT (:p_dbkey, 0);
    end

  end else begin
    if (:already_archived = 1) then exit;

    execute procedure ACCOUNT_USE_CHECK$INT (:ID_ACCOUNT)
    returning_values (:is_used);

    if (:is_used = 1) then begin
      select AB.POST_VALUE, AB.DEP_VALUE, AB.OPEN_CHARGES
      from   ACCOUNT_BALANCE$INT(:id_account) AB
      into   :post_sum, :dep_sum, :open_charges;
  
      if ((:post_sum <> 0) or (:open_charges = 1)) then
        exception ACCOUNT_EXCEPTION '-44' || f_character(31) || :ID_ACCOUNT;

      if (:dep_sum <> 0) then
        exception ACCOUNT_EXCEPTION '-40' || f_character(31) || :ID_ACCOUNT;
    
      execute procedure SYSTEM_DATE_GET (:id_hotel)
      returning_values (:archived_date);
    end else begin
      archived_date = null;  /* mark account as unused */
    end

    update ACCOUNT A
    set    A.IS_ARCHIVE = 1,
           A.ARCHIVED_DATE = :archived_date
    where  A.RDB$DB_KEY = :acc_dbkey;

    action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'ARCHIVE_ACCOUNT', :action_text);
  end
end
^

/* Restore proc. body: ACCOUNT_SET_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_SET_CREDIT_STATUS$INT(ID_ACCOUNT TYPE OF ID,
IS_CREDIT_ACCOUNT TYPE OF TLOGICAL,
CREDIT_LIMIT TYPE OF TPRICE,
SET_UNCONDITIONAL TYPE OF TLOGICAL = 0)
 AS
declare variable account_name varchar(50);
  declare variable old_is_credit_account smallint;
  declare variable action_code varchar(50);
  declare variable action_text varchar(255);
  declare variable id_profile integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable a_dbkey char(8);
begin

  select A.IS_CREDIT_ACCOUNT, A.ID_ACCOUNT, A.ACCOUNT_NAME, A.ID_PROFILE, A.ID_RESERV_DETAIL, a.RDB$DB_KEY
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :old_is_credit_account, :id_account, :account_name, :id_profile, :id_reserv_detail, :a_dbkey;

  if (:is_credit_account > :old_is_credit_account and :set_unconditional = 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('ACC_SET_CREDIT');

  end else if (:is_credit_account < :old_is_credit_account and :id_reserv_detail is not null) then begin
    select RD.CHECK_STATUS
    from   RESERV_DETAIL RD
    where  RD.ID_RESERV_DETAIL = :id_reserv_detail
    into   :check_status;

    if (:check_status = 1) then exception ACCOUNT_EXCEPTION '-1017';
  end

  update ACCOUNT A
  set    A.IS_CREDIT_ACCOUNT = :is_credit_account,
         A.CREDIT_LIMIT = :credit_limit
  where  A.RDB$DB_KEY = :a_dbkey;

  if (:old_is_credit_account <> :is_credit_account) then begin
    action_code = case when :is_credit_account = 1 then 'SET_CREDIT_ACCOUNT' else 'RESET_CREDIT_ACCOUNT' end;
    action_text = f_character(29) || :id_account || '/' || :account_name;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, :action_code, :action_text);
  end
end
^

/* Restore proc. body: ACCOUNT_SET_CURRENCY$INT */
ALTER PROCEDURE ACCOUNT_SET_CURRENCY$INT(A_DBKEY CHAR(8),
NEW_CURR CHAR(3))
 AS
declare variable id_account integer;
  declare variable old_acc_curr char(3);
  declare variable account_name varchar(50);
  declare variable id_profile integer;
  declare variable is_used integer;
  declare variable action_text varchar(255);
begin
  select A.ID_ACCOUNT, A.ACCOUNT_NAME, A.ACCOUNT_CURR, A.ID_PROFILE
  from   ACCOUNT A
  where  A.RDB$DB_KEY = :a_dbkey
  into   :id_account, :account_name, :old_acc_curr, :id_profile;

  if (:old_acc_curr <> :new_curr) then begin
    execute procedure ACCOUNT_USE_CHECK$INT (:id_account)
    returning_values  :is_used;
    if (:is_used = 1) then exception ACCOUNT_EXCEPTION '-41';
  end

  if (:old_acc_curr <> :new_curr) then begin
    action_text = f_character(29 ) || :id_account || '/' || :account_name
                  || f_character(28) || :old_acc_curr
                  || f_character(28) || :new_curr;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'EDIT_ACCOUNT_CURR', :action_text);
  end

  update ACCOUNT A
  set    A.ACCOUNT_CURR = :new_curr
  where  A.RDB$DB_KEY = :a_dbkey;
end
^

/* Restore proc. body: ACTIVITY_OFFER_COPY */
ALTER PROCEDURE ACTIVITY_OFFER_COPY(ID_ACTIVITY_OFFER TYPE OF ID)
 RETURNS(NEW_ID_ACTIVITY_OFFER TYPE OF ID)
 AS
declare variable activity_date type of TDATE;
declare variable status type of TENUM_SMALL;
declare variable offer_currency type of TCURRENCY;
declare variable recipient type of TPERSON_NAME;
declare variable recipient_comment type of TDESCRIPTION_LONG;
declare variable person_name type of TPERSON_NAME;
declare variable phone_num type of TPHONE;
declare variable fax type of TPHONE;
declare variable e_mail type of TEMAIL;
declare variable accomodation_note type of TNOTE_BLOB;
declare variable events_note type of TNOTE_BLOB;
declare variable fb_note type of TNOTE_BLOB;
declare variable addition_note type of TNOTE_BLOB;
declare variable extra_note type of TNOTE_BLOB;
declare variable offer_header type of TNOTE_BLOB;
declare variable offer_footer type of TNOTE_BLOB;
declare variable discount_note type of TNOTE_BLOB;
declare variable id_reserv_group type of ID_REF;
declare variable id_hotel type of ID;
declare variable id_agent_profile type of ID_REF;
declare variable id_activity_event type of ID;
declare variable id_activity_fb type of ID;
declare variable no_use type of ID_REF;
declare variable ad_additional_date type of TDATE;
declare variable ad_from_time type of TTIME;
declare variable ad_to_time type of TTIME;
declare variable ad_description type of TOBJECT_TEXT;
declare variable ad_speciality type of TDESCRIPTION_LONG;
declare variable ad_addition_price type of TPRICE;
declare variable ad_note type of TDESCRIPTION_LONG;
declare variable act_description type of TDESCRIPTION_SHORT;
declare variable discount_price type of TPRICE;
begin
  select AO.ACTIVITY_DATE, AO.STATUS, AO.OFFER_CURRENCY, AO.RECIPIENT, AO.RECIPIENT_COMMENT, AO.PERSON_NAME,
         AO.PHONE_NUM, AO.FAX, AO.E_MAIL, AO.ACCOMODATION_NOTE, AO.EVENTS_NOTE, AO.FB_NOTE, AO.ADDITION_NOTE,
         AO.EXTRA_NOTE, AO.OFFER_HEADER, AO.OFFER_FOOTER, AO.DISCOUNT_NOTE, AO.ID_RESERV_GROUP,
         AO.ID_HOTEL, AO.ID_AGENT_PROFILE
  from   ACTIVITY_OFFER AO
  where  AO.ID_ACTIVITY_OFFER = :id_activity_offer
  into   :activity_date, :status, :offer_currency, :recipient, :recipient_comment, :person_name,
         :phone_num, :fax, :e_mail, :accomodation_note, :events_note, :fb_note, :addition_note,
         :extra_note, :offer_header, :offer_footer, :discount_note, :id_reserv_group,
         :id_hotel, :id_agent_profile;

  execute procedure ACTIVITY_OFFER_MODIFY$RESERV(null, :activity_date, :status, :offer_currency, :recipient, :recipient_comment,
          :person_name, :phone_num, :fax, :e_mail, events_note, :fb_note, :addition_note, :accomodation_note, :offer_header, :offer_footer,
          :extra_note, :discount_note, :id_reserv_group, :id_hotel, :id_agent_profile, 'add')
  returning_values :new_id_activity_offer;

  for
    select AE.ID_ACTIVITY_EVENT
    from   ACTIVITY_EVENT AE
    where  AE.ID_ACTIVITY_OFFER = :id_activity_offer
    into   :id_activity_event
  do begin
    execute procedure ACTIVITY_EVENT_COPY(:id_activity_event, :new_id_activity_offer)
    returning_values  :no_use;
  end

  for
    select AF.ID_ACTIVITY_FB
    from   ACTIVITY_FB AF
    where  AF.ID_ACTIVITY_OFFER = :id_activity_offer
    into   :id_activity_fb
  do begin
    execute procedure ACTIVITY_FB_COPY(:id_activity_fb, :new_id_activity_offer)
    returning_values  :no_use;
  end

  for
    select AD.ADDITION_DATE, AD.FROM_TIME, AD.TO_TIME, AD.DESCRIPTION, AD.SPECIALITY, AD.ADDITION_PRICE,
           AD.NOTE
    from   ACTIVITY_ADDITION AD
    where  AD.ID_ACTIVITY_OFFER = :id_activity_offer
    into   :ad_additional_date, :ad_from_time, :ad_to_time, :ad_description, :ad_speciality, :ad_addition_price,
           :ad_note
  do begin
    execute procedure ACTIVITY_ADDITION_MODIFY$RESERV(null, :new_id_activity_offer, :ad_additional_date, :ad_from_time,
            :ad_to_time, :ad_description, :ad_speciality, :ad_addition_price, :ad_note, 'add')
    returning_values :no_use;
  end

  for
    select ACT.DESCRIPTION, ACT.DISCOUNT_PRICE
    from   ACTIVITY_DISCOUNT ACT
    where  ACT.ID_ACTIVITY_OFFER = :id_activity_offer
    into   :act_description, :discount_price
  do begin
    execute procedure ACTIVITY_DISCOUNT_MODIFY$RESERV(null, :new_id_activity_offer, :act_description, :discount_price, 'add')
    returning_values  :no_use;
  end

  execute procedure SYSTEM_LOG_ADD ('ACTIVITY_OFFER', :id_activity_offer, 'ACTIVITY_OFFER_COPY', f_character(29) || :new_id_activity_offer);
end
^

/* Restore proc. body: AR_OWING_ADD$INT */
ALTER PROCEDURE AR_OWING_ADD$INT(ID_PROFILE TYPE OF ID,
SUM_OWING TYPE OF TPRICE,
CURR_OWING TYPE OF TCURRENCY,
ID_DOC_HEAD TYPE OF ID_REF,
DUE_DATE TYPE OF TDATE,
SYSTEM_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
ID_AR_TYPE TYPE OF ID,
ID_HOTEL TYPE OF ID)
 RETURNS(NEW_ID_AR_OWING TYPE OF ID)
 AS
declare variable round_to numeric(15,4);
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
begin

  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :CURR_OWING
  into   :round_to;

  select P.PROFILE_NAME
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :profile_name;

  new_id_ar_owing = gen_id(GEN_AR_OWING_ID, 1);
  sum_owing = ROUND_F(:sum_owing, :round_to);

  insert into AR_OWING (ID_AR_OWING, ID_PROFILE, SUM_OWING, CURR_OWING,
         USER_CREATED, DATETIME_CREATED, ID_DOC, SYSTEM_DATE,
         ID_AR_OWING_BASE, DESCRIPTION, DUE_DATE, ID_AR_TYPE, ID_HOTEL)
  values (:new_id_ar_owing, :ID_PROFILE, :SUM_OWING, :CURR_OWING,
         user, current_timestamp, :ID_DOC_HEAD, :system_date,
         null, :description, STRIPTIME(:due_date), :ID_AR_TYPE, :ID_HOTEL);

  insert into AR_OWING_ADD(ID_AR_OWING, REST_OWING, OWING_STATUS)
  values (:NEW_ID_AR_OWING, :SUM_OWING, 11);

  --execute procedure AR_OWING_ADD_MODIFY(:new_id_ar_owing, :SUM_OWING, :CURR_OWING, null, 'add');

  action_text = substring(f_character(29) || :profile_name
                          || f_character(28) || formatfloat(:SUM_OWING, 'F;0.00') || ' ' || :CURR_OWING
                          || f_character(28) || :description from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'OWING_CREATE', :action_text);

end
^

/* Restore proc. body: AR_OWING_ANUL$INT */
ALTER PROCEDURE AR_OWING_ANUL$INT(ID_AR_OWING TYPE OF ID,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
IS_MANUAL_ANUL TYPE OF TLOGICAL = 1)
 RETURNS(NEW_ID_AR_OWING TYPE OF ID)
 AS
declare variable system_date type of TDATE;
  declare variable curr_id integer;
  declare variable owing_status smallint;
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable id_doc_head integer;
  declare variable sum_owing numeric(15,4) ;
  declare variable curr_owing char(3);
  declare variable id_profile integer;
begin

    select A.OWING_STATUS, O.ID_DOC, SDG.SYSTEM_DATE, o.SUM_OWING, o.CURR_OWING, o.ID_PROFILE
    from   AR_OWING O
           join AR_OWING_ADD A on A.ID_AR_OWING = O.ID_AR_OWING
           left outer join SYSTEM_DATE_GET(O.ID_HOTEL) SDG on 1=1
    where  A.ID_AR_OWING = :ID_AR_OWING
    into   :owing_status, :id_doc_head, :system_date, :sum_owing, :curr_owing, :id_profile;

    if (:OWING_STATUS = 22) then
      exception ACCOUNT_RECEIVABLE_EXCEPTION '-606' ;
    if (:IS_MANUAL_ANUL = 1 and :id_doc_head is not null) then
      exception ACCOUNT_RECEIVABLE_EXCEPTION '-609' ;

    update AR_OWING A  -- lock for update
    set    A.ID_AR_OWING = A.ID_AR_OWING
    where  A.ID_AR_OWING = :ID_AR_OWING;

    update AR_OWING_ADD A
    set    A.OWING_STATUS = 22,
           A.REST_OWING = :sum_owing
    where  A.ID_AR_OWING = :ID_AR_OWING;

    new_id_ar_owing = gen_id(GEN_AR_OWING_ID, 1);

    insert into AR_OWING (ID_AR_OWING, ID_PROFILE, SUM_OWING, CURR_OWING,
           USER_CREATED, DATETIME_CREATED, ID_DOC, SYSTEM_DATE,
           ID_AR_OWING_BASE, DESCRIPTION, DUE_DATE, ID_AR_TYPE, ID_HOTEL)
    select :new_id_ar_owing, A.ID_PROFILE, (-1)*A.SUM_OWING, A.CURR_OWING,
           user, current_timestamp, A.ID_DOC, :system_date, --A.SYSTEM_DATE,
           :ID_AR_OWING, :description, A.DUE_DATE, A.ID_AR_TYPE, a.ID_HOTEL
    from   AR_OWING A
    where  A.ID_AR_OWING = :ID_AR_OWING;

    insert into AR_OWING_ADD(ID_AR_OWING, REST_OWING, OWING_STATUS)
    select :new_id_ar_owing, (-1)*A.SUM_OWING, 22
    from   AR_OWING A
    where  A.ID_AR_OWING = :ID_AR_OWING;

    for
      select A.ID_AR_OWING_PAYMENT_POST
      from   AR_OWING_PAYMENT_POST A
      where  A.ID_AR_OWING = :ID_AR_OWING
             and A.IS_ANUL = 0
      into   :curr_id
    do begin
      execute procedure AR_OWING_PAYMENT_ANUL$AR(:curr_id, :DESCRIPTION);
    end
    -- transaction finalize
    execute procedure AR_POST_FINALIZE(:DESCRIPTION, iif(:IS_MANUAL_ANUL = 1, 'anul_owing', 'anul_link'));

    select P.PROFILE_NAME
    from   PROFILE P
    where  P.ID_PROFILE = :id_profile
    into   :profile_name;

    action_text = substring(f_character(29) || :profile_name
                            || f_character(28) || formatfloat(:sum_owing, 'F;0.00') || ' ' || :CURR_OWING
                            || f_character(28) || :description from 1 for 255);
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :id_profile, 'OWING_ANNUL', :action_text);

end
^

/* Restore proc. body: AR_OWING_PAYMENT_ADD$AR */
ALTER PROCEDURE AR_OWING_PAYMENT_ADD$AR(ID_AR_OWING INTEGER,
ID_AR_PAYMENT INTEGER,
SUM_OWING NUMERIC(15,4),
SUM_PAYMENT NUMERIC(15,4),
PAYMENT_RATE_TO_BGN NUMERIC(15,6),
OWING_RATE_TO_BGN NUMERIC(15,6),
DESCRIPTION VARCHAR(255))
 RETURNS(NEW_ID_AR_OWING_PAYMENT_POST INTEGER)
 AS
declare variable curr_payment varchar(3);
  declare variable curr_owing varchar(3);
  declare variable owing_status smallint;
  declare variable payment_status smallint;
  declare variable system_date date;
  declare variable id_ar_operation integer;
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable payment_type varchar(20);
  declare variable id_profile integer;
  declare variable owing_id_hotel integer;
  declare variable payment_id_hotel integer;
  declare variable payment_round_to numeric(15,4);
  declare variable owing_round_to numeric(15,4);
begin
  id_ar_operation = 3;
  select A.CURR_PAYMENT, PA.PAYMENT_STATUS, pt.PAYMENT_TYPE, a.ID_HOTEL, c.ROUND_TO
  from   AR_PAYMENT A
         join AR_PAYMENT_ADD PA on PA.ID_AR_PAYMENT = A.ID_AR_PAYMENT
         join PAYMENT_TYPE PT on PT.ID_PAYMENT_TYPE = a.ID_AR_PAYMENT_TYPE
         join CURRS c on c.CURR = a.CURR_PAYMENT
  where  A.ID_AR_PAYMENT = :ID_AR_PAYMENT
  into   :curr_payment, :PAYMENT_STATUS, :payment_type, :payment_id_hotel, :payment_round_to;

  select A.CURR_OWING, AA.OWING_STATUS, P.PROFILE_NAME, p.ID_PROFILE, a.ID_HOTEL, c.ROUND_TO
  from   AR_OWING A
         join AR_OWING_ADD AA on AA.ID_AR_OWING = A.ID_AR_OWING
         join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
         join CURRS c on c.CURR = a.CURR_OWING
  where  A.ID_AR_OWING = :id_ar_owing
  into   :curr_owing, :owing_status, :profile_name, :id_profile, :owing_id_hotel, :owing_round_to;

  if (:owing_id_hotel is distinct from :payment_id_hotel) then
    exception ACCOUNT_RECEIVABLE_EXCEPTION 'The payment and the owing are registered in different hotels!';

  if ( (:OWING_STATUS = 22) or (:PAYMENT_STATUS = 22) ) then
    exception ACCOUNT_RECEIVABLE_EXCEPTION '-604';

  execute procedure SYSTEM_DATE_GET(:payment_id_hotel)
  returning_values  (:system_date);

  /* lock records for update */
  select P.ID_AR_PAYMENT
  from   AR_PAYMENT P
  where  P.ID_AR_PAYMENT = :ID_AR_PAYMENT
  with lock  -- lock for update
  into   :ID_AR_PAYMENT;

  select O.ID_AR_OWING
  from   AR_OWING O
  where  O.ID_AR_OWING = :ID_AR_OWING
  with lock  -- lock for update
  into   :ID_AR_OWING;

  if (:SUM_OWING = 0.00) then exception ACCOUNT_RECEIVABLE_EXCEPTION '-602';

  SUM_OWING = round_f(:SUM_OWING, :owing_round_to);
  SUM_PAYMENT = round_f(:SUM_PAYMENT, :payment_round_to);

  insert into AR_OWING_PAYMENT_POST(ID_AR_OWING, ID_AR_PAYMENT,
         SUM_OWING, CURR_OWING, SUM_PAYMENT, CURR_PAYMENT, IS_ANUL, ID_AR_OPERATION,
         PAYMENT_RATE_TO_BGN, OWING_RATE_TO_BGN, ID_TRANSACTION, SYSTEM_DATE,
         ID_AR_OWING_PAYMENT_BASE, DESCRIPTION, USER_CREATED, DATETIME_CREATED)
  values (:ID_AR_OWING, :ID_AR_PAYMENT,
         :SUM_OWING, :curr_owing, :SUM_PAYMENT, :curr_payment, 0, :id_ar_operation,
         :payment_rate_to_bgn, :owing_rate_to_bgn, current_transaction, :system_date,
         null, :DESCRIPTION, user, current_timestamp)
  returning ID_AR_OWING_PAYMENT_POST
  into   :new_id_ar_owing_payment_post;

  action_text = substring(f_character(29) || :profile_name
                          || f_character(28) || formatfloat(:SUM_OWING, 'F;0.00') || ' ' || :CURR_OWING
                          || f_character(28) || :payment_type
                          || f_character(28) || formatfloat(:SUM_PAYMENT, 'F;0.00') || ' ' || :CURR_PAYMENT
                          || f_character(28) || :description
                          from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'OWING_PAY', :action_text);

end
^

/* Restore proc. body: AR_OWING_PAYMENT_ANUL$AR */
ALTER PROCEDURE AR_OWING_PAYMENT_ANUL$AR(ID_AR_OWING_PAYMENT_POST INTEGER,
DESCRIPTION VARCHAR(255))
 AS
declare variable curr_payment varchar(3);
  declare variable curr_owing varchar(3);
  declare variable owing_status smallint;
  declare variable payment_status smallint;
  declare variable is_anul smallint;
  declare variable system_date date;
  declare variable id_ar_operation integer;
  declare variable type_code varchar(10);
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable payment_type varchar(20);
  declare variable id_profile integer;
  declare variable owing_id_hotel integer;
  declare variable payment_id_hotel integer;
  declare variable sum_owing numeric(15,4);
  declare variable sum_payment numeric(15,4);
  declare variable id_ar_owing integer;
  declare variable id_ar_payment integer;
  declare variable payment_rate_to_bgn numeric(15,6);
  declare variable owing_rate_to_bgn numeric(15,6);
begin
  id_ar_operation = 3;
  if (:ID_AR_OWING_PAYMENT_POST is null) then
    exception ACCOUNT_RECEIVABLE_EXCEPTION '-85' || f_character(31) || 'ID_AR_OWING_PAYMENT_POST is null';

  /* lock record for update */
  select p.ID_AR_OWING, p.ID_AR_PAYMENT, p.IS_ANUL
  from   AR_OWING_PAYMENT_POST P
  where  P.ID_AR_OWING_PAYMENT_POST = :id_ar_owing_payment_post
  with lock  -- lock for update
  into   :id_ar_owing, :id_ar_payment, :is_anul;

  if (:is_anul = 1) then exception ACCOUNT_RECEIVABLE_EXCEPTION '-605';

  select A.CURR_PAYMENT, PA.PAYMENT_STATUS, pt.PAYMENT_TYPE, a.ID_HOTEL
  from   AR_PAYMENT A
         join AR_PAYMENT_ADD PA on PA.ID_AR_PAYMENT = A.ID_AR_PAYMENT
         join PAYMENT_TYPE PT on PT.ID_PAYMENT_TYPE = a.ID_AR_PAYMENT_TYPE
  where  A.ID_AR_PAYMENT = :ID_AR_PAYMENT
  into   :curr_payment, :PAYMENT_STATUS, :payment_type, :payment_id_hotel;

  select A.CURR_OWING, AA.OWING_STATUS, P.PROFILE_NAME, p.ID_PROFILE, a.ID_HOTEL, t.TYPE_CODE
  from   AR_OWING A
         join AR_OWING_ADD AA on AA.ID_AR_OWING = A.ID_AR_OWING
         join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
         join AR_TYPE T on a.ID_AR_TYPE = T.ID_AR_TYPE
  where  A.ID_AR_OWING = :id_ar_owing
  into   :curr_owing, :owing_status, :profile_name, :id_profile, :owing_id_hotel, :type_code;

  if (:type_code = 'DEPOSIT') then
    exception ACCOUNT_RECEIVABLE_EXCEPTION 'Operation (type_code=DEPOSIT) is not supported!';

  if (:owing_id_hotel is distinct from :payment_id_hotel) then
    exception ACCOUNT_RECEIVABLE_EXCEPTION 'The payment and the owing are registered in different hotels!';

  --if ( (:OWING_STATUS = 22) or (:PAYMENT_STATUS = 22) ) then
  --  exception ACCOUNT_RECEIVABLE_EXCEPTION '-604';

  /* lock records for update */
  select P.ID_AR_PAYMENT
  from   AR_PAYMENT P
  where  P.ID_AR_PAYMENT = :ID_AR_PAYMENT
  with lock  -- lock for update
  into   :ID_AR_PAYMENT;

  select O.ID_AR_OWING
  from   AR_OWING O
  where  O.ID_AR_OWING = :ID_AR_OWING
  with lock  -- lock for update
  into   :ID_AR_OWING;

  execute procedure SYSTEM_DATE_GET(:payment_id_hotel)
  returning_values  (:system_date);

  update AR_OWING_PAYMENT_POST A
  set    A.IS_ANUL = 1
  where  A.ID_AR_OWING_PAYMENT_POST = :ID_AR_OWING_PAYMENT_POST;

  select (-1)*P.SUM_OWING, (-1)*P.SUM_PAYMENT, P.ID_AR_OWING, P.ID_AR_PAYMENT,
         P.PAYMENT_RATE_TO_BGN, P.OWING_RATE_TO_BGN, P.CURR_OWING, P.CURR_PAYMENT
  from   AR_OWING_PAYMENT_POST P
  where  P.ID_AR_OWING_PAYMENT_POST = :ID_AR_OWING_PAYMENT_POST
  into   :SUM_OWING, :SUM_PAYMENT, :ID_AR_OWING, :ID_AR_PAYMENT,
         :PAYMENT_RATE_TO_BGN, :OWING_RATE_TO_BGN, :CURR_OWING, :CURR_PAYMENT;

  insert into AR_OWING_PAYMENT_POST(ID_AR_OWING, ID_AR_PAYMENT,
         SUM_OWING, CURR_OWING, SUM_PAYMENT, CURR_PAYMENT, IS_ANUL, ID_AR_OPERATION,
         PAYMENT_RATE_TO_BGN, OWING_RATE_TO_BGN, ID_TRANSACTION, SYSTEM_DATE,
         ID_AR_OWING_PAYMENT_BASE, DESCRIPTION, USER_CREATED, DATETIME_CREATED)
  values (:ID_AR_OWING, :ID_AR_PAYMENT,
         :SUM_OWING, :CURR_OWING, :SUM_PAYMENT, :CURR_PAYMENT, 1, :id_ar_operation,
         :PAYMENT_RATE_TO_BGN, :OWING_RATE_TO_BGN, current_transaction, :system_date,
         :ID_AR_OWING_PAYMENT_POST, :DESCRIPTION, user, current_timestamp);

  action_text = substring(f_character(29) || :profile_name
                          || f_character(28) || formatfloat(:SUM_OWING, 'F;0.00') || ' ' || :CURR_OWING
                          || f_character(28) || :payment_type
                          || f_character(28) || formatfloat(:SUM_PAYMENT, 'F;0.00') || ' ' || :CURR_PAYMENT
                          || f_character(28) || :description
                          from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'OWING_PAY_ANNUL', :action_text);

end
^

/* Restore proc. body: AR_PAYMENT_ADD$AR */
ALTER PROCEDURE AR_PAYMENT_ADD$AR(ID_PROFILE INTEGER,
ID_AR_PAYMENT_TYPE INTEGER,
ID_AR_PAYMENT_ACCOUNT INTEGER,
SUM_PAYMENT NUMERIC(15,4),
CURR_PAYMENT VARCHAR(3),
DESCRIPTION VARCHAR(255),
DATE_PAYMENT DATE,
ID_HOTEL INTEGER)
 RETURNS(NEW_ID_AR_PAYMENT INTEGER)
 AS
declare variable system_date date;
  declare variable payment_status smallint;
  declare variable round_to numeric(15,6);
  declare variable id_ar_operation integer;
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable payment_type varchar(20);
begin
  id_ar_operation = 2;

  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :CURR_PAYMENT
  into   :round_to;

  execute procedure SYSTEM_DATE_GET(:ID_HOTEL)
  returning_values  (:system_date);

  select p.PROFILE_NAME
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :profile_name;

  select P.PAYMENT_TYPE
  from   PAYMENT_TYPE P
  where  P.ID_PAYMENT_TYPE = :ID_AR_PAYMENT_TYPE
  into   :payment_type;

  payment_status = 11;
  SUM_PAYMENT = round_f(:SUM_PAYMENT, :round_to);

  new_id_ar_payment = gen_id(GEN_AR_PAYMENT_ID, 1);
  insert into AR_PAYMENT(ID_AR_PAYMENT, ID_PROFILE, SUM_PAYMENT, CURR_PAYMENT,
         USER_CREATED, DATETIME_CREATED, DESCRIPTION, ID_AR_OPERATION,
         SYSTEM_DATE, ID_AR_PAYMENT_BASE, ID_AR_PAYMENT_TYPE, ID_AR_PAYMENT_ACCOUNT,
         DATE_PAYMENT, ID_HOTEL)
  values (:new_id_ar_payment, :ID_PROFILE, :SUM_PAYMENT, :CURR_PAYMENT,
         user, current_timestamp, :DESCRIPTION, :id_ar_operation,
         :system_date, null, :ID_AR_PAYMENT_TYPE, :ID_AR_PAYMENT_ACCOUNT,
         :DATE_PAYMENT, :ID_HOTEL);

  insert into AR_PAYMENT_ADD(ID_AR_PAYMENT, REST_PAYMENT, PAYMENT_STATUS)
  values (:new_id_ar_payment, :SUM_PAYMENT, :PAYMENT_STATUS);

  action_text = substring(f_character(29) || :payment_type
                          || f_character(28) || :profile_name
                          || f_character(28) || formatfloat(:SUM_PAYMENT, 'F;0.00') || ' ' || :CURR_PAYMENT from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'PAYMENT_CREATE', :action_text);

end
^

/* Restore proc. body: AR_PAYMENT_ANUL$AR */
ALTER PROCEDURE AR_PAYMENT_ANUL$AR(ID_AR_PAYMENT INTEGER,
DESCRIPTION VARCHAR(255))
 RETURNS(NEW_ID_AR_PAYMENT INTEGER)
 AS
declare variable system_date date;
  declare variable curr_id integer;
  declare variable payment_status smallint;
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable payment_type varchar(20);
  declare variable curr_payment char(3);
  declare variable id_profile integer;
  declare variable id_payment_type integer;
  declare variable id_hotel integer;
  declare variable sum_payment numeric(15,4);
begin
  if (:ID_AR_PAYMENT is null) then exit;

  select A.PAYMENT_STATUS
  from   AR_PAYMENT_ADD A
  where  A.ID_AR_PAYMENT = :ID_AR_PAYMENT
  into   :payment_status;

  if (:payment_status = 22) then exception ACCOUNT_RECEIVABLE_EXCEPTION '-606';

  select p.CURR_PAYMENT, p.ID_PROFILE, p.ID_AR_PAYMENT_TYPE, p.ID_HOTEL, p.SUM_PAYMENT
  from   AR_PAYMENT P
  where P.ID_AR_PAYMENT = :ID_AR_PAYMENT
  with lock  -- lock for update
  into   :CURR_PAYMENT, :id_profile, :id_payment_type, :id_hotel, :sum_payment;

  select p.PROFILE_NAME
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :profile_name;

  select P.PAYMENT_TYPE
  from   PAYMENT_TYPE P
  where  P.ID_PAYMENT_TYPE = :id_payment_type
  into   :payment_type;

  execute procedure SYSTEM_DATE_GET(:ID_HOTEL)
  returning_values  (:system_date);

  payment_status = 22;

  update AR_PAYMENT_ADD A
  set    A.PAYMENT_STATUS = :payment_status
  where  A.ID_AR_PAYMENT = :ID_AR_PAYMENT;

  new_id_ar_payment = gen_id(GEN_AR_PAYMENT_ID, 1);

  insert into AR_PAYMENT(ID_AR_PAYMENT, ID_PROFILE, SUM_PAYMENT, CURR_PAYMENT,
         USER_CREATED, DATETIME_CREATED, DESCRIPTION, ID_AR_OPERATION,
         SYSTEM_DATE, ID_AR_PAYMENT_BASE, ID_AR_PAYMENT_TYPE, ID_AR_PAYMENT_ACCOUNT,
         DATE_PAYMENT, ID_HOTEL)
  select :new_id_ar_payment, A.ID_PROFILE, (-1)*A.SUM_PAYMENT, A.CURR_PAYMENT,
         user, current_timestamp, :DESCRIPTION, A.ID_AR_OPERATION,
         :system_date, :ID_AR_PAYMENT, A.ID_AR_PAYMENT_TYPE, A.ID_AR_PAYMENT_ACCOUNT,
         A.DATE_PAYMENT, a.ID_HOTEL
  from   AR_PAYMENT A
  where  A.ID_AR_PAYMENT = :id_ar_payment;

  insert into AR_PAYMENT_ADD(ID_AR_PAYMENT, REST_PAYMENT, PAYMENT_STATUS)
  select :new_id_ar_payment, (-1)*A.SUM_PAYMENT, :payment_status
  from   AR_PAYMENT A
  where  A.ID_AR_PAYMENT = :id_ar_payment;

  -- storno links
  for
    select A.ID_AR_OWING_PAYMENT_POST
    from   AR_OWING_PAYMENT_POST A
    where  A.ID_AR_PAYMENT = :ID_AR_PAYMENT
           and A.IS_ANUL = 0
    into   :curr_id
  do begin
    execute procedure AR_OWING_PAYMENT_ANUL$AR(:curr_id, :DESCRIPTION);
  end
  -- transaction finalize
  execute procedure AR_POST_FINALIZE(:DESCRIPTION, 'anul_pay');

  action_text = substring(f_character(29) || :payment_type
                          || f_character(28) || :profile_name
                          || f_character(28) || formatfloat(:SUM_PAYMENT, 'F;0.00') || ' ' || :CURR_PAYMENT from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'PAYMENT_ANNUL', :action_text);
end
^

/* Restore proc. body: BLOCK_ANNUL$BLK */
ALTER PROCEDURE BLOCK_ANNUL$BLK(ID_BLOCK_ROOM INTEGER,
OPERATION VARCHAR(30))
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable share_err_text varchar(255);
  declare variable system_date date;
  declare variable from_date date;
  declare variable b_dbkey char(8);
  declare variable new_id_block_room integer;
  declare variable id_room integer;
  declare variable block_grp integer;
  declare variable reason varchar(50);
  declare variable note varchar(255);
  declare variable action_text varchar(255);
  declare variable room_name varchar(10);
  declare variable id_hotel integer;
  declare variable mark_dirty_expired_block integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION (:operation, 'cancel, annul');

  select BR.FROM_DATE, BR.RDB$DB_KEY, R.ID_HOTEL
  from   BLOCK_ROOM BR
         join ROOMS R on R.ID_ROOM = BR.ID_ROOM
  where  BR.ID_BLOCK_ROOM = :id_block_room
  into   :from_date, :b_dbkey, :id_hotel;

  if (:operation = 'annul') then begin
    update BLOCK_ROOM BR
    set    BR.IS_ANNUL = 1
    where  BR.RDB$DB_KEY = :b_dbkey;
  
    execute procedure BLOCK_MODIFY_CONTROL$INT(:b_dbkey, :from_date);
    execute procedure ROOM_MAGIC_CLEAR(:id_block_room);
    action_text = '';
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :id_block_room, 'ANNUL_BLOCK', :action_text);
  end else begin
    select BR.ID_ROOM, BR.BLOCK_GRP, BR.REASON, BR.NOTE, R.ROOM_NAME
    from   BLOCK_ROOM BR
           join ROOMS R on R.ID_ROOM = BR.ID_ROOM
    where  BR.RDB$DB_KEY = :b_dbkey
    into   :id_room, :block_grp, :reason, :note, :room_name;

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :system_date;

    execute procedure BLOCK_MODIFY$INT(:id_block_room, :id_room, :from_date, :system_date, :block_grp, :reason,
                      :note, 'mod')
    returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :share_err_text, :warn_code;
    --ignore possible entering into share

    execute procedure SETTING_GET_VALUE('MARK_DIRTY_EXPIRED_BLOCK', :id_hotel)
    returning_values  :mark_dirty_expired_block;
    if (:mark_dirty_expired_block = '1') then begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'BLOCK_STOP', 'set_dirty');
    end

    action_text = f_character(29) || :room_name || f_character(28) || formatdate(:system_date, 'D;dd.mm.yyyy');
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :new_id_block_room, 'CANCEL_BLOCK', :action_text);
  end
end
^

/* Restore proc. body: BLOCK_CREATE$BLK */
ALTER PROCEDURE BLOCK_CREATE$BLK(ROOM_NAMES TYPE OF TDESCRIPTION_LONG,
ID_HOTEL TYPE OF ID,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
BLOCK_GRP TYPE OF TRANGE,
REASON TYPE OF TREASON,
NOTE TYPE OF TDESCRIPTION_LONG,
IS_FULL_FROM TYPE OF TRANGE,
IS_FULL_TO TYPE OF TRANGE)
 RETURNS(NEW_ID_BLOCK_ROOM TYPE OF ID,
SHARE_TRANSACTION_ID TYPE OF ID,
SHARE_ERR_CODE TYPE OF ID,
ERR_TEXT VARCHAR(255),
WARN_CODE TYPE OF ID,
NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable room_name varchar(50);
  declare variable id_room integer;
  declare variable action_text varchar(255);
  declare variable block_name varchar(30);
begin
  id_room = null;
  warn_code = null;
  SHARE_ERR_CODE = 0;

  for
    select ITEM
    from   SYSTEM_STRING_PARSER(:room_names, ',')
    into   :room_name
  do begin
    id_room = null;
    select R.ID_ROOM
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ROOM_NAME = :room_name
           and RT.ID_HOTEL = :id_hotel
    into   :id_room;

    if (:id_room is null) then exception BLOCK_EXCEPTION '-5' || f_character(31) || :room_name;

    execute procedure BLOCK_MODIFY$INT(null, :id_room, :from_date, :to_date, :block_grp,
                      :reason, :note, 'add')
    returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :err_text, :warn_code;

    block_name = iif(:block_grp = 18, 'OUT OF ORDER', 'OUT OF INVENTORY');
    action_text = f_character(29) || :room_name
                  || f_character(28) || formatdate(:from_date, 'D;dd.mm.yyyy') || '-' || formatdate(:to_date, 'D;dd.mm.yyyy')
                  || f_character(28) || :block_name;
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :new_id_block_room, 'BLOCK_ROOM', :action_text);

  end

  select cast('31.12.1899' as date) + count(b.ID_BLOCK_ROOM)
  from   BLOCK_ROOM b
  where  b.ID_ROOM is not null
  into   :NEW_FROM_DATE;
end
^

/* Restore proc. body: BLOCK_MODIFY$BLK */
ALTER PROCEDURE BLOCK_MODIFY$BLK(ID_BLOCK_ROOM INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
BLOCK_GRP INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
IS_FULL_FROM INTEGER,
IS_FULL_TO INTEGER)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable new_id_block_room integer;
  declare variable action_text varchar(255);
  declare variable old_from_date date;
  declare variable old_to_date date;
  declare variable old_group integer;
  declare variable room_name varchar(10);
  declare variable block_name varchar(30);
begin
  --  IS_FULL_FROM  - deprecated
  --  IS_FULL_TO  - deprecated

  select BR.FROM_DATE, BR.TO_DATE, BR.BLOCK_GRP, R.ROOM_NAME
  from   BLOCK_ROOM BR
         join ROOMS R on R.ID_ROOM = BR.ID_ROOM
  where  BR.ID_BLOCK_ROOM = :ID_BLOCK_ROOM              
  into   :old_from_date, :old_to_date, :old_group, :room_name;

  execute procedure BLOCK_MODIFY$INT(:id_block_room, :id_room, :from_date, :to_date, :block_grp,
                    :reason, :note, 'mod')
  returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :err_text, :warn_code;

  if ( (:old_from_date <> :FROM_DATE) or (:old_to_date <> :TO_DATE) or (:old_group <> :BLOCK_GRP) ) then begin
    block_name = iif(:block_grp = 18, 'OUT OF ORDER', 'OUT OF INVENTORY');
    action_text = f_character(29) || :room_name
                  || f_character(28) || formatdate(:FROM_DATE, 'D;dd.mm.yyyy') || '-' || formatdate(:TO_DATE, 'D;dd.mm.yyyy')
                  || f_character(28) || :block_name;
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :NEW_ID_BLOCK_ROOM, 'EDIT_BLOCK', :action_text);
  end
end
^

/* Restore proc. body: CONTRACT_CALENDAR_MODIFY$PMS */
ALTER PROCEDURE CONTRACT_CALENDAR_MODIFY$PMS(ID_CONTRACT_CALENDAR_POST TYPE OF ID,
ID_ROOM_CONTRACT TYPE OF ID,
ID_SERVICE TYPE OF ID,
IS_INCOME TYPE OF TLOGICAL,
SERVICE_PRICE TYPE OF TPRICE,
ID_CURRENCY TYPE OF TCURRENCY,
IS_ACC_POST_ITEM TYPE OF TLOGICAL,
POSTING_DATE_LIST TYPE OF TTEXT_EXTENDED,
POSTING_PERIOD_DURATION TYPE OF TCOUNT,
MONTH_NEXT_DATE TYPE OF TDATE,
IS_FIXED_DATE TYPE OF TLOGICAL,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_CALENDAR_POST TYPE OF ID)
 AS
declare variable post_date date;
  declare variable post_next_date date;
  declare variable service_name varchar(30);
  declare variable old_service_name varchar(30);
  declare variable old_post_next_date date;
  declare variable old_is_income smallint;
  declare variable old_service_price numeric(15,4);
  declare variable old_id_currency varchar(3);
  declare variable old_is_acc_post_item smallint;
  declare variable old_posting_period_duration integer;
  declare variable old_posting_date_list varchar(2000);
  declare variable old_id_service integer;
  declare variable old_is_fixed_date smallint;
  declare variable old_id_room_contract integer;
  declare variable action_text varchar(255);
begin

  /* POSTING_DATE_LIST - list ot dates(dd.mm.yyyy) comma separated;
     POSTING_PERIOD_DURATION must be in months,
     operation in ('add','mod','del') */

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del,mod_next_date');

  post_date = null;
  post_next_date = null;
  if (:OPERATION in ('add','mod')) then begin
    if (:is_fixed_date = 0) then begin
      post_date = :month_next_date;
      if (:posting_period_duration is not null and :post_date is not null) then begin
        post_next_date = addmonth(:post_date, :posting_period_duration);
      end
    end else begin
      select first 1 S.ITEM
      from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') S
      order by cast(S.ITEM as date)
      into :post_date;

      select first 1 SSP.ITEM
      from SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') SSP
      where cast(SSP.ITEM as date) > :post_date
      order by cast(SSP.ITEM as date)
      into :post_next_date;
    end

 --   select first 1 S.ITEM
 --   from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') S
 --   order by S.INTURN
 --   into   :post_date;

 --   if (:posting_period_duration is not null and :post_date is not null) then begin
 --     execute procedure ADD_MONTH(:post_date, :posting_period_duration)
 --     returning_values (:post_next_date);
 --   end else if (:posting_date_list is not null) then begin
 --     select S.ITEM
 --     from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') S
 --     where  S.INTURN = 2
 --     into   :post_next_date;
 --   end
  end

  select SE.SERVICE_NAME
  from SERVICES SE
  where SE.ID_SERVICE = :ID_SERVICE
  into :service_name;

  if (:operation = 'add') then begin
    if (coalesce(:ID_CONTRACT_CALENDAR_POST, -1) > 0) then
      NEW_ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST;
    else
      NEW_ID_CONTRACT_CALENDAR_POST = gen_id(GEN_CONTRACT_CAL_POST$PMS_ID, 1);

    insert into CONTRACT_CALENDAR_POST$PMS (
           ID_CONTRACT_CALENDAR_POST, ID_ROOM_CONTRACT, ID_SERVICE, IS_INCOME,
           SERVICE_PRICE, ID_CURRENCY, IS_ACC_POST_ITEM, POST_DATE, POST_NEXT_DATE, POSTING_PERIOD_DURATION, IS_FIXED_DATE)
    values (:NEW_ID_CONTRACT_CALENDAR_POST, :ID_ROOM_CONTRACT, :ID_SERVICE, :IS_INCOME,
            :SERVICE_PRICE, :ID_CURRENCY, :IS_ACC_POST_ITEM, :POST_DATE, :POST_NEXT_DATE, :POSTING_PERIOD_DURATION, :IS_FIXED_DATE);
    ID_CONTRACT_CALENDAR_POST = :NEW_ID_CONTRACT_CALENDAR_POST;

    if ((:is_fixed_date = 0) and (:month_next_date is not null)) then
      insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
      values (:ID_CONTRACT_CALENDAR_POST, :MONTH_NEXT_DATE);
    else if ((:is_fixed_date = 1) and (:posting_date_list is not null)) then begin
      for
        select SY.ITEM
        from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') SY
        into   :post_date
      do begin
        insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
        values (:ID_CONTRACT_CALENDAR_POST, :POST_DATE);
      end
    end

 --   for
 --     select S.ITEM
 --     from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') S
 --     into   :post_date
 --   do begin
 --     insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
 --     values (:ID_CONTRACT_CALENDAR_POST, :POST_DATE);
 --   end

    action_text = substring(f_character(29) || '@{pms.contract.is_income.' || :is_income || '}' || ', ' || :service_name ||
                  f_character(28) || '@{pms.is_acc_post_item.' || :is_acc_post_item || '}' ||
                  ', ' || formatfloat(:service_price, '0.00') ||
                  ', ' || :id_currency ||
                  ', ' || iif(:is_fixed_date = 0, '@{pms.montly_plannig_scheme}' || ', ' || coalesce(:posting_period_duration, ' ') || ', ' ||
                                                  iif(:month_next_date is not null, formatdate(:month_next_date, 'D;dd.mm.yyyy'), ' '),
                                                             '@{pms.fixed_plannig_scheme}' || ', ' ||coalesce(:posting_date_list, ' ')) from 1 for 255);

    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_CALEN_ADD', :ACTION_TEXT);
  end else begin
    select S.SERVICE_NAME, CCP.IS_INCOME, CCP.SERVICE_PRICE, CCP.ID_CURRENCY, CCP.IS_ACC_POST_ITEM,
           CCP.POSTING_PERIOD_DURATION, CCP.POST_NEXT_DATE, CCP.ID_SERVICE, CCP.IS_FIXED_DATE, CCP.ID_ROOM_CONTRACT
    from CONTRACT_CALENDAR_POST$PMS CCP
      join SERVICES S on S.ID_SERVICE = CCP.ID_SERVICE
    where CCP.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST
    into :old_service_name, old_is_income, :old_service_price, :old_id_currency, :old_is_acc_post_item,
         :old_posting_period_duration, :old_post_next_date, :old_id_service, :old_is_fixed_date, :old_id_room_contract;

    select list(formatdate(CCS.POST_DATE, 'D;dd.mm.yyyy'), ',')
    from CONTRACT_CALENDAR_SCHEME$PMS CCS
    where CCS.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST
    into :old_posting_date_list;

    if (:operation = 'mod') then begin
      if ((:old_is_income <> :is_income) or (:old_id_service <> :id_service)) then begin
        execute procedure CONTRACT_CALENDAR_MODIFY$PMS(:ID_CONTRACT_CALENDAR_POST, :ID_ROOM_CONTRACT, :ID_SERVICE, :IS_INCOME, :SERVICE_PRICE,
                                                       :ID_CURRENCY, :IS_ACC_POST_ITEM, :POSTING_DATE_LIST, :POSTING_PERIOD_DURATION,
                                                       :MONTH_NEXT_DATE, :IS_FIXED_DATE, 'del')
        returning_values :new_id_contract_calendar_post;
        execute procedure CONTRACT_CALENDAR_MODIFY$PMS(:ID_CONTRACT_CALENDAR_POST, :ID_ROOM_CONTRACT, :ID_SERVICE, :IS_INCOME, :SERVICE_PRICE,
                                                       :ID_CURRENCY, :IS_ACC_POST_ITEM, :POSTING_DATE_LIST, :POSTING_PERIOD_DURATION,
                                                       :MONTH_NEXT_DATE, :IS_FIXED_DATE, 'add')
        returning_values :new_id_contract_calendar_post;
      end else begin
        update CONTRACT_CALENDAR_POST$PMS C
        set    C.SERVICE_PRICE = :SERVICE_PRICE,
               C.ID_CURRENCY = :ID_CURRENCY,
               C.IS_ACC_POST_ITEM = :IS_ACC_POST_ITEM,
               C.POST_DATE = :POST_DATE,
               C.POST_NEXT_DATE = :POST_NEXT_DATE,
               C.POSTING_PERIOD_DURATION = :POSTING_PERIOD_DURATION,
               C.IS_FIXED_DATE = :IS_FIXED_DATE
        where C.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST;

        delete from CONTRACT_CALENDAR_SCHEME$PMS
        where (ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST);

        if ((:is_fixed_date = 0) and (:month_next_date is not null)) then
          insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
          values (:ID_CONTRACT_CALENDAR_POST, :MONTH_NEXT_DATE);
        else if ((:is_fixed_date = 1) and (:posting_date_list is not null)) then begin
          for
            select SY.ITEM
            from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') SY
            into   :post_date
          do begin
            insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
            values (:ID_CONTRACT_CALENDAR_POST, :POST_DATE);
          end
        end

 --       for
 --         select S.ITEM
 --         from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') S
 --         into   :post_date
 --       do begin
 --         insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
 --         values (:ID_CONTRACT_CALENDAR_POST, :POST_DATE);
 --       end

        if ((:old_is_acc_post_item <> :is_acc_post_item) or (:old_service_price <> :service_price) or (:old_id_currency <> :id_currency)) then begin
          action_text = substring(f_character(29) || '@{pms.contract.is_income.' || :is_income || '}' ||
                        ', ' || :service_name ||
                        f_character(28) || '@{pms.is_acc_post_item.' || :old_is_acc_post_item || '}' || ', '
                        || formatfloat(:old_service_price, '0.00') || ', ' ||
                        :old_id_currency ||
                        f_character(28) || '@{pms.is_acc_post_item.' || :is_acc_post_item || '}' || ', ' ||
                        formatfloat(:service_price, '0.00') || ', ' || :id_currency from 1 for 255);
          execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_CALEN_MOD', :ACTION_TEXT);
        end

        if ((coalesce(:old_posting_period_duration, 0) <> coalesce(:posting_period_duration, 0)) or
            (coalesce(:old_posting_date_list, ' ') <> coalesce(:posting_date_list, formatdate(:month_next_date, 'D;dd.mm.yyyy')))) then begin
          action_text = substring(f_character(29) || '@{pms.contract.is_income.' || :is_income || '}' ||
                        ', ' || :service_name || ', ' || f_character(28) ||
                        iif(:old_is_fixed_date = 0, '@{pms.montly_plannig_scheme}' || ', ' || coalesce(:old_posting_period_duration, ' ') || ', ' ||
                                                    coalesce(:old_posting_date_list, ' '),
                                                    '@{pms.fixed_plannig_scheme}' || ', ' ||coalesce(:old_posting_date_list, ' ')) ||
                        f_character(28) || iif(:is_fixed_date = 0, '@{pms.montly_plannig_scheme}' || ', ' || coalesce(:posting_period_duration, ' ')
                                                                   || ', ' || /*coalesce(:posting_date_list, ' ')*/iif(:month_next_date is not null, formatdate(:month_next_date, 'D;dd.mm.yyyy'), ' '),
                                                                   '@{pms.fixed_plannig_scheme}' || ', ' || coalesce(:posting_date_list, ' ')) from 1 for 255);
          execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_CALEN_MOD_SCHM', :ACTION_TEXT);
        end
      end
    end
    if (:operation = 'mod_next_date') then begin
      select C.POST_NEXT_DATE, C.POSTING_PERIOD_DURATION, C.IS_FIXED_DATE
      from   CONTRACT_CALENDAR_POST$PMS C
      where  C.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST
      into   :post_date, :posting_period_duration, :is_fixed_date;

      if ((:is_fixed_date = 0) and (:posting_period_duration is not null) and (:post_date is not null)) then begin
        POST_NEXT_DATE = addmonth(:POST_DATE, :POSTING_PERIOD_DURATION);
      end else begin
        select first 1 skip 1 S.POST_DATE
        from   CONTRACT_CALENDAR_SCHEME$PMS S
        where  S.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST
        order by S.POST_DATE
        into   :POST_NEXT_DATE;
      end

      update CONTRACT_CALENDAR_POST$PMS C
      set    C.POST_DATE = :POST_DATE,
             C.POST_NEXT_DATE = :POST_NEXT_DATE
      where  C.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST;
    end
    if (:operation = 'del') then begin
      action_text = f_character(29) || '@{pms.contract.is_income.' || :old_is_income || '}' || f_character(28) || :old_service_name ||
                    f_character(28) || '@{pms.is_acc_post_item.' || :old_is_acc_post_item || '}' ||
                    ', ' || formatfloat(:old_service_price, '0.00') ||
                    ', ' || :old_id_currency ||
                    ', ' || iif(:old_is_fixed_date = 0, '@{pms.montly_plannig_scheme}' || ', ' || coalesce(:old_posting_period_duration, ' ') ||
                                                        ', ' || coalesce(:old_post_next_date, ' '),
                                                        '@{pms.fixed_plannig_scheme}' || ', ' || coalesce(:old_posting_date_list, ' '));
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :OLD_ID_ROOM_CONTRACT, 'ROOM_CONTR_CALEN_DEL', substring(:ACTION_TEXT from 1 for 255));
      delete from CONTRACT_CALENDAR_POST$PMS
      where (ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST);
    end
  end
end
^

/* Restore proc. body: CONTRACT_EXPENSE_MODIFY$PMS */
ALTER PROCEDURE CONTRACT_EXPENSE_MODIFY$PMS(ID_CONTRACT_EXPENSE TYPE OF ID,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
ID_SERVICE TYPE OF ID,
ID_CURRENCY TYPE OF TCURRENCY,
SERVICE_PRICE TYPE OF TPRICE,
CONTRACT_EXPENSE_TYPE VARCHAR(50),
MULTIPLIER_TYPE VARCHAR(50),
ORDER_TAG TYPE OF TCOUNT,
IS_ACC_POST_ITEM TYPE OF TLOGICAL,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_EXPENSE TYPE OF ID)
 AS
declare variable is_use smallint;
  declare variable formula varchar(100);
  declare variable service_name varchar(30);
  declare variable id_room_contract integer;
  declare variable old_service_name varchar(30);
  declare variable old_is_acc_post_item smallint;
  declare variable old_multiplier_type varchar(50);
  declare variable old_contract_expense_type varchar(50);
  declare variable old_order_tag integer;
  declare variable old_id_currency char(3);
  declare variable old_service_price numeric(15,4);
  declare variable old_id_service integer;
  declare variable contract_acc varchar(50);
  declare variable action_text varchar(255);
  declare variable id_hotel_contract integer;
  declare variable id_hotel_service integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if ( :CONTRACT_EXPENSE_TYPE not in ('PERCENT', 'RUNNING_TOTAL_PERCENT', 'CURR_VALUE') ) then
    exception WRONG_PARAM_VALUE;

  if ( :MULTIPLIER_TYPE not in ('RESERVATION', 'STAY', 'GUESTS', 'BED_NIGHTS') ) then
    exception WRONG_PARAM_VALUE;

  if (:ORDER_TAG is null) then ORDER_TAG = 0;
  formula = '';
  is_use = 1;

  select SE.SERVICE_NAME, SE.id_hotel
  from   SERVICES SE
  where  SE.ID_SERVICE = :ID_SERVICE
  into   :service_name, :id_hotel_service;

  select R.ID_HOTEL
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS RP on RP.ID_ROOM_PERIOD = RC.ID_ROOM_PERIOD
         join ROOMS R on R.ID_ROOM = RP.ID_ROOM
  where  RC.ID_ROOM_CONTRACT = :ID_CONTRACT
  into   :id_hotel_contract;

  if (:id_hotel_contract is distinct from :id_hotel_service) then exception PMS_EXCEPTION '-626';

  if (:OPERATION = 'add') then begin
    /*select case
              when :ID_CONTRACT = RCP.ID_CONTRACT_GUEST then '@{pms.contract_base_account}'
              when :ID_CONTRACT = RCP.ID_CONTRACT_OWNER then '@{pms.contract_owner_use}'
              else '@{pms.contract_shadow_account}'
           end as CONTRACT_ACC,
           RCP.ID_ROOM_CONTRACT
    from ROOM_CONTRACT$PMS RCP
    where :ID_CONTRACT in (RCP.ID_CONTRACT_GUEST, RCP.ID_CONTRACT_OWNER, RCP.ID_CONTRACT_SHADOW)
    into :contract_acc, :id_room_contract;                      */
    id_room_contract = :ID_CONTRACT;
    contract_acc = case
                     when :SUB_CONTRACT = 'GUEST_USE' then '@{pms.contract_base_account}'
                     when :SUB_CONTRACT = 'OWNER_USE' then '@{pms.contract_owner_use}'
                     when :SUB_CONTRACT = 'SHADOW_ACC' then '@{pms.contract_shadow_account}'
                     else 'N/A'
                   end;

    NEW_ID_CONTRACT_EXPENSE = gen_id(GEN_CONTRACT_EXPENSE$PMS_ID, 1);
    insert into CONTRACT_EXPENSE$PMS (ID_CONTRACT_EXPENSE, ID_CONTRACT, SUB_CONTRACT, ID_SERVICE, ORDER_TAG,
           FORMULA, ID_CURRENCY, SERVICE_PRICE, CONTRACT_EXPENSE_TYPE, IS_ACC_POST_ITEM, MULTIPLIER_TYPE)
    values (:NEW_ID_CONTRACT_EXPENSE, :ID_CONTRACT, :SUB_CONTRACT, :ID_SERVICE, :ORDER_TAG,
           :FORMULA, :ID_CURRENCY, :SERVICE_PRICE, :CONTRACT_EXPENSE_TYPE, :IS_ACC_POST_ITEM, :MULTIPLIER_TYPE);

    action_text = substring(f_character(29) || :contract_acc || f_character(28) || :order_tag || f_character(28) || :service_name ||
                  f_character(28) || '@{pms.is_acc_post_item.' || :is_acc_post_item || '}' ||
                  f_character(28) || '@{pms.multiplier_type.' || :multiplier_type || '}' ||
                  f_character(28) || coalesce(:id_currency, '@{pms.contract_expense_type.' || :contract_expense_type || '}') ||
                  f_character(28) || formatfloat(:service_price, '0.00') from 1 for 255);
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_SERV_ADD', :ACTION_TEXT);
  end else begin
    select S.SERVICE_NAME, CEP.IS_ACC_POST_ITEM, CEP.MULTIPLIER_TYPE, CEP.CONTRACT_EXPENSE_TYPE, CEP.ORDER_TAG,
           CEP.ID_CURRENCY, CEP.SERVICE_PRICE, CEP.ID_SERVICE,
           case
             when CEP.SUB_CONTRACT = 'GUEST_USE' then '@{pms.contract_base_account}'
             when CEP.SUB_CONTRACT = 'OWNER_USE' then '@{pms.contract_owner_use}'
             when CEP.SUB_CONTRACT = 'SHADOW_ACC' then '@{pms.contract_shadow_account}'
             else 'N/A'
           end,
           CEP.ID_CONTRACT
    from   CONTRACT_EXPENSE$PMS CEP
           join SERVICES S on S.ID_SERVICE = CEP.ID_SERVICE
    where  CEP.ID_CONTRACT_EXPENSE = :ID_CONTRACT_EXPENSE
    into   :old_service_name, :old_is_acc_post_item, :old_multiplier_type, :old_contract_expense_type, :old_order_tag,
           :old_id_currency, :old_service_price, :old_id_service, :contract_acc, :id_room_contract;

    if (:OPERATION = 'mod') then begin
      if (:old_id_service <> :id_service) then begin
        execute procedure CONTRACT_EXPENSE_MODIFY$PMS(:ID_CONTRACT_EXPENSE, :ID_CONTRACT, :SUB_CONTRACT, :ID_SERVICE, :ID_CURRENCY, :SERVICE_PRICE,
                                                      :CONTRACT_EXPENSE_TYPE, :MULTIPLIER_TYPE, :ORDER_TAG, :IS_ACC_POST_ITEM, 'del')
        returning_values :new_id_contract_expense;
        execute procedure CONTRACT_EXPENSE_MODIFY$PMS(:ID_CONTRACT_EXPENSE, :ID_CONTRACT, :SUB_CONTRACT, :ID_SERVICE, :ID_CURRENCY, :SERVICE_PRICE,
                                                      :CONTRACT_EXPENSE_TYPE, :MULTIPLIER_TYPE, :ORDER_TAG, :IS_ACC_POST_ITEM, 'add')
        returning_values :new_id_contract_expense;
      end else begin
        update CONTRACT_EXPENSE$PMS
        set    -- ID_CONTRACT = :ID_CONTRACT,
               FORMULA = :FORMULA,
               ID_CURRENCY = :ID_CURRENCY,
               SERVICE_PRICE = :SERVICE_PRICE,
               CONTRACT_EXPENSE_TYPE = :CONTRACT_EXPENSE_TYPE,
               IS_ACC_POST_ITEM = :IS_ACC_POST_ITEM,
               MULTIPLIER_TYPE = :MULTIPLIER_TYPE,
               ORDER_TAG = :ORDER_TAG
        where  ID_CONTRACT_EXPENSE = :ID_CONTRACT_EXPENSE;

        if ((:old_is_acc_post_item <> :is_acc_post_item) or (:old_multiplier_type <> :multiplier_type) or
                   (coalesce(:old_id_currency, :old_contract_expense_type) <> coalesce(:id_currency, :contract_expense_type)) or
                   (:old_service_price <> :service_price)) then begin
          action_text = substring(f_character(29) || :old_service_name || f_character(28) || :contract_acc ||
                        f_character(28) || '@{pms.is_acc_post_item.' || :old_is_acc_post_item || '}' ||
                        f_character(28) || '@{pms.multiplier_type.' || :old_multiplier_type || '}' ||
                        f_character(28) || coalesce(:old_id_currency, '@{pms.contract_expense_type.' || :old_contract_expense_type || '}') ||
                        f_character(28) || formatfloat(:old_service_price, '0.00') ||
                        f_character(28) || '@{pms.is_acc_post_item.' || :is_acc_post_item || '}' ||
                        f_character(28) || '@{pms.multiplier_type.' || :multiplier_type || '}' ||
                        f_character(28) || coalesce(:id_currency, '@{pms.contract_expense_type.' || :contract_expense_type || '}') ||
                        f_character(28) || formatfloat(:service_price, '0.00') from 1 for 255);
          execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_SERV_CHANG', :ACTION_TEXT);
        end
      end
    end else if (:OPERATION = 'del') then begin
      action_text = substring(f_character(29) || :contract_acc || f_character(28) || :old_order_tag || f_character(28) || :old_service_name ||
                      f_character(28) || '@{pms.is_acc_post_item.' || :old_is_acc_post_item || '}' ||
                      f_character(28) || '@{pms.multiplier_type.' || :old_multiplier_type || '}' ||
                      f_character(28) || coalesce(:old_id_currency, '@{pms.contract_expense_type.' || :old_contract_expense_type || '}') ||
                      f_character(28) || formatfloat(:old_service_price, '0.00') from 1 for 255);
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_SERV_DEL', :ACTION_TEXT);

      delete from CONTRACT_EXPENSE$PMS
      where (ID_CONTRACT_EXPENSE = :ID_CONTRACT_EXPENSE);
    end
  end
end
^

/* Restore proc. body: CONTRACT_MANAGEMENT_MODIFY$PMS */
ALTER PROCEDURE CONTRACT_MANAGEMENT_MODIFY$PMS(ID_CONTRACT_MANAGEMENT TYPE OF ID,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
ID_SERVICE TYPE OF ID,
MIN_VALUE TYPE OF TPRICE,
MIN_VALUE_CURR TYPE OF TCURRENCY,
MAX_VALUE TYPE OF TPRICE,
MAX_VALUE_CURR TYPE OF TCURRENCY,
NIGHT_PRICE TYPE OF TPRICE,
NIGHT_PRICE_CURR TYPE OF TCURRENCY,
IS_NETO TYPE OF TLOGICAL,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_MANAGEMENT TYPE OF ID)
 AS
declare variable is_use smallint;
  declare variable formula varchar(100);
  declare variable contract_acc varchar(50);
  declare variable id_room_contract integer;
  declare variable service_name varchar(30);
  declare variable old_id_contract integer;
  declare variable old_service_name varchar(30);
  declare variable old_min_value numeric(15,4);
  declare variable old_min_value_curr varchar(3);
  declare variable old_max_value numeric(15,4);
  declare variable old_max_value_curr varchar(3);
  declare variable old_night_price numeric(15,4);
  declare variable old_night_price_curr varchar(3);
  declare variable is_commision_service smallint;
  declare variable old_is_commision_service smallint;
  declare variable action_text varchar(255);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  formula = '';
  is_use = 1;

  select SE.SERVICE_NAME, iif(se.SERVICE_TYPE = 'COMMISSION', 0, 1) --SE.IS_ACC_POST_ITEM
  from   SERVICES SE
  where  SE.ID_SERVICE = :ID_SERVICE
  into   :service_name, :is_commision_service;

  if (:OPERATION = 'add') then begin
    /*select case
              when :ID_CONTRACT = RCP.ID_CONTRACT_GUEST then '@{pms.contract_base_account}'
              when :ID_CONTRACT = RCP.ID_CONTRACT_OWNER then '@{pms.contract_owner_use}'
              else  '@{pms.contract_shadow_account}'
           end as CONTRACT_ACC,
           RCP.ID_ROOM_CONTRACT
    from   ROOM_CONTRACT$PMS RCP
    where  :ID_CONTRACT in (RCP.ID_CONTRACT_GUEST, RCP.ID_CONTRACT_OWNER, RCP.ID_CONTRACT_SHADOW)
    into   :contract_acc, :id_room_contract; */
    id_room_contract = :ID_CONTRACT;
    contract_acc = case
                     when :SUB_CONTRACT = 'GUEST_USE' then '@{pms.contract_base_account}'
                     when :SUB_CONTRACT = 'OWNER_USE' then '@{pms.contract_owner_use}'
                     when :SUB_CONTRACT = 'SHADOW_ACC' then '@{pms.contract_shadow_account}'
                     else 'N/A'
                   end;

    new_id_contract_management = gen_id(GEN_CONTRACT_MANAGEMENT$PMS_ID, 1);
    insert into CONTRACT_MANAGEMENT$PMS (ID_CONTRACT_MANAGEMENT, ID_CONTRACT, SUB_CONTRACT,
           MIN_VALUE, MIN_VALUE_CURR, MAX_VALUE, MAX_VALUE_CURR,
           NIGHT_PRICE, NIGHT_PRICE_CURR, FORMULA, IS_NETO, IS_USE, ID_SERVICE)
    values (:new_id_contract_management, :ID_CONTRACT, :SUB_CONTRACT,
           :MIN_VALUE, :MIN_VALUE_CURR, :MAX_VALUE, :MAX_VALUE_CURR,
           :NIGHT_PRICE, :NIGHT_PRICE_CURR, :FORMULA, :IS_NETO, :IS_USE, :ID_SERVICE);

    action_text = f_character(29) || :contract_acc || f_character(28) ||
                  iif(:is_commision_service = 0, '@{word.commission}' || ' ' ||'@{word.the_service}' || ' ' || :service_name, :service_name) || f_character(28) ||
                  iif(:min_value is null, '', formatfloat(min_value, '0.00')) ||
                  iif(:max_value is null, '', formatfloat(max_value, '0.00')) ||
                  iif(:night_price is null, '', formatfloat(night_price, '0.00')) || f_character(28) ||
                  coalesce(min_value_curr, '') ||
                  coalesce(max_value_curr, '') || coalesce(night_price_curr, '');
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_KOM_SERV_ADD', :ACTION_TEXT);

  end else begin
    /*select CMP.ID_CONTRACT, CMP.MIN_VALUE, CMP.MIN_VALUE_CURR, CMP.MAX_VALUE, CMP.MAX_VALUE_CURR,
           CMP.NIGHT_PRICE, CMP.NIGHT_PRICE_CURR, SE.SERVICE_NAME, SE.IS_ACC_POST_ITEM,
           case
              when CMP.ID_CONTRACT = RCP.ID_CONTRACT_GUEST then '@{pms.contract_base_account}'
              when CMP.ID_CONTRACT = RCP.ID_CONTRACT_OWNER then '@{pms.contract_owner_use}'
              else  '@{pms.contract_shadow_account}'
           end as CONTRACT_ACC,
           RCP.ID_ROOM_CONTRACT
    from   CONTRACT_MANAGEMENT$PMS CMP
           join SERVICES SE on SE.ID_SERVICE = CMP.ID_SERVICE
           join ROOM_CONTRACT$PMS RCP on CMP.ID_CONTRACT in (RCP.ID_CONTRACT_GUEST, RCP.ID_CONTRACT_OWNER, RCP.ID_CONTRACT_SHADOW)
    where  CMP.ID_CONTRACT_MANAGEMENT = :ID_CONTRACT_MANAGEMENT
    into   :old_id_contract, :old_min_value, :old_min_value_curr, :old_max_value, :old_max_value_curr,
           :old_night_price, :old_night_price_curr, :old_service_name, :old_is_commision_service, :contract_acc, :id_room_contract;*/
    select CMP.ID_CONTRACT, CMP.MIN_VALUE, CMP.MIN_VALUE_CURR, CMP.MAX_VALUE, CMP.MAX_VALUE_CURR,
           CMP.NIGHT_PRICE, CMP.NIGHT_PRICE_CURR, SE.SERVICE_NAME, iif(se.SERVICE_TYPE = 'COMMISSION', 0, 1), --SE.IS_ACC_POST_ITEM,
           case
             when CMP.SUB_CONTRACT = 'GUEST_USE' then '@{pms.contract_base_account}'
             when CMP.SUB_CONTRACT = 'OWNER_USE' then '@{pms.contract_owner_use}'
             when CMP.SUB_CONTRACT = 'SHADOW_ACC' then '@{pms.contract_shadow_account}'
             else 'N/A'
           end as CONTRACT_ACC,
           CMP.ID_CONTRACT
    from   CONTRACT_MANAGEMENT$PMS CMP
           join SERVICES SE on SE.ID_SERVICE = CMP.ID_SERVICE
    where  CMP.ID_CONTRACT_MANAGEMENT = :ID_CONTRACT_MANAGEMENT
    into   :old_id_contract, :old_min_value, :old_min_value_curr, :old_max_value, :old_max_value_curr,
           :old_night_price, :old_night_price_curr, :old_service_name, :old_is_commision_service, :contract_acc, :id_room_contract;

    if (:OPERATION = 'mod') then begin
      update CONTRACT_MANAGEMENT$PMS
      set    -- ID_CONTRACT = :ID_CONTRACT,
             MIN_VALUE = :MIN_VALUE,
             MIN_VALUE_CURR = :MIN_VALUE_CURR,
             MAX_VALUE = :MAX_VALUE,
             MAX_VALUE_CURR = :MAX_VALUE_CURR,
             NIGHT_PRICE = :NIGHT_PRICE,
             NIGHT_PRICE_CURR = :NIGHT_PRICE_CURR,
             FORMULA = :FORMULA,
             IS_NETO = :IS_NETO,
             IS_USE = :IS_USE,
             ID_SERVICE = :ID_SERVICE
      where (ID_CONTRACT_MANAGEMENT = :ID_CONTRACT_MANAGEMENT);

      if ((:old_id_contract <> :id_contract) or (coalesce(:old_min_value, 0) <> coalesce(:min_value, 0)) or
          (coalesce(:old_min_value_curr, ' ') <> coalesce(:min_value_curr, ' ')) or
          (coalesce(:old_max_value, 0) <> coalesce(:max_value, 0)) or
          (coalesce(:old_max_value_curr, ' ') <> coalesce(:max_value_curr, ' ')) or
          (coalesce(:old_night_price, 0) <> coalesce(:night_price, 0)) or
          (coalesce(:old_night_price_curr, ' ') <> coalesce(:night_price_curr, ' ')) or
          (:is_commision_service <> :old_is_commision_service) or
          (coalesce(:service_name, ' ') <> coalesce(:old_service_name, ' '))) then begin
        action_text = f_character(29) || :contract_acc || f_character(28) ||
                      iif(:old_is_commision_service = 0, '@{word.commission}' || ' ' ||'@{word.the_service}' || ' ' || :old_service_name, :old_service_name) || f_character(28) ||
                      iif(:old_min_value is null, '', formatfloat(:old_min_value, '0.00')) ||
                      iif(:old_max_value is null, '', formatfloat(:old_max_value, '0.00')) ||
                      iif(:old_night_price is null, '', formatfloat(:old_night_price, '0.00')) || f_character(28) ||
                      coalesce(old_min_value_curr, '') ||
                      coalesce(old_max_value_curr, '') || coalesce(old_night_price_curr, '') ||
                      f_character(28) ||
                      iif(:is_commision_service = 0, '@{word.commission}' || ' ' ||'@{word.the_service}' || ' ' || :service_name, :service_name) || f_character(28) ||
                      iif(:min_value is null, '', formatfloat(:min_value, '0.00')) ||
                      iif(:max_value is null, '', formatfloat(:max_value, '0.00')) ||
                      iif(:night_price is null, '', formatfloat(:night_price, '0.00')) || f_character(28) || coalesce(min_value_curr, '') ||
                      coalesce(max_value_curr, '') || coalesce(night_price_curr, '');
        execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_KOM_SERV_CHANG', :ACTION_TEXT);
      end
    end else if (:OPERATION = 'del') then begin
      action_text = f_character(29) || coalesce(:contract_acc, '') || f_character(28) ||
                    iif(:old_is_commision_service = 0, '@{word.commission}' || ' ' ||'@{word.the_service}' || ' ' || :old_service_name, :old_service_name) || f_character(28) ||
                    iif(:old_min_value is null, '', formatfloat(:old_min_value, '0.00')) ||
                    iif(:old_max_value is null, '', formatfloat(:old_max_value, '0.00')) ||
                    iif(:old_night_price is null, '', formatfloat(:old_night_price, '0.00')) || f_character(28) || coalesce(old_min_value_curr, '') ||
                    coalesce(old_max_value_curr, '') || coalesce(old_night_price_curr, '');
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_KOM_SERV_DEL', :ACTION_TEXT);

      delete from CONTRACT_MANAGEMENT$PMS
      where (ID_CONTRACT_MANAGEMENT = :ID_CONTRACT_MANAGEMENT);
    end
  end
end
^

/* Restore proc. body: CURR_RATE_MODIFY */
ALTER PROCEDURE CURR_RATE_MODIFY(CURR CHAR(3),
ID_HOTEL INTEGER,
RATE NUMERIC(15,6),
FOR_DATE DATE = null)
 AS
declare variable ap_dbkey char(8);
  declare variable guest_posting_rate varchar(20);
  declare variable from_date date;
  declare variable cr_dbkey char(8);
  declare variable old_rate numeric(15,6);
  declare variable id_curr_rate integer;
  declare variable hotel_name varchar(50);
  declare variable action_text varchar(255);
  declare variable nation_curr tcurrency;
begin
  for_date = coalesce(:FOR_DATE, current_date);

  select h.HOTEL_NAME, h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :ID_HOTEL
  into   :hotel_name, :nation_curr;

  if (:nation_curr = :CURR and :RATE <> 1) then exception ASSERT '-35';

  select cr.RDB$DB_KEY, cr.CURR_RATE
  from   CURR_RATES CR
  where  CR.CURR = :CURR
         and cr.ID_HOTEL = :ID_HOTEL
         and cr.DATE_ = :FOR_DATE
  into   :cr_dbkey, :old_rate;

  if (:old_rate is null) then begin
    insert into CURR_RATES (CURR, ID_HOTEL, DATE_, CURR_RATE)
    values (:CURR, :ID_HOTEL, :FOR_DATE, :RATE)
    returning ID_CURR_RATE into :id_curr_rate;

    select first 1 r.CURR_RATE
    from   CURR_RATES r
    where  r.ID_HOTEL = :ID_HOTEL
           and r.CURR = :CURR
           and r.DATE_ < :FOR_DATE
    order by r.DATE_ desc
    into   :old_rate;

  end else if (:old_rate <> :RATE) then begin
    update CURR_RATES r
    set    r.CURR_RATE = :RATE
    where  r.RDB$DB_KEY = :cr_dbkey;
  end else begin
    exit;
  end

  action_text = f_character(29) || :hotel_name || f_character(28)
                || formatdate(:FOR_DATE, 'D;dd.mm.yyyy') || f_character(28)
                || coalesce(:old_rate, 'N/A') || f_character(28)
                || coalesce(:RATE, 'N/A');

  execute procedure SYSTEM_LOG_ADD ('CURRENCY', :id_curr_rate, 'RATE_CHANGED', :action_text, :RATE);

  if (:old_rate is not null) then begin   -- this is not first, initial rate
    /* CHANGE THE CURRENR_RATE OF THE OPEN POSTINGS */
    execute procedure SETTING_GET_VALUE('GUEST_POSTING_RATE', :ID_HOTEL)
    returning_values  :guest_posting_rate;
  
    for
      select AP.rdb$db_key, G.FROM_DATE
      from   ACCOUNT_POST AP
             join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
             left outer join GUEST G on G.ID_GUEST = AP.ID_GUEST
      where  ((AP.CURR_POST = :CURR) or (AP.CURR_ORIG = :CURR))
             and AP.AC = '00'
             and AP.ID_BASE_DOC is null
             and AP.DATE_POST >= current_date
             and A.ID_HOTEL = :ID_HOTEL
      into   :ap_dbkey, :from_date
    do begin
      if (:guest_posting_rate = 'CHECKIN_DATE' and :from_date < current_date) then begin
        /* Do nothing. Theese postings are by guest check_in date rate,
        || which is not changing now
        */
      end else begin
        execute procedure ACCOUNT_POSTING_UPDATE_RATE$INT (:ap_dbkey, :CURR, :RATE);
      end
    end
  end
end
^

/* Restore proc. body: DEPOSIT_ANUL$INT */
ALTER PROCEDURE DEPOSIT_ANUL$INT(ID_DEPOSIT INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_PAYMENT_HEAD INTEGER)
 AS
declare variable id_doc_head integer;
  declare variable id_account integer;
  declare variable deposit_init_amount numeric(15,4);
  declare variable avail_value numeric(15,4);
  declare variable pay_currency varchar(3);
  declare variable payment_date date;
  declare variable dep_current_value numeric(15,4);
  declare variable sys_date date;
  declare variable id_hotel integer;
begin
  select D.ID_PAYMENT_HEAD, D.ID_ACCOUNT, P.PAY_VALUE_A, P.PAYMENT_DATE,
         D.RECEIVED_AMOUNT - d.DEDUCTED_AMOUNT as AVAIL_VALUE, D.ID_DOC_HEAD,
         D.PAY_CURRENCY, D.RECEIVED_AMOUNT
  from   DEPOSITS D
         join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_payment_head, :id_account, :deposit_init_amount, :payment_date,
         :avail_value, :id_doc_head, :pay_currency, :dep_current_value;

  if ((:dep_current_value is null) or (:dep_current_value < :deposit_init_amount)) then
    exception PAYMENT_ANNUL_EXCEPTION '-369';
    --'Part of deposit is refunded or transfered';

  if ((:avail_value is null) or (:avail_value < :deposit_init_amount)) then
    exception PAYMENT_ANNUL_EXCEPTION '-350';
    --'Part of deposit is used into document.';

  if (:id_doc_head is not null) then
    exception PAYMENT_ANNUL_EXCEPTION '-351';
    --'Can not storno deposit, because has invoice for it. First - storno invoice.';

  select A.ID_HOTEL
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :id_hotel;

  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) SD
  into   :SYS_DATE;

  if (:sys_date > :payment_date) then
    exception PAYMENT_ANNUL_EXCEPTION '-349';
    -- Can not void deposit payment for previous date ! May refund it! It's very important for payments control!!!

  execute procedure PAYMENT_ANUL$INT (:ID_PAYMENT_HEAD, :DESCRIPTION);

  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'ANNUL', f_character(29) || formatfloat(:deposit_init_amount, 'F;0.00') || ' ' || :PAY_CURRENCY || f_character(28) || :DESCRIPTION);

end
^

/* Restore proc. body: DEPOSIT_NEW$DOC */
ALTER PROCEDURE DEPOSIT_NEW$DOC(ID_ACCOUNT INTEGER,
ID_DOC_TYPE INTEGER,
PAY_VALUE NUMERIC(15,4),
PAY_CURRENCY VARCHAR(3),
DESCRIPTION VARCHAR(100),
ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_DEPOSIT INTEGER,
ID_PAYMENT_HEAD INTEGER)
 AS
declare variable pay_rate numeric(15,6);
  declare variable payment_date date;
  declare variable is_taxable smallint;
  declare variable id_profile integer;
  declare variable dbkey char(8);
  declare variable acc_curr varchar(3);
  declare variable acc_rate numeric(15,6);
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable id_account_payment integer;
  declare variable is_posting_stopped integer;
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_NEW');

  select r.IS_POSTING_STOPPED
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :is_posting_stopped;

  if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';

  select A.ID_PROFILE, A.ACCOUNT_CURR, A.ID_HOTEL
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :id_profile, :acc_curr, :id_hotel;

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values  (:payment_date);

  execute procedure CURR_RATE_GET (:acc_curr, :payment_date, :id_hotel)
  returning_values  (:acc_rate);

  execute procedure CURR_RATE_GET (:PAY_CURRENCY, :payment_date, :id_hotel)
  returning_values  (:pay_rate);

  execute procedure PAYMENT_CREATE$INT (:ID_DOC_TYPE, :ID_ACCOUNT, :payment_date,
                    :PAY_VALUE, :PAY_CURRENCY, :pay_rate,
                    :acc_curr, :acc_rate, :DESCRIPTION)
  returning_values  :id_payment_head, :id_account_payment, :is_taxable;

  ID_DEPOSIT = gen_id(GEN_DEPOSITS_ID, 1);
  insert into DEPOSIT (ID_DEPOSIT, DESCRIPTION, ID_ACCOUNT, ID_PAYMENT_HEAD, ID_PROFILE, ID_RESERV_DETAIL)
  values (:ID_DEPOSIT, :DESCRIPTION, :ID_ACCOUNT, :ID_PAYMENT_HEAD, :id_profile, :id_reserv_detail);

  select PH.RDB$DB_KEY
  from   PAYMENT_HEAD PH
  where  PH.ID_PAYMENT_HEAD = :id_payment_head
  into   :dbkey;

  update PAYMENT_HEAD P
  set    p.ID_DEPOSIT = :ID_DEPOSIT
  where  p.RDB$DB_KEY = :dbkey;

  update ACCOUNT_PAYMENTS AP
  set    AP.ID_DEPOSIT = :ID_DEPOSIT
  where  ap.ID_ACCOUNT_PAYMENT = :id_account_payment;

  execute procedure PAYMENT_SET_NUMBER$INT(:dbkey);

  action_text = f_character(29) || formatfloat(:PAY_VALUE, 'F;0.00') || ' ' || :PAY_CURRENCY;
  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'CREATE', :action_text);

end
^

/* Restore proc. body: DEPOSIT_REFUND_PAY_ANNUL$INT */
ALTER PROCEDURE DEPOSIT_REFUND_PAY_ANNUL$INT(ID_REFUND_PAYMENT INTEGER,
ANNUL_REASON VARCHAR(255) = '')
 AS
declare variable id_deposit integer;
  declare variable pay_value numeric(15,4);
  declare variable pay_curr varchar(3);
  declare variable id_hotel integer;
  declare variable sys_date date;
  declare variable payment_date date;
begin
  select ap.ID_DEPOSIT, P.PAY_CURRENCY, a.ID_HOTEL, p.PAYMENT_DATE, coalesce(sum(aP.PAY_AMOUNT), 0)
  from   PAYMENT_HEAD P
         join ACCOUNT A on a.ID_ACCOUNT = p.ID_ACCOUNT
         join ACCOUNT_PAYMENTS ap on ap.ID_PAYMENT_HEAD = p.ID_PAYMENT_HEAD
  where  P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT
  group by P.ID_PAYMENT_HEAD, ap.ID_DEPOSIT, P.PAY_CURRENCY, a.ID_HOTEL, p.PAYMENT_DATE
  into   :id_deposit, :pay_curr, :id_hotel, :payment_date, :pay_value;
  /* !!! - check if is real deposit refund */
  if (:id_deposit is null) then EXIT;

  if (:pay_value = 0) then exception PAYMENT_EXCEPTION 'Zero payment amount!';
  /*  */
  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) SD
  into   :sys_date;

  if (:sys_date > :payment_date) then
    exception PAYMENT_ANNUL_EXCEPTION '-349';
    -- Can not void deposit payment for previous date ! May refund it! It's very important for payments control!!!

  execute procedure PAYMENT_ANUL$INT(:ID_REFUND_PAYMENT, :ANNUL_REASON);

  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'REFUND_ANNUL', f_character(29) || formatfloat(:pay_value, 'F;0.00') || ' ' || :pay_curr || f_character(28) || :ANNUL_REASON);

end
^

/* Restore proc. body: DEPOSIT_TRANSFER$INT */
ALTER PROCEDURE DEPOSIT_TRANSFER$INT(ID_DEPOSIT TYPE OF ID,
ID_DEST_ACCOUNT TYPE OF ID,
SPLIT_AMOUNT TYPE OF TPRICE,
DEPOSIT_DESCRIPTION TYPE OF TDESCRIPTION_SHORT,
TRANSFER_REASON TYPE OF TREASON = null)
 RETURNS(NEW_ID_DEPOSIT TYPE OF ID)
 AS
declare variable id_source_account integer;
  declare variable id_payment_head integer;
  declare variable doc_selected integer;
  declare variable id_profile integer;
  declare variable orig_descr varchar(100);
  declare variable action_text varchar(255);
  declare variable pay_currency varchar(3);
  declare variable curr_dest varchar(3);
  declare variable pay_date date;
  declare variable dest_acc_rate numeric(15,6);
  declare variable is_anul integer;
  declare variable sys_date date;
  declare variable id_reserv_detail integer;
  declare variable id_hotel integer;
  declare variable pay_rate numeric(15,6);
  declare variable id_account_payment_src integer;
  declare variable id_account_payment_dest integer;
  declare variable is_posting_stopped integer;
  declare variable id_system_log integer;
begin

  select D.ID_ACCOUNT, D.ID_PAYMENT_HEAD, D.DOC_SELECTED, D.ID_PROFILE, D.DESCRIPTION,
         P.PAY_CURRENCY, P.IS_ANUL, P.PAYMENT_DATE, D.ID_RESERV_DETAIL, A.ID_HOTEL, p.PAY_RATE
  from   DEPOSIT D
         join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_source_account, :id_payment_head, :doc_selected, :id_profile, :orig_descr,
         :pay_currency, :is_anul, :pay_date, :id_reserv_detail, :id_hotel, :pay_rate;

  if (:is_anul = 1) then
    exception PAYMENT_EXCEPTION '-355'; -- payment is annul

  select r.IS_POSTING_STOPPED
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :is_posting_stopped;

  if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';

  if (not exists (select A.ID_ACCOUNT
                  from   ACCOUNT A
                  where  A.ID_ACCOUNT = :ID_DEST_ACCOUNT
                         and A.ID_HOTEL = :id_hotel)) then exception ACCOUNT_EXCEPTION '-376';

  if (coalesce(:DEPOSIT_DESCRIPTION, '') = '') then DEPOSIT_DESCRIPTION = :orig_descr;

  select A.ACCOUNT_CURR
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_DEST_ACCOUNT
  into   :curr_dest;
   
  execute procedure CURR_RATE_GET(:curr_dest, :pay_date, :id_hotel)
  returning_values  :dest_acc_rate;

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values :sys_date;

  insert into ACCOUNT_PAYMENTS (ID_ACCOUNT, ID_PAYMENT_HEAD, PAY_AMOUNT, PAY_RATE,
         ACC_AMOUNT, ACC_RATE, TRANSACTION_DATE, ID_DEPOSIT)
  values (:id_source_account, :id_payment_head, -:SPLIT_AMOUNT, :pay_rate,
         -:SPLIT_AMOUNT * cast(:pay_rate / :dest_acc_rate as double precision), :dest_acc_rate,
         :sys_date, :ID_DEPOSIT)
  returning id_account_payment into :id_account_payment_src;

  NEW_ID_DEPOSIT = gen_id(GEN_DEPOSITS_ID, 1);
  insert into DEPOSIT (ID_DEPOSIT, DESCRIPTION, ID_ACCOUNT, ID_PAYMENT_HEAD, DOC_SELECTED, ID_PROFILE, ID_RESERV_DETAIL)
  values (:NEW_ID_DEPOSIT, :DEPOSIT_DESCRIPTION, :ID_DEST_ACCOUNT, :id_payment_head, :doc_selected, :id_profile, :id_reserv_detail);

  insert into ACCOUNT_PAYMENTS (ID_ACCOUNT, ID_PAYMENT_HEAD, PAY_AMOUNT, PAY_RATE,
         ACC_AMOUNT, ACC_RATE, TRANSACTION_DATE, ID_DEPOSIT)
  values (:ID_DEST_ACCOUNT, :id_payment_head, :SPLIT_AMOUNT, :pay_rate,
         :SPLIT_AMOUNT * cast(:pay_rate / :dest_acc_rate as double precision), :dest_acc_rate,
         :sys_date, :NEW_ID_DEPOSIT)
  returning id_account_payment into :id_account_payment_dest;

  action_text = f_character(29) || :id_source_account ||
                f_character(28) || :id_dest_account ||
                f_character(28) || formatfloat(:split_amount, '0.00') || ' ' || :pay_currency ||
                f_character(28) || coalesce(:TRANSFER_REASON, '');
  execute procedure SYSTEM_EVENT_LOG$INT ('DEPOSIT', :ID_DEPOSIT, 'TRANSFER', :ACTION_TEXT)
  returning_values :id_system_log;

  insert into ACCOUNT_PAYMENT_TRANSFER (ID_ACCOUNT_PAYMENT_SOURCE, ID_ACCOUNT_PAYMENT_DEST, ID_SYSTEM_LOG)
  values (:id_account_payment_src, :id_account_payment_dest, :id_system_log);

end
^

/* Restore proc. body: DOCUMENT_ANUL$DOC */
ALTER PROCEDURE DOCUMENT_ANUL$DOC(ID_DOC_HEAD INTEGER,
ANUL_REASON VARCHAR(100),
MAKE_ANNUL_REPORT SMALLINT)
 AS
/**/
  declare variable id_account  integer;
  declare variable id_payment_head integer;
  declare variable for_deposit integer;
  declare variable id_base_doc integer;
  declare variable is_anul integer;
  declare variable dh_dbkey char(8);
  declare variable id_annul_protocol_num integer;
  declare variable num integer;
  declare variable doc_num varchar(20);
  declare variable system_date date;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable doc_date date;
  declare variable id_system_log integer;
  declare variable id_hotel integer;
  declare variable is_storno_doc integer;
  declare variable doc_direction smallint;
  declare variable is_storno_pay smallint;
  declare variable no_use integer;
begin

  select H.RDB$DB_KEY, H.ID_ACCOUNT, H.FOR_DEPOSIT, H.ID_BASE_DOC, H.IS_ANUL, A.ID_HOTEL,
         A.ID_RESERV_DETAIL, T.ID_ANNUL_DOC_NUM, h.DOC_DATE, H.IS_STORNO
  from   DOC_HEAD$INT H
         join DOC_COMPLETION dc on dc.ID_DOC_HEAD = h.ID_DOC_HEAD
         join DOC_TYPE T on H.ID_DOC_TYPE = T.ID_DOC_TYPE
         join DOC_TYPE_INV DTI on DTI.ID_DOC_TYPE = T.ID_DOC_TYPE
         join ACCOUNT A on A.ID_ACCOUNT = H.ID_ACCOUNT
  where  H.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :dh_dbkey, :id_account, :for_deposit, :id_base_doc, :is_anul, :id_hotel,
         :id_reserv_detail, :id_annul_protocol_num, :doc_date, :is_storno_doc;

  if (:is_anul = 1) then
    exception DOCUMENT_ANNUL_EXCEPTION '-352'; --'Document is already annul';

  if (exists (select D.ID_DOC
              from   DOC_HEAD D
              where  D.ID_BASE_DOC = :ID_BASE_DOC
                     and D.ID_DOC > :ID_DOC_HEAD
                     and D.IS_ANUL = 0))
  then exception DOCUMENT_ANNUL_EXCEPTION '-314';

  execute procedure SYSTEM_DATE_GET(:ID_HOTEL)
  returning_values  :system_date;

  if (:DOC_DATE < :SYSTEM_DATE) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_PREV_DATE');
  end
  /* unarchive account and set as credit account, for shecked out bookings only */
  execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:ID_ACCOUNT, 0);

  if (:ID_RESERV_DETAIL is not null) then begin
    select RD.CHECK_STATUS
    from   RESERV_DETAIL RD
    where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :check_status;

    if (:check_status = 1) then begin
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, null, 1);
    end
  end
  /* MARK THE DOCUMENT AS ANUL - before posting and payment updates */
  update DOC_HEAD$INT DH
  set    DH.IS_ANUL = 1
  where  DH.RDB$DB_KEY = :dh_dbkey;

  update DOC_COMPLETION Dc
  set    Dc.IS_EFAKTURA_EXPORTED = 0
  where  Dc.ID_DOC_HEAD = :ID_DOC_HEAD;


  if (:is_storno_doc = 1) then begin
    /* annul storno doc */
    update DOC_HEAD$INT BD
    set    BD.IS_STORNED = 0
    where  BD.ID_DOC_HEAD = :id_base_doc
           and BD.IS_STORNED = 1;
  end
  /* RELEASE ACCOUNT_POSTS */
  if (:for_deposit = 0) then
    execute procedure ACCOUNT_POSTING_DOC_UPDATE$INT (:DH_DBKEY)
    returning_values (:no_use);

  /* PAYMENTS REFLECTION */
  for
    select PH.ID_PAYMENT_HEAD, dt.DOC_DIRECTION, ph.IS_STORNO
    from   PAYMENT_HEAD PH
           join DOC_TYPE_PAY dt on dt.ID_DOC_TYPE = ph.ID_DOC_TYPE
    where  PH.ID_DOC_HEAD = :ID_DOC_HEAD
           and PH.IS_STORNED = 0
    into   :ID_PAYMENT_HEAD, :doc_direction, :is_storno_pay
  do begin

    execute procedure PAYMENT_ANUL$INT (:ID_PAYMENT_HEAD, :ANUL_REASON);
  end

  /* ANNUL_PROTOCOL creating section */
  NUM = null;
  DOC_NUM = null;
  if (:MAKE_ANNUL_REPORT = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_WITH_PROT');

    if (:ID_ANNUL_PROTOCOL_NUM is null) then exception DOCUMENT_ANNUL_EXCEPTION '-345';

    execute procedure SYSTEM_GEN_NUM ('DOCUMENT', :ID_ANNUL_PROTOCOL_NUM)
    returning_values  (:num, :doc_num);
  end
  /* log annul event */
  execute procedure SYSTEM_EVENT_LOG$INT ('DOCUMENT', :ID_DOC_HEAD, 'ANNUL', f_character(29)||:ANUL_REASON)
  returning_values  :id_system_log;

  insert into DOC_ANNULMENT (ID_DOC_HEAD, ANNULMENT_DATE, ID_PROT_DOC_NUM, PROT_NUM, PROT_DOC_NUM, ID_LOG_EVENT)
  values (:ID_DOC_HEAD, :SYSTEM_DATE, :ID_ANNUL_PROTOCOL_NUM, :NUM, :DOC_NUM, :ID_SYSTEM_LOG);
  /* reflect annul date on doc release dates */
  if (:DOC_DATE < :SYSTEM_DATE) then begin
    insert into DOC_RELEASE_DATE (ID_DOC_HEAD, RELEASE_DATE, VALUE_CORR_INDEX)
    values (:ID_DOC_HEAD, :SYSTEM_DATE, -1);
  end else begin
    update DOC_RELEASE_DATE RD
    set    RD.VALUE_CORR_INDEX = 0
    where  RD.ID_DOC_HEAD = :ID_DOC_HEAD
           and RD.RELEASE_DATE = :DOC_DATE;
  end
  /* reflect on AR module */
  execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT (:DH_DBKEY, null, 1, :ANUL_REASON);
  /* reflect on client loyalty module */
  execute procedure DOCUMENT_BONUSPOINTS_VOID$CL (:ID_DOC_HEAD);

end
^

/* Restore proc. body: DOCUMENT_DELETE$DOC */
ALTER PROCEDURE DOCUMENT_DELETE$DOC(ID_DOC_HEAD INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_account_post integer;
  declare variable id_doc integer;
  declare variable doc_num varchar(20);
  declare variable doc_type_name varchar(50);
  declare variable doc_date date;
  declare variable action_text varchar(255);
  declare variable id_base_doc integer;
  declare variable id_doc_num integer;
  declare variable num_dbkey char(8);
  declare variable doc_dbkey char(8);
  declare variable last_num integer;
  declare variable num integer;
  declare variable id_doc_line integer;
  declare variable for_deposit smallint;
begin

  select DH.ID_BASE_DOC
  from   DOC_HEAD$INT DH
  where  DH.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :id_base_doc;

  if (:id_base_doc is distinct from :ID_DOC_HEAD) then exception DOCUMENT_EXCEPTION '-342'; /* base doc is not selected to delete */

  for
    select D.ID_DOC_NUM, D.ID_DOC_HEAD, D.DOC_NUM, D.NUM, D.DOC_TYPE_NAME, D.DOC_DATE
    from   DOC_HEAD$INT D
    where  D.ID_BASE_DOC = :ID_DOC_HEAD
    order by D.ID_DOC_NUM asc, D.ID_DOC_HEAD desc
    into   :id_doc_num, :id_doc, :doc_num, :num, :doc_type_name, :doc_date
  do begin
    for
      select PV.ID_ACCOUNT_POST
      from   DOC_LINE dl
             join DOC_LINE_POST_VALUES pv on PV.ID_DOC_LINE = dl.ID_DOC_LINE
      where  DL.ID_DOC_HEAD = :id_doc
      order by Dl.ID_DOC_LINE desc
      into   :id_account_post
    do begin
      update ACCOUNT_POST AP
      set    AP.IN_DOC_QTY = 0,
             AP.IN_DOC_VALUE = 0,
             AP.AC = iif(AP.QTY_POST = 0, '10', '00'),
             AP.IS_ANUL = iif(AP.QTY_POST = 0, 1, 0),
             AP.ID_BASE_DOC = null
      where  AP.ID_ACCOUNT_POST = :id_account_post
             and AP.ID_BASE_DOC = :ID_DOC_HEAD;
    end
    /*   */
    action_text = f_character(29) || :doc_type_name || ' ' || :doc_num || '/' || formatdate(:doc_date, 'D;dd.mm.yyyy');
    execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :id_doc, 'DELETE', :action_text);

    /*ar*/
    select DH.RDB$DB_KEY, dh.FOR_DEPOSIT
    from   DOC_HEAD$INT DH
    where  DH.ID_DOC_HEAD = :id_doc
    into   :doc_dbkey, :for_deposit;

    execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT(:doc_dbkey, 'anul', 1, null);
    /*end ar*/
    if (:for_deposit = 1) then begin
      for
        select dl.ID_DOC_LINE
        from   DOC_LINE dl
        where  dl.ID_DOC_HEAD = :id_doc
        into   :id_doc_line
      do begin
        delete from DOC_LINE_DEP_VALUES dv
        where  dv.ID_DOC_LINE = :id_doc_line;
      end 
    end

    delete from PAYMENT_HEAD P
    where  P.ID_DOC_HEAD = :id_doc;

    delete from DOC_HEAD$INT dh
    where  dh.ID_DOC_HEAD = :id_doc;

    -- reset numerator if deleted document is the last
    select coalesce(max(d.NUM), 0)
    from   DOC_HEAD D
    where  D.ID_DOC_NUM = :id_doc_num
    into   :last_num;

    if (:last_num < :num) then begin
      select SN.RDB$DB_KEY
      from   SYSTEM_NUMERATOR SN
      where  SN.ID_NUMERATOR = :id_doc_num
      into   :num_dbkey;
  
      execute procedure SYSTEM_GEN_NUM$INT (:num_dbkey, :last_num)
      returning_values  (:dbg);
--        if (:err_code <> 0) then exception NUMERATOR_EXCEPTION;
    end

  end
  /*   */
  /* paranoid check  */
  if (exists (select d.ID_DOC_HEAD
              from   DOC_HEAD$INT d
              where  d.id_base_doc = :id_base_doc)) then exception DOCUMENT_EXCEPTION '-318';
end
^

/* Restore proc. body: DOCUMENT_PRENUMERATE$DOC */
ALTER PROCEDURE DOCUMENT_PRENUMERATE$DOC(SELECTION_ID INTEGER)
 AS
declare variable id_doc_num integer;
  declare variable last_num integer;
  declare variable old_doc_num varchar(20);
  declare variable doc_num varchar(20);
  declare variable tmp_id_doc integer;
  declare variable action_text varchar(255);
  declare variable num_dbkey char(8);
begin
  for
    select SN.ID_NUMERATOR, SN.RDB$DB_KEY, min(DH.NUM)
    from   DOC_HEAD DH
           join SYSTEM_NUMERATOR SN on SN.ID_NUMERATOR = DH.ID_DOC_NUM
    where  DH.SELECTION_ID = :SELECTION_ID
    group by SN.ID_NUMERATOR, SN.RDB$DB_KEY
    into   :id_doc_num, :num_dbkey, :last_num
  do begin
    execute procedure SYSTEM_GEN_NUM$INT (:num_dbkey, :last_num)
    returning_values  (:last_num);
    if (:last_num is null) then exception NUMERATOR_EXCEPTION 'Numerator is locked!';

    for
      select DH.DOC_NUM, DH.ID_DOC
      from   DOC_HEAD DH
      where  dh.ID_DOC_NUM = :id_doc_num
             and dh.NUM > :last_num
      order by DH.NUM asc
      into   :old_doc_num, :tmp_id_doc
    do begin
      execute procedure SYSTEM_GEN_NUM ('DOCUMENT', :id_doc_num)
      returning_values  (:last_num, :doc_num);

      update DOC_HEAD$INT D
      set    D.NUM = :last_num,
             D.DOC_NUM = :doc_num
      where  D.ID_DOC_HEAD = :tmp_id_doc;

      action_text = f_character(29)||:old_doc_num||f_character(28)||:doc_num;
      execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :tmp_id_doc, 'DOC_NUM_REGEN', :action_text);
    end
  end
end
^

/* Restore proc. body: DOCUMENT_STORNO$DOC */
ALTER PROCEDURE DOCUMENT_STORNO$DOC(ID_DOC_HEAD INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_STORNO_DOC INTEGER,
ID_HOTEL INTEGER,
ID_ACCOUNT INTEGER)
 AS
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_STORN_WITHP');

  execute procedure DOCUMENT_STORNO$INT (:ID_DOC_HEAD, :DESCRIPTION, 1)
  returning_values  (:ID_STORNO_DOC, :ID_HOTEL);

  select D.ID_ACCOUNT
  from   DOC_HEAD D
  where  D.ID_DOC = :id_storno_doc
  into   :id_account;

  execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :ID_DOC_HEAD, 'STORNO', f_character(29)||:DESCRIPTION);

end
^

/* Restore proc. body: EAI_AIRCONDITION_SMARTSTART */
ALTER PROCEDURE EAI_AIRCONDITION_SMARTSTART AS
declare variable id_reserv_detail integer;
begin
  for
    select RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.FROM_DATE = current_date
           and RD.IS_ANUL = 0
           and RD.CHECK_STATUS < 0
           and RD.ID_ROOM > 0
    into   :id_reserv_detail
  do begin
    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'AC.SMARTSTART', '');
  end
end
^

/* Restore proc. body: EAI_EVENTQ_ADD */
ALTER PROCEDURE EAI_EVENTQ_ADD(EAI_IFC VARCHAR(50),
EVENT_CODE VARCHAR(50),
OBJECT_ID INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_first_pushedback integer;
  declare variable m_dbkey char(8);
begin

  execute procedure SYSTEM_LOG_ADD ('EAI_EVENTQ', :object_id, :event_code, :eai_ifc);
end
^

/* Restore proc. body: END_WORK */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable system_date date;
  declare variable id_room integer;
  declare variable id_end_work integer;
  declare variable last_closed_date date;
  declare variable mark_dirty_expired_block varchar(10);
  declare variable mark_dirty_occ_room varchar(10);
  declare variable lock_id integer;
  declare variable shift_no integer;
  declare variable init_hotel_date date;
begin

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;
  if (:system_date >= :in_next_date) then exception END_WORK_EXCEPTION '-43';
  last_closed_date = :in_next_date - 1;

  /* LOCK THE CURRENT FINANCIAL (SYSTEM) DATE  */
  lock_id = null;
  while (:lock_id is null) do begin
    lock_id = strhash_large(:system_date || :id_hotel);
    execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'lock');
  
    when any do begin
      exception END_WORK_EXCEPTION '-337' || f_character(31) || f_character(29) || FormatDate(:system_date, 'D;dd.mm.yyyy');
    end
  end

  /* RIGHT IS REQUIRED TO CHANGE THE FINANCIAL DATE IF THERE ARE GUESTS WITH OVERDUE CHECK OUT */
  if (exists(
    select *
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
    where  G.TO_DATE <= :last_closed_date
           and G.CHECK_STATUS < 1
           and RD.ID_HOTEL = :id_hotel
           and rd.IS_ANUL = 0
  )) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('EW_OVERDUE_CHECKOUT');
  end

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', 'EW');
  -- Suppress eventual right checks into next procedures - all is permitted. Is this needed(?!?)

  update ACCOUNT_POST AP
  set    ap.ROOM_NAME = (select R.ROOM_NAME
                         from   GUEST G
                                join ROOMS R on R.ID_ROOM = G.ID_ROOM
                         where  G.ID_GUEST = ap.ID_GUEST)
  where  ap.DATE_POST between :system_date and :last_closed_date
         and ap.ID_GUEST > 0;

  select coalesce(max(ew.SHIFT_NO), 0) + 1
  from   END_WORKS ew
  where  ew.PREV_DATE = :system_date
  into   :shift_no;

  id_end_work = gen_id(G_AUTO_INC_END_WORKS, 1);
  insert into END_WORKS (ID_END_WORK, PREV_DATE, NEXT_DATE, END_WORK_KIND, SHIFT_NO, ID_HOTEL)
  values (:id_end_work, :system_date, :in_next_date, 3, :shift_no, :id_hotel);

  /* CHANGE SYSTEM DATE */
  execute procedure SYSTEM_DATE_SET(:id_hotel, :in_next_date);

  /* AUTO EXPIRATION OF ROOM NUMBERS, ROOMS AND BOOKING POSITIONS */
  execute procedure RESERVS_EXPIRE$INT(:last_closed_date, :id_hotel);

  execute procedure AGENT_CONTINGENT_EXPIRE(:system_date, :last_closed_date, null, 0, 1, :id_hotel);

  /* DELETE PERSON PROFILES WITH EXPIRATION DATE */
  execute procedure PROFILE_PERSON_EXPIRE (:in_next_date);

  execute procedure SETTING_GET_VALUE('MARK_DIRTY_EXPIRED_BLOCK', :ID_HOTEL)
  returning_values  :mark_dirty_expired_block;
  if (:mark_dirty_expired_block = '1') then begin
    for
      select distinct BR.ID_ROOM
      from   BLOCK_ROOM BR
             join ROOMS R on R.ID_ROOM = BR.ID_ROOM
      where  R.ID_HOTEL = :id_hotel
             and BR.TO_DATE >= :system_date
             and BR.TO_DATE < :in_next_date
             and BR.IS_ANNUL = 0
         into :id_room
    do begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'BLOCK_EXP', 'set_dirty');

      when any do post_event 'dummy';  -- nothing
    end
  end

  execute procedure SETTING_GET_VALUE('MARK_DIRTY_OCC_ROOM', :ID_HOTEL)
  returning_values  :mark_dirty_occ_room;
  if (:mark_dirty_occ_room = '1') then begin
    for
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
             join ROOMS R on R.ID_ROOM = rm.ID_ROOM
      where  R.ID_HOTEL = :id_hotel
             and RM.BUSY_DATE = :system_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and RM.BUSY_GROUP_TYPE = 24
      into   :id_room
    do begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'EW_DAY', 'set_dirty');

      when any do post_event 'dummy';  -- nothing
    end
  end

  /* Summary data prepare */
  if (:in_next_date > :system_date) then begin
    execute procedure SUMMARY_FINANCE_SAVE$INT (:id_end_work);

    select min(e.PREV_DATE)
    from   END_WORKS E
    where  E.ID_HOTEL = :ID_HOTEL
    into   :init_hotel_date;

    execute procedure SUMMARY_PREPARE$INT(:id_hotel, :init_hotel_date, :last_closed_date); --TODO precise the period

    execute procedure SUMMARY_FORECAST$INT(:ID_HOTEL, :system_date);
  end

  /* Delete data from temporal tables */
  delete from RESERV_ERROR;
  delete from TMP_SMALL_OCCUP;
--  delete from GUEST g where g.id_reserv_detail is null; pri regenerirane na statistikata ne vurshi rabota
  /*  */

  execute procedure CACHES_RESOLVE;

  execute procedure SYSTEM_LOG_ADD('SYSTEM', :id_end_work, 'DAY_EW', f_character(29) || :last_closed_date);

  execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'release');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', null);

  post_event 'invalidate.end_work';
end
^

/* Restore proc. body: GUEST_ADDRESSCARD_SET$RSV */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$RSV(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
EGN VARCHAR(30),
COUNTRY VARCHAR(10),
ID_STAY_REASON INTEGER,
IS_REGISTRED INTEGER,
PASS_PLACE VARCHAR(20),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_PLACE VARCHAR(30),
SEX CHAR,
MASK VARCHAR(10),
IS_CHILD INTEGER,
CAR VARCHAR(30),
KPP INTEGER,
KPP_DATE DATE,
PASS_EXP_DATE DATE,
AGE INTEGER,
BIRTH_DAY DATE,
VISA TDESCRIPTION_SHORT,
RATING_AGE INTEGER = null,
TITLE VARCHAR(10) = null,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable gd_dbkey char(8);
  declare variable pd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable rd_dbkey char(8);
  declare variable old_is_registred integer;
  declare variable old_guest_name1 varchar(250);
  declare variable old_guest_name2 varchar(250);
  declare variable old_id_pass_type integer;
  declare variable old_pass_num varchar(20);
  declare variable old_pass_date date;
  declare variable old_egn varchar(30);
  declare variable old_country varchar(20);
  declare variable old_id_stay_reason integer;
  declare variable old_kpp integer;
  declare variable old_kpp_date date;
  declare variable old_pass_exp_date date;
  declare variable old_birth_day date;
  declare variable old_pass_place varchar(20);
  declare variable old_city varchar(100);
  declare variable old_address varchar(100);
  declare variable old_visa TDESCRIPTION_SHORT;
  declare variable old_birth_place varchar(30);
  declare variable old_sex char(1);
  declare variable action_text varchar(250);
  declare variable tt_reg_number integer;
  declare variable id_hotel integer;
  declare variable id_tt_numerator integer;
  declare variable domestic_nation varchar(10);
  declare variable no_use varchar(255);
  declare variable is_anul smallint;
  declare variable acc_routing varchar(20);
begin
  err_code = 0;
  err_text = '';

  select G.RDB$DB_KEY, GD.RDB$DB_KEY, PD.RDB$DB_KEY,
         GD.IS_REGISTRED, PD.PERSON_NAME, PD.PERSON_NAME2, PD.ID_PASSPORT_TYPE, PD.PASS_NUM, PD.PASS_DATE,
         PD.EGN, PD.COUNTRY_CODE, GD.ID_STAY_REASON, GD.KPP, GD.KPP_DATE, PD.PASS_EXP_DATE,
         PD.BIRTH_DAY, PD.PASS_PLACE, PD.CITY, PD.ADDRESS, PD.BIRTH_PLACE, PD.SEX, rd.RDB$DB_KEY,
         g.TT_REG_NUMBER, rd.ID_HOTEL, rd.IS_ANUL, rd.ACC_ROUTING, GD.VISA
  from   GUEST G
         join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
         join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
         join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
  where  G.ID_GUEST = :id_guest
  into   :g_dbkey, :gd_dbkey, :pd_dbkey,
         :old_is_registred, :old_guest_name1, :old_guest_name2, :old_id_pass_type, :old_pass_num, :old_pass_date,
         :old_egn, :old_country, :old_id_stay_reason, :old_kpp, :old_kpp_date, :old_pass_exp_date,
         :old_birth_day, :old_pass_place, :old_city, :old_address, :old_birth_place, :old_sex, :rd_dbkey,
         :tt_reg_number, :id_hotel, :is_anul, :acc_routing, :old_visa;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, :birth_place, :egn, :id_passport_type, :pass_num, :pass_date, :pass_place,
          :pass_exp_date, :city, :address, :sex, :mask);

  update  GUEST_DATA GD
  set     GD.KPP_DATE = :kpp_date,
          GD.KPP = :kpp,
          GD.VISA = :visa,
          GD.ID_STAY_REASON = :id_stay_reason,
          GD.IS_REGISTRED = :is_registred,
          GD.USER_REGISTRED = iif(:IS_REGISTRED = 1, coalesce(GD.USER_REGISTRED, current_user), null),
          GD.CAR = :car,
          GD.RATING_AGE = :RATING_AGE
  where   GD.RDB$DB_KEY = :gd_dbkey;

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name1, :guest_name2, :country,
          :is_child, :age, :birth_day, :TITLE);

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -1);

  /*  */
  if (:IS_REGISTRED = 1 and :tt_reg_number is null and :is_anul = 0 and :acc_routing is distinct from 'OWNER') then begin
    execute procedure SETTING_GET_VALUE ('NATIVE_NATION', :id_hotel)
    returning_values :domestic_nation;

    select iif(:COUNTRY not in (:domestic_nation, '') and h.USE_DIFFERENT_TT_NUMERATORS = 1,
               h.ID_TT_NUMERATOR_2,
               h.ID_TT_NUMERATOR_1)
    from   HOTEL H
    where  h.ID_HOTEL = :id_hotel
    into   :id_tt_numerator;

    if (:id_tt_numerator is not null) then begin
      execute procedure SYSTEM_GEN_NUM('GUEST_NUM', :id_tt_numerator)
      returning_values :tt_reg_number, :no_use;
  
      update GUEST G
      set    g.TT_REG_NUMBER = :tt_reg_number
      where  G.RDB$DB_KEY = :g_dbkey;
    end
  end else if (:IS_REGISTRED is distinct from 1 and :tt_reg_number is not null) then begin
    update GUEST G
    set    g.TT_REG_NUMBER = null
    where  G.RDB$DB_KEY = :g_dbkey;
  end
  /*  */
  if ((:old_is_registred = 0) and (:is_registred = 1)) then begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'REGISTRED', '');
  end

  if ((:old_is_registred = 1) and (:old_guest_name1 <> :guest_name1)) then begin
    action_text = f_character(29)||:old_guest_name1||f_character(28)||:guest_name1;
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'CHANGE_CARD', :action_text);
  end

  if ((:old_IS_REGISTRED = 1)
      and
      ((:old_guest_name1 <> :guest_name1)
        or (:old_guest_name2 <> :guest_name2)
        or (:old_egn <> :egn)
        or (:old_id_pass_type <> :id_passport_type)
        or (:old_pass_num <> :pass_num)
        or (:old_pass_date <> :pass_date)
        or (:old_pass_exp_date <> :pass_exp_date)
        or (:old_pass_place <> :pass_place)
        or (:old_country <> :country)
        or (:old_city <> :city)
        or (:old_address <> :address)
        or (:old_visa <> :visa)
        or (:old_birth_day <> :birth_day)
        or (:old_birth_place <> :birth_place)
        or (:old_sex  <> :sex)
        or (:old_kpp <> :kpp)
        or (coalesce(:old_id_stay_reason,0) <> coalesce(:id_stay_reason,0))
        or (:old_kpp_date <> :kpp_date)
      )) then
  begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'PREREGISTRED', '');
  end

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
    returning_values  :warn_code;

  end

end
^

/* Restore proc. body: IMPORT_RATE_RECORD_RELINK$EXC */
ALTER PROCEDURE IMPORT_RATE_RECORD_RELINK$EXC(ID_RATE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ID_COLUMN integer;
declare variable ID_NEW_MASTER_RECORD integer;

declare variable PERIOD_DEPEND_ON_CHECKIN INTEGER;
declare variable CNT_DAYS_PRICE_BP INTEGER;
declare variable CNT_DAYS_PRICE_BOARD INTEGER;
declare variable BASE_BOARDS_LIST VARCHAR(255);
declare variable BOARD_TYPE VARCHAR(10);
begin
  execute procedure import_mark_transaction$exc;

  ERR_CODE = 0;
  ERR_TEXT = '';
  for
    select c.ID_TAR_DEFINE_COLUMN, im.ID_NEW
    from   TAR_UI_DEFINE_COLUMNS c
           join IDS_MAP$TMP im on c.ID_DIM2 = im.ID_OLD
    where  c.ID_TAR_HEAD = :ID_RATE
    into   :ID_COLUMN, :ID_NEW_MASTER_RECORD
  do begin
    update TAR_UI_DEFINE_COLUMNS c
    set    c.ID_DIM2 = :ID_NEW_MASTER_RECORD
    where  c.ID_TAR_DEFINE_COLUMN = :ID_COLUMN;
  end

  delete from IDS_MAP$TMP;


  select
        th.PERIOD_DEPEND_ON_CHECKIN,
        th.CNT_DAYS_PRICE_BP,
        th.CNT_DAYS_PRICE_BOARD,
        th.BASE_BOARDS_LIST,
        th.BOARD_TYPE
  from  TAR_HEAD th
  where th.ID_TAR_HEAD = :ID_RATE
  into  :PERIOD_DEPEND_ON_CHECKIN, :CNT_DAYS_PRICE_BP, :CNT_DAYS_PRICE_BOARD, :BASE_BOARDS_LIST, :BOARD_TYPE;

  for
    select ERR_CODE, ERR_TEXT
    from   TAR_SAVE(:ID_RATE, :PERIOD_DEPEND_ON_CHECKIN, :CNT_DAYS_PRICE_BP, :CNT_DAYS_PRICE_BOARD, :BASE_BOARDS_LIST, :BOARD_TYPE)
    into   :err_code, :err_text
  do begin
    if (0 <> :err_code) then begin
      exit;
    end
  end
end
^

/* Restore proc. body: OCCUPANCY_SUMMARY_REMAKE$SYS */
ALTER PROCEDURE OCCUPANCY_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
begin
  if (not exists (select h.ID_HOTEL
                  from   HOTEL H
                  where  h.ID_HOTEL = :ID_HOTEL)) then exception WRONG_VALUE 'Non-existing hotel!';

  select mindate(sd.SYSTEM_DATE - 1, :TO_DATE)
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :TO_DATE;

  if (:FROM_DATE > :TO_DATE) then exit;

  execute procedure SUMMARY_PREPARE$INT(:id_hotel, :FROM_DATE, :TO_DATE);

  execute procedure SYSTEM_LOG_ADD ('HOTEL', :id_hotel, 'OCCUPANCY_REGENERATE',
                                    f_character(29) || formatdate(:from_date, 'D;dd/mm/yyyy') || f_character(28) || formatdate(:to_date, 'D;dd/mm/yyyy'));
end
^

/* Restore proc. body: PAYMENT_ANUL$INT */
ALTER PROCEDURE PAYMENT_ANUL$INT(ID_PAYMENT_HEAD INTEGER,
ANUL_REASON VARCHAR(100))
 AS
declare variable p_dbkey char(8);
  declare variable id_ar_payment integer;
  declare variable id_payment_storned integer;
  declare variable payment_amount numeric(15,4);
  declare variable pay_currency varchar(3);
  declare variable system_date date;
  declare variable id_hotel integer;
  declare variable id_system_log integer;
  declare variable id_deposit integer;
  declare variable is_posting_stopped integer;
  declare variable round_to numeric(15,4);
begin 
  execute procedure PAYMENT_VOID_CHECK$INT (:ID_PAYMENT_HEAD, :ANUL_REASON);

  select P.RDB$DB_KEY, p.ID_PAYMENT_STORNED, P.PAY_VALUE_A, P.PAY_CURRENCY,
         P.ID_AR_PAYMENT, a.ID_HOTEL, p.ID_DEPOSIT, c.ROUND_TO
  from   PAYMENT_HEAD P
         join ACCOUNT A on A.ID_ACCOUNT = p.ID_ACCOUNT
         join CURRS c on c.CURR = p.PAY_CURRENCY
  where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  into   :p_dbkey, :id_payment_storned, :payment_amount, :pay_currency,
         :id_ar_payment, :id_hotel, :id_deposit, :round_to;

  if (:id_ar_payment is not null) then
    exception PAYMENT_ANNUL_EXCEPTION '-353';
    --'Payment is created from AR module.';

  if (:id_deposit is not null) then begin
    select r.IS_POSTING_STOPPED
    from   DEPOSIT d
           join RESERV_DETAIL r on r.ID_RESERV_DETAIL = d.ID_RESERV_DETAIL
    where  d.ID_DEPOSIT = :id_deposit
    into   :is_posting_stopped;

    if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';
  end

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :system_date;

  insert into ACCOUNT_PAYMENTS (ID_ACCOUNT, ID_PAYMENT_HEAD, PAY_AMOUNT, PAY_RATE,
         ACC_AMOUNT, ACC_RATE, TRANSACTION_DATE, ID_DEPOSIT)
  select AP.ID_ACCOUNT, AP.ID_PAYMENT_HEAD, -sum(AP.PAY_AMOUNT), AP.PAY_RATE,
         -sum(AP.ACC_AMOUNT), AP.ACC_RATE, :system_date, AP.ID_DEPOSIT
  from   ACCOUNT_PAYMENTS AP
  where  AP.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  group by AP.ID_ACCOUNT, AP.ID_PAYMENT_HEAD, AP.PAY_RATE, AP.ACC_RATE, AP.ID_DEPOSIT
  having round_f(sum(AP.PAY_AMOUNT), :round_to) <> 0;
                            
  if (:id_payment_storned is not null) then begin
    update PAYMENT_HEAD SP
    set    sp.IS_STORNED = 0
    where  sp.ID_PAYMENT_HEAD = :id_payment_storned;
  end

  execute procedure SYSTEM_EVENT_LOG$INT ('PAYMENT', :ID_PAYMENT_HEAD, 'ANNUL', f_character(29) || formatfloat(:payment_amount, 'F;0.00') || ' ' || :pay_currency || f_character(28) || :ANUL_REASON)
  returning_values  :id_system_log;

  update PAYMENT_HEAD PA
  set    PA.IS_ANUL = 1,
         pa.ANNUL_DATE = :system_date,
         pa.ID_LOG_EVENT_ANNUL = :id_system_log
  where  PA.RDB$DB_KEY = :p_dbkey;

end
^

/* Restore proc. body: PERSON_DATA_SET$INT */
ALTER PROCEDURE PERSON_DATA_SET$INT(P_DBKEY CHAR(8),
PD_DBKEY CHAR(8),
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
COUNTRY VARCHAR(10),
BIRTH_DAY DATE,
BIRTHDAY_INTERNAL DATE,
TITLE VARCHAR(10) = NULL)
 AS
declare variable id_profile integer;
  declare variable id_guest integer;
  declare variable first_name varchar(30);
  declare variable surname varchar(30);
  declare variable family_name varchar(30);
  declare variable old_name varchar(92);
  declare variable old_country varchar(10);
  declare variable country_name varchar(50);
  declare variable action_text varchar(255);
  declare variable rd_dbkey char(8);
  declare variable age integer;
  declare variable old_birthday date;
begin
  /*  Description:
  ||
  */
  select coalesce(:country, PD.COUNTRY_CODE), PD.BIRTH_DAY, PD.PERSON_NAME, PD.COUNTRY_CODE,
         (select max(GD.ID_GUEST)
          from   GUEST_DATA GD 
          where  GD.ID_PERSON_DATA = PD.ID_PERSON_DATA)
  from   PERSON_DATA PD
  where  PD.RDB$DB_KEY = :pd_dbkey
  into   :country, :old_birthday, :old_name, :old_country, :id_guest;

/*  execute procedure GUEST_BIRTHDAY$INT(:birth_day, :age, :old_birthday, :guest_from_date)
  returning_values  :birthday_internal, :birth_day;
  /*execute procedure sys_dbg('res PERSON_DATA_SET$INT birth_day = '||coalesce(:birth_day, 'null'));
  execute procedure sys_dbg('res PERSON_DATA_SET$INT birthday_internal = '||coalesce(:birthday_internal, 'null'));
  */
  select PP.FIRST_NAME, PP.SURNAME, PP.FAMILY_NAME
  from   PERSON_NAME_PARSE$INT (:GUEST_NAME1) PP
  into   :first_name, :surname, :family_name;

  update  PERSON_DATA PD
  set     PD.FIRST_NAME = :first_name,
          PD.SURNAME = :surname,
          PD.FAMILY_NAME = :family_name,
          PD.PERSON_NAME2 = coalesce(:guest_name2, iif(PD.PERSON_NAME = PD.PERSON_NAME2, :guest_name1, PD.PERSON_NAME2)),
          PD.COUNTRY_CODE = :country,
          PD.BIRTH_DAY = coalesce(:birthday_internal, :birth_day), -- this is relative date, calculated by input age or equal as real birth day (if exists)
          PD.BIRTHDAY_INTERNAL = :birthday_internal, -- this is real person birth day (can be null)
          PD.TITLE = :TITLE
  where   PD.RDB$DB_KEY = :pd_dbkey;

  execute procedure LIST_ITEM_MODIFY('person_title', null, :TITLE, 'add');

  if (:id_guest is not null and
       ((:old_name is distinct from :GUEST_NAME1)
         or (:OLD_BIRTHDAY is distinct from :birth_day)
         or (:old_country is distinct from :COUNTRY))
      /*or (:old_is_child is distinct from :is_child)*/) then
  begin
    select C.COUNTRY_NAME
    from   COUNTRY C
    where  C.COUNTRY_CODE = :COUNTRY
    into   :country_name;

    select CA.AGE_INYEARS
    from   SYSTEM_CALC_AGE_INYEARS (:birth_day, current_timestamp) CA
    into   :age;

    action_text = f_character(29) || '"' || :guest_name1 || '", ' || coalesce(:age, '') || ', ' || coalesce(:country_name, '');
    execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'GUEST_IDENT_CHNG', :action_text);
  end

  if (:p_dbkey is not null) then begin
    update PROFILE P
    set    P.PROFILE_NAME = :guest_name1
    where  P.RDB$DB_KEY = :p_dbkey;

    select P.ID_PROFILE
    from   PROFILE P
    where  P.RDB$DB_KEY = :p_dbkey
    into   :id_profile;

    for
      select rd.RDB$DB_KEY
      from   RESERV_DETAIL RD
      where  RD.ID_PERSON_PROFILE = :id_profile
             and RD.CHECK_STATUS >= -2  -- to be or not to be ???
      into   :rd_dbkey
    do begin
      execute procedure RESERV_TRACK_CHANGES$INT (:rd_dbkey);
    end
  end
end
^

/* Restore proc. body: PHONE_LINE_CONVERT_MODIFY$CFG */
ALTER PROCEDURE PHONE_LINE_CONVERT_MODIFY$CFG(ID INTEGER,
LINE VARCHAR(30),
ROOM_NAME VARCHAR(30),
IS_TAXABLE SMALLINT,
IS_ARCHIVE SMALLINT,
PRICE_INDEX NUMERIC(15,4),
ID_HOTEL INTEGER,
ID_ACCOUNT INTEGER,
OPERATION VARCHAR(10))
 RETURNS(NEW_ID INTEGER)
 AS
declare variable action_text varchar(255);
declare variable account_name varchar(50);
declare variable hotel_name varchar(50);
declare variable old_line varchar(30);
declare variable old_room_name varchar(30);
declare variable old_is_taxable smallint;
declare variable old_is_archive smallint;
declare variable old_price_index numeric(15,4);
declare variable old_account_name varchar(50);
declare variable old_hotel_name varchar(50);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  select ACC.ACCOUNT_NAME
  from ACCOUNT ACC
  where ACC.ID_ACCOUNT = :ID_ACCOUNT
  into :account_name;
  select H.HOTEL_NAME
  from HOTEL H
  where H.ID_HOTEL = :ID_HOTEL
  into :hotel_name;

  if (:operation = 'add') then begin
    insert into PHONE_LINE_CONVERT (LINE, ROOM_NAME, IS_TAXABLE, IS_ARCHIVE, PRICE_INDEX, ID_HOTEL, ID_ACCOUNT)
    values      (:line, :room_name, :is_taxable, :is_archive, :price_index, :id_hotel, :ID_ACCOUNT)
    returning   ID
    into        :new_id;

    action_text = f_character(29) || :line || f_character(28) || :room_name ||
                  f_character(28) || :is_taxable || f_character(28) || :is_archive ||
                  f_character(28) || formatfloat(:price_index, '0.00') || f_character(28) || :hotel_name ||
                  f_character(28) || :account_name;
    execute procedure SYSTEM_LOG_ADD ('PHONE_LINES', :ID, 'PHONE_LINE_MODIFY', :ACTION_TEXT);
  end else if (:operation = 'mod') then begin
    update PHONE_LINE_CONVERT
    set    LINE = :line,
           ROOM_NAME = :room_name,
           IS_TAXABLE = :is_taxable,
           IS_ARCHIVE = :is_archive,
           PRICE_INDEX = :price_index,
           ID_ACCOUNT = :id_account
    where  ID = :id;

    new_id = :id;

    action_text = f_character(29) || :line || f_character(28) || :room_name ||
                  f_character(28) || :is_taxable || f_character(28) || :is_archive ||
                  f_character(28) || formatfloat(:price_index, '0.00') || f_character(28) || :hotel_name ||
                  f_character(28) || :account_name;
    execute procedure SYSTEM_LOG_ADD ('PHONE_LINES', :ID, 'PHONE_LINE_MODIFY', :ACTION_TEXT);
    end else if (:operation = 'del') then begin
      select PLC.LINE, PLC.ROOM_NAME, PLC.IS_TAXABLE, PLC.IS_ARCHIVE, PLC.PRICE_INDEX,
             A.ACCOUNT_NAME, HO.HOTEL_NAME
      from PHONE_LINE_CONVERT PLC
        join ACCOUNT A on A.ID_ACCOUNT = PLC.ID_ACCOUNT
        join HOTEL HO on HO.ID_HOTEL = PLC.ID_HOTEL
      where PLC.ID = :ID
      into :old_line, :old_room_name, :old_is_taxable, :old_is_archive, :old_price_index,
           :old_account_name, :old_hotel_name;

      action_text = f_character(29) || :old_line || f_character(28) || :old_room_name ||
                    f_character(28) || :old_is_taxable || f_character(28) || :old_is_archive ||
                    f_character(28) || formatfloat(:old_price_index, '0.00') ||
                    f_character(28) || :old_hotel_name ||
                    f_character(28) || :old_account_name;
      execute procedure SYSTEM_LOG_ADD ('PHONE_LINES', :ID, 'PHONE_LINE_DEL', :ACTION_TEXT);

      delete from PHONE_LINE_CONVERT
      where  ID = :id;
  end
end
^

/* Restore proc. body: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
QTY TYPE OF TQTY,
ID_SECQUENCE TYPE OF ID,
IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
POST_TEXT TYPE OF TDESCRIPTION_SHORT,
RESOURCE_TEXT TYPE OF TREASON,
DATE_POST TYPE OF TDATE,
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ID_ROOM TYPE OF ID = null,
POST_DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable action_text varchar(255);
begin
  if (:date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :date_post;
  end
/* NO AUTO PRICE !!!!!!
  if (:in_is_manual_price = 0) then begin

    select P.ID_EXTRA_TARIFF
    from   ACCOUNT A
           join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
    where  A.ID_ACCOUNT = :in_id_account
    into   :id_extra_tarifa;
    if ((:id_extra_tarifa is null) or (:id_extra_tarifa < 0)) then begin
      err_code = -14;
      exit;
    end
    execute procedure TAR_RECALC_EXTRASRV(:id_extra_tarifa, :in_id_service, :in_date_post)
    returning_values  :err_code, :err_text, :post_price, :post_currency;
    if (:err_code < 0) then exit;
  end else begin
    --MANUAL PRICE
    post_currency = :manual_curr ;
    post_price = :manual_price ;
  end
*/

  post_currency = :manual_curr ;
  post_price = :manual_price ;
  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, -1, :id_secquence, :date_post, :id_service, -1, :id_room, 0, :qty, :post_price,
    :post_currency, null, :short_code, :from_date, :to_date, :post_text, :resource_text, '', -1, :POST_DESCRIPTION)
  returning_values :err_code, :err_text, :id_account_post;
  if (:err_code <> 0) then exit;

  select S.SERVICE_NAME
  from   SERVICES S
  where  S.ID_SERVICE = :ID_SERVICE
  into   :action_text;
   
  action_text = f_character(29) || :action_text
                || f_character(28) || formatdate(:DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || :post_currency;
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* Restore proc. body: POST_SERVICE_ON_GUEST$INT */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TDESCRIPTION_SHORT,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ACCOUNT_ROUTING TYPE OF TSHORT_CODE,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable id_room integer;
  declare variable no_use varchar(255);
  declare variable action_text varchar(255);
  declare variable is_guest_check_in smallint;
  declare variable service_name varchar(50);
begin
  err_code = 0;
  err_text = '';

  select g.check_status
  from   guest g
  where  g.id_guest = :in_id_guest
  into   :is_guest_check_in;

  if (:is_guest_check_in < 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
  end

  execute procedure GUEST_GET_POSTING_ACCOUNT$INT (:in_id_guest, :account_routing)
  returning_values  :id_account, :id_room;

  if (:in_date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :in_date_post;
  end

  if (:in_is_manual_price = 0) then begin
    execute procedure SERVICE_GET_POSTING_DETAILS(:in_id_service, :IN_DATE_POST)
    returning_values  :no_use, :no_use, :service_name, :post_price, :post_currency;
  end else begin
    /* MANUAL PRICE */
    post_currency = :manual_curr;
    post_price = :manual_price;
  end

  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, :in_id_guest, :in_id_secquence, :in_date_post, :in_id_service, -1, :id_room, 0, :in_qty,
    :post_price, :post_currency, null, :in_short_code, :in_from_datetime, :in_to_datetime, :in_post_text,
    :in_resource_text, '', -1, :DESCRIPTION)
  returning_values  :err_code, :err_text, :id_account_post;

  action_text = f_character(29) || :service_name
                || f_character(28) || formatdate(:IN_DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:IN_QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || :post_currency;
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* Restore proc. body: PROFILE_AGENT_MODIFY$PROFILE */
ALTER PROCEDURE PROFILE_AGENT_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
IS_ARCHIVE INTEGER,
AGENT_GROUP VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IATA_NUMBER VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null,
THRESHOLD_NOTE VARCHAR(255) = null,
THRESHOLD_AMOUNT NUMERIC(15,4) = null,
THRESHOLD_CURR CHAR(3) = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable id_agent integer;
  declare variable action_text varchar(255);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  AGENT_GROUP = nullif(trim(:AGENT_GROUP), '');

  if (:operation in ('add', 'mod')) then begin
    execute procedure PROFILE_COMMON_MODIFY$INT(:id_profile, 'AGENT', :profile_name,
            :phone, :fax, :email, :contact_city, :contact_address,
            :note, :msg, :is_archive, :id_def_contragent, :id_nom_market_segment,
            :wbe_password, :account_no, :is_exclusive_debt_ownership)
    returning_values (:NEW_ID_PROFILE);

    if (:new_id_profile is distinct from :id_profile) then begin
      id_agent = gen_id(G_AUTO_INC_AGENT,1);
      insert into AGENT (ID_AGENT, AGENT_NAME, IS_USE)
      values (:id_agent, :profile_name, 1-:is_archive);
  
      insert into PROFILE_AGENT(ID_PROFILE, ID_AGENT, AGENT_GROUP, COUNTRY_CODE, IATA_NUMBER, THRESHOLD_NOTE, THRESHOLD_AMOUNT, THRESHOLD_CURR)
      values (:new_id_profile, :id_agent, :agent_group, :country_code, :iata_number, :threshold_note, :threshold_amount, :threshold_curr);
  
      action_text = f_character(29) || :profile_name;
      execute procedure SYSTEM_LOG_ADD ('PROFILE', :new_id_profile, 'CREATE_AGENT_PROFILE', :action_text);
    end else begin
      select PA.ID_AGENT
      from   PROFILE_AGENT PA
      where  PA.ID_PROFILE = :NEW_ID_PROFILE
      into   :id_agent;

      update PROFILE_AGENT PA
      set    PA.IATA_NUMBER = :IATA_NUMBER,
             PA.COUNTRY_CODE = :COUNTRY_CODE,
             PA.AGENT_GROUP = :AGENT_GROUP,
             PA.THRESHOLD_NOTE = :THRESHOLD_NOTE,
             PA.THRESHOLD_AMOUNT = :THRESHOLD_AMOUNT,
             PA.THRESHOLD_CURR = :THRESHOLD_CURR
      where  PA.ID_PROFILE = :NEW_ID_PROFILE;

      update AGENT A
      set    A.AGENT_NAME = :profile_name,
             A.IS_USE = 1 - :is_archive
      where  A.ID_AGENT = :id_agent;
    end
  end else if (:operation = 'del') then  begin
    execute procedure PROFILE_DELETE$INT(:id_profile);

    new_id_profile = null;
  end
end
^

/* Restore proc. body: PROFILE_COMMON_MODIFY$INT */
ALTER PROCEDURE PROFILE_COMMON_MODIFY$INT(ID_PROFILE INTEGER,
PROFILE_TYPE VARCHAR(20),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
IS_ARCHIVE INTEGER,
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable action_text varchar(255);
  declare variable old_profile_name varchar(100);
  declare variable old_is_archive integer;
  declare variable p_dbkey char(8);
begin
  p_dbkey = null;
  select P.RDB$DB_KEY, P.PROFILE_NAME, P.IS_ARCHIVE
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :p_dbkey, :old_profile_name, :old_is_archive;
   
/*  if (:client_loyalty_card = '') then client_loyalty_card = null;

  if (coalesce(:client_loyalty_card,'') <> '') then begin
    update PROFILE P
    set    P.CLIENT_LOYALTY_CARD = null
    where  P.CLIENT_LOYALTY_CARD = :client_loyalty_card
           and P.RDB$DB_KEY is distinct from :p_dbkey;
  end
*/
  is_exclusive_debt_ownership = coalesce(:is_exclusive_debt_ownership, 0);
  new_id_profile = :id_profile;
  if (:p_dbkey is null) then begin
    execute procedure SYSTEM_CHECK_OPERATION (:PROFILE_TYPE, 'PERSON,AGENT,HOUSE', 'Profile type');

    new_id_profile = gen_id(gen_profile_id, 1);
    insert into PROFILE (ID_PROFILE, PROFILE_NAME, PROFILE_TYPE,
           PHONE, FAX, EMAIL, CITY, ADDRESS, NOTE, MSG,
           ID_DEF_CONTRAGENT, ID_NOM_MARKET_SEGMENT, IS_ARCHIVE, ACCOUNT_NO,
           WBE_PASSWORD, IS_EXCLUSIVE_DEBT_OWNERSHIP)
    values (:new_id_profile, :profile_name, :profile_type,
           :phone, :fax, :email, :contact_city, :contact_address, :note, :msg,
           :id_def_contragent, :id_nom_market_segment, 0, :account_no,
           nullif(:wbe_password, ''), :is_exclusive_debt_ownership)
    returning RDB$DB_KEY into :p_dbkey;
  end else begin
    update PROFILE PU
    set    PU.PROFILE_NAME = :profile_name,
           PU.PHONE = :phone,
           PU.FAX = :fax,
           PU.EMAIL = :email,
           PU.CITY = :contact_city,
           PU.ADDRESS = :contact_address,
           PU.NOTE = :note,
           PU.MSG = :msg,
           PU.ID_DEF_CONTRAGENT = :id_def_contragent,
           PU.ID_NOM_MARKET_SEGMENT = :id_nom_market_segment,
           PU.ACCOUNT_NO = :ACCOUNT_NO,
           PU.WBE_PASSWORD = iif(PU.WBE_PASSWORD is null and :wbe_password = '', null, :wbe_password),
           -- empty ('') new password should not relpace NULLs,
           -- empty password indicate for 'deleted real password'
           PU.IS_EXCLUSIVE_DEBT_OWNERSHIP = :IS_EXCLUSIVE_DEBT_OWNERSHIP
    where  PU.RDB$DB_KEY = :p_dbkey;
  
    if (:old_profile_name <> :profile_name) then begin
      action_text = f_character(29) || :old_profile_name || f_character(28) || :profile_name;
      execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'EDIT_NAME', :action_text);
    end
  
    if (:is_archive is distinct from :old_is_archive) then
      execute procedure PROFILE_SET_ARCHIVE$INT (:P_DBKEY, :IS_ARCHIVE);
   end
end
^

/* Restore proc. body: PROFILE_DELETE$INT */
ALTER PROCEDURE PROFILE_DELETE$INT(ID_PROFILE INTEGER)
 AS
declare variable action_text varchar(255);
begin

  delete from PROFILE P
  where  P.ID_PROFILE = :id_profile;

  action_text = '';
  execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'DELETE', :action_text);

end
^

/* Restore proc. body: PROFILE_HOUSE_MODIFY$PROFILE */
ALTER PROCEDURE PROFILE_HOUSE_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(20),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
IS_ARCHIVE INTEGER,
HOUSE_TYPE VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable action_text varchar(255);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    execute procedure PROFILE_COMMON_MODIFY$INT(:id_profile, 'HOUSE', :profile_name,
            :phone, :fax, :email, :contact_city, :contact_address,
            :note, :msg, :is_archive, :id_def_contragent, :id_nom_market_segment,
            :wbe_password, :account_no, :is_exclusive_debt_ownership)
    returning_values (:new_id_profile);

    if (:operation = 'add') then begin
      insert into PROFILE_HOUSE(ID_PROFILE, HOUSE_TYPE)
      values (:new_id_profile, :house_type);

      action_text = f_character(29) || :PROFILE_NAME;
      execute procedure SYSTEM_LOG_ADD ('PROFILE', :new_id_profile, 'CREATE_HOUSE_PROFILE', :action_text);
    end
  end else if (:operation = 'del') then  begin
    execute procedure PROFILE_DELETE$INT(:id_profile);

    new_id_profile = null;
  end
end
^

/* Restore proc. body: PROFILE_MERGE$PROFILE */
ALTER PROCEDURE PROFILE_MERGE$PROFILE(ID_SOURCE INTEGER,
ID_TARGET INTEGER,
OPERATION VARCHAR(20))
 AS
declare variable source_p_type varchar(30);
  declare variable target_p_type varchar(30);
  declare variable total_points_gained integer;
  declare variable total_points_consumed integer;
  declare variable source_p_name varchar(100);
  declare variable target_p_name varchar(100);
  declare variable id_hotel integer;
  declare variable id_bps integer;
  declare variable target_id_p_data integer;
  declare variable rd_dbkey char(8);
  declare variable gd_dbkey char(8);
  declare variable check_status smallint;
  declare variable id_reserv_detail integer;
  declare variable is_archive integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'merge, notequals');

  if ((:ID_SOURCE is null) or (:ID_TARGET is null)) then exception PROFILE_EXCEPTION '<NULL> profile id is passed!';

  if (:operation = 'notequals') then begin
    insert into PROFILE_DISSIMILAR (ID_PROFILE1, ID_PROFILE2)
    values (iif(:id_source < :id_target, :id_source, :id_target),
            iif(:id_source > :id_target, :id_source, :id_target));

    when any do exit;

  end else if (:operation = 'merge') then begin
    if (exists (select o.ID_OWNER from OWNER$PMS O where O.ID_OWNER in (:ID_SOURCE, :ID_TARGET))) then
      exception PROFILE_EXCEPTION '-1047';

    select p.PROFILE_TYPE, p.PROFILE_NAME
    from   PROFILE P
    where  P.ID_PROFILE = :ID_SOURCE
    into   :source_p_type, :source_p_name;

    select p.PROFILE_TYPE, p.PROFILE_NAME, PP.ID_PERSON_DATA, p.IS_ARCHIVE
    from   PROFILE P
           left outer join PROFILE_PERSON PP on PP.ID_PROFILE = P.ID_PROFILE 
    where  P.ID_PROFILE = :ID_TARGET
    into   :target_p_type, :target_p_name, :target_id_p_data, :is_archive;

    if (:is_archive = 1) then exception PROFILE_EXCEPTION '-1055';
    if (:source_p_type <> :target_p_type) then exception PROFILE_EXCEPTION 'Profile types are incompatible!';

    update RESERV_DETAIL RD
    set    rd.ID_AGENT_PROFILE = :ID_TARGET
    where  rd.ID_AGENT_PROFILE = :ID_SOURCE;

    update ACCOUNT A
    set    a.ID_PROFILE = :ID_TARGET
    where  a.ID_PROFILE = :ID_SOURCE;

    update AR_OWING AO
    set    ao.ID_PROFILE = :ID_TARGET
    where  ao.ID_PROFILE = :ID_SOURCE;

    update AR_PAYMENT ARP
    set    arp.ID_PROFILE = :ID_TARGET
    where  arp.ID_PROFILE = :ID_SOURCE;

    update DEPOSIT D
    set    d.ID_PROFILE = :ID_TARGET
    where  d.ID_PROFILE = :ID_SOURCE;

    update PROFILE_CREDIT_CARD pcc
    set    pcc.ID_PROFILE = :ID_TARGET
    where  pcc.ID_PROFILE = :ID_SOURCE
           and not exists (select spc.CARD_CODE
                           from   PROFILE_CREDIT_CARD spc
                           where  spc.ID_PROFILE = :ID_TARGET
                                  and spc.CARD_CODE = pcc.CARD_CODE);

    update PROFILE_DISCOUNT pd
    set    pd.ID_PROFILE = :ID_TARGET
    where  pd.ID_PROFILE = :ID_SOURCE
           and not exists (select spd.ID_SALE_DISCOUNT
                           from   PROFILE_DISCOUNT spd
                           where  spd.ID_PROFILE = :ID_TARGET
                                  and spd.ID_SALE_DISCOUNT = pd.ID_SALE_DISCOUNT);

    update PROFILE_HOTEL_RATE phr
    set    phr.ID_PROFILE = :ID_TARGET
    where  phr.ID_PROFILE = :ID_SOURCE
           and not exists (select tphr.ID_PROFILE
                           from   PROFILE_HOTEL_RATE tphr
                           where  tphr.ID_PROFILE = :ID_TARGET
                                  and tphr.ID_TARIFF = phr.ID_TARIFF
                                  and tphr.ID_HOTEL = phr.ID_HOTEL);

    update PROFILE_FILE pf
    set    pf.ID_PROFILE = :ID_TARGET
    where  pf.ID_PROFILE = :ID_SOURCE;

    for
      select sbs.ID_HOTEL, sbs.ID_BONUSPOINT_SCHEME
      from   PROFILE_BONUSPOINT_SCHEME sbs
      where  sbs.ID_PROFILE = :ID_SOURCE
      into   :id_hotel, :id_bps
    do begin
      if (not exists (select tbs.ID_BONUSPOINT_SCHEME
                      from   PROFILE_BONUSPOINT_SCHEME tbs
                      where  tbs.ID_PROFILE = :ID_TARGET
                             and tbs.ID_HOTEL = :id_hotel)) then
      begin
        insert into PROFILE_BONUSPOINT_SCHEME (ID_PROFILE, ID_HOTEL, ID_BONUSPOINT_SCHEME)
        values (:ID_TARGET, :id_hotel, :id_bps);
      end

    end

    update PROFILE_WALLET_POINTS pwp
    set    pwp.ID_PROFILE = :ID_TARGET
    where  pwp.ID_PROFILE = :ID_SOURCE;

    select pw.TOTAL_POINTS_GAINED, pw.TOTAL_POINTS_CONSUMED
    from   PROFILE_WALLET pw
    where  pw.ID_PROFILE = :ID_TARGET
    into   :total_points_gained, :total_points_consumed;

    update PROFILE p
    set    p.BONUSPOINT_GAINED = :total_points_gained,
           p.BONUSPOINT_CONSUMED = :total_points_consumed
    where  p.ID_PROFILE = :ID_TARGET;

    if (:source_p_type = 'PERSON') then begin
      for
        select RD.RDB$DB_KEY, GD.RDB$DB_KEY, RD.CHECK_STATUS, RD.ID_RESERV_DETAIL
        from   RESERV_DETAIL RD
               join GUEST_DATA GD on GD.ID_GUEST = RD.ID_TITULAR
        where  rd.ID_PERSON_PROFILE = :id_source
        into   :rd_dbkey, :gd_dbkey, :check_status, :id_reserv_detail
      do begin
        update RESERV_DETAIL RD
        set    RD.ID_PERSON_PROFILE = :id_target
        where  RD.RDB$DB_KEY = :rd_dbkey;

        if (:check_status < 1) then begin
          update GUEST_DATA GD
          set    GD.ID_PERSON_DATA = :target_id_p_data
          where  GD.RDB$DB_KEY = :gd_dbkey;

          execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL,  'TITULAR_CHAN_PROF_MERGE',
                                            f_character(29) || :source_p_name || f_character(28) || :target_p_name);
        end
      end

    end else if (:source_p_type = 'AGENT') then begin
      update SUMMARY_PROFILES$REV spr
      set    spr.ID_PROFILE = :ID_TARGET
      where  spr.ID_PROFILE = :ID_SOURCE;

      update SUMMARY_OCCUPANCY_PROFILE_MRKT sopm
      set    sopm.ID_PROFILE_AGENT = :ID_TARGET
      where  sopm.ID_PROFILE_AGENT = :ID_SOURCE;

      update SUMMARY_OCCUPANCY_OTHER soo
      set    soo.ID_PROFILE_AGENT = :ID_TARGET
      where  soo.ID_PROFILE_AGENT = :ID_SOURCE;
  
      update RES_TEMPLATE rt
      set    rt.ID_AGENT_PROFILE = :ID_TARGET
      where  rt.ID_AGENT_PROFILE = :ID_SOURCE;

      -- PROFILE_HOTEL_ALLOTMENT - keep target's allotments only 
    end

    /* delete or archivate */
    update PROFILE P
    set    p.IS_ARCHIVE = 1,
           p.ID_MERGE_PROFILE = :ID_TARGET
    where  p.ID_PROFILE = :ID_SOURCE;

    -- ficticious update - to force export only
    update PROFILE P
    set    p.UUID = p.UUID
    where  p.ID_PROFILE = :ID_TARGET;
    -- log
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_SOURCE, 'MERGE_TO', f_character(29) || :target_p_name);
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_TARGET, 'CONSOLIDATE_WITH', f_character(29) || :source_p_name);
  end
end
^

/* Restore proc. body: PROFILE_PERSON_CREATEQ$PROFILE */
ALTER PROCEDURE PROFILE_PERSON_CREATEQ$PROFILE(PROFILE_NAME TYPE OF TPERSON_NAME,
PHONE TYPE OF TPHONE,
ID_PASSPORT_TYPE TYPE OF ID,
PASS_NUM TYPE OF NAME_20,
EGN TYPE OF TTEXT_SHORT,
COUNTRY_CODE TYPE OF TSHORT_CODE,
CARD_CODE TYPE OF TCARD_CODE,
ID_PERSON_DATA TYPE OF ID_REF = null,
TITLE TYPE OF TSHORT_CODE = null,
ID_HOTEL TYPE OF ID_REF = null)
 RETURNS(NEW_ID_PROFILE TYPE OF ID,
P_DBKEY TYPE OF TDB_KEY,
PD_DBKEY TYPE OF TDB_KEY)
 AS
declare variable action_text varchar(255);
  declare variable mask varchar(10);
  declare variable first_name varchar(30);
  declare variable surname varchar(30);
  declare variable family_name varchar(30);
begin

  new_id_profile = gen_id(gen_profile_id, 1);
  insert into PROFILE (ID_PROFILE, PROFILE_NAME, PROFILE_TYPE, PHONE, IS_ARCHIVE)
  values (:new_id_profile, :profile_name, 'PERSON', :phone, 0)
  returning RDB$DB_KEY into :p_dbkey;

  if (:id_person_data is null) then begin
    id_person_data = gen_id(gen_person_data_id, 1);

    if (:ID_HOTEL is not null) then begin
      execute procedure SETTING_GET_VALUE ('DEF_GUEST_MASK', :ID_HOTEL)
      returning_values  :mask;
    end

    select PP.FIRST_NAME,  PP.SURNAME, PP.FAMILY_NAME
    from   PERSON_NAME_PARSE$INT (:PROFILE_NAME) PP
    into   :first_name,  :surname, :family_name;

    insert into PERSON_DATA(ID_PERSON_DATA, PERSON_NAME2, ID_PASSPORT_TYPE, PASS_NUM, EGN, MASK,
           FIRST_NAME, SURNAME, FAMILY_NAME, COUNTRY_CODE)
    values (:id_person_data, :profile_name, :id_passport_type, :pass_num, :egn, :mask,
           :first_name, :surname, :family_name, :country_code)
    returning RDB$DB_KEY into :pd_dbkey;

    execute procedure PERSON_DATA_SET$INT(:p_dbkey, :pd_dbkey, :profile_name, :profile_name, :country_code,
            null, null, :TITLE);
  end

  insert into PROFILE_PERSON (ID_PROFILE, ID_PERSON_DATA, CARD_CODE)
  values (:new_id_profile, :id_person_data, :card_code);

  action_text = f_character(29) || :profile_name;
  execute procedure SYSTEM_LOG_ADD ('PROFILE', :new_id_profile, 'CREATE_PERS_PROFILE', :action_text);
end
^

/* Restore proc. body: RES_ANUL_DETAIL$INT */
ALTER PROCEDURE RES_ANUL_DETAIL$INT(RD_DBKEY CHAR(8),
REASON VARCHAR(50),
CANCELATION_NUMBER TYPE OF NAME_20 = null)
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable id_reserv_detail integer;
  declare variable is_anul integer;
  declare variable id_log_event integer;
  declare variable id_guest integer;
  declare variable g_dbkey char(8);
  declare variable no_use varchar(255);
  declare variable tmp_extra_posts_left smallint;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:reason, 'NOSHOW, CANCELED, USERERROR, TRANSFER', 'Annul reason');

  select RD.IS_ANUL, RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :is_anul, :id_reserv_detail;

  if (:is_anul = 1) then begin
    exception BOOKING_EXCEPTION '-1021';
    -- Reservation is already annuled or checkedin !
  end

  if (:reason = 'NOSHOW') then begin
    execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    returning_values  :no_use, :no_use;

    -- execute procedure TAR_CALC_FINALIZE$INT(:err_code, :id_tar_calc, :rd_dbkey); -- this procedure is enclosed into RES_FINALIZE_RECALC$INT
    -- err_code = 0; -- IGNORE ALL ERRORS
  end

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_ANUL', f_character(29) || :reason);

  id_log_event = RDB$GET_CONTEXT('USER_TRANSACTION', 'ACTION_LOG_ID');

  update RESERV_DETAIL RDU
  set    RDU.IS_ANUL = 1,
         RDU.REASON_OF_ANUL = :reason,
         RDU.ID_LOG_EVENT_ANNUL = :id_log_event,
         RDU.CANCELATION_NUMBER = coalesce(:CANCELATION_NUMBER, strhash_large(rdu.NUMBER || 'CANCELATION'))
  where  RDU.RDB$DB_KEY = :rd_dbkey;

  EXTRA_POSTS_LEFT = 0;
  for
    select g.ID_GUEST, G.RDB$DB_KEY
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_guest, :g_dbkey
  do begin
    execute procedure GUEST_DEL_POSTINGS$INT(:id_guest)
    returning_values  :tmp_extra_posts_left;
    EXTRA_POSTS_LEFT = iif(:EXTRA_POSTS_LEFT = 1, 1, :tmp_extra_posts_left);

    update GUEST G
    set    G.UUID = null
    where  g.RDB$DB_KEY = :g_dbkey;
  end

  execute procedure RES_FINALIZE$INT (:RD_DBKEY, 0)
  returning_values (:warn_code);

  execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

end
^

/* Restore proc. body: RES_CHECK_OUT_GUESTS$RSV */
ALTER PROCEDURE RES_CHECK_OUT_GUESTS$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND SMALLINT = 0)
 AS
declare variable action_code varchar(100);
  declare variable cleaning_restriction varchar(10);
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable id_reserv_detail integer;
  declare variable id_guest integer;
  declare variable id_room integer;
  declare variable rd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable checkout_status integer;
  declare variable sys_date date;
  declare variable warn_code integer;
  declare variable id_hotel integer;
begin
  checkout_status = 1;
  action_code = case when :check_out_kind = 0 then 'CHECK_OUT'
                     when :check_out_kind = 1 then 'CHECK_OUT_EARLY1'
                     when :check_out_kind = 2 then 'CHECK_OUT_EARLY2'
                     when :check_out_kind = 3 then 'CHECK_OUT_EARLY3'
                end;

  for
    select RD.ID_RESERV_DETAIL, RD.ID_ROOM, RD.RDB$DB_KEY, rd.ID_HOTEL,
           (select sd.SYSTEM_DATE
            from   SYSTEM_DATE_GET (rd.ID_HOTEL) sd)
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :id_reserv_detail, :id_room, :rd_dbkey, :id_hotel, :sys_date
  do begin

    for
      select G.ID_GUEST, G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.CHECK_STATUS = 0 /* checked in */
      into   :id_guest, :g_dbkey
    do begin
      if (:CHECK_OUT_KIND = 3) then begin
        -- DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
        update GUEST G
        set    G.EARLYCHECKOUT_DATE = :sys_date
        where  g.RDB$DB_KEY = :g_dbkey;

        execute procedure GUEST_SET_MANUAL_STAY$INT(:rd_dbkey, :id_guest, :sys_date)
        returning_values  :err_code, :err_text;
        if (:err_code < 0) then exception RESERV_CHECK_OUT_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end

      update ACCOUNT_POST AP
      set    AP.IS_ARCHIVE = 1
      where  AP.ID_GUEST = :id_guest;
    
      execute procedure GUEST_SET_STATUS$INT (:g_dbkey, :checkout_status);

      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, :action_code, '');
    end

    if (:CHECK_OUT_KIND = 3) then begin
      -- DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
      execute procedure OCCUPANCY_RESERV$INT(:rd_dbkey)
      returning_values  :err_code, :err_text, :warn_code;
      if (:err_code < 0) then exit;
    end

    execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

    execute procedure SETTING_GET_VALUE('CLEANING_RESTRICTION', :id_hotel)
    returning_values  :cleaning_restriction;
  
    if (:cleaning_restriction <> '0' and :id_room > 0) then begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'CHECK_OUT', 'set_dirty');
    end

    execute procedure RES_SAVE_STATUS$INT (:rd_dbkey, :checkout_status);

    execute procedure RES_BONUSPOINTS_APPLY$CL (:id_reserv_detail);
  end

end
^

/* Restore proc. body: RES_CHECKIN$RSV */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable old_check_status integer;
  declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable is_anul integer;
  declare variable arrival_date date;
  declare variable system_date date;
begin
  /*  Description:
  ||
  */
  select RD.CHECK_STATUS, RD.RDB$DB_KEY, RD.FROM_DATE, RD.ID_HOTEL,
         RD.ID_ROOM, RD.IS_ANUL
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_check_status, :rd_dbkey, :arrival_date, :id_hotel,
         :old_id_room, :is_anul;

  if (:is_anul = 1) then exception RESERVATION_IS_ANNULED;

  if (:old_check_status >= 0) then exception BOOKING_EXCEPTION '-1003';

  if (:old_id_room < 0 and coalesce(:ID_ROOM, 0) <= 0) then exception BOOKING_EXCEPTION '-1018';

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date < :arrival_date) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CHECK_IN_FUTURE');
  end
  /*----*/
  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'lock');

  execute procedure sys_dbg('occ RES_CHECKIN$RSV id_room = '||coalesce(:id_room, 'null'));
  execute procedure sys_dbg('occ RES_CHECKIN$RSV old_id_room = '||coalesce(:old_id_room, 'null'));

  if (:id_room is not null) then begin
    if (:old_check_status = -3) then begin
      execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, -2);
    end

    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option);
  end

  execute procedure RES_SET_CHECKIN$INT (:rd_dbkey)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'release');
  /*----*/
  select f_character(29) || R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = coalesce(:ID_ROOM, :old_id_room)
  into   :action_text;
   
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'CHECK_IN', :action_text);

end
^

/* Restore proc. body: RES_CREATE_LOG$INT */
ALTER PROCEDURE RES_CREATE_LOG$INT(RD_DBKEY CHAR(8))
 AS
declare variable action_text varchar(255);
  declare variable room_name varchar(30);
  declare variable agent_profile varchar(100);
  declare variable tarifa_name varchar(50);
  declare variable type_hrana varchar(30);
  declare variable id_reserv_detail integer;
  declare variable number varchar(62);
  declare variable arrival_date date;
  declare variable departure_date date;
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable custom_price numeric(15,4);
  declare variable custom_currency varchar(3);
  declare variable id_event_log integer;
begin
  select rd.ID_RESERV_DETAIL, rd.NUMBER, rd.FROM_DATE, rd.TO_DATE, rd.ADULT_COUNT, rd.CHILD_COUNT,
         rt.TYPE_ROOM || ' ' || coalesce (R.ROOM_NAME, ''),
         P.PROFILE_NAME, T.TARIFA_NAME, TH.NAME, rd.CUSTOM_PRICE, rd.CUSTOM_CURRENCY
  from   RESERV_DETAIL RD
         left outer join ROOM_TYPES RT on rt.ID_ROOM_TYPE = rd.ID_ROOM_TYPE
         left outer join ROOMS R on R.ID_ROOM_TYPE = RT.ID_ROOM_TYPE and R.ID_ROOM = rd.ID_ROOM
         left outer join PROFILE P on P.ID_PROFILE = rd.ID_AGENT_PROFILE
         left outer join TARIFA T on T.ID_TARIFA = RD.ID_RATE
         left outer join MEALS TH on TH.ID_BOARD = rd.ID_BOARD
  where  RD.RDB$DB_KEY = :RD_DBKEY
  into   :id_reserv_detail, :number, :arrival_date, :departure_date, :adult_count, :child_count,
         :room_name,
         :agent_profile, :tarifa_name, :type_hrana, :custom_price, :custom_currency;

  action_text = substring(f_character(29) || :number
                || f_character(28) || formatdate(:arrival_date, 'D;dd.mm.yyyy') || '-' || formatdate(:departure_date, 'D;dd.mm.yyyy')
                || f_character(28) || :room_name
                || f_character(28) || :ADULT_COUNT || '+' || :CHILD_COUNT
                || f_character(28) || coalesce(:type_hrana, '')
                || f_character(28) || coalesce(substring(:agent_profile from 1 for 50), '')
                || f_character(28) || :tarifa_name
                || f_character(28) || coalesce(formatfloat(:custom_price, '0.00') || ' ' || :custom_currency, '')
                from 1 for 255);

  execute procedure SYSTEM_EVENT_LOG$INT ('RES_DETAIL', :id_reserv_detail, 'RES_CREATE', :action_text)
  returning_values :id_event_log;

  if (:id_event_log is not null) then
    update RESERV_DETAIL R
    set    r.ID_LOG_EVENT_CREATE = :id_event_log
    where  r.RDB$DB_KEY = :RD_DBKEY;
end
^

/* Restore proc. body: RES_DELETE$INT */
ALTER PROCEDURE RES_DELETE$INT(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable rd_dbkey char(8);
  declare variable id_guest integer;
  declare variable action_text varchar(255);
  declare variable from_date date;
  declare variable to_date date;
  declare variable room_type varchar(20);
  declare variable number varchar(62);
  declare variable tmp_extra_posts_left integer;
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_DELETE');

  select RD.RDB$DB_KEY, RD.FROM_DATE, rd.TO_DATE, RT.TYPE_ROOM, rd.NUMBER
  from   RESERV_DETAIL RD
         left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = RD.ID_ROOM_TYPE
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey, :from_date, :to_date, :room_type, :number;

  update RESERV_DETAIL R
  set    r.ID_TITULAR = null
  where  r.RDB$DB_KEY = :rd_dbkey;

  EXTRA_POSTS_LEFT = 0;
  for
    select G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_guest
  do begin
    execute procedure RES_GUEST_DEL$INT(:id_guest, :id_reserv_detail, :REASON)
    returning_values  :tmp_extra_posts_left;
    EXTRA_POSTS_LEFT = iif(:EXTRA_POSTS_LEFT = 1, 1, :tmp_extra_posts_left);
  end

  execute procedure RES_FINALIZE$INT (:RD_DBKEY, 1)
  returning_values (:warn_code);


  execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

  action_text = f_character(29) || coalesce(:number, '')
                || f_character(28) || coalesce(:room_type, '')
                || f_character(28) || :from_date
                || f_character(28) || :to_date
                || f_character(28) || :reason;
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'DELETE', :action_text);

  delete from RESERV_DETAIL RDD
  where  RDD.RDB$DB_KEY = :rd_dbkey;

  delete from XML_MESSAGE$EXC xml
  where  xml.OBJECT_TYPE = 'BOOKING'
         and xml.OBJECT_ID = :number;

end
^

/* Restore proc. body: RES_GUEST_ADD$RSV */
ALTER PROCEDURE RES_GUEST_ADD$RSV(ID_RESERV_DETAIL INTEGER,
IS_CHILD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_GUEST INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable action_text varchar(255);
begin
  warn_code = 0;
  err_code = 0;
  err_text = '';

  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey;

  execute procedure RES_GUEST_ADD$INT(:rd_dbkey, :IS_CHILD)
  returning_values  :NEW_ID_GUEST;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :NEW_ID_GUEST
  into   :ACTION_TEXT;
   
  ACTION_TEXT = F_CHARACTER(29) || '"' || :ACTION_TEXT || '" (' || :NEW_ID_GUEST || ')';
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_GUEST_ADD', :ACTION_TEXT);

end
^

/* Restore proc. body: RES_GUEST_CHANGE$RSV */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable id_guest integer;
  declare variable check_status integer;
  declare variable id_person_data integer;
  declare variable old_person_profile integer;
  declare variable old_profile_name varchar(100);
  declare variable new_profile_name varchar(100);
  declare variable acc_routing varchar(30);
  declare variable id_organizer integer;
  declare variable is_owner_profile integer;
begin
  select r.RDB$DB_KEY, r.ID_TITULAR, r.CHECK_STATUS, r.ID_PERSON_PROFILE, p.PROFILE_NAME,
         r.ACC_ROUTING, r.ID_AGENT_PROFILE
  from   RESERV_DETAIL R
         join PROFILE P on P.ID_PROFILE = r.ID_PERSON_PROFILE
  where  R.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey, :id_guest, :check_status, :old_person_profile, :old_profile_name,
         :acc_routing, :id_organizer;

  if (:old_person_profile = :ID_PERSON_PROFILE) then exit; -- NO CHANGES!

--  execute procedure RIGHTS_CHECK_GRANTED$INT ('RESERV_TITULAR_CHANGE');

  id_person_data = null;
  select pp.ID_PERSON_DATA, p.PROFILE_NAME, iif(op.ID_OWNER is null, 0, 1)
  from   PROFILE_PERSON PP
         join PROFILE P on P.ID_PROFILE = pp.ID_PROFILE
         left outer join OWNER$PMS OP on op.ID_OWNER = p.ID_PROFILE
  where  pp.ID_PROFILE = :ID_PERSON_PROFILE
  into   :id_person_data, :new_profile_name, :is_owner_profile;

  if (:id_person_data is null) then exception BOOKING_EXCEPTION '-1039';

  if (:acc_routing = 'OWNER'
      and :is_owner_profile = 0
      and not exists (select o.ID_OWNER
                      from   OWNER$PMS O
                      where  o.ID_OWNER = :id_organizer)) then
  begin
    exception BOOKING_EXCEPTION '-1041';
  end

  update RESERV_DETAIL RD
  set    rd.ID_PERSON_PROFILE = :ID_PERSON_PROFILE
  where  rd.RDB$DB_KEY = :rd_dbkey;

  if (:check_status = 1) then begin
    execute procedure PERSON_DATA_COPY$INT (:id_person_data)
    returning_values (:id_person_data);
  end

  update GUEST_DATA GD
  set    gd.ID_PERSON_DATA = :id_person_data
  where  gd.ID_GUEST = :id_guest;

  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey);

  if (exists (select ap.ID_ACCOUNT_POST
              from   ACCOUNT_POST AP
                     join ACCOUNT A on A.ID_ACCOUNT = ap.ID_ACCOUNT
              where  a.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                     and a.ID_PROFILE = :old_person_profile
                     and ap.IS_ANUL = 0)) then
    exception BOOKING_EXCEPTION '-1038';

  if (exists (select d.ID_DEPOSIT
              from   DEPOSITS D
                     join ACCOUNT A on A.ID_ACCOUNT = d.ID_ACCOUNT
              where  a.ID_PROFILE = :old_person_profile
                     and coalesce(d.ID_RESERV_DETAIL, a.ID_RESERV_DETAIL) = :ID_RESERV_DETAIL
                     and d.RECEIVED_AMOUNT > 0)) then
    exception BOOKING_EXCEPTION '-1040';

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'TITULAR_CHANGED',
          f_character(29) || :old_profile_name || f_character(28) || :new_profile_name, null);

end
^

/* Restore proc. body: RES_GUEST_DEL$INT */
ALTER PROCEDURE RES_GUEST_DEL$INT(ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50) = null)
 RETURNS(EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable id_profile integer;
  declare variable action_text varchar(255);
  declare variable is_spawned_by_this_reservation integer;
  declare variable guest_name varchar(100);
  declare variable is_child smallint;
BEGIN

  select PP.ID_PROFILE, pd.PERSON_NAME, G.IS_CHILD
  from   GUEST g
         join GUEST_DATA GD on gd.ID_GUEST = g.ID_GUEST
         join PERSON_DATA PD on PD.ID_PERSON_DATA = gd.ID_PERSON_DATA
         join RESERV_DETAIL RED on RED.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
         left outer join PROFILE_PERSON PP on PP.ID_PERSON_DATA = GD.ID_PERSON_DATA
  where  G.ID_GUEST = :ID_GUEST
  into   :id_profile, :guest_name, :is_child;

  execute procedure GUEST_DEL_POSTINGS$INT(:id_guest)
  returning_values :EXTRA_POSTS_LEFT;

/*  delete from GUEST G where G.ID_GUEST = :ID_GUEST;*/

  update GUEST G
  set    G.ID_RESERV_DETAIL = null
  where  G.ID_GUEST = :id_guest;

  update RESERV_DETAIL RD
  set    RD.ADULT_COUNT = RD.ADULT_COUNT - (1 - :is_child),
         RD.CHILD_COUNT = RD.CHILD_COUNT - :is_child
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL;

  action_text = f_character(29) || '"' || :guest_name || '" (' || :id_guest || ')' || f_character(28) || coalesce(:REASON, '');
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_GUEST_DEL', :action_text);

  is_spawned_by_this_reservation = 0; --TODO proper initialization needed
  if (:is_spawned_by_this_reservation = 1) then begin
    execute procedure PROFILE_DELETE$INT(:id_profile);

    when any do exit;
  end
END
^

/* Restore proc. body: RES_GUEST_SAVE_BOARD$RSV */
ALTER PROCEDURE RES_GUEST_SAVE_BOARD$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_BOARD INTEGER)
 AS
declare variable id_reserv_detail integer;
declare variable old_id_board integer;
  declare variable action_text varchar(255);
  declare variable guest_name varchar(50);
  declare variable old_board_name varchar(50);
  declare variable new_board_name varchar(50);
begin
  ID_BOARD = :ID_BOARD;
  if (:ID_BOARD = -1) then begin
    -- default to booking board
    select rd.ID_BOARD
    from   GUEST g
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :ID_GUEST
    into   :ID_BOARD;
  end

  update GUEST_STAY GS
  set    gs.ID_BOARD = :ID_BOARD
  where  gs.ID_GUEST = :ID_GUEST
         and gs.FOR_DATE = :FOR_DATE
  returning old.id_board
  into      :old_id_board;

  if (:old_id_board is distinct from :ID_BOARD) then begin
    select g.ID_RESERV_DETAIL, gc.GUEST_NAME1
    from   GUEST G
           left join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
    where  g.ID_GUEST = :ID_GUEST
    into   :id_reserv_detail, :guest_name;

    select M.NAME
    from   MEALS M
    where  M.ID_BOARD = :old_id_board
    into   :old_board_name;

    select M.NAME
    from   MEALS M
    where  M.ID_BOARD = :ID_BOARD
    into   :new_board_name;

    action_text = f_character(29) || :guest_name
                  || f_character(28) || formatdate(:for_date, 'd;dd.mm.yyyy')
                  || f_character(28) || coalesce(:new_board_name, '')
                  || f_character(28) || coalesce(:old_board_name, '');
    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'GUEST_DIFF_BOARD', :action_text);
  end
end
^

/* Restore proc. body: RES_GUEST_SAVE_OTHER$RSV */
ALTER PROCEDURE RES_GUEST_SAVE_OTHER$RSV(ID_GUEST INTEGER,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE)
 AS
declare variable g_dbkey char(8);
  declare variable old_code_first_food tfood_code;
  declare variable old_text_first_food varchar(50);
  declare variable text_first_food varchar(50);
  declare variable action_text varchar(255);
begin
  select G.RDB$DB_KEY, G.CODE_FIRST_FOOD
  from   GUEST G
  where  G.ID_GUEST = :id_guest
  into   :g_dbkey, :old_code_first_food;

  execute procedure RES_GUEST_SAVE_OTHER$INT(:g_dbkey, :transfer_in_time, :transfer_in_note,
          :transfer_out_time, :transfer_out_note, :code_first_food);

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -1);

  if (coalesce(:old_code_first_food, 0) <> coalesce(:code_first_food, 0)) then begin
    old_text_first_food = case
                              when :old_code_first_food = 'breakfast' then 'caption.breakfast'
                              when :old_code_first_food = 'lunch' then 'caption.launch'
                              when :old_code_first_food = 'dinner' then 'caption.dinner'
                              when :old_code_first_food = 'extrafood1' then 'caption.extrafood1'
                              when :old_code_first_food = 'extrafood2' then 'caption.extrafood2'
                              when :old_code_first_food = 'none' then 'caption.no_first_food'
                          end;
    text_first_food = case
                              when :code_first_food = 'breakfast' then 'caption.breakfast'
                              when :code_first_food = 'lunch' then 'caption.launch'
                              when :code_first_food = 'dinner' then 'caption.dinner'
                              when :code_first_food = 'extrafood1' then 'caption.extrafood1'
                              when :code_first_food = 'extrafood2' then 'caption.extrafood2'
                              when :code_first_food = 'none' then 'caption.no_first_food'
                      end;
    action_text = f_character(29) || coalesce('@{' || :old_text_first_food || '}', '') ||
                  f_character(28) || coalesce('@{' || :text_first_food || '}', '');
    execute procedure SYSTEM_LOG_ADD ('GUEST', :ID_GUEST, 'FIRST_FOOD_CHANGED', :ACTION_TEXT);
  end
end
^

/* Restore proc. body: RES_GUEST_SAVE_RATE$RSV */
ALTER PROCEDURE RES_GUEST_SAVE_RATE$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TARIFF INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_tariff integer;
  declare variable guest_name varchar(50);
  declare variable action_text varchar(255);
  declare variable old_rate varchar(50);
  declare variable new_rate varchar(50);
begin

  /*select G.TO_DATE - 1, G.ID_RESERV_DETAIL, GC.GUEST_NAME1
  from   GUEST G
         left join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
  where  G.ID_GUEST = :ID_GUEST
  into   :TO_DATE, :ID_RESERV_DETAIL, :GUEST_NAME;
  IS_DEPARTURE = iif(:TO_DATE = :FOR_DATE, 1, 0);

  select GS.ID_ROOM_TYPE, GS.ID_BOARD, GS.ID_TYPE_STAY, GS.ID_TARIFF
  from   GUEST_STAY GS
  where  GS.ID_GUEST = :ID_GUEST
         and GS.FOR_DATE = :FOR_DATE
  into   :ID_TAR_ROOM_TYPE, :ID_BOARD, :ID_TYPE_STAY, :OLD_ID_TARIFF;

  execute procedure RES_GUEST_DYNAMICPARAMS_SAVE(:ID_RESERV_DETAIL, :ID_GUEST, :FOR_DATE,
          :ID_TAR_ROOM_TYPE, :ID_BOARD, :ID_TYPE_STAY, :ID_TARIFF, :IS_DEPARTURE);
  */
  if (:ID_TARIFF = -1) then begin
    -- default to booking board
    select rd.ID_RATE
    from   GUEST g
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :ID_GUEST
    into   :ID_TARIFF;
  end

  update GUEST_STAY GS
  set    gs.ID_TARIFF = :ID_TARIFF
  where  gs.ID_GUEST = :ID_GUEST
         and gs.FOR_DATE = :FOR_DATE
  returning old.id_tariff
  into      :old_id_tariff;
  --

  if (:OLD_ID_TARIFF <> :ID_TARIFF) then begin
    select g.ID_RESERV_DETAIL, gc.GUEST_NAME1
    from   GUEST G
           left join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
    where  g.ID_GUEST = :ID_GUEST
    into   :id_reserv_detail, :guest_name;

    select T.TARIFA_NAME
    from   TARIFA T
    where  T.ID_TARIFA = :old_id_tariff
    into   :old_rate;
     
    select T.TARIFA_NAME
    from   TARIFA T
    where  T.ID_TARIFA = :ID_TARIFF
    into   :new_rate;
     
    action_text = f_character(29) || :guest_name
                  || f_character(28) || formatdate(:for_date, 'D;dd.mm.yyyy')
                  || f_character(28) || :new_rate
                  || f_character(28) || :old_rate;
    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :ID_RESERV_DETAIL, 'GUEST_DIFF_TARIFF', :ACTION_TEXT);
  end
end
^

/* Restore proc. body: RES_GUEST_SAVE_ROOMTYPE$RSV */
ALTER PROCEDURE RES_GUEST_SAVE_ROOMTYPE$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TAR_ROOM_TYPE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_room_type integer;
  declare variable action_text varchar(255);
  declare variable guest_name varchar(50);
  declare variable old_room_type varchar(50);
  declare variable new_room_type varchar(50);
begin
 /* select G.TO_DATE - 1, G.ID_RESERV_DETAIL, GC.GUEST_NAME1
  from   GUEST G
         left outer join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
  where  G.ID_GUEST = :ID_GUEST
  into   :to_date, :id_reserv_detail, :guest_name;
  is_departure = iif(:to_date = :for_date, 1, 0);

  select GS.ID_TARIFF, GS.ID_BOARD, GS.ID_TYPE_STAY, GS.ID_ROOM_TYPE
  from   GUEST_STAY GS
  where  GS.ID_GUEST = :ID_GUEST
         and GS.FOR_DATE = :FOR_DATE
  into   :id_tariff, :id_board, :id_type_stay, :old_id_room_type;

  execute procedure RES_GUEST_DYNAMICPARAMS_SAVE(:id_reserv_detail, :id_guest, :for_date,
          :id_tar_room_type, :id_board, :id_type_stay, :id_tariff, :is_departure);
  */
  --
  update GUEST_STAY GS
  set    gs.ID_ROOM_TYPE = :ID_TAR_ROOM_TYPE
  where  gs.ID_GUEST = :ID_GUEST
         and gs.FOR_DATE = :FOR_DATE
  returning old.ID_ROOM_TYPE
  into      :old_id_room_type;

  if (:OLD_ID_ROOM_TYPE <> :ID_TAR_ROOM_TYPE) then begin
    select g.ID_RESERV_DETAIL, gc.GUEST_NAME1
    from   GUEST G
           left join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
    where  g.ID_GUEST = :ID_GUEST
    into   :id_reserv_detail, :guest_name;

    if (:old_id_room_type = -1) then begin
      old_room_type = '@{other.AUTO_TYPE_STAY}';
    end else begin
      select RT.TYPE_ROOM
      from   ROOM_TYPES RT
      where  RT.ID_ROOM_TYPE = :old_id_room_type
      into   :old_room_type;
    end

    if (:ID_TAR_ROOM_TYPE = -1) then begin
      new_room_type = '@{other.AUTO_TYPE_STAY}';
    end else begin
      select RT.TYPE_ROOM
      from   ROOM_TYPES RT
      where  RT.ID_ROOM_TYPE = :ID_TAR_ROOM_TYPE
      into   :new_room_type;
    end

    action_text = f_character(29) || :guest_name
                  || f_character(28) || formatdate(:for_date, 'd;dd.mm.yyyy')
                  || f_character(28) || :new_room_type
                  || f_character(28) || :old_room_type;
    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'GUEST_DIFF_ROOM_TYPE', :action_text);
  end
end
^

/* Restore proc. body: RES_GUEST_SAVE_STAY$RSV */
ALTER PROCEDURE RES_GUEST_SAVE_STAY$RSV(ID_GUEST INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable g_dbkey char(8);
declare variable id_hotel integer;
  declare variable old_arrival date;
  declare variable old_departure date;
  declare variable action_text varchar(255);
begin
  err_code = 0;
  warn_code = 0;
  select G.RDB$DB_KEY, RD.ID_HOTEL, G.FROM_DATE, G.TO_DATE
  from   GUEST G
         join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
  where  G.ID_GUEST = :id_guest
  into   :g_dbkey, :id_hotel, :old_arrival, old_departure;

  execute procedure RES_GUEST_SAVE_STAY$INT(:g_dbkey, :arrival_date, :departure_date, :id_hotel);

  if ((:old_arrival <> :arrival_date) or (:old_departure <> :departure_date) ) then begin
    action_text = f_character(29) || '{' || formatdate(:old_arrival, 'D;dd.mm.yyyy') || '-' || formatdate(:old_departure, 'D;dd.mm.yyyy') || '}'
                  || f_character(28) || '{' || formatdate(:arrival_date, 'D;dd.mm.yyyy') || '-' || formatdate(:departure_date, 'D;dd.mm.yyyy') || '}';
    execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'GUEST_MOD_PERIOD', :action_text);
  end
end
^

/* Restore proc. body: RES_GUEST_SAVE_TYPESTAY$RSV */
ALTER PROCEDURE RES_GUEST_SAVE_TYPESTAY$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TYPE_STAY INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_type_stay integer;
  declare variable action_text varchar(255);
  declare variable guest_name varchar(50);
  declare variable old_type_stay varchar(50);
  declare variable new_type_stay varchar(50);
begin
/*  select G.TO_DATE - 1, G.ID_RESERV_DETAIL, GC.GUEST_NAME1
  from   GUEST G
         left outer join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
  where  G.ID_GUEST = :ID_GUEST
  into   :to_date, :id_reserv_detail, :guest_name;
  is_departure = iif(:TO_DATE = :FOR_DATE, 1, 0);

  select GS.ID_ROOM_TYPE, GS.ID_TARIFF, GS.ID_BOARD, GS.ID_TYPE_STAY
  from   GUEST_STAY GS
  where  GS.ID_GUEST = :ID_GUEST
         and GS.FOR_DATE = :FOR_DATE
  into   :id_tar_room_type, :id_tariff, :id_board, :old_id_type_stay;

  execute procedure RES_GUEST_DYNAMICPARAMS_SAVE(:id_reserv_detail, :id_guest, :for_date,
          :id_tar_room_type, :id_board, :id_type_stay, :id_tariff, :is_departure);
  */
  --
  update GUEST_STAY GS
  set    gs.ID_TYPE_STAY = :ID_TYPE_STAY
  where  gs.ID_GUEST = :ID_GUEST
         and gs.FOR_DATE = :FOR_DATE
  returning old.ID_TYPE_STAY
  into      :old_id_type_stay;

  if (:old_id_type_stay <> :id_type_stay) then begin
    select g.ID_RESERV_DETAIL, gc.GUEST_NAME1
    from   GUEST G
           left join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
    where  g.ID_GUEST = :ID_GUEST
    into   :id_reserv_detail, :guest_name;

    if (:old_id_type_stay = -1) then begin
      old_type_stay = '@{other.AUTO_TYPE_STAY}';
    end else begin
      select TS.TYPE_STAY
      from   TYPE_STAY TS
      where  TS.ID_TYPE_STAY = :old_id_type_stay
      into   :old_type_stay;
    end
    if (:ID_TYPE_STAY = -1) then begin
      new_type_stay = '@{other.AUTO_TYPE_STAY}';
    end else begin
      select TS.TYPE_STAY
      from   TYPE_STAY TS
      where  TS.ID_TYPE_STAY = :id_type_stay
      into   :new_type_stay;
    end
     
    action_text = f_character(29) || :guest_name
                  || f_character(28) || formatdate(:for_date, 'd;dd.mm.yyyy')
                  || f_character(28) || :new_type_stay
                  || f_character(28) || :old_type_stay;
    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'GUEST_DIFF_TYPESTAY', :action_text);
  end
end
^

/* Restore proc. body: RES_RECALC$INT */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable num_prefix varchar(20);
  declare variable number_1 varchar(20);
begin
  /* CALLER_KIND = {NORMAL, FORCED} */
  err_code = 0;

  /* 1. GET DATA */
  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL, rd.NUMBER_1
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :check_status, :id_reserv_detail, :number_1;

  if (:check_status = 1) then begin
    -- CHECKED OUT
    select sn.LEADING_PART
    from   SYSTEM_NUMERATOR SN
    where  sn.ID_NUMERATOR = 0
    into   :num_prefix;

    if (trim('.' from coalesce(:num_prefix, '')) = coalesce(:number_1, '')) then
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_MINE');
    else
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_ELSE');

    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :id_guest
    do begin
      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'MANUAL_EDIT_DATA', '');
    end
  end
  /* 2. FIND DEPENDANT GUESTS AND THEIR TARIFFS */
  execute procedure sys_dbg('calc RES_RECALC$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

  id_tar_calc = gen_id(gen_id_tar_calc, 1);
  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NONE');

  execute procedure TAR_CALC_EVAL_ALL$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  -- 3. UPDATE ROOM PRICE and REPOST ALL AFFECTED BOOKINGS
  execute procedure RES_TAR_CALC_FINALIZE$INT (:ERR_CODE, :ID_TAR_CALC, :RD_DBKEY, :CALLER_KIND, :FORCE_POSTING);

end
^

/* Restore proc. body: RES_RECALC$RSV */
ALTER PROCEDURE RES_RECALC$RSV(ID_RESERV_DETAIL INTEGER,
FORCE_POSTING SMALLINT = null)
 AS
declare variable id_tar_calc integer;
declare variable err_text varchar(255);
  declare variable err_code integer;
  declare variable rd_dbkey char(8);
begin
  -- FORCED, user activated recalculation
  execute procedure RIGHTS_CHECK_GRANTED$INT ('GUEST_RECALC_POST');

  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_RECALC$INT(:rd_dbkey, 'FORCED', :FORCE_POSTING)
  returning_values  :err_code, :err_text, :id_tar_calc;
  if (:err_code < 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || :err_text;

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'FORCED_RECALC', null);

end
^

/* Restore proc. body: RES_SAVE_ACCOUNTING$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
declare variable old_id_agent_profile integer;
  declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable action_text varchar(255);
  declare variable old_account_routing varchar(30);
  declare variable id_acc_profile integer;
begin
  /* Description : ACC_ROUTING = {GUEST, AGENT, MIXED, OWNER, GUEST_SEPARATE_ACCOUNTS, PART_COMPLIMENTARY, FULL_COMPLIMENTARY }
  ||
  *//*
  execute procedure RES_SAVE_PROFILING$INT (:RD_DBKEY, :ID_AGENT_PROFILE, :ID_AGENT_ACCOUNT, :ID_AGENT_PAYMENT,
          :id_person_profile, :ID_PERSON_PAYMENT, :ACC_ROUTING, :ID_GROUP);
  */
  execute procedure SYSTEM_CHECK_OPERATION(:acc_routing, 'GUEST, AGENT, MIXED, OWNER, FULL_COMPLIMENTARY, PART_COMPLIMENTARY', 'Account routing');

  if (exists (select *
              from   PROFILE_HOUSE PH
              where  PH.ID_PROFILE = :id_agent_profile)) then
  begin
    exception BOOKING_EXCEPTION '-1016';
  end

  execute procedure RESERV_TRACK_CHANGES$INT(:rd_dbkey);

  select RD.ID_AGENT_PROFILE, RD.ID_RESERV_DETAIL, RD.ACC_ROUTING
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_agent_profile, :id_reserv_detail, :old_account_routing;

  if (:ACC_ROUTING in ('AGENT','MIXED') and :ID_AGENT_ACCOUNT is not null) then begin
    select A.ID_PROFILE
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :ID_AGENT_ACCOUNT
    into   :id_acc_profile;
    -- check up agent account ownership
    if (:id_acc_profile is distinct from :ID_AGENT_PROFILE) then ID_AGENT_ACCOUNT = null;
--    if (:id_acc_profile is distinct from :ID_AGENT_PROFILE) then exception BOOKING_EXCEPTION '-1026';
  end

  update RESERV_DETAIL RD
  set    RD.ID_AGENT_ACCOUNT_RULE = :ID_AGENT_ACCOUNT,
         RD.ACC_ROUTING = :ACC_ROUTING,
         RD.ID_AGENT_PROFILE = :ID_AGENT_PROFILE,
         RD.ID_AGENT_PAYMENT = :ID_AGENT_PAYMENT,
         --RD.ID_PERSON_PROFILE = :ID_PERSON_PROFILE,
         RD.ID_PERSON_PAYMENT = coalesce(:ID_PERSON_PAYMENT, RD.ID_PERSON_PAYMENT),
         RD.ID_GROUP = :ID_GROUP
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_id_agent_profile is distinct from :id_agent_profile) then begin
    execute procedure RES_SET_EDIT_STATUS$INT(:RD_DBKEY, 'AGENT', 'add');

    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :g_dbkey
    do begin
      execute procedure GUEST_AGENT_SET$INT(:g_dbkey, :id_agent_profile);
    end

    select f_character(29)||coalesce(old_A.PROFILE_NAME, '')||f_character(28)||coalesce(new_A.PROFILE_NAME, '')
    from   PROFILE old_A, PROFILE new_A
    where  old_A.ID_PROFILE = :old_id_agent_profile
           and new_A.ID_PROFILE = :ID_AGENT_PROFILE
    into   :action_text;

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_AGENT', :action_text);
  end

  if (:ACC_ROUTING <> :old_account_routing) then begin
    action_text = f_character(29) || coalesce(:old_account_routing, '')
                  || f_character(28) || coalesce(:acc_routing, '');

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_ACC_ROUTING', :action_text);
  end

  execute procedure RES_SAVE_ACCOUNTS$INT (:RD_DBKEY);
end
^

/* Restore proc. body: RES_SAVE_ACCOUNTS_FINALIZE$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTS_FINALIZE$INT(ID_RESERV_DETAIL INTEGER,
OLD_ID_BASE_ACCOUNT INTEGER,
OLD_ID_EXTRA_ACCOUNT INTEGER,
NEW_ID_BASE_ACCOUNT INTEGER,
NEW_ID_EXTRA_ACCOUNT INTEGER)
 AS
declare variable id_old_account integer;
  declare variable action_text varchar(255);
  declare variable acc_name varchar(50);
  declare variable is_used integer;
begin
  if (:NEW_ID_BASE_ACCOUNT is distinct from :OLD_ID_BASE_ACCOUNT) then begin
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :OLD_ID_BASE_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = F_CHARACTER(29) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:OLD_ID_BASE_ACCOUNT, '')  || ')';
    ACC_NAME = null;
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :NEW_ID_BASE_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = :ACTION_TEXT || F_CHARACTER(28) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:NEW_ID_BASE_ACCOUNT, '')  || ')';

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_MOD_BASE_ACCOUNT', :ACTION_TEXT);
  end

  ACTION_TEXT = '';
  ACC_NAME = null;
  if (:NEW_ID_EXTRA_ACCOUNT is distinct from :OLD_ID_EXTRA_ACCOUNT) then begin
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :OLD_ID_EXTRA_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = F_CHARACTER(29) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:OLD_ID_EXTRA_ACCOUNT, '')  || ')';
    ACC_NAME = null;
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :NEW_ID_EXTRA_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = :ACTION_TEXT || F_CHARACTER(28) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:NEW_ID_EXTRA_ACCOUNT, '')  || ')';

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_MOD_EXTRA_ACCOUNT', :ACTION_TEXT);
  end

  -- Archivate old unused accounts
  for
    select A.ID_ACCOUNT
    from   ACCOUNT_S A
    where  A.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
           and A.IS_ARCHIVE = 0
           and A.ID_ACCOUNT <> :NEW_ID_BASE_ACCOUNT
           and A.ID_ACCOUNT <> :NEW_ID_EXTRA_ACCOUNT
           and A.IS_CREDIT_ACCOUNT = 0
           and not exists(select G.ID_GUEST
                          from   GUEST G
                          where  (G.ID_BASE_ACCOUNT = A.ID_ACCOUNT)
                                 or (G.ID_ACCOUNT = A.ID_ACCOUNT))
    into   :ID_OLD_ACCOUNT
  do begin
    select auc.is_used
    from   ACCOUNT_USE_CHECK$INT(:id_old_account) auc
    into   :is_used;

    if (:is_used = 0) then begin
      delete from ACCOUNT A
      where  a.ID_ACCOUNT = :id_old_account;
    end else begin
      -- cannot be deleted, because of available postings,corrections or payments (deposits)
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS (:ID_OLD_ACCOUNT, 1);
  
      when exception ACCOUNT_EXCEPTION do post_event 'dummy';
    end
  end 
end
^

/* Restore proc. body: RES_SAVE_BOARD$INT */
ALTER PROCEDURE RES_SAVE_BOARD$INT(RD_DBKEY CHAR(8),
ID_BOARD INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_guest integer;
  declare variable old_id_board integer;
  declare variable action_text varchar(255);
  declare variable old_board varchar(30);
  declare variable new_board varchar(30);
begin
  id_board = :ID_BOARD;
  select RD.ID_RESERV_DETAIL, RD.ID_BOARD, TH.NAME
  from   RESERV_DETAIL RD
         left outer join MEALS TH on TH.ID_BOARD = RD.ID_BOARD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail, :old_id_board, :old_board;

  update RESERV_DETAIL RD
  set    RD.ID_BOARD = :id_board,
         RD.HAS_DIFFERENT_BOARD = 0
  where  RD.RDB$DB_KEY = :rd_dbkey;

  for
    select G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_guest
  do begin
    update GUEST_STAY GS
    set    GS.ID_BOARD = :id_board
    where  GS.ID_GUEST = :id_guest;
  end

  execute procedure RES_GUESTDATA_INVALIDATE$INT(:rd_dbkey);

  if (:old_id_board is distinct from :id_board) then begin
    select TH.NAME
    from   MEALS TH
    where  TH.ID_BOARD = :id_board
    into   :new_board;

    action_text = f_character(29) || coalesce(:old_board, '') || f_character(28) || coalesce(:new_board, '');
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'BOARD_CHANGED', :action_text);
  end
end
^

/* Restore proc. body: RES_SAVE_GUARANTEE$RSV */
ALTER PROCEDURE RES_SAVE_GUARANTEE$RSV(ID_RESERV_DETAIL INTEGER,
IS_VIP SMALLINT,
CHECK_STATUS INTEGER,
ID_GUARANTEE_POLICY INTEGER,
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER)
 AS
declare variable old_check_status integer;
declare variable warn_code integer;
declare variable rd_dbkey char(8);
declare variable action_text varchar(255);
begin
  /*  Description:
  ||  GUI facade
  */
  select RD.RDB$DB_KEY, rd.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_check_status;

  update RESERV_DETAIL RDU
  set    RDU.IS_VIP = coalesce(:is_vip, RDU.IS_VIP),
         RDU.ID_GUARANTEE_POLICY = :id_guarantee_policy,
         RDU.GUARANTEE_DEPOSIT = :guarantee_deposit,
         RDU.GUARANTEE_CURRENCY = :guarantee_currency,
         RDU.BLOCK_CC = :BLOCK_CC,
         GUARANTEE_DEPOSIT_PERCENT = :GUARANTEE_DEPOSIT_PERCENT,
         GUARANTEE_DEPOSIT_NIGHTS = :GUARANTEE_DEPOSIT_NIGHTS,
         GUARANTEE_DUE_DAYS_BEF_ARRIVAL = :GUARANTEE_DUE_DAYS_BEF_ARRIVAL,
         GUARANTEE_DUE_DAYS_AFTER_CREATE = :GUARANTEE_DUE_DAYS_AFTER_CREATE
  where  RDU.RDB$DB_KEY = :rd_dbkey;

  action_text = '';
  if (:GUARANTEE_DEPOSIT_PERCENT is not null) then begin
    action_text = f_character(29) || '@{caption.guaranteetype.percent} ' || formatfloat(:GUARANTEE_DEPOSIT_PERCENT, '0.00') || f_character(28)
                  || '[' || coalesce(:GUARANTEE_DUE_DAYS_AFTER_CREATE, ' ') || ']'
                  || f_character(28) || '[' || coalesce(:GUARANTEE_DUE_DAYS_BEF_ARRIVAL, ' ') || ']';
  end
  else if (:GUARANTEE_DEPOSIT_NIGHTS is not null) then begin
    action_text = f_character(29) || '@{caption.guaranteetype.nights} ' || :GUARANTEE_DEPOSIT_NIGHTS || f_character(28)
                  || '[' || coalesce(:GUARANTEE_DUE_DAYS_AFTER_CREATE, ' ') || ']'
                  || f_character(28) || '[' || coalesce(:GUARANTEE_DUE_DAYS_BEF_ARRIVAL, ' ') || ']';
  end
  else if (:GUARANTEE_DEPOSIT is not null) then begin
    action_text = f_character(29) || '@{caption.guaranteetype.fixed} ' || formatfloat(:GUARANTEE_DEPOSIT, '0.00') || ' ' || :GUARANTEE_CURRENCY || f_character(28)
                  || '[' || coalesce(:GUARANTEE_DUE_DAYS_AFTER_CREATE, ' ') || ']'
                  || f_character(28) || '[' || coalesce(:GUARANTEE_DUE_DAYS_BEF_ARRIVAL, ' ') || ']';
  end

  if (:action_text <> '') then begin
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_GUARANTEE_CHANGED', :action_text);
  end

  CHECK_STATUS = coalesce(:CHECK_STATUS, :old_check_status);
  if (:CHECK_STATUS <> :old_check_status) then begin

    if (:CHECK_STATUS >= 0) then exception BOOKING_EXCEPTION 'Can not set status ''CHECKED IN'' or ''CHECKED OUT'' manually!';

    execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, :check_status);

    execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
    returning_values  :warn_code;
  end
end
^

/* Restore proc. body: RES_SAVE_MARKETING$RSV */
ALTER PROCEDURE RES_SAVE_MARKETING$RSV(ID_RESERV_DETAIL INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable rd_dbkey char(8);
declare variable old_mrkt_profile varchar(255);
declare variable new_mrkt_profile varchar(255);
begin
  err_code = 0;
  err_text = '';
  rd_dbkey = null;
  select RD.RDB$DB_KEY, MP.MARKETING_PROFILE
  from   RESERV_DETAIL RD
         left outer join MARKETING_PROFILE_GET (RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_COME_REASON,
              RD.ID_NOM_HEAR_REASON, RD.ID_NOM_SOURCE_CODE, RD.ID_NOM_MARKET_SEGMENT) MP on 1=1
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_mrkt_profile;

  execute procedure RES_SAVE_MARKETING$INT(:rd_dbkey, :id_nom_market_segment,
          :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason);

  select MP.MARKETING_PROFILE
  from   MARKETING_PROFILE_GET (:ID_NOM_CHANNEL_CODE, :ID_NOM_COME_REASON,
              :ID_NOM_HEAR_REASON, :ID_NOM_SOURCE_CODE, :ID_NOM_MARKET_SEGMENT) MP
  into   :new_mrkt_profile;

  if (:new_mrkt_profile is distinct from :old_mrkt_profile) then begin
    execute procedure RESERV_TRACK_CHANGES$INT (:rd_dbkey);

    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'MARKETING_CHANGE',
            f_character(29) || :old_mrkt_profile || f_character(28) || :new_mrkt_profile);
  end
end
^

/* Restore proc. body: RES_SAVE_PRICE$RSV */
ALTER PROCEDURE RES_SAVE_PRICE$RSV(ID_RESERV_DETAIL INTEGER,
FOR_DATE DATE,
PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3))
 AS
declare variable old_price numeric(14,4);
declare variable old_price_currency char(3);
declare variable action_text varchar(255);
declare variable r_dbkey char(8);
begin
  /*Insert OR Update dayli manual price, Delete record if null price received*/
  select rmp.RDB$DB_KEY, rmp.price, rmp.price_currency
  from   reserv_custom_price rmp
  where  rmp.id_reserv_detail = :id_reserv_detail
         and rmp.for_date = :for_date
  into   :r_dbkey, :old_price, :old_price_currency;

  if (:old_price is null) then begin
    if (:price is null) then begin
      post_event 'dummy';
    end else begin
      insert into reserv_custom_price (id_reserv_detail, for_date, price, price_currency)
      values (:id_reserv_detail, :for_date, :price, :price_currency);
    end
  end else begin
    if (:price is null) then begin
      delete from reserv_custom_price r
      where  r.RDB$DB_KEY = :r_dbkey;
    end else begin
      update reserv_custom_price rcp
      set    rcp.for_date = :for_date,
             rcp.price = :price,
             rcp.price_currency = :price_currency
      where  rcp.RDB$DB_KEY = :r_dbkey;
    end
  end

  /*Maintain the flag in RD - HAS_DIFFERENT_PRICE*/
  if (exists (select * from reserv_custom_price rmp where rmp.id_reserv_detail = :id_reserv_detail)) then
    update reserv_detail set has_different_price = 1 where id_reserv_detail = :id_reserv_detail;
  else
    update reserv_detail set has_different_price = 0 where id_reserv_detail = :id_reserv_detail;

  /*Log modifications if here is diferent values*/
  if ((:old_price <> :price) or (:old_price_currency <> :price_currency) ) then begin
    action_text = f_character(29) || :price || '' || :price_currency || f_character(28) || formatdate(:for_date, 'D;dd.mm.yyyy') ;
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_MANUAL_PRICE', :action_text);
  end

end
^

/* Restore proc. body: RES_SAVE_RATE$INT */
ALTER PROCEDURE RES_SAVE_RATE$INT(RD_DBKEY CHAR(8),
ID_RATE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable g_dbkey char(8);
  declare variable id_guest integer;
  declare variable id_old_rate integer;
  declare variable action_text varchar(255);
begin
  select RD.ID_RESERV_DETAIL, rd.ID_RATE
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail, :id_old_rate;

  update RESERV_DETAIL RD
  set    RD.ID_RATE = :id_rate,
         RD.HAS_DIFFERENT_TARIFF = 0
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:ID_RATE is distinct from :id_old_rate) then begin
    select f_character(29) || t.TARIFA_NAME
    from   TARIFA T
    where  t.ID_TARIFA = :id_old_rate
    into   :action_text;

    select :action_text || f_character(28) || t.TARIFA_NAME
    from   TARIFA T
    where  t.ID_TARIFA = :ID_RATE
    into   :action_text;

    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_RATE_CHANGED', :action_text);
  end

  for
    select G.RDB$DB_KEY, G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :g_dbkey, :id_guest
  do begin
    update GUEST GU
    set    GU.ID_TARIFA = :id_rate
    where  GU.RDB$DB_KEY = :g_dbkey;

    update GUEST_STAY GS
    set    GS.ID_TARIFF = :id_rate
    where  GS.ID_GUEST = :id_guest;

    execute procedure RES_GUESTDATA_INVALIDATE$INT(:rd_dbkey);
  end
end
^

/* Restore proc. body: RES_SAVE_RATE$RSV */
ALTER PROCEDURE RES_SAVE_RATE$RSV(ID_RESERV_DETAIL INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
IS_DIFFERENT_TARIFF INTEGER,
IS_DIFFERENT_PRICE INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 AS
declare variable rd_dbkey char(8);
  declare variable old_price numeric(14,4);
  declare variable old_price_currency char(3);
  declare variable action_text varchar(255);
  declare variable err_code integer;
  declare variable err_text varchar(255) ;
begin

  select RD.RDB$DB_KEY, RD.custom_price, rd.custom_currency
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_price, :old_price_currency;

  if (:is_different_tariff = 0) then begin
    execute procedure RES_SAVE_RATE$INT(:rd_dbkey, :id_tariff);
  end else begin
    execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey);
  end

  if (:IS_DIFFERENT_PRICE = 0) then begin
    delete from RESERV_CUSTOM_PRICE
    where  ID_RESERV_DETAIL  = :ID_RESERV_DETAIL;

    update RESERV_DETAIL RD
    set    RD.CUSTOM_PRICE = :custom_price,
           RD.CUSTOM_CURRENCY = :custom_currency
    where  RD.RDB$DB_KEY = :rd_dbkey;
  end else begin
    update RESERV_DETAIL RD
    set    RD.CUSTOM_PRICE = null,
           RD.CUSTOM_CURRENCY = null
    where  RD.RDB$DB_KEY = :rd_dbkey;
  end


  /*Maintain the flag in RD - HAS_DIFFERENT_PRICE*/
  if (exists (select * from RESERV_CUSTOM_PRICE rmp where rmp.id_reserv_detail = :id_reserv_detail)) then
    update RESERV_DETAIL set has_different_price = 1 where id_reserv_detail = :id_reserv_detail;
  else
    update RESERV_DETAIL set has_different_price = 0 where id_reserv_detail = :id_reserv_detail;

  /*Log modifications in custom price if here is diferent values*/
  if ((:old_price is distinct from :custom_price) or (:old_price_currency is distinct from :custom_currency) ) then begin
    action_text = f_character(29) || coalesce(:custom_price, 0) || '' || :custom_currency || f_character(28);
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_MANUAL_PRICE', :action_text);
  end

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    returning_values  :err_code, :err_text;
    if (:err_code < 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || :err_text;
  end
end
^

/* Restore proc. body: RES_SAVE_ROOM_LOG$INT */
ALTER PROCEDURE RES_SAVE_ROOM_LOG$INT(RD_DBKEY CHAR(8),
OLD_ID_ROOM INTEGER,
OLD_ID_RES_ROOM_TYPE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_res_room_type integer;
  declare variable id_room integer;
  declare variable check_status integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable system_date date;
begin

  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL, RD.ID_ROOM_TYPE, RD.ID_ROOM, RD.ID_HOTEL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :check_status, :id_reserv_detail, :id_res_room_type, :id_room, :id_hotel;

  /* LOG SECTION */
  action_text = f_character(29);
  if (:old_ID_RES_ROOM_TYPE is distinct from :ID_RES_ROOM_TYPE) then begin
    select :action_text || '<' || coalesce(rt.TYPE_ROOM, '') || '>'
    from   ROOM_TYPES rt
    where  rt.ID_ROOM_TYPE = :old_id_res_room_type
    into   :action_text;
    action_text = :action_text || f_character(28);
    select :action_text || '<' || coalesce(rt.TYPE_ROOM, '') || '>'
    from   ROOM_TYPES rt
    where  rt.ID_ROOM_TYPE = :ID_RES_ROOM_TYPE
    into   :action_text;
    action_text = :action_text || f_character(28);

    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_ROOM_TYPE_CHANGED', :action_text);
  end

  action_text = f_character(29);
  if (:old_id_room is distinct from :ID_ROOM) then begin
    select :action_text || '<' || coalesce(rt.TYPE_ROOM, '') || ' ' || coalesce (R.ROOM_NAME, '') || '>'
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :old_id_room
    into   :action_text;
    action_text = :action_text || f_character(28);

    select :action_text || '<' || coalesce(rt.TYPE_ROOM, '') || ' ' || coalesce (R.ROOM_NAME, '') || '>'
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :id_room
    into   :action_text;
    action_text = :action_text || f_character(28);

    if (:check_status >= 0) then begin
      execute procedure SYSTEM_DATE_GET (:id_hotel)
      returning_values :system_date;
      action_text = :action_text || f_character(28) || :system_date;
      execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'ROOM_MOVED', :action_text, :old_id_room);
    end else
      execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'ROOM_CHANGED', :action_text);
  end
  /*****/
end
^

/* Restore proc. body: RES_SAVE_STATUS$INT */
ALTER PROCEDURE RES_SAVE_STATUS$INT(RD_DBKEY CHAR(8),
CHECK_STATUS INTEGER,
CONFIRMATION_NUMBER TYPE OF NAME_20 = null)
 AS
declare variable old_check_status integer;
  declare variable id_reserv_detail integer;
  declare variable action_text varchar(255);
begin

  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_check_status, :id_reserv_detail;

  if (:old_check_status <> :check_status) then begin
    if (:old_check_status >= 0 and :CHECK_STATUS < :old_check_status) then begin
      exception BOOKING_EXCEPTION 'Can not downgrade status for checked in booking!';
    end

    if (:old_check_status < 0 and :CHECK_STATUS = 1) then begin
      exception BOOKING_EXCEPTION '-1006';
    end

    if (:CHECK_STATUS < 0) then begin
      select f_character(29) || coalesce(s.DEFAULT_CAPTION, :old_check_status)
             || f_character(28) || coalesce(s2.DEFAULT_CAPTION, :CHECK_STATUS)
      from   SYSTEM_ENUM S,   
             SYSTEM_ENUM S2
      where  S.GROUP_ = 'booking.status'
             and S.KEY_ = :old_check_status
             and S2.GROUP_ = 'booking.status'
             and S2.KEY_ = :CHECK_STATUS
      into   :action_text;

      execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_MOD_STATUS', :action_text);
    end

    update RESERV_DETAIL RDU
    set    RDU.CHECK_STATUS = :check_status,
           RDU.CONFIRMATION_NUMBER = iif (:CHECK_STATUS = -1, strhash_large(rdu.NUMBER || 'CONFIRMATION'), rdu.CONFIRMATION_NUMBER)
    where  RDU.RDB$DB_KEY = :rd_dbkey;

    update ROOM_MAGIC RM
    set    rm.BUSY_TYPE = case when :CHECK_STATUS = '1' then 'CHECK_OUT'
                               when :CHECK_STATUS = '0' then 'CHECK_IN'
                               when :CHECK_STATUS = '-1' then 'VALUE_CONFIRMED'
                               when :CHECK_STATUS = '-2' then 'VALUE_NOTCONFIRMED'
                               when :CHECK_STATUS = '-3' then 'VALUE_RESERVS'
                               else rm.BUSY_TYPE
                          end
    where  rm.ID_RESERV_DETAIL = :id_reserv_detail;

    update ROOMS_SHARE Rs
    set    rs.BUSY_TYPE = case when :CHECK_STATUS = '1' then 'CHECK_OUT'
                               when :CHECK_STATUS = '0' then 'CHECK_IN'
                               when :CHECK_STATUS = '-1' then 'VALUE_CONFIRMED'
                               when :CHECK_STATUS = '-2' then 'VALUE_NOTCONFIRMED'
                               when :CHECK_STATUS = '-3' then 'VALUE_RESERVS'
                               else rs.BUSY_TYPE
                          end
    where  rs.ID_RESERV_STATISTICS = :id_reserv_detail;

    execute procedure RES_SET_EDIT_STATUS$INT (:rd_dbkey, 'STATUS', 'add');
  end

  if (:CHECK_STATUS = -1 and :CONFIRMATION_NUMBER is not null) then begin
    -- override with incoming confirmation number
    update RESERV_DETAIL rd
    set    rd.CONFIRMATION_NUMBER = :CONFIRMATION_NUMBER
    where  rd.RDB$DB_KEY = :RD_DBKEY;
  end
end
^

/* Restore proc. body: RES_SAVE_STAY$INT */
ALTER PROCEDURE RES_SAVE_STAY$INT(RD_DBKEY CHAR(8),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER)
 AS
declare variable day_keep_types integer;
  declare variable exp_date date;
  declare variable leaving_kind integer;
  declare variable old_arrival date;
  declare variable old_departure date;
  declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable old_comming_kind integer;
  declare variable old_leaving_kind integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable is_stay_changed integer;
begin
  -- TODO exp_date must become input parameter, because the user may change it! or add exp_scheme!

  select RD.FROM_DATE, RD.TO_DATE, RD.COMMING_KIND, RD.LEAVING_KIND, RD.ID_HOTEL,
         rd.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_arrival, :old_departure, :old_comming_kind, :old_leaving_kind, :id_hotel,
         :id_reserv_detail;

  if (:DEPARTURE_DATE <= :ARRIVAL_DATE) then exception BOOKING_EXCEPTION '-53';

  execute procedure SETTING_GET_VALUE('DAY_KEEP_TYPES', :id_hotel)
  returning_values  :day_keep_types;

  exp_date = :arrival_date + :day_keep_types;
  leaving_kind = coalesce(:is_late_departure + 1, :old_leaving_kind);
  comming_kind = coalesce(:comming_kind, :old_comming_kind);

  if ((:arrival_date <> :old_arrival) or (:departure_date <> :old_departure)) then begin
    execute procedure RESERV_TRACK_CHANGES$INT (:RD_DBKEY);
  end

  if ((:arrival_date <> :old_arrival)
      or (:departure_date <> :old_departure)
      or (:comming_kind <> :old_comming_kind)
      or (:leaving_kind <> :old_leaving_kind)) then is_stay_changed = 1;
  else is_stay_changed = 0;

  update RESERV_DETAIL RD
  set    RD.COMMING_KIND = :comming_kind,
         RD.LEAVING_KIND = :leaving_kind,
         RD.EXP_DATE = :exp_date,
         RD.FROM_DATE = :arrival_date,
         RD.TO_DATE = :departure_date,
         rd.ROOM_PRICE = iif(:is_stay_changed = 1, null, rd.ROOM_PRICE) -- force recalculation
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:is_stay_changed = 1) then begin
    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :g_dbkey
    do begin
      execute procedure RES_GUEST_SAVE_STAY$INT(:g_dbkey, :arrival_date, :departure_date, :id_hotel);
    end

    execute procedure RES_SET_EDIT_STATUS$INT (:RD_DBKEY, 'DATE_CHANGED');

    --Remove manual prices (if any) outer new period--/
    if (:old_arrival < :arrival_date) then
      delete from RESERV_CUSTOM_PRICE rcp
      where  rcp.id_reserv_detail = :id_reserv_detail
             and rcp.FOR_DATE < :arrival_date;

    if (:old_departure > :departure_date) then
      delete from RESERV_CUSTOM_PRICE rcp
      where  rcp.id_reserv_detail = :id_reserv_detail
             and RCP.FOR_DATE >= :departure_date;

    if (not exists (select * from RESERV_CUSTOM_PRICE rmp where rmp.id_reserv_detail = :id_reserv_detail)) then
        update RESERV_DETAIL set  has_different_price = 0 where id_reserv_detail = :id_reserv_detail;
    ----
  end

  if ((:old_arrival <> :arrival_date) or (:old_departure <> :departure_date) ) then begin
    action_text = f_character(29) || '{' || formatdate(:old_arrival, 'D;dd.mm.yyyy') || '-' || formatdate(:old_departure, 'D;dd.mm.yyyy') || '}'
                  || f_character(28) || '{' || formatdate(:arrival_date, 'D;dd.mm.yyyy') || '-' || formatdate(:departure_date, 'D;dd.mm.yyyy') || '}';
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_MOD_PERIOD', :action_text);
  end
end
^

/* Restore proc. body: RES_SAVE_VOUCHER$INT */
ALTER PROCEDURE RES_SAVE_VOUCHER$INT(RD_DBKEY CHAR(8),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE)
 AS
declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable action_text varchar(255);
begin

  update RESERV_DETAIL RD
  set    RD.VAUCHER_NUM = :voucher_num,
         RD.VAUCHER_DATE = :voucher_date,
         RD.VAUCHER_TEXT = :voucher_text,
         RD.VAUCHER_NUM2 = :voucher2_num,
         RD.VAUCHER_DATE2 = :voucher2_date,
         RD.HAS_DIFFERENT_VOUCHERS = 0
  where  RD.RDB$DB_KEY = :rd_dbkey
         and
         ((RD.VAUCHER_NUM is distinct from :voucher_num)
          or (RD.VAUCHER_DATE is distinct from :voucher_date)
          or (RD.VAUCHER_TEXT is distinct from :voucher_text)
          or (RD.VAUCHER_NUM2 is distinct from :voucher2_num)
          or (RD.VAUCHER_DATE2 is distinct from :voucher2_date)
          or (RD.HAS_DIFFERENT_VOUCHERS is distinct from 0)
         );

  if (row_count > 0) then begin
    select RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.RDB$DB_KEY = :rd_dbkey
    into   :id_reserv_detail;
  
    action_text = f_character(29)
                  || coalesce(:VOUCHER_NUM, '')
                  || iif(:VOUCHER_DATE is not null, '/' || formatdate(:VOUCHER_DATE, 'D;dd.mm.yyyy'), '')
                  || ' (2: ' || coalesce(:VOUCHER2_NUM, '')
                  || iif(:VOUCHER2_DATE is not null, '/' || formatdate(:VOUCHER2_DATE, 'D;dd.mm.yyyy'), '')
                  || ')';
  
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'VOUCHER_SET', :action_text);
  
    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :g_dbkey
    do begin
      execute procedure RES_GUEST_SAVE_VOUCHER$INT(:rd_dbkey, :g_dbkey, :voucher_num, :voucher_date,
              :voucher_text, :voucher2_num, :voucher2_date);
    end
  
    execute procedure RES_GUESTDATA_INVALIDATE$INT(:rd_dbkey);
  end
end
^

/* Restore proc. body: RES_SET_ROOM_MULTI$RSV */
ALTER PROCEDURE RES_SET_ROOM_MULTI$RSV(OPERATION VARCHAR(20),
FROM_ROOM VARCHAR(20),
SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable cnt_requested integer;
  declare variable cnt_old_room integer;
  declare variable cnt_found integer;
  declare variable is_already_planned integer;
  declare variable is_satisfied integer;
  declare variable new_id_room integer;
  declare variable current_id_room integer;
  declare variable id_res_room_type integer;
  declare variable room_requirements blob sub_type 1 segment size 100;
  declare variable from_date date;
  declare variable to_date date;
  declare variable action_text varchar(255);
  declare variable is_early_arrival smallint;
  declare variable is_late_departure smallint;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable id_reserv_detail integer;
  declare variable tmp_warn_code integer;
  declare variable min_beds integer;
  declare variable virtual_room varchar(10);
  declare variable share_err_text varchar(255);
begin
  /* offer_method :
  ||     0 - NUMBER desc,
  ||     1 - NUMBER asc,
  ||     2 - DAYS FREE(MAX OCCUPANCY),
  ||     3 - FILING FACTOR(EQUAL ROOM USAGE)
  */
  warn_code = null;

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'set_number_asc, set_number_desc, set_max_occupancy, set_max_usage');

  cnt_requested = 0;
  cnt_old_room = 0;
  cnt_found = 0;
  for
    select RD.RDB$DB_KEY, rd.ID_RESERV_DETAIL, rd.ID_ROOM, rd.VIRTUAL_ROOM, RD.ID_ROOM_TYPE, RD.ROOM_FEATURES,
           RD.FROM_DATE, RD.TO_DATE, iif(rd.COMMING_KIND = 0, 1, 0), iif(rd.LEAVING_KIND = 2, 1, 0),
           rd.ADULT_COUNT + rd.CHILD_COUNT
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
           and RD.IS_ANUL = 0
    into   :rd_dbkey, :id_reserv_detail, :current_id_room, :virtual_room, :id_res_room_type, :room_requirements,
           :from_date, :to_date, :is_early_arrival, :is_late_departure, :min_beds
  do begin
    cnt_requested = :cnt_requested + 1;
    new_id_room = null;
    if (:current_id_room < 0) then begin
      if (:virtual_room is not null) then begin
        -- has related bookings with shared virtual room
        -- get cumulative stay for all shared bookings
        select min(vrd.FROM_DATE), min(vrd.FROM_DATE) - min(vrd.FROM_DATE - iif(vrd.COMMING_KIND = 0, 1, 0)),
               max(vrd.TO_DATE), max(vrd.TO_DATE + iif(vrd.LEAVING_KIND = 2, 1, 0)) - max(vrd.TO_DATE),
               sum(vrd.ADULT_COUNT + vrd.CHILD_COUNT)
        from   RESERV_DETAIL VRD
        where  vrd.ID_ROOM = :current_id_room
               and vrd.IS_ANUL = 0
        into   :from_date, :is_early_arrival, :to_date, :is_late_departure, :min_beds;
      end
      -- from_date and to_date are arrival and departure date of reservation,
      -- not first and last accomodation dates !!! this is need to check early arrivals and late departures
      execute procedure ROOM_PICKUP$INT(:id_res_room_type, :from_date, :to_date,
              :is_early_arrival, :is_late_departure,:operation, :from_room, :room_requirements, :min_beds)
      returning_values  :new_id_room;  -- offered room

      if (:new_id_room is not null) then begin
        is_satisfied = 1;
        select R.ROOM_NAME
        from   ROOMS R
        where  r.ID_ROOM = :new_id_room
        into   :action_text;

        execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'ROOM_SET_AUTO', :action_text);

        execute procedure RES_SET_ROOM$INT (:rd_dbkey, :new_id_room, 'nrttAsIs')
        returning_values (:tmp_warn_code, :share_transaction_id, :share_err_code, :share_err_text);
        if (:share_err_code < 0) then exception BOOKING_EXCEPTION 'Unallowable share!!!';
        WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

        if (:virtual_room is not null) then begin
          -- distribute the same room to shared bookings
          execute procedure RES_SET_ROOM_CO_RENTERS$INT (:current_id_room, :new_id_room, :id_reserv_detail, 'nrttAsIs')
          returning_values (:tmp_warn_code, :share_transaction_id, :share_err_code, :share_err_text);
          if (:share_err_code < 0) then exception BOOKING_EXCEPTION 'Unallowable share!!!';
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
        end
      end

    end else begin
      is_already_planned = 1;
    end

    cnt_old_room = :cnt_old_room + :is_already_planned;
    cnt_found = :cnt_found + :is_satisfied;

    when exception BOOKING_EXCEPTION do begin
      -- nothing, skip this booking
    end
  end

  if ((:cnt_found + :cnt_old_room) < :cnt_requested) then begin
    execute procedure SYSTEM_WARNING_ADD(-3, f_character(29)||:cnt_found||f_character(28)||:cnt_requested)
    returning_values  :warn_code;
  end
end
^

/* Restore proc. body: RES_SPLIT$RSV */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
declare variable rd_dbkey_old char(8);
  declare variable rd_dbkey_new char(8);
  declare variable id_guest integer;
  declare variable warn_code integer;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;

  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable check_status integer;
  declare variable arrival_date date;
  declare variable departure_date date;
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable id_room_type integer;
  declare variable id_room integer;
  declare variable id_board integer;
  declare variable id_tariff integer;
  declare variable custom_price numeric(15,4);
  declare variable custom_currency char(3);
  declare variable voucher_num varchar(30);
  declare variable voucher_date date;
  declare variable voucher_text varchar(30);
  declare variable voucher2_num varchar(30);
  declare variable voucher2_date date;
  declare variable transfer_in_time time;
  declare variable transfer_in_note varchar(255);
  declare variable transfer_out_time time;
  declare variable transfer_out_note varchar(255);
  declare variable comming_kind integer;
  declare variable is_late_departure integer;
  declare variable is_vip integer;
  declare variable country_code varchar(20);
  declare variable code_first_food tfood_code;
  declare variable i_special_treatment varchar(255);
  declare variable id_nom_market_segment integer;
  declare variable id_nom_source_code integer;
  declare variable id_nom_channel_code integer;
  declare variable id_nom_hear_reason integer;
  declare variable id_nom_come_reason integer;
  declare variable id_agent_account integer;
  declare variable acc_routing varchar(50);
  declare variable id_person_payment integer;
  declare variable id_agent_payment integer;
  declare variable room_features blob sub_type 1 segment size 80;
  declare variable id_hk_plan integer;
  declare variable id_group integer;
  declare variable id_hotel integer;
  declare variable note varchar(2000);
  declare variable note_reminders varchar(50);
  declare variable guarantee_deposit numeric(15,4);
  declare variable guarantee_currency char(3);
  declare variable id_titular integer;
  declare variable id_profile_data integer;
  declare variable id_acc_template_person integer;
  declare variable number_1 varchar(20);
  declare variable number_2 varchar(20);
  declare variable new_res_number varchar(62);
  declare variable g_dbkey char(8);
  declare variable is_child integer;
  declare variable id_guarantee_policy integer;
  declare variable block_cc varchar(255);
  declare variable virtual_room varchar(10);
  declare variable err_text varchar(255);
  declare variable is_posting_stopped integer;
  declare variable id_eating_object integer;
begin
  select RD.RDB$DB_KEY, RD.ID_AGENT_PROFILE, RD.CHECK_STATUS, RD.FROM_DATE, RD.TO_DATE,
         RD.ADULT_COUNT, RD.CHILD_COUNT, RD.ID_ROOM_TYPE, RD.ID_ROOM, RD.ID_BOARD, RD.ID_RATE,
         RD.CUSTOM_PRICE, RD.CUSTOM_CURRENCY, RD.VAUCHER_NUM, RD.VAUCHER_DATE, RD.VAUCHER_TEXT, RD.VAUCHER_NUM2,
         RD.VAUCHER_DATE2, RD.TRANSFER_IN_TIME, RD.TRANSFER_IN_NOTE, RD.TRANSFER_OUT_TIME, RD.TRANSFER_OUT_NOTE,
         RD.COMMING_KIND, RD.LEAVING_KIND - 1, RD.IS_VIP, RD.COUNTRY, RD.CODE_FIRST_FOOD, RD.I_SPECIAL_TREATMENT,
         RD.ID_NOM_MARKET_SEGMENT, RD.ID_NOM_SOURCE_CODE, RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_HEAR_REASON,
         RD.ID_NOM_COME_REASON, RD.ID_AGENT_ACCOUNT_RULE, RD.ACC_ROUTING, RD.ID_PERSON_PAYMENT, RD.ID_AGENT_PAYMENT,
         RD.ROOM_FEATURES, RD.ID_HK_PLAN, RD.ID_GROUP, RD.ID_HOTEL, RD.NOTE, RD.NOTE_REMINDERS,
         RD.GUARANTEE_DEPOSIT, RD.GUARANTEE_CURRENCY, RD.ID_ACC_TEMPLATE_PERSON,
         RD.NUMBER_1, rd.NUMBER_2, rd.ID_GUARANTEE_POLICY, rd.BLOCK_CC, rd.IS_POSTING_STOPPED, rd.ID_EATING_OBJECT
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail_source
  into   :rd_dbkey_old, :id_agent_profile, :check_status, :arrival_date, :departure_date,
         :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff,
         :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
         :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
         :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
         :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
         :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
         :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
         :guarantee_deposit, :guarantee_currency, :id_acc_template_person,
         :number_1, :number_2,:id_guarantee_policy, :block_cc, :is_posting_stopped, :id_eating_object;

  select first 1 sp.ITEM
  from   SYSTEM_STRING_PARSER(:guest_ids, ',') sp
  into   :id_titular;

  select min(g.FROM_DATE), max(g.TO_DATE)
  from   GUEST G
  where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL_SOURCE
         and ','||:GUEST_IDS||',' containing ','||g.ID_GUEST||','
  into   :arrival_date, :departure_date;

  if (exists (select *
              from   RESERV_DETAIL RD
              where  RD.ID_TITULAR = :id_titular
                     and RD.ID_RESERV_DETAIL = :id_reserv_detail_source))
  then exception BOOKING_EXCEPTION 'Titular can not be splited in new reservation';

  execute procedure RES_GET_PERSON_PROFILE$INT(:id_titular)
  returning_values  :id_person_profile, :id_profile_data;

  new_res_number = iif(coalesce(:number_1,'')='','.',:number_1||'.')
                   || coalesce(:number_2, '')
                   || '.0';  -- fictive suffix, needed for unique constraint limitation, that will be replaced with real one


  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, :check_status, :arrival_date, :departure_date,
                    0, 0, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
                    :guarantee_deposit, :guarantee_currency, 0, null, :new_res_number, :id_acc_template_person,
                    :id_guarantee_policy, :block_cc, :id_eating_object)
  returning_values  :rd_dbkey_new, :new_id_reserv_detail;

  execute procedure RES_NUMBER_SUFFIX_GEN (:NEW_ID_RESERV_DETAIL)
  returning_values  (:new_res_number);  -- add suffix to new (splited) booking number (empty on create)

  update RESERV_DETAIL NR
  set    nr.IS_POSTING_STOPPED = :is_posting_stopped
  where  nr.RDB$DB_KEY = :rd_dbkey_new;

  -- there is no need guests deleting, because new splited reservation is created with 0 guests
  adult_count = 0; child_count = 0;
  for
    select G.ID_GUEST, G.RDB$DB_KEY, G.IS_CHILD
    from   SYSTEM_STRING_PARSER(:guest_ids, ',') SP
           join GUEST G on G.ID_GUEST = SP.ITEM
    into   :id_guest, :g_dbkey, :is_child
  do begin
    execute procedure GUEST_SET_EDIT_STATUS$INT (:g_dbkey, 'REBUILD', 'add');

    update GUEST G
    set    G.ID_RESERV_DETAIL = :new_id_reserv_detail
    where  G.ID_GUEST = :id_guest;

    adult_count = :adult_count + (1-:is_child);
    child_count = :child_count + :is_child;

    if (:id_guest = :id_titular) then begin
      update RESERV_DETAIL RD
      set    RD.ID_TITULAR = :id_titular
      where  RD.RDB$DB_KEY = :rd_dbkey_new;

      update GUEST_DATA GD
      set    GD.ID_PERSON_DATA = :id_profile_data
      where  GD.ID_GUEST = :id_titular;
    end
  end

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL_SOURCE, 'RES_SPLIT',
          f_character(29) || :new_res_number || f_character(28) || :adult_count || ' + ' || :child_count);

  -- calling RES_SAVE_PROFILING$INT is unnecessary, it is called into RES_CREATE_SET$INT with same params
  -- here is needed to set reserv accounts per splited guests and reroute posting only (accomplished in next procedure)
  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey_new);

  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_old);
  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_new);

  update RESERV_DETAIL ORD
  set    ord.ROOM_PRICE = null
  where  ord.RDB$DB_KEY = :rd_dbkey_old;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_old, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_new, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  if (:id_room < 0) then begin
    virtual_room = gen_id(GEN_VIRTUAL_ROOM, 1);
    update RESERV_DETAIL RD
    set    rd.VIRTUAL_ROOM = '<'||:virtual_room||'>'
    where  rd.ID_ROOM = :id_room;
  end
end
^

/* Restore proc. body: RESERV_DETAIL_EXTERNAL_MOD$RSV */
ALTER PROCEDURE RESERV_DETAIL_EXTERNAL_MOD$RSV(ID_RESERV_DETAIL INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
LOCATOR VARCHAR(100))
 AS
BEGIN
  update RESERV_DETAIL_EXTERNAL
  set    MINIBAR_RIGHTS = :minibar_rights,
         PAYTV_RIGHTS = :paytv_rights,
         VIDEO_RIGHTS = :video_rights,
         NOPOST_PMS = :nopost_pms,
         PHONE_RIGHTS = :phone_rights,
         SEMINAR_CAHNNEL_RIGHTS = :seminar_cahnnel_rights,
         LOCATOR = :locator
  where  ID_RESERV_DETAIL = :id_reserv_detail;

  if (row_count = 0) then begin
    insert into RESERV_DETAIL_EXTERNAL (
        ID_RESERV_DETAIL,
        MINIBAR_RIGHTS,
        PAYTV_RIGHTS,
        VIDEO_RIGHTS,
        NOPOST_PMS,
        PHONE_RIGHTS,
        SEMINAR_CAHNNEL_RIGHTS,
        LOCATOR)
    values (
        :id_reserv_detail,
        :minibar_rights,
        :paytv_rights,
        :video_rights,
        :nopost_pms,
        :phone_rights,
        :seminar_cahnnel_rights,
        :locator);
  end

  execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RSV_EXT_DETAIL_CHNG', '');

END
^

/* Restore proc. body: RESERVS_EXPIRE$INT */
ALTER PROCEDURE RESERVS_EXPIRE$INT(CLEAR_TODATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable day_keep_number integer;
  declare variable rd_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable nouse integer;
  declare variable day_keep_types integer;
begin
  /*AA NA IONEA I?AAE I?EEE??AAIA -BF END WORK-*/
  execute procedure SETTING_GET_VALUE('DAY_KEEP_NUMBERS', :ID_HOTEL)
  returning_values  :day_keep_number;
  /*************************************************************/
  /*    REMOVE ROOM NUMBERS FROM EXPIRED RESERV DETAILS        */
  /*************************************************************/
  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.IS_ANUL = 0
           and RD.CHECK_STATUS < 0
           and RD.IS_VIP = 0
           and RD.ID_ROOM > 0
           and (RD.FROM_DATE <=  cast(:clear_todate - :day_keep_number as date))
    into   :rd_dbkey, :id_reserv_detail
  do begin
    execute procedure RES_ROOM_REMOVE$INT(:rd_dbkey)
    returning_values  :nouse;

    when any do begin
      -- nothing
    end
  end
  /*************************************************************/
  /*    EXPIRED NON VIP or VIP TYPES                           */
  /*************************************************************/
  execute procedure SETTING_GET_VALUE('DAY_KEEP_TYPES', :ID_HOTEL)
  returning_values  :day_keep_types;

  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.CHECK_STATUS < 0
           and RD.IS_ANUL = 0
           --and RD.EXP_DATE <= :clear_todate
           and RD.FROM_DATE <= cast(:clear_todate - :day_keep_types as date)
           and RD.IS_VIP = 0
    union
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.CHECK_STATUS < 0
           and RD.IS_ANUL = 0
           and RD.TO_DATE < :clear_todate
           and RD.IS_VIP = 1
    into   :rd_dbkey, :id_reserv_detail
  do begin
    execute procedure sys_dbg('res RESERVS_EXPIRE: id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

    execute procedure RES_ANUL_NOSHOW$INT(:rd_dbkey)
    returning_values  :nouse;

    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_NOSHOW', '');

    when any do begin
      -- nothing
    end
  end
end
^

/* Restore proc. body: RESGRP_SAVE_OTHER$INT */
ALTER PROCEDURE RESGRP_SAVE_OTHER$INT(RD_DBKEY CHAR(8),
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
ID_EATING_OBJECT TYPE OF ID_REF)
 AS
declare variable id_reserv_detail integer;
  declare variable g_dbkey char(8);
  declare variable old_code_first_food type of tfood_code;
  declare variable old_text_first_food varchar(50);
  declare variable text_first_food varchar(50);
  declare variable action_text varchar(255);
begin
  select RD.ID_RESERV_DETAIL, RD.CODE_FIRST_FOOD
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail, :old_code_first_food;

  update RESERV_DETAIL RD
  set    RD.HAS_DIFFERENT_OTHER = 0,
         RD.TRANSFER_IN_TIME = :transfer_in_time,
         RD.TRANSFER_IN_NOTE = :transfer_in_note,
         RD.TRANSFER_OUT_TIME = :transfer_out_time,
         RD.TRANSFER_OUT_NOTE = :transfer_out_note,
         RD.CODE_FIRST_FOOD = :code_first_food,
         rd.ID_EATING_OBJECT = :ID_EATING_OBJECT
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_code_first_food is distinct from :code_first_food) then begin
    old_text_first_food = cast(case
                              when :old_code_first_food = 'breakfast' then 'caption.breakfast'
                              when :old_code_first_food = 'lunch' then 'caption.launch'
                              when :old_code_first_food = 'dinner' then 'caption.dinner'
                              when :old_code_first_food = 'extrafood1' then 'caption.extrafood1'
                              when :old_code_first_food = 'extrafood2' then 'caption.extrafood2'
                              when :old_code_first_food = 'none' then 'caption.no_first_food'
                          end as varchar(50));
    text_first_food = cast(case
                              when :code_first_food = 'breakfast' then 'caption.breakfast'
                              when :code_first_food = 'lunch' then 'caption.launch'
                              when :code_first_food = 'dinner' then 'caption.dinner'
                              when :code_first_food = 'extrafood1' then 'caption.extrafood1'
                              when :code_first_food = 'extrafood2' then 'caption.extrafood2'
                              when :code_first_food = 'none' then 'caption.no_first_food'
                           end as varchar(50));
    action_text = f_character(29) || coalesce('@{' || :old_text_first_food || '}', '') ||
                  f_character(28) || coalesce('@{' || :text_first_food || '}', '');
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'FIRST_FOOD_CHANGED', :ACTION_TEXT);
  end

  for
    select G.RDB$DB_KEY
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :g_dbkey
  do begin
    execute procedure RES_GUEST_SAVE_OTHER$INT(:g_dbkey, :transfer_in_time, :transfer_in_note,
            :transfer_out_time, :transfer_out_note, :code_first_food);
  end
end
^

/* Restore proc. body: REVENUE_SUMMARY_REMAKE$SYS */
ALTER PROCEDURE REVENUE_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
STATISTIC_ONLY SMALLINT)
 AS
declare variable id_end_work integer;
declare variable ad_dbkey char(8);
declare variable id_service integer;
declare variable id_guest integer;
declare variable id_account integer;
declare variable revenue_group varchar(50);
declare variable revenue_account varchar(50);
declare variable revenue_sub_account varchar(50);
begin
  if (not exists (select h.ID_HOTEL
                  from   HOTEL H
                  where  h.ID_HOTEL = :ID_HOTEL)) then exception WRONG_VALUE 'Non-existing hotel!';

  if (:STATISTIC_ONLY = 1) then begin

    execute procedure REVENUE_STATISTIC_REMAKE$SYS (:ID_HOTEL, :FROM_DATE, :TO_DATE);

    execute procedure SYSTEM_LOG_ADD ('HOTEL', :id_hotel, 'REV_REGEN_PART',
                                      f_character(29) || formatdate(:from_date, 'D;dd/mm/yyyy') ||
                                      f_character(28) || formatdate(:to_date, 'D;dd/mm/yyyy'));
  end else begin
    for
      select ad.RDB$DB_KEY, ad.ID_SERVICE, ad.ID_GUEST, ad.ID_ACCOUNT
      from   ACCOUNT_DEBT AD
      where  AD.ID_HOTEL = :id_hotel
             and ad.DEBT_DATE between :FROM_DATE and :TO_DATE
      order by ad.DEBT_DATE asc, ad.ID_ACCOUNT_POST asc
      into   :ad_dbkey, :id_service, :id_guest, :id_account
    do begin
      select  S.REVENUE_GROUP, RA.REVENUE_ACCOUNT, RA.REVENUE_SUB_ACCOUNT
      from    ACCOUNT A
              left outer join SERVICES S on s.ID_SERVICE = :id_service
              left outer join GUEST G on G.ID_GUEST = :id_guest
              left outer join PROFILE_HOUSE PH on PH.ID_PROFILE = A.ID_PROFILE
              left outer join REVENUE_ACCOUNT_PARSE$INT (S.REVENUE_ACCOUNT, coalesce(G.ID_RESERV_DETAIL, A.ID_RESERV_DETAIL)) RA on 1=1
      where   a.ID_ACCOUNT = :id_account
              and PH.HOUSE_TYPE is distinct from 'hptComplimentary'
      into    :revenue_group, :revenue_account, :revenue_sub_account;
  
      update ACCOUNT_DEBT d
      set    d.REVENUE_GROUP = :revenue_group,
             d.REVENUE_ACCOUNT = :revenue_account,
             d.REVENUE_SUB_ACCOUNT = :revenue_sub_account
             -- TODO - revenue deduction tax recalc ???
      where  d.RDB$DB_KEY = :ad_dbkey;
    end
  
  
    for
      select se.ID_END_WORK
      from   SUMMARY_END_WORK SE
      where  se.ID_HOTEL = :ID_HOTEL
             and se.SUMMARY_DATE between :FROM_DATE and :TO_DATE
      order by se.ID_END_WORK
      into   :id_end_work
    do begin
  
      update SUMMARY_END_WORK s
      set    s.REVENUE_AMOUNT = 0,
             s.CORRECTION_AMOUNT = 0,
             s.VAT_AMOUNT = 0
      where  s.ID_END_WORK = :id_end_work;
  
      execute procedure REVENUE_EW_SUMMARIZE$INT (:id_end_work, 'full');
    end

    execute procedure SYSTEM_LOG_ADD ('HOTEL', :id_hotel, 'REV_REGEN_FULL',
                                      f_character(29) || formatdate(:from_date, 'D;dd/mm/yyyy') || f_character(28) ||
                                      formatdate(:to_date, 'D;dd/mm/yyyy'));
  end
end
^

/* Restore proc. body: RIGHTS_GROUP_MODIFY */
ALTER PROCEDURE RIGHTS_GROUP_MODIFY(ID_RIGHT_GROUP INTEGER,
GROUP_NAME VARCHAR(20),
GROUP_DESCRIPTION VARCHAR(100),
OPERATION VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
NEW_ID_RIGHT_GROUP INTEGER)
 AS
declare variable old_name varchar(30);
begin
  err_code = 0;
  err_text = '';
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation = 'add') then begin
    if ((:id_right_group is null) or (:id_right_group <= -1))  then
      new_id_right_group = gen_id(ID_RIGHT_GROUP_GEN, 1);
    else new_id_right_group = :id_right_group;

    insert into RIGHTS_GROUPS (ID_RIGHT_GROUP, GROUP_NAME, GROUP_DESCRIPTION)
    values (:new_id_right_group, :group_name , :group_description);
  end else if (:operation = 'mod') then begin
    select G.GROUP_NAME
    from   RIGHTS_GROUPS G
    where  G.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
    into   :old_name;

    update RIGHTS_GROUPS UG
    set    UG.GROUP_NAME  = :group_name,
           UG.GROUP_DESCRIPTION = :group_description
    where  UG.ID_RIGHT_GROUP = :id_right_group;

    if (:old_name <> :GROUP_NAME) then begin
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'GROUP_EDIT',
              f_character(29) || :old_name || f_character(28) || :GROUP_NAME);
    end
  end else if (:operation = 'del') then begin
    delete from RIGHTS_GROUPS
    where ID_RIGHT_GROUP = :id_right_group;
    delete from RIGHTS_USER_GROUPS
    where ID_RIGHT_GROUP = :id_right_group;
  end
end
^

/* Restore proc. body: RIGHTS_GROUP_REPORTS_MODIFY */
ALTER PROCEDURE RIGHTS_GROUP_REPORTS_MODIFY(ID_RIGHT_GROUP INTEGER,
REPORT_NAME VARCHAR(200),
OPERATION VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable right_group varchar(30);
begin
  err_code = 0;
  err_text = '';
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'grant, revoke');

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS rg
  where  rg.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'grant') then begin
    if (not exists (
      select *
      from   RIGHTS_GROUPS_REPORTS RGR
      where  RGR.ID_RIGHT_GROUP = :id_right_group
             and RGR.REPORT_NAME = :report_name)
    ) then begin
      insert into RIGHTS_GROUPS_REPORTS (ID_RIGHT_GROUP, REPORT_NAME)
      values (:id_right_group, :report_name);

      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'RIGHT_GRANT',
              f_character(29) || :REPORT_NAME || f_character(28) || :right_group);

    end
  end else if (:operation = 'revoke') then begin
    delete from RIGHTS_GROUPS_REPORTS RGR
    where  RGR.ID_RIGHT_GROUP = :id_right_group
           and  RGR.REPORT_NAME = :report_name;

    if (row_count = 1) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'RIGHT_REVOKE',
              f_character(29) || :REPORT_NAME || f_character(28) || :right_group);
  end
end
^

/* Restore proc. body: RIGHTS_GROUP_RIGHTS_MODIFY */
ALTER PROCEDURE RIGHTS_GROUP_RIGHTS_MODIFY(ID_RIGHT_GROUP INTEGER,
RIGHT_CODE VARCHAR(30),
VALUE_CODE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable rightType integer;
declare variable right_descr varchar(255);
declare variable right_group varchar(30);
begin
  err_code = 0;
  err_text = '';
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'grant, revoke');

  /* rightType = 0 (rtPlain: IsPlural=0;IS_VALUE_CODE_REQUIRED=0)
     rightType = 1 (rtSingle: IsPlural=0;IS_VALUE_CODE_REQUIRED=1)
     rightType = 2 (rtMulti: IsPlural=1;IS_VALUE_CODE_REQUIRED=1) */

  rightType = 0;
  right_descr = '@{right.name.' || :right_code || '}';

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS RG
  where  RG.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'grant') then begin
    if (:rightType is null) then begin
      err_code = -85;
      err_text = 'rightType information not found for right ' || :right_code;
      exit;
    end
    if ((:rightType = 0) and (:value_code <> 0)) then begin
      err_code = -85;
      err_text = 'rightType is rtPlain but value_code <> 0';
      exit;
    end
    if ((:rightType <> 0) and (:value_code = 0)) then begin
      err_code = -85;
      err_text = 'rightType is not rtPlain but value_code = 0';
      exit;
    end

    if (:rightType = 0) then begin
      if (not exists (select *
                      from   RIGHTS_GROUPS_LINES RGL
                      where  RGL.ID_RIGHT_GROUP = :id_right_group
                             and RGL.RIGHT_CODE = :right_code)) then
      begin
        insert into RIGHTS_GROUPS_LINES (ID_RIGHT_GROUP, RIGHT_CODE)
        values (:id_right_group, :right_code);

        execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'RIGHT_GRANT',
                f_character(29) || :right_descr || f_character(28) || :right_group);
      end
    end
  end else if (:operation = 'revoke') then begin
    if (:rightType = 0) then begin
      delete from RIGHTS_GROUPS_LINES RGL
      where  RGL.ID_RIGHT_GROUP = :id_right_group
             and RGL.RIGHT_CODE = :right_code;

      if (row_count > 0) then
        execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'RIGHT_REVOKE',
                f_character(29) || :right_descr || f_character(28) || :right_group);
    end
  end
end
^

/* Restore proc. body: RIGHTS_GROUP_USER_MODIFY */
ALTER PROCEDURE RIGHTS_GROUP_USER_MODIFY(USER_NAME VARCHAR(30),
ID_RIGHT_GROUP INTEGER,
OPERATION VARCHAR(50))
 AS
declare variable right_group varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add,del');

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS RG
  where  RG.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'add') then begin
    insert into RIGHTS_USER_GROUPS (USER_NAME, ID_RIGHT_GROUP)
    values (:user_name, :id_right_group);

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_ADDED',
            f_character(29) || :USER_NAME  || f_character(28) || :right_group);

  end else begin
    delete from RIGHTS_USER_GROUPS
    where USER_NAME = :user_name
          and ID_RIGHT_GROUP = :id_right_group;

    if (row_count > 0) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_REMOVED',
              f_character(29) || :USER_NAME || f_character(28) || :right_group);

  end

  when sqlcode -803 do begin
    /* ERR_TEXT = '       ! ' ;*/
    exit;
  end
end
^

/* Restore proc. body: RIGHTS_MODIFY_USER */
ALTER PROCEDURE RIGHTS_MODIFY_USER(IN_USER_NAME VARCHAR(30),
IN_USER_NAME_LONG VARCHAR(30),
IN_NEW_PASSWORD VARCHAR(8),
LANG_UI VARCHAR(10),
FISCAL_ID INTEGER,
IS_ACTIVE INTEGER,
OPERATION VARCHAR(20),
CODE VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100))
 AS
begin
  err_code = 0;
  err_text = '';
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod');

  if (:operation = 'add') then begin
    insert into RIGHTS_USERS (USER_NAME, USER_NAME_LONG, USER_PASSWORD, FISCAL_ID, LANG_UI, IS_ACTIVE, CODE)
    values (:in_user_name, :in_user_name_long, :in_new_password, :fiscal_id, :lang_ui, :is_active, :code);

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_NEW', f_character(29) || :IN_USER_NAME);
  end else if (:operation = 'mod') then begin
    update RIGHTS_USERS U
    set    U.USER_PASSWORD  = :in_new_password,
           U.USER_NAME_LONG = :in_user_name_long,
           U.LANG_UI = :lang_ui,
           U.IS_ACTIVE = :is_active,
           U.FISCAL_ID = :fiscal_id,
           U.code = :code
    where  U.USER_NAME = :in_user_name;

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_MODIFY', f_character(29) || :IN_USER_NAME);
  end else if (:operation = 'del') then begin
    if (:in_user_name = 'SYSDBA') then begin
      err_code = -42;
      exit;
    end

    delete from RIGHTS_USERS
    where USER_NAME = :in_user_name;

    delete from RIGHTS_USER_GROUPS
    where USER_NAME = :in_user_name;

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_DEL', f_character(29) || :IN_USER_NAME);
  end

  when sqlcode -803 do begin
    err_code = -87;
    err_text = '';
    exit;
  end
end
^

/* Restore proc. body: ROOM_CONTRACT_MODIFY$PMS */
ALTER PROCEDURE ROOM_CONTRACT_MODIFY$PMS(ID_ROOM_CONTRACT INTEGER,
ID_ROOM_PERIOD INTEGER,
CONTRACT_TYPE VARCHAR(50),
PMS_MARKERS BLOB SUB_TYPE 1 SEGMENT SIZE 100,
IMPORT_INCOME_WITH_VAT SMALLINT,
ID_RENTAL_POOL INTEGER,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_CONTRACT INTEGER)
 AS
declare variable key_ varchar(50);
  declare variable permissible_value_list varchar(255);
  declare variable from_date date;
  declare variable rental_pool_unit_name varchar(100);
  declare variable room_name varchar(10);
  declare variable old_contract_type varchar(50);
  declare variable old_import_income_with_vat smallint;
  declare variable old_from_date date;
  declare variable old_rental_pool_unit_name varchar(100);
  declare variable old_room_name varchar(10);
  declare variable old_id_room_period integer;
  declare variable new_id_room_period integer;
  declare variable id_room integer;
  declare variable action_text varchar(255);
begin

  permissible_value_list = '';
  for
    select trim(S.KEY_)
    from   SYSTEM_ENUM S
    where  S.GROUP_ = 'pms.contract_type'
    into   :key_
  do begin
    permissible_value_list = :permissible_value_list || :key_ || ',';
  end

  if (:operation in ('add', 'mod')) then begin
    execute procedure SYSTEM_CHECK_OPERATION(:contract_type, :permissible_value_list, 'contract type');

    select PRO.PROFILE_NAME
    from   PROFILE PRO
    where  PRO.ID_PROFILE = :ID_RENTAL_POOL
    into   :rental_pool_unit_name;

    select ROO.ROOM_NAME, RPP.FROM_DATE
    from   ROOM_PERIOD$PMS RPP
           join ROOMS ROO on ROO.ID_ROOM = RPP.ID_ROOM
    where  RPP.ID_ROOM_PERIOD = :ID_ROOM_PERIOD
    into   :room_name, :from_date;
  end

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');
  NEW_ID_ROOM_CONTRACT = :id_room_contract;

  if (:operation = 'add') then begin
    if (coalesce(:ID_ROOM_CONTRACT, -1) < 0) then begin
      NEW_ID_ROOM_CONTRACT = gen_id(GEN_ROOM_CONTRACT$PMS_ID, 1);
      ID_ROOM_CONTRACT = :NEW_ID_ROOM_CONTRACT;
    end
    else
      NEW_ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT;

    insert into ROOM_CONTRACT$PMS (ID_ROOM_CONTRACT, ID_ROOM_PERIOD,
           CONTRACT_TYPE, /*ID_CONTRACT_GUEST, ID_CONTRACT_OWNER, ID_CONTRACT_SHADOW,*/
           PMS_MARKERS, IMPORT_INCOME_WITH_VAT, ID_RENTAL_POOL)
    values (:NEW_ID_ROOM_CONTRACT, :ID_ROOM_PERIOD,
           :CONTRACT_TYPE, /*:ID_CONTRACT_GUEST, :ID_CONTRACT_OWNER, :ID_CONTRACT_SHADOW,*/
           :PMS_MARKERS, :IMPORT_INCOME_WITH_VAT, :ID_RENTAL_POOL);

    action_text = substring(f_character(29) || '@{pms.contract_type.' || :contract_type || '}' || f_character(28) ||
                  formatdate(:from_date, 'D;dd.mm.yyyy') ||
                  f_character(28) || :room_name || f_character(28) || coalesce(:rental_pool_unit_name, ' ') || f_character(28)
                  || coalesce(:import_income_with_vat, 0) from 1 for 255);
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_ADDED', :ACTION_TEXT);

  end else begin
    select RC.CONTRACT_TYPE, RC.IMPORT_INCOME_WITH_VAT,
           RO.ROOM_NAME, PR.PROFILE_NAME, RP.FROM_DATE, RC.ID_ROOM_PERIOD, RP.ID_ROOM
    from   ROOM_CONTRACT$PMS RC
           join ROOM_PERIOD$PMS RP on RP.ID_ROOM_PERIOD = RC.ID_ROOM_PERIOD
           join ROOMS RO on RO.ID_ROOM = RP.ID_ROOM
           left outer join PROFILE PR on PR.ID_PROFILE = RC.ID_RENTAL_POOL
    where  RC.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
    into   :old_contract_type, :old_import_income_with_vat,
           :old_room_name, :old_rental_pool_unit_name, :old_from_date, :old_id_room_period, :id_room;

    if (:operation = 'mod') then begin
      update ROOM_CONTRACT$PMS
      set    CONTRACT_TYPE = :CONTRACT_TYPE,
             --ID_CONTRACT_GUEST = :ID_CONTRACT_GUEST,
             --ID_CONTRACT_OWNER = :ID_CONTRACT_OWNER,
             --ID_CONTRACT_SHADOW = :ID_CONTRACT_SHADOW,
             PMS_MARKERS = :PMS_MARKERS,
             IMPORT_INCOME_WITH_VAT = :IMPORT_INCOME_WITH_VAT,
             ID_RENTAL_POOL = :ID_RENTAL_POOL
      where (ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT);

      if ((:contract_type <> :old_contract_type) or (:import_income_with_vat <> :old_import_income_with_vat) or
         (coalesce(:rental_pool_unit_name, ' ') <> coalesce(:old_rental_pool_unit_name, ' ')) or
         (:from_date <> :old_from_date) or (:room_name <> :old_room_name)) then begin
        action_text = substring(f_character(29) || '@{pms.contract_type.' || :old_contract_type || '}' || f_character(28) ||
                      formatdate(:old_from_date, 'D;dd.mm.yyyy') ||
                      f_character(28) || :old_room_name ||
                      f_character(28) || coalesce(:old_rental_pool_unit_name, ' ') || f_character(28) || coalesce(:old_import_income_with_vat, 0) ||
                      f_character(28) || '@{pms.contract_type.' || :contract_type || '}' || f_character(28) || formatdate(:from_date, 'D;dd.mm.yyyy') ||
                      f_character(28) || :room_name || f_character(28) || coalesce(:rental_pool_unit_name, ' ') || f_character(28)
                      || coalesce(:import_income_with_vat, 0) from 1 for 255);
        execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_CHANGED', :ACTION_TEXT);
      end
    end

    if (:operation = 'del') then begin
      action_text = substring(f_character(29) || '@{pms.contract_type.' || :old_contract_type || '}' || f_character(28) ||
                    formatdate(:old_from_date, 'D;dd.mm.yyyy') ||
                    f_character(28) || :old_room_name || f_character(28) || coalesce(:old_rental_pool_unit_name, ' ') || f_character(28)
                    || coalesce(:old_import_income_with_vat, 0) from 1 for 255);
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_REMOVED', :ACTION_TEXT);

      delete from ROOM_CONTRACT$PMS where (ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT);

      execute procedure ROOM_PERIOD_MODIFY$PMS (:OLD_ID_ROOM_PERIOD, :id_room,  :old_from_date,
              iif(:contract_type in ('PRIVATE_USE'), 'PRIVATE', 'CONTRACT'),  'del')
      returning_values :new_id_room_period;
    end
  end
end
^

/* Restore proc. body: ROOM_MODIFY$PMS */
ALTER PROCEDURE ROOM_MODIFY$PMS(ID_ROOM INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
BEDS INTEGER,
EXTRA_BEDS INTEGER,
SECTOR INTEGER,
SORT_ORDER INTEGER,
FEATURES BLOB SUB_TYPE 1 SEGMENT SIZE 100,
EXTERNAL_NAME VARCHAR(10),
ID_EATING_OBJECT TYPE OF ID_REF,
OPERATION VARCHAR(20))
 RETURNS(OVERRULE_NEED SMALLINT,
OVERRULE_CONTEXT VARCHAR(255),
NEW_ID_ROOM INTEGER)
 AS
declare variable old_id_room_type integer;
  declare variable old_room_name varchar(10);
  declare variable rebuild_id_hotel integer;
  declare variable rebuild_id_room_type integer;
  declare variable guests_max integer;
  declare variable no_use varchar(20);
  declare variable err_text_key varchar(20);
  declare variable old_capacity integer;
  declare variable busy_group_type integer;
  declare variable sys_date date;
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable action_text varchar(255);
  declare variable old_floor integer;
  declare variable old_sector integer;
  declare variable old_extra_beds integer;
  declare variable id_hotel integer;
begin
  overrule_need = 0;
  overrule_context = '';
  new_id_room = null;
  --if OVERRULE_NEED = 1 then OVERRULE_CONTEXT = ERR_TEXT like ERR_CODE = -9
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    if (coalesce(:room_name, '') = '') then
      exception ASSERT '-119';

    if ((:room_name containing '<') or (:room_name containing '>') or (:room_name starting with 'i')) then
      exception ASSERT '-120';
  end

  room_name = upper(:room_name);

  if (:operation='mod') then begin
    select R.ROOM_NAME, R.ID_ROOM_TYPE, R.BEDS+R.EXTRA_BEDS, r.floor, r.sector, r.extra_beds
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :id_room
    into   :old_room_name, :old_id_room_type, :old_capacity, :old_floor, :old_sector, :old_extra_beds;

    if (:id_room_type <> :old_id_room_type) then begin
      exception OCCUPANCY_EXCEPTION 'ROOM TYPE CAN NOT BE CHANGED';
    end

    new_id_room = :id_room;
    guests_max = 0;
    if (:old_capacity > (:beds + :extra_beds)) then begin
      select first 1 sum(RM.ADULT_COUNT+RM.CHILDREN_COUNT), max(rm.BUSY_GROUP_TYPE)
      from   ROOM_MAGIC RM
             join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = RM.ID_RESERV_DETAIL
      where  RM.ID_ROOM = :id_room
             and RD.CHECK_STATUS in (-3, -2, -1, 0)
      group by RM.BUSY_DATE
      order by 1 desc
      into   :guests_max, :busy_group_type;
    end
    if ((:beds + :extra_beds) < :guests_max) then begin
      err_code = -8;
      err_text = f_character(29)||:ROOM_NAME||f_character(28)||:guests_max||f_character(28)||(:beds + :extra_beds);
      if (:busy_group_type in (1)) then begin
        overrule_need = :err_code;
        overrule_context = :err_text;
        err_code = 0;
        err_text = '';
      end else begin
        exception ASSERT :err_code || f_character(31) || :err_text;
      end
    end

    update ROOMS RU
    set    RU.ID_ROOM_TYPE = :id_room_type,
           RU.ROOM_NAME = :room_name,
           RU.FLOOR = :floor,
           RU.BEDS = :beds,
           RU.EXTRA_BEDS = :extra_beds,
           RU.SECTOR = :sector,
           RU.FEATURES = :features,
           RU.SORT_ORDER = :sort_order,
           --RU.ID_HOTEL = :rebuild_id_hotel,
           RU.EXTERNAL_NAME = :external_name,
           RU.ID_EATING_OBJECT = :ID_EATING_OBJECT
    where  RU.ID_ROOM = :id_room;

    if ((:room_name <> :old_room_name)
        or (:floor <> :old_floor)
        or (:sector <> :old_sector)
        or (:extra_beds <> :old_extra_beds)) then
    begin
      action_text = f_character(29) || '(' || :old_room_name || '/' || :old_floor || '/' || :old_sector || '/'
                    || :old_extra_beds || ')' || f_character(28) || '(' || :room_name || '/' || :floor || '/'
                    || :sector || '/' || :extra_beds || ')';
      execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_PARAMS_CHANGED', :action_text);
    end

    if (:room_name <> :old_room_name) then begin
      update ACCOUNT_POST AP
      set    AP.ROOM_NAME = :room_name
      where  AP.ROOM_NAME = :old_room_name;
    end

  end else if (:operation = 'add') then begin
    select rt.ID_HOTEL
    from   ROOM_TYPES RT
    where  rt.ID_ROOM_TYPE = :ID_ROOM_TYPE
    into   :id_hotel;

    insert into ROOMS (
      ID_ROOM, ID_ROOM_TYPE, ROOM_NAME, FLOOR, BEDS, EXTRA_BEDS, SECTOR,
      FEATURES, SORT_ORDER, ID_HOTEL, EXTERNAL_NAME, ID_EATING_OBJECT)
    values (gen_id(ID_ROOM_GEN, 1), :id_room_type, :room_name, :floor, :beds, :extra_beds, :sector,
      :features, :sort_order, :id_hotel, :external_name, :ID_EATING_OBJECT)
    returning ID_ROOM into :NEW_ID_ROOM;

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :sys_date;

    execute procedure ROOM_PERIOD_MODIFY$PMS(null, :new_id_room, :sys_date, 'HOTEL', 'add')
    returning_values  :no_use;

    insert into ROOMS_ADD (ID_ROOM, PMS_MARKERS, ADDRESS)
    values (:new_id_room, null, null);
  end else if (:operation = 'del') then begin
    /*err_code = -34;
    if (exists(select g.ID_GUEST
               from   GUEST G
                      join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
               where  G.ID_ROOM = :id_room
                      and rd.IS_ANUL = 0)) then err_text_key = 'GUESTS';
    else if (exists(select rd.ID_RESERV_DETAIL
                    from   RESERV_DETAIL RD
                    where  RD.ID_ROOM = :id_room
                           and RD.IS_ANUL = 0)) then err_text_key = 'RESERVATIONS';
    else err_code = 0;

    if (:err_code = 0) then begin
    */
    -- Booked rooms are preserved with FK constraint on room_magic
      execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'DELETE', '');

      select RT.ID_ROOM_TYPE, RT.ID_HOTEL
      from   ROOM_TYPES RT
      where  RT.ID_ROOM_TYPE = :id_room_type
      into   :rebuild_id_room_type, :rebuild_id_hotel;

      delete from ROOMS where ID_ROOM = :id_room;

      execute procedure ALLOTMENT_PHYS_REBUILD$INT(:rebuild_id_hotel, :rebuild_id_room_type);
    /*end else begin
      err_text = 'other.'||:err_text_key;
      if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || :err_text;
    end*/

    when sqlcode -530 do begin
      -- Violation of FOREIGN KEY constraint "%s" on table "%s"
      exception ASSERT '-34';
    end
  end
end
^

/* Restore proc. body: ROOM_OWNER_MODIFY$PMS */
ALTER PROCEDURE ROOM_OWNER_MODIFY$PMS(ID_ROOM_OWNER INTEGER,
ID_ROOM_CONTRACT INTEGER,
ID_OWNER INTEGER,
OWNERSHIP_PERCENT NUMERIC(15,4),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_OWNER INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_hotel integer;
  declare variable id_acc_template_pms integer;
  declare variable id_currency varchar(3);
  declare variable owner_name varchar(100);
  declare variable old_owner_name varchar(100);
  declare variable old_ownership_percent NUMERIC(15,4);
  declare variable old_id_room_contract integer;
  declare variable action_text varchar(255);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');
  new_id_room_owner = :id_room_owner;

  if ( (:operation in ('add', 'mod')) and (not exists ( select * from OWNER$PMS P where P.ID_OWNER = :ID_OWNER ) )) then begin
    exception PMS_EXCEPTION '-610';
    exit;
  end

  select RT.ID_HOTEL
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS RP on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
         join ROOMS R on RP.ID_ROOM = R.ID_ROOM
         join ROOM_TYPES RT on R.ID_ROOM_TYPE = RT.ID_ROOM_TYPE
  where  RC.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
  into   :id_hotel;

  if (:operation not in ('add')) then begin
    select coalesce(PR.PROFILE_NAME, ' '), RO.OWNERSHIP_PERCENT, RO.ID_ROOM_CONTRACT
    from ROOM_OWNER$PMS RO
      left outer join PROFILE PR ON PR.ID_PROFILE = RO.ID_OWNER
    where RO.ID_ROOM_OWNER = :ID_ROOM_OWNER
    into :old_owner_name, :old_ownership_percent, :old_id_room_contract;
  end

  select PRO.PROFILE_NAME
  from PROFILE PRO
    where PRO.ID_PROFILE = :ID_OWNER
  into :owner_name;

  if (:operation in ('add', 'mod')) then begin
    if (coalesce(:OWNERSHIP_PERCENT, 0) <= 0) then begin
      exception PMS_EXCEPTION '-611';
      exit;
    end
  end

  if (:operation = 'add') then begin
    if (coalesce(:ID_ROOM_OWNER, -1) < 0) then
         NEW_ID_ROOM_OWNER = gen_id(GEN_ROOM_OWNER$PMS_ID, 1);
    else NEW_ID_ROOM_OWNER = :ID_ROOM_OWNER;

    insert into ROOM_OWNER$PMS (ID_ROOM_OWNER, ID_ROOM_CONTRACT, ID_OWNER, OWNERSHIP_PERCENT)
    values (:NEW_ID_ROOM_OWNER, :ID_ROOM_CONTRACT, :ID_OWNER, :OWNERSHIP_PERCENT);

    action_text = f_character(29) || :owner_name || f_character(28) || formatfloat(:ownership_percent, '0.00');
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_OWNER_ADDED', :ACTION_TEXT);

    if (not exists ( select *
                     from   ACCOUNT A
                     where  A.IS_PMS_ACCOUNT = 1
                            and A.ID_HOTEL = :id_hotel
                            and A.ID_PROFILE = :ID_OWNER ))
    then begin
      select O.ID_ACC_TEMPLATE_PMS, O.ID_CURRENCY
      from   OWNER$PMS O
      where  O.ID_OWNER = :ID_OWNER
      into   :id_acc_template_pms, :id_currency;

      execute procedure ACCOUNT_CREATE_PMS$PMS(:ID_OWNER, :ID_ACC_TEMPLATE_PMS,
              :ID_CURRENCY, :ID_HOTEL)
      returning_values (:dbg);
    end

  when sqlcode -803 do begin
      exception BLOCK_DUBLICATE '-1057';
      exit;
  end

  end else if (:operation = 'mod') then begin
    if (not exists ( select *
                     from   ROOM_OWNER$PMS R
                     where  R.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
                            and R.ID_OWNER = :ID_OWNER ))
    then begin /* smenen e sobstwenik */
      if (not exists ( select *
                       from   ACCOUNT A
                       where  A.IS_PMS_ACCOUNT = 1
                              and A.ID_HOTEL = :id_hotel
                              and A.ID_PROFILE = :ID_OWNER ))
      then begin
        select O.ID_ACC_TEMPLATE_PMS, O.ID_CURRENCY
        from   OWNER$PMS O
        where  O.ID_OWNER = :ID_OWNER
        into   :id_acc_template_pms, :id_currency;
  
        execute procedure ACCOUNT_CREATE_PMS$PMS(:ID_OWNER, :ID_ACC_TEMPLATE_PMS,
                :ID_CURRENCY, :ID_HOTEL)
        returning_values (:dbg);
      end
    end

    update ROOM_OWNER$PMS
    set ID_OWNER = :ID_OWNER,
        OWNERSHIP_PERCENT = :OWNERSHIP_PERCENT
    where (ID_ROOM_OWNER = :ID_ROOM_OWNER);

    if ((:old_owner_name <> :owner_name) or (:old_ownership_percent <> :ownership_percent)) then begin
      action_text = f_character(29) || :old_owner_name || f_character(28) || formatfloat(:old_ownership_percent, '0.00') ||
                    f_character(28) || :owner_name || f_character(28) || formatfloat(:ownership_percent, '0.00');
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_OWNER_CHANGED', :ACTION_TEXT);
    end
  end else if (:operation = 'del') then begin
    action_text = f_character(29) || :old_owner_name || f_character(28) || formatfloat(:old_ownership_percent, '0.00');
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :OLD_ID_ROOM_CONTRACT, 'ROOM_OWNER_REMOVED', :ACTION_TEXT);

    delete from ROOM_OWNER$PMS
    where (ID_ROOM_OWNER = :ID_ROOM_OWNER);
  end
end
^

/* Restore proc. body: ROOM_PERIOD_MODIFY$PMS */
ALTER PROCEDURE ROOM_PERIOD_MODIFY$PMS(ID_ROOM_PERIOD INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
STATUS VARCHAR(30),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_PERIOD INTEGER)
 AS
declare variable no_use varchar(2000);
  declare variable id_hotel integer;
  declare variable old_status varchar(30);
  declare variable old_from_date date;
  declare variable id_room_type integer;
  declare variable old_id_room integer;
  declare variable old_to_date date;
  declare variable id_account_post integer;
  declare variable id_pms_event integer;
  declare variable action_text varchar(255);
  declare variable new_to_date date;
  declare variable prev_status varchar(30);
  declare variable checking smallint;
  declare variable old_id_room_contract integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');
  execute procedure SYSTEM_CHECK_OPERATION(:status, 'HOTEL, PRIVATE, CONTRACT, INACTIVE', 'Status');
  new_id_room_period = :id_room_period;

  if (:operation = 'add') then begin
    if (exists (select *
                from   ROOM_PERIOD$PMS R
                where  R.ID_ROOM = :id_room
                       and R.FROM_DATE = :from_date )) then exception PMS_EXCEPTION '-612';

    if (coalesce(:id_room_period, 0) <= 0) then new_id_room_period = gen_id(GEN_ROOM_PERIOD$PMS_ID,1);
    else new_id_room_period = :id_room_period;

    insert into ROOM_PERIOD$PMS (ID_ROOM_PERIOD, ID_ROOM, FROM_DATE, STATUS)
    values (:new_id_room_period, :id_room, :from_date, :status);

    execute procedure ROOM_PERIOD_TODATE$INT(:id_room);

    select rp.to_date
    from   ROOM_PERIOD$PMS rp
    where  rp.id_room_period = :new_id_room_period
    into   :new_to_date;

    action_text = f_character(29) || '@{period_room_status.'||:status||'}' || f_character(28) || formatdate(:from_date, 'dd.mm.yyyy')
                  || f_character(28) || iif(extract(year from :new_to_date) = 2500, '~', formatdate(:new_to_date, 'dd.mm.yyyy'));
    execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_STATUS_ADDED', :action_text);

  end else begin
    select R.STATUS, R.FROM_DATE, R.ID_ROOM, R.TO_DATE
    from   ROOM_PERIOD$PMS R
    where  R.ID_ROOM_PERIOD = :id_room_period
    into   :old_status, :old_from_date, :old_id_room, :old_to_date;

    if (:OPERATION = 'mod' and :old_id_room <> :ID_ROOM) then
      /* Very important check! */
      exception PMS_EXCEPTION 'Cannot change the contract room !';

    if (:OPERATION = 'del' and :old_status in ('PRIVATE', 'CONTRACT')) then begin
      if ((exists ( select *
                    from   ACCOUNT_POST$PMS AP1
                           join ACCOUNT$PMS A1 on A1.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS
                           join PMS_EVENT$PMS E1 on E1.ID_PMS_EVENT = AP1.ID_PMS_EVENT
                    where  AP1.DATE_POST between :OLD_FROM_DATE and :OLD_TO_DATE
                           and E1.ID_ROOM = :OLD_ID_ROOM
                           and A1.IS_SHADOW = 0
                           and AP1.LINE_STATUS < 22  ))
          or
          (exists ( select *
                    from   ACCOUNT_POST AP2
                           join PMS_EVENT_POST PP2 on AP2.ID_ACCOUNT_POST = AP2.ID_ACCOUNT_POST
                           join PMS_EVENT$PMS E2 on E2.ID_PMS_EVENT = PP2.ID_PMS_EVENT
                    where  AP2.DATE_POST between :OLD_FROM_DATE and :OLD_TO_DATE
                           and E2.ID_ROOM = :OLD_ID_ROOM
                           and PP2.LINE_STATUS < 22  )) ) then
      begin
        exception PMS_EXCEPTION '-624';
      end
    end

    for
      select AP1.ID_ACCOUNT_POST, AP1.ID_PMS_EVENT
      from   ACCOUNT_POST$PMS AP1
             join ACCOUNT$PMS A1 on A1.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS
             join PMS_EVENT$PMS E1 on E1.ID_PMS_EVENT = AP1.ID_PMS_EVENT
      where  AP1.DATE_POST between :OLD_FROM_DATE and :OLD_TO_DATE
             and E1.ID_ROOM = :OLD_ID_ROOM
             and A1.IS_SHADOW = 1
             and AP1.LINE_STATUS = 11 /*  anulirat se samo aktiwnite nachisleniq. Ako ima dokumentirani?! ili anulirani, ne se pipat  */
      into   :id_account_post, :id_pms_event
    do begin
      execute procedure ACCOUNT_POST_PMS_ANUL$INT(:id_pms_event, :id_account_post);
    end

    if (:operation = 'mod') then begin
      if (exists (select *
                  from   ROOM_PERIOD$PMS R
                  where  R.ID_ROOM in (:old_id_room, :id_room)
                         and R.FROM_DATE = :from_date
                         and R.ID_ROOM_PERIOD <> :id_room_period)) then exception PMS_EXCEPTION '-612';
  
      checking = 1;
      if ((:status in ('PRIVATE', 'CONTRACT')) and (:from_date = :old_from_date) and (:status = :old_status)) then begin
        checking = 0;
      end else if((:status in ('PRIVATE', 'CONTRACT')) and (:from_date <> :old_from_date)) then begin
        checking = 2;
        select first 1 rcp.id_room_contract
        from   ROOM_CONTRACT$PMS rcp
        where  rcp.id_room_period = :id_room_period
        into   :old_id_room_contract;
      end

      if (:checking > 0) then  begin -- else beshe po staria nachin
        update ROOM_PERIOD$PMS p
        set    p.FROM_DATE = :from_date,
               p.STATUS = :status
        where  p.ID_ROOM_PERIOD = :id_room_period;

        execute procedure ROOM_PERIOD_TODATE$INT(:id_room);

        select rp.to_date
        from   ROOM_PERIOD$PMS rp
        where  rp.id_room_period = :id_room_period
        into   :new_to_date;

        action_text = f_character(29) || '@{period_room_status.'||:old_status||'}'
                      || f_character(28) || iif(extract(year from :old_from_date) = 2500, '~', formatdate(:old_from_date, 'dd.mm.yyyy'))
                      || f_character(28) || iif(extract(year from :old_to_date) = 2500, '~', formatdate(:old_to_date, 'dd.mm.yyyy'))
                      || f_character(28) || '@{period_room_status.'||:status||'}'
                      || f_character(28) || iif(extract(year from :from_date) = 2500, '~', formatdate(:from_date, 'dd.mm.yyyy'))
                      || f_character(28) || iif(extract(year from :new_to_date) = 2500, '~', formatdate(:new_to_date, 'dd.mm.yyyy'));
        execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_STATUS_CHANGED', :action_text);

        if (:checking > 1) then
          execute procedure SYSTEM_LOG_ADD ('CONTRACT', :OLD_ID_ROOM_CONTRACT, 'ROOM_STATUS_CHANGED', :action_text);

      end

    end else if (:operation = 'del') then begin
      if (singular (select *
                    from   ROOM_PERIOD$PMS R
                    where  R.ID_ROOM = :old_id_room)) then exception PMS_EXCEPTION '-622';

      select first 1 rpm.status
      from   ROOM_PERIOD$PMS rpm
      where  rpm.id_room = :id_room
             and rpm.from_date < :old_from_date
      order by rpm.from_date desc
      into   :prev_status;

      delete from ROOM_PERIOD$PMS
      where  ID_ROOM_PERIOD = :id_room_period;

      execute procedure ROOM_PERIOD_TODATE$INT(:id_room);

      action_text = f_character(29) || '@{period_room_status.'||:old_status||'}'
                  || f_character(28) || iif(extract(year from :old_from_date) = 2500, '~', formatdate(:old_from_date, 'dd.mm.yyyy'))
                  || f_character(28) || iif(extract(year from :old_to_date) = 2500, '~', formatdate(:old_to_date, 'dd.mm.yyyy'))
                  || f_character(28) || '@{period_room_status.'||:prev_status||'}' ;
      execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_STATUS_DELETED', :action_text);
    end
  end

  /* rebuild physical allotment */
  if ( (:operation in ('add', 'del'))
       or
       ((:operation = 'mod') and ((:old_status <> :status) or (:old_from_date <> :from_date)))) then
  begin
    select RT.ID_HOTEL, R.ID_ROOM_TYPE
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :id_room
    into   :id_hotel, :id_room_type;

    execute procedure ALLOTMENT_PHYS_REBUILD$INT(:id_hotel, :id_room_type);
  end

end
^

/* Restore proc. body: SAFE_OCCUPANCY_ANNUL */
ALTER PROCEDURE SAFE_OCCUPANCY_ANNUL(ID_SAFE TYPE OF ID,
REASON TYPE OF TREASON)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_resource_reservation integer;
  declare variable from_datetime timestamp;
  declare variable to_datetime timestamp;
  declare variable action_text varchar(255);
  declare variable id_account_post integer;
begin
  select s.ID_CURRENT_OCCUPANCY, od.FROM_DATETIME, od.TO_DATETIME, rp.ID_ACCOUNNT_POST
  from   SAFE S
         join RESOURCE_RESERVATION rr on rr.ID_RESOURCE_RESERVATION = s.ID_CURRENT_OCCUPANCY
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESOURCE_RESERV_POST rp on rp.ID_RESOURCE_RESERVATION = rr.ID_RESOURCE_RESERVATION
  where  s.ID_SAFE = :ID_SAFE
  into   :id_resource_reservation, :from_datetime, :to_datetime, :id_account_post;

  execute procedure RESOURCE_RESERVATION_CANCEL (:id_resource_reservation, :REASON);

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = null
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:REASON, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_ANNUL', :action_text);

  execute procedure ACCOUNT_POSTING_ANUL (:id_account_post, :REASON);

  DOC_SELECTED = null;
  update ACCOUNT_POST AP
  set    ap.DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1)
  where  ap.ID_ACCOUNT_POST = :id_account_post
         and ap.ac = '00'
  returning new.doc_selected
  into   :DOC_SELECTED;

end
^

/* Restore proc. body: SALE_TAX_MODIFY$CFG */
ALTER PROCEDURE SALE_TAX_MODIFY$CFG(ID_SALE_TAX INTEGER,
TAX_NAME VARCHAR(50),
TAX_PERCENT NUMERIC(15,4),
TAXABLE_BASE_PERCENT NUMERIC(15,4),
TAX_VALUE NUMERIC(15,4),
REVENUE_DEDUCTION_TAX SMALLINT,
REPORT_IN_DOCUMENT SMALLINT,
FISCAL_CODE VARCHAR(30),
ACCOUNT_NAME VARCHAR(50),
OPERATION VARCHAR(10),
ID_HOTEL TYPE OF ID)
 RETURNS(NEW_ID_SALE_TAX INTEGER)
 AS
declare variable id_sale_taxation integer;
declare variable old_tax_percent numeric(15,4);
declare variable old_taxable_base_percent numeric(15,4);
declare variable taxation_name varchar(50);
declare variable old_tax_name varchar(50);
declare variable old_fiscal_code varchar(30);
declare variable old_is_percent smallint;
declare variable new_is_percent smallint;
declare variable old_rev_deduction_tax integer;
declare variable old_tax_value tprice;
begin
  execute procedure SYSTEM_CHECK_OPERATION (:OPERATION, 'add, mod, del');

  if (:TAX_VALUE is not null and :TAX_PERCENT is not null) then exception ASSERT '-701';

  fiscal_code = nullif(trim(:FISCAL_CODE), '');
  if (:OPERATION = 'add') then begin
    insert into SALE_TAXES (ID_SALE_TAX, TAX_NAME, TAX_PERCENT, TAXABLE_BASE_PERCENT,
           FISCAL_CODE, ACCOUNT_NAME, ID_HOTEL, TAX_VALUE, REVENUE_DEDUCTION_TAX, REPORT_IN_DOCUMENT)
    values (nullif(:ID_SALE_TAX, -1), :TAX_NAME, coalesce(:TAX_PERCENT, 0), coalesce(:TAXABLE_BASE_PERCENT, 100),
           :FISCAL_CODE, :ACCOUNT_NAME, :id_hotel, :TAX_VALUE, :REVENUE_DEDUCTION_TAX, :REPORT_IN_DOCUMENT)
    returning ID_SALE_TAX
    into   :NEW_ID_SALE_TAX;

  end else if (:OPERATION = 'mod') then begin
    select st.TAX_PERCENT, st.TAXABLE_BASE_PERCENT, st.tax_name, st.fiscal_code, st.IS_PERCENT_TAX,
           st.REVENUE_DEDUCTION_TAX, st.TAX_VALUE
    from   SALE_TAXES st
    where  st.ID_SALE_TAX = :ID_SALE_TAX
    into   :old_tax_percent, :old_taxable_base_percent, :old_tax_name, :old_fiscal_code, :old_is_percent,
           :old_rev_deduction_tax, :old_tax_value;

    if (coalesce(:old_rev_deduction_tax, 0) <> coalesce(:REVENUE_DEDUCTION_TAX, 0)) then
      exception ASSERT '-702';

    if ((:TAX_PERCENT is distinct from :old_tax_percent)
        or (:TAXABLE_BASE_PERCENT is distinct from :old_taxable_base_percent)
        or (:TAX_VALUE is distinct from :old_tax_value)) then begin
      for
        select distinct stt.ID_SALE_TAXATION, t.NAME
        from   SALE_TAXATION_TAX STT
               join SALE_TAXATION t on t.ID_SALE_TAXATION = stt.ID_SALE_TAXATION
        where  stt.ID_SALE_TAX = :ID_SALE_TAX
        into   :id_sale_taxation, :taxation_name
      do begin

        /* check if sale tax is used in postings */
        delete from SALE_TAXATION STT where stt.ID_SALE_TAXATION = :id_sale_taxation;
  
        insert into SALE_TAXATION (ID_SALE_TAXATION, NAME, ID_HOTEL)
        values (:id_sale_taxation, :taxation_name, :id_hotel);
  
        when sqlcode -530 do begin
          exception UNALLOWABLE_EDITING;
        end
      end 

      execute procedure SYSTEM_LOG_ADD('SALE_TAX', :ID_SALE_TAX, 'TAX_CHANGED',
              f_character(29) || :old_tax_percent  || '%'  || f_character(28) || :old_taxable_base_percent || '%'
              || f_character(28) || :TAX_PERCENT  || '%'  || f_character(28) || :TAXABLE_BASE_PERCENT || '%');
    end

    update SALE_TAXES T
    set    t.TAX_PERCENT = :TAX_PERCENT,
           t.TAXABLE_BASE_PERCENT = :TAXABLE_BASE_PERCENT,
           T.TAX_NAME = :TAX_NAME,
           t.FISCAL_CODE = :FISCAL_CODE,
           t.ACCOUNT_NAME = :ACCOUNT_NAME,
           t.TAX_VALUE = :TAX_VALUE,
           --t.REVENUE_DEDUCTION_TAX = :REVENUE_DEDUCTION_TAX,
           t.REPORT_IN_DOCUMENT = :REPORT_IN_DOCUMENT
    where  T.ID_SALE_TAX = :ID_SALE_TAX
    returning new.IS_PERCENT_TAX
    into   :new_is_percent;
    NEW_ID_SALE_TAX = :ID_SALE_TAX;

    if (:new_is_percent <> :old_is_percent) then exception ASSERT '-703';

    if ((:old_tax_name <> :tax_name) or (:old_fiscal_code <> :fiscal_code)) then begin
      execute procedure SYSTEM_LOG_ADD('SALE_TAX', :ID_SALE_TAX, 'TAX_NAME_CHANGED',
              f_character(29) || :old_tax_name || f_character(28) || :old_fiscal_code ||
              f_character(28) || :tax_name || f_character(28) || :fiscal_code);
    end

  end else if (:OPERATION = 'del') then begin
    execute procedure SYSTEM_LOG_ADD ('SALE_TAX', :ID_SALE_TAX, 'DELETE', '');

    delete from SALE_TAXES ST
    where  ST.ID_SALE_TAX = :ID_SALE_TAX;

    NEW_ID_SALE_TAX = null;

    when sqlcode -530 do begin
      exception REF_INTEGRITY_DELETE;
    end
  end
end
^

/* Restore proc. body: SALE_TAXATION_MODIFY$CFG */
ALTER PROCEDURE SALE_TAXATION_MODIFY$CFG(ID_SALE_TAXATION TYPE OF ID,
NAME TYPE OF TOBJECT_NAME,
TAXES VARCHAR(250),
ACCOUNT_NAME TYPE OF TOBJECT_NAME,
OPERATION VARCHAR(10),
ID_HOTEL TYPE OF ID)
 RETURNS(NEW_ID_SALE_TAXATION INTEGER)
 AS
declare variable is_changed integer;
  declare variable id_sale_tax integer;
  declare variable nat_round_to numeric(15,4);
  declare variable nat_curr varchar(3);
  declare variable ap_dbkey char(8);
  declare variable action_text varchar(255);
begin
  execute procedure SYSTEM_CHECK_OPERATION (:OPERATION, 'add, mod, del');

  if (:OPERATION = 'add') then begin
    insert into SALE_TAXATION (NAME, ACCOUNT_NAME, ID_HOTEL)
    values (:NAME, :ACCOUNT_NAME, :ID_HOTEL)
    returning ID_SALE_TAXATION
    into      :NEW_ID_SALE_TAXATION;

  end else if (:OPERATION = 'mod') then begin
    new_id_sale_taxation = :id_sale_taxation;
    update SALE_TAXATION ST
    set    ST.NAME = :name,
           st.ACCOUNT_NAME = :ACCOUNT_NAME
    where  ST.ID_SALE_TAXATION = :id_sale_taxation;

    NEW_ID_SALE_TAXATION = :ID_SALE_TAXATION;
  end else if (:OPERATION = 'del') then begin
    delete from SALE_TAXATION
    where  ID_SALE_TAXATION = :id_sale_taxation;

    delete from SALE_TAXATION_TAX STT
    where  stt.ID_SALE_TAXATION = :ID_SALE_TAXATION;

    new_id_sale_taxation = null;
  end
   
  if (:OPERATION in ('add','mod')) then begin
    is_changed = 0;
    select f_character(29) || stax.name
    from   SALE_TAXATION stax
    where  stax.id_sale_taxation = :NEW_ID_SALE_TAXATION
    into   :action_text;

    for
      select stt.ID_SALE_TAX
      from   SALE_TAXATION_TAX STT
      where  stt.ID_SALE_TAXATION = :NEW_ID_SALE_TAXATION
             and ','||:TAXES||',' not containing ','||stt.ID_SALE_TAX||','
      into   :id_sale_tax
    do begin
      delete from SALE_TAXATION_TAX ST
      where  st.ID_SALE_TAXATION = :NEW_ID_SALE_TAXATION
             and st.ID_SALE_TAX = :id_sale_tax;
      is_changed = 1;
      execute procedure SYSTEM_LOG_ADD ('SALE_TAX', :id_sale_tax, 'SALE_TAX_REMOVED', :action_text);
    end

    for
      select T.ITEM
      from   SYSTEM_STRING_PARSER (:TAXES, ',') T
      --       left outer join SALE_TAXES ST on st.ID_SALE_TAX = t.ITEM
      --where  st.IS_ARCHIVE = 0
      into   :id_sale_tax
    do begin
      if (not exists (select stt.ID_SALE_TAX
                      from   SALE_TAXATION_TAX STT
                      where  stt.ID_SALE_TAXATION = :NEW_ID_SALE_TAXATION
                             and stt.ID_SALE_TAX = :id_sale_tax)) then
      begin
        insert into SALE_TAXATION_TAX (ID_SALE_TAXATION, ID_SALE_TAX)
        values (:NEW_ID_SALE_TAXATION, :id_sale_tax);
        is_changed = 1;
        execute procedure SYSTEM_LOG_ADD ('SALE_TAX', :id_sale_tax, 'SALE_TAX_ADDED', :action_text);
      end
    end

    if (:is_changed = 1) then begin
      select h.NATION_CURR
      from   HOTEL H
      where  h.ID_HOTEL = :ID_HOTEL
      into   :nat_curr;

      select C.ROUND_TO
      from   CURRS C
      where  c.CURR = :nat_curr
      into   :nat_round_to;
    
      for
        select AP.RDB$DB_KEY
        from   ACCOUNT_POST AP
        where  AP.ID_SALE_TAXATION = :NEW_ID_SALE_TAXATION
               --and A.IS_ARCHIVE = 0
               and AP.AC = '00'
        into   :ap_dbkey
      do begin
        execute procedure ACCOUNT_POSTING_UPDATE_TAX$INT (:ap_dbkey, :NEW_ID_SALE_TAXATION, :nat_round_to, 'SERVICE VAT CHANGED');
      end
    end
  end

  execute procedure SYSTEM_CACHE_APPLY('SALE_TAXATION');
end
^

/* Restore proc. body: SERVICE_TAXATION_MODIFY$CFG */
ALTER PROCEDURE SERVICE_TAXATION_MODIFY$CFG(ID_TAX_POLICY TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_SALE_TAXATION TYPE OF ID)
 AS
declare variable dbkey char(8);
  declare variable nat_round_to numeric(15,4);
  declare variable nat_curr varchar(3);
  declare variable action_text varchar(255);
  declare variable old_sale_taxation_name varchar(50);
  declare variable service_name varchar(30);
  declare variable id_hotel integer;
begin
  if (:ID_SALE_TAXATION is null) then begin
    delete from SERVICE_TAXATION T
    where  t.ID_TAX_POLICY = :ID_TAX_POLICY
           and t.ID_SERVICE = :ID_SERVICE;

    select f_character(29) || se.service_name
    from   SERVICES se
    where  se.id_service = :id_service
    into   :action_text;
    execute procedure SYSTEM_LOG_ADD ('TAX_POLICY', :id_tax_policy, 'TAX_POLICY_SERVICE_DELETED', :action_text);
  end else begin
    select sta.name, se.service_name, se.ID_HOTEL
    from   SERVICE_TAXATION TPT
           join SALE_TAXATION sta on sta.id_sale_taxation = tpt.id_sale_taxation
           join SERVICES se on se.id_service = tpt.id_service
    where  TPT.ID_TAX_POLICY = :ID_TAX_POLICY
           and TPT.ID_SERVICE = :ID_SERVICE
    into   :old_sale_taxation_name, :service_name, :id_hotel;

    update SERVICE_TAXATION T
    set    T.ID_SALE_TAXATION = :ID_SALE_TAXATION
    where  T.ID_TAX_POLICY = :ID_TAX_POLICY
           and T.ID_SERVICE = :ID_SERVICE;

    if (row_count > 0) then begin
      select st.name
      from   SALE_TAXATION st
      where  st.id_sale_taxation = :id_sale_taxation
      into   :action_text;
      action_text = f_character(29) || :service_name || f_character(28) || :old_sale_taxation_name || f_character(28) || :action_text;
      execute procedure SYSTEM_LOG_ADD ('TAX_POLICY', :id_tax_policy, 'TAX_POLICY_SERVICE_UPDATED', :action_text);
    end else begin
      insert into SERVICE_TAXATION (ID_TAX_POLICY, ID_SERVICE, ID_SALE_TAXATION)
      values (:ID_TAX_POLICY, :ID_SERVICE, :ID_SALE_TAXATION);
    end
  
    select h.NATION_CURR
    from   HOTEL H
    where  h.ID_HOTEL = :id_hotel
    into   :nat_curr;

    select C.ROUND_TO
    from   CURRS C
    where  c.CURR = :nat_curr
    into   :nat_round_to;
  
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT A
             join ACCOUNT_POST AP on AP.ID_ACCOUNT = A.ID_ACCOUNT
      where  A.ID_TAX_POLICY = :ID_TAX_POLICY
             and A.IS_ARCHIVE = 0
             and AP.ID_SERVICE = :ID_SERVICE
             and AP.AC = '00'
             and not AP.ID_SALE_TAXATION = :ID_SALE_TAXATION
      into   :dbkey
    do begin
      execute procedure ACCOUNT_POSTING_UPDATE_TAX$INT (:dbkey, :ID_SALE_TAXATION, :nat_round_to, 'SERVICE VAT CHANGED');
    end
  end
end
^

/* Restore proc. body: SETTINGS_MODIFY_VALUE */
ALTER PROCEDURE SETTINGS_MODIFY_VALUE(SETTING_CODE TYPE OF TSEARCH_CODE,
SETTING_VALUE TYPE OF TOBJECT_TEXT,
ID_HOTEL TYPE OF ID)
 AS
declare variable old_setting_value varchar(100);
declare variable tmp_setting_value varchar(100);
  declare variable action_text varchar(255);
  declare variable setting_name varchar(255);
  declare variable id_setting_grp integer;
  declare variable settingClass varchar(20);
  declare variable dbkey char(8);
begin
  dbkey = null;
  select SV.SETTING_VALUE, S.ID_SETTING_GRP, S.CONTROL_CLASS, sv.RDB$DB_KEY
  from   SETTING s
         join SETTING_HOTEL_VALUE SV on sv.SETTING_CODE = s.SETTING_CODE
  where  SV.SETTING_CODE = :setting_code
         and sv.ID_HOTEL = :ID_HOTEL
  into   :old_setting_value, :id_setting_grp, :settingClass, :dbkey;

  if (:dbkey is not null) then begin
    update SETTING_HOTEL_VALUE SV
    set    SV.SETTING_VALUE = :setting_value
    where  SV.RDB$DB_KEY = :dbkey;
  end else begin
    insert into SETTING_HOTEL_VALUE (SETTING_CODE, ID_HOTEL, SETTING_VALUE)
    values (:SETTING_CODE, :ID_HOTEL, :SETTING_VALUE);
  end

  RDB$SET_CONTEXT('USER_SESSION', 'setting.'||:setting_code||'.'||:id_hotel, :setting_value);

  if ((:id_setting_grp is not null) and (:setting_value is distinct from :old_setting_value)) then begin
    /* FOR THE FEATURE THIS KIND OF LOGING MUST BE BASED
    || ON MACROS WICH ARE EXECUTED AT DISPLAY TIME.
    || FOR NOW WE ARE HARDCODED TO THE BASE LANG.
    */
    setting_name = '@{set_name.'||:setting_code||'}';
    action_text = f_character(29)||:setting_name;

    if (:settingClass = 'COMBO') then begin
      old_setting_value = '@{set_item.'||:setting_code||'.'||:old_setting_value||'}';
      tmp_setting_value = '@{set_item.'||:setting_code||'.'||:setting_value||'}';
    end else begin
      tmp_setting_value = :setting_value;
    end

    action_text = :action_text
                  || f_character(28) || coalesce(:old_setting_value, '')
                  || f_character(28) || :tmp_setting_value;
    execute procedure SYSTEM_LOG_ADD ('SYSTEM', 0, 'SETTING_CHANGED', :action_text);
  end

  execute procedure SYSTEM_CACHE_APPLY('HOTEL');
end
^

SET TERM ; ^

ALTER TABLE EXT_BAVEL_SERVICE_MAP ALTER COLUMN ID_SERVICE POSITION 1;

ALTER TABLE EXT_BAVEL_SERVICE_MAP ALTER COLUMN IS_DISCOUNT POSITION 2;

ALTER TABLE EXT_BAVEL_SERVICE_MAP ALTER COLUMN BAVEL_SERVICE_TYPE POSITION 3;

ALTER TABLE HOTEL_BORICA_CFG$WBE ALTER COLUMN ID POSITION 1;

ALTER TABLE HOTEL_BORICA_CFG$WBE ALTER COLUMN HOTEL_ID POSITION 2;

ALTER TABLE HOTEL_BORICA_CFG$WBE ALTER COLUMN TERMINAL_ID POSITION 3;

ALTER TABLE HOTEL_BORICA_CFG$WBE ALTER COLUMN HTTPS_CER POSITION 4;

ALTER TABLE HOTEL_BORICA_CFG$WBE ALTER COLUMN HTTPS_KEY POSITION 5;

ALTER TABLE HOTEL_BORICA_CFG$WBE ALTER COLUMN APGW_KEY POSITION 6;

ALTER TABLE HOTEL_BORICA_CFG$WBE ALTER COLUMN WEB_CERT POSITION 7;

ALTER TABLE SYSTEM_INFO_UPDATE ALTER COLUMN ID_INFO_UPDATE POSITION 1;

ALTER TABLE SYSTEM_INFO_UPDATE ALTER COLUMN PRODUCT_VERSION POSITION 2;

ALTER TABLE SYSTEM_INFO_UPDATE ALTER COLUMN PATCH_VERSION POSITION 3;

ALTER TABLE SYSTEM_INFO_UPDATE ALTER COLUMN DATETIME_EXECUTION POSITION 4;

ALTER TABLE SYSTEM_INFO_UPDATE ALTER COLUMN BIN_CONTENT POSITION 5;

ALTER TABLE SYSTEM_INFO_UPDATE ALTER COLUMN RELEASE_DATE POSITION 6;

