/* Server version: WI-V6.3.4.18393 Firebird 2.1 
   SQLDialect: 3. ODS: 11.1. Forced writes: On. Sweep inteval: 20000.
   Page size: 8192. Cache pages: 2048 (16384 Kb). Read-only: False. */
SET SQL DIALECT 3;

ALTER TABLE SUBSCRIBTION$NH DROP CONSTRAINT PK_SUBSCRIBTION$NH;

RECONNECT;

ALTER TABLE DOC_PAYMENTS DROP CONSTRAINT PK_DOC_PAYMENTS;

ALTER TABLE DOC_PAYMENTS DROP CONSTRAINT FK_DPAY_DOC_HEAD;

ALTER TABLE DOC_PAYMENTS DROP CONSTRAINT FK_DPAY_ACC_PAYMENT;

/* Create Domains... */
CREATE DOMAIN TROOM_STATUS AS VARCHAR(50) CHECK(value in ('HOTEL', 'PRIVATE', 'CONTRACT', 'INACTIVE'));

/* Dropping trigger... */
DROP TRIGGER DOC_PAYMENTS_AIUD0;


/* Drop Index... */
RECONNECT;

/* Drop: TMP_ALLOTMENT_DETAIL_IDX1 (TIdxData) */
DROP INDEX TMP_ALLOTMENT_DETAIL_IDX1;


/* Drop View... */
SET TERM ^ ;

ALTER PROCEDURE ACCOUNTS_BALANCE_TO_DATE$RPT(ID_HOTEL INTEGER,
TO_DATE DATE)
 RETURNS(ID_ACCOUNT INTEGER,
ACCOUNT_CURR CHAR(3),
CURR_RATE NUMERIC(15,6),
POSTING_AMOUNT NUMERIC(15,4),
PAYMENT_AMOUNT NUMERIC(15,4),
OPEN_DEP_AMOUNT NUMERIC(15,4),
OPEN_CHARGES INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE DOC_CHECK_FISCAL$INT(DH_DBKEY CHAR(8))
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE DOCUMENT_PAY_TYPES(ID_DOC_HEAD INTEGER)
 RETURNS(PAY_TYPE_LIST VARCHAR(255),
PAY_TYPE_IDS VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE FISCAL_VALUE_GET$INT(ID_DOC_HEAD INTEGER)
 RETURNS(FISCAL_VALUE NUMERIC(15,2),
FISCAL_PAYMENT_CNT INTEGER,
FISCAL_PAYMENT_VALUE NUMERIC(15,2),
SALE_REDUCTION_COEF DOUBLE PRECISION)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE FISCALIZE_PAYMENT$FISC(ID_DOC_HEAD INTEGER)
 RETURNS(FISC_SUM NUMERIC(15,4),
FISC_TEXT VARCHAR(30),
FISC_GRP VARCHAR(10))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE PAYMENTS_EW_SUMMARIZE$INT(ID_END_WORK INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE SPR_DOC_MATRIX(FROM_DATE DATE,
TO_DATE DATE,
ID_CONTRAGENT INTEGER,
ID_TYPE_PAYMENT INTEGER,
ID_BASE_DOC_TYPE INTEGER,
SRV_GROUP_TAG VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(DOC_DATA VARCHAR(30),
IS_ANUL SMALLINT,
CONTRAGENT_NAME VARCHAR(100),
USER_NAME VARCHAR(50),
COL_NAME VARCHAR(30),
COL_VALUE NUMERIC(15,4),
COL_ORIG_VALUE NUMERIC(15,4),
SORT_ORDER SMALLINT)
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP VIEW REALIZED_PAYMENTS;


/* Create Table... */
CREATE GLOBAL TEMPORARY TABLE ALLOTMENT_DETAIL$TMP(ID_ALLOTMENT_SESSION ID,
ID_ALLOTMENT ID,
ID_ROOM_TYPE ID,
FOR_DATE TDATE,
CNT_ROOMS TCOUNT_SMALL,
ACTIVE_FRAME_BEGIN TCOUNT_SMALL,
ACTIVE_FRAME_END TCOUNT_SMALL,
SEQ BIGINT)
 ON COMMIT DELETE ROWS;


ALTER TABLE ALLOTMENT_DETAIL$TMP ADD DIFF_NO COMPUTED BY (CNT_ROOMS || '.' || (100 * (ACTIVE_FRAME_BEGIN+1) + ACTIVE_FRAME_END));

CREATE TABLE DOC_PAY_USAGE(ID_DOC_HEAD ID,
ID_ACCOUNT_PAYMENT ID,
PAY_AMOUNT TVALUE NOT NULL,
PAY_RATE TRATE NOT NULL,
DOC_AMOUNT TVALUE NOT NULL,
DOC_RATE TRATE NOT NULL,
EQUAL_PAY_DOC_RATE TCROSS_RATE);


CREATE TABLE INFOMATIC_ACCOUNT(ID TI64_ID NOT NULL,
ACCOUNT_NAME TSUBSCRIBER_ID DEFAULT '' NOT NULL,
AUTH_DIGEST TOBJECT_TEXT DEFAULT '' NOT NULL,
ACTIVE_SERVICES TOBJECT_TEXT DEFAULT '' NOT NULL,
IS_DEFAULT TBOOLEAN DEFAULT 0 NOT NULL);


CREATE TABLE INFOMATIC_CHANNEL(ID TI64_ID NOT NULL,
INFOMATIC_ACCOUNT_ID TI64_ID NOT NULL,
CHANNEL_NAME TOBJECT_NAME NOT NULL,
REMOTE_ID TOBJECT_TEXT DEFAULT '' NOT NULL);


CREATE TABLE INFOMATIC_QUEUE(ID TI64_ID NOT NULL,
INFOMATIC_CHANNEL_ID TI64_ID NOT NULL,
SUBJECT TOBJECT_TEXT NOT NULL,
QUEUE_POS TOBJECT_TEXT DEFAULT '' NOT NULL);


CREATE TABLE RESERV_ROOMS$EXC(ID_RESERV_DETAIL ID,
FOR_DATE TDATE NOT NULL,
IMPORT_ID_ROOM ID_REF,
IMPORT_ROOM_TYPE_UUID UUID,
IMPORT_ROOM_STATUS TROOM_STATUS,
ACTUAL_ROOM_STATUS TROOM_STATUS);



ALTER TABLE ROOM_MAGIC ADD ROOM_STATUS TROOM_STATUS;

UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='TROOM_STATUS' WHERE RDB$FIELD_NAME='STATUS' AND RDB$RELATION_NAME='ROOM_PERIOD$PMS';

/* Drop table-fields... */
/* Empty RES_OCCUPANCY_ROOM$INT for drop RESERV_STAY$TMP(ROOM_TYPE_UUID) */
SET TERM ^ ;

ALTER PROCEDURE RES_OCCUPANCY_ROOM$INT(ID_RESERV_DETAIL INTEGER,
FOR_DATE DATE,
ID_RES_ROOM INTEGER,
ID_RES_ROOM_TYPE INTEGER)
 RETURNS(ID_ROOM INTEGER,
ID_ROOM_TYPE INTEGER)
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

ALTER TABLE RESERV_STAY$TMP DROP ROOM_TYPE_UUID;


RECONNECT;

/* Drop tables... */
SET TERM ^ ;

ALTER PROCEDURE DOCUMENT_AR_PAYMENTS_APPLY$INT(DOC_DBKEY CHAR(8),
OPERATION VARCHAR(10),
THROW_EXCEPTION SMALLINT,
DESCRIPTION VARCHAR(255) = null)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE DOCUMENT_ATTACH_PAYMENT$INT(ID_DOC_HEAD INTEGER,
ID_ACCOUNT_PAYMENT INTEGER,
PAY_CURR_RATE NUMERIC(15,6),
PAY_VALUE NUMERIC(15,4))
 RETURNS(DOC_VALUE NUMERIC(15,4))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE DOCUMENT_CASH_STATUS(ID_DOC_HEAD INTEGER)
 RETURNS(IS_CASH SMALLINT)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE DOCUMENT_DETACH_DEPOSIT$INT(ID_DOC_HEAD INTEGER,
ID_DEPOSIT INTEGER,
ID_STORNO_DOC INTEGER = null)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE DOCUMENT_GET_VALUE$INT(ID_DOC_HEAD INTEGER,
TARGET_CURR VARCHAR(3),
TARGET_RATE NUMERIC(15,6) = null)
 RETURNS(ID_PAY_DOC_DEF INTEGER,
TOTAL_CURR VARCHAR(3),
TOTAL_RATE NUMERIC(15,6),
TOTAL_VALUE NUMERIC(15,4),
PAYABLE_VALUE NUMERIC(15,4))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE DOCUMENT_REUSE_PAYMENTS$INT(OLD_ID_DOC_HEAD INTEGER,
NEW_ID_DOC_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE DOCUMENT_STORNO_PAYS_SET$DOC(ID_STORNO_DOC INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE EXPORT_DOCUMENT_PAYMENT(ID_DOC_HEAD INTEGER,
PAY_TAG VARCHAR(20),
NO_PAY_DOCS VARCHAR(20),
DOC_CURRENCY CHAR(3),
ID_BASE_DOC INTEGER,
DOC_GRAND_TOTAL NUMERIC(15,4))
 RETURNS(PAY_TYPE_ID INTEGER,
PAY_TYPE VARCHAR(20),
PAY_CURRENCY CHAR(3),
PAY_RATE NUMERIC(15,6),
PAY_VALUE NUMERIC(15,4),
PAY_CC_NAME VARCHAR(50),
PAY_CC_NUM VARCHAR(50),
PAY_CC_BANK VARCHAR(50),
PAY_COEFICIENT DOUBLE PRECISION,
EXPORT_TAG VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE PAYMENT_STORNO$INT(ID_PAYMENT_HEAD INTEGER,
ID_ACCOUNT INTEGER,
NEW_ID_DOC_HEAD INTEGER,
STORNO_AMOUNT NUMERIC(15,4),
DESCRIPTION VARCHAR(100),
TARGET_DOC_AMOUNT NUMERIC(15,4))
 RETURNS(ID_STORNO_PAYMENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE PAYMENT_VOID_CHECK$INT(ID_PAYMENT_HEAD /* TYPE OF ID */ INTEGER,
VOID_REASON /* TYPE OF TREASON */ VARCHAR(50))
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE SERVICE_PAYMENT_ANALYSIS$RPT(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER)
 RETURNS(ID_SERVICE INTEGER,
ID_PAYMENT_TYPE INTEGER,
SALE_AMOUNT NUMERIC(15,4))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE DOCUMENT_REUSE_DEPOSITS$INT(OLD_ID_DOC_HEAD INTEGER,
NEW_ID_DOC_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE DOCUMENT_STORNO$INT(ID_DOC_HEAD INTEGER,
DESCRIPTION VARCHAR(100),
STORNO_PAYMENTS SMALLINT)
 RETURNS(ID_STORNO_DOC INTEGER,
ID_HOTEL INTEGER)
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP VIEW DEPOSIT_DEDUCT;

DROP VIEW DEPOSIT_FLOW;

SET TERM ^ ;

ALTER PROCEDURE DEPOSIT_ANUL$INT(ID_DEPOSIT INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_PAYMENT_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE DOCUMENT_ADVANCE_PAYMENT$INT(ID_DOC_HEAD INTEGER,
ID_PAYMENT_HEAD INTEGER,
ACC_RATE NUMERIC(15,6))
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE DOCUMENT_ADVANCE_STORNO$INT(ID_DEPOSIT INTEGER,
PAY_AMOUNT NUMERIC(15,2),
DESCRIPTION VARCHAR(100))
 RETURNS(ID_STORNO_DOC INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER TRIGGER DEPOSITS_BIUD0
 AS Declare variable I integer;
BEGIN I = 0; END
^

SET TERM ; ^

DROP TRIGGER DEPOSITS_BIUD0;

SET TERM ^ ;

ALTER PROCEDURE ACCOUNT_CURR_BALANCE$INT(ID_ACCOUNT INTEGER,
BALANCE_CURR VARCHAR(3),
EW_INCL_ONLY SMALLINT = 0)
 RETURNS(CURR_ORIG CHAR(3),
POST_ORIG_VALUE NUMERIC(15,4),
POST_BAL_VALUE NUMERIC(15,4),
DEP_ORIG_VALUE NUMERIC(15,4),
DEP_BAL_VALUE NUMERIC(15,4),
OPEN_CHARGES INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE ACCOUNT_JOIN_IN_ONE_BY_STRING(IN_TARGET_ID_ACCOUNT INTEGER,
IN_SOURCE_STRING VARCHAR(1000))
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE ACCOUNT_SELECTION_UNITE$DOC(ID_DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
PROFILE_ACCOUNTS_ONLY SMALLINT = 0)
 RETURNS(SKIP_DOC_SELECTED INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE DEPOSIT_REFUND$DOC(ID_DEPOSIT INTEGER,
REFUND_AMOUNT NUMERIC(15,4),
REFUND_CURRENCY VARCHAR(3),
ID_PAY_DOC_TYPE INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_REFUND_PAYMENT INTEGER,
ID_STORNO_DOC INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE DOCUMENT_ATTACH_AVAIL_PAYS$INT(ID_DOC_HEAD INTEGER,
ID_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE EAI_EXT_GUEST_BALANCE(ID_GUEST INTEGER)
 RETURNS(ID_ACCOUNT_POST INTEGER,
IS_DEPOSIT_POST SMALLINT,
ID_ACCOUNT INTEGER,
ACCOUNT_NAME VARCHAR(50),
ID_SERVICE INTEGER,
SERVICE_NAME VARCHAR(30),
SERVICE_NAME2 VARCHAR(30),
POST_VALUE NUMERIC(15,2),
CURR_POST VARCHAR(3),
RATE_POST NUMERIC(15,4),
DATE_POST DATE,
ROOM_NAME VARCHAR(10),
POST_TEXT VARCHAR(50),
IS_GUEST_POST SMALLINT)
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP VIEW ACCOUNTS_OPEN;

DROP VIEW DEPOSIT_AVAILABLE;

DROP VIEW DEPOSIT_SECURE;

DROP VIEW DEPOSITS;

DROP VIEW DOCUMENT_RELEASE_S;

DROP VIEW DOCUMENT_S;

DROP VIEW ENA_DOC_DEPOSIT_CONSUMPTION;

DROP VIEW ENA_DOC_PAYMENT;



DROP TABLE SUBSCRIBTION$NH;

/* Empty ALLOTMENT_TMP_GET$INT for drop TMP_ALLOTMENT_DETAIL(DIFF_NO) */
SET TERM ^ ;

ALTER PROCEDURE ALLOTMENT_TMP_GET$INT(ID_ALLOTMENT_SESSION INTEGER,
ALLOTMENT_PART VARCHAR(20) = 'ROOMS')
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE ALLOTMENT_CREATE_DETAIL$INT(ID_ALLOTMENT_SESSION INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
INIT_FROM_DATE VARCHAR(50) = 'start',
ALLOTMENT_PART VARCHAR(20) = 'ROOMS')
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE ALLOTMENT_TMP_SET$INT(ID_ALLOTMENT_SESSION INTEGER,
ID_ALLOTMENT INTEGER,
ID_ROOM_TYPE INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
CNT_ROOMS INTEGER,
ACTIVE_FRAME_BEGIN INTEGER = 0,
ACTIVE_FRAME_END INTEGER = 0,
IS_ADDITION INTEGER = 0)
 AS
 BEGIN EXIT; END
^

SET TERM ; ^

DROP TABLE TMP_ALLOTMENT_DETAIL;


SET TERM ^ ;

ALTER PROCEDURE ROOM_SMART_FILTER$INT(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(20),
RESTRICT_CLEANING INTEGER,
SUPPRESS_PRIVATE SMALLINT = 1)
 RETURNS(ROOM_NAME VARCHAR(50),
BEDS INTEGER,
EXTRA_BEDS INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
IS_CLEAN INTEGER,
FLOOR INTEGER,
CLEAN_TEXT VARCHAR(20),
FEATURES BLOB,
SYS_DATE DATE)
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP VIEW ROOM_EXIST_PERIOD;

/* Create view: ROOM_EXIST_PERIOD (ViwData.CreateDependDef) */
CREATE VIEW ROOM_EXIST_PERIOD(
ID_ROOM,
FROM_DATE,
TO_DATE)
 AS 
select P.ID_ROOM,
         min(P.FROM_DATE),
         max(P.TO_DATE)
  from   ROOM_PERIOD$PMS P
  group by 1
;

/* Create Views... */
/* Create view: DEPOSITS (ViwData.CreateDependDef) */
CREATE VIEW DEPOSITS(
ID_DEPOSIT,
DESCRIPTION,
ID_PROFILE,
ID_ACCOUNT,
ID_RESERV_DETAIL,
ID_PAYMENT_HEAD,
ID_PAYMENT_TYPE,
ID_DOC_TYPE,
DOC_TYPE_NAME,
PAYMENT_NUM,
PAYMENT_DATE,
PAY_CURRENCY,
PAY_RATE,
INIT_PAY_AMOUNT,
RECEIVED_AMOUNT,
DEDUCTED_AMOUNT,
IS_ANUL,
ID_DOC_HEAD,
USER_CREATED,
DATETIME_CREATED,
DOC_SELECTED,
UUID)
 AS 
select D.ID_DEPOSIT,
       D.DESCRIPTION,
       D.ID_PROFILE,
       D.ID_ACCOUNT,
       D.ID_RESERV_DETAIL,
       P.ID_PAYMENT_HEAD,
       P.ID_PAYMENT_TYPE,
       P.ID_DOC_TYPE,
       P.DOC_TYPE_NAME,
       P.PAYMENT_NUM,
       P.PAYMENT_DATE,
       P.PAY_CURRENCY,
       P.PAY_RATE,
       P.PAY_VALUE_A,
       iif(p.IS_STORNED + p.IS_ANUL > 0, 0,
           (select cast(round_f(sum(A.PAY_AMOUNT), c.ROUND_TO) as numeric(15,4))
            from   ACCOUNT_PAYMENTS A
            where  A.ID_DEPOSIT = d.ID_DEPOSIT)) as RECEIVED_AMOUNT,
       coalesce((select cast(round_f(sum(dcp.PAY_AMOUNT * drd.VALUE_CORR_INDEX), c.ROUND_TO) as numeric(15,4))
                 from   ACCOUNT_PAYMENTS AP
                        join DOC_PAY_USAGE DCP on dcp.ID_ACCOUNT_PAYMENT = ap.ID_ACCOUNT_PAYMENT
                        join DOC_RELEASE_DATE DRD on drd.ID_DOC_HEAD = dcp.ID_DOC_HEAD
                        join DOC_HEAD$INT DH on DH.ID_DOC_HEAD = DCP.ID_DOC_HEAD
                 where  ap.ID_DEPOSIT = d.ID_DEPOSIT
                        and dh.FOR_DEPOSIT = 0), 0) as USED_AMOUNT,
       P.IS_ANUL,
       P.ID_DOC_HEAD,
       P.USER_CREATED,
       P.DATETIME_CREATED,
       D.DOC_SELECTED,
       D.UUID
from   DEPOSIT D
       join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
       join CURRS C on C.CURR = p.PAY_CURRENCY
;

SET TERM ^ ;

CREATE TRIGGER DEPOSITS_BIUD0 FOR DEPOSITS
ACTIVE BEFORE INSERT OR UPDATE OR DELETE POSITION 0 
 AS Declare variable I integer;
BEGIN I = 0; END
^

/* Alter view (drop/create): DEPOSITS for view: DEPOSIT_AVAILABLE */
/* Alter view (drop): DEPOSITS for view: DEPOSIT_AVAILABLE */
SET TERM ; ^

DROP TRIGGER DEPOSITS_BIUD0;

DROP VIEW DEPOSITS;

/* Alter view (create): DEPOSITS for view: DEPOSIT_AVAILABLE */
/* Create view: DEPOSITS (ViwData.CreateDependDef) */
CREATE VIEW DEPOSITS(
ID_DEPOSIT,
DESCRIPTION,
ID_PROFILE,
ID_ACCOUNT,
ID_RESERV_DETAIL,
ID_PAYMENT_HEAD,
ID_PAYMENT_TYPE,
ID_DOC_TYPE,
DOC_TYPE_NAME,
PAYMENT_NUM,
PAYMENT_DATE,
PAY_CURRENCY,
PAY_RATE,
INIT_PAY_AMOUNT,
RECEIVED_AMOUNT,
DEDUCTED_AMOUNT,
IS_ANUL,
ID_DOC_HEAD,
USER_CREATED,
DATETIME_CREATED,
DOC_SELECTED,
UUID)
 AS 
select D.ID_DEPOSIT,
       D.DESCRIPTION,
       D.ID_PROFILE,
       D.ID_ACCOUNT,
       D.ID_RESERV_DETAIL,
       P.ID_PAYMENT_HEAD,
       P.ID_PAYMENT_TYPE,
       P.ID_DOC_TYPE,
       P.DOC_TYPE_NAME,
       P.PAYMENT_NUM,
       P.PAYMENT_DATE,
       P.PAY_CURRENCY,
       P.PAY_RATE,
       P.PAY_VALUE_A,
       iif(p.IS_STORNED + p.IS_ANUL > 0, 0,
           (select cast(round_f(sum(A.PAY_AMOUNT), c.ROUND_TO) as numeric(15,4))
            from   ACCOUNT_PAYMENTS A
            where  A.ID_DEPOSIT = d.ID_DEPOSIT)) as RECEIVED_AMOUNT,
       coalesce((select cast(round_f(sum(dcp.PAY_AMOUNT * drd.VALUE_CORR_INDEX), c.ROUND_TO) as numeric(15,4))
                 from   ACCOUNT_PAYMENTS AP
                        join DOC_PAY_USAGE DCP on dcp.ID_ACCOUNT_PAYMENT = ap.ID_ACCOUNT_PAYMENT
                        join DOC_RELEASE_DATE DRD on drd.ID_DOC_HEAD = dcp.ID_DOC_HEAD
                        join DOC_HEAD$INT DH on DH.ID_DOC_HEAD = DCP.ID_DOC_HEAD
                 where  ap.ID_DEPOSIT = d.ID_DEPOSIT
                        and dh.FOR_DEPOSIT = 0), 0) as USED_AMOUNT,
       P.IS_ANUL,
       P.ID_DOC_HEAD,
       P.USER_CREATED,
       P.DATETIME_CREATED,
       D.DOC_SELECTED,
       D.UUID
from   DEPOSIT D
       join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
       join CURRS C on C.CURR = p.PAY_CURRENCY
;

SET TERM ^ ;

CREATE TRIGGER DEPOSITS_BIUD0 FOR DEPOSITS
ACTIVE BEFORE INSERT OR UPDATE OR DELETE POSITION 0 
 AS Declare variable I integer;
BEGIN I = 0; END
^

/* Create view: DEPOSIT_AVAILABLE (ViwData.CreateDependDef) */
SET TERM ; ^

CREATE VIEW DEPOSIT_AVAILABLE(
ID_DEPOSIT,
DESCRIPTION,
ID_PROFILE,
ID_ACCOUNT,
ID_RESERV_DETAIL,
ID_PAYMENT_HEAD,
ID_PAYMENT_TYPE,
ID_DOC_TYPE,
DOC_TYPE_NAME,
PAYMENT_NUM,
PAYMENT_DATE,
PAY_CURRENCY,
PAY_RATE,
AVAIL_VALUE,
ID_DOC_HEAD,
USER_CREATED,
DATETIME_CREATED,
DOC_SELECTED)
 AS 
select D.ID_DEPOSIT,
       D.DESCRIPTION,
       D.ID_PROFILE,
       D.ID_ACCOUNT,
       D.ID_RESERV_DETAIL,
       D.ID_PAYMENT_HEAD,
       D.ID_PAYMENT_TYPE,
       D.ID_DOC_TYPE,
       D.DOC_TYPE_NAME,
       D.PAYMENT_NUM,
       D.PAYMENT_DATE,
       D.PAY_CURRENCY,
       D.PAY_RATE,
       D.RECEIVED_AMOUNT - d.DEDUCTED_AMOUNT,
       D.ID_DOC_HEAD,
       D.USER_CREATED,
       D.DATETIME_CREATED,
       D.DOC_SELECTED
from   DEPOSITS D
where  D.IS_ANUL = 0 
       and D.RECEIVED_AMOUNT - D.DEDUCTED_AMOUNT > 0
;

/* Create view: ACCOUNTS_OPEN (ViwData.CreateDependDef) */
CREATE VIEW ACCOUNTS_OPEN(
ID_ACCOUNT,
ACCOUNT_CURR,
ACCOUNT_NAME,
IS_CREDIT_ACCOUNT,
CREDIT_LIMIT,
ID_TYPE_PAYMENT,
NOTE,
MASK,
IS_BLOCKED,
BLOCK_TEXT,
SECURITY_LEVEL,
IS_ARCHIVE,
IS_BASE,
IS_EXTRA,
IS_ALOWED_POS_INTERFACE,
POS_INTERFACE_NOTE,
ID_RESERV_DETAIL,
ID_PROFILE,
ID_HOTEL)
 AS 
select
    A.ID_ACCOUNT,
    A.ACCOUNT_CURR,
    A.ACCOUNT_NAME,
    A.IS_CREDIT_ACCOUNT,
    A.CREDIT_LIMIT,
    A.ID_TYPE_PAYMENT,
    A.NOTE,
    A.MASK,
    A.IS_BLOCKED,
    A.BLOCK_TEXT,
    A.SECURITY_LEVEL,
    A.IS_ARCHIVE,
    A.IS_BASE,
    A.IS_EXTRA,
    A.IS_ALOWED_POS_INTERFACE,
    A.POS_INTERFACE_NOTE,
    A.ID_RESERV_DETAIL,
    A.ID_PROFILE,
    A.ID_HOTEL
from ACCOUNT_S A
where A.IS_ARCHIVE = 0
      and (exists (select AP.ID_ACCOUNT_POST
                   from   ACCOUNT_POST AP
                   where  AP.AC = '00'
                          and AP.ID_ACCOUNT = A.ID_ACCOUNT)
           or
           exists (select  DA.ID_DEPOSIT
                   from    DEPOSIT_AVAILABLE DA
                   where   DA.ID_ACCOUNT = A.ID_ACCOUNT))
;

/* Create view: DEPOSIT_DEDUCT (ViwData.CreateDependDef) */
CREATE VIEW DEPOSIT_DEDUCT(
ID_DEPOSIT,
DESCRIPTION,
ID_ACCOUNT,
ID_PAYMENT_HEAD,
ID_PAYMENT_TYPE,
ID_DOC_TYPE,
DOC_TYPE_NAME,
PAYMENT_NUM,
PAYMENT_DATE,
PAY_CURRENCY,
USER_CREATED,
DATETIME_CREATED,
ID_DEPOSIT_DOC,
ID_DOC_USED,
USED_PAY_VALUE,
USED_DOC_VALUE,
EQUAL_PAY_DOC_RATE)
 AS 
select D.ID_DEPOSIT,
       D.DESCRIPTION,
       D.ID_ACCOUNT,
       P.ID_PAYMENT_HEAD,
       P.ID_PAYMENT_TYPE,
       P.ID_DOC_TYPE,
       P.DOC_TYPE_NAME,
       P.PAYMENT_NUM,
       P.PAYMENT_DATE,
       P.PAY_CURRENCY,
       P.USER_CREATED,
       P.DATETIME_CREATED,
       P.ID_DOC_HEAD,
       DPM.ID_DOC_HEAD as id_doc_used,
       DPM.PAY_AMOUNT,
       DPM.DOC_AMOUNT,
       DPM.EQUAL_PAY_DOC_RATE
from   DEPOSIT D
       join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
       join ACCOUNT_PAYMENTS AP on AP.ID_DEPOSIT = d.ID_DEPOSIT and ap.ID_PAYMENT_HEAD = p.ID_PAYMENT_HEAD
       join DOC_PAY_USAGE DPM on DPM.ID_ACCOUNT_PAYMENT = ap.ID_ACCOUNT_PAYMENT
       join DOC_HEAD$INT DH on DH.ID_DOC_HEAD = DPM.ID_DOC_HEAD
where  DH.FOR_DEPOSIT = 0
       and DH.IS_ANUL = 0
;

/* Create view: DEPOSIT_FLOW (ViwData.CreateDependDef) */
CREATE VIEW DEPOSIT_FLOW(
OCCUR_DATE,
FLOW_TYPE,
ID_DEPOSIT,
ID_PAYMENT_HEAD,
ID_ACCOUNT,
DESCRIPTION,
ID_RESERV_DETAIL,
ID_PROFILE,
PAY_VALUE,
PAY_CURRENCY,
ID_DOC_HEAD,
ID_HOTEL,
USER_CREATED,
DATETIME_CREATED,
ID_SYSTEM_LOG)
 AS 
/* deposit changes */
select PM.TRANSACTION_DATE,
       cast(case
              when PM.ID_DEPOSIT = P.ID_DEPOSIT and PM.IS_INITIAL_PAYMENT = 1 then 'create'
              when coalesce(ST.ID_ACCOUNT_PAYMENT_SOURCE, DT.ID_ACCOUNT_PAYMENT_DEST) is not null then 'transfer'
              else 'refund'
            end as varchar(10)) as FLOW_TYPE,
       PM.ID_DEPOSIT, PM.ID_PAYMENT_HEAD, PM.ID_ACCOUNT,
       --iif(coalesce(ST.ID_ACCOUNT_PAYMENT_SOURCE, DT.ID_ACCOUNT_PAYMENT_DEST) is not null, PM.DESCRIPTION, P.DESCRIPTION) as DESCRIPTION,
       PM.DESCRIPTION,
       PM.ID_RESERV_DETAIL, PM.ID_PROFILE,
       case
         when PM.ID_DEPOSIT = P.ID_DEPOSIT and PM.IS_INITIAL_PAYMENT = 1 then pm.PAY_AMOUNT
         when coalesce(ST.ID_ACCOUNT_PAYMENT_SOURCE, DT.ID_ACCOUNT_PAYMENT_DEST) is not null then pm.PAY_AMOUNT
         else -pm.PAY_AMOUNT
       end as PAY_AMOUNT,
       P.PAY_CURRENCY, P.ID_DOC_HEAD, PM.ID_HOTEL,
       iif(PM.IS_INITIAL_PAYMENT = 1, P.USER_CREATED, SL.ACTION_USER) as USER_,
       iif(PM.IS_INITIAL_PAYMENT = 1, P.DATETIME_CREATED, SL.ACTION_DATETIME) as TRANSACTION_TIMESTAMP,
       sl.ID_SYSTEM_LOG
from   (select AP.TRANSACTION_DATE, D.ID_DEPOSIT, AP.ID_PAYMENT_HEAD, D.ID_ACCOUNT, D.DESCRIPTION, D.ID_RESERV_DETAIL,
               D.ID_PROFILE, AP.PAY_AMOUNT, A.ID_HOTEL, AP.ID_ACCOUNT_PAYMENT, AP.IS_INITIAL_PAYMENT
        from   ACCOUNT_PAYMENTS AP
               join DEPOSIT D on D.ID_DEPOSIT = AP.ID_DEPOSIT
               join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT) PM
       join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = PM.ID_PAYMENT_HEAD
       left outer join DEPOSIT_REFUND DR on DR.ID_PAYMENT_HEAD = P.ID_PAYMENT_HEAD
       left outer join ACCOUNT_PAYMENT_TRANSFER ST on PM.ID_ACCOUNT_PAYMENT = ST.ID_ACCOUNT_PAYMENT_SOURCE
       left outer join ACCOUNT_PAYMENT_TRANSFER DT on PM.ID_ACCOUNT_PAYMENT = DT.ID_ACCOUNT_PAYMENT_DEST
       left outer join SYSTEM_LOG_EVENT SL on SL.ID_SYSTEM_LOG = iif(pm.IS_INITIAL_PAYMENT = 1, null, coalesce(ST.ID_SYSTEM_LOG, DT.ID_SYSTEM_LOG, P.ID_LOG_EVENT_ANNUL))
union all
/* deposit usage */
select DRD.RELEASE_DATE, cast('use' as varchar(10)), D.ID_DEPOSIT, D.ID_PAYMENT_HEAD, D.ID_ACCOUNT, D.DESCRIPTION,
       D.ID_RESERV_DETAIL, D.ID_PROFILE, DP.PAY_AMOUNT * DRD.VALUE_CORR_INDEX, P.PAY_CURRENCY, DH.ID_DOC_HEAD,
       A.ID_HOTEL, coalesce(SL.ACTION_USER, DH.USER_CREATED), coalesce(SL.ACTION_DATETIME, DH.DATETIME_CREATED),
       sl.ID_SYSTEM_LOG
from   DEPOSIT D
       join ACCOUNT_PAYMENTS AP on AP.ID_DEPOSIT = D.ID_DEPOSIT and AP.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
       join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = AP.ID_PAYMENT_HEAD
       join DOC_PAY_USAGE DP on DP.ID_ACCOUNT_PAYMENT = AP.ID_ACCOUNT_PAYMENT
       join DOC_RELEASE_DATE DRD on DRD.ID_DOC_HEAD = DP.ID_DOC_HEAD and DRD.VALUE_CORR_INDEX <> 0
       join DOC_HEAD$INT DH on DH.ID_DOC_HEAD = DP.ID_DOC_HEAD and DH.FOR_DEPOSIT = 0
       join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
       left outer join DOC_ANNULMENT DA on DA.ID_DOC_HEAD = DH.ID_DOC_HEAD and DA.ANNULMENT_DATE = DRD.RELEASE_DATE
       left outer join SYSTEM_LOG_EVENT SL on SL.ID_SYSTEM_LOG = DA.ID_LOG_EVENT
;

/* Create view: DEPOSIT_SECURE (ViwData.CreateDependDef) */
CREATE VIEW DEPOSIT_SECURE(
ID_DEPOSIT,
DESCRIPTION,
ID_PROFILE,
ID_ACCOUNT,
ID_RESERV_DETAIL,
ID_PAYMENT_HEAD,
ID_PAYMENT_TYPE,
ID_DOC_TYPE,
DOC_TYPE_NAME,
PAYMENT_NUM,
PAYMENT_DATE,
PAY_CURRENCY,
PAY_RATE,
ID_DOC_HEAD,
USER_CREATED,
DATETIME_CREATED,
DOC_SELECTED,
DEP_VALUE,
AVAIL_VALUE)
 AS 
select D.ID_DEPOSIT,
       D.DESCRIPTION,
       D.ID_PROFILE,
       D.ID_ACCOUNT,
       D.ID_RESERV_DETAIL,
       D.ID_PAYMENT_HEAD,
       D.ID_PAYMENT_TYPE,
       D.ID_DOC_TYPE,
       D.DOC_TYPE_NAME,
       D.PAYMENT_NUM,
       D.PAYMENT_DATE,
       D.PAY_CURRENCY,
       D.PAY_RATE,
       D.ID_DOC_HEAD,
       D.USER_CREATED,
       D.DATETIME_CREATED,
       D.DOC_SELECTED,
       D.RECEIVED_AMOUNT,
       d.RECEIVED_AMOUNT - d.DEDUCTED_AMOUNT
from   DEPOSITS D
       join ACCOUNT_S A on A.ID_ACCOUNT = D.ID_ACCOUNT
       join PAY_DOC_TYPE_S PDT on PDT.ID_DOC_TYPE = D.ID_DOC_TYPE
where  d.IS_ANUL = 0
       and d.RECEIVED_AMOUNT > 0
;

/* Create view: DOCUMENT_PAYMENT (ViwData.CreateDependDef) */
CREATE VIEW DOCUMENT_PAYMENT(
ID_HOTEL,
REALIZE_DATE,
ID_PAYMENT_HEAD,
ID_ACCOUNT,
ID_DOC_TYPE,
DOC_TYPE_NAME,
ID_DOC_NUM,
NUM,
PAYMENT_NUM,
ID_PAYMENT_TYPE,
PAYMENT_DATE,
PAY_CURRENCY,
IS_ANUL,
IS_STORNED,
IS_STORNO,
DESCRIPTION,
ID_DOC_HEAD,
ID_DOC_CONTRAGENT,
USER_CREATED,
DATETIME_CREATED,
ID_AR_PAYMENT,
DUE_DATE,
INIT_PAY_VALUE,
INIT_PAY_RATE,
INIT_PAY_DOC_RATE,
REALIZED_VALUE,
EQUAL_PAY_DOC_RATE,
EQUAL_DOC_VALUE,
NAT_VALUE,
FISC_STATUS)
 AS 
select   A.ID_HOTEL,
         DRD.RELEASE_DATE as REALIZE_DATE,
         P.ID_PAYMENT_HEAD,
         P.ID_ACCOUNT,
         P.ID_DOC_TYPE,
         P.DOC_TYPE_NAME,
         P.ID_DOC_NUM,
         P.NUM,
         P.PAYMENT_NUM,
         P.ID_PAYMENT_TYPE,
         P.PAYMENT_DATE,
         P.PAY_CURRENCY,
         iif(p.IS_ANUL = 1 and P.ANNUL_DATE = drd.RELEASE_DATE, 1, 0) as is_anul,
         P.IS_STORNED,
         P.IS_STORNO,
         P.DESCRIPTION,
         DP.ID_DOC_HEAD,
         P.ID_DOC_CONTRAGENT,
         coalesce(sl.ACTION_USER, P.USER_CREATED),
         coalesce(sl.ACTION_DATETIME, P.DATETIME_CREATED),
         P.ID_AR_PAYMENT,
         P.DUE_DATE,
         DP.PAY_AMOUNT as INIT_PAY_VALUE,
         DP.PAY_RATE as INIT_PAY_RATE,
         cast(DP.PAY_RATE / dp.DOC_RATE as double precision) as INIT_PAY_DOC_RATE,
         cast(DP.PAY_AMOUNT * drd.VALUE_CORR_INDEX as numeric(15,4)) as REALIZED_VALUE,
         DP.EQUAL_PAY_DOC_RATE,
         cast(DP.DOC_AMOUNT * drd.VALUE_CORR_INDEX as numeric(15,4)) as EQUAL_DOC_VALUE,
         cast(DP.DOC_AMOUNT * Dh.DOC_RATE * drd.VALUE_CORR_INDEX as numeric(15,4)) as NAT_VALUE,
         Dh.FISC_STATUS
  from   DOC_PAY_USAGE DP
         join DOC_HEAD dh on dh.ID_DOC = dp.ID_DOC_HEAD
         join ACCOUNT A on A.ID_ACCOUNT = dh.ID_ACCOUNT
         join ACCOUNT_PAYMENTS AP on AP.ID_ACCOUNT_PAYMENT = DP.ID_ACCOUNT_PAYMENT
         join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = ap.ID_PAYMENT_HEAD
         join DOC_RELEASE_DATE DRD on DRD.ID_DOC_HEAD = DP.ID_DOC_HEAD
         left outer join DOC_ANNULMENT DA on DA.ID_DOC_HEAD = DH.ID_DOC and da.ANNULMENT_DATE = drd.RELEASE_DATE and da.ANNULMENT_DATE > dh.DOC_DATE
         left outer join SYSTEM_LOG_EVENT SL on SL.ID_SYSTEM_LOG = DA.ID_LOG_EVENT
  where  ((P.ID_DOC_HEAD is null) or (p.ID_DOC_HEAD = dp.ID_DOC_HEAD) or (Dh.FOR_DEPOSIT = 1))
;

/* Create view: DOCUMENT_S (ViwData.CreateDependDef) */
CREATE VIEW DOCUMENT_S(
ID_DOC,
ID_BASE_DOC,
ID_DOC_TYPE,
DOC_SUB_TYPE,
DOC_TYPE_NAME,
ID_DOC_NUM,
NUM,
DOC_NUM,
ID_ACCOUNT,
ID_DOC_CONTRAGENT,
ID_DOC_SUPPLIER,
DOC_DATE,
FOR_DEPOSIT,
IS_STORNED,
IS_ANUL,
IS_STORNO,
FISC_STATUS,
DOC_CURRENCY,
DOC_VALUE,
DOC_VALUE_A,
DOC_RATE,
DOC_ACC_RATE,
TAX_EVENT_DATE,
DESCRIPTION,
USER_CREATED,
DATETIME_CREATED,
SELECTION_ID,
ONE_LINE_TEXT,
DIFF_VAT_REASON,
TAXABLE_VALUE,
IS_EFAKTURA_EXPORTED)
 AS 
select ID_DOC,
       ID_BASE_DOC,
       ID_DOC_TYPE,
       DOC_SUB_TYPE,
       DOC_TYPE_NAME,
       ID_DOC_NUM,
       NUM,
       DOC_NUM,
       ID_ACCOUNT,
       ID_DOC_CONTRAGENT,
       ID_DOC_SUPPLIER,
       DOC_DATE,
       FOR_DEPOSIT,
       IS_STORNED,
       IS_ANUL,
       IS_STORNO,
       FISC_STATUS,
       DOC_CURRENCY,
       DOC_VALUE,
       DOC_VALUE_A,
       DOC_RATE,
       DOC_ACC_RATE,
       TAX_EVENT_DATE,
       DESCRIPTION,
       USER_CREATED,
       DATETIME_CREATED,
       SELECTION_ID,
       ONE_LINE_TEXT,
       DIFF_VAT_REASON,
       TAXABLE_VALUE,
       IS_EFAKTURA_EXPORTED
from   DOC_HEAD D
where  not exists (select AP.ID_PAYMENT_HEAD
                   from   DOC_PAY_USAGE DP
                          join ACCOUNT_PAYMENTS AP on AP.ID_ACCOUNT_PAYMENT = dp.ID_ACCOUNT_PAYMENT
                          join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = ap.ID_PAYMENT_HEAD
                          join PAY_DOC_TYPE_NA DNA on DNA.ID_DOC_TYPE = P.ID_DOC_TYPE
                   where  DP.ID_DOC_HEAD = D.ID_DOC)
;

/* Alter view (drop/create): DOCUMENT_S for view: DOCUMENT_RELEASE_S */
/* Alter view (drop): DOCUMENT_S for view: DOCUMENT_RELEASE_S */
DROP VIEW DOCUMENT_S;

/* Alter view (create): DOCUMENT_S for view: DOCUMENT_RELEASE_S */
/* Create view: DOCUMENT_S (ViwData.CreateDependDef) */
CREATE VIEW DOCUMENT_S(
ID_DOC,
ID_BASE_DOC,
ID_DOC_TYPE,
DOC_SUB_TYPE,
DOC_TYPE_NAME,
ID_DOC_NUM,
NUM,
DOC_NUM,
ID_ACCOUNT,
ID_DOC_CONTRAGENT,
ID_DOC_SUPPLIER,
DOC_DATE,
FOR_DEPOSIT,
IS_STORNED,
IS_ANUL,
IS_STORNO,
FISC_STATUS,
DOC_CURRENCY,
DOC_VALUE,
DOC_VALUE_A,
DOC_RATE,
DOC_ACC_RATE,
TAX_EVENT_DATE,
DESCRIPTION,
USER_CREATED,
DATETIME_CREATED,
SELECTION_ID,
ONE_LINE_TEXT,
DIFF_VAT_REASON,
TAXABLE_VALUE,
IS_EFAKTURA_EXPORTED)
 AS 
select ID_DOC,
       ID_BASE_DOC,
       ID_DOC_TYPE,
       DOC_SUB_TYPE,
       DOC_TYPE_NAME,
       ID_DOC_NUM,
       NUM,
       DOC_NUM,
       ID_ACCOUNT,
       ID_DOC_CONTRAGENT,
       ID_DOC_SUPPLIER,
       DOC_DATE,
       FOR_DEPOSIT,
       IS_STORNED,
       IS_ANUL,
       IS_STORNO,
       FISC_STATUS,
       DOC_CURRENCY,
       DOC_VALUE,
       DOC_VALUE_A,
       DOC_RATE,
       DOC_ACC_RATE,
       TAX_EVENT_DATE,
       DESCRIPTION,
       USER_CREATED,
       DATETIME_CREATED,
       SELECTION_ID,
       ONE_LINE_TEXT,
       DIFF_VAT_REASON,
       TAXABLE_VALUE,
       IS_EFAKTURA_EXPORTED
from   DOC_HEAD D
where  not exists (select AP.ID_PAYMENT_HEAD
                   from   DOC_PAY_USAGE DP
                          join ACCOUNT_PAYMENTS AP on AP.ID_ACCOUNT_PAYMENT = dp.ID_ACCOUNT_PAYMENT
                          join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = ap.ID_PAYMENT_HEAD
                          join PAY_DOC_TYPE_NA DNA on DNA.ID_DOC_TYPE = P.ID_DOC_TYPE
                   where  DP.ID_DOC_HEAD = D.ID_DOC)
;

/* Create view: DOCUMENT_RELEASE_S (ViwData.CreateDependDef) */
CREATE VIEW DOCUMENT_RELEASE_S(
ID_DOC,
ID_DOC_TYPE,
ID_DOC_NUM,
ID_ACCOUNT,
ID_DOC_CONTRAGENT,
ID_DOC_SUPPLIER,
DOC_CURRENCY,
DOC_TYPE_NAME,
NUM,
DOC_NUM,
REAL_DOC_DATE,
RPT_DOC_DATE,
DOC_RATE,
DOC_VALUE,
DOC_VALUE_A,
IS_ANNUL_FLAG,
IS_ANNUL_ON_DATE,
VALUE_CORR_IDX,
IS_STORNO,
IS_STORNED,
DESCRIPTION,
USER_CREATED,
DATETIME_CREATED,
DOC_ACC_RATE,
ID_BASE_DOC,
FOR_DEPOSIT,
TAX_EVENT_DATE,
DIFF_VAT_REASON,
FISC_STATUS,
ANNULMENT_DATE,
ANNUL_PROT_NUM,
ANNUL_PROT_DOC_NUM,
ANNUL_USER,
ANNUL_DATETIME)
 AS 
select DH.ID_DOC,
       DH.ID_DOC_TYPE,
       DH.ID_DOC_NUM,
       DH.ID_ACCOUNT,
       DH.ID_DOC_CONTRAGENT,
       DH.ID_DOC_SUPPLIER,
       DH.DOC_CURRENCY,
       DH.DOC_TYPE_NAME,
       DH.NUM,
       DH.DOC_NUM,
       DH.DOC_DATE as REAL_DOC_DATE,
       RD.RELEASE_DATE as RPT_DOC_DATE,
       DH.DOC_RATE,
       DH.DOC_VALUE,
       DH.DOC_VALUE_A,
       DH.IS_ANUL as IS_ANNUL_FLAG,
       iif(DA.ANNULMENT_DATE is not distinct from DH.DOC_DATE, DH.IS_ANUL, 0) as IS_ANNUL_ON_DATE,
       RD.VALUE_CORR_INDEX as VALUE_CORR_IDX,
       DH.IS_STORNO,
       DH.IS_STORNED,
       DH.DESCRIPTION,
       DH.USER_CREATED,
       DH.DATETIME_CREATED,
       DH.DOC_ACC_RATE,
       DH.ID_BASE_DOC,
       DH.FOR_DEPOSIT,
       DH.TAX_EVENT_DATE,
       DH.DIFF_VAT_REASON,
       DH.FISC_STATUS,
       DA.ANNULMENT_DATE,
       DA.PROT_NUM as ANNUL_PROT_NUM,
       DA.PROT_DOC_NUM as ANNUL_PROT_DOC_NUM,
       SL.ACTION_USER as ANNUL_USER,
       SL.ACTION_DATETIME as ANNUL_DATETIME
from DOCUMENT_S DH
     join DOC_RELEASE_DATE RD on rd.ID_DOC_HEAD = dh.ID_DOC
     left outer join DOC_ANNULMENT DA on DA.ID_DOC_HEAD = DH.ID_DOC
     left outer join SYSTEM_LOG_EVENT SL on SL.ID_SYSTEM_LOG = DA.ID_LOG_EVENT
;

/* Create view: ENA_DOC_DEPOSIT_CONSUMPTION (ViwData.CreateDependDef) */
CREATE VIEW ENA_DOC_DEPOSIT_CONSUMPTION(
ID_DOC_HEAD,
ID_DOC_TYPE,
DOC_TYPE_NAME,
PAYMENT_NUM,
PAYMENT_TYPE,
PAYMENT_DATE,
PAY_CURRENCY,
DESCRIPTION,
PAY_VALUE,
PAY_RATE,
PAY_DOC_RATE,
EQUAL_DOC_VALUE,
NAT_VALUE,
ID_DEPOSIT_PAYMENT,
EXPORT_TAG)
 AS 
select
   DP.ID_DOC_HEAD,
   p.ID_DOC_TYPE,
   P.DOC_TYPE_NAME,
   P.PAYMENT_NUM,
   PT.PAYMENT_TYPE,
   P.PAYMENT_DATE,
   P.PAY_CURRENCY,
   P.DESCRIPTION,
   DP.PAY_AMOUNT as INIT_PAY_VALUE,
   DP.PAY_RATE as INIT_PAY_RATE,
   cast(DP.PAY_RATE / dp.DOC_RATE as double precision) as PAY_DOC_RATE,
   cast(DP.DOC_AMOUNT as numeric(15,4)) as EQUAL_DOC_VALUE,
   cast(DP.DOC_AMOUNT * Dh.DOC_RATE as numeric(15,4)) as NAT_VALUE,
   p.ID_PAYMENT_HEAD,
   iif(p.IS_STORNO = 0, dt.EXPORT_TAG, dtp.STORNO_EXPORT_TAG)
from
   DOC_PAY_USAGE DP
   join DOC_HEAD dh on dh.ID_DOC = dp.ID_DOC_HEAD
   join ACCOUNT A on A.ID_ACCOUNT = dh.ID_ACCOUNT
   join ACCOUNT_PAYMENTS AP on AP.ID_ACCOUNT_PAYMENT = DP.ID_ACCOUNT_PAYMENT
   join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = ap.ID_PAYMENT_HEAD
   join PAYMENT_TYPE pt on pt.ID_PAYMENT_TYPE = p.ID_PAYMENT_TYPE
   join DOC_TYPE dt on dt.ID_DOC_TYPE = p.ID_DOC_TYPE
   join DOC_TYPE_PAY dtp on dtp.ID_DOC_TYPE = dt.ID_DOC_TYPE
where P.ID_DOC_HEAD is null
;

COMMENT ON VIEW ENA_DOC_DEPOSIT_CONSUMPTION IS
' !!!!!!    ID_DOC_TYPE - za mapowe.';

/* Create view: ENA_DOC_PAYMENT (ViwData.CreateDependDef) */
CREATE VIEW ENA_DOC_PAYMENT(
ID_DOC_HEAD,
DOC_TYPE_NAME,
PAYMENT_NUM,
PAYMENT_TYPE,
PAYMENT_DATE,
PAY_CURRENCY,
DESCRIPTION,
DUE_DATE,
PAY_VALUE,
PAY_RATE,
PAY_DOC_RATE,
EQUAL_DOC_VALUE,
NAT_VALUE,
EXPORT_TAG)
 AS 
select
   DP.ID_DOC_HEAD,
   P.DOC_TYPE_NAME,
   P.PAYMENT_NUM,
   PT.PAYMENT_TYPE,
   P.PAYMENT_DATE,
   P.PAY_CURRENCY,
   P.DESCRIPTION,
   P.DUE_DATE,
   DP.PAY_AMOUNT as INIT_PAY_VALUE,
   DP.PAY_RATE as INIT_PAY_RATE,
   cast(DP.PAY_RATE / dp.DOC_RATE as double precision) as PAY_DOC_RATE,
   cast(DP.DOC_AMOUNT as numeric(15,4)) as EQUAL_DOC_VALUE,
   cast(DP.DOC_AMOUNT * Dh.DOC_RATE as numeric(15,4)) as NAT_VALUE,
   iif(p.IS_STORNO = 0, dt.EXPORT_TAG, dtp.STORNO_EXPORT_TAG)
from
   DOC_PAY_USAGE DP
   join DOC_HEAD dh on dh.ID_DOC = dp.ID_DOC_HEAD
   join ACCOUNT A on A.ID_ACCOUNT = dh.ID_ACCOUNT
   join ACCOUNT_PAYMENTS AP on AP.ID_ACCOUNT_PAYMENT = DP.ID_ACCOUNT_PAYMENT
   join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = ap.ID_PAYMENT_HEAD and p.ID_DOC_HEAD = dp.ID_DOC_HEAD
   join PAYMENT_TYPE pt on pt.ID_PAYMENT_TYPE = p.ID_PAYMENT_TYPE
   join DOC_TYPE dt on dt.ID_DOC_TYPE = p.ID_DOC_TYPE
   join DOC_TYPE_PAY dtp on dtp.ID_DOC_TYPE = dt.ID_DOC_TYPE
;

COMMENT ON VIEW ENA_DOC_PAYMENT IS
'   ,     .';


COMMENT ON COLUMN ENA_ACCOUNT.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_ACCOUNT.ID_ACCOUNT IS
'  . .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_NAME IS
'   .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_EXT_CODE IS
'             .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ID IS
'         . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_NAME IS
'    .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ACCOUNT_NO IS
'             .  -    .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_TYPE IS
'       .  : AGENT -  , PERSON -  , HOUSE -    . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_HOUSE_TYPE IS
'      (PROFILE_TYPE = ''HOUSE''),    -.  : hptExternalClient -          ( ,      ); hptExternalRevenue -                (,   ..); hptComplimentary -           ,  ,        . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_HOTEL IS
'       .  ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_ACCOUNT_POST_HISTORY IS
'   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_ACCOUNT IS
'      .  ENA_ACCOUNT.ID_ACCOUNT. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_SERVICE IS
'   .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_SALE_TAXATION IS
'         .       . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.SYSTEM_DATE IS
'    / . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_DATE IS
'        (). .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_CURR IS
'  . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_AMOUNT IS
'    (   )    . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.NAT_NET_VALUE IS
'    ( )   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.NAT_GROSS_VALUE IS
'    ( )   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_TYPE IS
'  . BASE -  ; ADD_INS -  - ,    ; EXTRA -     ,     ; TAX -            ,     .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_GUEST IS
'       .  ENA_GUEST.ID_GUEST.        : 1.    "  "; 2.           ; 3.        ,      . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_GROUP IS
'       .    : ''ROOMS'', ''Food and Beverage'', ''Other Operated Departments'', ''Rentals and Other Income''. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_ACCOUNT IS
' -      .    . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_SUB_ACCOUNT IS
' --      . ,     -. .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.ID_HOTEL IS
'   ,    . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.ID_DOC_HEAD IS
'        .  ENA_DOC_HEAD_ADVANCE.ID_DOC. .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.SYSTEM_DATE IS
'      . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAYMENT_DATE IS
'     . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.SRC_ID_ACCOUNT IS
'   . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.DEST_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAY_AMOUNT IS
' .        . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAY_CURRENCY IS
' . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.USER_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.DATETIME_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_HOTEL IS
'   ,    . .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_DEPOSIT_PAYMENT IS
'  .         . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_DATE IS
'        .            . .';

COMMENT ON COLUMN ENA_DEPOSIT.SYSTEM_DATE IS
'   .         PAYMENT_DATE.        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_NUM IS
'           .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_DIRECTION IS
'0 -   , 1 -   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_TYPE_NAME IS
'       .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_ACCOUNT IS
'        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_AMOUNT IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DEPOSIT.IS_ANUL IS
'   . 0 - , 1 - .           /    .     IS_ANUL = 0,    1.           ID_DEPOSIT.  .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_CREATED IS
'     .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_CREATED IS
'       . .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_ANNUL IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_ANNUL IS
'     .  .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.ID_HOTEL IS
'       .  .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.ID_DEPOSIT_PAYMENT IS
'   ,   .  ENA_DEPOSIT.ID_DEPOSIT_PAYMENT. .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SYSTEM_DATE IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAYMENT_DATE IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SRC_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DEST_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAY_AMOUNT IS
' .        . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAY_CURRENCY IS
' . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.USER_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DATETIME_CREATED IS
'     . .';

COMMENT ON VIEW ENA_DOC_DEPOSIT_CONSUMPTION IS
' !!!!!!    ID_DOC_TYPE - za mapowe.';


COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.DOC_TYPE_NAME IS
'       . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_NUM IS
'         .  .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_DATE IS
'      .          . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_VALUE IS
'         . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_DOC_RATE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.EQUAL_DOC_VALUE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.NAT_VALUE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.ID_DEPOSIT_PAYMENT IS
'      (  ENA_DEPOSIT.ID_DEPOSIT_PAYMENT ). .';

COMMENT ON VIEW ENA_DOC_HEAD_ADVANCE IS
'!      ';


COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC IS
'  .             .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_ADVANCE.ID_DOC.  .     - , ..       ,      - .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SUB_TYPE IS
'   . ,  : 0 - / , 1 -  ,  , 2 -  ,  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_NAME IS
'    . ,       .              .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_DESCRIPTION IS
'   .         .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_NUM IS
'   ,        .      . ,     ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DATE IS
'        . .    SYSTEM_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.IS_ANUL IS
'        . . 0 - , 1 - .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TOTAL_VALUE IS
' (, )       . .      .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ONE_LINE_TEXT IS
' ,         .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURR_RATE IS
'   ()    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_POST_ADDRESS IS
'    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_ZIP_CODE IS
'     ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_MOL IS
'    ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_RECIPIENT_NAME IS
'     ()';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BANK_NAME IS
'  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BIC IS
'BIC  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IBAN IS
'IBAN  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_EMAIL IS
'email  .        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SUPPLIER_SEND_NAME IS
'     .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ACCOUNT_ID IS
'        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC IS
'  .             .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_SERVICE.ID_DOC.     - , ..       ,      - .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC_TYPE IS
'    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SUB_TYPE IS
'   .  : 0 - / , 1 -  ,  , 2 -  ,  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_NAME IS
'    .              .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_DESCRIPTION IS
'   .         .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_NUM IS
'   ,        .      .  -       ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DATE IS
'        .    SYSTEM_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.IS_ANUL IS
'        . 0 - , 1 - .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_CURRENCY IS
'  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TOTAL_VALUE IS
' (, )       .      .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ONE_LINE_TEXT IS
' ,         .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURR_RATE IS
'   ()    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_DATE IS
'   ,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_NUM IS
'  -,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_POST_ADDRESS IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_ZIP_CODE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_MOL IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_RECIPIENT_NAME IS
'     (). .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BANK_NAME IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BIC IS
'BIC  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IBAN IS
'IBAN  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_EMAIL IS
'email  .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SUPPLIER_SEND_NAME IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ACCOUNT_ID IS
'        .    ENA_ACCOUNT.ID_ACCOUNT. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_SERVICE IS
'     .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.DATE_POST IS
'    . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_SERVICE IS
'      .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_SERVICE IS
'   .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.IS_CORRECT IS
'            .      1,        . 0 -   ; 1 -      0. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_GUEST IS
'   ,        .    null,       ''  ''     .    ENA_GUEST.ID_GUEST. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.DATE_POST IS
'        .    ,    . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ROOM_NAME IS
'       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ACCOUNT_PRICE IS
'         /.             /. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_SERVICE IS
'    (, , , ,  ).  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_SALE_TAXATION IS
'         .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON VIEW ENA_DOC_PAYMENT IS
'   ,     .';


COMMENT ON COLUMN ENA_DOC_PAYMENT.ID_DOC_HEAD IS
'  ( ENA_DOC_HEAD.ID_DOC)      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DOC_TYPE_NAME IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_NUM IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_DATE IS
'     .        ,                 . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_CURRENCY IS
'  .        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DUE_DATE IS
'       .          ,      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_VALUE IS
'           . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_DOC_RATE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.EQUAL_DOC_VALUE IS
'      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.NAT_VALUE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.ID_DOC_HEAD IS
'         . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNT_VALUE IS
'      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNTABLE_VALUE IS
'  .       . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.IS_PERCENT_DISCOUNT IS
'  .         . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.FIXED_DISCOUNT_CURRENCY IS
'  .       -     . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNT_PERCENT_OR_AMOUNT IS
'  .       . .';

COMMENT ON COLUMN ENA_DOC_TAX.ID_DOC_HEAD IS
'         ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_TAX.ID_SALE_TAX IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.NONTAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_VALUE IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_NAME IS
'  .  -        .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_PERCENT IS
'   ().  .';

COMMENT ON COLUMN ENA_DOC_TAX.FISCAL_CODE IS
' .        .  -      .';

COMMENT ON COLUMN ENA_DOC_TAX.ACCOUNT_NAME IS
' .              . .';

COMMENT ON COLUMN ENA_GUEST.ID_GUEST IS
'   ( )   . .';

COMMENT ON COLUMN ENA_GUEST.ID_RESERV_DETAIL IS
'        ( ENA_RESERV_DETAIL.ID_RESERV_DETAIL). .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME2 IS
'      . .';

COMMENT ON COLUMN ENA_GUEST.IS_CHILD IS
'   . 0 - ; 1 - . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE IS
'    . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_TEXT IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.RATING_AGE IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.COUNTRY_CODE IS
'    .        ISO. .';

COMMENT ON COLUMN ENA_GUEST.MASK IS
'  .         . .';

COMMENT ON COLUMN ENA_HOTEL.ID_HOTEL IS
'  . .';

COMMENT ON COLUMN ENA_HOTEL.HOTEL_NAME IS
'  . .';

COMMENT ON COLUMN ENA_HOTEL.CODE IS
'   . .';

COMMENT ON COLUMN ENA_HOTEL.SYSTEM_DATE IS
'     .                  ENA.                . .';

COMMENT ON COLUMN ENA_HOTEL.IS_USE IS
'    (  ). 0 -   , 1 -  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_RESERV_DETAIL IS
'   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NUMBER IS
'  .    (   ). .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_GUEST_MAIN IS
'      .      .  -     .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME IS
'    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME2 IS
'       . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.FROM_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.TO_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NIGHTS IS
'. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ADULT_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHILD_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_EATING_OBJECT IS
'          . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHECK_STATUS IS
'  . -3 =  ; -2 =   ; -1 =  ; 0 =  ; 1 =  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.IS_ANUL IS
'   . 0 - , 1 - .  -       0  1.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ID IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_NAME IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_TYPE IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ACCOUNT_NO IS
'             .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SEGMENT_CODE IS
'   ''segment''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SOURCE_CODE IS
'   ''source''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_CHANNEL_CODE IS
'   ''channel''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_HEAR_CODE IS
'   ''hear reason''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_COME_CODE IS
'   ''come reason''.   . .';

COMMENT ON COLUMN ENA_SERVICES.ID_HOTEL IS
'       . .';

COMMENT ON COLUMN ENA_SERVICES.ID_SERVICE IS
'   . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_NAME IS
'  . .';

COMMENT ON COLUMN ENA_SERVICES.GROUP_NAME IS
'    .            a       . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_TYPE IS
'  .  : ''BASE'',''EXTRA'',''COMMISSION'',''MEAL''. ''BASE'' -    ,     ,''EXTRA'' -  , ''MEAL'' - , ''COMMISSION'' - ,        (  ). .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_GROUP IS
'       .  : ''ROOMS'', ''Food and Beverage'', ''Other Operated Departments'', ''Rentals and Other Income''. .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_ACCOUNT IS
' -      . .';

COMMENT ON COLUMN ENA_SERVICES.ACCOUNT_NAME IS
'      (. ),      .          . .';

COMMENT ON COLUMN ENA_SERVICES.EXT_CODE IS
'         . .';

COMMENT ON COLUMN ENA_SERVICES.IS_BREAKFAST IS
'   . 0 - , 1 - .    1,   SERVICE_TYPE e ''BASE''  ''MEAL''.  -          .';

COMMENT ON COLUMN ENA_SERVICES.ID_ROOM_TYPE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ). .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  -             .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM_EXT_CODE IS
'    ( )     ,      .  -        .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_STAY_CODE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  : ''ALONE'' -      , ''BED'' -            , ''EXTRA_BED'' -      . .';

/* Create index... */
CREATE INDEX ALLOTMENT_DETAIL$TMP_IDX1 ON ALLOTMENT_DETAIL$TMP(FOR_DATE);


/* Create Primary Key... */
ALTER TABLE DOC_PAY_USAGE ADD CONSTRAINT PK_DOC_PAY_USAGE PRIMARY KEY (ID_DOC_HEAD, ID_ACCOUNT_PAYMENT);

ALTER TABLE INFOMATIC_ACCOUNT ADD CONSTRAINT PK_INFOMATIC_ACCOUNT PRIMARY KEY (ID);

ALTER TABLE INFOMATIC_CHANNEL ADD CONSTRAINT PK_INFOMATIC_CHANNEL PRIMARY KEY (ID);

ALTER TABLE INFOMATIC_QUEUE ADD CONSTRAINT PK_INFOMATIC_QUEUE PRIMARY KEY (ID);

ALTER TABLE RESERV_ROOMS$EXC ADD CONSTRAINT PK_RESERV_ROOMS$EXC PRIMARY KEY (ID_RESERV_DETAIL, FOR_DATE);

/* Create Unique... */
ALTER TABLE INFOMATIC_ACCOUNT ADD CONSTRAINT UNQ_INFOMATIC_ACCOUNT UNIQUE (ACCOUNT_NAME);

ALTER TABLE INFOMATIC_CHANNEL ADD CONSTRAINT UNQ_INFOMATIC_CHANNEL UNIQUE (INFOMATIC_ACCOUNT_ID, CHANNEL_NAME);

ALTER TABLE INFOMATIC_QUEUE ADD CONSTRAINT UNQ_INFOMATIC_QUEUE UNIQUE (INFOMATIC_CHANNEL_ID, SUBJECT);

/* Create Foreign Key... */
RECONNECT;

ALTER TABLE DOC_PAY_USAGE ADD CONSTRAINT FK_DPU_ACC_PAYMENT FOREIGN KEY (ID_ACCOUNT_PAYMENT) REFERENCES ACCOUNT_PAYMENTS (ID_ACCOUNT_PAYMENT) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE DOC_PAY_USAGE ADD CONSTRAINT FK_DPU_DOC_HEAD FOREIGN KEY (ID_DOC_HEAD) REFERENCES DOC_COMPLETION (ID_DOC_HEAD) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE INFOMATIC_CHANNEL ADD CONSTRAINT FK_INFOMATIC_CHANNEL_ACCOUNT FOREIGN KEY (INFOMATIC_ACCOUNT_ID) REFERENCES INFOMATIC_ACCOUNT (ID) ON DELETE CASCADE;

ALTER TABLE INFOMATIC_QUEUE ADD CONSTRAINT FK_INFOMATIC_QUEUE_CHANNEL FOREIGN KEY (INFOMATIC_CHANNEL_ID) REFERENCES INFOMATIC_CHANNEL (ID) ON DELETE CASCADE;

ALTER TABLE RESERV_ROOMS$EXC ADD CONSTRAINT FK_RES_ROOMS$EXC_RESERV FOREIGN KEY (ID_RESERV_DETAIL) REFERENCES RESERV_DETAIL (ID_RESERV_DETAIL) ON UPDATE CASCADE ON DELETE CASCADE;

/*  Empty MONITOR_ROOM_GANTT$HM for RES_GET_INFO$RSV(param list change)  */
SET TERM ^ ;

ALTER PROCEDURE MONITOR_ROOM_GANTT$HM(FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ID_ROOM INTEGER,
GFROM_DATE DATE,
IS_MOVED_FROM INTEGER,
GTO_DATE DATE,
IS_MOVED_TO INTEGER,
BUSY_GRP INTEGER,
OCCUPANT_ID INTEGER,
IN_SHARE SMALLINT,
ID_GROUP INTEGER,
ATTENTION_STATUS SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/*  Empty MONITOR_ROOM_GANTT_OCCUPANT$HM for RES_GET_INFO$RSV(param list change)  */
ALTER PROCEDURE MONITOR_ROOM_GANTT_OCCUPANT$HM(FROM_DATE DATE,
TO_DATE DATE,
REQUEST_OCCUPANT_ID INTEGER)
 RETURNS(ID_ROOM INTEGER,
GFROM_DATE DATE,
IS_MOVED_FROM INTEGER,
GTO_DATE DATE,
IS_MOVED_TO INTEGER,
BUSY_GRP INTEGER,
OCCUPANT_ID INTEGER,
IN_SHARE SMALLINT,
ID_GROUP INTEGER,
ATTENTION_STATUS SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/*  Empty OCCUPANT_GET_INFO for RES_GET_INFO$RSV(param list change)  */
ALTER PROCEDURE OCCUPANT_GET_INFO(ID_OCCUPANT INTEGER,
IN_BUSY_GRP INTEGER = null)
 RETURNS(BUSY_GRP INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
INFO VARCHAR(1024))
 AS
 BEGIN SUSPEND; END
^

/*  Empty ROOM_SMART_LIST_OOS$INT for RES_GET_INFO$RSV(param list change)  */
ALTER PROCEDURE ROOM_SMART_LIST_OOS$INT(FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ROOM_NAME VARCHAR(50),
DESCRIPTION VARCHAR(100),
PERIOD VARCHAR(100),
FREE_BASE INTEGER,
FREE_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
IS_CLEAN INTEGER,
FEATURES BLOB)
 AS
 BEGIN SUSPEND; END
^

/*  Empty ROOM_SMART_LIST_SHARE$INT for RES_GET_INFO$RSV(param list change)  */
ALTER PROCEDURE ROOM_SMART_LIST_SHARE$INT(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(50),
SUPPRESS_PRIVATE SMALLINT = 1)
 RETURNS(ROOM_NAME VARCHAR(50),
DESCRIPTION VARCHAR(255),
PERIOD VARCHAR(255),
FREE_BASE INTEGER,
FREE_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
FEATURES BLOB)
 AS
 BEGIN SUSPEND; END
^

/*  Empty EXPORT_BOOKING$EXC for RES_LOAD(param list change)  */
ALTER PROCEDURE EXPORT_BOOKING$EXC(BOOKING_ID INTEGER)
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20),
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_ID INTEGER,
IS_GUEST_ARRANGER INTEGER,
POSTING_ROUTING VARCHAR(20),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IS_DIFFERENT_TARIFF SMALLINT,
IS_DIFFERENT_BOARD SMALLINT,
IS_CUSTOM_PRICE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
EXC_LOCAL_VERSION BIGINT,
EXC_REMOTE_VERSION BIGINT,
CREATE_DATETIME TIMESTAMP,
EATING_OBJECT VARCHAR(50))
 AS
 BEGIN SUSPEND; END
^

/*  Empty AGENT_CONTINGENT_OCCUPANCY for RES_OCCUPANCY_ROOM$INT(param list change)  */
ALTER PROCEDURE AGENT_CONTINGENT_OCCUPANCY(FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
ID_PROFILE /* TYPE OF ID */ INTEGER,
ID_HOTEL /* TYPE OF ID */ INTEGER)
 RETURNS(ID_ROOM_TYPE /* TYPE OF ID */ INTEGER,
FOR_DATE /* TYPE OF TDATE */ DATE,
CONT_ROOMS /* TYPE OF TCOUNT */ INTEGER,
CONT_BASE_BEDS /* TYPE OF TCOUNT */ INTEGER,
CONT_EXTRA_BEDS /* TYPE OF TCOUNT */ INTEGER,
OCC_ROOMS /* TYPE OF TCOUNT */ INTEGER,
OCC_BASE_BEDS_ADULTS /* TYPE OF TCOUNT */ INTEGER,
OCC_BASE_BEDS_CHILDREN /* TYPE OF TCOUNT */ INTEGER,
OCC_EXTRA_BEDS_ADULTS /* TYPE OF TCOUNT */ INTEGER,
OCC_EXTRA_BEDS_CHILDREN /* TYPE OF TCOUNT */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty GUEST_GET_STAY_CONDITIONS$INT for RES_OCCUPANCY_ROOM$INT(param list change)  */
ALTER PROCEDURE GUEST_GET_STAY_CONDITIONS$INT(ID_GUEST INTEGER,
FOR_DATE DATE)
 RETURNS(ID_TYPE_STAY INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
IS_MANUAL_TYPE_STAY SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/*  Empty IMPORT_BOOKING_FINALIZE$EXC for RES_OCCUPANCY_ROOM$INT(param list change)  */
ALTER PROCEDURE IMPORT_BOOKING_FINALIZE$EXC(BOOKING_ID INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1,
STATUS VARCHAR(50) = null,
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20) = null,
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20) = null)
 RETURNS(RECORD_TIMESTAMP TIMESTAMP,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/*  Empty OCCUPANCY_RESERV$INT for RES_OCCUPANCY_ROOM$INT(param list change)  */
ALTER PROCEDURE OCCUPANCY_RESERV$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty RES_GUEST_DYNAMICPARAMS_LOAD for RES_OCCUPANCY_ROOM$INT(param list change)  */
ALTER PROCEDURE RES_GUEST_DYNAMICPARAMS_LOAD(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TAR_ROOM_TYPE INTEGER,
ID_BOARD INTEGER,
ID_TYPE_STAY INTEGER,
ID_TARIFF INTEGER,
ID_AUTO_ROOM_TYPE INTEGER,
ID_AUTO_BOARD INTEGER,
ID_AUTO_TYPE_STAY INTEGER,
ID_AUTO_TARIFF INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty RES_SAVE_ROOM$INT for RES_OCCUPANCY_ROOM$INT(param list change)  */
ALTER PROCEDURE RES_SAVE_ROOM$INT(RD_DBKEY CHAR(8),
ID_ROOM INTEGER,
ID_RES_ROOM_TYPE INTEGER,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE INTEGER = null)
 AS
 BEGIN EXIT; END
^

/* Alter empty procedure RES_GET_INFO$RSV with new param-list */
ALTER PROCEDURE RES_GET_INFO$RSV(ID_RESERV_DETAIL INTEGER,
RETURN_BALANCE SMALLINT = 1,
RETURN_SHARE SMALLINT = 1,
RETURN_GEUSTDATA SMALLINT = 1)
 RETURNS(NUMBER VARCHAR(62),
AGENT_PROFILE_NAME VARCHAR(100),
ARRIVALS VARCHAR(255),
DEPARTURES VARCHAR(255),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
ID_ROOM INTEGER,
ROOM VARCHAR(60),
ID_ROOM_TYPE INTEGER,
ROOM_FEATURES BLOB,
GUESTS VARCHAR(255),
GUESTS_CNT INTEGER,
PERSON_PROFILE_NAME VARCHAR(150),
RATES VARCHAR(255),
BOARDS VARCHAR(255),
PACKETS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY VARCHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
BALANCE VARCHAR(255),
OPEN_CHARGES INTEGER,
CHECK_STATUS INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
NOTE VARCHAR(2000),
NOTE_GRP VARCHAR(255),
VOUCHER_RENDER VARCHAR(512),
ACC_ROUTING VARCHAR(255),
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
BUSY_GRP INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
GUEST_TYPE_COLOR INTEGER,
IS_CLEAN INTEGER,
ROOM_PRIVATE_STATUS TLOGICAL)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure RES_LOAD with new param-list */
ALTER PROCEDURE RES_LOAD(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_AGENT_PROFILE INTEGER,
AGENT_PROFILE_NAME VARCHAR(100),
ID_PERSON_PROFILE INTEGER,
PERSON_PROFILE_NAME VARCHAR(100),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_RES_ROOM_TYPE INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
BOARD_NAMES VARCHAR(255),
TARIFF_NAMES VARCHAR(255),
PACKET_NAMES VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100),
VOUCHER_RENDER VARCHAR(512),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
TRANSFER_RENDER VARCHAR(255),
CODE_FIRST_FOOD_RENDER VARCHAR(255),
IS_LATE_DEPARTURE INTEGER,
CODE_FIRST_FOOD VARCHAR(20),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
I_SPECIAL_TREATMENT VARCHAR(255),
COMMING_KIND SMALLINT,
IS_VIP SMALLINT,
HAS_GUEST_LIST SMALLINT,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
AGENT_ACCOUNT_NAME VARCHAR(100),
IS_DIFFERENT_VOUCHER INTEGER,
IS_DIFFERENT_OTHER INTEGER,
IS_DIFFERENT_BOARD INTEGER,
IS_DIFFERENT_TARIFF INTEGER,
IS_CUSTOM_PRICE INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
ID_RATE INTEGER,
ROOM_FEATURES BLOB,
ID_GROUP INTEGER,
NUMBER VARCHAR(62),
CHECK_STATUS INTEGER,
BALANCE VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER,
RECIEVED_DEPOSITS VARCHAR(100),
ROOM_HISTORY VARCHAR(200),
TAR_ROOM_TYPE VARCHAR(100),
ID_HK_PLAN INTEGER,
COUNTRIES VARCHAR(812),
IS_RESGRP INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
IS_ANUL INTEGER,
NOTE VARCHAR(2000),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
GROUP_NAME VARCHAR(50),
ID_HOTEL INTEGER,
NOTE_REMINDERS VARCHAR(50),
IS_DIFFERENT_PRICE INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ID_EATING_OBJECT TYPE OF ID_REF,
ROOM_PRIVATE_STATUS TLOGICAL)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure RES_OCCUPANCY_ROOM$INT with new param-list */
ALTER PROCEDURE RES_OCCUPANCY_ROOM$INT(ID_RESERV_DETAIL INTEGER,
FOR_DATE DATE,
ID_RES_ROOM INTEGER,
ID_RES_ROOM_TYPE INTEGER)
 RETURNS(ID_ROOM INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_STATUS VARCHAR(50))
 AS
 BEGIN SUSPEND; END
^

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_ADD$INT for: ACCOUNT_CHECK_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_POSTING_ADD$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_GUEST /* TYPE OF ID_REF */ INTEGER,
ID_SECQUENCE /* TYPE OF ID_REF */ INTEGER,
DATE_POST /* TYPE OF TDATE */ DATE,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_TARIFF /* TYPE OF ID_REF */ INTEGER,
ID_ROOM /* TYPE OF ID_REF */ INTEGER,
IS_BASE /* TYPE OF TLOGICAL */ SMALLINT,
QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
ORIG_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
RATE /* TYPE OF TRATE */ NUMERIC(15,6),
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
CHANGED_TEXT /* TYPE OF TTEXT_SHORT */ VARCHAR(30),
ID_MASTER_ADDINS_ACC_POST /* TYPE OF ID_REF */ INTEGER,
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
NEW_ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE$INT for: ACCOUNT_CHECK_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE$INT(AP_DBKEY /* TYPE OF TDB_KEY */ CHAR(8),
ID_ACCOUNT /* TYPE OF ID_REF */ INTEGER,
ID_SERVICE /* TYPE OF ID_REF */ INTEGER,
ID_TARIFF /* TYPE OF ID_REF */ INTEGER,
ID_ROOM /* TYPE OF ID_REF */ INTEGER,
QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
QTY_FREE /* TYPE OF TQTY */ NUMERIC(15,2),
PRICE /* TYPE OF TVALUE */ DOUBLE PRECISION,
CURR /* TYPE OF TCURRENCY */ CHAR(3),
RATE /* TYPE OF TRATE */ NUMERIC(15,6),
CHANGED_TEXT VARCHAR(40),
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
IS_CONSEQUENTIAL_UPDATE /* TYPE OF TBOOLEAN */ SMALLINT = 0)
 RETURNS(OUT_QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
OUT_PRICE_POST /* TYPE OF TVALUE */ DOUBLE PRECISION,
OUT_AC VARCHAR(2))
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_CHECK_CREDIT_STATUS$INT) */
ALTER PROCEDURE ACCOUNT_CHECK_CREDIT_STATUS$INT(ID_ACCOUNT TYPE OF ID_REF,
POST_VALUE TYPE OF TPRICE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_credit_account integer;
  declare variable id_reserv_detail integer;
  declare variable credit_limit tprice;
  declare variable b_post_sum tprice;
  declare variable b_pay_sum tprice;
  declare variable difference_value tprice;
  declare variable no_use varchar(255);
  declare variable account_currency tcurrency;
  declare variable round_to numeric(15,4);
begin
  if (:POST_VALUE = 0) then exit;

  select a.IS_CREDIT_ACCOUNT, a.CREDIT_LIMIT, a.ID_RESERV_DETAIL
  from   ACCOUNT A
  where  a.ID_ACCOUNT = :ID_ACCOUNT
  into   :is_credit_account, :credit_limit, :id_reserv_detail;

  if (:is_credit_account = 0
      and exists (select rd.ID_RESERV_DETAIL
                  from   RESERV_DETAIL rd
                  where  rd.ID_RESERV_DETAIL = :id_reserv_detail
                         and rd.CHECK_STATUS = 1)) then
  begin
    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, :credit_limit, 1);
  end

  if (coalesce(:credit_limit, 0) > 0) then begin
    /* FIND BALANCE OF ACCOUNT */
    execute procedure ACCOUNT_BALANCE$INT(:id_account)
    returning_values  :account_currency, :round_to, :no_use, :b_post_sum, :b_pay_sum, :no_use, :no_use;
    b_post_sum = coalesce(:b_post_sum, 0);
    b_pay_sum  = coalesce(:b_pay_sum, 0);

    /* IS THIS POST IS IN LIMIT */
    if ((:b_post_sum + :POST_VALUE) > :credit_limit) then begin
      err_code = -13; /*  */
      difference_value = :b_post_sum + :POST_VALUE - :credit_limit;
      err_text = f_character(29)||FormatFloat(:credit_limit, :round_to)||' '||:account_currency||
                 f_character(28)||FormatFloat(:difference_value, :round_to);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_BALANCE$INT for: ACCOUNT_CURR_BALANCE$INT */
ALTER PROCEDURE ACCOUNT_BALANCE$INT(ID_ACCOUNT INTEGER,
EW_INCL_ONLY SMALLINT = 0)
 RETURNS(ACCOUNT_CURR CHAR(3),
CURR_DISPLAY_FORMAT VARCHAR(10),
ACCOUNT_BALANCE NUMERIC(15,4),
POST_VALUE NUMERIC(15,4),
DEP_VALUE NUMERIC(15,4),
DEP_MONEY_BAG VARCHAR(255),
OPEN_CHARGES INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_CURR_BALANCE$INT) */
ALTER PROCEDURE ACCOUNT_CURR_BALANCE$INT(ID_ACCOUNT INTEGER,
BALANCE_CURR VARCHAR(3),
EW_INCL_ONLY SMALLINT = 0)
 RETURNS(CURR_ORIG CHAR(3),
POST_ORIG_VALUE NUMERIC(15,4),
POST_BAL_VALUE NUMERIC(15,4),
DEP_ORIG_VALUE NUMERIC(15,4),
DEP_BAL_VALUE NUMERIC(15,4),
OPEN_CHARGES INTEGER)
 AS
declare variable calc_rate numeric(15,6);
  declare variable pay_value numeric(15,4);
  declare variable sys_date date;
  declare variable pay_curr varchar(3);
  declare variable account_curr varchar(3);
  declare variable id_hotel integer;
  declare variable dbg varchar(1000);
begin
  OPEN_CHARGES = 0;
  /* FIND THE ACCOUNT CURRENCY */
  select A.ACCOUNT_CURR, A.ID_HOTEL
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :account_curr, :id_hotel;

  if (:balance_curr is null) then balance_curr = :account_curr;

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values :sys_date;
  /* -------------------- SUM POSTINGS --------------------- */
  post_orig_value = 0;
  post_bal_value = 0;
  for
    select sum(AP.QTY_POST * AP.PRICE_POST - AP.IN_DOC_QTY * AP.IN_DOC_VALUE), AP.CURR_POST
    from   ACCOUNT_POST AP
    where  AP.ID_ACCOUNT = :ID_ACCOUNT
           and AP.AC = '00'
           and AP.ID_END_WORK is distinct from iif(:EW_INCL_ONLY = 1, null, 0 /* ever */)
    group by AP.CURR_POST
    into   :POST_ORIG_VALUE, :CURR_ORIG
  do begin
    OPEN_CHARGES = 1;
    if (:account_curr is not distinct from :balance_curr) then begin
      post_bal_value = :post_orig_value;
    end else begin
      select CF.RATE
      from   CURR_CROSS_RATE_GET (:account_curr, :balance_curr, :sys_date, :id_hotel) cf
      into   :calc_rate;
      post_bal_value = :post_orig_value * :calc_rate;
    end
  end
  /* ------------------ CHECK FOR PAYMENT EXISTENCE ------------------- */
  DEP_ORIG_VALUE = 0;
  DEP_BAL_VALUE = 0;
  for
    select iif(DA.PAY_CURRENCY is not distinct from :CURR_ORIG, 0, 1),
           sum(DA.AVAIL_VALUE), DA.PAY_CURRENCY
    from   DEPOSIT_AVAILABLE DA
           left outer join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = da.ID_RESERV_DETAIL
    where  DA.ID_ACCOUNT = :ID_ACCOUNT
           and DA.PAYMENT_DATE < iif(:EW_INCL_ONLY = 1, :sys_date, DA.PAYMENT_DATE + 1)
           and rd.IS_POSTING_STOPPED is distinct from 1
    group by DA.PAY_CURRENCY
    order by 1 asc  /* get deposits on account currency first - to suspend with postings balance */
    into   :dbg, :pay_value, :pay_curr
  do begin
    if (:curr_orig is not null and :pay_curr is distinct from :curr_orig) then begin
      suspend;
      post_orig_value = 0;
      post_bal_value = 0;
    end
    dep_orig_value = :pay_value;
    curr_orig = :pay_curr;

    if (:pay_curr is not distinct from :balance_curr) then begin
      dep_bal_value = :dep_orig_value;
    end else begin
      select cf.rate
      from   CURR_CROSS_RATE_GET (:pay_curr, :balance_curr, :sys_date, :id_hotel) cf
      into   :calc_rate;
      dep_bal_value = :dep_orig_value * :calc_rate;
    end
  end

  suspend;
end
^

/* Alter (ACCOUNT_JOIN_IN_ONE_BY_STRING) */
ALTER PROCEDURE ACCOUNT_JOIN_IN_ONE_BY_STRING(IN_TARGET_ID_ACCOUNT INTEGER,
IN_SOURCE_STRING VARCHAR(1000))
 AS
declare variable source_id_account integer;
  declare variable id_deposit integer;
  declare variable avail_value numeric(15,4);
  declare variable dbg varchar(1000);
  declare variable description varchar(100);
  declare variable doc_selected integer;
begin

  for
    select cast(ITEM as integer)
    from   SYSTEM_STRING_PARSER(:IN_SOURCE_STRING, 'x')
    into   :source_id_account
  do begin
    if (:source_id_account <> :in_target_id_account) then begin
      doc_selected = gen_id(DOC_SELECTED_GEN, 1);
      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :doc_selected
      where  AP.ID_ACCOUNT =  :source_id_account
             and AP.AC = '00'
             and AP.ID_BASE_DOC is null;

      /* call next procedure because of logging */
      execute procedure ACCOUNT_POSTING_TRANSFER$ACC(:doc_selected, :in_target_id_account, :source_id_account);

      for
        select DA.ID_DEPOSIT, DA.AVAIL_VALUE, DA.DESCRIPTION
        from   DEPOSIT_AVAILABLE DA
        where  DA.ID_ACCOUNT = :source_id_account
        into   :id_deposit, :avail_value, :description
      do begin
        execute procedure DEPOSIT_TRANSFER$ACC (:id_deposit, :in_target_id_account, :avail_value, :description)
        returning_values  :dbg;
      end 
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_ACCOUNT$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
QTY /* TYPE OF TQTY */ NUMERIC(15,2),
ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
DATE_POST /* TYPE OF TDATE */ DATE,
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ROOM /* TYPE OF ID */ INTEGER = null,
POST_DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_GUEST$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ACCOUNT_ROUTING /* TYPE OF TSHORT_CODE */ VARCHAR(10),
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_TAR_CALC_REPOST$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE RES_TAR_CALC_REPOST$INT(ID_TAR_CALC /* TYPE OF ID_REF */ INTEGER,
ID_RESERV_DETAIL /* TYPE OF ID_REF */ INTEGER,
RECALC_MARKER VARCHAR(40))
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_ADD$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_ADD$INT(ID_ACCOUNT TYPE OF ID,
ID_GUEST TYPE OF ID_REF,
ID_SECQUENCE TYPE OF ID_REF,
DATE_POST TYPE OF TDATE,
ID_SERVICE TYPE OF ID,
ID_TARIFF TYPE OF ID_REF,
ID_ROOM TYPE OF ID_REF,
IS_BASE TYPE OF TLOGICAL,
QTY_POST TYPE OF TQTY,
PRICE TYPE OF TPRICE,
ORIG_CURRENCY TYPE OF TCURRENCY,
RATE TYPE OF TRATE,
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
POST_TEXT TYPE OF TDESCRIPTION_SHORT,
RESOURCE_TEXT TYPE OF TREASON,
CHANGED_TEXT TYPE OF TTEXT_SHORT,
ID_MASTER_ADDINS_ACC_POST TYPE OF ID_REF,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
NEW_ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable price_post double precision;
  declare variable post_rate numeric (15, 6);
  declare variable curr_post char(3);
  declare variable account_currency char(3);
  declare variable id_pack_service integer;
  declare variable id_room_type integer;
  declare variable room_name varchar(30);
  declare variable is_archive integer;
  declare variable id_tax_policy integer;
  declare variable id_sale_taxation integer;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable check_option varchar(255);
  declare variable id_hotel integer;
  declare variable id_srv_hotel integer;
  declare variable service_name varchar(30);
  declare variable account_name varchar(50);
begin
  ID_GUEST = nullif(:ID_GUEST, -1);

  execute procedure POST_PRICE_CHECK$INT (:QTY_POST, :PRICE, :ORIG_CURRENCY);

  if ( (:IS_BASE = 1) or (:ID_MASTER_ADDINS_ACC_POST > 0) ) then
    check_option = 'IS_BASE;ALLOW_POSTING';
  else
    check_option = 'IS_EXTRA;ALLOW_POSTING';

  execute procedure ACCOUNT_VALIDATE$INT(:id_account, :check_option)
  returning_values  (:err_code, :err_text, :account_currency, :id_tax_policy, :id_hotel, :account_name);
  if (:err_code < 0) then EXIT; --  exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;

  select s.ID_HOTEL, s.SERVICE_NAME
  from   SERVICES S
  where  s.ID_SERVICE = :ID_SERVICE
  into   :id_srv_hotel, :service_name;

  if (:id_srv_hotel is distinct from :id_hotel) then
    exception POSTING_EXCEPTION '-1056' || f_character(31) || f_character(29) || :service_name || f_character(28) || :account_name;

  if (:rate is null) then begin
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :orig_currency, :date_post, :id_guest)
    returning_values  :rate;
  end

  curr_post  = :account_currency;
  if (:orig_currency = :account_currency) then begin
    post_rate  = :rate;
  end else begin
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :account_currency, :date_post, :id_guest)
    returning_values  :post_rate;
  end

  execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :id_tax_policy, :ID_TARIFF, :DATE_POST - :FROM_DATE)
  returning_values (:id_sale_taxation);

  execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:QTY_POST, :PRICE,
                    :RATE, :post_rate, :id_sale_taxation)
  returning_values  :price_post, :post_net_value, :post_gross_value;

  execute procedure ACCOUNT_CHECK_CREDIT_STATUS$INT (:ID_ACCOUNT, :price_post * :QTY_POST)
  returning_values (:ERR_CODE, :ERR_TEXT);
  if (:ERR_CODE <> 0) then exit;

  --
  new_id_account_post = gen_id (id_account_post_gen, 1);

  if (:post_text starting with 'PACK') then begin
    id_pack_service = substring(:post_text from 6 for 20);
    post_text = '';
  end else begin
    id_pack_service = -1;
  end
  if (:is_base = 1) then id_master_addins_acc_post = :new_id_account_post;

  select R.ROOM_NAME, R.ID_ROOM_TYPE
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :room_name, :id_room_type;

  if (:id_guest is null) then begin
    is_archive = 1;
  end else begin
    select iif(G.CHECK_STATUS = 1, 1, 0)
    from   GUEST G
    where  G.ID_GUEST = :id_guest
    into   :is_archive;
  end

  insert into ACCOUNT_POST (
    ID_ACCOUNT_POST, ID_ACCOUNT, ID_GUEST, ID_SERVICE, ID_TARIFF, ID_ROOM,
    IS_BASE, DATE_POST, QTY_POST, QTY_FREE, PRICE_POST, POST_NET_VALUE, POST_GROSS_VALUE, CURR_POST, RATE_POST,
    PRICE_ORIG, CURR_ORIG, RATE_ORIG, IS_LOCKED_FOR_UPDATE, TO_DATE, FROM_DATE, ID_SEQUENCE,
    SHORT_CODE, CHANGED_TEXT, ID_MASTER_ADDINS_ACC_POST, ID_PACK_SERVICE, ROOM_NAME, ID_ROOM_TYPE,
    ID_SALE_TAXATION, AC, IS_ARCHIVE, IN_DOC_QTY, IN_DOC_VALUE, DESCRIPTION)
  values (
    :new_id_account_post, :id_account, :id_guest, :id_service, :id_tariff, coalesce(:id_room, -1),
    :is_base, :date_post, :qty_post, 0, :price_post, :post_net_value, :post_gross_value, :curr_post, :post_rate,
    :price, :orig_currency, :rate, 0, :TO_DATE, :FROM_DATE, :id_secquence,
    :short_code, :changed_text, :id_master_addins_acc_post, :id_pack_service, :room_name, :id_room_type,
    :id_sale_taxation, '00', :is_archive, 0, 0, :DESCRIPTION);

  if ((coalesce(:post_text, '') <> '') or (coalesce(:resource_text, '') <> '')) then begin
    insert into ACCOUNT_POSTING_DET (ID_ACCOUNT_POST, POST_TEXT, QTY, FROM_DATETIME, TO_DATETIME, RESOURCE_TEXT)
    values (:new_id_account_post, :post_text, :qty_post, :FROM_DATE, :TO_DATE, :resource_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_TRANSFER$INT for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE_PERC for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_PERC(IN_ID_ACCOUNT_POST VARCHAR(4000),
IN_PERC NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(30))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_POSTING$INT for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_POSTING$INT(ID_RESOURCE_RESERVATION /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
PRICE_DESCRIPTION /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
ID_RESERV_DETAIL /* TYPE OF ID */ INTEGER,
ID_EXTERNAL_CLIENT_ACCCOUNT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(DOC_SELECTED /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_POSTING_UPDATE$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE$INT(AP_DBKEY TYPE OF TDB_KEY,
ID_ACCOUNT TYPE OF ID_REF,
ID_SERVICE TYPE OF ID_REF,
ID_TARIFF TYPE OF ID_REF,
ID_ROOM TYPE OF ID_REF,
QTY_POST TYPE OF TQTY,
QTY_FREE TYPE OF TQTY,
PRICE TYPE OF TVALUE,
CURR TYPE OF TCURRENCY,
RATE TYPE OF TRATE,
CHANGED_TEXT VARCHAR(40),
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
IS_CONSEQUENTIAL_UPDATE TYPE OF TBOOLEAN = 0)
 RETURNS(OUT_QTY_POST TYPE OF TQTY,
OUT_PRICE_POST TYPE OF TVALUE,
OUT_AC VARCHAR(2))
 AS
declare variable date_post date;
  declare variable orig_is_base integer;
  declare variable orig_id_service integer;
  declare variable orig_id_room integer;
  declare variable orig_short_code varchar(255);
  declare variable orig_qty_post integer;
  declare variable orig_ac varchar(2);
  declare variable is_locked_for_update integer;
  declare variable orig_locked_for_update integer;
  declare variable orig_id_tariff integer;
  declare variable orig_id_guest integer;
  declare variable id_type_stay integer;
  declare variable id_room_type integer;
  declare variable id_board integer;
  declare variable id_pack_service integer;
  declare variable new_id_pack_service integer;
  declare variable post_currency char(3);
  declare variable room_name varchar(30);
  declare variable original_post varchar(30);
  declare variable new_ac varchar(2);
  declare variable orig_in_doc_qty numeric(15,2);
  declare variable orig_in_doc_value double precision;
  declare variable rate_post numeric(15,6);
  declare variable id_base_doc integer;
  declare variable id_tax_policy integer;
  declare variable price_post double precision;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable id_sale_taxation integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable orig_price_post tprice;
  declare variable round_to numeric(15,4);
  declare variable account_name tobject_name;
  declare variable err_code integer;
  declare variable err_text varchar(100);
begin
  /* GET DATA */
  original_post = '';
  new_id_pack_service = null;

  select AP.DATE_POST, AP.IS_BASE, AP.ID_SERVICE, AP.ID_BASE_DOC,
         AP.SHORT_CODE, AP.QTY_POST, ap.PRICE_POST, AP.IS_LOCKED_FOR_UPDATE,
         AP.AC, AP.ID_TARIFF, AP.ID_GUEST, AP.ID_ROOM,
         AP.CURR_POST, AP.ID_PACK_SERVICE, AP.ID_ROOM_TYPE,
         AP.IN_DOC_QTY, AP.IN_DOC_VALUE, AP.RATE_POST, ap.ID_SALE_TAXATION
  from   ACCOUNT_POST AP
  where  AP.rdb$db_key = :AP_DBKEY
  into   :date_post, :orig_is_base, :orig_id_service, :id_base_doc,
         :orig_short_code, :orig_qty_post, :orig_price_post, :orig_locked_for_update,
         :orig_ac, :orig_id_tariff, :orig_id_guest, :orig_id_room,
         :post_currency, :id_pack_service, :id_room_type,
         :orig_in_doc_qty, :orig_in_doc_value, :rate_post, :id_sale_taxation;

  is_locked_for_update = :orig_locked_for_update; /* to initialize and preserve from null */

  execute procedure ACCOUNT_VALIDATE$INT(:id_account, 'ALLOW_POSTING;')
  returning_values  (:err_code, :err_text, :post_currency, :id_tax_policy, :id_hotel, :account_name);
  if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;

  if (:IS_CONSEQUENTIAL_UPDATE is distinct from 1) then begin
    -- manual edition restrictions check
    if (:QTY_POST = -1) then QTY_POST = :orig_qty_post;   -- preserve current qty

    if (:QTY_POST <> :orig_qty_post) then exception POSTING_EXCEPTION '-379';

    if ((:orig_is_base = 1) and ((:QTY_POST <> 1) or (:ID_SERVICE <> :orig_id_service))) then
      exception POSTING_EXCEPTION '-223';

    if (:orig_ac = '01') then execute procedure RIGHTS_CHECK_GRANTED$INT('BALANCES_EDIT_CLOSED');

    short_code = :orig_short_code;
    id_tariff  = :orig_id_tariff;
    id_room    = :orig_id_room;
    is_locked_for_update = 1;  /* manual corrections must lock the postings  */

  end else begin  /* 'NORMAL', 'FORCED', safes recalc, ... */
    is_locked_for_update = 0;

    if (:orig_is_base = 1) then begin
      /* PREPARING THE PACKET SERVICE */
      select S.ID_TYPE_STAY, S.ID_ROOM_TYPE
      from   SERVICE_PACKET S
      where  S.ID_SERVICE = :id_service
      into   :id_type_stay, :id_room_type;

      select GS.ID_BOARD
      from   GUEST_STAY GS
      where  GS.ID_GUEST = :orig_id_guest
             and GS.FOR_DATE = :date_post
      into   :id_board;

      execute procedure TAR_GET_BASE_SERVICE$INT(:id_type_stay, :id_room_type, :id_board, :id_hotel)
      returning_values  :id_pack_service;
      /* detecting change of STAY_TYPE or ROOM_TYPE */
      if (exists(
        select *
        from   SERVICE_PACKET S
        where  S.ID_SERVICE = :orig_id_service
               and ((S.ID_TYPE_STAY is distinct from :id_type_stay) or (S.ID_ROOM_TYPE is distinct from :id_room_type))
      )) then original_post = 'CHANGED';
    end
  end

  select R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :room_name;

  if (:orig_locked_for_update = 1
      and :changed_text starting with 'NORMALRECALC'
      and :id_service = :orig_id_service
      --and :orig_is_anul = 0
      and :id_tariff = :orig_id_tariff) then
  begin
    -- price is locked for update
    update ACCOUNT_POST AP
    set    AP.ID_ROOM      = :id_room,
           AP.ROOM_NAME    = :room_name,
           Ap.FROM_DATE    = :from_date,
           Ap.TO_DATE      = :to_date,
           AP.CHANGED_TEXT = :changed_text,
           AP.USER_CHANGED = current_user,
           AP.DATETIME_CHANGED = current_timestamp
    where  AP.rdb$db_key   = :AP_DBKEY;
    OUT_QTY_POST = :orig_qty_post;
    OUT_PRICE_POST = :orig_price_post;
    OUT_AC = :orig_ac;
  end else begin
    -- fully update
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :curr, :date_post, :orig_id_guest)
    returning_values  :rate;
  
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :post_currency, :date_post, :orig_id_guest)
    returning_values  :rate_post;
  
    if (:id_base_doc is null) then begin
      execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :id_tax_policy, :ID_TARIFF, :date_post - :from_date)
      returning_values (:id_sale_taxation);
    end

    execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:QTY_POST, :PRICE,
                      :RATE, :rate_post, :id_sale_taxation)
    returning_values  :price_post, :post_net_value, :post_gross_value;

    select c.ROUND_TO
    from   CURRS c
    where  c.CURR = :post_currency
    into   :round_to;

    if ( (:id_base_doc is not null)
         and (:qty_post = :orig_in_doc_qty)
         and (round_f(:price_post - :orig_in_doc_value, :round_to) = 0))
    then new_ac = '01';
    else new_ac = '00';                   
  
    if (:new_ac = '00') then begin
      execute procedure ACCOUNT_CHECK_CREDIT_STATUS$INT (:id_account, :price_post * :QTY_POST - :orig_price_post * :orig_qty_post)
      returning_values (:err_code, :err_text);
      if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;
    end

    update ACCOUNT_POST AP
    set    AP.ID_ACCOUNT           = :id_account,
           AP.ID_SERVICE           = :id_service,
  
           AP.QTY_POST             = :qty_post,
           AP.QTY_FREE             = :qty_free,
           AP.PRICE_POST           = :price_post,
           AP.CURR_POST            = :post_currency,
           AP.RATE_POST            = :rate_post,
           AP.RATE_ORIG            = :rate,
           AP.PRICE_ORIG           = :price,
           AP.CURR_ORIG            = :curr,
           AP.POST_NET_VALUE       = :post_net_value,
           AP.POST_GROSS_VALUE     = :post_gross_value,
  
           AP.AC                   = :new_ac,
           AP.IS_ANUL              = 0,
           AP.ANUL_REASON          = '',
           AP.IS_LOCKED_FOR_UPDATE = :is_locked_for_update,
           AP.ID_TARIFF            = :id_tariff,
           AP.ID_PACK_SERVICE      = :id_pack_service,
           AP.ID_ROOM              = :id_room,
           AP.ID_ROOM_TYPE         = :id_room_type,
           AP.ROOM_NAME            = :room_name,
           AP.ID_SALE_TAXATION     = :id_sale_taxation,
           AP.ORIGINAL_POST        = :original_post,
           AP.SHORT_CODE           = :short_code,
           AP.CHANGED_TEXT         = :changed_text,
           AP.USER_CHANGED         = current_user,
           AP.DATETIME_CHANGED     = current_timestamp,
           Ap.FROM_DATE            = :from_date,
           Ap.TO_DATE              = :to_date
    where  AP.rdb$db_key = :AP_DBKEY
    returning new.id_account_post, new.id_pack_service
    into   :id_account_post, :new_id_pack_service;
  
    if (:new_ac = '01') then begin
      update ACCOUNT_POST_CORRECTION APC
      set    APC.IS_OPEN = 0
      where  APC.ID_ACCOUNT_POST = :id_account_post
             and APC.IS_OPEN = 1;
    end

    if (:orig_is_base = 1 and :new_id_pack_service <> :id_pack_service) then begin
      -- update add_inses with new pack service
      update ACCOUNT_POST AP
      set    ap.ID_PACK_SERVICE = :new_id_pack_service
      where  ap.ID_MASTER_ADDINS_ACC_POST = :id_account_post
             and ap.IS_BASE = 0;
    end

    OUT_QTY_POST = :qty_post;
    OUT_PRICE_POST = :price_post;
    OUT_AC = :new_ac;
  end
end
^

/* Alter (ACCOUNT_POSTING_UPDATE_PERC) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_PERC(IN_ID_ACCOUNT_POST VARCHAR(4000),
IN_PERC NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(30))
 AS
declare variable id_account_post integer;
  declare variable ap_dbkey char(8);
  declare variable id_service integer;
  declare variable id_tariff integer;
  declare variable id_room integer;
  declare variable id_account integer;
  declare variable qty_post numeric (15,4);
  declare variable qty_free numeric (15,4);
  declare variable short_code varchar(255);
  declare variable orig_currency char(3);
  declare variable orig_rate numeric (15,4);
  declare variable orig_price numeric (15,4);
  declare variable new_orig_price double precision;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  for
    select item
    from   SYSTEM_STRING_PARSER(:in_id_account_post, ',')
    into   :id_account_post
  do begin
    select AP.rdb$db_key, AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST,
           AP.QTY_FREE, AP.SHORT_CODE, AP.CURR_ORIG, AP.RATE_ORIG, AP.PRICE_ORIG,
           ap.FROM_DATE, ap.TO_DATE, ap.ID_ACCOUNT
    from   ACCOUNT_POST AP
    where  AP.ID_ACCOUNT_POST = :id_account_post
    into   :ap_dbkey, :id_service, :id_tariff, :id_room, :qty_post,
           :qty_free, :short_code, :orig_currency, :orig_rate, :orig_price,
           :from_date, :to_date, :id_account;

    new_orig_price = :orig_price + :orig_price * :in_perc;

    execute procedure ACCOUNT_POSTING_UPDATE$INT(:ap_dbkey, :id_account,
            :id_service, :id_tariff, :id_room,
            :qty_post, :qty_free, :new_orig_price, :orig_currency, :orig_rate,
            :in_changed_text, :short_code, :from_date, :to_date)
    returning_values  :no_use, :no_use, :no_use;
  end
end
^

/* Alter (ACCOUNT_SELECTION_UNITE$DOC) */
ALTER PROCEDURE ACCOUNT_SELECTION_UNITE$DOC(ID_DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
PROFILE_ACCOUNTS_ONLY SMALLINT = 0)
 RETURNS(SKIP_DOC_SELECTED INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_deposit integer;
  declare variable id_base_doc integer;
  declare variable avail_value double precision ;
  declare variable dbkey char(8);
  declare variable id_account integer;
  declare variable id_profile integer;
  declare variable description varchar(100);
begin
  dbg = null;
  skip_doc_selected = null;
  id_profile = null;
  if (:PROFILE_ACCOUNTS_ONLY = 1) then begin
    select A.ID_PROFILE
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :ID_DEST_ACCOUNT
    into   :ID_PROFILE;
  end

  for
    select AP.ID_ACCOUNT, max(AP.ID_BASE_DOC)
    from   ACCOUNT_POST AP
           join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
    where  AP.DOC_SELECTED = :ID_DOC_SELECTED
           and AP.ID_ACCOUNT is distinct from :ID_DEST_ACCOUNT
           and A.ID_PROFILE = coalesce(:ID_PROFILE, A.ID_PROFILE)
    group by AP.ID_ACCOUNT
    into   :ID_ACCOUNT, :ID_BASE_DOC
  do begin
    if (:ID_BASE_DOC is null) then begin
      /* posting transfer loging is released into next procedure */
      execute procedure ACCOUNT_POSTING_TRANSFER$ACC (:ID_DOC_SELECTED, :ID_DEST_ACCOUNT, :ID_ACCOUNT);
    end else begin
      /* has a document on some postings - skip transfer */
      SKIP_DOC_SELECTED = -:ID_DOC_SELECTED;
      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :SKIP_DOC_SELECTED
      where  AP.DOC_SELECTED = :ID_DOC_SELECTED
             and AP.ID_ACCOUNT = :ID_ACCOUNT;
    end
  end

  for
    select D.ID_ACCOUNT, D.ID_DEPOSIT, D.RDB$DB_KEY
    from   DEPOSIT D
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  D.DOC_SELECTED = :ID_DOC_SELECTED
           and D.ID_ACCOUNT is distinct from :ID_DEST_ACCOUNT
           and A.ID_PROFILE = coalesce(:ID_PROFILE, A.ID_PROFILE)
    order by 1 asc
    into   :ID_ACCOUNT, :ID_DEPOSIT, :DBKEY
  do begin
    if (not exists (select AP.ID_ACCOUNT_POST
                    from   ACCOUNT_POST AP
                    where  AP.ID_ACCOUNT = :ID_ACCOUNT
                           and AP.DOC_SELECTED = -:ID_DOC_SELECTED)) then
    begin
      /* transfer selected item */
      AVAIL_VALUE = null;
      select DA.AVAIL_VALUE, DA.DESCRIPTION
      from   DEPOSIT_AVAILABLE DA
      where  DA.ID_DEPOSIT = :ID_DEPOSIT
      into   :AVAIL_VALUE, :DESCRIPTION;

      if (:AVAIL_VALUE is not null) then begin
        execute procedure DEPOSIT_TRANSFER$ACC (:ID_DEPOSIT, :ID_DEST_ACCOUNT, :AVAIL_VALUE, :DESCRIPTION)
        returning_values  :DBG;
      end
    
      update DEPOSIT D
      set    D.DOC_SELECTED = null
      where  D.RDB$DB_KEY = :DBKEY;
    end else begin
      /* skipped account */
      SKIP_DOC_SELECTED = -:ID_DOC_SELECTED;
      update DEPOSIT D
      set    D.DOC_SELECTED = :SKIP_DOC_SELECTED
      where  D.RDB$DB_KEY = :DBKEY;
    end
  end 

end
^

/* Alter (ACCOUNTS_BALANCE_TO_DATE$RPT) */
ALTER PROCEDURE ACCOUNTS_BALANCE_TO_DATE$RPT(ID_HOTEL INTEGER,
TO_DATE DATE)
 RETURNS(ID_ACCOUNT INTEGER,
ACCOUNT_CURR CHAR(3),
CURR_RATE NUMERIC(15,6),
POSTING_AMOUNT NUMERIC(15,4),
PAYMENT_AMOUNT NUMERIC(15,4),
OPEN_DEP_AMOUNT NUMERIC(15,4),
OPEN_CHARGES INTEGER)
 AS
declare variable rates_marker integer;
declare variable all_payment_amount numeric(15,4);
declare variable used_payments numeric(15,4);
declare variable round_to numeric(15,4);
declare variable max_fin_date date;
begin
  select max(S.SUMMARY_DATE)
  from   SUMMARY_END_WORK S
  where  S.ID_HOTEL = :id_hotel
  into   :max_fin_date;

  if (:to_date > :max_fin_date) then to_date = :max_fin_date;

  execute procedure CURR_RATES_PREPARE$RPT (:ID_HOTEL, :TO_DATE)
  returning_values :rates_marker;

  for
    select A.ID_ACCOUNT, A.ACCOUNT_CURR, T.CURR_RATE, c.ROUND_TO,
           (select sum(AD.POST_AMOUNT)
            from   ACCOUNT_DEBT AD
            where  AD.ID_ACCOUNT = A.ID_ACCOUNT
                   and (AD.DEBT_DATE - 1) < :to_date),
           (select sum(ap.ACC_AMOUNT)
            from   ACCOUNT_PAYMENTS AP
            where  Ap.ID_ACCOUNT = A.ID_ACCOUNT
                   and AP.TRANSACTION_DATE <= :to_date),
           (select cast(sum(rp.realized_value * cast(tr.CURR_RATE / t.CURR_RATE as double precision)) as numeric(15,4))
             from  DOCUMENT_PAYMENT rp
                   left outer join CURR_RATES$TMP TR on TR.DOC_SELECTED = :rates_marker and tr.curr = rp.pay_currency
             where rp.id_account = a.id_account
                   and rp.realize_date <= :to_date)
    from   ACCOUNT A
           join CURRS c on c.CURR = a.ACCOUNT_CURR
           left outer join CURR_RATES$TMP T on T.DOC_SELECTED = :rates_marker and T.CURR = A.ACCOUNT_CURR
    where  A.ID_HOTEL = :id_hotel
           and ((A.IS_ARCHIVE = 0) or (a.ARCHIVED_DATE > :to_date))
    into   :ID_ACCOUNT, :ACCOUNT_CURR, :CURR_RATE, :round_to, :POSTING_AMOUNT, :all_payment_amount, :used_payments
  do begin
    if (round_f(coalesce(:POSTING_AMOUNT, 0) - coalesce(:used_payments, 0), :round_to) = 0) then OPEN_CHARGES = 0; else OPEN_CHARGES = 1;
    PAYMENT_AMOUNT = :used_payments;
    OPEN_DEP_AMOUNT = :all_payment_amount - :used_payments;
    suspend;
  end

  delete from CURR_RATES$TMP T
  where  T.DOC_SELECTED = :rates_marker;

  SUSPEND;
end
^

ALTER PROCEDURE RES_OCCUPANCY_ROOM$INT(ID_RESERV_DETAIL INTEGER,
FOR_DATE DATE,
ID_RES_ROOM INTEGER,
ID_RES_ROOM_TYPE INTEGER)
 RETURNS(ID_ROOM INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_STATUS VARCHAR(50))
 AS
declare variable mapped_id_room integer;
  declare variable mapped_id_room_type integer;
begin
  ROOM_STATUS = null;

  if (coalesce(:ID_RES_ROOM, 0) <= 0) then begin
    -- get mapped room id and room_type_id, because of shares and CRS compatability
    mapped_id_room = null;
    mapped_id_room_type = null;
    -- the next select makes sense only for imported bookings - getting room from imported data
    select mr.ID_ROOM, mr.ID_ROOM_TYPE, t.IMPORT_ROOM_STATUS
    from   RESERV_ROOMS$EXC T
           left outer join MAPPED_ROOM_GET$EXC (t.IMPORT_ROOM_TYPE_UUID, t.IMPORT_ID_ROOM) MR on 1=1
    where  t.ID_RESERV_DETAIL = :id_reserv_detail
           and t.FOR_DATE = :FOR_DATE
    into   :mapped_id_room, :mapped_id_room_type, :ROOM_STATUS;
    -- end
    id_room = coalesce(:mapped_id_room, :ID_RES_ROOM, gen_id(DETAIL_WITHOUT_ROOMING_LIST, -1));
    if (:mapped_id_room_type is null) then begin
      select rm.ID_ROOM_TYPE
      from   ROOM_MAP$EXC rm
      where  rm.ID_ROOM = :id_room
      into   :mapped_id_room_type;
    end
    id_room_type = coalesce(:mapped_id_room_type, :ID_RES_ROOM_TYPE);

  end else begin
    -- has a really room
    ID_ROOM = :ID_RES_ROOM;
    select r.ID_ROOM_TYPE
    from   ROOMS R
    where  r.ID_ROOM = :id_room
    into   :id_room_type;

    select rp.STATUS
    from   ROOM_PERIOD$PMS rp
    where  rp.ID_ROOM = :ID_ROOM
           and rp.FROM_DATE <= :FOR_DATE
           and rp.TO_DATE >= :FOR_DATE
    into   :ROOM_STATUS;
  end

  suspend;
end
^

/* Alter (AGENT_CONTINGENT_OCCUPANCY) */
ALTER PROCEDURE AGENT_CONTINGENT_OCCUPANCY(FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
ID_PROFILE TYPE OF ID,
ID_HOTEL TYPE OF ID)
 RETURNS(ID_ROOM_TYPE TYPE OF ID,
FOR_DATE TYPE OF TDATE,
CONT_ROOMS TYPE OF TCOUNT,
CONT_BASE_BEDS TYPE OF TCOUNT,
CONT_EXTRA_BEDS TYPE OF TCOUNT,
OCC_ROOMS TYPE OF TCOUNT,
OCC_BASE_BEDS_ADULTS TYPE OF TCOUNT,
OCC_BASE_BEDS_CHILDREN TYPE OF TCOUNT,
OCC_EXTRA_BEDS_ADULTS TYPE OF TCOUNT,
OCC_EXTRA_BEDS_CHILDREN TYPE OF TCOUNT)
 AS
declare variable id_contingent integer;
begin
  delete from CONTINGENT_OCCUPANCY$TMP t
  where  t.ID_AGENT_PROFILE = :ID_PROFILE;

  CONT_ROOMS = 0;
  CONT_BASE_BEDS = 0;
  CONT_EXTRA_BEDS = 0;
  OCC_ROOMS = 0;
  OCC_BASE_BEDS_ADULTS = 0;
  OCC_BASE_BEDS_CHILDREN = 0;
  OCC_EXTRA_BEDS_ADULTS = 0;
  OCC_EXTRA_BEDS_CHILDREN = 0;

  select pa.ID_CONTINGENT
  from   PROFILE_AGENT pa
  where  pa.ID_PROFILE = :ID_PROFILE
  into   :id_contingent;

  if (:id_contingent is null) then exit;

  insert into CONTINGENT_OCCUPANCY$TMP (ID_AGENT_PROFILE, FOR_DATE, ID_ROOM_TYPE,
         ROOM_TYPE_BASE_BEDS, ROOM_TYPE_AVG_EXTRA_BEDS, CONT_ROOMS, OCC_ROOMS,
         OCC_BASE_BEDS_ADULTS, OCC_BASE_BEDS_CHILDREN, OCC_EXTRA_BEDS_ADULTS, OCC_EXTRA_BEDS_CHILDREN)
  select :id_profile, slp.OUT_DATE, crt.ID_ROOM_TYPE, 
         crt.beds, crt.extra_beds, 0, 0, 0, 0, 0, 0
  from   (select rt.ID_ROOM_TYPE, rt.beds,
                 (select avg(cast(r.EXTRA_BEDS as double precision ))
                  from   ROOMS r
                         join ROOM_PERIOD$PMS rp on rp.ID_ROOM = r.ID_ROOM
                  where  r.ID_ROOM_TYPE = rt.ID_ROOM_TYPE
                         and rp.FROM_DATE <= :from_date
                         and rp.TO_DATE >= :from_date) as extra_beds
          from   ALLOTMENT_DETAIL aa
                 join ROOM_TYPES rt on rt.ID_ROOM_TYPE = aa.ID_ROOM_TYPE
          where  aa.ID_ALLOTMENT = :id_contingent
                 and aa.FROM_DATE <= :to_date
                 and aa.TO_DATE >= :to_date
                 and rt.ID_HOTEL = :id_hotel
          group by rt.ID_ROOM_TYPE, rt.beds) crt
         join SYSTEM_LOOP_PERIOD (:from_date, :to_date) slp on 1=1;

  for
    select ad.ID_ROOM_TYPE, slp.OUT_DATE, ad.CNT_ROOMS
    from   ALLOTMENT_DETAIL AD
           left outer join SYSTEM_LOOP_PERIOD (maxdate(ad.FROM_DATE, :FROM_DATE), mindate(ad.TO_DATE, :TO_DATE)) slp on 1=1
    where  ad.ID_ALLOTMENT = :id_contingent
           and ad.FROM_DATE <= :TO_DATE
           and ad.TO_DATE >= :FROM_DATE
    into   :ID_ROOM_TYPE, :FOR_DATE, :CONT_ROOMS
  do begin
    update CONTINGENT_OCCUPANCY$TMP co
    set    co.CONT_ROOMS = co.CONT_ROOMS + :CONT_ROOMS
    where  co.ID_AGENT_PROFILE = :ID_PROFILE
           and co.FOR_DATE = :FOR_DATE
           and co.ID_ROOM_TYPE = :ID_ROOM_TYPE;
  end

  for
    select gs.FOR_DATE, ror.ID_ROOM_TYPE,
           count(distinct g.ID_ROOM),
           count(iif(g.IS_CHILD = 0 and TS.TYPE_STAY_CODE is distinct from 'EXTRA_BED', gs.ID_GUEST, null)),
           count(iif(g.IS_CHILD = 1 and TS.TYPE_STAY_CODE is distinct from 'EXTRA_BED', gs.ID_GUEST, null)),
           count(iif(g.IS_CHILD = 0 and TS.TYPE_STAY_CODE = 'EXTRA_BED', gs.ID_GUEST, null)),
           count(iif(g.IS_CHILD = 1 and TS.TYPE_STAY_CODE = 'EXTRA_BED', gs.ID_GUEST, null))
    from   GUEST_STAY GS     
           join GUEST G on G.ID_GUEST = gs.ID_GUEST
           join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
           left outer join ACCOUNT_POST AP on rd.CHECK_STATUS >= 0
                                              and ap.ID_GUEST = gs.ID_GUEST
                                              and ap.DATE_POST = gs.FOR_DATE
                                              and ap.IS_BASE = 1
                                              and ap.IS_ANUL = 0
           left outer join SERVICE_PACKET s on s.ID_SERVICE = ap.ID_SERVICE
           left outer join TYPE_STAY TS on TS.ID_TYPE_STAY = coalesce(nullif(gs.ID_TYPE_STAY, -1), s.ID_TYPE_STAY)
           left outer join RES_OCCUPANCY_ROOM$INT (rd.ID_RESERV_DETAIL, gs.FOR_DATE, gs.ID_ROOM, rd.ID_ROOM_TYPE) ror on 1=1
    where  gs.FOR_DATE between :FROM_DATE and :TO_DATE
           and rd.ID_AGENT_PROFILE = :ID_PROFILE
           and rd.IS_ANUL = 0
    group by gs.FOR_DATE, ror.ID_ROOM_TYPE
    into   :FOR_DATE, :ID_ROOM_TYPE, :OCC_ROOMS, :OCC_BASE_BEDS_ADULTS, :OCC_BASE_BEDS_CHILDREN,
           :OCC_EXTRA_BEDS_ADULTS, :OCC_EXTRA_BEDS_CHILDREN
  do begin
    update CONTINGENT_OCCUPANCY$TMP co
    set    co.OCC_BASE_BEDS_ADULTS = co.OCC_BASE_BEDS_ADULTS + :OCC_BASE_BEDS_ADULTS,
           co.OCC_BASE_BEDS_CHILDREN = co.OCC_BASE_BEDS_CHILDREN + :OCC_BASE_BEDS_CHILDREN,
           co.OCC_EXTRA_BEDS_ADULTS = co.OCC_EXTRA_BEDS_ADULTS + :OCC_EXTRA_BEDS_ADULTS,
           co.OCC_EXTRA_BEDS_CHILDREN = co.OCC_EXTRA_BEDS_CHILDREN + :OCC_EXTRA_BEDS_CHILDREN,
           co.OCC_ROOMS = co.OCC_ROOMS + :OCC_ROOMS
    where  co.ID_AGENT_PROFILE = :ID_PROFILE
           and co.FOR_DATE = :FOR_DATE
           and co.ID_ROOM_TYPE = :ID_ROOM_TYPE;
  end 

  for
    select co.FOR_DATE, co.ID_ROOM_TYPE, co.CONT_ROOMS, co.CONT_ROOMS * co.ROOM_TYPE_BASE_BEDS, co.CONT_ROOMS * co.ROOM_TYPE_AVG_EXTRA_BEDS,
           co.OCC_ROOMS, co.OCC_BASE_BEDS_ADULTS, co.OCC_BASE_BEDS_CHILDREN, co.OCC_EXTRA_BEDS_ADULTS, co.OCC_EXTRA_BEDS_CHILDREN
    from   CONTINGENT_OCCUPANCY$TMP co
    where  co.ID_AGENT_PROFILE = :ID_PROFILE
    into   :FOR_DATE, :ID_ROOM_TYPE, :CONT_ROOMS, :CONT_BASE_BEDS, :CONT_EXTRA_BEDS,
           :OCC_ROOMS, :OCC_BASE_BEDS_ADULTS, :OCC_BASE_BEDS_CHILDREN, :OCC_EXTRA_BEDS_ADULTS, :OCC_EXTRA_BEDS_CHILDREN
  do begin
    suspend;
  end 

end
^

/* Alter (ALLOTMENT_CREATE_DETAIL$INT) */
ALTER PROCEDURE ALLOTMENT_CREATE_DETAIL$INT(ID_ALLOTMENT_SESSION INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
INIT_FROM_DATE VARCHAR(50) = 'start',
ALLOTMENT_PART VARCHAR(20) = 'ROOMS')
 AS
declare variable dbg varchar(2000);
  declare variable id_room_type integer;
  declare variable cnt_rooms integer;
  declare variable active_frame_begin integer;
  declare variable active_frame_end integer;
  declare variable new_id_allotment_detail integer;
  declare variable id_allotment integer;
  declare variable init_date date;
begin
  if (:init_from_date = 'start') then init_date = :from_date;
  else init_date = :to_date;

  select TAD.CNT_ROOMS, TAD.ACTIVE_FRAME_BEGIN, TAD.ACTIVE_FRAME_END, TAD.ID_ROOM_TYPE, TAD.ID_ALLOTMENT
  from   ALLOTMENT_DETAIL$TMP TAD
  where  TAD.ID_ALLOTMENT_SESSION = :id_allotment_session
         and TAD.FOR_DATE = :init_date
  into   :cnt_rooms, :active_frame_begin, :active_frame_end, :id_room_type, :id_allotment;

  new_id_allotment_detail = gen_id(GEN_ALLOTMENT_DETAIL_ID, 1);
  if (:allotment_part = 'ROOMS') then begin
    if (:cnt_rooms = 0) then exit;
    insert into ALLOTMENT_DETAIL (ID_ALLOTMENT_DETAIL, ID_ALLOTMENT, ID_ROOM_TYPE, FROM_DATE, TO_DATE,
           CNT_ROOMS)
    values (:new_id_allotment_detail, :id_allotment, :id_room_type, :from_date, :to_date,
           :cnt_rooms);
  end else begin
    insert into ALLOTMENT_RELEASE (ID_ALLOTMENT_RELEASE, ID_ALLOTMENT, ID_ROOM_TYPE, FROM_DATE, TO_DATE,
           DAYS_BEFORE, DAYS_AFTER)
    values (:new_id_allotment_detail, :id_allotment, :id_room_type, :from_date, :to_date,
           :active_frame_begin, :active_frame_end);
  end
  when any do begin
    execute procedure sys_dbg('occ ALLOTMENT_CREATE_DETAIL$INT cinit_date = '||coalesce(:init_date, 'null'));
    execute procedure sys_dbg('occ ALLOTMENT_CREATE_DETAIL$INT allotment_part = '||coalesce(:allotment_part, 'null'));
    exception;
  end
end
^

/* empty dependent procedure body */
/* Clear: ALLOTMENT_PHYS_REBUILD$INT for: ALLOTMENT_TMP_GET$INT */
ALTER PROCEDURE ALLOTMENT_PHYS_REBUILD$INT(IN_ID_HOTEL INTEGER = null,
IN_ID_ROOM_TYPE INTEGER = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ALLOTMENT_SET_DAYS$INT for: ALLOTMENT_TMP_GET$INT */
ALTER PROCEDURE ALLOTMENT_SET_DAYS$INT(ID_ALLOTMENT INTEGER,
ID_ROOM_TYPE INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ACTIVE_FRAME_BEGIN INTEGER,
ACTIVE_FRAME_END INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ALLOTMENT_SET_ROOMS$INT for: ALLOTMENT_TMP_GET$INT */
ALTER PROCEDURE ALLOTMENT_SET_ROOMS$INT(ID_ALLOTMENT INTEGER,
ID_ROOM_TYPE INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ROOMS_COUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ALLOTMENT_TMP_GET$INT) */
ALTER PROCEDURE ALLOTMENT_TMP_GET$INT(ID_ALLOTMENT_SESSION INTEGER,
ALLOTMENT_PART VARCHAR(20) = 'ROOMS')
 AS
declare variable dbg varchar(2000);
  declare variable tdiff_no_current numeric (15,4);
  declare variable tfor_date_current date;
  declare variable tfor_date_start date;
  declare variable tdiff_no_start numeric (15,4);
--  declare variable tfor_date_end date;
begin
--  ALLOTMENT_PART = {ROOMS || DAYS}
  tfor_date_start = null;
  tdiff_no_start = null;
--  tfor_date_end = null;
  for
    select TAD.DIFF_NO, TAD.FOR_DATE
    from   ALLOTMENT_DETAIL$TMP TAD
    where  TAD.ID_ALLOTMENT_SESSION = :id_allotment_session
    order by TAD.FOR_DATE asc
    into   :tdiff_no_current, :tfor_date_current
  do begin
    if (:tfor_date_start is null) then tfor_date_start = :tfor_date_current;
    if (:tdiff_no_start is null) then tdiff_no_start = :tdiff_no_current;

    if (:tdiff_no_start <> :tdiff_no_current) then begin
      execute procedure ALLOTMENT_CREATE_DETAIL$INT(:id_allotment_session, :tfor_date_start, :tfor_date_current - 1, 'start', :allotment_part);
      tdiff_no_start = :tdiff_no_current;
      tfor_date_start = :tfor_date_current;
    end
--    tfor_date_end = :tfor_date_current;
  end
  if (:tfor_date_start is not null) then begin
    execute procedure ALLOTMENT_CREATE_DETAIL$INT(:id_allotment_session, :tfor_date_start, :tfor_date_current, 'start', :allotment_part);
    delete from ALLOTMENT_DETAIL$TMP TAD where TAD.ID_ALLOTMENT_SESSION = :id_allotment_session;
  end
end
^

/* empty dependent procedure body */
/* Clear: ALLOTMENT_TMP_DAYS_CUT$INT for: ALLOTMENT_TMP_SET$INT */
ALTER PROCEDURE ALLOTMENT_TMP_DAYS_CUT$INT(ID_ALLOTMENT INTEGER,
ID_ROOM_TYPE INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_ALLOTMENT_SESSION INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ALLOTMENT_TMP_ROOMS_CUT$INT for: ALLOTMENT_TMP_SET$INT */
ALTER PROCEDURE ALLOTMENT_TMP_ROOMS_CUT$INT(ID_ALLOTMENT INTEGER,
ID_ROOM_TYPE INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_ALLOTMENT_SESSION INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ALLOTMENT_TMP_SET$INT) */
ALTER PROCEDURE ALLOTMENT_TMP_SET$INT(ID_ALLOTMENT_SESSION INTEGER,
ID_ALLOTMENT INTEGER,
ID_ROOM_TYPE INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
CNT_ROOMS INTEGER,
ACTIVE_FRAME_BEGIN INTEGER = 0,
ACTIVE_FRAME_END INTEGER = 0,
IS_ADDITION INTEGER = 0)
 AS
declare variable dbg varchar(2000);
  declare variable for_date date;
  declare variable tad_dbkey char(8);
  declare variable cnt_old_rooms integer;
  declare variable seq bigint;
begin
  active_frame_begin = coalesce(:active_frame_begin, 0);
  active_frame_end = coalesce(:active_frame_end, 0);
  seq = gen_id(GEN_SEQ_ID, 1);
  for
    select SLP.OUT_DATE
    from   ALLOTMENT_LOOP_PERIOD(:from_date, :to_date) SLP
    into   :for_date
  do begin
    if (:for_date = '01.01.1500') then begin
      if (:is_addition = 0) then begin
        delete from ALLOTMENT_DETAIL$TMP T
        where  T.ID_ALLOTMENT_SESSION = :id_allotment_session
               and T.FOR_DATE < :to_date;
      end else begin
        update ALLOTMENT_DETAIL$TMP T
        set    T.CNT_ROOMS = T.CNT_ROOMS + :cnt_rooms,
               T.SEQ = :seq
        where  T.ID_ALLOTMENT_SESSION = :id_allotment_session
               and T.FOR_DATE < :to_date
               and T.FOR_DATE  <> :for_date;
      end
    end else if (:for_date = '01.01.2500') then begin
      if (:is_addition = 0) then begin
        delete from ALLOTMENT_DETAIL$TMP T
        where  T.ID_ALLOTMENT_SESSION = :id_allotment_session
               and T.FOR_DATE > :from_date;
      end else if (:from_date <> '01.01.1500') then begin
        update ALLOTMENT_DETAIL$TMP T
        set    T.CNT_ROOMS = T.CNT_ROOMS + :cnt_rooms,
               T.SEQ = :seq
        where  T.ID_ALLOTMENT_SESSION = :id_allotment_session
               and T.FOR_DATE > :from_date
               and T.FOR_DATE  <> :for_date;
      end
    end

    tad_dbkey = null;
    select TAD.RDB$DB_KEY
    from   ALLOTMENT_DETAIL$TMP TAD
    where  TAD.ID_ALLOTMENT_SESSION = :id_allotment_session
           and TAD.FOR_DATE = :for_date
    into   :tad_dbkey;

    if (:tad_dbkey is null) then begin
      cnt_old_rooms = null;
      if (:is_addition = 1) then begin
        -- INITIALIZE FROM THE LEFT, BECAUSE OF THE DESCENDING ORDER OF THE PERIODS
        select first 1 AD.CNT_ROOMS - iif(AD.SEQ = :seq, :cnt_rooms, 0)
        from   ALLOTMENT_DETAIL$TMP AD
        where  AD.ID_ALLOTMENT_SESSION = :id_allotment_session
               and AD.FOR_DATE < :for_date
        order by AD.FOR_DATE desc
        into   :cnt_old_rooms;
      end
      insert into ALLOTMENT_DETAIL$TMP (ID_ALLOTMENT_SESSION, ID_ALLOTMENT, ID_ROOM_TYPE,
             FOR_DATE, CNT_ROOMS, ACTIVE_FRAME_BEGIN, ACTIVE_FRAME_END, SEQ)
      values (:id_allotment_session, :id_allotment, :id_room_type,
             :for_date, coalesce(:cnt_old_rooms, 0) + :cnt_rooms, :active_frame_begin, :active_frame_end, :seq);
    end else
      update ALLOTMENT_DETAIL$TMP TAD
      set    TAD.CNT_ROOMS = iif(:is_addition = 0, :cnt_rooms, TAD.CNT_ROOMS + :cnt_rooms),
             TAD.ACTIVE_FRAME_BEGIN = :active_frame_begin,
             TAD.ACTIVE_FRAME_END = :active_frame_end,
             TAD.SEQ = :seq
      where  TAD.RDB$DB_KEY = :tad_dbkey;
  end
end
^

/* Alter (AVAILABILITY_OCCUP_SMALL$EXC) */
ALTER PROCEDURE AVAILABILITY_OCCUP_SMALL$EXC(ID_ALLOTMENT INTEGER)
 RETURNS(FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_HOTEL INTEGER,
CNT_ROOMS INTEGER)
 AS
declare variable tmp_from_date date;
declare variable tmp_to_date date;
declare variable tmp_for_date date;
declare variable tmp_id_room_type integer;
declare variable tmp_available integer;
begin
  --check if allotment is physical
  select h.ID_HOTEL
  from   HOTEL h
  where  h.ID_PHYSICAL_ALLOTMENT = :ID_ALLOTMENT
  into   :ID_HOTEL;
  if (:ID_HOTEL is null) then exit;

  -- get min allotment date
  select min(ad.FROM_DATE)
  from   ALLOTMENT_DETAIL ad
  where  ad.ID_ALLOTMENT = :ID_ALLOTMENT
  into   :tmp_from_date;

  if (:tmp_from_date is null) then begin
    tmp_from_date = 'now';
  end

  tmp_to_date = 'now';
  tmp_to_date = :tmp_to_date + 1068; -- 3 years

  FROM_DATE = null;
  TO_DATE = null;
  ID_ROOM_TYPE = null;
  CNT_ROOMS = null;
  -- group data in periods by room type and availability
  for
    select ac.FOR_DATE, ac.ID_ROOM_TYPE, ac.AVAILABLE
    from   AVAILABILITY_OCCUP_SMALL$INT(:tmp_from_date, :tmp_to_date, :ID_HOTEL, 1) ac
    order by ID_ROOM_TYPE, FOR_DATE
    into   :tmp_for_date, :tmp_id_room_type, :tmp_available
  do begin
    if (:ID_ROOM_TYPE is null) then begin
      ID_ROOM_TYPE = :tmp_id_room_type;
    end
    if (:FROM_DATE is null) then begin
      FROM_DATE = :tmp_for_date;
    end
    if (:CNT_ROOMS is null) then begin
      CNT_ROOMS = :tmp_available;
    end

    if ((:ID_ROOM_TYPE <> :TMP_ID_ROOM_TYPE) or (:CNT_ROOMS <> :TMP_AVAILABLE)) then begin
      suspend;
      ID_ROOM_TYPE = :tmp_id_room_type;
      FROM_DATE = :tmp_for_date;
      CNT_ROOMS = :tmp_available;
    end

    TO_DATE = :tmp_for_date;
  end

  if (:ID_ROOM_TYPE is not null) then begin
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUP_SMALL$EXC for: AVAILABILITY_OCCUP_SMALL$INT */
ALTER PROCEDURE AVAILABILITY_OCCUP_SMALL$EXC(ID_ALLOTMENT INTEGER)
 RETURNS(FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_HOTEL INTEGER,
CNT_ROOMS INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: HOTEL_GET_FREE$CHM for: AVAILABILITY_OCCUP_SMALL$INT */
ALTER PROCEDURE HOTEL_GET_FREE$CHM(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER)
 RETURNS(FOR_DATE DATE,
AVAILABLE INTEGER,
OCCUPIED INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: OCCUPANCY_OVERBOOK_MAX$INT for: AVAILABILITY_OCCUP_SMALL$INT */
ALTER PROCEDURE OCCUPANCY_OVERBOOK_MAX$INT(FROM_DATE DATE,
TO_DATE DATE,
ID_ALLOTMENT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_AGENT INTEGER = null)
 RETURNS(MAX_BOOKDATE DATE,
MAX_BOOKROOMS INTEGER,
MIN_AVAILABLE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PRODUCT_AVAILABILITY$AVL for: AVAILABILITY_OCCUP_SMALL$INT */
ALTER PROCEDURE PRODUCT_AVAILABILITY$AVL(ID_CHANNEL INTEGER,
ID_HOTEL INTEGER,
DATE_FROM DATE,
DATE_TO DATE,
RATES VARCHAR(255),
ROOMTYPES VARCHAR(255))
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_TAR_HEAD INTEGER,
ROOM_STATUS INTEGER,
RATE_STATUS INTEGER,
PRODUCT_STATUS INTEGER,
AVAILABLE_ROOMS INTEGER,
MIN_LOS INTEGER,
MAX_LOS INTEGER,
IS_PUBLIC SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_TYPE_GET_FREE$CHM for: AVAILABILITY_OCCUP_SMALL$INT */
ALTER PROCEDURE ROOM_TYPE_GET_FREE$CHM(FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM_TYPE INTEGER)
 RETURNS(FOR_DATE DATE,
AVAILABLE INTEGER,
OCCUPIED INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_TYPE_GET_FREE_ALL$CHM for: AVAILABILITY_OCCUP_SMALL$INT */
ALTER PROCEDURE ROOM_TYPE_GET_FREE_ALL$CHM(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER)
 RETURNS(FOR_DATE DATE,
AVAILABLE INTEGER,
OCCUPIED INTEGER,
ID_ROOM_TYPE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (AVAILABILITY_OCCUP_SMALL$INT) */
ALTER PROCEDURE AVAILABILITY_OCCUP_SMALL$INT(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER,
SUBSTRACT_ONLY_OOI INTEGER)
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
CAPACITY INTEGER,
OCCUPIED INTEGER,
AVAILABLE INTEGER)
 AS
declare variable id_helper_session integer;
declare variable id_inventory_allotment integer;
declare variable id_external_occupancy_allotment integer;
begin
  /*  This procedure is short version from  availability_occupancy$avl */
  /*  its DOESNT take into hand contingent and booking positions and   */
  /*  DOESNT split data by agents                                     */
  /*  It suspends data                                                 */

  /* substract_only_ooi = 0 - will return Inventory - OOI - CheckedIn - Confirmed - NotConfirmed */
  /* substract_only_ooi = 1 - will return only Inventory - OOI                                   */
  /* If in hotel exists id_external_occupancy_allotment this allotment is take in to consideration as occupancy */

  id_helper_session = gen_id(SELECTION_GEN, 1);

  /* put occupancy in helper tmp table*/
  /* Inventory - OOI - CheckedIn - Confirmed - NotConfirmed*/
  if (:substract_only_ooi = 0) then begin
    for
      select RM.BUSY_DATE, RM.ID_ROOM_TYPE, count(distinct RM.ID_ROOM)
      from   ROOM_MAGIC RM
             /*left outer join ROOM_PERIOD$PMS RP on RP.ID_ROOM = rm.ID_ROOM
                                        and RM.BUSY_DATE between RP.FROM_DATE and RP.TO_DATE
                                        and RP.IS_AVAILABLE = 1*/
      where  RM.BUSY_DATE between :from_date and :to_date
             and RM.ID_HOTEL = :ID_HOTEL
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and RM.BUSY_TYPE is distinct from 'VALUE_RESERVS' /* skip waiting bookings */
             and RM.busy_group_type <> 18                      /* skip OOO              */
             /*and ((RM.ID_ROOM < 0) or (rp.IS_AVAILABLE is not distinct from 1))*/
             and rm.ROOM_STATUS is distinct from 'PRIVATE' -- replace previous clause
      group by 1,2
      into   :for_date, :id_room_type, :occupied
    do begin
      insert into TMP_SMALL_OCCUP (id_session, for_date, id_room_type,  occupied)
      values (:id_helper_session, :for_date, :id_room_type,  :occupied );
    end
  end else begin
    /* only inventory - OOI */
    for
      select RM.BUSY_DATE, RM.ID_ROOM_TYPE, count(distinct RM.ID_ROOM)
      from   ROOM_MAGIC RM
             /*left outer join ROOM_PERIOD$PMS RP on RP.ID_ROOM = rm.ID_ROOM
                                        and RM.BUSY_DATE between RP.FROM_DATE and RP.TO_DATE
                                        and RP.IS_AVAILABLE = 1     */
      where  RM.BUSY_DATE between :from_date and :to_date
             and RM.ID_HOTEL = :ID_HOTEL
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and RM.busy_group_type = 20  /* only OOI */
             and rm.DAY_ACTION = 'BLOCK'  /* only real blocks, without OWNER bookings */
             --and ((RM.ID_ROOM < 0) or (rp.IS_AVAILABLE is not distinct from 1))
             and rm.ROOM_STATUS is distinct from 'PRIVATE' -- replace previous clause
      group by 1,2
      into   :for_date, :id_room_type, :occupied
    do begin
      insert into TMP_SMALL_OCCUP (id_session, for_date, id_room_type,  occupied)
      values (:id_helper_session, :for_date, :id_room_type,  :occupied );
    end
  end

  /*Add occupancy given from external database - if set in hotel*/
  select h.ID_INVENTORY_ALLOTMENT, h.ID_EXTERNAL_OCCUPANCY_ALLOTMENT
  from   HOTEL h
  where  h.id_hotel = :id_hotel
  into   :id_inventory_allotment, :id_external_occupancy_allotment;

  if (:id_external_occupancy_allotment is not null) then begin
    insert into TMP_SMALL_OCCUP (id_session, for_date, id_room_type,  occupied)
    select :id_helper_session, abd.for_date, abd.id_room_type, abd.cnt_rooms
    from   ALLOTMENT_BYDATES$INT(:id_external_occupancy_allotment, :id_hotel, :from_date, :to_date) abd;
  end

  /*loop capacity join occupancy and suspend*/
  for
    select IBD.ID_ROOM_TYPE, IBD.for_date, IBD.CNT_ROOMS,
           (select sum(TSO.occupied)
            from   TMP_SMALL_OCCUP tso
            where  tso.id_session = :id_helper_session
                   and tso.for_date = IBD.for_date
                   and tso.id_room_type = IBD.id_room_type)
    from   ALLOTMENT_BYDATES$INT(:id_inventory_allotment, :ID_HOTEL, :FROM_DATE, :TO_DATE) IBD
    --group by 1, 2
    into   :ID_ROOM_TYPE, :FOR_DATE, :CAPACITY, :occupied
  do begin
    capacity = coalesce (:capacity, 0);
    occupied = coalesce (:occupied, 0);
    available = :capacity - :occupied;
    suspend;
  end
  /**/
  delete from TMP_SMALL_OCCUP tso where tso.id_session = :id_helper_session;
  /**/

end
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUP_PREPARE$AVL for: AVAILABILITY_OCCUPANCY$INT */
ALTER PROCEDURE AVAILABILITY_OCCUP_PREPARE$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS INTEGER,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUPANCY$AVL for: AVAILABILITY_OCCUPANCY$INT */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUPANCY_PREPARE for: AVAILABILITY_OCCUPANCY$INT */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY_PREPARE(FROM_DATE DATE,
TO_DATE DATE,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TEST_RATING for: AVAILABILITY_OCCUPANCY$INT */
ALTER PROCEDURE TEST_RATING RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (AVAILABILITY_OCCUPANCY$INT) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$INT(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
declare variable id_global_agent integer;
  declare variable for_date date;
  declare variable id_agent integer;
  declare variable id_room_type integer;
  declare variable g_capacity integer;
  declare variable bp_defined integer;
  declare variable c_defined integer;
  declare variable fdata integer;
  declare variable bp_is_released integer;
  declare variable c_is_released integer;
  declare variable gsts_in_house integer;
  declare variable gsts_come integer;
  declare variable gsts_gone integer;
  declare variable rooms_come integer;
  declare variable rooms_gone integer;
  declare variable id_hotel integer;
  declare variable id_b_allotment integer;
  declare variable id_c_allotment integer;
  declare variable ooo_rooms integer;
  declare variable ooi_rooms integer;
  declare variable sold_rooms integer;
  declare variable res_room_conf integer;
  declare variable res_room_notconf integer;
  declare variable res_room_wait integer;
begin
  /*  Description:   */
  HOTELS = coalesce(:HOTELS, '');
  ID_GLOBAL_AGENT = -100; /* HOLDS DATA GLOBAL FOR THE HOTEL */

  delete from SMART_OCCUP$TMP;

  for
    select RC.ID_ROOM_TYPE, RC.ID_HOTEL, RC.FOR_DATE, sum(RC.CNT_DEFINED)
    from   HOTEL_S H
           left outer join ALLOTMENT_GET$INT(H.ID_INVENTORY_ALLOTMENT, :FROM_DATE, :TO_DATE, null, 'PLAIN_PERIOD', :HOTELS) RC on 0=0
    where  ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
    group by 1, 2, 3
    into   :ID_ROOM_TYPE, :ID_HOTEL, :FOR_DATE, :G_CAPACITY
  do begin
    execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_global_agent, :id_room_type, :id_hotel, :g_capacity);
  end

  for
    select   RM.BUSY_DATE, RM.ID_ROOM_TYPE, RM.ID_HOTEL,
             iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (18,20), :ID_GLOBAL_AGENT, coalesce(RS.ID_AGENT, RM.ID_AGENT)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 18, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 20, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 24, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_CONFIRMED', RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_NOTCONFIRMED', RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_RESERVS', RM.ID_ROOM, null))
    from     ROOM_MAGIC RM
             join HOTEL_S H on H.ID_HOTEL = RM.ID_HOTEL
             left outer join ROOMS_SHARE RS on RS.ID_ROOM_SHARE = RM.ID_ROOM_MAGIC
    where    RM.BUSY_DATE between :from_date and :to_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
             /*and ((RM.ID_ROOM < 0) or (exists(
                 select *
                 from   ROOM_PERIOD$PMS P
                 where  P.ID_ROOM = RM.ID_ROOM
                        and RM.BUSY_DATE between P.FROM_DATE and P.TO_DATE
                        and P.IS_AVAILABLE = 1)))*/
             and rm.ROOM_STATUS is distinct from 'PRIVATE' -- replace previous clause
             and ((not (:RES_CONFIRMED = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_CONFIRMED'))
                  or (not (:RES_NOTCONFIRMED = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_NOTCONFIRMED'))
                  or (not (:RES_WAITING = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_RESERVS')))
    group by 1, 2, 3, 4
    into     :for_date, :id_room_type, :id_hotel, :id_agent,
             :ooo_rooms, :ooi_rooms, :sold_rooms, :res_room_conf, :res_room_notconf, :res_room_wait
  do begin
    execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
            null, :ooo_rooms, :ooi_rooms, null, :sold_rooms, :res_room_conf, :res_room_notconf, :res_room_wait);
  end

  if (:BOOKING_POSITIONS + :CONTINGENT > 0) then begin
    for
      select PA.ID_AGENT, PA.ID_BOOKING_POSITION, pa.ID_CONTINGENT
      from   PROFILE_AGENT PA
      where  (pa.ID_CONTINGENT is not null) or (pa.ID_BOOKING_POSITION is not null)
      into   :id_agent, :id_b_allotment, :id_c_allotment
    do begin
      for
        select al.for_date, al.id_room_type, al.id_hotel,
               sum(al.b_defined), max(al.b_is_released), sum(al.c_defined), max(al.c_is_released)
        from   (select ABP.FOR_DATE, ABP.ID_ROOM_TYPE, ABP.ID_HOTEL,
                       ABP.CNT_DEFINED as b_defined, ABP.IS_RELEASED as b_is_released, null as c_defined, null as c_is_released
                from   ALLOTMENT BA
                       left join ALLOTMENT_GET$INT(ba.ID_ALLOTMENT, :from_date, :to_date, null, 'RELEASES', :hotels) ABP on 1=1
                where  :BOOKING_POSITIONS = 1 and ba.ID_ALLOTMENT = :id_b_allotment
                union all
                select ACG.FOR_DATE, ACG.ID_ROOM_TYPE, ACG.ID_HOTEL, null, null, ACG.CNT_DEFINED, ACG.IS_RELEASED
                from   ALLOTMENT CA
                       left join ALLOTMENT_GET$INT(ca.ID_ALLOTMENT, :from_date, :to_date, null, '', :hotels) ACG on 1=1
                where  :CONTINGENT = 1 and CA.ID_ALLOTMENT = :id_c_allotment
               ) al
        where  al.for_date is not null
        group by 1, 2, 3
        into   :for_date, :id_room_type, :id_hotel,
               :bp_defined, :bp_is_released, :c_defined, :c_is_released
      do begin
        execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
                null, null, null, null, null, null, null, null, :c_defined, :c_is_released, :bp_defined, :bp_is_released);
      end
    end
  end

  if (:OVERBOOK = 1) then begin
    for
      select ACG.FOR_DATE, ACG.ID_ROOM_TYPE, ACG.ID_HOTEL, ACG.CNT_DEFINED
      from   HOTEL_S H
             left outer join ALLOTMENT_GET$INT(H.ID_OVERBOOK_ALLOTMENT, :FROM_DATE, :TO_DATE, null, '', :HOTELS) ACG on 0=0
      where  ACG.FOR_DATE is not null
             and ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
      into   :for_date, :id_room_type, :id_hotel, :fdata
    do begin
      execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
              null, null, null, :fdata);
    end
  end

  if (:FETCH_TOTALS = 1) then begin
    for
      select SOGT.BUSY_DATE, SOGT.ID_ROOM_TYPE, sum(SOGT.GSTS_COME+SOGT.GSTS_STAYOVER), sum(SOGT.GSTS_COME),
             sum(SOGT.GSTS_GONE), sum(SOGT.ROOMS_COME), sum(SOGT.ROOMS_GONE), SOGT.ID_HOTEL, SOGT.ID_AGENT
      from   REP_ROOM_STATUS_MOVE(:from_date, :to_date, -1, -1, -1, '', '', :hotels) SOGT
      group by SOGT.BUSY_DATE, SOGT.ID_ROOM_TYPE, SOGT.ID_HOTEL, SOGT.ID_AGENT
      into   :for_date, :id_room_type, :gsts_in_house, :gsts_come,
             :gsts_gone, :rooms_come, :rooms_gone, :id_hotel, :id_agent
    do begin
      execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
              null, null, null, null, null, null, null, null, null, null, null, null,
              :gsts_in_house, :gsts_come, :gsts_gone, :rooms_come, :rooms_gone);
    end
  end
end
^

/* Alter (AVAILABILITY_OCCUPANCY_PREPARE) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY_PREPARE(FROM_DATE DATE,
TO_DATE DATE,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
begin
  -- used from some reports - generate occupancy for selection
  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, 1, :OVERBOOK,
          :RES_CONFIRMED, :RES_NOTCONFIRMED, :RES_WAITING, :BOOKING_POSITIONS, :CONTINGENT, :HOTELS);
   
  execute procedure AVAILABILITY_OCCUPANCY_OPT$INT (:RELEASE_DATES, :OVERBOOK,
          :RES_CONFIRMED, :RES_NOTCONFIRMED, :RES_WAITING, :BOOKING_POSITIONS, :CONTINGENT);

  ID_OCCUPANCY_SESSION = current_transaction;
  suspend;
end
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_ANUL$DOC for: DEPOSIT_ANUL$INT */
ALTER PROCEDURE DEPOSIT_ANUL$DOC(ID_DEPOSIT INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_PAYMENT_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PAYMENT_DOC_DELETE$DOC for: DEPOSIT_ANUL$INT */
ALTER PROCEDURE PAYMENT_DOC_DELETE$DOC(ID_PAYMENT_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (DEPOSIT_ANUL$INT) */
ALTER PROCEDURE DEPOSIT_ANUL$INT(ID_DEPOSIT INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_PAYMENT_HEAD INTEGER)
 AS
declare variable id_doc_head integer;
  declare variable id_account integer;
  declare variable deposit_init_amount numeric(15,4);
  declare variable avail_value numeric(15,4);
  declare variable pay_currency varchar(3);
  declare variable payment_date date;
  declare variable dep_current_value numeric(15,4);
  declare variable sys_date date;
  declare variable id_hotel integer;
begin
  select D.ID_PAYMENT_HEAD, D.ID_ACCOUNT, P.PAY_VALUE_A, P.PAYMENT_DATE,
         D.RECEIVED_AMOUNT - d.DEDUCTED_AMOUNT as AVAIL_VALUE, D.ID_DOC_HEAD,
         D.PAY_CURRENCY, D.RECEIVED_AMOUNT
  from   DEPOSITS D
         join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_payment_head, :id_account, :deposit_init_amount, :payment_date,
         :avail_value, :id_doc_head, :pay_currency, :dep_current_value;

  if ((:dep_current_value is null) or (:dep_current_value < :deposit_init_amount)) then
    exception PAYMENT_ANNUL_EXCEPTION '-369';
    --'Part of deposit is refunded or transfered';

  if ((:avail_value is null) or (:avail_value < :deposit_init_amount)) then
    exception PAYMENT_ANNUL_EXCEPTION '-350';
    --'Part of deposit is used into document.';

  if (:id_doc_head is not null) then
    exception PAYMENT_ANNUL_EXCEPTION '-351';
    --'Can not storno deposit, because has invoice for it. First - storno invoice.';

  select A.ID_HOTEL
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :id_hotel;

  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) SD
  into   :SYS_DATE;

  if (:sys_date > :payment_date) then
    exception PAYMENT_ANNUL_EXCEPTION '-349';
    -- Can not void deposit payment for previous date ! May refund it! It's very important for payments control!!!

  execute procedure PAYMENT_ANUL$INT (:ID_PAYMENT_HEAD, :DESCRIPTION);

  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'ANNUL', f_character(29) || formatfloat(:deposit_init_amount, 'F;0.00') || ' ' || :PAY_CURRENCY || f_character(28) || :DESCRIPTION);

end
^

/* Alter (DEPOSIT_REFUND$DOC) */
ALTER PROCEDURE DEPOSIT_REFUND$DOC(ID_DEPOSIT INTEGER,
REFUND_AMOUNT NUMERIC(15,4),
REFUND_CURRENCY VARCHAR(3),
ID_PAY_DOC_TYPE INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_REFUND_PAYMENT INTEGER,
ID_STORNO_DOC INTEGER)
 AS
declare variable no_use varchar(2000);
  declare variable id_account integer;
  declare variable avail_value numeric(15,4);
  declare variable id_doc_head integer;
  declare variable pay_currency varchar(3);
  declare variable pay_rate numeric(15,6);
  declare variable sys_date date;
  declare variable round_to numeric(15,4);
  declare variable p_dbkey char(8);
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable id_account_payment integer;
  declare variable id_doc_type integer;
  declare variable account_curr varchar(3);
  declare variable account_rate numeric(15,6);
  declare variable id_reserv_detail integer;
  declare variable is_posting_stopped integer;
  declare variable firm_data type of tnote_blob;
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_REFUND');

  select D.ID_ACCOUNT, DH.ID_DOC, dh.ID_DOC_TYPE, c.ROUND_TO, d.ID_RESERV_DETAIL,
         D.AVAIL_VALUE, D.PAY_CURRENCY, D.PAY_RATE, A.ID_HOTEL, A.ACCOUNT_CURR
  from   DEPOSIT_AVAILABLE D
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join CURRS C on c.CURR = d.PAY_CURRENCY
         left outer join DOC_HEAD DH on DH.ID_DOC = D.ID_DOC_HEAD
                                        and DH.IS_STORNED = 0
                                        and DH.IS_ANUL = 0
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_account, :id_doc_head, :id_doc_type, :round_to, :id_reserv_detail,
         :avail_value, :pay_currency, :pay_rate, :id_hotel, :account_curr;

  if (:pay_currency is distinct from :refund_currency) then exception PAYMENT_EXCEPTION 'Currency mismatch!';

  if (round_f(:avail_value - :REFUND_AMOUNT, :round_to) < 0) then exception PAYMENT_EXCEPTION '-305';
  --'Issued value is more than available deposit amount.';

  select r.IS_POSTING_STOPPED
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :is_posting_stopped;

  if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';

  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET(:id_hotel) SD
  into   :sys_date;

  select first 1 ap.ACC_RATE
  from   ACCOUNT_PAYMENTS ap
  where  ap.ID_DEPOSIT = :ID_DEPOSIT
  order by ap.ID_ACCOUNT_PAYMENT asc
  into   :account_rate;

  execute procedure PAYMENT_CREATE$INT (:ID_PAY_DOC_TYPE, :ID_ACCOUNT, :SYS_DATE,
          -:REFUND_AMOUNT, :PAY_CURRENCY, :PAY_RATE, :account_curr, :account_rate, :DESCRIPTION)
  returning_values  (:id_refund_payment, :id_account_payment, :no_use);

  insert into DEPOSIT_REFUND (ID_DEPOSIT, ID_PAYMENT_HEAD, DESCRIPTION)
  values (:ID_DEPOSIT, :ID_REFUND_PAYMENT, :DESCRIPTION);

  update ACCOUNT_PAYMENTS AP
  set    AP.ID_DEPOSIT = :ID_DEPOSIT
  where  ap.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT;

  if (:ID_DOC_HEAD is not null) then begin
    execute procedure DOC_TYPE_EVALUATE$INT (:id_doc_type, :id_hotel, 0, :ID_REFUND_PAYMENT);

    execute procedure DOCUMENT_ADVANCE_STORNO$INT (:ID_DEPOSIT, :REFUND_AMOUNT, :DESCRIPTION)
    returning_values  (:ID_STORNO_DOC);

    execute procedure DOCUMENT_ATTACH_PAYMENT$INT (:ID_STORNO_DOC, :id_account_payment, :pay_rate, null)
    returning_values :no_use;
     
    update  PAYMENT_HEAD P
    set     P.ID_DOC_HEAD = :ID_STORNO_DOC
    where   P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT;

    execute procedure DOCUMENT_VALIDATE$DOC (:ID_STORNO_DOC)
    returning_values (:firm_data, :no_use, :no_use);
  end else begin
    select P.RDB$DB_KEY
    from   PAYMENT_HEAD P
    where  P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT
    into   :P_DBKEY;
     
    execute procedure PAYMENT_SET_NUMBER$INT (:P_DBKEY);
  end

  action_text = F_CHARACTER(29) || :REFUND_AMOUNT || ' ' || :PAY_CURRENCY;
  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'REFUND', :ACTION_TEXT);
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ADD_PAYMENT$DOC for: DOC_CHECK_FISCAL$INT */
ALTER PROCEDURE DOCUMENT_ADD_PAYMENT$DOC(ID_DOC_HEAD INTEGER,
ID_PAY_DOC_TYPE INTEGER,
PAY_VALUE NUMERIC(15,4),
PAY_CURRENCY VARCHAR(3),
DESCRIPTION VARCHAR(100))
 RETURNS(ID_PAYMENT_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_VALIDATE$DOC for: DOC_CHECK_FISCAL$INT */
ALTER PROCEDURE DOCUMENT_VALIDATE$DOC(ID_DOC_HEAD /* TYPE OF ID_REF */ INTEGER)
 RETURNS(FIRM_DATA /* TYPE OF TNOTE_BLOB */ BLOB SUB_TYPE 1,
WARN_CODE /* TYPE OF TRANGE */ INTEGER,
NEW_DOC_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOC_CHECK_FISCAL$INT) */
ALTER PROCEDURE DOC_CHECK_FISCAL$INT(DH_DBKEY CHAR(8))
 AS
declare variable max_is_fisc integer;
  declare variable dc_dbkey char(8);
begin
  select max(DTP.IS_FISC), max(dc.RDB$DB_KEY)
  from   DOC_HEAD$INT DH
         join DOC_COMPLETION dc on dc.ID_DOC_HEAD = dh.ID_DOC_HEAD
         left join DOCUMENT_PAYMENT PH on PH.ID_DOC_HEAD = DH.ID_DOC_HEAD
         left join DOC_TYPE DT on DT.ID_DOC_TYPE = PH.ID_DOC_TYPE
         left join DOC_TYPE_PAY DTP on DTP.ID_DOC_TYPE = DT.ID_DOC_TYPE
  where  DH.RDB$DB_KEY = :DH_DBKEY
         and DTP.DOC_DIRECTION = 0
         and PH.IS_STORNO = 0
  into   :max_is_fisc, :dc_dbkey;

  update DOC_COMPLETION Dc
  set    Dc.FISC_STATUS = coalesce(:MAX_IS_FISC, 0)
  where  Dc.RDB$DB_KEY = :dc_dbkey;
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ADD_DEF_PAYMENT$DOC for: DOCUMENT_ADD_PAYMENT$DOC */
ALTER PROCEDURE DOCUMENT_ADD_DEF_PAYMENT$DOC(ID_DOC_HEAD INTEGER,
ID_PAY_DOC_TYPE INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (DOCUMENT_ADD_PAYMENT$DOC) */
ALTER PROCEDURE DOCUMENT_ADD_PAYMENT$DOC(ID_DOC_HEAD INTEGER,
ID_PAY_DOC_TYPE INTEGER,
PAY_VALUE NUMERIC(15,4),
PAY_CURRENCY VARCHAR(3),
DESCRIPTION VARCHAR(100))
 RETURNS(ID_PAYMENT_HEAD INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_account integer;
  declare variable doc_date date;
  declare variable pay_rate numeric(15,6);
  declare variable acc_curr varchar(3);
  declare variable acc_rate numeric(15,6);
  declare variable id_doc_contragent integer;
  declare variable is_taxable integer;
  declare variable id_tax_policy integer;
  declare variable dh_dbkey char(8);
  declare variable id_account_payment integer;
  declare variable id_doc_type integer;
  declare variable id_hotel integer;
begin
  select D.ID_ACCOUNT, D.DOC_DATE,
         A.ACCOUNT_CURR, D.DOC_RATE / D.DOC_ACC_RATE,
         D.ID_DOC_CONTRAGENT, A.ID_TAX_POLICY, D.RDB$DB_KEY,
         D.ID_DOC_TYPE, a.ID_HOTEL
  from   DOC_HEAD$INT D
         join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :id_account, :doc_date,
         :acc_curr, :acc_rate, :id_doc_contragent, :id_tax_policy, :dh_dbkey,
         :id_doc_type, :id_hotel;

  if (exists (select dtp.ID_DOC_TYPE
              from   DOC_TYPE_PAY_RESTRICT dtp
              where  dtp.ID_DOC_TYPE = :id_doc_type
                     and dtp.ID_PAY_DOC_TYPE = :ID_PAY_DOC_TYPE)) then
    exception DOCUMENT_EXCEPTION '-1048';

  if (not exists (select dt.ID_DOC_TYPE
                  from   DOC_TYPE DT
                  where  dt.ID_DOC_TYPE = :ID_PAY_DOC_TYPE
                         and dt.ID_HOTEL = :id_hotel)) then
    exception DOCUMENT_EXCEPTION '-1049';

  execute procedure DOCUMENT_CURR_RATE_GET$INT (:ID_DOC_HEAD, :PAY_CURRENCY)
  returning_values  (:pay_rate, :dbg);

  if (:PAY_VALUE is null) then begin
    execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, :PAY_CURRENCY)
    returning_values  (:dbg, :dbg, :dbg, :dbg, :PAY_VALUE);
  end

  if (:PAY_VALUE = 0) then exit;

  execute procedure PAYMENT_CREATE$INT(:ID_PAY_DOC_TYPE, :id_account, :doc_date,
          :PAY_VALUE, :PAY_CURRENCY, :pay_rate, :acc_curr, :acc_rate, :DESCRIPTION)
  returning_values (:id_payment_head, :id_account_payment, :is_taxable);

  update PAYMENT_HEAD P
  set    P.ID_DOC_HEAD = :ID_DOC_HEAD,
         P.ID_DOC_CONTRAGENT = :id_doc_contragent
  where  P.ID_PAYMENT_HEAD = :id_payment_head;
   
  if (:is_taxable = 1) then begin
    execute procedure DOCUMENT_ADD_PAY_TAXES$INT (:ID_DOC_HEAD,
            :ID_PAYMENT_HEAD, :id_tax_policy, :doc_date);

    execute procedure DOCUMENT_SAVE_TOTAL$INT (:ID_DOC_HEAD)
    returning_values :dbg;
  end

  execute procedure DOCUMENT_ATTACH_PAYMENT$INT (:ID_DOC_HEAD, :id_account_payment, :pay_rate, null)
  returning_values :dbg;
   
  execute procedure DOC_CHECK_FISCAL$INT(:dh_dbkey);
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_CREATE$INT for: DOCUMENT_ADVANCE_PAYMENT$INT */
ALTER PROCEDURE DOCUMENT_CREATE$INT(DOC_SELECTED INTEGER,
ID_ACCOUNT INTEGER,
ID_DOC_TYPE INTEGER,
DOC_TYPE_NAME /* TYPE OF TOBJECT_NAME */ VARCHAR(50),
DOC_DATE DATE,
DOC_CURR VARCHAR(3),
ID_BASE_DOC INTEGER,
TAX_EVENT_DATE DATE,
IS_PROFORMA /* TLOGICAL */ SMALLINT,
ID_ADVANCE_PAYMENT /* ID_REF */ INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER,
DOC_SUB_TYPE SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOCUMENT_ADVANCE_PAYMENT$INT) */
ALTER PROCEDURE DOCUMENT_ADVANCE_PAYMENT$INT(ID_DOC_HEAD INTEGER,
ID_PAYMENT_HEAD INTEGER,
ACC_RATE NUMERIC(15,6))
 AS
declare variable id_deposit integer;
  declare variable dep_curr varchar(3);
  declare variable pay_rate numeric(15,6);
  declare variable id_doc_line integer;
  declare variable doc_value numeric(15,4);
  declare variable init_pay_value numeric(15,4);
  declare variable deducted_value numeric(15,4);
  declare variable pay_round_to numeric(15,4);
  declare variable id_account_payment integer;
  declare variable initial_deposit_id integer;
  declare variable pay_value numeric(15,4);
  declare variable total_pay_value numeric(15,4);
  declare variable total_doc_value numeric(15,4);
  declare variable id_dep_doc integer;
begin
  total_pay_value = 0;
  total_doc_value = 0;
  for
    select D.ID_DEPOSIT, D.PAY_CURRENCY, d.INIT_PAY_AMOUNT, d.DEDUCTED_AMOUNT, d.ID_DOC_HEAD
    from   DEPOSITS D
    where  d.ID_PAYMENT_HEAD = :id_payment_head
    order by d.ID_DEPOSIT asc
    into   :id_deposit, :dep_curr, :init_pay_value, :deducted_value, :id_dep_doc
  do begin
    initial_deposit_id = coalesce(:initial_deposit_id, :id_deposit);
    if (coalesce(:deducted_value, 0) > 0) then
      exception DOCUMENT_EXCEPTION '-350';

    if (:id_dep_doc is not null) then
      exception DOCUMENT_EXCEPTION '-364';

    if (:pay_rate is null) then
      execute procedure DOCUMENT_CURR_RATE_GET$INT (:ID_DOC_HEAD, :dep_curr)
      returning_values  (:pay_rate, :pay_round_to);
    /*
    if (round_f(:dep_value, :pay_round_to) <= 0) then
      exception DOCUMENT_EXCEPTION 'Unavailable payment amount!';
    */
    update ACCOUNT_PAYMENTS AP
    set    AP.ACC_AMOUNT = AP.PAY_AMOUNT * cast(:pay_rate / :acc_rate as double precision),
           Ap.ACC_RATE  = :acc_rate
    where  AP.ID_DEPOSIT = :id_deposit;

    select min(ap.ID_ACCOUNT_PAYMENT), sum(ap.PAY_AMOUNT)
    from   ACCOUNT_PAYMENTS AP
    where  AP.ID_DEPOSIT = :id_deposit
    into   :id_account_payment, :pay_value;
    total_pay_value = :total_pay_value + :pay_value;

    execute procedure DOCUMENT_ATTACH_PAYMENT$INT (:ID_DOC_HEAD, :id_account_payment, :pay_rate, :pay_value)
    returning_values (:doc_value);
    total_doc_value = :total_doc_value + :doc_value;
  end

  if (:total_pay_value <> 0) then begin
    if (round_f(:total_pay_value - :init_pay_value, :pay_round_to) <> 0) then
      exception DOCUMENT_EXCEPTION '-390' || f_character(31)
                || f_character(29) || formatfloat(:total_pay_value, 'F;0.00')
                || f_character(28) || formatfloat(:init_pay_value, 'F;0.00');
  
    execute procedure DOCUMENT_ADD_PAYMENT_LINE$INT (:initial_deposit_id, :ID_DOC_HEAD, :total_doc_value)
    returning_values  (:id_doc_line);

    update PAYMENT_HEAD P
    set    P.ID_DOC_HEAD = :ID_DOC_HEAD
    where  P.ID_PAYMENT_HEAD = :id_payment_head;
  end
end
^

/* Alter (DOCUMENT_ADVANCE_STORNO$INT) */
ALTER PROCEDURE DOCUMENT_ADVANCE_STORNO$INT(ID_DEPOSIT INTEGER,
PAY_AMOUNT NUMERIC(15,2),
DESCRIPTION VARCHAR(100))
 RETURNS(ID_STORNO_DOC INTEGER)
 AS
declare variable no_use varchar(2000);
  declare variable id_doc_head integer;
  declare variable doc_date date;
  declare variable doc_value numeric(15,4);
  declare variable pay_rate numeric(15,6);
  declare variable doc_rate numeric(15,6);
  declare variable id_vat_group integer;
  declare variable is_storned integer;
  declare variable is_full_storno integer;
  declare variable is_anul integer;
  declare variable id_doc_supplier integer;
  declare variable id_hotel integer;
  declare variable id_account integer;
  declare variable received_amount numeric(15,4);
  declare variable sec_gross_value numeric(15,4);
  declare variable nat_gross_value numeric(15,4);
  declare variable nat_round_to numeric(15,4);
  declare variable doc_round_to numeric(15,4);
  declare variable sec_round_to numeric(15,4);
  declare variable sec_curr_rate numeric(15,6);
  declare variable line_name varchar(100) ;
  declare variable id_service integer;
  declare variable id_doc_line integer;
  declare variable id_payment_head integer;
  declare variable sec_curr varchar(3);
  declare variable round_to numeric(15,4);
  declare variable tax_event_date date;
begin
  id_doc_head = null;
  select DH.ID_DOC, ph.PAY_RATE, DH.DOC_RATE, DH.IS_STORNED, DH.IS_ANUL,
         DH.ID_DOC_SUPPLIER, A.ID_HOTEL, A.ID_ACCOUNT, ph.ID_PAYMENT_HEAD, dh.TAX_EVENT_DATE
  from   DEPOSIT D
         join PAYMENT_HEAD PH on PH.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
         join DOC_HEAD DH on DH.ID_DOC = PH.ID_DOC_HEAD
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_doc_head, :pay_rate, :doc_rate, :is_storned, :is_anul,
         :id_doc_supplier, :id_hotel, :id_account, :id_payment_head, :tax_event_date;

  if (:id_doc_head is null) then EXIT; /* !?! */

  if (:is_anul = 1) then
    exception DOCUMENT_EXCEPTION '-352';
  if (:is_storned = 1) then
    exception MULTIPLE_STORNO_ON_DOC;

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values  (:doc_date);

  select sum(d.RECEIVED_AMOUNT), min(c.ROUND_TO)
  from   DEPOSITS D
         join CURRS c on c.CURR = d.PAY_CURRENCY
  where  D.ID_PAYMENT_HEAD = :id_payment_head
  into   :received_amount, :round_to;

  if (round_f(:received_amount, :round_to) = 0) then is_full_storno = 1;  -- Refund whole deposit payment
  else is_full_storno = 0;
   
  execute procedure DOC_SUPPLIER_GET_COPY$DOC (:id_doc_supplier)
  returning_values  (:id_doc_supplier);
   
  ID_STORNO_DOC = gen_id(DOC_SELECTED_GEN, 1);
  insert into DOC_HEAD$INT
         (ID_DOC_HEAD, ID_DOC_TYPE, ID_DOC_NUM, ID_ACCOUNT, DOC_CURRENCY, DOC_DATE,
         DOC_TYPE_NAME, IS_ANUL, IS_STORNED, DESCRIPTION,
         DOC_RATE, DOC_VALUE, DOC_VALUE_A, DOC_ACC_RATE, ID_BASE_DOC, FOR_DEPOSIT,
         ID_DOC_CONTRAGENT, ID_DOC_SUPPLIER, DOC_SUB_TYPE,
         IS_STORNO, SECOND_CURRENCY, SECOND_CURR_RATE, DOC_VALUE_ROUNDLESS)
  select :ID_STORNO_DOC, ID_DOC_TYPE, ID_DOC_NUM, :id_account, DOC_CURRENCY, :doc_date,
         DOC_TYPE_NAME, IS_ANUL, IS_STORNED, :DESCRIPTION,
         DOC_RATE, 0, 0, DOC_ACC_RATE, ID_BASE_DOC, FOR_DEPOSIT,
         ID_DOC_CONTRAGENT, :id_doc_supplier, 2,
         :is_full_storno, dh.SECOND_CURRENCY, dh.SECOND_CURR_RATE, dh.DOC_VALUE_ROUNDLESS
  from   DOC_HEAD$INT DH
  where  DH.ID_DOC_HEAD = :id_doc_head;

  execute procedure DOCUMENT_COMPLETE$INT (:ID_STORNO_DOC, :DOC_DATE, :TAX_EVENT_DATE, null);

  -- sum all invoice lines for this payment
  select min(dl.ID_SALE_TAXATION), min(dl.LINE_NAME), min(dl.ID_SERVICE),
         -sum(dl.SINGLE_VALUE * dl.QTY_POST), -sum(dl.NAT_GROSS_VALUE), -sum(dl.SEC_CURR_GROSS_VALUE)
  from   DEPOSIT d
         join DOC_LINE_DEP_VALUES DV on dv.ID_DEPOSIT = d.ID_DEPOSIT
         join DOC_LINE DL on dl.ID_DOC_LINE = dv.ID_DOC_LINE
         join DOC_HEAD$INT dh on dh.ID_DOC_HEAD = dl.ID_DOC_HEAD
  where  d.ID_PAYMENT_HEAD = :id_payment_head
         and dh.FOR_DEPOSIT = 1
         and dh.IS_ANUL = 0
  into   :id_vat_group, :line_name, :id_service, :doc_value, :nat_gross_value, :sec_gross_value;

  execute procedure DOCUMENT_CURRS_GET$INT (:ID_STORNO_DOC)
  returning_values (:no_use, :doc_rate, :doc_round_to, :no_use, :nat_round_to, :sec_curr, :sec_curr_rate, :sec_round_to);

  if (:is_full_storno = 0) then begin
    doc_value = -:PAY_AMOUNT * cast(:pay_rate / :doc_rate as double precision);
    nat_gross_value = round_f(:doc_value * :doc_rate, :nat_round_to);
    sec_gross_value = round_f(:doc_value * cast(:doc_rate / :sec_curr_rate as double precision), :sec_round_to);
  end

  execute procedure DOCUMENT_LINE_ADD$INT (:ID_STORNO_DOC, :id_service, :id_vat_group,
          :line_name, -1, :doc_date, :doc_date, :doc_date, null,
          1, :DOC_VALUE, round_f(:doc_value, :doc_round_to), :doc_round_to,
          :nat_gross_value, :nat_round_to, :sec_curr, :sec_gross_value, :sec_round_to,
          0, 1, 0)
  returning_values (:id_doc_line, :no_use, :no_use, :no_use);

  insert into DOC_LINE_DEP_VALUES (ID_DOC_LINE, ID_DEPOSIT)
  values (:id_doc_line, :ID_DEPOSIT);
  /*  */

  execute procedure DOCUMENT_SAVE_TOTAL$INT (:ID_STORNO_DOC)
  returning_values :no_use;

  if (:is_full_storno = 1) then begin
    update DOC_HEAD$INT D
    set    D.IS_STORNED = 1
    where  D.ID_DOC_HEAD = :id_doc_head;
  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ANUL$DOC for: DOCUMENT_AR_PAYMENTS_APPLY$INT */
ALTER PROCEDURE DOCUMENT_ANUL$DOC(ID_DOC_HEAD INTEGER,
ANUL_REASON VARCHAR(100),
MAKE_ANNUL_REPORT SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_DELETE$DOC for: DOCUMENT_AR_PAYMENTS_APPLY$INT */
ALTER PROCEDURE DOCUMENT_DELETE$DOC(ID_DOC_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (DOCUMENT_AR_PAYMENTS_APPLY$INT) */
ALTER PROCEDURE DOCUMENT_AR_PAYMENTS_APPLY$INT(DOC_DBKEY CHAR(8),
OPERATION VARCHAR(10),
THROW_EXCEPTION SMALLINT,
DESCRIPTION VARCHAR(255) = null)
 AS
declare variable pay_value numeric(15,4);
  declare variable pay_curr varchar(3);
  declare variable due_date date;
  declare variable doc_num varchar(20);
  declare variable doc_type_name varchar(50);
  declare variable id_base_doc integer;
  declare variable doc_date date;
  declare variable id_profile integer;
  declare variable id_hotel integer;
begin
  for
    select DP.PAY_AMOUNT, P.PAY_CURRENCY, P.DUE_DATE, A.ID_PROFILE,
           D.ID_BASE_DOC, D.DOC_NUM, D.DOC_DATE, D.DOC_TYPE_NAME, A.ID_HOTEL,
           coalesce(:operation,
                     case when D.IS_ANUL = 1 then 'anul'
                          when P.IS_STORNO = 1 then 'add_credit'
                          else 'add_owing'
                     end)
    from   DOC_HEAD$INT D
           join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
           join DOC_PAY_USAGE DP on DP.ID_DOC_HEAD = d.ID_DOC_HEAD
           join ACCOUNT_PAYMENTS AP on ap.ID_ACCOUNT_PAYMENT = dp.ID_ACCOUNT_PAYMENT
           join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = AP.ID_PAYMENT_HEAD
                                  and coalesce(p.ID_DOC_HEAD, d.ID_DOC_HEAD) = d.ID_DOC_HEAD
           left join DOC_TYPE_PAY dt on DT.ID_DOC_TYPE = P.ID_DOC_TYPE
    where  D.RDB$DB_KEY = :DOC_DBKEY
           and DT.IS_AR_DEBT = 1
           and DT.DOC_DIRECTION = 0 /* only income docs */
    into   :pay_value, :pay_curr, :due_date, :id_profile,
           :id_base_doc, :doc_num, :doc_date, :doc_type_name, :id_hotel, :operation
  do begin
    if (:DESCRIPTION is null) then begin
      description = :doc_type_name || ' ' || :doc_num || '/' || formatdate(:doc_date, 'D;dd.mm.yyyy');
    end

    if (:THROW_EXCEPTION = 1) then begin
      execute procedure AR_OWING_MODIFY$DOC (:id_base_doc, :id_profile,
              :pay_value, :pay_curr, :due_date, :description, :id_hotel, :operation);
    end else begin
      execute procedure AR_OWING_MODIFY$DOC (:id_base_doc, :id_profile,
              :pay_value, :pay_curr, :due_date, :description, :id_hotel, :operation);

      when any do exit;
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_INITIALIZE$DOC for: DOCUMENT_ATTACH_AVAIL_PAYS$INT */
ALTER PROCEDURE DOCUMENT_INITIALIZE$DOC(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
DOC_SELECTED /* TYPE OF ID */ INTEGER,
PROFORMA_NAME_PREFIX VARCHAR(30) = null)
 RETURNS(ID_DOC_HEAD INTEGER,
ID_HOTEL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOCUMENT_ATTACH_AVAIL_PAYS$INT) */
ALTER PROCEDURE DOCUMENT_ATTACH_AVAIL_PAYS$INT(ID_DOC_HEAD INTEGER,
ID_ACCOUNT INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_deposit integer;
  declare variable pay_curr varchar(3);
  declare variable dep_value numeric(15,4);
  declare variable rest_value numeric(15,4);
begin

  for
    select D.ID_DEPOSIT, D.PAY_CURRENCY, D.AVAIL_VALUE
    from   DEPOSIT_AVAILABLE D
    where  D.ID_ACCOUNT = :ID_ACCOUNT
    order by D.DATETIME_CREATED asc
    into   :ID_DEPOSIT, :PAY_CURR, :DEP_VALUE
  do begin

    execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, :PAY_CURR)
    returning_values  (:dbg, :dbg, :dbg, :dbg, :REST_VALUE);

    if (:REST_VALUE > 0) then begin
      DEP_VALUE = iif(:DEP_VALUE > :REST_VALUE, :REST_VALUE, :DEP_VALUE);
      execute procedure DOCUMENT_USE_DEPOSIT$DOC (:ID_DOC_HEAD, :ID_DEPOSIT, :DEP_VALUE);

   end else begin
      exit;
    end

    when exception DOCUMENT_EXCEPTION do post_event 'dummy';
  end

end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_USE_DEPOSIT$DOC for: DOCUMENT_ATTACH_PAYMENT$INT */
ALTER PROCEDURE DOCUMENT_USE_DEPOSIT$DOC(ID_DOC_HEAD INTEGER,
ID_DEPOSIT INTEGER,
DEPOSIT_AMOUNT NUMERIC(15,4))
 AS
 BEGIN EXIT; END
^

/* Alter (DOCUMENT_ATTACH_PAYMENT$INT) */
ALTER PROCEDURE DOCUMENT_ATTACH_PAYMENT$INT(ID_DOC_HEAD INTEGER,
ID_ACCOUNT_PAYMENT INTEGER,
PAY_CURR_RATE NUMERIC(15,6),
PAY_VALUE NUMERIC(15,4))
 RETURNS(DOC_VALUE NUMERIC(15,4))
 AS
declare variable doc_rate numeric(15,6);
  declare variable doc_curr varchar(3);
  declare variable rest_value numeric(15,4);
  declare variable doc_round_to numeric(15,4);
  declare variable pay_round_to numeric(15,4);
  declare variable pay_amount numeric(15,4);
  declare variable equal_pay_doc_rate double precision;
  declare variable id_deposit integer;
  declare variable id_reserv_detail integer;
begin
  if (:PAY_CURR_RATE is null) then exception DOCUMENT_EXCEPTION 'Unspecified payment currency rate!';

  select D.DOC_RATE, D.DOC_CURRENCY, C.ROUND_TO
  from   DOC_HEAD D
         join CURRS C on C.CURR = D.DOC_CURRENCY
  where  D.ID_DOC = :ID_DOC_HEAD
  into   :doc_rate, :doc_curr, :doc_round_to;

  select AP.PAY_AMOUNT, c.ROUND_TO, ap.ID_DEPOSIT
  from   ACCOUNT_PAYMENTS AP
         join PAYMENT_HEAD P on p.ID_PAYMENT_HEAD = ap.ID_PAYMENT_HEAD
         join CURRS C on C.CURR = p.PAY_CURRENCY
  where  aP.ID_ACCOUNT_PAYMENT = :ID_ACCOUNT_PAYMENT
  into   :pay_amount, :pay_round_to, :id_deposit;

  if (:id_deposit is not null) then begin
    select d.ID_RESERV_DETAIL
    from   DEPOSIT D
    where  d.ID_DEPOSIT = :id_deposit
    into   :id_reserv_detail;

    if (:id_reserv_detail is not null) then begin
      execute procedure RES_TAKE_POSTING_RESPONSIBILITY (:id_reserv_detail);
  
      when any do begin
        exception DOCUMENT_EXCEPTION 'Can not manipulate deposit!';
      end
    end
  end

  if (:PAY_VALUE is null) then PAY_VALUE = :pay_amount;

  select first 1 DV.PAYABLE_VALUE
  from   DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, :doc_curr, :doc_rate) DV
  into   :rest_value;

  execute procedure PAYMENT_EQUIVALENCE_CALC$INT (:PAY_CURR_RATE, :PAY_VALUE, :pay_round_to, :doc_rate, :doc_round_to, :rest_value)
  returning_values  (:DOC_VALUE, :equal_pay_doc_rate);
  doc_rate = :PAY_CURR_RATE / :equal_pay_doc_rate;

  insert into DOC_PAY_USAGE (ID_DOC_HEAD, ID_ACCOUNT_PAYMENT, PAY_AMOUNT, PAY_RATE,
         DOC_AMOUNT, DOC_RATE, EQUAL_PAY_DOC_RATE)
  values (:id_doc_head, :id_account_payment, :pay_value, :PAY_CURR_RATE,
         :DOC_VALUE, :doc_rate, :equal_pay_doc_rate);

end
^

/* Alter (DOCUMENT_CASH_STATUS) */
ALTER PROCEDURE DOCUMENT_CASH_STATUS(ID_DOC_HEAD INTEGER)
 RETURNS(IS_CASH SMALLINT)
 AS
begin
  IS_CASH = 0;
  select coalesce(max(pt.IS_CASH), 0)
  from   DOC_PAY_USAGE DP
         join ACCOUNT_PAYMENTS ap on ap.ID_ACCOUNT_PAYMENT = dp.ID_ACCOUNT_PAYMENT
         join PAYMENT_HEAD p on p.ID_PAYMENT_HEAD = ap.ID_PAYMENT_HEAD
         join PAYMENT_TYPE pt on pt.ID_PAYMENT_TYPE = p.ID_PAYMENT_TYPE
  where  dp.ID_DOC_HEAD = :ID_DOC_HEAD
         and coalesce(p.ID_DOC_HEAD, dp.ID_DOC_HEAD) = dp.ID_DOC_HEAD
  into   :IS_CASH;

  suspend;
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_RESET_TYPE$DOC for: DOCUMENT_CREATE$INT */
ALTER PROCEDURE DOCUMENT_RESET_TYPE$DOC(ID_DOC_HEAD INTEGER,
ID_DOC_TYPE INTEGER,
DOC_CURRENCY VARCHAR(3),
PROFORMA_NAME_PREFIX VARCHAR(30))
 AS
 BEGIN EXIT; END
^

/* Alter (DOCUMENT_CREATE$INT) */
ALTER PROCEDURE DOCUMENT_CREATE$INT(DOC_SELECTED INTEGER,
ID_ACCOUNT INTEGER,
ID_DOC_TYPE INTEGER,
DOC_TYPE_NAME TYPE OF TOBJECT_NAME,
DOC_DATE DATE,
DOC_CURR VARCHAR(3),
ID_BASE_DOC INTEGER,
TAX_EVENT_DATE DATE,
IS_PROFORMA TLOGICAL,
ID_ADVANCE_PAYMENT ID_REF)
 RETURNS(ID_DOC_HEAD INTEGER,
DOC_SUB_TYPE SMALLINT)
 AS
declare variable no_use varchar(255);
  declare variable acc_currency char(3);
  declare variable acc_curr_rate numeric(15,6);
  declare variable doc_curr_rate numeric(15,6);
  declare variable sec_curr_rate numeric(15,6);
  declare variable id_doc_num integer;
  declare variable id_hotel integer;
  declare variable second_currency varchar(3);
  declare variable currency_list varchar(1000);
begin
  /* FIND THE ACCOUNT CURRENCY ************************************************/
  select A.ACCOUNT_CURR, A.ID_HOTEL
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :acc_currency, :id_hotel;
  /* FIND THE DOCUMENT LOOKUPS FROM THE DOCUMENT TYPE *************************/
  select iif(:IS_PROFORMA = 1, dti.ID_PROFORMA_NUM, DT.ID_DOC_NUM), dti.SECOND_CURRENCY, dt.CURRENCY_LIST
  from   DOC_TYPE DT
         join DOC_TYPE_INV DTI on DTI.ID_DOC_TYPE = DT.ID_DOC_TYPE
  where  DT.ID_DOC_TYPE = :id_doc_type
         and DT.ID_HOTEL = :id_hotel
  into   :id_doc_num, :second_currency, :currency_list;

  if (:IS_PROFORMA = 1 and :ID_ADVANCE_PAYMENT is not null) then
     exception DOCUMENT_EXCEPTION '-392';
  if (:IS_PROFORMA = 1 and :id_doc_num is null) then
     exception DOCUMENT_EXCEPTION '-393';
  if (:id_doc_num is null) then
    exception DOCUMENT_EXCEPTION '-92' || f_character(31) || f_character(29) || :doc_type_name;
  /* CHECK DOC_TYPE CURRENCY RESTRICTIONS *************************************/
  if (:currency_list not containing :DOC_CURR) then
    exception CURRENCY_IS_NOT_SUPPORTED f_character (29) || :DOC_CURR || f_character (28) || :doc_type_name;
  /* GET ACTUAL CURRENCY RATES ************************************************/
  execute procedure DOCUMENT_CURR_RATE_GET$INT (:DOC_SELECTED, :acc_currency)
  returning_values  (:acc_curr_rate, :no_use);

  execute procedure DOCUMENT_CURR_RATE_GET$INT (:DOC_SELECTED, :DOC_CURR)
  returning_values  (:doc_curr_rate, :no_use);

  if (:second_currency is not null) then
    execute procedure DOCUMENT_CURR_RATE_GET$INT (:DOC_SELECTED, :second_currency)
    returning_values  (:sec_curr_rate, :no_use);
  /*****------------------------------------------------------------------*****/
  /*****                 CREATING THE NEW DOCUMENT                        *****/
  /*****              CREATING NEW RECORD IN DOC_HEAD                     *****/
  /*****                    AND NEW DOC LINES                             *****/
  /*****------------------------------------------------------------------*****/
  ID_DOC_HEAD = :DOC_SELECTED;
  ID_BASE_DOC = coalesce(:ID_BASE_DOC, :ID_DOC_HEAD);

  insert into DOC_HEAD$INT(ID_DOC_HEAD, ID_DOC_TYPE, DOC_SUB_TYPE, ID_ACCOUNT, DOC_DATE,
         DOC_CURRENCY, DOC_RATE, DOC_ACC_RATE, DOC_TYPE_NAME,
         DOC_VALUE, DOC_VALUE_A, DOC_VALUE_ROUNDLESS, ID_BASE_DOC, FOR_DEPOSIT,
         IS_STORNO, IS_STORNED, IS_ANUL, SECOND_CURRENCY, SECOND_CURR_RATE, ID_DOC_NUM)
  values (:id_doc_head, :id_doc_type, 0, :id_account, :DOC_DATE,
         :DOC_CURR, :doc_curr_rate, cast(:doc_curr_rate/:acc_curr_rate as double precision), :DOC_TYPE_NAME,
         0, 0, 0, :id_base_doc, iif(:ID_ADVANCE_PAYMENT is null,  0, 1),
         0, 0, 0, :second_currency, :sec_curr_rate, :id_doc_num);


  if (:IS_PROFORMA is distinct from 1) then begin
    execute procedure DOCUMENT_COMPLETE$INT (:ID_DOC_HEAD, :DOC_DATE, :TAX_EVENT_DATE, null);
  end

  if (:ID_ADVANCE_PAYMENT is null) then begin
    execute procedure DOCUMENT_ADD_SERVICES$INT (:ID_DOC_HEAD, :ID_ACCOUNT);

    execute procedure DOCUMENT_ADD_DISCOUNTS$INT(:ID_DOC_HEAD, :ID_ACCOUNT);

  end else begin
    execute procedure DOCUMENT_ADVANCE_PAYMENT$INT (:ID_DOC_HEAD, :ID_ADVANCE_PAYMENT, :acc_curr_rate);
  end

  execute procedure DOCUMENT_SAVE_TOTAL$INT (:ID_DOC_HEAD)
  returning_values :DOC_SUB_TYPE;

end
^

/* Alter (DOCUMENT_DELETE$DOC) */
ALTER PROCEDURE DOCUMENT_DELETE$DOC(ID_DOC_HEAD INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_account_post integer;
  declare variable id_doc integer;
  declare variable doc_num varchar(20);
  declare variable doc_type_name varchar(50);
  declare variable doc_date date;
  declare variable action_text varchar(255);
  declare variable id_base_doc integer;
  declare variable id_doc_num integer;
  declare variable num_dbkey char(8);
  declare variable doc_dbkey char(8);
  declare variable last_num integer;
  declare variable num integer;
  declare variable id_doc_line integer;
  declare variable for_deposit smallint;
begin

  select DH.ID_BASE_DOC
  from   DOC_HEAD$INT DH
  where  DH.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :id_base_doc;

  if (:id_base_doc is distinct from :ID_DOC_HEAD) then exception DOCUMENT_EXCEPTION '-342'; /* base doc is not selected to delete */

  for
    select D.ID_DOC_NUM, D.ID_DOC_HEAD, D.DOC_NUM, D.NUM, D.DOC_TYPE_NAME, D.DOC_DATE
    from   DOC_HEAD$INT D
    where  D.ID_BASE_DOC = :ID_DOC_HEAD
    order by D.ID_DOC_NUM asc, D.ID_DOC_HEAD desc
    into   :id_doc_num, :id_doc, :doc_num, :num, :doc_type_name, :doc_date
  do begin
    for
      select PV.ID_ACCOUNT_POST
      from   DOC_LINE dl
             join DOC_LINE_POST_VALUES pv on PV.ID_DOC_LINE = dl.ID_DOC_LINE
      where  DL.ID_DOC_HEAD = :id_doc
      order by Dl.ID_DOC_LINE desc
      into   :id_account_post
    do begin
      update ACCOUNT_POST AP
      set    AP.IN_DOC_QTY = 0,
             AP.IN_DOC_VALUE = 0,
             AP.AC = iif(AP.QTY_POST = 0, '10', '00'),
             AP.IS_ANUL = iif(AP.QTY_POST = 0, 1, 0),
             AP.ID_BASE_DOC = null
      where  AP.ID_ACCOUNT_POST = :id_account_post
             and AP.ID_BASE_DOC = :ID_DOC_HEAD;
    end
    /*   */
    action_text = f_character(29) || :doc_type_name || ' ' || :doc_num || '/' || formatdate(:doc_date, 'D;dd.mm.yyyy');
    execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :id_doc, 'DELETE', :action_text);

    /*ar*/
    select DH.RDB$DB_KEY, dh.FOR_DEPOSIT
    from   DOC_HEAD$INT DH
    where  DH.ID_DOC_HEAD = :id_doc
    into   :doc_dbkey, :for_deposit;

    execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT(:doc_dbkey, 'anul', 1, null);
    /*end ar*/
    if (:for_deposit = 1) then begin
      for
        select dl.ID_DOC_LINE
        from   DOC_LINE dl
        where  dl.ID_DOC_HEAD = :id_doc
        into   :id_doc_line
      do begin
        delete from DOC_LINE_DEP_VALUES dv
        where  dv.ID_DOC_LINE = :id_doc_line;
      end 
    end

    delete from PAYMENT_HEAD P
    where  P.ID_DOC_HEAD = :id_doc;

    delete from DOC_HEAD$INT dh
    where  dh.ID_DOC_HEAD = :id_doc;

    -- reset numerator if deleted document is the last
    select coalesce(max(d.NUM), 0)
    from   DOC_HEAD D
    where  D.ID_DOC_NUM = :id_doc_num
    into   :last_num;

    if (:last_num < :num) then begin
      select SN.RDB$DB_KEY
      from   SYSTEM_NUMERATOR SN
      where  SN.ID_NUMERATOR = :id_doc_num
      into   :num_dbkey;
  
      execute procedure SYSTEM_GEN_NUM$INT (:num_dbkey, :last_num)
      returning_values  (:dbg);
--        if (:err_code <> 0) then exception NUMERATOR_EXCEPTION;
    end

  end
  /*   */
  /* paranoid check  */
  if (exists (select d.ID_DOC_HEAD
              from   DOC_HEAD$INT d
              where  d.id_base_doc = :id_base_doc)) then exception DOCUMENT_EXCEPTION '-318';
end
^

/* Alter (DOCUMENT_DETACH_DEPOSIT$INT) */
ALTER PROCEDURE DOCUMENT_DETACH_DEPOSIT$INT(ID_DOC_HEAD INTEGER,
ID_DEPOSIT INTEGER,
ID_STORNO_DOC INTEGER = null)
 AS
declare variable id_doc_line integer;
  declare variable id_payment_head integer;
  declare variable is_anul integer;
  declare variable num integer;
  declare variable id_account_payment integer;
  declare variable is_storned integer;
  declare variable no_use varchar(255);
begin

  select D.ID_PAYMENT_HEAD, DH.IS_ANUL, DH.IS_STORNED, Dh.NUM
  from   DEPOSIT_DEDUCT D
         join DOC_HEAD DH on DH.ID_DOC = D.ID_DOC_USED
         join ACCOUNT A on A.ID_ACCOUNT = DH.ID_ACCOUNT
  where  D.ID_DEPOSIT = :ID_DEPOSIT
         and D.ID_DOC_USED = :ID_DOC_HEAD
  into   :id_payment_head, :is_anul, :is_storned, :num;

  if (:id_payment_head is null) then exit;

  if (:is_anul + :is_storned = 0) then begin
    /* in internal deposit detach, caused by changes on new document processing */
    if (:num is not null) then exception INTERNAL_DOC_EXCEPTION 'Cannot detach deposit from valid document!';

    for
      select ap.ID_ACCOUNT_PAYMENT
      from   ACCOUNT_PAYMENTS AP
             join DOC_PAY_USAGE DP on DP.ID_ACCOUNT_PAYMENT = ap.ID_ACCOUNT_PAYMENT
      where  dp.ID_DOC_HEAD = :ID_DOC_HEAD
             and ap.ID_DEPOSIT = :ID_DEPOSIT
      into   :id_account_payment
    do begin
      delete
      from    DOC_PAY_USAGE dp
      where   dp.ID_ACCOUNT_PAYMENT = :ID_ACCOUNT_PAYMENT
              and dp.ID_DOC_HEAD = :ID_DOC_HEAD;
    end

    if (:ID_DOC_HEAD > 0) then begin
      /* if id_doc_head is negative then it will be deleted after deposit detach */
      /* total update is needless in this case                                   */
      ID_DOC_LINE = null;
      select DL.ID_DOC_LINE
      from   DOC_LINE DL
             join DOC_LINE_DEP_VALUES DV on DV.ID_DOC_LINE = DL.ID_DOC_LINE
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
             and DV.ID_DEPOSIT = :ID_DEPOSIT
      into   :ID_DOC_LINE;
    
      if (:ID_DOC_LINE is not null) then begin
        delete from DOC_LINE DL
        where  DL.ID_DOC_LINE = :ID_DOC_LINE;
    
        execute procedure DOCUMENT_SAVE_TOTAL$INT (:ID_DOC_HEAD)
        returning_values :no_use;
      end
    end
  end else if (:is_storned = 1) then begin
    /* in case when document is storned */
    insert into DOC_PAY_USAGE (ID_DOC_HEAD, ID_ACCOUNT_PAYMENT, PAY_AMOUNT, PAY_RATE,
           DOC_AMOUNT, DOC_RATE, EQUAL_PAY_DOC_RATE)
    select :ID_STORNO_DOC, dp.ID_ACCOUNT_PAYMENT, -dp.PAY_AMOUNT, dp.PAY_RATE,
           -dp.DOC_AMOUNT, dp.DOC_RATE, dp.EQUAL_PAY_DOC_RATE
    from   DOC_PAY_USAGE DP
           join ACCOUNT_PAYMENTS AP on AP.ID_ACCOUNT_PAYMENT = dp.ID_ACCOUNT_PAYMENT
    where  DP.ID_DOC_HEAD = :ID_DOC_HEAD
           and ap.ID_DEPOSIT = :ID_DEPOSIT;
  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_BONUSPOINTS_SPEND for: DOCUMENT_GET_VALUE$INT */
ALTER PROCEDURE DOCUMENT_BONUSPOINTS_SPEND(ID_DOC_HEAD INTEGER,
BONUSPOINT_CNT INTEGER)
 RETURNS(DOC_REST_AMOUNT NUMERIC(15,4))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_GET_CURR_VALUE$DOC for: DOCUMENT_GET_VALUE$INT */
ALTER PROCEDURE DOCUMENT_GET_CURR_VALUE$DOC(ID_DOC_HEAD INTEGER,
PAY_CURR VARCHAR(3))
 RETURNS(ID_PAY_DOC_DEF INTEGER,
TOTAL_CURR VARCHAR(3),
TOTAL_RATE NUMERIC(15,6),
TOTAL_VALUE NUMERIC(15,4),
REST_VALUE NUMERIC(15,4))
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOCUMENT_GET_VALUE$INT) */
ALTER PROCEDURE DOCUMENT_GET_VALUE$INT(ID_DOC_HEAD INTEGER,
TARGET_CURR VARCHAR(3),
TARGET_RATE NUMERIC(15,6) = null)
 RETURNS(ID_PAY_DOC_DEF INTEGER,
TOTAL_CURR VARCHAR(3),
TOTAL_RATE NUMERIC(15,6),
TOTAL_VALUE NUMERIC(15,4),
PAYABLE_VALUE NUMERIC(15,4))
 AS
declare variable doc_curr varchar(3);
  declare variable doc_round_to numeric(15,4);
  declare variable target_round_to numeric(15,4);
  declare variable doc_rate numeric(15,6);
  declare variable pays_value numeric(15,4);
  declare variable used_dep_value numeric(15,4);
  declare variable ded_dep_value numeric(15,4);
  declare variable discounts numeric(15,4);
  declare variable is_dep_doc integer;
  declare variable id_account integer;
  declare variable doc_sub_type integer;
  declare variable dummy varchar(255);
begin
  select iif(round_f(D.DOC_VALUE_ROUNDLESS, c.ROUND_TO) = d.DOC_VALUE_A, d.DOC_VALUE_ROUNDLESS, d.DOC_VALUE_A),
         D.DOC_CURRENCY, D.DOC_RATE, D.FOR_DEPOSIT, D.ID_ACCOUNT, D.DOC_SUB_TYPE, c.ROUND_TO
  from   DOC_HEAD$INT D
         join DOC_TYPE DT on DT.ID_DOC_TYPE = D.ID_DOC_TYPE
         join CURRS c on C.CURR = d.DOC_CURRENCY
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :TOTAL_VALUE, :doc_curr, :doc_rate, :is_dep_doc, :id_account, :doc_sub_type, :doc_round_to;
   
  select sum(round_f(DD.FOOTER_VALUE, :doc_round_to))
  from   DOC_FOOTER DD
  where  DD.ID_DOC_HEAD = :ID_DOC_HEAD
         and DD.ID_DOC_LINE is null
  into   :discounts;

  select sum(round_f(P.DOC_AMOUNT, :doc_round_to))
  from   DOC_PAY_USAGE P
  where  P.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :pays_value;
  /*  */
  ded_dep_value = 0;  used_dep_value = 0;
  if (:is_dep_doc = 0) then begin
    select sum(round_f(DL.SINGLE_VALUE * DL.QTY_POST, :doc_round_to))
    from   DOC_LINE DL
           join DOC_LINE_DEP_VALUES DV on DV.ID_DOC_LINE = DL.ID_DOC_LINE
    where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
    into   :ded_dep_value;

   /* select sum(round_f(UD.USED_DOC_VALUE, :round_to))
    from   DEPOSIT_DEDUCT UD
    where  UD.ID_DOC_USED = :ID_DOC_HEAD
    into   :used_dep_value;  */
  end

  PAYABLE_VALUE = :TOTAL_VALUE
                  - coalesce(:ded_dep_value, 0)
                  - coalesce(:pays_value, 0)
                  - coalesce(:used_dep_value, 0)
                  + coalesce(:discounts, 0);

  if (:TARGET_CURR is null) then begin
    TOTAL_CURR = :doc_curr;
    TARGET_RATE = :doc_rate;
    target_round_to = :doc_round_to;
  end else begin
    TOTAL_CURR = :TARGET_CURR;
    if (:TARGET_RATE is null) then begin
      execute procedure DOC_GET_CURR_RATE$DOC (:ID_DOC_HEAD, :TOTAL_CURR)
      returning_values  (:TARGET_RATE);
    end

    select C.ROUND_TO
    from   CURRS C
    where  C.CURR = :TOTAL_CURR
    into   :target_round_to;
  end

  TOTAL_RATE = :TARGET_RATE;
  TOTAL_VALUE = round_f(:TOTAL_VALUE * cast(:doc_rate / :TARGET_RATE as double precision), :target_round_to);
  if ((round_f(:PAYABLE_VALUE, :doc_round_to) = 0) or (cast(abs(:PAYABLE_VALUE) as numeric(15,4)) = :doc_round_to/2)) then
    PAYABLE_VALUE = 0;
  else
    PAYABLE_VALUE = round_f(:PAYABLE_VALUE * cast(:doc_rate / :TARGET_RATE as double precision), :target_round_to);

  if (:doc_sub_type < 2) then begin
    execute procedure PAYMENT_GET_DEFAULT$INT (:id_account)
    returning_values  (:ID_PAY_DOC_DEF, :dummy);
  end

  suspend;
end
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_DOCUMENT_INITIALIZE$DOC for: DOCUMENT_INITIALIZE$DOC */
ALTER PROCEDURE DEPOSIT_DOCUMENT_INITIALIZE$DOC(ID_PAYMENT_HEAD INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER,
ID_HOTEL INTEGER,
ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TEST_DOC for: DOCUMENT_INITIALIZE$DOC */
ALTER PROCEDURE TEST_DOC(ID_ACCOUNT INTEGER,
DOC_SELECTED INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOCUMENT_INITIALIZE$DOC) */
ALTER PROCEDURE DOCUMENT_INITIALIZE$DOC(ID_ACCOUNT TYPE OF ID,
DOC_SELECTED TYPE OF ID,
PROFORMA_NAME_PREFIX VARCHAR(30) = null)
 RETURNS(ID_DOC_HEAD INTEGER,
ID_HOTEL INTEGER)
 AS
declare variable id_doc_type integer;
  declare variable id_base_doc integer;
  declare variable tax_event_date date;
  declare variable doc_date date;
  declare variable doc_curr varchar(3);
  declare variable id_doc_contragent integer;
  declare variable id_profile integer;
  declare variable doc_sub_type integer;
  declare variable firm_data blob sub_type 1 segment size 80 character set none;
  declare variable id_advance_payment integer;
  declare variable is_proforma tlogical;
  declare variable doc_type_name varchar(50);
begin
  is_proforma = iif(:PROFORMA_NAME_PREFIX is null, 0, 1);

  if (:IS_PROFORMA is distinct from 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_NOPAY_CREATE');
  end else begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('PROFORMA_CREATE');
  end

  select A.ID_HOTEL, A.ID_PROFILE, H.FIRM_DATA
  from   ACCOUNT A
         join HOTEL H on H.ID_HOTEL  = A.ID_HOTEL
  where  A.ID_ACCOUNT = :id_account
  into   :id_hotel, :id_profile, :firm_data;

  id_advance_payment = null;
  execute procedure DOCUMENT_CHECK_SELECTION$INT (:DOC_SELECTED, :ID_ACCOUNT)
  returning_values  (:id_doc_type, :id_base_doc, :doc_curr, :id_doc_contragent, :id_advance_payment);

  if (:is_proforma = 1 and :id_base_doc is not null) then exception DOCUMENT_EXCEPTION '-1062';

  if (:id_doc_type is null) then begin
    execute procedure DOC_TYPE_GET$INT (:id_hotel, :IS_PROFORMA, :id_advance_payment)
    returning_values (:id_doc_type);
  end

  execute procedure CURR_RATES_PREPARE$INT (:DOC_SELECTED, :ID_ACCOUNT, :doc_date);

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :doc_date;
  tax_event_date = :doc_date;
                                                    
  select coalesce(:doc_curr, DT.DOC_CURR),
         iif (:is_proforma = 1, substring(trim(:PROFORMA_NAME_PREFIX) || ' ' || dt.doc_type_name from 1 for 50), dt.DOC_TYPE_NAME)
  from   DOC_TYPE DT
  where  DT.ID_DOC_TYPE = :id_doc_type
  into   :doc_curr, :DOC_TYPE_NAME;

  execute procedure DOCUMENT_CREATE$INT (:DOC_SELECTED, :ID_ACCOUNT, :id_doc_type, :doc_type_name, :doc_date, :doc_curr, :id_base_doc, :tax_event_date, :is_proforma, :id_advance_payment)
  returning_values  (:ID_DOC_HEAD, :doc_sub_type);

  if (:ID_ADVANCE_PAYMENT is null and :IS_PROFORMA is distinct from 1 and :doc_sub_type < 2) then begin
    execute procedure DOCUMENT_ATTACH_AVAIL_PAYS$INT (:ID_DOC_HEAD, :ID_ACCOUNT);
  end

  if (:id_doc_contragent is not null) then begin
    execute procedure DOC_CONTRAGENT_INITIALIZE$DOC (:ID_DOC_HEAD, null, :id_doc_contragent);
  end else begin
    execute procedure DOC_CONTRAGENT_INITIALIZE$INT (:ID_DOC_HEAD, 0, :id_profile);
  end

  execute procedure DOC_SUPPLIER_SET$DOC (:ID_DOC_HEAD, :firm_data);

  when exception DOC_ON_EMPTY_SELECTION do begin
    ID_DOC_HEAD = null;
  end
end
^

/* Alter (DOCUMENT_PAY_TYPES) */
ALTER PROCEDURE DOCUMENT_PAY_TYPES(ID_DOC_HEAD INTEGER)
 RETURNS(PAY_TYPE_LIST VARCHAR(255),
PAY_TYPE_IDS VARCHAR(255))
 AS
declare variable pay_type varchar(50);
  declare variable id_pay_type integer;
begin
  PAY_TYPE_LIST = '';
  PAY_TYPE_IDS = '';
  for
    select distinct p.ID_PAYMENT_TYPE, PT.PAYMENT_TYPE
    from   DOCUMENT_PAYMENT p
           join PAYMENT_TYPE PT on PT.ID_PAYMENT_TYPE = P.ID_PAYMENT_TYPE
    where  P.ID_DOC_HEAD = :ID_DOC_HEAD
    into   :id_pay_type, :pay_type
  do begin
    PAY_TYPE_LIST = :PAY_TYPE_LIST || trim(iif(:PAY_TYPE_LIST <> '', ',', '')) || ' ' || :pay_type;
    PAY_TYPE_IDS = :PAY_TYPE_IDS || trim(iif(:PAY_TYPE_IDS <> '', ',', '')) || :id_pay_type;
  end 
  suspend;
end
^

/* Alter (DOCUMENT_RESET_TYPE$DOC) */
ALTER PROCEDURE DOCUMENT_RESET_TYPE$DOC(ID_DOC_HEAD INTEGER,
ID_DOC_TYPE INTEGER,
DOC_CURRENCY VARCHAR(3),
PROFORMA_NAME_PREFIX VARCHAR(30))
 AS
declare variable id_account integer;
  declare variable old_id_doc_type integer;
  declare variable id_doc_contragent integer;
  declare variable id_doc_supplier integer;
  declare variable is_deposit integer;
  declare variable old_doc_curr varchar(3);
  declare variable doc_date date;
  declare variable tax_event_date date;
  declare variable id_base_doc integer;
  declare variable dbg varchar(1000);
  declare variable d_dbkey char(8);
  declare variable bonuspoints integer;
  declare variable id_advance_payment integer;
  declare variable id_payment_head integer;
  declare variable id_hotel integer;
  declare variable is_proforma tlogical;
  declare variable doc_type_name varchar(50);
  declare variable doc_sub_type smallint;
begin
  is_proforma = iif(:PROFORMA_NAME_PREFIX is null, 0, 1);

  select D.ID_ACCOUNT, D.ID_DOC_TYPE, D.ID_DOC_CONTRAGENT, D.ID_DOC_SUPPLIER,
         D.FOR_DEPOSIT, D.DOC_CURRENCY, D.DOC_DATE, DC.TAX_EVENT_DATE,
         D.ID_BASE_DOC, D.RDB$DB_KEY, a.ID_HOTEL, d.DOC_SUB_TYPE
  from   DOC_HEAD$INT D
         join ACCOUNT A on a.ID_ACCOUNT = d.ID_ACCOUNT
         left outer join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :id_account, :old_id_doc_type, :id_doc_contragent, :id_doc_supplier,
         :is_deposit, :old_doc_curr, :doc_date, :tax_event_date,
         :id_base_doc, :d_dbkey, :id_hotel, :doc_sub_type;
  /***************/
  if (:doc_sub_type > 0) then exit; -- can't change type for credit or debit document
  /***************/
  if ((:old_id_doc_type <> :ID_DOC_TYPE) or (:old_doc_curr <> :DOC_CURRENCY)) then begin
    for
      select p.ID_PAYMENT_HEAD
      from   PAYMENT_HEAD p
      where  p.ID_DOC_HEAD = :ID_DOC_HEAD
      into   :id_payment_head
    do begin
      execute procedure DOC_TYPE_EVALUATE$INT (:ID_DOC_TYPE, :id_hotel, :is_proforma, :id_payment_head);
    end

    id_advance_payment = null;
    if (:is_deposit = 1) then begin
      select first 1 p.ID_PAYMENT_HEAD
      from   PAYMENT_HEAD p
      where  p.ID_DOC_HEAD = :ID_DOC_HEAD
      into   :id_advance_payment;

      update PAYMENT_HEAD DP
      set    DP.ID_DOC_HEAD = null
      where  DP.ID_DOC_HEAD = :ID_DOC_HEAD;
    end
    /* update old document with reverse ID, to be deleted on the end */
    update DOC_HEAD$INT OD
    set    OD.ID_DOC_HEAD = -OD.ID_DOC_HEAD
    where  OD.RDB$DB_KEY = :d_dbkey;
    /* recreate document */
    select dt.DOC_TYPE_NAME
    from   DOC_TYPE dt
    where  dt.ID_DOC_TYPE = :ID_DOC_TYPE
    into   :doc_type_name;

    execute procedure DOCUMENT_CREATE$INT (:ID_DOC_HEAD, :id_account, :ID_DOC_TYPE,
            substring(coalesce(:PROFORMA_NAME_PREFIX, '') || ' ' || :doc_type_name from 1 for 50),
            :doc_date, :DOC_CURRENCY, :id_base_doc, :tax_event_date, :is_proforma, :id_advance_payment)
    returning_values  (:dbg, :dbg);
    /* reuse bonuspoints discounts */
    for
      select DF.TAXABLE_VALUE
      from   DOC_FOOTER DF
      where  DF.ID_DOC_HEAD = -:ID_DOC_HEAD
             and DF.ID_TAX is null
      into   :bonuspoints
    do begin
      execute procedure DOCUMENT_BONUSPOINTS_SPEND (:ID_DOC_HEAD, :bonuspoints)
      returning_values (:dbg);
    end 
    /* reuse deposits and payments */
    if (:is_deposit = 0) then begin
      execute procedure DOCUMENT_REUSE_DEPOSITS$INT (-:ID_DOC_HEAD, :ID_DOC_HEAD);

      execute procedure DOCUMENT_REUSE_PAYMENTS$INT (-:ID_DOC_HEAD, :ID_DOC_HEAD);
    end
    /* get client and sipplier data */
    update DOC_HEAD$INT D
    set    D.ID_DOC_CONTRAGENT = :id_doc_contragent,
           D.ID_DOC_SUPPLIER = :id_doc_supplier
    where  D.ID_DOC_HEAD = :ID_DOC_HEAD;
    /* delete old document */
    delete from DOC_HEAD$INT D
    where  D.ID_DOC_HEAD = -:ID_DOC_HEAD;
    /*  */
  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_CLEAR_DEPOSITS$DOC for: DOCUMENT_REUSE_DEPOSITS$INT */
ALTER PROCEDURE DOCUMENT_CLEAR_DEPOSITS$DOC(ID_DOC_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (DOCUMENT_REUSE_DEPOSITS$INT) */
ALTER PROCEDURE DOCUMENT_REUSE_DEPOSITS$INT(OLD_ID_DOC_HEAD INTEGER,
NEW_ID_DOC_HEAD INTEGER)
 AS
declare variable ID_DEPOSIT integer;
declare variable DEPOSIT_AMOUNT numeric(15,4);
begin

  for
    select  D.ID_DEPOSIT, sum(D.USED_PAY_VALUE)
    from    DEPOSIT_DEDUCT D
    where   D.ID_DOC_USED = :OLD_ID_DOC_HEAD
    group by D.ID_DEPOSIT
    into    :ID_DEPOSIT, :DEPOSIT_AMOUNT
  do begin
    execute procedure DOCUMENT_DETACH_DEPOSIT$INT (:OLD_ID_DOC_HEAD, :ID_DEPOSIT);

    if (:NEW_ID_DOC_HEAD is not null) then begin
      execute procedure DOCUMENT_USE_DEPOSIT$DOC (:NEW_ID_DOC_HEAD, :ID_DEPOSIT, :DEPOSIT_AMOUNT);

      when exception DOCUMENT_EXCEPTION do post_event 'dummy';
    end
  end

end
^

/* Alter (DOCUMENT_REUSE_PAYMENTS$INT) */
ALTER PROCEDURE DOCUMENT_REUSE_PAYMENTS$INT(OLD_ID_DOC_HEAD INTEGER,
NEW_ID_DOC_HEAD INTEGER)
 AS
declare variable id_payment_head integer;
  declare variable id_account_payment integer;
  declare variable p_dbkey char(8);
  declare variable no_use varchar(255);
  declare variable pay_rate numeric(15,6);
begin
  for
    select AP.ID_ACCOUNT_PAYMENT, P.RDB$DB_KEY, ap.ID_PAYMENT_HEAD, p.PAY_RATE
    from   DOC_PAY_USAGE P
           join ACCOUNT_PAYMENTS AP on AP.ID_ACCOUNT_PAYMENT = p.ID_ACCOUNT_PAYMENT
    where  P.ID_DOC_HEAD = :OLD_ID_DOC_HEAD
    into   :id_account_payment, :p_dbkey, :id_payment_head, :pay_rate
  do begin
    delete from DOC_PAY_USAGE DP
    where  DP.RDB$DB_KEY = :p_dbkey;

    update PAYMENT_HEAD PH
    set    PH.ID_DOC_HEAD = :NEW_ID_DOC_HEAD
    where  PH.ID_PAYMENT_HEAD = :id_payment_head;
     
    execute procedure DOCUMENT_ATTACH_PAYMENT$INT (:NEW_ID_DOC_HEAD, :id_account_payment, :pay_rate, null)
    returning_values :no_use;
  end 
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_STORNO$DOC for: DOCUMENT_STORNO$INT */
ALTER PROCEDURE DOCUMENT_STORNO$DOC(ID_DOC_HEAD INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_STORNO_DOC INTEGER,
ID_HOTEL INTEGER,
ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOCUMENT_STORNO$INT) */
ALTER PROCEDURE DOCUMENT_STORNO$INT(ID_DOC_HEAD INTEGER,
DESCRIPTION VARCHAR(100),
STORNO_PAYMENTS SMALLINT)
 RETURNS(ID_STORNO_DOC INTEGER,
ID_HOTEL INTEGER)
 AS
declare variable id_deposit integer;
  declare variable id_account integer;
  declare variable is_storned integer;
  declare variable is_anul integer;
  declare variable doc_sub_type integer;
  declare variable id_doc_line integer;
  declare variable new_id_doc_line integer;
  declare variable post_value numeric(15,4);
  declare variable doc_value_a numeric(15,4);
  declare variable line_value numeric(15,4);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable doc_date date;
  declare variable id_doc_supplier integer;
  declare variable taxable_value numeric(15,4);
  declare variable tax_event_date date;
  declare variable doc_value_roundless double precision;
begin

  select D.ID_ACCOUNT, D.IS_STORNED, D.DOC_SUB_TYPE, D.IS_ANUL,
         A.ID_RESERV_DETAIL, D.ID_DOC_SUPPLIER, A.ID_HOTEL, d.TAX_EVENT_DATE
  from   DOC_HEAD D
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
  where  D.ID_DOC = :ID_DOC_HEAD
  into   :ID_ACCOUNT, :IS_STORNED, :DOC_SUB_TYPE, :IS_ANUL,
         :ID_RESERV_DETAIL, :ID_DOC_SUPPLIER, :ID_HOTEL, :tax_event_date;

  if (:DOC_SUB_TYPE <> 0) then
    exception DOCUMENT_EXCEPTION '-316';
  if (:IS_ANUL = 1) then
    exception DOCUMENT_EXCEPTION '-352';
  if (:IS_STORNED = 1) then
    exception MULTIPLE_STORNO_ON_DOC;

  execute procedure SYSTEM_DATE_GET(:ID_HOTEL)
  returning_values  (:DOC_DATE);

  ID_STORNO_DOC = gen_id(DOC_SELECTED_GEN, 1);

  execute procedure CURR_RATES_PREPARE$INT (:ID_STORNO_DOC, :ID_ACCOUNT, :DOC_DATE);

  execute procedure DOC_SUPPLIER_GET_COPY$DOC (:ID_DOC_SUPPLIER)
  returning_values  :ID_DOC_SUPPLIER;

  insert into DOC_HEAD$INT(ID_DOC_HEAD, ID_DOC_TYPE, DOC_SUB_TYPE, ID_ACCOUNT,
         DOC_CURRENCY, DOC_RATE, DOC_ACC_RATE, DOC_TYPE_NAME, ID_DOC_NUM, DOC_DATE,
         DOC_VALUE_A, DOC_VALUE, ID_BASE_DOC, FOR_DEPOSIT,
         ID_DOC_CONTRAGENT, ID_DOC_SUPPLIER, DESCRIPTION, IS_STORNO, TAXABLE_VALUE,
         SECOND_CURRENCY, SECOND_CURR_RATE, DOC_VALUE_ROUNDLESS)
  select :ID_STORNO_DOC, D.ID_DOC_TYPE, 2, D.ID_ACCOUNT,
         D.DOC_CURRENCY, D.DOC_RATE, D.DOC_ACC_RATE, DT.CREDIT_DOC_NAME, ID_DOC_NUM, :doc_date,
         0, D.DOC_VALUE, D.ID_BASE_DOC, D.FOR_DEPOSIT,
         D.ID_DOC_CONTRAGENT, :ID_DOC_SUPPLIER, :DESCRIPTION, 1, D.TAXABLE_VALUE,
         d.SECOND_CURRENCY, d.SECOND_CURR_RATE, d.DOC_VALUE_ROUNDLESS
  from   DOC_HEAD$INT D
         join DOC_TYPE_INV DT on DT.ID_DOC_TYPE = D.ID_DOC_TYPE
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD;

  execute procedure DOCUMENT_COMPLETE$INT (:ID_STORNO_DOC, :DOC_DATE, :TAX_EVENT_DATE, null);

  /* doc lines */
  POST_VALUE = 0;
  DOC_VALUE_A = 0;
  for
    select DL.ID_DOC_LINE, -(DL.SINGLE_VALUE * DL.QTY_POST)
    from   DOC_HEAD BD
           join DOC_LINE DL on BD.ID_DOC = DL.ID_DOC_HEAD
    where  BD.ID_BASE_DOC = :ID_DOC_HEAD
           and BD.IS_ANUL = 0
           and DL.ID_DOC_HEAD is distinct from :ID_STORNO_DOC
    order by DL.ID_DOC_LINE asc
    into   :ID_DOC_LINE, :LINE_VALUE
  do begin
    NEW_ID_DOC_LINE = gen_id(G_AUTO_INC_DOC_LINES, 1);
    insert into DOC_LINE(ID_DOC_LINE, ID_DOC_HEAD, DATE_POST, LINE_NAME,
           ID_SERVICE, QTY_POST, TO_DATE, FROM_DATE, VAT_PERCENT, ID_SALE_TAXATION,
           SINGLE_VALUE, SINGLE_WOT_VAT, WOT_VAT, WOT_DIFF,
           TAX_STATUS, IS_CORRECT, GROUP_TAG,
           ID_GUEST, ROOM_NAME, NAT_NET_VALUE, NAT_GROSS_VALUE, SEC_CURR_NET_VALUE, SEC_CURR_GROSS_VALUE)
    select :NEW_ID_DOC_LINE, :ID_STORNO_DOC, DL.DATE_POST, DL.LINE_NAME,
           DL.ID_SERVICE, DL.QTY_POST*(2*DL.IS_CORRECT-1), DL.TO_DATE, DL.FROM_DATE, DL.VAT_PERCENT, DL.ID_SALE_TAXATION,
           DL.SINGLE_VALUE*(1-2*DL.IS_CORRECT), DL.SINGLE_WOT_VAT*(1-2*DL.IS_CORRECT), -DL.WOT_VAT, DL.WOT_DIFF*(1-2*DL.IS_CORRECT),
           DL.TAX_STATUS, DL.IS_CORRECT, DL.GROUP_TAG,
           DL.ID_GUEST, DL.ROOM_NAME, -DL.NAT_NET_VALUE, -DL.NAT_GROSS_VALUE, -DL.SEC_CURR_NET_VALUE, -DL.SEC_CURR_GROSS_VALUE
    from   DOC_LINE DL
    where  DL.ID_DOC_LINE = :ID_DOC_LINE;

    insert into DOC_LINE_DISCOUNTED (ID_DOC_LINE, ID_DOC_DISCOUNT)
    select :NEW_ID_DOC_LINE, DLT.ID_DOC_DISCOUNT
    from   DOC_LINE_DISCOUNTED DLT
    where  DLT.ID_DOC_LINE = :ID_DOC_LINE;

    insert into DOC_LINE_POST_VALUES (
           ID_DOC_LINE, ID_ACCOUNT_POST,POST_RATE_IN_ACC, POST_RATE_IN_DOC,
           NET_RATE_DIFF, GROSS_RATE_DIFF, NET_ROUND_DIFF, GROSS_ROUND_DIFF,
           ID_MASTER_ADDINS, ID_PACK_SERVICE, IS_BASE, ACCOUNT_PRICE)
    select :NEW_ID_DOC_LINE, ID_ACCOUNT_POST, POST_RATE_IN_ACC, POST_RATE_IN_DOC,
           -NET_RATE_DIFF, -GROSS_RATE_DIFF, -NET_ROUND_DIFF, -GROSS_ROUND_DIFF,
           ID_MASTER_ADDINS, ID_PACK_SERVICE, IS_BASE, ACCOUNT_PRICE
    from   DOC_LINE_POST_VALUES PV
    where  PV.ID_DOC_LINE = :ID_DOC_LINE;

    if (row_count = 1) then POST_VALUE = :POST_VALUE + :LINE_VALUE;

    insert into DOC_LINE_DEP_VALUES (
           ID_DOC_LINE, DEP_RATE_IN_ACC, DEP_RATE_IN_DOC, ID_DEPOSIT)
    select :NEW_ID_DOC_LINE, DEP_RATE_IN_ACC, DEP_RATE_IN_DOC, ID_DEPOSIT
    from   DOC_LINE_DEP_VALUES DV
    where  DV.ID_DOC_LINE = :ID_DOC_LINE;

    insert into DOC_LINE_REV_DEDUCTION_TAX (ID_DOC_LINE, ID_SALE_TAX, TAX_NAME, TAX_UNIT, TAX_VALUE, NAT_TAX_VALUE)
    select :NEW_ID_DOC_LINE, rdt.ID_SALE_TAX, rdt.TAX_NAME, rdt.TAX_UNIT, -rdt.TAX_VALUE, -rdt.NAT_TAX_VALUE
    from   DOC_LINE_REV_DEDUCTION_TAX rdt
    where  rdt.ID_DOC_LINE = :id_doc_line;

    insert into DOC_FOOTER (
           ID_DOC_HEAD, ID_DOC_LINE, ID_TAX, TAX_ORDER, TAXABLE_VALUE, FOOTER_VALUE, DESCRIPTION)
    select :ID_STORNO_DOC, :NEW_ID_DOC_LINE, ID_TAX, TAX_ORDER, -TAXABLE_VALUE, -DF.FOOTER_VALUE, DF.DESCRIPTION
    from   DOC_FOOTER DF
    where  DF.ID_DOC_LINE = :ID_DOC_LINE;
    DOC_VALUE_A = :DOC_VALUE_A + :LINE_VALUE;
    /* payment footer lines ?!?!?!? */
  end
  /* totals */
  select -sum(d.DOC_VALUE), -sum(d.DOC_VALUE_A), -sum(d.DOC_VALUE_ROUNDLESS), -sum(d.TAXABLE_VALUE)
  from   DOC_HEAD$INT D
  where  D.ID_BASE_DOC = :ID_DOC_HEAD
         and D.IS_ANUL = 0
         and D.ID_DOC_HEAD is distinct from :ID_STORNO_DOC
  into   :POST_VALUE, :DOC_VALUE_A, :doc_value_roundless, :taxable_value;

  update DOC_HEAD$INT SD
  set    SD.DOC_VALUE = :POST_VALUE,
         SD.DOC_VALUE_A = :DOC_VALUE_A,
         sd.DOC_VALUE_ROUNDLESS = :doc_value_roundless,
         sd.TAXABLE_VALUE = :taxable_value
  where  SD.ID_DOC_HEAD = :ID_STORNO_DOC;

  insert into DOC_TAXES (ID_DOC_HEAD, ID_SALE_TAX, TAX_NAME, TAX_PERCENT, NONTAXABLE_VALUE, TAXABLE_VALUE, TAX_VALUE, TAXATION_REASON)
  select :ID_STORNO_DOC, DT.ID_SALE_TAX, DT.TAX_NAME, DT.TAX_PERCENT, -sum(DT.NONTAXABLE_VALUE), -sum(DT.TAXABLE_VALUE), -sum(DT.TAX_VALUE),
         DT.TAXATION_REASON
  from   DOC_HEAD D
         join DOC_TAXES DT on DT.ID_DOC_HEAD = D.ID_DOC
  where  D.ID_BASE_DOC = :ID_DOC_HEAD
         and D.IS_ANUL = 0
         and D.ID_DOC is distinct from :ID_STORNO_DOC
  group by DT.ID_SALE_TAX, DT.TAX_NAME, DT.TAX_PERCENT, DT.TAXATION_REASON;

  update DOC_HEAD$INT D
  set    D.IS_STORNED = 1
  where  D.ID_BASE_DOC = :ID_DOC_HEAD
         --and D.ID_DOC is distinct from :ID_STORNO_DOC
         and D.IS_ANUL = 0
         and d.DOC_SUB_TYPE < 2;

  /* discounts */
  insert into DOC_FOOTER (ID_DOC_HEAD, ID_TAX, ID_DOC_LINE, TAX_ORDER, DESCRIPTION, TAXABLE_VALUE, FOOTER_VALUE)
  select :ID_STORNO_DOC, DF.ID_TAX, null, DF.TAX_ORDER, DF.DESCRIPTION, sum(-DF.TAXABLE_VALUE), sum(-DF.FOOTER_VALUE)
  from   DOC_HEAD D
         join DOC_FOOTER DF on DF.ID_DOC_HEAD = D.ID_DOC
  where  DF.ID_DOC_HEAD = :ID_DOC_HEAD
         and DF.ID_DOC_LINE is null
  group by DF.ID_TAX, DF.DESCRIPTION, DF.TAX_ORDER;

  /* storno payments */
  if (:STORNO_PAYMENTS = 1/* and :for_deposit = 0*/) then begin
    execute procedure DOCUMENT_STORNO_PAYS_SET$DOC (:ID_STORNO_DOC);

    /* free deposits */
    for
      select D.ID_DEPOSIT
      from   DEPOSIT_DEDUCT D
      where  D.ID_DOC_USED = :ID_DOC_HEAD
      into   :ID_DEPOSIT
    do begin
      execute procedure DOCUMENT_DETACH_DEPOSIT$INT (:ID_DOC_HEAD, :ID_DEPOSIT, :ID_STORNO_DOC);
    end
  end

  if (:ID_RESERV_DETAIL is not null) then begin
    select RD.CHECK_STATUS
    from   RESERV_DETAIL RD
    where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :CHECK_STATUS;

    if (:CHECK_STATUS = 1) then begin
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, null, 1);
    end
  end

end
^

/* Alter (DOCUMENT_STORNO_PAYS_SET$DOC) */
ALTER PROCEDURE DOCUMENT_STORNO_PAYS_SET$DOC(ID_STORNO_DOC INTEGER)
 AS
declare variable id_account integer;
  declare variable id_payment_head integer;
  declare variable id_storned_doc integer;
  declare variable description varchar(100);
  declare variable id_storno_payment integer;
  declare variable storno_amount numeric(15,4);
  declare variable doc_amount numeric(15,4);
begin
  execute procedure DOCUMENT_PAYMENTS_CLEAR$DOC (:ID_STORNO_DOC);

  select D.ID_BASE_DOC, D.DESCRIPTION
  from   DOC_HEAD D
  where  D.ID_DOC = :ID_STORNO_DOC
  into   :id_storned_doc, :description;
   
  for
    select P.ID_PAYMENT_HEAD, BD.ID_ACCOUNT, sum(dp.PAY_AMOUNT), sum(dp.DOC_AMOUNT)
    from   DOC_HEAD BD
           join PAYMENT_HEAD P on P.ID_DOC_HEAD = BD.ID_DOC
           join ACCOUNT_PAYMENTS AP on AP.ID_PAYMENT_HEAD = p.ID_PAYMENT_HEAD
           join DOC_PAY_USAGE DP on dp.ID_ACCOUNT_PAYMENT = ap.ID_ACCOUNT_PAYMENT
                                   and dp.ID_DOC_HEAD = bd.ID_DOC
    where  BD.ID_BASE_DOC = :id_storned_doc
           and P.IS_STORNED = 0
           and P.IS_STORNO = 0
           and P.IS_ANUL = 0
    group by 1, 2
    into   :id_payment_head, :id_account, :storno_amount, :doc_amount
  do begin
    select :storno_amount + coalesce(sum(sdp.PAY_AMOUNT), 0),
           :doc_amount + coalesce(sum(sdp.DOC_AMOUNT), 0)
    from   PAYMENT_HEAD SP
           join ACCOUNT_PAYMENTS sap on sap.ID_PAYMENT_HEAD = sp.ID_PAYMENT_HEAD
           join DOC_PAY_USAGE sdp on sdp.ID_ACCOUNT_PAYMENT = sap.ID_ACCOUNT_PAYMENT
    where  sp.ID_PAYMENT_STORNED = :id_payment_head
           and sp.IS_ANUL = 0
    into   :storno_amount, :doc_amount;

    execute procedure PAYMENT_STORNO$INT (:id_payment_head, :id_account, :ID_STORNO_DOC, :storno_amount, :DESCRIPTION, :doc_amount)
    returning_values  (:id_storno_payment);

  end
end
^

/* Alter (DOCUMENT_USE_DEPOSIT$DOC) */
ALTER PROCEDURE DOCUMENT_USE_DEPOSIT$DOC(ID_DOC_HEAD INTEGER,
ID_DEPOSIT INTEGER,
DEPOSIT_AMOUNT NUMERIC(15,4))
 AS
declare variable id_deposit_doc integer;
  declare variable id_dep_doc_type integer;
  declare variable id_new_doc_type integer;
  declare variable id_dep_tax integer;
  declare variable dep_doc_curr varchar(3);
  declare variable new_doc_curr varchar(3);
  declare variable pay_curr varchar(3);
  declare variable doc_value numeric(15,4);
  declare variable id_doc_line integer;
  declare variable pay_round_to numeric(15,4);
  declare variable pay_rate numeric(15,6);
  declare variable doc_sub_type integer;
  declare variable id_account_payment integer;
begin
  ID_DEPOSIT_DOC = null;
  select DH.DOC_SUB_TYPE
  from   DOC_HEAD DH
  where  DH.ID_DOC = :ID_DOC_HEAD
  into   :doc_sub_type;
   
  if (:doc_sub_type = 2) then exception DOCUMENT_EXCEPTION '-372';  /* Can not use deposit into credit doc */
  /*  */
  execute procedure DOCUMENT_DETACH_DEPOSIT$INT (:ID_DOC_HEAD, :ID_DEPOSIT);

  select DH.ID_DOC, DH.ID_DOC_TYPE, DH.DOC_CURRENCY, ph.PAY_CURRENCY
  from   DEPOSIT D
         join PAYMENT_HEAD PH on PH.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
         left outer join DOC_HEAD DH on DH.ID_DOC = PH.ID_DOC_HEAD
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_deposit_doc, :id_dep_doc_type, :dep_doc_curr, :pay_curr;

  execute procedure DOCUMENT_CURR_RATE_GET$INT (:ID_DOC_HEAD, :pay_curr)
  returning_values (:pay_rate, :pay_round_to);
  /*********************************************************/
  if (round_f(:DEPOSIT_AMOUNT, :PAY_ROUND_TO) = 0) then exit;
  /*********************************************************/
  select first 1 AP.ID_ACCOUNT_PAYMENT
  from   ACCOUNT_PAYMENTS AP
  where  AP.ID_DEPOSIT = :ID_DEPOSIT
  order by ap.ID_ACCOUNT_PAYMENT asc
  into   :id_account_payment;

  execute procedure DOCUMENT_ATTACH_PAYMENT$INT (:ID_DOC_HEAD, :id_account_payment, :pay_rate, :DEPOSIT_AMOUNT)
  returning_values :doc_value;
   
  if (:ID_DEPOSIT_DOC is not null) then begin
    select first 1 DDL.ID_SALE_TAXATION
    from   DOC_LINE DDL
           join DOC_LINE_DEP_VALUES DV on DV.ID_DOC_LINE = DDL.ID_DOC_LINE
    where  DDL.ID_DOC_HEAD = :ID_DEPOSIT_DOC
           --and DV.ID_DEPOSIT = :ID_DEPOSIT
    into   :id_dep_tax;
     
    select  D.ID_DOC_TYPE, D.DOC_CURRENCY
    from    DOC_HEAD D
            join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where   D.ID_DOC = :ID_DOC_HEAD
    into    :id_new_doc_type, :new_doc_curr;

    if (not (:id_dep_doc_type = :id_new_doc_type and :dep_doc_curr = :new_doc_curr) ) then
       exception DOCUMENT_EXCEPTION '-374';

    if (not exists (select DL.ID_DOC_LINE
                    from   DOC_LINE DL
                           join SALE_TAXATION_TAX ST on ST.ID_SALE_TAXATION = DL.ID_SALE_TAXATION
                           join SALE_TAXES t on t.ID_SALE_TAX = st.ID_SALE_TAX and t.REVENUE_DEDUCTION_TAX is distinct from 1
                    where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
                           and ST.ID_SALE_TAX in (select STT.ID_SALE_TAX
                                                  from   SALE_TAXATION_TAX STT
                                                         join SALE_TAXES t2 on t2.ID_SALE_TAX = stt.ID_SALE_TAX
                                                                              and t2.REVENUE_DEDUCTION_TAX is distinct from 1
                                                  where  STT.ID_SALE_TAXATION = :ID_DEP_TAX))) then
      exception DOCUMENT_EXCEPTION '-373';

    DOC_VALUE = -:DOC_VALUE; /* !!! Value should be NEGATIVE - to deduct from postings value */
    execute procedure DOCUMENT_ADD_PAYMENT_LINE$INT (:ID_DEPOSIT, :ID_DOC_HEAD, :DOC_VALUE, :ID_DEP_TAX)
    returning_values  (:id_doc_line);
  
    execute procedure DOCUMENT_SAVE_TOTAL$INT (:ID_DOC_HEAD)
    returning_values :doc_sub_type;
  end
end
^

/* Alter (DOCUMENT_VALIDATE$DOC) */
ALTER PROCEDURE DOCUMENT_VALIDATE$DOC(ID_DOC_HEAD TYPE OF ID_REF)
 RETURNS(FIRM_DATA TYPE OF TNOTE_BLOB,
WARN_CODE TYPE OF TRANGE,
NEW_DOC_DATE TYPE OF TDATE)
 AS
declare variable no_use varchar(255);
  declare variable doc_value numeric(15,4);
  declare variable rest_value numeric(15,4);
  declare variable lines_value numeric(15,4);
  declare variable lines_wot_vat numeric(15,4);
  declare variable tax_value numeric(15,4);
  declare variable taxable_value numeric(15,4);
  declare variable round_to numeric(15,4);
  declare variable id_doc_contragent integer;
  declare variable id_doc_supplier integer;
  declare variable for_deposit integer;
  declare variable id_profile integer;
  declare variable dbkey char(8);
  declare variable id_contragent integer;
  declare variable ident_no varchar(20) ;
  declare variable action_text varchar(255);
  declare variable doc_currency varchar(3);
  declare variable is_juridical_person smallint;
  declare variable vat_ident_no varchar(30);
  declare variable id_doc_type integer;
  declare variable doc_sub_type integer;
  declare variable required_ident_no smallint;
  declare variable required_vat_no smallint;
  declare variable required_egn smallint;
  declare variable required_recipient_name smallint;
  declare variable lines_count integer;
  declare variable recipient_name varchar(100);
  declare variable id_doc_completed integer;
  declare variable action_code varchar(50);
begin

  select D.RDB$DB_KEY, D.DOC_VALUE_A, C.ROUND_TO,
         D.ID_DOC_CONTRAGENT, D.ID_DOC_SUPPLIER, D.FOR_DEPOSIT,
         A.ID_PROFILE, D.DOC_CURRENCY, D.TAXABLE_VALUE, d.ID_DOC_TYPE, d.DOC_SUB_TYPE,
         dc.ID_DOC_HEAD, ds.FIRM_DATA
  from   DOC_HEAD$INT D
         join CURRS C on C.CURR = D.DOC_CURRENCY
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         left outer join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
         left outer join DOC_SUPPLIER ds on ds.ID_DOC_SUPPLIER = d.ID_DOC_SUPPLIER
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :dbkey, :doc_value, :round_to,
         :id_doc_contragent, :id_doc_supplier, :for_deposit,
         :id_profile, :doc_currency, :taxable_value, :id_doc_type, :doc_sub_type,
         :id_doc_completed, :FIRM_DATA;

  if (:id_doc_contragent is null) then
    exception DOCUMENT_EXCEPTION '-356'; --'Contragent is not set!';

  if (:id_doc_supplier is null) then
    exception DOCUMENT_EXCEPTION '-357'; --'Supplier is not set!';

  select sum(DT.TAX_VALUE)
  from   DOC_TAXES DT
  where  DT.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :tax_value;

  /*if (round_f(:doc_value - :total_value, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Total value is not correct!';
  */
  select round_f(sum(DL.SINGLE_VALUE * DL.QTY_POST), :round_to),
         round_f(sum(DL.WOT_VAT), :round_to),
         count(*)
  from   DOC_LINE DL
  where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :lines_value, :lines_wot_vat, :lines_count;
 
  if (:lines_count = 0) then
    exception INTERNAL_DOC_EXCEPTION 'Document is empty! Not exists sale lines!';

  if (round_f(:doc_value - :lines_value, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines total value is not correct!' || :doc_value ||  ' / ' || :lines_value || ' ; '|| (:doc_value - :tax_value) ||  ' / ' || :lines_wot_vat;

  if (round_f(:doc_value - :tax_value - :lines_wot_vat, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines wot tax value is not correct!';

  if (round_f(abs(:lines_wot_vat) - abs(:taxable_value), :round_to) < 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines wot tax value is less than total taxable value!';

  if (:id_doc_completed is not null) then begin
    select DV.PAYABLE_VALUE
    from   DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, null) DV
    into   :rest_value;
  
    if (round_f(:rest_value, :round_to) <> 0) then
      exception DOCUMENT_EXCEPTION '-371'; --'Insufficient amount of payments !';
  end

  /* Validate contragent data */
  select dt.REQUIRED_IDENT_NO, dt.REQUIRED_VAT_NO, dt.REQUIRED_EGN, dt.REQUIRED_RECIPIENT_NAME
  from   DOC_TYPE_INV DT
  where  dt.ID_DOC_TYPE = :id_doc_type
  into   :required_ident_no, :required_vat_no, :required_egn, :required_recipient_name;

  select dc.ID_CONTRAGENT, dc.IS_JURIDICAL_PERSON,
         trim(coalesce(dc.IDENT_NO, '')), trim(coalesce(dc.VAT_REG_NUM, '')),
         trim(coalesce(dc.RECIPIENT_NAME, ''))
  from   DOC_CONTRAGENT dc
  where  dc.ID_DOC_CONTRAGENT = :id_doc_contragent
  into   :id_contragent, :is_juridical_person, :ident_no, :vat_ident_no, :recipient_name;

  if (:doc_sub_type = 0 and :required_ident_no = 1 and :is_juridical_person = 1 and :ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-324'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_egn = 1 and :is_juridical_person = 0 and :ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-324'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_vat_no = 1 and :is_juridical_person = 1 and :vat_ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-326'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_recipient_name = 1 and :recipient_name = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-327'; --'Recipient_name is empty.';
  /*if (:post_address = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-325'; --'Contragent address is empty.';
  /* save contragent link for profile */
  if (:id_contragent is not null) then begin
    update PROFILE P
    set    P.ID_DEF_CONTRAGENT = :id_contragent
    where  P.ID_PROFILE = :id_profile
           and P.ID_DEF_CONTRAGENT is null;
  end

  /*  */
  execute procedure DOC_CHECK_FISCAL$INT(:dbkey);
  /*  */
  execute procedure DOCUMENT_SET_NUMBER$INT (:dbkey)
  returning_values (:no_use, :no_use);
  /*  */
  if (:id_doc_completed is not null) then begin
    if (:for_deposit = 0) then begin
      /* check used deposits and create storno docs if necessary */
      /*execute procedure DOCUMENT_DEPOSIT_DOC_APPLY$INT (:ID_DOC_HEAD)
      returning_values  (:RESULT_DOC_LIST);  */
      /* update account posts */
      execute procedure ACCOUNT_POSTING_DOC_UPDATE$INT (:dbkey)
      returning_values :WARN_CODE;
    end

    execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT (:dbkey, null, 1, null);
    /* ... */
    execute procedure DOCUMENT_BONUSPOINTS_APPLY$CL (:ID_DOC_HEAD);
    /* ... */
  end
  /*  */
  action_text = f_character(29) || formatfloat(:doc_value, 'F;0.00') || ' ' || :doc_currency;
  action_code = iif(:id_doc_completed is null,  'PROFORMA_CREATE', 'CREATE');
  execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :ID_DOC_HEAD, :action_code, :action_text);

  select cast('31.12.1899' as date) + count(d.ID_DOC_HEAD)
  from   DOC_HEAD$INT d
  where  d.DOC_DATE is not null
  into   :NEW_DOC_DATE;

end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_ROOM_BALANCE for: EAI_EXT_GUEST_BALANCE */
ALTER PROCEDURE EAI_EXT_ROOM_BALANCE(ROOM_NAME VARCHAR(20))
 RETURNS(ID_GUEST INTEGER,
ID_ACCOUNT_POST INTEGER,
IS_DEPOSIT_POST SMALLINT,
ID_ACCOUNT INTEGER,
ACCOUNT_NAME VARCHAR(40),
ID_SERVICE INTEGER,
SERVICE_NAME VARCHAR(30),
SERVICE_NAME2 VARCHAR(30),
POST_VALUE NUMERIC(15,2),
CURR_POST VARCHAR(3),
RATE_POST NUMERIC(15,4),
DATE_POST DATE,
POST_TEXT VARCHAR(50))
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_EXT_GUEST_BALANCE) */
ALTER PROCEDURE EAI_EXT_GUEST_BALANCE(ID_GUEST INTEGER)
 RETURNS(ID_ACCOUNT_POST INTEGER,
IS_DEPOSIT_POST SMALLINT,
ID_ACCOUNT INTEGER,
ACCOUNT_NAME VARCHAR(50),
ID_SERVICE INTEGER,
SERVICE_NAME VARCHAR(30),
SERVICE_NAME2 VARCHAR(30),
POST_VALUE NUMERIC(15,2),
CURR_POST VARCHAR(3),
RATE_POST NUMERIC(15,4),
DATE_POST DATE,
ROOM_NAME VARCHAR(10),
POST_TEXT VARCHAR(50),
IS_GUEST_POST SMALLINT)
 AS
declare variable id_base_account integer;
  declare variable id_extra_account integer;
begin

  select G.ID_BASE_ACCOUNT, G.ID_ACCOUNT
  from   GUEST G
  where  G.ID_GUEST = :ID_GUEST
  into   :ID_BASE_ACCOUNT, :ID_EXTRA_ACCOUNT;

  for
    select GA.ID_ACCOUNT, A.ACCOUNT_NAME
    from   GUEST_RELATED_ACCOUNTS GA
           left join ACCOUNT A on A.ID_ACCOUNT = GA.ID_ACCOUNT
    where  GA.ID_GUEST = :ID_GUEST
           and A.ID_RESERV_DETAIL is not null
    into   :ID_ACCOUNT, :ACCOUNT_NAME
  do begin
    if ((:ID_ACCOUNT = :ID_BASE_ACCOUNT) or (:ID_ACCOUNT = :ID_EXTRA_ACCOUNT)) then begin
      for
        select 0, AP.ID_ACCOUNT_POST, AP.DATE_POST, AP.ID_SERVICE,
               S.SERVICE_NAME, S.SERVICE_NAME,
               AP.QTY_POST*AP.PRICE_POST - AP.IN_DOC_QTY*AP.IN_DOC_VALUE,
               AP.CURR_POST, AP.RATE_POST, AP.ROOM_NAME, substring(coalesce(AD.POST_TEXT, '') from 1 for 49),
               AP.IS_GUEST_POST
        from   ACCOUNT_POST AP
               left outer join SERVICES S on S.ID_SERVICE = AP.ID_SERVICE
               left outer join ACCOUNT_POSTING_DET AD on AD.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
        where  AP.ID_ACCOUNT = :ID_ACCOUNT
               and ((AP.ID_GUEST is null) or (ap.ID_GUEST = :ID_GUEST))
               and AP.AC = '00'
        union all
        select 1, D.ID_DEPOSIT, DA.PAYMENT_DATE, null,
               substring (DA.DESCRIPTION from 1 for 30), substring (DA.DESCRIPTION from 1 for 30),
               DA.AVAIL_VALUE,
               DA.PAY_CURRENCY, DA.PAY_RATE, cast('' as varchar(10)), cast('' as varchar(50)),
               case when D.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL then 1 else 0 end as IS_GUEST_DEP
        from   DEPOSIT_AVAILABLE DA
               join DEPOSIT D on D.ID_DEPOSIT = DA.ID_DEPOSIT
               join GUEST G on G.ID_RESERV_DETAIL = D.ID_RESERV_DETAIL
        where  D.ID_ACCOUNT = :ID_ACCOUNT
        into   :IS_DEPOSIT_POST, :ID_ACCOUNT_POST, :DATE_POST, :ID_SERVICE,
               :SERVICE_NAME, :SERVICE_NAME2,
               :POST_VALUE, :CURR_POST, :RATE_POST,
               :ROOM_NAME, :POST_TEXT, :IS_GUEST_POST
      do suspend;
    end else begin
      for
        select 0, AP.ID_ACCOUNT_POST, AP.DATE_POST, AP.ID_SERVICE,
               S.SERVICE_NAME, S.SERVICE_NAME,
               AP.QTY_POST*AP.PRICE_POST - AP.IN_DOC_QTY*AP.IN_DOC_VALUE,
               AP.CURR_POST, AP.RATE_POST, AP.ROOM_NAME, coalesce(AD.POST_TEXT, ''),
               AP.IS_GUEST_POST
        from   ACCOUNT_POST AP
               left outer join SERVICES S on S.ID_SERVICE = AP.ID_SERVICE
               left outer join ACCOUNT_POSTING_DET AD on AD.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
        where  AP.ID_ACCOUNT = :ID_ACCOUNT
               and AP.ID_GUEST = :ID_GUEST
               and AP.AC = '00'
        union all
        select 1, D.ID_DEPOSIT, DA.PAYMENT_DATE, null,
               substring (DA.DESCRIPTION from 1 for 30), substring (DA.DESCRIPTION from 1 for 30),
               DA.AVAIL_VALUE,
               DA.PAY_CURRENCY, DA.PAY_RATE, cast('' as varchar(10)), cast('' as varchar(50)),
               1 as IS_GUEST_DEP
        from   DEPOSIT_AVAILABLE DA
               join DEPOSIT D on D.ID_DEPOSIT = DA.ID_DEPOSIT
               join GUEST G on G.ID_RESERV_DETAIL = D.ID_RESERV_DETAIL
        where  D.ID_ACCOUNT = :ID_ACCOUNT
               and D.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
        into   :IS_DEPOSIT_POST, :ID_ACCOUNT_POST, :DATE_POST, :ID_SERVICE,
               :SERVICE_NAME, :SERVICE_NAME2,
               :POST_VALUE, :CURR_POST, :RATE_POST,
               :ROOM_NAME, :POST_TEXT, :IS_GUEST_POST
      do suspend;
    end
  end
end
^

/* Alter (EAI_EXT_ROOM_BALANCE) */
ALTER PROCEDURE EAI_EXT_ROOM_BALANCE(ROOM_NAME VARCHAR(20))
 RETURNS(ID_GUEST INTEGER,
ID_ACCOUNT_POST INTEGER,
IS_DEPOSIT_POST SMALLINT,
ID_ACCOUNT INTEGER,
ACCOUNT_NAME VARCHAR(40),
ID_SERVICE INTEGER,
SERVICE_NAME VARCHAR(30),
SERVICE_NAME2 VARCHAR(30),
POST_VALUE NUMERIC(15,2),
CURR_POST VARCHAR(3),
RATE_POST NUMERIC(15,4),
DATE_POST DATE,
POST_TEXT VARCHAR(50))
 AS
declare variable dbg varchar(2000);
  declare variable id_room integer;
  declare variable account_posts varchar(5000);
  declare variable is_guest_post smallint;
  declare variable tmp_id_guest integer;
begin
  dbg = null;
  account_posts = '';
  if (singular(select RO.ID_ROOM
               from ROOMS RO
                  join HOTEL_S HO on HO.ID_HOTEL = RO.ID_HOTEL
               where  RO.ROOM_NAME = :ROOM_NAME
                      and HO.IS_USE = 1)) then
    select R.ID_ROOM
    from   ROOMS R
      join HOTEL_S HS on HS.ID_HOTEL = R.ID_HOTEL
    where  R.ROOM_NAME = :ROOM_NAME
           and HS.IS_USE = 1
    into   :id_room;
  else
    exception assert '-1044';

  for
    select G.ID_GUEST
    from   RESERV_DETAIL RD
           join GUEST G on G.ID_RESERV_DETAIL = RD.ID_RESERV_DETAIL
    where  RD.ID_ROOM = :id_room
           and G.CHECK_STATUS = 0
    into   :tmp_id_guest 
  do begin
    for
      select ID_ACCOUNT_POST, IS_DEPOSIT_POST, ID_ACCOUNT, ACCOUNT_NAME,
             ID_SERVICE, SERVICE_NAME, SERVICE_NAME2,
             POST_VALUE, CURR_POST, RATE_POST, DATE_POST, substring(coalesce(POST_TEXT, '') from 1 for 49),
             IS_GUEST_POST
      from   EAI_EXT_GUEST_BALANCE (:tmp_id_guest) GB
      into   :ID_ACCOUNT_POST, :IS_DEPOSIT_POST, :ID_ACCOUNT, :ACCOUNT_NAME,
             :ID_SERVICE, :SERVICE_NAME, :SERVICE_NAME2,
             :POST_VALUE, :CURR_POST, :RATE_POST, :DATE_POST, :POST_TEXT, :is_guest_post
    do begin
      if (:is_guest_post = 1) then begin
        ID_GUEST = :tmp_id_guest;
        suspend;
      end else if (strpos(:ID_ACCOUNT_POST, :account_posts) = 0) then begin
        ID_GUEST = -1;
        suspend;
        account_posts = :account_posts || ',' || :ID_ACCOUNT_POST;
      end
    end
  end
end
^

/* Alter (EAI_POS_GET_GUESTS$P2E) */
ALTER PROCEDURE EAI_POS_GET_GUESTS$P2E(IN_ROOM_NAME VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(OUT_ID_GUEST INTEGER,
OUT_GUEST_NAME VARCHAR(100),
OUT_FROM_DATE DATE,
OUT_TO_DATE DATE,
OUT_OK_FOR_POST INTEGER,
OUT_COUNTRY VARCHAR(30),
OUT_TEXT VARCHAR(100),
OUT_BOARD_NAME VARCHAR(30),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100))
 AS
declare variable id_room integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  OUT_GUEST_NAME = null;

  /*FIND ROOM*/
  select R.ID_ROOM
  from   ROOMS R
         join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
  where  R.ROOM_NAME = :IN_ROOM_NAME
         and RT.ID_HOTEL = :ID_HOTEL
  into   :ID_ROOM;
  if ((:ID_ROOM is null) or (:ID_ROOM <= 0) ) then begin
    ERR_CODE = -5;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Room number not found!    ! ';
    suspend;
    exit;
  end

  /*FIND GUESTS*/
  for
    select G.ID_GUEST, GC.GUEST_NAME1, G.FROM_DATE, G.TO_DATE, C.COUNTRY_NAME,
           (select m.NAME
            from   GUEST_STAY gs
                   join MEALS M on m.ID_BOARD = gs.ID_BOARD
            where  gs.ID_GUEST = g.ID_GUEST
                   and gs.FOR_DATE = iif(current_date = g.to_date, current_date - 1, current_date))
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
           left outer join GUEST_CARD GC on G.ID_GUEST = GC.ID_GUEST
           left outer join COUNTRY C on C.COUNTRY_CODE = GC.COUNTRY
    where  G.ID_ROOM = :ID_ROOM
           and G.CHECK_STATUS = 0
           and rd.IS_ANUL = 0
    into   :OUT_ID_GUEST, :OUT_GUEST_NAME, :OUT_FROM_DATE,  :OUT_TO_DATE, :OUT_COUNTRY, :OUT_BOARD_NAME
  do begin
    OUT_OK_FOR_POST = iif(:OUT_TO_DATE < current_date, 0, 1) ;
    suspend;
  end

  if (:OUT_GUEST_NAME is null) then begin
    ERR_CODE = -1;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Guests not found!     !';
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: EXPORT_BOOKING$RSV for: EXPORT_BOOKING$EXC */
ALTER PROCEDURE EXPORT_BOOKING$RSV(DATA_RANGE VARCHAR(50))
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20),
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_NAME VARCHAR(100),
POSTING_ROUTING VARCHAR(20),
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE RES_LOAD(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_AGENT_PROFILE INTEGER,
AGENT_PROFILE_NAME VARCHAR(100),
ID_PERSON_PROFILE INTEGER,
PERSON_PROFILE_NAME VARCHAR(100),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_RES_ROOM_TYPE INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
BOARD_NAMES VARCHAR(255),
TARIFF_NAMES VARCHAR(255),
PACKET_NAMES VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100),
VOUCHER_RENDER VARCHAR(512),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
TRANSFER_RENDER VARCHAR(255),
CODE_FIRST_FOOD_RENDER VARCHAR(255),
IS_LATE_DEPARTURE INTEGER,
CODE_FIRST_FOOD VARCHAR(20),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
I_SPECIAL_TREATMENT VARCHAR(255),
COMMING_KIND SMALLINT,
IS_VIP SMALLINT,
HAS_GUEST_LIST SMALLINT,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
AGENT_ACCOUNT_NAME VARCHAR(100),
IS_DIFFERENT_VOUCHER INTEGER,
IS_DIFFERENT_OTHER INTEGER,
IS_DIFFERENT_BOARD INTEGER,
IS_DIFFERENT_TARIFF INTEGER,
IS_CUSTOM_PRICE INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
ID_RATE INTEGER,
ROOM_FEATURES BLOB,
ID_GROUP INTEGER,
NUMBER VARCHAR(62),
CHECK_STATUS INTEGER,
BALANCE VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER,
RECIEVED_DEPOSITS VARCHAR(100),
ROOM_HISTORY VARCHAR(200),
TAR_ROOM_TYPE VARCHAR(100),
ID_HK_PLAN INTEGER,
COUNTRIES VARCHAR(812),
IS_RESGRP INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
IS_ANUL INTEGER,
NOTE VARCHAR(2000),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
GROUP_NAME VARCHAR(50),
ID_HOTEL INTEGER,
NOTE_REMINDERS VARCHAR(50),
IS_DIFFERENT_PRICE INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ID_EATING_OBJECT TYPE OF ID_REF,
ROOM_PRIVATE_STATUS TLOGICAL)
 AS
declare variable rd_dbkey char(8);
  declare variable reason_of_anul varchar(100);
  declare variable shared_resvations varchar(1024);
  declare variable virtual_room varchar(10);
  declare variable packet_item_ids varchar(255);
  declare variable earlycheckout_date date;
begin
  select RD.RDB$DB_KEY, RD.ID_AGENT_PROFILE, PA.PROFILE_NAME,
         RD.ID_NOM_MARKET_SEGMENT, RD.ID_NOM_SOURCE_CODE, RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_HEAR_REASON, RD.ID_NOM_COME_REASON,
         RD.ADULT_COUNT, RD.CHILD_COUNT, RD.CUSTOM_PRICE, RD.CUSTOM_CURRENCY,
         RD.IS_VIP, RD.CHECK_STATUS, RD.ID_AGENT_ACCOUNT,
         RD.ACC_ROUTING, RD.ID_PERSON_PAYMENT,
         RD.ID_AGENT_PAYMENT, RD.ID_PERSON_PROFILE, PP.PROFILE_NAME, RD.ID_GROUP,
         RD.COMMING_KIND, RD.I_SPECIAL_TREATMENT, ACC.ACCOUNT_NAME, RD.ROOM_FEATURES, RD.ID_HK_PLAN,
         RD.NUMBER, RD.IS_ANUL, RD.REASON_OF_ANUL, RD.NOTE,
         RD.HAS_DIFFERENT_VOUCHERS, RD.HAS_DIFFERENT_OTHER,
         RD.HAS_DIFFERENT_BOARD, RD.HAS_DIFFERENT_TARIFF, RD.HAS_DIFFERENT_TYPE_STAY, RD.HAS_DIFFERENT_ROOM_TYPE,
         RD.ID_HOTEL, RG.GROUP_NAME, RD.ID_RATE, RD.NOTE_REMINDERS, RD.has_different_price,
         RD.ID_GUARANTEE_POLICY, RD.BLOCK_CC, rd.ID_EATING_OBJECT, g.EARLYCHECKOUT_DATE
  from   RESERV_DETAIL RD
         left outer join RESERV_GROUP RG on RG.ID_RESERV_GROUP = RD.ID_GROUP
         left outer join PROFILE PA on PA.ID_PROFILE = RD.ID_AGENT_PROFILE
         left outer join PROFILE PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
         left outer join ACCOUNT ACC on ACC.ID_ACCOUNT = RD.ID_AGENT_ACCOUNT
         left outer join GUEST G on g.ID_GUEST = rd.ID_TITULAR
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :id_agent_profile, :agent_profile_name,
         :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason,
         :adult_count, :child_count, :custom_price, :custom_currency,
         :is_vip, :check_status, :id_agent_account, :acc_routing, :id_person_payment,
         :id_agent_payment, :id_person_profile, :person_profile_name, :id_group,
         :comming_kind, :i_special_treatment, :agent_account_name, :room_features, :id_hk_plan,
         :number, :is_anul, :reason_of_anul, :note,
         :is_different_voucher, :is_different_other,
         :is_different_board, :is_different_tariff, :is_different_stay_type, :is_different_room_type,
         :id_hotel, :group_name, :id_rate, :note_reminders, :is_different_price,
         :id_guarantee_policy, :block_cc, :id_eating_object, :earlycheckout_date;

  is_resgrp = iif(:id_group is not null, 1, 0);

  if ((:is_different_price = 1) or (:custom_price is not null) ) then
    IS_CUSTOM_PRICE = 1;
  else
    IS_CUSTOM_PRICE = 0;

  execute procedure RES_GET_PRICE$INT(:rd_dbkey, 'SECURITY')
  returning_values  :room_price, :room_currency, :room_price_details,
                    :deposit_required, :deposit_required_currency;

  execute procedure RES_GET_BALLANCE$INT(:id_reserv_detail)
  returning_values  :balance, :recieved_deposits, :has_charges, :open_charges, :open_deposit;

  execute procedure RES_GET_STATIC_DATA$INT(:rd_dbkey)
  returning_values  :arrival_date, :departure_date, :voucher_num, :voucher_date,
                    :voucher_text, :voucher2_num, :voucher2_date, :transfer_in_time,
                    :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :is_late_departure, :code_first_food;

  execute procedure RES_GET_DYNAMIC_DATA$INT(:rd_dbkey, 1)
  returning_values  :id_res_room_type, :id_room_type, :id_room, :id_board,
                    :id_tariff, :packet_item_ids, :room_name, :room_history, :tar_room_type, :virtual_room;

  execute procedure RES_GET_GUEST_DATA$INT('DETAIL', :id_reserv_detail)
  returning_values  :board_names, :tariff_names, :packet_names, :voucher_render;

  execute procedure RES_GET_GUEST_DATA2$INT(:id_reserv_detail)
  returning_values  :has_guest_list, :countries, :transfer_render, :code_first_food_render;

  execute procedure RES_GET_ATTENTION_STATUS$INT(:arrival_date, :departure_date, :check_status, :id_hotel)
  returning_values  :attention_status;

  execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'RENDER', null)
  returning_values  :in_share, :shared_resvations, :shares_preview;
  if (:IN_SHARE = 1) then ROOM_NAME = coalesce(:ROOM_NAME, :virtual_room);

  annul_status = :is_anul;
  if (:reason_of_anul = 'EXPIRE') then annul_status = 2;
  execute procedure sys_dbg('res RES_LOAD comming_kind = '||coalesce(:comming_kind, 'null'));

  ROOM_PRIVATE_STATUS = 0;
  select cast(1 as smallint)
  from   SYSTEM_DATE_GET (:ID_HOTEL) sd
         join ROOM_MAGIC rm on rm.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                               and rm.ROOM_STATUS = 'PRIVATE'
                               and rm.BUSY_DATE = mindate(maxdate(:ARRIVAL_DATE, sd.SYSTEM_DATE), coalesce(:earlycheckout_date, :DEPARTURE_DATE) - 1)
  into   :ROOM_PRIVATE_STATUS;

  suspend;
end
^

/* Alter (EXPORT_BOOKING$EXC) */
ALTER PROCEDURE EXPORT_BOOKING$EXC(BOOKING_ID INTEGER)
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20,
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_ID INTEGER,
IS_GUEST_ARRANGER INTEGER,
POSTING_ROUTING VARCHAR(20),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IS_DIFFERENT_TARIFF SMALLINT,
IS_DIFFERENT_BOARD SMALLINT,
IS_CUSTOM_PRICE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
EXC_LOCAL_VERSION BIGINT,
EXC_REMOTE_VERSION BIGINT,
CREATE_DATETIME TIMESTAMP,
EATING_OBJECT VARCHAR(50))
 AS
declare variable arrival_type_code smallint;
BEGIN
  number = null;
  select h.hotel_name, b.number, bei.confirmation_number, bei.cancelation_number,
        bs.status, rg.id_reserv_group, rg.group_name, rg.uuid, b.is_vip, b.arrival_date, b.comming_kind,
        b.departure_date, b.is_late_departure, b.transfer_in_time, b.transfer_in_note,
        b.transfer_out_time, b.transfer_out_note, rt.type_room, board.name,
        b.room_features, b.i_special_treatment, hk.plan_name, r.tarifa_name, b.custom_price, b.custom_currency,
        b.deposit_required, b.deposit_required_currency, apt.payment_type, ppt.payment_type,
        b.voucher_num, b.voucher_date, b.voucher_text, ms.segment_name, sc.description,
        cc.description, hr.description, cr.description, b.note, b.note_reminders,
        b.code_first_food, ap.id_profile, isperson.id_profile as is_guest_arranger,
        b.acc_routing, b.is_different_room_type, b.is_different_stay_type, b.is_different_tariff,
        b.is_different_board, b.is_custom_price, b.is_different_price, bei.split_on_checkin,
        gp.name, b.block_cc, bei.guarantee_deposit_percent, bei.guarantee_deposit_nights,
        bei.guarantee_due_days_bef_arrival, bei.guarantee_due_days_after_create, bx.minibar_rights,
        bx.paytv_rights, bx.video_rights, bx.nopost_pms, bx.phone_rights, bx.seminar_cahnnel_rights,
        bei.posting_transaction_uuid, bei.exc_local_version, bei.exc_remote_version, bei.create_datetime,
        eo.name
  from  RES_LOAD(:booking_id) b
        join reserv_detail bei on bei.id_reserv_detail = :booking_id
        join HOTEL h on h.id_hotel = b.id_hotel
        join export_booking_status$exc(b.check_status, b.annul_status) bs on 1=1
        left outer join RESERV_GROUP RG on RG.ID_RESERV_GROUP = b.ID_GROUP
        join room_types rt on rt.id_room_type = b.id_res_room_type
        left outer join hk_plan hk on hk.id_plan = b.id_hk_plan
        join tarifa r on r.id_tarifa = b.id_tariff
        left outer join payment_type apt on apt.id_payment_type = b.id_agent_payment
        left outer join payment_type ppt on ppt.id_payment_type = b.id_person_payment
        left outer join nom_market_segments ms on ms.id_nom_market_segment = b.id_nom_market_segment
        left outer join nom_source_codes sc on sc.id_nom_source_code = b.id_nom_source_code
        left outer join nom_channel_codes cc on cc.id_nom_channel_code = b.id_nom_channel_code
        left outer join nom_hear_reasons hr on hr.id_nom_hear_reason = b.id_nom_hear_reason
        left outer join nom_come_reasons cr on cr.id_nom_come_reason = b.id_nom_come_reason
        left outer join profile ap on ap.id_profile = b.id_agent_profile
        left outer join profile_person isperson on isperson.id_profile = b.id_agent_profile
        left outer join meals board on board.ID_BOARD = bei.ID_BOARD
        left outer join guarantee_policy gp on gp.id_guarantee_policy=b.id_guarantee_policy
        left outer join reserv_detail_external bx on bx.id_reserv_detail = :booking_id
        left outer join eating_object eo on eo.id_eating_object = b.id_eating_object
  into  :hotel,
        :number,
        :confirmation_number,
        :cancelation_number,
        :status,
        :group_id,
        :group_name,
        :group_uuid,
        :is_vip,
        :arrival,
        :arrival_type_code,
        :departure,
        :is_late_departure,
        :transfer_in_time,
        :transfer_in_note,
        :transfer_out_time,
        :transfer_out_note,
        :room_type,
        :board,
        :room_preferences,
        :special_treatment,
        :maintance_shema,
        :rate,
        :manual_price,
        :manual_price_currency,
        :deposit_required,
        :deposit_required_currency,
        :arranger_payment_type,
        :guest_payment_type,
        :voucher,
        :voucher_date,
        :voucher_text,
        :marketing_segment,
        :marketing_source_code,
        :marketing_channel_code,
        :marketing_hear_reason,
        :marketing_come_reason,
        :note,
        :note_reminders,
        :first_food,
        :arranger_profile_id,
        :is_guest_arranger,
        :posting_routing,
        :is_different_room_type,
        :is_different_stay_type,
        :is_different_tariff,
        :is_different_board,
        :is_custom_price,
        :is_different_price,
        :split_on_checkin,
        :guarantee_policy,
        :block_cc,
        :guarantee_deposit_percent,
        :guarantee_deposit_nights,
        :guarantee_due_days_bef_arrival,
        :guarantee_due_days_after_create,
        :minibar_rights,
        :paytv_rights,
        :video_rights,
        :nopost_pms,
        :phone_rights,
        :seminar_cahnnel_rights,
        :posting_transaction_uuid,
        :exc_local_version,
        :exc_remote_version,
        :create_datetime,
        :eating_object
  ;

  if (:number is not null) then begin -- Check if we have export
    arrival_type = null;
    if (0 = :arrival_type_code) then begin
      arrival_type = 'early';
    end else if (2 = :arrival_type_code) then begin
      arrival_type = 'late';
    end
    suspend;
  end
END
^

/* Alter (EXPORT_BOOKING$RSV) */
ALTER PROCEDURE EXPORT_BOOKING$RSV(DATA_RANGE VARCHAR(50))
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20,
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_NAME VARCHAR(100),
POSTING_ROUTING VARCHAR(20),
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER)
 AS
BEGIN
  for select EB.HOTEL,
             EB.NUMBER, 
             EB.CONFIRMATION_NUMBER, 
             EB.CANCELATION_NUMBER,
             EB.STATUS, 
             EB.GROUP_ID, 
             EB.GROUP_NAME, 
             EB.IS_VIP,
             EB.ARRIVAL, 
             EB.ARRIVAL_TYPE, 
             EB.DEPARTURE, 
             EB.IS_LATE_DEPARTURE, 
             EB.TRANSFER_IN_TIME, 
             EB.TRANSFER_IN_NOTE, 
             EB.TRANSFER_OUT_TIME, 
             EB.TRANSFER_OUT_NOTE, 
             EB.ROOM_TYPE, 
             EB.BOARD, 
             EB.ROOM_PREFERENCES,
             EB.SPECIAL_TREATMENT, 
             EB.MAINTANCE_SHEMA, 
             EB.RATE, 
             EB.MANUAL_PRICE, 
             EB.MANUAL_PRICE_CURRENCY, 
             EB.DEPOSIT_REQUIRED, 
             EB.DEPOSIT_REQUIRED_CURRENCY, 
             EB.ARRANGER_PAYMENT_TYPE, 
             EB.GUEST_PAYMENT_TYPE, 
             EB.VOUCHER, 
             EB.VOUCHER_DATE, 
             EB.VOUCHER_TEXT, 
             EB.MARKETING_SEGMENT, 
             EB.MARKETING_SOURCE_CODE, 
             EB.MARKETING_CHANNEL_CODE, 
             EB.MARKETING_HEAR_REASON, 
             EB.MARKETING_COME_REASON, 
             EB.NOTE, 
             EB.NOTE_REMINDERS, 
             EB.FIRST_FOOD, 
             P.PROFILE_NAME,
             EB.POSTING_ROUTING, 
             EB.SPLIT_ON_CHECKIN, 
             EB.GUARANTEE_POLICY, 
             EB.GUARANTEE_DEPOSIT_PERCENT, 
             EB.GUARANTEE_DEPOSIT_NIGHTS, 
             EB.GUARANTEE_DUE_DAYS_BEF_ARRIVAL, 
             EB.GUARANTEE_DUE_DAYS_AFTER_CREATE
  from TMP_IDS ids
       left outer join EXPORT_BOOKING$EXC(ids.ID) EB on 1=1
       left outer join PROFILE P on P.ID_PROFILE = EB.ARRANGER_PROFILE_ID
  where ids.CONTEXT = :data_range
  into :hotel,
       :number, 
       :confirmation_number, 
       :cancelation_number,
       :status,
       :group_id, 
       :group_name, 
       :is_vip,
       :arrival, 
       :arrival_type, 
       :departure, 
       :is_late_departure, 
       :transfer_in_time, 
       :transfer_in_note, 
       :transfer_out_time, 
       :transfer_out_note, 
       :room_type, 
       :board, 
       :room_preferences,
       :special_treatment, 
       :maintance_shema, 
       :rate, 
       :manual_price, 
       :manual_price_currency, 
       :deposit_required, 
       :deposit_required_currency, 
       :arranger_payment_type, 
       :guest_payment_type, 
       :voucher, 
       :voucher_date, 
       :voucher_text, 
       :marketing_segment, 
       :marketing_source_code, 
       :marketing_channel_code, 
       :marketing_hear_reason, 
       :marketing_come_reason, 
       :note, 
       :note_reminders, 
       :first_food, 
       :arranger_profile_name,
       :posting_routing, 
       :split_on_checkin, 
       :guarantee_policy, 
       :guarantee_deposit_percent, 
       :guarantee_deposit_nights, 
       :guarantee_due_days_bef_arrival, 
       :guarantee_due_days_after_create
  do suspend;
END
^

/* empty dependent procedure body */
/* Clear: EXPORT_DOCUMENT for: EXPORT_DOCUMENT_PAYMENT */
ALTER PROCEDURE EXPORT_DOCUMENT(FROM_DATE DATE,
TO_DATE DATE,
DOC_TAG VARCHAR(20),
PAY_TAG VARCHAR(20),
NO_PAY_DOCS VARCHAR(20),
GROUP_TAG VARCHAR(20),
ID_HOTEL INTEGER = null,
RETURN_CLIENT_PERSON_ID SMALLINT = 0)
 RETURNS(DOC_TYPE_ID INTEGER,
DOC_SUB_TYPE SMALLINT,
DOC_TYPE_NAME VARCHAR(50),
DOC_DATE DATE,
DOC_FOR_DEPOSIT SMALLINT,
TAX_EVENT_DATE DATE,
DIFF_VAT_REASON VARCHAR(254),
DOC_NUM VARCHAR(20),
DOC_CURRENCY CHAR(3),
DOC_RATE NUMERIC(15,4),
DOC_IS_STORNED SMALLINT,
DOC_IS_STORNO SMALLINT,
DOC_ID_BASE_DOC INTEGER,
DOC_EXPORT_TAG VARCHAR(20),
DOC_SEND_NAME VARCHAR(100),
DOC_DOGOVOR_NUM VARCHAR(30),
DOC_NOTE VARCHAR(100),
DOC_SUPPLIER_ID INTEGER,
CLT_ID INTEGER,
CLT_NAME VARCHAR(100),
CLT_VAT_REG_NUM VARCHAR(30),
CLT_IDENT_NO VARCHAR(30),
CLT_MOL VARCHAR(50),
CLT_ADDRESS VARCHAR(100),
CLT_COUNTRY_CODE VARCHAR(10),
CLT_ZIP_CODE VARCHAR(10),
CLT_RECIEVE_NAME VARCHAR(100),
PAY_TYPE_ID INTEGER,
PAY_TYPE VARCHAR(20),
PAY_CURRENCY CHAR(3),
PAY_VALUE NUMERIC(15,4),
PAY_RATE NUMERIC(15,6),
PAY_CC_NAME VARCHAR(50),
PAY_CC_NUM VARCHAR(50),
PAY_CC_BANK VARCHAR(50),
PAY_EXPORT_TAG VARCHAR(20),
LINE_ID INTEGER,
LINE_NAME VARCHAR(50),
LINE_WOT_VAT NUMERIC(15,4),
LINE_VAT_FREE NUMERIC(15,4),
LINE_VAT_BASE NUMERIC(15,4),
LINE_VAT NUMERIC(15,4),
VAT_VALUE NUMERIC(15,4),
ID_VAT_GROUP INTEGER,
ID_SALE_TAXATION INTEGER,
LINE_QTY NUMERIC(15,4),
ACC_NO VARCHAR(30),
POSITION_NO INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EXPORT_DOCUMENT_PAYMENT) */
ALTER PROCEDURE EXPORT_DOCUMENT_PAYMENT(ID_DOC_HEAD INTEGER,
PAY_TAG VARCHAR(20),
NO_PAY_DOCS VARCHAR(20),
DOC_CURRENCY CHAR(3),
ID_BASE_DOC INTEGER,
DOC_GRAND_TOTAL NUMERIC(15,4))
 RETURNS(PAY_TYPE_ID INTEGER,
PAY_TYPE VARCHAR(20),
PAY_CURRENCY CHAR(3),
PAY_RATE NUMERIC(15,6),
PAY_VALUE NUMERIC(15,4),
PAY_CC_NAME VARCHAR(50),
PAY_CC_NUM VARCHAR(50),
PAY_CC_BANK VARCHAR(50),
PAY_COEFICIENT DOUBLE PRECISION,
EXPORT_TAG VARCHAR(20))
 AS
declare variable is_cc integer;
  declare variable id_payment_head integer;
begin
  /*  Description:
  ||
  */
  pay_type_id = null;
  --coef_total = 0;
  for
    select   PT.ID_PAYMENT_TYPE, PT.PAYMENT_TYPE, PH.PAY_CURRENCY, PH.PAY_RATE, DP.PAY_AMOUNT,
             null, cct.CREDIT_CARD_NAME, '', PT.IS_CC, PDT.EXPORT_TAG,
             iif(:doc_grand_total = 0, 0, DP.DOC_AMOUNT / :doc_grand_total)
    from     DOC_PAY_USAGE Dp
             join ACCOUNT_PAYMENTS AP on ap.ID_ACCOUNT_PAYMENT = dp.ID_ACCOUNT_PAYMENT
             join PAYMENT_HEAD PH on ph.ID_PAYMENT_HEAD = ap.ID_PAYMENT_HEAD
             join DOC_TYPE PDT on PDT.ID_DOC_TYPE = PH.ID_DOC_TYPE
             join PAYMENT_TYPE PT on PT.ID_PAYMENT_TYPE = PH.ID_PAYMENT_TYPE
             left outer join PAYMENT_CREDIT_CARD PCC on PCC.ID_PAYMENT_HEAD = PH.ID_PAYMENT_HEAD
             left outer join CREDIT_CARD_TYPE CCT on CCT.ID_CREDIT_CARD_TYPE = PCC.ID_CC_TYPE
    where    DP.ID_DOC_HEAD = :id_doc_head
             and ((PH.ID_DOC_HEAD is null) or (ph.ID_DOC_HEAD = dp.ID_DOC_HEAD))
             and ((upper(:pay_tag) = 'ALL') or (PDT.EXPORT_TAG = :pay_tag))
    --         and ((:DOC_GRAND_TOTAL >= 0 and PDT.STORNO_TYPE = 0) or (:DOC_GRAND_TOTAL < 0 and PDT.STORNO_TYPE = 2))
    order by PH.ID_PAYMENT_HEAD asc
    into     :pay_type_id, :pay_type, :pay_currency, :pay_rate, :pay_value,
             :pay_cc_num, :pay_cc_name, :pay_cc_bank, :is_cc, :export_tag,
             :pay_coeficient
  do begin
    --if (:PAY_COEFICIENT + :coef_total > 1) then PAY_COEFICIENT = 1 - :coef_total;
    --coef_total = :coef_total + :PAY_COEFICIENT;
    if (:is_cc <> 1) then begin
      pay_cc_num = ''; pay_cc_name = ''; pay_cc_bank = '';
    end
    suspend;
  end

  if (:no_pay_docs = 'NO') then exit; /* WE EXPLICITLY DISLIKE THIS KIND OF DOCUMENTS */
  if (:pay_type_id is null) then begin
    if (exists(
      select *
      from   PAYMENT_HEAD PH
      where  PH.ID_DOC_HEAD = :id_doc_head
    )) then exit;
    /* TO BE 100% SURE THAT THE DOCUMENT HAS NO PAYMENTS. BECAUSE THEY MAY EXISTS
    || BUT THE EXPORT_TAG FILTER EXCLUDES THEM.
    */

    /* FIRST. WE WILL CHECK IF OUR DOCUMENT CONSUMES DEPOSIT AND IF IT 
    || REALLY CONSUMES DEPISIT WILL TAKE THIS DEPOSIT PAYMENT WICH HAS
    || THE GREATEST VALUE. (MOST OF THE TIME IT WILL BE ONLY ONE).
    */
    select first 1 AP.ID_PAYMENT_HEAD
    from   DOC_PAY_USAGE DP
           join ACCOUNT_PAYMENTS AP on ap.ID_ACCOUNT_PAYMENT = DP.ID_ACCOUNT_PAYMENT
    where  dP.ID_DOC_HEAD = :id_doc_head
    order by dP.PAY_AMOUNT desc
    into   :id_payment_head;

    if (:id_payment_head is null) then begin
      /* SECOND. MAY BE THE DOCUMENT IS DEBIT/KREDIT WITH VALUE 0. WE 
      || WILL TRY TO GET THE PAYMENT WITH THE GREATEST VALUE FROM THE
      || ORIGINAL (BASE) DOCUMENT. (MOST OF THE TIME IT WILL BE ONLY ONE).
      */
      select first 1 PH.ID_PAYMENT_HEAD
      from   PAYMENT_HEAD PH
      where  PH.ID_DOC_HEAD = :id_base_doc
      order by PH.PAY_VALUE_A*PH.PAY_RATE desc
      into   :id_payment_head;
    end
    if (:id_payment_head is null) then begin
      /* ALL OF OUR ASSUMPTIONS ARE WRONG. THERE IS NO WAY TO CATCH
      || ANY CONNECTED PAYMENTS.
      */
      pay_type = '';
      pay_currency = :doc_currency;
      select first 1 PT.ID_PAYMENT_TYPE, PT.PAYMENT_TYPE
      from   PAYMENT_TYPE PT
      where  PT.IS_CASH = 1
             and PT.IS_USE = 1
      into   :pay_type_id, :pay_type;
    end else begin
      /* THERE IS FOUND PAYMENT. NOW WE NEED THE EXTRA INFO FOR IT.
      */
      select   PT.ID_PAYMENT_TYPE, PT.PAYMENT_TYPE, PH.PAY_CURRENCY, PDT.EXPORT_TAG
      from     PAYMENT_HEAD PH
               join DOC_TYPE PDT on PDT.ID_DOC_TYPE = PH.ID_DOC_TYPE
               join PAYMENT_TYPE PT on PT.ID_PAYMENT_TYPE = PH.ID_PAYMENT_TYPE
      where    PH.ID_PAYMENT_HEAD = :id_payment_head
               and ((upper(:pay_tag) = 'ALL') or (PDT.EXPORT_TAG = :pay_tag))
      into     :pay_type_id, :pay_type, :pay_currency, :export_tag;
      if (:pay_type_id is null) then exit;
      /* THERE ARE VALID PAYMENTS, BUT THEY DONT MATCH THE EXPORT_TAG.
      || IN THIS SITUATION THE WHOLE DOCUMENT MUST NOT BE FETCHED.
      || EVENTUALLY THIS DOCUMENT WILL APPEAR IN ANOTHER FILTER.
      */
    end
    pay_rate = 1;
    pay_value = 0;
    pay_cc_name = '';
    pay_cc_num = '';
    pay_cc_bank = '';
    pay_coeficient = 1;
    suspend;
  end
end
^

/* Alter (EXPORT_OCCUPANCY_TO_WBE$EXC) */
ALTER PROCEDURE EXPORT_OCCUPANCY_TO_WBE$EXC(ID_HOTEL INTEGER)
 RETURNS(ID_ROOM_TYPE INTEGER,
TYPE_ROOM VARCHAR(20),
HOTEL_NAME VARCHAR(50),
FROM_DATE DATE,
TO_DATE DATE,
CNT_ROOMS INTEGER)
 AS
declare variable res_prefix_exclude varchar(10);
declare variable id_helper_session integer;
declare variable starting_date date;
declare variable for_date date;
declare variable max_date date;
declare variable t_id_room_type integer;
declare variable t_occupied integer;
declare variable open_period_exist smallint;
begin

  /* Get all reservations that a NOT WBE reservations and export occupancy in allotment format */
  /* !!! Export only PRESENT and FUTURE (date >= today) */
  /* !! Returns OCCUPEIED rooms, not Avalable*/
  res_prefix_exclude = 'WBE';
  starting_date = 'now';
  starting_date = starting_date - 1; /* include today */
  max_date = starting_date;
  select h.hotel_name from hotel h where h.id_hotel = :id_hotel into :hotel_name;

  id_helper_session = gen_id(SELECTION_GEN, 1);

  /*put reservations in tmp table*/
  for
    select RM.BUSY_DATE, RM.ID_ROOM_TYPE, count(distinct RM.ID_ROOM)
    from   ROOM_MAGIC RM
           join ROOM_TYPES rt on Rt.id_room_type = rm.id_room_type
           join RESERV_DETAIL rd on rm.id_reserv_detail = rd.id_reserv_detail
           /*left outer join ROOM_PERIOD$PMS RP on RP.ID_ROOM = rm.ID_ROOM
                                        and RM.BUSY_DATE between RP.FROM_DATE and RP.TO_DATE
                                        and RP.IS_AVAILABLE = 1*/
    where  RM.BUSY_DATE >= :starting_date
           and rt.ID_HOTEL = :ID_HOTEL
           and RM.DAY_ACTION not containing 'CHECK_OUT'
           and RM.BUSY_TYPE is distinct from 'VALUE_RESERVS' /* skip waiting bookings */
           and RM.busy_group_type <> 18                      /* skip OOO              */
           and RM.busy_group_type <> 20                      /* skip OOI              */
           and RD.number_1 is distinct from :res_prefix_exclude
           --and ((RM.ID_ROOM < 0) or (rp.IS_AVAILABLE is not distinct from 1))
           and rm.ROOM_STATUS is distinct from 'PRIVATE' -- replace previous clause
    group by 1,2
    into   :for_date, :t_id_room_type, :t_occupied
  do begin
    insert into TMP_SMALL_OCCUP (id_session, for_date, id_room_type,  occupied)
    values (:id_helper_session, :for_date, :t_id_room_type,  :t_occupied );
    if (:for_date > :max_date) then max_date = for_date;
  end
  /**/

  /*loop room types in tmp table, join missing dates, then compress result in periods (allotment format)*/
  for
    select tso.id_room_type, max(rt.type_room)
    from   TMP_SMALL_OCCUP tso
           join ROOM_TYPES rt on tso.id_room_type = rt.id_room_type
    where  tso.id_session = :id_helper_session
    group by 1
    into   :t_id_room_type, :type_room
  do begin
    from_date = starting_date;
    to_date = null;
    cnt_rooms = null;
    open_period_exist = 0;
    id_room_type = t_id_room_type;
    for
      select p.OUT_DATE, coalesce( tso.occupied, 0)
      from   SYSTEM_LOOP_PERIOD ( :starting_date, :max_date )  P
             left outer join TMP_SMALL_OCCUP tso on tso.id_session = :id_helper_session
                                                and tso.for_date = p.OUT_DATE
                                                and tso.id_room_type = :id_room_type
      into :for_date, :t_occupied
    do begin
      if ( (:cnt_rooms = t_occupied) and (id_room_type = t_id_room_type)) then begin
        to_date = for_date;
        open_period_exist = 1;
      end else begin
        if (to_date is not null) then begin
          suspend;
          open_period_exist = 0;
        end
        else open_period_exist = 1;
        from_date =  for_date;
        to_date = for_date;
        id_room_type = t_id_room_type;
        cnt_rooms = t_occupied;
      end
    end

    if (:open_period_exist = 1) then suspend;
  end

  /**/
  delete from TMP_SMALL_OCCUP tso where tso.id_session = :id_helper_session;
  /**/


end
^

/* empty dependent procedure body */
/* Clear: FISCALIZE_LINE$FISC for: FISCAL_VALUE_GET$INT */
ALTER PROCEDURE FISCALIZE_LINE$FISC(ID_DOC_HEAD INTEGER,
DETAIL_LEVEL VARCHAR(20),
ADDITIONAL_PAYMENT_TEXT VARCHAR(30) = null)
 RETURNS(FISC_PRICE NUMERIC(15,4),
FISC_QTY NUMERIC(15,4),
FISC_TEXT VARCHAR(30),
FISC_GRP VARCHAR(10),
TRANSACTION_VALUE NUMERIC(15,4))
 AS
 BEGIN SUSPEND; END
^

/* Alter (FISCAL_VALUE_GET$INT) */
ALTER PROCEDURE FISCAL_VALUE_GET$INT(ID_DOC_HEAD INTEGER)
 RETURNS(FISCAL_VALUE NUMERIC(15,2),
FISCAL_PAYMENT_CNT INTEGER,
FISCAL_PAYMENT_VALUE NUMERIC(15,2),
SALE_REDUCTION_COEF DOUBLE PRECISION)
 AS
begin
  fiscal_value = 0;
  fiscal_payment_cnt = 0;
  fiscal_payment_value = 0;
  sale_reduction_coef = 1;

  select count(*),
         cast(iif(DH.DOC_VALUE_A = 0, 1, sum(PH.EQUAL_DOC_VALUE) / DH.DOC_VALUE_A) as double precision),
         sum(ph.NAT_VALUE)
  from   DOC_HEAD DH
         join DOCUMENT_PAYMENT PH on PH.ID_DOC_HEAD = DH.ID_DOC
         join PAY_DOC_TYPE_S PT on PT.ID_DOC_TYPE = PH.ID_DOC_TYPE
  where  DH.ID_DOC = :ID_DOC_HEAD
         and dh.FISC_STATUS > 0
         and PH.IS_STORNO = 0
         and pt.DOC_DIRECTION = 0
         and PT.IS_FISCALIZE = 1   --  get only fiscal payments
  group by DH.DOC_VALUE_A
  into   :fiscal_payment_cnt, :sale_reduction_coef, :fiscal_payment_value;

  if (:sale_reduction_coef > 1) then begin
    fiscal_value = :fiscal_payment_value / :sale_reduction_coef;
    sale_reduction_coef = 1;
  end else begin
    fiscal_value = :fiscal_payment_value;
  end
end
^

/* Alter (FISCALIZE_LINE$FISC) */
ALTER PROCEDURE FISCALIZE_LINE$FISC(ID_DOC_HEAD INTEGER,
DETAIL_LEVEL VARCHAR(20),
ADDITIONAL_PAYMENT_TEXT VARCHAR(30) = null)
 RETURNS(FISC_PRICE NUMERIC(15,4),
FISC_QTY NUMERIC(15,4),
FISC_TEXT VARCHAR(30),
FISC_GRP VARCHAR(10),
TRANSACTION_VALUE NUMERIC(15,4))
 AS
declare variable payment_cnt integer;
  declare variable fisc_value_coef double precision;
  declare variable target_fiscal_value numeric(15,2);
  declare variable fiscalized_value numeric(15,4);
  declare variable payment_value numeric(15,4);
  declare variable total_lines integer;
  declare variable lines_cnt integer;
  declare variable tmp_cnt integer;
  declare variable for_deposit integer;
  declare variable adv_payment_lines integer;
  declare variable one_line_text varchar(30);
  declare variable srv_groups integer;
  declare variable doc_rate numeric(15,6);
  declare variable round_to numeric(15,4);
begin
  /*  Description:
  ||
  function fiscalize(const text, taxGroup: string; qty, price, correction: Double): integer;
  function payment(const text, payType: string; summ: Double): integer;
  */
  FISC_PRICE = null;
  FISC_TEXT = null;
  FISC_GRP = null;
  TRANSACTION_VALUE = null;
  FISC_QTY = 1;
  FISCALIZED_VALUE = 0;
  LINES_CNT = 0;
  FISC_VALUE_COEF = 1;

  execute procedure FISCAL_VALUE_GET$INT (:ID_DOC_HEAD)
  returning_values  :target_fiscal_value, :payment_cnt, :payment_value, :fisc_value_coef;

  if (:payment_cnt = 0) then exit;

  doc_rate = null;
  select dh.DOC_RATE, dh.FOR_DEPOSIT, substring(H.DOC_ONE_LINE_TEXT from 1 for 30), c.ROUND_TO
  from   DOC_HEAD DH
         join ACCOUNT A on A.ID_ACCOUNT = dh.ID_ACCOUNT
         join HOTEL H on h.ID_HOTEL = a.ID_HOTEL
         join CURRS c on c.CURR = h.NATION_CURR
  where  DH.ID_DOC = :ID_DOC_HEAD
  into   :doc_rate, :for_deposit, :one_line_text, :round_to;

  select count(dl.ID_DOC_LINE), count(dv.ID_DOC_LINE), count(distinct s.ID_SERVICE_GROUP)
  from   DOC_LINE DL
         join SERVICES S on s.ID_SERVICE = dl.ID_SERVICE
         left outer join DOC_LINE_DEP_VALUES dv on dv.ID_DOC_LINE = dl.ID_DOC_LINE and :for_deposit = 0
  where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :total_lines, :adv_payment_lines, :srv_groups;

  if (:adv_payment_lines > 0 and trim(coalesce(:ADDITIONAL_PAYMENT_TEXT, '')) <> '') then
    DETAIL_LEVEL = 'aditional_payment';

  for
    select case
             when :detail_level = 'aditional_payment' then :ADDITIONAL_PAYMENT_TEXT
             when :DETAIL_LEVEL = 'group' then iif(:srv_groups = 1, SG.GROUP_NAME, :one_line_text)
             else S.SERVICE_NAME
           end,
           lines.fisc_codes,
           round_f(sum(DL.SINGLE_VALUE * DL.QTY_POST * :doc_rate) * :fisc_value_coef, 0.01),
           count(DL.ID_DOC_LINE)
    from   (select l.ID_DOC_LINE,
                   cast(substring(list(trim(coalesce(st.FISCAL_CODE, '')), '') from 1 for 10) as varchar(10)) as fisc_codes
            from   DOC_LINE l
                   join SALE_TAXATION_TAX stt on stt.ID_SALE_TAXATION = l.ID_SALE_TAXATION
                   join SALE_TAXES st on st.ID_SALE_TAX = stt.ID_SALE_TAX
                                         and st.REVENUE_DEDUCTION_TAX is distinct from 1
            where  l.ID_DOC_HEAD = :ID_DOC_HEAD
            group by l.ID_DOC_LINE) lines
           join DOC_LINE DL on dl.ID_DOC_LINE = lines.ID_DOC_LINE
           join SERVICES S on S.ID_SERVICE = DL.ID_SERVICE
           join SERVICE_GROUPS SG on SG.ID_SERVICE_GROUP = S.ID_SERVICE_GROUP
           left outer join DOC_LINE_DEP_VALUES dv on dv.ID_DOC_LINE = dl.ID_DOC_LINE
    group by iif((:DETAIL_LEVEL = 'aditional_payment') or (dv.ID_DOC_LINE is null), 0, 1),
           lines.fisc_codes,
           1
    order by iif((:DETAIL_LEVEL = 'aditional_payment') or (dv.ID_DOC_LINE is null), 0, 1),
           iif(sum(DL.SINGLE_VALUE * DL.QTY_POST * 1) * :fisc_value_coef > 0, 0, 1),  -- pull up positive value lines first
           lines.fisc_codes,
           1
    into   :FISC_TEXT, :FISC_GRP, :FISC_PRICE, :tmp_cnt
  do begin

    lines_cnt = :lines_cnt + :tmp_cnt;
    if (:lines_cnt = :total_lines) then begin
      FISC_PRICE = round_f(:target_fiscal_value, :round_to) - :fiscalized_value;
      -- to fiscalize rest value - in case of mixed fiscal/nonfiscal payments
    end

    TRANSACTION_VALUE = :FISC_PRICE;
    suspend;

    fiscalized_value = :fiscalized_value + :FISC_PRICE;
  end

end
^

/* Alter (FISCALIZE_PAYMENT$FISC) */
ALTER PROCEDURE FISCALIZE_PAYMENT$FISC(ID_DOC_HEAD INTEGER)
 RETURNS(FISC_SUM NUMERIC(15,4),
FISC_TEXT VARCHAR(30),
FISC_GRP VARCHAR(10))
 AS
declare variable sale_fisc_value numeric (15,4);
declare variable total_payment_value numeric (15,4);
  declare variable payment_value numeric (15,4);
  declare variable payment_cnt integer;
  declare variable payment_i integer;
  declare variable reduction_coef double precision;
begin

  execute procedure FISCAL_VALUE_GET$INT (:ID_DOC_HEAD)
  returning_values  :sale_fisc_value, :payment_cnt, :total_payment_value, :reduction_coef;
  if (:payment_cnt = 0) then exit;

  FISC_SUM = null;
  FISC_TEXT = null;
  FISC_GRP = null;
  PAYMENT_VALUE = 0;
  PAYMENT_I = 0;

  for
    select PT.PAYMENT_TYPE,
           substring(PT.FISCAL_CODE from 1 for 10),
           round_f(sum(PH.NAT_VALUE) /** :reduction_coef*/, c.ROUND_TO)
    from   DOCUMENT_PAYMENT PH
           join PAYMENT_TYPE PT on PT.ID_PAYMENT_TYPE = PH.ID_PAYMENT_TYPE
           join PAY_DOC_TYPE_S DT on DT.ID_DOC_TYPE = PH.ID_DOC_TYPE
           join HOTEL h on h.ID_HOTEL = dt.ID_HOTEL
           join CURRS c on c.CURR = h.NATION_CURR
    where  PH.ID_DOC_HEAD = :ID_DOC_HEAD
           and PH.IS_STORNO = 0
           and dt.DOC_DIRECTION = 0
           and DT.IS_FISCALIZE = 1
    group by 1, 2, c.ROUND_TO
    into   :FISC_TEXT, :FISC_GRP, :FISC_SUM
  do begin
    PAYMENT_I = :PAYMENT_I + 1;
    if (:PAYMENT_I < :PAYMENT_CNT) then begin
      PAYMENT_VALUE = :PAYMENT_VALUE + :FISC_SUM;
      suspend;
    end
  end

  FISC_SUM = :total_payment_value - :PAYMENT_VALUE;
  if (:FISC_SUM > 0) then suspend;
end
^

/* empty dependent procedure body */
/* Clear: GUEST_SET_MANUAL_STAY$INT for: GUEST_GET_STAY_CONDITIONS$INT */
ALTER PROCEDURE GUEST_SET_MANUAL_STAY$INT(RD_DBKEY CHAR(8),
ID_GUEST INTEGER,
FROM_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_INPUT_DETAILS$INT for: GUEST_GET_STAY_CONDITIONS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_DETAILS$INT(ID_TAR_CALC INTEGER,
ID_TEST_RATE INTEGER = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (GUEST_GET_STAY_CONDITIONS$INT) */
ALTER PROCEDURE GUEST_GET_STAY_CONDITIONS$INT(ID_GUEST INTEGER,
FOR_DATE DATE)
 RETURNS(ID_TYPE_STAY INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
IS_MANUAL_TYPE_STAY SMALLINT)
 AS
declare variable room_beds integer;
  declare variable cnt integer;
  declare variable gcnt integer;
  declare variable tmp_id_guest integer;
begin
  select ror.ID_ROOM,
         --iif(GS.ID_ROOM_TYPE <> -1, gsrt.ID_ROOM_TYPE, rrt.ID_ROOM_TYPE) id_room_type,
         coalesce(gsrt.ID_ROOM_TYPE, ror.id_room_type) as id_room_type,
         gs.ID_TYPE_STAY, coalesce(r.BEDS, rrt.BEDS) as beds,
         gs.ID_BOARD, gs.ID_TARIFF
  from   GUEST_STAY GS
         join GUEST G on G.ID_GUEST = gs.ID_GUEST
         join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
         left outer join ROOM_TYPES gsrt on gsrt.ID_ROOM_TYPE = gs.ID_ROOM_TYPE
         left outer join RES_OCCUPANCY_ROOM$INT (rd.ID_RESERV_DETAIL, gs.FOR_DATE, gs.ID_ROOM, rd.ID_ROOM_TYPE) ror on 1=1
         left outer join ROOMS R on r.ID_ROOM = ror.ID_ROOM
         --left outer join ROOM_TYPES RRT on RRT.ID_ROOM_TYPE = coalesce(r.ID_ROOM_TYPE, rd.ID_ROOM_TYPE)
         left outer join ROOM_TYPES RRT on rrt.ID_ROOM_TYPE = ror.ID_ROOM_TYPE
  where  GS.ID_GUEST = :id_guest
         and GS.FOR_DATE = :for_date
  into   :ID_ROOM, :ID_ROOM_TYPE, :ID_TYPE_STAY, :room_beds,
         :ID_BOARD, :ID_RATE;


  if (:ID_TYPE_STAY > 0) then begin
    IS_MANUAL_TYPE_STAY = 1;
  end else if (coalesce(:room_beds, 0) > 0) then begin
    IS_MANUAL_TYPE_STAY = 0;
    -- count guests and calculate type_stay according to room
    cnt = 0;
    gcnt = 0;
  
    for
      select G.ID_GUEST
      from   GUEST G
             join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
             join GUEST_STAY GS on GS.ID_GUEST = G.ID_GUEST
             left join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
             left outer join SYSTEM_CALC_AGE_INYEARS(GC.BIRTH_DAY, G.FROM_DATE) CAY on 0=0
      where  GS.ID_ROOM = :id_room
             and GS.FOR_DATE = :FOR_DATE
             and rd.IS_ANUL = 0
      order by iif(CAY.AGE_INYEARS > 16, 999, CAY.AGE_INYEARS) desc, G.ID_GUEST asc
      into   :tmp_id_guest
    do begin
      cnt = cnt + 1;
      if (:tmp_id_guest = :id_guest) then gcnt = :cnt;
    end
  
    execute procedure TYPE_STAY_GET (:room_beds, :gcnt, :cnt)
    returning_values  :ID_TYPE_STAY;
    /*if (:cnt in (0, 1)) then tmp_type_stay_code = 'ALONE';
    else if (:gcnt <= :room_beds) then tmp_type_stay_code = 'BED';
    else tmp_type_stay_code = 'EXTRA_BED';
  
    select ID_TYPE_STAY
    from   TYPE_STAY
    where  TYPE_STAY_CODE = :tmp_type_stay_code
    into   :ID_TYPE_STAY;*/
  end

  suspend;
end
^

/* empty dependent procedure body */
/* Clear: RES_CHECK_OUT_GUESTS$RSV for: GUEST_SET_MANUAL_STAY$INT */
ALTER PROCEDURE RES_CHECK_OUT_GUESTS$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND SMALLINT = 0)
 AS
 BEGIN EXIT; END
^

/* Alter (GUEST_SET_MANUAL_STAY$INT) */
ALTER PROCEDURE GUEST_SET_MANUAL_STAY$INT(RD_DBKEY CHAR(8),
ID_GUEST INTEGER,
FROM_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable for_date date;
  declare variable id_room_type integer;
  declare variable id_type_stay integer;
  declare variable current_id_type_stay integer;
  declare variable current_id_room_type integer;
  declare variable gs_dbkey char(8);
  declare variable has_manual_stay smallint;
  declare variable id_room integer;
  declare variable room_name varchar(20);
begin
  /*  Description:
  ||
  */
  ERR_CODE = 0;
  ERR_TEXT = '';
  execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MANUAL_STAY');

  has_manual_stay = 0;
  for
    select GS.RDB$DB_KEY, GS.FOR_DATE, gs.ID_TYPE_STAY, gs.ID_ROOM_TYPE, gs.ID_ROOM
    from   GUEST_STAY GS
    where  GS.ID_GUEST = :ID_GUEST
           and GS.FOR_DATE >= :FROM_DATE
    into   :gs_dbkey, :for_date, :current_id_type_stay, :current_id_room_type, :id_room
  do begin
    select gsc.ID_TYPE_STAY, gsc.ID_ROOM_TYPE
    from   GUEST_GET_STAY_CONDITIONS$INT (:id_guest, :for_date) gsc
    into   :id_type_stay, :id_room_type;

    if (coalesce(:id_room_type, 0) < 0) then begin
      err_code = -18;
      err_text = f_character(29) || :ID_GUEST || f_character(28) || :for_date;
      exit;
    end
    if (coalesce(:id_type_stay, -1) < 0) then begin
      if (:id_room > 0) then begin
        select r.ROOM_NAME
        from   ROOMS R
        where  r.ID_ROOM = :id_room
        into   :room_name;
      end else begin
        select rt.TYPE_ROOM
        from   ROOM_TYPES RT
        where  rt.ID_ROOM_TYPE = :id_room_type
        into   :room_name;
      end
      err_code = -17;
      err_text = f_character(29) || :ID_GUEST || f_character(28) || :for_date || f_character(28) || :room_name;
      exit;
    end

    if ((:current_id_room_type <> :id_room_type) or (:current_id_type_stay <> :id_type_stay)) then begin
      update GUEST_STAY GSU
      set    GSU.ID_ROOM_TYPE = :id_room_type,
             GSU.ID_TYPE_STAY = :id_type_stay
      where  GSU.RDB$DB_KEY = :gs_dbkey;
    end
    has_manual_stay = 1;
  end

  if (:has_manual_stay = 1) then
    update RESERV_DETAIL RD
    set    RD.HAS_DIFFERENT_TYPE_STAY = 1,
           RD.HAS_DIFFERENT_ROOM_TYPE = 1
    where  RD.RDB$DB_KEY = :rd_dbkey;

end
^

/* Alter (HOTEL_GET_FREE$CHM) */
ALTER PROCEDURE HOTEL_GET_FREE$CHM(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER)
 RETURNS(FOR_DATE DATE,
AVAILABLE INTEGER,
OCCUPIED INTEGER)
 AS
begin
  for
    select aos.for_date, sum(aos.available), sum(aos.occupied)
    from   AVAILABILITY_OCCUP_SMALL$INT (:from_date, :to_date, :id_hotel, 0) aos
    group by 1
    into   :for_date, :available, :occupied
  do suspend;
end
^

/* empty dependent procedure body */
/* Clear: CREATE_SESSION_BOOKINGS$WBE for: IMPORT_BOOKING_FINALIZE$EXC */
ALTER PROCEDURE CREATE_SESSION_BOOKINGS$WBE(WBE_SESSION_ID BIGINT,
ARANGER_ID INTEGER,
LANG_CODE VARCHAR(3))
 RETURNS(SELECTION_ID VARCHAR(20),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (IMPORT_BOOKING_FINALIZE$EXC) */
ALTER PROCEDURE IMPORT_BOOKING_FINALIZE$EXC(BOOKING_ID INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1,
STATUS VARCHAR(50) = null,
CONFIRMATION_NUMBER NAME_20 = null,
CANCELATION_NUMBER NAME_20 = null)
 RETURNS(RECORD_TIMESTAMP TIMESTAMP,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable booking_db_key char(8);
  declare variable dummy_int integer;
  declare variable dummy_text varchar(255) ;
  declare variable res_id_room integer;
  declare variable id_room integer;
  declare variable id_room_type integer;
  declare variable id_hotel integer;
  declare variable system_date date;
  declare variable from_date date;
  declare variable gs_dbkey char(8);
  declare variable has_different_room_type smallint;
begin
  ERR_CODE=0;
  ERR_TEXT=null;
  id_room = null;
  force_res_finalize = coalesce(:force_res_finalize, 1);

  execute procedure sys_dbg('exc IMPORT_BOOKING_FINALIZE$EXC => CLEAR_ORPHAN_GUESTS$EXC');
  execute procedure CLEAR_ORPHAN_GUESTS$EXC(:booking_id)
  returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  select b.rdb$db_key, b.ID_ROOM, b.ID_ROOM_TYPE, b.ID_HOTEL, b.FROM_DATE
  from   reserv_detail b
  where  b.id_reserv_detail = :booking_id
  into   :booking_db_key, :res_id_room, :id_room_type, :id_hotel, :from_date;

  execute procedure RES_GUEST_SAVE_DIFF$INT(:booking_db_key);

  if (:res_id_room < 0) then begin
    select sd.SYSTEM_DATE
    from   SYSTEM_DATE_GET (:id_hotel) sd
    into   :system_date;

    select ro.ID_ROOM, ro.ID_ROOM_TYPE
    from   RES_OCCUPANCY_ROOM$INT (:BOOKING_ID, maxdate(:system_date, :from_date), null, :id_room_type) ro
    into   :id_room, :id_room_type;

--    has_different_room_type = null;
    if (:id_room <> :res_id_room) then begin
      for
        select gs.RDB$DB_KEY
        from   GUEST_STAY GS
               join GUEST G on g.ID_GUEST = gs.ID_GUEST
        where  g.ID_RESERV_DETAIL = :BOOKING_ID
               and gs.FOR_DATE >= maxdate(:system_date, :from_date)
               and gs.ID_ROOM <> :id_room
        into   :gs_dbkey
      do begin
        update GUEST_STAY gsu
        set    gsu.ID_ROOM = :id_room
               --gsu.ID_ROOM_TYPE = iif (gsu.ID_ROOM_TYPE = -1, :id_room_type, gsu.ID_ROOM_TYPE)
        where  gsu.RDB$DB_KEY = :gs_dbkey;
        --has_different_room_type = 1;
      end

      update GUEST G
      set    G.ID_ROOM = :id_room
      where  g.ID_RESERV_DETAIL = :BOOKING_ID;
    end
  end

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null,   --force recalculation
         rd.ID_ROOM = coalesce(:id_room, :res_id_room)
         --rd.HAS_DIFFERENT_ROOM_TYPE = coalesce(:has_different_room_type,  rd.HAS_DIFFERENT_ROOM_TYPE)
  where  rd.RDB$DB_KEY = :booking_db_key;

  if (1 = :force_res_finalize) then begin
    execute procedure sys_dbg('exc IMPORT_BOOKING_FINALIZE$EXC => RES_FINALIZE_SHAREOPTION$INT');
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:booking_db_key, 0)
    returning_values  :dummy_int, :dummy_text, :dummy_int, :dummy_int;
  end

  execute procedure APPLY_BOOKING_STATUS$EXC(
    null, :booking_db_key, :status, :confirmation_number, :cancelation_number
  );

  select b.change_time
  from   reserv_detail b
  where  b.rdb$db_key =:booking_db_key
  into   :record_timestamp;
end
^

ALTER PROCEDURE RES_GET_INFO$RSV(ID_RESERV_DETAIL INTEGER,
RETURN_BALANCE SMALLINT = 1,
RETURN_SHARE SMALLINT = 1,
RETURN_GEUSTDATA SMALLINT = 1)
 RETURNS(NUMBER VARCHAR(62),
AGENT_PROFILE_NAME VARCHAR(100),
ARRIVALS VARCHAR(255),
DEPARTURES VARCHAR(255),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
ID_ROOM INTEGER,
ROOM VARCHAR(60),
ID_ROOM_TYPE INTEGER,
ROOM_FEATURES BLOB,
GUESTS VARCHAR(255),
GUESTS_CNT INTEGER,
PERSON_PROFILE_NAME VARCHAR(150),
RATES VARCHAR(255),
BOARDS VARCHAR(255),
PACKETS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY VARCHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
BALANCE VARCHAR(255),
OPEN_CHARGES INTEGER,
CHECK_STATUS INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
NOTE VARCHAR(2000),
NOTE_GRP VARCHAR(255),
VOUCHER_RENDER VARCHAR(512),
ACC_ROUTING VARCHAR(255),
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
BUSY_GRP INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
GUEST_TYPE_COLOR INTEGER,
IS_CLEAN INTEGER,
ROOM_PRIVATE_STATUS TLOGICAL)
 AS
declare variable arrival varchar(20);
declare variable departure varchar(20);
declare variable rd_dbkey char(8);
declare variable no_use varchar(1024);
declare variable rd_adult_count integer;
declare variable rd_child_count integer;
declare variable groupname varchar(100);
declare variable virtual_room varchar(10);
declare variable earlycheckout_date date;
begin
  arrivals = '';
  departures = '';
  rates = '';
  NOTE_GRP = null;

  IS_CLEAN = 0;

  select AP.PROFILE_NAME, RD.ADULT_COUNT, RD.CHILD_COUNT,
         R.ID_ROOM, R.ROOM_NAME, coalesce(rd.VIRTUAL_ROOM, 'i'||RM.ID_ROOM), coalesce(R.ID_ROOM_TYPE, RM.ID_ROOM_TYPE, RD.ID_ROOM_TYPE),
         RD.CHECK_STATUS, PP.PROFILE_NAME || coalesce(' (' || GT.GUEST_TYPE_NAME || ')', ''),
         RD.FROM_DATE, RD.TO_DATE, RG.GROUP_NAME,
         RD.ID_GROUP, RD.ROOM_FEATURES, RD.COMMING_KIND, RD.LEAVING_KIND - 1,
         RD.NUMBER, RD.NOTE, RD.RDB$DB_KEY, RD.ID_HOTEL, RD.ACC_ROUTING,
         GT.GUEST_TYPE_COLOR, coalesce(r.IS_CLEAN, 1), g.EARLYCHECKOUT_DATE
  from   RESERV_DETAIL RD
         left outer join RESERV_GROUP RG on RG.ID_RESERV_GROUP = RD.ID_GROUP
         left outer join PROFILE AP on AP.ID_PROFILE = RD.ID_AGENT_PROFILE
         left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
         left outer join ROOM_MAP$EXC RM on RM.ID_ROOM = RD.ID_ROOM
         left outer join PROFILE PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
         left outer join PROFILE_PERSON PPp on PPp.ID_PROFILE = PP.ID_PROFILE
         left outer join GUEST_TYPE GT on GT.ID_GUEST_TYPE = PPp.ID_GUEST_TYPE
         left outer join GUEST G on g.ID_GUEST = rd.ID_TITULAR
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :agent_profile_name, :rd_adult_count, :rd_child_count,
         :id_room, :room, :virtual_room, :id_room_type,
         :check_status, :person_profile_name,
         :arrival_date, :departure_date, :groupname,
         :id_group, :room_features, :comming_kind, :is_late_departure,
         :number, :note, :rd_dbkey, :id_hotel, :acc_routing,
         :guest_type_color, :is_clean, :earlycheckout_date;


  ARRIVALS = iif(extract(year from current_date) = extract(year from :ARRIVAL_DATE),
               formatDate(:ARRIVAL_DATE, 'D;dd.mm')||' ('||(:DEPARTURE_DATE - :ARRIVAL_DATE)||')',
               formatDate(:ARRIVAL_DATE, 'D;dd.mm.yy')||' ('||(:DEPARTURE_DATE - ARRIVAL_DATE)||')');
  DEPARTURES = iif(extract(year from current_date) = extract(year from :DEPARTURE_DATE),
               formatDate(:DEPARTURE_DATE, 'D;dd.mm'),
               formatDate(:DEPARTURE_DATE, 'D;dd.mm.yy'));
  for
    select iif(extract(year from current_date) = extract(year from g.FROM_DATE),
               formatDate(g.FROM_DATE, 'D;dd.mm')||' ('||(G.TO_DATE - G.FROM_DATE)||')',
               formatDate(g.FROM_DATE, 'D;dd.mm.yy')||' ('||(G.TO_DATE - G.FROM_DATE)||')'),
           iif(extract(year from current_date) = extract(year from g.TO_DATE),
               formatDate(g.TO_DATE, 'D;dd.mm'),
               formatDate(g.TO_DATE, 'D;dd.mm.yy'))
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
           and ((g.FROM_DATE <> :ARRIVAL_DATE) or (g.TO_DATE <> :DEPARTURE_DATE))
    into   :arrival, :departure
  do begin
    if (:ARRIVALS not containing :arrival) then ARRIVALS = :ARRIVALS || ','||:arrival;
    if (:DEPARTURES not containing :departure) then DEPARTURES = :DEPARTURES || ','||:departure;
  end

  execute procedure RES_GET_PRICE$INT(:rd_dbkey, 'SECURITY')
  returning_values  :room_price, :room_currency, :room_price_details, :no_use, :no_use;

  if (coalesce(:return_balance,1)=1) then
    execute procedure RES_GET_BALLANCE$INT(:id_reserv_detail)
    returning_values  :balance, :no_use, :no_use, :open_charges, :no_use;

  if (:groupname <> '') then agent_profile_name = coalesce(:agent_profile_name, '') || ' / ' || coalesce(:groupname, '');

  execute procedure RES_GET_ATTENTION_STATUS$INT(:arrival_date, :departure_date, :check_status, :id_hotel)
  returning_values  :attention_status;

  if (coalesce(:return_share,1)=1) then begin
    execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'RENDER', null)
    returning_values  :in_share, :no_use, :shares_preview;
    if (:IN_SHARE = 1) then ROOM = coalesce(:ROOM, :virtual_room);
  end

  if (coalesce(:return_geustdata,1)=1) then begin
    execute procedure RES_GET_GUEST_DATA$INT('DETAIL', :id_reserv_detail)
    returning_values  :boards, :rates, :packets, :voucher_render;
  end

  execute procedure RES_GET_ANNULSTATUS(:rd_dbkey)
  returning_values  :annul_status;

  guests = :rd_adult_count || ' + ' || :rd_child_count || ' ';
  guests_cnt = :rd_adult_count + :rd_child_count;

  if (:check_status > 1) then  busy_grp = 24;
  else busy_grp = 1;

  ROOM_PRIVATE_STATUS = 0;
  select cast(1 as smallint)
  from   SYSTEM_DATE_GET (:ID_HOTEL) sd
         join ROOM_MAGIC rm on rm.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                               and rm.ROOM_STATUS = 'PRIVATE'
                               and rm.BUSY_DATE = mindate(maxdate(:ARRIVAL_DATE, sd.SYSTEM_DATE), coalesce(:earlycheckout_date, :DEPARTURE_DATE) - 1)
  into   :ROOM_PRIVATE_STATUS;

  suspend;
end
^

/* Alter (MONITOR_ROOM_GANTT$HM) */
ALTER PROCEDURE MONITOR_ROOM_GANTT$HM(FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ID_ROOM INTEGER,
GFROM_DATE DATE,
IS_MOVED_FROM INTEGER,
GTO_DATE DATE,
IS_MOVED_TO INTEGER,
BUSY_GRP INTEGER,
OCCUPANT_ID INTEGER,
IN_SHARE SMALLINT,
ID_GROUP INTEGER,
ATTENTION_STATUS SMALLINT)
 AS
declare variable contiguous_id_room integer;
begin
  for
    select ID_ROOM, GFROM_DATE, IS_MOVED_FROM, GTO_DATE,
           IS_MOVED_TO, BUSY_GRP, OCCUPANT_ID
    from   MONITOR_ROOM_GANTT$INT(:from_date, :to_date)
    into   :id_room, :gfrom_date, :is_moved_from, :gto_date,
           :is_moved_to, :busy_grp, :occupant_id
  do begin
    if (:gfrom_date = :from_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gfrom_date - 1)
      into   :contiguous_id_room;
      if ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_from = 1;
      select O.FROM_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gfrom_date;
    end

    if (:gto_date = :to_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gto_date + 1)
      into   :contiguous_id_room;
      if ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_to = 1;
      select O.TO_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gto_date;
    end

    if (busy_grp in (1, 24)) then begin
      select RI.ATTENTION_STATUS, RI.ID_GROUP, RI.IN_SHARE
      from RES_GET_INFO$RSV(:occupant_id, 0, 1, 0) RI
      into :attention_status, :id_group, :in_share;
    end else begin
      id_group = null;
      attention_status = null;
      in_share = null;
      if (exists(
        select *
        from   ROOMS_SHARE RS
        where  RS.ID_RESERV_DETAIL = :occupant_id
      )) then in_share = 1;
      else in_share = 0;
    end
    suspend;
  end
end
^

/* Alter (MONITOR_ROOM_GANTT_OCCUPANT$HM) */
ALTER PROCEDURE MONITOR_ROOM_GANTT_OCCUPANT$HM(FROM_DATE DATE,
TO_DATE DATE,
REQUEST_OCCUPANT_ID INTEGER)
 RETURNS(ID_ROOM INTEGER,
GFROM_DATE DATE,
IS_MOVED_FROM INTEGER,
GTO_DATE DATE,
IS_MOVED_TO INTEGER,
BUSY_GRP INTEGER,
OCCUPANT_ID INTEGER,
IN_SHARE SMALLINT,
ID_GROUP INTEGER,
ATTENTION_STATUS SMALLINT)
 AS
declare variable contiguous_id_room integer;
begin
  for
    select ID_ROOM, GFROM_DATE, IS_MOVED_FROM, GTO_DATE,
           IS_MOVED_TO, BUSY_GRP, OCCUPANT_ID
    from   MONITOR_ROOM_GANTT$INT(:from_date, :to_date, :request_occupant_id)
    into   :id_room, :gfrom_date, :is_moved_from, :gto_date,
           :is_moved_to, :busy_grp, :occupant_id
  do begin
    if (:gfrom_date = :from_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gfrom_date - 1)
      into   :contiguous_id_room;

      if     ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_from = 1;

      select O.FROM_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gfrom_date;
    end

    if (:gto_date = :to_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gto_date + 1)
      into   :contiguous_id_room;

      if ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_to = 1;

      select O.TO_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gto_date;
    end

    if (exists(
      select *
      from   ROOMS_SHARE RS
      where  RS.ID_ROOM = :id_room
             and RS.BUSY_DATE between :from_date and :to_date
    )) then in_share = 1;
    else in_share = 0;
  
    if (:busy_grp in (1,24)) then begin
      select RI.ATTENTION_STATUS, RI.ID_GROUP
      from   RES_GET_INFO$RSV(:occupant_id, 0, 0, 0) RI
      into   :attention_status, :id_group;
    end else begin
      id_group = null;
      attention_status = null;
    end
    suspend;
  end
end
^

/* Alter (MONITOR_ROOMTYPE_GRAPHIC$HM) */
ALTER PROCEDURE MONITOR_ROOMTYPE_GRAPHIC$HM(IN_FROM_DATE DATE,
IN_TO_DATE DATE,
IN_ID_AGENT INTEGER,
IN_ID_ROOM_TYPE INTEGER,
IN_ONLY_ARRIVES INTEGER,
ID_HOTEL INTEGER)
 RETURNS(OUT_FOR_DATE DATE,
OUT_ALL_ROOMS INTEGER,
OUT_RESERV_ROOMS INTEGER,
OUT_OCUP_ROOMS INTEGER,
OUT_BLOCK_ROOMS INTEGER)
 AS
declare variable ibusy_date date;
  declare variable bgrp integer;
  declare variable rooms_cnt integer;
  declare variable for_date date;
  declare variable rt_rooms integer;
  declare variable id_room_type integer;

begin
  if (:in_from_date > :in_to_date) then exit;
  if ((:in_to_date - :in_from_date) > 90 ) then exit;
  out_for_date = null;
  out_reserv_rooms = null;
  out_ocup_rooms= null;
  out_block_rooms = null;
  for
    select out_date
    from   SYSTEM_LOOP_PERIOD(:in_from_date, :in_to_date)
    into   :for_date
  do begin
    out_all_rooms = 0;
    for
      select RT.ID_ROOM_TYPE
      from   HOTEL H
             join ROOM_TYPES RT ON RT.ID_HOTEL = H.ID_HOTEL
      where  H.ID_HOTEL = :id_hotel
      into   :id_room_type
    do begin
      rt_rooms = null;
      select max(AD.CNT_ROOMS)
      from   HOTEL H
             join ALLOTMENT_DETAIL AD ON AD.ID_ALLOTMENT = H.ID_INVENTORY_ALLOTMENT
      where  H.ID_HOTEL = :id_hotel
             and AD.ID_ROOM_TYPE = :id_room_type
             and :for_date between AD.FROM_DATE and AD.TO_DATE
      into   :rt_rooms;
      out_all_rooms = :out_all_rooms + coalesce(:rt_rooms, 0);
    end
    out_for_date = :for_date;
    out_reserv_rooms = 0;
    out_ocup_rooms   = 0;
    out_block_rooms  = 0;
    for
      select RM.BUSY_DATE, RM.BUSY_GROUP_TYPE, count(distinct RM.ID_ROOM)
      from   ROOM_MAGIC RM
             /*left outer join ROOM_PERIOD$PMS P on P.ID_ROOM = RM.ID_ROOM
                                                  and rm.BUSY_DATE between P.FROM_DATE and P.TO_DATE    */
      where  RM.BUSY_DATE = :for_date
             and RM.ID_HOTEL = :id_hotel
             and RM.BUSY_TYPE <> 'VALUE_RESERVS'
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and ((RM.ID_AGENT = :in_id_agent) or (:in_id_agent = -1))
             and ((RM.ID_ROOM_TYPE = :in_id_room_type) or (:in_id_room_type = -1))
             and ((:in_only_arrives <> 1) or (RM.DAY_ACTION containing 'CHECK_IN'))
             --and ((RM.ID_ROOM < 0) or (P.IS_AVAILABLE is not distinct from 1))
             and rm.ROOM_STATUS is distinct from 'PRIVATE' -- replace previous clause
      group by RM.BUSY_DATE, RM.BUSY_GROUP_TYPE
      order by RM.BUSY_DATE asc, RM.BUSY_GROUP_TYPE asc
      into   :ibusy_date, :bgrp, :rooms_cnt
    do begin
      if (:ibusy_date <> :out_for_date) then begin
        suspend;
        out_reserv_rooms = 0;
        out_ocup_rooms   = 0;
        out_block_rooms  = 0;
        out_for_date     = :ibusy_date;
      end
      if (:bgrp in (18, 20)) then
        out_block_rooms = (:out_block_rooms + coalesce(:rooms_cnt, 0));
      else if (:bgrp = 1) then
        out_reserv_rooms = (:out_reserv_rooms + coalesce(:rooms_cnt, 0));
      else
        out_ocup_rooms = (:out_ocup_rooms + coalesce(:rooms_cnt, 0));
    end
    suspend;
  end

end
^

/* Alter (NON_DOCUMENTED_INFO_GET$INT) */
ALTER PROCEDURE NON_DOCUMENTED_INFO_GET$INT(ID_OWNER INTEGER,
ID_ROOM INTEGER)
 RETURNS(OUT_LATE_INFO VARCHAR(255),
OUT_CURR_INFO VARCHAR(255),
OUT_NEXT_INFO VARCHAR(255))
 AS
declare variable from_date date;
declare variable to_date date;
declare variable value_post_total numeric(15,4);
declare variable curr_post varchar(3);
declare variable sub_delim varchar(3);
declare variable short_date_format varchar(50);
declare variable value_format varchar(50);
declare variable has_next smallint;
declare variable tmp_info varchar(5000);
declare variable billing_type varchar(10);
declare variable prev_billing_type varchar(10);
declare variable is_first smallint;
begin
  if (:ID_OWNER is null) then exit;

  OUT_LATE_INFO = null;
  OUT_CURR_INFO = null;
  OUT_NEXT_INFO = null;
  tmp_info = null;

  from_date = '01.01.1500';
  sub_delim = '/ ';
  short_date_format = 'D;dd.mm';
  value_format = 'F;0.00';

  is_first = 1;
  for
    select P.BILLING_PERIOD_FROM, P.BILLING_DATE, P.BILLING_TYPE
    from   PMS_BILLING_CYCLE_CALC(:id_owner) P
    into   :FROM_DATE, :TO_DATE, :billing_type
  do begin
    has_next = 0;
    if (:PREV_BILLING_TYPE <> :BILLING_TYPE) then
      tmp_info = null;

    tmp_info = coalesce(trim(:tmp_info) || '; ', '');

    if (:BILLING_TYPE in ('current', 'late') and :to_date is not null) then
        tmp_info = :tmp_info || formatdate(:to_date, :short_date_format) || :sub_delim;

    if (:ID_OWNER is not null) then begin
      for
      /*  select sum(P.VALUE_POST * iif(P.IS_OWNER_INCOME = 1, 1, -1)), P.CURR_POST
        from   PMS_ACC_POST_TO_BILL_GET$INT(:ID_OWNER, :ID_ROOM, iif(:IS_FIRST=1,'01.01.1500',:FROM_DATE), coalesce(:TO_DATE, '01.01.2500'), 0) P
        group by 2
        into   :value_post_total, :curr_post  */
        select   sum(coalesce(OP.INCOME_VALUE, OP.OUTGO_VALUE) * iif(coalesce(APP.IS_OWNER_INCOME, 0) = 1, 1, -1)), coalesce(OP.INCOME_CURR, OP.OUTGO_CURR)
        from     OWNER_POST OP
                 left outer join ACCOUNT_POST$PMS  APP on APP.ID_ACCOUNT_POST = OP.ID_ACCOUNT_POST$PMS
        where    OP.ID_OWNER = :id_owner
                 and ((OP.ID_ROOM = :id_room) or (:id_room is null))
                 and OP.POST_DATE between iif(:IS_FIRST=1, cast('01.01.1500' as date), :FROM_DATE) and coalesce(:TO_DATE, cast('01.01.2500' as date))
                 and OP.IS_ANUL = 0
        group by 2
        into     :value_post_total, :curr_post
      do begin
        tmp_info = trim(:tmp_info) || iif(:has_next = 1, ', ', '');
        tmp_info = iif(:tmp_info = '', '', trim(:tmp_info) || ' ') || FORMATFLOAT(:VALUE_POST_TOTAL, :value_format) || ' ' || :CURR_POST;
        has_next = 1;
      end
    end

    if (:has_next = 0) then begin
      select O.ID_CURRENCY
      from   OWNER$PMS O
      where  O.ID_OWNER = :ID_OWNER
      into   :CURR_POST;

      if (:billing_type in ('late', 'current')) then
        tmp_info = iif(:tmp_info = '', '', trim(:tmp_info) || ' ') || FORMATFLOAT(0, :value_format) || ' ' || :CURR_POST;
    end
    if (:billing_type = 'late') then OUT_LATE_INFO = substring(:tmp_info from 1 for 254);
    if (:billing_type = 'current') then OUT_CURR_INFO = substring(:tmp_info from 1 for 254);
    if (:billing_type = 'next') then OUT_NEXT_INFO = substring(:tmp_info from 1 for 254);
    prev_billing_type = :billing_type;
    is_first = 0;
  end
  suspend;
end
^

/* empty dependent procedure body */
/* Clear: OCCUPANCY_OVERBOOK$INT for: OCCUPANCY_OVERBOOK_MAX$INT */
ALTER PROCEDURE OCCUPANCY_OVERBOOK$INT(ID_AGENT INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM_TYPE INTEGER,
RESERV_STATUS VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (OCCUPANCY_OVERBOOK_MAX$INT) */
ALTER PROCEDURE OCCUPANCY_OVERBOOK_MAX$INT(FROM_DATE DATE,
TO_DATE DATE,
ID_ALLOTMENT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_AGENT INTEGER = null)
 RETURNS(MAX_BOOKDATE DATE,
MAX_BOOKROOMS INTEGER,
MIN_AVAILABLE INTEGER)
 AS
declare variable id_hotel integer;
declare variable contingent_rooms integer;
begin
  max_bookdate = null;
  max_bookrooms = null;
  min_available = null;

  select id_hotel
  from   ROOM_TYPES rt
  where  rt.id_room_type = :id_room_type
  into   :id_hotel;

  if (:id_agent is null) then begin
    /* TOTAL OCCUPANCY REQUESTED */
    select first 1 aos.for_date, aos.occupied, aos.available
    from   AVAILABILITY_OCCUP_SMALL$INT(:from_date, :to_date, :id_hotel, 0) aos
    where  aos.id_room_type = :id_room_type
    order by aos.available
    into   :max_bookdate, :max_bookrooms, :min_available;

  end else begin
    /* CONTINGENT IS REQUESTED */
    select first 1 ad.FOR_DATE,
           AD.CNT_ROOMS,
           AD.CNT_ROOMS - (select count(distinct RM.ID_ROOM)
                           from   ROOM_MAGIC RM
                           where  RM.BUSY_DATE = ad.FOR_DATE
                                  and RM.ID_ROOM_TYPE = ad.ID_ROOM_TYPE
                                  and RM.BUSY_TYPE is distinct from 'VALUE_RESERVS'
                                  and RM.DAY_ACTION not containing 'CHECK_OUT'
                                  and RM.ID_AGENT = :ID_AGENT) as available_contingent
    from   ALLOTMENT_BYDATES$INT (:id_allotment, :id_hotel, :FROM_DATE, :TO_DATE) AD
    where  AD.ID_ROOM_TYPE = :id_room_type
           and ad.CNT_ROOMS > 0  -- get only real contingent
    order by 3 asc
    into   :max_bookdate, :contingent_rooms, :min_available;

    max_bookrooms = :contingent_rooms - :min_available;
  end

  execute procedure sys_dbg('occ OCCUPANCY_OVERBOOK_MAX$INT maxbook_date = '||coalesce(:MAX_BOOKDATE, 'null'));
  execute procedure sys_dbg('occ OCCUPANCY_OVERBOOK_MAX$INT maxbook_rooms = '||coalesce(:MAX_BOOKROOMS, 'null'));
  execute procedure sys_dbg('occ OCCUPANCY_OVERBOOK_MAX$INT available_rooms = '||coalesce(:MIN_AVAILABLE, 'null'));

end
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE_OCCUPANCY$INT for: OCCUPANCY_RESERV$INT */
ALTER PROCEDURE RES_FINALIZE_OCCUPANCY$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ERROR_CONTEXT VARCHAR(200),
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_DEL$RSV for: OCCUPANCY_RESERV$INT */
ALTER PROCEDURE RES_GUEST_DEL$RSV(ID_GUEST INTEGER,
REASON VARCHAR(50) = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (OCCUPANCY_RESERV$INT) */
ALTER PROCEDURE OCCUPANCY_RESERV$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable from_date date;
  declare variable to_date date;
  declare variable id_room integer;
  declare variable id_room_type integer;
  declare variable id_agent integer;
  declare variable country_code varchar(50);
  declare variable busy_group_type integer;
  declare variable busy_type varchar(50);
  declare variable day_action_int smallint;
  declare variable busy_date date;
  declare variable res_edit_status varchar(255);
  declare variable system_date date;
  declare variable id_hotel integer;
  declare variable gst_ad_in integer;
  declare variable gst_ad_out integer;
  declare variable gst_ad_stay integer;
  declare variable gst_ch_in integer;
  declare variable gst_ch_out integer;
  declare variable gst_ch_stay integer;
  declare variable acc_routing varchar(50);
  declare variable check_out_date date;
  declare variable is_anul integer;
  declare variable room_status varchar(50);
  declare variable force_booking_export smallint;
begin
  /*  Description: */
  err_code = 0;
  err_text = '';
  warn_code = null;
  busy_group_type = 1;
  force_booking_export = 0;

  select RD.ID_RESERV_DETAIL, RD.FROM_DATE, RD.TO_DATE,
         RD.ID_ROOM, coalesce(R.ID_ROOM_TYPE, RD.ID_ROOM_TYPE), P.ID_AGENT,
         RD.COUNTRY, RD.RES_EDIT_STATUS, RD.ACC_ROUTING,
         case  --TODO permanently remove reserv_status
           when RD.CHECK_STATUS = -3 then 'VALUE_RESERVS'
           when RD.CHECK_STATUS = -2 then 'VALUE_NOTCONFIRMED'
           when RD.CHECK_STATUS = -1 then 'VALUE_CONFIRMED'
           when RD.CHECK_STATUS = 0 then 'CHECK_IN'
           when RD.CHECK_STATUS = 1 then 'CHECK_OUT'
           else null --error
         end, RD.ID_HOTEL, RD.IS_ANUL
  from   RESERV_DETAIL RD
         left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
         left outer join PROFILE_AGENT P on P.ID_PROFILE = RD.ID_AGENT_PROFILE
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail, :from_date, :to_date,
         :id_room, :id_room_type, :id_agent,
         :country_code, :res_edit_status, :acc_routing,
         :busy_type, :id_hotel, :is_anul;

  execute procedure ROOM_MAGIC_CLEAR(:id_reserv_detail);

  if (:is_anul = 0) then begin
    execute procedure sys_dbg('occ OCCUPANCY_RESERV$INT acc_routing = '||coalesce(:acc_routing, 'null'));
  
    if (:acc_routing = 'OWNER') then busy_group_type = 20; --OOI
    else if (:busy_type starting with 'VALUE') then busy_group_type = 1;
    else busy_group_type = 24;

    execute procedure sys_dbg('occ OCCUPANCY_RESERV$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));
    execute procedure sys_dbg('occ OCCUPANCY_RESERV$INT res_edit_status = '||coalesce(:res_edit_status, 'null'));
    execute procedure sys_dbg('occ OCCUPANCY_RESERV$INT busy_group_type = '||coalesce(:busy_group_type, 'null'));
    execute procedure sys_dbg('occ OCCUPANCY_RESERV$INT from_date = '||coalesce(:from_date, 'null'));
    execute procedure sys_dbg('occ OCCUPANCY_RESERV$INT to_date = '||coalesce(:to_date, 'null'));
  
    for
      select GS.FOR_DATE, GS.ID_ROOM, coalesce(iif(g.CHECK_STATUS = 1, g.EARLYCHECKOUT_DATE, null), g.TO_DATE),
             sum(iif(GS.FOR_DATE = G.FROM_DATE, 1 - G.IS_CHILD, 0)),
             sum(iif(GS.FOR_DATE = coalesce(iif(g.CHECK_STATUS = 1, g.EARLYCHECKOUT_DATE, null), g.TO_DATE), 1 - G.IS_CHILD, 0)),
             sum(iif(GS.FOR_DATE between (g.FROM_DATE + 1) and (coalesce(iif(g.CHECK_STATUS = 1, g.EARLYCHECKOUT_DATE, null), g.TO_DATE) - 1), 1 - G.IS_CHILD, 0)),
             sum(iif(GS.FOR_DATE = G.FROM_DATE, G.IS_CHILD, 0)),
             sum(iif(GS.FOR_DATE = coalesce(iif(g.CHECK_STATUS = 1, g.EARLYCHECKOUT_DATE, null), g.TO_DATE), G.IS_CHILD, 0)),
             sum(iif(GS.FOR_DATE between (g.FROM_DATE + 1) and (coalesce(iif(g.CHECK_STATUS = 1, g.EARLYCHECKOUT_DATE, null), g.TO_DATE) - 1), G.IS_CHILD, 0))
      from   GUEST G
             left outer join OCCUPANCY_GET_STAY$INT(G.ID_GUEST) GS on 0=0
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and GS.FOR_DATE <= coalesce(iif(g.CHECK_STATUS = 1, g.EARLYCHECKOUT_DATE, null), g.TO_DATE)
      group by 1, 2, 3
      order by 1 asc
      into   :busy_date, :id_room, :check_out_date,
             :gst_ad_in, :gst_ad_out, :gst_ad_stay, :gst_ch_in, :gst_ch_out, :gst_ch_stay
    do begin
      if (:busy_date is null) then begin
        -- fucked up situation. Checkedin in the future followed by early checkout. As a result empty ROOM_MAGIC !
        exit;
      end
      day_action_int = case
                         when :busy_date = :check_out_date and :busy_date = :from_date then 13 --'CHECK_IN,CHECK_OUT'
                         when :busy_date = :from_date then 1 --'CHECK_IN'
                         when :busy_date = :check_out_date then 3 --'CHECK_OUT'
                         else 2 --'STAY'
                       end;

      select ro.ID_ROOM, ro.ID_ROOM_TYPE, ro.ROOM_STATUS
      from   RES_OCCUPANCY_ROOM$INT (:id_reserv_detail, :busy_date, :id_room, :id_room_type) RO
      into   :id_room, :id_room_type, :room_status;

      insert into ROOM_MAGIC(ID_ROOM_MAGIC, BUSY_DATE, ID_ROOM, ID_ROOM_TYPE, DAY_ACTION_INT, ID_HOTEL,
             BUSY_GROUP_TYPE, ID_AGENT, BUSY_TYPE, COUNTRY, ID_RESERV_DETAIL, GST_AD_IN, GST_AD_OUT, GST_AD_STAY,
             GST_CH_IN, GST_CH_OUT, GST_CH_STAY, ROOM_STATUS)
      values (gen_id(g_auto_inc_rooms_magic, 1), :busy_date, :id_room, :id_room_type, :day_action_int, :id_hotel,
             :busy_group_type, :id_agent, :busy_type, :country_code, :id_reserv_detail, :gst_ad_in, :gst_ad_out, :gst_ad_stay,
             :gst_ch_in, :gst_ch_out, :gst_ch_stay, :room_status);

      if (:busy_date < :to_date) then begin
        update RESERV_ROOMS$EXC rr
        set    rr.ACTUAL_ROOM_STATUS = :room_status
        where  rr.ID_RESERV_DETAIL = :id_reserv_detail
               and rr.FOR_DATE = :busy_date
               and coalesce(rr.ACTUAL_ROOM_STATUS, rr.IMPORT_ROOM_STATUS) is distinct from :room_status;

        if (row_count > 0) then force_booking_export = 1;
      end
    end

    if (:force_booking_export = 1) then
      execute procedure LOG_BOOKING_CHANGE$EXC(:id_reserv_detail, :id_hotel, 0, 1);

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :system_date;
     
    execute procedure OCCUPANCY_ACTIVE_FRAME$INT(:id_agent, :from_date, :to_date - 1, :id_room_type, :system_date)
    returning_values  :err_code, :err_text;
    if (:err_code < 0) then exit;
  
    execute procedure OCCUPANCY_OVERBOOK$INT (:id_agent, :from_date, :to_date - 1, :id_room_type, :busy_type)
    returning_values  :err_code, :err_text, :warn_code;
    if (:err_code < 0) then exit;
  end
  --
end
^

/* empty dependent procedure body */
/* Clear: MONITOR_ROOM_GANT$HM for: OCCUPANT_GET_INFO */
ALTER PROCEDURE MONITOR_ROOM_GANT$HM(FROM_DATE DATE,
TO_DATE DATE,
IN_ROOM_NAME VARCHAR(10),
IN_ID_ROOM_TYPE INTEGER,
IN_FLOOR INTEGER,
ID_HOTEL INTEGER)
 RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(20),
GANT_FROM_DATE DATE,
GANT_TO_DATE DATE,
BUSY_GRP INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GET_SHARE_STATUS$INT for: OCCUPANT_GET_INFO */
ALTER PROCEDURE RES_GET_SHARE_STATUS$INT(ID_RESERV_DETAIL INTEGER,
OPTION_ VARCHAR(100),
FOR_DATE DATE)
 RETURNS(SHARE_STATUS INTEGER,
SHARED_RESERVATIONS VARCHAR(1024),
SHARE_RENDER VARCHAR(1024))
 AS
 BEGIN SUSPEND; END
^

/* Alter (OCCUPANT_GET_INFO) */
ALTER PROCEDURE OCCUPANT_GET_INFO(ID_OCCUPANT INTEGER,
IN_BUSY_GRP INTEGER = null)
 RETURNS(BUSY_GRP INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
INFO VARCHAR(1024))
 AS
declare variable max_day_action integer;
begin
  --busy_grp = :in_busy_grp;

  select max(RM.DAY_ACTION_INT), min(rm.BUSY_GROUP_TYPE)
  from   ROOM_MAGIC RM
  where  RM.ID_RESERV_DETAIL = :ID_OCCUPANT
         --and RM.BUSY_GROUP_TYPE = :busy_grp
  into   :max_day_action, :busy_grp;

  if (:busy_grp in (18, 20) and :max_day_action = 0) then begin
    select BGI.BUSY_GRP, BGI.REASON, BGI.FROM_DATE, BGI.TO_DATE
    from   BLOCK_GET_INFO(:id_occupant) BGI
    into   :busy_grp, :info, :from_date, :to_date;
  end else begin
    -- when :busy_grp in (1, 24) or (:max_day_action > 0) - reservation with block busy group type - owners, as an example
    select RGI.BUSY_GRP, RGI.NUMBER, RGI.ARRIVAL_DATE, RGI.DEPARTURE_DATE
    from   RES_GET_INFO$RSV(:id_occupant, 0, 0, 0) RGI
    into   :busy_grp, :info, :from_date, :to_date;
  end

  suspend;
end
^

/* Alter (OWNER_BILL_MODIFY$PMS) */
ALTER PROCEDURE OWNER_BILL_MODIFY$PMS(ID_OWNER_BILL INTEGER,
ID_OWNER INTEGER,
BILLING_DATE DATE,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_OWNER_BILL INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_anul smallint;
  declare variable bill_num integer;
  declare variable id_account_post_pms integer;
  declare variable id_account_post integer;
  declare variable prev_id_owner_bill integer;
  declare variable prev_billing_date date;

  declare variable id_account integer;
  declare variable id_account_pms integer;
  declare variable value_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable value_post numeric(15,4);
  declare variable curr_post varchar(3);
  declare variable is_owner_income smallint;
  declare variable id_service integer;
  declare variable id_room integer;
  declare variable date_post date;
  declare variable id_reserv_detail integer;
  declare variable doc_description varchar(255);
  declare variable id_doc_head integer;
  declare variable description varchar(255);
  declare variable id_pms_event integer;
  declare variable is_client_account_post smallint;
begin
  err_code = 0;
  err_text = '';
  is_client_account_post = null;
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'create, anul');

  if ( exists ( select *
                from   OWNER$PMS O
                where  O.ID_OWNER = :ID_OWNER
                       and O.ID_RENTAL_POOL_UNIT is not null ) ) then
  begin
    exception PMS_EXCEPTION 'selected owner is pool!';
  end

  if (:operation = 'create') then begin
    is_anul = 0;

    if ( (:ID_OWNER_BILL is null) or (:ID_OWNER_BILL <= 0) )  then
      NEW_ID_OWNER_BILL = gen_id(GEN_OWNER_BILL$PMS_ID, 1);
    else
      NEW_ID_OWNER_BILL = :ID_OWNER_BILL;

    BILL_NUM = :NEW_ID_OWNER_BILL;
    insert into OWNER_BILL$PMS (ID_OWNER_BILL, ID_OWNER, BILL_DATE, IS_ANUL, BILL_NUM,
           IS_EXPORTED_TO_INTRANET, IS_POOL_DISTRIBUTION_STATEMENT)
    values (:NEW_ID_OWNER_BILL, :ID_OWNER, :BILLING_DATE, :IS_ANUL, :BILL_NUM, 0, 0);

    update OWNER$PMS O
    set    O.LAST_BILLING_DATE = :billing_date,
           O.ID_OWNER_BILL = :NEW_ID_OWNER_BILL
    where  O.ID_OWNER = :ID_OWNER;

    for
    /*  select ID_ACCOUNT_POST, ID_ACCOUNT_POST_PMS
      from   PMS_ACC_POST_TO_BILL_GET$INT(:ID_OWNER, null, '01.01.1500', :BILLING_DATE, 1)
      into   :ID_ACCOUNT_POST, :ID_ACCOUNT_POST_PMS */
      select   OP.ID_ACCOUNT_POST, OP.ID_ACCOUNT_POST$PMS
      from     OWNER_POST OP
      where    OP.ID_OWNER = :id_owner
               and OP.POST_DATE between cast('01.01.1500' as date) and :billing_date
               and OP.IS_ANUL = 0
      order by OP.ID_ACCOUNT_POST$PMS nulls last
      into     :ID_ACCOUNT_POST, :ID_ACCOUNT_POST_PMS
    do begin
      if (:id_account_post_pms is not null) then begin

        update ACCOUNT_POST$PMS A
        set    A.LINE_STATUS = 21
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS;

        id_account = null;
        select ACC.ID_SERVICE, ACC.VALUE_ORIG, ACC.CURR_ORIG, ACC.VALUE_POST, ACC.CURR_POST,
               ACC.IS_OWNER_INCOME, ACC.DATE_POST, ACC.ID_ACCOUNT_PMS, E.ID_ROOM,
               E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION, A.IS_CLIENT_POOL_ACCOUNT
        from   ACCOUNT_POST$PMS ACC
               join ACCOUNT$PMS A on A.ID_ACCOUNT = ACC.ID_ACCOUNT_PMS
               join PMS_EVENT$PMS E on E.ID_PMS_EVENT = ACC.ID_PMS_EVENT
        where  ACC.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
        into   :ID_SERVICE, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
               :IS_OWNER_INCOME, :DATE_POST, :ID_ACCOUNT_PMS, :ID_ROOM,
               :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION, :is_client_account_post;
      end

      if (:id_account_post is not null) then begin
        exception PMS_EXCEPTION '-613';
          
        is_client_account_post = 1;
        update PMS_EVENT_POST A
        set    A.LINE_STATUS = 21
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST;

        id_account_pms = null;
        select ACC.ID_SERVICE, ACC.PRICE_ORIG, ACC.CURR_ORIG, ACC.PRICE_POST, ACC.CURR_POST,
               0, ACC.DATE_POST, ACC.ID_ACCOUNT, E.ID_ROOM,
               E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION
        from   ACCOUNT_POST ACC
               join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = ACC.ID_ACCOUNT_POST
               join PMS_EVENT$PMS E on E.ID_PMS_EVENT = PP.ID_PMS_EVENT
        where  ACC.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
        into   :ID_SERVICE, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
               :IS_OWNER_INCOME, :DATE_POST, :ID_ACCOUNT, :ID_ROOM,
               :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION;
      end

      insert into OWNER_BILL_ROW$PMS (ID_OWNER_BILL, ID_ACCOUNT_POST,
             ID_ACCOUNT, ID_ACCOUNT_POST_PMS, ID_ACCOUNT_PMS, ID_SERVICE, VALUE_ORIG,
             CURR_ORIG, VALUE_POST, CURR_POST, IS_OWNER_INCOME, ID_ROOM, DATE_POST,
             ID_RESERV_DETAIL, DOC_DESCRIPTION, ID_DOC_HEAD, DESCRIPTION, IS_CLIENT_ACCOUNT_POST)
      values (:new_id_owner_bill, :ID_ACCOUNT_POST, :ID_ACCOUNT,
             :ID_ACCOUNT_POST_PMS, :ID_ACCOUNT_PMS, :ID_SERVICE, :VALUE_ORIG,
             :CURR_ORIG, :VALUE_POST, :CURR_POST, :IS_OWNER_INCOME, :ID_ROOM, :DATE_POST,
             :ID_RESERV_DETAIL, :DOC_DESCRIPTION, :ID_DOC_HEAD, :DESCRIPTION, :is_client_account_post);
    end
  end
  if (:operation = 'anul') then begin
    select O.ID_OWNER, O.IS_ANUL
    from   OWNER_BILL$PMS O
    where  O.ID_OWNER_BILL = :ID_OWNER_BILL
    into   :id_owner, :is_anul;
    if (:is_anul = 1) then exit;

    select first 1 B.ID_OWNER_BILL
    from   OWNER_BILL$PMS B
    where  B.ID_OWNER = :id_owner
           and B.IS_ANUL = 0
    order by B.BILL_DATE desc
    into   :prev_id_owner_bill;
    if (:prev_id_owner_bill <> :id_owner_bill) then exception PMS_EXCEPTION '-619';

    select first 1 O.ID_OWNER_BILL, O.BILL_DATE
    from   OWNER_BILL$PMS O
    where  O.ID_OWNER = :ID_OWNER
           and o.IS_ANUL = 0
           and O.ID_OWNER_BILL <> :ID_OWNER_BILL
    order by O.BILL_DATE desc
    into   :prev_id_owner_bill, :prev_billing_date;

    update OWNER$PMS O
    set    O.LAST_BILLING_DATE = :prev_billing_date,
           O.ID_OWNER_BILL = :prev_id_owner_bill
    where  O.ID_OWNER = :ID_OWNER;

    update OWNER_BILL$PMS B
    set    B.IS_EXPORTED_TO_INTRANET = 0,
           B.IS_ANUL = 1
    where  B.ID_OWNER_BILL = :ID_OWNER_BILL;

    for
      select O.ID_ACCOUNT_POST, O.ID_ACCOUNT_POST_PMS
      from   OWNER_BILL_ROW$PMS O
      where  O.ID_OWNER_BILL = :ID_OWNER_BILL
      into   :id_account_post, :id_account_post_pms
    do begin
      if (:id_account_post_pms is not null) then begin
        update ACCOUNT_POST$PMS A
        set    A.LINE_STATUS = 11
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
               and A.LINE_STATUS = 21;
      end

      if (:id_account_post is not null) then begin
        update PMS_EVENT_POST A
        set    A.LINE_STATUS = 11
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and A.LINE_STATUS = 21;
      end
    end

    for
      select distinct AP.ID_PMS_EVENT
      from   OWNER_BILL_ROW$PMS R
             join OWNER_BILL$PMS B on B.ID_OWNER_BILL = R.ID_OWNER_BILL
             join ACCOUNT_POST$PMS AP on AP.ID_ACCOUNT_POST = R.ID_ACCOUNT_POST_PMS
             join PMS_EVENT$PMS E on E.ID_PMS_EVENT = AP.ID_PMS_EVENT
      where  R.ID_OWNER_BILL = :ID_OWNER_BILL
             and E.EVENT_TYPE = 'POOL_DISTRIBUTION'
             and B.IS_POOL_DISTRIBUTION_STATEMENT = 1
      into   :id_pms_event
    do begin
      execute procedure PMS_EVENT_VOID$INT(:id_pms_event);
    end
  end
end
^

/* Alter (PAYMENT_DOC_DELETE$DOC) */
ALTER PROCEDURE PAYMENT_DOC_DELETE$DOC(ID_PAYMENT_HEAD INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_deposit integer;
  declare variable is_dep_payment integer;
begin
  dbg = null;
  is_dep_payment = 0;

  for
    select D.ID_DEPOSIT
    from   DEPOSIT D
    where  D.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
    into   :id_deposit
  do begin
    execute procedure DEPOSIT_ANUL$INT (:id_deposit, null)
    returning_values :dbg;

    delete from DEPOSIT D
    where  D.ID_DEPOSIT = :id_deposit;

    is_dep_payment = 1;
  end

  if (:is_dep_payment = 0) then
    execute procedure DEPOSIT_REFUND_PAY_ANNUL$INT (:ID_PAYMENT_HEAD);

  delete from PAYMENT_HEAD PH
  where  PH.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;

end
^

/* Alter (PAYMENT_STORNO$INT) */
ALTER PROCEDURE PAYMENT_STORNO$INT(ID_PAYMENT_HEAD INTEGER,
ID_ACCOUNT INTEGER,
NEW_ID_DOC_HEAD INTEGER,
STORNO_AMOUNT NUMERIC(15,4),
DESCRIPTION VARCHAR(100),
TARGET_DOC_AMOUNT NUMERIC(15,4))
 RETURNS(ID_STORNO_PAYMENT INTEGER)
 AS
declare variable payment_date date;
  declare variable acc_currency varchar(3);
  declare variable id_doc_type integer;
  declare variable doc_type_name varchar(50);
  declare variable id_doc_num integer;
  declare variable is_storno integer;
  declare variable round_to numeric(15,4);
  declare variable pay_rate numeric(15,6);
  declare variable pay_curr varchar(3);
  declare variable doc_value numeric(15,4);
  declare variable acc_value numeric(15,4);
  declare variable acc_rate numeric(15,6);
  declare variable doc_rate numeric(15,6);
  declare variable doc_curr varchar(3);
  declare variable id_doc_contragent integer;
  declare variable id_storned_doc_head integer;
  declare variable id_payment_type integer;
  declare variable id_hotel integer;
  declare variable due_date date;
  declare variable equal_pay_doc_rate double precision;
  declare variable is_partial_storno numeric(15,4);
  declare variable id_account_payment integer;
  declare variable id_deposit integer;
  declare variable avail_pay_amount numeric(15,4);
begin
  execute procedure PAYMENT_VOID_CHECK$INT (:ID_PAYMENT_HEAD, substring(:DESCRIPTION from 1 for 50));

  select PH.ID_DOC_TYPE, DTP.STORNO_DOC_NAME, PH.ID_DOC_NUM, PH.ID_PAYMENT_TYPE, PH.DUE_DATE,
         ph.IS_STORNO, PH.PAY_CURRENCY, PH.PAY_RATE, PH.ID_DOC_HEAD,
         A.ID_HOTEL, c.ROUND_TO
  from   PAYMENT_HEAD PH
         join DOC_TYPE DP on DP.ID_DOC_TYPE = PH.ID_DOC_TYPE
         join DOC_TYPE_PAY dtp on dtp.ID_DOC_TYPE = dp.ID_DOC_TYPE
         join ACCOUNT A on A.ID_ACCOUNT = PH.ID_ACCOUNT
         join CURRS c on c.CURR = ph.PAY_CURRENCY
  where  PH.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  into   :id_doc_type, :doc_type_name, :id_doc_num, :id_payment_type, :due_date,
         :is_storno, :pay_curr, :pay_rate, :id_storned_doc_head,
         :id_hotel, :round_to;

  if (:is_storno = 1) then
    exception PAYMENT_EXCEPTION 'Storno payment cannot be voided !';

  select sum(AP.PAY_AMOUNT)
  from   ACCOUNT_PAYMENTS AP
  where  AP.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  into   :avail_pay_amount;

  if ((:STORNO_AMOUNT is null) or (round_f(:STORNO_AMOUNT - :avail_pay_amount, :round_to) = 0) ) then begin
    /* storn whole available payment */
    is_partial_storno = 0;
    STORNO_AMOUNT = :avail_pay_amount;
  end else begin
    is_partial_storno =1;
  end

  if (:STORNO_AMOUNT = 0 ) then
    exception PAYMENT_EXCEPTION '-340' || f_character(31) || '' || f_character(29) || :storno_amount;
    --'Payment value iz zero.' ;

  execute procedure SYSTEM_DATE_GET (:ID_HOTEL)
  returning_values  (:payment_date);
   
  /* CHECK FOR VALID ACCOUNT */
  select A.ACCOUNT_CURR
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :acc_currency;

  execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:ID_ACCOUNT, 0);
  /*-------------------- PAYMENT HEADER ---------------------*/
  select D.DOC_CURRENCY, D.ID_DOC_CONTRAGENT, D.DOC_RATE
  from   DOC_HEAD D
  where  D.ID_DOC = :NEW_ID_DOC_HEAD
  into   :doc_curr, :id_doc_contragent, :doc_rate;

  ID_STORNO_PAYMENT = gen_id(G_ID_PAYMENT_HEAD, 1);
  insert into PAYMENT_HEAD
         (ID_PAYMENT_HEAD, ID_ACCOUNT, ID_DOC_TYPE, ID_DOC_NUM,
         ID_PAYMENT_TYPE, DOC_TYPE_NAME, PAYMENT_DATE, DUE_DATE,
         PAY_VALUE, PAY_VALUE_A, PAY_CURRENCY, PAY_RATE, IS_STORNO, ID_DOC_HEAD,
         DESCRIPTION, ID_DOC_CONTRAGENT, ID_PAYMENT_STORNED)
  values (:ID_STORNO_PAYMENT, :ID_ACCOUNT, :id_doc_type, :id_doc_num,
         :id_payment_type, :doc_type_name, :payment_date, :due_date,
         -:STORNO_AMOUNT, -:STORNO_AMOUNT, :pay_curr, :pay_rate, 1, :NEW_ID_DOC_HEAD,
         :DESCRIPTION, :id_doc_contragent, :ID_PAYMENT_HEAD);
  /*-------------------- ACCOUNT_PAYMENT ---------------------*/
  execute procedure CURR_RATE_GET (:acc_currency, :payment_date, :id_hotel)
  returning_values  (:acc_rate);

  if (:is_partial_storno = 1 /*and :TARGET_DOC_AMOUNT is not null */) then begin
    if (:pay_curr = :doc_curr) then pay_rate = :doc_rate;
    execute procedure PAYMENT_EQUIVALENCE_CALC$INT (:pay_rate, -:STORNO_AMOUNT, :round_to, :doc_rate, :round_to, :TARGET_DOC_AMOUNT)
    returning_values  (:doc_value, :equal_pay_doc_rate);
    doc_rate = :pay_rate / :equal_pay_doc_rate;
     
    if (:acc_currency = :doc_curr) then begin
      acc_value = :doc_value;
      acc_rate = :doc_rate;
    end else begin
      acc_value = (-:storno_amount) * cast(:pay_rate/:acc_rate as double precision);
    end

    insert into ACCOUNT_PAYMENTS (ID_ACCOUNT, ID_PAYMENT_HEAD, PAY_AMOUNT, PAY_RATE,
           ACC_AMOUNT, ACC_RATE, TRANSACTION_DATE, ID_DEPOSIT, IS_INITIAL_PAYMENT)
    values (:ID_ACCOUNT, :ID_STORNO_PAYMENT, -:STORNO_AMOUNT , :pay_rate,
           :acc_value, :acc_rate, :payment_date, null, 1)
    returning id_account_payment into :id_account_payment;
  
    if (:NEW_ID_DOC_HEAD is not null) then begin
      insert into DOC_PAY_USAGE (ID_DOC_HEAD, ID_ACCOUNT_PAYMENT, PAY_AMOUNT, PAY_RATE,
             DOC_AMOUNT, DOC_RATE, EQUAL_PAY_DOC_RATE)
      values (:NEW_ID_DOC_HEAD, :id_account_payment, -:storno_amount, :pay_rate,
             :doc_value, :doc_rate, :equal_pay_doc_rate);
    end
  end else begin
    /* whole paymnent is storned */
    select dp.EQUAL_PAY_DOC_RATE
    from   DOC_PAY_USAGE DP
           join ACCOUNT_PAYMENTS AP on AP.ID_ACCOUNT_PAYMENT = dp.ID_ACCOUNT_PAYMENT
    where  DP.ID_DOC_HEAD = :id_storned_doc_head
           and AP.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
    into   :equal_pay_doc_rate;

    --acc_value = (-:storno_amount + :pay_taxes) * cast(:pay_rate/:acc_rate as double precision);
    --doc_value = (-:storno_amount + :pay_taxes) * cast(:equal_pay_doc_rate as double precision);
    --doc_rate = :pay_rate / :equal_pay_doc_rate;

    for
      select ap.ID_DEPOSIT, ap.id_account, ap.PAY_RATE, ap.ACC_RATE,
             sum(ap.PAY_AMOUNT), sum(ap.ACC_AMOUNT)
      from   ACCOUNT_PAYMENTS AP
      where  AP.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
      group by 1, 2, 3, 4
      having round_f(sum(AP.PAY_AMOUNT), :round_to) <> 0
      into   :id_deposit, :ID_ACCOUNT, :pay_rate, :acc_rate,
             :STORNO_AMOUNT, :acc_value
    do begin
      insert into ACCOUNT_PAYMENTS (ID_ACCOUNT, ID_PAYMENT_HEAD, PAY_AMOUNT, PAY_RATE,
             ACC_AMOUNT, ACC_RATE, TRANSACTION_DATE, ID_DEPOSIT, IS_INITIAL_PAYMENT)
      values (:ID_ACCOUNT, :ID_STORNO_PAYMENT, -:STORNO_AMOUNT, :pay_rate,
             -:acc_value, :acc_rate, :payment_date, :id_deposit, 1)
      returning id_account_payment into :id_account_payment;

      if (:NEW_ID_DOC_HEAD is not null) then begin
        doc_value = :storno_amount * :equal_pay_doc_rate;
        doc_rate = :pay_rate / :equal_pay_doc_rate;
        insert into DOC_PAY_USAGE (ID_DOC_HEAD, ID_ACCOUNT_PAYMENT, PAY_AMOUNT, PAY_RATE,
               DOC_AMOUNT, DOC_RATE, EQUAL_PAY_DOC_RATE)
        values (:NEW_ID_DOC_HEAD, :id_account_payment, -:storno_amount, :pay_rate,
               -:doc_value, :doc_rate, :equal_pay_doc_rate);
      end
    end

  end

  insert into PAYMENT_CREDIT_CARD (ID_PAYMENT_HEAD, CARD_CODE, ID_CC_TYPE,
         HOLDER_NAME, HOLDER_ADDRESS, VALIDITY_YEAR, VALIDITY_MONTH, VERIFICTION_CODE, CARD_CODE_PREVIEW)
  select :ID_STORNO_PAYMENT, CARD_CODE, ID_CC_TYPE,
         HOLDER_NAME, HOLDER_ADDRESS, VALIDITY_YEAR, VALIDITY_MONTH, VERIFICTION_CODE, CARD_CODE_PREVIEW
  from   PAYMENT_CREDIT_CARD pcc
  where  pcc.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;

  /* Mark storned pay doc and account payments for it as storned */
  if (:is_partial_storno = 0) then begin
    update PAYMENT_HEAD P
    set    P.IS_STORNED = 1
    where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;
  end
end
^

/* empty dependent procedure body */
/* Clear: PAYMENT_ANUL$INT for: PAYMENT_VOID_CHECK$INT */
ALTER PROCEDURE PAYMENT_ANUL$INT(ID_PAYMENT_HEAD INTEGER,
ANUL_REASON VARCHAR(100))
 AS
 BEGIN EXIT; END
^

/* Alter (PAYMENT_VOID_CHECK$INT) */
ALTER PROCEDURE PAYMENT_VOID_CHECK$INT(ID_PAYMENT_HEAD TYPE OF ID,
VOID_REASON TYPE OF TREASON)
 AS
declare variable no_use integer;
  declare variable avail_dep_value tprice;
  declare variable id_deposit integer;
  declare variable id_account integer;
  declare variable payment_description varchar(100);
  declare variable is_voided integer;
begin
  select p.IS_ANUL + p.IS_STORNED, p.DOC_TYPE_NAME || ' ' || p.PAYMENT_NUM || '/' || p.PAYMENT_DATE
  from   PAYMENT_HEAD P
  where  p.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  into   :is_voided, :payment_description;

  if (:is_voided > 0) then
    exception PAYMENT_ANNUL_EXCEPTION '-355' || f_character(31) || f_character(29) || :payment_description;
    -- 'Payment is already voided !'

  if (exists (select ap.ID_ACCOUNT_PAYMENT
              from   PAYMENT_HEAD P
                     join ACCOUNT_PAYMENTS ap on ap.ID_PAYMENT_HEAD = p.ID_PAYMENT_HEAD
                     join DOC_PAY_USAGE dp on dp.ID_ACCOUNT_PAYMENT = ap.ID_ACCOUNT_PAYMENT
                                             and dp.ID_DOC_HEAD is distinct from p.ID_DOC_HEAD
                     join DOC_HEAD D on d.ID_DOC = dp.ID_DOC_HEAD
              where  p.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
                     and d.IS_ANUL = 0
                     and d.IS_STORNED = 0)) then
    exception PAYMENT_ANNUL_EXCEPTION '-351' || f_character(31) || f_character(29) || :payment_description;
    --'Payment is used into valid document.';

  -- Check for transfered deposit into other accounts and return it to source (payment) account
  for
    select d.ID_DEPOSIT, d.AVAIL_VALUE, p.ID_ACCOUNT
    from   DEPOSIT_AVAILABLE D
           join PAYMENT_HEAD P on p.ID_PAYMENT_HEAD = d.ID_PAYMENT_HEAD
    where  D.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
           and d.ID_ACCOUNT <> p.ID_ACCOUNT
    into   :id_deposit, :avail_dep_value, :id_account
  do begin
    execute procedure DEPOSIT_TRANSFER$INT (:id_deposit, :id_account, :avail_dep_value, null, :VOID_REASON)
    returning_values  (:no_use);
  end
end
^

/* empty dependent procedure body */
/* Clear: SUMMARY_FINANCE_SAVE$INT for: PAYMENTS_EW_SUMMARIZE$INT */
ALTER PROCEDURE SUMMARY_FINANCE_SAVE$INT(ID_END_WORK INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (PAYMENTS_EW_SUMMARIZE$INT) */
ALTER PROCEDURE PAYMENTS_EW_SUMMARIZE$INT(ID_END_WORK INTEGER)
 AS
declare variable ID_HOTEL integer;
declare variable DATE_SUMMARY date;
declare variable PAYMENT_AMOUNT numeric(15,4);
declare variable PAYMENT_TRANSACTIONS integer;
declare variable FISCAL_PAY_AMOUNT numeric(15,4);
declare variable FISCAL_PAY_TRANSACTIONS integer;
declare variable ACCEPTED_AMOUNT numeric(15,4);
declare variable USED_AMOUNT numeric(15,4);
declare variable REFUNDED_AMOUNT numeric(15,4);
declare variable CURRENCY varchar(3);
declare variable DISCOUNTS_VALUE numeric(15,4);
begin

  select EW.ID_HOTEL, EW.PREV_DATE
  from   END_WORKS EW
  where  EW.ID_END_WORK = :ID_END_WORK
  into   :ID_HOTEL, :DATE_SUMMARY;

  select sum(P.NAT_VALUE) as PAY_AMOUNT,
         count(distinct P.ID_PAYMENT_HEAD) as PAY_CNT,
         sum(P.NAT_VALUE * iif(P.FISC_STATUS = 2, 1, 0)) as FISC_PAY_AMOUNT,
         count(distinct iif(P.FISC_STATUS = 2, P.ID_PAYMENT_HEAD, null)) as FISC_PAY_CNT
  from   DOCUMENT_PAYMENT P
  where  P.REALIZE_DATE = :DATE_SUMMARY
         and P.ID_HOTEL = :ID_HOTEL
  into   :PAYMENT_AMOUNT, :PAYMENT_TRANSACTIONS,
         :FISCAL_PAY_AMOUNT, :FISCAL_PAY_TRANSACTIONS;

  select sum(DD.FOOTER_VALUE * D.VALUE_CORR_IDX)
  from   DOCUMENT_RELEASE D
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join DOC_FOOTER DD on DD.ID_DOC_HEAD = D.ID_DOC and DD.ID_DOC_LINE is null
  where  D.RPT_DOC_DATE = :DATE_SUMMARY
         and A.ID_HOTEL = :ID_HOTEL
  into   :DISCOUNTS_VALUE;

  update SUMMARY_END_WORK
  set    PAYMENT_AMOUNT = coalesce(:PAYMENT_AMOUNT, 0),
         PAYMENT_TRANSACTIONS = coalesce(:PAYMENT_TRANSACTIONS, 0),
         FISCAL_PAY_AMOUNT = coalesce(:FISCAL_PAY_AMOUNT, 0),
         FISCAL_PAY_TRANSACTIONS = coalesce(:FISCAL_PAY_TRANSACTIONS, 0),
         DISCOUNTS_AMOUNT = coalesce(-:DISCOUNTS_VALUE, 0)
  where  ID_END_WORK = :ID_END_WORK;

  for
    select D.PAY_CURRENCY,
           sum(iif (D.FLOW_TYPE = 'create', D.PAY_VALUE, 0)) as ACCEPTED_AMOUNT,
           sum(iif (D.FLOW_TYPE = 'use', D.PAY_VALUE, 0)) as USED_AMOUNT,
           sum(iif (D.FLOW_TYPE = 'refund', D.PAY_VALUE, 0)) as REFUNDED_AMOUNT
    from   DEPOSIT_FLOW D
    where  /*D.IS_ANUL = 0
           and*/ D.OCCUR_DATE = :DATE_SUMMARY
           and D.ID_HOTEL = :ID_HOTEL
    group by D.PAY_CURRENCY
    into   :CURRENCY, :ACCEPTED_AMOUNT, :USED_AMOUNT, :REFUNDED_AMOUNT
  do begin
    insert into SUMMARY_DEPOSITS (ID_END_WORK, CURRENCY, ACCEPTED_AMOUNT, USED_AMOUNT, REFUNDED_AMOUNT)
    values (:ID_END_WORK, :CURRENCY, :ACCEPTED_AMOUNT, :USED_AMOUNT, :REFUNDED_AMOUNT);

  end
end
^

/* empty dependent procedure body */
/* Clear: GUEST_ADDRESSCARD_SET$INT for: PERSON_DATA_SET$INT */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$INT(PD_DBKEY CHAR(8),
G_DBKEY CHAR(8),
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
COUNTRY_CODE VARCHAR(10),
IS_CHILD INTEGER,
AGE INTEGER,
BIRTH_DAY DATE,
TITLE VARCHAR(10))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_PERSON_CREATEQ$PROFILE for: PERSON_DATA_SET$INT */
ALTER PROCEDURE PROFILE_PERSON_CREATEQ$PROFILE(PROFILE_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100),
PHONE /* TYPE OF TPHONE */ VARCHAR(50),
ID_PASSPORT_TYPE /* TYPE OF ID */ INTEGER,
PASS_NUM /* TYPE OF NAME_20 */ VARCHAR(20),
EGN /* TYPE OF TTEXT_SHORT */ VARCHAR(30),
COUNTRY_CODE /* TYPE OF TSHORT_CODE */ VARCHAR(10),
CARD_CODE /* TYPE OF TCARD_CODE */ VARCHAR(50),
ID_PERSON_DATA /* TYPE OF ID_REF */ INTEGER = null,
TITLE /* TYPE OF TSHORT_CODE */ VARCHAR(10) = null,
ID_HOTEL /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_PROFILE /* TYPE OF ID */ INTEGER,
P_DBKEY /* TYPE OF TDB_KEY */ CHAR(8),
PD_DBKEY /* TYPE OF TDB_KEY */ CHAR(8))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_PERSON_MODIFY$PROFILE for: PERSON_DATA_SET$INT */
ALTER PROCEDURE PROFILE_PERSON_MODIFY$PROFILE(ID_PROFILE INTEGER,
ID_GUEST_TYPE INTEGER,
PROFILE_NAME VARCHAR(100),
PERSON_NAME2 VARCHAR(100),
SEX CHAR,
BIRTH_DAY DATE,
BIRTH_PLACE VARCHAR(30),
EGN VARCHAR(30),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
COUNTRY_CODE VARCHAR(20),
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
MASK VARCHAR(10),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
IS_ARCHIVE INTEGER,
ID_PHOTO INTEGER,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
TITLE VARCHAR(10) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PERSON_DATA_SET$INT) */
ALTER PROCEDURE PERSON_DATA_SET$INT(P_DBKEY CHAR(8),
PD_DBKEY CHAR(8),
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
COUNTRY VARCHAR(10),
BIRTH_DAY DATE,
BIRTHDAY_INTERNAL DATE,
TITLE VARCHAR(10) = null)
 AS
declare variable id_profile integer;
  declare variable id_guest integer;
  declare variable first_name varchar(30);
  declare variable surname varchar(30);
  declare variable family_name varchar(30);
  declare variable old_name varchar(92);
  declare variable old_country varchar(10);
  declare variable country_name varchar(50);
  declare variable action_text varchar(255);
  declare variable rd_dbkey char(8);
  declare variable age integer;
  declare variable old_birthday date;
  declare variable id_person_data integer;
begin

  select coalesce(:country, PD.COUNTRY_CODE), PD.BIRTH_DAY, PD.PERSON_NAME, PD.COUNTRY_CODE, pd.ID_PERSON_DATA
  from   PERSON_DATA PD
  where  PD.RDB$DB_KEY = :pd_dbkey
  into   :country, :old_birthday, :old_name, :old_country, :id_person_data;

  select PP.FIRST_NAME, PP.SURNAME, PP.FAMILY_NAME
  from   PERSON_NAME_PARSE$INT (:GUEST_NAME1) PP
  into   :first_name, :surname, :family_name;

  update  PERSON_DATA PD
  set     PD.FIRST_NAME = :first_name,
          PD.SURNAME = :surname,
          PD.FAMILY_NAME = :family_name,
          PD.PERSON_NAME2 = coalesce(:guest_name2, iif(PD.PERSON_NAME = PD.PERSON_NAME2, :guest_name1, PD.PERSON_NAME2)),
          PD.COUNTRY_CODE = :country,
          PD.BIRTH_DAY = coalesce(:birthday_internal, :birth_day), -- this is relative date, calculated by input age or equal to real birth day (if exists)
          PD.BIRTHDAY_INTERNAL = :birthday_internal, -- this is real person birth day (can be null)
          PD.TITLE = :TITLE
  where   PD.RDB$DB_KEY = :pd_dbkey;

  execute procedure LIST_ITEM_MODIFY('person_title', null, :TITLE, 'add');

  if ((:old_name is distinct from :GUEST_NAME1)
      or (:OLD_BIRTHDAY is distinct from :birth_day)
      or (:old_country is distinct from :COUNTRY)) then
  begin
    -- update all related checked in and not checked out guest's cards
    for
      select GD.ID_GUEST
      from   GUEST_DATA GD
             join GUEST G on g.ID_GUEST = gd.ID_GUEST
      where  GD.ID_PERSON_DATA = :id_person_data
             and g.ID_RESERV_DETAIL is not null
             and g.IS_CHECK_IN = 1
             and g.IS_CHECK_OUT = 0
      into   :id_guest
    do begin
      select C.COUNTRY_NAME
      from   COUNTRY C
      where  C.COUNTRY_CODE = :COUNTRY
      into   :country_name;
  
      select CA.AGE_INYEARS
      from   SYSTEM_CALC_AGE_INYEARS (:birth_day, current_timestamp) CA
      into   :age;
  
      action_text = f_character(29) || '"' || :guest_name1 || '", ' || coalesce(:age, '') || ', ' || coalesce(:country_name, '');
      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'GUEST_IDENT_CHNG', :action_text);
    end
  end

  if (:p_dbkey is not null) then begin
    update PROFILE P
    set    P.PROFILE_NAME = :guest_name1
    where  P.RDB$DB_KEY = :p_dbkey;

    select P.ID_PROFILE
    from   PROFILE P
    where  P.RDB$DB_KEY = :p_dbkey
    into   :id_profile;

    for
      select rd.RDB$DB_KEY
      from   RESERV_DETAIL RD
      where  RD.ID_PERSON_PROFILE = :id_profile
             and RD.CHECK_STATUS >= -2  -- to be or not to be ???
      into   :rd_dbkey
    do begin
      execute procedure RESERV_TRACK_CHANGES$INT (:rd_dbkey);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: NON_DOCUMENTED_INFO_GET$INT for: PMS_ACC_POST_TO_BILL_GET$INT */
ALTER PROCEDURE NON_DOCUMENTED_INFO_GET$INT(ID_OWNER INTEGER,
ID_ROOM INTEGER)
 RETURNS(OUT_LATE_INFO VARCHAR(255),
OUT_CURR_INFO VARCHAR(255),
OUT_NEXT_INFO VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: OWNER_BILL_MODIFY$PMS for: PMS_ACC_POST_TO_BILL_GET$INT */
ALTER PROCEDURE OWNER_BILL_MODIFY$PMS(ID_OWNER_BILL INTEGER,
ID_OWNER INTEGER,
BILLING_DATE DATE,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_OWNER_BILL INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (PMS_ACC_POST_TO_BILL_GET$INT) */
ALTER PROCEDURE PMS_ACC_POST_TO_BILL_GET$INT(ID_OWNER INTEGER,
ID_ROOM INTEGER,
PERIOD_FROM DATE,
PERIOD_TO DATE,
THROW_EXCEPTION SMALLINT)
 RETURNS(ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
VALUE_POST NUMERIC(15,4),
CURR_POST VARCHAR(3),
IS_OWNER_INCOME SMALLINT)
 AS
declare variable ac smallint;
begin
  id_account_post_pms = null;
  id_account_post = null;
  value_post = 0;
  curr_post = '';

  exception ASSERT 'Not use!';

  for
    select AP.ID_ACCOUNT_POST, AP.VALUE_POST, AP.CURR_POST, AP.IS_OWNER_INCOME
    from   OWNER$PMS O
           join ACCOUNT$PMS ACC on ACC.ID_OWNER = O.ID_OWNER
           join ACCOUNT_POST$PMS AP on AP.ID_ACCOUNT_PMS = ACC.ID_ACCOUNT
           join PMS_EVENT$PMS E on E.ID_PMS_EVENT = AP.ID_PMS_EVENT
    where  O.ID_OWNER = :id_owner
           and AP.DATE_POST between :PERIOD_FROM and :PERIOD_TO
           and AP.LINE_STATUS = 11
           and ACC.IS_SHADOW = 0
           and ((:id_room is null) or (E.ID_ROOM = :id_room))
    into   :id_account_post_pms, :value_post, :curr_post, :IS_OWNER_INCOME
  do suspend;

  id_account_post_pms = null;
  for
    select AP.ID_ACCOUNT_POST, AP.AC, AP.PRICE_POST, AP.CURR_POST, 0
    from   OWNER$PMS O
           join ACCOUNT ACC on ACC.ID_PROFILE = O.ID_OWNER
           join ACCOUNT_POST AP on ACC.ID_ACCOUNT = AP.ID_ACCOUNT
           left outer join PMS_EVENT_POST EP on AP.ID_ACCOUNT_POST = EP.ID_ACCOUNT_POST
           left outer join PMS_EVENT$PMS E on EP.ID_PMS_EVENT = E.ID_PMS_EVENT
    where  O.ID_OWNER = :ID_OWNER
           and AP.DATE_POST between :PERIOD_FROM and :PERIOD_TO
           and AP.AC = '00'
           and ACC.IS_PMS_ACCOUNT = 1
           and ((:id_room is null) or (E.ID_ROOM = :id_room))
    into   :id_account_post, :ac, :value_post, :curr_post, :IS_OWNER_INCOME
  do begin
    if (:ac <> '01' and :THROW_EXCEPTION = 1) then begin
      exception PMS_EXCEPTION '-613';
    end
    suspend;
  end

end
^

/* empty dependent procedure body */
/* Clear: EAI_POS_POSTING_ADD$P2E for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PMS_POSTING_CREATE$INT for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
POST_DATE /* TYPE OF TDATE */ DATE,
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
POST_ON_PMS_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT,
IS_OWNER_INCOME /* TYPE OF TLOGICAL */ SMALLINT,
ID_ROOM /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_ACCOUNT_POST /* ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_FINALIZE$POST for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_TELECOUNT_CALL$INT for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_ACCOUNT$INT) */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
QTY TYPE OF TQTY,
ID_SECQUENCE TYPE OF ID,
IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
POST_TEXT TYPE OF TDESCRIPTION_SHORT,
RESOURCE_TEXT TYPE OF TREASON,
DATE_POST TYPE OF TDATE,
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ID_ROOM TYPE OF ID = null,
POST_DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable action_text varchar(255);
begin
  if (:date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :date_post;
  end
/* NO AUTO PRICE !!!!!!
  if (:in_is_manual_price = 0) then begin

    select P.ID_EXTRA_TARIFF
    from   ACCOUNT A
           join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
    where  A.ID_ACCOUNT = :in_id_account
    into   :id_extra_tarifa;
    if ((:id_extra_tarifa is null) or (:id_extra_tarifa < 0)) then begin
      err_code = -14;
      exit;
    end
    execute procedure TAR_RECALC_EXTRASRV(:id_extra_tarifa, :in_id_service, :in_date_post)
    returning_values  :err_code, :err_text, :post_price, :post_currency;
    if (:err_code < 0) then exit;
  end else begin
    --MANUAL PRICE
    post_currency = :manual_curr ;
    post_price = :manual_price ;
  end
*/

  post_currency = :manual_curr ;
  post_price = :manual_price ;
  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, -1, :id_secquence, :date_post, :id_service, -1, :id_room, 0, :qty, :post_price,
    :post_currency, null, :short_code, :from_date, :to_date, :post_text, :resource_text, '', -1, :POST_DESCRIPTION)
  returning_values :err_code, :err_text, :id_account_post;
  if (:err_code <> 0) then exit;

  select S.SERVICE_NAME
  from   SERVICES S
  where  S.ID_SERVICE = :ID_SERVICE
  into   :action_text;
   
  action_text = f_character(29) || :action_text
                || f_character(28) || formatdate(:DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || :post_currency;
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_RESERVATION$INT for: POST_SERVICE_ON_GUEST$INT */
ALTER PROCEDURE POST_SERVICE_ON_RESERVATION$INT(ID_RESERV_DETAIL /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_ROOM for: POST_SERVICE_ON_GUEST$INT */
ALTER PROCEDURE POST_SERVICE_ON_ROOM(IN_ID_ROOM /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255))
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_GUEST /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_GUEST$INT) */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TDESCRIPTION_SHORT,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ACCOUNT_ROUTING TYPE OF TSHORT_CODE,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable id_room integer;
  declare variable no_use varchar(255);
  declare variable action_text varchar(255);
  declare variable is_guest_check_in smallint;
  declare variable service_name varchar(50);
begin
  err_code = 0;
  err_text = '';

  select g.check_status
  from   guest g
  where  g.id_guest = :in_id_guest
  into   :is_guest_check_in;

  if (:is_guest_check_in < 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
  end

  execute procedure GUEST_GET_POSTING_ACCOUNT$INT (:in_id_guest, :account_routing)
  returning_values  :id_account, :id_room;

  if (:in_date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :in_date_post;
  end

  if (:in_is_manual_price = 0) then begin
    execute procedure SERVICE_GET_POSTING_DETAILS(:in_id_service, :IN_DATE_POST)
    returning_values  :no_use, :no_use, :service_name, :post_price, :post_currency;
  end else begin
    /* MANUAL PRICE */
    post_currency = :manual_curr;
    post_price = :manual_price;
  end

  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, :in_id_guest, :in_id_secquence, :in_date_post, :in_id_service, -1, :id_room, 0, :in_qty,
    :post_price, :post_currency, null, :in_short_code, :in_from_datetime, :in_to_datetime, :in_post_text,
    :in_resource_text, '', -1, :DESCRIPTION)
  returning_values  :err_code, :err_text, :id_account_post;

  action_text = f_character(29) || :service_name
                || f_character(28) || formatdate(:IN_DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:IN_QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || :post_currency;
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: RESOURCE_RESERVATION_CHECK_IN for: POST_SERVICE_ON_RESERVATION$INT */
ALTER PROCEDURE RESOURCE_RESERVATION_CHECK_IN(ID_RESOURCE_RESERVATION INTEGER,
SERVICE_PRICE NUMERIC(15,2),
SERVICE_CURR VARCHAR(3))
 RETURNS(OUT_ID_ACCOUNT INTEGER,
OUT_ID_ACCOUNT_POST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_RESERVATION$INT) */
ALTER PROCEDURE POST_SERVICE_ON_RESERVATION$INT(ID_RESERV_DETAIL TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TREASON,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable id_guest integer;
begin
  err_code = 0;
  err_text = '';

  id_guest = null;
  select RD.ID_TITULAR
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :id_guest;

  execute procedure POST_SERVICE_ON_GUEST$INT(:id_guest, :in_id_service, :in_qty, :in_id_secquence,
                    :in_is_manual_price, :manual_price, :manual_curr, :in_from_datetime, :in_to_datetime,
                    :in_post_text, :in_resource_text, :in_date_post, :in_short_code, '', :DESCRIPTION)
  returning_values  :err_code, :err_text, :id_account, :id_account_post;
end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_POST_TO_MH_FRONT_ONLINE for: POST_SERVICE_ON_ROOM */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_SERVICE_POST for: POST_SERVICE_ON_ROOM */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_ROOM) */
ALTER PROCEDURE POST_SERVICE_ON_ROOM(IN_ID_ROOM TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TREASON,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_GUEST TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
begin
  err_code = 0;
  err_text = '';

  id_guest = null;
  select first 1 G.ID_GUEST
  from   GUEST G
  where  G.ID_ROOM = :in_id_room
         and G.CHECK_STATUS = 0
  order by G.FROM_DATE desc, G.ID_GUEST asc
        /************************************************/
        /* DESCENDANT ORDER IS VERY IMPORTANT!!         */
        /* IF TWO GUESTS HAVE:                          */
        /* TO_DATE OF THE 1'ST = FROM_DATE OF THE 2'ND, */
        /* THEN PHONACALLS SHOULD GO TO THE 2'ND        */         
        /************************************************/
  into   :id_guest;

  if (:id_guest is null) then begin
    err_code = -24;   /* NO GUESTS ARE CHECKED_IN INTO THE REQUESTED ROOM! */
    exit;
  end

  execute procedure POST_SERVICE_ON_GUEST$INT(:id_guest, :in_id_service, :in_qty, :in_id_secquence, :in_is_manual_price,
    :manual_price, :manual_curr, :in_from_datetime, :in_to_datetime, :in_post_text, :in_resource_text,
    :in_date_post, :in_short_code, '')
  returning_values  :err_code, :err_text, :id_account, :id_account_post;
end
^

/* empty dependent procedure body */
/* Clear: EAI_TELECOUNT_TRANSFER for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALL_POST$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL /* ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALLS_POST_TO_ACCOUNT$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_TELECOUNT_TRANSFER$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_TELECOUNT_CALL$INT) */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ext_ifc_name varchar(20);
  declare variable room_name varchar(30);
  declare variable datetime_call timestamp;
  declare variable price numeric(15,2);
  declare variable dial_number varchar(50);
  declare variable units integer;
  declare variable pc_id_service integer;
  declare variable def_manual_curr char(3);
  declare variable post_text varchar(50);
  declare variable id_account_post integer;
  declare variable is_archive integer;
  declare variable id_account integer;
  declare variable new_id_account_post integer;
  declare variable pc_tag varchar(20);
  declare variable number_zone varchar(50);
  declare variable id_hotel integer;
  declare variable id_phonecall integer;
  declare variable no_use varchar(255);
begin
  /* Description:
  || POST_TO_TYPE = 0 - ACCOUNT, 1 - GUEST, 2 - RESERV_DETAIL, 3 - JUST PREPARE, FOR EXTERNAL CLIENT
  */
  err_code = 0;
  err_text = '';
  ext_ifc_name = 'TELECOUNT';

  select PC.ID_PHONECALL, PC.ROOM_NAME, PC.DATETIME_CALL, PC.PRICE, PC.DIAL_NUMBER, PC.UNITS,
         PC.ID_ACCOUNT_POST, PC.IS_ARCHIVE, PC.TAG, substring(PC.NUMBER_ZONE from 1 for 30), pc.ID_HOTEL
  from   PHONECALLS PC 
  where  PC.rdb$db_key = :ph_dbkey
  into   :id_phonecall, :room_name, :datetime_call, :price, :dial_number, :units,
         :id_account_post, :is_archive, :pc_tag, :number_zone, :id_hotel;

  if ((:is_archive = 1) or (coalesce(:id_account_post, 0) > 0)) then exit;

  if ((:pc_tag is null) or (:pc_tag = '')) then pc_tag = 'TELECOUNT_DEFAULT';
  else pc_tag = 'TELECOUNT_' || :pc_tag;

  execute procedure EAI_MAP_SERVICE(:pc_tag, :number_zone, :ext_ifc_name, :id_hotel)
  returning_values  :err_code, :err_text, :pc_id_service;
  if (:err_code < 0) then exit;

  post_text = substring(:dial_number || ', impulses ' || :units from 1 for 50);

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :def_manual_curr;

  new_id_account_post = null;
  if (:post_to_type = 0) then begin
    id_account = :post_to_id;
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name)
    returning_values :err_code, :err_text, :new_id_account_post;
  end else if (:post_to_type = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:post_to_id, :pc_id_service, 1, -1, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name, '')
    returning_values :err_code, :err_text, :id_account, :new_id_account_post;
  end else if (:post_to_type = 2) then begin
    execute procedure POST_SERVICE_ON_RESERVATION$INT(:post_to_id, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name)
    returning_values :err_code, :err_text, :id_account, :new_id_account_post;
  end else if (:post_to_type = 3) then begin
    execute procedure POST_PREPARE_ON_ACCOUNT$POST (:post_to_id, :pc_id_service,
      1, :ID_SEQUENCE, :price, :def_manual_curr, :post_text, null, null, :ID_PHONECALL)
    returning_values :no_use;
  end
  if (:err_code < 0) then exit;

  if (:new_id_account_post is not null) then begin
    update PHONECALLS PC
    set    PC.ID_ACCOUNT_POST = :new_id_account_post,
           pc.POSTING_ERROR = null
    where  PC.rdb$db_key = :ph_dbkey;
  end

end
^

/* Alter (POST_TELECOUNT_TRANSFER$TC) */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ph_dbkey char(8);
  declare variable id_account_post integer;
  declare variable account_name varchar(50);
begin
  err_code = 0;
  err_text = '';

  for
    select PC.RDB$DB_KEY, PC.ID_ACCOUNT_POST
    from   PHONECALLS PC
    where  PC.SELECTION_ID = :selection_id
    into   :ph_dbkey, :id_account_post
  do begin
    if ((:id_account_post is not null) and (:id_account_post <> -1)) then begin
      err_code = -117;
      select A.ACCOUNT_NAME
      from   ACCOUNT_POST AP
             join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
      where  AP.ID_ACCOUNT_POST = :id_account_post
      into   :account_name;
      err_text = f_character(29) || :account_name;
      exit;
    end

    execute procedure POST_TELECOUNT_CALL$INT(2, :id_reserv_detail, :ph_dbkey, 0)
    returning_values :err_code, :err_text;
    if (:err_code < 0) then exit;
  end
end
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUP_SMALL$WBE for: PRODUCT_AVAILABILITY$AVL */
ALTER PROCEDURE AVAILABILITY_OCCUP_SMALL$WBE(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER,
QUERY_ID INTEGER,
ROOMS INTEGER,
RATES VARCHAR(255) = '',
ROOMTYPES VARCHAR(255) = '')
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: CHANNEL_IDSGDS_AVAILABILITY$EXC for: PRODUCT_AVAILABILITY$AVL */
ALTER PROCEDURE CHANNEL_IDSGDS_AVAILABILITY$EXC(CHANNEL_NAME VARCHAR(30),
ID_HOTEL INTEGER,
ADD_BOOKINGS_WITH_PREFIX VARCHAR(10))
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_SIMPLE_RATE INTEGER,
ID_BOARD INTEGER,
ROOM_STATUS INTEGER,
RATE_STATUS INTEGER,
PRODUCT_STATUS INTEGER,
AVAILABLE_ROOMS INTEGER,
MIN_LOS INTEGER,
MAX_LOS INTEGER,
SINGLE_PRICE NUMERIC(15,4),
DOUBLE_PRICE NUMERIC(15,4),
GUEST3_PRICE NUMERIC(15,4),
GUEST4PLUS_PRICE NUMERIC(15,4),
CHILD1_W_ADULT1_PRICE NUMERIC(15,4),
CHILD1_W_ADULT2PLUS_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT1_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT2PLUS_PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: CHANNEL_PRODUCT_AVAIL_REQ$INT for: PRODUCT_AVAILABILITY$AVL */
ALTER PROCEDURE CHANNEL_PRODUCT_AVAIL_REQ$INT(ID_CHANNEL INTEGER,
ID_HOTEL INTEGER,
ARRIVAL DATE,
DEPARTURE DATE,
ROOMS INTEGER)
 RETURNS(ID_ROOM_TYPE INTEGER,
ID_TAR_HEAD INTEGER,
IS_PRODUCT_AVAIALABLE INTEGER,
ROOM_STATUS INTEGER,
RATE_STATUS INTEGER,
RATE_MIN_LOS INTEGER,
RATE_MAX_LOS INTEGER,
AVAILABLE_ROOMS INTEGER,
IS_PUBLIC SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PRODUCT_AVAILABILITY$AVL) */
ALTER PROCEDURE PRODUCT_AVAILABILITY$AVL(ID_CHANNEL INTEGER,
ID_HOTEL INTEGER,
DATE_FROM DATE,
DATE_TO DATE,
RATES VARCHAR(255),
ROOMTYPES VARCHAR(255))
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_TAR_HEAD INTEGER,
ROOM_STATUS INTEGER,
RATE_STATUS INTEGER,
PRODUCT_STATUS INTEGER,
AVAILABLE_ROOMS INTEGER,
MIN_LOS INTEGER,
MAX_LOS INTEGER,
IS_PUBLIC SMALLINT)
 AS
declare variable current_status integer;
declare variable auto_free_rooms integer;
declare variable channel_capacity integer;
declare variable free_rooms integer;
declare variable to_sell integer;
declare variable rate_found smallint;
declare variable auto_percent numeric(15,4);
declare variable conditions varchar(100);
declare variable capacity integer;
declare variable occupied integer;
declare variable part varchar(10);
declare variable subpart varchar(10);
declare variable id_helper_session integer;
declare variable day_capacity numeric(15,4);
declare variable day_occupied numeric(15,4);
begin
  --product_status 0 - closed
  --product_status 1 - closed for arrival
  --product_status 2 - opened

  id_helper_session = gen_id(SELECTION_GEN, 1);

  insert into tmp_small_occup  ( id_session, for_date, id_room_type,  occupied, capacity)
  select :id_helper_session, SO.for_date, SO.id_room_type, SO.occupied, SO.capacity
  from   AVAILABILITY_OCCUP_SMALL$INT(:date_from, :date_to, :id_hotel, 0) SO;


  for
     select CA.ID_ROOM_TYPE, CA.FOR_DATE,
            CA.STATUS, CA.AUTO_FREE_ROOMS, CA.ROOM_COUNT,
            sum(TSO.CAPACITY) - sum(TSO.OCCUPIED), sum(TSO.CAPACITY), sum(TSO.OCCUPIED)
     from   TMP_SMALL_OCCUP tso
            join CHANNEL_ALLOTMENT CA on TSO.ID_ROOM_TYPE = CA.ID_ROOM_TYPE
                                  and TSO.FOR_DATE = CA.FOR_DATE
      where CA.ID_CHANNEL = :id_channel
            and tso.id_session = :id_helper_session
            and CA.FOR_DATE between :date_from and :date_to
            and ((coalesce(:roomtypes,'') = '') or (','||:roomtypes||',' containing ','||CA.ID_ROOM_TYPE||','))
      group by CA.ID_ROOM_TYPE, CA.FOR_DATE,
            CA.STATUS, CA.AUTO_FREE_ROOMS, CA.ROOM_COUNT
      into  :id_room_type, :for_date,
            :current_status, :auto_free_rooms, :channel_capacity,
            :free_rooms, :capacity, :occupied
  do begin
    available_rooms = :channel_capacity;
    if (:auto_free_rooms is not null) then begin
      if (coalesce(:free_rooms,0) > :auto_free_rooms) then
        room_status = 2;
      else
        room_status = 0;

      to_sell = coalesce(:free_rooms,0) - coalesce(:auto_free_rooms,0);
      if (:to_sell < 0) then to_sell = 0;
  
      available_rooms = :to_sell;
      if (:channel_capacity is not null and :channel_capacity < :available_rooms) then
        available_rooms = :channel_capacity;

    end else if (:current_status = 0) /*csSell*/ then begin
      /*This situation currently is not supported - if is OPEN always :auto_free_rooms exists*/
      room_status = 2;
      available_rooms = :channel_capacity;
    end else begin /*csStop*/
      room_status = 0;
      available_rooms = 0;
    end

    min_los = null;
    max_los = null;
    rate_status = null;
    id_tar_head = null;
    rate_found = 0;

    for
      select TH.ID_TAR_HEAD, RA.STATUS, RA.AUTO_PERCENT, RA.CONDITIONS, CMR.IS_PUBLIC
      from   RATE_AVAILABILITY RA
             join TAR_HEAD TH on TH.ID_TAR_HEAD = RA.ID_TAR_HEAD
             join TARIFA T on T.ID_TARIFA = TH.ID_TAR_HEAD
             join channel_mapped_rates cmr on  cmr.id_tar_head = t.id_tarifa
      where  RA.FOR_DATE = :for_date
             and T.ID_HOTEL = :id_hotel
             and cmr.id_channel = :id_channel
             and ((coalesce(:rates,'') = '') or (','||:rates||',' containing ','||T.ID_TARIFA||','))
             and exists (select trt.id_room_type
                         from   TARIFA_ROOM_TYPES_SUPPORTED (th.id_tar_head) trt
                         where  trt.id_room_type = :ID_ROOM_TYPE)
      into   :id_tar_head, :current_status, :auto_percent, :conditions, :is_public
    do begin
      /* Waprosnata tarifa ot rate mng - poddarja li waob6te tozi room-type*/
      if (:auto_percent is not null) then begin
        select sum(tso.capacity), sum(tso.occupied)
        from   tmp_small_occup tso
        where  tso.id_session =:id_helper_session
               and tso.for_date = :for_date
        into   :day_capacity, :day_occupied;

        if ((:day_capacity <> 0) and ( :day_occupied  / :day_capacity * 100 < :auto_percent)) then begin
            --execute procedure sys_dbg ('AVL  occ' || :day_occupied || '--cap' || :day_capacity || '--%' || :day_percent || '--aut%' || :auto_percent ||'--date' ||:for_date );
          rate_status = 2;
        end else begin
          rate_status = 0;
        end
      end else if (:current_status = 0) then /*rsSell*/
        rate_status = 2;
      else if (:current_status = 1) /*rsStop*/ then
        rate_status = 0;
      else
        rate_status = 1; /*rsNoArrival*/

      min_los = null;
      max_los = null;

      for
        select ITEM
        from   SYSTEM_STRING_PARSER(:conditions,';')
        into   :part
      do begin
        subpart = null;
        select lower(ITEM)
        from   SYSTEM_STRING_PARSER(:part,':')
        where  inturn = 1
        into   :subpart;

        if (:subpart is not null) then begin
          if (:subpart in ('min','equal')) then
            select ITEM
            from   SYSTEM_STRING_PARSER(:part,':')
            where  inturn = 2
            into   :min_los;
          if (:subpart in ('max','equal')) then
            select ITEM
            from   SYSTEM_STRING_PARSER(:part,':')
            where  inturn = 2
            into   :max_los;
        end
      end

      rate_found = 1;

      if (:room_status = 0) then
        product_status = 0;
      else
        product_status = coalesce(:rate_status,0);

      suspend;
    end

    if (:rate_found = 0) then begin
      if (:room_status = 0) then
        product_status = 0;
      else
        product_status = coalesce(:rate_status,0);

      suspend;
    end
  end

  delete from TMP_SMALL_OCCUP tso where tso.id_session = :id_helper_session;

end
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_ROOM$INT for: PROFILE_PERSON_CREATEQ$PROFILE */
ALTER PROCEDURE RES_CREATE_ROOM$INT(CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_COUNT INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_AGENT_PROFILE INTEGER,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_PERSON_PROFILE INTEGER,
ACC_ROUTING VARCHAR(50),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ID_GROUP INTEGER = null,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_GUARANTEE_POLICY INTEGER = null,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
RD_DBKEY CHAR(8),
NEW_ID_PERSON_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GET_PERSON_PROFILE$INT for: PROFILE_PERSON_CREATEQ$PROFILE */
ALTER PROCEDURE RES_GET_PERSON_PROFILE$INT(ID_GUEST INTEGER)
 RETURNS(ID_PERSON_PROFILE INTEGER,
ID_PERSON_DATA INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PROFILE_PERSON_CREATEQ$PROFILE) */
ALTER PROCEDURE PROFILE_PERSON_CREATEQ$PROFILE(PROFILE_NAME TYPE OF TPERSON_NAME,
PHONE TYPE OF TPHONE,
ID_PASSPORT_TYPE TYPE OF ID,
PASS_NUM TYPE OF NAME_20,
EGN TYPE OF TTEXT_SHORT,
COUNTRY_CODE TYPE OF TSHORT_CODE,
CARD_CODE TYPE OF TCARD_CODE,
ID_PERSON_DATA TYPE OF ID_REF = null,
TITLE TYPE OF TSHORT_CODE = null,
ID_HOTEL TYPE OF ID_REF = null)
 RETURNS(NEW_ID_PROFILE TYPE OF ID,
P_DBKEY TYPE OF TDB_KEY,
PD_DBKEY TYPE OF TDB_KEY)
 AS
declare variable action_text varchar(255);
  declare variable mask varchar(10);
  declare variable first_name varchar(30);
  declare variable surname varchar(30);
  declare variable family_name varchar(30);
begin

  new_id_profile = gen_id(gen_profile_id, 1);
  insert into PROFILE (ID_PROFILE, PROFILE_NAME, PROFILE_TYPE, PHONE, IS_ARCHIVE)
  values (:new_id_profile, :profile_name, 'PERSON', :phone, 0)
  returning RDB$DB_KEY into :p_dbkey;

  if (:id_person_data is null) then begin
    id_person_data = gen_id(gen_person_data_id, 1);

    if (:ID_HOTEL is not null) then begin
      execute procedure SETTING_GET_VALUE ('DEF_GUEST_MASK', :ID_HOTEL)
      returning_values  :mask;
    end

    select PP.FIRST_NAME,  PP.SURNAME, PP.FAMILY_NAME
    from   PERSON_NAME_PARSE$INT (:PROFILE_NAME) PP
    into   :first_name,  :surname, :family_name;

    insert into PERSON_DATA(ID_PERSON_DATA, PERSON_NAME2, ID_PASSPORT_TYPE, PASS_NUM, EGN, MASK,
           FIRST_NAME, SURNAME, FAMILY_NAME, COUNTRY_CODE)
    values (:id_person_data, :profile_name, :id_passport_type, :pass_num, :egn, :mask,
           :first_name, :surname, :family_name, :country_code)
    returning RDB$DB_KEY into :pd_dbkey;

    execute procedure PERSON_DATA_SET$INT(:p_dbkey, :pd_dbkey, :profile_name, :profile_name, :country_code,
            null, null, :TITLE);
  end

  insert into PROFILE_PERSON (ID_PROFILE, ID_PERSON_DATA, CARD_CODE)
  values (:new_id_profile, :id_person_data, :card_code);

  action_text = f_character(29) || :profile_name;
  execute procedure SYSTEM_LOG_ADD ('PROFILE', :new_id_profile, 'CREATE_PERS_PROFILE', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_PERSON_PROFILE$EXC for: PROFILE_PERSON_MODIFY$PROFILE */
ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
CLEAR_HOTEL_RATE SMALLINT,
CREATE_ONLY SMALLINT,
MERGE_TARGET_UUID VARCHAR(40))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PROFILE_PERSON_MODIFY$PROFILE) */
ALTER PROCEDURE PROFILE_PERSON_MODIFY$PROFILE(ID_PROFILE INTEGER,
ID_GUEST_TYPE INTEGER,
PROFILE_NAME VARCHAR(100),
PERSON_NAME2 VARCHAR(100),
SEX CHAR,
BIRTH_DAY DATE,
BIRTH_PLACE VARCHAR(30),
EGN VARCHAR(30),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
COUNTRY_CODE VARCHAR(20),
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
MASK VARCHAR(10),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
IS_ARCHIVE INTEGER,
ID_PHOTO INTEGER,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
TITLE VARCHAR(10) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable p_dbkey char(8);
  declare variable pd_dbkey char(8);
  declare variable old_birth_day date;
  declare variable id_picture integer;
  declare variable birthday_internal date;
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    new_id_profile = :id_profile;

    if (:operation = 'add') then begin
      execute procedure PROFILE_PERSON_CREATEQ$PROFILE(:profile_name, :phone,
              :id_passport_type, :pass_num, :egn, :country_code, :card_code, null, :TITLE, null)
      returning_values  :new_id_profile, :p_dbkey, :pd_dbkey;

      if (:MASK is null) then begin
        -- keep the default mask if input mask is <null> - inexplicit
        -- empty mask is '' - passed by GUI, but <null> is passed from booking import, etc.
        select PD.MASK
        from   PERSON_DATA PD
        where  PD.RDB$DB_KEY = :pd_dbkey
        into   :mask;
      end
    end

    select P.RDB$DB_KEY, PD.RDB$DB_KEY, pd.BIRTH_DAY
    from   PROFILE P
           join PROFILE_PERSON PP on PP.ID_PROFILE = P.ID_PROFILE
           join PERSON_DATA PD on PD.ID_PERSON_DATA = PP.ID_PERSON_DATA
    where  P.ID_PROFILE = :new_id_profile
    into   :p_dbkey, :pd_dbkey, :old_birth_day;

    execute procedure PROFILE_COMMON_MODIFY$INT(:new_id_profile, 'PERSON', :profile_name,
            :phone, :fax, :email, :contact_city, :contact_address,
            :note, :msg, :is_archive, :id_def_contragent, :id_nom_market_segment,
            :wbe_password, :account_no, :is_exclusive_debt_ownership)
    returning_values (:new_id_profile);

    execute procedure PERSON_DATA_SET$INT(:p_dbkey, :pd_dbkey, :profile_name, :person_name2, :country_code,
            :old_birth_day, :birth_day, :TITLE);

    execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, :birth_place, :egn, :id_passport_type, :pass_num, :pass_date, :pass_place,
            :pass_exp_date, :pass_city, :pass_address, :sex, :mask);

    update PROFILE_PERSON PP
    set    PP.ID_GUEST_TYPE = :id_guest_type,
           PP.ID_PHOTO = :id_photo,
           PP.CARD_CODE = :card_code
    where  PP.ID_PROFILE = :new_id_profile;

  end else if (:operation = 'del') then begin
    id_picture = null;

    select PP.ID_PHOTO
    from   PROFILE_PERSON PP
    where  PP.ID_PROFILE = :id_profile
    into   :id_picture;

    execute procedure PICTURE_MODIFY (:id_picture, null, null, null, 'del')
    returning_values :id_picture;

    execute procedure PROFILE_DELETE$INT(:id_profile);
    new_id_profile = null;
  end
end
^

/* Alter (RATE_GET_AVAILABILITY$CHM) */
ALTER PROCEDURE RATE_GET_AVAILABILITY$CHM(ID_RATE INTEGER,
FOR_DATE DATE)
 RETURNS(ACTIVE_STATUS INTEGER,
MIN_LOS INTEGER,
MAX_LOS INTEGER)
 AS
declare variable date_from date;
  declare variable date_to date;
  declare variable RATE_capacity integer;
  declare variable to_sell integer;
begin
  --ACTIVE_STATUS 0 - closed
  --ACTIVE_STATUS 1 - closed fro arrival
  --ACTIVE_STATUS 2 - opened
  --opala ID_HOTEL
--  date_from = null;
--  ACTIVE_STATUS -  autoclose, t.e. AUTO_PERCENT






/*  select min(FOR_DATE), max(FOR_DATE)
  from RATE_ALLOTMENT
  where ID_RATE = :id_RATE
  into :date_from, :date_to;
  if (date_from is null) then exit;

  for select distinct ID_ROOM_TYPE
      from RATE_ALLOTMENT
      where ID_RATE = :id_RATE
        and FOR_DATE between :date_from and :date_to
      into :id_room_type
  do begin
    for select RTR.FOR_DATE,
               CA.STATUS,
               CA.AUTO_FREE_ROOMS, CA.ROOM_COUNT, RTR.AVAILABLE as FREE_ROOMS
        from ROOM_TYPE_GET_FREE$CHM(:date_from, :date_to, :id_room_type) RTR
             join RATE_ALLOTMENT CA on CA.ID_ROOM_TYPE = :id_room_type
                                      and CA.ID_RATE = :id_RATE
                                      and CA.FOR_DATE = RTR.FOR_DATE
    into :for_date, :status,
         :auto_free_rooms, :RATE_capacity, :free_rooms
    do begin
      if (:auto_free_rooms is not null) then
        if (coalesce(:free_rooms,0) >= :auto_free_rooms) then
          is_active = 1;
        else is_active = 0;
      else if (:status = 0) then
             is_active = 1;
           else is_active = 0;

      to_sell = coalesce(:free_rooms,0) - coalesce(:auto_free_rooms,0);
      if (to_sell < 0) then to_sell = 0;

      room_count = :to_sell;
      if (:RATE_capacity is not null) then
        if (RATE_capacity < room_count) then
          room_count = :RATE_capacity;

      suspend;
    end
  end*/
end
^

/* empty dependent procedure body */
/* Clear: APPLY_BOOKING_STATUS$EXC for: RES_CHECK_OUT_GUESTS$RSV */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: EAI_RES_CHECK_OUT_FAST for: RES_CHECK_OUT_GUESTS$RSV */
ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_CHECK_OUT_GUESTS$RSV) */
ALTER PROCEDURE RES_CHECK_OUT_GUESTS$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND SMALLINT = 0)
 AS
declare variable action_code varchar(100);
  declare variable cleaning_restriction varchar(10);
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable id_reserv_detail integer;
  declare variable id_guest integer;
  declare variable id_room integer;
  declare variable rd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable checkout_status integer;
  declare variable sys_date date;
  declare variable warn_code integer;
  declare variable id_hotel integer;
begin
  checkout_status = 1;
  action_code = case when :check_out_kind = 0 then 'CHECK_OUT'
                     when :check_out_kind = 1 then 'CHECK_OUT_EARLY1'
                     when :check_out_kind = 2 then 'CHECK_OUT_EARLY2'
                     when :check_out_kind = 3 then 'CHECK_OUT_EARLY3'
                end;

  for
    select RD.ID_RESERV_DETAIL, RD.ID_ROOM, RD.RDB$DB_KEY, rd.ID_HOTEL,
           (select sd.SYSTEM_DATE
            from   SYSTEM_DATE_GET (rd.ID_HOTEL) sd)
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :id_reserv_detail, :id_room, :rd_dbkey, :id_hotel, :sys_date
  do begin

    for
      select G.ID_GUEST, G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.CHECK_STATUS = 0 /* checked in */
      into   :id_guest, :g_dbkey
    do begin
      if (:CHECK_OUT_KIND = 3) then begin
        -- DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
        update GUEST G
        set    G.EARLYCHECKOUT_DATE = :sys_date
        where  g.RDB$DB_KEY = :g_dbkey;

        execute procedure GUEST_SET_MANUAL_STAY$INT(:rd_dbkey, :id_guest, :sys_date)
        returning_values  :err_code, :err_text;
        if (:err_code < 0) then exception RESERV_CHECK_OUT_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
      end

      update ACCOUNT_POST AP
      set    AP.IS_ARCHIVE = 1
      where  AP.ID_GUEST = :id_guest;
    
      execute procedure GUEST_SET_STATUS$INT (:g_dbkey, :checkout_status);

      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, :action_code, '');
    end

    if (:CHECK_OUT_KIND = 3) then begin
      -- DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
      execute procedure OCCUPANCY_RESERV$INT(:rd_dbkey)
      returning_values  :err_code, :err_text, :warn_code;
      if (:err_code < 0) then exit;
    end

    execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

    execute procedure SETTING_GET_VALUE('CLEANING_RESTRICTION', :id_hotel)
    returning_values  :cleaning_restriction;
  
    if (:cleaning_restriction <> '0' and :id_room > 0) then begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'CHECK_OUT', 'set_dirty');
    end

    execute procedure RES_SAVE_STATUS$INT (:rd_dbkey, :checkout_status);

    execute procedure RES_BONUSPOINTS_APPLY$CL (:id_reserv_detail);
  end

end
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_SET$INT for: RES_CREATE_ROOM$INT */
ALTER PROCEDURE RES_CREATE_SET$INT(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_HOTEL INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
SPLIT_ON_CHECKIN SMALLINT,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_ACC_TEMPLATE_PERSON INTEGER = null,
ID_GUARANTEE_POLICY INTEGER = null,
BLOCK_CC VARCHAR(255) = null,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(RD_DBKEY CHAR(8),
NEW_ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_CREATE_ROOM$INT) */
ALTER PROCEDURE RES_CREATE_ROOM$INT(CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_COUNT INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_AGENT_PROFILE INTEGER,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_PERSON_PROFILE INTEGER,
ACC_ROUTING VARCHAR(50),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ID_GROUP INTEGER = null,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_GUARANTEE_POLICY INTEGER = null,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
RD_DBKEY CHAR(8),
NEW_ID_PERSON_PROFILE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable day_keep_types integer;
  declare variable exp_date date;
  declare variable leaving_kind integer;
  declare variable cnt_processed integer;
begin
  execute procedure SETTING_GET_VALUE('DAY_KEEP_TYPES', :ID_HOTEL)
  returning_values  :day_keep_types;
  exp_date = :arrival_date + :day_keep_types;
  leaving_kind = coalesce(:is_late_departure, 0) + 1;
  comming_kind = coalesce(:comming_kind, 1);

  cnt_processed = 0;
  while (:room_count > :cnt_processed) do begin
    if (:res_number is null) then begin
      execute procedure SYSTEM_GEN_NUM('BOOKING', 0)
      returning_values  :dbg, :res_number;
    end
    
    if (:id_person_profile is null) then begin
      execute procedure PROFILE_PERSON_CREATEQ$PROFILE(:res_number, '', null, null, null,
              :country_code, null, null, null, :ID_HOTEL)
      returning_values  :new_id_person_profile, :dbg, :dbg;
      execute procedure sys_dbg('res RES_CREATE_ROOM$INT autocreate id_person_profile = '||coalesce(:id_person_profile, 'null'));
    end else begin
      new_id_person_profile = :id_person_profile;
    end

    execute procedure RES_CREATE_DETAIL$INT(:id_reserv_detail, :id_agent_profile, :res_number, :check_status,
                      :arrival_date, :departure_date, :code_first_food, :exp_date, :comming_kind, :leaving_kind,
                      :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                      0, 0, :note, :i_special_treatment, :id_board, -1, :id_rate,
                      :id_room_type, :country_code, '30.12.1899', null, null, '30.12.1899', null, null, null,
                      :room_features, :id_hk_plan, :new_id_person_profile, :id_hotel, :acc_routing, :id_acc_template_person,
                      :id_group, :id_agent_account, :id_guarantee_policy, :ID_EATING_OBJECT)
    returning_values  :new_id_reserv_detail, :rd_dbkey;
    res_number = null;

    execute procedure RES_GUESTCOUNT_ADD$INT(:rd_dbkey, :adult_count, :child_count);

    cnt_processed = :cnt_processed + 1;
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_SET$EXC for: RES_CREATE_SET$INT */
ALTER PROCEDURE RES_CREATE_SET$EXC(ID_RESERV_DETAIL INTEGER,
RES_NUMBER VARCHAR(62),
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER,
CREATE_DATETIME TIMESTAMP)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_RESERV_DETAIL INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_SET$RSV for: RES_CREATE_SET$INT */
ALTER PROCEDURE RES_CREATE_SET$RSV(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
SUPPRESS_WARNINGS INTEGER,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT$RSV for: RES_CREATE_SET$INT */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_CREATE$RSV for: RES_CREATE_SET$INT */
ALTER PROCEDURE RESMULTI_CREATE$RSV(ID_HOTEL INTEGER,
ID_ROOM_TYPE INTEGER,
TRANSFER_OUT_TIME TIME,
TRANSFER_IN_TIME TIME,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
TRANSFER_OUT_NOTE VARCHAR(50),
TRANSFER_IN_NOTE VARCHAR(50),
NOTE VARCHAR(255),
ID_BOARD INTEGER,
VOUCHER_DATE DATE,
VOUCHER_NUMBER VARCHAR(20),
VOUCHER_TEXT VARCHAR(30),
CHECK_STATUS INTEGER,
ID_TARIFF INTEGER,
COUNTRY_CODE VARCHAR(20),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
NOTE_REMINDERS VARCHAR(50),
TITULAR_NAME VARCHAR(100),
SPLIT_ON_CHECKIN INTEGER,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
NUMBER VARCHAR(62),
NEW_ID_TITULAR INTEGER,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_CREATE_SET$INT) */
ALTER PROCEDURE RES_CREATE_SET$INT(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(255),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_HOTEL INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
SPLIT_ON_CHECKIN SMALLINT,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_ACC_TEMPLATE_PERSON INTEGER = null,
ID_GUARANTEE_POLICY INTEGER = null,
BLOCK_CC VARCHAR(255) = null,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(RD_DBKEY CHAR(8),
NEW_ID_RESERV_DETAIL INTEGER)
 AS
declare variable guarantee_deposit_percent numeric(15,4);
  declare variable guarantee_deposit_nights integer;
  declare variable guarantee_due_days_bef_arrival integer;
  declare variable guarantee_due_days_after_create integer;
  declare variable gp_check_status integer;
  declare variable log_suppressed integer;
  declare variable id_guest integer;
  declare variable minibar_rights varchar(50);
  declare variable video_rights varchar(50);
  declare variable nopost_pms varchar(50);
  declare variable phone_rights varchar(50);
  declare variable paytv_rights varchar(50);
  declare variable is_profile_exclusive_debt_ownership integer;
  declare variable id_base_account integer;
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CREATE');

  select GP.DEPOSIT_NIGHTS_COUNT, GP.DEPOSIT_TOTALSUM_PART,
         GP.DUE_DAYS_BEFORE_ARRIVAL, GP.DUE_DAYS_AFTER_CREATE, gp.CHECK_STATUS
  from   GUARANTEE_POLICY GP
  where  GP.ID_GUARANTEE_POLICY = :ID_GUARANTEE_POLICY
         and gp.ID_HOTEL = :ID_HOTEL
  into   :guarantee_deposit_nights, :guarantee_deposit_percent,
         :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create, :gp_check_status;

  CHECK_STATUS = coalesce(:CHECK_STATUS, :gp_check_status, -2);

  execute procedure RES_CREATE_ROOM$INT(:check_status, :arrival_date, :departure_date, :adult_count, :child_count,
                    :id_room_type, 1, :id_board, :id_tariff, comming_kind, :is_late_departure, :country_code, :code_first_food,
                    :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note, :i_special_treatment, :id_agent_profile,
                    :id_hk_plan, '', :room_features, :id_person_profile, :acc_routing, :id_acc_template_person, :id_hotel, :id_agent_account,
                    :id_group, :id_reserv_detail, :res_number, :id_guarantee_policy, :id_eating_object)
  returning_values  :new_id_reserv_detail, :rd_dbkey, :id_person_profile;

  if (RDB$GET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE') is not distinct from 'disable') then begin
    log_suppressed = 1;
  end else begin
    log_suppressed = 0;
    RDB$SET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE', 'disable');
    -- disable only for intermediate changes
  end

  execute procedure RES_SAVE_ACCOUNTING$INT (:rd_dbkey, :id_agent_profile, :id_agent_account, :acc_routing,
          :id_person_payment, :id_agent_payment, :id_group);

  execute procedure RES_SAVE_MARKETING$INT(:rd_dbkey, :id_nom_market_segment,
                    :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason);

  execute procedure sys_dbg('res RES_CREATE_SET$INT id_room = '||coalesce(:id_room, 'null'));
  if (:id_room is not null) then begin
    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, :id_room_type, 'nrttRoom');
  end

  execute procedure RES_SAVE_VOUCHER$INT(:RD_DBKEY, :voucher_num, :voucher_date, :voucher_text, :voucher2_num, :voucher2_date);

  execute procedure RES_SAVE_NOTE$RSV(:new_id_reserv_detail, :note, :note_reminders);

  for
    select  g.ID_GUEST
    from    GUEST G
    where   G.ID_RESERV_DETAIL = :NEW_ID_RESERV_DETAIL
    into    :id_guest
  do begin
    execute procedure RES_GUEST_SAVE_PACKET$RSV (:id_guest, :PACKET_ITEM_IDS);
  end 

  update RESERV_DETAIL RD
  set    RD.CUSTOM_PRICE = :CUSTOM_PRICE,
         RD.CUSTOM_CURRENCY = :CUSTOM_CURRENCY,
         RD.SPLIT_ON_CHECKIN = :SPLIT_ON_CHECKIN,
         RD.IS_VIP = coalesce(:IS_VIP, RD.IS_VIP),
         RD.ID_GUARANTEE_POLICY = :ID_GUARANTEE_POLICY,
         RD.GUARANTEE_DEPOSIT = :GUARANTEE_DEPOSIT,
         RD.GUARANTEE_CURRENCY = :GUARANTEE_CURRENCY,
         RD.BLOCK_CC = :BLOCK_CC,
         RD.GUARANTEE_DEPOSIT_PERCENT = :guarantee_deposit_percent,
         RD.GUARANTEE_DEPOSIT_NIGHTS = :guarantee_deposit_nights,
         RD.GUARANTEE_DUE_DAYS_BEF_ARRIVAL = :guarantee_due_days_bef_arrival,
         RD.GUARANTEE_DUE_DAYS_AFTER_CREATE = :guarantee_due_days_after_create
         /*rd.POSTING_TRANSACTION_UUID =  (select iif(p.IS_EXCLUSIVE_DEBT_OWNERSHIP = 1, uuid_create(), null)
                                         from   ACCOUNT A
                                                join PROFILE P on P.ID_PROFILE = a.ID_PROFILE
                                         where  a.ID_ACCOUNT = rd.ID_BASE_ACCOUNT)*/
  where  RD.RDB$DB_KEY = :rd_dbkey
  returning new.ID_BASE_ACCOUNT
  into      :id_base_account;

  select p.IS_EXCLUSIVE_DEBT_OWNERSHIP
  from   ACCOUNT A
         join PROFILE P on P.ID_PROFILE = a.ID_PROFILE
  where  a.ID_ACCOUNT = :id_base_account
  into   :is_profile_exclusive_debt_ownership;

  if (:is_profile_exclusive_debt_ownership = 1) then begin
    execute procedure RES_TAKE_POSTING_RESPONSIBILITY (:NEW_ID_RESERV_DETAIL);
  end

  select rt.MINIBAR_RIGHTS, rt.VIDEO_RIGHTS, rt.NOPOST_PMS, rt.PHONE_RIGHTS, rt.PAYTV_RIGHTS
  from   RES_TEMPLATE RT
  where  rt.ID_HOTEL = :ID_HOTEL
  into   :minibar_rights, :video_rights, :nopost_pms, :phone_rights, :paytv_rights;

  execute procedure RESERV_DETAIL_EXTERNAL_MOD$RSV (:NEW_ID_RESERV_DETAIL,
          :minibar_rights, :paytv_rights, :video_rights, :nopost_pms, :phone_rights, null, null);

  if (:log_suppressed = 0) then RDB$SET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE', 'enable');

  execute procedure RES_CREATE_LOG$INT (:RD_DBKEY);

end
^

/* Alter (RES_CREATE_SET$RSV) */
ALTER PROCEDURE RES_CREATE_SET$RSV(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
SUPPRESS_WARNINGS INTEGER,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER,
NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable rd_dbkey char(8);
begin
  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, :check_status, :arrival_date, :departure_date,
                    :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff, :PACKET_ITEM_IDS,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
                    :guarantee_deposit, :guarantee_currency, :split_on_checkin, null, null, :ID_ACC_TEMPLATE_PERSON,
                    :ID_GUARANTEE_POLICY, null, :ID_EATING_OBJECT)
  returning_values  :rd_dbkey, :new_id_reserv_detail;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :ERR_TEXT, :share_transaction_id, :warn_code;

  if (:suppress_warnings = 1) then begin
    delete from SYSTEM_WARNINGS W
    where W.ID_TRANSACTION = :warn_code;
    warn_code = null;
  end

  update RESERV_DETAIL RD
  set    RD.NOTE_REMINDERS = :note_reminders
  where  RD.RDB$DB_KEY = :rd_dbkey;

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;

end
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE_SHAREOPTION$INT for: RES_FINALIZE_OCCUPANCY$INT */
ALTER PROCEDURE RES_FINALIZE_SHAREOPTION$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_FINALIZE_OCCUPANCY$INT) */
ALTER PROCEDURE RES_FINALIZE_OCCUPANCY$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ERROR_CONTEXT VARCHAR(200),
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable busy_group_source integer;
declare variable tmp_warn_code integer;
begin
  err_code = 0;
  warn_code = null;
  tmp_warn_code = null;

  select iif(RD.CHECK_STATUS = 1, 24, 1)
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :busy_group_source;

  error_context = 'OCCUPANCY';
  execute procedure OCCUPANCY_RESERV$INT(:rd_dbkey)
  returning_values  :err_code, :err_text, :warn_code;
  if (:err_code < 0) then exit;

  error_context = 'ROOM_VALIDATION';
  execute procedure OCCUPANCY_ROOM$INT(:rd_dbkey, :busy_group_source)
  returning_values  :share_err_code, :share_err_text, :share_transaction_id, :tmp_warn_code;

  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

  /* empty shares helper table*/
  delete from RESERV_STAY$TMP t
  where  t.id_session = RDB$GET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION');

end
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE$INT for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_FINALIZE$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ROOM$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SAVE_ROOM$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
ID_RES_ROOM_TYPE INTEGER,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(255),
SPLIT_ON_CHECKIN SMALLINT,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_STAY$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SAVE_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_CHECKIN$INT for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SET_CHECKIN$INT(RD_DBKEY CHAR(8))
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM$INT for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SET_ROOM$INT(RD_DBKEY CHAR(8),
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_STAY$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SET_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_FINALIZE$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RESMULTI_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER,
DISABLE_WARNING SMALLINT)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_FINALIZE_SHAREOPTION$INT) */
ALTER PROCEDURE RES_FINALIZE_SHAREOPTION$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable error_context varchar(200);
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable room_price numeric(15,4);
  declare variable is_anul smallint;
begin
  /* permissible FINALIZE_OPTIONS: OCCUPANCY, RECALC, GRP, ALL_ERRORS_ARE_INSTANT */
  WARN_CODE = null;

  select RD.ID_RESERV_DETAIL, RD.CHECK_STATUS, rd.ROOM_PRICE, rd.IS_ANUL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail, :check_status, :room_price, :is_anul;

  execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));
  --if (:finalize_options containing 'OCCUPANCY') then begin
    execute procedure RES_FINALIZE_OCCUPANCY$INT(:rd_dbkey)
    returning_values  :err_code, :err_text, :error_context, :share_transaction_id, :share_err_code, :share_err_text, :warn_code;
    /*if (:share_err_code <> 0) then begin
      err_code = 0;                         -- err_codes are independant from share_err_codes
      share_err_text = :err_text;           -- err_code should not be whitewashed by share_err_code
    end*/
    execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT share_err_code = '||coalesce(:share_err_code, 'null'));
    execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT share_err_text = '||coalesce(:share_err_text, 'null'));
    execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT err_code = '||coalesce(:err_code, 'null'));

    execute procedure RES_FINALIZE_ERRHANDLING$INT(:id_reserv_detail, :err_code, :err_text, :error_context, :SUPPRESS_NON_INSTANT_ERRORS);
  --end

  /*if (:finalize_options containing 'RECALC') then begin
    if ((:finalize_options containing 'GRP') and (:check_status < 0)) then begin
      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = null,
             RD.ROOM_CURRENCY = null,
             RD.ROOM_PRICE_DETAILS = ''
      where  RD.RDB$DB_KEY = :rd_dbkey;
    end else*/
    if (((:check_status >= 0) or (:room_price is null) or (:is_anul = 1) ) /*and (:is_anul = 0)*/) then begin
      execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
      returning_values  :err_code, :err_text;
  
      --execute procedure TAR_CALC_FINALIZE$INT(:err_code, :id_tar_calc, :rd_dbkey);  -- enclosed into RES_FINALIZE_RECALC$INT
  
      execute procedure RES_FINALIZE_ERRHANDLING$INT(:id_reserv_detail, :err_code, :err_text, 'RECALC', :SUPPRESS_NON_INSTANT_ERRORS);
    end
--  end

  execute procedure RES_FINALIZE_CLEAR$INT(:rd_dbkey, :id_reserv_detail);

  warn_code = coalesce(:WARN_CODE, RDB$GET_CONTEXT('USER_TRANSACTION', 'WARN_CODE'));
  RDB$SET_CONTEXT('USER_TRANSACTION', 'WARN_CODE', null);

  /*if (:share_err_code < 0) then begin
    -- on err_code <> 0, should be exited before this statement
    err_text = :share_err_text;
  end*/

end
^

/* Alter (RES_GET_PERSON_PROFILE$INT) */
ALTER PROCEDURE RES_GET_PERSON_PROFILE$INT(ID_GUEST INTEGER)
 RETURNS(ID_PERSON_PROFILE INTEGER,
ID_PERSON_DATA INTEGER)
 AS
declare variable p_dbkey char(8);
  declare variable profile_name varchar(100);
  declare variable pd_dbkey char(8);
  declare variable id_hotel integer;
  declare variable title varchar(10);
begin
  select PD.ID_PERSON_DATA, PD.PERSON_NAME, PP.ID_PROFILE, rd.ID_HOTEL, pd.TITLE
  from   GUEST G
         join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
         join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
         join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
         left outer join PROFILE_PERSON PP on PP.ID_PERSON_DATA = GD.ID_PERSON_DATA
  where  G.ID_GUEST = :id_guest
  into   :id_person_data, :profile_name, :id_person_profile, :id_hotel, :title;

  if (:id_person_profile is null) then begin
    execute procedure PROFILE_PERSON_CREATEQ$PROFILE(:profile_name, '', null, null, null, null, null, :id_person_data, :title, :id_hotel)
    returning_values  :id_person_profile, :p_dbkey, :pd_dbkey;
  end
end
^

/* empty dependent procedure body */
/* Clear: RESGRP_GET_INFO$RSV for: RES_GET_SHARE_STATUS$INT */
ALTER PROCEDURE RESGRP_GET_INFO$RSV(ID_INFO_GROUP INTEGER)
 RETURNS(AGENT_PROFILE_NAME VARCHAR(100),
ARRIVALS VARCHAR(255),
DEPARTURES VARCHAR(255),
ROOM_DATA VARCHAR(255),
ROOMS VARCHAR(255),
ID_ROOM INTEGER,
GUESTS VARCHAR(255),
PERSON_PROFILE_NAME VARCHAR(100),
RATES VARCHAR(255),
BOARDS VARCHAR(255),
PACKETS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY VARCHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
BALANCE VARCHAR(255),
OPEN_CHARGES INTEGER,
CHECK_STATUS VARCHAR(255),
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
NOTE VARCHAR(2000),
NOTE_GRP VARCHAR(255),
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
FIRST_ARRIVAL DATE,
FIRST_DEPARTURE DATE,
HOTELS VARCHAR(255),
ID_HOTEL INTEGER,
ACC_ROUTING VARCHAR(255),
RES_NUMBER VARCHAR(62))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_GET_GUESTS$INT for: RES_GET_SHARE_STATUS$INT */
ALTER PROCEDURE TAR_CALC_GET_GUESTS$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_GUEST INTEGER,
ID_TARIFF_CALC INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
G_DBKEY CHAR(8))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GET_SHARE_STATUS$INT) */
ALTER PROCEDURE RES_GET_SHARE_STATUS$INT(ID_RESERV_DETAIL INTEGER,
OPTION_ VARCHAR(100),
FOR_DATE DATE)
 RETURNS(SHARE_STATUS INTEGER,
SHARED_RESERVATIONS VARCHAR(1024),
SHARE_RENDER VARCHAR(1024))
 AS
declare variable mark_transaction integer;
  declare variable shared_reservation_id integer;
  declare variable occupant_info varchar(2000);
  declare variable is_ex_share integer;
  declare variable check_status integer;
  declare variable split_on_checkin integer;
  declare variable res_from_date date;
  declare variable res_to_date date;
  declare variable related_reservations VARCHAR(1024);
  declare variable busy_group_type integer;
begin
  /*  OPTIONs:
    !!!! DONT mix options !!!.
    ENUM_SHARES - return id's of shared reservations (SHARED_RESERVATIONS) in this save session - usable for calculation and regenerations, but not for renders.
    ENUM_EX_SHARES - return id's of shared reservations just leaved share. As above..
    RENDER - render all reservations in share with current. Usabe for gui previews.
  */
  execute procedure SYSTEM_CHECK_OPERATION (:OPTION_, 'ENUM_SHARES,ENUM_EX_SHARES,RENDER,FOR_RECALC', 'option');

  execute procedure sys_dbg('calc RES_GET_SHARE_STATUS$INT options = '||coalesce(:OPTION_, 'null'));

  shared_reservations = '';
  share_render = '';

  select RD.CHECK_STATUS, RD.SPLIT_ON_CHECKIN, RD.FROM_DATE, RD.TO_DATE
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :check_status, :split_on_checkin, :res_from_date, :res_to_date;

  mark_transaction = RDB$GET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION');

  if (:mark_transaction is null) then begin
    -- THE CALLER IS outside saving/regeneration transaction - NOT FINALIZING BOOKING CHANGES
    select min(RS.IS_EX_SHARE)
    from   ROOMS_SHARE RS
    where  RS.ID_RESERV_DETAIL = :id_reserv_detail
           and ((:for_date is null) or (RS.BUSY_DATE = :for_date))
    into   :is_ex_share;
  end else begin
    -- THIS TRANSACTION IS Saving booking and REGENERATING ROOMS_MAGIC
    select min(RS.IS_EX_SHARE)
    from   ROOMS_SHARE RS
    where  RS.MARK_TRANSACTION = :mark_transaction
           and ((:for_date is null) or (RS.BUSY_DATE = :for_date))
    into   :is_ex_share;
  end

  execute procedure sys_dbg('calc RES_GET_SHARE_STATUS$INT mark_transaction = '||coalesce(:mark_transaction, 'null'));

  if (:is_ex_share = 0) then share_status = 1;
  /*else - null or 1*/
  else share_status = 0;

  execute procedure sys_dbg('calc RES_GET_SHARE_STATUS$INT share_status = '||coalesce(:share_status, 'null'));

  /*option will be changed if we want enum shares ouside modification transaction - for recalculation in example*/
  if ((:OPTION_ = 'ENUM_SHARES') and (:share_status = 1) and (:mark_transaction is null)) then begin
    option_ = 'RENDER';
    execute procedure sys_dbg('calc RES_GET_SHARE_STATUS$INT option was ENUM_SHARES but is changd to RENDER, because :mark_transaction is null' );
  end

  if ((:OPTION_ = 'ENUM_SHARES') and (:share_status = 1)) then begin
    for
      select distinct RS.ID_RESERV_DETAIL
      from   ROOMS_SHARE RS
      where  RS.MARK_TRANSACTION = :mark_transaction
             and RS.BUSY_DATE = coalesce(:for_date, RS.BUSY_DATE)
             and RS.IS_EX_SHARE = 0
      into   :shared_reservation_id
    do begin
      if (:shared_reservation_id <> :id_reserv_detail) then begin
        shared_reservations = :shared_reservations || iif(:shared_reservations = '', '', ',');
        shared_reservations = :shared_reservations || :shared_reservation_id;
      end
    end
  end

  if (:OPTION_ = 'RENDER') then begin
    if (:SHARE_STATUS = 0 ) then begin
      if (:check_status < 0 and :split_on_checkin = 1 and :OPTION_ = 'RENDER') then begin
        share_status = 2;
        exit;
      end
    end else begin
      if (:for_date is not null) then begin
        /*make render only for one date, otherwise for erservation period*/
        res_from_date = :for_date;
        res_to_date = :for_date;
      end

      for
        select distinct RS.ID_RESERV_DETAIL, rs.BUSY_GROUP_TYPE
        from   ROOM_MAGIC rm
               join ROOMS_SHARE RS on rm.id_room = rs.id_room
                                      and rm.busy_date = rs.busy_date
        where  rm.id_reserv_detail = :id_reserv_detail
               and RM.BUSY_DATE between :res_from_date and :res_to_date
               and RS.IS_EX_SHARE = 0
        into   :shared_reservation_id, :busy_group_type
      do begin
        if (:shared_reservation_id <> :id_reserv_detail) then begin
          shared_reservations = :shared_reservations || iif(:shared_reservations = '', '', ',');
          shared_reservations = :shared_reservations || :shared_reservation_id;
          select OGI.INFO
          from   OCCUPANT_GET_INFO(:shared_reservation_id, :busy_group_type) OGI
          into   :occupant_info;
          share_render = :share_render || iif(:share_render = '', '', ',');
          share_render = :share_render || :occupant_info;
        end
      end
    end
  end

  if (:OPTION_ = 'ENUM_EX_SHARES') then begin
    for
      select distinct
             RS.ID_RESERV_DETAIL
      from   ROOMS_SHARE RS
      where  RS.MARK_TRANSACTION = :mark_transaction
             and ((:for_date is null) or (RS.BUSY_DATE = :for_date))
             /*and not exists (select RSH.ID_ROOM_SHARE
                             from   ROOMS_SHARE RSH
                             where  RSH.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                                    and RSH.BUSY_DATE = RS.BUSY_DATE
                                    and RSH.ID_ROOM = RS.ID_ROOM)*/
             and RS.IS_EX_SHARE = 1
      into   :shared_reservation_id
    do begin
      if (:shared_reservation_id <> :id_reserv_detail) then begin
        shared_reservations = :shared_reservations || iif(:shared_reservations = '', '', ',');
        shared_reservations = :shared_reservations || :shared_reservation_id;
      end
    end
  end

  if (:OPTION_ = 'FOR_RECALC') then begin
    /*for recalculation is needed all reservations that are connected somehow with this and relaetd to this reservations */
    execute procedure RES_GET_SHARE_ALL_RELATIONS$INT (:ID_RESERV_DETAIL)
    returning_values  :related_reservations;
    /*remove current reservation from list (recursion include curent also)*/
    for
      select SP.ITEM
      from   SYSTEM_STRING_PARSER(:related_reservations, ',') SP
      into   :shared_reservation_id
    do begin
      if (:shared_reservation_id <> :id_reserv_detail) then begin
        shared_reservations = :shared_reservations || iif(:shared_reservations = '', '', ',');
        shared_reservations = :shared_reservations || :shared_reservation_id;
      end
    end
  end

  suspend;
end
^

/* Alter (RES_GUEST_CHANGE$RSV) */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable id_guest integer;
  declare variable check_status integer;
  declare variable id_person_data integer;
  declare variable old_person_profile integer;
  declare variable old_profile_name varchar(100);
  declare variable new_profile_name varchar(100);
  declare variable acc_routing varchar(30);
  declare variable id_organizer integer;
  declare variable is_owner_profile integer;
begin
  select r.RDB$DB_KEY, r.ID_TITULAR, r.CHECK_STATUS, r.ID_PERSON_PROFILE, p.PROFILE_NAME,
         r.ACC_ROUTING, r.ID_AGENT_PROFILE
  from   RESERV_DETAIL R
         join PROFILE P on P.ID_PROFILE = r.ID_PERSON_PROFILE
  where  R.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey, :id_guest, :check_status, :old_person_profile, :old_profile_name,
         :acc_routing, :id_organizer;

  if (:old_person_profile = :ID_PERSON_PROFILE) then exit; -- NO CHANGES!

--  execute procedure RIGHTS_CHECK_GRANTED$INT ('RESERV_TITULAR_CHANGE');

  id_person_data = null;
  select pp.ID_PERSON_DATA, p.PROFILE_NAME, iif(op.ID_OWNER is null, 0, 1)
  from   PROFILE_PERSON PP
         join PROFILE P on P.ID_PROFILE = pp.ID_PROFILE
         left outer join OWNER$PMS OP on op.ID_OWNER = p.ID_PROFILE
  where  pp.ID_PROFILE = :ID_PERSON_PROFILE
  into   :id_person_data, :new_profile_name, :is_owner_profile;

  if (:id_person_data is null) then exception BOOKING_EXCEPTION '-1039';

  if (:acc_routing = 'OWNER'
      and :is_owner_profile = 0
      and not exists (select o.ID_OWNER
                      from   OWNER$PMS O
                      where  o.ID_OWNER = :id_organizer)) then
  begin
    exception BOOKING_EXCEPTION '-1041';
  end

  update RESERV_DETAIL RD
  set    rd.ID_PERSON_PROFILE = :ID_PERSON_PROFILE
  where  rd.RDB$DB_KEY = :rd_dbkey;

  if (:check_status = 1) then begin
    execute procedure PERSON_DATA_COPY$INT (:id_person_data)
    returning_values (:id_person_data);
  end

  update GUEST_DATA GD
  set    gd.ID_PERSON_DATA = :id_person_data
  where  gd.ID_GUEST = :id_guest;

  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey);

  if (exists (select ap.ID_ACCOUNT_POST
              from   ACCOUNT_POST AP
                     join ACCOUNT A on A.ID_ACCOUNT = ap.ID_ACCOUNT
              where  a.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                     and a.ID_PROFILE = :old_person_profile
                     and ap.IS_ANUL = 0)) then
    exception BOOKING_EXCEPTION '-1038';

  if (exists (select d.ID_DEPOSIT
              from   DEPOSITS D
                     join ACCOUNT A on A.ID_ACCOUNT = d.ID_ACCOUNT
              where  a.ID_PROFILE = :old_person_profile
                     and coalesce(d.ID_RESERV_DETAIL, a.ID_RESERV_DETAIL) = :ID_RESERV_DETAIL
                     and d.RECEIVED_AMOUNT > 0)) then
    exception BOOKING_EXCEPTION '-1040';

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'TITULAR_CHANGED',
          f_character(29) || :old_profile_name || f_character(28) || :new_profile_name, null);

end
^

/* empty dependent procedure body */
/* Clear: CLEAR_ORPHAN_GUESTS$EXC for: RES_GUEST_DEL$RSV */
ALTER PROCEDURE CLEAR_ORPHAN_GUESTS$EXC(BOOKING_ID INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GUEST_DEL$RSV) */
ALTER PROCEDURE RES_GUEST_DEL$RSV(ID_GUEST INTEGER,
REASON VARCHAR(50) = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable extra_posts_left integer;
begin
  select G.RDB$DB_KEY, RD.ID_RESERV_DETAIL, RD.CHECK_STATUS
  from   GUEST G
         join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
  where  G.ID_GUEST = :id_guest
  into   :rd_dbkey, :id_reserv_detail, :check_status;

  if (:check_status >= 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('RESERV_GUEST_DELETE');
  end

  execute procedure RES_GUEST_DEL$INT(:ID_GUEST, :id_reserv_detail, :REASON)
  returning_values :extra_posts_left;

  execute procedure OCCUPANCY_RESERV$INT(:rd_dbkey)
  returning_values  :err_code, :err_text, :warn_code;
  if (:err_code < 0) then exit;
  --
end
^

/* Alter (RES_GUEST_DYNAMICPARAMS_LOAD) */
ALTER PROCEDURE RES_GUEST_DYNAMICPARAMS_LOAD(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TAR_ROOM_TYPE INTEGER,
ID_BOARD INTEGER,
ID_TYPE_STAY INTEGER,
ID_TARIFF INTEGER,
ID_AUTO_ROOM_TYPE INTEGER,
ID_AUTO_BOARD INTEGER,
ID_AUTO_TYPE_STAY INTEGER,
ID_AUTO_TARIFF INTEGER)
 AS
declare variable id_res_room_type integer;
begin
  id_auto_type_stay = -1;
  select RD.ID_BOARD, RD.ID_RATE, RD.ID_ROOM_TYPE
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :id_auto_board, :id_auto_tariff, :id_res_room_type;

  for
    select G.ID_GUEST, GS.FOR_DATE, GS.ID_ROOM_TYPE, GS.ID_BOARD, GS.ID_TYPE_STAY,
           GS.ID_TARIFF, coalesce(ror.ID_ROOM_TYPE, :id_res_room_type)
    from   GUEST G
           join GUEST_STAY GS on GS.ID_GUEST = G.ID_GUEST
           --left outer join ROOMS R on R.ID_ROOM = GS.ID_ROOM
           left outer join RES_OCCUPANCY_ROOM$INT (:ID_RESERV_DETAIL, gs.FOR_DATE, gs.ID_ROOM, :id_res_room_type) ror on 1=1
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    order by G.IS_CHILD, G.ID_GUEST, GS.FOR_DATE
    into   :id_guest, :for_date, :id_tar_room_type, :id_board, :id_type_stay,
           :id_tariff, :id_auto_room_type
  do begin
    if (:id_type_stay is null) then id_type_stay = -1;
    if (:id_tariff = :id_auto_tariff) then id_tariff = -1;
    if (:id_board is not distinct from :id_auto_board) then id_board = -1;     -- NULL or -1 ?!
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_CHECKIN$RSV for: RES_SAVE_ROOM$INT */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_ROOM_REMOVE$INT for: RES_SAVE_ROOM$INT */
ALTER PROCEDURE RES_ROOM_REMOVE$INT(RD_DBKEY CHAR(8))
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_COMMON_MODIFY$RSV for: RES_SAVE_ROOM$INT */
ALTER PROCEDURE RESMULTI_COMMON_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
CHECK_STATUS SMALLINT,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
NOTE VARCHAR(255),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(30),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
NOTE_REMINDERS VARCHAR(50),
SPLIT_ON_CHECKIN SMALLINT)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SAVE_ROOM$INT) */
ALTER PROCEDURE RES_SAVE_ROOM$INT(RD_DBKEY CHAR(8),
ID_ROOM INTEGER,
ID_RES_ROOM_TYPE INTEGER,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE INTEGER = null)
 AS
declare variable id_reserv_detail integer;
  declare variable id_tar_room_type integer;
  declare variable old_id_room_type integer;
  declare variable old_id_room integer;
  declare variable departure_date date;
  declare variable id_guest integer;
  declare variable g_dbkey char(8);
  declare variable system_date date;
  declare variable system_date_for_room date;
  declare variable check_status integer;
  declare variable cleaning_restriction varchar(50);
  declare variable guest_status varchar(50) default '';
  declare variable id_hotel integer;
  declare variable room_id_room_type integer;
  declare variable has_different_room_type integer;
begin
  select RD.ID_ROOM_TYPE, RD.CHECK_STATUS, RD.ID_ROOM, RD.TO_DATE, RD.ID_RESERV_DETAIL, RD.ID_HOTEL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_room_type, :check_status, :old_id_room, :departure_date, :id_reserv_detail, :id_hotel;

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date_for_room;

  /**/
  system_date = null;

  /*  */
  if (:check_status >= 0 and :old_id_room > 0 and coalesce(:id_room, 0) <= 0) then
    exception BOOKING_EXCEPTION '-111';

  if ((:old_id_room > 0) and (:id_room is distinct from :old_id_room)) then begin
    guest_status = 'ROOM_CHANGED';
    if ((:old_id_room > 0) and (:id_room > 0)) then begin
      execute procedure SYSTEM_DATE_GET(:id_hotel)
      returning_values  :system_date;
      execute procedure sys_dbg('res RES_SAVE_ROOM$INT old_id_room = '||coalesce(:old_id_room, 'null'));
      execute procedure sys_dbg('res RES_SAVE_ROOM$INT check_status = '||coalesce(:check_status, 'null'));

      if ((:departure_date <= :system_date) and (:check_status >= 0)) then exception BOOKING_EXCEPTION '-51';
    end
  end

  if (:id_room is null and :old_id_room < 0) then id_room = :old_id_room; -- preserve old fictious ID, because of mapped rooms

  if (coalesce(:id_room, 0) <= 0) then begin
    delete from ROOM_MAP$EXC m
    where  m.id_room = :id_room
           and m.ID_SRC_ROOM < 0;  -- delete wrong mappings (bug 2827)

    select ro.ID_ROOM, ro.ID_ROOM_TYPE
    from   RES_OCCUPANCY_ROOM$INT (:id_reserv_detail, :system_date_for_room, :id_room, :ID_RES_ROOM_TYPE) RO
    into   :id_room, :room_id_room_type;
  --end else if  then begin
  --  dummy = 0; -- do nothing
  end else begin
    -- real room is
    id_res_room_type = :old_id_room_type;
  end
  id_res_room_type = coalesce(:id_res_room_type, :old_id_room_type);
  -- null is permissible for id_res_room_type, treat of "keep the same"

  /* tar_option : nrttAsIs, nrttRoom, nrttReserv */
  id_tar_room_type = null;
  has_different_room_type = null;
  if (:tar_option = 'nrttAsIs') then begin
    id_tar_room_type = null;
    has_different_room_type = null;
  end else if (:tar_option = 'nrttRoom') then begin
    --id_tar_room_type = iif(coalesce(:id_room, 0) <= 0 and :room_id_room_type <> :ID_RES_ROOM_TYPE, :room_id_room_type, -1);
    id_tar_room_type = iif (:ID_ROOM > 0, -1, null); -- if not room - like a AsIs
    has_different_room_type = iif(:id_tar_room_type = -1, 0, null);
    -- preserve tar_room_type from mapped(unexisted) room
  end else begin /* nrttReserv */
    id_tar_room_type = :id_res_room_type;
    has_different_room_type = 1;
  end

  update RESERV_DETAIL RD
  set    RD.ID_ROOM = :id_room,
         rd.ROOM_PRICE = case
                           when rd.CHECK_STATUS >= 0 then null
                           -- 'checked in' bookings - force recalculation always
                           when rd.CHECK_STATUS < 0
                                and ((rd.ID_ROOM_TYPE <> :id_res_room_type) or (:id_room is distinct from :old_id_room)) then null
                           -- not 'checked in', but room/room type changed - force too
                           else rd.ROOM_PRICE
                         end,   -- <null> room_price will be force booking recalculation !!!
         RD.ID_ROOM_TYPE = :id_res_room_type,  -- this field update must be after room_price update
         rd.HAS_DIFFERENT_ROOM_TYPE = coalesce(:has_different_room_type, rd.HAS_DIFFERENT_ROOM_TYPE) --iif(coalesce(:id_tar_room_type, 0) > 0, 1, rd.HAS_DIFFERENT_ROOM_TYPE)
  where  RD.RDB$DB_KEY = :rd_dbkey;

  for
    select G.RDB$DB_KEY, G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :g_dbkey, :id_guest
  do begin
    update GUEST GU
    set    GU.OLD_ID_ROOM = GU.ID_ROOM,
           GU.ID_ROOM = :id_room
    where  GU.RDB$DB_KEY = :g_dbkey;

    execute procedure GUEST_SET_EDIT_STATUS$INT (:g_dbkey, :guest_status, 'add');
   
    /*Old code if (:system_date is null) update room_type and type stay*/
    update GUEST_STAY GS
    set    GS.ID_ROOM_TYPE = iif(:id_tar_room_type is null, GS.ID_ROOM_TYPE, :id_tar_room_type),
           GS.ID_TYPE_STAY = iif(:is_auto_staytype = 1, -1, GS.ID_TYPE_STAY)
    where  GS.ID_GUEST = :id_guest
           and ((:system_date is null) or (GS.FOR_DATE >= :system_date));

    /*New part - Room number never be updated in past - important for shares and calulations*/
    /* will be updated in pass only if there was no room assigned*/
    update GUEST_STAY GS
    set    GS.ID_ROOM = :id_room
    where  GS.ID_GUEST = :id_guest
           and ((GS.FOR_DATE >= :system_date_for_room)
                 or (:check_status < 0) -- new - always change id_room from begining, for non checked in reservs
               ) ;
  end

  if ((:check_status = 0) and (:guest_status = 'ROOM_CHANGED') and (:old_id_room > 0)) then begin
    /* IF THE CLEANING RESTRICTION IS ACTIVATED AND THE OLD
    || GUEST'S ROOM IS VACANT THEN IT MUST BE MARKED DIRTY.
    */
    execute procedure SETTING_GET_VALUE('CLEANING_RESTRICTION', :id_hotel)
    returning_values  :cleaning_restriction;
    if ((:cleaning_restriction <> '0') and (not exists (
      select *
      from   GUEST G
             join GUEST_STAY GS on GS.ID_GUEST = G.ID_GUEST
      where  GS.FOR_DATE >= :system_date
             and G.CHECK_STATUS = 0
             and GS.ID_ROOM = :old_id_room
             and G.ID_RESERV_DETAIL <> :id_reserv_detail
    ))) then begin
      execute procedure ROOM_HOUSEKEEPING(:old_id_room, 'GST_MOVED', 'set_dirty');
    end
  end

  execute procedure RES_SAVE_ROOM_LOG$INT(:RD_DBKEY, :old_id_room, :old_id_room_type);

end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ROOM$EXC for: RES_SAVE_ROOM$RSV */
ALTER PROCEDURE RES_SAVE_ROOM$EXC(RD_DBKEY CHAR(8),
ID_RES_ROOM_TYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(250),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_ROOM$RSV) */
ALTER PROCEDURE RES_SAVE_ROOM$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
ID_RES_ROOM_TYPE INTEGER,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(255),
SPLIT_ON_CHECKIN SMALLINT,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, :id_res_room_type, :TAR_OPTION, :is_auto_staytype);

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 1)
    returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;
  end

  update RESERV_DETAIL R
  set    r.SPLIT_ON_CHECKIN = :split_on_checkin,
         r.ID_HK_PLAN = :ID_HK_PLAN,
         r.I_SPECIAL_TREATMENT = :I_SPECIAL_TREATMENT,
         r.ROOM_FEATURES = :ROOM_FEATURES
  where  r.ID_RESERV_DETAIL = :id_reserv_detail;
end
^

/* empty dependent procedure body */
/* Clear: UPDATE_BOOKING$EXC for: RES_SAVE_STAY$RSV */
ALTER PROCEDURE UPDATE_BOOKING$EXC(BOOKING_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE INTEGER,
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA_ID INTEGER,
POSTING_ROUTING VARCHAR(20),
ID_AGENT_ACCOUNT INTEGER,
RATE_ID INTEGER,
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD_CODE /* TFOOD_CODE */ VARCHAR(20),
ARRANGER_PROFILE_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_STAY$RSV) */
ALTER PROCEDURE RES_SAVE_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure sys_dbg('res RES_SAVE_STAY$RSV comming_kind = '||coalesce(:comming_kind, 'null'));
  execute procedure sys_dbg('res RES_SAVE_STAY$RSV is_late_departure = '||coalesce(:is_late_departure, 'null'));

  execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :departure_date, :is_late_departure, :comming_kind);

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 1)
    returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;
    execute procedure sys_dbg('res RES_SAVE_STAY$RSV share_err_code = '||coalesce(:share_err_code, 'null'));
  end
  --
end
^

/* Alter (RES_SET_CHECKIN$INT) */
ALTER PROCEDURE RES_SET_CHECKIN$INT(RD_DBKEY CHAR(8))
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
begin
  select r.ID_RESERV_DETAIL
  from   RESERV_DETAIL R
  where  r.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail;

  execute procedure ROOM_MAGIC_CLEAR(:id_reserv_detail);   -- ?!?

  execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, 0);

  for
    select G.RDB$DB_KEY
    from   GUEST G
    where  g.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :g_dbkey
  do begin
    execute procedure GUEST_SET_STATUS$INT(:g_dbkey, 0);
  end

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;
end
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_CO_RENTERS$INT for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_CO_RENTERS$INT(VIRTUAL_ID_ROOM INTEGER,
NEW_ID_ROOM INTEGER,
INIT_ID_RES_DETAIL INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_FAST$RSV for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_FAST$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_MULTI$RSV for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_MULTI$RSV(OPERATION VARCHAR(20),
FROM_ROOM VARCHAR(20),
SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_SHARED$RSV for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_SHARED$RSV(SELECTION_ID INTEGER,
ROOM_NAME VARCHAR(10))
 RETURNS(VIRTUAL_ROOM VARCHAR(10),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SET_ROOM$INT) */
ALTER PROCEDURE RES_SET_ROOM$INT(RD_DBKEY CHAR(8),
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
begin

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option);

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :SHARE_ERR_TEXT, :share_transaction_id, :warn_code;
end
^

/* Alter (RES_SET_ROOM_CO_RENTERS$INT) */
ALTER PROCEDURE RES_SET_ROOM_CO_RENTERS$INT(VIRTUAL_ID_ROOM INTEGER,
NEW_ID_ROOM INTEGER,
INIT_ID_RES_DETAIL INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
declare variable shared_rd_dbkey char(8);
declare variable shared_booking_ids varchar(255);
declare variable id_reserv_detail integer;
declare variable tmp_share_err_code integer;
declare variable tmp_share_err_text varchar(255);
begin
  -- distribute the same room to shared bookings

  if (coalesce(:NEW_ID_ROOM, 0) < 0) then exit; -- only for real rooms!1
  SHARE_ERR_CODE = 0;
  shared_booking_ids = ',' || :INIT_ID_RES_DETAIL || ',';
  for
    select vrd.RDB$DB_KEY, vrd.ID_RESERV_DETAIL
    from   RESERV_DETAIL VRD
    where  vrd.ID_ROOM = :VIRTUAL_ID_ROOM
           and vrd.IS_ANUL = 0
           and vrd.ID_RESERV_DETAIL is distinct from :INIT_ID_RES_DETAIL
           -- and vrd.SELECTION_ID = :SELECTION_ID ?????
    into   :shared_rd_dbkey, :id_reserv_detail
  do begin
    shared_booking_ids = :shared_booking_ids || :id_reserv_detail || ',';

    execute procedure RES_SET_ROOM$INT (:shared_rd_dbkey, :NEW_ID_ROOM, :TAR_OPTION)
    returning_values  :WARN_CODE, :share_transaction_id, :tmp_share_err_code, :tmp_share_err_text;

    if (:SHARE_ERR_CODE = 0 and :tmp_share_err_code < 0) then begin
      -- check for share with other bookings
      if (exists (select rs.ID_RESERV_DETAIL
                      from   ROOMS_SHARE rs
                      where  rs.MARK_TRANSACTION = :SHARE_TRANSACTION_ID
                             and :shared_booking_ids not containing ','||rs.ID_RESERV_DETAIL||','
                             and rs.IS_EX_SHARE = 0)) then
      begin
        SHARE_ERR_CODE = :tmp_share_err_code;
        SHARE_ERR_TEXT = :tmp_share_err_text;
      end
    end
  end 
end
^

/* Alter (RES_SET_ROOM_FAST$RSV) */
ALTER PROCEDURE RES_SET_ROOM_FAST$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable old_id_room integer;
  declare variable virtual_room varchar(10);
  declare variable rd_dbkey char(8);
  declare variable tmp_warn_code integer;
  declare variable tmp_share_err_code integer;
  declare variable tmp_share_err_text varchar(255);
begin

  select RD.ID_ROOM, rd.VIRTUAL_ROOM, rd.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_id_room, :virtual_room, :rd_dbkey;

  execute procedure RES_SET_ROOM$INT (:rd_dbkey, :ID_ROOM, :TAR_OPTION)
  returning_values (:warn_code, :share_transaction_id, :share_err_code, :ERR_TEXT);

  if (:virtual_room is not null and :old_id_room < 0) then begin
    execute procedure RES_SET_ROOM_CO_RENTERS$INT (:old_id_room, :ID_ROOM, :ID_RESERV_DETAIL, :TAR_OPTION)
    returning_values (:tmp_warn_code, :share_transaction_id, :tmp_share_err_code, :tmp_share_err_text);
    WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
    SHARE_ERR_CODE = coalesce(:SHARE_ERR_CODE, :tmp_share_err_code);
    ERR_TEXT = coalesce(:ERR_TEXT, :tmp_share_err_text);
  end
end
^

/* Alter (RES_SET_ROOM_MULTI$RSV) */
ALTER PROCEDURE RES_SET_ROOM_MULTI$RSV(OPERATION VARCHAR(20),
FROM_ROOM VARCHAR(20),
SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable cnt_requested integer;
  declare variable cnt_old_room integer;
  declare variable cnt_found integer;
  declare variable is_already_planned integer;
  declare variable is_satisfied integer;
  declare variable new_id_room integer;
  declare variable current_id_room integer;
  declare variable id_res_room_type integer;
  declare variable room_requirements blob sub_type 1 segment size 100;
  declare variable from_date date;
  declare variable to_date date;
  declare variable action_text varchar(255);
  declare variable is_early_arrival smallint;
  declare variable is_late_departure smallint;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable id_reserv_detail integer;
  declare variable tmp_warn_code integer;
  declare variable min_beds integer;
  declare variable virtual_room varchar(10);
  declare variable share_err_text varchar(255);
begin
  /* offer_method :
  ||     0 - NUMBER desc,
  ||     1 - NUMBER asc,
  ||     2 - DAYS FREE(MAX OCCUPANCY),
  ||     3 - FILING FACTOR(EQUAL ROOM USAGE)
  */
  warn_code = null;

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'set_number_asc, set_number_desc, set_max_occupancy, set_max_usage');

  cnt_requested = 0;
  cnt_old_room = 0;
  cnt_found = 0;
  for
    select RD.RDB$DB_KEY, rd.ID_RESERV_DETAIL, rd.ID_ROOM, rd.VIRTUAL_ROOM, RD.ID_ROOM_TYPE, RD.ROOM_FEATURES,
           RD.FROM_DATE, RD.TO_DATE, iif(rd.COMMING_KIND = 0, 1, 0), iif(rd.LEAVING_KIND = 2, 1, 0),
           rd.ADULT_COUNT + rd.CHILD_COUNT
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
           and RD.IS_ANUL = 0
    into   :rd_dbkey, :id_reserv_detail, :current_id_room, :virtual_room, :id_res_room_type, :room_requirements,
           :from_date, :to_date, :is_early_arrival, :is_late_departure, :min_beds
  do begin
    cnt_requested = :cnt_requested + 1;
    new_id_room = null;
    if (:current_id_room < 0) then begin
      if (:virtual_room is not null) then begin
        -- has related bookings with shared virtual room
        -- get cumulative stay for all shared bookings
        select min(vrd.FROM_DATE), min(vrd.FROM_DATE) - min(vrd.FROM_DATE - iif(vrd.COMMING_KIND = 0, 1, 0)),
               max(vrd.TO_DATE), max(vrd.TO_DATE + iif(vrd.LEAVING_KIND = 2, 1, 0)) - max(vrd.TO_DATE),
               sum(vrd.ADULT_COUNT + vrd.CHILD_COUNT)
        from   RESERV_DETAIL VRD
        where  vrd.ID_ROOM = :current_id_room
               and vrd.IS_ANUL = 0
        into   :from_date, :is_early_arrival, :to_date, :is_late_departure, :min_beds;
      end
      -- from_date and to_date are arrival and departure date of reservation,
      -- not first and last accomodation dates !!! this is need to check early arrivals and late departures
      execute procedure ROOM_PICKUP$INT(:id_res_room_type, :from_date, :to_date,
              :is_early_arrival, :is_late_departure,:operation, :from_room, :room_requirements, :min_beds)
      returning_values  :new_id_room;  -- offered room

      if (:new_id_room is not null) then begin
        is_satisfied = 1;
        select R.ROOM_NAME
        from   ROOMS R
        where  r.ID_ROOM = :new_id_room
        into   :action_text;

        execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'ROOM_SET_AUTO', :action_text);

        execute procedure RES_SET_ROOM$INT (:rd_dbkey, :new_id_room, 'nrttAsIs')
        returning_values (:tmp_warn_code, :share_transaction_id, :share_err_code, :share_err_text);
        if (:share_err_code < 0) then exception BOOKING_EXCEPTION 'Unallowable share!!!';
        WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

        if (:virtual_room is not null) then begin
          -- distribute the same room to shared bookings
          execute procedure RES_SET_ROOM_CO_RENTERS$INT (:current_id_room, :new_id_room, :id_reserv_detail, 'nrttAsIs')
          returning_values (:tmp_warn_code, :share_transaction_id, :share_err_code, :share_err_text);
          if (:share_err_code < 0) then exception BOOKING_EXCEPTION 'Unallowable share!!!';
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
        end
      end

    end else begin
      is_already_planned = 1;
    end

    cnt_old_room = :cnt_old_room + :is_already_planned;
    cnt_found = :cnt_found + :is_satisfied;

    when exception BOOKING_EXCEPTION do begin
      -- nothing, skip this booking
    end
  end

  if ((:cnt_found + :cnt_old_room) < :cnt_requested) then begin
    execute procedure SYSTEM_WARNING_ADD(-3, f_character(29)||:cnt_found||f_character(28)||:cnt_requested)
    returning_values  :warn_code;
  end
end
^

/* Alter (RES_SET_ROOM_SHARED$RSV) */
ALTER PROCEDURE RES_SET_ROOM_SHARED$RSV(SELECTION_ID INTEGER,
ROOM_NAME VARCHAR(10))
 RETURNS(VIRTUAL_ROOM VARCHAR(10),
WARN_CODE INTEGER)
 AS
declare variable r_dbkey char(8);
  declare variable is_anul integer;
  declare variable shared_id_room integer;
  declare variable current_id_room integer;
  declare variable tmp_warn_code integer;
  declare variable share_trans integer;
  declare variable share_err_code integer;
  declare variable id_hotel integer;
  declare variable cnt_hotels integer;
  declare variable id_room integer;
  declare variable res_counter integer;
  declare variable min_departure date;
  declare variable max_arrival date;
  declare variable share_err_text varchar(255);
begin
  VIRTUAL_ROOM = null;
  select min(r.ID_HOTEL), count(distinct r.ID_HOTEL),
         min(r.TO_DATE), max(r.FROM_DATE)
  from   RESERV_DETAIL R
  where  R.SELECTION_ID = :SELECTION_ID
  into   :id_hotel, :cnt_hotels, :min_departure, :max_arrival;

  if (:cnt_hotels > 1) then exception BOOKING_EXCEPTION '-1035';
  if (:min_departure <= :max_arrival) then exception BOOKING_EXCEPTION '-1037';

  if (:ROOM_NAME is not null) then begin
    execute procedure ROOM_GET_BY_NAME(:ROOM_NAME, :id_hotel)
    returning_values (:id_room);
    shared_id_room = :ID_ROOM;
  end else begin
    id_room = null;
    shared_id_room = gen_id(DETAIL_WITHOUT_ROOMING_LIST, -1);
    VIRTUAL_ROOM = gen_id(GEN_VIRTUAL_ROOM, 1);
  end

  res_counter = 0;
  for
    select r.RDB$DB_KEY, r.IS_ANUL, r.ID_ROOM
    from   RESERV_DETAIL R
    where  R.SELECTION_ID = :SELECTION_ID
    into   :r_dbkey, :is_anul, :current_id_room
  do begin
    res_counter = :res_counter + 1;
    if (:is_anul = 1) then
      exception BOOKING_EXCEPTION '-1036';

    if (:current_id_room > 0 and :ID_ROOM is null) then
      exception BOOKING_EXCEPTION '-1034';

    execute procedure RES_SET_ROOM$INT(:r_dbkey, :shared_id_room, 'nrttAsIs')
    returning_values  :tmp_warn_code, :share_trans, :share_err_code, :share_err_text;
    WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
  end

  if (:VIRTUAL_ROOM is not null and :share_trans is not null) then begin
    update RESERV_DETAIL RD
    set    rd.VIRTUAL_ROOM = '<'||:VIRTUAL_ROOM||'>'
    where  rd.ID_ROOM = :shared_id_room;
  end
end
^

/* Alter (RES_SET_STAY$RSV) */
ALTER PROCEDURE RES_SET_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable is_late_departure integer;
  declare variable comming_kind integer;
begin
  select RD.COMMING_KIND, RD.LEAVING_KIND - 1, RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :comming_kind, :is_late_departure, :rd_dbkey;

  execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :departure_date, :is_late_departure, :comming_kind);

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 1)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

end
^

/* empty dependent procedure body */
/* Clear: RES_CHECKIN_MULTI$RSV for: RES_SPLIT$RSV */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT_MULTI$RSV for: RES_SPLIT$RSV */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SPLIT$RSV) */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
declare variable rd_dbkey_old char(8);
  declare variable rd_dbkey_new char(8);
  declare variable id_guest integer;
  declare variable warn_code integer;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;

  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable check_status integer;
  declare variable arrival_date date;
  declare variable departure_date date;
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable id_room_type integer;
  declare variable id_room integer;
  declare variable id_board integer;
  declare variable id_tariff integer;
  declare variable custom_price numeric(15,4);
  declare variable custom_currency char(3);
  declare variable voucher_num varchar(30);
  declare variable voucher_date date;
  declare variable voucher_text varchar(30);
  declare variable voucher2_num varchar(30);
  declare variable voucher2_date date;
  declare variable transfer_in_time time;
  declare variable transfer_in_note varchar(255);
  declare variable transfer_out_time time;
  declare variable transfer_out_note varchar(255);
  declare variable comming_kind integer;
  declare variable is_late_departure integer;
  declare variable is_vip integer;
  declare variable country_code varchar(20);
  declare variable code_first_food tfood_code;
  declare variable i_special_treatment varchar(255);
  declare variable id_nom_market_segment integer;
  declare variable id_nom_source_code integer;
  declare variable id_nom_channel_code integer;
  declare variable id_nom_hear_reason integer;
  declare variable id_nom_come_reason integer;
  declare variable id_agent_account integer;
  declare variable acc_routing varchar(50);
  declare variable id_person_payment integer;
  declare variable id_agent_payment integer;
  declare variable room_features blob sub_type 1 segment size 80;
  declare variable id_hk_plan integer;
  declare variable id_group integer;
  declare variable id_hotel integer;
  declare variable note varchar(2000);
  declare variable note_reminders varchar(50);
  declare variable guarantee_deposit numeric(15,4);
  declare variable guarantee_currency char(3);
  declare variable id_titular integer;
  declare variable id_profile_data integer;
  declare variable id_acc_template_person integer;
  declare variable number_1 varchar(20);
  declare variable number_2 varchar(20);
  declare variable new_res_number varchar(62);
  declare variable g_dbkey char(8);
  declare variable is_child integer;
  declare variable id_guarantee_policy integer;
  declare variable block_cc varchar(255);
  declare variable virtual_room varchar(10);
  declare variable err_text varchar(255);
  declare variable is_posting_stopped integer;
  declare variable id_eating_object integer;
begin
  select RD.RDB$DB_KEY, RD.ID_AGENT_PROFILE, RD.CHECK_STATUS, RD.FROM_DATE, RD.TO_DATE,
         RD.ADULT_COUNT, RD.CHILD_COUNT, RD.ID_ROOM_TYPE, RD.ID_ROOM, RD.ID_BOARD, RD.ID_RATE,
         RD.CUSTOM_PRICE, RD.CUSTOM_CURRENCY, RD.VAUCHER_NUM, RD.VAUCHER_DATE, RD.VAUCHER_TEXT, RD.VAUCHER_NUM2,
         RD.VAUCHER_DATE2, RD.TRANSFER_IN_TIME, RD.TRANSFER_IN_NOTE, RD.TRANSFER_OUT_TIME, RD.TRANSFER_OUT_NOTE,
         RD.COMMING_KIND, RD.LEAVING_KIND - 1, RD.IS_VIP, RD.COUNTRY, RD.CODE_FIRST_FOOD, RD.I_SPECIAL_TREATMENT,
         RD.ID_NOM_MARKET_SEGMENT, RD.ID_NOM_SOURCE_CODE, RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_HEAR_REASON,
         RD.ID_NOM_COME_REASON, RD.ID_AGENT_ACCOUNT_RULE, RD.ACC_ROUTING, RD.ID_PERSON_PAYMENT, RD.ID_AGENT_PAYMENT,
         RD.ROOM_FEATURES, RD.ID_HK_PLAN, RD.ID_GROUP, RD.ID_HOTEL, RD.NOTE, RD.NOTE_REMINDERS,
         RD.GUARANTEE_DEPOSIT, RD.GUARANTEE_CURRENCY, RD.ID_ACC_TEMPLATE_PERSON,
         RD.NUMBER_1, rd.NUMBER_2, rd.ID_GUARANTEE_POLICY, rd.BLOCK_CC, rd.IS_POSTING_STOPPED, rd.ID_EATING_OBJECT
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail_source
  into   :rd_dbkey_old, :id_agent_profile, :check_status, :arrival_date, :departure_date,
         :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff,
         :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
         :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
         :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
         :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
         :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
         :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
         :guarantee_deposit, :guarantee_currency, :id_acc_template_person,
         :number_1, :number_2,:id_guarantee_policy, :block_cc, :is_posting_stopped, :id_eating_object;

  select first 1 sp.ITEM
  from   SYSTEM_STRING_PARSER(:guest_ids, ',') sp
  into   :id_titular;

  select min(g.FROM_DATE), max(g.TO_DATE)
  from   GUEST G
  where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL_SOURCE
         and ','||:GUEST_IDS||',' containing ','||g.ID_GUEST||','
  into   :arrival_date, :departure_date;

  if (exists (select *
              from   RESERV_DETAIL RD
              where  RD.ID_TITULAR = :id_titular
                     and RD.ID_RESERV_DETAIL = :id_reserv_detail_source))
  then exception BOOKING_EXCEPTION 'Titular can not be splited in new reservation';

  execute procedure RES_GET_PERSON_PROFILE$INT(:id_titular)
  returning_values  :id_person_profile, :id_profile_data;

  new_res_number = iif(coalesce(:number_1,'')='','.',:number_1||'.')
                   || coalesce(:number_2, '')
                   || '.0';  -- fictive suffix, needed for unique constraint limitation, that will be replaced with real one


  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, :check_status, :arrival_date, :departure_date,
                    0, 0, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
                    :guarantee_deposit, :guarantee_currency, 0, null, :new_res_number, :id_acc_template_person,
                    :id_guarantee_policy, :block_cc, :id_eating_object)
  returning_values  :rd_dbkey_new, :new_id_reserv_detail;

  execute procedure RES_NUMBER_SUFFIX_GEN (:NEW_ID_RESERV_DETAIL)
  returning_values  (:new_res_number);  -- add suffix to new (splited) booking number (empty on create)

  update RESERV_DETAIL NR
  set    nr.IS_POSTING_STOPPED = :is_posting_stopped
  where  nr.RDB$DB_KEY = :rd_dbkey_new;

  -- there is no need guests deleting, because new splited reservation is created with 0 guests
  adult_count = 0; child_count = 0;
  for
    select G.ID_GUEST, G.RDB$DB_KEY, G.IS_CHILD
    from   SYSTEM_STRING_PARSER(:guest_ids, ',') SP
           join GUEST G on G.ID_GUEST = SP.ITEM
    into   :id_guest, :g_dbkey, :is_child
  do begin
    execute procedure GUEST_SET_EDIT_STATUS$INT (:g_dbkey, 'REBUILD', 'add');

    update GUEST G
    set    G.ID_RESERV_DETAIL = :new_id_reserv_detail
    where  G.ID_GUEST = :id_guest;

    adult_count = :adult_count + (1-:is_child);
    child_count = :child_count + :is_child;

    if (:id_guest = :id_titular) then begin
      update RESERV_DETAIL RD
      set    RD.ID_TITULAR = :id_titular
      where  RD.RDB$DB_KEY = :rd_dbkey_new;

      update GUEST_DATA GD
      set    GD.ID_PERSON_DATA = :id_profile_data
      where  GD.ID_GUEST = :id_titular;
    end
  end

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL_SOURCE, 'RES_SPLIT',
          f_character(29) || :new_res_number || f_character(28) || :adult_count || ' + ' || :child_count);

  -- calling RES_SAVE_PROFILING$INT is unnecessary, it is called into RES_CREATE_SET$INT with same params
  -- here is needed to set reserv accounts per splited guests and reroute posting only (accomplished in next procedure)
  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey_new);

  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_old);
  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_new);

  update RESERV_DETAIL ORD
  set    ord.ROOM_PRICE = null
  where  ord.RDB$DB_KEY = :rd_dbkey_old;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_old, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_new, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  if (:id_room < 0) then begin
    virtual_room = gen_id(GEN_VIRTUAL_ROOM, 1);
    update RESERV_DETAIL RD
    set    rd.VIRTUAL_ROOM = '<'||:virtual_room||'>'
    where  rd.ID_ROOM = :id_room;
  end
end
^

/* Alter (RES_SPLIT_MULTI$RSV) */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
begin
  for
    select RD.ID_RESERV_DETAIL, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :id_reserv_detail, :id_titular
  do begin
    for
      select G.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.ID_GUEST <> :id_titular
      into   :id_guest
    do begin
      execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
      returning_values  :id_splited_reservation;

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_TAR_CALC_FINALIZE$INT for: RES_TAR_CALC_REPOST$INT */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(TAR_CALC_ERR INTEGER,
ID_TAR_CALC INTEGER,
RD_DBKEY_INIT CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_TAR_CALC_REPOST$INT) */
ALTER PROCEDURE RES_TAR_CALC_REPOST$INT(ID_TAR_CALC TYPE OF ID_REF,
ID_RESERV_DETAIL TYPE OF ID_REF,
RECALC_MARKER VARCHAR(40))
 AS
declare variable id_guest type of id_ref;
  declare variable id_service type of id_ref;
  declare variable id_tariff type of id_ref;
  declare variable date_post type of tdate;
  declare variable qty_post type of tqty;
  declare variable price_orig type of tprice;
  declare variable curr_orig type of tcurrency;
  declare variable id_room type of id_ref;
  declare variable is_base type of tlogical;
  declare variable short_code type of tdescription_long;
  declare variable id_account type of id_ref;
  declare variable gfrom_date type of tdate;
  declare variable gto_date type of tdate;
  declare variable ap_db_key char(8);
  declare variable id_pack_service type of id_ref;
  declare variable err_code type of id_ref;
  declare variable err_text type of tdescription_long;
  declare variable id_master_account_post type of id_ref;
  declare variable id_acc_post type of id_ref;
  declare variable rate_orig type of tprice;
  declare variable is_base_account type of id_ref;
  declare variable id_extra_account type of id_ref;
  declare variable no_use varchar(255);
begin
  for
    select   TCP.ID_GUEST, TCP.ID_SERVICE, TCP.ID_TARIFF, TCP.DATE_POST, TCP.QTY_POST,
             round_f(TCP.PRICE_ORIG, c.ROUND_TO), TCP.CURR_ORIG, TCP.ID_ROOM, TCP.IS_BASE,
             TCP.SHORT_CODE, iif(coalesce(AGP.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'NONE', 0, 1),
             G.ID_BASE_ACCOUNT, G.FROM_DATE, G.TO_DATE, G.ID_ACCOUNT
    from     TAR_CALC_POST$TMP TCP
             join GUEST G on G.ID_GUEST = TCP.ID_GUEST
             join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
             join SERVICES S on S.ID_SERVICE = TCP.ID_SERVICE
             join CURRS c on c.CURR = tcp.CURR_ORIG
             left outer join AGENT_PACKET AGP on AGP.ID_SERVICE = S.ID_SERVICE and AGP.ID_AGENT = G.ID_AGENT
    where    TCP.ID_TAR_CALC = :id_tar_calc
             and ((rd.ID_RESERV_DETAIL = :ID_RESERV_DETAIL)
                  or (coalesce(RD.IS_POSTING_STOPPED, 0) = 0 and RD.POSTING_TRANSACTION_UUID is not null))
    order by TCP.ID_GUEST asc, TCP.DATE_POST asc, TCP.IS_BASE desc
    into     :id_guest, :id_service, :id_tariff, :date_post, :qty_post,
             :price_orig, :curr_orig, :id_room, :is_base, :short_code, :is_base_account,
             :id_account, :gfrom_date, :gto_date, :id_extra_account
  do begin
    ap_db_key = null;
    if (:is_base = 1) then begin
      select AP.RDB$DB_KEY, AP.ID_MASTER_ADDINS_ACC_POST, AP.RATE_ORIG, AP.ID_PACK_SERVICE
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.DATE_POST = :date_post
             and AP.IS_BASE = 1
      into   :ap_db_key, :id_master_account_post, :rate_orig, :id_pack_service;

      execute procedure sys_dbg('tar TAR_CALC_REPOST$INT price_orig = '||coalesce(:price_orig, 'null'));
      execute procedure sys_dbg('tar TAR_CALC_REPOST$INT ap_db_key = '||coalesce(:ap_db_key, 'null'));

      if (:ap_db_key is null) then begin
        id_master_account_post = -1;
        rate_orig = null;
        execute procedure GUEST_POST_GET_PACK_SERVICE(:id_service, :id_guest, :date_post)
        returning_values  :id_pack_service;
      end
    end else begin
      short_code = '';
      select first 1 APU.rdb$db_key
      from   ACCOUNT_POST APU
      where  APU.ID_MASTER_ADDINS_ACC_POST = :id_master_account_post
             and APU.ID_SERVICE = :id_service
      order by apu.IS_ANUL asc, apu.ID_ACCOUNT_POST asc
      into   :ap_db_key;

      if ((:ap_db_key is null) and (:is_base_account <> 1)) then id_account = :id_extra_account;
    end

    if (:ap_db_key is null) then begin
      execute procedure ACCOUNT_POSTING_ADD$INT(
        :id_account, :id_guest, -1, :date_post, :id_service, :id_tariff, :id_room, :is_base, :qty_post,
        :price_orig, :curr_orig, :rate_orig, :short_code, :gfrom_date, :gto_date, 'PACK='||:id_pack_service, '',
        :recalc_marker, :id_master_account_post)
      returning_values  :err_code, :err_text, :id_acc_post;
      if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

      if (:is_base = 1) then id_master_account_post = :id_acc_post;

    end else begin
      execute procedure ACCOUNT_POSTING_UPDATE$INT(
        :ap_db_key, :id_account, :id_service, :id_tariff, :id_room, :qty_post, 0, :price_orig, :curr_orig, :rate_orig,
        :recalc_marker, :short_code, :gfrom_date, :gto_date, 1)
      returning_values  :no_use, :no_use, :no_use;
    end

  end

  ap_db_key = null;
  id_guest = null;
  for
    select distinct TCP.ID_GUEST
    from   TAR_CALC_POST$TMP TCP
    where  tcp.ID_TAR_CALC = :ID_TAR_CALC
    into   :id_guest
  do begin
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.CHANGED_TEXT is distinct from :recalc_marker
             and AP.ID_MASTER_ADDINS_ACC_POST > 0
             and AP.IS_ANUL = 0
      into   :ap_db_key
    do begin
      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_db_key, :recalc_marker);
    end
  end

  delete from RESERV_PREPOST RP where RP.ID_RESERV_DETAIL = :id_reserv_detail;
  execute procedure RES_TAKE_POSTING_RESPONSIBILITY (:ID_RESERV_DETAIL);
end
^

/* Alter (RESGRP_GET_INFO$RSV) */
ALTER PROCEDURE RESGRP_GET_INFO$RSV(ID_INFO_GROUP INTEGER)
 RETURNS(AGENT_PROFILE_NAME VARCHAR(100),
ARRIVALS VARCHAR(255),
DEPARTURES VARCHAR(255),
ROOM_DATA VARCHAR(255),
ROOMS VARCHAR(255),
ID_ROOM INTEGER,
GUESTS VARCHAR(255),
PERSON_PROFILE_NAME VARCHAR(100),
RATES VARCHAR(255),
BOARDS VARCHAR(255),
PACKETS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY VARCHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
BALANCE VARCHAR(255),
OPEN_CHARGES INTEGER,
CHECK_STATUS VARCHAR(255),
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
NOTE VARCHAR(2000),
NOTE_GRP VARCHAR(255),
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
FIRST_ARRIVAL DATE,
FIRST_DEPARTURE DATE,
HOTELS VARCHAR(255),
ID_HOTEL INTEGER,
ACC_ROUTING VARCHAR(255),
RES_NUMBER VARCHAR(62))
 AS
declare variable arrival date;
  declare variable departure date;
  declare variable room varchar(10);
  declare variable type_room varchar(20);
  declare variable stay_length varchar(60);
  declare variable id_reserv_detail integer;
  declare variable no_use varchar(255);
  declare variable rd_adult_count integer;
  declare variable rd_child_count integer;
  declare variable is_group integer;
  declare variable current_arrival varchar(60);
  declare variable current_departure varchar(60);
  declare variable nights varchar(255);
  declare variable roomcount integer;
  declare variable adultcount integer;
  declare variable childrencount integer;
  declare variable groupname varchar(100);
  declare variable rd_check_status integer;
  declare variable is_anul_detail integer;
  declare variable reason_of_anul varchar(100);
  declare variable hotel_code varchar(10);
  declare variable current_acc_routing varchar(255);
begin
  arrivals = '';
  departures = '';
  rooms = '';
  nights = '';
  rates = '';
  hotels = '';
  roomcount = 0;
  adultcount = 0;
  childrencount = 0;
  check_status = '';
  acc_routing = '';
  arrival = null;
  first_arrival = null;
  first_departure = null;

  ATTENTION_STATUS = null;  -- OUT of use ?!
  NOTE_GRP = null;

  for
    select RD.FROM_DATE, RD.ADULT_COUNT, RD.CHILD_COUNT, R.ROOM_NAME, RT.TYPE_ROOM,
           cast(RD.TO_DATE - RD.FROM_DATE as integer), RD.CHECK_STATUS, PP.PROFILE_NAME,
           RD.ROOM_PRICE, RD.ROOM_CURRENCY, RD.ROOM_PRICE_DETAILS, RD.ID_RESERV_DETAIL,
           RD.TO_DATE, R.ID_ROOM, RD.IS_ANUL, RD.REASON_OF_ANUL, RD.NOTE, H.CODE,
           RD.NUMBER, RD.ACC_ROUTING,
           AP.PROFILE_NAME, RG.GROUP_NAME, RD.ID_HOTEL, iif(RD.ID_GROUP is not null, 1, 0)
    from   RESERV_GROUP RG
           join HOTEL H on H.ID_HOTEL = RG.ID_HOTEL
           left outer join RESERV_DETAIL RD on RG.ID_RESERV_GROUP = RD.ID_GROUP and RD.IS_ANUL = 0
           left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
           left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = coalesce(R.ID_ROOM_TYPE, RD.ID_ROOM_TYPE)
           left outer join PROFILE PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
           left outer join PROFILE AP on AP.ID_PROFILE = RD.ID_AGENT_PROFILE
    where  RG.ID_RESERV_GROUP = :id_info_group
    order by RD.FROM_DATE asc
    into   :arrival, :rd_adult_count, :rd_child_count, :room, :type_room,
           :stay_length, :rd_check_status, :person_profile_name,
           :room_price, :room_currency, :room_price_details, :id_reserv_detail,
           :departure, :id_room, :is_anul_detail, :reason_of_anul, :note, :hotel_code,
           :res_number, :current_acc_routing,
           :agent_profile_name, :groupname, :id_hotel, :is_group
  do begin
    if (:first_arrival is null) then first_arrival = :arrival;
    if (:first_departure is null) then first_departure = :departure;

    if (:arrival is not null) then begin
      if (extract(year from current_date) = extract(year from :arrival)) then
        current_arrival = formatDate(:arrival, 'D;dd.mm');
      else
        current_arrival = formatDate(:arrival, 'D;dd.mm.yy');
  
      if (:arrivals not containing :current_arrival) then begin
        nights = :stay_length;
        if (:arrivals = '') then arrivals = :current_arrival||' ('||:stay_length;
        else if (char_length(:arrivals) < 100) then arrivals = :arrivals||')  '||:current_arrival||' ('||:stay_length;
      end else begin
        if (:nights not containing :stay_length) then begin
          nights = :nights ||','||:stay_length;
          arrivals = :arrivals||','||:stay_length;
        end
      end
    end

    if (:departure is not null) then begin
      if (extract(year from current_date) = extract(year from :departure)) then
        current_departure = formatDate(:departure, 'D;dd.mm');
      else
        current_departure = formatDate(:departure, 'D;dd.mm.yy');
  
      if (:departures not containing :current_departure) then begin
        if (:departures = '') then departures = :current_departure;
        else if (char_length(:departures) < 100) then departures = :departures||'  '||:current_departure;
      end
    end

    if (:acc_routing not containing :current_acc_routing) then begin
      if (:acc_routing = '') then acc_routing = :current_acc_routing;
      else if (char_length(:acc_routing) < 100) then acc_routing = :acc_routing||'  '||:current_acc_routing;
    end

    if (:check_status not containing :rd_check_status) then begin
      if (:check_status = '') then check_status = :rd_check_status;
      else check_status = :check_status||', '||:rd_check_status;
    end

    if (:hotels not containing :hotel_code) then begin
      if (:hotels = '') then hotels = :hotel_code;
      else hotels = :hotels||','||:hotel_code;
    end

    if (:is_group is distinct from 1) then begin
      if (:room is null) then room_data = :type_room;
      else room_data = :room || ' / ' || :type_room;
    end

    if (:is_group = 1) then begin
      in_share = null;
      balance = '-';
      res_number = '';
    end else begin
      execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'RENDER', null)
      returning_values  :in_share, :no_use, :shares_preview;

      execute procedure RES_GET_BALLANCE$INT(:id_reserv_detail)
      returning_values  :balance, :no_use, :no_use, :open_charges, :no_use;
    end
    adultcount = :adultcount + :rd_adult_count;
    childrencount = :childrencount + :rd_child_count;
  end
  if (coalesce(:groupname, '') <> '') then agent_profile_name = coalesce(:agent_profile_name, ' ') || ' / ' || :groupname;
  if (:is_group = 1) then person_profile_name = '';
  if (:arrivals <> '') then arrivals = :arrivals||')';
  guests = :adultcount || ' + ' || :childrencount || ' ';

  if (:arrivals <> '') then begin
    if (:is_group = 1) then begin
      note = '';
      room_data = '';
      for
        select RT.TYPE_ROOM, count(*)
        from   RESERV_DETAIL RD
               left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
               join ROOM_TYPES RT on RT.ID_ROOM_TYPE = coalesce(R.ID_ROOM_TYPE, RD.ID_ROOM_TYPE)
        where  RD.ID_GROUP = :id_info_group
               and RD.IS_ANUL = 0
        group by 1
        into   :type_room, :roomcount
      do begin
        if (:room_data = '') then room_data = :roomcount ||'x '||:type_room;
        else room_data = room_data ||', '|| :roomcount ||'x '||:type_room;
      end
    end
/*
    execute procedure RES_GET_ATTENTION_STATUS$INT(:arrival, :departure, :rd_check_status)
    returning_values  :attention_status;
*/
    execute procedure RES_GET_GUEST_DATA$INT('GROUP', :id_info_group)
    returning_values  :boards, :rates, :packets, :no_use;
  
    annul_status = :is_anul_detail;
    if (:reason_of_anul = 'EXPIRE') then annul_status = 2;
  end

  if (char_length(:arrivals) >= 100) then arrivals = :arrivals||'...';
  if (char_length(:departures) >= 100) then departures = :departures||'...';
  suspend;
end
^

/* Alter (RESMULTI_COMMON_MODIFY$RSV) */
ALTER PROCEDURE RESMULTI_COMMON_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
CHECK_STATUS SMALLINT,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
NOTE VARCHAR(255),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(30),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
NOTE_REMINDERS VARCHAR(50),
SPLIT_ON_CHECKIN SMALLINT)
 AS
declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable old_id_room_type integer;
  declare variable old_status integer;
begin
  select RD.RDB$DB_KEY, RD.ID_ROOM, RD.ID_ROOM_TYPE, rd.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_id_room, :old_id_room_type, :old_status;

  execute procedure RES_SAVE_GUESTCOUNT$INT(:rd_dbkey, :adult_count, :children_count);

  execute procedure RES_SAVE_NOTE$RSV(:id_reserv_detail, :note, null);

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, :id_room_type, 'nrttAsIs');

  execute procedure RES_SAVE_ROOM_LOG$INT(:rd_dbkey, :old_id_room, :old_id_room_type);

  execute procedure RES_SAVE_ACCOUNTING$INT(:rd_dbkey, :id_agent_profile, :id_agent_account, :acc_routing,
                    :id_person_payment, :id_agent_payment, :id_group);

  update RESERV_DETAIL RD
  set    RD.CUSTOM_PRICE = :CUSTOM_PRICE,
         RD.CUSTOM_CURRENCY = :CUSTOM_CURRENCY,
         RD.SPLIT_ON_CHECKIN = :SPLIT_ON_CHECKIN,
         RD.NOTE_REMINDERS = :NOTE_REMINDERS,
         rd.ID_HK_PLAN = :ID_HK_PLAN
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_status <> :CHECK_STATUS) then begin
    if (:CHECK_STATUS >= 0) then exception BOOKING_EXCEPTION 'Can not set status ''CHECKED IN'' or ''CHECKED OUT'' manually!';
  
    execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, :check_status);
  end
  --
end
^

/* Alter (RESMULTI_CREATE$RSV) */
ALTER PROCEDURE RESMULTI_CREATE$RSV(ID_HOTEL INTEGER,
ID_ROOM_TYPE INTEGER,
TRANSFER_OUT_TIME TIME,
TRANSFER_IN_TIME TIME,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
TRANSFER_OUT_NOTE VARCHAR(50),
TRANSFER_IN_NOTE VARCHAR(50),
NOTE VARCHAR(255),
ID_BOARD INTEGER,
VOUCHER_DATE DATE,
VOUCHER_NUMBER VARCHAR(20),
VOUCHER_TEXT VARCHAR(30),
CHECK_STATUS INTEGER,
ID_TARIFF INTEGER,
COUNTRY_CODE VARCHAR(20),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
NOTE_REMINDERS VARCHAR(50),
TITULAR_NAME VARCHAR(100),
SPLIT_ON_CHECKIN INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
NUMBER VARCHAR(62),
NEW_ID_TITULAR INTEGER,
NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable rd_dbkey char(8);
  declare variable id_person_profile integer;
  declare variable pd_dbkey char(8);
  declare variable id_acc_template_person integer;
  declare variable first_name varchar(30);
  declare variable surname varchar(30);
  declare variable family_name varchar(30);
begin

  select sv.SETTING_VALUE
  from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :ID_HOTEL) sv
  into   :id_acc_template_person;

  execute procedure RES_CREATE_SET$INT(:id_agent_profile, null, :check_status, :arrival_date, :departure_date,
                    :adult_count, :children_count, :id_room_type, null, :id_board, :id_tariff, null,
                    null, null, :voucher_number, :voucher_date, :voucher_text, '',
                    null, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    1, 0, 0, :country_code, :code_first_food, '',
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    '', :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders, null, null,
                    :split_on_checkin, null, null, :id_acc_template_person, null, null, :ID_EATING_OBJECT)
  returning_values  :rd_dbkey, :new_id_reserv_detail;

  select RD.NUMBER, RD.ID_PERSON_PROFILE, RD.ID_TITULAR
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :number, :id_person_profile, :new_id_titular;

  if (:titular_name <> '') then begin
    select PD.RDB$DB_KEY
    from   PROFILE P
           join PROFILE_PERSON PP on PP.ID_PROFILE = P.ID_PROFILE
           join PERSON_DATA PD on PD.ID_PERSON_DATA = PP.ID_PERSON_DATA
    where  P.ID_PROFILE = :id_person_profile
    into   :pd_dbkey;

    select PP.FIRST_NAME, PP.SURNAME, PP.FAMILY_NAME
    from   PERSON_NAME_PARSE$INT (:TITULAR_NAME) PP
    into   :first_name, :surname, :family_name;

    update PERSON_DATA PD
    set    PD.PERSON_NAME2 = :titular_name,
           PD.FIRST_NAME = :first_name,
           PD.SURNAME = :surname,
           PD.FAMILY_NAME = :family_name
    where  PD.RDB$DB_KEY = :pd_dbkey;
  end

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;
end
^

/* Alter (RESMULTI_FINALIZE$RSV) */
ALTER PROCEDURE RESMULTI_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER,
DISABLE_WARNING SMALLINT)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  /*savedbg('------------ RES DET: ' || :ID_RESERV_DETAIL);
  savedbg('err_code: ' || :ERR_CODE);
  savedbg('share_err_code: ' || :SHARE_ERR_CODE);
  savedbg('warn_code: ' || :WARN_CODE);*/
  if (:disable_warning = 1) then warn_code = 0;
end
^

/* Alter (RESOURCE_RESERVATION_CHECK_IN) */
ALTER PROCEDURE RESOURCE_RESERVATION_CHECK_IN(ID_RESOURCE_RESERVATION INTEGER,
SERVICE_PRICE NUMERIC(15,2),
SERVICE_CURR VARCHAR(3))
 RETURNS(OUT_ID_ACCOUNT INTEGER,
OUT_ID_ACCOUNT_POST INTEGER)
 AS
declare variable old_status varchar(20);
  declare variable new_status varchar(20);
  declare variable dbkey char(8);
  declare variable id_service id_ref;
  declare variable price_post tprice;
  declare variable curr_post TCURRENCY;
  declare variable is_manual_price TLOGICAL;
  declare variable is_details tlogical;
  declare variable post_description tobject_text;
  declare variable id_reserv_detail integer;
  declare variable post_date tdate;
  declare variable from_datetime tdatetime;
  declare variable to_datetime tdatetime;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  new_status = 'CHECKED_IN';

  select r.RDB$DB_KEY, R.STATUS, rd.ID_RESERV_DETAIL
  from   RESOURCE_RESERVATION R
         left outer join RESERV_DETAIL rd on rd.NUMBER = r.BOOKING_NUMBER
                                             and rd.IS_ANUL = 0
                                             and rd.SUBSCRIBER_ID is not distinct from r.SUBSCRIBER_ID
  where  R.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION
  into   :dbkey, :old_status, :id_reserv_detail;

  if (:old_status = :NEW_STATUS) then exit;
 
  if (:old_status is distinct from 'RESERVED') then exception ASSERT '-511';

  if (exists (select RP.ID_RESOURCE_RESERVATION
              from   RESOURCE_RESERV_POST RP
                     join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = RP.ID_ACCOUNNT_POST
              where  RP.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION)) then
  begin
    exception ASSERT '-505';
  end

  if (:id_reserv_detail is not null) then begin
    execute procedure RESOURCE_RESERV_SERVICE_GET (:ID_RESOURCE_RESERVATION)
    returning_values (:id_service, :price_post, :curr_post, :is_manual_price, :is_details, :post_description,
                     :post_date, :from_datetime, :to_datetime);
  
    if (:is_manual_price = 1) then begin
      price_post = :SERVICE_PRICE;
      curr_post = :SERVICE_CURR;
    end

    if (:price_post is null) then exception ASSERT 'Unspecified service price!';
    if (:curr_post is null) then exception ASSERT 'Unspecified price currency!';
  
    execute procedure POST_SERVICE_ON_RESERVATION$INT (:id_reserv_detail, :id_service, 1, 0,
            1, :price_post, :curr_post, :from_datetime, :to_datetime,
            '', '', :post_date, 'RESOURCE', :post_description)
    returning_values (:ERR_CODE, :ERR_TEXT, :OUT_ID_ACCOUNT, :OUT_ID_ACCOUNT_POST);
    if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
  
    insert into RESOURCE_RESERV_POST(ID_RESOURCE_RESERVATION, ID_ACCOUNNT_POST)
    values (:ID_RESOURCE_RESERVATION, :OUT_ID_ACCOUNT_POST);
  end

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = :NEW_STATUS
  where  RR.RDB$DB_KEY = :dbkey;

end
^

/* Alter (RIGHTS_GROUP_MODIFY) */
ALTER PROCEDURE RIGHTS_GROUP_MODIFY(ID_RIGHT_GROUP INTEGER,
GROUP_NAME VARCHAR(20),
GROUP_DESCRIPTION VARCHAR(100),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_RIGHT_GROUP INTEGER)
 AS
declare variable old_name varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation = 'add') then begin
    if ((:id_right_group is null) or (:id_right_group <= -1))  then
      new_id_right_group = gen_id(ID_RIGHT_GROUP_GEN, 1);
    else new_id_right_group = :id_right_group;

    insert into RIGHTS_GROUPS (ID_RIGHT_GROUP, GROUP_NAME, GROUP_DESCRIPTION)
    values (:new_id_right_group, :group_name , :group_description);
  end else if (:operation = 'mod') then begin
    select G.GROUP_NAME
    from   RIGHTS_GROUPS G
    where  G.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
    into   :old_name;

    update RIGHTS_GROUPS UG
    set    UG.GROUP_NAME  = :group_name,
           UG.GROUP_DESCRIPTION = :group_description
    where  UG.ID_RIGHT_GROUP = :id_right_group;

    if (:old_name <> :GROUP_NAME) then begin
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'GROUP_EDIT',
              f_character(29) || :old_name || f_character(28) || :GROUP_NAME);
    end
  end else if (:operation = 'del') then begin
    delete from RIGHTS_GROUPS
    where ID_RIGHT_GROUP = :id_right_group;
    delete from RIGHTS_USER_GROUPS
    where ID_RIGHT_GROUP = :id_right_group;
  end
end
^

/* Alter (RIGHTS_GROUP_REPORTS_MODIFY) */
ALTER PROCEDURE RIGHTS_GROUP_REPORTS_MODIFY(ID_RIGHT_GROUP INTEGER,
REPORT_NAME VARCHAR(200),
OPERATION VARCHAR(20))
 AS
declare variable right_group varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'grant, revoke');

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS rg
  where  rg.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'grant') then begin
    if (not exists (
      select *
      from   RIGHTS_GROUPS_REPORTS RGR
      where  RGR.ID_RIGHT_GROUP = :id_right_group
             and RGR.REPORT_NAME = :report_name)
    ) then begin
      insert into RIGHTS_GROUPS_REPORTS (ID_RIGHT_GROUP, REPORT_NAME)
      values (:id_right_group, :report_name);

      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'RIGHT_GRANT',
              f_character(29) || :REPORT_NAME || f_character(28) || :right_group);

    end
  end else if (:operation = 'revoke') then begin
    delete from RIGHTS_GROUPS_REPORTS RGR
    where  RGR.ID_RIGHT_GROUP = :id_right_group
           and  RGR.REPORT_NAME = :report_name;

    if (row_count = 1) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'RIGHT_REVOKE',
              f_character(29) || :REPORT_NAME || f_character(28) || :right_group);
  end
end
^

/* Alter (RIGHTS_GROUP_RIGHTS_MODIFY) */
ALTER PROCEDURE RIGHTS_GROUP_RIGHTS_MODIFY(ID_RIGHT_GROUP INTEGER,
RIGHT_CODE VARCHAR(30),
VALUE_CODE INTEGER,
OPERATION VARCHAR(20))
 AS
declare variable right_descr varchar(255);
declare variable right_group varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'grant, revoke');

  right_descr = '@{right.name.' || :right_code || '}';

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS RG
  where  RG.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'grant') then begin
    --if (:value_code <> 0) then exception WRONG_VALUE 'rightType is rtPlain but value_code <> 0';

    if (not exists (select *
                    from   RIGHTS_GROUPS_LINES RGL
                    where  RGL.ID_RIGHT_GROUP = :id_right_group
                           and RGL.RIGHT_CODE = :right_code)) then
    begin
      insert into RIGHTS_GROUPS_LINES (ID_RIGHT_GROUP, RIGHT_CODE)
      values (:id_right_group, :right_code);

      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'RIGHT_GRANT',
              f_character(29) || :right_descr || f_character(28) || :right_group);
    end

  end else if (:operation = 'revoke') then begin
    delete from RIGHTS_GROUPS_LINES RGL
    where  RGL.ID_RIGHT_GROUP = :id_right_group
           and RGL.RIGHT_CODE = :right_code;

    if (row_count > 0) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'RIGHT_REVOKE',
              f_character(29) || :right_descr || f_character(28) || :right_group);
  end
end
^

/* Alter (RIGHTS_GROUP_USER_MODIFY) */
ALTER PROCEDURE RIGHTS_GROUP_USER_MODIFY(USER_NAME VARCHAR(30),
ID_RIGHT_GROUP INTEGER,
OPERATION VARCHAR(50))
 AS
declare variable right_group varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add,del');

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS RG
  where  RG.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'add') then begin
    insert into RIGHTS_USER_GROUPS (USER_NAME, ID_RIGHT_GROUP)
    values (:user_name, :id_right_group);

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_ADDED',
            f_character(29) || :USER_NAME  || f_character(28) || :right_group);

  end else begin
    delete from RIGHTS_USER_GROUPS
    where USER_NAME = :user_name
          and ID_RIGHT_GROUP = :id_right_group;

    if (row_count > 0) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_REMOVED',
              f_character(29) || :USER_NAME || f_character(28) || :right_group);

  end

  when sqlcode -803 do begin
    /* ERR_TEXT = '       ! ' ;*/
    exit;
  end
end
^

/* Alter (RIGHTS_MODIFY_USER) */
ALTER PROCEDURE RIGHTS_MODIFY_USER(IN_USER_NAME VARCHAR(30),
IN_USER_NAME_LONG VARCHAR(30),
IN_NEW_PASSWORD VARCHAR(8),
LANG_UI VARCHAR(10),
FISCAL_ID INTEGER,
IS_ACTIVE INTEGER,
OPERATION VARCHAR(20),
CODE VARCHAR(50))
 AS
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod');

  if (:operation = 'add') then begin
    insert into RIGHTS_USERS (USER_NAME, USER_NAME_LONG, USER_PASSWORD, FISCAL_ID, LANG_UI, IS_ACTIVE, CODE)
    values (:in_user_name, :in_user_name_long, :in_new_password, :fiscal_id, :lang_ui, :is_active, :code);

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_NEW', f_character(29) || :IN_USER_NAME);
  end else if (:operation = 'mod') then begin
    update RIGHTS_USERS U
    set    U.USER_PASSWORD  = :in_new_password,
           U.USER_NAME_LONG = :in_user_name_long,
           U.LANG_UI = :lang_ui,
           U.IS_ACTIVE = :is_active,
           U.FISCAL_ID = :fiscal_id,
           U.code = :code
    where  U.USER_NAME = :in_user_name;

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_MODIFY', f_character(29) || :IN_USER_NAME);
  end else if (:operation = 'del') then begin

    if (:in_user_name = 'SYSDBA') then exception ASSERT '-42';

    delete from RIGHTS_USERS
    where USER_NAME = :in_user_name;

    delete from RIGHTS_USER_GROUPS
    where USER_NAME = :in_user_name;

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_DEL', f_character(29) || :IN_USER_NAME);
  end

  when sqlcode -803 do begin
    exception ASSERT '-87';
  end
end
^

/* empty dependent procedure body */
/* Clear: RIGHTS_PROTECT for: RIGHTS_PROTECT */
ALTER PROCEDURE RIGHTS_PROTECT(RIGHT_CODE VARCHAR(50))
 AS
 BEGIN EXIT; END
^

/* Alter (RIGHTS_PROTECT) */
ALTER PROCEDURE RIGHTS_PROTECT(RIGHT_CODE VARCHAR(50))
 AS
declare variable granted_users_cnt integer;
begin
  /*  Description:
  ||  operation = {revoke right, delete user, delete group from user}
  */

  if (:right_code is not null) then begin
    if (:right_code in ('USERSEDIT', 'RIGHTSEDIT')) then begin
       select count(distinct RUG.USER_NAME)
       from   RIGHTS_GROUPS_LINES RGL
              join RIGHTS_USER_GROUPS RUG on RUG.ID_RIGHT_GROUP = RGL.ID_RIGHT_GROUP
       where  RGL.RIGHT_CODE = :right_code
       into   :granted_users_cnt;

       if (:granted_users_cnt = 0) then exception RIGHTS_RIGHTSEDIT_MUST_EXIST;
    end
  end else begin
    execute procedure RIGHTS_PROTECT('USERSEDIT');
    execute procedure RIGHTS_PROTECT('RIGHTSEDIT');
  end
end
^

/* empty dependent procedure body */
/* Clear: RIGHTS_REGRANT for: RIGHTS_REGRANT_SUB */
ALTER PROCEDURE RIGHTS_REGRANT AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RIGHTS_REGRANT_SUB for: RIGHTS_REGRANT_SUB */
ALTER PROCEDURE RIGHTS_REGRANT_SUB(GRANT_TO CHAR(31),
GRANT_ON CHAR(31),
USER_TYPE INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RIGHTS_REGRANT_SUB) */
ALTER PROCEDURE RIGHTS_REGRANT_SUB(GRANT_TO CHAR(31),
GRANT_ON CHAR(31),
USER_TYPE INTEGER)
 AS
declare variable dependent_name char(31);
  declare variable trigger_name char(31);
  declare variable trigger_dependent char(31);
begin
  /* PREVENT SHORT RECURSION WHEN ONE POCEDURE IS ITSELF */
  if (:grant_to = :grant_on) then exit;

  /* PREVENT LONG RECURSION */
  if (exists(
    select *
    from   RDB$USER_PRIVILEGES U
    where  U.RDB$USER = :grant_to
           and U.RDB$RELATION_NAME = :grant_on)
  ) then exit;

  insert into RDB$USER_PRIVILEGES (RDB$USER, RDB$GRANTOR, RDB$PRIVILEGE, RDB$GRANT_OPTION,
         RDB$RELATION_NAME, RDB$FIELD_NAME, RDB$USER_TYPE, RDB$OBJECT_TYPE)
  select :grant_to, 'SYSDBA', U.RDB$PRIVILEGE, 0,
         U.RDB$RELATION_NAME, U.RDB$FIELD_NAME, :user_type, U.RDB$OBJECT_TYPE
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = 'SYSDBA'
         and U.RDB$RELATION_NAME = :grant_on
         and (not exists( /* NOT ALREADY GRANTED */
           select 'X'
           from   RDB$USER_PRIVILEGES u2
           where  u2.RDB$USER = :grant_to
                  and u2.RDB$PRIVILEGE = U.RDB$PRIVILEGE 
                  and u2.RDB$RELATION_NAME = u.RDB$RELATION_NAME
           ))
         and U.RDB$PRIVILEGE <> 'M' /* NOT A MEMBERSHIP PRIVILIGE */;

  for
    select D.RDB$DEPENDED_ON_NAME
    from   RDB$DEPENDENCIES D
    where  D.RDB$DEPENDENT_NAME = :grant_on
           and D.RDB$DEPENDENT_TYPE not in (2, 3) /* 2 TRIGGERS, 3 DOMAINS */
           and D.RDB$DEPENDED_ON_TYPE in (0, 5) /*0 TABLE/VIEW, 5 PROCEDURE, 14 GENERATOR, 15 UDF, 7 EXCEPTION */
    into   :dependent_name
  do begin
    execute procedure RIGHTS_REGRANT_SUB(:grant_on, :dependent_name, 5);
  end

  /* if grant_on is table then
  ||
  */
  for
    select distinct T.RDB$TRIGGER_NAME, D.RDB$DEPENDED_ON_NAME
    from   RDB$TRIGGERS T
           join RDB$DEPENDENCIES D on D.RDB$DEPENDENT_NAME = T.RDB$TRIGGER_NAME
    where  T.RDB$RELATION_NAME = :grant_on
           and ((T.RDB$SYSTEM_FLAG is null) or (T.RDB$SYSTEM_FLAG = 0))
           and D.RDB$DEPENDED_ON_TYPE in (0, 5) /*0 TABLE/VIEW, 5 PROCEDURE, 14 GENERATOR, 15 UDF, 7 EXCEPTION */
    into   :trigger_name, :trigger_dependent
  do begin
    execute procedure RIGHTS_REGRANT_SUB(:trigger_name, :trigger_dependent, 2);
  end
end
^

/* empty dependent procedure body */
/* Clear: ROOM_CONTRACT_MODIFY$PMS for: ROOM_PERIOD_MODIFY$PMS */
ALTER PROCEDURE ROOM_CONTRACT_MODIFY$PMS(ID_ROOM_CONTRACT INTEGER,
ID_ROOM_PERIOD INTEGER,
CONTRACT_TYPE VARCHAR(50),
PMS_MARKERS BLOB SUB_TYPE 1 SEGMENT SIZE 100,
IMPORT_INCOME_WITH_VAT SMALLINT,
ID_RENTAL_POOL INTEGER,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_CONTRACT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_MODIFY$PMS for: ROOM_PERIOD_MODIFY$PMS */
ALTER PROCEDURE ROOM_MODIFY$PMS(ID_ROOM INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
BEDS INTEGER,
EXTRA_BEDS INTEGER,
SECTOR INTEGER,
SORT_ORDER INTEGER,
FEATURES BLOB SUB_TYPE 1 SEGMENT SIZE 100,
EXTERNAL_NAME VARCHAR(10),
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER,
OPERATION VARCHAR(20))
 RETURNS(OVERRULE_NEED SMALLINT,
OVERRULE_CONTEXT VARCHAR(255),
NEW_ID_ROOM INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ROOM_PERIOD_MODIFY$PMS) */
ALTER PROCEDURE ROOM_PERIOD_MODIFY$PMS(ID_ROOM_PERIOD INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
STATUS VARCHAR(30),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_PERIOD INTEGER)
 AS
declare variable id_hotel integer;
  declare variable old_status varchar(30);
  declare variable old_from_date date;
  declare variable id_room_type integer;
  declare variable old_id_room integer;
  declare variable old_to_date date;
  declare variable id_account_post integer;
  declare variable id_pms_event integer;
  declare variable action_text varchar(255);
  declare variable new_to_date date;
  declare variable prev_status varchar(30);
  declare variable checking smallint;
  declare variable old_id_room_contract integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');
  execute procedure SYSTEM_CHECK_OPERATION(:status, 'HOTEL, PRIVATE, CONTRACT, INACTIVE', 'Status');
  new_id_room_period = :id_room_period;

  if (:operation = 'add') then begin
    if (exists (select *
                from   ROOM_PERIOD$PMS R
                where  R.ID_ROOM = :id_room
                       and R.FROM_DATE = :from_date )) then exception PMS_EXCEPTION '-612';

    if (coalesce(:id_room_period, 0) <= 0) then new_id_room_period = gen_id(GEN_ROOM_PERIOD$PMS_ID,1);
    else new_id_room_period = :id_room_period;

    insert into ROOM_PERIOD$PMS (ID_ROOM_PERIOD, ID_ROOM, FROM_DATE, STATUS)
    values (:new_id_room_period, :id_room, :from_date, :status);

    execute procedure ROOM_PERIOD_TODATE$INT(:id_room);

    select rp.to_date
    from   ROOM_PERIOD$PMS rp
    where  rp.id_room_period = :new_id_room_period
    into   :new_to_date;

    action_text = f_character(29) || '@{period_room_status.'||:status||'}' || f_character(28) || formatdate(:from_date, 'dd.mm.yyyy')
                  || f_character(28) || iif(extract(year from :new_to_date) = 2500, '~', formatdate(:new_to_date, 'dd.mm.yyyy'));
    execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_STATUS_ADDED', :action_text);

  end else begin
    select R.STATUS, R.FROM_DATE, R.ID_ROOM, R.TO_DATE
    from   ROOM_PERIOD$PMS R
    where  R.ID_ROOM_PERIOD = :id_room_period
    into   :old_status, :old_from_date, :old_id_room, :old_to_date;

    if (:OPERATION = 'mod' and :old_id_room <> :ID_ROOM) then
      /* Very important check! */
      exception PMS_EXCEPTION 'Cannot change the contract room !';

    if (:OPERATION = 'del' and :old_status in ('PRIVATE', 'CONTRACT')) then begin
      if ((exists ( select *
                    from   ACCOUNT_POST$PMS AP1
                           join ACCOUNT$PMS A1 on A1.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS
                           join PMS_EVENT$PMS E1 on E1.ID_PMS_EVENT = AP1.ID_PMS_EVENT
                    where  AP1.DATE_POST between :OLD_FROM_DATE and :OLD_TO_DATE
                           and E1.ID_ROOM = :OLD_ID_ROOM
                           and A1.IS_SHADOW = 0
                           and AP1.LINE_STATUS < 22  ))
          or
          (exists ( select *
                    from   ACCOUNT_POST AP2
                           join PMS_EVENT_POST PP2 on PP2.ID_ACCOUNT_POST = AP2.ID_ACCOUNT_POST
                           join PMS_EVENT$PMS E2 on E2.ID_PMS_EVENT = PP2.ID_PMS_EVENT
                    where  AP2.DATE_POST between :OLD_FROM_DATE and :OLD_TO_DATE
                           and E2.ID_ROOM = :OLD_ID_ROOM
                           and PP2.LINE_STATUS < 22  )) ) then
      begin
        exception PMS_EXCEPTION '-624';
      end
    end

    for
      select AP1.ID_ACCOUNT_POST, AP1.ID_PMS_EVENT
      from   ACCOUNT_POST$PMS AP1
             join ACCOUNT$PMS A1 on A1.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS
             join PMS_EVENT$PMS E1 on E1.ID_PMS_EVENT = AP1.ID_PMS_EVENT
      where  AP1.DATE_POST between :OLD_FROM_DATE and :OLD_TO_DATE
             and E1.ID_ROOM = :OLD_ID_ROOM
             and A1.IS_SHADOW = 1
             and AP1.LINE_STATUS = 11 /*  anulirat se samo aktiwnite nachisleniq. Ako ima dokumentirani?! ili anulirani, ne se pipat  */
      into   :id_account_post, :id_pms_event
    do begin
      execute procedure ACCOUNT_POST_PMS_ANUL$INT(:id_pms_event, :id_account_post);
    end

    if (:operation = 'mod') then begin
      if (exists (select *
                  from   ROOM_PERIOD$PMS R
                  where  R.ID_ROOM in (:old_id_room, :id_room)
                         and R.FROM_DATE = :from_date
                         and R.ID_ROOM_PERIOD <> :id_room_period)) then exception PMS_EXCEPTION '-612';
  
      checking = 1;
      if ((:status in ('PRIVATE', 'CONTRACT')) and (:from_date = :old_from_date) and (:status = :old_status)) then begin
        checking = 0;
      end else if((:status in ('PRIVATE', 'CONTRACT')) and (:from_date <> :old_from_date)) then begin
        checking = 2;
        select first 1 rcp.id_room_contract
        from   ROOM_CONTRACT$PMS rcp
        where  rcp.id_room_period = :id_room_period
        into   :old_id_room_contract;
      end

      if (:checking > 0) then  begin -- else beshe po staria nachin
        update ROOM_PERIOD$PMS p
        set    p.FROM_DATE = :from_date,
               p.STATUS = :status
        where  p.ID_ROOM_PERIOD = :id_room_period;

        execute procedure ROOM_PERIOD_TODATE$INT(:id_room);

        select rp.to_date
        from   ROOM_PERIOD$PMS rp
        where  rp.id_room_period = :id_room_period
        into   :new_to_date;

        action_text = f_character(29) || '@{period_room_status.'||:old_status||'}'
                      || f_character(28) || iif(extract(year from :old_from_date) = 2500, '~', formatdate(:old_from_date, 'dd.mm.yyyy'))
                      || f_character(28) || iif(extract(year from :old_to_date) = 2500, '~', formatdate(:old_to_date, 'dd.mm.yyyy'))
                      || f_character(28) || '@{period_room_status.'||:status||'}'
                      || f_character(28) || iif(extract(year from :from_date) = 2500, '~', formatdate(:from_date, 'dd.mm.yyyy'))
                      || f_character(28) || iif(extract(year from :new_to_date) = 2500, '~', formatdate(:new_to_date, 'dd.mm.yyyy'));
        execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_STATUS_CHANGED', :action_text);

        if (:checking > 1) then
          execute procedure SYSTEM_LOG_ADD ('CONTRACT', :OLD_ID_ROOM_CONTRACT, 'ROOM_STATUS_CHANGED', :action_text);

      end

    end else if (:operation = 'del') then begin
      if (singular (select *
                    from   ROOM_PERIOD$PMS R
                    where  R.ID_ROOM = :old_id_room)) then exception PMS_EXCEPTION '-622';

      select first 1 rpm.status, rpm.ID_ROOM
      from   ROOM_PERIOD$PMS rpm
      where  rpm.id_room = :old_id_room
             and rpm.from_date < :old_from_date
      order by rpm.from_date desc
      into   :prev_status, :id_room;

      delete from ROOM_PERIOD$PMS
      where  ID_ROOM_PERIOD = :id_room_period;

      execute procedure ROOM_PERIOD_TODATE$INT(:id_room);

      action_text = f_character(29) || '@{period_room_status.'||:old_status||'}'
                  || f_character(28) || iif(extract(year from :old_from_date) = 2500, '~', formatdate(:old_from_date, 'dd.mm.yyyy'))
                  || f_character(28) || iif(extract(year from :old_to_date) = 2500, '~', formatdate(:old_to_date, 'dd.mm.yyyy'))
                  || f_character(28) || '@{period_room_status.'||:prev_status||'}' ;
      execute procedure SYSTEM_LOG_ADD ('ROOM', :id_room, 'ROOM_STATUS_DELETED', :action_text);
    end
  end

  /* rebuild physical allotment */
  if ( (:operation in ('add', 'del'))
       or
       ((:operation = 'mod') and ((:old_status <> :status) or (:old_from_date <> :from_date)))) then
  begin
    select RT.ID_HOTEL, R.ID_ROOM_TYPE
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :id_room
    into   :id_hotel, :id_room_type;

    execute procedure ALLOTMENT_PHYS_REBUILD$INT(:id_hotel, :id_room_type);
  end

end
^

/* empty dependent procedure body */
/* Clear: ROOM_PERIOD_MODIFY$PMS for: ROOM_PERIOD_TODATE$INT */
ALTER PROCEDURE ROOM_PERIOD_MODIFY$PMS(ID_ROOM_PERIOD INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
STATUS VARCHAR(30),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_PERIOD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ROOM_PERIOD_TODATE$INT) */
ALTER PROCEDURE ROOM_PERIOD_TODATE$INT(ID_ROOM INTEGER)
 AS
declare variable rp_dbkey char(8);
  declare variable to_date date;
  declare variable from_date date;
  declare variable status varchar(50);
begin
--  todate = null;
  to_date = '01.01.2500';
  for
    select R.RDB$DB_KEY, R.FROM_DATE, r.STATUS
    from   ROOM_PERIOD$PMS R
    where  R.ID_ROOM = :id_room
    order by R.FROM_DATE desc
    into   :rp_dbkey, :from_date, :status
  do begin
    if (:status = 'INACTIVE'
        and exists (select rm.ID_ROOM_MAGIC
                    from   ROOM_MAGIC rm
                    where  rm.ID_ROOM$INT = :ID_ROOM
                           and rm.BUSY_DATE between :from_date and :to_date)) then
      exception VALIDATE_EXCEPTION '-56' || f_character(31) || f_character(29) || formatdate(:from_date, 'D;dd.mm.yyyy') || f_character(28) || formatdate(:to_date, 'D;dd.mm.yyyy');
    else if (:status = 'PRIVATE'
             and (exists (select rm.ID_ROOM_MAGIC
                           from   ROOM_MAGIC rm
                                  join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = rm.ID_RESERV_DETAIL
                           where  rm.ID_ROOM$INT = :ID_ROOM
                                  and rm.BUSY_DATE between :from_date and :to_date
                                  and rd.ACC_ROUTING <> 'OWNER')
                  or exists (select rm.ID_ROOM_MAGIC
                           from   ROOM_MAGIC rm
                                  join BLOCK_ROOM br on br.ID_BLOCK_ROOM = rm.ID_RESERV_DETAIL
                           where  rm.ID_ROOM$INT = :ID_ROOM
                                  and rm.BUSY_DATE between :from_date and :to_date) ) ) then
      exception VALIDATE_EXCEPTION '-56' || f_character(31) || f_character(29) || formatdate(:from_date, 'D;dd.mm.yyyy') || f_character(28) || formatdate(:to_date, 'D;dd.mm.yyyy');
    else if (:status = 'HOTEL'
             and (exists (select rm.ID_ROOM_MAGIC
                           from   ROOM_MAGIC rm
                                  join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = rm.ID_RESERV_DETAIL
                           where  rm.ID_ROOM$INT = :ID_ROOM
                                  and rm.BUSY_DATE between :from_date and :to_date
                                  and rd.ACC_ROUTING = 'OWNER') ) ) then
      exception VALIDATE_EXCEPTION '-56' || f_character(31) || f_character(29) || formatdate(:from_date, 'D;dd.mm.yyyy') || f_character(28) || formatdate(:to_date, 'D;dd.mm.yyyy');

    update ROOM_PERIOD$PMS R
    set    R.TO_DATE = :to_date
    where  r.RDB$DB_KEY = :rp_dbkey;

    to_date = :from_date - 1;
  end
end
^

/* empty dependent procedure body */
/* Clear: ROOM_SMART_LIST_FREE$INT for: ROOM_SMART_FILTER$INT */
ALTER PROCEDURE ROOM_SMART_LIST_FREE$INT(FROM_DATE DATE,
TO_DATE DATE,
REPORT_LEAVING VARCHAR(50),
SUPPRESS_PRIVATE SMALLINT = 1)
 RETURNS(ROOM_NAME VARCHAR(50),
DBEFORE INTEGER,
DAFTER INTEGER,
FREE_BASE INTEGER,
FREE_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
FEATURES BLOB)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ROOM_SMART_FILTER$INT) */
ALTER PROCEDURE ROOM_SMART_FILTER$INT(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(20),
RESTRICT_CLEANING INTEGER,
SUPPRESS_PRIVATE SMALLINT = 1)
 RETURNS(ROOM_NAME VARCHAR(50),
BEDS INTEGER,
EXTRA_BEDS INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
IS_CLEAN INTEGER,
FLOOR INTEGER,
CLEAN_TEXT VARCHAR(20),
FEATURES BLOB,
SYS_DATE DATE)
 AS
declare variable inactive_rooms_list varchar(5000);
  declare variable blocked_rooms_list varchar(5000);
  declare variable busy_rooms_list varchar(5000);
begin
  execute procedure sys_dbg('occ ROOM_SMART_FILTER$INT from_date = '||coalesce(:from_date, 'null'));
  execute procedure sys_dbg('occ ROOM_SMART_FILTER$INT to_date = '||coalesce(:to_date, 'null'));

  inactive_rooms_list  = 'x';
  blocked_rooms_list  = 'x';
  -- PREPARE EXCLUDING OF UNAVAILABLE ROOMS - PRIVATE USE, OR INACTIVE FOR THE PERIOD
  for
    select distinct R.ID_ROOM
    from   ROOM_PERIOD$PMS R
           join TMP_SMART_ROOMS TSR on TSR.ID_ROOM = R.ID_ROOM and TSR.ID_SESSION = current_connection
    where  R.FROM_DATE <= :to_date
           and R.TO_DATE >= :from_date
           and ((R.STATUS  = 'INACTIVE') or (:SUPPRESS_PRIVATE = 1 and R.STATUS = 'PRIVATE'))
    into   :id_room
  do inactive_rooms_list = :inactive_rooms_list || :id_room || 'x';

  execute procedure sys_dbg('occ ROOM_SMART_FILTER$INT unavailable blocked_rooms_list = '||coalesce(:blocked_rooms_list, 'null'));

  -- PREPARE EXCLUDING OF BLOCKED ROOMS
  for
    select distinct RM.ID_ROOM
    from   ROOM_MAGIC RM
           join TMP_SMART_ROOMS TSR on TSR.ID_ROOM = RM.ID_ROOM
                                       and TSR.ID_SESSION = current_connection
    where  RM.BUSY_DATE between :from_date and :to_date - 1
           and RM.BUSY_GROUP_TYPE IN (18, 20)
           and RM.DAY_ACTION not containing 'CHECK_OUT'
    into   :id_room
  do begin
    blocked_rooms_list = :blocked_rooms_list||:id_room||'x';
  end
  execute procedure sys_dbg('occ ROOM_SMART_FILTER$INT blocked blocked_rooms_list = '||coalesce(:blocked_rooms_list, 'null'));

  /*
  ||  PREPARE EXCLUDING OF NON CLEANED OR INSPECTED ROOMS
  ||  DEPENDING ON DB_SETTING AND FROM_DATE
  */
  if (:restrict_cleaning = '1') then begin
    for
      select R.ID_ROOM
      from   ROOMS R
             join TMP_SMART_ROOMS TSR on TSR.ID_ROOM = R.ID_ROOM and TSR.ID_SESSION = current_connection
      where  R.IS_CLEAN = 0
      into   :id_room
    do blocked_rooms_list = :blocked_rooms_list||:id_room||'x';
  end else if (:restrict_cleaning = '2') then begin
    for
      select R.ID_ROOM
      from   ROOMS R
             join TMP_SMART_ROOMS TSR on TSR.ID_ROOM = R.ID_ROOM and TSR.ID_SESSION = current_connection
      where  (R.IS_CLEAN = 0) or (R.IS_INSPECTED = 0)
      into   :id_room
    do blocked_rooms_list = :blocked_rooms_list||:id_room||'x';
  end
  execute procedure sys_dbg('occ ROOM_SMART_FILTER$INT dirty blocked_rooms_list = '||coalesce(:blocked_rooms_list, 'null'));

  /*
  ||  PREPARE EXCLUDING OF PARTIAL BUSY ROOMS
  ||  DEPENDING ON INPUT PARAM
  */
  busy_rooms_list = 'x';
  for
    select distinct RM.ID_ROOM
    from   ROOM_MAGIC RM
           join TMP_SMART_ROOMS TSR on TSR.ID_ROOM = RM.ID_ROOM and TSR.ID_SESSION = current_connection
    where  RM.BUSY_DATE between :from_date and :to_date - 1
           and RM.BUSY_GROUP_TYPE IN (1, 24) --RESERVATIONS AND CHECKINS
           and RM.ID_ROOM > 0
           and RM.DAY_ACTION not containing 'CHECK_OUT'
    into   :id_room
  do begin
    if (:busy_rooms_list not containing 'x'||:id_room||'x') then
      busy_rooms_list = :busy_rooms_list||:id_room||'x';
  end
  execute procedure sys_dbg('occ ROOM_SMART_FILTER$INT busy busy_rooms_list = '||coalesce(:busy_rooms_list, 'null'));
  /* GET THE REAL ROOMS ACCORDING TO THE GENERATED FILTER
  */
  if (:report_type = 'FREE') then begin
    blocked_rooms_list = :blocked_rooms_list||'x'||:busy_rooms_list||'x';
    for
      select R.ROOM_NAME, R.BEDS, R.EXTRA_BEDS, R.IS_CLEAN, RT.TYPE_ROOM, R.ID_ROOM,
             R.FLOOR, R.FEATURES, R.CLEAN_TEXT, H.SYSTEM_DATE
      from   (select P.ID_ROOM
              from   ROOM_EXIST_PERIOD P
              where  P.FROM_DATE <= :from_date
                     and P.TO_DATE >= :to_date) RP
             join ROOMS R on R.ID_ROOM = RP.iD_ROOM
             join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
             join HOTEL H on H.ID_HOTEL = RT.ID_HOTEL
             join TMP_SMART_ROOMS TSR on TSR.ID_ROOM = R.ID_ROOM and TSR.ID_SESSION = current_connection
      where  :blocked_rooms_list not containing 'x'||R.ID_ROOM||'x'
             and :inactive_rooms_list not containing 'x'||R.ID_ROOM||'x'
      into   :room_name, :beds, :extra_beds, :is_clean, :type_room, :id_room,
             :floor, :features, :clean_text, :sys_date
    do suspend;
  end else if (:report_type = 'SHARE') then begin
    for
      select R.ROOM_NAME, R.BEDS, R.EXTRA_BEDS, R.IS_CLEAN, RT.TYPE_ROOM, R.ID_ROOM,
             R.FLOOR, R.FEATURES, R.CLEAN_TEXT, H.SYSTEM_DATE
      from   (select P.ID_ROOM
              from   ROOM_EXIST_PERIOD P
              where  P.FROM_DATE <= :from_date
                     and P.TO_DATE >= :to_date) RP
             join ROOMS R on R.ID_ROOM = RP.iD_ROOM
             join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
             join HOTEL H on H.ID_HOTEL = RT.ID_HOTEL
             join TMP_SMART_ROOMS TSR on TSR.ID_ROOM = R.ID_ROOM and TSR.ID_SESSION = current_connection
      where  :busy_rooms_list containing 'x'||R.ID_ROOM||'x'
             and :blocked_rooms_list not containing 'x'||R.ID_ROOM||'x'
             and :inactive_rooms_list not containing 'x'||R.ID_ROOM||'x'
      into   :room_name, :beds, :extra_beds, :is_clean, :type_room, :id_room,
             :floor, :features, :clean_text, :sys_date
    do suspend;
  end else begin
    for
      select R.ROOM_NAME, R.BEDS, R.EXTRA_BEDS, R.IS_CLEAN, RT.TYPE_ROOM, R.ID_ROOM,
             R.FLOOR, R.FEATURES, R.CLEAN_TEXT, H.SYSTEM_DATE
      from   (select P.ID_ROOM
              from   ROOM_EXIST_PERIOD P
              where  P.FROM_DATE <= :from_date
                     and P.TO_DATE >= :to_date) RP
             join ROOMS R on R.ID_ROOM = RP.iD_ROOM
             join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
             join HOTEL H on H.ID_HOTEL = RT.ID_HOTEL
             join TMP_SMART_ROOMS TSR on TSR.ID_ROOM = R.ID_ROOM and TSR.ID_SESSION = current_connection
      where  :blocked_rooms_list containing 'x'||R.ID_ROOM||'x'
             and :inactive_rooms_list not containing 'x'||R.ID_ROOM||'x'
      into   :room_name, :beds, :extra_beds, :is_clean, :type_room, :id_room,
             :floor, :features, :clean_text, :sys_date
    do suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: ROOM_SMART_LIST$RSV for: ROOM_SMART_LIST_FREE$INT */
ALTER PROCEDURE ROOM_SMART_LIST$RSV(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(50))
 RETURNS(ROOM_NAME VARCHAR(50),
FREE_BEDS_BASE INTEGER,
FREE_BEDS_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
FEATURES BLOB,
BUSY_GROUP_TYPE INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
DATA1 VARCHAR(255),
DATA2 VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (ROOM_SMART_LIST_FREE$INT) */
ALTER PROCEDURE ROOM_SMART_LIST_FREE$INT(FROM_DATE DATE,
TO_DATE DATE,
REPORT_LEAVING VARCHAR(50),
SUPPRESS_PRIVATE SMALLINT = 1)
 RETURNS(ROOM_NAME VARCHAR(50),
DBEFORE INTEGER,
DAFTER INTEGER,
FREE_BASE INTEGER,
FREE_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
FEATURES BLOB)
 AS
declare variable magic_date date;
  declare variable sys_date date;
  declare variable dummy integer;
  declare variable beds integer;
  declare variable extra_beds integer;
begin
  for
    select SRLF.ROOM_NAME, SRLF.BEDS, SRLF.EXTRA_BEDS, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
           SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.CLEAN_TEXT, SRLF.SYS_DATE
    from   ROOM_SMART_FILTER$INT(:from_date, :to_date, 'FREE', 0, :SUPPRESS_PRIVATE) SRLF
    into   :room_name, :beds, :extra_beds, :is_clean, :type_room,
           :id_room, :floor, :features, :clean_text, :sys_date
  do begin
    atention = 0;
    execute procedure ROOM_SMART_OCCUP$INT(:id_room, :from_date, :to_date, 'AFTER')
    returning_values  :magic_date, :dummy;
    if ((:magic_date is null) or (:magic_date >= :to_date)) then begin
      -- THE ROOM IS EMPTY FOR THE PERIOD
      dafter = (:magic_date - :to_date);
      if (:dafter = 0) then atention = :atention+2;
      execute procedure ROOM_SMART_OCCUP$INT(:id_room, :from_date, :to_date/*ROGO old :sys_date*/, 'BEFORE')
      returning_values  :magic_date, :dummy;
      dbefore = (:from_date - :magic_date - 1);
      if ((:dbefore = 0) and (exists(
        select g.ID_GUEST
        from   GUEST G
               join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
        where  G.TO_DATE = :from_date
               and G.ID_ROOM = :id_room
               and G.CHECK_STATUS = 0
               and rd.IS_ANUL = 0
        ))) then begin
          atention = :atention+1;
          if (:report_leaving <> 'AS_FREE') then atention = 666;
        end
      free_base = :beds;
      free_extra = :extra_beds;
      if (:atention <> 666) then suspend;
    end/* else if (:fetch_partial_busy=1) then begin
      partial_busy = '!';
      dbefore = NULL;
      dafter  = NULL;
      execute procedure ROOM_SMART_OCCUP$INT(:id_room, :magic_date, :to_date, 'GUESTS')
      returning_values  :magic_date, :cnt_guests;
      if (:cnt_guests < (:beds+:extra_beds)) then begin
        if (:cnt_guests < :beds) then begin
          free_base = (:beds - :cnt_guests);
          free_extra = extra_beds;
        end else begin
          free_base = 0;
          free_extra = ((:beds+:extra_beds)-:cnt_guests);
        end
        suspend;
      end
    end   */
  end
end
^

/* Alter (ROOM_SMART_LIST_OOS$INT) */
ALTER PROCEDURE ROOM_SMART_LIST_OOS$INT(FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ROOM_NAME VARCHAR(50),
DESCRIPTION VARCHAR(100),
PERIOD VARCHAR(100),
FREE_BASE INTEGER,
FREE_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
IS_CLEAN INTEGER,
FEATURES BLOB)
 AS
declare variable id_reserv_detail integer;
  declare variable sys_date date;
  declare variable dummy integer;
  declare variable beds integer;
  declare variable extra_beds integer;
  declare variable guests_cnt integer;
begin
  if (:from_date >= :to_date) then exit;

  for
    select SRLF.ROOM_NAME, SRLF.BEDS, SRLF.EXTRA_BEDS, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
           SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.SYS_DATE
    from   ROOM_SMART_FILTER$INT(:from_date, :to_date, 'SHARE', 0, 1) SRLF
    into   :room_name, :beds, :extra_beds, :is_clean, :type_room,
           :id_room, :floor, :features, :sys_date
  do begin
    for
      select distinct RM.ID_RESERV_DETAIL
      from   ROOM_MAGIC RM
      where  RM.ID_ROOM = :id_room
             and RM.BUSY_DATE between :from_date and :to_date
             and RM.DAY_ACTION not containing 'CHECK_IN'
      into   :id_reserv_detail
    do begin
      select RGI.NUMBER ||', '|| RGI.PERSON_PROFILE_NAME ||', '||  RGI.AGENT_PROFILE_NAME,
             RGI.ARRIVALS ||' '|| RGI.DEPARTURES, RGI.GUESTS_CNT
      from   RES_GET_INFO$RSV(:id_reserv_detail, 0, 0, 0) RGI
      into   :description, :period, :guests_cnt;

      if (:guests_cnt < (:beds+:extra_beds)) then begin
        if (:guests_cnt < :beds) then begin
          free_base = (:beds - :guests_cnt);
          free_extra = extra_beds;
        end else begin
          free_base = 0;
          free_extra = ((:beds+:extra_beds)-:guests_cnt);
        end
        suspend;
      end
    end
  end
end
^

/* Alter (ROOM_SMART_LIST_SHARE$INT) */
ALTER PROCEDURE ROOM_SMART_LIST_SHARE$INT(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(50),
SUPPRESS_PRIVATE SMALLINT = 1)
 RETURNS(ROOM_NAME VARCHAR(50),
DESCRIPTION VARCHAR(255),
PERIOD VARCHAR(255),
FREE_BASE INTEGER,
FREE_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
FEATURES BLOB)
 AS
declare variable id_reserv_detail integer;
  declare variable beds integer;
  declare variable extra_beds integer;
  declare variable guests_cnt integer;
  declare variable busy_group_type integer;
  declare variable r_guests_cnt integer;
  declare variable r_description varchar(255);
  declare variable r_period varchar(255);
  declare variable min_day_action integer;
begin
  if (:from_date >= :to_date) then exit;
  report_type = iif(:report_type = 'POTENTIAL_SHARE', 'SHARE', 'BLOCKED');
  for
    select SRLF.ROOM_NAME, SRLF.BEDS, SRLF.EXTRA_BEDS, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
           SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.CLEAN_TEXT
    from   ROOM_SMART_FILTER$INT(:from_date, :to_date, :report_type, 0, :SUPPRESS_PRIVATE) SRLF
    into   :room_name, :beds, :extra_beds, :is_clean, :type_room,
           :id_room, :floor, :features, :clean_text
  do begin
    guests_cnt = 0;
    description = '';
    for
      select RM.ID_RESERV_DETAIL, RM.BUSY_GROUP_TYPE, min(RM.DAY_ACTION_INT)
      from   ROOM_MAGIC RM   --TODO order by arrival
      where  RM.ID_ROOM = :id_room
             and RM.BUSY_DATE between :from_date and :to_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
      group by 1, 2
      into   :id_reserv_detail, :busy_group_type, :min_day_action
    do begin
      if ((:busy_group_type in (1, 24)) or (:min_day_action > 0)) then begin
        select substring(RGI.NUMBER ||', '|| RGI.PERSON_PROFILE_NAME ||', '||  RGI.AGENT_PROFILE_NAME from 1 for 254),
               substring(RGI.ARRIVALS ||' '|| RGI.DEPARTURES from 1 for 254), RGI.GUESTS_CNT
        from   RES_GET_INFO$RSV(:id_reserv_detail, 0, 0, 0) RGI
        into   :r_description, :r_period, :r_guests_cnt;
      end else begin
        select iif(BR.BLOCK_GRP=18, 'OOO', 'OOI') ||', ' || substring(BR.REASON ||', '|| BR.NOTE from 1 for 254),
               substring(formatDate(BR.FROM_DATE, 'D;dd.mm')||' ('|| cast((BR.TO_DATE - BR.FROM_DATE) as integer) ||') '||formatDate(BR.TO_DATE, 'D;dd.mm') from 1 for 254)
        from   BLOCK_ROOM BR
        where  BR.ID_BLOCK_ROOM = :id_reserv_detail
        into   :r_description, :r_period;
        r_guests_cnt = 0;
      end
      if (:r_guests_cnt > :guests_cnt) then guests_cnt = :r_guests_cnt;

      if (:description <> '') then description = :description || F_CRLF();
      description = substring(:description || :r_description || ', ' || :r_period from 1 for 250);
    end
    if (:guests_cnt < (:beds+:extra_beds)) then begin
      if (:guests_cnt < :beds) then begin
        free_base = (:beds - :guests_cnt);
        free_extra = extra_beds;
      end else begin
        free_base = 0;
        free_extra = ((:beds+:extra_beds)-:guests_cnt);
      end
    end
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: CHANNEL_GET_WHOLEALLOTMENT$CHM for: ROOM_TYPE_GET_FREE$CHM */
ALTER PROCEDURE CHANNEL_GET_WHOLEALLOTMENT$CHM(ID_CHANNEL INTEGER)
 RETURNS(ID_ROOM_TYPE INTEGER,
FOR_DATE DATE,
IS_ACTIVE INTEGER,
AUTO_FREE_ROOMS INTEGER,
ROOM_COUNT INTEGER,
FREE_ROOMS INTEGER,
STATUS INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ROOM_TYPE_GET_FREE$CHM) */
ALTER PROCEDURE ROOM_TYPE_GET_FREE$CHM(FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM_TYPE INTEGER)
 RETURNS(FOR_DATE DATE,
AVAILABLE INTEGER,
OCCUPIED INTEGER)
 AS
declare variable id_hotel integer;
begin

  select RT.ID_HOTEL
  from   ROOM_TYPES RT
  where  RT.ID_ROOM_TYPE = :id_room_type
  into   :id_hotel;

  /*!!!! moje da se optimizira - ako se sloji id_room_type whoden parametar na availability_occup_small$int*/
  for
    select aos.for_date, aos.available, aos.occupied
    from   availability_occup_small$int (:from_date, :to_date, :id_hotel, 0) aos
    where  aos.id_room_type = :id_room_type
    into   :for_date, :available, :occupied
  do suspend;

end
^

/* Alter (ROOM_TYPE_GET_FREE_ALL$CHM) */
ALTER PROCEDURE ROOM_TYPE_GET_FREE_ALL$CHM(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER)
 RETURNS(FOR_DATE DATE,
AVAILABLE INTEGER,
OCCUPIED INTEGER,
ID_ROOM_TYPE INTEGER)
 AS
begin

  /*!!!! moje da se optimizira - ako se sloji id_room_type whoden parametar na availability_occup_small$int*/
  for
    select AOS.FOR_DATE, AOS.AVAILABLE, AOS.OCCUPIED, AOS.ID_ROOM_TYPE
    from   AVAILABILITY_OCCUP_SMALL$INT (:from_date, :to_date, :id_hotel, 0) AOS
    into   :for_date, :available, :occupied, id_room_type
  do suspend;

end
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_MODIFY for: SAFE_OCCUPANCY_POSTING$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE /* TYPE OF ID */ INTEGER,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100))
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_NEW for: SAFE_OCCUPANCY_POSTING$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE /* TYPE OF ID */ INTEGER,
FROM_DATETIME /* TDATETIME */ TIMESTAMP,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100),
BOOKING_NUMBER /* TYPE OF TRES_NUMBER */ VARCHAR(62),
ID_EXTERNAL_CLIENT_ACCCOUNT /* TYPE OF ID_REF */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER,
ID_RESOURCE_RESERVATION /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SAFE_OCCUPANCY_POSTING$INT) */
ALTER PROCEDURE SAFE_OCCUPANCY_POSTING$INT(ID_RESOURCE_RESERVATION TYPE OF ID,
ID_SERVICE TYPE OF ID,
PRICE TYPE OF TPRICE,
CURRENCY TYPE OF TCURRENCY,
PRICE_DESCRIPTION TYPE OF TDESCRIPTION_SHORT,
ID_RESERV_DETAIL TYPE OF ID,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF = null)
 RETURNS(DOC_SELECTED TYPE OF TRANGE)
 AS
declare variable from_datetime timestamp;
  declare variable to_datetime timestamp;
  declare variable ap_dbkey TDB_KEY;
  declare variable id_account_post integer;
  declare variable id_account integer;
  declare variable safe_name TOBJECT_NAME;
  declare variable no_use varchar(255);
  declare variable new_ac varchar(2);
  declare variable err_code integer;
  declare variable err_text varchar(255) ;
  declare variable occupant_name tperson_name;
  declare variable id_room integer;
  declare variable id_tariff integer;
begin
  DOC_SELECTED = null;
  select od.FROM_DATETIME, od.TO_DATETIME, ap.RDB$DB_KEY, ap.ID_ACCOUNT_POST,
         ap.ID_ACCOUNT, s.SAFE_NAME, rr.OCCUPANT_NAME, ap.ID_ROOM, ap.ID_TARIFF
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join SAFES s on s.ID_SAFE = od.ID_RESOURCE
         left outer join RESOURCE_RESERV_POST rrp on rrp.ID_RESOURCE_RESERVATION = rr.ID_RESOURCE_RESERVATION
         left outer join ACCOUNT_POST ap on ap.ID_ACCOUNT_POST = rrp.ID_ACCOUNNT_POST
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :from_datetime, :to_datetime, :ap_dbkey, :id_account_post,
         :id_account, :safe_name, :occupant_name, :id_room, :id_tariff;

  new_ac = null;
  if (:id_account_post is not null) then begin
    execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_account, :id_service,
            :id_tariff, :id_room, 1, 0, :price, :currency, null, null, 'RESOURCE', :from_datetime, :TO_DATETIME, 1)
    returning_values :no_use, :no_use, :new_ac;
  end else begin
    if (:id_reserv_detail is not null) then begin
      execute procedure POST_SERVICE_ON_RESERVATION$INT (:id_reserv_detail, :id_service, 1, 0,
              1, :price, :currency, :from_datetime, :to_datetime,
              '', '', cast(:from_datetime as date), 'RESOURCE', null)
      returning_values (:ERR_CODE, :ERR_TEXT, :id_account, :id_account_post);
      if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      new_ac = '00';
    end else if (:ID_EXTERNAL_CLIENT_ACCCOUNT is not null) then begin
      execute procedure POST_SERVICE_ON_ACCOUNT$INT (:ID_EXTERNAL_CLIENT_ACCCOUNT, :id_service,
              1, 0, 1, :price, :currency, :from_datetime, :TO_DATETIME, '', '',
              cast(:from_datetime as date), 'RESOURCE', null, null)
      returning_values (:err_code, :err_text, :id_account_post);
      if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      new_ac = '00';
    end
  end

  if (:new_ac is null) then
    exception ASSERT '-1067' || f_character(31) || f_character(29) || :safe_name || f_character(28) || :occupant_name;

  if (:new_ac = '00') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);
    update ACCOUNT_POST AP
    set    ap.DOC_SELECTED = :DOC_SELECTED
    where  ap.ID_ACCOUNT_POST = :id_account_post;
  end

  update or insert into ACCOUNT_POSTING_DET (ID_ACCOUNT_POST, POST_TEXT, QTY,
         FROM_DATETIME, TO_DATETIME, RESOURCE_TEXT, EXT_USER_ANUL)
  values (:id_account_post, :safe_name ||' / '||formatdate(:from_datetime, 'D;dd.mm.yy(hh:mm)')||' - '||formatdate(:to_datetime, 'D;dd.mm.yy(hh:mm)')||' / '
          ||substring(replace(:price_description, F_CRLF(), ';') from 1 for 100), 1, :from_datetime, :to_datetime, :safe_name, null);

  if (not exists (select rp.ID_ACCOUNNT_POST
                  from   RESOURCE_RESERV_POST rp
                  where  rp.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION
                         and rp.ID_ACCOUNNT_POST = :id_account_post)) then
  begin
    insert into RESOURCE_RESERV_POST (ID_RESOURCE_RESERVATION, ID_ACCOUNNT_POST)
    values (:id_resource_reservation, :id_account_post);
  end
end
^

/* Alter (SERVICE_PAYMENT_ANALYSIS$RPT) */
ALTER PROCEDURE SERVICE_PAYMENT_ANALYSIS$RPT(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER)
 RETURNS(ID_SERVICE INTEGER,
ID_PAYMENT_TYPE INTEGER,
SALE_AMOUNT NUMERIC(15,4))
 AS
declare variable id_doc integer;
  declare variable pay_coef double precision;
  declare variable doc_value numeric(15,4);
  declare variable data_orig numeric(15,4);
  declare variable d_rate numeric(15,6);
  declare variable value_corr_idx integer;
  declare variable for_deposit integer;
begin

  for
    select DH.ID_DOC, DH.DOC_RATE, DH.VALUE_CORR_IDX, DH.FOR_DEPOSIT
    from   DOCUMENT_RELEASE_S DH
           join ACCOUNT A on A.ID_ACCOUNT = DH.ID_ACCOUNT
    where  A.ID_HOTEL = :ID_HOTEL
           and DH.RPT_DOC_DATE between :FROM_DATE and :TO_DATE
           and DH.IS_ANNUL_ON_DATE = 0
    into   :id_doc, :d_rate, :value_corr_idx, :for_deposit
  do begin
    doc_value = null;
    select sum(DP.DOC_AMOUNT)
    from   DOC_PAY_USAGE DP
    where  DP.ID_DOC_HEAD = :id_doc
    into   :doc_value;

    if (:doc_value <> 0) then begin
      for
        /* get all used payments */
        select  PT.ID_PAYMENT_TYPE, sum(dP.DOC_AMOUNT) / :doc_value
        from    DOC_PAY_USAGE DP
                join ACCOUNT_PAYMENTS AP on AP.ID_ACCOUNT_PAYMENT = dp.ID_ACCOUNT_PAYMENT
                join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = AP.ID_PAYMENT_HEAD
                join PAYMENT_TYPE PT on PT.ID_PAYMENT_TYPE = P.ID_PAYMENT_TYPE
        where   DP.ID_DOC_HEAD = :ID_DOC
        group by 1
        into     :ID_PAYMENT_TYPE, :pay_coef
      do begin
        /* apportion payments to services */
        for
          select DL.ID_SERVICE, sum(DL.SINGLE_VALUE * DL.QTY_POST)
          from   DOC_LINE DL
                 left outer join DOC_LINE_DEP_VALUES DV on DV.ID_DOC_LINE = DL.ID_DOC_LINE and :for_deposit = 0
          where  DL.ID_DOC_HEAD = :ID_DOC
                 and DV.ID_DOC_LINE is null /* skip used advance payments */
          group by 1
          into   :ID_SERVICE, :data_orig
        do begin
          SALE_AMOUNT = :data_orig * :pay_coef * :d_rate * :value_corr_idx;
          suspend;
        end
      end
      /* subtract used advance payments (invoiced) */
      for
        select DL.ID_SERVICE, PT.ID_PAYMENT_TYPE, -sum(DD.USED_DOC_VALUE)
        from   DOC_LINE DL
               join DOC_LINE_DEP_VALUES DV on DV.ID_DOC_LINE = DL.ID_DOC_LINE
               join DEPOSIT_DEDUCT DD on DD.ID_DEPOSIT = DV.ID_DEPOSIT
               join PAYMENT_TYPE PT on PT.ID_PAYMENT_TYPE = DD.ID_PAYMENT_TYPE
        where  DL.ID_DOC_HEAD = :ID_DOC
               and DD.ID_DOC_USED = :ID_DOC
        group by 1, 2
        into   :ID_SERVICE, :ID_PAYMENT_TYPE, :DATA_ORIG
      do begin
        SALE_AMOUNT = :DATA_ORIG * :D_RATE * :VALUE_CORR_IDX;
        suspend;
      end
    end
  end
end
^

/* Alter (SPR_DOC_MATRIX) */
ALTER PROCEDURE SPR_DOC_MATRIX(FROM_DATE DATE,
TO_DATE DATE,
ID_CONTRAGENT INTEGER,
ID_TYPE_PAYMENT INTEGER,
ID_BASE_DOC_TYPE INTEGER,
SRV_GROUP_TAG VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(DOC_DATA VARCHAR(30),
IS_ANUL SMALLINT,
CONTRAGENT_NAME VARCHAR(100),
USER_NAME VARCHAR(50),
COL_NAME VARCHAR(30),
COL_VALUE NUMERIC(15,4),
COL_ORIG_VALUE NUMERIC(15,4),
SORT_ORDER SMALLINT)
 AS
declare variable id_doc integer;
  declare variable tmp_id_contragent integer;
  declare variable doc_num varchar(20);
  declare variable doc_date date;
  declare variable payment_allowed smallint;
  declare variable doc_rate numeric(15,6);
  declare variable value_corr_idx numeric(15,2);
  declare variable doc_value numeric(15,4);
  declare variable nontaxable_value numeric(15,4);
  declare variable taxable_value numeric(15,4);
  declare variable tax_value numeric(15,4);
  declare variable tax_name varchar(50);
begin
  /* GROUP_TAGs : 'SRV_ACC', 'SRV_GRP' */

  VALUE_CORR_IDX = 1;
  ID_CONTRAGENT = case when :ID_CONTRAGENT = -1 then null else :ID_CONTRAGENT end;
  ID_TYPE_PAYMENT = case when :ID_TYPE_PAYMENT = -1 then null else :ID_TYPE_PAYMENT end;
  ID_BASE_DOC_TYPE = case when :ID_BASE_DOC_TYPE = -1 then null else :ID_BASE_DOC_TYPE end;

  for
    select DH.ID_DOC, DH.USER_CREATED, DC.ID_CONTRAGENT, DH.DOC_NUM,
           DH.REAL_DOC_DATE, DH.DOC_RATE, DH.IS_ANNUL_FLAG, DH.VALUE_CORR_IDX,
           DH.DOC_VALUE_A
    from   DOCUMENT_RELEASE_S DH
           join DOC_CONTRAGENT DC on DC.ID_DOC_CONTRAGENT = DH.ID_DOC_CONTRAGENT
           join DOC_TYPE DT on DT.ID_DOC_TYPE = DH.ID_DOC_TYPE
           join ACCOUNT A on A.ID_ACCOUNT = DH.ID_ACCOUNT
    where  A.ID_HOTEL = :ID_HOTEL
           and DH.RPT_DOC_DATE between :FROM_DATE and :TO_DATE
           and DC.ID_CONTRAGENT is not distinct from coalesce(:ID_CONTRAGENT, DC.ID_CONTRAGENT)
           and DT.ID_DOC_TYPE is not distinct from coalesce(:ID_BASE_DOC_TYPE, DT.ID_DOC_TYPE)
    order by 1
    into   :id_doc, :user_name, :tmp_id_contragent, :doc_num,
           :doc_date, :doc_rate, :is_anul, :value_corr_idx, :doc_value
  do begin
    PAYMENT_ALLOWED = 0;
    if ((:ID_TYPE_PAYMENT is null)
        or (exists (select P.ID_PAYMENT_HEAD
                    from   DOCUMENT_PAYMENT P
                    where  P.ID_DOC_HEAD = :ID_DOC
                           and P.ID_PAYMENT_TYPE = :ID_TYPE_PAYMENT)) ) then
    begin
      PAYMENT_ALLOWED = 1;
    end

    if (:PAYMENT_ALLOWED = 1) then begin
      CONTRAGENT_NAME = null;
      select  C.CONTRAGENT_NAME
      from    CONTRAGENTS C
      where   C.ID_CONTRAGENT = :TMP_ID_CONTRAGENT
      into    :CONTRAGENT_NAME;
      CONTRAGENT_NAME = coalesce(:CONTRAGENT_NAME, '-');

      DOC_DATA = case when :is_anul = 1 then '*' else ' ' end
                 || f_padright(:doc_num, ' ', 10)
                 || ' ' || formatdate(:doc_date, 'D;dd.mm.yyyy');

      for
        select   cast(case
                        when cast(:SRV_GROUP_TAG as varchar(20))  = 'SRV_ACC' then S.ACCOUNT_NAME
                        when cast(:SRV_GROUP_TAG as varchar(20)) = 'SRV_GRP' then SG.GROUP_NAME
                        else ''
                      end as varchar(30)),
                 sum(D.WOT_VAT * cast(:DOC_RATE as numeric(15,6)) * :VALUE_CORR_IDX), 100
        from     DOC_LINE D
                 join SERVICES S on D.ID_SERVICE = S.ID_SERVICE
                 join SERVICE_GROUPS SG on SG.ID_SERVICE_GROUP = S.ID_SERVICE_GROUP
        where    D.ID_DOC_HEAD = :ID_DOC     
                 and cast(:SRV_GROUP_TAG as varchar(20)) <> ''
        group by 1
        union all
        select   cast(PT.PAYMENT_TYPE as varchar(30)),
                 sum(PH.NAT_VALUE), 200
        from     DOCUMENT_PAYMENT PH
                 join PAYMENT_TYPE PT on PT.ID_PAYMENT_TYPE = PH.ID_PAYMENT_TYPE
        where    PH.ID_DOC_HEAD = :ID_DOC
                 and PH.REALIZE_DATE between :FROM_DATE and :TO_DATE
--                 and :is_anul = 0
        group by 1
        into     :COL_NAME, :COL_ORIG_VALUE, :SORT_ORDER
      do begin
        /********************/
        /*   FINAL MAKEUP   */  
        /********************/
        COL_NAME = substring(:COL_NAME from 1 for 11);
        COL_VALUE = :COL_ORIG_VALUE; --  * :VALUE_CORR_IDX;
        suspend;
      end
      /********************/  
      /*     SUMMARY      */  
      /********************/
      for
        select t.NONTAXABLE_VALUE, t.TAXABLE_VALUE, t.TAX_VALUE, t.TAX_NAME
        from   DOC_TAXES t
        where  t.ID_DOC_HEAD = :id_doc
        into   :nontaxable_value, :taxable_value, :tax_value, :tax_name
      do begin
        if (:nontaxable_value <> 0) then begin
          COL_NAME = '@nontaxable';
          COL_ORIG_VALUE = :nontaxable_value;
          COL_VALUE = :nontaxable_value * cast(:DOC_RATE as numeric(15,6)) * :VALUE_CORR_IDX;
          SORT_ORDER = 300;
          suspend;
        end
        if (:taxable_value <> 0) then begin
          COL_NAME = '@taxable';
          COL_ORIG_VALUE = :taxable_value;
          COL_VALUE = :taxable_value * cast(:DOC_RATE as numeric(15,6)) * :VALUE_CORR_IDX;
          SORT_ORDER = 301;
          suspend;
        end
        if (:tax_value <> 0) then begin
          COL_NAME = :tax_name;
          COL_ORIG_VALUE = :tax_value;
          COL_VALUE = :tax_value * cast(:DOC_RATE as numeric(15,6)) * :VALUE_CORR_IDX;
          SORT_ORDER = 302;
          suspend;
        end
      end
      COL_NAME = '@total';
      COL_ORIG_VALUE = :doc_value;
      COL_VALUE = :doc_value * cast(:DOC_RATE as numeric(15,6)) * :VALUE_CORR_IDX;
      SORT_ORDER = 303;
      suspend;
    end
  end
end
^

/* Alter (SPR_HOTEL_REGISTER) */
ALTER PROCEDURE SPR_HOTEL_REGISTER(IN_FROM DATE,
IN_TO DATE,
IN_FROM_GUEST INTEGER,
IN_TO_GUEST INTEGER,
IN_MASK VARCHAR(10),
ID_HOTEL INTEGER = null)
 RETURNS(ID_GUEST INTEGER,
GUEST_NAME VARCHAR(50),
ROOM_NAME VARCHAR(10),
CITIZENSHIP_EGN VARCHAR(65),
PERIOD_FROM DATE,
PERIOD_TO DATE,
NIGHTS INTEGER,
RESERVATION VARCHAR(100),
ID_ACCOUNT_NIGHTS VARCHAR(30),
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
ADDRESS_BULGARIAN VARCHAR(100),
PASSPORT VARCHAR(40),
NOTE VARCHAR(255))
 AS
declare variable EGN varchar(50);
  declare variable COUNTRY_CODE varchar(20);
  declare variable COUNTRY varchar(50);
  declare variable ID_ACCOUNT integer;
  declare variable ADDRESS varchar(100);
  declare variable PASS_NUM varchar(20);
  declare variable PASS_DATE date;
  declare variable MASK varchar(10);
begin
  select
         coalesce((select first 1 cast(:in_mask as varchar(10))
                   from   RIGHTS_USER_GROUPS RUG
                          join RIGHTS_GROUPS_LINES RGL on RGL.ID_RIGHT_GROUP = RUG.ID_RIGHT_GROUP
                   where  RUG.USER_NAME = current_user
                          and RGL.RIGHT_CODE = 'MASK_DIFF_FROM_DEF'),
                  (select iif(coalesce(nullif(cast(:in_mask as varchar(10)), ''), SGV.SETTING_VALUE) is distinct from SGV.SETTING_VALUE, 'unknown', SGV.SETTING_VALUE)
                   from   SETTING_GET_VALUE('DEF_GUEST_MASK', :id_hotel) SGV))
  from dummy
  into :in_mask;
  
  for
    select G.ID_GUEST, GC.GUEST_NAME1, R.ROOM_NAME, GC.COUNTRY, CN.COUNTRY_NAME,
           GC.EGN, G.FROM_DATE, G.TO_DATE, G.ID_ACCOUNT, GC.BIRTH_DAY, GC.BIRTH_PLACE,
           GC.ADDRESS, GC.PASS_NUM, GC.PASS_DATE, GC.MASK, RD.NUMBER
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
           left outer join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
           left outer join ROOMS R on G.ID_ROOM = R.ID_ROOM
           left outer join COUNTRY CN on CN.COUNTRY_CODE = GC.COUNTRY
    where  G.FROM_DATE between :IN_FROM and :IN_TO
           and rd.IS_ANUL = 0
           and RD.CHECK_STATUS >= 0
           and ((RD.ID_HOTEL = :id_hotel) or (:id_hotel is null))
    into   :ID_GUEST, :GUEST_NAME, :ROOM_NAME, :COUNTRY_CODE, :COUNTRY,
           :EGN, :PERIOD_FROM, :PERIOD_TO, :ID_ACCOUNT, :BIRTH_DATE, :BIRTH_PLACE,
           :ADDRESS, :PASS_NUM, :PASS_DATE, :MASK, :RESERVATION
  do begin
    CITIZENSHIP_EGN = :COUNTRY;

    if ((:EGN is not null) and (EGN <> '')) then
      CITIZENSHIP_EGN = :CITIZENSHIP_EGN || ' (' || :EGN || ')';

    if (upper(:COUNTRY_CODE) = 'BG') then begin
      ADDRESS_BULGARIAN = :ADDRESS;
    end else begin
      ADDRESS_BULGARIAN = '';
    end

    if (:PASS_NUM is null) then PASS_NUM = '';
    PASSPORT = :PASS_NUM;
    if (:PASS_DATE is not null and :PASS_DATE <> '30.12.1899') then
      PASSPORT = trim(:PASSPORT || FORMATDATE(:PASS_DATE,'D; dd/mm/yyyy'));

    NIGHTS = :PERIOD_TO - :PERIOD_FROM;
    ID_ACCOUNT_NIGHTS = ''|| :ID_ACCOUNT || ' (' || :NIGHTS || ')';
    NOTE = '';
    if (((:IN_FROM_GUEST is null) or (:ID_GUEST >= :IN_FROM_GUEST))
        and ((:IN_TO_GUEST is null) or (:ID_GUEST <= IN_TO_GUEST))
        and ((:IN_MASK is null) or (:IN_MASK = '') or (:MASK like '%' || :IN_MASK||'%'))) then
      suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: END_WORK for: SUMMARY_FINANCE_SAVE$INT */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (SUMMARY_FINANCE_SAVE$INT) */
ALTER PROCEDURE SUMMARY_FINANCE_SAVE$INT(ID_END_WORK INTEGER)
 AS
declare variable id_hotel integer;
  declare variable summary_date date;
begin
  select EW.ID_HOTEL, EW.PREV_DATE
  from   END_WORKS EW
  where  EW.ID_END_WORK = :ID_END_WORK
  into   :id_hotel, :summary_date;

  /* prepare postings */
  execute procedure ACCOUNT_POSTS_EW_MARK$INT (:ID_END_WORK);

  execute procedure ACCOUNT_DEBT_FILL$INT(:ID_END_WORK);

  insert into SUMMARY_END_WORK (ID_END_WORK, ID_HOTEL, SUMMARY_DATE,
         REVENUE_AMOUNT, CORRECTION_AMOUNT, DOC_TAXES_AMOUNT, VAT_AMOUNT,
         DISCOUNTS_AMOUNT, PAYMENT_AMOUNT, PAYMENT_TRANSACTIONS,
         FISCAL_PAY_AMOUNT, FISCAL_PAY_TRANSACTIONS, DEPOSIT_AMOUNT)
  values (:ID_END_WORK, :ID_HOTEL, :SUMMARY_DATE, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);

  execute procedure REVENUE_EW_SUMMARIZE$INT (:ID_END_WORK, 'full');

  execute procedure PAYMENTS_EW_SUMMARIZE$INT (:ID_END_WORK);

  /* update statistic revenue summary (sections by refenrenes) for previous affected dates */
  execute procedure REVENUE_STATISTIC_REBUILD (:id_hotel, :summary_date - 1);

end
^

/* empty dependent procedure body */
/* Clear: SUMMARY_PREPARE$INT for: SUMMARY_PREPARE_MAIN$INT */
ALTER PROCEDURE SUMMARY_PREPARE$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* Alter (SUMMARY_PREPARE_MAIN$INT) */
ALTER PROCEDURE SUMMARY_PREPARE_MAIN$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
OPTIONS VARCHAR(255))
 RETURNS(BUSY_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_PROFILE_AGENT INTEGER,
COUNTRY_CODE VARCHAR(20),
MARKET_SEGMENT_CODE VARCHAR(3),
SOURCE_CODE VARCHAR(3),
CHANNEL_CODE VARCHAR(3),
HEAR_REASON_CODE VARCHAR(3),
COME_REASON_CODE VARCHAR(3),
ROOMS_SOLD SMALLINT,
ROOMS_SOLD_MULTIPLE_GST SMALLINT,
ROOMS_ARRIVAL SMALLINT,
ROOMS_DEPARTURE SMALLINT,
GUESTS_IN_HOUSE SMALLINT,
GUESTS_ARRIVAL SMALLINT,
GUESTS_DEPARTURE SMALLINT,
GUESTS_DAY_USE SMALLINT)
 AS
declare variable guests_stayover smallint;
  declare variable rooms_stayover smallint;
  declare variable ad_day_use smallint;
  declare variable ch_day_use smallint;
begin
  for
    select RM.BUSY_DATE, RM.ID_ROOM_TYPE, S.ID_PROFILE_AGENT, S.COUNTRY_CODE,
           S.MARKET_SEGMENT_CODE, S.SOURCE_CODE, S.CHANNEL_CODE, S.HEAR_REASON_CODE, S.COME_REASON_CODE,
           sum(RM.GST_AD_STAY + RM.GST_CH_STAY),
           count(distinct iif(RM.DAY_ACTION = 'STAY', RM.ID_ROOM, null)),
           sum(RM.GST_AD_IN + RM.GST_CH_IN),
           count(distinct iif(RM.DAY_ACTION = 'CHECK_IN', RM.ID_ROOM, null)),
           sum(RM.GST_AD_OUT + RM.GST_CH_OUT),
           count(distinct iif(RM.DAY_ACTION = 'CHECK_OUT', RM.ID_ROOM, null)),
           count(distinct iif(RM.DAY_ACTION = 'CHECK_IN' and RM.ADULT_COUNT + RM.CHILDREN_COUNT > 1, RM.ID_ROOM, null))
            + count(distinct iif(RM.DAY_ACTION = 'STAY' and RM.ADULT_COUNT + RM.CHILDREN_COUNT > 1, RM.ID_ROOM, null)),
           --count(distinct iif(RM.ADULT_COUNT + RM.CHILDREN_COUNT > 1, RM.ID_ROOM, null)),
           sum(iif(RM.DAY_ACTION = 'CHECK_IN,CHECK_OUT' and RD.TO_DATE = RM.BUSY_DATE + 1, RM.ADULT_COUNT, 0)),
           sum(iif(RM.DAY_ACTION = 'CHECK_IN,CHECK_OUT' and RD.TO_DATE = RM.BUSY_DATE + 1, RM.CHILDREN_COUNT, 0))
    from   ROOM_MAGIC RM
           left outer join RESERV_DETAIL rd on rd.id_reserv_detail = rm.id_reserv_detail
           left outer join ROOMS_SHARE RS on RS.ID_ROOM_SHARE = RM.ID_ROOM_MAGIC
           left outer join SUMMARY_PREPARE_SLICE$INT(coalesce(RS.ID_RESERV_STATISTICS, RM.ID_RESERV_DETAIL), :options) S on 0=0
    where  RM.BUSY_DATE between :from_date and :to_date
           and RM.ID_HOTEL = :id_hotel
           and RM.BUSY_GROUP_TYPE in (1, 24) -- CHECKIN & RESERVATIONS
           and RM.BUSY_TYPE <> 'VALUE_RESERVS'
           and (coalesce(rd.check_status, 0) >= 0) -- skip non expired, expected bookings
           /*and ((RM.ID_ROOM < 0) or (exists(
               select *
               from   ROOM_PERIOD$PMS P
               where  P.ID_ROOM = RM.ID_ROOM
                      and RM.BUSY_DATE between P.FROM_DATE and P.TO_DATE
                      and P.IS_AVAILABLE = 1)))   */
           and rm.ROOM_STATUS is distinct from 'PRIVATE' -- replace previous clause
    group by 1, 2, 3, 4, 5, 6, 7, 8, 9
    into   :busy_date, :id_room_type, :id_profile_agent, :country_code,
           :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
           :guests_stayover, :rooms_stayover,
           :guests_arrival, :rooms_arrival,
           :guests_departure, :rooms_departure,
           :rooms_sold_multiple_gst, :ad_day_use, :ch_day_use
  do begin
    rooms_sold = :rooms_arrival + :rooms_stayover;
    guests_day_use = coalesce(:ad_day_use, 0) + coalesce(:ch_day_use, 0);
    guests_in_house = :guests_arrival + :guests_stayover - :guests_day_use;

    --guests_arrival = :guests_arrival + :guests_day_use;
    --guests_departure = :guests_departure + :guests_day_use;
    suspend;
  end
end
^

/* Alter (SUMMARY_PREPARE_TOTAL$INT) */
ALTER PROCEDURE SUMMARY_PREPARE_TOTAL$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(BUSY_DATE DATE,
ID_ROOM_TYPE INTEGER,
ROOMS_OOI SMALLINT,
ROOMS_OOO SMALLINT,
ROOMS_SOLD SMALLINT,
ROOMS_SOLD_MULTIPLE_GST SMALLINT,
ROOMS_ARRIVAL SMALLINT,
ROOMS_DEPARTURE SMALLINT,
CH_IN_HOUSE SMALLINT,
CH_ARRIVAL SMALLINT,
CH_DEPARTURE SMALLINT,
AD_IN_HOUSE SMALLINT,
AD_ARRIVAL SMALLINT,
AD_DEPARTURE SMALLINT,
GUESTS_DAY_USE SMALLINT)
 AS
declare variable ad_stayover smallint;
  declare variable ch_stayover smallint;
  declare variable rooms_stayover smallint;
  declare variable ad_day_use smallint;
  declare variable ch_day_use smallint;
begin
  for
    select RM.BUSY_DATE, RM.ID_ROOM_TYPE,
           count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 18 and coalesce(RS.DAY_ACTION, RM.DAY_ACTION) not containing 'CHECK_OUT', RM.ID_ROOM, null)),
           count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 20 and coalesce(RS.DAY_ACTION, RM.DAY_ACTION) not containing 'CHECK_OUT', RM.ID_ROOM, null)),

           sum(iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.GST_AD_STAY, 0)),
           sum(iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.GST_CH_STAY, 0)),
           count(distinct iif(coalesce(RS.DAY_ACTION, RM.DAY_ACTION) = 'STAY' and coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.ID_ROOM, null)),

           sum(iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.GST_AD_IN, 0)),
           sum(iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.GST_CH_IN, 0)),
           count(distinct iif(coalesce(RS.DAY_ACTION, RM.DAY_ACTION) = 'CHECK_IN' and coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.ID_ROOM, null)),
                                                                   
           sum(iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.GST_AD_OUT, 0)),
           sum(iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.GST_CH_OUT, 0)),
           count(distinct iif(coalesce(RS.DAY_ACTION, RM.DAY_ACTION) = 'CHECK_OUT' and coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.ID_ROOM, null)),

           count(distinct iif((coalesce(RS.DAY_ACTION, RM.DAY_ACTION) in ('STAY', 'CHECK_IN')) and (RM.ADULT_COUNT+RM.CHILDREN_COUNT > 1) and coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 24, RM.ID_ROOM, null)),
           sum(iif(RM.DAY_ACTION = 'CHECK_IN,CHECK_OUT' and RD.TO_DATE = RM.BUSY_DATE + 1, RM.ADULT_COUNT, 0)),
           sum(iif(RM.DAY_ACTION = 'CHECK_IN,CHECK_OUT' and RD.TO_DATE = RM.BUSY_DATE + 1, RM.CHILDREN_COUNT, 0))
    from   ROOM_MAGIC RM
           left outer join RESERV_DETAIL rd on rd.id_reserv_detail = rm.id_reserv_detail
           left outer join ROOMS_SHARE RS on RS.ID_ROOM_SHARE = RM.ID_ROOM_MAGIC
    where  RM.BUSY_DATE between :from_date and :to_date
           and RM.ID_HOTEL = :id_hotel
           and RM.BUSY_TYPE <> 'VALUE_RESERVS'
           and (coalesce(rd.check_status, 0) >=0)
           /*and ((RM.ID_ROOM < 0) or (exists(
               select *
               from   ROOM_PERIOD$PMS P
               where  P.ID_ROOM = RM.ID_ROOM
                      and RM.BUSY_DATE between P.FROM_DATE and P.TO_DATE
                      and P.IS_AVAILABLE = 1)))  */
           and rm.ROOM_STATUS is distinct from 'PRIVATE' -- replace previous clause
    group by 1, 2
    into   :busy_date, :id_room_type,
           :rooms_ooo,
           :rooms_ooi,
           :ad_stayover, :ch_stayover, :rooms_stayover,
           :ad_arrival, :ch_arrival, :rooms_arrival,
           :ad_departure, :ch_departure, :rooms_departure,
           :rooms_sold_multiple_gst, :ad_day_use, :ch_day_use
  do begin
    rooms_sold = :rooms_arrival + :rooms_stayover;

    guests_day_use = coalesce(:ad_day_use, 0) + coalesce(:ch_day_use, 0);

    ad_in_house = :ad_arrival + :ad_stayover - :ad_day_use;
    ch_in_house = :ch_arrival + :ch_stayover - :ch_day_use;

    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_INPUT_RESERV$INT for: TAR_CALC_GET_GUESTS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_RESERV$INT(ID_RESERV_DETAIL INTEGER,
ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
ID_TEST_RATE INTEGER = null)
 AS
 BEGIN EXIT; END
^

/* Alter (TAR_CALC_GET_GUESTS$INT) */
ALTER PROCEDURE TAR_CALC_GET_GUESTS$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_GUEST INTEGER,
ID_TARIFF_CALC INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
G_DBKEY CHAR(8))
 AS
declare variable dbg varchar(2000);
declare variable share_status integer;
declare variable shared_reservations varchar(1024);
declare variable id_shared_detail integer;
declare variable unshared_reservations varchar(1024);
declare variable id_unshared_detail integer;
declare variable incremental_guest_list varchar(2000);
begin
  incremental_guest_list = ','; /*using for not suspend dublicated guests - otherwise calculations are wrong*/
  for
    select G.ID_GUEST, G.ID_TARIFA, G.FROM_DATE, G.TO_DATE, G.RDB$DB_KEY
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  Rd.ID_RESERV_DETAIL = :id_reserv_detail
           and rd.IS_ANUL = 0
    into   :id_guest, :id_tariff_calc, :from_date, :to_date, :g_dbkey
  do begin
    suspend;
    incremental_guest_list = :incremental_guest_list || :id_guest ||',';
  end

/*  execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'ENUM_SHARES', null)*/
  execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'FOR_RECALC', null)
  returning_values  :share_status, :shared_reservations, :dbg;
  execute procedure sys_dbg('calc TAR_CALC_GET_GUESTS$INT shared_reservations = '||coalesce(:shared_reservations, 'null'));

  if (:share_status = 1) then begin
    for
      select SP.ITEM
      from   SYSTEM_STRING_PARSER(:shared_reservations, ',') SP
      into   :id_shared_detail
    do begin
      for
        select G.ID_GUEST, G.ID_TARIFA, G.FROM_DATE, G.TO_DATE, G.RDB$DB_KEY
        from   GUEST G
        where  G.ID_RESERV_DETAIL = :id_shared_detail
        into   :id_guest, :id_tariff_calc, :from_date, :to_date, :g_dbkey
      do begin
        if (:incremental_guest_list not containing ','||:id_guest||',' ) then begin
          suspend;
          incremental_guest_list = :incremental_guest_list || :id_guest ||',';
        end
      end
    end
  end

  execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'ENUM_EX_SHARES', null)
  returning_values  :share_status, :unshared_reservations, :dbg;

  execute procedure sys_dbg('calc TAR_CALC_GET_GUESTS$INT unshared_reservations = '||coalesce(:unshared_reservations, 'null'));
  execute procedure sys_dbg('calc TAR_CALC_GET_GUESTS$INT incremental_guest_list = '||coalesce(:incremental_guest_list, 'null'));

  if (:unshared_reservations <> '') then begin
    for
      select SP.ITEM
      from   SYSTEM_STRING_PARSER(:unshared_reservations, ',') SP
      into   :id_unshared_detail
    do begin
      for
        select G.ID_GUEST, G.ID_TARIFA, G.FROM_DATE, G.TO_DATE, G.RDB$DB_KEY
        from   GUEST G
        where  G.ID_RESERV_DETAIL = :id_unshared_detail
        into   :id_guest, :id_tariff_calc, :from_date, :to_date, :g_dbkey
      do begin
        if (:incremental_guest_list not containing ','||:id_guest||',' ) then begin
          suspend;
          incremental_guest_list = :incremental_guest_list || :id_guest ||',';
        end
        execute procedure sys_dbg('calc TAR_CALC_GET_GUESTS$INT incremental_guest_list2 = '||coalesce(:incremental_guest_list, 'null'));
      end
    end
  end
end
^

/* Alter (TAR_CALC_INPUT_DETAILS$INT) */
ALTER PROCEDURE TAR_CALC_INPUT_DETAILS$INT(ID_TAR_CALC INTEGER,
ID_TEST_RATE INTEGER = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_input integer;
  declare variable id_guest integer;
/****************************************/
  declare variable for_date date;
  declare variable id_room_type integer;
  declare variable id_board integer;
  declare variable id_type_stay integer;
  declare variable is_manual_type_stay integer;
  declare variable checkin_order integer;
  declare variable id_calc_tariff integer;
  declare variable id_room integer;
begin
  err_code = 0;
  err_text = '';
  ID_TEST_RATE = nullif(:ID_TEST_RATE, -1);
  for
    select TCI.ID_TAR_INPUT, TCI.ID_GUEST, LP.OUT_DATE,
           GS.ID_BOARD, coalesce(:ID_TEST_RATE, GS.ID_RATE), GS.ID_ROOM,
           gs.ID_TYPE_STAY, gs.ID_ROOM_TYPE, gs.IS_MANUAL_TYPE_STAY
    from   TAR_CALC_INPUT$TMP TCI
           join GUEST G on G.ID_GUEST = TCI.ID_GUEST
           left join SYSTEM_LOOP_PERIOD (TCI.FROM_DATE_CALC, TCI.TO_DATE_CALC) LP on 1=1
           left join GUEST_GET_STAY_CONDITIONS$INT (g.ID_GUEST, lp.OUT_DATE) GS on 1=1
    where  TCI.ID_TAR_CALC = :id_tar_calc
    order by g.ID_GUEST asc, LP.OUT_DATE asc
    into   :id_tar_input, :id_guest, :for_date,
           :id_board, :id_calc_tariff, :id_room,
           :id_type_stay, :id_room_type, :is_manual_type_stay
  do begin
    checkin_order = :id_guest;
    insert into TAR_CALC_INPUT_DETAIL$TMP (
      ID_TAR_INPUT, FOR_DATE, ID_TAR_HEAD, ID_BOARD, ID_ROOM,
      ID_ROOM_TYPE, ID_TYPE_STAY, IS_MANUAL_TYPE_STAY, CHECKIN_ORDER,
      SEPARATE_BOARD, ID_BOARD_INCLUDE, param_values)
    values (
      :id_tar_input, :for_date, :id_calc_tariff, :id_board, :id_room,
      :id_room_type, :id_type_stay, :is_manual_type_stay,
      :checkin_order, 0, null, '');
    /* get date dependent params */
  end

  execute procedure TAR_CALC_INPUT_PARAMS$INT (:ID_TAR_CALC)
  returning_values (:ERR_CODE, :ERR_TEXT);
  if (:ERR_CODE < 0) then exit;
  /*handle costom prices by days or single one*/
  execute procedure TAR_INPUT_RES_CUSTOMPRICE$INT(:id_tar_calc);

  execute procedure TAR_INPUT_ISSTATICK$INT(:id_tar_calc);
end
^

/* empty dependent procedure body */
/* Clear: RES_RECALC$INT for: TAR_CALC_INPUT_RESERV$INT */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_TEST$TAR for: TAR_CALC_INPUT_RESERV$INT */
ALTER PROCEDURE TAR_TEST$TAR(NUMBER VARCHAR(62),
ID_TAR_HEAD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_INPUT_RESERV$INT) */
ALTER PROCEDURE TAR_CALC_INPUT_RESERV$INT(ID_RESERV_DETAIL INTEGER,
ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
ID_TEST_RATE INTEGER = null)
 AS
declare variable id_guest integer;
  declare variable g_dbkey char(8);
  declare variable from_date date;
  declare variable to_date  date;
  declare variable id_tariff_calc integer;
  declare variable err_code integer;
  declare variable err_text varchar(25);
begin
  for
    select G.ID_GUEST, G.ID_TARIFF_CALC, G.FROM_DATE, G.TO_DATE, G.G_DBKEY
    from   TAR_CALC_GET_GUESTS$INT(:id_reserv_detail) G
    into   :id_guest, :id_tariff_calc, :from_date, :to_date, :g_dbkey
  do begin
    execute procedure sys_dbg('calc RES_RECALC$INT input guest_id '|| :id_guest || ', from:' || :from_date || ', to:' ||  :to_date);

    execute procedure TAR_CALC_INPUT_GUEST$INT(:id_tar_calc, :room_status, :g_dbkey, :id_tariff_calc, 1);
  end

  -- 3. RECALCULATING DEPENDING ON THE TARIFF KIND
  execute procedure TAR_CALC_INPUT_DETAILS$INT(:id_tar_calc, :ID_TEST_RATE)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exception RATING_PREPARE_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
end
^

/* Alter (TAR_TEST$TAR) */
ALTER PROCEDURE TAR_TEST$TAR(NUMBER VARCHAR(62),
ID_TAR_HEAD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_reserv_detail integer;
begin
  id_tar_calc = -1 * :id_tar_head;
  delete from TAR_CALC_OUTPUT$TMP where id_tar_calc = :id_tar_calc;
  delete from TAR_CALC_INPUT$TMP  where id_tar_calc = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP  where id_tar_calc = :id_tar_calc;

  err_code = 0;

  id_reserv_detail = null;
  select RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.NUMBER = :number
  into   :id_reserv_detail;

  if (:id_reserv_detail is null) then begin
    select first 1 RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.NUMBER_2 = :number
    into   :id_reserv_detail;
  end

  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NEW_ROOM', :ID_TAR_HEAD);

  execute procedure TAR_CALC_EVAL_ALL$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_PARAMS$INT for: TARIFA_GET_PARAM */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TARIFA_GET_PARAM) */
ALTER PROCEDURE TARIFA_GET_PARAM(ID_PARAM INTEGER,
FOR_DATE DATE,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER)
 RETURNS(OUT_VALUE VARCHAR(255))
 AS
declare variable is_interface integer;
  declare variable param_code varchar(30);
  declare variable is_value integer;
  declare variable int1 integer;
  declare variable data_type varchar(10);
  declare variable pvalue varchar(20);
  declare variable from_ date;
  declare variable to_ date;
begin
  select TP.IS_INTERFACE, TP.PARAM_CODE, TP.IS_VALUE, TP.DATA_TYPE, TP.PVALUE
  from   TARIFA_PARAMS TP
  where  ID_TARIFA_PARAM = :ID_PARAM 
  into   :is_interface, :param_code, :is_value, :data_type, :pvalue;
  /*get interface params*/
  if (:PARAM_CODE = 'NATION2') then
    PARAM_CODE = 'NATION'; /* !!!!!!!!!! */

  /*get value params*/
  if (:IS_VALUE = 1) then
    OUT_VALUE = :pvalue;

  /*get internal params*/
  OUT_VALUE = null;
  if (:IS_INTERFACE = 0) then begin
    if (:PARAM_CODE = 'TODAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE, 'D;dd/mm/yyyy');

    end else if (:PARAM_CODE = 'WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE, 'DW;MON');

    end else if (:PARAM_CODE = 'NEXT_DATE_WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE + 1, 'DW;MON');

    end else if (:PARAM_CODE = 'PREV_DATE_WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE - 1, 'DW;MON');

    end else if (:PARAM_CODE = 'REQUIRED_WEEK_DAYS') then begin
      select maxdate(ti.FROM_DATE, :FOR_DATE -3), mindate(ti.TO_DATE -1, :FOR_DATE +3)
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :from_, :to_;
      
      for
        select formatdate(RLP.OUT_DATE, 'DW;MON')
        from   SYSTEM_LOOP_PERIOD(:from_, :to_) RLP
        into   :int1
      do OUT_VALUE = :OUT_VALUE||','||:int1;

    end else if (:PARAM_CODE = 'ARRIVAL_WEEK_DAYS') then begin
      select formatdate(ti.FROM_DATE, 'DW;MON')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'PRESTOI') then begin
      select cast(ti.TO_DATE - ti.FROM_DATE as integer)
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'FROM_DATE') then begin
      select formatdate(ti.FROM_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TO_DATE') then begin
      select formatdate(ti.TO_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'DAYS_PASSED') then begin
       /* 01  03 -  01-1, 02-2   (        )*/   
       select cast((:FOR_DATE - G.FROM_DATE + 1) as integer)
       from   TAR_CALC_INPUT$TMP G
       where  G.ID_TAR_INPUT = :ID_TAR_INPUT
       into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'DAYS_TO_STAY') then begin
       /* 01  03 -  01-2, 02-1    (  )*/
       select cast((G.TO_DATE - :FOR_DATE - 1) as integer)
       from   TAR_CALC_INPUT$TMP G
       where  G.ID_TAR_INPUT = :ID_TAR_INPUT
       into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_GUESTS') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_CHILDREN') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.IS_CHILD = 1
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_ADULTS') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.IS_CHILD is distinct from 1
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_GUESTS_BY_ACCOUNT') then begin
      select (select count(*)
              from   GUEST G
                     join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
              where  G.ID_BASE_ACCOUNT = ti.ID_BASE_ACCOUNT
                     and G.FROM_DATE <= :FOR_DATE
                     and G.TO_DATE > :FOR_DATE
                     and RD.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP ti
      where  ti.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TYPE_ROOM') then begin
      select rt.TYPE_ROOM
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join ROOM_TYPES RT on RT.ID_ROOM_TYPE = tid.ID_ROOM_TYPE
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
      into   :OUT_VALUE;
      /* TO PRESEVE COMPATIBILITY WITH OLD TARIFF VERSIONS */
      /* WE HAVE TO RETURN THE NAME NOT THE ID !           */

    end else if (:PARAM_CODE = 'TYPE_STAY') then begin
      select ts.TYPE_STAY
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join TYPE_STAY TS on ts.ID_TYPE_STAY = tid.ID_TYPE_STAY
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TYPE_HRANA') then  begin
      select m.NAME
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join MEALS m on m.ID_BOARD = tid.ID_BOARD
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;
      OUT_VALUE = trim(coalesce(:OUT_VALUE, ''));

    end else if (:PARAM_CODE = 'PACK_ITEMS') then begin
      OUT_VALUE = null;
      select TID.PACKET_ITEMS
      from   TAR_CALC_INPUT$TMP TID
      where  TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;
      OUT_VALUE = coalesce(:OUT_VALUE, '~~');
      -- strfloateval('POS("~2~", :PACK_ITEMS)>0', ';:PACK_ITEMS,STRING,~2~3~D~')

    end else if (:PARAM_CODE = 'AGE') then begin
      select ti.GUEST_AGE
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_SEX') then begin
      select G.GUEST_SEX
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE ;
      if ((:OUT_VALUE is null) or (:OUT_VALUE = '')) then OUT_VALUE = '-' ;

    end else if (:PARAM_CODE = 'NATION') then begin
      select tid.COUNTRY_CODE
      from   TAR_CALC_INPUT$TMP TID
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_FIRST_DATE') then begin
      select cast(iif(G.FROM_DATE = :FOR_DATE, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_LAST_DATE') then begin
      select cast(iif(G.TO_DATE -1 = :FOR_DATE, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_LATE_CHECKOUT') then begin
      select g.IS_LATE_CHECKOUT
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_FIRST_GUEST_IN_ROOM') then begin
      select (select count(ti.ID_TAR_INPUT)
              from   TAR_CALC_INPUT$TMP ti
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and ti.ID_GUEST < t.ID_GUEST)
      from   TAR_CALC_INPUT$TMP t
      where  t.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :int1;

      if (:int1 = 0) then OUT_VALUE = 1; else OUT_VALUE = 0;
      
    end else if (:PARAM_CODE = 'IS_DIFER_NATIONS') then begin
      select (select cast(iif(count(distinct ti.COUNTRY_CODE) > 1, 1, 0) as integer)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_GROUP') then begin
      select cast(iif(g.ID_GROUP is not null, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_NIGHTS_BY_ACCOUNT') then begin
      /*          . */
      select (select cast(sum (G_IN_R.TO_DATE - G_IN_R.FROM_DATE) as integer)
              from   GUEST G_IN_R
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_R.ID_RESERV_DETAIL
              where  G_IN_R.ID_BASE_ACCOUNT = G.ID_BASE_ACCOUNT
                     and G_IN_R.CHECK_STATUS = 0
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_INTURN_BYACCOUNT') then begin
      select (select cast(count(G.ID_GUEST) as integer)
              from   GUEST G
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL and rd.IS_ANUL = 0
              where  G.ID_BASE_ACCOUNT = t.ID_BASE_ACCOUNT
                     and G.ID_GUEST <= t.ID_GUEST)
      from   TAR_CALC_INPUT$TMP t
      where  t.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'PAX_PRICE_WO_ADDINS') then begin
      /*             */
      /* PRICE_ORIG          */
      -- ?????    ???
      /*select  max(AP.PRICE_ORIG)
      from    ACCOUNT_POST AP 
      where   AP.ID_GUEST = :ID_GUEST
              and AP.DATE_POST = :FOR_DATE
              and AP.IS_BASE = 1
      plan    (AP index (ACCOUNT_POST_IDX6))
      into    :OUT_VALUE;
      */
      OUT_VALUE = null;

    end else if (:PARAM_CODE = 'ROOM_FEATURES') then begin
      select substring(R.FEATURES from 1 for 255)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join ROOMS R on r.ID_ROOM = tid.ID_ROOM
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_NIGHTS') then begin
      select (select cast(sum (G_IN_V.TO_DATE - G_IN_V.FROM_DATE) as integer)
              from   GUEST G_IN_V
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_V.ID_RESERV_DETAIL
              where  rd.ID_AGENT_PROFILE is not distinct from G.ID_AGENT_PROFILE
                     and G_IN_V.VAUCHER_NUM = G.VOUCHER_NUM
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE ;

    end else if (:PARAM_CODE = 'VAUCHER_GUESTS') then begin
      select (select count (G_IN_V.ID_GUEST)
              from   GUEST G_IN_V
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_V.ID_RESERV_DETAIL and rd.IS_ANUL = 0
              where  rd.ID_AGENT_PROFILE is not distinct from G.ID_AGENT_PROFILE
                     and G_IN_V.VAUCHER_NUM = G.VOUCHER_NUM
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_DATE') then begin
      select formatdate(G.VOUCHER_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_TEXT') then begin
      select G.VOUCHER_TEXT
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_INTURN_BYROOM') then begin
      select (select count(*)
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_GUEST <= t.ID_GUEST)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'ADULT_INTURN_BYROOM') then begin
      OUT_VALUE = 0;
      select (select count(*)
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_GUEST <= t.ID_GUEST
                     and ti.IS_CHILD = 0)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
             and t.IS_CHILD = 0
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'CHILD_INTURN_BYROOM') then begin
      OUT_VALUE = 0;
      select (select count(*)
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_GUEST <= t.ID_GUEST
                     and ti.IS_CHILD = 1)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
             and t.IS_CHILD = 1
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_TYPE') then begin
      select G.ID_GUEST_TYPE
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else begin
      exception RATING_EXCEPTION 'Unsupported param - '||:PARAM_CODE;
    end

  end /*PART OF INTERNAL PARAMS*/


  /**********************************************/
  begin
    /* the source of the next check is gone with the wind
    /* but we must distinguish different data types */
    if ((:OUT_VALUE is null) or (:OUT_VALUE = '')) then begin
      /*not allow nulls*/
      if (:DATA_TYPE = 'DATE') then OUT_VALUE = '01/01/1899';
      else OUT_VALUE = '-1';  -- Unspecified
    end else if (:DATA_TYPE = 'INTEGER') then begin
      OUT_VALUE = cast(:OUT_VALUE as integer);
      /* to prevent errors like OUT_VALUE = '00001' */
    end

    when any do exception RATING_EXCEPTION 'Unsupported param value: ' || :param_code || ' = "' || coalesce(:OUT_VALUE, '<null>') || '"';
  end
  /**********************************************/
end
^

/* Alter (TEST_DOC) */
ALTER PROCEDURE TEST_DOC(ID_ACCOUNT INTEGER,
DOC_SELECTED INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER)
 AS
declare variable is_dep_doc integer;
  declare variable id_hotel integer;
  declare variable dummy varchar(255);
begin
  is_dep_doc = 0;

  execute procedure DOCUMENT_INITIALIZE$DOC (:id_account, :doc_selected, null)
  returning_values (:id_doc_head, :id_hotel);

  execute procedure DOCUMENT_ADD_DEF_PAYMENT$DOC (:id_doc_head, null);

  execute procedure DOCUMENT_VALIDATE$DOC (:id_doc_head)
  returning_values :dummy, :dummy, :dummy;
  suspend;
end
^

/* Alter (TEST_RATING) */
ALTER PROCEDURE TEST_RATING RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
declare variable from_date date;
 declare variable to_date date;
 declare variable hotels varchar(255);
begin
  from_date = '01.01.2010';
  to_date = '08.01.2010';
  hotels = '2';

  execute procedure AVAILABILITY_OCCUPANCY$INT (:from_date,  :from_date + 30, 1, 0, 1, 1, 0, 0, 0, :hotels);

  execute procedure AVAILABILITY_OCCUPANCY_OPT$INT (0, 0, 1, 1, 0, 0, 0);

  execute procedure AVAILABILITY_RATING$AVL (null, :from_date, :to_date, 2,
          2, 0, '33,31,55,30,32,54,62,59,71,72', '2301,2210,2347,1633,2300,2342,2353,2362', '6,0,8,7,22,21,23', :hotels)
  returning_values (:ID_OCCUPANCY_SESSION);

end
^

/* empty dependent procedure body */
/* Clear: IMPORT_BOOKING$EXC for: UPDATE_BOOKING$EXC */
ALTER PROCEDURE IMPORT_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(250),
MAINTANCE_SHEMA VARCHAR(30),
POSTING_ROUTING VARCHAR(20),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
COMPLIMENTARY_ACCOUNT VARCHAR(50),
EATING_OBJECT VARCHAR(50),
CREATE_DATETIME TIMESTAMP)
 RETURNS(HOTEL_ID INTEGER,
BOOKING_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (UPDATE_BOOKING$EXC) */
ALTER PROCEDURE UPDATE_BOOKING$EXC(BOOKING_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE INTEGER,
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA_ID INTEGER,
POSTING_ROUTING VARCHAR(20),
ID_AGENT_ACCOUNT INTEGER,
RATE_ID INTEGER,
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD_CODE TFOOD_CODE,
ARRANGER_PROFILE_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable hotel_id integer;
  declare variable warn_code integer;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable rd_dbkey char(8);
  declare variable current_status_code smallint;
BEGIN
  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => START(' || :booking_id || ')');

  select RD.RDB$DB_KEY, RD.ID_HOTEL, RD.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :booking_id
  into  :rd_dbkey, :hotel_id, :current_status_code;

  execute procedure update_posting_transaction$exc(:rd_dbkey, :posting_transaction_uuid, 0);

  /* lock all guests */
  update guest set ORPHANED_IMPORT$EXC=1 where id_reserv_detail=:booking_id;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_GUARANTEE$RSV');
  execute procedure RES_SAVE_GUARANTEE$RSV(
    :booking_id, :is_vip, :current_status_code, :id_guarantee_policy,
    :deposit_required, :deposit_required_currency, :block_cc,
    :guarantee_deposit_percent, :guarantee_deposit_nights, :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_STAY$RSV');
  execute procedure RES_SAVE_STAY$RSV(
    :booking_id, :arrival, :departure, :is_late_departure,
    :arrival_type, 0
  ) returning_values :share_err_code, :err_text, :share_transaction_id, :warn_code;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_BOARD$INT');
  execute procedure RES_SAVE_BOARD$INT(
    :rd_dbkey, :board_id
  ) ;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_OTHER$RSV');
  execute procedure RES_SAVE_OTHER$RSV(
    :booking_id, :transfer_in_time, :transfer_in_note,
    :transfer_out_time, transfer_out_note, :first_food_code
  ) ;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_ROOM$EXC(room_type_id=>' || coalesce(:room_type_id, '<null>') || ')');
  execute procedure RES_SAVE_ROOM$EXC(
    :rd_dbkey, :room_type_id, :maintance_shema_id, :room_preferences, :special_treatment, :split_on_checkin
  ) returning_values :err_text, :warn_code, :share_transaction_id, :share_err_code;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_MARKETING$RSV');
  execute procedure RES_SAVE_MARKETING$RSV(
    :booking_id, :marketing1_id, :marketing2_id, :marketing3_id, :marketing4_id, :marketing5_id
  ) returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_RATE$RSV(:rate_id=>'
  || coalesce(:rate_id, '<null>')
  || ', :booking_id=>' || coalesce(:booking_id, '<null>')
  || ', :manual_price=>' || coalesce(:manual_price, '<null>')
  || ', :manual_price_currency=>' || coalesce(:manual_price_currency, '<null>')
  || ', :is_different_rate=>' || coalesce(:is_different_rate, '<null>')
  || ')');
  execute procedure RES_SAVE_RATE$RSV(
    :booking_id, :rate_id, :manual_price, :manual_price_currency,
    :is_different_rate, :is_different_price, 0
  );

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_VOUCHER$RSV');
  execute procedure RES_SAVE_VOUCHER$RSV(
    :booking_id, :voucher, :voucher_date, :voucher_text, null,  null
  );

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_NOTE$RSV');
  execute procedure RES_SAVE_NOTE$RSV(
    :booking_id, :note, :note_reminders);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_ACCOUNTING$RSV(arranger_profile_id=>'
    || coalesce(:arranger_profile_id, '<null>')
    || ', posting_routing=>' || coalesce(:posting_routing, '<null>')
    || ', id_agent_account=>' || coalesce(:id_agent_account, '<null>')
    || ')');
  execute procedure RES_SAVE_ACCOUNTING$INT(
    :rd_dbkey, :arranger_profile_id,
    :id_agent_account,
    :posting_routing,
    :guest_payment_type_id,
    :arranger_payment_type_id,
    :reserv_group_id
  ) ;

  /*execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_PACKET$RSV');
  execute procedure RES_SAVE_PACKET$RSV(
    :booking_id, :packet_id, 0
  );
  */
  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_EATING_OBJECT$RSV');
  execute procedure RES_SAVE_EATING_OBJECT$RSV(:booking_id, :id_eating_object);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => END(' || :booking_id || ')');
END
^

/* Restore proc. body: ACCOUNT_BALANCE$INT */
ALTER PROCEDURE ACCOUNT_BALANCE$INT(ID_ACCOUNT INTEGER,
EW_INCL_ONLY SMALLINT = 0)
 RETURNS(ACCOUNT_CURR CHAR(3),
CURR_DISPLAY_FORMAT VARCHAR(10),
ACCOUNT_BALANCE NUMERIC(15,4),
POST_VALUE NUMERIC(15,4),
DEP_VALUE NUMERIC(15,4),
DEP_MONEY_BAG VARCHAR(255),
OPEN_CHARGES INTEGER)
 AS
declare variable dep_curr_value numeric(15,4);
  declare variable dep_curr varchar(3);
  declare variable round_to numeric(15,4);
  declare variable open_charges_int integer;
  declare variable cached_balances integer;
begin
  select A.ACCOUNT_CURR, C.ROUND_TO, C.DISPLAY_FORMAT
  from   ACCOUNT A
         join CURRS C on C.CURR = A.ACCOUNT_CURR
  where  A.ID_ACCOUNT = :id_account
  into   :account_curr, :round_to, :curr_display_format;

  account_balance = null;
  if (:EW_INCL_ONLY is distinct from 1) then begin
    select count(*),
           min(AC.ACCOUNT_BALANCE), min(AC.POST_VALUE), min(AC.DEP_VALUE),
           min(AC.DEP_MONEY_BAG), min(AC.OPEN_CHARGES)
    from   ACCOUNT_BALANCE_CACHE AC
    where  AC.ID_ACCOUNT = :id_account
    into   :cached_balances,
           :account_balance, :post_value, :dep_value, :dep_money_bag, :open_charges;
  
    if (:cached_balances <> 1) then account_balance = null;
  --    execute procedure ACCOUNT_BALANCE_INVALIDATE$INT (:id_account);
  end

  if (:account_balance is null) then begin
    account_balance = 0;
    post_value = 0;
    dep_value = 0;
    dep_money_bag = '';
    open_charges = 0;
    for
      select :POST_VALUE + round_f(AB.POST_BAL_VALUE, :round_to), :DEP_VALUE + round_f(AB.DEP_BAL_VALUE, :round_to),
             AB.DEP_ORIG_VALUE, AB.CURR_ORIG, AB.OPEN_CHARGES
      from   ACCOUNT_CURR_BALANCE$INT (:id_account, :account_curr, :ew_incl_only) AB
      into   :post_value, :dep_value, :dep_curr_value, :dep_curr, :open_charges_int
    do begin
      if (:open_charges_int = 1) then open_charges = 1;
      if (:dep_curr is not null and :dep_value > 0) then
        dep_money_bag = :dep_money_bag || formatfloat (:dep_curr_value, :curr_display_format) || ' ' || :dep_curr || ';';
    end
    account_balance = :post_value - :dep_value;

    if (:EW_INCL_ONLY is distinct from 1) then begin
      execute procedure ACCOUNT_BALANCE_CACHE$INT(:id_account, :account_balance, :post_value, :dep_value, :dep_money_bag, :open_charges);
    end
  end

  suspend;
end
^

/* Restore proc. body: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER)
 AS
declare variable id_current_account integer;
  declare variable id_service integer;
  declare variable is_anul integer;
  declare variable id_tariff integer;
  declare variable qty_post numeric(15,2);
  declare variable qty_free numeric(15,2);
  declare variable price_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable id_room integer;
  declare variable id_base_doc integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  if ((:AP_DBKEY is null) or (:id_target_account is null) or (:id_target_account < 0)) then
     exception POSTING_TRANSFER_EXCEPTION '-31';

  select AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST, AP.QTY_FREE,
         AP.PRICE_ORIG, AP.CURR_ORIG, AP.RATE_ORIG, ap.from_date, ap.to_date,
         AP.IS_ANUL, AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_BASE_DOC, A.ID_HOTEL
  from   ACCOUNT_POST AP
         left join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :id_service, :id_tariff, :id_room, :qty_post, :qty_free,
         :price_orig, :curr_orig, :rate_orig, :from_date, :to_date,
         :is_anul, :id_account_post, :id_current_account, :id_base_doc, :id_hotel;

  if (:id_current_account = :id_target_account) then EXIT;

  if (:is_anul = 1 ) then exception POSTING_TRANSFER_EXCEPTION '-33';

  if (:id_base_doc is not null) then exception POSTING_TRANSFER_EXCEPTION '-32';

  if (not exists(select A.ID_ACCOUNT
                 from   ACCOUNT A
                 where  A.ID_ACCOUNT = :ID_TARGET_ACCOUNT
                        and A.ID_HOTEL = :id_hotel)) then exception POSTING_TRANSFER_EXCEPTION '-376';

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_target_account, :id_service,
                    :id_tariff, :id_room, :qty_post, :qty_free, :price_orig, :curr_orig,
                    :rate_orig, 'TRANSFER_POSTING', null, :from_date, :to_date)
  returning_values  :no_use, :no_use, :no_use;

  insert into ACCOUNT_TRANSFER_HISTORY(ID_ACCOUNT_POST, FROM_ID_ACCOUNT, TO_ID_ACCOUNT)
  values (:id_account_post, :id_current_account, :id_target_account);
end
^

/* Restore proc. body: ACCOUNT_POSTING_UPDATE */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable in_db_key char(8);
begin
  /* GUI facade for manual update */
  select AP.ID_ACCOUNT, AP.ID_GUEST, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :id_guest, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :id_account, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date)
  returning_values  (:new_qty_post, :new_price_post, :new_ac);

  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    if (coalesce(:id_guest, 0) > 0) then begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || :id_account
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'POST_UPDATE', :action_text);
    end else begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
    end
  end

end
^

/* Restore proc. body: ALLOTMENT_PHYS_REBUILD$INT */
ALTER PROCEDURE ALLOTMENT_PHYS_REBUILD$INT(IN_ID_HOTEL INTEGER = null,
IN_ID_ROOM_TYPE INTEGER = null)
 AS
declare variable dbg varchar(2000);
  declare variable id_physical_allotment integer;
  declare variable ifrom_date date;
  declare variable ito_date date;
  declare variable icnt_rooms integer;
  declare variable id_allotment_session integer;
  declare variable id_room_type integer;
begin
  for
    select RT.ID_ROOM_TYPE, H.ID_PHYSICAL_ALLOTMENT
    from   HOTEL H
           join ROOM_TYPES RT on RT.ID_HOTEL = H.ID_HOTEL
    where  ((:in_id_hotel is null) or (H.ID_HOTEL = :in_id_hotel))
           and ((:in_id_room_type is null) or (RT.ID_ROOM_TYPE = :in_id_room_type))
    into   :id_room_type, :id_physical_allotment
  do begin
    delete from ALLOTMENT_DETAIL AD
    where  AD.ID_ALLOTMENT = :id_physical_allotment
           and AD.ID_ROOM_TYPE = :id_room_type;
  
    id_allotment_session = gen_id(GEN_ALLOTMENT_SESSION_ID, 1);
    for
      select RP.FROM_DATE, RP.TO_DATE, RP.IS_AVAILABLE
      from   ROOM_PERIOD$PMS RP
             join ROOMS R on R.ID_ROOM = RP.ID_ROOM
      where  R.ID_ROOM_TYPE = :id_room_type
      order by RP.FROM_DATE desc, RP.TO_DATE desc
      into   :ifrom_date, :ito_date, :icnt_rooms
    do begin
      execute procedure ALLOTMENT_TMP_SET$INT(:id_allotment_session, :id_physical_allotment, :id_room_type, :ifrom_date, :ito_date, :icnt_rooms, 0, 0, 1);
    end
  
    execute procedure ALLOTMENT_TMP_GET$INT(:id_allotment_session, 'ROOMS');
  end
end
^

/* Restore proc. body: ALLOTMENT_SET_DAYS$INT */
ALTER PROCEDURE ALLOTMENT_SET_DAYS$INT(ID_ALLOTMENT INTEGER,
ID_ROOM_TYPE INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ACTIVE_FRAME_BEGIN INTEGER,
ACTIVE_FRAME_END INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_allotment_session integer;
begin
  if (:to_date < :from_date) then exception WRONG_VALUE 'Wrong period';

  id_allotment_session = gen_id(GEN_ALLOTMENT_SESSION_ID, 1);
  execute procedure ALLOTMENT_TMP_DAYS_CUT$INT(:id_allotment, :id_room_type,
          :from_date, :to_date, :id_allotment_session);

  execute procedure ALLOTMENT_TMP_SET$INT(:id_allotment_session, :id_allotment, :id_room_type,
          :from_date, :to_date, 0, :active_frame_begin, :active_frame_end);

  execute procedure ALLOTMENT_TMP_GET$INT(:id_allotment_session, 'DAYS');
end
^

/* Restore proc. body: ALLOTMENT_SET_ROOMS$INT */
ALTER PROCEDURE ALLOTMENT_SET_ROOMS$INT(ID_ALLOTMENT INTEGER,
ID_ROOM_TYPE INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ROOMS_COUNT INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_allotment_session integer;
begin
  if (:to_date < :from_date) then exception WRONG_VALUE 'Wrong period';

  id_allotment_session = gen_id(GEN_ALLOTMENT_SESSION_ID, 1);
  execute procedure ALLOTMENT_TMP_ROOMS_CUT$INT(:id_allotment, :id_room_type,
          :from_date, :to_date, :id_allotment_session);

  execute procedure ALLOTMENT_TMP_SET$INT(:id_allotment_session, :id_allotment, :id_room_type,
          :from_date, :to_date, :rooms_count, 0, 0);

  execute procedure ALLOTMENT_TMP_GET$INT(:id_allotment_session, 'ROOMS');
end
^

/* Restore proc. body: ALLOTMENT_TMP_DAYS_CUT$INT */
ALTER PROCEDURE ALLOTMENT_TMP_DAYS_CUT$INT(ID_ALLOTMENT INTEGER,
ID_ROOM_TYPE INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_ALLOTMENT_SESSION INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable ad_dbkey char(8);
  declare variable ad_from_date date;
  declare variable ad_to_date date;
  declare variable ad_days_before integer;
  declare variable ad_days_after integer;
begin
  /* ALL DETAILS WITH INTERSECTION WITH THE NEW ONE MUST BE TRANSFERED TO THE TEMP SPACE
  || BUT THE NEW PERIOD MUST OBTAIN ONLY THE NEW ROOM COUNT
  */
  for
    select AD.RDB$DB_KEY, AD.FROM_DATE, AD.TO_DATE, AD.DAYS_BEFORE, AD.DAYS_AFTER
    from   ALLOTMENT_RELEASE AD
    where  AD.ID_ALLOTMENT = :id_allotment
           and AD.ID_ROOM_TYPE = :id_room_type
           and ((:to_date is null)  or (AD.FROM_DATE <= :to_date + 1))
           and ((:from_date is null)  or (AD.TO_DATE >= :from_date - 1))
    into   :ad_dbkey, :ad_from_date, :ad_to_date, :ad_days_before, :ad_days_after
  do begin
    execute procedure ALLOTMENT_TMP_SET$INT(:id_allotment_session, :id_allotment, :id_room_type,
            :ad_from_date, :ad_to_date, 0, :ad_days_before, :ad_days_after);

    delete from ALLOTMENT_RELEASE AD
    where  AD.RDB$DB_KEY = :ad_dbkey;
  end
end
^

/* Restore proc. body: ALLOTMENT_TMP_ROOMS_CUT$INT */
ALTER PROCEDURE ALLOTMENT_TMP_ROOMS_CUT$INT(ID_ALLOTMENT INTEGER,
ID_ROOM_TYPE INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_ALLOTMENT_SESSION INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable ad_dbkey char(8);
  declare variable ad_from_date date;
  declare variable ad_to_date date;
  declare variable ad_cnt_rooms integer;
begin
  /* ALL DETAILS WITH INTERSECTION WITH THE NEW ONE MUST BE TRANSFERED TO THE TEMP SPACE
  || BUT THE NEW PERIOD MUST OBTAIN ONLY THE NEW ROOM COUNT
  */
  for
    select AD.RDB$DB_KEY, AD.FROM_DATE, AD.TO_DATE, AD.CNT_ROOMS
    from   ALLOTMENT_DETAIL AD
    where  AD.ID_ALLOTMENT = :id_allotment
           and AD.ID_ROOM_TYPE = :id_room_type
           and ((:to_date is null)  or (AD.FROM_DATE <= :to_date + 1))
           and ((:from_date is null)  or (AD.TO_DATE >= :from_date - 1))
    into   :ad_dbkey, :ad_from_date, :ad_to_date, :ad_cnt_rooms
  do begin
    execute procedure ALLOTMENT_TMP_SET$INT(:id_allotment_session, :id_allotment, :id_room_type,
            :ad_from_date, :ad_to_date, :ad_cnt_rooms, 0, 0);

    delete from ALLOTMENT_DETAIL AD
    where  AD.RDB$DB_KEY = :ad_dbkey;
  end
end
^

/* Restore proc. body: APPLY_BOOKING_STATUS$EXC */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20)
 AS
declare variable err_text varchar(255);
declare variable dummy_int integer;
declare variable anul_reason varchar(30);
declare variable selection_id integer;

declare variable status_code smallint;
declare variable current_anul_code smallint;
declare variable current_status_code smallint;
declare variable current_status_text varchar(50);
declare variable new_status_text varchar(50);
declare variable extra_posts_left integer;
begin
  if (:booking_db_key is null) then begin
    select rd.RDB$DB_KEY, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.ID_RESERV_DETAIL = :BOOKING_ID
    into   :booking_db_key, :current_status_code, :current_anul_code;
  end else begin
    select rd.id_reserv_detail, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.rdb$db_key = :booking_db_key
    into   :booking_id, :current_status_code, :current_anul_code;
  end

  execute procedure IMPORT_BOOKING_STATUS$EXC(:status, -2)
  returning_values :status_code;

  execute procedure EXPORT_BOOKING_STATUS$EXC(:current_status_code, :current_anul_code)
  returning_values :current_status_text;
  execute procedure IMPORT_BOOKING_STATUS$EXC(:current_status_text, :current_status_code)
  returning_values :current_status_code;

  /* nop - exit */
  if (:current_status_code = :status_code) then exit;

  /* validate status transition */
  if (
     /* terminal status values - void booking */
    (:current_status_code in (1004/*no show*/, 1005/*canceled*/))

    /* void over checkin */
    or ((:current_status_code >= 0) and (:status_code in (1004/*no show*/, 1005/*canceled*/)))

    /* positive status downgrade */
    or ((:current_status_code > 0) and (:current_status_code > :status_code))
  )  then begin
    execute procedure PRINT_BOOKING_STATUS$EXC(:current_status_code) returning_values :current_status_text;
    execute procedure PRINT_BOOKING_STATUS$EXC(:status_code) returning_values :new_status_text;

    exception VALIDATE_EXCEPTION '-1022' || f_character(31) || '@{invalid_status_transition} ' || :current_status_text || ' -> ' || :new_status_text;
  end

  anul_reason = null;
  if (1004 = :status_code) then begin
    anul_reason = 'NOSHOW';
  end else if (1005 = :status_code) then begin
    anul_reason = 'CANCELED';
  end

  if (:anul_reason is null) then begin
    if (0 > :status_code) then begin
      execute procedure RES_SAVE_STATUS$INT(:booking_db_key, :status_code, :CONFIRMATION_NUMBER);
    end else begin
      if (:status_code in (0, 1) and 0 > :current_status_code) then begin
        -- checkin
        execute procedure RES_SET_CHECKIN$INT (:booking_db_key)
        returning_values (:dummy_int, :err_text, :dummy_int, :dummy_int);
      end
      if (1 = :status_code and 1 > :current_status_code) then begin
        -- checkout
        selection_id = gen_id(SELECTION_GEN, 1);
        update RESERV_DETAIL
        set    selection_id=:selection_id
        where  rdb$db_key=:booking_db_key;
    
        execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id);
      end
    end
  end else begin
    -- void
    execute procedure RES_ANUL_DETAIL$INT(:booking_db_key, :anul_reason, :CANCELATION_NUMBER)
    returning_values  :dummy_int, :extra_posts_left;
    if (:extra_posts_left = 1) then exception BOOKING_EXCEPTION '-1042';

  end
end
^

/* Restore proc. body: AVAILABILITY_OCCUP_PREPARE$AVL */
ALTER PROCEDURE AVAILABILITY_OCCUP_PREPARE$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS INTEGER,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
begin

  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, :FETCH_TOTALS, 1, 1, 1, 1, 1, 1, :HOTELS);
   
  execute procedure AVAILABILITY_OCCUPANCY_OPT$INT (:RELEASE_DATES, :OVERBOOK,
          :RES_CONFIRMED, :RES_NOTCONFIRMED, :RES_WAITING, :BOOKING_POSITIONS, :CONTINGENT);

end
^

/* Restore proc. body: AVAILABILITY_OCCUP_SMALL$EXC */
ALTER PROCEDURE AVAILABILITY_OCCUP_SMALL$EXC(ID_ALLOTMENT INTEGER)
 RETURNS(FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_HOTEL INTEGER,
CNT_ROOMS INTEGER)
 AS
declare variable tmp_from_date date;
declare variable tmp_to_date date;
declare variable tmp_for_date date;
declare variable tmp_id_room_type integer;
declare variable tmp_available integer;
begin
  --check if allotment is physical
  select h.ID_HOTEL
  from   HOTEL h
  where  h.ID_PHYSICAL_ALLOTMENT = :ID_ALLOTMENT
  into   :ID_HOTEL;
  if (:ID_HOTEL is null) then exit;

  -- get min allotment date
  select min(ad.FROM_DATE)
  from   ALLOTMENT_DETAIL ad
  where  ad.ID_ALLOTMENT = :ID_ALLOTMENT
  into   :tmp_from_date;

  if (:tmp_from_date is null) then begin
    tmp_from_date = 'now';
  end

  tmp_to_date = 'now';
  tmp_to_date = :tmp_to_date + 1068; -- 3 years

  FROM_DATE = null;
  TO_DATE = null;
  ID_ROOM_TYPE = null;
  CNT_ROOMS = null;
  -- group data in periods by room type and availability
  for
    select ac.FOR_DATE, ac.ID_ROOM_TYPE, ac.AVAILABLE
    from   AVAILABILITY_OCCUP_SMALL$INT(:tmp_from_date, :tmp_to_date, :ID_HOTEL, 1) ac
    order by ID_ROOM_TYPE, FOR_DATE
    into   :tmp_for_date, :tmp_id_room_type, :tmp_available
  do begin
    if (:ID_ROOM_TYPE is null) then begin
      ID_ROOM_TYPE = :tmp_id_room_type;
    end
    if (:FROM_DATE is null) then begin
      FROM_DATE = :tmp_for_date;
    end
    if (:CNT_ROOMS is null) then begin
      CNT_ROOMS = :tmp_available;
    end

    if ((:ID_ROOM_TYPE <> :TMP_ID_ROOM_TYPE) or (:CNT_ROOMS <> :TMP_AVAILABLE)) then begin
      suspend;
      ID_ROOM_TYPE = :tmp_id_room_type;
      FROM_DATE = :tmp_for_date;
      CNT_ROOMS = :tmp_available;
    end

    TO_DATE = :tmp_for_date;
  end

  if (:ID_ROOM_TYPE is not null) then begin
    suspend;
  end
end
^

/* Restore proc. body: AVAILABILITY_OCCUP_SMALL$WBE */
ALTER PROCEDURE AVAILABILITY_OCCUP_SMALL$WBE(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER,
QUERY_ID INTEGER,
ROOMS INTEGER,
RATES VARCHAR(255) = '',
ROOMTYPES VARCHAR(255) = '')
 AS
declare variable id_channel integer;
declare variable error_check integer;
declare variable room_type_id integer;
declare variable availability_date date;
declare variable available_rooms integer;
declare variable is_available integer;
begin
  /*Leave data in table availability_room_type$wbe */
  /*In WBE database, look directly to WBE channel settings */

  /*empty WBE specific table*/
  delete from AVAILABILITY_ROOM_TYPE$WBE
  where QUERY_ID = :QUERY_ID;

  select max(c.id_channel), count(c.id_channel)
  from   CHANNEL c
  where  c.name = 'WBE'
  into   :id_channel, :error_check;
  if (not (:error_check = 1)) then  exception WRONG_VALUE 'Missing channel WBE or dublicated definition!';

  /*Fill WBE specific table*/
  /*polzwa se MAX, za6toto ako pone edna tarifa e pozwolena, zna4i ima stai*/
  /*!!!!! PROBLEM - channel management-a moje da puska stai i tarifi, no towa wse o6te ne ozna4awa 4e et mogat da minat prez tarifata i da polu4at cena*/
  for
    select  PA.id_room_type, PA.for_date,  max(PA.available_rooms),  max(PA.product_status)
    from    PRODUCT_AVAILABILITY$AVL(:id_channel, :id_hotel, :from_date, :to_date, :rates, :roomtypes) PA
    group by 1, 2
    into    :room_type_id, :availability_date, :available_rooms, :is_available
  do begin
    if ((:rooms > :available_rooms) or (:is_available = 0)) then begin
      available_rooms = 0;
      is_available = 0;
    end else begin
      is_available = 1;
    end

    insert into AVAILABILITY_ROOM_TYPE$WBE (room_type_id, availability_date, available_rooms, is_available, query_id)
    values (:room_type_id, :availability_date, :available_rooms, :is_available, :query_id);
  end

end
^

/* Restore proc. body: AVAILABILITY_OCCUPANCY$AVL */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
begin

  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, :FETCH_TOTALS, 1, 1, 1, 1, 1, 1, :HOTELS);

  ID_OCCUPANCY_SESSION = current_transaction;
end
^

/* Restore proc. body: CHANNEL_GET_WHOLEALLOTMENT$CHM */
ALTER PROCEDURE CHANNEL_GET_WHOLEALLOTMENT$CHM(ID_CHANNEL INTEGER)
 RETURNS(ID_ROOM_TYPE INTEGER,
FOR_DATE DATE,
IS_ACTIVE INTEGER,
AUTO_FREE_ROOMS INTEGER,
ROOM_COUNT INTEGER,
FREE_ROOMS INTEGER,
STATUS INTEGER)
 AS
declare variable date_from date;
  declare variable date_to date;
  declare variable channel_capacity integer;
  declare variable to_sell integer;
begin
  date_from = null;
  select min(FOR_DATE), max(FOR_DATE)
  from CHANNEL_ALLOTMENT
  where ID_CHANNEL = :id_channel
  into :date_from, :date_to;
  if (date_from is null) then exit;

  for select distinct ID_ROOM_TYPE
      from CHANNEL_ALLOTMENT
      where ID_CHANNEL = :id_channel
        and FOR_DATE between :date_from and :date_to
      into :id_room_type
  do begin
    for select RTR.FOR_DATE,
               CA.STATUS,
               CA.AUTO_FREE_ROOMS, CA.ROOM_COUNT, RTR.AVAILABLE as FREE_ROOMS
        from ROOM_TYPE_GET_FREE$CHM(:date_from, :date_to, :id_room_type) RTR
             join CHANNEL_ALLOTMENT CA on CA.ID_ROOM_TYPE = :id_room_type
                                      and CA.ID_CHANNEL = :id_channel
                                      and CA.FOR_DATE = RTR.FOR_DATE
    into :for_date, :status,
         :auto_free_rooms, :channel_capacity, :free_rooms
    do begin
      if (:auto_free_rooms is not null) then
        if (coalesce(:free_rooms,0) >= :auto_free_rooms) then
          is_active = 1;
        else is_active = 0;
      else if (:status = 0) then
             is_active = 1;
           else is_active = 0;

      to_sell = coalesce(:free_rooms,0) - coalesce(:auto_free_rooms,0);
      if (to_sell < 0) then to_sell = 0;

      room_count = :to_sell;
      if (:channel_capacity is not null) then
        if (channel_capacity < room_count) then
          room_count = :channel_capacity;

      suspend;
    end
  end
end
^

/* Restore proc. body: CHANNEL_IDSGDS_AVAILABILITY$EXC */
ALTER PROCEDURE CHANNEL_IDSGDS_AVAILABILITY$EXC(CHANNEL_NAME VARCHAR(30),
ID_HOTEL INTEGER,
ADD_BOOKINGS_WITH_PREFIX VARCHAR(10))
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_SIMPLE_RATE INTEGER,
ID_BOARD INTEGER,
ROOM_STATUS INTEGER,
RATE_STATUS INTEGER,
PRODUCT_STATUS INTEGER,
AVAILABLE_ROOMS INTEGER,
MIN_LOS INTEGER,
MAX_LOS INTEGER,
SINGLE_PRICE NUMERIC(15,4),
DOUBLE_PRICE NUMERIC(15,4),
GUEST3_PRICE NUMERIC(15,4),
GUEST4PLUS_PRICE NUMERIC(15,4),
CHILD1_W_ADULT1_PRICE NUMERIC(15,4),
CHILD1_W_ADULT2PLUS_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT1_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT2PLUS_PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3))
 AS
declare variable date_from date;
declare variable date_to date;
declare variable id_channel integer;
declare variable rate_found integer;
declare variable id_helper_session integer;
declare variable ch_date date;
declare variable ch_id_room integer;
declare variable ch_occupied integer;
begin
  --product_status 0 - closed
  --product_status 1 - closed for arrival
  --product_status 2 - opened
  --ADD_BOOKINGS_WITH_PREFIX - if set - add reservations with this prefix to channel availability. For pegasus etc.
  
  select min(CA.FOR_DATE), max(CA.FOR_DATE), min(C.ID_CHANNEL)
  from   CHANNEL_ALLOTMENT CA
         join CHANNEL C on C.ID_CHANNEL = CA.ID_CHANNEL
         join ROOM_TYPES RT on RT.ID_ROOM_TYPE = CA.ID_ROOM_TYPE
  where  C.NAME = :channel_name
         and CA.FOR_DATE >= current_date
         and RT.ID_HOTEL = :id_hotel
  into   :date_from, :date_to, :id_channel;
  if (date_from is null) then exit;

  /* Get reservations already booked. To add them to availability. Case is Pegasus */
  if (coalesce (ADD_BOOKINGS_WITH_PREFIX,'') <> '') then begin
    id_helper_session = gen_id(SELECTION_GEN, 1);
  
    for
       select RM.BUSY_DATE, RM.ID_ROOM_TYPE,  count(distinct RM.ID_ROOM) as ROOMS
       from   reserv_detail rd
              join  ROOM_MAGIC RM on rm.id_reserv_detail = rd.id_reserv_detail
       where  rd.id_hotel = :id_hotel
              and rd.to_date > current_date
              and RM.BUSY_DATE >= current_date
              and RM.DAY_ACTION not containing 'CHECK_OUT'
              /*bez Waiting reservations*/
              and RM.BUSY_TYPE <> 'VALUE_RESERVS'
              and rd.number_1 = :ADD_BOOKINGS_WITH_PREFIX
              and coalesce( rd.number_1, '') <> ''
       group by 1,2
       into :ch_date, :ch_id_room, :ch_occupied
     do begin
       insert into tmp_small_occup (id_session, for_date, id_room_type,  occupied)
       values (:id_helper_session, :ch_date, :ch_id_room, :ch_occupied ) ;
     end
   end
  /* */
  for
    select PA.FOR_DATE, PA.ID_ROOM_TYPE, PA.ID_TAR_HEAD,
           PA.ROOM_STATUS, PA.RATE_STATUS, PA.PRODUCT_STATUS,
           PA.AVAILABLE_ROOMS + coalesce(tso.occupied,0), PA.MIN_LOS, PA.MAX_LOS,
           T.CURR
    from   PRODUCT_AVAILABILITY$AVL(:id_channel, :id_hotel, :date_from, :date_to, '', '') PA
           left outer join TARIFA T on T.ID_TARIFA = PA.ID_TAR_HEAD
           left outer join TAR_SIMPLE TS on TS.ID_TAR_HEAD = PA.ID_TAR_HEAD
           /*get booked rooms to add them to channel availability (if requested)*/
           left outer join tmp_small_occup tso on PA.for_date = tso.for_date and PA.id_room_type = tso.id_room_type and tso.id_session = :id_helper_session
    where  ((PA.ID_TAR_HEAD is null) or (TS.ID_TAR_SIMPLE is not null))
    into   :for_date, :id_room_type, :id_simple_rate,
           :room_status, :rate_status, :product_status,
           :available_rooms, :min_los, :max_los,
           :price_currency
  do begin
    rate_found = 0;
    single_price = null;
    double_price = null;
    guest3_price = null;
    guest4plus_price = null;
    child1_w_adult1_price = null;
    child1_w_adult2plus_price = null;
    child2plus_w_adult1_price = null;
    child2plus_w_adult2plus_price = null;
    for
      select TSP.SINGLE_PRICE, TSP.DOUBLE_PRICE, TSP.GUEST3_PRICE, TSP.GUEST4PLUS_PRICE,
             TSP.CHILD1_W_ADULT1_PRICE, TSP.CHILD1_W_ADULT2PLUS_PRICE, TSP.CHILD2PLUS_W_ADULT1_PRICE, TSP.CHILD2PLUS_W_ADULT2PLUS_PRICE,
             TSP.ID_BOARD
      from   TAR_SIMPLE TS
             join TAR_SIMPLE_SEASON TSS on TS.ID_TAR_SIMPLE = TSS.ID_TAR_SIMPLE
             join TAR_SIMPLE_SEASON_PERIODS TSSP on TSS.ID_TAR_SIMPLE_SEASON = TSSP.ID_TAR_SIMPLE_SEASON
             join TAR_SIMPLE_PRICE TSP on TSSP.ID_TAR_SIMPLE_SEASON = TSP.ID_TAR_SIMPLE_SEASON
      where  TS.ID_TAR_HEAD = :id_simple_rate
             and :for_date between TSSP.FROM_DATE and TSSP.TO_DATE
             and TSP.ID_ROOM_TYPE = :id_room_type
             and ((tsp.IS_BASE_DAYS_PRICE = 0 and coalesce(tss.SPECIAL_DAYS_OF_WEEK, '') containing extract (weekday from cast(:for_date as date)))
                  or (tsp.IS_BASE_DAYS_PRICE = 1 and coalesce(tss.SPECIAL_DAYS_OF_WEEK, '') not containing extract (weekday from cast(:for_date as date))))
             -- and TSP.days_of_week containing extract (weekday from :for_date )
      into   :single_price, :double_price, :guest3_price, :guest4plus_price,
             :child1_w_adult1_price, :child1_w_adult2plus_price, :child2plus_w_adult1_price, :child2plus_w_adult2plus_price,
             :id_board
    do begin
      rate_found = 1;
      suspend;
    end

    if (:rate_found = 0) then begin
      rate_status = 0;
      product_status = 0;
      suspend;
    end

  end
  /*clear tmp table*/
  delete from tmp_small_occup tso where tso.id_session = :id_helper_session;
end
^

/* Restore proc. body: CHANNEL_PRODUCT_AVAIL_REQ$INT */
ALTER PROCEDURE CHANNEL_PRODUCT_AVAIL_REQ$INT(ID_CHANNEL INTEGER,
ID_HOTEL INTEGER,
ARRIVAL DATE,
DEPARTURE DATE,
ROOMS INTEGER)
 RETURNS(ID_ROOM_TYPE INTEGER,
ID_TAR_HEAD INTEGER,
IS_PRODUCT_AVAIALABLE INTEGER,
ROOM_STATUS INTEGER,
RATE_STATUS INTEGER,
RATE_MIN_LOS INTEGER,
RATE_MAX_LOS INTEGER,
AVAILABLE_ROOMS INTEGER,
IS_PUBLIC SMALLINT)
 AS
declare variable los integer;
begin
    /*TODO Proc will check all room types in channel management and rates in rate restrictions and
           will return all available and nonavailable combinations (products). For each product :
       - is_product_avaialable = 0/1 - general decision for product - can or cannot be sold
       - room_status 0-closed, 2-open - can be used for extra info if product is closed
       - rate_status 0-closed, 1-closed for arrival, 2-open - can be used for extra info if rate is closed
       - rate_min_los and rate_max_los integer - null or > 0 - extra info*/


  los = :departure - :arrival;

  for select PA.ID_ROOM_TYPE, PA.ID_TAR_HEAD,
             min(PA.ROOM_STATUS),
             /*za wsi4ki dni oswen arriaval-a close for arrival = open*/
             min( iif((pa.for_date <> :arrival) and (PA.RATE_STATUS = 1), 2, PA.RATE_STATUS)),
             /*min i max los se gledat samo na datata na pristigane*/
             max( iif((pa.for_date = :arrival), PA.MIN_LOS , null)),
             max( iif((pa.for_date = :arrival), PA.MAX_LOS , null)),
             min(PA.AVAILABLE_ROOMS),
             min(pa.is_public)
  from PRODUCT_AVAILABILITY$AVL(:id_channel, :id_hotel, :arrival, :departure-1, '', '') PA
  where PA.ID_TAR_HEAD is not null
  group by 1, 2
  /*ako kanala ne warne wsi4ki dati ot prestoia - zna4i producta niama definicia tam i ne se predlaga waob6te*/
  having count (pa.for_date) = :los
  into :id_room_type, :id_tar_head,
        :room_status,
        :rate_status,
        :rate_min_los,
        :rate_max_los,
        :available_rooms,
        :is_public
  do begin
    is_product_avaialable = 0;
    if (
        (:available_rooms >= :rooms)
        and (:room_status = 2)
        and (:rate_status = 2)
        and ((:rate_min_los is null) or (:los >= :rate_min_los)  )
        and ((:rate_max_los is null) or (:los <= :rate_max_los)  )
        )
    then is_product_avaialable = 1;
    suspend;
  end
end
^

/* Restore proc. body: CLEAR_ORPHAN_GUESTS$EXC */
ALTER PROCEDURE CLEAR_ORPHAN_GUESTS$EXC(BOOKING_ID INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable guest_id integer;
  declare variable warn_code integer;
  declare variable guest_uuid varchar(50);
begin
  ERR_CODE=0;
  ERR_TEXT=null;

  for select g.id_guest, g.uuid
  from guest g
  where g.id_reserv_detail=:booking_id and g.orphaned_import$exc=1
  into :guest_id, :guest_uuid do begin
    execute procedure sys_dbg('exc CLEAR_ORPHAN_GUESTS$EXC - RES_GUEST_DEL$RSV(:guest_id=>' || coalesce(:guest_id, '<null>') || ', :guest_uuid=>' || coalesce(:guest_uuid, '<null>') || ')');
    execute procedure RES_GUEST_DEL$RSV(
      :guest_id
    ) returning_values :err_code, :err_text, :warn_code;
    if (0 <> :err_code) then begin
      exit;
    end
  end
end
^

/* Restore proc. body: CREATE_SESSION_BOOKINGS$WBE */
ALTER PROCEDURE CREATE_SESSION_BOOKINGS$WBE(WBE_SESSION_ID BIGINT,
ARANGER_ID INTEGER,
LANG_CODE VARCHAR(3))
 RETURNS(SELECTION_ID VARCHAR(20),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable product_selection_id bigint;
declare variable next_num integer;
declare variable sel_cnt integer;
declare variable aranger_name varchar(100);
declare variable aranger_email varchar(50);
declare variable aranger_phone varchar(50);
declare variable booking_id integer;
declare variable record_timestamp timestamp;
declare variable new_res_number varchar(62);
declare variable room_types_src varchar(255) = '';
declare variable rates_src varchar(255) = '';
declare variable hotel_id integer;
declare variable profile_id integer;
declare variable from_date date;
declare variable to_date date;
declare variable day_count integer;
declare variable room_type_id integer;
declare variable rate_id integer;
declare variable query_id_tmp integer;
declare variable rooms_required integer;
declare variable rooms_available integer;
declare variable profile_import_time timestamp;
begin
  execute procedure EXPORT_LOG_FORCE$EXC(1);
  /* test overbook (multiuser) */
   for select ws.hotel_id,ws.profile,aq.first_date,(aq.first_date+aq.day_count)-1,pa.room_type_id,pa.rate_id,aq.day_count
    from   PRODUCT_availability$WBE PA
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    join availability_query$wbe aq on aq.id = pa.query_id
   where ws.id = :wbe_session_id and coalesce(pa.room_count,0) > 0
   into  :hotel_id, :profile_id, :from_date, :to_date, :room_type_id, :rate_id , :day_count
   do begin
       room_types_src = :room_types_src||','||cast(:room_type_id as varchar(10));
       rates_src = :rates_src||','||cast(rate_id as varchar(10));
   end

   query_id_tmp = GEN_ID(AVAILABILITY_QUERY$WBE_SEQ,1);
   insert into availability_query$wbe(ID, WBE_SESSION_ID, FIRST_DATE, DAY_COUNT)    -- prevent FK exception
    values (:query_id_tmp,:wbe_session_id,:from_date,:day_count) ;

   execute procedure availability_occup_small$wbe(:from_date,:to_date,:hotel_id,:query_id_tmp,1,:rates_src,:room_types_src) ;

   --  check minimum available rooms for every day
   err_code = null;
   err_text = '';
   for select pa.room_type_id,pa.room_count,
    (select coalesce(min(art.available_rooms),0) from availability_room_type$wbe art
      where art.query_id = :query_id_tmp and art.room_type_id = pa.room_type_id)
    from product_availability$wbe pa
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    where ws.id = :wbe_session_id
    and coalesce(pa.room_count,0) > 0   into :room_type_id,:rooms_required,:rooms_available
   do begin
       if (rooms_required > rooms_available) then
       begin
        err_code = 1;
        ERR_TEXT = coalesce(ERR_TEXT,'')||:room_type_id||';';
       end
   end
   delete from availability_query$wbe aqt where aqt.id = :query_id_tmp;       -- remove temp query
   if (err_code is not null) then exit;

  /* create profile if not exist and reservations > 1*/
  if (aranger_id is NULL) then
  begin
    select WS.person_name,WS.address,WS.phone
    from   WBE_SESSION$WBE WS
    where  WS.id = :wbe_session_id
    into   :aranger_name,:aranger_email,:aranger_phone;

    execute procedure IMPORT_PERSON_PROFILE$EXC(
       uuid_create(),:aranger_name,null,null,null,null,null,null,null,null,null,null,
       null,null,null,null,:aranger_phone,null,:aranger_email,null,null,null,null,null,null,
       STRHASH_LARGE(substring(uuid_create() from 1 for 4)),null,null,null,null,null,null,null,null,0,0, null)
    returning_values :aranger_id, :profile_import_time;

    update WBE_SESSION$WBE uWS
    set    uWS.profile = :aranger_id
    where  uWS.id = :wbe_session_id;
  end else begin
    -- da podmeni email, phone ako !!
  end
  /* create reservations */
  for
    select PS.id
    from   PRODUCT_SELECTION$WBE PS
    where  PS.wbe_session_id = :wbe_session_id
           and PS.booking_id is null
           and coalesce(PS.is_deleted,0) <> 1
    into   :product_selection_id
  do begin
     if (next_num = 1) then begin      -- increment first reservation number_3
      execute procedure res_number_suffix_gen(:booking_id) returning_values :new_res_number;
      next_num = next_num + 1;
     end
     execute procedure CREATE_BOOKING$WBE(:product_selection_id,:aranger_id,'WBE.'||:selection_id||'.'||:next_num) returning_values :booking_id,:selection_id;
     execute procedure IMPORT_BOOKING_FINALIZE$EXC(:booking_id) returning_values  record_timestamp,:err_code,:err_text;
     insert into SCHEDULER$WBE(booking_id,status,last_action_time,lang_code,guarantee_passed) values (:booking_id, NULL, current_timestamp, :lang_code,0);

     if (next_num is NULL) then begin
      next_num = 1;
     end else begin
      next_num = next_num + 1;
     end
  end
end
^

/* Restore proc. body: DEPOSIT_ANUL$DOC */
ALTER PROCEDURE DEPOSIT_ANUL$DOC(ID_DEPOSIT INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_PAYMENT_HEAD INTEGER)
 AS
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_ANUL');

  execute procedure DEPOSIT_ANUL$INT (:ID_DEPOSIT, :DESCRIPTION)
  returning_values :ID_PAYMENT_HEAD;

end
^

/* Restore proc. body: DEPOSIT_DOCUMENT_INITIALIZE$DOC */
ALTER PROCEDURE DEPOSIT_DOCUMENT_INITIALIZE$DOC(ID_PAYMENT_HEAD INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER,
ID_HOTEL INTEGER,
ID_ACCOUNT INTEGER)
 AS
declare variable id_dep_doc integer;
declare variable doc_selected integer;
declare variable payment_date date;
declare variable system_date date;
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_BILLING');

  id_dep_doc = null;

  select p.ID_DOC_HEAD, p.ID_ACCOUNT, p.PAYMENT_DATE, a.ID_HOTEL
  from   PAYMENT_HEAD P
         join DEPOSIT d on d.ID_PAYMENT_HEAD = p.ID_PAYMENT_HEAD
         join ACCOUNT a on a.ID_ACCOUNT = p.ID_ACCOUNT
  where  p.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
         and p.IS_ANUL = 0
  into   :id_dep_doc, :id_account, :payment_date, :id_hotel;

  if (:id_account is null) then
    exception DOCUMENT_EXCEPTION '-355';

  if (:id_dep_doc is not null) then
    exception DOCUMENT_EXCEPTION '-364';

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :system_date;

  if (:payment_date < :system_date) then
    exception DOCUMENT_EXCEPTION '-399';

  doc_selected = gen_id(DOC_SELECTED_GEN, 1);

  update DEPOSIT P
  set    p.DOC_SELECTED = :doc_selected
  where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;

  execute procedure DOCUMENT_INITIALIZE$DOC (:ID_ACCOUNT, :doc_selected)
  returning_values  (:ID_DOC_HEAD, :ID_HOTEL);

end
^

/* Restore proc. body: DOCUMENT_ADD_DEF_PAYMENT$DOC */
ALTER PROCEDURE DOCUMENT_ADD_DEF_PAYMENT$DOC(ID_DOC_HEAD INTEGER,
ID_PAY_DOC_TYPE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable pay_curr varchar(3);
  declare variable doc_curr varchar(3);
  declare variable id_account integer;
  declare variable doc_sub_type integer;
  declare variable id_base_doc integer;
  declare variable paydocs_cnt integer;
  declare variable id_payment_head integer;
  declare variable storno_amount numeric(15,4);
  declare variable rest_value numeric(15,4);
  declare variable doc_rnd_to numeric(15,4);
  declare variable doc_value numeric(15,4);
  declare variable pay_rate numeric(15,6);
  declare variable doc_rate numeric(15,6);
  declare variable extra_info_needed smallint;
  declare variable id_doc_type integer;
begin                         /* create payment */
  PAY_CURR = null;
  select D.ID_ACCOUNT, D.DOC_SUB_TYPE, D.ID_BASE_DOC,
         D.DOC_CURRENCY, D.DOC_VALUE_A, d.DOC_RATE, d.ID_DOC_TYPE
  from   DOC_HEAD D
         join DOC_TYPE DT on dt.ID_DOC_TYPE = d.ID_DOC_TYPE
  where  D.ID_DOC = :ID_DOC_HEAD
  into   :id_account, :doc_sub_type, :id_base_doc,
         :doc_curr, :doc_value, :doc_rate, :id_doc_type;

  if (:doc_sub_type < 2) then begin
    if (:ID_PAY_DOC_TYPE is null) then begin
      /* = case */
      execute procedure PAYMENT_GET_DEFAULT$INT (:ID_ACCOUNT)
      returning_values  (:ID_PAY_DOC_TYPE, :pay_curr);

      if (:pay_curr <> :doc_curr) then begin
        execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, null)
        returning_values  (:dbg, :dbg, :dbg, :dbg, :rest_value);

        select C.ROUND_TO
        from   CURRS C
        where  C.CURR = :DOC_CURR
        into   :doc_rnd_to;
         
        if (:REST_VALUE = :DOC_RND_TO) then begin
          select iif(pdt.CURRENCY_LIST containing :doc_curr, :doc_curr, null)
          from   DOC_TYPE pdt
          where  pdt.ID_DOC_TYPE = :ID_DOC_TYPE
          into   :pay_curr;
        end
      end
    end else begin
      select  PDT.DEF_CURRENCY
      from    PAY_DOC_TYPE_S PDT
      where   PDT.ID_DOC_TYPE = :ID_PAY_DOC_TYPE
              and PDT.IS_ARCHIVE = 0
              and PDT.DOC_DIRECTION = 1
      into    :PAY_CURR;
    end

    if (:ID_PAY_DOC_TYPE is not null and :PAY_CURR is not null) then begin
      select coalesce(dtp.IS_CC, 0) + coalesce(dtp.IS_AR_DEBT, 0)
      from   DOC_TYPE_PAY DTp
      where  DTP.ID_DOC_TYPE = :ID_PAY_DOC_TYPE
      into   :extra_info_needed;

      if (:extra_info_needed = 0) then begin
        execute procedure DOCUMENT_ADD_PAYMENT$DOC (:ID_DOC_HEAD, :ID_PAY_DOC_TYPE, null, :PAY_CURR, '')
        returning_values :DBG;
      end
    end
  end else begin
    select count(P.ID_PAYMENT_HEAD)
    from   PAYMENT_HEAD P
    where  P.ID_DOC_HEAD = :ID_BASE_DOC
    into   :PAYDOCS_CNT;

    if (:PAYDOCS_CNT = 1) then begin
      select P.ID_PAYMENT_HEAD, P.PAY_CURRENCY, P.PAY_RATE
      from   PAYMENT_HEAD P
      where  P.ID_DOC_HEAD = :ID_BASE_DOC
      into   :id_payment_head, :pay_curr, :pay_rate;

      if (:pay_curr = :doc_curr) then pay_rate = :doc_rate;
      execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, :pay_curr, :pay_rate)
      returning_values  (:dbg, :dbg, :dbg, :dbg, :rest_value);

      STORNO_AMOUNT = -:REST_VALUE;

      execute procedure PAYMENT_STORNO$INT (:ID_PAYMENT_HEAD, :ID_ACCOUNT, :ID_DOC_HEAD, :STORNO_AMOUNT, '', :DOC_VALUE)
      returning_values  :DBG;

      when any do exit;
       
    end
  end
end
^

/* Restore proc. body: DOCUMENT_ANUL$DOC */
ALTER PROCEDURE DOCUMENT_ANUL$DOC(ID_DOC_HEAD INTEGER,
ANUL_REASON VARCHAR(100),
MAKE_ANNUL_REPORT SMALLINT)
 AS
/**/
  declare variable id_account  integer;
  declare variable id_payment_head integer;
  declare variable for_deposit integer;
  declare variable id_base_doc integer;
  declare variable is_anul integer;
  declare variable dh_dbkey char(8);
  declare variable id_annul_protocol_num integer;
  declare variable num integer;
  declare variable doc_num varchar(20);
  declare variable system_date date;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable doc_date date;
  declare variable id_system_log integer;
  declare variable id_hotel integer;
  declare variable is_storno_doc integer;
  declare variable no_use integer;
begin

  select H.RDB$DB_KEY, H.ID_ACCOUNT, H.FOR_DEPOSIT, H.ID_BASE_DOC, H.IS_ANUL, A.ID_HOTEL,
         A.ID_RESERV_DETAIL, T.ID_ANNUL_DOC_NUM, h.DOC_DATE, H.IS_STORNO
  from   DOC_HEAD$INT H
         join DOC_COMPLETION dc on dc.ID_DOC_HEAD = h.ID_DOC_HEAD
         join DOC_TYPE T on H.ID_DOC_TYPE = T.ID_DOC_TYPE
         join DOC_TYPE_INV DTI on DTI.ID_DOC_TYPE = T.ID_DOC_TYPE
         join ACCOUNT A on A.ID_ACCOUNT = H.ID_ACCOUNT
  where  H.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :dh_dbkey, :id_account, :for_deposit, :id_base_doc, :is_anul, :id_hotel,
         :id_reserv_detail, :id_annul_protocol_num, :doc_date, :is_storno_doc;

  if (:is_anul = 1) then
    exception DOCUMENT_ANNUL_EXCEPTION '-352'; --'Document is already annul';

  if (exists (select D.ID_DOC
              from   DOC_HEAD D
              where  D.ID_BASE_DOC = :ID_BASE_DOC
                     and D.ID_DOC > :ID_DOC_HEAD
                     and D.IS_ANUL = 0))
  then exception DOCUMENT_ANNUL_EXCEPTION '-314';

  execute procedure SYSTEM_DATE_GET(:ID_HOTEL)
  returning_values  :system_date;

  if (:DOC_DATE < :SYSTEM_DATE) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_PREV_DATE');
  end
  /* unarchive account and set as credit account, for shecked out bookings only */
  execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:ID_ACCOUNT, 0);

  if (:ID_RESERV_DETAIL is not null) then begin
    select RD.CHECK_STATUS
    from   RESERV_DETAIL RD
    where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :check_status;

    if (:check_status = 1) then begin
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, null, 1);
    end
  end
  /* MARK THE DOCUMENT AS ANUL - before posting and payment updates */
  update DOC_HEAD$INT DH
  set    DH.IS_ANUL = 1
  where  DH.RDB$DB_KEY = :dh_dbkey;

  update DOC_COMPLETION Dc
  set    Dc.IS_EFAKTURA_EXPORTED = 0
  where  Dc.ID_DOC_HEAD = :ID_DOC_HEAD;


  if (:is_storno_doc = 1) then begin
    /* annul storno doc */
    update DOC_HEAD$INT BD
    set    BD.IS_STORNED = 0
    where  BD.ID_DOC_HEAD = :id_base_doc
           and BD.IS_STORNED = 1;
  end
  /* RELEASE ACCOUNT_POSTS */
  if (:for_deposit = 0) then
    execute procedure ACCOUNT_POSTING_DOC_UPDATE$INT (:DH_DBKEY)
    returning_values (:no_use);

  /* PAYMENTS REFLECTION */
  for
    select PH.ID_PAYMENT_HEAD
    from   PAYMENT_HEAD PH
           join DOC_TYPE_PAY dt on dt.ID_DOC_TYPE = ph.ID_DOC_TYPE
    where  PH.ID_DOC_HEAD = :ID_DOC_HEAD
           and PH.IS_STORNED = 0
    into   :ID_PAYMENT_HEAD
  do begin

    execute procedure PAYMENT_ANUL$INT (:ID_PAYMENT_HEAD, :ANUL_REASON);
  end

  /* ANNUL_PROTOCOL creating section */
  NUM = null;
  DOC_NUM = null;
  if (:MAKE_ANNUL_REPORT = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_WITH_PROT');

    if (:ID_ANNUL_PROTOCOL_NUM is null) then exception DOCUMENT_ANNUL_EXCEPTION '-345';

    execute procedure SYSTEM_GEN_NUM ('ANNUL_PROT', :ID_ANNUL_PROTOCOL_NUM)
    returning_values  (:num, :doc_num);
  end
  /* log annul event */
  execute procedure SYSTEM_EVENT_LOG$INT ('DOCUMENT', :ID_DOC_HEAD, 'ANNUL', f_character(29)||:ANUL_REASON)
  returning_values  :id_system_log;

  insert into DOC_ANNULMENT (ID_DOC_HEAD, ANNULMENT_DATE, ID_PROT_DOC_NUM, PROT_NUM, PROT_DOC_NUM, ID_LOG_EVENT)
  values (:ID_DOC_HEAD, :SYSTEM_DATE, :ID_ANNUL_PROTOCOL_NUM, :NUM, :DOC_NUM, :ID_SYSTEM_LOG);
  /* reflect annul date on doc release dates */
  if (:DOC_DATE < :SYSTEM_DATE) then begin
    insert into DOC_RELEASE_DATE (ID_DOC_HEAD, RELEASE_DATE, VALUE_CORR_INDEX)
    values (:ID_DOC_HEAD, :SYSTEM_DATE, -1);
  end else begin
    update DOC_RELEASE_DATE RD
    set    RD.VALUE_CORR_INDEX = 0
    where  RD.ID_DOC_HEAD = :ID_DOC_HEAD
           and RD.RELEASE_DATE = :DOC_DATE;
  end
  /* reflect on AR module */
  execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT (:DH_DBKEY, null, 1, :ANUL_REASON);
  /* reflect on client loyalty module */
  execute procedure DOCUMENT_BONUSPOINTS_VOID$CL (:ID_DOC_HEAD);

end
^

/* Restore proc. body: DOCUMENT_BONUSPOINTS_SPEND */
ALTER PROCEDURE DOCUMENT_BONUSPOINTS_SPEND(ID_DOC_HEAD INTEGER,
BONUSPOINT_CNT INTEGER)
 RETURNS(DOC_REST_AMOUNT NUMERIC(15,4))
 AS
declare variable bonuspoints_avail integer;
  declare variable id_bonuspoint_scheme integer;
  declare variable consume_discount_txt varchar(100) ;
  declare variable consume_point_price numeric(15,4);
  declare variable consume_point_curr varchar(3);
  declare variable doc_curr varchar(3);
  declare variable discount_value numeric(15,4);
  declare variable round_to numeric(15,4);
  declare variable doc_rate numeric(15,6);
  declare variable bp_price_rate numeric(15,6);
  declare variable no_use varchar(255);
  declare variable consume_point_nominal integer;
begin
  delete from DOC_FOOTER DF
  where  DF.ID_DOC_HEAD = :ID_DOC_HEAD
         and df.ID_TAX is null;

  if (:BONUSPOINT_CNT <= 0) then exit;

  select D.DOC_CURRENCY, D.DOC_RATE, PB.ID_BONUSPOINT_SCHEME, c.ROUND_TO,
         cast(coalesce(P.BONUSPOINT_GAINED, 0) - coalesce(p.BONUSPOINT_CONSUMED, 0) as integer)
  from   DOC_HEAD D
         join ACCOUNT A on A.ID_ACCOUNT = d.ID_ACCOUNT
         join PROFILE P on P.ID_PROFILE = a.ID_PROFILE
         join PROFILE_BONUSPOINT_SCHEME PB on PB.ID_PROFILE = P.ID_PROFILE and PB.ID_HOTEL = a.ID_HOTEL
         join CURRS c on c.CURR = d.DOC_CURRENCY
  where  D.ID_DOC = :ID_DOC_HEAD
  into   :doc_curr, :doc_rate, :id_bonuspoint_scheme, :round_to,
         :bonuspoints_avail;

  if (:BONUSPOINT_CNT > :bonuspoints_avail) then exception DOCUMENT_EXCEPTION 'Insufficient bonus points !';

  select BS.CONSUME_DISCOUNT_TXT, BS.CONSUME_POINT_PRICE, BS.CONSUME_POINT_CURR, BS.CONSUME_POINT_NOMINAL
  from   BONUSPOINT_SCHEME BS
  where  BS.ID_BONUSPOINT_SCHEME = :id_bonuspoint_scheme
  into   :consume_discount_txt, :consume_point_price, :consume_point_curr, :consume_point_nominal;

  discount_value = -round_f(:BONUSPOINT_CNT * iif(:consume_point_nominal = 0, 0, cast(:consume_point_price / :consume_point_nominal as double precision)), :round_to);

  if (:doc_curr <> :consume_point_curr) then begin
    -- convert to document currency
    execute procedure DOCUMENT_CURR_RATE_GET$INT (:ID_DOC_HEAD, :consume_point_curr)
    returning_values (:bp_price_rate, :no_use);

    discount_value = round_f(:discount_value * cast(:bp_price_rate / :doc_rate as double precision), :round_to);
  end

  insert into DOC_FOOTER (ID_DOC_HEAD, ID_TAX, TAX_ORDER, TAXABLE_VALUE,
         ID_DOC_LINE, FOOTER_VALUE, DESCRIPTION)
  values (:ID_DOC_HEAD, null, 0, :BONUSPOINT_CNT, null, :discount_value, :consume_discount_txt);

  execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, null)
  returning_values (:no_use, :no_use, :no_use, :no_use, :DOC_REST_AMOUNT);

  if (:DOC_REST_AMOUNT < 0) then exception DOCUMENT_EXCEPTION '-380';
end
^

/* Restore proc. body: DOCUMENT_CLEAR_DEPOSITS$DOC */
ALTER PROCEDURE DOCUMENT_CLEAR_DEPOSITS$DOC(ID_DOC_HEAD INTEGER)
 AS
declare variable is_storno_doc smallint;
begin

  execute procedure DOCUMENT_REUSE_DEPOSITS$INT (:ID_DOC_HEAD, null);

end
^

/* Restore proc. body: DOCUMENT_GET_CURR_VALUE$DOC */
ALTER PROCEDURE DOCUMENT_GET_CURR_VALUE$DOC(ID_DOC_HEAD INTEGER,
PAY_CURR VARCHAR(3))
 RETURNS(ID_PAY_DOC_DEF INTEGER,
TOTAL_CURR VARCHAR(3),
TOTAL_RATE NUMERIC(15,6),
TOTAL_VALUE NUMERIC(15,4),
REST_VALUE NUMERIC(15,4))
 AS
begin

  execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, :PAY_CURR)
  returning_values :ID_PAY_DOC_DEF, :TOTAL_CURR, :TOTAL_RATE, :TOTAL_VALUE, :REST_VALUE;

  suspend;
end
^

/* Restore proc. body: DOCUMENT_STORNO$DOC */
ALTER PROCEDURE DOCUMENT_STORNO$DOC(ID_DOC_HEAD INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_STORNO_DOC INTEGER,
ID_HOTEL INTEGER,
ID_ACCOUNT INTEGER)
 AS
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_STORN_WITHP');

  execute procedure DOCUMENT_STORNO$INT (:ID_DOC_HEAD, :DESCRIPTION, 1)
  returning_values  (:ID_STORNO_DOC, :ID_HOTEL);

  select D.ID_ACCOUNT
  from   DOC_HEAD D
  where  D.ID_DOC = :id_storno_doc
  into   :id_account;

  execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :ID_DOC_HEAD, 'STORNO', f_character(29)||:DESCRIPTION);

end
^

/* Restore proc. body: EAI_EXT_POST_TO_MH_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  if (:CODE_TYPE = 'EXT_CODE') then begin
    execute procedure EAI_MAP_SERVICE(:SERVICE_CODE, :SERVICE_CODE, 'UNKNOWN', :id_hotel)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_SERVICE;
    if (:ERR_CODE < 0) then exit;
  end else begin
    select S.ID_SERVICE
    from   SERVICES S
    where  S.ID_SERVICE = :SERVICE_CODE
           and s.ID_HOTEL = :ID_HOTEL
    into   :ID_SERVICE;
    if (:ID_SERVICE is null) then begin
      ERR_CODE = -85;   /* Wrong value! */
      exit;
    end
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Restore proc. body: EAI_EXT_SERVICE_POST */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable max_id_service integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_ROOM  = null;
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  select min(S.ID_SERVICE) as id_service, max(s.id_service) as max_id_service
  from   SERVICES S
  where  S.EXT_CODE = :SERVICE_EXT_CODE
         and s.IS_BASE = 0
         and s.IS_DELETED = 0
  into   :ID_SERVICE, :max_id_service;
  if (:ID_SERVICE is null) then begin
      ERR_CODE = -388;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end else if (:ID_SERVICE <> :max_id_service) then begin
      ERR_CODE = -389;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_EXT_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Restore proc. body: EAI_POS_POSTING_ADD$P2E */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
declare variable id_service integer;
  declare variable my_post_text varchar(255);
  declare variable my_resource_text varchar(255);
  declare variable no_use integer;
  declare variable nation_curr varchar(3);
  declare variable post_short_code varchar(10);
  declare variable id_hotel integer;
begin
  /* in_on_guest = 0 (account), 1 (guest), -1 (ew)
  */
  if (:IN_ON_GUEST = 1) then begin
    select rd.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :IN_ID_GUEST
    into   :id_hotel;
  end else begin
    select a.ID_HOTEL
    from   account a
    where  a.ID_ACCOUNT = :in_id_account
    into   :id_hotel;
  end

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :nation_curr;

  if ('END_WORK' = :in_smetka_num) then begin
    post_short_code='POS_EW';
  end else begin
    post_short_code='POS';
  end

  /* FIND SERVICE */
  execute procedure EAI_MAP_SERVICE(:in_service_tag, :in_service_name, 'POS', :id_hotel)
  returning_values  :err_code, :err_text, :id_service;
  if (:err_code < 0) then exit;

  my_post_text = 'date:'|| formatdate(:in_date_smetka, 'D;dd.mm.yyyy') ||
                 ' num:'|| :in_smetka_num ||
                 ' obj:'|| :in_obj_name ||
                 ' tbl:'|| :in_table ||
                 ' site:'|| :in_site;

  my_resource_text = 'POS_ID_SMETKA:'||:in_id_smetka;
  my_post_text = substring(:my_post_text from 1 for 100);
  my_resource_text = substring(:my_resource_text from 1 for 49);

  if (:in_on_guest = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:in_id_guest, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code, '')
    returning_values  :err_code, :err_text, :out_id_account, :no_use;
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:in_id_account, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code)
    returning_values  :err_code, :err_text, :no_use;
    out_id_account = :in_id_account;
  end
end
^

/* Restore proc. body: EAI_RES_CHECK_OUT_FAST */
ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
declare variable selection_id integer;
  declare variable is_early_check_out smallint;
  declare variable early_check_out_dep_date date;
  declare variable check_out_date date;
begin
  selection_id = gen_id(selection_gen, 1);

  update RESERV_DETAIL RD
  set RD.SELECTION_ID = :SELECTION_ID
  where RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL;

  execute procedure RES_CHECK_OUT_CHECK$RSV(:selection_id)
  returning_values :is_early_check_out, :early_check_out_dep_date, :check_out_date;

  if (:is_early_check_out = 1) then
    exception BOOKING_EXCEPTION '-1043';

  execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id, 0);
end
^

/* Restore proc. body: EAI_TELECOUNT_TRANSFER */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* Restore proc. body: END_WORK */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable system_date date;
  declare variable id_room integer;
  declare variable id_end_work integer;
  declare variable last_closed_date date;
  declare variable mark_dirty_expired_block varchar(10);
  declare variable mark_dirty_occ_room varchar(10);
  declare variable lock_id integer;
  declare variable shift_no integer;
  declare variable init_hotel_date date;
begin

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;
  if (:system_date >= :in_next_date) then exception END_WORK_EXCEPTION '-43';
  if (:IN_NEXT_DATE > current_date + 1) then exception END_WORK_EXCEPTION '-60';

  last_closed_date = :in_next_date - 1;

  /* LOCK THE CURRENT FINANCIAL (SYSTEM) DATE  */
  lock_id = null;
  while (:lock_id is null) do begin
    lock_id = strhash_large(:system_date || :id_hotel);
    execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'lock');
  
    when any do begin
      exception END_WORK_EXCEPTION '-337' || f_character(31) || f_character(29) || FormatDate(:system_date, 'D;dd.mm.yyyy');
    end
  end

  /* RIGHT IS REQUIRED TO CHANGE THE FINANCIAL DATE IF THERE ARE GUESTS WITH OVERDUE CHECK OUT */
  if (exists(
    select *
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
    where  G.TO_DATE <= :last_closed_date
           and G.CHECK_STATUS < 1
           and RD.ID_HOTEL = :id_hotel
           and rd.IS_ANUL = 0
  )) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('EW_OVERDUE_CHECKOUT');
  end

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', 'EW');
  -- Suppress eventual right checks into next procedures - all is permitted. Is this needed(?!?)

  update ACCOUNT_POST AP
  set    ap.ROOM_NAME = (select R.ROOM_NAME
                         from   GUEST G
                                join ROOMS R on R.ID_ROOM = G.ID_ROOM
                         where  G.ID_GUEST = ap.ID_GUEST)
  where  ap.DATE_POST between :system_date and :last_closed_date
         and ap.ID_GUEST > 0;

  select coalesce(max(ew.SHIFT_NO), 0) + 1
  from   END_WORKS ew
  where  ew.PREV_DATE = :system_date
  into   :shift_no;

  id_end_work = gen_id(G_AUTO_INC_END_WORKS, 1);
  insert into END_WORKS (ID_END_WORK, PREV_DATE, NEXT_DATE, END_WORK_KIND, SHIFT_NO, ID_HOTEL)
  values (:id_end_work, :system_date, :in_next_date, 3, :shift_no, :id_hotel);

  /* CHANGE SYSTEM DATE */
  execute procedure SYSTEM_DATE_SET(:id_hotel, :in_next_date);

  /* AUTO EXPIRATION OF ROOM NUMBERS, ROOMS AND BOOKING POSITIONS */
  execute procedure RESERVS_EXPIRE$INT(:last_closed_date, :id_hotel);

  execute procedure AGENT_CONTINGENT_EXPIRE(:system_date, :last_closed_date, null, 0, 1, :id_hotel);

  /* DELETE PERSON PROFILES WITH EXPIRATION DATE */
  execute procedure PROFILE_PERSON_EXPIRE (:in_next_date);

  execute procedure SETTING_GET_VALUE('MARK_DIRTY_EXPIRED_BLOCK', :ID_HOTEL)
  returning_values  :mark_dirty_expired_block;
  if (:mark_dirty_expired_block = '1') then begin
    for
      select distinct BR.ID_ROOM
      from   BLOCK_ROOM BR
             join ROOMS R on R.ID_ROOM = BR.ID_ROOM
      where  R.ID_HOTEL = :id_hotel
             and BR.TO_DATE >= :system_date
             and BR.TO_DATE < :in_next_date
             and BR.IS_ANNUL = 0
         into :id_room
    do begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'BLOCK_EXP', 'set_dirty');

      when any do post_event 'dummy';  -- nothing
    end
  end

  execute procedure SETTING_GET_VALUE('MARK_DIRTY_OCC_ROOM', :ID_HOTEL)
  returning_values  :mark_dirty_occ_room;
  if (:mark_dirty_occ_room = '1') then begin
    for
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
             join ROOMS R on R.ID_ROOM = rm.ID_ROOM
      where  R.ID_HOTEL = :id_hotel
             and RM.BUSY_DATE = :system_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and RM.BUSY_GROUP_TYPE = 24
      into   :id_room
    do begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'EW_DAY', 'set_dirty');

      when any do post_event 'dummy';  -- nothing
    end
  end

  /* Summary data prepare */
  if (:in_next_date > :system_date) then begin
    execute procedure SUMMARY_FINANCE_SAVE$INT (:id_end_work);

    select min(e.PREV_DATE)
    from   END_WORKS E
    where  E.ID_HOTEL = :ID_HOTEL
    into   :init_hotel_date;

    execute procedure SUMMARY_PREPARE$INT(:id_hotel, :init_hotel_date, :last_closed_date); --TODO precise the period

    execute procedure SUMMARY_FORECAST$INT(:ID_HOTEL, :system_date);
  end

  /* Delete data from temporal tables */
  delete from RESERV_ERROR;
  delete from TMP_SMALL_OCCUP;
--  delete from GUEST g where g.id_reserv_detail is null; pri regenerirane na statistikata ne vurshi rabota
  /*  */

  execute procedure CACHES_RESOLVE;

  execute procedure SYSTEM_LOG_ADD('SYSTEM', :id_end_work, 'DAY_EW', f_character(29) || :last_closed_date);

  execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'release');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', null);

  post_event 'invalidate.end_work';
end
^

/* Restore proc. body: EXPORT_DOCUMENT */
ALTER PROCEDURE EXPORT_DOCUMENT(FROM_DATE DATE,
TO_DATE DATE,
DOC_TAG VARCHAR(20),
PAY_TAG VARCHAR(20),
NO_PAY_DOCS VARCHAR(20),
GROUP_TAG VARCHAR(20),
ID_HOTEL INTEGER = null,
RETURN_CLIENT_PERSON_ID SMALLINT = 0)
 RETURNS(DOC_TYPE_ID INTEGER,
DOC_SUB_TYPE SMALLINT,
DOC_TYPE_NAME VARCHAR(50),
DOC_DATE DATE,
DOC_FOR_DEPOSIT SMALLINT,
TAX_EVENT_DATE DATE,
DIFF_VAT_REASON VARCHAR(254),
DOC_NUM VARCHAR(20),
DOC_CURRENCY CHAR(3),
DOC_RATE NUMERIC(15,4),
DOC_IS_STORNED SMALLINT,
DOC_IS_STORNO SMALLINT,
DOC_ID_BASE_DOC INTEGER,
DOC_EXPORT_TAG VARCHAR(20),
DOC_SEND_NAME VARCHAR(100),
DOC_DOGOVOR_NUM VARCHAR(30),
DOC_NOTE VARCHAR(100),
DOC_SUPPLIER_ID INTEGER,
CLT_ID INTEGER,
CLT_NAME VARCHAR(100),
CLT_VAT_REG_NUM VARCHAR(30),
CLT_IDENT_NO VARCHAR(30),
CLT_MOL VARCHAR(50),
CLT_ADDRESS VARCHAR(100),
CLT_COUNTRY_CODE VARCHAR(10),
CLT_ZIP_CODE VARCHAR(10),
CLT_RECIEVE_NAME VARCHAR(100),
PAY_TYPE_ID INTEGER,
PAY_TYPE VARCHAR(20),
PAY_CURRENCY CHAR(3),
PAY_VALUE NUMERIC(15,4),
PAY_RATE NUMERIC(15,6),
PAY_CC_NAME VARCHAR(50),
PAY_CC_NUM VARCHAR(50),
PAY_CC_BANK VARCHAR(50),
PAY_EXPORT_TAG VARCHAR(20),
LINE_ID INTEGER,
LINE_NAME VARCHAR(50),
LINE_WOT_VAT NUMERIC(15,4),
LINE_VAT_FREE NUMERIC(15,4),
LINE_VAT_BASE NUMERIC(15,4),
LINE_VAT NUMERIC(15,4),
VAT_VALUE NUMERIC(15,4),
ID_VAT_GROUP INTEGER,
ID_SALE_TAXATION INTEGER,
LINE_QTY NUMERIC(15,4),
ACC_NO VARCHAR(30),
POSITION_NO INTEGER)
 AS
declare variable id_doc_head integer;
  declare variable doc_grand_total numeric(15,4);
  declare variable pay_coeficient double precision;
  declare variable value_corr_idx numeric(15,2);
  declare variable doc_total numeric(15,2);
  declare variable doc_rate_int numeric(15,4);
  declare variable curr_sel varchar(10);
  declare variable delim_pos integer;
begin
  /*  Description:
  ||
  */

  POSITION_NO = 1;
  delim_pos = strpos(';', :GROUP_TAG);
  if (:delim_pos > 0) then begin
    curr_sel = substring(:GROUP_TAG from :delim_pos + 1 for char_length(:group_tag) - :delim_pos);
    GROUP_TAG = substring(:GROUP_TAG from 1 for :delim_pos - 1);
  end

  for
    select DH.ID_DOC, DH.DOC_TYPE_NAME, DH.REAL_DOC_DATE, DH.DOC_NUM,
           coalesce(DD.ID_CONTRAGENT, iif(:RETURN_CLIENT_PERSON_ID = 1, 1000000000 + a.ID_PROFILE, null)),
           DH.ID_DOC_TYPE, DH.DOC_RATE, DD.CONTRAGENT_NAME, DD.VAT_REG_NUM, DD.IDENT_NO,
           DD.MOL, DD.POST_ADDRESS, DD.COUNTRY_CODE, DD.ZIP_CODE,
           DS.SEND_NAME, DD.RECIPIENT_NAME, DH.DESCRIPTION, DD.NUM_DOGOVOR,
           DH.DOC_VALUE_A, DH.DOC_CURRENCY, DH.ID_BASE_DOC,
           DH.IS_STORNED, DH.IS_STORNO,
           case when D.DOC_SUB_TYPE = 2 then DI.CREDIT_EXPORT_TAG
                when D.DOC_SUB_TYPE = 1 then DI.DEBIT_EXPORT_TAG
                else DT.EXPORT_TAG
           end as EXPORT_TAG, DH.TAX_EVENT_DATE, DH.DIFF_VAT_REASON,
           DH.FOR_DEPOSIT,
           iif(dh.ANNULMENT_DATE between :from_date and :to_date /*and dh.VALUE_CORR_IDX = 1*/, 0, DH.VALUE_CORR_IDX) as VALUE_CORR_IDX,
           D.DOC_SUB_TYPE, DS.ID_DOC_SUPPLIER, DH.DOC_VALUE_A
    from   DOCUMENT_RELEASE DH
           join DOC_CONTRAGENT DD on DD.ID_DOC_CONTRAGENT = DH.ID_DOC_CONTRAGENT
           join DOC_SUPPLIER DS on DS.ID_DOC_SUPPLIER = DH.ID_DOC_SUPPLIER
           join DOC_TYPE DT on DT.ID_DOC_TYPE = DH.ID_DOC_TYPE
           join DOC_TYPE_INV DI on DI.ID_DOC_TYPE = DT.ID_DOC_TYPE
           join DOC_HEAD D on D.ID_DOC = DH.ID_DOC
           join ACCOUNT A on A.ID_ACCOUNT = DH.ID_ACCOUNT
    where  DH.RPT_DOC_DATE between :from_date and :to_date
           and ((upper(:doc_tag) = 'ALL') or (coalesce(DI.ANNUL_EXPORT_TAG, DT.EXPORT_TAG) = :doc_tag))
           --and DH.IS_ANNUL_ON_DATE = 0
           and ((:ID_HOTEL is null) or (A.ID_HOTEL = :ID_HOTEL))
           and not (dh.REAL_DOC_DATE between :from_date and :to_date
                    and dh.ANNULMENT_DATE between :from_date and :to_date
                    and dh.VALUE_CORR_IDX = -1)  -- skip annul records into same period
    into   :id_doc_head, :doc_type_name, :doc_date, :doc_num, :clt_id,
           :doc_type_id, :doc_rate, :clt_name, :clt_vat_reg_num, :clt_ident_no,
           :clt_mol, :clt_address, :clt_country_code, :clt_zip_code,
           :doc_send_name, :clt_recieve_name, :doc_note, :doc_dogovor_num,
           :doc_grand_total, :doc_currency, :doc_id_base_doc,
           :doc_is_storned, :doc_is_storno, :doc_export_tag, :tax_event_date, :diff_vat_reason,
           :DOC_FOR_DEPOSIT, :value_corr_idx, :doc_sub_type, :doc_supplier_id, :doc_total
  do begin
    if (:curr_sel = 'ORIG') then doc_rate_int = 1; else doc_rate_int = :DOC_RATE;
    /****************************************/
    if (upper(:group_tag) = 'DOC_TOTAL') then begin
      line_vat_free = null;
      line_vat_base = null;
      line_vat = null;
      doc_total = null;

      select sum(dt.NONTAXABLE_VALUE), sum(dt.TAXABLE_VALUE), sum(dt.TAX_VALUE), min(dt.ID_SALE_TAX)
      from   DOC_TAXES DT
      where  DT.ID_DOC_HEAD = :id_doc_head
      into   :LINE_VAT_FREE, :LINE_VAT_BASE, :LINE_VAT, :ID_VAT_GROUP;
      line_vat_free = coalesce(:line_vat_free, 0) * :value_corr_idx;
      line_vat_base = coalesce(:line_vat_base, 0) * :value_corr_idx;
      line_vat = coalesce(:line_vat, 0) * :value_corr_idx;
      doc_total = coalesce(:doc_total, 0)* :value_corr_idx;

      select st.TAX_PERCENT
      from   SALE_TAXES ST
      where  ST.ID_SALE_TAX = :ID_VAT_GROUP
      into   :VAT_VALUE;
       
      LINE_WOT_VAT = (:LINE_VAT_BASE + :LINE_VAT_FREE) * :value_corr_idx; /*:doc_total - :LINE_VAT;*/
      LINE_ID = :id_doc_head;
      LINE_NAME = '';
      LINE_QTY = 1;
      ACC_NO = '';

      select   first 1 EDP.PAY_TYPE_ID, EDP.PAY_TYPE, EDP.PAY_CURRENCY, EDP.PAY_RATE, EDP.PAY_VALUE,
               EDP.PAY_CC_NUM, EDP.PAY_CC_NAME, EDP.PAY_CC_BANK, EDP.PAY_COEFICIENT, EDP.EXPORT_TAG
      from     EXPORT_DOCUMENT_PAYMENT(:id_doc_head, :pay_tag, :no_pay_docs, :doc_currency,
                                       :doc_id_base_doc, :doc_grand_total) EDP
      into     :pay_type_id, :pay_type, :pay_currency, :pay_rate, :pay_value,
               :pay_cc_num, :pay_cc_name, :pay_cc_bank, :pay_coeficient, :pay_export_tag;

      PAY_VALUE = :PAY_VALUE * :value_corr_idx;
      suspend;
      POSITION_NO = :POSITION_NO + 1;
    end else if (upper(:group_tag) = 'TAXES') then begin
      ID_SALE_TAXATION = null;
      POSITION_NO = 1;
      for
        select dt.TAX_NAME, 1, dt.ID_SALE_TAX,
               (dt.TAXABLE_VALUE + dt.NONTAXABLE_VALUE) * :value_corr_idx,
               dt.NONTAXABLE_VALUE * :value_corr_idx,
               dt.TAXABLE_VALUE * :value_corr_idx,
               dt.TAX_VALUE * :value_corr_idx,
               dt.TAX_PERCENT, st.ACCOUNT_NAME, dt.ID_SALE_TAX
        from   DOC_TAXES dt
               join SALE_TAXES st on st.ID_SALE_TAX = dt.ID_SALE_TAX
        where  dt.ID_DOC_HEAD = :ID_DOC_HEAD
        into   :line_name, :line_qty, :LINE_ID, :line_wot_vat, :line_vat_free, :line_vat_base,
               :line_vat, :vat_value, :acc_no, :id_vat_group
      do begin
      
        suspend;
        POSITION_NO = :POSITION_NO + 1;
      end 
    end else begin
      LINE_VAT_BASE = null;
      LINE_VAT_FREE = null;
      ID_VAT_GROUP = null;
      for
        select   EDP.PAY_TYPE_ID, EDP.PAY_TYPE, EDP.PAY_CURRENCY, EDP.PAY_RATE, EDP.PAY_VALUE,
                 EDP.PAY_CC_NUM, EDP.PAY_CC_NAME, EDP.PAY_CC_BANK, EDP.PAY_COEFICIENT, EDP.EXPORT_TAG
        from     EXPORT_DOCUMENT_PAYMENT(:id_doc_head, :pay_tag, :no_pay_docs, :doc_currency,
                                         :doc_id_base_doc, :doc_grand_total) EDP
        into     :pay_type_id, :pay_type, :pay_currency, :pay_rate, :pay_value,
                 :pay_cc_num, :pay_cc_name, :pay_cc_bank, :pay_coeficient, :pay_export_tag
      do begin
        PAY_VALUE = :PAY_VALUE * :value_corr_idx;
        for
          select EDL.LINE_ID, EDL.LINE_NAME, EDL.LINE_WOT_TAX, EDL.LINE_TAX, EDL.LINE_QTY,
                 EDL.ACC_NO, EDL.TAX_PERCENT, EDL.POSITION_NO, EDL.ID_SALE_TAXATION
          from   EXPORT_DOCUMENT_LINES(:id_doc_head, :group_tag, :pay_coeficient, :doc_rate_int) EDL
          into   :line_id, :line_name, :line_wot_vat, :line_vat, :line_qty,
                 :acc_no, :vat_value, :POSITION_NO, :ID_SALE_TAXATION
        do begin
          LINE_WOT_VAT = :LINE_WOT_VAT * :value_corr_idx;
          LINE_VAT = :LINE_VAT * :value_corr_idx;
          select min(st.ID_SALE_TAX)
          from   SALE_TAXATION_TAX ST
                 join SALE_TAXES t on t.ID_SALE_TAX = st.ID_SALE_TAX
          where  ST.ID_SALE_TAXATION = :ID_SALE_TAXATION
                 and t.REVENUE_DEDUCTION_TAX is distinct from 1
          having count(st.ID_SALE_TAX) = 1
          into   :ID_VAT_GROUP;

          suspend;
        end
      end
    end
  end
end
^

/* Restore proc. body: GUEST_ADDRESSCARD_SET$INT */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$INT(PD_DBKEY CHAR(8),
G_DBKEY CHAR(8),
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
COUNTRY_CODE VARCHAR(10),
IS_CHILD INTEGER,
AGE INTEGER,
BIRTH_DAY DATE,
TITLE VARCHAR(10))
 AS
declare variable rd_dbkey char(8);
  declare variable old_is_child integer;
  declare variable old_birthday date;
  declare variable p_dbkey char(8);
  declare variable old_country_code varchar(10);
  declare variable from_date date;
  declare variable birthday_internal date;
begin

  select G.IS_CHILD, coalesce(:is_child, G.IS_CHILD), RD.RDB$DB_KEY, G.FROM_DATE
  from   GUEST G
         left join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
  where  G.RDB$DB_KEY = :g_dbkey
  into   :old_is_child, :is_child, :rd_dbkey, :from_date;

  select PD.COUNTRY_CODE, PD.BIRTH_DAY, P.RDB$DB_KEY
  from   PERSON_DATA PD
         left outer join PROFILE_PERSON PP on PP.ID_PERSON_DATA = PD.ID_PERSON_DATA
         left outer join PROFILE P on P.ID_PROFILE = PP.ID_PROFILE
  where  PD.RDB$DB_KEY = :pd_dbkey
  into   :old_country_code, :old_birthday, :p_dbkey;

  country_code = coalesce(:country_code, '');

  execute procedure sys_dbg('res GUEST_ADDRESSCARD_SET$INT birth_day = '||coalesce(:birth_day, 'null'));
  execute procedure sys_dbg('res GUEST_ADDRESSCARD_SET$INT old_birthday = '||coalesce(:old_birthday, 'null'));
  execute procedure sys_dbg('res GUEST_ADDRESSCARD_SET$INT age = '||coalesce(:age, 'null'));

  execute procedure GUEST_BIRTHDAY$INT(:birth_day, :age, :old_birthday, :from_date)
  returning_values  :birthday_internal, :birth_day;

  execute procedure PERSON_DATA_SET$INT(:p_dbkey, :pd_dbkey, :guest_name1, :guest_name2,
          :country_code, :birth_day, :birthday_internal, :TITLE);

  if (:old_is_child <> :is_child) then begin
    --TODO rename guests with auto names to reflect the new is_child status
    update RESERV_DETAIL RD
    set    RD.ADULT_COUNT = RD.ADULT_COUNT + (2*:old_is_child - 1),
           RD.CHILD_COUNT = RD.CHILD_COUNT - (2*:old_is_child - 1)
    where  RD.RDB$DB_KEY = :rd_dbkey;

    update GUEST G
    set    G.IS_CHILD = :is_child
    where  G.RDB$DB_KEY = :g_dbkey;
  end

  if (:old_country_code is distinct from :country_code) then begin
    update RESERV_DETAIL RD
    set    RD.COUNTRY = :country_code
    where  RD.RDB$DB_KEY = :rd_dbkey;
  end
end
^

/* Restore proc. body: IMPORT_BOOKING$EXC */
ALTER PROCEDURE IMPORT_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(250),
MAINTANCE_SHEMA VARCHAR(30),
POSTING_ROUTING VARCHAR(20),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
COMPLIMENTARY_ACCOUNT VARCHAR(50),
EATING_OBJECT VARCHAR(50),
CREATE_DATETIME TIMESTAMP)
 RETURNS(HOTEL_ID INTEGER,
BOOKING_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable current_hotel_id integer;
declare variable booking_update_id integer;
declare variable warn_code integer;
declare variable share_transaction_id integer;
declare variable share_err_code integer;
declare variable arranger_profile_id integer;
declare variable main_guest_profile_id integer;
declare variable rate_id integer;
declare variable room_type_id integer;
declare variable board_id integer;
declare variable maintance_shema_id integer;
declare variable arranger_payment_type_id integer;
declare variable guest_payment_type_id integer;
declare variable marketing_segment_id integer;
declare variable marketing_source_code_id integer;
declare variable marketing_channel_code_id integer;
declare variable marketing_hear_reason_id integer;
declare variable marketing_come_reason_id integer;
declare variable arranger_account_id integer;
declare variable packet_id integer;
declare variable id_guarantee_policy integer;
declare variable first_food_code tfood_code;
declare variable arrival_type_code smallint;
declare variable booking_dbkey char(8);
declare variable reserv_group_id integer;
declare variable id_complimentary_account integer;
declare variable id_eating_object integer;
begin
  /*execute procedure sys_dbg('exc IMPORT_BOOKING$EXC('
  || 'hotel => ' || coalesce(:hotel, '<null>')
  || ', booking_number => ' || coalesce(:number, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  ||')');
  */
  execute procedure import_mark_transaction$exc;

  /* init */
  err_code = 0;
  err_text = '';
  booking_update_id = null;
  booking_dbkey = null;
  current_hotel_id = null;
  if (:voucher_date is not null) then begin
    voucher_date = striptime(:voucher_date);
  end
  posting_routing = upper(:posting_routing);

  /* detect inser/update mode */
  select b.id_reserv_detail, b.rdb$db_key, b.id_hotel
  from   reserv_detail b
  where  b.number=:number
         and b.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and b.id_log_event_annul is null
  into   :booking_update_id, :booking_dbkey, :current_hotel_id;

  if (:booking_update_id is null) then begin
    booking_id = gen_id (id_reserv_detail_gen, 1);
  end else begin
    booking_id = :booking_update_id;
  end

  /* text to id map */
  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => MAP_BOOKING_RELATIONS$EXC');
  execute procedure MAP_BOOKING_RELATIONS$EXC(
    :booking_id,
    :hotel,
    :room_type,
    :board,
    :maintance_shema,
    :rate,
    :arranger_payment_type,
    :guest_payment_type,
    :marketing_segment,
    :marketing_source_code,
    :marketing_channel_code,
    :marketing_hear_reason,
    :marketing_come_reason,
    :first_food,
    :arranger_profile_uuid,
    :arranger_profile_name,
    :main_guest_profile_uuid,
    :arrival_type,
    :guarantee_policy,
    :eating_object
  ) returning_values
    :arranger_profile_id,
    :main_guest_profile_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :hotel_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :first_food_code,
    :arrival_type_code,
    :id_guarantee_policy,
    :id_eating_object;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* hotel change test */
  if (coalesce(:current_hotel_id, :hotel_id) <> :hotel_id) then begin
    execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', null, :hotel, 'booking hotel changed');
  end

  id_complimentary_account = null;
  if (complimentary_account is not null) then begin
    execute procedure lookup_account$exc(:hotel_id, :complimentary_account, 'booking', :booking_id)
    returning_values :id_complimentary_account;
  end

  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => CREATE_PACK_INSTANCE$EXC');
  packet_id = null;
  /*execute procedure CREATE_PACK_INSTANCE$EXC(
    :hotel_id, :booking_id, :package
  )
  returning_values :packet_id, :err_code, :err_text;
  if (0 <> :err_code) then exit;
  */
  /* merge input and default/persistent database values */
  execute procedure DEFAULT_BOOKING_VALUES$EXC(
    :booking_dbkey, :hotel_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :group_name,
    :group_uuid,
    :is_late_departure,
    :id_eating_object
  ) returning_values
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :arranger_account_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :reserv_group_id,
    :is_late_departure,
    :id_eating_object;

  if ('' = :board) then board_id = null; /* preserve "empty board" state and discard default value */

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC DEFAULTED => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* if the booking is complimentary use complimentary account */
  arranger_account_id = coalesce(:id_complimentary_account, :arranger_account_id);

  /* CREATE or UPDATE */
  if (:booking_update_id is not null) then begin
    /* UPDATE booking */
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => UPDATE_BOOKING$EXC');
    execute procedure UPDATE_BOOKING$EXC(
      :booking_id,
      :reserv_group_id,
      :is_vip,
      :arrival,
      :arrival_type_code,
      :departure,
      :is_late_departure,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :room_type_id,
      :board_id,
      :room_preferences,
      :special_treatment,
      :maintance_shema_id,
      :posting_routing,
      :arranger_account_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :deposit_required,
      :deposit_required_currency,
      :arranger_payment_type_id,
      :guest_payment_type_id,
      :voucher,
      :voucher_date,
      :voucher_text,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :note,
      :note_reminders,
      :first_food_code,
      :arranger_profile_id,
      :main_guest_profile_id,
      :is_different_rate,
      :is_different_price,
      :split_on_checkin,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object
    ) returning_values :err_code, :err_text;
    if (0 <> :err_code) then begin
      exit;
    end
  end else begin
    /* CREATE booking */
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => RES_CREATE_SET$EXC');
    execute procedure RES_CREATE_SET$EXC (
      :booking_id,
      :number,
      :arranger_profile_id,
      :main_guest_profile_id,
      :arrival,
      :departure,
      :adult_count,
      :children_count,
      :room_type_id,
      null,
      :board_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :voucher,
      :voucher_date,
      :voucher_text,
      null,
      null,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :arrival_type_code,
      :is_late_departure,
      :is_vip,
      :first_food_code,
      :special_treatment,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :arranger_account_id,
      :posting_routing,
      :guest_payment_type_id,
      :arranger_payment_type_id,
      null,
      :room_preferences,
      :maintance_shema_id,
      :note,
      :note_reminders,
      :deposit_required,
      :deposit_required_currency,
      :hotel_id,
      :reserv_group_id,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object,
      :create_datetime
      )
    returning_values :err_code, :err_text, :warn_code, :booking_id, :share_transaction_id, :share_err_code;
  end

  execute procedure GUEST_STAY_INITIALIZE$INT (:booking_id);
  /* final error check */
  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;

  delete from PENDING_DEPOSIT d
  where  d.ID_RESERV_DETAIL = :BOOKING_ID;
end
^

/* Restore proc. body: IMPORT_PERSON_PROFILE$EXC */
ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
CLEAR_HOTEL_RATE SMALLINT,
CREATE_ONLY SMALLINT,
MERGE_TARGET_UUID VARCHAR(40))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
declare variable op varchar(10);
  declare variable market_segment_id integer;
  declare variable sex_old char(1);
  declare variable birth_date_old date;
  declare variable birth_place_old varchar(30);
  declare variable personal_number_old varchar(30);
  declare variable pass_num_old varchar(20);
  declare variable pass_date_old date;
  declare variable pass_place_old varchar(20);
  declare variable pass_exp_date_old date;
  declare variable pass_city_old varchar(100);
  declare variable pass_address_old varchar(100);
  declare variable country_old varchar(10);
  declare variable mask_old varchar(10);
  declare variable title_old varchar(10);
  declare variable id_photo integer;
  declare variable id_def_contragent integer;
  declare variable id_passport_type integer;
  declare variable account_no_old varchar(20);
  declare variable msg_old varchar(255);
  declare variable id_guest_type integer;
  declare variable id_guest_type_old integer;
  declare variable card_code_old varchar(50);
  declare variable is_exclusive_debt_ownership smallint;
  declare variable profile_receiver_id integer;
begin
  profile_id = null;
  import_time = null;

  execute procedure import_mark_transaction$exc;

  /*FIXME - remove this block*/
  if (1 = :create_only) then begin
    clear_hotel_rate = 0;
  end else begin
    clear_hotel_rate = 1;
  end

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC(:profile_uuid=>' || coalesce(:profile_uuid, '<null>')
                          || ', email=>' || coalesce(:email, '<null>') || ')');

  profile_id = null;
  if (profile_uuid is null) then begin
    execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC <null> :profile_uuid - exit;');
    exit;
  end

  select p.profile_id, p.profile_name, p.phone, p.fax, p.email, p.city,
         p.address, p.market_segment, p.note, p.is_archive, pp.card_code,
         pd.sex, pd.birthday_internal, pd.birth_place, pd.egn, pd.pass_num,
         pd.pass_date, pd.pass_place, pd.pass_exp_date, pd.city, pd.address, pd.country_code,
         pd.mask, p.id_def_contragent, p.wbe_password,
         pd.title, p.account_no, p.msg, pp.id_guest_type, pp.id_photo, pd.id_passport_type,
         p.is_exclusive_debt_ownership
  from   import_common_profile$exc(:profile_uuid, 0, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :wbe_password, :ACCOUNT_NO, :MSG, 'PERSON_PROFILE', :CLEAR_HOTEL_RATE) p
         left outer join profile_person pp on pp.id_profile = p.profile_id
         left outer join person_data pd on pd.id_person_data=pp.id_person_data
  into   :profile_id, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :card_code_old,
         :sex_old, :birth_date_old, :birth_place_old, :personal_number_old, :pass_num_old,
         :pass_date_old, :pass_place_old, :pass_exp_date_old, :pass_city_old, :pass_address_old, :country_old,
         :mask_old, :id_def_contragent, :wbe_password, :title_old,
         :account_no_old, :msg_old, :id_guest_type_old, :id_photo, :id_passport_type, :is_exclusive_debt_ownership;

  if (:profile_id is null) then begin
    op = 'add';
  end else if (1 = :create_only) then begin
    profile_id = null;
    exit;
  end else begin
    op = 'mod';
    delete from PROFILE_HOTEL_RATE phr
      where phr.ID_PROFILE = :profile_id;
    delete from PROFILE_BONUSPOINT_SCHEME bs
      where bs.ID_PROFILE = :profile_id;
  end

  sex=coalesce(:sex, :sex_old);
  birth_date=coalesce(:birth_date, :birth_date_old);
  birth_place=coalesce(:birth_place, :birth_place_old);
  personal_number=coalesce(:personal_number, :personal_number_old);
  pass_num=coalesce(:pass_num, :pass_num_old);
  pass_date=coalesce(:pass_date, :pass_date_old);
  pass_place=coalesce(:pass_place, :pass_place_old);
  pass_exp_date=coalesce(:pass_exp_date, :pass_exp_date_old);
  pass_city=coalesce(:pass_city, :pass_city_old);
  pass_address=coalesce(:pass_address, :pass_address_old);
  country=upper(coalesce(:country, :country_old));
  mask=coalesce(:mask, :mask_old);
  title=coalesce(:title, :title_old);
  account_no=coalesce(:account_no, :account_no_old);
  msg=coalesce(:msg, :msg_old);
  card_code=coalesce(:card_code, :card_code_old);

  execute procedure IMPORT_PASSPORT_TYPE$EXC(:pass_type_name, :pass_type_external_code)
  returning_values :id_passport_type;

  execute procedure lookup_market_segment$exc(:profile_name, 'PERSON_PROFILE', :market_segment)
  returning_values :market_segment_id;

  if (guest_type_name is not null) then begin
    execute procedure lookup_guest_type$exc(:profile_name, 'PERSON_PROFILE', :guest_type_name)
    returning_values :id_guest_type;
  end

  if ((def_contragent_name is not null) and (def_contragent_name <> '')) then begin
    execute procedure LOOKUP_CONTRAGENT$EXC(:profile_name, 'PERSON_PROFILE', :def_contragent_name)
    returning_values :id_def_contragent;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:profile_name, 'PERSON_PROFILE');

  id_guest_type=coalesce(:id_guest_type, :id_guest_type_old);

  if (id_photo is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, null, null, null, 'del')
    returning_values :id_photo;
  end
  id_photo = null;
  if (picture is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, :picture, :picture_type, :picture_layout, 'add')
    returning_values :id_photo;
  end

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC - profile_person_modify$profile(:profile_uuid=>'
    || coalesce(:profile_uuid, '<null>')
    || ', :operation=>' || coalesce(:op, '<null>')
    || ', :email=>' || coalesce(:email, '<null>')
    || ', :birth_date=>' || coalesce(:birth_date, '<null>')
  || ')');
  execute procedure profile_person_modify$profile(
    :profile_id,
    :id_guest_type,
    :profile_name,
    null,
    :sex,
    :birth_date,
    :birth_place,
    :personal_number,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :pass_place,
    :pass_exp_date,
    :country,
    :pass_city,
    :pass_address,
    :mask,
    :phone,
    :fax,
    :email,
    :city,
    :address,
    :note,
    :msg,
    :id_def_contragent,
    :market_segment_id,
    :is_archive,
    :id_photo,
    :card_code,
    :wbe_password,
    :op,
    :account_no,
    :title,
    :is_exclusive_debt_ownership
  ) returning_values
    :profile_id;

  /*assign uuid to the new profiles*/
  if ('add' = :op) then begin
    update profile set uuid=:profile_uuid where id_profile=:profile_id;
  end

  select record_timestamp from profile where id_profile=:profile_id
  into :import_time;

  if (:MERGE_TARGET_UUID is not null) then begin
    select p.ID_PROFILE
    from   PROFILE P
    where  P.UUID = :MERGE_TARGET_UUID
    into   :profile_receiver_id;

    execute procedure PROFILE_MERGE$PROFILE (:PROFILE_ID, :profile_receiver_id, 'merge');

  end

end
^

/* Restore proc. body: MONITOR_ROOM_GANT$HM */
ALTER PROCEDURE MONITOR_ROOM_GANT$HM(FROM_DATE DATE,
TO_DATE DATE,
IN_ROOM_NAME VARCHAR(10),
IN_ID_ROOM_TYPE INTEGER,
IN_FLOOR INTEGER,
ID_HOTEL INTEGER)
 RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(20),
GANT_FROM_DATE DATE,
GANT_TO_DATE DATE,
BUSY_GRP INTEGER)
 AS
declare variable id_occupant integer;
begin
  for
    select R.ID_ROOM, R.ROOM_NAME
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  RT.ID_HOTEL = :id_hotel
           and ((R.ID_ROOM_TYPE = :in_id_room_type) or (:in_id_room_type = -1))
           and ((:in_room_name = '') or (r.room_name like :in_room_name))
           and ((:in_floor = -1) or (R.FLOOR = :in_floor))
    order by R.ROOM_NAME
    into :id_room, :room_name
  do begin
    gant_from_date = null;
    gant_to_date = null;
    busy_grp = null;
    suspend;

    for
      select distinct
             RM.ID_RESERV_DETAIL, RM.BUSY_GROUP_TYPE
      from   ROOM_MAGIC RM
      where  RM.BUSY_DATE between :from_date and :to_date
             and RM.ID_ROOM = :id_room
      into   :id_occupant, :busy_grp
    do begin
      select O.FROM_DATE, O.TO_DATE
      from   OCCUPANT_GET_INFO(:id_occupant, :busy_grp) O
      into   :gant_from_date, :gant_to_date;

      suspend;
    end
  end
end
^

/* Restore proc. body: NON_DOCUMENTED_INFO_GET$INT */
ALTER PROCEDURE NON_DOCUMENTED_INFO_GET$INT(ID_OWNER INTEGER,
ID_ROOM INTEGER)
 RETURNS(OUT_LATE_INFO VARCHAR(255),
OUT_CURR_INFO VARCHAR(255),
OUT_NEXT_INFO VARCHAR(255))
 AS
declare variable from_date date;
declare variable to_date date;
declare variable value_post_total numeric(15,4);
declare variable curr_post varchar(3);
declare variable sub_delim varchar(3);
declare variable short_date_format varchar(50);
declare variable value_format varchar(50);
declare variable has_next smallint;
declare variable tmp_info varchar(5000);
declare variable billing_type varchar(10);
declare variable prev_billing_type varchar(10);
declare variable is_first smallint;
begin
  if (:ID_OWNER is null) then exit;

  OUT_LATE_INFO = null;
  OUT_CURR_INFO = null;
  OUT_NEXT_INFO = null;
  tmp_info = null;

  from_date = '01.01.1500';
  sub_delim = '/ ';
  short_date_format = 'D;dd.mm';
  value_format = 'F;0.00';

  is_first = 1;
  for
    select P.BILLING_PERIOD_FROM, P.BILLING_DATE, P.BILLING_TYPE
    from   PMS_BILLING_CYCLE_CALC(:id_owner) P
    into   :FROM_DATE, :TO_DATE, :billing_type
  do begin
    has_next = 0;
    if (:PREV_BILLING_TYPE <> :BILLING_TYPE) then
      tmp_info = null;

    tmp_info = coalesce(trim(:tmp_info) || '; ', '');

    if (:BILLING_TYPE in ('current', 'late') and :to_date is not null) then
        tmp_info = :tmp_info || formatdate(:to_date, :short_date_format) || :sub_delim;

    if (:ID_OWNER is not null) then begin
      for
      /*  select sum(P.VALUE_POST * iif(P.IS_OWNER_INCOME = 1, 1, -1)), P.CURR_POST
        from   PMS_ACC_POST_TO_BILL_GET$INT(:ID_OWNER, :ID_ROOM, iif(:IS_FIRST=1,'01.01.1500',:FROM_DATE), coalesce(:TO_DATE, '01.01.2500'), 0) P
        group by 2
        into   :value_post_total, :curr_post  */
        select   sum(coalesce(OP.INCOME_VALUE, OP.OUTGO_VALUE) * iif(coalesce(APP.IS_OWNER_INCOME, 0) = 1, 1, -1)), coalesce(OP.INCOME_CURR, OP.OUTGO_CURR)
        from     OWNER_POST OP
                 left outer join ACCOUNT_POST$PMS  APP on APP.ID_ACCOUNT_POST = OP.ID_ACCOUNT_POST$PMS
        where    OP.ID_OWNER = :id_owner
                 and ((OP.ID_ROOM = :id_room) or (:id_room is null))
                 and OP.POST_DATE between iif(:IS_FIRST=1, cast('01.01.1500' as date), :FROM_DATE) and coalesce(:TO_DATE, cast('01.01.2500' as date))
                 and OP.IS_ANUL = 0
        group by 2
        into     :value_post_total, :curr_post
      do begin
        tmp_info = trim(:tmp_info) || iif(:has_next = 1, ', ', '');
        tmp_info = iif(:tmp_info = '', '', trim(:tmp_info) || ' ') || FORMATFLOAT(:VALUE_POST_TOTAL, :value_format) || ' ' || :CURR_POST;
        has_next = 1;
      end
    end

    if (:has_next = 0) then begin
      select O.ID_CURRENCY
      from   OWNER$PMS O
      where  O.ID_OWNER = :ID_OWNER
      into   :CURR_POST;

      if (:billing_type in ('late', 'current')) then
        tmp_info = iif(:tmp_info = '', '', trim(:tmp_info) || ' ') || FORMATFLOAT(0, :value_format) || ' ' || :CURR_POST;
    end
    if (:billing_type = 'late') then OUT_LATE_INFO = substring(:tmp_info from 1 for 254);
    if (:billing_type = 'current') then OUT_CURR_INFO = substring(:tmp_info from 1 for 254);
    if (:billing_type = 'next') then OUT_NEXT_INFO = substring(:tmp_info from 1 for 254);
    prev_billing_type = :billing_type;
    is_first = 0;
  end
  suspend;
end
^

/* Restore proc. body: OCCUPANCY_OVERBOOK$INT */
ALTER PROCEDURE OCCUPANCY_OVERBOOK$INT(ID_AGENT INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM_TYPE INTEGER,
RESERV_STATUS VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable must_check_overbook integer;
  declare variable maxbook_date  date;
  declare variable maxbook_rooms  integer;
  declare variable agent_maxbook_date date;
  declare variable agent_maxbook_rooms integer;
  declare variable id_inventory_allotment integer;
  declare variable id_agent_contingent integer;
  declare variable available_rooms integer;
  declare variable problem_date date;
  declare variable room_type varchar(20);
  declare variable id_hotel integer;
begin
  /* 1. DEALING WITH THE TOTAL OVERBOOK.
  || 2. DEALING WITH THE CONTINGENT OVERBOOK.
  */
  err_code = 0;
  err_text = '';
  warn_code = null;

  /* CHECK THE TOTAL HOTEL AVAILABILITY*/
  select H.ID_INVENTORY_ALLOTMENT, RT.TYPE_ROOM, h.ID_HOTEL
  from   ROOM_TYPES RT
         join HOTEL H on H.ID_HOTEL = RT.ID_HOTEL
  where  RT.ID_ROOM_TYPE = :id_room_type
  into   :id_inventory_allotment, :room_type, :id_hotel;

  if (:reserv_status = 'VALUE_RESERVS') then begin
    must_check_overbook = 0;
  end else begin
    execute procedure SETTING_GET_VALUE('CHECK_OVERBOOK', :id_hotel)
    returning_values  :must_check_overbook;
  end

  if (:must_check_overbook = 0) then exit;
  /* ********************************** */
  execute procedure OCCUPANCY_OVERBOOK_MAX$INT(:from_date, :to_date, :id_inventory_allotment, :id_room_type)
  returning_values  :maxbook_date, :maxbook_rooms, :available_rooms;

  if (:available_rooms < 0) then begin
    problem_date = :maxbook_date;
    err_text = substring(f_character(29)||cast(abs(:available_rooms) as integer)||f_character(28)||FormatDate(:problem_date, 'D;dd.mm.yyyy')||f_character(28)||:room_type from 1 for 255);

    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_TOTAL_OVERBOOK');

    execute procedure SYSTEM_WARNING_ADD(-95, :err_text)
    returning_values :warn_code;

    when exception RIGHT_NOT_GRANTED do begin
      err_code = -94;
      exit;
    end
  end

  /* check agent contingent overbooko *****************************************/
  select PA.ID_CONTINGENT
  from   PROFILE_AGENT PA
  where  PA.ID_AGENT = :id_agent
  into   :id_agent_contingent;

  if (:id_agent_contingent is not null) then begin
    /* CHECK THE AGENT CONTINGENT AVAILABILITY*/
    execute procedure OCCUPANCY_OVERBOOK_MAX$INT(:from_date, :to_date, :id_agent_contingent, :id_room_type, :id_agent)
    returning_values  :agent_maxbook_date, :agent_maxbook_rooms, :available_rooms;
  
    if (:available_rooms < 0) then begin
      problem_date = :agent_maxbook_date;
      err_text = f_character(29)||FormatDate(:problem_date, 'D;dd.mm.yyyy')||f_character(28)||:room_type||f_character(28)||cast(abs(:available_rooms) as integer);
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CONT_OVERBOOK');

      execute procedure SYSTEM_WARNING_ADD(-97, :err_text)
      returning_values :warn_code;

      when exception RIGHT_NOT_GRANTED do begin
        err_code = -96;
        exit;
      end
    end
  end
end
^

/* Restore proc. body: OWNER_BILL_MODIFY$PMS */
ALTER PROCEDURE OWNER_BILL_MODIFY$PMS(ID_OWNER_BILL INTEGER,
ID_OWNER INTEGER,
BILLING_DATE DATE,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_OWNER_BILL INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_anul smallint;
  declare variable bill_num integer;
  declare variable id_account_post_pms integer;
  declare variable id_account_post integer;
  declare variable prev_id_owner_bill integer;
  declare variable prev_billing_date date;

  declare variable id_account integer;
  declare variable id_account_pms integer;
  declare variable value_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable value_post numeric(15,4);
  declare variable curr_post varchar(3);
  declare variable is_owner_income smallint;
  declare variable id_service integer;
  declare variable id_room integer;
  declare variable date_post date;
  declare variable id_reserv_detail integer;
  declare variable doc_description varchar(255);
  declare variable id_doc_head integer;
  declare variable description varchar(255);
  declare variable id_pms_event integer;
  declare variable is_client_account_post smallint;
begin
  err_code = 0;
  err_text = '';
  is_client_account_post = null;
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'create, anul');

  if ( exists ( select *
                from   OWNER$PMS O
                where  O.ID_OWNER = :ID_OWNER
                       and O.ID_RENTAL_POOL_UNIT is not null ) ) then
  begin
    exception PMS_EXCEPTION 'selected owner is pool!';
  end

  if (:operation = 'create') then begin
    is_anul = 0;

    if ( (:ID_OWNER_BILL is null) or (:ID_OWNER_BILL <= 0) )  then
      NEW_ID_OWNER_BILL = gen_id(GEN_OWNER_BILL$PMS_ID, 1);
    else
      NEW_ID_OWNER_BILL = :ID_OWNER_BILL;

    BILL_NUM = :NEW_ID_OWNER_BILL;
    insert into OWNER_BILL$PMS (ID_OWNER_BILL, ID_OWNER, BILL_DATE, IS_ANUL, BILL_NUM,
           IS_EXPORTED_TO_INTRANET, IS_POOL_DISTRIBUTION_STATEMENT)
    values (:NEW_ID_OWNER_BILL, :ID_OWNER, :BILLING_DATE, :IS_ANUL, :BILL_NUM, 0, 0);

    update OWNER$PMS O
    set    O.LAST_BILLING_DATE = :billing_date,
           O.ID_OWNER_BILL = :NEW_ID_OWNER_BILL
    where  O.ID_OWNER = :ID_OWNER;

    for
    /*  select ID_ACCOUNT_POST, ID_ACCOUNT_POST_PMS
      from   PMS_ACC_POST_TO_BILL_GET$INT(:ID_OWNER, null, '01.01.1500', :BILLING_DATE, 1)
      into   :ID_ACCOUNT_POST, :ID_ACCOUNT_POST_PMS */
      select   OP.ID_ACCOUNT_POST, OP.ID_ACCOUNT_POST$PMS
      from     OWNER_POST OP
      where    OP.ID_OWNER = :id_owner
               and OP.POST_DATE between cast('01.01.1500' as date) and :billing_date
               and OP.IS_ANUL = 0
      order by OP.ID_ACCOUNT_POST$PMS nulls last
      into     :ID_ACCOUNT_POST, :ID_ACCOUNT_POST_PMS
    do begin
      if (:id_account_post_pms is not null) then begin

        update ACCOUNT_POST$PMS A
        set    A.LINE_STATUS = 21
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS;

        id_account = null;
        select ACC.ID_SERVICE, ACC.VALUE_ORIG, ACC.CURR_ORIG, ACC.VALUE_POST, ACC.CURR_POST,
               ACC.IS_OWNER_INCOME, ACC.DATE_POST, ACC.ID_ACCOUNT_PMS, E.ID_ROOM,
               E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION, A.IS_CLIENT_POOL_ACCOUNT
        from   ACCOUNT_POST$PMS ACC
               join ACCOUNT$PMS A on A.ID_ACCOUNT = ACC.ID_ACCOUNT_PMS
               join PMS_EVENT$PMS E on E.ID_PMS_EVENT = ACC.ID_PMS_EVENT
        where  ACC.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
        into   :ID_SERVICE, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
               :IS_OWNER_INCOME, :DATE_POST, :ID_ACCOUNT_PMS, :ID_ROOM,
               :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION, :is_client_account_post;
      end

      if (:id_account_post is not null) then begin
        exception PMS_EXCEPTION '-613';
          
        is_client_account_post = 1;
        update PMS_EVENT_POST A
        set    A.LINE_STATUS = 21
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST;

        id_account_pms = null;
        select ACC.ID_SERVICE, ACC.PRICE_ORIG, ACC.CURR_ORIG, ACC.PRICE_POST, ACC.CURR_POST,
               0, ACC.DATE_POST, ACC.ID_ACCOUNT, E.ID_ROOM,
               E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION
        from   ACCOUNT_POST ACC
               join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = ACC.ID_ACCOUNT_POST
               join PMS_EVENT$PMS E on E.ID_PMS_EVENT = PP.ID_PMS_EVENT
        where  ACC.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
        into   :ID_SERVICE, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
               :IS_OWNER_INCOME, :DATE_POST, :ID_ACCOUNT, :ID_ROOM,
               :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION;
      end

      insert into OWNER_BILL_ROW$PMS (ID_OWNER_BILL, ID_ACCOUNT_POST,
             ID_ACCOUNT, ID_ACCOUNT_POST_PMS, ID_ACCOUNT_PMS, ID_SERVICE, VALUE_ORIG,
             CURR_ORIG, VALUE_POST, CURR_POST, IS_OWNER_INCOME, ID_ROOM, DATE_POST,
             ID_RESERV_DETAIL, DOC_DESCRIPTION, ID_DOC_HEAD, DESCRIPTION, IS_CLIENT_ACCOUNT_POST)
      values (:new_id_owner_bill, :ID_ACCOUNT_POST, :ID_ACCOUNT,
             :ID_ACCOUNT_POST_PMS, :ID_ACCOUNT_PMS, :ID_SERVICE, :VALUE_ORIG,
             :CURR_ORIG, :VALUE_POST, :CURR_POST, :IS_OWNER_INCOME, :ID_ROOM, :DATE_POST,
             :ID_RESERV_DETAIL, :DOC_DESCRIPTION, :ID_DOC_HEAD, :DESCRIPTION, :is_client_account_post);
    end
  end
  if (:operation = 'anul') then begin
    select O.ID_OWNER, O.IS_ANUL
    from   OWNER_BILL$PMS O
    where  O.ID_OWNER_BILL = :ID_OWNER_BILL
    into   :id_owner, :is_anul;
    if (:is_anul = 1) then exit;

    select first 1 B.ID_OWNER_BILL
    from   OWNER_BILL$PMS B
    where  B.ID_OWNER = :id_owner
           and B.IS_ANUL = 0
    order by B.BILL_DATE desc
    into   :prev_id_owner_bill;
    if (:prev_id_owner_bill <> :id_owner_bill) then exception PMS_EXCEPTION '-619';

    select first 1 O.ID_OWNER_BILL, O.BILL_DATE
    from   OWNER_BILL$PMS O
    where  O.ID_OWNER = :ID_OWNER
           and o.IS_ANUL = 0
           and O.ID_OWNER_BILL <> :ID_OWNER_BILL
    order by O.BILL_DATE desc
    into   :prev_id_owner_bill, :prev_billing_date;

    update OWNER$PMS O
    set    O.LAST_BILLING_DATE = :prev_billing_date,
           O.ID_OWNER_BILL = :prev_id_owner_bill
    where  O.ID_OWNER = :ID_OWNER;

    update OWNER_BILL$PMS B
    set    B.IS_EXPORTED_TO_INTRANET = 0,
           B.IS_ANUL = 1
    where  B.ID_OWNER_BILL = :ID_OWNER_BILL;

    for
      select O.ID_ACCOUNT_POST, O.ID_ACCOUNT_POST_PMS
      from   OWNER_BILL_ROW$PMS O
      where  O.ID_OWNER_BILL = :ID_OWNER_BILL
      into   :id_account_post, :id_account_post_pms
    do begin
      if (:id_account_post_pms is not null) then begin
        update ACCOUNT_POST$PMS A
        set    A.LINE_STATUS = 11
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
               and A.LINE_STATUS = 21;
      end

      if (:id_account_post is not null) then begin
        update PMS_EVENT_POST A
        set    A.LINE_STATUS = 11
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and A.LINE_STATUS = 21;
      end
    end

    for
      select distinct AP.ID_PMS_EVENT
      from   OWNER_BILL_ROW$PMS R
             join OWNER_BILL$PMS B on B.ID_OWNER_BILL = R.ID_OWNER_BILL
             join ACCOUNT_POST$PMS AP on AP.ID_ACCOUNT_POST = R.ID_ACCOUNT_POST_PMS
             join PMS_EVENT$PMS E on E.ID_PMS_EVENT = AP.ID_PMS_EVENT
      where  R.ID_OWNER_BILL = :ID_OWNER_BILL
             and E.EVENT_TYPE = 'POOL_DISTRIBUTION'
             and B.IS_POOL_DISTRIBUTION_STATEMENT = 1
      into   :id_pms_event
    do begin
      execute procedure PMS_EVENT_VOID$INT(:id_pms_event);
    end
  end
end
^

/* Restore proc. body: PAYMENT_ANUL$INT */
ALTER PROCEDURE PAYMENT_ANUL$INT(ID_PAYMENT_HEAD INTEGER,
ANUL_REASON VARCHAR(100))
 AS
declare variable p_dbkey char(8);
  declare variable id_ar_payment integer;
  declare variable id_payment_storned integer;
  declare variable payment_amount numeric(15,4);
  declare variable pay_currency varchar(3);
  declare variable system_date date;
  declare variable id_hotel integer;
  declare variable id_system_log integer;
  declare variable id_deposit integer;
  declare variable is_posting_stopped integer;
  declare variable round_to numeric(15,4);
begin 
  execute procedure PAYMENT_VOID_CHECK$INT (:ID_PAYMENT_HEAD, :ANUL_REASON);

  select P.RDB$DB_KEY, p.ID_PAYMENT_STORNED, P.PAY_VALUE_A, P.PAY_CURRENCY,
         P.ID_AR_PAYMENT, a.ID_HOTEL, p.ID_DEPOSIT, c.ROUND_TO
  from   PAYMENT_HEAD P
         join ACCOUNT A on A.ID_ACCOUNT = p.ID_ACCOUNT
         join CURRS c on c.CURR = p.PAY_CURRENCY
  where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  into   :p_dbkey, :id_payment_storned, :payment_amount, :pay_currency,
         :id_ar_payment, :id_hotel, :id_deposit, :round_to;

  if (:id_ar_payment is not null) then
    exception PAYMENT_ANNUL_EXCEPTION '-353';
    --'Payment is created from AR module.';

  if (:id_deposit is not null) then begin
    select r.IS_POSTING_STOPPED
    from   DEPOSIT d
           join RESERV_DETAIL r on r.ID_RESERV_DETAIL = d.ID_RESERV_DETAIL
    where  d.ID_DEPOSIT = :id_deposit
    into   :is_posting_stopped;

    if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';
  end

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :system_date;

  insert into ACCOUNT_PAYMENTS (ID_ACCOUNT, ID_PAYMENT_HEAD, PAY_AMOUNT, PAY_RATE,
         ACC_AMOUNT, ACC_RATE, TRANSACTION_DATE, ID_DEPOSIT)
  select AP.ID_ACCOUNT, AP.ID_PAYMENT_HEAD, -sum(AP.PAY_AMOUNT), AP.PAY_RATE,
         -sum(AP.ACC_AMOUNT), AP.ACC_RATE, :system_date, AP.ID_DEPOSIT
  from   ACCOUNT_PAYMENTS AP
  where  AP.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  group by AP.ID_ACCOUNT, AP.ID_PAYMENT_HEAD, AP.PAY_RATE, AP.ACC_RATE, AP.ID_DEPOSIT
  having round_f(sum(AP.PAY_AMOUNT), :round_to) <> 0;
                            
  if (:id_payment_storned is not null) then begin
    update PAYMENT_HEAD SP
    set    sp.IS_STORNED = 0
    where  sp.ID_PAYMENT_HEAD = :id_payment_storned;
  end

  execute procedure SYSTEM_EVENT_LOG$INT ('PAYMENT', :ID_PAYMENT_HEAD, 'ANNUL', f_character(29) || formatfloat(:payment_amount, 'F;0.00') || ' ' || :pay_currency || f_character(28) || :ANUL_REASON)
  returning_values  :id_system_log;

  update PAYMENT_HEAD PA
  set    PA.IS_ANUL = 1,
         pa.ANNUL_DATE = :system_date,
         pa.ID_LOG_EVENT_ANNUL = :id_system_log
  where  PA.RDB$DB_KEY = :p_dbkey;

end
^

/* Restore proc. body: PHONECALL_POST$TC */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Restore proc. body: PHONECALLS_POST_TO_ACCOUNT$TC */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* Restore proc. body: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_OWNER TYPE OF ID,
POST_DATE TYPE OF TDATE,
CURR_ORIG TYPE OF TCURRENCY,
VALUE_ORIG TYPE OF TPRICE,
POST_ON_PMS_ACCOUNT TYPE OF TLOGICAL,
IS_OWNER_INCOME TYPE OF TLOGICAL,
ID_ROOM TYPE OF ID_REF = null)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  if (:POST_ON_PMS_ACCOUNT = 1) then begin
    execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account, :id_owner,
            :CURR_ORIG, :VALUE_ORIG, :id_service, :is_owner_income, :POST_DATE)
    returning_values  (:new_id_account_post);
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :ID_SERVICE, 1, 0, 1,
            :VALUE_ORIG, :CURR_ORIG, current_date, current_date,
            '', '', :POST_DATE, 'PMS', :ID_ROOM)
    returning_values  :err_code, :err_text, :new_id_account_post;
    if (:err_code <> 0) then exception PMS_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

    insert into PMS_EVENT_POST (ID_PMS_EVENT, ID_ACCOUNT_POST, ID_OWNER, LINE_STATUS)
    values (:ID_PMS_EVENT, :NEW_ID_ACCOUNT_POST, :ID_OWNER, 11);
  end
end
^

/* Restore proc. body: POST_SERVICE_FINALIZE$POST */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
  declare variable id_acc_post integer;
  declare variable id_service integer;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable date_post date;
  declare variable price_post numeric(15,4);
  declare variable qty_post numeric(15,2);
  declare variable post_text varchar(100);
  declare variable curr_post varchar(3);
  declare variable id_phonecall integer;
  declare variable p_dbkey char(8);
begin

  if (:OPERATION = 'clear') then begin
    delete from TMP_SERVICE_POST T
    where  T.ID_SEQUENCE = :ID_SEQUENCE;

  end else if (:OPERATION = 'store') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);

    for
      select TS.RDB$DB_KEY, TS.ID_SERVICE, TS.ID_ACCOUNT, TS.ID_GUEST, TS.DATE_POST,
             TS.PRICE_POST, TS.QTY_POST, TS.CURR_POST, TS.POST_TEXT, TS.ID_PHONECALL
      from   TMP_SERVICE_POST TS
      where  TS.ID_SEQUENCE = :ID_SEQUENCE
      into   :p_dbkey, :id_service, :id_account, :id_guest, :date_post,
             :price_post, :qty_post, :curr_post, :post_text, :id_phonecall
    do begin
      id_acc_post = null;
      if (:id_guest is not null) then begin
        execute procedure POST_SERVICE_ON_GUEST$INT (:id_guest, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :CURR_POST,
                :date_post, :date_post, :post_text, '', :date_post, '', '')
        returning_values  (:err_code, :err_text, :no_use, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end else begin
        execute procedure POST_SERVICE_ON_ACCOUNT$INT (:id_account, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :curr_post, :date_post, :date_post, :post_text,
                '', :date_post, '')
        returning_values  (:err_code, :err_text, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end

      update TMP_SERVICE_POST
      set ID_ACCOUNT_POST = :id_acc_post
      where RDB$DB_KEY = :p_dbkey;

      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :DOC_SELECTED,
             AP.SHORT_CODE = case
                               when :id_phonecall is not null then 'TELECOUNT'
                               else null
                             end
      where  AP.ID_ACCOUNT_POST = :id_acc_post;

      if (:id_phonecall is not null) then begin
        update PHONECALLS P
        set    P.ID_ACCOUNT_POST = :id_acc_post
        where  P.ID_PHONECALL = :id_phonecall;
      end
    end
  end
end
^

/* Restore proc. body: RES_CHECKIN$RSV */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable old_check_status integer;
  declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable is_anul integer;
  declare variable arrival_date date;
  declare variable system_date date;
begin
  /*  Description:
  ||
  */
  select RD.CHECK_STATUS, RD.RDB$DB_KEY, RD.FROM_DATE, RD.ID_HOTEL,
         RD.ID_ROOM, RD.IS_ANUL
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_check_status, :rd_dbkey, :arrival_date, :id_hotel,
         :old_id_room, :is_anul;

  if (:is_anul = 1) then exception BOOKING_EXCEPTION '-2';

  if (:old_check_status >= 0) then exception BOOKING_EXCEPTION '-1003';

  if (:old_id_room < 0 and coalesce(:ID_ROOM, 0) <= 0) then exception BOOKING_EXCEPTION '-1018';

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date < :arrival_date) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CHECK_IN_FUTURE');
  end
  /*----*/
  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'lock');

  execute procedure sys_dbg('occ RES_CHECKIN$RSV id_room = '||coalesce(:id_room, 'null'));
  execute procedure sys_dbg('occ RES_CHECKIN$RSV old_id_room = '||coalesce(:old_id_room, 'null'));

  if (:id_room is not null) then begin
    if (:old_check_status = -3) then begin
      execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, -2);
    end

    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option);
  end

  execute procedure RES_SET_CHECKIN$INT (:rd_dbkey)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'release');
  /*----*/
  select f_character(29) || R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = coalesce(:ID_ROOM, :old_id_room)
  into   :action_text;
   
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'CHECK_IN', :action_text);

end
^

/* Restore proc. body: RES_CHECKIN_MULTI$RSV */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable checkin_count integer;
  declare variable split_on_checkin integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
  declare variable tmp_warn_code integer;
begin
  checkin_count = 0;
  warn_code = null;
  for
    select RD.ID_RESERV_DETAIL, RD.CHECK_STATUS, RD.SPLIT_ON_CHECKIN, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :SELECTION_ID
    into   :id_reserv_detail, :check_status, :split_on_checkin, :id_titular
  do begin
    if (:check_status >= 0) then begin
      checkin_count = :checkin_count + 1;
    end else begin
      if (:split_on_checkin = 1) then begin
        for
          select G.ID_GUEST
          from   GUEST G
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and G.ID_GUEST <> :id_titular
          into   :id_guest
        do begin
          execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
          returning_values  :id_splited_reservation;

          execute procedure RES_CHECKIN$RSV (:id_splited_reservation)
          returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

          update RESERV_DETAIL RD
          set    RD.SELECTION_ID = :selection_id
          where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
        end
      end

      execute procedure RES_CHECKIN$RSV (:id_reserv_detail)
      returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
      WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end

  if (:checkin_count > 0) then begin
    execute procedure SYSTEM_WARNING_ADD(-1011, f_character(29)||:checkin_count)
    returning_values  :warn_code;
  end
end
^

/* Restore proc. body: RES_CREATE_SET$EXC */
ALTER PROCEDURE RES_CREATE_SET$EXC(ID_RESERV_DETAIL INTEGER,
RES_NUMBER VARCHAR(62),
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER,
CREATE_DATETIME TIMESTAMP)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_RESERV_DETAIL INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  WARN_CODE = 0;
  SHARE_TRANSACTION_ID = 0;
  SHARE_ERR_CODE = 0;

  execute procedure sys_dbg('exc RES_CREATE_SET$EXC => RES_CREATE_SET$INT('
  || 'code_first_food=>' || coalesce(:code_first_food, '<null>')
  || ', id_person_payment=>' || coalesce(:id_person_payment, '<null>')
  || ')');

  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, null, :arrival_date, :departure_date,
                    :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, '', :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders, :guarantee_deposit,
                    :guarantee_currency, 0, :id_reserv_detail, :res_number, null,  :id_guarantee_policy, :block_cc,
                    :id_eating_object)
  returning_values  :rd_dbkey, :new_id_reserv_detail;

  execute procedure UPDATE_POSTING_TRANSACTION$EXC(:rd_dbkey, :posting_transaction_uuid, 1);

  execute procedure RES_SAVE_GUARANTEE$RSV(:id_reserv_detail, :is_vip, null,
    :id_guarantee_policy, :guarantee_deposit, :guarantee_currency, :block_cc, :guarantee_deposit_percent,
    :guarantee_deposit_nights, :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create
  );

  execute procedure RESERV_DETAIL_EXTERNAL_MOD$RSV(:id_reserv_detail,
    :minibar_rights, :paytv_rights, :video_rights, :nopost_pms, :phone_rights,
    :seminar_cahnnel_rights, null
  );

  if (:create_datetime is not null) then begin
    update reserv_detail set create_datetime = :create_datetime where rdb$db_key = :rd_dbkey;
  end
end
^

/* Restore proc. body: RES_FINALIZE$INT */
ALTER PROCEDURE RES_FINALIZE$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable err_text varchar(255);
begin
  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, :SUPPRESS_NON_INSTANT_ERRORS)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;
  if (:share_err_code < 0) then exception BOOKING_EXCEPTION :share_err_code || f_character(31) || :ERR_TEXT;
end
^

/* Restore proc. body: RES_RECALC$INT */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable num_prefix varchar(20);
  declare variable number_1 varchar(20);
begin
  /* CALLER_KIND = {NORMAL, FORCED} */
  err_code = 0;

  /* 1. GET DATA */
  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL, rd.NUMBER_1
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :check_status, :id_reserv_detail, :number_1;

  if (:check_status = 1) then begin
    -- CHECKED OUT
    select sn.LEADING_PART
    from   SYSTEM_NUMERATOR SN
    where  sn.ID_NUMERATOR = 0
    into   :num_prefix;

    if (trim('.' from coalesce(:num_prefix, '')) = coalesce(:number_1, '')) then
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_MINE');
    else
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_ELSE');

    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :id_guest
    do begin
      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'MANUAL_EDIT_DATA', '');
    end
  end
  /* 2. FIND DEPENDANT GUESTS AND THEIR TARIFFS */
  execute procedure sys_dbg('calc RES_RECALC$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

  id_tar_calc = gen_id(gen_id_tar_calc, 1);
  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NONE');

  execute procedure TAR_CALC_EVAL_ALL$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  -- 3. UPDATE ROOM PRICE and REPOST ALL AFFECTED BOOKINGS
  execute procedure RES_TAR_CALC_FINALIZE$INT (:ERR_CODE, :ID_TAR_CALC, :RD_DBKEY, :CALLER_KIND, :FORCE_POSTING);

end
^

/* Restore proc. body: RES_ROOM_REMOVE$INT */
ALTER PROCEDURE RES_ROOM_REMOVE$INT(RD_DBKEY CHAR(8))
 RETURNS(WARN_CODE INTEGER)
 AS
begin

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, null, null, 'nrttAsIs');

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 0)
  returning_values  :WARN_CODE;

end
^

/* Restore proc. body: RES_SAVE_ROOM$EXC */
ALTER PROCEDURE RES_SAVE_ROOM$EXC(RD_DBKEY CHAR(8),
ID_RES_ROOM_TYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(250),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_room integer;
begin
  select RD.ID_ROOM, RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_room, :id_reserv_detail;

  execute procedure RES_SAVE_ROOM$RSV(
    :id_reserv_detail,
    :old_id_room,
    :id_res_room_type,
    'nrttAsIs',
    1,
    :id_hk_plan,
    :room_features,
    :i_special_treatment,
    :split_on_checkin,
    0
  ) returning_values :share_err_code, :err_text, :share_transaction_id, :warn_code;
end
^

/* Restore proc. body: RES_TAR_CALC_FINALIZE$INT */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(TAR_CALC_ERR INTEGER,
ID_TAR_CALC INTEGER,
RD_DBKEY_INIT CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
begin
  /*  Description:
  ||  Razpiswa cenata na staia, kakto i price_detailite.
      Za4istwa temp tablicite
  */
  --savedbg('TAR_CALC_ERR: ' || :TAR_CALC_ERR);
  --savedbg('ID_TAR_CALC: ' || :ID_TAR_CALC);
  if (:tar_calc_err = 0) then begin
    room_price = 0;
    room_price_details = '';

    execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

    for
      select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, rd.IS_POSTING_STOPPED,
             coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
             coalesce(max((select first 1 AP.IS_BASE
                           from   GUEST G
                                  join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                           where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                  and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (eventually)
      from   TAR_CALC_INPUT$TMP TI
             join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
             join TARIFA t on t.ID_TARIFA = rd.ID_RATE
      where  ti.ID_TAR_CALC = :ID_TAR_CALC
      group by 1, 2, 3, 4, 5, 6
      into   :id_reserv_detail, :check_status, :is_posting_stopped,
             :room_currency, :id_hotel, :is_anul, :has_postings
    do begin
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);

      if ( (not (:is_posting_stopped = 1 and :has_postings = 0))                                -- posting is not stopped
           and                                                                                  -- and
           ( (coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1) ) -- there are reasons to repost
         ) then
      begin

        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);

      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;

        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end

      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end else begin

    update RESERV_DETAIL RD
    set    RD.ROOM_PRICE = null,
           RD.ROOM_CURRENCY = null,
           RD.ROOM_PRICE_DETAILS = null,
           RD.LAST_ID_TAR_CALC = null
    where  RD.RDB$DB_KEY = :RD_DBKEY_INIT;
  end
  
  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;
end
^

/* Restore proc. body: RIGHTS_REGRANT */
ALTER PROCEDURE RIGHTS_REGRANT AS
declare variable relation_name char(31);
  declare variable ui_role_name char(31);
  declare variable ena_role_name char(31);
begin
  ui_role_name = 'CLOCKBS_ROLE';
  ena_role_name = 'HTTPDBA_ROLE';

  /* PRIVILEGES GIVEN DIRECTLY TO SOME DB USER MUST BE PRESERVED.
  || AUTOGRANTS ARE MADE ONLY TO THE 'UI' and 'ENA' ROLES AND 'PUBLIC' USER.
  */
  delete from RDB$USER_PRIVILEGES UP
  where  (UP.RDB$USER_TYPE not in (8 /* user*/, 13 /* role */));

  delete from RDB$USER_PRIVILEGES UP
  where  (UP.RDB$USER = :ui_role_name)
         or (UP.RDB$USER = :ena_role_name)
         or (UP.RDB$USER = 'PUBLIC');

  /* THE 'UI' ROLE MUST HAVE ALL PRIVILIGES LIKE THE USER 'SYSDBA'.
  || ONLY NATIVE CLOCKBS APPLICATIONS ARE USING THIS ROLE.
  */
  insert into RDB$USER_PRIVILEGES (RDB$USER, RDB$GRANTOR, RDB$PRIVILEGE, RDB$GRANT_OPTION,
         RDB$RELATION_NAME, RDB$FIELD_NAME, RDB$USER_TYPE, RDB$OBJECT_TYPE)
  select :ui_role_name, 'SYSDBA', U.RDB$PRIVILEGE, 0,
         U.RDB$RELATION_NAME, U.RDB$FIELD_NAME, 13, U.RDB$OBJECT_TYPE
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = 'SYSDBA'
         and (not exists (select u2.RDB$PRIVILEGE
                          from   RDB$USER_PRIVILEGES u2
                          where  u2.RDB$USER = :ui_role_name
                                 and u2.RDB$PRIVILEGE = U.RDB$PRIVILEGE 
                                 and u2.RDB$RELATION_NAME = u.RDB$RELATION_NAME))
         and U.RDB$PRIVILEGE <> 'M' /* MEMBERSHIP */;

  insert into RDB$USER_PRIVILEGES (RDB$USER, RDB$GRANTOR, RDB$PRIVILEGE, RDB$GRANT_OPTION,
         RDB$RELATION_NAME, RDB$FIELD_NAME, RDB$USER_TYPE, RDB$OBJECT_TYPE)
  select :ena_role_name, 'SYSDBA', U.RDB$PRIVILEGE, 0,
         U.RDB$RELATION_NAME, U.RDB$FIELD_NAME, 13, U.RDB$OBJECT_TYPE
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = 'SYSDBA'
         and u.RDB$RELATION_NAME starting with 'ENA_'
         and (not exists (select u2.RDB$PRIVILEGE
                          from   RDB$USER_PRIVILEGES u2
                          where  u2.RDB$USER = :ena_role_name
                                 and u2.RDB$PRIVILEGE = U.RDB$PRIVILEGE 
                                 and u2.RDB$RELATION_NAME = u.RDB$RELATION_NAME))
         and U.RDB$PRIVILEGE in ('S') /* Select (and Reference ??) */;

  /* GRANT REFERENCE RIGHT TO 'PUBLIC' FOR ALL TABLES THAT ARE REFERENCED WITH
  || FOREIGN KEYS.
  */
  insert into RDB$USER_PRIVILEGES (RDB$USER, RDB$GRANTOR, RDB$PRIVILEGE, RDB$GRANT_OPTION,
         RDB$RELATION_NAME, RDB$FIELD_NAME, RDB$USER_TYPE, RDB$OBJECT_TYPE)
  select distinct
         'PUBLIC', 'SYSDBA', 'R', 0, RC2.RDB$RELATION_NAME, null, 8, 0
  from   RDB$RELATION_CONSTRAINTS RC
         join RDB$REF_CONSTRAINTS C on C.RDB$CONSTRAINT_NAME = RC.RDB$CONSTRAINT_NAME
         join RDB$RELATION_CONSTRAINTS RC2 on RC2.RDB$CONSTRAINT_NAME = C.RDB$CONST_NAME_UQ
  where  RC.RDB$CONSTRAINT_TYPE = 'FOREIGN KEY';

  /* ALL EXTERNAL INTERFACES FROM OTHER VENDORS ARE NOT USING ROLES, SO
  || THEY WILL TAKE THE PRIVILEDGES OF THE 'PUBLIC' USER. THEY MUST HAVE
  || ACCESS ONLY TO THEIR SPECIFIC PROCEDURES OR OTHER METADATA OBJECTS WICH
  || MUST BE ENUMERATED HERE.
  */
  for
    select R.RDB$RELATION_NAME
    from   RDB$RELATIONS R
    where  (R.RDB$RELATION_NAME starting with 'EAI_')
           or (R.RDB$RELATION_NAME in ('SYSTEM_INFO_MODULE','PHONECALLS'))
    union

    select R.RDB$PROCEDURE_NAME
    from   RDB$PROCEDURES R
    where  (R.RDB$PROCEDURE_NAME starting with 'EAI_')
           or (R.RDB$PROCEDURE_NAME in ('SYSTEM_INFO_GET', 'RDB$F_SP'))
    into   :relation_name
  do begin
    execute procedure RIGHTS_REGRANT_SUB('PUBLIC', :relation_name, 8);
  end
end
^

/* Restore proc. body: ROOM_CONTRACT_MODIFY$PMS */
ALTER PROCEDURE ROOM_CONTRACT_MODIFY$PMS(ID_ROOM_CONTRACT INTEGER,
ID_ROOM_PERIOD INTEGER,
CONTRACT_TYPE VARCHAR(50),
PMS_MARKERS BLOB SUB_TYPE 1 SEGMENT SIZE 100,
IMPORT_INCOME_WITH_VAT SMALLINT,
ID_RENTAL_POOL INTEGER,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_CONTRACT INTEGER)
 AS
declare variable permissible_value_list varchar(255);
  declare variable from_date date;
  declare variable rental_pool_unit_name varchar(100);
  declare variable room_name varchar(10);
  declare variable old_contract_type varchar(50);
  declare variable old_import_income_with_vat smallint;
  declare variable old_from_date date;
  declare variable old_rental_pool_unit_name varchar(100);
  declare variable old_room_name varchar(10);
  declare variable old_id_room_period integer;
  declare variable new_id_room_period integer;
  declare variable id_room integer;
  declare variable action_text varchar(255);
begin

  permissible_value_list = '';
  select list(trim(S.KEY_))
  from   SYSTEM_ENUM S
  where  S.GROUP_ = 'pms.contract_type'
  into   :permissible_value_list;

  if (:operation in ('add', 'mod')) then begin
    execute procedure SYSTEM_CHECK_OPERATION(:contract_type, :permissible_value_list, 'contract type');

    select PRO.PROFILE_NAME
    from   PROFILE PRO
    where  PRO.ID_PROFILE = :ID_RENTAL_POOL
    into   :rental_pool_unit_name;

    select ROO.ROOM_NAME, RPP.FROM_DATE
    from   ROOM_PERIOD$PMS RPP
           join ROOMS ROO on ROO.ID_ROOM = RPP.ID_ROOM
    where  RPP.ID_ROOM_PERIOD = :ID_ROOM_PERIOD
    into   :room_name, :from_date;
  end

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');
  NEW_ID_ROOM_CONTRACT = :id_room_contract;

  if (:operation = 'add') then begin
    if (coalesce(:ID_ROOM_CONTRACT, -1) < 0) then begin
      NEW_ID_ROOM_CONTRACT = gen_id(GEN_ROOM_CONTRACT$PMS_ID, 1);
      ID_ROOM_CONTRACT = :NEW_ID_ROOM_CONTRACT;
    end
    else
      NEW_ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT;

    insert into ROOM_CONTRACT$PMS (ID_ROOM_CONTRACT, ID_ROOM_PERIOD,
           CONTRACT_TYPE, PMS_MARKERS, IMPORT_INCOME_WITH_VAT, ID_RENTAL_POOL)
    values (:NEW_ID_ROOM_CONTRACT, :ID_ROOM_PERIOD,
           :CONTRACT_TYPE, :PMS_MARKERS, :IMPORT_INCOME_WITH_VAT, :ID_RENTAL_POOL);

    action_text = substring(f_character(29) || '@{pms.contract_type.' || :contract_type || '}' || f_character(28) ||
                  formatdate(:from_date, 'D;dd.mm.yyyy') ||
                  f_character(28) || :room_name || f_character(28) || coalesce(:rental_pool_unit_name, ' ') || f_character(28)
                  || coalesce(:import_income_with_vat, 0) from 1 for 255);
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_ADDED', :ACTION_TEXT);

  end else begin
    select RC.CONTRACT_TYPE, RC.IMPORT_INCOME_WITH_VAT,
           RO.ROOM_NAME, PR.PROFILE_NAME, RP.FROM_DATE, RC.ID_ROOM_PERIOD, RP.ID_ROOM
    from   ROOM_CONTRACT$PMS RC
           join ROOM_PERIOD$PMS RP on RP.ID_ROOM_PERIOD = RC.ID_ROOM_PERIOD
           join ROOMS RO on RO.ID_ROOM = RP.ID_ROOM
           left outer join PROFILE PR on PR.ID_PROFILE = RC.ID_RENTAL_POOL
    where  RC.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
    into   :old_contract_type, :old_import_income_with_vat,
           :old_room_name, :old_rental_pool_unit_name, :old_from_date, :old_id_room_period, :id_room;

    if (:operation = 'mod') then begin
      update ROOM_CONTRACT$PMS
      set    CONTRACT_TYPE = :CONTRACT_TYPE,
             PMS_MARKERS = :PMS_MARKERS,
             IMPORT_INCOME_WITH_VAT = :IMPORT_INCOME_WITH_VAT,
             ID_RENTAL_POOL = :ID_RENTAL_POOL
      where (ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT);

      if ((:contract_type <> :old_contract_type) or (:import_income_with_vat <> :old_import_income_with_vat) or
         (coalesce(:rental_pool_unit_name, ' ') <> coalesce(:old_rental_pool_unit_name, ' ')) or
         (:from_date <> :old_from_date) or (:room_name <> :old_room_name)) then begin
        action_text = substring(f_character(29) || '@{pms.contract_type.' || :old_contract_type || '}' || f_character(28) ||
                      formatdate(:old_from_date, 'D;dd.mm.yyyy') ||
                      f_character(28) || :old_room_name ||
                      f_character(28) || coalesce(:old_rental_pool_unit_name, ' ') || f_character(28) || coalesce(:old_import_income_with_vat, 0) ||
                      f_character(28) || '@{pms.contract_type.' || :contract_type || '}' || f_character(28) || formatdate(:from_date, 'D;dd.mm.yyyy') ||
                      f_character(28) || :room_name || f_character(28) || coalesce(:rental_pool_unit_name, ' ') || f_character(28)
                      || coalesce(:import_income_with_vat, 0) from 1 for 255);
        execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_CHANGED', :ACTION_TEXT);
      end
    end

    if (:operation = 'del') then begin
      action_text = substring(f_character(29) || '@{pms.contract_type.' || :old_contract_type || '}' || f_character(28) ||
                    formatdate(:old_from_date, 'D;dd.mm.yyyy') ||
                    f_character(28) || :old_room_name || f_character(28) || coalesce(:old_rental_pool_unit_name, ' ') || f_character(28)
                    || coalesce(:old_import_income_with_vat, 0) from 1 for 255);
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_REMOVED', :ACTION_TEXT);

      delete from ROOM_CONTRACT$PMS where (ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT);

      execute procedure ROOM_PERIOD_MODIFY$PMS (:OLD_ID_ROOM_PERIOD, :id_room,  :old_from_date,
              iif(:contract_type in ('PRIVATE_USE'), 'PRIVATE', 'CONTRACT'),  'del')
      returning_values :new_id_room_period;
    end
  end
end
^

/* Restore proc. body: ROOM_MODIFY$PMS */
ALTER PROCEDURE ROOM_MODIFY$PMS(ID_ROOM INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
BEDS INTEGER,
EXTRA_BEDS INTEGER,
SECTOR INTEGER,
SORT_ORDER INTEGER,
FEATURES BLOB SUB_TYPE 1 SEGMENT SIZE 100,
EXTERNAL_NAME VARCHAR(10),
ID_EATING_OBJECT TYPE OF ID_REF,
OPERATION VARCHAR(20))
 RETURNS(OVERRULE_NEED SMALLINT,
OVERRULE_CONTEXT VARCHAR(255),
NEW_ID_ROOM INTEGER)
 AS
declare variable old_id_room_type integer;
  declare variable old_room_name varchar(10);
  declare variable rebuild_id_hotel integer;
  declare variable rebuild_id_room_type integer;
  declare variable guests_max integer;
  declare variable no_use varchar(20);
  declare variable old_capacity integer;
  declare variable busy_group_type integer;
  declare variable sys_date date;
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable action_text varchar(255);
  declare variable old_floor integer;
  declare variable old_sector integer;
  declare variable old_extra_beds integer;
  declare variable id_hotel integer;
begin
  overrule_need = 0;
  overrule_context = '';
  new_id_room = null;
  --if OVERRULE_NEED = 1 then OVERRULE_CONTEXT = ERR_TEXT like ERR_CODE = -9
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    if (coalesce(:room_name, '') = '') then
      exception ASSERT '-119';

    if ((:room_name containing '<') or (:room_name containing '>') or (:room_name starting with 'i')) then
      exception ASSERT '-120';
  end

  room_name = upper(:room_name);

  if (:operation='mod') then begin
    select R.ROOM_NAME, R.ID_ROOM_TYPE, R.BEDS+R.EXTRA_BEDS, r.floor, r.sector, r.extra_beds
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :id_room
    into   :old_room_name, :old_id_room_type, :old_capacity, :old_floor, :old_sector, :old_extra_beds;

    if (:id_room_type <> :old_id_room_type) then begin
      exception OCCUPANCY_EXCEPTION 'ROOM TYPE CAN NOT BE CHANGED';
    end

    new_id_room = :id_room;
    guests_max = 0;
    if (:old_capacity > (:beds + :extra_beds)) then begin
      select first 1 sum(RM.ADULT_COUNT+RM.CHILDREN_COUNT), max(rm.BUSY_GROUP_TYPE)
      from   ROOM_MAGIC RM
             join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = RM.ID_RESERV_DETAIL
      where  RM.ID_ROOM = :id_room
             and RD.CHECK_STATUS in (-3, -2, -1, 0)
      group by RM.BUSY_DATE
      order by 1 desc
      into   :guests_max, :busy_group_type;
    end
    if ((:beds + :extra_beds) < :guests_max) then begin
      err_code = -8;
      err_text = f_character(29)||:ROOM_NAME||f_character(28)||:guests_max||f_character(28)||(:beds + :extra_beds);
      if (:busy_group_type in (1)) then begin
        overrule_need = :err_code;
        overrule_context = :err_text;
        err_code = 0;
        err_text = '';
      end else begin
        exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      end
    end

    update ROOMS RU
    set    RU.ID_ROOM_TYPE = :id_room_type,
           RU.ROOM_NAME = :room_name,
           RU.FLOOR = :floor,
           RU.BEDS = :beds,
           RU.EXTRA_BEDS = :extra_beds,
           RU.SECTOR = :sector,
           RU.FEATURES = :features,
           RU.SORT_ORDER = :sort_order,
           --RU.ID_HOTEL = :rebuild_id_hotel,
           RU.EXTERNAL_NAME = :external_name,
           RU.ID_EATING_OBJECT = :ID_EATING_OBJECT
    where  RU.ID_ROOM = :id_room;

    if ((:room_name <> :old_room_name)
        or (:floor <> :old_floor)
        or (:sector <> :old_sector)
        or (:extra_beds <> :old_extra_beds)) then
    begin
      action_text = f_character(29) || '(' || :old_room_name || '/' || :old_floor || '/' || :old_sector || '/'
                    || :old_extra_beds || ')' || f_character(28) || '(' || :room_name || '/' || :floor || '/'
                    || :sector || '/' || :extra_beds || ')';
      execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_PARAMS_CHANGED', :action_text);
    end

    if (:room_name <> :old_room_name) then begin
      update ACCOUNT_POST AP
      set    AP.ROOM_NAME = :room_name
      where  AP.ROOM_NAME = :old_room_name;
    end

  end else if (:operation = 'add') then begin
    select rt.ID_HOTEL
    from   ROOM_TYPES RT
    where  rt.ID_ROOM_TYPE = :ID_ROOM_TYPE
    into   :id_hotel;

    insert into ROOMS (
      ID_ROOM, ID_ROOM_TYPE, ROOM_NAME, FLOOR, BEDS, EXTRA_BEDS, SECTOR,
      FEATURES, SORT_ORDER, ID_HOTEL, EXTERNAL_NAME, ID_EATING_OBJECT)
    values (gen_id(ID_ROOM_GEN, 1), :id_room_type, :room_name, :floor, :beds, :extra_beds, :sector,
      :features, :sort_order, :id_hotel, :external_name, :ID_EATING_OBJECT)
    returning ID_ROOM into :NEW_ID_ROOM;

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :sys_date;

    execute procedure ROOM_PERIOD_MODIFY$PMS(null, :new_id_room, :sys_date, 'HOTEL', 'add')
    returning_values  :no_use;

    insert into ROOMS_ADD (ID_ROOM, PMS_MARKERS, ADDRESS)
    values (:new_id_room, null, null);
  end else if (:operation = 'del') then begin
    -- Booked rooms are preserved with FK constraint on room_magic
    execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'DELETE', '');

    select RT.ID_ROOM_TYPE, RT.ID_HOTEL
    from   ROOM_TYPES RT
    where  RT.ID_ROOM_TYPE = :id_room_type
    into   :rebuild_id_room_type, :rebuild_id_hotel;

    delete from ROOMS where ID_ROOM = :id_room;

    execute procedure ALLOTMENT_PHYS_REBUILD$INT(:rebuild_id_hotel, :rebuild_id_room_type);

    when sqlcode -530 do begin
      -- Violation of FOREIGN KEY constraint "%s" on table "%s"
      exception ASSERT '-34';
    end
  end
end
^

/* Restore proc. body: ROOM_PERIOD_MODIFY$PMS */
ALTER PROCEDURE ROOM_PERIOD_MODIFY$PMS(ID_ROOM_PERIOD INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
STATUS VARCHAR(30),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_PERIOD INTEGER)
 AS
declare variable id_hotel integer;
  declare variable old_status varchar(30);
  declare variable old_from_date date;
  declare variable id_room_type integer;
  declare variable old_id_room integer;
  declare variable old_to_date date;
  declare variable id_account_post integer;
  declare variable id_pms_event integer;
  declare variable action_text varchar(255);
  declare variable new_to_date date;
  declare variable prev_status varchar(30);
  declare variable checking smallint;
  declare variable old_id_room_contract integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');
  execute procedure SYSTEM_CHECK_OPERATION(:status, 'HOTEL, PRIVATE, CONTRACT, INACTIVE', 'Status');
  new_id_room_period = :id_room_period;

  if (:operation = 'add') then begin
    if (exists (select *
                from   ROOM_PERIOD$PMS R
                where  R.ID_ROOM = :id_room
                       and R.FROM_DATE = :from_date )) then exception PMS_EXCEPTION '-612';

    if (coalesce(:id_room_period, 0) <= 0) then new_id_room_period = gen_id(GEN_ROOM_PERIOD$PMS_ID,1);
    else new_id_room_period = :id_room_period;

    insert into ROOM_PERIOD$PMS (ID_ROOM_PERIOD, ID_ROOM, FROM_DATE, STATUS)
    values (:new_id_room_period, :id_room, :from_date, :status);

    execute procedure ROOM_PERIOD_TODATE$INT(:id_room);

    select rp.to_date
    from   ROOM_PERIOD$PMS rp
    where  rp.id_room_period = :new_id_room_period
    into   :new_to_date;

    action_text = f_character(29) || '@{period_room_status.'||:status||'}' || f_character(28) || formatdate(:from_date, 'dd.mm.yyyy')
                  || f_character(28) || iif(extract(year from :new_to_date) = 2500, '~', formatdate(:new_to_date, 'dd.mm.yyyy'));
    execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_STATUS_ADDED', :action_text);

  end else begin
    select R.STATUS, R.FROM_DATE, R.ID_ROOM, R.TO_DATE
    from   ROOM_PERIOD$PMS R
    where  R.ID_ROOM_PERIOD = :id_room_period
    into   :old_status, :old_from_date, :old_id_room, :old_to_date;

    if (:OPERATION = 'mod' and :old_id_room <> :ID_ROOM) then
      /* Very important check! */
      exception PMS_EXCEPTION 'Cannot change the contract room !';

    if (:OPERATION = 'del' and :old_status in ('PRIVATE', 'CONTRACT')) then begin
      if ((exists ( select *
                    from   ACCOUNT_POST$PMS AP1
                           join ACCOUNT$PMS A1 on A1.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS
                           join PMS_EVENT$PMS E1 on E1.ID_PMS_EVENT = AP1.ID_PMS_EVENT
                    where  AP1.DATE_POST between :OLD_FROM_DATE and :OLD_TO_DATE
                           and E1.ID_ROOM = :OLD_ID_ROOM
                           and A1.IS_SHADOW = 0
                           and AP1.LINE_STATUS < 22  ))
          or
          (exists ( select *
                    from   ACCOUNT_POST AP2
                           join PMS_EVENT_POST PP2 on PP2.ID_ACCOUNT_POST = AP2.ID_ACCOUNT_POST
                           join PMS_EVENT$PMS E2 on E2.ID_PMS_EVENT = PP2.ID_PMS_EVENT
                    where  AP2.DATE_POST between :OLD_FROM_DATE and :OLD_TO_DATE
                           and E2.ID_ROOM = :OLD_ID_ROOM
                           and PP2.LINE_STATUS < 22  )) ) then
      begin
        exception PMS_EXCEPTION '-624';
      end
    end

    for
      select AP1.ID_ACCOUNT_POST, AP1.ID_PMS_EVENT
      from   ACCOUNT_POST$PMS AP1
             join ACCOUNT$PMS A1 on A1.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS
             join PMS_EVENT$PMS E1 on E1.ID_PMS_EVENT = AP1.ID_PMS_EVENT
      where  AP1.DATE_POST between :OLD_FROM_DATE and :OLD_TO_DATE
             and E1.ID_ROOM = :OLD_ID_ROOM
             and A1.IS_SHADOW = 1
             and AP1.LINE_STATUS = 11 /*  anulirat se samo aktiwnite nachisleniq. Ako ima dokumentirani?! ili anulirani, ne se pipat  */
      into   :id_account_post, :id_pms_event
    do begin
      execute procedure ACCOUNT_POST_PMS_ANUL$INT(:id_pms_event, :id_account_post);
    end

    if (:operation = 'mod') then begin
      if (exists (select *
                  from   ROOM_PERIOD$PMS R
                  where  R.ID_ROOM in (:old_id_room, :id_room)
                         and R.FROM_DATE = :from_date
                         and R.ID_ROOM_PERIOD <> :id_room_period)) then exception PMS_EXCEPTION '-612';
  
      checking = 1;
      if ((:status in ('PRIVATE', 'CONTRACT')) and (:from_date = :old_from_date) and (:status = :old_status)) then begin
        checking = 0;
      end else if((:status in ('PRIVATE', 'CONTRACT')) and (:from_date <> :old_from_date)) then begin
        checking = 2;
        select first 1 rcp.id_room_contract
        from   ROOM_CONTRACT$PMS rcp
        where  rcp.id_room_period = :id_room_period
        into   :old_id_room_contract;
      end

      if (:checking > 0) then  begin -- else beshe po staria nachin
        update ROOM_PERIOD$PMS p
        set    p.FROM_DATE = :from_date,
               p.STATUS = :status
        where  p.ID_ROOM_PERIOD = :id_room_period;

        execute procedure ROOM_PERIOD_TODATE$INT(:id_room);

        select rp.to_date
        from   ROOM_PERIOD$PMS rp
        where  rp.id_room_period = :id_room_period
        into   :new_to_date;

        action_text = f_character(29) || '@{period_room_status.'||:old_status||'}'
                      || f_character(28) || iif(extract(year from :old_from_date) = 2500, '~', formatdate(:old_from_date, 'dd.mm.yyyy'))
                      || f_character(28) || iif(extract(year from :old_to_date) = 2500, '~', formatdate(:old_to_date, 'dd.mm.yyyy'))
                      || f_character(28) || '@{period_room_status.'||:status||'}'
                      || f_character(28) || iif(extract(year from :from_date) = 2500, '~', formatdate(:from_date, 'dd.mm.yyyy'))
                      || f_character(28) || iif(extract(year from :new_to_date) = 2500, '~', formatdate(:new_to_date, 'dd.mm.yyyy'));
        execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_STATUS_CHANGED', :action_text);

        if (:checking > 1) then
          execute procedure SYSTEM_LOG_ADD ('CONTRACT', :OLD_ID_ROOM_CONTRACT, 'ROOM_STATUS_CHANGED', :action_text);

      end

    end else if (:operation = 'del') then begin
      if (singular (select *
                    from   ROOM_PERIOD$PMS R
                    where  R.ID_ROOM = :old_id_room)) then exception PMS_EXCEPTION '-622';

      select first 1 rpm.status, rpm.ID_ROOM
      from   ROOM_PERIOD$PMS rpm
      where  rpm.id_room = :old_id_room
             and rpm.from_date < :old_from_date
      order by rpm.from_date desc
      into   :prev_status, :id_room;

      delete from ROOM_PERIOD$PMS
      where  ID_ROOM_PERIOD = :id_room_period;

      execute procedure ROOM_PERIOD_TODATE$INT(:id_room);

      action_text = f_character(29) || '@{period_room_status.'||:old_status||'}'
                  || f_character(28) || iif(extract(year from :old_from_date) = 2500, '~', formatdate(:old_from_date, 'dd.mm.yyyy'))
                  || f_character(28) || iif(extract(year from :old_to_date) = 2500, '~', formatdate(:old_to_date, 'dd.mm.yyyy'))
                  || f_character(28) || '@{period_room_status.'||:prev_status||'}' ;
      execute procedure SYSTEM_LOG_ADD ('ROOM', :id_room, 'ROOM_STATUS_DELETED', :action_text);
    end
  end

  /* rebuild physical allotment */
  if ( (:operation in ('add', 'del'))
       or
       ((:operation = 'mod') and ((:old_status <> :status) or (:old_from_date <> :from_date)))) then
  begin
    select RT.ID_HOTEL, R.ID_ROOM_TYPE
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :id_room
    into   :id_hotel, :id_room_type;

    execute procedure ALLOTMENT_PHYS_REBUILD$INT(:id_hotel, :id_room_type);
  end

end
^

/* Restore proc. body: ROOM_SMART_LIST$RSV */
ALTER PROCEDURE ROOM_SMART_LIST$RSV(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(50))
 RETURNS(ROOM_NAME VARCHAR(50),
FREE_BEDS_BASE INTEGER,
FREE_BEDS_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
FEATURES BLOB,
BUSY_GROUP_TYPE INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
DATA1 VARCHAR(255),
DATA2 VARCHAR(255))
 AS
declare variable report_leaving varchar(20);
declare variable suppress_private integer;
begin
  if (:from_date >= :to_date) then exit;
  execute procedure SYSTEM_CHECK_OPERATION(:report_type, 'FREE_ONLY,FREE_AND_LEAVING,BLOCKED,POTENTIAL_SHARE,PRIVATE_USE,ALL');

  suppress_private = iif(:REPORT_TYPE = 'ALL', 0, 1);
  if (:report_type in ('FREE_ONLY','FREE_AND_LEAVING')) then begin
    if (:report_type = 'FREE_AND_LEAVING') then report_leaving = 'AS_FREE';
    else report_leaving = 'AS_LEAVING';
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DBEFORE, SRLF.DAFTER, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_FREE$INT(:from_date, :to_date, :report_leaving, :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end else if (:report_type in ('BLOCKED','POTENTIAL_SHARE')) then begin
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DESCRIPTION, SRLF.PERIOD, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_SHARE$INT(:from_date, :to_date, :report_type, :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end else if (:report_type in ('ALL')) then begin
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DBEFORE, SRLF.DAFTER, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_FREE$INT(:from_date, :to_date, 'FREE_AND_LEAVING', :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;

    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DESCRIPTION, SRLF.PERIOD, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_SHARE$INT(:from_date, :to_date, 'POTENTIAL_SHARE', :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end
end
^

/* Restore proc. body: SAFE_OCCUPANCY_MODIFY */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE TYPE OF ID,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable old_booking_number tres_number;
  declare variable id_resource_reservation id_ref;
  declare variable from_datetime tdatetime;
  declare variable action_text tdescription_long;
  declare variable old_occupant varchar(100);
  declare variable old_to_dt timestamp;
  declare variable id_reserv_detail integer;
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation;

  select rr.BOOKING_NUMBER, od.FROM_DATETIME,
         RR.OCCUPANT_NAME, od.TO_DATETIME, rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESERV_DETAIL rd on rd.NUMBER = rr.BOOKING_NUMBER and rd.IS_ANUL = 0
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :old_booking_number, :from_datetime,
         :old_occupant, :old_to_dt, :id_reserv_detail, :id_agent_profile;

  --if (:old_booking_number <> :BOOKING_NUMBER) then exception ASSERT 'Can not change booking number!';
  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  update SAFE_RESOURCE_RESERV rr
  set    rr.PRICE_DESCRIPTION = :price_description,
         rr.ID_RATE_PRICE_PROFILE = :id_agent_profile,
         rr.RATING_UNITS = :rating_units,
         rr.RATE_PRICE = :price,
         rr.RATE_CURR = :currency
  where  rr.ID_RESOURCE_RESERV = :id_resource_reservation;

  execute procedure RESOURCE_RESERVATION_MODIFY (:id_resource_reservation, :ID_SAFE, :from_datetime,
          :TO_DATETIME, :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :old_booking_number, 'mod')
  returning_values :id_resource_reservation, :no_use;

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail)
  returning_values (:DOC_SELECTED);

  /* Log changes */
  if ((:old_occupant <> :OCCUPANT_NAME) or (:old_to_dt <> :TO_DATETIME)) then begin
    action_text = f_character(29) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                  || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                  || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');
  
    execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_CHANGED', :action_text);
  end
end
^

/* Restore proc. body: SAFE_OCCUPANCY_NEW */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE TYPE OF ID,
FROM_DATETIME TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME,
BOOKING_NUMBER TYPE OF TRES_NUMBER,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
ID_RESOURCE_RESERVATION TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable action_text tdescription_long;
  declare variable id_reserv_detail integer;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, s.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  if (:id_resource_reservation is not null) then exception ASSERT '-1064'|| f_character(31) || f_character(29) || :safe_name;

  select rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESERV_DETAIL rd
  where  rd.NUMBER = :BOOKING_NUMBER
         and rd.IS_ANUL = 0
  into   :id_reserv_detail, :id_agent_profile;

  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  execute procedure  RESOURCE_RESERVATION_MODIFY (null, :ID_SAFE, :FROM_DATETIME, :TO_DATETIME,
          :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :BOOKING_NUMBER, 'add')
  returning_values (:id_resource_reservation, :no_use) ;

  insert into SAFE_RESOURCE_RESERV (ID_RESOURCE_RESERV, PRICE_DESCRIPTION, ID_RATE_PRICE_PROFILE,
         RATING_UNITS, RATE_PRICE, RATE_CURR)
  values (:id_resource_reservation, :price_description, :id_agent_profile,
         :rating_units, :price, :currency);

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail, :ID_EXTERNAL_CLIENT_ACCCOUNT)
  returning_values (:DOC_SELECTED);

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = 'CHECKED_IN'
  where  RR.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = :id_resource_reservation
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                || f_character(28) || coalesce(:BOOKING_NUMBER, '')
                || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUPIED', :action_text);
end
^

/* Restore proc. body: SUMMARY_PREPARE$INT */
ALTER PROCEDURE SUMMARY_PREPARE$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
declare variable busy_date date;
  declare variable id_room_type integer;
  declare variable id_profile_agent integer;
  declare variable country_code varchar(20);
  declare variable market_segment_code varchar(3);
  declare variable source_code varchar(3);
  declare variable channel_code varchar(3);
  declare variable hear_reason_code varchar(3);
  declare variable come_reason_code varchar(3);
  declare variable rooms_noshow smallint;
  declare variable rooms_canceled smallint;

  declare variable rooms_ooi smallint;
  declare variable rooms_ooo smallint;

  declare variable rooms_sold smallint;
  declare variable rooms_sold_multiple_gst smallint;
  declare variable rooms_arrival smallint;
  declare variable rooms_departure smallint;
  declare variable ad_in_house smallint;
  declare variable ad_arrival smallint;
  declare variable ad_departure smallint;
  declare variable ch_in_house smallint;
  declare variable ch_arrival smallint;
  declare variable ch_departure smallint;
  declare variable guests_noshow smallint;
  declare variable guests_day_use smallint;
begin
  -- REBUILD THE "NO SLICE"
  delete from SUMMARY_OCCUPANCY D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY (ID_ROOM_TYPE, FOR_DATE, ROOMS_AVAILABLE, ID_HOTEL)
  select RC.ID_ROOM_TYPE, RC.FOR_DATE, sum(RC.CNT_DEFINED), :id_hotel
  from   HOTEL H
         left outer join ALLOTMENT_GET$INT(H.ID_INVENTORY_ALLOTMENT, :from_date, :to_date, null, 'PLAIN_PERIOD', H.ID_HOTEL) RC on 0=0
  where  H.ID_HOTEL = :id_hotel
         and RC.CNT_DEFINED is not null
  group by 1, 2;

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, 
           M.ROOMS_OOI, M.ROOMS_OOO,
           M.ROOMS_SOLD, M.ROOMS_SOLD_MULTIPLE_GST, M.ROOMS_ARRIVAL, M.ROOMS_DEPARTURE,
           M.AD_IN_HOUSE, M.AD_ARRIVAL, M.AD_DEPARTURE,
           M.CH_IN_HOUSE, M.CH_ARRIVAL, M.CH_DEPARTURE, M.GUESTS_DAY_USE
    from   SUMMARY_PREPARE_TOTAL$INT(:id_hotel, :from_date, :to_date) M
    into   :id_room_type, :busy_date,
           :rooms_ooi, :rooms_ooo,
           :rooms_sold, :rooms_sold_multiple_gst, :rooms_arrival, :rooms_departure,
           :ad_in_house, :ad_arrival, :ad_departure,
           :ch_in_house, :ch_arrival, :ch_departure, :guests_day_use
  do begin
    update SUMMARY_OCCUPANCY SO
    set    SO.ROOMS_OOI = :rooms_ooi,
           SO.ROOMS_OOO = :rooms_ooo,
           SO.ROOMS_SOLD = :rooms_sold,
           SO.ROOMS_SOLD_MULTIPLE_GST = :rooms_sold_multiple_gst,
           SO.ROOMS_ARRIVAL = :rooms_arrival,
           SO.ROOMS_DEPARTURE = :rooms_departure,
           SO.GST_AD_IN_HOUSE = :ad_in_house,
           SO.GST_AD_DEPARTURE = :ad_departure,
           SO.GST_AD_ARRIVAL = :ad_arrival,
           SO.GST_CH_IN_HOUSE = :ch_in_house,
           SO.GST_CH_DEPARTURE = :ch_departure,
           SO.GST_CH_ARRIVAL = :ch_arrival,
           SO.GUESTS_DAY_USE = :guests_day_use
    where  SO.FOR_DATE = :busy_date
           and SO.ID_ROOM_TYPE = :id_room_type;

    if (row_count = 0) then begin
      --savedbg('skip SUMMARY_OCCUPANCY');
    end
  end

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, 
           M.ROOMS_NOSHOW, M.ROOMS_CANCELED, M.GUESTS_NOSHOW
    from   SUMMARY_PREPARE_CANCELED$INT(:id_hotel, :from_date, :to_date, 'TOTAL') M
    into   :id_room_type, :busy_date, 
           :rooms_noshow, :rooms_canceled, :guests_noshow
  do begin
    update SUMMARY_OCCUPANCY SO
    set    SO.ROOMS_NOSHOW = :rooms_noshow,
           SO.ROOMS_CANCELED = :rooms_canceled,
           SO.GUESTS_NOSHOW = :guests_noshow
    where  SO.FOR_DATE = :busy_date
           and SO.ID_ROOM_TYPE = :id_room_type;

    if (row_count = 0) then begin
      --savedbg('skip SUMMARY_OCCUPANCY');
    end
  end

  -- REBUILD THE "MARKET SLICE"
  delete from SUMMARY_OCCUPANCY_MARKET D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY_MARKET (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL,
         MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
         ROOMS_SOLD, ROOMS_SOLD_MULTIPLE_GST, ROOMS_ARRIVAL, ROOMS_DEPARTURE,
         ROOMS_NOSHOW, ROOMS_CANCELED, GUESTS_IN_HOUSE, GUESTS_ARRIVAL, GUESTS_DEPARTURE, GUESTS_DAY_USE)
  select M.ID_ROOM_TYPE, M.BUSY_DATE, :id_hotel,
         M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE,
         M.ROOMS_SOLD, M.ROOMS_SOLD_MULTIPLE_GST, M.ROOMS_ARRIVAL, M.ROOMS_DEPARTURE,
         0, 0, M.GUESTS_IN_HOUSE, M.GUESTS_ARRIVAL, M.GUESTS_DEPARTURE, M.GUESTS_DAY_USE
  from   SUMMARY_PREPARE_MAIN$INT(:id_hotel, :from_date, :to_date, 'MARKET') M;

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, 
           M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE,
           M.ROOMS_NOSHOW, M.ROOMS_CANCELED
    from   SUMMARY_PREPARE_CANCELED$INT(:id_hotel, :from_date, :to_date, 'MARKET') M
    into   :id_room_type, :busy_date, 
           :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
           :rooms_noshow, :rooms_canceled
  do begin
    update SUMMARY_OCCUPANCY_MARKET MA
    set    MA.ROOMS_NOSHOW = :rooms_noshow,
           MA.ROOMS_CANCELED = :rooms_canceled
    where  MA.FOR_DATE = :busy_date
           and MA.ID_ROOM_TYPE = :id_room_type
           and MA.MARKET_SEGMENT_CODE = :market_segment_code
           and MA.SOURCE_CODE = :source_code
           and MA.CHANNEL_CODE = :channel_code
           and MA.HEAR_REASON_CODE = :hear_reason_code
           and MA.COME_REASON_CODE = :come_reason_code;
    if (row_count = 0) then begin
      insert into SUMMARY_OCCUPANCY_MARKET (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL,
             MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
             ROOMS_NOSHOW, ROOMS_CANCELED)
      values (:id_room_type, :busy_date, :id_hotel,
             :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
             :rooms_noshow, :rooms_canceled);
    end
  end

  -- REBUILD THE "PROFILE/COUNTRY SLICE"
  delete from SUMMARY_OCCUPANCY_OTHER D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY_OTHER (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL,
         ID_PROFILE_AGENT, COUNTRY_CODE,
         ROOMS_SOLD, ROOMS_SOLD_MULTIPLE_GST, ROOMS_ARRIVAL, ROOMS_DEPARTURE,
         ROOMS_NOSHOW, ROOMS_CANCELED, GUESTS_IN_HOUSE, GUESTS_ARRIVAL, GUESTS_DEPARTURE, GUESTS_DAY_USE)
  select M.ID_ROOM_TYPE, M.BUSY_DATE, :id_hotel,
         M.ID_PROFILE_AGENT, M.COUNTRY_CODE,
         M.ROOMS_SOLD, M.ROOMS_SOLD_MULTIPLE_GST, M.ROOMS_ARRIVAL, M.ROOMS_DEPARTURE,
         0, 0, M.GUESTS_IN_HOUSE, M.GUESTS_ARRIVAL, M.GUESTS_DEPARTURE, M.GUESTS_DAY_USE
  from   SUMMARY_PREPARE_MAIN$INT(:id_hotel, :from_date, :to_date, 'PROFILE') M;

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, 
           M.ID_PROFILE_AGENT, M.COUNTRY_CODE,
           M.ROOMS_NOSHOW, M.ROOMS_CANCELED, M.GUESTS_NOSHOW
    from   SUMMARY_PREPARE_CANCELED$INT(:id_hotel, :from_date, :to_date, 'PROFILE') M
    into   :id_room_type, :busy_date, 
           :id_profile_agent, :country_code,
           :rooms_noshow, :rooms_canceled, :guests_noshow
  do begin

    update SUMMARY_OCCUPANCY_OTHER MA
    set    MA.ROOMS_NOSHOW = :rooms_noshow,
           MA.ROOMS_CANCELED = :rooms_canceled
    where  MA.FOR_DATE = :busy_date
           and MA.ID_ROOM_TYPE = :id_room_type
           and MA.ID_PROFILE_AGENT = :id_profile_agent
           and MA.COUNTRY_CODE = :country_code;
    if (row_count = 0) then begin
      insert into SUMMARY_OCCUPANCY_OTHER (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL,
             ID_PROFILE_AGENT, COUNTRY_CODE, ROOMS_NOSHOW, ROOMS_CANCELED)
      values (:id_room_type, :busy_date, :id_hotel,
             :id_profile_agent, :country_code, :rooms_noshow, :rooms_canceled);
    end
  end

  -- REBUILD THE "PROFILE/MARKETING SLICE"
  delete from SUMMARY_OCCUPANCY_PROFILE_MRKT D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY_PROFILE_MRKT (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL,
         ID_PROFILE_AGENT,
         MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
         ROOMS_SOLD, ROOMS_SOLD_MULTIPLE_GST, ROOMS_ARRIVAL, ROOMS_DEPARTURE,
         ROOMS_NOSHOW, ROOMS_CANCELED, GUESTS_IN_HOUSE, GUESTS_ARRIVAL, GUESTS_DEPARTURE, GUESTS_DAY_USE)
  select M.ID_ROOM_TYPE, M.BUSY_DATE, :id_hotel,
         M.ID_PROFILE_AGENT,
         M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE,
         M.ROOMS_SOLD, M.ROOMS_SOLD_MULTIPLE_GST, M.ROOMS_ARRIVAL, M.ROOMS_DEPARTURE,
         0, 0, M.GUESTS_IN_HOUSE, M.GUESTS_ARRIVAL, M.GUESTS_DEPARTURE, M.GUESTS_DAY_USE
  from   SUMMARY_PREPARE_MAIN$INT(:id_hotel, :from_date, :to_date, 'MIXED') M;

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, M.ID_PROFILE_AGENT,
           M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE,
           M.ROOMS_NOSHOW, M.ROOMS_CANCELED, M.GUESTS_NOSHOW
    from   SUMMARY_PREPARE_CANCELED$INT(:id_hotel, :from_date, :to_date, 'MIXED') M
    into   :id_room_type, :busy_date,  :id_profile_agent,
           :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
           :rooms_noshow, :rooms_canceled, :guests_noshow
  do begin

    update SUMMARY_OCCUPANCY_PROFILE_MRKT MA
    set    MA.ROOMS_NOSHOW = :rooms_noshow,
           MA.ROOMS_CANCELED = :rooms_canceled
    where  MA.FOR_DATE = :busy_date
           and MA.ID_ROOM_TYPE = :id_room_type
           and MA.ID_PROFILE_AGENT = :id_profile_agent
           and MA.MARKET_SEGMENT_CODE = :market_segment_code
           and MA.SOURCE_CODE = :source_code
           and MA.CHANNEL_CODE = :channel_code
           and MA.HEAR_REASON_CODE = :hear_reason_code
           and MA.COME_REASON_CODE = :come_reason_code;
    if (row_count = 0) then begin
      insert into SUMMARY_OCCUPANCY_PROFILE_MRKT (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL, ID_PROFILE_AGENT,
             MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
             ROOMS_NOSHOW, ROOMS_CANCELED)
      values (:id_room_type, :busy_date, :id_hotel, :id_profile_agent,
             :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
             :rooms_noshow, :rooms_canceled);
    end
  end

end
^

/* Restore proc. body: TAR_CALC_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
declare variable param_code varchar(40);
  declare variable id_param integer;
  declare variable param_value varchar(255);
  declare variable data_type  varchar(30);
  declare variable rate_list varchar(2000);
begin
  err_code = 0;
  param_values = '';

  if (coalesce(:rate_list_replace, '') = '') then rate_list = ',' || :id_rate || ',';
  else rate_list = :rate_list_replace;

  for
    select distinct TBP.PARAM_NAME
    from   SYSTEM_STRING_PARSER (:rate_list, ',') sp
           left join TAR_BO_PARAMS TBP on TBP.ID_TAR_HEAD = sp.ITEM
    where  (TBP.PARAM_TYPE <> 'DATE_DEPENDANT' and :for_date is null)
           or (TBP.PARAM_TYPE = 'DATE_DEPENDANT' and :for_date is not null)
    into   :param_code
  do begin
    if (:param_code is not null) then begin
      id_param = null;
      select TP.ID_TARIFA_PARAM, TP.DATA_TYPE
      from   TARIFA_PARAMS TP
      where  TP.PARAM_CODE = :param_code
             and tp.IS_USE = 1
      into   :id_param, :data_type;
  
      if (:id_param is null) then begin
        err_code = -202;
        execute procedure sys_dbg ('tar calc params err_code: ' || :err_code || F_CRLF() || 'PARAM_CODE = ' || :param_code);
        exit;
      end
  
      execute procedure TARIFA_GET_PARAM (:id_param, :for_date, :id_tar_input, :id_tar_calc)
      returning_values (:param_value);
  
      param_code = ':'||param_code;
  
      if ((:param_code is not null) and (:param_code is not null) and (:data_type is not null)) then
         param_values = :param_values||';'||:param_code||','||:data_type||','||:param_value;
    end
  end
end
^

/* Creating trigger... */
CREATE TRIGGER DOC_PAY_USAGE_AIUD0 FOR DOC_PAY_USAGE
ACTIVE AFTER INSERT OR UPDATE OR DELETE POSITION 0 
AS
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable id_deposit integer;
begin
  select ap.ID_DEPOSIT
  from   ACCOUNT_PAYMENTS ap
  where  ap.ID_ACCOUNT_PAYMENT = coalesce(old.ID_ACCOUNT_PAYMENT, new.ID_ACCOUNT_PAYMENT)
  into   :ID_DEPOSIT;

  if (:id_deposit is not null) then begin
    id_reserv_detail = null;
    select rd.ID_RESERV_DETAIL, rd.ID_HOTEL
    from   DEPOSIT d
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = d.ID_RESERV_DETAIL
    where  d.ID_DEPOSIT = :id_deposit
    into   :id_reserv_detail, :id_hotel;

    if (:id_reserv_detail is not null) then
      execute procedure LOG_BOOKING_CHANGE$EXC(:id_reserv_detail, :id_hotel, 0, 0);
  end

end
^


/* Create Views... */

/* Altering existing trigger... */
ALTER TRIGGER DEPOSITS_BIUD0
AS
begin
  execute procedure ACCOUNT_BALANCE_INVALIDATE$INT(coalesce(old.id_account, new.ID_ACCOUNT));

end
^

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: ACCOUNT_BALANCE$RPT for: ACCOUNT_BALANCE$INT */
ALTER PROCEDURE ACCOUNT_BALANCE$RPT(ID_ACCOUNT INTEGER,
EW_INCL_ONLY SMALLINT = 0)
 RETURNS(ACCOUNT_CURR CHAR(3),
ACCOUNT_BALANCE NUMERIC(15,4),
POST_VALUE NUMERIC(15,4),
DEP_VALUE NUMERIC(15,4),
OPEN_CHARGES INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_CHECK_CREDIT_STATUS$INT for: ACCOUNT_BALANCE$INT */
ALTER PROCEDURE ACCOUNT_CHECK_CREDIT_STATUS$INT(ID_ACCOUNT /* TYPE OF ID_REF */ INTEGER,
POST_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_SET_ARCHIVE_STATUS for: ACCOUNT_BALANCE$INT */
ALTER PROCEDURE ACCOUNT_SET_ARCHIVE_STATUS(ID_ACCOUNT INTEGER,
IS_ARCHIVE SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: CACHES_RESOLVE for: ACCOUNT_BALANCE$INT */
ALTER PROCEDURE CACHES_RESOLVE AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_GET_ACCOUNT$PROFILE for: ACCOUNT_BALANCE$INT */
ALTER PROCEDURE PROFILE_GET_ACCOUNT$PROFILE(ID_PROFILE INTEGER,
SHOW_ARCHIVE SMALLINT)
 RETURNS(ID_ACCOUNT INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
DEPOSIT_VALUE NUMERIC(15,4),
BALANCE_VALUE NUMERIC(15,4),
IS_DEFAULT SMALLINT,
IS_CREDIT SMALLINT,
CREDIT_LIMIT NUMERIC(15,4),
ID_TYPE_PAYMENT INTEGER,
IS_LEVEL_1 INTEGER,
IS_ARCHIVE INTEGER,
HOTEL_NAME VARCHAR(50))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GET_BALLANCE$INT for: ACCOUNT_BALANCE$INT */
ALTER PROCEDURE RES_GET_BALLANCE$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(RESERVATION_BALLANCE VARCHAR(255),
RECIEVED_DEPOSITS VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_BALANCE$INT) */
ALTER PROCEDURE ACCOUNT_BALANCE$INT(ID_ACCOUNT INTEGER,
EW_INCL_ONLY SMALLINT = 0)
 RETURNS(ACCOUNT_CURR CHAR(3),
CURR_DISPLAY_FORMAT VARCHAR(10),
ACCOUNT_BALANCE NUMERIC(15,4),
POST_VALUE NUMERIC(15,4),
DEP_VALUE NUMERIC(15,4),
DEP_MONEY_BAG VARCHAR(255),
OPEN_CHARGES INTEGER)
 AS
declare variable dep_curr_value numeric(15,4);
  declare variable dep_curr varchar(3);
  declare variable round_to numeric(15,4);
  declare variable open_charges_int integer;
  declare variable cached_balances integer;
begin
  select A.ACCOUNT_CURR, C.ROUND_TO, C.DISPLAY_FORMAT
  from   ACCOUNT A
         join CURRS C on C.CURR = A.ACCOUNT_CURR
  where  A.ID_ACCOUNT = :id_account
  into   :account_curr, :round_to, :curr_display_format;

  account_balance = null;
  if (:EW_INCL_ONLY is distinct from 1) then begin
    select count(*),
           min(AC.ACCOUNT_BALANCE), min(AC.POST_VALUE), min(AC.DEP_VALUE),
           min(AC.DEP_MONEY_BAG), min(AC.OPEN_CHARGES)
    from   ACCOUNT_BALANCE_CACHE AC
    where  AC.ID_ACCOUNT = :id_account
    into   :cached_balances,
           :account_balance, :post_value, :dep_value, :dep_money_bag, :open_charges;
  
    if (:cached_balances <> 1) then account_balance = null;
  --    execute procedure ACCOUNT_BALANCE_INVALIDATE$INT (:id_account);
  end

  if (:account_balance is null) then begin
    account_balance = 0;
    post_value = 0;
    dep_value = 0;
    dep_money_bag = '';
    open_charges = 0;
    for
      select :POST_VALUE + round_f(AB.POST_BAL_VALUE, :round_to), :DEP_VALUE + round_f(AB.DEP_BAL_VALUE, :round_to),
             AB.DEP_ORIG_VALUE, AB.CURR_ORIG, AB.OPEN_CHARGES
      from   ACCOUNT_CURR_BALANCE$INT (:id_account, :account_curr, :ew_incl_only) AB
      into   :post_value, :dep_value, :dep_curr_value, :dep_curr, :open_charges_int
    do begin
      if (:open_charges_int = 1) then open_charges = 1;
      if (:dep_curr is not null and :dep_value > 0) then
        dep_money_bag = :dep_money_bag || formatfloat (:dep_curr_value, :curr_display_format) || ' ' || :dep_curr || ';';
    end
    account_balance = :post_value - :dep_value;

    if (:EW_INCL_ONLY is distinct from 1) then begin
      execute procedure ACCOUNT_BALANCE_CACHE$INT(:id_account, :account_balance, :post_value, :dep_value, :dep_money_bag, :open_charges);
    end
  end

  suspend;
end
^

/* Alter (ACCOUNT_BALANCE$RPT) */
ALTER PROCEDURE ACCOUNT_BALANCE$RPT(ID_ACCOUNT INTEGER,
EW_INCL_ONLY SMALLINT = 0)
 RETURNS(ACCOUNT_CURR CHAR(3),
ACCOUNT_BALANCE NUMERIC(15,4),
POST_VALUE NUMERIC(15,4),
DEP_VALUE NUMERIC(15,4),
OPEN_CHARGES INTEGER)
 AS
begin

  select AB.ACCOUNT_CURR, AB.ACCOUNT_BALANCE, AB.POST_VALUE, AB.DEP_VALUE, AB.OPEN_CHARGES
  from   ACCOUNT_BALANCE$INT (:ID_ACCOUNT, :EW_INCL_ONLY) AB
  into   :ACCOUNT_CURR, :ACCOUNT_BALANCE, :POST_VALUE, :DEP_VALUE, :OPEN_CHARGES;
   
  suspend;
end
^

/* Alter (ACCOUNT_CHECK_CREDIT_STATUS$INT) */
ALTER PROCEDURE ACCOUNT_CHECK_CREDIT_STATUS$INT(ID_ACCOUNT TYPE OF ID_REF,
POST_VALUE TYPE OF TPRICE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_credit_account integer;
  declare variable id_reserv_detail integer;
  declare variable credit_limit tprice;
  declare variable b_post_sum tprice;
  declare variable b_pay_sum tprice;
  declare variable difference_value tprice;
  declare variable no_use varchar(255);
  declare variable account_currency tcurrency;
  declare variable round_to numeric(15,4);
begin
  if (:POST_VALUE = 0) then exit;

  select a.IS_CREDIT_ACCOUNT, a.CREDIT_LIMIT, a.ID_RESERV_DETAIL
  from   ACCOUNT A
  where  a.ID_ACCOUNT = :ID_ACCOUNT
  into   :is_credit_account, :credit_limit, :id_reserv_detail;

  if (:is_credit_account = 0
      and exists (select rd.ID_RESERV_DETAIL
                  from   RESERV_DETAIL rd
                  where  rd.ID_RESERV_DETAIL = :id_reserv_detail
                         and rd.CHECK_STATUS = 1)) then
  begin
    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, :credit_limit, 1);
  end

  if (coalesce(:credit_limit, 0) > 0) then begin
    /* FIND BALANCE OF ACCOUNT */
    execute procedure ACCOUNT_BALANCE$INT(:id_account)
    returning_values  :account_currency, :round_to, :no_use, :b_post_sum, :b_pay_sum, :no_use, :no_use;
    b_post_sum = coalesce(:b_post_sum, 0);
    b_pay_sum  = coalesce(:b_pay_sum, 0);

    /* IS THIS POST IS IN LIMIT */
    if ((:b_post_sum + :POST_VALUE) > :credit_limit) then begin
      err_code = -13; /*  */
      difference_value = :b_post_sum + :POST_VALUE - :credit_limit;
      err_text = f_character(29)||FormatFloat(:credit_limit, :round_to)||' '||:account_currency||
                 f_character(28)||FormatFloat(:difference_value, :round_to);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_TRANSFER$ACC for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: GUEST_ACCOUNT_TRANSFER$INT for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE GUEST_ACCOUNT_TRANSFER$INT(ID_GUEST INTEGER,
ID_SOURCE_ACCOUNT INTEGER,
ID_TARGET_ACCOUNT INTEGER,
SERVICE_TYPE VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: GUEST_REROUTE_POSTINGS$INT for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE GUEST_REROUTE_POSTINGS$INT(ID_GUEST INTEGER,
ID_BASE_ACCOUNT INTEGER,
ID_EXTRA_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_TRANSFER$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER)
 AS
declare variable id_current_account integer;
  declare variable id_service integer;
  declare variable is_anul integer;
  declare variable id_tariff integer;
  declare variable qty_post numeric(15,2);
  declare variable qty_free numeric(15,2);
  declare variable price_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable id_room integer;
  declare variable id_base_doc integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  if ((:AP_DBKEY is null) or (:id_target_account is null) or (:id_target_account < 0)) then
     exception POSTING_TRANSFER_EXCEPTION '-31';

  select AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST, AP.QTY_FREE,
         AP.PRICE_ORIG, AP.CURR_ORIG, AP.RATE_ORIG, ap.from_date, ap.to_date,
         AP.IS_ANUL, AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_BASE_DOC, A.ID_HOTEL
  from   ACCOUNT_POST AP
         left join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :id_service, :id_tariff, :id_room, :qty_post, :qty_free,
         :price_orig, :curr_orig, :rate_orig, :from_date, :to_date,
         :is_anul, :id_account_post, :id_current_account, :id_base_doc, :id_hotel;

  if (:id_current_account = :id_target_account) then EXIT;

  if (:is_anul = 1 ) then exception POSTING_TRANSFER_EXCEPTION '-33';

  if (:id_base_doc is not null) then exception POSTING_TRANSFER_EXCEPTION '-32';

  if (not exists(select A.ID_ACCOUNT
                 from   ACCOUNT A
                 where  A.ID_ACCOUNT = :ID_TARGET_ACCOUNT
                        and A.ID_HOTEL = :id_hotel)) then exception POSTING_TRANSFER_EXCEPTION '-376';

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_target_account, :id_service,
                    :id_tariff, :id_room, :qty_post, :qty_free, :price_orig, :curr_orig,
                    :rate_orig, 'TRANSFER_POSTING', null, :from_date, :to_date)
  returning_values  :no_use, :no_use, :no_use;

  insert into ACCOUNT_TRANSFER_HISTORY(ID_ACCOUNT_POST, FROM_ID_ACCOUNT, TO_ID_ACCOUNT)
  values (:id_account_post, :id_current_account, :id_target_account);
end
^

/* Alter (ACCOUNT_POSTING_UPDATE) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable in_db_key char(8);
begin
  /* GUI facade for manual update */
  select AP.ID_ACCOUNT, AP.ID_GUEST, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :id_guest, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :id_account, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date)
  returning_values  (:new_qty_post, :new_price_post, :new_ac);

  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    if (coalesce(:id_guest, 0) > 0) then begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || :id_account
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'POST_UPDATE', :action_text);
    end else begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
    end
  end

end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_MODIFY$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE ACCOUNT_MODIFY$INT(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL /* TYPE OF ID_REF */ INTEGER,
IS_PMS_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_GET_ACCOUNT$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE PROFILE_GET_ACCOUNT$INT(ID_PROFILE INTEGER,
ID_RESERV_DETAIL INTEGER,
ACCOUNT_CURR VARCHAR(3),
ID_ACC_TEMPLATE INTEGER,
IS_BASE_ENABLE SMALLINT = 1,
IS_EXTRA_ENABLE SMALLINT = 1)
 RETURNS(ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_SET_ARCHIVE$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE PROFILE_SET_ARCHIVE$INT(P_DBKEY CHAR(8),
ARCHIVE_STATUS SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_ACCOUNTS_RECIEVE$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE RES_ACCOUNTS_RECIEVE$INT(ID_RESERV_DETAIL INTEGER,
OLD_ID_BASE_ACCOUNT INTEGER,
OLD_ID_EXTRA_ACCOUNT INTEGER,
ID_AGENT_ACCOUNT_RULE INTEGER,
ID_BASE_ACCOUNT_PROFILE INTEGER,
ID_EXTRA_ACCOUNT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ID_ACC_TEMPLATE_PERSON INTEGER,
IS_SEPARATE_ACCOUNTS SMALLINT)
 RETURNS(NEW_ID_BASE_ACCOUNT INTEGER,
NEW_ID_EXTRA_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_ARCHIVATE_ACCOUNTS$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE RES_ARCHIVATE_ACCOUNTS$INT(ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACC_ARCHIVE$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE RES_SAVE_ACC_ARCHIVE$INT(ACCOUNTS_FOR_ARCHIVE VARCHAR(2000),
ID_PROFILE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTS_FINALIZE$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE RES_SAVE_ACCOUNTS_FINALIZE$INT(ID_RESERV_DETAIL INTEGER,
OLD_ID_BASE_ACCOUNT INTEGER,
OLD_ID_EXTRA_ACCOUNT INTEGER,
NEW_ID_BASE_ACCOUNT INTEGER,
NEW_ID_EXTRA_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_SET_ARCHIVE_STATUS) */
ALTER PROCEDURE ACCOUNT_SET_ARCHIVE_STATUS(ID_ACCOUNT INTEGER,
IS_ARCHIVE SMALLINT)
 AS
declare variable post_sum numeric (15,2);
  declare variable dep_sum numeric (15,2);
  declare variable open_charges integer;
  declare variable old_is_archive integer;
  declare variable id_profile integer;
  declare variable id_hotel integer;
  declare variable p_dbkey char(8);
  declare variable acc_dbkey char(8);
  declare variable archived_date date;
  declare variable is_used integer;
  declare variable action_text varchar(255);
  declare variable account_name varchar(50);
begin

  select A.RDB$DB_KEY, A.IS_ARCHIVE, A.ID_PROFILE, A.ID_HOTEL, A.ACCOUNT_NAME
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :acc_dbkey, :old_is_archive, :id_profile, :id_hotel, :account_name;
  /* --------------------------------------- */
  if (:old_is_archive = :IS_ARCHIVE) then exit;
  /* --------------------------------------- */
  if (:IS_ARCHIVE = 0) then begin
    -- unarchive
    update ACCOUNT A
    set    A.IS_ARCHIVE = 0
    where  A.RDB$DB_KEY = :acc_dbkey;

    p_dbkey = null;
    select P.RDB$DB_KEY
    from   PROFILE P
    where  P.ID_PROFILE = :id_profile
           and p.IS_ARCHIVE = 1
    into   :p_dbkey;

    if (:p_dbkey is not null) then begin
      /* restore profile active status */
      execute procedure PROFILE_SET_ARCHIVE$INT (:p_dbkey, 0);
    end

  end else begin
    execute procedure ACCOUNT_USE_CHECK$INT (:ID_ACCOUNT)
    returning_values (:is_used);

    if (:is_used = 1) then begin
      select AB.POST_VALUE, AB.DEP_VALUE, AB.OPEN_CHARGES
      from   ACCOUNT_BALANCE$INT(:id_account) AB
      into   :post_sum, :dep_sum, :open_charges;
  
      if ((:post_sum <> 0) or (:open_charges = 1)) then
        exception ACCOUNT_EXCEPTION '-44' || f_character(31) || :ID_ACCOUNT;

      if (:dep_sum <> 0) then
        exception ACCOUNT_EXCEPTION '-40' || f_character(31) || :ID_ACCOUNT;
    
      execute procedure SYSTEM_DATE_GET (:id_hotel)
      returning_values (:archived_date);
    end else begin
      archived_date = null;  /* mark account as unused */
    end

    update ACCOUNT A
    set    A.IS_ARCHIVE = 1,
           A.ARCHIVED_DATE = :archived_date
    where  A.RDB$DB_KEY = :acc_dbkey;

    action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'ARCHIVE_ACCOUNT', :action_text);
  end
end
^

/* Alter (ALLOTMENT_PHYS_REBUILD$INT) */
ALTER PROCEDURE ALLOTMENT_PHYS_REBUILD$INT(IN_ID_HOTEL INTEGER = null,
IN_ID_ROOM_TYPE INTEGER = null)
 AS
declare variable dbg varchar(2000);
  declare variable id_physical_allotment integer;
  declare variable ifrom_date date;
  declare variable ito_date date;
  declare variable icnt_rooms integer;
  declare variable id_allotment_session integer;
  declare variable id_room_type integer;
begin
  for
    select RT.ID_ROOM_TYPE, H.ID_PHYSICAL_ALLOTMENT
    from   HOTEL H
           join ROOM_TYPES RT on RT.ID_HOTEL = H.ID_HOTEL
    where  ((:in_id_hotel is null) or (H.ID_HOTEL = :in_id_hotel))
           and ((:in_id_room_type is null) or (RT.ID_ROOM_TYPE = :in_id_room_type))
    into   :id_room_type, :id_physical_allotment
  do begin
    delete from ALLOTMENT_DETAIL AD
    where  AD.ID_ALLOTMENT = :id_physical_allotment
           and AD.ID_ROOM_TYPE = :id_room_type;
  
    id_allotment_session = gen_id(GEN_ALLOTMENT_SESSION_ID, 1);
    for
      select RP.FROM_DATE, RP.TO_DATE, RP.IS_AVAILABLE
      from   ROOM_PERIOD$PMS RP
             join ROOMS R on R.ID_ROOM = RP.ID_ROOM
      where  R.ID_ROOM_TYPE = :id_room_type
      order by RP.FROM_DATE desc, RP.TO_DATE desc
      into   :ifrom_date, :ito_date, :icnt_rooms
    do begin
      execute procedure ALLOTMENT_TMP_SET$INT(:id_allotment_session, :id_physical_allotment, :id_room_type, :ifrom_date, :ito_date, :icnt_rooms, 0, 0, 1);
    end
  
    execute procedure ALLOTMENT_TMP_GET$INT(:id_allotment_session, 'ROOMS');
  end
end
^

/* empty dependent procedure body */
/* Clear: ALLOTMENT_SET$AVL for: ALLOTMENT_SET_DAYS$INT */
ALTER PROCEDURE ALLOTMENT_SET$AVL(ID_ALLOTMENT INTEGER,
ID_ROOM_TYPE INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
CNT_ROOMS INTEGER,
ACTIVE_FRAME_BEGIN INTEGER = 0,
ACTIVE_FRAME_END INTEGER = 0)
 RETURNS(ID_ALLOTMENT_DETAIL INTEGER,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE,
NEW_TO_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ALLOTMENT_SET_FRAME$AVL for: ALLOTMENT_SET_DAYS$INT */
ALTER PROCEDURE ALLOTMENT_SET_FRAME$AVL(ID_ALLOTMENT INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ACTIVE_FRAME_BEGIN INTEGER = 0,
ACTIVE_FRAME_END INTEGER = 0)
 AS
 BEGIN EXIT; END
^

/* Alter (ALLOTMENT_SET_DAYS$INT) */
ALTER PROCEDURE ALLOTMENT_SET_DAYS$INT(ID_ALLOTMENT INTEGER,
ID_ROOM_TYPE INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ACTIVE_FRAME_BEGIN INTEGER,
ACTIVE_FRAME_END INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_allotment_session integer;
begin
  if (:to_date < :from_date) then exception WRONG_VALUE 'Wrong period';

  id_allotment_session = gen_id(GEN_ALLOTMENT_SESSION_ID, 1);
  execute procedure ALLOTMENT_TMP_DAYS_CUT$INT(:id_allotment, :id_room_type,
          :from_date, :to_date, :id_allotment_session);

  execute procedure ALLOTMENT_TMP_SET$INT(:id_allotment_session, :id_allotment, :id_room_type,
          :from_date, :to_date, 0, :active_frame_begin, :active_frame_end);

  execute procedure ALLOTMENT_TMP_GET$INT(:id_allotment_session, 'DAYS');
end
^

/* Alter (ALLOTMENT_SET_FRAME$AVL) */
ALTER PROCEDURE ALLOTMENT_SET_FRAME$AVL(ID_ALLOTMENT INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ACTIVE_FRAME_BEGIN INTEGER = 0,
ACTIVE_FRAME_END INTEGER = 0)
 AS
declare variable id_room_type integer;
begin
  if (:to_date < :from_date) then exception WRONG_VALUE 'Wrong period';
  --TODO pass list of room_types ias input param !
  for
    select distinct ad.ID_ROOM_TYPE
    from   ALLOTMENT_DETAIL ad    -- only for room types in allotment
    where  ad.id_allotment = :id_allotment
    into   :id_room_type
  do begin
    execute procedure ALLOTMENT_SET_DAYS$INT(:id_allotment, :id_room_type, :from_date, :to_date, :active_frame_begin, :active_frame_end);
  end
end
^

/* empty dependent procedure body */
/* Clear: ALLOTMENT_SET_ROOMS$AVL for: ALLOTMENT_SET_ROOMS$INT */
ALTER PROCEDURE ALLOTMENT_SET_ROOMS$AVL(ID_ALLOTMENT INTEGER,
ID_ROOM_TYPE INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
CNT_ROOMS INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ALLOTMENT_SET_ROOMS$INT) */
ALTER PROCEDURE ALLOTMENT_SET_ROOMS$INT(ID_ALLOTMENT INTEGER,
ID_ROOM_TYPE INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ROOMS_COUNT INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_allotment_session integer;
begin
  if (:to_date < :from_date) then exception WRONG_VALUE 'Wrong period';

  id_allotment_session = gen_id(GEN_ALLOTMENT_SESSION_ID, 1);
  execute procedure ALLOTMENT_TMP_ROOMS_CUT$INT(:id_allotment, :id_room_type,
          :from_date, :to_date, :id_allotment_session);

  execute procedure ALLOTMENT_TMP_SET$INT(:id_allotment_session, :id_allotment, :id_room_type,
          :from_date, :to_date, :rooms_count, 0, 0);

  execute procedure ALLOTMENT_TMP_GET$INT(:id_allotment_session, 'ROOMS');
end
^

/* Alter (ALLOTMENT_TMP_DAYS_CUT$INT) */
ALTER PROCEDURE ALLOTMENT_TMP_DAYS_CUT$INT(ID_ALLOTMENT INTEGER,
ID_ROOM_TYPE INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_ALLOTMENT_SESSION INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable ad_dbkey char(8);
  declare variable ad_from_date date;
  declare variable ad_to_date date;
  declare variable ad_days_before integer;
  declare variable ad_days_after integer;
begin
  /* ALL DETAILS WITH INTERSECTION WITH THE NEW ONE MUST BE TRANSFERED TO THE TEMP SPACE
  || BUT THE NEW PERIOD MUST OBTAIN ONLY THE NEW ROOM COUNT
  */
  for
    select AD.RDB$DB_KEY, AD.FROM_DATE, AD.TO_DATE, AD.DAYS_BEFORE, AD.DAYS_AFTER
    from   ALLOTMENT_RELEASE AD
    where  AD.ID_ALLOTMENT = :id_allotment
           and AD.ID_ROOM_TYPE = :id_room_type
           and ((:to_date is null)  or (AD.FROM_DATE <= :to_date + 1))
           and ((:from_date is null)  or (AD.TO_DATE >= :from_date - 1))
    into   :ad_dbkey, :ad_from_date, :ad_to_date, :ad_days_before, :ad_days_after
  do begin
    execute procedure ALLOTMENT_TMP_SET$INT(:id_allotment_session, :id_allotment, :id_room_type,
            :ad_from_date, :ad_to_date, 0, :ad_days_before, :ad_days_after);

    delete from ALLOTMENT_RELEASE AD
    where  AD.RDB$DB_KEY = :ad_dbkey;
  end
end
^

/* Alter (ALLOTMENT_TMP_ROOMS_CUT$INT) */
ALTER PROCEDURE ALLOTMENT_TMP_ROOMS_CUT$INT(ID_ALLOTMENT INTEGER,
ID_ROOM_TYPE INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_ALLOTMENT_SESSION INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable ad_dbkey char(8);
  declare variable ad_from_date date;
  declare variable ad_to_date date;
  declare variable ad_cnt_rooms integer;
begin
  /* ALL DETAILS WITH INTERSECTION WITH THE NEW ONE MUST BE TRANSFERED TO THE TEMP SPACE
  || BUT THE NEW PERIOD MUST OBTAIN ONLY THE NEW ROOM COUNT
  */
  for
    select AD.RDB$DB_KEY, AD.FROM_DATE, AD.TO_DATE, AD.CNT_ROOMS
    from   ALLOTMENT_DETAIL AD
    where  AD.ID_ALLOTMENT = :id_allotment
           and AD.ID_ROOM_TYPE = :id_room_type
           and ((:to_date is null)  or (AD.FROM_DATE <= :to_date + 1))
           and ((:from_date is null)  or (AD.TO_DATE >= :from_date - 1))
    into   :ad_dbkey, :ad_from_date, :ad_to_date, :ad_cnt_rooms
  do begin
    execute procedure ALLOTMENT_TMP_SET$INT(:id_allotment_session, :id_allotment, :id_room_type,
            :ad_from_date, :ad_to_date, :ad_cnt_rooms, 0, 0);

    delete from ALLOTMENT_DETAIL AD
    where  AD.RDB$DB_KEY = :ad_dbkey;
  end
end
^

/* empty dependent procedure body */
/* Clear: CANCEL_BOOKING$EXC for: APPLY_BOOKING_STATUS$EXC */
ALTER PROCEDURE CANCEL_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20),
STATUS VARCHAR(20))
 RETURNS(BOOKING_ID INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (APPLY_BOOKING_STATUS$EXC) */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20)
 AS
declare variable err_text varchar(255);
declare variable dummy_int integer;
declare variable anul_reason varchar(30);
declare variable selection_id integer;

declare variable status_code smallint;
declare variable current_anul_code smallint;
declare variable current_status_code smallint;
declare variable current_status_text varchar(50);
declare variable new_status_text varchar(50);
declare variable extra_posts_left integer;
begin
  if (:booking_db_key is null) then begin
    select rd.RDB$DB_KEY, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.ID_RESERV_DETAIL = :BOOKING_ID
    into   :booking_db_key, :current_status_code, :current_anul_code;
  end else begin
    select rd.id_reserv_detail, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.rdb$db_key = :booking_db_key
    into   :booking_id, :current_status_code, :current_anul_code;
  end

  execute procedure IMPORT_BOOKING_STATUS$EXC(:status, -2)
  returning_values :status_code;

  execute procedure EXPORT_BOOKING_STATUS$EXC(:current_status_code, :current_anul_code)
  returning_values :current_status_text;
  execute procedure IMPORT_BOOKING_STATUS$EXC(:current_status_text, :current_status_code)
  returning_values :current_status_code;

  /* nop - exit */
  if (:current_status_code = :status_code) then exit;

  /* validate status transition */
  if (
     /* terminal status values - void booking */
    (:current_status_code in (1004/*no show*/, 1005/*canceled*/))

    /* void over checkin */
    or ((:current_status_code >= 0) and (:status_code in (1004/*no show*/, 1005/*canceled*/)))

    /* positive status downgrade */
    or ((:current_status_code > 0) and (:current_status_code > :status_code))
  )  then begin
    execute procedure PRINT_BOOKING_STATUS$EXC(:current_status_code) returning_values :current_status_text;
    execute procedure PRINT_BOOKING_STATUS$EXC(:status_code) returning_values :new_status_text;

    exception VALIDATE_EXCEPTION '-1022' || f_character(31) || '@{invalid_status_transition} ' || :current_status_text || ' -> ' || :new_status_text;
  end

  anul_reason = null;
  if (1004 = :status_code) then begin
    anul_reason = 'NOSHOW';
  end else if (1005 = :status_code) then begin
    anul_reason = 'CANCELED';
  end

  if (:anul_reason is null) then begin
    if (0 > :status_code) then begin
      execute procedure RES_SAVE_STATUS$INT(:booking_db_key, :status_code, :CONFIRMATION_NUMBER);
    end else begin
      if (:status_code in (0, 1) and 0 > :current_status_code) then begin
        -- checkin
        execute procedure RES_SET_CHECKIN$INT (:booking_db_key)
        returning_values (:dummy_int, :err_text, :dummy_int, :dummy_int);
      end
      if (1 = :status_code and 1 > :current_status_code) then begin
        -- checkout
        selection_id = gen_id(SELECTION_GEN, 1);
        update RESERV_DETAIL
        set    selection_id=:selection_id
        where  rdb$db_key=:booking_db_key;
    
        execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id);
      end
    end
  end else begin
    -- void
    execute procedure RES_ANUL_DETAIL$INT(:booking_db_key, :anul_reason, :CANCELATION_NUMBER)
    returning_values  :dummy_int, :extra_posts_left;
    if (:extra_posts_left = 1) then exception BOOKING_EXCEPTION '-1042';

  end
end
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUPANCY$RPT for: AVAILABILITY_OCCUP_PREPARE$AVL */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$RPT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ID_ROOM_TYPE INTEGER,
FOR_DATE DATE,
ID_PROFILE INTEGER,
ROOMS_AVAILABLE SMALLINT,
ROOMS_OOI SMALLINT,
ROOMS_OOO SMALLINT,
ROOMS_SOLD_CONFIRMED SMALLINT,
ROOMS_SOLD_NOTCONFIRMED SMALLINT,
ROOMS_SOLD SMALLINT,
ROOMS_SOLD_MULTIPLE_GST SMALLINT,
ROOMS_ARRIVAL SMALLINT,
ROOMS_DEPARTURE SMALLINT,
GUESTS_IN_HOUSE BIGINT,
GUESTS_ARRIVAL BIGINT,
GUESTS_DEPARTURE BIGINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: OCCUPANCY_RTI_BP$RPT for: AVAILABILITY_OCCUP_PREPARE$AVL */
ALTER PROCEDURE OCCUPANCY_RTI_BP$RPT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ROOM_TYPES VARCHAR(255))
 RETURNS(OUT_DATE DATE,
CATEGORY VARCHAR(50),
AGENT_NAME VARCHAR(50),
ROOM_CNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SUMMARY_FORECAST$INT for: AVAILABILITY_OCCUP_PREPARE$AVL */
ALTER PROCEDURE SUMMARY_FORECAST$INT(ID_HOTEL INTEGER,
SUMMARY_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* Alter (AVAILABILITY_OCCUP_PREPARE$AVL) */
ALTER PROCEDURE AVAILABILITY_OCCUP_PREPARE$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS INTEGER,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
begin

  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, :FETCH_TOTALS, 1, 1, 1, 1, 1, 1, :HOTELS);
   
  execute procedure AVAILABILITY_OCCUPANCY_OPT$INT (:RELEASE_DATES, :OVERBOOK,
          :RES_CONFIRMED, :RES_NOTCONFIRMED, :RES_WAITING, :BOOKING_POSITIONS, :CONTINGENT);

end
^

/* Alter (AVAILABILITY_OCCUP_SMALL$EXC) */
ALTER PROCEDURE AVAILABILITY_OCCUP_SMALL$EXC(ID_ALLOTMENT INTEGER)
 RETURNS(FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_HOTEL INTEGER,
CNT_ROOMS INTEGER)
 AS
declare variable tmp_from_date date;
declare variable tmp_to_date date;
declare variable tmp_for_date date;
declare variable tmp_id_room_type integer;
declare variable tmp_available integer;
begin
  --check if allotment is physical
  select h.ID_HOTEL
  from   HOTEL h
  where  h.ID_PHYSICAL_ALLOTMENT = :ID_ALLOTMENT
  into   :ID_HOTEL;
  if (:ID_HOTEL is null) then exit;

  -- get min allotment date
  select min(ad.FROM_DATE)
  from   ALLOTMENT_DETAIL ad
  where  ad.ID_ALLOTMENT = :ID_ALLOTMENT
  into   :tmp_from_date;

  if (:tmp_from_date is null) then begin
    tmp_from_date = 'now';
  end

  tmp_to_date = 'now';
  tmp_to_date = :tmp_to_date + 1068; -- 3 years

  FROM_DATE = null;
  TO_DATE = null;
  ID_ROOM_TYPE = null;
  CNT_ROOMS = null;
  -- group data in periods by room type and availability
  for
    select ac.FOR_DATE, ac.ID_ROOM_TYPE, ac.AVAILABLE
    from   AVAILABILITY_OCCUP_SMALL$INT(:tmp_from_date, :tmp_to_date, :ID_HOTEL, 1) ac
    order by ID_ROOM_TYPE, FOR_DATE
    into   :tmp_for_date, :tmp_id_room_type, :tmp_available
  do begin
    if (:ID_ROOM_TYPE is null) then begin
      ID_ROOM_TYPE = :tmp_id_room_type;
    end
    if (:FROM_DATE is null) then begin
      FROM_DATE = :tmp_for_date;
    end
    if (:CNT_ROOMS is null) then begin
      CNT_ROOMS = :tmp_available;
    end

    if ((:ID_ROOM_TYPE <> :TMP_ID_ROOM_TYPE) or (:CNT_ROOMS <> :TMP_AVAILABLE)) then begin
      suspend;
      ID_ROOM_TYPE = :tmp_id_room_type;
      FROM_DATE = :tmp_for_date;
      CNT_ROOMS = :tmp_available;
    end

    TO_DATE = :tmp_for_date;
  end

  if (:ID_ROOM_TYPE is not null) then begin
    suspend;
  end
end
^

/* Alter (AVAILABILITY_OCCUP_SMALL$WBE) */
ALTER PROCEDURE AVAILABILITY_OCCUP_SMALL$WBE(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER,
QUERY_ID INTEGER,
ROOMS INTEGER,
RATES VARCHAR(255) = '',
ROOMTYPES VARCHAR(255) = '')
 AS
declare variable id_channel integer;
declare variable error_check integer;
declare variable room_type_id integer;
declare variable availability_date date;
declare variable available_rooms integer;
declare variable is_available integer;
begin
  /*Leave data in table availability_room_type$wbe */
  /*In WBE database, look directly to WBE channel settings */

  /*empty WBE specific table*/
  delete from AVAILABILITY_ROOM_TYPE$WBE
  where QUERY_ID = :QUERY_ID;

  select max(c.id_channel), count(c.id_channel)
  from   CHANNEL c
  where  c.name = 'WBE'
  into   :id_channel, :error_check;
  if (not (:error_check = 1)) then  exception WRONG_VALUE 'Missing channel WBE or dublicated definition!';

  /*Fill WBE specific table*/
  /*polzwa se MAX, za6toto ako pone edna tarifa e pozwolena, zna4i ima stai*/
  /*!!!!! PROBLEM - channel management-a moje da puska stai i tarifi, no towa wse o6te ne ozna4awa 4e et mogat da minat prez tarifata i da polu4at cena*/
  for
    select  PA.id_room_type, PA.for_date,  max(PA.available_rooms),  max(PA.product_status)
    from    PRODUCT_AVAILABILITY$AVL(:id_channel, :id_hotel, :from_date, :to_date, :rates, :roomtypes) PA
    group by 1, 2
    into    :room_type_id, :availability_date, :available_rooms, :is_available
  do begin
    if ((:rooms > :available_rooms) or (:is_available = 0)) then begin
      available_rooms = 0;
      is_available = 0;
    end else begin
      is_available = 1;
    end

    insert into AVAILABILITY_ROOM_TYPE$WBE (room_type_id, availability_date, available_rooms, is_available, query_id)
    values (:room_type_id, :availability_date, :available_rooms, :is_available, :query_id);
  end

end
^

/* empty dependent procedure body */
/* Clear: TEST_AVAILABILITY for: AVAILABILITY_OCCUPANCY$AVL */
ALTER PROCEDURE TEST_AVAILABILITY RETURNS(FOR_DATE DATE,
MINUS_ROOM_TYE INTEGER,
ID_AGENT INTEGER,
AGENT_NAME VARCHAR(100),
SOLD INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
CONT_BP_REMAIN INTEGER,
RES_WAITING INTEGER,
CONT_PLAIN INTEGER,
CONT_BP INTEGER,
CONT_BP_PLAIN INTEGER,
CONT_PLAIN_REMAIN INTEGER,
RES_TOTAL INTEGER,
ROOM_TYPE_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* Alter (AVAILABILITY_OCCUPANCY$AVL) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
begin

  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, :FETCH_TOTALS, 1, 1, 1, 1, 1, 1, :HOTELS);

  ID_OCCUPANCY_SESSION = current_transaction;
end
^

/* Alter (AVAILABILITY_OCCUPANCY$RPT) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$RPT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ID_ROOM_TYPE INTEGER,
FOR_DATE DATE,
ID_PROFILE INTEGER,
ROOMS_AVAILABLE SMALLINT,
ROOMS_OOI SMALLINT,
ROOMS_OOO SMALLINT,
ROOMS_SOLD_CONFIRMED SMALLINT,
ROOMS_SOLD_NOTCONFIRMED SMALLINT,
ROOMS_SOLD SMALLINT,
ROOMS_SOLD_MULTIPLE_GST SMALLINT,
ROOMS_ARRIVAL SMALLINT,
ROOMS_DEPARTURE SMALLINT,
GUESTS_IN_HOUSE BIGINT,
GUESTS_ARRIVAL BIGINT,
GUESTS_DEPARTURE BIGINT)
 AS
begin

  execute procedure AVAILABILITY_OCCUP_PREPARE$AVL (:FROM_DATE, :TO_DATE, 1, 0, 0, 1, 1, 0, 0, 0, :ID_HOTEL);

  for
    select SO.ID_ROOM_TYPE,
           SO.FOR_DATE,
           pa.id_profile,
           sum(SO.G_CAPACITY),
           sum(so.G_OOI),
           sum(so.G_OOO),
           sum(so.SOLD + so.RES_CONFIRMED),
           sum(so.RES_NOTCONFIRMED),
           sum(so.SOLD + so.RES_CONFIRMED + so.RES_NOTCONFIRMED),
           sum(iif(so.GUESTS_INHOUSE > 1, so.SOLD, 0)),
           sum(so.ROOMS_COME),
           sum(so.ROOMS_GONE),
           sum(so.GUESTS_INHOUSE),
           sum(so.GUESTS_COME),
           sum(so.GUESTS_GONE)
    from   SMART_OCCUP$TMP SO
           left outer join PROFILE_AGENT pa on pa.id_agent = so.id_agent
    group by 1, 2, 3
    into   :ID_ROOM_TYPE, :FOR_DATE, :id_profile, :ROOMS_AVAILABLE, :ROOMS_OOI, :ROOMS_OOO,
           :ROOMS_SOLD_CONFIRMED, :ROOMS_SOLD_NOTCONFIRMED,
           :ROOMS_SOLD, :ROOMS_SOLD_MULTIPLE_GST, :ROOMS_ARRIVAL, :ROOMS_DEPARTURE,
           :GUESTS_IN_HOUSE, :GUESTS_ARRIVAL, :GUESTS_DEPARTURE
  do begin
    suspend;
  end
end
^

/* Alter (CACHES_RESOLVE) */
ALTER PROCEDURE CACHES_RESOLVE AS
declare variable id_res_detail integer;
  declare variable id_group integer;
  declare variable cache_cnt integer;
  declare variable id_account integer;
  declare variable no_use varchar(1024);
begin
  /* resolve reservs cache conflicts */
  for
    select first 20 RG.ID_RESERV_DETAIL, rg.ID_GROUP, sum(iif(rg.BOARD_NAMES is null, 2, 1))
    from   RESERV_GUESTDATA_CACHE RG
    group by RG.ID_RESERV_DETAIL, rg.ID_GROUP
    having sum(iif(rg.BOARD_NAMES is null, 2, 1)) > 1
    into   :id_res_detail, :id_group, :cache_cnt
  do begin
    execute procedure RES_GET_GUEST_DATA$INT (iif(:id_res_detail is not null, 'DETAIL', 'GROUP'), coalesce(:id_res_detail, :id_group))
    returning_values  (:no_use, :no_use, :no_use, :no_use);

    when any do begin
      execute procedure sys_dbg('all Cache resolve error for reserv '|| iif(:id_res_detail is not null, 'DETAIL', 'GROUP') || ': ' || coalesce(:id_res_detail, :id_group));
    end
  end 

  /* resolve account balances cache conflicts */
  for
    select first 20 AC.ID_ACCOUNT, sum(iif(AC.ACCOUNT_BALANCE is null, 2, 1))
    from   ACCOUNT_BALANCE_CACHE AC
    group by AC.ID_ACCOUNT
    having sum(iif(AC.ACCOUNT_BALANCE is null, 2, 1)) > 1
    into   :id_account, :cache_cnt
  do begin
    execute procedure ACCOUNT_BALANCE$INT (:id_account, 0)
    returning_values  (:no_use, :no_use, :no_use, :no_use, :no_use, :no_use, :no_use);

    when any do begin
      execute procedure sys_dbg('all Cache resolve error for account: ' || :id_account);
    end
  end 
end
^

/* Alter (CANCEL_BOOKING$EXC) */
ALTER PROCEDURE CANCEL_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20,
STATUS VARCHAR(20))
 RETURNS(BOOKING_ID INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable hotel_id integer;
declare variable cancel_event_log_id integer;
begin
  /* init */
  err_code = 0;
  err_text = '';

  execute procedure import_mark_transaction$exc;

  select first 1 b.id_reserv_detail, b.id_log_event_annul, b.from_date, b.to_date
  from   reserv_detail b
  where  b.number=:number
         and b.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  order by id_log_event_annul nulls first
  into   :booking_id, cancel_event_log_id, :from_date, :to_date;

  if ((:booking_id is null) or (:cancel_event_log_id is not null)) then begin
    /* not found or found but already in void status - ignore and exit */
    exit;
  end

  /* verify hotel */
  execute procedure lookup_hotel$exc(:hotel, 'BOOKING', :booking_id)
  returning_values :hotel_id;

  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  execute procedure APPLY_BOOKING_STATUS$EXC(
    :booking_id, null, :status, :confirmation_number, :cancelation_number
  );
end
^

/* Alter (CHANNEL_GET_WHOLEALLOTMENT$CHM) */
ALTER PROCEDURE CHANNEL_GET_WHOLEALLOTMENT$CHM(ID_CHANNEL INTEGER)
 RETURNS(ID_ROOM_TYPE INTEGER,
FOR_DATE DATE,
IS_ACTIVE INTEGER,
AUTO_FREE_ROOMS INTEGER,
ROOM_COUNT INTEGER,
FREE_ROOMS INTEGER,
STATUS INTEGER)
 AS
declare variable date_from date;
  declare variable date_to date;
  declare variable channel_capacity integer;
  declare variable to_sell integer;
begin
  date_from = null;
  select min(FOR_DATE), max(FOR_DATE)
  from CHANNEL_ALLOTMENT
  where ID_CHANNEL = :id_channel
  into :date_from, :date_to;
  if (date_from is null) then exit;

  for select distinct ID_ROOM_TYPE
      from CHANNEL_ALLOTMENT
      where ID_CHANNEL = :id_channel
        and FOR_DATE between :date_from and :date_to
      into :id_room_type
  do begin
    for select RTR.FOR_DATE,
               CA.STATUS,
               CA.AUTO_FREE_ROOMS, CA.ROOM_COUNT, RTR.AVAILABLE as FREE_ROOMS
        from ROOM_TYPE_GET_FREE$CHM(:date_from, :date_to, :id_room_type) RTR
             join CHANNEL_ALLOTMENT CA on CA.ID_ROOM_TYPE = :id_room_type
                                      and CA.ID_CHANNEL = :id_channel
                                      and CA.FOR_DATE = RTR.FOR_DATE
    into :for_date, :status,
         :auto_free_rooms, :channel_capacity, :free_rooms
    do begin
      if (:auto_free_rooms is not null) then
        if (coalesce(:free_rooms,0) >= :auto_free_rooms) then
          is_active = 1;
        else is_active = 0;
      else if (:status = 0) then
             is_active = 1;
           else is_active = 0;

      to_sell = coalesce(:free_rooms,0) - coalesce(:auto_free_rooms,0);
      if (to_sell < 0) then to_sell = 0;

      room_count = :to_sell;
      if (:channel_capacity is not null) then
        if (channel_capacity < room_count) then
          room_count = :channel_capacity;

      suspend;
    end
  end
end
^

/* Alter (CHANNEL_IDSGDS_AVAILABILITY$EXC) */
ALTER PROCEDURE CHANNEL_IDSGDS_AVAILABILITY$EXC(CHANNEL_NAME VARCHAR(30),
ID_HOTEL INTEGER,
ADD_BOOKINGS_WITH_PREFIX VARCHAR(10))
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_SIMPLE_RATE INTEGER,
ID_BOARD INTEGER,
ROOM_STATUS INTEGER,
RATE_STATUS INTEGER,
PRODUCT_STATUS INTEGER,
AVAILABLE_ROOMS INTEGER,
MIN_LOS INTEGER,
MAX_LOS INTEGER,
SINGLE_PRICE NUMERIC(15,4),
DOUBLE_PRICE NUMERIC(15,4),
GUEST3_PRICE NUMERIC(15,4),
GUEST4PLUS_PRICE NUMERIC(15,4),
CHILD1_W_ADULT1_PRICE NUMERIC(15,4),
CHILD1_W_ADULT2PLUS_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT1_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT2PLUS_PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3))
 AS
declare variable date_from date;
declare variable date_to date;
declare variable id_channel integer;
declare variable rate_found integer;
declare variable id_helper_session integer;
declare variable ch_date date;
declare variable ch_id_room integer;
declare variable ch_occupied integer;
begin
  --product_status 0 - closed
  --product_status 1 - closed for arrival
  --product_status 2 - opened
  --ADD_BOOKINGS_WITH_PREFIX - if set - add reservations with this prefix to channel availability. For pegasus etc.
  
  select min(CA.FOR_DATE), max(CA.FOR_DATE), min(C.ID_CHANNEL)
  from   CHANNEL_ALLOTMENT CA
         join CHANNEL C on C.ID_CHANNEL = CA.ID_CHANNEL
         join ROOM_TYPES RT on RT.ID_ROOM_TYPE = CA.ID_ROOM_TYPE
  where  C.NAME = :channel_name
         and CA.FOR_DATE >= current_date
         and RT.ID_HOTEL = :id_hotel
  into   :date_from, :date_to, :id_channel;
  if (date_from is null) then exit;

  /* Get reservations already booked. To add them to availability. Case is Pegasus */
  if (coalesce (ADD_BOOKINGS_WITH_PREFIX,'') <> '') then begin
    id_helper_session = gen_id(SELECTION_GEN, 1);
  
    for
       select RM.BUSY_DATE, RM.ID_ROOM_TYPE,  count(distinct RM.ID_ROOM) as ROOMS
       from   reserv_detail rd
              join  ROOM_MAGIC RM on rm.id_reserv_detail = rd.id_reserv_detail
       where  rd.id_hotel = :id_hotel
              and rd.to_date > current_date
              and RM.BUSY_DATE >= current_date
              and RM.DAY_ACTION not containing 'CHECK_OUT'
              /*bez Waiting reservations*/
              and RM.BUSY_TYPE <> 'VALUE_RESERVS'
              and rd.number_1 = :ADD_BOOKINGS_WITH_PREFIX
              and coalesce( rd.number_1, '') <> ''
       group by 1,2
       into :ch_date, :ch_id_room, :ch_occupied
     do begin
       insert into tmp_small_occup (id_session, for_date, id_room_type,  occupied)
       values (:id_helper_session, :ch_date, :ch_id_room, :ch_occupied ) ;
     end
   end
  /* */
  for
    select PA.FOR_DATE, PA.ID_ROOM_TYPE, PA.ID_TAR_HEAD,
           PA.ROOM_STATUS, PA.RATE_STATUS, PA.PRODUCT_STATUS,
           PA.AVAILABLE_ROOMS + coalesce(tso.occupied,0), PA.MIN_LOS, PA.MAX_LOS,
           T.CURR
    from   PRODUCT_AVAILABILITY$AVL(:id_channel, :id_hotel, :date_from, :date_to, '', '') PA
           left outer join TARIFA T on T.ID_TARIFA = PA.ID_TAR_HEAD
           left outer join TAR_SIMPLE TS on TS.ID_TAR_HEAD = PA.ID_TAR_HEAD
           /*get booked rooms to add them to channel availability (if requested)*/
           left outer join tmp_small_occup tso on PA.for_date = tso.for_date and PA.id_room_type = tso.id_room_type and tso.id_session = :id_helper_session
    where  ((PA.ID_TAR_HEAD is null) or (TS.ID_TAR_SIMPLE is not null))
    into   :for_date, :id_room_type, :id_simple_rate,
           :room_status, :rate_status, :product_status,
           :available_rooms, :min_los, :max_los,
           :price_currency
  do begin
    rate_found = 0;
    single_price = null;
    double_price = null;
    guest3_price = null;
    guest4plus_price = null;
    child1_w_adult1_price = null;
    child1_w_adult2plus_price = null;
    child2plus_w_adult1_price = null;
    child2plus_w_adult2plus_price = null;
    for
      select TSP.SINGLE_PRICE, TSP.DOUBLE_PRICE, TSP.GUEST3_PRICE, TSP.GUEST4PLUS_PRICE,
             TSP.CHILD1_W_ADULT1_PRICE, TSP.CHILD1_W_ADULT2PLUS_PRICE, TSP.CHILD2PLUS_W_ADULT1_PRICE, TSP.CHILD2PLUS_W_ADULT2PLUS_PRICE,
             TSP.ID_BOARD
      from   TAR_SIMPLE TS
             join TAR_SIMPLE_SEASON TSS on TS.ID_TAR_SIMPLE = TSS.ID_TAR_SIMPLE
             join TAR_SIMPLE_SEASON_PERIODS TSSP on TSS.ID_TAR_SIMPLE_SEASON = TSSP.ID_TAR_SIMPLE_SEASON
             join TAR_SIMPLE_PRICE TSP on TSSP.ID_TAR_SIMPLE_SEASON = TSP.ID_TAR_SIMPLE_SEASON
      where  TS.ID_TAR_HEAD = :id_simple_rate
             and :for_date between TSSP.FROM_DATE and TSSP.TO_DATE
             and TSP.ID_ROOM_TYPE = :id_room_type
             and ((tsp.IS_BASE_DAYS_PRICE = 0 and coalesce(tss.SPECIAL_DAYS_OF_WEEK, '') containing extract (weekday from cast(:for_date as date)))
                  or (tsp.IS_BASE_DAYS_PRICE = 1 and coalesce(tss.SPECIAL_DAYS_OF_WEEK, '') not containing extract (weekday from cast(:for_date as date))))
             -- and TSP.days_of_week containing extract (weekday from :for_date )
      into   :single_price, :double_price, :guest3_price, :guest4plus_price,
             :child1_w_adult1_price, :child1_w_adult2plus_price, :child2plus_w_adult1_price, :child2plus_w_adult2plus_price,
             :id_board
    do begin
      rate_found = 1;
      suspend;
    end

    if (:rate_found = 0) then begin
      rate_status = 0;
      product_status = 0;
      suspend;
    end

  end
  /*clear tmp table*/
  delete from tmp_small_occup tso where tso.id_session = :id_helper_session;
end
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_RATE_SMALL$WBE for: CHANNEL_PRODUCT_AVAIL_REQ$INT */
ALTER PROCEDURE AVAILABILITY_RATE_SMALL$WBE(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER,
ROOMS INTEGER,
ADULTS INTEGER,
CHILDREN INTEGER,
QUERY_ID INTEGER,
PROFILE_ID INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (CHANNEL_PRODUCT_AVAIL_REQ$INT) */
ALTER PROCEDURE CHANNEL_PRODUCT_AVAIL_REQ$INT(ID_CHANNEL INTEGER,
ID_HOTEL INTEGER,
ARRIVAL DATE,
DEPARTURE DATE,
ROOMS INTEGER)
 RETURNS(ID_ROOM_TYPE INTEGER,
ID_TAR_HEAD INTEGER,
IS_PRODUCT_AVAIALABLE INTEGER,
ROOM_STATUS INTEGER,
RATE_STATUS INTEGER,
RATE_MIN_LOS INTEGER,
RATE_MAX_LOS INTEGER,
AVAILABLE_ROOMS INTEGER,
IS_PUBLIC SMALLINT)
 AS
declare variable los integer;
begin
    /*TODO Proc will check all room types in channel management and rates in rate restrictions and
           will return all available and nonavailable combinations (products). For each product :
       - is_product_avaialable = 0/1 - general decision for product - can or cannot be sold
       - room_status 0-closed, 2-open - can be used for extra info if product is closed
       - rate_status 0-closed, 1-closed for arrival, 2-open - can be used for extra info if rate is closed
       - rate_min_los and rate_max_los integer - null or > 0 - extra info*/


  los = :departure - :arrival;

  for select PA.ID_ROOM_TYPE, PA.ID_TAR_HEAD,
             min(PA.ROOM_STATUS),
             /*za wsi4ki dni oswen arriaval-a close for arrival = open*/
             min( iif((pa.for_date <> :arrival) and (PA.RATE_STATUS = 1), 2, PA.RATE_STATUS)),
             /*min i max los se gledat samo na datata na pristigane*/
             max( iif((pa.for_date = :arrival), PA.MIN_LOS , null)),
             max( iif((pa.for_date = :arrival), PA.MAX_LOS , null)),
             min(PA.AVAILABLE_ROOMS),
             min(pa.is_public)
  from PRODUCT_AVAILABILITY$AVL(:id_channel, :id_hotel, :arrival, :departure-1, '', '') PA
  where PA.ID_TAR_HEAD is not null
  group by 1, 2
  /*ako kanala ne warne wsi4ki dati ot prestoia - zna4i producta niama definicia tam i ne se predlaga waob6te*/
  having count (pa.for_date) = :los
  into :id_room_type, :id_tar_head,
        :room_status,
        :rate_status,
        :rate_min_los,
        :rate_max_los,
        :available_rooms,
        :is_public
  do begin
    is_product_avaialable = 0;
    if (
        (:available_rooms >= :rooms)
        and (:room_status = 2)
        and (:rate_status = 2)
        and ((:rate_min_los is null) or (:los >= :rate_min_los)  )
        and ((:rate_max_los is null) or (:los <= :rate_max_los)  )
        )
    then is_product_avaialable = 1;
    suspend;
  end
end
^

/* Alter (CLEAR_ORPHAN_GUESTS$EXC) */
ALTER PROCEDURE CLEAR_ORPHAN_GUESTS$EXC(BOOKING_ID INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable guest_id integer;
  declare variable warn_code integer;
  declare variable guest_uuid varchar(50);
begin
  ERR_CODE=0;
  ERR_TEXT=null;

  for select g.id_guest, g.uuid
  from guest g
  where g.id_reserv_detail=:booking_id and g.orphaned_import$exc=1
  into :guest_id, :guest_uuid do begin
    execute procedure sys_dbg('exc CLEAR_ORPHAN_GUESTS$EXC - RES_GUEST_DEL$RSV(:guest_id=>' || coalesce(:guest_id, '<null>') || ', :guest_uuid=>' || coalesce(:guest_uuid, '<null>') || ')');
    execute procedure RES_GUEST_DEL$RSV(
      :guest_id
    ) returning_values :err_code, :err_text, :warn_code;
    if (0 <> :err_code) then begin
      exit;
    end
  end
end
^

/* Alter (CREATE_SESSION_BOOKINGS$WBE) */
ALTER PROCEDURE CREATE_SESSION_BOOKINGS$WBE(WBE_SESSION_ID BIGINT,
ARANGER_ID INTEGER,
LANG_CODE VARCHAR(3))
 RETURNS(SELECTION_ID VARCHAR(20),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable product_selection_id bigint;
declare variable next_num integer;
declare variable sel_cnt integer;
declare variable aranger_name varchar(100);
declare variable aranger_email varchar(50);
declare variable aranger_phone varchar(50);
declare variable booking_id integer;
declare variable record_timestamp timestamp;
declare variable new_res_number varchar(62);
declare variable room_types_src varchar(255) = '';
declare variable rates_src varchar(255) = '';
declare variable hotel_id integer;
declare variable profile_id integer;
declare variable from_date date;
declare variable to_date date;
declare variable day_count integer;
declare variable room_type_id integer;
declare variable rate_id integer;
declare variable query_id_tmp integer;
declare variable rooms_required integer;
declare variable rooms_available integer;
declare variable profile_import_time timestamp;
begin
  execute procedure EXPORT_LOG_FORCE$EXC(1);
  /* test overbook (multiuser) */
   for select ws.hotel_id,ws.profile,aq.first_date,(aq.first_date+aq.day_count)-1,pa.room_type_id,pa.rate_id,aq.day_count
    from   PRODUCT_availability$WBE PA
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    join availability_query$wbe aq on aq.id = pa.query_id
   where ws.id = :wbe_session_id and coalesce(pa.room_count,0) > 0
   into  :hotel_id, :profile_id, :from_date, :to_date, :room_type_id, :rate_id , :day_count
   do begin
       room_types_src = :room_types_src||','||cast(:room_type_id as varchar(10));
       rates_src = :rates_src||','||cast(rate_id as varchar(10));
   end

   query_id_tmp = GEN_ID(AVAILABILITY_QUERY$WBE_SEQ,1);
   insert into availability_query$wbe(ID, WBE_SESSION_ID, FIRST_DATE, DAY_COUNT)    -- prevent FK exception
    values (:query_id_tmp,:wbe_session_id,:from_date,:day_count) ;

   execute procedure availability_occup_small$wbe(:from_date,:to_date,:hotel_id,:query_id_tmp,1,:rates_src,:room_types_src) ;

   --  check minimum available rooms for every day
   err_code = null;
   err_text = '';
   for select pa.room_type_id,pa.room_count,
    (select coalesce(min(art.available_rooms),0) from availability_room_type$wbe art
      where art.query_id = :query_id_tmp and art.room_type_id = pa.room_type_id)
    from product_availability$wbe pa
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    where ws.id = :wbe_session_id
    and coalesce(pa.room_count,0) > 0   into :room_type_id,:rooms_required,:rooms_available
   do begin
       if (rooms_required > rooms_available) then
       begin
        err_code = 1;
        ERR_TEXT = coalesce(ERR_TEXT,'')||:room_type_id||';';
       end
   end
   delete from availability_query$wbe aqt where aqt.id = :query_id_tmp;       -- remove temp query
   if (err_code is not null) then exit;

  /* create profile if not exist and reservations > 1*/
  if (aranger_id is NULL) then
  begin
    select WS.person_name,WS.address,WS.phone
    from   WBE_SESSION$WBE WS
    where  WS.id = :wbe_session_id
    into   :aranger_name,:aranger_email,:aranger_phone;

    execute procedure IMPORT_PERSON_PROFILE$EXC(
       uuid_create(),:aranger_name,null,null,null,null,null,null,null,null,null,null,
       null,null,null,null,:aranger_phone,null,:aranger_email,null,null,null,null,null,null,
       STRHASH_LARGE(substring(uuid_create() from 1 for 4)),null,null,null,null,null,null,null,null,0,0, null)
    returning_values :aranger_id, :profile_import_time;

    update WBE_SESSION$WBE uWS
    set    uWS.profile = :aranger_id
    where  uWS.id = :wbe_session_id;
  end else begin
    -- da podmeni email, phone ako !!
  end
  /* create reservations */
  for
    select PS.id
    from   PRODUCT_SELECTION$WBE PS
    where  PS.wbe_session_id = :wbe_session_id
           and PS.booking_id is null
           and coalesce(PS.is_deleted,0) <> 1
    into   :product_selection_id
  do begin
     if (next_num = 1) then begin      -- increment first reservation number_3
      execute procedure res_number_suffix_gen(:booking_id) returning_values :new_res_number;
      next_num = next_num + 1;
     end
     execute procedure CREATE_BOOKING$WBE(:product_selection_id,:aranger_id,'WBE.'||:selection_id||'.'||:next_num) returning_values :booking_id,:selection_id;
     execute procedure IMPORT_BOOKING_FINALIZE$EXC(:booking_id) returning_values  record_timestamp,:err_code,:err_text;
     insert into SCHEDULER$WBE(booking_id,status,last_action_time,lang_code,guarantee_passed) values (:booking_id, NULL, current_timestamp, :lang_code,0);

     if (next_num is NULL) then begin
      next_num = 1;
     end else begin
      next_num = next_num + 1;
     end
  end
end
^

/* empty dependent procedure body */
/* Clear: PAYMENT_DOC_ANUL$DOC for: DEPOSIT_ANUL$DOC */
ALTER PROCEDURE PAYMENT_DOC_ANUL$DOC(ID_PAYMENT_HEAD INTEGER,
ANUL_REASON VARCHAR(100))
 AS
 BEGIN EXIT; END
^

/* Alter (DEPOSIT_ANUL$DOC) */
ALTER PROCEDURE DEPOSIT_ANUL$DOC(ID_DEPOSIT INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_PAYMENT_HEAD INTEGER)
 AS
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_ANUL');

  execute procedure DEPOSIT_ANUL$INT (:ID_DEPOSIT, :DESCRIPTION)
  returning_values :ID_PAYMENT_HEAD;

end
^

/* Alter (DEPOSIT_DOCUMENT_INITIALIZE$DOC) */
ALTER PROCEDURE DEPOSIT_DOCUMENT_INITIALIZE$DOC(ID_PAYMENT_HEAD INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER,
ID_HOTEL INTEGER,
ID_ACCOUNT INTEGER)
 AS
declare variable id_dep_doc integer;
declare variable doc_selected integer;
declare variable payment_date date;
declare variable system_date date;
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_BILLING');

  id_dep_doc = null;

  select p.ID_DOC_HEAD, p.ID_ACCOUNT, p.PAYMENT_DATE, a.ID_HOTEL
  from   PAYMENT_HEAD P
         join DEPOSIT d on d.ID_PAYMENT_HEAD = p.ID_PAYMENT_HEAD
         join ACCOUNT a on a.ID_ACCOUNT = p.ID_ACCOUNT
  where  p.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
         and p.IS_ANUL = 0
  into   :id_dep_doc, :id_account, :payment_date, :id_hotel;

  if (:id_account is null) then
    exception DOCUMENT_EXCEPTION '-355';

  if (:id_dep_doc is not null) then
    exception DOCUMENT_EXCEPTION '-364';

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :system_date;

  if (:payment_date < :system_date) then
    exception DOCUMENT_EXCEPTION '-399';

  doc_selected = gen_id(DOC_SELECTED_GEN, 1);

  update DEPOSIT P
  set    p.DOC_SELECTED = :doc_selected
  where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;

  execute procedure DOCUMENT_INITIALIZE$DOC (:ID_ACCOUNT, :doc_selected)
  returning_values  (:ID_DOC_HEAD, :ID_HOTEL);

end
^

/* Alter (DOCUMENT_ADD_DEF_PAYMENT$DOC) */
ALTER PROCEDURE DOCUMENT_ADD_DEF_PAYMENT$DOC(ID_DOC_HEAD INTEGER,
ID_PAY_DOC_TYPE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable pay_curr varchar(3);
  declare variable doc_curr varchar(3);
  declare variable id_account integer;
  declare variable doc_sub_type integer;
  declare variable id_base_doc integer;
  declare variable paydocs_cnt integer;
  declare variable id_payment_head integer;
  declare variable storno_amount numeric(15,4);
  declare variable rest_value numeric(15,4);
  declare variable doc_rnd_to numeric(15,4);
  declare variable doc_value numeric(15,4);
  declare variable pay_rate numeric(15,6);
  declare variable doc_rate numeric(15,6);
  declare variable extra_info_needed smallint;
  declare variable id_doc_type integer;
begin                         /* create payment */
  PAY_CURR = null;
  select D.ID_ACCOUNT, D.DOC_SUB_TYPE, D.ID_BASE_DOC,
         D.DOC_CURRENCY, D.DOC_VALUE_A, d.DOC_RATE, d.ID_DOC_TYPE
  from   DOC_HEAD D
         join DOC_TYPE DT on dt.ID_DOC_TYPE = d.ID_DOC_TYPE
  where  D.ID_DOC = :ID_DOC_HEAD
  into   :id_account, :doc_sub_type, :id_base_doc,
         :doc_curr, :doc_value, :doc_rate, :id_doc_type;

  if (:doc_sub_type < 2) then begin
    if (:ID_PAY_DOC_TYPE is null) then begin
      /* = case */
      execute procedure PAYMENT_GET_DEFAULT$INT (:ID_ACCOUNT)
      returning_values  (:ID_PAY_DOC_TYPE, :pay_curr);

      if (:pay_curr <> :doc_curr) then begin
        execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, null)
        returning_values  (:dbg, :dbg, :dbg, :dbg, :rest_value);

        select C.ROUND_TO
        from   CURRS C
        where  C.CURR = :DOC_CURR
        into   :doc_rnd_to;
         
        if (:REST_VALUE = :DOC_RND_TO) then begin
          select iif(pdt.CURRENCY_LIST containing :doc_curr, :doc_curr, null)
          from   DOC_TYPE pdt
          where  pdt.ID_DOC_TYPE = :ID_DOC_TYPE
          into   :pay_curr;
        end
      end
    end else begin
      select  PDT.DEF_CURRENCY
      from    PAY_DOC_TYPE_S PDT
      where   PDT.ID_DOC_TYPE = :ID_PAY_DOC_TYPE
              and PDT.IS_ARCHIVE = 0
              and PDT.DOC_DIRECTION = 1
      into    :PAY_CURR;
    end

    if (:ID_PAY_DOC_TYPE is not null and :PAY_CURR is not null) then begin
      select coalesce(dtp.IS_CC, 0) + coalesce(dtp.IS_AR_DEBT, 0)
      from   DOC_TYPE_PAY DTp
      where  DTP.ID_DOC_TYPE = :ID_PAY_DOC_TYPE
      into   :extra_info_needed;

      if (:extra_info_needed = 0) then begin
        execute procedure DOCUMENT_ADD_PAYMENT$DOC (:ID_DOC_HEAD, :ID_PAY_DOC_TYPE, null, :PAY_CURR, '')
        returning_values :DBG;
      end
    end
  end else begin
    select count(P.ID_PAYMENT_HEAD)
    from   PAYMENT_HEAD P
    where  P.ID_DOC_HEAD = :ID_BASE_DOC
    into   :PAYDOCS_CNT;

    if (:PAYDOCS_CNT = 1) then begin
      select P.ID_PAYMENT_HEAD, P.PAY_CURRENCY, P.PAY_RATE
      from   PAYMENT_HEAD P
      where  P.ID_DOC_HEAD = :ID_BASE_DOC
      into   :id_payment_head, :pay_curr, :pay_rate;

      if (:pay_curr = :doc_curr) then pay_rate = :doc_rate;
      execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, :pay_curr, :pay_rate)
      returning_values  (:dbg, :dbg, :dbg, :dbg, :rest_value);

      STORNO_AMOUNT = -:REST_VALUE;

      execute procedure PAYMENT_STORNO$INT (:ID_PAYMENT_HEAD, :ID_ACCOUNT, :ID_DOC_HEAD, :STORNO_AMOUNT, '', :DOC_VALUE)
      returning_values  :DBG;

      when any do exit;
       
    end
  end
end
^

/* Alter (DOCUMENT_ANUL$DOC) */
ALTER PROCEDURE DOCUMENT_ANUL$DOC(ID_DOC_HEAD INTEGER,
ANUL_REASON VARCHAR(100),
MAKE_ANNUL_REPORT SMALLINT)
 AS
/**/
  declare variable id_account  integer;
  declare variable id_payment_head integer;
  declare variable for_deposit integer;
  declare variable id_base_doc integer;
  declare variable is_anul integer;
  declare variable dh_dbkey char(8);
  declare variable id_annul_protocol_num integer;
  declare variable num integer;
  declare variable doc_num varchar(20);
  declare variable system_date date;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable doc_date date;
  declare variable id_system_log integer;
  declare variable id_hotel integer;
  declare variable is_storno_doc integer;
  declare variable no_use integer;
begin

  select H.RDB$DB_KEY, H.ID_ACCOUNT, H.FOR_DEPOSIT, H.ID_BASE_DOC, H.IS_ANUL, A.ID_HOTEL,
         A.ID_RESERV_DETAIL, T.ID_ANNUL_DOC_NUM, h.DOC_DATE, H.IS_STORNO
  from   DOC_HEAD$INT H
         join DOC_COMPLETION dc on dc.ID_DOC_HEAD = h.ID_DOC_HEAD
         join DOC_TYPE T on H.ID_DOC_TYPE = T.ID_DOC_TYPE
         join DOC_TYPE_INV DTI on DTI.ID_DOC_TYPE = T.ID_DOC_TYPE
         join ACCOUNT A on A.ID_ACCOUNT = H.ID_ACCOUNT
  where  H.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :dh_dbkey, :id_account, :for_deposit, :id_base_doc, :is_anul, :id_hotel,
         :id_reserv_detail, :id_annul_protocol_num, :doc_date, :is_storno_doc;

  if (:is_anul = 1) then
    exception DOCUMENT_ANNUL_EXCEPTION '-352'; --'Document is already annul';

  if (exists (select D.ID_DOC
              from   DOC_HEAD D
              where  D.ID_BASE_DOC = :ID_BASE_DOC
                     and D.ID_DOC > :ID_DOC_HEAD
                     and D.IS_ANUL = 0))
  then exception DOCUMENT_ANNUL_EXCEPTION '-314';

  execute procedure SYSTEM_DATE_GET(:ID_HOTEL)
  returning_values  :system_date;

  if (:DOC_DATE < :SYSTEM_DATE) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_PREV_DATE');
  end
  /* unarchive account and set as credit account, for shecked out bookings only */
  execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:ID_ACCOUNT, 0);

  if (:ID_RESERV_DETAIL is not null) then begin
    select RD.CHECK_STATUS
    from   RESERV_DETAIL RD
    where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :check_status;

    if (:check_status = 1) then begin
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, null, 1);
    end
  end
  /* MARK THE DOCUMENT AS ANUL - before posting and payment updates */
  update DOC_HEAD$INT DH
  set    DH.IS_ANUL = 1
  where  DH.RDB$DB_KEY = :dh_dbkey;

  update DOC_COMPLETION Dc
  set    Dc.IS_EFAKTURA_EXPORTED = 0
  where  Dc.ID_DOC_HEAD = :ID_DOC_HEAD;


  if (:is_storno_doc = 1) then begin
    /* annul storno doc */
    update DOC_HEAD$INT BD
    set    BD.IS_STORNED = 0
    where  BD.ID_DOC_HEAD = :id_base_doc
           and BD.IS_STORNED = 1;
  end
  /* RELEASE ACCOUNT_POSTS */
  if (:for_deposit = 0) then
    execute procedure ACCOUNT_POSTING_DOC_UPDATE$INT (:DH_DBKEY)
    returning_values (:no_use);

  /* PAYMENTS REFLECTION */
  for
    select PH.ID_PAYMENT_HEAD
    from   PAYMENT_HEAD PH
           join DOC_TYPE_PAY dt on dt.ID_DOC_TYPE = ph.ID_DOC_TYPE
    where  PH.ID_DOC_HEAD = :ID_DOC_HEAD
           and PH.IS_STORNED = 0
    into   :ID_PAYMENT_HEAD
  do begin

    execute procedure PAYMENT_ANUL$INT (:ID_PAYMENT_HEAD, :ANUL_REASON);
  end

  /* ANNUL_PROTOCOL creating section */
  NUM = null;
  DOC_NUM = null;
  if (:MAKE_ANNUL_REPORT = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_WITH_PROT');

    if (:ID_ANNUL_PROTOCOL_NUM is null) then exception DOCUMENT_ANNUL_EXCEPTION '-345';

    execute procedure SYSTEM_GEN_NUM ('ANNUL_PROT', :ID_ANNUL_PROTOCOL_NUM)
    returning_values  (:num, :doc_num);
  end
  /* log annul event */
  execute procedure SYSTEM_EVENT_LOG$INT ('DOCUMENT', :ID_DOC_HEAD, 'ANNUL', f_character(29)||:ANUL_REASON)
  returning_values  :id_system_log;

  insert into DOC_ANNULMENT (ID_DOC_HEAD, ANNULMENT_DATE, ID_PROT_DOC_NUM, PROT_NUM, PROT_DOC_NUM, ID_LOG_EVENT)
  values (:ID_DOC_HEAD, :SYSTEM_DATE, :ID_ANNUL_PROTOCOL_NUM, :NUM, :DOC_NUM, :ID_SYSTEM_LOG);
  /* reflect annul date on doc release dates */
  if (:DOC_DATE < :SYSTEM_DATE) then begin
    insert into DOC_RELEASE_DATE (ID_DOC_HEAD, RELEASE_DATE, VALUE_CORR_INDEX)
    values (:ID_DOC_HEAD, :SYSTEM_DATE, -1);
  end else begin
    update DOC_RELEASE_DATE RD
    set    RD.VALUE_CORR_INDEX = 0
    where  RD.ID_DOC_HEAD = :ID_DOC_HEAD
           and RD.RELEASE_DATE = :DOC_DATE;
  end
  /* reflect on AR module */
  execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT (:DH_DBKEY, null, 1, :ANUL_REASON);
  /* reflect on client loyalty module */
  execute procedure DOCUMENT_BONUSPOINTS_VOID$CL (:ID_DOC_HEAD);

end
^

/* Alter (DOCUMENT_BONUSPOINTS_SPEND) */
ALTER PROCEDURE DOCUMENT_BONUSPOINTS_SPEND(ID_DOC_HEAD INTEGER,
BONUSPOINT_CNT INTEGER)
 RETURNS(DOC_REST_AMOUNT NUMERIC(15,4))
 AS
declare variable bonuspoints_avail integer;
  declare variable id_bonuspoint_scheme integer;
  declare variable consume_discount_txt varchar(100) ;
  declare variable consume_point_price numeric(15,4);
  declare variable consume_point_curr varchar(3);
  declare variable doc_curr varchar(3);
  declare variable discount_value numeric(15,4);
  declare variable round_to numeric(15,4);
  declare variable doc_rate numeric(15,6);
  declare variable bp_price_rate numeric(15,6);
  declare variable no_use varchar(255);
  declare variable consume_point_nominal integer;
begin
  delete from DOC_FOOTER DF
  where  DF.ID_DOC_HEAD = :ID_DOC_HEAD
         and df.ID_TAX is null;

  if (:BONUSPOINT_CNT <= 0) then exit;

  select D.DOC_CURRENCY, D.DOC_RATE, PB.ID_BONUSPOINT_SCHEME, c.ROUND_TO,
         cast(coalesce(P.BONUSPOINT_GAINED, 0) - coalesce(p.BONUSPOINT_CONSUMED, 0) as integer)
  from   DOC_HEAD D
         join ACCOUNT A on A.ID_ACCOUNT = d.ID_ACCOUNT
         join PROFILE P on P.ID_PROFILE = a.ID_PROFILE
         join PROFILE_BONUSPOINT_SCHEME PB on PB.ID_PROFILE = P.ID_PROFILE and PB.ID_HOTEL = a.ID_HOTEL
         join CURRS c on c.CURR = d.DOC_CURRENCY
  where  D.ID_DOC = :ID_DOC_HEAD
  into   :doc_curr, :doc_rate, :id_bonuspoint_scheme, :round_to,
         :bonuspoints_avail;

  if (:BONUSPOINT_CNT > :bonuspoints_avail) then exception DOCUMENT_EXCEPTION 'Insufficient bonus points !';

  select BS.CONSUME_DISCOUNT_TXT, BS.CONSUME_POINT_PRICE, BS.CONSUME_POINT_CURR, BS.CONSUME_POINT_NOMINAL
  from   BONUSPOINT_SCHEME BS
  where  BS.ID_BONUSPOINT_SCHEME = :id_bonuspoint_scheme
  into   :consume_discount_txt, :consume_point_price, :consume_point_curr, :consume_point_nominal;

  discount_value = -round_f(:BONUSPOINT_CNT * iif(:consume_point_nominal = 0, 0, cast(:consume_point_price / :consume_point_nominal as double precision)), :round_to);

  if (:doc_curr <> :consume_point_curr) then begin
    -- convert to document currency
    execute procedure DOCUMENT_CURR_RATE_GET$INT (:ID_DOC_HEAD, :consume_point_curr)
    returning_values (:bp_price_rate, :no_use);

    discount_value = round_f(:discount_value * cast(:bp_price_rate / :doc_rate as double precision), :round_to);
  end

  insert into DOC_FOOTER (ID_DOC_HEAD, ID_TAX, TAX_ORDER, TAXABLE_VALUE,
         ID_DOC_LINE, FOOTER_VALUE, DESCRIPTION)
  values (:ID_DOC_HEAD, null, 0, :BONUSPOINT_CNT, null, :discount_value, :consume_discount_txt);

  execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, null)
  returning_values (:no_use, :no_use, :no_use, :no_use, :DOC_REST_AMOUNT);

  if (:DOC_REST_AMOUNT < 0) then exception DOCUMENT_EXCEPTION '-380';
end
^

/* Alter (DOCUMENT_CLEAR_DEPOSITS$DOC) */
ALTER PROCEDURE DOCUMENT_CLEAR_DEPOSITS$DOC(ID_DOC_HEAD INTEGER)
 AS
declare variable is_storno_doc smallint;
begin

  execute procedure DOCUMENT_REUSE_DEPOSITS$INT (:ID_DOC_HEAD, null);

end
^

/* Alter (DOCUMENT_GET_CURR_VALUE$DOC) */
ALTER PROCEDURE DOCUMENT_GET_CURR_VALUE$DOC(ID_DOC_HEAD INTEGER,
PAY_CURR VARCHAR(3))
 RETURNS(ID_PAY_DOC_DEF INTEGER,
TOTAL_CURR VARCHAR(3),
TOTAL_RATE NUMERIC(15,6),
TOTAL_VALUE NUMERIC(15,4),
REST_VALUE NUMERIC(15,4))
 AS
begin

  execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, :PAY_CURR)
  returning_values :ID_PAY_DOC_DEF, :TOTAL_CURR, :TOTAL_RATE, :TOTAL_VALUE, :REST_VALUE;

  suspend;
end
^

/* Alter (DOCUMENT_STORNO$DOC) */
ALTER PROCEDURE DOCUMENT_STORNO$DOC(ID_DOC_HEAD INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_STORNO_DOC INTEGER,
ID_HOTEL INTEGER,
ID_ACCOUNT INTEGER)
 AS
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_STORN_WITHP');

  execute procedure DOCUMENT_STORNO$INT (:ID_DOC_HEAD, :DESCRIPTION, 1)
  returning_values  (:ID_STORNO_DOC, :ID_HOTEL);

  select D.ID_ACCOUNT
  from   DOC_HEAD D
  where  D.ID_DOC = :id_storno_doc
  into   :id_account;

  execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :ID_DOC_HEAD, 'STORNO', f_character(29)||:DESCRIPTION);

end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_POST_TO_FRONT_ONLINE for: EAI_EXT_POST_TO_MH_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_EXT_POST_TO_MH_FRONT_ONLINE) */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  if (:CODE_TYPE = 'EXT_CODE') then begin
    execute procedure EAI_MAP_SERVICE(:SERVICE_CODE, :SERVICE_CODE, 'UNKNOWN', :id_hotel)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_SERVICE;
    if (:ERR_CODE < 0) then exit;
  end else begin
    select S.ID_SERVICE
    from   SERVICES S
    where  S.ID_SERVICE = :SERVICE_CODE
           and s.ID_HOTEL = :ID_HOTEL
    into   :ID_SERVICE;
    if (:ID_SERVICE is null) then begin
      ERR_CODE = -85;   /* Wrong value! */
      exit;
    end
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Alter (EAI_EXT_SERVICE_POST) */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable max_id_service integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_ROOM  = null;
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  select min(S.ID_SERVICE) as id_service, max(s.id_service) as max_id_service
  from   SERVICES S
  where  S.EXT_CODE = :SERVICE_EXT_CODE
         and s.IS_BASE = 0
         and s.IS_DELETED = 0
  into   :ID_SERVICE, :max_id_service;
  if (:ID_SERVICE is null) then begin
      ERR_CODE = -388;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end else if (:ID_SERVICE <> :max_id_service) then begin
      ERR_CODE = -389;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_EXT_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* empty dependent procedure body */
/* Clear: EAI_POS_POSTING_ADD for: EAI_POS_POSTING_ADD$P2E */
ALTER PROCEDURE EAI_POS_POSTING_ADD(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_POS_POSTING_ADD$P2E) */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
declare variable id_service integer;
  declare variable my_post_text varchar(255);
  declare variable my_resource_text varchar(255);
  declare variable no_use integer;
  declare variable nation_curr varchar(3);
  declare variable post_short_code varchar(10);
  declare variable id_hotel integer;
begin
  /* in_on_guest = 0 (account), 1 (guest), -1 (ew)
  */
  if (:IN_ON_GUEST = 1) then begin
    select rd.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :IN_ID_GUEST
    into   :id_hotel;
  end else begin
    select a.ID_HOTEL
    from   account a
    where  a.ID_ACCOUNT = :in_id_account
    into   :id_hotel;
  end

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :nation_curr;

  if ('END_WORK' = :in_smetka_num) then begin
    post_short_code='POS_EW';
  end else begin
    post_short_code='POS';
  end

  /* FIND SERVICE */
  execute procedure EAI_MAP_SERVICE(:in_service_tag, :in_service_name, 'POS', :id_hotel)
  returning_values  :err_code, :err_text, :id_service;
  if (:err_code < 0) then exit;

  my_post_text = 'date:'|| formatdate(:in_date_smetka, 'D;dd.mm.yyyy') ||
                 ' num:'|| :in_smetka_num ||
                 ' obj:'|| :in_obj_name ||
                 ' tbl:'|| :in_table ||
                 ' site:'|| :in_site;

  my_resource_text = 'POS_ID_SMETKA:'||:in_id_smetka;
  my_post_text = substring(:my_post_text from 1 for 100);
  my_resource_text = substring(:my_resource_text from 1 for 49);

  if (:in_on_guest = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:in_id_guest, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code, '')
    returning_values  :err_code, :err_text, :out_id_account, :no_use;
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:in_id_account, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code)
    returning_values  :err_code, :err_text, :no_use;
    out_id_account = :in_id_account;
  end
end
^

/* Alter (EAI_RES_CHECK_OUT_FAST) */
ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
declare variable selection_id integer;
  declare variable is_early_check_out smallint;
  declare variable early_check_out_dep_date date;
  declare variable check_out_date date;
begin
  selection_id = gen_id(selection_gen, 1);

  update RESERV_DETAIL RD
  set RD.SELECTION_ID = :SELECTION_ID
  where RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL;

  execute procedure RES_CHECK_OUT_CHECK$RSV(:selection_id)
  returning_values :is_early_check_out, :early_check_out_dep_date, :check_out_date;

  if (:is_early_check_out = 1) then
    exception BOOKING_EXCEPTION '-1043';

  execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id, 0);
end
^

/* Alter (EAI_TELECOUNT_TRANSFER) */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* Alter (END_WORK) */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable system_date date;
  declare variable id_room integer;
  declare variable id_end_work integer;
  declare variable last_closed_date date;
  declare variable mark_dirty_expired_block varchar(10);
  declare variable mark_dirty_occ_room varchar(10);
  declare variable lock_id integer;
  declare variable shift_no integer;
  declare variable init_hotel_date date;
begin

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;
  if (:system_date >= :in_next_date) then exception END_WORK_EXCEPTION '-43';
  if (:IN_NEXT_DATE > current_date + 1) then exception END_WORK_EXCEPTION '-60';

  last_closed_date = :in_next_date - 1;

  /* LOCK THE CURRENT FINANCIAL (SYSTEM) DATE  */
  lock_id = null;
  while (:lock_id is null) do begin
    lock_id = strhash_large(:system_date || :id_hotel);
    execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'lock');
  
    when any do begin
      exception END_WORK_EXCEPTION '-337' || f_character(31) || f_character(29) || FormatDate(:system_date, 'D;dd.mm.yyyy');
    end
  end

  /* RIGHT IS REQUIRED TO CHANGE THE FINANCIAL DATE IF THERE ARE GUESTS WITH OVERDUE CHECK OUT */
  if (exists(
    select *
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
    where  G.TO_DATE <= :last_closed_date
           and G.CHECK_STATUS < 1
           and RD.ID_HOTEL = :id_hotel
           and rd.IS_ANUL = 0
  )) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('EW_OVERDUE_CHECKOUT');
  end

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', 'EW');
  -- Suppress eventual right checks into next procedures - all is permitted. Is this needed(?!?)

  update ACCOUNT_POST AP
  set    ap.ROOM_NAME = (select R.ROOM_NAME
                         from   GUEST G
                                join ROOMS R on R.ID_ROOM = G.ID_ROOM
                         where  G.ID_GUEST = ap.ID_GUEST)
  where  ap.DATE_POST between :system_date and :last_closed_date
         and ap.ID_GUEST > 0;

  select coalesce(max(ew.SHIFT_NO), 0) + 1
  from   END_WORKS ew
  where  ew.PREV_DATE = :system_date
  into   :shift_no;

  id_end_work = gen_id(G_AUTO_INC_END_WORKS, 1);
  insert into END_WORKS (ID_END_WORK, PREV_DATE, NEXT_DATE, END_WORK_KIND, SHIFT_NO, ID_HOTEL)
  values (:id_end_work, :system_date, :in_next_date, 3, :shift_no, :id_hotel);

  /* CHANGE SYSTEM DATE */
  execute procedure SYSTEM_DATE_SET(:id_hotel, :in_next_date);

  /* AUTO EXPIRATION OF ROOM NUMBERS, ROOMS AND BOOKING POSITIONS */
  execute procedure RESERVS_EXPIRE$INT(:last_closed_date, :id_hotel);

  execute procedure AGENT_CONTINGENT_EXPIRE(:system_date, :last_closed_date, null, 0, 1, :id_hotel);

  /* DELETE PERSON PROFILES WITH EXPIRATION DATE */
  execute procedure PROFILE_PERSON_EXPIRE (:in_next_date);

  execute procedure SETTING_GET_VALUE('MARK_DIRTY_EXPIRED_BLOCK', :ID_HOTEL)
  returning_values  :mark_dirty_expired_block;
  if (:mark_dirty_expired_block = '1') then begin
    for
      select distinct BR.ID_ROOM
      from   BLOCK_ROOM BR
             join ROOMS R on R.ID_ROOM = BR.ID_ROOM
      where  R.ID_HOTEL = :id_hotel
             and BR.TO_DATE >= :system_date
             and BR.TO_DATE < :in_next_date
             and BR.IS_ANNUL = 0
         into :id_room
    do begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'BLOCK_EXP', 'set_dirty');

      when any do post_event 'dummy';  -- nothing
    end
  end

  execute procedure SETTING_GET_VALUE('MARK_DIRTY_OCC_ROOM', :ID_HOTEL)
  returning_values  :mark_dirty_occ_room;
  if (:mark_dirty_occ_room = '1') then begin
    for
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
             join ROOMS R on R.ID_ROOM = rm.ID_ROOM
      where  R.ID_HOTEL = :id_hotel
             and RM.BUSY_DATE = :system_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and RM.BUSY_GROUP_TYPE = 24
      into   :id_room
    do begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'EW_DAY', 'set_dirty');

      when any do post_event 'dummy';  -- nothing
    end
  end

  /* Summary data prepare */
  if (:in_next_date > :system_date) then begin
    execute procedure SUMMARY_FINANCE_SAVE$INT (:id_end_work);

    select min(e.PREV_DATE)
    from   END_WORKS E
    where  E.ID_HOTEL = :ID_HOTEL
    into   :init_hotel_date;

    execute procedure SUMMARY_PREPARE$INT(:id_hotel, :init_hotel_date, :last_closed_date); --TODO precise the period

    execute procedure SUMMARY_FORECAST$INT(:ID_HOTEL, :system_date);
  end

  /* Delete data from temporal tables */
  delete from RESERV_ERROR;
  delete from TMP_SMALL_OCCUP;
--  delete from GUEST g where g.id_reserv_detail is null; pri regenerirane na statistikata ne vurshi rabota
  /*  */

  execute procedure CACHES_RESOLVE;

  execute procedure SYSTEM_LOG_ADD('SYSTEM', :id_end_work, 'DAY_EW', f_character(29) || :last_closed_date);

  execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'release');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', null);

  post_event 'invalidate.end_work';
end
^

/* Alter (EXPORT_DOCUMENT) */
ALTER PROCEDURE EXPORT_DOCUMENT(FROM_DATE DATE,
TO_DATE DATE,
DOC_TAG VARCHAR(20),
PAY_TAG VARCHAR(20),
NO_PAY_DOCS VARCHAR(20),
GROUP_TAG VARCHAR(20),
ID_HOTEL INTEGER = null,
RETURN_CLIENT_PERSON_ID SMALLINT = 0)
 RETURNS(DOC_TYPE_ID INTEGER,
DOC_SUB_TYPE SMALLINT,
DOC_TYPE_NAME VARCHAR(50),
DOC_DATE DATE,
DOC_FOR_DEPOSIT SMALLINT,
TAX_EVENT_DATE DATE,
DIFF_VAT_REASON VARCHAR(254),
DOC_NUM VARCHAR(20),
DOC_CURRENCY CHAR(3),
DOC_RATE NUMERIC(15,4),
DOC_IS_STORNED SMALLINT,
DOC_IS_STORNO SMALLINT,
DOC_ID_BASE_DOC INTEGER,
DOC_EXPORT_TAG VARCHAR(20),
DOC_SEND_NAME VARCHAR(100),
DOC_DOGOVOR_NUM VARCHAR(30),
DOC_NOTE VARCHAR(100),
DOC_SUPPLIER_ID INTEGER,
CLT_ID INTEGER,
CLT_NAME VARCHAR(100),
CLT_VAT_REG_NUM VARCHAR(30),
CLT_IDENT_NO VARCHAR(30),
CLT_MOL VARCHAR(50),
CLT_ADDRESS VARCHAR(100),
CLT_COUNTRY_CODE VARCHAR(10),
CLT_ZIP_CODE VARCHAR(10),
CLT_RECIEVE_NAME VARCHAR(100),
PAY_TYPE_ID INTEGER,
PAY_TYPE VARCHAR(20),
PAY_CURRENCY CHAR(3),
PAY_VALUE NUMERIC(15,4),
PAY_RATE NUMERIC(15,6),
PAY_CC_NAME VARCHAR(50),
PAY_CC_NUM VARCHAR(50),
PAY_CC_BANK VARCHAR(50),
PAY_EXPORT_TAG VARCHAR(20),
LINE_ID INTEGER,
LINE_NAME VARCHAR(50),
LINE_WOT_VAT NUMERIC(15,4),
LINE_VAT_FREE NUMERIC(15,4),
LINE_VAT_BASE NUMERIC(15,4),
LINE_VAT NUMERIC(15,4),
VAT_VALUE NUMERIC(15,4),
ID_VAT_GROUP INTEGER,
ID_SALE_TAXATION INTEGER,
LINE_QTY NUMERIC(15,4),
ACC_NO VARCHAR(30),
POSITION_NO INTEGER)
 AS
declare variable id_doc_head integer;
  declare variable doc_grand_total numeric(15,4);
  declare variable pay_coeficient double precision;
  declare variable value_corr_idx numeric(15,2);
  declare variable doc_total numeric(15,2);
  declare variable doc_rate_int numeric(15,4);
  declare variable curr_sel varchar(10);
  declare variable delim_pos integer;
begin
  /*  Description:
  ||
  */

  POSITION_NO = 1;
  delim_pos = strpos(';', :GROUP_TAG);
  if (:delim_pos > 0) then begin
    curr_sel = substring(:GROUP_TAG from :delim_pos + 1 for char_length(:group_tag) - :delim_pos);
    GROUP_TAG = substring(:GROUP_TAG from 1 for :delim_pos - 1);
  end

  for
    select DH.ID_DOC, DH.DOC_TYPE_NAME, DH.REAL_DOC_DATE, DH.DOC_NUM,
           coalesce(DD.ID_CONTRAGENT, iif(:RETURN_CLIENT_PERSON_ID = 1, 1000000000 + a.ID_PROFILE, null)),
           DH.ID_DOC_TYPE, DH.DOC_RATE, DD.CONTRAGENT_NAME, DD.VAT_REG_NUM, DD.IDENT_NO,
           DD.MOL, DD.POST_ADDRESS, DD.COUNTRY_CODE, DD.ZIP_CODE,
           DS.SEND_NAME, DD.RECIPIENT_NAME, DH.DESCRIPTION, DD.NUM_DOGOVOR,
           DH.DOC_VALUE_A, DH.DOC_CURRENCY, DH.ID_BASE_DOC,
           DH.IS_STORNED, DH.IS_STORNO,
           case when D.DOC_SUB_TYPE = 2 then DI.CREDIT_EXPORT_TAG
                when D.DOC_SUB_TYPE = 1 then DI.DEBIT_EXPORT_TAG
                else DT.EXPORT_TAG
           end as EXPORT_TAG, DH.TAX_EVENT_DATE, DH.DIFF_VAT_REASON,
           DH.FOR_DEPOSIT,
           iif(dh.ANNULMENT_DATE between :from_date and :to_date /*and dh.VALUE_CORR_IDX = 1*/, 0, DH.VALUE_CORR_IDX) as VALUE_CORR_IDX,
           D.DOC_SUB_TYPE, DS.ID_DOC_SUPPLIER, DH.DOC_VALUE_A
    from   DOCUMENT_RELEASE DH
           join DOC_CONTRAGENT DD on DD.ID_DOC_CONTRAGENT = DH.ID_DOC_CONTRAGENT
           join DOC_SUPPLIER DS on DS.ID_DOC_SUPPLIER = DH.ID_DOC_SUPPLIER
           join DOC_TYPE DT on DT.ID_DOC_TYPE = DH.ID_DOC_TYPE
           join DOC_TYPE_INV DI on DI.ID_DOC_TYPE = DT.ID_DOC_TYPE
           join DOC_HEAD D on D.ID_DOC = DH.ID_DOC
           join ACCOUNT A on A.ID_ACCOUNT = DH.ID_ACCOUNT
    where  DH.RPT_DOC_DATE between :from_date and :to_date
           and ((upper(:doc_tag) = 'ALL') or (coalesce(DI.ANNUL_EXPORT_TAG, DT.EXPORT_TAG) = :doc_tag))
           --and DH.IS_ANNUL_ON_DATE = 0
           and ((:ID_HOTEL is null) or (A.ID_HOTEL = :ID_HOTEL))
           and not (dh.REAL_DOC_DATE between :from_date and :to_date
                    and dh.ANNULMENT_DATE between :from_date and :to_date
                    and dh.VALUE_CORR_IDX = -1)  -- skip annul records into same period
    into   :id_doc_head, :doc_type_name, :doc_date, :doc_num, :clt_id,
           :doc_type_id, :doc_rate, :clt_name, :clt_vat_reg_num, :clt_ident_no,
           :clt_mol, :clt_address, :clt_country_code, :clt_zip_code,
           :doc_send_name, :clt_recieve_name, :doc_note, :doc_dogovor_num,
           :doc_grand_total, :doc_currency, :doc_id_base_doc,
           :doc_is_storned, :doc_is_storno, :doc_export_tag, :tax_event_date, :diff_vat_reason,
           :DOC_FOR_DEPOSIT, :value_corr_idx, :doc_sub_type, :doc_supplier_id, :doc_total
  do begin
    if (:curr_sel = 'ORIG') then doc_rate_int = 1; else doc_rate_int = :DOC_RATE;
    /****************************************/
    if (upper(:group_tag) = 'DOC_TOTAL') then begin
      line_vat_free = null;
      line_vat_base = null;
      line_vat = null;
      doc_total = null;

      select sum(dt.NONTAXABLE_VALUE), sum(dt.TAXABLE_VALUE), sum(dt.TAX_VALUE), min(dt.ID_SALE_TAX)
      from   DOC_TAXES DT
      where  DT.ID_DOC_HEAD = :id_doc_head
      into   :LINE_VAT_FREE, :LINE_VAT_BASE, :LINE_VAT, :ID_VAT_GROUP;
      line_vat_free = coalesce(:line_vat_free, 0) * :value_corr_idx;
      line_vat_base = coalesce(:line_vat_base, 0) * :value_corr_idx;
      line_vat = coalesce(:line_vat, 0) * :value_corr_idx;
      doc_total = coalesce(:doc_total, 0)* :value_corr_idx;

      select st.TAX_PERCENT
      from   SALE_TAXES ST
      where  ST.ID_SALE_TAX = :ID_VAT_GROUP
      into   :VAT_VALUE;
       
      LINE_WOT_VAT = (:LINE_VAT_BASE + :LINE_VAT_FREE) * :value_corr_idx; /*:doc_total - :LINE_VAT;*/
      LINE_ID = :id_doc_head;
      LINE_NAME = '';
      LINE_QTY = 1;
      ACC_NO = '';

      select   first 1 EDP.PAY_TYPE_ID, EDP.PAY_TYPE, EDP.PAY_CURRENCY, EDP.PAY_RATE, EDP.PAY_VALUE,
               EDP.PAY_CC_NUM, EDP.PAY_CC_NAME, EDP.PAY_CC_BANK, EDP.PAY_COEFICIENT, EDP.EXPORT_TAG
      from     EXPORT_DOCUMENT_PAYMENT(:id_doc_head, :pay_tag, :no_pay_docs, :doc_currency,
                                       :doc_id_base_doc, :doc_grand_total) EDP
      into     :pay_type_id, :pay_type, :pay_currency, :pay_rate, :pay_value,
               :pay_cc_num, :pay_cc_name, :pay_cc_bank, :pay_coeficient, :pay_export_tag;

      PAY_VALUE = :PAY_VALUE * :value_corr_idx;
      suspend;
      POSITION_NO = :POSITION_NO + 1;
    end else if (upper(:group_tag) = 'TAXES') then begin
      ID_SALE_TAXATION = null;
      POSITION_NO = 1;
      for
        select dt.TAX_NAME, 1, dt.ID_SALE_TAX,
               (dt.TAXABLE_VALUE + dt.NONTAXABLE_VALUE) * :value_corr_idx,
               dt.NONTAXABLE_VALUE * :value_corr_idx,
               dt.TAXABLE_VALUE * :value_corr_idx,
               dt.TAX_VALUE * :value_corr_idx,
               dt.TAX_PERCENT, st.ACCOUNT_NAME, dt.ID_SALE_TAX
        from   DOC_TAXES dt
               join SALE_TAXES st on st.ID_SALE_TAX = dt.ID_SALE_TAX
        where  dt.ID_DOC_HEAD = :ID_DOC_HEAD
        into   :line_name, :line_qty, :LINE_ID, :line_wot_vat, :line_vat_free, :line_vat_base,
               :line_vat, :vat_value, :acc_no, :id_vat_group
      do begin
      
        suspend;
        POSITION_NO = :POSITION_NO + 1;
      end 
    end else begin
      LINE_VAT_BASE = null;
      LINE_VAT_FREE = null;
      ID_VAT_GROUP = null;
      for
        select   EDP.PAY_TYPE_ID, EDP.PAY_TYPE, EDP.PAY_CURRENCY, EDP.PAY_RATE, EDP.PAY_VALUE,
                 EDP.PAY_CC_NUM, EDP.PAY_CC_NAME, EDP.PAY_CC_BANK, EDP.PAY_COEFICIENT, EDP.EXPORT_TAG
        from     EXPORT_DOCUMENT_PAYMENT(:id_doc_head, :pay_tag, :no_pay_docs, :doc_currency,
                                         :doc_id_base_doc, :doc_grand_total) EDP
        into     :pay_type_id, :pay_type, :pay_currency, :pay_rate, :pay_value,
                 :pay_cc_num, :pay_cc_name, :pay_cc_bank, :pay_coeficient, :pay_export_tag
      do begin
        PAY_VALUE = :PAY_VALUE * :value_corr_idx;
        for
          select EDL.LINE_ID, EDL.LINE_NAME, EDL.LINE_WOT_TAX, EDL.LINE_TAX, EDL.LINE_QTY,
                 EDL.ACC_NO, EDL.TAX_PERCENT, EDL.POSITION_NO, EDL.ID_SALE_TAXATION
          from   EXPORT_DOCUMENT_LINES(:id_doc_head, :group_tag, :pay_coeficient, :doc_rate_int) EDL
          into   :line_id, :line_name, :line_wot_vat, :line_vat, :line_qty,
                 :acc_no, :vat_value, :POSITION_NO, :ID_SALE_TAXATION
        do begin
          LINE_WOT_VAT = :LINE_WOT_VAT * :value_corr_idx;
          LINE_VAT = :LINE_VAT * :value_corr_idx;
          select min(st.ID_SALE_TAX)
          from   SALE_TAXATION_TAX ST
                 join SALE_TAXES t on t.ID_SALE_TAX = st.ID_SALE_TAX
          where  ST.ID_SALE_TAXATION = :ID_SALE_TAXATION
                 and t.REVENUE_DEDUCTION_TAX is distinct from 1
          having count(st.ID_SALE_TAX) = 1
          into   :ID_VAT_GROUP;

          suspend;
        end
      end
    end
  end
end
^

/* Alter (GUEST_ACCOUNT_TRANSFER$INT) */
ALTER PROCEDURE GUEST_ACCOUNT_TRANSFER$INT(ID_GUEST INTEGER,
ID_SOURCE_ACCOUNT INTEGER,
ID_TARGET_ACCOUNT INTEGER,
SERVICE_TYPE VARCHAR(20))
 AS
declare variable dbkey char(8);
begin

  if (:service_type = 'BASE') then begin
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.ID_ACCOUNT = :id_source_account
             and AP.AC = '00'
             and AP.ID_BASE_DOC is null
             and ((AP.IS_BASE = 1) or (AP.ID_MASTER_ADDINS_ACC_POST <> -1))
      into   :dbkey
    do
      execute procedure ACCOUNT_POSTING_TRANSFER$INT(:dbkey, :id_target_account);

  end else begin
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.ID_ACCOUNT = :id_source_account
             and AP.AC = '00'
             and AP.ID_BASE_DOC is null
             and ((AP.IS_BASE = 0) and (AP.ID_MASTER_ADDINS_ACC_POST = -1))
      into   :dbkey
    do
      execute procedure ACCOUNT_POSTING_TRANSFER$INT(:dbkey, :id_target_account);

  end
end
^

/* empty dependent procedure body */
/* Clear: GUEST_ADDRESSCARD_SET$RSV for: GUEST_ADDRESSCARD_SET$INT */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$RSV(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
EGN VARCHAR(30),
COUNTRY VARCHAR(10),
ID_STAY_REASON INTEGER,
IS_REGISTRED INTEGER,
PASS_PLACE VARCHAR(20),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_PLACE VARCHAR(30),
SEX CHAR,
MASK VARCHAR(10),
IS_CHILD INTEGER,
CAR VARCHAR(30),
KPP INTEGER,
KPP_DATE DATE,
PASS_EXP_DATE DATE,
AGE INTEGER,
BIRTH_DAY DATE,
VISA /* TDESCRIPTION_SHORT */ VARCHAR(100),
RATING_AGE INTEGER = null,
TITLE VARCHAR(10) = null,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_ADD$INT for: GUEST_ADDRESSCARD_SET$INT */
ALTER PROCEDURE RES_GUEST_ADD$INT(RD_DBKEY CHAR(8),
IS_CHILD INTEGER)
 RETURNS(NEW_ID_GUEST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_SAVE$RSV for: GUEST_ADDRESSCARD_SET$INT */
ALTER PROCEDURE RES_GUEST_SAVE$RSV(ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
GUEST_NAME1 VARCHAR(100),
AGE INTEGER,
BIRTH_DAY DATE,
IS_CHILD INTEGER,
COUNTRY_CODE VARCHAR(10) = NULL)
 RETURNS(NEW_ID_GUEST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (GUEST_ADDRESSCARD_SET$INT) */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$INT(PD_DBKEY CHAR(8),
G_DBKEY CHAR(8),
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
COUNTRY_CODE VARCHAR(10),
IS_CHILD INTEGER,
AGE INTEGER,
BIRTH_DAY DATE,
TITLE VARCHAR(10))
 AS
declare variable rd_dbkey char(8);
  declare variable old_is_child integer;
  declare variable old_birthday date;
  declare variable p_dbkey char(8);
  declare variable old_country_code varchar(10);
  declare variable from_date date;
  declare variable birthday_internal date;
begin

  select G.IS_CHILD, coalesce(:is_child, G.IS_CHILD), RD.RDB$DB_KEY, G.FROM_DATE
  from   GUEST G
         left join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
  where  G.RDB$DB_KEY = :g_dbkey
  into   :old_is_child, :is_child, :rd_dbkey, :from_date;

  select PD.COUNTRY_CODE, PD.BIRTH_DAY, P.RDB$DB_KEY
  from   PERSON_DATA PD
         left outer join PROFILE_PERSON PP on PP.ID_PERSON_DATA = PD.ID_PERSON_DATA
         left outer join PROFILE P on P.ID_PROFILE = PP.ID_PROFILE
  where  PD.RDB$DB_KEY = :pd_dbkey
  into   :old_country_code, :old_birthday, :p_dbkey;

  country_code = coalesce(:country_code, '');

  execute procedure sys_dbg('res GUEST_ADDRESSCARD_SET$INT birth_day = '||coalesce(:birth_day, 'null'));
  execute procedure sys_dbg('res GUEST_ADDRESSCARD_SET$INT old_birthday = '||coalesce(:old_birthday, 'null'));
  execute procedure sys_dbg('res GUEST_ADDRESSCARD_SET$INT age = '||coalesce(:age, 'null'));

  execute procedure GUEST_BIRTHDAY$INT(:birth_day, :age, :old_birthday, :from_date)
  returning_values  :birthday_internal, :birth_day;

  execute procedure PERSON_DATA_SET$INT(:p_dbkey, :pd_dbkey, :guest_name1, :guest_name2,
          :country_code, :birth_day, :birthday_internal, :TITLE);

  if (:old_is_child <> :is_child) then begin
    --TODO rename guests with auto names to reflect the new is_child status
    update RESERV_DETAIL RD
    set    RD.ADULT_COUNT = RD.ADULT_COUNT + (2*:old_is_child - 1),
           RD.CHILD_COUNT = RD.CHILD_COUNT - (2*:old_is_child - 1)
    where  RD.RDB$DB_KEY = :rd_dbkey;

    update GUEST G
    set    G.IS_CHILD = :is_child
    where  G.RDB$DB_KEY = :g_dbkey;
  end

  if (:old_country_code is distinct from :country_code) then begin
    update RESERV_DETAIL RD
    set    RD.COUNTRY = :country_code
    where  RD.RDB$DB_KEY = :rd_dbkey;
  end
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_GUEST$EXC for: GUEST_ADDRESSCARD_SET$RSV */
ALTER PROCEDURE IMPORT_GUEST$EXC(BOOKING_ID INTEGER,
PROFILE_UUID VARCHAR(40),
GUEST_UUID VARCHAR(40),
GUEST_NAME VARCHAR(100),
IS_CHILD SMALLINT,
AGE INTEGER,
IS_DIFFERENT_ARRANGER SMALLINT,
ARRIVAL DATE,
DEPARTURE DATE,
VOUCHER VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
RATING_AGE INTEGER,
KPP VARCHAR(50),
KPP_DATE DATE,
STAY_REASON VARCHAR(255),
CAR VARCHAR(30),
IS_REGISTRED SMALLINT,
PERSONAL_NUMBER VARCHAR(30),
TITLE VARCHAR(10),
PT_NAME VARCHAR(100),
PT_EXTCODE VARCHAR(50),
PASS_NUM VARCHAR(20),
PASS_PLACE VARCHAR(20),
PASS_DATE DATE,
PASS_EXP_DATE DATE,
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_DATE DATE,
SEX CHAR,
BIRTH_PLACE VARCHAR(30),
MASK VARCHAR(10),
PACKAGE VARCHAR(255),
VISA /* TDESCRIPTION_SHORT */ VARCHAR(100))
 RETURNS(GUEST_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (GUEST_ADDRESSCARD_SET$RSV) */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$RSV(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
EGN VARCHAR(30),
COUNTRY VARCHAR(10),
ID_STAY_REASON INTEGER,
IS_REGISTRED INTEGER,
PASS_PLACE VARCHAR(20),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_PLACE VARCHAR(30),
SEX CHAR,
MASK VARCHAR(10),
IS_CHILD INTEGER,
CAR VARCHAR(30),
KPP INTEGER,
KPP_DATE DATE,
PASS_EXP_DATE DATE,
AGE INTEGER,
BIRTH_DAY DATE,
VISA TDESCRIPTION_SHORT,
RATING_AGE INTEGER = null,
TITLE VARCHAR(10) = null,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable gd_dbkey char(8);
  declare variable pd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable rd_dbkey char(8);
  declare variable old_is_registred integer;
  declare variable old_guest_name1 varchar(250);
  declare variable old_guest_name2 varchar(250);
  declare variable old_id_pass_type integer;
  declare variable old_pass_num varchar(20);
  declare variable old_pass_date date;
  declare variable old_egn varchar(30);
  declare variable old_country varchar(20);
  declare variable old_id_stay_reason integer;
  declare variable old_kpp integer;
  declare variable old_kpp_date date;
  declare variable old_pass_exp_date date;
  declare variable old_birth_day date;
  declare variable old_pass_place varchar(20);
  declare variable old_city varchar(100);
  declare variable old_address varchar(100);
  declare variable old_visa TDESCRIPTION_SHORT;
  declare variable old_birth_place varchar(30);
  declare variable old_sex char(1);
  declare variable action_text varchar(250);
  declare variable tt_reg_number integer;
  declare variable id_hotel integer;
  declare variable id_tt_numerator integer;
  declare variable domestic_nation varchar(10);
  declare variable no_use varchar(255);
  declare variable is_anul smallint;
  declare variable acc_routing varchar(20);
begin
  err_code = 0;
  err_text = '';

  select G.RDB$DB_KEY, GD.RDB$DB_KEY, PD.RDB$DB_KEY,
         GD.IS_REGISTRED, PD.PERSON_NAME, PD.PERSON_NAME2, PD.ID_PASSPORT_TYPE, PD.PASS_NUM, PD.PASS_DATE,
         PD.EGN, PD.COUNTRY_CODE, GD.ID_STAY_REASON, GD.KPP, GD.KPP_DATE, PD.PASS_EXP_DATE,
         PD.BIRTH_DAY, PD.PASS_PLACE, PD.CITY, PD.ADDRESS, PD.BIRTH_PLACE, PD.SEX, rd.RDB$DB_KEY,
         g.TT_REG_NUMBER, rd.ID_HOTEL, rd.IS_ANUL, rd.ACC_ROUTING, GD.VISA
  from   GUEST G
         join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
         join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
         join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
  where  G.ID_GUEST = :id_guest
  into   :g_dbkey, :gd_dbkey, :pd_dbkey,
         :old_is_registred, :old_guest_name1, :old_guest_name2, :old_id_pass_type, :old_pass_num, :old_pass_date,
         :old_egn, :old_country, :old_id_stay_reason, :old_kpp, :old_kpp_date, :old_pass_exp_date,
         :old_birth_day, :old_pass_place, :old_city, :old_address, :old_birth_place, :old_sex, :rd_dbkey,
         :tt_reg_number, :id_hotel, :is_anul, :acc_routing, :old_visa;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, :birth_place, :egn, :id_passport_type, :pass_num, :pass_date, :pass_place,
          :pass_exp_date, :city, :address, :sex, :mask);

  update  GUEST_DATA GD
  set     GD.KPP_DATE = :kpp_date,
          GD.KPP = :kpp,
          GD.VISA = :visa,
          GD.ID_STAY_REASON = :id_stay_reason,
          GD.IS_REGISTRED = :is_registred,
          GD.USER_REGISTRED = iif(:IS_REGISTRED = 1, coalesce(GD.USER_REGISTRED, current_user), null),
          GD.CAR = :car,
          GD.RATING_AGE = :RATING_AGE
  where   GD.RDB$DB_KEY = :gd_dbkey;

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name1, :guest_name2, :country,
          :is_child, :age, :birth_day, :TITLE);

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -1);

  /*  */
  if (:IS_REGISTRED = 1 and :tt_reg_number is null and :is_anul = 0 and :acc_routing is distinct from 'OWNER') then begin
    execute procedure SETTING_GET_VALUE ('NATIVE_NATION', :id_hotel)
    returning_values :domestic_nation;

    select iif(:COUNTRY not in (:domestic_nation, '') and h.USE_DIFFERENT_TT_NUMERATORS = 1,
               h.ID_TT_NUMERATOR_2,
               h.ID_TT_NUMERATOR_1)
    from   HOTEL H
    where  h.ID_HOTEL = :id_hotel
    into   :id_tt_numerator;

    if (:id_tt_numerator is not null) then begin
      execute procedure SYSTEM_GEN_NUM('GUEST_NUM', :id_tt_numerator)
      returning_values :tt_reg_number, :no_use;
  
      update GUEST G
      set    g.TT_REG_NUMBER = :tt_reg_number
      where  G.RDB$DB_KEY = :g_dbkey;
    end
  end else if (:IS_REGISTRED is distinct from 1 and :tt_reg_number is not null) then begin
    update GUEST G
    set    g.TT_REG_NUMBER = null
    where  G.RDB$DB_KEY = :g_dbkey;
  end
  /*  */
  if ((:old_is_registred = 0) and (:is_registred = 1)) then begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'REGISTRED', '');
  end

  if ((:old_is_registred = 1) and (:old_guest_name1 <> :guest_name1)) then begin
    action_text = f_character(29)||:old_guest_name1||f_character(28)||:guest_name1;
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'CHANGE_CARD', :action_text);
  end

  if ((:old_IS_REGISTRED = 1)
      and
      ((:old_guest_name1 <> :guest_name1)
        or (:old_guest_name2 <> :guest_name2)
        or (:old_egn <> :egn)
        or (:old_id_pass_type <> :id_passport_type)
        or (:old_pass_num <> :pass_num)
        or (:old_pass_date <> :pass_date)
        or (:old_pass_exp_date <> :pass_exp_date)
        or (:old_pass_place <> :pass_place)
        or (:old_country <> :country)
        or (:old_city <> :city)
        or (:old_address <> :address)
        or (:old_visa <> :visa)
        or (:old_birth_day <> :birth_day)
        or (:old_birth_place <> :birth_place)
        or (:old_sex  <> :sex)
        or (:old_kpp <> :kpp)
        or (coalesce(:old_id_stay_reason,0) <> coalesce(:id_stay_reason,0))
        or (:old_kpp_date <> :kpp_date)
      )) then
  begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'PREREGISTRED', '');
  end

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
    returning_values  :warn_code;

  end

end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTS$INT for: GUEST_REROUTE_POSTINGS$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTS$INT(RD_DBKEY CHAR(8))
 AS
 BEGIN EXIT; END
^

/* Alter (GUEST_REROUTE_POSTINGS$INT) */
ALTER PROCEDURE GUEST_REROUTE_POSTINGS$INT(ID_GUEST INTEGER,
ID_BASE_ACCOUNT INTEGER,
ID_EXTRA_ACCOUNT INTEGER)
 AS
declare variable ap_dbkey char(8);
  declare variable is_packet_post integer;
  declare variable packet_option varchar(50);
  declare variable id_target_account integer;
  declare variable id_current_account integer;
begin
  for
    select AP.RDB$DB_KEY, iif(AP.ID_MASTER_ADDINS_ACC_POST > 0, 1, 0), S.VAUCHER_PACKET,
           ap.ID_ACCOUNT
    from   ACCOUNT_POST AP
           join SERVICES S on S.ID_SERVICE = AP.ID_SERVICE
    where  AP.ID_GUEST = :id_guest
           and AP.AC = '00'
           and AP.ID_BASE_DOC is null
    into   :ap_dbkey, :is_packet_post, :packet_option, :id_current_account
  do begin
    if ((:is_packet_post = 1) and (:packet_option <> 'NONE')) then id_target_account = :id_base_account;
    else id_target_account = :id_extra_account;

    if (:id_current_account <> :id_target_account) then begin
      execute procedure ACCOUNT_POSTING_TRANSFER$INT(:ap_dbkey, :id_target_account);
    end
  end

end
^

/* empty dependent procedure body */
/* Clear: CREATE_BOOKING$WBE for: IMPORT_BOOKING$EXC */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TEST_BOOKING_IMPORT for: IMPORT_BOOKING$EXC */
ALTER PROCEDURE TEST_BOOKING_IMPORT AS
 BEGIN EXIT; END
^

/* Alter (IMPORT_BOOKING$EXC) */
ALTER PROCEDURE IMPORT_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(250),
MAINTANCE_SHEMA VARCHAR(30),
POSTING_ROUTING VARCHAR(20),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
COMPLIMENTARY_ACCOUNT VARCHAR(50),
EATING_OBJECT VARCHAR(50),
CREATE_DATETIME TIMESTAMP)
 RETURNS(HOTEL_ID INTEGER,
BOOKING_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable current_hotel_id integer;
declare variable booking_update_id integer;
declare variable warn_code integer;
declare variable share_transaction_id integer;
declare variable share_err_code integer;
declare variable arranger_profile_id integer;
declare variable main_guest_profile_id integer;
declare variable rate_id integer;
declare variable room_type_id integer;
declare variable board_id integer;
declare variable maintance_shema_id integer;
declare variable arranger_payment_type_id integer;
declare variable guest_payment_type_id integer;
declare variable marketing_segment_id integer;
declare variable marketing_source_code_id integer;
declare variable marketing_channel_code_id integer;
declare variable marketing_hear_reason_id integer;
declare variable marketing_come_reason_id integer;
declare variable arranger_account_id integer;
declare variable packet_id integer;
declare variable id_guarantee_policy integer;
declare variable first_food_code tfood_code;
declare variable arrival_type_code smallint;
declare variable booking_dbkey char(8);
declare variable reserv_group_id integer;
declare variable id_complimentary_account integer;
declare variable id_eating_object integer;
begin
  /*execute procedure sys_dbg('exc IMPORT_BOOKING$EXC('
  || 'hotel => ' || coalesce(:hotel, '<null>')
  || ', booking_number => ' || coalesce(:number, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  ||')');
  */
  execute procedure import_mark_transaction$exc;

  /* init */
  err_code = 0;
  err_text = '';
  booking_update_id = null;
  booking_dbkey = null;
  current_hotel_id = null;
  if (:voucher_date is not null) then begin
    voucher_date = striptime(:voucher_date);
  end
  posting_routing = upper(:posting_routing);

  /* detect inser/update mode */
  select b.id_reserv_detail, b.rdb$db_key, b.id_hotel
  from   reserv_detail b
  where  b.number=:number
         and b.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and b.id_log_event_annul is null
  into   :booking_update_id, :booking_dbkey, :current_hotel_id;

  if (:booking_update_id is null) then begin
    booking_id = gen_id (id_reserv_detail_gen, 1);
  end else begin
    booking_id = :booking_update_id;
  end

  /* text to id map */
  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => MAP_BOOKING_RELATIONS$EXC');
  execute procedure MAP_BOOKING_RELATIONS$EXC(
    :booking_id,
    :hotel,
    :room_type,
    :board,
    :maintance_shema,
    :rate,
    :arranger_payment_type,
    :guest_payment_type,
    :marketing_segment,
    :marketing_source_code,
    :marketing_channel_code,
    :marketing_hear_reason,
    :marketing_come_reason,
    :first_food,
    :arranger_profile_uuid,
    :arranger_profile_name,
    :main_guest_profile_uuid,
    :arrival_type,
    :guarantee_policy,
    :eating_object
  ) returning_values
    :arranger_profile_id,
    :main_guest_profile_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :hotel_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :first_food_code,
    :arrival_type_code,
    :id_guarantee_policy,
    :id_eating_object;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* hotel change test */
  if (coalesce(:current_hotel_id, :hotel_id) <> :hotel_id) then begin
    execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', null, :hotel, 'booking hotel changed');
  end

  id_complimentary_account = null;
  if (complimentary_account is not null) then begin
    execute procedure lookup_account$exc(:hotel_id, :complimentary_account, 'booking', :booking_id)
    returning_values :id_complimentary_account;
  end

  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => CREATE_PACK_INSTANCE$EXC');
  packet_id = null;
  /*execute procedure CREATE_PACK_INSTANCE$EXC(
    :hotel_id, :booking_id, :package
  )
  returning_values :packet_id, :err_code, :err_text;
  if (0 <> :err_code) then exit;
  */
  /* merge input and default/persistent database values */
  execute procedure DEFAULT_BOOKING_VALUES$EXC(
    :booking_dbkey, :hotel_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :group_name,
    :group_uuid,
    :is_late_departure,
    :id_eating_object
  ) returning_values
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :arranger_account_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :reserv_group_id,
    :is_late_departure,
    :id_eating_object;

  if ('' = :board) then board_id = null; /* preserve "empty board" state and discard default value */

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC DEFAULTED => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* if the booking is complimentary use complimentary account */
  arranger_account_id = coalesce(:id_complimentary_account, :arranger_account_id);

  /* CREATE or UPDATE */
  if (:booking_update_id is not null) then begin
    /* UPDATE booking */
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => UPDATE_BOOKING$EXC');
    execute procedure UPDATE_BOOKING$EXC(
      :booking_id,
      :reserv_group_id,
      :is_vip,
      :arrival,
      :arrival_type_code,
      :departure,
      :is_late_departure,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :room_type_id,
      :board_id,
      :room_preferences,
      :special_treatment,
      :maintance_shema_id,
      :posting_routing,
      :arranger_account_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :deposit_required,
      :deposit_required_currency,
      :arranger_payment_type_id,
      :guest_payment_type_id,
      :voucher,
      :voucher_date,
      :voucher_text,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :note,
      :note_reminders,
      :first_food_code,
      :arranger_profile_id,
      :main_guest_profile_id,
      :is_different_rate,
      :is_different_price,
      :split_on_checkin,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object
    ) returning_values :err_code, :err_text;
    if (0 <> :err_code) then begin
      exit;
    end
  end else begin
    /* CREATE booking */
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => RES_CREATE_SET$EXC');
    execute procedure RES_CREATE_SET$EXC (
      :booking_id,
      :number,
      :arranger_profile_id,
      :main_guest_profile_id,
      :arrival,
      :departure,
      :adult_count,
      :children_count,
      :room_type_id,
      null,
      :board_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :voucher,
      :voucher_date,
      :voucher_text,
      null,
      null,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :arrival_type_code,
      :is_late_departure,
      :is_vip,
      :first_food_code,
      :special_treatment,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :arranger_account_id,
      :posting_routing,
      :guest_payment_type_id,
      :arranger_payment_type_id,
      null,
      :room_preferences,
      :maintance_shema_id,
      :note,
      :note_reminders,
      :deposit_required,
      :deposit_required_currency,
      :hotel_id,
      :reserv_group_id,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object,
      :create_datetime
      )
    returning_values :err_code, :err_text, :warn_code, :booking_id, :share_transaction_id, :share_err_code;
  end

  execute procedure GUEST_STAY_INITIALIZE$INT (:booking_id);
  /* final error check */
  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;

  delete from PENDING_DEPOSIT d
  where  d.ID_RESERV_DETAIL = :BOOKING_ID;
end
^

/* Alter (IMPORT_GUEST$EXC) */
ALTER PROCEDURE IMPORT_GUEST$EXC(BOOKING_ID INTEGER,
PROFILE_UUID VARCHAR(40),
GUEST_UUID VARCHAR(40),
GUEST_NAME VARCHAR(100),
IS_CHILD SMALLINT,
AGE INTEGER,
IS_DIFFERENT_ARRANGER SMALLINT,
ARRIVAL DATE,
DEPARTURE DATE,
VOUCHER VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
RATING_AGE INTEGER,
KPP VARCHAR(50),
KPP_DATE DATE,
STAY_REASON VARCHAR(255),
CAR VARCHAR(30),
IS_REGISTRED SMALLINT,
PERSONAL_NUMBER VARCHAR(30),
TITLE VARCHAR(10),
PT_NAME VARCHAR(100),
PT_EXTCODE VARCHAR(50),
PASS_NUM VARCHAR(20),
PASS_PLACE VARCHAR(20),
PASS_DATE DATE,
PASS_EXP_DATE DATE,
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_DATE DATE,
SEX CHAR,
BIRTH_PLACE VARCHAR(30),
MASK VARCHAR(10),
PACKAGE VARCHAR(255),
VISA TDESCRIPTION_SHORT)
 RETURNS(GUEST_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable warn_code integer;

declare variable birth_date_old date;
declare variable title_old varchar(10);
declare variable id_passport_type_old integer;
declare variable pass_num_old varchar(20);
declare variable pass_date_old date;
declare variable personal_number_old varchar(30);
declare variable id_stay_reason_old integer;
declare variable is_registred_old integer;
declare variable pass_place_old varchar(20);
declare variable city_old varchar(100);
declare variable address_old varchar(100);
declare variable birth_place_old varchar(30);
declare variable sex_old char(1);
declare variable mask_old varchar(10);
declare variable car_old varchar(30);
declare variable kpp_id_old integer;
declare variable kpp_date_old date;
declare variable pass_exp_date_old date;
declare variable rating_age_old integer;
declare variable visa_old tdescription_short;

declare variable guest_name_old varchar(100);
declare variable is_child_old integer;
declare variable is_different_arranger_old smallint;
declare variable arrival_old date;
declare variable departure_old date;
declare variable voucher_old varchar(30);
declare variable voucher_date_old date;
declare variable voucher_text_old varchar(30);
declare variable country_code_old varchar(10);

declare variable id_passport_type integer;
declare variable kpp_id integer;
declare variable id_stay_reason integer;
begin
  execute procedure import_mark_transaction$exc;

  guest_name = substring(:guest_name from 1 for 50);

  execute procedure sys_dbg('exc IMPORT_GUEST$EXC(:guest_uuid=>' || coalesce(:guest_uuid, '<null>') || ')');
  guest_id = null;

  select pd.person_name, --g.is_different_organizer,
         g.id_guest, g.from_date, g.to_date,
         pd.birthday_internal, pd.title, pd.id_passport_type,
         pd.pass_num, pd.pass_date, pd.egn, gd.id_stay_reason,
         gd.is_registred, pd.pass_place, pd.city, pd.address, pd.birth_place,
         pd.sex, pd.mask, g.is_child, gd.car, gd.kpp, gd.kpp_date,
         pd.pass_exp_date, gd.rating_age, g.vaucher_num, g.vaucher_date, g.vaucher_text, pd.country_code,
         gd.id_stay_reason, gd.visa
  from   GUEST g
         join guest_data gd on gd.id_guest=g.id_guest
         join person_data pd on pd.id_person_data=gd.id_person_data
  where  g.uuid=:guest_uuid
         and g.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and g.id_reserv_detail=:booking_id
  into   :guest_name_old, --:is_different_arranger_old,
         :guest_id, :arrival_old, :departure_old, :birth_date_old,
         :title_old, :id_passport_type_old,
         :pass_num_old, :pass_date_old, :personal_number_old, :id_stay_reason_old,
         :is_registred_old, :pass_place_old, :city_old, :address_old, :birth_place_old,
         :sex_old, :mask_old, :is_child_old, :car_old, :kpp_id_old, :kpp_date_old,
         :pass_exp_date_old, :rating_age_old, :voucher_old, :voucher_date_old,
         :voucher_text_old, :country_code_old, :id_stay_reason_old, :visa_old;

  execute procedure import_passport_type$exc(:pt_name, pt_extcode)
  returning_values :id_passport_type;

  execute procedure import_kpp$exc(:kpp, null)
  returning_values :kpp_id;

  execute procedure import_stay_reason$exc(:stay_reason, null)
  returning_values :id_stay_reason;

  guest_name = coalesce(:guest_name, :guest_name_old);
--  DISABLE age/is_child merge (RIU rating cases)
--  is_child = coalesce(:is_child, :is_child_old);
--  is_different_arranger = coalesce(:is_different_arranger, :is_different_arranger_old);
  arrival = coalesce(:arrival, :arrival_old);
  departure = coalesce(:departure, :departure_old);
  voucher = coalesce(:voucher, :voucher_old);
  voucher_date = coalesce(:voucher_date, :voucher_date_old);
  voucher_text = coalesce(:voucher_text, :voucher_text_old);
  country_code = coalesce(:country_code, :country_code_old);

--  DISABLE age/is_child merge (RIU rating cases)
--  rating_age = coalesce(:rating_age, :rating_age_old);
  kpp_id = coalesce(:kpp_id, :kpp_id_old);
  kpp_date = coalesce(:kpp_date, :kpp_date_old);
  id_stay_reason = coalesce(:id_stay_reason, :id_stay_reason_old);
  car = coalesce(:car, :car_old);
  is_registred = coalesce(:is_registred, 0);
  if (1 = :is_registred_old) then begin --one way update
    is_registred = 1;
  end
  personal_number = coalesce(:personal_number, :personal_number_old);
  title = coalesce(:title, :title_old);
  id_passport_type = coalesce(:id_passport_type, :id_passport_type_old);
  pass_num = coalesce(:pass_num, :pass_num_old);
  pass_place = coalesce(:pass_place, :pass_place_old);
  pass_date = coalesce(:pass_date, :pass_date_old);
  pass_exp_date = coalesce(:pass_exp_date, :pass_exp_date_old);
  city = coalesce(:city, :city_old);
  address = coalesce(:address, :address_old);
  birth_date = coalesce(:birth_date, :birth_date_old);
  sex = coalesce(:sex, :sex_old);
  birth_place = coalesce(:birth_place, :birth_place_old);
  mask = coalesce(:mask, :mask_old);
  visa = coalesce(:visa, :visa_old);

  if (guest_id is null) then begin
    execute procedure RES_GUEST_SAVE$RSV(null, :booking_id, :guest_name, null, null, :is_child, :COUNTRY_CODE)
    returning_values :guest_id;

    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - get_next_auto_guest = :guest_id=>' || coalesce(:guest_id, '<null>'));
    if (:guest_id is null) then begin 
      execute procedure sys_dbg('exc IMPORT_GUEST$EXC - exhausted auto guests list - create new guest');
      execute procedure RES_GUEST_ADD$RSV(:booking_id, :is_child)
      returning_values :err_code, :err_text, :warn_code, :guest_id;
      if (0 <> :err_code) then exit;
    end

    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - update_new_guest_uuid(:guest_id=>' || coalesce(:guest_id, '<null>') || ', :uuid=>' || coalesce(:guest_uuid, '<null>') || ')');
    update GUEST
    set    uuid = :guest_uuid
    where  id_guest=:guest_id;

    /* preserve default mask */
    if (:mask is null) then begin
      select pd.mask
      from   guest_data gd
             join person_data pd on pd.id_person_data=gd.id_person_data
      where  gd.id_guest=:guest_id
      into   :mask;
    end          
  end else begin
    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - update_guest(:update_guest_id=>' || coalesce(:guest_id, '<null>') || ')');

--    DISABLE age/is_child merge (RIU rating cases) 
--    if (:age is null) then begin
--      select age from GUEST_AGE_CALC(:guest_id)
--      into :age;
--    end
  end

  /*
  execute procedure sys_dbg('exc IMPORT_GUEST$EXC->GUEST_ADDRESSCARD_SET$RSV('
  || 'update_guest_id => ' || coalesce(:update_guest_id, '<null>')
  || ', guest_name => ' || coalesce(:guest_name, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  || ', :id_passport_type => ' || coalesce(:id_passport_type, '<null>')
  || ', :pass_num => ' || coalesce(:pass_num, '<null>')
  || ', :pass_date => ' || coalesce(:pass_date, '<null>')
  || ', :egn => ' || coalesce(:egn_old, '<null>')
  || ', :country => ' || coalesce(:country_old, '<null>')
  || ', :id_stay_reason => ' || coalesce(:id_stay_reason, '<null>')
  || ', :is_registred => ' || coalesce(:is_registred, '<null>')
  || ', :pass_place => ' || coalesce(:pass_place, '<null>')
  || ', :city => ' || coalesce(:city, '<null>')
  || ', :address => ' || coalesce(:address, '<null>')
  || ', :birth_place => ' || coalesce(:birth_place, '<null>')
  || ', :sex => ' || coalesce(:sex, '<null>')
  || ', :mask => ' || coalesce(:mask, '<null>')
  || ', :is_child => ' || coalesce(:is_child, '<null>')
  || ', :car => ' || coalesce(:car, '<null>')
  || ', :kpp => ' || coalesce(:kpp_old, '<null>')
  || ', :kpp_date => ' || coalesce(:kpp_date, '<null>')
  || ', :pass_exp_date => ' || coalesce(:pass_exp_date, '<null>')
  || ', :age => ' || coalesce(:age, '<null>')
  || ', :birth_date => ' || coalesce(:birth_date, '<null>')
  || ', :rating_age => ' || coalesce(:rating_age, '<null>')
  || ', :title => ' || coalesce(:title, '<null>')
  ||')');
  */
  execute procedure GUEST_ADDRESSCARD_SET$RSV(
    :guest_id,
    :guest_name,
    null,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :personal_number,
    :country_code,
    :id_stay_reason,
    :is_registred,
    :pass_place,
    :city,
    :address,
    :birth_place,
    :sex,
    :mask,
    :is_child,
    :car,
    :kpp_id,
    :kpp_date,
    :pass_exp_date,
    :age,
    :birth_date,
    :visa,
    :rating_age,
    :title,
    0
  )
  returning_values :err_code, :err_text, :warn_code;
  if (0 <> :err_code) then exit;

  --execute procedure RES_GUEST_SAVE_ORGANIZER$RSV(:guest_id, :is_different_arranger);

  if ((:arrival is not null) and (:departure is not null)) then begin
    execute procedure RES_GUEST_SAVE_STAY$RSV(:guest_id, :arrival, :departure)
    returning_values :err_code, :err_text, :warn_code;
    if (0 <> :err_code) then exit;
  end

  if (:voucher is not null) then begin
    execute procedure RES_GUEST_SAVE_VOUCHER$RSV(:guest_id, :voucher,
            :voucher_date, :voucher_text, null, null);
  end

  execute procedure IMPORT_GUEST_PACK$EXC(:guest_id, :package);

  update GUEST
  set    ORPHANED_IMPORT$EXC = null
  where  id_guest=:guest_id;
end
^

/* empty dependent procedure body */
/* Clear: EAI_IMPORT_ALOYALTY_CLIENT for: IMPORT_PERSON_PROFILE$EXC */
ALTER PROCEDURE EAI_IMPORT_ALOYALTY_CLIENT(CLIENT_UUID VARCHAR(40),
CLIENT_NAME VARCHAR(100),
CARD_CODE VARCHAR(50),
IS_ARHIVE SMALLINT,
DATE_OF_BIRTH DATE)
 AS
 BEGIN EXIT; END
^

/* Alter (IMPORT_PERSON_PROFILE$EXC) */
ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
CLEAR_HOTEL_RATE SMALLINT,
CREATE_ONLY SMALLINT,
MERGE_TARGET_UUID VARCHAR(40))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
declare variable op varchar(10);
  declare variable market_segment_id integer;
  declare variable sex_old char(1);
  declare variable birth_date_old date;
  declare variable birth_place_old varchar(30);
  declare variable personal_number_old varchar(30);
  declare variable pass_num_old varchar(20);
  declare variable pass_date_old date;
  declare variable pass_place_old varchar(20);
  declare variable pass_exp_date_old date;
  declare variable pass_city_old varchar(100);
  declare variable pass_address_old varchar(100);
  declare variable country_old varchar(10);
  declare variable mask_old varchar(10);
  declare variable title_old varchar(10);
  declare variable id_photo integer;
  declare variable id_def_contragent integer;
  declare variable id_passport_type integer;
  declare variable account_no_old varchar(20);
  declare variable msg_old varchar(255);
  declare variable id_guest_type integer;
  declare variable id_guest_type_old integer;
  declare variable card_code_old varchar(50);
  declare variable is_exclusive_debt_ownership smallint;
  declare variable profile_receiver_id integer;
begin
  profile_id = null;
  import_time = null;

  execute procedure import_mark_transaction$exc;

  /*FIXME - remove this block*/
  if (1 = :create_only) then begin
    clear_hotel_rate = 0;
  end else begin
    clear_hotel_rate = 1;
  end

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC(:profile_uuid=>' || coalesce(:profile_uuid, '<null>')
                          || ', email=>' || coalesce(:email, '<null>') || ')');

  profile_id = null;
  if (profile_uuid is null) then begin
    execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC <null> :profile_uuid - exit;');
    exit;
  end

  select p.profile_id, p.profile_name, p.phone, p.fax, p.email, p.city,
         p.address, p.market_segment, p.note, p.is_archive, pp.card_code,
         pd.sex, pd.birthday_internal, pd.birth_place, pd.egn, pd.pass_num,
         pd.pass_date, pd.pass_place, pd.pass_exp_date, pd.city, pd.address, pd.country_code,
         pd.mask, p.id_def_contragent, p.wbe_password,
         pd.title, p.account_no, p.msg, pp.id_guest_type, pp.id_photo, pd.id_passport_type,
         p.is_exclusive_debt_ownership
  from   import_common_profile$exc(:profile_uuid, 0, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :wbe_password, :ACCOUNT_NO, :MSG, 'PERSON_PROFILE', :CLEAR_HOTEL_RATE) p
         left outer join profile_person pp on pp.id_profile = p.profile_id
         left outer join person_data pd on pd.id_person_data=pp.id_person_data
  into   :profile_id, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :card_code_old,
         :sex_old, :birth_date_old, :birth_place_old, :personal_number_old, :pass_num_old,
         :pass_date_old, :pass_place_old, :pass_exp_date_old, :pass_city_old, :pass_address_old, :country_old,
         :mask_old, :id_def_contragent, :wbe_password, :title_old,
         :account_no_old, :msg_old, :id_guest_type_old, :id_photo, :id_passport_type, :is_exclusive_debt_ownership;

  if (:profile_id is null) then begin
    op = 'add';
  end else if (1 = :create_only) then begin
    profile_id = null;
    exit;
  end else begin
    op = 'mod';
    delete from PROFILE_HOTEL_RATE phr
      where phr.ID_PROFILE = :profile_id;
    delete from PROFILE_BONUSPOINT_SCHEME bs
      where bs.ID_PROFILE = :profile_id;
  end

  sex=coalesce(:sex, :sex_old);
  birth_date=coalesce(:birth_date, :birth_date_old);
  birth_place=coalesce(:birth_place, :birth_place_old);
  personal_number=coalesce(:personal_number, :personal_number_old);
  pass_num=coalesce(:pass_num, :pass_num_old);
  pass_date=coalesce(:pass_date, :pass_date_old);
  pass_place=coalesce(:pass_place, :pass_place_old);
  pass_exp_date=coalesce(:pass_exp_date, :pass_exp_date_old);
  pass_city=coalesce(:pass_city, :pass_city_old);
  pass_address=coalesce(:pass_address, :pass_address_old);
  country=upper(coalesce(:country, :country_old));
  mask=coalesce(:mask, :mask_old);
  title=coalesce(:title, :title_old);
  account_no=coalesce(:account_no, :account_no_old);
  msg=coalesce(:msg, :msg_old);
  card_code=coalesce(:card_code, :card_code_old);

  execute procedure IMPORT_PASSPORT_TYPE$EXC(:pass_type_name, :pass_type_external_code)
  returning_values :id_passport_type;

  execute procedure lookup_market_segment$exc(:profile_name, 'PERSON_PROFILE', :market_segment)
  returning_values :market_segment_id;

  if (guest_type_name is not null) then begin
    execute procedure lookup_guest_type$exc(:profile_name, 'PERSON_PROFILE', :guest_type_name)
    returning_values :id_guest_type;
  end

  if ((def_contragent_name is not null) and (def_contragent_name <> '')) then begin
    execute procedure LOOKUP_CONTRAGENT$EXC(:profile_name, 'PERSON_PROFILE', :def_contragent_name)
    returning_values :id_def_contragent;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:profile_name, 'PERSON_PROFILE');

  id_guest_type=coalesce(:id_guest_type, :id_guest_type_old);

  if (id_photo is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, null, null, null, 'del')
    returning_values :id_photo;
  end
  id_photo = null;
  if (picture is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, :picture, :picture_type, :picture_layout, 'add')
    returning_values :id_photo;
  end

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC - profile_person_modify$profile(:profile_uuid=>'
    || coalesce(:profile_uuid, '<null>')
    || ', :operation=>' || coalesce(:op, '<null>')
    || ', :email=>' || coalesce(:email, '<null>')
    || ', :birth_date=>' || coalesce(:birth_date, '<null>')
  || ')');
  execute procedure profile_person_modify$profile(
    :profile_id,
    :id_guest_type,
    :profile_name,
    null,
    :sex,
    :birth_date,
    :birth_place,
    :personal_number,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :pass_place,
    :pass_exp_date,
    :country,
    :pass_city,
    :pass_address,
    :mask,
    :phone,
    :fax,
    :email,
    :city,
    :address,
    :note,
    :msg,
    :id_def_contragent,
    :market_segment_id,
    :is_archive,
    :id_photo,
    :card_code,
    :wbe_password,
    :op,
    :account_no,
    :title,
    :is_exclusive_debt_ownership
  ) returning_values
    :profile_id;

  /*assign uuid to the new profiles*/
  if ('add' = :op) then begin
    update profile set uuid=:profile_uuid where id_profile=:profile_id;
  end

  select record_timestamp from profile where id_profile=:profile_id
  into :import_time;

  if (:MERGE_TARGET_UUID is not null) then begin
    select p.ID_PROFILE
    from   PROFILE P
    where  P.UUID = :MERGE_TARGET_UUID
    into   :profile_receiver_id;

    execute procedure PROFILE_MERGE$PROFILE (:PROFILE_ID, :profile_receiver_id, 'merge');

  end

end
^

/* Alter (MONITOR_ROOM_GANT$HM) */
ALTER PROCEDURE MONITOR_ROOM_GANT$HM(FROM_DATE DATE,
TO_DATE DATE,
IN_ROOM_NAME VARCHAR(10),
IN_ID_ROOM_TYPE INTEGER,
IN_FLOOR INTEGER,
ID_HOTEL INTEGER)
 RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(20),
GANT_FROM_DATE DATE,
GANT_TO_DATE DATE,
BUSY_GRP INTEGER)
 AS
declare variable id_occupant integer;
begin
  for
    select R.ID_ROOM, R.ROOM_NAME
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  RT.ID_HOTEL = :id_hotel
           and ((R.ID_ROOM_TYPE = :in_id_room_type) or (:in_id_room_type = -1))
           and ((:in_room_name = '') or (r.room_name like :in_room_name))
           and ((:in_floor = -1) or (R.FLOOR = :in_floor))
    order by R.ROOM_NAME
    into :id_room, :room_name
  do begin
    gant_from_date = null;
    gant_to_date = null;
    busy_grp = null;
    suspend;

    for
      select distinct
             RM.ID_RESERV_DETAIL, RM.BUSY_GROUP_TYPE
      from   ROOM_MAGIC RM
      where  RM.BUSY_DATE between :from_date and :to_date
             and RM.ID_ROOM = :id_room
      into   :id_occupant, :busy_grp
    do begin
      select O.FROM_DATE, O.TO_DATE
      from   OCCUPANT_GET_INFO(:id_occupant, :busy_grp) O
      into   :gant_from_date, :gant_to_date;

      suspend;
    end
  end
end
^

/* Alter (NON_DOCUMENTED_INFO_GET$INT) */
ALTER PROCEDURE NON_DOCUMENTED_INFO_GET$INT(ID_OWNER INTEGER,
ID_ROOM INTEGER)
 RETURNS(OUT_LATE_INFO VARCHAR(255),
OUT_CURR_INFO VARCHAR(255),
OUT_NEXT_INFO VARCHAR(255))
 AS
declare variable from_date date;
declare variable to_date date;
declare variable value_post_total numeric(15,4);
declare variable curr_post varchar(3);
declare variable sub_delim varchar(3);
declare variable short_date_format varchar(50);
declare variable value_format varchar(50);
declare variable has_next smallint;
declare variable tmp_info varchar(5000);
declare variable billing_type varchar(10);
declare variable prev_billing_type varchar(10);
declare variable is_first smallint;
begin
  if (:ID_OWNER is null) then exit;

  OUT_LATE_INFO = null;
  OUT_CURR_INFO = null;
  OUT_NEXT_INFO = null;
  tmp_info = null;

  from_date = '01.01.1500';
  sub_delim = '/ ';
  short_date_format = 'D;dd.mm';
  value_format = 'F;0.00';

  is_first = 1;
  for
    select P.BILLING_PERIOD_FROM, P.BILLING_DATE, P.BILLING_TYPE
    from   PMS_BILLING_CYCLE_CALC(:id_owner) P
    into   :FROM_DATE, :TO_DATE, :billing_type
  do begin
    has_next = 0;
    if (:PREV_BILLING_TYPE <> :BILLING_TYPE) then
      tmp_info = null;

    tmp_info = coalesce(trim(:tmp_info) || '; ', '');

    if (:BILLING_TYPE in ('current', 'late') and :to_date is not null) then
        tmp_info = :tmp_info || formatdate(:to_date, :short_date_format) || :sub_delim;

    if (:ID_OWNER is not null) then begin
      for
      /*  select sum(P.VALUE_POST * iif(P.IS_OWNER_INCOME = 1, 1, -1)), P.CURR_POST
        from   PMS_ACC_POST_TO_BILL_GET$INT(:ID_OWNER, :ID_ROOM, iif(:IS_FIRST=1,'01.01.1500',:FROM_DATE), coalesce(:TO_DATE, '01.01.2500'), 0) P
        group by 2
        into   :value_post_total, :curr_post  */
        select   sum(coalesce(OP.INCOME_VALUE, OP.OUTGO_VALUE) * iif(coalesce(APP.IS_OWNER_INCOME, 0) = 1, 1, -1)), coalesce(OP.INCOME_CURR, OP.OUTGO_CURR)
        from     OWNER_POST OP
                 left outer join ACCOUNT_POST$PMS  APP on APP.ID_ACCOUNT_POST = OP.ID_ACCOUNT_POST$PMS
        where    OP.ID_OWNER = :id_owner
                 and ((OP.ID_ROOM = :id_room) or (:id_room is null))
                 and OP.POST_DATE between iif(:IS_FIRST=1, cast('01.01.1500' as date), :FROM_DATE) and coalesce(:TO_DATE, cast('01.01.2500' as date))
                 and OP.IS_ANUL = 0
        group by 2
        into     :value_post_total, :curr_post
      do begin
        tmp_info = trim(:tmp_info) || iif(:has_next = 1, ', ', '');
        tmp_info = iif(:tmp_info = '', '', trim(:tmp_info) || ' ') || FORMATFLOAT(:VALUE_POST_TOTAL, :value_format) || ' ' || :CURR_POST;
        has_next = 1;
      end
    end

    if (:has_next = 0) then begin
      select O.ID_CURRENCY
      from   OWNER$PMS O
      where  O.ID_OWNER = :ID_OWNER
      into   :CURR_POST;

      if (:billing_type in ('late', 'current')) then
        tmp_info = iif(:tmp_info = '', '', trim(:tmp_info) || ' ') || FORMATFLOAT(0, :value_format) || ' ' || :CURR_POST;
    end
    if (:billing_type = 'late') then OUT_LATE_INFO = substring(:tmp_info from 1 for 254);
    if (:billing_type = 'current') then OUT_CURR_INFO = substring(:tmp_info from 1 for 254);
    if (:billing_type = 'next') then OUT_NEXT_INFO = substring(:tmp_info from 1 for 254);
    prev_billing_type = :billing_type;
    is_first = 0;
  end
  suspend;
end
^

/* Alter (OCCUPANCY_OVERBOOK$INT) */
ALTER PROCEDURE OCCUPANCY_OVERBOOK$INT(ID_AGENT INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM_TYPE INTEGER,
RESERV_STATUS VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable must_check_overbook integer;
  declare variable maxbook_date  date;
  declare variable maxbook_rooms  integer;
  declare variable agent_maxbook_date date;
  declare variable agent_maxbook_rooms integer;
  declare variable id_inventory_allotment integer;
  declare variable id_agent_contingent integer;
  declare variable available_rooms integer;
  declare variable problem_date date;
  declare variable room_type varchar(20);
  declare variable id_hotel integer;
begin
  /* 1. DEALING WITH THE TOTAL OVERBOOK.
  || 2. DEALING WITH THE CONTINGENT OVERBOOK.
  */
  err_code = 0;
  err_text = '';
  warn_code = null;

  /* CHECK THE TOTAL HOTEL AVAILABILITY*/
  select H.ID_INVENTORY_ALLOTMENT, RT.TYPE_ROOM, h.ID_HOTEL
  from   ROOM_TYPES RT
         join HOTEL H on H.ID_HOTEL = RT.ID_HOTEL
  where  RT.ID_ROOM_TYPE = :id_room_type
  into   :id_inventory_allotment, :room_type, :id_hotel;

  if (:reserv_status = 'VALUE_RESERVS') then begin
    must_check_overbook = 0;
  end else begin
    execute procedure SETTING_GET_VALUE('CHECK_OVERBOOK', :id_hotel)
    returning_values  :must_check_overbook;
  end

  if (:must_check_overbook = 0) then exit;
  /* ********************************** */
  execute procedure OCCUPANCY_OVERBOOK_MAX$INT(:from_date, :to_date, :id_inventory_allotment, :id_room_type)
  returning_values  :maxbook_date, :maxbook_rooms, :available_rooms;

  if (:available_rooms < 0) then begin
    problem_date = :maxbook_date;
    err_text = substring(f_character(29)||cast(abs(:available_rooms) as integer)||f_character(28)||FormatDate(:problem_date, 'D;dd.mm.yyyy')||f_character(28)||:room_type from 1 for 255);

    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_TOTAL_OVERBOOK');

    execute procedure SYSTEM_WARNING_ADD(-95, :err_text)
    returning_values :warn_code;

    when exception RIGHT_NOT_GRANTED do begin
      err_code = -94;
      exit;
    end
  end

  /* check agent contingent overbooko *****************************************/
  select PA.ID_CONTINGENT
  from   PROFILE_AGENT PA
  where  PA.ID_AGENT = :id_agent
  into   :id_agent_contingent;

  if (:id_agent_contingent is not null) then begin
    /* CHECK THE AGENT CONTINGENT AVAILABILITY*/
    execute procedure OCCUPANCY_OVERBOOK_MAX$INT(:from_date, :to_date, :id_agent_contingent, :id_room_type, :id_agent)
    returning_values  :agent_maxbook_date, :agent_maxbook_rooms, :available_rooms;
  
    if (:available_rooms < 0) then begin
      problem_date = :agent_maxbook_date;
      err_text = f_character(29)||FormatDate(:problem_date, 'D;dd.mm.yyyy')||f_character(28)||:room_type||f_character(28)||cast(abs(:available_rooms) as integer);
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CONT_OVERBOOK');

      execute procedure SYSTEM_WARNING_ADD(-97, :err_text)
      returning_values :warn_code;

      when exception RIGHT_NOT_GRANTED do begin
        err_code = -96;
        exit;
      end
    end
  end
end
^

/* Alter (OCCUPANCY_RTI_BP$RPT) */
ALTER PROCEDURE OCCUPANCY_RTI_BP$RPT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ROOM_TYPES VARCHAR(255))
 RETURNS(OUT_DATE DATE,
CATEGORY VARCHAR(50),
AGENT_NAME VARCHAR(50),
ROOM_CNT INTEGER)
 AS
declare variable capacity integer;
declare variable ooi integer;
declare variable busy integer;
declare variable res_conf integer;
declare variable res_notconf integer;
declare variable bp_total integer;
declare variable sold_total integer;
declare variable total_bp_remains integer;
begin
  execute procedure AVAILABILITY_OCCUP_PREPARE$AVL (:FROM_DATE, :TO_DATE, 1, 1, 0, 1, 1, 0, 1, 0, :ID_HOTEL);

  for
    select t.FOR_DATE,
           sum(t.G_CAPACITY),
           sum(t.G_OOI),
           sum(t.SOLD),
           sum(t.RES_CONFIRMED),
           sum(t.RES_NOTCONFIRMED)
    from   SMART_OCCUP$TMP T
           join ROOM_TYPES rt on rt.ID_ROOM_TYPE = t.ID_ROOM_TYPE
    where  ','||:room_types||',' containing ','||rt.type_room||','
    group by 1
    into  :OUT_DATE, :capacity, :ooi, :busy, :res_conf, :res_notconf
  do begin
    CATEGORY = '1.Capacity';
    AGENT_NAME = '';
    ROOM_CNT = :capacity;
    suspend;
    CATEGORY = '2.OOI';
    AGENT_NAME = '';
    ROOM_CNT = :ooi;
    suspend;
    CATEGORY = '3.Available';
    AGENT_NAME = '';
    ROOM_CNT = :capacity - :ooi;
    suspend;
    CATEGORY = '4.Check in';
    AGENT_NAME = '';
    ROOM_CNT = :busy;
    suspend;
    CATEGORY = '5.Confirmed';
    AGENT_NAME = '';
    ROOM_CNT = :res_conf;
    suspend;
    CATEGORY = '6.Tentative';
    AGENT_NAME = '';
    ROOM_CNT = :res_notconf;
    suspend;
    CATEGORY = '7.Total sold';
    AGENT_NAME = '';
    ROOM_CNT = :busy + :res_conf + :res_notconf;
    suspend;
    CATEGORY = '8.Free';
    AGENT_NAME = '';
    ROOM_CNT = :capacity - :ooi - :busy - :res_conf - :res_notconf;
    suspend;

    CATEGORY = '9.RTI-BP';
    total_bp_remains = 0;
    for
      select '9.'||P.PROFILE_NAME as agent_name, sum(AO.CONT_BP), sum(ao.SOLD + ao.RES_CONFIRMED + ao.RES_NOTCONFIRMED)
      from   SMART_OCCUP$TMP AO
             join ROOM_TYPES rt on rt.id_room_type = ao.id_room_type
             left outer join PROFILE_AGENT PA on PA.ID_AGENT = AO.ID_AGENT
             left outer join PROFILE P on P.ID_PROFILE = pa.ID_PROFILE
      where  AO.FOR_DATE = :OUT_DATE
             and ','||:room_types||',' containing ','||rt.type_room||','
      group by 1
      having (sum(AO.CONT_BP) > 0) or (sum(ao.SOLD + ao.RES_CONFIRMED + ao.RES_NOTCONFIRMED) > 0)
      into   :CATEGORY/*:AGENT_NAME*/, :bp_total, :sold_total
    do begin
      AGENT_NAME = 'Total BP';
      ROOM_CNT = :bp_total;
      suspend;

      AGENT_NAME = 'Sold rooms';
      ROOM_CNT = :sold_total;
      suspend;

      AGENT_NAME = 'BP-remain';
      if (:bp_total < :sold_total) then ROOM_CNT = 0;
      else ROOM_CNT = :bp_total - :sold_total;
      suspend;

      total_bp_remains = :total_bp_remains + :ROOM_CNT;
    end 

    CATEGORY = 'Occupancy %';
    AGENT_NAME = '';
    ROOM_CNT =  iif((:capacity - :ooi) = 0, 0, cast(:busy + :res_conf + :res_notconf + :total_bp_remains as double precision) / (:capacity - :ooi)) * 100;
    suspend;

    CATEGORY = 'Remain';
    AGENT_NAME = '';
    ROOM_CNT = :capacity - :ooi - :busy - :res_conf - :res_notconf - :total_bp_remains;
    suspend;
  end
end
^

/* Alter (OWNER_BILL_MODIFY$PMS) */
ALTER PROCEDURE OWNER_BILL_MODIFY$PMS(ID_OWNER_BILL INTEGER,
ID_OWNER INTEGER,
BILLING_DATE DATE,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_OWNER_BILL INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_anul smallint;
  declare variable bill_num integer;
  declare variable id_account_post_pms integer;
  declare variable id_account_post integer;
  declare variable prev_id_owner_bill integer;
  declare variable prev_billing_date date;

  declare variable id_account integer;
  declare variable id_account_pms integer;
  declare variable value_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable value_post numeric(15,4);
  declare variable curr_post varchar(3);
  declare variable is_owner_income smallint;
  declare variable id_service integer;
  declare variable id_room integer;
  declare variable date_post date;
  declare variable id_reserv_detail integer;
  declare variable doc_description varchar(255);
  declare variable id_doc_head integer;
  declare variable description varchar(255);
  declare variable id_pms_event integer;
  declare variable is_client_account_post smallint;
begin
  err_code = 0;
  err_text = '';
  is_client_account_post = null;
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'create, anul');

  if ( exists ( select *
                from   OWNER$PMS O
                where  O.ID_OWNER = :ID_OWNER
                       and O.ID_RENTAL_POOL_UNIT is not null ) ) then
  begin
    exception PMS_EXCEPTION 'selected owner is pool!';
  end

  if (:operation = 'create') then begin
    is_anul = 0;

    if ( (:ID_OWNER_BILL is null) or (:ID_OWNER_BILL <= 0) )  then
      NEW_ID_OWNER_BILL = gen_id(GEN_OWNER_BILL$PMS_ID, 1);
    else
      NEW_ID_OWNER_BILL = :ID_OWNER_BILL;

    BILL_NUM = :NEW_ID_OWNER_BILL;
    insert into OWNER_BILL$PMS (ID_OWNER_BILL, ID_OWNER, BILL_DATE, IS_ANUL, BILL_NUM,
           IS_EXPORTED_TO_INTRANET, IS_POOL_DISTRIBUTION_STATEMENT)
    values (:NEW_ID_OWNER_BILL, :ID_OWNER, :BILLING_DATE, :IS_ANUL, :BILL_NUM, 0, 0);

    update OWNER$PMS O
    set    O.LAST_BILLING_DATE = :billing_date,
           O.ID_OWNER_BILL = :NEW_ID_OWNER_BILL
    where  O.ID_OWNER = :ID_OWNER;

    for
    /*  select ID_ACCOUNT_POST, ID_ACCOUNT_POST_PMS
      from   PMS_ACC_POST_TO_BILL_GET$INT(:ID_OWNER, null, '01.01.1500', :BILLING_DATE, 1)
      into   :ID_ACCOUNT_POST, :ID_ACCOUNT_POST_PMS */
      select   OP.ID_ACCOUNT_POST, OP.ID_ACCOUNT_POST$PMS
      from     OWNER_POST OP
      where    OP.ID_OWNER = :id_owner
               and OP.POST_DATE between cast('01.01.1500' as date) and :billing_date
               and OP.IS_ANUL = 0
      order by OP.ID_ACCOUNT_POST$PMS nulls last
      into     :ID_ACCOUNT_POST, :ID_ACCOUNT_POST_PMS
    do begin
      if (:id_account_post_pms is not null) then begin

        update ACCOUNT_POST$PMS A
        set    A.LINE_STATUS = 21
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS;

        id_account = null;
        select ACC.ID_SERVICE, ACC.VALUE_ORIG, ACC.CURR_ORIG, ACC.VALUE_POST, ACC.CURR_POST,
               ACC.IS_OWNER_INCOME, ACC.DATE_POST, ACC.ID_ACCOUNT_PMS, E.ID_ROOM,
               E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION, A.IS_CLIENT_POOL_ACCOUNT
        from   ACCOUNT_POST$PMS ACC
               join ACCOUNT$PMS A on A.ID_ACCOUNT = ACC.ID_ACCOUNT_PMS
               join PMS_EVENT$PMS E on E.ID_PMS_EVENT = ACC.ID_PMS_EVENT
        where  ACC.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
        into   :ID_SERVICE, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
               :IS_OWNER_INCOME, :DATE_POST, :ID_ACCOUNT_PMS, :ID_ROOM,
               :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION, :is_client_account_post;
      end

      if (:id_account_post is not null) then begin
        exception PMS_EXCEPTION '-613';
          
        is_client_account_post = 1;
        update PMS_EVENT_POST A
        set    A.LINE_STATUS = 21
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST;

        id_account_pms = null;
        select ACC.ID_SERVICE, ACC.PRICE_ORIG, ACC.CURR_ORIG, ACC.PRICE_POST, ACC.CURR_POST,
               0, ACC.DATE_POST, ACC.ID_ACCOUNT, E.ID_ROOM,
               E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION
        from   ACCOUNT_POST ACC
               join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = ACC.ID_ACCOUNT_POST
               join PMS_EVENT$PMS E on E.ID_PMS_EVENT = PP.ID_PMS_EVENT
        where  ACC.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
        into   :ID_SERVICE, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
               :IS_OWNER_INCOME, :DATE_POST, :ID_ACCOUNT, :ID_ROOM,
               :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION;
      end

      insert into OWNER_BILL_ROW$PMS (ID_OWNER_BILL, ID_ACCOUNT_POST,
             ID_ACCOUNT, ID_ACCOUNT_POST_PMS, ID_ACCOUNT_PMS, ID_SERVICE, VALUE_ORIG,
             CURR_ORIG, VALUE_POST, CURR_POST, IS_OWNER_INCOME, ID_ROOM, DATE_POST,
             ID_RESERV_DETAIL, DOC_DESCRIPTION, ID_DOC_HEAD, DESCRIPTION, IS_CLIENT_ACCOUNT_POST)
      values (:new_id_owner_bill, :ID_ACCOUNT_POST, :ID_ACCOUNT,
             :ID_ACCOUNT_POST_PMS, :ID_ACCOUNT_PMS, :ID_SERVICE, :VALUE_ORIG,
             :CURR_ORIG, :VALUE_POST, :CURR_POST, :IS_OWNER_INCOME, :ID_ROOM, :DATE_POST,
             :ID_RESERV_DETAIL, :DOC_DESCRIPTION, :ID_DOC_HEAD, :DESCRIPTION, :is_client_account_post);
    end
  end
  if (:operation = 'anul') then begin
    select O.ID_OWNER, O.IS_ANUL
    from   OWNER_BILL$PMS O
    where  O.ID_OWNER_BILL = :ID_OWNER_BILL
    into   :id_owner, :is_anul;
    if (:is_anul = 1) then exit;

    select first 1 B.ID_OWNER_BILL
    from   OWNER_BILL$PMS B
    where  B.ID_OWNER = :id_owner
           and B.IS_ANUL = 0
    order by B.BILL_DATE desc
    into   :prev_id_owner_bill;
    if (:prev_id_owner_bill <> :id_owner_bill) then exception PMS_EXCEPTION '-619';

    select first 1 O.ID_OWNER_BILL, O.BILL_DATE
    from   OWNER_BILL$PMS O
    where  O.ID_OWNER = :ID_OWNER
           and o.IS_ANUL = 0
           and O.ID_OWNER_BILL <> :ID_OWNER_BILL
    order by O.BILL_DATE desc
    into   :prev_id_owner_bill, :prev_billing_date;

    update OWNER$PMS O
    set    O.LAST_BILLING_DATE = :prev_billing_date,
           O.ID_OWNER_BILL = :prev_id_owner_bill
    where  O.ID_OWNER = :ID_OWNER;

    update OWNER_BILL$PMS B
    set    B.IS_EXPORTED_TO_INTRANET = 0,
           B.IS_ANUL = 1
    where  B.ID_OWNER_BILL = :ID_OWNER_BILL;

    for
      select O.ID_ACCOUNT_POST, O.ID_ACCOUNT_POST_PMS
      from   OWNER_BILL_ROW$PMS O
      where  O.ID_OWNER_BILL = :ID_OWNER_BILL
      into   :id_account_post, :id_account_post_pms
    do begin
      if (:id_account_post_pms is not null) then begin
        update ACCOUNT_POST$PMS A
        set    A.LINE_STATUS = 11
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
               and A.LINE_STATUS = 21;
      end

      if (:id_account_post is not null) then begin
        update PMS_EVENT_POST A
        set    A.LINE_STATUS = 11
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and A.LINE_STATUS = 21;
      end
    end

    for
      select distinct AP.ID_PMS_EVENT
      from   OWNER_BILL_ROW$PMS R
             join OWNER_BILL$PMS B on B.ID_OWNER_BILL = R.ID_OWNER_BILL
             join ACCOUNT_POST$PMS AP on AP.ID_ACCOUNT_POST = R.ID_ACCOUNT_POST_PMS
             join PMS_EVENT$PMS E on E.ID_PMS_EVENT = AP.ID_PMS_EVENT
      where  R.ID_OWNER_BILL = :ID_OWNER_BILL
             and E.EVENT_TYPE = 'POOL_DISTRIBUTION'
             and B.IS_POOL_DISTRIBUTION_STATEMENT = 1
      into   :id_pms_event
    do begin
      execute procedure PMS_EVENT_VOID$INT(:id_pms_event);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_REFUND_PAY_ANNUL$INT for: PAYMENT_ANUL$INT */
ALTER PROCEDURE DEPOSIT_REFUND_PAY_ANNUL$INT(ID_REFUND_PAYMENT INTEGER,
ANNUL_REASON VARCHAR(255) = '')
 AS
 BEGIN EXIT; END
^

/* Alter (PAYMENT_ANUL$INT) */
ALTER PROCEDURE PAYMENT_ANUL$INT(ID_PAYMENT_HEAD INTEGER,
ANUL_REASON VARCHAR(100))
 AS
declare variable p_dbkey char(8);
  declare variable id_ar_payment integer;
  declare variable id_payment_storned integer;
  declare variable payment_amount numeric(15,4);
  declare variable pay_currency varchar(3);
  declare variable system_date date;
  declare variable id_hotel integer;
  declare variable id_system_log integer;
  declare variable id_deposit integer;
  declare variable is_posting_stopped integer;
  declare variable round_to numeric(15,4);
begin 
  execute procedure PAYMENT_VOID_CHECK$INT (:ID_PAYMENT_HEAD, :ANUL_REASON);

  select P.RDB$DB_KEY, p.ID_PAYMENT_STORNED, P.PAY_VALUE_A, P.PAY_CURRENCY,
         P.ID_AR_PAYMENT, a.ID_HOTEL, p.ID_DEPOSIT, c.ROUND_TO
  from   PAYMENT_HEAD P
         join ACCOUNT A on A.ID_ACCOUNT = p.ID_ACCOUNT
         join CURRS c on c.CURR = p.PAY_CURRENCY
  where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  into   :p_dbkey, :id_payment_storned, :payment_amount, :pay_currency,
         :id_ar_payment, :id_hotel, :id_deposit, :round_to;

  if (:id_ar_payment is not null) then
    exception PAYMENT_ANNUL_EXCEPTION '-353';
    --'Payment is created from AR module.';

  if (:id_deposit is not null) then begin
    select r.IS_POSTING_STOPPED
    from   DEPOSIT d
           join RESERV_DETAIL r on r.ID_RESERV_DETAIL = d.ID_RESERV_DETAIL
    where  d.ID_DEPOSIT = :id_deposit
    into   :is_posting_stopped;

    if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';
  end

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :system_date;

  insert into ACCOUNT_PAYMENTS (ID_ACCOUNT, ID_PAYMENT_HEAD, PAY_AMOUNT, PAY_RATE,
         ACC_AMOUNT, ACC_RATE, TRANSACTION_DATE, ID_DEPOSIT)
  select AP.ID_ACCOUNT, AP.ID_PAYMENT_HEAD, -sum(AP.PAY_AMOUNT), AP.PAY_RATE,
         -sum(AP.ACC_AMOUNT), AP.ACC_RATE, :system_date, AP.ID_DEPOSIT
  from   ACCOUNT_PAYMENTS AP
  where  AP.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  group by AP.ID_ACCOUNT, AP.ID_PAYMENT_HEAD, AP.PAY_RATE, AP.ACC_RATE, AP.ID_DEPOSIT
  having round_f(sum(AP.PAY_AMOUNT), :round_to) <> 0;
                            
  if (:id_payment_storned is not null) then begin
    update PAYMENT_HEAD SP
    set    sp.IS_STORNED = 0
    where  sp.ID_PAYMENT_HEAD = :id_payment_storned;
  end

  execute procedure SYSTEM_EVENT_LOG$INT ('PAYMENT', :ID_PAYMENT_HEAD, 'ANNUL', f_character(29) || formatfloat(:payment_amount, 'F;0.00') || ' ' || :pay_currency || f_character(28) || :ANUL_REASON)
  returning_values  :id_system_log;

  update PAYMENT_HEAD PA
  set    PA.IS_ANUL = 1,
         pa.ANNUL_DATE = :system_date,
         pa.ID_LOG_EVENT_ANNUL = :id_system_log
  where  PA.RDB$DB_KEY = :p_dbkey;

end
^

/* Alter (PAYMENT_DOC_ANUL$DOC) */
ALTER PROCEDURE PAYMENT_DOC_ANUL$DOC(ID_PAYMENT_HEAD INTEGER,
ANUL_REASON VARCHAR(100))
 AS
declare variable dbg varchar(2000);
  declare variable id_deposit integer;
  declare variable doc_direction integer;
begin
  select DP.DOC_DIRECTION
  from   PAYMENT_HEAD P
         join DOC_TYPE_PAY DP on DP.ID_DOC_TYPE = P.ID_DOC_TYPE
  where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  into   :doc_direction;

  if (:doc_direction = 0) then begin
    /* get all deposits created/splited from this payment */
    for
      select D.ID_DEPOSIT
      from   DEPOSIT D
      where  D.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
      into   :id_deposit
    do begin
      execute procedure DEPOSIT_ANUL$DOC (:id_deposit, :ANUL_REASON)
      returning_values :dbg;
    end
  end else begin
    execute procedure DEPOSIT_REFUND_PAY_ANNUL$INT (:ID_PAYMENT_HEAD, :ANUL_REASON);
  end

end
^

/* Alter (PHONECALL_POST$TC) */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Alter (PHONECALLS_POST_TO_ACCOUNT$TC) */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POST_MODIFY$PMS for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: CONTRACT_EXPENSE_POST$INT for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_HOTEL INTEGER,
ID_CONTRACT /* TYPE OF ID */ INTEGER,
SUB_CONTRACT /* TYPE OF TSUB_CONTRACT */ VARCHAR(10),
ID_OWNER /* TYPE OF ID */ INTEGER,
OWNERSHIP_PERCENT /* TYPE OF TPERCENT */ NUMERIC(15,4),
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
POST_DATE /* TYPE OF TDATE */ DATE,
STAY /* TYPE OF TCOUNT */ INTEGER,
MAX_GUEST_CNT /* TYPE OF TCOUNT */ INTEGER,
BED_NIGHT_CNT /* TYPE OF TCOUNT */ INTEGER,
RESERVS /* TYPE OF TCOUNT */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PMS_EXPENSE_POSTS_CREATE$INT for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_EXPENSE_POSTS_CREATE$INT(ID_ROOM /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
POST_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
IS_CLIENT_ACC_POST /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_POST_DATE /* TYPE OF TDATE */ DATE,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IS_POST_PER_POOL /* TYPE OF TLOGICAL */ SMALLINT)
 RETURNS(NEW_ID_ACCOUNT_POST /* ID_REF */ INTEGER,
NEW_ID_ACCOUNT_POST$PMS /* ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PMS_POOL_DISTRIBUTION_SUB for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_POSTING_CREATE$INT) */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_OWNER TYPE OF ID,
POST_DATE TYPE OF TDATE,
CURR_ORIG TYPE OF TCURRENCY,
VALUE_ORIG TYPE OF TPRICE,
POST_ON_PMS_ACCOUNT TYPE OF TLOGICAL,
IS_OWNER_INCOME TYPE OF TLOGICAL,
ID_ROOM TYPE OF ID_REF = null)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  if (:POST_ON_PMS_ACCOUNT = 1) then begin
    execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account, :id_owner,
            :CURR_ORIG, :VALUE_ORIG, :id_service, :is_owner_income, :POST_DATE)
    returning_values  (:new_id_account_post);
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :ID_SERVICE, 1, 0, 1,
            :VALUE_ORIG, :CURR_ORIG, current_date, current_date,
            '', '', :POST_DATE, 'PMS', :ID_ROOM)
    returning_values  :err_code, :err_text, :new_id_account_post;
    if (:err_code <> 0) then exception PMS_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

    insert into PMS_EVENT_POST (ID_PMS_EVENT, ID_ACCOUNT_POST, ID_OWNER, LINE_STATUS)
    values (:ID_PMS_EVENT, :NEW_ID_ACCOUNT_POST, :ID_OWNER, 11);
  end
end
^

/* Alter (POST_SERVICE_FINALIZE$POST) */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
  declare variable id_acc_post integer;
  declare variable id_service integer;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable date_post date;
  declare variable price_post numeric(15,4);
  declare variable qty_post numeric(15,2);
  declare variable post_text varchar(100);
  declare variable curr_post varchar(3);
  declare variable id_phonecall integer;
  declare variable p_dbkey char(8);
begin

  if (:OPERATION = 'clear') then begin
    delete from TMP_SERVICE_POST T
    where  T.ID_SEQUENCE = :ID_SEQUENCE;

  end else if (:OPERATION = 'store') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);

    for
      select TS.RDB$DB_KEY, TS.ID_SERVICE, TS.ID_ACCOUNT, TS.ID_GUEST, TS.DATE_POST,
             TS.PRICE_POST, TS.QTY_POST, TS.CURR_POST, TS.POST_TEXT, TS.ID_PHONECALL
      from   TMP_SERVICE_POST TS
      where  TS.ID_SEQUENCE = :ID_SEQUENCE
      into   :p_dbkey, :id_service, :id_account, :id_guest, :date_post,
             :price_post, :qty_post, :curr_post, :post_text, :id_phonecall
    do begin
      id_acc_post = null;
      if (:id_guest is not null) then begin
        execute procedure POST_SERVICE_ON_GUEST$INT (:id_guest, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :CURR_POST,
                :date_post, :date_post, :post_text, '', :date_post, '', '')
        returning_values  (:err_code, :err_text, :no_use, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end else begin
        execute procedure POST_SERVICE_ON_ACCOUNT$INT (:id_account, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :curr_post, :date_post, :date_post, :post_text,
                '', :date_post, '')
        returning_values  (:err_code, :err_text, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end

      update TMP_SERVICE_POST
      set ID_ACCOUNT_POST = :id_acc_post
      where RDB$DB_KEY = :p_dbkey;

      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :DOC_SELECTED,
             AP.SHORT_CODE = case
                               when :id_phonecall is not null then 'TELECOUNT'
                               else null
                             end
      where  AP.ID_ACCOUNT_POST = :id_acc_post;

      if (:id_phonecall is not null) then begin
        update PHONECALLS P
        set    P.ID_ACCOUNT_POST = :id_acc_post
        where  P.ID_PHONECALL = :id_phonecall;
      end
    end
  end
end
^

/* Alter (PROFILE_GET_ACCOUNT$INT) */
ALTER PROCEDURE PROFILE_GET_ACCOUNT$INT(ID_PROFILE INTEGER,
ID_RESERV_DETAIL INTEGER,
ACCOUNT_CURR VARCHAR(3),
ID_ACC_TEMPLATE INTEGER,
IS_BASE_ENABLE SMALLINT = 1,
IS_EXTRA_ENABLE SMALLINT = 1)
 RETURNS(ID_ACCOUNT INTEGER)
 AS
declare variable is_archive integer;
declare variable id_hotel integer;
begin
  id_account = null;

  select first 1 A.ID_ACCOUNT, a.IS_ARCHIVE
  from   ACCOUNT A
  where  A.ID_PROFILE = :id_profile
         and A.ACCOUNT_CURR = :account_curr
         and A.ID_RESERV_DETAIL is not distinct from :id_reserv_detail
         and A.IS_BASE >= :IS_BASE_ENABLE
         and A.IS_EXTRA >= :IS_EXTRA_ENABLE
  order by A.IS_ARCHIVE asc, A.ID_ACCOUNT asc
  into   :id_account, :is_archive;

  if (:id_account is null) then begin
    if (:id_acc_template is null) then begin
      select rd.ID_HOTEL
      from   RESERV_DETAIL RD
      where  rd.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
      into   :id_hotel;

      select P.ID_ACCOUNT_TEMPLATE
      from   PROFILE_BOOKING_DEFAULTS P
      where  P.ID_PROFILE = :id_profile
             and P.ID_HOTEL = :id_hotel
      into   :id_acc_template;
    end

    execute procedure RES_ACCOUNT_CREATE$INT(:id_profile, :id_acc_template, :account_curr,
            :id_reserv_detail, :IS_BASE_ENABLE, :IS_EXTRA_ENABLE)
    returning_values  :id_account;

  end else if (:is_archive = 1) then begin
    execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 0);
  end
end
^

/* Alter (PROFILE_GET_ACCOUNT$PROFILE) */
ALTER PROCEDURE PROFILE_GET_ACCOUNT$PROFILE(ID_PROFILE INTEGER,
SHOW_ARCHIVE SMALLINT)
 RETURNS(ID_ACCOUNT INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
DEPOSIT_VALUE NUMERIC(15,4),
BALANCE_VALUE NUMERIC(15,4),
IS_DEFAULT SMALLINT,
IS_CREDIT SMALLINT,
CREDIT_LIMIT NUMERIC(15,4),
ID_TYPE_PAYMENT INTEGER,
IS_LEVEL_1 INTEGER,
IS_ARCHIVE INTEGER,
HOTEL_NAME VARCHAR(50))
 AS
begin
  for
    select A.ID_ACCOUNT, A.ACCOUNT_CURR, A.ACCOUNT_NAME, A.CREDIT_LIMIT,
           A.IS_CREDIT_ACCOUNT, A.ID_TYPE_PAYMENT, AB.DEP_VALUE, AB.ACCOUNT_BALANCE,
           A.IS_DEFAULT,
           case
             when A.SECURITY_LEVEL = 1 then 1
             else 0
           end,
           A.IS_ARCHIVE, H.HOTEL_NAME
    from  ACCOUNT_S A
          join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
          join HOTEL_S H on H.ID_HOTEL = A.ID_HOTEL
          left outer join ACCOUNT_BALANCE$INT(A.ID_ACCOUNT) AB on 0=0
    where A.ID_PROFILE = :ID_PROFILE
          and (:SHOW_ARCHIVE = 1 or A.IS_ARCHIVE = 0)
    into  :ID_ACCOUNT, :ACCOUNT_CURR, :ACCOUNT_NAME, :CREDIT_LIMIT,
          :IS_CREDIT, :ID_TYPE_PAYMENT, :DEPOSIT_VALUE, :BALANCE_VALUE,
          :IS_DEFAULT, :IS_LEVEL_1, :IS_ARCHIVE, :HOTEL_NAME
  do begin
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: PROFILE_COMMON_MODIFY$INT for: PROFILE_SET_ARCHIVE$INT */
ALTER PROCEDURE PROFILE_COMMON_MODIFY$INT(ID_PROFILE INTEGER,
PROFILE_TYPE VARCHAR(20),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
IS_ARCHIVE INTEGER,
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PROFILE_SET_ARCHIVE$INT) */
ALTER PROCEDURE PROFILE_SET_ARCHIVE$INT(P_DBKEY CHAR(8),
ARCHIVE_STATUS SMALLINT)
 AS
declare variable old_is_archive smallint;
  declare variable id_profile integer;
  declare variable id_account integer;
  declare variable id_merge_profile integer;
begin
  select P.IS_ARCHIVE, P.ID_PROFILE, p.ID_MERGE_PROFILE
  from   PROFILE P
  where  P.RDB$DB_KEY = :P_DBKEY
  into   :old_is_archive, :id_profile, :id_merge_profile;
   
  if (:ARCHIVE_STATUS > :old_is_archive) then begin
    /* archive */
    if (exists (select app.ID_ACCOUNT_POST
                from   ACCOUNT_POST$PMS APP
                where  app.ID_OWNER = :id_profile
                       and app.LINE_STATUS = 11)) then
      exception PROFILE_EXCEPTION '-1050';

    for
      select A.ID_ACCOUNT
      from   ACCOUNT A
      where  A.ID_PROFILE = :id_profile
             and a.IS_ARCHIVE is distinct from 1
      into   :id_account
    do begin
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS (:id_account, 1);
    end 

  end else if (:ARCHIVE_STATUS < :old_is_archive) then begin
    /* unarchive */
    if (:id_merge_profile is not null) then exception PROFILE_EXCEPTION '-1045';

    for
      select A.ID_ACCOUNT
      from   ACCOUNT A
      where  A.ID_PROFILE = :id_profile
             and a.IS_PMS_ACCOUNT = 1
             and a.IS_ARCHIVE = 1
      into   :id_account
    do begin
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS (:id_account, 0);
    end 

  end

  update PROFILE P
  set    P.IS_ARCHIVE = :ARCHIVE_STATUS
  where  P.RDB$DB_KEY = :P_DBKEY;
   
end
^

/* Alter (RES_ACCOUNTS_RECIEVE$INT) */
ALTER PROCEDURE RES_ACCOUNTS_RECIEVE$INT(ID_RESERV_DETAIL INTEGER,
OLD_ID_BASE_ACCOUNT INTEGER,
OLD_ID_EXTRA_ACCOUNT INTEGER,
ID_AGENT_ACCOUNT_RULE INTEGER,
ID_BASE_ACCOUNT_PROFILE INTEGER,
ID_EXTRA_ACCOUNT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ID_ACC_TEMPLATE_PERSON INTEGER,
IS_SEPARATE_ACCOUNTS SMALLINT)
 RETURNS(NEW_ID_BASE_ACCOUNT INTEGER,
NEW_ID_EXTRA_ACCOUNT INTEGER)
 AS
declare variable id_acc_profile integer;
  declare variable base_account_curr varchar(3);
  declare variable base_tariff_currency char(3);
  declare variable extra_tariff_currency char(3);
  declare variable id_hotel integer;
  declare variable id_base_acc_reserv integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
begin
  id_acc_profile = null;
  select A.ID_PROFILE, A.ACCOUNT_CURR, A.ID_RESERV_DETAIL
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :old_id_base_account
  into   :id_acc_profile, :base_account_curr, :id_base_acc_reserv;

  select first 1 T.CURR, T.ID_HOTEL
  from   GUEST G
         join GUEST_STAY GS on gs.ID_GUEST = g.ID_GUEST
         join TARIFA T on T.ID_TARIFA = GS.ID_TARIFF
  where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  order by GS.FOR_DATE asc
  into   :base_tariff_currency, :id_hotel;

  if (:base_tariff_currency is null) then EXIT;

  select first 1 T.CURR
  from   TARIFA T
  where  T.IS_EXTRA = 1
         and T.ID_HOTEL = :id_hotel
  into   :extra_tariff_currency;

  if (coalesce(:id_agent_account_rule, 0) > 0) then begin
    /* get specified account */
    new_id_base_account = :id_agent_account_rule;
    execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:NEW_ID_BASE_ACCOUNT, 0);
  end else if (:id_acc_profile = :id_base_account_profile
               and :base_account_curr = :base_tariff_currency
               and :id_base_acc_reserv is not distinct from :ID_RESERV_DETAIL) then
  begin
    /* preserve old base personal account */
    new_id_base_account = :old_id_base_account;
  end else begin
    /* get new personal account */
    execute procedure PROFILE_GET_ACCOUNT$INT (:id_base_account_profile, :id_reserv_detail, 
            :base_tariff_currency, iif(:id_base_account_profile = :id_person_profile, :id_acc_template_person, null),
            1, iif(:IS_SEPARATE_ACCOUNTS = 0, 1, 0))
    returning_values (:new_id_base_account);
  end

  select ba.ACCOUNT_CURR
  from   ACCOUNT BA
  where  ba.ID_ACCOUNT = :NEW_ID_BASE_ACCOUNT
  into   :base_account_curr;

  if (:IS_SEPARATE_ACCOUNTS = 1
      and :base_account_curr = :extra_tariff_currency
      and :ID_BASE_ACCOUNT_PROFILE = :ID_EXTRA_ACCOUNT_PROFILE)
  then IS_SEPARATE_ACCOUNTS = 0;


  if (:IS_SEPARATE_ACCOUNTS = 0) then begin
    new_id_extra_account = :new_id_base_account;
    update ACCOUNT A
    set    a.IS_EXTRA = 1
    where  a.ID_ACCOUNT = :NEW_ID_EXTRA_ACCOUNT
           and a.IS_EXTRA is distinct from 1;
  end else begin
    id_acc_profile = null;
    select A.ID_PROFILE/*, A.ACCOUNT_CURR*/
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :old_id_extra_account
    into   :id_acc_profile/*, :account_curr*/;

    if (:id_acc_profile = :id_extra_account_profile /*and :account_curr = :extra_tariff_currency*/ and :old_id_extra_account is not null) then begin
      -- CHANGED after p27 -> condition {:account_curr = :extra_tariff_currency} is removed;
      -- if exists extra account by this profile, it must be preserve, independent of currency,
      -- because of unnecessary posting transfer and archiving of unused accounts (by the same profile);
      -- this can be forced with ACC_ROUTING changing (MIXED -> AGENT -> MIXED)
      new_id_extra_account = :old_id_extra_account;
    end else begin
      execute procedure PROFILE_GET_ACCOUNT$INT (:id_extra_account_profile, :id_reserv_detail,
              :extra_tariff_currency, iif(:id_extra_account_profile = :id_person_profile, :id_acc_template_person, null),
              1, 1)
      returning_values (:new_id_extra_account);
    end
  end
  /*  */
  if (:NEW_ID_BASE_ACCOUNT is distinct from :OLD_ID_BASE_ACCOUNT) then begin
    execute procedure ACCOUNT_VALIDATE$INT(:NEW_ID_BASE_ACCOUNT, 'IS_BASE')
    returning_values  :err_code, :err_text, :no_use, :no_use, :no_use, :no_use;
    if (:err_code < 0) then exception ACCOUNT_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end
  if (:NEW_ID_EXTRA_ACCOUNT is distinct from :OLD_ID_EXTRA_ACCOUNT) then begin
    execute procedure ACCOUNT_VALIDATE$INT(:NEW_ID_EXTRA_ACCOUNT, 'IS_EXTRA')
    returning_values  :err_code, :err_text, :no_use, :no_use, :no_use, :no_use;
    if (:err_code < 0) then exception ACCOUNT_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end

end
^

/* empty dependent procedure body */
/* Clear: RES_ANUL_DETAIL$INT for: RES_ARCHIVATE_ACCOUNTS$INT */
ALTER PROCEDURE RES_ANUL_DETAIL$INT(RD_DBKEY CHAR(8),
REASON VARCHAR(50),
CANCELATION_NUMBER /* TYPE OF NAME_20 */ VARCHAR(20) = null)
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_DELETE$INT for: RES_ARCHIVATE_ACCOUNTS$INT */
ALTER PROCEDURE RES_DELETE$INT(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_ARCHIVATE_ACCOUNTS$INT) */
ALTER PROCEDURE RES_ARCHIVATE_ACCOUNTS$INT(ID_RESERV_DETAIL INTEGER)
 AS
declare variable id_account integer;
begin
  for
    select RA.ID_ACCOUNT
    from   RES_GET_ACCOUNTS(:id_reserv_detail, 'BALANCE') RA
    into   :id_account
  do begin
    execute procedure ACCOUNT_BALANCE_INVALIDATE$INT (:id_account);

    execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 1);
  end

end
^

/* Alter (RES_CHECKIN$RSV) */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable old_check_status integer;
  declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable is_anul integer;
  declare variable arrival_date date;
  declare variable system_date date;
begin
  /*  Description:
  ||
  */
  select RD.CHECK_STATUS, RD.RDB$DB_KEY, RD.FROM_DATE, RD.ID_HOTEL,
         RD.ID_ROOM, RD.IS_ANUL
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_check_status, :rd_dbkey, :arrival_date, :id_hotel,
         :old_id_room, :is_anul;

  if (:is_anul = 1) then exception BOOKING_EXCEPTION '-2';

  if (:old_check_status >= 0) then exception BOOKING_EXCEPTION '-1003';

  if (:old_id_room < 0 and coalesce(:ID_ROOM, 0) <= 0) then exception BOOKING_EXCEPTION '-1018';

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date < :arrival_date) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CHECK_IN_FUTURE');
  end
  /*----*/
  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'lock');

  execute procedure sys_dbg('occ RES_CHECKIN$RSV id_room = '||coalesce(:id_room, 'null'));
  execute procedure sys_dbg('occ RES_CHECKIN$RSV old_id_room = '||coalesce(:old_id_room, 'null'));

  if (:id_room is not null) then begin
    if (:old_check_status = -3) then begin
      execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, -2);
    end

    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option);
  end

  execute procedure RES_SET_CHECKIN$INT (:rd_dbkey)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'release');
  /*----*/
  select f_character(29) || R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = coalesce(:ID_ROOM, :old_id_room)
  into   :action_text;
   
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'CHECK_IN', :action_text);

end
^

/* Alter (RES_CHECKIN_MULTI$RSV) */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable checkin_count integer;
  declare variable split_on_checkin integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
  declare variable tmp_warn_code integer;
begin
  checkin_count = 0;
  warn_code = null;
  for
    select RD.ID_RESERV_DETAIL, RD.CHECK_STATUS, RD.SPLIT_ON_CHECKIN, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :SELECTION_ID
    into   :id_reserv_detail, :check_status, :split_on_checkin, :id_titular
  do begin
    if (:check_status >= 0) then begin
      checkin_count = :checkin_count + 1;
    end else begin
      if (:split_on_checkin = 1) then begin
        for
          select G.ID_GUEST
          from   GUEST G
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and G.ID_GUEST <> :id_titular
          into   :id_guest
        do begin
          execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
          returning_values  :id_splited_reservation;

          execute procedure RES_CHECKIN$RSV (:id_splited_reservation)
          returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

          update RESERV_DETAIL RD
          set    RD.SELECTION_ID = :selection_id
          where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
        end
      end

      execute procedure RES_CHECKIN$RSV (:id_reserv_detail)
      returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
      WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end

  if (:checkin_count > 0) then begin
    execute procedure SYSTEM_WARNING_ADD(-1011, f_character(29)||:checkin_count)
    returning_values  :warn_code;
  end
end
^

/* Alter (RES_CREATE_SET$EXC) */
ALTER PROCEDURE RES_CREATE_SET$EXC(ID_RESERV_DETAIL INTEGER,
RES_NUMBER VARCHAR(62),
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER,
CREATE_DATETIME TIMESTAMP)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_RESERV_DETAIL INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  WARN_CODE = 0;
  SHARE_TRANSACTION_ID = 0;
  SHARE_ERR_CODE = 0;

  execute procedure sys_dbg('exc RES_CREATE_SET$EXC => RES_CREATE_SET$INT('
  || 'code_first_food=>' || coalesce(:code_first_food, '<null>')
  || ', id_person_payment=>' || coalesce(:id_person_payment, '<null>')
  || ')');

  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, null, :arrival_date, :departure_date,
                    :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, '', :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders, :guarantee_deposit,
                    :guarantee_currency, 0, :id_reserv_detail, :res_number, null,  :id_guarantee_policy, :block_cc,
                    :id_eating_object)
  returning_values  :rd_dbkey, :new_id_reserv_detail;

  execute procedure UPDATE_POSTING_TRANSACTION$EXC(:rd_dbkey, :posting_transaction_uuid, 1);

  execute procedure RES_SAVE_GUARANTEE$RSV(:id_reserv_detail, :is_vip, null,
    :id_guarantee_policy, :guarantee_deposit, :guarantee_currency, :block_cc, :guarantee_deposit_percent,
    :guarantee_deposit_nights, :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create
  );

  execute procedure RESERV_DETAIL_EXTERNAL_MOD$RSV(:id_reserv_detail,
    :minibar_rights, :paytv_rights, :video_rights, :nopost_pms, :phone_rights,
    :seminar_cahnnel_rights, null
  );

  if (:create_datetime is not null) then begin
    update reserv_detail set create_datetime = :create_datetime where rdb$db_key = :rd_dbkey;
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_DELETE$RSV for: RES_DELETE$INT */
ALTER PROCEDURE RES_DELETE$RSV(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESGRP_DELETE$RSV for: RES_DELETE$INT */
ALTER PROCEDURE RESGRP_DELETE$RSV(ID_GROUP INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_DELETE$INT) */
ALTER PROCEDURE RES_DELETE$INT(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable rd_dbkey char(8);
  declare variable id_guest integer;
  declare variable action_text varchar(255);
  declare variable from_date date;
  declare variable to_date date;
  declare variable room_type varchar(20);
  declare variable number varchar(62);
  declare variable tmp_extra_posts_left integer;
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_DELETE');

  select RD.RDB$DB_KEY, RD.FROM_DATE, rd.TO_DATE, RT.TYPE_ROOM, rd.NUMBER
  from   RESERV_DETAIL RD
         left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = RD.ID_ROOM_TYPE
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey, :from_date, :to_date, :room_type, :number;

  update RESERV_DETAIL R
  set    r.ID_TITULAR = null
  where  r.RDB$DB_KEY = :rd_dbkey;

  EXTRA_POSTS_LEFT = 0;
  for
    select G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_guest
  do begin
    execute procedure RES_GUEST_DEL$INT(:id_guest, :id_reserv_detail, :REASON)
    returning_values  :tmp_extra_posts_left;
    EXTRA_POSTS_LEFT = iif(:EXTRA_POSTS_LEFT = 1, 1, :tmp_extra_posts_left);
  end

  execute procedure RES_FINALIZE$INT (:RD_DBKEY, 1)
  returning_values (:warn_code);


  execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

  action_text = f_character(29) || coalesce(:number, '')
                || f_character(28) || coalesce(:room_type, '')
                || f_character(28) || :from_date
                || f_character(28) || :to_date
                || f_character(28) || :reason;
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'DELETE', :action_text);

  delete from RESERV_DETAIL RDD
  where  RDD.RDB$DB_KEY = :rd_dbkey;

  delete from XML_MESSAGE$EXC xml
  where  xml.OBJECT_TYPE = 'BOOKING'
         and xml.OBJECT_ID = :number;

end
^

/* Alter (RES_DELETE$RSV) */
ALTER PROCEDURE RES_DELETE$RSV(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT,
NEW_FROM_DATE TYPE OF TDATE)
 AS
begin

  execute procedure RES_DELETE$INT(:ID_RESERV_DETAIL, :REASON)
  returning_values :WARN_CODE, :EXTRA_POSTS_LEFT;

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;
end
^

/* empty dependent procedure body */
/* Clear: RES_EARLY_DEPARTURE_SET$RSV for: RES_FINALIZE$INT */
ALTER PROCEDURE RES_EARLY_DEPARTURE_SET$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND INTEGER)
 RETURNS(RECALC_MARKER_LIST VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_FINALIZE$RSV for: RES_FINALIZE$INT */
ALTER PROCEDURE RES_GUEST_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER,
ALL_ERRORS_ARE_INSTANT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUESTLIST_REMOVE$RSV for: RES_FINALIZE$INT */
ALTER PROCEDURE RES_GUESTLIST_REMOVE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTING$RSV for: RES_FINALIZE$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$RSV(ID_RESERV_DETAIL INTEGER,
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER,
ID_CREDIT_CARD INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_GUARANTEE$RSV for: RES_FINALIZE$INT */
ALTER PROCEDURE RES_SAVE_GUARANTEE$RSV(ID_RESERV_DETAIL INTEGER,
IS_VIP SMALLINT,
CHECK_STATUS INTEGER,
ID_GUARANTEE_POLICY INTEGER,
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_GUESTCOUNT$RSV for: RES_FINALIZE$INT */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_FINALIZE$INT) */
ALTER PROCEDURE RES_FINALIZE$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable err_text varchar(255);
begin
  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, :SUPPRESS_NON_INSTANT_ERRORS)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;
  if (:share_err_code < 0) then exception BOOKING_EXCEPTION :share_err_code || f_character(31) || :ERR_TEXT;
end
^

/* empty dependent procedure body */
/* Clear: REP_ROOM_STATUS$INT for: RES_GET_BALLANCE$INT */
ALTER PROCEDURE REP_ROOM_STATUS$INT(FOR_DATE DATE,
STAT_OPTIONS VARCHAR(255),
PRIVATE_STATUS_ADDING SMALLINT = 0)
 RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
SECTOR INTEGER,
ID_ROOM_TYPE INTEGER,
TYPE_ROOM VARCHAR(20),
IS_CLEAN INTEGER,
IS_INSPECTED INTEGER,
CLEAN_TEXT VARCHAR(30),
IS_LEAVING SMALLINT,
IS_COMMING SMALLINT,
IS_SHARED SMALLINT,
IS_LEAVING_WORDS VARCHAR(30),
BUSY_GRP INTEGER,
DAYS_THIS_STATUS INTEGER,
DTS_CONTEXT VARCHAR(10),
COMMING_OCCUPANTS VARCHAR(1024),
ID_BLOCK_ROOM INTEGER,
OTHER_OCCUPANTS VARCHAR(1024),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ID_HOTEL INTEGER,
HAS_OPENED_POSTINGS SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GET_BALLANCE$RPT for: RES_GET_BALLANCE$INT */
ALTER PROCEDURE RES_GET_BALLANCE$RPT(ID_RESERV_DETAIL INTEGER)
 RETURNS(RESERVATION_BALLANCE VARCHAR(255),
RECIEVED_DEPOSITS VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GET_BALLANCE$INT) */
ALTER PROCEDURE RES_GET_BALLANCE$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(RESERVATION_BALLANCE VARCHAR(255),
RECIEVED_DEPOSITS VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER)
 AS
declare variable account_balance numeric(15,2);
  declare variable account_curr char(3);
  declare variable dep_money_bag varchar(255);
  declare variable dep_value numeric(15,2);
  declare variable curr_display_format varchar(10);
  declare variable open_charges_int integer;
  declare variable account_curr_current char(3);
  declare variable account_balance_current numeric (15,4);
  declare variable partial_ballance integer;
  declare variable id_account integer;
  declare variable round_to numeric(15,4) ;
begin
  /*  Description:
  ||
  */
  RESERVATION_BALLANCE = '';
  RECIEVED_DEPOSITS = '';
  PARTIAL_BALLANCE = 0;
  OPEN_DEPOSIT = 0;
  OPEN_CHARGES = 0;
  HAS_CHARGES = 0;

  ACCOUNT_BALANCE = 0;
  ACCOUNT_CURR = '';

  for
    select AB.ACCOUNT_CURR, AB.CURR_DISPLAY_FORMAT, AB.ACCOUNT_BALANCE, AB.OPEN_CHARGES,
           AB.DEP_VALUE, AB.DEP_MONEY_BAG, RA.ID_ACCOUNT
    from   RES_GET_ACCOUNTS(:ID_RESERV_DETAIL, 'BALANCE') RA
           left outer join ACCOUNT_BALANCE$INT(RA.ID_ACCOUNT) AB on 0=0
    union all
    select 'ZZZ', null, null, null,
           null, null, null
    from   RDB$DATABASE
    order by 1 asc
    into   :ACCOUNT_CURR_CURRENT, :CURR_DISPLAY_FORMAT, :ACCOUNT_BALANCE_CURRENT, :OPEN_CHARGES_INT,
           :DEP_VALUE, :DEP_MONEY_BAG, :ID_ACCOUNT
  do begin
    if ((:ACCOUNT_CURR_CURRENT <> 'ZZZ') and (not exists(
      select *
      from   ACCOUNT_S A
      where  A.ID_ACCOUNT = :ID_ACCOUNT
    ))) then PARTIAL_BALLANCE = 1;
    else begin
      if (:ACCOUNT_CURR_CURRENT = :ACCOUNT_CURR) then begin
        ACCOUNT_BALANCE = :ACCOUNT_BALANCE + :ACCOUNT_BALANCE_CURRENT;
      end else begin
        select c.ROUND_TO
        from   currs c
        where  c.CURR = :ACCOUNT_CURR_CURRENT
        into   :round_to;

        if (round_f(:ACCOUNT_BALANCE, :round_to) <> 0) then begin
          if (:RESERVATION_BALLANCE = '') then RESERVATION_BALLANCE = formatfloat (:ACCOUNT_BALANCE, :CURR_DISPLAY_FORMAT) ||' '|| :ACCOUNT_CURR;
          else RESERVATION_BALLANCE = :RESERVATION_BALLANCE ||', '||formatfloat (:ACCOUNT_BALANCE, :CURR_DISPLAY_FORMAT) ||' '|| :ACCOUNT_CURR;
        end
  
        ACCOUNT_BALANCE = :ACCOUNT_BALANCE_CURRENT;
        ACCOUNT_CURR = :ACCOUNT_CURR_CURRENT;
      end
  
      if (:ACCOUNT_CURR_CURRENT <> 'ZZZ') then begin
        if (:OPEN_CHARGES_INT = 1) then OPEN_CHARGES = 1;
        if (:DEP_VALUE > 0) then OPEN_DEPOSIT = 1;

        if (:RECIEVED_DEPOSITS = '') then RECIEVED_DEPOSITS = :DEP_MONEY_BAG;
        else if (:DEP_MONEY_BAG <> '') then RECIEVED_DEPOSITS = :RECIEVED_DEPOSITS || :DEP_MONEY_BAG;
      end
    end

    if (:HAS_CHARGES = 0) then begin
      if (:OPEN_CHARGES = 1) then HAS_CHARGES = 1;
      else if (exists (select ap.ID_ACCOUNT_POST
                       from   ACCOUNT_POST AP
                       where  ap.ID_ACCOUNT = :ID_ACCOUNT)) then HAS_CHARGES = 1;
    end
  end

  if (:PARTIAL_BALLANCE = 1) then RESERVATION_BALLANCE = :RESERVATION_BALLANCE || ' xxx';
end
^

/* Alter (RES_GET_BALLANCE$RPT) */
ALTER PROCEDURE RES_GET_BALLANCE$RPT(ID_RESERV_DETAIL INTEGER)
 RETURNS(RESERVATION_BALLANCE VARCHAR(255),
RECIEVED_DEPOSITS VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER)
 AS
begin
  execute procedure RES_GET_BALLANCE$INT (:ID_RESERV_DETAIL)
  returning_values  (:RESERVATION_BALLANCE, :RECIEVED_DEPOSITS, :HAS_CHARGES, :OPEN_CHARGES, :OPEN_DEPOSIT);

  suspend;
end
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_ADD$RSV for: RES_GUEST_ADD$INT */
ALTER PROCEDURE RES_GUEST_ADD$RSV(ID_RESERV_DETAIL INTEGER,
IS_CHILD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_GUEST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUESTCOUNT_ADD$INT for: RES_GUEST_ADD$INT */
ALTER PROCEDURE RES_GUESTCOUNT_ADD$INT(RD_DBKEY CHAR(8),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_GUEST_ADD$INT) */
ALTER PROCEDURE RES_GUEST_ADD$INT(RD_DBKEY CHAR(8),
IS_CHILD INTEGER)
 RETURNS(NEW_ID_GUEST INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable pd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable check_status integer;

  declare variable from_date date;
  declare variable to_date date;
  declare variable id_room integer;
  declare variable id_agent integer;
  declare variable id_tarrif integer;
  declare variable guest_name varchar(100);
  declare variable country_code varchar(10);
  declare variable guest_status varchar(50);
  declare variable default_mask varchar(50);
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable id_titular integer;
  declare variable id_profile_data integer;
  declare variable id_person_data integer;
  declare variable id_base_account integer;
  declare variable id_extra_account integer;
  declare variable id_hotel integer;
begin
  select RD.FROM_DATE, RD.TO_DATE, RD.ID_ROOM, PA.ID_AGENT, RD.ID_RATE,
         RD.ID_RESERV_DETAIL, RD.ID_TITULAR, PP.ID_PERSON_DATA,
         RD.CHECK_STATUS, RD.ADULT_COUNT, RD.CHILD_COUNT, RD.COUNTRY,
         rd.ID_BASE_ACCOUNT, rd.ID_EXTRA_ACCOUNT, rd.ID_HOTEL
  from   RESERV_DETAIL RD
         left outer join PROFILE_PERSON PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
         left outer join PROFILE_AGENT PA on PA.ID_PROFILE = RD.ID_AGENT_PROFILE
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :from_date, :to_date, :id_room, :id_agent, :id_tarrif,
         :id_reserv_detail, :id_titular, :id_profile_data,
         :check_status, :adult_count, :child_count, :country_code,
         :id_base_account, :id_extra_account, :id_hotel;

  if (:check_status < 0) then begin
    guest_status = '';
    check_status = -2;
  end else if (:check_status = 0) then begin
    guest_status = 'CHECKING_IN';
  end else begin  /* checked out */
    exception BOOKING_EXCEPTION '-1032';
    -- guest_status = '';
  end


  new_id_guest = gen_id (id_guest_gen, 1);
  insert into GUEST (ID_GUEST, ID_BASE_ACCOUNT, ID_ACCOUNT, FROM_DATE, TO_DATE, ID_ROOM, ID_AGENT, ID_TARIFA,
         ID_RESERV_DETAIL, IS_CHILD, CHECK_STATUS, GUEST_EDIT_STATUS)
  values (:new_id_guest,  :id_base_account, :id_extra_account, :from_date, :to_date, :id_room, :id_agent, :id_tarrif,
         :id_reserv_detail, :is_child, -2, :guest_status)
  returning RDB$DB_KEY into :g_dbkey;

  execute procedure sys_dbg('res RES_GUEST_ADD$INT new_id_guest = '||coalesce(:new_id_guest, 'null'));

  insert into GUEST_CHANGE_STATUS (ID_GUEST, FROM_DATE_ORIG, TO_DATE_ORIG)
  values (:new_id_guest, :from_date, :to_date);
--  execute procedure SETINGS_GET_VALUE(-1, '')
--  returning_values  :default_age; TODO
  if (:is_child = 1) then begin
    child_count = :child_count + 1;
    guest_name = '-';
--    guest_name = 'Child '||:child_count;
  end else begin
    adult_count = :adult_count + 1;
    guest_name = '-';
--    guest_name = 'Adult '||:adult_count;
  end

  if (:id_titular is null) then begin
    id_titular = :new_id_guest;
    id_person_data = :id_profile_data;
  end else begin
    execute procedure SETTING_GET_VALUE('DEF_GUEST_MASK', :id_hotel)
    returning_values  :default_mask;

    id_person_data = gen_id(GEN_PERSON_DATA_ID, 1);
    insert into PERSON_DATA (ID_PERSON_DATA, MASK) --TODO some default values KPP?!
    values (:id_person_data, :default_mask)
    returning RDB$DB_KEY into :pd_dbkey;

  end

  insert into GUEST_DATA (ID_GUEST, ID_PERSON_DATA) --TODO some default values KPP?!
  values (:new_id_guest, :id_person_data);

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name, :guest_name, coalesce(:country_code, ''),
          :is_child, null, null, null);

  execute procedure RES_GUEST_AUTO$INT(:g_dbkey, :rd_dbkey, 1);

  update RESERV_DETAIL RD
  set    RD.ADULT_COUNT = :adult_count,
         RD.CHILD_COUNT = :child_count,
         RD.ID_TITULAR = :id_titular
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SET_EDIT_STATUS$INT (:RD_DBKEY, 'ADDGUEST', 'add');

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, :check_status);

end
^

/* Alter (RES_GUEST_ADD$RSV) */
ALTER PROCEDURE RES_GUEST_ADD$RSV(ID_RESERV_DETAIL INTEGER,
IS_CHILD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_GUEST INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable action_text varchar(255);
begin
  warn_code = 0;
  err_code = 0;
  err_text = '';

  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey;

  execute procedure RES_GUEST_ADD$INT(:rd_dbkey, :IS_CHILD)
  returning_values  :NEW_ID_GUEST;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :NEW_ID_GUEST
  into   :ACTION_TEXT;
   
  ACTION_TEXT = F_CHARACTER(29) || '"' || :ACTION_TEXT || '" (' || :NEW_ID_GUEST || ')';
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_GUEST_ADD', :ACTION_TEXT);

end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_FINALIZE$RSV for: RES_GUEST_FINALIZE$RSV */
ALTER PROCEDURE RES_SAVE_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_RESERV_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GUEST_FINALIZE$RSV) */
ALTER PROCEDURE RES_GUEST_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER,
ALL_ERRORS_ARE_INSTANT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, iif (:all_errors_are_instant = 1, 0, 1))
  returning_values  :warn_code;

end
^

/* Alter (RES_GUEST_SAVE$RSV) */
ALTER PROCEDURE RES_GUEST_SAVE$RSV(ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
GUEST_NAME1 VARCHAR(100),
AGE INTEGER,
BIRTH_DAY DATE,
IS_CHILD INTEGER,
COUNTRY_CODE VARCHAR(10) = NULL)
 RETURNS(NEW_ID_GUEST INTEGER)
 AS
declare variable g_dbkey char(8);
  declare variable pd_dbkey char(8);
begin
  /*  Description:
  ||
  */
  if (:id_guest is null) then begin
    -- get first anonnimous guest (check_status = -2  ?!)
    select first 1 PD.RDB$DB_KEY, G.RDB$DB_KEY, coalesce(:country_code, PD.COUNTRY_CODE),
           G.ID_GUEST
    from   GUEST G
           join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
           join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
           and G.CHECK_STATUS = -2
           and G.IS_CHILD = :IS_CHILD
    order by G.ID_GUEST asc
    into   :pd_dbkey, :g_dbkey, :country_code,
           :new_id_guest;
  end else begin
    new_id_guest = :id_guest;
    select G.RDB$DB_KEY, PD.RDB$DB_KEY, coalesce(:country_code, PD.COUNTRY_CODE)
    from   GUEST G
           join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
           join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
    where  G.ID_GUEST = :id_guest
    into   :g_dbkey, :pd_dbkey, :country_code;
  end

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name1, null,
          :country_code, :is_child, :age, :birth_day, null);

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -1);

end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_GUESTCOUNT$INT for: RES_GUESTCOUNT_ADD$INT */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$INT(RD_DBKEY CHAR(8),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_GUESTCOUNT_ADD$INT) */
ALTER PROCEDURE RES_GUESTCOUNT_ADD$INT(RD_DBKEY CHAR(8),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 AS
declare variable i integer;
  declare variable is_child integer;
  declare variable new_id_guest integer;
begin
  i = 1;
  while (:i <= (coalesce(:adult_count, 0) + coalesce(:child_count, 0))) do begin
    if (:i <= :adult_count) then is_child = 0;
    else is_child = 1;

    execute procedure RES_GUEST_ADD$INT(:rd_dbkey, :is_child)
    returning_values  :new_id_guest;
    i = :i + 1;

  end
end
^

/* Alter (RES_GUESTLIST_REMOVE$RSV) */
ALTER PROCEDURE RES_GUESTLIST_REMOVE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable g_dbkey char(8);
  declare variable rd_dbkey char(8);
begin
  /*  Description:
  ||
  */

  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  for
    select G.RDB$DB_KEY
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :g_dbkey
  do begin
    execute procedure RES_GUEST_AUTO$INT(:g_dbkey, :rd_dbkey, 0);
  end

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
  returning_values  :WARN_CODE;

end
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE_RECALC$INT for: RES_RECALC$INT */
ALTER PROCEDURE RES_FINALIZE_RECALC$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_RECALC$RSV for: RES_RECALC$INT */
ALTER PROCEDURE RES_RECALC$RSV(ID_RESERV_DETAIL INTEGER,
FORCE_POSTING SMALLINT = null)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_RECALC$INT) */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable num_prefix varchar(20);
  declare variable number_1 varchar(20);
begin
  /* CALLER_KIND = {NORMAL, FORCED} */
  err_code = 0;

  /* 1. GET DATA */
  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL, rd.NUMBER_1
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :check_status, :id_reserv_detail, :number_1;

  if (:check_status = 1) then begin
    -- CHECKED OUT
    select sn.LEADING_PART
    from   SYSTEM_NUMERATOR SN
    where  sn.ID_NUMERATOR = 0
    into   :num_prefix;

    if (trim('.' from coalesce(:num_prefix, '')) = coalesce(:number_1, '')) then
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_MINE');
    else
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_ELSE');

    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :id_guest
    do begin
      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'MANUAL_EDIT_DATA', '');
    end
  end
  /* 2. FIND DEPENDANT GUESTS AND THEIR TARIFFS */
  execute procedure sys_dbg('calc RES_RECALC$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

  id_tar_calc = gen_id(gen_id_tar_calc, 1);
  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NONE');

  execute procedure TAR_CALC_EVAL_ALL$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  -- 3. UPDATE ROOM PRICE and REPOST ALL AFFECTED BOOKINGS
  execute procedure RES_TAR_CALC_FINALIZE$INT (:ERR_CODE, :ID_TAR_CALC, :RD_DBKEY, :CALLER_KIND, :FORCE_POSTING);

end
^

/* Alter (RES_RECALC$RSV) */
ALTER PROCEDURE RES_RECALC$RSV(ID_RESERV_DETAIL INTEGER,
FORCE_POSTING SMALLINT = null)
 AS
declare variable id_tar_calc integer;
declare variable err_text varchar(255);
  declare variable err_code integer;
  declare variable rd_dbkey char(8);
begin
  -- FORCED, user activated recalculation
  execute procedure RIGHTS_CHECK_GRANTED$INT ('GUEST_RECALC_POST');

  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_RECALC$INT(:rd_dbkey, 'FORCED', :FORCE_POSTING)
  returning_values  :err_code, :err_text, :id_tar_calc;
  if (:err_code < 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'FORCED_RECALC', null);

end
^

/* empty dependent procedure body */
/* Clear: RES_ROOM_REMOVE$RSV for: RES_ROOM_REMOVE$INT */
ALTER PROCEDURE RES_ROOM_REMOVE$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESERVS_EXPIRE$INT for: RES_ROOM_REMOVE$INT */
ALTER PROCEDURE RESERVS_EXPIRE$INT(CLEAR_TODATE DATE,
ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_ROOM_REMOVE$INT) */
ALTER PROCEDURE RES_ROOM_REMOVE$INT(RD_DBKEY CHAR(8))
 RETURNS(WARN_CODE INTEGER)
 AS
begin

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, null, null, 'nrttAsIs');

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 0)
  returning_values  :WARN_CODE;

end
^

/* Alter (RES_ROOM_REMOVE$RSV) */
ALTER PROCEDURE RES_ROOM_REMOVE$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable tmp_warn_code integer;
begin

  warn_code = null;

  for
    select RD.RDB$DB_KEY
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
           and RD.IS_ANUL = 0
    into   :rd_dbkey
  do begin
    execute procedure RES_ROOM_REMOVE$INT (:rd_dbkey)
    returning_values (:tmp_warn_code);
    WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
  end

end
^

/* Alter (RES_SAVE_ACC_ARCHIVE$INT) */
ALTER PROCEDURE RES_SAVE_ACC_ARCHIVE$INT(ACCOUNTS_FOR_ARCHIVE VARCHAR(2000),
ID_PROFILE INTEGER)
 AS
declare variable id_account integer;
  declare variable old_id_profile integer;
  declare variable is_used integer;
  declare variable errtxt_acc_name varchar(50);
  declare variable errtxt_prof_name varchar(100);
begin
  /*  Description:
  ||
  */
  for
    select ITEM
    from   SYSTEM_STRING_PARSER(:accounts_for_archive, ',')
    into   :id_account                                 
  do begin
    select A.ID_PROFILE
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :old_id_profile;

    execute procedure sys_dbg('acc RES_SAVE_ACC_ARCHIVE$INT old_id_profile = '||coalesce(:old_id_profile, 'null'));
    execute procedure sys_dbg('acc RES_SAVE_ACC_ARCHIVE$INT id_profile = '||coalesce(:id_profile, 'null'));

    execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 1);
    execute procedure sys_dbg('acc RES_SAVE_ACC_ARCHIVE$INT id_account = '||coalesce(:id_account, 'null'));

    if (:old_id_profile is distinct from :id_profile) then begin
      execute procedure ACCOUNT_USE_CHECK$INT(:id_account)
      returning_values  :is_used;
      if (:is_used = 0) then
        delete from ACCOUNT A
        where  A.ID_ACCOUNT = :id_account;
    end

    when exception ACCOUNT_EXCEPTION do begin
      -- catch the exception raised from archivate procedure (err_code = -44)
      select A.ACCOUNT_NAME
      from   ACCOUNT A
      where  A.ID_ACCOUNT = :id_account
      into   :errtxt_acc_name;
  
      select P.PROFILE_NAME
      from   PROFILE P
      where  P.ID_PROFILE = :old_id_profile
      into   :errtxt_prof_name;
      -- override error code with most concrete
      exception ACCOUNT_EXCEPTION '-1009' || f_character(31) || '' || f_character(29)||:errtxt_acc_name||f_character(28)||:errtxt_prof_name;
    end

  end
end
^

/* Alter (RES_SAVE_ACCOUNTING$RSV) */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$RSV(ID_RESERV_DETAIL INTEGER,
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER,
ID_CREDIT_CARD INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);


begin
  /* Description : ACC_ROUTING = {GUEST, AGENT, MIXED, OWNER,  }
  ||
  */
  select rd.RDB$DB_KEY
  from   RESERV_DETAIL rd
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SAVE_ACCOUNTING$INT(:rd_dbkey, :id_agent_profile, :id_agent_account, :acc_routing,
                    :id_person_payment, :id_agent_payment, :id_group);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
  returning_values  :warn_code;

  --
end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTING$INT for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SAVE_ACCOUNTS$INT) */
ALTER PROCEDURE RES_SAVE_ACCOUNTS$INT(RD_DBKEY CHAR(8))
 AS
declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable old_id_base_account integer;
  declare variable old_id_extra_account integer;
  declare variable new_id_base_account integer;
  declare variable new_id_extra_account integer;
  declare variable acc_routing varchar(30);
  declare variable is_sep_accounts integer;
  declare variable id_base_account_profile integer;
  declare variable id_extra_account_profile integer;
  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable id_agent_account_rule integer;
  declare variable id_acc_template_person integer;
  declare variable id_guest integer;
  declare variable id_hotel integer;
begin

  select RD.ID_RESERV_DETAIL, RD.ID_PERSON_PROFILE, RD.ID_ACC_TEMPLATE_PERSON,
         RD.ACC_ROUTING, RD.ID_BASE_ACCOUNT, RD.ID_EXTRA_ACCOUNT,
         RD.ID_AGENT_PROFILE, RD.ID_AGENT_ACCOUNT_RULE, rd.id_hotel
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :RD_DBKEY
  into   :id_reserv_detail, :id_person_profile, :id_acc_template_person,
         :acc_routing, :old_id_base_account, :old_id_extra_account,
         :id_agent_profile, :id_agent_account_rule, :id_hotel;

  id_agent_account_rule = nullif(:id_agent_account_rule, -1);
  /* --- new */
  execute procedure SETTING_GET_VALUE ('SEPARATE_ACCOUNTS_PER_PAYER', :id_hotel)
  returning_values (:IS_SEP_ACCOUNTS);

  NEW_ID_BASE_ACCOUNT = null; --:old_id_base_account;
  NEW_ID_EXTRA_ACCOUNT = null; --:old_id_extra_account;

  /* identify profiles for base and extra account */
  if (:ACC_ROUTING in ('MIXED')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else if (:ACC_ROUTING in ('AGENT')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
  end else if (:ACC_ROUTING in ('FULL_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = null;
    IS_SEP_ACCOUNTS = 0;  -- never
  end else if (:ACC_ROUTING in ('PART_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else begin -- if (:acc_routing in ('GUEST', 'OWNER'))
    ID_BASE_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_AGENT_ACCOUNT_RULE = null;
  end

  execute procedure RES_ACCOUNTS_RECIEVE$INT (:ID_RESERV_DETAIL, :old_id_base_account, :old_id_extra_account,
          :id_agent_account_rule, :id_base_account_profile, :id_extra_account_profile, :id_person_profile,
          :id_acc_template_person, :is_sep_accounts)
  returning_values (:new_id_base_account, :new_id_extra_account);

--  if (:new_id_base_account is null) then exception WRONG_VALUE 'Invalid base account!';
--  if (:new_id_extra_account is null) then exception WRONG_VALUE 'Invalid extra account!';
  if ((:old_id_base_account is distinct from :new_id_base_account)
       or (:old_id_extra_account is distinct from :new_id_extra_account)) then
  begin
    update RESERV_DETAIL RD
    set    RD.ID_BASE_ACCOUNT = :new_id_base_account,
           RD.ID_EXTRA_ACCOUNT = :new_id_extra_account
    where  RD.RDB$DB_KEY = :RD_DBKEY;
    /* end --- */
    for
      select G.RDB$DB_KEY, g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
             and G.CHECK_STATUS < 1
      into   :G_DBKEY, :id_guest
    do begin
      update GUEST G
      set    G.ID_BASE_ACCOUNT = :new_id_base_account,
             G.ID_ACCOUNT = :new_id_extra_account
      where  G.RDB$DB_KEY = :G_DBKEY;

      execute procedure GUEST_REROUTE_POSTINGS$INT(:id_guest, :new_id_base_account, :new_id_extra_account);
    end

    -- Log account changes
    execute procedure RES_SAVE_ACCOUNTS_FINALIZE$INT(:id_reserv_detail, :old_id_base_account, :old_id_extra_account,
            :new_id_base_account, :new_id_extra_account);
  end

end
^

/* Alter (RES_SAVE_ACCOUNTS_FINALIZE$INT) */
ALTER PROCEDURE RES_SAVE_ACCOUNTS_FINALIZE$INT(ID_RESERV_DETAIL INTEGER,
OLD_ID_BASE_ACCOUNT INTEGER,
OLD_ID_EXTRA_ACCOUNT INTEGER,
NEW_ID_BASE_ACCOUNT INTEGER,
NEW_ID_EXTRA_ACCOUNT INTEGER)
 AS
declare variable id_old_account integer;
  declare variable action_text varchar(255);
  declare variable acc_name varchar(50);
  declare variable is_used integer;
begin
  if (:NEW_ID_BASE_ACCOUNT is distinct from :OLD_ID_BASE_ACCOUNT) then begin
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :OLD_ID_BASE_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = F_CHARACTER(29) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:OLD_ID_BASE_ACCOUNT, '')  || ')';
    ACC_NAME = null;
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :NEW_ID_BASE_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = :ACTION_TEXT || F_CHARACTER(28) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:NEW_ID_BASE_ACCOUNT, '')  || ')';

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_MOD_BASE_ACCOUNT', :ACTION_TEXT);
  end

  ACTION_TEXT = '';
  ACC_NAME = null;
  if (:NEW_ID_EXTRA_ACCOUNT is distinct from :OLD_ID_EXTRA_ACCOUNT) then begin
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :OLD_ID_EXTRA_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = F_CHARACTER(29) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:OLD_ID_EXTRA_ACCOUNT, '')  || ')';
    ACC_NAME = null;
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :NEW_ID_EXTRA_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = :ACTION_TEXT || F_CHARACTER(28) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:NEW_ID_EXTRA_ACCOUNT, '')  || ')';

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_MOD_EXTRA_ACCOUNT', :ACTION_TEXT);
  end

  -- Archivate old unused accounts
  for
    select A.ID_ACCOUNT
    from   ACCOUNT_S A
    where  A.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
           and A.IS_ARCHIVE = 0
           and A.ID_ACCOUNT <> :NEW_ID_BASE_ACCOUNT
           and A.ID_ACCOUNT <> :NEW_ID_EXTRA_ACCOUNT
           and A.IS_CREDIT_ACCOUNT = 0
           and not exists(select G.ID_GUEST
                          from   GUEST G
                          where  (G.ID_BASE_ACCOUNT = A.ID_ACCOUNT)
                                 or (G.ID_ACCOUNT = A.ID_ACCOUNT))
    into   :ID_OLD_ACCOUNT
  do begin
    select auc.is_used
    from   ACCOUNT_USE_CHECK$INT(:id_old_account) auc
    into   :is_used;

    if (:is_used = 0) then begin
      delete from ACCOUNT A
      where  a.ID_ACCOUNT = :id_old_account;
    end else begin
      -- cannot be deleted, because of available postings,corrections or payments (deposits)
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS (:ID_OLD_ACCOUNT, 1);
  
      when exception ACCOUNT_EXCEPTION do post_event 'dummy';
    end
  end 
end
^

/* Alter (RES_SAVE_FINALIZE$RSV) */
ALTER PROCEDURE RES_SAVE_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_RESERV_DATE TYPE OF TDATE)
 AS
declare variable rd_dbkey char(8);
  declare variable busy_group_source integer;
  declare variable res_edit_status varchar(255);
  declare variable err_code integer;
  declare variable tmp_err_text varchar(255);
  declare variable id_hotel integer;
begin
  execute procedure sys_dbg('occ RES_SAVE_FINALIZE$RSV enter');

  select RD.RDB$DB_KEY, iif(RD.CHECK_STATUS = 1, 24, 1), rd.RES_EDIT_STATUS, rd.ID_HOTEL
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :busy_group_source, :res_edit_status, :id_hotel;

  if (:res_edit_status containing 'ADDGUEST') then begin
    execute procedure RES_GUEST_FINALIZE$RSV (:ID_RESERV_DETAIL, 0)
    returning_values (:warn_code);

  end

  execute procedure OCCUPANCY_ROOM$INT(:rd_dbkey, :busy_group_source)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :WARN_CODE;
  --if (:share_err_code <> 0) then err_code = 0;      -- offer share entering
  --if (:share_err_code = 1) then share_err_code = 0; -- all shares are known

  execute procedure sys_dbg('occup RES_SAVE_FINALIZE$RSV share_err_code = '||coalesce(:share_err_code, 'null'));

  execute procedure RES_FINALIZE_CLEAR$INT(:rd_dbkey, :id_reserv_detail);

  delete from RESERV_STAY$TMP t
  where  t.id_session = RDB$GET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION', null);  -- Excplicitly set to null !!!

  err_code = 0;
  select first 1 RE.ERR_CODE, RE.ERR_TEXT
  from   RESERV_ERROR RE
  where  RE.ID_RESERV_DETAIL = :id_reserv_detail
  into   :err_code, :tmp_err_text;

  if (:err_code <> 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || :tmp_err_text;

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :NEW_RESERV_DATE;
end
^

/* Alter (RES_SAVE_GUARANTEE$RSV) */
ALTER PROCEDURE RES_SAVE_GUARANTEE$RSV(ID_RESERV_DETAIL INTEGER,
IS_VIP SMALLINT,
CHECK_STATUS INTEGER,
ID_GUARANTEE_POLICY INTEGER,
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER)
 AS
declare variable old_check_status integer;
declare variable warn_code integer;
declare variable rd_dbkey char(8);
declare variable action_text varchar(255);
begin
  /*  Description:
  ||  GUI facade
  */
  select RD.RDB$DB_KEY, rd.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_check_status;

  update RESERV_DETAIL RDU
  set    RDU.IS_VIP = coalesce(:is_vip, RDU.IS_VIP),
         RDU.ID_GUARANTEE_POLICY = :id_guarantee_policy,
         RDU.GUARANTEE_DEPOSIT = :guarantee_deposit,
         RDU.GUARANTEE_CURRENCY = :guarantee_currency,
         RDU.BLOCK_CC = :BLOCK_CC,
         GUARANTEE_DEPOSIT_PERCENT = :GUARANTEE_DEPOSIT_PERCENT,
         GUARANTEE_DEPOSIT_NIGHTS = :GUARANTEE_DEPOSIT_NIGHTS,
         GUARANTEE_DUE_DAYS_BEF_ARRIVAL = :GUARANTEE_DUE_DAYS_BEF_ARRIVAL,
         GUARANTEE_DUE_DAYS_AFTER_CREATE = :GUARANTEE_DUE_DAYS_AFTER_CREATE
  where  RDU.RDB$DB_KEY = :rd_dbkey;

  action_text = '';
  if (:GUARANTEE_DEPOSIT_PERCENT is not null) then begin
    action_text = f_character(29) || '@{caption.guaranteetype.percent} ' || formatfloat(:GUARANTEE_DEPOSIT_PERCENT, '0.00') || f_character(28)
                  || '[' || coalesce(:GUARANTEE_DUE_DAYS_AFTER_CREATE, ' ') || ']'
                  || f_character(28) || '[' || coalesce(:GUARANTEE_DUE_DAYS_BEF_ARRIVAL, ' ') || ']';
  end
  else if (:GUARANTEE_DEPOSIT_NIGHTS is not null) then begin
    action_text = f_character(29) || '@{caption.guaranteetype.nights} ' || :GUARANTEE_DEPOSIT_NIGHTS || f_character(28)
                  || '[' || coalesce(:GUARANTEE_DUE_DAYS_AFTER_CREATE, ' ') || ']'
                  || f_character(28) || '[' || coalesce(:GUARANTEE_DUE_DAYS_BEF_ARRIVAL, ' ') || ']';
  end
  else if (:GUARANTEE_DEPOSIT is not null) then begin
    action_text = f_character(29) || '@{caption.guaranteetype.fixed} ' || formatfloat(:GUARANTEE_DEPOSIT, '0.00') || ' ' || :GUARANTEE_CURRENCY || f_character(28)
                  || '[' || coalesce(:GUARANTEE_DUE_DAYS_AFTER_CREATE, ' ') || ']'
                  || f_character(28) || '[' || coalesce(:GUARANTEE_DUE_DAYS_BEF_ARRIVAL, ' ') || ']';
  end

  if (:action_text <> '') then begin
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_GUARANTEE_CHANGED', :action_text);
  end

  CHECK_STATUS = coalesce(:CHECK_STATUS, :old_check_status);
  if (:CHECK_STATUS <> :old_check_status) then begin

    if (:CHECK_STATUS >= 0) then exception BOOKING_EXCEPTION 'Can not set status ''CHECKED IN'' or ''CHECKED OUT'' manually!';

    execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, :check_status);

    execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
    returning_values  :warn_code;
  end
end
^

/* Alter (RES_SAVE_GUESTCOUNT$INT) */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$INT(RD_DBKEY CHAR(8),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 AS
declare variable old_adult_count integer;
  declare variable old_child_count integer;
  declare variable add_adult_count integer;
  declare variable add_child_count integer;
  declare variable del_adult_count integer;
  declare variable del_child_count integer;
begin

  if (((:adult_count + :child_count) <= 0) or (:adult_count < 0) or (:child_count < 0)) then begin
    exception BOOKING_EXCEPTION '-1005' || f_character(31) || f_character(29) || :adult_count || f_character(28) || :child_count;
  end

  select RD.ADULT_COUNT, RD.CHILD_COUNT
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_adult_count, :old_child_count;
  add_adult_count = 0;
  add_child_count = 0;
  del_adult_count = 0;
  del_child_count = 0;
  if (:old_adult_count < :adult_count) then add_adult_count = adult_count - :old_adult_count;
  else del_adult_count = :old_adult_count - :adult_count;
  if (:old_child_count < :child_count) then add_child_count = child_count - :old_child_count;
  else del_child_count = :old_child_count - :child_count;

  execute procedure RES_GUESTCOUNT_ADD$INT(:rd_dbkey, :add_adult_count, :add_child_count);

  execute procedure RES_GUESTCOUNT_DEL$INT(:rd_dbkey, :del_adult_count, :del_child_count);
end
^

/* Alter (RES_SAVE_GUESTCOUNT$RSV) */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select rd.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  rd.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SAVE_GUESTCOUNT$INT(:rd_dbkey, :adult_count, :child_count);

  execute procedure RES_SAVE_ACCOUNTS$INT (:rd_dbkey);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 0)
  returning_values  :warn_code;

end
^

/* Alter (RES_SAVE_ROOM$EXC) */
ALTER PROCEDURE RES_SAVE_ROOM$EXC(RD_DBKEY CHAR(8),
ID_RES_ROOM_TYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(250),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_room integer;
begin
  select RD.ID_ROOM, RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_room, :id_reserv_detail;

  execute procedure RES_SAVE_ROOM$RSV(
    :id_reserv_detail,
    :old_id_room,
    :id_res_room_type,
    'nrttAsIs',
    1,
    :id_hk_plan,
    :room_features,
    :i_special_treatment,
    :split_on_checkin,
    0
  ) returning_values :share_err_code, :err_text, :share_transaction_id, :warn_code;
end
^

/* Alter (RES_TAR_CALC_FINALIZE$INT) */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(TAR_CALC_ERR INTEGER,
ID_TAR_CALC INTEGER,
RD_DBKEY_INIT CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
begin
  /*  Description:
  ||  Razpiswa cenata na staia, kakto i price_detailite.
      Za4istwa temp tablicite
  */
  --savedbg('TAR_CALC_ERR: ' || :TAR_CALC_ERR);
  --savedbg('ID_TAR_CALC: ' || :ID_TAR_CALC);
  if (:tar_calc_err = 0) then begin
    room_price = 0;
    room_price_details = '';

    execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

    for
      select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, rd.IS_POSTING_STOPPED,
             coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
             coalesce(max((select first 1 AP.IS_BASE
                           from   GUEST G
                                  join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                           where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                  and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (eventually)
      from   TAR_CALC_INPUT$TMP TI
             join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
             join TARIFA t on t.ID_TARIFA = rd.ID_RATE
      where  ti.ID_TAR_CALC = :ID_TAR_CALC
      group by 1, 2, 3, 4, 5, 6
      into   :id_reserv_detail, :check_status, :is_posting_stopped,
             :room_currency, :id_hotel, :is_anul, :has_postings
    do begin
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);

      if ( (not (:is_posting_stopped = 1 and :has_postings = 0))                                -- posting is not stopped
           and                                                                                  -- and
           ( (coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1) ) -- there are reasons to repost
         ) then
      begin

        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);

      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;

        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end

      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end else begin

    update RESERV_DETAIL RD
    set    RD.ROOM_PRICE = null,
           RD.ROOM_CURRENCY = null,
           RD.ROOM_PRICE_DETAILS = null,
           RD.LAST_ID_TAR_CALC = null
    where  RD.RDB$DB_KEY = :RD_DBKEY_INIT;
  end
  
  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;
end
^

/* Alter (RESERVS_EXPIRE$INT) */
ALTER PROCEDURE RESERVS_EXPIRE$INT(CLEAR_TODATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable day_keep_number integer;
  declare variable rd_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable nouse integer;
  declare variable day_keep_types integer;
begin
  /*AA NA IONEA I?AAE I?EEE??AAIA -BF END WORK-*/
  execute procedure SETTING_GET_VALUE('DAY_KEEP_NUMBERS', :ID_HOTEL)
  returning_values  :day_keep_number;
  /*************************************************************/
  /*    REMOVE ROOM NUMBERS FROM EXPIRED RESERV DETAILS        */
  /*************************************************************/
  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.IS_ANUL = 0
           and RD.CHECK_STATUS < 0
           and RD.IS_VIP = 0
           and RD.ID_ROOM > 0
           and (RD.FROM_DATE <=  cast(:clear_todate - :day_keep_number as date))
    into   :rd_dbkey, :id_reserv_detail
  do begin
    execute procedure RES_ROOM_REMOVE$INT(:rd_dbkey)
    returning_values  :nouse;

    when any do begin
      -- nothing
    end
  end
  /*************************************************************/
  /*    EXPIRED NON VIP or VIP TYPES                           */
  /*************************************************************/
  execute procedure SETTING_GET_VALUE('DAY_KEEP_TYPES', :ID_HOTEL)
  returning_values  :day_keep_types;

  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.CHECK_STATUS < 0
           and RD.IS_ANUL = 0
           --and RD.EXP_DATE <= :clear_todate
           and RD.FROM_DATE <= cast(:clear_todate - :day_keep_types as date)
           and RD.IS_VIP = 0
    union
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.CHECK_STATUS < 0
           and RD.IS_ANUL = 0
           and RD.TO_DATE < :clear_todate
           and RD.IS_VIP = 1
    into   :rd_dbkey, :id_reserv_detail
  do begin
    execute procedure sys_dbg('res RESERVS_EXPIRE: id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

    execute procedure RES_ANUL_NOSHOW$INT(:rd_dbkey)
    returning_values  :nouse;

    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_NOSHOW', '');

    when any do begin
      -- nothing
    end
  end
end
^

/* Alter (RESGRP_DELETE$RSV) */
ALTER PROCEDURE RESGRP_DELETE$RSV(ID_GROUP INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable id_reserv_detail integer;
  declare variable tmp_warn_code integer;
begin

  for
    select RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
           left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = rd.ID_ROOM_TYPE
    where  RD.ID_GROUP = :id_group
    into   :id_reserv_detail
  do begin
    execute procedure RES_DELETE$INT(:id_reserv_detail, :REASON)
    returning_values :tmp_warn_code, :extra_posts_left;
    if (:warn_code is null) then WARN_CODE = :tmp_warn_code;
  end
end
^

/* Alter (RIGHTS_REGRANT) */
ALTER PROCEDURE RIGHTS_REGRANT AS
declare variable relation_name char(31);
  declare variable ui_role_name char(31);
  declare variable ena_role_name char(31);
begin
  ui_role_name = 'CLOCKBS_ROLE';
  ena_role_name = 'HTTPDBA_ROLE';

  /* PRIVILEGES GIVEN DIRECTLY TO SOME DB USER MUST BE PRESERVED.
  || AUTOGRANTS ARE MADE ONLY TO THE 'UI' and 'ENA' ROLES AND 'PUBLIC' USER.
  */
  delete from RDB$USER_PRIVILEGES UP
  where  (UP.RDB$USER_TYPE not in (8 /* user*/, 13 /* role */));

  delete from RDB$USER_PRIVILEGES UP
  where  (UP.RDB$USER = :ui_role_name)
         or (UP.RDB$USER = :ena_role_name)
         or (UP.RDB$USER = 'PUBLIC');

  /* THE 'UI' ROLE MUST HAVE ALL PRIVILIGES LIKE THE USER 'SYSDBA'.
  || ONLY NATIVE CLOCKBS APPLICATIONS ARE USING THIS ROLE.
  */
  insert into RDB$USER_PRIVILEGES (RDB$USER, RDB$GRANTOR, RDB$PRIVILEGE, RDB$GRANT_OPTION,
         RDB$RELATION_NAME, RDB$FIELD_NAME, RDB$USER_TYPE, RDB$OBJECT_TYPE)
  select :ui_role_name, 'SYSDBA', U.RDB$PRIVILEGE, 0,
         U.RDB$RELATION_NAME, U.RDB$FIELD_NAME, 13, U.RDB$OBJECT_TYPE
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = 'SYSDBA'
         and (not exists (select u2.RDB$PRIVILEGE
                          from   RDB$USER_PRIVILEGES u2
                          where  u2.RDB$USER = :ui_role_name
                                 and u2.RDB$PRIVILEGE = U.RDB$PRIVILEGE 
                                 and u2.RDB$RELATION_NAME = u.RDB$RELATION_NAME))
         and U.RDB$PRIVILEGE <> 'M' /* MEMBERSHIP */;

  insert into RDB$USER_PRIVILEGES (RDB$USER, RDB$GRANTOR, RDB$PRIVILEGE, RDB$GRANT_OPTION,
         RDB$RELATION_NAME, RDB$FIELD_NAME, RDB$USER_TYPE, RDB$OBJECT_TYPE)
  select :ena_role_name, 'SYSDBA', U.RDB$PRIVILEGE, 0,
         U.RDB$RELATION_NAME, U.RDB$FIELD_NAME, 13, U.RDB$OBJECT_TYPE
  from   RDB$USER_PRIVILEGES U
  where  U.RDB$USER = 'SYSDBA'
         and u.RDB$RELATION_NAME starting with 'ENA_'
         and (not exists (select u2.RDB$PRIVILEGE
                          from   RDB$USER_PRIVILEGES u2
                          where  u2.RDB$USER = :ena_role_name
                                 and u2.RDB$PRIVILEGE = U.RDB$PRIVILEGE 
                                 and u2.RDB$RELATION_NAME = u.RDB$RELATION_NAME))
         and U.RDB$PRIVILEGE in ('S') /* Select (and Reference ??) */;

  /* GRANT REFERENCE RIGHT TO 'PUBLIC' FOR ALL TABLES THAT ARE REFERENCED WITH
  || FOREIGN KEYS.
  */
  insert into RDB$USER_PRIVILEGES (RDB$USER, RDB$GRANTOR, RDB$PRIVILEGE, RDB$GRANT_OPTION,
         RDB$RELATION_NAME, RDB$FIELD_NAME, RDB$USER_TYPE, RDB$OBJECT_TYPE)
  select distinct
         'PUBLIC', 'SYSDBA', 'R', 0, RC2.RDB$RELATION_NAME, null, 8, 0
  from   RDB$RELATION_CONSTRAINTS RC
         join RDB$REF_CONSTRAINTS C on C.RDB$CONSTRAINT_NAME = RC.RDB$CONSTRAINT_NAME
         join RDB$RELATION_CONSTRAINTS RC2 on RC2.RDB$CONSTRAINT_NAME = C.RDB$CONST_NAME_UQ
  where  RC.RDB$CONSTRAINT_TYPE = 'FOREIGN KEY';

  /* ALL EXTERNAL INTERFACES FROM OTHER VENDORS ARE NOT USING ROLES, SO
  || THEY WILL TAKE THE PRIVILEDGES OF THE 'PUBLIC' USER. THEY MUST HAVE
  || ACCESS ONLY TO THEIR SPECIFIC PROCEDURES OR OTHER METADATA OBJECTS WICH
  || MUST BE ENUMERATED HERE.
  */
  for
    select R.RDB$RELATION_NAME
    from   RDB$RELATIONS R
    where  (R.RDB$RELATION_NAME starting with 'EAI_')
           or (R.RDB$RELATION_NAME in ('SYSTEM_INFO_MODULE','PHONECALLS'))
    union

    select R.RDB$PROCEDURE_NAME
    from   RDB$PROCEDURES R
    where  (R.RDB$PROCEDURE_NAME starting with 'EAI_')
           or (R.RDB$PROCEDURE_NAME in ('SYSTEM_INFO_GET', 'RDB$F_SP'))
    into   :relation_name
  do begin
    execute procedure RIGHTS_REGRANT_SUB('PUBLIC', :relation_name, 8);
  end
end
^

/* Alter (ROOM_CONTRACT_MODIFY$PMS) */
ALTER PROCEDURE ROOM_CONTRACT_MODIFY$PMS(ID_ROOM_CONTRACT INTEGER,
ID_ROOM_PERIOD INTEGER,
CONTRACT_TYPE VARCHAR(50),
PMS_MARKERS BLOB SUB_TYPE 1 SEGMENT SIZE 100,
IMPORT_INCOME_WITH_VAT SMALLINT,
ID_RENTAL_POOL INTEGER,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_CONTRACT INTEGER)
 AS
declare variable permissible_value_list varchar(255);
  declare variable from_date date;
  declare variable rental_pool_unit_name varchar(100);
  declare variable room_name varchar(10);
  declare variable old_contract_type varchar(50);
  declare variable old_import_income_with_vat smallint;
  declare variable old_from_date date;
  declare variable old_rental_pool_unit_name varchar(100);
  declare variable old_room_name varchar(10);
  declare variable old_id_room_period integer;
  declare variable new_id_room_period integer;
  declare variable id_room integer;
  declare variable action_text varchar(255);
begin

  permissible_value_list = '';
  select list(trim(S.KEY_))
  from   SYSTEM_ENUM S
  where  S.GROUP_ = 'pms.contract_type'
  into   :permissible_value_list;

  if (:operation in ('add', 'mod')) then begin
    execute procedure SYSTEM_CHECK_OPERATION(:contract_type, :permissible_value_list, 'contract type');

    select PRO.PROFILE_NAME
    from   PROFILE PRO
    where  PRO.ID_PROFILE = :ID_RENTAL_POOL
    into   :rental_pool_unit_name;

    select ROO.ROOM_NAME, RPP.FROM_DATE
    from   ROOM_PERIOD$PMS RPP
           join ROOMS ROO on ROO.ID_ROOM = RPP.ID_ROOM
    where  RPP.ID_ROOM_PERIOD = :ID_ROOM_PERIOD
    into   :room_name, :from_date;
  end

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');
  NEW_ID_ROOM_CONTRACT = :id_room_contract;

  if (:operation = 'add') then begin
    if (coalesce(:ID_ROOM_CONTRACT, -1) < 0) then begin
      NEW_ID_ROOM_CONTRACT = gen_id(GEN_ROOM_CONTRACT$PMS_ID, 1);
      ID_ROOM_CONTRACT = :NEW_ID_ROOM_CONTRACT;
    end
    else
      NEW_ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT;

    insert into ROOM_CONTRACT$PMS (ID_ROOM_CONTRACT, ID_ROOM_PERIOD,
           CONTRACT_TYPE, PMS_MARKERS, IMPORT_INCOME_WITH_VAT, ID_RENTAL_POOL)
    values (:NEW_ID_ROOM_CONTRACT, :ID_ROOM_PERIOD,
           :CONTRACT_TYPE, :PMS_MARKERS, :IMPORT_INCOME_WITH_VAT, :ID_RENTAL_POOL);

    action_text = substring(f_character(29) || '@{pms.contract_type.' || :contract_type || '}' || f_character(28) ||
                  formatdate(:from_date, 'D;dd.mm.yyyy') ||
                  f_character(28) || :room_name || f_character(28) || coalesce(:rental_pool_unit_name, ' ') || f_character(28)
                  || coalesce(:import_income_with_vat, 0) from 1 for 255);
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_ADDED', :ACTION_TEXT);

  end else begin
    select RC.CONTRACT_TYPE, RC.IMPORT_INCOME_WITH_VAT,
           RO.ROOM_NAME, PR.PROFILE_NAME, RP.FROM_DATE, RC.ID_ROOM_PERIOD, RP.ID_ROOM
    from   ROOM_CONTRACT$PMS RC
           join ROOM_PERIOD$PMS RP on RP.ID_ROOM_PERIOD = RC.ID_ROOM_PERIOD
           join ROOMS RO on RO.ID_ROOM = RP.ID_ROOM
           left outer join PROFILE PR on PR.ID_PROFILE = RC.ID_RENTAL_POOL
    where  RC.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
    into   :old_contract_type, :old_import_income_with_vat,
           :old_room_name, :old_rental_pool_unit_name, :old_from_date, :old_id_room_period, :id_room;

    if (:operation = 'mod') then begin
      update ROOM_CONTRACT$PMS
      set    CONTRACT_TYPE = :CONTRACT_TYPE,
             PMS_MARKERS = :PMS_MARKERS,
             IMPORT_INCOME_WITH_VAT = :IMPORT_INCOME_WITH_VAT,
             ID_RENTAL_POOL = :ID_RENTAL_POOL
      where (ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT);

      if ((:contract_type <> :old_contract_type) or (:import_income_with_vat <> :old_import_income_with_vat) or
         (coalesce(:rental_pool_unit_name, ' ') <> coalesce(:old_rental_pool_unit_name, ' ')) or
         (:from_date <> :old_from_date) or (:room_name <> :old_room_name)) then begin
        action_text = substring(f_character(29) || '@{pms.contract_type.' || :old_contract_type || '}' || f_character(28) ||
                      formatdate(:old_from_date, 'D;dd.mm.yyyy') ||
                      f_character(28) || :old_room_name ||
                      f_character(28) || coalesce(:old_rental_pool_unit_name, ' ') || f_character(28) || coalesce(:old_import_income_with_vat, 0) ||
                      f_character(28) || '@{pms.contract_type.' || :contract_type || '}' || f_character(28) || formatdate(:from_date, 'D;dd.mm.yyyy') ||
                      f_character(28) || :room_name || f_character(28) || coalesce(:rental_pool_unit_name, ' ') || f_character(28)
                      || coalesce(:import_income_with_vat, 0) from 1 for 255);
        execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_CHANGED', :ACTION_TEXT);
      end
    end

    if (:operation = 'del') then begin
      action_text = substring(f_character(29) || '@{pms.contract_type.' || :old_contract_type || '}' || f_character(28) ||
                    formatdate(:old_from_date, 'D;dd.mm.yyyy') ||
                    f_character(28) || :old_room_name || f_character(28) || coalesce(:old_rental_pool_unit_name, ' ') || f_character(28)
                    || coalesce(:old_import_income_with_vat, 0) from 1 for 255);
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_REMOVED', :ACTION_TEXT);

      delete from ROOM_CONTRACT$PMS where (ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT);

      execute procedure ROOM_PERIOD_MODIFY$PMS (:OLD_ID_ROOM_PERIOD, :id_room,  :old_from_date,
              iif(:contract_type in ('PRIVATE_USE'), 'PRIVATE', 'CONTRACT'),  'del')
      returning_values :new_id_room_period;
    end
  end
end
^

/* Alter (ROOM_MODIFY$PMS) */
ALTER PROCEDURE ROOM_MODIFY$PMS(ID_ROOM INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
BEDS INTEGER,
EXTRA_BEDS INTEGER,
SECTOR INTEGER,
SORT_ORDER INTEGER,
FEATURES BLOB SUB_TYPE 1 SEGMENT SIZE 100,
EXTERNAL_NAME VARCHAR(10),
ID_EATING_OBJECT TYPE OF ID_REF,
OPERATION VARCHAR(20))
 RETURNS(OVERRULE_NEED SMALLINT,
OVERRULE_CONTEXT VARCHAR(255),
NEW_ID_ROOM INTEGER)
 AS
declare variable old_id_room_type integer;
  declare variable old_room_name varchar(10);
  declare variable rebuild_id_hotel integer;
  declare variable rebuild_id_room_type integer;
  declare variable guests_max integer;
  declare variable no_use varchar(20);
  declare variable old_capacity integer;
  declare variable busy_group_type integer;
  declare variable sys_date date;
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable action_text varchar(255);
  declare variable old_floor integer;
  declare variable old_sector integer;
  declare variable old_extra_beds integer;
  declare variable id_hotel integer;
begin
  overrule_need = 0;
  overrule_context = '';
  new_id_room = null;
  --if OVERRULE_NEED = 1 then OVERRULE_CONTEXT = ERR_TEXT like ERR_CODE = -9
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    if (coalesce(:room_name, '') = '') then
      exception ASSERT '-119';

    if ((:room_name containing '<') or (:room_name containing '>') or (:room_name starting with 'i')) then
      exception ASSERT '-120';
  end

  room_name = upper(:room_name);

  if (:operation='mod') then begin
    select R.ROOM_NAME, R.ID_ROOM_TYPE, R.BEDS+R.EXTRA_BEDS, r.floor, r.sector, r.extra_beds
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :id_room
    into   :old_room_name, :old_id_room_type, :old_capacity, :old_floor, :old_sector, :old_extra_beds;

    if (:id_room_type <> :old_id_room_type) then begin
      exception OCCUPANCY_EXCEPTION 'ROOM TYPE CAN NOT BE CHANGED';
    end

    new_id_room = :id_room;
    guests_max = 0;
    if (:old_capacity > (:beds + :extra_beds)) then begin
      select first 1 sum(RM.ADULT_COUNT+RM.CHILDREN_COUNT), max(rm.BUSY_GROUP_TYPE)
      from   ROOM_MAGIC RM
             join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = RM.ID_RESERV_DETAIL
      where  RM.ID_ROOM = :id_room
             and RD.CHECK_STATUS in (-3, -2, -1, 0)
      group by RM.BUSY_DATE
      order by 1 desc
      into   :guests_max, :busy_group_type;
    end
    if ((:beds + :extra_beds) < :guests_max) then begin
      err_code = -8;
      err_text = f_character(29)||:ROOM_NAME||f_character(28)||:guests_max||f_character(28)||(:beds + :extra_beds);
      if (:busy_group_type in (1)) then begin
        overrule_need = :err_code;
        overrule_context = :err_text;
        err_code = 0;
        err_text = '';
      end else begin
        exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      end
    end

    update ROOMS RU
    set    RU.ID_ROOM_TYPE = :id_room_type,
           RU.ROOM_NAME = :room_name,
           RU.FLOOR = :floor,
           RU.BEDS = :beds,
           RU.EXTRA_BEDS = :extra_beds,
           RU.SECTOR = :sector,
           RU.FEATURES = :features,
           RU.SORT_ORDER = :sort_order,
           --RU.ID_HOTEL = :rebuild_id_hotel,
           RU.EXTERNAL_NAME = :external_name,
           RU.ID_EATING_OBJECT = :ID_EATING_OBJECT
    where  RU.ID_ROOM = :id_room;

    if ((:room_name <> :old_room_name)
        or (:floor <> :old_floor)
        or (:sector <> :old_sector)
        or (:extra_beds <> :old_extra_beds)) then
    begin
      action_text = f_character(29) || '(' || :old_room_name || '/' || :old_floor || '/' || :old_sector || '/'
                    || :old_extra_beds || ')' || f_character(28) || '(' || :room_name || '/' || :floor || '/'
                    || :sector || '/' || :extra_beds || ')';
      execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_PARAMS_CHANGED', :action_text);
    end

    if (:room_name <> :old_room_name) then begin
      update ACCOUNT_POST AP
      set    AP.ROOM_NAME = :room_name
      where  AP.ROOM_NAME = :old_room_name;
    end

  end else if (:operation = 'add') then begin
    select rt.ID_HOTEL
    from   ROOM_TYPES RT
    where  rt.ID_ROOM_TYPE = :ID_ROOM_TYPE
    into   :id_hotel;

    insert into ROOMS (
      ID_ROOM, ID_ROOM_TYPE, ROOM_NAME, FLOOR, BEDS, EXTRA_BEDS, SECTOR,
      FEATURES, SORT_ORDER, ID_HOTEL, EXTERNAL_NAME, ID_EATING_OBJECT)
    values (gen_id(ID_ROOM_GEN, 1), :id_room_type, :room_name, :floor, :beds, :extra_beds, :sector,
      :features, :sort_order, :id_hotel, :external_name, :ID_EATING_OBJECT)
    returning ID_ROOM into :NEW_ID_ROOM;

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :sys_date;

    execute procedure ROOM_PERIOD_MODIFY$PMS(null, :new_id_room, :sys_date, 'HOTEL', 'add')
    returning_values  :no_use;

    insert into ROOMS_ADD (ID_ROOM, PMS_MARKERS, ADDRESS)
    values (:new_id_room, null, null);
  end else if (:operation = 'del') then begin
    -- Booked rooms are preserved with FK constraint on room_magic
    execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'DELETE', '');

    select RT.ID_ROOM_TYPE, RT.ID_HOTEL
    from   ROOM_TYPES RT
    where  RT.ID_ROOM_TYPE = :id_room_type
    into   :rebuild_id_room_type, :rebuild_id_hotel;

    delete from ROOMS where ID_ROOM = :id_room;

    execute procedure ALLOTMENT_PHYS_REBUILD$INT(:rebuild_id_hotel, :rebuild_id_room_type);

    when sqlcode -530 do begin
      -- Violation of FOREIGN KEY constraint "%s" on table "%s"
      exception ASSERT '-34';
    end
  end
end
^

/* Alter (ROOM_PERIOD_MODIFY$PMS) */
ALTER PROCEDURE ROOM_PERIOD_MODIFY$PMS(ID_ROOM_PERIOD INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
STATUS VARCHAR(30),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_PERIOD INTEGER)
 AS
declare variable id_hotel integer;
  declare variable old_status varchar(30);
  declare variable old_from_date date;
  declare variable id_room_type integer;
  declare variable old_id_room integer;
  declare variable old_to_date date;
  declare variable id_account_post integer;
  declare variable id_pms_event integer;
  declare variable action_text varchar(255);
  declare variable new_to_date date;
  declare variable prev_status varchar(30);
  declare variable checking smallint;
  declare variable old_id_room_contract integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');
  execute procedure SYSTEM_CHECK_OPERATION(:status, 'HOTEL, PRIVATE, CONTRACT, INACTIVE', 'Status');
  new_id_room_period = :id_room_period;

  if (:operation = 'add') then begin
    if (exists (select *
                from   ROOM_PERIOD$PMS R
                where  R.ID_ROOM = :id_room
                       and R.FROM_DATE = :from_date )) then exception PMS_EXCEPTION '-612';

    if (coalesce(:id_room_period, 0) <= 0) then new_id_room_period = gen_id(GEN_ROOM_PERIOD$PMS_ID,1);
    else new_id_room_period = :id_room_period;

    insert into ROOM_PERIOD$PMS (ID_ROOM_PERIOD, ID_ROOM, FROM_DATE, STATUS)
    values (:new_id_room_period, :id_room, :from_date, :status);

    execute procedure ROOM_PERIOD_TODATE$INT(:id_room);

    select rp.to_date
    from   ROOM_PERIOD$PMS rp
    where  rp.id_room_period = :new_id_room_period
    into   :new_to_date;

    action_text = f_character(29) || '@{period_room_status.'||:status||'}' || f_character(28) || formatdate(:from_date, 'dd.mm.yyyy')
                  || f_character(28) || iif(extract(year from :new_to_date) = 2500, '~', formatdate(:new_to_date, 'dd.mm.yyyy'));
    execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_STATUS_ADDED', :action_text);

  end else begin
    select R.STATUS, R.FROM_DATE, R.ID_ROOM, R.TO_DATE
    from   ROOM_PERIOD$PMS R
    where  R.ID_ROOM_PERIOD = :id_room_period
    into   :old_status, :old_from_date, :old_id_room, :old_to_date;

    if (:OPERATION = 'mod' and :old_id_room <> :ID_ROOM) then
      /* Very important check! */
      exception PMS_EXCEPTION 'Cannot change the contract room !';

    if (:OPERATION = 'del' and :old_status in ('PRIVATE', 'CONTRACT')) then begin
      if ((exists ( select *
                    from   ACCOUNT_POST$PMS AP1
                           join ACCOUNT$PMS A1 on A1.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS
                           join PMS_EVENT$PMS E1 on E1.ID_PMS_EVENT = AP1.ID_PMS_EVENT
                    where  AP1.DATE_POST between :OLD_FROM_DATE and :OLD_TO_DATE
                           and E1.ID_ROOM = :OLD_ID_ROOM
                           and A1.IS_SHADOW = 0
                           and AP1.LINE_STATUS < 22  ))
          or
          (exists ( select *
                    from   ACCOUNT_POST AP2
                           join PMS_EVENT_POST PP2 on PP2.ID_ACCOUNT_POST = AP2.ID_ACCOUNT_POST
                           join PMS_EVENT$PMS E2 on E2.ID_PMS_EVENT = PP2.ID_PMS_EVENT
                    where  AP2.DATE_POST between :OLD_FROM_DATE and :OLD_TO_DATE
                           and E2.ID_ROOM = :OLD_ID_ROOM
                           and PP2.LINE_STATUS < 22  )) ) then
      begin
        exception PMS_EXCEPTION '-624';
      end
    end

    for
      select AP1.ID_ACCOUNT_POST, AP1.ID_PMS_EVENT
      from   ACCOUNT_POST$PMS AP1
             join ACCOUNT$PMS A1 on A1.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS
             join PMS_EVENT$PMS E1 on E1.ID_PMS_EVENT = AP1.ID_PMS_EVENT
      where  AP1.DATE_POST between :OLD_FROM_DATE and :OLD_TO_DATE
             and E1.ID_ROOM = :OLD_ID_ROOM
             and A1.IS_SHADOW = 1
             and AP1.LINE_STATUS = 11 /*  anulirat se samo aktiwnite nachisleniq. Ako ima dokumentirani?! ili anulirani, ne se pipat  */
      into   :id_account_post, :id_pms_event
    do begin
      execute procedure ACCOUNT_POST_PMS_ANUL$INT(:id_pms_event, :id_account_post);
    end

    if (:operation = 'mod') then begin
      if (exists (select *
                  from   ROOM_PERIOD$PMS R
                  where  R.ID_ROOM in (:old_id_room, :id_room)
                         and R.FROM_DATE = :from_date
                         and R.ID_ROOM_PERIOD <> :id_room_period)) then exception PMS_EXCEPTION '-612';
  
      checking = 1;
      if ((:status in ('PRIVATE', 'CONTRACT')) and (:from_date = :old_from_date) and (:status = :old_status)) then begin
        checking = 0;
      end else if((:status in ('PRIVATE', 'CONTRACT')) and (:from_date <> :old_from_date)) then begin
        checking = 2;
        select first 1 rcp.id_room_contract
        from   ROOM_CONTRACT$PMS rcp
        where  rcp.id_room_period = :id_room_period
        into   :old_id_room_contract;
      end

      if (:checking > 0) then  begin -- else beshe po staria nachin
        update ROOM_PERIOD$PMS p
        set    p.FROM_DATE = :from_date,
               p.STATUS = :status
        where  p.ID_ROOM_PERIOD = :id_room_period;

        execute procedure ROOM_PERIOD_TODATE$INT(:id_room);

        select rp.to_date
        from   ROOM_PERIOD$PMS rp
        where  rp.id_room_period = :id_room_period
        into   :new_to_date;

        action_text = f_character(29) || '@{period_room_status.'||:old_status||'}'
                      || f_character(28) || iif(extract(year from :old_from_date) = 2500, '~', formatdate(:old_from_date, 'dd.mm.yyyy'))
                      || f_character(28) || iif(extract(year from :old_to_date) = 2500, '~', formatdate(:old_to_date, 'dd.mm.yyyy'))
                      || f_character(28) || '@{period_room_status.'||:status||'}'
                      || f_character(28) || iif(extract(year from :from_date) = 2500, '~', formatdate(:from_date, 'dd.mm.yyyy'))
                      || f_character(28) || iif(extract(year from :new_to_date) = 2500, '~', formatdate(:new_to_date, 'dd.mm.yyyy'));
        execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_STATUS_CHANGED', :action_text);

        if (:checking > 1) then
          execute procedure SYSTEM_LOG_ADD ('CONTRACT', :OLD_ID_ROOM_CONTRACT, 'ROOM_STATUS_CHANGED', :action_text);

      end

    end else if (:operation = 'del') then begin
      if (singular (select *
                    from   ROOM_PERIOD$PMS R
                    where  R.ID_ROOM = :old_id_room)) then exception PMS_EXCEPTION '-622';

      select first 1 rpm.status, rpm.ID_ROOM
      from   ROOM_PERIOD$PMS rpm
      where  rpm.id_room = :old_id_room
             and rpm.from_date < :old_from_date
      order by rpm.from_date desc
      into   :prev_status, :id_room;

      delete from ROOM_PERIOD$PMS
      where  ID_ROOM_PERIOD = :id_room_period;

      execute procedure ROOM_PERIOD_TODATE$INT(:id_room);

      action_text = f_character(29) || '@{period_room_status.'||:old_status||'}'
                  || f_character(28) || iif(extract(year from :old_from_date) = 2500, '~', formatdate(:old_from_date, 'dd.mm.yyyy'))
                  || f_character(28) || iif(extract(year from :old_to_date) = 2500, '~', formatdate(:old_to_date, 'dd.mm.yyyy'))
                  || f_character(28) || '@{period_room_status.'||:prev_status||'}' ;
      execute procedure SYSTEM_LOG_ADD ('ROOM', :id_room, 'ROOM_STATUS_DELETED', :action_text);
    end
  end

  /* rebuild physical allotment */
  if ( (:operation in ('add', 'del'))
       or
       ((:operation = 'mod') and ((:old_status <> :status) or (:old_from_date <> :from_date)))) then
  begin
    select RT.ID_HOTEL, R.ID_ROOM_TYPE
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :id_room
    into   :id_hotel, :id_room_type;

    execute procedure ALLOTMENT_PHYS_REBUILD$INT(:id_hotel, :id_room_type);
  end

end
^

/* Alter (ROOM_SMART_LIST$RSV) */
ALTER PROCEDURE ROOM_SMART_LIST$RSV(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(50))
 RETURNS(ROOM_NAME VARCHAR(50),
FREE_BEDS_BASE INTEGER,
FREE_BEDS_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
FEATURES BLOB,
BUSY_GROUP_TYPE INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
DATA1 VARCHAR(255),
DATA2 VARCHAR(255))
 AS
declare variable report_leaving varchar(20);
declare variable suppress_private integer;
begin
  if (:from_date >= :to_date) then exit;
  execute procedure SYSTEM_CHECK_OPERATION(:report_type, 'FREE_ONLY,FREE_AND_LEAVING,BLOCKED,POTENTIAL_SHARE,PRIVATE_USE,ALL');

  suppress_private = iif(:REPORT_TYPE = 'ALL', 0, 1);
  if (:report_type in ('FREE_ONLY','FREE_AND_LEAVING')) then begin
    if (:report_type = 'FREE_AND_LEAVING') then report_leaving = 'AS_FREE';
    else report_leaving = 'AS_LEAVING';
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DBEFORE, SRLF.DAFTER, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_FREE$INT(:from_date, :to_date, :report_leaving, :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end else if (:report_type in ('BLOCKED','POTENTIAL_SHARE')) then begin
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DESCRIPTION, SRLF.PERIOD, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_SHARE$INT(:from_date, :to_date, :report_type, :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end else if (:report_type in ('ALL')) then begin
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DBEFORE, SRLF.DAFTER, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_FREE$INT(:from_date, :to_date, 'FREE_AND_LEAVING', :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;

    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DESCRIPTION, SRLF.PERIOD, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_SHARE$INT(:from_date, :to_date, 'POTENTIAL_SHARE', :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: SAFE_CHECK_OUT for: SAFE_OCCUPANCY_MODIFY */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE /* TYPE OF ID */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER,
WARN_CODE /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SAFE_OCCUPANCY_MODIFY) */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE TYPE OF ID,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable old_booking_number tres_number;
  declare variable id_resource_reservation id_ref;
  declare variable from_datetime tdatetime;
  declare variable action_text tdescription_long;
  declare variable old_occupant varchar(100);
  declare variable old_to_dt timestamp;
  declare variable id_reserv_detail integer;
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation;

  select rr.BOOKING_NUMBER, od.FROM_DATETIME,
         RR.OCCUPANT_NAME, od.TO_DATETIME, rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESERV_DETAIL rd on rd.NUMBER = rr.BOOKING_NUMBER and rd.IS_ANUL = 0
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :old_booking_number, :from_datetime,
         :old_occupant, :old_to_dt, :id_reserv_detail, :id_agent_profile;

  --if (:old_booking_number <> :BOOKING_NUMBER) then exception ASSERT 'Can not change booking number!';
  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  update SAFE_RESOURCE_RESERV rr
  set    rr.PRICE_DESCRIPTION = :price_description,
         rr.ID_RATE_PRICE_PROFILE = :id_agent_profile,
         rr.RATING_UNITS = :rating_units,
         rr.RATE_PRICE = :price,
         rr.RATE_CURR = :currency
  where  rr.ID_RESOURCE_RESERV = :id_resource_reservation;

  execute procedure RESOURCE_RESERVATION_MODIFY (:id_resource_reservation, :ID_SAFE, :from_datetime,
          :TO_DATETIME, :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :old_booking_number, 'mod')
  returning_values :id_resource_reservation, :no_use;

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail)
  returning_values (:DOC_SELECTED);

  /* Log changes */
  if ((:old_occupant <> :OCCUPANT_NAME) or (:old_to_dt <> :TO_DATETIME)) then begin
    action_text = f_character(29) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                  || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                  || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');
  
    execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_CHANGED', :action_text);
  end
end
^

/* Alter (SAFE_OCCUPANCY_NEW) */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE TYPE OF ID,
FROM_DATETIME TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME,
BOOKING_NUMBER TYPE OF TRES_NUMBER,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
ID_RESOURCE_RESERVATION TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable action_text tdescription_long;
  declare variable id_reserv_detail integer;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, s.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  if (:id_resource_reservation is not null) then exception ASSERT '-1064'|| f_character(31) || f_character(29) || :safe_name;

  select rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESERV_DETAIL rd
  where  rd.NUMBER = :BOOKING_NUMBER
         and rd.IS_ANUL = 0
  into   :id_reserv_detail, :id_agent_profile;

  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  execute procedure  RESOURCE_RESERVATION_MODIFY (null, :ID_SAFE, :FROM_DATETIME, :TO_DATETIME,
          :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :BOOKING_NUMBER, 'add')
  returning_values (:id_resource_reservation, :no_use) ;

  insert into SAFE_RESOURCE_RESERV (ID_RESOURCE_RESERV, PRICE_DESCRIPTION, ID_RATE_PRICE_PROFILE,
         RATING_UNITS, RATE_PRICE, RATE_CURR)
  values (:id_resource_reservation, :price_description, :id_agent_profile,
         :rating_units, :price, :currency);

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail, :ID_EXTERNAL_CLIENT_ACCCOUNT)
  returning_values (:DOC_SELECTED);

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = 'CHECKED_IN'
  where  RR.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = :id_resource_reservation
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                || f_character(28) || coalesce(:BOOKING_NUMBER, '')
                || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUPIED', :action_text);
end
^

/* Alter (SUMMARY_FORECAST$INT) */
ALTER PROCEDURE SUMMARY_FORECAST$INT(ID_HOTEL INTEGER,
SUMMARY_DATE DATE)
 AS
declare variable to_date date;
begin
  select max(rm.busy_date)
  from   ROOM_MAGIC rm
  where  rm.id_hotel = :id_hotel
  into   :to_date;
  to_date = maxdate(:TO_DATE, :SUMMARY_DATE + 1);

  execute procedure AVAILABILITY_OCCUP_PREPARE$AVL (:SUMMARY_DATE + 1, :TO_DATE, 1, 1, 0, 1, 1, 1, 1, 1, :ID_HOTEL);

  insert into SUMMARY_FORECAST (
         summary_date, forecast_date, id_room_type, id_hotel,
         rooms_capacity, rooms_ooi, res_confirmed, res_notconfirmed, res_waiting,
         res_checked_in, cont_remain, bp_remain)
  select :summary_date, tso.for_date, tso.id_room_type, tso.ID_HOTEL,
         sum(tso.g_capacity), sum(tso.g_ooi), sum(tso.res_confirmed), sum(tso.res_notconfirmed), sum(tso.res_waiting),
         sum(tso.sold), sum(tso.cont_plain_remain), sum(tso.cont_bp_remain)
  from   SMART_OCCUP$TMP tso
  where  tso.ID_HOTEL = :ID_HOTEL
  group by 2, 3, 4;

  delete
  from   SUMMARY_FORECAST sf
  where  sf.summary_date = sf.forecast_date
         and sf.ID_HOTEL = :ID_HOTEL;

  insert into SUMMARY_FORECAST (
         summary_date, forecast_date, id_room_type, id_hotel,
         rooms_capacity, rooms_ooi, res_confirmed, res_notconfirmed, res_waiting,
         res_checked_in, cont_remain, bp_remain)
  select so.for_date, so.for_date, so.id_room_type, so.id_hotel,
         sum(so.rooms_available), sum(so.rooms_ooi), 0, 0, 0,
         sum(so.rooms_sold), 0, 0
  from   SUMMARY_OCCUPANCY so
  where  so.ID_HOTEL = :ID_HOTEL
         and so.for_date <= :summary_date
  group by 1, 2, 3, 4;

end
^

/* empty dependent procedure body */
/* Clear: OCCUPANCY_SUMMARY_REMAKE$SYS for: SUMMARY_PREPARE$INT */
ALTER PROCEDURE OCCUPANCY_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* Alter (SUMMARY_PREPARE$INT) */
ALTER PROCEDURE SUMMARY_PREPARE$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
declare variable busy_date date;
  declare variable id_room_type integer;
  declare variable id_profile_agent integer;
  declare variable country_code varchar(20);
  declare variable market_segment_code varchar(3);
  declare variable source_code varchar(3);
  declare variable channel_code varchar(3);
  declare variable hear_reason_code varchar(3);
  declare variable come_reason_code varchar(3);
  declare variable rooms_noshow smallint;
  declare variable rooms_canceled smallint;

  declare variable rooms_ooi smallint;
  declare variable rooms_ooo smallint;

  declare variable rooms_sold smallint;
  declare variable rooms_sold_multiple_gst smallint;
  declare variable rooms_arrival smallint;
  declare variable rooms_departure smallint;
  declare variable ad_in_house smallint;
  declare variable ad_arrival smallint;
  declare variable ad_departure smallint;
  declare variable ch_in_house smallint;
  declare variable ch_arrival smallint;
  declare variable ch_departure smallint;
  declare variable guests_noshow smallint;
  declare variable guests_day_use smallint;
begin
  -- REBUILD THE "NO SLICE"
  delete from SUMMARY_OCCUPANCY D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY (ID_ROOM_TYPE, FOR_DATE, ROOMS_AVAILABLE, ID_HOTEL)
  select RC.ID_ROOM_TYPE, RC.FOR_DATE, sum(RC.CNT_DEFINED), :id_hotel
  from   HOTEL H
         left outer join ALLOTMENT_GET$INT(H.ID_INVENTORY_ALLOTMENT, :from_date, :to_date, null, 'PLAIN_PERIOD', H.ID_HOTEL) RC on 0=0
  where  H.ID_HOTEL = :id_hotel
         and RC.CNT_DEFINED is not null
  group by 1, 2;

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, 
           M.ROOMS_OOI, M.ROOMS_OOO,
           M.ROOMS_SOLD, M.ROOMS_SOLD_MULTIPLE_GST, M.ROOMS_ARRIVAL, M.ROOMS_DEPARTURE,
           M.AD_IN_HOUSE, M.AD_ARRIVAL, M.AD_DEPARTURE,
           M.CH_IN_HOUSE, M.CH_ARRIVAL, M.CH_DEPARTURE, M.GUESTS_DAY_USE
    from   SUMMARY_PREPARE_TOTAL$INT(:id_hotel, :from_date, :to_date) M
    into   :id_room_type, :busy_date,
           :rooms_ooi, :rooms_ooo,
           :rooms_sold, :rooms_sold_multiple_gst, :rooms_arrival, :rooms_departure,
           :ad_in_house, :ad_arrival, :ad_departure,
           :ch_in_house, :ch_arrival, :ch_departure, :guests_day_use
  do begin
    update SUMMARY_OCCUPANCY SO
    set    SO.ROOMS_OOI = :rooms_ooi,
           SO.ROOMS_OOO = :rooms_ooo,
           SO.ROOMS_SOLD = :rooms_sold,
           SO.ROOMS_SOLD_MULTIPLE_GST = :rooms_sold_multiple_gst,
           SO.ROOMS_ARRIVAL = :rooms_arrival,
           SO.ROOMS_DEPARTURE = :rooms_departure,
           SO.GST_AD_IN_HOUSE = :ad_in_house,
           SO.GST_AD_DEPARTURE = :ad_departure,
           SO.GST_AD_ARRIVAL = :ad_arrival,
           SO.GST_CH_IN_HOUSE = :ch_in_house,
           SO.GST_CH_DEPARTURE = :ch_departure,
           SO.GST_CH_ARRIVAL = :ch_arrival,
           SO.GUESTS_DAY_USE = :guests_day_use
    where  SO.FOR_DATE = :busy_date
           and SO.ID_ROOM_TYPE = :id_room_type;

    if (row_count = 0) then begin
      --savedbg('skip SUMMARY_OCCUPANCY');
    end
  end

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, 
           M.ROOMS_NOSHOW, M.ROOMS_CANCELED, M.GUESTS_NOSHOW
    from   SUMMARY_PREPARE_CANCELED$INT(:id_hotel, :from_date, :to_date, 'TOTAL') M
    into   :id_room_type, :busy_date, 
           :rooms_noshow, :rooms_canceled, :guests_noshow
  do begin
    update SUMMARY_OCCUPANCY SO
    set    SO.ROOMS_NOSHOW = :rooms_noshow,
           SO.ROOMS_CANCELED = :rooms_canceled,
           SO.GUESTS_NOSHOW = :guests_noshow
    where  SO.FOR_DATE = :busy_date
           and SO.ID_ROOM_TYPE = :id_room_type;

    if (row_count = 0) then begin
      --savedbg('skip SUMMARY_OCCUPANCY');
    end
  end

  -- REBUILD THE "MARKET SLICE"
  delete from SUMMARY_OCCUPANCY_MARKET D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY_MARKET (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL,
         MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
         ROOMS_SOLD, ROOMS_SOLD_MULTIPLE_GST, ROOMS_ARRIVAL, ROOMS_DEPARTURE,
         ROOMS_NOSHOW, ROOMS_CANCELED, GUESTS_IN_HOUSE, GUESTS_ARRIVAL, GUESTS_DEPARTURE, GUESTS_DAY_USE)
  select M.ID_ROOM_TYPE, M.BUSY_DATE, :id_hotel,
         M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE,
         M.ROOMS_SOLD, M.ROOMS_SOLD_MULTIPLE_GST, M.ROOMS_ARRIVAL, M.ROOMS_DEPARTURE,
         0, 0, M.GUESTS_IN_HOUSE, M.GUESTS_ARRIVAL, M.GUESTS_DEPARTURE, M.GUESTS_DAY_USE
  from   SUMMARY_PREPARE_MAIN$INT(:id_hotel, :from_date, :to_date, 'MARKET') M;

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, 
           M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE,
           M.ROOMS_NOSHOW, M.ROOMS_CANCELED
    from   SUMMARY_PREPARE_CANCELED$INT(:id_hotel, :from_date, :to_date, 'MARKET') M
    into   :id_room_type, :busy_date, 
           :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
           :rooms_noshow, :rooms_canceled
  do begin
    update SUMMARY_OCCUPANCY_MARKET MA
    set    MA.ROOMS_NOSHOW = :rooms_noshow,
           MA.ROOMS_CANCELED = :rooms_canceled
    where  MA.FOR_DATE = :busy_date
           and MA.ID_ROOM_TYPE = :id_room_type
           and MA.MARKET_SEGMENT_CODE = :market_segment_code
           and MA.SOURCE_CODE = :source_code
           and MA.CHANNEL_CODE = :channel_code
           and MA.HEAR_REASON_CODE = :hear_reason_code
           and MA.COME_REASON_CODE = :come_reason_code;
    if (row_count = 0) then begin
      insert into SUMMARY_OCCUPANCY_MARKET (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL,
             MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
             ROOMS_NOSHOW, ROOMS_CANCELED)
      values (:id_room_type, :busy_date, :id_hotel,
             :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
             :rooms_noshow, :rooms_canceled);
    end
  end

  -- REBUILD THE "PROFILE/COUNTRY SLICE"
  delete from SUMMARY_OCCUPANCY_OTHER D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY_OTHER (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL,
         ID_PROFILE_AGENT, COUNTRY_CODE,
         ROOMS_SOLD, ROOMS_SOLD_MULTIPLE_GST, ROOMS_ARRIVAL, ROOMS_DEPARTURE,
         ROOMS_NOSHOW, ROOMS_CANCELED, GUESTS_IN_HOUSE, GUESTS_ARRIVAL, GUESTS_DEPARTURE, GUESTS_DAY_USE)
  select M.ID_ROOM_TYPE, M.BUSY_DATE, :id_hotel,
         M.ID_PROFILE_AGENT, M.COUNTRY_CODE,
         M.ROOMS_SOLD, M.ROOMS_SOLD_MULTIPLE_GST, M.ROOMS_ARRIVAL, M.ROOMS_DEPARTURE,
         0, 0, M.GUESTS_IN_HOUSE, M.GUESTS_ARRIVAL, M.GUESTS_DEPARTURE, M.GUESTS_DAY_USE
  from   SUMMARY_PREPARE_MAIN$INT(:id_hotel, :from_date, :to_date, 'PROFILE') M;

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, 
           M.ID_PROFILE_AGENT, M.COUNTRY_CODE,
           M.ROOMS_NOSHOW, M.ROOMS_CANCELED, M.GUESTS_NOSHOW
    from   SUMMARY_PREPARE_CANCELED$INT(:id_hotel, :from_date, :to_date, 'PROFILE') M
    into   :id_room_type, :busy_date, 
           :id_profile_agent, :country_code,
           :rooms_noshow, :rooms_canceled, :guests_noshow
  do begin

    update SUMMARY_OCCUPANCY_OTHER MA
    set    MA.ROOMS_NOSHOW = :rooms_noshow,
           MA.ROOMS_CANCELED = :rooms_canceled
    where  MA.FOR_DATE = :busy_date
           and MA.ID_ROOM_TYPE = :id_room_type
           and MA.ID_PROFILE_AGENT = :id_profile_agent
           and MA.COUNTRY_CODE = :country_code;
    if (row_count = 0) then begin
      insert into SUMMARY_OCCUPANCY_OTHER (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL,
             ID_PROFILE_AGENT, COUNTRY_CODE, ROOMS_NOSHOW, ROOMS_CANCELED)
      values (:id_room_type, :busy_date, :id_hotel,
             :id_profile_agent, :country_code, :rooms_noshow, :rooms_canceled);
    end
  end

  -- REBUILD THE "PROFILE/MARKETING SLICE"
  delete from SUMMARY_OCCUPANCY_PROFILE_MRKT D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY_PROFILE_MRKT (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL,
         ID_PROFILE_AGENT,
         MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
         ROOMS_SOLD, ROOMS_SOLD_MULTIPLE_GST, ROOMS_ARRIVAL, ROOMS_DEPARTURE,
         ROOMS_NOSHOW, ROOMS_CANCELED, GUESTS_IN_HOUSE, GUESTS_ARRIVAL, GUESTS_DEPARTURE, GUESTS_DAY_USE)
  select M.ID_ROOM_TYPE, M.BUSY_DATE, :id_hotel,
         M.ID_PROFILE_AGENT,
         M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE,
         M.ROOMS_SOLD, M.ROOMS_SOLD_MULTIPLE_GST, M.ROOMS_ARRIVAL, M.ROOMS_DEPARTURE,
         0, 0, M.GUESTS_IN_HOUSE, M.GUESTS_ARRIVAL, M.GUESTS_DEPARTURE, M.GUESTS_DAY_USE
  from   SUMMARY_PREPARE_MAIN$INT(:id_hotel, :from_date, :to_date, 'MIXED') M;

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, M.ID_PROFILE_AGENT,
           M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE,
           M.ROOMS_NOSHOW, M.ROOMS_CANCELED, M.GUESTS_NOSHOW
    from   SUMMARY_PREPARE_CANCELED$INT(:id_hotel, :from_date, :to_date, 'MIXED') M
    into   :id_room_type, :busy_date,  :id_profile_agent,
           :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
           :rooms_noshow, :rooms_canceled, :guests_noshow
  do begin

    update SUMMARY_OCCUPANCY_PROFILE_MRKT MA
    set    MA.ROOMS_NOSHOW = :rooms_noshow,
           MA.ROOMS_CANCELED = :rooms_canceled
    where  MA.FOR_DATE = :busy_date
           and MA.ID_ROOM_TYPE = :id_room_type
           and MA.ID_PROFILE_AGENT = :id_profile_agent
           and MA.MARKET_SEGMENT_CODE = :market_segment_code
           and MA.SOURCE_CODE = :source_code
           and MA.CHANNEL_CODE = :channel_code
           and MA.HEAR_REASON_CODE = :hear_reason_code
           and MA.COME_REASON_CODE = :come_reason_code;
    if (row_count = 0) then begin
      insert into SUMMARY_OCCUPANCY_PROFILE_MRKT (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL, ID_PROFILE_AGENT,
             MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
             ROOMS_NOSHOW, ROOMS_CANCELED)
      values (:id_room_type, :busy_date, :id_hotel, :id_profile_agent,
             :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
             :rooms_noshow, :rooms_canceled);
    end
  end

end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_INPUT_PARAMS$INT for: TAR_CALC_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_PARAMS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_PARAMS$INT) */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
declare variable param_code varchar(40);
  declare variable id_param integer;
  declare variable param_value varchar(255);
  declare variable data_type  varchar(30);
  declare variable rate_list varchar(2000);
begin
  err_code = 0;
  param_values = '';

  if (coalesce(:rate_list_replace, '') = '') then rate_list = ',' || :id_rate || ',';
  else rate_list = :rate_list_replace;

  for
    select distinct TBP.PARAM_NAME
    from   SYSTEM_STRING_PARSER (:rate_list, ',') sp
           left join TAR_BO_PARAMS TBP on TBP.ID_TAR_HEAD = sp.ITEM
    where  (TBP.PARAM_TYPE <> 'DATE_DEPENDANT' and :for_date is null)
           or (TBP.PARAM_TYPE = 'DATE_DEPENDANT' and :for_date is not null)
    into   :param_code
  do begin
    if (:param_code is not null) then begin
      id_param = null;
      select TP.ID_TARIFA_PARAM, TP.DATA_TYPE
      from   TARIFA_PARAMS TP
      where  TP.PARAM_CODE = :param_code
             and tp.IS_USE = 1
      into   :id_param, :data_type;
  
      if (:id_param is null) then begin
        err_code = -202;
        execute procedure sys_dbg ('tar calc params err_code: ' || :err_code || F_CRLF() || 'PARAM_CODE = ' || :param_code);
        exit;
      end
  
      execute procedure TARIFA_GET_PARAM (:id_param, :for_date, :id_tar_input, :id_tar_calc)
      returning_values (:param_value);
  
      param_code = ':'||param_code;
  
      if ((:param_code is not null) and (:param_code is not null) and (:data_type is not null)) then
         param_values = :param_values||';'||:param_code||','||:data_type||','||:param_value;
    end
  end
end
^

/* Alter (TEST_AVAILABILITY) */
ALTER PROCEDURE TEST_AVAILABILITY RETURNS(FOR_DATE DATE,
MINUS_ROOM_TYE INTEGER,
ID_AGENT INTEGER,
AGENT_NAME VARCHAR(100),
SOLD INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
CONT_BP_REMAIN INTEGER,
RES_WAITING INTEGER,
CONT_PLAIN INTEGER,
CONT_BP INTEGER,
CONT_BP_PLAIN INTEGER,
CONT_PLAIN_REMAIN INTEGER,
RES_TOTAL INTEGER,
ROOM_TYPE_NAME VARCHAR(20))
 AS
declare variable FROM_DATE date;
  declare variable TO_DATE date;
  declare variable HOTELS varchar(255);
  declare variable ID_OCCUPANCY_SESSION integer;
begin
  from_date = '01.06.2009';
  to_date = '30.06.2009';
  hotels = '4';
  execute procedure AVAILABILITY_OCCUPANCY$AVL (:from_date, :to_date,  0, :hotels)
  returning_values (:id_occupancy_session);

  execute procedure AVAILABILITY_OCCUPANCY_OPT$AVL (:id_occupancy_session, 0, 0, 1, 1, 0, 0, 0);

  for
    SELECT
        SOT.FOR_DATE,
        -SOT.ID_ROOM_TYPE as MINUS_ROOM_TYE,
        SOT.ID_AGENT,
        RT.TYPE_ROOM as ROOM_TYPE_NAME,
        P.PROFILE_NAME as AGENT_NAME,
        sum(SOT.SOLD) as SOLD,
        sum(SOT.RES_CONFIRMED) as RES_CONFIRMED,
        sum(SOT.RES_NOTCONFIRMED) as RES_NOTCONFIRMED,
        sum(SOT.RES_WAITING) as RES_WAITING,
        sum(SOT.CONT_PLAIN  ) as CONT_PLAIN,
        sum(SOT.CONT_BP) as CONT_BP,
        sum(SOT.CONT_BP_REMAIN) as CONT_BP_REMAIN,
        sum(SOT.CONT_PLAIN_REMAIN  ) as CONT_PLAIN_REMAIN,
        sum(0 + (SOT.RES_CONFIRMED+SOT.RES_NOTCONFIRMED) ) as RES_TOTAL
    from SMART_OCCUP$TMP SOT
         left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = SOT.ID_ROOM_TYPE
         left outer join PROFILE_AGENT PA on SOT.ID_AGENT = PA.ID_AGENT
         left outer join PROFILE P on PA.ID_PROFILE = P.ID_PROFILE
    where  SOT.ID_SESSION = :id_occupancy_session
      and RT.ID_HOTEL = 4
      and  1=0
      
      
      and SOT.ID_AGENT > -100
    group by SOT.ID_AGENT,
             SOT.FOR_DATE,
             SOT.ID_ROOM_TYPE,
             RT.TYPE_ROOM,
             P.PROFILE_NAME
    union
    SELECT
        FOR_DATE,
        1,
        SOT.ID_AGENT,
        cast('' as varchar(20)),
        P.PROFILE_NAME as AGENT_NAME,
        sum(SOT.SOLD) as SOLD,
        sum(SOT.RES_CONFIRMED) as RES_CONFIRMED,
        sum(SOT.RES_NOTCONFIRMED) as RES_NOTCONFIRMED,
        sum(SOT.RES_WAITING) as RES_WAITING,
        sum(SOT.CONT_PLAIN  ) as CONT_PLAIN,
        sum(SOT.CONT_BP) as CONT_BP,
        sum(SOT.CONT_BP_REMAIN) as CONT_BP_REMAIN,
        sum(SOT.CONT_PLAIN_REMAIN  ) as CONT_PLAIN_REMAIN,
        sum(0 + (SOT.RES_CONFIRMED+SOT.RES_NOTCONFIRMED) ) as RES_TOTAL
    from SMART_OCCUP$TMP SOT
         left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = SOT.ID_ROOM_TYPE
         left outer join PROFILE_AGENT PA on SOT.ID_AGENT = PA.ID_AGENT
         left outer join PROFILE P on PA.ID_PROFILE = P.ID_PROFILE
    where  SOT.ID_SESSION = :id_occupancy_session
      and RT.ID_HOTEL = 4
      and  1=1
      
      and SOT.ID_AGENT > -100
    group by SOT.ID_AGENT,
             SOT.FOR_DATE,
             P.PROFILE_NAME
    order by 5,3,1,2
    into  :for_date, :MINUS_ROOM_TYE, :id_agent, :room_type_name, :agent_name, :sold,
          :res_confirmed, :res_notconfirmed, :res_waiting, :cont_plain, :cont_bp,
          :cont_bp_remain, :cont_plain_remain, :res_total
  do suspend;

end
^

/* Alter (TEST_BOOKING_IMPORT) */
ALTER PROCEDURE TEST_BOOKING_IMPORT AS
declare variable dbg varchar(255);
  declare variable booking_id integer;
begin
  dbg = null;
  EXECUTE PROCEDURE IMPORT_BOOKING$EXC ('SOL NESSEBAR BAY', 'EXP.3', null, null, 0,
  cast('17.11.2008' as date), null, cast('19.11.2008' as date),
  null, null, null, null, null, 'LARGE_ROOM', 'BB', null, null, '????????', 'MIXED', 'EXPEDIA-BAY',
  null, null, null, null, '?????? ??????', null, null, null, null, 'Business - Corporate',
  'Companies (FIR)', 'E-Mail (EMA)', 'Advert (ANZ)', 'Activities (ANI)', 'A room with a view.(4)',
  null, null, 2, 2, 'e43a4cc0-7d73-47cc-bd07-a98c18c714a3', null, '0D074F966A187B2A9912B5F0E213FEB4',
  0, 0, 0, null, null, null, null, null, null, null, null, null, null,  null, null, null, null, null, null)
  returning_values (:dbg, :booking_id, :dbg, :dbg);
  dbg = null;
end
^

/* Restore proc. body: ACCOUNT_MODIFY$INT */
ALTER PROCEDURE ACCOUNT_MODIFY$INT(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL TYPE OF ID_REF,
IS_PMS_ACCOUNT TYPE OF TLOGICAL,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
declare variable a_dbkey char(8);
  declare variable old_sec_level integer;
  declare variable action_text varchar(255);
  declare variable old_acc_name varchar(50);
  declare variable old_acc_curr varchar(3);
  declare variable old_tax_policy integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, archive');

  new_id_account = :id_account;
  if (:operation = 'add') then begin
    if ((:new_id_account is null) or (:new_id_account <= 0)) then new_id_account = gen_id(ID_ACCOUNT_GEN, 1);

    insert into ACCOUNT(ID_ACCOUNT, ACCOUNT_CURR, ACCOUNT_NAME, IS_CREDIT_ACCOUNT, CREDIT_LIMIT,
           ID_TYPE_PAYMENT, NOTE, IS_BLOCKED, BLOCK_TEXT, SECURITY_LEVEL, IS_BASE, IS_EXTRA,
           IS_ALOWED_POS_INTERFACE, POS_INTERFACE_NOTE, EXT_CODE, ID_TAX_POLICY, ID_PROFILE,
           ID_HOTEL, IS_DEFAULT, IS_PMS_ACCOUNT, ID_RESERV_DETAIL)
    values (:new_id_account, :account_curr, :account_name, 0, null,
           :id_type_payment, :note, :is_blocked, :block_text, :security_level, :is_base, :is_extra,
           :is_alowed_pos_interface, :pos_interface_note, :ext_code, :id_tax_policy, :id_profile,
           :id_hotel, :is_default, coalesce(:IS_PMS_ACCOUNT, 0), :ID_RESERV_DETAIL)
    returning RDB$DB_KEY
    into   :a_dbkey;

    action_text = f_character(29) || :new_id_account || '/' || :account_name;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'ADD_ACCOUNT', :action_text);

    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:NEW_ID_ACCOUNT, :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT);
    -- check special right and log event

  end else begin
    ID_RESERV_DETAIL = null;
    select A.RDB$DB_KEY, A.ID_RESERV_DETAIL, A.SECURITY_LEVEL,
           A.ACCOUNT_NAME, A.ACCOUNT_CURR, A.ID_TAX_POLICY
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :a_dbkey, :id_reserv_detail, :old_sec_level,
           :old_acc_name, :old_acc_curr, :old_tax_policy;
    if (:operation = 'mod') then begin
  
      update ACCOUNT A
      set    A.ACCOUNT_NAME = :account_name,
             A.ID_TYPE_PAYMENT = :id_type_payment,
             A.NOTE = :note,
             A.IS_BLOCKED = :is_blocked,
             A.BLOCK_TEXT = :block_text,
             A.SECURITY_LEVEL = :security_level,
             A.IS_BASE = :is_base,
             A.IS_EXTRA = :is_extra,
             A.IS_ALOWED_POS_INTERFACE = :is_alowed_pos_interface,
             A.POS_INTERFACE_NOTE = :pos_interface_note,
             A.EXT_CODE = :ext_code,
             A.ID_TAX_POLICY = :id_tax_policy,
             A.IS_DEFAULT = :is_default
      where  A.RDB$DB_KEY = :a_dbkey;
  
      execute procedure ACCOUNT_SET_CURRENCY$INT (:a_dbkey, :account_curr);
  
      if (:old_acc_name <> :account_name) then begin
        action_text = f_character(29 ) || :ID_ACCOUNT || '/' || :old_acc_name || ', ' || :old_acc_curr
                      || f_character(28) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME || ', ' || :ACCOUNT_CURR;
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'EDIT_ACCOUNT', :action_text);
      end
  
      if (:old_sec_level <> :SECURITY_LEVEL) then begin
        action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME
                      || f_character(28) || :SECURITY_LEVEL;
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'SET_ACC_SEC_LEVEL', :action_text);
      end
  
      if (:old_tax_policy <> :id_tax_policy) then begin
        execute procedure ACCOUNT_TAXATION_RECALC$INT (:ID_ACCOUNT, :ID_TAX_POLICY);
  
        action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME;                        
  
        select :action_text || f_character(28) || OTP.POLICY_NAME
        from   TAX_POLICY OTP
        where  OTP.ID_TAX_POLICY = :old_tax_policy
        into   :action_text;
        select :action_text || f_character(28) || NTP.POLICY_NAME
        from   TAX_POLICY NTP
        where  NTP.ID_TAX_POLICY = :ID_TAX_POLICY
        into   :action_text;
         
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'VAT_POLICY_CHNG', :action_text);
      end
  
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:ID_ACCOUNT, :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT); -- check special right and log event
  
    end else if (:operation = 'archive') then begin
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 1);

    end
  end

  if ((:id_reserv_detail is null) and (:IS_CREDIT_ACCOUNT = 0)) then begin
    exception ACCOUNT_EXCEPTION '-1010';
    -- The account must have active credit status
    exit;
  end

  if (:is_default = 1) then begin
    update ACCOUNT A
    set    A.IS_DEFAULT = 0
    where  A.ID_HOTEL = :id_hotel
           and A.ID_PROFILE = :id_profile
           and A.ID_ACCOUNT <> :new_id_account;
  end
end
^

/* Restore proc. body: ACCOUNT_POST_MODIFY$PMS */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
declare variable id_account integer;
  declare variable id_service integer;
  declare variable date_post date;
  declare variable is_owner_income smallint;
  declare variable is_account_post_item smallint;
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable no_use_id_acc_post integer;
  declare variable ap_dbkey char(8);
begin
  -- da se wika samo ot GUI
  if ( (:ID_ACCOUNT_POST is null) and (:ID_ACCOUNT_POST_PMS is null) ) then begin
    exception WRONG_PARAM_VALUE;
    exit;
  end

  is_account_post_item = iif(:id_account_post is not null, 1, 0);

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'mod, anul');

  if (:operation in ('mod', 'anul')) then begin
    -- prowerka: ot GUI-to mogat da se anulirat samo nedokumentirani i neanulirani nachisleniq
    if (:is_account_post_item = 1) then begin
      if ( (:ID_PMS_EVENT > 0) and
           not exists ( select *
                        from   PMS_EVENT_POST PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      select ap.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  ap.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
      into   :ap_dbkey;

      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_dbkey, 'PMS GUI VOID');

      update PMS_EVENT_POST PP
      set    PP.LINE_STATUS = 22
      where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST;

    end else if (:ID_ACCOUNT_POST_PMS is not null) then begin
      if ( not exists ( select *
                        from   ACCOUNT_POST$PMS PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      execute procedure ACCOUNT_POST_PMS_ANUL$INT(:ID_PMS_EVENT, :ID_ACCOUNT_POST_PMS);
    end

    if (:operation = 'mod') then begin
      id_account = null;
      if (:is_account_post_item = 1) then begin
        select AP.ID_ACCOUNT, AP.ID_SERVICE, AP.DATE_POST, PP.ID_OWNER, 0, ap.id_room
        from   ACCOUNT_POST AP
               join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and PP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :id_owner, :is_owner_income, :id_room;
      end else begin
        select AP.ID_ACCOUNT_PMS, AP.ID_SERVICE, AP.DATE_POST, AP.IS_OWNER_INCOME, AP.ID_OWNER
        from   ACCOUNT_POST$PMS AP
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
               and AP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :is_owner_income, :id_owner;
      end
      if (:id_account is null) then exit;

      execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_account, :id_service, :id_owner, :date_post,
              :in_curr_orig, :in_value_orig, 1 - :is_account_post_item, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* Restore proc. body: ACCOUNT_POSTING_TRANSFER$ACC */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
declare variable ap_dbkey char(8);
  declare variable transfer_value double precision;
  declare variable post_value double precision;
  declare variable id_account integer;
  declare variable tmp_id_account integer;
  declare variable curr_post varchar(3);
  declare variable acc_name varchar(50);
  declare variable action_text varchar(255);
  declare variable is_pms_account integer;
  declare variable dest_acc_name varchar(50);
begin

  id_account = null;
  transfer_value = 0;

  select ACC.ACCOUNT_NAME, acc.IS_PMS_ACCOUNT
  from   ACCOUNT ACC
  where  ACC.ID_ACCOUNT = :ID_DEST_ACCOUNT
  into   :dest_acc_name, is_pms_account;

  if (:is_pms_account = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('PMS_TRANSFER_POSTINGS');
  end

  for
    select AP.RDB$DB_KEY, AP.ID_ACCOUNT, ap.PRICE_POST * ap.QTY_POST
    from   ACCOUNT_POST AP
    where  AP.DOC_SELECTED = :DOC_SELECTED
           and AP.ID_ACCOUNT = coalesce(:ID_SRC_ACCOUNT, AP.ID_ACCOUNT)
           and AP.ID_ACCOUNT is distinct from :ID_DEST_ACCOUNT
    order by AP.ID_ACCOUNT asc
    into   :ap_dbkey, :tmp_id_account, :post_value
  do begin
    execute procedure ACCOUNT_POSTING_TRANSFER$INT (:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:id_account is null) then id_account = :tmp_id_account;

    /* update from/to pms account */
    execute procedure PMS_ACCOUNT_POST_TRANSFER$INT(:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:tmp_id_account is distinct from :id_account) then begin
      select A.ACCOUNT_NAME, A.ACCOUNT_CURR
      from   ACCOUNT A
      where  A.ID_ACCOUNT = :id_account
      into   :acc_name, :curr_post;

      action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                    f_character(28) || :id_account || '/' || :acc_name ||
                    f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
      execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
      id_account = :tmp_id_account;
      transfer_value = 0;
    end
    transfer_value = :transfer_value + :post_value;
  end

  if (:id_account is not null) then begin
    select A.ACCOUNT_NAME, A.ACCOUNT_CURR
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :acc_name, :curr_post;
  
    action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                  f_character(28) || :id_account || '/' || :acc_name ||
                  f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
  end
end
^

/* Restore proc. body: ALLOTMENT_SET$AVL */
ALTER PROCEDURE ALLOTMENT_SET$AVL(ID_ALLOTMENT INTEGER,
ID_ROOM_TYPE INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
CNT_ROOMS INTEGER,
ACTIVE_FRAME_BEGIN INTEGER = 0,
ACTIVE_FRAME_END INTEGER = 0)
 RETURNS(ID_ALLOTMENT_DETAIL INTEGER,
NEW_FROM_DATE TYPE OF TDATE,
NEW_TO_DATE TYPE OF TDATE)
 AS
begin
  execute procedure sys_dbg('occ ID_ALLOTMENT = '||coalesce(:id_allotment, 'null'));
  execute procedure sys_dbg('occ ID_ROOM_TYPE = '||coalesce(:ID_ROOM_TYPE, 'null'));
  execute procedure sys_dbg('occ FROM_DATE = '||coalesce(:FROM_DATE, 'null'));
  execute procedure sys_dbg('occ TO_DATE = '||coalesce(:TO_DATE, 'null'));
  execute procedure sys_dbg('occ ACTIVE_FRAME_BEGIN = '||coalesce(:ACTIVE_FRAME_BEGIN, 'null'));
  execute procedure sys_dbg('occ ACTIVE_FRAME_END = '||coalesce(:ACTIVE_FRAME_END, 'null'));
  -- USED FOR CONTINGENTS
  if (:cnt_rooms < 0) then exception ASSERT 'Room count must be greater than 0';
  if (:to_date < :from_date) then exception ASSERT '-501';

  execute procedure ALLOTMENT_SET_ROOMS$INT(:id_allotment, :id_room_type, :from_date, :to_date, :cnt_rooms);

  execute procedure ALLOTMENT_SET_DAYS$INT(:id_allotment, :id_room_type, :from_date, :to_date, :active_frame_begin, :active_frame_end);

  select first 1 AD.ID_ALLOTMENT_DETAIL
  from   ALLOTMENT_DETAIL AD
  where  AD.ID_ALLOTMENT = :id_allotment
         and AD.ID_ROOM_TYPE = :id_room_type
         and AD.FROM_DATE <= :to_date
         and AD.TO_DATE >= :from_date
  into   :id_allotment_detail;

  select cast('31.12.1899' as date) + count(distinct ad.ID_ALLOTMENT),
         cast('31.12.1899' as date) + count(ad.ID_ALLOTMENT_DETAIL)
  from   ALLOTMENT_DETAIL ad
  where  ad.ID_ALLOTMENT is not null
  into   :NEW_FROM_DATE, :NEW_TO_DATE;

end
^

/* Restore proc. body: ALLOTMENT_SET_ROOMS$AVL */
ALTER PROCEDURE ALLOTMENT_SET_ROOMS$AVL(ID_ALLOTMENT INTEGER,
ID_ROOM_TYPE INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
CNT_ROOMS INTEGER)
 AS
declare variable id_allotment_session integer;
begin
  -- USED FOR BOOKING POSITIONS
  if (:cnt_rooms < 0) then exception WRONG_VALUE 'cnt_rooms must be greater than 0';
  if (:to_date < :from_date) then exception WRONG_VALUE 'Wrong period';

  execute procedure ALLOTMENT_SET_ROOMS$INT(:id_allotment, :id_room_type, :from_date, :to_date, :cnt_rooms);
end
^

/* Restore proc. body: AVAILABILITY_RATE_SMALL$WBE */
ALTER PROCEDURE AVAILABILITY_RATE_SMALL$WBE(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER,
ROOMS INTEGER,
ADULTS INTEGER,
CHILDREN INTEGER,
QUERY_ID INTEGER,
PROFILE_ID INTEGER)
 AS
declare variable id_room_type integer;
declare variable nonavaialbility_note varchar(255);
declare variable is_available smallint;
declare variable id_rate integer;
declare variable id_board integer;
declare variable roomtype_list varchar(2000);
declare variable rate_list varchar(2000);
declare variable board_list varchar(2000);
declare variable hotels varchar(255);
declare variable room_status integer;
declare variable rate_status integer;
declare variable rate_min_los integer;
declare variable rate_max_los integer;
declare variable id_channel integer;
declare variable helper_session_id integer;
declare variable error_check integer;
declare variable available_roomtype_list varchar(2000);
declare variable special_rate_list varchar(2000);
declare variable available_rooms integer;
declare variable is_public smallint;
begin
    
  /*Produces data in result table availabiliti_rate$wbe.
   Get availability as AVAILABILITY_OCCUP_SMALL$WBE see there for notes */

  /*empty WBE specific table*/
  delete from product_availability$wbe p
  where p.query_id = :query_id;

  /* find id_channel for wbe*/
  select max(c.id_channel), count(c.id_channel)  from channel c where c.name = 'WBE'
  into :id_channel, :error_check;
  if (not (:error_check = 1)) then  exception WRONG_VALUE 'Missing channel WBE or dublicated definition!';

  /*First check chennel management - find rates, room type for sale and restrictions*/
  special_rate_list = ',';
  available_roomtype_list = ',';
  helper_session_id =  gen_id(SELECTION_GEN, 1);
  for
    select c.id_room_type, c.id_tar_head, c.is_product_avaialable, c.room_status, c.rate_status,
           c.rate_min_los, c.rate_max_los, c.available_rooms, c.is_public
    from   channel_product_avail_req$int (:id_channel, :id_hotel, :from_date, :to_date, :rooms) c
    into   :id_room_type, :id_rate, :is_available, :room_status, :rate_status,
           :rate_min_los, :rate_max_los, :available_rooms, :is_public
  do begin
      /*make a list of available roomt types - needed for special rate product building*/
      if ((:room_status = 2) and (','|| :available_roomtype_list ||',' not containing ','|| :id_room_type ||',')) then
        available_roomtype_list = :available_roomtype_list || :id_room_type ||',';

      /*set nonavaialbility_note*/
      nonavaialbility_note = '';
      if (:is_available = 0) then begin
        if ((:room_status = 0) or (:room_status is null) ) then nonavaialbility_note = '@{No rooms available.} ';
        else begin
            if (:rate_status = 0) then nonavaialbility_note = nonavaialbility_note || '@{Rate is closed.} ';
            if (:rate_status = 1) then nonavaialbility_note = nonavaialbility_note || '@{Rate is closed for arrival.} ';
            if (:rate_status = 2 and :rate_min_los = :rate_max_los) then nonavaialbility_note = nonavaialbility_note || '@{Required stay} ' || rate_min_los || ' @{days.} ';
            if ((:rate_status = 2) and (:rate_min_los > 0) and (:rate_min_los is distinct from :rate_max_los)) then  nonavaialbility_note = nonavaialbility_note || '@{Minimum stay} ' || rate_min_los || ' @{days.} ';
            if ((:rate_status = 2) and (:rate_max_los > 0) and (:rate_min_los is distinct from :rate_max_los)) then  nonavaialbility_note = nonavaialbility_note || '@{Maximum stay} ' || rate_max_los || ' @{days.} ';
        end
      end

      /*insert status and note in int table for this product IF RATE IS PUBLIC or If it is Private but allowed in current profile. Supress 'closed' rate, but show closed for arrival, min los, etc.*/
      /* !! new behaviour - SPECIAL/PRIVATE rates must be managed from CHANNEL MANAGEMENT too */
      if (:rate_status <> 0) then begin
        if (:is_public = 1) then begin
          insert into product_availability$int (session_id, room_type_id, rate_id, is_available, nonavaialbility_note, available_rooms)
          values (:helper_session_id, :id_room_type, :id_rate, :is_available, :nonavaialbility_note, :available_rooms);
        end else begin /* If it is PRIVATE */
          if (exists ( select phr.id_tariff
                        from profile_hotel_rate phr
                        where phr.id_profile = :profile_id
                          and phr.id_hotel = :id_hotel
                          and phr.id_tariff = :id_rate )) then
          begin
              insert into product_availability$int (session_id, room_type_id, rate_id, is_available, nonavaialbility_note, available_rooms)
              values (:helper_session_id, :id_room_type, :id_rate, :is_available, :nonavaialbility_note, :available_rooms);
              /*Making special rate list for indicating in WBE GUI. Rate will be indicated as special if they are private */
              special_rate_list = :special_rate_list || :id_rate ||',';
          end
        end
      end

  end


  /* for available rates - make a rate list. */
  rate_list = ',';
  for
    select distinct pa.rate_id
    from   product_availability$int pa
    where  pa.session_id = :helper_session_id
      /*$$IBEC$$   and pa.is_available = 1 $$IBEC$$*/
    into :id_rate
  do begin
    rate_list = :rate_list || :id_rate || ',';
  end

  /* make a room type list from prepared int table*/
  ROOMTYPE_LIST = ',';
  for
    select distinct pa.room_type_id
    from product_availability$int pa
    where pa.session_id = :helper_session_id
       /*$$IBEC$$  and pa.is_available = 1 $$IBEC$$*/
    into :id_room_type
  do begin
    roomtype_list = :roomtype_list || :id_room_type || ',';
  end

  /* make a list of all boards. Rating will remove non used boards */
  --BOARD_LIST = ',0,'; -- without board
  BOARD_LIST = ',';
  for
    select th.ID_BOARD
    from   MEALS th
    where  th.IS_ARCHIVE = 0
           and th.IS_BOARD = 1
           and th.ID_HOTEL = :ID_HOTEL
           --and th.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
    into   :id_board
  do begin
    BOARD_LIST = :BOARD_LIST || coalesce(:id_board, 0) || ',';
  end

  hotels = ',' || :id_hotel ||',';

  execute procedure sys_dbg('wbe PARAMS FOR  availability_raiting_sub$int :');
  execute procedure sys_dbg('wbe -:helper_session_id = '|| :helper_session_id);
  execute procedure sys_dbg('wbe -:from_date = '|| :from_date);
  execute procedure sys_dbg('wbe -:to_date = '|| :to_date);
  execute procedure sys_dbg('wbe -:rooms = '|| :rooms);
  execute procedure sys_dbg('wbe -:adults = '|| :adults);
  execute procedure sys_dbg('wbe -:children = '|| :children);
  execute procedure sys_dbg('wbe -:roomtype_list = '|| :roomtype_list);
  execute procedure sys_dbg('wbe -:rate_list = '|| :rate_list);
  execute procedure sys_dbg('wbe -:board_list = '|| :board_list);
  execute procedure sys_dbg('wbe -:hotels = '|| :hotels  );
  execute procedure sys_dbg('wbe -:available_roomtype_list = '|| :available_roomtype_list );

  /*calc prices for request in TMP_AVAILABILITY */
  execute procedure AVAILABILITY_RATING_LOOP$INT (:helper_session_id,  :from_date, :to_date,
                    :rooms, :adults, :children, :roomtype_list, :rate_list, :board_list, :hotels);

  /*Copy data to WBE specific table*/
  insert into PRODUCT_AVAILABILITY$WBE
       (query_id, room_type_id, room_name, rate_id, rate_name, board_id, board_name,
       price_night, price_total, currency, is_available, nonavailability_note,
       is_special_rate, available_rooms)
  select :query_id, pa.room_type_id, rt.type_room, pa.rate_id, t.tarifa_name, ta.id_board, th.NAME,
        ta.price, ta.total_price, ta.currency, coalesce( pa.is_available, 0), pa.nonavaialbility_note,
        iif( ','|| :special_rate_list ||',' containing ','|| pa.rate_id ||',', 1, 0), pa.available_rooms
  from  PRODUCT_AVAILABILITY$INT pa /*left outer join*/
        join TMP_AVAILABILITY ta on pa.room_type_id = ta.id_room_type
                                    and pa.rate_id = ta.id_rate
                                    and pa.session_id = ta.ID_SESSION
        join ROOM_TYPES rt on rt.id_room_type =  ta.id_room_type
        join TARIFA t on t.id_tarifa = ta.id_rate
        join MEALS th on th.ID_BOARD = ta.id_board
  where pa.session_id = :helper_session_id;
        --and ta.id_board is not null; -- ???

/*Empty tmp_availability*/
  delete from TMP_AVAILABILITY ta
  where  ta.ID_SESSION = :helper_session_id;

  /*Empty helper in table product_availability$int*/
  delete from  PRODUCT_AVAILABILITY$INT p
  where p.session_id = :helper_session_id;

end
^

/* Restore proc. body: CONTRACT_EXPENSE_POST$INT */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT TYPE OF ID,
ID_HOTEL INTEGER,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
ID_OWNER TYPE OF ID,
OWNERSHIP_PERCENT TYPE OF TPERCENT,
ID_RENTAL_POOL TYPE OF ID_REF,
VALUE_ORIG TYPE OF TPRICE,
CURR_ORIG TYPE OF TCURRENCY,
POST_DATE TYPE OF TDATE,
STAY TYPE OF TCOUNT,
MAX_GUEST_CNT TYPE OF TCOUNT,
BED_NIGHT_CNT TYPE OF TCOUNT,
RESERVS TYPE OF TCOUNT)
 AS
declare variable service_price numeric(15,4);
  declare variable id_currency varchar(3);
  declare variable contract_expense_type varchar(50);
  declare variable id_account integer;
  declare variable post_value numeric(15,4);
  declare variable post_currency varchar(3);
  declare variable id_service integer;
  declare variable is_owner_income smallint;
  declare variable is_client_acc_post smallint;
  declare variable multiplier_type varchar(50);
  declare variable multiplier integer;
  declare variable id_room integer;
  declare variable use_shadow_account integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
begin
  is_owner_income = 0;
  use_shadow_account = iif(:SUB_CONTRACT = 'SHADOW_ACC', 1, 0);

  select r.ID_HOTEL
  from   PMS_EVENT$PMS p
         join ROOMS R on r.ID_ROOM = p.ID_ROOM
  where  p.ID_PMS_EVENT = :ID_PMS_EVENT
  into   :id_hotel;
-- CONTRACT_EXPENSE_TYPE in ( 'PERCENT', 'RUNNING_TOTAL_PERCENT', 'CURR_VALUE' )
-- MULTIPLIER_TYPE in ('RESERVATION', 'STAY', 'GUESTS', 'BED_NIGHTS')
  for
    select C.SERVICE_PRICE, C.ID_CURRENCY, C.CONTRACT_EXPENSE_TYPE, C.IS_ACC_POST_ITEM,
           C.ID_SERVICE, C.MULTIPLIER_TYPE
    from   CONTRACT_EXPENSE$PMS C
    where  C.ID_CONTRACT = :id_contract
           and c.SUB_CONTRACT = :SUB_CONTRACT
    order by C.ORDER_TAG asc
    into   :service_price, :id_currency, :contract_expense_type, :is_client_acc_post,
           :ID_SERVICE, :multiplier_type
  do begin

    execute procedure OWNER_ACCOUNT_GET$INT (coalesce(:ID_RENTAL_POOL,:ID_OWNER),
            :id_hotel, :use_shadow_account, :is_client_acc_post)
    returning_values (:id_account, :is_account$pms);

    multiplier = case
                   when :multiplier_type = 'RESERVATION' then iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'STAY' then :STAY
                   when :multiplier_type = 'GUESTS' then :MAX_GUEST_CNT * iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'BED_NIGHTS' then :BED_NIGHT_CNT
                   else null
                 end;

    if (:multiplier is not null) then begin
      if (:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE') then begin
        post_value = cast(:service_price as double precision) * :ownership_percent / 100 * :multiplier;
        post_currency = :id_currency;
      end else if (:CONTRACT_EXPENSE_TYPE = 'PERCENT') then begin
        post_value = :VALUE_ORIG * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end else if (:CONTRACT_EXPENSE_TYPE = 'RUNNING_TOTAL_PERCENT') then begin
        execute procedure PMS_RUNNING_TOTAL_GET(:ID_PMS_EVENT, coalesce(:ID_RENTAL_POOL,:ID_OWNER), :ID_HOTEL, :POST_DATE, :CURR_ORIG)
        returning_values :post_value;
        if (:post_value < 0) then post_value = 0;
    
        post_value = :post_value * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end

      select pe.ID_ROOM
      from   PMS_EVENT$PMS PE
      where  pe.ID_PMS_EVENT = :ID_PMS_EVENT
      into   :id_room;

      select c.ROUND_TO
      from   CURRS C
      where  c.CURR = :post_currency
      into   :round_to;

      execute procedure PMS_POSTING_CREATE$INT(:ID_PMS_EVENT, :id_account, :id_service, :ID_OWNER,
              :POST_DATE, :post_currency, round_f(:post_value, :round_to), :is_account$pms, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* Restore proc. body: CREATE_BOOKING$WBE */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
declare variable RATE varchar(50);
declare variable ROOM_TYPE varchar(20);
declare variable ARRIVAL date;
declare variable DEPARTURE date;
declare variable ADULTS integer;
declare variable CHILDREN integer;
declare variable PROFILE_NAME varchar(100);
declare variable ARANGER_NAME varchar(100);
declare variable GUEST_PROFILE_UUID varchar(40);
declare variable ARANGER_PROFILE_UUID varchar(40);
declare variable HOTEL_NAME varchar(50);
declare variable WBE_SESSION_ID bigint;
declare variable MAIN_GUEST_PROFILE_ID integer;
declare variable BOARD varchar(50);
declare variable HOTEL_ID integer;
declare variable GUARANTEE_POLICY_NAME varchar(50);
declare variable GUARANTEE_DEPOSIT_PERCENT numeric(15,4);
declare variable GUARANTEE_DEPOSIT_NIGHTS integer;
declare variable GUARANTEE_DUE_DAYS_BEF_ARRIVAL integer;
declare variable GUARANTEE_DUE_DAYS_AFTER_CREATE integer;
declare variable ERR_CODE integer;
declare variable ERR_TEXT varchar(255);
declare variable PROFILE_TYPE varchar(20);
declare variable PROFILE_IMPORT_TIME timestamp;
declare variable B_COUNT integer;
declare variable AGE integer;
declare variable IS_CHILD smallint;
declare variable GUEST_ID integer;
declare variable SPECIAL_TREATMENT varchar(250);
declare variable MAINTENANCE varchar(30);
declare variable ROUTING varchar(20);
declare variable ARRANGER_PAYMENY_TYPE varchar(20);
declare variable MARKET_SEGMENT varchar(30);
declare variable MARKET_SOURCE varchar(30);
declare variable MARKET_CHANNEL varchar(30);
declare variable MARKET_HEAR_REASON varchar(30);
declare variable MARKET_COME_REASON varchar(30);
declare variable FIRST_FOOD varchar(30);
declare variable BNOTE varchar(2000);
begin
  -- get wbe product selection
  select  PA.rate_name,PA.room_name, AQ.first_date, AQ.first_date+AQ.day_count,
          PS.adults, PS.children, PS.person_name, H.hotel_name, H.id_hotel,
          WS.id, PA.board_name, GP.name, GP.deposit_totalsum_part, GP.deposit_nights_count, GP.due_days_before_arrival, GP.due_days_after_create,
          PS.bnote
   from   PRODUCT_SELECTION$WBE PS
          join WBE_SESSION$WBE WS on WS.id = PS.wbe_session_id
          join PRODUCT_AVAILABILITY$WBE PA on pa.id = PS.product_availability_id
          join AVAILABILITY_QUERY$WBE AQ on aq.id = WS.product_query_id
          join HOTEL H on H.id_hotel = WS.hotel_id
          join GUARANTEE_POLICY GP on GP.id_guarantee_policy = PS.guarantee_policy_id
   where  PS.id = :product_selection_id
   into   :rate, :room_type, :arrival, :departure,
          :adults,  :children, :profile_name, :hotel_name, :hotel_id,
          :wbe_session_id, :board, :guarantee_policy_name,
          :guarantee_deposit_percent, :guarantee_deposit_nights,
          :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create,
          :bnote;

  select PA.uuid , PA.profile_name, PA.profile_type
  from   profile PA
  where  PA.id_profile = :aranger_profile_id
  into   :aranger_profile_uuid,:aranger_name,  :profile_type;

  if (:aranger_name = :profile_name and :profile_type = 'PERSON') then begin
    -- aranger is main guest
    select count(*) from PRODUCT_SELECTION$WBE PSC
        where PSC.wbe_session_id = :wbe_session_id
        into :b_count;
       -- only if single reservation bugfix 2228
    if (1 = :b_count) then begin
     guest_profile_uuid =  aranger_profile_uuid;
     aranger_profile_uuid = null;
    end
  end else begin
    -- create profile for main guest
    execute procedure IMPORT_PERSON_PROFILE$EXC(
      uuid_create(),:profile_name,null,null,null,null,null,null,null,null,null,null, null,
      null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
      null,null,null,null,null, 0, 0, null)
    returning_values :main_guest_profile_id, :profile_import_time;

    select P.uuid
    from   profile P
    where  P.id_profile = :main_guest_profile_id
    into   :guest_profile_uuid;
  end

    -- apply default map + forced arranger
    special_treatment = null;
    maintenance = null;
    routing = null;
    arranger_paymeny_type = null;
    market_segment = null;
    market_source = null;
    market_channel = null;
    market_hear_reason = null;
    market_come_reason = null;


  select hc.special_treatment,hk.plan_name,hc.routing,
        pt.payment_type, ms.segment_name,sc.description,cc.description,
        hr.description,cr.description,hc.first_food
  from  hotel_product_cfg$wbe hc
        left join hk_plan hk on hk.id_plan = hc.id_hk_plan
        left join payment_type pt on pt.id_payment_type = hc.arranger_id_payment_type
        left join nom_market_segments ms on ms.id_nom_market_segment = hc.id_m_segment
        left join nom_source_codes sc on sc.id_nom_source_code = hc.id_m_source
        left join nom_channel_codes cc on cc.id_nom_channel_code = hc.id_m_channel
        left join nom_hear_reasons hr on hr.id_nom_hear_reason = hc.id_m_hear_reason
        left join nom_come_reasons cr on cr.id_nom_come_reason = hc.id_m_come_reason
  where hc.hotel_id = :hotel_id
  into  :special_treatment,:maintenance,:routing,:arranger_paymeny_type,
        :market_segment,:market_source,:market_channel,:market_hear_reason,:market_come_reason,:first_food;
  -- create reseravation
  execute procedure IMPORT_BOOKING$EXC(
    :hotel_name, :number, null, null, 0,
    :arrival, null, :departure, null, null, null, null, null, :room_type, :board, null,
     :special_treatment, :maintenance, :routing, :rate, null, null, null, null, :arranger_paymeny_type, null, null, null, null,
     :market_segment, :market_source,:market_channel, :market_hear_reason, :market_come_reason,
     :bnote, null, :first_food, :adults, :children, :aranger_profile_uuid, null, :guest_profile_uuid,
     0, 0, null, :guarantee_policy_name, null, :guarantee_deposit_percent, :guarantee_deposit_nights,
     :guarantee_due_days_bef_arrival,  :guarantee_due_days_after_create, null, null, null, null,  null, null, null, null, null, null)
   returning_values
    :hotel_id ,
    :booking_id,
    :err_code,
    :err_text;

  if (0 <> :err_code) then exception wrong_value ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');

  -- import guests
  for select psg.guest_name,psg.is_child,psg.age from product_selection_guests$wbe psg
  where psg.product_selection_id = :product_selection_id
  into :profile_name,:is_child,:age
  do begin
    execute procedure import_guest$exc(:booking_id, null, null, :profile_name, :is_child, :age, null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null)
    returning_values :guest_id, :err_code,:err_text;
    if (0 <> :err_code) then exception wrong_value ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');
  end
  ----------------

  select RD.number_2
  from   reserv_detail RD
  where  RD.id_reserv_detail = :booking_id
  into   :number_2;

  update product_selection$wbe uPS
  set    uPS.booking_id = :booking_id, uPS.selection_id = :number_2
  where  uPS.id = :product_selection_id;
end
^

/* Restore proc. body: DEPOSIT_REFUND_PAY_ANNUL$INT */
ALTER PROCEDURE DEPOSIT_REFUND_PAY_ANNUL$INT(ID_REFUND_PAYMENT INTEGER,
ANNUL_REASON VARCHAR(255) = '')
 AS
declare variable id_deposit integer;
  declare variable pay_value numeric(15,4);
  declare variable pay_curr varchar(3);
  declare variable id_hotel integer;
  declare variable sys_date date;
  declare variable payment_date date;
begin
  select ap.ID_DEPOSIT, P.PAY_CURRENCY, a.ID_HOTEL, p.PAYMENT_DATE, coalesce(sum(aP.PAY_AMOUNT), 0)
  from   PAYMENT_HEAD P
         join ACCOUNT A on a.ID_ACCOUNT = p.ID_ACCOUNT
         join ACCOUNT_PAYMENTS ap on ap.ID_PAYMENT_HEAD = p.ID_PAYMENT_HEAD
  where  P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT
  group by P.ID_PAYMENT_HEAD, ap.ID_DEPOSIT, P.PAY_CURRENCY, a.ID_HOTEL, p.PAYMENT_DATE
  into   :id_deposit, :pay_curr, :id_hotel, :payment_date, :pay_value;
  /* !!! - check if is real deposit refund */
  if (:id_deposit is null) then EXIT;

  if (:pay_value = 0) then exception PAYMENT_EXCEPTION 'Zero payment amount!';
  /*  */
  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) SD
  into   :sys_date;

  if (:sys_date > :payment_date) then
    exception PAYMENT_ANNUL_EXCEPTION '-349';
    -- Can not void deposit payment for previous date ! May refund it! It's very important for payments control!!!

  execute procedure PAYMENT_ANUL$INT(:ID_REFUND_PAYMENT, :ANNUL_REASON);

  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'REFUND_ANNUL', f_character(29) || formatfloat(:pay_value, 'F;0.00') || ' ' || :pay_curr || f_character(28) || :ANNUL_REASON);

end
^

/* Restore proc. body: EAI_EXT_POST_TO_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable ID_HOTEL integer;
begin
  if (singular(select HS.ID_HOTEL
               from HOTEL_S HS
               where HS.IS_USE = 1)) then
    select H.ID_HOTEL
    from   HOTEL_S H
    where H.IS_USE = 1
    into   :id_hotel;
  else begin
    err_code = -1044;
    exit;
  end

  execute procedure EAI_EXT_POST_TO_MH_FRONT_ONLINE(:ID_HOTEL, :ROOM_NAME,
    :SERVICE_CODE, :CODE_TYPE, :QTY_POST, :PRICE_POST, :CURR_POST, :POST_TEXT)
  returning_values (:ERR_CODE, :ERR_TEXT, :ID_ROOM, :ID_GUEST, :GUEST_NAME1,
    :ID_ACCOUNT, :ID_ACCOUNT_POST, :ID_SERVICE);

end
^

/* Restore proc. body: EAI_IMPORT_ALOYALTY_CLIENT */
ALTER PROCEDURE EAI_IMPORT_ALOYALTY_CLIENT(CLIENT_UUID VARCHAR(40),
CLIENT_NAME VARCHAR(100),
CARD_CODE VARCHAR(50),
IS_ARHIVE SMALLINT,
DATE_OF_BIRTH DATE)
 AS
declare variable PROFILE_ID integer;
  declare variable IMPORT_TIME timestamp;
begin
  execute procedure IMPORT_PERSON_PROFILE$EXC(:CLIENT_UUID, :CLIENT_NAME, null, :DATE_OF_BIRTH, null, null,
    null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null,
    :IS_ARHIVE, :CARD_CODE, null, null, null, null, null, null, null, null, null, null, null, null)
  returning_values :PROFILE_ID, :IMPORT_TIME;
end
^

/* Restore proc. body: EAI_POS_POSTING_ADD */
ALTER PROCEDURE EAI_POS_POSTING_ADD(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
begin
  -- used external inteface - for compatability with Front 2008
  execute procedure EAI_POS_POSTING_ADD$P2E (:IN_ON_GUEST, :IN_ID_ACCOUNT, :IN_ID_GUEST, :IN_DATE_SMETKA,
          :IN_PRICE, :IN_DATETIME, :IN_OBJ_NAME, :IN_TABLE, :IN_SITE, :IN_SMETKA_NUM, :IN_POS_USER,
          :IN_ID_SMETKA, :IN_SERVICE_TAG, :IN_SERVICE_NAME)
  returning_values (:ERR_CODE, :ERR_TEXT, :OUT_ID_ACCOUNT);

end
^

/* Restore proc. body: OCCUPANCY_SUMMARY_REMAKE$SYS */
ALTER PROCEDURE OCCUPANCY_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
begin
  if (not exists (select h.ID_HOTEL
                  from   HOTEL H
                  where  h.ID_HOTEL = :ID_HOTEL)) then exception WRONG_VALUE 'Non-existing hotel!';

  select mindate(sd.SYSTEM_DATE - 1, :TO_DATE)
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :TO_DATE;

  if (:FROM_DATE > :TO_DATE) then exit;

  execute procedure SUMMARY_PREPARE$INT(:id_hotel, :FROM_DATE, :TO_DATE);

  execute procedure SYSTEM_LOG_ADD ('HOTEL', :id_hotel, 'OCCUPANCY_REGENERATE',
                                    f_character(29) || formatdate(:from_date, 'D;dd/mm/yyyy') || f_character(28) || formatdate(:to_date, 'D;dd/mm/yyyy'));
end
^

/* Restore proc. body: PMS_EXPENSE_POSTS_CREATE$INT */
ALTER PROCEDURE PMS_EXPENSE_POSTS_CREATE$INT(ID_ROOM TYPE OF ID,
ID_OWNER TYPE OF ID,
ID_RENTAL_POOL TYPE OF ID_REF,
ID_SERVICE TYPE OF ID,
ID_CURRENCY TYPE OF TCURRENCY,
POST_VALUE TYPE OF TPRICE,
IS_CLIENT_ACC_POST TYPE OF TLOGICAL,
MANUAL_POST_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
IS_POST_PER_POOL TYPE OF TLOGICAL)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF,
NEW_ID_ACCOUNT_POST$PMS ID_REF)
 AS
declare variable event_type varchar(30);
  declare variable id_room_contract integer;
  declare variable new_id_pms_event integer;
  declare variable round_to_orig numeric(15,6);
  declare variable ownership_percent numeric(15,4);
  declare variable curr_contract_owner integer;
  declare variable curr_total_ownership numeric(15,4);
  declare variable curr_total_value numeric(15,4);
  declare variable percent_value numeric(15,4);
  declare variable id_account integer;
  declare variable id_hotel integer;
  declare variable is_account$pms integer;
  declare variable id_acc_post integer;
BEGIN
  event_type = 'MANUAL_EXPENSE';
  curr_total_value = 0;
  curr_total_ownership = 0;

  select RC.ID_ROOM_CONTRACT, r.ID_HOTEL
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS P on RC.ID_ROOM_PERIOD = P.ID_ROOM_PERIOD
         join ROOMS R on R.ID_ROOM = p.ID_ROOM
  where  :MANUAL_POST_DATE between P.FROM_DATE and P.TO_DATE
         and P.ID_ROOM = :ID_ROOM
         and P.STATUS in ('PRIVATE','CONTRACT')
  into   :id_room_contract, :id_hotel;

  if (:ID_ROOM_CONTRACT is null) then exception PMS_EXCEPTION '-615';

  execute procedure PMS_EVENT_CREATE$INT(:EVENT_TYPE, :ID_ROOM, :ID_OWNER, :DESCRIPTION,
          :MANUAL_POST_DATE, null, null, null, null, :POST_VALUE, :POST_VALUE, :ID_CURRENCY, null)
  returning_values :new_id_pms_event;

  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :ID_CURRENCY
  into   :round_to_orig;

  for
    select iif(:ID_OWNER is null, O.OWNERSHIP_PERCENT, 100), O.ID_OWNER
    from   ROOM_CONTRACT$PMS RC
           join ROOM_OWNER$PMS O on O.ID_ROOM_CONTRACT = RC.ID_ROOM_CONTRACT
    where  RC.ID_ROOM_CONTRACT = :id_room_contract
           and ((:ID_OWNER is null) or (O.ID_OWNER = :ID_OWNER))
    into   :ownership_percent, :curr_contract_owner
  do begin
    curr_total_ownership = :curr_total_ownership + :ownership_percent;
    if (:curr_total_ownership = 100) then begin
      percent_value = :post_value - :curr_total_value;
    end else
      percent_value = round_f(:post_value * :ownership_percent / 100, :round_to_orig);

    curr_total_value = :curr_total_value + :percent_value;

    execute procedure OWNER_ACCOUNT_GET$INT (iif(:is_post_per_pool = 1, :id_rental_pool, :curr_contract_owner),
            :id_hotel, 0, :IS_CLIENT_ACC_POST)
    returning_values (:id_account, :is_account$pms);

    execute procedure PMS_POSTING_CREATE$INT(:new_id_pms_event, :ID_ACCOUNT, :ID_SERVICE,
            :curr_contract_owner, :MANUAL_POST_DATE, :ID_CURRENCY, :PERCENT_VALUE, :is_account$pms, 0, :ID_ROOM)
    returning_values :id_acc_post;

    new_id_account_post = null;
    new_id_account_post$pms = null;

    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 1)) then new_id_account_post$pms = :id_acc_post;
    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 0)) then new_id_account_post = :id_acc_post;
    suspend;
  end

  execute procedure PMS_EVENT_SET_ACTIVE$INT(:new_id_pms_event);
END
^

/* Restore proc. body: PMS_POOL_DISTRIBUTION_SUB */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
declare variable cnt_room smallint;
  declare variable curr_total_posted numeric(15,4);
  declare variable cnt integer;
  declare variable value_to_post numeric(15,4);
  declare variable value_to_post_per_owner numeric(15,4);
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable id_room_contract integer;
  declare variable id_owner_account integer;
  declare variable id_pms_event integer;
  declare variable id_hotel integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
begin
  select c.ROUND_TO
  from   CURRS c
  where  c.CURR = :CURR
  into   :round_to;

  if (:is_room_pool = 1) then begin
    cnt_room = 0;
    select count(distinct RP.ID_ROOM)
    from   ROOM_PERIOD$PMS RP
           join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
    where  RC.ID_RENTAL_POOL = :id_rental_pool
           and RP.STATUS in ('PRIVATE','CONTRACT')
           and :for_date between RP.FROM_DATE and RP.TO_DATE
    into   :cnt_room;
    if (coalesce(:cnt_room, 0) = 0) then exception PMS_EXCEPTION;
    curr_total_posted = 0;
    cnt = 0;
    id_pms_event = null;
    id_hotel = null;
    for
      select distinct RP.ID_ROOM, RC.ID_ROOM_CONTRACT, RT.ID_HOTEL
      from   ROOM_PERIOD$PMS RP
             join ROOMS R on R.ID_ROOM = RP.ID_ROOM
             join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and :for_date between RP.FROM_DATE AND RP.TO_DATE
      into   :id_room, :id_room_contract, :id_hotel
    do begin
      id_pms_event = null;

      select E.ID_PMS_EVENT
      from   PMS_EVENT$PMS E
      where  E.ID_ROOM = :id_room
             and E.ID_SESSION = current_transaction
      into   :ID_PMS_EVENT;

      if (:ID_PMS_EVENT is null) then begin
        execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null)
        returning_values :id_pms_event;
        -- FIXME nakraq da se update total_event_value
      end
      if (:cnt_room - :cnt = 1) then begin
        value_to_post = :TOTAL_VALUE_PER_SERVICE - :curr_total_posted;
      end else begin
        value_to_post = round_f(:TOTAL_VALUE_PER_SERVICE / :cnt_room, :round_to);
      end

      curr_total_posted = :curr_total_posted + :value_to_post;
      cnt = :cnt + 1;

      /* ...i se razpredelq mejdu sobstwenicite na staqta */
      value_to_post = abs(:value_to_post);
      for
        select R.ID_OWNER, R.OUT_VALUE
        from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
        into   :id_owner, :value_to_post_per_owner
      do begin
        /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_pool_account,
                :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                0, :IS_OWNER_INCOME, :id_room)
        returning_values :no_use_id_acc_post;
        /* ... i se nachislqwa po sobswtenik */
        execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
        returning_values (:id_owner_account, :is_account$pms);

        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                :is_account$pms, :is_owner_income, :id_room)
        returning_values :no_use_id_acc_post;
      end
    end
  end else begin
    /* distribution by room_param */
    insert into TMP_SELECT$PMS(ID_SESSION, ID_ROOM, ID_OWNER)
    select distinct current_transaction, RP.ID_ROOM, null
    from   ROOM_PERIOD$PMS RP
           join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
    where  RC.ID_RENTAL_POOL = :id_rental_pool
           and RP.STATUS in ('PRIVATE','CONTRACT')
           and :for_date between RP.FROM_DATE and RP.TO_DATE;

    id_hotel = null;
    for
      select P.OUT_VALUE, P.OUT_ID_ROOM, RT.ID_HOTEL
      from   PMS_CALC_VALUE_BY_PARAM(:ID_ROOM_PARAM, :TOTAL_VALUE_PER_SERVICE, :round_to) P
             join ROOMS R on R.ID_ROOM = P.OUT_ID_ROOM
             join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
      into   :value_to_post, :id_room, :id_hotel
    do begin
      id_pms_event = null;
      select E.ID_PMS_EVENT
      from   PMS_EVENT$PMS E
      where  E.ID_ROOM = :id_room
             and E.ID_SESSION = current_transaction
      into   :ID_PMS_EVENT;

      if (:ID_PMS_EVENT is null) then begin
        execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null)
        returning_values :id_pms_event;
        -- FIXME nakraq da se update total_event_value
      end

      /* ...i se razpredelq mejdu sobstwenicite na staqta */
      for
        select distinct RC.ID_ROOM_CONTRACT
        from   ROOM_PERIOD$PMS RP
               join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
        where  RC.ID_RENTAL_POOL = :id_rental_pool
               and RP.STATUS in ('PRIVATE','CONTRACT')
               and RP.ID_ROOM = :id_room
               and :for_date between RP.FROM_DATE and RP.TO_DATE
        into   :id_room_contract
      do begin
        for
          select R.ID_OWNER, R.OUT_VALUE
          from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
          into   :id_owner, :value_to_post_per_owner
        do begin
          /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :ID_POOL_ACCOUNT,
                  :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                  0, :IS_OWNER_INCOME, :id_room)
          returning_values :no_use_id_acc_post;
  
          /* ... i se nachislqwa po sobswtenik */
          execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
          returning_values (:id_owner_account, :is_account$pms);

          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                  :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                  :is_account$pms, :is_owner_income, :id_room)
          returning_values :no_use_id_acc_post;
        end
      end
    end
    delete from TMP_SELECT$PMS T
    where  T.ID_SESSION = current_transaction;
  end
end
^

/* Restore proc. body: PROFILE_COMMON_MODIFY$INT */
ALTER PROCEDURE PROFILE_COMMON_MODIFY$INT(ID_PROFILE INTEGER,
PROFILE_TYPE VARCHAR(20),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
IS_ARCHIVE INTEGER,
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable action_text varchar(255);
  declare variable old_profile_name varchar(100);
  declare variable old_is_archive integer;
  declare variable p_dbkey char(8);
begin
  p_dbkey = null;
  select P.RDB$DB_KEY, P.PROFILE_NAME, P.IS_ARCHIVE
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :p_dbkey, :old_profile_name, :old_is_archive;
   
/*  if (:client_loyalty_card = '') then client_loyalty_card = null;

  if (coalesce(:client_loyalty_card,'') <> '') then begin
    update PROFILE P
    set    P.CLIENT_LOYALTY_CARD = null
    where  P.CLIENT_LOYALTY_CARD = :client_loyalty_card
           and P.RDB$DB_KEY is distinct from :p_dbkey;
  end
*/
  is_exclusive_debt_ownership = coalesce(:is_exclusive_debt_ownership, 0);
  new_id_profile = :id_profile;
  if (:p_dbkey is null) then begin
    execute procedure SYSTEM_CHECK_OPERATION (:PROFILE_TYPE, 'PERSON,AGENT,HOUSE', 'Profile type');

    new_id_profile = gen_id(gen_profile_id, 1);
    insert into PROFILE (ID_PROFILE, PROFILE_NAME, PROFILE_TYPE,
           PHONE, FAX, EMAIL, CITY, ADDRESS, NOTE, MSG,
           ID_DEF_CONTRAGENT, ID_NOM_MARKET_SEGMENT, IS_ARCHIVE, ACCOUNT_NO,
           WBE_PASSWORD, IS_EXCLUSIVE_DEBT_OWNERSHIP)
    values (:new_id_profile, :profile_name, :profile_type,
           :phone, :fax, :email, :contact_city, :contact_address, :note, :msg,
           :id_def_contragent, :id_nom_market_segment, 0, :account_no,
           nullif(:wbe_password, ''), :is_exclusive_debt_ownership)
    returning RDB$DB_KEY into :p_dbkey;
  end else begin
    update PROFILE PU
    set    PU.PROFILE_NAME = :profile_name,
           PU.PHONE = :phone,
           PU.FAX = :fax,
           PU.EMAIL = :email,
           PU.CITY = :contact_city,
           PU.ADDRESS = :contact_address,
           PU.NOTE = :note,
           PU.MSG = :msg,
           PU.ID_DEF_CONTRAGENT = :id_def_contragent,
           PU.ID_NOM_MARKET_SEGMENT = :id_nom_market_segment,
           PU.ACCOUNT_NO = :ACCOUNT_NO,
           PU.WBE_PASSWORD = iif(PU.WBE_PASSWORD is null and :wbe_password = '', null, :wbe_password),
           -- empty ('') new password should not relpace NULLs,
           -- empty password indicate for 'deleted real password'
           PU.IS_EXCLUSIVE_DEBT_OWNERSHIP = :IS_EXCLUSIVE_DEBT_OWNERSHIP
    where  PU.RDB$DB_KEY = :p_dbkey;
  
    if (:old_profile_name <> :profile_name) then begin
      action_text = f_character(29) || :old_profile_name || f_character(28) || :profile_name;
      execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'EDIT_NAME', :action_text);
    end
  
    if (:is_archive is distinct from :old_is_archive) then
      execute procedure PROFILE_SET_ARCHIVE$INT (:P_DBKEY, :IS_ARCHIVE);
   end
end
^

/* Restore proc. body: REP_ROOM_STATUS$INT */
ALTER PROCEDURE REP_ROOM_STATUS$INT(FOR_DATE DATE,
STAT_OPTIONS VARCHAR(255),
PRIVATE_STATUS_ADDING SMALLINT = 0)
 RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
SECTOR INTEGER,
ID_ROOM_TYPE INTEGER,
TYPE_ROOM VARCHAR(20),
IS_CLEAN INTEGER,
IS_INSPECTED INTEGER,
CLEAN_TEXT VARCHAR(30),
IS_LEAVING SMALLINT,
IS_COMMING SMALLINT,
IS_SHARED SMALLINT,
IS_LEAVING_WORDS VARCHAR(30),
BUSY_GRP INTEGER,
DAYS_THIS_STATUS INTEGER,
DTS_CONTEXT VARCHAR(10),
COMMING_OCCUPANTS VARCHAR(1024),
ID_BLOCK_ROOM INTEGER,
OTHER_OCCUPANTS VARCHAR(1024),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ID_HOTEL INTEGER,
HAS_OPENED_POSTINGS SMALLINT)
 AS
declare variable dbg varchar(6000);
  declare variable id_room_tmp integer;
  declare variable id_room_magic integer;
  declare variable occupant_id integer;
begin
  for
    select RM.ID_ROOM_MAGIC, RM.ID_ROOM
    from   ROOMS R
           join TMP_SMART_ROOMS TSR on TSR.ID_ROOM = R.ID_ROOM
                and TSR.ID_SESSION = current_connection
           join ROOM_MAGIC RM on RM.ID_ROOM = R.ID_ROOM
    where  RM.BUSY_DATE = :for_date
    into   :id_room_magic, :id_room_tmp
  do begin
    insert into TMP_HM_ROOM_STATUS (ID_ROOMS_MAGIC, ID_SESSION, ID_ROOM)
    values (:id_room_magic, current_transaction, :id_room_tmp);
  end

  for
    select R.ID_ROOM, R.ROOM_NAME, R.FLOOR, R.ID_ROOM_TYPE,
           R.IS_CLEAN, R.CLEAN_TEXT, R.IS_INSPECTED,
           RT.TYPE_ROOM, RT.ID_HOTEL, R.SECTOR
    from   (select distinct P.ID_ROOM
            from   TMP_SMART_ROOMS TSR
                   join ROOM_PERIOD$PMS P on P.ID_ROOM = TSR.ID_ROOM
            where  TSR.ID_SESSION = current_connection
                   and ((P.IS_AVAILABLE = 1) or (:private_status_adding = 1))
                   and P.FROM_DATE <= :for_date
                   and P.TO_DATE >= :for_date) AVR
           join ROOMS R on AVR.ID_ROOM = R.ID_ROOM
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    into   :id_room, :room_name, :floor, :id_room_type,
           :is_clean, :clean_text, :is_inspected,
           :type_room, :id_hotel, :sector
  do begin

    execute procedure REP_ROOM_STATUS_BUILD$INT(:id_room, :for_date, :stat_options)
    returning_values  :is_leaving, :is_comming, :is_shared, :is_leaving_words, :busy_grp,
                      :days_this_status, :dts_context, :comming_occupants, :id_block_room,
                      :other_occupants, :adult_count, :children_count;

    is_comming = iif(:comming_occupants = '', 0, 1);

    HAS_OPENED_POSTINGS = 0;
    for
      select distinct sp.ITEM
      from   SYSTEM_STRING_PARSER (:other_occupants || ',' || :COMMING_OCCUPANTS, ',') SP
      into   :occupant_id
    do begin
      execute procedure RES_GET_BALLANCE$INT (:occupant_id)
      returning_values :dbg, :dbg, :dbg, :HAS_OPENED_POSTINGS, :dbg;
      if (:HAS_OPENED_POSTINGS = 1) then break;
    end

    suspend;

  end

  delete from TMP_HM_ROOM_STATUS HM
  where  HM.ID_SESSION = current_transaction;
end
^

/* Restore proc. body: RES_ANUL_DETAIL$INT */
ALTER PROCEDURE RES_ANUL_DETAIL$INT(RD_DBKEY CHAR(8),
REASON VARCHAR(50),
CANCELATION_NUMBER TYPE OF NAME_20 = null)
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable id_reserv_detail integer;
  declare variable is_anul integer;
  declare variable id_log_event integer;
  declare variable id_guest integer;
  declare variable g_dbkey char(8);
  declare variable no_use varchar(255);
  declare variable tmp_extra_posts_left smallint;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:reason, 'NOSHOW, CANCELED, USERERROR, TRANSFER', 'Annul reason');

  select RD.IS_ANUL, RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :is_anul, :id_reserv_detail;

  if (:is_anul = 1) then begin
    exception BOOKING_EXCEPTION '-1021';
    -- Reservation is already annuled or checkedin !
  end

  if (:reason = 'NOSHOW') then begin
    execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    returning_values  :no_use, :no_use;

    -- execute procedure TAR_CALC_FINALIZE$INT(:err_code, :id_tar_calc, :rd_dbkey); -- this procedure is enclosed into RES_FINALIZE_RECALC$INT
    -- err_code = 0; -- IGNORE ALL ERRORS
  end

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_ANUL', f_character(29) || :reason);

  id_log_event = RDB$GET_CONTEXT('USER_TRANSACTION', 'ACTION_LOG_ID');

  update RESERV_DETAIL RDU
  set    RDU.IS_ANUL = 1,
         RDU.REASON_OF_ANUL = :reason,
         RDU.ID_LOG_EVENT_ANNUL = :id_log_event,
         RDU.CANCELATION_NUMBER = coalesce(:CANCELATION_NUMBER, strhash_large(rdu.NUMBER || 'CANCELATION'))
  where  RDU.RDB$DB_KEY = :rd_dbkey;

  EXTRA_POSTS_LEFT = 0;
  for
    select g.ID_GUEST, G.RDB$DB_KEY
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_guest, :g_dbkey
  do begin
    execute procedure GUEST_DEL_POSTINGS$INT(:id_guest)
    returning_values  :tmp_extra_posts_left;
    EXTRA_POSTS_LEFT = iif(:EXTRA_POSTS_LEFT = 1, 1, :tmp_extra_posts_left);

    update GUEST G
    set    G.UUID = null
    where  g.RDB$DB_KEY = :g_dbkey;
  end

  execute procedure RES_FINALIZE$INT (:RD_DBKEY, 0)
  returning_values (:warn_code);

  execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

end
^

/* Restore proc. body: RES_EARLY_DEPARTURE_SET$RSV */
ALTER PROCEDURE RES_EARLY_DEPARTURE_SET$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND INTEGER)
 RETURNS(RECALC_MARKER_LIST VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable sys_date date;
  declare variable stay integer;
  declare variable rd_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable id_hotel integer;
  declare variable hotels_cnt integer;
  declare variable arrival_date date;
  declare variable is_late_departure smallint;
  declare variable comming_kind smallint;
  declare variable dep_date date;
begin
  /* CHECK_OUT_kind =
  || 1 - DO NOT MODIFY GUEST
  || 2 - SHRINK PERIOD AND OCCUPANCY
  || 3 - DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
  */
  execute procedure RIGHTS_CHECK_GRANTED$INT('CHECK_OUT_EARLY');

  select min(RD.ID_HOTEL), count(distinct RD.ID_HOTEL)
  from   RESERV_DETAIL RD
  where  RD.SELECTION_ID = :SELECTION_ID
  into   :id_hotel, :hotels_cnt;

  if (:hotels_cnt > 1) then exception RESERV_CHECK_OUT_EXCEPTION '-1020';

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values  :sys_date;

  RECALC_MARKER_LIST = null;
  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL, rd.FROM_DATE, rd.TO_DATE, RD.LEAVING_KIND - 1, rd.COMMING_KIND
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :rd_dbkey, :id_reserv_detail, :arrival_date, :dep_date, :is_late_departure, :comming_kind
  do begin
    if ((:check_out_kind = 2) and (:dep_date > :sys_date)) then begin
      -- SHRINK PERIOD AND OCCUPANCY
      execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :sys_date, :is_late_departure, :comming_kind);
    
      execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
      returning_values  :warn_code;

    end else if ((:check_out_kind = 1) and (:dep_date > :sys_date)) then begin
      /* KEEP BOOKING STAY PERIOD AND ROOM OCCUPANCY */
      for
        select G.TO_DATE - :sys_date
        from   GUEST G
        where  G.ID_RESERV_DETAIL = :id_reserv_detail
        into   :stay
      do begin
  --      if (:check_out_kind = 1) then begin
        if (:stay > 1) then begin
            --THE DEPARTURE DATE IS LATER THAN NEXT DATE. STAY SHOULD BE CHANGED MANUALY.;
            exception RESERV_CHECK_OUT_EXCEPTION '-323';
        end
      end
    end
  end
end
^

/* Restore proc. body: RES_FINALIZE_RECALC$INT */
ALTER PROCEDURE RES_FINALIZE_RECALC$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_calc integer;
begin
  -- NORMAL recalculation processing
  execute procedure RES_RECALC$INT(:rd_dbkey, 'NORMAL', 0)
  returning_values  :err_code, :err_text, :id_tar_calc;
  if (:err_code < 0) then exit;

end
^

/* Restore proc. body: RES_SAVE_ACCOUNTING$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
declare variable old_id_agent_profile integer;
  declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable action_text varchar(255);
  declare variable old_account_routing varchar(30);
  declare variable id_acc_profile integer;
begin
  /* Description : ACC_ROUTING = {GUEST, AGENT, MIXED, OWNER, GUEST_SEPARATE_ACCOUNTS, PART_COMPLIMENTARY, FULL_COMPLIMENTARY }
  ||
  *//*
  execute procedure RES_SAVE_PROFILING$INT (:RD_DBKEY, :ID_AGENT_PROFILE, :ID_AGENT_ACCOUNT, :ID_AGENT_PAYMENT,
          :id_person_profile, :ID_PERSON_PAYMENT, :ACC_ROUTING, :ID_GROUP);
  */
  execute procedure SYSTEM_CHECK_OPERATION(:acc_routing, 'GUEST, AGENT, MIXED, OWNER, FULL_COMPLIMENTARY, PART_COMPLIMENTARY', 'Account routing');

  if (exists (select *
              from   PROFILE_HOUSE PH
              where  PH.ID_PROFILE = :id_agent_profile)) then
  begin
    exception BOOKING_EXCEPTION '-1016';
  end

  execute procedure RESERV_TRACK_CHANGES$INT(:rd_dbkey);

  select RD.ID_AGENT_PROFILE, RD.ID_RESERV_DETAIL, RD.ACC_ROUTING
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_agent_profile, :id_reserv_detail, :old_account_routing;

  if (:ACC_ROUTING in ('AGENT','MIXED') and :ID_AGENT_ACCOUNT is not null) then begin
    select A.ID_PROFILE
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :ID_AGENT_ACCOUNT
    into   :id_acc_profile;
    -- check up agent account ownership
    if (:id_acc_profile is distinct from :ID_AGENT_PROFILE) then ID_AGENT_ACCOUNT = null;
--    if (:id_acc_profile is distinct from :ID_AGENT_PROFILE) then exception BOOKING_EXCEPTION '-1026';
  end

  update RESERV_DETAIL RD
  set    RD.ID_AGENT_ACCOUNT_RULE = :ID_AGENT_ACCOUNT,
         RD.ACC_ROUTING = :ACC_ROUTING,
         RD.ID_AGENT_PROFILE = :ID_AGENT_PROFILE,
         RD.ID_AGENT_PAYMENT = :ID_AGENT_PAYMENT,
         --RD.ID_PERSON_PROFILE = :ID_PERSON_PROFILE,
         RD.ID_PERSON_PAYMENT = coalesce(:ID_PERSON_PAYMENT, RD.ID_PERSON_PAYMENT),
         RD.ID_GROUP = :ID_GROUP
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_id_agent_profile is distinct from :id_agent_profile) then begin
    execute procedure RES_SET_EDIT_STATUS$INT(:RD_DBKEY, 'AGENT', 'add');

    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :g_dbkey
    do begin
      execute procedure GUEST_AGENT_SET$INT(:g_dbkey, :id_agent_profile);
    end

    select f_character(29)||coalesce(old_A.PROFILE_NAME, '')||f_character(28)||coalesce(new_A.PROFILE_NAME, '')
    from   PROFILE old_A, PROFILE new_A
    where  old_A.ID_PROFILE = :old_id_agent_profile
           and new_A.ID_PROFILE = :ID_AGENT_PROFILE
    into   :action_text;

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_AGENT', :action_text);
  end

  if (:ACC_ROUTING <> :old_account_routing) then begin
    action_text = f_character(29) || coalesce(:old_account_routing, '')
                  || f_character(28) || coalesce(:acc_routing, '');

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_ACC_ROUTING', :action_text);
  end

  execute procedure RES_SAVE_ACCOUNTS$INT (:RD_DBKEY);
end
^

/* Restore proc. body: SAFE_CHECK_OUT */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE TYPE OF ID)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
WARN_CODE TYPE OF ID_REF)
 AS
declare variable to_dt timestamp;
  declare variable is_occupied integer;
  declare variable expire_tollerance integer;
  declare variable occupant_name varchar(100);
  declare variable id_resource_reservation integer;
  declare variable check_out_datetime timestamp;
begin
  DOC_SELECTED = null;
  select s.IS_OCCUPIED, od.TO_DATETIME,
         st.EXPIRE_TOLLERANCE, rr.OCCUPANT_NAME, rr.ID_RESOURCE_RESERVATION
  from   SAFE s
         join RESOURCE$INT r on r.ID_RESOURCE = s.ID_SAFE
         join SAFE_TYPES st on st.ID_SAFE_TYPE = r.ID_RESOURCE_TYPE
         join RESOURCE_RESERVATION rr on rr.ID_RESOURCE_RESERVATION = s.ID_CURRENT_OCCUPANCY
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join RESOURCE_OCCUPANCY ro on ro.ID_RESOURCE_OCCUPANCY_DATA = od.ID_RESOURCE_OCCUPANCY_DATA
  where  s.ID_SAFE = :ID_SAFE
  into   :is_occupied, :to_dt, :expire_tollerance, :occupant_name, :id_resource_reservation;

  if (:is_occupied = 0) then exit;

  expire_tollerance = coalesce(:expire_tollerance, 0);
  check_out_datetime = current_timestamp;

  execute procedure SAFE_OCCUPANCY_MODIFY (:id_safe, current_timestamp, :occupant_name)
  returning_values  :DOC_SELECTED;

  if (:check_out_datetime > (:to_dt + cast(:expire_tollerance as double precision) / 60 / 24)) then begin
    execute procedure SYSTEM_WARNING_ADD (-1066, f_character(29) || :expire_tollerance || f_character(28) || formatdate(:to_dt + cast(:expire_tollerance as double precision) / 60 / 24, 'D;dd/mm/yyyy HH:MM'))
    returning_values (:WARN_CODE);
  end

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = null
  where  s.ID_SAFE = :ID_SAFE;

  update RESOURCE_RESERVATION rr
  set    rr.STATUS = 'CHECKED_OUT'
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_CHECKED_OUT', :occupant_name);
end
^

/* Restore proc. body: TAR_CALC_INPUT_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_PARAMS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_input integer;
  declare variable id_guest integer;
  declare variable for_date date;
  declare variable id_calc_tariff integer;
  declare variable td_dbkey char(8);
  declare variable date_independent_param_values varchar(2000);
  declare variable date_dep_param_values varchar(2000);
  declare variable prev_id_guest integer;
  declare variable prev_id_tariff integer;
begin
  prev_id_guest = null;
  prev_id_tariff = null;
  for
    select Td.RDB$DB_KEY, TI.ID_TAR_INPUT, ti.ID_GUEST, td.FOR_DATE, td.ID_TAR_HEAD
    from   TAR_CALC_INPUT$TMP TI
           join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
    where  TI.ID_TAR_CALC = :id_tar_calc
    order by ti.ID_GUEST asc, td.FOR_DATE asc
    into   :td_dbkey, :id_tar_input, :id_guest, :for_date, :id_calc_tariff
  do begin
    if ((:id_guest is distinct from :prev_id_guest)
        or (:id_calc_tariff is distinct from :prev_id_tariff)) then
    begin
      /* get date independent params */
      execute procedure TAR_CALC_PARAMS$INT (:id_calc_tariff, :id_tar_input, :ID_TAR_CALC, null, null)
      returning_values (:ERR_CODE, :date_independent_param_values);
      if (:ERR_CODE < 0) then exit;
      prev_id_guest = :id_guest;
      prev_id_tariff = :id_calc_tariff;
    end

    execute procedure TAR_CALC_PARAMS$INT (:id_calc_tariff, :id_tar_input, :ID_TAR_CALC, :for_date, null)
    returning_values (:ERR_CODE, :date_dep_param_values);
    if (:ERR_CODE < 0) then exit;

    update TAR_CALC_INPUT_DETAIL$TMP d
    set    d.PARAM_VALUES = coalesce(:date_independent_param_values, '') || ';'
                            || coalesce(:date_dep_param_values, '')
    where  d.RDB$DB_KEY = :td_dbkey;
  end
end
^

SET TERM ; ^

ALTER TABLE ALLOTMENT_DETAIL$TMP ALTER COLUMN ID_ALLOTMENT_SESSION POSITION 1;

ALTER TABLE ALLOTMENT_DETAIL$TMP ALTER COLUMN ID_ALLOTMENT POSITION 2;

ALTER TABLE ALLOTMENT_DETAIL$TMP ALTER COLUMN ID_ROOM_TYPE POSITION 3;

ALTER TABLE ALLOTMENT_DETAIL$TMP ALTER COLUMN FOR_DATE POSITION 4;

ALTER TABLE ALLOTMENT_DETAIL$TMP ALTER COLUMN CNT_ROOMS POSITION 5;

ALTER TABLE ALLOTMENT_DETAIL$TMP ALTER COLUMN ACTIVE_FRAME_BEGIN POSITION 6;

ALTER TABLE ALLOTMENT_DETAIL$TMP ALTER COLUMN ACTIVE_FRAME_END POSITION 7;

ALTER TABLE ALLOTMENT_DETAIL$TMP ALTER COLUMN SEQ POSITION 8;

ALTER TABLE ALLOTMENT_DETAIL$TMP ALTER COLUMN DIFF_NO POSITION 9;

ALTER TABLE RESERV_STAY$TMP ALTER COLUMN ID_RESERV_DETAIL POSITION 1;

ALTER TABLE RESERV_STAY$TMP ALTER COLUMN FOR_DATE POSITION 2;

ALTER TABLE RESERV_STAY$TMP ALTER COLUMN ID_SESSION POSITION 3;

ALTER TABLE RESERV_STAY$TMP ALTER COLUMN ID_ROOM POSITION 4;

ALTER TABLE ROOM_MAGIC ALTER COLUMN ID_ROOM_MAGIC POSITION 1;

ALTER TABLE ROOM_MAGIC ALTER COLUMN BUSY_DATE POSITION 2;

ALTER TABLE ROOM_MAGIC ALTER COLUMN ID_ROOM POSITION 3;

ALTER TABLE ROOM_MAGIC ALTER COLUMN ID_ROOM$INT POSITION 4;

ALTER TABLE ROOM_MAGIC ALTER COLUMN ID_ROOM_TYPE POSITION 5;

ALTER TABLE ROOM_MAGIC ALTER COLUMN ID_AGENT POSITION 6;

ALTER TABLE ROOM_MAGIC ALTER COLUMN COUNTRY POSITION 7;

ALTER TABLE ROOM_MAGIC ALTER COLUMN DAY_ACTION_INT POSITION 8;

ALTER TABLE ROOM_MAGIC ALTER COLUMN DAY_ACTION POSITION 9;

ALTER TABLE ROOM_MAGIC ALTER COLUMN BUSY_GROUP_TYPE POSITION 10;

ALTER TABLE ROOM_MAGIC ALTER COLUMN BUSY_TYPE POSITION 11;

ALTER TABLE ROOM_MAGIC ALTER COLUMN ID_HOTEL POSITION 12;

ALTER TABLE ROOM_MAGIC ALTER COLUMN ID_RESERV_DETAIL POSITION 13;

ALTER TABLE ROOM_MAGIC ALTER COLUMN GST_AD_IN POSITION 14;

ALTER TABLE ROOM_MAGIC ALTER COLUMN GST_AD_OUT POSITION 15;

ALTER TABLE ROOM_MAGIC ALTER COLUMN GST_AD_STAY POSITION 16;

ALTER TABLE ROOM_MAGIC ALTER COLUMN GST_CH_IN POSITION 17;

ALTER TABLE ROOM_MAGIC ALTER COLUMN GST_CH_OUT POSITION 18;

ALTER TABLE ROOM_MAGIC ALTER COLUMN GST_CH_STAY POSITION 19;

ALTER TABLE ROOM_MAGIC ALTER COLUMN ADULT_COUNT POSITION 20;

ALTER TABLE ROOM_MAGIC ALTER COLUMN CHILDREN_COUNT POSITION 21;

ALTER TABLE ROOM_MAGIC ALTER COLUMN ROOM_STATUS POSITION 22;

