/* Server version: WI-V6.3.4.18393 Firebird 2.1 
   SQLDialect: 3. ODS: 11.1. Forced writes: On. Sweep inteval: 20000.
   Page size: 8192. Cache pages: 2048 (16384 Kb). Read-only: False. */
SET SQL DIALECT 3;

ALTER TABLE SERVICES DROP CONSTRAINT CHK_SERVICES;

/* Alter Procedure (Before Drop)... */
SET TERM ^ ;

ALTER PROCEDURE PMS_ACCOUNT_POST_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_DEST_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^


/* Drop Procedure... */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
 BEGIN EXIT; END
^

SET TERM ; ^

DROP PROCEDURE PMS_ACCOUNT_POST_TRANSFER$INT;


ALTER TABLE DEPOSIT ADD ID_BILLING_SERVICE ID_REF;

ALTER TABLE TAR_CALC_INPUT$TMP ADD ID_RATE_OVERRULE ID_REF;

COMMENT ON COLUMN SERVICES.SERVICE_TYPE IS
'SERVICE_TYPE in (''BASE'',''EXTRA'',''COMMISSION'',''MEAL'',''ADVANCE_PAYMENT'')';

/* Drop table-fields... */
/* Empty PMS_EVENT_CREATE$INT for drop PMS_EVENT$PMS(ROOM_OWNERSHIP_PERCENT) */
SET TERM ^ ;

ALTER PROCEDURE PMS_EVENT_CREATE$INT(EVENT_TYPE VARCHAR(30),
ID_ROOM INTEGER,
ID_OWNER INTEGER,
DESCRIPTION VARCHAR(255),
MANUAL_POST_DATE DATE,
IMPORT_PERIOD_FROM DATE,
IMPORT_PERIOD_TO DATE,
ID_RESERV_DETAIL INTEGER,
ID_DOC_HEAD INTEGER,
PRICE_WITH_VAT NUMERIC(15,4),
PRICE_WO_VAT NUMERIC(15,4),
CURR VARCHAR(3),
ID_EXPORT_HEAD INTEGER,
RESERVS INTEGER = null,
STAY INTEGER = null,
BEDNIGHTS INTEGER = null,
ID_ROOM_CONTRACT INTEGER = null,
DOC_DESCRIPTION /* TDESCRIPTION_LONG */ VARCHAR(255) = null)
 RETURNS(NEW_ID_PMS_EVENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE NON_DOCUMENTED_INFO_GET$INT(ID_OWNER INTEGER,
ID_ROOM INTEGER)
 RETURNS(OUT_LATE_INFO VARCHAR(255),
OUT_CURR_INFO VARCHAR(255),
OUT_NEXT_INFO VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE OWNER_BILL_MODIFY$PMS(ID_OWNER_BILL INTEGER,
ID_OWNER INTEGER,
BILLING_DATE DATE,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_OWNER_BILL INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP VIEW OWNER_POST;

ALTER TABLE PMS_EVENT$PMS DROP ROOM_OWNERSHIP_PERCENT;


/* Create Procedure... */
SET TERM ^ ;

CREATE PROCEDURE ACCOUNT_POST_EVENT_REROUTE$INT(AP_DBKEY TYPE OF TDB_KEY,
ID_DEST_ACCOUNT TYPE OF ID)
 AS
 BEGIN EXIT; END
^


/* Create Views... */
/* Create view: OWNER_POST */
SET TERM ; ^

CREATE VIEW OWNER_POST(
POST_DATE,
ID_RESERV_DETAIL,
RES_FROM_DATE,
RES_TO_DATE,
RES_STAY,
INCOME_CURR,
INCOME_VALUE,
OUTGO_CURR,
OUTGO_VALUE,
ID_ACCOUNT_POST,
ID_ACCOUNT_POST$PMS,
ID_SERVICE,
POST_STATUS,
IS_ANUL,
DESCRIPTION_EVENT,
ID_PMS_EVENT,
IS_INVOICED,
DOC_DESCRIPTION,
ID_ROOM,
OWNER_PERC,
ID_OWNER,
IS_POOL,
ID_HOTEL,
IS_OWNER_INCOME)
 AS 
select AP.DATE_POST as POST_DATE,
       E.ID_RESERV_DETAIL,
       E.IMP_PERIOD_FROM as RES_FROM_DATE,
       E.IMP_PERIOD_TO + 1 as RES_TO_DATE,
       E.IMP_PERIOD_TO - E.IMP_PERIOD_FROM + 1 as RES_STAY,
       iif(AP.IS_OWNER_INCOME = 1, AP.CURR_POST, NULL) as INCOME_CURR,
       iif(AP.IS_OWNER_INCOME = 1, round_f(AP.VALUE_POST, C.ROUND_TO), NULL) as INCOME_VALUE,
       iif(AP.IS_OWNER_INCOME = 0, AP.CURR_POST, NULL) as OUTGO_CURR,
       iif(AP.IS_OWNER_INCOME = 0, round_f(AP.VALUE_POST, C.ROUND_TO), NULL) as OUTGO_VALUE,
       null as ID_ACCOUNT_POST,
       AP.ID_ACCOUNT_POST as ID_ACCOUNT_POST$PMS,
       AP.ID_SERVICE as ID_SERVICE,
       AP.LINE_STATUS as POST_STATUS,
       iif(AP.LINE_STATUS=22,1,0) as IS_ANUL,
       E.DESCRIPTION as DESCRIPTION_EVENT,
       E.ID_PMS_EVENT as ID_PMS_EVENT,
       null as IS_INVOICED,
       coalesce(E.DOC_DESCRIPTION, E.ID_DOC_HEAD) as DOC_DESCRIPTION,
       E.ID_ROOM as ID_ROOM,
       --(iif(O.ID_RENTAL_POOL_UNIT is null, E.ROOM_OWNERSHIP_PERCENT, 0)) as OWNER_PERC,
       iif(O.ID_RENTAL_POOL_UNIT is null, ro.OWNERSHIP_PERCENT, 0) as OWNER_PERC,
       ACC.ID_OWNER as ID_OWNER,
       iif(O.ID_RENTAL_POOL_UNIT is null, 0, 1) as IS_POOL,
       ACC.ID_HOTEL,
       AP.IS_OWNER_INCOME
from PMS_EVENT$PMS E
  join ACCOUNT_POST$PMS AP on AP.ID_PMS_EVENT = E.ID_PMS_EVENT
  join ACCOUNT$PMS ACC on ACC.ID_ACCOUNT = AP.ID_ACCOUNT_PMS
  join OWNER$PMS O on O.ID_OWNER = ACC.ID_OWNER
  join ROOM_OWNER$PMS ro on ro.ID_ROOM_CONTRACT = e.ID_ROOM_CONTRACT and ro.ID_OWNER = o.ID_OWNER
  join CURRS C on C.CURR = AP.CURR_POST
where AP.LINE_STATUS in (11,22)
     and ACC.IS_SHADOW = 0
union all
select AP.DATE_POST as POST_DATE,
       E.ID_RESERV_DETAIL,
       E.IMP_PERIOD_FROM as RES_FROM_DATE,
       E.IMP_PERIOD_TO + 1 as RES_TO_DATE,
       E.IMP_PERIOD_TO - E.IMP_PERIOD_FROM + 1 as RES_STAY,
       null as INCOME_CURR,
       null as INCOME_VALUE,
       O.ID_CURRENCY as OUTGO_CURR,
       round_f((AP.QTY_POST * AP.PRICE_POST - AP.IN_DOC_QTY * AP.IN_DOC_VALUE) * iif(O.ID_CURRENCY = AP.CURR_POST, 1,
                                                                                    (select CR.RATE
                                                                                     from   CURR_CROSS_RATE_GET(AP.CURR_POST, O.ID_CURRENCY, AP.DATE_POST, ACC.ID_HOTEL) CR)),
               c.ROUND_TO) as OUTGO_VALUE,
       AP.ID_ACCOUNT_POST as ID_ACCOUNT_POST,
       null as ID_ACCOUNT_POST$PMS,
       AP.ID_SERVICE as ID_SERVICE,
       iif(AP.IS_ANUL = 0, 11, 22) as POST_STATUS,
       AP.IS_ANUL as IS_ANUL,
       E.DESCRIPTION as DESCRIPTION_EVENT,
       E.ID_PMS_EVENT as ID_PMS_EVENT,
       0 as IS_INVOICED,
       coalesce(E.DOC_DESCRIPTION, E.ID_DOC_HEAD) as DOC_DESCRIPTION,
       AP.ID_ROOM,
       --(iif(O.ID_RENTAL_POOL_UNIT is null, E.ROOM_OWNERSHIP_PERCENT, 0)) as OWNER_PERC,
       iif(O.ID_RENTAL_POOL_UNIT is null, ro.OWNERSHIP_PERCENT, 0) as OWNER_PERC,
       ACC.ID_PROFILE as ID_OWNER,
       iif(O.ID_RENTAL_POOL_UNIT is null, 0, 1) as IS_POOL,
       ACC.ID_HOTEL,
       null as IS_OWNER_INCOME
from ACCOUNT ACC
  join ACCOUNT_POST AP on ACC.ID_ACCOUNT = AP.ID_ACCOUNT
  join OWNER$PMS O on O.ID_OWNER = ACC.ID_PROFILE
  join CURRS c on C.CURR = O.ID_CURRENCY
  left outer join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
  left outer join PMS_EVENT$PMS E on PP.ID_PMS_EVENT = E.ID_PMS_EVENT
  left outer join ROOM_OWNER$PMS ro on ro.ID_ROOM_CONTRACT = e.ID_ROOM_CONTRACT and ro.ID_OWNER = o.ID_OWNER
where ACC.IS_PMS_ACCOUNT = 1
      and ((PP.ID_PMS_EVENT_POST is null) or (PP.LINE_STATUS in (11,22)))
      and AP.AC in ('00', '10')
;

COMMENT ON COLUMN OWNER_POST.POST_STATUS IS
'11  
22  ';


COMMENT ON COLUMN ENA_ACCOUNT.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_ACCOUNT.ID_ACCOUNT IS
'  . .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_NAME IS
'   .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_EXT_CODE IS
'             .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ID IS
'         . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_NAME IS
'    .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ACCOUNT_NO IS
'             .  -    .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_TYPE IS
'       .  : AGENT -  , PERSON -  , HOUSE -    . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_HOUSE_TYPE IS
'      (PROFILE_TYPE = ''HOUSE''),    -.  : hptExternalClient -          ( ,      ); hptExternalRevenue -                (,   ..); hptComplimentary -           ,  ,        . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_HOTEL IS
'       .  ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_ACCOUNT_POST_HISTORY IS
'   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_ACCOUNT IS
'      .  ENA_ACCOUNT.ID_ACCOUNT. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_SERVICE IS
'   .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_SALE_TAXATION IS
'         .       . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.SYSTEM_DATE IS
'    / . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_DATE IS
'        (). .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_CURR IS
'  . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_AMOUNT IS
'    (   )    . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.NAT_NET_VALUE IS
'    ( )   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.NAT_GROSS_VALUE IS
'    ( )   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_TYPE IS
'  . BASE -  ; ADD_INS -  - ,    ; EXTRA -     ,     ; TAX -            ,     .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_GUEST IS
'       .  ENA_GUEST.ID_GUEST.        : 1.    "  "; 2.           ; 3.        ,      . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_GROUP IS
'       .    : ''ROOMS'', ''Food and Beverage'', ''Other Operated Departments'', ''Rentals and Other Income''. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_ACCOUNT IS
' -      .    . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_SUB_ACCOUNT IS
' --      . ,     -. .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.ID_HOTEL IS
'   ,    . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.ID_DOC_HEAD IS
'        .  ENA_DOC_HEAD_ADVANCE.ID_DOC. .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.SYSTEM_DATE IS
'      . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAYMENT_DATE IS
'     . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.SRC_ID_ACCOUNT IS
'   . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.DEST_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAY_AMOUNT IS
' .        . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAY_CURRENCY IS
' . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.USER_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.DATETIME_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_HOTEL IS
'   ,    . .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_DEPOSIT_PAYMENT IS
'  .         . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_DATE IS
'        .            . .';

COMMENT ON COLUMN ENA_DEPOSIT.SYSTEM_DATE IS
'   .         PAYMENT_DATE.        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_NUM IS
'           .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_DIRECTION IS
'0 -   , 1 -   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_TYPE_NAME IS
'       .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_ACCOUNT IS
'        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_AMOUNT IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DEPOSIT.IS_ANUL IS
'   . 0 - , 1 - .           /    .     IS_ANUL = 0,    1.           ID_DEPOSIT.  .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_CREATED IS
'     .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_CREATED IS
'       . .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_ANNUL IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_ANNUL IS
'     .  .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.ID_HOTEL IS
'       .  .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.ID_DEPOSIT_PAYMENT IS
'   ,   .  ENA_DEPOSIT.ID_DEPOSIT_PAYMENT. .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SYSTEM_DATE IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAYMENT_DATE IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SRC_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DEST_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAY_AMOUNT IS
' .        . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAY_CURRENCY IS
' . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.USER_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DATETIME_CREATED IS
'     . .';

COMMENT ON VIEW ENA_DOC_DEPOSIT_CONSUMPTION IS
' !!!!!!    ID_DOC_TYPE - za mapowe.';


COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.DOC_TYPE_NAME IS
'       . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_NUM IS
'         .  .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_DATE IS
'      .          . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_VALUE IS
'         . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_DOC_RATE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.EQUAL_DOC_VALUE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.NAT_VALUE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.ID_DEPOSIT_PAYMENT IS
'      (  ENA_DEPOSIT.ID_DEPOSIT_PAYMENT ). .';

COMMENT ON VIEW ENA_DOC_HEAD_ADVANCE IS
'!      ';


COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC IS
'  .             .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_ADVANCE.ID_DOC.  .     - , ..       ,      - .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SUB_TYPE IS
'   . ,  : 0 - / , 1 -  ,  , 2 -  ,  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_NAME IS
'    . ,       .              .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_DESCRIPTION IS
'   .         .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_NUM IS
'   ,        .      . ,     ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DATE IS
'        . .    SYSTEM_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.IS_ANUL IS
'        . . 0 - , 1 - .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TOTAL_VALUE IS
' (, )       . .      .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ONE_LINE_TEXT IS
' ,         .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURR_RATE IS
'   ()    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_POST_ADDRESS IS
'    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_ZIP_CODE IS
'     ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_MOL IS
'    ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_RECIPIENT_NAME IS
'     ()';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BANK_NAME IS
'  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BIC IS
'BIC  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IBAN IS
'IBAN  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_EMAIL IS
'email  .        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SUPPLIER_SEND_NAME IS
'     .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ACCOUNT_ID IS
'        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC IS
'  .             .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_SERVICE.ID_DOC.     - , ..       ,      - .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC_TYPE IS
'    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SUB_TYPE IS
'   .  : 0 - / , 1 -  ,  , 2 -  ,  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_NAME IS
'    .              .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_DESCRIPTION IS
'   .         .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_NUM IS
'   ,        .      .  -       ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DATE IS
'        .    SYSTEM_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.IS_ANUL IS
'        . 0 - , 1 - .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_CURRENCY IS
'  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TOTAL_VALUE IS
' (, )       .      .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ONE_LINE_TEXT IS
' ,         .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURR_RATE IS
'   ()    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_DATE IS
'   ,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_NUM IS
'  -,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_POST_ADDRESS IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_ZIP_CODE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_MOL IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_RECIPIENT_NAME IS
'     (). .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BANK_NAME IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BIC IS
'BIC  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IBAN IS
'IBAN  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_EMAIL IS
'email  .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SUPPLIER_SEND_NAME IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ACCOUNT_ID IS
'        .    ENA_ACCOUNT.ID_ACCOUNT. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_SERVICE IS
'     .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.DATE_POST IS
'    . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_SERVICE IS
'      .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_SERVICE IS
'   .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.IS_CORRECT IS
'            .      1,        . 0 -   ; 1 -      0. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_GUEST IS
'   ,        .    null,       ''  ''     .    ENA_GUEST.ID_GUEST. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.DATE_POST IS
'        .    ,    . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ROOM_NAME IS
'       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ACCOUNT_PRICE IS
'         /.             /. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_SERVICE IS
'    (, , , ,  ).  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_SALE_TAXATION IS
'         .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON VIEW ENA_DOC_PAYMENT IS
'   ,     .';


COMMENT ON COLUMN ENA_DOC_PAYMENT.ID_DOC_HEAD IS
'  ( ENA_DOC_HEAD.ID_DOC)      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DOC_TYPE_NAME IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_NUM IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_DATE IS
'     .        ,                 . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_CURRENCY IS
'  .        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DUE_DATE IS
'       .          ,      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_VALUE IS
'           . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_DOC_RATE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.EQUAL_DOC_VALUE IS
'      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.NAT_VALUE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.ID_DOC_HEAD IS
'         . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNT_VALUE IS
'      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNTABLE_VALUE IS
'  .       . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.IS_PERCENT_DISCOUNT IS
'  .         . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.FIXED_DISCOUNT_CURRENCY IS
'  .       -     . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNT_PERCENT_OR_AMOUNT IS
'  .       . .';

COMMENT ON COLUMN ENA_DOC_TAX.ID_DOC_HEAD IS
'         ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_TAX.ID_SALE_TAX IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.NONTAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_VALUE IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_NAME IS
'  .  -        .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_PERCENT IS
'   ().  .';

COMMENT ON COLUMN ENA_DOC_TAX.FISCAL_CODE IS
' .        .  -      .';

COMMENT ON COLUMN ENA_DOC_TAX.ACCOUNT_NAME IS
' .              . .';

COMMENT ON COLUMN ENA_GUEST.ID_GUEST IS
'   ( )   . .';

COMMENT ON COLUMN ENA_GUEST.ID_RESERV_DETAIL IS
'        ( ENA_RESERV_DETAIL.ID_RESERV_DETAIL). .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME2 IS
'      . .';

COMMENT ON COLUMN ENA_GUEST.IS_CHILD IS
'   . 0 - ; 1 - . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE IS
'    . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_TEXT IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.RATING_AGE IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.COUNTRY_CODE IS
'    .        ISO. .';

COMMENT ON COLUMN ENA_GUEST.MASK IS
'  .         . .';

COMMENT ON COLUMN ENA_HOTEL.ID_HOTEL IS
'  . .';

COMMENT ON COLUMN ENA_HOTEL.HOTEL_NAME IS
'  . .';

COMMENT ON COLUMN ENA_HOTEL.CODE IS
'   . .';

COMMENT ON COLUMN ENA_HOTEL.SYSTEM_DATE IS
'     .                  ENA.                . .';

COMMENT ON COLUMN ENA_HOTEL.IS_USE IS
'    (  ). 0 -   , 1 -  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_RESERV_DETAIL IS
'   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NUMBER IS
'  .    (   ). .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_GUEST_MAIN IS
'      .      .  -     .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME IS
'    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME2 IS
'       . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.FROM_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.TO_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NIGHTS IS
'. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ADULT_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHILD_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_EATING_OBJECT IS
'          . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHECK_STATUS IS
'  . -3 =  ; -2 =   ; -1 =  ; 0 =  ; 1 =  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.IS_ANUL IS
'   . 0 - , 1 - .  -       0  1.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ID IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_NAME IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_TYPE IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ACCOUNT_NO IS
'             .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SEGMENT_CODE IS
'   ''segment''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SOURCE_CODE IS
'   ''source''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_CHANNEL_CODE IS
'   ''channel''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_HEAR_CODE IS
'   ''hear reason''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_COME_CODE IS
'   ''come reason''.   . .';

COMMENT ON COLUMN ENA_SERVICES.ID_HOTEL IS
'       . .';

COMMENT ON COLUMN ENA_SERVICES.ID_SERVICE IS
'   . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_NAME IS
'  . .';

COMMENT ON COLUMN ENA_SERVICES.GROUP_NAME IS
'    .            a       . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_TYPE IS
'  .  : ''BASE'',''EXTRA'',''COMMISSION'',''MEAL''. ''BASE'' -    ,     ,''EXTRA'' -  , ''MEAL'' - , ''COMMISSION'' - ,        (  ). .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_GROUP IS
'       .  : ''ROOMS'', ''Food and Beverage'', ''Other Operated Departments'', ''Rentals and Other Income''. .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_ACCOUNT IS
' -      . .';

COMMENT ON COLUMN ENA_SERVICES.ACCOUNT_NAME IS
'      (. ),      .          . .';

COMMENT ON COLUMN ENA_SERVICES.EXT_CODE IS
'         . .';

COMMENT ON COLUMN ENA_SERVICES.IS_BREAKFAST IS
'   . 0 - , 1 - .    1,   SERVICE_TYPE e ''BASE''  ''MEAL''.  -          .';

COMMENT ON COLUMN ENA_SERVICES.ID_ROOM_TYPE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ). .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  -             .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM_EXT_CODE IS
'    ( )     ,      .  -        .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_STAY_CODE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  : ''ALONE'' -      , ''BED'' -            , ''EXTRA_BED'' -      . .';

COMMENT ON COLUMN OWNER_POST.POST_STATUS IS
'11  
22  ';

/* Alter View (Drop, Create)... */
/* Drop altered view: PROFILE_WALLET */
SET TERM ^ ;

ALTER PROCEDURE PROFILE_MERGE$PROFILE(ID_SOURCE INTEGER,
ID_TARGET INTEGER,
OPERATION VARCHAR(20))
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE PROFILE_WALLET_POINTS_REGISTER(ID_PROFILE INTEGER,
POINTS INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255))
 RETURNS(NEW_ID_PROFILE_WALLET_POINTS INTEGER)
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP VIEW PROFILE_WALLET;

/* Create altered view: PROFILE_WALLET */
/* Create view: PROFILE_WALLET */
CREATE VIEW PROFILE_WALLET(
ID_PROFILE,
TOTAL_NIGHTS,
TOTAL_DAYBEDS,
TOTAL_DAYBED_ADULTS,
TOTAL_GUESTS,
TOTAL_GUEST_ADULTS,
TOTAL_BOOKINGS,
TOTAL_TURNOVER,
TOTAL_POINTS_GAINED,
TOTAL_POINTS_CONSUMED,
TOTAL_POINTS_BALANCE)
 AS 
select WP.ID_PROFILE,
       sum(iif(Wp.REASON = 'NIGHT', PS.NIGHTS, 0)),
       sum(iif(Wp.REASON = 'DAYBED', PS.DAYBEDS, 0)),
       sum(iif(Wp.REASON = 'DAYBED_ADULT', PS.DAYBED_ADULTS, 0)),
       sum(iif(Wp.REASON = 'GUEST', PS.GUESTS, 0)),
       sum(iif(Wp.REASON = 'GUEST_ADULT', PS.GUEST_ADULTS, 0)),
       sum(iif(Wp.REASON = 'BOOKING', PS.BOOKINGS, 0)),
       sum(iif(Wp.REASON = 'TURNOVER', PS.TURNOVER, 0)),
       sum(iif(WP.REASON not containing 'CONSUME', WP.POINTS, 0)),
       sum(iif(WP.REASON containing 'CONSUME', -WP.POINTS, 0)),
       sum(WP.POINTS)
from   PROFILE_WALLET_POINTS WP
       left outer join PROFILE_WALLET_POINTS_SOURCE PS on pS.ID_PROFILE_WALLET_POINTS = WP.ID_PROFILE_WALLET_POINTS
group by 1
;

/* Create Check... */
ALTER TABLE SERVICES ADD CONSTRAINT CHK_SERVICES CHECK(SERVICE_TYPE in ('BASE','EXTRA','COMMISSION','MEAL','ADVANCE_PAYMENT'));

/*  Empty PMS_EVENT_POST$INT for CONTRACT_MANAGEMENT_POST$INT(param list change)  */
SET TERM ^ ;

ALTER PROCEDURE PMS_EVENT_POST$INT(ID_PMS_EVENT INTEGER,
ID_ROOM_CONTRACT INTEGER,
ID_RENTAL_POOL INTEGER,
POST_DATE DATE,
PRICE_WITH_VAT NUMERIC(15,4),
PRICE_WO_VAT NUMERIC(15,4),
CURR VARCHAR(3),
MAX_ADULT_CNT INTEGER,
STAY INTEGER,
BED_NIGHT_CNT INTEGER,
BOOKING_CNT INTEGER,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN EXIT; END
^

/*  Empty EXPORT_PMS for PMS_EVENT_CREATE$INT(param list change)  */
ALTER PROCEDURE EXPORT_PMS RETURNS(ID_EXPORT_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty PMS_EXPENSE_POSTS_CREATE$INT for PMS_EVENT_CREATE$INT(param list change)  */
ALTER PROCEDURE PMS_EXPENSE_POSTS_CREATE$INT(ID_ROOM /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
POST_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
IS_CLIENT_ACC_POST /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_POST_DATE /* TYPE OF TDATE */ DATE,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IS_POST_PER_POOL /* TYPE OF TLOGICAL */ SMALLINT)
 RETURNS(NEW_ID_ACCOUNT_POST /* ID_REF */ INTEGER,
NEW_ID_ACCOUNT_POST$PMS /* ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty PMS_INCOME_POSTING_CREATE$PMS for PMS_EVENT_CREATE$INT(param list change)  */
ALTER PROCEDURE PMS_INCOME_POSTING_CREATE$PMS(ID_ROOM INTEGER,
ID_OWNER INTEGER,
ID_RENTAL_POOL INTEGER,
ID_CURRENCY VARCHAR(3),
ID_SERVICE INTEGER,
POST_VALUE NUMERIC(15,4),
MANUAL_POST_DATE DATE,
DESCRIPTION VARCHAR(255),
IS_POST_PER_POOL SMALLINT)
 AS
 BEGIN EXIT; END
^

/*  Empty PMS_POOL_DISTRIBUTION_SUB for PMS_EVENT_CREATE$INT(param list change)  */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
 BEGIN EXIT; END
^

/*  Empty TAR_CALC_INPUT_RESERV$INT for TAR_CALC_GET_GUESTS$INT(param list change)  */
ALTER PROCEDURE TAR_CALC_INPUT_RESERV$INT(ID_RESERV_DETAIL INTEGER,
ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
ID_TEST_RATE INTEGER = null)
 AS
 BEGIN EXIT; END
^

/*  Empty RES_RECALC$INT for TAR_CALC_INPUT_RESERV$INT(param list change)  */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty TAR_TEST$TAR for TAR_CALC_INPUT_RESERV$INT(param list change)  */
ALTER PROCEDURE TAR_TEST$TAR(NUMBER VARCHAR(62),
ID_TAR_HEAD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure CONTRACT_MANAGEMENT_POST$INT with new param-list */
ALTER PROCEDURE CONTRACT_MANAGEMENT_POST$INT(ID_PMS_EVENT TYPE OF ID,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
CONTRACT_TYPE VARCHAR(30),
ID_OWNER TYPE OF ID,
ID_RENTAL_POOL TYPE OF ID_REF,
VALUE_ORIG TYPE OF TPRICE,
CURR_ORIG TYPE OF TCURRENCY,
POST_DATE TYPE OF TDATE,
STAY TYPE OF TCOUNT,
OWNERSHIP_PERCENT TYPE OF TPERCENT)
 RETURNS(POSTED_VALUE TYPE OF TPRICE,
POSTED_CURRENCY TYPE OF TCURRENCY)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure PMS_EVENT_CREATE$INT with new param-list */
ALTER PROCEDURE PMS_EVENT_CREATE$INT(EVENT_TYPE VARCHAR(30),
ID_ROOM INTEGER,
ID_OWNER INTEGER,
DESCRIPTION VARCHAR(255),
MANUAL_POST_DATE DATE,
IMPORT_PERIOD_FROM DATE,
IMPORT_PERIOD_TO DATE,
ID_RESERV_DETAIL INTEGER,
ID_DOC_HEAD INTEGER,
PRICE_WITH_VAT NUMERIC(15,4),
PRICE_WO_VAT NUMERIC(15,4),
CURR VARCHAR(3),
ID_EXPORT_HEAD INTEGER,
ID_ROOM_CONTRACT INTEGER,
REF_RESERVS INTEGER = null,
REF_STAY INTEGER = null,
REF_BEDNIGHTS INTEGER = null,
REF_DOC_DESCRIPTION TDESCRIPTION_LONG = null)
 RETURNS(NEW_ID_PMS_EVENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure TAR_CALC_GET_GUESTS$INT with new param-list */
ALTER PROCEDURE TAR_CALC_GET_GUESTS$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_GUEST INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
G_DBKEY CHAR(8),
ID_GUEST_RESERV TYPE OF ID)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure TAR_CALC_INPUT_DETAILS$INT with new param-list */
ALTER PROCEDURE TAR_CALC_INPUT_DETAILS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure TAR_CALC_INPUT_GUEST$INT with new param-list */
ALTER PROCEDURE TAR_CALC_INPUT_GUEST$INT(ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
G_DBKEY CHAR(8),
ID_RATE_OVERRULE INTEGER,
REAL_RECALC INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter empty procedure TAR_CALC_INPUT_RESERV$INT with new param-list */
ALTER PROCEDURE TAR_CALC_INPUT_RESERV$INT(ID_RESERV_DETAIL INTEGER,
ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
ID_RATE_OVERRULE INTEGER = null)
 AS
 BEGIN EXIT; END
^

/* Alter Procedure... */
/* Alter (ACC_STATEMENT_GET_INFO$PMS) */
ALTER PROCEDURE ACC_STATEMENT_GET_INFO$PMS(FROM_DATE DATE,
TO_DATE DATE,
ID_SERVICE_HL_LIST VARCHAR(255))
 RETURNS(ID_BILL INTEGER,
ID_DOC INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
POST_DATE DATE,
ID_ROOM INTEGER,
ID_OWNER INTEGER,
ROOM_INFO VARCHAR(30),
OWNER_NAME VARCHAR(100),
BILLING_INFO VARCHAR(100),
ID_SERVICE INTEGER,
SERVICE_DESC VARCHAR(100),
DESCRIPTION VARCHAR(300),
REF_DOC_INFO VARCHAR(300),
DEVICE_READING_INFO VARCHAR(300),
INCOME_VALUE NUMERIC(15,4),
INCOME_CURR VARCHAR(3),
OUTGO_VALUE NUMERIC(15,4),
OUTGO_CURR VARCHAR(3),
IS_ANUL SMALLINT,
IS_INVOICED SMALLINT,
ID_EXPORT_HEAD INTEGER)
 AS
declare variable info_delim varchar(3);
  declare variable curr_format varchar(20);
  declare variable res_period_delim varchar(3);
  declare variable short_date_format varchar(20);
  declare variable doc_description varchar(255);
  declare variable id_doc_head integer;
  declare variable id_service_hl_list_found varchar(255);
  declare variable description_event varchar(255);
  declare variable res_number varchar(62);
  declare variable res_from_date date;
  declare variable res_to_date date;
  declare variable res_stay integer;
  declare variable curr_id_room integer;
  declare variable curr_id_owner integer;
  declare variable tmp_info varchar(100);
begin
  info_delim = '/ ';
  curr_format = 'F;#.00';
  short_date_format = 'D;dd.mm';
  res_period_delim = '-';

  for
    select T.ID_ROOM, T.ID_OWNER
    from   TMP_SELECT$PMS T
    where  T.ID_SESSION = current_transaction
    into   :curr_id_room, :curr_id_owner
  do begin
    id_service_hl_list_found = ',';
    id_doc = null;
    for
      select BH.ID_OWNER_BILL, BR.DATE_POST, BR.ID_ROOM, coalesce(H.CODE, '')||:info_delim||R.ROOM_NAME,
             coalesce(BH.BILL_NUM||', '||formatdate(BH.BILL_DATE,'D;dd/mm/yyyy'), ''), BH.ID_OWNER, P.PROFILE_NAME,
             S.ID_SERVICE, S.SERVICE_NAME, BR.DESCRIPTION, BR.DOC_DESCRIPTION,
             iif(BR.IS_OWNER_INCOME = 1, BR.VALUE_POST, null) as INCOME,
             iif(BR.IS_OWNER_INCOME = 1, BR.CURR_POST, null) as IN_CURR,
             iif(BR.IS_OWNER_INCOME = 0, BR.VALUE_POST, null) as OUTGO,
             iif(BR.IS_OWNER_INCOME = 0, BR.CURR_POST, null) as OUT_CURR, BH.IS_ANUL,
             iif(BR.ID_ACCOUNT_POST is not null, 1, null) as IS_INVOICED,
             RD.NUMBER, PEP.IMP_PERIOD_FROM, PEP.IMP_PERIOD_TO + 1, PEP.IMP_PERIOD_TO - PEP.IMP_PERIOD_FROM + 1,
             BR.ID_ACCOUNT_POST, BR.ID_ACCOUNT_POST_PMS, PEP.ID_EXPORT_HEAD
      from   OWNER_BILL$PMS BH
             left outer join OWNER_BILL_ROW$PMS BR on BH.ID_OWNER_BILL = BR.ID_OWNER_BILL
                                                      and BR.ID_ACCOUNT_POST_PMS is not null
             join PROFILE P on P.ID_PROFILE = BH.ID_OWNER
             left outer join ROOMS R on R.ID_ROOM = BR.ID_ROOM
             left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
             left outer join HOTEL_S H on H.ID_HOTEL = RT.ID_HOTEL
             left outer join SERVICES S on S.ID_SERVICE = BR.ID_SERVICE
             left outer join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = BR.ID_RESERV_DETAIL
             left outer join ACCOUNT_POST$PMS APP on APP.ID_ACCOUNT_POST = BR.ID_ACCOUNT_POST_PMS
             left outer join PMS_EVENT$PMS PEP on PEP.ID_PMS_EVENT = APP.ID_PMS_EVENT
      where  BH.BILL_DATE between coalesce(:from_date, '01.01.1500') and coalesce(:to_date, '01.01.2500')
             and ((:curr_id_room is null) or (BR.ID_ROOM = :curr_id_room))
             and ((:curr_id_owner is null) or (BH.ID_OWNER = :curr_id_owner))
      into   :ID_BILL, :POST_DATE, :ID_ROOM, :ROOM_INFO, :BILLING_INFO, :ID_OWNER, :OWNER_NAME,
             :ID_SERVICE, :SERVICE_DESC, :DESCRIPTION_EVENT, :DOC_DESCRIPTION,
             :INCOME_VALUE, :INCOME_CURR, :OUTGO_VALUE, :OUTGO_CURR, :IS_ANUL, :IS_INVOICED,
             :res_number, :RES_FROM_DATE, :RES_TO_DATE, :RES_STAY,
             :ID_ACCOUNT_POST, :ID_ACCOUNT_POST_PMS, :ID_EXPORT_HEAD
    do begin
      DESCRIPTION = '';
      ref_doc_info = null;
      for
        select ITEM
        from   SYSTEM_STRING_PARSER(:doc_description,',')
        into   :id_doc_head
      do begin
        select coalesce(:ref_doc_info||'; ','')||DH.DOC_NUM||:info_delim||formatfloat(DH.DOC_VALUE, :curr_format)||' '||DH.DOC_CURRENCY
        from   DOC_HEAD DH
        where  DH.ID_DOC = :id_doc_head
        into   :ref_doc_info;
      end

      select substring(list(DR.ID_DEVICE_READING || ', ' || coalesce(formatdate(DR.DATE_READ, 'dd/mm/yyyy'), ''), :info_delim) from 1 for 300)
      from   DEVICE_READING_POST DRP
             join DEVICE_READING_EVIDENCE DRE on DRE.ID_DEVICE_READING_EVIDENCE = DRP.ID_DEVICE_READING_EVIDENCE
             join DEVICE_READING DR on DR.ID_DEVICE_READING = DRE.ID_DEVICE_READING
      where  DRP.ID_ACCOUNT_POST$PMS = :id_account_post_pms
      into   :device_reading_info;
  
      DESCRIPTION = :res_number||', '
                  ||formatdate(:res_from_date,:short_date_format)||:res_period_delim||:res_stay||:res_period_delim||formatdate(:res_to_date,:short_date_format);
      DESCRIPTION = coalesce(:DESCRIPTION, '');
      DESCRIPTION = iif(:DESCRIPTION = '', :DESCRIPTION, :DESCRIPTION||', ')||coalesce(:DESCRIPTION_EVENT, '');

      if (trim(coalesce(:ID_SERVICE_HL_LIST, '')) = '') then begin
        suspend;
      end else begin
        if (:ID_SERVICE_HL_LIST containing :ID_SERVICE) then begin
          if (:ID_SERVICE_HL_LIST_FOUND not containing :ID_SERVICE and :is_anul = 0) then begin
            id_service_hl_list_found = :id_service_hl_list_found ||:id_service|| ',';
          end
          suspend;
        end
      end
    end

    REF_DOC_INFO = '';
    ID_ACCOUNT_POST_PMS = null;
    INCOME_VALUE = null;
    INCOME_CURR = null;
    DESCRIPTION = '';
    for
      select A.INV_DESCRIPTION, A.BILLING_INFO, A.ID_ACCOUNT_POST, A.DATE_POST,
             A.OUT_ID_OWNER, A.OUT_ID_ROOM, coalesce(H.CODE, '')||:info_delim||R.ROOM_NAME, P.PROFILE_NAME, A.ID_SERVICE,
             A.LINE_DESC, A.OUTGO_VALUE, A.CURR_POST, A.IS_ANUL, A.IS_INVOICED,
             A.ID_BILL, A.ID_DOC, A.DEVICE_READING_INFO, A.ID_EXPORT_HEAD
      from   ACC_STATEMENT_INVOICES_GET$INT(:FROM_DATE, :TO_DATE, :CURR_ID_ROOM, :CURR_ID_OWNER) A
             left outer join ROOMS R on R.ID_ROOM = A.OUT_ID_ROOM
             left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
             left outer join HOTEL_S H on H.ID_HOTEL = RT.ID_HOTEL
             join PROFILE P on P.ID_PROFILE = A.OUT_ID_OWNER
      into   :REF_DOC_INFO, :BILLING_INFO, :ID_ACCOUNT_POST, :POST_DATE,
             :ID_OWNER, :ID_ROOM, :ROOM_INFO, :OWNER_NAME, :ID_SERVICE, -- predi :ID_SERVICE beshe missing
             :SERVICE_DESC, :OUTGO_VALUE, :OUTGO_CURR, :IS_ANUL, :IS_INVOICED,
             :ID_BILL, :ID_DOC, :DEVICE_READING_INFO, :ID_EXPORT_HEAD
    do begin
      if (trim(coalesce(:ID_SERVICE_HL_LIST, '')) = '') then
        suspend;
      else begin
        if (:ID_SERVICE_HL_LIST containing :ID_SERVICE) then begin
          if (:ID_SERVICE_HL_LIST_FOUND not containing :ID_SERVICE and :is_anul = 0) then begin
            id_service_hl_list_found = :id_service_hl_list_found ||:id_service|| ',';
          end
          suspend;
        end
      end
    end
     

    ID_ACCOUNT_POST = null;
    ID_ACCOUNT_POST_PMS = null;
    ID_BILL = null;
    POST_DATE = iif(:TO_DATE = '01.01.2500', null, :TO_DATE-1);
    BILLING_INFO = '';
    DESCRIPTION = 'missing service '||iif(:TO_DATE = '01.01.2500', '', ': billing date '||formatdate(:TO_DATE,'D;dd.mm.yy'));
    REF_DOC_INFO = null;
    INCOME_VALUE = null;
    INCOME_CURR = null;
    OUTGO_VALUE = null;
    OUTGO_CURR = null;
    IS_ANUL = 0;
    IS_INVOICED = null;
  
    for
      select ITEM
      from   SYSTEM_STRING_PARSER(:ID_SERVICE_HL_LIST, ',')
      into   :ID_SERVICE
    do begin
      if (:ID_SERVICE_HL_LIST_FOUND not containing (','||:ID_SERVICE||',')) then begin
        id_service_hl_list_found = :id_service_hl_list_found ||:id_service|| ',';
  
        select S.SERVICE_NAME
        from   SERVICES S
        where  S.ID_SERVICE = :ID_SERVICE
        into   :SERVICE_DESC;
  
        suspend;
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_ADD$INT for: ACCOUNT_CHECK_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_POSTING_ADD$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_GUEST /* TYPE OF ID_REF */ INTEGER,
ID_SECQUENCE /* TYPE OF ID_REF */ INTEGER,
DATE_POST /* TYPE OF TDATE */ DATE,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_TARIFF /* TYPE OF ID_REF */ INTEGER,
ID_ROOM /* TYPE OF ID_REF */ INTEGER,
IS_BASE /* TYPE OF TLOGICAL */ SMALLINT,
QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
ORIG_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
RATE /* TYPE OF TRATE */ NUMERIC(15,6),
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
CHANGED_TEXT /* TYPE OF TTEXT_SHORT */ VARCHAR(30),
ID_MASTER_ADDINS_ACC_POST /* TYPE OF ID_REF */ INTEGER,
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
NEW_ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE$INT for: ACCOUNT_CHECK_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE$INT(AP_DBKEY /* TYPE OF TDB_KEY */ CHAR(8),
ID_SERVICE /* TYPE OF ID_REF */ INTEGER,
ID_TARIFF /* TYPE OF ID_REF */ INTEGER,
ID_ROOM /* TYPE OF ID_REF */ INTEGER,
QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
QTY_FREE /* TYPE OF TQTY */ NUMERIC(15,2),
PRICE /* TYPE OF TVALUE */ DOUBLE PRECISION,
CURR /* TYPE OF TCURRENCY */ CHAR(3),
RATE /* TYPE OF TRATE */ NUMERIC(15,6),
CHANGED_TEXT VARCHAR(40),
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
IS_CONSEQUENTIAL_UPDATE /* TYPE OF TBOOLEAN */ SMALLINT = 0,
RE_ROUTE_ACCOUNT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(OUT_QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
OUT_PRICE_POST /* TYPE OF TVALUE */ DOUBLE PRECISION,
OUT_AC VARCHAR(2))
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_CHECK_CREDIT_STATUS$INT) */
ALTER PROCEDURE ACCOUNT_CHECK_CREDIT_STATUS$INT(ID_ACCOUNT TYPE OF ID_REF,
POST_VALUE TYPE OF TPRICE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_credit_account integer;
  declare variable id_reserv_detail integer;
  declare variable credit_limit tprice;
  declare variable b_post_sum tprice;
  declare variable b_pay_sum tprice;
  declare variable difference_value tprice;
  declare variable no_use varchar(255);
  declare variable account_currency tcurrency;
  declare variable round_to numeric(15,4);
begin
  if (:POST_VALUE = 0) then exit;

  select a.IS_CREDIT_ACCOUNT, a.CREDIT_LIMIT, a.ID_RESERV_DETAIL
  from   ACCOUNT A
  where  a.ID_ACCOUNT = :ID_ACCOUNT
  into   :is_credit_account, :credit_limit, :id_reserv_detail;

  if (:is_credit_account = 0
      and exists (select rd.ID_RESERV_DETAIL
                  from   RESERV_DETAIL rd
                  where  rd.ID_RESERV_DETAIL = :id_reserv_detail
                         and rd.CHECK_STATUS = 1)) then
  begin
    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, :credit_limit, 1);
  end

  if (coalesce(:credit_limit, 0) > 0) then begin
    /* FIND BALANCE OF ACCOUNT */
    execute procedure ACCOUNT_BALANCE$INT(:id_account)
    returning_values  :account_currency, :round_to, :no_use, :b_post_sum, :b_pay_sum, :no_use, :no_use;
    b_post_sum = coalesce(:b_post_sum, 0);
    b_pay_sum  = coalesce(:b_pay_sum, 0);

    /* IS THIS POST IS IN LIMIT */
    if ((:b_post_sum + :POST_VALUE) > :credit_limit) then begin
      err_code = -13; /*  */
      difference_value = :b_post_sum + :POST_VALUE - :credit_limit;
      err_text = f_character(29)||FormatFloat(:credit_limit, :round_to)||' '||:account_currency||
                 f_character(28)||FormatFloat(:difference_value, :round_to);
    end
  end
end
^

ALTER PROCEDURE PMS_EVENT_CREATE$INT(EVENT_TYPE VARCHAR(30),
ID_ROOM INTEGER,
ID_OWNER INTEGER,
DESCRIPTION VARCHAR(255),
MANUAL_POST_DATE DATE,
IMPORT_PERIOD_FROM DATE,
IMPORT_PERIOD_TO DATE,
ID_RESERV_DETAIL INTEGER,
ID_DOC_HEAD INTEGER,
PRICE_WITH_VAT NUMERIC(15,4),
PRICE_WO_VAT NUMERIC(15,4),
CURR VARCHAR(3),
ID_EXPORT_HEAD INTEGER,
ID_ROOM_CONTRACT INTEGER,
REF_RESERVS INTEGER = null,
REF_STAY INTEGER = null,
REF_BEDNIGHTS INTEGER = null,
REF_DOC_DESCRIPTION TDESCRIPTION_LONG = null)
 RETURNS(NEW_ID_PMS_EVENT INTEGER)
 AS
begin
/*  EVENT_TYPE in ('INCOME, MANUAL_INCOME, MANUAL_EXPENSE, POOL_DISTRIBUTION') */

  new_id_pms_event = GEN_ID(GEN_PMS_EVENT$PMS_ID,1);

  insert into PMS_EVENT$PMS (ID_PMS_EVENT, EVENT_TYPE, DESCRIPTION,
       ID_ROOM, ID_OWNER, MANUAL_POST_DATE, IMP_PERIOD_FROM, IMP_PERIOD_TO,
       ID_RESERV_DETAIL, ID_DOC_HEAD, PRICE_WITH_VAT, PRICE_WO_VAT, CURR,
       EVENT_STATUS, ID_PREV_EVENT, ID_EXPORT_HEAD, DOC_DESCRIPTION,
       RESERVS, STAY, BEDNIGHTS, ID_ROOM_CONTRACT)
  values (:new_id_pms_event, :EVENT_TYPE, :DESCRIPTION,
       :ID_ROOM, :ID_OWNER, :MANUAL_POST_DATE, :IMPORT_PERIOD_FROM, :IMPORT_PERIOD_TO,
       :ID_RESERV_DETAIL, :ID_DOC_HEAD, :PRICE_WITH_VAT, :PRICE_WO_VAT, :CURR,
       11, null, :id_export_head, :REF_DOC_DESCRIPTION,
       :REF_RESERVS, :REF_STAY, :REF_BEDNIGHTS, :ID_ROOM_CONTRACT);
end
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_ACCOUNT$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
QTY /* TYPE OF TQTY */ NUMERIC(15,2),
ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
DATE_POST /* TYPE OF TDATE */ DATE,
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ROOM /* TYPE OF ID */ INTEGER = null,
POST_DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_GUEST$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ACCOUNT_ROUTING /* TYPE OF TSHORT_CODE */ VARCHAR(10),
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_TAR_CALC_REPOST$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE RES_TAR_CALC_REPOST$INT(ID_TAR_CALC /* TYPE OF ID_REF */ INTEGER,
ID_RESERV_DETAIL /* TYPE OF ID_REF */ INTEGER,
RECALC_MARKER VARCHAR(40))
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_ADD$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_ADD$INT(ID_ACCOUNT TYPE OF ID,
ID_GUEST TYPE OF ID_REF,
ID_SECQUENCE TYPE OF ID_REF,
DATE_POST TYPE OF TDATE,
ID_SERVICE TYPE OF ID,
ID_TARIFF TYPE OF ID_REF,
ID_ROOM TYPE OF ID_REF,
IS_BASE TYPE OF TLOGICAL,
QTY_POST TYPE OF TQTY,
PRICE TYPE OF TPRICE,
ORIG_CURRENCY TYPE OF TCURRENCY,
RATE TYPE OF TRATE,
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
POST_TEXT TYPE OF TDESCRIPTION_SHORT,
RESOURCE_TEXT TYPE OF TREASON,
CHANGED_TEXT TYPE OF TTEXT_SHORT,
ID_MASTER_ADDINS_ACC_POST TYPE OF ID_REF,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
NEW_ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable price_post double precision;
  declare variable post_rate numeric (15, 6);
  declare variable curr_post char(3);
  declare variable account_currency char(3);
  declare variable id_pack_service integer;
  declare variable id_room_type integer;
  declare variable room_name varchar(30);
  declare variable is_archive integer;
  declare variable id_tax_policy integer;
  declare variable id_sale_taxation integer;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable check_option varchar(255);
  declare variable id_hotel integer;
  declare variable id_srv_hotel integer;
  declare variable service_name varchar(30);
  declare variable account_name varchar(50);
begin
  ID_GUEST = nullif(:ID_GUEST, -1);

  execute procedure POST_PRICE_CHECK$INT (:QTY_POST, :PRICE, :ORIG_CURRENCY);

  if ( (:IS_BASE = 1) or (:ID_MASTER_ADDINS_ACC_POST > 0) ) then
    check_option = 'IS_BASE;ALLOW_POSTING';
  else
    check_option = 'IS_EXTRA;ALLOW_POSTING';

  execute procedure ACCOUNT_VALIDATE$INT(:id_account, :check_option)
  returning_values  (:err_code, :err_text, :account_currency, :id_tax_policy, :id_hotel, :account_name);
  if (:err_code < 0) then EXIT; --  exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;

  select s.ID_HOTEL, s.SERVICE_NAME
  from   SERVICES S
  where  s.ID_SERVICE = :ID_SERVICE
  into   :id_srv_hotel, :service_name;

  if (:id_srv_hotel is distinct from :id_hotel) then
    exception POSTING_EXCEPTION '-1056' || f_character(31) || f_character(29) || :service_name || f_character(28) || :account_name;

  if (:rate is null) then begin
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :orig_currency, :date_post, :id_guest)
    returning_values  :rate;
  end

  curr_post  = :account_currency;
  if (:orig_currency = :account_currency) then begin
    post_rate  = :rate;
  end else begin
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :account_currency, :date_post, :id_guest)
    returning_values  :post_rate;
  end

  execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :id_tax_policy, :ID_TARIFF, :DATE_POST - :FROM_DATE)
  returning_values (:id_sale_taxation);

  execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:QTY_POST, :PRICE,
                    :RATE, :post_rate, :id_sale_taxation)
  returning_values  :price_post, :post_net_value, :post_gross_value;

  execute procedure ACCOUNT_CHECK_CREDIT_STATUS$INT (:ID_ACCOUNT, :price_post * :QTY_POST)
  returning_values (:ERR_CODE, :ERR_TEXT);
  if (:ERR_CODE <> 0) then exit;

  --
  new_id_account_post = gen_id (id_account_post_gen, 1);

  if (:post_text starting with 'PACK') then begin
    id_pack_service = substring(:post_text from 6 for 20);
    post_text = '';
  end else begin
    id_pack_service = -1;
  end
  if (:is_base = 1) then id_master_addins_acc_post = :new_id_account_post;

  select R.ROOM_NAME, R.ID_ROOM_TYPE
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :room_name, :id_room_type;

  if (:id_guest is null) then begin
    is_archive = 1;
  end else begin
    select iif(G.CHECK_STATUS = 1, 1, 0)
    from   GUEST G
    where  G.ID_GUEST = :id_guest
    into   :is_archive;
  end

  insert into ACCOUNT_POST (
    ID_ACCOUNT_POST, ID_ACCOUNT, ID_GUEST, ID_SERVICE, ID_TARIFF, ID_ROOM,
    IS_BASE, DATE_POST, QTY_POST, QTY_FREE, PRICE_POST, POST_NET_VALUE, POST_GROSS_VALUE, CURR_POST, RATE_POST,
    PRICE_ORIG, CURR_ORIG, RATE_ORIG, IS_LOCKED_FOR_UPDATE, TO_DATE, FROM_DATE, ID_SEQUENCE,
    SHORT_CODE, CHANGED_TEXT, ID_MASTER_ADDINS_ACC_POST, ID_PACK_SERVICE, ROOM_NAME, ID_ROOM_TYPE,
    ID_SALE_TAXATION, AC, IS_ARCHIVE, IN_DOC_QTY, IN_DOC_VALUE, DESCRIPTION)
  values (
    :new_id_account_post, :id_account, :id_guest, :id_service, :id_tariff, coalesce(:id_room, -1),
    :is_base, :date_post, :qty_post, 0, :price_post, :post_net_value, :post_gross_value, :curr_post, :post_rate,
    :price, :orig_currency, :rate, 0, :TO_DATE, :FROM_DATE, :id_secquence,
    :short_code, :changed_text, :id_master_addins_acc_post, :id_pack_service, :room_name, :id_room_type,
    :id_sale_taxation, '00', :is_archive, 0, 0, :DESCRIPTION);

  if ((coalesce(:post_text, '') <> '') or (coalesce(:resource_text, '') <> '')) then begin
    insert into ACCOUNT_POSTING_DET (ID_ACCOUNT_POST, POST_TEXT, QTY, FROM_DATETIME, TO_DATETIME, RESOURCE_TEXT)
    values (:new_id_account_post, :post_text, :qty_post, :FROM_DATE, :TO_DATE, :resource_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_JOIN_IN_ONE_BY_STRING for: ACCOUNT_POSTING_TRANSFER$ACC */
ALTER PROCEDURE ACCOUNT_JOIN_IN_ONE_BY_STRING(IN_TARGET_ID_ACCOUNT INTEGER,
IN_SOURCE_STRING VARCHAR(1000))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_SELECTION_UNITE$DOC for: ACCOUNT_POSTING_TRANSFER$ACC */
ALTER PROCEDURE ACCOUNT_SELECTION_UNITE$DOC(ID_DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
PROFILE_ACCOUNTS_ONLY SMALLINT = 0)
 RETURNS(SKIP_DOC_SELECTED INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_POSTING_TRANSFER$ACC) */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
declare variable ap_dbkey char(8);
  declare variable transfer_value double precision;
  declare variable post_value double precision;
  declare variable id_account integer;
  declare variable tmp_id_account integer;
  declare variable curr_post varchar(3);
  declare variable acc_name varchar(50);
  declare variable action_text varchar(255);
  declare variable is_pms_account integer;
  declare variable dest_acc_name varchar(50);
begin

  id_account = null;
  transfer_value = 0;

  select ACC.ACCOUNT_NAME, acc.IS_PMS_ACCOUNT
  from   ACCOUNT ACC
  where  ACC.ID_ACCOUNT = :ID_DEST_ACCOUNT
  into   :dest_acc_name, is_pms_account;

  if (:is_pms_account = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('PMS_TRANSFER_POSTINGS');
  end

  for
    select AP.RDB$DB_KEY, AP.ID_ACCOUNT, ap.PRICE_POST * ap.QTY_POST
    from   ACCOUNT_POST AP
    where  AP.DOC_SELECTED = :DOC_SELECTED
           and AP.ID_ACCOUNT = coalesce(:ID_SRC_ACCOUNT, AP.ID_ACCOUNT)
           and AP.ID_ACCOUNT is distinct from :ID_DEST_ACCOUNT
    order by AP.ID_ACCOUNT asc
    into   :ap_dbkey, :tmp_id_account, :post_value
  do begin
    execute procedure ACCOUNT_POSTING_TRANSFER$INT (:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:id_account is null) then id_account = :tmp_id_account;

    /* update from/to pms account */
    execute procedure ACCOUNT_POST_EVENT_REROUTE$INT(:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:tmp_id_account is distinct from :id_account) then begin
      select A.ACCOUNT_NAME, A.ACCOUNT_CURR
      from   ACCOUNT A
      where  A.ID_ACCOUNT = :id_account
      into   :acc_name, :curr_post;

      action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                    f_character(28) || :id_account || '/' || :acc_name ||
                    f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
      execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
      id_account = :tmp_id_account;
      transfer_value = 0;
    end
    transfer_value = :transfer_value + :post_value;
  end

  if (:id_account is not null) then begin
    select A.ACCOUNT_NAME, A.ACCOUNT_CURR
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :acc_name, :curr_post;
  
    action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                  f_character(28) || :id_account || '/' || :acc_name ||
                  f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_TRANSFER$INT for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE_PERC for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_PERC(IN_ID_ACCOUNT_POST VARCHAR(4000),
IN_PERC NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(30))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_POSTING$INT for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_POSTING$INT(ID_RESOURCE_RESERVATION /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
PRICE_DESCRIPTION /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
ID_RESERV_DETAIL /* TYPE OF ID */ INTEGER,
ID_EXTERNAL_CLIENT_ACCCOUNT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(DOC_SELECTED /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_POSTING_UPDATE$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE$INT(AP_DBKEY TYPE OF TDB_KEY,
ID_SERVICE TYPE OF ID_REF,
ID_TARIFF TYPE OF ID_REF,
ID_ROOM TYPE OF ID_REF,
QTY_POST TYPE OF TQTY,
QTY_FREE TYPE OF TQTY,
PRICE TYPE OF TVALUE,
CURR TYPE OF TCURRENCY,
RATE TYPE OF TRATE,
CHANGED_TEXT VARCHAR(40),
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
IS_CONSEQUENTIAL_UPDATE TYPE OF TBOOLEAN = 0,
RE_ROUTE_ACCOUNT TYPE OF ID_REF = null)
 RETURNS(OUT_QTY_POST TYPE OF TQTY,
OUT_PRICE_POST TYPE OF TVALUE,
OUT_AC VARCHAR(2))
 AS
declare variable date_post date;
  declare variable orig_is_base integer;
  declare variable orig_id_service integer;
  declare variable orig_id_room integer;
  declare variable orig_short_code varchar(255);
  declare variable orig_qty_post integer;
  declare variable orig_ac varchar(2);
  declare variable is_locked_for_update integer;
  declare variable orig_locked_for_update integer;
  declare variable orig_id_tariff integer;
  declare variable orig_id_guest integer;
  declare variable id_type_stay integer;
  declare variable id_room_type integer;
  declare variable id_board integer;
  declare variable id_pack_service integer;
  declare variable new_id_pack_service integer;
  declare variable post_currency char(3);
  declare variable room_name varchar(30);
  declare variable original_post varchar(30);
  declare variable new_ac varchar(2);
  declare variable orig_in_doc_qty numeric(15,2);
  declare variable orig_in_doc_value double precision;
  declare variable rate_post numeric(15,6);
  declare variable id_base_doc integer;
  declare variable id_tax_policy integer;
  declare variable price_post double precision;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable id_sale_taxation integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable orig_price_post tprice;
  declare variable round_to numeric(15,4);
  declare variable account_name tobject_name;
  declare variable err_code integer;
  declare variable err_text varchar(100);
  declare variable id_account integer;
begin
  /* GET DATA */
  original_post = '';
  new_id_pack_service = null;

  select AP.DATE_POST, AP.IS_BASE, AP.ID_SERVICE, AP.ID_BASE_DOC,
         AP.SHORT_CODE, AP.QTY_POST, ap.PRICE_POST, AP.IS_LOCKED_FOR_UPDATE,
         AP.AC, AP.ID_TARIFF, AP.ID_GUEST, AP.ID_ROOM,
         AP.CURR_POST, AP.ID_PACK_SERVICE, AP.ID_ROOM_TYPE,
         AP.IN_DOC_QTY, AP.IN_DOC_VALUE, AP.RATE_POST, ap.ID_SALE_TAXATION, ap.ID_ACCOUNT, ap.ID_ACCOUNT_POST
  from   ACCOUNT_POST AP
  where  AP.rdb$db_key = :AP_DBKEY
  into   :date_post, :orig_is_base, :orig_id_service, :id_base_doc,
         :orig_short_code, :orig_qty_post, :orig_price_post, :orig_locked_for_update,
         :orig_ac, :orig_id_tariff, :orig_id_guest, :orig_id_room,
         :post_currency, :id_pack_service, :id_room_type,
         :orig_in_doc_qty, :orig_in_doc_value, :rate_post, :id_sale_taxation, :id_account, :id_account_post;

  if (:RE_ROUTE_ACCOUNT is not null and :id_base_doc is null) then id_account = :RE_ROUTE_ACCOUNT;  -- IMPORTANT !!! Re-routing is possible only in this case!

  is_locked_for_update = :orig_locked_for_update; /* to initialize and preserve from null */

  execute procedure ACCOUNT_VALIDATE$INT(:id_account, 'ALLOW_POSTING;')
  returning_values  (:err_code, :err_text, :post_currency, :id_tax_policy, :id_hotel, :account_name);
  if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;

  if (:IS_CONSEQUENTIAL_UPDATE is distinct from 1) then begin
    -- direct post update - manual edition restrictions check
    if (:QTY_POST = -1) then QTY_POST = :orig_qty_post;   -- preserve current qty

    if (:QTY_POST <> :orig_qty_post) then exception POSTING_EXCEPTION '-379';

    if ((:orig_is_base = 1) and ((:QTY_POST <> 1) or (:ID_SERVICE <> :orig_id_service))) then
      exception POSTING_EXCEPTION '-223';

    if (:orig_ac = '01') then execute procedure RIGHTS_CHECK_GRANTED$INT('BALANCES_EDIT_CLOSED');

    short_code = :orig_short_code;
    id_tariff  = :orig_id_tariff;
    id_room    = :orig_id_room;
    is_locked_for_update = 1;  /* manual corrections must lock the postings  */

  end else begin
    /* post changes is a result from some user operation, indirect update ('NORMAL', 'FORCED', safes recalc, etc....) */
    is_locked_for_update = 0;

    if (:orig_is_base = 1) then begin
      /* PREPARING THE PACKET SERVICE */
      select S.ID_TYPE_STAY, S.ID_ROOM_TYPE
      from   SERVICE_PACKET S
      where  S.ID_SERVICE = :id_service
      into   :id_type_stay, :id_room_type;

      select GS.ID_BOARD
      from   GUEST_STAY GS
      where  GS.ID_GUEST = :orig_id_guest
             and GS.FOR_DATE = :date_post
      into   :id_board;

      execute procedure TAR_GET_BASE_SERVICE$INT(:id_type_stay, :id_room_type, :id_board, :id_hotel)
      returning_values  :id_pack_service;
      /* detecting change of STAY_TYPE or ROOM_TYPE */
      if (exists(
        select *
        from   SERVICE_PACKET S
        where  S.ID_SERVICE = :orig_id_service
               and ((S.ID_TYPE_STAY is distinct from :id_type_stay) or (S.ID_ROOM_TYPE is distinct from :id_room_type))
      )) then original_post = 'CHANGED';
    end
  end

  select R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :room_name;

  if (:orig_locked_for_update = 1
      and :changed_text starting with 'NORMALRECALC'
      and :id_service = :orig_id_service
      --and :orig_is_anul = 0
      and :id_tariff = :orig_id_tariff) then
  begin
    -- price is locked for update
    update ACCOUNT_POST AP
    set    AP.ID_ROOM      = :id_room,
           AP.ROOM_NAME    = :room_name,
           Ap.FROM_DATE    = :from_date,
           Ap.TO_DATE      = :to_date,
           AP.CHANGED_TEXT = :changed_text,
           AP.USER_CHANGED = current_user,
           AP.DATETIME_CHANGED = current_timestamp
    where  AP.rdb$db_key   = :AP_DBKEY;
    OUT_QTY_POST = :orig_qty_post;
    OUT_PRICE_POST = :orig_price_post;
    OUT_AC = :orig_ac;
  end else begin
    -- fully update
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :curr, :date_post, :orig_id_guest)
    returning_values  :rate;
  
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :post_currency, :date_post, :orig_id_guest)
    returning_values  :rate_post;
  
    if (:id_base_doc is null) then begin
      execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :id_tax_policy, :ID_TARIFF, :date_post - :from_date)
      returning_values (:id_sale_taxation);
    end

    execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:QTY_POST, :PRICE,
                      :RATE, :rate_post, :id_sale_taxation)
    returning_values  :price_post, :post_net_value, :post_gross_value;

    select c.ROUND_TO
    from   CURRS c
    where  c.CURR = :post_currency
    into   :round_to;

    if ( (:id_base_doc is not null)
         and (:qty_post = :orig_in_doc_qty)
         and (round_f(:price_post * :qty_post - :orig_in_doc_value * :orig_in_doc_qty, :round_to) = 0))
    then new_ac = '01';
    else new_ac = '00';                   
  
    if (:new_ac = '00') then begin
      execute procedure ACCOUNT_CHECK_CREDIT_STATUS$INT (:id_account, :price_post * :QTY_POST - :orig_price_post * :orig_qty_post)
      returning_values (:err_code, :err_text);
      if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;
    end

    update ACCOUNT_POST AP
    set    AP.ID_ACCOUNT           = :id_account,
           AP.ID_SERVICE           = :id_service,
  
           AP.QTY_POST             = :qty_post,
           AP.QTY_FREE             = :qty_free,
           AP.PRICE_POST           = :price_post,
           AP.CURR_POST            = :post_currency,
           AP.RATE_POST            = :rate_post,
           AP.RATE_ORIG            = :rate,
           AP.PRICE_ORIG           = :price,
           AP.CURR_ORIG            = :curr,
           AP.POST_NET_VALUE       = :post_net_value,
           AP.POST_GROSS_VALUE     = :post_gross_value,
  
           AP.AC                   = :new_ac,
           AP.IS_ANUL              = 0,
           AP.ANUL_REASON          = '',
           AP.IS_LOCKED_FOR_UPDATE = :is_locked_for_update,
           AP.ID_TARIFF            = :id_tariff,
           AP.ID_PACK_SERVICE      = :id_pack_service,
           AP.ID_ROOM              = :id_room,
           AP.ID_ROOM_TYPE         = :id_room_type,
           AP.ROOM_NAME            = :room_name,
           AP.ID_SALE_TAXATION     = :id_sale_taxation,
           AP.ORIGINAL_POST        = :original_post,
           AP.SHORT_CODE           = :short_code,
           AP.CHANGED_TEXT         = :changed_text,
           AP.USER_CHANGED         = current_user,
           AP.DATETIME_CHANGED     = current_timestamp,
           Ap.FROM_DATE            = :from_date,
           Ap.TO_DATE              = :to_date
    where  AP.rdb$db_key = :AP_DBKEY
    returning new.id_account_post, new.id_pack_service
    into   :id_account_post, :new_id_pack_service;
  
    if (:new_ac = '01') then begin
      update ACCOUNT_POST_CORRECTION APC
      set    APC.IS_OPEN = 0
      where  APC.ID_ACCOUNT_POST = :id_account_post
             and APC.IS_OPEN = 1;
    end

    if (:orig_is_base = 1 and :new_id_pack_service <> :id_pack_service) then begin
      -- update add_inses with new pack service
      update ACCOUNT_POST AP
      set    ap.ID_PACK_SERVICE = :new_id_pack_service
      where  ap.ID_MASTER_ADDINS_ACC_POST = :id_account_post
             and ap.IS_BASE = 0;
    end

    OUT_QTY_POST = :qty_post;
    OUT_PRICE_POST = :price_post;
    OUT_AC = :new_ac;
  end
end
^

/* Alter (ACCOUNT_POSTING_UPDATE_PERC) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_PERC(IN_ID_ACCOUNT_POST VARCHAR(4000),
IN_PERC NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(30))
 AS
declare variable id_account_post integer;
  declare variable ap_dbkey char(8);
  declare variable id_service integer;
  declare variable id_tariff integer;
  declare variable id_room integer;
  declare variable qty_post numeric (15,4);
  declare variable qty_free numeric (15,4);
  declare variable short_code varchar(255);
  declare variable orig_currency char(3);
  declare variable orig_rate numeric (15,4);
  declare variable orig_price numeric (15,4);
  declare variable new_orig_price double precision;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  for
    select item
    from   SYSTEM_STRING_PARSER(:in_id_account_post, ',')
    into   :id_account_post
  do begin
    select AP.rdb$db_key, AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST,
           AP.QTY_FREE, AP.SHORT_CODE, AP.CURR_ORIG, AP.RATE_ORIG, AP.PRICE_ORIG,
           ap.FROM_DATE, ap.TO_DATE
    from   ACCOUNT_POST AP
    where  AP.ID_ACCOUNT_POST = :id_account_post
    into   :ap_dbkey, :id_service, :id_tariff, :id_room, :qty_post,
           :qty_free, :short_code, :orig_currency, :orig_rate, :orig_price,
           :from_date, :to_date;

    new_orig_price = :orig_price + :orig_price * :in_perc;

    execute procedure ACCOUNT_POSTING_UPDATE$INT(:ap_dbkey,
            :id_service, :id_tariff, :id_room,
            :qty_post, :qty_free, :new_orig_price, :orig_currency, :orig_rate,
            :in_changed_text, :short_code, :from_date, :to_date)
    returning_values  :no_use, :no_use, :no_use;
  end
end
^

/* Alter (ACCOUNT_SELECTION_UNITE$DOC) */
ALTER PROCEDURE ACCOUNT_SELECTION_UNITE$DOC(ID_DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
PROFILE_ACCOUNTS_ONLY SMALLINT = 0)
 RETURNS(SKIP_DOC_SELECTED INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_deposit integer;
  declare variable id_base_doc integer;
  declare variable avail_value double precision ;
  declare variable dbkey char(8);
  declare variable id_account integer;
  declare variable id_profile integer;
  declare variable description varchar(100);
begin
  dbg = null;
  skip_doc_selected = null;
  id_profile = null;
  if (:PROFILE_ACCOUNTS_ONLY = 1) then begin
    select A.ID_PROFILE
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :ID_DEST_ACCOUNT
    into   :ID_PROFILE;
  end

  for
    select AP.ID_ACCOUNT, max(AP.ID_BASE_DOC)
    from   ACCOUNT_POST AP
           join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
    where  AP.DOC_SELECTED = :ID_DOC_SELECTED
           and AP.ID_ACCOUNT is distinct from :ID_DEST_ACCOUNT
           and A.ID_PROFILE = coalesce(:ID_PROFILE, A.ID_PROFILE)
    group by AP.ID_ACCOUNT
    into   :ID_ACCOUNT, :ID_BASE_DOC
  do begin
    if (:ID_BASE_DOC is null) then begin
      /* posting transfer loging is released into next procedure */
      execute procedure ACCOUNT_POSTING_TRANSFER$ACC (:ID_DOC_SELECTED, :ID_DEST_ACCOUNT, :ID_ACCOUNT);
    end else begin
      /* has a document on some postings - skip transfer */
      SKIP_DOC_SELECTED = -:ID_DOC_SELECTED;
      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :SKIP_DOC_SELECTED
      where  AP.DOC_SELECTED = :ID_DOC_SELECTED
             and AP.ID_ACCOUNT = :ID_ACCOUNT;
    end
  end

  for
    select D.ID_ACCOUNT, D.ID_DEPOSIT, D.RDB$DB_KEY
    from   DEPOSIT D
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  D.DOC_SELECTED = :ID_DOC_SELECTED
           and D.ID_ACCOUNT is distinct from :ID_DEST_ACCOUNT
           and A.ID_PROFILE = coalesce(:ID_PROFILE, A.ID_PROFILE)
    order by 1 asc
    into   :ID_ACCOUNT, :ID_DEPOSIT, :DBKEY
  do begin
    if (not exists (select AP.ID_ACCOUNT_POST
                    from   ACCOUNT_POST AP
                    where  AP.ID_ACCOUNT = :ID_ACCOUNT
                           and AP.DOC_SELECTED = -:ID_DOC_SELECTED)) then
    begin
      /* transfer selected item */
      AVAIL_VALUE = null;
      select DA.AVAIL_VALUE, DA.DESCRIPTION
      from   DEPOSIT_AVAILABLE DA
      where  DA.ID_DEPOSIT = :ID_DEPOSIT
      into   :AVAIL_VALUE, :DESCRIPTION;

      if (:AVAIL_VALUE is not null) then begin
        execute procedure DEPOSIT_TRANSFER$ACC (:ID_DEPOSIT, :ID_DEST_ACCOUNT, :AVAIL_VALUE, :DESCRIPTION)
        returning_values  :DBG;
      end
    
      update DEPOSIT D
      set    D.DOC_SELECTED = null
      where  D.RDB$DB_KEY = :DBKEY;
    end else begin
      /* skipped account */
      SKIP_DOC_SELECTED = -:ID_DOC_SELECTED;
      update DEPOSIT D
      set    D.DOC_SELECTED = :SKIP_DOC_SELECTED
      where  D.RDB$DB_KEY = :DBKEY;
    end
  end 

end
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUP_PREPARE$AVL for: AVAILABILITY_OCCUPANCY$INT */
ALTER PROCEDURE AVAILABILITY_OCCUP_PREPARE$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS INTEGER,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUPANCY$AVL for: AVAILABILITY_OCCUPANCY$INT */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUPANCY_PREPARE for: AVAILABILITY_OCCUPANCY$INT */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY_PREPARE(FROM_DATE DATE,
TO_DATE DATE,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TEST_RATING for: AVAILABILITY_OCCUPANCY$INT */
ALTER PROCEDURE TEST_RATING RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (AVAILABILITY_OCCUPANCY$INT) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$INT(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
declare variable id_global_agent integer;
  declare variable for_date date;
  declare variable id_agent integer;
  declare variable id_room_type integer;
  declare variable g_capacity integer;
  declare variable bp_defined integer;
  declare variable c_defined integer;
  declare variable fdata integer;
  declare variable bp_is_released integer;
  declare variable c_is_released integer;
  declare variable gsts_in_house integer;
  declare variable gsts_come integer;
  declare variable gsts_gone integer;
  declare variable rooms_come integer;
  declare variable rooms_gone integer;
  declare variable id_hotel integer;
  declare variable id_b_allotment integer;
  declare variable id_c_allotment integer;
  declare variable ooo_rooms integer;
  declare variable ooi_rooms integer;
  declare variable sold_rooms integer;
  declare variable res_room_conf integer;
  declare variable res_room_notconf integer;
  declare variable res_room_wait integer;
begin
  /*  Description:   */
  HOTELS = coalesce(:HOTELS, '');
  ID_GLOBAL_AGENT = -100; /* HOLDS DATA GLOBAL FOR THE HOTEL */

  delete from SMART_OCCUP$TMP;

  for
    select RC.ID_ROOM_TYPE, RC.ID_HOTEL, RC.FOR_DATE, sum(RC.CNT_DEFINED)
    from   HOTEL_S H
           left outer join ALLOTMENT_GET$INT(H.ID_INVENTORY_ALLOTMENT, :FROM_DATE, :TO_DATE, null, 'PLAIN_PERIOD', :HOTELS) RC on 0=0
    where  ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
    group by 1, 2, 3
    into   :ID_ROOM_TYPE, :ID_HOTEL, :FOR_DATE, :G_CAPACITY
  do begin
    execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_global_agent, :id_room_type, :id_hotel, :g_capacity);
  end

  for
    select   RM.BUSY_DATE, RM.ID_ROOM_TYPE, RM.ID_HOTEL,
             iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (18,20), :ID_GLOBAL_AGENT, coalesce(RS.ID_AGENT, RM.ID_AGENT)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 18, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 20, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 24, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_CONFIRMED', RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_NOTCONFIRMED', RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_RESERVS', RM.ID_ROOM, null))
    from     ROOM_MAGIC RM
             join HOTEL_S H on H.ID_HOTEL = RM.ID_HOTEL
             left outer join ROOMS_SHARE RS on RS.ID_ROOM_SHARE = RM.ID_ROOM_MAGIC
    where    RM.BUSY_DATE between :from_date and :to_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
             and rm.ROOM_STATUS is distinct from 'PRIVATE'
             and ((not (:RES_CONFIRMED = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_CONFIRMED'))
                  or (not (:RES_NOTCONFIRMED = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_NOTCONFIRMED'))
                  or (not (:RES_WAITING = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_RESERVS')))
    group by 1, 2, 3, 4
    into     :for_date, :id_room_type, :id_hotel, :id_agent,
             :ooo_rooms, :ooi_rooms, :sold_rooms, :res_room_conf, :res_room_notconf, :res_room_wait
  do begin
    execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
            null, :ooo_rooms, :ooi_rooms, null, :sold_rooms, :res_room_conf, :res_room_notconf, :res_room_wait);
  end

  if (:BOOKING_POSITIONS + :CONTINGENT > 0) then begin
    for
      select PA.ID_AGENT, PA.ID_BOOKING_POSITION, pa.ID_CONTINGENT
      from   PROFILE_AGENT PA
      where  (pa.ID_CONTINGENT is not null) or (pa.ID_BOOKING_POSITION is not null)
      into   :id_agent, :id_b_allotment, :id_c_allotment
    do begin
      for
        select al.for_date, al.id_room_type, al.id_hotel,
               sum(al.b_defined), max(al.b_is_released), sum(al.c_defined), max(al.c_is_released)
        from   (select ABP.FOR_DATE, ABP.ID_ROOM_TYPE, ABP.ID_HOTEL,
                       ABP.CNT_DEFINED as b_defined, ABP.IS_RELEASED as b_is_released, null as c_defined, null as c_is_released
                from   ALLOTMENT BA
                       left join ALLOTMENT_GET$INT(ba.ID_ALLOTMENT, :from_date, :to_date, null, 'RELEASES', :hotels) ABP on 1=1
                where  :BOOKING_POSITIONS = 1 and ba.ID_ALLOTMENT = :id_b_allotment
                union all
                select ACG.FOR_DATE, ACG.ID_ROOM_TYPE, ACG.ID_HOTEL, null, null, ACG.CNT_DEFINED, ACG.IS_RELEASED
                from   ALLOTMENT CA
                       left join ALLOTMENT_GET$INT(ca.ID_ALLOTMENT, :from_date, :to_date, null, '', :hotels) ACG on 1=1
                where  :CONTINGENT = 1 and CA.ID_ALLOTMENT = :id_c_allotment
               ) al
        where  al.for_date is not null
        group by 1, 2, 3
        into   :for_date, :id_room_type, :id_hotel,
               :bp_defined, :bp_is_released, :c_defined, :c_is_released
      do begin
        execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
                null, null, null, null, null, null, null, null, :c_defined, :c_is_released, :bp_defined, :bp_is_released);
      end
    end
  end

  if (:OVERBOOK = 1) then begin
    for
      select ACG.FOR_DATE, ACG.ID_ROOM_TYPE, ACG.ID_HOTEL, ACG.CNT_DEFINED
      from   HOTEL_S H
             left outer join ALLOTMENT_GET$INT(H.ID_OVERBOOK_ALLOTMENT, :FROM_DATE, :TO_DATE, null, '', :HOTELS) ACG on 0=0
      where  ACG.FOR_DATE is not null
             and ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
      into   :for_date, :id_room_type, :id_hotel, :fdata
    do begin
      execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
              null, null, null, :fdata);
    end
  end

  if (:FETCH_TOTALS = 1) then begin
    for
      select SOGT.BUSY_DATE, SOGT.ID_ROOM_TYPE, sum(SOGT.GSTS_COME+SOGT.GSTS_STAYOVER), sum(SOGT.GSTS_COME),
             sum(SOGT.GSTS_GONE), sum(SOGT.ROOMS_COME), sum(SOGT.ROOMS_GONE), SOGT.ID_HOTEL, SOGT.ID_AGENT
      from   REP_ROOM_STATUS_MOVE(:from_date, :to_date, -1, -1, -1, '', '', :hotels) SOGT
      group by SOGT.BUSY_DATE, SOGT.ID_ROOM_TYPE, SOGT.ID_HOTEL, SOGT.ID_AGENT
      into   :for_date, :id_room_type, :gsts_in_house, :gsts_come,
             :gsts_gone, :rooms_come, :rooms_gone, :id_hotel, :id_agent
    do begin
      execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
              null, null, null, null, null, null, null, null, null, null, null, null,
              :gsts_in_house, :gsts_come, :gsts_gone, :rooms_come, :rooms_gone);
    end
  end
end
^

/* Alter (AVAILABILITY_OCCUPANCY_PREPARE) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY_PREPARE(FROM_DATE DATE,
TO_DATE DATE,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
begin
  -- used from some reports - generate occupancy for selection
  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, 1, :OVERBOOK,
          :RES_CONFIRMED, :RES_NOTCONFIRMED, :RES_WAITING, :BOOKING_POSITIONS, :CONTINGENT, :HOTELS);
   
  execute procedure AVAILABILITY_OCCUPANCY_OPT$INT (:RELEASE_DATES, :OVERBOOK,
          :RES_CONFIRMED, :RES_NOTCONFIRMED, :RES_WAITING, :BOOKING_POSITIONS, :CONTINGENT);

  ID_OCCUPANCY_SESSION = current_transaction;
  suspend;
end
^

/* Alter (CONTRACT_MANAGEMENT_POST$INT) */
ALTER PROCEDURE CONTRACT_MANAGEMENT_POST$INT(ID_PMS_EVENT TYPE OF ID,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
CONTRACT_TYPE VARCHAR(30),
ID_OWNER TYPE OF ID,
ID_RENTAL_POOL TYPE OF ID_REF,
VALUE_ORIG TYPE OF TPRICE,
CURR_ORIG TYPE OF TCURRENCY,
POST_DATE TYPE OF TDATE,
STAY TYPE OF TCOUNT,
OWNERSHIP_PERCENT TYPE OF TPERCENT)
 RETURNS(POSTED_VALUE TYPE OF TPRICE,
POSTED_CURRENCY TYPE OF TCURRENCY)
 AS
declare variable night_price numeric(15,4);
  declare variable night_price_curr varchar(3);
  declare variable id_account integer;
  declare variable my_value numeric(15,4);
  declare variable my_currency varchar(3);
  declare variable id_service integer;
  declare variable do_post smallint;
  declare variable is_owner_income smallint;
  declare variable id_account_post_pms integer;
  declare variable use_shadow_account integer;
  declare variable id_hotel integer;
  declare variable is_account$pms integer;
  declare variable round_to numeric(15,4);
begin

  do_post = 0;
  posted_value = null;
  posted_currency = null;
  is_owner_income = 1;
  use_shadow_account = iif(:SUB_CONTRACT = 'SHADOW_ACC', 1, 0);

  select c.ROUND_TO
  from   CURRS c
  where  c.CURR = :curr_orig
  into   :round_to;

  /*select P.ID_ACCOUNT
  from   ACCOUNT$PMS P
  where  P.ID_OWNER = coalesce(:ID_RENTAL_POOL,:ID_OWNER)
         and P.IS_SHADOW = :use_shadow_account
         and P.IS_CLIENT_POOL_ACCOUNT = 0
  into   :id_account;*/
  select r.ID_HOTEL
  from   PMS_EVENT$PMS p
         join ROOMS R on R.ID_ROOM = p.ID_ROOM
  where  p.ID_PMS_EVENT = :ID_PMS_EVENT
  into   :id_hotel;

  execute procedure OWNER_ACCOUNT_GET$INT (coalesce(:ID_RENTAL_POOL,:ID_OWNER),
          :id_hotel, :use_shadow_account, 0)
  returning_values (:id_account, :is_account$pms);

  for
    select C.NIGHT_PRICE, C.NIGHT_PRICE_CURR, C.ID_SERVICE
    from   CONTRACT_MANAGEMENT$PMS C
    where  C.ID_CONTRACT = :id_contract
           and c.SUB_CONTRACT = :SUB_CONTRACT
    into   :night_price, :night_price_curr, :ID_SERVICE
  do begin
    if (:CONTRACT_TYPE = 'PRIVATE_USE' and :use_shadow_account = 0) then begin
      do_post = 0;
    end
    if (:CONTRACT_TYPE = 'TO_PRICE' and :use_shadow_account = 0) then begin
      my_value = :VALUE_ORIG;
      my_currency = :CURR_ORIG;
      do_post = 1;
    end
    if (:CONTRACT_TYPE = 'FIXED_PRICE' and :use_shadow_account = 0) then begin
      my_value = :night_price * :stay;
      my_currency = :night_price_curr;
      do_post = 1;
    end
    if (:CONTRACT_TYPE = 'GUARANTEE_INCOME_FIXED_PRICE' and :use_shadow_account = 1) then begin
      my_value = :night_price * :stay;
      my_currency = :night_price_curr;
      do_post = 1;
    end
    if (:CONTRACT_TYPE = 'GUARANTEE_INCOME_TO_PRICE' and :use_shadow_account = 1) then begin
      my_value = :VALUE_ORIG;
      my_currency = :CURR_ORIG;
      do_post = 1;
    end
    if (:CONTRACT_TYPE = 'TO_PRICE_FIXED_PRICE') then begin
      if (:use_shadow_account = 0) then begin
        my_value = :VALUE_ORIG;
        my_currency = :CURR_ORIG;
      end else if (:USE_SHADOW_ACCOUNT = 1) then begin
        my_value = :night_price * :stay;
        my_currency = :night_price_curr;
      end
      do_post = 1;
    end
    if (:CONTRACT_TYPE = 'FIXED_PRICE_TO_PRICE') then begin
      if (:use_shadow_account = 0) then begin
        my_value = :night_price * :stay;
        my_currency = :night_price_curr;
      end else if (:USE_SHADOW_ACCOUNT = 1) then begin
        my_value = :VALUE_ORIG;
        my_currency = :CURR_ORIG;
      end
      do_post = 1;
    end
  
    if (:do_post = 1 and :id_service is not null) then begin
      my_value = round_f(cast(:my_value as double precision) * :ownership_percent / 100, :round_to);
      execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account,
              :id_owner, :my_currency, :my_value, :id_service, :is_owner_income, :post_date)
      returning_values  (:id_account_post_pms);
      posted_value = :my_value;
      posted_currency = :my_currency;
    end
  end
end
^

/* Alter (DEPOSIT_DOCUMENT_INITIALIZE$DOC) */
ALTER PROCEDURE DEPOSIT_DOCUMENT_INITIALIZE$DOC(ID_PAYMENT_HEAD TYPE OF ID,
ID_BILLING_SERVICE TYPE OF ID)
 RETURNS(ID_DOC_HEAD TYPE OF ID,
ID_HOTEL TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
WARN_CODE TYPE OF TRANGE)
 AS
declare variable id_dep_doc integer;
declare variable doc_selected integer;
declare variable payment_date date;
declare variable system_date date;
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_BILLING');

  id_dep_doc = null;

  select p.ID_DOC_HEAD, p.ID_ACCOUNT, p.PAYMENT_DATE, a.ID_HOTEL
  from   PAYMENT_HEAD P
         join DEPOSIT d on d.ID_PAYMENT_HEAD = p.ID_PAYMENT_HEAD
         join ACCOUNT a on a.ID_ACCOUNT = p.ID_ACCOUNT
  where  p.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
         and p.IS_ANUL = 0
  into   :id_dep_doc, :id_account, :payment_date, :id_hotel;

  if (:id_account is null) then
    exception DOCUMENT_EXCEPTION '-355';

  if (:id_dep_doc is not null) then
    exception DOCUMENT_EXCEPTION '-364';

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :system_date;

  if (:payment_date < :system_date) then
    exception DOCUMENT_EXCEPTION '-399';

  doc_selected = gen_id(DOC_SELECTED_GEN, 1);

  update DEPOSIT P
  set    p.DOC_SELECTED = :doc_selected,
         p.ID_BILLING_SERVICE = :ID_BILLING_SERVICE
  where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;

  execute procedure DOCUMENT_INITIALIZE$DOC (:ID_ACCOUNT, :doc_selected)
  returning_values  (:ID_DOC_HEAD, :ID_HOTEL, :WARN_CODE);

end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ADVANCE_PAYMENT$INT for: DOCUMENT_ADD_PAYMENT_LINE$INT */
ALTER PROCEDURE DOCUMENT_ADVANCE_PAYMENT$INT(ID_DOC_HEAD INTEGER,
ID_PAYMENT_HEAD INTEGER,
ACC_RATE NUMERIC(15,6))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_USE_DEPOSIT$DOC for: DOCUMENT_ADD_PAYMENT_LINE$INT */
ALTER PROCEDURE DOCUMENT_USE_DEPOSIT$DOC(ID_DOC_HEAD INTEGER,
ID_DEPOSIT INTEGER,
DEPOSIT_AMOUNT NUMERIC(15,4))
 AS
 BEGIN EXIT; END
^

/* Alter (DOCUMENT_ADD_PAYMENT_LINE$INT) */
ALTER PROCEDURE DOCUMENT_ADD_PAYMENT_LINE$INT(ID_DEPOSIT TYPE OF ID,
ID_DOC_HEAD TYPE OF ID,
DOC_VALUE TYPE OF TPRICE,
ID_SALE_TAXATION INTEGER = null)
 RETURNS(ID_DOC_LINE TYPE OF ID)
 AS
declare variable pay_date date;
  declare variable round_to numeric(15,4);
  declare variable nat_round_to numeric(15,4);
  declare variable nat_gross_value numeric(15,4);
  declare variable service_name varchar(50);
  declare variable id_service integer;
  declare variable id_tax_policy integer;
  declare variable no_use varchar(255);
  declare variable sec_curr_rate numeric(15,6);
  declare variable sec_curr_round numeric(15,4);
  declare variable sec_gross_value numeric(15,4);
  declare variable doc_rate numeric(15,6);
  declare variable sec_curr varchar(3);
  declare variable id_hotel integer;
begin

  select P.PAYMENT_DATE, A.ID_TAX_POLICY, A.ID_HOTEL, d.ID_BILLING_SERVICE
  from   DEPOSIT D
         join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :pay_date, :id_tax_policy, :id_hotel, :id_service;
  /*
  execute procedure SETTING_GET_VALUE ('DEF_DEPOSIT_BILLING_SERVICE', :ID_HOTEL)
  returning_values  (:id_service);
  */

  service_name = null;
  select S.SERVICE_NAME
  from   SERVICES S
  where  S.ID_SERVICE = :id_service
  into   :service_name;

  if (:service_name is null) then exception DOCUMENT_EXCEPTION '-378';

  execute procedure DOCUMENT_CURRS_GET$INT (:ID_DOC_HEAD)
  returning_values (:no_use, :doc_rate, :round_to, :no_use, :nat_round_to,
                   :sec_curr, :sec_curr_rate, :sec_curr_round);

  if (:ID_SALE_TAXATION is null) then begin
    select t.ID_SALE_TAXATION
    from   SERVICE_TAXATION t
    where  t.ID_SERVICE = :id_service
           and t.ID_TAX_POLICY = :id_tax_policy
    into   :ID_SALE_TAXATION;
  end

  nat_gross_value = round_f(:doc_value * :doc_rate, :nat_round_to);
  sec_gross_value = round_f(:doc_value * cast(:doc_rate / :sec_curr_rate as double precision), :sec_curr_round);

  execute procedure DOCUMENT_LINE_ADD$INT (:ID_DOC_HEAD, :id_service, :ID_SALE_TAXATION,
          :service_name, -1, :pay_date, :pay_date, :pay_date, null,
          1, :DOC_VALUE, round_f(:doc_value, :round_to), :round_to,
          :nat_gross_value, :nat_round_to, :sec_curr, :sec_gross_value, :sec_curr_round,
          0, 1, 0)
  returning_values (:id_doc_line, :no_use, :no_use, :no_use);

  insert into DOC_LINE_DEP_VALUES (ID_DOC_LINE, ID_DEPOSIT)
  values (:id_doc_line, :ID_DEPOSIT);

end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_CREATE$INT for: DOCUMENT_ADVANCE_PAYMENT$INT */
ALTER PROCEDURE DOCUMENT_CREATE$INT(DOC_SELECTED INTEGER,
ID_ACCOUNT INTEGER,
ID_DOC_TYPE INTEGER,
DOC_TYPE_NAME /* TYPE OF TOBJECT_NAME */ VARCHAR(50),
DOC_DATE DATE,
DOC_CURR VARCHAR(3),
ID_BASE_DOC INTEGER,
TAX_EVENT_DATE DATE,
IS_PROFORMA /* TLOGICAL */ SMALLINT,
ID_ADVANCE_PAYMENT /* ID_REF */ INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER,
DOC_SUB_TYPE SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOCUMENT_ADVANCE_PAYMENT$INT) */
ALTER PROCEDURE DOCUMENT_ADVANCE_PAYMENT$INT(ID_DOC_HEAD INTEGER,
ID_PAYMENT_HEAD INTEGER,
ACC_RATE NUMERIC(15,6))
 AS
declare variable id_deposit integer;
  declare variable dep_curr varchar(3);
  declare variable pay_rate numeric(15,6);
  declare variable id_doc_line integer;
  declare variable doc_value numeric(15,4);
  declare variable init_pay_value numeric(15,4);
  declare variable deducted_value numeric(15,4);
  declare variable pay_round_to numeric(15,4);
  declare variable id_account_payment integer;
  declare variable initial_deposit_id integer;
  declare variable pay_value numeric(15,4);
  declare variable total_pay_value numeric(15,4);
  declare variable total_doc_value numeric(15,4);
  declare variable id_dep_doc integer;
begin
  total_pay_value = 0;
  total_doc_value = 0;
  for
    select D.ID_DEPOSIT, D.PAY_CURRENCY, d.INIT_PAY_AMOUNT, d.DEDUCTED_AMOUNT, d.ID_DOC_HEAD
    from   DEPOSITS D
    where  d.ID_PAYMENT_HEAD = :id_payment_head
    order by d.ID_DEPOSIT asc
    into   :id_deposit, :dep_curr, :init_pay_value, :deducted_value, :id_dep_doc
  do begin
    initial_deposit_id = coalesce(:initial_deposit_id, :id_deposit);
    if (coalesce(:deducted_value, 0) > 0) then
      exception DOCUMENT_EXCEPTION '-350';

    if (:id_dep_doc is not null) then
      exception DOCUMENT_EXCEPTION '-364';

    if (:pay_rate is null) then
      execute procedure DOCUMENT_CURR_RATE_GET$INT (:ID_DOC_HEAD, :dep_curr)
      returning_values  (:pay_rate, :pay_round_to);
    /*
    if (round_f(:dep_value, :pay_round_to) <= 0) then
      exception DOCUMENT_EXCEPTION 'Unavailable payment amount!';
    */
    update ACCOUNT_PAYMENTS AP
    set    AP.ACC_AMOUNT = AP.PAY_AMOUNT * cast(:pay_rate / :acc_rate as double precision),
           Ap.ACC_RATE  = :acc_rate
    where  AP.ID_DEPOSIT = :id_deposit;

    select min(ap.ID_ACCOUNT_PAYMENT), sum(ap.PAY_AMOUNT)
    from   ACCOUNT_PAYMENTS AP
    where  AP.ID_DEPOSIT = :id_deposit
    into   :id_account_payment, :pay_value;
    total_pay_value = :total_pay_value + :pay_value;

    execute procedure DOCUMENT_ATTACH_PAYMENT$INT (:ID_DOC_HEAD, :id_account_payment, :pay_rate, :pay_value)
    returning_values (:doc_value);
    total_doc_value = :total_doc_value + :doc_value;
  end

  if (:total_pay_value <> 0) then begin
    if (round_f(:total_pay_value - :init_pay_value, :pay_round_to) <> 0) then
      exception DOCUMENT_EXCEPTION '-390' || f_character(31)
                || f_character(29) || formatfloat(:total_pay_value, 'F;0.00')
                || f_character(28) || formatfloat(:init_pay_value, 'F;0.00');
  
    execute procedure DOCUMENT_ADD_PAYMENT_LINE$INT (:initial_deposit_id, :ID_DOC_HEAD, :total_doc_value)
    returning_values  (:id_doc_line);

    update PAYMENT_HEAD P
    set    P.ID_DOC_HEAD = :ID_DOC_HEAD
    where  P.ID_PAYMENT_HEAD = :id_payment_head;
  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_INITIALIZE$DOC for: DOCUMENT_CREATE$INT */
ALTER PROCEDURE DOCUMENT_INITIALIZE$DOC(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
DOC_SELECTED /* TYPE OF ID */ INTEGER,
PROFORMA_NAME_PREFIX VARCHAR(30) = null)
 RETURNS(ID_DOC_HEAD INTEGER,
ID_HOTEL INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_RESET_TYPE$DOC for: DOCUMENT_CREATE$INT */
ALTER PROCEDURE DOCUMENT_RESET_TYPE$DOC(ID_DOC_HEAD INTEGER,
ID_DOC_TYPE INTEGER,
DOC_CURRENCY VARCHAR(3),
PROFORMA_NAME_PREFIX VARCHAR(30))
 AS
 BEGIN EXIT; END
^

/* Alter (DOCUMENT_CREATE$INT) */
ALTER PROCEDURE DOCUMENT_CREATE$INT(DOC_SELECTED INTEGER,
ID_ACCOUNT INTEGER,
ID_DOC_TYPE INTEGER,
DOC_TYPE_NAME TYPE OF TOBJECT_NAME,
DOC_DATE DATE,
DOC_CURR VARCHAR(3),
ID_BASE_DOC INTEGER,
TAX_EVENT_DATE DATE,
IS_PROFORMA TLOGICAL,
ID_ADVANCE_PAYMENT ID_REF)
 RETURNS(ID_DOC_HEAD INTEGER,
DOC_SUB_TYPE SMALLINT)
 AS
declare variable no_use varchar(255);
  declare variable acc_currency char(3);
  declare variable acc_curr_rate numeric(15,6);
  declare variable doc_curr_rate numeric(15,6);
  declare variable sec_curr_rate numeric(15,6);
  declare variable id_doc_num integer;
  declare variable id_hotel integer;
  declare variable second_currency varchar(3);
  declare variable currency_list varchar(1000);
begin
  /* FIND THE ACCOUNT CURRENCY ************************************************/
  select A.ACCOUNT_CURR, A.ID_HOTEL
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :acc_currency, :id_hotel;
  /* FIND THE DOCUMENT LOOKUPS FROM THE DOCUMENT TYPE *************************/
  select iif(:IS_PROFORMA = 1, dti.ID_PROFORMA_NUM, DT.ID_DOC_NUM), dti.SECOND_CURRENCY, dt.CURRENCY_LIST
  from   DOC_TYPE DT
         join DOC_TYPE_INV DTI on DTI.ID_DOC_TYPE = DT.ID_DOC_TYPE
  where  DT.ID_DOC_TYPE = :id_doc_type
         and DT.ID_HOTEL = :id_hotel
  into   :id_doc_num, :second_currency, :currency_list;

  if (:IS_PROFORMA = 1 and :ID_ADVANCE_PAYMENT is not null) then
     exception DOCUMENT_EXCEPTION '-392';
  if (:IS_PROFORMA = 1 and :id_doc_num is null) then
     exception DOCUMENT_EXCEPTION '-393';
  if (:id_doc_num is null) then
    exception DOCUMENT_EXCEPTION '-92' || f_character(31) || f_character(29) || :doc_type_name;
  /* CHECK DOC_TYPE CURRENCY RESTRICTIONS *************************************/
  if (:currency_list not containing :DOC_CURR) then
    exception CURRENCY_IS_NOT_SUPPORTED f_character (29) || :DOC_CURR || f_character (28) || :doc_type_name;
  /* GET ACTUAL CURRENCY RATES ************************************************/
  execute procedure DOCUMENT_CURR_RATE_GET$INT (:DOC_SELECTED, :acc_currency)
  returning_values  (:acc_curr_rate, :no_use);

  execute procedure DOCUMENT_CURR_RATE_GET$INT (:DOC_SELECTED, :DOC_CURR)
  returning_values  (:doc_curr_rate, :no_use);

  if (:second_currency is not null) then
    execute procedure DOCUMENT_CURR_RATE_GET$INT (:DOC_SELECTED, :second_currency)
    returning_values  (:sec_curr_rate, :no_use);
  /*****------------------------------------------------------------------*****/
  /*****                 CREATING THE NEW DOCUMENT                        *****/
  /*****              CREATING NEW RECORD IN DOC_HEAD                     *****/
  /*****                    AND NEW DOC LINES                             *****/
  /*****------------------------------------------------------------------*****/
  ID_DOC_HEAD = :DOC_SELECTED;
  ID_BASE_DOC = coalesce(:ID_BASE_DOC, :ID_DOC_HEAD);

  insert into DOC_HEAD$INT(ID_DOC_HEAD, ID_DOC_TYPE, DOC_SUB_TYPE, ID_ACCOUNT, DOC_DATE,
         DOC_CURRENCY, DOC_RATE, DOC_ACC_RATE, DOC_TYPE_NAME,
         DOC_VALUE, DOC_VALUE_A, DOC_VALUE_ROUNDLESS, ID_BASE_DOC, FOR_DEPOSIT,
         IS_STORNO, IS_STORNED, IS_ANUL, SECOND_CURRENCY, SECOND_CURR_RATE, ID_DOC_NUM)
  values (:id_doc_head, :id_doc_type, 0, :id_account, :DOC_DATE,
         :DOC_CURR, :doc_curr_rate, cast(:doc_curr_rate/:acc_curr_rate as double precision), :DOC_TYPE_NAME,
         0, 0, 0, :id_base_doc, iif(:ID_ADVANCE_PAYMENT is null,  0, 1),
         0, 0, 0, :second_currency, :sec_curr_rate, :id_doc_num);


  if (:IS_PROFORMA is distinct from 1) then begin
    execute procedure DOCUMENT_COMPLETE$INT (:ID_DOC_HEAD, :DOC_DATE, :TAX_EVENT_DATE, null);
  end

  if (:ID_ADVANCE_PAYMENT is null) then begin
    execute procedure DOCUMENT_ADD_SERVICES$INT (:ID_DOC_HEAD, :ID_ACCOUNT);

    execute procedure DOCUMENT_ADD_DISCOUNTS$INT(:ID_DOC_HEAD, :ID_ACCOUNT);

  end else begin
    execute procedure DOCUMENT_ADVANCE_PAYMENT$INT (:ID_DOC_HEAD, :ID_ADVANCE_PAYMENT, :acc_curr_rate);
  end

  execute procedure DOCUMENT_SAVE_TOTAL$INT (:ID_DOC_HEAD)
  returning_values :DOC_SUB_TYPE;

end
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_DOCUMENT_INITIALIZE$DOC for: DOCUMENT_INITIALIZE$DOC */
ALTER PROCEDURE DEPOSIT_DOCUMENT_INITIALIZE$DOC(ID_PAYMENT_HEAD INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER,
ID_HOTEL INTEGER,
ID_ACCOUNT INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TEST_DOC for: DOCUMENT_INITIALIZE$DOC */
ALTER PROCEDURE TEST_DOC(ID_ACCOUNT INTEGER,
DOC_SELECTED INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOCUMENT_INITIALIZE$DOC) */
ALTER PROCEDURE DOCUMENT_INITIALIZE$DOC(ID_ACCOUNT TYPE OF ID,
DOC_SELECTED TYPE OF ID,
PROFORMA_NAME_PREFIX VARCHAR(30) = null)
 RETURNS(ID_DOC_HEAD INTEGER,
ID_HOTEL INTEGER,
WARN_CODE INTEGER)
 AS
declare variable id_doc_type integer;
  declare variable id_base_doc integer;
  declare variable tax_event_date date;
  declare variable doc_date date;
  declare variable doc_curr varchar(3);
  declare variable id_doc_contragent integer;
  declare variable id_profile integer;
  declare variable doc_sub_type integer;
  declare variable firm_data blob sub_type 1 segment size 80 character set none;
  declare variable id_advance_payment integer;
  declare variable is_proforma tlogical;
  declare variable is_archive tlogical;
  declare variable doc_type_name varchar(50);
begin
  is_proforma = iif(:PROFORMA_NAME_PREFIX is null, 0, 1);

  if (:IS_PROFORMA is distinct from 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_NOPAY_CREATE');
  end else begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('PROFORMA_CREATE');
  end

  select A.ID_HOTEL, A.ID_PROFILE, H.FIRM_DATA
  from   ACCOUNT A
         join HOTEL H on H.ID_HOTEL  = A.ID_HOTEL
  where  A.ID_ACCOUNT = :id_account
  into   :id_hotel, :id_profile, :firm_data;

  id_advance_payment = null;
  execute procedure DOCUMENT_CHECK_SELECTION$INT (:DOC_SELECTED, :ID_ACCOUNT)
  returning_values  (:id_doc_type, :id_base_doc, :doc_curr, :id_doc_contragent, :id_advance_payment);

  if (:is_proforma = 1 and :id_base_doc is not null) then exception DOCUMENT_EXCEPTION '-1062';

  if (:id_doc_type is null) then begin
    execute procedure DOC_TYPE_GET$INT (:id_hotel, :IS_PROFORMA, :id_advance_payment)
    returning_values (:id_doc_type);
  end

  execute procedure CURR_RATES_PREPARE$INT (:DOC_SELECTED, :ID_ACCOUNT, :doc_date);

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :doc_date;
  tax_event_date = :doc_date;
                                                    
  select coalesce(:doc_curr, DT.DOC_CURR),
         iif (:is_proforma = 1, substring(trim(:PROFORMA_NAME_PREFIX) || ' ' || dt.doc_type_name from 1 for 50), dt.DOC_TYPE_NAME),
         dt.IS_ARCHIVE
  from   DOC_TYPE DT
  where  DT.ID_DOC_TYPE = :id_doc_type
  into   :doc_curr, :DOC_TYPE_NAME, :is_archive;

  if (:is_archive = 1) then execute procedure SYSTEM_WARNING_ADD(-312, '') returning_values :WARN_CODE;

  execute procedure DOCUMENT_CREATE$INT (:DOC_SELECTED, :ID_ACCOUNT, :id_doc_type, :doc_type_name, :doc_date, :doc_curr, :id_base_doc, :tax_event_date, :is_proforma, :id_advance_payment)
  returning_values  (:ID_DOC_HEAD, :doc_sub_type);

  if (:ID_ADVANCE_PAYMENT is null and :IS_PROFORMA is distinct from 1 and :doc_sub_type < 2) then begin
    execute procedure DOCUMENT_ATTACH_AVAIL_PAYS$INT (:ID_DOC_HEAD, :ID_ACCOUNT);
  end

  if (:id_doc_contragent is not null) then begin
    execute procedure DOC_CONTRAGENT_INITIALIZE$DOC (:ID_DOC_HEAD, null, :id_doc_contragent);
  end else begin
    execute procedure DOC_CONTRAGENT_INITIALIZE$INT (:ID_DOC_HEAD, 0, :id_profile);
  end

  execute procedure DOC_SUPPLIER_SET$DOC (:ID_DOC_HEAD, :firm_data);

  when exception DOC_ON_EMPTY_SELECTION do begin
    ID_DOC_HEAD = null;
  end
end
^

/* Alter (DOCUMENT_RESET_TYPE$DOC) */
ALTER PROCEDURE DOCUMENT_RESET_TYPE$DOC(ID_DOC_HEAD INTEGER,
ID_DOC_TYPE INTEGER,
DOC_CURRENCY VARCHAR(3),
PROFORMA_NAME_PREFIX VARCHAR(30))
 AS
declare variable id_account integer;
  declare variable old_id_doc_type integer;
  declare variable id_doc_contragent integer;
  declare variable id_doc_supplier integer;
  declare variable is_deposit integer;
  declare variable old_doc_curr varchar(3);
  declare variable doc_date date;
  declare variable tax_event_date date;
  declare variable id_base_doc integer;
  declare variable dbg varchar(1000);
  declare variable d_dbkey char(8);
  declare variable bonuspoints integer;
  declare variable id_advance_payment integer;
  declare variable id_payment_head integer;
  declare variable id_hotel integer;
  declare variable is_proforma tlogical;
  declare variable doc_type_name varchar(50);
  declare variable doc_sub_type smallint;
begin
  is_proforma = iif(:PROFORMA_NAME_PREFIX is null, 0, 1);

  select D.ID_ACCOUNT, D.ID_DOC_TYPE, D.ID_DOC_CONTRAGENT, D.ID_DOC_SUPPLIER,
         D.FOR_DEPOSIT, D.DOC_CURRENCY, D.DOC_DATE, DC.TAX_EVENT_DATE,
         D.ID_BASE_DOC, D.RDB$DB_KEY, a.ID_HOTEL, d.DOC_SUB_TYPE
  from   DOC_HEAD$INT D
         join ACCOUNT A on a.ID_ACCOUNT = d.ID_ACCOUNT
         left outer join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :id_account, :old_id_doc_type, :id_doc_contragent, :id_doc_supplier,
         :is_deposit, :old_doc_curr, :doc_date, :tax_event_date,
         :id_base_doc, :d_dbkey, :id_hotel, :doc_sub_type;
  /***************/
  if (:doc_sub_type > 0) then exit; -- can't change type for credit or debit document
  /***************/
  if ((:old_id_doc_type <> :ID_DOC_TYPE) or (:old_doc_curr <> :DOC_CURRENCY)) then begin
    for
      select p.ID_PAYMENT_HEAD
      from   PAYMENT_HEAD p
      where  p.ID_DOC_HEAD = :ID_DOC_HEAD
      into   :id_payment_head
    do begin
      execute procedure DOC_TYPE_EVALUATE$INT (:ID_DOC_TYPE, :id_hotel, :is_proforma, :id_payment_head);
    end

    id_advance_payment = null;
    if (:is_deposit = 1) then begin
      select first 1 p.ID_PAYMENT_HEAD
      from   PAYMENT_HEAD p
      where  p.ID_DOC_HEAD = :ID_DOC_HEAD
      into   :id_advance_payment;

      update PAYMENT_HEAD DP
      set    DP.ID_DOC_HEAD = null
      where  DP.ID_DOC_HEAD = :ID_DOC_HEAD;
    end
    /* update old document with reverse ID, to be deleted on the end */
    update DOC_HEAD$INT OD
    set    OD.ID_DOC_HEAD = -OD.ID_DOC_HEAD
    where  OD.RDB$DB_KEY = :d_dbkey;
    /* recreate document */
    select iif (:is_proforma = 1, substring(trim(:PROFORMA_NAME_PREFIX) || ' ' || dt.doc_type_name from 1 for 50), dt.DOC_TYPE_NAME)
    from   DOC_TYPE dt
    where  dt.ID_DOC_TYPE = :ID_DOC_TYPE
    into   :doc_type_name;

    execute procedure DOCUMENT_CREATE$INT (:ID_DOC_HEAD, :id_account, :ID_DOC_TYPE,
            :doc_type_name, :doc_date, :DOC_CURRENCY, :id_base_doc, :tax_event_date, :is_proforma, :id_advance_payment)
    returning_values  (:dbg, :dbg);
    /* reuse bonuspoints discounts */
    for
      select DF.TAXABLE_VALUE
      from   DOC_FOOTER DF
      where  DF.ID_DOC_HEAD = -:ID_DOC_HEAD
             and DF.ID_TAX is null
      into   :bonuspoints
    do begin
      execute procedure DOCUMENT_BONUSPOINTS_SPEND (:ID_DOC_HEAD, :bonuspoints)
      returning_values (:dbg);
    end 
    /* reuse deposits and payments */
    if (:is_deposit = 0) then begin
      execute procedure DOCUMENT_REUSE_DEPOSITS$INT (-:ID_DOC_HEAD, :ID_DOC_HEAD);

      execute procedure DOCUMENT_REUSE_PAYMENTS$INT (-:ID_DOC_HEAD, :ID_DOC_HEAD);
    end
    /* get client and sipplier data */
    update DOC_HEAD$INT D
    set    D.ID_DOC_CONTRAGENT = :id_doc_contragent,
           D.ID_DOC_SUPPLIER = :id_doc_supplier
    where  D.ID_DOC_HEAD = :ID_DOC_HEAD;
    /* delete old document */
    delete from DOC_HEAD$INT D
    where  D.ID_DOC_HEAD = -:ID_DOC_HEAD;
    /*  */
  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ATTACH_AVAIL_PAYS$INT for: DOCUMENT_USE_DEPOSIT$DOC */
ALTER PROCEDURE DOCUMENT_ATTACH_AVAIL_PAYS$INT(ID_DOC_HEAD INTEGER,
ID_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_REUSE_DEPOSITS$INT for: DOCUMENT_USE_DEPOSIT$DOC */
ALTER PROCEDURE DOCUMENT_REUSE_DEPOSITS$INT(OLD_ID_DOC_HEAD INTEGER,
NEW_ID_DOC_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (DOCUMENT_USE_DEPOSIT$DOC) */
ALTER PROCEDURE DOCUMENT_USE_DEPOSIT$DOC(ID_DOC_HEAD INTEGER,
ID_DEPOSIT INTEGER,
DEPOSIT_AMOUNT NUMERIC(15,4))
 AS
declare variable id_deposit_doc integer;
  declare variable id_dep_doc_type integer;
  declare variable id_new_doc_type integer;
  declare variable id_dep_taxation integer;
  declare variable dep_doc_curr varchar(3);
  declare variable new_doc_curr varchar(3);
  declare variable pay_curr varchar(3);
  declare variable deposit_doc_value numeric(15,4);
  declare variable id_doc_line integer;
  declare variable pay_round_to numeric(15,4);
  declare variable pay_rate numeric(15,6);
  declare variable doc_sub_type integer;
  declare variable id_account_payment integer;
  declare variable service_amount numeric(15,4);
begin
  ID_DEPOSIT_DOC = null;
  select DH.DOC_SUB_TYPE
  from   DOC_HEAD DH
  where  DH.ID_DOC = :ID_DOC_HEAD
  into   :doc_sub_type;
   
  if (:doc_sub_type = 2) then exception DOCUMENT_EXCEPTION '-372';  /* Can not use deposit into credit doc */
  /*  */
  execute procedure DOCUMENT_DETACH_DEPOSIT$INT (:ID_DOC_HEAD, :ID_DEPOSIT);

  select DH.ID_DOC, DH.ID_DOC_TYPE, DH.DOC_CURRENCY, ph.PAY_CURRENCY
  from   DEPOSIT D
         join PAYMENT_HEAD PH on PH.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
         left outer join DOC_HEAD DH on DH.ID_DOC = PH.ID_DOC_HEAD
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_deposit_doc, :id_dep_doc_type, :dep_doc_curr, :pay_curr;

  execute procedure DOCUMENT_CURR_RATE_GET$INT (:ID_DOC_HEAD, :pay_curr)
  returning_values (:pay_rate, :pay_round_to);
  /*********************************************************/
  if (round_f(:DEPOSIT_AMOUNT, :PAY_ROUND_TO) = 0) then exit;
  /*********************************************************/
  select first 1 AP.ID_ACCOUNT_PAYMENT
  from   ACCOUNT_PAYMENTS AP
  where  AP.ID_DEPOSIT = :ID_DEPOSIT
  order by ap.ID_ACCOUNT_PAYMENT asc
  into   :id_account_payment;

  execute procedure DOCUMENT_ATTACH_PAYMENT$INT (:ID_DOC_HEAD, :id_account_payment, :pay_rate, :DEPOSIT_AMOUNT)
  returning_values :deposit_doc_value;
   
  if (:ID_DEPOSIT_DOC is not null) then begin
    select first 1 DDL.ID_SALE_TAXATION
    from   DOC_LINE DDL
           join DOC_LINE_DEP_VALUES DV on DV.ID_DOC_LINE = DDL.ID_DOC_LINE
    where  DDL.ID_DOC_HEAD = :ID_DEPOSIT_DOC
           --and DV.ID_DEPOSIT = :ID_DEPOSIT
    into   :id_dep_taxation;
     
    select  D.ID_DOC_TYPE, D.DOC_CURRENCY
    from    DOC_HEAD D
            join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where   D.ID_DOC = :ID_DOC_HEAD
    into    :id_new_doc_type, :new_doc_curr;

    if (not (:id_dep_doc_type = :id_new_doc_type and :dep_doc_curr = :new_doc_curr) ) then
       exception DOCUMENT_EXCEPTION '-374';

    /*if (not exists (select DL.ID_DOC_LINE
                    from   DOC_LINE DL
                           join SALE_TAXATION_TAX ST on ST.ID_SALE_TAXATION = DL.ID_SALE_TAXATION
                           join SALE_TAXES t on t.ID_SALE_TAX = st.ID_SALE_TAX and t.REVENUE_DEDUCTION_TAX is distinct from 1
                    where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
                           and ST.ID_SALE_TAX in (select STT.ID_SALE_TAX
                                                  from   SALE_TAXATION_TAX STT
                                                         join SALE_TAXES t2 on t2.ID_SALE_TAX = stt.ID_SALE_TAX
                                                                              and t2.REVENUE_DEDUCTION_TAX is distinct from 1
                                                  where  STT.ID_SALE_TAXATION = :ID_DEP_TAX))) then
      exception DOCUMENT_EXCEPTION '-373';
    */
    select sum(dl.QTY_POST * dl.SINGLE_VALUE)
    from   DOC_LINE DL
           join SALE_TAXATION_TAX ST on ST.ID_SALE_TAXATION = DL.ID_SALE_TAXATION
           join SALE_TAXES t on t.ID_SALE_TAX = st.ID_SALE_TAX and t.REVENUE_DEDUCTION_TAX is distinct from 1
    where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
           and ST.ID_SALE_TAX in (select STT.ID_SALE_TAX
                                  from   SALE_TAXATION_TAX STT
                                         join SALE_TAXES t2 on t2.ID_SALE_TAX = stt.ID_SALE_TAX
                                                               and t2.REVENUE_DEDUCTION_TAX is distinct from 1
                                         where  STT.ID_SALE_TAXATION = :id_dep_taxation)
    into   :service_amount;

    if (coalesce(:service_amount, 0) < :deposit_doc_value) then
      exception DOCUMENT_EXCEPTION '-334' || f_character(31) || f_character(29) || formatfloat(:service_amount, 'F;0.00') || ' ' || :new_doc_curr;

    deposit_doc_value = -:deposit_doc_value; /* !!! Value should be NEGATIVE - to reduce document total amount */
    execute procedure DOCUMENT_ADD_PAYMENT_LINE$INT (:ID_DEPOSIT, :ID_DOC_HEAD, :deposit_doc_value, :id_dep_taxation)
    returning_values  (:id_doc_line);
  
    execute procedure DOCUMENT_SAVE_TOTAL$INT (:ID_DOC_HEAD)
    returning_values :doc_sub_type;
  end
end
^

/* Alter (EAI_POS_GET_GUESTS$P2E) */
ALTER PROCEDURE EAI_POS_GET_GUESTS$P2E(IN_ROOM_NAME VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(OUT_ID_GUEST INTEGER,
OUT_GUEST_NAME VARCHAR(100),
OUT_FROM_DATE DATE,
OUT_TO_DATE DATE,
OUT_OK_FOR_POST INTEGER,
OUT_COUNTRY VARCHAR(30),
OUT_TEXT VARCHAR(100),
OUT_BOARD_NAME VARCHAR(30),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100))
 AS
declare variable id_room integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  OUT_GUEST_NAME = null;

  /*FIND ROOM*/
  select R.ID_ROOM
  from   ROOMS R
         join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
  where  R.ROOM_NAME = :IN_ROOM_NAME
         and RT.ID_HOTEL = :ID_HOTEL
  into   :ID_ROOM;
  if ((:ID_ROOM is null) or (:ID_ROOM <= 0) ) then begin
    ERR_CODE = -5;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Room number not found!    ! ';
    suspend;
    exit;
  end

  /*FIND GUESTS*/
  for
    select G.ID_GUEST, GC.GUEST_NAME1, G.FROM_DATE, G.TO_DATE, C.COUNTRY_NAME,
           (select m.NAME
            from   GUEST_STAY gs
                   join MEALS M on m.ID_BOARD = gs.ID_BOARD
            where  gs.ID_GUEST = g.ID_GUEST
                   and gs.FOR_DATE = iif(current_date = g.to_date, current_date - 1, current_date))
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
           left outer join GUEST_CARD GC on G.ID_GUEST = GC.ID_GUEST
           left outer join COUNTRY C on C.COUNTRY_CODE = GC.COUNTRY
    where  G.ID_ROOM = :ID_ROOM
           and G.CHECK_STATUS = 0
           and rd.IS_ANUL = 0
    into   :OUT_ID_GUEST, :OUT_GUEST_NAME, :OUT_FROM_DATE,  :OUT_TO_DATE, :OUT_COUNTRY, :OUT_BOARD_NAME
  do begin
    OUT_OK_FOR_POST = iif(:OUT_TO_DATE < current_date, 0, 1) ;
    suspend;
  end

  if (:OUT_GUEST_NAME is null) then begin
    ERR_CODE = -1;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Guests not found!     !';
    suspend;
  end
end
^

/* Alter (EXPORT_PMS) */
ALTER PROCEDURE EXPORT_PMS RETURNS(ID_EXPORT_HEAD INTEGER)
 AS
declare variable start_date date;
  declare variable end_date date;
  declare variable id_hotel integer;
  declare variable initial_begining date;

  declare variable id_room integer;
  declare variable from_date date;
  declare variable to_date date;
  declare variable id_reserv_detail integer;
  declare variable id_doc_head integer;
  declare variable price_with_vat numeric (15,4);
  declare variable price_wo_vat numeric (15,4);
  declare variable curr char(3);
  declare variable new_id_event integer;
  declare variable export_cnt smallint;
  declare variable bednights integer;
  declare variable stay integer;
  declare variable reservs integer;
  declare variable id_contract integer;
  declare variable doc_description tdescription_long;
begin
  export_cnt = 0;
  for
    select H.ID_HOTEL, h.NATION_CURR
    from   HOTEL_S H
    into   :id_hotel, :curr
  do begin
    start_date = null;
    select first 1 EH.TO_SYS_DATE + 1
    from   RESERV_EXPORT$PMS EH
    where  EH.ID_HOTEL = :id_hotel
           and EH.IS_ANUL = 0
    order by EH.ID_EXPORT_HEAD desc
    into   :start_date;

    if (:start_date is null) then begin
      select min(RP.FROM_DATE)
      from   ROOMS R
             join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
             join ROOM_PERIOD$PMS RP on RP.ID_ROOM = R.ID_ROOM
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RT.ID_HOTEL = :id_hotel
             and RP.STATUS in ('PRIVATE','CONTRACT')
      into   :initial_begining;
      start_date = :initial_begining;
    end

    select sd.SYSTEM_DATE - 1
    from   SYSTEM_DATE_GET(:id_hotel) sd
    into   :end_date;

    if (:start_date <= :end_date) then begin
      export_cnt = :export_cnt + 1;
      id_export_head = gen_id(GEN_EXPORT_PMS_ID, 1);
  
      insert into RESERV_EXPORT$PMS (ID_EXPORT_HEAD, ID_HOTEL, FROM_SYS_DATE, TO_SYS_DATE, DT_CREATED, IS_ANUL, DT_ANUL)
      values (:id_export_head, :id_hotel, :start_date, :end_date, current_timestamp, 0, null);
  
      for
        select  ed.id_room, ed.id_reserv_detail, ed.id_contract,
                ed.from_date, ed.to_date, ed.price_with_vat, ed.price_wo_vat,
                ed.bednights, ed.stay, ed.reservs, ed.LAST_ID_DOC_HEAD, ed.DOC_DESCRIPTION
        from    EXPORT_DOCS$PMS (:start_date, :end_date, :id_hotel) ed
        into    :id_room, :id_reserv_detail, :id_contract,
                :from_date, :to_date, :price_with_vat, :price_wo_vat,
                :bednights, :stay, :reservs, :id_doc_head, :doc_description
      do begin
        execute procedure PMS_EVENT_CREATE$INT('INCOME', :id_room, null, '',
                null, :from_date, :to_date, :id_reserv_detail, :id_doc_head,
                :price_with_vat, :price_wo_vat, :curr, :id_export_head,
                :id_contract, :reservs, :stay, :bednights, :doc_description)
        returning_values :new_id_event;
      end

      suspend;
    end
  end

  if (:export_cnt = 0) then exception PMS_EXCEPTION '-618';
end
^

/* Alter (NON_DOCUMENTED_INFO_GET$INT) */
ALTER PROCEDURE NON_DOCUMENTED_INFO_GET$INT(ID_OWNER INTEGER,
ID_ROOM INTEGER)
 RETURNS(OUT_LATE_INFO VARCHAR(255),
OUT_CURR_INFO VARCHAR(255),
OUT_NEXT_INFO VARCHAR(255))
 AS
declare variable from_date date;
declare variable to_date date;
declare variable value_post_total numeric(15,4);
declare variable curr_post varchar(3);
declare variable sub_delim varchar(3);
declare variable short_date_format varchar(50);
declare variable value_format varchar(50);
declare variable has_next smallint;
declare variable tmp_info varchar(5000);
declare variable billing_type varchar(10);
declare variable prev_billing_type varchar(10);
declare variable is_first smallint;
begin
  if (:ID_OWNER is null) then exit;

  OUT_LATE_INFO = null;
  OUT_CURR_INFO = null;
  OUT_NEXT_INFO = null;
  tmp_info = null;

  from_date = '01.01.1500';
  sub_delim = '/ ';
  short_date_format = 'D;dd.mm';
  value_format = 'F;0.00';

  is_first = 1;
  for
    select P.BILLING_PERIOD_FROM, P.BILLING_DATE, P.BILLING_TYPE
    from   PMS_BILLING_CYCLE_CALC(:id_owner) P
    into   :FROM_DATE, :TO_DATE, :billing_type
  do begin
    has_next = 0;
    if (:PREV_BILLING_TYPE <> :BILLING_TYPE) then
      tmp_info = null;

    tmp_info = coalesce(trim(:tmp_info) || '; ', '');

    if (:BILLING_TYPE in ('current', 'late') and :to_date is not null) then
        tmp_info = :tmp_info || formatdate(:to_date, :short_date_format) || :sub_delim;

    FROM_DATE = iif(:IS_FIRST=1, cast('01.01.1500' as date), :FROM_DATE);
    TO_DATE  = coalesce(:TO_DATE, cast('01.01.2500' as date));
    for
      /*  select sum(P.VALUE_POST * iif(P.IS_OWNER_INCOME = 1, 1, -1)), P.CURR_POST
        from   PMS_ACC_POST_TO_BILL_GET$INT(:ID_OWNER, :ID_ROOM, iif(:IS_FIRST=1,'01.01.1500',:FROM_DATE), coalesce(:TO_DATE, '01.01.2500'), 0) P
        group by 2
        into   :value_post_total, :curr_post  */
      select   sum(iif(OP.IS_OWNER_INCOME = 1, OP.INCOME_VALUE, OP.OUTGO_VALUE * (-1))), iif(OP.IS_OWNER_INCOME = 1, OP.INCOME_CURR, OP.OUTGO_CURR)
      from     OWNER_POST OP
               left outer join ACCOUNT_POST$PMS  APP on APP.ID_ACCOUNT_POST = OP.ID_ACCOUNT_POST$PMS
      where    OP.ID_OWNER = :id_owner
               and ((OP.ID_ROOM = :id_room) or (:id_room is null))
               and OP.POST_DATE between :FROM_DATE and :TO_DATE
               --and OP.POST_DATE between iif(:IS_FIRST=1, cast('01.01.1500' as date), :FROM_DATE) and coalesce(:TO_DATE, cast('01.01.2500' as date))
               and OP.POST_STATUS = 11
      group by 2
      into     :value_post_total, :curr_post
    do begin
      tmp_info = trim(:tmp_info) || iif(:has_next = 1, ', ', '');
      tmp_info = iif(:tmp_info = '', '', trim(:tmp_info) || ' ') || FORMATFLOAT(:VALUE_POST_TOTAL, :value_format) || ' ' || :CURR_POST;
      has_next = 1;
    end

    if (:has_next = 0) then begin
      select O.ID_CURRENCY
      from   OWNER$PMS O
      where  O.ID_OWNER = :ID_OWNER
      into   :CURR_POST;

      if (:billing_type in ('late', 'current')) then
        tmp_info = iif(:tmp_info = '', '', trim(:tmp_info) || ' ') || FORMATFLOAT(0, :value_format) || ' ' || :CURR_POST;
    end
    if (:billing_type = 'late') then OUT_LATE_INFO = substring(:tmp_info from 1 for 254);
    if (:billing_type = 'current') then OUT_CURR_INFO = substring(:tmp_info from 1 for 254);
    if (:billing_type = 'next') then OUT_NEXT_INFO = substring(:tmp_info from 1 for 254);
    prev_billing_type = :billing_type;
    is_first = 0;
  end
  suspend;
end
^

/* Alter (OWNER_BILL_MODIFY$PMS) */
ALTER PROCEDURE OWNER_BILL_MODIFY$PMS(ID_OWNER_BILL INTEGER,
ID_OWNER INTEGER,
BILLING_DATE DATE,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_OWNER_BILL INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_anul smallint;
  declare variable bill_num integer;
  declare variable id_account_post_pms integer;
  declare variable id_account_post integer;
  declare variable prev_id_owner_bill integer;
  declare variable prev_billing_date date;

  declare variable id_account integer;
  declare variable id_account_pms integer;
  declare variable value_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable value_post numeric(15,4);
  declare variable curr_post varchar(3);
  declare variable is_owner_income smallint;
  declare variable id_service integer;
  declare variable id_room integer;
  declare variable date_post date;
  declare variable id_reserv_detail integer;
  declare variable doc_description varchar(255);
  declare variable id_doc_head integer;
  declare variable description varchar(255);
  declare variable id_pms_event integer;
  declare variable is_client_account_post smallint;
begin
  err_code = 0;
  err_text = '';
  is_client_account_post = null;
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'create, anul');

  if ( exists ( select *
                from   OWNER$PMS O
                where  O.ID_OWNER = :ID_OWNER
                       and O.ID_RENTAL_POOL_UNIT is not null ) ) then
  begin
    exception PMS_EXCEPTION 'selected owner is pool!';
  end

  if (:operation = 'create') then begin
    is_anul = 0;

    if ( (:ID_OWNER_BILL is null) or (:ID_OWNER_BILL <= 0) )  then
      NEW_ID_OWNER_BILL = gen_id(GEN_OWNER_BILL$PMS_ID, 1);
    else
      NEW_ID_OWNER_BILL = :ID_OWNER_BILL;

    BILL_NUM = :NEW_ID_OWNER_BILL;
    insert into OWNER_BILL$PMS (ID_OWNER_BILL, ID_OWNER, BILL_DATE, IS_ANUL, BILL_NUM,
           IS_EXPORTED_TO_INTRANET, IS_POOL_DISTRIBUTION_STATEMENT)
    values (:NEW_ID_OWNER_BILL, :ID_OWNER, :BILLING_DATE, :IS_ANUL, :BILL_NUM, 0, 0);

    update OWNER$PMS O
    set    O.LAST_BILLING_DATE = :billing_date,
           O.ID_OWNER_BILL = :NEW_ID_OWNER_BILL
    where  O.ID_OWNER = :ID_OWNER;

    for
    /*  select ID_ACCOUNT_POST, ID_ACCOUNT_POST_PMS
      from   PMS_ACC_POST_TO_BILL_GET$INT(:ID_OWNER, null, '01.01.1500', :BILLING_DATE, 1)
      into   :ID_ACCOUNT_POST, :ID_ACCOUNT_POST_PMS */
      select   OP.ID_ACCOUNT_POST, OP.ID_ACCOUNT_POST$PMS
      from     OWNER_POST OP
      where    OP.ID_OWNER = :id_owner
               and OP.POST_DATE between cast('01.01.1500' as date) and :billing_date
               and OP.IS_ANUL = 0
      order by OP.ID_ACCOUNT_POST$PMS nulls last
      into     :ID_ACCOUNT_POST, :ID_ACCOUNT_POST_PMS
    do begin
      if (:id_account_post_pms is not null) then begin

        update ACCOUNT_POST$PMS A
        set    A.LINE_STATUS = 21
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS;

        id_account = null;
        select ACC.ID_SERVICE, ACC.VALUE_ORIG, ACC.CURR_ORIG, ACC.VALUE_POST, ACC.CURR_POST,
               ACC.IS_OWNER_INCOME, ACC.DATE_POST, ACC.ID_ACCOUNT_PMS, E.ID_ROOM,
               E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION, A.IS_CLIENT_POOL_ACCOUNT
        from   ACCOUNT_POST$PMS ACC
               join ACCOUNT$PMS A on A.ID_ACCOUNT = ACC.ID_ACCOUNT_PMS
               join PMS_EVENT$PMS E on E.ID_PMS_EVENT = ACC.ID_PMS_EVENT
        where  ACC.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
        into   :ID_SERVICE, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
               :IS_OWNER_INCOME, :DATE_POST, :ID_ACCOUNT_PMS, :ID_ROOM,
               :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION, :is_client_account_post;
      end

      if (:id_account_post is not null) then begin
        exception PMS_EXCEPTION '-613';
          
        is_client_account_post = 1;
        update PMS_EVENT_POST A
        set    A.LINE_STATUS = 21
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST;

        id_account_pms = null;
        select ACC.ID_SERVICE, ACC.PRICE_ORIG, ACC.CURR_ORIG, ACC.PRICE_POST, ACC.CURR_POST,
               0, ACC.DATE_POST, ACC.ID_ACCOUNT, E.ID_ROOM,
               E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION
        from   ACCOUNT_POST ACC
               join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = ACC.ID_ACCOUNT_POST
               join PMS_EVENT$PMS E on E.ID_PMS_EVENT = PP.ID_PMS_EVENT
        where  ACC.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
        into   :ID_SERVICE, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
               :IS_OWNER_INCOME, :DATE_POST, :ID_ACCOUNT, :ID_ROOM,
               :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION;
      end

      insert into OWNER_BILL_ROW$PMS (ID_OWNER_BILL, ID_ACCOUNT_POST,
             ID_ACCOUNT, ID_ACCOUNT_POST_PMS, ID_ACCOUNT_PMS, ID_SERVICE, VALUE_ORIG,
             CURR_ORIG, VALUE_POST, CURR_POST, IS_OWNER_INCOME, ID_ROOM, DATE_POST,
             ID_RESERV_DETAIL, DOC_DESCRIPTION, ID_DOC_HEAD, DESCRIPTION, IS_CLIENT_ACCOUNT_POST)
      values (:new_id_owner_bill, :ID_ACCOUNT_POST, :ID_ACCOUNT,
             :ID_ACCOUNT_POST_PMS, :ID_ACCOUNT_PMS, :ID_SERVICE, :VALUE_ORIG,
             :CURR_ORIG, :VALUE_POST, :CURR_POST, :IS_OWNER_INCOME, :ID_ROOM, :DATE_POST,
             :ID_RESERV_DETAIL, :DOC_DESCRIPTION, :ID_DOC_HEAD, :DESCRIPTION, :is_client_account_post);
    end
  end
  if (:operation = 'anul') then begin
    select O.ID_OWNER, O.IS_ANUL
    from   OWNER_BILL$PMS O
    where  O.ID_OWNER_BILL = :ID_OWNER_BILL
    into   :id_owner, :is_anul;
    if (:is_anul = 1) then exit;

    select first 1 B.ID_OWNER_BILL
    from   OWNER_BILL$PMS B
    where  B.ID_OWNER = :id_owner
           and B.IS_ANUL = 0
    order by B.BILL_DATE desc
    into   :prev_id_owner_bill;
    if (:prev_id_owner_bill <> :id_owner_bill) then exception PMS_EXCEPTION '-619';

    select first 1 O.ID_OWNER_BILL, O.BILL_DATE
    from   OWNER_BILL$PMS O
    where  O.ID_OWNER = :ID_OWNER
           and o.IS_ANUL = 0
           and O.ID_OWNER_BILL <> :ID_OWNER_BILL
    order by O.BILL_DATE desc
    into   :prev_id_owner_bill, :prev_billing_date;

    update OWNER$PMS O
    set    O.LAST_BILLING_DATE = :prev_billing_date,
           O.ID_OWNER_BILL = :prev_id_owner_bill
    where  O.ID_OWNER = :ID_OWNER;

    update OWNER_BILL$PMS B
    set    B.IS_EXPORTED_TO_INTRANET = 0,
           B.IS_ANUL = 1
    where  B.ID_OWNER_BILL = :ID_OWNER_BILL;

    for
      select O.ID_ACCOUNT_POST, O.ID_ACCOUNT_POST_PMS
      from   OWNER_BILL_ROW$PMS O
      where  O.ID_OWNER_BILL = :ID_OWNER_BILL
      into   :id_account_post, :id_account_post_pms
    do begin
      if (:id_account_post_pms is not null) then begin
        update ACCOUNT_POST$PMS A
        set    A.LINE_STATUS = 11
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
               and A.LINE_STATUS = 21;
      end

      if (:id_account_post is not null) then begin
        update PMS_EVENT_POST A
        set    A.LINE_STATUS = 11
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and A.LINE_STATUS = 21;
      end
    end

    for
      select distinct AP.ID_PMS_EVENT
      from   OWNER_BILL_ROW$PMS R
             join OWNER_BILL$PMS B on B.ID_OWNER_BILL = R.ID_OWNER_BILL
             join ACCOUNT_POST$PMS AP on AP.ID_ACCOUNT_POST = R.ID_ACCOUNT_POST_PMS
             join PMS_EVENT$PMS E on E.ID_PMS_EVENT = AP.ID_PMS_EVENT
      where  R.ID_OWNER_BILL = :ID_OWNER_BILL
             and E.EVENT_TYPE = 'POOL_DISTRIBUTION'
             and B.IS_POOL_DISTRIBUTION_STATEMENT = 1
      into   :id_pms_event
    do begin
      execute procedure PMS_EVENT_VOID$INT(:id_pms_event);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: PMS_IMPORT$INT for: PMS_EVENT_POST$INT */
ALTER PROCEDURE PMS_IMPORT$INT(ID_EXPORT_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_EVENT_POST$INT) */
ALTER PROCEDURE PMS_EVENT_POST$INT(ID_PMS_EVENT INTEGER,
ID_ROOM_CONTRACT INTEGER,
ID_RENTAL_POOL INTEGER,
POST_DATE DATE,
PRICE_WITH_VAT NUMERIC(15,4),
PRICE_WO_VAT NUMERIC(15,4),
CURR VARCHAR(3),
MAX_ADULT_CNT INTEGER,
STAY INTEGER,
BED_NIGHT_CNT INTEGER,
BOOKING_CNT INTEGER,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL INTEGER)
 AS
declare variable ownership_percent numeric(15,4);
  declare variable id_owner integer;
  declare variable contract_type varchar(50);
  declare variable posted_orig_value numeric(15,4);
  declare variable posted_orig_curr varchar(3);
  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable owner_use smallint;
  declare variable price_to_post numeric(15,4);
  declare variable id_owner_post_to integer;
  declare variable reserv_no varchar(62);
  declare variable sub_contract varchar(10);
begin
  id_owner_post_to = null;
  owner_use = 0;

  select RD.ID_AGENT_PROFILE, RD.ID_PERSON_PROFILE, iif(RD.ACC_ROUTING = 'OWNER', 1, 0), rd.NUMBER
  from   RESERV_DETAIL RD                      
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :id_agent_profile, :id_person_profile, :owner_use, :reserv_no;

  /* if RESERV_DETAIL.ACC_ROUTING = 'OWNER', ediniqt profil w reserv. e garantirano owner
     pyrwo se prowerqwa dali id_agent_profile e owner, ako ne e se wzema person_profile */

  if (:owner_use = 1) then begin
    /* ako reserv. e owner-ska, ne se generirat prihodi, a razhodite otiwat po smetkata na gosta, a ne na sobstwenicite
     gosta se tyrsi w posledowatelnost ID_AGENT_PROFILE, ID_PERSON_PROFILE*/
    if ( exists ( select p.ID_ROOM
                  from   ROOM_PERIOD$PMS P
                         join ROOM_CONTRACT$PMS C on C.ID_ROOM_PERIOD = P.ID_ROOM_PERIOD
                         join ROOM_OWNER$PMS O on O.ID_ROOM_CONTRACT = C.ID_ROOM_CONTRACT
                  where  O.ID_OWNER = :id_agent_profile
                         and :POST_DATE between P.FROM_DATE and P.TO_DATE  ) ) then
    begin
      --prowerka dali kym momenta(post_date) ima aktiwen dogowor
      id_owner_post_to = :id_agent_profile;
    end else if ( exists ( select p.ID_ROOM
                      from   ROOM_PERIOD$PMS P
                             join ROOM_CONTRACT$PMS C on C.ID_ROOM_PERIOD = P.ID_ROOM_PERIOD
                             join ROOM_OWNER$PMS O on O.ID_ROOM_CONTRACT = C.ID_ROOM_CONTRACT
                      where  O.ID_OWNER = :id_person_profile
                             and :POST_DATE between P.FROM_DATE and P.TO_DATE  ) ) then
    begin
      id_owner_post_to = :id_person_profile;
    end

    if (:id_owner_post_to is null) then begin
      exception PMS_EXCEPTION 'no valid agent/profile contract(date '||:POST_DATE||', reservation '||:reserv_no||')'; -- FIXME
    end
  end

  for
    select RO.OWNERSHIP_PERCENT,
           RO.ID_OWNER,
           iif(RC.IMPORT_INCOME_WITH_VAT = 1, :price_with_vat, :price_wo_vat),
           RC.CONTRACT_TYPE
    from   ROOM_CONTRACT$PMS RC
           join ROOM_OWNER$PMS RO on RO.ID_ROOM_CONTRACT = RC.ID_ROOM_CONTRACT
    where  RC.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
    into   :ownership_percent,
           :id_owner,
           :price_to_post,
           :contract_type
  do begin
    if (:owner_use = 1) then begin
      /*    za sobstwenik ne se poddyrjat prihodi!    */
      sub_contract = 'OWNER_USE';
      posted_orig_value = :price_to_post;
      posted_orig_curr = :curr;
      execute procedure CONTRACT_EXPENSE_POST$INT(:ID_PMS_EVENT, :ID_HOTEL, :ID_ROOM_CONTRACT, :sub_contract,
              :id_owner_post_to, :ownership_percent, null, :posted_orig_value, :posted_orig_curr, :POST_DATE,
              :stay, :max_adult_cnt, :BED_NIGHT_CNT, :BOOKING_CNT);
    end else begin
      sub_contract = 'GUEST_USE';
      execute procedure CONTRACT_MANAGEMENT_POST$INT(:ID_PMS_EVENT, :ID_ROOM_CONTRACT, :sub_contract,
              :contract_type, :ID_OWNER, :ID_RENTAL_POOL, :price_to_post, :curr, :POST_DATE, :stay, :ownership_percent)
      returning_values  (:posted_orig_value, :posted_orig_curr);
      if (:posted_orig_curr is null) then begin
        posted_orig_value = :price_to_post;
        posted_orig_curr = :curr;
      end
      execute procedure CONTRACT_EXPENSE_POST$INT(:ID_PMS_EVENT, :ID_HOTEL, :ID_ROOM_CONTRACT, :sub_contract,
              :ID_OWNER, :ownership_percent, :ID_RENTAL_POOL, :posted_orig_value, :posted_orig_curr, :POST_DATE,
              :stay, :max_adult_cnt, :BED_NIGHT_CNT, :BOOKING_CNT);
    end


    begin -- SHADOW ACCOUNT POSTING
      sub_contract = 'SHADOW_ACC';
      /* da ne se nachislqwa, ako e USE_OWNER_CONTRACT = 1 */
      if (:owner_use = 0) then begin
        execute procedure CONTRACT_MANAGEMENT_POST$INT(:ID_PMS_EVENT, :ID_ROOM_CONTRACT, :sub_contract,
                :contract_type, :ID_OWNER, :ID_RENTAL_POOL, :price_to_post, :curr, :POST_DATE, :stay, :ownership_percent)
        returning_values  (:posted_orig_value, :posted_orig_curr);
        if (:posted_orig_curr is null) then begin
          posted_orig_value = :price_to_post;
          posted_orig_curr = :curr;
        end
      end else begin
        posted_orig_value = :price_to_post;
        posted_orig_curr = :curr;
      end
  
      execute procedure CONTRACT_EXPENSE_POST$INT(:ID_PMS_EVENT, :ID_HOTEL, :ID_ROOM_CONTRACT, :sub_contract,
              iif(:owner_use = 0, :ID_OWNER, :ID_OWNER_POST_TO), :ownership_percent,
              iif(:owner_use = 0, :ID_RENTAL_POOL, null), :posted_orig_value, :posted_orig_curr, :POST_DATE,
              :stay, :max_adult_cnt, :BED_NIGHT_CNT, :BOOKING_CNT);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: DEVICE_READING_POST$PMS for: PMS_EXPENSE_POSTS_CREATE$INT */
ALTER PROCEDURE DEVICE_READING_POST$PMS(ID_DEVICE_READING /* TYPE OF ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PMS_EXPENSE_POSTING_CREATE$PMS for: PMS_EXPENSE_POSTS_CREATE$INT */
ALTER PROCEDURE PMS_EXPENSE_POSTING_CREATE$PMS(ID_ROOM /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
POST_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
IS_ACC_POST_ITEM /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_POST_DATE /* TYPE OF TDATE */ DATE,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IS_POST_PER_POOL /* TYPE OF TLOGICAL */ SMALLINT)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_EXPENSE_POSTS_CREATE$INT) */
ALTER PROCEDURE PMS_EXPENSE_POSTS_CREATE$INT(ID_ROOM TYPE OF ID,
ID_OWNER TYPE OF ID,
ID_RENTAL_POOL TYPE OF ID_REF,
ID_SERVICE TYPE OF ID,
ID_CURRENCY TYPE OF TCURRENCY,
POST_VALUE TYPE OF TPRICE,
IS_CLIENT_ACC_POST TYPE OF TLOGICAL,
MANUAL_POST_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
IS_POST_PER_POOL TYPE OF TLOGICAL)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF,
NEW_ID_ACCOUNT_POST$PMS ID_REF)
 AS
declare variable event_type varchar(30);
  declare variable id_room_contract integer;
  declare variable new_id_pms_event integer;
  declare variable round_to_orig numeric(15,6);
  declare variable ownership_percent numeric(15,4);
  declare variable curr_contract_owner integer;
  declare variable curr_total_ownership numeric(15,4);
  declare variable curr_total_value numeric(15,4);
  declare variable percent_value numeric(15,4);
  declare variable id_account integer;
  declare variable id_hotel integer;
  declare variable is_account$pms integer;
  declare variable id_acc_post integer;
BEGIN
  event_type = 'MANUAL_EXPENSE';
  curr_total_value = 0;
  curr_total_ownership = 0;

  select RC.ID_ROOM_CONTRACT, r.ID_HOTEL
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS P on RC.ID_ROOM_PERIOD = P.ID_ROOM_PERIOD
         join ROOMS R on R.ID_ROOM = p.ID_ROOM
  where  :MANUAL_POST_DATE between P.FROM_DATE and P.TO_DATE
         and P.ID_ROOM = :ID_ROOM
         and P.STATUS in ('PRIVATE','CONTRACT')
  into   :id_room_contract, :id_hotel;

  if (:ID_ROOM_CONTRACT is null) then exception PMS_EXCEPTION '-615';

  execute procedure PMS_EVENT_CREATE$INT(:EVENT_TYPE, :ID_ROOM, :ID_OWNER, :DESCRIPTION,
          :MANUAL_POST_DATE, null, null, null, null, :POST_VALUE, :POST_VALUE, :ID_CURRENCY, null, :id_room_contract)
  returning_values :new_id_pms_event;

  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :ID_CURRENCY
  into   :round_to_orig;

  for
    select iif(:ID_OWNER is null, O.OWNERSHIP_PERCENT, 100), O.ID_OWNER
    from   ROOM_CONTRACT$PMS RC
           join ROOM_OWNER$PMS O on O.ID_ROOM_CONTRACT = RC.ID_ROOM_CONTRACT
    where  RC.ID_ROOM_CONTRACT = :id_room_contract
           and ((:ID_OWNER is null) or (O.ID_OWNER = :ID_OWNER))
    into   :ownership_percent, :curr_contract_owner
  do begin
    curr_total_ownership = :curr_total_ownership + :ownership_percent;
    if (:curr_total_ownership = 100) then begin
      percent_value = :post_value - :curr_total_value;
    end else
      percent_value = round_f(:post_value * :ownership_percent / 100, :round_to_orig);

    curr_total_value = :curr_total_value + :percent_value;

    execute procedure OWNER_ACCOUNT_GET$INT (iif(:is_post_per_pool = 1, :id_rental_pool, :curr_contract_owner),
            :id_hotel, 0, :IS_CLIENT_ACC_POST)
    returning_values (:id_account, :is_account$pms);

    execute procedure PMS_POSTING_CREATE$INT(:new_id_pms_event, :ID_ACCOUNT, :ID_SERVICE,
            :curr_contract_owner, :MANUAL_POST_DATE, :ID_CURRENCY, :PERCENT_VALUE, :is_account$pms, 0, :ID_ROOM)
    returning_values :id_acc_post;

    new_id_account_post = null;
    new_id_account_post$pms = null;

    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 1)) then new_id_account_post$pms = :id_acc_post;
    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 0)) then new_id_account_post = :id_acc_post;
    suspend;
  end

  execute procedure PMS_EVENT_SET_ACTIVE$INT(:new_id_pms_event);
END
^

/* empty dependent procedure body */
/* Clear: PMS_IMPORT for: PMS_IMPORT$INT */
ALTER PROCEDURE PMS_IMPORT(ID_EXPORT_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_IMPORT$INT) */
ALTER PROCEDURE PMS_IMPORT$INT(ID_EXPORT_HEAD INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_room_contract integer;
  declare variable id_pms_event integer;
  declare variable imp_period_from date;
  declare variable event_price_with_vat numeric(15,4);
  declare variable event_price_wo_vat numeric(15,4);
  declare variable curr varchar(3);
  declare variable adult_count integer;
  declare variable id_rental_pool integer;
  declare variable reservs integer;
  declare variable stay integer;
  declare variable bednights integer;
  declare variable id_hotel integer;
begin
  for
    select E.ID_PMS_EVENT, E.ID_RESERV_DETAIL, E.IMP_PERIOD_FROM,
           E.CURR, r.ID_HOTEL, e.PRICE_WO_VAT, e.PRICE_WITH_VAT,
           e.RESERVS, e.STAY, e.BEDNIGHTS, rc.ID_ROOM_CONTRACT, rc.ID_RENTAL_POOL
    from   PMS_EVENT$PMS E
           join ROOMS R on R.ID_ROOM = e.ID_ROOM
           join ROOM_CONTRACT$PMS rc on rc.ID_ROOM_CONTRACT = e.ID_ROOM_CONTRACT
    where  E.ID_EXPORT_HEAD = :ID_EXPORT_HEAD
           and E.EVENT_STATUS = 11
    order by 1
    into   :id_pms_event, :id_reserv_detail, :imp_period_from,
           :curr, :id_hotel, :event_price_wo_vat, :event_price_with_vat,
           :reservs, :stay, :bednights, :id_room_contract, :id_rental_pool
  do begin
/* */
    select r.ADULT_COUNT
    from   RESERV_DETAIL r
    where  r.ID_RESERV_DETAIL = :id_reserv_detail
    into   :adult_count;

    execute procedure PMS_EVENT_POST$INT (:id_pms_event, :id_room_contract, :id_rental_pool,
            :imp_period_from, :event_price_with_vat, :event_price_wo_vat, :curr,
            :adult_count, :stay, :bednights, :reservs, :id_hotel, :id_reserv_detail);

    execute procedure PMS_EVENT_SET_ACTIVE$INT(:id_pms_event);

  end
end
^

/* empty dependent procedure body */
/* Clear: PMS_REGULAR_POST_CREATE$PMS for: PMS_INCOME_POSTING_CREATE$PMS */
ALTER PROCEDURE PMS_REGULAR_POST_CREATE$PMS(ID_CONTRACT_CALENDAR_POST INTEGER,
ID_ROOM INTEGER,
ID_OWNER INTEGER,
ID_CURRENCY VARCHAR(3),
ID_SERVICE INTEGER,
POST_VALUE NUMERIC(15,4),
IS_ACC_POST_ITEM SMALLINT,
MANUAL_POST_DATE DATE,
DESCRIPTION VARCHAR(255),
IS_POST_PER_POOL SMALLINT,
ID_RENTAL_POOL INTEGER,
IS_INCOME_POST SMALLINT)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_INCOME_POSTING_CREATE$PMS) */
ALTER PROCEDURE PMS_INCOME_POSTING_CREATE$PMS(ID_ROOM INTEGER,
ID_OWNER INTEGER,
ID_RENTAL_POOL INTEGER,
ID_CURRENCY VARCHAR(3),
ID_SERVICE INTEGER,
POST_VALUE NUMERIC(15,4),
MANUAL_POST_DATE DATE,
DESCRIPTION VARCHAR(255),
IS_POST_PER_POOL SMALLINT)
 AS
declare variable ownership_percent numeric(15,4);
  declare variable id_room_contract integer;
  declare variable id_account integer;
  declare variable percent_value numeric(15,4);
  declare variable curr_total_ownership numeric(15,4);
  declare variable curr_total_value numeric(15,4);
  declare variable new_id_pms_event integer;
  declare variable id_account_post_pms integer;
  declare variable curr_contract_owner integer;
  declare variable event_type varchar(30);
  declare variable round_to_orig numeric(15,6);
  declare variable id_hotel integer;
  declare variable is_account$pms integer;
begin
  id_room_contract = null;
  curr_total_value = 0;
  curr_total_ownership = 0;
  event_type = 'MANUAL_INCOME';

  select RC.ID_ROOM_CONTRACT
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS P on RC.ID_ROOM_PERIOD = P.ID_ROOM_PERIOD
  where  :MANUAL_POST_DATE between P.FROM_DATE and P.TO_DATE
         and P.STATUS in ('PRIVATE','CONTRACT')
         and P.ID_ROOM = :ID_ROOM
  into   :id_room_contract;
  if (:ID_ROOM_CONTRACT is null) then exception PMS_EXCEPTION '-615';

  execute procedure PMS_EVENT_CREATE$INT(:EVENT_TYPE, :ID_ROOM, :ID_OWNER, :DESCRIPTION,
          :MANUAL_POST_DATE, null, null, null, null,
          :POST_VALUE, :POST_VALUE, :ID_CURRENCY, null, :id_room_contract)
  returning_values :new_id_pms_event;

  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :ID_CURRENCY
  into   :round_to_orig;

  for
    select iif(:ID_OWNER is null, O.OWNERSHIP_PERCENT, 100), O.ID_OWNER, r.ID_HOTEL
    from   ROOM_CONTRACT$PMS RC
           join ROOM_OWNER$PMS O on O.ID_ROOM_CONTRACT = RC.ID_ROOM_CONTRACT
           join ROOM_PERIOD$PMS rp on rp.ID_ROOM_PERIOD = rc.ID_ROOM_PERIOD
           join ROOMS R on r.ID_ROOM = rp.ID_ROOM
    where  RC.ID_ROOM_CONTRACT = :id_room_contract
           and ((:id_owner is null) or (O.ID_OWNER = :id_owner))
    order by 1 asc
    into   :ownership_percent, :curr_contract_owner, :id_hotel
  do begin
    curr_total_ownership = :curr_total_ownership + :ownership_percent;
    if (:curr_total_ownership = 100) then begin
      percent_value = :POST_VALUE - :curr_total_value;
    end else
      percent_value = round_f(:POST_VALUE * :ownership_percent / 100, :round_to_orig);

    curr_total_value = :curr_total_value + :percent_value;

    execute procedure OWNER_ACCOUNT_GET$INT (iif(:IS_POST_PER_POOL = 0, :curr_contract_owner, :ID_RENTAL_POOL),
            :id_hotel, 0, 0)
    returning_values (:id_account, :is_account$pms);

    execute procedure ACCOUNT_POST_PMS_ADD$INT(:new_id_pms_event, :id_account,
            :curr_contract_owner, :ID_CURRENCY, :percent_value, :id_service, 1, :MANUAL_POST_DATE)
    returning_values  (:id_account_post_pms);
  end

  execute procedure PMS_EVENT_SET_ACTIVE$INT(:new_id_pms_event);
end
^

/* Alter (PMS_POOL_DISTRIBUTION) */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION(ID_RENTAL_POOL INTEGER,
FOR_DATE DATE)
 AS
declare variable total_value_per_service numeric(15,4);
  declare variable id_service integer;
  declare variable curr varchar(3);
  declare variable id_room_param integer;
  declare variable is_room_pool smallint;
  declare variable is_owner_income smallint;

  declare variable is_acc_post_item smallint;
  declare variable new_id_owner_bill integer;
  declare variable id_account_post_pms integer;
  declare variable id_pool_account integer;

  declare variable id_account_pms integer;
  declare variable value_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable value_post numeric(15,4);
  declare variable curr_post varchar(3);
  declare variable id_room integer;
  declare variable date_post date;
  declare variable id_reserv_detail integer;
  declare variable doc_description varchar(255);
  declare variable id_doc_head integer;
  declare variable description varchar(255);
  declare variable is_client_account_post smallint;
begin
  is_room_pool = null;
  select U.IS_ROOM_POOL, U.ID_ROOM_PARAM
  from   OWNER$PMS O
         join RENTAL_POOL_UNIT$PMS U on U.ID_RENTAL_POOL_UNIT = O.ID_RENTAL_POOL_UNIT
  where  O.ID_OWNER = :ID_RENTAL_POOL
  into   :is_room_pool, :id_room_param;
  if (:is_room_pool is null) then exception PMS_EXCEPTION;

  for
    select sum(AP1.VALUE_POST), AP1.ID_SERVICE, AP1.CURR_POST, AP1.IS_OWNER_INCOME,
           ACC.IS_CLIENT_POOL_ACCOUNT, ACC.ID_ACCOUNT
    from   (select distinct AP.ID_PMS_EVENT
            from   ACCOUNT_POST$PMS AP
                   join ACCOUNT$PMS AC on AC.ID_ACCOUNT = AP.ID_ACCOUNT_PMS
            where  AP.DATE_POST <= :FOR_DATE
                   and AP.LINE_STATUS = 11
                   and AC.ID_OWNER = :ID_RENTAL_POOL
                   and AC.IS_SHADOW = 0) E
           join ACCOUNT_POST$PMS AP1 on AP1.ID_PMS_EVENT = e.ID_PMS_EVENT and AP1.LINE_STATUS = 11
           join ACCOUNT$PMS ACC on ACC.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS and ACC.IS_SHADOW = 0
    group by 2,3,4,5,6
    into   :total_value_per_service, :id_service, :curr, :is_owner_income,
           :is_acc_post_item, :id_pool_account
  do begin
    execute procedure PMS_POOL_DISTRIBUTION_SUB(:ID_RENTAL_POOL, :id_pool_account,
            :IS_ROOM_POOL, :ID_ROOM_PARAM, :total_value_per_service,
            :ID_SERVICE, :CURR, :IS_OWNER_INCOME, :FOR_DATE, :is_acc_post_item);
  end

  NEW_ID_OWNER_BILL = gen_id(GEN_OWNER_BILL$PMS_ID, 1);

  insert into OWNER_BILL$PMS (ID_OWNER_BILL, ID_OWNER, BILL_DATE, IS_ANUL, BILL_NUM,
         IS_EXPORTED_TO_INTRANET, IS_POOL_DISTRIBUTION_STATEMENT)
  values (:NEW_ID_OWNER_BILL, :ID_RENTAL_POOL, :FOR_DATE, 0, :NEW_ID_OWNER_BILL, 0, 1);

  update OWNER$PMS O
  set    O.LAST_BILLING_DATE = :for_date,
         O.ID_OWNER_BILL = :NEW_ID_OWNER_BILL
  where  O.ID_OWNER = :ID_RENTAL_POOL;

  for
    select AP.ID_ACCOUNT_POST, AP.VALUE_ORIG, AP.CURR_ORIG, AP.VALUE_POST, AP.CURR_POST,
           ACC.ID_ACCOUNT, AP.IS_OWNER_INCOME, AP.ID_SERVICE, E.ID_ROOM, AP.DATE_POST,
           E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION, ACC.IS_CLIENT_POOL_ACCOUNT
    from   PMS_EVENT$PMS E
           join ACCOUNT_POST$PMS AP on ap.ID_PMS_EVENT = e.ID_PMS_EVENT
                                       and AP.LINE_STATUS = 11
           join ACCOUNT$PMS ACC on ACC.ID_ACCOUNT = AP.ID_ACCOUNT_PMS
                                   and ACC.ID_OWNER = :ID_RENTAL_POOL
                                   and ACC.IS_SHADOW = 0
    where  E.ID_SESSION = current_transaction
    into   :id_account_post_pms, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
           :ID_ACCOUNT_PMS, :IS_OWNER_INCOME, :ID_SERVICE, :ID_ROOM, :DATE_POST,
           :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION, :is_client_account_post
  do begin
    insert into OWNER_BILL_ROW$PMS (ID_OWNER_BILL, ID_ACCOUNT_POST, ID_ACCOUNT,
           ID_ACCOUNT_POST_PMS, ID_ACCOUNT_PMS, ID_SERVICE, VALUE_ORIG,
           CURR_ORIG, VALUE_POST, CURR_POST, IS_OWNER_INCOME, ID_ROOM, DATE_POST,
           ID_RESERV_DETAIL, DOC_DESCRIPTION, ID_DOC_HEAD, DESCRIPTION, IS_CLIENT_ACCOUNT_POST)
    values (:new_id_owner_bill, null, null,
           :ID_ACCOUNT_POST_PMS, :ID_ACCOUNT_PMS, :ID_SERVICE, :VALUE_ORIG,
           :CURR_ORIG, :VALUE_POST, :CURR_POST, :IS_OWNER_INCOME, :ID_ROOM, :DATE_POST,
           :ID_RESERV_DETAIL, :DOC_DESCRIPTION, :ID_DOC_HEAD, :DESCRIPTION, :is_client_account_post);

    update ACCOUNT_POST$PMS A
    set    A.LINE_STATUS = 21
    where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS;
  end
end
^

/* empty dependent procedure body */
/* Clear: PMS_POOL_DISTRIBUTION for: PMS_POOL_DISTRIBUTION_SUB */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION(ID_RENTAL_POOL INTEGER,
FOR_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_POOL_DISTRIBUTION_SUB) */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
declare variable cnt_room smallint;
  declare variable curr_total_posted numeric(15,4);
  declare variable cnt integer;
  declare variable value_to_post numeric(15,4);
  declare variable value_to_post_per_owner numeric(15,4);
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable id_room_contract integer;
  declare variable id_owner_account integer;
  declare variable id_pms_event integer;
  declare variable id_hotel integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
begin
  select c.ROUND_TO
  from   CURRS c
  where  c.CURR = :CURR
  into   :round_to;

  cnt_room = 0;
  select count(distinct RP.ID_ROOM)
  from   ROOM_PERIOD$PMS RP
         join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
  where  RC.ID_RENTAL_POOL = :id_rental_pool
         and RP.STATUS in ('PRIVATE','CONTRACT')
         and RP.FROM_DATE <= :FOR_DATE
         and RP.TO_DATE >= :FOR_DATE
  into   :cnt_room;

  if (:cnt_room = 0) then exception PMS_EXCEPTION 'The pool has not assigned room contracts for selected date (' || :FOR_DATE || ') !';

  if (:is_room_pool = 1) then begin
    curr_total_posted = 0;
    cnt = 0;
    id_pms_event = null;
    id_hotel = null;
    for
      select distinct RP.ID_ROOM, RC.ID_ROOM_CONTRACT, R.ID_HOTEL
      from   ROOM_PERIOD$PMS RP
             join ROOMS R on R.ID_ROOM = RP.ID_ROOM
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.FROM_DATE <= :FOR_DATE
             and RP.TO_DATE >= :FOR_DATE
      into   :id_room, :id_room_contract, :id_hotel
    do begin
      id_pms_event = null;

      select E.ID_PMS_EVENT
      from   PMS_EVENT$PMS E
      where  E.ID_ROOM = :id_room
             and E.ID_SESSION = current_transaction
      into   :ID_PMS_EVENT;

      if (:ID_PMS_EVENT is null) then begin
        execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, :id_room_contract)
        returning_values :id_pms_event;
        -- FIXME nakraq da se update total_event_value
      end
      if (:cnt_room - :cnt = 1) then begin
        value_to_post = :TOTAL_VALUE_PER_SERVICE - :curr_total_posted;
      end else begin
        value_to_post = round_f(:TOTAL_VALUE_PER_SERVICE / :cnt_room, :round_to);
      end

      curr_total_posted = :curr_total_posted + :value_to_post;
      cnt = :cnt + 1;

      /* ...i se razpredelq mejdu sobstwenicite na staqta */
      value_to_post = abs(:value_to_post);
      for
        select R.ID_OWNER, R.OUT_VALUE
        from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
        into   :id_owner, :value_to_post_per_owner
      do begin
        /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_pool_account,
                :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                0, :IS_OWNER_INCOME, :id_room)
        returning_values :no_use_id_acc_post;
        /* ... i se nachislqwa po sobswtenik */
        execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
        returning_values (:id_owner_account, :is_account$pms);

        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                :is_account$pms, :is_owner_income, :id_room)
        returning_values :no_use_id_acc_post;
      end
    end
  end else begin
    /* distribution by room_param */
    insert into TMP_SELECT$PMS(ID_SESSION, ID_ROOM, ID_OWNER)
    select distinct current_transaction, RP.ID_ROOM, null
    from   ROOM_PERIOD$PMS RP
           join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
    where  RC.ID_RENTAL_POOL = :ID_RENTAL_POOL
           and RP.STATUS in ('PRIVATE','CONTRACT')
           and RP.FROM_DATE <= :FOR_DATE
           and RP.TO_DATE >= :FOR_DATE;

    id_hotel = null;
    for
      select P.OUT_VALUE, P.OUT_ID_ROOM, R.ID_HOTEL
      from   PMS_CALC_VALUE_BY_PARAM(:ID_ROOM_PARAM, :TOTAL_VALUE_PER_SERVICE, :round_to) P
             join ROOMS R on R.ID_ROOM = P.OUT_ID_ROOM
      into   :value_to_post, :id_room, :id_hotel
    do begin
      id_pms_event = null;
      id_room_contract = null;
      -- room contract must be only one for this period
      select RC.ID_ROOM_CONTRACT
      from   ROOM_PERIOD$PMS RP
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.ID_ROOM = :id_room
             and :for_date between RP.FROM_DATE and RP.TO_DATE
      into   :id_room_contract;

      if (:id_room_contract is not null) then begin
        select E.ID_PMS_EVENT
        from   PMS_EVENT$PMS E
        where  E.ID_ROOM = :id_room
               and E.ID_SESSION = current_transaction
        into   :ID_PMS_EVENT;
  
        if (:ID_PMS_EVENT is null) then begin
          execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                  'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, id_room_contract)
          returning_values :id_pms_event;
          -- FIXME nakraq da se update total_event_value
        end
  
        /* ...i se razpredelq mejdu sobstwenicite na staqta */
        for
          select R.ID_OWNER, R.OUT_VALUE
          from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
          into   :id_owner, :value_to_post_per_owner
        do begin
          /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :ID_POOL_ACCOUNT,
                  :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                  0, :IS_OWNER_INCOME, :id_room)
          returning_values :no_use_id_acc_post;
  
          /* ... i se nachislqwa po sobswtenik */
          execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
          returning_values (:id_owner_account, :is_account$pms);

          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                  :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                  :is_account$pms, :is_owner_income, :id_room)
          returning_values :no_use_id_acc_post;
        end
      end
    end

    delete from TMP_SELECT$PMS T
    where  T.ID_SESSION = current_transaction;
  end
end
^

/* Alter (PMS_REGULAR_POST_CREATE$PMS) */
ALTER PROCEDURE PMS_REGULAR_POST_CREATE$PMS(ID_CONTRACT_CALENDAR_POST INTEGER,
ID_ROOM INTEGER,
ID_OWNER INTEGER,
ID_CURRENCY VARCHAR(3),
ID_SERVICE INTEGER,
POST_VALUE NUMERIC(15,4),
IS_ACC_POST_ITEM SMALLINT,
MANUAL_POST_DATE DATE,
DESCRIPTION VARCHAR(255),
IS_POST_PER_POOL SMALLINT,
ID_RENTAL_POOL INTEGER,
IS_INCOME_POST SMALLINT)
 AS
declare variable no_use varchar(1000);
begin

  if (:IS_INCOME_POST = 1) then begin
    execute procedure PMS_INCOME_POSTING_CREATE$PMS(:ID_ROOM, :ID_OWNER, :ID_RENTAL_POOL,
            :ID_CURRENCY, :ID_SERVICE, :POST_VALUE, :MANUAL_POST_DATE, :DESCRIPTION, :IS_POST_PER_POOL);
  end else begin
    execute procedure PMS_EXPENSE_POSTING_CREATE$PMS(:ID_ROOM, :ID_OWNER, :ID_RENTAL_POOL,
            :ID_SERVICE, :ID_CURRENCY, :POST_VALUE, :IS_ACC_POST_ITEM, :MANUAL_POST_DATE,
            :DESCRIPTION, :IS_POST_PER_POOL);
  end

  delete from CONTRACT_CALENDAR_SCHEME$PMS S
  where  S.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST
         and S.POST_DATE = :MANUAL_POST_DATE;

  execute procedure CONTRACT_CALENDAR_MODIFY$PMS(:ID_CONTRACT_CALENDAR_POST,
          null, null, null, null, null, null, null, null, null,  null, 'mod_next_date')
  returning_values (:no_use);

end
^

/* empty dependent procedure body */
/* Clear: EAI_POS_POSTING_ADD$P2E for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PMS_POSTING_CREATE$INT for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
POST_DATE /* TYPE OF TDATE */ DATE,
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
POST_ON_PMS_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT,
IS_OWNER_INCOME /* TYPE OF TLOGICAL */ SMALLINT,
ID_ROOM /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_ACCOUNT_POST /* ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_FINALIZE$POST for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_TELECOUNT_CALL$INT for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_ACCOUNT$INT) */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
QTY TYPE OF TQTY,
ID_SECQUENCE TYPE OF ID,
IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
POST_TEXT TYPE OF TDESCRIPTION_SHORT,
RESOURCE_TEXT TYPE OF TREASON,
DATE_POST TYPE OF TDATE,
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ID_ROOM TYPE OF ID = null,
POST_DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable action_text varchar(255);
begin
  if (:date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :date_post;
  end
/* NO AUTO PRICE !!!!!!
  if (:in_is_manual_price = 0) then begin

    select P.ID_EXTRA_TARIFF
    from   ACCOUNT A
           join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
    where  A.ID_ACCOUNT = :in_id_account
    into   :id_extra_tarifa;
    if ((:id_extra_tarifa is null) or (:id_extra_tarifa < 0)) then begin
      err_code = -14;
      exit;
    end
    execute procedure TAR_RECALC_EXTRASRV(:id_extra_tarifa, :in_id_service, :in_date_post)
    returning_values  :err_code, :err_text, :post_price, :post_currency;
    if (:err_code < 0) then exit;
  end else begin
    --MANUAL PRICE
    post_currency = :manual_curr ;
    post_price = :manual_price ;
  end
*/

  post_currency = :manual_curr ;
  post_price = :manual_price ;
  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, -1, :id_secquence, :date_post, :id_service, -1, :id_room, 0, :qty, :post_price,
    :post_currency, null, :short_code, :from_date, :to_date, :post_text, :resource_text, '', -1, :POST_DESCRIPTION)
  returning_values :err_code, :err_text, :id_account_post;
  if (:err_code <> 0) then exit;

  select S.SERVICE_NAME
  from   SERVICES S
  where  S.ID_SERVICE = :ID_SERVICE
  into   :action_text;
   
  action_text = f_character(29) || coalesce(:action_text, '')
                || f_character(28) || formatdate(:DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || coalesce(:post_currency, '');
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_RESERVATION$INT for: POST_SERVICE_ON_GUEST$INT */
ALTER PROCEDURE POST_SERVICE_ON_RESERVATION$INT(ID_RESERV_DETAIL /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_ROOM for: POST_SERVICE_ON_GUEST$INT */
ALTER PROCEDURE POST_SERVICE_ON_ROOM(IN_ID_ROOM /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255))
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_GUEST /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_GUEST$INT) */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TDESCRIPTION_SHORT,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ACCOUNT_ROUTING TYPE OF TSHORT_CODE,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable id_room integer;
  declare variable no_use varchar(255);
  declare variable action_text varchar(255);
  declare variable is_guest_check_in smallint;
  declare variable service_name varchar(50);
begin
  err_code = 0;
  err_text = '';

  select g.check_status
  from   guest g
  where  g.id_guest = :in_id_guest
  into   :is_guest_check_in;

  if (:is_guest_check_in < 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
  end

  execute procedure GUEST_GET_POSTING_ACCOUNT$INT (:in_id_guest, :account_routing)
  returning_values  :id_account, :id_room;

  if (:in_date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :in_date_post;
  end

  if (:in_is_manual_price = 0) then begin
    execute procedure SERVICE_GET_POSTING_DETAILS(:in_id_service, :IN_DATE_POST)
    returning_values  :no_use, :no_use, :service_name, :post_price, :post_currency;
  end else begin
    /* MANUAL PRICE */
    post_currency = :manual_curr;
    post_price = :manual_price;
    select s.SERVICE_NAME
    from   SERVICES s
    where  s.ID_SERVICE = :IN_ID_SERVICE
    into   :service_name;
  end

  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, :in_id_guest, :in_id_secquence, :in_date_post, :in_id_service, -1, :id_room, 0, :in_qty,
    :post_price, :post_currency, null, :in_short_code, :in_from_datetime, :in_to_datetime, :in_post_text,
    :in_resource_text, '', -1, :DESCRIPTION)
  returning_values  :err_code, :err_text, :id_account_post;

  action_text = f_character(29) || coalesce(:service_name, '')
                || f_character(28) || formatdate(:IN_DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:IN_QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || coalesce(:post_currency, '');
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: RESOURCE_RESERVATION_CHECK_IN for: POST_SERVICE_ON_RESERVATION$INT */
ALTER PROCEDURE RESOURCE_RESERVATION_CHECK_IN(ID_RESOURCE_RESERVATION INTEGER,
SERVICE_PRICE NUMERIC(15,2),
SERVICE_CURR VARCHAR(3))
 RETURNS(OUT_ID_ACCOUNT INTEGER,
OUT_ID_ACCOUNT_POST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_RESERVATION$INT) */
ALTER PROCEDURE POST_SERVICE_ON_RESERVATION$INT(ID_RESERV_DETAIL TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TREASON,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable id_guest integer;
begin
  err_code = 0;
  err_text = '';

  id_guest = null;
  select RD.ID_TITULAR
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :id_guest;

  execute procedure POST_SERVICE_ON_GUEST$INT(:id_guest, :in_id_service, :in_qty, :in_id_secquence,
                    :in_is_manual_price, :manual_price, :manual_curr, :in_from_datetime, :in_to_datetime,
                    :in_post_text, :in_resource_text, :in_date_post, :in_short_code, '', :DESCRIPTION)
  returning_values  :err_code, :err_text, :id_account, :id_account_post;
end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_POST_TO_MH_FRONT_ONLINE for: POST_SERVICE_ON_ROOM */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_SERVICE_POST for: POST_SERVICE_ON_ROOM */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_ROOM) */
ALTER PROCEDURE POST_SERVICE_ON_ROOM(IN_ID_ROOM TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TREASON,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_GUEST TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
begin
  err_code = 0;
  err_text = '';

  id_guest = null;
  select first 1 G.ID_GUEST
  from   GUEST G
  where  G.ID_ROOM = :in_id_room
         and G.CHECK_STATUS = 0
  order by G.FROM_DATE desc, G.ID_GUEST asc
        /************************************************/
        /* DESCENDANT ORDER IS VERY IMPORTANT!!         */
        /* IF TWO GUESTS HAVE:                          */
        /* TO_DATE OF THE 1'ST = FROM_DATE OF THE 2'ND, */
        /* THEN PHONACALLS SHOULD GO TO THE 2'ND        */         
        /************************************************/
  into   :id_guest;

  if (:id_guest is null) then begin
    err_code = -24;   /* NO GUESTS ARE CHECKED_IN INTO THE REQUESTED ROOM! */
    exit;
  end

  execute procedure POST_SERVICE_ON_GUEST$INT(:id_guest, :in_id_service, :in_qty, :in_id_secquence, :in_is_manual_price,
    :manual_price, :manual_curr, :in_from_datetime, :in_to_datetime, :in_post_text, :in_resource_text,
    :in_date_post, :in_short_code, '')
  returning_values  :err_code, :err_text, :id_account, :id_account_post;
end
^

/* empty dependent procedure body */
/* Clear: EAI_TELECOUNT_TRANSFER for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALL_POST$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL /* ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALLS_POST_TO_ACCOUNT$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_TELECOUNT_TRANSFER$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_TELECOUNT_CALL$INT) */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ext_ifc_name varchar(20);
  declare variable room_name varchar(30);
  declare variable datetime_call timestamp;
  declare variable price numeric(15,2);
  declare variable dial_number varchar(50);
  declare variable units integer;
  declare variable pc_id_service integer;
  declare variable def_manual_curr char(3);
  declare variable post_text varchar(50);
  declare variable id_account_post integer;
  declare variable is_archive integer;
  declare variable id_account integer;
  declare variable new_id_account_post integer;
  declare variable pc_tag varchar(20);
  declare variable number_zone varchar(50);
  declare variable id_hotel integer;
  declare variable id_phonecall integer;
  declare variable no_use varchar(255);
begin
  /* Description:
  || POST_TO_TYPE = 0 - ACCOUNT, 1 - GUEST, 2 - RESERV_DETAIL, 3 - JUST PREPARE, FOR EXTERNAL CLIENT
  */
  err_code = 0;
  err_text = '';
  ext_ifc_name = 'TELECOUNT';

  select PC.ID_PHONECALL, PC.ROOM_NAME, PC.DATETIME_CALL, PC.PRICE, PC.DIAL_NUMBER, PC.UNITS,
         PC.ID_ACCOUNT_POST, PC.IS_ARCHIVE, PC.TAG, substring(PC.NUMBER_ZONE from 1 for 30), pc.ID_HOTEL
  from   PHONECALLS PC 
  where  PC.rdb$db_key = :ph_dbkey
  into   :id_phonecall, :room_name, :datetime_call, :price, :dial_number, :units,
         :id_account_post, :is_archive, :pc_tag, :number_zone, :id_hotel;

  if ((:is_archive = 1) or (coalesce(:id_account_post, 0) > 0)) then exit;

  if ((:pc_tag is null) or (:pc_tag = '')) then pc_tag = 'TELECOUNT_DEFAULT';
  else pc_tag = 'TELECOUNT_' || :pc_tag;

  execute procedure EAI_MAP_SERVICE(:pc_tag, :number_zone, :ext_ifc_name, :id_hotel)
  returning_values  :err_code, :err_text, :pc_id_service;
  if (:err_code < 0) then exit;

  post_text = substring(:dial_number || ', impulses ' || :units from 1 for 50);

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :def_manual_curr;

  new_id_account_post = null;
  if (:post_to_type = 0) then begin
    id_account = :post_to_id;
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name)
    returning_values :err_code, :err_text, :new_id_account_post;
  end else if (:post_to_type = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:post_to_id, :pc_id_service, 1, -1, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name, '')
    returning_values :err_code, :err_text, :id_account, :new_id_account_post;
  end else if (:post_to_type = 2) then begin
    execute procedure POST_SERVICE_ON_RESERVATION$INT(:post_to_id, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name)
    returning_values :err_code, :err_text, :id_account, :new_id_account_post;
  end else if (:post_to_type = 3) then begin
    execute procedure POST_PREPARE_ON_ACCOUNT$POST (:post_to_id, :pc_id_service,
      1, :ID_SEQUENCE, :price, :def_manual_curr, :post_text, null, null, :ID_PHONECALL)
    returning_values :no_use;
  end
  if (:err_code < 0) then exit;

  if (:new_id_account_post is not null) then begin
    update PHONECALLS PC
    set    PC.ID_ACCOUNT_POST = :new_id_account_post,
           pc.POSTING_ERROR = null
    where  PC.rdb$db_key = :ph_dbkey;
  end

end
^

/* Alter (POST_TELECOUNT_TRANSFER$TC) */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ph_dbkey char(8);
  declare variable id_account_post integer;
  declare variable account_name varchar(50);
begin
  err_code = 0;
  err_text = '';

  for
    select PC.RDB$DB_KEY, PC.ID_ACCOUNT_POST
    from   PHONECALLS PC
    where  PC.SELECTION_ID = :selection_id
    into   :ph_dbkey, :id_account_post
  do begin
    if ((:id_account_post is not null) and (:id_account_post <> -1)) then begin
      err_code = -117;
      select A.ACCOUNT_NAME
      from   ACCOUNT_POST AP
             join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
      where  AP.ID_ACCOUNT_POST = :id_account_post
      into   :account_name;
      err_text = f_character(29) || :account_name;
      exit;
    end

    execute procedure POST_TELECOUNT_CALL$INT(2, :id_reserv_detail, :ph_dbkey, 0)
    returning_values :err_code, :err_text;
    if (:err_code < 0) then exit;
  end
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_AGENT_PROFILE$EXC for: PROFILE_MERGE$PROFILE */
ALTER PROCEDURE IMPORT_AGENT_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
AGENT_GROUP VARCHAR(50),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
WBE_PASSWORD VARCHAR(20),
IATA_NUMBER VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
DEF_CONTRAGENT_NAME VARCHAR(100),
CLEAR_HOTEL_RATE SMALLINT,
CLEAR_HOTEL_DISCOUNT SMALLINT,
CREATE_ONLY SMALLINT,
THRESHOLD_NOTE VARCHAR(255),
THRESHOLD_AMOUNT NUMERIC(15,4),
THRESHOLD_CURR CHAR(3),
MERGE_TARGET_UUID VARCHAR(40))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_PERSON_PROFILE$EXC for: PROFILE_MERGE$PROFILE */
ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
CLEAR_HOTEL_RATE SMALLINT,
CREATE_ONLY SMALLINT,
MERGE_TARGET_UUID VARCHAR(40))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PROFILE_MERGE$PROFILE) */
ALTER PROCEDURE PROFILE_MERGE$PROFILE(ID_SOURCE INTEGER,
ID_TARGET INTEGER,
OPERATION VARCHAR(20))
 AS
declare variable source_p_type varchar(30);
  declare variable target_p_type varchar(30);
  declare variable total_points_gained integer;
  declare variable total_points_consumed integer;
  declare variable source_p_name varchar(100);
  declare variable target_p_name varchar(100);
  declare variable id_hotel integer;
  declare variable id_bps integer;
  declare variable target_id_p_data integer;
  declare variable rd_dbkey char(8);
  declare variable gd_dbkey char(8);
  declare variable check_status smallint;
  declare variable id_reserv_detail integer;
  declare variable is_archive integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'merge, notequals');

  if ((:ID_SOURCE is null) or (:ID_TARGET is null)) then exception PROFILE_EXCEPTION '<NULL> profile id is passed!';

  if (:operation = 'notequals') then begin
    insert into PROFILE_DISSIMILAR (ID_PROFILE1, ID_PROFILE2)
    values (iif(:id_source < :id_target, :id_source, :id_target),
            iif(:id_source > :id_target, :id_source, :id_target));

    when any do exit;

  end else if (:operation = 'merge') then begin
    if (exists (select o.ID_OWNER from OWNER$PMS O where O.ID_OWNER in (:ID_SOURCE, :ID_TARGET))) then
      exception PROFILE_EXCEPTION '-1047';

    select p.PROFILE_TYPE, p.PROFILE_NAME
    from   PROFILE P
    where  P.ID_PROFILE = :ID_SOURCE
    into   :source_p_type, :source_p_name;

    select p.PROFILE_TYPE, p.PROFILE_NAME, PP.ID_PERSON_DATA, p.IS_ARCHIVE
    from   PROFILE P
           left outer join PROFILE_PERSON PP on PP.ID_PROFILE = P.ID_PROFILE 
    where  P.ID_PROFILE = :ID_TARGET
    into   :target_p_type, :target_p_name, :target_id_p_data, :is_archive;

    if (:is_archive = 1) then exception PROFILE_EXCEPTION '-1055';
    if (:source_p_type <> :target_p_type) then exception PROFILE_EXCEPTION 'Profile types are incompatible!';

    update RESERV_DETAIL RD
    set    rd.ID_AGENT_PROFILE = :ID_TARGET
    where  rd.ID_AGENT_PROFILE = :ID_SOURCE;

    update ACCOUNT A
    set    a.ID_PROFILE = :ID_TARGET
    where  a.ID_PROFILE = :ID_SOURCE;

    update AR_OWING AO
    set    ao.ID_PROFILE = :ID_TARGET
    where  ao.ID_PROFILE = :ID_SOURCE;

    update AR_PAYMENT ARP
    set    arp.ID_PROFILE = :ID_TARGET
    where  arp.ID_PROFILE = :ID_SOURCE;

    update DEPOSIT D
    set    d.ID_PROFILE = :ID_TARGET
    where  d.ID_PROFILE = :ID_SOURCE;

    update PROFILE_CREDIT_CARD pcc
    set    pcc.ID_PROFILE = :ID_TARGET
    where  pcc.ID_PROFILE = :ID_SOURCE
           and not exists (select spc.CARD_CODE
                           from   PROFILE_CREDIT_CARD spc
                           where  spc.ID_PROFILE = :ID_TARGET
                                  and spc.CARD_CODE = pcc.CARD_CODE);

    update PROFILE_DISCOUNT pd
    set    pd.ID_PROFILE = :ID_TARGET
    where  pd.ID_PROFILE = :ID_SOURCE
           and not exists (select spd.ID_SALE_DISCOUNT
                           from   PROFILE_DISCOUNT spd
                           where  spd.ID_PROFILE = :ID_TARGET
                                  and spd.ID_SALE_DISCOUNT = pd.ID_SALE_DISCOUNT);

    update PROFILE_HOTEL_RATE phr
    set    phr.ID_PROFILE = :ID_TARGET
    where  phr.ID_PROFILE = :ID_SOURCE
           and not exists (select tphr.ID_PROFILE
                           from   PROFILE_HOTEL_RATE tphr
                           where  tphr.ID_PROFILE = :ID_TARGET
                                  and tphr.ID_TARIFF = phr.ID_TARIFF
                                  and tphr.ID_HOTEL = phr.ID_HOTEL);

    update PROFILE_FILE pf
    set    pf.ID_PROFILE = :ID_TARGET
    where  pf.ID_PROFILE = :ID_SOURCE;

    for
      select sbs.ID_HOTEL, sbs.ID_BONUSPOINT_SCHEME
      from   PROFILE_BONUSPOINT_SCHEME sbs
      where  sbs.ID_PROFILE = :ID_SOURCE
      into   :id_hotel, :id_bps
    do begin
      if (not exists (select tbs.ID_BONUSPOINT_SCHEME
                      from   PROFILE_BONUSPOINT_SCHEME tbs
                      where  tbs.ID_PROFILE = :ID_TARGET
                             and tbs.ID_HOTEL = :id_hotel)) then
      begin
        insert into PROFILE_BONUSPOINT_SCHEME (ID_PROFILE, ID_HOTEL, ID_BONUSPOINT_SCHEME)
        values (:ID_TARGET, :id_hotel, :id_bps);
      end

    end

    update PROFILE_WALLET_POINTS pwp
    set    pwp.ID_PROFILE = :ID_TARGET
    where  pwp.ID_PROFILE = :ID_SOURCE;

    select pw.TOTAL_POINTS_GAINED, pw.TOTAL_POINTS_CONSUMED
    from   PROFILE_WALLET pw
    where  pw.ID_PROFILE = :ID_TARGET
    into   :total_points_gained, :total_points_consumed;

    update PROFILE p
    set    p.BONUSPOINT_GAINED = :total_points_gained,
           p.BONUSPOINT_CONSUMED = :total_points_consumed
    where  p.ID_PROFILE = :ID_TARGET;

    if (:source_p_type = 'PERSON') then begin
      for
        select RD.RDB$DB_KEY, GD.RDB$DB_KEY, RD.CHECK_STATUS, RD.ID_RESERV_DETAIL
        from   RESERV_DETAIL RD
               join GUEST_DATA GD on GD.ID_GUEST = RD.ID_TITULAR
        where  rd.ID_PERSON_PROFILE = :id_source
        into   :rd_dbkey, :gd_dbkey, :check_status, :id_reserv_detail
      do begin
        update RESERV_DETAIL RD
        set    RD.ID_PERSON_PROFILE = :id_target
        where  RD.RDB$DB_KEY = :rd_dbkey;

        if (:check_status < 1) then begin
          update GUEST_DATA GD
          set    GD.ID_PERSON_DATA = :target_id_p_data
          where  GD.RDB$DB_KEY = :gd_dbkey;

          execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL,  'TITULAR_CHAN_PROF_MERGE',
                                            f_character(29) || :source_p_name || f_character(28) || :target_p_name);
        end
      end

    end else if (:source_p_type = 'AGENT') then begin
      update SUMMARY_PROFILES$REV spr
      set    spr.ID_PROFILE = :ID_TARGET
      where  spr.ID_PROFILE = :ID_SOURCE;

      update SUMMARY_OCCUPANCY_PROFILE_MRKT sopm
      set    sopm.ID_PROFILE_AGENT = :ID_TARGET
      where  sopm.ID_PROFILE_AGENT = :ID_SOURCE;

      update SUMMARY_OCCUPANCY_OTHER soo
      set    soo.ID_PROFILE_AGENT = :ID_TARGET
      where  soo.ID_PROFILE_AGENT = :ID_SOURCE;
  
      update RES_TEMPLATE rt
      set    rt.ID_AGENT_PROFILE = :ID_TARGET
      where  rt.ID_AGENT_PROFILE = :ID_SOURCE;

      -- PROFILE_HOTEL_ALLOTMENT - keep target's allotments only 
    end

    /* delete or archivate */
    update PROFILE P
    set    p.IS_ARCHIVE = 1,
           p.ID_MERGE_PROFILE = :ID_TARGET
    where  p.ID_PROFILE = :ID_SOURCE;

    -- ficticious update - to force export only
    update PROFILE P
    set    p.UUID = p.UUID
    where  p.ID_PROFILE = :ID_TARGET;
    -- log
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_SOURCE, 'MERGE_TO', f_character(29) || :target_p_name);
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_TARGET, 'CONSOLIDATE_WITH', f_character(29) || :source_p_name);
  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_BONUSPOINTS_APPLY$CL for: PROFILE_WALLET_POINTS_REGISTER */
ALTER PROCEDURE DOCUMENT_BONUSPOINTS_APPLY$CL(ID_DOC_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_BONUSPOINTS_VOID$CL for: PROFILE_WALLET_POINTS_REGISTER */
ALTER PROCEDURE DOCUMENT_BONUSPOINTS_VOID$CL(ID_DOC_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_WALLET_POINTS$EXC for: PROFILE_WALLET_POINTS_REGISTER */
ALTER PROCEDURE IMPORT_WALLET_POINTS$EXC(UUID VARCHAR(40),
PROFILE_UUID VARCHAR(40),
POINTS INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
USER_CREATED VARCHAR(30),
DATETIME_CREATED TIMESTAMP)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_BONUSPOINTS_APPLY$CL for: PROFILE_WALLET_POINTS_REGISTER */
ALTER PROCEDURE RES_BONUSPOINTS_APPLY$CL(ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (PROFILE_WALLET_POINTS_REGISTER) */
ALTER PROCEDURE PROFILE_WALLET_POINTS_REGISTER(ID_PROFILE INTEGER,
POINTS INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255))
 RETURNS(NEW_ID_PROFILE_WALLET_POINTS INTEGER)
 AS
declare variable total_points_gained integer;
  declare variable total_points_consumed integer;
BEGIN

  /*select P.BONUSPOINT_GAINED, P.BONUSPOINT_CONSUMED
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :total_points_gained, :total_points_consumed;
  */
  if (:reason = 'VOID') then begin
    --total_points_gained = coalesce(:total_points_gained,0) - coalesce(:POINTS,0);
    POINTS = -:POINTS; -- reverse value
  end else if (:reason containing 'CONSUME') then begin
    --total_points_consumed = coalesce(:total_points_consumed,0) + coalesce(:POINTS,0);
    POINTS = -:POINTS; -- reverse value
  end else begin
    --total_points_gained = coalesce(:total_points_gained,0) + coalesce(:POINTS,0);
  end

  insert into PROFILE_WALLET_POINTS (ID_PROFILE, POINTS, REASON, NOTE)
  values (:id_profile, :points, :reason, :note)
  returning ID_PROFILE_WALLET_POINTS
  into      :NEW_ID_PROFILE_WALLET_POINTS;

  select pw.TOTAL_POINTS_CONSUMED, pw.TOTAL_POINTS_GAINED
  from   PROFILE_WALLET pw
  where  pw.ID_PROFILE = :ID_PROFILE
  into   :total_points_consumed, :total_points_gained;

  update PROFILE p
  set    p.BONUSPOINT_GAINED = :total_points_gained,
         p.BONUSPOINT_CONSUMED = :total_points_consumed
  where  p.ID_PROFILE = :ID_PROFILE;
END
^

/* Alter (RATE_GET_AVAILABILITY$CHM) */
ALTER PROCEDURE RATE_GET_AVAILABILITY$CHM(ID_RATE INTEGER,
FOR_DATE DATE)
 RETURNS(ACTIVE_STATUS INTEGER,
MIN_LOS INTEGER,
MAX_LOS INTEGER)
 AS
declare variable date_from date;
  declare variable date_to date;
  declare variable RATE_capacity integer;
  declare variable to_sell integer;
begin
  --ACTIVE_STATUS 0 - closed
  --ACTIVE_STATUS 1 - closed fro arrival
  --ACTIVE_STATUS 2 - opened
  --opala ID_HOTEL
--  date_from = null;
--  ACTIVE_STATUS -  autoclose, t.e. AUTO_PERCENT






/*  select min(FOR_DATE), max(FOR_DATE)
  from RATE_ALLOTMENT
  where ID_RATE = :id_RATE
  into :date_from, :date_to;
  if (date_from is null) then exit;

  for select distinct ID_ROOM_TYPE
      from RATE_ALLOTMENT
      where ID_RATE = :id_RATE
        and FOR_DATE between :date_from and :date_to
      into :id_room_type
  do begin
    for select RTR.FOR_DATE,
               CA.STATUS,
               CA.AUTO_FREE_ROOMS, CA.ROOM_COUNT, RTR.AVAILABLE as FREE_ROOMS
        from ROOM_TYPE_GET_FREE$CHM(:date_from, :date_to, :id_room_type) RTR
             join RATE_ALLOTMENT CA on CA.ID_ROOM_TYPE = :id_room_type
                                      and CA.ID_RATE = :id_RATE
                                      and CA.FOR_DATE = RTR.FOR_DATE
    into :for_date, :status,
         :auto_free_rooms, :RATE_capacity, :free_rooms
    do begin
      if (:auto_free_rooms is not null) then
        if (coalesce(:free_rooms,0) >= :auto_free_rooms) then
          is_active = 1;
        else is_active = 0;
      else if (:status = 0) then
             is_active = 1;
           else is_active = 0;

      to_sell = coalesce(:free_rooms,0) - coalesce(:auto_free_rooms,0);
      if (to_sell < 0) then to_sell = 0;

      room_count = :to_sell;
      if (:RATE_capacity is not null) then
        if (RATE_capacity < room_count) then
          room_count = :RATE_capacity;

      suspend;
    end
  end*/
end
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUPANCY$INT for: REP_ROOM_STATUS_MOVE */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$INT(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
 BEGIN EXIT; END
^

/* Alter (REP_ROOM_STATUS_MOVE) */
ALTER PROCEDURE REP_ROOM_STATUS_MOVE(FROM_DATE DATE,
TO_DATE DATE,
IN_ID_ROOM_TYPE INTEGER,
SECTOR INTEGER,
FLOOR INTEGER,
ROOM_PARAM_LIST VARCHAR(100),
OPTIONS VARCHAR(255),
HOTELS VARCHAR(255) = '')
 RETURNS(BUSY_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_AGENT INTEGER,
ID_HOTEL INTEGER,
GSTS_STAYOVER INTEGER,
ROOMS_STAYOVER INTEGER,
GSTS_COME INTEGER,
ROOMS_COME INTEGER,
GSTS_GONE INTEGER,
ROOMS_GONE INTEGER)
 AS
declare variable check_in_only integer;
  declare variable busy_group_type integer;
  declare variable room_requirements blob sub_type 1;
begin
  /*  Description:
  ||       
  */
  room_requirements = F_STRTOBLOB(:room_param_list);
  if (:options like '%CHECK_IN_ONLY%') then check_in_only = 1;
  else check_in_only = 0;

  for
    select RM.BUSY_DATE, RM.ID_ROOM_TYPE,
           --iif(:options containing 'DIST_AGENTS', RM.ID_AGENT, null),
           RM.ID_AGENT,
           coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE), RM.ID_HOTEL,
           sum(RM.GST_AD_STAY+RM.GST_CH_STAY), count(distinct iif(RM.DAY_ACTION in ('STAY', 'BLOCK'), RM.ID_ROOM, null)),
           sum(RM.GST_AD_IN+RM.GST_CH_IN), count(distinct iif(RM.DAY_ACTION = 'CHECK_IN', RM.ID_ROOM, null)),
           sum(RM.GST_AD_OUT+RM.GST_CH_OUT), count(distinct iif(RM.DAY_ACTION = 'CHECK_OUT', RM.ID_ROOM, null))
    from   ROOM_MAGIC RM
           join HOTEL_S H on H.ID_HOTEL = RM.ID_HOTEL
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = RM.ID_RESERV_DETAIL and RD.ACC_ROUTING <> 'OWNER'
           left outer join ROOMS_SHARE RS on RS.ID_ROOM_SHARE = RM.ID_ROOM_MAGIC
    where  RM.BUSY_DATE between :from_date and :to_date
           and RM.BUSY_TYPE not in ('VALUE_RESERVS')
           and rm.ROOM_STATUS is distinct from 'PRIVATE'
           and ((:hotels = '') or (','||:hotels||',' containing ','||H.ID_HOTEL||','))
           and ((:check_in_only = 0) or (RM.BUSY_GROUP_TYPE = 24))
           and ((:in_id_room_type = -1) or (RM.ID_ROOM_TYPE = :in_id_room_type))
           and ((:sector = -1 and :floor = -1 and :room_param_list = '') or (exists (
             select R.ID_ROOM , R.ROOM_NAME, R.ID_ROOM_TYPE, R.SECTOR, R.FLOOR, RT.ID_HOTEL
             from   ROOMS R
                    join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
                    left outer join SYSTEM_PICKUP_FEATURES$INT(R.FEATURES, :room_requirements, 38, R.ID_HOTEL) RPF on 0=0
             where  R.ID_ROOM = RM.ID_ROOM
                    and RPF.IS_MATCHING = 1
                    and ((R.SECTOR = :SECTOR) or (:SECTOR <= 0))
                    and ((R.FLOOR = :FLOOR) or (:FLOOR <= 0))
           )))
    group by 1, 2, 3, 4, 5
    into   :busy_date, :id_room_type,
           :id_agent,
           :busy_group_type, :id_hotel,
           :gsts_stayover, :rooms_stayover,
           :gsts_come, :rooms_come,
           :gsts_gone, :rooms_gone
  do begin
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_CHECK_OUT_GUESTS$RSV for: RES_BONUSPOINTS_APPLY$CL */
ALTER PROCEDURE RES_CHECK_OUT_GUESTS$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND SMALLINT = 0)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_BONUSPOINTS_APPLY$CL) */
ALTER PROCEDURE RES_BONUSPOINTS_APPLY$CL(ID_RESERV_DETAIL INTEGER)
 AS
declare variable nights integer;
  declare variable daybeds integer;
  declare variable daybed_adults integer;
  declare variable guests integer;
  declare variable guest_adults integer;
  declare variable bookings integer;
  declare variable id_guest_profile integer;
  declare variable points integer;
  declare variable id_guest_scheme integer;
  declare variable reason varchar(50);
  declare variable note varchar(255);
  declare variable new_id_profile_wallet_points integer;
  declare variable id_organizer_profile integer;
  declare variable id_organizer_scheme integer;
  declare variable acc_routing varchar(30);
begin
  nights = 0;
  daybeds = 0;
  daybed_adults = 0;
  guests = 0;
  guest_adults = 0;
  bookings = 0;
  points = null;
  reason = null;
  note = null;

  select P.ID_PROFILE, PS.ID_BONUSPOINT_SCHEME,
         OP.ID_PROFILE, OP.ID_BONUSPOINT_SCHEME, RD.ACC_ROUTING,
         cast(RD.NUMBER || ', ' || P.PROFILE_NAME || ', '
             || formatdate(rd.FROM_DATE, 'D;dd.MM.yyyy') || '-' || formatdate(rd.TO_DATE, 'D;dd.MM.yyyy') as varchar(255))
  from   RESERV_DETAIL RD
         join PROFILE P on p.ID_PROFILE = RD.ID_PERSON_PROFILE
         join PROFILE_BONUSPOINT_SCHEME PS on PS.ID_PROFILE = p.ID_PROFILE
                                             and ps.ID_HOTEL = rd.ID_HOTEL
         left outer join PROFILE_BONUSPOINT_SCHEME OP on OP.ID_PROFILE = RD.ID_AGENT_PROFILE
                                                         and op.ID_HOTEL = rd.id_hotel
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :id_guest_profile, :id_guest_scheme,
         :id_organizer_profile, :id_organizer_scheme, :acc_routing, :note;

  if (:id_organizer_scheme is not null) then begin
    for
      select BPC.POINTS, BPC.NIGHTS, BPC.DAYBEDS, BPC.DAYBED_ADULTS, BPC.GUESTS, BPC.GUEST_ADULTS,
             BPC.BOOKINGS, BPC.POINTS_REASON
      from   BP_SCHEME_CALC_NIGHTS_POINTS (:id_organizer_scheme, :ID_RESERV_DETAIL) BPC
      into   :points, :nights, :daybeds, :daybed_adults, :guests, :guest_adults,
             :bookings, :reason
    do begin
      execute procedure PROFILE_WALLET_POINTS_REGISTER (:id_organizer_profile, :points, :reason, :note)
      returning_values (:new_id_profile_wallet_points);
    
      insert into PROFILE_WALLET_POINTS_SOURCE (ID_PROFILE_WALLET_POINTS, ID_RESERV_DETAIL,
             NIGHTS, DAYBEDS, DAYBED_ADULTS, GUESTS, GUEST_ADULTS, BOOKINGS, ID_BONUSPOINT_SCHEME)
      values (:new_id_profile_wallet_points, :ID_RESERV_DETAIL,
             :nights, :daybeds, :daybed_adults, :guests, :guest_adults, :bookings, :id_organizer_scheme);
    end
  end

  if (:id_guest_profile is distinct from :id_organizer_profile
      and :acc_routing = 'GUEST'
      and :id_guest_scheme is not null) then
  begin
    for
      select BPC.POINTS, BPC.NIGHTS, BPC.DAYBEDS, BPC.DAYBED_ADULTS, BPC.GUESTS, BPC.GUEST_ADULTS,
             BPC.BOOKINGS, BPC.POINTS_REASON
      from   BP_SCHEME_CALC_NIGHTS_POINTS (:id_guest_scheme, :ID_RESERV_DETAIL) BPC
      into   :points, :nights, :daybeds, :daybed_adults, :guests, :guest_adults,
             :bookings, :reason
    do begin
      execute procedure PROFILE_WALLET_POINTS_REGISTER (:id_guest_profile, :points, :reason, :note)
      returning_values (:new_id_profile_wallet_points);
    
      insert into PROFILE_WALLET_POINTS_SOURCE (ID_PROFILE_WALLET_POINTS, ID_RESERV_DETAIL,
             NIGHTS, DAYBEDS, DAYBED_ADULTS, GUESTS, GUEST_ADULTS, BOOKINGS, ID_BONUSPOINT_SCHEME)
      values (:new_id_profile_wallet_points, :ID_RESERV_DETAIL,
             :nights, :daybeds, :daybed_adults, :guests, :guest_adults, :bookings, :id_guest_scheme);
    end
  end


end
^

/* empty dependent procedure body */
/* Clear: APPLY_BOOKING_STATUS$EXC for: RES_CHECK_OUT_GUESTS$RSV */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: EAI_RES_CHECK_OUT_FAST for: RES_CHECK_OUT_GUESTS$RSV */
ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_CHECK_OUT_GUESTS$RSV) */
ALTER PROCEDURE RES_CHECK_OUT_GUESTS$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND SMALLINT = 0)
 AS
declare variable action_code varchar(100);
  declare variable cleaning_restriction varchar(10);
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable id_reserv_detail integer;
  declare variable id_guest integer;
  declare variable id_room integer;
  declare variable rd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable checkout_status integer;
  declare variable sys_date date;
  declare variable id_hotel integer;
begin
  checkout_status = 1;
  action_code = case when :check_out_kind = 0 then 'CHECK_OUT'
                     when :check_out_kind = 1 then 'CHECK_OUT_EARLY1'
                     when :check_out_kind = 2 then 'CHECK_OUT_EARLY2'
                     when :check_out_kind = 3 then 'CHECK_OUT_EARLY3'
                end;

  for
    select RD.ID_RESERV_DETAIL, RD.ID_ROOM, RD.RDB$DB_KEY, rd.ID_HOTEL,
           (select sd.SYSTEM_DATE
            from   SYSTEM_DATE_GET (rd.ID_HOTEL) sd)
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :id_reserv_detail, :id_room, :rd_dbkey, :id_hotel, :sys_date
  do begin

    for
      select G.ID_GUEST, G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.CHECK_STATUS = 0 /* checked in */
      into   :id_guest, :g_dbkey
    do begin
      if (:CHECK_OUT_KIND = 3) then begin
        -- DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
        update GUEST G
        set    G.EARLYCHECKOUT_DATE = :sys_date
        where  g.RDB$DB_KEY = :g_dbkey;

        execute procedure GUEST_SET_MANUAL_STAY$INT(:rd_dbkey, :id_guest, :sys_date)
        returning_values  :err_code, :err_text;
        if (:err_code < 0) then exception RESERV_CHECK_OUT_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
      end

      update ACCOUNT_POST AP
      set    AP.IS_ARCHIVE = 1
      where  AP.ID_GUEST = :id_guest;
    
      execute procedure GUEST_SET_STATUS$INT (:g_dbkey, :checkout_status);

      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, :action_code, '');
    end

    if (:CHECK_OUT_KIND = 3) then begin
      -- DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
      execute procedure OCCUPANCY_RESERV$INT(:rd_dbkey);
    end

    execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

    execute procedure SETTING_GET_VALUE('CLEANING_RESTRICTION', :id_hotel)
    returning_values  :cleaning_restriction;
  
    if (:cleaning_restriction <> '0' and :id_room > 0) then begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'CHECK_OUT', 'set_dirty');
    end

    execute procedure RES_SAVE_STATUS$INT (:rd_dbkey, :checkout_status);

    execute procedure RES_BONUSPOINTS_APPLY$CL (:id_reserv_detail);
  end

end
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE_RECALC$INT for: RES_RECALC$INT */
ALTER PROCEDURE RES_FINALIZE_RECALC$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_RECALC$RSV for: RES_RECALC$INT */
ALTER PROCEDURE RES_RECALC$RSV(ID_RESERV_DETAIL INTEGER,
FORCE_POSTING SMALLINT = null)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE TAR_CALC_INPUT_RESERV$INT(ID_RESERV_DETAIL INTEGER,
ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
ID_RATE_OVERRULE INTEGER = null)
 AS
declare variable id_guest integer;
  declare variable g_dbkey char(8);
  declare variable from_date date;
  declare variable to_date  date;
  declare variable id_tariff_calc integer;
  declare variable err_code integer;
  declare variable err_text varchar(25);
  declare variable id_guest_reserv integer;
begin
  for
    select G.ID_GUEST, G.FROM_DATE, G.TO_DATE, G.G_DBKEY, g.ID_GUEST_RESERV
    from   TAR_CALC_GET_GUESTS$INT(:id_reserv_detail) G
    into   :id_guest, :from_date, :to_date, :g_dbkey, :id_guest_reserv
  do begin
    execute procedure sys_dbg('calc RES_RECALC$INT input guest_id '|| :id_guest || ', from:' || :from_date || ', to:' ||  :to_date);

    id_tariff_calc = null;
    if (:id_guest_reserv = :ID_RESERV_DETAIL and :ID_RATE_OVERRULE is not null) then id_tariff_calc = :ID_RATE_OVERRULE;
    -- skip ID_RATE_OVERRULE for shared bookings
    execute procedure TAR_CALC_INPUT_GUEST$INT(:id_tar_calc, :room_status, :g_dbkey, :id_tariff_calc, 1);
  end

  -- RECALCULATING DEPENDING ON THE TARIFF KIND
  execute procedure TAR_CALC_INPUT_DETAILS$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exception RATING_PREPARE_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
end
^

/* Alter (RES_RECALC$INT) */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable num_prefix varchar(20);
  declare variable number_1 varchar(20);
begin
  /* CALLER_KIND = {NORMAL, FORCED} */
  err_code = 0;
  /* 1. GET DATA */
  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL, rd.NUMBER_1
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :check_status, :id_reserv_detail, :number_1;

  if (:check_status = 1) then begin
    -- CHECKED OUT
    select sn.LEADING_PART
    from   SYSTEM_NUMERATOR SN
    where  sn.ID_NUMERATOR = 0
    into   :num_prefix;

    if (trim('.' from coalesce(:num_prefix, '')) = coalesce(:number_1, '')) then
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_MINE');
    else
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_ELSE');

    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :id_guest
    do begin
      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'MANUAL_EDIT_DATA', '');
    end
  end
  /* 2. FIND DEPENDANT GUESTS AND THEIR TARIFFS */
  execute procedure sys_dbg('calc RES_RECALC$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

  id_tar_calc = gen_id(gen_id_tar_calc, 1);
  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NONE');

  execute procedure TAR_CALC_EVAL_ALL$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  -- 3. UPDATE ROOM PRICE and REPOST ALL AFFECTED BOOKINGS
  execute procedure RES_TAR_CALC_FINALIZE$INT (:ERR_CODE, :ID_TAR_CALC, :RD_DBKEY, :CALLER_KIND, :FORCE_POSTING);

end
^

/* Alter (RES_RECALC$RSV) */
ALTER PROCEDURE RES_RECALC$RSV(ID_RESERV_DETAIL INTEGER,
FORCE_POSTING SMALLINT = null)
 AS
declare variable id_tar_calc integer;
declare variable err_text varchar(255);
  declare variable err_code integer;
  declare variable rd_dbkey char(8);
begin
  -- FORCED, user activated recalculation
  execute procedure RIGHTS_CHECK_GRANTED$INT ('GUEST_RECALC_POST');

  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_RECALC$INT(:rd_dbkey, 'FORCED', :FORCE_POSTING)
  returning_values  :err_code, :err_text, :id_tar_calc;
  if (:err_code < 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'FORCED_RECALC', null);

end
^

/* empty dependent procedure body */
/* Clear: RES_TAR_CALC_FINALIZE$INT for: RES_TAR_CALC_REPOST$INT */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(TAR_CALC_ERR INTEGER,
ID_TAR_CALC INTEGER,
RD_DBKEY_INIT CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_TAR_CALC_REPOST$INT) */
ALTER PROCEDURE RES_TAR_CALC_REPOST$INT(ID_TAR_CALC TYPE OF ID_REF,
ID_RESERV_DETAIL TYPE OF ID_REF,
RECALC_MARKER VARCHAR(40))
 AS
declare variable id_guest type of id_ref;
  declare variable id_service type of id_ref;
  declare variable id_tariff type of id_ref;
  declare variable date_post type of tdate;
  declare variable qty_post type of tqty;
  declare variable price_orig type of tprice;
  declare variable curr_orig type of tcurrency;
  declare variable id_room type of id_ref;
  declare variable is_base type of tlogical;
  declare variable short_code type of tdescription_long;
  declare variable id_account type of id_ref;
  declare variable gfrom_date type of tdate;
  declare variable gto_date type of tdate;
  declare variable ap_db_key char(8);
  declare variable id_pack_service type of id_ref;
  declare variable err_code type of id_ref;
  declare variable err_text type of tdescription_long;
  declare variable id_master_account_post type of id_ref;
  declare variable id_acc_post type of id_ref;
  declare variable rate_orig type of tprice;
  declare variable is_base_account type of id_ref;
  declare variable id_extra_account type of id_ref;
  declare variable no_use varchar(255);
begin
  for
    select   TCP.ID_GUEST, TCP.ID_SERVICE, TCP.ID_TARIFF, TCP.DATE_POST, TCP.QTY_POST,
             round_f(TCP.PRICE_ORIG, c.ROUND_TO), TCP.CURR_ORIG, TCP.ID_ROOM, TCP.IS_BASE,
             TCP.SHORT_CODE, iif(coalesce(AGP.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'NONE', 0, 1),
             G.ID_BASE_ACCOUNT, G.FROM_DATE, G.TO_DATE, G.ID_ACCOUNT
    from     TAR_CALC_POST$TMP TCP
             join GUEST G on G.ID_GUEST = TCP.ID_GUEST
             join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
             join SERVICES S on S.ID_SERVICE = TCP.ID_SERVICE
             join CURRS c on c.CURR = tcp.CURR_ORIG
             left outer join AGENT_PACKET AGP on AGP.ID_SERVICE = S.ID_SERVICE and AGP.ID_AGENT = G.ID_AGENT
    where    TCP.ID_TAR_CALC = :id_tar_calc
             and ((rd.ID_RESERV_DETAIL = :ID_RESERV_DETAIL)
                  or (coalesce(RD.IS_POSTING_STOPPED, 0) = 0 and RD.POSTING_TRANSACTION_UUID is not null))
    order by TCP.ID_GUEST asc, TCP.DATE_POST asc, TCP.IS_BASE desc
    into     :id_guest, :id_service, :id_tariff, :date_post, :qty_post,
             :price_orig, :curr_orig, :id_room, :is_base, :short_code, :is_base_account,
             :id_account, :gfrom_date, :gto_date, :id_extra_account
  do begin
    ap_db_key = null;
    if (:is_base = 1) then begin
      select AP.RDB$DB_KEY, AP.ID_MASTER_ADDINS_ACC_POST, AP.RATE_ORIG, AP.ID_PACK_SERVICE
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.DATE_POST = :date_post
             and AP.IS_BASE = 1
      into   :ap_db_key, :id_master_account_post, :rate_orig, :id_pack_service;

      execute procedure sys_dbg('tar TAR_CALC_REPOST$INT price_orig = '||coalesce(:price_orig, 'null'));
      execute procedure sys_dbg('tar TAR_CALC_REPOST$INT ap_db_key = '||coalesce(:ap_db_key, 'null'));

      if (:ap_db_key is null) then begin
        id_master_account_post = -1;
        rate_orig = null;
        execute procedure GUEST_POST_GET_PACK_SERVICE(:id_service, :id_guest, :date_post)
        returning_values  :id_pack_service;
      end
    end else begin
      short_code = '';
      select first 1 APU.rdb$db_key
      from   ACCOUNT_POST APU
      where  APU.ID_MASTER_ADDINS_ACC_POST = :id_master_account_post
             and APU.ID_SERVICE = :id_service
      order by apu.IS_ANUL asc, apu.ID_ACCOUNT_POST asc
      into   :ap_db_key;

      if ((:ap_db_key is null) and (:is_base_account <> 1)) then id_account = :id_extra_account;
    end

    if (:ap_db_key is null) then begin
      execute procedure ACCOUNT_POSTING_ADD$INT(
        :id_account, :id_guest, -1, :date_post, :id_service, :id_tariff, :id_room, :is_base, :qty_post,
        :price_orig, :curr_orig, :rate_orig, :short_code, :gfrom_date, :gto_date, 'PACK='||:id_pack_service, '',
        :recalc_marker, :id_master_account_post)
      returning_values  :err_code, :err_text, :id_acc_post;
      if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

      if (:is_base = 1) then id_master_account_post = :id_acc_post;

    end else begin
      execute procedure ACCOUNT_POSTING_UPDATE$INT(
        :ap_db_key, :id_service, :id_tariff, :id_room, :qty_post, 0, :price_orig, :curr_orig, :rate_orig,
        :recalc_marker, :short_code, :gfrom_date, :gto_date, 1, :id_account)
      returning_values  :no_use, :no_use, :no_use;
    end

  end

  ap_db_key = null;
  id_guest = null;
  for
    select distinct TCP.ID_GUEST
    from   TAR_CALC_POST$TMP TCP
    where  tcp.ID_TAR_CALC = :ID_TAR_CALC
    into   :id_guest
  do begin
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.CHANGED_TEXT is distinct from :recalc_marker
             and AP.ID_MASTER_ADDINS_ACC_POST > 0
             and AP.IS_ANUL = 0
      into   :ap_db_key
    do begin
      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_db_key, :recalc_marker);
    end
  end

  delete from RESERV_PREPOST RP where RP.ID_RESERV_DETAIL = :id_reserv_detail;
  execute procedure RES_TAKE_POSTING_RESPONSIBILITY (:ID_RESERV_DETAIL);
end
^

/* Alter (RESOURCE_RESERVATION_CHECK_IN) */
ALTER PROCEDURE RESOURCE_RESERVATION_CHECK_IN(ID_RESOURCE_RESERVATION INTEGER,
SERVICE_PRICE NUMERIC(15,2),
SERVICE_CURR VARCHAR(3))
 RETURNS(OUT_ID_ACCOUNT INTEGER,
OUT_ID_ACCOUNT_POST INTEGER)
 AS
declare variable old_status varchar(20);
  declare variable new_status varchar(20);
  declare variable dbkey char(8);
  declare variable id_service id_ref;
  declare variable price_post tprice;
  declare variable curr_post TCURRENCY;
  declare variable is_manual_price TLOGICAL;
  declare variable is_details tlogical;
  declare variable post_description tobject_text;
  declare variable id_reserv_detail integer;
  declare variable post_date tdate;
  declare variable from_datetime tdatetime;
  declare variable to_datetime tdatetime;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  new_status = 'CHECKED_IN';

  select r.RDB$DB_KEY, R.STATUS, rd.ID_RESERV_DETAIL
  from   RESOURCE_RESERVATION R
         left outer join RESERV_DETAIL rd on rd.NUMBER = r.BOOKING_NUMBER
                                             and rd.IS_ANUL = 0
                                             and rd.SUBSCRIBER_ID is not distinct from r.SUBSCRIBER_ID
  where  R.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION
  into   :dbkey, :old_status, :id_reserv_detail;

  if (:old_status = :NEW_STATUS) then exit;
 
  if (:old_status is distinct from 'RESERVED') then exception ASSERT '-511';

  if (exists (select RP.ID_RESOURCE_RESERVATION
              from   RESOURCE_RESERV_POST RP
                     join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = RP.ID_ACCOUNNT_POST
              where  RP.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION)) then
  begin
    exception ASSERT '-505';
  end

  if (:id_reserv_detail is not null) then begin
    execute procedure RESOURCE_RESERV_SERVICE_GET (:ID_RESOURCE_RESERVATION)
    returning_values (:id_service, :price_post, :curr_post, :is_manual_price, :is_details, :post_description,
                     :post_date, :from_datetime, :to_datetime);
  
    if (:is_manual_price = 1) then begin
      price_post = :SERVICE_PRICE;
      curr_post = :SERVICE_CURR;
    end

    if (:price_post is null) then exception ASSERT 'Unspecified service price!';
    if (:curr_post is null) then exception ASSERT 'Unspecified price currency!';
  
    execute procedure POST_SERVICE_ON_RESERVATION$INT (:id_reserv_detail, :id_service, 1, 0,
            1, :price_post, :curr_post, :from_datetime, :to_datetime,
            '', '', :post_date, 'RESOURCE', :post_description)
    returning_values (:ERR_CODE, :ERR_TEXT, :OUT_ID_ACCOUNT, :OUT_ID_ACCOUNT_POST);
    if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
  
    insert into RESOURCE_RESERV_POST(ID_RESOURCE_RESERVATION, ID_ACCOUNNT_POST)
    values (:ID_RESOURCE_RESERVATION, :OUT_ID_ACCOUNT_POST);
  end

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = :NEW_STATUS
  where  RR.RDB$DB_KEY = :dbkey;

end
^

/* Alter (RIGHTS_GROUP_USER_MODIFY) */
ALTER PROCEDURE RIGHTS_GROUP_USER_MODIFY(USER_NAME VARCHAR(30),
ID_RIGHT_GROUP INTEGER,
OPERATION VARCHAR(50))
 AS
declare variable right_group varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add,del');

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS RG
  where  RG.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'add') then begin
    insert into RIGHTS_USER_GROUPS (USER_NAME, ID_RIGHT_GROUP)
    values (:user_name, :id_right_group);

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_ADDED',
            f_character(29) || :USER_NAME  || f_character(28) || :right_group);

  end else begin
    delete from RIGHTS_USER_GROUPS
    where USER_NAME = :user_name
          and ID_RIGHT_GROUP = :id_right_group;

    if (row_count > 0) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_REMOVED',
              f_character(29) || :USER_NAME || f_character(28) || :right_group);

  end

  when sqlcode -803 do begin
    /* ERR_TEXT = '       ! ' ;*/
    exit;
  end
end
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_MODIFY for: SAFE_OCCUPANCY_POSTING$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE /* TYPE OF ID */ INTEGER,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100))
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_NEW for: SAFE_OCCUPANCY_POSTING$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE /* TYPE OF ID */ INTEGER,
FROM_DATETIME /* TDATETIME */ TIMESTAMP,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100),
BOOKING_NUMBER /* TYPE OF TRES_NUMBER */ VARCHAR(62),
ID_EXTERNAL_CLIENT_ACCCOUNT /* TYPE OF ID_REF */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER,
ID_RESOURCE_RESERVATION /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SAFE_OCCUPANCY_POSTING$INT) */
ALTER PROCEDURE SAFE_OCCUPANCY_POSTING$INT(ID_RESOURCE_RESERVATION TYPE OF ID,
ID_SERVICE TYPE OF ID,
PRICE TYPE OF TPRICE,
CURRENCY TYPE OF TCURRENCY,
PRICE_DESCRIPTION TYPE OF TDESCRIPTION_SHORT,
ID_RESERV_DETAIL TYPE OF ID,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF = null)
 RETURNS(DOC_SELECTED TYPE OF TRANGE)
 AS
declare variable from_datetime timestamp;
  declare variable to_datetime timestamp;
  declare variable ap_dbkey TDB_KEY;
  declare variable id_account_post integer;
  declare variable safe_name TOBJECT_NAME;
  declare variable no_use varchar(255);
  declare variable new_ac varchar(2);
  declare variable err_code integer;
  declare variable err_text varchar(255) ;
  declare variable occupant_name tperson_name;
  declare variable id_room integer;
  declare variable id_tariff integer;
begin
  DOC_SELECTED = null;
  select od.FROM_DATETIME, od.TO_DATETIME, ap.RDB$DB_KEY, ap.ID_ACCOUNT_POST,
         s.SAFE_NAME, rr.OCCUPANT_NAME, ap.ID_ROOM, ap.ID_TARIFF
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join SAFES s on s.ID_SAFE = od.ID_RESOURCE
         left outer join RESOURCE_RESERV_POST rrp on rrp.ID_RESOURCE_RESERVATION = rr.ID_RESOURCE_RESERVATION
         left outer join ACCOUNT_POST ap on ap.ID_ACCOUNT_POST = rrp.ID_ACCOUNNT_POST
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :from_datetime, :to_datetime, :ap_dbkey, :id_account_post,
         :safe_name, :occupant_name, :id_room, :id_tariff;

  new_ac = null;
  if (:id_account_post is not null) then begin
    execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
            :id_tariff, :id_room, 1, 0, :price, :currency, null, null, 'RESOURCE', :from_datetime, :TO_DATETIME, 1)
    returning_values :no_use, :no_use, :new_ac;
  end else begin
    if (:id_reserv_detail is not null) then begin
      execute procedure POST_SERVICE_ON_RESERVATION$INT (:id_reserv_detail, :id_service, 1, 0,
              1, :price, :currency, :from_datetime, :to_datetime,
              '', '', cast(:from_datetime as date), 'RESOURCE', null)
      returning_values (:ERR_CODE, :ERR_TEXT, :no_use, :id_account_post);
      if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      new_ac = '00';
    end else if (:ID_EXTERNAL_CLIENT_ACCCOUNT is not null) then begin
      execute procedure POST_SERVICE_ON_ACCOUNT$INT (:ID_EXTERNAL_CLIENT_ACCCOUNT, :id_service,
              1, 0, 1, :price, :currency, :from_datetime, :TO_DATETIME, '', '',
              cast(:from_datetime as date), 'RESOURCE', null, null)
      returning_values (:err_code, :err_text, :id_account_post);
      if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      new_ac = '00';
    end
  end

  if (:new_ac is null) then
    exception ASSERT '-1067' || f_character(31) || f_character(29) || :safe_name || f_character(28) || :occupant_name;

  if (:new_ac = '00') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);
    update ACCOUNT_POST AP
    set    ap.DOC_SELECTED = :DOC_SELECTED
    where  ap.ID_ACCOUNT_POST = :id_account_post;
  end

  update or insert into ACCOUNT_POSTING_DET (ID_ACCOUNT_POST, POST_TEXT, QTY,
         FROM_DATETIME, TO_DATETIME, RESOURCE_TEXT, EXT_USER_ANUL)
  values (:id_account_post, :safe_name ||' / '||formatdate(:from_datetime, 'D;dd.mm.yy(hh:mm)')||' - '||formatdate(:to_datetime, 'D;dd.mm.yy(hh:mm)')||' / '
          ||substring(replace(:price_description, F_CRLF(), ';') from 1 for 100), 1, :from_datetime, :to_datetime, :safe_name, null);

  if (not exists (select rp.ID_ACCOUNNT_POST
                  from   RESOURCE_RESERV_POST rp
                  where  rp.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION
                         and rp.ID_ACCOUNNT_POST = :id_account_post)) then
  begin
    insert into RESOURCE_RESERV_POST (ID_RESOURCE_RESERVATION, ID_ACCOUNNT_POST)
    values (:id_resource_reservation, :id_account_post);
  end
end
^

/* Alter (TAR_CALC_GET_GUESTS$INT) */
ALTER PROCEDURE TAR_CALC_GET_GUESTS$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_GUEST INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
G_DBKEY CHAR(8),
ID_GUEST_RESERV TYPE OF ID)
 AS
declare variable dbg varchar(2000);
declare variable share_status integer;
declare variable shared_reservations varchar(1024);
declare variable id_shared_detail integer;
declare variable unshared_reservations varchar(1024);
declare variable id_unshared_detail integer;
declare variable incremental_guest_list varchar(2000);
begin
  incremental_guest_list = ','; /*using for not suspend dublicated guests - otherwise calculations are wrong*/
  for
    select G.ID_GUEST, G.FROM_DATE, G.TO_DATE, G.RDB$DB_KEY, rd.ID_RESERV_DETAIL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  Rd.ID_RESERV_DETAIL = :id_reserv_detail
           and rd.IS_ANUL = 0
    into   :ID_GUEST, :FROM_DATE, :TO_DATE, :G_DBKEY, :ID_GUEST_RESERV
  do begin
    suspend;
    incremental_guest_list = :incremental_guest_list || :id_guest ||',';
  end

/*  execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'ENUM_SHARES', null)*/
  execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'FOR_RECALC', null)
  returning_values  :share_status, :shared_reservations, :dbg;
  execute procedure sys_dbg('calc TAR_CALC_GET_GUESTS$INT shared_reservations = '||coalesce(:shared_reservations, 'null'));

  if (:share_status = 1) then begin
    for
      select SP.ITEM
      from   SYSTEM_STRING_PARSER(:shared_reservations, ',') SP
      into   :id_shared_detail
    do begin
      for
        select G.ID_GUEST, G.FROM_DATE, G.TO_DATE, G.RDB$DB_KEY, G.ID_RESERV_DETAIL
        from   GUEST G
        where  G.ID_RESERV_DETAIL = :id_shared_detail
        into   :ID_GUEST, :FROM_DATE, :TO_DATE, :G_DBKEY, :ID_GUEST_RESERV
      do begin
        if (:incremental_guest_list not containing ','||:id_guest||',' ) then begin
          suspend;
          incremental_guest_list = :incremental_guest_list || :id_guest ||',';
        end
      end
    end
  end

  execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'ENUM_EX_SHARES', null)
  returning_values  :share_status, :unshared_reservations, :dbg;

  execute procedure sys_dbg('calc TAR_CALC_GET_GUESTS$INT unshared_reservations = '||coalesce(:unshared_reservations, 'null'));
  execute procedure sys_dbg('calc TAR_CALC_GET_GUESTS$INT incremental_guest_list = '||coalesce(:incremental_guest_list, 'null'));

  if (:unshared_reservations <> '') then begin
    for
      select SP.ITEM
      from   SYSTEM_STRING_PARSER(:unshared_reservations, ',') SP
      into   :id_unshared_detail
    do begin
      for
        select G.ID_GUEST, G.FROM_DATE, G.TO_DATE, G.RDB$DB_KEY, g.ID_RESERV_DETAIL
        from   GUEST G
        where  G.ID_RESERV_DETAIL = :id_unshared_detail
        into   :ID_GUEST, :FROM_DATE, :TO_DATE, :G_DBKEY, :ID_GUEST_RESERV
      do begin
        if (:incremental_guest_list not containing ','||:id_guest||',' ) then begin
          suspend;
          incremental_guest_list = :incremental_guest_list || :id_guest ||',';
        end
        execute procedure sys_dbg('calc TAR_CALC_GET_GUESTS$INT incremental_guest_list2 = '||coalesce(:incremental_guest_list, 'null'));
      end
    end
  end
end
^

/* Alter (TAR_CALC_INPUT_DETAILS$INT) */
ALTER PROCEDURE TAR_CALC_INPUT_DETAILS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_input integer;
  declare variable id_guest integer;
/****************************************/
  declare variable for_date date;
  declare variable id_room_type integer;
  declare variable id_board integer;
  declare variable id_type_stay integer;
  declare variable is_manual_type_stay integer;
  declare variable checkin_order integer;
  declare variable id_calc_tariff integer;
  declare variable id_room integer;
begin
  err_code = 0;
  err_text = '';
  for
    select TCI.ID_TAR_INPUT, TCI.ID_GUEST, LP.OUT_DATE,
           GS.ID_BOARD, coalesce(tci.ID_RATE_OVERRULE, GS.ID_RATE), GS.ID_ROOM,
           gs.ID_TYPE_STAY, gs.ID_ROOM_TYPE, gs.IS_MANUAL_TYPE_STAY
    from   TAR_CALC_INPUT$TMP TCI
           join GUEST G on G.ID_GUEST = TCI.ID_GUEST
           left join SYSTEM_LOOP_PERIOD (TCI.FROM_DATE_CALC, TCI.TO_DATE_CALC) LP on 1=1
           left join GUEST_GET_STAY_CONDITIONS$INT (g.ID_GUEST, lp.OUT_DATE) GS on 1=1
    where  TCI.ID_TAR_CALC = :id_tar_calc
    order by g.ID_GUEST asc, LP.OUT_DATE asc
    into   :id_tar_input, :id_guest, :for_date,
           :id_board, :id_calc_tariff, :id_room,
           :id_type_stay, :id_room_type, :is_manual_type_stay
  do begin
    checkin_order = :id_guest;
    insert into TAR_CALC_INPUT_DETAIL$TMP (
      ID_TAR_INPUT, FOR_DATE, ID_TAR_HEAD, ID_BOARD, ID_ROOM,
      ID_ROOM_TYPE, ID_TYPE_STAY, IS_MANUAL_TYPE_STAY, CHECKIN_ORDER,
      SEPARATE_BOARD, ID_BOARD_INCLUDE, param_values)
    values (
      :id_tar_input, :for_date, :id_calc_tariff, :id_board, :id_room,
      :id_room_type, :id_type_stay, :is_manual_type_stay,
      :checkin_order, 0, null, '');
    /* get date dependent params */
  end

  execute procedure TAR_CALC_INPUT_PARAMS$INT (:ID_TAR_CALC)
  returning_values (:ERR_CODE, :ERR_TEXT);
  if (:ERR_CODE < 0) then exit;
  /*handle costom prices by days or single one*/
  execute procedure TAR_INPUT_RES_CUSTOMPRICE$INT(:id_tar_calc);

  execute procedure TAR_INPUT_ISSTATICK$INT(:id_tar_calc);
end
^

/* Alter (TAR_CALC_INPUT_GUEST$INT) */
ALTER PROCEDURE TAR_CALC_INPUT_GUEST$INT(ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
G_DBKEY CHAR(8),
ID_RATE_OVERRULE INTEGER,
REAL_RECALC INTEGER)
 AS
declare variable adult_def_age integer;
  declare variable child_def_age integer;
begin
  adult_def_age = 30;
  child_def_age = 9;

  insert into TAR_CALC_INPUT$TMP (ID_TAR_CALC, ROOM_STATUS, ID_GUEST,
         GUEST_AGE, FROM_DATE, TO_DATE, REAL_RECALC,
         FROM_DATE_CALC, TO_DATE_CALC,
         VOUCHER_NUM, VOUCHER_DATE, VOUCHER_TEXT, IS_CHILD, GUEST_SEX,
         COUNTRY_CODE, ID_BASE_ACCOUNT, IS_LATE_CHECKOUT, ID_GROUP, ID_AGENT_PROFILE,
         ID_GUEST_TYPE, ID_RESERV, PACKET_ITEMS, ID_RATE_OVERRULE)
  select :id_tar_calc, :room_status, G.ID_GUEST,
         coalesce(coalesce(GD.RATING_AGE, CA.AGE_INYEARS), iif(G.IS_CHILD = 1, :child_def_age, :adult_def_age)),
         G.FROM_DATE, G.TO_DATE, :real_recalc,
         G.FROM_DATE,  G.TO_DATE-1,
         coalesce(G.VAUCHER_NUM, g.ID_GUEST), g.VAUCHER_DATE, g.VAUCHER_TEXT, g.IS_CHILD, pd.SEX,
         pd.COUNTRY_CODE, g.ID_BASE_ACCOUNT, rd.LEAVING_KIND - 1, rd.ID_GROUP, rd.ID_AGENT_PROFILE,
         pp.ID_GUEST_TYPE, g.ID_RESERV_DETAIL, (select '~'||list(gp.ID_PACKET_ITEM, '~')||'~' --list(p.PACKET_ITEM_TAG)
                                                from   GUEST_PACKET gp
                                                       join PACKET_ITEM p on p.ID_PACKET_ITEM = gp.ID_PACKET_ITEM
                                                where  gp.ID_GUEST = g.ID_GUEST),
         :ID_RATE_OVERRULE
  from   GUEST G
         left join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
         left outer join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
         left outer join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
         left outer join PROFILE_PERSON PP on pp.ID_PERSON_DATA = pd.ID_PERSON_DATA
         left outer join SYSTEM_CALC_AGE_INYEARS(PD.BIRTH_DAY, G.FROM_DATE) CA on 0=0
  where  G.RDB$DB_KEY = :g_dbkey;
end
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE for: TAR_SAVE_BO_PACK */
ALTER PROCEDURE TAR_SAVE(ID_TAR_HEAD INTEGER,
PERIOD_DEPEND_ON_CHECKIN INTEGER,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BASE_BOARDS_LIST VARCHAR(255),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
BO_TYPE VARCHAR(20),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_SAVE_BO_PACK) */
ALTER PROCEDURE TAR_SAVE_BO_PACK(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_pack integer;
  declare variable pos_numbers varchar(2000);
  declare variable id_service integer;
  declare variable day_scheme varchar(20);
  declare variable day_scheme_num integer;
  declare variable cnt_post integer;
  declare variable pack_currency char(3);
  declare variable in_base_price integer;
  declare variable grp_rpt varchar(20);
  declare variable grp_docs varchar(20);
  declare variable price_type varchar(20);
  declare variable price_pack varchar(20);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      if (:price_pack = '') then err_code = -216;
      if (:id_service is null) then err_code = -217;
      if (:err_code < 0) then exit;
      insert into TAR_BO_PACK(
        ID_TAR_PACK, ID_TAR_HEAD, ID_SERVICE, PRICE_CURRENCY, IS_IN_BASE_PRICE,
        CNT_POST,  DAY_SCHEME, DAY_SCHEME_NUM, GRP_IN_REPORTS,
        GRP_IN_DOCUMENTS, PTEXT, PACKET_ITEM, DISC_TAG, SET_VAR, RND_METHOD)
      values (
        :id_tar_pack, :id_tar_head, :id_service, :pack_currency, :in_base_price,
        :cnt_post, :day_scheme, :day_scheme_num, :grp_rpt,
        :grp_docs, :ptext, :packet_item, :disc_tag, :set_var, :rnd_method);
      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_pack, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_pack = gen_id(GEN_TAR_BO_PACK_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers   = '';
      id_service    = null;
      day_scheme     = 'EVERY';
      day_scheme_num = 1;
      cnt_post      = 0;
/*
        select TH.TARIFA_CURR
        from   TAR_HEAD TH
        where  TH.ID_TAR_HEAD = :id_tar_head
        into   :pack_currency;
*/    pack_currency = '';
      in_base_price = 0;
      grp_rpt       = '';
      grp_docs      = '';
      price_pack    = '';
      ptext         = '';
      disc_tag      = '';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      packet_item   = null;
    end
    if (:param_name = 'SERVICE') then begin
      if ((:data = '') or (:data = '-1')) then err_code = -217;
      else if (:data = '0') then err_code = -222;
      else id_service = :data;
    end else if (:param_name = 'CNT_POST')  then cnt_post      = :data;
    else if (:param_name = 'IN_BASE_PRICE') then in_base_price = :data;
    else if (:param_name = 'GRP_RPT')       then grp_rpt       = :data;
    else if (:param_name = 'GRP_DOCS')      then grp_docs      = :data;
    else if (:param_name = 'PTEXT')         then ptext         = :data;
    else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
    else if (:param_name = 'SET_VAR')        then set_var = :data;
    else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
    else if (:param_name = 'PACKET_ITEM')   then packet_item   = :data;
    else if (:param_name = 'PRICE')         then begin
      price_pack    = :data;
      if (:price_pack = '') then err_code = -216;
      else
        execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_pack, :bo_type, -1)
        returning_values  :err_code, :no_use, :price_type;
    end else if (:param_name = 'LIST_BASE_POS') then pos_numbers   = :data;
    else if (:param_name = 'CURRENCY') then begin
      if ((:data <> upper(:data)) or (char_length(:data) <> 3)) then err_code = -218;
      else pack_currency = :data;
    end else if (:param_name = 'DAY_SCHEME') then begin
      execute procedure TAR_SAVE_PARSE_DAYSCHM(:data)
      returning_values  :err_code, :day_scheme, :day_scheme_num;
    end else if (:param_name = 'CHECKIN_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end else if (:param_name = 'NIGHT_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end
    if (:err_code < 0) then exit;
  end
  when any do begin
    err_code = -200;
/*    err_text = ' '||:id_service||' '||:pack_currency||' '||:in_base_price;*/
/*    err_text = ' '||:day_scheme||' '||:day_scheme_num;*/
    err_text = ' '||:cnt_post||' '||:grp_rpt||' '||:grp_docs||' '||:ptext;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
  end
end
^

/* Alter (TAR_SAVE_BO_SEASON) */
ALTER PROCEDURE TAR_SAVE_BO_SEASON(ID_TAR_HEAD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable delim integer;
  declare variable id_dim2 integer;
  declare variable id_season integer;
  declare variable from_date date;
  declare variable to_date date;
  declare variable idate date;
begin
  err_code = 0;
  execute procedure SETTING_GET_VALUE('RANGE_DATA_DELIMETER', null)
  returning_values  :delim;
  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, 'SEASON') TSP
    into    :param_name, :row_id, :id_dim2, :data, :col_id
  do begin
    if (:param_name = 'NAME') then begin
      id_season = gen_id(GEN_TAR_BO_SEASON_ID, 1);
      insert into TAR_BO_SEASON(ID_TAR_SEASON, ID_TAR_HEAD, SEASON_NAME, ID_DIM2)
      values (:id_season, :id_tar_head, :data, :id_dim2);
    end else if ((:param_name = 'PERIOD') and (:data <> '')) then begin
      from_date = null; to_date =null;
      for
        select SPD.ITEM
        from   SYSTEM_STRING_PARSER(:data, f_character(:delim)) SPD
        into   :idate
      do begin
        if (:from_date is null) then from_date = :idate;
        else to_date = :idate;
      end
      /* CHECK VALIDITY */
      if (exists(
        select *
        from   TAR_BO_SEASON TBS
               join TAR_BO_SEASON_PERIOD TSP
                 on TSP.ID_TAR_SEASON = TBS.ID_TAR_SEASON
        where  TBS.ID_TAR_HEAD = :id_tar_head
               and TSP.FROM_DATE <= :to_date
               and TSP.TO_DATE >= :from_date
      )) then begin
        err_code = -201;
        exit;
      end
      insert into TAR_BO_SEASON_PERIOD (ID_TAR_SEASON, FROM_DATE, TO_DATE)
      values (:id_season, :from_date, :to_date);
    end
  end
  when any do begin
    err_code = -200;
    err_text = :data;
    err_text = 'OBJECT='||'SEASONS'||', '||:err_text;
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_BO_BOARD for: TAR_SAVE_PARSE */
ALTER PROCEDURE TAR_SAVE_BO_BOARD(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_BO_BP for: TAR_SAVE_PARSE */
ALTER PROCEDURE TAR_SAVE_BO_BP(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_BO_DISC for: TAR_SAVE_PARSE */
ALTER PROCEDURE TAR_SAVE_BO_DISC(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_BO_DISC_PERIOD for: TAR_SAVE_PARSE */
ALTER PROCEDURE TAR_SAVE_BO_DISC_PERIOD(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_BO_EG for: TAR_SAVE_PARSE */
ALTER PROCEDURE TAR_SAVE_BO_EG(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_BO_PACK for: TAR_SAVE_PARSE */
ALTER PROCEDURE TAR_SAVE_BO_PACK(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_BO_SEASON for: TAR_SAVE_PARSE */
ALTER PROCEDURE TAR_SAVE_BO_SEASON(ID_TAR_HEAD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_SAVE_PARSE) */
ALTER PROCEDURE TAR_SAVE_PARSE(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(COL_NAME VARCHAR(20),
ROW_ID INTEGER,
COL_ID INTEGER,
DATA VARCHAR(2000),
ID_TAR_SEASON INTEGER,
END_OF_LINE INTEGER)
 AS
declare variable icol integer;
  declare variable id_dim2 integer;
  declare variable is_system integer;
  declare variable id_record integer;
  declare variable table_width integer;
  declare variable dynamic_filter varchar(2000);
  declare variable value_interface varchar(2000);
begin
  select count(*)
  from   TAR_UI_DEFINE_COLUMNS TDC
  where  TDC.ID_TAR_HEAD = :id_tar_head
         and TDC.TAR_BUSINESS_OBJECT = :bo_type
  into   :table_width;
  icol = 0;
  dynamic_filter = '(1=1)';
  end_of_line = 0;
  for
    select   TDC.TAR_BUSINESS_OBJECT, TDR.ORDER_ROW_TAG, TDC.TAR_PARAM, TDR.VALUE_FORMULA,
             TDR.VALUE_INTERFACE, TP.IS_SYSTEM, TDC.ID_DIM2, TDR.ID_TAR_DEFINE_RECORD, TDC.ORDER_COL_TAG
    from     TAR_UI_DEFINE_COLUMNS TDC
             join TAR_UI_DEFINE_RECORDS TDR
               on TDR.ID_COLUMN = TDC.ID_TAR_DEFINE_COLUMN
             join TAR_UI_PARAMS TP
               on TP.INTERNAL_PARAM_NAME = TDC.TAR_PARAM
    where    TDC.ID_TAR_HEAD = :id_tar_head
             and TDC.TAR_BUSINESS_OBJECT = :bo_type
    order by TDC.TAR_BUSINESS_OBJECT asc, TDR.ORDER_ROW_TAG asc, TDC.ID_DIM2 asc, TP.IS_SYSTEM desc, TDC.ORDER_COL_TAG asc
    into     :bo_type, :row_id, :col_name, :data,
             :value_interface, :is_system, :id_dim2, :id_record, :col_id
  do begin
--    data = trim(:data);
    icol = :icol + 1;
    if (:data is null) then data = '';
    if (:is_system = 2) then begin
      id_tar_season = -1;
      if (trim(:data) <> '') then dynamic_filter = dynamic_filter||' and ('||:data||')';
      data = SUBSTR(:value_interface, 1, STRPOS(';', :value_interface)-1);
--      data = substring(:value_interface from 1 for STRPOS(';', :value_interface)-1);
      if (trim(:data) = '') then data = null;
      suspend;
    end else if (:is_system = 1) then begin
      if (:id_dim2 <> -1) then begin
        id_tar_season = null;
        select  TBS.ID_TAR_SEASON
        from    TAR_BO_SEASON TBS
        where   TBS.ID_DIM2 = :id_dim2
        into    :id_tar_season;
      end else ID_TAR_SEASON = -1;
      if (:bo_type = 'SEASON') then ID_TAR_SEASON = :id_record;
      /* THIS BO RECIEVES DIFFERENT VALUES FOR ID_TAR_SEASON !!! */
      suspend;
    end else if (trim(:data) <> '') then dynamic_filter = dynamic_filter||' and ('||:data||')';
    if (:icol = :table_width) then begin
      col_name = 'DYN_FILTER';
      data = :dynamic_filter;
      id_tar_season = -1;
      end_of_line = 1;
      suspend;
      row_id = :row_id + 1;
      end_of_line = 0;
      icol = 0;
      dynamic_filter = '(1=1)';
    end else end_of_line = 0;
  end
end
^

/* Alter (TAR_TEST$TAR) */
ALTER PROCEDURE TAR_TEST$TAR(NUMBER VARCHAR(62),
ID_TAR_HEAD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_reserv_detail integer;
begin
  id_tar_calc = -1 * :id_tar_head;
  delete from TAR_CALC_OUTPUT$TMP where id_tar_calc = :id_tar_calc;
  delete from TAR_CALC_INPUT$TMP  where id_tar_calc = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP  where id_tar_calc = :id_tar_calc;

  err_code = 0;

  id_reserv_detail = null;
  select RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.NUMBER = :number
  into   :id_reserv_detail;

  if (:id_reserv_detail is null) then begin
    select first 1 RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.NUMBER_2 = :number
    into   :id_reserv_detail;
  end

  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NEW_ROOM', :ID_TAR_HEAD);

  execute procedure TAR_CALC_EVAL_ALL$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_PARAMS$INT for: TARIFA_GET_PARAM */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TARIFA_GET_PARAM) */
ALTER PROCEDURE TARIFA_GET_PARAM(ID_PARAM INTEGER,
FOR_DATE DATE,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER)
 RETURNS(OUT_VALUE VARCHAR(255))
 AS
declare variable is_interface integer;
  declare variable param_code varchar(30);
  declare variable is_value integer;
  declare variable int1 integer;
  declare variable data_type varchar(10);
  declare variable pvalue varchar(20);
  declare variable from_ date;
  declare variable to_ date;
begin
  select TP.IS_INTERFACE, TP.PARAM_CODE, TP.IS_VALUE, TP.DATA_TYPE, TP.PVALUE
  from   TARIFA_PARAMS TP
  where  ID_TARIFA_PARAM = :ID_PARAM 
  into   :is_interface, :param_code, :is_value, :data_type, :pvalue;
  /*get interface params*/
  if (:PARAM_CODE = 'NATION2') then
    PARAM_CODE = 'NATION'; /* !!!!!!!!!! */

  /*get value params*/
  if (:IS_VALUE = 1) then
    OUT_VALUE = :pvalue;

  /*get internal params*/
  OUT_VALUE = null;
  if (:IS_INTERFACE = 0) then begin
    if (:PARAM_CODE = 'TODAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE, 'D;dd/mm/yyyy');

    end else if (:PARAM_CODE = 'WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE, 'DW;MON');

    end else if (:PARAM_CODE = 'NEXT_DATE_WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE + 1, 'DW;MON');

    end else if (:PARAM_CODE = 'PREV_DATE_WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE - 1, 'DW;MON');

    end else if (:PARAM_CODE = 'REQUIRED_WEEK_DAYS') then begin
      select maxdate(ti.FROM_DATE, :FOR_DATE -3), mindate(ti.TO_DATE -1, :FOR_DATE +3)
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :from_, :to_;
      
      for
        select formatdate(RLP.OUT_DATE, 'DW;MON')
        from   SYSTEM_LOOP_PERIOD(:from_, :to_) RLP
        into   :int1
      do OUT_VALUE = :OUT_VALUE||','||:int1;

    end else if (:PARAM_CODE = 'ARRIVAL_WEEK_DAYS') then begin
      select formatdate(ti.FROM_DATE, 'DW;MON')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'PRESTOI') then begin
      select cast(ti.TO_DATE - ti.FROM_DATE as integer)
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'FROM_DATE') then begin
      select formatdate(ti.FROM_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TO_DATE') then begin
      select formatdate(ti.TO_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'DAYS_PASSED') then begin
       /* 01  03 -  01-1, 02-2   (        )*/   
       select cast((:FOR_DATE - G.FROM_DATE + 1) as integer)
       from   TAR_CALC_INPUT$TMP G
       where  G.ID_TAR_INPUT = :ID_TAR_INPUT
       into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'DAYS_TO_STAY') then begin
       /* 01  03 -  01-2, 02-1    (  )*/
       select cast((G.TO_DATE - :FOR_DATE - 1) as integer)
       from   TAR_CALC_INPUT$TMP G
       where  G.ID_TAR_INPUT = :ID_TAR_INPUT
       into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_GUESTS') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_CHILDREN') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.IS_CHILD = 1
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_ADULTS') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.IS_CHILD is distinct from 1
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_GUESTS_BY_ACCOUNT') then begin
      select (select count(*)
              from   GUEST G
                     join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
              where  G.ID_BASE_ACCOUNT = ti.ID_BASE_ACCOUNT
                     and G.FROM_DATE <= :FOR_DATE
                     and G.TO_DATE > :FOR_DATE
                     and RD.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP ti
      where  ti.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TYPE_ROOM') then begin
      select rt.TYPE_ROOM
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join ROOM_TYPES RT on RT.ID_ROOM_TYPE = tid.ID_ROOM_TYPE
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
      into   :OUT_VALUE;
      /* TO PRESEVE COMPATIBILITY WITH OLD TARIFF VERSIONS */
      /* WE HAVE TO RETURN THE NAME NOT THE ID !           */

    end else if (:PARAM_CODE = 'TYPE_STAY') then begin
      select ts.TYPE_STAY
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join TYPE_STAY TS on ts.ID_TYPE_STAY = tid.ID_TYPE_STAY
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TYPE_HRANA') then  begin
      select m.NAME
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join MEALS m on m.ID_BOARD = tid.ID_BOARD
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;
      OUT_VALUE = trim(coalesce(:OUT_VALUE, ''));

    end else if (:PARAM_CODE = 'PACK_ITEMS') then begin
      OUT_VALUE = null;
      select TID.PACKET_ITEMS
      from   TAR_CALC_INPUT$TMP TID
      where  TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;
      OUT_VALUE = coalesce(:OUT_VALUE, '~~');
      -- strfloateval('POS("~2~", :PACK_ITEMS)>0', ';:PACK_ITEMS,STRING,~2~3~D~')

    end else if (:PARAM_CODE = 'AGE') then begin
      select ti.GUEST_AGE
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_SEX') then begin
      select G.GUEST_SEX
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE ;
      if ((:OUT_VALUE is null) or (:OUT_VALUE = '')) then OUT_VALUE = '-' ;

    end else if (:PARAM_CODE = 'NATION') then begin
      select tid.COUNTRY_CODE
      from   TAR_CALC_INPUT$TMP TID
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_FIRST_DATE') then begin
      select cast(iif(G.FROM_DATE = :FOR_DATE, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_LAST_DATE') then begin
      select cast(iif(G.TO_DATE -1 = :FOR_DATE, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_LATE_CHECKOUT') then begin
      select g.IS_LATE_CHECKOUT
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_FIRST_GUEST_IN_ROOM') then begin
      select (select count(ti.ID_TAR_INPUT)
              from   TAR_CALC_INPUT$TMP ti
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and ti.ID_GUEST < t.ID_GUEST)
      from   TAR_CALC_INPUT$TMP t
      where  t.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :int1;

      if (:int1 = 0) then OUT_VALUE = 1; else OUT_VALUE = 0;
      
    end else if (:PARAM_CODE = 'IS_DIFER_NATIONS') then begin
      select (select cast(iif(count(distinct ti.COUNTRY_CODE) > 1, 1, 0) as integer)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_GROUP') then begin
      select cast(iif(g.ID_GROUP is not null, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_NIGHTS_BY_ACCOUNT') then begin
      /*          . */
      select (select cast(sum (G_IN_R.TO_DATE - G_IN_R.FROM_DATE) as integer)
              from   GUEST G_IN_R
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_R.ID_RESERV_DETAIL
              where  G_IN_R.ID_BASE_ACCOUNT = G.ID_BASE_ACCOUNT
                     and G_IN_R.CHECK_STATUS = 0
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_INTURN_BYACCOUNT') then begin
      select (select cast(count(G.ID_GUEST) as integer)
              from   GUEST G
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL and rd.IS_ANUL = 0
              where  G.ID_BASE_ACCOUNT = t.ID_BASE_ACCOUNT
                     and G.ID_GUEST <= t.ID_GUEST)
      from   TAR_CALC_INPUT$TMP t
      where  t.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'PAX_PRICE_WO_ADDINS') then begin
      /*             */
      /* PRICE_ORIG          */
      -- ?????    ???
      /*select  max(AP.PRICE_ORIG)
      from    ACCOUNT_POST AP 
      where   AP.ID_GUEST = :ID_GUEST
              and AP.DATE_POST = :FOR_DATE
              and AP.IS_BASE = 1
      plan    (AP index (ACCOUNT_POST_IDX6))
      into    :OUT_VALUE;
      */
      OUT_VALUE = null;

    end else if (:PARAM_CODE = 'ROOM_FEATURES') then begin
      select substring(R.FEATURES from 1 for 255)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join ROOMS R on r.ID_ROOM = tid.ID_ROOM
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_NIGHTS') then begin
      select (select cast(sum (G_IN_V.TO_DATE - G_IN_V.FROM_DATE) as integer)
              from   GUEST G_IN_V
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_V.ID_RESERV_DETAIL
              where  rd.ID_AGENT_PROFILE is not distinct from G.ID_AGENT_PROFILE
                     and G_IN_V.VAUCHER_NUM = G.VOUCHER_NUM
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE ;

    end else if (:PARAM_CODE = 'VAUCHER_GUESTS') then begin
      select (select count (G_IN_V.ID_GUEST)
              from   GUEST G_IN_V
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_V.ID_RESERV_DETAIL and rd.IS_ANUL = 0
              where  rd.ID_AGENT_PROFILE is not distinct from G.ID_AGENT_PROFILE
                     and G_IN_V.VAUCHER_NUM = G.VOUCHER_NUM
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_DATE') then begin
      select formatdate(G.VOUCHER_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_TEXT') then begin
      select G.VOUCHER_TEXT
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_INTURN_BYROOM') then begin
      select (select count(*)
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_GUEST <= t.ID_GUEST)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'ADULT_INTURN_BYROOM') then begin
      OUT_VALUE = 0;
      select (select count(*)
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_GUEST <= t.ID_GUEST
                     and ti.IS_CHILD = 0)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
             and t.IS_CHILD = 0
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'CHILD_INTURN_BYROOM') then begin
      OUT_VALUE = 0;
      select (select count(*)
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_GUEST <= t.ID_GUEST
                     and ti.IS_CHILD = 1)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
             and t.IS_CHILD = 1
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_TYPE') then begin
      select G.ID_GUEST_TYPE
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else begin
      exception RATING_EXCEPTION 'Unsupported param - '||:PARAM_CODE;
    end

  end /*PART OF INTERNAL PARAMS*/


  /**********************************************/
  begin
    /* the source of the next check is gone with the wind
    /* but we must distinguish different data types */
    if ((:OUT_VALUE is null) or (:OUT_VALUE = '')) then begin
      /*not allow nulls*/
      if (:DATA_TYPE = 'DATE') then OUT_VALUE = '01/01/1899';
      else OUT_VALUE = '-1';  -- Unspecified
    end else if (:DATA_TYPE = 'INTEGER') then begin
      OUT_VALUE = cast(:OUT_VALUE as integer);
      /* to prevent errors like OUT_VALUE = '00001' */
    end

    when any do exception RATING_EXCEPTION 'Unsupported param value: ' || :param_code || ' = "' || coalesce(:OUT_VALUE, '<null>') || '"';
  end
  /**********************************************/
end
^

/* Alter (TEST_DOC) */
ALTER PROCEDURE TEST_DOC(ID_ACCOUNT INTEGER,
DOC_SELECTED INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER)
 AS
declare variable is_dep_doc integer;
  declare variable id_hotel integer;
  declare variable dummy varchar(255);
begin
  is_dep_doc = 0;

  execute procedure DOCUMENT_INITIALIZE$DOC (:id_account, :doc_selected, null)
  returning_values (:id_doc_head, :id_hotel, :dummy);

  execute procedure DOCUMENT_ADD_DEF_PAYMENT$DOC (:id_doc_head, null);

  execute procedure DOCUMENT_VALIDATE$DOC (:id_doc_head)
  returning_values :dummy, :dummy, :dummy;
  suspend;
end
^

/* Alter (TEST_RATING) */
ALTER PROCEDURE TEST_RATING RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
declare variable from_date date;
 declare variable to_date date;
 declare variable hotels varchar(255);
begin
  from_date = '01.01.2010';
  to_date = '08.01.2010';
  hotels = '2';

  execute procedure AVAILABILITY_OCCUPANCY$INT (:from_date,  :from_date + 30, 1, 0, 1, 1, 0, 0, 0, :hotels);

  execute procedure AVAILABILITY_OCCUPANCY_OPT$INT (0, 0, 1, 1, 0, 0, 0);

  execute procedure AVAILABILITY_RATING$AVL (null, :from_date, :to_date, 2,
          2, 0, '33,31,55,30,32,54,62,59,71,72', '2301,2210,2347,1633,2300,2342,2353,2362', '6,0,8,7,22,21,23', :hotels)
  returning_values (:ID_OCCUPANCY_SESSION);

end
^

/* Restore proc. body: ACCOUNT_JOIN_IN_ONE_BY_STRING */
ALTER PROCEDURE ACCOUNT_JOIN_IN_ONE_BY_STRING(IN_TARGET_ID_ACCOUNT INTEGER,
IN_SOURCE_STRING VARCHAR(1000))
 AS
declare variable source_id_account integer;
  declare variable id_deposit integer;
  declare variable avail_value numeric(15,4);
  declare variable dbg varchar(1000);
  declare variable description varchar(100);
  declare variable doc_selected integer;
begin

  for
    select cast(ITEM as integer)
    from   SYSTEM_STRING_PARSER(:IN_SOURCE_STRING, 'x')
    into   :source_id_account
  do begin
    if (:source_id_account <> :in_target_id_account) then begin
      doc_selected = gen_id(DOC_SELECTED_GEN, 1);
      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :doc_selected
      where  AP.ID_ACCOUNT =  :source_id_account
             and AP.AC = '00'
             and AP.ID_BASE_DOC is null;

      /* call next procedure because of logging */
      execute procedure ACCOUNT_POSTING_TRANSFER$ACC(:doc_selected, :in_target_id_account, :source_id_account);

      for
        select DA.ID_DEPOSIT, DA.AVAIL_VALUE, DA.DESCRIPTION
        from   DEPOSIT_AVAILABLE DA
        where  DA.ID_ACCOUNT = :source_id_account
        into   :id_deposit, :avail_value, :description
      do begin
        execute procedure DEPOSIT_TRANSFER$ACC (:id_deposit, :in_target_id_account, :avail_value, :description)
        returning_values  :dbg;
      end 
    end
  end
end
^

/* Restore proc. body: ACCOUNT_POST_EVENT_REROUTE$INT */
ALTER PROCEDURE ACCOUNT_POST_EVENT_REROUTE$INT(AP_DBKEY TYPE OF TDB_KEY,
ID_DEST_ACCOUNT TYPE OF ID)
 AS
declare variable new_id_pms_event integer;
  declare variable id_room integer;
  declare variable id_owner_dest integer;
  declare variable date_post date;
  declare variable price_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable id_account_post integer;
  declare variable id_pms_event integer;
  declare variable id_room_contract integer;
begin

  id_owner_dest = null;
  select ACC.ID_PROFILE
  from   ACCOUNT ACC
  where  ACC.ID_ACCOUNT = :ID_DEST_ACCOUNT
         and ACC.IS_PMS_ACCOUNT = 1
  into   :ID_OWNER_DEST;

  id_pms_event = null;
  select PP.ID_PMS_EVENT
  from   ACCOUNT_POST AP
         join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
         join PMS_EVENT$PMS E on E.ID_PMS_EVENT = PP.ID_PMS_EVENT
  where  AP.RDB$DB_KEY = :AP_DBKEY
         and E.EVENT_STATUS < 22
  into   :ID_PMS_EVENT;

  if ((:ID_OWNER_DEST is null) and (:ID_PMS_EVENT is not null)) then begin
    delete from PMS_EVENT_POST PP
    where PP.ID_PMS_EVENT = :id_pms_event;

    delete from PMS_EVENT$PMS PP
    where PP.ID_PMS_EVENT = :id_pms_event;
  end

  if ((:ID_OWNER_DEST is not null) and (:ID_PMS_EVENT is not null)) then begin
    update PMS_EVENT$PMS E
    set    E.ID_OWNER = :ID_OWNER_DEST
    where  E.ID_PMS_EVENT = :ID_PMS_EVENT;

    update PMS_EVENT_POST PP
    set    PP.ID_OWNER = :ID_OWNER_DEST
    where  PP.ID_PMS_EVENT = :ID_PMS_EVENT;
  end

  if ((:ID_OWNER_DEST is not null) and (:ID_PMS_EVENT is null)) then begin
    select nullif(AP.ID_ROOM, -1), AP.DATE_POST, AP.PRICE_ORIG, AP.CURR_ORIG, AP.ID_ACCOUNT_POST
    from   ACCOUNT_POST AP
    where  AP.RDB$DB_KEY = :AP_DBKEY
    into   :id_room, :date_post, :price_orig, :curr_orig, :id_account_post;

    id_room_contract = null;
    select rc.ID_ROOM_CONTRACT
    from   ROOM_PERIOD$PMS rp
           join ROOM_CONTRACT$PMS rc on rc.ID_ROOM_PERIOD = rp.ID_ROOM_PERIOD
    where  rp.FROM_DATE <= :date_post
           and rp.TO_DATE >= :date_post
           and rp.ID_ROOM = :id_room
    into   :id_room_contract;

    -- ????? if (:id_room_contract is not null) then
    execute procedure PMS_EVENT_CREATE$INT('MANUAL_EXPENSE', :ID_ROOM, :ID_OWNER_DEST, 'ACCOUNT POST TRANSFER',
            :DATE_POST, null, null, null, null, :PRICE_ORIG, :PRICE_ORIG, :CURR_ORIG, null, :id_room_contract)
    returning_values :new_id_pms_event;

    insert into PMS_EVENT_POST (ID_PMS_EVENT, ID_ACCOUNT_POST, ID_OWNER, LINE_STATUS)
    values (:new_id_pms_event, :ID_ACCOUNT_POST, :ID_OWNER_DEST, 11);

    execute procedure PMS_EVENT_SET_ACTIVE$INT(:new_id_pms_event);
  end

end
^

/* Restore proc. body: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER)
 AS
declare variable id_current_account integer;
  declare variable id_service integer;
  declare variable is_anul integer;
  declare variable id_tariff integer;
  declare variable qty_post numeric(15,2);
  declare variable qty_free numeric(15,2);
  declare variable price_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable id_room integer;
  declare variable id_base_doc integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  if ((:AP_DBKEY is null) or (:id_target_account is null) or (:id_target_account < 0)) then
     exception POSTING_TRANSFER_EXCEPTION '-31';

  select AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST, AP.QTY_FREE,
         AP.PRICE_ORIG, AP.CURR_ORIG, AP.RATE_ORIG, ap.from_date, ap.to_date,
         AP.IS_ANUL, AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_BASE_DOC, A.ID_HOTEL
  from   ACCOUNT_POST AP
         left join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :id_service, :id_tariff, :id_room, :qty_post, :qty_free,
         :price_orig, :curr_orig, :rate_orig, :from_date, :to_date,
         :is_anul, :id_account_post, :id_current_account, :id_base_doc, :id_hotel;

  if (:id_current_account = :id_target_account) then EXIT;

  if (:is_anul = 1 ) then exception POSTING_TRANSFER_EXCEPTION '-33';

  if (:id_base_doc is not null) then exception POSTING_TRANSFER_EXCEPTION '-32';

  if (not exists(select A.ID_ACCOUNT
                 from   ACCOUNT A
                 where  A.ID_ACCOUNT = :ID_TARGET_ACCOUNT
                        and A.ID_HOTEL = :id_hotel)) then exception POSTING_TRANSFER_EXCEPTION '-376';

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
                    :id_tariff, :id_room, :qty_post, :qty_free, :price_orig, :curr_orig,
                    :rate_orig, 'TRANSFER_POSTING', null, :from_date, :to_date, 0, :id_target_account)
  returning_values  :no_use, :no_use, :no_use;

  insert into ACCOUNT_TRANSFER_HISTORY(ID_ACCOUNT_POST, FROM_ID_ACCOUNT, TO_ID_ACCOUNT)
  values (:id_account_post, :id_current_account, :id_target_account);
end
^

/* Restore proc. body: ACCOUNT_POSTING_UPDATE */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable in_db_key char(8);
begin
  /* GUI facade for manual update */
  select AP.ID_ACCOUNT, AP.ID_GUEST, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :id_guest, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date)
  returning_values  (:new_qty_post, :new_price_post, :new_ac);

  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    if (coalesce(:id_guest, 0) > 0) then begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || :id_account
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'POST_UPDATE', :action_text);
    end else begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
    end
  end

end
^

/* Restore proc. body: APPLY_BOOKING_STATUS$EXC */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20)
 AS
declare variable err_text varchar(255);
declare variable dummy_int integer;
declare variable anul_reason varchar(30);
declare variable selection_id integer;

declare variable status_code smallint;
declare variable current_anul_code smallint;
declare variable current_status_code smallint;
declare variable current_status_text varchar(50);
declare variable new_status_text varchar(50);
declare variable extra_posts_left integer;
begin
  if (:booking_db_key is null) then begin
    select rd.RDB$DB_KEY, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.ID_RESERV_DETAIL = :BOOKING_ID
    into   :booking_db_key, :current_status_code, :current_anul_code;
  end else begin
    select rd.id_reserv_detail, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.rdb$db_key = :booking_db_key
    into   :booking_id, :current_status_code, :current_anul_code;
  end

  execute procedure IMPORT_BOOKING_STATUS$EXC(:status, -2)
  returning_values :status_code;

  execute procedure EXPORT_BOOKING_STATUS$EXC(:current_status_code, :current_anul_code)
  returning_values :current_status_text;
  execute procedure IMPORT_BOOKING_STATUS$EXC(:current_status_text, :current_status_code)
  returning_values :current_status_code;

  /* nop - exit */
  if (:current_status_code = :status_code) then exit;

  /* validate status transition */
  if (
     /* terminal status values - void booking */
    (:current_status_code in (1004/*no show*/, 1005/*canceled*/))

    /* void over checkin */
    or ((:current_status_code >= 0) and (:status_code in (1004/*no show*/, 1005/*canceled*/)))

    /* positive status downgrade */
    or ((:current_status_code > 0) and (:current_status_code > :status_code))
  )  then begin
    execute procedure PRINT_BOOKING_STATUS$EXC(:current_status_code) returning_values :current_status_text;
    execute procedure PRINT_BOOKING_STATUS$EXC(:status_code) returning_values :new_status_text;

    exception VALIDATE_EXCEPTION '-1022' || f_character(31) || '@{invalid_status_transition} ' || :current_status_text || ' -> ' || :new_status_text;
  end

  anul_reason = null;
  if (1004 = :status_code) then begin
    anul_reason = 'NOSHOW';
  end else if (1005 = :status_code) then begin
    anul_reason = 'CANCELED';
  end

  if (:anul_reason is null) then begin
    if (0 > :status_code) then begin
      execute procedure RES_SAVE_STATUS$INT(:booking_db_key, :status_code, :CONFIRMATION_NUMBER);
    end else begin
      if (:status_code in (0, 1) and 0 > :current_status_code) then begin
        -- checkin
        execute procedure RES_SET_CHECKIN$INT (:booking_db_key)
        returning_values (:dummy_int, :err_text, :dummy_int, :dummy_int);
      end
      if (1 = :status_code and 1 > :current_status_code) then begin
        -- checkout
        selection_id = gen_id(SELECTION_GEN, 1);
        update RESERV_DETAIL
        set    selection_id=:selection_id
        where  rdb$db_key=:booking_db_key;
    
        execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id);
      end
    end
  end else begin
    -- void
    execute procedure RES_ANUL_DETAIL$INT(:booking_db_key, :anul_reason, :CANCELATION_NUMBER)
    returning_values  :dummy_int, :extra_posts_left;
    if (:extra_posts_left = 1) then exception BOOKING_EXCEPTION '-1042';

  end
end
^

/* Restore proc. body: AVAILABILITY_OCCUP_PREPARE$AVL */
ALTER PROCEDURE AVAILABILITY_OCCUP_PREPARE$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS INTEGER,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
begin

  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, :FETCH_TOTALS, 1, 1, 1, 1, 1, 1, :HOTELS);
   
  execute procedure AVAILABILITY_OCCUPANCY_OPT$INT (:RELEASE_DATES, :OVERBOOK,
          :RES_CONFIRMED, :RES_NOTCONFIRMED, :RES_WAITING, :BOOKING_POSITIONS, :CONTINGENT);

end
^

/* Restore proc. body: AVAILABILITY_OCCUPANCY$AVL */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
begin

  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, :FETCH_TOTALS, 1, 1, 1, 1, 1, 1, :HOTELS);

  ID_OCCUPANCY_SESSION = current_transaction;
end
^

/* Restore proc. body: AVAILABILITY_OCCUPANCY$INT */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$INT(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
declare variable id_global_agent integer;
  declare variable for_date date;
  declare variable id_agent integer;
  declare variable id_room_type integer;
  declare variable g_capacity integer;
  declare variable bp_defined integer;
  declare variable c_defined integer;
  declare variable fdata integer;
  declare variable bp_is_released integer;
  declare variable c_is_released integer;
  declare variable gsts_in_house integer;
  declare variable gsts_come integer;
  declare variable gsts_gone integer;
  declare variable rooms_come integer;
  declare variable rooms_gone integer;
  declare variable id_hotel integer;
  declare variable id_b_allotment integer;
  declare variable id_c_allotment integer;
  declare variable ooo_rooms integer;
  declare variable ooi_rooms integer;
  declare variable sold_rooms integer;
  declare variable res_room_conf integer;
  declare variable res_room_notconf integer;
  declare variable res_room_wait integer;
begin
  /*  Description:   */
  HOTELS = coalesce(:HOTELS, '');
  ID_GLOBAL_AGENT = -100; /* HOLDS DATA GLOBAL FOR THE HOTEL */

  delete from SMART_OCCUP$TMP;

  for
    select RC.ID_ROOM_TYPE, RC.ID_HOTEL, RC.FOR_DATE, sum(RC.CNT_DEFINED)
    from   HOTEL_S H
           left outer join ALLOTMENT_GET$INT(H.ID_INVENTORY_ALLOTMENT, :FROM_DATE, :TO_DATE, null, 'PLAIN_PERIOD', :HOTELS) RC on 0=0
    where  ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
    group by 1, 2, 3
    into   :ID_ROOM_TYPE, :ID_HOTEL, :FOR_DATE, :G_CAPACITY
  do begin
    execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_global_agent, :id_room_type, :id_hotel, :g_capacity);
  end

  for
    select   RM.BUSY_DATE, RM.ID_ROOM_TYPE, RM.ID_HOTEL,
             iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (18,20), :ID_GLOBAL_AGENT, coalesce(RS.ID_AGENT, RM.ID_AGENT)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 18, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 20, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 24, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_CONFIRMED', RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_NOTCONFIRMED', RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_RESERVS', RM.ID_ROOM, null))
    from     ROOM_MAGIC RM
             join HOTEL_S H on H.ID_HOTEL = RM.ID_HOTEL
             left outer join ROOMS_SHARE RS on RS.ID_ROOM_SHARE = RM.ID_ROOM_MAGIC
    where    RM.BUSY_DATE between :from_date and :to_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
             and rm.ROOM_STATUS is distinct from 'PRIVATE'
             and ((not (:RES_CONFIRMED = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_CONFIRMED'))
                  or (not (:RES_NOTCONFIRMED = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_NOTCONFIRMED'))
                  or (not (:RES_WAITING = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_RESERVS')))
    group by 1, 2, 3, 4
    into     :for_date, :id_room_type, :id_hotel, :id_agent,
             :ooo_rooms, :ooi_rooms, :sold_rooms, :res_room_conf, :res_room_notconf, :res_room_wait
  do begin
    execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
            null, :ooo_rooms, :ooi_rooms, null, :sold_rooms, :res_room_conf, :res_room_notconf, :res_room_wait);
  end

  if (:BOOKING_POSITIONS + :CONTINGENT > 0) then begin
    for
      select PA.ID_AGENT, PA.ID_BOOKING_POSITION, pa.ID_CONTINGENT
      from   PROFILE_AGENT PA
      where  (pa.ID_CONTINGENT is not null) or (pa.ID_BOOKING_POSITION is not null)
      into   :id_agent, :id_b_allotment, :id_c_allotment
    do begin
      for
        select al.for_date, al.id_room_type, al.id_hotel,
               sum(al.b_defined), max(al.b_is_released), sum(al.c_defined), max(al.c_is_released)
        from   (select ABP.FOR_DATE, ABP.ID_ROOM_TYPE, ABP.ID_HOTEL,
                       ABP.CNT_DEFINED as b_defined, ABP.IS_RELEASED as b_is_released, null as c_defined, null as c_is_released
                from   ALLOTMENT BA
                       left join ALLOTMENT_GET$INT(ba.ID_ALLOTMENT, :from_date, :to_date, null, 'RELEASES', :hotels) ABP on 1=1
                where  :BOOKING_POSITIONS = 1 and ba.ID_ALLOTMENT = :id_b_allotment
                union all
                select ACG.FOR_DATE, ACG.ID_ROOM_TYPE, ACG.ID_HOTEL, null, null, ACG.CNT_DEFINED, ACG.IS_RELEASED
                from   ALLOTMENT CA
                       left join ALLOTMENT_GET$INT(ca.ID_ALLOTMENT, :from_date, :to_date, null, '', :hotels) ACG on 1=1
                where  :CONTINGENT = 1 and CA.ID_ALLOTMENT = :id_c_allotment
               ) al
        where  al.for_date is not null
        group by 1, 2, 3
        into   :for_date, :id_room_type, :id_hotel,
               :bp_defined, :bp_is_released, :c_defined, :c_is_released
      do begin
        execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
                null, null, null, null, null, null, null, null, :c_defined, :c_is_released, :bp_defined, :bp_is_released);
      end
    end
  end

  if (:OVERBOOK = 1) then begin
    for
      select ACG.FOR_DATE, ACG.ID_ROOM_TYPE, ACG.ID_HOTEL, ACG.CNT_DEFINED
      from   HOTEL_S H
             left outer join ALLOTMENT_GET$INT(H.ID_OVERBOOK_ALLOTMENT, :FROM_DATE, :TO_DATE, null, '', :HOTELS) ACG on 0=0
      where  ACG.FOR_DATE is not null
             and ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
      into   :for_date, :id_room_type, :id_hotel, :fdata
    do begin
      execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
              null, null, null, :fdata);
    end
  end

  if (:FETCH_TOTALS = 1) then begin
    for
      select SOGT.BUSY_DATE, SOGT.ID_ROOM_TYPE, sum(SOGT.GSTS_COME+SOGT.GSTS_STAYOVER), sum(SOGT.GSTS_COME),
             sum(SOGT.GSTS_GONE), sum(SOGT.ROOMS_COME), sum(SOGT.ROOMS_GONE), SOGT.ID_HOTEL, SOGT.ID_AGENT
      from   REP_ROOM_STATUS_MOVE(:from_date, :to_date, -1, -1, -1, '', '', :hotels) SOGT
      group by SOGT.BUSY_DATE, SOGT.ID_ROOM_TYPE, SOGT.ID_HOTEL, SOGT.ID_AGENT
      into   :for_date, :id_room_type, :gsts_in_house, :gsts_come,
             :gsts_gone, :rooms_come, :rooms_gone, :id_hotel, :id_agent
    do begin
      execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
              null, null, null, null, null, null, null, null, null, null, null, null,
              :gsts_in_house, :gsts_come, :gsts_gone, :rooms_come, :rooms_gone);
    end
  end
end
^

/* Restore proc. body: DEPOSIT_DOCUMENT_INITIALIZE$DOC */
ALTER PROCEDURE DEPOSIT_DOCUMENT_INITIALIZE$DOC(ID_PAYMENT_HEAD TYPE OF ID,
ID_BILLING_SERVICE TYPE OF ID)
 RETURNS(ID_DOC_HEAD TYPE OF ID,
ID_HOTEL TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
WARN_CODE TYPE OF TRANGE)
 AS
declare variable id_dep_doc integer;
declare variable doc_selected integer;
declare variable payment_date date;
declare variable system_date date;
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_BILLING');

  id_dep_doc = null;

  select p.ID_DOC_HEAD, p.ID_ACCOUNT, p.PAYMENT_DATE, a.ID_HOTEL
  from   PAYMENT_HEAD P
         join DEPOSIT d on d.ID_PAYMENT_HEAD = p.ID_PAYMENT_HEAD
         join ACCOUNT a on a.ID_ACCOUNT = p.ID_ACCOUNT
  where  p.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
         and p.IS_ANUL = 0
  into   :id_dep_doc, :id_account, :payment_date, :id_hotel;

  if (:id_account is null) then
    exception DOCUMENT_EXCEPTION '-355';

  if (:id_dep_doc is not null) then
    exception DOCUMENT_EXCEPTION '-364';

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :system_date;

  if (:payment_date < :system_date) then
    exception DOCUMENT_EXCEPTION '-399';

  doc_selected = gen_id(DOC_SELECTED_GEN, 1);

  update DEPOSIT P
  set    p.DOC_SELECTED = :doc_selected,
         p.ID_BILLING_SERVICE = :ID_BILLING_SERVICE
  where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;

  execute procedure DOCUMENT_INITIALIZE$DOC (:ID_ACCOUNT, :doc_selected)
  returning_values  (:ID_DOC_HEAD, :ID_HOTEL, :WARN_CODE);

end
^

/* Restore proc. body: DEVICE_READING_POST$PMS */
ALTER PROCEDURE DEVICE_READING_POST$PMS(ID_DEVICE_READING TYPE OF ID)
 AS
declare variable id_service type of id_ref;
  declare variable post_value type of tprice;
  declare variable curr type of tcurrency;
  declare variable id_room type of id_ref;
  declare variable is_client_acc_post type of tlogical;
  declare variable date_post tdate;
  declare variable id_account_post id_ref;
  declare variable id_account_post$pms id_ref;
  declare variable id_device_reading_evidence id_ref;
  declare variable descr tdescription_long;
begin
  if(exists(select DR.ID_DEVICE_READING
            from   DEVICE_READING DR
            where  DR.ID_DEVICE_READING = :id_device_reading
                   and dr.status = 1)) then exception assert '-1051';
  for
    select CDC.ID_SERVICE,
           sum((CDC.QTY * cast(coalesce(CDC.UNIT_PRICE, 0) as double precision)) + coalesce(CDC.PRICE, 0)),
           CDC.CURR, D.ID_ROOM, CDC.IS_CLIENT_ACC_POST, DR.DATE_POST, DRQ.ID_DEVICE_READING_EVIDENCE,
           substring(list(coalesce(CDC.price || '+', '') || '(' || CDC.QTY || ' ' || coalesce(DT.MEASURE, '') || ' x '
                          || coalesce(CDC.UNIT_PRICE, 0) || ') ' || CDC.CURR) from 1 for 255)
    from DEVICE_READING DR
         join DEVICE_READING_EVIDENCE DRQ on DRQ.ID_DEVICE_READING = DR.ID_DEVICE_READING
         join DEVICE D on D.ID_DEVICE = DRQ.ID_DEVICE
         join DEVICE_TYPE DT on DT.ID_DEVICE_TYPE = D.ID_DEVICE_TYPE
         left outer join CREATE_DEVICE_CALC (D.ID_DEVICE_TYPE, DR.DATE_POST, DRQ.NEW_EVIDENCE - DRQ.OLD_EVIDENCE) CDC on 1=1
    where DR.ID_DEVICE_READING = :id_device_reading
    group by 1, 3, 4, 5, 6, 7
    into  :id_service, :post_value, :curr, :id_room, :is_client_acc_post, :date_post,
          :id_device_reading_evidence, :descr
  do begin
    if (coalesce(:post_value, -1) >= 0) then begin
      for
        select PEP.NEW_ID_ACCOUNT_POST, PEP.NEW_ID_ACCOUNT_POST$PMS
        from   PMS_EXPENSE_POSTS_CREATE$INT(:ID_ROOM, null, null, :ID_SERVICE, :CURR, :POST_VALUE,
                                            :IS_CLIENT_ACC_POST, :DATE_POST, :DESCR, 0) PEP
        into   :id_account_post, :id_account_post$pms
      do begin
        insert into DEVICE_READING_POST (ID_DEVICE_READING_EVIDENCE, ID_ACCOUNT_POST,
               ID_ACCOUNT_POST$PMS)
        values (:ID_DEVICE_READING_EVIDENCE, :ID_ACCOUNT_POST, :ID_ACCOUNT_POST$PMS);
      end
    end
  end
  update DEVICE_READING DR
  set    DR.STATUS = 1
  where  DR.ID_DEVICE_READING = :id_device_reading;
end
^

/* Restore proc. body: DOCUMENT_ATTACH_AVAIL_PAYS$INT */
ALTER PROCEDURE DOCUMENT_ATTACH_AVAIL_PAYS$INT(ID_DOC_HEAD INTEGER,
ID_ACCOUNT INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_deposit integer;
  declare variable pay_curr varchar(3);
  declare variable dep_value numeric(15,4);
  declare variable rest_value numeric(15,4);
begin

  for
    select D.ID_DEPOSIT, D.PAY_CURRENCY, D.AVAIL_VALUE
    from   DEPOSIT_AVAILABLE D
    where  D.ID_ACCOUNT = :ID_ACCOUNT
    order by D.DATETIME_CREATED asc
    into   :ID_DEPOSIT, :PAY_CURR, :DEP_VALUE
  do begin

    execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, :PAY_CURR)
    returning_values  (:dbg, :dbg, :dbg, :dbg, :REST_VALUE);

    if (:REST_VALUE > 0) then begin
      DEP_VALUE = iif(:DEP_VALUE > :REST_VALUE, :REST_VALUE, :DEP_VALUE);
      execute procedure DOCUMENT_USE_DEPOSIT$DOC (:ID_DOC_HEAD, :ID_DEPOSIT, :DEP_VALUE);

   end else begin
      exit;
    end

    when exception DOCUMENT_EXCEPTION do post_event 'dummy';
  end

end
^

/* Restore proc. body: DOCUMENT_BONUSPOINTS_APPLY$CL */
ALTER PROCEDURE DOCUMENT_BONUSPOINTS_APPLY$CL(ID_DOC_HEAD INTEGER)
 AS
declare variable points integer;
  declare variable id_guest_profile integer;
  declare variable id_guest_scheme integer;
  declare variable id_organizer_profile integer;
  declare variable id_organizer_scheme integer;
  declare variable reason varchar(50);
  declare variable note varchar(255);
  declare variable new_id_profile_wallet_points integer;
  declare variable turnover numeric(15,4);
  declare variable id_reserv_detail integer;
  declare variable acc_routing varchar(30);
  declare variable id_doc_footer integer;
  declare variable id_profile integer;
  declare variable bonuspoint_cnt integer;
  declare variable turnover_curr char(3);
begin
  points = null;
  reason = null;
  note = null;

/*  for
    select PW.ID_PROFILE_WALLET_POINTS
    from   PROFILE_WALLET_POINTS_SOURCE PW
    where  PW.ID_DOC_HEAD = :ID_DOC_HEAD
    into   :id_profile_wallet_points
  do begin
    delete from PROFILE_WALLET_POINTS PWP
    where  PWP.ID_PROFILE_WALLET_POINTS = :id_profile_wallet_points;
  end 
*/
  for
    select  DF.ID, P.ID_PROFILE, DF.TAXABLE_VALUE,
            substring(d.DOC_TYPE_NAME || ' ' || d.DOC_NUM || ' / ' || formatdate(d.DOC_DATE, 'D;dd.MM.yyyy') from 1 for 255)
    from    DOC_FOOTER DF
            join DOC_HEAD D on d.ID_DOC = df.ID_DOC_HEAD
            join ACCOUNT A on A.ID_ACCOUNT = d.ID_ACCOUNT
            join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
    where   DF.ID_DOC_HEAD = :ID_DOC_HEAD
            and df.ID_DOC_LINE is null
            and df.ID_TAX is null
    into    :id_doc_footer, :id_profile, :bonuspoint_cnt, :note
  do begin
    /* register spended bonus points */
    execute procedure PROFILE_WALLET_POINTS_REGISTER (:id_profile, :bonuspoint_cnt, 'CONSUME', :note)
    returning_values (:new_id_profile_wallet_points);
  
    insert into PROFILE_WALLET_POINTS_SPEND (ID_PROFILE_WALLET_POINTS, ID_DOC_FOOTER)
    values (:new_id_profile_wallet_points, :id_doc_footer);
  end

  for
    select distinct rd.ID_RESERV_DETAIL,
           RD.ACC_ROUTING, P.ID_PROFILE, P.ID_BONUSPOINT_SCHEME,
           PO.ID_PROFILE, PO.ID_BONUSPOINT_SCHEME,
           substring(d.DOC_TYPE_NAME || ' ' || d.DOC_NUM || ' / ' || formatdate(d.DOC_DATE, 'D;dd.MM.yyyy') from 1 for 255)
    from   DOC_HEAD D
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
           join DOC_LINE DL on DL.ID_DOC_HEAD = D.ID_DOC
           join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE
           left outer join GUEST G on G.ID_GUEST = DL.ID_GUEST
           left outer join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
           left outer join PROFILE_BONUSPOINT_SCHEME P on P.ID_PROFILE = coalesce(RD.ID_PERSON_PROFILE, A.ID_PROFILE)
                                                          and P.ID_HOTEL = RD.ID_HOTEL
           left outer join PROFILE_BONUSPOINT_SCHEME PO on PO.ID_PROFILE = coalesce(RD.ID_AGENT_PROFILE, A.ID_PROFILE)
                                                           and PO.ID_HOTEL = RD.ID_HOTEL
    where  D.ID_DOC = :ID_DOC_HEAD
           and D.IS_ANUL = 0
    into   :id_reserv_detail, :acc_routing, :id_guest_profile, :id_guest_scheme,
           :id_organizer_profile, :id_organizer_scheme, :note
  do begin
    if (:id_organizer_scheme is not null) then begin
      for
        select BPC.POINTS, BPC.TURNOVER, BPC.POINTS_REASON, BPC.TURNOVER_CURR
        from   BP_SCHEME_CALC_TURNOVER_POINTS (:id_organizer_scheme, :ID_DOC_HEAD, :id_reserv_detail, 'BASE,EXTRA') BPC
        where  BPC.POINTS <> 0
        into   :points, :turnover, :reason, :turnover_curr
      do begin
        execute procedure PROFILE_WALLET_POINTS_REGISTER (:id_organizer_profile, :points, :reason, :note)
        returning_values (:new_id_profile_wallet_points);
      
        insert into PROFILE_WALLET_POINTS_SOURCE
               (ID_PROFILE_WALLET_POINTS, ID_RESERV_DETAIL, ID_DOC_HEAD, TURNOVER, TURNOVER_CURR, ID_BONUSPOINT_SCHEME)
        values (:new_id_profile_wallet_points, :id_reserv_detail, :ID_DOC_HEAD, :turnover, :turnover_curr, :id_organizer_scheme);
      end
    end
  
    if (:id_guest_profile is distinct from :id_organizer_profile
        and :acc_routing in ('GUEST', 'MIXED')
        and :id_guest_scheme is not null) then
    begin
      for
        select BPC.POINTS, BPC.TURNOVER, BPC.POINTS_REASON, BPC.TURNOVER_CURR
        from   BP_SCHEME_CALC_TURNOVER_POINTS (:id_guest_scheme, :ID_DOC_HEAD, :id_reserv_detail,
               iif(:acc_routing = 'GUEST', 'BASE,EXTRA', 'EXTRA')) BPC
        where  BPC.POINTS <> 0
        into   :points, :turnover, :reason, :turnover_curr
      do begin
        execute procedure PROFILE_WALLET_POINTS_REGISTER (:id_guest_profile, :points, :reason, :note)
        returning_values (:new_id_profile_wallet_points);
      
        insert into PROFILE_WALLET_POINTS_SOURCE
               (ID_PROFILE_WALLET_POINTS, ID_RESERV_DETAIL, ID_DOC_HEAD, TURNOVER, TURNOVER_CURR, ID_BONUSPOINT_SCHEME)
        values (:new_id_profile_wallet_points, :id_reserv_detail, :ID_DOC_HEAD, :turnover, :turnover_curr, :id_guest_scheme);
      end
    end
  end
end
^

/* Restore proc. body: DOCUMENT_BONUSPOINTS_VOID$CL */
ALTER PROCEDURE DOCUMENT_BONUSPOINTS_VOID$CL(ID_DOC_HEAD INTEGER)
 AS
declare variable id_profile integer;
  declare variable points integer;
  declare variable note varchar(255);
  declare variable new_id_profile_wallet_points integer;
  declare variable turnover numeric(15,4);
  declare variable id_reserv_detail integer;
  declare variable id_bonuspoint_scheme integer;
  declare variable id_doc_footer integer;
  declare variable turnover_curr char(3);
begin

  for
    select PWP.ID_PROFILE, PWP.POINTS, PWP.NOTE,
           PWS.ID_BONUSPOINT_SCHEME, PWS.ID_RESERV_DETAIL, PWS.TURNOVER, PWS.TURNOVER_CURR
    from   PROFILE_WALLET_POINTS_SOURCE PWS
           join PROFILE_WALLET_POINTS PWP on PWP.ID_PROFILE_WALLET_POINTS = PWS.ID_PROFILE_WALLET_POINTS
    where  PWS.ID_DOC_HEAD = :ID_DOC_HEAD
           and PWP.REASON <> 'VOID'
    into   :id_profile, :points, :note,
           :id_bonuspoint_scheme, :id_reserv_detail, :turnover, :turnover_curr
  do begin
    execute procedure PROFILE_WALLET_POINTS_REGISTER (:id_profile, :points, 'VOID', :note)
    returning_values (:new_id_profile_wallet_points);

    insert into PROFILE_WALLET_POINTS_SOURCE (ID_PROFILE_WALLET_POINTS, ID_RESERV_DETAIL, ID_DOC_HEAD,
           TURNOVER, TURNOVER_CURR, ID_BONUSPOINT_SCHEME)
    values (:new_id_profile_wallet_points, :id_reserv_detail, :ID_DOC_HEAD,
           :turnover, :turnover_curr, :id_bonuspoint_scheme);
  end

  for
    select PWP.ID_PROFILE, PWP.POINTS, PWP.NOTE, DF.ID
    from   DOC_FOOTER DF
           join PROFILE_WALLET_POINTS_SPEND PS on PS.ID_DOC_FOOTER = df.ID
           join PROFILE_WALLET_POINTS PWP on PWP.ID_PROFILE_WALLET_POINTS = PS.ID_PROFILE_WALLET_POINTS
    where  DF.ID_DOC_HEAD = :ID_DOC_HEAD
           and PWP.REASON not containing 'VOID'
    into   :id_profile, :points, :note, :id_doc_footer
  do begin
    execute procedure PROFILE_WALLET_POINTS_REGISTER (:id_profile, :points, 'CONSUME_VOID', :note)
    returning_values (:new_id_profile_wallet_points);

    insert into PROFILE_WALLET_POINTS_SPEND (ID_PROFILE_WALLET_POINTS, ID_DOC_FOOTER)
    values (:new_id_profile_wallet_points, :id_doc_footer);
  end
end
^

/* Restore proc. body: DOCUMENT_REUSE_DEPOSITS$INT */
ALTER PROCEDURE DOCUMENT_REUSE_DEPOSITS$INT(OLD_ID_DOC_HEAD INTEGER,
NEW_ID_DOC_HEAD INTEGER)
 AS
declare variable ID_DEPOSIT integer;
declare variable DEPOSIT_AMOUNT numeric(15,4);
begin

  for
    select  D.ID_DEPOSIT, sum(D.USED_PAY_VALUE)
    from    DEPOSIT_DEDUCT D
    where   D.ID_DOC_USED = :OLD_ID_DOC_HEAD
    group by D.ID_DEPOSIT
    into    :ID_DEPOSIT, :DEPOSIT_AMOUNT
  do begin
    execute procedure DOCUMENT_DETACH_DEPOSIT$INT (:OLD_ID_DOC_HEAD, :ID_DEPOSIT);

    if (:NEW_ID_DOC_HEAD is not null) then begin
      execute procedure DOCUMENT_USE_DEPOSIT$DOC (:NEW_ID_DOC_HEAD, :ID_DEPOSIT, :DEPOSIT_AMOUNT);

      when exception DOCUMENT_EXCEPTION do post_event 'dummy';
    end
  end

end
^

/* Restore proc. body: EAI_EXT_POST_TO_MH_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  if (:CODE_TYPE = 'EXT_CODE') then begin
    execute procedure EAI_MAP_SERVICE(:SERVICE_CODE, :SERVICE_CODE, 'UNKNOWN', :id_hotel)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_SERVICE;
    if (:ERR_CODE < 0) then exit;
  end else begin
    select S.ID_SERVICE
    from   SERVICES S
    where  S.ID_SERVICE = :SERVICE_CODE
           and s.ID_HOTEL = :ID_HOTEL
    into   :ID_SERVICE;
    if (:ID_SERVICE is null) then begin
      ERR_CODE = -85;   /* Wrong value! */
      exit;
    end
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Restore proc. body: EAI_EXT_SERVICE_POST */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable max_id_service integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_ROOM  = null;
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  select min(S.ID_SERVICE) as id_service, max(s.id_service) as max_id_service
  from   SERVICES S
  where  S.EXT_CODE = :SERVICE_EXT_CODE
         and s.IS_BASE = 0
         and s.IS_DELETED = 0
  into   :ID_SERVICE, :max_id_service;
  if (:ID_SERVICE is null) then begin
      ERR_CODE = -388;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end else if (:ID_SERVICE <> :max_id_service) then begin
      ERR_CODE = -389;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_EXT_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Restore proc. body: EAI_POS_POSTING_ADD$P2E */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
declare variable id_service integer;
  declare variable my_post_text varchar(255);
  declare variable my_resource_text varchar(255);
  declare variable no_use integer;
  declare variable nation_curr varchar(3);
  declare variable post_short_code varchar(10);
  declare variable id_hotel integer;
begin
  /* in_on_guest = 0 (account), 1 (guest), -1 (ew)
  */
  if (:IN_ON_GUEST = 1) then begin
    select rd.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :IN_ID_GUEST
    into   :id_hotel;
  end else begin
    select a.ID_HOTEL
    from   account a
    where  a.ID_ACCOUNT = :in_id_account
    into   :id_hotel;
  end

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :nation_curr;

  if ('END_WORK' = :in_smetka_num) then begin
    post_short_code='POS_EW';
  end else begin
    post_short_code='POS';
  end

  /* FIND SERVICE */
  execute procedure EAI_MAP_SERVICE(:in_service_tag, :in_service_name, 'POS', :id_hotel)
  returning_values  :err_code, :err_text, :id_service;
  if (:err_code < 0) then exit;

  my_post_text = 'date:'|| formatdate(:in_date_smetka, 'D;dd.mm.yyyy') ||
                 ' num:'|| :in_smetka_num ||
                 ' obj:'|| :in_obj_name ||
                 ' tbl:'|| :in_table ||
                 ' site:'|| :in_site;

  my_resource_text = 'POS_ID_SMETKA:'||:in_id_smetka;
  my_post_text = substring(:my_post_text from 1 for 100);
  my_resource_text = substring(:my_resource_text from 1 for 49);

  if (:in_on_guest = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:in_id_guest, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code, '')
    returning_values  :err_code, :err_text, :out_id_account, :no_use;
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:in_id_account, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code)
    returning_values  :err_code, :err_text, :no_use;
    out_id_account = :in_id_account;
  end
end
^

/* Restore proc. body: EAI_RES_CHECK_OUT_FAST */
ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
declare variable selection_id integer;
  declare variable is_early_check_out smallint;
  declare variable early_check_out_dep_date date;
  declare variable check_out_date date;
begin
  selection_id = gen_id(selection_gen, 1);

  update RESERV_DETAIL RD
  set RD.SELECTION_ID = :SELECTION_ID
  where RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL;

  execute procedure RES_CHECK_OUT_CHECK$RSV(:selection_id)
  returning_values :is_early_check_out, :early_check_out_dep_date, :check_out_date;

  if (:is_early_check_out = 1) then
    exception BOOKING_EXCEPTION '-1043';

  execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id, 0);
end
^

/* Restore proc. body: EAI_TELECOUNT_TRANSFER */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* Restore proc. body: IMPORT_AGENT_PROFILE$EXC */
ALTER PROCEDURE IMPORT_AGENT_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
AGENT_GROUP VARCHAR(50),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
WBE_PASSWORD VARCHAR(20),
IATA_NUMBER VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
DEF_CONTRAGENT_NAME VARCHAR(100),
CLEAR_HOTEL_RATE SMALLINT,
CLEAR_HOTEL_DISCOUNT SMALLINT,
CREATE_ONLY SMALLINT,
THRESHOLD_NOTE VARCHAR(255),
THRESHOLD_AMOUNT NUMERIC(15,4),
THRESHOLD_CURR CHAR(3),
MERGE_TARGET_UUID VARCHAR(40))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
declare variable op varchar(10);
  declare variable market_segment_id integer;
  declare variable agent_group_old varchar(50);
  declare variable id_bonuspoint_scheme integer;
  declare variable id_def_contragent integer;
  declare variable is_exclusive_debt_ownership smallint;
  declare variable country_code_old varchar(10);
  declare variable profile_receiver_id integer;
begin
  profile_id = null;
  import_time = null;

  execute procedure import_mark_transaction$exc;

  /*FIXME - remove this block*/
  if (1 = :create_only) then begin
    clear_hotel_rate = 0;
    clear_hotel_discount = 0;
  end else begin
    clear_hotel_rate = 1;
    clear_hotel_discount = 1;
  end

  execute procedure sys_dbg('exc IMPORT_AGENT_PROFILE$EXC(:profile_uuid=>' || coalesce(:profile_uuid, cast('<null>' as varchar(40)) ) || ')');
  profile_id = null;
  if (:PROFILE_UUID is null) then begin
    execute procedure sys_dbg('exc IMPORT_AGENT_PROFILE$EXC <null> :profile_uuid - exit;');
    exit;
  end

  select p.profile_id, p.profile_name, p.phone, p.fax, p.email, p.city,
         p.address, p.market_segment, p.note, p.is_archive, p.id_bonuspoint_scheme,
         p.id_def_contragent, pa.agent_group, p.wbe_password,
         p.msg, p.account_no, p.is_exclusive_debt_ownership, pa.country_code
  from   IMPORT_COMMON_PROFILE$EXC(:PROFILE_UUID, 1, :PROFILE_NAME,
         :PHONE, :FAX, :EMAIL, :CITY, :ADDRESS, :MARKET_SEGMENT, :NOTE, :IS_ARCHIVE, :WBE_PASSWORD, :ACCOUNT_NO, :MSG,  'AGENT_PROFILE', :CLEAR_HOTEL_RATE) p
         left outer join profile_agent pa on pa.id_profile = p.profile_id
  into   :profile_id, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :id_bonuspoint_scheme,
         :id_def_contragent, :agent_group_old, :wbe_password,
         :msg, :account_no, :is_exclusive_debt_ownership, :country_code_old;

  if (:profile_id is null) then begin
    op = 'add';
  end else if (1 = :create_only) then begin
    profile_id = null;
    exit;
  end else begin
    op = 'mod';
    if (1 = :clear_hotel_discount) then begin
      delete from PROFILE_DISCOUNT pd
      where  pd.ID_PROFILE = :profile_id;
    end

    delete from PROFILE_BONUSPOINT_SCHEME bs
    where  bs.ID_PROFILE = :profile_id;
  end

  AGENT_GROUP=coalesce(:AGENT_GROUP, :AGENT_GROUP_OLD);
  country_code=coalesce(:country_code, :country_code_old);

  execute procedure LOOKUP_MARKET_SEGMENT$EXC(:profile_name, 'AGENT_PROFILE', :market_segment)
  returning_values :market_segment_id;

  if ((def_contragent_name is not null) and (def_contragent_name <> '')) then begin
    execute procedure LOOKUP_CONTRAGENT$EXC(:profile_name, 'AGENT_PROFILE', :def_contragent_name)
    returning_values :id_def_contragent;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:profile_name, 'AGENT_PROFILE');

  execute procedure sys_dbg('exc IMPORT_AGENT_PROFILE$EXC - profile_agent_modify$profile(:profile_uuid=>' || coalesce(:profile_uuid,cast('<null>' as varchar(40)))
    || ', :operation=>' || coalesce(:op, cast('<null>' as varchar(10)) )
    || ', :market_segment_id=>' || coalesce(cast(:market_segment_id as varchar(10)) , cast('<null>' as varchar(10)) )
    || ')');

  if (1 = :create_only) then begin
    -- in :create_only mode (i.e. embeded mode transfer only profile key fields )
    --profile_name = null;
    phone = null;
    fax = null;
    email = null;
    country_code = null;
    city = null;
    address = null;
    note = null;
    msg = null;
    --is_archive = null;
    agent_group = null;
    id_def_contragent = null;
    market_segment_id = null;
    id_bonuspoint_scheme = null;
    wbe_password = null;
    account_no = null;
    --iata_number = null;
    is_exclusive_debt_ownership = null;
  end

  execute procedure profile_agent_modify$profile(
    :profile_id, :profile_name, :phone, :fax, :email,
    :country_code, :city, :address, :note, :msg, :is_archive, :agent_group, :id_def_contragent, :market_segment_id,
    :wbe_password, :op, :account_no, :iata_number, :is_exclusive_debt_ownership,
    :threshold_note, :threshold_amount, :threshold_curr)
  returning_values :profile_id;

  /*assign UUID to the new profiles*/
  if ('add' = :op) then begin
    update profile
    set    uuid = :profile_uuid
    where  id_profile = :profile_id;
  end

  select record_timestamp
  from   profile
  where  id_profile = :profile_id
  into   :import_time;

  if (:MERGE_TARGET_UUID is not null) then begin
    select p.ID_PROFILE
    from   PROFILE P
    where  P.UUID = :MERGE_TARGET_UUID
    into   :profile_receiver_id;

    execute procedure PROFILE_MERGE$PROFILE (:PROFILE_ID, :profile_receiver_id, 'merge');

  end
end
^

/* Restore proc. body: IMPORT_PERSON_PROFILE$EXC */
ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
CLEAR_HOTEL_RATE SMALLINT,
CREATE_ONLY SMALLINT,
MERGE_TARGET_UUID VARCHAR(40))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
declare variable op varchar(10);
  declare variable market_segment_id integer;
  declare variable sex_old char(1);
  declare variable birth_date_old date;
  declare variable birth_place_old varchar(30);
  declare variable personal_number_old varchar(30);
  declare variable pass_num_old varchar(20);
  declare variable pass_date_old date;
  declare variable pass_place_old varchar(20);
  declare variable pass_exp_date_old date;
  declare variable pass_city_old varchar(100);
  declare variable pass_address_old varchar(100);
  declare variable country_old varchar(10);
  declare variable mask_old varchar(10);
  declare variable title_old varchar(10);
  declare variable id_photo integer;
  declare variable id_def_contragent integer;
  declare variable id_passport_type integer;
  declare variable account_no_old varchar(20);
  declare variable msg_old varchar(255);
  declare variable id_guest_type integer;
  declare variable id_guest_type_old integer;
  declare variable card_code_old varchar(50);
  declare variable is_exclusive_debt_ownership smallint;
  declare variable profile_receiver_id integer;
begin
  profile_id = null;
  import_time = null;

  execute procedure import_mark_transaction$exc;

  /*FIXME - remove this block*/
  if (1 = :create_only) then begin
    clear_hotel_rate = 0;
  end else begin
    clear_hotel_rate = 1;
  end

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC(:profile_uuid=>' || coalesce(:profile_uuid, '<null>')
                          || ', email=>' || coalesce(:email, '<null>') || ')');

  profile_id = null;
  if (profile_uuid is null) then begin
    execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC <null> :profile_uuid - exit;');
    exit;
  end

  select p.profile_id, p.profile_name, p.phone, p.fax, p.email, p.city,
         p.address, p.market_segment, p.note, p.is_archive, pp.card_code,
         pd.sex, pd.birthday_internal, pd.birth_place, pd.egn, pd.pass_num,
         pd.pass_date, pd.pass_place, pd.pass_exp_date, pd.city, pd.address, pd.country_code,
         pd.mask, p.id_def_contragent, p.wbe_password,
         pd.title, p.account_no, p.msg, pp.id_guest_type, pp.id_photo, pd.id_passport_type,
         p.is_exclusive_debt_ownership
  from   import_common_profile$exc(:profile_uuid, 0, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :wbe_password, :ACCOUNT_NO, :MSG, 'PERSON_PROFILE', :CLEAR_HOTEL_RATE) p
         left outer join profile_person pp on pp.id_profile = p.profile_id
         left outer join person_data pd on pd.id_person_data=pp.id_person_data
  into   :profile_id, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :card_code_old,
         :sex_old, :birth_date_old, :birth_place_old, :personal_number_old, :pass_num_old,
         :pass_date_old, :pass_place_old, :pass_exp_date_old, :pass_city_old, :pass_address_old, :country_old,
         :mask_old, :id_def_contragent, :wbe_password, :title_old,
         :account_no_old, :msg_old, :id_guest_type_old, :id_photo, :id_passport_type, :is_exclusive_debt_ownership;

  if (:profile_id is null) then begin
    op = 'add';
  end else if (1 = :create_only) then begin
    profile_id = null;
    exit;
  end else begin
    op = 'mod';
    delete from PROFILE_HOTEL_RATE phr
      where phr.ID_PROFILE = :profile_id;
    delete from PROFILE_BONUSPOINT_SCHEME bs
      where bs.ID_PROFILE = :profile_id;
  end

  sex=coalesce(:sex, :sex_old);
  birth_date=coalesce(:birth_date, :birth_date_old);
  birth_place=coalesce(:birth_place, :birth_place_old);
  personal_number=coalesce(:personal_number, :personal_number_old);
  pass_num=coalesce(:pass_num, :pass_num_old);
  pass_date=coalesce(:pass_date, :pass_date_old);
  pass_place=coalesce(:pass_place, :pass_place_old);
  pass_exp_date=coalesce(:pass_exp_date, :pass_exp_date_old);
  pass_city=coalesce(:pass_city, :pass_city_old);
  pass_address=coalesce(:pass_address, :pass_address_old);
  country=upper(coalesce(:country, :country_old));
  mask=coalesce(:mask, :mask_old);
  title=coalesce(:title, :title_old);
  account_no=coalesce(:account_no, :account_no_old);
  msg=coalesce(:msg, :msg_old);
  card_code=coalesce(:card_code, :card_code_old);

  execute procedure IMPORT_PASSPORT_TYPE$EXC(:pass_type_name, :pass_type_external_code)
  returning_values :id_passport_type;

  execute procedure lookup_market_segment$exc(:profile_name, 'PERSON_PROFILE', :market_segment)
  returning_values :market_segment_id;

  if (guest_type_name is not null) then begin
    execute procedure lookup_guest_type$exc(:profile_name, 'PERSON_PROFILE', :guest_type_name)
    returning_values :id_guest_type;
  end

  if ((def_contragent_name is not null) and (def_contragent_name <> '')) then begin
    execute procedure LOOKUP_CONTRAGENT$EXC(:profile_name, 'PERSON_PROFILE', :def_contragent_name)
    returning_values :id_def_contragent;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:profile_name, 'PERSON_PROFILE');

  id_guest_type=coalesce(:id_guest_type, :id_guest_type_old);

  if (id_photo is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, null, null, null, 'del')
    returning_values :id_photo;
  end
  id_photo = null;
  if (picture is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, :picture, :picture_type, :picture_layout, 'add')
    returning_values :id_photo;
  end

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC - profile_person_modify$profile(:profile_uuid=>'
    || coalesce(:profile_uuid, '<null>')
    || ', :operation=>' || coalesce(:op, '<null>')
    || ', :email=>' || coalesce(:email, '<null>')
    || ', :birth_date=>' || coalesce(:birth_date, '<null>')
  || ')');
  execute procedure profile_person_modify$profile(
    :profile_id,
    :id_guest_type,
    :profile_name,
    null,
    :sex,
    :birth_date,
    :birth_place,
    :personal_number,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :pass_place,
    :pass_exp_date,
    :country,
    :pass_city,
    :pass_address,
    :mask,
    :phone,
    :fax,
    :email,
    :city,
    :address,
    :note,
    :msg,
    :id_def_contragent,
    :market_segment_id,
    :is_archive,
    :id_photo,
    :card_code,
    :wbe_password,
    :op,
    :account_no,
    :title,
    :is_exclusive_debt_ownership
  ) returning_values
    :profile_id;

  /*assign uuid to the new profiles*/
  if ('add' = :op) then begin
    update profile set uuid=:profile_uuid where id_profile=:profile_id;
  end

  select record_timestamp from profile where id_profile=:profile_id
  into :import_time;

  if (:MERGE_TARGET_UUID is not null) then begin
    select p.ID_PROFILE
    from   PROFILE P
    where  P.UUID = :MERGE_TARGET_UUID
    into   :profile_receiver_id;

    execute procedure PROFILE_MERGE$PROFILE (:PROFILE_ID, :profile_receiver_id, 'merge');

  end

end
^

/* Restore proc. body: IMPORT_WALLET_POINTS$EXC */
ALTER PROCEDURE IMPORT_WALLET_POINTS$EXC(UUID VARCHAR(40),
PROFILE_UUID VARCHAR(40),
POINTS INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
USER_CREATED VARCHAR(30),
DATETIME_CREATED TIMESTAMP)
 AS
declare variable profile_id integer;
  declare variable wp_id integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:UUID, 'WALLET_POINTS');

  /* exit if update is detected - wallet points interface is log based */
  if (exists(
    select first 1 ID_PROFILE_WALLET_POINTS
    from   PROFILE_WALLET_POINTS
    where  UUID = :uuid
  )) then exit;

  select first 1 p.id_profile
  from   PROFILE p
  where  p.uuid=:profile_uuid
         and p.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :profile_id;

  /* exit if we are unable to find the target profile - it is a legal situation */
  if (:profile_id is null) then exit;

  execute procedure PROFILE_WALLET_POINTS_REGISTER(:profile_id, :points, :reason, :note)
  returning_values :wp_id;

  /* preserve the original object properties */
  update profile_wallet_points
  set    user_created = :user_created,
         datetime_created = :datetime_created,
         uuid = :uuid
  where (id_profile_wallet_points = :wp_id);
end
^

/* Restore proc. body: PHONECALL_POST$TC */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Restore proc. body: PHONECALLS_POST_TO_ACCOUNT$TC */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* Restore proc. body: PMS_EXPENSE_POSTING_CREATE$PMS */
ALTER PROCEDURE PMS_EXPENSE_POSTING_CREATE$PMS(ID_ROOM TYPE OF ID,
ID_OWNER TYPE OF ID,
ID_RENTAL_POOL TYPE OF ID_REF,
ID_SERVICE TYPE OF ID,
ID_CURRENCY TYPE OF TCURRENCY,
POST_VALUE TYPE OF TPRICE,
IS_ACC_POST_ITEM TYPE OF TLOGICAL,
MANUAL_POST_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
IS_POST_PER_POOL TYPE OF TLOGICAL)
 AS
declare variable no_use_id_acc_post integer;
declare variable no_use_id_acc_post$pms integer;
begin
  for
    select PE.NEW_ID_ACCOUNT_POST, PE.NEW_ID_ACCOUNT_POST$PMS
    from PMS_EXPENSE_POSTS_CREATE$INT(:ID_ROOM, :ID_OWNER, :ID_RENTAL_POOL, :ID_SERVICE,
         :ID_CURRENCY, :POST_VALUE, :IS_ACC_POST_ITEM, :MANUAL_POST_DATE, :DESCRIPTION, :IS_POST_PER_POOL) PE
    into :no_use_id_acc_post, :no_use_id_acc_post$pms
  do begin

  end
end
^

/* Restore proc. body: PMS_IMPORT */
ALTER PROCEDURE PMS_IMPORT(ID_EXPORT_HEAD INTEGER)
 AS
begin

  execute procedure PMS_IMPORT$INT(:ID_EXPORT_HEAD);

end
^

/* Restore proc. body: PMS_POOL_DISTRIBUTION */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION(ID_RENTAL_POOL INTEGER,
FOR_DATE DATE)
 AS
declare variable total_value_per_service numeric(15,4);
  declare variable id_service integer;
  declare variable curr varchar(3);
  declare variable id_room_param integer;
  declare variable is_room_pool smallint;
  declare variable is_owner_income smallint;

  declare variable is_acc_post_item smallint;
  declare variable new_id_owner_bill integer;
  declare variable id_account_post_pms integer;
  declare variable id_pool_account integer;

  declare variable id_account_pms integer;
  declare variable value_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable value_post numeric(15,4);
  declare variable curr_post varchar(3);
  declare variable id_room integer;
  declare variable date_post date;
  declare variable id_reserv_detail integer;
  declare variable doc_description varchar(255);
  declare variable id_doc_head integer;
  declare variable description varchar(255);
  declare variable is_client_account_post smallint;
begin
  is_room_pool = null;
  select U.IS_ROOM_POOL, U.ID_ROOM_PARAM
  from   OWNER$PMS O
         join RENTAL_POOL_UNIT$PMS U on U.ID_RENTAL_POOL_UNIT = O.ID_RENTAL_POOL_UNIT
  where  O.ID_OWNER = :ID_RENTAL_POOL
  into   :is_room_pool, :id_room_param;
  if (:is_room_pool is null) then exception PMS_EXCEPTION;

  for
    select sum(AP1.VALUE_POST), AP1.ID_SERVICE, AP1.CURR_POST, AP1.IS_OWNER_INCOME,
           ACC.IS_CLIENT_POOL_ACCOUNT, ACC.ID_ACCOUNT
    from   (select distinct AP.ID_PMS_EVENT
            from   ACCOUNT_POST$PMS AP
                   join ACCOUNT$PMS AC on AC.ID_ACCOUNT = AP.ID_ACCOUNT_PMS
            where  AP.DATE_POST <= :FOR_DATE
                   and AP.LINE_STATUS = 11
                   and AC.ID_OWNER = :ID_RENTAL_POOL
                   and AC.IS_SHADOW = 0) E
           join ACCOUNT_POST$PMS AP1 on AP1.ID_PMS_EVENT = e.ID_PMS_EVENT and AP1.LINE_STATUS = 11
           join ACCOUNT$PMS ACC on ACC.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS and ACC.IS_SHADOW = 0
    group by 2,3,4,5,6
    into   :total_value_per_service, :id_service, :curr, :is_owner_income,
           :is_acc_post_item, :id_pool_account
  do begin
    execute procedure PMS_POOL_DISTRIBUTION_SUB(:ID_RENTAL_POOL, :id_pool_account,
            :IS_ROOM_POOL, :ID_ROOM_PARAM, :total_value_per_service,
            :ID_SERVICE, :CURR, :IS_OWNER_INCOME, :FOR_DATE, :is_acc_post_item);
  end

  NEW_ID_OWNER_BILL = gen_id(GEN_OWNER_BILL$PMS_ID, 1);

  insert into OWNER_BILL$PMS (ID_OWNER_BILL, ID_OWNER, BILL_DATE, IS_ANUL, BILL_NUM,
         IS_EXPORTED_TO_INTRANET, IS_POOL_DISTRIBUTION_STATEMENT)
  values (:NEW_ID_OWNER_BILL, :ID_RENTAL_POOL, :FOR_DATE, 0, :NEW_ID_OWNER_BILL, 0, 1);

  update OWNER$PMS O
  set    O.LAST_BILLING_DATE = :for_date,
         O.ID_OWNER_BILL = :NEW_ID_OWNER_BILL
  where  O.ID_OWNER = :ID_RENTAL_POOL;

  for
    select AP.ID_ACCOUNT_POST, AP.VALUE_ORIG, AP.CURR_ORIG, AP.VALUE_POST, AP.CURR_POST,
           ACC.ID_ACCOUNT, AP.IS_OWNER_INCOME, AP.ID_SERVICE, E.ID_ROOM, AP.DATE_POST,
           E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION, ACC.IS_CLIENT_POOL_ACCOUNT
    from   PMS_EVENT$PMS E
           join ACCOUNT_POST$PMS AP on ap.ID_PMS_EVENT = e.ID_PMS_EVENT
                                       and AP.LINE_STATUS = 11
           join ACCOUNT$PMS ACC on ACC.ID_ACCOUNT = AP.ID_ACCOUNT_PMS
                                   and ACC.ID_OWNER = :ID_RENTAL_POOL
                                   and ACC.IS_SHADOW = 0
    where  E.ID_SESSION = current_transaction
    into   :id_account_post_pms, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
           :ID_ACCOUNT_PMS, :IS_OWNER_INCOME, :ID_SERVICE, :ID_ROOM, :DATE_POST,
           :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION, :is_client_account_post
  do begin
    insert into OWNER_BILL_ROW$PMS (ID_OWNER_BILL, ID_ACCOUNT_POST, ID_ACCOUNT,
           ID_ACCOUNT_POST_PMS, ID_ACCOUNT_PMS, ID_SERVICE, VALUE_ORIG,
           CURR_ORIG, VALUE_POST, CURR_POST, IS_OWNER_INCOME, ID_ROOM, DATE_POST,
           ID_RESERV_DETAIL, DOC_DESCRIPTION, ID_DOC_HEAD, DESCRIPTION, IS_CLIENT_ACCOUNT_POST)
    values (:new_id_owner_bill, null, null,
           :ID_ACCOUNT_POST_PMS, :ID_ACCOUNT_PMS, :ID_SERVICE, :VALUE_ORIG,
           :CURR_ORIG, :VALUE_POST, :CURR_POST, :IS_OWNER_INCOME, :ID_ROOM, :DATE_POST,
           :ID_RESERV_DETAIL, :DOC_DESCRIPTION, :ID_DOC_HEAD, :DESCRIPTION, :is_client_account_post);

    update ACCOUNT_POST$PMS A
    set    A.LINE_STATUS = 21
    where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS;
  end
end
^

/* Restore proc. body: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_OWNER TYPE OF ID,
POST_DATE TYPE OF TDATE,
CURR_ORIG TYPE OF TCURRENCY,
VALUE_ORIG TYPE OF TPRICE,
POST_ON_PMS_ACCOUNT TYPE OF TLOGICAL,
IS_OWNER_INCOME TYPE OF TLOGICAL,
ID_ROOM TYPE OF ID_REF = null)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  if (:POST_ON_PMS_ACCOUNT = 1) then begin
    execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account, :id_owner,
            :CURR_ORIG, :VALUE_ORIG, :id_service, :is_owner_income, :POST_DATE)
    returning_values  (:new_id_account_post);
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :ID_SERVICE, 1, 0, 1,
            :VALUE_ORIG, :CURR_ORIG, current_date, current_date,
            '', '', :POST_DATE, 'PMS', :ID_ROOM)
    returning_values  :err_code, :err_text, :new_id_account_post;
    if (:err_code <> 0) then exception PMS_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

    insert into PMS_EVENT_POST (ID_PMS_EVENT, ID_ACCOUNT_POST, ID_OWNER, LINE_STATUS)
    values (:ID_PMS_EVENT, :NEW_ID_ACCOUNT_POST, :ID_OWNER, 11);
  end
end
^

/* Restore proc. body: POST_SERVICE_FINALIZE$POST */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
  declare variable id_acc_post integer;
  declare variable id_service integer;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable date_post date;
  declare variable price_post numeric(15,4);
  declare variable qty_post numeric(15,2);
  declare variable post_text varchar(100);
  declare variable curr_post varchar(3);
  declare variable id_phonecall integer;
  declare variable p_dbkey char(8);
begin

  if (:OPERATION = 'clear') then begin
    delete from TMP_SERVICE_POST T
    where  T.ID_SEQUENCE = :ID_SEQUENCE;

  end else if (:OPERATION = 'store') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);

    for
      select TS.RDB$DB_KEY, TS.ID_SERVICE, TS.ID_ACCOUNT, TS.ID_GUEST, TS.DATE_POST,
             TS.PRICE_POST, TS.QTY_POST, TS.CURR_POST, TS.POST_TEXT, TS.ID_PHONECALL
      from   TMP_SERVICE_POST TS
      where  TS.ID_SEQUENCE = :ID_SEQUENCE
      into   :p_dbkey, :id_service, :id_account, :id_guest, :date_post,
             :price_post, :qty_post, :curr_post, :post_text, :id_phonecall
    do begin
      id_acc_post = null;
      if (:id_guest is not null) then begin
        execute procedure POST_SERVICE_ON_GUEST$INT (:id_guest, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :CURR_POST,
                :date_post, :date_post, :post_text, '', :date_post, '', '')
        returning_values  (:err_code, :err_text, :no_use, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end else begin
        execute procedure POST_SERVICE_ON_ACCOUNT$INT (:id_account, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :curr_post, :date_post, :date_post, :post_text,
                '', :date_post, '')
        returning_values  (:err_code, :err_text, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end

      update TMP_SERVICE_POST
      set ID_ACCOUNT_POST = :id_acc_post
      where RDB$DB_KEY = :p_dbkey;

      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :DOC_SELECTED,
             AP.SHORT_CODE = case
                               when :id_phonecall is not null then 'TELECOUNT'
                               else null
                             end
      where  AP.ID_ACCOUNT_POST = :id_acc_post;

      if (:id_phonecall is not null) then begin
        update PHONECALLS P
        set    P.ID_ACCOUNT_POST = :id_acc_post
        where  P.ID_PHONECALL = :id_phonecall;
      end
    end
  end
end
^

/* Restore proc. body: RES_FINALIZE_RECALC$INT */
ALTER PROCEDURE RES_FINALIZE_RECALC$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_calc integer;
begin
  -- NORMAL recalculation processing
  execute procedure RES_RECALC$INT(:rd_dbkey, 'NORMAL', 0)
  returning_values  :err_code, :err_text, :id_tar_calc;
  if (:err_code < 0) then exit;

end
^

/* Restore proc. body: RES_TAR_CALC_FINALIZE$INT */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(TAR_CALC_ERR INTEGER,
ID_TAR_CALC INTEGER,
RD_DBKEY_INIT CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
begin
  /*  Description:
  ||  Razpiswa cenata na staia, kakto i price_detailite.
      Za4istwa temp tablicite
  */
  --savedbg('TAR_CALC_ERR: ' || :TAR_CALC_ERR);
  --savedbg('ID_TAR_CALC: ' || :ID_TAR_CALC);
  if (:tar_calc_err = 0) then begin
    room_price = 0;
    room_price_details = '';

    execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

    for
      select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, rd.IS_POSTING_STOPPED,
             coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
             coalesce(max((select first 1 AP.IS_BASE
                           from   GUEST G
                                  join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                           where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                  and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (eventually)
      from   TAR_CALC_INPUT$TMP TI
             join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
             join TARIFA t on t.ID_TARIFA = rd.ID_RATE
      where  ti.ID_TAR_CALC = :ID_TAR_CALC
      group by 1, 2, 3, 4, 5, 6
      into   :id_reserv_detail, :check_status, :is_posting_stopped,
             :room_currency, :id_hotel, :is_anul, :has_postings
    do begin
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);

      if ( (not (:is_posting_stopped = 1 and :has_postings = 0))                                -- posting is not stopped
           and                                                                                  -- and
           ( (coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1) ) -- there are reasons to repost
         ) then
      begin

        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);

      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;

        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end

      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end else begin

    update RESERV_DETAIL RD
    set    RD.ROOM_PRICE = null,
           RD.ROOM_CURRENCY = null,
           RD.ROOM_PRICE_DETAILS = null,
           RD.LAST_ID_TAR_CALC = null
    where  RD.RDB$DB_KEY = :RD_DBKEY_INIT;
  end
  
  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;
end
^

/* Restore proc. body: SAFE_OCCUPANCY_MODIFY */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE TYPE OF ID,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable old_booking_number tres_number;
  declare variable id_resource_reservation id_ref;
  declare variable from_datetime tdatetime;
  declare variable action_text tdescription_long;
  declare variable old_occupant varchar(100);
  declare variable old_to_dt timestamp;
  declare variable id_reserv_detail integer;
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation;

  select rr.BOOKING_NUMBER, od.FROM_DATETIME,
         RR.OCCUPANT_NAME, od.TO_DATETIME, rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESERV_DETAIL rd on rd.NUMBER = rr.BOOKING_NUMBER and rd.IS_ANUL = 0
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :old_booking_number, :from_datetime,
         :old_occupant, :old_to_dt, :id_reserv_detail, :id_agent_profile;

  --if (:old_booking_number <> :BOOKING_NUMBER) then exception ASSERT 'Can not change booking number!';
  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  update SAFE_RESOURCE_RESERV rr
  set    rr.PRICE_DESCRIPTION = :price_description,
         rr.ID_RATE_PRICE_PROFILE = :id_agent_profile,
         rr.RATING_UNITS = :rating_units,
         rr.RATE_PRICE = :price,
         rr.RATE_CURR = :currency
  where  rr.ID_RESOURCE_RESERV = :id_resource_reservation;

  execute procedure RESOURCE_RESERVATION_MODIFY (:id_resource_reservation, :ID_SAFE, :from_datetime,
          :TO_DATETIME, :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :old_booking_number, 'mod')
  returning_values :id_resource_reservation, :no_use;

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail)
  returning_values (:DOC_SELECTED);

  /* Log changes */
  if ((:old_occupant <> :OCCUPANT_NAME) or (:old_to_dt <> :TO_DATETIME)) then begin
    action_text = f_character(29) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                  || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                  || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');
  
    execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_CHANGED', :action_text);
  end
end
^

/* Restore proc. body: SAFE_OCCUPANCY_NEW */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE TYPE OF ID,
FROM_DATETIME TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME,
BOOKING_NUMBER TYPE OF TRES_NUMBER,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
ID_RESOURCE_RESERVATION TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable action_text tdescription_long;
  declare variable id_reserv_detail integer;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, s.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  if (:id_resource_reservation is not null) then exception ASSERT '-1064'|| f_character(31) || f_character(29) || :safe_name;

  select rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESERV_DETAIL rd
  where  rd.NUMBER = :BOOKING_NUMBER
         and rd.IS_ANUL = 0
  into   :id_reserv_detail, :id_agent_profile;

  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  execute procedure  RESOURCE_RESERVATION_MODIFY (null, :ID_SAFE, :FROM_DATETIME, :TO_DATETIME,
          :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :BOOKING_NUMBER, 'add')
  returning_values (:id_resource_reservation, :no_use) ;

  insert into SAFE_RESOURCE_RESERV (ID_RESOURCE_RESERV, PRICE_DESCRIPTION, ID_RATE_PRICE_PROFILE,
         RATING_UNITS, RATE_PRICE, RATE_CURR)
  values (:id_resource_reservation, :price_description, :id_agent_profile,
         :rating_units, :price, :currency);

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail, :ID_EXTERNAL_CLIENT_ACCCOUNT)
  returning_values (:DOC_SELECTED);

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = 'CHECKED_IN'
  where  RR.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = :id_resource_reservation
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                || f_character(28) || coalesce(:BOOKING_NUMBER, '')
                || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUPIED', :action_text);
end
^

/* Restore proc. body: TAR_CALC_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
declare variable param_code varchar(40);
  declare variable id_param integer;
  declare variable param_value varchar(255);
  declare variable data_type  varchar(30);
  declare variable rate_list varchar(2000);
begin
  err_code = 0;
  param_values = '';

  if (coalesce(:rate_list_replace, '') = '') then rate_list = ',' || :id_rate || ',';
  else rate_list = :rate_list_replace;

  for
    select distinct TBP.PARAM_NAME
    from   SYSTEM_STRING_PARSER (:rate_list, ',') sp
           left join TAR_BO_PARAMS TBP on TBP.ID_TAR_HEAD = sp.ITEM
    where  (TBP.PARAM_TYPE <> 'DATE_DEPENDANT' and :for_date is null)
           or (TBP.PARAM_TYPE = 'DATE_DEPENDANT' and :for_date is not null)
    into   :param_code
  do begin
    if (:param_code is not null) then begin
      id_param = null;
      select TP.ID_TARIFA_PARAM, TP.DATA_TYPE
      from   TARIFA_PARAMS TP
      where  TP.PARAM_CODE = :param_code
             and tp.IS_USE = 1
      into   :id_param, :data_type;
  
      if (:id_param is null) then begin
        err_code = -202;
        execute procedure sys_dbg ('tar calc params err_code: ' || :err_code || F_CRLF() || 'PARAM_CODE = ' || :param_code);
        exit;
      end
  
      execute procedure TARIFA_GET_PARAM (:id_param, :for_date, :id_tar_input, :id_tar_calc)
      returning_values (:param_value);
  
      param_code = ':'||param_code;
  
      if ((:param_code is not null) and (:param_code is not null) and (:data_type is not null)) then
         param_values = :param_values||';'||:param_code||','||:data_type||','||:param_value;
    end
  end
end
^

/* Restore proc. body: TAR_SAVE */
ALTER PROCEDURE TAR_SAVE(ID_TAR_HEAD INTEGER,
PERIOD_DEPEND_ON_CHECKIN INTEGER,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BASE_BOARDS_LIST VARCHAR(255),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
BO_TYPE VARCHAR(20),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable delim integer;
  declare variable id_hotel integer;
  declare variable action_text varchar(255);
begin
  if (:base_boards_list is null) then base_boards_list = '';
  if (:board_type not in ('BOARD', 'HRANI')) then begin
    if (:board_type = '0') then board_type = 'BOARD';
    else board_type = 'HRANI';
  end
  err_code = 0;
  err_text = '';
  execute procedure SETTING_GET_VALUE('RANGE_DATA_DELIMETER', null)
  returning_values  :delim;

  -- TAR_BO_PRICES are never cleared
  delete from TAR_BO_SEASON
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_BASE_POSITION
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_BOARD
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_EXTRA_GUEST
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_DISCOUNT
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_PACK
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_PARAMS
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_DISCOUNT_STAY
  where  ID_TAR_HEAD = :id_tar_head;
  update TAR_HEAD TH
  set    PERIOD_DEPEND_ON_CHECKIN = :period_depend_on_checkin,
         CNT_DAYS_PRICE_BP        = :cnt_days_price_bp,
         CNT_DAYS_PRICE_BOARD     = :cnt_days_price_board,
         BASE_BOARDS_LIST         = f_character(:delim)||:base_boards_list||f_character(:delim),
         BOARD_TYPE               = :board_type,
         LOCK_STAMP               = current_timestamp
  where  TH.ID_TAR_HEAD = :id_tar_head;
  update TARIFA T
  set    T.IS_BASE = 1
  where  T.ID_TARIFA = :id_tar_head;
  bo_type = 'SEASON';
  execute procedure TAR_SAVE_BO_SEASON(:id_tar_head)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'BASE';
  execute procedure TAR_SAVE_BO_BP(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'BOARD';
  execute procedure TAR_SAVE_BO_BOARD(:id_tar_head, :bo_type, :board_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'EXTRA_GUEST';
  execute procedure TAR_SAVE_BO_EG(:id_tar_head, :bo_type, :board_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'PACK';
  execute procedure TAR_SAVE_BO_PACK(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'DISCOUNT';
  execute procedure TAR_SAVE_BO_DISC(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'DISCOUNT_PERIOD';
  execute procedure TAR_SAVE_BO_DISC_PERIOD(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end

  select f_character(29) || T.TARIFA_NAME, T.id_hotel
  from   TARIFA T
  where  T.ID_TARIFA = :ID_TAR_HEAD
  into   :action_text, :id_hotel;

  execute procedure EXPORT_LOG_INSERT$EXC ('RATE_BASE', :id_tar_head, :id_hotel, 0);

  execute procedure SYSTEM_LOG_ADD ('RATE', :ID_TAR_HEAD, 'RATE_CHANGED', :action_text);

  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||'NONE'||', '||:err_text;
--    suspend;
    exception;
  end
end
^

/* Restore proc. body: TAR_SAVE_BO_BOARD */
ALTER PROCEDURE TAR_SAVE_BO_BOARD(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable id_tar_season integer;
  declare variable iteration varchar(20);
/*****************************************************/
  declare variable id_tar_board integer;
  declare variable id_board integer;
  declare variable id_service integer;
  declare variable pos_numbers varchar(2000);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable separate_board integer;
  declare variable id_bo_price integer;
  declare variable price_type varchar(20);
  declare variable price_type_equal_exists integer;
  declare variable is_board integer;
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  err_text = '';
  iteration = 'FIRST';
  price_type_equal_exists = 0;

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :id_tar_season, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_board, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
      if (:price_type_equal_exists = 1) then begin
        if (exists(
          select *
          from   TAR_BO_RELATION TBR
                 join TAR_BO_BASE_POSITION TBB on TBR.ID_TAR_BP = TBB.ID_TAR_BP
          where  TBR.ID_BO = :id_tar_board
                 and TBR.BO_TYPE = 'BOARD'
                 and TBB.ID_BOARD_INCLUDE is not distinct from :id_board
        )) then begin
          err_code = -237;
          exit;
        end
      end
      price_type_equal_exists = 0;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_board = gen_id(GEN_TAR_BO_BOARD_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers = '';
      id_board = null;
      separate_board = 0;
      ptext = '';
      disc_tag = 'F';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      packet_item = null;
    end
    if (:iteration = 'MIDDLE') then begin
      if (:param_name = 'PTEXT') then ptext = :data;
      else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
      else if (:param_name = 'SET_VAR')       then set_var = :data;
      else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
      else if (:param_name = 'LIST_BASE_POS') then pos_numbers = :data;
      else if (:param_name = 'SEPARATE_BOARD') then begin
        separate_board = :data;
        if ((:separate_board = 0) and (:board_type = 'HRANI')) then err_code = -226;
      end else if (:param_name = 'CHECKIN_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'NIGHT_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'PACKET_ITEM') then begin
        packet_item = :data;
      end else if (:param_name = 'HRANI') then begin
        if (:data = -1) then err_code = -210;
        else begin
          id_service = :data;
          select m.IS_BOARD
          from   MEALS M
          where  M.ID_SERVICE = :id_service
          into   :is_board;
          id_board = :id_service;

          if ((:is_board = 1) and (:board_type = 'HRANI')) then err_code = -228;
          else if ((:is_board = 0) and (:board_type = 'BOARD')) then err_code = -229;
        end
      end
      if (:err_code < 0) then exit;
      if ((:id_tar_season <> -1) and (:iteration = 'MIDDLE')) then begin
        /* WE ARE STARTING THE SEASON PRICES SO: */
        if ((:id_board is null) or (:id_board = -1)) then err_code = -210;
        else if ((:separate_board = 0) and (:board_type = 'HRANI')) then err_code = -226;
        if (:err_code < 0) then exit;
        if ((:separate_board = 1) and (:board_type = 'HRANI')) then separate_board = 2;
        insert into TAR_BO_BOARD(ID_TAR_BOARD, ID_TAR_HEAD, ID_SERVICE, ID_BOARD, PTEXT, SEPARATE_BOARD,
                    PACKET_ITEM, DISC_TAG, SET_VAR, RND_METHOD)
        values (:id_tar_board, :id_tar_head, :id_service, :id_board, :ptext, :separate_board,
               :packet_item, :disc_tag, :set_var, :rnd_method);
        iteration = 'SEASON_PRICES';
      end
    end
    if (:iteration = 'SEASON_PRICES') then begin
      execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_board, :bo_type, :id_tar_season)
      returning_values  :err_code, :id_bo_price, :price_type;
      if (:price_type = 'EQUAL') then begin
        if (:board_type = 'HRANI') then err_code = -225;
        price_type_equal_exists = 1;
      end
      if (:err_code < 0) then exit;
    end
  end
  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:BO_TYPE||', '||:err_text;
  end
end
^

/* Restore proc. body: TAR_SAVE_BO_BP */
ALTER PROCEDURE TAR_SAVE_BO_BP(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable no_use integer;
  declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable id_tar_season integer;
  declare variable iteration varchar(20);
/*****************************************************/
  declare variable id_tar_bp integer;
  declare variable position_number varchar(20);
  declare variable id_room_type integer;
  declare variable max_persons integer;
  declare variable id_board_include integer;
  declare variable is_price_for_room integer;
  declare variable ptext varchar(20);
  declare variable price_type varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable board_weight integer;
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :id_tar_season, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      param_filter = :data||season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      insert into TAR_BO_RELATION(ID_TAR_BP, BO_TYPE, ID_BO, PARAM_FILTER)
      values (:id_tar_bp, :bo_type, :id_tar_bp, :param_filter);
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_bp = gen_id(GEN_TAR_BO_BP_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      position_number = null;
      id_room_type = null;
      max_persons = null;
      id_board_include = -1;
      is_price_for_room = 0;
      ptext = '';
      disc_tag = 'B';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      packet_item = null;
    end
    if (:iteration = 'MIDDLE') then begin
      if (:param_name = 'BASE_POS')            then begin
        if (:data = '') then err_code = -203;
        else position_number = :data;
      end else if (:param_name = 'ROOM_TYPE')  then begin
        if (:data = '') then err_code = -204;
        else id_room_type = :data;
      end else if (:param_name = 'MAX_PERSONS')then begin
        if (:data = '') then err_code = -205;
        else max_persons = :data;
      end else if (:param_name = 'CHECKIN_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'NIGHT_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'BOARD')      then id_board_include = :data;
      else if (:param_name = 'BPRICE_ROOM')    then is_price_for_room = :data;
      else if (:param_name = 'PACKET_ITEM')    then packet_item = :data;
      else if (:param_name = 'PTEXT')          then ptext = :data;
      else if (:param_name = 'DISC_TAG')       then disc_tag = :data;
      else if (:param_name = 'SET_VAR')        then set_var = :data;
      else if (:param_name = 'ROUND_TYPE')     then rnd_method = :data;
      if (:err_code < 0) then exit;
      if ((:id_tar_season <> -1) and (:iteration = 'MIDDLE')) then begin
        /* WE ARE STARTING THE SEASON PRICES SO: */
        board_weight = null;
        select m.WEIGHT_TAG
        from   MEALS M
        where  m.ID_BOARD = :id_board_include
        into   :board_weight;
        board_weight = coalesce(:board_weight, 0);

        insert into TAR_BO_BASE_POSITION(
          ID_TAR_BP, ID_TAR_HEAD, POSITION_NUMBER, ID_ROOM_TYPE, MAX_PERSONS, SET_VAR, RND_METHOD,
          ID_BOARD_INCLUDE, BOARD_WEIGHT, IS_PRICE_FOR_ROOM, PTEXT, PACKET_ITEM, DISC_TAG)
        values (
          :id_tar_bp, :id_tar_head, :position_number, :id_room_type, :max_persons, :set_var, :rnd_method,
          :id_board_include, :board_weight, :is_price_for_room, :ptext, :packet_item, :disc_tag);
       iteration = 'SEASON_PRICES';
      end
    end
    if (:iteration = 'SEASON_PRICES') then begin
      execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_bp, :bo_type, :id_tar_season)
      returning_values  :err_code, :no_use, :price_type;
      if (:err_code < 0) then exit;
    end
  end
  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:BO_TYPE||', '||:err_text;
  end
end
^

/* Restore proc. body: TAR_SAVE_BO_DISC */
ALTER PROCEDURE TAR_SAVE_BO_DISC(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_disc integer;
  declare variable pos_numbers varchar(2000);
  declare variable id_service integer;
  declare variable prioritet integer;
  declare variable day_scheme varchar(20);
  declare variable day_scheme_num integer;
  declare variable price_type varchar(20);
  declare variable price varchar(2000);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable calc_type varchar(20);
  declare variable calc_list varchar(2000);
  declare variable in_base_price integer;
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  err_text = '';
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      if (:price = '') then err_code = -219;
      if (:err_code < 0) then exit;
      rnd_method = iif(coalesce(:rnd_method, '') = '', 'NONE', :rnd_method);
      insert into TAR_BO_DISCOUNT (
        ID_TAR_DISCOUNT, ID_TAR_HEAD, PRIORITET, DAY_SCHEME, DAY_SCHEME_NUM, DISC_TAG, SET_VAR, RND_METHOD,
        IS_IN_BASE_PRICE,  CALC_LIST, ID_SERVICE, PTEXT, PACKET_ITEM)
      values (
        :id_tar_disc, :id_tar_head, :prioritet, :day_scheme, :day_scheme_num, :disc_tag, :set_var, :rnd_method,
        :in_base_price, :calc_list, :id_service, :ptext, :packet_item);
      param_filter = :data||:season_filter;
      execute procedure tar_save_parse_param(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure tar_save_parse_pnum(:id_tar_head, :id_tar_disc, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_disc = gen_id(GEN_TAR_BO_DISCOUNT_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers   = '';
      id_service    = -1;
      day_scheme     = 'EVERY';
      day_scheme_num = 1;
      calc_type     = 'NONE';
      calc_list     = '';
      price         = '';
      prioritet     = 1;
      ptext         = '';
      disc_tag      = '';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      in_base_price = 0;
      packet_item   = null;
    end
    if (:param_name = 'SERVICE')            then begin
      if (:data = '') then id_service = -1;
      else id_service = :data;
    end else if (:param_name = 'PTEXT')     then ptext = :data;
    else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
    else if (:param_name = 'SET_VAR')       then set_var = :data;
    else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
    else if (:param_name = 'PRIORITET')     then prioritet     = :data;
    else if (:param_name = 'IN_BASE_PRICE') then in_base_price = :data;
    else if (:param_name = 'PACKET_ITEM')   then packet_item   = :data;
--    else if (:param_name = 'PRICE_NOTEQUAL') then begin
    else if (:param_name = 'PRICE_FORMULA') then begin
      price = trim(:data);
      if ((:id_service > 0) and (:in_base_price = 1) and (substring(:price from 1 for 1) = '-')) then err_code = -240;
      else if (:price = '') then err_code = -219;
      else
        execute procedure tar_save_parse_price(:price, :id_tar_disc, :bo_type, -1)
        returning_values  :err_code, :no_use, :price_type;
    end else if (:param_name = 'LIST_BASE_POS') then pos_numbers   = :data;
    else if (:param_name = 'DAY_SCHEME') then begin
      execute procedure tar_save_parse_dayschm(:data)
      returning_values  :err_code, :day_scheme, :day_scheme_num;
    end else if (:param_name = 'CALC_TYPE') then begin
      calc_list = :data;
--      execute procedure tar_save_parse_calctype(:data)
--      returning_values  :err_code, :calc_type, :calc_list;
    end else if (:param_name = 'CHECKIN_SEASON') then begin
      execute procedure tar_save_parse_season(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end else if (:param_name = 'NIGHT_SEASON') then begin
      execute procedure tar_save_parse_season(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end
    if (:err_code < 0) then exit;
  end
/*  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
  end*/
end
^

/* Restore proc. body: TAR_SAVE_BO_DISC_PERIOD */
ALTER PROCEDURE TAR_SAVE_BO_DISC_PERIOD(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_disc integer;
  declare variable pos_numbers varchar(2000);
  declare variable id_service integer;
  declare variable prioritet integer;
  declare variable calc_position varchar(20);
  declare variable price_type varchar(20);
  declare variable price varchar(2000);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable calc_list varchar(2000);
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  err_text = 'OBJECT='||:bo_type;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      if (:price = '') then err_code = -219;
      if (:calc_position = '') then err_code = -244;
      if (:err_code < 0) then exit;
      insert into TAR_BO_DISCOUNT_STAY (ID_TAR_DISCOUNT_STAY, ID_TAR_HEAD, PRIORITET, CALC_POSITION,
             CALC_LIST, ID_SERVICE, PTEXT, DISC_TAG, SET_VAR, RND_METHOD)
      values (:id_tar_disc, :id_tar_head, :prioritet, :calc_position,
             :calc_list, :id_service, :ptext, :disc_tag, :set_var, :rnd_method);

      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_disc, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration = 'MIDDLE';
      id_tar_disc = gen_id(GEN_TAR_BO_DISCOUNT_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers   = '';
      id_service    = -1;
      calc_list     = '';
      price         = '';
      prioritet     = 1;
      calc_position = 'GUEST_PERIOD';
      ptext         = '';
      disc_tag      = '';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
    end
    if (:param_name = 'SERVICE')            then begin
      if (:data = '') then id_service = -1;
      else id_service = :data;
    end else if (:param_name = 'PTEXT')     then ptext = :data;
    else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
    else if (:param_name = 'SET_VAR')       then set_var = :data;
    else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
    else if (:param_name = 'PRIORITET')     then prioritet     = :data;
    else if (:param_name = 'PERIOD_BASE_TYPE')    then calc_position = :data;
    else if (:param_name = 'PRICE_FORMULA') then begin
      price = trim(:data);
      if (:price = '') then err_code = -219;
      else begin
        execute procedure TAR_SAVE_PARSE_PRICE(:price, :id_tar_disc, :bo_type, -1)
        returning_values  :err_code, :no_use, :price_type;
        if (:err_code < 0) then exit;
      end
    end else if (:param_name = 'LIST_BASE_POS') then pos_numbers   = :data;
    else if (:param_name = 'CALC_TYPE') then begin
      calc_list = :data;
--      execute procedure tar_save_parse_calctype(:data)
--      returning_values  :err_code, :calc_type, :calc_list;
    end else if (:param_name = 'CHECKIN_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end else if (:param_name = 'NIGHT_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end
    if (:err_code < 0) then exit;
  end
  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
--    exception;
  end
end
^

/* Restore proc. body: TAR_SAVE_BO_EG */
ALTER PROCEDURE TAR_SAVE_BO_EG(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable id_tar_season integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_eg integer;
  declare variable pos_numbers varchar(2000);
  declare variable min_payors integer;
  declare variable max_extra_guests integer;
  declare variable order_num integer; /* !!!! */
  declare variable id_price_bb integer;
  declare variable id_price_eb integer;
  declare variable price_type varchar(20);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable is_packet_reduction integer;
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :id_tar_season, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_eg, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_eg = gen_id(GEN_TAR_BO_EG_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers = '';
      min_payors  = null;
      id_price_eb = -1;
      id_price_bb = -1;
      order_num   = 99;
      ptext       = '';
      disc_tag    = '';
      set_var = '';
      is_packet_reduction = 0;
      rnd_method = 'MATH';
      season_filter = '';
      max_extra_guests = null;
      packet_item = null;
    end
    if (:iteration = 'MIDDLE') then begin
      if (:param_name = 'LIST_BASE_POS')   then pos_numbers = :data;
      else if (:param_name = 'SET_VAR')    then set_var = :data;
      else if (:param_name = 'ROUND_TYPE') then rnd_method = :data;
      else if (:param_name = 'MIN_PAYORS') then begin
        if (:data = '') then err_code = -213;
        else min_payors = :data;
      end else if (:param_name = 'MAX_EG') then begin
        if (:data = '') then err_code = -214;
        else max_extra_guests = :data;
      end else if (:param_name = 'EG_ORDER')   then begin
        if (:data = '') then order_num = 99;
        else order_num = :data;
        if (:order_num < 1) then err_code = -215;
      end else if (:param_name = 'CHECKIN_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'NIGHT_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'PTEXT')     then ptext = :data;
      else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
      else if (:param_name = 'EG_POST_TYPE')  then is_packet_reduction = :data;
      else if (:param_name = 'PACKET_ITEM')   then packet_item = :data;
      else if (:param_name = 'BB_PRICE')   then begin
        if (:data <> '') then begin
          execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_eg, :bo_type, -1)
          returning_values  :err_code, :id_price_bb, :price_type;
          if ((:board_type = 'HRANI') and (:price_type <> 'PERCENT')) then begin
            err_code = -227;
            exit;
          end
        end
      end else if (:param_name = 'EB_PRICE') then begin
        if (:data <> '') then begin
          execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_eg, :bo_type, -1)
          returning_values  :err_code, :id_price_eb, :price_type;
          if ((:board_type = 'HRANI') and (:price_type <> 'PERCENT')) then begin
            err_code = -227;
            exit;
          end
        end
      end
      if (:err_code < 0) then exit;
      if ((:id_tar_season <> -1) and (:iteration = 'MIDDLE')) then begin
        if (:min_payors is null) then err_code = -213;
        if (:max_extra_guests is null) then err_code = -214;
        if (:err_code < 0) then exit;
        /* WE ARE STARTING THE SEASON PRICES SO: */
        insert into TAR_BO_EXTRA_GUEST(
          ID_TAR_EG, ID_TAR_HEAD, MIN_PAYORS, MAX_EXTRA_GUESTS, EG_ORDER, IS_PACKET_REDUCTION,
          ID_PRICE_BB, ID_PRICE_EB, PTEXT, PACKET_ITEM, DISC_TAG, SET_VAR, RND_METHOD)
        values (
          :id_tar_eg, :id_tar_head, :min_payors, :max_extra_guests, :order_num, :is_packet_reduction,
          :id_price_bb, :id_price_eb, :ptext, :packet_item, :disc_tag, :set_var, :rnd_method);
        iteration = 'SEASON_PRICES';
      end
    end
    if (:iteration = 'SEASON_PRICES') then begin
      execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_eg, :bo_type, :id_tar_season)
      returning_values  :err_code, :no_use, :price_type;
      if (:err_code < 0) then exit;
    end
  end
  when any do begin
    err_code = -200;
    err_text = ''||:iteration||' '||:id_price_bb||' '||:id_price_eb;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
/*    err_text = ' '||:min_payors||' '||:max_extra_guests||' '||:order_num;*/
  end
end
^

/* Restore proc. body: TAR_SAVE_BO_PACK */
ALTER PROCEDURE TAR_SAVE_BO_PACK(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_pack integer;
  declare variable pos_numbers varchar(2000);
  declare variable id_service integer;
  declare variable day_scheme varchar(20);
  declare variable day_scheme_num integer;
  declare variable cnt_post integer;
  declare variable pack_currency char(3);
  declare variable in_base_price integer;
  declare variable grp_rpt varchar(20);
  declare variable grp_docs varchar(20);
  declare variable price_type varchar(20);
  declare variable price_pack varchar(20);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      if (:price_pack = '') then err_code = -216;
      if (:id_service is null) then err_code = -217;
      if (:err_code < 0) then exit;
      insert into TAR_BO_PACK(
        ID_TAR_PACK, ID_TAR_HEAD, ID_SERVICE, PRICE_CURRENCY, IS_IN_BASE_PRICE,
        CNT_POST,  DAY_SCHEME, DAY_SCHEME_NUM, GRP_IN_REPORTS,
        GRP_IN_DOCUMENTS, PTEXT, PACKET_ITEM, DISC_TAG, SET_VAR, RND_METHOD)
      values (
        :id_tar_pack, :id_tar_head, :id_service, :pack_currency, :in_base_price,
        :cnt_post, :day_scheme, :day_scheme_num, :grp_rpt,
        :grp_docs, :ptext, :packet_item, :disc_tag, :set_var, :rnd_method);
      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_pack, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_pack = gen_id(GEN_TAR_BO_PACK_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers   = '';
      id_service    = null;
      day_scheme     = 'EVERY';
      day_scheme_num = 1;
      cnt_post      = 0;
/*
        select TH.TARIFA_CURR
        from   TAR_HEAD TH
        where  TH.ID_TAR_HEAD = :id_tar_head
        into   :pack_currency;
*/    pack_currency = '';
      in_base_price = 0;
      grp_rpt       = '';
      grp_docs      = '';
      price_pack    = '';
      ptext         = '';
      disc_tag      = '';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      packet_item   = null;
    end
    if (:param_name = 'SERVICE') then begin
      if ((:data = '') or (:data = '-1')) then err_code = -217;
      else if (:data = '0') then err_code = -222;
      else id_service = :data;
    end else if (:param_name = 'CNT_POST')  then cnt_post      = :data;
    else if (:param_name = 'IN_BASE_PRICE') then in_base_price = :data;
    else if (:param_name = 'GRP_RPT')       then grp_rpt       = :data;
    else if (:param_name = 'GRP_DOCS')      then grp_docs      = :data;
    else if (:param_name = 'PTEXT')         then ptext         = :data;
    else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
    else if (:param_name = 'SET_VAR')        then set_var = :data;
    else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
    else if (:param_name = 'PACKET_ITEM')   then packet_item   = :data;
    else if (:param_name = 'PRICE')         then begin
      price_pack    = :data;
      if (:price_pack = '') then err_code = -216;
      else
        execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_pack, :bo_type, -1)
        returning_values  :err_code, :no_use, :price_type;
    end else if (:param_name = 'LIST_BASE_POS') then pos_numbers   = :data;
    else if (:param_name = 'CURRENCY') then begin
      if ((:data <> upper(:data)) or (char_length(:data) <> 3)) then err_code = -218;
      else pack_currency = :data;
    end else if (:param_name = 'DAY_SCHEME') then begin
      execute procedure TAR_SAVE_PARSE_DAYSCHM(:data)
      returning_values  :err_code, :day_scheme, :day_scheme_num;
    end else if (:param_name = 'CHECKIN_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end else if (:param_name = 'NIGHT_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end
    if (:err_code < 0) then exit;
  end
  when any do begin
    err_code = -200;
/*    err_text = ' '||:id_service||' '||:pack_currency||' '||:in_base_price;*/
/*    err_text = ' '||:day_scheme||' '||:day_scheme_num;*/
    err_text = ' '||:cnt_post||' '||:grp_rpt||' '||:grp_docs||' '||:ptext;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
  end
end
^

/* Restore proc. body: TAR_SAVE_BO_SEASON */
ALTER PROCEDURE TAR_SAVE_BO_SEASON(ID_TAR_HEAD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable delim integer;
  declare variable id_dim2 integer;
  declare variable id_season integer;
  declare variable from_date date;
  declare variable to_date date;
  declare variable idate date;
begin
  err_code = 0;
  execute procedure SETTING_GET_VALUE('RANGE_DATA_DELIMETER', null)
  returning_values  :delim;
  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, 'SEASON') TSP
    into    :param_name, :row_id, :id_dim2, :data, :col_id
  do begin
    if (:param_name = 'NAME') then begin
      id_season = gen_id(GEN_TAR_BO_SEASON_ID, 1);
      insert into TAR_BO_SEASON(ID_TAR_SEASON, ID_TAR_HEAD, SEASON_NAME, ID_DIM2)
      values (:id_season, :id_tar_head, :data, :id_dim2);
    end else if ((:param_name = 'PERIOD') and (:data <> '')) then begin
      from_date = null; to_date =null;
      for
        select SPD.ITEM
        from   SYSTEM_STRING_PARSER(:data, f_character(:delim)) SPD
        into   :idate
      do begin
        if (:from_date is null) then from_date = :idate;
        else to_date = :idate;
      end
      /* CHECK VALIDITY */
      if (exists(
        select *
        from   TAR_BO_SEASON TBS
               join TAR_BO_SEASON_PERIOD TSP
                 on TSP.ID_TAR_SEASON = TBS.ID_TAR_SEASON
        where  TBS.ID_TAR_HEAD = :id_tar_head
               and TSP.FROM_DATE <= :to_date
               and TSP.TO_DATE >= :from_date
      )) then begin
        err_code = -201;
        exit;
      end
      insert into TAR_BO_SEASON_PERIOD (ID_TAR_SEASON, FROM_DATE, TO_DATE)
      values (:id_season, :from_date, :to_date);
    end
  end
  when any do begin
    err_code = -200;
    err_text = :data;
    err_text = 'OBJECT='||'SEASONS'||', '||:err_text;
  end
end
^

/* Alter Procedure... */
/* Alter (ACCOUNT_JOIN_IN_ONE_BY_STRING) */
ALTER PROCEDURE ACCOUNT_JOIN_IN_ONE_BY_STRING(IN_TARGET_ID_ACCOUNT INTEGER,
IN_SOURCE_STRING VARCHAR(1000))
 AS
declare variable source_id_account integer;
  declare variable id_deposit integer;
  declare variable avail_value numeric(15,4);
  declare variable dbg varchar(1000);
  declare variable description varchar(100);
  declare variable doc_selected integer;
begin

  for
    select cast(ITEM as integer)
    from   SYSTEM_STRING_PARSER(:IN_SOURCE_STRING, 'x')
    into   :source_id_account
  do begin
    if (:source_id_account <> :in_target_id_account) then begin
      doc_selected = gen_id(DOC_SELECTED_GEN, 1);
      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :doc_selected
      where  AP.ID_ACCOUNT =  :source_id_account
             and AP.AC = '00'
             and AP.ID_BASE_DOC is null;

      /* call next procedure because of logging */
      execute procedure ACCOUNT_POSTING_TRANSFER$ACC(:doc_selected, :in_target_id_account, :source_id_account);

      for
        select DA.ID_DEPOSIT, DA.AVAIL_VALUE, DA.DESCRIPTION
        from   DEPOSIT_AVAILABLE DA
        where  DA.ID_ACCOUNT = :source_id_account
        into   :id_deposit, :avail_value, :description
      do begin
        execute procedure DEPOSIT_TRANSFER$ACC (:id_deposit, :in_target_id_account, :avail_value, :description)
        returning_values  :dbg;
      end 
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: GUEST_ACCOUNT_TRANSFER$INT for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE GUEST_ACCOUNT_TRANSFER$INT(ID_GUEST INTEGER,
ID_SOURCE_ACCOUNT INTEGER,
ID_TARGET_ACCOUNT INTEGER,
SERVICE_TYPE VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: GUEST_REROUTE_POSTINGS$INT for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE GUEST_REROUTE_POSTINGS$INT(ID_GUEST INTEGER,
ID_BASE_ACCOUNT INTEGER,
ID_EXTRA_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_TRANSFER$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER)
 AS
declare variable id_current_account integer;
  declare variable id_service integer;
  declare variable is_anul integer;
  declare variable id_tariff integer;
  declare variable qty_post numeric(15,2);
  declare variable qty_free numeric(15,2);
  declare variable price_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable id_room integer;
  declare variable id_base_doc integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  if ((:AP_DBKEY is null) or (:id_target_account is null) or (:id_target_account < 0)) then
     exception POSTING_TRANSFER_EXCEPTION '-31';

  select AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST, AP.QTY_FREE,
         AP.PRICE_ORIG, AP.CURR_ORIG, AP.RATE_ORIG, ap.from_date, ap.to_date,
         AP.IS_ANUL, AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_BASE_DOC, A.ID_HOTEL
  from   ACCOUNT_POST AP
         left join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :id_service, :id_tariff, :id_room, :qty_post, :qty_free,
         :price_orig, :curr_orig, :rate_orig, :from_date, :to_date,
         :is_anul, :id_account_post, :id_current_account, :id_base_doc, :id_hotel;

  if (:id_current_account = :id_target_account) then EXIT;

  if (:is_anul = 1 ) then exception POSTING_TRANSFER_EXCEPTION '-33';

  if (:id_base_doc is not null) then exception POSTING_TRANSFER_EXCEPTION '-32';

  if (not exists(select A.ID_ACCOUNT
                 from   ACCOUNT A
                 where  A.ID_ACCOUNT = :ID_TARGET_ACCOUNT
                        and A.ID_HOTEL = :id_hotel)) then exception POSTING_TRANSFER_EXCEPTION '-376';

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
                    :id_tariff, :id_room, :qty_post, :qty_free, :price_orig, :curr_orig,
                    :rate_orig, 'TRANSFER_POSTING', null, :from_date, :to_date, 0, :id_target_account)
  returning_values  :no_use, :no_use, :no_use;

  insert into ACCOUNT_TRANSFER_HISTORY(ID_ACCOUNT_POST, FROM_ID_ACCOUNT, TO_ID_ACCOUNT)
  values (:id_account_post, :id_current_account, :id_target_account);
end
^

/* Alter (ACCOUNT_POSTING_UPDATE) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable in_db_key char(8);
begin
  /* GUI facade for manual update */
  select AP.ID_ACCOUNT, AP.ID_GUEST, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :id_guest, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date)
  returning_values  (:new_qty_post, :new_price_post, :new_ac);

  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    if (coalesce(:id_guest, 0) > 0) then begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || :id_account
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'POST_UPDATE', :action_text);
    end else begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
    end
  end

end
^

/* empty dependent procedure body */
/* Clear: CANCEL_BOOKING$EXC for: APPLY_BOOKING_STATUS$EXC */
ALTER PROCEDURE CANCEL_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20),
STATUS VARCHAR(20))
 RETURNS(BOOKING_ID INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_BOOKING_FINALIZE$EXC for: APPLY_BOOKING_STATUS$EXC */
ALTER PROCEDURE IMPORT_BOOKING_FINALIZE$EXC(BOOKING_ID INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1,
STATUS VARCHAR(50) = null,
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20) = null,
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20) = null)
 RETURNS(RECORD_TIMESTAMP TIMESTAMP,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (APPLY_BOOKING_STATUS$EXC) */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20)
 AS
declare variable err_text varchar(255);
declare variable dummy_int integer;
declare variable anul_reason varchar(30);
declare variable selection_id integer;

declare variable status_code smallint;
declare variable current_anul_code smallint;
declare variable current_status_code smallint;
declare variable current_status_text varchar(50);
declare variable new_status_text varchar(50);
declare variable extra_posts_left integer;
begin
  if (:booking_db_key is null) then begin
    select rd.RDB$DB_KEY, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.ID_RESERV_DETAIL = :BOOKING_ID
    into   :booking_db_key, :current_status_code, :current_anul_code;
  end else begin
    select rd.id_reserv_detail, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.rdb$db_key = :booking_db_key
    into   :booking_id, :current_status_code, :current_anul_code;
  end

  execute procedure IMPORT_BOOKING_STATUS$EXC(:status, -2)
  returning_values :status_code;

  execute procedure EXPORT_BOOKING_STATUS$EXC(:current_status_code, :current_anul_code)
  returning_values :current_status_text;
  execute procedure IMPORT_BOOKING_STATUS$EXC(:current_status_text, :current_status_code)
  returning_values :current_status_code;

  /* nop - exit */
  if (:current_status_code = :status_code) then exit;

  /* validate status transition */
  if (
     /* terminal status values - void booking */
    (:current_status_code in (1004/*no show*/, 1005/*canceled*/))

    /* void over checkin */
    or ((:current_status_code >= 0) and (:status_code in (1004/*no show*/, 1005/*canceled*/)))

    /* positive status downgrade */
    or ((:current_status_code > 0) and (:current_status_code > :status_code))
  )  then begin
    execute procedure PRINT_BOOKING_STATUS$EXC(:current_status_code) returning_values :current_status_text;
    execute procedure PRINT_BOOKING_STATUS$EXC(:status_code) returning_values :new_status_text;

    exception VALIDATE_EXCEPTION '-1022' || f_character(31) || '@{invalid_status_transition} ' || :current_status_text || ' -> ' || :new_status_text;
  end

  anul_reason = null;
  if (1004 = :status_code) then begin
    anul_reason = 'NOSHOW';
  end else if (1005 = :status_code) then begin
    anul_reason = 'CANCELED';
  end

  if (:anul_reason is null) then begin
    if (0 > :status_code) then begin
      execute procedure RES_SAVE_STATUS$INT(:booking_db_key, :status_code, :CONFIRMATION_NUMBER);
    end else begin
      if (:status_code in (0, 1) and 0 > :current_status_code) then begin
        -- checkin
        execute procedure RES_SET_CHECKIN$INT (:booking_db_key)
        returning_values (:dummy_int, :err_text, :dummy_int, :dummy_int);
      end
      if (1 = :status_code and 1 > :current_status_code) then begin
        -- checkout
        selection_id = gen_id(SELECTION_GEN, 1);
        update RESERV_DETAIL
        set    selection_id=:selection_id
        where  rdb$db_key=:booking_db_key;
    
        execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id);
      end
    end
  end else begin
    -- void
    execute procedure RES_ANUL_DETAIL$INT(:booking_db_key, :anul_reason, :CANCELATION_NUMBER)
    returning_values  :dummy_int, :extra_posts_left;
    if (:extra_posts_left = 1) then exception BOOKING_EXCEPTION '-1042';

  end
end
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUPANCY$RPT for: AVAILABILITY_OCCUP_PREPARE$AVL */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$RPT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ID_ROOM_TYPE INTEGER,
FOR_DATE DATE,
ID_PROFILE INTEGER,
ROOMS_AVAILABLE SMALLINT,
ROOMS_OOI SMALLINT,
ROOMS_OOO SMALLINT,
ROOMS_SOLD_CONFIRMED SMALLINT,
ROOMS_SOLD_NOTCONFIRMED SMALLINT,
ROOMS_SOLD SMALLINT,
ROOMS_SOLD_MULTIPLE_GST SMALLINT,
ROOMS_ARRIVAL SMALLINT,
ROOMS_DEPARTURE SMALLINT,
GUESTS_IN_HOUSE BIGINT,
GUESTS_ARRIVAL BIGINT,
GUESTS_DEPARTURE BIGINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: OCCUPANCY_RTI_BP$RPT for: AVAILABILITY_OCCUP_PREPARE$AVL */
ALTER PROCEDURE OCCUPANCY_RTI_BP$RPT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ROOM_TYPES VARCHAR(255))
 RETURNS(OUT_DATE DATE,
CATEGORY VARCHAR(50),
AGENT_NAME VARCHAR(50),
ROOM_CNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SUMMARY_FORECAST$INT for: AVAILABILITY_OCCUP_PREPARE$AVL */
ALTER PROCEDURE SUMMARY_FORECAST$INT(ID_HOTEL INTEGER,
SUMMARY_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* Alter (AVAILABILITY_OCCUP_PREPARE$AVL) */
ALTER PROCEDURE AVAILABILITY_OCCUP_PREPARE$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS INTEGER,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
begin

  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, :FETCH_TOTALS, 1, 1, 1, 1, 1, 1, :HOTELS);
   
  execute procedure AVAILABILITY_OCCUPANCY_OPT$INT (:RELEASE_DATES, :OVERBOOK,
          :RES_CONFIRMED, :RES_NOTCONFIRMED, :RES_WAITING, :BOOKING_POSITIONS, :CONTINGENT);

end
^

/* empty dependent procedure body */
/* Clear: TEST_AVAILABILITY for: AVAILABILITY_OCCUPANCY$AVL */
ALTER PROCEDURE TEST_AVAILABILITY RETURNS(FOR_DATE DATE,
MINUS_ROOM_TYE INTEGER,
ID_AGENT INTEGER,
AGENT_NAME VARCHAR(100),
SOLD INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
CONT_BP_REMAIN INTEGER,
RES_WAITING INTEGER,
CONT_PLAIN INTEGER,
CONT_BP INTEGER,
CONT_BP_PLAIN INTEGER,
CONT_PLAIN_REMAIN INTEGER,
RES_TOTAL INTEGER,
ROOM_TYPE_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* Alter (AVAILABILITY_OCCUPANCY$AVL) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
begin

  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, :FETCH_TOTALS, 1, 1, 1, 1, 1, 1, :HOTELS);

  ID_OCCUPANCY_SESSION = current_transaction;
end
^

/* Alter (AVAILABILITY_OCCUPANCY$INT) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$INT(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
declare variable id_global_agent integer;
  declare variable for_date date;
  declare variable id_agent integer;
  declare variable id_room_type integer;
  declare variable g_capacity integer;
  declare variable bp_defined integer;
  declare variable c_defined integer;
  declare variable fdata integer;
  declare variable bp_is_released integer;
  declare variable c_is_released integer;
  declare variable gsts_in_house integer;
  declare variable gsts_come integer;
  declare variable gsts_gone integer;
  declare variable rooms_come integer;
  declare variable rooms_gone integer;
  declare variable id_hotel integer;
  declare variable id_b_allotment integer;
  declare variable id_c_allotment integer;
  declare variable ooo_rooms integer;
  declare variable ooi_rooms integer;
  declare variable sold_rooms integer;
  declare variable res_room_conf integer;
  declare variable res_room_notconf integer;
  declare variable res_room_wait integer;
begin
  /*  Description:   */
  HOTELS = coalesce(:HOTELS, '');
  ID_GLOBAL_AGENT = -100; /* HOLDS DATA GLOBAL FOR THE HOTEL */

  delete from SMART_OCCUP$TMP;

  for
    select RC.ID_ROOM_TYPE, RC.ID_HOTEL, RC.FOR_DATE, sum(RC.CNT_DEFINED)
    from   HOTEL_S H
           left outer join ALLOTMENT_GET$INT(H.ID_INVENTORY_ALLOTMENT, :FROM_DATE, :TO_DATE, null, 'PLAIN_PERIOD', :HOTELS) RC on 0=0
    where  ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
    group by 1, 2, 3
    into   :ID_ROOM_TYPE, :ID_HOTEL, :FOR_DATE, :G_CAPACITY
  do begin
    execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_global_agent, :id_room_type, :id_hotel, :g_capacity);
  end

  for
    select   RM.BUSY_DATE, RM.ID_ROOM_TYPE, RM.ID_HOTEL,
             iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (18,20), :ID_GLOBAL_AGENT, coalesce(RS.ID_AGENT, RM.ID_AGENT)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 18, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 20, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 24, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_CONFIRMED', RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_NOTCONFIRMED', RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_RESERVS', RM.ID_ROOM, null))
    from     ROOM_MAGIC RM
             join HOTEL_S H on H.ID_HOTEL = RM.ID_HOTEL
             left outer join ROOMS_SHARE RS on RS.ID_ROOM_SHARE = RM.ID_ROOM_MAGIC
    where    RM.BUSY_DATE between :from_date and :to_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
             and rm.ROOM_STATUS is distinct from 'PRIVATE'
             and ((not (:RES_CONFIRMED = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_CONFIRMED'))
                  or (not (:RES_NOTCONFIRMED = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_NOTCONFIRMED'))
                  or (not (:RES_WAITING = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_RESERVS')))
    group by 1, 2, 3, 4
    into     :for_date, :id_room_type, :id_hotel, :id_agent,
             :ooo_rooms, :ooi_rooms, :sold_rooms, :res_room_conf, :res_room_notconf, :res_room_wait
  do begin
    execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
            null, :ooo_rooms, :ooi_rooms, null, :sold_rooms, :res_room_conf, :res_room_notconf, :res_room_wait);
  end

  if (:BOOKING_POSITIONS + :CONTINGENT > 0) then begin
    for
      select PA.ID_AGENT, PA.ID_BOOKING_POSITION, pa.ID_CONTINGENT
      from   PROFILE_AGENT PA
      where  (pa.ID_CONTINGENT is not null) or (pa.ID_BOOKING_POSITION is not null)
      into   :id_agent, :id_b_allotment, :id_c_allotment
    do begin
      for
        select al.for_date, al.id_room_type, al.id_hotel,
               sum(al.b_defined), max(al.b_is_released), sum(al.c_defined), max(al.c_is_released)
        from   (select ABP.FOR_DATE, ABP.ID_ROOM_TYPE, ABP.ID_HOTEL,
                       ABP.CNT_DEFINED as b_defined, ABP.IS_RELEASED as b_is_released, null as c_defined, null as c_is_released
                from   ALLOTMENT BA
                       left join ALLOTMENT_GET$INT(ba.ID_ALLOTMENT, :from_date, :to_date, null, 'RELEASES', :hotels) ABP on 1=1
                where  :BOOKING_POSITIONS = 1 and ba.ID_ALLOTMENT = :id_b_allotment
                union all
                select ACG.FOR_DATE, ACG.ID_ROOM_TYPE, ACG.ID_HOTEL, null, null, ACG.CNT_DEFINED, ACG.IS_RELEASED
                from   ALLOTMENT CA
                       left join ALLOTMENT_GET$INT(ca.ID_ALLOTMENT, :from_date, :to_date, null, '', :hotels) ACG on 1=1
                where  :CONTINGENT = 1 and CA.ID_ALLOTMENT = :id_c_allotment
               ) al
        where  al.for_date is not null
        group by 1, 2, 3
        into   :for_date, :id_room_type, :id_hotel,
               :bp_defined, :bp_is_released, :c_defined, :c_is_released
      do begin
        execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
                null, null, null, null, null, null, null, null, :c_defined, :c_is_released, :bp_defined, :bp_is_released);
      end
    end
  end

  if (:OVERBOOK = 1) then begin
    for
      select ACG.FOR_DATE, ACG.ID_ROOM_TYPE, ACG.ID_HOTEL, ACG.CNT_DEFINED
      from   HOTEL_S H
             left outer join ALLOTMENT_GET$INT(H.ID_OVERBOOK_ALLOTMENT, :FROM_DATE, :TO_DATE, null, '', :HOTELS) ACG on 0=0
      where  ACG.FOR_DATE is not null
             and ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
      into   :for_date, :id_room_type, :id_hotel, :fdata
    do begin
      execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
              null, null, null, :fdata);
    end
  end

  if (:FETCH_TOTALS = 1) then begin
    for
      select SOGT.BUSY_DATE, SOGT.ID_ROOM_TYPE, sum(SOGT.GSTS_COME+SOGT.GSTS_STAYOVER), sum(SOGT.GSTS_COME),
             sum(SOGT.GSTS_GONE), sum(SOGT.ROOMS_COME), sum(SOGT.ROOMS_GONE), SOGT.ID_HOTEL, SOGT.ID_AGENT
      from   REP_ROOM_STATUS_MOVE(:from_date, :to_date, -1, -1, -1, '', '', :hotels) SOGT
      group by SOGT.BUSY_DATE, SOGT.ID_ROOM_TYPE, SOGT.ID_HOTEL, SOGT.ID_AGENT
      into   :for_date, :id_room_type, :gsts_in_house, :gsts_come,
             :gsts_gone, :rooms_come, :rooms_gone, :id_hotel, :id_agent
    do begin
      execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
              null, null, null, null, null, null, null, null, null, null, null, null,
              :gsts_in_house, :gsts_come, :gsts_gone, :rooms_come, :rooms_gone);
    end
  end
end
^

/* Alter (AVAILABILITY_OCCUPANCY$RPT) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$RPT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ID_ROOM_TYPE INTEGER,
FOR_DATE DATE,
ID_PROFILE INTEGER,
ROOMS_AVAILABLE SMALLINT,
ROOMS_OOI SMALLINT,
ROOMS_OOO SMALLINT,
ROOMS_SOLD_CONFIRMED SMALLINT,
ROOMS_SOLD_NOTCONFIRMED SMALLINT,
ROOMS_SOLD SMALLINT,
ROOMS_SOLD_MULTIPLE_GST SMALLINT,
ROOMS_ARRIVAL SMALLINT,
ROOMS_DEPARTURE SMALLINT,
GUESTS_IN_HOUSE BIGINT,
GUESTS_ARRIVAL BIGINT,
GUESTS_DEPARTURE BIGINT)
 AS
begin

  execute procedure AVAILABILITY_OCCUP_PREPARE$AVL (:FROM_DATE, :TO_DATE, 1, 0, 0, 1, 1, 0, 0, 0, :ID_HOTEL);

  for
    select SO.ID_ROOM_TYPE,
           SO.FOR_DATE,
           pa.id_profile,
           sum(SO.G_CAPACITY),
           sum(so.G_OOI),
           sum(so.G_OOO),
           sum(so.SOLD + so.RES_CONFIRMED),
           sum(so.RES_NOTCONFIRMED),
           sum(so.SOLD + so.RES_CONFIRMED + so.RES_NOTCONFIRMED),
           sum(iif(so.GUESTS_INHOUSE > 1, so.SOLD, 0)),
           sum(so.ROOMS_COME),
           sum(so.ROOMS_GONE),
           sum(so.GUESTS_INHOUSE),
           sum(so.GUESTS_COME),
           sum(so.GUESTS_GONE)
    from   SMART_OCCUP$TMP SO
           left outer join PROFILE_AGENT pa on pa.id_agent = so.id_agent
    group by 1, 2, 3
    into   :ID_ROOM_TYPE, :FOR_DATE, :id_profile, :ROOMS_AVAILABLE, :ROOMS_OOI, :ROOMS_OOO,
           :ROOMS_SOLD_CONFIRMED, :ROOMS_SOLD_NOTCONFIRMED,
           :ROOMS_SOLD, :ROOMS_SOLD_MULTIPLE_GST, :ROOMS_ARRIVAL, :ROOMS_DEPARTURE,
           :GUESTS_IN_HOUSE, :GUESTS_ARRIVAL, :GUESTS_DEPARTURE
  do begin
    suspend;
  end
end
^

/* Alter (CANCEL_BOOKING$EXC) */
ALTER PROCEDURE CANCEL_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20,
STATUS VARCHAR(20))
 RETURNS(BOOKING_ID INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable hotel_id integer;
declare variable cancel_event_log_id integer;
begin
  /* init */
  err_code = 0;
  err_text = '';

  execute procedure import_mark_transaction$exc;

  select first 1 b.id_reserv_detail, b.id_log_event_annul, b.from_date, b.to_date
  from   reserv_detail b
  where  b.number=:number
         and b.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  order by id_log_event_annul nulls first
  into   :booking_id, cancel_event_log_id, :from_date, :to_date;

  if ((:booking_id is null) or (:cancel_event_log_id is not null)) then begin
    /* not found or found but already in void status - ignore and exit */
    exit;
  end

  /* verify hotel */
  execute procedure lookup_hotel$exc(:hotel, 'BOOKING', :booking_id)
  returning_values :hotel_id;

  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  execute procedure APPLY_BOOKING_STATUS$EXC(
    :booking_id, null, :status, :confirmation_number, :cancelation_number
  );
end
^

/* Alter (DEPOSIT_DOCUMENT_INITIALIZE$DOC) */
ALTER PROCEDURE DEPOSIT_DOCUMENT_INITIALIZE$DOC(ID_PAYMENT_HEAD TYPE OF ID,
ID_BILLING_SERVICE TYPE OF ID)
 RETURNS(ID_DOC_HEAD TYPE OF ID,
ID_HOTEL TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
WARN_CODE TYPE OF TRANGE)
 AS
declare variable id_dep_doc integer;
declare variable doc_selected integer;
declare variable payment_date date;
declare variable system_date date;
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_BILLING');

  id_dep_doc = null;

  select p.ID_DOC_HEAD, p.ID_ACCOUNT, p.PAYMENT_DATE, a.ID_HOTEL
  from   PAYMENT_HEAD P
         join DEPOSIT d on d.ID_PAYMENT_HEAD = p.ID_PAYMENT_HEAD
         join ACCOUNT a on a.ID_ACCOUNT = p.ID_ACCOUNT
  where  p.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
         and p.IS_ANUL = 0
  into   :id_dep_doc, :id_account, :payment_date, :id_hotel;

  if (:id_account is null) then
    exception DOCUMENT_EXCEPTION '-355';

  if (:id_dep_doc is not null) then
    exception DOCUMENT_EXCEPTION '-364';

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :system_date;

  if (:payment_date < :system_date) then
    exception DOCUMENT_EXCEPTION '-399';

  doc_selected = gen_id(DOC_SELECTED_GEN, 1);

  update DEPOSIT P
  set    p.DOC_SELECTED = :doc_selected,
         p.ID_BILLING_SERVICE = :ID_BILLING_SERVICE
  where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;

  execute procedure DOCUMENT_INITIALIZE$DOC (:ID_ACCOUNT, :doc_selected)
  returning_values  (:ID_DOC_HEAD, :ID_HOTEL, :WARN_CODE);

end
^

/* Alter (DEVICE_READING_POST$PMS) */
ALTER PROCEDURE DEVICE_READING_POST$PMS(ID_DEVICE_READING TYPE OF ID)
 AS
declare variable id_service type of id_ref;
  declare variable post_value type of tprice;
  declare variable curr type of tcurrency;
  declare variable id_room type of id_ref;
  declare variable is_client_acc_post type of tlogical;
  declare variable date_post tdate;
  declare variable id_account_post id_ref;
  declare variable id_account_post$pms id_ref;
  declare variable id_device_reading_evidence id_ref;
  declare variable descr tdescription_long;
begin
  if(exists(select DR.ID_DEVICE_READING
            from   DEVICE_READING DR
            where  DR.ID_DEVICE_READING = :id_device_reading
                   and dr.status = 1)) then exception assert '-1051';
  for
    select CDC.ID_SERVICE,
           sum((CDC.QTY * cast(coalesce(CDC.UNIT_PRICE, 0) as double precision)) + coalesce(CDC.PRICE, 0)),
           CDC.CURR, D.ID_ROOM, CDC.IS_CLIENT_ACC_POST, DR.DATE_POST, DRQ.ID_DEVICE_READING_EVIDENCE,
           substring(list(coalesce(CDC.price || '+', '') || '(' || CDC.QTY || ' ' || coalesce(DT.MEASURE, '') || ' x '
                          || coalesce(CDC.UNIT_PRICE, 0) || ') ' || CDC.CURR) from 1 for 255)
    from DEVICE_READING DR
         join DEVICE_READING_EVIDENCE DRQ on DRQ.ID_DEVICE_READING = DR.ID_DEVICE_READING
         join DEVICE D on D.ID_DEVICE = DRQ.ID_DEVICE
         join DEVICE_TYPE DT on DT.ID_DEVICE_TYPE = D.ID_DEVICE_TYPE
         left outer join CREATE_DEVICE_CALC (D.ID_DEVICE_TYPE, DR.DATE_POST, DRQ.NEW_EVIDENCE - DRQ.OLD_EVIDENCE) CDC on 1=1
    where DR.ID_DEVICE_READING = :id_device_reading
    group by 1, 3, 4, 5, 6, 7
    into  :id_service, :post_value, :curr, :id_room, :is_client_acc_post, :date_post,
          :id_device_reading_evidence, :descr
  do begin
    if (coalesce(:post_value, -1) >= 0) then begin
      for
        select PEP.NEW_ID_ACCOUNT_POST, PEP.NEW_ID_ACCOUNT_POST$PMS
        from   PMS_EXPENSE_POSTS_CREATE$INT(:ID_ROOM, null, null, :ID_SERVICE, :CURR, :POST_VALUE,
                                            :IS_CLIENT_ACC_POST, :DATE_POST, :DESCR, 0) PEP
        into   :id_account_post, :id_account_post$pms
      do begin
        insert into DEVICE_READING_POST (ID_DEVICE_READING_EVIDENCE, ID_ACCOUNT_POST,
               ID_ACCOUNT_POST$PMS)
        values (:ID_DEVICE_READING_EVIDENCE, :ID_ACCOUNT_POST, :ID_ACCOUNT_POST$PMS);
      end
    end
  end
  update DEVICE_READING DR
  set    DR.STATUS = 1
  where  DR.ID_DEVICE_READING = :id_device_reading;
end
^

/* Alter (DOCUMENT_ATTACH_AVAIL_PAYS$INT) */
ALTER PROCEDURE DOCUMENT_ATTACH_AVAIL_PAYS$INT(ID_DOC_HEAD INTEGER,
ID_ACCOUNT INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_deposit integer;
  declare variable pay_curr varchar(3);
  declare variable dep_value numeric(15,4);
  declare variable rest_value numeric(15,4);
begin

  for
    select D.ID_DEPOSIT, D.PAY_CURRENCY, D.AVAIL_VALUE
    from   DEPOSIT_AVAILABLE D
    where  D.ID_ACCOUNT = :ID_ACCOUNT
    order by D.DATETIME_CREATED asc
    into   :ID_DEPOSIT, :PAY_CURR, :DEP_VALUE
  do begin

    execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, :PAY_CURR)
    returning_values  (:dbg, :dbg, :dbg, :dbg, :REST_VALUE);

    if (:REST_VALUE > 0) then begin
      DEP_VALUE = iif(:DEP_VALUE > :REST_VALUE, :REST_VALUE, :DEP_VALUE);
      execute procedure DOCUMENT_USE_DEPOSIT$DOC (:ID_DOC_HEAD, :ID_DEPOSIT, :DEP_VALUE);

   end else begin
      exit;
    end

    when exception DOCUMENT_EXCEPTION do post_event 'dummy';
  end

end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_VALIDATE$DOC for: DOCUMENT_BONUSPOINTS_APPLY$CL */
ALTER PROCEDURE DOCUMENT_VALIDATE$DOC(ID_DOC_HEAD /* TYPE OF ID_REF */ INTEGER)
 RETURNS(FIRM_DATA /* TYPE OF TNOTE_BLOB */ BLOB SUB_TYPE 1,
WARN_CODE /* TYPE OF TRANGE */ INTEGER,
NEW_DOC_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOCUMENT_BONUSPOINTS_APPLY$CL) */
ALTER PROCEDURE DOCUMENT_BONUSPOINTS_APPLY$CL(ID_DOC_HEAD INTEGER)
 AS
declare variable points integer;
  declare variable id_guest_profile integer;
  declare variable id_guest_scheme integer;
  declare variable id_organizer_profile integer;
  declare variable id_organizer_scheme integer;
  declare variable reason varchar(50);
  declare variable note varchar(255);
  declare variable new_id_profile_wallet_points integer;
  declare variable turnover numeric(15,4);
  declare variable id_reserv_detail integer;
  declare variable acc_routing varchar(30);
  declare variable id_doc_footer integer;
  declare variable id_profile integer;
  declare variable bonuspoint_cnt integer;
  declare variable turnover_curr char(3);
begin
  points = null;
  reason = null;
  note = null;

/*  for
    select PW.ID_PROFILE_WALLET_POINTS
    from   PROFILE_WALLET_POINTS_SOURCE PW
    where  PW.ID_DOC_HEAD = :ID_DOC_HEAD
    into   :id_profile_wallet_points
  do begin
    delete from PROFILE_WALLET_POINTS PWP
    where  PWP.ID_PROFILE_WALLET_POINTS = :id_profile_wallet_points;
  end 
*/
  for
    select  DF.ID, P.ID_PROFILE, DF.TAXABLE_VALUE,
            substring(d.DOC_TYPE_NAME || ' ' || d.DOC_NUM || ' / ' || formatdate(d.DOC_DATE, 'D;dd.MM.yyyy') from 1 for 255)
    from    DOC_FOOTER DF
            join DOC_HEAD D on d.ID_DOC = df.ID_DOC_HEAD
            join ACCOUNT A on A.ID_ACCOUNT = d.ID_ACCOUNT
            join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
    where   DF.ID_DOC_HEAD = :ID_DOC_HEAD
            and df.ID_DOC_LINE is null
            and df.ID_TAX is null
    into    :id_doc_footer, :id_profile, :bonuspoint_cnt, :note
  do begin
    /* register spended bonus points */
    execute procedure PROFILE_WALLET_POINTS_REGISTER (:id_profile, :bonuspoint_cnt, 'CONSUME', :note)
    returning_values (:new_id_profile_wallet_points);
  
    insert into PROFILE_WALLET_POINTS_SPEND (ID_PROFILE_WALLET_POINTS, ID_DOC_FOOTER)
    values (:new_id_profile_wallet_points, :id_doc_footer);
  end

  for
    select distinct rd.ID_RESERV_DETAIL,
           RD.ACC_ROUTING, P.ID_PROFILE, P.ID_BONUSPOINT_SCHEME,
           PO.ID_PROFILE, PO.ID_BONUSPOINT_SCHEME,
           substring(d.DOC_TYPE_NAME || ' ' || d.DOC_NUM || ' / ' || formatdate(d.DOC_DATE, 'D;dd.MM.yyyy') from 1 for 255)
    from   DOC_HEAD D
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
           join DOC_LINE DL on DL.ID_DOC_HEAD = D.ID_DOC
           join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE
           left outer join GUEST G on G.ID_GUEST = DL.ID_GUEST
           left outer join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
           left outer join PROFILE_BONUSPOINT_SCHEME P on P.ID_PROFILE = coalesce(RD.ID_PERSON_PROFILE, A.ID_PROFILE)
                                                          and P.ID_HOTEL = RD.ID_HOTEL
           left outer join PROFILE_BONUSPOINT_SCHEME PO on PO.ID_PROFILE = coalesce(RD.ID_AGENT_PROFILE, A.ID_PROFILE)
                                                           and PO.ID_HOTEL = RD.ID_HOTEL
    where  D.ID_DOC = :ID_DOC_HEAD
           and D.IS_ANUL = 0
    into   :id_reserv_detail, :acc_routing, :id_guest_profile, :id_guest_scheme,
           :id_organizer_profile, :id_organizer_scheme, :note
  do begin
    if (:id_organizer_scheme is not null) then begin
      for
        select BPC.POINTS, BPC.TURNOVER, BPC.POINTS_REASON, BPC.TURNOVER_CURR
        from   BP_SCHEME_CALC_TURNOVER_POINTS (:id_organizer_scheme, :ID_DOC_HEAD, :id_reserv_detail, 'BASE,EXTRA') BPC
        where  BPC.POINTS <> 0
        into   :points, :turnover, :reason, :turnover_curr
      do begin
        execute procedure PROFILE_WALLET_POINTS_REGISTER (:id_organizer_profile, :points, :reason, :note)
        returning_values (:new_id_profile_wallet_points);
      
        insert into PROFILE_WALLET_POINTS_SOURCE
               (ID_PROFILE_WALLET_POINTS, ID_RESERV_DETAIL, ID_DOC_HEAD, TURNOVER, TURNOVER_CURR, ID_BONUSPOINT_SCHEME)
        values (:new_id_profile_wallet_points, :id_reserv_detail, :ID_DOC_HEAD, :turnover, :turnover_curr, :id_organizer_scheme);
      end
    end
  
    if (:id_guest_profile is distinct from :id_organizer_profile
        and :acc_routing in ('GUEST', 'MIXED')
        and :id_guest_scheme is not null) then
    begin
      for
        select BPC.POINTS, BPC.TURNOVER, BPC.POINTS_REASON, BPC.TURNOVER_CURR
        from   BP_SCHEME_CALC_TURNOVER_POINTS (:id_guest_scheme, :ID_DOC_HEAD, :id_reserv_detail,
               iif(:acc_routing = 'GUEST', 'BASE,EXTRA', 'EXTRA')) BPC
        where  BPC.POINTS <> 0
        into   :points, :turnover, :reason, :turnover_curr
      do begin
        execute procedure PROFILE_WALLET_POINTS_REGISTER (:id_guest_profile, :points, :reason, :note)
        returning_values (:new_id_profile_wallet_points);
      
        insert into PROFILE_WALLET_POINTS_SOURCE
               (ID_PROFILE_WALLET_POINTS, ID_RESERV_DETAIL, ID_DOC_HEAD, TURNOVER, TURNOVER_CURR, ID_BONUSPOINT_SCHEME)
        values (:new_id_profile_wallet_points, :id_reserv_detail, :ID_DOC_HEAD, :turnover, :turnover_curr, :id_guest_scheme);
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ANUL$DOC for: DOCUMENT_BONUSPOINTS_VOID$CL */
ALTER PROCEDURE DOCUMENT_ANUL$DOC(ID_DOC_HEAD INTEGER,
ANUL_REASON VARCHAR(100),
MAKE_ANNUL_REPORT SMALLINT)
 AS
 BEGIN EXIT; END
^

/* Alter (DOCUMENT_BONUSPOINTS_VOID$CL) */
ALTER PROCEDURE DOCUMENT_BONUSPOINTS_VOID$CL(ID_DOC_HEAD INTEGER)
 AS
declare variable id_profile integer;
  declare variable points integer;
  declare variable note varchar(255);
  declare variable new_id_profile_wallet_points integer;
  declare variable turnover numeric(15,4);
  declare variable id_reserv_detail integer;
  declare variable id_bonuspoint_scheme integer;
  declare variable id_doc_footer integer;
  declare variable turnover_curr char(3);
begin

  for
    select PWP.ID_PROFILE, PWP.POINTS, PWP.NOTE,
           PWS.ID_BONUSPOINT_SCHEME, PWS.ID_RESERV_DETAIL, PWS.TURNOVER, PWS.TURNOVER_CURR
    from   PROFILE_WALLET_POINTS_SOURCE PWS
           join PROFILE_WALLET_POINTS PWP on PWP.ID_PROFILE_WALLET_POINTS = PWS.ID_PROFILE_WALLET_POINTS
    where  PWS.ID_DOC_HEAD = :ID_DOC_HEAD
           and PWP.REASON <> 'VOID'
    into   :id_profile, :points, :note,
           :id_bonuspoint_scheme, :id_reserv_detail, :turnover, :turnover_curr
  do begin
    execute procedure PROFILE_WALLET_POINTS_REGISTER (:id_profile, :points, 'VOID', :note)
    returning_values (:new_id_profile_wallet_points);

    insert into PROFILE_WALLET_POINTS_SOURCE (ID_PROFILE_WALLET_POINTS, ID_RESERV_DETAIL, ID_DOC_HEAD,
           TURNOVER, TURNOVER_CURR, ID_BONUSPOINT_SCHEME)
    values (:new_id_profile_wallet_points, :id_reserv_detail, :ID_DOC_HEAD,
           :turnover, :turnover_curr, :id_bonuspoint_scheme);
  end

  for
    select PWP.ID_PROFILE, PWP.POINTS, PWP.NOTE, DF.ID
    from   DOC_FOOTER DF
           join PROFILE_WALLET_POINTS_SPEND PS on PS.ID_DOC_FOOTER = df.ID
           join PROFILE_WALLET_POINTS PWP on PWP.ID_PROFILE_WALLET_POINTS = PS.ID_PROFILE_WALLET_POINTS
    where  DF.ID_DOC_HEAD = :ID_DOC_HEAD
           and PWP.REASON not containing 'VOID'
    into   :id_profile, :points, :note, :id_doc_footer
  do begin
    execute procedure PROFILE_WALLET_POINTS_REGISTER (:id_profile, :points, 'CONSUME_VOID', :note)
    returning_values (:new_id_profile_wallet_points);

    insert into PROFILE_WALLET_POINTS_SPEND (ID_PROFILE_WALLET_POINTS, ID_DOC_FOOTER)
    values (:new_id_profile_wallet_points, :id_doc_footer);
  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_CLEAR_DEPOSITS$DOC for: DOCUMENT_REUSE_DEPOSITS$INT */
ALTER PROCEDURE DOCUMENT_CLEAR_DEPOSITS$DOC(ID_DOC_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (DOCUMENT_REUSE_DEPOSITS$INT) */
ALTER PROCEDURE DOCUMENT_REUSE_DEPOSITS$INT(OLD_ID_DOC_HEAD INTEGER,
NEW_ID_DOC_HEAD INTEGER)
 AS
declare variable ID_DEPOSIT integer;
declare variable DEPOSIT_AMOUNT numeric(15,4);
begin

  for
    select  D.ID_DEPOSIT, sum(D.USED_PAY_VALUE)
    from    DEPOSIT_DEDUCT D
    where   D.ID_DOC_USED = :OLD_ID_DOC_HEAD
    group by D.ID_DEPOSIT
    into    :ID_DEPOSIT, :DEPOSIT_AMOUNT
  do begin
    execute procedure DOCUMENT_DETACH_DEPOSIT$INT (:OLD_ID_DOC_HEAD, :ID_DEPOSIT);

    if (:NEW_ID_DOC_HEAD is not null) then begin
      execute procedure DOCUMENT_USE_DEPOSIT$DOC (:NEW_ID_DOC_HEAD, :ID_DEPOSIT, :DEPOSIT_AMOUNT);

      when exception DOCUMENT_EXCEPTION do post_event 'dummy';
    end
  end

end
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_REFUND$DOC for: DOCUMENT_VALIDATE$DOC */
ALTER PROCEDURE DEPOSIT_REFUND$DOC(ID_DEPOSIT INTEGER,
REFUND_AMOUNT NUMERIC(15,4),
REFUND_CURRENCY VARCHAR(3),
ID_PAY_DOC_TYPE INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_REFUND_PAYMENT INTEGER,
ID_STORNO_DOC INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOCUMENT_VALIDATE$DOC) */
ALTER PROCEDURE DOCUMENT_VALIDATE$DOC(ID_DOC_HEAD TYPE OF ID_REF)
 RETURNS(FIRM_DATA TYPE OF TNOTE_BLOB,
WARN_CODE TYPE OF TRANGE,
NEW_DOC_DATE TYPE OF TDATE)
 AS
declare variable no_use varchar(255);
  declare variable doc_value numeric(15,4);
  declare variable rest_value numeric(15,4);
  declare variable lines_value numeric(15,4);
  declare variable lines_wot_vat numeric(15,4);
  declare variable tax_value numeric(15,4);
  declare variable taxable_value numeric(15,4);
  declare variable round_to numeric(15,4);
  declare variable id_doc_contragent integer;
  declare variable id_doc_supplier integer;
  declare variable for_deposit integer;
  declare variable id_profile integer;
  declare variable dbkey char(8);
  declare variable id_contragent integer;
  declare variable ident_no varchar(30) ;
  declare variable action_text varchar(255);
  declare variable doc_currency varchar(3);
  declare variable is_juridical_person smallint;
  declare variable vat_ident_no varchar(30);
  declare variable id_doc_type integer;
  declare variable doc_sub_type integer;
  declare variable required_ident_no smallint;
  declare variable required_vat_no smallint;
  declare variable required_egn smallint;
  declare variable required_recipient_name smallint;
  declare variable lines_count integer;
  declare variable recipient_name varchar(100);
  declare variable id_doc_completed integer;
  declare variable action_code varchar(50);
begin

  select D.RDB$DB_KEY, D.DOC_VALUE_A, C.ROUND_TO,
         D.ID_DOC_CONTRAGENT, D.ID_DOC_SUPPLIER, D.FOR_DEPOSIT,
         A.ID_PROFILE, D.DOC_CURRENCY, D.TAXABLE_VALUE, d.ID_DOC_TYPE, d.DOC_SUB_TYPE,
         dc.ID_DOC_HEAD, ds.FIRM_DATA
  from   DOC_HEAD$INT D
         join CURRS C on C.CURR = D.DOC_CURRENCY
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         left outer join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
         left outer join DOC_SUPPLIER ds on ds.ID_DOC_SUPPLIER = d.ID_DOC_SUPPLIER
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :dbkey, :doc_value, :round_to,
         :id_doc_contragent, :id_doc_supplier, :for_deposit,
         :id_profile, :doc_currency, :taxable_value, :id_doc_type, :doc_sub_type,
         :id_doc_completed, :FIRM_DATA;

  if (:id_doc_contragent is null) then
    exception DOCUMENT_EXCEPTION '-356'; --'Contragent is not set!';

  if (:id_doc_supplier is null) then
    exception DOCUMENT_EXCEPTION '-357'; --'Supplier is not set!';

  select sum(DT.TAX_VALUE)
  from   DOC_TAXES DT
  where  DT.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :tax_value;

  /*if (round_f(:doc_value - :total_value, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Total value is not correct!';
  */
  select round_f(sum(DL.SINGLE_VALUE * DL.QTY_POST), :round_to),
         round_f(sum(DL.WOT_VAT), :round_to),
         count(*)
  from   DOC_LINE DL
  where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :lines_value, :lines_wot_vat, :lines_count;
 
  if (:lines_count = 0) then
    exception INTERNAL_DOC_EXCEPTION 'Document is empty! Not exists sale lines!';

  if (round_f(:doc_value - :lines_value, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines total value is not correct!' || :doc_value ||  ' / ' || :lines_value || ' ; '|| (:doc_value - :tax_value) ||  ' / ' || :lines_wot_vat;

  if (round_f(:doc_value - :tax_value - :lines_wot_vat, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines wot tax value is not correct!';

  if (round_f(abs(:lines_wot_vat) - abs(:taxable_value), :round_to) < 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines wot tax value is less than total taxable value!';

  if (:id_doc_completed is not null) then begin
    select DV.PAYABLE_VALUE
    from   DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, null) DV
    into   :rest_value;
  
    if (round_f(:rest_value, :round_to) <> 0) then
      exception DOCUMENT_EXCEPTION '-371'; --'Insufficient amount of payments !';
  end

  /* Validate contragent data */
  select dt.REQUIRED_IDENT_NO, dt.REQUIRED_VAT_NO, dt.REQUIRED_EGN, dt.REQUIRED_RECIPIENT_NAME
  from   DOC_TYPE_INV DT
  where  dt.ID_DOC_TYPE = :id_doc_type
  into   :required_ident_no, :required_vat_no, :required_egn, :required_recipient_name;

  select dc.ID_CONTRAGENT, dc.IS_JURIDICAL_PERSON,
         trim(coalesce(dc.IDENT_NO, '')), trim(coalesce(dc.VAT_REG_NUM, '')),
         trim(coalesce(dc.RECIPIENT_NAME, ''))
  from   DOC_CONTRAGENT dc
  where  dc.ID_DOC_CONTRAGENT = :id_doc_contragent
  into   :id_contragent, :is_juridical_person, :ident_no, :vat_ident_no, :recipient_name;

  if (:doc_sub_type = 0 and :required_ident_no = 1 and :is_juridical_person = 1 and :ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-324'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_egn = 1 and :is_juridical_person = 0 and :ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-324'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_vat_no = 1 and :is_juridical_person = 1 and :vat_ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-326'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_recipient_name = 1 and :recipient_name = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-327'; --'Recipient_name is empty.';
  /*if (:post_address = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-325'; --'Contragent address is empty.';
  /* save contragent link for profile */
  if (:id_contragent is not null) then begin
    update PROFILE P
    set    P.ID_DEF_CONTRAGENT = :id_contragent
    where  P.ID_PROFILE = :id_profile
           and P.ID_DEF_CONTRAGENT is null;
  end

  /*  */
  execute procedure DOC_CHECK_FISCAL$INT(:dbkey);
  /*  */
  execute procedure DOCUMENT_SET_NUMBER$INT (:dbkey)
  returning_values (:no_use, :no_use);
  /*  */
  if (:id_doc_completed is not null) then begin
    if (:for_deposit = 0) then begin
      /* check used deposits and create storno docs if necessary */
      /*execute procedure DOCUMENT_DEPOSIT_DOC_APPLY$INT (:ID_DOC_HEAD)
      returning_values  (:RESULT_DOC_LIST);  */
      /* update account posts */
      execute procedure ACCOUNT_POSTING_DOC_UPDATE$INT (:dbkey)
      returning_values :WARN_CODE;
    end

    execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT (:dbkey, null, 1, null);
    /* ... */
    execute procedure DOCUMENT_BONUSPOINTS_APPLY$CL (:ID_DOC_HEAD);
    /* ... */
  end
  /*  */
  action_text = f_character(29) || formatfloat(:doc_value, 'F;0.00') || ' ' || :doc_currency;
  action_code = iif(:id_doc_completed is null,  'PROFORMA_CREATE', 'CREATE');
  execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :ID_DOC_HEAD, :action_code, :action_text);

  select cast('31.12.1899' as date) + count(d.ID_DOC_HEAD)
  from   DOC_HEAD$INT d
  where  d.DOC_DATE is not null
  into   :NEW_DOC_DATE;

end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_POST_TO_FRONT_ONLINE for: EAI_EXT_POST_TO_MH_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_EXT_POST_TO_MH_FRONT_ONLINE) */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  if (:CODE_TYPE = 'EXT_CODE') then begin
    execute procedure EAI_MAP_SERVICE(:SERVICE_CODE, :SERVICE_CODE, 'UNKNOWN', :id_hotel)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_SERVICE;
    if (:ERR_CODE < 0) then exit;
  end else begin
    select S.ID_SERVICE
    from   SERVICES S
    where  S.ID_SERVICE = :SERVICE_CODE
           and s.ID_HOTEL = :ID_HOTEL
    into   :ID_SERVICE;
    if (:ID_SERVICE is null) then begin
      ERR_CODE = -85;   /* Wrong value! */
      exit;
    end
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Alter (EAI_EXT_SERVICE_POST) */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable max_id_service integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_ROOM  = null;
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  select min(S.ID_SERVICE) as id_service, max(s.id_service) as max_id_service
  from   SERVICES S
  where  S.EXT_CODE = :SERVICE_EXT_CODE
         and s.IS_BASE = 0
         and s.IS_DELETED = 0
  into   :ID_SERVICE, :max_id_service;
  if (:ID_SERVICE is null) then begin
      ERR_CODE = -388;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end else if (:ID_SERVICE <> :max_id_service) then begin
      ERR_CODE = -389;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_EXT_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* empty dependent procedure body */
/* Clear: EAI_POS_POSTING_ADD for: EAI_POS_POSTING_ADD$P2E */
ALTER PROCEDURE EAI_POS_POSTING_ADD(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_POS_POSTING_ADD$P2E) */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
declare variable id_service integer;
  declare variable my_post_text varchar(255);
  declare variable my_resource_text varchar(255);
  declare variable no_use integer;
  declare variable nation_curr varchar(3);
  declare variable post_short_code varchar(10);
  declare variable id_hotel integer;
begin
  /* in_on_guest = 0 (account), 1 (guest), -1 (ew)
  */
  if (:IN_ON_GUEST = 1) then begin
    select rd.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :IN_ID_GUEST
    into   :id_hotel;
  end else begin
    select a.ID_HOTEL
    from   account a
    where  a.ID_ACCOUNT = :in_id_account
    into   :id_hotel;
  end

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :nation_curr;

  if ('END_WORK' = :in_smetka_num) then begin
    post_short_code='POS_EW';
  end else begin
    post_short_code='POS';
  end

  /* FIND SERVICE */
  execute procedure EAI_MAP_SERVICE(:in_service_tag, :in_service_name, 'POS', :id_hotel)
  returning_values  :err_code, :err_text, :id_service;
  if (:err_code < 0) then exit;

  my_post_text = 'date:'|| formatdate(:in_date_smetka, 'D;dd.mm.yyyy') ||
                 ' num:'|| :in_smetka_num ||
                 ' obj:'|| :in_obj_name ||
                 ' tbl:'|| :in_table ||
                 ' site:'|| :in_site;

  my_resource_text = 'POS_ID_SMETKA:'||:in_id_smetka;
  my_post_text = substring(:my_post_text from 1 for 100);
  my_resource_text = substring(:my_resource_text from 1 for 49);

  if (:in_on_guest = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:in_id_guest, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code, '')
    returning_values  :err_code, :err_text, :out_id_account, :no_use;
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:in_id_account, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code)
    returning_values  :err_code, :err_text, :no_use;
    out_id_account = :in_id_account;
  end
end
^

/* Alter (EAI_RES_CHECK_OUT_FAST) */
ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
declare variable selection_id integer;
  declare variable is_early_check_out smallint;
  declare variable early_check_out_dep_date date;
  declare variable check_out_date date;
begin
  selection_id = gen_id(selection_gen, 1);

  update RESERV_DETAIL RD
  set RD.SELECTION_ID = :SELECTION_ID
  where RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL;

  execute procedure RES_CHECK_OUT_CHECK$RSV(:selection_id)
  returning_values :is_early_check_out, :early_check_out_dep_date, :check_out_date;

  if (:is_early_check_out = 1) then
    exception BOOKING_EXCEPTION '-1043';

  execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id, 0);
end
^

/* Alter (EAI_TELECOUNT_TRANSFER) */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* Alter (GUEST_ACCOUNT_TRANSFER$INT) */
ALTER PROCEDURE GUEST_ACCOUNT_TRANSFER$INT(ID_GUEST INTEGER,
ID_SOURCE_ACCOUNT INTEGER,
ID_TARGET_ACCOUNT INTEGER,
SERVICE_TYPE VARCHAR(20))
 AS
declare variable dbkey char(8);
begin

  if (:service_type = 'BASE') then begin
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.ID_ACCOUNT = :id_source_account
             and AP.AC = '00'
             and AP.ID_BASE_DOC is null
             and ((AP.IS_BASE = 1) or (AP.ID_MASTER_ADDINS_ACC_POST <> -1))
      into   :dbkey
    do
      execute procedure ACCOUNT_POSTING_TRANSFER$INT(:dbkey, :id_target_account);

  end else begin
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.ID_ACCOUNT = :id_source_account
             and AP.AC = '00'
             and AP.ID_BASE_DOC is null
             and ((AP.IS_BASE = 0) and (AP.ID_MASTER_ADDINS_ACC_POST = -1))
      into   :dbkey
    do
      execute procedure ACCOUNT_POSTING_TRANSFER$INT(:dbkey, :id_target_account);

  end
end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTS$INT for: GUEST_REROUTE_POSTINGS$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTS$INT(RD_DBKEY CHAR(8))
 AS
 BEGIN EXIT; END
^

/* Alter (GUEST_REROUTE_POSTINGS$INT) */
ALTER PROCEDURE GUEST_REROUTE_POSTINGS$INT(ID_GUEST INTEGER,
ID_BASE_ACCOUNT INTEGER,
ID_EXTRA_ACCOUNT INTEGER)
 AS
declare variable ap_dbkey char(8);
  declare variable is_packet_post integer;
  declare variable packet_option varchar(50);
  declare variable id_target_account integer;
  declare variable id_current_account integer;
begin
  update GUEST G
  set    G.ID_BASE_ACCOUNT = :ID_BASE_ACCOUNT,
         G.ID_ACCOUNT = :ID_EXTRA_ACCOUNT
  where  G.ID_GUEST = :ID_GUEST;

  for
    select AP.RDB$DB_KEY, iif(AP.ID_MASTER_ADDINS_ACC_POST > 0, 1, 0), S.VAUCHER_PACKET,
           ap.ID_ACCOUNT
    from   ACCOUNT_POST AP
           join SERVICES S on S.ID_SERVICE = AP.ID_SERVICE
    where  AP.ID_GUEST = :ID_GUEST
           and AP.AC = '00'
           and AP.ID_BASE_DOC is null
    into   :ap_dbkey, :is_packet_post, :packet_option, :id_current_account
  do begin
    if ((:is_packet_post = 1) and (:packet_option <> 'NONE')) then id_target_account = :id_base_account;
    else id_target_account = :id_extra_account;

    if (:id_current_account <> :id_target_account) then begin
      execute procedure ACCOUNT_POSTING_TRANSFER$INT(:ap_dbkey, :id_target_account);
    end
  end

end
^

/* Alter (IMPORT_AGENT_PROFILE$EXC) */
ALTER PROCEDURE IMPORT_AGENT_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
AGENT_GROUP VARCHAR(50),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
WBE_PASSWORD VARCHAR(20),
IATA_NUMBER VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
DEF_CONTRAGENT_NAME VARCHAR(100),
CLEAR_HOTEL_RATE SMALLINT,
CLEAR_HOTEL_DISCOUNT SMALLINT,
CREATE_ONLY SMALLINT,
THRESHOLD_NOTE VARCHAR(255),
THRESHOLD_AMOUNT NUMERIC(15,4),
THRESHOLD_CURR CHAR(3),
MERGE_TARGET_UUID VARCHAR(40))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
declare variable op varchar(10);
  declare variable market_segment_id integer;
  declare variable agent_group_old varchar(50);
  declare variable id_bonuspoint_scheme integer;
  declare variable id_def_contragent integer;
  declare variable is_exclusive_debt_ownership smallint;
  declare variable country_code_old varchar(10);
  declare variable profile_receiver_id integer;
begin
  profile_id = null;
  import_time = null;

  execute procedure import_mark_transaction$exc;

  /*FIXME - remove this block*/
  if (1 = :create_only) then begin
    clear_hotel_rate = 0;
    clear_hotel_discount = 0;
  end else begin
    clear_hotel_rate = 1;
    clear_hotel_discount = 1;
  end

  execute procedure sys_dbg('exc IMPORT_AGENT_PROFILE$EXC(:profile_uuid=>' || coalesce(:profile_uuid, cast('<null>' as varchar(40)) ) || ')');
  profile_id = null;
  if (:PROFILE_UUID is null) then begin
    execute procedure sys_dbg('exc IMPORT_AGENT_PROFILE$EXC <null> :profile_uuid - exit;');
    exit;
  end

  select p.profile_id, p.profile_name, p.phone, p.fax, p.email, p.city,
         p.address, p.market_segment, p.note, p.is_archive, p.id_bonuspoint_scheme,
         p.id_def_contragent, pa.agent_group, p.wbe_password,
         p.msg, p.account_no, p.is_exclusive_debt_ownership, pa.country_code
  from   IMPORT_COMMON_PROFILE$EXC(:PROFILE_UUID, 1, :PROFILE_NAME,
         :PHONE, :FAX, :EMAIL, :CITY, :ADDRESS, :MARKET_SEGMENT, :NOTE, :IS_ARCHIVE, :WBE_PASSWORD, :ACCOUNT_NO, :MSG,  'AGENT_PROFILE', :CLEAR_HOTEL_RATE) p
         left outer join profile_agent pa on pa.id_profile = p.profile_id
  into   :profile_id, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :id_bonuspoint_scheme,
         :id_def_contragent, :agent_group_old, :wbe_password,
         :msg, :account_no, :is_exclusive_debt_ownership, :country_code_old;

  if (:profile_id is null) then begin
    op = 'add';
  end else if (1 = :create_only) then begin
    profile_id = null;
    exit;
  end else begin
    op = 'mod';
    if (1 = :clear_hotel_discount) then begin
      delete from PROFILE_DISCOUNT pd
      where  pd.ID_PROFILE = :profile_id;
    end

    delete from PROFILE_BONUSPOINT_SCHEME bs
    where  bs.ID_PROFILE = :profile_id;
  end

  AGENT_GROUP=coalesce(:AGENT_GROUP, :AGENT_GROUP_OLD);
  country_code=coalesce(:country_code, :country_code_old);

  execute procedure LOOKUP_MARKET_SEGMENT$EXC(:profile_name, 'AGENT_PROFILE', :market_segment)
  returning_values :market_segment_id;

  if ((def_contragent_name is not null) and (def_contragent_name <> '')) then begin
    execute procedure LOOKUP_CONTRAGENT$EXC(:profile_name, 'AGENT_PROFILE', :def_contragent_name)
    returning_values :id_def_contragent;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:profile_name, 'AGENT_PROFILE');

  execute procedure sys_dbg('exc IMPORT_AGENT_PROFILE$EXC - profile_agent_modify$profile(:profile_uuid=>' || coalesce(:profile_uuid,cast('<null>' as varchar(40)))
    || ', :operation=>' || coalesce(:op, cast('<null>' as varchar(10)) )
    || ', :market_segment_id=>' || coalesce(cast(:market_segment_id as varchar(10)) , cast('<null>' as varchar(10)) )
    || ')');

  if (1 = :create_only) then begin
    -- in :create_only mode (i.e. embeded mode transfer only profile key fields )
    --profile_name = null;
    phone = null;
    fax = null;
    email = null;
    country_code = null;
    city = null;
    address = null;
    note = null;
    msg = null;
    --is_archive = null;
    agent_group = null;
    id_def_contragent = null;
    market_segment_id = null;
    id_bonuspoint_scheme = null;
    wbe_password = null;
    account_no = null;
    --iata_number = null;
    is_exclusive_debt_ownership = null;
  end

  execute procedure profile_agent_modify$profile(
    :profile_id, :profile_name, :phone, :fax, :email,
    :country_code, :city, :address, :note, :msg, :is_archive, :agent_group, :id_def_contragent, :market_segment_id,
    :wbe_password, :op, :account_no, :iata_number, :is_exclusive_debt_ownership,
    :threshold_note, :threshold_amount, :threshold_curr)
  returning_values :profile_id;

  /*assign UUID to the new profiles*/
  if ('add' = :op) then begin
    update profile
    set    uuid = :profile_uuid
    where  id_profile = :profile_id;
  end

  select record_timestamp
  from   profile
  where  id_profile = :profile_id
  into   :import_time;

  if (:MERGE_TARGET_UUID is not null) then begin
    select p.ID_PROFILE
    from   PROFILE P
    where  P.UUID = :MERGE_TARGET_UUID
    into   :profile_receiver_id;

    execute procedure PROFILE_MERGE$PROFILE (:PROFILE_ID, :profile_receiver_id, 'merge');

  end
end
^

/* empty dependent procedure body */
/* Clear: CREATE_SESSION_BOOKINGS$WBE for: IMPORT_BOOKING_FINALIZE$EXC */
ALTER PROCEDURE CREATE_SESSION_BOOKINGS$WBE(WBE_SESSION_ID BIGINT,
ARANGER_ID INTEGER,
LANG_CODE VARCHAR(3))
 RETURNS(SELECTION_ID VARCHAR(20),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (IMPORT_BOOKING_FINALIZE$EXC) */
ALTER PROCEDURE IMPORT_BOOKING_FINALIZE$EXC(BOOKING_ID INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1,
STATUS VARCHAR(50) = null,
CONFIRMATION_NUMBER NAME_20 = null,
CANCELATION_NUMBER NAME_20 = null)
 RETURNS(RECORD_TIMESTAMP TIMESTAMP,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable booking_db_key char(8);
  declare variable dummy_int integer;
  declare variable dummy_text varchar(255) ;
  declare variable res_id_room integer;
  declare variable id_room integer;
  declare variable id_room_type integer;
  declare variable id_hotel integer;
  declare variable system_date date;
  declare variable from_date date;
  declare variable gs_dbkey char(8);
begin
  ERR_CODE=0;
  ERR_TEXT=null;
  id_room = null;
  force_res_finalize = coalesce(:force_res_finalize, 1);

  execute procedure sys_dbg('exc IMPORT_BOOKING_FINALIZE$EXC => CLEAR_ORPHAN_GUESTS$EXC');
  execute procedure CLEAR_ORPHAN_GUESTS$EXC(:booking_id);

  select b.rdb$db_key, b.ID_ROOM, b.ID_ROOM_TYPE, b.ID_HOTEL, b.FROM_DATE
  from   reserv_detail b
  where  b.id_reserv_detail = :booking_id
  into   :booking_db_key, :res_id_room, :id_room_type, :id_hotel, :from_date;

  execute procedure RES_GUEST_SAVE_DIFF$INT(:booking_db_key);

  if (:res_id_room < 0) then begin
    select sd.SYSTEM_DATE
    from   SYSTEM_DATE_GET (:id_hotel) sd
    into   :system_date;

    select ro.ID_ROOM, ro.ID_ROOM_TYPE
    from   RES_OCCUPANCY_ROOM$INT (:BOOKING_ID, maxdate(:system_date, :from_date), null, :id_room_type) ro
    into   :id_room, :id_room_type;

--    has_different_room_type = null;
    if (:id_room <> :res_id_room) then begin
      for
        select gs.RDB$DB_KEY
        from   GUEST_STAY GS
               join GUEST G on g.ID_GUEST = gs.ID_GUEST
        where  g.ID_RESERV_DETAIL = :BOOKING_ID
               and gs.FOR_DATE >= maxdate(:system_date, :from_date)
               and gs.ID_ROOM <> :id_room
        into   :gs_dbkey
      do begin
        update GUEST_STAY gsu
        set    gsu.ID_ROOM = :id_room
               --gsu.ID_ROOM_TYPE = iif (gsu.ID_ROOM_TYPE = -1, :id_room_type, gsu.ID_ROOM_TYPE)
        where  gsu.RDB$DB_KEY = :gs_dbkey;
        --has_different_room_type = 1;
      end

      update GUEST G
      set    G.ID_ROOM = :id_room
      where  g.ID_RESERV_DETAIL = :BOOKING_ID;
    end
  end

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null,   --force recalculation
         rd.ID_ROOM = coalesce(:id_room, :res_id_room)
         --rd.HAS_DIFFERENT_ROOM_TYPE = coalesce(:has_different_room_type,  rd.HAS_DIFFERENT_ROOM_TYPE)
  where  rd.RDB$DB_KEY = :booking_db_key;

  if (1 = :force_res_finalize) then begin
    execute procedure sys_dbg('exc IMPORT_BOOKING_FINALIZE$EXC => RES_FINALIZE_SHAREOPTION$INT');
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:booking_db_key, 0)
    returning_values  :dummy_int, :dummy_text, :dummy_int, :dummy_int;
  end

  execute procedure APPLY_BOOKING_STATUS$EXC(
    null, :booking_db_key, :status, :confirmation_number, :cancelation_number
  );

  select b.change_time
  from   reserv_detail b
  where  b.rdb$db_key =:booking_db_key
  into   :record_timestamp;
end
^

/* empty dependent procedure body */
/* Clear: CREATE_BOOKING$WBE for: IMPORT_PERSON_PROFILE$EXC */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: EAI_IMPORT_ALOYALTY_CLIENT for: IMPORT_PERSON_PROFILE$EXC */
ALTER PROCEDURE EAI_IMPORT_ALOYALTY_CLIENT(CLIENT_UUID VARCHAR(40),
CLIENT_NAME VARCHAR(100),
CARD_CODE VARCHAR(50),
IS_ARHIVE SMALLINT,
DATE_OF_BIRTH DATE)
 AS
 BEGIN EXIT; END
^

/* Alter (IMPORT_PERSON_PROFILE$EXC) */
ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
CLEAR_HOTEL_RATE SMALLINT,
CREATE_ONLY SMALLINT,
MERGE_TARGET_UUID VARCHAR(40))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
declare variable op varchar(10);
  declare variable market_segment_id integer;
  declare variable sex_old char(1);
  declare variable birth_date_old date;
  declare variable birth_place_old varchar(30);
  declare variable personal_number_old varchar(30);
  declare variable pass_num_old varchar(20);
  declare variable pass_date_old date;
  declare variable pass_place_old varchar(20);
  declare variable pass_exp_date_old date;
  declare variable pass_city_old varchar(100);
  declare variable pass_address_old varchar(100);
  declare variable country_old varchar(10);
  declare variable mask_old varchar(10);
  declare variable title_old varchar(10);
  declare variable id_photo integer;
  declare variable id_def_contragent integer;
  declare variable id_passport_type integer;
  declare variable account_no_old varchar(20);
  declare variable msg_old varchar(255);
  declare variable id_guest_type integer;
  declare variable id_guest_type_old integer;
  declare variable card_code_old varchar(50);
  declare variable is_exclusive_debt_ownership smallint;
  declare variable profile_receiver_id integer;
begin
  profile_id = null;
  import_time = null;

  execute procedure import_mark_transaction$exc;

  /*FIXME - remove this block*/
  if (1 = :create_only) then begin
    clear_hotel_rate = 0;
  end else begin
    clear_hotel_rate = 1;
  end

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC(:profile_uuid=>' || coalesce(:profile_uuid, '<null>')
                          || ', email=>' || coalesce(:email, '<null>') || ')');

  profile_id = null;
  if (profile_uuid is null) then begin
    execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC <null> :profile_uuid - exit;');
    exit;
  end

  select p.profile_id, p.profile_name, p.phone, p.fax, p.email, p.city,
         p.address, p.market_segment, p.note, p.is_archive, pp.card_code,
         pd.sex, pd.birthday_internal, pd.birth_place, pd.egn, pd.pass_num,
         pd.pass_date, pd.pass_place, pd.pass_exp_date, pd.city, pd.address, pd.country_code,
         pd.mask, p.id_def_contragent, p.wbe_password,
         pd.title, p.account_no, p.msg, pp.id_guest_type, pp.id_photo, pd.id_passport_type,
         p.is_exclusive_debt_ownership
  from   import_common_profile$exc(:profile_uuid, 0, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :wbe_password, :ACCOUNT_NO, :MSG, 'PERSON_PROFILE', :CLEAR_HOTEL_RATE) p
         left outer join profile_person pp on pp.id_profile = p.profile_id
         left outer join person_data pd on pd.id_person_data=pp.id_person_data
  into   :profile_id, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :card_code_old,
         :sex_old, :birth_date_old, :birth_place_old, :personal_number_old, :pass_num_old,
         :pass_date_old, :pass_place_old, :pass_exp_date_old, :pass_city_old, :pass_address_old, :country_old,
         :mask_old, :id_def_contragent, :wbe_password, :title_old,
         :account_no_old, :msg_old, :id_guest_type_old, :id_photo, :id_passport_type, :is_exclusive_debt_ownership;

  if (:profile_id is null) then begin
    op = 'add';
  end else if (1 = :create_only) then begin
    profile_id = null;
    exit;
  end else begin
    op = 'mod';
    delete from PROFILE_HOTEL_RATE phr
      where phr.ID_PROFILE = :profile_id;
    delete from PROFILE_BONUSPOINT_SCHEME bs
      where bs.ID_PROFILE = :profile_id;
  end

  sex=coalesce(:sex, :sex_old);
  birth_date=coalesce(:birth_date, :birth_date_old);
  birth_place=coalesce(:birth_place, :birth_place_old);
  personal_number=coalesce(:personal_number, :personal_number_old);
  pass_num=coalesce(:pass_num, :pass_num_old);
  pass_date=coalesce(:pass_date, :pass_date_old);
  pass_place=coalesce(:pass_place, :pass_place_old);
  pass_exp_date=coalesce(:pass_exp_date, :pass_exp_date_old);
  pass_city=coalesce(:pass_city, :pass_city_old);
  pass_address=coalesce(:pass_address, :pass_address_old);
  country=upper(coalesce(:country, :country_old));
  mask=coalesce(:mask, :mask_old);
  title=coalesce(:title, :title_old);
  account_no=coalesce(:account_no, :account_no_old);
  msg=coalesce(:msg, :msg_old);
  card_code=coalesce(:card_code, :card_code_old);

  execute procedure IMPORT_PASSPORT_TYPE$EXC(:pass_type_name, :pass_type_external_code)
  returning_values :id_passport_type;

  execute procedure lookup_market_segment$exc(:profile_name, 'PERSON_PROFILE', :market_segment)
  returning_values :market_segment_id;

  if (guest_type_name is not null) then begin
    execute procedure lookup_guest_type$exc(:profile_name, 'PERSON_PROFILE', :guest_type_name)
    returning_values :id_guest_type;
  end

  if ((def_contragent_name is not null) and (def_contragent_name <> '')) then begin
    execute procedure LOOKUP_CONTRAGENT$EXC(:profile_name, 'PERSON_PROFILE', :def_contragent_name)
    returning_values :id_def_contragent;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:profile_name, 'PERSON_PROFILE');

  id_guest_type=coalesce(:id_guest_type, :id_guest_type_old);

  if (id_photo is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, null, null, null, 'del')
    returning_values :id_photo;
  end
  id_photo = null;
  if (picture is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, :picture, :picture_type, :picture_layout, 'add')
    returning_values :id_photo;
  end

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC - profile_person_modify$profile(:profile_uuid=>'
    || coalesce(:profile_uuid, '<null>')
    || ', :operation=>' || coalesce(:op, '<null>')
    || ', :email=>' || coalesce(:email, '<null>')
    || ', :birth_date=>' || coalesce(:birth_date, '<null>')
  || ')');
  execute procedure profile_person_modify$profile(
    :profile_id,
    :id_guest_type,
    :profile_name,
    null,
    :sex,
    :birth_date,
    :birth_place,
    :personal_number,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :pass_place,
    :pass_exp_date,
    :country,
    :pass_city,
    :pass_address,
    :mask,
    :phone,
    :fax,
    :email,
    :city,
    :address,
    :note,
    :msg,
    :id_def_contragent,
    :market_segment_id,
    :is_archive,
    :id_photo,
    :card_code,
    :wbe_password,
    :op,
    :account_no,
    :title,
    :is_exclusive_debt_ownership
  ) returning_values
    :profile_id;

  /*assign uuid to the new profiles*/
  if ('add' = :op) then begin
    update profile set uuid=:profile_uuid where id_profile=:profile_id;
  end

  select record_timestamp from profile where id_profile=:profile_id
  into :import_time;

  if (:MERGE_TARGET_UUID is not null) then begin
    select p.ID_PROFILE
    from   PROFILE P
    where  P.UUID = :MERGE_TARGET_UUID
    into   :profile_receiver_id;

    execute procedure PROFILE_MERGE$PROFILE (:PROFILE_ID, :profile_receiver_id, 'merge');

  end

end
^

/* Alter (IMPORT_WALLET_POINTS$EXC) */
ALTER PROCEDURE IMPORT_WALLET_POINTS$EXC(UUID VARCHAR(40),
PROFILE_UUID VARCHAR(40),
POINTS INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
USER_CREATED VARCHAR(30),
DATETIME_CREATED TIMESTAMP)
 AS
declare variable profile_id integer;
  declare variable wp_id integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:UUID, 'WALLET_POINTS');

  /* exit if update is detected - wallet points interface is log based */
  if (exists(
    select first 1 ID_PROFILE_WALLET_POINTS
    from   PROFILE_WALLET_POINTS
    where  UUID = :uuid
  )) then exit;

  select first 1 p.id_profile
  from   PROFILE p
  where  p.uuid=:profile_uuid
         and p.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :profile_id;

  /* exit if we are unable to find the target profile - it is a legal situation */
  if (:profile_id is null) then exit;

  execute procedure PROFILE_WALLET_POINTS_REGISTER(:profile_id, :points, :reason, :note)
  returning_values :wp_id;

  /* preserve the original object properties */
  update profile_wallet_points
  set    user_created = :user_created,
         datetime_created = :datetime_created,
         uuid = :uuid
  where (id_profile_wallet_points = :wp_id);
end
^

/* Alter (OCCUPANCY_RTI_BP$RPT) */
ALTER PROCEDURE OCCUPANCY_RTI_BP$RPT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ROOM_TYPES VARCHAR(255))
 RETURNS(OUT_DATE DATE,
CATEGORY VARCHAR(50),
AGENT_NAME VARCHAR(50),
ROOM_CNT INTEGER)
 AS
declare variable capacity integer;
declare variable ooi integer;
declare variable busy integer;
declare variable res_conf integer;
declare variable res_notconf integer;
declare variable bp_total integer;
declare variable sold_total integer;
declare variable total_bp_remains integer;
begin
  execute procedure AVAILABILITY_OCCUP_PREPARE$AVL (:FROM_DATE, :TO_DATE, 1, 1, 0, 1, 1, 0, 1, 0, :ID_HOTEL);

  for
    select t.FOR_DATE,
           sum(t.G_CAPACITY),
           sum(t.G_OOI),
           sum(t.SOLD),
           sum(t.RES_CONFIRMED),
           sum(t.RES_NOTCONFIRMED)
    from   SMART_OCCUP$TMP T
           join ROOM_TYPES rt on rt.ID_ROOM_TYPE = t.ID_ROOM_TYPE
    where  ','||:room_types||',' containing ','||rt.type_room||','
    group by 1
    into  :OUT_DATE, :capacity, :ooi, :busy, :res_conf, :res_notconf
  do begin
    CATEGORY = '1.Capacity';
    AGENT_NAME = '';
    ROOM_CNT = :capacity;
    suspend;
    CATEGORY = '2.OOI';
    AGENT_NAME = '';
    ROOM_CNT = :ooi;
    suspend;
    CATEGORY = '3.Available';
    AGENT_NAME = '';
    ROOM_CNT = :capacity - :ooi;
    suspend;
    CATEGORY = '4.Check in';
    AGENT_NAME = '';
    ROOM_CNT = :busy;
    suspend;
    CATEGORY = '5.Confirmed';
    AGENT_NAME = '';
    ROOM_CNT = :res_conf;
    suspend;
    CATEGORY = '6.Tentative';
    AGENT_NAME = '';
    ROOM_CNT = :res_notconf;
    suspend;
    CATEGORY = '7.Total sold';
    AGENT_NAME = '';
    ROOM_CNT = :busy + :res_conf + :res_notconf;
    suspend;
    CATEGORY = '8.Free';
    AGENT_NAME = '';
    ROOM_CNT = :capacity - :ooi - :busy - :res_conf - :res_notconf;
    suspend;

    CATEGORY = '9.RTI-BP';
    total_bp_remains = 0;
    for
      select '9.'||P.PROFILE_NAME as agent_name, sum(AO.CONT_BP), sum(ao.SOLD + ao.RES_CONFIRMED + ao.RES_NOTCONFIRMED)
      from   SMART_OCCUP$TMP AO
             join ROOM_TYPES rt on rt.id_room_type = ao.id_room_type
             left outer join PROFILE_AGENT PA on PA.ID_AGENT = AO.ID_AGENT
             left outer join PROFILE P on P.ID_PROFILE = pa.ID_PROFILE
      where  AO.FOR_DATE = :OUT_DATE
             and ','||:room_types||',' containing ','||rt.type_room||','
      group by 1
      having (sum(AO.CONT_BP) > 0) or (sum(ao.SOLD + ao.RES_CONFIRMED + ao.RES_NOTCONFIRMED) > 0)
      into   :CATEGORY/*:AGENT_NAME*/, :bp_total, :sold_total
    do begin
      AGENT_NAME = 'Total BP';
      ROOM_CNT = :bp_total;
      suspend;

      AGENT_NAME = 'Sold rooms';
      ROOM_CNT = :sold_total;
      suspend;

      AGENT_NAME = 'BP-remain';
      if (:bp_total < :sold_total) then ROOM_CNT = 0;
      else ROOM_CNT = :bp_total - :sold_total;
      suspend;

      total_bp_remains = :total_bp_remains + :ROOM_CNT;
    end 

    CATEGORY = 'Occupancy %';
    AGENT_NAME = '';
    ROOM_CNT =  iif((:capacity - :ooi) = 0, 0, cast(:busy + :res_conf + :res_notconf + :total_bp_remains as double precision) / (:capacity - :ooi)) * 100;
    suspend;

    CATEGORY = 'Remain';
    AGENT_NAME = '';
    ROOM_CNT = :capacity - :ooi - :busy - :res_conf - :res_notconf - :total_bp_remains;
    suspend;
  end
end
^

/* Alter (PHONECALL_POST$TC) */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Alter (PHONECALLS_POST_TO_ACCOUNT$TC) */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* Alter (PMS_EXPENSE_POSTING_CREATE$PMS) */
ALTER PROCEDURE PMS_EXPENSE_POSTING_CREATE$PMS(ID_ROOM TYPE OF ID,
ID_OWNER TYPE OF ID,
ID_RENTAL_POOL TYPE OF ID_REF,
ID_SERVICE TYPE OF ID,
ID_CURRENCY TYPE OF TCURRENCY,
POST_VALUE TYPE OF TPRICE,
IS_ACC_POST_ITEM TYPE OF TLOGICAL,
MANUAL_POST_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
IS_POST_PER_POOL TYPE OF TLOGICAL)
 AS
declare variable no_use_id_acc_post integer;
declare variable no_use_id_acc_post$pms integer;
begin
  for
    select PE.NEW_ID_ACCOUNT_POST, PE.NEW_ID_ACCOUNT_POST$PMS
    from PMS_EXPENSE_POSTS_CREATE$INT(:ID_ROOM, :ID_OWNER, :ID_RENTAL_POOL, :ID_SERVICE,
         :ID_CURRENCY, :POST_VALUE, :IS_ACC_POST_ITEM, :MANUAL_POST_DATE, :DESCRIPTION, :IS_POST_PER_POOL) PE
    into :no_use_id_acc_post, :no_use_id_acc_post$pms
  do begin

  end
end
^

/* Alter (PMS_IMPORT) */
ALTER PROCEDURE PMS_IMPORT(ID_EXPORT_HEAD INTEGER)
 AS
begin

  execute procedure PMS_IMPORT$INT(:ID_EXPORT_HEAD);

end
^

/* Alter (PMS_POOL_DISTRIBUTION) */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION(ID_RENTAL_POOL INTEGER,
FOR_DATE DATE)
 AS
declare variable total_value_per_service numeric(15,4);
  declare variable id_service integer;
  declare variable curr varchar(3);
  declare variable id_room_param integer;
  declare variable is_room_pool smallint;
  declare variable is_owner_income smallint;

  declare variable is_acc_post_item smallint;
  declare variable new_id_owner_bill integer;
  declare variable id_account_post_pms integer;
  declare variable id_pool_account integer;

  declare variable id_account_pms integer;
  declare variable value_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable value_post numeric(15,4);
  declare variable curr_post varchar(3);
  declare variable id_room integer;
  declare variable date_post date;
  declare variable id_reserv_detail integer;
  declare variable doc_description varchar(255);
  declare variable id_doc_head integer;
  declare variable description varchar(255);
  declare variable is_client_account_post smallint;
begin
  is_room_pool = null;
  select U.IS_ROOM_POOL, U.ID_ROOM_PARAM
  from   OWNER$PMS O
         join RENTAL_POOL_UNIT$PMS U on U.ID_RENTAL_POOL_UNIT = O.ID_RENTAL_POOL_UNIT
  where  O.ID_OWNER = :ID_RENTAL_POOL
  into   :is_room_pool, :id_room_param;
  if (:is_room_pool is null) then exception PMS_EXCEPTION;

  for
    select sum(AP1.VALUE_POST), AP1.ID_SERVICE, AP1.CURR_POST, AP1.IS_OWNER_INCOME,
           ACC.IS_CLIENT_POOL_ACCOUNT, ACC.ID_ACCOUNT
    from   (select distinct AP.ID_PMS_EVENT
            from   ACCOUNT_POST$PMS AP
                   join ACCOUNT$PMS AC on AC.ID_ACCOUNT = AP.ID_ACCOUNT_PMS
            where  AP.DATE_POST <= :FOR_DATE
                   and AP.LINE_STATUS = 11
                   and AC.ID_OWNER = :ID_RENTAL_POOL
                   and AC.IS_SHADOW = 0) E
           join ACCOUNT_POST$PMS AP1 on AP1.ID_PMS_EVENT = e.ID_PMS_EVENT and AP1.LINE_STATUS = 11
           join ACCOUNT$PMS ACC on ACC.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS and ACC.IS_SHADOW = 0
    group by 2,3,4,5,6
    into   :total_value_per_service, :id_service, :curr, :is_owner_income,
           :is_acc_post_item, :id_pool_account
  do begin
    execute procedure PMS_POOL_DISTRIBUTION_SUB(:ID_RENTAL_POOL, :id_pool_account,
            :IS_ROOM_POOL, :ID_ROOM_PARAM, :total_value_per_service,
            :ID_SERVICE, :CURR, :IS_OWNER_INCOME, :FOR_DATE, :is_acc_post_item);
  end

  NEW_ID_OWNER_BILL = gen_id(GEN_OWNER_BILL$PMS_ID, 1);

  insert into OWNER_BILL$PMS (ID_OWNER_BILL, ID_OWNER, BILL_DATE, IS_ANUL, BILL_NUM,
         IS_EXPORTED_TO_INTRANET, IS_POOL_DISTRIBUTION_STATEMENT)
  values (:NEW_ID_OWNER_BILL, :ID_RENTAL_POOL, :FOR_DATE, 0, :NEW_ID_OWNER_BILL, 0, 1);

  update OWNER$PMS O
  set    O.LAST_BILLING_DATE = :for_date,
         O.ID_OWNER_BILL = :NEW_ID_OWNER_BILL
  where  O.ID_OWNER = :ID_RENTAL_POOL;

  for
    select AP.ID_ACCOUNT_POST, AP.VALUE_ORIG, AP.CURR_ORIG, AP.VALUE_POST, AP.CURR_POST,
           ACC.ID_ACCOUNT, AP.IS_OWNER_INCOME, AP.ID_SERVICE, E.ID_ROOM, AP.DATE_POST,
           E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION, ACC.IS_CLIENT_POOL_ACCOUNT
    from   PMS_EVENT$PMS E
           join ACCOUNT_POST$PMS AP on ap.ID_PMS_EVENT = e.ID_PMS_EVENT
                                       and AP.LINE_STATUS = 11
           join ACCOUNT$PMS ACC on ACC.ID_ACCOUNT = AP.ID_ACCOUNT_PMS
                                   and ACC.ID_OWNER = :ID_RENTAL_POOL
                                   and ACC.IS_SHADOW = 0
    where  E.ID_SESSION = current_transaction
    into   :id_account_post_pms, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
           :ID_ACCOUNT_PMS, :IS_OWNER_INCOME, :ID_SERVICE, :ID_ROOM, :DATE_POST,
           :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION, :is_client_account_post
  do begin
    insert into OWNER_BILL_ROW$PMS (ID_OWNER_BILL, ID_ACCOUNT_POST, ID_ACCOUNT,
           ID_ACCOUNT_POST_PMS, ID_ACCOUNT_PMS, ID_SERVICE, VALUE_ORIG,
           CURR_ORIG, VALUE_POST, CURR_POST, IS_OWNER_INCOME, ID_ROOM, DATE_POST,
           ID_RESERV_DETAIL, DOC_DESCRIPTION, ID_DOC_HEAD, DESCRIPTION, IS_CLIENT_ACCOUNT_POST)
    values (:new_id_owner_bill, null, null,
           :ID_ACCOUNT_POST_PMS, :ID_ACCOUNT_PMS, :ID_SERVICE, :VALUE_ORIG,
           :CURR_ORIG, :VALUE_POST, :CURR_POST, :IS_OWNER_INCOME, :ID_ROOM, :DATE_POST,
           :ID_RESERV_DETAIL, :DOC_DESCRIPTION, :ID_DOC_HEAD, :DESCRIPTION, :is_client_account_post);

    update ACCOUNT_POST$PMS A
    set    A.LINE_STATUS = 21
    where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS;
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POST_MODIFY$PMS for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: CONTRACT_EXPENSE_POST$INT for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_HOTEL INTEGER,
ID_CONTRACT /* TYPE OF ID */ INTEGER,
SUB_CONTRACT /* TYPE OF TSUB_CONTRACT */ VARCHAR(10),
ID_OWNER /* TYPE OF ID */ INTEGER,
OWNERSHIP_PERCENT /* TYPE OF TPERCENT */ NUMERIC(15,4),
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
POST_DATE /* TYPE OF TDATE */ DATE,
STAY /* TYPE OF TCOUNT */ INTEGER,
MAX_GUEST_CNT /* TYPE OF TCOUNT */ INTEGER,
BED_NIGHT_CNT /* TYPE OF TCOUNT */ INTEGER,
RESERVS /* TYPE OF TCOUNT */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_POSTING_CREATE$INT) */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_OWNER TYPE OF ID,
POST_DATE TYPE OF TDATE,
CURR_ORIG TYPE OF TCURRENCY,
VALUE_ORIG TYPE OF TPRICE,
POST_ON_PMS_ACCOUNT TYPE OF TLOGICAL,
IS_OWNER_INCOME TYPE OF TLOGICAL,
ID_ROOM TYPE OF ID_REF = null)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  if (:POST_ON_PMS_ACCOUNT = 1) then begin
    execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account, :id_owner,
            :CURR_ORIG, :VALUE_ORIG, :id_service, :is_owner_income, :POST_DATE)
    returning_values  (:new_id_account_post);
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :ID_SERVICE, 1, 0, 1,
            :VALUE_ORIG, :CURR_ORIG, current_date, current_date,
            '', '', :POST_DATE, 'PMS', :ID_ROOM)
    returning_values  :err_code, :err_text, :new_id_account_post;
    if (:err_code <> 0) then exception PMS_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

    insert into PMS_EVENT_POST (ID_PMS_EVENT, ID_ACCOUNT_POST, ID_OWNER, LINE_STATUS)
    values (:ID_PMS_EVENT, :NEW_ID_ACCOUNT_POST, :ID_OWNER, 11);
  end
end
^

/* Alter (POST_SERVICE_FINALIZE$POST) */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
  declare variable id_acc_post integer;
  declare variable id_service integer;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable date_post date;
  declare variable price_post numeric(15,4);
  declare variable qty_post numeric(15,2);
  declare variable post_text varchar(100);
  declare variable curr_post varchar(3);
  declare variable id_phonecall integer;
  declare variable p_dbkey char(8);
begin

  if (:OPERATION = 'clear') then begin
    delete from TMP_SERVICE_POST T
    where  T.ID_SEQUENCE = :ID_SEQUENCE;

  end else if (:OPERATION = 'store') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);

    for
      select TS.RDB$DB_KEY, TS.ID_SERVICE, TS.ID_ACCOUNT, TS.ID_GUEST, TS.DATE_POST,
             TS.PRICE_POST, TS.QTY_POST, TS.CURR_POST, TS.POST_TEXT, TS.ID_PHONECALL
      from   TMP_SERVICE_POST TS
      where  TS.ID_SEQUENCE = :ID_SEQUENCE
      into   :p_dbkey, :id_service, :id_account, :id_guest, :date_post,
             :price_post, :qty_post, :curr_post, :post_text, :id_phonecall
    do begin
      id_acc_post = null;
      if (:id_guest is not null) then begin
        execute procedure POST_SERVICE_ON_GUEST$INT (:id_guest, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :CURR_POST,
                :date_post, :date_post, :post_text, '', :date_post, '', '')
        returning_values  (:err_code, :err_text, :no_use, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end else begin
        execute procedure POST_SERVICE_ON_ACCOUNT$INT (:id_account, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :curr_post, :date_post, :date_post, :post_text,
                '', :date_post, '')
        returning_values  (:err_code, :err_text, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end

      update TMP_SERVICE_POST
      set ID_ACCOUNT_POST = :id_acc_post
      where RDB$DB_KEY = :p_dbkey;

      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :DOC_SELECTED,
             AP.SHORT_CODE = case
                               when :id_phonecall is not null then 'TELECOUNT'
                               else null
                             end
      where  AP.ID_ACCOUNT_POST = :id_acc_post;

      if (:id_phonecall is not null) then begin
        update PHONECALLS P
        set    P.ID_ACCOUNT_POST = :id_acc_post
        where  P.ID_PHONECALL = :id_phonecall;
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_ANUL_DETAIL$INT for: RES_FINALIZE_RECALC$INT */
ALTER PROCEDURE RES_ANUL_DETAIL$INT(RD_DBKEY CHAR(8),
REASON VARCHAR(50),
CANCELATION_NUMBER /* TYPE OF NAME_20 */ VARCHAR(20) = null)
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE_SHAREOPTION$INT for: RES_FINALIZE_RECALC$INT */
ALTER PROCEDURE RES_FINALIZE_SHAREOPTION$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GET_PRICE$INT for: RES_FINALIZE_RECALC$INT */
ALTER PROCEDURE RES_GET_PRICE$INT(RD_DBKEY CHAR(8),
OPTIONS VARCHAR(255))
 RETURNS(ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
REQUIRED_DEPOSIT_VALUE NUMERIC(15,4),
REQUIRED_DEPOSIT_CURRENCY CHAR(3))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_BOARD$RSV for: RES_FINALIZE_RECALC$INT */
ALTER PROCEDURE RES_SAVE_BOARD$RSV(ID_RESERV_DETAIL INTEGER,
ID_BOARD INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_RATE$RSV for: RES_FINALIZE_RECALC$INT */
ALTER PROCEDURE RES_SAVE_RATE$RSV(ID_RESERV_DETAIL INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
IS_DIFFERENT_TARIFF INTEGER,
IS_DIFFERENT_PRICE INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_FINALIZE_RECALC$INT) */
ALTER PROCEDURE RES_FINALIZE_RECALC$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_calc integer;
begin
  -- NORMAL recalculation processing
  execute procedure RES_RECALC$INT(:rd_dbkey, 'NORMAL', 0)
  returning_values  :err_code, :err_text, :id_tar_calc;
  if (:err_code < 0) then exit;

end
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_SET$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_CREATE_SET$RSV(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
SUPPRESS_WARNINGS INTEGER,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE$INT for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_FINALIZE$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ROOM$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SAVE_ROOM$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
ID_RES_ROOM_TYPE INTEGER,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(255),
SPLIT_ON_CHECKIN SMALLINT,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_STAY$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SAVE_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_CHECKIN$INT for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SET_CHECKIN$INT(RD_DBKEY CHAR(8))
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM$INT for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SET_ROOM$INT(RD_DBKEY CHAR(8),
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_STAY$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SET_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_FINALIZE$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RESMULTI_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER,
DISABLE_WARNING SMALLINT)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_FINALIZE_SHAREOPTION$INT) */
ALTER PROCEDURE RES_FINALIZE_SHAREOPTION$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable error_context varchar(200);
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable room_price numeric(15,4);
  declare variable is_anul smallint;
begin
  WARN_CODE = null;

  select RD.ID_RESERV_DETAIL, RD.CHECK_STATUS, rd.ROOM_PRICE, rd.IS_ANUL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail, :check_status, :room_price, :is_anul;

  execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));
  execute procedure RES_FINALIZE_OCCUPANCY$INT(:rd_dbkey)
  returning_values  :err_code, :err_text, :error_context, :share_transaction_id, :share_err_code, :share_err_text, :warn_code;

  execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT share_err_code = '||coalesce(:share_err_code, 'null'));
  execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT share_err_text = '||coalesce(:share_err_text, 'null'));
  execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT err_code = '||coalesce(:err_code, 'null'));

  execute procedure RES_FINALIZE_ERRHANDLING$INT(:id_reserv_detail, :err_code, :err_text, :error_context, :SUPPRESS_NON_INSTANT_ERRORS);

  if (((:check_status >= 0) or (:room_price is null) or (:is_anul = 1) ) /*and (:is_anul = 0)*/) then begin
    execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    returning_values  :err_code, :err_text;

    execute procedure RES_FINALIZE_ERRHANDLING$INT(:id_reserv_detail, :err_code, :err_text, 'RECALC', :SUPPRESS_NON_INSTANT_ERRORS);
  end

  execute procedure RES_FINALIZE_CLEAR$INT(:rd_dbkey, :id_reserv_detail);

  warn_code = coalesce(:WARN_CODE, RDB$GET_CONTEXT('USER_TRANSACTION', 'WARN_CODE'));
  RDB$SET_CONTEXT('USER_TRANSACTION', 'WARN_CODE', null);

end
^

/* empty dependent procedure body */
/* Clear: RES_GET_DEPOSIT$INT for: RES_GET_PRICE$INT */
ALTER PROCEDURE RES_GET_DEPOSIT$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(DEPOSIT_VALUE NUMERIC(15,4),
DEPOSIT_CURRENCY CHAR(3))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GET_INFO$RSV for: RES_GET_PRICE$INT */
ALTER PROCEDURE RES_GET_INFO$RSV(ID_RESERV_DETAIL INTEGER,
RETURN_BALANCE SMALLINT = 1,
RETURN_SHARE SMALLINT = 1,
RETURN_GEUSTDATA SMALLINT = 1)
 RETURNS(NUMBER VARCHAR(62),
AGENT_PROFILE_NAME VARCHAR(100),
ARRIVALS VARCHAR(255),
DEPARTURES VARCHAR(255),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
ID_ROOM INTEGER,
ROOM VARCHAR(60),
ID_ROOM_TYPE INTEGER,
ROOM_FEATURES BLOB,
GUESTS VARCHAR(255),
GUESTS_CNT INTEGER,
PERSON_PROFILE_NAME VARCHAR(150),
RATES VARCHAR(255),
BOARDS VARCHAR(255),
PACKETS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY VARCHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
BALANCE VARCHAR(255),
OPEN_CHARGES INTEGER,
CHECK_STATUS INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
NOTE VARCHAR(2000),
NOTE_GRP VARCHAR(255),
VOUCHER_RENDER VARCHAR(512),
ACC_ROUTING VARCHAR(255),
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
BUSY_GRP INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
GUEST_TYPE_COLOR INTEGER,
IS_CLEAN INTEGER,
ROOM_PRIVATE_STATUS /* TLOGICAL */ SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GET_PRICE$RPT for: RES_GET_PRICE$INT */
ALTER PROCEDURE RES_GET_PRICE$RPT(ID_RESERV_DETAIL INTEGER,
OPTIONS VARCHAR(255) = 'FORCED')
 RETURNS(ROOM_PRICE NUMERIC(15,4),
PRICE_CURRENCY VARCHAR(3),
ROOM_DAY_PRICE NUMERIC(15,4),
ROOM_PRICE_DETAILS VARCHAR(255),
IS_MANUAL_PRICE SMALLINT,
REQUIRED_DEPOSIT_VALUE NUMERIC(15,4),
REQUIRED_DEPOSIT_CURRENCY CHAR(3))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GET_PRICE$RSV for: RES_GET_PRICE$INT */
ALTER PROCEDURE RES_GET_PRICE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(ROOM_PRICE_DETAILS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_LOAD for: RES_GET_PRICE$INT */
ALTER PROCEDURE RES_LOAD(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_AGENT_PROFILE INTEGER,
AGENT_PROFILE_NAME VARCHAR(100),
ID_PERSON_PROFILE INTEGER,
PERSON_PROFILE_NAME VARCHAR(100),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_RES_ROOM_TYPE INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
BOARD_NAMES VARCHAR(255),
TARIFF_NAMES VARCHAR(255),
PACKET_NAMES VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100),
VOUCHER_RENDER VARCHAR(512),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
TRANSFER_RENDER VARCHAR(255),
CODE_FIRST_FOOD_RENDER VARCHAR(255),
IS_LATE_DEPARTURE INTEGER,
CODE_FIRST_FOOD VARCHAR(20),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
I_SPECIAL_TREATMENT VARCHAR(255),
COMMING_KIND SMALLINT,
IS_VIP SMALLINT,
HAS_GUEST_LIST SMALLINT,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
AGENT_ACCOUNT_NAME VARCHAR(100),
IS_DIFFERENT_VOUCHER INTEGER,
IS_DIFFERENT_OTHER INTEGER,
IS_DIFFERENT_BOARD INTEGER,
IS_DIFFERENT_TARIFF INTEGER,
IS_CUSTOM_PRICE INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
ID_RATE INTEGER,
ROOM_FEATURES BLOB,
ID_GROUP INTEGER,
NUMBER VARCHAR(62),
CHECK_STATUS INTEGER,
BALANCE VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER,
RECIEVED_DEPOSITS VARCHAR(100),
ROOM_HISTORY VARCHAR(200),
TAR_ROOM_TYPE VARCHAR(100),
ID_HK_PLAN INTEGER,
COUNTRIES VARCHAR(812),
IS_RESGRP INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
IS_ANUL INTEGER,
NOTE VARCHAR(2000),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
GROUP_NAME VARCHAR(50),
ID_HOTEL INTEGER,
NOTE_REMINDERS VARCHAR(50),
IS_DIFFERENT_PRICE INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER,
ROOM_PRIVATE_STATUS /* TLOGICAL */ SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GET_PRICE$INT) */
ALTER PROCEDURE RES_GET_PRICE$INT(RD_DBKEY CHAR(8),
OPTIONS VARCHAR(255))
 RETURNS(ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
REQUIRED_DEPOSIT_VALUE NUMERIC(15,4),
REQUIRED_DEPOSIT_CURRENCY CHAR(3))
 AS
declare variable id_reserv_detail integer;
  declare variable no_access integer;

  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable guarantee_deposit_percent integer;
  declare variable guarantee_deposit_nights integer;
  declare variable res_days integer;
begin
  /*  Description:
  ||  OPTIONS = [FORCED || SECURITY || POSTED ]
  */

  select RD.ROOM_PRICE, RD.ROOM_CURRENCY, RD.ROOM_PRICE_DETAILS,
         RD.ID_RESERV_DETAIL, rd.GUARANTEE_DEPOSIT_PERCENT, rd.GUARANTEE_DEPOSIT_NIGHTS,
         RD.GUARANTEE_DEPOSIT, rd.GUARANTEE_CURRENCY,rd.TO_DATE - rd.FROM_DATE
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :room_price, :room_currency, :room_price_details,
         :id_reserv_detail, :guarantee_deposit_percent, :guarantee_deposit_nights,
         :required_deposit_value, :required_deposit_currency, :res_days;

  if (:options containing 'POSTED' /*and (:check_status >= 0)*/) then begin
    -- can be posted and not checked in
    select sum(AP.PRICE_ORIG * AP.QTY_POST * CR.RATE)
    from   ACCOUNT_POST AP
           join GUEST G on G.ID_GUEST = AP.ID_GUEST
           join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
           left outer join CURR_CROSS_RATE_GET(AP.CURR_ORIG, :room_currency, AP.DATE_POST, A.ID_HOTEL) CR on 0=0
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
           and AP.IS_ANUL = 0
           and AP.ID_MASTER_ADDINS_ACC_POST > 0
    into   :room_price;
    room_price_details = '';
    REQUIRED_DEPOSIT_CURRENCY = null;
    REQUIRED_DEPOSIT_VALUE = null;
  end

  if (:options containing 'SECURITY') then begin
    select max(A.SECURITY_LEVEL - SEC.GRANTED_LEVEL)
    from   GUEST G
           join ACCOUNT A on A.ID_ACCOUNT = G.ID_BASE_ACCOUNT
           left outer join (select cast(iif(
                exists(
                  select *
                  from   RIGHTS_USER_GROUPS R
                         join RIGHTS_GROUPS_LINES RGL on R.ID_RIGHT_GROUP = RGL.ID_RIGHT_GROUP
                  where  R.USER_NAME = current_user
                         and RGL.RIGHT_CODE  = 'ACCSECURLEVEL1'
                ) , 1, 0) as integer) as GRANTED_LEVEL
           from RDB$DATABASE) SEC on 0=0
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :no_access;
    if (:no_access = 1) then begin
      room_price = null;
      room_currency = null;
      room_price_details = '-';
      exit;
    end
  end

  if ((:room_price is null) and (:options containing 'FORCED')) then begin
    execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    returning_values  :err_code, :err_text;
    if (:err_code < 0) then exit;
  
    -- execute procedure TAR_CALC_FINALIZE$INT(:err_code, :id_tar_calc, :rd_dbkey);

    select RD.ROOM_PRICE, RD.ROOM_CURRENCY, RD.ROOM_PRICE_DETAILS
    from   RESERV_DETAIL RD
    where  RD.RDB$DB_KEY = :rd_dbkey
    into   :room_price, :room_currency, :room_price_details;

  end

  if (:REQUIRED_DEPOSIT_VALUE is null) then begin
    REQUIRED_DEPOSIT_CURRENCY = :ROOM_CURRENCY;
    if (:guarantee_deposit_percent is not null) then
      REQUIRED_DEPOSIT_VALUE = :ROOM_PRICE * cast(:guarantee_deposit_percent as double precision) / 100;
    else if (:guarantee_deposit_nights is not null) then
      REQUIRED_DEPOSIT_VALUE = :ROOM_PRICE * cast(:guarantee_deposit_nights as double precision) / :res_days;
  end

end
^

/* Alter (RES_GET_PRICE$RPT) */
ALTER PROCEDURE RES_GET_PRICE$RPT(ID_RESERV_DETAIL INTEGER,
OPTIONS VARCHAR(255) = 'FORCED')
 RETURNS(ROOM_PRICE NUMERIC(15,4),
PRICE_CURRENCY VARCHAR(3),
ROOM_DAY_PRICE NUMERIC(15,4),
ROOM_PRICE_DETAILS VARCHAR(255),
IS_MANUAL_PRICE SMALLINT,
REQUIRED_DEPOSIT_VALUE NUMERIC(15,4),
REQUIRED_DEPOSIT_CURRENCY CHAR(3))
 AS
declare variable rd_dbkey char(8);
  declare variable r_days integer;
begin
  /*  Description:
  ||
  */
  rd_dbkey = null;
  room_price = null;
  price_currency = null;
  select RD.RDB$DB_KEY, RD.TO_DATE - RD.FROM_DATE,
         iif((RD.HAS_DIFFERENT_PRICE = 1) or (RD.CUSTOM_PRICE is not null), 1, 0)
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
         and RD.IS_ANUL = 0
  into   :rd_dbkey, :r_days, :IS_MANUAL_PRICE;

  if (:rd_dbkey is null) then exit;
  execute procedure RES_GET_PRICE$INT(:rd_dbkey, :options)
  returning_values  :room_price, :price_currency, :room_price_details, :required_deposit_value, :required_deposit_currency;
  room_day_price = :room_price / :r_days;

  suspend;
end
^

/* Alter (RES_GET_PRICE$RSV) */
ALTER PROCEDURE RES_GET_PRICE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(ROOM_PRICE_DETAILS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3))
 AS
declare variable rd_dbkey char(8);
declare variable dummy varchar(255);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_GET_PRICE$INT(:rd_dbkey, 'SECURITY, FORCED')
  returning_values  :room_price, :room_currency, :room_price_details, :dummy, :dummy;

  room_price_details = formatFloat(:room_price, 'F;0.00')||:room_currency||' ('|| :room_price_details||')';
end
^

/* empty dependent procedure body */
/* Clear: EXPORT_BOOKING$EXC for: RES_LOAD */
ALTER PROCEDURE EXPORT_BOOKING$EXC(BOOKING_ID INTEGER)
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20),
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_ID INTEGER,
IS_GUEST_ARRANGER INTEGER,
POSTING_ROUTING VARCHAR(20),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IS_DIFFERENT_TARIFF SMALLINT,
IS_DIFFERENT_BOARD SMALLINT,
IS_CUSTOM_PRICE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
EXC_LOCAL_VERSION BIGINT,
EXC_REMOTE_VERSION BIGINT,
CREATE_DATETIME TIMESTAMP,
EATING_OBJECT VARCHAR(50))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_LOAD) */
ALTER PROCEDURE RES_LOAD(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_AGENT_PROFILE INTEGER,
AGENT_PROFILE_NAME VARCHAR(100),
ID_PERSON_PROFILE INTEGER,
PERSON_PROFILE_NAME VARCHAR(100),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_RES_ROOM_TYPE INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
BOARD_NAMES VARCHAR(255),
TARIFF_NAMES VARCHAR(255),
PACKET_NAMES VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100),
VOUCHER_RENDER VARCHAR(512),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
TRANSFER_RENDER VARCHAR(255),
CODE_FIRST_FOOD_RENDER VARCHAR(255),
IS_LATE_DEPARTURE INTEGER,
CODE_FIRST_FOOD VARCHAR(20),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
I_SPECIAL_TREATMENT VARCHAR(255),
COMMING_KIND SMALLINT,
IS_VIP SMALLINT,
HAS_GUEST_LIST SMALLINT,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
AGENT_ACCOUNT_NAME VARCHAR(100),
IS_DIFFERENT_VOUCHER INTEGER,
IS_DIFFERENT_OTHER INTEGER,
IS_DIFFERENT_BOARD INTEGER,
IS_DIFFERENT_TARIFF INTEGER,
IS_CUSTOM_PRICE INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
ID_RATE INTEGER,
ROOM_FEATURES BLOB,
ID_GROUP INTEGER,
NUMBER VARCHAR(62),
CHECK_STATUS INTEGER,
BALANCE VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER,
RECIEVED_DEPOSITS VARCHAR(100),
ROOM_HISTORY VARCHAR(200),
TAR_ROOM_TYPE VARCHAR(100),
ID_HK_PLAN INTEGER,
COUNTRIES VARCHAR(812),
IS_RESGRP INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
IS_ANUL INTEGER,
NOTE VARCHAR(2000),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
GROUP_NAME VARCHAR(50),
ID_HOTEL INTEGER,
NOTE_REMINDERS VARCHAR(50),
IS_DIFFERENT_PRICE INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ID_EATING_OBJECT TYPE OF ID_REF,
ROOM_PRIVATE_STATUS TLOGICAL)
 AS
declare variable rd_dbkey char(8);
  declare variable reason_of_anul varchar(100);
  declare variable shared_resvations varchar(1024);
  declare variable virtual_room varchar(10);
  declare variable packet_item_ids varchar(255);
  declare variable earlycheckout_date date;
begin
  select RD.RDB$DB_KEY, RD.ID_AGENT_PROFILE, PA.PROFILE_NAME,
         RD.ID_NOM_MARKET_SEGMENT, RD.ID_NOM_SOURCE_CODE, RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_HEAR_REASON, RD.ID_NOM_COME_REASON,
         RD.ADULT_COUNT, RD.CHILD_COUNT, RD.CUSTOM_PRICE, RD.CUSTOM_CURRENCY,
         RD.IS_VIP, RD.CHECK_STATUS, RD.ID_AGENT_ACCOUNT,
         RD.ACC_ROUTING, RD.ID_PERSON_PAYMENT,
         RD.ID_AGENT_PAYMENT, RD.ID_PERSON_PROFILE, PP.PROFILE_NAME, RD.ID_GROUP,
         RD.COMMING_KIND, RD.I_SPECIAL_TREATMENT, ACC.ACCOUNT_NAME, RD.ROOM_FEATURES, RD.ID_HK_PLAN,
         RD.NUMBER, RD.IS_ANUL, RD.REASON_OF_ANUL, RD.NOTE,
         RD.HAS_DIFFERENT_VOUCHERS, RD.HAS_DIFFERENT_OTHER,
         RD.HAS_DIFFERENT_BOARD, RD.HAS_DIFFERENT_TARIFF, RD.HAS_DIFFERENT_TYPE_STAY, RD.HAS_DIFFERENT_ROOM_TYPE,
         RD.ID_HOTEL, RG.GROUP_NAME, RD.ID_RATE, RD.NOTE_REMINDERS, RD.has_different_price,
         RD.ID_GUARANTEE_POLICY, RD.BLOCK_CC, rd.ID_EATING_OBJECT, g.EARLYCHECKOUT_DATE
  from   RESERV_DETAIL RD
         left outer join RESERV_GROUP RG on RG.ID_RESERV_GROUP = RD.ID_GROUP
         left outer join PROFILE PA on PA.ID_PROFILE = RD.ID_AGENT_PROFILE
         left outer join PROFILE PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
         left outer join ACCOUNT ACC on ACC.ID_ACCOUNT = RD.ID_AGENT_ACCOUNT
         left outer join GUEST G on g.ID_GUEST = rd.ID_TITULAR
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :id_agent_profile, :agent_profile_name,
         :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason,
         :adult_count, :child_count, :custom_price, :custom_currency,
         :is_vip, :check_status, :id_agent_account, :acc_routing, :id_person_payment,
         :id_agent_payment, :id_person_profile, :person_profile_name, :id_group,
         :comming_kind, :i_special_treatment, :agent_account_name, :room_features, :id_hk_plan,
         :number, :is_anul, :reason_of_anul, :note,
         :is_different_voucher, :is_different_other,
         :is_different_board, :is_different_tariff, :is_different_stay_type, :is_different_room_type,
         :id_hotel, :group_name, :id_rate, :note_reminders, :is_different_price,
         :id_guarantee_policy, :block_cc, :id_eating_object, :earlycheckout_date;

  is_resgrp = iif(:id_group is not null, 1, 0);

  if ((:is_different_price = 1) or (:custom_price is not null) ) then
    IS_CUSTOM_PRICE = 1;
  else
    IS_CUSTOM_PRICE = 0;

  execute procedure RES_GET_PRICE$INT(:rd_dbkey, 'SECURITY')
  returning_values  :room_price, :room_currency, :room_price_details,
                    :deposit_required, :deposit_required_currency;

  execute procedure RES_GET_BALLANCE$INT(:id_reserv_detail)
  returning_values  :balance, :recieved_deposits, :has_charges, :open_charges, :open_deposit;

  execute procedure RES_GET_STATIC_DATA$INT(:rd_dbkey)
  returning_values  :arrival_date, :departure_date, :voucher_num, :voucher_date,
                    :voucher_text, :voucher2_num, :voucher2_date, :transfer_in_time,
                    :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :is_late_departure, :code_first_food;

  execute procedure RES_GET_DYNAMIC_DATA$INT(:rd_dbkey, 1)
  returning_values  :id_res_room_type, :id_room_type, :id_room, :id_board,
                    :id_tariff, :packet_item_ids, :room_name, :room_history, :tar_room_type, :virtual_room;

  execute procedure RES_GET_GUEST_DATA$INT('DETAIL', :id_reserv_detail)
  returning_values  :board_names, :tariff_names, :packet_names, :voucher_render;

  execute procedure RES_GET_GUEST_DATA2$INT(:id_reserv_detail)
  returning_values  :has_guest_list, :countries, :transfer_render, :code_first_food_render;

  execute procedure RES_GET_ATTENTION_STATUS$INT(:arrival_date, :departure_date, :check_status, :id_hotel)
  returning_values  :attention_status;

  execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'RENDER', null)
  returning_values  :in_share, :shared_resvations, :shares_preview;
  if (:IN_SHARE = 1) then ROOM_NAME = coalesce(:ROOM_NAME, :virtual_room);

  annul_status = :is_anul;
  if (:reason_of_anul = 'EXPIRE') then annul_status = 2;
  execute procedure sys_dbg('res RES_LOAD comming_kind = '||coalesce(:comming_kind, 'null'));

  ROOM_PRIVATE_STATUS = 0;
  select cast(1 as smallint)
  from   SYSTEM_DATE_GET (:ID_HOTEL) sd
         join ROOM_MAGIC rm on rm.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                               and rm.ROOM_STATUS = 'PRIVATE'
                               and rm.BUSY_DATE = mindate(maxdate(:ARRIVAL_DATE, sd.SYSTEM_DATE), coalesce(:earlycheckout_date, :DEPARTURE_DATE) - 1)
  into   :ROOM_PRIVATE_STATUS;

  suspend;
end
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_CHANGE$RSV for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTING$INT for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_GUESTCOUNT$RSV for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_ACCOUNTS$INT) */
ALTER PROCEDURE RES_SAVE_ACCOUNTS$INT(RD_DBKEY CHAR(8))
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_base_account integer;
  declare variable old_id_extra_account integer;
  declare variable new_id_base_account integer;
  declare variable new_id_extra_account integer;
  declare variable acc_routing varchar(30);
  declare variable is_sep_accounts integer;
  declare variable id_base_account_profile integer;
  declare variable id_extra_account_profile integer;
  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable id_agent_account_rule integer;
  declare variable id_acc_template_person integer;
  declare variable id_guest integer;
  declare variable id_hotel integer;
begin

  select RD.ID_RESERV_DETAIL, RD.ID_PERSON_PROFILE, RD.ID_ACC_TEMPLATE_PERSON,
         RD.ACC_ROUTING, RD.ID_BASE_ACCOUNT, RD.ID_EXTRA_ACCOUNT,
         RD.ID_AGENT_PROFILE, RD.ID_AGENT_ACCOUNT_RULE, rd.id_hotel
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :RD_DBKEY
  into   :id_reserv_detail, :id_person_profile, :id_acc_template_person,
         :acc_routing, :old_id_base_account, :old_id_extra_account,
         :id_agent_profile, :id_agent_account_rule, :id_hotel;

  id_agent_account_rule = nullif(:id_agent_account_rule, -1);
  /* --- new */
  execute procedure SETTING_GET_VALUE ('SEPARATE_ACCOUNTS_PER_PAYER', :id_hotel)
  returning_values (:IS_SEP_ACCOUNTS);

  NEW_ID_BASE_ACCOUNT = null; --:old_id_base_account;
  NEW_ID_EXTRA_ACCOUNT = null; --:old_id_extra_account;

  /* identify profiles for base and extra account */
  if (:ACC_ROUTING in ('MIXED')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else if (:ACC_ROUTING in ('AGENT')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
  end else if (:ACC_ROUTING in ('FULL_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = null;
    IS_SEP_ACCOUNTS = 0;  -- never
  end else if (:ACC_ROUTING in ('PART_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else begin -- if (:acc_routing in ('GUEST', 'OWNER'))
    ID_BASE_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_AGENT_ACCOUNT_RULE = null;
  end

  execute procedure RES_ACCOUNTS_RECIEVE$INT (:ID_RESERV_DETAIL, :old_id_base_account, :old_id_extra_account,
          :id_agent_account_rule, :id_base_account_profile, :id_extra_account_profile, :id_person_profile,
          :id_acc_template_person, :is_sep_accounts)
  returning_values (:new_id_base_account, :new_id_extra_account);

--  if (:new_id_base_account is null) then exception WRONG_VALUE 'Invalid base account!';
--  if (:new_id_extra_account is null) then exception WRONG_VALUE 'Invalid extra account!';
  if ((:old_id_base_account is distinct from :new_id_base_account)
       or (:old_id_extra_account is distinct from :new_id_extra_account)) then
  begin
    update RESERV_DETAIL RD
    set    RD.ID_BASE_ACCOUNT = :new_id_base_account,
           RD.ID_EXTRA_ACCOUNT = :new_id_extra_account
    where  RD.RDB$DB_KEY = :RD_DBKEY;
    /* end --- */
    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
             --and G.CHECK_STATUS < 1
      into   :id_guest
    do begin
      execute procedure GUEST_REROUTE_POSTINGS$INT(:id_guest, :new_id_base_account, :new_id_extra_account);
    end

    -- Log account changes
    execute procedure RES_SAVE_ACCOUNTS_FINALIZE$INT(:id_reserv_detail, :old_id_base_account, :old_id_extra_account,
            :new_id_base_account, :new_id_extra_account);
  end

end
^

/* Alter (RES_SAVE_BOARD$RSV) */
ALTER PROCEDURE RES_SAVE_BOARD$RSV(ID_RESERV_DETAIL INTEGER,
ID_BOARD INTEGER)
 AS
declare variable rd_dbkey char(8);
declare variable err_code integer;
declare variable err_text varchar(255);
begin

  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_SAVE_BOARD$INT(:rd_dbkey, :id_board);
   
  execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');

end
^

/* Alter (RES_SAVE_GUESTCOUNT$RSV) */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select rd.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  rd.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SAVE_GUESTCOUNT$INT(:rd_dbkey, :adult_count, :child_count);

  execute procedure RES_SAVE_ACCOUNTS$INT (:rd_dbkey);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 0)
  returning_values  :warn_code;

end
^

/* empty dependent procedure body */
/* Clear: UPDATE_BOOKING$EXC for: RES_SAVE_RATE$RSV */
ALTER PROCEDURE UPDATE_BOOKING$EXC(BOOKING_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE INTEGER,
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA_ID INTEGER,
POSTING_ROUTING VARCHAR(20),
ID_AGENT_ACCOUNT INTEGER,
RATE_ID INTEGER,
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD_CODE /* TFOOD_CODE */ VARCHAR(20),
ARRANGER_PROFILE_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_RATE$RSV) */
ALTER PROCEDURE RES_SAVE_RATE$RSV(ID_RESERV_DETAIL INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
IS_DIFFERENT_TARIFF INTEGER,
IS_DIFFERENT_PRICE INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 AS
declare variable rd_dbkey char(8);
  declare variable old_price numeric(14,4);
  declare variable old_price_currency char(3);
  declare variable action_text varchar(255);
  declare variable err_code integer;
  declare variable err_text varchar(255) ;
begin

  select RD.RDB$DB_KEY, RD.custom_price, rd.custom_currency
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_price, :old_price_currency;

  if (:is_different_tariff = 0) then begin
    execute procedure RES_SAVE_RATE$INT(:rd_dbkey, :id_tariff);
  end else begin
    execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey);
  end

  if (:IS_DIFFERENT_PRICE = 0) then begin
    delete from RESERV_CUSTOM_PRICE
    where  ID_RESERV_DETAIL  = :ID_RESERV_DETAIL;

    update RESERV_DETAIL RD
    set    RD.CUSTOM_PRICE = :custom_price,
           RD.CUSTOM_CURRENCY = :custom_currency
    where  RD.RDB$DB_KEY = :rd_dbkey;
  end else begin
    update RESERV_DETAIL RD
    set    RD.CUSTOM_PRICE = null,
           RD.CUSTOM_CURRENCY = null
    where  RD.RDB$DB_KEY = :rd_dbkey;
  end


  /*Maintain the flag in RD - HAS_DIFFERENT_PRICE*/
  if (exists (select * from RESERV_CUSTOM_PRICE rmp where rmp.id_reserv_detail = :id_reserv_detail)) then
    update RESERV_DETAIL set has_different_price = 1 where id_reserv_detail = :id_reserv_detail;
  else
    update RESERV_DETAIL set has_different_price = 0 where id_reserv_detail = :id_reserv_detail;

  /*Log modifications in custom price if here is diferent values*/
  if ((:old_price is distinct from :custom_price) or (:old_price_currency is distinct from :custom_currency) ) then begin
    action_text = f_character(29) || coalesce(:custom_price, 0) || '' || :custom_currency || f_character(28);
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_MANUAL_PRICE', :action_text);
  end

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    returning_values  :err_code, :err_text;
    if (:err_code < 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ROOM$EXC for: RES_SAVE_ROOM$RSV */
ALTER PROCEDURE RES_SAVE_ROOM$EXC(RD_DBKEY CHAR(8),
ID_RES_ROOM_TYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(250),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_ROOM$RSV) */
ALTER PROCEDURE RES_SAVE_ROOM$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
ID_RES_ROOM_TYPE INTEGER,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(255),
SPLIT_ON_CHECKIN SMALLINT,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
declare variable tmp_warn_code integer;
begin
  WARN_CODE = null;
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, :id_res_room_type, :TAR_OPTION, :is_auto_staytype)
  returning_values (:WARN_CODE);

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 1)
    returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :tmp_warn_code;
  end
  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

  update RESERV_DETAIL R
  set    r.SPLIT_ON_CHECKIN = :split_on_checkin,
         r.ID_HK_PLAN = :ID_HK_PLAN,
         r.I_SPECIAL_TREATMENT = :I_SPECIAL_TREATMENT,
         r.ROOM_FEATURES = :ROOM_FEATURES
  where  r.ID_RESERV_DETAIL = :id_reserv_detail;
end
^

/* Alter (RES_SAVE_STAY$RSV) */
ALTER PROCEDURE RES_SAVE_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure sys_dbg('res RES_SAVE_STAY$RSV comming_kind = '||coalesce(:comming_kind, 'null'));
  execute procedure sys_dbg('res RES_SAVE_STAY$RSV is_late_departure = '||coalesce(:is_late_departure, 'null'));

  execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :departure_date, :is_late_departure, :comming_kind);

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 1)
    returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;
    execute procedure sys_dbg('res RES_SAVE_STAY$RSV share_err_code = '||coalesce(:share_err_code, 'null'));
  end
  --
end
^

/* empty dependent procedure body */
/* Clear: RES_CHECKIN$RSV for: RES_SET_CHECKIN$INT */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SET_CHECKIN$INT) */
ALTER PROCEDURE RES_SET_CHECKIN$INT(RD_DBKEY CHAR(8))
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
begin
  select r.ID_RESERV_DETAIL
  from   RESERV_DETAIL R
  where  r.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail;

  execute procedure ROOM_MAGIC_CLEAR(:id_reserv_detail);   -- ?!?

  execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, 0);

  for
    select G.RDB$DB_KEY
    from   GUEST G
    where  g.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :g_dbkey
  do begin
    execute procedure GUEST_SET_STATUS$INT(:g_dbkey, 0);
  end

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;
end
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_CO_RENTERS$INT for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_CO_RENTERS$INT(VIRTUAL_ID_ROOM INTEGER,
NEW_ID_ROOM INTEGER,
INIT_ID_RES_DETAIL INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_FAST$RSV for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_FAST$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_MULTI$RSV for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_MULTI$RSV(OPERATION VARCHAR(20),
FROM_ROOM VARCHAR(20),
SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_SHARED$RSV for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_SHARED$RSV(SELECTION_ID INTEGER,
ROOM_NAME VARCHAR(10))
 RETURNS(VIRTUAL_ROOM VARCHAR(10),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SET_ROOM$INT) */
ALTER PROCEDURE RES_SET_ROOM$INT(RD_DBKEY CHAR(8),
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
declare variable tmp_warn_code integer;
begin
  WARN_CODE = null;
  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option)
  returning_values (:WARN_CODE);

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :SHARE_ERR_TEXT, :share_transaction_id, :tmp_warn_code;

  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
end
^

/* Alter (RES_SET_ROOM_CO_RENTERS$INT) */
ALTER PROCEDURE RES_SET_ROOM_CO_RENTERS$INT(VIRTUAL_ID_ROOM INTEGER,
NEW_ID_ROOM INTEGER,
INIT_ID_RES_DETAIL INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
declare variable shared_rd_dbkey char(8);
declare variable shared_booking_ids varchar(255);
declare variable id_reserv_detail integer;
declare variable tmp_share_err_code integer;
declare variable tmp_share_err_text varchar(255);
begin
  -- distribute the same room to shared bookings

  if (coalesce(:NEW_ID_ROOM, 0) < 0) then exit; -- only for real rooms!1
  SHARE_ERR_CODE = 0;
  shared_booking_ids = ',' || :INIT_ID_RES_DETAIL || ',';
  for
    select vrd.RDB$DB_KEY, vrd.ID_RESERV_DETAIL
    from   RESERV_DETAIL VRD
    where  vrd.ID_ROOM = :VIRTUAL_ID_ROOM
           and vrd.IS_ANUL = 0
           and vrd.ID_RESERV_DETAIL is distinct from :INIT_ID_RES_DETAIL
           -- and vrd.SELECTION_ID = :SELECTION_ID ?????
    into   :shared_rd_dbkey, :id_reserv_detail
  do begin
    shared_booking_ids = :shared_booking_ids || :id_reserv_detail || ',';

    execute procedure RES_SET_ROOM$INT (:shared_rd_dbkey, :NEW_ID_ROOM, :TAR_OPTION)
    returning_values  :WARN_CODE, :share_transaction_id, :tmp_share_err_code, :tmp_share_err_text;

    if (:SHARE_ERR_CODE = 0 and :tmp_share_err_code < 0) then begin
      -- check for share with other bookings
      if (exists (select rs.ID_RESERV_DETAIL
                      from   ROOMS_SHARE rs
                      where  rs.MARK_TRANSACTION = :SHARE_TRANSACTION_ID
                             and :shared_booking_ids not containing ','||rs.ID_RESERV_DETAIL||','
                             and rs.IS_EX_SHARE = 0)) then
      begin
        SHARE_ERR_CODE = :tmp_share_err_code;
        SHARE_ERR_TEXT = :tmp_share_err_text;
      end
    end
  end 
end
^

/* Alter (RES_SET_ROOM_FAST$RSV) */
ALTER PROCEDURE RES_SET_ROOM_FAST$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable old_id_room integer;
  declare variable virtual_room varchar(10);
  declare variable rd_dbkey char(8);
  declare variable tmp_warn_code integer;
  declare variable tmp_share_err_code integer;
  declare variable tmp_share_err_text varchar(255);
begin

  select RD.ID_ROOM, rd.VIRTUAL_ROOM, rd.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_id_room, :virtual_room, :rd_dbkey;

  execute procedure RES_SET_ROOM$INT (:rd_dbkey, :ID_ROOM, :TAR_OPTION)
  returning_values (:warn_code, :share_transaction_id, :share_err_code, :ERR_TEXT);

  if (:virtual_room is not null and :old_id_room < 0) then begin
    execute procedure RES_SET_ROOM_CO_RENTERS$INT (:old_id_room, :ID_ROOM, :ID_RESERV_DETAIL, :TAR_OPTION)
    returning_values (:tmp_warn_code, :share_transaction_id, :tmp_share_err_code, :tmp_share_err_text);
    WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
    SHARE_ERR_CODE = coalesce(:SHARE_ERR_CODE, :tmp_share_err_code);
    ERR_TEXT = coalesce(:ERR_TEXT, :tmp_share_err_text);
  end
end
^

/* Alter (RES_SET_ROOM_MULTI$RSV) */
ALTER PROCEDURE RES_SET_ROOM_MULTI$RSV(OPERATION VARCHAR(20),
FROM_ROOM VARCHAR(20),
SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable cnt_requested integer;
  declare variable cnt_old_room integer;
  declare variable cnt_found integer;
  declare variable is_already_planned integer;
  declare variable is_satisfied integer;
  declare variable new_id_room integer;
  declare variable current_id_room integer;
  declare variable id_res_room_type integer;
  declare variable room_requirements blob sub_type 1 segment size 100;
  declare variable from_date date;
  declare variable to_date date;
  declare variable action_text varchar(255);
  declare variable is_early_arrival smallint;
  declare variable is_late_departure smallint;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable id_reserv_detail integer;
  declare variable tmp_warn_code integer;
  declare variable min_beds integer;
  declare variable virtual_room varchar(10);
  declare variable share_err_text varchar(255);
begin
  /* offer_method :
  ||     0 - NUMBER desc,
  ||     1 - NUMBER asc,
  ||     2 - DAYS FREE(MAX OCCUPANCY),
  ||     3 - FILING FACTOR(EQUAL ROOM USAGE)
  */
  warn_code = null;

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'set_number_asc, set_number_desc, set_max_occupancy, set_max_usage');

  cnt_requested = 0;
  cnt_old_room = 0;
  cnt_found = 0;
  for
    select RD.RDB$DB_KEY, rd.ID_RESERV_DETAIL, rd.ID_ROOM, rd.VIRTUAL_ROOM, RD.ID_ROOM_TYPE, RD.ROOM_FEATURES,
           RD.FROM_DATE, RD.TO_DATE, iif(rd.COMMING_KIND = 0, 1, 0), iif(rd.LEAVING_KIND = 2, 1, 0),
           rd.ADULT_COUNT + rd.CHILD_COUNT
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
           and RD.IS_ANUL = 0
    into   :rd_dbkey, :id_reserv_detail, :current_id_room, :virtual_room, :id_res_room_type, :room_requirements,
           :from_date, :to_date, :is_early_arrival, :is_late_departure, :min_beds
  do begin
    cnt_requested = :cnt_requested + 1;
    new_id_room = null;
    if (:current_id_room < 0) then begin
      if (:virtual_room is not null) then begin
        -- has related bookings with shared virtual room
        -- get cumulative stay for all shared bookings
        select min(vrd.FROM_DATE), min(vrd.FROM_DATE) - min(vrd.FROM_DATE - iif(vrd.COMMING_KIND = 0, 1, 0)),
               max(vrd.TO_DATE), max(vrd.TO_DATE + iif(vrd.LEAVING_KIND = 2, 1, 0)) - max(vrd.TO_DATE),
               sum(vrd.ADULT_COUNT + vrd.CHILD_COUNT)
        from   RESERV_DETAIL VRD
        where  vrd.ID_ROOM = :current_id_room
               and vrd.IS_ANUL = 0
        into   :from_date, :is_early_arrival, :to_date, :is_late_departure, :min_beds;
      end
      -- from_date and to_date are arrival and departure date of reservation,
      -- not first and last accomodation dates !!! this is need to check early arrivals and late departures
      execute procedure ROOM_PICKUP$INT(:id_res_room_type, :from_date, :to_date,
              :is_early_arrival, :is_late_departure,:operation, :from_room, :room_requirements, :min_beds)
      returning_values  :new_id_room;  -- offered room

      if (:new_id_room is not null) then begin
        is_satisfied = 1;
        select R.ROOM_NAME
        from   ROOMS R
        where  r.ID_ROOM = :new_id_room
        into   :action_text;

        execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'ROOM_SET_AUTO', :action_text);

        execute procedure RES_SET_ROOM$INT (:rd_dbkey, :new_id_room, 'nrttAsIs')
        returning_values (:tmp_warn_code, :share_transaction_id, :share_err_code, :share_err_text);
        if (:share_err_code < 0) then exception BOOKING_EXCEPTION 'Unallowable share!!!';
        WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

        if (:virtual_room is not null) then begin
          -- distribute the same room to shared bookings
          execute procedure RES_SET_ROOM_CO_RENTERS$INT (:current_id_room, :new_id_room, :id_reserv_detail, 'nrttAsIs')
          returning_values (:tmp_warn_code, :share_transaction_id, :share_err_code, :share_err_text);
          if (:share_err_code < 0) then exception BOOKING_EXCEPTION 'Unallowable share!!!';
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
        end
      end

    end else begin
      is_already_planned = 1;
    end

    cnt_old_room = :cnt_old_room + :is_already_planned;
    cnt_found = :cnt_found + :is_satisfied;

    when exception BOOKING_EXCEPTION do begin
      -- nothing, skip this booking
    end
  end

  if ((:cnt_found + :cnt_old_room) < :cnt_requested) then begin
    execute procedure SYSTEM_WARNING_ADD(-3, f_character(29)||:cnt_found||f_character(28)||:cnt_requested)
    returning_values  :warn_code;
  end
end
^

/* Alter (RES_SET_ROOM_SHARED$RSV) */
ALTER PROCEDURE RES_SET_ROOM_SHARED$RSV(SELECTION_ID INTEGER,
ROOM_NAME VARCHAR(10))
 RETURNS(VIRTUAL_ROOM VARCHAR(10),
WARN_CODE INTEGER)
 AS
declare variable r_dbkey char(8);
  declare variable is_anul integer;
  declare variable shared_id_room integer;
  declare variable current_id_room integer;
  declare variable tmp_warn_code integer;
  declare variable share_trans integer;
  declare variable share_err_code integer;
  declare variable id_hotel integer;
  declare variable cnt_hotels integer;
  declare variable id_room integer;
  declare variable res_counter integer;
  declare variable min_departure date;
  declare variable max_arrival date;
  declare variable share_err_text varchar(255);
begin
  VIRTUAL_ROOM = null;
  select min(r.ID_HOTEL), count(distinct r.ID_HOTEL),
         min(r.TO_DATE), max(r.FROM_DATE)
  from   RESERV_DETAIL R
  where  R.SELECTION_ID = :SELECTION_ID
  into   :id_hotel, :cnt_hotels, :min_departure, :max_arrival;

  if (:cnt_hotels > 1) then exception BOOKING_EXCEPTION '-1035';
  if (:min_departure <= :max_arrival) then exception BOOKING_EXCEPTION '-1037';

  if (:ROOM_NAME is not null) then begin
    execute procedure ROOM_GET_BY_NAME(:ROOM_NAME, :id_hotel)
    returning_values (:id_room);
    shared_id_room = :ID_ROOM;
  end else begin
    id_room = null;
    shared_id_room = gen_id(DETAIL_WITHOUT_ROOMING_LIST, -1);
    VIRTUAL_ROOM = gen_id(GEN_VIRTUAL_ROOM, 1);
  end

  res_counter = 0;
  for
    select r.RDB$DB_KEY, r.IS_ANUL, r.ID_ROOM
    from   RESERV_DETAIL R
    where  R.SELECTION_ID = :SELECTION_ID
    into   :r_dbkey, :is_anul, :current_id_room
  do begin
    res_counter = :res_counter + 1;
    if (:is_anul = 1) then
      exception BOOKING_EXCEPTION '-1036';

    if (:current_id_room > 0 and :ID_ROOM is null) then
      exception BOOKING_EXCEPTION '-1034';

    execute procedure RES_SET_ROOM$INT(:r_dbkey, :shared_id_room, 'nrttAsIs')
    returning_values  :tmp_warn_code, :share_trans, :share_err_code, :share_err_text;
    WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
  end

  if (:VIRTUAL_ROOM is not null and :share_trans is not null) then begin
    update RESERV_DETAIL RD
    set    rd.VIRTUAL_ROOM = '<'||:VIRTUAL_ROOM||'>'
    where  rd.ID_ROOM = :shared_id_room;
  end
end
^

/* Alter (RES_SET_STAY$RSV) */
ALTER PROCEDURE RES_SET_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable is_late_departure integer;
  declare variable comming_kind integer;
begin
  select RD.COMMING_KIND, RD.LEAVING_KIND - 1, RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :comming_kind, :is_late_departure, :rd_dbkey;

  execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :departure_date, :is_late_departure, :comming_kind);

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 1)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

end
^

/* empty dependent procedure body */
/* Clear: RES_CHECKIN_MULTI$RSV for: RES_SPLIT$RSV */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT_MULTI$RSV for: RES_SPLIT$RSV */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SPLIT$RSV) */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
declare variable rd_dbkey_old char(8);
  declare variable rd_dbkey_new char(8);
  declare variable id_guest integer;
  declare variable warn_code integer;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;

  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable check_status integer;
  declare variable arrival_date date;
  declare variable departure_date date;
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable id_room_type integer;
  declare variable id_room integer;
  declare variable id_board integer;
  declare variable id_tariff integer;
  declare variable custom_price numeric(15,4);
  declare variable custom_currency char(3);
  declare variable voucher_num varchar(30);
  declare variable voucher_date date;
  declare variable voucher_text varchar(30);
  declare variable voucher2_num varchar(30);
  declare variable voucher2_date date;
  declare variable transfer_in_time time;
  declare variable transfer_in_note varchar(255);
  declare variable transfer_out_time time;
  declare variable transfer_out_note varchar(255);
  declare variable comming_kind integer;
  declare variable is_late_departure integer;
  declare variable is_vip integer;
  declare variable country_code varchar(20);
  declare variable code_first_food tfood_code;
  declare variable i_special_treatment varchar(255);
  declare variable id_nom_market_segment integer;
  declare variable id_nom_source_code integer;
  declare variable id_nom_channel_code integer;
  declare variable id_nom_hear_reason integer;
  declare variable id_nom_come_reason integer;
  declare variable id_agent_account integer;
  declare variable acc_routing varchar(50);
  declare variable id_person_payment integer;
  declare variable id_agent_payment integer;
  declare variable room_features blob sub_type 1 segment size 80;
  declare variable id_hk_plan integer;
  declare variable id_group integer;
  declare variable id_hotel integer;
  declare variable note varchar(2000);
  declare variable note_reminders varchar(50);
  declare variable guarantee_deposit numeric(15,4);
  declare variable guarantee_currency char(3);
  declare variable id_titular integer;
  declare variable id_profile_data integer;
  declare variable id_acc_template_person integer;
  declare variable number_1 varchar(20);
  declare variable number_2 varchar(20);
  declare variable new_res_number varchar(62);
  declare variable g_dbkey char(8);
  declare variable is_child integer;
  declare variable id_guarantee_policy integer;
  declare variable block_cc varchar(255);
  declare variable virtual_room varchar(10);
  declare variable err_text varchar(255);
  declare variable is_posting_stopped integer;
  declare variable id_eating_object integer;
begin
  select RD.RDB$DB_KEY, RD.ID_AGENT_PROFILE, RD.CHECK_STATUS, RD.FROM_DATE, RD.TO_DATE,
         RD.ADULT_COUNT, RD.CHILD_COUNT, RD.ID_ROOM_TYPE, RD.ID_ROOM, RD.ID_BOARD, RD.ID_RATE,
         RD.CUSTOM_PRICE, RD.CUSTOM_CURRENCY, RD.VAUCHER_NUM, RD.VAUCHER_DATE, RD.VAUCHER_TEXT, RD.VAUCHER_NUM2,
         RD.VAUCHER_DATE2, RD.TRANSFER_IN_TIME, RD.TRANSFER_IN_NOTE, RD.TRANSFER_OUT_TIME, RD.TRANSFER_OUT_NOTE,
         RD.COMMING_KIND, RD.LEAVING_KIND - 1, RD.IS_VIP, RD.COUNTRY, RD.CODE_FIRST_FOOD, RD.I_SPECIAL_TREATMENT,
         RD.ID_NOM_MARKET_SEGMENT, RD.ID_NOM_SOURCE_CODE, RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_HEAR_REASON,
         RD.ID_NOM_COME_REASON, RD.ID_AGENT_ACCOUNT_RULE, RD.ACC_ROUTING, RD.ID_PERSON_PAYMENT, RD.ID_AGENT_PAYMENT,
         RD.ROOM_FEATURES, RD.ID_HK_PLAN, RD.ID_GROUP, RD.ID_HOTEL, RD.NOTE, RD.NOTE_REMINDERS,
         RD.GUARANTEE_DEPOSIT, RD.GUARANTEE_CURRENCY, RD.ID_ACC_TEMPLATE_PERSON,
         RD.NUMBER_1, rd.NUMBER_2, rd.ID_GUARANTEE_POLICY, rd.BLOCK_CC, rd.IS_POSTING_STOPPED, rd.ID_EATING_OBJECT
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail_source
  into   :rd_dbkey_old, :id_agent_profile, :check_status, :arrival_date, :departure_date,
         :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff,
         :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
         :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
         :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
         :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
         :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
         :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
         :guarantee_deposit, :guarantee_currency, :id_acc_template_person,
         :number_1, :number_2,:id_guarantee_policy, :block_cc, :is_posting_stopped, :id_eating_object;

  select first 1 sp.ITEM
  from   SYSTEM_STRING_PARSER(:guest_ids, ',') sp
  into   :id_titular;

  select min(g.FROM_DATE), max(g.TO_DATE)
  from   GUEST G
  where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL_SOURCE
         and ','||:GUEST_IDS||',' containing ','||g.ID_GUEST||','
  into   :arrival_date, :departure_date;

  if (exists (select *
              from   RESERV_DETAIL RD
              where  RD.ID_TITULAR = :id_titular
                     and RD.ID_RESERV_DETAIL = :id_reserv_detail_source))
  then exception BOOKING_EXCEPTION 'Titular can not be splited in new reservation';

  execute procedure RES_GET_PERSON_PROFILE$INT(:id_titular)
  returning_values  :id_person_profile, :id_profile_data;

  new_res_number = iif(coalesce(:number_1,'')='','.',:number_1||'.')
                   || coalesce(:number_2, '')
                   || '.0';  -- fictive suffix, needed for unique constraint limitation, that will be replaced with real one


  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, :check_status, :arrival_date, :departure_date,
                    0, 0, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
                    :guarantee_deposit, :guarantee_currency, 0, null, :new_res_number, :id_acc_template_person,
                    :id_guarantee_policy, :block_cc, :id_eating_object)
  returning_values  :rd_dbkey_new, :new_id_reserv_detail, :warn_code;

  execute procedure RES_NUMBER_SUFFIX_GEN (:NEW_ID_RESERV_DETAIL)
  returning_values  (:new_res_number);  -- add suffix to new (splited) booking number (empty on create)

  update RESERV_DETAIL NR
  set    nr.IS_POSTING_STOPPED = :is_posting_stopped
  where  nr.RDB$DB_KEY = :rd_dbkey_new;

  -- there is no need guests deleting, because new splited reservation is created with 0 guests
  adult_count = 0; child_count = 0;
  for
    select G.ID_GUEST, G.RDB$DB_KEY, G.IS_CHILD
    from   SYSTEM_STRING_PARSER(:guest_ids, ',') SP
           join GUEST G on G.ID_GUEST = SP.ITEM
    into   :id_guest, :g_dbkey, :is_child
  do begin
    execute procedure GUEST_SET_EDIT_STATUS$INT (:g_dbkey, 'REBUILD', 'add');

    update GUEST G
    set    G.ID_RESERV_DETAIL = :new_id_reserv_detail
    where  G.ID_GUEST = :id_guest;

    adult_count = :adult_count + (1-:is_child);
    child_count = :child_count + :is_child;

    if (:id_guest = :id_titular) then begin
      update RESERV_DETAIL RD
      set    RD.ID_TITULAR = :id_titular
      where  RD.RDB$DB_KEY = :rd_dbkey_new;

      update GUEST_DATA GD
      set    GD.ID_PERSON_DATA = :id_profile_data
      where  GD.ID_GUEST = :id_titular;
    end
  end

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL_SOURCE, 'RES_SPLIT',
          f_character(29) || :new_res_number || f_character(28) || :adult_count || ' + ' || :child_count);

  -- calling RES_SAVE_PROFILING$INT is unnecessary, it is called into RES_CREATE_SET$INT with same params
  -- here is needed to set reserv accounts per splited guests and reroute posting only (accomplished in next procedure)
  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey_new);

  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_old);
  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_new);

  update RESERV_DETAIL ORD
  set    ord.ROOM_PRICE = null
  where  ord.RDB$DB_KEY = :rd_dbkey_old;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_old, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_new, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  if (:id_room < 0) then begin
    virtual_room = gen_id(GEN_VIRTUAL_ROOM, 1);
    update RESERV_DETAIL RD
    set    rd.VIRTUAL_ROOM = '<'||:virtual_room||'>'
    where  rd.ID_ROOM = :id_room;
  end
end
^

/* Alter (RES_SPLIT_MULTI$RSV) */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
begin
  for
    select RD.ID_RESERV_DETAIL, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :id_reserv_detail, :id_titular
  do begin
    for
      select G.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.ID_GUEST <> :id_titular
      into   :id_guest
    do begin
      execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
      returning_values  :id_splited_reservation;

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
    end
  end
end
^

/* Alter (RES_TAR_CALC_FINALIZE$INT) */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(TAR_CALC_ERR INTEGER,
ID_TAR_CALC INTEGER,
RD_DBKEY_INIT CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
begin
  /*  Description:
  ||  Razpiswa cenata na staia, kakto i price_detailite.
      Za4istwa temp tablicite
  */
  --savedbg('TAR_CALC_ERR: ' || :TAR_CALC_ERR);
  --savedbg('ID_TAR_CALC: ' || :ID_TAR_CALC);
  if (:tar_calc_err = 0) then begin
    room_price = 0;
    room_price_details = '';

    execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

    for
      select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, rd.IS_POSTING_STOPPED,
             coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
             coalesce(max((select first 1 AP.IS_BASE
                           from   GUEST G
                                  join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                           where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                  and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (eventually)
      from   TAR_CALC_INPUT$TMP TI
             join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
             join TARIFA t on t.ID_TARIFA = rd.ID_RATE
      where  ti.ID_TAR_CALC = :ID_TAR_CALC
      group by 1, 2, 3, 4, 5, 6
      into   :id_reserv_detail, :check_status, :is_posting_stopped,
             :room_currency, :id_hotel, :is_anul, :has_postings
    do begin
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);

      if ( (not (:is_posting_stopped = 1 and :has_postings = 0))                                -- posting is not stopped
           and                                                                                  -- and
           ( (coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1) ) -- there are reasons to repost
         ) then
      begin

        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);

      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;

        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end

      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end else begin

    update RESERV_DETAIL RD
    set    RD.ROOM_PRICE = null,
           RD.ROOM_CURRENCY = null,
           RD.ROOM_PRICE_DETAILS = null,
           RD.LAST_ID_TAR_CALC = null
    where  RD.RDB$DB_KEY = :RD_DBKEY_INIT;
  end
  
  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;
end
^

/* Alter (RESMULTI_FINALIZE$RSV) */
ALTER PROCEDURE RESMULTI_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER,
DISABLE_WARNING SMALLINT)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  /*savedbg('------------ RES DET: ' || :ID_RESERV_DETAIL);
  savedbg('err_code: ' || :ERR_CODE);
  savedbg('share_err_code: ' || :SHARE_ERR_CODE);
  savedbg('warn_code: ' || :WARN_CODE);*/
  if (:disable_warning = 1) then warn_code = 0;
end
^

/* empty dependent procedure body */
/* Clear: SAFE_CHECK_OUT for: SAFE_OCCUPANCY_MODIFY */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE /* TYPE OF ID */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER,
WARN_CODE /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SAFE_OCCUPANCY_MODIFY) */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE TYPE OF ID,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable old_booking_number tres_number;
  declare variable id_resource_reservation id_ref;
  declare variable from_datetime tdatetime;
  declare variable action_text tdescription_long;
  declare variable old_occupant varchar(100);
  declare variable old_to_dt timestamp;
  declare variable id_reserv_detail integer;
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation;

  select rr.BOOKING_NUMBER, od.FROM_DATETIME,
         RR.OCCUPANT_NAME, od.TO_DATETIME, rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESERV_DETAIL rd on rd.NUMBER = rr.BOOKING_NUMBER and rd.IS_ANUL = 0
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :old_booking_number, :from_datetime,
         :old_occupant, :old_to_dt, :id_reserv_detail, :id_agent_profile;

  --if (:old_booking_number <> :BOOKING_NUMBER) then exception ASSERT 'Can not change booking number!';
  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  update SAFE_RESOURCE_RESERV rr
  set    rr.PRICE_DESCRIPTION = :price_description,
         rr.ID_RATE_PRICE_PROFILE = :id_agent_profile,
         rr.RATING_UNITS = :rating_units,
         rr.RATE_PRICE = :price,
         rr.RATE_CURR = :currency
  where  rr.ID_RESOURCE_RESERV = :id_resource_reservation;

  execute procedure RESOURCE_RESERVATION_MODIFY (:id_resource_reservation, :ID_SAFE, :from_datetime,
          :TO_DATETIME, :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :old_booking_number, 'mod')
  returning_values :id_resource_reservation, :no_use;

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail)
  returning_values (:DOC_SELECTED);

  /* Log changes */
  if ((:old_occupant <> :OCCUPANT_NAME) or (:old_to_dt <> :TO_DATETIME)) then begin
    action_text = f_character(29) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                  || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                  || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');
  
    execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_CHANGED', :action_text);
  end
end
^

/* Alter (SAFE_OCCUPANCY_NEW) */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE TYPE OF ID,
FROM_DATETIME TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME,
BOOKING_NUMBER TYPE OF TRES_NUMBER,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
ID_RESOURCE_RESERVATION TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable action_text tdescription_long;
  declare variable id_reserv_detail integer;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, s.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  if (:id_resource_reservation is not null) then exception ASSERT '-1064'|| f_character(31) || f_character(29) || :safe_name;

  select rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESERV_DETAIL rd
  where  rd.NUMBER = :BOOKING_NUMBER
         and rd.IS_ANUL = 0
  into   :id_reserv_detail, :id_agent_profile;

  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  execute procedure  RESOURCE_RESERVATION_MODIFY (null, :ID_SAFE, :FROM_DATETIME, :TO_DATETIME,
          :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :BOOKING_NUMBER, 'add')
  returning_values (:id_resource_reservation, :no_use) ;

  insert into SAFE_RESOURCE_RESERV (ID_RESOURCE_RESERV, PRICE_DESCRIPTION, ID_RATE_PRICE_PROFILE,
         RATING_UNITS, RATE_PRICE, RATE_CURR)
  values (:id_resource_reservation, :price_description, :id_agent_profile,
         :rating_units, :price, :currency);

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail, :ID_EXTERNAL_CLIENT_ACCCOUNT)
  returning_values (:DOC_SELECTED);

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = 'CHECKED_IN'
  where  RR.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = :id_resource_reservation
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                || f_character(28) || coalesce(:BOOKING_NUMBER, '')
                || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUPIED', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: END_WORK for: SUMMARY_FORECAST$INT */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (SUMMARY_FORECAST$INT) */
ALTER PROCEDURE SUMMARY_FORECAST$INT(ID_HOTEL INTEGER,
SUMMARY_DATE DATE)
 AS
declare variable to_date date;
begin
  select max(rm.busy_date)
  from   ROOM_MAGIC rm
  where  rm.id_hotel = :id_hotel
  into   :to_date;
  to_date = maxdate(:TO_DATE, :SUMMARY_DATE + 1);

  execute procedure AVAILABILITY_OCCUP_PREPARE$AVL (:SUMMARY_DATE + 1, :TO_DATE, 1, 1, 0, 1, 1, 1, 1, 1, :ID_HOTEL);

  insert into SUMMARY_FORECAST (
         summary_date, forecast_date, id_room_type, id_hotel,
         rooms_capacity, rooms_ooi, res_confirmed, res_notconfirmed, res_waiting,
         res_checked_in, cont_remain, bp_remain)
  select :summary_date, tso.for_date, tso.id_room_type, tso.ID_HOTEL,
         sum(tso.g_capacity), sum(tso.g_ooi), sum(tso.res_confirmed), sum(tso.res_notconfirmed), sum(tso.res_waiting),
         sum(tso.sold), sum(tso.cont_plain_remain), sum(tso.cont_bp_remain)
  from   SMART_OCCUP$TMP tso
  where  tso.ID_HOTEL = :ID_HOTEL
  group by 2, 3, 4;

  delete
  from   SUMMARY_FORECAST sf
  where  sf.summary_date = sf.forecast_date
         and sf.ID_HOTEL = :ID_HOTEL;

  insert into SUMMARY_FORECAST (
         summary_date, forecast_date, id_room_type, id_hotel,
         rooms_capacity, rooms_ooi, res_confirmed, res_notconfirmed, res_waiting,
         res_checked_in, cont_remain, bp_remain)
  select so.for_date, so.for_date, so.id_room_type, so.id_hotel,
         sum(so.rooms_available), sum(so.rooms_ooi), 0, 0, 0,
         sum(so.rooms_sold), 0, 0
  from   SUMMARY_OCCUPANCY so
  where  so.ID_HOTEL = :ID_HOTEL
         and so.for_date <= :summary_date
  group by 1, 2, 3, 4;

end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_INPUT_PARAMS$INT for: TAR_CALC_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_PARAMS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_PARAMS$INT) */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
declare variable param_code varchar(40);
  declare variable id_param integer;
  declare variable param_value varchar(255);
  declare variable data_type  varchar(30);
  declare variable rate_list varchar(2000);
begin
  err_code = 0;
  param_values = '';

  if (coalesce(:rate_list_replace, '') = '') then rate_list = ',' || :id_rate || ',';
  else rate_list = :rate_list_replace;

  for
    select distinct TBP.PARAM_NAME
    from   SYSTEM_STRING_PARSER (:rate_list, ',') sp
           left join TAR_BO_PARAMS TBP on TBP.ID_TAR_HEAD = sp.ITEM
    where  (TBP.PARAM_TYPE <> 'DATE_DEPENDANT' and :for_date is null)
           or (TBP.PARAM_TYPE = 'DATE_DEPENDANT' and :for_date is not null)
    into   :param_code
  do begin
    if (:param_code is not null) then begin
      id_param = null;
      select TP.ID_TARIFA_PARAM, TP.DATA_TYPE
      from   TARIFA_PARAMS TP
      where  TP.PARAM_CODE = :param_code
             and tp.IS_USE = 1
      into   :id_param, :data_type;
  
      if (:id_param is null) then begin
        err_code = -202;
        execute procedure sys_dbg ('tar calc params err_code: ' || :err_code || F_CRLF() || 'PARAM_CODE = ' || :param_code);
        exit;
      end
  
      execute procedure TARIFA_GET_PARAM (:id_param, :for_date, :id_tar_input, :id_tar_calc)
      returning_values (:param_value);
  
      param_code = ':'||param_code;
  
      if ((:param_code is not null) and (:param_code is not null) and (:data_type is not null)) then
         param_values = :param_values||';'||:param_code||','||:data_type||','||:param_value;
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_RATE_RECORD_RELINK$EXC for: TAR_SAVE */
ALTER PROCEDURE IMPORT_RATE_RECORD_RELINK$EXC(ID_RATE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_SAVE) */
ALTER PROCEDURE TAR_SAVE(ID_TAR_HEAD INTEGER,
PERIOD_DEPEND_ON_CHECKIN INTEGER,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BASE_BOARDS_LIST VARCHAR(255),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
BO_TYPE VARCHAR(20),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable delim integer;
  declare variable id_hotel integer;
  declare variable action_text varchar(255);
begin
  if (:base_boards_list is null) then base_boards_list = '';
  if (:board_type not in ('BOARD', 'HRANI')) then begin
    if (:board_type = '0') then board_type = 'BOARD';
    else board_type = 'HRANI';
  end
  err_code = 0;
  err_text = '';
  execute procedure SETTING_GET_VALUE('RANGE_DATA_DELIMETER', null)
  returning_values  :delim;

  -- TAR_BO_PRICES are never cleared
  delete from TAR_BO_SEASON
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_BASE_POSITION
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_BOARD
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_EXTRA_GUEST
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_DISCOUNT
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_PACK
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_PARAMS
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_DISCOUNT_STAY
  where  ID_TAR_HEAD = :id_tar_head;
  update TAR_HEAD TH
  set    PERIOD_DEPEND_ON_CHECKIN = :period_depend_on_checkin,
         CNT_DAYS_PRICE_BP        = :cnt_days_price_bp,
         CNT_DAYS_PRICE_BOARD     = :cnt_days_price_board,
         BASE_BOARDS_LIST         = f_character(:delim)||:base_boards_list||f_character(:delim),
         BOARD_TYPE               = :board_type,
         LOCK_STAMP               = current_timestamp
  where  TH.ID_TAR_HEAD = :id_tar_head;
  update TARIFA T
  set    T.IS_BASE = 1
  where  T.ID_TARIFA = :id_tar_head;
  bo_type = 'SEASON';
  execute procedure TAR_SAVE_BO_SEASON(:id_tar_head)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'BASE';
  execute procedure TAR_SAVE_BO_BP(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'BOARD';
  execute procedure TAR_SAVE_BO_BOARD(:id_tar_head, :bo_type, :board_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'EXTRA_GUEST';
  execute procedure TAR_SAVE_BO_EG(:id_tar_head, :bo_type, :board_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'PACK';
  execute procedure TAR_SAVE_BO_PACK(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'DISCOUNT';
  execute procedure TAR_SAVE_BO_DISC(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'DISCOUNT_PERIOD';
  execute procedure TAR_SAVE_BO_DISC_PERIOD(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end

  select f_character(29) || T.TARIFA_NAME, T.id_hotel
  from   TARIFA T
  where  T.ID_TARIFA = :ID_TAR_HEAD
  into   :action_text, :id_hotel;

  execute procedure EXPORT_LOG_INSERT$EXC ('RATE_BASE', :id_tar_head, :id_hotel, 0);

  execute procedure SYSTEM_LOG_ADD ('RATE', :ID_TAR_HEAD, 'RATE_CHANGED', :action_text);

  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||'NONE'||', '||:err_text;
--    suspend;
    exception;
  end
end
^

/* Alter (TAR_SAVE_BO_BOARD) */
ALTER PROCEDURE TAR_SAVE_BO_BOARD(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable id_tar_season integer;
  declare variable iteration varchar(20);
/*****************************************************/
  declare variable id_tar_board integer;
  declare variable id_board integer;
  declare variable id_service integer;
  declare variable pos_numbers varchar(2000);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable separate_board integer;
  declare variable id_bo_price integer;
  declare variable price_type varchar(20);
  declare variable price_type_equal_exists integer;
  declare variable is_board integer;
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  err_text = '';
  iteration = 'FIRST';
  price_type_equal_exists = 0;

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :id_tar_season, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_board, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
      if (:price_type_equal_exists = 1) then begin
        if (exists(
          select *
          from   TAR_BO_RELATION TBR
                 join TAR_BO_BASE_POSITION TBB on TBR.ID_TAR_BP = TBB.ID_TAR_BP
          where  TBR.ID_BO = :id_tar_board
                 and TBR.BO_TYPE = 'BOARD'
                 and TBB.ID_BOARD_INCLUDE is not distinct from :id_board
        )) then begin
          err_code = -237;
          exit;
        end
      end
      price_type_equal_exists = 0;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_board = gen_id(GEN_TAR_BO_BOARD_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers = '';
      id_board = null;
      separate_board = 0;
      ptext = '';
      disc_tag = 'F';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      packet_item = null;
    end
    if (:iteration = 'MIDDLE') then begin
      if (:param_name = 'PTEXT') then ptext = :data;
      else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
      else if (:param_name = 'SET_VAR')       then set_var = :data;
      else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
      else if (:param_name = 'LIST_BASE_POS') then pos_numbers = :data;
      else if (:param_name = 'SEPARATE_BOARD') then begin
        separate_board = :data;
        if ((:separate_board = 0) and (:board_type = 'HRANI')) then err_code = -226;
      end else if (:param_name = 'CHECKIN_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'NIGHT_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'PACKET_ITEM') then begin
        packet_item = :data;
      end else if (:param_name = 'HRANI') then begin
        if (:data = -1) then err_code = -210;
        else begin
          id_service = :data;
          select m.IS_BOARD
          from   MEALS M
          where  M.ID_SERVICE = :id_service
          into   :is_board;
          id_board = :id_service;

          if ((:is_board = 1) and (:board_type = 'HRANI')) then err_code = -228;
          else if ((:is_board = 0) and (:board_type = 'BOARD')) then err_code = -229;
        end
      end
      if (:err_code < 0) then exit;
      if ((:id_tar_season <> -1) and (:iteration = 'MIDDLE')) then begin
        /* WE ARE STARTING THE SEASON PRICES SO: */
        if ((:id_board is null) or (:id_board = -1)) then err_code = -210;
        else if ((:separate_board = 0) and (:board_type = 'HRANI')) then err_code = -226;
        if (:err_code < 0) then exit;
        if ((:separate_board = 1) and (:board_type = 'HRANI')) then separate_board = 2;
        insert into TAR_BO_BOARD(ID_TAR_BOARD, ID_TAR_HEAD, ID_SERVICE, ID_BOARD, PTEXT, SEPARATE_BOARD,
                    PACKET_ITEM, DISC_TAG, SET_VAR, RND_METHOD)
        values (:id_tar_board, :id_tar_head, :id_service, :id_board, :ptext, :separate_board,
               :packet_item, :disc_tag, :set_var, :rnd_method);
        iteration = 'SEASON_PRICES';
      end
    end
    if (:iteration = 'SEASON_PRICES') then begin
      execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_board, :bo_type, :id_tar_season)
      returning_values  :err_code, :id_bo_price, :price_type;
      if (:price_type = 'EQUAL') then begin
        if (:board_type = 'HRANI') then err_code = -225;
        price_type_equal_exists = 1;
      end
      if (:err_code < 0) then exit;
    end
  end
  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:BO_TYPE||', '||:err_text;
  end
end
^

/* Alter (TAR_SAVE_BO_BP) */
ALTER PROCEDURE TAR_SAVE_BO_BP(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable no_use integer;
  declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable id_tar_season integer;
  declare variable iteration varchar(20);
/*****************************************************/
  declare variable id_tar_bp integer;
  declare variable position_number varchar(20);
  declare variable id_room_type integer;
  declare variable max_persons integer;
  declare variable id_board_include integer;
  declare variable is_price_for_room integer;
  declare variable ptext varchar(20);
  declare variable price_type varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable board_weight integer;
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :id_tar_season, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      param_filter = :data||season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      insert into TAR_BO_RELATION(ID_TAR_BP, BO_TYPE, ID_BO, PARAM_FILTER)
      values (:id_tar_bp, :bo_type, :id_tar_bp, :param_filter);
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_bp = gen_id(GEN_TAR_BO_BP_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      position_number = null;
      id_room_type = null;
      max_persons = null;
      id_board_include = -1;
      is_price_for_room = 0;
      ptext = '';
      disc_tag = 'B';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      packet_item = null;
    end
    if (:iteration = 'MIDDLE') then begin
      if (:param_name = 'BASE_POS')            then begin
        if (:data = '') then err_code = -203;
        else position_number = :data;
      end else if (:param_name = 'ROOM_TYPE')  then begin
        if (:data = '') then err_code = -204;
        else id_room_type = :data;
      end else if (:param_name = 'MAX_PERSONS')then begin
        if (:data = '') then err_code = -205;
        else max_persons = :data;
      end else if (:param_name = 'CHECKIN_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'NIGHT_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'BOARD')      then id_board_include = :data;
      else if (:param_name = 'BPRICE_ROOM')    then is_price_for_room = :data;
      else if (:param_name = 'PACKET_ITEM')    then packet_item = :data;
      else if (:param_name = 'PTEXT')          then ptext = :data;
      else if (:param_name = 'DISC_TAG')       then disc_tag = :data;
      else if (:param_name = 'SET_VAR')        then set_var = :data;
      else if (:param_name = 'ROUND_TYPE')     then rnd_method = :data;
      if (:err_code < 0) then exit;
      if ((:id_tar_season <> -1) and (:iteration = 'MIDDLE')) then begin
        /* WE ARE STARTING THE SEASON PRICES SO: */
        board_weight = null;
        select m.WEIGHT_TAG
        from   MEALS M
        where  m.ID_BOARD = :id_board_include
        into   :board_weight;
        board_weight = coalesce(:board_weight, 0);

        insert into TAR_BO_BASE_POSITION(
          ID_TAR_BP, ID_TAR_HEAD, POSITION_NUMBER, ID_ROOM_TYPE, MAX_PERSONS, SET_VAR, RND_METHOD,
          ID_BOARD_INCLUDE, BOARD_WEIGHT, IS_PRICE_FOR_ROOM, PTEXT, PACKET_ITEM, DISC_TAG)
        values (
          :id_tar_bp, :id_tar_head, :position_number, :id_room_type, :max_persons, :set_var, :rnd_method,
          :id_board_include, :board_weight, :is_price_for_room, :ptext, :packet_item, :disc_tag);
       iteration = 'SEASON_PRICES';
      end
    end
    if (:iteration = 'SEASON_PRICES') then begin
      execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_bp, :bo_type, :id_tar_season)
      returning_values  :err_code, :no_use, :price_type;
      if (:err_code < 0) then exit;
    end
  end
  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:BO_TYPE||', '||:err_text;
  end
end
^

/* Alter (TAR_SAVE_BO_DISC) */
ALTER PROCEDURE TAR_SAVE_BO_DISC(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_disc integer;
  declare variable pos_numbers varchar(2000);
  declare variable id_service integer;
  declare variable prioritet integer;
  declare variable day_scheme varchar(20);
  declare variable day_scheme_num integer;
  declare variable price_type varchar(20);
  declare variable price varchar(2000);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable calc_type varchar(20);
  declare variable calc_list varchar(2000);
  declare variable in_base_price integer;
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  err_text = '';
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      if (:price = '') then err_code = -219;
      if (:err_code < 0) then exit;
      rnd_method = iif(coalesce(:rnd_method, '') = '', 'NONE', :rnd_method);
      insert into TAR_BO_DISCOUNT (
        ID_TAR_DISCOUNT, ID_TAR_HEAD, PRIORITET, DAY_SCHEME, DAY_SCHEME_NUM, DISC_TAG, SET_VAR, RND_METHOD,
        IS_IN_BASE_PRICE,  CALC_LIST, ID_SERVICE, PTEXT, PACKET_ITEM)
      values (
        :id_tar_disc, :id_tar_head, :prioritet, :day_scheme, :day_scheme_num, :disc_tag, :set_var, :rnd_method,
        :in_base_price, :calc_list, :id_service, :ptext, :packet_item);
      param_filter = :data||:season_filter;
      execute procedure tar_save_parse_param(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure tar_save_parse_pnum(:id_tar_head, :id_tar_disc, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_disc = gen_id(GEN_TAR_BO_DISCOUNT_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers   = '';
      id_service    = -1;
      day_scheme     = 'EVERY';
      day_scheme_num = 1;
      calc_type     = 'NONE';
      calc_list     = '';
      price         = '';
      prioritet     = 1;
      ptext         = '';
      disc_tag      = '';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      in_base_price = 0;
      packet_item   = null;
    end
    if (:param_name = 'SERVICE')            then begin
      if (:data = '') then id_service = -1;
      else id_service = :data;
    end else if (:param_name = 'PTEXT')     then ptext = :data;
    else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
    else if (:param_name = 'SET_VAR')       then set_var = :data;
    else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
    else if (:param_name = 'PRIORITET')     then prioritet     = :data;
    else if (:param_name = 'IN_BASE_PRICE') then in_base_price = :data;
    else if (:param_name = 'PACKET_ITEM')   then packet_item   = :data;
--    else if (:param_name = 'PRICE_NOTEQUAL') then begin
    else if (:param_name = 'PRICE_FORMULA') then begin
      price = trim(:data);
      if ((:id_service > 0) and (:in_base_price = 1) and (substring(:price from 1 for 1) = '-')) then err_code = -240;
      else if (:price = '') then err_code = -219;
      else
        execute procedure tar_save_parse_price(:price, :id_tar_disc, :bo_type, -1)
        returning_values  :err_code, :no_use, :price_type;
    end else if (:param_name = 'LIST_BASE_POS') then pos_numbers   = :data;
    else if (:param_name = 'DAY_SCHEME') then begin
      execute procedure tar_save_parse_dayschm(:data)
      returning_values  :err_code, :day_scheme, :day_scheme_num;
    end else if (:param_name = 'CALC_TYPE') then begin
      calc_list = :data;
--      execute procedure tar_save_parse_calctype(:data)
--      returning_values  :err_code, :calc_type, :calc_list;
    end else if (:param_name = 'CHECKIN_SEASON') then begin
      execute procedure tar_save_parse_season(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end else if (:param_name = 'NIGHT_SEASON') then begin
      execute procedure tar_save_parse_season(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end
    if (:err_code < 0) then exit;
  end
/*  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
  end*/
end
^

/* Alter (TAR_SAVE_BO_DISC_PERIOD) */
ALTER PROCEDURE TAR_SAVE_BO_DISC_PERIOD(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_disc integer;
  declare variable pos_numbers varchar(2000);
  declare variable id_service integer;
  declare variable prioritet integer;
  declare variable calc_position varchar(20);
  declare variable price_type varchar(20);
  declare variable price varchar(2000);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable calc_list varchar(2000);
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  err_text = 'OBJECT='||:bo_type;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      if (:price = '') then err_code = -219;
      if (:calc_position = '') then err_code = -244;
      if (:err_code < 0) then exit;
      insert into TAR_BO_DISCOUNT_STAY (ID_TAR_DISCOUNT_STAY, ID_TAR_HEAD, PRIORITET, CALC_POSITION,
             CALC_LIST, ID_SERVICE, PTEXT, DISC_TAG, SET_VAR, RND_METHOD)
      values (:id_tar_disc, :id_tar_head, :prioritet, :calc_position,
             :calc_list, :id_service, :ptext, :disc_tag, :set_var, :rnd_method);

      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_disc, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration = 'MIDDLE';
      id_tar_disc = gen_id(GEN_TAR_BO_DISCOUNT_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers   = '';
      id_service    = -1;
      calc_list     = '';
      price         = '';
      prioritet     = 1;
      calc_position = 'GUEST_PERIOD';
      ptext         = '';
      disc_tag      = '';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
    end
    if (:param_name = 'SERVICE')            then begin
      if (:data = '') then id_service = -1;
      else id_service = :data;
    end else if (:param_name = 'PTEXT')     then ptext = :data;
    else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
    else if (:param_name = 'SET_VAR')       then set_var = :data;
    else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
    else if (:param_name = 'PRIORITET')     then prioritet     = :data;
    else if (:param_name = 'PERIOD_BASE_TYPE')    then calc_position = :data;
    else if (:param_name = 'PRICE_FORMULA') then begin
      price = trim(:data);
      if (:price = '') then err_code = -219;
      else begin
        execute procedure TAR_SAVE_PARSE_PRICE(:price, :id_tar_disc, :bo_type, -1)
        returning_values  :err_code, :no_use, :price_type;
        if (:err_code < 0) then exit;
      end
    end else if (:param_name = 'LIST_BASE_POS') then pos_numbers   = :data;
    else if (:param_name = 'CALC_TYPE') then begin
      calc_list = :data;
--      execute procedure tar_save_parse_calctype(:data)
--      returning_values  :err_code, :calc_type, :calc_list;
    end else if (:param_name = 'CHECKIN_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end else if (:param_name = 'NIGHT_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end
    if (:err_code < 0) then exit;
  end
  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
--    exception;
  end
end
^

/* Alter (TAR_SAVE_BO_EG) */
ALTER PROCEDURE TAR_SAVE_BO_EG(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable id_tar_season integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_eg integer;
  declare variable pos_numbers varchar(2000);
  declare variable min_payors integer;
  declare variable max_extra_guests integer;
  declare variable order_num integer; /* !!!! */
  declare variable id_price_bb integer;
  declare variable id_price_eb integer;
  declare variable price_type varchar(20);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable is_packet_reduction integer;
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :id_tar_season, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_eg, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_eg = gen_id(GEN_TAR_BO_EG_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers = '';
      min_payors  = null;
      id_price_eb = -1;
      id_price_bb = -1;
      order_num   = 99;
      ptext       = '';
      disc_tag    = '';
      set_var = '';
      is_packet_reduction = 0;
      rnd_method = 'MATH';
      season_filter = '';
      max_extra_guests = null;
      packet_item = null;
    end
    if (:iteration = 'MIDDLE') then begin
      if (:param_name = 'LIST_BASE_POS')   then pos_numbers = :data;
      else if (:param_name = 'SET_VAR')    then set_var = :data;
      else if (:param_name = 'ROUND_TYPE') then rnd_method = :data;
      else if (:param_name = 'MIN_PAYORS') then begin
        if (:data = '') then err_code = -213;
        else min_payors = :data;
      end else if (:param_name = 'MAX_EG') then begin
        if (:data = '') then err_code = -214;
        else max_extra_guests = :data;
      end else if (:param_name = 'EG_ORDER')   then begin
        if (:data = '') then order_num = 99;
        else order_num = :data;
        if (:order_num < 1) then err_code = -215;
      end else if (:param_name = 'CHECKIN_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'NIGHT_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'PTEXT')     then ptext = :data;
      else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
      else if (:param_name = 'EG_POST_TYPE')  then is_packet_reduction = :data;
      else if (:param_name = 'PACKET_ITEM')   then packet_item = :data;
      else if (:param_name = 'BB_PRICE')   then begin
        if (:data <> '') then begin
          execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_eg, :bo_type, -1)
          returning_values  :err_code, :id_price_bb, :price_type;
          if ((:board_type = 'HRANI') and (:price_type <> 'PERCENT')) then begin
            err_code = -227;
            exit;
          end
        end
      end else if (:param_name = 'EB_PRICE') then begin
        if (:data <> '') then begin
          execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_eg, :bo_type, -1)
          returning_values  :err_code, :id_price_eb, :price_type;
          if ((:board_type = 'HRANI') and (:price_type <> 'PERCENT')) then begin
            err_code = -227;
            exit;
          end
        end
      end
      if (:err_code < 0) then exit;
      if ((:id_tar_season <> -1) and (:iteration = 'MIDDLE')) then begin
        if (:min_payors is null) then err_code = -213;
        if (:max_extra_guests is null) then err_code = -214;
        if (:err_code < 0) then exit;
        /* WE ARE STARTING THE SEASON PRICES SO: */
        insert into TAR_BO_EXTRA_GUEST(
          ID_TAR_EG, ID_TAR_HEAD, MIN_PAYORS, MAX_EXTRA_GUESTS, EG_ORDER, IS_PACKET_REDUCTION,
          ID_PRICE_BB, ID_PRICE_EB, PTEXT, PACKET_ITEM, DISC_TAG, SET_VAR, RND_METHOD)
        values (
          :id_tar_eg, :id_tar_head, :min_payors, :max_extra_guests, :order_num, :is_packet_reduction,
          :id_price_bb, :id_price_eb, :ptext, :packet_item, :disc_tag, :set_var, :rnd_method);
        iteration = 'SEASON_PRICES';
      end
    end
    if (:iteration = 'SEASON_PRICES') then begin
      execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_eg, :bo_type, :id_tar_season)
      returning_values  :err_code, :no_use, :price_type;
      if (:err_code < 0) then exit;
    end
  end
  when any do begin
    err_code = -200;
    err_text = ''||:iteration||' '||:id_price_bb||' '||:id_price_eb;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
/*    err_text = ' '||:min_payors||' '||:max_extra_guests||' '||:order_num;*/
  end
end
^

/* Alter (TAR_SAVE_BO_PACK) */
ALTER PROCEDURE TAR_SAVE_BO_PACK(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_pack integer;
  declare variable pos_numbers varchar(2000);
  declare variable id_service integer;
  declare variable day_scheme varchar(20);
  declare variable day_scheme_num integer;
  declare variable cnt_post integer;
  declare variable pack_currency char(3);
  declare variable in_base_price integer;
  declare variable grp_rpt varchar(20);
  declare variable grp_docs varchar(20);
  declare variable price_type varchar(20);
  declare variable price_pack varchar(20);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      if (:price_pack = '') then err_code = -216;
      if (:id_service is null) then err_code = -217;
      if (:err_code < 0) then exit;
      insert into TAR_BO_PACK(
        ID_TAR_PACK, ID_TAR_HEAD, ID_SERVICE, PRICE_CURRENCY, IS_IN_BASE_PRICE,
        CNT_POST,  DAY_SCHEME, DAY_SCHEME_NUM, GRP_IN_REPORTS,
        GRP_IN_DOCUMENTS, PTEXT, PACKET_ITEM, DISC_TAG, SET_VAR, RND_METHOD)
      values (
        :id_tar_pack, :id_tar_head, :id_service, :pack_currency, :in_base_price,
        :cnt_post, :day_scheme, :day_scheme_num, :grp_rpt,
        :grp_docs, :ptext, :packet_item, :disc_tag, :set_var, :rnd_method);
      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_pack, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_pack = gen_id(GEN_TAR_BO_PACK_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers   = '';
      id_service    = null;
      day_scheme     = 'EVERY';
      day_scheme_num = 1;
      cnt_post      = 0;
/*
        select TH.TARIFA_CURR
        from   TAR_HEAD TH
        where  TH.ID_TAR_HEAD = :id_tar_head
        into   :pack_currency;
*/    pack_currency = '';
      in_base_price = 0;
      grp_rpt       = '';
      grp_docs      = '';
      price_pack    = '';
      ptext         = '';
      disc_tag      = '';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      packet_item   = null;
    end
    if (:param_name = 'SERVICE') then begin
      if ((:data = '') or (:data = '-1')) then err_code = -217;
      else if (:data = '0') then err_code = -222;
      else id_service = :data;
    end else if (:param_name = 'CNT_POST')  then cnt_post      = :data;
    else if (:param_name = 'IN_BASE_PRICE') then in_base_price = :data;
    else if (:param_name = 'GRP_RPT')       then grp_rpt       = :data;
    else if (:param_name = 'GRP_DOCS')      then grp_docs      = :data;
    else if (:param_name = 'PTEXT')         then ptext         = :data;
    else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
    else if (:param_name = 'SET_VAR')        then set_var = :data;
    else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
    else if (:param_name = 'PACKET_ITEM')   then packet_item   = :data;
    else if (:param_name = 'PRICE')         then begin
      price_pack    = :data;
      if (:price_pack = '') then err_code = -216;
      else
        execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_pack, :bo_type, -1)
        returning_values  :err_code, :no_use, :price_type;
    end else if (:param_name = 'LIST_BASE_POS') then pos_numbers   = :data;
    else if (:param_name = 'CURRENCY') then begin
      if ((:data <> upper(:data)) or (char_length(:data) <> 3)) then err_code = -218;
      else pack_currency = :data;
    end else if (:param_name = 'DAY_SCHEME') then begin
      execute procedure TAR_SAVE_PARSE_DAYSCHM(:data)
      returning_values  :err_code, :day_scheme, :day_scheme_num;
    end else if (:param_name = 'CHECKIN_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end else if (:param_name = 'NIGHT_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end
    if (:err_code < 0) then exit;
  end
  when any do begin
    err_code = -200;
/*    err_text = ' '||:id_service||' '||:pack_currency||' '||:in_base_price;*/
/*    err_text = ' '||:day_scheme||' '||:day_scheme_num;*/
    err_text = ' '||:cnt_post||' '||:grp_rpt||' '||:grp_docs||' '||:ptext;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
  end
end
^

/* Alter (TAR_SAVE_BO_SEASON) */
ALTER PROCEDURE TAR_SAVE_BO_SEASON(ID_TAR_HEAD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable delim integer;
  declare variable id_dim2 integer;
  declare variable id_season integer;
  declare variable from_date date;
  declare variable to_date date;
  declare variable idate date;
begin
  err_code = 0;
  execute procedure SETTING_GET_VALUE('RANGE_DATA_DELIMETER', null)
  returning_values  :delim;
  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, 'SEASON') TSP
    into    :param_name, :row_id, :id_dim2, :data, :col_id
  do begin
    if (:param_name = 'NAME') then begin
      id_season = gen_id(GEN_TAR_BO_SEASON_ID, 1);
      insert into TAR_BO_SEASON(ID_TAR_SEASON, ID_TAR_HEAD, SEASON_NAME, ID_DIM2)
      values (:id_season, :id_tar_head, :data, :id_dim2);
    end else if ((:param_name = 'PERIOD') and (:data <> '')) then begin
      from_date = null; to_date =null;
      for
        select SPD.ITEM
        from   SYSTEM_STRING_PARSER(:data, f_character(:delim)) SPD
        into   :idate
      do begin
        if (:from_date is null) then from_date = :idate;
        else to_date = :idate;
      end
      /* CHECK VALIDITY */
      if (exists(
        select *
        from   TAR_BO_SEASON TBS
               join TAR_BO_SEASON_PERIOD TSP
                 on TSP.ID_TAR_SEASON = TBS.ID_TAR_SEASON
        where  TBS.ID_TAR_HEAD = :id_tar_head
               and TSP.FROM_DATE <= :to_date
               and TSP.TO_DATE >= :from_date
      )) then begin
        err_code = -201;
        exit;
      end
      insert into TAR_BO_SEASON_PERIOD (ID_TAR_SEASON, FROM_DATE, TO_DATE)
      values (:id_season, :from_date, :to_date);
    end
  end
  when any do begin
    err_code = -200;
    err_text = :data;
    err_text = 'OBJECT='||'SEASONS'||', '||:err_text;
  end
end
^

/* Alter (TEST_AVAILABILITY) */
ALTER PROCEDURE TEST_AVAILABILITY RETURNS(FOR_DATE DATE,
MINUS_ROOM_TYE INTEGER,
ID_AGENT INTEGER,
AGENT_NAME VARCHAR(100),
SOLD INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
CONT_BP_REMAIN INTEGER,
RES_WAITING INTEGER,
CONT_PLAIN INTEGER,
CONT_BP INTEGER,
CONT_BP_PLAIN INTEGER,
CONT_PLAIN_REMAIN INTEGER,
RES_TOTAL INTEGER,
ROOM_TYPE_NAME VARCHAR(20))
 AS
declare variable FROM_DATE date;
  declare variable TO_DATE date;
  declare variable HOTELS varchar(255);
  declare variable ID_OCCUPANCY_SESSION integer;
begin
  from_date = '01.06.2009';
  to_date = '30.06.2009';
  hotels = '4';
  execute procedure AVAILABILITY_OCCUPANCY$AVL (:from_date, :to_date,  0, :hotels)
  returning_values (:id_occupancy_session);

  execute procedure AVAILABILITY_OCCUPANCY_OPT$AVL (:id_occupancy_session, 0, 0, 1, 1, 0, 0, 0);

  for
    SELECT
        SOT.FOR_DATE,
        -SOT.ID_ROOM_TYPE as MINUS_ROOM_TYE,
        SOT.ID_AGENT,
        RT.TYPE_ROOM as ROOM_TYPE_NAME,
        P.PROFILE_NAME as AGENT_NAME,
        sum(SOT.SOLD) as SOLD,
        sum(SOT.RES_CONFIRMED) as RES_CONFIRMED,
        sum(SOT.RES_NOTCONFIRMED) as RES_NOTCONFIRMED,
        sum(SOT.RES_WAITING) as RES_WAITING,
        sum(SOT.CONT_PLAIN  ) as CONT_PLAIN,
        sum(SOT.CONT_BP) as CONT_BP,
        sum(SOT.CONT_BP_REMAIN) as CONT_BP_REMAIN,
        sum(SOT.CONT_PLAIN_REMAIN  ) as CONT_PLAIN_REMAIN,
        sum(0 + (SOT.RES_CONFIRMED+SOT.RES_NOTCONFIRMED) ) as RES_TOTAL
    from SMART_OCCUP$TMP SOT
         left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = SOT.ID_ROOM_TYPE
         left outer join PROFILE_AGENT PA on SOT.ID_AGENT = PA.ID_AGENT
         left outer join PROFILE P on PA.ID_PROFILE = P.ID_PROFILE
    where  SOT.ID_SESSION = :id_occupancy_session
      and RT.ID_HOTEL = 4
      and  1=0
      
      
      and SOT.ID_AGENT > -100
    group by SOT.ID_AGENT,
             SOT.FOR_DATE,
             SOT.ID_ROOM_TYPE,
             RT.TYPE_ROOM,
             P.PROFILE_NAME
    union
    SELECT
        FOR_DATE,
        1,
        SOT.ID_AGENT,
        cast('' as varchar(20)),
        P.PROFILE_NAME as AGENT_NAME,
        sum(SOT.SOLD) as SOLD,
        sum(SOT.RES_CONFIRMED) as RES_CONFIRMED,
        sum(SOT.RES_NOTCONFIRMED) as RES_NOTCONFIRMED,
        sum(SOT.RES_WAITING) as RES_WAITING,
        sum(SOT.CONT_PLAIN  ) as CONT_PLAIN,
        sum(SOT.CONT_BP) as CONT_BP,
        sum(SOT.CONT_BP_REMAIN) as CONT_BP_REMAIN,
        sum(SOT.CONT_PLAIN_REMAIN  ) as CONT_PLAIN_REMAIN,
        sum(0 + (SOT.RES_CONFIRMED+SOT.RES_NOTCONFIRMED) ) as RES_TOTAL
    from SMART_OCCUP$TMP SOT
         left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = SOT.ID_ROOM_TYPE
         left outer join PROFILE_AGENT PA on SOT.ID_AGENT = PA.ID_AGENT
         left outer join PROFILE P on PA.ID_PROFILE = P.ID_PROFILE
    where  SOT.ID_SESSION = :id_occupancy_session
      and RT.ID_HOTEL = 4
      and  1=1
      
      and SOT.ID_AGENT > -100
    group by SOT.ID_AGENT,
             SOT.FOR_DATE,
             P.PROFILE_NAME
    order by 5,3,1,2
    into  :for_date, :MINUS_ROOM_TYE, :id_agent, :room_type_name, :agent_name, :sold,
          :res_confirmed, :res_notconfirmed, :res_waiting, :cont_plain, :cont_bp,
          :cont_bp_remain, :cont_plain_remain, :res_total
  do suspend;

end
^

/* empty dependent procedure body */
/* Clear: IMPORT_BOOKING$EXC for: UPDATE_BOOKING$EXC */
ALTER PROCEDURE IMPORT_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(250),
MAINTANCE_SHEMA VARCHAR(30),
POSTING_ROUTING VARCHAR(20),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
COMPLIMENTARY_ACCOUNT VARCHAR(50),
EATING_OBJECT VARCHAR(50),
CREATE_DATETIME TIMESTAMP)
 RETURNS(HOTEL_ID INTEGER,
BOOKING_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (UPDATE_BOOKING$EXC) */
ALTER PROCEDURE UPDATE_BOOKING$EXC(BOOKING_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE INTEGER,
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA_ID INTEGER,
POSTING_ROUTING VARCHAR(20),
ID_AGENT_ACCOUNT INTEGER,
RATE_ID INTEGER,
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD_CODE TFOOD_CODE,
ARRANGER_PROFILE_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable hotel_id integer;
  declare variable warn_code integer;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable rd_dbkey char(8);
  declare variable current_status_code smallint;
BEGIN
  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => START(' || :booking_id || ')');

  select RD.RDB$DB_KEY, RD.ID_HOTEL, RD.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :booking_id
  into  :rd_dbkey, :hotel_id, :current_status_code;

  execute procedure update_posting_transaction$exc(:rd_dbkey, :posting_transaction_uuid, 0);

  /* lock all guests */
  update guest set ORPHANED_IMPORT$EXC=1 where id_reserv_detail=:booking_id;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_GUARANTEE$RSV');
  execute procedure RES_SAVE_GUARANTEE$RSV(
    :booking_id, :is_vip, :current_status_code, :id_guarantee_policy,
    :deposit_required, :deposit_required_currency, :block_cc,
    :guarantee_deposit_percent, :guarantee_deposit_nights, :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_STAY$RSV');
  execute procedure RES_SAVE_STAY$RSV(
    :booking_id, :arrival, :departure, :is_late_departure,
    :arrival_type, 0
  ) returning_values :share_err_code, :err_text, :share_transaction_id, :warn_code;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_BOARD$INT');
  execute procedure RES_SAVE_BOARD$INT(
    :rd_dbkey, :board_id
  ) ;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_OTHER$RSV');
  execute procedure RES_SAVE_OTHER$RSV(
    :booking_id, :transfer_in_time, :transfer_in_note,
    :transfer_out_time, transfer_out_note, :first_food_code
  ) ;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_ROOM$EXC(room_type_id=>' || coalesce(:room_type_id, '<null>') || ')');
  execute procedure RES_SAVE_ROOM$EXC(
    :rd_dbkey, :room_type_id, :maintance_shema_id, :room_preferences, :special_treatment, :split_on_checkin
  ) returning_values :err_text, :warn_code, :share_transaction_id, :share_err_code;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_MARKETING$RSV');
  execute procedure RES_SAVE_MARKETING$RSV(
    :booking_id, :marketing1_id, :marketing2_id, :marketing3_id, :marketing4_id, :marketing5_id
  ) returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_RATE$RSV(:rate_id=>'
  || coalesce(:rate_id, '<null>')
  || ', :booking_id=>' || coalesce(:booking_id, '<null>')
  || ', :manual_price=>' || coalesce(:manual_price, '<null>')
  || ', :manual_price_currency=>' || coalesce(:manual_price_currency, '<null>')
  || ', :is_different_rate=>' || coalesce(:is_different_rate, '<null>')
  || ')');
  execute procedure RES_SAVE_RATE$RSV(
    :booking_id, :rate_id, :manual_price, :manual_price_currency,
    :is_different_rate, :is_different_price, 0
  );

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_VOUCHER$RSV');
  execute procedure RES_SAVE_VOUCHER$RSV(
    :booking_id, :voucher, :voucher_date, :voucher_text, null,  null
  );

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_NOTE$RSV');
  execute procedure RES_SAVE_NOTE$RSV(
    :booking_id, :note, :note_reminders);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_ACCOUNTING$RSV(arranger_profile_id=>'
    || coalesce(:arranger_profile_id, '<null>')
    || ', posting_routing=>' || coalesce(:posting_routing, '<null>')
    || ', id_agent_account=>' || coalesce(:id_agent_account, '<null>')
    || ')');
  execute procedure RES_SAVE_ACCOUNTING$INT(
    :rd_dbkey, :arranger_profile_id,
    :id_agent_account,
    :posting_routing,
    :guest_payment_type_id,
    :arranger_payment_type_id,
    :reserv_group_id
  ) ;

  /*execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_PACKET$RSV');
  execute procedure RES_SAVE_PACKET$RSV(
    :booking_id, :packet_id, 0
  );
  */
  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_EATING_OBJECT$RSV');
  execute procedure RES_SAVE_EATING_OBJECT$RSV(:booking_id, :id_eating_object);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => END(' || :booking_id || ')');
END
^

/* Restore proc. body: ACCOUNT_POST_MODIFY$PMS */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
declare variable id_account integer;
  declare variable id_service integer;
  declare variable date_post date;
  declare variable is_owner_income smallint;
  declare variable is_account_post_item smallint;
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable no_use_id_acc_post integer;
  declare variable ap_dbkey char(8);
begin
  -- da se wika samo ot GUI
  if ( (:ID_ACCOUNT_POST is null) and (:ID_ACCOUNT_POST_PMS is null) ) then begin
    exception WRONG_PARAM_VALUE;
    exit;
  end

  is_account_post_item = iif(:id_account_post is not null, 1, 0);

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'mod, anul');

  if (:operation in ('mod', 'anul')) then begin
    -- prowerka: ot GUI-to mogat da se anulirat samo nedokumentirani i neanulirani nachisleniq
    if (:is_account_post_item = 1) then begin
      if ( (:ID_PMS_EVENT > 0) and
           not exists ( select *
                        from   PMS_EVENT_POST PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      select ap.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  ap.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
      into   :ap_dbkey;

      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_dbkey, 'PMS GUI VOID');

      update PMS_EVENT_POST PP
      set    PP.LINE_STATUS = 22
      where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST;

    end else if (:ID_ACCOUNT_POST_PMS is not null) then begin
      if ( not exists ( select *
                        from   ACCOUNT_POST$PMS PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      execute procedure ACCOUNT_POST_PMS_ANUL$INT(:ID_PMS_EVENT, :ID_ACCOUNT_POST_PMS);
    end

    if (:operation = 'mod') then begin
      id_account = null;
      if (:is_account_post_item = 1) then begin
        select AP.ID_ACCOUNT, AP.ID_SERVICE, AP.DATE_POST, PP.ID_OWNER, 0, ap.id_room
        from   ACCOUNT_POST AP
               join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and PP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :id_owner, :is_owner_income, :id_room;
      end else begin
        select AP.ID_ACCOUNT_PMS, AP.ID_SERVICE, AP.DATE_POST, AP.IS_OWNER_INCOME, AP.ID_OWNER
        from   ACCOUNT_POST$PMS AP
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
               and AP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :is_owner_income, :id_owner;
      end
      if (:id_account is null) then exit;

      execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_account, :id_service, :id_owner, :date_post,
              :in_curr_orig, :in_value_orig, 1 - :is_account_post_item, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* Restore proc. body: CONTRACT_EXPENSE_POST$INT */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT TYPE OF ID,
ID_HOTEL INTEGER,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
ID_OWNER TYPE OF ID,
OWNERSHIP_PERCENT TYPE OF TPERCENT,
ID_RENTAL_POOL TYPE OF ID_REF,
VALUE_ORIG TYPE OF TPRICE,
CURR_ORIG TYPE OF TCURRENCY,
POST_DATE TYPE OF TDATE,
STAY TYPE OF TCOUNT,
MAX_GUEST_CNT TYPE OF TCOUNT,
BED_NIGHT_CNT TYPE OF TCOUNT,
RESERVS TYPE OF TCOUNT)
 AS
declare variable service_price numeric(15,4);
  declare variable id_currency varchar(3);
  declare variable contract_expense_type varchar(50);
  declare variable id_account integer;
  declare variable post_value numeric(15,4);
  declare variable post_currency varchar(3);
  declare variable id_service integer;
  declare variable is_owner_income smallint;
  declare variable is_client_acc_post smallint;
  declare variable multiplier_type varchar(50);
  declare variable multiplier integer;
  declare variable id_room integer;
  declare variable use_shadow_account integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
begin
  is_owner_income = 0;
  use_shadow_account = iif(:SUB_CONTRACT = 'SHADOW_ACC', 1, 0);

  select r.ID_HOTEL
  from   PMS_EVENT$PMS p
         join ROOMS R on r.ID_ROOM = p.ID_ROOM
  where  p.ID_PMS_EVENT = :ID_PMS_EVENT
  into   :id_hotel;
-- CONTRACT_EXPENSE_TYPE in ( 'PERCENT', 'RUNNING_TOTAL_PERCENT', 'CURR_VALUE' )
-- MULTIPLIER_TYPE in ('RESERVATION', 'STAY', 'GUESTS', 'BED_NIGHTS')
  for
    select C.SERVICE_PRICE, C.ID_CURRENCY, C.CONTRACT_EXPENSE_TYPE, C.IS_ACC_POST_ITEM,
           C.ID_SERVICE, C.MULTIPLIER_TYPE
    from   CONTRACT_EXPENSE$PMS C
    where  C.ID_CONTRACT = :id_contract
           and c.SUB_CONTRACT = :SUB_CONTRACT
    order by C.ORDER_TAG asc
    into   :service_price, :id_currency, :contract_expense_type, :is_client_acc_post,
           :ID_SERVICE, :multiplier_type
  do begin

    execute procedure OWNER_ACCOUNT_GET$INT (coalesce(:ID_RENTAL_POOL,:ID_OWNER),
            :id_hotel, :use_shadow_account, :is_client_acc_post)
    returning_values (:id_account, :is_account$pms);

    multiplier = case
                   when :multiplier_type = 'RESERVATION' then iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'STAY' then :STAY
                   when :multiplier_type = 'GUESTS' then :MAX_GUEST_CNT * iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'BED_NIGHTS' then :BED_NIGHT_CNT
                   else null
                 end;

    if (:multiplier is not null) then begin
      if (:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE') then begin
        post_value = cast(:service_price as double precision) * :ownership_percent / 100 * :multiplier;
        post_currency = :id_currency;
      end else if (:CONTRACT_EXPENSE_TYPE = 'PERCENT') then begin
        post_value = :VALUE_ORIG * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end else if (:CONTRACT_EXPENSE_TYPE = 'RUNNING_TOTAL_PERCENT') then begin
        execute procedure PMS_RUNNING_TOTAL_GET(:ID_PMS_EVENT, coalesce(:ID_RENTAL_POOL,:ID_OWNER), :ID_HOTEL, :POST_DATE, :CURR_ORIG)
        returning_values :post_value;
        if (:post_value < 0) then post_value = 0;
    
        post_value = :post_value * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end

      select pe.ID_ROOM
      from   PMS_EVENT$PMS PE
      where  pe.ID_PMS_EVENT = :ID_PMS_EVENT
      into   :id_room;

      select c.ROUND_TO
      from   CURRS C
      where  c.CURR = :post_currency
      into   :round_to;

      execute procedure PMS_POSTING_CREATE$INT(:ID_PMS_EVENT, :id_account, :id_service, :ID_OWNER,
              :POST_DATE, :post_currency, round_f(:post_value, :round_to), :is_account$pms, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* Restore proc. body: CREATE_BOOKING$WBE */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
declare variable RATE varchar(50);
declare variable ROOM_TYPE varchar(20);
declare variable ARRIVAL date;
declare variable DEPARTURE date;
declare variable ADULTS integer;
declare variable CHILDREN integer;
declare variable PROFILE_NAME varchar(100);
declare variable ARANGER_NAME varchar(100);
declare variable GUEST_PROFILE_UUID varchar(40);
declare variable ARANGER_PROFILE_UUID varchar(40);
declare variable HOTEL_NAME varchar(50);
declare variable WBE_SESSION_ID bigint;
declare variable MAIN_GUEST_PROFILE_ID integer;
declare variable BOARD varchar(50);
declare variable HOTEL_ID integer;
declare variable GUARANTEE_POLICY_NAME varchar(50);
declare variable GUARANTEE_DEPOSIT_PERCENT numeric(15,4);
declare variable GUARANTEE_DEPOSIT_NIGHTS integer;
declare variable GUARANTEE_DUE_DAYS_BEF_ARRIVAL integer;
declare variable GUARANTEE_DUE_DAYS_AFTER_CREATE integer;
declare variable ERR_CODE integer;
declare variable ERR_TEXT varchar(255);
declare variable PROFILE_TYPE varchar(20);
declare variable PROFILE_IMPORT_TIME timestamp;
declare variable B_COUNT integer;
declare variable AGE integer;
declare variable IS_CHILD smallint;
declare variable GUEST_ID integer;
declare variable SPECIAL_TREATMENT varchar(250);
declare variable MAINTENANCE varchar(30);
declare variable ROUTING varchar(20);
declare variable ARRANGER_PAYMENY_TYPE varchar(20);
declare variable MARKET_SEGMENT varchar(30);
declare variable MARKET_SOURCE varchar(30);
declare variable MARKET_CHANNEL varchar(30);
declare variable MARKET_HEAR_REASON varchar(30);
declare variable MARKET_COME_REASON varchar(30);
declare variable FIRST_FOOD varchar(30);
declare variable BNOTE varchar(2000);
begin
  -- get wbe product selection
  select  PA.rate_name,PA.room_name, AQ.first_date, AQ.first_date+AQ.day_count,
          PS.adults, PS.children, PS.person_name, H.hotel_name, H.id_hotel,
          WS.id, PA.board_name, GP.name, GP.deposit_totalsum_part, GP.deposit_nights_count, GP.due_days_before_arrival, GP.due_days_after_create,
          PS.bnote
   from   PRODUCT_SELECTION$WBE PS
          join WBE_SESSION$WBE WS on WS.id = PS.wbe_session_id
          join PRODUCT_AVAILABILITY$WBE PA on pa.id = PS.product_availability_id
          join AVAILABILITY_QUERY$WBE AQ on aq.id = WS.product_query_id
          join HOTEL H on H.id_hotel = WS.hotel_id
          join GUARANTEE_POLICY GP on GP.id_guarantee_policy = PS.guarantee_policy_id
   where  PS.id = :product_selection_id
   into   :rate, :room_type, :arrival, :departure,
          :adults,  :children, :profile_name, :hotel_name, :hotel_id,
          :wbe_session_id, :board, :guarantee_policy_name,
          :guarantee_deposit_percent, :guarantee_deposit_nights,
          :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create,
          :bnote;

  select PA.uuid , PA.profile_name, PA.profile_type
  from   profile PA
  where  PA.id_profile = :aranger_profile_id
  into   :aranger_profile_uuid,:aranger_name,  :profile_type;

  if (:aranger_name = :profile_name and :profile_type = 'PERSON') then begin
    -- aranger is main guest
    select count(*) from PRODUCT_SELECTION$WBE PSC
        where PSC.wbe_session_id = :wbe_session_id
        into :b_count;
       -- only if single reservation bugfix 2228
    if (1 = :b_count) then begin
     guest_profile_uuid =  aranger_profile_uuid;
     aranger_profile_uuid = null;
    end
  end else begin
    -- create profile for main guest
    execute procedure IMPORT_PERSON_PROFILE$EXC(
      uuid_create(),:profile_name,null,null,null,null,null,null,null,null,null,null, null,
      null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
      null,null,null,null,null, 0, 0, null)
    returning_values :main_guest_profile_id, :profile_import_time;

    select P.uuid
    from   profile P
    where  P.id_profile = :main_guest_profile_id
    into   :guest_profile_uuid;
  end

    -- apply default map + forced arranger
    special_treatment = null;
    maintenance = null;
    routing = null;
    arranger_paymeny_type = null;
    market_segment = null;
    market_source = null;
    market_channel = null;
    market_hear_reason = null;
    market_come_reason = null;


  select hc.special_treatment,hk.plan_name,hc.routing,
        pt.payment_type, ms.segment_name,sc.description,cc.description,
        hr.description,cr.description,hc.first_food
  from  hotel_product_cfg$wbe hc
        left join hk_plan hk on hk.id_plan = hc.id_hk_plan
        left join payment_type pt on pt.id_payment_type = hc.arranger_id_payment_type
        left join nom_market_segments ms on ms.id_nom_market_segment = hc.id_m_segment
        left join nom_source_codes sc on sc.id_nom_source_code = hc.id_m_source
        left join nom_channel_codes cc on cc.id_nom_channel_code = hc.id_m_channel
        left join nom_hear_reasons hr on hr.id_nom_hear_reason = hc.id_m_hear_reason
        left join nom_come_reasons cr on cr.id_nom_come_reason = hc.id_m_come_reason
  where hc.hotel_id = :hotel_id
  into  :special_treatment,:maintenance,:routing,:arranger_paymeny_type,
        :market_segment,:market_source,:market_channel,:market_hear_reason,:market_come_reason,:first_food;
  -- create reseravation
  execute procedure IMPORT_BOOKING$EXC(
    :hotel_name, :number, null, null, 0,
    :arrival, null, :departure, null, null, null, null, null, :room_type, :board, null,
     :special_treatment, :maintenance, :routing, :rate, null, null, null, null, :arranger_paymeny_type, null, null, null, null,
     :market_segment, :market_source,:market_channel, :market_hear_reason, :market_come_reason,
     :bnote, null, :first_food, :adults, :children, :aranger_profile_uuid, null, :guest_profile_uuid,
     0, 0, null, :guarantee_policy_name, null, :guarantee_deposit_percent, :guarantee_deposit_nights,
     :guarantee_due_days_bef_arrival,  :guarantee_due_days_after_create, null, null, null, null,  null, null, null, null, null, null)
   returning_values
    :hotel_id ,
    :booking_id,
    :err_code,
    :err_text;

  if (0 <> :err_code) then exception wrong_value ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');

  -- import guests
  for select psg.guest_name,psg.is_child,psg.age from product_selection_guests$wbe psg
  where psg.product_selection_id = :product_selection_id
  into :profile_name,:is_child,:age
  do begin
    execute procedure import_guest$exc(:booking_id, null, null, :profile_name, :is_child, :age, null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null)
    returning_values :guest_id, :err_code,:err_text;
    if (0 <> :err_code) then exception wrong_value ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');
  end
  ----------------

  select RD.number_2
  from   reserv_detail RD
  where  RD.id_reserv_detail = :booking_id
  into   :number_2;

  update product_selection$wbe uPS
  set    uPS.booking_id = :booking_id, uPS.selection_id = :number_2
  where  uPS.id = :product_selection_id;
end
^

/* Restore proc. body: CREATE_SESSION_BOOKINGS$WBE */
ALTER PROCEDURE CREATE_SESSION_BOOKINGS$WBE(WBE_SESSION_ID BIGINT,
ARANGER_ID INTEGER,
LANG_CODE VARCHAR(3))
 RETURNS(SELECTION_ID VARCHAR(20),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable product_selection_id bigint;
declare variable next_num integer;
declare variable sel_cnt integer;
declare variable aranger_name varchar(100);
declare variable aranger_email varchar(50);
declare variable aranger_phone varchar(50);
declare variable booking_id integer;
declare variable record_timestamp timestamp;
declare variable new_res_number varchar(62);
declare variable room_types_src varchar(255) = '';
declare variable rates_src varchar(255) = '';
declare variable hotel_id integer;
declare variable profile_id integer;
declare variable from_date date;
declare variable to_date date;
declare variable day_count integer;
declare variable room_type_id integer;
declare variable rate_id integer;
declare variable query_id_tmp integer;
declare variable rooms_required integer;
declare variable rooms_available integer;
declare variable profile_import_time timestamp;
begin
  execute procedure EXPORT_LOG_FORCE$EXC(1);
  /* test overbook (multiuser) */
   for select ws.hotel_id,ws.profile,aq.first_date,(aq.first_date+aq.day_count)-1,pa.room_type_id,pa.rate_id,aq.day_count
    from   PRODUCT_availability$WBE PA
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    join availability_query$wbe aq on aq.id = pa.query_id
   where ws.id = :wbe_session_id and coalesce(pa.room_count,0) > 0
   into  :hotel_id, :profile_id, :from_date, :to_date, :room_type_id, :rate_id , :day_count
   do begin
       room_types_src = :room_types_src||','||cast(:room_type_id as varchar(10));
       rates_src = :rates_src||','||cast(rate_id as varchar(10));
   end

   query_id_tmp = GEN_ID(AVAILABILITY_QUERY$WBE_SEQ,1);
   insert into availability_query$wbe(ID, WBE_SESSION_ID, FIRST_DATE, DAY_COUNT)    -- prevent FK exception
    values (:query_id_tmp,:wbe_session_id,:from_date,:day_count) ;

   execute procedure availability_occup_small$wbe(:from_date,:to_date,:hotel_id,:query_id_tmp,1,:rates_src,:room_types_src) ;

   --  check minimum available rooms for every day
   err_code = null;
   err_text = '';
   for select pa.room_type_id,pa.room_count,
    (select coalesce(min(art.available_rooms),0) from availability_room_type$wbe art
      where art.query_id = :query_id_tmp and art.room_type_id = pa.room_type_id)
    from product_availability$wbe pa
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    where ws.id = :wbe_session_id
    and coalesce(pa.room_count,0) > 0   into :room_type_id,:rooms_required,:rooms_available
   do begin
       if (rooms_required > rooms_available) then
       begin
        err_code = 1;
        ERR_TEXT = coalesce(ERR_TEXT,'')||:room_type_id||';';
       end
   end
   delete from availability_query$wbe aqt where aqt.id = :query_id_tmp;       -- remove temp query
   if (err_code is not null) then exit;

  /* create profile if not exist and reservations > 1*/
  if (aranger_id is NULL) then
  begin
    select WS.person_name,WS.address,WS.phone
    from   WBE_SESSION$WBE WS
    where  WS.id = :wbe_session_id
    into   :aranger_name,:aranger_email,:aranger_phone;

    execute procedure IMPORT_PERSON_PROFILE$EXC(
       uuid_create(),:aranger_name,null,null,null,null,null,null,null,null,null,null,
       null,null,null,null,:aranger_phone,null,:aranger_email,null,null,null,null,null,null,
       STRHASH_LARGE(substring(uuid_create() from 1 for 4)),null,null,null,null,null,null,null,null,0,0, null)
    returning_values :aranger_id, :profile_import_time;

    update WBE_SESSION$WBE uWS
    set    uWS.profile = :aranger_id
    where  uWS.id = :wbe_session_id;
  end else begin
    -- da podmeni email, phone ako !!
  end
  /* create reservations */
  for
    select PS.id
    from   PRODUCT_SELECTION$WBE PS
    where  PS.wbe_session_id = :wbe_session_id
           and PS.booking_id is null
           and coalesce(PS.is_deleted,0) <> 1
    into   :product_selection_id
  do begin
     if (next_num = 1) then begin      -- increment first reservation number_3
      execute procedure res_number_suffix_gen(:booking_id) returning_values :new_res_number;
      next_num = next_num + 1;
     end
     execute procedure CREATE_BOOKING$WBE(:product_selection_id,:aranger_id,'WBE.'||:selection_id||'.'||:next_num) returning_values :booking_id,:selection_id;
     execute procedure IMPORT_BOOKING_FINALIZE$EXC(:booking_id) returning_values  record_timestamp,:err_code,:err_text;
     insert into SCHEDULER$WBE(booking_id,status,last_action_time,lang_code,guarantee_passed) values (:booking_id, NULL, current_timestamp, :lang_code,0);

     if (next_num is NULL) then begin
      next_num = 1;
     end else begin
      next_num = next_num + 1;
     end
  end
end
^

/* Restore proc. body: DEPOSIT_REFUND$DOC */
ALTER PROCEDURE DEPOSIT_REFUND$DOC(ID_DEPOSIT INTEGER,
REFUND_AMOUNT NUMERIC(15,4),
REFUND_CURRENCY VARCHAR(3),
ID_PAY_DOC_TYPE INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_REFUND_PAYMENT INTEGER,
ID_STORNO_DOC INTEGER,
WARN_CODE INTEGER)
 AS
declare variable no_use varchar(2000);
  declare variable id_account integer;
  declare variable avail_value numeric(15,4);
  declare variable id_doc_head integer;
  declare variable pay_currency varchar(3);
  declare variable pay_rate numeric(15,6);
  declare variable sys_date date;
  declare variable round_to numeric(15,4);
  declare variable p_dbkey char(8);
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable id_account_payment integer;
  declare variable id_doc_type integer;
  declare variable account_curr varchar(3);
  declare variable account_rate numeric(15,6);
  declare variable id_reserv_detail integer;
  declare variable is_posting_stopped integer;
  declare variable firm_data type of tnote_blob;
begin
  WARN_CODE = null;
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_REFUND');

  select D.ID_ACCOUNT, DH.ID_DOC, dh.ID_DOC_TYPE, c.ROUND_TO, d.ID_RESERV_DETAIL,
         D.AVAIL_VALUE, D.PAY_CURRENCY, D.PAY_RATE, A.ID_HOTEL, A.ACCOUNT_CURR
  from   DEPOSIT_AVAILABLE D
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join CURRS C on c.CURR = d.PAY_CURRENCY
         left outer join DOC_HEAD DH on DH.ID_DOC = D.ID_DOC_HEAD
                                        and DH.IS_STORNED = 0
                                        and DH.IS_ANUL = 0
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_account, :id_doc_head, :id_doc_type, :round_to, :id_reserv_detail,
         :avail_value, :pay_currency, :pay_rate, :id_hotel, :account_curr;

  if (:pay_currency is distinct from :refund_currency) then exception PAYMENT_EXCEPTION 'Currency mismatch!';

  if (round_f(:avail_value - :REFUND_AMOUNT, :round_to) < 0) then exception PAYMENT_EXCEPTION '-305';
  --'Issued value is more than available deposit amount.';

  select r.IS_POSTING_STOPPED
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :is_posting_stopped;

  if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';

  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET(:id_hotel) SD
  into   :sys_date;

  select first 1 ap.ACC_RATE
  from   ACCOUNT_PAYMENTS ap
  where  ap.ID_DEPOSIT = :ID_DEPOSIT
  order by ap.ID_ACCOUNT_PAYMENT asc
  into   :account_rate;

  execute procedure PAYMENT_CREATE$INT (:ID_PAY_DOC_TYPE, :ID_ACCOUNT, :SYS_DATE,
          -:REFUND_AMOUNT, :PAY_CURRENCY, :PAY_RATE, :account_curr, :account_rate, :DESCRIPTION)
  returning_values  (:id_refund_payment, :id_account_payment, :no_use);

  insert into DEPOSIT_REFUND (ID_DEPOSIT, ID_PAYMENT_HEAD, DESCRIPTION)
  values (:ID_DEPOSIT, :ID_REFUND_PAYMENT, :DESCRIPTION);

  update ACCOUNT_PAYMENTS AP
  set    AP.ID_DEPOSIT = :ID_DEPOSIT
  where  ap.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT;

  if (:ID_DOC_HEAD is not null) then begin
    execute procedure DOC_TYPE_EVALUATE$INT (:id_doc_type, :id_hotel, 0, :ID_REFUND_PAYMENT);

    execute procedure DOCUMENT_ADVANCE_STORNO$INT (:ID_DEPOSIT, :REFUND_AMOUNT, :DESCRIPTION)
    returning_values  (:ID_STORNO_DOC, :WARN_CODE);

    execute procedure DOCUMENT_ATTACH_PAYMENT$INT (:ID_STORNO_DOC, :id_account_payment, :pay_rate, null)
    returning_values :no_use;
     
    update  PAYMENT_HEAD P
    set     P.ID_DOC_HEAD = :ID_STORNO_DOC
    where   P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT;

    execute procedure DOCUMENT_VALIDATE$DOC (:ID_STORNO_DOC)
    returning_values (:firm_data, :no_use, :no_use);
  end else begin
    select P.RDB$DB_KEY
    from   PAYMENT_HEAD P
    where  P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT
    into   :P_DBKEY;
     
    execute procedure PAYMENT_SET_NUMBER$INT (:P_DBKEY);
  end

  action_text = F_CHARACTER(29) || :REFUND_AMOUNT || ' ' || :PAY_CURRENCY;
  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'REFUND', :ACTION_TEXT);
end
^

/* Restore proc. body: DOCUMENT_ANUL$DOC */
ALTER PROCEDURE DOCUMENT_ANUL$DOC(ID_DOC_HEAD INTEGER,
ANUL_REASON VARCHAR(100),
MAKE_ANNUL_REPORT SMALLINT)
 AS
/**/
  declare variable id_account  integer;
  declare variable id_payment_head integer;
  declare variable for_deposit integer;
  declare variable id_base_doc integer;
  declare variable is_anul integer;
  declare variable dh_dbkey char(8);
  declare variable id_annul_protocol_num integer;
  declare variable num integer;
  declare variable doc_num varchar(20);
  declare variable system_date date;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable doc_date date;
  declare variable id_system_log integer;
  declare variable id_hotel integer;
  declare variable is_storno_doc integer;
  declare variable no_use integer;
begin

  select H.RDB$DB_KEY, H.ID_ACCOUNT, H.FOR_DEPOSIT, H.ID_BASE_DOC, H.IS_ANUL, A.ID_HOTEL,
         A.ID_RESERV_DETAIL, T.ID_ANNUL_DOC_NUM, h.DOC_DATE, H.IS_STORNO
  from   DOC_HEAD$INT H
         join DOC_COMPLETION dc on dc.ID_DOC_HEAD = h.ID_DOC_HEAD
         join DOC_TYPE T on H.ID_DOC_TYPE = T.ID_DOC_TYPE
         join DOC_TYPE_INV DTI on DTI.ID_DOC_TYPE = T.ID_DOC_TYPE
         join ACCOUNT A on A.ID_ACCOUNT = H.ID_ACCOUNT
  where  H.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :dh_dbkey, :id_account, :for_deposit, :id_base_doc, :is_anul, :id_hotel,
         :id_reserv_detail, :id_annul_protocol_num, :doc_date, :is_storno_doc;

  if (:is_anul = 1) then
    exception DOCUMENT_ANNUL_EXCEPTION '-352'; --'Document is already annul';

  if (exists (select D.ID_DOC
              from   DOC_HEAD D
              where  D.ID_BASE_DOC = :ID_BASE_DOC
                     and D.ID_DOC > :ID_DOC_HEAD
                     and D.IS_ANUL = 0))
  then exception DOCUMENT_ANNUL_EXCEPTION '-314';

  execute procedure SYSTEM_DATE_GET(:ID_HOTEL)
  returning_values  :system_date;

  if (:DOC_DATE < :SYSTEM_DATE) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_PREV_DATE');
  end
  /* unarchive account and set as credit account, for shecked out bookings only */
  execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:ID_ACCOUNT, 0);

  if (:ID_RESERV_DETAIL is not null) then begin
    select RD.CHECK_STATUS
    from   RESERV_DETAIL RD
    where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :check_status;

    if (:check_status = 1) then begin
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, null, 1);
    end
  end
  /* MARK THE DOCUMENT AS ANUL - before posting and payment updates */
  update DOC_HEAD$INT DH
  set    DH.IS_ANUL = 1
  where  DH.RDB$DB_KEY = :dh_dbkey;

  update DOC_COMPLETION Dc
  set    Dc.IS_EFAKTURA_EXPORTED = 0
  where  Dc.ID_DOC_HEAD = :ID_DOC_HEAD;


  if (:is_storno_doc = 1) then begin
    /* annul storno doc */
    update DOC_HEAD$INT BD
    set    BD.IS_STORNED = 0
    where  BD.ID_DOC_HEAD = :id_base_doc
           and BD.IS_STORNED = 1;
  end
  /* RELEASE ACCOUNT_POSTS */
  if (:for_deposit = 0) then
    execute procedure ACCOUNT_POSTING_DOC_UPDATE$INT (:DH_DBKEY)
    returning_values (:no_use);

  /* PAYMENTS REFLECTION */
  for
    select PH.ID_PAYMENT_HEAD
    from   PAYMENT_HEAD PH
           join DOC_TYPE_PAY dt on dt.ID_DOC_TYPE = ph.ID_DOC_TYPE
    where  PH.ID_DOC_HEAD = :ID_DOC_HEAD
           and PH.IS_STORNED = 0
    into   :ID_PAYMENT_HEAD
  do begin

    execute procedure PAYMENT_ANUL$INT (:ID_PAYMENT_HEAD, :ANUL_REASON);
  end

  /* ANNUL_PROTOCOL creating section */
  NUM = null;
  DOC_NUM = null;
  if (:MAKE_ANNUL_REPORT = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_WITH_PROT');

    if (:ID_ANNUL_PROTOCOL_NUM is null) then exception DOCUMENT_ANNUL_EXCEPTION '-345';

    execute procedure SYSTEM_GEN_NUM ('ANNUL_PROT', :ID_ANNUL_PROTOCOL_NUM)
    returning_values  (:num, :doc_num);
  end
  /* log annul event */
  execute procedure SYSTEM_EVENT_LOG$INT ('DOCUMENT', :ID_DOC_HEAD, 'ANNUL', f_character(29)||:ANUL_REASON)
  returning_values  :id_system_log;

  insert into DOC_ANNULMENT (ID_DOC_HEAD, ANNULMENT_DATE, ID_PROT_DOC_NUM, PROT_NUM, PROT_DOC_NUM, ID_LOG_EVENT)
  values (:ID_DOC_HEAD, :SYSTEM_DATE, :ID_ANNUL_PROTOCOL_NUM, :NUM, :DOC_NUM, :ID_SYSTEM_LOG);
  /* reflect annul date on doc release dates */
  if (:DOC_DATE < :SYSTEM_DATE) then begin
    insert into DOC_RELEASE_DATE (ID_DOC_HEAD, RELEASE_DATE, VALUE_CORR_INDEX)
    values (:ID_DOC_HEAD, :SYSTEM_DATE, -1);
  end else begin
    update DOC_RELEASE_DATE RD
    set    RD.VALUE_CORR_INDEX = 0
    where  RD.ID_DOC_HEAD = :ID_DOC_HEAD
           and RD.RELEASE_DATE = :DOC_DATE;
  end
  /* reflect on AR module */
  execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT (:DH_DBKEY, null, 1, :ANUL_REASON);
  /* reflect on client loyalty module */
  execute procedure DOCUMENT_BONUSPOINTS_VOID$CL (:ID_DOC_HEAD);

end
^

/* Restore proc. body: DOCUMENT_CLEAR_DEPOSITS$DOC */
ALTER PROCEDURE DOCUMENT_CLEAR_DEPOSITS$DOC(ID_DOC_HEAD INTEGER)
 AS
declare variable is_storno_doc smallint;
begin

  execute procedure DOCUMENT_REUSE_DEPOSITS$INT (:ID_DOC_HEAD, null);

end
^

/* Restore proc. body: EAI_EXT_POST_TO_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable ID_HOTEL integer;
begin
  if (singular(select HS.ID_HOTEL
               from HOTEL_S HS
               where HS.IS_USE = 1)) then
    select H.ID_HOTEL
    from   HOTEL_S H
    where H.IS_USE = 1
    into   :id_hotel;
  else begin
    err_code = -1044;
    exit;
  end

  execute procedure EAI_EXT_POST_TO_MH_FRONT_ONLINE(:ID_HOTEL, :ROOM_NAME,
    :SERVICE_CODE, :CODE_TYPE, :QTY_POST, :PRICE_POST, :CURR_POST, :POST_TEXT)
  returning_values (:ERR_CODE, :ERR_TEXT, :ID_ROOM, :ID_GUEST, :GUEST_NAME1,
    :ID_ACCOUNT, :ID_ACCOUNT_POST, :ID_SERVICE);

end
^

/* Restore proc. body: EAI_IMPORT_ALOYALTY_CLIENT */
ALTER PROCEDURE EAI_IMPORT_ALOYALTY_CLIENT(CLIENT_UUID VARCHAR(40),
CLIENT_NAME VARCHAR(100),
CARD_CODE VARCHAR(50),
IS_ARHIVE SMALLINT,
DATE_OF_BIRTH DATE)
 AS
declare variable PROFILE_ID integer;
  declare variable IMPORT_TIME timestamp;
begin
  execute procedure IMPORT_PERSON_PROFILE$EXC(:CLIENT_UUID, :CLIENT_NAME, null, :DATE_OF_BIRTH, null, null,
    null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null,
    :IS_ARHIVE, :CARD_CODE, null, null, null, null, null, null, null, null, null, null, null, null)
  returning_values :PROFILE_ID, :IMPORT_TIME;
end
^

/* Restore proc. body: EAI_POS_POSTING_ADD */
ALTER PROCEDURE EAI_POS_POSTING_ADD(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
begin
  -- used external inteface - for compatability with Front 2008
  execute procedure EAI_POS_POSTING_ADD$P2E (:IN_ON_GUEST, :IN_ID_ACCOUNT, :IN_ID_GUEST, :IN_DATE_SMETKA,
          :IN_PRICE, :IN_DATETIME, :IN_OBJ_NAME, :IN_TABLE, :IN_SITE, :IN_SMETKA_NUM, :IN_POS_USER,
          :IN_ID_SMETKA, :IN_SERVICE_TAG, :IN_SERVICE_NAME)
  returning_values (:ERR_CODE, :ERR_TEXT, :OUT_ID_ACCOUNT);

end
^

/* Restore proc. body: END_WORK */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable system_date date;
  declare variable id_room integer;
  declare variable id_end_work integer;
  declare variable last_closed_date date;
  declare variable mark_dirty_expired_block varchar(10);
  declare variable mark_dirty_occ_room varchar(10);
  declare variable lock_id integer;
  declare variable shift_no integer;
  declare variable init_hotel_date date;
begin

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;
  if (:system_date >= :in_next_date) then exception END_WORK_EXCEPTION '-43';
  if (:IN_NEXT_DATE > current_date + 1) then exception END_WORK_EXCEPTION '-60';

  last_closed_date = :in_next_date - 1;

  /* LOCK THE CURRENT FINANCIAL (SYSTEM) DATE  */
  lock_id = null;
  while (:lock_id is null) do begin
    lock_id = strhash_large(:system_date || :id_hotel);
    execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'lock');
  
    when any do begin
      exception END_WORK_EXCEPTION '-337' || f_character(31) || f_character(29) || FormatDate(:system_date, 'D;dd.mm.yyyy');
    end
  end

  /* RIGHT IS REQUIRED TO CHANGE THE FINANCIAL DATE IF THERE ARE GUESTS WITH OVERDUE CHECK OUT */
  if (exists(
    select *
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
    where  G.TO_DATE <= :last_closed_date
           and G.CHECK_STATUS < 1
           and RD.ID_HOTEL = :id_hotel
           and rd.IS_ANUL = 0
  )) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('EW_OVERDUE_CHECKOUT');
  end

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', 'EW');
  -- Suppress eventual right checks into next procedures - all is permitted. Is this needed(?!?)

  update ACCOUNT_POST AP
  set    ap.ROOM_NAME = (select R.ROOM_NAME
                         from   GUEST G
                                join ROOMS R on R.ID_ROOM = G.ID_ROOM
                         where  G.ID_GUEST = ap.ID_GUEST)
  where  ap.DATE_POST between :system_date and :last_closed_date
         and ap.ID_GUEST > 0;

  select coalesce(max(ew.SHIFT_NO), 0) + 1
  from   END_WORKS ew
  where  ew.PREV_DATE = :system_date
  into   :shift_no;

  id_end_work = gen_id(G_AUTO_INC_END_WORKS, 1);
  insert into END_WORKS (ID_END_WORK, PREV_DATE, NEXT_DATE, END_WORK_KIND, SHIFT_NO, ID_HOTEL)
  values (:id_end_work, :system_date, :in_next_date, 3, :shift_no, :id_hotel);

  /* CHANGE SYSTEM DATE */
  execute procedure SYSTEM_DATE_SET(:id_hotel, :in_next_date);

  /* AUTO EXPIRATION OF ROOM NUMBERS, ROOMS AND BOOKING POSITIONS */
  execute procedure RESERVS_EXPIRE$INT(:last_closed_date, :id_hotel);

  execute procedure AGENT_CONTINGENT_EXPIRE(:system_date, :last_closed_date, null, 0, 1, :id_hotel);

  /* DELETE PERSON PROFILES WITH EXPIRATION DATE */
  execute procedure PROFILE_PERSON_EXPIRE (:in_next_date);

  execute procedure SETTING_GET_VALUE('MARK_DIRTY_EXPIRED_BLOCK', :ID_HOTEL)
  returning_values  :mark_dirty_expired_block;
  if (:mark_dirty_expired_block = '1') then begin
    for
      select distinct BR.ID_ROOM
      from   BLOCK_ROOM BR
             join ROOMS R on R.ID_ROOM = BR.ID_ROOM
      where  R.ID_HOTEL = :id_hotel
             and BR.TO_DATE >= :system_date
             and BR.TO_DATE < :in_next_date
             and BR.IS_ANNUL = 0
         into :id_room
    do begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'BLOCK_EXP', 'set_dirty');

      when any do post_event 'dummy';  -- nothing
    end
  end

  execute procedure SETTING_GET_VALUE('MARK_DIRTY_OCC_ROOM', :ID_HOTEL)
  returning_values  :mark_dirty_occ_room;
  if (:mark_dirty_occ_room = '1') then begin
    for
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
             join ROOMS R on R.ID_ROOM = rm.ID_ROOM
      where  R.ID_HOTEL = :id_hotel
             and RM.BUSY_DATE = :system_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and RM.BUSY_GROUP_TYPE = 24
      into   :id_room
    do begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'EW_DAY', 'set_dirty');

      when any do post_event 'dummy';  -- nothing
    end
  end

  /* Summary data prepare */
  if (:in_next_date > :system_date) then begin
    execute procedure SUMMARY_FINANCE_SAVE$INT (:id_end_work);

    select min(e.PREV_DATE)
    from   END_WORKS E
    where  E.ID_HOTEL = :ID_HOTEL
    into   :init_hotel_date;

    execute procedure SUMMARY_PREPARE$INT(:id_hotel, :init_hotel_date, :last_closed_date); --TODO precise the period

    execute procedure SUMMARY_FORECAST$INT(:ID_HOTEL, :system_date);
  end

  /* Delete data from temporal tables */
  delete from RESERV_ERROR;
  delete from TMP_SMALL_OCCUP;
--  delete from GUEST g where g.id_reserv_detail is null; pri regenerirane na statistikata ne vurshi rabota
  /*  */

  execute procedure CACHES_RESOLVE;

  execute procedure SYSTEM_LOG_ADD('SYSTEM', :id_end_work, 'DAY_EW', f_character(29) || :last_closed_date);

  execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'release');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', null);

  post_event 'invalidate.end_work';
end
^

/* Restore proc. body: EXPORT_BOOKING$EXC */
ALTER PROCEDURE EXPORT_BOOKING$EXC(BOOKING_ID INTEGER)
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20,
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_ID INTEGER,
IS_GUEST_ARRANGER INTEGER,
POSTING_ROUTING VARCHAR(20),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IS_DIFFERENT_TARIFF SMALLINT,
IS_DIFFERENT_BOARD SMALLINT,
IS_CUSTOM_PRICE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
EXC_LOCAL_VERSION BIGINT,
EXC_REMOTE_VERSION BIGINT,
CREATE_DATETIME TIMESTAMP,
EATING_OBJECT VARCHAR(50))
 AS
declare variable arrival_type_code smallint;
BEGIN
  number = null;
  select h.hotel_name, b.number, bei.confirmation_number, bei.cancelation_number,
        bs.status, rg.id_reserv_group, rg.group_name, rg.uuid, b.is_vip, b.arrival_date, b.comming_kind,
        b.departure_date, b.is_late_departure, b.transfer_in_time, b.transfer_in_note,
        b.transfer_out_time, b.transfer_out_note, rt.type_room, board.name,
        b.room_features, b.i_special_treatment, hk.plan_name, r.tarifa_name, b.custom_price, b.custom_currency,
        b.deposit_required, b.deposit_required_currency, apt.payment_type, ppt.payment_type,
        b.voucher_num, b.voucher_date, b.voucher_text, ms.segment_name, sc.description,
        cc.description, hr.description, cr.description, b.note, b.note_reminders,
        b.code_first_food, ap.id_profile, isperson.id_profile as is_guest_arranger,
        b.acc_routing, b.is_different_room_type, b.is_different_stay_type, b.is_different_tariff,
        b.is_different_board, b.is_custom_price, b.is_different_price, bei.split_on_checkin,
        gp.name, b.block_cc, bei.guarantee_deposit_percent, bei.guarantee_deposit_nights,
        bei.guarantee_due_days_bef_arrival, bei.guarantee_due_days_after_create, bx.minibar_rights,
        bx.paytv_rights, bx.video_rights, bx.nopost_pms, bx.phone_rights, bx.seminar_cahnnel_rights,
        bei.posting_transaction_uuid, bei.exc_local_version, bei.exc_remote_version, bei.create_datetime,
        eo.name
  from  RES_LOAD(:booking_id) b
        join reserv_detail bei on bei.id_reserv_detail = :booking_id
        join HOTEL h on h.id_hotel = b.id_hotel
        join export_booking_status$exc(b.check_status, b.annul_status) bs on 1=1
        left outer join RESERV_GROUP RG on RG.ID_RESERV_GROUP = b.ID_GROUP
        join room_types rt on rt.id_room_type = b.id_res_room_type
        left outer join hk_plan hk on hk.id_plan = b.id_hk_plan
        join tarifa r on r.id_tarifa = b.id_tariff
        left outer join payment_type apt on apt.id_payment_type = b.id_agent_payment
        left outer join payment_type ppt on ppt.id_payment_type = b.id_person_payment
        left outer join nom_market_segments ms on ms.id_nom_market_segment = b.id_nom_market_segment
        left outer join nom_source_codes sc on sc.id_nom_source_code = b.id_nom_source_code
        left outer join nom_channel_codes cc on cc.id_nom_channel_code = b.id_nom_channel_code
        left outer join nom_hear_reasons hr on hr.id_nom_hear_reason = b.id_nom_hear_reason
        left outer join nom_come_reasons cr on cr.id_nom_come_reason = b.id_nom_come_reason
        left outer join profile ap on ap.id_profile = b.id_agent_profile
        left outer join profile_person isperson on isperson.id_profile = b.id_agent_profile
        left outer join meals board on board.ID_BOARD = bei.ID_BOARD
        left outer join guarantee_policy gp on gp.id_guarantee_policy=b.id_guarantee_policy
        left outer join reserv_detail_external bx on bx.id_reserv_detail = :booking_id
        left outer join eating_object eo on eo.id_eating_object = b.id_eating_object
  into  :hotel,
        :number,
        :confirmation_number,
        :cancelation_number,
        :status,
        :group_id,
        :group_name,
        :group_uuid,
        :is_vip,
        :arrival,
        :arrival_type_code,
        :departure,
        :is_late_departure,
        :transfer_in_time,
        :transfer_in_note,
        :transfer_out_time,
        :transfer_out_note,
        :room_type,
        :board,
        :room_preferences,
        :special_treatment,
        :maintance_shema,
        :rate,
        :manual_price,
        :manual_price_currency,
        :deposit_required,
        :deposit_required_currency,
        :arranger_payment_type,
        :guest_payment_type,
        :voucher,
        :voucher_date,
        :voucher_text,
        :marketing_segment,
        :marketing_source_code,
        :marketing_channel_code,
        :marketing_hear_reason,
        :marketing_come_reason,
        :note,
        :note_reminders,
        :first_food,
        :arranger_profile_id,
        :is_guest_arranger,
        :posting_routing,
        :is_different_room_type,
        :is_different_stay_type,
        :is_different_tariff,
        :is_different_board,
        :is_custom_price,
        :is_different_price,
        :split_on_checkin,
        :guarantee_policy,
        :block_cc,
        :guarantee_deposit_percent,
        :guarantee_deposit_nights,
        :guarantee_due_days_bef_arrival,
        :guarantee_due_days_after_create,
        :minibar_rights,
        :paytv_rights,
        :video_rights,
        :nopost_pms,
        :phone_rights,
        :seminar_cahnnel_rights,
        :posting_transaction_uuid,
        :exc_local_version,
        :exc_remote_version,
        :create_datetime,
        :eating_object
  ;

  if (:number is not null) then begin -- Check if we have export
    arrival_type = null;
    if (0 = :arrival_type_code) then begin
      arrival_type = 'early';
    end else if (2 = :arrival_type_code) then begin
      arrival_type = 'late';
    end
    suspend;
  end
END
^

/* Restore proc. body: IMPORT_BOOKING$EXC */
ALTER PROCEDURE IMPORT_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(250),
MAINTANCE_SHEMA VARCHAR(30),
POSTING_ROUTING VARCHAR(20),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
COMPLIMENTARY_ACCOUNT VARCHAR(50),
EATING_OBJECT VARCHAR(50),
CREATE_DATETIME TIMESTAMP)
 RETURNS(HOTEL_ID INTEGER,
BOOKING_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable current_hotel_id integer;
declare variable booking_update_id integer;
declare variable warn_code integer;
declare variable share_transaction_id integer;
declare variable share_err_code integer;
declare variable arranger_profile_id integer;
declare variable main_guest_profile_id integer;
declare variable rate_id integer;
declare variable room_type_id integer;
declare variable board_id integer;
declare variable maintance_shema_id integer;
declare variable arranger_payment_type_id integer;
declare variable guest_payment_type_id integer;
declare variable marketing_segment_id integer;
declare variable marketing_source_code_id integer;
declare variable marketing_channel_code_id integer;
declare variable marketing_hear_reason_id integer;
declare variable marketing_come_reason_id integer;
declare variable arranger_account_id integer;
declare variable packet_id integer;
declare variable id_guarantee_policy integer;
declare variable first_food_code tfood_code;
declare variable arrival_type_code smallint;
declare variable booking_dbkey char(8);
declare variable reserv_group_id integer;
declare variable id_complimentary_account integer;
declare variable id_eating_object integer;
begin
  /*execute procedure sys_dbg('exc IMPORT_BOOKING$EXC('
  || 'hotel => ' || coalesce(:hotel, '<null>')
  || ', booking_number => ' || coalesce(:number, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  ||')');
  */
  execute procedure import_mark_transaction$exc;

  /* init */
  err_code = 0;
  err_text = '';
  booking_update_id = null;
  booking_dbkey = null;
  current_hotel_id = null;
  if (:voucher_date is not null) then begin
    voucher_date = striptime(:voucher_date);
  end
  posting_routing = upper(:posting_routing);

  /* detect inser/update mode */
  select b.id_reserv_detail, b.rdb$db_key, b.id_hotel
  from   reserv_detail b
  where  b.number=:number
         and b.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and b.id_log_event_annul is null
  into   :booking_update_id, :booking_dbkey, :current_hotel_id;

  if (:booking_update_id is null) then begin
    booking_id = gen_id (id_reserv_detail_gen, 1);
  end else begin
    booking_id = :booking_update_id;
  end

  /* text to id map */
  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => MAP_BOOKING_RELATIONS$EXC');
  execute procedure MAP_BOOKING_RELATIONS$EXC(
    :booking_id,
    :hotel,
    :room_type,
    :board,
    :maintance_shema,
    :rate,
    :arranger_payment_type,
    :guest_payment_type,
    :marketing_segment,
    :marketing_source_code,
    :marketing_channel_code,
    :marketing_hear_reason,
    :marketing_come_reason,
    :first_food,
    :arranger_profile_uuid,
    :arranger_profile_name,
    :main_guest_profile_uuid,
    :arrival_type,
    :guarantee_policy,
    :eating_object
  ) returning_values
    :arranger_profile_id,
    :main_guest_profile_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :hotel_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :first_food_code,
    :arrival_type_code,
    :id_guarantee_policy,
    :id_eating_object;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* hotel change test */
  if (coalesce(:current_hotel_id, :hotel_id) <> :hotel_id) then begin
    execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', null, :hotel, 'booking hotel changed');
  end

  id_complimentary_account = null;
  if (complimentary_account is not null) then begin
    execute procedure lookup_account$exc(:hotel_id, :complimentary_account, 'booking', :booking_id)
    returning_values :id_complimentary_account;
  end

  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => CREATE_PACK_INSTANCE$EXC');
  packet_id = null;
  /*execute procedure CREATE_PACK_INSTANCE$EXC(
    :hotel_id, :booking_id, :package
  )
  returning_values :packet_id, :err_code, :err_text;
  if (0 <> :err_code) then exit;
  */
  /* merge input and default/persistent database values */
  execute procedure DEFAULT_BOOKING_VALUES$EXC(
    :booking_dbkey, :hotel_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :group_name,
    :group_uuid,
    :is_late_departure,
    :id_eating_object
  ) returning_values
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :arranger_account_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :reserv_group_id,
    :is_late_departure,
    :id_eating_object;

  if ('' = :board) then board_id = null; /* preserve "empty board" state and discard default value */

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC DEFAULTED => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* if the booking is complimentary use complimentary account */
  arranger_account_id = coalesce(:id_complimentary_account, :arranger_account_id);

  /* CREATE or UPDATE */
  if (:booking_update_id is not null) then begin
    /* UPDATE booking */
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => UPDATE_BOOKING$EXC');
    execute procedure UPDATE_BOOKING$EXC(
      :booking_id,
      :reserv_group_id,
      :is_vip,
      :arrival,
      :arrival_type_code,
      :departure,
      :is_late_departure,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :room_type_id,
      :board_id,
      :room_preferences,
      :special_treatment,
      :maintance_shema_id,
      :posting_routing,
      :arranger_account_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :deposit_required,
      :deposit_required_currency,
      :arranger_payment_type_id,
      :guest_payment_type_id,
      :voucher,
      :voucher_date,
      :voucher_text,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :note,
      :note_reminders,
      :first_food_code,
      :arranger_profile_id,
      :main_guest_profile_id,
      :is_different_rate,
      :is_different_price,
      :split_on_checkin,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object
    ) returning_values :err_code, :err_text;
    if (0 <> :err_code) then begin
      exit;
    end
  end else begin
    /* CREATE booking */
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => RES_CREATE_SET$EXC');
    execute procedure RES_CREATE_SET$EXC (
      :booking_id,
      :number,
      :arranger_profile_id,
      :main_guest_profile_id,
      :arrival,
      :departure,
      :adult_count,
      :children_count,
      :room_type_id,
      null,
      :board_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :voucher,
      :voucher_date,
      :voucher_text,
      null,
      null,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :arrival_type_code,
      :is_late_departure,
      :is_vip,
      :first_food_code,
      :special_treatment,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :arranger_account_id,
      :posting_routing,
      :guest_payment_type_id,
      :arranger_payment_type_id,
      null,
      :room_preferences,
      :maintance_shema_id,
      :note,
      :note_reminders,
      :deposit_required,
      :deposit_required_currency,
      :hotel_id,
      :reserv_group_id,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object,
      :create_datetime
      )
    returning_values :err_code, :err_text, :warn_code, :booking_id, :share_transaction_id, :share_err_code;
  end

  execute procedure GUEST_STAY_INITIALIZE$INT (:booking_id);
  /* final error check */
  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;

  delete from PENDING_DEPOSIT d
  where  d.ID_RESERV_DETAIL = :BOOKING_ID;
end
^

/* Restore proc. body: IMPORT_RATE_RECORD_RELINK$EXC */
ALTER PROCEDURE IMPORT_RATE_RECORD_RELINK$EXC(ID_RATE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ID_COLUMN integer;
declare variable ID_NEW_MASTER_RECORD integer;

declare variable PERIOD_DEPEND_ON_CHECKIN INTEGER;
declare variable CNT_DAYS_PRICE_BP INTEGER;
declare variable CNT_DAYS_PRICE_BOARD INTEGER;
declare variable BASE_BOARDS_LIST VARCHAR(255);
declare variable BOARD_TYPE VARCHAR(10);
begin
  execute procedure import_mark_transaction$exc;

  ERR_CODE = 0;
  ERR_TEXT = '';
  for
    select c.ID_TAR_DEFINE_COLUMN, im.ID_NEW
    from   TAR_UI_DEFINE_COLUMNS c
           join IDS_MAP$TMP im on c.ID_DIM2 = im.ID_OLD
    where  c.ID_TAR_HEAD = :ID_RATE
    into   :ID_COLUMN, :ID_NEW_MASTER_RECORD
  do begin
    update TAR_UI_DEFINE_COLUMNS c
    set    c.ID_DIM2 = :ID_NEW_MASTER_RECORD
    where  c.ID_TAR_DEFINE_COLUMN = :ID_COLUMN;
  end

  delete from IDS_MAP$TMP;


  select
        th.PERIOD_DEPEND_ON_CHECKIN,
        th.CNT_DAYS_PRICE_BP,
        th.CNT_DAYS_PRICE_BOARD,
        th.BASE_BOARDS_LIST,
        th.BOARD_TYPE
  from  TAR_HEAD th
  where th.ID_TAR_HEAD = :ID_RATE
  into  :PERIOD_DEPEND_ON_CHECKIN, :CNT_DAYS_PRICE_BP, :CNT_DAYS_PRICE_BOARD, :BASE_BOARDS_LIST, :BOARD_TYPE;

  for
    select ERR_CODE, ERR_TEXT
    from   TAR_SAVE(:ID_RATE, :PERIOD_DEPEND_ON_CHECKIN, :CNT_DAYS_PRICE_BP, :CNT_DAYS_PRICE_BOARD, :BASE_BOARDS_LIST, :BOARD_TYPE)
    into   :err_code, :err_text
  do begin
    if (0 <> :err_code) then begin
      exit;
    end
  end
end
^

/* Restore proc. body: RES_ANUL_DETAIL$INT */
ALTER PROCEDURE RES_ANUL_DETAIL$INT(RD_DBKEY CHAR(8),
REASON VARCHAR(50),
CANCELATION_NUMBER TYPE OF NAME_20 = null)
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable id_reserv_detail integer;
  declare variable is_anul integer;
  declare variable id_log_event integer;
  declare variable id_guest integer;
  declare variable g_dbkey char(8);
  declare variable no_use varchar(255);
  declare variable tmp_extra_posts_left smallint;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:reason, 'NOSHOW, CANCELED, USERERROR, TRANSFER', 'Annul reason');

  select RD.IS_ANUL, RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :is_anul, :id_reserv_detail;

  if (:is_anul = 1) then begin
    exception BOOKING_EXCEPTION '-1021';
    -- Reservation is already annuled or checkedin !
  end

  if (:reason = 'NOSHOW') then begin
    execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    returning_values  :no_use, :no_use;

    -- execute procedure TAR_CALC_FINALIZE$INT(:err_code, :id_tar_calc, :rd_dbkey); -- this procedure is enclosed into RES_FINALIZE_RECALC$INT
    -- err_code = 0; -- IGNORE ALL ERRORS
  end

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_ANUL', f_character(29) || :reason);

  id_log_event = RDB$GET_CONTEXT('USER_TRANSACTION', 'ACTION_LOG_ID');

  update RESERV_DETAIL RDU
  set    RDU.IS_ANUL = 1,
         RDU.REASON_OF_ANUL = :reason,
         RDU.ID_LOG_EVENT_ANNUL = :id_log_event,
         RDU.CANCELATION_NUMBER = coalesce(:CANCELATION_NUMBER, strhash_large(rdu.NUMBER || 'CANCELATION'))
  where  RDU.RDB$DB_KEY = :rd_dbkey;

  EXTRA_POSTS_LEFT = 0;
  for
    select g.ID_GUEST, G.RDB$DB_KEY
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_guest, :g_dbkey
  do begin
    execute procedure GUEST_DEL_POSTINGS$INT(:id_guest)
    returning_values  :tmp_extra_posts_left;
    EXTRA_POSTS_LEFT = iif(:EXTRA_POSTS_LEFT = 1, 1, :tmp_extra_posts_left);

    update GUEST G
    set    G.UUID = null
    where  g.RDB$DB_KEY = :g_dbkey;
  end

  execute procedure RES_FINALIZE$INT (:RD_DBKEY, 0)
  returning_values (:warn_code);

  execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

end
^

/* Restore proc. body: RES_CHECKIN$RSV */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable old_check_status integer;
  declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable is_anul integer;
  declare variable arrival_date date;
  declare variable system_date date;
begin
  /*  Description:
  ||
  */
  select RD.CHECK_STATUS, RD.RDB$DB_KEY, RD.FROM_DATE, RD.ID_HOTEL,
         RD.ID_ROOM, RD.IS_ANUL
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_check_status, :rd_dbkey, :arrival_date, :id_hotel,
         :old_id_room, :is_anul;

  if (:is_anul = 1) then exception BOOKING_EXCEPTION '-2';

  if (:old_check_status >= 0) then exception BOOKING_EXCEPTION '-1003';

  if (:old_id_room < 0 and coalesce(:ID_ROOM, 0) <= 0) then exception BOOKING_EXCEPTION '-1018';

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date < :arrival_date) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CHECK_IN_FUTURE');
  end
  /*----*/
  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'lock');

  execute procedure sys_dbg('occ RES_CHECKIN$RSV id_room = '||coalesce(:id_room, 'null'));
  execute procedure sys_dbg('occ RES_CHECKIN$RSV old_id_room = '||coalesce(:old_id_room, 'null'));

  if (:id_room is not null) then begin
    if (:old_check_status = -3) then begin
      execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, -2);
    end

    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option)
    returning_values (:WARN_CODE);
  end

  execute procedure RES_SET_CHECKIN$INT (:rd_dbkey)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'release');
  /*----*/
  select f_character(29) || R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = coalesce(:ID_ROOM, :old_id_room)
  into   :action_text;
   
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'CHECK_IN', :action_text);

end
^

/* Restore proc. body: RES_CHECKIN_MULTI$RSV */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable checkin_count integer;
  declare variable split_on_checkin integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
  declare variable tmp_warn_code integer;
begin
  checkin_count = 0;
  warn_code = null;
  for
    select RD.ID_RESERV_DETAIL, RD.CHECK_STATUS, RD.SPLIT_ON_CHECKIN, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :SELECTION_ID
    into   :id_reserv_detail, :check_status, :split_on_checkin, :id_titular
  do begin
    if (:check_status >= 0) then begin
      checkin_count = :checkin_count + 1;
    end else begin
      if (:split_on_checkin = 1) then begin
        for
          select G.ID_GUEST
          from   GUEST G
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and G.ID_GUEST <> :id_titular
          into   :id_guest
        do begin
          execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
          returning_values  :id_splited_reservation;

          execute procedure RES_CHECKIN$RSV (:id_splited_reservation)
          returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

          update RESERV_DETAIL RD
          set    RD.SELECTION_ID = :selection_id
          where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
        end
      end

      execute procedure RES_CHECKIN$RSV (:id_reserv_detail)
      returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
      WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end

  if (:checkin_count > 0) then begin
    execute procedure SYSTEM_WARNING_ADD(-1011, f_character(29)||:checkin_count)
    returning_values  :warn_code;
  end
end
^

/* Restore proc. body: RES_CREATE_SET$RSV */
ALTER PROCEDURE RES_CREATE_SET$RSV(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
SUPPRESS_WARNINGS INTEGER,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER,
NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable rd_dbkey char(8);
declare variable tmp_warn_code integer;
begin
  WARN_CODE = null;
  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, :check_status, :arrival_date, :departure_date,
                    :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff, :PACKET_ITEM_IDS,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
                    :guarantee_deposit, :guarantee_currency, :split_on_checkin, null, null, :ID_ACC_TEMPLATE_PERSON,
                    :ID_GUARANTEE_POLICY, null, :ID_EATING_OBJECT)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :WARN_CODE;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :ERR_TEXT, :share_transaction_id, :tmp_warn_code;
  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

  if (:suppress_warnings = 1) then begin
    delete from SYSTEM_WARNINGS W
    where W.ID_TRANSACTION = :warn_code;
    warn_code = null;
  end

  update RESERV_DETAIL RD
  set    RD.NOTE_REMINDERS = :note_reminders
  where  RD.RDB$DB_KEY = :rd_dbkey;

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;

end
^

/* Restore proc. body: RES_FINALIZE$INT */
ALTER PROCEDURE RES_FINALIZE$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable err_text varchar(255);
begin
  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, :SUPPRESS_NON_INSTANT_ERRORS)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;
  if (:share_err_code < 0) then exception BOOKING_EXCEPTION :share_err_code || f_character(31) || :ERR_TEXT;
end
^

/* Restore proc. body: RES_GET_DEPOSIT$INT */
ALTER PROCEDURE RES_GET_DEPOSIT$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(DEPOSIT_VALUE NUMERIC(15,4),
DEPOSIT_CURRENCY CHAR(3))
 AS
declare variable rd_dbkey char(8);
declare variable dummy varchar(255);
begin
  select RD.RDB$DB_KEY, RD.GUARANTEE_DEPOSIT, rd.GUARANTEE_CURRENCY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :deposit_value, :deposit_currency;

  if (:DEPOSIT_VALUE is not null) then begin
    EXIT;
  end else begin
    execute procedure RES_GET_PRICE$INT(:rd_dbkey, 'SECURITY, FORCED')
    returning_values  :dummy, :dummy, :dummy, :deposit_value, :deposit_currency;
  end

end
^

/* Restore proc. body: RES_GET_INFO$RSV */
ALTER PROCEDURE RES_GET_INFO$RSV(ID_RESERV_DETAIL INTEGER,
RETURN_BALANCE SMALLINT = 1,
RETURN_SHARE SMALLINT = 1,
RETURN_GEUSTDATA SMALLINT = 1)
 RETURNS(NUMBER VARCHAR(62),
AGENT_PROFILE_NAME VARCHAR(100),
ARRIVALS VARCHAR(255),
DEPARTURES VARCHAR(255),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
ID_ROOM INTEGER,
ROOM VARCHAR(60),
ID_ROOM_TYPE INTEGER,
ROOM_FEATURES BLOB,
GUESTS VARCHAR(255),
GUESTS_CNT INTEGER,
PERSON_PROFILE_NAME VARCHAR(150),
RATES VARCHAR(255),
BOARDS VARCHAR(255),
PACKETS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY VARCHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
BALANCE VARCHAR(255),
OPEN_CHARGES INTEGER,
CHECK_STATUS INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
NOTE VARCHAR(2000),
NOTE_GRP VARCHAR(255),
VOUCHER_RENDER VARCHAR(512),
ACC_ROUTING VARCHAR(255),
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
BUSY_GRP INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
GUEST_TYPE_COLOR INTEGER,
IS_CLEAN INTEGER,
ROOM_PRIVATE_STATUS TLOGICAL)
 AS
declare variable arrival varchar(20);
declare variable departure varchar(20);
declare variable rd_dbkey char(8);
declare variable no_use varchar(1024);
declare variable rd_adult_count integer;
declare variable rd_child_count integer;
declare variable groupname varchar(100);
declare variable virtual_room varchar(10);
declare variable earlycheckout_date date;
begin
  arrivals = '';
  departures = '';
  rates = '';
  NOTE_GRP = null;

  IS_CLEAN = 0;

  select AP.PROFILE_NAME, RD.ADULT_COUNT, RD.CHILD_COUNT,
         R.ID_ROOM, R.ROOM_NAME, coalesce(rd.VIRTUAL_ROOM, 'i'||RM.ID_ROOM), coalesce(R.ID_ROOM_TYPE, RM.ID_ROOM_TYPE, RD.ID_ROOM_TYPE),
         RD.CHECK_STATUS, PP.PROFILE_NAME || coalesce(' (' || GT.GUEST_TYPE_NAME || ')', ''),
         RD.FROM_DATE, RD.TO_DATE, RG.GROUP_NAME,
         RD.ID_GROUP, RD.ROOM_FEATURES, RD.COMMING_KIND, RD.LEAVING_KIND - 1,
         RD.NUMBER, RD.NOTE, RD.RDB$DB_KEY, RD.ID_HOTEL, RD.ACC_ROUTING,
         GT.GUEST_TYPE_COLOR, coalesce(r.IS_CLEAN, 1), g.EARLYCHECKOUT_DATE
  from   RESERV_DETAIL RD
         left outer join RESERV_GROUP RG on RG.ID_RESERV_GROUP = RD.ID_GROUP
         left outer join PROFILE AP on AP.ID_PROFILE = RD.ID_AGENT_PROFILE
         left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
         left outer join ROOM_MAP$EXC RM on RM.ID_ROOM = RD.ID_ROOM
         left outer join PROFILE PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
         left outer join PROFILE_PERSON PPp on PPp.ID_PROFILE = PP.ID_PROFILE
         left outer join GUEST_TYPE GT on GT.ID_GUEST_TYPE = PPp.ID_GUEST_TYPE
         left outer join GUEST G on g.ID_GUEST = rd.ID_TITULAR
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :agent_profile_name, :rd_adult_count, :rd_child_count,
         :id_room, :room, :virtual_room, :id_room_type,
         :check_status, :person_profile_name,
         :arrival_date, :departure_date, :groupname,
         :id_group, :room_features, :comming_kind, :is_late_departure,
         :number, :note, :rd_dbkey, :id_hotel, :acc_routing,
         :guest_type_color, :is_clean, :earlycheckout_date;


  ARRIVALS = iif(extract(year from current_date) = extract(year from :ARRIVAL_DATE),
               formatDate(:ARRIVAL_DATE, 'D;dd.mm')||' ('||(:DEPARTURE_DATE - :ARRIVAL_DATE)||')',
               formatDate(:ARRIVAL_DATE, 'D;dd.mm.yy')||' ('||(:DEPARTURE_DATE - ARRIVAL_DATE)||')');
  DEPARTURES = iif(extract(year from current_date) = extract(year from :DEPARTURE_DATE),
               formatDate(:DEPARTURE_DATE, 'D;dd.mm'),
               formatDate(:DEPARTURE_DATE, 'D;dd.mm.yy'));
  for
    select iif(extract(year from current_date) = extract(year from g.FROM_DATE),
               formatDate(g.FROM_DATE, 'D;dd.mm')||' ('||(G.TO_DATE - G.FROM_DATE)||')',
               formatDate(g.FROM_DATE, 'D;dd.mm.yy')||' ('||(G.TO_DATE - G.FROM_DATE)||')'),
           iif(extract(year from current_date) = extract(year from g.TO_DATE),
               formatDate(g.TO_DATE, 'D;dd.mm'),
               formatDate(g.TO_DATE, 'D;dd.mm.yy'))
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
           and ((g.FROM_DATE <> :ARRIVAL_DATE) or (g.TO_DATE <> :DEPARTURE_DATE))
    into   :arrival, :departure
  do begin
    if (:ARRIVALS not containing :arrival) then ARRIVALS = :ARRIVALS || ','||:arrival;
    if (:DEPARTURES not containing :departure) then DEPARTURES = :DEPARTURES || ','||:departure;
  end

  execute procedure RES_GET_PRICE$INT(:rd_dbkey, 'SECURITY')
  returning_values  :room_price, :room_currency, :room_price_details, :no_use, :no_use;

  if (coalesce(:return_balance,1)=1) then
    execute procedure RES_GET_BALLANCE$INT(:id_reserv_detail)
    returning_values  :balance, :no_use, :no_use, :open_charges, :no_use;

  if (:groupname <> '') then agent_profile_name = coalesce(:agent_profile_name, '') || ' / ' || coalesce(:groupname, '');

  execute procedure RES_GET_ATTENTION_STATUS$INT(:arrival_date, :departure_date, :check_status, :id_hotel)
  returning_values  :attention_status;

  if (coalesce(:return_share,1)=1) then begin
    execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'RENDER', null)
    returning_values  :in_share, :no_use, :shares_preview;
    if (:IN_SHARE = 1) then ROOM = coalesce(:ROOM, :virtual_room);
  end

  if (coalesce(:return_geustdata,1)=1) then begin
    execute procedure RES_GET_GUEST_DATA$INT('DETAIL', :id_reserv_detail)
    returning_values  :boards, :rates, :packets, :voucher_render;
  end

  execute procedure RES_GET_ANNULSTATUS(:rd_dbkey)
  returning_values  :annul_status;

  guests = :rd_adult_count || ' + ' || :rd_child_count || ' ';
  guests_cnt = :rd_adult_count + :rd_child_count;

  if (:check_status > 1) then  busy_grp = 24;
  else busy_grp = 1;

  ROOM_PRIVATE_STATUS = 0;
  select cast(1 as smallint)
  from   SYSTEM_DATE_GET (:ID_HOTEL) sd
         join ROOM_MAGIC rm on rm.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                               and rm.ROOM_STATUS = 'PRIVATE'
                               and rm.BUSY_DATE = mindate(maxdate(:ARRIVAL_DATE, sd.SYSTEM_DATE), coalesce(:earlycheckout_date, :DEPARTURE_DATE) - 1)
  into   :ROOM_PRIVATE_STATUS;

  suspend;
end
^

/* Restore proc. body: RES_GUEST_CHANGE$RSV */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable id_guest integer;
  declare variable check_status integer;
  declare variable id_person_data integer;
  declare variable old_person_profile integer;
  declare variable old_profile_name varchar(100);
  declare variable new_profile_name varchar(100);
begin
  select r.RDB$DB_KEY, r.ID_TITULAR, r.CHECK_STATUS, r.ID_PERSON_PROFILE, p.PROFILE_NAME
  from   RESERV_DETAIL R
         join PROFILE P on P.ID_PROFILE = r.ID_PERSON_PROFILE
  where  R.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey, :id_guest, :check_status, :old_person_profile, :old_profile_name;

  if (:old_person_profile = :ID_PERSON_PROFILE) then exit; -- NO CHANGES!

  id_person_data = null;
  select pp.ID_PERSON_DATA, p.PROFILE_NAME
  from   PROFILE_PERSON PP
         join PROFILE P on P.ID_PROFILE = pp.ID_PROFILE
  where  pp.ID_PROFILE = :ID_PERSON_PROFILE
  into   :id_person_data, :new_profile_name;

  if (:id_person_data is null) then exception BOOKING_EXCEPTION '-1039';

  update RESERV_DETAIL RD
  set    rd.ID_PERSON_PROFILE = :ID_PERSON_PROFILE
  where  rd.RDB$DB_KEY = :rd_dbkey;

  if (:check_status = 1) then begin
    execute procedure PERSON_DATA_COPY$INT (:id_person_data)
    returning_values (:id_person_data);
  end

  update GUEST_DATA GD
  set    gd.ID_PERSON_DATA = :id_person_data
  where  gd.ID_GUEST = :id_guest;

  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey);

  if (exists (select ap.ID_ACCOUNT_POST
              from   ACCOUNT_POST AP
                     join ACCOUNT A on A.ID_ACCOUNT = ap.ID_ACCOUNT
              where  a.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                     and a.ID_PROFILE = :old_person_profile
                     and ap.IS_ANUL = 0)) then
    exception BOOKING_EXCEPTION '-1038';

  if (exists (select d.ID_DEPOSIT
              from   DEPOSITS D
                     join ACCOUNT A on A.ID_ACCOUNT = d.ID_ACCOUNT
              where  a.ID_PROFILE = :old_person_profile
                     and coalesce(d.ID_RESERV_DETAIL, a.ID_RESERV_DETAIL) = :ID_RESERV_DETAIL
                     and d.RECEIVED_AMOUNT > 0)) then
    exception BOOKING_EXCEPTION '-1040';

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'TITULAR_CHANGED',
          f_character(29) || :old_profile_name || f_character(28) || :new_profile_name, null);

end
^

/* Restore proc. body: RES_SAVE_ACCOUNTING$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
declare variable old_id_agent_profile integer;
  declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable action_text varchar(255);
  declare variable old_account_routing varchar(30);
  declare variable id_acc_profile integer;
begin
  /* Description : ACC_ROUTING = {GUEST, AGENT, MIXED, OWNER, GUEST_SEPARATE_ACCOUNTS, PART_COMPLIMENTARY, FULL_COMPLIMENTARY }
  ||
  *//*
  execute procedure RES_SAVE_PROFILING$INT (:RD_DBKEY, :ID_AGENT_PROFILE, :ID_AGENT_ACCOUNT, :ID_AGENT_PAYMENT,
          :id_person_profile, :ID_PERSON_PAYMENT, :ACC_ROUTING, :ID_GROUP);
  */
  execute procedure SYSTEM_CHECK_OPERATION(:acc_routing, 'GUEST, AGENT, MIXED, OWNER, FULL_COMPLIMENTARY, PART_COMPLIMENTARY', 'Account routing');

  if (exists (select *
              from   PROFILE_HOUSE PH
              where  PH.ID_PROFILE = :id_agent_profile)) then
  begin
    exception BOOKING_EXCEPTION '-1016';
  end

  execute procedure RESERV_TRACK_CHANGES$INT(:rd_dbkey);

  select RD.ID_AGENT_PROFILE, RD.ID_RESERV_DETAIL, RD.ACC_ROUTING
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_agent_profile, :id_reserv_detail, :old_account_routing;

  if (:ACC_ROUTING in ('AGENT','MIXED') and :ID_AGENT_ACCOUNT is not null) then begin
    select A.ID_PROFILE
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :ID_AGENT_ACCOUNT
    into   :id_acc_profile;
    -- check up agent account ownership
    if (:id_acc_profile is distinct from :ID_AGENT_PROFILE) then ID_AGENT_ACCOUNT = null;
--    if (:id_acc_profile is distinct from :ID_AGENT_PROFILE) then exception BOOKING_EXCEPTION '-1026';
  end

  update RESERV_DETAIL RD
  set    RD.ID_AGENT_ACCOUNT_RULE = :ID_AGENT_ACCOUNT,
         RD.ACC_ROUTING = :ACC_ROUTING,
         RD.ID_AGENT_PROFILE = :ID_AGENT_PROFILE,
         RD.ID_AGENT_PAYMENT = :ID_AGENT_PAYMENT,
         --RD.ID_PERSON_PROFILE = :ID_PERSON_PROFILE,
         RD.ID_PERSON_PAYMENT = coalesce(:ID_PERSON_PAYMENT, RD.ID_PERSON_PAYMENT),
         RD.ID_GROUP = :ID_GROUP
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_id_agent_profile is distinct from :id_agent_profile) then begin
    execute procedure RES_SET_EDIT_STATUS$INT(:RD_DBKEY, 'AGENT', 'add');

    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :g_dbkey
    do begin
      execute procedure GUEST_AGENT_SET$INT(:g_dbkey, :id_agent_profile);
    end

    select f_character(29)||coalesce(old_A.PROFILE_NAME, '')||f_character(28)||coalesce(new_A.PROFILE_NAME, '')
    from   PROFILE old_A, PROFILE new_A
    where  old_A.ID_PROFILE = :old_id_agent_profile
           and new_A.ID_PROFILE = :ID_AGENT_PROFILE
    into   :action_text;

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_AGENT', :action_text);
  end

  if (:ACC_ROUTING <> :old_account_routing) then begin
    action_text = f_character(29) || coalesce(:old_account_routing, '')
                  || f_character(28) || coalesce(:acc_routing, '');

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_ACC_ROUTING', :action_text);
  end

  execute procedure RES_SAVE_ACCOUNTS$INT (:RD_DBKEY);
end
^

/* Restore proc. body: RES_SAVE_ROOM$EXC */
ALTER PROCEDURE RES_SAVE_ROOM$EXC(RD_DBKEY CHAR(8),
ID_RES_ROOM_TYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(250),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_room integer;
begin
  select RD.ID_ROOM, RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_room, :id_reserv_detail;

  execute procedure RES_SAVE_ROOM$RSV(
    :id_reserv_detail,
    :old_id_room,
    :id_res_room_type,
    'nrttAsIs',
    1,
    :id_hk_plan,
    :room_features,
    :i_special_treatment,
    :split_on_checkin,
    0
  ) returning_values :share_err_code, :err_text, :share_transaction_id, :warn_code;
end
^

/* Restore proc. body: SAFE_CHECK_OUT */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE TYPE OF ID)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
WARN_CODE TYPE OF ID_REF)
 AS
declare variable to_dt timestamp;
  declare variable is_occupied integer;
  declare variable expire_tollerance integer;
  declare variable occupant_name varchar(100);
  declare variable id_resource_reservation integer;
  declare variable check_out_datetime timestamp;
begin
  DOC_SELECTED = null;
  select s.IS_OCCUPIED, od.TO_DATETIME,
         st.EXPIRE_TOLLERANCE, rr.OCCUPANT_NAME, rr.ID_RESOURCE_RESERVATION
  from   SAFE s
         join RESOURCE$INT r on r.ID_RESOURCE = s.ID_SAFE
         join SAFE_TYPES st on st.ID_SAFE_TYPE = r.ID_RESOURCE_TYPE
         join RESOURCE_RESERVATION rr on rr.ID_RESOURCE_RESERVATION = s.ID_CURRENT_OCCUPANCY
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join RESOURCE_OCCUPANCY ro on ro.ID_RESOURCE_OCCUPANCY_DATA = od.ID_RESOURCE_OCCUPANCY_DATA
  where  s.ID_SAFE = :ID_SAFE
  into   :is_occupied, :to_dt, :expire_tollerance, :occupant_name, :id_resource_reservation;

  if (:is_occupied = 0) then exit;

  expire_tollerance = coalesce(:expire_tollerance, 0);
  check_out_datetime = current_timestamp;

  execute procedure SAFE_OCCUPANCY_MODIFY (:id_safe, current_timestamp, :occupant_name)
  returning_values  :DOC_SELECTED;

  if (:check_out_datetime > (:to_dt + cast(:expire_tollerance as double precision) / 60 / 24)) then begin
    execute procedure SYSTEM_WARNING_ADD (-1066, f_character(29) || :expire_tollerance || f_character(28) || formatdate(:to_dt + cast(:expire_tollerance as double precision) / 60 / 24, 'D;dd/mm/yyyy HH:MM'))
    returning_values (:WARN_CODE);
  end

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = null
  where  s.ID_SAFE = :ID_SAFE;

  update RESOURCE_RESERVATION rr
  set    rr.STATUS = 'CHECKED_OUT'
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_CHECKED_OUT', :occupant_name);
end
^

/* Restore proc. body: TAR_CALC_INPUT_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_PARAMS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_input integer;
  declare variable id_guest integer;
  declare variable for_date date;
  declare variable id_calc_tariff integer;
  declare variable td_dbkey char(8);
  declare variable date_independent_param_values varchar(2000);
  declare variable date_dep_param_values varchar(2000);
  declare variable prev_id_guest integer;
  declare variable prev_id_tariff integer;
begin
  prev_id_guest = null;
  prev_id_tariff = null;
  for
    select Td.RDB$DB_KEY, TI.ID_TAR_INPUT, ti.ID_GUEST, td.FOR_DATE, td.ID_TAR_HEAD
    from   TAR_CALC_INPUT$TMP TI
           join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
    where  TI.ID_TAR_CALC = :id_tar_calc
    order by ti.ID_GUEST asc, td.FOR_DATE asc
    into   :td_dbkey, :id_tar_input, :id_guest, :for_date, :id_calc_tariff
  do begin
    if ((:id_guest is distinct from :prev_id_guest)
        or (:id_calc_tariff is distinct from :prev_id_tariff)) then
    begin
      /* get date independent params */
      execute procedure TAR_CALC_PARAMS$INT (:id_calc_tariff, :id_tar_input, :ID_TAR_CALC, null, null)
      returning_values (:ERR_CODE, :date_independent_param_values);
      if (:ERR_CODE < 0) then exit;
      prev_id_guest = :id_guest;
      prev_id_tariff = :id_calc_tariff;
    end

    execute procedure TAR_CALC_PARAMS$INT (:id_calc_tariff, :id_tar_input, :ID_TAR_CALC, :for_date, null)
    returning_values (:ERR_CODE, :date_dep_param_values);
    if (:ERR_CODE < 0) then exit;

    update TAR_CALC_INPUT_DETAIL$TMP d
    set    d.PARAM_VALUES = coalesce(:date_independent_param_values, '') || ';'
                            || coalesce(:date_dep_param_values, '')
    where  d.RDB$DB_KEY = :td_dbkey;
  end
end
^

SET TERM ; ^

ALTER TABLE DEPOSIT ALTER COLUMN ID_DEPOSIT POSITION 1;

ALTER TABLE DEPOSIT ALTER COLUMN DESCRIPTION POSITION 2;

ALTER TABLE DEPOSIT ALTER COLUMN ID_PAYMENT_HEAD POSITION 3;

ALTER TABLE DEPOSIT ALTER COLUMN ID_ACCOUNT POSITION 4;

ALTER TABLE DEPOSIT ALTER COLUMN ID_PROFILE POSITION 5;

ALTER TABLE DEPOSIT ALTER COLUMN ID_RESERV_DETAIL POSITION 6;

ALTER TABLE DEPOSIT ALTER COLUMN DOC_SELECTED POSITION 7;

ALTER TABLE DEPOSIT ALTER COLUMN UUID POSITION 8;

ALTER TABLE DEPOSIT ALTER COLUMN ID_BILLING_SERVICE POSITION 9;

ALTER TABLE PMS_EVENT$PMS ALTER COLUMN ID_PMS_EVENT POSITION 1;

ALTER TABLE PMS_EVENT$PMS ALTER COLUMN ID_ROOM POSITION 2;

ALTER TABLE PMS_EVENT$PMS ALTER COLUMN ID_OWNER POSITION 3;

ALTER TABLE PMS_EVENT$PMS ALTER COLUMN ID_EXPORT_HEAD POSITION 4;

ALTER TABLE PMS_EVENT$PMS ALTER COLUMN ID_RESERV_DETAIL POSITION 5;

ALTER TABLE PMS_EVENT$PMS ALTER COLUMN ID_DOC_HEAD POSITION 6;

ALTER TABLE PMS_EVENT$PMS ALTER COLUMN EVENT_TYPE POSITION 7;

ALTER TABLE PMS_EVENT$PMS ALTER COLUMN DESCRIPTION POSITION 8;

ALTER TABLE PMS_EVENT$PMS ALTER COLUMN IMP_PERIOD_FROM POSITION 9;

ALTER TABLE PMS_EVENT$PMS ALTER COLUMN IMP_PERIOD_TO POSITION 10;

ALTER TABLE PMS_EVENT$PMS ALTER COLUMN PRICE_WO_VAT POSITION 11;

ALTER TABLE PMS_EVENT$PMS ALTER COLUMN PRICE_WITH_VAT POSITION 12;

ALTER TABLE PMS_EVENT$PMS ALTER COLUMN CURR POSITION 13;

ALTER TABLE PMS_EVENT$PMS ALTER COLUMN EVENT_STATUS POSITION 14;

ALTER TABLE PMS_EVENT$PMS ALTER COLUMN ID_PREV_EVENT POSITION 15;

ALTER TABLE PMS_EVENT$PMS ALTER COLUMN MANUAL_POST_DATE POSITION 16;

ALTER TABLE PMS_EVENT$PMS ALTER COLUMN DOC_DESCRIPTION POSITION 17;

ALTER TABLE PMS_EVENT$PMS ALTER COLUMN ID_SESSION POSITION 18;

ALTER TABLE PMS_EVENT$PMS ALTER COLUMN STAY POSITION 19;

ALTER TABLE PMS_EVENT$PMS ALTER COLUMN RESERVS POSITION 20;

ALTER TABLE PMS_EVENT$PMS ALTER COLUMN BEDNIGHTS POSITION 21;

ALTER TABLE PMS_EVENT$PMS ALTER COLUMN ID_ROOM_CONTRACT POSITION 22;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN ID_TAR_INPUT POSITION 1;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN ID_TAR_CALC POSITION 2;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN ROOM_STATUS POSITION 3;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN ID_GUEST POSITION 4;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN ID_RESERV POSITION 5;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN IS_CHILD POSITION 6;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN GUEST_AGE POSITION 7;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN GUEST_SEX POSITION 8;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN FROM_DATE POSITION 9;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN TO_DATE POSITION 10;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN REAL_RECALC POSITION 11;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN FROM_DATE_CALC POSITION 12;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN TO_DATE_CALC POSITION 13;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN VOUCHER_NUM POSITION 14;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN VOUCHER_DATE POSITION 15;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN VOUCHER_TEXT POSITION 16;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN COUNTRY_CODE POSITION 17;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN ID_BASE_ACCOUNT POSITION 18;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN IS_LATE_CHECKOUT POSITION 19;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN ID_GROUP POSITION 20;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN ID_AGENT_PROFILE POSITION 21;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN ID_GUEST_TYPE POSITION 22;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN PACKET_ITEMS POSITION 23;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN IS_STATIC POSITION 24;

ALTER TABLE TAR_CALC_INPUT$TMP ALTER COLUMN ID_RATE_OVERRULE POSITION 25;

