/* Server version: WI-V6.3.4.18393 Firebird 2.1 
   SQLDialect: 3. ODS: 11.1. Forced writes: On. Sweep inteval: 20000.
   Page size: 8192. Cache pages: 2048 (16384 Kb). Read-only: False. */
SET SQL DIALECT 3;

DROP VIEW ACCOUNT_PREVIEW;

DROP VIEW ENA_ACCOUNT;

DROP VIEW ENA_RESERV_DETAIL;

RECONNECT;

/* Drop: PROFILE_MERGE_NAME_IDX (TIdxData) */
DROP INDEX PROFILE_MERGE_NAME_IDX;

SET TERM ^ ;

ALTER TRIGGER PROFILE_BIU0
 AS Declare variable I integer;
BEGIN I = 0; END
^

/* Empty CONTRAGENT_MODIFY$CONTR for drop PROFILE(MERGE_IDENT_NUM) */
ALTER PROCEDURE CONTRAGENT_MODIFY$CONTR(ID_CONTRAGENT INTEGER,
CONTRAGENT_NAME VARCHAR(100),
IS_JURIDICAL_PERSON SMALLINT,
IDENT_NO VARCHAR(30),
VAT_REG_NUM VARCHAR(30),
POST_ADDRESS VARCHAR(100),
ZIP_CODE VARCHAR(10),
EMAIL VARCHAR(50),
MOL VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
BANK_NAME VARCHAR(50),
BIC VARCHAR(30),
IBAN VARCHAR(30))
 RETURNS(NEW_ID_CONTRAGENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Empty PERSON_PASS_DATA_SET$INT for drop PROFILE(MERGE_IDENT_NUM) */
ALTER PROCEDURE PERSON_PASS_DATA_SET$INT(PD_DBKEY CHAR(8),
BIRTH_PLACE VARCHAR(30),
EGN VARCHAR(30),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
SEX CHAR,
MASK VARCHAR(10))
 AS
 BEGIN EXIT; END
^

/* Empty PROFILE_PERSON_CREATEQ$PROFILE for drop PROFILE(MERGE_IDENT_NUM) */
ALTER PROCEDURE PROFILE_PERSON_CREATEQ$PROFILE(PROFILE_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100),
PHONE /* TYPE OF TPHONE */ VARCHAR(50),
ID_PASSPORT_TYPE /* TYPE OF ID */ INTEGER,
PASS_NUM /* TYPE OF NAME_20 */ VARCHAR(20),
EGN /* TYPE OF TTEXT_SHORT */ VARCHAR(30),
COUNTRY_CODE /* TYPE OF TSHORT_CODE */ VARCHAR(10),
CARD_CODE /* TYPE OF TCARD_CODE */ VARCHAR(50),
ID_PERSON_DATA /* TYPE OF ID_REF */ INTEGER = null,
TITLE /* TYPE OF TSHORT_CODE */ VARCHAR(10) = null,
ID_HOTEL /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_PROFILE /* TYPE OF ID */ INTEGER,
P_DBKEY /* TYPE OF TDB_KEY */ CHAR(8),
PD_DBKEY /* TYPE OF TDB_KEY */ CHAR(8))
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

RECONNECT;

/* Drop: PROFILE_MERGE_NUM_IDX (TIdxData) */
DROP INDEX PROFILE_MERGE_NUM_IDX;

RECONNECT;

/* Drop: PROFILE_MERGE_NUM_ALT_IDX (TIdxData) */
DROP INDEX PROFILE_MERGE_NUM_ALT_IDX;

Update Rdb$Fields set Rdb$Character_Set_ID =
(Select C.Rdb$Character_Set_ID from Rdb$Character_Sets C
where C.Rdb$Character_Set_Name='UNICODE_FSS')
where Rdb$Field_Name='TNAME_UNICODE';

Update Rdb$Fields set Rdb$Character_Set_ID =
(Select C.Rdb$Character_Set_ID from Rdb$Character_Sets C
where C.Rdb$Character_Set_Name='UNICODE_FSS')
where Rdb$Field_Name='TNAME_UNICODE';

/* Create Views... */
/* Create view: ACCOUNT_PREVIEW */
CREATE VIEW ACCOUNT_PREVIEW(
ID_ACCOUNT,
ACCOUNT_NAME,
ID_PROFILE,
PROFILE_NAME,
PROFILE_TYPE,
ROOM_NAME,
ACCOUNT_CURR,
IS_CREDIT_ACCOUNT,
IS_BLOCKED,
IS_ARCHIVE,
ID_HOTEL,
NOTE)
 AS 
select A.ID_ACCOUNT,
       A.ACCOUNT_NAME,
       P.ID_PROFILE,
       P.PROFILE_NAME,
       P.PROFILE_TYPE,
       R.ROOM_NAME,
       A.ACCOUNT_CURR,
       A.IS_CREDIT_ACCOUNT,
       A.IS_BLOCKED,
       A.IS_ARCHIVE,
       A.ID_HOTEL,
       A.NOTE
from   ACCOUNT_S A
       join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
       left outer join RESERV_DETAIL RD ON RD.ID_RESERV_DETAIL = A.ID_RESERV_DETAIL
       left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
;

/* Create view: ENA_ACCOUNT */
CREATE VIEW ENA_ACCOUNT(
ID_HOTEL,
ID_ACCOUNT,
ACCOUNT_NAME,
ACCOUNT_EXT_CODE,
PROFILE_ID,
PROFILE_NAME,
PROFILE_ACCOUNT_NO,
PROFILE_TYPE,
PROFILE_HOUSE_TYPE)
 AS 
select A.ID_HOTEL,
       a.ID_ACCOUNT,
       a.ACCOUNT_NAME,
       a.EXT_CODE,
       p.ID_PROFILE,
       p.PROFILE_NAME,
       p.ACCOUNT_NO,
       p.PROFILE_TYPE,
       (select ph.HOUSE_TYPE from PROFILE_HOUSE ph where ph.ID_PROFILE = p.ID_PROFILE)
from  ACCOUNT a
    join PROFILE p on p.ID_PROFILE = a.ID_PROFILE
;

COMMENT ON COLUMN ENA_ACCOUNT.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_ACCOUNT.ID_ACCOUNT IS
'  . .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_NAME IS
'   .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_EXT_CODE IS
'             .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ID IS
'         . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_NAME IS
'    .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ACCOUNT_NO IS
'             .  -    .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_TYPE IS
'       .  : AGENT -  , PERSON -  , HOUSE -    . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_HOUSE_TYPE IS
'      (PROFILE_TYPE = ''HOUSE''),    -.  : hptExternalClient -          ( ,      ); hptExternalRevenue -                (,   ..); hptComplimentary -           ,  ,        . .';

/* Create view: ENA_RESERV_DETAIL */
CREATE VIEW ENA_RESERV_DETAIL(
ID_HOTEL,
ID_RESERV_DETAIL,
NUMBER,
ID_GUEST_MAIN,
GUEST_MAIN_NAME,
GUEST_MAIN_NAME2,
FROM_DATE,
TO_DATE,
NIGHTS,
ADULT_COUNT,
CHILD_COUNT,
ID_EATING_OBJECT,
CHECK_STATUS,
IS_ANUL,
ARRANGER_PROFILE_ID,
ARRANGER_PROFILE_NAME,
ARRANGER_PROFILE_TYPE,
ARRANGER_PROFILE_ACCOUNT_NO,
MARKET_SEGMENT_CODE,
MARKET_SOURCE_CODE,
MARKET_CHANNEL_CODE,
MARKET_HEAR_CODE,
MARKET_COME_CODE)
 AS 
select
rd.ID_HOTEL,
rd.ID_RESERV_DETAIL,
rd.NUMBER,
rd.ID_TITULAR,
pd.PERSON_NAME,
pd.PERSON_NAME2,
rd.FROM_DATE,
rd.TO_DATE,
rd.TO_DATE - rd.FROM_DATE,
rd.ADULT_COUNT,
rd.CHILD_COUNT,
rd.CHECK_STATUS,
rd.ID_EATING_OBJECT,
rd.IS_ANUL,
rd.ID_AGENT_PROFILE,
(select p1.PROFILE_NAME from PROFILE p1 where p1.ID_PROFILE = rd.ID_AGENT_PROFILE),
(select p2.PROFILE_TYPE from PROFILE p2 where p2.ID_PROFILE = rd.ID_AGENT_PROFILE),
(select p3.ACCOUNT_NO from PROFILE p3 where p3.ID_PROFILE = rd.ID_AGENT_PROFILE),
(select M1.MARKET_CODE from NOM_MARKET_SEGMENTS M1 where m1.ID_NOM_MARKET_SEGMENT = rd.ID_NOM_MARKET_SEGMENT),
(select M2.SOURCE_CODE from NOM_SOURCE_CODES M2 where m2.ID_NOM_SOURCE_CODE = rd.ID_NOM_SOURCE_CODE),
(select M3.CHANNEL_CODE from NOM_CHANNEL_CODES M3 where m3.ID_NOM_CHANNEL_CODE = rd.ID_NOM_CHANNEL_CODE),
(select M4.HEAR_REASON_CODE from NOM_HEAR_REASONS M4 where m4.ID_NOM_HEAR_REASON = rd.ID_NOM_HEAR_REASON),
(select M5.COME_REASON_CODE from NOM_COME_REASONS M5 where m5.ID_NOM_COME_REASON = rd.ID_NOM_COME_REASON)
from RESERV_DETAIL rd
    join GUEST g on g.ID_GUEST = rd.ID_TITULAR
    join GUEST_DATA gd on gd.ID_GUEST = g.ID_GUEST
    join PERSON_DATA pd on pd.ID_PERSON_DATA = gd.ID_PERSON_DATA
;

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_RESERV_DETAIL IS
'   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NUMBER IS
'  .    (   ). .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_GUEST_MAIN IS
'      .      .  -     .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME IS
'    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME2 IS
'       . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.FROM_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.TO_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NIGHTS IS
'. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ADULT_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHILD_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_EATING_OBJECT IS
'          . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHECK_STATUS IS
'  . -3 =  ; -2 =   ; -1 =  ; 0 =  ; 1 =  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.IS_ANUL IS
'   . 0 - , 1 - .  -       0  1.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ID IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_NAME IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_TYPE IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ACCOUNT_NO IS
'             .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SEGMENT_CODE IS
'   ''segment''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SOURCE_CODE IS
'   ''source''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_CHANNEL_CODE IS
'   ''channel''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_HEAR_CODE IS
'   ''hear reason''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_COME_CODE IS
'   ''come reason''.   . .';


COMMENT ON COLUMN ENA_ACCOUNT.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_ACCOUNT.ID_ACCOUNT IS
'  . .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_NAME IS
'   .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_EXT_CODE IS
'             .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ID IS
'         . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_NAME IS
'    .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ACCOUNT_NO IS
'             .  -    .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_TYPE IS
'       .  : AGENT -  , PERSON -  , HOUSE -    . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_HOUSE_TYPE IS
'      (PROFILE_TYPE = ''HOUSE''),    -.  : hptExternalClient -          ( ,      ); hptExternalRevenue -                (,   ..); hptComplimentary -           ,  ,        . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_HOTEL IS
'       .  ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_ACCOUNT_POST_HISTORY IS
'   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_ACCOUNT IS
'      .  ENA_ACCOUNT.ID_ACCOUNT. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_SERVICE IS
'   .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_SALE_TAXATION IS
'         .       . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.SYSTEM_DATE IS
'    / . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_DATE IS
'        (). .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_CURR IS
'  . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_AMOUNT IS
'    (   )    . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.NAT_NET_VALUE IS
'    ( )   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.NAT_GROSS_VALUE IS
'    ( )   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_TYPE IS
'  . BASE -  ; ADD_INS -  - ,    ; EXTRA -     ,     ; TAX -            ,     .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_GUEST IS
'       .  ENA_GUEST.ID_GUEST.        : 1.    "  "; 2.           ; 3.        ,      . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_GROUP IS
'       .    : ''ROOMS'', ''Food and Beverage'', ''Other Operated Departments'', ''Rentals and Other Income''. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_ACCOUNT IS
' -      .    . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_SUB_ACCOUNT IS
' --      . ,     -. .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.ID_HOTEL IS
'   ,    . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.ID_DOC_HEAD IS
'        .  ENA_DOC_HEAD_ADVANCE.ID_DOC. .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.SYSTEM_DATE IS
'      . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAYMENT_DATE IS
'     . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.SRC_ID_ACCOUNT IS
'   . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.DEST_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAY_AMOUNT IS
' .        . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAY_CURRENCY IS
' . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.USER_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.DATETIME_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_HOTEL IS
'   ,    . .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_DEPOSIT_PAYMENT IS
'  .         . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_DATE IS
'        .            . .';

COMMENT ON COLUMN ENA_DEPOSIT.SYSTEM_DATE IS
'   .         PAYMENT_DATE.        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_NUM IS
'           .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_DIRECTION IS
'0 -   , 1 -   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_TYPE_NAME IS
'       .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_ACCOUNT IS
'        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_AMOUNT IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DEPOSIT.IS_ANUL IS
'   . 0 - , 1 - .           /    .     IS_ANUL = 0,    1.           ID_DEPOSIT.  .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_CREATED IS
'     .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_CREATED IS
'       . .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_ANNUL IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_ANNUL IS
'     .  .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.ID_HOTEL IS
'       .  .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.ID_DEPOSIT_PAYMENT IS
'   ,   .  ENA_DEPOSIT.ID_DEPOSIT_PAYMENT. .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SYSTEM_DATE IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAYMENT_DATE IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SRC_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DEST_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAY_AMOUNT IS
' .        . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAY_CURRENCY IS
' . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.USER_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DATETIME_CREATED IS
'     . .';

COMMENT ON VIEW ENA_DOC_DEPOSIT_CONSUMPTION IS
' !!!!!!    ID_DOC_TYPE - za mapowe.';


COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.DOC_TYPE_NAME IS
'       . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_NUM IS
'         .  .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_DATE IS
'      .          . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_VALUE IS
'         . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_DOC_RATE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.EQUAL_DOC_VALUE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.NAT_VALUE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.ID_DEPOSIT_PAYMENT IS
'      (  ENA_DEPOSIT.ID_DEPOSIT_PAYMENT ). .';

COMMENT ON VIEW ENA_DOC_HEAD_ADVANCE IS
'!      ';


COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC IS
'  .             .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_ADVANCE.ID_DOC.  .     - , ..       ,      - .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SUB_TYPE IS
'   . ,  : 0 - / , 1 -  ,  , 2 -  ,  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_NAME IS
'    . ,       .              .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_DESCRIPTION IS
'   .         .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_NUM IS
'   ,        .      . ,     ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DATE IS
'        . .    SYSTEM_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.IS_ANUL IS
'        . . 0 - , 1 - .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TOTAL_VALUE IS
' (, )       . .      .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ONE_LINE_TEXT IS
' ,         .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURR_RATE IS
'   ()    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_POST_ADDRESS IS
'    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_ZIP_CODE IS
'     ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_MOL IS
'    ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_RECIPIENT_NAME IS
'     ()';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BANK_NAME IS
'  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BIC IS
'BIC  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IBAN IS
'IBAN  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_EMAIL IS
'email  .        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SUPPLIER_SEND_NAME IS
'     .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ACCOUNT_ID IS
'        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC IS
'  .             .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_SERVICE.ID_DOC.     - , ..       ,      - .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC_TYPE IS
'    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SUB_TYPE IS
'   .  : 0 - / , 1 -  ,  , 2 -  ,  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_NAME IS
'    .              .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_DESCRIPTION IS
'   .         .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_NUM IS
'   ,        .      .  -       ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DATE IS
'        .    SYSTEM_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.IS_ANUL IS
'        . 0 - , 1 - .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_CURRENCY IS
'  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TOTAL_VALUE IS
' (, )       .      .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ONE_LINE_TEXT IS
' ,         .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURR_RATE IS
'   ()    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_DATE IS
'   ,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_NUM IS
'  -,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_POST_ADDRESS IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_ZIP_CODE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_MOL IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_RECIPIENT_NAME IS
'     (). .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BANK_NAME IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BIC IS
'BIC  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IBAN IS
'IBAN  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_EMAIL IS
'email  .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SUPPLIER_SEND_NAME IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ACCOUNT_ID IS
'        .    ENA_ACCOUNT.ID_ACCOUNT. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_SERVICE IS
'     .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.DATE_POST IS
'    . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_SERVICE IS
'      .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_SERVICE IS
'   .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.IS_CORRECT IS
'            .      1,        . 0 -   ; 1 -      0. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_GUEST IS
'   ,        .    null,       ''  ''     .    ENA_GUEST.ID_GUEST. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.DATE_POST IS
'        .    ,    . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ROOM_NAME IS
'       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ACCOUNT_PRICE IS
'         /.             /. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_SERVICE IS
'    (, , , ,  ).  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_SALE_TAXATION IS
'         .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON VIEW ENA_DOC_PAYMENT IS
'   ,     .';


COMMENT ON COLUMN ENA_DOC_PAYMENT.ID_DOC_HEAD IS
'  ( ENA_DOC_HEAD.ID_DOC)      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DOC_TYPE_NAME IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_NUM IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_DATE IS
'     .        ,                 . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_CURRENCY IS
'  .        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DUE_DATE IS
'       .          ,      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_VALUE IS
'           . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_DOC_RATE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.EQUAL_DOC_VALUE IS
'      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.NAT_VALUE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.ID_DOC_HEAD IS
'         . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNT_VALUE IS
'      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNTABLE_VALUE IS
'  .       . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.IS_PERCENT_DISCOUNT IS
'  .         . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.FIXED_DISCOUNT_CURRENCY IS
'  .       -     . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNT_PERCENT_OR_AMOUNT IS
'  .       . .';

COMMENT ON COLUMN ENA_DOC_TAX.ID_DOC_HEAD IS
'         ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_TAX.ID_SALE_TAX IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.NONTAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_VALUE IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_NAME IS
'  .  -        .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_PERCENT IS
'   ().  .';

COMMENT ON COLUMN ENA_DOC_TAX.FISCAL_CODE IS
' .        .  -      .';

COMMENT ON COLUMN ENA_DOC_TAX.ACCOUNT_NAME IS
' .              . .';

COMMENT ON COLUMN ENA_GUEST.ID_GUEST IS
'   ( )   . .';

COMMENT ON COLUMN ENA_GUEST.ID_RESERV_DETAIL IS
'        ( ENA_RESERV_DETAIL.ID_RESERV_DETAIL). .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME2 IS
'      . .';

COMMENT ON COLUMN ENA_GUEST.IS_CHILD IS
'   . 0 - ; 1 - . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE IS
'    . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_TEXT IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.RATING_AGE IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.COUNTRY_CODE IS
'    .        ISO. .';

COMMENT ON COLUMN ENA_GUEST.MASK IS
'  .         . .';

COMMENT ON COLUMN ENA_HOTEL.ID_HOTEL IS
'  . .';

COMMENT ON COLUMN ENA_HOTEL.HOTEL_NAME IS
'  . .';

COMMENT ON COLUMN ENA_HOTEL.CODE IS
'   . .';

COMMENT ON COLUMN ENA_HOTEL.SYSTEM_DATE IS
'     .                  ENA.                . .';

COMMENT ON COLUMN ENA_HOTEL.IS_USE IS
'    (  ). 0 -   , 1 -  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_RESERV_DETAIL IS
'   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NUMBER IS
'  .    (   ). .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_GUEST_MAIN IS
'      .      .  -     .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME IS
'    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME2 IS
'       . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.FROM_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.TO_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NIGHTS IS
'. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ADULT_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHILD_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_EATING_OBJECT IS
'          . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHECK_STATUS IS
'  . -3 =  ; -2 =   ; -1 =  ; 0 =  ; 1 =  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.IS_ANUL IS
'   . 0 - , 1 - .  -       0  1.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ID IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_NAME IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_TYPE IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ACCOUNT_NO IS
'             .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SEGMENT_CODE IS
'   ''segment''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SOURCE_CODE IS
'   ''source''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_CHANNEL_CODE IS
'   ''channel''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_HEAR_CODE IS
'   ''hear reason''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_COME_CODE IS
'   ''come reason''.   . .';

COMMENT ON COLUMN ENA_SERVICES.ID_HOTEL IS
'       . .';

COMMENT ON COLUMN ENA_SERVICES.ID_SERVICE IS
'   . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_NAME IS
'  . .';

COMMENT ON COLUMN ENA_SERVICES.GROUP_NAME IS
'    .            a       . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_TYPE IS
'  .  : ''BASE'',''EXTRA'',''COMMISSION'',''MEAL''. ''BASE'' -    ,     ,''EXTRA'' -  , ''MEAL'' - , ''COMMISSION'' - ,        (  ). .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_GROUP IS
'       .  : ''ROOMS'', ''Food and Beverage'', ''Other Operated Departments'', ''Rentals and Other Income''. .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_ACCOUNT IS
' -      . .';

COMMENT ON COLUMN ENA_SERVICES.ACCOUNT_NAME IS
'      (. ),      .          . .';

COMMENT ON COLUMN ENA_SERVICES.EXT_CODE IS
'         . .';

COMMENT ON COLUMN ENA_SERVICES.IS_BREAKFAST IS
'   . 0 - , 1 - .    1,   SERVICE_TYPE e ''BASE''  ''MEAL''.  -          .';

COMMENT ON COLUMN ENA_SERVICES.IS_LUNCH IS
'   .   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_DINNER IS
'   .   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_EXTRAFOOD1 IS
'     1.   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_EXTRAFOOD2 IS
'     2.   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.ID_ROOM_TYPE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ). .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  -             .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM_EXT_CODE IS
'    ( )     ,      .  -        .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_STAY_CODE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  : ''ALONE'' -      , ''BED'' -            , ''EXTRA_BED'' -      . .';

/* Alter View (Drop, Create)... */
/* Drop altered view: OWNER_POST */
SET TERM ^ ;

ALTER PROCEDURE NON_DOCUMENTED_INFO_GET$INT(ID_OWNER INTEGER,
ID_ROOM INTEGER)
 RETURNS(OUT_LATE_INFO VARCHAR(255),
OUT_CURR_INFO VARCHAR(255),
OUT_NEXT_INFO VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE OWNER_BILL_MODIFY$PMS(ID_OWNER_BILL INTEGER,
ID_OWNER INTEGER,
BILLING_DATE DATE,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_OWNER_BILL INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP VIEW OWNER_POST;

/* Create altered view: OWNER_POST */
/* Create view: OWNER_POST */
CREATE VIEW OWNER_POST(
POST_DATE,
ID_RESERV_DETAIL,
RES_FROM_DATE,
RES_TO_DATE,
RES_STAY,
INCOME_CURR,
INCOME_VALUE,
OUTGO_CURR,
OUTGO_VALUE,
ID_ACCOUNT_POST,
ID_ACCOUNT_POST$PMS,
ID_SERVICE,
POST_STATUS,
IS_ANUL,
DESCRIPTION_EVENT,
ID_PMS_EVENT,
IS_INVOICED,
DOC_DESCRIPTION,
ID_ROOM,
OWNER_PERC,
ID_OWNER,
IS_POOL,
ID_HOTEL,
IS_OWNER_INCOME)
 AS 
select AP.DATE_POST as POST_DATE,
       E.ID_RESERV_DETAIL,
       E.IMP_PERIOD_FROM as RES_FROM_DATE,
       E.IMP_PERIOD_TO + 1 as RES_TO_DATE,
       E.IMP_PERIOD_TO - E.IMP_PERIOD_FROM + 1 as RES_STAY,
       iif(AP.IS_OWNER_INCOME = 1, AP.CURR_POST, NULL) as INCOME_CURR,
       iif(AP.IS_OWNER_INCOME = 1, round_f(AP.VALUE_POST, C.ROUND_TO), NULL) as INCOME_VALUE,
       iif(AP.IS_OWNER_INCOME = 0, AP.CURR_POST, NULL) as OUTGO_CURR,
       iif(AP.IS_OWNER_INCOME = 0, round_f(AP.VALUE_POST, C.ROUND_TO), NULL) as OUTGO_VALUE,
       null as ID_ACCOUNT_POST,
       AP.ID_ACCOUNT_POST as ID_ACCOUNT_POST$PMS,
       AP.ID_SERVICE as ID_SERVICE,
       AP.LINE_STATUS as POST_STATUS,
       iif(AP.LINE_STATUS=22,1,0) as IS_ANUL,
       E.DESCRIPTION as DESCRIPTION_EVENT,
       E.ID_PMS_EVENT as ID_PMS_EVENT,
       null as IS_INVOICED,
       coalesce(E.DOC_DESCRIPTION, E.ID_DOC_HEAD) as DOC_DESCRIPTION,
       E.ID_ROOM as ID_ROOM,
       --(iif(O.ID_RENTAL_POOL_UNIT is null, E.ROOM_OWNERSHIP_PERCENT, 0)) as OWNER_PERC,
       iif(O.ID_RENTAL_POOL_UNIT is null, ro.OWNERSHIP_PERCENT, 0) as OWNER_PERC,
       ACC.ID_OWNER as ID_OWNER,
       iif(O.ID_RENTAL_POOL_UNIT is null, 0, 1) as IS_POOL,
       ACC.ID_HOTEL,
       AP.IS_OWNER_INCOME
from PMS_EVENT$PMS E
  join ACCOUNT_POST$PMS AP on AP.ID_PMS_EVENT = E.ID_PMS_EVENT
  join ACCOUNT$PMS ACC on ACC.ID_ACCOUNT = AP.ID_ACCOUNT_PMS
  join OWNER$PMS O on O.ID_OWNER = ACC.ID_OWNER
  left outer join ROOM_OWNER$PMS ro on ro.ID_ROOM_CONTRACT = e.ID_ROOM_CONTRACT and ro.ID_OWNER = o.ID_OWNER -- pula ne e sobstvenik na staia
  join CURRS C on C.CURR = AP.CURR_POST
where AP.LINE_STATUS in (11,22)
     and ACC.IS_SHADOW = 0
union all
select AP.DATE_POST as POST_DATE,
       E.ID_RESERV_DETAIL,
       E.IMP_PERIOD_FROM as RES_FROM_DATE,
       E.IMP_PERIOD_TO + 1 as RES_TO_DATE,
       E.IMP_PERIOD_TO - E.IMP_PERIOD_FROM + 1 as RES_STAY,
       null as INCOME_CURR,
       null as INCOME_VALUE,
       O.ID_CURRENCY as OUTGO_CURR,
       round_f((AP.QTY_POST * AP.PRICE_POST - AP.IN_DOC_QTY * AP.IN_DOC_VALUE) * iif(O.ID_CURRENCY = AP.CURR_POST, 1,
                                                                                    (select CR.RATE
                                                                                     from   CURR_CROSS_RATE_GET(AP.CURR_POST, O.ID_CURRENCY, AP.DATE_POST, ACC.ID_HOTEL) CR)),
               c.ROUND_TO) as OUTGO_VALUE,
       AP.ID_ACCOUNT_POST as ID_ACCOUNT_POST,
       null as ID_ACCOUNT_POST$PMS,
       AP.ID_SERVICE as ID_SERVICE,
       iif(AP.IS_ANUL = 0, 11, 22) as POST_STATUS,
       AP.IS_ANUL as IS_ANUL,
       E.DESCRIPTION as DESCRIPTION_EVENT,
       E.ID_PMS_EVENT as ID_PMS_EVENT,
       0 as IS_INVOICED,
       coalesce(E.DOC_DESCRIPTION, E.ID_DOC_HEAD) as DOC_DESCRIPTION,
       AP.ID_ROOM,
       --(iif(O.ID_RENTAL_POOL_UNIT is null, E.ROOM_OWNERSHIP_PERCENT, 0)) as OWNER_PERC,
       iif(O.ID_RENTAL_POOL_UNIT is null, ro.OWNERSHIP_PERCENT, 0) as OWNER_PERC,
       ACC.ID_PROFILE as ID_OWNER,
       iif(O.ID_RENTAL_POOL_UNIT is null, 0, 1) as IS_POOL,
       ACC.ID_HOTEL,
       null as IS_OWNER_INCOME
from ACCOUNT ACC
  join ACCOUNT_POST AP on ACC.ID_ACCOUNT = AP.ID_ACCOUNT
  join OWNER$PMS O on O.ID_OWNER = ACC.ID_PROFILE
  join CURRS c on C.CURR = O.ID_CURRENCY
  left outer join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
  left outer join PMS_EVENT$PMS E on PP.ID_PMS_EVENT = E.ID_PMS_EVENT
  left outer join ROOM_OWNER$PMS ro on ro.ID_ROOM_CONTRACT = e.ID_ROOM_CONTRACT and ro.ID_OWNER = o.ID_OWNER
where ACC.IS_PMS_ACCOUNT = 1
      and ((PP.ID_PMS_EVENT_POST is null) or (PP.LINE_STATUS in (11,22)))
      and AP.AC in ('00', '10')
;

COMMENT ON COLUMN OWNER_POST.POST_STATUS IS
'11  
22  ';

/* Create index... */
CREATE INDEX PROFILE_MERGE_NAME_IDX ON PROFILE COMPUTED BY(upper(trim(MERGE_NAME)));

CREATE INDEX PROFILE_MERGE_NUM_ALT_IDX ON PROFILE COMPUTED BY(upper(trim(MERGE_IDENT_NUM_ALT)));

CREATE INDEX PROFILE_MERGE_NUM_IDX ON PROFILE COMPUTED BY(upper(trim(MERGE_IDENT_NUM)));


/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_ADD$INT for: ACCOUNT_CHECK_CREDIT_STATUS$INT */
SET TERM ^ ;

ALTER PROCEDURE ACCOUNT_POSTING_ADD$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_GUEST /* TYPE OF ID_REF */ INTEGER,
ID_SECQUENCE /* TYPE OF ID_REF */ INTEGER,
DATE_POST /* TYPE OF TDATE */ DATE,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_TARIFF /* TYPE OF ID_REF */ INTEGER,
ID_ROOM /* TYPE OF ID_REF */ INTEGER,
IS_BASE /* TYPE OF TLOGICAL */ SMALLINT,
QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
ORIG_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
RATE /* TYPE OF TRATE */ NUMERIC(15,6),
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
CHANGED_TEXT /* TYPE OF TTEXT_SHORT */ VARCHAR(30),
ID_MASTER_ADDINS_ACC_POST /* TYPE OF ID_REF */ INTEGER,
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
NEW_ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE$INT for: ACCOUNT_CHECK_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE$INT(AP_DBKEY /* TYPE OF TDB_KEY */ CHAR(8),
ID_SERVICE /* TYPE OF ID_REF */ INTEGER,
ID_TARIFF /* TYPE OF ID_REF */ INTEGER,
ID_ROOM /* TYPE OF ID_REF */ INTEGER,
QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
QTY_FREE /* TYPE OF TQTY */ NUMERIC(15,2),
PRICE /* TYPE OF TVALUE */ DOUBLE PRECISION,
CURR /* TYPE OF TCURRENCY */ CHAR(3),
RATE /* TYPE OF TRATE */ NUMERIC(15,6),
CHANGED_TEXT VARCHAR(40),
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
IS_CONSEQUENTIAL_UPDATE /* TYPE OF TBOOLEAN */ SMALLINT = 0,
RE_ROUTE_ACCOUNT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(OUT_QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
OUT_PRICE_POST /* TYPE OF TVALUE */ DOUBLE PRECISION,
OUT_AC VARCHAR(2))
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_CHECK_CREDIT_STATUS$INT) */
ALTER PROCEDURE ACCOUNT_CHECK_CREDIT_STATUS$INT(ID_ACCOUNT TYPE OF ID_REF,
POST_VALUE TYPE OF TPRICE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_credit_account integer;
  declare variable id_reserv_detail integer;
  declare variable credit_limit tprice;
  declare variable b_post_sum tprice;
  declare variable b_pay_sum tprice;
  declare variable difference_value tprice;
  declare variable no_use varchar(255);
  declare variable account_currency tcurrency;
  declare variable round_to numeric(15,4);
begin
  if (:POST_VALUE = 0) then exit;

  select a.IS_CREDIT_ACCOUNT, a.CREDIT_LIMIT, a.ID_RESERV_DETAIL
  from   ACCOUNT A
  where  a.ID_ACCOUNT = :ID_ACCOUNT
  into   :is_credit_account, :credit_limit, :id_reserv_detail;

  if (:is_credit_account = 0
      and exists (select rd.ID_RESERV_DETAIL
                  from   RESERV_DETAIL rd
                  where  rd.ID_RESERV_DETAIL = :id_reserv_detail
                         and rd.CHECK_STATUS = 1)) then
  begin
    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, :credit_limit, 1);
  end

  if (coalesce(:credit_limit, 0) > 0) then begin
    /* FIND BALANCE OF ACCOUNT */
    execute procedure ACCOUNT_BALANCE$INT(:id_account)
    returning_values  :account_currency, :round_to, :no_use, :b_post_sum, :b_pay_sum, :no_use, :no_use;
    b_post_sum = coalesce(:b_post_sum, 0);
    b_pay_sum  = coalesce(:b_pay_sum, 0);

    /* IS THIS POST IS IN LIMIT */
    if ((:b_post_sum + :POST_VALUE) > :credit_limit) then begin
      err_code = -13; /*  */
      difference_value = :b_post_sum + :POST_VALUE - :credit_limit;
      err_text = f_character(29)||FormatFloat(:credit_limit, :round_to)||' '||:account_currency||
                 f_character(28)||FormatFloat(:difference_value, :round_to);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_ACCOUNT$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
QTY /* TYPE OF TQTY */ NUMERIC(15,2),
ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
DATE_POST /* TYPE OF TDATE */ DATE,
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ROOM /* TYPE OF ID */ INTEGER = null,
POST_DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_GUEST$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ACCOUNT_ROUTING /* TYPE OF TSHORT_CODE */ VARCHAR(10),
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_TAR_CALC_REPOST$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE RES_TAR_CALC_REPOST$INT(ID_TAR_CALC /* TYPE OF ID_REF */ INTEGER,
ID_RESERV_DETAIL /* TYPE OF ID_REF */ INTEGER,
RECALC_MARKER VARCHAR(40))
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_ADD$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_ADD$INT(ID_ACCOUNT TYPE OF ID,
ID_GUEST TYPE OF ID_REF,
ID_SECQUENCE TYPE OF ID_REF,
DATE_POST TYPE OF TDATE,
ID_SERVICE TYPE OF ID,
ID_TARIFF TYPE OF ID_REF,
ID_ROOM TYPE OF ID_REF,
IS_BASE TYPE OF TLOGICAL,
QTY_POST TYPE OF TQTY,
PRICE TYPE OF TPRICE,
ORIG_CURRENCY TYPE OF TCURRENCY,
RATE TYPE OF TRATE,
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
POST_TEXT TYPE OF TDESCRIPTION_SHORT,
RESOURCE_TEXT TYPE OF TREASON,
CHANGED_TEXT TYPE OF TTEXT_SHORT,
ID_MASTER_ADDINS_ACC_POST TYPE OF ID_REF,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
NEW_ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable price_post double precision;
  declare variable post_rate numeric (15, 6);
  declare variable curr_post char(3);
  declare variable account_currency char(3);
  declare variable id_pack_service integer;
  declare variable id_room_type integer;
  declare variable room_name varchar(30);
  declare variable is_archive integer;
  declare variable id_tax_policy integer;
  declare variable id_sale_taxation integer;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable check_option varchar(255);
  declare variable id_hotel integer;
  declare variable id_srv_hotel integer;
  declare variable service_name varchar(30);
  declare variable account_name varchar(50);
begin
  ID_GUEST = nullif(:ID_GUEST, -1);

  execute procedure POST_PRICE_CHECK$INT (:QTY_POST, :PRICE, :ORIG_CURRENCY);

  if ( (:IS_BASE = 1) or (:ID_MASTER_ADDINS_ACC_POST > 0) ) then
    check_option = 'IS_BASE;ALLOW_POSTING';
  else
    check_option = 'IS_EXTRA;ALLOW_POSTING';

  execute procedure ACCOUNT_VALIDATE$INT(:id_account, :check_option)
  returning_values  (:err_code, :err_text, :account_currency, :id_tax_policy, :id_hotel, :account_name);
  if (:err_code < 0) then EXIT; --  exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;

  select s.ID_HOTEL, s.SERVICE_NAME
  from   SERVICES S
  where  s.ID_SERVICE = :ID_SERVICE
  into   :id_srv_hotel, :service_name;

  if (:id_srv_hotel is distinct from :id_hotel) then
    exception POSTING_EXCEPTION '-1056' || f_character(31) || f_character(29) || :service_name || f_character(28) || :account_name;

  if (:rate is null) then begin
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :orig_currency, :date_post, :id_guest)
    returning_values  :rate;
  end

  curr_post  = :account_currency;
  if (:orig_currency = :account_currency) then begin
    post_rate  = :rate;
  end else begin
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :account_currency, :date_post, :id_guest)
    returning_values  :post_rate;
  end

  execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :id_tax_policy, :ID_TARIFF, :DATE_POST - :FROM_DATE)
  returning_values (:id_sale_taxation);

  execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:QTY_POST, :PRICE,
                    :RATE, :post_rate, :id_sale_taxation)
  returning_values  :price_post, :post_net_value, :post_gross_value;

  execute procedure ACCOUNT_CHECK_CREDIT_STATUS$INT (:ID_ACCOUNT, :price_post * :QTY_POST)
  returning_values (:ERR_CODE, :ERR_TEXT);
  if (:ERR_CODE <> 0) then exit;

  --
  new_id_account_post = gen_id (id_account_post_gen, 1);

  if (:post_text starting with 'PACK') then begin
    id_pack_service = substring(:post_text from 6 for 20);
    post_text = '';
  end else begin
    id_pack_service = -1;
  end
  if (:is_base = 1) then id_master_addins_acc_post = :new_id_account_post;

  select R.ROOM_NAME, R.ID_ROOM_TYPE
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :room_name, :id_room_type;

  if (:id_guest is null) then begin
    is_archive = 1;
  end else begin
    select iif(G.CHECK_STATUS = 1, 1, 0)
    from   GUEST G
    where  G.ID_GUEST = :id_guest
    into   :is_archive;
  end

  insert into ACCOUNT_POST (
    ID_ACCOUNT_POST, ID_ACCOUNT, ID_GUEST, ID_SERVICE, ID_TARIFF, ID_ROOM,
    IS_BASE, DATE_POST, QTY_POST, QTY_FREE, PRICE_POST, POST_NET_VALUE, POST_GROSS_VALUE, CURR_POST, RATE_POST,
    PRICE_ORIG, CURR_ORIG, RATE_ORIG, IS_LOCKED_FOR_UPDATE, TO_DATE, FROM_DATE, ID_SEQUENCE,
    SHORT_CODE, CHANGED_TEXT, ID_MASTER_ADDINS_ACC_POST, ID_PACK_SERVICE, ROOM_NAME, ID_ROOM_TYPE,
    ID_SALE_TAXATION, AC, IS_ARCHIVE, IN_DOC_QTY, IN_DOC_VALUE, DESCRIPTION)
  values (
    :new_id_account_post, :id_account, :id_guest, :id_service, :id_tariff, coalesce(:id_room, -1),
    :is_base, :date_post, :qty_post, 0, :price_post, :post_net_value, :post_gross_value, :curr_post, :post_rate,
    :price, :orig_currency, :rate, 0, :TO_DATE, :FROM_DATE, :id_secquence,
    :short_code, :changed_text, :id_master_addins_acc_post, :id_pack_service, :room_name, :id_room_type,
    :id_sale_taxation, '00', :is_archive, 0, 0, :DESCRIPTION);

  if ((coalesce(:post_text, '') <> '') or (coalesce(:resource_text, '') <> '')) then begin
    insert into ACCOUNT_POSTING_DET (ID_ACCOUNT_POST, POST_TEXT, QTY, FROM_DATETIME, TO_DATETIME, RESOURCE_TEXT)
    values (:new_id_account_post, :post_text, :qty_post, :FROM_DATE, :TO_DATE, :resource_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_TRANSFER$INT for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE_PERC for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_PERC(IN_ID_ACCOUNT_POST VARCHAR(4000),
IN_PERC NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(30))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_POSTING$INT for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_POSTING$INT(ID_RESOURCE_RESERVATION /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
PRICE_DESCRIPTION /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
ID_RESERV_DETAIL /* TYPE OF ID */ INTEGER,
ID_EXTERNAL_CLIENT_ACCCOUNT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(DOC_SELECTED /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_POSTING_UPDATE$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE$INT(AP_DBKEY TYPE OF TDB_KEY,
ID_SERVICE TYPE OF ID_REF,
ID_TARIFF TYPE OF ID_REF,
ID_ROOM TYPE OF ID_REF,
QTY_POST TYPE OF TQTY,
QTY_FREE TYPE OF TQTY,
PRICE TYPE OF TVALUE,
CURR TYPE OF TCURRENCY,
RATE TYPE OF TRATE,
CHANGED_TEXT VARCHAR(40),
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
IS_CONSEQUENTIAL_UPDATE TYPE OF TBOOLEAN = 0,
RE_ROUTE_ACCOUNT TYPE OF ID_REF = null)
 RETURNS(OUT_QTY_POST TYPE OF TQTY,
OUT_PRICE_POST TYPE OF TVALUE,
OUT_AC VARCHAR(2))
 AS
declare variable date_post date;
  declare variable orig_is_base integer;
  declare variable orig_id_service integer;
  declare variable orig_id_room integer;
  declare variable orig_short_code varchar(255);
  declare variable orig_qty_post integer;
  declare variable orig_ac varchar(2);
  declare variable is_locked_for_update integer;
  declare variable orig_locked_for_update integer;
  declare variable orig_id_tariff integer;
  declare variable orig_id_guest integer;
  declare variable id_type_stay integer;
  declare variable id_room_type integer;
  declare variable id_board integer;
  declare variable id_pack_service integer;
  declare variable new_id_pack_service integer;
  declare variable post_currency char(3);
  declare variable room_name varchar(30);
  declare variable original_post varchar(30);
  declare variable new_ac varchar(2);
  declare variable orig_in_doc_qty numeric(15,2);
  declare variable orig_in_doc_value double precision;
  declare variable rate_post numeric(15,6);
  declare variable id_base_doc integer;
  declare variable id_tax_policy integer;
  declare variable price_post double precision;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable id_sale_taxation integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable orig_price_post tprice;
  declare variable round_to numeric(15,4);
  declare variable account_name tobject_name;
  declare variable err_code integer;
  declare variable err_text varchar(100);
  declare variable id_account integer;
begin
  /* GET DATA */
  original_post = '';
  new_id_pack_service = null;

  select AP.DATE_POST, AP.IS_BASE, AP.ID_SERVICE, AP.ID_BASE_DOC,
         AP.SHORT_CODE, AP.QTY_POST, ap.PRICE_POST, AP.IS_LOCKED_FOR_UPDATE,
         AP.AC, AP.ID_TARIFF, AP.ID_GUEST, AP.ID_ROOM,
         AP.CURR_POST, AP.ID_PACK_SERVICE, AP.ID_ROOM_TYPE,
         AP.IN_DOC_QTY, AP.IN_DOC_VALUE, AP.RATE_POST, ap.ID_SALE_TAXATION, ap.ID_ACCOUNT, ap.ID_ACCOUNT_POST
  from   ACCOUNT_POST AP
  where  AP.rdb$db_key = :AP_DBKEY
  into   :date_post, :orig_is_base, :orig_id_service, :id_base_doc,
         :orig_short_code, :orig_qty_post, :orig_price_post, :orig_locked_for_update,
         :orig_ac, :orig_id_tariff, :orig_id_guest, :orig_id_room,
         :post_currency, :id_pack_service, :id_room_type,
         :orig_in_doc_qty, :orig_in_doc_value, :rate_post, :id_sale_taxation, :id_account, :id_account_post;

  if (:RE_ROUTE_ACCOUNT is not null and :id_base_doc is null) then id_account = :RE_ROUTE_ACCOUNT;  -- IMPORTANT !!! Re-routing is possible only in this case!

  is_locked_for_update = :orig_locked_for_update; /* to initialize and preserve from null */

  execute procedure ACCOUNT_VALIDATE$INT(:id_account, 'ALLOW_POSTING;')
  returning_values  (:err_code, :err_text, :post_currency, :id_tax_policy, :id_hotel, :account_name);
  if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;

  if (:IS_CONSEQUENTIAL_UPDATE is distinct from 1) then begin
    -- direct post update - manual edition restrictions check
    if (:QTY_POST = -1) then QTY_POST = :orig_qty_post;   -- preserve current qty

    if (:QTY_POST <> :orig_qty_post) then exception POSTING_EXCEPTION '-379';

    if ((:orig_is_base = 1) and ((:QTY_POST <> 1) or (:ID_SERVICE <> :orig_id_service))) then
      exception POSTING_EXCEPTION '-223';

    if (:orig_ac = '01') then execute procedure RIGHTS_CHECK_GRANTED$INT('BALANCES_EDIT_CLOSED');

    short_code = :orig_short_code;
    id_tariff  = :orig_id_tariff;
    id_room    = :orig_id_room;
    is_locked_for_update = 1;  /* manual corrections must lock the postings  */

  end else begin
    /* post changes is a result from some user operation, indirect update ('NORMAL', 'FORCED', safes recalc, etc....) */
    is_locked_for_update = 0;

    if (:orig_is_base = 1) then begin
      /* PREPARING THE PACKET SERVICE */
      select S.ID_TYPE_STAY, S.ID_ROOM_TYPE
      from   SERVICE_PACKET S
      where  S.ID_SERVICE = :id_service
      into   :id_type_stay, :id_room_type;

      select GS.ID_BOARD
      from   GUEST_STAY GS
      where  GS.ID_GUEST = :orig_id_guest
             and GS.FOR_DATE = :date_post
      into   :id_board;

      execute procedure TAR_GET_BASE_SERVICE$INT(:id_type_stay, :id_room_type, :id_board, :id_hotel)
      returning_values  :id_pack_service;
      /* detecting change of STAY_TYPE or ROOM_TYPE */
      if (exists(
        select *
        from   SERVICE_PACKET S
        where  S.ID_SERVICE = :orig_id_service
               and ((S.ID_TYPE_STAY is distinct from :id_type_stay) or (S.ID_ROOM_TYPE is distinct from :id_room_type))
      )) then original_post = 'CHANGED';
    end
  end

  select R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :room_name;

  if (:orig_locked_for_update = 1
      and :changed_text starting with 'NORMALRECALC'
      and :id_service = :orig_id_service
      --and :orig_is_anul = 0
      and :id_tariff = :orig_id_tariff) then
  begin
    -- price is locked for update
    update ACCOUNT_POST AP
    set    AP.ID_ROOM      = :id_room,
           AP.ROOM_NAME    = :room_name,
           Ap.FROM_DATE    = :from_date,
           Ap.TO_DATE      = :to_date,
           AP.CHANGED_TEXT = :changed_text,
           AP.USER_CHANGED = current_user,
           AP.DATETIME_CHANGED = current_timestamp
    where  AP.rdb$db_key   = :AP_DBKEY;
    OUT_QTY_POST = :orig_qty_post;
    OUT_PRICE_POST = :orig_price_post;
    OUT_AC = :orig_ac;
  end else begin
    -- fully update
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :curr, :date_post, :orig_id_guest)
    returning_values  :rate;
  
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :post_currency, :date_post, :orig_id_guest)
    returning_values  :rate_post;
  
    if (:id_base_doc is null) then begin
      execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :id_tax_policy, :ID_TARIFF, :date_post - :from_date)
      returning_values (:id_sale_taxation);
    end

    execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:QTY_POST, :PRICE,
                      :RATE, :rate_post, :id_sale_taxation)
    returning_values  :price_post, :post_net_value, :post_gross_value;

    select c.ROUND_TO
    from   CURRS c
    where  c.CURR = :post_currency
    into   :round_to;

    if ( (:id_base_doc is not null)
         and (:qty_post = :orig_in_doc_qty)
         and (round_f(:price_post * :qty_post - :orig_in_doc_value * :orig_in_doc_qty, :round_to) = 0))
    then new_ac = '01';
    else new_ac = '00';                   
  
    if (:new_ac = '00') then begin
      execute procedure ACCOUNT_CHECK_CREDIT_STATUS$INT (:id_account, :price_post * :QTY_POST - :orig_price_post * :orig_qty_post)
      returning_values (:err_code, :err_text);
      if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;
    end

    update ACCOUNT_POST AP
    set    AP.ID_ACCOUNT           = :id_account,
           AP.ID_SERVICE           = :id_service,
  
           AP.QTY_POST             = :qty_post,
           AP.QTY_FREE             = :qty_free,
           AP.PRICE_POST           = :price_post,
           AP.CURR_POST            = :post_currency,
           AP.RATE_POST            = :rate_post,
           AP.RATE_ORIG            = :rate,
           AP.PRICE_ORIG           = :price,
           AP.CURR_ORIG            = :curr,
           AP.POST_NET_VALUE       = :post_net_value,
           AP.POST_GROSS_VALUE     = :post_gross_value,
  
           AP.AC                   = :new_ac,
           AP.IS_ANUL              = 0,
           AP.ANUL_REASON          = '',
           AP.IS_LOCKED_FOR_UPDATE = :is_locked_for_update,
           AP.ID_TARIFF            = :id_tariff,
           AP.ID_PACK_SERVICE      = :id_pack_service,
           AP.ID_ROOM              = :id_room,
           AP.ID_ROOM_TYPE         = :id_room_type,
           AP.ROOM_NAME            = :room_name,
           AP.ID_SALE_TAXATION     = :id_sale_taxation,
           AP.ORIGINAL_POST        = :original_post,
           AP.SHORT_CODE           = :short_code,
           AP.CHANGED_TEXT         = :changed_text,
           AP.USER_CHANGED         = current_user,
           AP.DATETIME_CHANGED     = current_timestamp,
           Ap.FROM_DATE            = :from_date,
           Ap.TO_DATE              = :to_date
    where  AP.rdb$db_key = :AP_DBKEY
    returning new.id_account_post, new.id_pack_service
    into   :id_account_post, :new_id_pack_service;
  
    if (:new_ac = '01') then begin
      update ACCOUNT_POST_CORRECTION APC
      set    APC.IS_OPEN = 0
      where  APC.ID_ACCOUNT_POST = :id_account_post
             and APC.IS_OPEN = 1;
    end

    if (:orig_is_base = 1 and :new_id_pack_service <> :id_pack_service) then begin
      -- update add_inses with new pack service
      update ACCOUNT_POST AP
      set    ap.ID_PACK_SERVICE = :new_id_pack_service
      where  ap.ID_MASTER_ADDINS_ACC_POST = :id_account_post
             and ap.IS_BASE = 0;
    end

    OUT_QTY_POST = :qty_post;
    OUT_PRICE_POST = :price_post;
    OUT_AC = :new_ac;
  end
end
^

/* Alter (ACCOUNT_POSTING_UPDATE_PERC) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_PERC(IN_ID_ACCOUNT_POST VARCHAR(4000),
IN_PERC NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(30))
 AS
declare variable id_account_post integer;
  declare variable ap_dbkey char(8);
  declare variable id_service integer;
  declare variable id_tariff integer;
  declare variable id_room integer;
  declare variable qty_post numeric (15,4);
  declare variable qty_free numeric (15,4);
  declare variable short_code varchar(255);
  declare variable orig_currency char(3);
  declare variable orig_rate numeric (15,4);
  declare variable orig_price numeric (15,4);
  declare variable new_orig_price double precision;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  for
    select item
    from   SYSTEM_STRING_PARSER(:in_id_account_post, ',')
    into   :id_account_post
  do begin
    select AP.rdb$db_key, AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST,
           AP.QTY_FREE, AP.SHORT_CODE, AP.CURR_ORIG, AP.RATE_ORIG, AP.PRICE_ORIG,
           ap.FROM_DATE, ap.TO_DATE
    from   ACCOUNT_POST AP
    where  AP.ID_ACCOUNT_POST = :id_account_post
    into   :ap_dbkey, :id_service, :id_tariff, :id_room, :qty_post,
           :qty_free, :short_code, :orig_currency, :orig_rate, :orig_price,
           :from_date, :to_date;

    new_orig_price = :orig_price + :orig_price * :in_perc;

    execute procedure ACCOUNT_POSTING_UPDATE$INT(:ap_dbkey,
            :id_service, :id_tariff, :id_room,
            :qty_post, :qty_free, :new_orig_price, :orig_currency, :orig_rate,
            :in_changed_text, :short_code, :from_date, :to_date)
    returning_values  :no_use, :no_use, :no_use;
  end
end
^

/* empty dependent procedure body */
/* Clear: DOC_CONTRAGENT_SET$DOC for: CONTRAGENT_MODIFY$CONTR */
ALTER PROCEDURE DOC_CONTRAGENT_SET$DOC(ID_DOC INTEGER,
IS_PAY_DOC SMALLINT,
ID_CONTRAGENT INTEGER,
IS_JURIDICAL_PERSON SMALLINT,
CONTRAGENT_NAME VARCHAR(100),
VAT_REG_NUM VARCHAR(30),
IDENT_NO VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
POST_ADDRESS VARCHAR(100),
ZIP_CODE VARCHAR(10),
EMAIL VARCHAR(50),
MOL VARCHAR(30),
RECIPIENT_NAME VARCHAR(100),
RECIPIENT_PAS_NUM VARCHAR(20),
RECIPIENT_PAS_DATE DATE,
RECIPIENT_PAS_FROM VARCHAR(30),
RECIPIENT_LETTER VARCHAR(30),
NUM_DOGOVOR VARCHAR(30),
NUM_SPECIF VARCHAR(30),
ADD_PERMANENTLY SMALLINT,
BANK_NAME VARCHAR(50),
BIC VARCHAR(30),
IBAN VARCHAR(30))
 RETURNS(ID_DOC_CONTRAGENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_CONTRAGENT$EXC for: CONTRAGENT_MODIFY$CONTR */
ALTER PROCEDURE IMPORT_CONTRAGENT$EXC(CONTRAGENT_NAME VARCHAR(100),
IS_JURIDICAL_PERSON SMALLINT,
IDENT_NO VARCHAR(20),
VAT_REG_NUM VARCHAR(30),
POST_ADDRESS VARCHAR(100),
ZIP_CODE VARCHAR(10),
EMAIL VARCHAR(50),
MOL VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
BANK_NAME VARCHAR(50),
BIC VARCHAR(30),
IBAN VARCHAR(30),
UUID VARCHAR(40),
CREATE_ONLY SMALLINT)
 RETURNS(ID_CONTRAGENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (CONTRAGENT_MODIFY$CONTR) */
ALTER PROCEDURE CONTRAGENT_MODIFY$CONTR(ID_CONTRAGENT INTEGER,
CONTRAGENT_NAME VARCHAR(100),
IS_JURIDICAL_PERSON SMALLINT,
IDENT_NO VARCHAR(30),
VAT_REG_NUM VARCHAR(30),
POST_ADDRESS VARCHAR(100),
ZIP_CODE VARCHAR(10),
EMAIL VARCHAR(50),
MOL VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
BANK_NAME VARCHAR(50),
BIC VARCHAR(30),
IBAN VARCHAR(30))
 RETURNS(NEW_ID_CONTRAGENT INTEGER)
 AS
declare variable id_profile integer;
begin

  if (:ID_CONTRAGENT is null) then begin
    insert into CONTRAGENTS (CONTRAGENT_NAME, IS_JURIDICAL_PERSON,
           IDENT_NO, VAT_REG_NUM, POST_ADDRESS, ZIP_CODE,
           MOL, BANK_NAME, BIC, IBAN, COUNTRY, EMAIL)
    values (:CONTRAGENT_NAME, :IS_JURIDICAL_PERSON,
           :IDENT_NO, :VAT_REG_NUM, :POST_ADDRESS, :ZIP_CODE,
           :MOL, :BANK_NAME, :BIC, :IBAN, :COUNTRY_CODE, :EMAIL)
    returning ID_CONTRAGENT into :NEW_ID_CONTRAGENT;
  end else begin
    update CONTRAGENTS C
    set    C.CONTRAGENT_NAME = :CONTRAGENT_NAME,
           C.IS_JURIDICAL_PERSON = :IS_JURIDICAL_PERSON,
           C.IDENT_NO = :IDENT_NO,
           C.VAT_REG_NUM = :VAT_REG_NUM,
           C.POST_ADDRESS = :POST_ADDRESS,
           C.ZIP_CODE = :ZIP_CODE,
           C.MOL = :MOL,
           C.COUNTRY = :COUNTRY_CODE,
           C.BANK_NAME = :BANK_NAME,
           C.BIC = :BIC,
           C.IBAN = :IBAN,
           C.EMAIL = :EMAIL
    where  C.ID_CONTRAGENT = :ID_CONTRAGENT;
    NEW_ID_CONTRAGENT = :ID_CONTRAGENT;
  end

  for
    select p.ID_PROFILE
    from   PROFILE p
    where  p.ID_DEF_CONTRAGENT = :ID_CONTRAGENT
           and p.PROFILE_TYPE = 'AGENT'
    into   :id_profile
  do begin
    update PROFILE p
    set    p.MERGE_IDENT_NUM = trim(:IDENT_NO),
           p.MERGE_IDENT_NUM_ALT = trim(:VAT_REG_NUM)
    where  p.ID_PROFILE = :id_profile;
  end
end
^

/* empty dependent procedure body */
/* Clear: DOC_CONTRAGENT_INITIALIZE$INT for: DOC_CONTRAGENT_SET$DOC */
ALTER PROCEDURE DOC_CONTRAGENT_INITIALIZE$INT(ID_DOC INTEGER,
IS_PAY_DOC SMALLINT,
ID_PROFILE INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (DOC_CONTRAGENT_SET$DOC) */
ALTER PROCEDURE DOC_CONTRAGENT_SET$DOC(ID_DOC INTEGER,
IS_PAY_DOC SMALLINT,
ID_CONTRAGENT INTEGER,
IS_JURIDICAL_PERSON SMALLINT,
CONTRAGENT_NAME VARCHAR(100),
VAT_REG_NUM VARCHAR(30),
IDENT_NO VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
POST_ADDRESS VARCHAR(100),
ZIP_CODE VARCHAR(10),
EMAIL VARCHAR(50),
MOL VARCHAR(30),
RECIPIENT_NAME VARCHAR(100),
RECIPIENT_PAS_NUM VARCHAR(20),
RECIPIENT_PAS_DATE DATE,
RECIPIENT_PAS_FROM VARCHAR(30),
RECIPIENT_LETTER VARCHAR(30),
NUM_DOGOVOR VARCHAR(30),
NUM_SPECIF VARCHAR(30),
ADD_PERMANENTLY SMALLINT,
BANK_NAME VARCHAR(50),
BIC VARCHAR(30),
IBAN VARCHAR(30))
 RETURNS(ID_DOC_CONTRAGENT INTEGER)
 AS
declare variable doc_num varchar(20);
begin

  if (:IS_PAY_DOC = 1) then begin
    select P.ID_DOC_CONTRAGENT, P.PAYMENT_NUM
    from   PAYMENT_HEAD P
    where  p.ID_PAYMENT_HEAD = :ID_DOC
    into   :id_doc_contragent, :doc_num;
  end else begin
    select D.ID_DOC_CONTRAGENT, D.DOC_NUM
    from   DOC_HEAD$INT D
    where  D.ID_DOC_HEAD = :ID_DOC
    into   :id_doc_contragent, :doc_num;
  end

  if (trim(:doc_num) <> '') then
    exception DOCUMENT_EXCEPTION '-354'; --'Cannot edit valid document!';
   
  if (:IS_JURIDICAL_PERSON = 1 and ((:ID_CONTRAGENT is null) or (:ADD_PERMANENTLY = 1)) ) then begin
    execute procedure CONTRAGENT_MODIFY$CONTR (:ID_CONTRAGENT, :CONTRAGENT_NAME,
            :IS_JURIDICAL_PERSON, :IDENT_NO, :VAT_REG_NUM, :POST_ADDRESS, :ZIP_CODE, :EMAIL,
            :MOL, :COUNTRY_CODE, :BANK_NAME, :BIC, :IBAN)
    returning_values (:ID_CONTRAGENT);
  end

  if (:id_doc_contragent is null) then begin
    id_doc_contragent = gen_id(GEN_DOC_CONTRAGENT_ID, 1);
    insert into DOC_CONTRAGENT (
         ID_DOC_CONTRAGENT, ID_CONTRAGENT, IS_JURIDICAL_PERSON, CONTRAGENT_NAME,
         VAT_REG_NUM, IDENT_NO, POST_ADDRESS, ZIP_CODE, COUNTRY_CODE,
         MOL, RECIPIENT_NAME, RECIPIENT_PAS_NUM, RECIPIENT_PAS_DATE, RECIPIENT_PAS_FROM,
         RECIPIENT_LETTER, NUM_DOGOVOR, NUM_SPECIF, BANK_NAME, BIC, IBAN, EMAIL)
    values (:ID_DOC_CONTRAGENT, :ID_CONTRAGENT, :IS_JURIDICAL_PERSON, :CONTRAGENT_NAME,
         :VAT_REG_NUM, :IDENT_NO, :POST_ADDRESS, :ZIP_CODE, :COUNTRY_CODE,
         :MOL, :RECIPIENT_NAME, :RECIPIENT_PAS_NUM, :RECIPIENT_PAS_DATE, :RECIPIENT_PAS_FROM,
         :RECIPIENT_LETTER, :NUM_DOGOVOR, :NUM_SPECIF, :BANK_NAME, :BIC, :IBAN, :EMAIL);

    if (:IS_PAY_DOC = 1) then begin
      update PAYMENT_HEAD P
      set    P.ID_DOC_CONTRAGENT = :id_doc_contragent
      where  P.ID_PAYMENT_HEAD = :ID_DOC;
    end else begin
      update DOC_HEAD$INT D
      set    D.ID_DOC_CONTRAGENT = :id_doc_contragent
      where  D.ID_DOC_HEAD = :ID_DOC;
    end

  end else begin
    update DOC_CONTRAGENT DC
    set    DC.ID_CONTRAGENT = :ID_CONTRAGENT,
           DC.IS_JURIDICAL_PERSON = :IS_JURIDICAL_PERSON,
           DC.CONTRAGENT_NAME = :CONTRAGENT_NAME,
           DC.VAT_REG_NUM = :VAT_REG_NUM,
           DC.IDENT_NO = :IDENT_NO,
           DC.POST_ADDRESS = :POST_ADDRESS,
           DC.ZIP_CODE = :ZIP_CODE,
           DC.COUNTRY_CODE = :COUNTRY_CODE,
           dc.EMAIL = :EMAIL,
           DC.MOL = :MOL,
           DC.RECIPIENT_NAME = :RECIPIENT_NAME,
           DC.RECIPIENT_PAS_NUM = :RECIPIENT_PAS_NUM,
           DC.RECIPIENT_PAS_DATE = :RECIPIENT_PAS_DATE,
           DC.RECIPIENT_PAS_FROM = :RECIPIENT_PAS_FROM,
           DC.RECIPIENT_LETTER = :RECIPIENT_LETTER,
           DC.NUM_DOGOVOR = :NUM_DOGOVOR,
           DC.NUM_SPECIF = :NUM_SPECIF,
           DC.BANK_NAME = :BANK_NAME,
           DC.BIC = :BIC,
           DC.IBAN = :IBAN
    where  DC.ID_DOC_CONTRAGENT = :ID_DOC_CONTRAGENT;
  end
end
^

/* Alter (EAI_POS_GET_GUESTS$P2E) */
ALTER PROCEDURE EAI_POS_GET_GUESTS$P2E(IN_ROOM_NAME VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(OUT_ID_GUEST INTEGER,
OUT_GUEST_NAME VARCHAR(100),
OUT_FROM_DATE DATE,
OUT_TO_DATE DATE,
OUT_OK_FOR_POST INTEGER,
OUT_COUNTRY VARCHAR(30),
OUT_TEXT VARCHAR(100),
OUT_BOARD_NAME VARCHAR(30),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100))
 AS
declare variable id_room integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  OUT_GUEST_NAME = null;

  /*FIND ROOM*/
  select R.ID_ROOM
  from   ROOMS R
         join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
  where  R.ROOM_NAME = :IN_ROOM_NAME
         and RT.ID_HOTEL = :ID_HOTEL
  into   :ID_ROOM;
  if ((:ID_ROOM is null) or (:ID_ROOM <= 0) ) then begin
    ERR_CODE = -5;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Room number not found!    ! ';
    suspend;
    exit;
  end

  /*FIND GUESTS*/
  for
    select G.ID_GUEST, GC.GUEST_NAME1, G.FROM_DATE, G.TO_DATE, C.COUNTRY_NAME,
           (select m.NAME
            from   GUEST_STAY gs
                   join MEALS M on m.ID_BOARD = gs.ID_BOARD
            where  gs.ID_GUEST = g.ID_GUEST
                   and gs.FOR_DATE = iif(current_date = g.to_date, current_date - 1, current_date))
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
           left outer join GUEST_CARD GC on G.ID_GUEST = GC.ID_GUEST
           left outer join COUNTRY C on C.COUNTRY_CODE = GC.COUNTRY
    where  G.ID_ROOM = :ID_ROOM
           and G.CHECK_STATUS = 0
           and rd.IS_ANUL = 0
    into   :OUT_ID_GUEST, :OUT_GUEST_NAME, :OUT_FROM_DATE,  :OUT_TO_DATE, :OUT_COUNTRY, :OUT_BOARD_NAME
  do begin
    OUT_OK_FOR_POST = iif(:OUT_TO_DATE < current_date, 0, 1) ;
    suspend;
  end

  if (:OUT_GUEST_NAME is null) then begin
    ERR_CODE = -1;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Guests not found!     !';
    suspend;
  end
end
^

/* Alter (FISCALIZE_LINE$FISC) */
ALTER PROCEDURE FISCALIZE_LINE$FISC(ID_DOC_HEAD INTEGER,
DETAIL_LEVEL VARCHAR(20),
ADDITIONAL_PAYMENT_TEXT VARCHAR(30) = null)
 RETURNS(FISC_PRICE NUMERIC(15,4),
FISC_QTY NUMERIC(15,4),
FISC_TEXT VARCHAR(30),
FISC_GRP VARCHAR(10),
TRANSACTION_VALUE NUMERIC(15,4))
 AS
declare variable payment_cnt integer;
  declare variable fisc_value_coef double precision;
  declare variable target_fiscal_value numeric(15,2);
  declare variable fiscalized_value numeric(15,4);
  declare variable payment_value numeric(15,4);
  declare variable total_lines integer;
  declare variable lines_cnt integer;
  declare variable tmp_cnt integer;
  declare variable for_deposit integer;
  declare variable adv_payment_lines integer;
  declare variable one_line_text varchar(30);
  declare variable srv_groups integer;
  declare variable doc_rate numeric(15,6);
  declare variable round_to numeric(15,4);
begin
  /*  Description:
  ||
  function fiscalize(const text, taxGroup: string; qty, price, correction: Double): integer;
  function payment(const text, payType: string; summ: Double): integer;
  */
  FISC_PRICE = null;
  FISC_TEXT = null;
  FISC_GRP = null;
  TRANSACTION_VALUE = null;
  FISC_QTY = 1;
  FISCALIZED_VALUE = 0;
  LINES_CNT = 0;
  FISC_VALUE_COEF = 1;

  execute procedure FISCAL_VALUE_GET$INT (:ID_DOC_HEAD)
  returning_values  :target_fiscal_value, :payment_cnt, :payment_value, :fisc_value_coef;

  if (:payment_cnt = 0) then exit;

  doc_rate = null;
  select dh.DOC_RATE, dh.FOR_DEPOSIT, substring(H.DOC_ONE_LINE_TEXT from 1 for 30), c.ROUND_TO
  from   DOC_HEAD DH
         join ACCOUNT A on A.ID_ACCOUNT = dh.ID_ACCOUNT
         join HOTEL H on h.ID_HOTEL = a.ID_HOTEL
         join CURRS c on c.CURR = h.NATION_CURR
  where  DH.ID_DOC = :ID_DOC_HEAD
  into   :doc_rate, :for_deposit, :one_line_text, :round_to;

  select count(dl.ID_DOC_LINE), count(dv.ID_DOC_LINE), count(distinct s.ID_SERVICE_GROUP)
  from   DOC_LINE DL
         join SERVICES S on s.ID_SERVICE = dl.ID_SERVICE
         left outer join DOC_LINE_DEP_VALUES dv on dv.ID_DOC_LINE = dl.ID_DOC_LINE and :for_deposit = 0
  where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :total_lines, :adv_payment_lines, :srv_groups;

  if (:adv_payment_lines > 0 and trim(coalesce(:ADDITIONAL_PAYMENT_TEXT, '')) <> '') then
    DETAIL_LEVEL = 'aditional_payment';

  for
    select case
             when :detail_level = 'aditional_payment' then :ADDITIONAL_PAYMENT_TEXT
             when :DETAIL_LEVEL = 'group' then iif(:srv_groups = 1, SG.GROUP_NAME, :one_line_text)
             else S.SERVICE_NAME
           end,
           lines.fisc_codes,
           round_f(sum(DL.SINGLE_VALUE * DL.QTY_POST * :doc_rate) * :fisc_value_coef, 0.01),
           count(DL.ID_DOC_LINE)
    from   (select l.ID_DOC_LINE,
                   cast(substring(list(trim(coalesce(st.FISCAL_CODE, '')), '') from 1 for 10) as varchar(10)) as fisc_codes
            from   DOC_LINE l
                   join SALE_TAXATION_TAX stt on stt.ID_SALE_TAXATION = l.ID_SALE_TAXATION
                   join SALE_TAXES st on st.ID_SALE_TAX = stt.ID_SALE_TAX
                                         and st.REVENUE_DEDUCTION_TAX is distinct from 1
            where  l.ID_DOC_HEAD = :ID_DOC_HEAD
            group by l.ID_DOC_LINE) lines
           join DOC_LINE DL on dl.ID_DOC_LINE = lines.ID_DOC_LINE
           join SERVICES S on S.ID_SERVICE = DL.ID_SERVICE
           join SERVICE_GROUPS SG on SG.ID_SERVICE_GROUP = S.ID_SERVICE_GROUP
           left outer join DOC_LINE_DEP_VALUES dv on dv.ID_DOC_LINE = dl.ID_DOC_LINE
    group by iif((:DETAIL_LEVEL = 'aditional_payment') or (dv.ID_DOC_LINE is null), 0, 1),
           lines.fisc_codes,
           1
    order by iif((:DETAIL_LEVEL = 'aditional_payment') or (dv.ID_DOC_LINE is null), 0, 1),
           iif(sum(DL.SINGLE_VALUE * DL.QTY_POST * 1) * :fisc_value_coef > 0, 0, 1),  -- pull up positive value lines first
           lines.fisc_codes,
           1
    into   :FISC_TEXT, :FISC_GRP, :FISC_PRICE, :tmp_cnt
  do begin

    lines_cnt = :lines_cnt + :tmp_cnt;
    if (:lines_cnt = :total_lines) then begin
      FISC_PRICE = round_f(:target_fiscal_value, :round_to) - :fiscalized_value;
      -- to fiscalize rest value - in case of mixed fiscal/nonfiscal payments
    end

    if (:FISC_PRICE <> 0) then begin
      TRANSACTION_VALUE = :FISC_PRICE;
      suspend;
    end

    fiscalized_value = :fiscalized_value + :FISC_PRICE;
  end

end
^

/* Alter (FISCALIZE_PAYMENT$FISC) */
ALTER PROCEDURE FISCALIZE_PAYMENT$FISC(ID_DOC_HEAD INTEGER)
 RETURNS(FISC_SUM NUMERIC(15,4),
FISC_TEXT VARCHAR(30),
FISC_GRP VARCHAR(10))
 AS
declare variable sale_fisc_value numeric (15,4);
declare variable total_payment_value numeric (15,4);
  declare variable payment_value numeric (15,4);
  declare variable payment_cnt integer;
  declare variable payment_i integer;
  declare variable reduction_coef double precision;
begin

  execute procedure FISCAL_VALUE_GET$INT (:ID_DOC_HEAD)
  returning_values  :sale_fisc_value, :payment_cnt, :total_payment_value, :reduction_coef;
  if (:payment_cnt = 0) then exit;

  FISC_SUM = null;
  FISC_TEXT = null;
  FISC_GRP = null;
  PAYMENT_VALUE = 0;
  PAYMENT_I = 0;

  for
    select PT.PAYMENT_TYPE,
           substring(PT.FISCAL_CODE from 1 for 10),
           round_f(sum(PH.NAT_VALUE), c.ROUND_TO)
    from   DOCUMENT_PAYMENT PH
           join PAYMENT_TYPE PT on PT.ID_PAYMENT_TYPE = PH.ID_PAYMENT_TYPE
           join PAY_DOC_TYPE_S DT on DT.ID_DOC_TYPE = PH.ID_DOC_TYPE
           join HOTEL h on h.ID_HOTEL = dt.ID_HOTEL
           join CURRS c on c.CURR = h.NATION_CURR
    where  PH.ID_DOC_HEAD = :ID_DOC_HEAD
           and PH.IS_STORNO = 0
           and dt.DOC_DIRECTION = 0
           and DT.IS_FISCALIZE = 1
    group by 1, 2, c.ROUND_TO
    into   :FISC_TEXT, :FISC_GRP, :FISC_SUM
  do begin
    PAYMENT_I = :PAYMENT_I + 1;
    if (:PAYMENT_I < :PAYMENT_CNT) then begin
      PAYMENT_VALUE = :PAYMENT_VALUE + :FISC_SUM;
      suspend;
    end
  end

  FISC_SUM = :total_payment_value - :PAYMENT_VALUE;
  if (:FISC_SUM > 0) then suspend;
end
^

/* Alter (IMPORT_CONTRAGENT$EXC) */
ALTER PROCEDURE IMPORT_CONTRAGENT$EXC(CONTRAGENT_NAME VARCHAR(100),
IS_JURIDICAL_PERSON SMALLINT,
IDENT_NO VARCHAR(20),
VAT_REG_NUM VARCHAR(30),
POST_ADDRESS VARCHAR(100),
ZIP_CODE VARCHAR(10),
EMAIL VARCHAR(50),
MOL VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
BANK_NAME VARCHAR(50),
BIC VARCHAR(30),
IBAN VARCHAR(30),
UUID VARCHAR(40),
CREATE_ONLY SMALLINT)
 RETURNS(ID_CONTRAGENT INTEGER)
 AS
declare variable IS_INSERT smallint;
begin
  execute procedure import_mark_transaction$exc;

  ID_CONTRAGENT = null;
  select c.ID_CONTRAGENT
  from CONTRAGENTS c
  where c.uuid = :UUID and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :ID_CONTRAGENT;

  /* FIXME - remove this fallback lookup by name (depends on the separate contragents exchange implementation)*/
  if (:ID_CONTRAGENT is null) then begin
    select c.ID_CONTRAGENT
    from CONTRAGENTS c
    where c.contragent_name = :contragent_name and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
    into :ID_CONTRAGENT;
  end

  IS_INSERT = 0;
  if (ID_CONTRAGENT is null) then begin
    IS_INSERT = 1;
  end else if (1 = :create_only) then begin
    exit;
  end

  execute procedure CONTRAGENT_MODIFY$CONTR(:ID_CONTRAGENT, :CONTRAGENT_NAME,
    :IS_JURIDICAL_PERSON, :IDENT_NO, :VAT_REG_NUM, :POST_ADDRESS, :ZIP_CODE,
    :EMAIL, :MOL, :COUNTRY_CODE, :BANK_NAME, :BIC, :IBAN)
  returning_values :ID_CONTRAGENT;

  if (IS_INSERT = 1) then begin
    update CONTRAGENTS c
      set c.UUID = :UUID
      where c.ID_CONTRAGENT = :ID_CONTRAGENT;
  end
end
^

/* Alter (NON_DOCUMENTED_INFO_GET$INT) */
ALTER PROCEDURE NON_DOCUMENTED_INFO_GET$INT(ID_OWNER INTEGER,
ID_ROOM INTEGER)
 RETURNS(OUT_LATE_INFO VARCHAR(255),
OUT_CURR_INFO VARCHAR(255),
OUT_NEXT_INFO VARCHAR(255))
 AS
declare variable from_date date;
declare variable to_date date;
declare variable value_post_total numeric(15,4);
declare variable curr_post varchar(3);
declare variable sub_delim varchar(3);
declare variable short_date_format varchar(50);
declare variable value_format varchar(50);
declare variable has_next smallint;
declare variable tmp_info varchar(5000);
declare variable billing_type varchar(10);
declare variable prev_billing_type varchar(10);
declare variable is_first smallint;
begin
  if (:ID_OWNER is null) then exit;

  OUT_LATE_INFO = null;
  OUT_CURR_INFO = null;
  OUT_NEXT_INFO = null;
  tmp_info = null;

  from_date = '01.01.1500';
  sub_delim = '/ ';
  short_date_format = 'D;dd.mm';
  value_format = 'F;0.00';

  is_first = 1;
  for
    select P.BILLING_PERIOD_FROM, P.BILLING_DATE, P.BILLING_TYPE
    from   PMS_BILLING_CYCLE_CALC(:id_owner) P
    into   :FROM_DATE, :TO_DATE, :billing_type
  do begin
    has_next = 0;
    if (:PREV_BILLING_TYPE <> :BILLING_TYPE) then
      tmp_info = null;

    tmp_info = coalesce(trim(:tmp_info) || '; ', '');

    if (:BILLING_TYPE in ('current', 'late') and :to_date is not null) then
        tmp_info = :tmp_info || formatdate(:to_date, :short_date_format) || :sub_delim;

    FROM_DATE = iif(:IS_FIRST=1, cast('01.01.1500' as date), :FROM_DATE);
    TO_DATE  = coalesce(:TO_DATE, cast('01.01.2500' as date));
    for
      /*  select sum(P.VALUE_POST * iif(P.IS_OWNER_INCOME = 1, 1, -1)), P.CURR_POST
        from   PMS_ACC_POST_TO_BILL_GET$INT(:ID_OWNER, :ID_ROOM, iif(:IS_FIRST=1,'01.01.1500',:FROM_DATE), coalesce(:TO_DATE, '01.01.2500'), 0) P
        group by 2
        into   :value_post_total, :curr_post  */
      select   sum(iif(OP.IS_OWNER_INCOME = 1, OP.INCOME_VALUE, OP.OUTGO_VALUE * (-1))), iif(OP.IS_OWNER_INCOME = 1, OP.INCOME_CURR, OP.OUTGO_CURR)
      from     OWNER_POST OP
               left outer join ACCOUNT_POST$PMS  APP on APP.ID_ACCOUNT_POST = OP.ID_ACCOUNT_POST$PMS
      where    OP.ID_OWNER = :id_owner
               and ((OP.ID_ROOM = :id_room) or (:id_room is null))
               and OP.POST_DATE between :FROM_DATE and :TO_DATE
               --and OP.POST_DATE between iif(:IS_FIRST=1, cast('01.01.1500' as date), :FROM_DATE) and coalesce(:TO_DATE, cast('01.01.2500' as date))
               and OP.POST_STATUS = 11
      group by 2
      into     :value_post_total, :curr_post
    do begin
      tmp_info = trim(:tmp_info) || iif(:has_next = 1, ', ', '');
      tmp_info = iif(:tmp_info = '', '', trim(:tmp_info) || ' ') || FORMATFLOAT(:VALUE_POST_TOTAL, :value_format) || ' ' || :CURR_POST;
      has_next = 1;
    end

    if (:has_next = 0) then begin
      select O.ID_CURRENCY
      from   OWNER$PMS O
      where  O.ID_OWNER = :ID_OWNER
      into   :CURR_POST;

      if (:billing_type in ('late', 'current')) then
        tmp_info = iif(:tmp_info = '', '', trim(:tmp_info) || ' ') || FORMATFLOAT(0, :value_format) || ' ' || :CURR_POST;
    end
    if (:billing_type = 'late') then OUT_LATE_INFO = substring(:tmp_info from 1 for 254);
    if (:billing_type = 'current') then OUT_CURR_INFO = substring(:tmp_info from 1 for 254);
    if (:billing_type = 'next') then OUT_NEXT_INFO = substring(:tmp_info from 1 for 254);
    prev_billing_type = :billing_type;
    is_first = 0;
  end
  suspend;
end
^

/* Alter (OWNER_BILL_MODIFY$PMS) */
ALTER PROCEDURE OWNER_BILL_MODIFY$PMS(ID_OWNER_BILL INTEGER,
ID_OWNER INTEGER,
BILLING_DATE DATE,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_OWNER_BILL INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_anul smallint;
  declare variable bill_num integer;
  declare variable id_account_post_pms integer;
  declare variable id_account_post integer;
  declare variable prev_id_owner_bill integer;
  declare variable prev_billing_date date;

  declare variable id_account integer;
  declare variable id_account_pms integer;
  declare variable value_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable value_post numeric(15,4);
  declare variable curr_post varchar(3);
  declare variable is_owner_income smallint;
  declare variable id_service integer;
  declare variable id_room integer;
  declare variable date_post date;
  declare variable id_reserv_detail integer;
  declare variable doc_description varchar(255);
  declare variable id_doc_head integer;
  declare variable description varchar(255);
  declare variable id_pms_event integer;
  declare variable is_client_account_post smallint;
begin
  err_code = 0;
  err_text = '';
  is_client_account_post = null;
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'create, anul');

  if ( exists ( select *
                from   OWNER$PMS O
                where  O.ID_OWNER = :ID_OWNER
                       and O.ID_RENTAL_POOL_UNIT is not null ) ) then
  begin
    exception PMS_EXCEPTION 'selected owner is pool!';
  end

  if (:operation = 'create') then begin
    is_anul = 0;

    if ( (:ID_OWNER_BILL is null) or (:ID_OWNER_BILL <= 0) )  then
      NEW_ID_OWNER_BILL = gen_id(GEN_OWNER_BILL$PMS_ID, 1);
    else
      NEW_ID_OWNER_BILL = :ID_OWNER_BILL;

    BILL_NUM = :NEW_ID_OWNER_BILL;
    insert into OWNER_BILL$PMS (ID_OWNER_BILL, ID_OWNER, BILL_DATE, IS_ANUL, BILL_NUM,
           IS_EXPORTED_TO_INTRANET, IS_POOL_DISTRIBUTION_STATEMENT)
    values (:NEW_ID_OWNER_BILL, :ID_OWNER, :BILLING_DATE, :IS_ANUL, :BILL_NUM, 0, 0);

    update OWNER$PMS O
    set    O.LAST_BILLING_DATE = :billing_date,
           O.ID_OWNER_BILL = :NEW_ID_OWNER_BILL
    where  O.ID_OWNER = :ID_OWNER;

    for
    /*  select ID_ACCOUNT_POST, ID_ACCOUNT_POST_PMS
      from   PMS_ACC_POST_TO_BILL_GET$INT(:ID_OWNER, null, '01.01.1500', :BILLING_DATE, 1)
      into   :ID_ACCOUNT_POST, :ID_ACCOUNT_POST_PMS */
      select   OP.ID_ACCOUNT_POST, OP.ID_ACCOUNT_POST$PMS
      from     OWNER_POST OP
      where    OP.ID_OWNER = :id_owner
               and OP.POST_DATE between cast('01.01.1500' as date) and :billing_date
               and OP.IS_ANUL = 0
      order by OP.ID_ACCOUNT_POST$PMS nulls last
      into     :ID_ACCOUNT_POST, :ID_ACCOUNT_POST_PMS
    do begin
      if (:id_account_post_pms is not null) then begin

        update ACCOUNT_POST$PMS A
        set    A.LINE_STATUS = 21
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS;

        id_account = null;
        select ACC.ID_SERVICE, ACC.VALUE_ORIG, ACC.CURR_ORIG, ACC.VALUE_POST, ACC.CURR_POST,
               ACC.IS_OWNER_INCOME, ACC.DATE_POST, ACC.ID_ACCOUNT_PMS, E.ID_ROOM,
               E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION, A.IS_CLIENT_POOL_ACCOUNT
        from   ACCOUNT_POST$PMS ACC
               join ACCOUNT$PMS A on A.ID_ACCOUNT = ACC.ID_ACCOUNT_PMS
               join PMS_EVENT$PMS E on E.ID_PMS_EVENT = ACC.ID_PMS_EVENT
        where  ACC.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
        into   :ID_SERVICE, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
               :IS_OWNER_INCOME, :DATE_POST, :ID_ACCOUNT_PMS, :ID_ROOM,
               :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION, :is_client_account_post;
      end

      if (:id_account_post is not null) then begin
        exception PMS_EXCEPTION '-613';
          
        is_client_account_post = 1;
        update PMS_EVENT_POST A
        set    A.LINE_STATUS = 21
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST;

        id_account_pms = null;
        select ACC.ID_SERVICE, ACC.PRICE_ORIG, ACC.CURR_ORIG, ACC.PRICE_POST, ACC.CURR_POST,
               0, ACC.DATE_POST, ACC.ID_ACCOUNT, E.ID_ROOM,
               E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION
        from   ACCOUNT_POST ACC
               join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = ACC.ID_ACCOUNT_POST
               join PMS_EVENT$PMS E on E.ID_PMS_EVENT = PP.ID_PMS_EVENT
        where  ACC.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
        into   :ID_SERVICE, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
               :IS_OWNER_INCOME, :DATE_POST, :ID_ACCOUNT, :ID_ROOM,
               :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION;
      end

      insert into OWNER_BILL_ROW$PMS (ID_OWNER_BILL, ID_ACCOUNT_POST,
             ID_ACCOUNT, ID_ACCOUNT_POST_PMS, ID_ACCOUNT_PMS, ID_SERVICE, VALUE_ORIG,
             CURR_ORIG, VALUE_POST, CURR_POST, IS_OWNER_INCOME, ID_ROOM, DATE_POST,
             ID_RESERV_DETAIL, DOC_DESCRIPTION, ID_DOC_HEAD, DESCRIPTION, IS_CLIENT_ACCOUNT_POST)
      values (:new_id_owner_bill, :ID_ACCOUNT_POST, :ID_ACCOUNT,
             :ID_ACCOUNT_POST_PMS, :ID_ACCOUNT_PMS, :ID_SERVICE, :VALUE_ORIG,
             :CURR_ORIG, :VALUE_POST, :CURR_POST, :IS_OWNER_INCOME, :ID_ROOM, :DATE_POST,
             :ID_RESERV_DETAIL, :DOC_DESCRIPTION, :ID_DOC_HEAD, :DESCRIPTION, :is_client_account_post);
    end
  end
  if (:operation = 'anul') then begin
    select O.ID_OWNER, O.IS_ANUL
    from   OWNER_BILL$PMS O
    where  O.ID_OWNER_BILL = :ID_OWNER_BILL
    into   :id_owner, :is_anul;
    if (:is_anul = 1) then exit;

    select first 1 B.ID_OWNER_BILL
    from   OWNER_BILL$PMS B
    where  B.ID_OWNER = :id_owner
           and B.IS_ANUL = 0
    order by B.BILL_DATE desc
    into   :prev_id_owner_bill;
    if (:prev_id_owner_bill <> :id_owner_bill) then exception PMS_EXCEPTION '-619';

    select first 1 O.ID_OWNER_BILL, O.BILL_DATE
    from   OWNER_BILL$PMS O
    where  O.ID_OWNER = :ID_OWNER
           and o.IS_ANUL = 0
           and O.ID_OWNER_BILL <> :ID_OWNER_BILL
    order by O.BILL_DATE desc
    into   :prev_id_owner_bill, :prev_billing_date;

    update OWNER$PMS O
    set    O.LAST_BILLING_DATE = :prev_billing_date,
           O.ID_OWNER_BILL = :prev_id_owner_bill
    where  O.ID_OWNER = :ID_OWNER;

    update OWNER_BILL$PMS B
    set    B.IS_EXPORTED_TO_INTRANET = 0,
           B.IS_ANUL = 1
    where  B.ID_OWNER_BILL = :ID_OWNER_BILL;

    for
      select O.ID_ACCOUNT_POST, O.ID_ACCOUNT_POST_PMS
      from   OWNER_BILL_ROW$PMS O
      where  O.ID_OWNER_BILL = :ID_OWNER_BILL
      into   :id_account_post, :id_account_post_pms
    do begin
      if (:id_account_post_pms is not null) then begin
        update ACCOUNT_POST$PMS A
        set    A.LINE_STATUS = 11
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
               and A.LINE_STATUS = 21;
      end

      if (:id_account_post is not null) then begin
        update PMS_EVENT_POST A
        set    A.LINE_STATUS = 11
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and A.LINE_STATUS = 21;
      end
    end

    for
      select distinct AP.ID_PMS_EVENT
      from   OWNER_BILL_ROW$PMS R
             join OWNER_BILL$PMS B on B.ID_OWNER_BILL = R.ID_OWNER_BILL
             join ACCOUNT_POST$PMS AP on AP.ID_ACCOUNT_POST = R.ID_ACCOUNT_POST_PMS
             join PMS_EVENT$PMS E on E.ID_PMS_EVENT = AP.ID_PMS_EVENT
      where  R.ID_OWNER_BILL = :ID_OWNER_BILL
             and E.EVENT_TYPE = 'POOL_DISTRIBUTION'
             and B.IS_POOL_DISTRIBUTION_STATEMENT = 1
      into   :id_pms_event
    do begin
      execute procedure PMS_EVENT_VOID$INT(:id_pms_event);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: GUEST_ADDRESSCARD_SET$RSV for: PERSON_PASS_DATA_SET$INT */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$RSV(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
EGN VARCHAR(30),
COUNTRY VARCHAR(10),
ID_STAY_REASON INTEGER,
IS_REGISTRED INTEGER,
PASS_PLACE VARCHAR(20),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_PLACE VARCHAR(30),
SEX CHAR,
MASK VARCHAR(10),
IS_CHILD INTEGER,
CAR VARCHAR(30),
KPP INTEGER,
KPP_DATE DATE,
PASS_EXP_DATE DATE,
AGE INTEGER,
BIRTH_DAY DATE,
VISA /* TDESCRIPTION_SHORT */ VARCHAR(100),
RATING_AGE INTEGER = null,
TITLE VARCHAR(10) = null,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_PERSON_MODIFY$PROFILE for: PERSON_PASS_DATA_SET$INT */
ALTER PROCEDURE PROFILE_PERSON_MODIFY$PROFILE(ID_PROFILE INTEGER,
ID_GUEST_TYPE INTEGER,
PROFILE_NAME VARCHAR(100),
PERSON_NAME2 VARCHAR(100),
SEX CHAR,
BIRTH_DAY DATE,
BIRTH_PLACE VARCHAR(30),
EGN VARCHAR(30),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
COUNTRY_CODE VARCHAR(20),
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
MASK VARCHAR(10),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
IS_ARCHIVE INTEGER,
ID_PHOTO INTEGER,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
TITLE VARCHAR(10) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PERSON_PASS_DATA_SET$INT) */
ALTER PROCEDURE PERSON_PASS_DATA_SET$INT(PD_DBKEY CHAR(8),
BIRTH_PLACE VARCHAR(30),
EGN VARCHAR(30),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
SEX CHAR,
MASK VARCHAR(10))
 AS
declare variable id_profile integer;
begin
  /*  Description:
  ||
  */

  update PERSON_DATA PDU
  set    PDU.BIRTH_PLACE = :birth_place,
         PDU.EGN = :egn,
         PDU.ID_PASSPORT_TYPE = :ID_PASSPORT_TYPE,
         PDU.PASS_NUM = :pass_num,
         PDU.PASS_DATE = :pass_date,
         PDU.PASS_EXP_DATE = :pass_exp_date,
         PDU.PASS_PLACE = :pass_place,
         PDU.CITY = :city,
         PDU.ADDRESS = :address,
         PDU.SEX = :sex,
         PDU.MASK = :mask
  where  PDU.RDB$DB_KEY = :pd_dbkey;

  for
    select pp.ID_PROFILE
    from   PERSON_DATA pd
           join PROFILE_PERSON pp on pp.ID_PERSON_DATA = pd.ID_PERSON_DATA
    where  PD.RDB$DB_KEY = :pd_dbkey
    into   :id_profile
  do begin
    update PROFILE p
    set    p.MERGE_IDENT_NUM = trim(:EGN),
           p.MERGE_IDENT_NUM_ALT = trim(:PASS_NUM)
    where  p.ID_PROFILE = :id_profile;
  end 
end
^

/* Alter (PMS_POOL_DISTRIBUTION) */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION(ID_RENTAL_POOL INTEGER,
FOR_DATE DATE)
 AS
declare variable total_value_per_service numeric(15,4);
  declare variable id_service integer;
  declare variable curr varchar(3);
  declare variable id_room_param integer;
  declare variable is_room_pool smallint;
  declare variable is_owner_income smallint;

  declare variable is_acc_post_item smallint;
  declare variable new_id_owner_bill integer;
  declare variable id_account_post_pms integer;
  declare variable id_pool_account integer;

  declare variable id_account_pms integer;
  declare variable value_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable value_post numeric(15,4);
  declare variable curr_post varchar(3);
  declare variable id_room integer;
  declare variable date_post date;
  declare variable id_reserv_detail integer;
  declare variable doc_description varchar(255);
  declare variable id_doc_head integer;
  declare variable description varchar(255);
  declare variable is_client_account_post smallint;
  declare variable id_event_lst varchar(5000);
begin
  is_room_pool = null;
  select U.IS_ROOM_POOL, U.ID_ROOM_PARAM
  from   OWNER$PMS O
         join RENTAL_POOL_UNIT$PMS U on U.ID_RENTAL_POOL_UNIT = O.ID_RENTAL_POOL_UNIT
  where  O.ID_OWNER = :ID_RENTAL_POOL
  into   :is_room_pool, :id_room_param;
  if (:is_room_pool is null) then exception PMS_EXCEPTION;

  select cast(list(distinct AP.ID_PMS_EVENT) as varchar(5000))
  from   ACCOUNT_POST$PMS AP
         join ACCOUNT$PMS AC on AC.ID_ACCOUNT = AP.ID_ACCOUNT_PMS
  where  AP.DATE_POST <= :FOR_DATE
         and AP.LINE_STATUS = 11
         and AC.ID_OWNER = :ID_RENTAL_POOL
         and AC.IS_SHADOW = 0
  into   :id_event_lst;

  for
    select sum(AP1.VALUE_POST), AP1.ID_SERVICE, AP1.CURR_POST, AP1.IS_OWNER_INCOME,
           ACC.IS_CLIENT_POOL_ACCOUNT, ACC.ID_ACCOUNT
    from   ACCOUNT_POST$PMS AP1
           join ACCOUNT$PMS ACC on ACC.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS
           join SYSTEM_STRING_PARSER(:id_event_lst, ',') S on S.ITEM = AP1.ID_PMS_EVENT
    where  AP1.LINE_STATUS = 11
           and ACC.IS_SHADOW = 0
    group by 2,3,4,5,6
    into   :total_value_per_service, :id_service, :curr, :is_owner_income,
           :is_acc_post_item, :id_pool_account
  do begin
    execute procedure PMS_POOL_DISTRIBUTION_SUB(:ID_RENTAL_POOL, :id_pool_account,
            :IS_ROOM_POOL, :ID_ROOM_PARAM, :total_value_per_service,
            :ID_SERVICE, :CURR, :IS_OWNER_INCOME, :FOR_DATE, :is_acc_post_item);
  end

  NEW_ID_OWNER_BILL = gen_id(GEN_OWNER_BILL$PMS_ID, 1);

  insert into OWNER_BILL$PMS (ID_OWNER_BILL, ID_OWNER, BILL_DATE, IS_ANUL, BILL_NUM,
         IS_EXPORTED_TO_INTRANET, IS_POOL_DISTRIBUTION_STATEMENT)
  values (:NEW_ID_OWNER_BILL, :ID_RENTAL_POOL, :FOR_DATE, 0, :NEW_ID_OWNER_BILL, 0, 1);

  update OWNER$PMS O
  set    O.LAST_BILLING_DATE = :for_date,
         O.ID_OWNER_BILL = :NEW_ID_OWNER_BILL
  where  O.ID_OWNER = :ID_RENTAL_POOL;

  for
    select AP.ID_ACCOUNT_POST, AP.VALUE_ORIG, AP.CURR_ORIG, AP.VALUE_POST, AP.CURR_POST,
           ACC.ID_ACCOUNT, AP.IS_OWNER_INCOME, AP.ID_SERVICE, E.ID_ROOM, AP.DATE_POST,
           E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION, ACC.IS_CLIENT_POOL_ACCOUNT
    from   PMS_EVENT$PMS E
           join ACCOUNT_POST$PMS AP on ap.ID_PMS_EVENT = e.ID_PMS_EVENT
                                       and AP.LINE_STATUS = 11
           join ACCOUNT$PMS ACC on ACC.ID_ACCOUNT = AP.ID_ACCOUNT_PMS
                                   and ACC.ID_OWNER = :ID_RENTAL_POOL
                                   and ACC.IS_SHADOW = 0
    where  ((E.ID_SESSION = current_transaction) or (','||:id_event_lst||',' containing  ','||E.ID_PMS_EVENT||','))
    into   :id_account_post_pms, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
           :ID_ACCOUNT_PMS, :IS_OWNER_INCOME, :ID_SERVICE, :ID_ROOM, :DATE_POST,
           :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION, :is_client_account_post
  do begin
    insert into OWNER_BILL_ROW$PMS (ID_OWNER_BILL, ID_ACCOUNT_POST, ID_ACCOUNT,
           ID_ACCOUNT_POST_PMS, ID_ACCOUNT_PMS, ID_SERVICE, VALUE_ORIG,
           CURR_ORIG, VALUE_POST, CURR_POST, IS_OWNER_INCOME, ID_ROOM, DATE_POST,
           ID_RESERV_DETAIL, DOC_DESCRIPTION, ID_DOC_HEAD, DESCRIPTION, IS_CLIENT_ACCOUNT_POST)
    values (:new_id_owner_bill, null, null,
           :ID_ACCOUNT_POST_PMS, :ID_ACCOUNT_PMS, :ID_SERVICE, :VALUE_ORIG,
           :CURR_ORIG, :VALUE_POST, :CURR_POST, :IS_OWNER_INCOME, :ID_ROOM, :DATE_POST,
           :ID_RESERV_DETAIL, :DOC_DESCRIPTION, :ID_DOC_HEAD, :DESCRIPTION, :is_client_account_post);

    update ACCOUNT_POST$PMS A
    set    A.LINE_STATUS = 21
    where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS;
  end
end
^

/* empty dependent procedure body */
/* Clear: PMS_POOL_DISTRIBUTION for: PMS_POOL_DISTRIBUTION_SUB */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION(ID_RENTAL_POOL INTEGER,
FOR_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_POOL_DISTRIBUTION_SUB) */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
declare variable cnt_room smallint;
  declare variable curr_total_posted numeric(15,4);
  declare variable cnt integer;
  declare variable value_to_post numeric(15,4);
  declare variable value_to_post_per_owner numeric(15,4);
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable id_room_contract integer;
  declare variable id_owner_account integer;
  declare variable id_pms_event integer;
  declare variable id_hotel integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
begin
  select c.ROUND_TO
  from   CURRS c
  where  c.CURR = :CURR
  into   :round_to;

  cnt_room = 0;
  select count(distinct RP.ID_ROOM)
  from   ROOM_PERIOD$PMS RP
         join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
  where  RC.ID_RENTAL_POOL = :id_rental_pool
         and RP.STATUS in ('PRIVATE','CONTRACT')
         and RP.FROM_DATE <= :FOR_DATE
         and RP.TO_DATE >= :FOR_DATE
  into   :cnt_room;

  if (:cnt_room = 0) then exception PMS_EXCEPTION 'The pool has not assigned room contracts for selected date (' || :FOR_DATE || ') !';

  if (:is_room_pool = 1) then begin
    curr_total_posted = 0;
    cnt = 0;
    id_pms_event = null;
    id_hotel = null;
    for
      select distinct RP.ID_ROOM, RC.ID_ROOM_CONTRACT, R.ID_HOTEL
      from   ROOM_PERIOD$PMS RP
             join ROOMS R on R.ID_ROOM = RP.ID_ROOM
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.FROM_DATE <= :FOR_DATE
             and RP.TO_DATE >= :FOR_DATE
      into   :id_room, :id_room_contract, :id_hotel
    do begin
      id_pms_event = null;

      select E.ID_PMS_EVENT
      from   PMS_EVENT$PMS E
      where  E.ID_ROOM = :id_room
             and E.ID_SESSION = current_transaction
      into   :ID_PMS_EVENT;

      if (:ID_PMS_EVENT is null) then begin
        execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, :id_room_contract)
        returning_values :id_pms_event;
        -- FIXME nakraq da se update total_event_value
      end
      if (:cnt_room - :cnt = 1) then begin
        value_to_post = :TOTAL_VALUE_PER_SERVICE - :curr_total_posted;
      end else begin
        value_to_post = round_f(:TOTAL_VALUE_PER_SERVICE / :cnt_room, :round_to);
      end

      curr_total_posted = :curr_total_posted + :value_to_post;
      cnt = :cnt + 1;

      /* ...i se razpredelq mejdu sobstwenicite na staqta */
      value_to_post = abs(:value_to_post);
      for
        select R.ID_OWNER, R.OUT_VALUE
        from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
        into   :id_owner, :value_to_post_per_owner
      do begin
        /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_pool_account,
                :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                1, :IS_OWNER_INCOME, :id_room)
        returning_values :no_use_id_acc_post;
        /* ... i se nachislqwa po sobswtenik */
        execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
        returning_values (:id_owner_account, :is_account$pms);

        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                :is_account$pms, :is_owner_income, :id_room)
        returning_values :no_use_id_acc_post;
      end
    end
  end else begin
    /* distribution by room_param */
    insert into TMP_SELECT$PMS(ID_SESSION, ID_ROOM, ID_OWNER)
    select distinct current_transaction, RP.ID_ROOM, null
    from   ROOM_PERIOD$PMS RP
           join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
    where  RC.ID_RENTAL_POOL = :ID_RENTAL_POOL
           and RP.STATUS in ('PRIVATE','CONTRACT')
           and RP.FROM_DATE <= :FOR_DATE
           and RP.TO_DATE >= :FOR_DATE;

    id_hotel = null;
    for
      select P.OUT_VALUE, P.OUT_ID_ROOM, R.ID_HOTEL
      from   PMS_CALC_VALUE_BY_PARAM(:ID_ROOM_PARAM, :TOTAL_VALUE_PER_SERVICE, :round_to) P
             join ROOMS R on R.ID_ROOM = P.OUT_ID_ROOM
      into   :value_to_post, :id_room, :id_hotel
    do begin
      id_pms_event = null;
      id_room_contract = null;
      -- room contract must be only one for this period
      select RC.ID_ROOM_CONTRACT
      from   ROOM_PERIOD$PMS RP
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.ID_ROOM = :id_room
             and :for_date between RP.FROM_DATE and RP.TO_DATE
      into   :id_room_contract;

      if (:id_room_contract is not null) then begin
        select E.ID_PMS_EVENT
        from   PMS_EVENT$PMS E
        where  E.ID_ROOM = :id_room
               and E.ID_SESSION = current_transaction
        into   :ID_PMS_EVENT;
  
        if (:ID_PMS_EVENT is null) then begin
          execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                  'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, id_room_contract)
          returning_values :id_pms_event;
          -- FIXME nakraq da se update total_event_value
        end
  
        /* ...i se razpredelq mejdu sobstwenicite na staqta */
        for
          select R.ID_OWNER, R.OUT_VALUE
          from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
          into   :id_owner, :value_to_post_per_owner
        do begin
          /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :ID_POOL_ACCOUNT,
                  :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                  1, :IS_OWNER_INCOME, :id_room)
          returning_values :no_use_id_acc_post;
  
          /* ... i se nachislqwa po sobswtenik */
          execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
          returning_values (:id_owner_account, :is_account$pms);

          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                  :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                  :is_account$pms, :is_owner_income, :id_room)
          returning_values :no_use_id_acc_post;
        end
      end
    end

    delete from TMP_SELECT$PMS T
    where  T.ID_SESSION = current_transaction;
  end
end
^

/* empty dependent procedure body */
/* Clear: EAI_POS_POSTING_ADD$P2E for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PMS_POSTING_CREATE$INT for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
POST_DATE /* TYPE OF TDATE */ DATE,
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
POST_ON_PMS_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT,
IS_OWNER_INCOME /* TYPE OF TLOGICAL */ SMALLINT,
ID_ROOM /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_ACCOUNT_POST /* ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_FINALIZE$POST for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_TELECOUNT_CALL$INT for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_ACCOUNT$INT) */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
QTY TYPE OF TQTY,
ID_SECQUENCE TYPE OF ID,
IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
POST_TEXT TYPE OF TDESCRIPTION_SHORT,
RESOURCE_TEXT TYPE OF TREASON,
DATE_POST TYPE OF TDATE,
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ID_ROOM TYPE OF ID = null,
POST_DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable action_text varchar(255);
begin
  if (:date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :date_post;
  end
/* NO AUTO PRICE !!!!!!
  if (:in_is_manual_price = 0) then begin

    select P.ID_EXTRA_TARIFF
    from   ACCOUNT A
           join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
    where  A.ID_ACCOUNT = :in_id_account
    into   :id_extra_tarifa;
    if ((:id_extra_tarifa is null) or (:id_extra_tarifa < 0)) then begin
      err_code = -14;
      exit;
    end
    execute procedure TAR_RECALC_EXTRASRV(:id_extra_tarifa, :in_id_service, :in_date_post)
    returning_values  :err_code, :err_text, :post_price, :post_currency;
    if (:err_code < 0) then exit;
  end else begin
    --MANUAL PRICE
    post_currency = :manual_curr ;
    post_price = :manual_price ;
  end
*/

  post_currency = :manual_curr ;
  post_price = :manual_price ;
  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, -1, :id_secquence, :date_post, :id_service, -1, :id_room, 0, :qty, :post_price,
    :post_currency, null, :short_code, :from_date, :to_date, :post_text, :resource_text, '', -1, :POST_DESCRIPTION)
  returning_values :err_code, :err_text, :id_account_post;
  if (:err_code <> 0) then exit;

  select S.SERVICE_NAME
  from   SERVICES S
  where  S.ID_SERVICE = :ID_SERVICE
  into   :action_text;
   
  action_text = f_character(29) || coalesce(:action_text, '')
                || f_character(28) || formatdate(:DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || coalesce(:post_currency, '');
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_RESERVATION$INT for: POST_SERVICE_ON_GUEST$INT */
ALTER PROCEDURE POST_SERVICE_ON_RESERVATION$INT(ID_RESERV_DETAIL /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_ROOM for: POST_SERVICE_ON_GUEST$INT */
ALTER PROCEDURE POST_SERVICE_ON_ROOM(IN_ID_ROOM /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255))
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_GUEST /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_GUEST$INT) */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TDESCRIPTION_SHORT,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ACCOUNT_ROUTING TYPE OF TSHORT_CODE,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable id_room integer;
  declare variable no_use varchar(255);
  declare variable action_text varchar(255);
  declare variable is_guest_check_in smallint;
  declare variable service_name varchar(50);
begin
  err_code = 0;
  err_text = '';

  select g.check_status
  from   guest g
  where  g.id_guest = :in_id_guest
  into   :is_guest_check_in;

  if (:is_guest_check_in < 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
  end

  execute procedure GUEST_GET_POSTING_ACCOUNT$INT (:in_id_guest, :account_routing)
  returning_values  :id_account, :id_room;

  if (:in_date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :in_date_post;
  end

  if (:in_is_manual_price = 0) then begin
    execute procedure SERVICE_GET_POSTING_DETAILS(:in_id_service, :IN_DATE_POST)
    returning_values  :no_use, :no_use, :service_name, :post_price, :post_currency;
  end else begin
    /* MANUAL PRICE */
    post_currency = :manual_curr;
    post_price = :manual_price;
    select s.SERVICE_NAME
    from   SERVICES s
    where  s.ID_SERVICE = :IN_ID_SERVICE
    into   :service_name;
  end

  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, :in_id_guest, :in_id_secquence, :in_date_post, :in_id_service, -1, :id_room, 0, :in_qty,
    :post_price, :post_currency, null, :in_short_code, :in_from_datetime, :in_to_datetime, :in_post_text,
    :in_resource_text, '', -1, :DESCRIPTION)
  returning_values  :err_code, :err_text, :id_account_post;

  action_text = f_character(29) || coalesce(:service_name, '')
                || f_character(28) || formatdate(:IN_DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:IN_QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || coalesce(:post_currency, '');
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: RESOURCE_RESERVATION_CHECK_IN for: POST_SERVICE_ON_RESERVATION$INT */
ALTER PROCEDURE RESOURCE_RESERVATION_CHECK_IN(ID_RESOURCE_RESERVATION INTEGER,
SERVICE_PRICE NUMERIC(15,2),
SERVICE_CURR VARCHAR(3))
 RETURNS(OUT_ID_ACCOUNT INTEGER,
OUT_ID_ACCOUNT_POST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_RESERVATION$INT) */
ALTER PROCEDURE POST_SERVICE_ON_RESERVATION$INT(ID_RESERV_DETAIL TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TREASON,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable id_guest integer;
begin
  err_code = 0;
  err_text = '';

  id_guest = null;
  select RD.ID_TITULAR
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :id_guest;

  execute procedure POST_SERVICE_ON_GUEST$INT(:id_guest, :in_id_service, :in_qty, :in_id_secquence,
                    :in_is_manual_price, :manual_price, :manual_curr, :in_from_datetime, :in_to_datetime,
                    :in_post_text, :in_resource_text, :in_date_post, :in_short_code, '', :DESCRIPTION)
  returning_values  :err_code, :err_text, :id_account, :id_account_post;
end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_POST_TO_MH_FRONT_ONLINE for: POST_SERVICE_ON_ROOM */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_SERVICE_POST for: POST_SERVICE_ON_ROOM */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_ROOM) */
ALTER PROCEDURE POST_SERVICE_ON_ROOM(IN_ID_ROOM TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TREASON,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_GUEST TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
begin
  err_code = 0;
  err_text = '';

  id_guest = null;
  select first 1 G.ID_GUEST
  from   GUEST G
  where  G.ID_ROOM = :in_id_room
         and G.CHECK_STATUS = 0
  order by G.FROM_DATE desc, G.ID_GUEST asc
        /************************************************/
        /* DESCENDANT ORDER IS VERY IMPORTANT!!         */
        /* IF TWO GUESTS HAVE:                          */
        /* TO_DATE OF THE 1'ST = FROM_DATE OF THE 2'ND, */
        /* THEN PHONACALLS SHOULD GO TO THE 2'ND        */         
        /************************************************/
  into   :id_guest;

  if (:id_guest is null) then begin
    err_code = -24;   /* NO GUESTS ARE CHECKED_IN INTO THE REQUESTED ROOM! */
    exit;
  end

  execute procedure POST_SERVICE_ON_GUEST$INT(:id_guest, :in_id_service, :in_qty, :in_id_secquence, :in_is_manual_price,
    :manual_price, :manual_curr, :in_from_datetime, :in_to_datetime, :in_post_text, :in_resource_text,
    :in_date_post, :in_short_code, '')
  returning_values  :err_code, :err_text, :id_account, :id_account_post;
end
^

/* empty dependent procedure body */
/* Clear: EAI_TELECOUNT_TRANSFER for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALL_POST$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL /* ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALLS_POST_TO_ACCOUNT$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_TELECOUNT_TRANSFER$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_TELECOUNT_CALL$INT) */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ext_ifc_name varchar(20);
  declare variable room_name varchar(30);
  declare variable datetime_call timestamp;
  declare variable price numeric(15,2);
  declare variable dial_number varchar(50);
  declare variable units integer;
  declare variable pc_id_service integer;
  declare variable def_manual_curr char(3);
  declare variable post_text varchar(50);
  declare variable id_account_post integer;
  declare variable is_archive integer;
  declare variable id_account integer;
  declare variable new_id_account_post integer;
  declare variable pc_tag varchar(20);
  declare variable number_zone varchar(50);
  declare variable id_hotel integer;
  declare variable id_phonecall integer;
  declare variable no_use varchar(255);
begin
  /* Description:
  || POST_TO_TYPE = 0 - ACCOUNT, 1 - GUEST, 2 - RESERV_DETAIL, 3 - JUST PREPARE, FOR EXTERNAL CLIENT
  */
  err_code = 0;
  err_text = '';
  ext_ifc_name = 'TELECOUNT';

  select PC.ID_PHONECALL, PC.ROOM_NAME, PC.DATETIME_CALL, PC.PRICE, PC.DIAL_NUMBER, PC.UNITS,
         PC.ID_ACCOUNT_POST, PC.IS_ARCHIVE, PC.TAG, substring(PC.NUMBER_ZONE from 1 for 30), pc.ID_HOTEL
  from   PHONECALLS PC 
  where  PC.rdb$db_key = :ph_dbkey
  into   :id_phonecall, :room_name, :datetime_call, :price, :dial_number, :units,
         :id_account_post, :is_archive, :pc_tag, :number_zone, :id_hotel;

  if ((:is_archive = 1) or (coalesce(:id_account_post, 0) > 0)) then exit;

  if ((:pc_tag is null) or (:pc_tag = '')) then pc_tag = 'TELECOUNT_DEFAULT';
  else pc_tag = 'TELECOUNT_' || :pc_tag;

  execute procedure EAI_MAP_SERVICE(:pc_tag, :number_zone, :ext_ifc_name, :id_hotel)
  returning_values  :err_code, :err_text, :pc_id_service;
  if (:err_code < 0) then exit;

  post_text = substring(:dial_number || ', impulses ' || :units from 1 for 50);

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :def_manual_curr;

  new_id_account_post = null;
  if (:post_to_type = 0) then begin
    id_account = :post_to_id;
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name)
    returning_values :err_code, :err_text, :new_id_account_post;
  end else if (:post_to_type = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:post_to_id, :pc_id_service, 1, -1, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name, '')
    returning_values :err_code, :err_text, :id_account, :new_id_account_post;
  end else if (:post_to_type = 2) then begin
    execute procedure POST_SERVICE_ON_RESERVATION$INT(:post_to_id, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name)
    returning_values :err_code, :err_text, :id_account, :new_id_account_post;
  end else if (:post_to_type = 3) then begin
    execute procedure POST_PREPARE_ON_ACCOUNT$POST (:post_to_id, :pc_id_service,
      1, :ID_SEQUENCE, :price, :def_manual_curr, :post_text, null, null, :ID_PHONECALL)
    returning_values :no_use;
  end
  if (:err_code < 0) then exit;

  if (:new_id_account_post is not null) then begin
    update PHONECALLS PC
    set    PC.ID_ACCOUNT_POST = :new_id_account_post,
           pc.POSTING_ERROR = null
    where  PC.rdb$db_key = :ph_dbkey;
  end

end
^

/* Alter (POST_TELECOUNT_TRANSFER$TC) */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ph_dbkey char(8);
  declare variable id_account_post integer;
  declare variable account_name varchar(50);
begin
  err_code = 0;
  err_text = '';

  for
    select PC.RDB$DB_KEY, PC.ID_ACCOUNT_POST
    from   PHONECALLS PC
    where  PC.SELECTION_ID = :selection_id
    into   :ph_dbkey, :id_account_post
  do begin
    if ((:id_account_post is not null) and (:id_account_post <> -1)) then begin
      err_code = -117;
      select A.ACCOUNT_NAME
      from   ACCOUNT_POST AP
             join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
      where  AP.ID_ACCOUNT_POST = :id_account_post
      into   :account_name;
      err_text = f_character(29) || :account_name;
      exit;
    end

    execute procedure POST_TELECOUNT_CALL$INT(2, :id_reserv_detail, :ph_dbkey, 0)
    returning_values :err_code, :err_text;
    if (:err_code < 0) then exit;
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_ROOM$INT for: PROFILE_PERSON_CREATEQ$PROFILE */
ALTER PROCEDURE RES_CREATE_ROOM$INT(CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_COUNT INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_AGENT_PROFILE INTEGER,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_PERSON_PROFILE INTEGER,
ACC_ROUTING VARCHAR(50),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ID_GROUP INTEGER = null,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_GUARANTEE_POLICY INTEGER = null,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
RD_DBKEY CHAR(8),
NEW_ID_PERSON_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GET_PERSON_PROFILE$INT for: PROFILE_PERSON_CREATEQ$PROFILE */
ALTER PROCEDURE RES_GET_PERSON_PROFILE$INT(ID_GUEST INTEGER)
 RETURNS(ID_PERSON_PROFILE INTEGER,
ID_PERSON_DATA INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PROFILE_PERSON_CREATEQ$PROFILE) */
ALTER PROCEDURE PROFILE_PERSON_CREATEQ$PROFILE(PROFILE_NAME TYPE OF TPERSON_NAME,
PHONE TYPE OF TPHONE,
ID_PASSPORT_TYPE TYPE OF ID,
PASS_NUM TYPE OF NAME_20,
EGN TYPE OF TTEXT_SHORT,
COUNTRY_CODE TYPE OF TSHORT_CODE,
CARD_CODE TYPE OF TCARD_CODE,
ID_PERSON_DATA TYPE OF ID_REF = null,
TITLE TYPE OF TSHORT_CODE = null,
ID_HOTEL TYPE OF ID_REF = null)
 RETURNS(NEW_ID_PROFILE TYPE OF ID,
P_DBKEY TYPE OF TDB_KEY,
PD_DBKEY TYPE OF TDB_KEY)
 AS
declare variable action_text varchar(255);
  declare variable mask varchar(10);
  declare variable first_name varchar(30);
  declare variable surname varchar(30);
  declare variable family_name varchar(30);
begin

  new_id_profile = gen_id(gen_profile_id, 1);
  insert into PROFILE (ID_PROFILE, PROFILE_NAME, PROFILE_TYPE, PHONE, IS_ARCHIVE, MERGE_IDENT_NUM, MERGE_IDENT_NUM_ALT)
  values (:new_id_profile, :profile_name, 'PERSON', :phone, 0, trim(:EGN), trim(:PASS_NUM))
  returning RDB$DB_KEY into :p_dbkey;

  if (:id_person_data is null) then begin
    id_person_data = gen_id(gen_person_data_id, 1);

    if (:ID_HOTEL is not null) then begin
      execute procedure SETTING_GET_VALUE ('DEF_GUEST_MASK', :ID_HOTEL)
      returning_values  :mask;
    end

    select PP.FIRST_NAME,  PP.SURNAME, PP.FAMILY_NAME
    from   PERSON_NAME_PARSE$INT (:PROFILE_NAME) PP
    into   :first_name,  :surname, :family_name;

    insert into PERSON_DATA(ID_PERSON_DATA, PERSON_NAME2, ID_PASSPORT_TYPE, PASS_NUM, EGN, MASK,
           FIRST_NAME, SURNAME, FAMILY_NAME, COUNTRY_CODE)
    values (:id_person_data, :profile_name, :id_passport_type, :pass_num, :egn, :mask,
           :first_name, :surname, :family_name, :country_code)
    returning RDB$DB_KEY into :pd_dbkey;

    execute procedure PERSON_DATA_SET$INT(:p_dbkey, :pd_dbkey, :profile_name, :profile_name, :country_code,
            null, null, :TITLE);
  end

  insert into PROFILE_PERSON (ID_PROFILE, ID_PERSON_DATA, CARD_CODE)
  values (:new_id_profile, :id_person_data, :card_code);

  action_text = f_character(29) || :profile_name;
  execute procedure SYSTEM_LOG_ADD ('PROFILE', :new_id_profile, 'CREATE_PERS_PROFILE', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_PERSON_PROFILE$EXC for: PROFILE_PERSON_MODIFY$PROFILE */
ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
CLEAR_HOTEL_RATE SMALLINT,
CREATE_ONLY SMALLINT,
MERGE_TARGET_UUID VARCHAR(40))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PROFILE_PERSON_MODIFY$PROFILE) */
ALTER PROCEDURE PROFILE_PERSON_MODIFY$PROFILE(ID_PROFILE INTEGER,
ID_GUEST_TYPE INTEGER,
PROFILE_NAME VARCHAR(100),
PERSON_NAME2 VARCHAR(100),
SEX CHAR,
BIRTH_DAY DATE,
BIRTH_PLACE VARCHAR(30),
EGN VARCHAR(30),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
COUNTRY_CODE VARCHAR(20),
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
MASK VARCHAR(10),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
IS_ARCHIVE INTEGER,
ID_PHOTO INTEGER,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
TITLE VARCHAR(10) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable p_dbkey char(8);
  declare variable pd_dbkey char(8);
  declare variable old_birth_day date;
  declare variable id_picture integer;
  declare variable birthday_internal date;
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    new_id_profile = :id_profile;

    if (:operation = 'add') then begin
      execute procedure PROFILE_PERSON_CREATEQ$PROFILE(:profile_name, :phone,
              :id_passport_type, :pass_num, :egn, :country_code, :card_code, null, :TITLE, null)
      returning_values  :new_id_profile, :p_dbkey, :pd_dbkey;

      if (:MASK is null) then begin
        -- keep the default mask if input mask is <null> - inexplicit
        -- empty mask is '' - passed by GUI, but <null> is passed from booking import, etc.
        select PD.MASK
        from   PERSON_DATA PD
        where  PD.RDB$DB_KEY = :pd_dbkey
        into   :mask;
      end
    end

    select P.RDB$DB_KEY, PD.RDB$DB_KEY, pd.BIRTH_DAY
    from   PROFILE P
           join PROFILE_PERSON PP on PP.ID_PROFILE = P.ID_PROFILE
           join PERSON_DATA PD on PD.ID_PERSON_DATA = PP.ID_PERSON_DATA
    where  P.ID_PROFILE = :new_id_profile
    into   :p_dbkey, :pd_dbkey, :old_birth_day;

    execute procedure PROFILE_COMMON_MODIFY$INT(:new_id_profile, 'PERSON', :profile_name,
            :phone, :fax, :email, :contact_city, :contact_address,
            :note, :msg, :is_archive, :id_def_contragent, :id_nom_market_segment,
            :wbe_password, :account_no, :is_exclusive_debt_ownership)
    returning_values (:new_id_profile);

    execute procedure PERSON_DATA_SET$INT(:p_dbkey, :pd_dbkey, :profile_name, :person_name2, :country_code,
            :old_birth_day, :birth_day, :TITLE);

    execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, :birth_place, :egn, :id_passport_type, :pass_num, :pass_date, :pass_place,
            :pass_exp_date, :pass_city, :pass_address, :sex, :mask);

    update PROFILE_PERSON PP
    set    PP.ID_GUEST_TYPE = :id_guest_type,
           PP.ID_PHOTO = :id_photo,
           PP.CARD_CODE = :card_code
    where  PP.ID_PROFILE = :new_id_profile;

  end else if (:operation = 'del') then begin
    id_picture = null;

    select PP.ID_PHOTO
    from   PROFILE_PERSON PP
    where  PP.ID_PROFILE = :id_profile
    into   :id_picture;

    execute procedure PICTURE_MODIFY (:id_picture, null, null, null, 'del')
    returning_values :id_picture;

    execute procedure PROFILE_DELETE$INT(:id_profile);
    new_id_profile = null;
  end
end
^

/* Alter (RATE_GET_AVAILABILITY$CHM) */
ALTER PROCEDURE RATE_GET_AVAILABILITY$CHM(ID_RATE INTEGER,
FOR_DATE DATE)
 RETURNS(ACTIVE_STATUS INTEGER,
MIN_LOS INTEGER,
MAX_LOS INTEGER)
 AS
declare variable date_from date;
  declare variable date_to date;
  declare variable RATE_capacity integer;
  declare variable to_sell integer;
begin
  --ACTIVE_STATUS 0 - closed
  --ACTIVE_STATUS 1 - closed fro arrival
  --ACTIVE_STATUS 2 - opened
  --opala ID_HOTEL
--  date_from = null;
--  ACTIVE_STATUS -  autoclose, t.e. AUTO_PERCENT






/*  select min(FOR_DATE), max(FOR_DATE)
  from RATE_ALLOTMENT
  where ID_RATE = :id_RATE
  into :date_from, :date_to;
  if (date_from is null) then exit;

  for select distinct ID_ROOM_TYPE
      from RATE_ALLOTMENT
      where ID_RATE = :id_RATE
        and FOR_DATE between :date_from and :date_to
      into :id_room_type
  do begin
    for select RTR.FOR_DATE,
               CA.STATUS,
               CA.AUTO_FREE_ROOMS, CA.ROOM_COUNT, RTR.AVAILABLE as FREE_ROOMS
        from ROOM_TYPE_GET_FREE$CHM(:date_from, :date_to, :id_room_type) RTR
             join RATE_ALLOTMENT CA on CA.ID_ROOM_TYPE = :id_room_type
                                      and CA.ID_RATE = :id_RATE
                                      and CA.FOR_DATE = RTR.FOR_DATE
    into :for_date, :status,
         :auto_free_rooms, :RATE_capacity, :free_rooms
    do begin
      if (:auto_free_rooms is not null) then
        if (coalesce(:free_rooms,0) >= :auto_free_rooms) then
          is_active = 1;
        else is_active = 0;
      else if (:status = 0) then
             is_active = 1;
           else is_active = 0;

      to_sell = coalesce(:free_rooms,0) - coalesce(:auto_free_rooms,0);
      if (to_sell < 0) then to_sell = 0;

      room_count = :to_sell;
      if (:RATE_capacity is not null) then
        if (RATE_capacity < room_count) then
          room_count = :RATE_capacity;

      suspend;
    end
  end*/
end
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUPANCY$INT for: REP_ROOM_STATUS_MOVE */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$INT(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
 BEGIN EXIT; END
^

/* Alter (REP_ROOM_STATUS_MOVE) */
ALTER PROCEDURE REP_ROOM_STATUS_MOVE(FROM_DATE DATE,
TO_DATE DATE,
IN_ID_ROOM_TYPE INTEGER,
SECTOR INTEGER,
FLOOR INTEGER,
ROOM_PARAM_LIST VARCHAR(100),
OPTIONS VARCHAR(255),
HOTELS VARCHAR(255) = '')
 RETURNS(BUSY_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_AGENT INTEGER,
ID_HOTEL INTEGER,
GSTS_STAYOVER INTEGER,
ROOMS_STAYOVER INTEGER,
GSTS_COME INTEGER,
ROOMS_COME INTEGER,
GSTS_GONE INTEGER,
ROOMS_GONE INTEGER)
 AS
declare variable check_in_only integer;
  declare variable busy_group_type integer;
  declare variable room_requirements blob sub_type 1;
begin
  /*  Description:
  ||       
  */
  room_requirements = F_STRTOBLOB(:room_param_list);
  if (:options like '%CHECK_IN_ONLY%') then check_in_only = 1;
  else check_in_only = 0;

  for
    select RM.BUSY_DATE, RM.ID_ROOM_TYPE,
           --iif(:options containing 'DIST_AGENTS', RM.ID_AGENT, null),
           coalesce(RS.ID_AGENT, RM.ID_AGENT),
           coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE), RM.ID_HOTEL,
           sum(RM.GST_AD_STAY+RM.GST_CH_STAY), count(distinct iif(RM.DAY_ACTION in ('STAY', 'BLOCK'), RM.ID_ROOM, null)),
           sum(RM.GST_AD_IN+RM.GST_CH_IN), count(distinct iif(RM.DAY_ACTION = 'CHECK_IN', RM.ID_ROOM, null)),
           sum(RM.GST_AD_OUT+RM.GST_CH_OUT), count(distinct iif(RM.DAY_ACTION = 'CHECK_OUT', RM.ID_ROOM, null))
    from   ROOM_MAGIC RM
           join HOTEL_S H on H.ID_HOTEL = RM.ID_HOTEL
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = RM.ID_RESERV_DETAIL and RD.ACC_ROUTING <> 'OWNER'
           -- join to SHARE table (potential)
           left outer join ROOM_MAGIC rm_last_occ on RM.DAY_ACTION = 'CHECK_OUT' and rm_last_occ.ID_RESERV_DETAIL = rm.ID_RESERV_DETAIL and rm_last_occ.BUSY_DATE = (rm.BUSY_DATE - 1)
           left outer join ROOMS_SHARE RS on RS.ID_ROOM_SHARE = coalesce(rm_last_occ.ID_ROOM_MAGIC, RM.ID_ROOM_MAGIC)
           -- on CHECK_OUT date - join to previous date ROOM_MAGIC, for this date does not exists SHARE record
    where  RM.BUSY_DATE between :from_date and :to_date
           and RM.BUSY_TYPE not in ('VALUE_RESERVS')
           and rm.ROOM_STATUS is distinct from 'PRIVATE'
           and ((:hotels = '') or (','||:hotels||',' containing ','||H.ID_HOTEL||','))
           and ((:check_in_only = 0) or (RM.BUSY_GROUP_TYPE = 24))
           and ((:in_id_room_type = -1) or (RM.ID_ROOM_TYPE = :in_id_room_type))
           and ((:sector = -1 and :floor = -1 and :room_param_list = '') or (exists (
             select R.ID_ROOM , R.ROOM_NAME, R.ID_ROOM_TYPE, R.SECTOR, R.FLOOR, RT.ID_HOTEL
             from   ROOMS R
                    join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
                    left outer join SYSTEM_PICKUP_FEATURES$INT(R.FEATURES, :room_requirements, 38, R.ID_HOTEL) RPF on 0=0
             where  R.ID_ROOM = RM.ID_ROOM
                    and RPF.IS_MATCHING = 1
                    and ((R.SECTOR = :SECTOR) or (:SECTOR <= 0))
                    and ((R.FLOOR = :FLOOR) or (:FLOOR <= 0))
           )))
    group by 1, 2, 3, 4, 5
    into   :busy_date, :id_room_type,
           :id_agent,
           :busy_group_type, :id_hotel,
           :gsts_stayover, :rooms_stayover,
           :gsts_come, :rooms_come,
           :gsts_gone, :rooms_gone
  do begin
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_SET$INT for: RES_CREATE_ROOM$INT */
ALTER PROCEDURE RES_CREATE_SET$INT(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_HOTEL INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
SPLIT_ON_CHECKIN SMALLINT,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_ACC_TEMPLATE_PERSON INTEGER = null,
ID_GUARANTEE_POLICY INTEGER = null,
BLOCK_CC VARCHAR(255) = null,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(RD_DBKEY CHAR(8),
NEW_ID_RESERV_DETAIL INTEGER,
WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_CREATE_ROOM$INT) */
ALTER PROCEDURE RES_CREATE_ROOM$INT(CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_COUNT INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_AGENT_PROFILE INTEGER,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_PERSON_PROFILE INTEGER,
ACC_ROUTING VARCHAR(50),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ID_GROUP INTEGER = null,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_GUARANTEE_POLICY INTEGER = null,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
RD_DBKEY CHAR(8),
NEW_ID_PERSON_PROFILE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable day_keep_types integer;
  declare variable exp_date date;
  declare variable leaving_kind integer;
  declare variable cnt_processed integer;
begin
  execute procedure SETTING_GET_VALUE('DAY_KEEP_TYPES', :ID_HOTEL)
  returning_values  :day_keep_types;
  exp_date = :arrival_date + :day_keep_types;
  leaving_kind = coalesce(:is_late_departure, 0) + 1;
  comming_kind = coalesce(:comming_kind, 1);

  cnt_processed = 0;
  while (:room_count > :cnt_processed) do begin
    if (:res_number is null) then begin
      execute procedure SYSTEM_GEN_NUM('BOOKING', 0)
      returning_values  :dbg, :res_number;
    end
    
    if (:id_person_profile is null) then begin
      execute procedure PROFILE_PERSON_CREATEQ$PROFILE(:res_number, '', null, null, null,
              :country_code, null, null, null, :ID_HOTEL)
      returning_values  :new_id_person_profile, :dbg, :dbg;
      execute procedure sys_dbg('res RES_CREATE_ROOM$INT autocreate id_person_profile = '||coalesce(:id_person_profile, 'null'));
    end else begin
      new_id_person_profile = :id_person_profile;
    end

    execute procedure RES_CREATE_DETAIL$INT(:id_reserv_detail, :id_agent_profile, :res_number, :check_status,
                      :arrival_date, :departure_date, :code_first_food, :exp_date, :comming_kind, :leaving_kind,
                      :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                      0, 0, :note, :i_special_treatment, :id_board, -1, :id_rate,
                      :id_room_type, :country_code, '30.12.1899', null, null, '30.12.1899', null, null, null,
                      :room_features, :id_hk_plan, :new_id_person_profile, :id_hotel, :acc_routing, :id_acc_template_person,
                      :id_group, :id_agent_account, :id_guarantee_policy, :ID_EATING_OBJECT)
    returning_values  :new_id_reserv_detail, :rd_dbkey;
    res_number = null;

    execute procedure RES_GUESTCOUNT_ADD$INT(:rd_dbkey, :adult_count, :child_count);

    cnt_processed = :cnt_processed + 1;
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_SET$EXC for: RES_CREATE_SET$INT */
ALTER PROCEDURE RES_CREATE_SET$EXC(ID_RESERV_DETAIL INTEGER,
RES_NUMBER VARCHAR(62),
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER,
CREATE_DATETIME TIMESTAMP)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_RESERV_DETAIL INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_SET$RSV for: RES_CREATE_SET$INT */
ALTER PROCEDURE RES_CREATE_SET$RSV(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
SUPPRESS_WARNINGS INTEGER,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT$RSV for: RES_CREATE_SET$INT */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_CREATE$RSV for: RES_CREATE_SET$INT */
ALTER PROCEDURE RESMULTI_CREATE$RSV(ID_HOTEL INTEGER,
ID_ROOM_TYPE INTEGER,
TRANSFER_OUT_TIME TIME,
TRANSFER_IN_TIME TIME,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
TRANSFER_OUT_NOTE VARCHAR(50),
TRANSFER_IN_NOTE VARCHAR(50),
NOTE VARCHAR(255),
ID_BOARD INTEGER,
VOUCHER_DATE DATE,
VOUCHER_NUMBER VARCHAR(20),
VOUCHER_TEXT VARCHAR(30),
CHECK_STATUS INTEGER,
ID_TARIFF INTEGER,
COUNTRY_CODE VARCHAR(20),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
NOTE_REMINDERS VARCHAR(50),
TITULAR_NAME VARCHAR(100),
SPLIT_ON_CHECKIN INTEGER,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
NUMBER VARCHAR(62),
NEW_ID_TITULAR INTEGER,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE,
WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_CREATE_SET$INT) */
ALTER PROCEDURE RES_CREATE_SET$INT(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(255),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_HOTEL INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
SPLIT_ON_CHECKIN SMALLINT,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_ACC_TEMPLATE_PERSON INTEGER = null,
ID_GUARANTEE_POLICY INTEGER = null,
BLOCK_CC VARCHAR(255) = null,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(RD_DBKEY CHAR(8),
NEW_ID_RESERV_DETAIL INTEGER,
WARN_CODE TYPE OF TRANGE)
 AS
declare variable guarantee_deposit_percent numeric(15,4);
  declare variable guarantee_deposit_nights integer;
  declare variable guarantee_due_days_bef_arrival integer;
  declare variable guarantee_due_days_after_create integer;
  declare variable gp_check_status integer;
  declare variable log_suppressed integer;
  declare variable id_guest integer;
  declare variable minibar_rights varchar(50);
  declare variable video_rights varchar(50);
  declare variable nopost_pms varchar(50);
  declare variable phone_rights varchar(50);
  declare variable paytv_rights varchar(50);
  declare variable is_profile_exclusive_debt_ownership integer;
  declare variable id_base_account integer;
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CREATE');

  select GP.DEPOSIT_NIGHTS_COUNT, GP.DEPOSIT_TOTALSUM_PART,
         GP.DUE_DAYS_BEFORE_ARRIVAL, GP.DUE_DAYS_AFTER_CREATE, gp.CHECK_STATUS
  from   GUARANTEE_POLICY GP
  where  GP.ID_GUARANTEE_POLICY = :ID_GUARANTEE_POLICY
         and gp.ID_HOTEL = :ID_HOTEL
  into   :guarantee_deposit_nights, :guarantee_deposit_percent,
         :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create, :gp_check_status;

  CHECK_STATUS = coalesce(:CHECK_STATUS, :gp_check_status, -2);

  execute procedure RES_CREATE_ROOM$INT(:check_status, :arrival_date, :departure_date, :adult_count, :child_count,
                    :id_room_type, 1, :id_board, :id_tariff, comming_kind, :is_late_departure, :country_code, :code_first_food,
                    :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note, :i_special_treatment, :id_agent_profile,
                    :id_hk_plan, '', :room_features, :id_person_profile, :acc_routing, :id_acc_template_person, :id_hotel, :id_agent_account,
                    :id_group, :id_reserv_detail, :res_number, :id_guarantee_policy, :id_eating_object)
  returning_values  :new_id_reserv_detail, :rd_dbkey, :id_person_profile;

  if (RDB$GET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE') is not distinct from 'disable') then begin
    log_suppressed = 1;
  end else begin
    log_suppressed = 0;
    RDB$SET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE', 'disable');
    -- disable only for intermediate changes
  end

  execute procedure RES_SAVE_ACCOUNTING$INT (:rd_dbkey, :id_agent_profile, :id_agent_account, :acc_routing,
          :id_person_payment, :id_agent_payment, :id_group);

  execute procedure RES_SAVE_MARKETING$INT(:rd_dbkey, :id_nom_market_segment,
                    :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason);

  execute procedure sys_dbg('res RES_CREATE_SET$INT id_room = '||coalesce(:id_room, 'null'));
  if (:id_room is not null) then begin
    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, :id_room_type, 'nrttRoom')
    returning_values (:WARN_CODE);
  end

  execute procedure RES_SAVE_VOUCHER$INT(:RD_DBKEY, :voucher_num, :voucher_date, :voucher_text, :voucher2_num, :voucher2_date);

  execute procedure RES_SAVE_NOTE$RSV(:new_id_reserv_detail, :note, :note_reminders);

  for
    select  g.ID_GUEST
    from    GUEST G
    where   G.ID_RESERV_DETAIL = :NEW_ID_RESERV_DETAIL
    into    :id_guest
  do begin
    execute procedure RES_GUEST_SAVE_PACKET$RSV (:id_guest, :PACKET_ITEM_IDS);
  end 

  update RESERV_DETAIL RD
  set    RD.CUSTOM_PRICE = :CUSTOM_PRICE,
         RD.CUSTOM_CURRENCY = :CUSTOM_CURRENCY,
         RD.SPLIT_ON_CHECKIN = :SPLIT_ON_CHECKIN,
         RD.IS_VIP = coalesce(:IS_VIP, RD.IS_VIP),
         RD.ID_GUARANTEE_POLICY = :ID_GUARANTEE_POLICY,
         RD.GUARANTEE_DEPOSIT = :GUARANTEE_DEPOSIT,
         RD.GUARANTEE_CURRENCY = :GUARANTEE_CURRENCY,
         RD.BLOCK_CC = :BLOCK_CC,
         RD.GUARANTEE_DEPOSIT_PERCENT = :guarantee_deposit_percent,
         RD.GUARANTEE_DEPOSIT_NIGHTS = :guarantee_deposit_nights,
         RD.GUARANTEE_DUE_DAYS_BEF_ARRIVAL = :guarantee_due_days_bef_arrival,
         RD.GUARANTEE_DUE_DAYS_AFTER_CREATE = :guarantee_due_days_after_create
         /*rd.POSTING_TRANSACTION_UUID =  (select iif(p.IS_EXCLUSIVE_DEBT_OWNERSHIP = 1, uuid_create(), null)
                                         from   ACCOUNT A
                                                join PROFILE P on P.ID_PROFILE = a.ID_PROFILE
                                         where  a.ID_ACCOUNT = rd.ID_BASE_ACCOUNT)*/
  where  RD.RDB$DB_KEY = :rd_dbkey
  returning new.ID_BASE_ACCOUNT
  into      :id_base_account;

  select p.IS_EXCLUSIVE_DEBT_OWNERSHIP
  from   ACCOUNT A
         join PROFILE P on P.ID_PROFILE = a.ID_PROFILE
  where  a.ID_ACCOUNT = :id_base_account
  into   :is_profile_exclusive_debt_ownership;

  if (:is_profile_exclusive_debt_ownership = 1) then begin
    execute procedure RES_TAKE_POSTING_RESPONSIBILITY (:NEW_ID_RESERV_DETAIL);
  end

  select rt.MINIBAR_RIGHTS, rt.VIDEO_RIGHTS, rt.NOPOST_PMS, rt.PHONE_RIGHTS, rt.PAYTV_RIGHTS
  from   RES_TEMPLATE RT
  where  rt.ID_HOTEL = :ID_HOTEL
  into   :minibar_rights, :video_rights, :nopost_pms, :phone_rights, :paytv_rights;

  execute procedure RESERV_DETAIL_EXTERNAL_MOD$RSV (:NEW_ID_RESERV_DETAIL,
          :minibar_rights, :paytv_rights, :video_rights, :nopost_pms, :phone_rights, null, null);

  if (:log_suppressed = 0) then RDB$SET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE', 'enable');

  execute procedure RES_CREATE_LOG$INT (:RD_DBKEY);

end
^

/* Alter (RES_CREATE_SET$RSV) */
ALTER PROCEDURE RES_CREATE_SET$RSV(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
SUPPRESS_WARNINGS INTEGER,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER,
NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable rd_dbkey char(8);
declare variable tmp_warn_code integer;
begin
  WARN_CODE = null;
  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, :check_status, :arrival_date, :departure_date,
                    :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff, :PACKET_ITEM_IDS,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
                    :guarantee_deposit, :guarantee_currency, :split_on_checkin, null, null, :ID_ACC_TEMPLATE_PERSON,
                    :ID_GUARANTEE_POLICY, null, :ID_EATING_OBJECT)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :WARN_CODE;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :ERR_TEXT, :share_transaction_id, :tmp_warn_code;
  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

  if (:suppress_warnings = 1) then begin
    delete from SYSTEM_WARNINGS W
    where W.ID_TRANSACTION = :warn_code;
    warn_code = null;
  end

  update RESERV_DETAIL RD
  set    RD.NOTE_REMINDERS = :note_reminders
  where  RD.RDB$DB_KEY = :rd_dbkey;

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;

end
^

/* Alter (RES_GET_PERSON_PROFILE$INT) */
ALTER PROCEDURE RES_GET_PERSON_PROFILE$INT(ID_GUEST INTEGER)
 RETURNS(ID_PERSON_PROFILE INTEGER,
ID_PERSON_DATA INTEGER)
 AS
declare variable p_dbkey char(8);
  declare variable profile_name varchar(100);
  declare variable pd_dbkey char(8);
  declare variable id_hotel integer;
  declare variable title varchar(10);
begin
  select PD.ID_PERSON_DATA, PD.PERSON_NAME, PP.ID_PROFILE, rd.ID_HOTEL, pd.TITLE
  from   GUEST G
         join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
         join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
         join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
         left outer join PROFILE_PERSON PP on PP.ID_PERSON_DATA = GD.ID_PERSON_DATA
  where  G.ID_GUEST = :id_guest
  into   :id_person_data, :profile_name, :id_person_profile, :id_hotel, :title;

  if (:id_person_profile is null) then begin
    execute procedure PROFILE_PERSON_CREATEQ$PROFILE(:profile_name, '', null, null, null, null, null, :id_person_data, :title, :id_hotel)
    returning_values  :id_person_profile, :p_dbkey, :pd_dbkey;
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_CHECKIN_MULTI$RSV for: RES_SPLIT$RSV */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT_MULTI$RSV for: RES_SPLIT$RSV */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SPLIT$RSV) */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
declare variable rd_dbkey_old char(8);
  declare variable rd_dbkey_new char(8);
  declare variable id_guest integer;
  declare variable warn_code integer;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;

  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable check_status integer;
  declare variable arrival_date date;
  declare variable departure_date date;
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable id_room_type integer;
  declare variable id_room integer;
  declare variable id_board integer;
  declare variable id_tariff integer;
  declare variable custom_price numeric(15,4);
  declare variable custom_currency char(3);
  declare variable voucher_num varchar(30);
  declare variable voucher_date date;
  declare variable voucher_text varchar(30);
  declare variable voucher2_num varchar(30);
  declare variable voucher2_date date;
  declare variable transfer_in_time time;
  declare variable transfer_in_note varchar(255);
  declare variable transfer_out_time time;
  declare variable transfer_out_note varchar(255);
  declare variable comming_kind integer;
  declare variable is_late_departure integer;
  declare variable is_vip integer;
  declare variable country_code varchar(20);
  declare variable code_first_food tfood_code;
  declare variable i_special_treatment varchar(255);
  declare variable id_nom_market_segment integer;
  declare variable id_nom_source_code integer;
  declare variable id_nom_channel_code integer;
  declare variable id_nom_hear_reason integer;
  declare variable id_nom_come_reason integer;
  declare variable id_agent_account integer;
  declare variable acc_routing varchar(50);
  declare variable id_person_payment integer;
  declare variable id_agent_payment integer;
  declare variable room_features blob sub_type 1 segment size 80;
  declare variable id_hk_plan integer;
  declare variable id_group integer;
  declare variable id_hotel integer;
  declare variable note varchar(2000);
  declare variable note_reminders varchar(50);
  declare variable guarantee_deposit numeric(15,4);
  declare variable guarantee_currency char(3);
  declare variable id_titular integer;
  declare variable id_profile_data integer;
  declare variable id_acc_template_person integer;
  declare variable number_1 varchar(20);
  declare variable number_2 varchar(20);
  declare variable new_res_number varchar(62);
  declare variable g_dbkey char(8);
  declare variable is_child integer;
  declare variable id_guarantee_policy integer;
  declare variable block_cc varchar(255);
  declare variable virtual_room varchar(10);
  declare variable err_text varchar(255);
  declare variable is_posting_stopped integer;
  declare variable id_eating_object integer;
begin
  select RD.RDB$DB_KEY, RD.ID_AGENT_PROFILE, RD.CHECK_STATUS, RD.FROM_DATE, RD.TO_DATE,
         RD.ADULT_COUNT, RD.CHILD_COUNT, RD.ID_ROOM_TYPE, RD.ID_ROOM, RD.ID_BOARD, RD.ID_RATE,
         RD.CUSTOM_PRICE, RD.CUSTOM_CURRENCY, RD.VAUCHER_NUM, RD.VAUCHER_DATE, RD.VAUCHER_TEXT, RD.VAUCHER_NUM2,
         RD.VAUCHER_DATE2, RD.TRANSFER_IN_TIME, RD.TRANSFER_IN_NOTE, RD.TRANSFER_OUT_TIME, RD.TRANSFER_OUT_NOTE,
         RD.COMMING_KIND, RD.LEAVING_KIND - 1, RD.IS_VIP, RD.COUNTRY, RD.CODE_FIRST_FOOD, RD.I_SPECIAL_TREATMENT,
         RD.ID_NOM_MARKET_SEGMENT, RD.ID_NOM_SOURCE_CODE, RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_HEAR_REASON,
         RD.ID_NOM_COME_REASON, RD.ID_AGENT_ACCOUNT_RULE, RD.ACC_ROUTING, RD.ID_PERSON_PAYMENT, RD.ID_AGENT_PAYMENT,
         RD.ROOM_FEATURES, RD.ID_HK_PLAN, RD.ID_GROUP, RD.ID_HOTEL, RD.NOTE, RD.NOTE_REMINDERS,
         RD.GUARANTEE_DEPOSIT, RD.GUARANTEE_CURRENCY, RD.ID_ACC_TEMPLATE_PERSON,
         RD.NUMBER_1, rd.NUMBER_2, rd.ID_GUARANTEE_POLICY, rd.BLOCK_CC, rd.IS_POSTING_STOPPED, rd.ID_EATING_OBJECT
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail_source
  into   :rd_dbkey_old, :id_agent_profile, :check_status, :arrival_date, :departure_date,
         :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff,
         :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
         :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
         :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
         :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
         :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
         :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
         :guarantee_deposit, :guarantee_currency, :id_acc_template_person,
         :number_1, :number_2,:id_guarantee_policy, :block_cc, :is_posting_stopped, :id_eating_object;

  select first 1 sp.ITEM
  from   SYSTEM_STRING_PARSER(:guest_ids, ',') sp
  into   :id_titular;

  select min(g.FROM_DATE), max(g.TO_DATE)
  from   GUEST G
  where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL_SOURCE
         and ','||:GUEST_IDS||',' containing ','||g.ID_GUEST||','
  into   :arrival_date, :departure_date;

  if (exists (select *
              from   RESERV_DETAIL RD
              where  RD.ID_TITULAR = :id_titular
                     and RD.ID_RESERV_DETAIL = :id_reserv_detail_source))
  then exception BOOKING_EXCEPTION 'Titular can not be splited in new reservation';

  execute procedure RES_GET_PERSON_PROFILE$INT(:id_titular)
  returning_values  :id_person_profile, :id_profile_data;

  new_res_number = iif(coalesce(:number_1,'')='','.',:number_1||'.')
                   || coalesce(:number_2, '')
                   || '.0';  -- fictive suffix, needed for unique constraint limitation, that will be replaced with real one


  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, :check_status, :arrival_date, :departure_date,
                    0, 0, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
                    :guarantee_deposit, :guarantee_currency, 0, null, :new_res_number, :id_acc_template_person,
                    :id_guarantee_policy, :block_cc, :id_eating_object)
  returning_values  :rd_dbkey_new, :new_id_reserv_detail, :warn_code;

  execute procedure RES_NUMBER_SUFFIX_GEN (:NEW_ID_RESERV_DETAIL)
  returning_values  (:new_res_number);  -- add suffix to new (splited) booking number (empty on create)

  update RESERV_DETAIL NR
  set    nr.IS_POSTING_STOPPED = :is_posting_stopped
  where  nr.RDB$DB_KEY = :rd_dbkey_new;

  -- there is no need guests deleting, because new splited reservation is created with 0 guests
  adult_count = 0; child_count = 0;
  for
    select G.ID_GUEST, G.RDB$DB_KEY, G.IS_CHILD
    from   SYSTEM_STRING_PARSER(:guest_ids, ',') SP
           join GUEST G on G.ID_GUEST = SP.ITEM
    into   :id_guest, :g_dbkey, :is_child
  do begin
    execute procedure GUEST_SET_EDIT_STATUS$INT (:g_dbkey, 'REBUILD', 'add');

    update GUEST G
    set    G.ID_RESERV_DETAIL = :new_id_reserv_detail
    where  G.ID_GUEST = :id_guest;

    adult_count = :adult_count + (1-:is_child);
    child_count = :child_count + :is_child;

    if (:id_guest = :id_titular) then begin
      update RESERV_DETAIL RD
      set    RD.ID_TITULAR = :id_titular
      where  RD.RDB$DB_KEY = :rd_dbkey_new;

      update GUEST_DATA GD
      set    GD.ID_PERSON_DATA = :id_profile_data
      where  GD.ID_GUEST = :id_titular;
    end
  end

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL_SOURCE, 'RES_SPLIT',
          f_character(29) || :new_res_number || f_character(28) || :adult_count || ' + ' || :child_count);

  -- calling RES_SAVE_PROFILING$INT is unnecessary, it is called into RES_CREATE_SET$INT with same params
  -- here is needed to set reserv accounts per splited guests and reroute posting only (accomplished in next procedure)
  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey_new);

  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_old);
  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_new);

  update RESERV_DETAIL ORD
  set    ord.ROOM_PRICE = null
  where  ord.RDB$DB_KEY = :rd_dbkey_old;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_old, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_new, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  if (:id_room < 0) then begin
    virtual_room = gen_id(GEN_VIRTUAL_ROOM, 1);
    update RESERV_DETAIL RD
    set    rd.VIRTUAL_ROOM = '<'||:virtual_room||'>'
    where  rd.ID_ROOM = :id_room;
  end
end
^

/* Alter (RES_SPLIT_MULTI$RSV) */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
begin
  for
    select RD.ID_RESERV_DETAIL, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :id_reserv_detail, :id_titular
  do begin
    for
      select G.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.ID_GUEST <> :id_titular
      into   :id_guest
    do begin
      execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
      returning_values  :id_splited_reservation;

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_TAR_CALC_FINALIZE$INT for: RES_TAR_CALC_REPOST$INT */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(TAR_CALC_ERR INTEGER,
ID_TAR_CALC INTEGER,
RD_DBKEY_INIT CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_TAR_CALC_REPOST$INT) */
ALTER PROCEDURE RES_TAR_CALC_REPOST$INT(ID_TAR_CALC TYPE OF ID_REF,
ID_RESERV_DETAIL TYPE OF ID_REF,
RECALC_MARKER VARCHAR(40))
 AS
declare variable id_guest type of id_ref;
  declare variable id_service type of id_ref;
  declare variable id_tariff type of id_ref;
  declare variable date_post type of tdate;
  declare variable qty_post type of tqty;
  declare variable price_orig type of tprice;
  declare variable curr_orig type of tcurrency;
  declare variable id_room type of id_ref;
  declare variable is_base type of tlogical;
  declare variable short_code type of tdescription_long;
  declare variable id_account type of id_ref;
  declare variable gfrom_date type of tdate;
  declare variable gto_date type of tdate;
  declare variable ap_db_key char(8);
  declare variable id_pack_service type of id_ref;
  declare variable err_code type of id_ref;
  declare variable err_text type of tdescription_long;
  declare variable id_master_account_post type of id_ref;
  declare variable id_acc_post type of id_ref;
  declare variable rate_orig type of tprice;
  declare variable is_base_account type of id_ref;
  declare variable id_extra_account type of id_ref;
  declare variable no_use varchar(255);
begin
  for
    select   TCP.ID_GUEST, TCP.ID_SERVICE, TCP.ID_TARIFF, TCP.DATE_POST, TCP.QTY_POST,
             round_f(TCP.PRICE_ORIG, c.ROUND_TO), TCP.CURR_ORIG, TCP.ID_ROOM, TCP.IS_BASE,
             TCP.SHORT_CODE, iif(coalesce(AGP.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'NONE', 0, 1),
             G.ID_BASE_ACCOUNT, G.FROM_DATE, G.TO_DATE, G.ID_ACCOUNT
    from     TAR_CALC_POST$TMP TCP
             join GUEST G on G.ID_GUEST = TCP.ID_GUEST
             join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
             join SERVICES S on S.ID_SERVICE = TCP.ID_SERVICE
             join CURRS c on c.CURR = tcp.CURR_ORIG
             left outer join AGENT_PACKET AGP on AGP.ID_SERVICE = S.ID_SERVICE and AGP.ID_AGENT = G.ID_AGENT
    where    TCP.ID_TAR_CALC = :id_tar_calc
             and ((rd.ID_RESERV_DETAIL = :ID_RESERV_DETAIL)
                  or (coalesce(RD.IS_POSTING_STOPPED, 0) = 0 and RD.POSTING_TRANSACTION_UUID is not null))
    order by TCP.ID_GUEST asc, TCP.DATE_POST asc, TCP.IS_BASE desc
    into     :id_guest, :id_service, :id_tariff, :date_post, :qty_post,
             :price_orig, :curr_orig, :id_room, :is_base, :short_code, :is_base_account,
             :id_account, :gfrom_date, :gto_date, :id_extra_account
  do begin
    ap_db_key = null;
    if (:is_base = 1) then begin
      select AP.RDB$DB_KEY, AP.ID_MASTER_ADDINS_ACC_POST, AP.RATE_ORIG, AP.ID_PACK_SERVICE
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.DATE_POST = :date_post
             and AP.IS_BASE = 1
      into   :ap_db_key, :id_master_account_post, :rate_orig, :id_pack_service;

      execute procedure sys_dbg('tar TAR_CALC_REPOST$INT price_orig = '||coalesce(:price_orig, 'null'));
      execute procedure sys_dbg('tar TAR_CALC_REPOST$INT ap_db_key = '||coalesce(:ap_db_key, 'null'));

      if (:ap_db_key is null) then begin
        id_master_account_post = -1;
        rate_orig = null;
        execute procedure GUEST_POST_GET_PACK_SERVICE(:id_service, :id_guest, :date_post)
        returning_values  :id_pack_service;
      end
    end else begin
      short_code = '';
      select first 1 APU.rdb$db_key
      from   ACCOUNT_POST APU
      where  APU.ID_MASTER_ADDINS_ACC_POST = :id_master_account_post
             and APU.ID_SERVICE = :id_service
      order by apu.IS_ANUL asc, apu.ID_ACCOUNT_POST asc
      into   :ap_db_key;

      if ((:ap_db_key is null) and (:is_base_account <> 1)) then id_account = :id_extra_account;
    end

    if (:ap_db_key is null) then begin
      execute procedure ACCOUNT_POSTING_ADD$INT(
        :id_account, :id_guest, -1, :date_post, :id_service, :id_tariff, :id_room, :is_base, :qty_post,
        :price_orig, :curr_orig, :rate_orig, :short_code, :gfrom_date, :gto_date, 'PACK='||:id_pack_service, '',
        :recalc_marker, :id_master_account_post)
      returning_values  :err_code, :err_text, :id_acc_post;
      if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

      if (:is_base = 1) then id_master_account_post = :id_acc_post;

    end else begin
      execute procedure ACCOUNT_POSTING_UPDATE$INT(
        :ap_db_key, :id_service, :id_tariff, :id_room, :qty_post, 0, :price_orig, :curr_orig, :rate_orig,
        :recalc_marker, :short_code, :gfrom_date, :gto_date, 1, :id_account)
      returning_values  :no_use, :no_use, :no_use;
    end

  end

  ap_db_key = null;
  id_guest = null;
  for
    select distinct TCP.ID_GUEST
    from   TAR_CALC_POST$TMP TCP
    where  tcp.ID_TAR_CALC = :ID_TAR_CALC
    into   :id_guest
  do begin
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.CHANGED_TEXT is distinct from :recalc_marker
             and AP.ID_MASTER_ADDINS_ACC_POST > 0
             and AP.IS_ANUL = 0
      into   :ap_db_key
    do begin
      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_db_key, :recalc_marker);
    end
  end

  delete from RESERV_PREPOST RP where RP.ID_RESERV_DETAIL = :id_reserv_detail;
  execute procedure RES_TAKE_POSTING_RESPONSIBILITY (:ID_RESERV_DETAIL);
end
^

/* Alter (RESMULTI_CREATE$RSV) */
ALTER PROCEDURE RESMULTI_CREATE$RSV(ID_HOTEL INTEGER,
ID_ROOM_TYPE INTEGER,
TRANSFER_OUT_TIME TIME,
TRANSFER_IN_TIME TIME,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
TRANSFER_OUT_NOTE VARCHAR(50),
TRANSFER_IN_NOTE VARCHAR(50),
NOTE VARCHAR(255),
ID_BOARD INTEGER,
VOUCHER_DATE DATE,
VOUCHER_NUMBER VARCHAR(20),
VOUCHER_TEXT VARCHAR(30),
CHECK_STATUS INTEGER,
ID_TARIFF INTEGER,
COUNTRY_CODE VARCHAR(20),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
NOTE_REMINDERS VARCHAR(50),
TITULAR_NAME VARCHAR(100),
SPLIT_ON_CHECKIN INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
NUMBER VARCHAR(62),
NEW_ID_TITULAR INTEGER,
NEW_FROM_DATE TYPE OF TDATE,
WARN_CODE TYPE OF TRANGE)
 AS
declare variable rd_dbkey char(8);
  declare variable id_person_profile integer;
  declare variable pd_dbkey char(8);
  declare variable id_acc_template_person integer;
  declare variable first_name varchar(30);
  declare variable surname varchar(30);
  declare variable family_name varchar(30);
begin

  select sv.SETTING_VALUE
  from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :ID_HOTEL) sv
  into   :id_acc_template_person;

  execute procedure RES_CREATE_SET$INT(:id_agent_profile, null, :check_status, :arrival_date, :departure_date,
                    :adult_count, :children_count, :id_room_type, null, :id_board, :id_tariff, null,
                    null, null, :voucher_number, :voucher_date, :voucher_text, '',
                    null, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    1, 0, 0, :country_code, :code_first_food, '',
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    '', :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders, null, null,
                    :split_on_checkin, null, null, :id_acc_template_person, null, null, :ID_EATING_OBJECT)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :WARN_CODE;

  select RD.NUMBER, RD.ID_PERSON_PROFILE, RD.ID_TITULAR
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :number, :id_person_profile, :new_id_titular;

  if (:titular_name <> '') then begin
    select PD.RDB$DB_KEY
    from   PROFILE P
           join PROFILE_PERSON PP on PP.ID_PROFILE = P.ID_PROFILE
           join PERSON_DATA PD on PD.ID_PERSON_DATA = PP.ID_PERSON_DATA
    where  P.ID_PROFILE = :id_person_profile
    into   :pd_dbkey;

    select PP.FIRST_NAME, PP.SURNAME, PP.FAMILY_NAME
    from   PERSON_NAME_PARSE$INT (:TITULAR_NAME) PP
    into   :first_name, :surname, :family_name;

    update PERSON_DATA PD
    set    PD.PERSON_NAME2 = :titular_name,
           PD.FIRST_NAME = :first_name,
           PD.SURNAME = :surname,
           PD.FAMILY_NAME = :family_name
    where  PD.RDB$DB_KEY = :pd_dbkey;
  end

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;
end
^

/* Alter (RESOURCE_RESERVATION_CHECK_IN) */
ALTER PROCEDURE RESOURCE_RESERVATION_CHECK_IN(ID_RESOURCE_RESERVATION INTEGER,
SERVICE_PRICE NUMERIC(15,2),
SERVICE_CURR VARCHAR(3))
 RETURNS(OUT_ID_ACCOUNT INTEGER,
OUT_ID_ACCOUNT_POST INTEGER)
 AS
declare variable old_status varchar(20);
  declare variable new_status varchar(20);
  declare variable dbkey char(8);
  declare variable id_service id_ref;
  declare variable price_post tprice;
  declare variable curr_post TCURRENCY;
  declare variable is_manual_price TLOGICAL;
  declare variable is_details tlogical;
  declare variable post_description tobject_text;
  declare variable id_reserv_detail integer;
  declare variable post_date tdate;
  declare variable from_datetime tdatetime;
  declare variable to_datetime tdatetime;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  new_status = 'CHECKED_IN';

  select r.RDB$DB_KEY, R.STATUS, rd.ID_RESERV_DETAIL
  from   RESOURCE_RESERVATION R
         left outer join RESERV_DETAIL rd on rd.NUMBER = r.BOOKING_NUMBER
                                             and rd.IS_ANUL = 0
                                             and rd.SUBSCRIBER_ID is not distinct from r.SUBSCRIBER_ID
  where  R.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION
  into   :dbkey, :old_status, :id_reserv_detail;

  if (:old_status = :NEW_STATUS) then exit;
 
  if (:old_status is distinct from 'RESERVED') then exception ASSERT '-511';

  if (exists (select RP.ID_RESOURCE_RESERVATION
              from   RESOURCE_RESERV_POST RP
                     join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = RP.ID_ACCOUNNT_POST
              where  RP.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION)) then
  begin
    exception ASSERT '-505';
  end

  if (:id_reserv_detail is not null) then begin
    execute procedure RESOURCE_RESERV_SERVICE_GET (:ID_RESOURCE_RESERVATION)
    returning_values (:id_service, :price_post, :curr_post, :is_manual_price, :is_details, :post_description,
                     :post_date, :from_datetime, :to_datetime);
  
    if (:is_manual_price = 1) then begin
      price_post = :SERVICE_PRICE;
      curr_post = :SERVICE_CURR;
    end

    if (:price_post is null) then exception ASSERT 'Unspecified service price!';
    if (:curr_post is null) then exception ASSERT 'Unspecified price currency!';
  
    execute procedure POST_SERVICE_ON_RESERVATION$INT (:id_reserv_detail, :id_service, 1, 0,
            1, :price_post, :curr_post, :from_datetime, :to_datetime,
            '', '', :post_date, 'RESOURCE', :post_description)
    returning_values (:ERR_CODE, :ERR_TEXT, :OUT_ID_ACCOUNT, :OUT_ID_ACCOUNT_POST);
    if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
  
    insert into RESOURCE_RESERV_POST(ID_RESOURCE_RESERVATION, ID_ACCOUNNT_POST)
    values (:ID_RESOURCE_RESERVATION, :OUT_ID_ACCOUNT_POST);
  end

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = :NEW_STATUS
  where  RR.RDB$DB_KEY = :dbkey;

end
^

/* Alter (RIGHTS_GROUP_USER_MODIFY) */
ALTER PROCEDURE RIGHTS_GROUP_USER_MODIFY(USER_NAME VARCHAR(30),
ID_RIGHT_GROUP INTEGER,
OPERATION VARCHAR(50))
 AS
declare variable right_group varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add,del');

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS RG
  where  RG.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'add') then begin
    insert into RIGHTS_USER_GROUPS (USER_NAME, ID_RIGHT_GROUP)
    values (:user_name, :id_right_group);

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_ADDED',
            f_character(29) || :USER_NAME  || f_character(28) || :right_group);

  end else begin
    delete from RIGHTS_USER_GROUPS
    where USER_NAME = :user_name
          and ID_RIGHT_GROUP = :id_right_group;

    if (row_count > 0) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_REMOVED',
              f_character(29) || :USER_NAME || f_character(28) || :right_group);

  end

  when sqlcode -803 do begin
    /* ERR_TEXT = '       ! ' ;*/
    exit;
  end
end
^

/* empty dependent procedure body */
/* Clear: BLOCK_ANNUL$BLK for: ROOM_HOUSEKEEPING */
ALTER PROCEDURE BLOCK_ANNUL$BLK(ID_BLOCK_ROOM INTEGER,
OPERATION VARCHAR(30))
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: EAI_ROOM_STATUS_SET for: ROOM_HOUSEKEEPING */
ALTER PROCEDURE EAI_ROOM_STATUS_SET(ROOM_NAME VARCHAR(10),
OPERATION VARCHAR(20),
TAG VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: END_WORK for: ROOM_HOUSEKEEPING */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_CHECK_OUT_GUESTS$RSV for: ROOM_HOUSEKEEPING */
ALTER PROCEDURE RES_CHECK_OUT_GUESTS$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND SMALLINT = 0)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ROOM$INT for: ROOM_HOUSEKEEPING */
ALTER PROCEDURE RES_SAVE_ROOM$INT(RD_DBKEY /* TYPE OF TDB_KEY */ CHAR(8),
ID_ROOM /* TYPE OF ID */ INTEGER,
ID_RES_ROOM_TYPE /* TYPE OF ID */ INTEGER,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE /* TYPE OF TLOGICAL */ SMALLINT = null)
 RETURNS(WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ROOM_HOUSEKEEPING) */
ALTER PROCEDURE ROOM_HOUSEKEEPING(ID_ROOM INTEGER,
ACTION_REASON VARCHAR(50),
SET_OPTIONS VARCHAR(255))
 AS
declare variable r_dbkey char(8);
  declare variable old_is_clean integer;
  declare variable old_is_inspected integer;
  declare variable new_is_clean integer;
  declare variable new_is_inspected integer;
  declare variable new_id_clean_log integer;
  declare variable machine_name varchar(30);
  declare variable eai_status varchar(50);
  declare variable eai_note varchar(50);
  declare variable owing_status varchar(30);
  declare variable id_hotel integer;
  declare variable system_date date;
begin
  /*  Description:
  ||  set_options = {set_clean, set_dirty, set_inspected, set_uninspected, set_text}
  ||  action_reason = {EW_DAY, MANUAL, BLOCK_EXP, BLOCK_STOP, CHECK_OUT, GST_MOVED, EXT_IFC}
  */
  r_dbkey = null;
  select R.rdb$db_key, R.IS_CLEAN, R.IS_INSPECTED, R.ID_HOTEL
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :r_dbkey, :old_is_clean, :old_is_inspected, :id_hotel;
  if (:r_dbkey is null) then exit;

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) SD
  into   :system_date;

  select rp.STATUS
  from   ROOM_PERIOD$PMS RP
  where  RP.ID_ROOM = :ID_ROOM
         and :system_date between RP.FROM_DATE and rp.TO_DATE
  into   :owing_status;

  if (:owing_status = 'PRIVATE') then SET_OPTIONS = 'set_clean,set_inspected';

  if (:set_options like '%set_clean%') then new_is_clean = 1;
  else if (:set_options like '%set_dirty%') then new_is_clean = 0;
  else new_is_clean = :old_is_clean;

  if (:set_options like '%set_inspected%') then new_is_inspected = 1;
  else if (:set_options like '%set_uninspected%') then new_is_inspected = 0;
  else new_is_inspected = :old_is_inspected;

  if (:new_is_clean = 1) then eai_status = 'CLEAN';
  else eai_status = 'DIRTY';
  if (:new_is_inspected = 1) then eai_status = :eai_status||'_'||'INSPECTED';
  else eai_status = :eai_status||'_'||'NOTINSPECTED';

  if (:set_options like '%set_text%') then begin
    /* SET_TEXT MUST BE ALONE. CAN NOT BE COMBINED WITH ANOTHER COMMAND */
    eai_note = substring(:set_options from 10  for 20);
  end else eai_note = null;

  update ROOMS Ru
  set    Ru.IS_CLEAN = :new_is_clean,
         Ru.IS_INSPECTED = :new_is_inspected,
         Ru.CLEAN_TEXT = coalesce(:eai_note, Ru.CLEAN_TEXT)
  where  Ru.rdb$db_key = :r_dbkey;

  if (:new_is_clean <> :old_is_clean) then begin
    execute procedure SYSTEM_SESSION_GET('MACHINE_NAME')
    returning_values  :machine_name;

    new_id_clean_log = gen_id (GEN_ROOM_CLEAN_LOG_ID, 1);
    insert into ROOM_CLEAN_LOG(ID_CLEAN_LOG, ID_ROOM, TEXT, NEW_CLEAN_STATUS,
      ACTION_REASON, ACTION_USER, ACTION_DATETIME, MACHINE_NAME)
    values (:new_id_clean_log, :id_room, '', :new_is_clean,
      :action_reason, current_user, current_timestamp, :machine_name);
  end

  execute procedure EAI_ROOM_SET_STATUS('ifc_clean_manager', :id_room, :eai_status, :action_reason, :eai_note);
end
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_MODIFY for: SAFE_OCCUPANCY_POSTING$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE /* TYPE OF ID */ INTEGER,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100))
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_NEW for: SAFE_OCCUPANCY_POSTING$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE /* TYPE OF ID */ INTEGER,
FROM_DATETIME /* TDATETIME */ TIMESTAMP,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100),
BOOKING_NUMBER /* TYPE OF TRES_NUMBER */ VARCHAR(62),
ID_EXTERNAL_CLIENT_ACCCOUNT /* TYPE OF ID_REF */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER,
ID_RESOURCE_RESERVATION /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SAFE_OCCUPANCY_POSTING$INT) */
ALTER PROCEDURE SAFE_OCCUPANCY_POSTING$INT(ID_RESOURCE_RESERVATION TYPE OF ID,
ID_SERVICE TYPE OF ID,
PRICE TYPE OF TPRICE,
CURRENCY TYPE OF TCURRENCY,
PRICE_DESCRIPTION TYPE OF TDESCRIPTION_SHORT,
ID_RESERV_DETAIL TYPE OF ID,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF = null)
 RETURNS(DOC_SELECTED TYPE OF TRANGE)
 AS
declare variable from_datetime timestamp;
  declare variable to_datetime timestamp;
  declare variable ap_dbkey TDB_KEY;
  declare variable id_account_post integer;
  declare variable safe_name TOBJECT_NAME;
  declare variable no_use varchar(255);
  declare variable new_ac varchar(2);
  declare variable err_code integer;
  declare variable err_text varchar(255) ;
  declare variable occupant_name tperson_name;
  declare variable id_room integer;
  declare variable id_tariff integer;
begin
  DOC_SELECTED = null;
  select od.FROM_DATETIME, od.TO_DATETIME, ap.RDB$DB_KEY, ap.ID_ACCOUNT_POST,
         s.SAFE_NAME, rr.OCCUPANT_NAME, ap.ID_ROOM, ap.ID_TARIFF
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join SAFES s on s.ID_SAFE = od.ID_RESOURCE
         left outer join RESOURCE_RESERV_POST rrp on rrp.ID_RESOURCE_RESERVATION = rr.ID_RESOURCE_RESERVATION
         left outer join ACCOUNT_POST ap on ap.ID_ACCOUNT_POST = rrp.ID_ACCOUNNT_POST
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :from_datetime, :to_datetime, :ap_dbkey, :id_account_post,
         :safe_name, :occupant_name, :id_room, :id_tariff;

  new_ac = null;
  if (:id_account_post is not null) then begin
    execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
            :id_tariff, :id_room, 1, 0, :price, :currency, null, null, 'RESOURCE', :from_datetime, :TO_DATETIME, 1)
    returning_values :no_use, :no_use, :new_ac;
  end else begin
    if (:id_reserv_detail is not null) then begin
      execute procedure POST_SERVICE_ON_RESERVATION$INT (:id_reserv_detail, :id_service, 1, 0,
              1, :price, :currency, :from_datetime, :to_datetime,
              '', '', cast(:from_datetime as date), 'RESOURCE', null)
      returning_values (:ERR_CODE, :ERR_TEXT, :no_use, :id_account_post);
      if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      new_ac = '00';
    end else if (:ID_EXTERNAL_CLIENT_ACCCOUNT is not null) then begin
      execute procedure POST_SERVICE_ON_ACCOUNT$INT (:ID_EXTERNAL_CLIENT_ACCCOUNT, :id_service,
              1, 0, 1, :price, :currency, :from_datetime, :TO_DATETIME, '', '',
              cast(:from_datetime as date), 'RESOURCE', null, null)
      returning_values (:err_code, :err_text, :id_account_post);
      if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      new_ac = '00';
    end
  end

  if (:new_ac is null) then
    exception ASSERT '-1067' || f_character(31) || f_character(29) || :safe_name || f_character(28) || :occupant_name;

  if (:new_ac = '00') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);
    update ACCOUNT_POST AP
    set    ap.DOC_SELECTED = :DOC_SELECTED
    where  ap.ID_ACCOUNT_POST = :id_account_post;
  end

  update or insert into ACCOUNT_POSTING_DET (ID_ACCOUNT_POST, POST_TEXT, QTY,
         FROM_DATETIME, TO_DATETIME, RESOURCE_TEXT, EXT_USER_ANUL)
  values (:id_account_post, :safe_name ||' / '||formatdate(:from_datetime, 'D;dd.mm.yy(hh:mm)')||' - '||formatdate(:to_datetime, 'D;dd.mm.yy(hh:mm)')||' / '
          ||substring(replace(:price_description, F_CRLF(), ';') from 1 for 100), 1, :from_datetime, :to_datetime, :safe_name, null);

  if (not exists (select rp.ID_ACCOUNNT_POST
                  from   RESOURCE_RESERV_POST rp
                  where  rp.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION
                         and rp.ID_ACCOUNNT_POST = :id_account_post)) then
  begin
    insert into RESOURCE_RESERV_POST (ID_RESOURCE_RESERVATION, ID_ACCOUNNT_POST)
    values (:id_resource_reservation, :id_account_post);
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_PARAMS$INT for: TARIFA_GET_PARAM */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TARIFA_GET_PARAM) */
ALTER PROCEDURE TARIFA_GET_PARAM(ID_PARAM INTEGER,
FOR_DATE DATE,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER)
 RETURNS(OUT_VALUE VARCHAR(255))
 AS
declare variable is_interface integer;
  declare variable param_code varchar(30);
  declare variable is_value integer;
  declare variable int1 integer;
  declare variable data_type varchar(10);
  declare variable pvalue varchar(20);
  declare variable from_ date;
  declare variable to_ date;
begin
  select TP.IS_INTERFACE, TP.PARAM_CODE, TP.IS_VALUE, TP.DATA_TYPE, TP.PVALUE
  from   TARIFA_PARAMS TP
  where  ID_TARIFA_PARAM = :ID_PARAM 
  into   :is_interface, :param_code, :is_value, :data_type, :pvalue;
  /*get interface params*/
  if (:PARAM_CODE = 'NATION2') then
    PARAM_CODE = 'NATION'; /* !!!!!!!!!! */

  /*get value params*/
  if (:IS_VALUE = 1) then
    OUT_VALUE = :pvalue;

  /*get internal params*/
  OUT_VALUE = null;
  if (:IS_INTERFACE = 0) then begin
    if (:PARAM_CODE = 'TODAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE, 'D;dd/mm/yyyy');

    end else if (:PARAM_CODE = 'WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE, 'DW;MON');

    end else if (:PARAM_CODE = 'NEXT_DATE_WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE + 1, 'DW;MON');

    end else if (:PARAM_CODE = 'PREV_DATE_WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE - 1, 'DW;MON');

    end else if (:PARAM_CODE = 'REQUIRED_WEEK_DAYS') then begin
      select maxdate(ti.FROM_DATE, :FOR_DATE -3), mindate(ti.TO_DATE -1, :FOR_DATE +3)
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :from_, :to_;
      
      for
        select formatdate(RLP.OUT_DATE, 'DW;MON')
        from   SYSTEM_LOOP_PERIOD(:from_, :to_) RLP
        into   :int1
      do OUT_VALUE = :OUT_VALUE||','||:int1;

    end else if (:PARAM_CODE = 'ARRIVAL_WEEK_DAYS') then begin
      select formatdate(ti.FROM_DATE, 'DW;MON')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'PRESTOI') then begin
      select cast(ti.TO_DATE - ti.FROM_DATE as integer)
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'FROM_DATE') then begin
      select formatdate(ti.FROM_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TO_DATE') then begin
      select formatdate(ti.TO_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'DAYS_PASSED') then begin
       /* 01  03 -  01-1, 02-2   (        )*/   
       select cast((:FOR_DATE - G.FROM_DATE + 1) as integer)
       from   TAR_CALC_INPUT$TMP G
       where  G.ID_TAR_INPUT = :ID_TAR_INPUT
       into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'DAYS_TO_STAY') then begin
       /* 01  03 -  01-2, 02-1    (  )*/
       select cast((G.TO_DATE - :FOR_DATE - 1) as integer)
       from   TAR_CALC_INPUT$TMP G
       where  G.ID_TAR_INPUT = :ID_TAR_INPUT
       into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_GUESTS') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_CHILDREN') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.IS_CHILD = 1
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_ADULTS') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.IS_CHILD is distinct from 1
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_GUESTS_BY_ACCOUNT') then begin
      select (select count(*)
              from   GUEST G
                     join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
              where  G.ID_BASE_ACCOUNT = ti.ID_BASE_ACCOUNT
                     and G.FROM_DATE <= :FOR_DATE
                     and G.TO_DATE > :FOR_DATE
                     and RD.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP ti
      where  ti.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TYPE_ROOM') then begin
      select rt.TYPE_ROOM
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join ROOM_TYPES RT on RT.ID_ROOM_TYPE = tid.ID_ROOM_TYPE
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
      into   :OUT_VALUE;
      /* TO PRESEVE COMPATIBILITY WITH OLD TARIFF VERSIONS */
      /* WE HAVE TO RETURN THE NAME NOT THE ID !           */

    end else if (:PARAM_CODE = 'TYPE_STAY') then begin
      select ts.TYPE_STAY
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join TYPE_STAY TS on ts.ID_TYPE_STAY = tid.ID_TYPE_STAY
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TYPE_HRANA') then  begin
      select m.NAME
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join MEALS m on m.ID_BOARD = tid.ID_BOARD
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;
      OUT_VALUE = trim(coalesce(:OUT_VALUE, ''));

    end else if (:PARAM_CODE = 'PACK_ITEMS') then begin
      OUT_VALUE = null;
      select TID.PACKET_ITEMS
      from   TAR_CALC_INPUT$TMP TID
      where  TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;
      OUT_VALUE = coalesce(:OUT_VALUE, '~~');
      -- strfloateval('POS("~2~", :PACK_ITEMS)>0', ';:PACK_ITEMS,STRING,~2~3~D~')

    end else if (:PARAM_CODE = 'AGE') then begin
      select ti.GUEST_AGE
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_SEX') then begin
      select G.GUEST_SEX
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE ;
      if ((:OUT_VALUE is null) or (:OUT_VALUE = '')) then OUT_VALUE = '-' ;

    end else if (:PARAM_CODE = 'NATION') then begin
      select tid.COUNTRY_CODE
      from   TAR_CALC_INPUT$TMP TID
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_FIRST_DATE') then begin
      select cast(iif(G.FROM_DATE = :FOR_DATE, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_LAST_DATE') then begin
      select cast(iif(G.TO_DATE -1 = :FOR_DATE, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_LATE_CHECKOUT') then begin
      select g.IS_LATE_CHECKOUT
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_FIRST_GUEST_IN_ROOM') then begin
      select (select count(ti.ID_TAR_INPUT)
              from   TAR_CALC_INPUT$TMP ti
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and ti.ID_GUEST < t.ID_GUEST)
      from   TAR_CALC_INPUT$TMP t
      where  t.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :int1;

      if (:int1 = 0) then OUT_VALUE = 1; else OUT_VALUE = 0;
      
    end else if (:PARAM_CODE = 'IS_DIFER_NATIONS') then begin
      select (select cast(iif(count(distinct ti.COUNTRY_CODE) > 1, 1, 0) as integer)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_GROUP') then begin
      select cast(iif(g.ID_GROUP is not null, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_NIGHTS_BY_ACCOUNT') then begin
      /*          . */
      select (select cast(sum (G_IN_R.TO_DATE - G_IN_R.FROM_DATE) as integer)
              from   GUEST G_IN_R
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_R.ID_RESERV_DETAIL
              where  G_IN_R.ID_BASE_ACCOUNT = G.ID_BASE_ACCOUNT
                     and G_IN_R.CHECK_STATUS = 0
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_INTURN_BYACCOUNT') then begin
      select (select cast(count(G.ID_GUEST) as integer)
              from   GUEST G
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL and rd.IS_ANUL = 0
              where  G.ID_BASE_ACCOUNT = t.ID_BASE_ACCOUNT
                     and G.ID_GUEST <= t.ID_GUEST)
      from   TAR_CALC_INPUT$TMP t
      where  t.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'PAX_PRICE_WO_ADDINS') then begin
      /*             */
      /* PRICE_ORIG          */
      -- ?????    ???
      /*select  max(AP.PRICE_ORIG)
      from    ACCOUNT_POST AP 
      where   AP.ID_GUEST = :ID_GUEST
              and AP.DATE_POST = :FOR_DATE
              and AP.IS_BASE = 1
      plan    (AP index (ACCOUNT_POST_IDX6))
      into    :OUT_VALUE;
      */
      OUT_VALUE = null;

    end else if (:PARAM_CODE = 'ROOM_FEATURES') then begin
      select substring(R.FEATURES from 1 for 255)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join ROOMS R on r.ID_ROOM = tid.ID_ROOM
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_NIGHTS') then begin
      select (select cast(sum (G_IN_V.TO_DATE - G_IN_V.FROM_DATE) as integer)
              from   GUEST G_IN_V
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_V.ID_RESERV_DETAIL
              where  rd.ID_AGENT_PROFILE is not distinct from G.ID_AGENT_PROFILE
                     and G_IN_V.VAUCHER_NUM = G.VOUCHER_NUM
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE ;

    end else if (:PARAM_CODE = 'VAUCHER_GUESTS') then begin
      select (select count (G_IN_V.ID_GUEST)
              from   GUEST G_IN_V
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_V.ID_RESERV_DETAIL and rd.IS_ANUL = 0
              where  rd.ID_AGENT_PROFILE is not distinct from G.ID_AGENT_PROFILE
                     and G_IN_V.VAUCHER_NUM = G.VOUCHER_NUM
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_DATE') then begin
      select formatdate(G.VOUCHER_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_TEXT') then begin
      select G.VOUCHER_TEXT
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_INTURN_BYROOM') then begin
      select (select count(*)
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_GUEST <= t.ID_GUEST)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'ADULT_INTURN_BYROOM') then begin
      OUT_VALUE = 0;
      select (select count(*)
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_GUEST <= t.ID_GUEST
                     and ti.IS_CHILD = 0)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
             and t.IS_CHILD = 0
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'CHILD_INTURN_BYROOM') then begin
      OUT_VALUE = 0;
      select (select count(*)
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_GUEST <= t.ID_GUEST
                     and ti.IS_CHILD = 1)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
             and t.IS_CHILD = 1
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_TYPE') then begin
      select G.ID_GUEST_TYPE
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else begin
      exception RATING_EXCEPTION 'Unsupported param - '||:PARAM_CODE;
    end

  end /*PART OF INTERNAL PARAMS*/


  /**********************************************/
  begin
    /* the source of the next check is gone with the wind
    /* but we must distinguish different data types */
    if ((:OUT_VALUE is null) or (:OUT_VALUE = '')) then begin
      /*not allow nulls*/
      if (:DATA_TYPE = 'DATE') then OUT_VALUE = '01/01/1899';
      else OUT_VALUE = '-1';  -- Unspecified
    end else if (:DATA_TYPE = 'INTEGER') then begin
      OUT_VALUE = cast(:OUT_VALUE as integer);
      /* to prevent errors like OUT_VALUE = '00001' */
    end

    when any do exception RATING_EXCEPTION 'Unsupported param value: ' || :param_code || ' = "' || coalesce(:OUT_VALUE, '<null>') || '"';
  end
  /**********************************************/
end
^

/* Restore proc. body: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER)
 AS
declare variable id_current_account integer;
  declare variable id_service integer;
  declare variable is_anul integer;
  declare variable id_tariff integer;
  declare variable qty_post numeric(15,2);
  declare variable qty_free numeric(15,2);
  declare variable price_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable id_room integer;
  declare variable id_base_doc integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  if ((:AP_DBKEY is null) or (:id_target_account is null) or (:id_target_account < 0)) then
     exception POSTING_TRANSFER_EXCEPTION '-31';

  select AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST, AP.QTY_FREE,
         AP.PRICE_ORIG, AP.CURR_ORIG, AP.RATE_ORIG, ap.from_date, ap.to_date,
         AP.IS_ANUL, AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_BASE_DOC, A.ID_HOTEL
  from   ACCOUNT_POST AP
         left join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :id_service, :id_tariff, :id_room, :qty_post, :qty_free,
         :price_orig, :curr_orig, :rate_orig, :from_date, :to_date,
         :is_anul, :id_account_post, :id_current_account, :id_base_doc, :id_hotel;

  if (:id_current_account = :id_target_account) then EXIT;

  if (:is_anul = 1 ) then exception POSTING_TRANSFER_EXCEPTION '-33';

  if (:id_base_doc is not null) then exception POSTING_TRANSFER_EXCEPTION '-32';

  if (not exists(select A.ID_ACCOUNT
                 from   ACCOUNT A
                 where  A.ID_ACCOUNT = :ID_TARGET_ACCOUNT
                        and A.ID_HOTEL = :id_hotel)) then exception POSTING_TRANSFER_EXCEPTION '-376';

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
                    :id_tariff, :id_room, :qty_post, :qty_free, :price_orig, :curr_orig,
                    :rate_orig, 'TRANSFER_POSTING', null, :from_date, :to_date, 0, :id_target_account)
  returning_values  :no_use, :no_use, :no_use;

  insert into ACCOUNT_TRANSFER_HISTORY(ID_ACCOUNT_POST, FROM_ID_ACCOUNT, TO_ID_ACCOUNT)
  values (:id_account_post, :id_current_account, :id_target_account);
end
^

/* Restore proc. body: ACCOUNT_POSTING_UPDATE */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable in_db_key char(8);
begin
  /* GUI facade for manual update */
  select AP.ID_ACCOUNT, AP.ID_GUEST, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :id_guest, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date)
  returning_values  (:new_qty_post, :new_price_post, :new_ac);

  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    if (coalesce(:id_guest, 0) > 0) then begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || :id_account
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'POST_UPDATE', :action_text);
    end else begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
    end
  end

end
^

/* Restore proc. body: AVAILABILITY_OCCUPANCY$INT */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$INT(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
declare variable id_global_agent integer;
  declare variable for_date date;
  declare variable id_agent integer;
  declare variable id_room_type integer;
  declare variable g_capacity integer;
  declare variable bp_defined integer;
  declare variable c_defined integer;
  declare variable fdata integer;
  declare variable bp_is_released integer;
  declare variable c_is_released integer;
  declare variable gsts_in_house integer;
  declare variable gsts_come integer;
  declare variable gsts_gone integer;
  declare variable rooms_come integer;
  declare variable rooms_gone integer;
  declare variable id_hotel integer;
  declare variable id_b_allotment integer;
  declare variable id_c_allotment integer;
  declare variable ooo_rooms integer;
  declare variable ooi_rooms integer;
  declare variable sold_rooms integer;
  declare variable res_room_conf integer;
  declare variable res_room_notconf integer;
  declare variable res_room_wait integer;
begin
  /*  Description:   */
  HOTELS = coalesce(:HOTELS, '');
  ID_GLOBAL_AGENT = -100; /* HOLDS DATA GLOBAL FOR THE HOTEL */

  delete from SMART_OCCUP$TMP;

  for
    select RC.ID_ROOM_TYPE, RC.ID_HOTEL, RC.FOR_DATE, sum(RC.CNT_DEFINED)
    from   HOTEL_S H
           left outer join ALLOTMENT_GET$INT(H.ID_INVENTORY_ALLOTMENT, :FROM_DATE, :TO_DATE, null, 'PLAIN_PERIOD', :HOTELS) RC on 0=0
    where  ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
    group by 1, 2, 3
    into   :ID_ROOM_TYPE, :ID_HOTEL, :FOR_DATE, :G_CAPACITY
  do begin
    execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_global_agent, :id_room_type, :id_hotel, :g_capacity);
  end

  for
    select   RM.BUSY_DATE, RM.ID_ROOM_TYPE, RM.ID_HOTEL,
             iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (18,20), :ID_GLOBAL_AGENT, coalesce(RS.ID_AGENT, RM.ID_AGENT)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 18, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 20, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 24, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_CONFIRMED', RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_NOTCONFIRMED', RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_RESERVS', RM.ID_ROOM, null))
    from     ROOM_MAGIC RM
             join HOTEL_S H on H.ID_HOTEL = RM.ID_HOTEL
             left outer join ROOMS_SHARE RS on RS.ID_ROOM_SHARE = RM.ID_ROOM_MAGIC
    where    RM.BUSY_DATE between :from_date and :to_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
             and rm.ROOM_STATUS is distinct from 'PRIVATE'
             and ((not (:RES_CONFIRMED = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_CONFIRMED'))
                  or (not (:RES_NOTCONFIRMED = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_NOTCONFIRMED'))
                  or (not (:RES_WAITING = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_RESERVS')))
    group by 1, 2, 3, 4
    into     :for_date, :id_room_type, :id_hotel, :id_agent,
             :ooo_rooms, :ooi_rooms, :sold_rooms, :res_room_conf, :res_room_notconf, :res_room_wait
  do begin
    execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
            null, :ooo_rooms, :ooi_rooms, null, :sold_rooms, :res_room_conf, :res_room_notconf, :res_room_wait);
  end

  if (:BOOKING_POSITIONS + :CONTINGENT > 0) then begin
    for
      select PA.ID_AGENT, PA.ID_BOOKING_POSITION, pa.ID_CONTINGENT
      from   PROFILE_AGENT PA
      where  (pa.ID_CONTINGENT is not null) or (pa.ID_BOOKING_POSITION is not null)
      into   :id_agent, :id_b_allotment, :id_c_allotment
    do begin
      for
        select al.for_date, al.id_room_type, al.id_hotel,
               sum(al.b_defined), max(al.b_is_released), sum(al.c_defined), max(al.c_is_released)
        from   (select ABP.FOR_DATE, ABP.ID_ROOM_TYPE, ABP.ID_HOTEL,
                       ABP.CNT_DEFINED as b_defined, ABP.IS_RELEASED as b_is_released, null as c_defined, null as c_is_released
                from   ALLOTMENT BA
                       left join ALLOTMENT_GET$INT(ba.ID_ALLOTMENT, :from_date, :to_date, null, 'RELEASES', :hotels) ABP on 1=1
                where  :BOOKING_POSITIONS = 1 and ba.ID_ALLOTMENT = :id_b_allotment
                union all
                select ACG.FOR_DATE, ACG.ID_ROOM_TYPE, ACG.ID_HOTEL, null, null, ACG.CNT_DEFINED, ACG.IS_RELEASED
                from   ALLOTMENT CA
                       left join ALLOTMENT_GET$INT(ca.ID_ALLOTMENT, :from_date, :to_date, null, '', :hotels) ACG on 1=1
                where  :CONTINGENT = 1 and CA.ID_ALLOTMENT = :id_c_allotment
               ) al
        where  al.for_date is not null
        group by 1, 2, 3
        into   :for_date, :id_room_type, :id_hotel,
               :bp_defined, :bp_is_released, :c_defined, :c_is_released
      do begin
        execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
                null, null, null, null, null, null, null, null, :c_defined, :c_is_released, :bp_defined, :bp_is_released);
      end
    end
  end

  if (:OVERBOOK = 1) then begin
    for
      select ACG.FOR_DATE, ACG.ID_ROOM_TYPE, ACG.ID_HOTEL, ACG.CNT_DEFINED
      from   HOTEL_S H
             left outer join ALLOTMENT_GET$INT(H.ID_OVERBOOK_ALLOTMENT, :FROM_DATE, :TO_DATE, null, '', :HOTELS) ACG on 0=0
      where  ACG.FOR_DATE is not null
             and ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
      into   :for_date, :id_room_type, :id_hotel, :fdata
    do begin
      execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
              null, null, null, :fdata);
    end
  end

  if (:FETCH_TOTALS = 1) then begin
    for
      select SOGT.BUSY_DATE, SOGT.ID_ROOM_TYPE, sum(SOGT.GSTS_COME+SOGT.GSTS_STAYOVER), sum(SOGT.GSTS_COME),
             sum(SOGT.GSTS_GONE), sum(SOGT.ROOMS_COME), sum(SOGT.ROOMS_GONE), SOGT.ID_HOTEL, SOGT.ID_AGENT
      from   REP_ROOM_STATUS_MOVE(:from_date, :to_date, -1, -1, -1, '', '', :hotels) SOGT
      group by SOGT.BUSY_DATE, SOGT.ID_ROOM_TYPE, SOGT.ID_HOTEL, SOGT.ID_AGENT
      into   :for_date, :id_room_type, :gsts_in_house, :gsts_come,
             :gsts_gone, :rooms_come, :rooms_gone, :id_hotel, :id_agent
    do begin
      execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
              null, null, null, null, null, null, null, null, null, null, null, null,
              :gsts_in_house, :gsts_come, :gsts_gone, :rooms_come, :rooms_gone);
    end
  end
end
^

/* Restore proc. body: BLOCK_ANNUL$BLK */
ALTER PROCEDURE BLOCK_ANNUL$BLK(ID_BLOCK_ROOM INTEGER,
OPERATION VARCHAR(30))
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable share_err_text varchar(255);
  declare variable system_date date;
  declare variable cancel_date date;
  declare variable from_date date;
  declare variable b_dbkey char(8);
  declare variable new_id_block_room integer;
  declare variable id_room integer;
  declare variable block_grp integer;
  declare variable reason varchar(50);
  declare variable note varchar(255);
  declare variable action_text varchar(255);
  declare variable room_name varchar(10);
  declare variable id_hotel integer;
  declare variable mark_dirty_expired_block integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION (:operation, 'cancel, annul');

  select BR.FROM_DATE, BR.RDB$DB_KEY, R.ID_HOTEL
  from   BLOCK_ROOM BR
         join ROOMS R on R.ID_ROOM = BR.ID_ROOM
  where  BR.ID_BLOCK_ROOM = :id_block_room
  into   :from_date, :b_dbkey, :id_hotel;

  if (:operation = 'annul') then begin
    update BLOCK_ROOM BR
    set    BR.IS_ANNUL = 1
    where  BR.RDB$DB_KEY = :b_dbkey;
  
    execute procedure BLOCK_MODIFY_CONTROL$INT(:b_dbkey, :from_date);
    execute procedure ROOM_MAGIC_CLEAR(:id_block_room);
    action_text = '';
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :id_block_room, 'ANNUL_BLOCK', :action_text);
  end else begin
    select BR.ID_ROOM, BR.BLOCK_GRP, BR.REASON, BR.NOTE, R.ROOM_NAME
    from   BLOCK_ROOM BR
           join ROOMS R on R.ID_ROOM = BR.ID_ROOM
    where  BR.RDB$DB_KEY = :b_dbkey
    into   :id_room, :block_grp, :reason, :note, :room_name;

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :system_date;
    cancel_date = :system_date - 1;

    execute procedure BLOCK_MODIFY$INT(:id_block_room, :id_room, :from_date, :cancel_date, :block_grp, :reason,
                      :note, 'mod')
    returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :share_err_text, :warn_code;
    --ignore possible entering into share

    execute procedure SETTING_GET_VALUE('MARK_DIRTY_EXPIRED_BLOCK', :id_hotel)
    returning_values  :mark_dirty_expired_block;
    if (:mark_dirty_expired_block = '1') then begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'BLOCK_STOP', 'set_dirty');
    end

    action_text = f_character(29) || :room_name || f_character(28) || formatdate(:cancel_date, 'D;dd.mm.yyyy');
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :new_id_block_room, 'CANCEL_BLOCK', :action_text);
  end
end
^

/* Restore proc. body: DOC_CONTRAGENT_INITIALIZE$INT */
ALTER PROCEDURE DOC_CONTRAGENT_INITIALIZE$INT(ID_DOC INTEGER,
IS_PAY_DOC SMALLINT,
ID_PROFILE INTEGER)
 AS
declare variable is_juridical_person integer;
  declare variable contragent_name varchar(100);
  declare variable vat_reg_num varchar(30);
  declare variable ident_no varchar(30);
  declare variable post_address varchar(100);
  declare variable zip_code varchar(10);
  declare variable country_code varchar(20);
  declare variable mol varchar(30);
  declare variable id_contragent integer;
  declare variable recipient_name varchar(100);
  declare variable recipient_pas_num varchar(20);
  declare variable recipient_pas_date date;
  declare variable recipient_pas_from varchar(30);
  declare variable bank_name varchar(50);
  declare variable bic varchar(30);
  declare variable iban varchar(30);
  declare variable id_doc_contragent integer;
  declare variable email varchar(50);
begin

  execute procedure PROFILE_GET_CONTRAGENT_DATA$INT (:id_profile)
  returning_values (:id_contragent, :is_juridical_person, :contragent_name,
                    :vat_reg_num, :ident_no, :country_code, :post_address, :zip_code, :email,
                    :mol, :recipient_name, :recipient_pas_num, :recipient_pas_date, :recipient_pas_from,
                    :bank_name, :bic, :iban);

  if (:id_contragent is null and trim(coalesce(:contragent_name, '')) = '') then exit; /* not valid contragent */

  execute procedure DOC_CONTRAGENT_SET$DOC (:ID_DOC, :IS_PAY_DOC, :id_contragent,
          coalesce(:is_juridical_person, 0), :contragent_name, :vat_reg_num, :ident_no,
          :country_code, :post_address, :zip_code, :email, :mol, :recipient_name,
          :recipient_pas_num, :recipient_pas_date, :recipient_pas_from, null, null, null,
          0, :bank_name, :bic, :iban)
  returning_values :id_doc_contragent;

end
^

/* Restore proc. body: EAI_EXT_POST_TO_MH_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  if (:CODE_TYPE = 'EXT_CODE') then begin
    execute procedure EAI_MAP_SERVICE(:SERVICE_CODE, :SERVICE_CODE, 'UNKNOWN', :id_hotel)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_SERVICE;
    if (:ERR_CODE < 0) then exit;
  end else begin
    select S.ID_SERVICE
    from   SERVICES S
    where  S.ID_SERVICE = :SERVICE_CODE
           and s.ID_HOTEL = :ID_HOTEL
    into   :ID_SERVICE;
    if (:ID_SERVICE is null) then begin
      ERR_CODE = -85;   /* Wrong value! */
      exit;
    end
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Restore proc. body: EAI_EXT_SERVICE_POST */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable max_id_service integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_ROOM  = null;
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  select min(S.ID_SERVICE) as id_service, max(s.id_service) as max_id_service
  from   SERVICES S
  where  S.EXT_CODE = :SERVICE_EXT_CODE
         and s.IS_BASE = 0
         and s.IS_DELETED = 0
  into   :ID_SERVICE, :max_id_service;
  if (:ID_SERVICE is null) then begin
      ERR_CODE = -388;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end else if (:ID_SERVICE <> :max_id_service) then begin
      ERR_CODE = -389;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_EXT_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Restore proc. body: EAI_POS_POSTING_ADD$P2E */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
declare variable id_service integer;
  declare variable my_post_text varchar(255);
  declare variable my_resource_text varchar(255);
  declare variable no_use integer;
  declare variable nation_curr varchar(3);
  declare variable post_short_code varchar(10);
  declare variable id_hotel integer;
begin
  /* in_on_guest = 0 (account), 1 (guest), -1 (ew)
  */
  if (:IN_ON_GUEST = 1) then begin
    select rd.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :IN_ID_GUEST
    into   :id_hotel;
  end else begin
    select a.ID_HOTEL
    from   account a
    where  a.ID_ACCOUNT = :in_id_account
    into   :id_hotel;
  end

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :nation_curr;

  if ('END_WORK' = :in_smetka_num) then begin
    post_short_code='POS_EW';
  end else begin
    post_short_code='POS';
  end

  /* FIND SERVICE */
  execute procedure EAI_MAP_SERVICE(:in_service_tag, :in_service_name, 'POS', :id_hotel)
  returning_values  :err_code, :err_text, :id_service;
  if (:err_code < 0) then exit;

  my_post_text = 'date:'|| formatdate(:in_date_smetka, 'D;dd.mm.yyyy') ||
                 ' num:'|| :in_smetka_num ||
                 ' obj:'|| :in_obj_name ||
                 ' tbl:'|| :in_table ||
                 ' site:'|| :in_site;

  my_resource_text = 'POS_ID_SMETKA:'||:in_id_smetka;
  my_post_text = substring(:my_post_text from 1 for 100);
  my_resource_text = substring(:my_resource_text from 1 for 49);

  if (:in_on_guest = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:in_id_guest, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code, '')
    returning_values  :err_code, :err_text, :out_id_account, :no_use;
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:in_id_account, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code)
    returning_values  :err_code, :err_text, :no_use;
    out_id_account = :in_id_account;
  end
end
^

/* Restore proc. body: EAI_ROOM_STATUS_SET */
ALTER PROCEDURE EAI_ROOM_STATUS_SET(ROOM_NAME VARCHAR(10),
OPERATION VARCHAR(20),
TAG VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_room integer;
  declare variable set_options varchar(255);
begin
  err_code = 0;
  err_text = '';

  execute procedure SYSTEM_CHECK_OPERATION(:OPERATION, 'setclean,setdirty,settext');

  id_room = null;
  if (singular(select RO.ID_ROOM
               from ROOMS RO
                  join HOTEL_S HO on HO.ID_HOTEL = RO.ID_HOTEL
               where  RO.ROOM_NAME = :ROOM_NAME
                      and HO.IS_USE = 1)) then
    select R.ID_ROOM
    from   ROOMS R
      join HOTEL_S HS on HS.ID_HOTEL = R.ID_HOTEL
    where  R.ROOM_NAME = :ROOM_NAME
           and HS.IS_USE = 1
    into   :id_room;
  else begin
    err_code = -1044;
    exit;
  end

  if (:id_room is null) then begin
    err_code = -5;
    err_text = :room_name;
    exit;
  end

  if (:operation = 'setclean') then set_options = 'set_clean';
  else if (:operation = 'setdirty') then set_options = 'set_dirty';
  else if (:operation = 'settext') then set_options = 'set_text'||f_character(28)||:tag;

  execute procedure ROOM_HOUSEKEEPING(:id_room, 'EXT_IFC', :set_options);
end
^

/* Restore proc. body: EAI_TELECOUNT_TRANSFER */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* Restore proc. body: END_WORK */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable system_date date;
  declare variable id_room integer;
  declare variable id_end_work integer;
  declare variable last_closed_date date;
  declare variable mark_dirty_expired_block varchar(10);
  declare variable mark_dirty_occ_room varchar(10);
  declare variable lock_id integer;
  declare variable shift_no integer;
  declare variable init_hotel_date date;
begin

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;
  if (:system_date >= :in_next_date) then exception END_WORK_EXCEPTION '-43';
  if (:IN_NEXT_DATE > current_date + 1) then exception END_WORK_EXCEPTION '-60';

  last_closed_date = :in_next_date - 1;

  /* LOCK THE CURRENT FINANCIAL (SYSTEM) DATE  */
  lock_id = null;
  while (:lock_id is null) do begin
    lock_id = strhash_large(:system_date || :id_hotel);
    execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'lock');
  
    when any do begin
      exception END_WORK_EXCEPTION '-337' || f_character(31) || f_character(29) || FormatDate(:system_date, 'D;dd.mm.yyyy');
    end
  end

  /* RIGHT IS REQUIRED TO CHANGE THE FINANCIAL DATE IF THERE ARE GUESTS WITH OVERDUE CHECK OUT */
  if (exists(
    select *
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
    where  G.TO_DATE <= :last_closed_date
           and G.CHECK_STATUS < 1
           and RD.ID_HOTEL = :id_hotel
           and rd.IS_ANUL = 0
  )) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('EW_OVERDUE_CHECKOUT');
  end

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', 'EW');
  -- Suppress eventual right checks into next procedures - all is permitted. Is this needed(?!?)

  update ACCOUNT_POST AP
  set    ap.ROOM_NAME = (select R.ROOM_NAME
                         from   GUEST G
                                join ROOMS R on R.ID_ROOM = G.ID_ROOM
                         where  G.ID_GUEST = ap.ID_GUEST)
  where  ap.DATE_POST between :system_date and :last_closed_date
         and ap.ID_GUEST > 0;

  select coalesce(max(ew.SHIFT_NO), 0) + 1
  from   END_WORKS ew
  where  ew.PREV_DATE = :system_date
  into   :shift_no;

  id_end_work = gen_id(G_AUTO_INC_END_WORKS, 1);
  insert into END_WORKS (ID_END_WORK, PREV_DATE, NEXT_DATE, END_WORK_KIND, SHIFT_NO, ID_HOTEL)
  values (:id_end_work, :system_date, :in_next_date, 3, :shift_no, :id_hotel);

  /* CHANGE SYSTEM DATE */
  execute procedure SYSTEM_DATE_SET(:id_hotel, :in_next_date);

  /* AUTO EXPIRATION OF ROOM NUMBERS, ROOMS AND BOOKING POSITIONS */
  execute procedure RESERVS_EXPIRE$INT(:last_closed_date, :id_hotel);

  execute procedure AGENT_CONTINGENT_EXPIRE(:system_date, :last_closed_date, null, 0, 1, :id_hotel);

  /* DELETE PERSON PROFILES WITH EXPIRATION DATE */
  execute procedure PROFILE_PERSON_EXPIRE (:in_next_date);

  execute procedure SETTING_GET_VALUE('MARK_DIRTY_EXPIRED_BLOCK', :ID_HOTEL)
  returning_values  :mark_dirty_expired_block;
  if (:mark_dirty_expired_block = '1') then begin
    for
      select distinct BR.ID_ROOM
      from   BLOCK_ROOM BR
             join ROOMS R on R.ID_ROOM = BR.ID_ROOM
      where  R.ID_HOTEL = :id_hotel
             and BR.TO_DATE >= :system_date
             and BR.TO_DATE < :in_next_date
             and BR.IS_ANNUL = 0
         into :id_room
    do begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'BLOCK_EXP', 'set_dirty');

      when any do post_event 'dummy';  -- nothing
    end
  end

  execute procedure SETTING_GET_VALUE('MARK_DIRTY_OCC_ROOM', :ID_HOTEL)
  returning_values  :mark_dirty_occ_room;
  if (:mark_dirty_occ_room = '1') then begin
    for
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
             join ROOMS R on R.ID_ROOM = rm.ID_ROOM
      where  R.ID_HOTEL = :id_hotel
             and RM.BUSY_DATE = :system_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and RM.BUSY_GROUP_TYPE = 24
      into   :id_room
    do begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'EW_DAY', 'set_dirty');

      when any do post_event 'dummy';  -- nothing
    end
  end

  /* Summary data prepare */
  if (:in_next_date > :system_date) then begin
    execute procedure SUMMARY_FINANCE_SAVE$INT (:id_end_work);

    select min(e.PREV_DATE)
    from   END_WORKS E
    where  E.ID_HOTEL = :ID_HOTEL
    into   :init_hotel_date;

    execute procedure SUMMARY_PREPARE$INT(:id_hotel, :init_hotel_date, :last_closed_date); --TODO precise the period

    execute procedure SUMMARY_FORECAST$INT(:ID_HOTEL, :system_date);
  end

  /* Delete data from temporal tables */
  delete from RESERV_ERROR;
  delete from TMP_SMALL_OCCUP;
--  delete from GUEST g where g.id_reserv_detail is null; pri regenerirane na statistikata ne vurshi rabota
  /*  */

  execute procedure CACHES_RESOLVE;

  execute procedure SYSTEM_LOG_ADD('SYSTEM', :id_end_work, 'DAY_EW', f_character(29) || :last_closed_date);

  execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'release');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', null);

  post_event 'invalidate.end_work';
end
^

/* Restore proc. body: GUEST_ADDRESSCARD_SET$RSV */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$RSV(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
EGN VARCHAR(30),
COUNTRY VARCHAR(10),
ID_STAY_REASON INTEGER,
IS_REGISTRED INTEGER,
PASS_PLACE VARCHAR(20),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_PLACE VARCHAR(30),
SEX CHAR,
MASK VARCHAR(10),
IS_CHILD INTEGER,
CAR VARCHAR(30),
KPP INTEGER,
KPP_DATE DATE,
PASS_EXP_DATE DATE,
AGE INTEGER,
BIRTH_DAY DATE,
VISA TDESCRIPTION_SHORT,
RATING_AGE INTEGER = null,
TITLE VARCHAR(10) = null,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable gd_dbkey char(8);
  declare variable pd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable rd_dbkey char(8);
  declare variable old_is_registred integer;
  declare variable old_guest_name1 varchar(250);
  declare variable old_guest_name2 varchar(250);
  declare variable old_id_pass_type integer;
  declare variable old_pass_num varchar(20);
  declare variable old_pass_date date;
  declare variable old_egn varchar(30);
  declare variable old_country varchar(20);
  declare variable old_id_stay_reason integer;
  declare variable old_kpp integer;
  declare variable old_kpp_date date;
  declare variable old_pass_exp_date date;
  declare variable old_birth_day date;
  declare variable old_pass_place varchar(20);
  declare variable old_city varchar(100);
  declare variable old_address varchar(100);
  declare variable old_visa TDESCRIPTION_SHORT;
  declare variable old_birth_place varchar(30);
  declare variable old_sex char(1);
  declare variable action_text varchar(250);
  declare variable tt_reg_number integer;
  declare variable id_hotel integer;
  declare variable id_tt_numerator integer;
  declare variable domestic_nation varchar(10);
  declare variable no_use varchar(255);
  declare variable is_anul smallint;
  declare variable acc_routing varchar(20);
begin
  err_code = 0;
  err_text = '';

  select G.RDB$DB_KEY, GD.RDB$DB_KEY, PD.RDB$DB_KEY,
         GD.IS_REGISTRED, PD.PERSON_NAME, PD.PERSON_NAME2, PD.ID_PASSPORT_TYPE, PD.PASS_NUM, PD.PASS_DATE,
         PD.EGN, PD.COUNTRY_CODE, GD.ID_STAY_REASON, GD.KPP, GD.KPP_DATE, PD.PASS_EXP_DATE,
         PD.BIRTH_DAY, PD.PASS_PLACE, PD.CITY, PD.ADDRESS, PD.BIRTH_PLACE, PD.SEX, rd.RDB$DB_KEY,
         g.TT_REG_NUMBER, rd.ID_HOTEL, rd.IS_ANUL, rd.ACC_ROUTING, GD.VISA
  from   GUEST G
         join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
         join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
         join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
  where  G.ID_GUEST = :id_guest
  into   :g_dbkey, :gd_dbkey, :pd_dbkey,
         :old_is_registred, :old_guest_name1, :old_guest_name2, :old_id_pass_type, :old_pass_num, :old_pass_date,
         :old_egn, :old_country, :old_id_stay_reason, :old_kpp, :old_kpp_date, :old_pass_exp_date,
         :old_birth_day, :old_pass_place, :old_city, :old_address, :old_birth_place, :old_sex, :rd_dbkey,
         :tt_reg_number, :id_hotel, :is_anul, :acc_routing, :old_visa;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, :birth_place, :egn, :id_passport_type, :pass_num, :pass_date, :pass_place,
          :pass_exp_date, :city, :address, :sex, :mask);

  update  GUEST_DATA GD
  set     GD.KPP_DATE = :kpp_date,
          GD.KPP = :kpp,
          GD.VISA = :visa,
          GD.ID_STAY_REASON = :id_stay_reason,
          GD.IS_REGISTRED = :is_registred,
          GD.USER_REGISTRED = iif(:IS_REGISTRED = 1, coalesce(GD.USER_REGISTRED, current_user), null),
          GD.CAR = :car,
          GD.RATING_AGE = :RATING_AGE
  where   GD.RDB$DB_KEY = :gd_dbkey;

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name1, :guest_name2, :country,
          :is_child, :age, :birth_day, :TITLE);

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -1);

  /*  */
  if (:IS_REGISTRED = 1 and :tt_reg_number is null and :is_anul = 0 and :acc_routing is distinct from 'OWNER') then begin
    execute procedure SETTING_GET_VALUE ('NATIVE_NATION', :id_hotel)
    returning_values :domestic_nation;

    select iif(:COUNTRY not in (:domestic_nation, '') and h.USE_DIFFERENT_TT_NUMERATORS = 1,
               h.ID_TT_NUMERATOR_2,
               h.ID_TT_NUMERATOR_1)
    from   HOTEL H
    where  h.ID_HOTEL = :id_hotel
    into   :id_tt_numerator;

    if (:id_tt_numerator is not null) then begin
      execute procedure SYSTEM_GEN_NUM('GUEST_NUM', :id_tt_numerator)
      returning_values :tt_reg_number, :no_use;
  
      update GUEST G
      set    g.TT_REG_NUMBER = :tt_reg_number
      where  G.RDB$DB_KEY = :g_dbkey;
    end
  end else if (:IS_REGISTRED is distinct from 1 and :tt_reg_number is not null) then begin
    update GUEST G
    set    g.TT_REG_NUMBER = null
    where  G.RDB$DB_KEY = :g_dbkey;
  end
  /*  */
  if ((:old_is_registred = 0) and (:is_registred = 1)) then begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'REGISTRED', '');
  end

  if ((:old_is_registred = 1) and (:old_guest_name1 <> :guest_name1)) then begin
    action_text = f_character(29)||:old_guest_name1||f_character(28)||:guest_name1;
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'CHANGE_CARD', :action_text);
  end

  if ((:old_IS_REGISTRED = 1)
      and
      ((:old_guest_name1 <> :guest_name1)
        or (:old_guest_name2 <> :guest_name2)
        or (:old_egn <> :egn)
        or (:old_id_pass_type <> :id_passport_type)
        or (:old_pass_num <> :pass_num)
        or (:old_pass_date <> :pass_date)
        or (:old_pass_exp_date <> :pass_exp_date)
        or (:old_pass_place <> :pass_place)
        or (:old_country <> :country)
        or (:old_city <> :city)
        or (:old_address <> :address)
        or (:old_visa <> :visa)
        or (:old_birth_day <> :birth_day)
        or (:old_birth_place <> :birth_place)
        or (:old_sex  <> :sex)
        or (:old_kpp <> :kpp)
        or (coalesce(:old_id_stay_reason,0) <> coalesce(:id_stay_reason,0))
        or (:old_kpp_date <> :kpp_date)
      )) then
  begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'PREREGISTRED', '');
  end

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
    returning_values  :warn_code;

  end

end
^

/* Restore proc. body: IMPORT_PERSON_PROFILE$EXC */
ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
CLEAR_HOTEL_RATE SMALLINT,
CREATE_ONLY SMALLINT,
MERGE_TARGET_UUID VARCHAR(40))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
declare variable op varchar(10);
  declare variable market_segment_id integer;
  declare variable sex_old char(1);
  declare variable birth_date_old date;
  declare variable birth_place_old varchar(30);
  declare variable personal_number_old varchar(30);
  declare variable pass_num_old varchar(20);
  declare variable pass_date_old date;
  declare variable pass_place_old varchar(20);
  declare variable pass_exp_date_old date;
  declare variable pass_city_old varchar(100);
  declare variable pass_address_old varchar(100);
  declare variable country_old varchar(10);
  declare variable mask_old varchar(10);
  declare variable title_old varchar(10);
  declare variable id_photo integer;
  declare variable id_def_contragent integer;
  declare variable id_passport_type integer;
  declare variable account_no_old varchar(20);
  declare variable msg_old varchar(255);
  declare variable id_guest_type integer;
  declare variable id_guest_type_old integer;
  declare variable card_code_old varchar(50);
  declare variable is_exclusive_debt_ownership smallint;
  declare variable profile_receiver_id integer;
begin
  profile_id = null;
  import_time = null;

  execute procedure import_mark_transaction$exc;

  /*FIXME - remove this block*/
  if (1 = :create_only) then begin
    clear_hotel_rate = 0;
  end else begin
    clear_hotel_rate = 1;
  end

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC(:profile_uuid=>' || coalesce(:profile_uuid, '<null>')
                          || ', email=>' || coalesce(:email, '<null>') || ')');

  profile_id = null;
  if (profile_uuid is null) then begin
    execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC <null> :profile_uuid - exit;');
    exit;
  end

  select p.profile_id, p.profile_name, p.phone, p.fax, p.email, p.city,
         p.address, p.market_segment, p.note, p.is_archive, pp.card_code,
         pd.sex, pd.birthday_internal, pd.birth_place, pd.egn, pd.pass_num,
         pd.pass_date, pd.pass_place, pd.pass_exp_date, pd.city, pd.address, pd.country_code,
         pd.mask, p.id_def_contragent, p.wbe_password,
         pd.title, p.account_no, p.msg, pp.id_guest_type, pp.id_photo, pd.id_passport_type,
         p.is_exclusive_debt_ownership
  from   import_common_profile$exc(:profile_uuid, 0, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :wbe_password, :ACCOUNT_NO, :MSG, 'PERSON_PROFILE', :CLEAR_HOTEL_RATE) p
         left outer join profile_person pp on pp.id_profile = p.profile_id
         left outer join person_data pd on pd.id_person_data=pp.id_person_data
  into   :profile_id, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :card_code_old,
         :sex_old, :birth_date_old, :birth_place_old, :personal_number_old, :pass_num_old,
         :pass_date_old, :pass_place_old, :pass_exp_date_old, :pass_city_old, :pass_address_old, :country_old,
         :mask_old, :id_def_contragent, :wbe_password, :title_old,
         :account_no_old, :msg_old, :id_guest_type_old, :id_photo, :id_passport_type, :is_exclusive_debt_ownership;

  if (:profile_id is null) then begin
    op = 'add';
  end else if (1 = :create_only) then begin
    profile_id = null;
    exit;
  end else begin
    op = 'mod';
    delete from PROFILE_HOTEL_RATE phr
      where phr.ID_PROFILE = :profile_id;
    delete from PROFILE_BONUSPOINT_SCHEME bs
      where bs.ID_PROFILE = :profile_id;
  end

  sex=coalesce(:sex, :sex_old);
  birth_date=coalesce(:birth_date, :birth_date_old);
  birth_place=coalesce(:birth_place, :birth_place_old);
  personal_number=coalesce(:personal_number, :personal_number_old);
  pass_num=coalesce(:pass_num, :pass_num_old);
  pass_date=coalesce(:pass_date, :pass_date_old);
  pass_place=coalesce(:pass_place, :pass_place_old);
  pass_exp_date=coalesce(:pass_exp_date, :pass_exp_date_old);
  pass_city=coalesce(:pass_city, :pass_city_old);
  pass_address=coalesce(:pass_address, :pass_address_old);
  country=upper(coalesce(:country, :country_old));
  mask=coalesce(:mask, :mask_old);
  title=coalesce(:title, :title_old);
  account_no=coalesce(:account_no, :account_no_old);
  msg=coalesce(:msg, :msg_old);
  card_code=coalesce(:card_code, :card_code_old);

  execute procedure IMPORT_PASSPORT_TYPE$EXC(:pass_type_name, :pass_type_external_code)
  returning_values :id_passport_type;

  execute procedure lookup_market_segment$exc(:profile_name, 'PERSON_PROFILE', :market_segment)
  returning_values :market_segment_id;

  if (guest_type_name is not null) then begin
    execute procedure lookup_guest_type$exc(:profile_name, 'PERSON_PROFILE', :guest_type_name)
    returning_values :id_guest_type;
  end

  if ((def_contragent_name is not null) and (def_contragent_name <> '')) then begin
    execute procedure LOOKUP_CONTRAGENT$EXC(:profile_name, 'PERSON_PROFILE', :def_contragent_name)
    returning_values :id_def_contragent;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:profile_name, 'PERSON_PROFILE');

  id_guest_type=coalesce(:id_guest_type, :id_guest_type_old);

  if (id_photo is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, null, null, null, 'del')
    returning_values :id_photo;
  end
  id_photo = null;
  if (picture is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, :picture, :picture_type, :picture_layout, 'add')
    returning_values :id_photo;
  end

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC - profile_person_modify$profile(:profile_uuid=>'
    || coalesce(:profile_uuid, '<null>')
    || ', :operation=>' || coalesce(:op, '<null>')
    || ', :email=>' || coalesce(:email, '<null>')
    || ', :birth_date=>' || coalesce(:birth_date, '<null>')
  || ')');
  execute procedure profile_person_modify$profile(
    :profile_id,
    :id_guest_type,
    :profile_name,
    null,
    :sex,
    :birth_date,
    :birth_place,
    :personal_number,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :pass_place,
    :pass_exp_date,
    :country,
    :pass_city,
    :pass_address,
    :mask,
    :phone,
    :fax,
    :email,
    :city,
    :address,
    :note,
    :msg,
    :id_def_contragent,
    :market_segment_id,
    :is_archive,
    :id_photo,
    :card_code,
    :wbe_password,
    :op,
    :account_no,
    :title,
    :is_exclusive_debt_ownership
  ) returning_values
    :profile_id;

  /*assign uuid to the new profiles*/
  if ('add' = :op) then begin
    update profile set uuid=:profile_uuid where id_profile=:profile_id;
  end

  select record_timestamp from profile where id_profile=:profile_id
  into :import_time;

  if (:MERGE_TARGET_UUID is not null) then begin
    select p.ID_PROFILE
    from   PROFILE P
    where  P.UUID = :MERGE_TARGET_UUID
    into   :profile_receiver_id;

    execute procedure PROFILE_MERGE$PROFILE (:PROFILE_ID, :profile_receiver_id, 'merge');

  end

end
^

/* Restore proc. body: PHONECALL_POST$TC */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Restore proc. body: PHONECALLS_POST_TO_ACCOUNT$TC */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* Restore proc. body: PMS_POOL_DISTRIBUTION */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION(ID_RENTAL_POOL INTEGER,
FOR_DATE DATE)
 AS
declare variable total_value_per_service numeric(15,4);
  declare variable id_service integer;
  declare variable curr varchar(3);
  declare variable id_room_param integer;
  declare variable is_room_pool smallint;
  declare variable is_owner_income smallint;

  declare variable is_acc_post_item smallint;
  declare variable new_id_owner_bill integer;
  declare variable id_account_post_pms integer;
  declare variable id_pool_account integer;

  declare variable id_account_pms integer;
  declare variable value_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable value_post numeric(15,4);
  declare variable curr_post varchar(3);
  declare variable id_room integer;
  declare variable date_post date;
  declare variable id_reserv_detail integer;
  declare variable doc_description varchar(255);
  declare variable id_doc_head integer;
  declare variable description varchar(255);
  declare variable is_client_account_post smallint;
  declare variable id_event_lst varchar(5000);
begin
  is_room_pool = null;
  select U.IS_ROOM_POOL, U.ID_ROOM_PARAM
  from   OWNER$PMS O
         join RENTAL_POOL_UNIT$PMS U on U.ID_RENTAL_POOL_UNIT = O.ID_RENTAL_POOL_UNIT
  where  O.ID_OWNER = :ID_RENTAL_POOL
  into   :is_room_pool, :id_room_param;
  if (:is_room_pool is null) then exception PMS_EXCEPTION;

  select cast(list(distinct AP.ID_PMS_EVENT) as varchar(5000))
  from   ACCOUNT_POST$PMS AP
         join ACCOUNT$PMS AC on AC.ID_ACCOUNT = AP.ID_ACCOUNT_PMS
  where  AP.DATE_POST <= :FOR_DATE
         and AP.LINE_STATUS = 11
         and AC.ID_OWNER = :ID_RENTAL_POOL
         and AC.IS_SHADOW = 0
  into   :id_event_lst;

  for
    select sum(AP1.VALUE_POST), AP1.ID_SERVICE, AP1.CURR_POST, AP1.IS_OWNER_INCOME,
           ACC.IS_CLIENT_POOL_ACCOUNT, ACC.ID_ACCOUNT
    from   ACCOUNT_POST$PMS AP1
           join ACCOUNT$PMS ACC on ACC.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS
           join SYSTEM_STRING_PARSER(:id_event_lst, ',') S on S.ITEM = AP1.ID_PMS_EVENT
    where  AP1.LINE_STATUS = 11
           and ACC.IS_SHADOW = 0
    group by 2,3,4,5,6
    into   :total_value_per_service, :id_service, :curr, :is_owner_income,
           :is_acc_post_item, :id_pool_account
  do begin
    execute procedure PMS_POOL_DISTRIBUTION_SUB(:ID_RENTAL_POOL, :id_pool_account,
            :IS_ROOM_POOL, :ID_ROOM_PARAM, :total_value_per_service,
            :ID_SERVICE, :CURR, :IS_OWNER_INCOME, :FOR_DATE, :is_acc_post_item);
  end

  NEW_ID_OWNER_BILL = gen_id(GEN_OWNER_BILL$PMS_ID, 1);

  insert into OWNER_BILL$PMS (ID_OWNER_BILL, ID_OWNER, BILL_DATE, IS_ANUL, BILL_NUM,
         IS_EXPORTED_TO_INTRANET, IS_POOL_DISTRIBUTION_STATEMENT)
  values (:NEW_ID_OWNER_BILL, :ID_RENTAL_POOL, :FOR_DATE, 0, :NEW_ID_OWNER_BILL, 0, 1);

  update OWNER$PMS O
  set    O.LAST_BILLING_DATE = :for_date,
         O.ID_OWNER_BILL = :NEW_ID_OWNER_BILL
  where  O.ID_OWNER = :ID_RENTAL_POOL;

  for
    select AP.ID_ACCOUNT_POST, AP.VALUE_ORIG, AP.CURR_ORIG, AP.VALUE_POST, AP.CURR_POST,
           ACC.ID_ACCOUNT, AP.IS_OWNER_INCOME, AP.ID_SERVICE, E.ID_ROOM, AP.DATE_POST,
           E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION, ACC.IS_CLIENT_POOL_ACCOUNT
    from   PMS_EVENT$PMS E
           join ACCOUNT_POST$PMS AP on ap.ID_PMS_EVENT = e.ID_PMS_EVENT
                                       and AP.LINE_STATUS = 11
           join ACCOUNT$PMS ACC on ACC.ID_ACCOUNT = AP.ID_ACCOUNT_PMS
                                   and ACC.ID_OWNER = :ID_RENTAL_POOL
                                   and ACC.IS_SHADOW = 0
    where  ((E.ID_SESSION = current_transaction) or (','||:id_event_lst||',' containing  ','||E.ID_PMS_EVENT||','))
    into   :id_account_post_pms, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
           :ID_ACCOUNT_PMS, :IS_OWNER_INCOME, :ID_SERVICE, :ID_ROOM, :DATE_POST,
           :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION, :is_client_account_post
  do begin
    insert into OWNER_BILL_ROW$PMS (ID_OWNER_BILL, ID_ACCOUNT_POST, ID_ACCOUNT,
           ID_ACCOUNT_POST_PMS, ID_ACCOUNT_PMS, ID_SERVICE, VALUE_ORIG,
           CURR_ORIG, VALUE_POST, CURR_POST, IS_OWNER_INCOME, ID_ROOM, DATE_POST,
           ID_RESERV_DETAIL, DOC_DESCRIPTION, ID_DOC_HEAD, DESCRIPTION, IS_CLIENT_ACCOUNT_POST)
    values (:new_id_owner_bill, null, null,
           :ID_ACCOUNT_POST_PMS, :ID_ACCOUNT_PMS, :ID_SERVICE, :VALUE_ORIG,
           :CURR_ORIG, :VALUE_POST, :CURR_POST, :IS_OWNER_INCOME, :ID_ROOM, :DATE_POST,
           :ID_RESERV_DETAIL, :DOC_DESCRIPTION, :ID_DOC_HEAD, :DESCRIPTION, :is_client_account_post);

    update ACCOUNT_POST$PMS A
    set    A.LINE_STATUS = 21
    where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS;
  end
end
^

/* Restore proc. body: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_OWNER TYPE OF ID,
POST_DATE TYPE OF TDATE,
CURR_ORIG TYPE OF TCURRENCY,
VALUE_ORIG TYPE OF TPRICE,
POST_ON_PMS_ACCOUNT TYPE OF TLOGICAL,
IS_OWNER_INCOME TYPE OF TLOGICAL,
ID_ROOM TYPE OF ID_REF = null)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  if (:POST_ON_PMS_ACCOUNT = 1) then begin
    execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account, :id_owner,
            :CURR_ORIG, :VALUE_ORIG, :id_service, :is_owner_income, :POST_DATE)
    returning_values  (:new_id_account_post);
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :ID_SERVICE, 1, 0, 1,
            :VALUE_ORIG, :CURR_ORIG, current_date, current_date,
            '', '', :POST_DATE, 'PMS', :ID_ROOM)
    returning_values  :err_code, :err_text, :new_id_account_post;
    if (:err_code <> 0) then exception PMS_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

    insert into PMS_EVENT_POST (ID_PMS_EVENT, ID_ACCOUNT_POST, ID_OWNER, LINE_STATUS)
    values (:ID_PMS_EVENT, :NEW_ID_ACCOUNT_POST, :ID_OWNER, 11);
  end
end
^

/* Restore proc. body: POST_SERVICE_FINALIZE$POST */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
  declare variable id_acc_post integer;
  declare variable id_service integer;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable date_post date;
  declare variable price_post numeric(15,4);
  declare variable qty_post numeric(15,2);
  declare variable post_text varchar(100);
  declare variable curr_post varchar(3);
  declare variable id_phonecall integer;
  declare variable p_dbkey char(8);
begin

  if (:OPERATION = 'clear') then begin
    delete from TMP_SERVICE_POST T
    where  T.ID_SEQUENCE = :ID_SEQUENCE;

  end else if (:OPERATION = 'store') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);

    for
      select TS.RDB$DB_KEY, TS.ID_SERVICE, TS.ID_ACCOUNT, TS.ID_GUEST, TS.DATE_POST,
             TS.PRICE_POST, TS.QTY_POST, TS.CURR_POST, TS.POST_TEXT, TS.ID_PHONECALL
      from   TMP_SERVICE_POST TS
      where  TS.ID_SEQUENCE = :ID_SEQUENCE
      into   :p_dbkey, :id_service, :id_account, :id_guest, :date_post,
             :price_post, :qty_post, :curr_post, :post_text, :id_phonecall
    do begin
      id_acc_post = null;
      if (:id_guest is not null) then begin
        execute procedure POST_SERVICE_ON_GUEST$INT (:id_guest, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :CURR_POST,
                :date_post, :date_post, :post_text, '', :date_post, '', '')
        returning_values  (:err_code, :err_text, :no_use, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end else begin
        execute procedure POST_SERVICE_ON_ACCOUNT$INT (:id_account, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :curr_post, :date_post, :date_post, :post_text,
                '', :date_post, '')
        returning_values  (:err_code, :err_text, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end

      update TMP_SERVICE_POST
      set ID_ACCOUNT_POST = :id_acc_post
      where RDB$DB_KEY = :p_dbkey;

      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :DOC_SELECTED,
             AP.SHORT_CODE = case
                               when :id_phonecall is not null then 'TELECOUNT'
                               else null
                             end
      where  AP.ID_ACCOUNT_POST = :id_acc_post;

      if (:id_phonecall is not null) then begin
        update PHONECALLS P
        set    P.ID_ACCOUNT_POST = :id_acc_post
        where  P.ID_PHONECALL = :id_phonecall;
      end
    end
  end
end
^

/* Restore proc. body: RES_CHECK_OUT_GUESTS$RSV */
ALTER PROCEDURE RES_CHECK_OUT_GUESTS$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND SMALLINT = 0)
 AS
declare variable action_code varchar(100);
  declare variable cleaning_restriction varchar(10);
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable id_reserv_detail integer;
  declare variable id_guest integer;
  declare variable id_room integer;
  declare variable rd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable checkout_status integer;
  declare variable sys_date date;
  declare variable id_hotel integer;
begin
  checkout_status = 1;
  action_code = case when :check_out_kind = 0 then 'CHECK_OUT'
                     when :check_out_kind = 1 then 'CHECK_OUT_EARLY1'
                     when :check_out_kind = 2 then 'CHECK_OUT_EARLY2'
                     when :check_out_kind = 3 then 'CHECK_OUT_EARLY3'
                end;

  for
    select RD.ID_RESERV_DETAIL, RD.ID_ROOM, RD.RDB$DB_KEY, rd.ID_HOTEL,
           (select sd.SYSTEM_DATE
            from   SYSTEM_DATE_GET (rd.ID_HOTEL) sd)
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :id_reserv_detail, :id_room, :rd_dbkey, :id_hotel, :sys_date
  do begin

    for
      select G.ID_GUEST, G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.CHECK_STATUS = 0 /* checked in */
      into   :id_guest, :g_dbkey
    do begin
      if (:CHECK_OUT_KIND = 3) then begin
        -- DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
        update GUEST G
        set    G.EARLYCHECKOUT_DATE = :sys_date
        where  g.RDB$DB_KEY = :g_dbkey;

        execute procedure GUEST_SET_MANUAL_STAY$INT(:rd_dbkey, :id_guest, :sys_date)
        returning_values  :err_code, :err_text;
        if (:err_code < 0) then exception RESERV_CHECK_OUT_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
      end

      update ACCOUNT_POST AP
      set    AP.IS_ARCHIVE = 1
      where  AP.ID_GUEST = :id_guest;
    
      execute procedure GUEST_SET_STATUS$INT (:g_dbkey, :checkout_status);

      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, :action_code, '');
    end

    if (:CHECK_OUT_KIND = 3) then begin
      -- DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
      execute procedure OCCUPANCY_RESERV$INT(:rd_dbkey);
    end

    execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

    execute procedure SETTING_GET_VALUE('CLEANING_RESTRICTION', :id_hotel)
    returning_values  :cleaning_restriction;
  
    if (:cleaning_restriction <> '0' and :id_room > 0) then begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'CHECK_OUT', 'set_dirty');
    end

    execute procedure RES_SAVE_STATUS$INT (:rd_dbkey, :checkout_status);

    execute procedure RES_BONUSPOINTS_APPLY$CL (:id_reserv_detail);
  end

end
^

/* Restore proc. body: RES_CHECKIN_MULTI$RSV */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable checkin_count integer;
  declare variable split_on_checkin integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
  declare variable tmp_warn_code integer;
begin
  checkin_count = 0;
  warn_code = null;
  for
    select RD.ID_RESERV_DETAIL, RD.CHECK_STATUS, RD.SPLIT_ON_CHECKIN, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :SELECTION_ID
    into   :id_reserv_detail, :check_status, :split_on_checkin, :id_titular
  do begin
    if (:check_status >= 0) then begin
      checkin_count = :checkin_count + 1;
    end else begin
      if (:split_on_checkin = 1) then begin
        for
          select G.ID_GUEST
          from   GUEST G
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and G.ID_GUEST <> :id_titular
          into   :id_guest
        do begin
          execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
          returning_values  :id_splited_reservation;

          execute procedure RES_CHECKIN$RSV (:id_splited_reservation)
          returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

          update RESERV_DETAIL RD
          set    RD.SELECTION_ID = :selection_id
          where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
        end
      end

      execute procedure RES_CHECKIN$RSV (:id_reserv_detail)
      returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
      WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end

  if (:checkin_count > 0) then begin
    execute procedure SYSTEM_WARNING_ADD(-1011, f_character(29)||:checkin_count)
    returning_values  :warn_code;
  end
end
^

/* Restore proc. body: RES_CREATE_SET$EXC */
ALTER PROCEDURE RES_CREATE_SET$EXC(ID_RESERV_DETAIL INTEGER,
RES_NUMBER VARCHAR(62),
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER,
CREATE_DATETIME TIMESTAMP)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_RESERV_DETAIL INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  WARN_CODE = 0;
  SHARE_TRANSACTION_ID = 0;
  SHARE_ERR_CODE = 0;

  execute procedure sys_dbg('exc RES_CREATE_SET$EXC => RES_CREATE_SET$INT('
  || 'code_first_food=>' || coalesce(:code_first_food, '<null>')
  || ', id_person_payment=>' || coalesce(:id_person_payment, '<null>')
  || ')');

  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, null, :arrival_date, :departure_date,
                    :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, '', :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders, :guarantee_deposit,
                    :guarantee_currency, 0, :id_reserv_detail, :res_number, null,  :id_guarantee_policy, :block_cc,
                    :id_eating_object)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :warn_code;

  execute procedure UPDATE_POSTING_TRANSACTION$EXC(:rd_dbkey, :posting_transaction_uuid, 1);

  execute procedure RES_SAVE_GUARANTEE$RSV(:id_reserv_detail, :is_vip, null,
    :id_guarantee_policy, :guarantee_deposit, :guarantee_currency, :block_cc, :guarantee_deposit_percent,
    :guarantee_deposit_nights, :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create
  );

  execute procedure RESERV_DETAIL_EXTERNAL_MOD$RSV(:id_reserv_detail,
    :minibar_rights, :paytv_rights, :video_rights, :nopost_pms, :phone_rights,
    :seminar_cahnnel_rights, null
  );

  if (:create_datetime is not null) then begin
    update reserv_detail set create_datetime = :create_datetime where rdb$db_key = :rd_dbkey;
  end
end
^

/* Restore proc. body: RES_SAVE_ROOM$INT */
ALTER PROCEDURE RES_SAVE_ROOM$INT(RD_DBKEY TYPE OF TDB_KEY,
ID_ROOM TYPE OF ID,
ID_RES_ROOM_TYPE TYPE OF ID,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE TYPE OF TLOGICAL = null)
 RETURNS(WARN_CODE TYPE OF TRANGE)
 AS
declare variable id_reserv_detail integer;
  declare variable id_tar_room_type integer;
  declare variable old_id_room_type integer;
  declare variable old_id_room integer;
  declare variable departure_date date;
  declare variable id_guest integer;
  declare variable g_dbkey char(8);
  declare variable system_date date;
  declare variable system_date_for_room date;
  declare variable check_status integer;
  declare variable cleaning_restriction varchar(50);
  declare variable guest_status varchar(50) default '';
  declare variable id_hotel integer;
  declare variable has_different_room_type integer;
  declare variable acc_routing varchar(30);
  declare variable res_number varchar(62);
begin
  select RD.ID_ROOM_TYPE, RD.CHECK_STATUS, RD.ID_ROOM, RD.TO_DATE, RD.ID_RESERV_DETAIL, RD.ID_HOTEL, rd.ACC_ROUTING, rd.NUMBER
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_room_type, :check_status, :old_id_room, :departure_date, :id_reserv_detail, :id_hotel, :acc_routing, :res_number;

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date_for_room;
  /**/
  system_date = null;
  /*  */
  if (:check_status >= 0 and :old_id_room > 0 and coalesce(:id_room, 0) <= 0) then
    exception BOOKING_EXCEPTION '-111';

  if ((:old_id_room > 0) and (:id_room is distinct from :old_id_room)) then begin
    guest_status = 'ROOM_CHANGED';
    if ((:old_id_room > 0) and (:id_room > 0)) then begin
      execute procedure SYSTEM_DATE_GET(:id_hotel)
      returning_values  :system_date;
      execute procedure sys_dbg('res RES_SAVE_ROOM$INT old_id_room = '||coalesce(:old_id_room, 'null'));
      execute procedure sys_dbg('res RES_SAVE_ROOM$INT check_status = '||coalesce(:check_status, 'null'));

      if ((:departure_date <= :system_date) and (:check_status >= 0)) then exception BOOKING_EXCEPTION '-51';
    end
  end

  if (:id_room is null and :old_id_room < 0) then id_room = :old_id_room; -- preserve old fictious ID, because of mapped rooms

  if (coalesce(:id_room, 0) <= 0) then begin
    delete from ROOM_MAP$EXC m
    where  m.id_room = :id_room
           and m.ID_SRC_ROOM < 0;  -- delete wrong mappings (bug 2827)

    select ro.ID_ROOM
    from   RES_OCCUPANCY_ROOM$INT (:id_reserv_detail, :system_date_for_room, :id_room, :ID_RES_ROOM_TYPE) RO
    into   :id_room;
  --end else if  then begin
  --  dummy = 0; -- do nothing
  end else begin
    -- real room is
    id_res_room_type = :old_id_room_type;
    if (:acc_routing <> 'OWNER'
        and :id_room is distinct from :old_id_room
        and exists (select rp.ID_ROOM_PERIOD
                    from   ROOM_PERIOD$PMS rp
                    where  rp.ID_ROOM = :ID_ROOM
                           and rp.FROM_DATE <= :system_date_for_room
                           and rp.TO_DATE >= :system_date_for_room
                           and rp.STATUS = 'PRIVATE')) then
    begin
      execute procedure SYSTEM_WARNING_ADD (-61, f_character(29) || :res_number)
      returning_values  :WARN_CODE;
    end
  end
  id_res_room_type = coalesce(:id_res_room_type, :old_id_room_type);
  -- null is permissible for id_res_room_type, treat of "keep the same"

  /* tar_option : nrttAsIs, nrttRoom, nrttReserv */
  id_tar_room_type = null;
  has_different_room_type = null;
  if (:tar_option = 'nrttAsIs') then begin
    id_tar_room_type = null;
    has_different_room_type = null;
  end else if (:tar_option = 'nrttRoom') then begin
    --id_tar_room_type = iif(coalesce(:id_room, 0) <= 0 and :room_id_room_type <> :ID_RES_ROOM_TYPE, :room_id_room_type, -1);
    id_tar_room_type = iif (:ID_ROOM > 0, -1, null); -- if not room - like a AsIs
    has_different_room_type = iif(:id_tar_room_type = -1, 0, null);
    -- preserve tar_room_type from mapped(unexisted) room
  end else begin /* nrttReserv */
    id_tar_room_type = :id_res_room_type;
    has_different_room_type = 1;
  end

  update RESERV_DETAIL RD
  set    RD.ID_ROOM = :id_room,
         rd.ROOM_PRICE = case
                           when rd.CHECK_STATUS >= 0 then null
                           -- 'checked in' bookings - force recalculation always
                           when rd.CHECK_STATUS < 0
                                and ((rd.ID_ROOM_TYPE <> :id_res_room_type) or (:id_room is distinct from :old_id_room)) then null
                           -- not 'checked in', but room/room type changed - force too
                           else rd.ROOM_PRICE
                         end,   -- <null> room_price will be force booking recalculation !!!
         RD.ID_ROOM_TYPE = :id_res_room_type,  -- this field update must be after room_price update
         rd.HAS_DIFFERENT_ROOM_TYPE = coalesce(:has_different_room_type, rd.HAS_DIFFERENT_ROOM_TYPE) --iif(coalesce(:id_tar_room_type, 0) > 0, 1, rd.HAS_DIFFERENT_ROOM_TYPE)
  where  RD.RDB$DB_KEY = :rd_dbkey;

  for
    select G.RDB$DB_KEY, G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :g_dbkey, :id_guest
  do begin
    update GUEST GU
    set    GU.OLD_ID_ROOM = GU.ID_ROOM,
           GU.ID_ROOM = :id_room
    where  GU.RDB$DB_KEY = :g_dbkey;

    execute procedure GUEST_SET_EDIT_STATUS$INT (:g_dbkey, :guest_status, 'add');
   
    /*Old code if (:system_date is null) update room_type and type stay*/
    update GUEST_STAY GS
    set    GS.ID_ROOM_TYPE = iif(:id_tar_room_type is null, GS.ID_ROOM_TYPE, :id_tar_room_type),
           GS.ID_TYPE_STAY = iif(:is_auto_staytype = 1, -1, GS.ID_TYPE_STAY)
    where  GS.ID_GUEST = :id_guest
           and ((:system_date is null) or (GS.FOR_DATE >= :system_date));

    /*New part - Room number never be updated in past - important for shares and calulations*/
    /* will be updated in pass only if there was no room assigned*/
    update GUEST_STAY GS
    set    GS.ID_ROOM = :id_room
    where  GS.ID_GUEST = :id_guest
           and ((GS.FOR_DATE >= :system_date_for_room)
                 or (:check_status < 0) -- new - always change id_room from begining, for non checked in reservs
               ) ;
  end

  if ((:check_status = 0) and (:guest_status = 'ROOM_CHANGED') and (:old_id_room > 0)) then begin
    /* IF THE CLEANING RESTRICTION IS ACTIVATED AND THE OLD
    || GUEST'S ROOM IS VACANT THEN IT MUST BE MARKED DIRTY.
    */
    execute procedure SETTING_GET_VALUE('CLEANING_RESTRICTION', :id_hotel)
    returning_values  :cleaning_restriction;
    if ((:cleaning_restriction <> '0') and (not exists (
      select *
      from   GUEST G
             join GUEST_STAY GS on GS.ID_GUEST = G.ID_GUEST
      where  GS.FOR_DATE >= :system_date
             and G.CHECK_STATUS = 0
             and GS.ID_ROOM = :old_id_room
             and G.ID_RESERV_DETAIL <> :id_reserv_detail
    ))) then begin
      execute procedure ROOM_HOUSEKEEPING(:old_id_room, 'GST_MOVED', 'set_dirty');
    end
  end

  execute procedure RES_SAVE_ROOM_LOG$INT(:RD_DBKEY, :old_id_room, :old_id_room_type);

end
^

/* Restore proc. body: RES_TAR_CALC_FINALIZE$INT */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(TAR_CALC_ERR INTEGER,
ID_TAR_CALC INTEGER,
RD_DBKEY_INIT CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
begin
  /*  Description:
  ||  Razpiswa cenata na staia, kakto i price_detailite.
      Za4istwa temp tablicite
  */
  --savedbg('TAR_CALC_ERR: ' || :TAR_CALC_ERR);
  --savedbg('ID_TAR_CALC: ' || :ID_TAR_CALC);
  if (:tar_calc_err = 0) then begin
    room_price = 0;
    room_price_details = '';

    execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

    for
      select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, rd.IS_POSTING_STOPPED,
             coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
             coalesce(max((select first 1 AP.IS_BASE
                           from   GUEST G
                                  join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                           where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                  and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (eventually)
      from   TAR_CALC_INPUT$TMP TI
             join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
             join TARIFA t on t.ID_TARIFA = rd.ID_RATE
      where  ti.ID_TAR_CALC = :ID_TAR_CALC
      group by 1, 2, 3, 4, 5, 6
      into   :id_reserv_detail, :check_status, :is_posting_stopped,
             :room_currency, :id_hotel, :is_anul, :has_postings
    do begin
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);

      if ( (not (:is_posting_stopped = 1 and :has_postings = 0))                                -- posting is not stopped
           and                                                                                  -- and
           ( (coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1) ) -- there are reasons to repost
         ) then
      begin

        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);

      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;

        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end

      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end else begin

    update RESERV_DETAIL RD
    set    RD.ROOM_PRICE = null,
           RD.ROOM_CURRENCY = null,
           RD.ROOM_PRICE_DETAILS = null,
           RD.LAST_ID_TAR_CALC = null
    where  RD.RDB$DB_KEY = :RD_DBKEY_INIT;
  end
  
  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;
end
^

/* Restore proc. body: SAFE_OCCUPANCY_MODIFY */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE TYPE OF ID,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable old_booking_number tres_number;
  declare variable id_resource_reservation id_ref;
  declare variable from_datetime tdatetime;
  declare variable action_text tdescription_long;
  declare variable old_occupant varchar(100);
  declare variable old_to_dt timestamp;
  declare variable id_reserv_detail integer;
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation;

  select rr.BOOKING_NUMBER, od.FROM_DATETIME,
         RR.OCCUPANT_NAME, od.TO_DATETIME, rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESERV_DETAIL rd on rd.NUMBER = rr.BOOKING_NUMBER and rd.IS_ANUL = 0
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :old_booking_number, :from_datetime,
         :old_occupant, :old_to_dt, :id_reserv_detail, :id_agent_profile;

  --if (:old_booking_number <> :BOOKING_NUMBER) then exception ASSERT 'Can not change booking number!';
  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  update SAFE_RESOURCE_RESERV rr
  set    rr.PRICE_DESCRIPTION = :price_description,
         rr.ID_RATE_PRICE_PROFILE = :id_agent_profile,
         rr.RATING_UNITS = :rating_units,
         rr.RATE_PRICE = :price,
         rr.RATE_CURR = :currency
  where  rr.ID_RESOURCE_RESERV = :id_resource_reservation;

  execute procedure RESOURCE_RESERVATION_MODIFY (:id_resource_reservation, :ID_SAFE, :from_datetime,
          :TO_DATETIME, :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :old_booking_number, 'mod')
  returning_values :id_resource_reservation, :no_use;

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail)
  returning_values (:DOC_SELECTED);

  /* Log changes */
  if ((:old_occupant <> :OCCUPANT_NAME) or (:old_to_dt <> :TO_DATETIME)) then begin
    action_text = f_character(29) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                  || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                  || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');
  
    execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_CHANGED', :action_text);
  end
end
^

/* Restore proc. body: SAFE_OCCUPANCY_NEW */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE TYPE OF ID,
FROM_DATETIME TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME,
BOOKING_NUMBER TYPE OF TRES_NUMBER,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
ID_RESOURCE_RESERVATION TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable action_text tdescription_long;
  declare variable id_reserv_detail integer;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, s.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  if (:id_resource_reservation is not null) then exception ASSERT '-1064'|| f_character(31) || f_character(29) || :safe_name;

  select rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESERV_DETAIL rd
  where  rd.NUMBER = :BOOKING_NUMBER
         and rd.IS_ANUL = 0
  into   :id_reserv_detail, :id_agent_profile;

  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  execute procedure  RESOURCE_RESERVATION_MODIFY (null, :ID_SAFE, :FROM_DATETIME, :TO_DATETIME,
          :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :BOOKING_NUMBER, 'add')
  returning_values (:id_resource_reservation, :no_use) ;

  insert into SAFE_RESOURCE_RESERV (ID_RESOURCE_RESERV, PRICE_DESCRIPTION, ID_RATE_PRICE_PROFILE,
         RATING_UNITS, RATE_PRICE, RATE_CURR)
  values (:id_resource_reservation, :price_description, :id_agent_profile,
         :rating_units, :price, :currency);

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail, :ID_EXTERNAL_CLIENT_ACCCOUNT)
  returning_values (:DOC_SELECTED);

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = 'CHECKED_IN'
  where  RR.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = :id_resource_reservation
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                || f_character(28) || coalesce(:BOOKING_NUMBER, '')
                || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUPIED', :action_text);
end
^

/* Restore proc. body: TAR_CALC_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
declare variable param_code varchar(40);
  declare variable id_param integer;
  declare variable param_value varchar(255);
  declare variable data_type  varchar(30);
  declare variable rate_list varchar(2000);
begin
  err_code = 0;
  param_values = '';

  if (coalesce(:rate_list_replace, '') = '') then rate_list = ',' || :id_rate || ',';
  else rate_list = :rate_list_replace;

  for
    select distinct TBP.PARAM_NAME
    from   SYSTEM_STRING_PARSER (:rate_list, ',') sp
           left join TAR_BO_PARAMS TBP on TBP.ID_TAR_HEAD = sp.ITEM
    where  (TBP.PARAM_TYPE <> 'DATE_DEPENDANT' and :for_date is null)
           or (TBP.PARAM_TYPE = 'DATE_DEPENDANT' and :for_date is not null)
    into   :param_code
  do begin
    if (:param_code is not null) then begin
      id_param = null;
      select TP.ID_TARIFA_PARAM, TP.DATA_TYPE
      from   TARIFA_PARAMS TP
      where  TP.PARAM_CODE = :param_code
             and tp.IS_USE = 1
      into   :id_param, :data_type;
  
      if (:id_param is null) then begin
        err_code = -202;
        execute procedure sys_dbg ('tar calc params err_code: ' || :err_code || F_CRLF() || 'PARAM_CODE = ' || :param_code);
        exit;
      end
  
      execute procedure TARIFA_GET_PARAM (:id_param, :for_date, :id_tar_input, :id_tar_calc)
      returning_values (:param_value);
  
      param_code = ':'||param_code;
  
      if ((:param_code is not null) and (:param_code is not null) and (:data_type is not null)) then
         param_values = :param_values||';'||:param_code||','||:data_type||','||:param_value;
    end
  end
end
^

/* Altering existing trigger... */
ALTER TRIGGER PROFILE_BIU0
AS
  declare variable charset varchar(20);
begin
  if ((inserting) or (new.PROFILE_NAME is distinct from old.PROFILE_NAME) ) then begin
    select si.INFO_VALUE
    from   SYSTEM_INFO_GET('DATABASE CHARSET') si
    into   :charset;

    if (:charset = 'WIN1250') then new.MERGE_NAME = cast(new.PROFILE_NAME as varchar(200) character set win1250);
    else if (:charset = 'WIN1251') then new.MERGE_NAME = cast(new.PROFILE_NAME as varchar(200) character set win1251);
    else if (:charset = 'WIN1252') then new.MERGE_NAME = cast(new.PROFILE_NAME as varchar(200) character set win1252);
    else new.MERGE_NAME = cast(new.PROFILE_NAME as varchar(200) character set win1252);

  end
end
^

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_TRANSFER$ACC for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: GUEST_ACCOUNT_TRANSFER$INT for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE GUEST_ACCOUNT_TRANSFER$INT(ID_GUEST INTEGER,
ID_SOURCE_ACCOUNT INTEGER,
ID_TARGET_ACCOUNT INTEGER,
SERVICE_TYPE VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: GUEST_REROUTE_POSTINGS$INT for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE GUEST_REROUTE_POSTINGS$INT(ID_GUEST INTEGER,
ID_BASE_ACCOUNT INTEGER,
ID_EXTRA_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_TRANSFER$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER)
 AS
declare variable id_current_account integer;
  declare variable id_service integer;
  declare variable is_anul integer;
  declare variable id_tariff integer;
  declare variable qty_post numeric(15,2);
  declare variable qty_free numeric(15,2);
  declare variable price_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable id_room integer;
  declare variable id_base_doc integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  if ((:AP_DBKEY is null) or (:id_target_account is null) or (:id_target_account < 0)) then
     exception POSTING_TRANSFER_EXCEPTION '-31';

  select AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST, AP.QTY_FREE,
         AP.PRICE_ORIG, AP.CURR_ORIG, AP.RATE_ORIG, ap.from_date, ap.to_date,
         AP.IS_ANUL, AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_BASE_DOC, A.ID_HOTEL
  from   ACCOUNT_POST AP
         left join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :id_service, :id_tariff, :id_room, :qty_post, :qty_free,
         :price_orig, :curr_orig, :rate_orig, :from_date, :to_date,
         :is_anul, :id_account_post, :id_current_account, :id_base_doc, :id_hotel;

  if (:id_current_account = :id_target_account) then EXIT;

  if (:is_anul = 1 ) then exception POSTING_TRANSFER_EXCEPTION '-33';

  if (:id_base_doc is not null) then exception POSTING_TRANSFER_EXCEPTION '-32';

  if (not exists(select A.ID_ACCOUNT
                 from   ACCOUNT A
                 where  A.ID_ACCOUNT = :ID_TARGET_ACCOUNT
                        and A.ID_HOTEL = :id_hotel)) then exception POSTING_TRANSFER_EXCEPTION '-376';

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
                    :id_tariff, :id_room, :qty_post, :qty_free, :price_orig, :curr_orig,
                    :rate_orig, 'TRANSFER_POSTING', null, :from_date, :to_date, 0, :id_target_account)
  returning_values  :no_use, :no_use, :no_use;

  insert into ACCOUNT_TRANSFER_HISTORY(ID_ACCOUNT_POST, FROM_ID_ACCOUNT, TO_ID_ACCOUNT)
  values (:id_account_post, :id_current_account, :id_target_account);
end
^

/* Alter (ACCOUNT_POSTING_UPDATE) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable in_db_key char(8);
begin
  /* GUI facade for manual update */
  select AP.ID_ACCOUNT, AP.ID_GUEST, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :id_guest, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date)
  returning_values  (:new_qty_post, :new_price_post, :new_ac);

  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    if (coalesce(:id_guest, 0) > 0) then begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || :id_account
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'POST_UPDATE', :action_text);
    end else begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
    end
  end

end
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUP_PREPARE$AVL for: AVAILABILITY_OCCUPANCY$INT */
ALTER PROCEDURE AVAILABILITY_OCCUP_PREPARE$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS INTEGER,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUPANCY$AVL for: AVAILABILITY_OCCUPANCY$INT */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUPANCY_PREPARE for: AVAILABILITY_OCCUPANCY$INT */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY_PREPARE(FROM_DATE DATE,
TO_DATE DATE,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TEST_RATING for: AVAILABILITY_OCCUPANCY$INT */
ALTER PROCEDURE TEST_RATING RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (AVAILABILITY_OCCUPANCY$INT) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$INT(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
declare variable id_global_agent integer;
  declare variable for_date date;
  declare variable id_agent integer;
  declare variable id_room_type integer;
  declare variable g_capacity integer;
  declare variable bp_defined integer;
  declare variable c_defined integer;
  declare variable fdata integer;
  declare variable bp_is_released integer;
  declare variable c_is_released integer;
  declare variable gsts_in_house integer;
  declare variable gsts_come integer;
  declare variable gsts_gone integer;
  declare variable rooms_come integer;
  declare variable rooms_gone integer;
  declare variable id_hotel integer;
  declare variable id_b_allotment integer;
  declare variable id_c_allotment integer;
  declare variable ooo_rooms integer;
  declare variable ooi_rooms integer;
  declare variable sold_rooms integer;
  declare variable res_room_conf integer;
  declare variable res_room_notconf integer;
  declare variable res_room_wait integer;
begin
  /*  Description:   */
  HOTELS = coalesce(:HOTELS, '');
  ID_GLOBAL_AGENT = -100; /* HOLDS DATA GLOBAL FOR THE HOTEL */

  delete from SMART_OCCUP$TMP;

  for
    select RC.ID_ROOM_TYPE, RC.ID_HOTEL, RC.FOR_DATE, sum(RC.CNT_DEFINED)
    from   HOTEL_S H
           left outer join ALLOTMENT_GET$INT(H.ID_INVENTORY_ALLOTMENT, :FROM_DATE, :TO_DATE, null, 'PLAIN_PERIOD', :HOTELS) RC on 0=0
    where  ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
    group by 1, 2, 3
    into   :ID_ROOM_TYPE, :ID_HOTEL, :FOR_DATE, :G_CAPACITY
  do begin
    execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_global_agent, :id_room_type, :id_hotel, :g_capacity);
  end

  for
    select   RM.BUSY_DATE, RM.ID_ROOM_TYPE, RM.ID_HOTEL,
             iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (18,20), :ID_GLOBAL_AGENT, coalesce(RS.ID_AGENT, RM.ID_AGENT)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 18, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 20, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 24, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_CONFIRMED', RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_NOTCONFIRMED', RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_RESERVS', RM.ID_ROOM, null))
    from     ROOM_MAGIC RM
             join HOTEL_S H on H.ID_HOTEL = RM.ID_HOTEL
             left outer join ROOMS_SHARE RS on RS.ID_ROOM_SHARE = RM.ID_ROOM_MAGIC
    where    RM.BUSY_DATE between :from_date and :to_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
             and rm.ROOM_STATUS is distinct from 'PRIVATE'
             and ((not (:RES_CONFIRMED = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_CONFIRMED'))
                  or (not (:RES_NOTCONFIRMED = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_NOTCONFIRMED'))
                  or (not (:RES_WAITING = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_RESERVS')))
    group by 1, 2, 3, 4
    into     :for_date, :id_room_type, :id_hotel, :id_agent,
             :ooo_rooms, :ooi_rooms, :sold_rooms, :res_room_conf, :res_room_notconf, :res_room_wait
  do begin
    execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
            null, :ooo_rooms, :ooi_rooms, null, :sold_rooms, :res_room_conf, :res_room_notconf, :res_room_wait);
  end

  if (:BOOKING_POSITIONS + :CONTINGENT > 0) then begin
    for
      select PA.ID_AGENT, PA.ID_BOOKING_POSITION, pa.ID_CONTINGENT
      from   PROFILE_AGENT PA
      where  (pa.ID_CONTINGENT is not null) or (pa.ID_BOOKING_POSITION is not null)
      into   :id_agent, :id_b_allotment, :id_c_allotment
    do begin
      for
        select al.for_date, al.id_room_type, al.id_hotel,
               sum(al.b_defined), max(al.b_is_released), sum(al.c_defined), max(al.c_is_released)
        from   (select ABP.FOR_DATE, ABP.ID_ROOM_TYPE, ABP.ID_HOTEL,
                       ABP.CNT_DEFINED as b_defined, ABP.IS_RELEASED as b_is_released, null as c_defined, null as c_is_released
                from   ALLOTMENT BA
                       left join ALLOTMENT_GET$INT(ba.ID_ALLOTMENT, :from_date, :to_date, null, 'RELEASES', :hotels) ABP on 1=1
                where  :BOOKING_POSITIONS = 1 and ba.ID_ALLOTMENT = :id_b_allotment
                union all
                select ACG.FOR_DATE, ACG.ID_ROOM_TYPE, ACG.ID_HOTEL, null, null, ACG.CNT_DEFINED, ACG.IS_RELEASED
                from   ALLOTMENT CA
                       left join ALLOTMENT_GET$INT(ca.ID_ALLOTMENT, :from_date, :to_date, null, '', :hotels) ACG on 1=1
                where  :CONTINGENT = 1 and CA.ID_ALLOTMENT = :id_c_allotment
               ) al
        where  al.for_date is not null
        group by 1, 2, 3
        into   :for_date, :id_room_type, :id_hotel,
               :bp_defined, :bp_is_released, :c_defined, :c_is_released
      do begin
        execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
                null, null, null, null, null, null, null, null, :c_defined, :c_is_released, :bp_defined, :bp_is_released);
      end
    end
  end

  if (:OVERBOOK = 1) then begin
    for
      select ACG.FOR_DATE, ACG.ID_ROOM_TYPE, ACG.ID_HOTEL, ACG.CNT_DEFINED
      from   HOTEL_S H
             left outer join ALLOTMENT_GET$INT(H.ID_OVERBOOK_ALLOTMENT, :FROM_DATE, :TO_DATE, null, '', :HOTELS) ACG on 0=0
      where  ACG.FOR_DATE is not null
             and ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
      into   :for_date, :id_room_type, :id_hotel, :fdata
    do begin
      execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
              null, null, null, :fdata);
    end
  end

  if (:FETCH_TOTALS = 1) then begin
    for
      select SOGT.BUSY_DATE, SOGT.ID_ROOM_TYPE, sum(SOGT.GSTS_COME+SOGT.GSTS_STAYOVER), sum(SOGT.GSTS_COME),
             sum(SOGT.GSTS_GONE), sum(SOGT.ROOMS_COME), sum(SOGT.ROOMS_GONE), SOGT.ID_HOTEL, SOGT.ID_AGENT
      from   REP_ROOM_STATUS_MOVE(:from_date, :to_date, -1, -1, -1, '', '', :hotels) SOGT
      group by SOGT.BUSY_DATE, SOGT.ID_ROOM_TYPE, SOGT.ID_HOTEL, SOGT.ID_AGENT
      into   :for_date, :id_room_type, :gsts_in_house, :gsts_come,
             :gsts_gone, :rooms_come, :rooms_gone, :id_hotel, :id_agent
    do begin
      execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
              null, null, null, null, null, null, null, null, null, null, null, null,
              :gsts_in_house, :gsts_come, :gsts_gone, :rooms_come, :rooms_gone);
    end
  end
end
^

/* Alter (AVAILABILITY_OCCUPANCY_PREPARE) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY_PREPARE(FROM_DATE DATE,
TO_DATE DATE,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
begin
  -- used from some reports - generate occupancy for selection
  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, 1, :OVERBOOK,
          :RES_CONFIRMED, :RES_NOTCONFIRMED, :RES_WAITING, :BOOKING_POSITIONS, :CONTINGENT, :HOTELS);
   
  execute procedure AVAILABILITY_OCCUPANCY_OPT$INT (:RELEASE_DATES, :OVERBOOK,
          :RES_CONFIRMED, :RES_NOTCONFIRMED, :RES_WAITING, :BOOKING_POSITIONS, :CONTINGENT);

  ID_OCCUPANCY_SESSION = current_transaction;
  suspend;
end
^

/* Alter (BLOCK_ANNUL$BLK) */
ALTER PROCEDURE BLOCK_ANNUL$BLK(ID_BLOCK_ROOM INTEGER,
OPERATION VARCHAR(30))
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable share_err_text varchar(255);
  declare variable system_date date;
  declare variable cancel_date date;
  declare variable from_date date;
  declare variable b_dbkey char(8);
  declare variable new_id_block_room integer;
  declare variable id_room integer;
  declare variable block_grp integer;
  declare variable reason varchar(50);
  declare variable note varchar(255);
  declare variable action_text varchar(255);
  declare variable room_name varchar(10);
  declare variable id_hotel integer;
  declare variable mark_dirty_expired_block integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION (:operation, 'cancel, annul');

  select BR.FROM_DATE, BR.RDB$DB_KEY, R.ID_HOTEL
  from   BLOCK_ROOM BR
         join ROOMS R on R.ID_ROOM = BR.ID_ROOM
  where  BR.ID_BLOCK_ROOM = :id_block_room
  into   :from_date, :b_dbkey, :id_hotel;

  if (:operation = 'annul') then begin
    update BLOCK_ROOM BR
    set    BR.IS_ANNUL = 1
    where  BR.RDB$DB_KEY = :b_dbkey;
  
    execute procedure BLOCK_MODIFY_CONTROL$INT(:b_dbkey, :from_date);
    execute procedure ROOM_MAGIC_CLEAR(:id_block_room);
    action_text = '';
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :id_block_room, 'ANNUL_BLOCK', :action_text);
  end else begin
    select BR.ID_ROOM, BR.BLOCK_GRP, BR.REASON, BR.NOTE, R.ROOM_NAME
    from   BLOCK_ROOM BR
           join ROOMS R on R.ID_ROOM = BR.ID_ROOM
    where  BR.RDB$DB_KEY = :b_dbkey
    into   :id_room, :block_grp, :reason, :note, :room_name;

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :system_date;
    cancel_date = :system_date - 1;

    execute procedure BLOCK_MODIFY$INT(:id_block_room, :id_room, :from_date, :cancel_date, :block_grp, :reason,
                      :note, 'mod')
    returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :share_err_text, :warn_code;
    --ignore possible entering into share

    execute procedure SETTING_GET_VALUE('MARK_DIRTY_EXPIRED_BLOCK', :id_hotel)
    returning_values  :mark_dirty_expired_block;
    if (:mark_dirty_expired_block = '1') then begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'BLOCK_STOP', 'set_dirty');
    end

    action_text = f_character(29) || :room_name || f_character(28) || formatdate(:cancel_date, 'D;dd.mm.yyyy');
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :new_id_block_room, 'CANCEL_BLOCK', :action_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_INITIALIZE$DOC for: DOC_CONTRAGENT_INITIALIZE$INT */
ALTER PROCEDURE DOCUMENT_INITIALIZE$DOC(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
DOC_SELECTED /* TYPE OF ID */ INTEGER,
PROFORMA_NAME_PREFIX VARCHAR(30) = null)
 RETURNS(ID_DOC_HEAD INTEGER,
ID_HOTEL INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOC_CONTRAGENT_INITIALIZE$INT) */
ALTER PROCEDURE DOC_CONTRAGENT_INITIALIZE$INT(ID_DOC INTEGER,
IS_PAY_DOC SMALLINT,
ID_PROFILE INTEGER)
 AS
declare variable is_juridical_person integer;
  declare variable contragent_name varchar(100);
  declare variable vat_reg_num varchar(30);
  declare variable ident_no varchar(30);
  declare variable post_address varchar(100);
  declare variable zip_code varchar(10);
  declare variable country_code varchar(20);
  declare variable mol varchar(30);
  declare variable id_contragent integer;
  declare variable recipient_name varchar(100);
  declare variable recipient_pas_num varchar(20);
  declare variable recipient_pas_date date;
  declare variable recipient_pas_from varchar(30);
  declare variable bank_name varchar(50);
  declare variable bic varchar(30);
  declare variable iban varchar(30);
  declare variable id_doc_contragent integer;
  declare variable email varchar(50);
begin

  execute procedure PROFILE_GET_CONTRAGENT_DATA$INT (:id_profile)
  returning_values (:id_contragent, :is_juridical_person, :contragent_name,
                    :vat_reg_num, :ident_no, :country_code, :post_address, :zip_code, :email,
                    :mol, :recipient_name, :recipient_pas_num, :recipient_pas_date, :recipient_pas_from,
                    :bank_name, :bic, :iban);

  if (:id_contragent is null and trim(coalesce(:contragent_name, '')) = '') then exit; /* not valid contragent */

  execute procedure DOC_CONTRAGENT_SET$DOC (:ID_DOC, :IS_PAY_DOC, :id_contragent,
          coalesce(:is_juridical_person, 0), :contragent_name, :vat_reg_num, :ident_no,
          :country_code, :post_address, :zip_code, :email, :mol, :recipient_name,
          :recipient_pas_num, :recipient_pas_date, :recipient_pas_from, null, null, null,
          0, :bank_name, :bic, :iban)
  returning_values :id_doc_contragent;

end
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_DOCUMENT_INITIALIZE$DOC for: DOCUMENT_INITIALIZE$DOC */
ALTER PROCEDURE DEPOSIT_DOCUMENT_INITIALIZE$DOC(ID_PAYMENT_HEAD /* TYPE OF ID */ INTEGER,
ID_BILLING_SERVICE /* TYPE OF ID */ INTEGER)
 RETURNS(ID_DOC_HEAD /* TYPE OF ID */ INTEGER,
ID_HOTEL /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TEST_DOC for: DOCUMENT_INITIALIZE$DOC */
ALTER PROCEDURE TEST_DOC(ID_ACCOUNT INTEGER,
DOC_SELECTED INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOCUMENT_INITIALIZE$DOC) */
ALTER PROCEDURE DOCUMENT_INITIALIZE$DOC(ID_ACCOUNT TYPE OF ID,
DOC_SELECTED TYPE OF ID,
PROFORMA_NAME_PREFIX VARCHAR(30) = null)
 RETURNS(ID_DOC_HEAD INTEGER,
ID_HOTEL INTEGER,
WARN_CODE INTEGER)
 AS
declare variable id_doc_type integer;
  declare variable id_base_doc integer;
  declare variable tax_event_date date;
  declare variable doc_date date;
  declare variable doc_curr varchar(3);
  declare variable id_doc_contragent integer;
  declare variable id_profile integer;
  declare variable doc_sub_type integer;
  declare variable firm_data blob sub_type 1 segment size 80 character set none;
  declare variable id_advance_payment integer;
  declare variable is_proforma tlogical;
  declare variable is_archive tlogical;
  declare variable doc_type_name varchar(50);
begin
  is_proforma = iif(:PROFORMA_NAME_PREFIX is null, 0, 1);

  if (:IS_PROFORMA is distinct from 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_NOPAY_CREATE');
  end else begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('PROFORMA_CREATE');
  end

  select A.ID_HOTEL, A.ID_PROFILE, H.FIRM_DATA
  from   ACCOUNT A
         join HOTEL H on H.ID_HOTEL  = A.ID_HOTEL
  where  A.ID_ACCOUNT = :id_account
  into   :id_hotel, :id_profile, :firm_data;

  id_advance_payment = null;
  execute procedure DOCUMENT_CHECK_SELECTION$INT (:DOC_SELECTED, :ID_ACCOUNT)
  returning_values  (:id_doc_type, :id_base_doc, :doc_curr, :id_doc_contragent, :id_advance_payment);

  if (:is_proforma = 1 and :id_base_doc is not null) then exception DOCUMENT_EXCEPTION '-1062';

  if (:id_doc_type is null) then begin
    execute procedure DOC_TYPE_GET$INT (:id_hotel, :IS_PROFORMA, :id_advance_payment)
    returning_values (:id_doc_type);
  end

  execute procedure CURR_RATES_PREPARE$INT (:DOC_SELECTED, :ID_ACCOUNT, :doc_date);

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :doc_date;
  tax_event_date = :doc_date;
                                                    
  select coalesce(:doc_curr, DT.DOC_CURR),
         iif (:is_proforma = 1, substring(trim(:PROFORMA_NAME_PREFIX) || ' ' || dt.doc_type_name from 1 for 50), dt.DOC_TYPE_NAME),
         dt.IS_ARCHIVE
  from   DOC_TYPE DT
  where  DT.ID_DOC_TYPE = :id_doc_type
  into   :doc_curr, :DOC_TYPE_NAME, :is_archive;

  if (:is_archive = 1) then execute procedure SYSTEM_WARNING_ADD(-312, '') returning_values :WARN_CODE;

  execute procedure DOCUMENT_CREATE$INT (:DOC_SELECTED, :ID_ACCOUNT, :id_doc_type, :doc_type_name, :doc_date, :doc_curr, :id_base_doc, :tax_event_date, :is_proforma, :id_advance_payment)
  returning_values  (:ID_DOC_HEAD, :doc_sub_type);

  if (:ID_ADVANCE_PAYMENT is null and :IS_PROFORMA is distinct from 1 and :doc_sub_type < 2) then begin
    execute procedure DOCUMENT_ATTACH_AVAIL_PAYS$INT (:ID_DOC_HEAD, :ID_ACCOUNT);
  end

  if (:id_doc_contragent is not null) then begin
    execute procedure DOC_CONTRAGENT_INITIALIZE$DOC (:ID_DOC_HEAD, null, :id_doc_contragent);
  end else begin
    execute procedure DOC_CONTRAGENT_INITIALIZE$INT (:ID_DOC_HEAD, 0, :id_profile);
  end

  execute procedure DOC_SUPPLIER_SET$DOC (:ID_DOC_HEAD, :firm_data);

  when exception DOC_ON_EMPTY_SELECTION do begin
    ID_DOC_HEAD = null;
  end
end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_POST_TO_FRONT_ONLINE for: EAI_EXT_POST_TO_MH_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_EXT_POST_TO_MH_FRONT_ONLINE) */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  if (:CODE_TYPE = 'EXT_CODE') then begin
    execute procedure EAI_MAP_SERVICE(:SERVICE_CODE, :SERVICE_CODE, 'UNKNOWN', :id_hotel)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_SERVICE;
    if (:ERR_CODE < 0) then exit;
  end else begin
    select S.ID_SERVICE
    from   SERVICES S
    where  S.ID_SERVICE = :SERVICE_CODE
           and s.ID_HOTEL = :ID_HOTEL
    into   :ID_SERVICE;
    if (:ID_SERVICE is null) then begin
      ERR_CODE = -85;   /* Wrong value! */
      exit;
    end
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Alter (EAI_EXT_SERVICE_POST) */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable max_id_service integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_ROOM  = null;
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  select min(S.ID_SERVICE) as id_service, max(s.id_service) as max_id_service
  from   SERVICES S
  where  S.EXT_CODE = :SERVICE_EXT_CODE
         and s.IS_BASE = 0
         and s.IS_DELETED = 0
  into   :ID_SERVICE, :max_id_service;
  if (:ID_SERVICE is null) then begin
      ERR_CODE = -388;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end else if (:ID_SERVICE <> :max_id_service) then begin
      ERR_CODE = -389;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_EXT_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* empty dependent procedure body */
/* Clear: EAI_POS_POSTING_ADD for: EAI_POS_POSTING_ADD$P2E */
ALTER PROCEDURE EAI_POS_POSTING_ADD(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_POS_POSTING_ADD$P2E) */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
declare variable id_service integer;
  declare variable my_post_text varchar(255);
  declare variable my_resource_text varchar(255);
  declare variable no_use integer;
  declare variable nation_curr varchar(3);
  declare variable post_short_code varchar(10);
  declare variable id_hotel integer;
begin
  /* in_on_guest = 0 (account), 1 (guest), -1 (ew)
  */
  if (:IN_ON_GUEST = 1) then begin
    select rd.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :IN_ID_GUEST
    into   :id_hotel;
  end else begin
    select a.ID_HOTEL
    from   account a
    where  a.ID_ACCOUNT = :in_id_account
    into   :id_hotel;
  end

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :nation_curr;

  if ('END_WORK' = :in_smetka_num) then begin
    post_short_code='POS_EW';
  end else begin
    post_short_code='POS';
  end

  /* FIND SERVICE */
  execute procedure EAI_MAP_SERVICE(:in_service_tag, :in_service_name, 'POS', :id_hotel)
  returning_values  :err_code, :err_text, :id_service;
  if (:err_code < 0) then exit;

  my_post_text = 'date:'|| formatdate(:in_date_smetka, 'D;dd.mm.yyyy') ||
                 ' num:'|| :in_smetka_num ||
                 ' obj:'|| :in_obj_name ||
                 ' tbl:'|| :in_table ||
                 ' site:'|| :in_site;

  my_resource_text = 'POS_ID_SMETKA:'||:in_id_smetka;
  my_post_text = substring(:my_post_text from 1 for 100);
  my_resource_text = substring(:my_resource_text from 1 for 49);

  if (:in_on_guest = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:in_id_guest, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code, '')
    returning_values  :err_code, :err_text, :out_id_account, :no_use;
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:in_id_account, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code)
    returning_values  :err_code, :err_text, :no_use;
    out_id_account = :in_id_account;
  end
end
^

/* Alter (EAI_ROOM_STATUS_SET) */
ALTER PROCEDURE EAI_ROOM_STATUS_SET(ROOM_NAME VARCHAR(10),
OPERATION VARCHAR(20),
TAG VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_room integer;
  declare variable set_options varchar(255);
begin
  err_code = 0;
  err_text = '';

  execute procedure SYSTEM_CHECK_OPERATION(:OPERATION, 'setclean,setdirty,settext');

  id_room = null;
  if (singular(select RO.ID_ROOM
               from ROOMS RO
                  join HOTEL_S HO on HO.ID_HOTEL = RO.ID_HOTEL
               where  RO.ROOM_NAME = :ROOM_NAME
                      and HO.IS_USE = 1)) then
    select R.ID_ROOM
    from   ROOMS R
      join HOTEL_S HS on HS.ID_HOTEL = R.ID_HOTEL
    where  R.ROOM_NAME = :ROOM_NAME
           and HS.IS_USE = 1
    into   :id_room;
  else begin
    err_code = -1044;
    exit;
  end

  if (:id_room is null) then begin
    err_code = -5;
    err_text = :room_name;
    exit;
  end

  if (:operation = 'setclean') then set_options = 'set_clean';
  else if (:operation = 'setdirty') then set_options = 'set_dirty';
  else if (:operation = 'settext') then set_options = 'set_text'||f_character(28)||:tag;

  execute procedure ROOM_HOUSEKEEPING(:id_room, 'EXT_IFC', :set_options);
end
^

/* Alter (EAI_TELECOUNT_TRANSFER) */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* Alter (END_WORK) */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable system_date date;
  declare variable id_room integer;
  declare variable id_end_work integer;
  declare variable last_closed_date date;
  declare variable mark_dirty_expired_block varchar(10);
  declare variable mark_dirty_occ_room varchar(10);
  declare variable lock_id integer;
  declare variable shift_no integer;
  declare variable init_hotel_date date;
begin

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;
  if (:system_date >= :in_next_date) then exception END_WORK_EXCEPTION '-43';
  if (:IN_NEXT_DATE > current_date + 1) then exception END_WORK_EXCEPTION '-60';

  last_closed_date = :in_next_date - 1;

  /* LOCK THE CURRENT FINANCIAL (SYSTEM) DATE  */
  lock_id = null;
  while (:lock_id is null) do begin
    lock_id = strhash_large(:system_date || :id_hotel);
    execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'lock');
  
    when any do begin
      exception END_WORK_EXCEPTION '-337' || f_character(31) || f_character(29) || FormatDate(:system_date, 'D;dd.mm.yyyy');
    end
  end

  /* RIGHT IS REQUIRED TO CHANGE THE FINANCIAL DATE IF THERE ARE GUESTS WITH OVERDUE CHECK OUT */
  if (exists(
    select *
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
    where  G.TO_DATE <= :last_closed_date
           and G.CHECK_STATUS < 1
           and RD.ID_HOTEL = :id_hotel
           and rd.IS_ANUL = 0
  )) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('EW_OVERDUE_CHECKOUT');
  end

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', 'EW');
  -- Suppress eventual right checks into next procedures - all is permitted. Is this needed(?!?)

  update ACCOUNT_POST AP
  set    ap.ROOM_NAME = (select R.ROOM_NAME
                         from   GUEST G
                                join ROOMS R on R.ID_ROOM = G.ID_ROOM
                         where  G.ID_GUEST = ap.ID_GUEST)
  where  ap.DATE_POST between :system_date and :last_closed_date
         and ap.ID_GUEST > 0;

  select coalesce(max(ew.SHIFT_NO), 0) + 1
  from   END_WORKS ew
  where  ew.PREV_DATE = :system_date
  into   :shift_no;

  id_end_work = gen_id(G_AUTO_INC_END_WORKS, 1);
  insert into END_WORKS (ID_END_WORK, PREV_DATE, NEXT_DATE, END_WORK_KIND, SHIFT_NO, ID_HOTEL)
  values (:id_end_work, :system_date, :in_next_date, 3, :shift_no, :id_hotel);

  /* CHANGE SYSTEM DATE */
  execute procedure SYSTEM_DATE_SET(:id_hotel, :in_next_date);

  /* AUTO EXPIRATION OF ROOM NUMBERS, ROOMS AND BOOKING POSITIONS */
  execute procedure RESERVS_EXPIRE$INT(:last_closed_date, :id_hotel);

  execute procedure AGENT_CONTINGENT_EXPIRE(:system_date, :last_closed_date, null, 0, 1, :id_hotel);

  /* DELETE PERSON PROFILES WITH EXPIRATION DATE */
  execute procedure PROFILE_PERSON_EXPIRE (:in_next_date);

  execute procedure SETTING_GET_VALUE('MARK_DIRTY_EXPIRED_BLOCK', :ID_HOTEL)
  returning_values  :mark_dirty_expired_block;
  if (:mark_dirty_expired_block = '1') then begin
    for
      select distinct BR.ID_ROOM
      from   BLOCK_ROOM BR
             join ROOMS R on R.ID_ROOM = BR.ID_ROOM
      where  R.ID_HOTEL = :id_hotel
             and BR.TO_DATE >= :system_date
             and BR.TO_DATE < :in_next_date
             and BR.IS_ANNUL = 0
         into :id_room
    do begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'BLOCK_EXP', 'set_dirty');

      when any do post_event 'dummy';  -- nothing
    end
  end

  execute procedure SETTING_GET_VALUE('MARK_DIRTY_OCC_ROOM', :ID_HOTEL)
  returning_values  :mark_dirty_occ_room;
  if (:mark_dirty_occ_room = '1') then begin
    for
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
             join ROOMS R on R.ID_ROOM = rm.ID_ROOM
      where  R.ID_HOTEL = :id_hotel
             and RM.BUSY_DATE = :system_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and RM.BUSY_GROUP_TYPE = 24
      into   :id_room
    do begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'EW_DAY', 'set_dirty');

      when any do post_event 'dummy';  -- nothing
    end
  end

  /* Summary data prepare */
  if (:in_next_date > :system_date) then begin
    execute procedure SUMMARY_FINANCE_SAVE$INT (:id_end_work);

    select min(e.PREV_DATE)
    from   END_WORKS E
    where  E.ID_HOTEL = :ID_HOTEL
    into   :init_hotel_date;

    execute procedure SUMMARY_PREPARE$INT(:id_hotel, :init_hotel_date, :last_closed_date); --TODO precise the period

    execute procedure SUMMARY_FORECAST$INT(:ID_HOTEL, :system_date);
  end

  /* Delete data from temporal tables */
  delete from RESERV_ERROR;
  delete from TMP_SMALL_OCCUP;
--  delete from GUEST g where g.id_reserv_detail is null; pri regenerirane na statistikata ne vurshi rabota
  /*  */

  execute procedure CACHES_RESOLVE;

  execute procedure SYSTEM_LOG_ADD('SYSTEM', :id_end_work, 'DAY_EW', f_character(29) || :last_closed_date);

  execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'release');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', null);

  post_event 'invalidate.end_work';
end
^

/* Alter (GUEST_ACCOUNT_TRANSFER$INT) */
ALTER PROCEDURE GUEST_ACCOUNT_TRANSFER$INT(ID_GUEST INTEGER,
ID_SOURCE_ACCOUNT INTEGER,
ID_TARGET_ACCOUNT INTEGER,
SERVICE_TYPE VARCHAR(20))
 AS
declare variable dbkey char(8);
begin

  if (:service_type = 'BASE') then begin
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.ID_ACCOUNT = :id_source_account
             and AP.AC = '00'
             and AP.ID_BASE_DOC is null
             and ((AP.IS_BASE = 1) or (AP.ID_MASTER_ADDINS_ACC_POST <> -1))
      into   :dbkey
    do
      execute procedure ACCOUNT_POSTING_TRANSFER$INT(:dbkey, :id_target_account);

  end else begin
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.ID_ACCOUNT = :id_source_account
             and AP.AC = '00'
             and AP.ID_BASE_DOC is null
             and ((AP.IS_BASE = 0) and (AP.ID_MASTER_ADDINS_ACC_POST = -1))
      into   :dbkey
    do
      execute procedure ACCOUNT_POSTING_TRANSFER$INT(:dbkey, :id_target_account);

  end
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_GUEST$EXC for: GUEST_ADDRESSCARD_SET$RSV */
ALTER PROCEDURE IMPORT_GUEST$EXC(BOOKING_ID INTEGER,
PROFILE_UUID VARCHAR(40),
GUEST_UUID VARCHAR(40),
GUEST_NAME VARCHAR(100),
IS_CHILD SMALLINT,
AGE INTEGER,
IS_DIFFERENT_ARRANGER SMALLINT,
ARRIVAL DATE,
DEPARTURE DATE,
VOUCHER VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
RATING_AGE INTEGER,
KPP VARCHAR(50),
KPP_DATE DATE,
STAY_REASON VARCHAR(255),
CAR VARCHAR(30),
IS_REGISTRED SMALLINT,
PERSONAL_NUMBER VARCHAR(30),
TITLE VARCHAR(10),
PT_NAME VARCHAR(100),
PT_EXTCODE VARCHAR(50),
PASS_NUM VARCHAR(20),
PASS_PLACE VARCHAR(20),
PASS_DATE DATE,
PASS_EXP_DATE DATE,
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_DATE DATE,
SEX CHAR,
BIRTH_PLACE VARCHAR(30),
MASK VARCHAR(10),
PACKAGE VARCHAR(255),
VISA /* TDESCRIPTION_SHORT */ VARCHAR(100))
 RETURNS(GUEST_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (GUEST_ADDRESSCARD_SET$RSV) */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$RSV(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
EGN VARCHAR(30),
COUNTRY VARCHAR(10),
ID_STAY_REASON INTEGER,
IS_REGISTRED INTEGER,
PASS_PLACE VARCHAR(20),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_PLACE VARCHAR(30),
SEX CHAR,
MASK VARCHAR(10),
IS_CHILD INTEGER,
CAR VARCHAR(30),
KPP INTEGER,
KPP_DATE DATE,
PASS_EXP_DATE DATE,
AGE INTEGER,
BIRTH_DAY DATE,
VISA TDESCRIPTION_SHORT,
RATING_AGE INTEGER = null,
TITLE VARCHAR(10) = null,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable gd_dbkey char(8);
  declare variable pd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable rd_dbkey char(8);
  declare variable old_is_registred integer;
  declare variable old_guest_name1 varchar(250);
  declare variable old_guest_name2 varchar(250);
  declare variable old_id_pass_type integer;
  declare variable old_pass_num varchar(20);
  declare variable old_pass_date date;
  declare variable old_egn varchar(30);
  declare variable old_country varchar(20);
  declare variable old_id_stay_reason integer;
  declare variable old_kpp integer;
  declare variable old_kpp_date date;
  declare variable old_pass_exp_date date;
  declare variable old_birth_day date;
  declare variable old_pass_place varchar(20);
  declare variable old_city varchar(100);
  declare variable old_address varchar(100);
  declare variable old_visa TDESCRIPTION_SHORT;
  declare variable old_birth_place varchar(30);
  declare variable old_sex char(1);
  declare variable action_text varchar(250);
  declare variable tt_reg_number integer;
  declare variable id_hotel integer;
  declare variable id_tt_numerator integer;
  declare variable domestic_nation varchar(10);
  declare variable no_use varchar(255);
  declare variable is_anul smallint;
  declare variable acc_routing varchar(20);
begin
  err_code = 0;
  err_text = '';

  select G.RDB$DB_KEY, GD.RDB$DB_KEY, PD.RDB$DB_KEY,
         GD.IS_REGISTRED, PD.PERSON_NAME, PD.PERSON_NAME2, PD.ID_PASSPORT_TYPE, PD.PASS_NUM, PD.PASS_DATE,
         PD.EGN, PD.COUNTRY_CODE, GD.ID_STAY_REASON, GD.KPP, GD.KPP_DATE, PD.PASS_EXP_DATE,
         PD.BIRTH_DAY, PD.PASS_PLACE, PD.CITY, PD.ADDRESS, PD.BIRTH_PLACE, PD.SEX, rd.RDB$DB_KEY,
         g.TT_REG_NUMBER, rd.ID_HOTEL, rd.IS_ANUL, rd.ACC_ROUTING, GD.VISA
  from   GUEST G
         join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
         join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
         join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
  where  G.ID_GUEST = :id_guest
  into   :g_dbkey, :gd_dbkey, :pd_dbkey,
         :old_is_registred, :old_guest_name1, :old_guest_name2, :old_id_pass_type, :old_pass_num, :old_pass_date,
         :old_egn, :old_country, :old_id_stay_reason, :old_kpp, :old_kpp_date, :old_pass_exp_date,
         :old_birth_day, :old_pass_place, :old_city, :old_address, :old_birth_place, :old_sex, :rd_dbkey,
         :tt_reg_number, :id_hotel, :is_anul, :acc_routing, :old_visa;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, :birth_place, :egn, :id_passport_type, :pass_num, :pass_date, :pass_place,
          :pass_exp_date, :city, :address, :sex, :mask);

  update  GUEST_DATA GD
  set     GD.KPP_DATE = :kpp_date,
          GD.KPP = :kpp,
          GD.VISA = :visa,
          GD.ID_STAY_REASON = :id_stay_reason,
          GD.IS_REGISTRED = :is_registred,
          GD.USER_REGISTRED = iif(:IS_REGISTRED = 1, coalesce(GD.USER_REGISTRED, current_user), null),
          GD.CAR = :car,
          GD.RATING_AGE = :RATING_AGE
  where   GD.RDB$DB_KEY = :gd_dbkey;

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name1, :guest_name2, :country,
          :is_child, :age, :birth_day, :TITLE);

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -1);

  /*  */
  if (:IS_REGISTRED = 1 and :tt_reg_number is null and :is_anul = 0 and :acc_routing is distinct from 'OWNER') then begin
    execute procedure SETTING_GET_VALUE ('NATIVE_NATION', :id_hotel)
    returning_values :domestic_nation;

    select iif(:COUNTRY not in (:domestic_nation, '') and h.USE_DIFFERENT_TT_NUMERATORS = 1,
               h.ID_TT_NUMERATOR_2,
               h.ID_TT_NUMERATOR_1)
    from   HOTEL H
    where  h.ID_HOTEL = :id_hotel
    into   :id_tt_numerator;

    if (:id_tt_numerator is not null) then begin
      execute procedure SYSTEM_GEN_NUM('GUEST_NUM', :id_tt_numerator)
      returning_values :tt_reg_number, :no_use;
  
      update GUEST G
      set    g.TT_REG_NUMBER = :tt_reg_number
      where  G.RDB$DB_KEY = :g_dbkey;
    end
  end else if (:IS_REGISTRED is distinct from 1 and :tt_reg_number is not null) then begin
    update GUEST G
    set    g.TT_REG_NUMBER = null
    where  G.RDB$DB_KEY = :g_dbkey;
  end
  /*  */
  if ((:old_is_registred = 0) and (:is_registred = 1)) then begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'REGISTRED', '');
  end

  if ((:old_is_registred = 1) and (:old_guest_name1 <> :guest_name1)) then begin
    action_text = f_character(29)||:old_guest_name1||f_character(28)||:guest_name1;
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'CHANGE_CARD', :action_text);
  end

  if ((:old_IS_REGISTRED = 1)
      and
      ((:old_guest_name1 <> :guest_name1)
        or (:old_guest_name2 <> :guest_name2)
        or (:old_egn <> :egn)
        or (:old_id_pass_type <> :id_passport_type)
        or (:old_pass_num <> :pass_num)
        or (:old_pass_date <> :pass_date)
        or (:old_pass_exp_date <> :pass_exp_date)
        or (:old_pass_place <> :pass_place)
        or (:old_country <> :country)
        or (:old_city <> :city)
        or (:old_address <> :address)
        or (:old_visa <> :visa)
        or (:old_birth_day <> :birth_day)
        or (:old_birth_place <> :birth_place)
        or (:old_sex  <> :sex)
        or (:old_kpp <> :kpp)
        or (coalesce(:old_id_stay_reason,0) <> coalesce(:id_stay_reason,0))
        or (:old_kpp_date <> :kpp_date)
      )) then
  begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'PREREGISTRED', '');
  end

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
    returning_values  :warn_code;

  end

end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTS$INT for: GUEST_REROUTE_POSTINGS$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTS$INT(RD_DBKEY CHAR(8))
 AS
 BEGIN EXIT; END
^

/* Alter (GUEST_REROUTE_POSTINGS$INT) */
ALTER PROCEDURE GUEST_REROUTE_POSTINGS$INT(ID_GUEST INTEGER,
ID_BASE_ACCOUNT INTEGER,
ID_EXTRA_ACCOUNT INTEGER)
 AS
declare variable ap_dbkey char(8);
  declare variable is_packet_post integer;
  declare variable packet_option varchar(50);
  declare variable id_target_account integer;
  declare variable id_current_account integer;
begin
  update GUEST G
  set    G.ID_BASE_ACCOUNT = :ID_BASE_ACCOUNT,
         G.ID_ACCOUNT = :ID_EXTRA_ACCOUNT
  where  G.ID_GUEST = :ID_GUEST;

  for
    select AP.RDB$DB_KEY, iif(AP.ID_MASTER_ADDINS_ACC_POST > 0, 1, 0), S.VAUCHER_PACKET,
           ap.ID_ACCOUNT
    from   ACCOUNT_POST AP
           join SERVICES S on S.ID_SERVICE = AP.ID_SERVICE
    where  AP.ID_GUEST = :ID_GUEST
           and AP.AC = '00'
           and AP.ID_BASE_DOC is null
    into   :ap_dbkey, :is_packet_post, :packet_option, :id_current_account
  do begin
    if ((:is_packet_post = 1) and (:packet_option <> 'NONE')) then id_target_account = :id_base_account;
    else id_target_account = :id_extra_account;

    if (:id_current_account <> :id_target_account) then begin
      execute procedure ACCOUNT_POSTING_TRANSFER$INT(:ap_dbkey, :id_target_account);
    end
  end

end
^

/* empty dependent procedure body */
/* Clear: CREATE_BOOKING$WBE for: IMPORT_GUEST$EXC */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
 BEGIN SUSPEND; END
^

/* Alter (IMPORT_GUEST$EXC) */
ALTER PROCEDURE IMPORT_GUEST$EXC(BOOKING_ID INTEGER,
PROFILE_UUID VARCHAR(40),
GUEST_UUID VARCHAR(40),
GUEST_NAME VARCHAR(100),
IS_CHILD SMALLINT,
AGE INTEGER,
IS_DIFFERENT_ARRANGER SMALLINT,
ARRIVAL DATE,
DEPARTURE DATE,
VOUCHER VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
RATING_AGE INTEGER,
KPP VARCHAR(50),
KPP_DATE DATE,
STAY_REASON VARCHAR(255),
CAR VARCHAR(30),
IS_REGISTRED SMALLINT,
PERSONAL_NUMBER VARCHAR(30),
TITLE VARCHAR(10),
PT_NAME VARCHAR(100),
PT_EXTCODE VARCHAR(50),
PASS_NUM VARCHAR(20),
PASS_PLACE VARCHAR(20),
PASS_DATE DATE,
PASS_EXP_DATE DATE,
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_DATE DATE,
SEX CHAR,
BIRTH_PLACE VARCHAR(30),
MASK VARCHAR(10),
PACKAGE VARCHAR(255),
VISA TDESCRIPTION_SHORT)
 RETURNS(GUEST_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable warn_code integer;

declare variable birth_date_old date;
declare variable title_old varchar(10);
declare variable id_passport_type_old integer;
declare variable pass_num_old varchar(20);
declare variable pass_date_old date;
declare variable personal_number_old varchar(30);
declare variable id_stay_reason_old integer;
declare variable is_registred_old integer;
declare variable pass_place_old varchar(20);
declare variable city_old varchar(100);
declare variable address_old varchar(100);
declare variable birth_place_old varchar(30);
declare variable sex_old char(1);
declare variable mask_old varchar(10);
declare variable car_old varchar(30);
declare variable kpp_id_old integer;
declare variable kpp_date_old date;
declare variable pass_exp_date_old date;
declare variable rating_age_old integer;
declare variable visa_old tdescription_short;

declare variable guest_name_old varchar(100);
declare variable is_child_old integer;
declare variable is_different_arranger_old smallint;
declare variable arrival_old date;
declare variable departure_old date;
declare variable voucher_old varchar(30);
declare variable voucher_date_old date;
declare variable voucher_text_old varchar(30);
declare variable country_code_old varchar(10);

declare variable id_passport_type integer;
declare variable kpp_id integer;
declare variable id_stay_reason integer;
begin
  execute procedure import_mark_transaction$exc;

  guest_name = substring(:guest_name from 1 for 50);

  execute procedure sys_dbg('exc IMPORT_GUEST$EXC(:guest_uuid=>' || coalesce(:guest_uuid, '<null>') || ')');
  guest_id = null;

  select pd.person_name, --g.is_different_organizer,
         g.id_guest, g.from_date, g.to_date,
         pd.birthday_internal, pd.title, pd.id_passport_type,
         pd.pass_num, pd.pass_date, pd.egn, gd.id_stay_reason,
         gd.is_registred, pd.pass_place, pd.city, pd.address, pd.birth_place,
         pd.sex, pd.mask, g.is_child, gd.car, gd.kpp, gd.kpp_date,
         pd.pass_exp_date, gd.rating_age, g.vaucher_num, g.vaucher_date, g.vaucher_text, pd.country_code,
         gd.id_stay_reason, gd.visa
  from   GUEST g
         join guest_data gd on gd.id_guest=g.id_guest
         join person_data pd on pd.id_person_data=gd.id_person_data
  where  g.uuid=:guest_uuid
         and g.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and g.id_reserv_detail=:booking_id
  into   :guest_name_old, --:is_different_arranger_old,
         :guest_id, :arrival_old, :departure_old, :birth_date_old,
         :title_old, :id_passport_type_old,
         :pass_num_old, :pass_date_old, :personal_number_old, :id_stay_reason_old,
         :is_registred_old, :pass_place_old, :city_old, :address_old, :birth_place_old,
         :sex_old, :mask_old, :is_child_old, :car_old, :kpp_id_old, :kpp_date_old,
         :pass_exp_date_old, :rating_age_old, :voucher_old, :voucher_date_old,
         :voucher_text_old, :country_code_old, :id_stay_reason_old, :visa_old;

  execute procedure import_passport_type$exc(:pt_name, pt_extcode)
  returning_values :id_passport_type;

  execute procedure import_kpp$exc(:kpp, null)
  returning_values :kpp_id;

  execute procedure import_stay_reason$exc(:stay_reason, null)
  returning_values :id_stay_reason;

  guest_name = coalesce(:guest_name, :guest_name_old);
--  DISABLE age/is_child merge (RIU rating cases)
--  is_child = coalesce(:is_child, :is_child_old);
--  is_different_arranger = coalesce(:is_different_arranger, :is_different_arranger_old);
  arrival = coalesce(:arrival, :arrival_old);
  departure = coalesce(:departure, :departure_old);
  voucher = coalesce(:voucher, :voucher_old);
  voucher_date = coalesce(:voucher_date, :voucher_date_old);
  voucher_text = coalesce(:voucher_text, :voucher_text_old);
  country_code = coalesce(:country_code, :country_code_old);

--  DISABLE age/is_child merge (RIU rating cases)
--  rating_age = coalesce(:rating_age, :rating_age_old);
  kpp_id = coalesce(:kpp_id, :kpp_id_old);
  kpp_date = coalesce(:kpp_date, :kpp_date_old);
  id_stay_reason = coalesce(:id_stay_reason, :id_stay_reason_old);
  car = coalesce(:car, :car_old);
  is_registred = coalesce(:is_registred, 0);
  if (1 = :is_registred_old) then begin --one way update
    is_registred = 1;
  end
  personal_number = coalesce(:personal_number, :personal_number_old);
  title = coalesce(:title, :title_old);
  id_passport_type = coalesce(:id_passport_type, :id_passport_type_old);
  pass_num = coalesce(:pass_num, :pass_num_old);
  pass_place = coalesce(:pass_place, :pass_place_old);
  pass_date = coalesce(:pass_date, :pass_date_old);
  pass_exp_date = coalesce(:pass_exp_date, :pass_exp_date_old);
  city = coalesce(:city, :city_old);
  address = coalesce(:address, :address_old);
  birth_date = coalesce(:birth_date, :birth_date_old);
  sex = coalesce(:sex, :sex_old);
  birth_place = coalesce(:birth_place, :birth_place_old);
  mask = coalesce(:mask, :mask_old);
  visa = coalesce(:visa, :visa_old);

  if (guest_id is null) then begin
    execute procedure RES_GUEST_SAVE$RSV(null, :booking_id, :guest_name, null, null, :is_child, :COUNTRY_CODE)
    returning_values :guest_id;

    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - get_next_auto_guest = :guest_id=>' || coalesce(:guest_id, '<null>'));
    if (:guest_id is null) then begin 
      execute procedure sys_dbg('exc IMPORT_GUEST$EXC - exhausted auto guests list - create new guest');
      execute procedure RES_GUEST_ADD$RSV(:booking_id, :is_child)
      returning_values :err_code, :err_text, :warn_code, :guest_id;
      if (0 <> :err_code) then exit;
    end

    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - update_new_guest_uuid(:guest_id=>' || coalesce(:guest_id, '<null>') || ', :uuid=>' || coalesce(:guest_uuid, '<null>') || ')');
    update GUEST
    set    uuid = :guest_uuid
    where  id_guest=:guest_id;

    /* preserve default mask */
    if (:mask is null) then begin
      select pd.mask
      from   guest_data gd
             join person_data pd on pd.id_person_data=gd.id_person_data
      where  gd.id_guest=:guest_id
      into   :mask;
    end          
  end else begin
    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - update_guest(:update_guest_id=>' || coalesce(:guest_id, '<null>') || ')');

--    DISABLE age/is_child merge (RIU rating cases) 
--    if (:age is null) then begin
--      select age from GUEST_AGE_CALC(:guest_id)
--      into :age;
--    end
  end

  /*
  execute procedure sys_dbg('exc IMPORT_GUEST$EXC->GUEST_ADDRESSCARD_SET$RSV('
  || 'update_guest_id => ' || coalesce(:update_guest_id, '<null>')
  || ', guest_name => ' || coalesce(:guest_name, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  || ', :id_passport_type => ' || coalesce(:id_passport_type, '<null>')
  || ', :pass_num => ' || coalesce(:pass_num, '<null>')
  || ', :pass_date => ' || coalesce(:pass_date, '<null>')
  || ', :egn => ' || coalesce(:egn_old, '<null>')
  || ', :country => ' || coalesce(:country_old, '<null>')
  || ', :id_stay_reason => ' || coalesce(:id_stay_reason, '<null>')
  || ', :is_registred => ' || coalesce(:is_registred, '<null>')
  || ', :pass_place => ' || coalesce(:pass_place, '<null>')
  || ', :city => ' || coalesce(:city, '<null>')
  || ', :address => ' || coalesce(:address, '<null>')
  || ', :birth_place => ' || coalesce(:birth_place, '<null>')
  || ', :sex => ' || coalesce(:sex, '<null>')
  || ', :mask => ' || coalesce(:mask, '<null>')
  || ', :is_child => ' || coalesce(:is_child, '<null>')
  || ', :car => ' || coalesce(:car, '<null>')
  || ', :kpp => ' || coalesce(:kpp_old, '<null>')
  || ', :kpp_date => ' || coalesce(:kpp_date, '<null>')
  || ', :pass_exp_date => ' || coalesce(:pass_exp_date, '<null>')
  || ', :age => ' || coalesce(:age, '<null>')
  || ', :birth_date => ' || coalesce(:birth_date, '<null>')
  || ', :rating_age => ' || coalesce(:rating_age, '<null>')
  || ', :title => ' || coalesce(:title, '<null>')
  ||')');
  */
  execute procedure GUEST_ADDRESSCARD_SET$RSV(
    :guest_id,
    :guest_name,
    null,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :personal_number,
    :country_code,
    :id_stay_reason,
    :is_registred,
    :pass_place,
    :city,
    :address,
    :birth_place,
    :sex,
    :mask,
    :is_child,
    :car,
    :kpp_id,
    :kpp_date,
    :pass_exp_date,
    :age,
    :birth_date,
    :visa,
    :rating_age,
    :title,
    0
  )
  returning_values :err_code, :err_text, :warn_code;
  if (0 <> :err_code) then exit;

  --execute procedure RES_GUEST_SAVE_ORGANIZER$RSV(:guest_id, :is_different_arranger);

  if ((:arrival is not null) and (:departure is not null)) then begin
    execute procedure RES_GUEST_SAVE_STAY$RSV(:guest_id, :arrival, :departure)
    returning_values :err_code, :err_text, :warn_code;
    if (0 <> :err_code) then exit;
  end

  if (:voucher is not null) then begin
    execute procedure RES_GUEST_SAVE_VOUCHER$RSV(:guest_id, :voucher,
            :voucher_date, :voucher_text, null, null);
  end

  execute procedure IMPORT_GUEST_PACK$EXC(:guest_id, :package);

  update GUEST
  set    ORPHANED_IMPORT$EXC = null
  where  id_guest=:guest_id;
end
^

/* empty dependent procedure body */
/* Clear: CREATE_SESSION_BOOKINGS$WBE for: IMPORT_PERSON_PROFILE$EXC */
ALTER PROCEDURE CREATE_SESSION_BOOKINGS$WBE(WBE_SESSION_ID BIGINT,
ARANGER_ID INTEGER,
LANG_CODE VARCHAR(3))
 RETURNS(SELECTION_ID VARCHAR(20),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: EAI_IMPORT_ALOYALTY_CLIENT for: IMPORT_PERSON_PROFILE$EXC */
ALTER PROCEDURE EAI_IMPORT_ALOYALTY_CLIENT(CLIENT_UUID VARCHAR(40),
CLIENT_NAME VARCHAR(100),
CARD_CODE VARCHAR(50),
IS_ARHIVE SMALLINT,
DATE_OF_BIRTH DATE)
 AS
 BEGIN EXIT; END
^

/* Alter (IMPORT_PERSON_PROFILE$EXC) */
ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
CLEAR_HOTEL_RATE SMALLINT,
CREATE_ONLY SMALLINT,
MERGE_TARGET_UUID VARCHAR(40))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
declare variable op varchar(10);
  declare variable market_segment_id integer;
  declare variable sex_old char(1);
  declare variable birth_date_old date;
  declare variable birth_place_old varchar(30);
  declare variable personal_number_old varchar(30);
  declare variable pass_num_old varchar(20);
  declare variable pass_date_old date;
  declare variable pass_place_old varchar(20);
  declare variable pass_exp_date_old date;
  declare variable pass_city_old varchar(100);
  declare variable pass_address_old varchar(100);
  declare variable country_old varchar(10);
  declare variable mask_old varchar(10);
  declare variable title_old varchar(10);
  declare variable id_photo integer;
  declare variable id_def_contragent integer;
  declare variable id_passport_type integer;
  declare variable account_no_old varchar(20);
  declare variable msg_old varchar(255);
  declare variable id_guest_type integer;
  declare variable id_guest_type_old integer;
  declare variable card_code_old varchar(50);
  declare variable is_exclusive_debt_ownership smallint;
  declare variable profile_receiver_id integer;
begin
  profile_id = null;
  import_time = null;

  execute procedure import_mark_transaction$exc;

  /*FIXME - remove this block*/
  if (1 = :create_only) then begin
    clear_hotel_rate = 0;
  end else begin
    clear_hotel_rate = 1;
  end

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC(:profile_uuid=>' || coalesce(:profile_uuid, '<null>')
                          || ', email=>' || coalesce(:email, '<null>') || ')');

  profile_id = null;
  if (profile_uuid is null) then begin
    execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC <null> :profile_uuid - exit;');
    exit;
  end

  select p.profile_id, p.profile_name, p.phone, p.fax, p.email, p.city,
         p.address, p.market_segment, p.note, p.is_archive, pp.card_code,
         pd.sex, pd.birthday_internal, pd.birth_place, pd.egn, pd.pass_num,
         pd.pass_date, pd.pass_place, pd.pass_exp_date, pd.city, pd.address, pd.country_code,
         pd.mask, p.id_def_contragent, p.wbe_password,
         pd.title, p.account_no, p.msg, pp.id_guest_type, pp.id_photo, pd.id_passport_type,
         p.is_exclusive_debt_ownership
  from   import_common_profile$exc(:profile_uuid, 0, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :wbe_password, :ACCOUNT_NO, :MSG, 'PERSON_PROFILE', :CLEAR_HOTEL_RATE) p
         left outer join profile_person pp on pp.id_profile = p.profile_id
         left outer join person_data pd on pd.id_person_data=pp.id_person_data
  into   :profile_id, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :card_code_old,
         :sex_old, :birth_date_old, :birth_place_old, :personal_number_old, :pass_num_old,
         :pass_date_old, :pass_place_old, :pass_exp_date_old, :pass_city_old, :pass_address_old, :country_old,
         :mask_old, :id_def_contragent, :wbe_password, :title_old,
         :account_no_old, :msg_old, :id_guest_type_old, :id_photo, :id_passport_type, :is_exclusive_debt_ownership;

  if (:profile_id is null) then begin
    op = 'add';
  end else if (1 = :create_only) then begin
    profile_id = null;
    exit;
  end else begin
    op = 'mod';
    delete from PROFILE_HOTEL_RATE phr
      where phr.ID_PROFILE = :profile_id;
    delete from PROFILE_BONUSPOINT_SCHEME bs
      where bs.ID_PROFILE = :profile_id;
  end

  sex=coalesce(:sex, :sex_old);
  birth_date=coalesce(:birth_date, :birth_date_old);
  birth_place=coalesce(:birth_place, :birth_place_old);
  personal_number=coalesce(:personal_number, :personal_number_old);
  pass_num=coalesce(:pass_num, :pass_num_old);
  pass_date=coalesce(:pass_date, :pass_date_old);
  pass_place=coalesce(:pass_place, :pass_place_old);
  pass_exp_date=coalesce(:pass_exp_date, :pass_exp_date_old);
  pass_city=coalesce(:pass_city, :pass_city_old);
  pass_address=coalesce(:pass_address, :pass_address_old);
  country=upper(coalesce(:country, :country_old));
  mask=coalesce(:mask, :mask_old);
  title=coalesce(:title, :title_old);
  account_no=coalesce(:account_no, :account_no_old);
  msg=coalesce(:msg, :msg_old);
  card_code=coalesce(:card_code, :card_code_old);

  execute procedure IMPORT_PASSPORT_TYPE$EXC(:pass_type_name, :pass_type_external_code)
  returning_values :id_passport_type;

  execute procedure lookup_market_segment$exc(:profile_name, 'PERSON_PROFILE', :market_segment)
  returning_values :market_segment_id;

  if (guest_type_name is not null) then begin
    execute procedure lookup_guest_type$exc(:profile_name, 'PERSON_PROFILE', :guest_type_name)
    returning_values :id_guest_type;
  end

  if ((def_contragent_name is not null) and (def_contragent_name <> '')) then begin
    execute procedure LOOKUP_CONTRAGENT$EXC(:profile_name, 'PERSON_PROFILE', :def_contragent_name)
    returning_values :id_def_contragent;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:profile_name, 'PERSON_PROFILE');

  id_guest_type=coalesce(:id_guest_type, :id_guest_type_old);

  if (id_photo is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, null, null, null, 'del')
    returning_values :id_photo;
  end
  id_photo = null;
  if (picture is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, :picture, :picture_type, :picture_layout, 'add')
    returning_values :id_photo;
  end

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC - profile_person_modify$profile(:profile_uuid=>'
    || coalesce(:profile_uuid, '<null>')
    || ', :operation=>' || coalesce(:op, '<null>')
    || ', :email=>' || coalesce(:email, '<null>')
    || ', :birth_date=>' || coalesce(:birth_date, '<null>')
  || ')');
  execute procedure profile_person_modify$profile(
    :profile_id,
    :id_guest_type,
    :profile_name,
    null,
    :sex,
    :birth_date,
    :birth_place,
    :personal_number,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :pass_place,
    :pass_exp_date,
    :country,
    :pass_city,
    :pass_address,
    :mask,
    :phone,
    :fax,
    :email,
    :city,
    :address,
    :note,
    :msg,
    :id_def_contragent,
    :market_segment_id,
    :is_archive,
    :id_photo,
    :card_code,
    :wbe_password,
    :op,
    :account_no,
    :title,
    :is_exclusive_debt_ownership
  ) returning_values
    :profile_id;

  /*assign uuid to the new profiles*/
  if ('add' = :op) then begin
    update profile set uuid=:profile_uuid where id_profile=:profile_id;
  end

  select record_timestamp from profile where id_profile=:profile_id
  into :import_time;

  if (:MERGE_TARGET_UUID is not null) then begin
    select p.ID_PROFILE
    from   PROFILE P
    where  P.UUID = :MERGE_TARGET_UUID
    into   :profile_receiver_id;

    execute procedure PROFILE_MERGE$PROFILE (:PROFILE_ID, :profile_receiver_id, 'merge');

  end

end
^

/* Alter (PHONECALL_POST$TC) */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Alter (PHONECALLS_POST_TO_ACCOUNT$TC) */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* Alter (PMS_POOL_DISTRIBUTION) */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION(ID_RENTAL_POOL INTEGER,
FOR_DATE DATE)
 AS
declare variable total_value_per_service numeric(15,4);
  declare variable id_service integer;
  declare variable curr varchar(3);
  declare variable id_room_param integer;
  declare variable is_room_pool smallint;
  declare variable is_owner_income smallint;

  declare variable is_acc_post_item smallint;
  declare variable new_id_owner_bill integer;
  declare variable id_account_post_pms integer;
  declare variable id_pool_account integer;

  declare variable id_account_pms integer;
  declare variable value_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable value_post numeric(15,4);
  declare variable curr_post varchar(3);
  declare variable id_room integer;
  declare variable date_post date;
  declare variable id_reserv_detail integer;
  declare variable doc_description varchar(255);
  declare variable id_doc_head integer;
  declare variable description varchar(255);
  declare variable is_client_account_post smallint;
  declare variable id_event_lst varchar(5000);
begin
  is_room_pool = null;
  select U.IS_ROOM_POOL, U.ID_ROOM_PARAM
  from   OWNER$PMS O
         join RENTAL_POOL_UNIT$PMS U on U.ID_RENTAL_POOL_UNIT = O.ID_RENTAL_POOL_UNIT
  where  O.ID_OWNER = :ID_RENTAL_POOL
  into   :is_room_pool, :id_room_param;
  if (:is_room_pool is null) then exception PMS_EXCEPTION;

  select cast(list(distinct AP.ID_PMS_EVENT) as varchar(5000))
  from   ACCOUNT_POST$PMS AP
         join ACCOUNT$PMS AC on AC.ID_ACCOUNT = AP.ID_ACCOUNT_PMS
  where  AP.DATE_POST <= :FOR_DATE
         and AP.LINE_STATUS = 11
         and AC.ID_OWNER = :ID_RENTAL_POOL
         and AC.IS_SHADOW = 0
  into   :id_event_lst;

  for
    select sum(AP1.VALUE_POST), AP1.ID_SERVICE, AP1.CURR_POST, AP1.IS_OWNER_INCOME,
           ACC.IS_CLIENT_POOL_ACCOUNT, ACC.ID_ACCOUNT
    from   ACCOUNT_POST$PMS AP1
           join ACCOUNT$PMS ACC on ACC.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS
           join SYSTEM_STRING_PARSER(:id_event_lst, ',') S on S.ITEM = AP1.ID_PMS_EVENT
    where  AP1.LINE_STATUS = 11
           and ACC.IS_SHADOW = 0
    group by 2,3,4,5,6
    into   :total_value_per_service, :id_service, :curr, :is_owner_income,
           :is_acc_post_item, :id_pool_account
  do begin
    execute procedure PMS_POOL_DISTRIBUTION_SUB(:ID_RENTAL_POOL, :id_pool_account,
            :IS_ROOM_POOL, :ID_ROOM_PARAM, :total_value_per_service,
            :ID_SERVICE, :CURR, :IS_OWNER_INCOME, :FOR_DATE, :is_acc_post_item);
  end

  NEW_ID_OWNER_BILL = gen_id(GEN_OWNER_BILL$PMS_ID, 1);

  insert into OWNER_BILL$PMS (ID_OWNER_BILL, ID_OWNER, BILL_DATE, IS_ANUL, BILL_NUM,
         IS_EXPORTED_TO_INTRANET, IS_POOL_DISTRIBUTION_STATEMENT)
  values (:NEW_ID_OWNER_BILL, :ID_RENTAL_POOL, :FOR_DATE, 0, :NEW_ID_OWNER_BILL, 0, 1);

  update OWNER$PMS O
  set    O.LAST_BILLING_DATE = :for_date,
         O.ID_OWNER_BILL = :NEW_ID_OWNER_BILL
  where  O.ID_OWNER = :ID_RENTAL_POOL;

  for
    select AP.ID_ACCOUNT_POST, AP.VALUE_ORIG, AP.CURR_ORIG, AP.VALUE_POST, AP.CURR_POST,
           ACC.ID_ACCOUNT, AP.IS_OWNER_INCOME, AP.ID_SERVICE, E.ID_ROOM, AP.DATE_POST,
           E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION, ACC.IS_CLIENT_POOL_ACCOUNT
    from   PMS_EVENT$PMS E
           join ACCOUNT_POST$PMS AP on ap.ID_PMS_EVENT = e.ID_PMS_EVENT
                                       and AP.LINE_STATUS = 11
           join ACCOUNT$PMS ACC on ACC.ID_ACCOUNT = AP.ID_ACCOUNT_PMS
                                   and ACC.ID_OWNER = :ID_RENTAL_POOL
                                   and ACC.IS_SHADOW = 0
    where  ((E.ID_SESSION = current_transaction) or (','||:id_event_lst||',' containing  ','||E.ID_PMS_EVENT||','))
    into   :id_account_post_pms, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
           :ID_ACCOUNT_PMS, :IS_OWNER_INCOME, :ID_SERVICE, :ID_ROOM, :DATE_POST,
           :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION, :is_client_account_post
  do begin
    insert into OWNER_BILL_ROW$PMS (ID_OWNER_BILL, ID_ACCOUNT_POST, ID_ACCOUNT,
           ID_ACCOUNT_POST_PMS, ID_ACCOUNT_PMS, ID_SERVICE, VALUE_ORIG,
           CURR_ORIG, VALUE_POST, CURR_POST, IS_OWNER_INCOME, ID_ROOM, DATE_POST,
           ID_RESERV_DETAIL, DOC_DESCRIPTION, ID_DOC_HEAD, DESCRIPTION, IS_CLIENT_ACCOUNT_POST)
    values (:new_id_owner_bill, null, null,
           :ID_ACCOUNT_POST_PMS, :ID_ACCOUNT_PMS, :ID_SERVICE, :VALUE_ORIG,
           :CURR_ORIG, :VALUE_POST, :CURR_POST, :IS_OWNER_INCOME, :ID_ROOM, :DATE_POST,
           :ID_RESERV_DETAIL, :DOC_DESCRIPTION, :ID_DOC_HEAD, :DESCRIPTION, :is_client_account_post);

    update ACCOUNT_POST$PMS A
    set    A.LINE_STATUS = 21
    where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS;
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POST_MODIFY$PMS for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: CONTRACT_EXPENSE_POST$INT for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_HOTEL INTEGER,
ID_CONTRACT /* TYPE OF ID */ INTEGER,
SUB_CONTRACT /* TYPE OF TSUB_CONTRACT */ VARCHAR(10),
ID_OWNER /* TYPE OF ID */ INTEGER,
OWNERSHIP_PERCENT /* TYPE OF TPERCENT */ NUMERIC(15,4),
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
POST_DATE /* TYPE OF TDATE */ DATE,
STAY /* TYPE OF TCOUNT */ INTEGER,
MAX_GUEST_CNT /* TYPE OF TCOUNT */ INTEGER,
BED_NIGHT_CNT /* TYPE OF TCOUNT */ INTEGER,
RESERVS /* TYPE OF TCOUNT */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PMS_EXPENSE_POSTS_CREATE$INT for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_EXPENSE_POSTS_CREATE$INT(ID_ROOM /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
POST_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
IS_CLIENT_ACC_POST /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_POST_DATE /* TYPE OF TDATE */ DATE,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IS_POST_PER_POOL /* TYPE OF TLOGICAL */ SMALLINT)
 RETURNS(NEW_ID_ACCOUNT_POST /* ID_REF */ INTEGER,
NEW_ID_ACCOUNT_POST$PMS /* ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PMS_POOL_DISTRIBUTION_SUB for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_POSTING_CREATE$INT) */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_OWNER TYPE OF ID,
POST_DATE TYPE OF TDATE,
CURR_ORIG TYPE OF TCURRENCY,
VALUE_ORIG TYPE OF TPRICE,
POST_ON_PMS_ACCOUNT TYPE OF TLOGICAL,
IS_OWNER_INCOME TYPE OF TLOGICAL,
ID_ROOM TYPE OF ID_REF = null)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  if (:POST_ON_PMS_ACCOUNT = 1) then begin
    execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account, :id_owner,
            :CURR_ORIG, :VALUE_ORIG, :id_service, :is_owner_income, :POST_DATE)
    returning_values  (:new_id_account_post);
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :ID_SERVICE, 1, 0, 1,
            :VALUE_ORIG, :CURR_ORIG, current_date, current_date,
            '', '', :POST_DATE, 'PMS', :ID_ROOM)
    returning_values  :err_code, :err_text, :new_id_account_post;
    if (:err_code <> 0) then exception PMS_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

    insert into PMS_EVENT_POST (ID_PMS_EVENT, ID_ACCOUNT_POST, ID_OWNER, LINE_STATUS)
    values (:ID_PMS_EVENT, :NEW_ID_ACCOUNT_POST, :ID_OWNER, 11);
  end
end
^

/* Alter (POST_SERVICE_FINALIZE$POST) */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
  declare variable id_acc_post integer;
  declare variable id_service integer;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable date_post date;
  declare variable price_post numeric(15,4);
  declare variable qty_post numeric(15,2);
  declare variable post_text varchar(100);
  declare variable curr_post varchar(3);
  declare variable id_phonecall integer;
  declare variable p_dbkey char(8);
begin

  if (:OPERATION = 'clear') then begin
    delete from TMP_SERVICE_POST T
    where  T.ID_SEQUENCE = :ID_SEQUENCE;

  end else if (:OPERATION = 'store') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);

    for
      select TS.RDB$DB_KEY, TS.ID_SERVICE, TS.ID_ACCOUNT, TS.ID_GUEST, TS.DATE_POST,
             TS.PRICE_POST, TS.QTY_POST, TS.CURR_POST, TS.POST_TEXT, TS.ID_PHONECALL
      from   TMP_SERVICE_POST TS
      where  TS.ID_SEQUENCE = :ID_SEQUENCE
      into   :p_dbkey, :id_service, :id_account, :id_guest, :date_post,
             :price_post, :qty_post, :curr_post, :post_text, :id_phonecall
    do begin
      id_acc_post = null;
      if (:id_guest is not null) then begin
        execute procedure POST_SERVICE_ON_GUEST$INT (:id_guest, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :CURR_POST,
                :date_post, :date_post, :post_text, '', :date_post, '', '')
        returning_values  (:err_code, :err_text, :no_use, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end else begin
        execute procedure POST_SERVICE_ON_ACCOUNT$INT (:id_account, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :curr_post, :date_post, :date_post, :post_text,
                '', :date_post, '')
        returning_values  (:err_code, :err_text, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end

      update TMP_SERVICE_POST
      set ID_ACCOUNT_POST = :id_acc_post
      where RDB$DB_KEY = :p_dbkey;

      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :DOC_SELECTED,
             AP.SHORT_CODE = case
                               when :id_phonecall is not null then 'TELECOUNT'
                               else null
                             end
      where  AP.ID_ACCOUNT_POST = :id_acc_post;

      if (:id_phonecall is not null) then begin
        update PHONECALLS P
        set    P.ID_ACCOUNT_POST = :id_acc_post
        where  P.ID_PHONECALL = :id_phonecall;
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: APPLY_BOOKING_STATUS$EXC for: RES_CHECK_OUT_GUESTS$RSV */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: EAI_RES_CHECK_OUT_FAST for: RES_CHECK_OUT_GUESTS$RSV */
ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_CHECK_OUT_GUESTS$RSV) */
ALTER PROCEDURE RES_CHECK_OUT_GUESTS$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND SMALLINT = 0)
 AS
declare variable action_code varchar(100);
  declare variable cleaning_restriction varchar(10);
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable id_reserv_detail integer;
  declare variable id_guest integer;
  declare variable id_room integer;
  declare variable rd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable checkout_status integer;
  declare variable sys_date date;
  declare variable id_hotel integer;
begin
  checkout_status = 1;
  action_code = case when :check_out_kind = 0 then 'CHECK_OUT'
                     when :check_out_kind = 1 then 'CHECK_OUT_EARLY1'
                     when :check_out_kind = 2 then 'CHECK_OUT_EARLY2'
                     when :check_out_kind = 3 then 'CHECK_OUT_EARLY3'
                end;

  for
    select RD.ID_RESERV_DETAIL, RD.ID_ROOM, RD.RDB$DB_KEY, rd.ID_HOTEL,
           (select sd.SYSTEM_DATE
            from   SYSTEM_DATE_GET (rd.ID_HOTEL) sd)
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :id_reserv_detail, :id_room, :rd_dbkey, :id_hotel, :sys_date
  do begin

    for
      select G.ID_GUEST, G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.CHECK_STATUS = 0 /* checked in */
      into   :id_guest, :g_dbkey
    do begin
      if (:CHECK_OUT_KIND = 3) then begin
        -- DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
        update GUEST G
        set    G.EARLYCHECKOUT_DATE = :sys_date
        where  g.RDB$DB_KEY = :g_dbkey;

        execute procedure GUEST_SET_MANUAL_STAY$INT(:rd_dbkey, :id_guest, :sys_date)
        returning_values  :err_code, :err_text;
        if (:err_code < 0) then exception RESERV_CHECK_OUT_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
      end

      update ACCOUNT_POST AP
      set    AP.IS_ARCHIVE = 1
      where  AP.ID_GUEST = :id_guest;
    
      execute procedure GUEST_SET_STATUS$INT (:g_dbkey, :checkout_status);

      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, :action_code, '');
    end

    if (:CHECK_OUT_KIND = 3) then begin
      -- DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
      execute procedure OCCUPANCY_RESERV$INT(:rd_dbkey);
    end

    execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

    execute procedure SETTING_GET_VALUE('CLEANING_RESTRICTION', :id_hotel)
    returning_values  :cleaning_restriction;
  
    if (:cleaning_restriction <> '0' and :id_room > 0) then begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'CHECK_OUT', 'set_dirty');
    end

    execute procedure RES_SAVE_STATUS$INT (:rd_dbkey, :checkout_status);

    execute procedure RES_BONUSPOINTS_APPLY$CL (:id_reserv_detail);
  end

end
^

/* Alter (RES_CHECKIN_MULTI$RSV) */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable checkin_count integer;
  declare variable split_on_checkin integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
  declare variable tmp_warn_code integer;
begin
  checkin_count = 0;
  warn_code = null;
  for
    select RD.ID_RESERV_DETAIL, RD.CHECK_STATUS, RD.SPLIT_ON_CHECKIN, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :SELECTION_ID
    into   :id_reserv_detail, :check_status, :split_on_checkin, :id_titular
  do begin
    if (:check_status >= 0) then begin
      checkin_count = :checkin_count + 1;
    end else begin
      if (:split_on_checkin = 1) then begin
        for
          select G.ID_GUEST
          from   GUEST G
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and G.ID_GUEST <> :id_titular
          into   :id_guest
        do begin
          execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
          returning_values  :id_splited_reservation;

          execute procedure RES_CHECKIN$RSV (:id_splited_reservation)
          returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

          update RESERV_DETAIL RD
          set    RD.SELECTION_ID = :selection_id
          where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
        end
      end

      execute procedure RES_CHECKIN$RSV (:id_reserv_detail)
      returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
      WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end

  if (:checkin_count > 0) then begin
    execute procedure SYSTEM_WARNING_ADD(-1011, f_character(29)||:checkin_count)
    returning_values  :warn_code;
  end
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_BOOKING$EXC for: RES_CREATE_SET$EXC */
ALTER PROCEDURE IMPORT_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(250),
MAINTANCE_SHEMA VARCHAR(30),
POSTING_ROUTING VARCHAR(20),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
COMPLIMENTARY_ACCOUNT VARCHAR(50),
EATING_OBJECT VARCHAR(50),
CREATE_DATETIME TIMESTAMP)
 RETURNS(HOTEL_ID INTEGER,
BOOKING_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_CREATE_SET$EXC) */
ALTER PROCEDURE RES_CREATE_SET$EXC(ID_RESERV_DETAIL INTEGER,
RES_NUMBER VARCHAR(62),
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER,
CREATE_DATETIME TIMESTAMP)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_RESERV_DETAIL INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  WARN_CODE = 0;
  SHARE_TRANSACTION_ID = 0;
  SHARE_ERR_CODE = 0;

  execute procedure sys_dbg('exc RES_CREATE_SET$EXC => RES_CREATE_SET$INT('
  || 'code_first_food=>' || coalesce(:code_first_food, '<null>')
  || ', id_person_payment=>' || coalesce(:id_person_payment, '<null>')
  || ')');

  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, null, :arrival_date, :departure_date,
                    :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, '', :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders, :guarantee_deposit,
                    :guarantee_currency, 0, :id_reserv_detail, :res_number, null,  :id_guarantee_policy, :block_cc,
                    :id_eating_object)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :warn_code;

  execute procedure UPDATE_POSTING_TRANSACTION$EXC(:rd_dbkey, :posting_transaction_uuid, 1);

  execute procedure RES_SAVE_GUARANTEE$RSV(:id_reserv_detail, :is_vip, null,
    :id_guarantee_policy, :guarantee_deposit, :guarantee_currency, :block_cc, :guarantee_deposit_percent,
    :guarantee_deposit_nights, :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create
  );

  execute procedure RESERV_DETAIL_EXTERNAL_MOD$RSV(:id_reserv_detail,
    :minibar_rights, :paytv_rights, :video_rights, :nopost_pms, :phone_rights,
    :seminar_cahnnel_rights, null
  );

  if (:create_datetime is not null) then begin
    update reserv_detail set create_datetime = :create_datetime where rdb$db_key = :rd_dbkey;
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_CHANGE$RSV for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTING$INT for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_GUESTCOUNT$RSV for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_ACCOUNTS$INT) */
ALTER PROCEDURE RES_SAVE_ACCOUNTS$INT(RD_DBKEY CHAR(8))
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_base_account integer;
  declare variable old_id_extra_account integer;
  declare variable new_id_base_account integer;
  declare variable new_id_extra_account integer;
  declare variable acc_routing varchar(30);
  declare variable is_sep_accounts integer;
  declare variable id_base_account_profile integer;
  declare variable id_extra_account_profile integer;
  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable id_agent_account_rule integer;
  declare variable id_acc_template_person integer;
  declare variable id_guest integer;
  declare variable id_hotel integer;
begin

  select RD.ID_RESERV_DETAIL, RD.ID_PERSON_PROFILE, RD.ID_ACC_TEMPLATE_PERSON,
         RD.ACC_ROUTING, RD.ID_BASE_ACCOUNT, RD.ID_EXTRA_ACCOUNT,
         RD.ID_AGENT_PROFILE, RD.ID_AGENT_ACCOUNT_RULE, rd.id_hotel
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :RD_DBKEY
  into   :id_reserv_detail, :id_person_profile, :id_acc_template_person,
         :acc_routing, :old_id_base_account, :old_id_extra_account,
         :id_agent_profile, :id_agent_account_rule, :id_hotel;

  id_agent_account_rule = nullif(:id_agent_account_rule, -1);
  /* --- new */
  execute procedure SETTING_GET_VALUE ('SEPARATE_ACCOUNTS_PER_PAYER', :id_hotel)
  returning_values (:IS_SEP_ACCOUNTS);

  NEW_ID_BASE_ACCOUNT = null; --:old_id_base_account;
  NEW_ID_EXTRA_ACCOUNT = null; --:old_id_extra_account;

  /* identify profiles for base and extra account */
  if (:ACC_ROUTING in ('MIXED')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else if (:ACC_ROUTING in ('AGENT')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
  end else if (:ACC_ROUTING in ('FULL_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = null;
    IS_SEP_ACCOUNTS = 0;  -- never
  end else if (:ACC_ROUTING in ('PART_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else begin -- if (:acc_routing in ('GUEST', 'OWNER'))
    ID_BASE_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_AGENT_ACCOUNT_RULE = null;
  end

  execute procedure RES_ACCOUNTS_RECIEVE$INT (:ID_RESERV_DETAIL, :old_id_base_account, :old_id_extra_account,
          :id_agent_account_rule, :id_base_account_profile, :id_extra_account_profile, :id_person_profile,
          :id_acc_template_person, :is_sep_accounts)
  returning_values (:new_id_base_account, :new_id_extra_account);

--  if (:new_id_base_account is null) then exception WRONG_VALUE 'Invalid base account!';
--  if (:new_id_extra_account is null) then exception WRONG_VALUE 'Invalid extra account!';
  if ((:old_id_base_account is distinct from :new_id_base_account)
       or (:old_id_extra_account is distinct from :new_id_extra_account)) then
  begin
    update RESERV_DETAIL RD
    set    RD.ID_BASE_ACCOUNT = :new_id_base_account,
           RD.ID_EXTRA_ACCOUNT = :new_id_extra_account
    where  RD.RDB$DB_KEY = :RD_DBKEY;
    /* end --- */
    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
             --and G.CHECK_STATUS < 1
      into   :id_guest
    do begin
      execute procedure GUEST_REROUTE_POSTINGS$INT(:id_guest, :new_id_base_account, :new_id_extra_account);
    end

    -- Log account changes
    execute procedure RES_SAVE_ACCOUNTS_FINALIZE$INT(:id_reserv_detail, :old_id_base_account, :old_id_extra_account,
            :new_id_base_account, :new_id_extra_account);
  end

end
^

/* Alter (RES_SAVE_GUESTCOUNT$RSV) */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select rd.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  rd.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SAVE_GUESTCOUNT$INT(:rd_dbkey, :adult_count, :child_count);

  execute procedure RES_SAVE_ACCOUNTS$INT (:rd_dbkey);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 0)
  returning_values  :warn_code;

end
^

/* empty dependent procedure body */
/* Clear: RES_CHECKIN$RSV for: RES_SAVE_ROOM$INT */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_ROOM_REMOVE$INT for: RES_SAVE_ROOM$INT */
ALTER PROCEDURE RES_ROOM_REMOVE$INT(RD_DBKEY CHAR(8))
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ROOM$RSV for: RES_SAVE_ROOM$INT */
ALTER PROCEDURE RES_SAVE_ROOM$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
ID_RES_ROOM_TYPE INTEGER,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(255),
SPLIT_ON_CHECKIN SMALLINT,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM$INT for: RES_SAVE_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM$INT(RD_DBKEY CHAR(8),
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_COMMON_MODIFY$RSV for: RES_SAVE_ROOM$INT */
ALTER PROCEDURE RESMULTI_COMMON_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
CHECK_STATUS SMALLINT,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
NOTE VARCHAR(255),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(30),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
NOTE_REMINDERS VARCHAR(50),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_ROOM$INT) */
ALTER PROCEDURE RES_SAVE_ROOM$INT(RD_DBKEY TYPE OF TDB_KEY,
ID_ROOM TYPE OF ID,
ID_RES_ROOM_TYPE TYPE OF ID,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE TYPE OF TLOGICAL = null)
 RETURNS(WARN_CODE TYPE OF TRANGE)
 AS
declare variable id_reserv_detail integer;
  declare variable id_tar_room_type integer;
  declare variable old_id_room_type integer;
  declare variable old_id_room integer;
  declare variable departure_date date;
  declare variable id_guest integer;
  declare variable g_dbkey char(8);
  declare variable system_date date;
  declare variable system_date_for_room date;
  declare variable check_status integer;
  declare variable cleaning_restriction varchar(50);
  declare variable guest_status varchar(50) default '';
  declare variable id_hotel integer;
  declare variable has_different_room_type integer;
  declare variable acc_routing varchar(30);
  declare variable res_number varchar(62);
begin
  select RD.ID_ROOM_TYPE, RD.CHECK_STATUS, RD.ID_ROOM, RD.TO_DATE, RD.ID_RESERV_DETAIL, RD.ID_HOTEL, rd.ACC_ROUTING, rd.NUMBER
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_room_type, :check_status, :old_id_room, :departure_date, :id_reserv_detail, :id_hotel, :acc_routing, :res_number;

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date_for_room;
  /**/
  system_date = null;
  /*  */
  if (:check_status >= 0 and :old_id_room > 0 and coalesce(:id_room, 0) <= 0) then
    exception BOOKING_EXCEPTION '-111';

  if ((:old_id_room > 0) and (:id_room is distinct from :old_id_room)) then begin
    guest_status = 'ROOM_CHANGED';
    if ((:old_id_room > 0) and (:id_room > 0)) then begin
      execute procedure SYSTEM_DATE_GET(:id_hotel)
      returning_values  :system_date;
      execute procedure sys_dbg('res RES_SAVE_ROOM$INT old_id_room = '||coalesce(:old_id_room, 'null'));
      execute procedure sys_dbg('res RES_SAVE_ROOM$INT check_status = '||coalesce(:check_status, 'null'));

      if ((:departure_date <= :system_date) and (:check_status >= 0)) then exception BOOKING_EXCEPTION '-51';
    end
  end

  if (:id_room is null and :old_id_room < 0) then id_room = :old_id_room; -- preserve old fictious ID, because of mapped rooms

  if (coalesce(:id_room, 0) <= 0) then begin
    delete from ROOM_MAP$EXC m
    where  m.id_room = :id_room
           and m.ID_SRC_ROOM < 0;  -- delete wrong mappings (bug 2827)

    select ro.ID_ROOM
    from   RES_OCCUPANCY_ROOM$INT (:id_reserv_detail, :system_date_for_room, :id_room, :ID_RES_ROOM_TYPE) RO
    into   :id_room;
  --end else if  then begin
  --  dummy = 0; -- do nothing
  end else begin
    -- real room is
    id_res_room_type = :old_id_room_type;
    if (:acc_routing <> 'OWNER'
        and :id_room is distinct from :old_id_room
        and exists (select rp.ID_ROOM_PERIOD
                    from   ROOM_PERIOD$PMS rp
                    where  rp.ID_ROOM = :ID_ROOM
                           and rp.FROM_DATE <= :system_date_for_room
                           and rp.TO_DATE >= :system_date_for_room
                           and rp.STATUS = 'PRIVATE')) then
    begin
      execute procedure SYSTEM_WARNING_ADD (-61, f_character(29) || :res_number)
      returning_values  :WARN_CODE;
    end
  end
  id_res_room_type = coalesce(:id_res_room_type, :old_id_room_type);
  -- null is permissible for id_res_room_type, treat of "keep the same"

  /* tar_option : nrttAsIs, nrttRoom, nrttReserv */
  id_tar_room_type = null;
  has_different_room_type = null;
  if (:tar_option = 'nrttAsIs') then begin
    id_tar_room_type = null;
    has_different_room_type = null;
  end else if (:tar_option = 'nrttRoom') then begin
    --id_tar_room_type = iif(coalesce(:id_room, 0) <= 0 and :room_id_room_type <> :ID_RES_ROOM_TYPE, :room_id_room_type, -1);
    id_tar_room_type = iif (:ID_ROOM > 0, -1, null); -- if not room - like a AsIs
    has_different_room_type = iif(:id_tar_room_type = -1, 0, null);
    -- preserve tar_room_type from mapped(unexisted) room
  end else begin /* nrttReserv */
    id_tar_room_type = :id_res_room_type;
    has_different_room_type = 1;
  end

  update RESERV_DETAIL RD
  set    RD.ID_ROOM = :id_room,
         rd.ROOM_PRICE = case
                           when rd.CHECK_STATUS >= 0 then null
                           -- 'checked in' bookings - force recalculation always
                           when rd.CHECK_STATUS < 0
                                and ((rd.ID_ROOM_TYPE <> :id_res_room_type) or (:id_room is distinct from :old_id_room)) then null
                           -- not 'checked in', but room/room type changed - force too
                           else rd.ROOM_PRICE
                         end,   -- <null> room_price will be force booking recalculation !!!
         RD.ID_ROOM_TYPE = :id_res_room_type,  -- this field update must be after room_price update
         rd.HAS_DIFFERENT_ROOM_TYPE = coalesce(:has_different_room_type, rd.HAS_DIFFERENT_ROOM_TYPE) --iif(coalesce(:id_tar_room_type, 0) > 0, 1, rd.HAS_DIFFERENT_ROOM_TYPE)
  where  RD.RDB$DB_KEY = :rd_dbkey;

  for
    select G.RDB$DB_KEY, G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :g_dbkey, :id_guest
  do begin
    update GUEST GU
    set    GU.OLD_ID_ROOM = GU.ID_ROOM,
           GU.ID_ROOM = :id_room
    where  GU.RDB$DB_KEY = :g_dbkey;

    execute procedure GUEST_SET_EDIT_STATUS$INT (:g_dbkey, :guest_status, 'add');
   
    /*Old code if (:system_date is null) update room_type and type stay*/
    update GUEST_STAY GS
    set    GS.ID_ROOM_TYPE = iif(:id_tar_room_type is null, GS.ID_ROOM_TYPE, :id_tar_room_type),
           GS.ID_TYPE_STAY = iif(:is_auto_staytype = 1, -1, GS.ID_TYPE_STAY)
    where  GS.ID_GUEST = :id_guest
           and ((:system_date is null) or (GS.FOR_DATE >= :system_date));

    /*New part - Room number never be updated in past - important for shares and calulations*/
    /* will be updated in pass only if there was no room assigned*/
    update GUEST_STAY GS
    set    GS.ID_ROOM = :id_room
    where  GS.ID_GUEST = :id_guest
           and ((GS.FOR_DATE >= :system_date_for_room)
                 or (:check_status < 0) -- new - always change id_room from begining, for non checked in reservs
               ) ;
  end

  if ((:check_status = 0) and (:guest_status = 'ROOM_CHANGED') and (:old_id_room > 0)) then begin
    /* IF THE CLEANING RESTRICTION IS ACTIVATED AND THE OLD
    || GUEST'S ROOM IS VACANT THEN IT MUST BE MARKED DIRTY.
    */
    execute procedure SETTING_GET_VALUE('CLEANING_RESTRICTION', :id_hotel)
    returning_values  :cleaning_restriction;
    if ((:cleaning_restriction <> '0') and (not exists (
      select *
      from   GUEST G
             join GUEST_STAY GS on GS.ID_GUEST = G.ID_GUEST
      where  GS.FOR_DATE >= :system_date
             and G.CHECK_STATUS = 0
             and GS.ID_ROOM = :old_id_room
             and G.ID_RESERV_DETAIL <> :id_reserv_detail
    ))) then begin
      execute procedure ROOM_HOUSEKEEPING(:old_id_room, 'GST_MOVED', 'set_dirty');
    end
  end

  execute procedure RES_SAVE_ROOM_LOG$INT(:RD_DBKEY, :old_id_room, :old_id_room_type);

end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ROOM$EXC for: RES_SAVE_ROOM$RSV */
ALTER PROCEDURE RES_SAVE_ROOM$EXC(RD_DBKEY CHAR(8),
ID_RES_ROOM_TYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(250),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_ROOM$RSV) */
ALTER PROCEDURE RES_SAVE_ROOM$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
ID_RES_ROOM_TYPE INTEGER,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(255),
SPLIT_ON_CHECKIN SMALLINT,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
declare variable tmp_warn_code integer;
begin
  WARN_CODE = null;
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, :id_res_room_type, :TAR_OPTION, :is_auto_staytype)
  returning_values (:WARN_CODE);

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 1)
    returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :tmp_warn_code;
  end
  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

  update RESERV_DETAIL R
  set    r.SPLIT_ON_CHECKIN = :split_on_checkin,
         r.ID_HK_PLAN = :ID_HK_PLAN,
         r.I_SPECIAL_TREATMENT = :I_SPECIAL_TREATMENT,
         r.ROOM_FEATURES = :ROOM_FEATURES
  where  r.ID_RESERV_DETAIL = :id_reserv_detail;
end
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_CO_RENTERS$INT for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_CO_RENTERS$INT(VIRTUAL_ID_ROOM INTEGER,
NEW_ID_ROOM INTEGER,
INIT_ID_RES_DETAIL INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_FAST$RSV for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_FAST$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_MULTI$RSV for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_MULTI$RSV(OPERATION VARCHAR(20),
FROM_ROOM VARCHAR(20),
SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_SHARED$RSV for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_SHARED$RSV(SELECTION_ID INTEGER,
ROOM_NAME VARCHAR(10))
 RETURNS(VIRTUAL_ROOM VARCHAR(10),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SET_ROOM$INT) */
ALTER PROCEDURE RES_SET_ROOM$INT(RD_DBKEY CHAR(8),
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
declare variable tmp_warn_code integer;
begin
  WARN_CODE = null;
  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option)
  returning_values (:WARN_CODE);

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :SHARE_ERR_TEXT, :share_transaction_id, :tmp_warn_code;

  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
end
^

/* Alter (RES_SET_ROOM_CO_RENTERS$INT) */
ALTER PROCEDURE RES_SET_ROOM_CO_RENTERS$INT(VIRTUAL_ID_ROOM INTEGER,
NEW_ID_ROOM INTEGER,
INIT_ID_RES_DETAIL INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
declare variable shared_rd_dbkey char(8);
declare variable shared_booking_ids varchar(255);
declare variable id_reserv_detail integer;
declare variable tmp_share_err_code integer;
declare variable tmp_share_err_text varchar(255);
begin
  -- distribute the same room to shared bookings

  if (coalesce(:NEW_ID_ROOM, 0) < 0) then exit; -- only for real rooms!1
  SHARE_ERR_CODE = 0;
  shared_booking_ids = ',' || :INIT_ID_RES_DETAIL || ',';
  for
    select vrd.RDB$DB_KEY, vrd.ID_RESERV_DETAIL
    from   RESERV_DETAIL VRD
    where  vrd.ID_ROOM = :VIRTUAL_ID_ROOM
           and vrd.IS_ANUL = 0
           and vrd.ID_RESERV_DETAIL is distinct from :INIT_ID_RES_DETAIL
           -- and vrd.SELECTION_ID = :SELECTION_ID ?????
    into   :shared_rd_dbkey, :id_reserv_detail
  do begin
    shared_booking_ids = :shared_booking_ids || :id_reserv_detail || ',';

    execute procedure RES_SET_ROOM$INT (:shared_rd_dbkey, :NEW_ID_ROOM, :TAR_OPTION)
    returning_values  :WARN_CODE, :share_transaction_id, :tmp_share_err_code, :tmp_share_err_text;

    if (:SHARE_ERR_CODE = 0 and :tmp_share_err_code < 0) then begin
      -- check for share with other bookings
      if (exists (select rs.ID_RESERV_DETAIL
                      from   ROOMS_SHARE rs
                      where  rs.MARK_TRANSACTION = :SHARE_TRANSACTION_ID
                             and :shared_booking_ids not containing ','||rs.ID_RESERV_DETAIL||','
                             and rs.IS_EX_SHARE = 0)) then
      begin
        SHARE_ERR_CODE = :tmp_share_err_code;
        SHARE_ERR_TEXT = :tmp_share_err_text;
      end
    end
  end 
end
^

/* Alter (RES_SET_ROOM_FAST$RSV) */
ALTER PROCEDURE RES_SET_ROOM_FAST$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable old_id_room integer;
  declare variable virtual_room varchar(10);
  declare variable rd_dbkey char(8);
  declare variable tmp_warn_code integer;
  declare variable tmp_share_err_code integer;
  declare variable tmp_share_err_text varchar(255);
begin

  select RD.ID_ROOM, rd.VIRTUAL_ROOM, rd.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_id_room, :virtual_room, :rd_dbkey;

  execute procedure RES_SET_ROOM$INT (:rd_dbkey, :ID_ROOM, :TAR_OPTION)
  returning_values (:warn_code, :share_transaction_id, :share_err_code, :ERR_TEXT);

  if (:virtual_room is not null and :old_id_room < 0) then begin
    execute procedure RES_SET_ROOM_CO_RENTERS$INT (:old_id_room, :ID_ROOM, :ID_RESERV_DETAIL, :TAR_OPTION)
    returning_values (:tmp_warn_code, :share_transaction_id, :tmp_share_err_code, :tmp_share_err_text);
    WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
    SHARE_ERR_CODE = coalesce(:SHARE_ERR_CODE, :tmp_share_err_code);
    ERR_TEXT = coalesce(:ERR_TEXT, :tmp_share_err_text);
  end
end
^

/* Alter (RES_SET_ROOM_MULTI$RSV) */
ALTER PROCEDURE RES_SET_ROOM_MULTI$RSV(OPERATION VARCHAR(20),
FROM_ROOM VARCHAR(20),
SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable cnt_requested integer;
  declare variable cnt_old_room integer;
  declare variable cnt_found integer;
  declare variable is_already_planned integer;
  declare variable is_satisfied integer;
  declare variable new_id_room integer;
  declare variable current_id_room integer;
  declare variable id_res_room_type integer;
  declare variable room_requirements blob sub_type 1 segment size 100;
  declare variable from_date date;
  declare variable to_date date;
  declare variable action_text varchar(255);
  declare variable is_early_arrival smallint;
  declare variable is_late_departure smallint;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable id_reserv_detail integer;
  declare variable tmp_warn_code integer;
  declare variable min_beds integer;
  declare variable virtual_room varchar(10);
  declare variable share_err_text varchar(255);
begin
  /* offer_method :
  ||     0 - NUMBER desc,
  ||     1 - NUMBER asc,
  ||     2 - DAYS FREE(MAX OCCUPANCY),
  ||     3 - FILING FACTOR(EQUAL ROOM USAGE)
  */
  warn_code = null;

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'set_number_asc, set_number_desc, set_max_occupancy, set_max_usage');

  cnt_requested = 0;
  cnt_old_room = 0;
  cnt_found = 0;
  for
    select RD.RDB$DB_KEY, rd.ID_RESERV_DETAIL, rd.ID_ROOM, rd.VIRTUAL_ROOM, RD.ID_ROOM_TYPE, RD.ROOM_FEATURES,
           RD.FROM_DATE, RD.TO_DATE, iif(rd.COMMING_KIND = 0, 1, 0), iif(rd.LEAVING_KIND = 2, 1, 0),
           rd.ADULT_COUNT + rd.CHILD_COUNT
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
           and RD.IS_ANUL = 0
    into   :rd_dbkey, :id_reserv_detail, :current_id_room, :virtual_room, :id_res_room_type, :room_requirements,
           :from_date, :to_date, :is_early_arrival, :is_late_departure, :min_beds
  do begin
    cnt_requested = :cnt_requested + 1;
    new_id_room = null;
    if (:current_id_room < 0) then begin
      if (:virtual_room is not null) then begin
        -- has related bookings with shared virtual room
        -- get cumulative stay for all shared bookings
        select min(vrd.FROM_DATE), min(vrd.FROM_DATE) - min(vrd.FROM_DATE - iif(vrd.COMMING_KIND = 0, 1, 0)),
               max(vrd.TO_DATE), max(vrd.TO_DATE + iif(vrd.LEAVING_KIND = 2, 1, 0)) - max(vrd.TO_DATE),
               sum(vrd.ADULT_COUNT + vrd.CHILD_COUNT)
        from   RESERV_DETAIL VRD
        where  vrd.ID_ROOM = :current_id_room
               and vrd.IS_ANUL = 0
        into   :from_date, :is_early_arrival, :to_date, :is_late_departure, :min_beds;
      end
      -- from_date and to_date are arrival and departure date of reservation,
      -- not first and last accomodation dates !!! this is need to check early arrivals and late departures
      execute procedure ROOM_PICKUP$INT(:id_res_room_type, :from_date, :to_date,
              :is_early_arrival, :is_late_departure,:operation, :from_room, :room_requirements, :min_beds)
      returning_values  :new_id_room;  -- offered room

      if (:new_id_room is not null) then begin
        is_satisfied = 1;
        select R.ROOM_NAME
        from   ROOMS R
        where  r.ID_ROOM = :new_id_room
        into   :action_text;

        execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'ROOM_SET_AUTO', :action_text);

        execute procedure RES_SET_ROOM$INT (:rd_dbkey, :new_id_room, 'nrttAsIs')
        returning_values (:tmp_warn_code, :share_transaction_id, :share_err_code, :share_err_text);
        if (:share_err_code < 0) then exception BOOKING_EXCEPTION 'Unallowable share!!!';
        WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

        if (:virtual_room is not null) then begin
          -- distribute the same room to shared bookings
          execute procedure RES_SET_ROOM_CO_RENTERS$INT (:current_id_room, :new_id_room, :id_reserv_detail, 'nrttAsIs')
          returning_values (:tmp_warn_code, :share_transaction_id, :share_err_code, :share_err_text);
          if (:share_err_code < 0) then exception BOOKING_EXCEPTION 'Unallowable share!!!';
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
        end
      end

    end else begin
      is_already_planned = 1;
    end

    cnt_old_room = :cnt_old_room + :is_already_planned;
    cnt_found = :cnt_found + :is_satisfied;

    when exception BOOKING_EXCEPTION do begin
      -- nothing, skip this booking
    end
  end

  if ((:cnt_found + :cnt_old_room) < :cnt_requested) then begin
    execute procedure SYSTEM_WARNING_ADD(-3, f_character(29)||:cnt_found||f_character(28)||:cnt_requested)
    returning_values  :warn_code;
  end
end
^

/* Alter (RES_SET_ROOM_SHARED$RSV) */
ALTER PROCEDURE RES_SET_ROOM_SHARED$RSV(SELECTION_ID INTEGER,
ROOM_NAME VARCHAR(10))
 RETURNS(VIRTUAL_ROOM VARCHAR(10),
WARN_CODE INTEGER)
 AS
declare variable r_dbkey char(8);
  declare variable is_anul integer;
  declare variable shared_id_room integer;
  declare variable current_id_room integer;
  declare variable tmp_warn_code integer;
  declare variable share_trans integer;
  declare variable share_err_code integer;
  declare variable id_hotel integer;
  declare variable cnt_hotels integer;
  declare variable id_room integer;
  declare variable res_counter integer;
  declare variable min_departure date;
  declare variable max_arrival date;
  declare variable share_err_text varchar(255);
begin
  VIRTUAL_ROOM = null;
  select min(r.ID_HOTEL), count(distinct r.ID_HOTEL),
         min(r.TO_DATE), max(r.FROM_DATE)
  from   RESERV_DETAIL R
  where  R.SELECTION_ID = :SELECTION_ID
  into   :id_hotel, :cnt_hotels, :min_departure, :max_arrival;

  if (:cnt_hotels > 1) then exception BOOKING_EXCEPTION '-1035';
  if (:min_departure <= :max_arrival) then exception BOOKING_EXCEPTION '-1037';

  if (:ROOM_NAME is not null) then begin
    execute procedure ROOM_GET_BY_NAME(:ROOM_NAME, :id_hotel)
    returning_values (:id_room);
    shared_id_room = :ID_ROOM;
  end else begin
    id_room = null;
    shared_id_room = gen_id(DETAIL_WITHOUT_ROOMING_LIST, -1);
    VIRTUAL_ROOM = gen_id(GEN_VIRTUAL_ROOM, 1);
  end

  res_counter = 0;
  for
    select r.RDB$DB_KEY, r.IS_ANUL, r.ID_ROOM
    from   RESERV_DETAIL R
    where  R.SELECTION_ID = :SELECTION_ID
    into   :r_dbkey, :is_anul, :current_id_room
  do begin
    res_counter = :res_counter + 1;
    if (:is_anul = 1) then
      exception BOOKING_EXCEPTION '-1036';

    if (:current_id_room > 0 and :ID_ROOM is null) then
      exception BOOKING_EXCEPTION '-1034';

    execute procedure RES_SET_ROOM$INT(:r_dbkey, :shared_id_room, 'nrttAsIs')
    returning_values  :tmp_warn_code, :share_trans, :share_err_code, :share_err_text;
    WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
  end

  if (:VIRTUAL_ROOM is not null and :share_trans is not null) then begin
    update RESERV_DETAIL RD
    set    rd.VIRTUAL_ROOM = '<'||:VIRTUAL_ROOM||'>'
    where  rd.ID_ROOM = :shared_id_room;
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_RECALC$INT for: RES_TAR_CALC_FINALIZE$INT */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_TAR_CALC_FINALIZE$INT) */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(TAR_CALC_ERR INTEGER,
ID_TAR_CALC INTEGER,
RD_DBKEY_INIT CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
begin
  /*  Description:
  ||  Razpiswa cenata na staia, kakto i price_detailite.
      Za4istwa temp tablicite
  */
  --savedbg('TAR_CALC_ERR: ' || :TAR_CALC_ERR);
  --savedbg('ID_TAR_CALC: ' || :ID_TAR_CALC);
  if (:tar_calc_err = 0) then begin
    room_price = 0;
    room_price_details = '';

    execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

    for
      select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, rd.IS_POSTING_STOPPED,
             coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
             coalesce(max((select first 1 AP.IS_BASE
                           from   GUEST G
                                  join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                           where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                  and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (eventually)
      from   TAR_CALC_INPUT$TMP TI
             join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
             join TARIFA t on t.ID_TARIFA = rd.ID_RATE
      where  ti.ID_TAR_CALC = :ID_TAR_CALC
      group by 1, 2, 3, 4, 5, 6
      into   :id_reserv_detail, :check_status, :is_posting_stopped,
             :room_currency, :id_hotel, :is_anul, :has_postings
    do begin
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);

      if ( (not (:is_posting_stopped = 1 and :has_postings = 0))                                -- posting is not stopped
           and                                                                                  -- and
           ( (coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1) ) -- there are reasons to repost
         ) then
      begin

        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);

      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;

        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end

      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end else begin

    update RESERV_DETAIL RD
    set    RD.ROOM_PRICE = null,
           RD.ROOM_CURRENCY = null,
           RD.ROOM_PRICE_DETAILS = null,
           RD.LAST_ID_TAR_CALC = null
    where  RD.RDB$DB_KEY = :RD_DBKEY_INIT;
  end
  
  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;
end
^

/* Alter (RESMULTI_COMMON_MODIFY$RSV) */
ALTER PROCEDURE RESMULTI_COMMON_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
CHECK_STATUS SMALLINT,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
NOTE VARCHAR(255),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(30),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
NOTE_REMINDERS VARCHAR(50),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(WARN_CODE TYPE OF TRANGE)
 AS
declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable old_id_room_type integer;
  declare variable old_status integer;
begin
  select RD.RDB$DB_KEY, RD.ID_ROOM, RD.ID_ROOM_TYPE, rd.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_id_room, :old_id_room_type, :old_status;

  execute procedure RES_SAVE_GUESTCOUNT$INT(:rd_dbkey, :adult_count, :children_count);

  execute procedure RES_SAVE_NOTE$RSV(:id_reserv_detail, :note, null);

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, :id_room_type, 'nrttAsIs')
  returning_values (:WARN_CODE);

  execute procedure RES_SAVE_ROOM_LOG$INT(:rd_dbkey, :old_id_room, :old_id_room_type);

  execute procedure RES_SAVE_ACCOUNTING$INT(:rd_dbkey, :id_agent_profile, :id_agent_account, :acc_routing,
                    :id_person_payment, :id_agent_payment, :id_group);

  update RESERV_DETAIL RD
  set    RD.CUSTOM_PRICE = :CUSTOM_PRICE,
         RD.CUSTOM_CURRENCY = :CUSTOM_CURRENCY,
         RD.SPLIT_ON_CHECKIN = :SPLIT_ON_CHECKIN,
         RD.NOTE_REMINDERS = :NOTE_REMINDERS,
         rd.ID_HK_PLAN = :ID_HK_PLAN
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_status <> :CHECK_STATUS) then begin
    if (:CHECK_STATUS >= 0) then exception BOOKING_EXCEPTION 'Can not set status ''CHECKED IN'' or ''CHECKED OUT'' manually!';
  
    execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, :check_status);
  end
  --
end
^

/* empty dependent procedure body */
/* Clear: SAFE_CHECK_OUT for: SAFE_OCCUPANCY_MODIFY */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE /* TYPE OF ID */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER,
WARN_CODE /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SAFE_OCCUPANCY_MODIFY) */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE TYPE OF ID,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable old_booking_number tres_number;
  declare variable id_resource_reservation id_ref;
  declare variable from_datetime tdatetime;
  declare variable action_text tdescription_long;
  declare variable old_occupant varchar(100);
  declare variable old_to_dt timestamp;
  declare variable id_reserv_detail integer;
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation;

  select rr.BOOKING_NUMBER, od.FROM_DATETIME,
         RR.OCCUPANT_NAME, od.TO_DATETIME, rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESERV_DETAIL rd on rd.NUMBER = rr.BOOKING_NUMBER and rd.IS_ANUL = 0
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :old_booking_number, :from_datetime,
         :old_occupant, :old_to_dt, :id_reserv_detail, :id_agent_profile;

  --if (:old_booking_number <> :BOOKING_NUMBER) then exception ASSERT 'Can not change booking number!';
  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  update SAFE_RESOURCE_RESERV rr
  set    rr.PRICE_DESCRIPTION = :price_description,
         rr.ID_RATE_PRICE_PROFILE = :id_agent_profile,
         rr.RATING_UNITS = :rating_units,
         rr.RATE_PRICE = :price,
         rr.RATE_CURR = :currency
  where  rr.ID_RESOURCE_RESERV = :id_resource_reservation;

  execute procedure RESOURCE_RESERVATION_MODIFY (:id_resource_reservation, :ID_SAFE, :from_datetime,
          :TO_DATETIME, :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :old_booking_number, 'mod')
  returning_values :id_resource_reservation, :no_use;

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail)
  returning_values (:DOC_SELECTED);

  /* Log changes */
  if ((:old_occupant <> :OCCUPANT_NAME) or (:old_to_dt <> :TO_DATETIME)) then begin
    action_text = f_character(29) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                  || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                  || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');
  
    execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_CHANGED', :action_text);
  end
end
^

/* Alter (SAFE_OCCUPANCY_NEW) */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE TYPE OF ID,
FROM_DATETIME TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME,
BOOKING_NUMBER TYPE OF TRES_NUMBER,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
ID_RESOURCE_RESERVATION TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable action_text tdescription_long;
  declare variable id_reserv_detail integer;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, s.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  if (:id_resource_reservation is not null) then exception ASSERT '-1064'|| f_character(31) || f_character(29) || :safe_name;

  select rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESERV_DETAIL rd
  where  rd.NUMBER = :BOOKING_NUMBER
         and rd.IS_ANUL = 0
  into   :id_reserv_detail, :id_agent_profile;

  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  execute procedure  RESOURCE_RESERVATION_MODIFY (null, :ID_SAFE, :FROM_DATETIME, :TO_DATETIME,
          :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :BOOKING_NUMBER, 'add')
  returning_values (:id_resource_reservation, :no_use) ;

  insert into SAFE_RESOURCE_RESERV (ID_RESOURCE_RESERV, PRICE_DESCRIPTION, ID_RATE_PRICE_PROFILE,
         RATING_UNITS, RATE_PRICE, RATE_CURR)
  values (:id_resource_reservation, :price_description, :id_agent_profile,
         :rating_units, :price, :currency);

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail, :ID_EXTERNAL_CLIENT_ACCCOUNT)
  returning_values (:DOC_SELECTED);

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = 'CHECKED_IN'
  where  RR.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = :id_resource_reservation
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                || f_character(28) || coalesce(:BOOKING_NUMBER, '')
                || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUPIED', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_INPUT_PARAMS$INT for: TAR_CALC_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_PARAMS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_PARAMS$INT) */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
declare variable param_code varchar(40);
  declare variable id_param integer;
  declare variable param_value varchar(255);
  declare variable data_type  varchar(30);
  declare variable rate_list varchar(2000);
begin
  err_code = 0;
  param_values = '';

  if (coalesce(:rate_list_replace, '') = '') then rate_list = ',' || :id_rate || ',';
  else rate_list = :rate_list_replace;

  for
    select distinct TBP.PARAM_NAME
    from   SYSTEM_STRING_PARSER (:rate_list, ',') sp
           left join TAR_BO_PARAMS TBP on TBP.ID_TAR_HEAD = sp.ITEM
    where  (TBP.PARAM_TYPE <> 'DATE_DEPENDANT' and :for_date is null)
           or (TBP.PARAM_TYPE = 'DATE_DEPENDANT' and :for_date is not null)
    into   :param_code
  do begin
    if (:param_code is not null) then begin
      id_param = null;
      select TP.ID_TARIFA_PARAM, TP.DATA_TYPE
      from   TARIFA_PARAMS TP
      where  TP.PARAM_CODE = :param_code
             and tp.IS_USE = 1
      into   :id_param, :data_type;
  
      if (:id_param is null) then begin
        err_code = -202;
        execute procedure sys_dbg ('tar calc params err_code: ' || :err_code || F_CRLF() || 'PARAM_CODE = ' || :param_code);
        exit;
      end
  
      execute procedure TARIFA_GET_PARAM (:id_param, :for_date, :id_tar_input, :id_tar_calc)
      returning_values (:param_value);
  
      param_code = ':'||param_code;
  
      if ((:param_code is not null) and (:param_code is not null) and (:data_type is not null)) then
         param_values = :param_values||';'||:param_code||','||:data_type||','||:param_value;
    end
  end
end
^

/* Alter (TEST_DOC) */
ALTER PROCEDURE TEST_DOC(ID_ACCOUNT INTEGER,
DOC_SELECTED INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER)
 AS
declare variable is_dep_doc integer;
  declare variable id_hotel integer;
  declare variable dummy varchar(255);
begin
  is_dep_doc = 0;

  execute procedure DOCUMENT_INITIALIZE$DOC (:id_account, :doc_selected, null)
  returning_values (:id_doc_head, :id_hotel, :dummy);

  execute procedure DOCUMENT_ADD_DEF_PAYMENT$DOC (:id_doc_head, null);

  execute procedure DOCUMENT_VALIDATE$DOC (:id_doc_head)
  returning_values :dummy, :dummy, :dummy;
  suspend;
end
^

/* Alter (TEST_RATING) */
ALTER PROCEDURE TEST_RATING RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
declare variable from_date date;
 declare variable to_date date;
 declare variable hotels varchar(255);
begin
  from_date = '01.01.2010';
  to_date = '08.01.2010';
  hotels = '2';

  execute procedure AVAILABILITY_OCCUPANCY$INT (:from_date,  :from_date + 30, 1, 0, 1, 1, 0, 0, 0, :hotels);

  execute procedure AVAILABILITY_OCCUPANCY_OPT$INT (0, 0, 1, 1, 0, 0, 0);

  execute procedure AVAILABILITY_RATING$AVL (null, :from_date, :to_date, 2,
          2, 0, '33,31,55,30,32,54,62,59,71,72', '2301,2210,2347,1633,2300,2342,2353,2362', '6,0,8,7,22,21,23', :hotels)
  returning_values (:ID_OCCUPANCY_SESSION);

end
^

/* Restore proc. body: ACCOUNT_POST_MODIFY$PMS */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
declare variable id_account integer;
  declare variable id_service integer;
  declare variable date_post date;
  declare variable is_owner_income smallint;
  declare variable is_account_post_item smallint;
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable no_use_id_acc_post integer;
  declare variable ap_dbkey char(8);
begin
  -- da se wika samo ot GUI
  if ( (:ID_ACCOUNT_POST is null) and (:ID_ACCOUNT_POST_PMS is null) ) then begin
    exception WRONG_PARAM_VALUE;
    exit;
  end

  is_account_post_item = iif(:id_account_post is not null, 1, 0);

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'mod, anul');

  if (:operation in ('mod', 'anul')) then begin
    -- prowerka: ot GUI-to mogat da se anulirat samo nedokumentirani i neanulirani nachisleniq
    if (:is_account_post_item = 1) then begin
      if ( (:ID_PMS_EVENT > 0) and
           not exists ( select *
                        from   PMS_EVENT_POST PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      select ap.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  ap.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
      into   :ap_dbkey;

      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_dbkey, 'PMS GUI VOID');

      update PMS_EVENT_POST PP
      set    PP.LINE_STATUS = 22
      where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST;

    end else if (:ID_ACCOUNT_POST_PMS is not null) then begin
      if ( not exists ( select *
                        from   ACCOUNT_POST$PMS PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      execute procedure ACCOUNT_POST_PMS_ANUL$INT(:ID_PMS_EVENT, :ID_ACCOUNT_POST_PMS);
    end

    if (:operation = 'mod') then begin
      id_account = null;
      if (:is_account_post_item = 1) then begin
        select AP.ID_ACCOUNT, AP.ID_SERVICE, AP.DATE_POST, PP.ID_OWNER, 0, ap.id_room
        from   ACCOUNT_POST AP
               join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and PP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :id_owner, :is_owner_income, :id_room;
      end else begin
        select AP.ID_ACCOUNT_PMS, AP.ID_SERVICE, AP.DATE_POST, AP.IS_OWNER_INCOME, AP.ID_OWNER
        from   ACCOUNT_POST$PMS AP
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
               and AP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :is_owner_income, :id_owner;
      end
      if (:id_account is null) then exit;

      execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_account, :id_service, :id_owner, :date_post,
              :in_curr_orig, :in_value_orig, 1 - :is_account_post_item, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* Restore proc. body: ACCOUNT_POSTING_TRANSFER$ACC */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
declare variable ap_dbkey char(8);
  declare variable transfer_value double precision;
  declare variable post_value double precision;
  declare variable id_account integer;
  declare variable tmp_id_account integer;
  declare variable curr_post varchar(3);
  declare variable acc_name varchar(50);
  declare variable action_text varchar(255);
  declare variable is_pms_account integer;
  declare variable dest_acc_name varchar(50);
begin

  id_account = null;
  transfer_value = 0;

  select ACC.ACCOUNT_NAME, acc.IS_PMS_ACCOUNT
  from   ACCOUNT ACC
  where  ACC.ID_ACCOUNT = :ID_DEST_ACCOUNT
  into   :dest_acc_name, is_pms_account;

  if (:is_pms_account = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('PMS_TRANSFER_POSTINGS');
  end

  for
    select AP.RDB$DB_KEY, AP.ID_ACCOUNT, ap.PRICE_POST * ap.QTY_POST
    from   ACCOUNT_POST AP
    where  AP.DOC_SELECTED = :DOC_SELECTED
           and AP.ID_ACCOUNT = coalesce(:ID_SRC_ACCOUNT, AP.ID_ACCOUNT)
           and AP.ID_ACCOUNT is distinct from :ID_DEST_ACCOUNT
    order by AP.ID_ACCOUNT asc
    into   :ap_dbkey, :tmp_id_account, :post_value
  do begin
    execute procedure ACCOUNT_POSTING_TRANSFER$INT (:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:id_account is null) then id_account = :tmp_id_account;

    /* update from/to pms account */
    execute procedure ACCOUNT_POST_EVENT_REROUTE$INT(:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:tmp_id_account is distinct from :id_account) then begin
      select A.ACCOUNT_NAME, A.ACCOUNT_CURR
      from   ACCOUNT A
      where  A.ID_ACCOUNT = :id_account
      into   :acc_name, :curr_post;

      action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                    f_character(28) || :id_account || '/' || :acc_name ||
                    f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
      execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
      id_account = :tmp_id_account;
      transfer_value = 0;
    end
    transfer_value = :transfer_value + :post_value;
  end

  if (:id_account is not null) then begin
    select A.ACCOUNT_NAME, A.ACCOUNT_CURR
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :acc_name, :curr_post;
  
    action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                  f_character(28) || :id_account || '/' || :acc_name ||
                  f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
  end
end
^

/* Restore proc. body: APPLY_BOOKING_STATUS$EXC */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20)
 AS
declare variable err_text varchar(255);
declare variable dummy_int integer;
declare variable anul_reason varchar(30);
declare variable selection_id integer;

declare variable status_code smallint;
declare variable current_anul_code smallint;
declare variable current_status_code smallint;
declare variable current_status_text varchar(50);
declare variable new_status_text varchar(50);
declare variable extra_posts_left integer;
begin
  if (:booking_db_key is null) then begin
    select rd.RDB$DB_KEY, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.ID_RESERV_DETAIL = :BOOKING_ID
    into   :booking_db_key, :current_status_code, :current_anul_code;
  end else begin
    select rd.id_reserv_detail, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.rdb$db_key = :booking_db_key
    into   :booking_id, :current_status_code, :current_anul_code;
  end

  execute procedure IMPORT_BOOKING_STATUS$EXC(:status, -2)
  returning_values :status_code;

  execute procedure EXPORT_BOOKING_STATUS$EXC(:current_status_code, :current_anul_code)
  returning_values :current_status_text;
  execute procedure IMPORT_BOOKING_STATUS$EXC(:current_status_text, :current_status_code)
  returning_values :current_status_code;

  /* nop - exit */
  if (:current_status_code = :status_code) then exit;

  /* validate status transition */
  if (
     /* terminal status values - void booking */
    (:current_status_code in (1004/*no show*/, 1005/*canceled*/))

    /* void over checkin */
    or ((:current_status_code >= 0) and (:status_code in (1004/*no show*/, 1005/*canceled*/)))

    /* positive status downgrade */
    or ((:current_status_code > 0) and (:current_status_code > :status_code))
  )  then begin
    execute procedure PRINT_BOOKING_STATUS$EXC(:current_status_code) returning_values :current_status_text;
    execute procedure PRINT_BOOKING_STATUS$EXC(:status_code) returning_values :new_status_text;

    exception VALIDATE_EXCEPTION '-1022' || f_character(31) || '@{invalid_status_transition} ' || :current_status_text || ' -> ' || :new_status_text;
  end

  anul_reason = null;
  if (1004 = :status_code) then begin
    anul_reason = 'NOSHOW';
  end else if (1005 = :status_code) then begin
    anul_reason = 'CANCELED';
  end

  if (:anul_reason is null) then begin
    if (0 > :status_code) then begin
      execute procedure RES_SAVE_STATUS$INT(:booking_db_key, :status_code, :CONFIRMATION_NUMBER);
    end else begin
      if (:status_code in (0, 1) and 0 > :current_status_code) then begin
        -- checkin
        execute procedure RES_SET_CHECKIN$INT (:booking_db_key)
        returning_values (:dummy_int, :err_text, :dummy_int, :dummy_int);
      end
      if (1 = :status_code and 1 > :current_status_code) then begin
        -- checkout
        selection_id = gen_id(SELECTION_GEN, 1);
        update RESERV_DETAIL
        set    selection_id=:selection_id
        where  rdb$db_key=:booking_db_key;
    
        execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id);
      end
    end
  end else begin
    -- void
    execute procedure RES_ANUL_DETAIL$INT(:booking_db_key, :anul_reason, :CANCELATION_NUMBER)
    returning_values  :dummy_int, :extra_posts_left;
    if (:extra_posts_left = 1) then exception BOOKING_EXCEPTION '-1042';

  end
end
^

/* Restore proc. body: AVAILABILITY_OCCUP_PREPARE$AVL */
ALTER PROCEDURE AVAILABILITY_OCCUP_PREPARE$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS INTEGER,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
begin

  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, :FETCH_TOTALS, 1, 1, 1, 1, 1, 1, :HOTELS);
   
  execute procedure AVAILABILITY_OCCUPANCY_OPT$INT (:RELEASE_DATES, :OVERBOOK,
          :RES_CONFIRMED, :RES_NOTCONFIRMED, :RES_WAITING, :BOOKING_POSITIONS, :CONTINGENT);

end
^

/* Restore proc. body: AVAILABILITY_OCCUPANCY$AVL */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
begin

  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, :FETCH_TOTALS, 1, 1, 1, 1, 1, 1, :HOTELS);

  ID_OCCUPANCY_SESSION = current_transaction;
end
^

/* Restore proc. body: CONTRACT_EXPENSE_POST$INT */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT TYPE OF ID,
ID_HOTEL INTEGER,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
ID_OWNER TYPE OF ID,
OWNERSHIP_PERCENT TYPE OF TPERCENT,
ID_RENTAL_POOL TYPE OF ID_REF,
VALUE_ORIG TYPE OF TPRICE,
CURR_ORIG TYPE OF TCURRENCY,
POST_DATE TYPE OF TDATE,
STAY TYPE OF TCOUNT,
MAX_GUEST_CNT TYPE OF TCOUNT,
BED_NIGHT_CNT TYPE OF TCOUNT,
RESERVS TYPE OF TCOUNT)
 AS
declare variable service_price numeric(15,4);
  declare variable id_currency varchar(3);
  declare variable contract_expense_type varchar(50);
  declare variable id_account integer;
  declare variable post_value numeric(15,4);
  declare variable post_currency varchar(3);
  declare variable id_service integer;
  declare variable is_owner_income smallint;
  declare variable is_client_acc_post smallint;
  declare variable multiplier_type varchar(50);
  declare variable multiplier integer;
  declare variable id_room integer;
  declare variable use_shadow_account integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
begin
  is_owner_income = 0;
  use_shadow_account = iif(:SUB_CONTRACT = 'SHADOW_ACC', 1, 0);

  select r.ID_HOTEL
  from   PMS_EVENT$PMS p
         join ROOMS R on r.ID_ROOM = p.ID_ROOM
  where  p.ID_PMS_EVENT = :ID_PMS_EVENT
  into   :id_hotel;
-- CONTRACT_EXPENSE_TYPE in ( 'PERCENT', 'RUNNING_TOTAL_PERCENT', 'CURR_VALUE' )
-- MULTIPLIER_TYPE in ('RESERVATION', 'STAY', 'GUESTS', 'BED_NIGHTS')
  for
    select C.SERVICE_PRICE, C.ID_CURRENCY, C.CONTRACT_EXPENSE_TYPE, C.IS_ACC_POST_ITEM,
           C.ID_SERVICE, C.MULTIPLIER_TYPE
    from   CONTRACT_EXPENSE$PMS C
    where  C.ID_CONTRACT = :id_contract
           and c.SUB_CONTRACT = :SUB_CONTRACT
    order by C.ORDER_TAG asc
    into   :service_price, :id_currency, :contract_expense_type, :is_client_acc_post,
           :ID_SERVICE, :multiplier_type
  do begin

    execute procedure OWNER_ACCOUNT_GET$INT (coalesce(:ID_RENTAL_POOL,:ID_OWNER),
            :id_hotel, :use_shadow_account, :is_client_acc_post)
    returning_values (:id_account, :is_account$pms);

    multiplier = case
                   when :multiplier_type = 'RESERVATION' then iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'STAY' then :STAY
                   when :multiplier_type = 'GUESTS' then :MAX_GUEST_CNT * iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'BED_NIGHTS' then :BED_NIGHT_CNT
                   else null
                 end;

    if (:multiplier is not null) then begin
      if (:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE') then begin
        post_value = cast(:service_price as double precision) * :ownership_percent / 100 * :multiplier;
        post_currency = :id_currency;
      end else if (:CONTRACT_EXPENSE_TYPE = 'PERCENT') then begin
        post_value = :VALUE_ORIG * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end else if (:CONTRACT_EXPENSE_TYPE = 'RUNNING_TOTAL_PERCENT') then begin
        execute procedure PMS_RUNNING_TOTAL_GET(:ID_PMS_EVENT, coalesce(:ID_RENTAL_POOL,:ID_OWNER), :ID_HOTEL, :POST_DATE, :CURR_ORIG)
        returning_values :post_value;
        if (:post_value < 0) then post_value = 0;
    
        post_value = :post_value * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end

      select pe.ID_ROOM
      from   PMS_EVENT$PMS PE
      where  pe.ID_PMS_EVENT = :ID_PMS_EVENT
      into   :id_room;

      select c.ROUND_TO
      from   CURRS C
      where  c.CURR = :post_currency
      into   :round_to;

      execute procedure PMS_POSTING_CREATE$INT(:ID_PMS_EVENT, :id_account, :id_service, :ID_OWNER,
              :POST_DATE, :post_currency, round_f(:post_value, :round_to), :is_account$pms, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* Restore proc. body: CREATE_BOOKING$WBE */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
declare variable RATE varchar(50);
declare variable ROOM_TYPE varchar(20);
declare variable ARRIVAL date;
declare variable DEPARTURE date;
declare variable ADULTS integer;
declare variable CHILDREN integer;
declare variable PROFILE_NAME varchar(100);
declare variable ARANGER_NAME varchar(100);
declare variable GUEST_PROFILE_UUID varchar(40);
declare variable ARANGER_PROFILE_UUID varchar(40);
declare variable HOTEL_NAME varchar(50);
declare variable WBE_SESSION_ID bigint;
declare variable MAIN_GUEST_PROFILE_ID integer;
declare variable BOARD varchar(50);
declare variable HOTEL_ID integer;
declare variable GUARANTEE_POLICY_NAME varchar(50);
declare variable GUARANTEE_DEPOSIT_PERCENT numeric(15,4);
declare variable GUARANTEE_DEPOSIT_NIGHTS integer;
declare variable GUARANTEE_DUE_DAYS_BEF_ARRIVAL integer;
declare variable GUARANTEE_DUE_DAYS_AFTER_CREATE integer;
declare variable ERR_CODE integer;
declare variable ERR_TEXT varchar(255);
declare variable PROFILE_TYPE varchar(20);
declare variable PROFILE_IMPORT_TIME timestamp;
declare variable B_COUNT integer;
declare variable AGE integer;
declare variable IS_CHILD smallint;
declare variable GUEST_ID integer;
declare variable SPECIAL_TREATMENT varchar(250);
declare variable MAINTENANCE varchar(30);
declare variable ROUTING varchar(20);
declare variable ARRANGER_PAYMENY_TYPE varchar(20);
declare variable MARKET_SEGMENT varchar(30);
declare variable MARKET_SOURCE varchar(30);
declare variable MARKET_CHANNEL varchar(30);
declare variable MARKET_HEAR_REASON varchar(30);
declare variable MARKET_COME_REASON varchar(30);
declare variable FIRST_FOOD varchar(30);
declare variable BNOTE varchar(2000);
begin
  -- get wbe product selection
  select  PA.rate_name,PA.room_name, AQ.first_date, AQ.first_date+AQ.day_count,
          PS.adults, PS.children, PS.person_name, H.hotel_name, H.id_hotel,
          WS.id, PA.board_name, GP.name, GP.deposit_totalsum_part, GP.deposit_nights_count, GP.due_days_before_arrival, GP.due_days_after_create,
          PS.bnote
   from   PRODUCT_SELECTION$WBE PS
          join WBE_SESSION$WBE WS on WS.id = PS.wbe_session_id
          join PRODUCT_AVAILABILITY$WBE PA on pa.id = PS.product_availability_id
          join AVAILABILITY_QUERY$WBE AQ on aq.id = WS.product_query_id
          join HOTEL H on H.id_hotel = WS.hotel_id
          join GUARANTEE_POLICY GP on GP.id_guarantee_policy = PS.guarantee_policy_id
   where  PS.id = :product_selection_id
   into   :rate, :room_type, :arrival, :departure,
          :adults,  :children, :profile_name, :hotel_name, :hotel_id,
          :wbe_session_id, :board, :guarantee_policy_name,
          :guarantee_deposit_percent, :guarantee_deposit_nights,
          :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create,
          :bnote;

  select PA.uuid , PA.profile_name, PA.profile_type
  from   profile PA
  where  PA.id_profile = :aranger_profile_id
  into   :aranger_profile_uuid,:aranger_name,  :profile_type;

  if (:aranger_name = :profile_name and :profile_type = 'PERSON') then begin
    -- aranger is main guest
    select count(*) from PRODUCT_SELECTION$WBE PSC
        where PSC.wbe_session_id = :wbe_session_id
        into :b_count;
       -- only if single reservation bugfix 2228
    if (1 = :b_count) then begin
     guest_profile_uuid =  aranger_profile_uuid;
     aranger_profile_uuid = null;
    end
  end else begin
    -- create profile for main guest
    execute procedure IMPORT_PERSON_PROFILE$EXC(
      uuid_create(),:profile_name,null,null,null,null,null,null,null,null,null,null, null,
      null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
      null,null,null,null,null, 0, 0, null)
    returning_values :main_guest_profile_id, :profile_import_time;

    select P.uuid
    from   profile P
    where  P.id_profile = :main_guest_profile_id
    into   :guest_profile_uuid;
  end

    -- apply default map + forced arranger
    special_treatment = null;
    maintenance = null;
    routing = null;
    arranger_paymeny_type = null;
    market_segment = null;
    market_source = null;
    market_channel = null;
    market_hear_reason = null;
    market_come_reason = null;


  select hc.special_treatment,hk.plan_name,hc.routing,
        pt.payment_type, ms.segment_name,sc.description,cc.description,
        hr.description,cr.description,hc.first_food
  from  hotel_product_cfg$wbe hc
        left join hk_plan hk on hk.id_plan = hc.id_hk_plan
        left join payment_type pt on pt.id_payment_type = hc.arranger_id_payment_type
        left join nom_market_segments ms on ms.id_nom_market_segment = hc.id_m_segment
        left join nom_source_codes sc on sc.id_nom_source_code = hc.id_m_source
        left join nom_channel_codes cc on cc.id_nom_channel_code = hc.id_m_channel
        left join nom_hear_reasons hr on hr.id_nom_hear_reason = hc.id_m_hear_reason
        left join nom_come_reasons cr on cr.id_nom_come_reason = hc.id_m_come_reason
  where hc.hotel_id = :hotel_id
  into  :special_treatment,:maintenance,:routing,:arranger_paymeny_type,
        :market_segment,:market_source,:market_channel,:market_hear_reason,:market_come_reason,:first_food;
  -- create reseravation
  execute procedure IMPORT_BOOKING$EXC(
    :hotel_name, :number, null, null, 0,
    :arrival, null, :departure, null, null, null, null, null, :room_type, :board, null,
     :special_treatment, :maintenance, :routing, :rate, null, null, null, null, :arranger_paymeny_type, null, null, null, null,
     :market_segment, :market_source,:market_channel, :market_hear_reason, :market_come_reason,
     :bnote, null, :first_food, :adults, :children, :aranger_profile_uuid, null, :guest_profile_uuid,
     0, 0, null, :guarantee_policy_name, null, :guarantee_deposit_percent, :guarantee_deposit_nights,
     :guarantee_due_days_bef_arrival,  :guarantee_due_days_after_create, null, null, null, null,  null, null, null, null, null, null)
   returning_values
    :hotel_id ,
    :booking_id,
    :err_code,
    :err_text;

  if (0 <> :err_code) then exception wrong_value ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');

  -- import guests
  for select psg.guest_name,psg.is_child,psg.age from product_selection_guests$wbe psg
  where psg.product_selection_id = :product_selection_id
  into :profile_name,:is_child,:age
  do begin
    execute procedure import_guest$exc(:booking_id, null, null, :profile_name, :is_child, :age, null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null)
    returning_values :guest_id, :err_code,:err_text;
    if (0 <> :err_code) then exception wrong_value ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');
  end
  ----------------

  select RD.number_2
  from   reserv_detail RD
  where  RD.id_reserv_detail = :booking_id
  into   :number_2;

  update product_selection$wbe uPS
  set    uPS.booking_id = :booking_id, uPS.selection_id = :number_2
  where  uPS.id = :product_selection_id;
end
^

/* Restore proc. body: CREATE_SESSION_BOOKINGS$WBE */
ALTER PROCEDURE CREATE_SESSION_BOOKINGS$WBE(WBE_SESSION_ID BIGINT,
ARANGER_ID INTEGER,
LANG_CODE VARCHAR(3))
 RETURNS(SELECTION_ID VARCHAR(20),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable product_selection_id bigint;
declare variable next_num integer;
declare variable sel_cnt integer;
declare variable aranger_name varchar(100);
declare variable aranger_email varchar(50);
declare variable aranger_phone varchar(50);
declare variable booking_id integer;
declare variable record_timestamp timestamp;
declare variable new_res_number varchar(62);
declare variable room_types_src varchar(255) = '';
declare variable rates_src varchar(255) = '';
declare variable hotel_id integer;
declare variable profile_id integer;
declare variable from_date date;
declare variable to_date date;
declare variable day_count integer;
declare variable room_type_id integer;
declare variable rate_id integer;
declare variable query_id_tmp integer;
declare variable rooms_required integer;
declare variable rooms_available integer;
declare variable profile_import_time timestamp;
begin
  execute procedure EXPORT_LOG_FORCE$EXC(1);
  /* test overbook (multiuser) */
   for select ws.hotel_id,ws.profile,aq.first_date,(aq.first_date+aq.day_count)-1,pa.room_type_id,pa.rate_id,aq.day_count
    from   PRODUCT_availability$WBE PA
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    join availability_query$wbe aq on aq.id = pa.query_id
   where ws.id = :wbe_session_id and coalesce(pa.room_count,0) > 0
   into  :hotel_id, :profile_id, :from_date, :to_date, :room_type_id, :rate_id , :day_count
   do begin
       room_types_src = :room_types_src||','||cast(:room_type_id as varchar(10));
       rates_src = :rates_src||','||cast(rate_id as varchar(10));
   end

   query_id_tmp = GEN_ID(AVAILABILITY_QUERY$WBE_SEQ,1);
   insert into availability_query$wbe(ID, WBE_SESSION_ID, FIRST_DATE, DAY_COUNT)    -- prevent FK exception
    values (:query_id_tmp,:wbe_session_id,:from_date,:day_count) ;

   execute procedure availability_occup_small$wbe(:from_date,:to_date,:hotel_id,:query_id_tmp,1,:rates_src,:room_types_src) ;

   --  check minimum available rooms for every day
   err_code = null;
   err_text = '';
   for select pa.room_type_id,pa.room_count,
    (select coalesce(min(art.available_rooms),0) from availability_room_type$wbe art
      where art.query_id = :query_id_tmp and art.room_type_id = pa.room_type_id)
    from product_availability$wbe pa
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    where ws.id = :wbe_session_id
    and coalesce(pa.room_count,0) > 0   into :room_type_id,:rooms_required,:rooms_available
   do begin
       if (rooms_required > rooms_available) then
       begin
        err_code = 1;
        ERR_TEXT = coalesce(ERR_TEXT,'')||:room_type_id||';';
       end
   end
   delete from availability_query$wbe aqt where aqt.id = :query_id_tmp;       -- remove temp query
   if (err_code is not null) then exit;

  /* create profile if not exist and reservations > 1*/
  if (aranger_id is NULL) then
  begin
    select WS.person_name,WS.address,WS.phone
    from   WBE_SESSION$WBE WS
    where  WS.id = :wbe_session_id
    into   :aranger_name,:aranger_email,:aranger_phone;

    execute procedure IMPORT_PERSON_PROFILE$EXC(
       uuid_create(),:aranger_name,null,null,null,null,null,null,null,null,null,null,
       null,null,null,null,:aranger_phone,null,:aranger_email,null,null,null,null,null,null,
       STRHASH_LARGE(substring(uuid_create() from 1 for 4)),null,null,null,null,null,null,null,null,0,0, null)
    returning_values :aranger_id, :profile_import_time;

    update WBE_SESSION$WBE uWS
    set    uWS.profile = :aranger_id
    where  uWS.id = :wbe_session_id;
  end else begin
    -- da podmeni email, phone ako !!
  end
  /* create reservations */
  for
    select PS.id
    from   PRODUCT_SELECTION$WBE PS
    where  PS.wbe_session_id = :wbe_session_id
           and PS.booking_id is null
           and coalesce(PS.is_deleted,0) <> 1
    into   :product_selection_id
  do begin
     if (next_num = 1) then begin      -- increment first reservation number_3
      execute procedure res_number_suffix_gen(:booking_id) returning_values :new_res_number;
      next_num = next_num + 1;
     end
     execute procedure CREATE_BOOKING$WBE(:product_selection_id,:aranger_id,'WBE.'||:selection_id||'.'||:next_num) returning_values :booking_id,:selection_id;
     execute procedure IMPORT_BOOKING_FINALIZE$EXC(:booking_id) returning_values  record_timestamp,:err_code,:err_text;
     insert into SCHEDULER$WBE(booking_id,status,last_action_time,lang_code,guarantee_passed) values (:booking_id, NULL, current_timestamp, :lang_code,0);

     if (next_num is NULL) then begin
      next_num = 1;
     end else begin
      next_num = next_num + 1;
     end
  end
end
^

/* Restore proc. body: DEPOSIT_DOCUMENT_INITIALIZE$DOC */
ALTER PROCEDURE DEPOSIT_DOCUMENT_INITIALIZE$DOC(ID_PAYMENT_HEAD TYPE OF ID,
ID_BILLING_SERVICE TYPE OF ID)
 RETURNS(ID_DOC_HEAD TYPE OF ID,
ID_HOTEL TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
WARN_CODE TYPE OF TRANGE)
 AS
declare variable id_dep_doc integer;
declare variable doc_selected integer;
declare variable payment_date date;
declare variable system_date date;
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_BILLING');

  id_dep_doc = null;

  select p.ID_DOC_HEAD, p.ID_ACCOUNT, p.PAYMENT_DATE, a.ID_HOTEL
  from   PAYMENT_HEAD P
         join DEPOSIT d on d.ID_PAYMENT_HEAD = p.ID_PAYMENT_HEAD
         join ACCOUNT a on a.ID_ACCOUNT = p.ID_ACCOUNT
  where  p.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
         and p.IS_ANUL = 0
  into   :id_dep_doc, :id_account, :payment_date, :id_hotel;

  if (:id_account is null) then
    exception DOCUMENT_EXCEPTION '-355';

  if (:id_dep_doc is not null) then
    exception DOCUMENT_EXCEPTION '-364';

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :system_date;

  if (:payment_date < :system_date) then
    exception DOCUMENT_EXCEPTION '-399';

  doc_selected = gen_id(DOC_SELECTED_GEN, 1);

  update DEPOSIT P
  set    p.DOC_SELECTED = :doc_selected,
         p.ID_BILLING_SERVICE = :ID_BILLING_SERVICE
  where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;

  execute procedure DOCUMENT_INITIALIZE$DOC (:ID_ACCOUNT, :doc_selected)
  returning_values  (:ID_DOC_HEAD, :ID_HOTEL, :WARN_CODE);

end
^

/* Restore proc. body: EAI_EXT_POST_TO_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable ID_HOTEL integer;
begin
  if (singular(select HS.ID_HOTEL
               from HOTEL_S HS
               where HS.IS_USE = 1)) then
    select H.ID_HOTEL
    from   HOTEL_S H
    where H.IS_USE = 1
    into   :id_hotel;
  else begin
    err_code = -1044;
    exit;
  end

  execute procedure EAI_EXT_POST_TO_MH_FRONT_ONLINE(:ID_HOTEL, :ROOM_NAME,
    :SERVICE_CODE, :CODE_TYPE, :QTY_POST, :PRICE_POST, :CURR_POST, :POST_TEXT)
  returning_values (:ERR_CODE, :ERR_TEXT, :ID_ROOM, :ID_GUEST, :GUEST_NAME1,
    :ID_ACCOUNT, :ID_ACCOUNT_POST, :ID_SERVICE);

end
^

/* Restore proc. body: EAI_IMPORT_ALOYALTY_CLIENT */
ALTER PROCEDURE EAI_IMPORT_ALOYALTY_CLIENT(CLIENT_UUID VARCHAR(40),
CLIENT_NAME VARCHAR(100),
CARD_CODE VARCHAR(50),
IS_ARHIVE SMALLINT,
DATE_OF_BIRTH DATE)
 AS
declare variable PROFILE_ID integer;
  declare variable IMPORT_TIME timestamp;
begin
  execute procedure IMPORT_PERSON_PROFILE$EXC(:CLIENT_UUID, :CLIENT_NAME, null, :DATE_OF_BIRTH, null, null,
    null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null,
    :IS_ARHIVE, :CARD_CODE, null, null, null, null, null, null, null, null, null, null, null, null)
  returning_values :PROFILE_ID, :IMPORT_TIME;
end
^

/* Restore proc. body: EAI_POS_POSTING_ADD */
ALTER PROCEDURE EAI_POS_POSTING_ADD(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
begin
  -- used external inteface - for compatability with Front 2008
  execute procedure EAI_POS_POSTING_ADD$P2E (:IN_ON_GUEST, :IN_ID_ACCOUNT, :IN_ID_GUEST, :IN_DATE_SMETKA,
          :IN_PRICE, :IN_DATETIME, :IN_OBJ_NAME, :IN_TABLE, :IN_SITE, :IN_SMETKA_NUM, :IN_POS_USER,
          :IN_ID_SMETKA, :IN_SERVICE_TAG, :IN_SERVICE_NAME)
  returning_values (:ERR_CODE, :ERR_TEXT, :OUT_ID_ACCOUNT);

end
^

/* Restore proc. body: EAI_RES_CHECK_OUT_FAST */
ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
declare variable selection_id integer;
  declare variable is_early_check_out smallint;
  declare variable early_check_out_dep_date date;
  declare variable check_out_date date;
begin
  selection_id = gen_id(selection_gen, 1);

  update RESERV_DETAIL RD
  set RD.SELECTION_ID = :SELECTION_ID
  where RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL;

  execute procedure RES_CHECK_OUT_CHECK$RSV(:selection_id)
  returning_values :is_early_check_out, :early_check_out_dep_date, :check_out_date;

  if (:is_early_check_out = 1) then
    exception BOOKING_EXCEPTION '-1043';

  execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id, 0);
end
^

/* Restore proc. body: IMPORT_BOOKING$EXC */
ALTER PROCEDURE IMPORT_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(250),
MAINTANCE_SHEMA VARCHAR(30),
POSTING_ROUTING VARCHAR(20),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
COMPLIMENTARY_ACCOUNT VARCHAR(50),
EATING_OBJECT VARCHAR(50),
CREATE_DATETIME TIMESTAMP)
 RETURNS(HOTEL_ID INTEGER,
BOOKING_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable current_hotel_id integer;
declare variable booking_update_id integer;
declare variable warn_code integer;
declare variable share_transaction_id integer;
declare variable share_err_code integer;
declare variable arranger_profile_id integer;
declare variable main_guest_profile_id integer;
declare variable rate_id integer;
declare variable room_type_id integer;
declare variable board_id integer;
declare variable maintance_shema_id integer;
declare variable arranger_payment_type_id integer;
declare variable guest_payment_type_id integer;
declare variable marketing_segment_id integer;
declare variable marketing_source_code_id integer;
declare variable marketing_channel_code_id integer;
declare variable marketing_hear_reason_id integer;
declare variable marketing_come_reason_id integer;
declare variable arranger_account_id integer;
declare variable packet_id integer;
declare variable id_guarantee_policy integer;
declare variable first_food_code tfood_code;
declare variable arrival_type_code smallint;
declare variable booking_dbkey char(8);
declare variable reserv_group_id integer;
declare variable id_complimentary_account integer;
declare variable id_eating_object integer;
begin
  /*execute procedure sys_dbg('exc IMPORT_BOOKING$EXC('
  || 'hotel => ' || coalesce(:hotel, '<null>')
  || ', booking_number => ' || coalesce(:number, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  ||')');
  */
  execute procedure import_mark_transaction$exc;

  /* init */
  err_code = 0;
  err_text = '';
  booking_update_id = null;
  booking_dbkey = null;
  current_hotel_id = null;
  if (:voucher_date is not null) then begin
    voucher_date = striptime(:voucher_date);
  end
  posting_routing = upper(:posting_routing);

  /* detect inser/update mode */
  select b.id_reserv_detail, b.rdb$db_key, b.id_hotel
  from   reserv_detail b
  where  b.number=:number
         and b.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and b.id_log_event_annul is null
  into   :booking_update_id, :booking_dbkey, :current_hotel_id;

  if (:booking_update_id is null) then begin
    booking_id = gen_id (id_reserv_detail_gen, 1);
  end else begin
    booking_id = :booking_update_id;
  end

  /* text to id map */
  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => MAP_BOOKING_RELATIONS$EXC');
  execute procedure MAP_BOOKING_RELATIONS$EXC(
    :booking_id,
    :hotel,
    :room_type,
    :board,
    :maintance_shema,
    :rate,
    :arranger_payment_type,
    :guest_payment_type,
    :marketing_segment,
    :marketing_source_code,
    :marketing_channel_code,
    :marketing_hear_reason,
    :marketing_come_reason,
    :first_food,
    :arranger_profile_uuid,
    :arranger_profile_name,
    :main_guest_profile_uuid,
    :arrival_type,
    :guarantee_policy,
    :eating_object
  ) returning_values
    :arranger_profile_id,
    :main_guest_profile_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :hotel_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :first_food_code,
    :arrival_type_code,
    :id_guarantee_policy,
    :id_eating_object;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* hotel change test */
  if (coalesce(:current_hotel_id, :hotel_id) <> :hotel_id) then begin
    execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', null, :hotel, 'booking hotel changed');
  end

  id_complimentary_account = null;
  if (complimentary_account is not null) then begin
    execute procedure lookup_account$exc(:hotel_id, :complimentary_account, 'booking', :booking_id)
    returning_values :id_complimentary_account;
  end

  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => CREATE_PACK_INSTANCE$EXC');
  packet_id = null;
  /*execute procedure CREATE_PACK_INSTANCE$EXC(
    :hotel_id, :booking_id, :package
  )
  returning_values :packet_id, :err_code, :err_text;
  if (0 <> :err_code) then exit;
  */
  /* merge input and default/persistent database values */
  execute procedure DEFAULT_BOOKING_VALUES$EXC(
    :booking_dbkey, :hotel_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :group_name,
    :group_uuid,
    :is_late_departure,
    :id_eating_object
  ) returning_values
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :arranger_account_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :reserv_group_id,
    :is_late_departure,
    :id_eating_object;

  if ('' = :board) then board_id = null; /* preserve "empty board" state and discard default value */

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC DEFAULTED => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* if the booking is complimentary use complimentary account */
  arranger_account_id = coalesce(:id_complimentary_account, :arranger_account_id);

  /* CREATE or UPDATE */
  if (:booking_update_id is not null) then begin
    /* UPDATE booking */
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => UPDATE_BOOKING$EXC');
    execute procedure UPDATE_BOOKING$EXC(
      :booking_id,
      :reserv_group_id,
      :is_vip,
      :arrival,
      :arrival_type_code,
      :departure,
      :is_late_departure,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :room_type_id,
      :board_id,
      :room_preferences,
      :special_treatment,
      :maintance_shema_id,
      :posting_routing,
      :arranger_account_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :deposit_required,
      :deposit_required_currency,
      :arranger_payment_type_id,
      :guest_payment_type_id,
      :voucher,
      :voucher_date,
      :voucher_text,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :note,
      :note_reminders,
      :first_food_code,
      :arranger_profile_id,
      :main_guest_profile_id,
      :is_different_rate,
      :is_different_price,
      :split_on_checkin,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object
    ) returning_values :err_code, :err_text;
    if (0 <> :err_code) then begin
      exit;
    end
  end else begin
    /* CREATE booking */
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => RES_CREATE_SET$EXC');
    execute procedure RES_CREATE_SET$EXC (
      :booking_id,
      :number,
      :arranger_profile_id,
      :main_guest_profile_id,
      :arrival,
      :departure,
      :adult_count,
      :children_count,
      :room_type_id,
      null,
      :board_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :voucher,
      :voucher_date,
      :voucher_text,
      null,
      null,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :arrival_type_code,
      :is_late_departure,
      :is_vip,
      :first_food_code,
      :special_treatment,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :arranger_account_id,
      :posting_routing,
      :guest_payment_type_id,
      :arranger_payment_type_id,
      null,
      :room_preferences,
      :maintance_shema_id,
      :note,
      :note_reminders,
      :deposit_required,
      :deposit_required_currency,
      :hotel_id,
      :reserv_group_id,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object,
      :create_datetime
      )
    returning_values :err_code, :err_text, :warn_code, :booking_id, :share_transaction_id, :share_err_code;
  end

  execute procedure GUEST_STAY_INITIALIZE$INT (:booking_id);
  /* final error check */
  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;

  delete from PENDING_DEPOSIT d
  where  d.ID_RESERV_DETAIL = :BOOKING_ID;
end
^

/* Restore proc. body: PMS_EXPENSE_POSTS_CREATE$INT */
ALTER PROCEDURE PMS_EXPENSE_POSTS_CREATE$INT(ID_ROOM TYPE OF ID,
ID_OWNER TYPE OF ID,
ID_RENTAL_POOL TYPE OF ID_REF,
ID_SERVICE TYPE OF ID,
ID_CURRENCY TYPE OF TCURRENCY,
POST_VALUE TYPE OF TPRICE,
IS_CLIENT_ACC_POST TYPE OF TLOGICAL,
MANUAL_POST_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
IS_POST_PER_POOL TYPE OF TLOGICAL)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF,
NEW_ID_ACCOUNT_POST$PMS ID_REF)
 AS
declare variable event_type varchar(30);
  declare variable id_room_contract integer;
  declare variable new_id_pms_event integer;
  declare variable round_to_orig numeric(15,6);
  declare variable ownership_percent numeric(15,4);
  declare variable curr_contract_owner integer;
  declare variable curr_total_ownership numeric(15,4);
  declare variable curr_total_value numeric(15,4);
  declare variable percent_value numeric(15,4);
  declare variable id_account integer;
  declare variable id_hotel integer;
  declare variable is_account$pms integer;
  declare variable id_acc_post integer;
BEGIN
  event_type = 'MANUAL_EXPENSE';
  curr_total_value = 0;
  curr_total_ownership = 0;

  select RC.ID_ROOM_CONTRACT, r.ID_HOTEL
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS P on RC.ID_ROOM_PERIOD = P.ID_ROOM_PERIOD
         join ROOMS R on R.ID_ROOM = p.ID_ROOM
  where  :MANUAL_POST_DATE between P.FROM_DATE and P.TO_DATE
         and P.ID_ROOM = :ID_ROOM
         and P.STATUS in ('PRIVATE','CONTRACT')
  into   :id_room_contract, :id_hotel;

  if (:ID_ROOM_CONTRACT is null) then exception PMS_EXCEPTION '-615';

  execute procedure PMS_EVENT_CREATE$INT(:EVENT_TYPE, :ID_ROOM, :ID_OWNER, :DESCRIPTION,
          :MANUAL_POST_DATE, null, null, null, null, :POST_VALUE, :POST_VALUE, :ID_CURRENCY, null, :id_room_contract)
  returning_values :new_id_pms_event;

  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :ID_CURRENCY
  into   :round_to_orig;

  for
    select iif(:ID_OWNER is null, O.OWNERSHIP_PERCENT, 100), O.ID_OWNER
    from   ROOM_CONTRACT$PMS RC
           join ROOM_OWNER$PMS O on O.ID_ROOM_CONTRACT = RC.ID_ROOM_CONTRACT
    where  RC.ID_ROOM_CONTRACT = :id_room_contract
           and ((:ID_OWNER is null) or (O.ID_OWNER = :ID_OWNER))
    into   :ownership_percent, :curr_contract_owner
  do begin
    curr_total_ownership = :curr_total_ownership + :ownership_percent;
    if (:curr_total_ownership = 100) then begin
      percent_value = :post_value - :curr_total_value;
    end else
      percent_value = round_f(:post_value * :ownership_percent / 100, :round_to_orig);

    curr_total_value = :curr_total_value + :percent_value;

    execute procedure OWNER_ACCOUNT_GET$INT (iif(:is_post_per_pool = 1, :id_rental_pool, :curr_contract_owner),
            :id_hotel, 0, :IS_CLIENT_ACC_POST)
    returning_values (:id_account, :is_account$pms);

    execute procedure PMS_POSTING_CREATE$INT(:new_id_pms_event, :ID_ACCOUNT, :ID_SERVICE,
            :curr_contract_owner, :MANUAL_POST_DATE, :ID_CURRENCY, :PERCENT_VALUE, :is_account$pms, 0, :ID_ROOM)
    returning_values :id_acc_post;

    new_id_account_post = null;
    new_id_account_post$pms = null;

    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 1)) then new_id_account_post$pms = :id_acc_post;
    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 0)) then new_id_account_post = :id_acc_post;
    suspend;
  end

  execute procedure PMS_EVENT_SET_ACTIVE$INT(:new_id_pms_event);
END
^

/* Restore proc. body: PMS_POOL_DISTRIBUTION_SUB */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
declare variable cnt_room smallint;
  declare variable curr_total_posted numeric(15,4);
  declare variable cnt integer;
  declare variable value_to_post numeric(15,4);
  declare variable value_to_post_per_owner numeric(15,4);
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable id_room_contract integer;
  declare variable id_owner_account integer;
  declare variable id_pms_event integer;
  declare variable id_hotel integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
begin
  select c.ROUND_TO
  from   CURRS c
  where  c.CURR = :CURR
  into   :round_to;

  cnt_room = 0;
  select count(distinct RP.ID_ROOM)
  from   ROOM_PERIOD$PMS RP
         join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
  where  RC.ID_RENTAL_POOL = :id_rental_pool
         and RP.STATUS in ('PRIVATE','CONTRACT')
         and RP.FROM_DATE <= :FOR_DATE
         and RP.TO_DATE >= :FOR_DATE
  into   :cnt_room;

  if (:cnt_room = 0) then exception PMS_EXCEPTION 'The pool has not assigned room contracts for selected date (' || :FOR_DATE || ') !';

  if (:is_room_pool = 1) then begin
    curr_total_posted = 0;
    cnt = 0;
    id_pms_event = null;
    id_hotel = null;
    for
      select distinct RP.ID_ROOM, RC.ID_ROOM_CONTRACT, R.ID_HOTEL
      from   ROOM_PERIOD$PMS RP
             join ROOMS R on R.ID_ROOM = RP.ID_ROOM
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.FROM_DATE <= :FOR_DATE
             and RP.TO_DATE >= :FOR_DATE
      into   :id_room, :id_room_contract, :id_hotel
    do begin
      id_pms_event = null;

      select E.ID_PMS_EVENT
      from   PMS_EVENT$PMS E
      where  E.ID_ROOM = :id_room
             and E.ID_SESSION = current_transaction
      into   :ID_PMS_EVENT;

      if (:ID_PMS_EVENT is null) then begin
        execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, :id_room_contract)
        returning_values :id_pms_event;
        -- FIXME nakraq da se update total_event_value
      end
      if (:cnt_room - :cnt = 1) then begin
        value_to_post = :TOTAL_VALUE_PER_SERVICE - :curr_total_posted;
      end else begin
        value_to_post = round_f(:TOTAL_VALUE_PER_SERVICE / :cnt_room, :round_to);
      end

      curr_total_posted = :curr_total_posted + :value_to_post;
      cnt = :cnt + 1;

      /* ...i se razpredelq mejdu sobstwenicite na staqta */
      value_to_post = abs(:value_to_post);
      for
        select R.ID_OWNER, R.OUT_VALUE
        from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
        into   :id_owner, :value_to_post_per_owner
      do begin
        /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_pool_account,
                :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                1, :IS_OWNER_INCOME, :id_room)
        returning_values :no_use_id_acc_post;
        /* ... i se nachislqwa po sobswtenik */
        execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
        returning_values (:id_owner_account, :is_account$pms);

        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                :is_account$pms, :is_owner_income, :id_room)
        returning_values :no_use_id_acc_post;
      end
    end
  end else begin
    /* distribution by room_param */
    insert into TMP_SELECT$PMS(ID_SESSION, ID_ROOM, ID_OWNER)
    select distinct current_transaction, RP.ID_ROOM, null
    from   ROOM_PERIOD$PMS RP
           join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
    where  RC.ID_RENTAL_POOL = :ID_RENTAL_POOL
           and RP.STATUS in ('PRIVATE','CONTRACT')
           and RP.FROM_DATE <= :FOR_DATE
           and RP.TO_DATE >= :FOR_DATE;

    id_hotel = null;
    for
      select P.OUT_VALUE, P.OUT_ID_ROOM, R.ID_HOTEL
      from   PMS_CALC_VALUE_BY_PARAM(:ID_ROOM_PARAM, :TOTAL_VALUE_PER_SERVICE, :round_to) P
             join ROOMS R on R.ID_ROOM = P.OUT_ID_ROOM
      into   :value_to_post, :id_room, :id_hotel
    do begin
      id_pms_event = null;
      id_room_contract = null;
      -- room contract must be only one for this period
      select RC.ID_ROOM_CONTRACT
      from   ROOM_PERIOD$PMS RP
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.ID_ROOM = :id_room
             and :for_date between RP.FROM_DATE and RP.TO_DATE
      into   :id_room_contract;

      if (:id_room_contract is not null) then begin
        select E.ID_PMS_EVENT
        from   PMS_EVENT$PMS E
        where  E.ID_ROOM = :id_room
               and E.ID_SESSION = current_transaction
        into   :ID_PMS_EVENT;
  
        if (:ID_PMS_EVENT is null) then begin
          execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                  'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, id_room_contract)
          returning_values :id_pms_event;
          -- FIXME nakraq da se update total_event_value
        end
  
        /* ...i se razpredelq mejdu sobstwenicite na staqta */
        for
          select R.ID_OWNER, R.OUT_VALUE
          from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
          into   :id_owner, :value_to_post_per_owner
        do begin
          /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :ID_POOL_ACCOUNT,
                  :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                  1, :IS_OWNER_INCOME, :id_room)
          returning_values :no_use_id_acc_post;
  
          /* ... i se nachislqwa po sobswtenik */
          execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
          returning_values (:id_owner_account, :is_account$pms);

          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                  :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                  :is_account$pms, :is_owner_income, :id_room)
          returning_values :no_use_id_acc_post;
        end
      end
    end

    delete from TMP_SELECT$PMS T
    where  T.ID_SESSION = current_transaction;
  end
end
^

/* Restore proc. body: RES_CHECKIN$RSV */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable old_check_status integer;
  declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable is_anul integer;
  declare variable arrival_date date;
  declare variable system_date date;
begin
  /*  Description:
  ||
  */
  select RD.CHECK_STATUS, RD.RDB$DB_KEY, RD.FROM_DATE, RD.ID_HOTEL,
         RD.ID_ROOM, RD.IS_ANUL
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_check_status, :rd_dbkey, :arrival_date, :id_hotel,
         :old_id_room, :is_anul;

  if (:is_anul = 1) then exception BOOKING_EXCEPTION '-2';

  if (:old_check_status >= 0) then exception BOOKING_EXCEPTION '-1003';

  if (:old_id_room < 0 and coalesce(:ID_ROOM, 0) <= 0) then exception BOOKING_EXCEPTION '-1018';

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date < :arrival_date) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CHECK_IN_FUTURE');
  end
  /*----*/
  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'lock');

  execute procedure sys_dbg('occ RES_CHECKIN$RSV id_room = '||coalesce(:id_room, 'null'));
  execute procedure sys_dbg('occ RES_CHECKIN$RSV old_id_room = '||coalesce(:old_id_room, 'null'));

  if (:id_room is not null) then begin
    if (:old_check_status = -3) then begin
      execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, -2);
    end

    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option)
    returning_values (:WARN_CODE);
  end

  execute procedure RES_SET_CHECKIN$INT (:rd_dbkey)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'release');
  /*----*/
  select f_character(29) || R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = coalesce(:ID_ROOM, :old_id_room)
  into   :action_text;
   
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'CHECK_IN', :action_text);

end
^

/* Restore proc. body: RES_GUEST_CHANGE$RSV */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable id_guest integer;
  declare variable check_status integer;
  declare variable id_person_data integer;
  declare variable old_person_profile integer;
  declare variable old_profile_name varchar(100);
  declare variable new_profile_name varchar(100);
begin
  select r.RDB$DB_KEY, r.ID_TITULAR, r.CHECK_STATUS, r.ID_PERSON_PROFILE, p.PROFILE_NAME
  from   RESERV_DETAIL R
         join PROFILE P on P.ID_PROFILE = r.ID_PERSON_PROFILE
  where  R.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey, :id_guest, :check_status, :old_person_profile, :old_profile_name;

  if (:old_person_profile = :ID_PERSON_PROFILE) then exit; -- NO CHANGES!

  id_person_data = null;
  select pp.ID_PERSON_DATA, p.PROFILE_NAME
  from   PROFILE_PERSON PP
         join PROFILE P on P.ID_PROFILE = pp.ID_PROFILE
  where  pp.ID_PROFILE = :ID_PERSON_PROFILE
  into   :id_person_data, :new_profile_name;

  if (:id_person_data is null) then exception BOOKING_EXCEPTION '-1039';

  update RESERV_DETAIL RD
  set    rd.ID_PERSON_PROFILE = :ID_PERSON_PROFILE
  where  rd.RDB$DB_KEY = :rd_dbkey;

  if (:check_status = 1) then begin
    execute procedure PERSON_DATA_COPY$INT (:id_person_data)
    returning_values (:id_person_data);
  end

  update GUEST_DATA GD
  set    gd.ID_PERSON_DATA = :id_person_data
  where  gd.ID_GUEST = :id_guest;

  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey);

  if (exists (select ap.ID_ACCOUNT_POST
              from   ACCOUNT_POST AP
                     join ACCOUNT A on A.ID_ACCOUNT = ap.ID_ACCOUNT
              where  a.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                     and a.ID_PROFILE = :old_person_profile
                     and ap.IS_ANUL = 0)) then
    exception BOOKING_EXCEPTION '-1038';

  if (exists (select d.ID_DEPOSIT
              from   DEPOSITS D
                     join ACCOUNT A on A.ID_ACCOUNT = d.ID_ACCOUNT
              where  a.ID_PROFILE = :old_person_profile
                     and coalesce(d.ID_RESERV_DETAIL, a.ID_RESERV_DETAIL) = :ID_RESERV_DETAIL
                     and d.RECEIVED_AMOUNT > 0)) then
    exception BOOKING_EXCEPTION '-1040';

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'TITULAR_CHANGED',
          f_character(29) || :old_profile_name || f_character(28) || :new_profile_name, null);

end
^

/* Restore proc. body: RES_RECALC$INT */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable num_prefix varchar(20);
  declare variable number_1 varchar(20);
begin
  /* CALLER_KIND = {NORMAL, FORCED} */
  err_code = 0;
  /* 1. GET DATA */
  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL, rd.NUMBER_1
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :check_status, :id_reserv_detail, :number_1;

  if (:check_status = 1) then begin
    -- CHECKED OUT
    select sn.LEADING_PART
    from   SYSTEM_NUMERATOR SN
    where  sn.ID_NUMERATOR = 0
    into   :num_prefix;

    if (trim('.' from coalesce(:num_prefix, '')) = coalesce(:number_1, '')) then
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_MINE');
    else
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_ELSE');

    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :id_guest
    do begin
      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'MANUAL_EDIT_DATA', '');
    end
  end
  /* 2. FIND DEPENDANT GUESTS AND THEIR TARIFFS */
  execute procedure sys_dbg('calc RES_RECALC$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

  id_tar_calc = gen_id(gen_id_tar_calc, 1);
  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NONE');

  execute procedure TAR_CALC_EVAL_ALL$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  -- 3. UPDATE ROOM PRICE and REPOST ALL AFFECTED BOOKINGS
  execute procedure RES_TAR_CALC_FINALIZE$INT (:ERR_CODE, :ID_TAR_CALC, :RD_DBKEY, :CALLER_KIND, :FORCE_POSTING);

end
^

/* Restore proc. body: RES_ROOM_REMOVE$INT */
ALTER PROCEDURE RES_ROOM_REMOVE$INT(RD_DBKEY CHAR(8))
 RETURNS(WARN_CODE INTEGER)
 AS
begin

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, null, null, 'nrttAsIs')
  returning_values (:WARN_CODE);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 0)
  returning_values  :WARN_CODE;

end
^

/* Restore proc. body: RES_SAVE_ACCOUNTING$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
declare variable old_id_agent_profile integer;
  declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable action_text varchar(255);
  declare variable old_account_routing varchar(30);
  declare variable id_acc_profile integer;
begin
  /* Description : ACC_ROUTING = {GUEST, AGENT, MIXED, OWNER, GUEST_SEPARATE_ACCOUNTS, PART_COMPLIMENTARY, FULL_COMPLIMENTARY }
  ||
  *//*
  execute procedure RES_SAVE_PROFILING$INT (:RD_DBKEY, :ID_AGENT_PROFILE, :ID_AGENT_ACCOUNT, :ID_AGENT_PAYMENT,
          :id_person_profile, :ID_PERSON_PAYMENT, :ACC_ROUTING, :ID_GROUP);
  */
  execute procedure SYSTEM_CHECK_OPERATION(:acc_routing, 'GUEST, AGENT, MIXED, OWNER, FULL_COMPLIMENTARY, PART_COMPLIMENTARY', 'Account routing');

  if (exists (select *
              from   PROFILE_HOUSE PH
              where  PH.ID_PROFILE = :id_agent_profile)) then
  begin
    exception BOOKING_EXCEPTION '-1016';
  end

  execute procedure RESERV_TRACK_CHANGES$INT(:rd_dbkey);

  select RD.ID_AGENT_PROFILE, RD.ID_RESERV_DETAIL, RD.ACC_ROUTING
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_agent_profile, :id_reserv_detail, :old_account_routing;

  if (:ACC_ROUTING in ('AGENT','MIXED') and :ID_AGENT_ACCOUNT is not null) then begin
    select A.ID_PROFILE
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :ID_AGENT_ACCOUNT
    into   :id_acc_profile;
    -- check up agent account ownership
    if (:id_acc_profile is distinct from :ID_AGENT_PROFILE) then ID_AGENT_ACCOUNT = null;
--    if (:id_acc_profile is distinct from :ID_AGENT_PROFILE) then exception BOOKING_EXCEPTION '-1026';
  end

  update RESERV_DETAIL RD
  set    RD.ID_AGENT_ACCOUNT_RULE = :ID_AGENT_ACCOUNT,
         RD.ACC_ROUTING = :ACC_ROUTING,
         RD.ID_AGENT_PROFILE = :ID_AGENT_PROFILE,
         RD.ID_AGENT_PAYMENT = :ID_AGENT_PAYMENT,
         --RD.ID_PERSON_PROFILE = :ID_PERSON_PROFILE,
         RD.ID_PERSON_PAYMENT = coalesce(:ID_PERSON_PAYMENT, RD.ID_PERSON_PAYMENT),
         RD.ID_GROUP = :ID_GROUP
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_id_agent_profile is distinct from :id_agent_profile) then begin
    execute procedure RES_SET_EDIT_STATUS$INT(:RD_DBKEY, 'AGENT', 'add');

    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :g_dbkey
    do begin
      execute procedure GUEST_AGENT_SET$INT(:g_dbkey, :id_agent_profile);
    end

    select f_character(29)||coalesce(old_A.PROFILE_NAME, '')||f_character(28)||coalesce(new_A.PROFILE_NAME, '')
    from   PROFILE old_A, PROFILE new_A
    where  old_A.ID_PROFILE = :old_id_agent_profile
           and new_A.ID_PROFILE = :ID_AGENT_PROFILE
    into   :action_text;

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_AGENT', :action_text);
  end

  if (:ACC_ROUTING <> :old_account_routing) then begin
    action_text = f_character(29) || coalesce(:old_account_routing, '')
                  || f_character(28) || coalesce(:acc_routing, '');

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_ACC_ROUTING', :action_text);
  end

  execute procedure RES_SAVE_ACCOUNTS$INT (:RD_DBKEY);
end
^

/* Restore proc. body: RES_SAVE_ROOM$EXC */
ALTER PROCEDURE RES_SAVE_ROOM$EXC(RD_DBKEY CHAR(8),
ID_RES_ROOM_TYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(250),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_room integer;
begin
  select RD.ID_ROOM, RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_room, :id_reserv_detail;

  execute procedure RES_SAVE_ROOM$RSV(
    :id_reserv_detail,
    :old_id_room,
    :id_res_room_type,
    'nrttAsIs',
    1,
    :id_hk_plan,
    :room_features,
    :i_special_treatment,
    :split_on_checkin,
    0
  ) returning_values :share_err_code, :err_text, :share_transaction_id, :warn_code;
end
^

/* Restore proc. body: SAFE_CHECK_OUT */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE TYPE OF ID)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
WARN_CODE TYPE OF ID_REF)
 AS
declare variable to_dt timestamp;
  declare variable is_occupied integer;
  declare variable expire_tollerance integer;
  declare variable occupant_name varchar(100);
  declare variable id_resource_reservation integer;
  declare variable check_out_datetime timestamp;
begin
  DOC_SELECTED = null;
  select s.IS_OCCUPIED, od.TO_DATETIME,
         st.EXPIRE_TOLLERANCE, rr.OCCUPANT_NAME, rr.ID_RESOURCE_RESERVATION
  from   SAFE s
         join RESOURCE$INT r on r.ID_RESOURCE = s.ID_SAFE
         join SAFE_TYPES st on st.ID_SAFE_TYPE = r.ID_RESOURCE_TYPE
         join RESOURCE_RESERVATION rr on rr.ID_RESOURCE_RESERVATION = s.ID_CURRENT_OCCUPANCY
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join RESOURCE_OCCUPANCY ro on ro.ID_RESOURCE_OCCUPANCY_DATA = od.ID_RESOURCE_OCCUPANCY_DATA
  where  s.ID_SAFE = :ID_SAFE
  into   :is_occupied, :to_dt, :expire_tollerance, :occupant_name, :id_resource_reservation;

  if (:is_occupied = 0) then exit;

  expire_tollerance = coalesce(:expire_tollerance, 0);
  check_out_datetime = current_timestamp;

  execute procedure SAFE_OCCUPANCY_MODIFY (:id_safe, current_timestamp, :occupant_name)
  returning_values  :DOC_SELECTED;

  if (:check_out_datetime > (:to_dt + cast(:expire_tollerance as double precision) / 60 / 24)) then begin
    execute procedure SYSTEM_WARNING_ADD (-1066, f_character(29) || :expire_tollerance || f_character(28) || formatdate(:to_dt + cast(:expire_tollerance as double precision) / 60 / 24, 'D;dd/mm/yyyy HH:MM'))
    returning_values (:WARN_CODE);
  end

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = null
  where  s.ID_SAFE = :ID_SAFE;

  update RESOURCE_RESERVATION rr
  set    rr.STATUS = 'CHECKED_OUT'
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_CHECKED_OUT', :occupant_name);
end
^

/* Restore proc. body: TAR_CALC_INPUT_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_PARAMS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_input integer;
  declare variable id_guest integer;
  declare variable for_date date;
  declare variable id_calc_tariff integer;
  declare variable td_dbkey char(8);
  declare variable date_independent_param_values varchar(2000);
  declare variable date_dep_param_values varchar(2000);
  declare variable prev_id_guest integer;
  declare variable prev_id_tariff integer;
begin
  prev_id_guest = null;
  prev_id_tariff = null;
  for
    select Td.RDB$DB_KEY, TI.ID_TAR_INPUT, ti.ID_GUEST, td.FOR_DATE, td.ID_TAR_HEAD
    from   TAR_CALC_INPUT$TMP TI
           join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
    where  TI.ID_TAR_CALC = :id_tar_calc
    order by ti.ID_GUEST asc, td.FOR_DATE asc
    into   :td_dbkey, :id_tar_input, :id_guest, :for_date, :id_calc_tariff
  do begin
    if ((:id_guest is distinct from :prev_id_guest)
        or (:id_calc_tariff is distinct from :prev_id_tariff)) then
    begin
      /* get date independent params */
      execute procedure TAR_CALC_PARAMS$INT (:id_calc_tariff, :id_tar_input, :ID_TAR_CALC, null, null)
      returning_values (:ERR_CODE, :date_independent_param_values);
      if (:ERR_CODE < 0) then exit;
      prev_id_guest = :id_guest;
      prev_id_tariff = :id_calc_tariff;
    end

    execute procedure TAR_CALC_PARAMS$INT (:id_calc_tariff, :id_tar_input, :ID_TAR_CALC, :for_date, null)
    returning_values (:ERR_CODE, :date_dep_param_values);
    if (:ERR_CODE < 0) then exit;

    update TAR_CALC_INPUT_DETAIL$TMP d
    set    d.PARAM_VALUES = coalesce(:date_independent_param_values, '') || ';'
                            || coalesce(:date_dep_param_values, '')
    where  d.RDB$DB_KEY = :td_dbkey;
  end
end
^

SET TERM ; ^

