/* Server version: WI-V6.3.4.18393 Firebird 2.1 
   SQLDialect: 3. ODS: 11.1. Forced writes: On. Sweep inteval: 20000.
   Page size: 8192. Cache pages: 2048 (16384 Kb). Read-only: False. */
SET SQL DIALECT 3;

ALTER TABLE AR_PAYMENT_ADD DROP CONSTRAINT PK_AR_PAYMENT_ADD;

RECONNECT;

ALTER TABLE AR_PAYMENT DROP CONSTRAINT FK_ARP_AR_PAYMENT_ACCOUNT;

ALTER TABLE AR_PAYMENT_ACCOUNT DROP CONSTRAINT PK_AR_PAYMENT_ACCOUNT;

RECONNECT;

ALTER TABLE AR_OWING_ADD DROP CONSTRAINT PK_AR_OWING_ADD;

RECONNECT;

ALTER TABLE AR_OWING_PAYMENT_POST DROP CONSTRAINT FK_AROPP_OPERATION;

ALTER TABLE AR_PAYMENT DROP CONSTRAINT FK_ARP_OPERATION;

ALTER TABLE AR_TYPE DROP CONSTRAINT FK_ART_OPERATION;

ALTER TABLE AR_OPERATION DROP CONSTRAINT PK_AR_OPERATION;

ALTER TABLE AR_PAYMENT DROP CONSTRAINT FK_ARP_PAYMENT_TYPE;

ALTER TABLE AR_PAYMENT DROP CONSTRAINT FK_ARP_HOTEL;

ALTER TABLE AR_PAYMENT_TYPE DROP CONSTRAINT FK_AR_PAYMENT_TYPE;

ALTER TABLE AR_PAYMENT_ADD DROP CONSTRAINT FK_AR_PAYMENT_ADD;

ALTER TABLE AR_PAYMENT_ACCOUNT DROP CONSTRAINT FK_AR_PAYMENT_ACCOUNT;

ALTER TABLE AR_OWING_ADD DROP CONSTRAINT FK_AR_OWING_ADD;

ALTER TABLE AR_OWING DROP CONSTRAINT FK_AR_OWING;

/* Create Domains... */
CREATE DOMAIN TOBJECT_ID AS VARCHAR(20);

/* Alter Procedure (Before Drop)... */
SET TERM ^ ;

ALTER PROCEDURE ACC_STATEMENT_INVOICES_GET$INT(FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM INTEGER,
ID_OWNER INTEGER)
 RETURNS(ID_DOC INTEGER,
DATE_POST DATE,
ROOM_NAME VARCHAR(100),
LINE_DESC VARCHAR(100),
OUTGO_VALUE NUMERIC(15,4),
CURR_POST VARCHAR(3),
IS_ANUL SMALLINT,
IS_INVOICED SMALLINT,
ID_ACCOUNT_POST INTEGER,
ID_BILL INTEGER,
BILLING_INFO VARCHAR(100),
OUT_ID_OWNER INTEGER,
OUT_ID_ROOM INTEGER,
ID_SERVICE INTEGER,
INV_DESCRIPTION VARCHAR(100),
DEVICE_READING_INFO VARCHAR(300),
ID_EXPORT_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE AR_ACCOUNT_BALANCE_REPORT(FROM_DATE DATE,
ID_PROFILE /* TYPE OF ID_REF */ INTEGER,
ID_HOTEL /* TYPE OF ID_REF */ INTEGER,
IN_GROUP SMALLINT,
USE_FOR_NS_CALCULATION SMALLINT)
 RETURNS(ID_ROW INTEGER,
DESCRIPTION VARCHAR(255),
SUMA NUMERIC(15,4),
CURR VARCHAR(3),
SUMA_RECALC NUMERIC(15,4),
CURR_RECALC VARCHAR(3),
PAYMENT_RATE_TO_BGN NUMERIC(15,6),
OWING_RATE_TO_BGN NUMERIC(15,6),
ROW_TYPE VARCHAR(10))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE AR_ACCOUNT_BALANCE_SELECT(FROM_DATE /* TYPE OF TDATE */ DATE,
ID_PROFIL /* TYPE OF ID_REF */ INTEGER,
ID_HOTEL /* TYPE OF ID_REF */ INTEGER,
IN_GROUP SMALLINT,
USE_FOR_NS_CALCULATION SMALLINT)
 RETURNS(DESCRIPTION VARCHAR(255),
SUMA NUMERIC(15,4),
CURR VARCHAR(3),
ID_AR_PAYMENT INTEGER,
REST_PAYMENT NUMERIC(15,4))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE AR_FIND_PROFILE$AR(PROFILE_DESC /* TYPE OF TPERSON_NAME */ VARCHAR(100),
ONLY_WITH_OWINGS /* TYPE OF TLOGICAL */ SMALLINT,
TO_DATE /* TYPE OF TDATE */ DATE = null,
ID_HOTEL /* TYPE OF ID */ INTEGER = null)
 RETURNS(ID_PROFILE /* TYPE OF ID */ INTEGER,
PROFILE_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100),
BALANCE_OWING VARCHAR(100),
BALANCE_PAYMENT VARCHAR(100))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE AR_PAYMENT_ACCOUNT_MODIFY$AR(ID_AR_PAYMENT_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_AR_PAYMENT_TYPE /* TYPE OF ID */ INTEGER,
ACCOUNT_NAME /* TYPE OF NAME_20 */ VARCHAR(20),
OPERATION VARCHAR(10))
 RETURNS(NEW_ID_AR_PAYMENT_ACCOUNT /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE REP_ROOM_STATUS(LANG_CODE VARCHAR(10),
IN_FOR_DATE DATE,
IN_OCUP_TYPE INTEGER,
STAT_OPTIONS VARCHAR(255),
ID_HOTEL /* TYPE OF ID */ INTEGER)
 RETURNS(OUT_ID_ROOM INTEGER,
OUT_ROOM_NAME VARCHAR(10),
OUT_FLOOR INTEGER,
OUT_SECTOR INTEGER,
OUT_BEDS INTEGER,
OUT_IS_CLEAN INTEGER,
OUT_IS_CLEAN_WORDS VARCHAR(100),
OUT_ID_ROOM_TYPE INTEGER,
OUT_TYPE_ROOM VARCHAR(20),
OUT_IS_FREE INTEGER,
OUT_IS_FREE_WORDS VARCHAR(100),
OUT_IS_LEAVING INTEGER,
OUT_IS_LEAVING_WORDS VARCHAR(100),
OUT_OCUP_TYPE VARCHAR(100),
OUT_OCUP_SUB_TYPE VARCHAR(100),
OUT_GUEST_IN_ROOM INTEGER,
OUT_GROUP_NAME VARCHAR(30),
OUT_DAYS_THIS_STATUS INTEGER,
OUT_DAYS_THIS_STATUS_TXT VARCHAR(5),
OUT_COUNTRY VARCHAR(30),
OUT_ID_GROUP INTEGER,
OUT_ID_AGENT INTEGER,
OUT_AGENT_NAME VARCHAR(30),
OUT_EARLY_COMING INTEGER,
OUT_LATE_LEAVING INTEGER,
OUT_IS_CRITICAL_LEAVING INTEGER,
OUT_ID_ARISE_SOURCE INTEGER,
OUT_GUEST_NAME VARCHAR(50),
OUT_TYPE_STAY VARCHAR(30),
OUT_IS_ARROW CHAR,
OUT_COLOR INTEGER,
OUT_EXPECTED_COME INTEGER,
OUT_ADULT_COUNT INTEGER,
OUT_CHILD_COUNT INTEGER,
OUT_BUSY_GRP INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE REP_ROOM_STATUS_FREE(CURRENT_DB_LANG VARCHAR(10),
CURRENT_UI_LANG VARCHAR(10),
BASE_LANG VARCHAR(10),
FROM_ROOM_NAME VARCHAR(30),
TO_ROOM_NAME VARCHAR(30),
FOR_DATE DATE,
STAT_OPTIONS VARCHAR(255))
 RETURNS(OUT_ID_ROOM INTEGER,
OUT_ROOM_NAME VARCHAR(10),
OUT_FLOOR INTEGER,
OUT_SECTOR INTEGER,
OUT_BEDS INTEGER,
OUT_IS_CLEAN INTEGER,
OUT_IS_CLEAN_WORDS VARCHAR(100),
OUT_ID_ROOM_TYPE INTEGER,
OUT_TYPE_ROOM VARCHAR(20),
OUT_IS_FREE INTEGER,
OUT_IS_FREE_WORDS VARCHAR(100),
OUT_IS_LEAVING INTEGER,
OUT_IS_LEAVING_WORDS VARCHAR(100),
OUT_OCUP_TYPE VARCHAR(100),
OUT_OCUP_SUB_TYPE VARCHAR(100),
OUT_GUEST_IN_ROOM INTEGER,
OUT_GROUP_NAME VARCHAR(30),
OUT_DAYS_THIS_STATUS INTEGER,
OUT_DAYS_THIS_STATUS_TXT VARCHAR(5),
OUT_COUNTRY VARCHAR(30),
OUT_ID_GROUP INTEGER,
OUT_ID_AGENT INTEGER,
OUT_AGENT_NAME VARCHAR(30),
OUT_EARLY_COMING INTEGER,
OUT_LATE_LEAVING INTEGER,
OUT_IS_CRITICAL_LEAVING INTEGER,
OUT_ID_ARISE_SOURCE INTEGER,
OUT_GUEST_NAME VARCHAR(50),
OUT_TYPE_STAY VARCHAR(30),
OUT_IS_ARROW CHAR,
OUT_COLOR INTEGER,
OUT_EXPECTED_COME INTEGER,
OUT_ADULT_COUNT INTEGER,
OUT_CHILD_COUNT INTEGER,
OUT_BUSY_GRP INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE REP_ROOM_STATUS_MOVE(FROM_DATE DATE,
TO_DATE DATE,
IN_ID_ROOM_TYPE INTEGER,
SECTOR INTEGER,
FLOOR INTEGER,
ROOM_PARAM_LIST VARCHAR(100),
OPTIONS VARCHAR(255),
HOTELS VARCHAR(255) = '')
 RETURNS(BUSY_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_AGENT INTEGER,
ID_HOTEL INTEGER,
GSTS_STAYOVER INTEGER,
ROOMS_STAYOVER INTEGER,
GSTS_COME INTEGER,
ROOMS_COME INTEGER,
GSTS_GONE INTEGER,
ROOMS_GONE INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE REP_ROOM_STATUS_OCCUPIED(CURRENT_DB_LANG VARCHAR(10),
CURRENT_UI_LANG VARCHAR(10),
BASE_LANG VARCHAR(10),
ID_ROOM INTEGER,
FOR_DATE DATE,
ID_ARISE_SOURCE INTEGER,
ARISE_SOURCE VARCHAR(50),
BUSY_GROUP_TYPE INTEGER,
BUSY_TYPE VARCHAR(50),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
GUEST_IN_ROOM INTEGER,
STAT_OPTIONS VARCHAR(255),
BUSY_ROOMS_LIST VARCHAR(5000))
 RETURNS(OUT_ID_ROOM INTEGER,
OUT_ROOM_NAME VARCHAR(10),
OUT_FLOOR INTEGER,
OUT_SECTOR INTEGER,
OUT_BEDS INTEGER,
OUT_IS_CLEAN INTEGER,
OUT_IS_CLEAN_WORDS VARCHAR(100),
OUT_ID_ROOM_TYPE INTEGER,
OUT_TYPE_ROOM VARCHAR(20),
OUT_IS_FREE INTEGER,
OUT_IS_FREE_WORDS VARCHAR(100),
OUT_IS_LEAVING INTEGER,
OUT_IS_LEAVING_WORDS VARCHAR(100),
OUT_OCUP_TYPE VARCHAR(100),
OUT_OCUP_SUB_TYPE VARCHAR(100),
OUT_GUEST_IN_ROOM INTEGER,
OUT_GROUP_NAME VARCHAR(30),
OUT_DAYS_THIS_STATUS INTEGER,
OUT_DAYS_THIS_STATUS_TXT VARCHAR(5),
OUT_COUNTRY VARCHAR(30),
OUT_ID_GROUP INTEGER,
OUT_ID_AGENT INTEGER,
OUT_AGENT_NAME VARCHAR(30),
OUT_EARLY_COMING INTEGER,
OUT_LATE_LEAVING INTEGER,
OUT_IS_CRITICAL_LEAVING INTEGER,
OUT_ID_ARISE_SOURCE INTEGER,
OUT_GUEST_NAME VARCHAR(50),
OUT_TYPE_STAY VARCHAR(30),
OUT_IS_ARROW CHAR,
OUT_COLOR INTEGER,
OUT_EXPECTED_COME INTEGER,
OUT_ADULT_COUNT INTEGER,
OUT_CHILD_COUNT INTEGER,
OUT_BUSY_GRP INTEGER,
OUT_BUSY_ROOMS_LIST VARCHAR(5000))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE SUMMARY_PREPARE$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE SUMMARY_PREPARE_CANCELED$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
OPTIONS VARCHAR(255))
 RETURNS(BUSY_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_PROFILE_AGENT INTEGER,
COUNTRY_CODE VARCHAR(20),
MARKET_SEGMENT_CODE VARCHAR(3),
SOURCE_CODE VARCHAR(3),
CHANNEL_CODE VARCHAR(3),
HEAR_REASON_CODE VARCHAR(3),
COME_REASON_CODE VARCHAR(3),
ROOMS_NOSHOW SMALLINT,
GUESTS_NOSHOW SMALLINT,
ROOMS_CANCELED SMALLINT)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE SUMMARY_PREPARE_MAIN$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
OPTIONS VARCHAR(255))
 RETURNS(BUSY_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_PROFILE_AGENT INTEGER,
COUNTRY_CODE VARCHAR(20),
MARKET_SEGMENT_CODE VARCHAR(3),
SOURCE_CODE VARCHAR(3),
CHANNEL_CODE VARCHAR(3),
HEAR_REASON_CODE VARCHAR(3),
COME_REASON_CODE VARCHAR(3),
ROOMS_SOLD SMALLINT,
ROOMS_SOLD_MULTIPLE_GST SMALLINT,
ROOMS_ARRIVAL SMALLINT,
ROOMS_DEPARTURE SMALLINT,
GUESTS_IN_HOUSE SMALLINT,
GUESTS_ARRIVAL SMALLINT,
GUESTS_DEPARTURE SMALLINT,
GUESTS_DAY_USE SMALLINT)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE SUMMARY_PREPARE_SLICE$INT(ID_RESERV_DETAIL INTEGER,
OPTIONS VARCHAR(50))
 RETURNS(ID_PROFILE_AGENT INTEGER,
COUNTRY_CODE VARCHAR(20),
MARKET_SEGMENT_CODE VARCHAR(3),
SOURCE_CODE VARCHAR(3),
CHANNEL_CODE VARCHAR(3),
HEAR_REASON_CODE VARCHAR(3),
COME_REASON_CODE VARCHAR(3))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE SUMMARY_PREPARE_TOTAL$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(BUSY_DATE DATE,
ID_ROOM_TYPE INTEGER,
ROOMS_OOI SMALLINT,
ROOMS_OOO SMALLINT,
ROOMS_SOLD SMALLINT,
ROOMS_SOLD_MULTIPLE_GST SMALLINT,
ROOMS_ARRIVAL SMALLINT,
ROOMS_DEPARTURE SMALLINT,
CH_IN_HOUSE SMALLINT,
CH_ARRIVAL SMALLINT,
CH_DEPARTURE SMALLINT,
AD_IN_HOUSE SMALLINT,
AD_ARRIVAL SMALLINT,
AD_DEPARTURE SMALLINT,
GUESTS_DAY_USE SMALLINT)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE SYSTEM_DECODE_ID(ENTERPRISE_ID INTEGER)
 RETURNS(LOCAL_ID INTEGER)
 AS
 BEGIN SUSPEND; END
^


/* Drop Procedure... */
ALTER PROCEDURE ACC_STATEMENT_GET_INFO$PMS(FROM_DATE DATE,
TO_DATE DATE,
ID_SERVICE_HL_LIST VARCHAR(255))
 RETURNS(ID_BILL INTEGER,
ID_DOC INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
POST_DATE DATE,
ID_ROOM INTEGER,
ID_OWNER INTEGER,
ROOM_INFO VARCHAR(30),
OWNER_NAME VARCHAR(100),
BILLING_INFO VARCHAR(100),
ID_SERVICE INTEGER,
SERVICE_DESC VARCHAR(100),
DESCRIPTION VARCHAR(300),
REF_DOC_INFO VARCHAR(300),
DEVICE_READING_INFO VARCHAR(300),
INCOME_VALUE NUMERIC(15,4),
INCOME_CURR VARCHAR(3),
OUTGO_VALUE NUMERIC(15,4),
OUTGO_CURR VARCHAR(3),
IS_ANUL SMALLINT,
IS_INVOICED SMALLINT,
ID_EXPORT_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP PROCEDURE ACC_STATEMENT_INVOICES_GET$INT;

DROP PROCEDURE AR_ACCOUNT_BALANCE_REPORT;

DROP PROCEDURE AR_ACCOUNT_BALANCE_SELECT;

DROP PROCEDURE AR_FIND_PROFILE$AR;

DROP PROCEDURE AR_PAYMENT_ACCOUNT_MODIFY$AR;

SET TERM ^ ;

ALTER PROCEDURE EAI_EXT_ROOM_STATUS(ROOMS_FILTER VARCHAR(512) = '',
ID_HOTEL INTEGER = null)
 RETURNS(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
GUEST_NAME2 VARCHAR(50),
ROOM_NAME VARCHAR(10),
FROM_DATE DATE,
TO_DATE DATE,
COUNTRY VARCHAR(30),
AGE INTEGER,
ID_AGENT INTEGER,
ID_GROUP INTEGER,
SEX CHAR,
GUEST_CODE VARCHAR(50),
GUESTS_IN_ROOM INTEGER)
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP PROCEDURE REP_ROOM_STATUS;

DROP PROCEDURE REP_ROOM_STATUS_FREE;

SET TERM ^ ;

ALTER PROCEDURE AVAILABILITY_OCCUPANCY$INT(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
 BEGIN EXIT; END
^

SET TERM ; ^

DROP PROCEDURE REP_ROOM_STATUS_MOVE;

DROP PROCEDURE REP_ROOM_STATUS_OCCUPIED;

SET TERM ^ ;

ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE OCCUPANCY_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
 BEGIN EXIT; END
^

SET TERM ; ^

DROP PROCEDURE SUMMARY_PREPARE$INT;

DROP PROCEDURE SUMMARY_PREPARE_CANCELED$INT;

DROP PROCEDURE SUMMARY_PREPARE_MAIN$INT;

DROP PROCEDURE SUMMARY_PREPARE_SLICE$INT;

DROP PROCEDURE SUMMARY_PREPARE_TOTAL$INT;

DROP PROCEDURE SYSTEM_DECODE_ID;

DROP PROCEDURE SYSTEM_LOOP_GUESTS;


/* Dropping trigger... */
DROP TRIGGER AR_PAYMENT_ACCOUNT_BI_BI;


/* Drop Index... */
RECONNECT;

/* Drop: AR_OWING_ADD_IDX1 (TIdxData) */
DROP INDEX AR_OWING_ADD_IDX1;

RECONNECT;

/* Drop: ROOM_MAGIC_IDX1 (TIdxData) */
DROP INDEX ROOM_MAGIC_IDX1;

RECONNECT;

/* Drop: ROOMS_SHARE_EXSHARE_IDX (TIdxData) */
DROP INDEX ROOMS_SHARE_EXSHARE_IDX;


/* Drop View... */
DROP VIEW AR_PAY_TYPE;

DROP VIEW ROOMTYPE_MAGIC;


/* Create Table... */
CREATE TABLE EXT_PRATE_EXPORT_MAP(ID_PRATE_MAP ID NOT NULL,
MAX_ROOMS TCOUNT,
IS_ACTIVE TLOGICAL NOT NULL);


CREATE TABLE EXT_PRATE_HOTEL_MAP(ID_HOTEL ID_REF NOT NULL,
PRATE_ID_HOTEL TSHORT_CODE NOT NULL,
USER_NAME TUSER_NAME NOT NULL,
"PASSWORD" TPASSWORD NOT NULL,
IS_ACTIVE TLOGICAL NOT NULL);


CREATE TABLE EXT_PRATE_MAP(ID_PRATE_MAP ID NOT NULL,
ID_HOTEL ID_REF NOT NULL,
ID_OBJECT TOBJECT_ID,
OBJECT_TYPE TOBJECT_TYPE NOT NULL,
EXTERNAL_CODE TSHORT_CODE NOT NULL,
EXTERNAL_DESCRIPTION TOBJECT_TEXT,
IS_EXPORT TLOGICAL NOT NULL);


COMMENT ON COLUMN EXT_PRATE_MAP.OBJECT_TYPE IS
'room_type';

CREATE TABLE HOTEL_PAYPAL_CFG$WBE(ID ID NOT NULL,
HOTEL_ID ID_REF,
EMAIL TEMAIL,
CURRENCY TCURRENCY,
IS_TEST D_BOOLEAN);



ALTER TABLE AR_OWING ADD REST_OWING TPRICE;

ALTER TABLE AR_OWING ADD OWING_STATUS TENUM_SMALL;

ALTER TABLE AR_OWING_PAYMENT_POST ADD ID_PROFILE ID_REF;

ALTER TABLE AR_PAYMENT ADD REST_PAYMENT TPRICE;

ALTER TABLE AR_PAYMENT ADD PAYMENT_STATUS TENUM_SMALL;

ALTER TABLE AR_PAYMENT ADD ACCOUNT_NAME TNAME_SHORT;

ALTER TABLE AR_PAYMENT_TYPE ADD PAYMENT_TYPE TNAME_SHORT NOT NULL;

ALTER TABLE AR_PAYMENT_TYPE ADD IS_USE TLOGICAL;

UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='ID_TYPE' WHERE RDB$FIELD_NAME='BUSY_GROUP_TYPE' AND RDB$RELATION_NAME='ROOM_MAGIC';

COMMENT ON COLUMN ROOM_MAGIC.DAY_ACTION_INT IS
'0 BLOCK
1 CHECK_IN
2 STAY
3 CHECK_OUT
13 CHECK_IN/CHECK_OUT';

/* Drop table-fields... */

/* Empty AR_OWING_PAYMENT_ADD$AR for drop AR_OWING_PAYMENT_POST(ID_AR_OPERATION) */
SET TERM ^ ;

ALTER PROCEDURE AR_OWING_PAYMENT_ADD$AR(ID_AR_OWING INTEGER,
ID_AR_PAYMENT INTEGER,
SUM_OWING NUMERIC(15,4),
SUM_PAYMENT NUMERIC(15,4),
PAYMENT_RATE_TO_BGN NUMERIC(15,6),
OWING_RATE_TO_BGN NUMERIC(15,6),
DESCRIPTION VARCHAR(255))
 RETURNS(NEW_ID_AR_OWING_PAYMENT_POST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Empty AR_OWING_PAYMENT_ANUL$AR for drop AR_OWING_PAYMENT_POST(ID_AR_OPERATION) */
ALTER PROCEDURE AR_OWING_PAYMENT_ANUL$AR(ID_AR_OWING_PAYMENT_POST INTEGER,
DESCRIPTION VARCHAR(255))
 AS
 BEGIN EXIT; END
^

SET TERM ; ^

/* Empty AR_PAYMENT_ADD$AR for drop AR_PAYMENT(ID_AR_PAYMENT_ACCOUNT) */
SET TERM ^ ;

ALTER PROCEDURE AR_PAYMENT_ADD$AR(ID_PROFILE INTEGER,
ID_AR_PAYMENT_TYPE INTEGER,
ID_AR_PAYMENT_ACCOUNT INTEGER,
SUM_PAYMENT NUMERIC(15,4),
CURR_PAYMENT VARCHAR(3),
DESCRIPTION VARCHAR(255),
DATE_PAYMENT DATE,
ID_HOTEL INTEGER)
 RETURNS(NEW_ID_AR_PAYMENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Empty AR_PAYMENT_ANUL$AR for drop AR_PAYMENT(ID_AR_PAYMENT_ACCOUNT) */
ALTER PROCEDURE AR_PAYMENT_ANUL$AR(ID_AR_PAYMENT INTEGER,
DESCRIPTION VARCHAR(255))
 RETURNS(NEW_ID_AR_PAYMENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^


RECONNECT;

/* Drop tables... */

SET TERM ^ ;

ALTER PROCEDURE AR_OWING_ADD$INT(ID_PROFILE /* TYPE OF ID */ INTEGER,
SUM_OWING /* TYPE OF TPRICE */ NUMERIC(15,4),
CURR_OWING /* TYPE OF TCURRENCY */ CHAR(3),
ID_DOC_HEAD /* TYPE OF ID_REF */ INTEGER,
DUE_DATE /* TYPE OF TDATE */ DATE,
SYSTEM_DATE /* TYPE OF TDATE */ DATE,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_AR_TYPE /* TYPE OF ID */ INTEGER,
ID_HOTEL /* TYPE OF ID */ INTEGER)
 RETURNS(NEW_ID_AR_OWING /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE AR_OWING_ANUL$INT(ID_AR_OWING /* TYPE OF ID */ INTEGER,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IS_MANUAL_ANUL /* TYPE OF TLOGICAL */ SMALLINT = 1)
 RETURNS(NEW_ID_AR_OWING /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE AR_OWING_MODIFY$DOC(ID_DOC /* TYPE OF ID */ INTEGER,
ID_PROFILE /* TYPE OF ID */ INTEGER,
OWING_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
OWING_CURR /* TYPE OF TCURRENCY */ CHAR(3),
DUE_DATE /* TYPE OF TDATE */ DATE,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_HOTEL /* TYPE OF ID */ INTEGER,
OPERATION VARCHAR(10))
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE AR_OWING_REST_MODIFY$INT(ID_AR_OWING INTEGER,
REST_OWING NUMERIC(15,4),
OWING_CURR VARCHAR(3),
OWING_STATUS SMALLINT)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE AR_POST_FINALIZE(DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
OPERATION VARCHAR(10))
 AS
 BEGIN EXIT; END
^

SET TERM ; ^


/* Create Procedure... */
SET TERM ^ ;

CREATE PROCEDURE EXT_PRATE_EXPORT_MAP_SET(ID_PRATE_MAP INTEGER,
MAX_ROOMS INTEGER,
IS_ACTIVE SMALLINT)
 AS
 BEGIN EXIT; END
^

CREATE PROCEDURE EXT_PRATE_HOTEL_MAP_MODIFY(ID_HOTEL INTEGER,
PRATE_ID_HOTEL VARCHAR(10),
USER_NAME VARCHAR(30),
"PASSWORD" VARCHAR(50),
IS_ACTIVE SMALLINT,
OPERATION VARCHAR(3))
 AS
 BEGIN EXIT; END
^

CREATE PROCEDURE EXT_PRATE_MAP_MODIFY(ID_PRATE_MAP INTEGER,
ID_HOTEL INTEGER,
ID_OBJECT VARCHAR(20),
OBJECT_TYPE VARCHAR(100),
EXTERNAL_CODE VARCHAR(10),
EXTERNAL_DESCRIPTION VARCHAR(50),
IS_EXPORT SMALLINT,
OPERATION VARCHAR(5))
 RETURNS(NEW_ID_PRATE_MAP INTEGER)
 AS
 BEGIN SUSPEND; END
^

CREATE PROCEDURE POST_PREPARE$INT(ID_ACCOUNT ID_REF,
ID_GUEST ID_REF,
ID_SERVICE ID_REF,
QTY TQTY,
ID_SEQUENCE TRANGE,
PRICE_POST TPRICE,
CURR_POST TCURRENCY,
POST_TEXT TOBJECT_TEXT,
FROM_DATE TDATE,
TO_DATE TDATE,
ID_PHONECALL ID_REF = null)
 RETURNS(NEW_FROM_DATE TYPE OF TDATE)
 AS
 BEGIN SUSPEND; END
^

CREATE PROCEDURE RESERV_STATISTIC_CANCELED$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(BUSY_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_PROFILE_AGENT INTEGER,
COUNTRY_CODE VARCHAR(20),
MARKET_SEGMENT_CODE VARCHAR(3),
SOURCE_CODE VARCHAR(3),
CHANNEL_CODE VARCHAR(3),
HEAR_REASON_CODE VARCHAR(3),
COME_REASON_CODE VARCHAR(3),
ROOMS_NOSHOW SMALLINT,
GUESTS_NOSHOW SMALLINT,
ROOMS_CANCELED SMALLINT)
 AS
 BEGIN SUSPEND; END
^

CREATE PROCEDURE RESERV_STATISTIC_SLICE$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_PROFILE_AGENT INTEGER,
COUNTRY_CODE VARCHAR(20),
MARKET_SEGMENT_CODE VARCHAR(3),
SOURCE_CODE VARCHAR(3),
CHANNEL_CODE VARCHAR(3),
HEAR_REASON_CODE VARCHAR(3),
COME_REASON_CODE VARCHAR(3))
 AS
 BEGIN SUSPEND; END
^

CREATE PROCEDURE SUMMARY_OCCUPANCY_STATISTIC$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
 BEGIN EXIT; END
^

CREATE PROCEDURE TAR_BO_PRICE_GET(ID_TAR_BO_PRICE ID)
 RETURNS(PRICE_VALUE TYPE OF TTEXT_FORMULA,
PRICE_TYPE TYPE OF NAME_20)
 AS
 BEGIN SUSPEND; END
^


SET TERM ; ^

DROP VIEW HK_GUEST;

/* Create view: HK_GUEST */
CREATE VIEW HK_GUEST(
BUSY_DATE,
ID_HK_PLAN,
ID_ROOM_TYPE,
ID_ROOM,
ADULT_COUNT,
CHILD_COUNT,
DAY_ACTION,
DAY_OF_STAY,
ID_AGENT_PROFILE,
ID_RESERV_DETAIL,
FROM_DATE,
TO_DATE,
NUMBER,
I_SPECIAL_TREATMENT,
ID_HOTEL)
 AS 
select RM.BUSY_DATE, RD.ID_HK_PLAN, RM.ID_ROOM_TYPE, RM.ID_ROOM, RM.ADULT_COUNT+RM.GST_AD_OUT, RM.CHILDREN_COUNT+RM.GST_CH_OUT,
       RM.DAY_ACTION, RM.BUSY_DATE - G.FROM_DATE + 1 as DAY_OF_STAY,
       RD.ID_AGENT_PROFILE, RM.ID_RESERV_DETAIL,
       G.FROM_DATE, G.TO_DATE, RD.NUMBER, RD.I_SPECIAL_TREATMENT, RD.ID_HOTEL
from   ROOM_MAGIC RM
       join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = RM.ID_RESERV_DETAIL
       join GUEST G on G.ID_RESERV_DETAIL = RD.ID_RESERV_DETAIL
where  RD.CHECK_STATUS in (0, 1)
       and RD.ID_ROOM > 0
;

SET TERM ^ ;

ALTER PROCEDURE HK_PLAN_LINES_FINALIZE$HK(ID_PLAN_PERIOD INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE HK_PLAN_PERIOD_MODIFY$HK(ID_PLAN_PERIOD INTEGER,
ID_PLAN INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
OPERATION VARCHAR(10))
 RETURNS(NEW_ID_PLAN_PERIOD INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP VIEW HK_RESERVATION;

/* Create view: HK_RESERVATION */
CREATE VIEW HK_RESERVATION(
BUSY_DATE,
ID_HK_PLAN,
ID_ROOM_TYPE,
ID_ROOM,
ADULT_COUNT,
CHILD_COUNT,
DAY_ACTION,
DAY_OF_STAY,
ID_AGENT_PROFILE,
FROM_DATE,
TO_DATE,
NUMBER,
I_SPECIAL_TREATMENT,
ID_RESERVATION_DETAIL,
ID_HOTEL,
HOUR_ACTION,
IS_OWNER)
 AS 
select RM.BUSY_DATE, RD.ID_HK_PLAN, RM.ID_ROOM_TYPE, RM.ID_ROOM,
       RM.ADULT_COUNT + RM.GST_AD_OUT, RM.CHILDREN_COUNT + RM.GST_CH_OUT,
       RM.DAY_ACTION,
       RM.BUSY_DATE - RD.FROM_DATE + 1 as DAY_OF_STAY, RD.ID_AGENT_PROFILE,
       RD.FROM_DATE, RD.TO_DATE, RD.NUMBER, RD.I_SPECIAL_TREATMENT, RM.ID_RESERV_DETAIL,
       RD.ID_HOTEL,
        CASE
            WHEN DAY_ACTION containing 'CHECK_IN' then RD.transfer_in_time
            WHEN DAY_ACTION containing 'CHECK_OUT' then RD.transfer_out_time
        ELSE NULL
       END,
       iif(RD.ACC_ROUTING = 'OWNER', 1, 0)
from   ROOM_MAGIC RM
       join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = RM.ID_RESERV_DETAIL
where  RD.CHECK_STATUS in (-3, -2, -1, 0, 1)
       and RD.ID_ROOM > 0
;

/* Create Views... */
/* Create view: AR_PROFILE_ENTRIES */
CREATE VIEW AR_PROFILE_ENTRIES(
ID_PROFILE,
SYSTEM_DATE,
AR_VALUE_TYPE,
AR_VALUE,
BALANCE_VALUE,
CURR,
REF_ID)
 AS 
select ao.ID_PROFILE,
       ao.SYSTEM_DATE,
       'owing',
       ao.SUM_OWING,
       ao.SUM_OWING,
       ao.CURR_OWING,
       coalesce(AO.ID_AR_OWING_BASE, AO.ID_AR_OWING)
from   AR_OWING AO
union all
select ap.ID_PROFILE,
       ap.DATE_PAYMENT,
       'payment',
       ap.SUM_PAYMENT,
       -ap.SUM_PAYMENT,
       ap.CURR_PAYMENT,
       coalesce(ap.ID_AR_PAYMENT_BASE, Ap.ID_AR_PAYMENT)
from   AR_PAYMENT AP
union all
select aop.ID_PROFILE,
       aop.SYSTEM_DATE,
       iif(m.tag = 0, 'owing', 'payment'),
       iif(m.tag = 0, aop.SUM_OWING, aop.SUM_PAYMENT),
       iif(m.tag = 0, -aop.SUM_OWING, aop.SUM_PAYMENT),
       iif(m.tag = 0, aop.CURR_OWING, aop.CURR_PAYMENT),
       iif(m.tag = 0, aop.ID_AR_OWING, aop.ID_AR_PAYMENT)
from   AR_OWING_PAYMENT_POST AOP
       join AR_OWING op on op.ID_AR_OWING = aop.ID_AR_OWING
       join AR_PAYMENT pp on pp.ID_AR_PAYMENT = aop.ID_AR_PAYMENT
       left join RECORD_MULTIPLIER m on 1=1
;

/* Create view: AR_PROFILE_BALANCE */
CREATE VIEW AR_PROFILE_BALANCE(
ID_PROFILE,
BALANCE_OWING,
BALANCE_PAYMENT)
 AS 
select p.id_PROFILE,
       cast(list(iif(round_f(p.owing, c.ROUND_TO) <> 0, formatfloat(p.owing, c.DISPLAY_FORMAT) || ' ' || p.curr, null)) as varchar(255))  as owings,
       cast(list(iif(round_f(p.payment, c.ROUND_TO) <> 0, formatfloat(p.payment, c.DISPLAY_FORMAT) || ' ' || p.curr, null)) as varchar(255)) as payments
from   (select ap.ID_PROFILE,
               sum(iif(ap.AR_VALUE_TYPE = 'owing', ap.BALANCE_VALUE, null)) as OWING,
               sum(iif(ap.AR_VALUE_TYPE = 'payment', -ap.BALANCE_VALUE, null)) as PAYMENT,
               ap.CURR
        from   AR_PROFILE_ENTRIES ap
        group by ap.ID_PROFILE, ap.CURR, ap.AR_VALUE_TYPE) p
       join CURRS c on c.CURR = p.curr
group by 1
;

/* Create view: HOTEL_ROOM_OCCUPANCY */
CREATE VIEW HOTEL_ROOM_OCCUPANCY(
BUSY_DATE,
ID_ROOM_TYPE,
ID_ROOM,
ID_HOTEL,
ID_RESERV_STATISTICS,
BUSY_GROUP_TYPE,
BUSY_TYPE,
ID_AGENT,
OOO_ROOM,
OOI_ROOM,
STAYOVER_ADULTS,
STAYOVER_CHILDREN,
STAYOVER_ROOM,
ARRIVAL_ADULTS,
ARRIVAL_CHILDREN,
ARRIVAL_ROOM,
DEPARTURE_ADULTS,
DEPARTURE_CHILDREN,
DEPARTURE_ROOM,
MULTIPLE_GUEST_ROOM,
DAY_USE_ADULTS,
DAY_USE_CHILDREN,
BOOKINGS_CNT)
 AS 
select RM.BUSY_DATE,
       RM.ID_ROOM_TYPE,
       RM.ID_ROOM,
       RM.ID_HOTEL,
       coalesce(rsp.ID_RESERV_STATISTICS, RS.ID_RESERV_STATISTICS, RM.ID_RESERV_DETAIL),
       coalesce(rs.BUSY_GROUP_TYPE, rm.BUSY_GROUP_TYPE),
       coalesce(rsp.BUSY_TYPE, rs.BUSY_TYPE, rm.BUSY_TYPE),
       coalesce(rsp.ID_AGENT, rs.ID_AGENT, rm.ID_AGENT),
       -- blocks
       count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 18 and coalesce(RS.DAY_ACTION, RM.DAY_ACTION) not containing 'CHECK_OUT', RM.ID_ROOM, null)),
       count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 20 and coalesce(RS.DAY_ACTION, RM.DAY_ACTION) not containing 'CHECK_OUT', RM.ID_ROOM, null)),
       -- stayovers
       sum(iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.GST_AD_STAY, 0)),
       sum(iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.GST_CH_STAY, 0)),
       count(distinct iif(coalesce(RS.DAY_ACTION, RM.DAY_ACTION) = 'STAY' and coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.ID_ROOM, null)),
       -- arrivals
       sum(iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.GST_AD_IN, 0)),
       sum(iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.GST_CH_IN, 0)),
       count(distinct iif(coalesce(RS.DAY_ACTION, RM.DAY_ACTION) = 'CHECK_IN' and coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.ID_ROOM, null)),
       -- departures
       sum(iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.GST_AD_OUT, 0)),
       sum(iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.GST_CH_OUT, 0)),
       count(distinct iif(coalesce(RS.DAY_ACTION, RM.DAY_ACTION) = 'CHECK_OUT' and coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (1, 24), RM.ID_ROOM, null)),
       -- multiple guest rooms
       count(distinct iif((coalesce(RS.DAY_ACTION, RM.DAY_ACTION) in ('STAY', 'CHECK_IN'))
                          and (RM.ADULT_COUNT+RM.CHILDREN_COUNT > 1)
                          and coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 24, RM.ID_ROOM, null)),
       -- daily uses
       sum(iif(RM.DAY_ACTION = 'CHECK_IN,CHECK_OUT', RM.ADULT_COUNT, 0)),
       sum(iif(RM.DAY_ACTION = 'CHECK_IN,CHECK_OUT', RM.CHILDREN_COUNT, 0)),
       -- bookings count
       count(distinct iif((coalesce(RS.DAY_ACTION, RM.DAY_ACTION) in ('STAY', 'CHECK_IN'))
                          and coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 24, RM.ID_RESERV_DETAIL, null))
from   ROOM_MAGIC RM
       left outer join RESERV_DETAIL rd on rd.id_reserv_detail = rm.id_reserv_detail
       left outer join ROOMS_SHARE RS on RS.ID_ROOM_SHARE = RM.ID_ROOM_MAGIC
       left outer join ROOMS_SHARE rsp on rsp.BUSY_DATE = (rm.BUSY_DATE - 1) and rsp.ID_RESERV_DETAIL = rm.ID_RESERV_DETAIL and rm.DAY_ACTION = 'CHECK_OUT' -- because of missed share on check_out date
where  rm.ROOM_STATUS is distinct from 'PRIVATE'  -- only hotel rooms occupancy
group by 1, 2, 3, 4, 5, 6, 7, 8
;

/* Create view: OWNER_POST_INVOICED */
CREATE VIEW OWNER_POST_INVOICED(
ID_DOC,
DATE_POST,
ROOM_NAME,
LINE_DESC,
POST_VALUE,
POST_CURR,
IS_ANUL,
IS_INVOICED,
ID_ACCOUNT_POST,
ID_BILL,
BILLING_INFO,
ID_OWNER,
ID_ROOM,
ID_SERVICE,
INV_DESCRIPTION,
DEVICE_READING_INFO,
ID_EXPORT_HEAD,
ID_ACCOUNT,
ID_HOTEL)
 AS 
select
      DL.ID_DOC_HEAD,
      DL.DATE_POST,
      DL.ROOM_NAME,
      DL.LINE_NAME,
      cast(DL.QTY_POST * PV.ACCOUNT_PRICE as numeric(15,4)),
      AP.CURR_POST,
      cast(iif(DH.IS_ANUL = 1, 1, coalesce(BH.IS_ANUL, 0)) as smallint),
      cast(substring(AP.AC from 2 for 1) as  smallint),
      AP.ID_ACCOUNT_POST,
      BR.ID_OWNER_BILL,
      cast(substring(coalesce(BH.BILL_NUM||', '||formatdate(BH.BILL_DATE,'D;dd/mm/yyyy'), '') from 1 for 100) as varchar(100)),
      ACC.ID_PROFILE,
      E.ID_ROOM,
      AP.ID_SERVICE,
      cast(substring(DT.DOC_TYPE_NAME || ' ' || DH.DOC_NUM || ', ' || formatdate(DH.DOC_DATE,'D;dd/mm/yyyy') from 1 for 100) as varchar(100)) as doc_descr,
      (select cast(substring(list(DR.ID_DEVICE_READING || ', ' || coalesce(formatdate(DR.DATE_READ, 'dd/mm/yyyy'), ''), '/ ') from 1 for 300) as  varchar(300))
       from   DEVICE_READING_POST DRP
              join DEVICE_READING_EVIDENCE DRE on DRE.ID_DEVICE_READING_EVIDENCE = DRP.ID_DEVICE_READING_EVIDENCE
              join DEVICE_READING DR on DR.ID_DEVICE_READING = DRE.ID_DEVICE_READING
       where  DRP.ID_ACCOUNT_POST = ap.ID_ACCOUNT_POST),
      E.ID_EXPORT_HEAD,
      acc.ID_ACCOUNT,
      acc.ID_HOTEL
from  ACCOUNT_POST AP
      join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
      join PMS_EVENT$PMS E on E.ID_PMS_EVENT = PP.ID_PMS_EVENT
      join ACCOUNT ACC on ACC.ID_ACCOUNT = AP.ID_ACCOUNT
      join OWNER$PMS O on O.ID_OWNER = ACC.ID_PROFILE
      join DOC_LINE_POST_VALUES PV on AP.ID_ACCOUNT_POST = PV.ID_ACCOUNT_POST
      join DOC_LINE DL on PV.ID_DOC_LINE = DL.ID_DOC_LINE
      join DOC_HEAD DH on DH.ID_DOC = DL.ID_DOC_HEAD
      join DOC_TYPE DT on DT.ID_DOC_TYPE = DH.ID_DOC_TYPE  
      left outer join OWNER_BILL_ROW$PMS BR on BR.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
      left outer join OWNER_BILL$PMS BH on BH.ID_OWNER_BILL = BR.ID_OWNER_BILL
;


COMMENT ON COLUMN ENA_ACCOUNT.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_ACCOUNT.ID_ACCOUNT IS
'  . .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_NAME IS
'   .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_EXT_CODE IS
'             .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ID IS
'         . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_NAME IS
'    .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ACCOUNT_NO IS
'             .  -    .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_TYPE IS
'       .  : AGENT -  , PERSON -  , HOUSE -    . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_HOUSE_TYPE IS
'      (PROFILE_TYPE = ''HOUSE''),    -.  : hptExternalClient -          ( ,      ); hptExternalRevenue -                (,   ..); hptComplimentary -           ,  ,        . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_HOTEL IS
'       .  ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_ACCOUNT_POST_HISTORY IS
'   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_ACCOUNT IS
'      .  ENA_ACCOUNT.ID_ACCOUNT. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_SERVICE IS
'   .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_SALE_TAXATION IS
'         .       . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.SYSTEM_DATE IS
'    / . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_DATE IS
'        (). .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_CURR IS
'  . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_AMOUNT IS
'    (   )    . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.NAT_NET_VALUE IS
'    ( )   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.NAT_GROSS_VALUE IS
'    ( )   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_TYPE IS
'  . BASE -  ; ADD_INS -  - ,    ; EXTRA -     ,     ; TAX -            ,     .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_GUEST IS
'       .  ENA_GUEST.ID_GUEST.        : 1.    "  "; 2.           ; 3.        ,      . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_GROUP IS
'       .    : ''ROOMS'', ''Food and Beverage'', ''Other Operated Departments'', ''Rentals and Other Income''. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_ACCOUNT IS
' -      .    . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_SUB_ACCOUNT IS
' --      . ,     -. .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.ID_HOTEL IS
'   ,    . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.ID_DOC_HEAD IS
'        .  ENA_DOC_HEAD_ADVANCE.ID_DOC. .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.SYSTEM_DATE IS
'      . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAYMENT_DATE IS
'     . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.SRC_ID_ACCOUNT IS
'   . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.DEST_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAY_AMOUNT IS
' .        . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAY_CURRENCY IS
' . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.USER_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.DATETIME_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_HOTEL IS
'   ,    . .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_DEPOSIT_PAYMENT IS
'  .         . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_DATE IS
'        .            . .';

COMMENT ON COLUMN ENA_DEPOSIT.SYSTEM_DATE IS
'   .         PAYMENT_DATE.        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_NUM IS
'           .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_DIRECTION IS
'0 -   , 1 -   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_TYPE_NAME IS
'       .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_ACCOUNT IS
'        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_AMOUNT IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DEPOSIT.IS_ANUL IS
'   . 0 - , 1 - .           /    .     IS_ANUL = 0,    1.           ID_DEPOSIT.  .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_CREATED IS
'     .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_CREATED IS
'       . .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_ANNUL IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_ANNUL IS
'     .  .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.ID_HOTEL IS
'       .  .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.ID_DEPOSIT_PAYMENT IS
'   ,   .  ENA_DEPOSIT.ID_DEPOSIT_PAYMENT. .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SYSTEM_DATE IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAYMENT_DATE IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SRC_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DEST_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAY_AMOUNT IS
' .        . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAY_CURRENCY IS
' . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.USER_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DATETIME_CREATED IS
'     . .';

COMMENT ON VIEW ENA_DOC_DEPOSIT_CONSUMPTION IS
' !!!!!!    ID_DOC_TYPE - za mapowe.';


COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.DOC_TYPE_NAME IS
'       . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_NUM IS
'         .  .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_DATE IS
'      .          . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_VALUE IS
'         . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_DOC_RATE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.EQUAL_DOC_VALUE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.NAT_VALUE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.ID_DEPOSIT_PAYMENT IS
'      (  ENA_DEPOSIT.ID_DEPOSIT_PAYMENT ). .';

COMMENT ON VIEW ENA_DOC_HEAD_ADVANCE IS
'!      ';


COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC IS
'  .             .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_ADVANCE.ID_DOC.  .     - , ..       ,      - .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SUB_TYPE IS
'   . ,  : 0 - / , 1 -  ,  , 2 -  ,  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_NAME IS
'    . ,       .              .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_DESCRIPTION IS
'   .         .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_NUM IS
'   ,        .      . ,     ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DATE IS
'        . .    SYSTEM_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.IS_ANUL IS
'        . . 0 - , 1 - .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TOTAL_VALUE IS
' (, )       . .      .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ONE_LINE_TEXT IS
' ,         .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURR_RATE IS
'   ()    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_POST_ADDRESS IS
'    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_ZIP_CODE IS
'     ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_MOL IS
'    ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_RECIPIENT_NAME IS
'     ()';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BANK_NAME IS
'  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BIC IS
'BIC  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IBAN IS
'IBAN  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_EMAIL IS
'email  .        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SUPPLIER_SEND_NAME IS
'     .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ACCOUNT_ID IS
'        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC IS
'  .             .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_SERVICE.ID_DOC.     - , ..       ,      - .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC_TYPE IS
'    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SUB_TYPE IS
'   .  : 0 - / , 1 -  ,  , 2 -  ,  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_NAME IS
'    .              .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_DESCRIPTION IS
'   .         .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_NUM IS
'   ,        .      .  -       ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DATE IS
'        .    SYSTEM_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.IS_ANUL IS
'        . 0 - , 1 - .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_CURRENCY IS
'  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TOTAL_VALUE IS
' (, )       .      .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ONE_LINE_TEXT IS
' ,         .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURR_RATE IS
'   ()    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_DATE IS
'   ,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_NUM IS
'  -,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_POST_ADDRESS IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_ZIP_CODE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_MOL IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_RECIPIENT_NAME IS
'     (). .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BANK_NAME IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BIC IS
'BIC  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IBAN IS
'IBAN  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_EMAIL IS
'email  .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SUPPLIER_SEND_NAME IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ACCOUNT_ID IS
'        .    ENA_ACCOUNT.ID_ACCOUNT. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

/* Alter View (Drop, Create)... */
/* Drop altered view: ENA_DOC_LINE_ADVANCE */
DROP VIEW ENA_DOC_LINE_ADVANCE;

/* Create altered view: ENA_DOC_LINE_ADVANCE */
/* Create view: ENA_DOC_LINE_ADVANCE */
CREATE VIEW ENA_DOC_LINE_ADVANCE(
ID_DOC_HEAD,
ID_SERVICE,
ID_SALE_TAXATION,
TAXATION_NAME,
TAXATION_ACCOUNT_NAME,
VAT_PERCENT,
QTY_POST,
SINGLE_VALUE,
SINGLE_WOT_VAT,
WOT_VAT,
LINE_NAME,
DATE_POST,
NAT_NET_VALUE,
NAT_GROSS_VALUE,
SEC_CURR_NET_VALUE,
SEC_CURR_GROSS_VALUE,
ID_DOC_ADVANCE_REFERENCE)
 AS 
select
    dl.ID_DOC_HEAD,
    dl.ID_SERVICE,
    dl.ID_SALE_TAXATION,
    st.NAME,
    st.ACCOUNT_NAME,
    dl.VAT_PERCENT,
    dl.QTY_POST,
    dl.SINGLE_VALUE,
    dl.SINGLE_WOT_VAT,
    dl.WOT_VAT,
    dl.LINE_NAME,
    dl.DATE_POST,
    dl.NAT_NET_VALUE,
    dl.NAT_GROSS_VALUE,
    dl.SEC_CURR_NET_VALUE,
    dl.SEC_CURR_GROSS_VALUE,
    (select p.ID_DOC_HEAD
     from   DEPOSIT d
            join PAYMENT_HEAD p on p.ID_PAYMENT_HEAD = d.ID_PAYMENT_HEAD and p.ID_DOC_HEAD is distinct from dh.ID_DOC
     where  d.ID_DEPOSIT = dv.ID_DEPOSIT
            and dh.FOR_DEPOSIT = 0)
from DOC_LINE dl
     join DOC_HEAD dh on dh.ID_DOC = dl.ID_DOC_HEAD
     join SALE_TAXATION st on st.ID_SALE_TAXATION = dl.ID_SALE_TAXATION
     join ACCOUNT A on a.ID_ACCOUNT = dh.ID_ACCOUNT
     join DOC_LINE_DEP_VALUES dv on dv.ID_DOC_LINE = dl.ID_DOC_LINE
;

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_SERVICE IS
'     .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.DATE_POST IS
'    . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_SERVICE IS
'      .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_SERVICE IS
'   .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.IS_CORRECT IS
'            .      1,        . 0 -   ; 1 -      0. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_GUEST IS
'   ,        .    null,       ''  ''     .    ENA_GUEST.ID_GUEST. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.DATE_POST IS
'        .    ,    . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ROOM_NAME IS
'       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ACCOUNT_PRICE IS
'         /.             /. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_SERVICE IS
'    (, , , ,  ).  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_SALE_TAXATION IS
'         .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON VIEW ENA_DOC_PAYMENT IS
'   ,     .';


COMMENT ON COLUMN ENA_DOC_PAYMENT.ID_DOC_HEAD IS
'  ( ENA_DOC_HEAD.ID_DOC)      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DOC_TYPE_NAME IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_NUM IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_DATE IS
'     .        ,                 . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_CURRENCY IS
'  .        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DUE_DATE IS
'       .          ,      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_VALUE IS
'           . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_DOC_RATE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.EQUAL_DOC_VALUE IS
'      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.NAT_VALUE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.ID_DOC_HEAD IS
'         . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNT_VALUE IS
'      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNTABLE_VALUE IS
'  .       . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.IS_PERCENT_DISCOUNT IS
'  .         . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.FIXED_DISCOUNT_CURRENCY IS
'  .       -     . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNT_PERCENT_OR_AMOUNT IS
'  .       . .';

COMMENT ON COLUMN ENA_DOC_TAX.ID_DOC_HEAD IS
'         ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_TAX.ID_SALE_TAX IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.NONTAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_VALUE IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_NAME IS
'  .  -        .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_PERCENT IS
'   ().  .';

COMMENT ON COLUMN ENA_DOC_TAX.FISCAL_CODE IS
' .        .  -      .';

COMMENT ON COLUMN ENA_DOC_TAX.ACCOUNT_NAME IS
' .              . .';

COMMENT ON COLUMN ENA_GUEST.ID_GUEST IS
'   ( )   . .';

COMMENT ON COLUMN ENA_GUEST.ID_RESERV_DETAIL IS
'        ( ENA_RESERV_DETAIL.ID_RESERV_DETAIL). .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME2 IS
'      . .';

COMMENT ON COLUMN ENA_GUEST.IS_CHILD IS
'   . 0 - ; 1 - . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE IS
'    . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_TEXT IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.RATING_AGE IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.COUNTRY_CODE IS
'    .        ISO. .';

COMMENT ON COLUMN ENA_GUEST.MASK IS
'  .         . .';

COMMENT ON COLUMN ENA_HOTEL.ID_HOTEL IS
'  . .';

COMMENT ON COLUMN ENA_HOTEL.HOTEL_NAME IS
'  . .';

COMMENT ON COLUMN ENA_HOTEL.CODE IS
'   . .';

COMMENT ON COLUMN ENA_HOTEL.SYSTEM_DATE IS
'     .                  ENA.                . .';

COMMENT ON COLUMN ENA_HOTEL.IS_USE IS
'    (  ). 0 -   , 1 -  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_RESERV_DETAIL IS
'   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NUMBER IS
'  .    (   ). .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_GUEST_MAIN IS
'      .      .  -     .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME IS
'    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME2 IS
'       . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.FROM_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.TO_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NIGHTS IS
'. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ADULT_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHILD_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_EATING_OBJECT IS
'          . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHECK_STATUS IS
'  . -3 =  ; -2 =   ; -1 =  ; 0 =  ; 1 =  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.IS_ANUL IS
'   . 0 - , 1 - .  -       0  1.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ID IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_NAME IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_TYPE IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ACCOUNT_NO IS
'             .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SEGMENT_CODE IS
'   ''segment''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SOURCE_CODE IS
'   ''source''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_CHANNEL_CODE IS
'   ''channel''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_HEAR_CODE IS
'   ''hear reason''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_COME_CODE IS
'   ''come reason''.   . .';

COMMENT ON COLUMN ENA_SERVICES.ID_HOTEL IS
'       . .';

COMMENT ON COLUMN ENA_SERVICES.ID_SERVICE IS
'   . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_NAME IS
'  . .';

COMMENT ON COLUMN ENA_SERVICES.GROUP_NAME IS
'    .            a       . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_TYPE IS
'  .  : ''BASE'',''EXTRA'',''COMMISSION'',''MEAL''. ''BASE'' -    ,     ,''EXTRA'' -  , ''MEAL'' - , ''COMMISSION'' - ,        (  ). .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_GROUP IS
'       .  : ''ROOMS'', ''Food and Beverage'', ''Other Operated Departments'', ''Rentals and Other Income''. .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_ACCOUNT IS
' -      . .';

COMMENT ON COLUMN ENA_SERVICES.ACCOUNT_NAME IS
'      (. ),      .          . .';

COMMENT ON COLUMN ENA_SERVICES.EXT_CODE IS
'         . .';

COMMENT ON COLUMN ENA_SERVICES.IS_BREAKFAST IS
'   . 0 - , 1 - .    1,   SERVICE_TYPE e ''BASE''  ''MEAL''.  -          .';

COMMENT ON COLUMN ENA_SERVICES.IS_LUNCH IS
'   .   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_DINNER IS
'   .   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_EXTRAFOOD1 IS
'     1.   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_EXTRAFOOD2 IS
'     2.   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.ID_ROOM_TYPE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ). .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  -             .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM_EXT_CODE IS
'    ( )     ,      .  -        .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_STAY_CODE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  : ''ALONE'' -      , ''BED'' -            , ''EXTRA_BED'' -      . .';

COMMENT ON COLUMN OWNER_POST.POST_STATUS IS
'11  
22  ';

/* Drop altered view: ROOM_EXIST_PERIOD */
SET TERM ^ ;

ALTER PROCEDURE ROOM_SMART_FILTER$INT(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(20),
RESTRICT_CLEANING INTEGER,
SUPPRESS_PRIVATE SMALLINT = 1)
 RETURNS(ROOM_NAME VARCHAR(50),
BEDS INTEGER,
EXTRA_BEDS INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
IS_CLEAN INTEGER,
FLOOR INTEGER,
CLEAN_TEXT VARCHAR(20),
FEATURES BLOB,
SYS_DATE DATE)
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP VIEW ROOM_EXIST_PERIOD;

/* Create altered view: ROOM_EXIST_PERIOD */
/* Create view: ROOM_EXIST_PERIOD */
CREATE VIEW ROOM_EXIST_PERIOD(
ID_ROOM,
FROM_DATE,
TO_DATE)
 AS 
select P.ID_ROOM,
       min(P.FROM_DATE),
       max(P.TO_DATE)
from   ROOM_PERIOD$PMS P
group by 1
;

/* Create index... */
CREATE INDEX AR_OWING_DATE_IDX ON AR_OWING(SYSTEM_DATE);

CREATE INDEX AR_PAYMENT_DATE_IDX ON AR_PAYMENT(DATE_PAYMENT);


/* Create generator... */
CREATE GENERATOR GEN_HOTEL_PAYPAL_CFG$WBE_ID;

CREATE GENERATOR GEN_ID_PRATE_MAP;


/* Create Primary Key... */
ALTER TABLE EXT_PRATE_EXPORT_MAP ADD CONSTRAINT PK_EXT_PRATE_EXPORT_MAP PRIMARY KEY (ID_PRATE_MAP);

ALTER TABLE EXT_PRATE_HOTEL_MAP ADD CONSTRAINT PK_EXT_PRATE_HOTEL_MAP PRIMARY KEY (ID_HOTEL);

ALTER TABLE EXT_PRATE_MAP ADD CONSTRAINT PK_EXT_PRATE_MAP PRIMARY KEY (ID_PRATE_MAP);

ALTER TABLE HOTEL_PAYPAL_CFG$WBE ADD CONSTRAINT PK_HOTEL_PAYPAL_CFG$WBE PRIMARY KEY (ID);

/* Create Unique... */
ALTER TABLE EXT_PRATE_MAP ADD CONSTRAINT UNQ_EPRM_HOTEL_CODE_TYPE_EXP UNIQUE (ID_HOTEL, OBJECT_TYPE, EXTERNAL_CODE, IS_EXPORT);

ALTER TABLE ROOM_MAGIC ADD CONSTRAINT UNQ_RM_RESERV_BUSY_DATE UNIQUE (ID_RESERV_DETAIL, BUSY_DATE);

ALTER TABLE SUMMARY_OCCUPANCY ADD CONSTRAINT UNQ_SUMMARY_OCCUPANCY UNIQUE (ID_ROOM_TYPE, FOR_DATE);

/* Create Foreign Key... */
RECONNECT;

ALTER TABLE AR_OWING_PAYMENT_POST ADD CONSTRAINT FK_AROPP_PROFILE FOREIGN KEY (ID_PROFILE) REFERENCES PROFILE (ID_PROFILE) ON UPDATE CASCADE;

ALTER TABLE AR_PAYMENT ADD CONSTRAINT FK_ARP_PAYMENT_TYPE FOREIGN KEY (ID_AR_PAYMENT_TYPE) REFERENCES AR_PAYMENT_TYPE (ID_AR_PAYMENT_TYPE) ON UPDATE CASCADE;

ALTER TABLE EXT_PRATE_EXPORT_MAP ADD CONSTRAINT FK_EPREM_EXT_PRATE_MAP FOREIGN KEY (ID_PRATE_MAP) REFERENCES EXT_PRATE_MAP (ID_PRATE_MAP) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE EXT_PRATE_HOTEL_MAP ADD CONSTRAINT FK_EPRHM_HOTEL FOREIGN KEY (ID_HOTEL) REFERENCES HOTEL (ID_HOTEL);

ALTER TABLE EXT_PRATE_MAP ADD CONSTRAINT FK_EPRM_HOTEL FOREIGN KEY (ID_HOTEL) REFERENCES HOTEL (ID_HOTEL);

ALTER TABLE HOTEL_PAYPAL_CFG$WBE ADD CONSTRAINT FK_HOTEL_PAYPAL_CFG$WBE_1 FOREIGN KEY (HOTEL_ID) REFERENCES HOTEL (ID_HOTEL);

/*  Empty DOCUMENT_ANUL$DOC for DOCUMENT_AR_PAYMENTS_APPLY$INT(param list change)  */
SET TERM ^ ;

ALTER PROCEDURE DOCUMENT_ANUL$DOC(ID_DOC_HEAD INTEGER,
ANUL_REASON VARCHAR(100),
MAKE_ANNUL_REPORT SMALLINT)
 AS
 BEGIN EXIT; END
^

/*  Empty DOCUMENT_DELETE$DOC for DOCUMENT_AR_PAYMENTS_APPLY$INT(param list change)  */
ALTER PROCEDURE DOCUMENT_DELETE$DOC(ID_DOC_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/*  Empty DOCUMENT_VALIDATE$DOC for DOCUMENT_AR_PAYMENTS_APPLY$INT(param list change)  */
ALTER PROCEDURE DOCUMENT_VALIDATE$DOC(ID_DOC_HEAD /* TYPE OF ID_REF */ INTEGER)
 RETURNS(FIRM_DATA /* TYPE OF TNOTE_BLOB */ BLOB SUB_TYPE 1,
WARN_CODE /* TYPE OF TRANGE */ INTEGER,
NEW_DOC_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/*  Empty IMPORT_AGENT_PROFILE$EXC for LOOKUP_CONTRAGENT$EXC(param list change)  */
ALTER PROCEDURE IMPORT_AGENT_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
AGENT_GROUP VARCHAR(50),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
WBE_PASSWORD VARCHAR(20),
IATA_NUMBER VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
DEF_CONTRAGENT_NAME VARCHAR(100),
THRESHOLD_NOTE VARCHAR(255),
THRESHOLD_AMOUNT NUMERIC(15,4),
THRESHOLD_CURR CHAR(3),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
 BEGIN SUSPEND; END
^

/*  Empty IMPORT_PERSON_PROFILE$EXC for LOOKUP_CONTRAGENT$EXC(param list change)  */
ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure AR_POST_FINALIZE with new param-list */
ALTER PROCEDURE AR_POST_FINALIZE(OPERATION VARCHAR(10))
 AS
 BEGIN EXIT; END
^

/* Alter empty procedure DOCUMENT_AR_PAYMENTS_APPLY$INT with new param-list */
ALTER PROCEDURE DOCUMENT_AR_PAYMENTS_APPLY$INT(DOC_DBKEY CHAR(8),
OPERATION_INFO VARCHAR(100) = null)
 AS
 BEGIN EXIT; END
^

/* Alter empty procedure LOOKUP_CONTRAGENT$EXC with new param-list */
ALTER PROCEDURE LOOKUP_CONTRAGENT$EXC(OBJECT_ID VARCHAR(100),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(100))
 RETURNS(ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter Procedure... */
/* Alter (ACC_STATEMENT_GET_INFO$PMS) */
ALTER PROCEDURE ACC_STATEMENT_GET_INFO$PMS(FROM_DATE DATE,
TO_DATE DATE,
ID_SERVICE_HL_LIST VARCHAR(255))
 RETURNS(ID_BILL INTEGER,
ID_DOC INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
POST_DATE DATE,
ID_ROOM INTEGER,
ID_OWNER INTEGER,
ROOM_INFO VARCHAR(30),
OWNER_NAME VARCHAR(100),
BILLING_INFO VARCHAR(100),
ID_SERVICE INTEGER,
SERVICE_DESC VARCHAR(100),
DESCRIPTION VARCHAR(300),
REF_DOC_INFO VARCHAR(300),
DEVICE_READING_INFO VARCHAR(300),
INCOME_VALUE NUMERIC(15,4),
INCOME_CURR VARCHAR(3),
OUTGO_VALUE NUMERIC(15,4),
OUTGO_CURR VARCHAR(3),
IS_ANUL SMALLINT,
IS_INVOICED SMALLINT,
ID_EXPORT_HEAD INTEGER)
 AS
declare variable info_delim varchar(3);
  declare variable curr_format varchar(20);
  declare variable res_period_delim varchar(3);
  declare variable short_date_format varchar(20);
  declare variable doc_description varchar(255);
  declare variable id_doc_head integer;
  declare variable id_service_hl_list_found varchar(255);
  declare variable description_event varchar(255);
  declare variable res_number varchar(62);
  declare variable res_from_date date;
  declare variable res_to_date date;
  declare variable res_stay integer;
  declare variable curr_id_room integer;
  declare variable curr_id_owner integer;
begin
  info_delim = '/ ';
  curr_format = 'F;#.00';
  short_date_format = 'D;dd.mm';
  res_period_delim = '-';

  for
    select T.ID_ROOM, T.ID_OWNER
    from   TMP_SELECT$PMS T
    where  T.ID_SESSION = current_transaction
    into   :curr_id_room, :curr_id_owner
  do begin
    id_service_hl_list_found = ',';
    id_doc = null;
    for
      select BH.ID_OWNER_BILL, BR.DATE_POST, BR.ID_ROOM, coalesce(H.CODE, '')||:info_delim||R.ROOM_NAME,
             coalesce(BH.BILL_NUM||', '||formatdate(BH.BILL_DATE,'D;dd/mm/yyyy'), ''), BH.ID_OWNER, P.PROFILE_NAME,
             S.ID_SERVICE, S.SERVICE_NAME, BR.DESCRIPTION, BR.DOC_DESCRIPTION,
             iif(BR.IS_OWNER_INCOME = 1, BR.VALUE_POST, null) as INCOME,
             iif(BR.IS_OWNER_INCOME = 1, BR.CURR_POST, null) as IN_CURR,
             iif(BR.IS_OWNER_INCOME = 0, BR.VALUE_POST, null) as OUTGO,
             iif(BR.IS_OWNER_INCOME = 0, BR.CURR_POST, null) as OUT_CURR, BH.IS_ANUL,
             iif(BR.ID_ACCOUNT_POST is not null, 1, null) as IS_INVOICED,
             RD.NUMBER, PEP.IMP_PERIOD_FROM, PEP.IMP_PERIOD_TO + 1, PEP.IMP_PERIOD_TO - PEP.IMP_PERIOD_FROM + 1,
             BR.ID_ACCOUNT_POST, BR.ID_ACCOUNT_POST_PMS, PEP.ID_EXPORT_HEAD
      from   OWNER_BILL$PMS BH
             left outer join OWNER_BILL_ROW$PMS BR on BH.ID_OWNER_BILL = BR.ID_OWNER_BILL
                                                      and BR.ID_ACCOUNT_POST_PMS is not null
             join PROFILE P on P.ID_PROFILE = BH.ID_OWNER
             left outer join ROOMS R on R.ID_ROOM = BR.ID_ROOM
             left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
             left outer join HOTEL H on H.ID_HOTEL = RT.ID_HOTEL
             left outer join SERVICES S on S.ID_SERVICE = BR.ID_SERVICE
             left outer join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = BR.ID_RESERV_DETAIL
             left outer join ACCOUNT_POST$PMS APP on APP.ID_ACCOUNT_POST = BR.ID_ACCOUNT_POST_PMS
             left outer join PMS_EVENT$PMS PEP on PEP.ID_PMS_EVENT = APP.ID_PMS_EVENT
      where  BH.BILL_DATE between coalesce(:from_date, '01.01.1500') and coalesce(:to_date, '01.01.2500')
             and ((:curr_id_room is null) or (BR.ID_ROOM = :curr_id_room))
             and ((:curr_id_owner is null) or (BH.ID_OWNER = :curr_id_owner))
      into   :ID_BILL, :POST_DATE, :ID_ROOM, :ROOM_INFO, :BILLING_INFO, :ID_OWNER, :OWNER_NAME,
             :ID_SERVICE, :SERVICE_DESC, :DESCRIPTION_EVENT, :DOC_DESCRIPTION,
             :INCOME_VALUE, :INCOME_CURR, :OUTGO_VALUE, :OUTGO_CURR, :IS_ANUL, :IS_INVOICED,
             :res_number, :RES_FROM_DATE, :RES_TO_DATE, :RES_STAY,
             :ID_ACCOUNT_POST, :ID_ACCOUNT_POST_PMS, :ID_EXPORT_HEAD
    do begin
      DESCRIPTION = '';
      ref_doc_info = null;
      for
        select ITEM
        from   SYSTEM_STRING_PARSER(:doc_description,',')
        into   :id_doc_head
      do begin
        select coalesce(:ref_doc_info||'; ','')||DH.DOC_NUM||:info_delim||formatfloat(DH.DOC_VALUE, :curr_format)||' '||DH.DOC_CURRENCY
        from   DOC_HEAD DH
        where  DH.ID_DOC = :id_doc_head
        into   :ref_doc_info;
      end

      select substring(list(DR.ID_DEVICE_READING || ', ' || coalesce(formatdate(DR.DATE_READ, 'dd/mm/yyyy'), ''), :info_delim) from 1 for 300)
      from   DEVICE_READING_POST DRP
             join DEVICE_READING_EVIDENCE DRE on DRE.ID_DEVICE_READING_EVIDENCE = DRP.ID_DEVICE_READING_EVIDENCE
             join DEVICE_READING DR on DR.ID_DEVICE_READING = DRE.ID_DEVICE_READING
      where  DRP.ID_ACCOUNT_POST$PMS = :id_account_post_pms
      into   :device_reading_info;
  
      DESCRIPTION = :res_number||', '
                  ||formatdate(:res_from_date,:short_date_format)||:res_period_delim||:res_stay||:res_period_delim||formatdate(:res_to_date,:short_date_format);
      DESCRIPTION = coalesce(:DESCRIPTION, '');
      DESCRIPTION = iif(:DESCRIPTION = '', :DESCRIPTION, :DESCRIPTION||', ')||coalesce(:DESCRIPTION_EVENT, '');

      if (trim(coalesce(:ID_SERVICE_HL_LIST, '')) = '') then begin
        suspend;
      end else begin
        if (:ID_SERVICE_HL_LIST containing :ID_SERVICE) then begin
          if (:ID_SERVICE_HL_LIST_FOUND not containing :ID_SERVICE and :is_anul = 0) then begin
            id_service_hl_list_found = :id_service_hl_list_found ||:id_service|| ',';
          end
          suspend;
        end
      end
    end

    REF_DOC_INFO = '';
    ID_ACCOUNT_POST_PMS = null;
    INCOME_VALUE = null;
    INCOME_CURR = null;
    DESCRIPTION = '';
    for
      select AP.INV_DESCRIPTION, AP.BILLING_INFO, AP.ID_ACCOUNT_POST, AP.DATE_POST,
             AP.ID_OWNER, AP.ID_ROOM, coalesce(H.CODE, '')||:info_delim||R.ROOM_NAME, P.PROFILE_NAME, AP.ID_SERVICE,
             AP.LINE_DESC,
             round_f(AP.POST_VALUE * iif(ap.POST_CURR = o.ID_CURRENCY, 1, (select cr.RATE
                                                                           from   CURR_CROSS_RATE_GET (ap.POST_CURR, o.ID_CURRENCY, ap.DATE_POST, ap.ID_HOTEL) cr)), c.ROUND_TO),
             o.ID_CURRENCY, AP.IS_ANUL, AP.IS_INVOICED,
             AP.ID_BILL, AP.ID_DOC, AP.DEVICE_READING_INFO, AP.ID_EXPORT_HEAD
      from   OWNER_POST_INVOICED Ap
             join OWNER$PMS o on o.ID_OWNER = ap.ID_OWNER
             join CURRS c on c.CURR = o.ID_CURRENCY
             left outer join ROOMS R on R.ID_ROOM = AP.ID_ROOM
             left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
             left outer join HOTEL H on H.ID_HOTEL = RT.ID_HOTEL
             join PROFILE P on P.ID_PROFILE = AP.ID_OWNER
      where  AP.DATE_POST between coalesce(:FROM_DATE, '01.01.1500') and coalesce(:TO_DATE, '01.01.2500')
             and ((:curr_id_room is null) or (AP.ID_ROOM = :curr_id_room))
             and ((:curr_id_owner is null) or (AP.ID_OWNER = :curr_id_owner))
      into   :REF_DOC_INFO, :BILLING_INFO, :ID_ACCOUNT_POST, :POST_DATE,
             :ID_OWNER, :ID_ROOM, :ROOM_INFO, :OWNER_NAME, :ID_SERVICE,
             :SERVICE_DESC, :OUTGO_VALUE, :OUTGO_CURR, :IS_ANUL, :IS_INVOICED,
             :ID_BILL, :ID_DOC, :DEVICE_READING_INFO, :ID_EXPORT_HEAD
    do begin
      if (trim(coalesce(:ID_SERVICE_HL_LIST, '')) = '') then
        suspend;
      else begin
        if (:ID_SERVICE_HL_LIST containing :ID_SERVICE) then begin
          if (:ID_SERVICE_HL_LIST_FOUND not containing :ID_SERVICE and :is_anul = 0) then begin
            id_service_hl_list_found = :id_service_hl_list_found ||:id_service|| ',';
          end
          suspend;
        end
      end
    end
     

    ID_ACCOUNT_POST = null;
    ID_ACCOUNT_POST_PMS = null;
    ID_BILL = null;
    POST_DATE = iif(:TO_DATE = '01.01.2500', null, :TO_DATE-1);
    BILLING_INFO = '';
    DESCRIPTION = 'missing service '||iif(:TO_DATE = '01.01.2500', '', ': billing date '||formatdate(:TO_DATE,'D;dd.mm.yy'));
    REF_DOC_INFO = null;
    INCOME_VALUE = null;
    INCOME_CURR = null;
    OUTGO_VALUE = null;
    OUTGO_CURR = null;
    IS_ANUL = 0;
    IS_INVOICED = null;
  
    for
      select ITEM
      from   SYSTEM_STRING_PARSER(:ID_SERVICE_HL_LIST, ',')
      into   :ID_SERVICE
    do begin
      if (:ID_SERVICE_HL_LIST_FOUND not containing (','||:ID_SERVICE||',')) then begin
        id_service_hl_list_found = :id_service_hl_list_found ||:id_service|| ',';
  
        select S.SERVICE_NAME
        from   SERVICES S
        where  S.ID_SERVICE = :ID_SERVICE
        into   :SERVICE_DESC;
  
        suspend;
      end
    end
  end
end
^

/* Alter (ACC_STATEMENT_INVOICES_GET$PMS) */
ALTER PROCEDURE ACC_STATEMENT_INVOICES_GET$PMS(ID_BILL INTEGER)
 RETURNS(ID_DOC INTEGER,
ID_SERVICE INTEGER,
DATE_POST DATE,
ROOM_NAME VARCHAR(100),
LINE_DESC VARCHAR(100),
OUTGO_VALUE NUMERIC(15,4),
CURR_POST VARCHAR(3),
IS_ANUL SMALLINT,
INV_DESCRIPTION VARCHAR(100))
 AS
declare variable id_hotel integer;
  declare variable sign_ smallint;
  declare variable doc_sub_type smallint;
begin

  for
    select distinct DL.ID_DOC_HEAD, DH.DOC_SUB_TYPE, O.ID_CURRENCY,
           DT.DOC_TYPE_NAME || ' ' || DH.DOC_NUM || ', ' || formatdate(DH.DOC_DATE,'D;dd/mm/yyyy'),
           DH.IS_ANUL, B.ID_SERVICE, a.ID_HOTEL
    from   OWNER_BILL_ROW$PMS B
           join OWNER_BILL$PMS BH on BH.ID_OWNER_BILL = B.ID_OWNER_BILL
           join OWNER$PMS O on O.ID_OWNER = BH.ID_OWNER
           join DOC_LINE_POST_VALUES PV on B.ID_ACCOUNT_POST = PV.ID_ACCOUNT_POST
           join DOC_LINE DL on PV.ID_DOC_LINE = DL.ID_DOC_LINE
           join DOC_HEAD DH on DH.ID_DOC = DL.ID_DOC_HEAD
           join ACCOUNT A on A.ID_ACCOUNT = dh.ID_ACCOUNT
           join DOC_TYPE DT on DT.ID_DOC_TYPE = DH.ID_DOC_TYPE
    where  B.ID_OWNER_BILL = :ID_BILL
           and B.ID_ACCOUNT_POST is not null
    into   :id_doc, :doc_sub_type, :CURR_POST, :INV_DESCRIPTION, :IS_ANUL, :ID_SERVICE, :id_hotel
  do begin
    select case when SGV.SETTING_VALUE = 'AS_POSITIVE' and :DOC_SUB_TYPE = 2 then -1 else 1 end
    from   SETTING_GET_VALUE('VIEW_STORNO_SUMS_IN_DOCUMENTS', :id_hotel) SGV
    into   :sign_;

    for
      select
        DL.LINE_NAME,
        DL.ROOM_NAME,
        DL.DATE_POST,
        DL.LINE_VALUE as line_sum
      from
        DOC_LINES_SUSPEND (:ID_DOC, :sign_, '', 'details', 'acc', 'as_doc', 0) DL
      order by
        DL.IS_FOR_PAY asc, DL.DATE_POST, DL.IS_BASE desc, DL.ROOM_NAME, DL.LINE_NAME asc
      into :LINE_DESC,
           :ROOM_NAME,
           :DATE_POST,
           :OUTGO_VALUE
    do begin
      suspend;
    end
  end

end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_ADD$INT for: ACCOUNT_CHECK_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_POSTING_ADD$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_GUEST /* TYPE OF ID_REF */ INTEGER,
ID_SECQUENCE /* TYPE OF ID_REF */ INTEGER,
DATE_POST /* TYPE OF TDATE */ DATE,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_TARIFF /* TYPE OF ID_REF */ INTEGER,
ID_ROOM /* TYPE OF ID_REF */ INTEGER,
IS_BASE /* TYPE OF TLOGICAL */ SMALLINT,
QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
ORIG_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
RATE /* TYPE OF TRATE */ NUMERIC(15,6),
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
CHANGED_TEXT /* TYPE OF TTEXT_SHORT */ VARCHAR(30),
ID_MASTER_ADDINS_ACC_POST /* TYPE OF ID_REF */ INTEGER,
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
NEW_ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE$INT for: ACCOUNT_CHECK_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE$INT(AP_DBKEY /* TYPE OF TDB_KEY */ CHAR(8),
ID_SERVICE /* TYPE OF ID_REF */ INTEGER,
ID_TARIFF /* TYPE OF ID_REF */ INTEGER,
ID_ROOM /* TYPE OF ID_REF */ INTEGER,
QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
QTY_FREE /* TYPE OF TQTY */ NUMERIC(15,2),
PRICE /* TYPE OF TVALUE */ DOUBLE PRECISION,
CURR /* TYPE OF TCURRENCY */ CHAR(3),
RATE /* TYPE OF TRATE */ NUMERIC(15,6),
CHANGED_TEXT VARCHAR(40),
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
IS_CONSEQUENTIAL_UPDATE /* TYPE OF TBOOLEAN */ SMALLINT = 0,
RE_ROUTE_ACCOUNT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(OUT_QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
OUT_PRICE_POST /* TYPE OF TVALUE */ DOUBLE PRECISION,
OUT_AC VARCHAR(2))
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_CHECK_CREDIT_STATUS$INT) */
ALTER PROCEDURE ACCOUNT_CHECK_CREDIT_STATUS$INT(ID_ACCOUNT TYPE OF ID_REF,
POST_VALUE TYPE OF TPRICE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_credit_account integer;
  declare variable id_reserv_detail integer;
  declare variable credit_limit tprice;
  declare variable b_post_sum tprice;
  declare variable b_pay_sum tprice;
  declare variable difference_value tprice;
  declare variable no_use varchar(255);
  declare variable account_currency tcurrency;
  declare variable round_to numeric(15,4);
begin
  if (:POST_VALUE = 0) then exit;

  select a.IS_CREDIT_ACCOUNT, a.CREDIT_LIMIT, a.ID_RESERV_DETAIL
  from   ACCOUNT A
  where  a.ID_ACCOUNT = :ID_ACCOUNT
  into   :is_credit_account, :credit_limit, :id_reserv_detail;

  if (:is_credit_account = 0
      and exists (select rd.ID_RESERV_DETAIL
                  from   RESERV_DETAIL rd
                  where  rd.ID_RESERV_DETAIL = :id_reserv_detail
                         and rd.CHECK_STATUS = 1)) then
  begin
    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, :credit_limit, 1);
  end

  if (coalesce(:credit_limit, 0) > 0) then begin
    /* FIND BALANCE OF ACCOUNT */
    execute procedure ACCOUNT_BALANCE$INT(:id_account)
    returning_values  :account_currency, :round_to, :no_use, :b_post_sum, :b_pay_sum, :no_use, :no_use;
    b_post_sum = coalesce(:b_post_sum, 0);
    b_pay_sum  = coalesce(:b_pay_sum, 0);

    /* IS THIS POST IS IN LIMIT */
    if ((:b_post_sum + :POST_VALUE) > :credit_limit) then begin
      err_code = -13; /*  */
      difference_value = :b_post_sum + :POST_VALUE - :credit_limit;
      err_text = f_character(29)||FormatFloat(:credit_limit, :round_to)||' '||:account_currency||
                 f_character(28)||FormatFloat(:difference_value, :round_to);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: OWNER_ACCOUNT_GET$INT for: ACCOUNT_CREATE_PMS$PMS */
ALTER PROCEDURE OWNER_ACCOUNT_GET$INT(ID_OWNER /* TYPE OF ID */ INTEGER,
ID_HOTEL /* TYPE OF ID */ INTEGER,
IS_SHADOW_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT,
IS_CLIENT_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT)
 RETURNS(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
IS_ACCOUNT$PMS /* TYPE OF TLOGICAL */ SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_OWNER_MODIFY$PMS for: ACCOUNT_CREATE_PMS$PMS */
ALTER PROCEDURE ROOM_OWNER_MODIFY$PMS(ID_ROOM_OWNER INTEGER,
ID_ROOM_CONTRACT INTEGER,
ID_OWNER INTEGER,
OWNERSHIP_PERCENT NUMERIC(15,4),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_OWNER INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_CREATE_PMS$PMS) */
ALTER PROCEDURE ACCOUNT_CREATE_PMS$PMS(ID_OWNER INTEGER,
ID_ACC_TEMPLATE INTEGER,
ID_CURRENCY CHAR(3),
ID_HOTEL INTEGER)
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
declare variable hotel_name varchar(50);
  declare variable account_name varchar(50);
  declare variable is_owner_pool smallint;
  declare variable is_credit_account integer;
  declare variable credit_limit numeric (15,4);
  declare variable sec_level integer;
  declare variable is_pos_allowed integer;
  declare variable id_tax_policy integer;
begin
  -- klientska smetka za pool ne triabwa da se syzdawa!
  select iif(O.ID_RENTAL_POOL_UNIT is null, 0, 1)
  from   OWNER$PMS O
  where  O.ID_OWNER = :ID_OWNER
  into   :is_owner_pool;
  if (:is_owner_pool = 1) then exit;

  select H.HOTEL_NAME
  from   HOTEL H
  where  H.ID_HOTEL = :ID_HOTEL
  into   :hotel_name;
  account_name = substring('Owner account - '||:hotel_name from 1 for 50);

  if (:ID_ACC_TEMPLATE is null) then begin
    select sv.SETTING_VALUE
    from   SETTING_GET_VALUE ('DEF_OWNER_ACC_TEMPLATE', :ID_HOTEL) sv
    into   :id_acc_template;

    if (not exists (select t.ID_ACC_TEMPLATE
                    from   ACC_TEMPLATE t
                    where  t.ID_ACC_TEMPLATE = :ID_ACC_TEMPLATE
                           and t.ID_HOTEL = :ID_HOTEL)) then
    begin
      select sv.SETTING_VALUE
      from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :id_hotel) sv
      into   :id_acc_template;
    end
  end

  is_credit_account = null;
  select ACT.IS_CREDIT_ACCOUNT, ACT.CREDIT_LIMIT, ACT.SECURITY_LEVEL,
         ACT.IS_ALOWED_POS_INTERFACE, ACT.ID_TAX_POLICY
  from   ACC_TEMPLATE ACT
  where  ACT.ID_ACC_TEMPLATE = :id_acc_template
         and act.ID_HOTEL = :id_hotel
  into   :is_credit_account, :credit_limit, :sec_level,
         :is_pos_allowed, :id_tax_policy;

  if (:is_credit_account is null) then exception ACCOUNT_EXCEPTION '-50';

  execute procedure ACCOUNT_MODIFY$INT (null, :ID_OWNER, :ID_CURRENCY, :account_name, 1, :credit_limit,
          null, null, 0, null, :sec_level, 1, 1, :is_pos_allowed, null,
          null, :id_tax_policy, null, :ID_HOTEL, null, 1, 'add')
  returning_values (:NEW_ID_ACCOUNT);
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_BALANCE$INT for: ACCOUNT_CURR_BALANCE$INT */
ALTER PROCEDURE ACCOUNT_BALANCE$INT(ID_ACCOUNT INTEGER,
EW_INCL_ONLY SMALLINT = 0)
 RETURNS(ACCOUNT_CURR CHAR(3),
CURR_DISPLAY_FORMAT VARCHAR(10),
ACCOUNT_BALANCE NUMERIC(15,4),
POST_VALUE NUMERIC(15,4),
DEP_VALUE NUMERIC(15,4),
DEP_MONEY_BAG VARCHAR(255),
OPEN_CHARGES INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_CURR_BALANCE$INT) */
ALTER PROCEDURE ACCOUNT_CURR_BALANCE$INT(ID_ACCOUNT INTEGER,
BALANCE_CURR VARCHAR(3),
EW_INCL_ONLY SMALLINT = 0)
 RETURNS(CURR_ORIG CHAR(3),
POST_ORIG_VALUE NUMERIC(15,4),
POST_BAL_VALUE NUMERIC(15,4),
DEP_ORIG_VALUE NUMERIC(15,4),
DEP_BAL_VALUE NUMERIC(15,4),
OPEN_CHARGES INTEGER)
 AS
declare variable calc_rate double precision;
  declare variable pay_value numeric(15,4);
  declare variable sys_date date;
  declare variable pay_curr varchar(3);
  declare variable account_curr varchar(3);
  declare variable id_hotel integer;
  declare variable dbg varchar(1000);
begin
  OPEN_CHARGES = 0;
  /* FIND THE ACCOUNT CURRENCY */
  select A.ACCOUNT_CURR, A.ID_HOTEL
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :account_curr, :id_hotel;

  if (:balance_curr is null) then balance_curr = :account_curr;

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values :sys_date;
  /* -------------------- SUM POSTINGS --------------------- */
  post_orig_value = 0;
  post_bal_value = 0;
  for
    select sum(AP.QTY_POST * AP.PRICE_POST - AP.IN_DOC_QTY * AP.IN_DOC_VALUE), AP.CURR_POST
    from   ACCOUNT_POST AP
    where  AP.ID_ACCOUNT = :ID_ACCOUNT
           and AP.AC = '00'
           and AP.ID_END_WORK is distinct from iif(:EW_INCL_ONLY = 1, null, 0 /* ever */)
    group by AP.CURR_POST
    into   :POST_ORIG_VALUE, :CURR_ORIG
  do begin
    OPEN_CHARGES = 1;
    if (:account_curr is not distinct from :balance_curr) then begin
      post_bal_value = :post_orig_value;
    end else begin
      select CF.RATE
      from   CURR_CROSS_RATE_GET (:account_curr, :balance_curr, :sys_date, :id_hotel) cf
      into   :calc_rate;
      post_bal_value = :post_orig_value * :calc_rate;
    end
  end
  /* ------------------ CHECK FOR PAYMENT EXISTENCE ------------------- */
  DEP_ORIG_VALUE = 0;
  DEP_BAL_VALUE = 0;
  for
    select iif(DA.PAY_CURRENCY is not distinct from :CURR_ORIG, 0, 1),
           sum(DA.AVAIL_VALUE), DA.PAY_CURRENCY
    from   DEPOSIT_AVAILABLE DA
           left outer join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = da.ID_RESERV_DETAIL
    where  DA.ID_ACCOUNT = :ID_ACCOUNT
           and DA.PAYMENT_DATE < iif(:EW_INCL_ONLY = 1, :sys_date, DA.PAYMENT_DATE + 1)
           and rd.IS_POSTING_STOPPED is distinct from 1
    group by DA.PAY_CURRENCY
    order by 1 asc  /* get deposits on account currency first - to suspend with postings balance */
    into   :dbg, :pay_value, :pay_curr
  do begin
    if (:curr_orig is not null and :pay_curr is distinct from :curr_orig) then begin
      suspend;
      post_orig_value = 0;
      post_bal_value = 0;
    end
    dep_orig_value = :pay_value;
    curr_orig = :pay_curr;

    if (:pay_curr is not distinct from :balance_curr) then begin
      dep_bal_value = :dep_orig_value;
    end else begin
      select cf.rate
      from   CURR_CROSS_RATE_GET (:pay_curr, :balance_curr, :sys_date, :id_hotel) cf
      into   :calc_rate;
      dep_bal_value = :dep_orig_value * :calc_rate;
    end
  end

  suspend;
end
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_ACCOUNT$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
QTY /* TYPE OF TQTY */ NUMERIC(15,2),
ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
DATE_POST /* TYPE OF TDATE */ DATE,
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ROOM /* TYPE OF ID */ INTEGER = null,
POST_DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_GUEST$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ACCOUNT_ROUTING /* TYPE OF TSHORT_CODE */ VARCHAR(10),
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_TAR_CALC_REPOST$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE RES_TAR_CALC_REPOST$INT(ID_TAR_CALC /* TYPE OF ID_REF */ INTEGER,
ID_RESERV_DETAIL /* TYPE OF ID_REF */ INTEGER,
RECALC_MARKER VARCHAR(40))
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_ADD$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_ADD$INT(ID_ACCOUNT TYPE OF ID,
ID_GUEST TYPE OF ID_REF,
ID_SECQUENCE TYPE OF ID_REF,
DATE_POST TYPE OF TDATE,
ID_SERVICE TYPE OF ID,
ID_TARIFF TYPE OF ID_REF,
ID_ROOM TYPE OF ID_REF,
IS_BASE TYPE OF TLOGICAL,
QTY_POST TYPE OF TQTY,
PRICE TYPE OF TPRICE,
ORIG_CURRENCY TYPE OF TCURRENCY,
RATE TYPE OF TRATE,
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
POST_TEXT TYPE OF TDESCRIPTION_SHORT,
RESOURCE_TEXT TYPE OF TREASON,
CHANGED_TEXT TYPE OF TTEXT_SHORT,
ID_MASTER_ADDINS_ACC_POST TYPE OF ID_REF,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
NEW_ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable price_post double precision;
  declare variable post_rate numeric (15, 6);
  declare variable curr_post char(3);
  declare variable account_currency char(3);
  declare variable id_pack_service integer;
  declare variable id_room_type integer;
  declare variable room_name varchar(30);
  declare variable is_archive integer;
  declare variable id_tax_policy integer;
  declare variable id_sale_taxation integer;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable check_option varchar(255);
  declare variable id_hotel integer;
  declare variable id_srv_hotel integer;
  declare variable service_name varchar(30);
  declare variable account_name varchar(50);
begin
  ID_GUEST = nullif(:ID_GUEST, -1);

  execute procedure POST_PRICE_CHECK$INT (:QTY_POST, :PRICE, :ORIG_CURRENCY);

  if ( (:IS_BASE = 1) or (:ID_MASTER_ADDINS_ACC_POST > 0) ) then
    check_option = 'IS_BASE;ALLOW_POSTING';
  else
    check_option = 'IS_EXTRA;ALLOW_POSTING';

  execute procedure ACCOUNT_VALIDATE$INT(:id_account, :check_option)
  returning_values  (:err_code, :err_text, :account_currency, :id_tax_policy, :id_hotel, :account_name);
  if (:err_code < 0) then EXIT; --  exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;

  select s.ID_HOTEL, s.SERVICE_NAME
  from   SERVICES S
  where  s.ID_SERVICE = :ID_SERVICE
  into   :id_srv_hotel, :service_name;

  if (:id_srv_hotel is distinct from :id_hotel) then
    exception POSTING_EXCEPTION '-1056' || f_character(31) || f_character(29) || :service_name || f_character(28) || :account_name;

  if (:rate is null) then begin
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :orig_currency, :date_post, :id_guest)
    returning_values  :rate;
  end

  curr_post  = :account_currency;
  if (:orig_currency = :account_currency) then begin
    post_rate  = :rate;
  end else begin
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :account_currency, :date_post, :id_guest)
    returning_values  :post_rate;
  end

  execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :id_tax_policy, :ID_TARIFF, :DATE_POST - :FROM_DATE)
  returning_values (:id_sale_taxation);

  execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:QTY_POST, :PRICE,
                    :RATE, :post_rate, :id_sale_taxation)
  returning_values  :price_post, :post_net_value, :post_gross_value;

  execute procedure ACCOUNT_CHECK_CREDIT_STATUS$INT (:ID_ACCOUNT, :price_post * :QTY_POST)
  returning_values (:ERR_CODE, :ERR_TEXT);
  if (:ERR_CODE <> 0) then exit;

  --
  new_id_account_post = gen_id (id_account_post_gen, 1);

  if (:post_text starting with 'PACK') then begin
    id_pack_service = substring(:post_text from 6 for 20);
    post_text = '';
  end else begin
    id_pack_service = -1;
  end
  if (:is_base = 1) then id_master_addins_acc_post = :new_id_account_post;

  select R.ROOM_NAME, R.ID_ROOM_TYPE
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :room_name, :id_room_type;

  if (:id_guest is null) then begin
    is_archive = 1;
  end else begin
    select iif(G.CHECK_STATUS = 1, 1, 0)
    from   GUEST G
    where  G.ID_GUEST = :id_guest
    into   :is_archive;
  end

  insert into ACCOUNT_POST (
    ID_ACCOUNT_POST, ID_ACCOUNT, ID_GUEST, ID_SERVICE, ID_TARIFF, ID_ROOM,
    IS_BASE, DATE_POST, QTY_POST, QTY_FREE, PRICE_POST, POST_NET_VALUE, POST_GROSS_VALUE, CURR_POST, RATE_POST,
    PRICE_ORIG, CURR_ORIG, RATE_ORIG, IS_LOCKED_FOR_UPDATE, TO_DATE, FROM_DATE, ID_SEQUENCE,
    SHORT_CODE, CHANGED_TEXT, ID_MASTER_ADDINS_ACC_POST, ID_PACK_SERVICE, ROOM_NAME, ID_ROOM_TYPE,
    ID_SALE_TAXATION, AC, IS_ARCHIVE, IN_DOC_QTY, IN_DOC_VALUE, DESCRIPTION)
  values (
    :new_id_account_post, :id_account, :id_guest, :id_service, :id_tariff, coalesce(:id_room, -1),
    :is_base, :date_post, :qty_post, 0, :price_post, :post_net_value, :post_gross_value, :curr_post, :post_rate,
    :price, :orig_currency, :rate, 0, :TO_DATE, :FROM_DATE, :id_secquence,
    :short_code, :changed_text, :id_master_addins_acc_post, :id_pack_service, :room_name, :id_room_type,
    :id_sale_taxation, '00', :is_archive, 0, 0, :DESCRIPTION);

  if ((coalesce(:post_text, '') <> '') or (coalesce(:resource_text, '') <> '')) then begin
    insert into ACCOUNT_POSTING_DET (ID_ACCOUNT_POST, POST_TEXT, QTY, FROM_DATETIME, TO_DATETIME, RESOURCE_TEXT)
    values (:new_id_account_post, :post_text, :qty_post, :FROM_DATE, :TO_DATE, :resource_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POST_MODIFY$PMS for: ACCOUNT_POSTING_ANUL$INT */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_ANUL for: ACCOUNT_POSTING_ANUL$INT */
ALTER PROCEDURE ACCOUNT_POSTING_ANUL(IN_ID_ACCOUNT_POST INTEGER,
IN_ANUL_REASON VARCHAR(70))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_ANUL$INT for: ACCOUNT_POSTING_ANUL$INT */
ALTER PROCEDURE ACCOUNT_POSTING_ANUL$INT(AP_DBKEY /* TYPE OF TDB_KEY */ CHAR(8),
ANUL_REASON /* TYPE OF TREASON */ VARCHAR(50))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_DEL$INT for: ACCOUNT_POSTING_ANUL$INT */
ALTER PROCEDURE ACCOUNT_POSTING_DEL$INT(AP_DBKEY CHAR(8),
REASON VARCHAR(50))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_MULTIANUL for: ACCOUNT_POSTING_ANUL$INT */
ALTER PROCEDURE ACCOUNT_POSTING_MULTIANUL(AP_LIST VARCHAR(4096),
ANUL_REASON VARCHAR(70))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PMS_EVENT_VOID$INT for: ACCOUNT_POSTING_ANUL$INT */
ALTER PROCEDURE PMS_EVENT_VOID$INT(ID_PMS_EVENT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_ANUL$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_ANUL$INT(AP_DBKEY TYPE OF TDB_KEY,
ANUL_REASON TYPE OF TREASON)
 AS
declare variable is_anul integer;
  declare variable qty_post integer;
  declare variable orig_is_base integer;
  declare variable orig_short_code varchar(255);
  declare variable id_base_doc integer;
  declare variable rp_dbkey char(8);
  declare variable id_resource_reserv integer;
  declare variable id_account_post integer;
  declare variable is_locked_for_update integer;
  declare variable orig_ac varchar(2);
  declare variable doc_qty numeric(15,2);
begin
  select AP.ID_ACCOUNT_POST, AP.IS_ANUL, AP.QTY_POST,
         AP.IS_BASE, AP.SHORT_CODE, AP.ID_BASE_DOC, ap.AC, ap.IN_DOC_QTY
  from   ACCOUNT_POST AP
  where  AP.rdb$db_key = :AP_DBKEY
  into   :id_account_post, :is_anul, :qty_post,
         :orig_is_base, :orig_short_code, :id_base_doc, :orig_ac, :doc_qty;

  /*if (:is_anul = 1) then begin
    exception POSTING_ANNUL_EXCEPTION '-33'; /* POSTING IS ALREADY ANULED */
  /*end*/

  if (:ANUL_REASON not like '%RECALC_%') then begin
    /* MANUAL ANUL */
    is_locked_for_update = 1;
    execute procedure RIGHTS_CHECK_GRANTED$INT('ACCPOSTANUL');
    if (:orig_ac = '01') then execute procedure RIGHTS_CHECK_GRANTED$INT('BALANCES_EDIT_CLOSED');

    if (:orig_is_base = 1) then exception POSTING_ANNUL_EXCEPTION '-103'; /* CAN`T ANUL BASE SERVICE */
  end else begin
    /* AUTO RECALC */
    is_locked_for_update = 0;
  end

  if (:id_base_doc > 0) then begin -- has a valid doc
    if (:qty_post = 0) then exit;  -- already anul
    qty_post = 0;
    if (:doc_qty = 0) then begin   -- has a storno doc for this posting
      is_anul = 1;
    end else begin
      is_anul = 0;
    end
  end else begin
    if (:is_anul = 1) then exit;   -- already anul
    is_anul = 1;
  end

  update ACCOUNT_POST APU
  set    APU.IS_ANUL = :is_anul,
         APU.QTY_POST = :qty_post,
         APU.USER_ANUL = current_user,
         APU.ANUL_DATETIME = current_timestamp,
         APU.ANUL_REASON = :anul_reason,
         APU.CHANGED_TEXT = substring(:anul_reason from 1 for 30),
         APU.AC = :is_anul || '0',
         APU.DATETIME_CHANGED = current_timestamp,
         APU.POST_NET_VALUE = 0,
         APU.POST_GROSS_VALUE = 0,
         APU.IS_LOCKED_FOR_UPDATE = :is_locked_for_update
  where  APU.rdb$db_key = :AP_DBKEY;

  if (:orig_short_code = 'TELECOUNT') then begin
    update PHONECALLS PH
    set    PH.ID_ACCOUNT_POST = -1,
           PH.IS_LOGICLESS_RECORD = 1
            /*!!! TO PREVENT FUTURE AUTO TRANSFER !!!*/
    where  PH.ID_ACCOUNT_POST = :id_account_post;
  end else if (:orig_short_code = 'RESOURCE') then begin
    select RP.RDB$DB_KEY, RP.ID_RESOURCE_RESERVATION
    from   RESOURCE_RESERV_POST RP
    where  RP.ID_ACCOUNNT_POST = :id_account_post
    into   :rp_dbkey, :id_resource_reserv;

    delete from RESOURCE_RESERV_POST RRP
    where  RRP.RDB$DB_KEY = :rp_dbkey;

    execute procedure RESOURCE_RESERV_RESET$INT (:id_resource_reserv);

  end else if (:orig_short_code = 'PMS') then begin
    if (exists ( select *
                 from   PMS_EVENT_POST P
                 where  P.LINE_STATUS > 11
                        and P.ID_ACCOUNT_POST = :id_account_post )) then exception PMS_EXCEPTION '-620';

    update PMS_EVENT_POST PP
    set    PP.LINE_STATUS = 22
    where  PP.ID_ACCOUNT_POST = :id_account_post;
  end


  if (:orig_is_base = 1) then begin
    /* ANUL THE REST OF THE PACKET (ADDINS) */
    for
      select AP_addins.rdb$db_key
      from   ACCOUNT_POST AP_addins
      where  AP_addins.ID_MASTER_ADDINS_ACC_POST = :id_account_post
             and AP_addins.IS_BASE = 0
             and AP_addins.IS_ANUL = 0
      into   :ap_dbkey
    do begin
      execute procedure ACCOUNT_POSTING_ANUL$INT (:AP_DBKEY, :ANUL_REASON);
    end
  end

end
^

/* empty dependent procedure body */
/* Clear: GUEST_DEL_POSTINGS$INT for: ACCOUNT_POSTING_DEL$INT */
ALTER PROCEDURE GUEST_DEL_POSTINGS$INT(ID_GUEST INTEGER)
 RETURNS(EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_DEL_POSTING for: ACCOUNT_POSTING_DEL$INT */
ALTER PROCEDURE POST_DEL_POSTING(IN_ID_ACCOUNT_POST INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100))
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_POSTING_DEL$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_DEL$INT(AP_DBKEY CHAR(8),
REASON VARCHAR(50))
 AS
declare variable id_end_work integer;
  declare variable id_doc integer;
  declare variable is_base integer;
  declare variable id_master_acc_post integer;
  declare variable short_code varchar(255);
  declare variable id_account integer;
  declare variable success_del smallint;
begin
  success_del = 0;

  select AP.ID_END_WORK, AP.ID_BASE_DOC, AP.IS_BASE, AP.ID_ACCOUNT_POST, AP.SHORT_CODE, ap.ID_ACCOUNT
  from   ACCOUNT_POST AP
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :id_end_work, :id_doc, :is_base, :id_master_acc_post, :short_code, :id_account;

  if (:id_doc is not null) then exception POSTING_ANNUL_EXCEPTION '-29'; -- account post has doc

  if (:id_end_work is null) then begin
    if (:short_code = 'TELECOUNT') then begin
      update PHONECALLS PC
      set    PC.ID_ACCOUNT_POST = -1,
             PC.IS_LOGICLESS_RECORD = 1
      where  PC.ID_ACCOUNT_POST = :id_master_acc_post;
    end 

    delete from ACCOUNT_POST AP
    where  AP.RDB$DB_KEY = :ap_dbkey;

    if (:is_base = 1) then
      delete from ACCOUNT_POST PAD where PAD.ID_MASTER_ADDINS_ACC_POST = :id_master_acc_post;

    success_del = 1;
    when sqlcode -530 do begin /* Violation of FOREIGN KEY constraint */
      RDB$SET_CONTEXT ('USER_TRANSACTION', 'ACCOUNT_CACHE_STATUS#'||:id_account, null);

      success_del = 0;
      /*execute procedure ACCOUNT_POSTING_ANUL$INT (-1, :ap_dbkey, :REASON)
      returning_values  :err_code, :err_text;
      if (:err_code < 0) then
        exception POSTING_ANNUL_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);*/
    end
  end

  if (:success_del = 0) then begin
    execute procedure ACCOUNT_POSTING_ANUL$INT (:ap_dbkey, :REASON);
  end

end
^

/* Alter (ACCOUNT_POSTING_MULTIANUL) */
ALTER PROCEDURE ACCOUNT_POSTING_MULTIANUL(AP_LIST VARCHAR(4096),
ANUL_REASON VARCHAR(70))
 AS
declare variable ap_dbkey char(8);
  declare variable id_account integer;
  declare variable prev_id_account integer;
  declare variable curr_post varchar(3);
  declare variable post_value double precision;
  declare variable log_curr varchar(3);
  declare variable log_value double precision;
  declare variable action_text varchar(255);
begin
  prev_id_account = null;
  log_value = 0;
  for
    select AP.RDB$DB_KEY, AP.ID_ACCOUNT, AP.CURR_POST, AP.QTY_POST * AP.PRICE_POST
    from   SYSTEM_STRING_PARSER(:ap_list, ',') SP
           left outer join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = SP.ITEM
    order by AP.ID_ACCOUNT asc
    into   :ap_dbkey, :id_account, :curr_post, :post_value
  do begin
    execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_dbkey,  :anul_reason);

    if (:prev_id_account is not null and :prev_id_account <> :id_account) then begin
      action_text = f_character(29) || formatfloat(:log_value, 'F;0.00') || ' ' || :log_curr
                    || f_character(28) || f_replstr(:ANUL_REASON, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_MULTIANUL', :action_text);
    end
    log_value = :log_value + :post_value;
    log_curr = :curr_post;
    prev_id_account = :id_account;
  end

  if (:id_account is not null) then begin
    action_text = f_character(29) || formatfloat(:log_value, 'F;0.00') || ' ' || :log_curr
                  || f_character(28) || f_replstr(:ANUL_REASON, 'MANUAL', '');
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_MULTIANUL', :action_text);
 end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_TRANSFER$INT for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE_PERC for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_PERC(IN_ID_ACCOUNT_POST VARCHAR(4000),
IN_PERC NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(30))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_POSTING$INT for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_POSTING$INT(ID_RESOURCE_RESERVATION /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
PRICE_DESCRIPTION /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
ID_RESERV_DETAIL /* TYPE OF ID */ INTEGER,
ID_EXTERNAL_CLIENT_ACCCOUNT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(DOC_SELECTED /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_POSTING_UPDATE$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE$INT(AP_DBKEY TYPE OF TDB_KEY,
ID_SERVICE TYPE OF ID_REF,
ID_TARIFF TYPE OF ID_REF,
ID_ROOM TYPE OF ID_REF,
QTY_POST TYPE OF TQTY,
QTY_FREE TYPE OF TQTY,
PRICE TYPE OF TVALUE,
CURR TYPE OF TCURRENCY,
RATE TYPE OF TRATE,
CHANGED_TEXT VARCHAR(40),
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
IS_CONSEQUENTIAL_UPDATE TYPE OF TBOOLEAN = 0,
RE_ROUTE_ACCOUNT TYPE OF ID_REF = null)
 RETURNS(OUT_QTY_POST TYPE OF TQTY,
OUT_PRICE_POST TYPE OF TVALUE,
OUT_AC VARCHAR(2))
 AS
declare variable date_post date;
  declare variable orig_is_base integer;
  declare variable orig_id_service integer;
  declare variable orig_id_room integer;
  declare variable orig_short_code varchar(255);
  declare variable orig_qty_post integer;
  declare variable orig_ac varchar(2);
  declare variable is_locked_for_update integer;
  declare variable orig_locked_for_update integer;
  declare variable orig_id_tariff integer;
  declare variable orig_id_guest integer;
  declare variable id_type_stay integer;
  declare variable id_room_type integer;
  declare variable id_board integer;
  declare variable id_pack_service integer;
  declare variable new_id_pack_service integer;
  declare variable post_currency char(3);
  declare variable room_name varchar(30);
  declare variable original_post varchar(30);
  declare variable new_ac varchar(2);
  declare variable orig_in_doc_qty numeric(15,2);
  declare variable orig_in_doc_value double precision;
  declare variable rate_post numeric(15,6);
  declare variable id_base_doc integer;
  declare variable id_tax_policy integer;
  declare variable price_post double precision;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable id_sale_taxation integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable orig_price_post tprice;
  declare variable round_to numeric(15,4);
  declare variable account_name tobject_name;
  declare variable err_code integer;
  declare variable err_text varchar(100);
  declare variable id_account integer;
begin
  /* GET DATA */
  original_post = '';
  new_id_pack_service = null;

  select AP.DATE_POST, AP.IS_BASE, AP.ID_SERVICE, AP.ID_BASE_DOC,
         AP.SHORT_CODE, AP.QTY_POST, ap.PRICE_POST, AP.IS_LOCKED_FOR_UPDATE,
         AP.AC, AP.ID_TARIFF, AP.ID_GUEST, AP.ID_ROOM,
         AP.CURR_POST, AP.ID_PACK_SERVICE, AP.ID_ROOM_TYPE,
         AP.IN_DOC_QTY, AP.IN_DOC_VALUE, AP.RATE_POST, ap.ID_SALE_TAXATION, ap.ID_ACCOUNT, ap.ID_ACCOUNT_POST
  from   ACCOUNT_POST AP
  where  AP.rdb$db_key = :AP_DBKEY
  into   :date_post, :orig_is_base, :orig_id_service, :id_base_doc,
         :orig_short_code, :orig_qty_post, :orig_price_post, :orig_locked_for_update,
         :orig_ac, :orig_id_tariff, :orig_id_guest, :orig_id_room,
         :post_currency, :id_pack_service, :id_room_type,
         :orig_in_doc_qty, :orig_in_doc_value, :rate_post, :id_sale_taxation, :id_account, :id_account_post;

  if (:RE_ROUTE_ACCOUNT is not null and :id_base_doc is null) then id_account = :RE_ROUTE_ACCOUNT;  -- IMPORTANT !!! Re-routing is possible only in this case!

  is_locked_for_update = :orig_locked_for_update; /* to initialize and preserve from null */

  execute procedure ACCOUNT_VALIDATE$INT(:id_account, 'ALLOW_POSTING;')
  returning_values  (:err_code, :err_text, :post_currency, :id_tax_policy, :id_hotel, :account_name);
  if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;

  if (:IS_CONSEQUENTIAL_UPDATE is distinct from 1) then begin
    -- direct post update - manual edition restrictions check
    if (:QTY_POST = -1) then QTY_POST = :orig_qty_post;   -- preserve current qty

    if (:QTY_POST <> :orig_qty_post) then exception POSTING_EXCEPTION '-379';

    if ((:orig_is_base = 1) and ((:QTY_POST <> 1) or (:ID_SERVICE <> :orig_id_service))) then
      exception POSTING_EXCEPTION '-223';

    if (:orig_ac = '01') then execute procedure RIGHTS_CHECK_GRANTED$INT('BALANCES_EDIT_CLOSED');

    short_code = :orig_short_code;
    id_tariff  = :orig_id_tariff;
    id_room    = :orig_id_room;
    is_locked_for_update = 1;  /* manual corrections must lock the postings  */

  end else begin
    /* post changes is a result from some user operation, indirect update ('NORMAL', 'FORCED', safes recalc, etc....) */
    is_locked_for_update = 0;

    if (:orig_is_base = 1) then begin
      /* PREPARING THE PACKET SERVICE */
      select S.ID_TYPE_STAY, S.ID_ROOM_TYPE
      from   SERVICE_PACKET S
      where  S.ID_SERVICE = :id_service
      into   :id_type_stay, :id_room_type;

      select GS.ID_BOARD
      from   GUEST_STAY GS
      where  GS.ID_GUEST = :orig_id_guest
             and GS.FOR_DATE = :date_post
      into   :id_board;

      execute procedure TAR_GET_BASE_SERVICE$INT(:id_type_stay, :id_room_type, :id_board, :id_hotel)
      returning_values  :id_pack_service;
      /* detecting change of STAY_TYPE or ROOM_TYPE */
      if (exists(
        select *
        from   SERVICE_PACKET S
        where  S.ID_SERVICE = :orig_id_service
               and ((S.ID_TYPE_STAY is distinct from :id_type_stay) or (S.ID_ROOM_TYPE is distinct from :id_room_type))
      )) then original_post = 'CHANGED';
    end
  end

  select R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :room_name;

  if (:orig_locked_for_update = 1
      and :changed_text starting with 'NORMALRECALC'
      and :id_service = :orig_id_service
      --and :orig_is_anul = 0
      and :id_tariff = :orig_id_tariff) then
  begin
    -- price is locked for update
    update ACCOUNT_POST AP
    set    AP.ID_ROOM      = :id_room,
           AP.ROOM_NAME    = :room_name,
           Ap.FROM_DATE    = :from_date,
           Ap.TO_DATE      = :to_date,
           AP.CHANGED_TEXT = :changed_text,
           AP.USER_CHANGED = current_user,
           AP.DATETIME_CHANGED = current_timestamp
    where  AP.rdb$db_key   = :AP_DBKEY;
    OUT_QTY_POST = :orig_qty_post;
    OUT_PRICE_POST = :orig_price_post;
    OUT_AC = :orig_ac;
  end else begin
    -- fully update
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :curr, :date_post, :orig_id_guest)
    returning_values  :rate;
  
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :post_currency, :date_post, :orig_id_guest)
    returning_values  :rate_post;
  
    if (:id_base_doc is null) then begin
      execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :id_tax_policy, :ID_TARIFF, :date_post - :from_date)
      returning_values (:id_sale_taxation);
    end

    execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:QTY_POST, :PRICE,
                      :RATE, :rate_post, :id_sale_taxation)
    returning_values  :price_post, :post_net_value, :post_gross_value;

    select c.ROUND_TO
    from   CURRS c
    where  c.CURR = :post_currency
    into   :round_to;

    if ( (:id_base_doc is not null)
         and (:qty_post = :orig_in_doc_qty)
         and (round_f(:price_post * :qty_post - :orig_in_doc_value * :orig_in_doc_qty, :round_to) = 0))
    then new_ac = '01';
    else new_ac = '00';                   
  
    if (:new_ac = '00') then begin
      execute procedure ACCOUNT_CHECK_CREDIT_STATUS$INT (:id_account, :price_post * :QTY_POST - :orig_price_post * :orig_qty_post)
      returning_values (:err_code, :err_text);
      if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;
    end

    update ACCOUNT_POST AP
    set    AP.ID_ACCOUNT           = :id_account,
           AP.ID_SERVICE           = :id_service,
  
           AP.QTY_POST             = :qty_post,
           AP.QTY_FREE             = :qty_free,
           AP.PRICE_POST           = :price_post,
           AP.CURR_POST            = :post_currency,
           AP.RATE_POST            = :rate_post,
           AP.RATE_ORIG            = :rate,
           AP.PRICE_ORIG           = :price,
           AP.CURR_ORIG            = :curr,
           AP.POST_NET_VALUE       = :post_net_value,
           AP.POST_GROSS_VALUE     = :post_gross_value,
  
           AP.AC                   = :new_ac,
           AP.IS_ANUL              = 0,
           AP.ANUL_REASON          = '',
           AP.IS_LOCKED_FOR_UPDATE = :is_locked_for_update,
           AP.ID_TARIFF            = :id_tariff,
           AP.ID_PACK_SERVICE      = :id_pack_service,
           AP.ID_ROOM              = :id_room,
           AP.ID_ROOM_TYPE         = :id_room_type,
           AP.ROOM_NAME            = :room_name,
           AP.ID_SALE_TAXATION     = :id_sale_taxation,
           AP.ORIGINAL_POST        = :original_post,
           AP.SHORT_CODE           = :short_code,
           AP.CHANGED_TEXT         = :changed_text,
           AP.USER_CHANGED         = current_user,
           AP.DATETIME_CHANGED     = current_timestamp,
           Ap.FROM_DATE            = :from_date,
           Ap.TO_DATE              = :to_date
    where  AP.rdb$db_key = :AP_DBKEY
    returning new.id_account_post, new.id_pack_service
    into   :id_account_post, :new_id_pack_service;
  
    if (:new_ac = '01') then begin
      update ACCOUNT_POST_CORRECTION APC
      set    APC.IS_OPEN = 0
      where  APC.ID_ACCOUNT_POST = :id_account_post
             and APC.IS_OPEN = 1;
    end

    if (:orig_is_base = 1 and :new_id_pack_service <> :id_pack_service) then begin
      -- update add_inses with new pack service
      update ACCOUNT_POST AP
      set    ap.ID_PACK_SERVICE = :new_id_pack_service
      where  ap.ID_MASTER_ADDINS_ACC_POST = :id_account_post
             and ap.IS_BASE = 0;
    end

    OUT_QTY_POST = :qty_post;
    OUT_PRICE_POST = :price_post;
    OUT_AC = :new_ac;
  end
end
^

/* Alter (ACCOUNT_POSTING_UPDATE_PERC) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_PERC(IN_ID_ACCOUNT_POST VARCHAR(4000),
IN_PERC NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(30))
 AS
declare variable id_account_post integer;
  declare variable ap_dbkey char(8);
  declare variable id_service integer;
  declare variable id_tariff integer;
  declare variable id_room integer;
  declare variable qty_post numeric (15,4);
  declare variable qty_free numeric (15,4);
  declare variable short_code varchar(255);
  declare variable orig_currency char(3);
  declare variable orig_rate numeric (15,4);
  declare variable orig_price numeric (15,4);
  declare variable new_orig_price double precision;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  for
    select item
    from   SYSTEM_STRING_PARSER(:in_id_account_post, ',')
    into   :id_account_post
  do begin
    select AP.rdb$db_key, AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST,
           AP.QTY_FREE, AP.SHORT_CODE, AP.CURR_ORIG, AP.RATE_ORIG, AP.PRICE_ORIG,
           ap.FROM_DATE, ap.TO_DATE
    from   ACCOUNT_POST AP
    where  AP.ID_ACCOUNT_POST = :id_account_post
    into   :ap_dbkey, :id_service, :id_tariff, :id_room, :qty_post,
           :qty_free, :short_code, :orig_currency, :orig_rate, :orig_price,
           :from_date, :to_date;

    new_orig_price = :orig_price + :orig_price * :in_perc;

    execute procedure ACCOUNT_POSTING_UPDATE$INT(:ap_dbkey,
            :id_service, :id_tariff, :id_room,
            :qty_post, :qty_free, :new_orig_price, :orig_currency, :orig_rate,
            :in_changed_text, :short_code, :from_date, :to_date)
    returning_values  :no_use, :no_use, :no_use;
  end
end
^

/* empty dependent procedure body */
/* Clear: AR_OWING_ADD$AR for: AR_OWING_ADD$INT */
ALTER PROCEDURE AR_OWING_ADD$AR(ID_PROFILE /* TYPE OF ID */ INTEGER,
SUM_OWING /* TYPE OF TPRICE */ NUMERIC(15,4),
CURR_OWING /* TYPE OF TCURRENCY */ CHAR(3),
DUE_DATE /* TYPE OF TDATE */ DATE,
SYSTEM_DATE /* TYPE OF TDATE */ DATE,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_AR_TYPE /* TYPE OF ID */ INTEGER,
ID_HOTEL /* TYPE OF ID */ INTEGER)
 RETURNS(NEW_ID_AR_OWING /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (AR_OWING_ADD$INT) */
ALTER PROCEDURE AR_OWING_ADD$INT(ID_PROFILE TYPE OF ID,
SUM_OWING TYPE OF TPRICE,
CURR_OWING TYPE OF TCURRENCY,
ID_DOC_HEAD TYPE OF ID_REF,
DUE_DATE TYPE OF TDATE,
SYSTEM_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
ID_AR_TYPE TYPE OF ID,
ID_HOTEL TYPE OF ID)
 RETURNS(NEW_ID_AR_OWING TYPE OF ID)
 AS
declare variable round_to numeric(15,4);
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
begin

  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :CURR_OWING
  into   :round_to;

  select P.PROFILE_NAME
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :profile_name;

  new_id_ar_owing = gen_id(GEN_AR_OWING_ID, 1);
  sum_owing = ROUND_F(:sum_owing, :round_to);

  insert into AR_OWING (ID_AR_OWING, ID_PROFILE, SUM_OWING, CURR_OWING,
         USER_CREATED, DATETIME_CREATED, ID_DOC, SYSTEM_DATE,
         ID_AR_OWING_BASE, DESCRIPTION, DUE_DATE, ID_AR_TYPE, ID_HOTEL,
         REST_OWING, OWING_STATUS)
  values (:new_id_ar_owing, :ID_PROFILE, :SUM_OWING, :CURR_OWING,
         user, current_timestamp, :ID_DOC_HEAD, :system_date,
         null, :description, STRIPTIME(:due_date), :ID_AR_TYPE, :ID_HOTEL,
         :SUM_OWING, 11);

  action_text = substring(f_character(29) || :profile_name
                          || f_character(28) || formatfloat(:SUM_OWING, 'F;0.00') || ' ' || :CURR_OWING
                          || f_character(28) || :description from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'OWING_CREATE', :action_text);

end
^

/* empty dependent procedure body */
/* Clear: AR_OWING_ANUL$AR for: AR_OWING_ANUL$INT */
ALTER PROCEDURE AR_OWING_ANUL$AR(ID_AR_OWING /* TYPE OF ID */ INTEGER,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255))
 RETURNS(NEW_ID_AR_OWING /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE AR_POST_FINALIZE(OPERATION VARCHAR(10))
 AS
declare variable transaction_payment numeric(15,4);
  declare variable id_ar_payment integer;
  declare variable id_ar_owing integer;
  declare variable sum_payment numeric(15,4);
  declare variable rest_payment numeric(15,4);
  declare variable sum_owing numeric(15,4);
  declare variable rest_owing numeric(15,4);
  declare variable transaction_owing_sum numeric(15,4);
  declare variable payment_status smallint;
  declare variable owing_status smallint;
  declare variable payment_sum_in_owing_curr numeric(15,4);
  declare variable owing_sum_total numeric(15,4);
  declare variable truncc integer;
  declare variable round_to_payment numeric(15,4);
  declare variable owing_sum_in_payment_curr numeric(15,4);
  declare variable payment_sum_total numeric(15,4);
  declare variable curr_payment_status smallint;
  declare variable owing_curr varchar(3);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, anul_link, anul_pay, anul_owing');

  truncc = 1000000;
  select sum(round_f(
         ( floor(cast(PP.SUM_PAYMENT as double precision) * PP.PAYMENT_RATE_TO_BGN * :truncc) / :truncc) / PP.OWING_RATE_TO_BGN,
           C.ROUND_TO ))
  from   AR_OWING_PAYMENT_POST PP
         left outer join CURRS C on C.CURR = PP.CURR_OWING
  where  PP.ID_TRANSACTION = current_transaction
  into   :PAYMENT_SUM_IN_OWING_CURR;

  select sum(PP.SUM_OWING)
  from   AR_OWING_PAYMENT_POST PP
  where  PP.ID_TRANSACTION = current_transaction
  into   :OWING_SUM_TOTAL;

  if (:OWING_SUM_TOTAL <> :PAYMENT_SUM_IN_OWING_CURR) then begin
    select sum(round_f(
           ( floor(cast(PP.SUM_OWING as double precision) * PP.OWING_RATE_TO_BGN * :truncc) / :truncc) / PP.PAYMENT_RATE_TO_BGN,
             C.ROUND_TO ))
    from   AR_OWING_PAYMENT_POST PP
           left outer join CURRS C on C.CURR = PP.CURR_PAYMENT
    where  PP.ID_TRANSACTION = current_transaction
    into   :OWING_SUM_IN_PAYMENT_CURR;
  
    select sum(PP.SUM_PAYMENT)
    from   AR_OWING_PAYMENT_POST PP
    where  PP.ID_TRANSACTION = current_transaction
    into   :PAYMENT_SUM_TOTAL;

    if (:OWING_SUM_IN_PAYMENT_CURR <> :PAYMENT_SUM_TOTAL) then
      exception ACCOUNT_RECEIVABLE_EXCEPTION '-605' || f_character(31) || '' || :OWING_SUM_IN_PAYMENT_CURR || ' <> ' || :PAYMENT_SUM_TOTAL;
  end

  if ( (:OPERATION = 'add') ) then begin    /*  add links  */
    /* UPDATE PAYMENT ROW  */
    select sum(PP.SUM_PAYMENT), PP.ID_AR_PAYMENT
    from   AR_OWING_PAYMENT_POST PP
    where  PP.ID_TRANSACTION = current_transaction
    group by 2
    into   :transaction_payment, :id_ar_payment;

    select P.SUM_PAYMENT, P.REST_PAYMENT, c.ROUND_TO
    from   AR_PAYMENT P
           join CURRS C on c.CURR = p.CURR_PAYMENT
    where  P.ID_AR_PAYMENT = :id_ar_payment
    into   :sum_payment, :rest_payment, :round_to_payment;

    if ( abs(:REST_PAYMENT) < abs(:TRANSACTION_PAYMENT) ) then
      exception ACCOUNT_RECEIVABLE_EXCEPTION '-603' ;

    if ( :rest_payment = :transaction_payment ) then begin
      payment_status = 21;
    end else begin
      payment_status = 12;
    end

    update AR_PAYMENT A
    set    A.REST_PAYMENT = round_f(A.REST_PAYMENT - :transaction_payment, :round_to_payment),
           A.PAYMENT_STATUS = :payment_status
    where  A.ID_AR_PAYMENT = :ID_AR_PAYMENT;
    /* END OF UPDATE PAYMENT ROW  */
    /* UPDATE OWING ROWS  */
    for
      select P.ID_AR_OWING, P.SUM_OWING, O.SUM_OWING, O.REST_OWING, O.CURR_OWING
      from   AR_OWING_PAYMENT_POST P
             join AR_OWING O on O.ID_AR_OWING = P.ID_AR_OWING
      where  P.ID_TRANSACTION = current_transaction
      into   :id_ar_owing, :transaction_owing_sum, :sum_owing, :rest_owing, :owing_curr
    do begin
      if ( abs(:REST_OWING) < abs(:TRANSACTION_OWING_SUM) ) then
        exception ACCOUNT_RECEIVABLE_EXCEPTION '-603';

      REST_OWING = :REST_OWING - :TRANSACTION_OWING_SUM;
      if ( :rest_owing = 0 ) then
        owing_status = 21;
      else
        owing_status = 12;

      execute procedure AR_OWING_REST_MODIFY$INT(:ID_AR_OWING, :REST_OWING, :owing_curr, :OWING_STATUS);

    end
    /* END OF UPDATE OWING ROWS  */
  end else if ( :operation = 'anul_link' ) then begin
    /* UPDATE PAYMENT ROWS */
    for
      select PP.SUM_PAYMENT, PP.ID_AR_PAYMENT, P.SUM_PAYMENT, P.REST_PAYMENT, P.PAYMENT_STATUS, c.ROUND_TO
      from   AR_OWING_PAYMENT_POST PP
             join AR_PAYMENT P on P.ID_AR_PAYMENT = PP.ID_AR_PAYMENT
             join CURRS C on c.CURR = p.CURR_PAYMENT
      where  PP.ID_TRANSACTION = current_transaction
      into   :transaction_payment, :id_ar_payment, :sum_payment, :rest_payment, :curr_payment_status, :round_to_payment
    do begin
      if ( :rest_payment - :transaction_payment = :sum_payment ) then begin
        payment_status = 11;
      end else begin
        if (:transaction_payment = 0) then
          payment_status = :curr_payment_status;
        else
          payment_status = 12;
      end
  
      update AR_PAYMENT A
      set    A.REST_PAYMENT = round_f(A.REST_PAYMENT - :transaction_payment, :round_to_payment),
             A.PAYMENT_STATUS = :payment_status
      where  A.ID_AR_PAYMENT = :ID_AR_PAYMENT;
    end /* END OF UPDATE PAYMENT ROW  */
    /* UPDATE OWING ROWS  */
    for
      select P.ID_AR_OWING, P.SUM_OWING, O.SUM_OWING, O.REST_OWING, O.OWING_STATUS, o.CURR_OWING
      from   AR_OWING_PAYMENT_POST P
             join AR_OWING O on O.ID_AR_OWING = P.ID_AR_OWING
      where  P.ID_TRANSACTION = current_transaction
      into   :id_ar_owing, :transaction_owing_sum, :sum_owing, :rest_owing, :owing_status, :owing_curr
    do begin
      REST_OWING = :REST_OWING - :TRANSACTION_OWING_SUM;
      if ( :rest_owing = :sum_owing ) then begin
        owing_status = 11;
      end else begin
        owing_status = 12;
      end

      execute procedure AR_OWING_REST_MODIFY$INT(:ID_AR_OWING, :REST_OWING, :owing_curr, :OWING_STATUS);

    end
    /* END OF UPDATE OWING ROWS  */
  end else if ( :operation = 'anul_pay' ) then begin
    /* UPDATE PAYMENT ROW  */
    payment_status = 22;
    for
      select PP.ID_AR_PAYMENT
      from   AR_OWING_PAYMENT_POST PP
      where  PP.ID_TRANSACTION = current_transaction
      into   :id_ar_payment
    do begin
      update AR_PAYMENT A
      set    A.REST_PAYMENT = A.SUM_PAYMENT,
             A.PAYMENT_STATUS = :PAYMENT_STATUS
      where  A.ID_AR_PAYMENT = :id_ar_payment;
    end
    /* END OF UPDATE PAYMENT ROW  */
    /* UPDATE OWING ROWS  */
    for
      select P.ID_AR_OWING, P.SUM_OWING, O.SUM_OWING, O.REST_OWING, O.OWING_STATUS, o.CURR_OWING
      from   AR_OWING_PAYMENT_POST P
             join AR_OWING O on O.ID_AR_OWING = P.ID_AR_OWING
      where  P.ID_TRANSACTION = current_transaction
      into   :id_ar_owing, :transaction_owing_sum, :sum_owing, :rest_owing, :owing_status, :owing_curr
    do begin
      rest_owing = :rest_owing - :transaction_owing_sum;
      if ( :rest_owing = :sum_owing ) then begin
        owing_status = 11;
      end else begin
        owing_status = 12;
      end

      execute procedure AR_OWING_REST_MODIFY$INT (:ID_AR_OWING, :REST_OWING, :owing_curr, :OWING_STATUS);

    end
    /* END OF UPDATE OWING ROWS  */
  end else if ( :operation = 'anul_owing' ) then begin
    /* UPDATE PAYMENT ROWS  */
    for
      select P.ID_AR_PAYMENT, P.SUM_PAYMENT, O.SUM_PAYMENT, O.REST_PAYMENT, c.ROUND_TO
      from   AR_OWING_PAYMENT_POST P
             join AR_PAYMENT O on O.ID_AR_PAYMENT = P.ID_AR_PAYMENT
             join CURRS C on c.CURR = p.CURR_PAYMENT
      where  P.ID_TRANSACTION = current_transaction
      into   :id_ar_payment, :transaction_payment, :sum_payment, :rest_payment, :round_to_payment
    do begin
      if ( :rest_payment - :transaction_payment = :sum_payment ) then begin
        payment_status = 11;
      end else begin
        payment_status = 12;
      end
      update AR_PAYMENT A
      set    A.REST_PAYMENT = round_f(A.REST_PAYMENT - :transaction_payment, :round_to_payment),
             A.PAYMENT_STATUS = :payment_status
      where  A.ID_AR_PAYMENT = :id_ar_payment;
    end
    /* END OF UPDATE PAYMENT ROWS  */
  end
end
^

/* Alter (AR_OWING_ANUL$INT) */
ALTER PROCEDURE AR_OWING_ANUL$INT(ID_AR_OWING TYPE OF ID,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
IS_MANUAL_ANUL TYPE OF TLOGICAL = 1)
 RETURNS(NEW_ID_AR_OWING TYPE OF ID)
 AS
declare variable system_date type of TDATE;
  declare variable curr_id integer;
  declare variable owing_status smallint;
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable id_doc_head integer;
  declare variable sum_owing numeric(15,4) ;
  declare variable curr_owing char(3);
  declare variable id_profile integer;
begin

    select O.OWING_STATUS, O.ID_DOC, SDG.SYSTEM_DATE, o.SUM_OWING, o.CURR_OWING, o.ID_PROFILE
    from   AR_OWING O
           left outer join SYSTEM_DATE_GET(O.ID_HOTEL) SDG on 1=1
    where  O.ID_AR_OWING = :ID_AR_OWING
    into   :owing_status, :id_doc_head, :system_date, :sum_owing, :curr_owing, :id_profile;

    if (:OWING_STATUS = 22) then
      exception ACCOUNT_RECEIVABLE_EXCEPTION '-606' ;
    if (:IS_MANUAL_ANUL = 1 and :id_doc_head is not null) then
      exception ACCOUNT_RECEIVABLE_EXCEPTION '-609' ;

    update AR_OWING A  -- lock for update
    set    A.ID_AR_OWING = A.ID_AR_OWING,
           A.OWING_STATUS = 22,
           A.REST_OWING = :sum_owing
    where  A.ID_AR_OWING = :ID_AR_OWING;

    new_id_ar_owing = gen_id(GEN_AR_OWING_ID, 1);

    insert into AR_OWING (ID_AR_OWING, ID_PROFILE, SUM_OWING, CURR_OWING,
           USER_CREATED, DATETIME_CREATED, ID_DOC, SYSTEM_DATE,
           ID_AR_OWING_BASE, DESCRIPTION, DUE_DATE, ID_AR_TYPE, ID_HOTEL,
           REST_OWING, OWING_STATUS)
    select :new_id_ar_owing, A.ID_PROFILE, -A.SUM_OWING, A.CURR_OWING,
           user, current_timestamp, A.ID_DOC, :system_date,
           :ID_AR_OWING, :description, A.DUE_DATE, A.ID_AR_TYPE, a.ID_HOTEL,
           -A.SUM_OWING, 22
    from   AR_OWING A
    where  A.ID_AR_OWING = :ID_AR_OWING;

    for
      select A.ID_AR_OWING_PAYMENT_POST
      from   AR_OWING_PAYMENT_POST A
      where  A.ID_AR_OWING = :ID_AR_OWING
             and A.IS_ANUL = 0
      into   :curr_id
    do begin
      execute procedure AR_OWING_PAYMENT_ANUL$AR(:curr_id, :DESCRIPTION);
    end
    -- transaction finalize
    execute procedure AR_POST_FINALIZE(iif(:IS_MANUAL_ANUL = 1, 'anul_owing', 'anul_link'));

    select P.PROFILE_NAME
    from   PROFILE P
    where  P.ID_PROFILE = :id_profile
    into   :profile_name;

    action_text = substring(f_character(29) || :profile_name
                            || f_character(28) || formatfloat(:sum_owing, 'F;0.00') || ' ' || :CURR_OWING
                            || f_character(28) || :description from 1 for 255);
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :id_profile, 'OWING_ANNUL', :action_text);

end
^

/* Alter (AR_OWING_MODIFY$DOC) */
ALTER PROCEDURE AR_OWING_MODIFY$DOC(ID_DOC TYPE OF ID,
ID_PROFILE TYPE OF ID,
OWING_VALUE TYPE OF TPRICE,
OWING_CURR TYPE OF TCURRENCY,
DUE_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
ID_HOTEL TYPE OF ID,
OPERATION VARCHAR(10))
 AS
declare variable id_ar_owing integer;
  declare variable owing_type integer;
  declare variable system_date date;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add_owing, add_credit, anul');

  execute procedure SYSTEM_DATE_GET(:ID_HOTEL)
  returning_values  (:system_date);

  if (:operation in ('add_owing', 'add_credit')) then begin
    if (:OPERATION = 'add_owing') then begin
      select T.ID_AR_TYPE
      from   AR_TYPE T
      where  T.TYPE_CODE = 'RECEIVABLE'
      into   :owing_type;
    end else if (:OPERATION = 'add_credit') then begin
      select T.ID_AR_TYPE
      from   AR_TYPE T
      where  T.TYPE_CODE = 'CREDIT'
      into   :owing_type;
      OWING_VALUE = -abs(:OWING_VALUE);
    end
    id_ar_owing = null;
    execute procedure AR_OWING_ADD$INT (:ID_PROFILE, :OWING_VALUE, :OWING_CURR,
          :ID_DOC, :DUE_DATE, :SYSTEM_DATE, :DESCRIPTION, :owing_type, :ID_HOTEL)
    returning_values (:id_ar_owing);

  end else if (:operation = 'anul') then begin
    select first 1 A.ID_AR_OWING
    from   AR_OWING A
    where  A.ID_DOC = :ID_DOC
           and a.SUM_OWING = :OWING_VALUE
           and a.OWING_STATUS <> 22
    order by a.ID_AR_OWING desc    -- !!! Very important order  !!!
    into  :ID_AR_OWING;

    if (:ID_AR_OWING is null) then exit;

    execute procedure AR_OWING_ANUL$INT (:id_ar_owing, :DESCRIPTION, 0)
    returning_values (:id_ar_owing);
  end
end
^

/* Alter (AR_OWING_PAYMENT_ADD$AR) */
ALTER PROCEDURE AR_OWING_PAYMENT_ADD$AR(ID_AR_OWING INTEGER,
ID_AR_PAYMENT INTEGER,
SUM_OWING NUMERIC(15,4),
SUM_PAYMENT NUMERIC(15,4),
PAYMENT_RATE_TO_BGN NUMERIC(15,6),
OWING_RATE_TO_BGN NUMERIC(15,6),
DESCRIPTION VARCHAR(255))
 RETURNS(NEW_ID_AR_OWING_PAYMENT_POST INTEGER)
 AS
declare variable curr_payment varchar(3);
  declare variable curr_owing varchar(3);
  declare variable owing_status smallint;
  declare variable payment_status smallint;
  declare variable system_date date;
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable payment_type varchar(20);
  declare variable id_profile integer;
  declare variable id_hotel integer;
  declare variable payment_round_to numeric(15,4);
  declare variable owing_round_to numeric(15,4);
begin
  select A.CURR_PAYMENT, A.PAYMENT_STATUS, pt.PAYMENT_TYPE, c.ROUND_TO
  from   AR_PAYMENT A
         join AR_PAYMENT_TYPE PT on PT.ID_AR_PAYMENT_TYPE = a.ID_AR_PAYMENT_TYPE
         join CURRS c on c.CURR = a.CURR_PAYMENT
  where  A.ID_AR_PAYMENT = :ID_AR_PAYMENT
  into   :curr_payment, :PAYMENT_STATUS, :payment_type, :payment_round_to;

  select A.CURR_OWING, A.OWING_STATUS, P.PROFILE_NAME, p.ID_PROFILE, a.ID_HOTEL, c.ROUND_TO
  from   AR_OWING A
         join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
         join CURRS c on c.CURR = a.CURR_OWING
  where  A.ID_AR_OWING = :id_ar_owing
  into   :curr_owing, :owing_status, :profile_name, :id_profile, :id_hotel, :owing_round_to;

  if ( (:OWING_STATUS = 22) or (:PAYMENT_STATUS = 22) ) then
    exception ACCOUNT_RECEIVABLE_EXCEPTION '-604';

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  (:system_date);

  /* lock records for update */
  select P.ID_AR_PAYMENT
  from   AR_PAYMENT P
  where  P.ID_AR_PAYMENT = :ID_AR_PAYMENT
  with lock  -- lock for update
  into   :ID_AR_PAYMENT;

  select O.ID_AR_OWING
  from   AR_OWING O
  where  O.ID_AR_OWING = :ID_AR_OWING
  with lock  -- lock for update
  into   :ID_AR_OWING;

  if (:SUM_OWING = 0.00) then exception ACCOUNT_RECEIVABLE_EXCEPTION '-602';

  SUM_OWING = round_f(:SUM_OWING, :owing_round_to);
  SUM_PAYMENT = round_f(:SUM_PAYMENT, :payment_round_to);

  insert into AR_OWING_PAYMENT_POST(ID_AR_OWING, ID_AR_PAYMENT, ID_PROFILE,
         SUM_OWING, CURR_OWING, SUM_PAYMENT, CURR_PAYMENT, IS_ANUL,
         PAYMENT_RATE_TO_BGN, OWING_RATE_TO_BGN, ID_TRANSACTION, SYSTEM_DATE,
         ID_AR_OWING_PAYMENT_BASE, DESCRIPTION, USER_CREATED, DATETIME_CREATED)
  values (:ID_AR_OWING, :ID_AR_PAYMENT, :id_profile,
         :SUM_OWING, :curr_owing, :SUM_PAYMENT, :curr_payment, 0,
         :payment_rate_to_bgn, :owing_rate_to_bgn, current_transaction, :system_date,
         null, :DESCRIPTION, user, current_timestamp)
  returning ID_AR_OWING_PAYMENT_POST
  into   :new_id_ar_owing_payment_post;

  action_text = substring(f_character(29) || :profile_name
                          || f_character(28) || formatfloat(:SUM_OWING, 'F;0.00') || ' ' || :CURR_OWING
                          || f_character(28) || :payment_type
                          || f_character(28) || formatfloat(:SUM_PAYMENT, 'F;0.00') || ' ' || :CURR_PAYMENT
                          || f_character(28) || :description
                          from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'OWING_PAY', :action_text);

end
^

/* Alter (AR_OWING_PAYMENT_ANUL$AR) */
ALTER PROCEDURE AR_OWING_PAYMENT_ANUL$AR(ID_AR_OWING_PAYMENT_POST INTEGER,
DESCRIPTION VARCHAR(255))
 AS
declare variable curr_payment varchar(3);
  declare variable curr_owing varchar(3);
  declare variable is_anul smallint;
  declare variable system_date date;
  declare variable type_code varchar(10);
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable payment_type varchar(20);
  declare variable id_profile integer;
  declare variable id_hotel integer;
  declare variable sum_owing numeric(15,4);
  declare variable sum_payment numeric(15,4);
  declare variable id_ar_owing integer;
  declare variable id_ar_payment integer;
  declare variable payment_rate_to_bgn numeric(15,6);
  declare variable owing_rate_to_bgn numeric(15,6);
begin
  if (:ID_AR_OWING_PAYMENT_POST is null) then
    exception ACCOUNT_RECEIVABLE_EXCEPTION '-85' || f_character(31) || 'ID_AR_OWING_PAYMENT_POST is null';

  /* lock record for update */
  select p.ID_AR_OWING, p.ID_AR_PAYMENT, p.IS_ANUL
  from   AR_OWING_PAYMENT_POST P
  where  P.ID_AR_OWING_PAYMENT_POST = :id_ar_owing_payment_post
  with lock  -- lock for update
  into   :id_ar_owing, :id_ar_payment, :is_anul;

  if (:is_anul = 1) then exception ACCOUNT_RECEIVABLE_EXCEPTION '-605';

  select A.CURR_PAYMENT, pt.PAYMENT_TYPE
  from   AR_PAYMENT A
         join AR_PAYMENT_TYPE PT on PT.ID_AR_PAYMENT_TYPE = a.ID_AR_PAYMENT_TYPE
  where  A.ID_AR_PAYMENT = :ID_AR_PAYMENT
  into   :curr_payment, :payment_type;

  select A.CURR_OWING, P.PROFILE_NAME, p.ID_PROFILE, t.TYPE_CODE, A.ID_HOTEL
  from   AR_OWING A
         join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
         join AR_TYPE T on a.ID_AR_TYPE = T.ID_AR_TYPE
  where  A.ID_AR_OWING = :id_ar_owing
  into   :curr_owing, :profile_name, :id_profile, :type_code, :id_hotel;

  if (:type_code = 'DEPOSIT') then
    exception ACCOUNT_RECEIVABLE_EXCEPTION 'Operation (type_code=DEPOSIT) is not supported!';

  /* lock records for update */
  select P.ID_AR_PAYMENT
  from   AR_PAYMENT P
  where  P.ID_AR_PAYMENT = :ID_AR_PAYMENT
  with lock  -- lock for update
  into   :ID_AR_PAYMENT;

  select O.ID_AR_OWING
  from   AR_OWING O
  where  O.ID_AR_OWING = :ID_AR_OWING
  with lock  -- lock for update
  into   :ID_AR_OWING;

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  (:system_date);

  update AR_OWING_PAYMENT_POST A
  set    A.IS_ANUL = 1
  where  A.ID_AR_OWING_PAYMENT_POST = :ID_AR_OWING_PAYMENT_POST;

  select -P.SUM_OWING, -P.SUM_PAYMENT, P.ID_AR_OWING, P.ID_AR_PAYMENT, p.ID_PROFILE,
         P.PAYMENT_RATE_TO_BGN, P.OWING_RATE_TO_BGN, P.CURR_OWING, P.CURR_PAYMENT
  from   AR_OWING_PAYMENT_POST P
  where  P.ID_AR_OWING_PAYMENT_POST = :ID_AR_OWING_PAYMENT_POST
  into   :SUM_OWING, :SUM_PAYMENT, :ID_AR_OWING, :ID_AR_PAYMENT, :id_profile,
         :PAYMENT_RATE_TO_BGN, :OWING_RATE_TO_BGN, :CURR_OWING, :CURR_PAYMENT;

  insert into AR_OWING_PAYMENT_POST(ID_AR_OWING, ID_AR_PAYMENT, ID_PROFILE,
         SUM_OWING, CURR_OWING, SUM_PAYMENT, CURR_PAYMENT, IS_ANUL,
         PAYMENT_RATE_TO_BGN, OWING_RATE_TO_BGN, ID_TRANSACTION, SYSTEM_DATE,
         ID_AR_OWING_PAYMENT_BASE, DESCRIPTION, USER_CREATED, DATETIME_CREATED)
  values (:id_ar_owing, :id_ar_payment, :id_profile,
         :sum_owing, :curr_owing, :sum_payment, :curr_payment, 1,
         :payment_rate_to_bgn, :owing_rate_to_bgn, current_transaction, :system_date,
         :id_ar_owing_payment_post, :DESCRIPTION, user, current_timestamp);

  action_text = substring(f_character(29) || :profile_name
                          || f_character(28) || formatfloat(:sum_owing, 'F;0.00') || ' ' || :curr_owing
                          || f_character(28) || :payment_type
                          || f_character(28) || formatfloat(:sum_payment, 'F;0.00') || ' ' || :curr_payment
                          || f_character(28) || :DESCRIPTION
                          from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'OWING_PAY_ANNUL', :action_text);

end
^

/* Alter (AR_OWING_REST_MODIFY$INT) */
ALTER PROCEDURE AR_OWING_REST_MODIFY$INT(ID_AR_OWING INTEGER,
REST_OWING NUMERIC(15,4),
OWING_CURR VARCHAR(3),
OWING_STATUS SMALLINT)
 AS
declare variable round_to numeric(15,4);
begin

  select c.ROUND_TO
  from   CURRS c
  where  C.CURR = :OWING_CURR
  into   :round_to;

  update AR_OWING A
  set    A.OWING_STATUS = :owing_status,
         A.REST_OWING = round_f(:REST_OWING, :round_to)
  where  A.ID_AR_OWING = :ID_AR_OWING
         and A.OWING_STATUS < 22;   -- does not update voided owings

end
^

/* Alter (AR_PAYMENT_ADD$AR) */
ALTER PROCEDURE AR_PAYMENT_ADD$AR(ID_PROFILE TYPE OF ID,
ID_AR_PAYMENT_TYPE TYPE OF ID_REF,
ACCOUNT_NAME TYPE OF TNAME_SHORT,
SUM_PAYMENT TYPE OF TPRICE,
CURR_PAYMENT TYPE OF TCURRENCY,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
DATE_PAYMENT TYPE OF TDATE)
 RETURNS(NEW_ID_AR_PAYMENT INTEGER)
 AS
declare variable payment_status smallint;
  declare variable round_to numeric(15,6);
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable payment_type varchar(20);
begin
  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :CURR_PAYMENT
  into   :round_to;

  select p.PROFILE_NAME
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :profile_name;

  select P.PAYMENT_TYPE
  from   AR_PAYMENT_TYPE P
  where  P.ID_AR_PAYMENT_TYPE = :ID_AR_PAYMENT_TYPE
  into   :payment_type;

  payment_status = 11;
  SUM_PAYMENT = round_f(:SUM_PAYMENT, :round_to);

  new_id_ar_payment = gen_id(GEN_AR_PAYMENT_ID, 1);
  insert into AR_PAYMENT(ID_AR_PAYMENT, ID_PROFILE, SUM_PAYMENT, CURR_PAYMENT,
         USER_CREATED, DATETIME_CREATED, DESCRIPTION,
         ID_AR_PAYMENT_BASE, ID_AR_PAYMENT_TYPE, ACCOUNT_NAME,
         DATE_PAYMENT, REST_PAYMENT, PAYMENT_STATUS)
  values (:new_id_ar_payment, :ID_PROFILE, :SUM_PAYMENT, :CURR_PAYMENT,
         user, current_timestamp, :DESCRIPTION,
         null, :ID_AR_PAYMENT_TYPE, :ACCOUNT_NAME,
         :DATE_PAYMENT, :SUM_PAYMENT, :PAYMENT_STATUS);

  action_text = substring(f_character(29) || :payment_type
                          || f_character(28) || :profile_name
                          || f_character(28) || formatfloat(:SUM_PAYMENT, 'F;0.00') || ' ' || :CURR_PAYMENT from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'PAYMENT_CREATE', :action_text);

end
^

/* Alter (AR_PAYMENT_ANUL$AR) */
ALTER PROCEDURE AR_PAYMENT_ANUL$AR(ID_AR_PAYMENT INTEGER,
DESCRIPTION VARCHAR(255))
 RETURNS(NEW_ID_AR_PAYMENT INTEGER)
 AS
declare variable curr_id integer;
  declare variable payment_status smallint;
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable payment_type varchar(20);
  declare variable curr_payment char(3);
  declare variable id_profile integer;
  declare variable id_payment_type integer;
  declare variable sum_payment numeric(15,4);
begin
  if (:ID_AR_PAYMENT is null) then exit;

  select p.CURR_PAYMENT, p.ID_PROFILE, p.ID_AR_PAYMENT_TYPE, p.SUM_PAYMENT, p.PAYMENT_STATUS
  from   AR_PAYMENT P
  where  P.ID_AR_PAYMENT = :ID_AR_PAYMENT
  into   :CURR_PAYMENT, :id_profile, :id_payment_type, :sum_payment, :payment_status;

  if (:payment_status = 22) then exception ACCOUNT_RECEIVABLE_EXCEPTION '-606';

  payment_status = 22;

  update AR_PAYMENT A
  set    A.PAYMENT_STATUS = :payment_status
  where  A.ID_AR_PAYMENT = :ID_AR_PAYMENT;

  new_id_ar_payment = gen_id(GEN_AR_PAYMENT_ID, 1);

  insert into AR_PAYMENT(ID_AR_PAYMENT, ID_PROFILE, SUM_PAYMENT, CURR_PAYMENT,
         USER_CREATED, DATETIME_CREATED, DESCRIPTION,
         ID_AR_PAYMENT_BASE, ID_AR_PAYMENT_TYPE, ACCOUNT_NAME,
         DATE_PAYMENT, REST_PAYMENT, PAYMENT_STATUS)
  select :new_id_ar_payment, A.ID_PROFILE, -A.SUM_PAYMENT, A.CURR_PAYMENT,
         user, current_timestamp, :DESCRIPTION,
         :ID_AR_PAYMENT, A.ID_AR_PAYMENT_TYPE, A.ACCOUNT_NAME,
         A.DATE_PAYMENT, -A.SUM_PAYMENT, :payment_status
  from   AR_PAYMENT A
  where  A.ID_AR_PAYMENT = :id_ar_payment;

  -- storno links
  for
    select A.ID_AR_OWING_PAYMENT_POST
    from   AR_OWING_PAYMENT_POST A
    where  A.ID_AR_PAYMENT = :ID_AR_PAYMENT
           and A.IS_ANUL = 0
    into   :curr_id
  do begin
    execute procedure AR_OWING_PAYMENT_ANUL$AR(:curr_id, :DESCRIPTION);
  end
  -- transaction finalize
  execute procedure AR_POST_FINALIZE('anul_pay');

  select p.PROFILE_NAME
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :profile_name;

  select P.PAYMENT_TYPE
  from   AR_PAYMENT_TYPE P
  where  P.ID_AR_PAYMENT_TYPE = :id_payment_type
  into   :payment_type;

  action_text = substring(f_character(29) || :payment_type
                          || f_character(28) || :profile_name
                          || f_character(28) || formatfloat(:SUM_PAYMENT, 'F;0.00') || ' ' || :CURR_PAYMENT from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'PAYMENT_ANNUL', :action_text);
end
^

/* Alter (AR_PAYMENT_TYPE_MODIFY$AR) */
ALTER PROCEDURE AR_PAYMENT_TYPE_MODIFY$AR(ID_AR_PAYMENT_TYPE INTEGER,
PAYMENT_TYPE VARCHAR(30),
IS_USE SMALLINT,
OPERATION VARCHAR(3))
 RETURNS(NEW_ID_AR_PAYMENT_TYPE INTEGER)
 AS
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  NEW_ID_AR_PAYMENT_TYPE = ID_AR_PAYMENT_TYPE;
  if (:OPERATION = 'add') then begin
    NEW_ID_AR_PAYMENT_TYPE = gen_id(G_AUTO_INC_PAYMENT_TYPE, 1);
    insert into AR_PAYMENT_TYPE (ID_AR_PAYMENT_TYPE, PAYMENT_TYPE, IS_USE)
    values (:NEW_ID_AR_PAYMENT_TYPE, :PAYMENT_TYPE, :IS_USE);
  end if (:OPERATION = 'mod') then begin
    update AR_PAYMENT_TYPE pt
    set pt.PAYMENT_TYPE = :PAYMENT_TYPE,
        pt.IS_USE = :IS_USE
    where pt.ID_AR_PAYMENT_TYPE = :ID_AR_PAYMENT_TYPE;
  end if (:OPERATION = 'del') then begin
    delete from AR_PAYMENT_TYPE pt
    where pt.ID_AR_PAYMENT_TYPE = :ID_AR_PAYMENT_TYPE;
  end
end
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUP_PREPARE$AVL for: AVAILABILITY_OCCUPANCY$INT */
ALTER PROCEDURE AVAILABILITY_OCCUP_PREPARE$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS INTEGER,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUPANCY$AVL for: AVAILABILITY_OCCUPANCY$INT */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUPANCY_PREPARE for: AVAILABILITY_OCCUPANCY$INT */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY_PREPARE(FROM_DATE DATE,
TO_DATE DATE,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TEST_RATING for: AVAILABILITY_OCCUPANCY$INT */
ALTER PROCEDURE TEST_RATING RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (AVAILABILITY_OCCUPANCY$INT) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$INT(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
declare variable id_global_agent integer;
  declare variable for_date date;
  declare variable id_agent integer;
  declare variable id_room_type integer;
  declare variable g_capacity integer;
  declare variable bp_defined integer;
  declare variable c_defined integer;
  declare variable fdata integer;
  declare variable bp_is_released integer;
  declare variable c_is_released integer;
  declare variable gsts_in_house integer;
  declare variable gsts_come integer;
  declare variable gsts_gone integer;
  declare variable rooms_come integer;
  declare variable rooms_gone integer;
  declare variable id_hotel integer;
  declare variable id_b_allotment integer;
  declare variable id_c_allotment integer;
  declare variable ooo_rooms integer;
  declare variable ooi_rooms integer;
  declare variable sold_rooms integer;
  declare variable res_room_conf integer;
  declare variable res_room_notconf integer;
  declare variable res_room_wait integer;
begin
  /*  Description:   */
  HOTELS = coalesce(:HOTELS, '');
  ID_GLOBAL_AGENT = -100; /* HOLDS DATA GLOBAL FOR THE HOTEL */

  delete from SMART_OCCUP$TMP;

  for
    select RC.ID_ROOM_TYPE, RC.ID_HOTEL, RC.FOR_DATE, sum(RC.CNT_DEFINED)
    from   HOTEL_S H
           left outer join ALLOTMENT_GET$INT(H.ID_INVENTORY_ALLOTMENT, :FROM_DATE, :TO_DATE, null, 'PLAIN_PERIOD', :HOTELS) RC on 0=0
    where  ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
           and rc.ID_ROOM_TYPE is not null
    group by 1, 2, 3
    into   :ID_ROOM_TYPE, :ID_HOTEL, :FOR_DATE, :G_CAPACITY
  do begin
    execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_global_agent, :id_room_type, :id_hotel, :g_capacity);
  end

  for
    select   RM.BUSY_DATE, RM.ID_ROOM_TYPE, RM.ID_HOTEL,
             iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (18,20), :ID_GLOBAL_AGENT, coalesce(RS.ID_AGENT, RM.ID_AGENT)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 18, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 20, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 24, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_CONFIRMED', RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_NOTCONFIRMED', RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_RESERVS', RM.ID_ROOM, null))
    from     ROOM_MAGIC RM
             join HOTEL_S H on H.ID_HOTEL = RM.ID_HOTEL
             left outer join ROOMS_SHARE RS on RS.ID_ROOM_SHARE = RM.ID_ROOM_MAGIC
    where    RM.BUSY_DATE between :from_date and :to_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
             and rm.ROOM_STATUS is distinct from 'PRIVATE'
             and ((not (:RES_CONFIRMED = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_CONFIRMED'))
                  or (not (:RES_NOTCONFIRMED = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_NOTCONFIRMED'))
                  or (not (:RES_WAITING = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_RESERVS')))
    group by 1, 2, 3, 4
    into     :for_date, :id_room_type, :id_hotel, :id_agent,
             :ooo_rooms, :ooi_rooms, :sold_rooms, :res_room_conf, :res_room_notconf, :res_room_wait
  do begin
    execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
            null, :ooo_rooms, :ooi_rooms, null, :sold_rooms, :res_room_conf, :res_room_notconf, :res_room_wait);
  end

  if (:BOOKING_POSITIONS + :CONTINGENT > 0) then begin
    for
      select PA.ID_AGENT, PA.ID_BOOKING_POSITION, pa.ID_CONTINGENT
      from   PROFILE_AGENT PA
      where  (pa.ID_CONTINGENT is not null) or (pa.ID_BOOKING_POSITION is not null)
      into   :id_agent, :id_b_allotment, :id_c_allotment
    do begin
      for
        select al.for_date, al.id_room_type, al.id_hotel,
               sum(al.b_defined), max(al.b_is_released), sum(al.c_defined), max(al.c_is_released)
        from   (select ABP.FOR_DATE, ABP.ID_ROOM_TYPE, ABP.ID_HOTEL,
                       ABP.CNT_DEFINED as b_defined, ABP.IS_RELEASED as b_is_released, null as c_defined, null as c_is_released
                from   ALLOTMENT BA
                       left join ALLOTMENT_GET$INT(ba.ID_ALLOTMENT, :from_date, :to_date, null, 'RELEASES', :hotels) ABP on 1=1
                where  :BOOKING_POSITIONS = 1 and ba.ID_ALLOTMENT = :id_b_allotment
                union all
                select ACG.FOR_DATE, ACG.ID_ROOM_TYPE, ACG.ID_HOTEL, null, null, ACG.CNT_DEFINED, ACG.IS_RELEASED
                from   ALLOTMENT CA
                       left join ALLOTMENT_GET$INT(ca.ID_ALLOTMENT, :from_date, :to_date, null, '', :hotels) ACG on 1=1
                where  :CONTINGENT = 1 and CA.ID_ALLOTMENT = :id_c_allotment
               ) al
        where  al.for_date is not null
        group by 1, 2, 3
        into   :for_date, :id_room_type, :id_hotel,
               :bp_defined, :bp_is_released, :c_defined, :c_is_released
      do begin
        execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
                null, null, null, null, null, null, null, null, :c_defined, :c_is_released, :bp_defined, :bp_is_released);
      end
    end
  end

  if (:OVERBOOK = 1) then begin
    for
      select ACG.FOR_DATE, ACG.ID_ROOM_TYPE, ACG.ID_HOTEL, ACG.CNT_DEFINED
      from   HOTEL_S H
             left outer join ALLOTMENT_GET$INT(H.ID_OVERBOOK_ALLOTMENT, :FROM_DATE, :TO_DATE, null, '', :HOTELS) ACG on 0=0
      where  ACG.FOR_DATE is not null
             and ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
      into   :for_date, :id_room_type, :id_hotel, :fdata
    do begin
      execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
              null, null, null, :fdata);
    end
  end

  if (:FETCH_TOTALS = 1) then begin
    for
      select RM.BUSY_DATE, RM.ID_ROOM_TYPE, RM.ID_HOTEL, RM.ID_AGENT,
             sum(RM.STAYOVER_ADULTS + RM.STAYOVER_CHILDREN + RM.ARRIVAL_ADULTS + RM.ARRIVAL_CHILDREN),
             sum(RM.ARRIVAL_ADULTS + RM.ARRIVAL_CHILDREN),
             sum(RM.DEPARTURE_ADULTS + RM.DEPARTURE_CHILDREN),
             sum(rm.ARRIVAL_ROOM),
             sum(rm.DEPARTURE_ROOM)
      from   HOTEL_ROOM_OCCUPANCY RM
             join HOTEL_S H on H.ID_HOTEL = RM.ID_HOTEL
      where  RM.BUSY_DATE between :from_date and :to_date
             and rm.BUSY_GROUP_TYPE in (1, 24)
             and RM.BUSY_TYPE not in ('VALUE_RESERVS')
             and ((:hotels = '') or (','||:hotels||',' containing ','||RM.ID_HOTEL||','))
      group by 1, 2, 3, 4
      into   :for_date, :id_room_type, :id_hotel, :id_agent,
               :gsts_in_house, :gsts_come, :gsts_gone, :rooms_come, :rooms_gone
    do begin
      execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
              null, null, null, null, null, null, null, null, null, null, null, null,
              :gsts_in_house, :gsts_come, :gsts_gone, :rooms_come, :rooms_gone);
    end
  end
end
^

/* Alter (AVAILABILITY_OCCUPANCY_PREPARE) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY_PREPARE(FROM_DATE DATE,
TO_DATE DATE,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
begin
  -- used from some reports - generate occupancy for selection
  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, 1, :OVERBOOK,
          :RES_CONFIRMED, :RES_NOTCONFIRMED, :RES_WAITING, :BOOKING_POSITIONS, :CONTINGENT, :HOTELS);
   
  execute procedure AVAILABILITY_OCCUPANCY_OPT$INT (:RELEASE_DATES, :OVERBOOK,
          :RES_CONFIRMED, :RES_NOTCONFIRMED, :RES_WAITING, :BOOKING_POSITIONS, :CONTINGENT);

  ID_OCCUPANCY_SESSION = current_transaction;
  suspend;
end
^

ALTER PROCEDURE DOCUMENT_AR_PAYMENTS_APPLY$INT(DOC_DBKEY CHAR(8),
OPERATION_INFO VARCHAR(100) = null)
 AS
declare variable pay_value numeric(15,4);
  declare variable pay_curr varchar(3);
  declare variable due_date date;
  declare variable id_base_doc integer;
  declare variable id_profile integer;
  declare variable id_hotel integer;
  declare variable description varchar(255);
  declare variable operation varchar(10);
begin
  for
    select DP.PAY_AMOUNT, P.PAY_CURRENCY, P.DUE_DATE, A.ID_PROFILE, D.ID_BASE_DOC, A.ID_HOTEL,
           trim(coalesce(:OPERATION_INFO || ': ', '') || D.DOC_TYPE_NAME || ' ' || D.DOC_NUM || '/' || formatdate(D.DOC_DATE, 'D;dd.mm.yyyy')),
           case when D.IS_ANUL = 1 then 'anul'
                when P.IS_STORNO = 1 then 'add_credit'
                else 'add_owing'
           end
    from   DOC_HEAD$INT D
           join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
           join DOC_PAY_USAGE DP on DP.ID_DOC_HEAD = d.ID_DOC_HEAD
           join ACCOUNT_PAYMENTS AP on ap.ID_ACCOUNT_PAYMENT = dp.ID_ACCOUNT_PAYMENT
           join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = AP.ID_PAYMENT_HEAD
                                  and coalesce(p.ID_DOC_HEAD, d.ID_DOC_HEAD) = d.ID_DOC_HEAD
           left join DOC_TYPE_PAY dt on DT.ID_DOC_TYPE = P.ID_DOC_TYPE
    where  D.RDB$DB_KEY = :DOC_DBKEY
           and DT.IS_AR_DEBT = 1
           and DT.DOC_DIRECTION = 0 /* only income docs */
    into   :pay_value, :pay_curr, :due_date, :id_profile, :id_base_doc, :id_hotel,
           :description, :operation
  do begin
    execute procedure AR_OWING_MODIFY$DOC (:id_base_doc, :id_profile,
            :pay_value, :pay_curr, :due_date, :description, :id_hotel, :operation);
  end
end
^

/* Alter (DOCUMENT_ANUL$DOC) */
ALTER PROCEDURE DOCUMENT_ANUL$DOC(ID_DOC_HEAD INTEGER,
ANUL_REASON VARCHAR(100),
MAKE_ANNUL_REPORT SMALLINT)
 AS
/**/
  declare variable id_account  integer;
  declare variable id_payment_head integer;
  declare variable for_deposit integer;
  declare variable id_base_doc integer;
  declare variable is_anul integer;
  declare variable dh_dbkey char(8);
  declare variable id_annul_protocol_num integer;
  declare variable num integer;
  declare variable doc_num varchar(20);
  declare variable system_date date;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable doc_date date;
  declare variable id_system_log integer;
  declare variable id_hotel integer;
  declare variable is_storno_doc integer;
  declare variable no_use integer;
begin

  select H.RDB$DB_KEY, H.ID_ACCOUNT, H.FOR_DEPOSIT, H.ID_BASE_DOC, H.IS_ANUL, A.ID_HOTEL,
         A.ID_RESERV_DETAIL, T.ID_ANNUL_DOC_NUM, h.DOC_DATE, H.IS_STORNO
  from   DOC_HEAD$INT H
         join DOC_COMPLETION dc on dc.ID_DOC_HEAD = h.ID_DOC_HEAD
         join DOC_TYPE T on H.ID_DOC_TYPE = T.ID_DOC_TYPE
         join DOC_TYPE_INV DTI on DTI.ID_DOC_TYPE = T.ID_DOC_TYPE
         join ACCOUNT A on A.ID_ACCOUNT = H.ID_ACCOUNT
  where  H.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :dh_dbkey, :id_account, :for_deposit, :id_base_doc, :is_anul, :id_hotel,
         :id_reserv_detail, :id_annul_protocol_num, :doc_date, :is_storno_doc;

  if (:is_anul = 1) then
    exception DOCUMENT_ANNUL_EXCEPTION '-352'; --'Document is already annul';

  if (exists (select D.ID_DOC
              from   DOC_HEAD D
              where  D.ID_BASE_DOC = :ID_BASE_DOC
                     and D.ID_DOC > :ID_DOC_HEAD
                     and D.IS_ANUL = 0))
  then exception DOCUMENT_ANNUL_EXCEPTION '-314';

  execute procedure SYSTEM_DATE_GET(:ID_HOTEL)
  returning_values  :system_date;

  if (:DOC_DATE < :SYSTEM_DATE) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_PREV_DATE');
  end
  /* unarchive account and set as credit account, for shecked out bookings only */
  execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:ID_ACCOUNT, 0);

  if (:ID_RESERV_DETAIL is not null) then begin
    select RD.CHECK_STATUS
    from   RESERV_DETAIL RD
    where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :check_status;

    if (:check_status = 1) then begin
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, null, 1);
    end
  end
  /* MARK THE DOCUMENT AS ANUL - before posting and payment updates */
  update DOC_HEAD$INT DH
  set    DH.IS_ANUL = 1
  where  DH.RDB$DB_KEY = :dh_dbkey;

  update DOC_COMPLETION Dc
  set    Dc.IS_EFAKTURA_EXPORTED = 0
  where  Dc.ID_DOC_HEAD = :ID_DOC_HEAD;


  if (:is_storno_doc = 1) then begin
    /* annul storno doc */
    update DOC_HEAD$INT BD
    set    BD.IS_STORNED = 0
    where  BD.ID_DOC_HEAD = :id_base_doc
           and BD.IS_STORNED = 1;
  end
  /* RELEASE ACCOUNT_POSTS */
  if (:for_deposit = 0) then
    execute procedure ACCOUNT_POSTING_DOC_UPDATE$INT (:DH_DBKEY)
    returning_values (:no_use);

  /* PAYMENTS REFLECTION */
  for
    select PH.ID_PAYMENT_HEAD
    from   PAYMENT_HEAD PH
           join DOC_TYPE_PAY dt on dt.ID_DOC_TYPE = ph.ID_DOC_TYPE
    where  PH.ID_DOC_HEAD = :ID_DOC_HEAD
           and PH.IS_STORNED = 0
    into   :ID_PAYMENT_HEAD
  do begin

    execute procedure PAYMENT_ANUL$INT (:ID_PAYMENT_HEAD, :ANUL_REASON);
  end

  /* ANNUL_PROTOCOL creating section */
  NUM = null;
  DOC_NUM = null;
  if (:MAKE_ANNUL_REPORT = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_WITH_PROT');

    if (:ID_ANNUL_PROTOCOL_NUM is null) then exception DOCUMENT_ANNUL_EXCEPTION '-345';

    execute procedure SYSTEM_GEN_NUM ('ANNUL_PROT', :ID_ANNUL_PROTOCOL_NUM)
    returning_values  (:num, :doc_num);
  end
  /* log annul event */
  execute procedure SYSTEM_EVENT_LOG$INT ('DOCUMENT', :ID_DOC_HEAD, 'ANNUL', f_character(29)||:ANUL_REASON)
  returning_values  :id_system_log;

  insert into DOC_ANNULMENT (ID_DOC_HEAD, ANNULMENT_DATE, ID_PROT_DOC_NUM, PROT_NUM, PROT_DOC_NUM, ID_LOG_EVENT)
  values (:ID_DOC_HEAD, :SYSTEM_DATE, :ID_ANNUL_PROTOCOL_NUM, :NUM, :DOC_NUM, :ID_SYSTEM_LOG);
  /* reflect annul date on doc release dates */
  if (:DOC_DATE < :SYSTEM_DATE) then begin
    insert into DOC_RELEASE_DATE (ID_DOC_HEAD, RELEASE_DATE, VALUE_CORR_INDEX)
    values (:ID_DOC_HEAD, :SYSTEM_DATE, -1);
  end else begin
    update DOC_RELEASE_DATE RD
    set    RD.VALUE_CORR_INDEX = 0
    where  RD.ID_DOC_HEAD = :ID_DOC_HEAD
           and RD.RELEASE_DATE = :DOC_DATE;
  end
  /* reflect on AR module */
  execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT (:DH_DBKEY, :ANUL_REASON);
  /* reflect on client loyalty module */
  execute procedure DOCUMENT_BONUSPOINTS_VOID$CL (:ID_DOC_HEAD);

end
^

/* Alter (DOCUMENT_DELETE$DOC) */
ALTER PROCEDURE DOCUMENT_DELETE$DOC(ID_DOC_HEAD INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_account_post integer;
  declare variable id_doc integer;
  declare variable doc_num varchar(20);
  declare variable doc_type_name varchar(50);
  declare variable doc_date date;
  declare variable action_text varchar(255);
  declare variable id_base_doc integer;
  declare variable id_doc_num integer;
  declare variable num_dbkey char(8);
  declare variable doc_dbkey char(8);
  declare variable last_num integer;
  declare variable num integer;
  declare variable id_doc_line integer;
  declare variable for_deposit smallint;
  declare variable is_anul smallint;
begin

  select DH.ID_BASE_DOC, dh.IS_ANUL
  from   DOC_HEAD$INT DH
  where  DH.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :id_base_doc, :is_anul;

  if (:id_base_doc is distinct from :ID_DOC_HEAD and :is_anul = 0) then
    exception DOCUMENT_EXCEPTION '-342'; /* base doc is not selected to delete */

  for
    select D.ID_DOC_NUM, D.ID_DOC_HEAD, D.DOC_NUM, D.NUM, D.DOC_TYPE_NAME, D.DOC_DATE, d.FOR_DEPOSIT, D.RDB$DB_KEY
    from   DOC_HEAD$INT D
    where  (D.ID_BASE_DOC = :ID_DOC_HEAD and :is_anul = 0)
           or (d.ID_DOC_HEAD = :ID_DOC_HEAD and :is_anul = 1)
    order by D.ID_DOC_NUM asc, D.ID_DOC_HEAD desc
    into   :id_doc_num, :id_doc, :doc_num, :num, :doc_type_name, :doc_date, :for_deposit, :doc_dbkey
  do begin
    if (:is_anul = 0) then begin
      for
        select PV.ID_ACCOUNT_POST
        from   DOC_LINE dl
               join DOC_LINE_POST_VALUES pv on PV.ID_DOC_LINE = dl.ID_DOC_LINE
        where  DL.ID_DOC_HEAD = :id_doc
        order by Dl.ID_DOC_LINE desc
        into   :id_account_post
      do begin
        update ACCOUNT_POST AP
        set    AP.IN_DOC_QTY = 0,
               AP.IN_DOC_VALUE = 0,
               AP.AC = iif(AP.QTY_POST = 0, '10', '00'),
               AP.IS_ANUL = iif(AP.QTY_POST = 0, 1, 0),
               AP.ID_BASE_DOC = null
        where  AP.ID_ACCOUNT_POST = :id_account_post
               and AP.ID_BASE_DOC = :ID_DOC_HEAD;
      end
    end
    /*   */
    action_text = f_character(29) || :doc_type_name || ' ' || :doc_num || '/' || formatdate(:doc_date, 'D;dd.mm.yyyy');
    execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :id_doc, 'DELETE', :action_text);

    if (:is_anul = 0 and exists (select p.ID_PAYMENT_HEAD
                                 from   PAYMENT_HEAD P
                                        join PAYMENT_TYPE pt on pt.ID_PAYMENT_TYPE = p.ID_PAYMENT_TYPE and pt.IS_AR_DEBT = 1
                                 where  p.ID_DOC_HEAD = :id_doc)) then begin
      /* Account recievables check*/
      update DOC_HEAD$INT DH
      set    dh.IS_ANUL = 1
      where  DH.RDB$DB_KEY = :doc_dbkey;
  
      execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT(:doc_dbkey);
    end

    if (:for_deposit = 1) then begin
      for
        select dl.ID_DOC_LINE
        from   DOC_LINE dl
        where  dl.ID_DOC_HEAD = :id_doc
        into   :id_doc_line
      do begin
        delete from DOC_LINE_DEP_VALUES dv
        where  dv.ID_DOC_LINE = :id_doc_line;
      end 
    end

    delete from PAYMENT_HEAD P
    where  P.ID_DOC_HEAD = :id_doc;

    delete from DOC_HEAD$INT dh
    where  dh.ID_DOC_HEAD = :id_doc;

    -- reset numerator if deleted document is the last
    select coalesce(max(d.NUM), 0)
    from   DOC_HEAD D
    where  D.ID_DOC_NUM = :id_doc_num
    into   :last_num;

    if (:last_num < :num) then begin
      select SN.RDB$DB_KEY
      from   SYSTEM_NUMERATOR SN
      where  SN.ID_NUMERATOR = :id_doc_num
      into   :num_dbkey;
  
      execute procedure SYSTEM_GEN_NUM$INT (:num_dbkey, :last_num)
      returning_values  (:dbg);
--        if (:err_code <> 0) then exception NUMERATOR_EXCEPTION;
    end

  end
  /*   */
end
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_REFUND$DOC for: DOCUMENT_VALIDATE$DOC */
ALTER PROCEDURE DEPOSIT_REFUND$DOC(ID_DEPOSIT INTEGER,
REFUND_AMOUNT NUMERIC(15,4),
REFUND_CURRENCY VARCHAR(3),
ID_PAY_DOC_TYPE INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_REFUND_PAYMENT INTEGER,
ID_STORNO_DOC INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TEST_DOC for: DOCUMENT_VALIDATE$DOC */
ALTER PROCEDURE TEST_DOC(ID_ACCOUNT INTEGER,
DOC_SELECTED INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOCUMENT_VALIDATE$DOC) */
ALTER PROCEDURE DOCUMENT_VALIDATE$DOC(ID_DOC_HEAD TYPE OF ID_REF)
 RETURNS(FIRM_DATA TYPE OF TNOTE_BLOB,
WARN_CODE TYPE OF TRANGE,
NEW_DOC_DATE TYPE OF TDATE)
 AS
declare variable no_use varchar(255);
  declare variable doc_value numeric(15,4);
  declare variable rest_value numeric(15,4);
  declare variable lines_value numeric(15,4);
  declare variable lines_wot_vat numeric(15,4);
  declare variable tax_value numeric(15,4);
  declare variable taxable_value numeric(15,4);
  declare variable round_to numeric(15,4);
  declare variable id_doc_contragent integer;
  declare variable id_doc_supplier integer;
  declare variable for_deposit integer;
  declare variable id_profile integer;
  declare variable dbkey char(8);
  declare variable id_contragent integer;
  declare variable ident_no varchar(30) ;
  declare variable action_text varchar(255);
  declare variable doc_currency varchar(3);
  declare variable is_juridical_person smallint;
  declare variable vat_ident_no varchar(30);
  declare variable id_doc_type integer;
  declare variable doc_sub_type integer;
  declare variable required_ident_no smallint;
  declare variable required_vat_no smallint;
  declare variable required_egn smallint;
  declare variable required_recipient_name smallint;
  declare variable lines_count integer;
  declare variable recipient_name varchar(100);
  declare variable id_doc_completed integer;
  declare variable action_code varchar(50);
begin

  select D.RDB$DB_KEY, D.DOC_VALUE_A, C.ROUND_TO,
         D.ID_DOC_CONTRAGENT, D.ID_DOC_SUPPLIER, D.FOR_DEPOSIT,
         A.ID_PROFILE, D.DOC_CURRENCY, D.TAXABLE_VALUE, d.ID_DOC_TYPE, d.DOC_SUB_TYPE,
         dc.ID_DOC_HEAD, ds.FIRM_DATA
  from   DOC_HEAD$INT D
         join CURRS C on C.CURR = D.DOC_CURRENCY
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         left outer join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
         left outer join DOC_SUPPLIER ds on ds.ID_DOC_SUPPLIER = d.ID_DOC_SUPPLIER
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :dbkey, :doc_value, :round_to,
         :id_doc_contragent, :id_doc_supplier, :for_deposit,
         :id_profile, :doc_currency, :taxable_value, :id_doc_type, :doc_sub_type,
         :id_doc_completed, :FIRM_DATA;

  if (:id_doc_contragent is null) then
    exception DOCUMENT_EXCEPTION '-356'; --'Contragent is not set!';

  if (:id_doc_supplier is null) then
    exception DOCUMENT_EXCEPTION '-357'; --'Supplier is not set!';

  select sum(DT.TAX_VALUE)
  from   DOC_TAXES DT
  where  DT.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :tax_value;

  /*if (round_f(:doc_value - :total_value, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Total value is not correct!';
  */
  select round_f(sum(DL.SINGLE_VALUE * DL.QTY_POST), :round_to),
         round_f(sum(DL.WOT_VAT), :round_to),
         count(*)
  from   DOC_LINE DL
  where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :lines_value, :lines_wot_vat, :lines_count;
 
  if (:lines_count = 0) then
    exception INTERNAL_DOC_EXCEPTION 'Document is empty! Not exists sale lines!';

  if (round_f(:doc_value - :lines_value, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines total value is not correct!' || :doc_value ||  ' / ' || :lines_value || ' ; '|| (:doc_value - :tax_value) ||  ' / ' || :lines_wot_vat;

  if (round_f(:doc_value - :tax_value - :lines_wot_vat, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines wot tax value is not correct!';

  if (round_f(abs(:lines_wot_vat) - abs(:taxable_value), :round_to) < 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines wot tax value is less than total taxable value!';

  if (:id_doc_completed is not null) then begin
    select DV.PAYABLE_VALUE
    from   DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, null) DV
    into   :rest_value;
  
    if (round_f(:rest_value, :round_to) <> 0) then
      exception DOCUMENT_EXCEPTION '-371'; --'Insufficient amount of payments !';
  end

  /* Validate contragent data */
  select dt.REQUIRED_IDENT_NO, dt.REQUIRED_VAT_NO, dt.REQUIRED_EGN, dt.REQUIRED_RECIPIENT_NAME
  from   DOC_TYPE_INV DT
  where  dt.ID_DOC_TYPE = :id_doc_type
  into   :required_ident_no, :required_vat_no, :required_egn, :required_recipient_name;

  select dc.ID_CONTRAGENT, dc.IS_JURIDICAL_PERSON,
         trim(coalesce(dc.IDENT_NO, '')), trim(coalesce(dc.VAT_REG_NUM, '')),
         trim(coalesce(dc.RECIPIENT_NAME, ''))
  from   DOC_CONTRAGENT dc
  where  dc.ID_DOC_CONTRAGENT = :id_doc_contragent
  into   :id_contragent, :is_juridical_person, :ident_no, :vat_ident_no, :recipient_name;

  if (:doc_sub_type = 0 and :required_ident_no = 1 and :is_juridical_person = 1 and :ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-324'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_egn = 1 and :is_juridical_person = 0 and :ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-324'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_vat_no = 1 and :is_juridical_person = 1 and :vat_ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-326'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_recipient_name = 1 and :recipient_name = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-327'; --'Recipient_name is empty.';
  /*if (:post_address = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-325'; --'Contragent address is empty.';
  /* save contragent link for profile */
  if (:id_contragent is not null) then begin
    update PROFILE P
    set    P.ID_DEF_CONTRAGENT = :id_contragent
    where  P.ID_PROFILE = :id_profile
           and P.ID_DEF_CONTRAGENT is null;
  end

  /*  */
  execute procedure DOC_CHECK_FISCAL$INT(:dbkey);
  /*  */
  execute procedure DOCUMENT_SET_NUMBER$INT (:dbkey)
  returning_values (:no_use, :no_use);
  /*  */
  if (:id_doc_completed is not null) then begin
    if (:for_deposit = 0) then begin
      /* update account posts */
      execute procedure ACCOUNT_POSTING_DOC_UPDATE$INT (:dbkey)
      returning_values :WARN_CODE;
    end

    execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT (:dbkey);
    /* ... */
    execute procedure DOCUMENT_BONUSPOINTS_APPLY$CL (:ID_DOC_HEAD);
    /* ... */
  end
  /*  */
  action_text = f_character(29) || formatfloat(:doc_value, 'F;0.00') || ' ' || :doc_currency;
  action_code = iif(:id_doc_completed is null,  'PROFORMA_CREATE', 'CREATE');
  execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :ID_DOC_HEAD, :action_code, :action_text);

  select cast('31.12.1899' as date) + count(d.ID_DOC_HEAD)
  from   DOC_HEAD$INT d
  where  d.DOC_DATE is not null
  into   :NEW_DOC_DATE;

end
^

/* Alter (EAI_EXT_ROOM_STATUS) */
ALTER PROCEDURE EAI_EXT_ROOM_STATUS(ROOMS_FILTER VARCHAR(512) = '',
ID_HOTEL INTEGER = null)
 RETURNS(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
GUEST_NAME2 VARCHAR(50),
ROOM_NAME VARCHAR(10),
FROM_DATE DATE,
TO_DATE DATE,
COUNTRY VARCHAR(30),
AGE INTEGER,
ID_AGENT INTEGER,
ID_GROUP INTEGER,
SEX CHAR,
GUEST_CODE VARCHAR(50),
GUESTS_IN_ROOM INTEGER)
 AS
declare variable sys_date date;
  declare variable is_free integer;
begin
  if (:ID_HOTEL is null) then begin
    if (singular(select HS.ID_HOTEL
                 from HOTEL_S HS
                 where HS.IS_USE = 1)) then
      select H.ID_HOTEL
      from   HOTEL_S H
      where  H.IS_USE = 1
      into   :id_hotel;
    else
      exception assert '-1044';
  end

  select SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel)
  into   :SYS_DATE;

  for
    select R.ROOM_NAME,
           sum(Ro.ARRIVAL_ADULTS + ro.ARRIVAL_CHILDREN + ro.STAYOVER_ADULTS + ro.STAYOVER_CHILDREN),
           iif(sum(ro.ARRIVAL_ROOM + ro.STAYOVER_ROOM + ro.OOI_ROOM) > 0, 0, 1)
    from   ROOMS r
           join ROOM_PERIOD$PMS rp on rp.ID_ROOM = r.ID_ROOM
           left outer join HOTEL_ROOM_OCCUPANCY ro on ro.ID_ROOM = r.ID_ROOM
                                                      and ro.BUSY_DATE = :sys_date
                                                      and ro.ID_HOTEL = :ID_HOTEL
    where  r.ID_HOTEL = :ID_HOTEL
           and rp.FROM_DATE <= :sys_date
           and rp.TO_DATE >= :sys_date
           and rp.STATUS in ('HOTEL', 'CONTRACT')
    group by 1
    into   :room_name, :guests_in_room, :is_free
  do begin
    if (:is_free = 1) then begin
      id_guest = null;
      guest_name1 = null;
      guest_name2 = null;
      from_date = null;
      to_date = null;
      country = null;
      id_agent = null;
      id_group = null;
      sex = null;
      guests_in_room = 0;
      guest_code = null;
      suspend;
    end else begin
      for
        select RG.ID_GUEST, RG.GUEST_NAME1, RG.GUEST_NAME2, RG.FROM_DATE, RG.TO_DATE,
               RG.COUNTRY, RG.ID_AGENT, RG.ID_GROUP, RG.SEX, RG.GUEST_CODE, rg.AGE
        from   EAI_EXT_ROOM_GUESTS(:room_name) RG
        into   :id_guest, :guest_name1, :guest_name2, :from_date, :to_date,
               :country, :id_agent, :id_group, :sex, :guest_code, :AGE
      do suspend;
    end
  end
end
^

/* Alter (EAI_POS_GET_GUESTS$P2E) */
ALTER PROCEDURE EAI_POS_GET_GUESTS$P2E(IN_ROOM_NAME VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(OUT_ID_GUEST INTEGER,
OUT_GUEST_NAME VARCHAR(100),
OUT_FROM_DATE DATE,
OUT_TO_DATE DATE,
OUT_OK_FOR_POST INTEGER,
OUT_COUNTRY VARCHAR(30),
OUT_TEXT VARCHAR(100),
OUT_BOARD_NAME VARCHAR(30),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100))
 AS
declare variable id_room integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  OUT_GUEST_NAME = null;

  /*FIND ROOM*/
  select R.ID_ROOM
  from   ROOMS R
         join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
  where  R.ROOM_NAME = :IN_ROOM_NAME
         and RT.ID_HOTEL = :ID_HOTEL
  into   :ID_ROOM;
  if ((:ID_ROOM is null) or (:ID_ROOM <= 0) ) then begin
    ERR_CODE = -5;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Room number not found!    ! ';
    suspend;
    exit;
  end

  /*FIND GUESTS*/
  for
    select G.ID_GUEST, GC.GUEST_NAME1, G.FROM_DATE, G.TO_DATE, C.COUNTRY_NAME,
           (select m.NAME
            from   GUEST_STAY gs
                   join MEALS M on m.ID_BOARD = gs.ID_BOARD
            where  gs.ID_GUEST = g.ID_GUEST
                   and gs.FOR_DATE = iif(current_date = g.to_date, current_date - 1, current_date))
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
           left outer join GUEST_CARD GC on G.ID_GUEST = GC.ID_GUEST
           left outer join COUNTRY C on C.COUNTRY_CODE = GC.COUNTRY
    where  G.ID_ROOM = :ID_ROOM
           and G.CHECK_STATUS = 0
           and rd.IS_ANUL = 0
    into   :OUT_ID_GUEST, :OUT_GUEST_NAME, :OUT_FROM_DATE,  :OUT_TO_DATE, :OUT_COUNTRY, :OUT_BOARD_NAME
  do begin
    OUT_OK_FOR_POST = iif(:OUT_TO_DATE < current_date, 0, 1) ;
    suspend;
  end

  if (:OUT_GUEST_NAME is null) then begin
    ERR_CODE = -1;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Guests not found!     !';
    suspend;
  end
end
^

/* Alter (EAI_RESROOM_STATUS) */
ALTER PROCEDURE EAI_RESROOM_STATUS(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(50),
LINE_NAME VARCHAR(50),
PROFILE_NAME VARCHAR(100),
IS_FREE INTEGER)
 AS
declare variable id_reserv_detail_ integer;
begin

  for
    select distinct GS.ID_ROOM
    from   GUEST G
           join GUEST_STAY GS on GS.ID_GUEST = G.ID_GUEST
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_room
  do begin
    id_reserv_detail_ = null;
    PROFILE_NAME = null;
    IS_FREE = null;
    ROOM_NAME = null;
    LINE_NAME = null;
    for
      select distinct R.ROOM_NAME, plc.LINE, P.PROFILE_NAME, RD.ID_RESERV_DETAIL
      from   ROOMS R
             left outer join PHONE_LINE_CONVERT PLC on PLC.ROOM_NAME = R.ROOM_NAME
                                                     and PLC.ID_HOTEL = R.ID_HOTEL
             left outer join ROOM_MAGIC RM on RM.ID_ROOM = R.ID_ROOM
                                              and RM.BUSY_DATE = current_date
             left outer join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = RM.ID_RESERV_DETAIL
                                                 and RD.CHECK_STATUS = 0
             left outer join PROFILE P on P.ID_PROFILE = rd.ID_PERSON_PROFILE
      where  R.ID_ROOM = :ID_ROOM
      order by rm.DAY_ACTION_INT desc -- leaving reservation first
      into   :ROOM_NAME, :LINE_NAME, :PROFILE_NAME, :id_reserv_detail_
    do begin
      IS_FREE = iif(:id_reserv_detail_ is null, 1, 0);
      suspend;
    end
  end

end
^

/* Alter (END_WORK) */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable system_date date;
  declare variable id_room integer;
  declare variable id_end_work integer;
  declare variable last_closed_date date;
  declare variable mark_dirty_expired_block varchar(10);
  declare variable mark_dirty_occ_room varchar(10);
  declare variable lock_id integer;
  declare variable shift_no integer;
  declare variable init_hotel_date date;
begin

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;
  if (:system_date >= :in_next_date) then exception END_WORK_EXCEPTION '-43';
  if (:IN_NEXT_DATE > current_date + 1) then exception END_WORK_EXCEPTION '-60';

  last_closed_date = :in_next_date - 1;

  /* LOCK THE CURRENT FINANCIAL (SYSTEM) DATE  */
  lock_id = null;
  while (:lock_id is null) do begin
    lock_id = strhash_large(:system_date || :id_hotel);
    execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'lock');
  
    when any do begin
      exception END_WORK_EXCEPTION '-337' || f_character(31) || f_character(29) || FormatDate(:system_date, 'D;dd.mm.yyyy');
    end
  end

  /* RIGHT IS REQUIRED TO CHANGE THE FINANCIAL DATE IF THERE ARE GUESTS WITH OVERDUE CHECK OUT */
  if (exists(
    select *
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
    where  G.TO_DATE <= :last_closed_date
           and G.CHECK_STATUS < 1
           and RD.ID_HOTEL = :id_hotel
           and rd.IS_ANUL = 0
  )) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('EW_OVERDUE_CHECKOUT');
  end

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', 'EW');
  -- Suppress eventual right checks into next procedures - all is permitted. Is this needed(?!?)

  update ACCOUNT_POST AP
  set    ap.ROOM_NAME = (select R.ROOM_NAME
                         from   GUEST G
                                join ROOMS R on R.ID_ROOM = G.ID_ROOM
                         where  G.ID_GUEST = ap.ID_GUEST)
  where  ap.DATE_POST between :system_date and :last_closed_date
         and ap.ID_GUEST > 0;

  select coalesce(max(ew.SHIFT_NO), 0) + 1
  from   END_WORKS ew
  where  ew.PREV_DATE = :system_date
  into   :shift_no;

  id_end_work = gen_id(G_AUTO_INC_END_WORKS, 1);
  insert into END_WORKS (ID_END_WORK, PREV_DATE, NEXT_DATE, END_WORK_KIND, SHIFT_NO, ID_HOTEL)
  values (:id_end_work, :system_date, :in_next_date, 3, :shift_no, :id_hotel);

  /* CHANGE SYSTEM DATE */
  execute procedure SYSTEM_DATE_SET(:id_hotel, :in_next_date);

  /* AUTO EXPIRATION OF ROOM NUMBERS, ROOMS AND BOOKING POSITIONS */
  execute procedure RESERVS_EXPIRE$INT(:last_closed_date, :id_hotel);

  execute procedure AGENT_CONTINGENT_EXPIRE(:system_date, :last_closed_date, null, 0, 1, :id_hotel);

  /* DELETE PERSON PROFILES WITH EXPIRATION DATE */
  execute procedure PROFILE_PERSON_EXPIRE (:in_next_date);

  execute procedure SETTING_GET_VALUE('MARK_DIRTY_EXPIRED_BLOCK', :ID_HOTEL)
  returning_values  :mark_dirty_expired_block;
  if (:mark_dirty_expired_block = '1') then begin
    for
      select distinct BR.ID_ROOM
      from   BLOCK_ROOM BR
             join ROOMS R on R.ID_ROOM = BR.ID_ROOM
      where  R.ID_HOTEL = :id_hotel
             and BR.TO_DATE >= :system_date
             and BR.TO_DATE < :in_next_date
             and BR.IS_ANNUL = 0
         into :id_room
    do begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'BLOCK_EXP', 'set_dirty');

      when any do post_event 'dummy';  -- nothing
    end
  end

  execute procedure SETTING_GET_VALUE('MARK_DIRTY_OCC_ROOM', :ID_HOTEL)
  returning_values  :mark_dirty_occ_room;
  if (:mark_dirty_occ_room = '1') then begin
    for
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
             join ROOMS R on R.ID_ROOM = rm.ID_ROOM
      where  R.ID_HOTEL = :id_hotel
             and RM.BUSY_DATE = :system_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and RM.BUSY_GROUP_TYPE = 24
      into   :id_room
    do begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'EW_DAY', 'set_dirty');

      when any do post_event 'dummy';  -- nothing
    end
  end

  /* Summary data prepare */
  if (:in_next_date > :system_date) then begin
    execute procedure SUMMARY_FINANCE_SAVE$INT (:id_end_work);

    select min(e.PREV_DATE)
    from   END_WORKS E
    where  E.ID_HOTEL = :ID_HOTEL
    into   :init_hotel_date;

    execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:id_hotel, :init_hotel_date, :last_closed_date); --TODO precise the period

    execute procedure SUMMARY_FORECAST$INT(:ID_HOTEL, :system_date);
  end

  /* Delete data from temporal tables */
  delete from RESERV_ERROR;
  delete from TMP_SMALL_OCCUP;
--  delete from GUEST g where g.id_reserv_detail is null; pri regenerirane na statistikata ne vurshi rabota
  /*  */

  execute procedure CACHES_RESOLVE;

  execute procedure SYSTEM_LOG_ADD('SYSTEM', :id_end_work, 'DAY_EW', f_character(29) || :last_closed_date);

  execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'release');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', null);

  post_event 'invalidate.end_work';
end
^

/* empty dependent procedure body */
/* Clear: GUEST_ADDRESSCARD_SET$RSV for: GUEST_ADDRESSCARD_SET$INT */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$RSV(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
EGN VARCHAR(30),
COUNTRY VARCHAR(10),
ID_STAY_REASON INTEGER,
IS_REGISTRED INTEGER,
PASS_PLACE VARCHAR(20),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_PLACE VARCHAR(30),
SEX CHAR,
MASK VARCHAR(10),
IS_CHILD INTEGER,
CAR VARCHAR(30),
KPP INTEGER,
KPP_DATE DATE,
PASS_EXP_DATE DATE,
AGE INTEGER,
BIRTH_DAY DATE,
VISA /* TDESCRIPTION_SHORT */ VARCHAR(100),
RATING_AGE INTEGER = null,
TITLE VARCHAR(10) = null,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_ADD$INT for: GUEST_ADDRESSCARD_SET$INT */
ALTER PROCEDURE RES_GUEST_ADD$INT(RD_DBKEY CHAR(8),
IS_CHILD INTEGER)
 RETURNS(NEW_ID_GUEST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_SAVE$RSV for: GUEST_ADDRESSCARD_SET$INT */
ALTER PROCEDURE RES_GUEST_SAVE$RSV(ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
GUEST_NAME1 VARCHAR(100),
AGE INTEGER,
BIRTH_DAY DATE,
IS_CHILD INTEGER,
COUNTRY_CODE VARCHAR(10) = NULL)
 RETURNS(NEW_ID_GUEST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (GUEST_ADDRESSCARD_SET$INT) */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$INT(PD_DBKEY CHAR(8),
G_DBKEY CHAR(8),
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
COUNTRY_CODE VARCHAR(10),
IS_CHILD INTEGER,
AGE INTEGER,
BIRTH_DAY DATE,
TITLE VARCHAR(10))
 AS
declare variable rd_dbkey char(8);
  declare variable old_is_child integer;
  declare variable old_birthday date;
  declare variable p_dbkey char(8);
  declare variable old_country_code varchar(10);
  declare variable from_date date;
  declare variable birthday_internal date;
begin

  select G.IS_CHILD, coalesce(:is_child, G.IS_CHILD), RD.RDB$DB_KEY, G.FROM_DATE
  from   GUEST G
         left join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
  where  G.RDB$DB_KEY = :g_dbkey
  into   :old_is_child, :is_child, :rd_dbkey, :from_date;

  select PD.COUNTRY_CODE, PD.BIRTH_DAY, P.RDB$DB_KEY
  from   PERSON_DATA PD
         left outer join PROFILE_PERSON PP on PP.ID_PERSON_DATA = PD.ID_PERSON_DATA
         left outer join PROFILE P on P.ID_PROFILE = PP.ID_PROFILE
  where  PD.RDB$DB_KEY = :pd_dbkey
  into   :old_country_code, :old_birthday, :p_dbkey;

  country_code = coalesce(:country_code, '');

  execute procedure sys_dbg('res GUEST_ADDRESSCARD_SET$INT birth_day = '||coalesce(:birth_day, 'null'));
  execute procedure sys_dbg('res GUEST_ADDRESSCARD_SET$INT old_birthday = '||coalesce(:old_birthday, 'null'));
  execute procedure sys_dbg('res GUEST_ADDRESSCARD_SET$INT age = '||coalesce(:age, 'null'));

  execute procedure GUEST_BIRTHDAY$INT(:birth_day, :age, :old_birthday, :from_date)
  returning_values  :birthday_internal, :birth_day;

  execute procedure PERSON_DATA_SET$INT(:p_dbkey, :pd_dbkey, :guest_name1, :guest_name2,
          :country_code, :birth_day, :birthday_internal, :TITLE);

  if (:old_is_child <> :is_child) then begin
    update RESERV_DETAIL RD
    set    RD.ADULT_COUNT = RD.ADULT_COUNT + (2*:old_is_child - 1),
           RD.CHILD_COUNT = RD.CHILD_COUNT - (2*:old_is_child - 1)
    where  RD.RDB$DB_KEY = :rd_dbkey;

    update GUEST G
    set    G.IS_CHILD = :is_child
    where  G.RDB$DB_KEY = :g_dbkey;
  end

  if (:old_country_code is distinct from :country_code) then begin
    update RESERV_DETAIL RD
    set    RD.COUNTRY = :country_code
    where  RD.RDB$DB_KEY = :rd_dbkey;
  end
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_GUEST$EXC for: GUEST_ADDRESSCARD_SET$RSV */
ALTER PROCEDURE IMPORT_GUEST$EXC(BOOKING_ID INTEGER,
PROFILE_UUID VARCHAR(40),
GUEST_UUID VARCHAR(40),
GUEST_NAME VARCHAR(100),
IS_CHILD SMALLINT,
AGE INTEGER,
IS_DIFFERENT_ARRANGER SMALLINT,
ARRIVAL DATE,
DEPARTURE DATE,
VOUCHER VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
RATING_AGE INTEGER,
KPP VARCHAR(50),
KPP_DATE DATE,
STAY_REASON VARCHAR(255),
CAR VARCHAR(30),
IS_REGISTRED SMALLINT,
PERSONAL_NUMBER VARCHAR(30),
TITLE VARCHAR(10),
PT_NAME VARCHAR(100),
PT_EXTCODE VARCHAR(50),
PASS_NUM VARCHAR(20),
PASS_PLACE VARCHAR(20),
PASS_DATE DATE,
PASS_EXP_DATE DATE,
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_DATE DATE,
SEX CHAR,
BIRTH_PLACE VARCHAR(30),
MASK VARCHAR(10),
PACKAGE VARCHAR(255),
VISA /* TDESCRIPTION_SHORT */ VARCHAR(100))
 RETURNS(GUEST_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (GUEST_ADDRESSCARD_SET$RSV) */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$RSV(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
EGN VARCHAR(30),
COUNTRY VARCHAR(10),
ID_STAY_REASON INTEGER,
IS_REGISTRED INTEGER,
PASS_PLACE VARCHAR(20),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_PLACE VARCHAR(30),
SEX CHAR,
MASK VARCHAR(10),
IS_CHILD INTEGER,
CAR VARCHAR(30),
KPP INTEGER,
KPP_DATE DATE,
PASS_EXP_DATE DATE,
AGE INTEGER,
BIRTH_DAY DATE,
VISA TDESCRIPTION_SHORT,
RATING_AGE INTEGER = null,
TITLE VARCHAR(10) = null,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable gd_dbkey char(8);
  declare variable pd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable rd_dbkey char(8);
  declare variable old_is_registred integer;
  declare variable old_guest_name1 varchar(250);
  declare variable old_guest_name2 varchar(250);
  declare variable old_id_pass_type integer;
  declare variable old_pass_num varchar(20);
  declare variable old_pass_date date;
  declare variable old_egn varchar(30);
  declare variable old_country varchar(20);
  declare variable old_id_stay_reason integer;
  declare variable old_kpp integer;
  declare variable old_kpp_date date;
  declare variable old_pass_exp_date date;
  declare variable old_birth_day date;
  declare variable old_pass_place varchar(20);
  declare variable old_city varchar(100);
  declare variable old_address varchar(100);
  declare variable old_visa TDESCRIPTION_SHORT;
  declare variable old_birth_place varchar(30);
  declare variable old_sex char(1);
  declare variable action_text varchar(250);
  declare variable tt_reg_number integer;
  declare variable id_hotel integer;
  declare variable id_tt_numerator integer;
  declare variable domestic_nation varchar(10);
  declare variable no_use varchar(255);
  declare variable is_anul smallint;
  declare variable acc_routing varchar(20);
begin
  err_code = 0;
  err_text = '';

  select G.RDB$DB_KEY, GD.RDB$DB_KEY, PD.RDB$DB_KEY,
         GD.IS_REGISTRED, PD.PERSON_NAME, PD.PERSON_NAME2, PD.ID_PASSPORT_TYPE, PD.PASS_NUM, PD.PASS_DATE,
         PD.EGN, PD.COUNTRY_CODE, GD.ID_STAY_REASON, GD.KPP, GD.KPP_DATE, PD.PASS_EXP_DATE,
         PD.BIRTH_DAY, PD.PASS_PLACE, PD.CITY, PD.ADDRESS, PD.BIRTH_PLACE, PD.SEX, rd.RDB$DB_KEY,
         g.TT_REG_NUMBER, rd.ID_HOTEL, rd.IS_ANUL, rd.ACC_ROUTING, GD.VISA
  from   GUEST G
         join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
         join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
         join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
  where  G.ID_GUEST = :id_guest
  into   :g_dbkey, :gd_dbkey, :pd_dbkey,
         :old_is_registred, :old_guest_name1, :old_guest_name2, :old_id_pass_type, :old_pass_num, :old_pass_date,
         :old_egn, :old_country, :old_id_stay_reason, :old_kpp, :old_kpp_date, :old_pass_exp_date,
         :old_birth_day, :old_pass_place, :old_city, :old_address, :old_birth_place, :old_sex, :rd_dbkey,
         :tt_reg_number, :id_hotel, :is_anul, :acc_routing, :old_visa;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, :birth_place, :egn, :id_passport_type, :pass_num, :pass_date, :pass_place,
          :pass_exp_date, :city, :address, :sex, :mask);

  update  GUEST_DATA GD
  set     GD.KPP_DATE = :kpp_date,
          GD.KPP = :kpp,
          GD.VISA = :visa,
          GD.ID_STAY_REASON = :id_stay_reason,
          GD.IS_REGISTRED = :is_registred,
          GD.USER_REGISTRED = iif(:IS_REGISTRED = 1, coalesce(GD.USER_REGISTRED, current_user), null),
          GD.CAR = :car,
          GD.RATING_AGE = :RATING_AGE
  where   GD.RDB$DB_KEY = :gd_dbkey;

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name1, :guest_name2, :country,
          :is_child, :age, :birth_day, :TITLE);

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -1);

  /*  */
  if (:IS_REGISTRED = 1 and :tt_reg_number is null and :is_anul = 0 and :acc_routing is distinct from 'OWNER') then begin
    execute procedure SETTING_GET_VALUE ('NATIVE_NATION', :id_hotel)
    returning_values :domestic_nation;

    select iif(:COUNTRY not in (:domestic_nation, '') and h.USE_DIFFERENT_TT_NUMERATORS = 1,
               h.ID_TT_NUMERATOR_2,
               h.ID_TT_NUMERATOR_1)
    from   HOTEL H
    where  h.ID_HOTEL = :id_hotel
    into   :id_tt_numerator;

    if (:id_tt_numerator is not null) then begin
      execute procedure SYSTEM_GEN_NUM('GUEST_NUM', :id_tt_numerator)
      returning_values :tt_reg_number, :no_use;
  
      update GUEST G
      set    g.TT_REG_NUMBER = :tt_reg_number
      where  G.RDB$DB_KEY = :g_dbkey;
    end
  end else if (:IS_REGISTRED is distinct from 1 and :tt_reg_number is not null) then begin
    update GUEST G
    set    g.TT_REG_NUMBER = null
    where  G.RDB$DB_KEY = :g_dbkey;
  end
  /*  */
  if ((:old_is_registred = 0) and (:is_registred = 1)) then begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'REGISTRED', '');
  end

  if ((:old_is_registred = 1) and (:old_guest_name1 <> :guest_name1)) then begin
    action_text = f_character(29)||:old_guest_name1||f_character(28)||:guest_name1;
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'CHANGE_CARD', :action_text);
  end

  if ((:old_IS_REGISTRED = 1)
      and
      ((:old_guest_name1 <> :guest_name1)
        or (:old_guest_name2 <> :guest_name2)
        or (:old_egn <> :egn)
        or (:old_id_pass_type <> :id_passport_type)
        or (:old_pass_num <> :pass_num)
        or (:old_pass_date <> :pass_date)
        or (:old_pass_exp_date <> :pass_exp_date)
        or (:old_pass_place <> :pass_place)
        or (:old_country <> :country)
        or (:old_city <> :city)
        or (:old_address <> :address)
        or (:old_visa <> :visa)
        or (:old_birth_day <> :birth_day)
        or (:old_birth_place <> :birth_place)
        or (:old_sex  <> :sex)
        or (:old_kpp <> :kpp)
        or (coalesce(:old_id_stay_reason,0) <> coalesce(:id_stay_reason,0))
        or (:old_kpp_date <> :kpp_date)
      )) then
  begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'PREREGISTRED', '');
  end

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
    returning_values  :warn_code;

  end

end
^

/* empty dependent procedure body */
/* Clear: RES_ANUL_DETAIL$INT for: GUEST_DEL_POSTINGS$INT */
ALTER PROCEDURE RES_ANUL_DETAIL$INT(RD_DBKEY CHAR(8),
REASON VARCHAR(50),
CANCELATION_NUMBER /* TYPE OF NAME_20 */ VARCHAR(20) = null)
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_DEL$INT for: GUEST_DEL_POSTINGS$INT */
ALTER PROCEDURE RES_GUEST_DEL$INT(ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50) = null)
 RETURNS(EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (GUEST_DEL_POSTINGS$INT) */
ALTER PROCEDURE GUEST_DEL_POSTINGS$INT(ID_GUEST INTEGER)
 RETURNS(EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable ap_dbkey char(8);
  declare variable id_master_addins_acc_post integer;
begin
  EXTRA_POSTS_LEFT = 0;
  for
    select AP.RDB$DB_KEY, AP.ID_MASTER_ADDINS_ACC_POST
    from   ACCOUNT_POST AP
    where  AP.ID_GUEST = :ID_GUEST
           and AP.IS_ANUL = 0
    into   :AP_DBKEY, :ID_MASTER_ADDINS_ACC_POST
  do begin
    if (:ID_MASTER_ADDINS_ACC_POST > 0) then begin
      execute procedure ACCOUNT_POSTING_DEL$INT (:AP_DBKEY, 'RECALC_GUEST_DELETE');
    end else begin
      /*update ACCOUNT_POST APU
      set    APU.ID_GUEST = -1
      where  APU.RDB$DB_KEY = :AP_DBKEY;
      */
      EXTRA_POSTS_LEFT = 1;
    end
  end

end
^

/* Alter (HK_PLAN_LINES_FINALIZE$HK) */
ALTER PROCEDURE HK_PLAN_LINES_FINALIZE$HK(ID_PLAN_PERIOD INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
begin
  WARN_CODE = null;

/*
  if ( exists (select *
               from   HK_PLAN_PERIOD PP
                      join HK_RESERVATION R on R.ID_HK_PLAN = PP.ID_PLAN
               where  PP.ID_PLAN_PERIOD = :ID_PLAN_PERIOD )) then begin
    execute procedure SYSTEM_WARNING_ADD(-607, 'HK_PLAN_LINES_FINALIZE$HK_1');
    WARN_CODE = current_transaction; */


  if ( exists (select *
               from   HK_RESERVATION R
                      join HK_PLAN_PERIOD PP on PP.ID_PLAN = R.ID_HK_PLAN
                      join HK_PLAN_LINE L on L.ID_PLAN_PERIOD = PP.ID_PLAN_PERIOD
                      join TMP_SELECT$HK TMP on TMP.ID_PLAN_LINE = L.ID_PLAN_LINE
                                            and TMP.ID_ROOM_TYPE = R.ID_ROOM_TYPE
               where TMP.ID_SESSION = current_transaction
                     and PP.ID_PLAN_PERIOD = :ID_PLAN_PERIOD )) then begin
    execute procedure SYSTEM_WARNING_ADD(-607, 'HK_PLAN_LINES_FINALIZE$HK')
    returning_values :WARN_CODE;
  end

  delete from TMP_SELECT$HK H
  where H.ID_SESSION = current_transaction;
end
^

/* Alter (HK_PLAN_PERIOD_MODIFY$HK) */
ALTER PROCEDURE HK_PLAN_PERIOD_MODIFY$HK(ID_PLAN_PERIOD INTEGER,
ID_PLAN INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
OPERATION VARCHAR(10))
 RETURNS(NEW_ID_PLAN_PERIOD INTEGER,
WARN_CODE INTEGER)
 AS
begin
  WARN_CODE = null;
  execute procedure SYSTEM_CHECK_OPERATION(:OPERATION, 'add, mod, del');

  if (:OPERATION in ('add', 'mod')) then begin
    if (exists (select P.FROM_DATE, P.TO_DATE
                from   HK_PLAN_PERIOD P
                where  P.ID_PLAN = :ID_PLAN
                       and P.ID_PLAN_PERIOD is distinct from :ID_PLAN_PERIOD
                       and P.FROM_DATE <= :TO_DATE
                       and P.TO_DATE >= :FROM_DATE)) then
    exception VALIDATE_EXCEPTION '-608';
  end

  if (:OPERATION = 'add') then begin
    NEW_ID_PLAN_PERIOD = gen_id(GEN_HK_PLAN_PERIOD_ID, 1);
    insert into HK_PLAN_PERIOD(ID_PLAN_PERIOD, ID_PLAN, FROM_DATE, TO_DATE)
    values (:NEW_ID_PLAN_PERIOD, :ID_PLAN, :FROM_DATE, :TO_DATE);

  end else if (:OPERATION = 'mod') then begin
    update HK_PLAN_PERIOD
    set ID_PLAN = :ID_PLAN,
        FROM_DATE = :FROM_DATE,
        TO_DATE = :TO_DATE
    where (ID_PLAN_PERIOD = :ID_PLAN_PERIOD);

  end else if (:OPERATION = 'del') then begin
    select K.FROM_DATE, K.TO_DATE
    from   HK_PLAN_PERIOD K
    where  K.ID_PLAN_PERIOD = :ID_PLAN_PERIOD
    into   :FROM_DATE, :TO_DATE;

    delete from HK_PLAN_PERIOD
    where (ID_PLAN_PERIOD = :ID_PLAN_PERIOD);
  end

  if ( exists (select *
               from   HK_RESERVATION R
               where  R.ID_HK_PLAN = :ID_PLAN
                      and R.BUSY_DATE between :FROM_DATE and :TO_DATE )) then begin
    execute procedure SYSTEM_WARNING_ADD(-607, 'HK_PLAN_PERIOD_MODIFY$HK')
    returning_values :WARN_CODE;
  end
end
^

ALTER PROCEDURE LOOKUP_CONTRAGENT$EXC(OBJECT_ID VARCHAR(100),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(100))
 RETURNS(ID INTEGER)
 AS
begin
  ID = null;
  select first 1 c.ID_CONTRAGENT
    from CONTRAGENTS c
    where (c.CONTRAGENT_NAME = :NAME)
      and (c.SUBSCRIBER_ID is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID'))
    into :ID;

  execute procedure log_id_lookup_error$exc(:OBJECT_ID, :OBJECT_TYPE, :ID, :NAME, 'contragent');
end
^

/* Alter (IMPORT_AGENT_PROFILE$EXC) */
ALTER PROCEDURE IMPORT_AGENT_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
AGENT_GROUP VARCHAR(50),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
WBE_PASSWORD VARCHAR(20),
IATA_NUMBER VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
DEF_CONTRAGENT_NAME VARCHAR(100),
THRESHOLD_NOTE VARCHAR(255),
THRESHOLD_AMOUNT NUMERIC(15,4),
THRESHOLD_CURR CHAR(3),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
declare variable op varchar(10);
  declare variable market_segment_id integer;
  declare variable agent_group_old varchar(50);
  declare variable id_bonuspoint_scheme integer;
  declare variable id_def_contragent integer;
  declare variable is_exclusive_debt_ownership smallint;
  declare variable country_code_old varchar(10);
  declare variable profile_receiver_id integer;
  declare variable discount_id integer;
begin
  profile_id = null;
  import_time = null;

  execute procedure import_mark_transaction$exc;

  execute procedure sys_dbg('exc IMPORT_AGENT_PROFILE$EXC(:profile_uuid=>' || coalesce(:profile_uuid, cast('<null>' as varchar(40)) ) || ')');
  profile_id = null;
  if (:PROFILE_UUID is null) then begin
    execute procedure sys_dbg('exc IMPORT_AGENT_PROFILE$EXC <null> :profile_uuid - exit;');
    exit;
  end

  select p.profile_id, p.profile_name, p.phone, p.fax, p.email, p.city,
         p.address, p.market_segment, p.note, p.is_archive, p.id_bonuspoint_scheme,
         p.id_def_contragent, pa.agent_group, p.wbe_password,
         p.msg, p.account_no, p.is_exclusive_debt_ownership, pa.country_code
  from   IMPORT_COMMON_PROFILE$EXC(:PROFILE_UUID, 1, :PROFILE_NAME,
         :PHONE, :FAX, :EMAIL, :CITY, :ADDRESS, :MARKET_SEGMENT, :NOTE, :IS_ARCHIVE, :WBE_PASSWORD, :ACCOUNT_NO, :MSG,  'AGENT_PROFILE', :HOTEL_UUID_LIST) p
         left outer join profile_agent pa on pa.id_profile = p.profile_id
  into   :profile_id, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :id_bonuspoint_scheme,
         :id_def_contragent, :agent_group_old, :wbe_password,
         :msg, :account_no, :is_exclusive_debt_ownership, :country_code_old;

  if (:profile_id is null) then begin
    op = 'add';
  end else if (:hotel_uuid_list is null) then begin
    profile_id = null;
    exit;
  end else begin
    op = 'mod';
    if (:hotel_uuid_list is not null) then begin
      for select d.id_sale_discount
      from sale_discount d
      join hotel h on h.id_hotel = d.id_hotel
      where :hotel_uuid_list containing h.uuid
      into :discount_id do begin
        delete from PROFILE_DISCOUNT pd
        where  pd.ID_PROFILE = :profile_id and pd.id_sale_discount = :discount_id;
      end
    end

    delete from PROFILE_BONUSPOINT_SCHEME bs
    where  bs.ID_PROFILE = :profile_id;
  end

  AGENT_GROUP=coalesce(:AGENT_GROUP, :AGENT_GROUP_OLD);
  country_code=coalesce(:country_code, :country_code_old);

  execute procedure LOOKUP_MARKET_SEGMENT$EXC(:profile_name, 'AGENT_PROFILE', :market_segment)
  returning_values :market_segment_id;

  if ((def_contragent_name is not null) and (def_contragent_name <> '')) then begin
    execute procedure LOOKUP_CONTRAGENT$EXC(:profile_name, 'AGENT_PROFILE', :def_contragent_name)
    returning_values :id_def_contragent;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:profile_name, 'AGENT_PROFILE');

  execute procedure sys_dbg('exc IMPORT_AGENT_PROFILE$EXC - profile_agent_modify$profile(:profile_uuid=>' || coalesce(:profile_uuid,cast('<null>' as varchar(40)))
    || ', :operation=>' || coalesce(:op, cast('<null>' as varchar(10)) )
    || ', :market_segment_id=>' || coalesce(cast(:market_segment_id as varchar(10)) , cast('<null>' as varchar(10)) )
    || ')');

  if (:hotel_uuid_list is null) then begin
    -- in "non authoritive" mode (i.e. embeded mode transfer only profile key fields )
    --profile_name = null;
    phone = null;
    fax = null;
    email = null;
    country_code = null;
    city = null;
    address = null;
    note = null;
    msg = null;
    --is_archive = null;
    agent_group = null;
    id_def_contragent = null;
    market_segment_id = null;
    id_bonuspoint_scheme = null;
    wbe_password = null;
    account_no = null;
    --iata_number = null;
    is_exclusive_debt_ownership = null;
  end

  execute procedure profile_agent_modify$profile(
    :profile_id, :profile_name, :phone, :fax, :email,
    :country_code, :city, :address, :note, :msg, :is_archive, :agent_group, :id_def_contragent, :market_segment_id,
    :wbe_password, :op, :account_no, :iata_number, :is_exclusive_debt_ownership,
    :threshold_note, :threshold_amount, :threshold_curr)
  returning_values :profile_id;

  /*assign UUID to the new profiles*/
  if ('add' = :op) then begin
    update profile
    set    uuid = :profile_uuid
    where  id_profile = :profile_id;
  end

  select record_timestamp
  from   profile
  where  id_profile = :profile_id
  into   :import_time;

  if (:MERGE_TARGET_UUID is not null) then begin
    select p.ID_PROFILE
    from   PROFILE P
    where  P.UUID = :MERGE_TARGET_UUID
    into   :profile_receiver_id;

    execute procedure PROFILE_MERGE$PROFILE (:PROFILE_ID, :profile_receiver_id, 'merge');

  end
end
^

/* empty dependent procedure body */
/* Clear: CREATE_BOOKING$WBE for: IMPORT_GUEST$EXC */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
 BEGIN SUSPEND; END
^

/* Alter (IMPORT_GUEST$EXC) */
ALTER PROCEDURE IMPORT_GUEST$EXC(BOOKING_ID INTEGER,
PROFILE_UUID VARCHAR(40),
GUEST_UUID VARCHAR(40),
GUEST_NAME VARCHAR(100),
IS_CHILD SMALLINT,
AGE INTEGER,
IS_DIFFERENT_ARRANGER SMALLINT,
ARRIVAL DATE,
DEPARTURE DATE,
VOUCHER VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
RATING_AGE INTEGER,
KPP VARCHAR(50),
KPP_DATE DATE,
STAY_REASON VARCHAR(255),
CAR VARCHAR(30),
IS_REGISTRED SMALLINT,
PERSONAL_NUMBER VARCHAR(30),
TITLE VARCHAR(10),
PT_NAME VARCHAR(100),
PT_EXTCODE VARCHAR(50),
PASS_NUM VARCHAR(20),
PASS_PLACE VARCHAR(20),
PASS_DATE DATE,
PASS_EXP_DATE DATE,
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_DATE DATE,
SEX CHAR,
BIRTH_PLACE VARCHAR(30),
MASK VARCHAR(10),
PACKAGE VARCHAR(255),
VISA TDESCRIPTION_SHORT)
 RETURNS(GUEST_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable warn_code integer;

declare variable birth_date_old date;
declare variable title_old varchar(10);
declare variable id_passport_type_old integer;
declare variable pass_num_old varchar(20);
declare variable pass_date_old date;
declare variable personal_number_old varchar(30);
declare variable id_stay_reason_old integer;
declare variable is_registred_old integer;
declare variable pass_place_old varchar(20);
declare variable city_old varchar(100);
declare variable address_old varchar(100);
declare variable birth_place_old varchar(30);
declare variable sex_old char(1);
declare variable mask_old varchar(10);
declare variable car_old varchar(30);
declare variable kpp_id_old integer;
declare variable kpp_date_old date;
declare variable pass_exp_date_old date;
declare variable rating_age_old integer;
declare variable visa_old tdescription_short;

declare variable guest_name_old varchar(100);
declare variable is_child_old integer;
declare variable is_different_arranger_old smallint;
declare variable arrival_old date;
declare variable departure_old date;
declare variable voucher_old varchar(30);
declare variable voucher_date_old date;
declare variable voucher_text_old varchar(30);
declare variable country_code_old varchar(10);

declare variable id_passport_type integer;
declare variable kpp_id integer;
declare variable id_stay_reason integer;
begin
  execute procedure import_mark_transaction$exc;

  guest_name = substring(:guest_name from 1 for 50);

  execute procedure sys_dbg('exc IMPORT_GUEST$EXC(:guest_uuid=>' || coalesce(:guest_uuid, '<null>') || ')');
  guest_id = null;

  select pd.person_name, --g.is_different_organizer,
         g.id_guest, g.from_date, g.to_date,
         pd.birthday_internal, pd.title, pd.id_passport_type,
         pd.pass_num, pd.pass_date, pd.egn, gd.id_stay_reason,
         gd.is_registred, pd.pass_place, pd.city, pd.address, pd.birth_place,
         pd.sex, pd.mask, g.is_child, gd.car, gd.kpp, gd.kpp_date,
         pd.pass_exp_date, gd.rating_age, g.vaucher_num, g.vaucher_date, g.vaucher_text, pd.country_code,
         gd.id_stay_reason, gd.visa
  from   GUEST g
         join guest_data gd on gd.id_guest=g.id_guest
         join person_data pd on pd.id_person_data=gd.id_person_data
  where  g.uuid=:guest_uuid
         and g.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and g.id_reserv_detail=:booking_id
  into   :guest_name_old, --:is_different_arranger_old,
         :guest_id, :arrival_old, :departure_old, :birth_date_old,
         :title_old, :id_passport_type_old,
         :pass_num_old, :pass_date_old, :personal_number_old, :id_stay_reason_old,
         :is_registred_old, :pass_place_old, :city_old, :address_old, :birth_place_old,
         :sex_old, :mask_old, :is_child_old, :car_old, :kpp_id_old, :kpp_date_old,
         :pass_exp_date_old, :rating_age_old, :voucher_old, :voucher_date_old,
         :voucher_text_old, :country_code_old, :id_stay_reason_old, :visa_old;

  execute procedure import_passport_type$exc(:pt_name, pt_extcode)
  returning_values :id_passport_type;

  execute procedure import_kpp$exc(:kpp, null)
  returning_values :kpp_id;

  execute procedure import_stay_reason$exc(:stay_reason, null)
  returning_values :id_stay_reason;

  guest_name = coalesce(:guest_name, :guest_name_old);
--  DISABLE age/is_child merge (RIU rating cases)
--  is_child = coalesce(:is_child, :is_child_old);
--  is_different_arranger = coalesce(:is_different_arranger, :is_different_arranger_old);
  arrival = coalesce(:arrival, :arrival_old);
  departure = coalesce(:departure, :departure_old);
  voucher = coalesce(:voucher, :voucher_old);
  voucher_date = coalesce(:voucher_date, :voucher_date_old);
  voucher_text = coalesce(:voucher_text, :voucher_text_old);
  country_code = coalesce(:country_code, :country_code_old);

--  DISABLE age/is_child merge (RIU rating cases)
--  rating_age = coalesce(:rating_age, :rating_age_old);
  kpp_id = coalesce(:kpp_id, :kpp_id_old);
  kpp_date = coalesce(:kpp_date, :kpp_date_old);
  id_stay_reason = coalesce(:id_stay_reason, :id_stay_reason_old);
  car = coalesce(:car, :car_old);
  is_registred = coalesce(:is_registred, 0);
  if (1 = :is_registred_old) then begin --one way update
    is_registred = 1;
  end
  personal_number = coalesce(:personal_number, :personal_number_old);
  title = coalesce(:title, :title_old);
  id_passport_type = coalesce(:id_passport_type, :id_passport_type_old);
  pass_num = coalesce(:pass_num, :pass_num_old);
  pass_place = coalesce(:pass_place, :pass_place_old);
  pass_date = coalesce(:pass_date, :pass_date_old);
  pass_exp_date = coalesce(:pass_exp_date, :pass_exp_date_old);
  city = coalesce(:city, :city_old);
  address = coalesce(:address, :address_old);
  birth_date = coalesce(:birth_date, :birth_date_old);
  sex = coalesce(:sex, :sex_old);
  birth_place = coalesce(:birth_place, :birth_place_old);
  mask = coalesce(:mask, :mask_old);
  visa = coalesce(:visa, :visa_old);

  if (guest_id is null) then begin
    execute procedure RES_GUEST_SAVE$RSV(null, :booking_id, :guest_name, null, null, :is_child, :COUNTRY_CODE)
    returning_values :guest_id;

    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - get_next_auto_guest = :guest_id=>' || coalesce(:guest_id, '<null>'));
    if (:guest_id is null) then begin 
      execute procedure sys_dbg('exc IMPORT_GUEST$EXC - exhausted auto guests list - create new guest');
      execute procedure RES_GUEST_ADD$RSV(:booking_id, :is_child)
      returning_values :err_code, :err_text, :warn_code, :guest_id;
      if (0 <> :err_code) then exit;
    end

    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - update_new_guest_uuid(:guest_id=>' || coalesce(:guest_id, '<null>') || ', :uuid=>' || coalesce(:guest_uuid, '<null>') || ')');
    update GUEST
    set    uuid = :guest_uuid
    where  id_guest=:guest_id;

    /* preserve default mask */
    if (:mask is null) then begin
      select pd.mask
      from   guest_data gd
             join person_data pd on pd.id_person_data=gd.id_person_data
      where  gd.id_guest=:guest_id
      into   :mask;
    end          
  end else begin
    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - update_guest(:update_guest_id=>' || coalesce(:guest_id, '<null>') || ')');

--    DISABLE age/is_child merge (RIU rating cases) 
--    if (:age is null) then begin
--      select age from GUEST_AGE_CALC(:guest_id)
--      into :age;
--    end
  end

  /*
  execute procedure sys_dbg('exc IMPORT_GUEST$EXC->GUEST_ADDRESSCARD_SET$RSV('
  || 'update_guest_id => ' || coalesce(:update_guest_id, '<null>')
  || ', guest_name => ' || coalesce(:guest_name, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  || ', :id_passport_type => ' || coalesce(:id_passport_type, '<null>')
  || ', :pass_num => ' || coalesce(:pass_num, '<null>')
  || ', :pass_date => ' || coalesce(:pass_date, '<null>')
  || ', :egn => ' || coalesce(:egn_old, '<null>')
  || ', :country => ' || coalesce(:country_old, '<null>')
  || ', :id_stay_reason => ' || coalesce(:id_stay_reason, '<null>')
  || ', :is_registred => ' || coalesce(:is_registred, '<null>')
  || ', :pass_place => ' || coalesce(:pass_place, '<null>')
  || ', :city => ' || coalesce(:city, '<null>')
  || ', :address => ' || coalesce(:address, '<null>')
  || ', :birth_place => ' || coalesce(:birth_place, '<null>')
  || ', :sex => ' || coalesce(:sex, '<null>')
  || ', :mask => ' || coalesce(:mask, '<null>')
  || ', :is_child => ' || coalesce(:is_child, '<null>')
  || ', :car => ' || coalesce(:car, '<null>')
  || ', :kpp => ' || coalesce(:kpp_old, '<null>')
  || ', :kpp_date => ' || coalesce(:kpp_date, '<null>')
  || ', :pass_exp_date => ' || coalesce(:pass_exp_date, '<null>')
  || ', :age => ' || coalesce(:age, '<null>')
  || ', :birth_date => ' || coalesce(:birth_date, '<null>')
  || ', :rating_age => ' || coalesce(:rating_age, '<null>')
  || ', :title => ' || coalesce(:title, '<null>')
  ||')');
  */
  execute procedure GUEST_ADDRESSCARD_SET$RSV(
    :guest_id,
    :guest_name,
    null,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :personal_number,
    :country_code,
    :id_stay_reason,
    :is_registred,
    :pass_place,
    :city,
    :address,
    :birth_place,
    :sex,
    :mask,
    :is_child,
    :car,
    :kpp_id,
    :kpp_date,
    :pass_exp_date,
    :age,
    :birth_date,
    :visa,
    :rating_age,
    :title,
    0
  )
  returning_values :err_code, :err_text, :warn_code;
  if (0 <> :err_code) then exit;

  --execute procedure RES_GUEST_SAVE_ORGANIZER$RSV(:guest_id, :is_different_arranger);

  if ((:arrival is not null) and (:departure is not null)) then begin
    execute procedure RES_GUEST_SAVE_STAY$RSV(:guest_id, :arrival, :departure)
    returning_values :err_code, :err_text, :warn_code;
    if (0 <> :err_code) then exit;
  end

  if (:voucher is not null) then begin
    execute procedure RES_GUEST_SAVE_VOUCHER$RSV(:guest_id, :voucher,
            :voucher_date, :voucher_text, null, null);
  end

  execute procedure IMPORT_GUEST_PACK$EXC(:guest_id, :package);

  update GUEST
  set    ORPHANED_IMPORT$EXC = null
  where  id_guest=:guest_id;
end
^

/* empty dependent procedure body */
/* Clear: CREATE_SESSION_BOOKINGS$WBE for: IMPORT_PERSON_PROFILE$EXC */
ALTER PROCEDURE CREATE_SESSION_BOOKINGS$WBE(WBE_SESSION_ID BIGINT,
ARANGER_ID INTEGER,
LANG_CODE VARCHAR(3))
 RETURNS(SELECTION_ID VARCHAR(20),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: EAI_IMPORT_ALOYALTY_CLIENT for: IMPORT_PERSON_PROFILE$EXC */
ALTER PROCEDURE EAI_IMPORT_ALOYALTY_CLIENT(CLIENT_UUID VARCHAR(40),
CLIENT_NAME VARCHAR(100),
CARD_CODE VARCHAR(50),
IS_ARHIVE SMALLINT,
DATE_OF_BIRTH DATE)
 AS
 BEGIN EXIT; END
^

/* Alter (IMPORT_PERSON_PROFILE$EXC) */
ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
declare variable op varchar(10);
  declare variable market_segment_id integer;
  declare variable sex_old char(1);
  declare variable birth_date_old date;
  declare variable birth_place_old varchar(30);
  declare variable personal_number_old varchar(30);
  declare variable pass_num_old varchar(20);
  declare variable pass_date_old date;
  declare variable pass_place_old varchar(20);
  declare variable pass_exp_date_old date;
  declare variable pass_city_old varchar(100);
  declare variable pass_address_old varchar(100);
  declare variable country_old varchar(10);
  declare variable mask_old varchar(10);
  declare variable title_old varchar(10);
  declare variable id_photo integer;
  declare variable id_def_contragent integer;
  declare variable id_passport_type integer;
  declare variable account_no_old varchar(20);
  declare variable msg_old varchar(255);
  declare variable id_guest_type integer;
  declare variable id_guest_type_old integer;
  declare variable card_code_old varchar(50);
  declare variable is_exclusive_debt_ownership smallint;
  declare variable profile_receiver_id integer;
begin
  profile_id = null;
  import_time = null;

  execute procedure import_mark_transaction$exc;

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC(:profile_uuid=>' || coalesce(:profile_uuid, '<null>')
                          || ', email=>' || coalesce(:email, '<null>') || ')');

  profile_id = null;
  if (profile_uuid is null) then begin
    execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC <null> :profile_uuid - exit;');
    exit;
  end

  select p.profile_id, p.profile_name, p.phone, p.fax, p.email, p.city,
         p.address, p.market_segment, p.note, p.is_archive, pp.card_code,
         pd.sex, pd.birthday_internal, pd.birth_place, pd.egn, pd.pass_num,
         pd.pass_date, pd.pass_place, pd.pass_exp_date, pd.city, pd.address, pd.country_code,
         pd.mask, p.id_def_contragent, p.wbe_password,
         pd.title, p.account_no, p.msg, pp.id_guest_type, pp.id_photo, pd.id_passport_type,
         p.is_exclusive_debt_ownership
  from   import_common_profile$exc(:profile_uuid, 0, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :wbe_password, :ACCOUNT_NO, :MSG, 'PERSON_PROFILE', :HOTEL_UUID_LIST) p
         left outer join profile_person pp on pp.id_profile = p.profile_id
         left outer join person_data pd on pd.id_person_data=pp.id_person_data
  into   :profile_id, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :card_code_old,
         :sex_old, :birth_date_old, :birth_place_old, :personal_number_old, :pass_num_old,
         :pass_date_old, :pass_place_old, :pass_exp_date_old, :pass_city_old, :pass_address_old, :country_old,
         :mask_old, :id_def_contragent, :wbe_password, :title_old,
         :account_no_old, :msg_old, :id_guest_type_old, :id_photo, :id_passport_type, :is_exclusive_debt_ownership;

  if (:profile_id is null) then begin
    op = 'add';
  end else if (:hotel_uuid_list is null) then begin
    profile_id = null;
    exit;
  end else begin
    op = 'mod';
    delete from PROFILE_BONUSPOINT_SCHEME bs
      where bs.ID_PROFILE = :profile_id;
  end

  sex=coalesce(:sex, :sex_old);
  birth_date=coalesce(:birth_date, :birth_date_old);
  birth_place=coalesce(:birth_place, :birth_place_old);
  personal_number=coalesce(:personal_number, :personal_number_old);
  pass_num=coalesce(:pass_num, :pass_num_old);
  pass_date=coalesce(:pass_date, :pass_date_old);
  pass_place=coalesce(:pass_place, :pass_place_old);
  pass_exp_date=coalesce(:pass_exp_date, :pass_exp_date_old);
  pass_city=coalesce(:pass_city, :pass_city_old);
  pass_address=coalesce(:pass_address, :pass_address_old);
  country=upper(coalesce(:country, :country_old));
  mask=coalesce(:mask, :mask_old);
  title=coalesce(:title, :title_old);
  account_no=coalesce(:account_no, :account_no_old);
  msg=coalesce(:msg, :msg_old);
  card_code=coalesce(:card_code, :card_code_old);

  execute procedure IMPORT_PASSPORT_TYPE$EXC(:pass_type_name, :pass_type_external_code)
  returning_values :id_passport_type;

  execute procedure lookup_market_segment$exc(:profile_name, 'PERSON_PROFILE', :market_segment)
  returning_values :market_segment_id;

  if (guest_type_name is not null) then begin
    execute procedure lookup_guest_type$exc(:profile_name, 'PERSON_PROFILE', :guest_type_name)
    returning_values :id_guest_type;
  end

  if ((def_contragent_name is not null) and (def_contragent_name <> '')) then begin
    execute procedure LOOKUP_CONTRAGENT$EXC(:profile_name, 'PERSON_PROFILE', :def_contragent_name)
    returning_values :id_def_contragent;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:profile_name, 'PERSON_PROFILE');

  id_guest_type=coalesce(:id_guest_type, :id_guest_type_old);

  if (id_photo is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, null, null, null, 'del')
    returning_values :id_photo;
  end
  id_photo = null;
  if (picture is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, :picture, :picture_type, :picture_layout, 'add')
    returning_values :id_photo;
  end

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC - profile_person_modify$profile(:profile_uuid=>'
    || coalesce(:profile_uuid, '<null>')
    || ', :operation=>' || coalesce(:op, '<null>')
    || ', :email=>' || coalesce(:email, '<null>')
    || ', :birth_date=>' || coalesce(:birth_date, '<null>')
  || ')');
  execute procedure profile_person_modify$profile(
    :profile_id,
    :id_guest_type,
    :profile_name,
    null,
    :sex,
    :birth_date,
    :birth_place,
    :personal_number,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :pass_place,
    :pass_exp_date,
    :country,
    :pass_city,
    :pass_address,
    :mask,
    :phone,
    :fax,
    :email,
    :city,
    :address,
    :note,
    :msg,
    :id_def_contragent,
    :market_segment_id,
    :is_archive,
    :id_photo,
    :card_code,
    :wbe_password,
    :op,
    :account_no,
    :title,
    :is_exclusive_debt_ownership
  ) returning_values
    :profile_id;

  /*assign uuid to the new profiles*/
  if ('add' = :op) then begin
    update profile set uuid=:profile_uuid where id_profile=:profile_id;
  end

  select record_timestamp from profile where id_profile=:profile_id
  into :import_time;

  if (:MERGE_TARGET_UUID is not null) then begin
    select p.ID_PROFILE
    from   PROFILE P
    where  P.UUID = :MERGE_TARGET_UUID
    into   :profile_receiver_id;

    execute procedure PROFILE_MERGE$PROFILE (:PROFILE_ID, :profile_receiver_id, 'merge');

  end

end
^

/* Alter (MONITOR_ROOM_GANTT$HM) */
ALTER PROCEDURE MONITOR_ROOM_GANTT$HM(FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ID_ROOM INTEGER,
GFROM_DATE DATE,
IS_MOVED_FROM INTEGER,
GTO_DATE DATE,
IS_MOVED_TO INTEGER,
BUSY_GRP INTEGER,
OCCUPANT_ID INTEGER,
IN_SHARE SMALLINT,
ID_GROUP INTEGER,
ATTENTION_STATUS SMALLINT)
 AS
declare variable contiguous_id_room integer;
begin
  for
    select ID_ROOM, GFROM_DATE, IS_MOVED_FROM, GTO_DATE,
           IS_MOVED_TO, BUSY_GRP, OCCUPANT_ID
    from   MONITOR_ROOM_GANTT$INT(:from_date, :to_date)
    into   :id_room, :gfrom_date, :is_moved_from, :gto_date,
           :is_moved_to, :busy_grp, :occupant_id
  do begin
    if (:gfrom_date = :from_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gfrom_date - 1)
      into   :contiguous_id_room;

      if ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_from = 1;

      select O.FROM_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gfrom_date;
    end

    if (:gto_date = :to_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gto_date + 1)
      into   :contiguous_id_room;

      if ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_to = 1;

      select O.TO_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gto_date;
    end

    if (:busy_grp in (1, 24)) then begin
      select RI.ATTENTION_STATUS, RI.ID_GROUP, RI.IN_SHARE
      from   RES_GET_INFO$RSV(:occupant_id, 0, 1, 0) RI
      into   :attention_status, :id_group, :in_share;
    end else begin
      id_group = null;
      attention_status = null;
      in_share = null;
      if (exists(
        select *
        from   ROOMS_SHARE RS
        where  RS.ID_RESERV_DETAIL = :occupant_id
      )) then in_share = 1;
      else in_share = 0;
    end
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_NOM_CHANNEL_CODE$EXC for: NOM_MODIFY_CHANNEL_CODES */
ALTER PROCEDURE IMPORT_NOM_CHANNEL_CODE$EXC(CODE VARCHAR(3),
DESCRIPTION VARCHAR(30),
UUID VARCHAR(40))
 RETURNS(ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (NOM_MODIFY_CHANNEL_CODES) */
ALTER PROCEDURE NOM_MODIFY_CHANNEL_CODES(ID_NOM_CHANNEL_CODE INTEGER,
CHANNEL_CODE VARCHAR(3),
DESCRIPTION VARCHAR(30),
OPERATION VARCHAR(10))
 RETURNS(NEW_ID_NOM_CHANNEL_CODE INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
BEGIN
  err_code = 0;
  err_text = '';
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  NEW_ID_NOM_CHANNEL_CODE = :ID_NOM_CHANNEL_CODE;
  if (:OPERATION = 'add') then begin
    if (coalesce(:ID_NOM_CHANNEL_CODE, -1) <= -1) then
      NEW_ID_NOM_CHANNEL_CODE = gen_id(GEN_NOM_CHANNEL_CODES_ID,1);

    insert into NOM_CHANNEL_CODES (ID_NOM_CHANNEL_CODE, CHANNEL_CODE, DESCRIPTION)
    values (:NEW_ID_NOM_CHANNEL_CODE, :CHANNEL_CODE, :DESCRIPTION);
  end else if (:OPERATION = 'mod') then begin
    update NOM_CHANNEL_CODES
    set    CHANNEL_CODE = :CHANNEL_CODE,
           DESCRIPTION = :DESCRIPTION
    where  ID_NOM_CHANNEL_CODE = :ID_NOM_CHANNEL_CODE;
  end else if (:OPERATION = 'del') then begin
    delete from NOM_CHANNEL_CODES
    where  ID_NOM_CHANNEL_CODE = :ID_NOM_CHANNEL_CODE;
  end

  -- TODO: log
END
^

/* empty dependent procedure body */
/* Clear: RES_CHECK_OUT_GUESTS$RSV for: OCCUPANCY_RESERV$INT */
ALTER PROCEDURE RES_CHECK_OUT_GUESTS$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND SMALLINT = 0)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE_OCCUPANCY$INT for: OCCUPANCY_RESERV$INT */
ALTER PROCEDURE RES_FINALIZE_OCCUPANCY$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ERROR_CONTEXT VARCHAR(200),
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_DEL$RSV for: OCCUPANCY_RESERV$INT */
ALTER PROCEDURE RES_GUEST_DEL$RSV(ID_GUEST INTEGER,
REASON VARCHAR(50) = null)
 AS
 BEGIN EXIT; END
^

/* Alter (OCCUPANCY_RESERV$INT) */
ALTER PROCEDURE OCCUPANCY_RESERV$INT(RD_DBKEY TYPE OF TDB_KEY)
 AS
declare variable id_reserv_detail integer;
  declare variable from_date date;
  declare variable to_date date;
  declare variable id_room integer;
  declare variable id_room_type integer;
  declare variable id_agent integer;
  declare variable country_code varchar(50);
  declare variable busy_group_type integer;
  declare variable busy_type varchar(50);
  declare variable day_action_int smallint;
  declare variable busy_date date;
  declare variable id_hotel integer;
  declare variable gst_ad_in integer;
  declare variable gst_ad_out integer;
  declare variable gst_ad_stay integer;
  declare variable gst_ch_in integer;
  declare variable gst_ch_out integer;
  declare variable gst_ch_stay integer;
  declare variable acc_routing varchar(50);
  declare variable check_out_date date;
  declare variable is_anul integer;
  declare variable room_status varchar(50);
  declare variable force_booking_export smallint;
begin
  /*  Description: */
  busy_group_type = 1;
  force_booking_export = 0;

  select RD.ID_RESERV_DETAIL, RD.FROM_DATE, RD.TO_DATE,
         RD.ID_ROOM, coalesce(R.ID_ROOM_TYPE, RD.ID_ROOM_TYPE), P.ID_AGENT,
         RD.COUNTRY, RD.ACC_ROUTING,
         case  --TODO permanently remove reserv_status
           when RD.CHECK_STATUS = -3 then 'VALUE_RESERVS'
           when RD.CHECK_STATUS = -2 then 'VALUE_NOTCONFIRMED'
           when RD.CHECK_STATUS = -1 then 'VALUE_CONFIRMED'
           when RD.CHECK_STATUS = 0 then 'CHECK_IN'
           when RD.CHECK_STATUS = 1 then 'CHECK_OUT'
           else null --error
         end, RD.ID_HOTEL, RD.IS_ANUL
  from   RESERV_DETAIL RD
         left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
         left outer join PROFILE_AGENT P on P.ID_PROFILE = RD.ID_AGENT_PROFILE
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail, :from_date, :to_date,
         :id_room, :id_room_type, :id_agent,
         :country_code, :acc_routing,
         :busy_type, :id_hotel, :is_anul;

  execute procedure ROOM_MAGIC_CLEAR(:id_reserv_detail);

  if (:is_anul = 0) then begin
    execute procedure sys_dbg('occ OCCUPANCY_RESERV$INT acc_routing = '||coalesce(:acc_routing, 'null'));
  
    if (:acc_routing = 'OWNER') then busy_group_type = 20; --OOI
    else if (:busy_type starting with 'VALUE') then busy_group_type = 1;
    else busy_group_type = 24;

    for
      select GS.FOR_DATE, GS.ID_ROOM, coalesce(iif(g.CHECK_STATUS = 1, g.EARLYCHECKOUT_DATE, null), g.TO_DATE),
             sum(iif(GS.FOR_DATE = G.FROM_DATE, 1 - G.IS_CHILD, 0)),
             sum(iif(GS.FOR_DATE = coalesce(iif(g.CHECK_STATUS = 1, g.EARLYCHECKOUT_DATE, null), g.TO_DATE), 1 - G.IS_CHILD, 0)),
             sum(iif(GS.FOR_DATE between (g.FROM_DATE + 1) and (coalesce(iif(g.CHECK_STATUS = 1, g.EARLYCHECKOUT_DATE, null), g.TO_DATE) - 1), 1 - G.IS_CHILD, 0)),
             sum(iif(GS.FOR_DATE = G.FROM_DATE, G.IS_CHILD, 0)),
             sum(iif(GS.FOR_DATE = coalesce(iif(g.CHECK_STATUS = 1, g.EARLYCHECKOUT_DATE, null), g.TO_DATE), G.IS_CHILD, 0)),
             sum(iif(GS.FOR_DATE between (g.FROM_DATE + 1) and (coalesce(iif(g.CHECK_STATUS = 1, g.EARLYCHECKOUT_DATE, null), g.TO_DATE) - 1), G.IS_CHILD, 0))
      from   GUEST G
             left outer join GUEST_STAY_ROOM$INT(G.ID_GUEST) GS on 0=0
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and GS.FOR_DATE <= coalesce(iif(g.CHECK_STATUS = 1, g.EARLYCHECKOUT_DATE, null), g.TO_DATE)
      group by 1, 2, 3
      order by 1 asc
      into   :busy_date, :id_room, :check_out_date,
             :gst_ad_in, :gst_ad_out, :gst_ad_stay, :gst_ch_in, :gst_ch_out, :gst_ch_stay
    do begin
      if (:busy_date is null) then begin
        -- fucked up situation. Checkedin in the future followed by early checkout. As a result empty ROOM_MAGIC !
        exit;
      end
      day_action_int = case
                         when :busy_date = :check_out_date and :busy_date = :from_date then 13 --'CHECK_IN,CHECK_OUT'
                         when :busy_date = :from_date then 1 --'CHECK_IN'
                         when :busy_date = :check_out_date then 3 --'CHECK_OUT'
                         else 2 --'STAY'
                       end;

      select ro.ID_ROOM, ro.ID_ROOM_TYPE, ro.ROOM_STATUS
      from   RES_OCCUPANCY_ROOM$INT (:id_reserv_detail, :busy_date, :id_room, :id_room_type) RO
      into   :id_room, :id_room_type, :room_status;

      insert into ROOM_MAGIC(ID_ROOM_MAGIC, BUSY_DATE, ID_ROOM, ID_ROOM_TYPE, DAY_ACTION_INT, ID_HOTEL,
             BUSY_GROUP_TYPE, ID_AGENT, BUSY_TYPE, COUNTRY, ID_RESERV_DETAIL, GST_AD_IN, GST_AD_OUT, GST_AD_STAY,
             GST_CH_IN, GST_CH_OUT, GST_CH_STAY, ROOM_STATUS)
      values (gen_id(g_auto_inc_rooms_magic, 1), :busy_date, :id_room, :id_room_type, :day_action_int, :id_hotel,
             :busy_group_type, :id_agent, :busy_type, :country_code, :id_reserv_detail, :gst_ad_in, :gst_ad_out, :gst_ad_stay,
             :gst_ch_in, :gst_ch_out, :gst_ch_stay, :room_status);

      if (:busy_date < :to_date) then begin
        update RESERV_ROOMS$EXC rr
        set    rr.ACTUAL_ROOM_STATUS = :room_status
        where  rr.ID_RESERV_DETAIL = :id_reserv_detail
               and rr.FOR_DATE = :busy_date
               and coalesce(rr.ACTUAL_ROOM_STATUS, rr.IMPORT_ROOM_STATUS) is distinct from :room_status;

        if (row_count > 0) then force_booking_export = 1;
      end
    end

    if (:force_booking_export = 1) then
      execute procedure LOG_BOOKING_CHANGE$EXC(:id_reserv_detail, :id_hotel, 0, 1);

  end
  --
end
^

/* empty dependent procedure body */
/* Clear: OCCUPANCY_ROOMS_CHECK$INT for: OCCUPANCY_ROOM_VALIDATE$INT */
ALTER PROCEDURE OCCUPANCY_ROOMS_CHECK$INT(OCCUPANT_DBKEY CHAR(8),
BUSY_GROUP_SOURCE INTEGER)
 RETURNS(SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (OCCUPANCY_ROOM_VALIDATE$INT) */
ALTER PROCEDURE OCCUPANCY_ROOM_VALIDATE$INT(ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_OCCUPANT INTEGER,
OCC_BUSY_GRP_TYPE INTEGER,
REQUEST_GUEST_CNT INTEGER,
CHECK_OPTIONS VARCHAR(255))
 RETURNS(SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
declare variable must_check_cleaning integer;
  declare variable room_capacity integer;
  declare variable real_id_room_type integer;
  declare variable room_name varchar(20);
  declare variable id_other_occupant integer;
  declare variable other_busy_grp_type integer;
  declare variable is_clean integer;
  declare variable clean_txt varchar(20);
  declare variable id_hotel integer;
begin
  /*  Description:
  ||  CONTEXT   CLEAN, BEDS, ROOM_TYPE, OCCUP
  ||  RESERV    N      Y     Y          FULL
  ||  CHECKIN   Y      Y     N          RES (  ONLY RESERVATIONS)
  ||  BLOCK     N      N     N          FULL
  ||  ROOMEDIT  N      Y     N          RES2 (ONLY RESERVATIONS,NO PERIOD)
  ||----------------------------------------------------
  || CHECK_OPTIONS = (clean, beds, occup_res)
  */
  SHARE_ERR_CODE = 0;
  SHARE_ERR_TEXT = '';
  execute procedure sys_dbg('occ ROOM_VALIDATE ID_ROOM = '||coalesce(:id_room, 'null'));
  execute procedure sys_dbg('occ ROOM_VALIDATE FROM_DATE = '||coalesce(:from_date, 'null'));
  execute procedure sys_dbg('occ ROOM_VALIDATE TO_DATE = '||coalesce(:to_date, 'null'));
  execute procedure sys_dbg('occ ROOM_VALIDATE REQUEST_GUEST_CNT = '||coalesce(:request_guest_cnt, 'null'));
  execute procedure sys_dbg('occ ROOM_VALIDATE CHECK_OPTIONS = '||coalesce(:check_options, 'null'));

  other_busy_grp_type = null;
  real_id_room_type = null;

  select R.ID_ROOM_TYPE, R.BEDS + R.EXTRA_BEDS, R.ROOM_NAME, R.IS_CLEAN, r.ID_HOTEL
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :real_id_room_type, :room_capacity, :room_name, :is_clean, :id_hotel;
  if (:real_id_room_type is null
      and ((:CHECK_OPTIONS containing 'beds') or (:CHECK_OPTIONS containing 'clean')) ) then begin
    exception OCCUPANCY_EXCEPTION '-5';
  end

  if (:check_options like '%clean%'
      and not exists (select rp.ID_ROOM_PERIOD       --skip private rooms for cleaning validation
                      from   ROOM_PERIOD$PMS RP
                      where  RP.ID_ROOM = :ID_ROOM
                             and rp.FROM_DATE <= :FROM_DATE
                             and rp.TO_DATE >= :TO_DATE
                             and rp.STATUS = 'PRIVATE')) then
  begin
    execute procedure SETTING_GET_VALUE('CLEANING_RESTRICTION', :id_hotel)
    returning_values  :must_check_cleaning;
    if ((:must_check_cleaning = 1) and (:is_clean = 0)) then begin
      clean_txt = '@{other.not}';
      exception OCCUPANCY_EXCEPTION '-46' || f_character(31) || f_character(29)||:room_name||f_character(28)||:clean_txt;
    end
  end

  if (:check_options like '%beds%') then begin
    /* CHECK BEDS */
    select max(DRM.day_guests)
    from   (select rm.BUSY_DATE, sum(rm.ADULT_COUNT + rm.CHILDREN_COUNT) as day_guests
            from   ROOM_MAGIC RM
            where  Rm.ID_ROOM = :ID_ROOM
                   and rm.BUSY_DATE between :FROM_DATE and :TO_DATE
                   and rm.DAY_ACTION not containing 'CHECK_OUT'
            group by rm.BUSY_DATE) DRM
    into   :REQUEST_GUEST_CNT;

    if (:room_capacity < :request_guest_cnt) then begin
      exception OCCUPANCY_EXCEPTION '-8' || f_character(31) || f_character(29)||:room_name||f_character(28)||:request_guest_cnt||f_character(28)||:room_capacity;
    end
  end

  /* CHECK OCCUPANCY */
  id_other_occupant = null;
  if (:check_options containing 'occup_res') then begin
    if (exists (select R.ID_ROOM
                from   ROOMS R
                       join ROOM_PERIOD$PMS P on P.ID_ROOM = R.ID_ROOM
                where  P.ID_ROOM = :id_room
                       and P.STATUS = 'INACTIVE' -- allow PRIVATE
                       and P.FROM_DATE <= :to_date
                       and P.TO_DATE >= :from_date)) then
    begin
      exception OCCUPANCY_EXCEPTION '-118';
    end

    --execute procedure sys_dbg('occ ROOM_VALIDATE id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));
    select first 1 RM.ID_RESERV_DETAIL, RM.BUSY_GROUP_TYPE
    from   ROOM_MAGIC RM
    where  RM.BUSY_DATE between :from_date and :to_date
           and RM.ID_ROOM = :id_room
           and RM.DAY_ACTION not containing 'CHECK_OUT'
           and RM.ID_RESERV_DETAIL <> :ID_OCCUPANT
    into   :id_other_occupant, :other_busy_grp_type;
  end
  --execute procedure sys_dbg('occ ROOM_VALIDATE id_arise_source = '||coalesce(:id_arise_source, 'null'));

  if (:id_other_occupant is not null) then begin
    -- other occupant has detected
    if (:other_busy_grp_type in (1, 24)) then begin
      if (:other_busy_grp_type = 1) then share_err_code = -9;
      else share_err_code = -10;

      select substring(f_character(29)||:room_name||f_character(28)||RD.NUMBER||'-'|| P.PROFILE_NAME||', '||FormatDate(RD.FROM_DATE, 'D;dd.mm.yyyy')||'-'||FormatDate(RD.TO_DATE, 'D;dd.mm.yyyy') from 1 for 255)
      from   RESERV_DETAIL RD
             join PROFILE P on P.ID_PROFILE = RD.ID_PERSON_PROFILE
      where  RD.ID_RESERV_DETAIL = :id_other_occupant
      into   :share_err_text;
    end else begin
      share_err_code = -106;
      execute procedure sys_dbg('occ ROOM_VALIDATE err_code = -106 room_name = '||coalesce(:room_name, 'null'));
      select substring(
               f_character(29)||:room_name||f_character(28)||iif(BR.BLOCK_GRP=18, 'Out of order', 'Out of inventory')||
               ' - '||BR.REASON||f_character(28)||FormatDate(BR.FROM_DATE, 'D;dd.mm.yyyy')||'-'||FormatDate(BR.TO_DATE, 'D;dd.mm.yyyy')
             from 1 for 255)
      from   BLOCK_ROOM BR
      where  BR.ID_BLOCK_ROOM = :id_other_occupant
      into   :share_err_text;
    end

    if (((:OCC_BUSY_GRP_TYPE in (1, 24)) and (:other_busy_grp_type in (1, 24, 18, 20)))
       or
       ((:OCC_BUSY_GRP_TYPE in (18, 20)) and (:other_busy_grp_type in (1, 24)))) then
    begin
      -- occupants are compatible for room sharing
      exit;
    end else begin
      exception OCCUPANCY_EXCEPTION :SHARE_ERR_CODE || f_character(31) || :SHARE_ERR_TEXT;
    end
  end
  --
end
^

/* empty dependent procedure body */
/* Clear: BLOCK_MODIFY$INT for: OCCUPANCY_ROOMS_CHECK$INT */
ALTER PROCEDURE BLOCK_MODIFY$INT(ID_BLOCK_ROOM INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
BLOCK_GRP INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_BLOCK_ROOM INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_FINALIZE$RSV for: OCCUPANCY_ROOMS_CHECK$INT */
ALTER PROCEDURE RES_SAVE_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_RESERV_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* Alter (OCCUPANCY_ROOMS_CHECK$INT) */
ALTER PROCEDURE OCCUPANCY_ROOMS_CHECK$INT(OCCUPANT_DBKEY CHAR(8),
BUSY_GROUP_SOURCE INTEGER)
 RETURNS(SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable from_date date;
declare variable to_date date;
declare variable id_room integer;
declare variable guests_in_room integer;
declare variable id_occupant integer;
declare variable validate_options varchar(255);
declare variable tmp_err_code integer;
declare variable tmp_err_text varchar(255);
declare variable new_shares_arise integer;
begin
  share_err_code = 0;
  share_transaction_id = null;
  tmp_err_code = 0;
  WARN_CODE = null;

  for
    select ORV.ID_ROOM, ORV.FROM_DATE, ORV.TO_DATE, ORV.GUESTS_INROOM, ORV.ID_OCCUPANT, ORV.VALIDATE_OPTIONS
    from   OCCUPANT_ROOMS$INT(:occupant_dbkey, :busy_group_source) ORV
    into   :id_room, :from_date, :to_date, :guests_in_room, :id_occupant, :validate_options
  do begin
    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT from_date = '||coalesce(:from_date, 'null'));
    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT to_date = '||coalesce(:to_date, 'null'));
    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT validate_options = '||coalesce(:validate_options, 'null'));

    execute procedure OCCUPANCY_ROOM_VALIDATE$INT(:id_room, :from_date, :to_date, :id_occupant, :busy_group_source, :guests_in_room, :validate_options)
    returning_values  :tmp_err_code, :tmp_err_text;

    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT err_code = '||coalesce(:tmp_err_code, 'null'));
    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT err_text = '||coalesce(:tmp_err_text, 'null'));
    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT busy_group_source = '||coalesce(:busy_group_source, 'null'));

    if (:share_err_code = 0 and :tmp_err_code <> 0) then begin
      -- room share has detected
      share_err_code = :tmp_err_code;
      share_err_text = :tmp_err_text;
    end
  end
  /*
  Look for shares which:
    - are not own by this reservation
    - are brand new
  if found new - user must be asked for new shares entering permission
  */
  execute procedure OCCUPANCY_SHARES_COMPLETE$INT (:id_occupant)
  returning_values (:new_shares_arise, :share_transaction_id);

  execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT new_shares_arise = '||coalesce(:new_shares_arise, 'null'));
  execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT share_transaction_id = '||coalesce(:share_transaction_id, 'null'));
  /*  */
  if (:new_shares_arise = 0) then begin
    -- ALL SHARES ARE KNOWN...
    -- suppress new shares entering question
    share_err_code = 0;
    share_err_text = '';
    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT no new shares found ');
  end

  /* check for overlaping on arrival or departure date */
  execute procedure OCCUPANCY_OVERLAP_CHECK$INT (:id_occupant, :busy_group_source)
  returning_values :warn_code;
end
^

/* Alter (OCCUPANCY_SHARES_COMPLETE$INT) */
ALTER PROCEDURE OCCUPANCY_SHARES_COMPLETE$INT(ID_OCCUPANT INTEGER)
 RETURNS(NEW_SHARES_ARISE INTEGER,
SHARE_MARK_TRANSACTION INTEGER)
 AS
declare variable id_room integer;
declare variable rm_dbkey char(8);
declare variable share_date date;
declare variable found_reservaions integer;
declare variable existent_share integer;
declare variable tmp_res_detail integer;
declare variable has_share integer;
begin
  /* -- SHARES detection and clean section --*/
  has_share = 0;
  new_shares_arise = 0;
  execute procedure OCCUPANCY_GET_TRANSACTION$INT
  returning_values (:share_mark_transaction);

  /* -- we check old stay and rooms + new stay and rooms and will regenerate shares --*/
  for
    select distinct trs.for_date, trs.id_room
    from   RESERV_STAY$TMP trs
    where  trs.id_session = :share_mark_transaction
    union
    select rm.busy_date, rm.id_room
    from   ROOM_MAGIC rm
    where  rm.id_reserv_detail = :id_occupant
           and RM.DAY_ACTION not containing 'CHECK_OUT'
    into   :share_date, :id_room
  do begin
    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT Now will check share status.......... :'|| :share_date || ' ID_ROOM =' || :id_room);
    /* Count reservations for this date and room*/
    for
      select RM.BUSY_DATE, count(distinct RM.ID_RESERV_DETAIL)
      from   ROOM_MAGIC RM
      where  RM.BUSY_DATE = :share_date
             and RM.ID_ROOM = :id_room
             and RM.DAY_ACTION not containing 'CHECK_OUT' -- exclude 'CHECK_OUT' and 'CHEKC_IN,CHECK_OUT' day actions
      group by 1
      into   :share_date, :found_reservaions
    do begin
      if (:found_reservaions > 1) then begin
        has_share = 1;
        /* CREATE/UPDATE SHARES */
        for
          select RM.RDB$DB_KEY, RM.ID_RESERV_DETAIL
          from   ROOM_MAGIC RM
          where  RM.BUSY_DATE = :share_date
                 and RM.ID_ROOM = :id_room
                 and RM.DAY_ACTION not containing 'CHECK_OUT' -- exclude 'CHECK_OUT' and 'CHEKC_IN,CHECK_OUT' day actions
          into   :rm_dbkey, :tmp_res_detail
        do begin
          execute procedure ROOM_SHARE$INT(:rm_dbkey, :share_mark_transaction)
          returning_values  :existent_share;

          if (:existent_share = 0 and :tmp_res_detail <> :id_occupant) then new_shares_arise = 1;
        end
      end else begin
        /* CLEAN SHARES IF ANY */
        update ROOMS_SHARE RS
        set    RS.IS_EX_SHARE = 1,
               RS.MARK_TRANSACTION = :share_mark_transaction
        where  RS.BUSY_DATE = :share_date
               and RS.ID_ROOM = :id_room;
      end
    end
  end

  if (:has_share = 0) then SHARE_MARK_TRANSACTION = null;
end
^

/* Alter (OCCUPANCY_SUMMARY_REMAKE$SYS) */
ALTER PROCEDURE OCCUPANCY_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
begin
  if (not exists (select h.ID_HOTEL
                  from   HOTEL H
                  where  h.ID_HOTEL = :ID_HOTEL)) then exception WRONG_VALUE 'Non-existing hotel!';

  select mindate(sd.SYSTEM_DATE - 1, :TO_DATE)
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :TO_DATE;

  if (:FROM_DATE > :TO_DATE) then exit;

  execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:id_hotel, :FROM_DATE, :TO_DATE);

  execute procedure SYSTEM_LOG_ADD ('HOTEL', :id_hotel, 'OCCUPANCY_REGENERATE',
                                    f_character(29) || formatdate(:from_date, 'D;dd/mm/yyyy') || f_character(28) || formatdate(:to_date, 'D;dd/mm/yyyy'));
end
^

/* empty dependent procedure body */
/* Clear: CONTRACT_EXPENSE_POST$INT for: OWNER_ACCOUNT_GET$INT */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_HOTEL INTEGER,
ID_CONTRACT /* TYPE OF ID */ INTEGER,
SUB_CONTRACT /* TYPE OF TSUB_CONTRACT */ VARCHAR(10),
ID_OWNER /* TYPE OF ID */ INTEGER,
OWNERSHIP_PERCENT /* TYPE OF TPERCENT */ NUMERIC(15,4),
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
POST_DATE /* TYPE OF TDATE */ DATE,
STAY /* TYPE OF TCOUNT */ INTEGER,
MAX_GUEST_CNT /* TYPE OF TCOUNT */ INTEGER,
BED_NIGHT_CNT /* TYPE OF TCOUNT */ INTEGER,
RESERVS /* TYPE OF TCOUNT */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: CONTRACT_MANAGEMENT_POST$INT for: OWNER_ACCOUNT_GET$INT */
ALTER PROCEDURE CONTRACT_MANAGEMENT_POST$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_CONTRACT /* TYPE OF ID */ INTEGER,
SUB_CONTRACT /* TYPE OF TSUB_CONTRACT */ VARCHAR(10),
CONTRACT_TYPE VARCHAR(30),
ID_OWNER /* TYPE OF ID */ INTEGER,
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
POST_DATE /* TYPE OF TDATE */ DATE,
STAY /* TYPE OF TCOUNT */ INTEGER,
OWNERSHIP_PERCENT /* TYPE OF TPERCENT */ NUMERIC(15,4))
 RETURNS(POSTED_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
POSTED_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PMS_EXPENSE_POSTS_CREATE$INT for: OWNER_ACCOUNT_GET$INT */
ALTER PROCEDURE PMS_EXPENSE_POSTS_CREATE$INT(ID_ROOM /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
POST_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
IS_CLIENT_ACC_POST /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_POST_DATE /* TYPE OF TDATE */ DATE,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IS_POST_PER_POOL /* TYPE OF TLOGICAL */ SMALLINT)
 RETURNS(NEW_ID_ACCOUNT_POST /* ID_REF */ INTEGER,
NEW_ID_ACCOUNT_POST$PMS /* ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PMS_INCOME_POSTING_CREATE$PMS for: OWNER_ACCOUNT_GET$INT */
ALTER PROCEDURE PMS_INCOME_POSTING_CREATE$PMS(ID_ROOM INTEGER,
ID_OWNER INTEGER,
ID_RENTAL_POOL INTEGER,
ID_CURRENCY VARCHAR(3),
ID_SERVICE INTEGER,
POST_VALUE NUMERIC(15,4),
MANUAL_POST_DATE DATE,
DESCRIPTION VARCHAR(255),
IS_POST_PER_POOL SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PMS_POOL_DISTRIBUTION_SUB for: OWNER_ACCOUNT_GET$INT */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
 BEGIN EXIT; END
^

/* Alter (OWNER_ACCOUNT_GET$INT) */
ALTER PROCEDURE OWNER_ACCOUNT_GET$INT(ID_OWNER TYPE OF ID,
ID_HOTEL TYPE OF ID,
IS_SHADOW_ACCOUNT TYPE OF TLOGICAL,
IS_CLIENT_ACCOUNT TYPE OF TLOGICAL)
 RETURNS(ID_ACCOUNT TYPE OF ID,
IS_ACCOUNT$PMS TYPE OF TLOGICAL)
 AS
declare variable is_rental_pool smallint;
  declare variable acc_curr char(3);
begin
  ID_ACCOUNT = null;

  select iif(o.ID_RENTAL_POOL_UNIT is null, 0, 1), o.ID_CURRENCY
  from   OWNER$PMS O
  where  o.ID_OWNER = :ID_OWNER
  into   :is_rental_pool, :acc_curr;

  if (:IS_CLIENT_ACCOUNT = 1 and :is_rental_pool = 0) then begin
    select a.ID_ACCOUNT
    from   ACCOUNT A
    where  a.ID_PROFILE = :ID_OWNER
           and a.ID_HOTEL = :ID_HOTEL
           and a.IS_PMS_ACCOUNT = 1
    into   :ID_ACCOUNT;

    if (:ID_ACCOUNT is null) then begin
      execute procedure ACCOUNT_CREATE_PMS$PMS (:ID_OWNER, null, :acc_curr, :ID_HOTEL)
      returning_values (:ID_ACCOUNT);
    end
    IS_ACCOUNT$PMS = 0;
  end else begin
    select a.ID_ACCOUNT
    from   ACCOUNT$PMS a
    where  a.ID_OWNER = :ID_OWNER
           and a.ID_HOTEL = :ID_HOTEL
           and a.IS_SHADOW = :IS_SHADOW_ACCOUNT
           and a.IS_CLIENT_POOL_ACCOUNT = :IS_CLIENT_ACCOUNT
    into   :ID_ACCOUNT;

    if (:ID_ACCOUNT is null) then begin
      insert into ACCOUNT$PMS (ID_OWNER, IS_SHADOW, IS_CLIENT_POOL_ACCOUNT, ID_HOTEL)
      values (:ID_OWNER, :IS_SHADOW_ACCOUNT, :IS_CLIENT_ACCOUNT, :ID_HOTEL)
      returning ID_ACCOUNT into :ID_ACCOUNT;
    end
    IS_ACCOUNT$PMS = 1;
  end
end
^

/* empty dependent procedure body */
/* Clear: OWNER_BILL_MODIFY$PMS for: PMS_EVENT_VOID$INT */
ALTER PROCEDURE OWNER_BILL_MODIFY$PMS(ID_OWNER_BILL INTEGER,
ID_OWNER INTEGER,
BILLING_DATE DATE,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_OWNER_BILL INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PMS_EVENT_ANUL$PMS for: PMS_EVENT_VOID$INT */
ALTER PROCEDURE PMS_EVENT_ANUL$PMS(ID_PMS_EVENT INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PMS_IMPORT_ANUL for: PMS_EVENT_VOID$INT */
ALTER PROCEDURE PMS_IMPORT_ANUL(ID_EXPORT_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_EVENT_VOID$INT) */
ALTER PROCEDURE PMS_EVENT_VOID$INT(ID_PMS_EVENT INTEGER)
 AS
declare variable id_post integer;
  declare variable ap_dbkey char(8);
begin
/*  EVENT_TYPE in ('INCOME, MANUAL_INCOME, MANUAL_EXPENSE, POOL_DISTRIBUTION') */

  if ( exists ( select *
                from   ACCOUNT_POST$PMS AP
                where  AP.ID_PMS_EVENT = :id_pms_event
                       and AP.LINE_STATUS = 21 )
       or
       exists ( select *
                from   ACCOUNT_POST AP
                       join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
                where  PP.ID_PMS_EVENT = :id_pms_event
                       and PP.LINE_STATUS = 21 ) ) then
  begin
    exception PMS_EXCEPTION '-620';    --dokumentirani nachisleniq ne mogat da se anulirat!
  end

  update PMS_EVENT$PMS P
  set    P.EVENT_STATUS = 22
  where  P.ID_PMS_EVENT = :ID_PMS_EVENT;

  for
    select P.ID_ACCOUNT_POST
    from   ACCOUNT_POST$PMS P
    where  P.ID_PMS_EVENT = :ID_PMS_EVENT
           and P.LINE_STATUS = 11
    into   :id_post
  do begin
    execute procedure ACCOUNT_POST_PMS_ANUL$INT(:id_pms_event, :id_post);
  end

  for
    select PEP.ID_ACCOUNT_POST, ap.RDB$DB_KEY
    from   PMS_EVENT_POST PEP
           join ACCOUNT_POST AP on PEP.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
    where  PEP.ID_PMS_EVENT = :ID_PMS_EVENT
           and AP.IS_ANUL = 0
    into   :id_post, :ap_dbkey
  do begin
    execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_dbkey, 'VOID');

    update PMS_EVENT_POST EP
    set    EP.LINE_STATUS = 22
    where  EP.ID_ACCOUNT_POST = :id_post;
  end

  -- for compatibility with old import logic
  execute procedure PMS_PREV_EVENT_CHECK$INT(:ID_PMS_EVENT);
end
^

/* empty dependent procedure body */
/* Clear: DEVICE_READING_POST$PMS for: PMS_EXPENSE_POSTS_CREATE$INT */
ALTER PROCEDURE DEVICE_READING_POST$PMS(ID_DEVICE_READING /* TYPE OF ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PMS_EXPENSE_POSTING_CREATE$PMS for: PMS_EXPENSE_POSTS_CREATE$INT */
ALTER PROCEDURE PMS_EXPENSE_POSTING_CREATE$PMS(ID_ROOM /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
POST_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
IS_ACC_POST_ITEM /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_POST_DATE /* TYPE OF TDATE */ DATE,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IS_POST_PER_POOL /* TYPE OF TLOGICAL */ SMALLINT)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_EXPENSE_POSTS_CREATE$INT) */
ALTER PROCEDURE PMS_EXPENSE_POSTS_CREATE$INT(ID_ROOM TYPE OF ID,
ID_OWNER TYPE OF ID,
ID_RENTAL_POOL TYPE OF ID_REF,
ID_SERVICE TYPE OF ID,
ID_CURRENCY TYPE OF TCURRENCY,
POST_VALUE TYPE OF TPRICE,
IS_CLIENT_ACC_POST TYPE OF TLOGICAL,
MANUAL_POST_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
IS_POST_PER_POOL TYPE OF TLOGICAL)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF,
NEW_ID_ACCOUNT_POST$PMS ID_REF)
 AS
declare variable event_type varchar(30);
  declare variable id_room_contract integer;
  declare variable new_id_pms_event integer;
  declare variable round_to_orig numeric(15,6);
  declare variable ownership_percent numeric(15,4);
  declare variable curr_contract_owner integer;
  declare variable curr_total_ownership numeric(15,4);
  declare variable curr_total_value numeric(15,4);
  declare variable percent_value numeric(15,4);
  declare variable id_account integer;
  declare variable id_hotel integer;
  declare variable is_account$pms integer;
  declare variable id_acc_post integer;
BEGIN
  event_type = 'MANUAL_EXPENSE';
  curr_total_value = 0;
  curr_total_ownership = 0;

  select RC.ID_ROOM_CONTRACT, r.ID_HOTEL
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS P on RC.ID_ROOM_PERIOD = P.ID_ROOM_PERIOD
         join ROOMS R on R.ID_ROOM = p.ID_ROOM
  where  :MANUAL_POST_DATE between P.FROM_DATE and P.TO_DATE
         and P.ID_ROOM = :ID_ROOM
         and P.STATUS in ('PRIVATE','CONTRACT')
  into   :id_room_contract, :id_hotel;

  if (:ID_ROOM_CONTRACT is null) then exception PMS_EXCEPTION '-615';

  execute procedure PMS_EVENT_CREATE$INT(:EVENT_TYPE, :ID_ROOM, :ID_OWNER, :DESCRIPTION,
          :MANUAL_POST_DATE, null, null, null, null, :POST_VALUE, :POST_VALUE, :ID_CURRENCY, null, :id_room_contract)
  returning_values :new_id_pms_event;

  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :ID_CURRENCY
  into   :round_to_orig;

  for
    select iif(:ID_OWNER is null, O.OWNERSHIP_PERCENT, 100), O.ID_OWNER
    from   ROOM_CONTRACT$PMS RC
           join ROOM_OWNER$PMS O on O.ID_ROOM_CONTRACT = RC.ID_ROOM_CONTRACT
    where  RC.ID_ROOM_CONTRACT = :id_room_contract
           and ((:ID_OWNER is null) or (O.ID_OWNER = :ID_OWNER))
    into   :ownership_percent, :curr_contract_owner
  do begin
    curr_total_ownership = :curr_total_ownership + :ownership_percent;
    if (:curr_total_ownership = 100) then begin
      percent_value = :post_value - :curr_total_value;
    end else
      percent_value = round_f(:post_value * :ownership_percent / 100, :round_to_orig);

    curr_total_value = :curr_total_value + :percent_value;

    execute procedure OWNER_ACCOUNT_GET$INT (iif(:is_post_per_pool = 1, :id_rental_pool, :curr_contract_owner),
            :id_hotel, 0, :IS_CLIENT_ACC_POST)
    returning_values (:id_account, :is_account$pms);

    execute procedure PMS_POSTING_CREATE$INT(:new_id_pms_event, :ID_ACCOUNT, :ID_SERVICE,
            :curr_contract_owner, :MANUAL_POST_DATE, :ID_CURRENCY, :PERCENT_VALUE, :is_account$pms, 0, :ID_ROOM)
    returning_values :id_acc_post;

    new_id_account_post = null;
    new_id_account_post$pms = null;

    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 1)) then new_id_account_post$pms = :id_acc_post;
    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 0)) then new_id_account_post = :id_acc_post;
    suspend;
  end

  execute procedure PMS_EVENT_SET_ACTIVE$INT(:new_id_pms_event);
END
^

/* Alter (PMS_IMPORT_ANUL) */
ALTER PROCEDURE PMS_IMPORT_ANUL(ID_EXPORT_HEAD INTEGER)
 AS
declare variable id_pms_event integer;

  declare variable is_anul smallint;
  declare variable exist_not_anul smallint;
  declare variable to_sys_date date;
  declare variable id_hotel integer;
begin

  select R.IS_ANUL, R.TO_SYS_DATE, R.ID_HOTEL
  from   RESERV_EXPORT$PMS R
  where  R.ID_EXPORT_HEAD = :ID_EXPORT_HEAD
  into   :IS_ANUL, :to_sys_date, :id_hotel;
  if (:IS_ANUL = 1) then exception PMS_EXCEPTION '-621';

  select min(R.IS_ANUL)
  from   RESERV_EXPORT$PMS R
  where  R.from_sys_date > :to_sys_date
         and r.ID_HOTEL = :id_hotel
  into   :exist_not_anul;
  if (:exist_not_anul = 0) then exception PMS_EXCEPTION '-625';

  for
    select E.ID_PMS_EVENT
    from   PMS_EVENT$PMS E
    where  E.ID_EXPORT_HEAD = :ID_EXPORT_HEAD
    into   :id_pms_event
  do begin
    execute procedure PMS_EVENT_VOID$INT(:id_pms_event);

  end
   
  update RESERV_EXPORT$PMS R
  set    R.IS_ANUL = 1,
         R.DT_ANUL = current_timestamp
  where  R.ID_EXPORT_HEAD = :ID_EXPORT_HEAD;

end
^

/* empty dependent procedure body */
/* Clear: PMS_REGULAR_POST_CREATE$PMS for: PMS_INCOME_POSTING_CREATE$PMS */
ALTER PROCEDURE PMS_REGULAR_POST_CREATE$PMS(ID_CONTRACT_CALENDAR_POST INTEGER,
ID_ROOM INTEGER,
ID_OWNER INTEGER,
ID_CURRENCY VARCHAR(3),
ID_SERVICE INTEGER,
POST_VALUE NUMERIC(15,4),
IS_ACC_POST_ITEM SMALLINT,
MANUAL_POST_DATE DATE,
DESCRIPTION VARCHAR(255),
IS_POST_PER_POOL SMALLINT,
ID_RENTAL_POOL INTEGER,
IS_INCOME_POST SMALLINT)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_INCOME_POSTING_CREATE$PMS) */
ALTER PROCEDURE PMS_INCOME_POSTING_CREATE$PMS(ID_ROOM INTEGER,
ID_OWNER INTEGER,
ID_RENTAL_POOL INTEGER,
ID_CURRENCY VARCHAR(3),
ID_SERVICE INTEGER,
POST_VALUE NUMERIC(15,4),
MANUAL_POST_DATE DATE,
DESCRIPTION VARCHAR(255),
IS_POST_PER_POOL SMALLINT)
 AS
declare variable ownership_percent numeric(15,4);
  declare variable id_room_contract integer;
  declare variable id_account integer;
  declare variable percent_value numeric(15,4);
  declare variable curr_total_ownership numeric(15,4);
  declare variable curr_total_value numeric(15,4);
  declare variable new_id_pms_event integer;
  declare variable id_account_post_pms integer;
  declare variable curr_contract_owner integer;
  declare variable event_type varchar(30);
  declare variable round_to_orig numeric(15,6);
  declare variable id_hotel integer;
  declare variable is_account$pms integer;
begin
  id_room_contract = null;
  curr_total_value = 0;
  curr_total_ownership = 0;
  event_type = 'MANUAL_INCOME';

  select RC.ID_ROOM_CONTRACT
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS P on RC.ID_ROOM_PERIOD = P.ID_ROOM_PERIOD
  where  :MANUAL_POST_DATE between P.FROM_DATE and P.TO_DATE
         and P.STATUS in ('PRIVATE','CONTRACT')
         and P.ID_ROOM = :ID_ROOM
  into   :id_room_contract;
  if (:ID_ROOM_CONTRACT is null) then exception PMS_EXCEPTION '-615';

  execute procedure PMS_EVENT_CREATE$INT(:EVENT_TYPE, :ID_ROOM, :ID_OWNER, :DESCRIPTION,
          :MANUAL_POST_DATE, null, null, null, null,
          :POST_VALUE, :POST_VALUE, :ID_CURRENCY, null, :id_room_contract)
  returning_values :new_id_pms_event;

  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :ID_CURRENCY
  into   :round_to_orig;

  for
    select iif(:ID_OWNER is null, O.OWNERSHIP_PERCENT, 100), O.ID_OWNER, r.ID_HOTEL
    from   ROOM_CONTRACT$PMS RC
           join ROOM_OWNER$PMS O on O.ID_ROOM_CONTRACT = RC.ID_ROOM_CONTRACT
           join ROOM_PERIOD$PMS rp on rp.ID_ROOM_PERIOD = rc.ID_ROOM_PERIOD
           join ROOMS R on r.ID_ROOM = rp.ID_ROOM
    where  RC.ID_ROOM_CONTRACT = :id_room_contract
           and ((:id_owner is null) or (O.ID_OWNER = :id_owner))
    order by 1 asc
    into   :ownership_percent, :curr_contract_owner, :id_hotel
  do begin
    curr_total_ownership = :curr_total_ownership + :ownership_percent;
    if (:curr_total_ownership = 100) then begin
      percent_value = :POST_VALUE - :curr_total_value;
    end else
      percent_value = round_f(:POST_VALUE * :ownership_percent / 100, :round_to_orig);

    curr_total_value = :curr_total_value + :percent_value;

    execute procedure OWNER_ACCOUNT_GET$INT (iif(:IS_POST_PER_POOL = 0, :curr_contract_owner, :ID_RENTAL_POOL),
            :id_hotel, 0, 0)
    returning_values (:id_account, :is_account$pms);

    execute procedure ACCOUNT_POST_PMS_ADD$INT(:new_id_pms_event, :id_account,
            :curr_contract_owner, :ID_CURRENCY, :percent_value, :id_service, 1, :MANUAL_POST_DATE)
    returning_values  (:id_account_post_pms);
  end

  execute procedure PMS_EVENT_SET_ACTIVE$INT(:new_id_pms_event);
end
^

/* empty dependent procedure body */
/* Clear: PMS_POOL_DISTRIBUTION for: PMS_POOL_DISTRIBUTION_SUB */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION(ID_RENTAL_POOL INTEGER,
FOR_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_POOL_DISTRIBUTION_SUB) */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
declare variable cnt_room smallint;
  declare variable curr_total_posted numeric(15,4);
  declare variable cnt integer;
  declare variable value_to_post numeric(15,4);
  declare variable value_to_post_per_owner numeric(15,4);
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable id_room_contract integer;
  declare variable id_owner_account integer;
  declare variable id_pms_event integer;
  declare variable id_hotel integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
begin
  select c.ROUND_TO
  from   CURRS c
  where  c.CURR = :CURR
  into   :round_to;

  cnt_room = 0;
  select count(distinct RP.ID_ROOM)
  from   ROOM_PERIOD$PMS RP
         join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
  where  RC.ID_RENTAL_POOL = :id_rental_pool
         and RP.STATUS in ('PRIVATE','CONTRACT')
         and RP.FROM_DATE <= :FOR_DATE
         and RP.TO_DATE >= :FOR_DATE
  into   :cnt_room;

  if (:cnt_room = 0) then exception PMS_EXCEPTION 'The pool has not assigned room contracts for selected date (' || :FOR_DATE || ') !';

  if (:is_room_pool = 1) then begin
    curr_total_posted = 0;
    cnt = 0;
    id_pms_event = null;
    id_hotel = null;
    for
      select distinct RP.ID_ROOM, RC.ID_ROOM_CONTRACT, R.ID_HOTEL
      from   ROOM_PERIOD$PMS RP
             join ROOMS R on R.ID_ROOM = RP.ID_ROOM
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.FROM_DATE <= :FOR_DATE
             and RP.TO_DATE >= :FOR_DATE
      into   :id_room, :id_room_contract, :id_hotel
    do begin
      id_pms_event = null;

      select E.ID_PMS_EVENT
      from   PMS_EVENT$PMS E
      where  E.ID_ROOM = :id_room
             and E.ID_SESSION = current_transaction
      into   :ID_PMS_EVENT;

      if (:ID_PMS_EVENT is null) then begin
        execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, :id_room_contract)
        returning_values :id_pms_event;
        -- FIXME nakraq da se update total_event_value
      end
      if (:cnt_room - :cnt = 1) then begin
        value_to_post = :TOTAL_VALUE_PER_SERVICE - :curr_total_posted;
      end else begin
        value_to_post = round_f(:TOTAL_VALUE_PER_SERVICE / :cnt_room, :round_to);
      end

      curr_total_posted = :curr_total_posted + :value_to_post;
      cnt = :cnt + 1;

      /* ...i se razpredelq mejdu sobstwenicite na staqta */
      value_to_post = abs(:value_to_post);
      for
        select R.ID_OWNER, R.OUT_VALUE
        from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
        into   :id_owner, :value_to_post_per_owner
      do begin
        /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_pool_account,
                :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                1, :IS_OWNER_INCOME, :id_room)
        returning_values :no_use_id_acc_post;
        /* ... i se nachislqwa po sobswtenik */
        execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
        returning_values (:id_owner_account, :is_account$pms);

        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                :is_account$pms, :is_owner_income, :id_room)
        returning_values :no_use_id_acc_post;
      end
    end
  end else begin
    /* distribution by room_param */
    insert into TMP_SELECT$PMS(ID_SESSION, ID_ROOM, ID_OWNER)
    select distinct current_transaction, RP.ID_ROOM, null
    from   ROOM_PERIOD$PMS RP
           join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
    where  RC.ID_RENTAL_POOL = :ID_RENTAL_POOL
           and RP.STATUS in ('PRIVATE','CONTRACT')
           and RP.FROM_DATE <= :FOR_DATE
           and RP.TO_DATE >= :FOR_DATE;

    id_hotel = null;
    for
      select P.OUT_VALUE, P.OUT_ID_ROOM, R.ID_HOTEL
      from   PMS_CALC_VALUE_BY_PARAM(:ID_ROOM_PARAM, :TOTAL_VALUE_PER_SERVICE, :round_to) P
             join ROOMS R on R.ID_ROOM = P.OUT_ID_ROOM
      into   :value_to_post, :id_room, :id_hotel
    do begin
      id_pms_event = null;
      id_room_contract = null;
      -- room contract must be only one for this period
      select RC.ID_ROOM_CONTRACT
      from   ROOM_PERIOD$PMS RP
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.ID_ROOM = :id_room
             and :for_date between RP.FROM_DATE and RP.TO_DATE
      into   :id_room_contract;

      if (:id_room_contract is not null) then begin
        select E.ID_PMS_EVENT
        from   PMS_EVENT$PMS E
        where  E.ID_ROOM = :id_room
               and E.ID_SESSION = current_transaction
        into   :ID_PMS_EVENT;
  
        if (:ID_PMS_EVENT is null) then begin
          execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                  'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, id_room_contract)
          returning_values :id_pms_event;
          -- FIXME nakraq da se update total_event_value
        end
  
        /* ...i se razpredelq mejdu sobstwenicite na staqta */
        for
          select R.ID_OWNER, R.OUT_VALUE
          from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
          into   :id_owner, :value_to_post_per_owner
        do begin
          /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :ID_POOL_ACCOUNT,
                  :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                  1, :IS_OWNER_INCOME, :id_room)
          returning_values :no_use_id_acc_post;
  
          /* ... i se nachislqwa po sobswtenik */
          execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
          returning_values (:id_owner_account, :is_account$pms);

          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                  :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                  :is_account$pms, :is_owner_income, :id_room)
          returning_values :no_use_id_acc_post;
        end
      end
    end

    delete from TMP_SELECT$PMS T
    where  T.ID_SESSION = current_transaction;
  end
end
^

/* Alter (PMS_REGULAR_POST_CREATE$PMS) */
ALTER PROCEDURE PMS_REGULAR_POST_CREATE$PMS(ID_CONTRACT_CALENDAR_POST INTEGER,
ID_ROOM INTEGER,
ID_OWNER INTEGER,
ID_CURRENCY VARCHAR(3),
ID_SERVICE INTEGER,
POST_VALUE NUMERIC(15,4),
IS_ACC_POST_ITEM SMALLINT,
MANUAL_POST_DATE DATE,
DESCRIPTION VARCHAR(255),
IS_POST_PER_POOL SMALLINT,
ID_RENTAL_POOL INTEGER,
IS_INCOME_POST SMALLINT)
 AS
declare variable no_use varchar(1000);
begin

  if (:IS_INCOME_POST = 1) then begin
    execute procedure PMS_INCOME_POSTING_CREATE$PMS(:ID_ROOM, :ID_OWNER, :ID_RENTAL_POOL,
            :ID_CURRENCY, :ID_SERVICE, :POST_VALUE, :MANUAL_POST_DATE, :DESCRIPTION, :IS_POST_PER_POOL);
  end else begin
    execute procedure PMS_EXPENSE_POSTING_CREATE$PMS(:ID_ROOM, :ID_OWNER, :ID_RENTAL_POOL,
            :ID_SERVICE, :ID_CURRENCY, :POST_VALUE, :IS_ACC_POST_ITEM, :MANUAL_POST_DATE,
            :DESCRIPTION, :IS_POST_PER_POOL);
  end

  delete from CONTRACT_CALENDAR_SCHEME$PMS S
  where  S.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST
         and S.POST_DATE = :MANUAL_POST_DATE;

  execute procedure CONTRACT_CALENDAR_MODIFY$PMS(:ID_CONTRACT_CALENDAR_POST,
          null, null, null, null, null, null, null, null, null,  null, 'mod_next_date')
  returning_values (:no_use);

end
^

/* Alter (POST_DEL_POSTING) */
ALTER PROCEDURE POST_DEL_POSTING(IN_ID_ACCOUNT_POST INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100))
 AS
declare variable ap_dbkey char(8);
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  
  select  AP.RDB$DB_KEY
  from    ACCOUNT_POST AP
  where   AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into    :ap_dbkey;

  execute procedure ACCOUNT_POSTING_DEL$INT (:ap_dbkey, '');
end
^

/* empty dependent procedure body */
/* Clear: POST_TELECOUNT_CALL$INT for: POST_PREPARE_ON_ACCOUNT$POST */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_PREPARE_ON_ACCOUNT$POST) */
ALTER PROCEDURE POST_PREPARE_ON_ACCOUNT$POST(ID_ACCOUNT ID_REF,
ID_SERVICE ID_REF,
QTY TQTY,
ID_SEQUENCE TRANGE,
PRICE_POST TPRICE,
CURR_POST TCURRENCY,
POST_TEXT TOBJECT_TEXT,
FROM_DATE TDATE,
TO_DATE TDATE,
ID_PHONECALL ID_REF = null)
 RETURNS(NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable id_hotel id_ref;
begin

  if (:FROM_DATE is null) then begin
    select A.ID_HOTEL
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :ID_ACCOUNT
    into   :id_hotel;

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :FROM_DATE;
    TO_DATE = :FROM_DATE;
  end

  execute procedure POST_PREPARE$INT(:ID_ACCOUNT, null, :ID_SERVICE, :QTY, :ID_SEQUENCE,
          :PRICE_POST, :CURR_POST, :POST_TEXT, :FROM_DATE, :TO_DATE, :ID_PHONECALL)
  returning_values (:NEW_FROM_DATE);

end
^

/* Alter (POST_PREPARE_ON_GUEST$POST) */
ALTER PROCEDURE POST_PREPARE_ON_GUEST$POST(ID_GUEST ID_REF,
ID_SERVICE ID_REF,
QTY TQTY,
ID_SEQUENCE TRANGE,
PRICE_POST TPRICE,
CURR_POST TCURRENCY,
POST_TEXT TOBJECT_TEXT,
FROM_DATE TDATE,
TO_DATE TDATE)
 RETURNS(NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable no_use varchar(255);
begin
  /* check if exists available posting account for guest */
  execute procedure GUEST_GET_POSTING_ACCOUNT$INT (:ID_GUEST, '')
  returning_values  (:no_use, :no_use);

  execute procedure POST_PREPARE$INT(null, :ID_GUEST, :ID_SERVICE, :QTY, :ID_SEQUENCE,
          :PRICE_POST, :CURR_POST, :POST_TEXT, :FROM_DATE, :TO_DATE, null)
  returning_values (:NEW_FROM_DATE);
end
^

/* empty dependent procedure body */
/* Clear: EAI_POS_POSTING_ADD$P2E for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PMS_POSTING_CREATE$INT for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
POST_DATE /* TYPE OF TDATE */ DATE,
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
POST_ON_PMS_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT,
IS_OWNER_INCOME /* TYPE OF TLOGICAL */ SMALLINT,
ID_ROOM /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_ACCOUNT_POST /* ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_FINALIZE$POST for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_ACCOUNT$INT) */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
QTY TYPE OF TQTY,
ID_SECQUENCE TYPE OF ID,
IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
POST_TEXT TYPE OF TDESCRIPTION_SHORT,
RESOURCE_TEXT TYPE OF TREASON,
DATE_POST TYPE OF TDATE,
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ID_ROOM TYPE OF ID = null,
POST_DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable action_text varchar(255);
begin
  if (:date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :date_post;
  end
/* NO AUTO PRICE !!!!!!
  if (:in_is_manual_price = 0) then begin

    select P.ID_EXTRA_TARIFF
    from   ACCOUNT A
           join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
    where  A.ID_ACCOUNT = :in_id_account
    into   :id_extra_tarifa;
    if ((:id_extra_tarifa is null) or (:id_extra_tarifa < 0)) then begin
      err_code = -14;
      exit;
    end
    execute procedure TAR_RECALC_EXTRASRV(:id_extra_tarifa, :in_id_service, :in_date_post)
    returning_values  :err_code, :err_text, :post_price, :post_currency;
    if (:err_code < 0) then exit;
  end else begin
    --MANUAL PRICE
    post_currency = :manual_curr ;
    post_price = :manual_price ;
  end
*/

  post_currency = :manual_curr ;
  post_price = :manual_price ;
  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, -1, :id_secquence, :date_post, :id_service, -1, :id_room, 0, :qty, :post_price,
    :post_currency, null, :short_code, :from_date, :to_date, :post_text, :resource_text, '', -1, :POST_DESCRIPTION)
  returning_values :err_code, :err_text, :id_account_post;
  if (:err_code <> 0) then exit;

  select S.SERVICE_NAME
  from   SERVICES S
  where  S.ID_SERVICE = :ID_SERVICE
  into   :action_text;
   
  action_text = f_character(29) || coalesce(:action_text, '')
                || f_character(28) || formatdate(:DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || coalesce(:post_currency, '');
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_RESERVATION$INT for: POST_SERVICE_ON_GUEST$INT */
ALTER PROCEDURE POST_SERVICE_ON_RESERVATION$INT(ID_RESERV_DETAIL /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_ROOM for: POST_SERVICE_ON_GUEST$INT */
ALTER PROCEDURE POST_SERVICE_ON_ROOM(IN_ID_ROOM /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255))
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_GUEST /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_GUEST$INT) */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TDESCRIPTION_SHORT,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ACCOUNT_ROUTING TYPE OF TSHORT_CODE,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable id_room integer;
  declare variable no_use varchar(255);
  declare variable action_text varchar(255);
  declare variable is_guest_check_in smallint;
  declare variable service_name varchar(50);
begin
  err_code = 0;
  err_text = '';

  select g.check_status
  from   guest g
  where  g.id_guest = :in_id_guest
  into   :is_guest_check_in;

  if (:is_guest_check_in < 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
  end

  execute procedure GUEST_GET_POSTING_ACCOUNT$INT (:in_id_guest, :account_routing)
  returning_values  :id_account, :id_room;

  if (:in_date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :in_date_post;
  end

  if (:in_is_manual_price = 0) then begin
    execute procedure SERVICE_GET_POSTING_DETAILS(:in_id_service, :IN_DATE_POST)
    returning_values  :no_use, :no_use, :service_name, :post_price, :post_currency;
  end else begin
    /* MANUAL PRICE */
    post_currency = :manual_curr;
    post_price = :manual_price;
    select s.SERVICE_NAME
    from   SERVICES s
    where  s.ID_SERVICE = :IN_ID_SERVICE
    into   :service_name;
  end

  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, :in_id_guest, :in_id_secquence, :in_date_post, :in_id_service, -1, :id_room, 0, :in_qty,
    :post_price, :post_currency, null, :in_short_code, :in_from_datetime, :in_to_datetime, :in_post_text,
    :in_resource_text, '', -1, :DESCRIPTION)
  returning_values  :err_code, :err_text, :id_account_post;

  action_text = f_character(29) || coalesce(:service_name, '')
                || f_character(28) || formatdate(:IN_DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:IN_QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || coalesce(:post_currency, '');
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: RESOURCE_RESERVATION_CHECK_IN for: POST_SERVICE_ON_RESERVATION$INT */
ALTER PROCEDURE RESOURCE_RESERVATION_CHECK_IN(ID_RESOURCE_RESERVATION INTEGER,
SERVICE_PRICE NUMERIC(15,2),
SERVICE_CURR VARCHAR(3))
 RETURNS(OUT_ID_ACCOUNT INTEGER,
OUT_ID_ACCOUNT_POST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_RESERVATION$INT) */
ALTER PROCEDURE POST_SERVICE_ON_RESERVATION$INT(ID_RESERV_DETAIL TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TREASON,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable id_guest integer;
begin
  err_code = 0;
  err_text = '';

  id_guest = null;
  select RD.ID_TITULAR
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :id_guest;

  execute procedure POST_SERVICE_ON_GUEST$INT(:id_guest, :in_id_service, :in_qty, :in_id_secquence,
                    :in_is_manual_price, :manual_price, :manual_curr, :in_from_datetime, :in_to_datetime,
                    :in_post_text, :in_resource_text, :in_date_post, :in_short_code, '', :DESCRIPTION)
  returning_values  :err_code, :err_text, :id_account, :id_account_post;
end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_POST_TO_MH_FRONT_ONLINE for: POST_SERVICE_ON_ROOM */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_SERVICE_POST for: POST_SERVICE_ON_ROOM */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_ROOM) */
ALTER PROCEDURE POST_SERVICE_ON_ROOM(IN_ID_ROOM TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TREASON,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_GUEST TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
begin
  err_code = 0;
  err_text = '';

  id_guest = null;
  select first 1 G.ID_GUEST
  from   GUEST G
  where  G.ID_ROOM = :in_id_room
         and G.CHECK_STATUS = 0
  order by G.FROM_DATE desc, G.ID_GUEST asc
        /************************************************/
        /* DESCENDANT ORDER IS VERY IMPORTANT!!         */
        /* IF TWO GUESTS HAVE:                          */
        /* TO_DATE OF THE 1'ST = FROM_DATE OF THE 2'ND, */
        /* THEN PHONACALLS SHOULD GO TO THE 2'ND        */         
        /************************************************/
  into   :id_guest;

  if (:id_guest is null) then begin
    err_code = -24;   /* NO GUESTS ARE CHECKED_IN INTO THE REQUESTED ROOM! */
    exit;
  end

  execute procedure POST_SERVICE_ON_GUEST$INT(:id_guest, :in_id_service, :in_qty, :in_id_secquence, :in_is_manual_price,
    :manual_price, :manual_curr, :in_from_datetime, :in_to_datetime, :in_post_text, :in_resource_text,
    :in_date_post, :in_short_code, '')
  returning_values  :err_code, :err_text, :id_account, :id_account_post;
end
^

/* Alter (POST_SERVICE_PREPARE) */
ALTER PROCEDURE POST_SERVICE_PREPARE(ID_SERVICE INTEGER,
ID_GUEST INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(DATE_POST DATE,
QTY_POST INTEGER,
PRICE_POST NUMERIC(15,4),
CURR_POST CHAR(3),
POST_TEXT VARCHAR(50),
RESOURCE_TEXT VARCHAR(50),
FROM_DATETIME DATE,
TO_DATETIME DATE,
IS_DETAILS INTEGER,
IS_MANUAL_PRICE INTEGER,
SERVICE_NAME VARCHAR(30))
 AS
declare variable id_hotel integer;
begin

  if (:id_account is not null) then begin
    select A.ID_HOTEL
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :id_hotel;
  end else begin
    select RD.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
    where  G.ID_GUEST = :id_guest
    into   :id_hotel;
  end

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :date_post;

  execute procedure SERVICE_GET_POSTING_DETAILS(:ID_SERVICE, :DATE_POST)
  returning_values  :IS_DETAILS, :IS_MANUAL_PRICE, :SERVICE_NAME, :PRICE_POST, :CURR_POST;

  qty_post = 1;
  post_text = '';
  resource_text = '';
  from_datetime = :date_post;
  to_datetime = :date_post;
end
^

/* empty dependent procedure body */
/* Clear: EAI_TELECOUNT_TRANSFER for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALL_POST$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL /* ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALLS_POST_TO_ACCOUNT$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_TELECOUNT_TRANSFER$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_TELECOUNT_CALL$INT) */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ext_ifc_name varchar(20);
  declare variable room_name varchar(30);
  declare variable datetime_call timestamp;
  declare variable price numeric(15,2);
  declare variable dial_number varchar(50);
  declare variable units integer;
  declare variable pc_id_service integer;
  declare variable def_manual_curr char(3);
  declare variable post_text varchar(50);
  declare variable id_account_post integer;
  declare variable is_archive integer;
  declare variable id_account integer;
  declare variable new_id_account_post integer;
  declare variable pc_tag varchar(20);
  declare variable number_zone varchar(50);
  declare variable id_hotel integer;
  declare variable id_phonecall integer;
  declare variable no_use varchar(255);
begin
  /* Description:
  || POST_TO_TYPE = 0 - ACCOUNT, 1 - GUEST, 2 - RESERV_DETAIL, 3 - JUST PREPARE, FOR EXTERNAL CLIENT
  */
  err_code = 0;
  err_text = '';
  ext_ifc_name = 'TELECOUNT';

  select PC.ID_PHONECALL, PC.ROOM_NAME, PC.DATETIME_CALL, PC.PRICE, PC.DIAL_NUMBER, PC.UNITS,
         PC.ID_ACCOUNT_POST, PC.IS_ARCHIVE, PC.TAG, substring(PC.NUMBER_ZONE from 1 for 30), pc.ID_HOTEL
  from   PHONECALLS PC 
  where  PC.rdb$db_key = :ph_dbkey
  into   :id_phonecall, :room_name, :datetime_call, :price, :dial_number, :units,
         :id_account_post, :is_archive, :pc_tag, :number_zone, :id_hotel;

  if ((:is_archive = 1) or (coalesce(:id_account_post, 0) > 0)) then exit;

  if ((:pc_tag is null) or (:pc_tag = '')) then pc_tag = 'TELECOUNT_DEFAULT';
  else pc_tag = 'TELECOUNT_' || :pc_tag;

  execute procedure EAI_MAP_SERVICE(:pc_tag, :number_zone, :ext_ifc_name, :id_hotel)
  returning_values  :err_code, :err_text, :pc_id_service;
  if (:err_code < 0) then exit;

  post_text = substring(:dial_number || ', impulses ' || :units from 1 for 50);

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :def_manual_curr;

  new_id_account_post = null;
  if (:post_to_type = 0) then begin
    id_account = :post_to_id;
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name)
    returning_values :err_code, :err_text, :new_id_account_post;
  end else if (:post_to_type = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:post_to_id, :pc_id_service, 1, -1, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name, '')
    returning_values :err_code, :err_text, :id_account, :new_id_account_post;
  end else if (:post_to_type = 2) then begin
    execute procedure POST_SERVICE_ON_RESERVATION$INT(:post_to_id, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name)
    returning_values :err_code, :err_text, :id_account, :new_id_account_post;
  end else if (:post_to_type = 3) then begin
    execute procedure POST_PREPARE_ON_ACCOUNT$POST (:post_to_id, :pc_id_service,
      1, :ID_SEQUENCE, :price, :def_manual_curr, :post_text, null, null, :ID_PHONECALL)
    returning_values :no_use;
  end
  if (:err_code < 0) then exit;

  if (:new_id_account_post is not null) then begin
    update PHONECALLS PC
    set    PC.ID_ACCOUNT_POST = :new_id_account_post,
           pc.POSTING_ERROR = null
    where  PC.rdb$db_key = :ph_dbkey;
  end

end
^

/* Alter (POST_TELECOUNT_TRANSFER$TC) */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ph_dbkey char(8);
  declare variable id_account_post integer;
  declare variable account_name varchar(50);
begin
  err_code = 0;
  err_text = '';

  for
    select PC.RDB$DB_KEY, PC.ID_ACCOUNT_POST
    from   PHONECALLS PC
    where  PC.SELECTION_ID = :selection_id
    into   :ph_dbkey, :id_account_post
  do begin
    if ((:id_account_post is not null) and (:id_account_post <> -1)) then begin
      err_code = -117;
      select A.ACCOUNT_NAME
      from   ACCOUNT_POST AP
             join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
      where  AP.ID_ACCOUNT_POST = :id_account_post
      into   :account_name;
      err_text = f_character(29) || :account_name;
      exit;
    end

    execute procedure POST_TELECOUNT_CALL$INT(2, :id_reserv_detail, :ph_dbkey, 0)
    returning_values :err_code, :err_text;
    if (:err_code < 0) then exit;
  end
end
^

/* Alter (RATE_GET_AVAILABILITY$CHM) */
ALTER PROCEDURE RATE_GET_AVAILABILITY$CHM(ID_RATE INTEGER,
FOR_DATE DATE)
 RETURNS(ACTIVE_STATUS INTEGER,
MIN_LOS INTEGER,
MAX_LOS INTEGER)
 AS
declare variable date_from date;
  declare variable date_to date;
  declare variable RATE_capacity integer;
  declare variable to_sell integer;
begin
  --ACTIVE_STATUS 0 - closed
  --ACTIVE_STATUS 1 - closed fro arrival
  --ACTIVE_STATUS 2 - opened
  --opala ID_HOTEL
--  date_from = null;
--  ACTIVE_STATUS -  autoclose, t.e. AUTO_PERCENT






/*  select min(FOR_DATE), max(FOR_DATE)
  from RATE_ALLOTMENT
  where ID_RATE = :id_RATE
  into :date_from, :date_to;
  if (date_from is null) then exit;

  for select distinct ID_ROOM_TYPE
      from RATE_ALLOTMENT
      where ID_RATE = :id_RATE
        and FOR_DATE between :date_from and :date_to
      into :id_room_type
  do begin
    for select RTR.FOR_DATE,
               CA.STATUS,
               CA.AUTO_FREE_ROOMS, CA.ROOM_COUNT, RTR.AVAILABLE as FREE_ROOMS
        from ROOM_TYPE_GET_FREE$CHM(:date_from, :date_to, :id_room_type) RTR
             join RATE_ALLOTMENT CA on CA.ID_ROOM_TYPE = :id_room_type
                                      and CA.ID_RATE = :id_RATE
                                      and CA.FOR_DATE = RTR.FOR_DATE
    into :for_date, :status,
         :auto_free_rooms, :RATE_capacity, :free_rooms
    do begin
      if (:auto_free_rooms is not null) then
        if (coalesce(:free_rooms,0) >= :auto_free_rooms) then
          is_active = 1;
        else is_active = 0;
      else if (:status = 0) then
             is_active = 1;
           else is_active = 0;

      to_sell = coalesce(:free_rooms,0) - coalesce(:auto_free_rooms,0);
      if (to_sell < 0) then to_sell = 0;

      room_count = :to_sell;
      if (:RATE_capacity is not null) then
        if (RATE_capacity < room_count) then
          room_count = :RATE_capacity;

      suspend;
    end
  end*/
end
^

/* empty dependent procedure body */
/* Clear: REP_ROOM_STATUS_BUILD$INT for: REP_ROOM_STATUS_DTS$INT */
ALTER PROCEDURE REP_ROOM_STATUS_BUILD$INT(ID_ROOM INTEGER,
FOR_DATE DATE,
STAT_OPTIONS VARCHAR(255))
 RETURNS(IS_LEAVING SMALLINT,
IS_COMMING SMALLINT,
IS_SHARED SMALLINT,
IS_LEAVING_WORDS VARCHAR(30),
BUSY_GRP INTEGER,
DAYS_THIS_STATUS INTEGER,
DTS_CONTEXT VARCHAR(10),
COMMING_OCCUPANTS VARCHAR(1024),
ID_BLOCK_ROOM INTEGER,
OTHER_OCCUPANTS VARCHAR(1024),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (REP_ROOM_STATUS_DTS$INT) */
ALTER PROCEDURE REP_ROOM_STATUS_DTS$INT(BUSY_GROUP_TYPE INTEGER,
FOR_DATE DATE,
ID_ROOM INTEGER)
 RETURNS(DAYS_THIS_STATUS INTEGER)
 AS
declare variable prev_date date;
  declare variable busy_date date;
begin
  -- CALCS DAYS THIS STATUS
  days_this_status = null;
  if (:busy_group_type = 0) then begin
    /* THE CURRENT STATUS IS FREE */
    select first 1 RM.BUSY_DATE
    from   ROOM_MAGIC RM
    where  RM.BUSY_DATE >= :for_date
           and RM.ID_ROOM = :id_room
           and RM.DAY_ACTION not containing 'CHECK_OUT'
    order by RM.BUSY_DATE asc
    into   :busy_date;
    days_this_status = :busy_date - :for_date;
  end else begin
    /* THE CURRENT STATUS IS BUSY */
    busy_date = :for_date;
    prev_date = :for_date;
    for
      select RM.BUSY_DATE
      from   ROOM_MAGIC RM
      where  RM.BUSY_DATE > :for_date
             and RM.ID_ROOM = :id_room
             and RM.DAY_ACTION not containing 'CHECK_OUT'
      order by RM.BUSY_DATE asc
      into   :busy_date
    do begin
      if (:busy_date > :prev_date + 1) then begin
        /* STATUS CHANGE FOUND */
        days_this_status = (:prev_date + 1) - :for_date;
        exit;
      end else begin
        prev_date = :busy_date;
      end
    end
    days_this_status = (:prev_date + 1) - :for_date;
  end
end
^

/* empty dependent procedure body */
/* Clear: APPLY_BOOKING_STATUS$EXC for: RES_ANUL_DETAIL$INT */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_ANUL_DETAIL$RSV for: RES_ANUL_DETAIL$INT */
ALTER PROCEDURE RES_ANUL_DETAIL$RSV(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_ANUL_DETAIL$WBE for: RES_ANUL_DETAIL$INT */
ALTER PROCEDURE RES_ANUL_DETAIL$WBE(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_ANUL_NOSHOW$INT for: RES_ANUL_DETAIL$INT */
ALTER PROCEDURE RES_ANUL_NOSHOW$INT(RD_DBKEY CHAR(8))
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_ANUL_DETAIL$INT) */
ALTER PROCEDURE RES_ANUL_DETAIL$INT(RD_DBKEY CHAR(8),
REASON VARCHAR(50),
CANCELATION_NUMBER TYPE OF NAME_20 = null)
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable id_reserv_detail integer;
  declare variable is_anul integer;
  declare variable id_log_event integer;
  declare variable id_guest integer;
  declare variable g_dbkey char(8);
  declare variable no_use varchar(255);
  declare variable tmp_extra_posts_left smallint;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:reason, 'NOSHOW, CANCELED, USERERROR, TRANSFER', 'Annul reason');

  select RD.IS_ANUL, RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :is_anul, :id_reserv_detail;

  if (:is_anul = 1) then begin
    exception BOOKING_EXCEPTION '-1021';
    -- Reservation is already annuled or checkedin !
  end

  if (:reason = 'NOSHOW') then begin
    execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    returning_values  :no_use, :no_use;

    -- execute procedure TAR_CALC_FINALIZE$INT(:err_code, :id_tar_calc, :rd_dbkey); -- this procedure is enclosed into RES_FINALIZE_RECALC$INT
    -- err_code = 0; -- IGNORE ALL ERRORS
  end

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_ANUL', f_character(29) || :reason);

  id_log_event = RDB$GET_CONTEXT('USER_TRANSACTION', 'ACTION_LOG_ID');

  update RESERV_DETAIL RDU
  set    RDU.IS_ANUL = 1,
         RDU.REASON_OF_ANUL = :reason,
         RDU.ID_LOG_EVENT_ANNUL = :id_log_event,
         RDU.CANCELATION_NUMBER = coalesce(:CANCELATION_NUMBER, strhash_large(rdu.NUMBER || 'CANCELATION'))
  where  RDU.RDB$DB_KEY = :rd_dbkey;

  EXTRA_POSTS_LEFT = 0;
  for
    select g.ID_GUEST, G.RDB$DB_KEY
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_guest, :g_dbkey
  do begin
    execute procedure GUEST_DEL_POSTINGS$INT(:id_guest)
    returning_values  :tmp_extra_posts_left;
    EXTRA_POSTS_LEFT = iif(:EXTRA_POSTS_LEFT = 1, 1, :tmp_extra_posts_left);

    update GUEST G
    set    G.UUID = null
    where  g.RDB$DB_KEY = :g_dbkey;
  end

  execute procedure RES_FINALIZE$INT (:RD_DBKEY, 0)
  returning_values (:warn_code);

  execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

end
^

/* empty dependent procedure body */
/* Clear: RES_TRANSFER_FINALIZE$RSV for: RES_ANUL_DETAIL$RSV */
ALTER PROCEDURE RES_TRANSFER_FINALIZE$RSV(ID_RESERV_DETAIL_NEW INTEGER,
ID_RESERV_DETAIL_OLD INTEGER)
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_ANUL_DETAIL$RSV) */
ALTER PROCEDURE RES_ANUL_DETAIL$RSV(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable rd_dbkey char(8);
declare variable check_status integer;
begin

  select RD.RDB$DB_KEY, rd.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :check_status;

  if (:check_status < 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('RESERV_ANNUL');
  end else begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('RESERV_CHECKED_IN_ANNUL');
  end

  execute procedure RES_ANUL_DETAIL$INT(:rd_dbkey, :reason)
  returning_values :WARN_CODE, :EXTRA_POSTS_LEFT;

end
^

/* Alter (RES_ANUL_DETAIL$WBE) */
ALTER PROCEDURE RES_ANUL_DETAIL$WBE(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable no_use varchar(255);
declare variable rd_dbkey char(8);
begin
  rd_dbkey = null;
  select rd.rdb$db_key
  from   reserv_detail rd
  where  rd.id_reserv_detail = :ID_RESERV_DETAIL
  into   :rd_dbkey;

  if (:rd_dbkey is null) then
    exception assert 'Reservation not found - RESERV_DETAIL_ID=' || coalesce(:ID_RESERV_DETAIL, '<null>');

  execute procedure EXPORT_LOG_FORCE$EXC(1);

  execute procedure RES_ANUL_DETAIL$INT (:rd_dbkey, coalesce(:REASON, 'CANCELED'))
  returning_values  :no_use, :no_use;
end
^

/* empty dependent procedure body */
/* Clear: RESERVS_EXPIRE$INT for: RES_ANUL_NOSHOW$INT */
ALTER PROCEDURE RESERVS_EXPIRE$INT(CLEAR_TODATE DATE,
ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_ANUL_NOSHOW$INT) */
ALTER PROCEDURE RES_ANUL_NOSHOW$INT(RD_DBKEY CHAR(8))
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable extra_posts_left smallint;
begin
  execute procedure RES_ANUL_DETAIL$INT(:rd_dbkey, 'NOSHOW')
  returning_values  :warn_code, :extra_posts_left;
  if (:extra_posts_left = 1) then exception ACCOUNT_EXCEPTION '-1042';

  when exception ACCOUNT_EXCEPTION do begin
    -- continue;
    execute procedure sys_dbg('res RES_ANUL_NOSHOW$INT exception ACCOUNT_EXCEPTION');
  end
end
^

/* empty dependent procedure body */
/* Clear: EAI_RES_CHECK_OUT_FAST for: RES_CHECK_OUT_GUESTS$RSV */
ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_CHECK_OUT_GUESTS$RSV) */
ALTER PROCEDURE RES_CHECK_OUT_GUESTS$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND SMALLINT = 0)
 AS
declare variable action_code varchar(100);
  declare variable cleaning_restriction varchar(10);
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable id_reserv_detail integer;
  declare variable id_guest integer;
  declare variable id_room integer;
  declare variable rd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable checkout_status integer;
  declare variable sys_date date;
  declare variable id_hotel integer;
begin
  checkout_status = 1;
  action_code = case when :check_out_kind = 0 then 'CHECK_OUT'
                     when :check_out_kind = 1 then 'CHECK_OUT_EARLY1'
                     when :check_out_kind = 2 then 'CHECK_OUT_EARLY2'
                     when :check_out_kind = 3 then 'CHECK_OUT_EARLY3'
                end;

  for
    select RD.ID_RESERV_DETAIL, RD.ID_ROOM, RD.RDB$DB_KEY, rd.ID_HOTEL,
           (select sd.SYSTEM_DATE
            from   SYSTEM_DATE_GET (rd.ID_HOTEL) sd)
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :id_reserv_detail, :id_room, :rd_dbkey, :id_hotel, :sys_date
  do begin

    for
      select G.ID_GUEST, G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.CHECK_STATUS = 0 /* checked in */
      into   :id_guest, :g_dbkey
    do begin
      if (:CHECK_OUT_KIND = 3) then begin
        -- DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
        update GUEST G
        set    G.EARLYCHECKOUT_DATE = :sys_date
        where  g.RDB$DB_KEY = :g_dbkey;

        execute procedure GUEST_SET_MANUAL_STAY$INT(:rd_dbkey, :id_guest, :sys_date)
        returning_values  :err_code, :err_text;
        if (:err_code < 0) then exception RESERV_CHECK_OUT_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
      end

      update ACCOUNT_POST AP
      set    AP.IS_ARCHIVE = 1
      where  AP.ID_GUEST = :id_guest;
    
      execute procedure GUEST_SET_STATUS$INT (:g_dbkey, :checkout_status);

      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, :action_code, '');
    end

    if (:CHECK_OUT_KIND = 3) then begin
      -- DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
      execute procedure OCCUPANCY_RESERV$INT(:rd_dbkey);
    end

    execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

    execute procedure SETTING_GET_VALUE('CLEANING_RESTRICTION', :id_hotel)
    returning_values  :cleaning_restriction;
  
    if (:cleaning_restriction <> '0' and :id_room > 0) then begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'CHECK_OUT', 'set_dirty');
    end

    execute procedure RES_SAVE_STATUS$INT (:rd_dbkey, :checkout_status);

    execute procedure RES_BONUSPOINTS_APPLY$CL (:id_reserv_detail);
  end

end
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE_ERRHANDLING$INT for: RES_FINALIZE_CLEAR$INT */
ALTER PROCEDURE RES_FINALIZE_ERRHANDLING$INT(ID_RESERV_DETAIL INTEGER,
HANDLED_ERR_CODE INTEGER,
HANDLED_ERR_TEXT VARCHAR(255),
ERROR_CONTEXT VARCHAR(200),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE_SHAREOPTION$INT for: RES_FINALIZE_CLEAR$INT */
ALTER PROCEDURE RES_FINALIZE_SHAREOPTION$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_FINALIZE_CLEAR$INT) */
ALTER PROCEDURE RES_FINALIZE_CLEAR$INT(OCCUPANT_DBKEY CHAR(8),
OCCUPANT_ID INTEGER,
OCCUPANT_TYPE VARCHAR(50) = 'RESERV')
 AS
declare variable id_room integer;
  declare variable busy_date date;
  declare variable share_transaction_id integer;
  declare variable shared_busy_group_type integer;
  declare variable shared_day_action_int integer;
  declare variable share_has_booking integer;
  declare variable share_has_ooo integer;
  declare variable share_has_block_ooi integer;
  declare variable share_has_owner_ooi integer;
  declare variable share_has_checkin integer;
  declare variable shared_busy_type varchar(50);
  declare variable shared_id_agent integer;
  declare variable id_reserv_statistics integer;
  declare variable g_dbkey char(8);
begin
  if (exists (select *
              from   RESERV_ERROR RE
              where  RE.ID_RESERV_DETAIL = :OCCUPANT_ID)) then
  begin
    exit;
  end

  if (:occupant_type = 'RESERV') then begin
    execute procedure RES_SET_EDIT_STATUS$INT (:occupant_dbkey, '');

    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :OCCUPANT_ID
      into   :g_dbkey
    do begin
      update GUEST G
      set    G.OLD_FROM_DATE = null,
             G.OLD_TO_DATE = null,
             G.OLD_ID_ROOM = null
      where  G.RDB$DB_KEY = :g_dbkey;

      execute procedure GUEST_SET_EDIT_STATUS$INT (:G_DBKEY, '');
    end
  end else begin
    -- do nothing BLOCKS DOES NOT NEED CLEAINING OF MODIFICATION FLAGS
    post_event 'dummy';
  end

  delete from ROOMS_SHARE RS
  where  RS.IS_EX_SHARE = 1;

  select first 1 RS.MARK_TRANSACTION
  from   ROOMS_SHARE RS
  where  RS.ID_RESERV_DETAIL = :occupant_id
  into   :share_transaction_id;

  if (:share_transaction_id is not null) then begin
    for
      select RM.ID_ROOM, RM.BUSY_DATE,
             max(iif(RM.BUSY_GROUP_TYPE = 1, 1, 0)),
             max(iif(RM.BUSY_GROUP_TYPE = 18, 1, 0)),
             max(iif(RM.BUSY_GROUP_TYPE = 20 and RM.DAY_ACTION_INT = 0, 1, 0)),
             max(iif(RM.BUSY_GROUP_TYPE = 20 and RM.DAY_ACTION_INT > 0, 1, 0)),
             max(iif(RM.BUSY_GROUP_TYPE = 24, 1, 0))
      from   ROOMS_SHARE RS
             join ROOM_MAGIC RM on RM.ID_ROOM_MAGIC = RS.ID_ROOM_SHARE
      where  RS.MARK_TRANSACTION = :share_transaction_id
      group by 1, 2
      into   :id_room, :busy_date,
             :share_has_booking, :share_has_ooo, :share_has_block_ooi, :share_has_owner_ooi, :share_has_checkin
    do begin
       if (:share_has_block_ooi = 1) then shared_busy_group_type = 20;
       else if (:share_has_owner_ooi = 1 and :share_has_checkin = 0 and :share_has_booking = 0) then shared_busy_group_type = 20;
       else if (:share_has_checkin = 1) then shared_busy_group_type = 24;
       else if (:share_has_booking = 1) then shared_busy_group_type = 1;
       else if (:share_has_ooo = 1) then shared_busy_group_type = 18;
       else exception OCCUPANCY_EXCEPTION 'Unknown occupant type. ASSERT.';

       select first 1 RM.BUSY_TYPE, RM.ID_AGENT, RM.DAY_ACTION_INT,
              --max(iif(RM.DAY_ACTION_INT = 2, 100, RM.DAY_ACTION_INT)),
              RM.ID_RESERV_DETAIL
       from   ROOMS_SHARE RS
              join ROOM_MAGIC RM on RM.ID_ROOM_MAGIC = RS.ID_ROOM_SHARE
              left outer join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = rm.ID_RESERV_DETAIL
       where  RS.MARK_TRANSACTION = :share_transaction_id
              and RS.ID_ROOM = :id_room
              and RS.BUSY_DATE = :busy_date
              and RM.BUSY_GROUP_TYPE = :shared_busy_group_type
       order by rd.FROM_DATE asc, rm.BUSY_TYPE asc, rm.ID_RESERV_DETAIL asc
       into   :shared_busy_type, :shared_id_agent, :shared_day_action_int, :id_reserv_statistics;

       update ROOMS_SHARE RSU
       set    RSU.BUSY_GROUP_TYPE = :shared_busy_group_type,
              RSU.DAY_ACTION_INT = iif(:shared_day_action_int = 100, 2, :shared_day_action_int),
              RSU.ID_AGENT = :shared_id_agent,
              RSU.BUSY_TYPE = :shared_busy_type,
              RSU.ID_RESERV_STATISTICS = :id_reserv_statistics
       where  RSU.BUSY_DATE = :busy_date
              and RSU.ID_ROOM = :id_room;
    end
  end

  if (:share_transaction_id is null and :OCCUPANT_TYPE = 'RESERV') then begin
    update RESERV_DETAIL RD
    set    rd.VIRTUAL_ROOM = null
    where  rd.RDB$DB_KEY = :OCCUPANT_DBKEY;
  end
end
^

/* empty dependent procedure body */
/* Clear: LOG_ID_LOOKUP_ERROR$EXC for: RES_FINALIZE_ERRHANDLING$INT */
ALTER PROCEDURE LOG_ID_LOOKUP_ERROR$EXC(OBJECT_ID VARCHAR(100),
OBJECT_TYPE VARCHAR(100),
LOOKUP_VALUE INTEGER,
LOOKUP_KEY VARCHAR(255),
LOOKUP_TYPE VARCHAR(255))
 AS
 BEGIN EXIT; END
^

/* Alter (RES_FINALIZE_ERRHANDLING$INT) */
ALTER PROCEDURE RES_FINALIZE_ERRHANDLING$INT(ID_RESERV_DETAIL INTEGER,
HANDLED_ERR_CODE INTEGER,
HANDLED_ERR_TEXT VARCHAR(255),
ERROR_CONTEXT VARCHAR(200),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT)
 AS
declare variable rd_dbkey char(8);
begin
  -- ALL INSTANT ERRORS MUST BE RAISED AS EXCEPTION !!!

  execute procedure sys_dbg('res RES_FINALIZE_ERRHANDLING$INT error_context = '||coalesce(:error_context, 'null'));
  execute procedure sys_dbg('res RES_FINALIZE_ERRHANDLING$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));
  execute procedure sys_dbg('res RES_FINALIZE_ERRHANDLING$INT handled_err_code = '||coalesce(:handled_err_code, 'null'));

  if (:handled_err_code < 0) then begin
    if (:SUPPRESS_NON_INSTANT_ERRORS = 0) then begin
      select rd.RDB$DB_KEY
      from   RESERV_DETAIL RD
      where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
      into   :rd_dbkey;
      -- clear
      execute procedure RES_FINALIZE_CLEAR$INT(:rd_dbkey, :id_reserv_detail);
      -- and raise exception
      exception BOOKING_EXCEPTION :handled_err_code || f_character(31) || :handled_err_text;

    end else begin
      -- log error
      update RESERV_ERROR re
      set    RE.ERR_CODE = :handled_err_code,
             RE.ERR_TEXT = :handled_err_text
      where  RE.ID_RESERV_DETAIL = :id_reserv_detail
             and RE.ERROR_CONTEXT = :error_context;
      if (row_count = 0) then begin
        insert into RESERV_ERROR (ID_RESERV_DETAIL, ERROR_CONTEXT, ERR_CODE, ERR_TEXT)
        values (:id_reserv_detail, :error_context, :handled_err_code, :handled_err_text);
      end
    end
  end else if (:handled_err_code = 0) then begin
    delete from RESERV_ERROR RE
    where  RE.ID_RESERV_DETAIL = :id_reserv_detail
           and RE.ERROR_CONTEXT = :error_context;
  end
end
^

/* Alter (RES_FINALIZE_OCCUPANCY$INT) */
ALTER PROCEDURE RES_FINALIZE_OCCUPANCY$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ERROR_CONTEXT VARCHAR(200),
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable busy_group_source integer;
declare variable tmp_warn_code integer;
declare variable id_room_type integer;
declare variable id_agent integer;
declare variable check_status integer;
declare variable from_date date;
declare variable to_date date;
begin
  err_code = 0;
  warn_code = null;
  tmp_warn_code = null;

  select iif(RD.CHECK_STATUS = 1, 24, 1), coalesce(R.ID_ROOM_TYPE, RD.ID_ROOM_TYPE), P.ID_AGENT,
         rd.CHECK_STATUS, rd.FROM_DATE, rd.TO_DATE
  from   RESERV_DETAIL RD
         left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
         left outer join PROFILE_AGENT P on P.ID_PROFILE = RD.ID_AGENT_PROFILE
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :busy_group_source, :id_room_type, :id_agent, :check_status, :from_date, :to_date;

  error_context = 'OCCUPANCY';
  execute procedure OCCUPANCY_RESERV$INT(:rd_dbkey);

  if (:id_agent is not null) then begin
    execute procedure OCCUPANCY_ACTIVE_FRAME_CHK$INT(:id_agent, :from_date, :to_date - 1, :id_room_type)
    returning_values  :err_code, :err_text;
    if (:err_code < 0) then exit;
  end

  if (:check_status > -3) then begin
    execute procedure OCCUPANCY_OVERBOOK_CHECK$INT (:id_agent, :from_date, :to_date - 1, :id_room_type)
    returning_values  :err_code, :err_text, :warn_code;
    if (:err_code < 0) then exit;
  end
  ---------------------------------
  error_context = 'ROOM_VALIDATION';
  execute procedure OCCUPANCY_ROOMS_CHECK$INT(:rd_dbkey, :busy_group_source)
  returning_values  :share_err_code, :share_err_text, :share_transaction_id, :tmp_warn_code;

  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

  /* empty shares helper table*/
  delete from RESERV_STAY$TMP t
  where  t.id_session = RDB$GET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION');

end
^

/* empty dependent procedure body */
/* Clear: IMPORT_BOOKING_FINALIZE$EXC for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE IMPORT_BOOKING_FINALIZE$EXC(BOOKING_ID INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1,
STATUS VARCHAR(50) = null,
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20) = null,
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20) = null)
 RETURNS(RECORD_TIMESTAMP TIMESTAMP,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_SET$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_CREATE_SET$RSV(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
SUPPRESS_WARNINGS INTEGER,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE$INT for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_FINALIZE$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ROOM$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SAVE_ROOM$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
ID_RES_ROOM_TYPE INTEGER,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(255),
SPLIT_ON_CHECKIN SMALLINT,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_STAY$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SAVE_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_CHECKIN$INT for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SET_CHECKIN$INT(RD_DBKEY CHAR(8))
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM$INT for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SET_ROOM$INT(RD_DBKEY CHAR(8),
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_STAY$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SET_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_FINALIZE$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RESMULTI_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER,
DISABLE_WARNING SMALLINT)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_FINALIZE_SHAREOPTION$INT) */
ALTER PROCEDURE RES_FINALIZE_SHAREOPTION$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable error_context varchar(200);
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable room_price numeric(15,4);
  declare variable is_anul smallint;
begin
  WARN_CODE = null;

  select RD.ID_RESERV_DETAIL, RD.CHECK_STATUS, rd.ROOM_PRICE, rd.IS_ANUL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail, :check_status, :room_price, :is_anul;

  execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));
  execute procedure RES_FINALIZE_OCCUPANCY$INT(:rd_dbkey)
  returning_values  :err_code, :err_text, :error_context, :share_transaction_id, :share_err_code, :share_err_text, :warn_code;

  --execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT share_err_code = '||coalesce(:share_err_code, 'null'));
  --execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT share_err_text = '||coalesce(:share_err_text, 'null'));
  --execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT err_code = '||coalesce(:err_code, 'null'));

  execute procedure RES_FINALIZE_ERRHANDLING$INT(:id_reserv_detail, :err_code, :err_text, :error_context, :SUPPRESS_NON_INSTANT_ERRORS);

  if (((:check_status >= 0) or (:room_price is null) or (:is_anul = 1) ) /*and (:is_anul = 0)*/) then begin
    execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    returning_values  :err_code, :err_text;

    execute procedure RES_FINALIZE_ERRHANDLING$INT(:id_reserv_detail, :err_code, :err_text, 'RECALC', :SUPPRESS_NON_INSTANT_ERRORS);
  end

  execute procedure RES_FINALIZE_CLEAR$INT(:rd_dbkey, :id_reserv_detail);

  warn_code = coalesce(:WARN_CODE, RDB$GET_CONTEXT('USER_TRANSACTION', 'WARN_CODE'));
  RDB$SET_CONTEXT('USER_TRANSACTION', 'WARN_CODE', null);

end
^

/* empty dependent procedure body */
/* Clear: RES_LOAD for: RES_GET_DYNAMIC_DATA$INT */
ALTER PROCEDURE RES_LOAD(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_AGENT_PROFILE INTEGER,
AGENT_PROFILE_NAME VARCHAR(100),
ID_PERSON_PROFILE INTEGER,
PERSON_PROFILE_NAME VARCHAR(100),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_RES_ROOM_TYPE INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
BOARD_NAMES VARCHAR(255),
TARIFF_NAMES VARCHAR(255),
PACKET_NAMES VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100),
VOUCHER_RENDER VARCHAR(512),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
TRANSFER_RENDER VARCHAR(255),
CODE_FIRST_FOOD_RENDER VARCHAR(255),
IS_LATE_DEPARTURE INTEGER,
CODE_FIRST_FOOD VARCHAR(20),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
I_SPECIAL_TREATMENT VARCHAR(255),
COMMING_KIND SMALLINT,
IS_VIP SMALLINT,
HAS_GUEST_LIST SMALLINT,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
AGENT_ACCOUNT_NAME VARCHAR(100),
IS_DIFFERENT_VOUCHER INTEGER,
IS_DIFFERENT_OTHER INTEGER,
IS_DIFFERENT_BOARD INTEGER,
IS_DIFFERENT_TARIFF INTEGER,
IS_CUSTOM_PRICE INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
ID_RATE INTEGER,
ROOM_FEATURES BLOB,
ID_GROUP INTEGER,
NUMBER VARCHAR(62),
CHECK_STATUS INTEGER,
BALANCE VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER,
RECIEVED_DEPOSITS VARCHAR(100),
ROOM_HISTORY VARCHAR(200),
TAR_ROOM_TYPE VARCHAR(100),
ID_HK_PLAN INTEGER,
COUNTRIES VARCHAR(812),
IS_RESGRP INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
IS_ANUL INTEGER,
NOTE VARCHAR(2000),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
GROUP_NAME VARCHAR(50),
ID_HOTEL INTEGER,
NOTE_REMINDERS VARCHAR(50),
IS_DIFFERENT_PRICE INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER,
ROOM_PRIVATE_STATUS /* TLOGICAL */ SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GET_DYNAMIC_DATA$INT) */
ALTER PROCEDURE RES_GET_DYNAMIC_DATA$INT(RD_DBKEY CHAR(8),
SHOW_ROOM_TEXTS INTEGER)
 RETURNS(ID_RES_ROOM_TYPE INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
ROOM_NAME VARCHAR(10),
ROOM_HISTORY VARCHAR(200),
TAR_ROOM_TYPE VARCHAR(200),
VIRTUAL_ROOM VARCHAR(10))
 AS
declare variable id_guest integer;
  declare variable proom_name varchar(50);
  declare variable croom_name varchar(50);
  declare variable type_room varchar(50);
  declare variable for_date date;
  declare variable first_room varchar(200);
begin
  room_name = null;
  room_history = '';
  tar_room_type = '';
  select RD.ID_BOARD, RD.ID_RATE,
         RD.ID_ROOM_TYPE, R.ID_ROOM, R.ROOM_NAME, coalesce(rd.VIRTUAL_ROOM, 'i'||RM.ID_ROOM),
         coalesce(rm.ID_ROOM_TYPE, R.ID_ROOM_TYPE), rd.ID_TITULAR,
         (select list(gp.ID_PACKET_ITEM, ',')
          from   GUEST_PACKET GP
          where  GP.ID_GUEST = rd.ID_TITULAR)
  from   RESERV_DETAIL RD
         left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
         left outer join ROOM_MAP$EXC rm on rm.ID_ROOM = rd.ID_ROOM
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_board, :id_rate,
         :id_res_room_type, :id_room, :room_name, :virtual_room,
         :id_room_type, :id_guest, :packet_item_ids;

  select substring(f_blobaspchar(list(distinct rt.TYPE_ROOM)) from 1 for 200)
  from   GUEST_STAY gs
         join ROOM_TYPES Rt on rt.ID_ROOM_TYPE = gs.ID_ROOM_TYPE
  where  gs.ID_GUEST = :id_guest
  into   :TAR_ROOM_TYPE;


  if (:show_room_texts = 1) then begin
    proom_name = null;
    first_room = '';
    /* GET ROOM MOVING HISTORY AS TEXT */
    for
      select R.ROOM_NAME, R.ID_ROOM_TYPE, GS.FOR_DATE
      from   GUEST_STAY GS
             join ROOMS R on R.ID_ROOM = GS.ID_ROOM
      where  GS.ID_GUEST = :id_guest
      order by GS.FOR_DATE asc
      into   :croom_name, :id_room_type, :for_date
    do begin
      if (:proom_name is distinct from :croom_name) then begin
        select RT.TYPE_ROOM
        from   ROOM_TYPES RT
        where  RT.ID_ROOM_TYPE = :id_room_type
        into   :type_room;

        if (:first_room = '') then
          first_room = formatDate(:for_date, 'D;dd/mm/yy') || ' ' ||:croom_name ||' / '|| :type_room;
        else begin
          room_history = formatDate(:for_date, 'D;dd/mm/yy') || ' ' ||:croom_name ||' / '|| :type_room || ' <- ' || :room_history;
        end

        proom_name = :croom_name;
      end
    end
    if (:room_history <> '') then room_history = :room_history || :first_room;
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_GET_SHARE_ALL_RELATIONS$INT for: RES_GET_SHARE_ALL_RELATIONS$INT */
ALTER PROCEDURE RES_GET_SHARE_ALL_RELATIONS$INT(FOR_RESERVATIONS VARCHAR(1024))
 RETURNS(RELATED_RESERVATIONS VARCHAR(1024))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GET_SHARE_STATUS$INT for: RES_GET_SHARE_ALL_RELATIONS$INT */
ALTER PROCEDURE RES_GET_SHARE_STATUS$INT(ID_RESERV_DETAIL INTEGER,
OPTION_ VARCHAR(100),
FOR_DATE DATE)
 RETURNS(SHARE_STATUS INTEGER,
SHARED_RESERVATIONS VARCHAR(1024),
SHARE_RENDER VARCHAR(1024))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GET_SHARE_ALL_RELATIONS$INT) */
ALTER PROCEDURE RES_GET_SHARE_ALL_RELATIONS$INT(FOR_RESERVATIONS VARCHAR(1024))
 RETURNS(RELATED_RESERVATIONS VARCHAR(1024))
 AS
declare variable id_reserv integer;
declare variable found_id_reserv integer;
begin
  /* Recursion - Find all reservations in shares, and then shared reservation with them and so on... */
  FOR_RESERVATIONS = ','|| :FOR_RESERVATIONS || ',';
  RELATED_RESERVATIONS = :FOR_RESERVATIONS;

  for
    select SP.ITEM
    from   SYSTEM_STRING_PARSER(:FOR_RESERVATIONS, ',') SP
    into   :id_reserv
  do begin
    for
      select distinct RS.ID_RESERV_DETAIL
      from   ROOM_MAGIC rm
             join ROOMS_SHARE RS on rm.id_room = rs.id_room
                                    and rm.busy_date = rs.busy_date
      where  rm.id_reserv_detail = :id_reserv
             and RS.IS_EX_SHARE = 0
      into   :found_id_reserv
    do begin
       if (:RELATED_RESERVATIONS not containing ','||:found_id_reserv ||',' ) then begin
          RELATED_RESERVATIONS = :RELATED_RESERVATIONS || ',' || :found_id_reserv || ','  ;
       end
    end
   end
   /*Recursion*/
   if (:RELATED_RESERVATIONS <> :FOR_RESERVATIONS) then
     execute procedure  RES_GET_SHARE_ALL_RELATIONS$INT ( :RELATED_RESERVATIONS )
     returning_values   :RELATED_RESERVATIONS;
end
^

/* empty dependent procedure body */
/* Clear: RES_GET_INFO$RSV for: RES_GET_SHARE_STATUS$INT */
ALTER PROCEDURE RES_GET_INFO$RSV(ID_RESERV_DETAIL INTEGER,
RETURN_BALANCE SMALLINT = 1,
RETURN_SHARE SMALLINT = 1,
RETURN_GEUSTDATA SMALLINT = 1)
 RETURNS(NUMBER VARCHAR(62),
AGENT_PROFILE_NAME VARCHAR(100),
ARRIVALS VARCHAR(255),
DEPARTURES VARCHAR(255),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
ID_ROOM INTEGER,
ROOM VARCHAR(60),
ID_ROOM_TYPE INTEGER,
ROOM_FEATURES BLOB,
GUESTS VARCHAR(255),
GUESTS_CNT INTEGER,
PERSON_PROFILE_NAME VARCHAR(150),
RATES VARCHAR(255),
BOARDS VARCHAR(255),
PACKETS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY VARCHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
BALANCE VARCHAR(255),
OPEN_CHARGES INTEGER,
CHECK_STATUS INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
NOTE VARCHAR(2000),
NOTE_GRP VARCHAR(255),
VOUCHER_RENDER VARCHAR(512),
ACC_ROUTING VARCHAR(255),
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
BUSY_GRP INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
GUEST_TYPE_COLOR INTEGER,
IS_CLEAN INTEGER,
ROOM_PRIVATE_STATUS /* TLOGICAL */ SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESGRP_GET_INFO$RSV for: RES_GET_SHARE_STATUS$INT */
ALTER PROCEDURE RESGRP_GET_INFO$RSV(ID_INFO_GROUP INTEGER)
 RETURNS(AGENT_PROFILE_NAME VARCHAR(100),
ARRIVALS VARCHAR(255),
DEPARTURES VARCHAR(255),
ROOM_DATA VARCHAR(255),
ROOMS VARCHAR(255),
ID_ROOM INTEGER,
GUESTS VARCHAR(255),
PERSON_PROFILE_NAME VARCHAR(100),
RATES VARCHAR(255),
BOARDS VARCHAR(255),
PACKETS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY VARCHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
BALANCE VARCHAR(255),
OPEN_CHARGES INTEGER,
CHECK_STATUS VARCHAR(255),
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
NOTE VARCHAR(2000),
NOTE_GRP VARCHAR(255),
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
FIRST_ARRIVAL DATE,
FIRST_DEPARTURE DATE,
HOTELS VARCHAR(255),
ID_HOTEL INTEGER,
ACC_ROUTING VARCHAR(255),
RES_NUMBER VARCHAR(62))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_GET_GUESTS$INT for: RES_GET_SHARE_STATUS$INT */
ALTER PROCEDURE TAR_CALC_GET_GUESTS$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_GUEST INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
G_DBKEY CHAR(8),
ID_GUEST_RESERV /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GET_SHARE_STATUS$INT) */
ALTER PROCEDURE RES_GET_SHARE_STATUS$INT(ID_RESERV_DETAIL INTEGER,
OPTION_ VARCHAR(100),
FOR_DATE DATE)
 RETURNS(SHARE_STATUS INTEGER,
SHARED_RESERVATIONS VARCHAR(1024),
SHARE_RENDER VARCHAR(1024))
 AS
declare variable mark_transaction integer;
  declare variable shared_reservation_id integer;
  declare variable occupant_info varchar(2000);
  declare variable is_ex_share integer;
  declare variable check_status integer;
  declare variable split_on_checkin integer;
  declare variable res_from_date date;
  declare variable res_to_date date;
  declare variable related_reservations VARCHAR(1024);
  declare variable busy_group_type integer;
begin
  /*  OPTIONs:
    !!!! DONT mix options !!!.
    ENUM_SHARES - return id's of shared reservations (SHARED_RESERVATIONS) in this save session - usable for calculation and regenerations, but not for renders.
    ENUM_EX_SHARES - return id's of shared reservations just leaved share. As above..
    RENDER - render all reservations in share with current. Usabe for gui previews.
  */
  execute procedure SYSTEM_CHECK_OPERATION (:OPTION_, 'ENUM_SHARES,ENUM_EX_SHARES,RENDER,FOR_RECALC', 'option');

  execute procedure sys_dbg('calc RES_GET_SHARE_STATUS$INT options = '||coalesce(:OPTION_, 'null'));

  shared_reservations = '';
  share_render = '';

  select RD.CHECK_STATUS, RD.SPLIT_ON_CHECKIN, RD.FROM_DATE, RD.TO_DATE
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :check_status, :split_on_checkin, :res_from_date, :res_to_date;

  mark_transaction = RDB$GET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION');

  if (:mark_transaction is null) then begin
    -- THE CALLER IS outside saving/regeneration transaction - NOT FINALIZING BOOKING CHANGES
    select min(RS.IS_EX_SHARE)
    from   ROOMS_SHARE RS
    where  RS.ID_RESERV_DETAIL = :id_reserv_detail
           and ((:for_date is null) or (RS.BUSY_DATE = :for_date))
    into   :is_ex_share;
  end else begin
    -- THIS TRANSACTION IS Saving booking and REGENERATING ROOMS_MAGIC
    select min(RS.IS_EX_SHARE)
    from   ROOMS_SHARE RS
    where  RS.MARK_TRANSACTION = :mark_transaction
           and ((:for_date is null) or (RS.BUSY_DATE = :for_date))
    into   :is_ex_share;
  end

  execute procedure sys_dbg('calc RES_GET_SHARE_STATUS$INT mark_transaction = '||coalesce(:mark_transaction, 'null'));

  if (:is_ex_share = 0) then share_status = 1;
  /*else - null or 1*/
  else share_status = 0;

  execute procedure sys_dbg('calc RES_GET_SHARE_STATUS$INT share_status = '||coalesce(:share_status, 'null'));

  /*option will be changed if we want enum shares ouside modification transaction - for recalculation in example*/
  if ((:OPTION_ = 'ENUM_SHARES') and (:share_status = 1) and (:mark_transaction is null)) then begin
    option_ = 'RENDER';
    execute procedure sys_dbg('calc RES_GET_SHARE_STATUS$INT option was ENUM_SHARES but is changd to RENDER, because :mark_transaction is null' );
  end

  if ((:OPTION_ = 'ENUM_SHARES') and (:share_status = 1)) then begin
    for
      select distinct RS.ID_RESERV_DETAIL
      from   ROOMS_SHARE RS
      where  RS.MARK_TRANSACTION = :mark_transaction
             and RS.BUSY_DATE = coalesce(:for_date, RS.BUSY_DATE)
             and RS.IS_EX_SHARE = 0
      into   :shared_reservation_id
    do begin
      if (:shared_reservation_id <> :id_reserv_detail) then begin
        shared_reservations = :shared_reservations || iif(:shared_reservations = '', '', ',');
        shared_reservations = :shared_reservations || :shared_reservation_id;
      end
    end
  end

  if (:OPTION_ = 'RENDER') then begin
    if (:SHARE_STATUS = 0 ) then begin
      if (:check_status < 0 and :split_on_checkin = 1 and :OPTION_ = 'RENDER') then begin
        share_status = 2;
        exit;
      end
    end else begin
      if (:for_date is not null) then begin
        /*make render only for one date, otherwise for erservation period*/
        res_from_date = :for_date;
        res_to_date = :for_date;
      end

      for
        select distinct RS.ID_RESERV_DETAIL, rs.BUSY_GROUP_TYPE
        from   ROOM_MAGIC rm
               join ROOMS_SHARE RS on rm.id_room = rs.id_room
                                      and rm.busy_date = rs.busy_date
        where  rm.id_reserv_detail = :id_reserv_detail
               and RM.BUSY_DATE between :res_from_date and :res_to_date
               and RS.IS_EX_SHARE = 0
        into   :shared_reservation_id, :busy_group_type
      do begin
        if (:shared_reservation_id <> :id_reserv_detail) then begin
          shared_reservations = :shared_reservations || iif(:shared_reservations = '', '', ',');
          shared_reservations = :shared_reservations || :shared_reservation_id;
          select OGI.INFO
          from   OCCUPANT_GET_INFO(:shared_reservation_id, :busy_group_type) OGI
          into   :occupant_info;
          share_render = :share_render || iif(:share_render = '', '', ',');
          share_render = :share_render || :occupant_info;
        end
      end
    end
  end

  if (:OPTION_ = 'ENUM_EX_SHARES') then begin
    for
      select distinct
             RS.ID_RESERV_DETAIL
      from   ROOMS_SHARE RS
      where  RS.MARK_TRANSACTION = :mark_transaction
             and ((:for_date is null) or (RS.BUSY_DATE = :for_date))
             and RS.IS_EX_SHARE = 1
      into   :shared_reservation_id
    do begin
      if (:shared_reservation_id <> :id_reserv_detail) then begin
        shared_reservations = :shared_reservations || iif(:shared_reservations = '', '', ',');
        shared_reservations = :shared_reservations || :shared_reservation_id;
      end
    end
  end

  if (:OPTION_ = 'FOR_RECALC') then begin
    /*for recalculation is needed all reservations that are connected somehow with this and relaetd to this reservations */
    execute procedure RES_GET_SHARE_ALL_RELATIONS$INT (:ID_RESERV_DETAIL)
    returning_values  :related_reservations;
    /*remove current reservation from list (recursion include curent also)*/
    for
      select SP.ITEM
      from   SYSTEM_STRING_PARSER(:related_reservations, ',') SP
      into   :shared_reservation_id
    do begin
      if (:shared_reservation_id <> :id_reserv_detail) then begin
        shared_reservations = :shared_reservations || iif(:shared_reservations = '', '', ',');
        shared_reservations = :shared_reservations || :shared_reservation_id;
      end
    end
  end

  suspend;
end
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_ADD$RSV for: RES_GUEST_ADD$INT */
ALTER PROCEDURE RES_GUEST_ADD$RSV(ID_RESERV_DETAIL INTEGER,
IS_CHILD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_GUEST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUESTCOUNT_ADD$INT for: RES_GUEST_ADD$INT */
ALTER PROCEDURE RES_GUESTCOUNT_ADD$INT(RD_DBKEY CHAR(8),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_GUEST_ADD$INT) */
ALTER PROCEDURE RES_GUEST_ADD$INT(RD_DBKEY CHAR(8),
IS_CHILD INTEGER)
 RETURNS(NEW_ID_GUEST INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable pd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable check_status integer;

  declare variable from_date date;
  declare variable to_date date;
  declare variable id_room integer;
  declare variable id_agent integer;
  declare variable id_tarrif integer;
  declare variable guest_name varchar(100);
  declare variable country_code varchar(10);
  declare variable guest_status varchar(50);
  declare variable default_mask varchar(50);
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable id_titular integer;
  declare variable id_profile_data integer;
  declare variable id_person_data integer;
  declare variable id_base_account integer;
  declare variable id_extra_account integer;
  declare variable id_hotel integer;
begin
  select RD.FROM_DATE, RD.TO_DATE, RD.ID_ROOM, PA.ID_AGENT, RD.ID_RATE,
         RD.ID_RESERV_DETAIL, RD.ID_TITULAR, PP.ID_PERSON_DATA,
         RD.CHECK_STATUS, RD.ADULT_COUNT, RD.CHILD_COUNT, RD.COUNTRY,
         rd.ID_BASE_ACCOUNT, rd.ID_EXTRA_ACCOUNT, rd.ID_HOTEL
  from   RESERV_DETAIL RD
         left outer join PROFILE_PERSON PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
         left outer join PROFILE_AGENT PA on PA.ID_PROFILE = RD.ID_AGENT_PROFILE
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :from_date, :to_date, :id_room, :id_agent, :id_tarrif,
         :id_reserv_detail, :id_titular, :id_profile_data,
         :check_status, :adult_count, :child_count, :country_code,
         :id_base_account, :id_extra_account, :id_hotel;

  if (:check_status < 0) then begin
    guest_status = '';
    check_status = -2;
  end else if (:check_status = 0) then begin
    guest_status = 'CHECKING_IN';
  end else begin  /* checked out */
    exception BOOKING_EXCEPTION '-1032';
  end


  new_id_guest = gen_id (id_guest_gen, 1);
  insert into GUEST (ID_GUEST, ID_BASE_ACCOUNT, ID_ACCOUNT, FROM_DATE, TO_DATE, ID_ROOM, ID_AGENT, ID_TARIFA,
         ID_RESERV_DETAIL, IS_CHILD, CHECK_STATUS, GUEST_EDIT_STATUS)
  values (:new_id_guest,  :id_base_account, :id_extra_account, :from_date, :to_date, :id_room, :id_agent, :id_tarrif,
         :id_reserv_detail, :is_child, -2, :guest_status)
  returning RDB$DB_KEY into :g_dbkey;

  execute procedure sys_dbg('res RES_GUEST_ADD$INT new_id_guest = '||coalesce(:new_id_guest, 'null'));

  insert into GUEST_CHANGE_STATUS (ID_GUEST, FROM_DATE_ORIG, TO_DATE_ORIG)
  values (:new_id_guest, :from_date, :to_date);

  if (:is_child = 1) then begin
    child_count = :child_count + 1;
    guest_name = '-';
  end else begin
    adult_count = :adult_count + 1;
    guest_name = '-';
  end

  if (:id_titular is null) then begin
    id_titular = :new_id_guest;
    id_person_data = :id_profile_data;
  end else begin
    execute procedure SETTING_GET_VALUE('DEF_GUEST_MASK', :id_hotel)
    returning_values  :default_mask;

    id_person_data = gen_id(GEN_PERSON_DATA_ID, 1);
    insert into PERSON_DATA (ID_PERSON_DATA, MASK)
    values (:id_person_data, :default_mask)
    returning RDB$DB_KEY into :pd_dbkey;

  end

  insert into GUEST_DATA (ID_GUEST, ID_PERSON_DATA)
  values (:new_id_guest, :id_person_data);

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name, :guest_name, coalesce(:country_code, ''),
          :is_child, null, null, null);

  execute procedure RES_GUEST_AUTO$INT(:g_dbkey, :rd_dbkey, 1);

  update RESERV_DETAIL RD
  set    RD.ADULT_COUNT = :adult_count,
         RD.CHILD_COUNT = :child_count,
         RD.ID_TITULAR = :id_titular
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SET_EDIT_STATUS$INT (:RD_DBKEY, 'ADDGUEST', 'add');

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, :check_status);

end
^

/* Alter (RES_GUEST_ADD$RSV) */
ALTER PROCEDURE RES_GUEST_ADD$RSV(ID_RESERV_DETAIL INTEGER,
IS_CHILD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_GUEST INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable action_text varchar(255);
begin
  warn_code = 0;
  err_code = 0;
  err_text = '';

  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey;

  execute procedure RES_GUEST_ADD$INT(:rd_dbkey, :IS_CHILD)
  returning_values  :NEW_ID_GUEST;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :NEW_ID_GUEST
  into   :ACTION_TEXT;
   
  ACTION_TEXT = F_CHARACTER(29) || '"' || :ACTION_TEXT || '" (' || :NEW_ID_GUEST || ')';
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_GUEST_ADD', :ACTION_TEXT);

end
^

/* empty dependent procedure body */
/* Clear: RES_DELETE$INT for: RES_GUEST_DEL$INT */
ALTER PROCEDURE RES_DELETE$INT(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUESTCOUNT_DEL$INT for: RES_GUEST_DEL$INT */
ALTER PROCEDURE RES_GUESTCOUNT_DEL$INT(RD_DBKEY CHAR(8),
DEL_ADULT_COUNT INTEGER,
DEL_CHILD_COUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_GUEST_DEL$INT) */
ALTER PROCEDURE RES_GUEST_DEL$INT(ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50) = null)
 RETURNS(EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable action_text varchar(255);
  declare variable guest_name varchar(100);
  declare variable is_child smallint;
  declare variable id_titular integer;
BEGIN

  select pd.PERSON_NAME, G.IS_CHILD, red.ID_TITULAR
  from   GUEST g
         join GUEST_DATA GD on gd.ID_GUEST = g.ID_GUEST
         join PERSON_DATA PD on PD.ID_PERSON_DATA = gd.ID_PERSON_DATA
         join RESERV_DETAIL RED on RED.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
         left outer join PROFILE_PERSON PP on PP.ID_PERSON_DATA = GD.ID_PERSON_DATA
  where  G.ID_GUEST = :ID_GUEST
  into   :guest_name, :is_child, :id_titular;

  if (:ID_GUEST = :id_titular) then exception BOOKING_EXCEPTION '-1007';

  execute procedure GUEST_DEL_POSTINGS$INT(:id_guest)
  returning_values :EXTRA_POSTS_LEFT;

  update GUEST G
  set    G.ID_RESERV_DETAIL = null
  where  G.ID_GUEST = :id_guest;

  update RESERV_DETAIL RD
  set    RD.ADULT_COUNT = RD.ADULT_COUNT - (1 - :is_child),
         RD.CHILD_COUNT = RD.CHILD_COUNT - :is_child
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL;

  action_text = f_character(29) || '"' || :guest_name || '" (' || :id_guest || ')' || f_character(28) || coalesce(:REASON, '');
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_GUEST_DEL', :action_text);

END
^

/* empty dependent procedure body */
/* Clear: CLEAR_ORPHAN_GUESTS$EXC for: RES_GUEST_DEL$RSV */
ALTER PROCEDURE CLEAR_ORPHAN_GUESTS$EXC(BOOKING_ID INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_GUEST_DEL$RSV) */
ALTER PROCEDURE RES_GUEST_DEL$RSV(ID_GUEST INTEGER,
REASON VARCHAR(50) = null)
 AS
declare variable rd_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable extra_posts_left integer;
begin
  select G.RDB$DB_KEY, RD.ID_RESERV_DETAIL, RD.CHECK_STATUS
  from   GUEST G
         join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
  where  G.ID_GUEST = :id_guest
  into   :rd_dbkey, :id_reserv_detail, :check_status;

  if (:check_status >= 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('RESERV_GUEST_DELETE');
  end

  execute procedure RES_GUEST_DEL$INT(:ID_GUEST, :id_reserv_detail, :REASON)
  returning_values :extra_posts_left;

  execute procedure OCCUPANCY_RESERV$INT(:rd_dbkey);
  --
end
^

/* Alter (RES_GUEST_SAVE$RSV) */
ALTER PROCEDURE RES_GUEST_SAVE$RSV(ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
GUEST_NAME1 VARCHAR(100),
AGE INTEGER,
BIRTH_DAY DATE,
IS_CHILD INTEGER,
COUNTRY_CODE VARCHAR(10) = NULL)
 RETURNS(NEW_ID_GUEST INTEGER)
 AS
declare variable g_dbkey char(8);
  declare variable pd_dbkey char(8);
begin
  /*  Description:
  ||
  */
  if (:id_guest is null) then begin
    -- get first anonnimous guest (check_status = -2  ?!)
    select first 1 PD.RDB$DB_KEY, G.RDB$DB_KEY, coalesce(:country_code, PD.COUNTRY_CODE),
           G.ID_GUEST
    from   GUEST G
           join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
           join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
           and G.CHECK_STATUS = -2
           and G.IS_CHILD = :IS_CHILD
    order by G.ID_GUEST asc
    into   :pd_dbkey, :g_dbkey, :country_code,
           :new_id_guest;
  end else begin
    new_id_guest = :id_guest;
    select G.RDB$DB_KEY, PD.RDB$DB_KEY, coalesce(:country_code, PD.COUNTRY_CODE)
    from   GUEST G
           join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
           join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
    where  G.ID_GUEST = :id_guest
    into   :g_dbkey, :pd_dbkey, :country_code;
  end

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name1, null,
          :country_code, :is_child, :age, :birth_day, null);

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -1);

end
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_ROOM$INT for: RES_GUESTCOUNT_ADD$INT */
ALTER PROCEDURE RES_CREATE_ROOM$INT(CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_COUNT INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_AGENT_PROFILE INTEGER,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_PERSON_PROFILE INTEGER,
ACC_ROUTING VARCHAR(50),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ID_GROUP INTEGER = null,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_GUARANTEE_POLICY INTEGER = null,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
RD_DBKEY CHAR(8),
NEW_ID_PERSON_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_GUESTCOUNT$INT for: RES_GUESTCOUNT_ADD$INT */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$INT(RD_DBKEY CHAR(8),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_GUESTCOUNT_ADD$INT) */
ALTER PROCEDURE RES_GUESTCOUNT_ADD$INT(RD_DBKEY CHAR(8),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 AS
declare variable i integer;
  declare variable is_child integer;
  declare variable new_id_guest integer;
begin
  i = 1;
  while (:i <= (coalesce(:adult_count, 0) + coalesce(:child_count, 0))) do begin
    if (:i <= :adult_count) then is_child = 0;
    else is_child = 1;

    execute procedure RES_GUEST_ADD$INT(:rd_dbkey, :is_child)
    returning_values  :new_id_guest;
    i = :i + 1;

  end
end
^

/* Alter (RES_GUESTCOUNT_DEL$INT) */
ALTER PROCEDURE RES_GUESTCOUNT_DEL$INT(RD_DBKEY CHAR(8),
DEL_ADULT_COUNT INTEGER,
DEL_CHILD_COUNT INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable del_count integer;
  declare variable id_guest integer;
  declare variable extra_posts_left integer;
begin
  /*  Description:
  ||
  */
  select RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail;

  del_count = 0;
  if (:del_adult_count > 0) then begin
    for
      select first (:DEL_ADULT_COUNT) g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.IS_CHILD = 0
             and G.CHECK_STATUS = -2
      order by G.ID_GUEST desc
      into   :id_guest
    do begin
      execute procedure RES_GUEST_DEL$INT(:id_guest, :id_reserv_detail)
      returning_values  :extra_posts_left;
      del_count = :del_count + 1;
    end
    if (:del_count < :DEL_ADULT_COUNT) then exception BOOKING_EXCEPTION '-1002';
  end

  del_count = 0;
  if (:del_child_count > 0) then begin
    for
      select first (:DEL_CHILD_COUNT) g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.IS_CHILD = 1
             and G.CHECK_STATUS = -2
      order by G.ID_GUEST desc
      into   :id_guest
    do begin
      execute procedure RES_GUEST_DEL$INT(:id_guest, :id_reserv_detail)
      returning_values  :extra_posts_left;
      del_count = :del_count + 1;
    end
    if (:del_count < :DEL_CHILD_COUNT) then exception BOOKING_EXCEPTION '-1002';
  end

end
^

/* empty dependent procedure body */
/* Clear: EXPORT_BOOKING$EXC for: RES_LOAD */
ALTER PROCEDURE EXPORT_BOOKING$EXC(BOOKING_ID INTEGER)
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20),
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_ID INTEGER,
IS_GUEST_ARRANGER INTEGER,
POSTING_ROUTING VARCHAR(20),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IS_DIFFERENT_TARIFF SMALLINT,
IS_DIFFERENT_BOARD SMALLINT,
IS_CUSTOM_PRICE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
EXC_LOCAL_VERSION BIGINT,
EXC_REMOTE_VERSION BIGINT,
CREATE_DATETIME TIMESTAMP,
EATING_OBJECT VARCHAR(50))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_LOAD) */
ALTER PROCEDURE RES_LOAD(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_AGENT_PROFILE INTEGER,
AGENT_PROFILE_NAME VARCHAR(100),
ID_PERSON_PROFILE INTEGER,
PERSON_PROFILE_NAME VARCHAR(100),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_RES_ROOM_TYPE INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
BOARD_NAMES VARCHAR(255),
TARIFF_NAMES VARCHAR(255),
PACKET_NAMES VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100),
VOUCHER_RENDER VARCHAR(512),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
TRANSFER_RENDER VARCHAR(255),
CODE_FIRST_FOOD_RENDER VARCHAR(255),
IS_LATE_DEPARTURE INTEGER,
CODE_FIRST_FOOD VARCHAR(20),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
I_SPECIAL_TREATMENT VARCHAR(255),
COMMING_KIND SMALLINT,
IS_VIP SMALLINT,
HAS_GUEST_LIST SMALLINT,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
AGENT_ACCOUNT_NAME VARCHAR(100),
IS_DIFFERENT_VOUCHER INTEGER,
IS_DIFFERENT_OTHER INTEGER,
IS_DIFFERENT_BOARD INTEGER,
IS_DIFFERENT_TARIFF INTEGER,
IS_CUSTOM_PRICE INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
ID_RATE INTEGER,
ROOM_FEATURES BLOB,
ID_GROUP INTEGER,
NUMBER VARCHAR(62),
CHECK_STATUS INTEGER,
BALANCE VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER,
RECIEVED_DEPOSITS VARCHAR(100),
ROOM_HISTORY VARCHAR(200),
TAR_ROOM_TYPE VARCHAR(100),
ID_HK_PLAN INTEGER,
COUNTRIES VARCHAR(812),
IS_RESGRP INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
IS_ANUL INTEGER,
NOTE VARCHAR(2000),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
GROUP_NAME VARCHAR(50),
ID_HOTEL INTEGER,
NOTE_REMINDERS VARCHAR(50),
IS_DIFFERENT_PRICE INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ID_EATING_OBJECT TYPE OF ID_REF,
ROOM_PRIVATE_STATUS TLOGICAL)
 AS
declare variable rd_dbkey char(8);
  declare variable reason_of_anul varchar(100);
  declare variable shared_resvations varchar(1024);
  declare variable virtual_room varchar(10);
  declare variable packet_item_ids varchar(255);
  declare variable earlycheckout_date date;
begin
  select RD.RDB$DB_KEY, RD.ID_AGENT_PROFILE, PA.PROFILE_NAME,
         RD.ID_NOM_MARKET_SEGMENT, RD.ID_NOM_SOURCE_CODE, RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_HEAR_REASON, RD.ID_NOM_COME_REASON,
         RD.ADULT_COUNT, RD.CHILD_COUNT, RD.CUSTOM_PRICE, RD.CUSTOM_CURRENCY,
         RD.IS_VIP, RD.CHECK_STATUS, RD.ID_AGENT_ACCOUNT,
         RD.ACC_ROUTING, RD.ID_PERSON_PAYMENT,
         RD.ID_AGENT_PAYMENT, RD.ID_PERSON_PROFILE, PP.PROFILE_NAME, RD.ID_GROUP,
         RD.COMMING_KIND, RD.I_SPECIAL_TREATMENT, ACC.ACCOUNT_NAME, RD.ROOM_FEATURES, RD.ID_HK_PLAN,
         RD.NUMBER, RD.IS_ANUL, RD.REASON_OF_ANUL, RD.NOTE,
         RD.HAS_DIFFERENT_VOUCHERS, RD.HAS_DIFFERENT_OTHER,
         RD.HAS_DIFFERENT_BOARD, RD.HAS_DIFFERENT_TARIFF, RD.HAS_DIFFERENT_TYPE_STAY, RD.HAS_DIFFERENT_ROOM_TYPE,
         RD.ID_HOTEL, RG.GROUP_NAME, RD.ID_RATE, RD.NOTE_REMINDERS, RD.has_different_price,
         RD.ID_GUARANTEE_POLICY, RD.BLOCK_CC, rd.ID_EATING_OBJECT, g.EARLYCHECKOUT_DATE
  from   RESERV_DETAIL RD
         left outer join RESERV_GROUP RG on RG.ID_RESERV_GROUP = RD.ID_GROUP
         left outer join PROFILE PA on PA.ID_PROFILE = RD.ID_AGENT_PROFILE
         left outer join PROFILE PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
         left outer join ACCOUNT ACC on ACC.ID_ACCOUNT = RD.ID_AGENT_ACCOUNT
         left outer join GUEST G on g.ID_GUEST = rd.ID_TITULAR
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :id_agent_profile, :agent_profile_name,
         :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason,
         :adult_count, :child_count, :custom_price, :custom_currency,
         :is_vip, :check_status, :id_agent_account, :acc_routing, :id_person_payment,
         :id_agent_payment, :id_person_profile, :person_profile_name, :id_group,
         :comming_kind, :i_special_treatment, :agent_account_name, :room_features, :id_hk_plan,
         :number, :is_anul, :reason_of_anul, :note,
         :is_different_voucher, :is_different_other,
         :is_different_board, :is_different_tariff, :is_different_stay_type, :is_different_room_type,
         :id_hotel, :group_name, :id_rate, :note_reminders, :is_different_price,
         :id_guarantee_policy, :block_cc, :id_eating_object, :earlycheckout_date;

  is_resgrp = iif(:id_group is not null, 1, 0);

  if ((:is_different_price = 1) or (:custom_price is not null) ) then
    IS_CUSTOM_PRICE = 1;
  else
    IS_CUSTOM_PRICE = 0;

  execute procedure RES_GET_PRICE$INT(:rd_dbkey, 'SECURITY')
  returning_values  :room_price, :room_currency, :room_price_details,
                    :deposit_required, :deposit_required_currency;

  execute procedure RES_GET_BALLANCE$INT(:id_reserv_detail)
  returning_values  :balance, :recieved_deposits, :has_charges, :open_charges, :open_deposit;

  execute procedure RES_GET_STATIC_DATA$INT(:rd_dbkey)
  returning_values  :arrival_date, :departure_date, :voucher_num, :voucher_date,
                    :voucher_text, :voucher2_num, :voucher2_date, :transfer_in_time,
                    :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :is_late_departure, :code_first_food;

  execute procedure RES_GET_DYNAMIC_DATA$INT(:rd_dbkey, 1)
  returning_values  :id_res_room_type, :id_room_type, :id_room, :id_board,
                    :id_tariff, :packet_item_ids, :room_name, :room_history, :tar_room_type, :virtual_room;

  execute procedure RES_GET_GUEST_DATA$INT('DETAIL', :id_reserv_detail)
  returning_values  :board_names, :tariff_names, :packet_names, :voucher_render;

  execute procedure RES_GET_GUEST_DATA2$INT(:id_reserv_detail)
  returning_values  :has_guest_list, :countries, :transfer_render, :code_first_food_render;

  execute procedure RES_GET_ATTENTION_STATUS$INT(:arrival_date, :departure_date, :check_status, :id_hotel)
  returning_values  :attention_status;

  execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'RENDER', null)
  returning_values  :in_share, :shared_resvations, :shares_preview;
  if (:IN_SHARE = 1) then ROOM_NAME = coalesce(:ROOM_NAME, :virtual_room);

  annul_status = :is_anul;
  if (:reason_of_anul = 'EXPIRE') then annul_status = 2;
  execute procedure sys_dbg('res RES_LOAD comming_kind = '||coalesce(:comming_kind, 'null'));

  ROOM_PRIVATE_STATUS = 0;
  select cast(1 as smallint)
  from   SYSTEM_DATE_GET (:ID_HOTEL) sd
         join ROOM_MAGIC rm on rm.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                               and rm.ROOM_STATUS = 'PRIVATE'
                               and rm.BUSY_DATE = mindate(maxdate(:ARRIVAL_DATE, sd.SYSTEM_DATE), coalesce(:earlycheckout_date, :DEPARTURE_DATE) - 1)
  into   :ROOM_PRIVATE_STATUS;

  suspend;
end
^

/* empty dependent procedure body */
/* Clear: RES_ROOM_REMOVE$RSV for: RES_ROOM_REMOVE$INT */
ALTER PROCEDURE RES_ROOM_REMOVE$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_ROOM_REMOVE$INT) */
ALTER PROCEDURE RES_ROOM_REMOVE$INT(RD_DBKEY CHAR(8))
 RETURNS(WARN_CODE INTEGER)
 AS
begin

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, gen_id(DETAIL_WITHOUT_ROOMING_LIST, -1), null, 'nrttAsIs')
  returning_values (:WARN_CODE);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 0)
  returning_values  :WARN_CODE;

end
^

/* Alter (RES_ROOM_REMOVE$RSV) */
ALTER PROCEDURE RES_ROOM_REMOVE$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable tmp_warn_code integer;
begin

  warn_code = null;

  for
    select RD.RDB$DB_KEY
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
           and RD.IS_ANUL = 0
    into   :rd_dbkey
  do begin
    execute procedure RES_ROOM_REMOVE$INT (:rd_dbkey)
    returning_values (:tmp_warn_code);
    WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
  end

end
^

/* Alter (RES_SAVE_FINALIZE$RSV) */
ALTER PROCEDURE RES_SAVE_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_RESERV_DATE TYPE OF TDATE)
 AS
declare variable rd_dbkey char(8);
  declare variable busy_group_source integer;
  declare variable res_edit_status varchar(255);
  declare variable err_code integer;
  declare variable tmp_err_text varchar(255);
  declare variable id_hotel integer;
begin
  execute procedure sys_dbg('occ RES_SAVE_FINALIZE$RSV enter');

  select RD.RDB$DB_KEY, iif(RD.CHECK_STATUS = 1, 24, 1), rd.RES_EDIT_STATUS, rd.ID_HOTEL
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :busy_group_source, :res_edit_status, :id_hotel;

  if (:res_edit_status containing 'ADDGUEST') then begin
    execute procedure RES_GUEST_FINALIZE$RSV (:ID_RESERV_DETAIL, 0)
    returning_values (:warn_code);
  end

  execute procedure OCCUPANCY_ROOMS_CHECK$INT(:rd_dbkey, :busy_group_source)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :WARN_CODE;
  --if (:share_err_code <> 0) then err_code = 0;      -- offer share entering
  --if (:share_err_code = 1) then share_err_code = 0; -- all shares are known

  execute procedure sys_dbg('occup RES_SAVE_FINALIZE$RSV share_err_code = '||coalesce(:share_err_code, 'null'));

  execute procedure RES_FINALIZE_CLEAR$INT(:rd_dbkey, :id_reserv_detail);

  delete from RESERV_STAY$TMP t
  where  t.id_session = RDB$GET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION', null);  -- Excplicitly set to null !!!

  err_code = 0;
  select first 1 RE.ERR_CODE, RE.ERR_TEXT
  from   RESERV_ERROR RE
  where  RE.ID_RESERV_DETAIL = :id_reserv_detail
  into   :err_code, :tmp_err_text;

  if (:err_code <> 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || :tmp_err_text;

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :NEW_RESERV_DATE;
end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_GUESTCOUNT$RSV for: RES_SAVE_GUESTCOUNT$INT */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_COMMON_MODIFY$RSV for: RES_SAVE_GUESTCOUNT$INT */
ALTER PROCEDURE RESMULTI_COMMON_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
CHECK_STATUS SMALLINT,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
NOTE VARCHAR(255),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(30),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
NOTE_REMINDERS VARCHAR(50),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_GUESTCOUNT$INT) */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$INT(RD_DBKEY CHAR(8),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 AS
declare variable old_adult_count integer;
  declare variable old_child_count integer;
  declare variable add_adult_count integer;
  declare variable add_child_count integer;
  declare variable del_adult_count integer;
  declare variable del_child_count integer;
begin

  if (((:adult_count + :child_count) <= 0) or (:adult_count < 0) or (:child_count < 0)) then begin
    exception BOOKING_EXCEPTION '-1005' || f_character(31) || f_character(29) || :adult_count || f_character(28) || :child_count;
  end

  select RD.ADULT_COUNT, RD.CHILD_COUNT
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_adult_count, :old_child_count;
  add_adult_count = 0;
  add_child_count = 0;
  del_adult_count = 0;
  del_child_count = 0;
  if (:old_adult_count < :adult_count) then add_adult_count = adult_count - :old_adult_count;
  else del_adult_count = :old_adult_count - :adult_count;
  if (:old_child_count < :child_count) then add_child_count = child_count - :old_child_count;
  else del_child_count = :old_child_count - :child_count;

  execute procedure RES_GUESTCOUNT_ADD$INT(:rd_dbkey, :add_adult_count, :add_child_count);

  execute procedure RES_GUESTCOUNT_DEL$INT(:rd_dbkey, :del_adult_count, :del_child_count);
end
^

/* Alter (RES_SAVE_GUESTCOUNT$RSV) */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select rd.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  rd.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SAVE_GUESTCOUNT$INT(:rd_dbkey, :adult_count, :child_count);

  execute procedure RES_SAVE_ACCOUNTS$INT (:rd_dbkey);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 0)
  returning_values  :warn_code;

end
^

/* empty dependent procedure body */
/* Clear: RES_CHECKIN$RSV for: RES_SAVE_ROOM$INT */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_SET$INT for: RES_SAVE_ROOM$INT */
ALTER PROCEDURE RES_CREATE_SET$INT(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_HOTEL INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
SPLIT_ON_CHECKIN SMALLINT,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_ACC_TEMPLATE_PERSON INTEGER = null,
ID_GUARANTEE_POLICY INTEGER = null,
BLOCK_CC VARCHAR(255) = null,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(RD_DBKEY CHAR(8),
NEW_ID_RESERV_DETAIL INTEGER,
WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_ROOM_REMOVE$INT for: RES_SAVE_ROOM$INT */
ALTER PROCEDURE RES_ROOM_REMOVE$INT(RD_DBKEY CHAR(8))
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_ROOM$INT) */
ALTER PROCEDURE RES_SAVE_ROOM$INT(RD_DBKEY TYPE OF TDB_KEY,
ID_ROOM TYPE OF ID,
ID_RES_ROOM_TYPE TYPE OF ID,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE TYPE OF TLOGICAL = null)
 RETURNS(WARN_CODE TYPE OF TRANGE)
 AS
declare variable id_reserv_detail integer;
  declare variable id_tar_room_type integer;
  declare variable old_id_room_type integer;
  declare variable old_id_room integer;
  declare variable departure_date date;
  declare variable id_guest integer;
  declare variable g_dbkey char(8);
  declare variable system_date date;
  declare variable system_date_for_room date;
  declare variable check_status integer;
  declare variable cleaning_restriction varchar(50);
  declare variable guest_status varchar(50) default '';
  declare variable id_hotel integer;
  declare variable has_different_room_type integer;
  declare variable acc_routing varchar(30);
  declare variable res_number varchar(62);
begin
  select RD.ID_ROOM_TYPE, RD.CHECK_STATUS, RD.ID_ROOM, RD.TO_DATE, RD.ID_RESERV_DETAIL, RD.ID_HOTEL, rd.ACC_ROUTING, rd.NUMBER
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_room_type, :check_status, :old_id_room, :departure_date, :id_reserv_detail, :id_hotel, :acc_routing, :res_number;

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date_for_room;
  /**/
  system_date = null;
  /*  */
  if (:check_status >= 0 and :old_id_room > 0 and coalesce(:id_room, 0) <= 0) then
    exception BOOKING_EXCEPTION '-111';

  if ((:old_id_room > 0) and (:id_room is distinct from :old_id_room)) then begin
    guest_status = 'ROOM_CHANGED';
    if ((:old_id_room > 0) and (:id_room > 0)) then begin
      execute procedure SYSTEM_DATE_GET(:id_hotel)
      returning_values  :system_date;
      execute procedure sys_dbg('res RES_SAVE_ROOM$INT old_id_room = '||coalesce(:old_id_room, 'null'));
      execute procedure sys_dbg('res RES_SAVE_ROOM$INT check_status = '||coalesce(:check_status, 'null'));

      if ((:departure_date <= :system_date) and (:check_status >= 0)) then exception BOOKING_EXCEPTION '-51';
    end
  end

  if (:id_room is null and :old_id_room < 0) then id_room = :old_id_room; -- preserve old fictious ID, because of mapped rooms

  if (coalesce(:id_room, 0) <= 0) then begin
    delete from ROOM_MAP$EXC m
    where  m.id_room = :id_room
           and m.ID_SRC_ROOM < 0;  -- delete wrong mappings (bug 2827)

    select ro.ID_ROOM
    from   RES_OCCUPANCY_ROOM$INT (:id_reserv_detail, :system_date_for_room, :id_room, :ID_RES_ROOM_TYPE) RO
    into   :id_room;

  end else begin
    -- real room is
    id_res_room_type = :old_id_room_type;
    if (:acc_routing <> 'OWNER'
        and :id_room is distinct from :old_id_room
        and exists (select rp.ID_ROOM_PERIOD
                    from   ROOM_PERIOD$PMS rp
                    where  rp.ID_ROOM = :ID_ROOM
                           and rp.FROM_DATE <= :system_date_for_room
                           and rp.TO_DATE >= :system_date_for_room
                           and rp.STATUS = 'PRIVATE')) then
    begin
      execute procedure SYSTEM_WARNING_ADD (-61, f_character(29) || :res_number)
      returning_values  :WARN_CODE;
    end
  end
  id_res_room_type = coalesce(:id_res_room_type, :old_id_room_type);
  -- null is permissible for id_res_room_type, treat of "keep the same"

  /* tar_option : nrttAsIs, nrttRoom, nrttReserv */
  id_tar_room_type = null;
  has_different_room_type = null;
  if (:tar_option = 'nrttAsIs') then begin
    id_tar_room_type = null;
    has_different_room_type = null;
  end else if (:tar_option = 'nrttRoom') then begin
    --id_tar_room_type = iif(coalesce(:id_room, 0) <= 0 and :room_id_room_type <> :ID_RES_ROOM_TYPE, :room_id_room_type, -1);
    id_tar_room_type = iif (:ID_ROOM > 0, -1, null); -- if not room - like a AsIs
    has_different_room_type = iif(:id_tar_room_type = -1, 0, null);
    -- preserve tar_room_type from mapped(unexisted) room
  end else begin /* nrttReserv */
    id_tar_room_type = :id_res_room_type;
    has_different_room_type = 1;
  end

  update RESERV_DETAIL RD
  set    RD.ID_ROOM = :id_room,
         rd.ROOM_PRICE = case
                           when rd.CHECK_STATUS >= 0 then null
                           -- 'checked in' bookings - force recalculation always
                           when rd.CHECK_STATUS < 0
                                and ((rd.ID_ROOM_TYPE <> :id_res_room_type) or (:id_room is distinct from :old_id_room)) then null
                           -- not 'checked in', but room/room type changed - force too
                           else rd.ROOM_PRICE
                         end,   -- <null> room_price will be force booking recalculation !!!
         RD.ID_ROOM_TYPE = :id_res_room_type,  -- this field update must be after room_price update
         rd.HAS_DIFFERENT_ROOM_TYPE = coalesce(:has_different_room_type, rd.HAS_DIFFERENT_ROOM_TYPE) --iif(coalesce(:id_tar_room_type, 0) > 0, 1, rd.HAS_DIFFERENT_ROOM_TYPE)
  where  RD.RDB$DB_KEY = :rd_dbkey;

  for
    select G.RDB$DB_KEY, G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :g_dbkey, :id_guest
  do begin
    update GUEST GU
    set    GU.OLD_ID_ROOM = GU.ID_ROOM,
           GU.ID_ROOM = :id_room
    where  GU.RDB$DB_KEY = :g_dbkey;

    execute procedure GUEST_SET_EDIT_STATUS$INT (:g_dbkey, :guest_status, 'add');
   
    /*Old code if (:system_date is null) update room_type and type stay*/
    update GUEST_STAY GS
    set    GS.ID_ROOM_TYPE = iif(:id_tar_room_type is null, GS.ID_ROOM_TYPE, :id_tar_room_type),
           GS.ID_TYPE_STAY = iif(:is_auto_staytype = 1, -1, GS.ID_TYPE_STAY)
    where  GS.ID_GUEST = :id_guest
           and ((:system_date is null) or (GS.FOR_DATE >= :system_date));

    /*New part - Room number never be updated in past - important for shares and calulations*/
    /* will be updated in pass only if there was no room assigned*/
    update GUEST_STAY GS
    set    GS.ID_ROOM = :id_room
    where  GS.ID_GUEST = :id_guest
           and ((GS.FOR_DATE >= :system_date_for_room)
                 or (:check_status < 0) -- new - always change id_room from begining, for non checked in reservs
               ) ;
  end

  if ((:check_status = 0) and (:guest_status = 'ROOM_CHANGED') and (:old_id_room > 0)) then begin
    /* IF THE CLEANING RESTRICTION IS ACTIVATED AND THE OLD
    || GUEST'S ROOM IS VACANT THEN IT MUST BE MARKED DIRTY.
    */
    execute procedure SETTING_GET_VALUE('CLEANING_RESTRICTION', :id_hotel)
    returning_values  :cleaning_restriction;
    if ((:cleaning_restriction <> '0') and (not exists (
      select *
      from   GUEST G
             join GUEST_STAY GS on GS.ID_GUEST = G.ID_GUEST
      where  GS.FOR_DATE >= :system_date
             and G.CHECK_STATUS = 0
             and GS.ID_ROOM = :old_id_room
             and G.ID_RESERV_DETAIL <> :id_reserv_detail
    ))) then begin
      execute procedure ROOM_HOUSEKEEPING(:old_id_room, 'GST_MOVED', 'set_dirty');
    end
  end

  execute procedure RES_SAVE_ROOM_LOG$INT(:RD_DBKEY, :old_id_room, :old_id_room_type);

end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ROOM$EXC for: RES_SAVE_ROOM$RSV */
ALTER PROCEDURE RES_SAVE_ROOM$EXC(RD_DBKEY CHAR(8),
ID_RES_ROOM_TYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(250),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_ROOM$RSV) */
ALTER PROCEDURE RES_SAVE_ROOM$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
ID_RES_ROOM_TYPE INTEGER,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(255),
SPLIT_ON_CHECKIN SMALLINT,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
declare variable tmp_warn_code integer;
begin
  WARN_CODE = null;
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, :id_res_room_type, :TAR_OPTION, :is_auto_staytype)
  returning_values (:WARN_CODE);

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 1)
    returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :tmp_warn_code;
  end
  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

  update RESERV_DETAIL R
  set    r.SPLIT_ON_CHECKIN = :split_on_checkin,
         r.ID_HK_PLAN = :ID_HK_PLAN,
         r.I_SPECIAL_TREATMENT = :I_SPECIAL_TREATMENT,
         r.ROOM_FEATURES = :ROOM_FEATURES
  where  r.ID_RESERV_DETAIL = :id_reserv_detail;
end
^

/* empty dependent procedure body */
/* Clear: UPDATE_BOOKING$EXC for: RES_SAVE_STAY$RSV */
ALTER PROCEDURE UPDATE_BOOKING$EXC(BOOKING_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE INTEGER,
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA_ID INTEGER,
POSTING_ROUTING VARCHAR(20),
ID_AGENT_ACCOUNT INTEGER,
RATE_ID INTEGER,
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD_CODE /* TFOOD_CODE */ VARCHAR(20),
ARRANGER_PROFILE_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_STAY$RSV) */
ALTER PROCEDURE RES_SAVE_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure sys_dbg('res RES_SAVE_STAY$RSV comming_kind = '||coalesce(:comming_kind, 'null'));
  execute procedure sys_dbg('res RES_SAVE_STAY$RSV is_late_departure = '||coalesce(:is_late_departure, 'null'));

  execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :departure_date, :is_late_departure, :comming_kind);

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 1)
    returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;
    execute procedure sys_dbg('res RES_SAVE_STAY$RSV share_err_code = '||coalesce(:share_err_code, 'null'));
  end
  --
end
^

/* Alter (RES_SET_CHECKIN$INT) */
ALTER PROCEDURE RES_SET_CHECKIN$INT(RD_DBKEY CHAR(8))
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
begin
  select r.ID_RESERV_DETAIL
  from   RESERV_DETAIL R
  where  r.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail;

  execute procedure ROOM_MAGIC_CLEAR(:id_reserv_detail);   -- ?!?

  execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, 0);

  for
    select G.RDB$DB_KEY
    from   GUEST G
    where  g.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :g_dbkey
  do begin
    execute procedure GUEST_SET_STATUS$INT(:g_dbkey, 0);
  end

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;
end
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_CO_RENTERS$INT for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_CO_RENTERS$INT(VIRTUAL_ID_ROOM INTEGER,
NEW_ID_ROOM INTEGER,
INIT_ID_RES_DETAIL INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_FAST$RSV for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_FAST$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_MULTI$RSV for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_MULTI$RSV(OPERATION VARCHAR(20),
FROM_ROOM VARCHAR(20),
SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_SHARED$RSV for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_SHARED$RSV(SELECTION_ID INTEGER,
ROOM_NAME VARCHAR(10))
 RETURNS(VIRTUAL_ROOM VARCHAR(10),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SET_ROOM$INT) */
ALTER PROCEDURE RES_SET_ROOM$INT(RD_DBKEY CHAR(8),
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
declare variable tmp_warn_code integer;
begin
  WARN_CODE = null;
  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option)
  returning_values (:WARN_CODE);

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :SHARE_ERR_TEXT, :share_transaction_id, :tmp_warn_code;

  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
end
^

/* Alter (RES_SET_ROOM_CO_RENTERS$INT) */
ALTER PROCEDURE RES_SET_ROOM_CO_RENTERS$INT(VIRTUAL_ID_ROOM INTEGER,
NEW_ID_ROOM INTEGER,
INIT_ID_RES_DETAIL INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
declare variable shared_rd_dbkey char(8);
declare variable shared_booking_ids varchar(255);
declare variable id_reserv_detail integer;
declare variable tmp_share_err_code integer;
declare variable tmp_share_err_text varchar(255);
begin
  -- distribute the same room to shared bookings

  if (coalesce(:NEW_ID_ROOM, 0) < 0) then exit; -- only for real rooms!1
  SHARE_ERR_CODE = 0;
  shared_booking_ids = ',' || :INIT_ID_RES_DETAIL || ',';
  for
    select vrd.RDB$DB_KEY, vrd.ID_RESERV_DETAIL
    from   RESERV_DETAIL VRD
    where  vrd.ID_ROOM = :VIRTUAL_ID_ROOM
           and vrd.IS_ANUL = 0
           and vrd.ID_RESERV_DETAIL is distinct from :INIT_ID_RES_DETAIL
    into   :shared_rd_dbkey, :id_reserv_detail
  do begin
    shared_booking_ids = :shared_booking_ids || :id_reserv_detail || ',';

    execute procedure RES_SET_ROOM$INT (:shared_rd_dbkey, :NEW_ID_ROOM, :TAR_OPTION)
    returning_values  :WARN_CODE, :share_transaction_id, :tmp_share_err_code, :tmp_share_err_text;

    if (:SHARE_ERR_CODE = 0 and :tmp_share_err_code < 0) then begin
      -- check for share with other bookings
      if (exists (select rs.ID_RESERV_DETAIL
                      from   ROOMS_SHARE rs
                      where  rs.MARK_TRANSACTION = :SHARE_TRANSACTION_ID
                             and :shared_booking_ids not containing ','||rs.ID_RESERV_DETAIL||','
                             and rs.IS_EX_SHARE = 0)) then
      begin
        SHARE_ERR_CODE = :tmp_share_err_code;
        SHARE_ERR_TEXT = :tmp_share_err_text;
      end
    end
  end 
end
^

/* Alter (RES_SET_ROOM_FAST$RSV) */
ALTER PROCEDURE RES_SET_ROOM_FAST$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable old_id_room integer;
  declare variable virtual_room varchar(10);
  declare variable rd_dbkey char(8);
  declare variable tmp_warn_code integer;
  declare variable tmp_share_err_code integer;
  declare variable tmp_share_err_text varchar(255);
begin

  select RD.ID_ROOM, rd.VIRTUAL_ROOM, rd.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_id_room, :virtual_room, :rd_dbkey;

  execute procedure RES_SET_ROOM$INT (:rd_dbkey, :ID_ROOM, :TAR_OPTION)
  returning_values (:warn_code, :share_transaction_id, :share_err_code, :ERR_TEXT);

  if (:virtual_room is not null and :old_id_room < 0) then begin
    execute procedure RES_SET_ROOM_CO_RENTERS$INT (:old_id_room, :ID_ROOM, :ID_RESERV_DETAIL, :TAR_OPTION)
    returning_values (:tmp_warn_code, :share_transaction_id, :tmp_share_err_code, :tmp_share_err_text);
    WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
    SHARE_ERR_CODE = coalesce(:SHARE_ERR_CODE, :tmp_share_err_code);
    ERR_TEXT = coalesce(:ERR_TEXT, :tmp_share_err_text);
  end
end
^

/* Alter (RES_SET_ROOM_MULTI$RSV) */
ALTER PROCEDURE RES_SET_ROOM_MULTI$RSV(OPERATION VARCHAR(20),
FROM_ROOM VARCHAR(20),
SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable cnt_requested integer;
  declare variable cnt_old_room integer;
  declare variable cnt_found integer;
  declare variable is_already_planned integer;
  declare variable is_satisfied integer;
  declare variable new_id_room integer;
  declare variable current_id_room integer;
  declare variable id_res_room_type integer;
  declare variable room_requirements blob sub_type 1 segment size 100;
  declare variable from_date date;
  declare variable to_date date;
  declare variable action_text varchar(255);
  declare variable is_early_arrival smallint;
  declare variable is_late_departure smallint;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable id_reserv_detail integer;
  declare variable tmp_warn_code integer;
  declare variable min_beds integer;
  declare variable virtual_room varchar(10);
  declare variable share_err_text varchar(255);
begin
  /* offer_method :
  ||     0 - NUMBER desc,
  ||     1 - NUMBER asc,
  ||     2 - DAYS FREE(MAX OCCUPANCY),
  ||     3 - FILING FACTOR(EQUAL ROOM USAGE)
  */
  warn_code = null;

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'set_number_asc, set_number_desc, set_max_occupancy, set_max_usage');

  cnt_requested = 0;
  cnt_old_room = 0;
  cnt_found = 0;
  for
    select RD.RDB$DB_KEY, rd.ID_RESERV_DETAIL, rd.ID_ROOM, rd.VIRTUAL_ROOM, RD.ID_ROOM_TYPE, RD.ROOM_FEATURES,
           RD.FROM_DATE, RD.TO_DATE, iif(rd.COMMING_KIND = 0, 1, 0), iif(rd.LEAVING_KIND = 2, 1, 0),
           rd.ADULT_COUNT + rd.CHILD_COUNT
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
           and RD.IS_ANUL = 0
    into   :rd_dbkey, :id_reserv_detail, :current_id_room, :virtual_room, :id_res_room_type, :room_requirements,
           :from_date, :to_date, :is_early_arrival, :is_late_departure, :min_beds
  do begin
    cnt_requested = :cnt_requested + 1;
    new_id_room = null;
    if (:current_id_room < 0) then begin
      if (:virtual_room is not null) then begin
        -- has related bookings with shared virtual room
        -- get cumulative stay for all shared bookings
        select min(vrd.FROM_DATE), min(vrd.FROM_DATE) - min(vrd.FROM_DATE - iif(vrd.COMMING_KIND = 0, 1, 0)),
               max(vrd.TO_DATE), max(vrd.TO_DATE + iif(vrd.LEAVING_KIND = 2, 1, 0)) - max(vrd.TO_DATE),
               sum(vrd.ADULT_COUNT + vrd.CHILD_COUNT)
        from   RESERV_DETAIL VRD
        where  vrd.ID_ROOM = :current_id_room
               and vrd.IS_ANUL = 0
        into   :from_date, :is_early_arrival, :to_date, :is_late_departure, :min_beds;
      end
      -- from_date and to_date are arrival and departure date of reservation,
      -- not first and last accomodation dates !!! this is need to check early arrivals and late departures
      execute procedure ROOM_PICKUP$INT(:id_res_room_type, :from_date, :to_date,
              :is_early_arrival, :is_late_departure,:operation, :from_room, :room_requirements, :min_beds)
      returning_values  :new_id_room;  -- offered room

      if (:new_id_room is not null) then begin
        is_satisfied = 1;
        select R.ROOM_NAME
        from   ROOMS R
        where  r.ID_ROOM = :new_id_room
        into   :action_text;

        execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'ROOM_SET_AUTO', :action_text);

        execute procedure RES_SET_ROOM$INT (:rd_dbkey, :new_id_room, 'nrttAsIs')
        returning_values (:tmp_warn_code, :share_transaction_id, :share_err_code, :share_err_text);
        if (:share_err_code < 0) then exception BOOKING_EXCEPTION 'Unallowable share!!!';
        WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

        if (:virtual_room is not null) then begin
          -- distribute the same room to shared bookings
          execute procedure RES_SET_ROOM_CO_RENTERS$INT (:current_id_room, :new_id_room, :id_reserv_detail, 'nrttAsIs')
          returning_values (:tmp_warn_code, :share_transaction_id, :share_err_code, :share_err_text);
          if (:share_err_code < 0) then exception BOOKING_EXCEPTION 'Unallowable share!!!';
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
        end
      end

    end else begin
      is_already_planned = 1;
    end

    cnt_old_room = :cnt_old_room + :is_already_planned;
    cnt_found = :cnt_found + :is_satisfied;

    when exception BOOKING_EXCEPTION do begin
      -- nothing, skip this booking
    end
  end

  if ((:cnt_found + :cnt_old_room) < :cnt_requested) then begin
    execute procedure SYSTEM_WARNING_ADD(-3, f_character(29)||:cnt_found||f_character(28)||:cnt_requested)
    returning_values  :warn_code;
  end
end
^

/* Alter (RES_SET_ROOM_SHARED$RSV) */
ALTER PROCEDURE RES_SET_ROOM_SHARED$RSV(SELECTION_ID INTEGER,
ROOM_NAME VARCHAR(10))
 RETURNS(VIRTUAL_ROOM VARCHAR(10),
WARN_CODE INTEGER)
 AS
declare variable r_dbkey char(8);
  declare variable is_anul integer;
  declare variable shared_id_room integer;
  declare variable current_id_room integer;
  declare variable tmp_warn_code integer;
  declare variable share_trans integer;
  declare variable share_err_code integer;
  declare variable id_hotel integer;
  declare variable cnt_hotels integer;
  declare variable id_room integer;
  declare variable res_counter integer;
  declare variable min_departure date;
  declare variable max_arrival date;
  declare variable share_err_text varchar(255);
begin
  VIRTUAL_ROOM = null;
  select min(r.ID_HOTEL), count(distinct r.ID_HOTEL),
         min(r.TO_DATE), max(r.FROM_DATE)
  from   RESERV_DETAIL R
  where  R.SELECTION_ID = :SELECTION_ID
  into   :id_hotel, :cnt_hotels, :min_departure, :max_arrival;

  if (:cnt_hotels > 1) then exception BOOKING_EXCEPTION '-1035';
  if (:min_departure <= :max_arrival) then exception BOOKING_EXCEPTION '-1037';

  if (:ROOM_NAME is not null) then begin
    execute procedure ROOM_GET_BY_NAME(:ROOM_NAME, :id_hotel)
    returning_values (:id_room);
    shared_id_room = :ID_ROOM;
  end else begin
    id_room = null;
    shared_id_room = gen_id(DETAIL_WITHOUT_ROOMING_LIST, -1);
    VIRTUAL_ROOM = gen_id(GEN_VIRTUAL_ROOM, 1);
  end

  res_counter = 0;
  for
    select r.RDB$DB_KEY, r.IS_ANUL, r.ID_ROOM
    from   RESERV_DETAIL R
    where  R.SELECTION_ID = :SELECTION_ID
    into   :r_dbkey, :is_anul, :current_id_room
  do begin
    res_counter = :res_counter + 1;
    if (:is_anul = 1) then
      exception BOOKING_EXCEPTION '-1036';

    if (:current_id_room > 0 and :ID_ROOM is null) then
      exception BOOKING_EXCEPTION '-1034';

    execute procedure RES_SET_ROOM$INT(:r_dbkey, :shared_id_room, 'nrttAsIs')
    returning_values  :tmp_warn_code, :share_trans, :share_err_code, :share_err_text;
    WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
  end

  if (:VIRTUAL_ROOM is not null and :share_trans is not null) then begin
    update RESERV_DETAIL RD
    set    rd.VIRTUAL_ROOM = '<'||:VIRTUAL_ROOM||'>'
    where  rd.ID_ROOM = :shared_id_room;
  end
end
^

/* Alter (RES_SET_STAY$RSV) */
ALTER PROCEDURE RES_SET_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable is_late_departure integer;
  declare variable comming_kind integer;
begin
  select RD.COMMING_KIND, RD.LEAVING_KIND - 1, RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :comming_kind, :is_late_departure, :rd_dbkey;

  execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :departure_date, :is_late_departure, :comming_kind);

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 1)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

end
^

/* empty dependent procedure body */
/* Clear: RES_CHECKIN_MULTI$RSV for: RES_SPLIT$RSV */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT_MULTI$RSV for: RES_SPLIT$RSV */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SPLIT$RSV) */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
declare variable rd_dbkey_old char(8);
  declare variable rd_dbkey_new char(8);
  declare variable id_guest integer;
  declare variable warn_code integer;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;

  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable check_status integer;
  declare variable arrival_date date;
  declare variable departure_date date;
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable id_room_type integer;
  declare variable id_room integer;
  declare variable id_board integer;
  declare variable id_tariff integer;
  declare variable custom_price numeric(15,4);
  declare variable custom_currency char(3);
  declare variable voucher_num varchar(30);
  declare variable voucher_date date;
  declare variable voucher_text varchar(30);
  declare variable voucher2_num varchar(30);
  declare variable voucher2_date date;
  declare variable transfer_in_time time;
  declare variable transfer_in_note varchar(255);
  declare variable transfer_out_time time;
  declare variable transfer_out_note varchar(255);
  declare variable comming_kind integer;
  declare variable is_late_departure integer;
  declare variable is_vip integer;
  declare variable country_code varchar(20);
  declare variable code_first_food tfood_code;
  declare variable i_special_treatment varchar(255);
  declare variable id_nom_market_segment integer;
  declare variable id_nom_source_code integer;
  declare variable id_nom_channel_code integer;
  declare variable id_nom_hear_reason integer;
  declare variable id_nom_come_reason integer;
  declare variable id_agent_account integer;
  declare variable acc_routing varchar(50);
  declare variable id_person_payment integer;
  declare variable id_agent_payment integer;
  declare variable room_features blob sub_type 1 segment size 80;
  declare variable id_hk_plan integer;
  declare variable id_group integer;
  declare variable id_hotel integer;
  declare variable note varchar(2000);
  declare variable note_reminders varchar(50);
  declare variable guarantee_deposit numeric(15,4);
  declare variable guarantee_currency char(3);
  declare variable id_titular integer;
  declare variable id_profile_data integer;
  declare variable id_acc_template_person integer;
  declare variable number_1 varchar(20);
  declare variable number_2 varchar(20);
  declare variable new_res_number varchar(62);
  declare variable g_dbkey char(8);
  declare variable is_child integer;
  declare variable id_guarantee_policy integer;
  declare variable block_cc varchar(255);
  declare variable virtual_room varchar(10);
  declare variable err_text varchar(255);
  declare variable is_posting_stopped integer;
  declare variable id_eating_object integer;
begin
  select RD.RDB$DB_KEY, RD.ID_AGENT_PROFILE, RD.CHECK_STATUS, RD.FROM_DATE, RD.TO_DATE,
         RD.ADULT_COUNT, RD.CHILD_COUNT, RD.ID_ROOM_TYPE, RD.ID_ROOM, RD.ID_BOARD, RD.ID_RATE,
         RD.CUSTOM_PRICE, RD.CUSTOM_CURRENCY, RD.VAUCHER_NUM, RD.VAUCHER_DATE, RD.VAUCHER_TEXT, RD.VAUCHER_NUM2,
         RD.VAUCHER_DATE2, RD.TRANSFER_IN_TIME, RD.TRANSFER_IN_NOTE, RD.TRANSFER_OUT_TIME, RD.TRANSFER_OUT_NOTE,
         RD.COMMING_KIND, RD.LEAVING_KIND - 1, RD.IS_VIP, RD.COUNTRY, RD.CODE_FIRST_FOOD, RD.I_SPECIAL_TREATMENT,
         RD.ID_NOM_MARKET_SEGMENT, RD.ID_NOM_SOURCE_CODE, RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_HEAR_REASON,
         RD.ID_NOM_COME_REASON, RD.ID_AGENT_ACCOUNT_RULE, RD.ACC_ROUTING, RD.ID_PERSON_PAYMENT, RD.ID_AGENT_PAYMENT,
         RD.ROOM_FEATURES, RD.ID_HK_PLAN, RD.ID_GROUP, RD.ID_HOTEL, RD.NOTE, RD.NOTE_REMINDERS,
         RD.GUARANTEE_DEPOSIT, RD.GUARANTEE_CURRENCY, RD.ID_ACC_TEMPLATE_PERSON,
         RD.NUMBER_1, rd.NUMBER_2, rd.ID_GUARANTEE_POLICY, rd.BLOCK_CC, rd.IS_POSTING_STOPPED, rd.ID_EATING_OBJECT
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail_source
  into   :rd_dbkey_old, :id_agent_profile, :check_status, :arrival_date, :departure_date,
         :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff,
         :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
         :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
         :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
         :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
         :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
         :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
         :guarantee_deposit, :guarantee_currency, :id_acc_template_person,
         :number_1, :number_2,:id_guarantee_policy, :block_cc, :is_posting_stopped, :id_eating_object;

  select first 1 sp.ITEM
  from   SYSTEM_STRING_PARSER(:guest_ids, ',') sp
  into   :id_titular;

  select min(g.FROM_DATE), max(g.TO_DATE)
  from   GUEST G
  where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL_SOURCE
         and ','||:GUEST_IDS||',' containing ','||g.ID_GUEST||','
  into   :arrival_date, :departure_date;

  if (exists (select *
              from   RESERV_DETAIL RD
              where  RD.ID_TITULAR = :id_titular
                     and RD.ID_RESERV_DETAIL = :id_reserv_detail_source))
  then exception BOOKING_EXCEPTION 'Titular can not be splited in new reservation';

  execute procedure RES_GET_PERSON_PROFILE$INT(:id_titular)
  returning_values  :id_person_profile, :id_profile_data;

  new_res_number = iif(coalesce(:number_1,'')='','.',:number_1||'.')
                   || coalesce(:number_2, '')
                   || '.0';  -- fictive suffix, needed for unique constraint limitation, that will be replaced with real one


  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, :check_status, :arrival_date, :departure_date,
                    0, 0, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
                    :guarantee_deposit, :guarantee_currency, 0, null, :new_res_number, :id_acc_template_person,
                    :id_guarantee_policy, :block_cc, :id_eating_object)
  returning_values  :rd_dbkey_new, :new_id_reserv_detail, :warn_code;

  execute procedure RES_NUMBER_SUFFIX_GEN (:NEW_ID_RESERV_DETAIL)
  returning_values  (:new_res_number);  -- add suffix to new (splited) booking number (empty on create)

  update RESERV_DETAIL NR
  set    nr.IS_POSTING_STOPPED = :is_posting_stopped
  where  nr.RDB$DB_KEY = :rd_dbkey_new;

  -- there is no need guests deleting, because new splited reservation is created with 0 guests
  adult_count = 0; child_count = 0;
  for
    select G.ID_GUEST, G.RDB$DB_KEY, G.IS_CHILD
    from   SYSTEM_STRING_PARSER(:guest_ids, ',') SP
           join GUEST G on G.ID_GUEST = SP.ITEM
    into   :id_guest, :g_dbkey, :is_child
  do begin
    execute procedure GUEST_SET_EDIT_STATUS$INT (:g_dbkey, 'REBUILD', 'add');

    update GUEST G
    set    G.ID_RESERV_DETAIL = :new_id_reserv_detail
    where  G.ID_GUEST = :id_guest;

    adult_count = :adult_count + (1-:is_child);
    child_count = :child_count + :is_child;

    if (:id_guest = :id_titular) then begin
      update RESERV_DETAIL RD
      set    RD.ID_TITULAR = :id_titular
      where  RD.RDB$DB_KEY = :rd_dbkey_new;

      update GUEST_DATA GD
      set    GD.ID_PERSON_DATA = :id_profile_data
      where  GD.ID_GUEST = :id_titular;
    end
  end

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL_SOURCE, 'RES_SPLIT',
          f_character(29) || :new_res_number || f_character(28) || :adult_count || ' + ' || :child_count);

  -- calling RES_SAVE_PROFILING$INT is unnecessary, it is called into RES_CREATE_SET$INT with same params
  -- here is needed to set reserv accounts per splited guests and reroute posting only (accomplished in next procedure)
  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey_new);

  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_old);
  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_new);

  update RESERV_DETAIL ORD
  set    ord.ROOM_PRICE = null
  where  ord.RDB$DB_KEY = :rd_dbkey_old;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_old, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_new, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  if (:id_room < 0) then begin
    virtual_room = gen_id(GEN_VIRTUAL_ROOM, 1);
    update RESERV_DETAIL RD
    set    rd.VIRTUAL_ROOM = '<'||:virtual_room||'>'
    where  rd.ID_ROOM = :id_room;
  end
end
^

/* Alter (RES_SPLIT_MULTI$RSV) */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
begin
  for
    select RD.ID_RESERV_DETAIL, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :id_reserv_detail, :id_titular
  do begin
    for
      select G.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.ID_GUEST <> :id_titular
      into   :id_guest
    do begin
      execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
      returning_values  :id_splited_reservation;

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_RECALC$INT for: RES_TAR_CALC_FINALIZE$INT */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_TAR_CALC_FINALIZE$INT) */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(TAR_CALC_ERR INTEGER,
ID_TAR_CALC INTEGER,
RD_DBKEY_INIT CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
begin
  --  Razpiswa cenata na staia, kakto i price_detailite.

  if (:tar_calc_err = 0) then begin
    room_price = 0;
    room_price_details = '';

    execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

    for
      select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, rd.IS_POSTING_STOPPED,
             coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
             coalesce(max((select first 1 AP.IS_BASE
                           from   GUEST G
                                  join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                           where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                  and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (eventually)
      from   TAR_CALC_INPUT$TMP TI
             join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
             join TARIFA t on t.ID_TARIFA = rd.ID_RATE
      where  ti.ID_TAR_CALC = :ID_TAR_CALC
      group by 1, 2, 3, 4, 5, 6
      into   :id_reserv_detail, :check_status, :is_posting_stopped,
             :room_currency, :id_hotel, :is_anul, :has_postings
    do begin
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);

      if ( (not (:is_posting_stopped = 1 and :has_postings = 0))                                -- posting is not stopped
           and                                                                                  -- and
           ( (coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1) ) -- there are reasons to repost
         ) then
      begin

        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);

      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;

        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end

      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end else begin

    update RESERV_DETAIL RD
    set    RD.ROOM_PRICE = null,
           RD.ROOM_CURRENCY = null,
           RD.ROOM_PRICE_DETAILS = null,
           RD.LAST_ID_TAR_CALC = null
    where  RD.RDB$DB_KEY = :RD_DBKEY_INIT;
  end
  
  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;
end
^

/* empty dependent procedure body */
/* Clear: RES_TAR_CALC_FINALIZE$INT for: RES_TAR_CALC_REPOST$INT */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(TAR_CALC_ERR INTEGER,
ID_TAR_CALC INTEGER,
RD_DBKEY_INIT CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_TAR_CALC_REPOST$INT) */
ALTER PROCEDURE RES_TAR_CALC_REPOST$INT(ID_TAR_CALC TYPE OF ID_REF,
ID_RESERV_DETAIL TYPE OF ID_REF,
RECALC_MARKER VARCHAR(40))
 AS
declare variable id_guest type of id_ref;
  declare variable id_service type of id_ref;
  declare variable id_tariff type of id_ref;
  declare variable date_post type of tdate;
  declare variable qty_post type of tqty;
  declare variable price_orig type of tprice;
  declare variable curr_orig type of tcurrency;
  declare variable id_room type of id_ref;
  declare variable is_base type of tlogical;
  declare variable short_code type of tdescription_long;
  declare variable id_account type of id_ref;
  declare variable gfrom_date type of tdate;
  declare variable gto_date type of tdate;
  declare variable ap_db_key char(8);
  declare variable id_pack_service type of id_ref;
  declare variable err_code type of id_ref;
  declare variable err_text type of tdescription_long;
  declare variable id_master_account_post type of id_ref;
  declare variable id_acc_post type of id_ref;
  declare variable rate_orig type of tprice;
  declare variable is_base_account type of id_ref;
  declare variable id_extra_account type of id_ref;
  declare variable no_use varchar(255);
begin
  for
    select   TCP.ID_GUEST, TCP.ID_SERVICE, TCP.ID_TARIFF, TCP.DATE_POST, TCP.QTY_POST,
             round_f(TCP.PRICE_ORIG, c.ROUND_TO), TCP.CURR_ORIG, TCP.ID_ROOM, TCP.IS_BASE,
             TCP.SHORT_CODE, iif(coalesce(AGP.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'NONE', 0, 1),
             G.ID_BASE_ACCOUNT, G.FROM_DATE, G.TO_DATE, G.ID_ACCOUNT
    from     TAR_CALC_POST$TMP TCP
             join GUEST G on G.ID_GUEST = TCP.ID_GUEST
             join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
             join SERVICES S on S.ID_SERVICE = TCP.ID_SERVICE
             join CURRS c on c.CURR = tcp.CURR_ORIG
             left outer join AGENT_PACKET AGP on AGP.ID_SERVICE = S.ID_SERVICE and AGP.ID_AGENT = G.ID_AGENT
    where    TCP.ID_TAR_CALC = :id_tar_calc
             and ((rd.ID_RESERV_DETAIL = :ID_RESERV_DETAIL)
                  or (coalesce(RD.IS_POSTING_STOPPED, 0) = 0 and RD.POSTING_TRANSACTION_UUID is not null))
    order by TCP.ID_GUEST asc, TCP.DATE_POST asc, TCP.IS_BASE desc
    into     :id_guest, :id_service, :id_tariff, :date_post, :qty_post,
             :price_orig, :curr_orig, :id_room, :is_base, :short_code, :is_base_account,
             :id_account, :gfrom_date, :gto_date, :id_extra_account
  do begin
    ap_db_key = null;
    if (:is_base = 1) then begin
      select AP.RDB$DB_KEY, AP.ID_MASTER_ADDINS_ACC_POST, AP.RATE_ORIG, AP.ID_PACK_SERVICE
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.DATE_POST = :date_post
             and AP.IS_BASE = 1
      into   :ap_db_key, :id_master_account_post, :rate_orig, :id_pack_service;

      execute procedure sys_dbg('tar TAR_CALC_REPOST$INT price_orig = '||coalesce(:price_orig, 'null'));
      execute procedure sys_dbg('tar TAR_CALC_REPOST$INT ap_db_key = '||coalesce(:ap_db_key, 'null'));

      if (:ap_db_key is null) then begin
        id_master_account_post = -1;
        rate_orig = null;
        execute procedure GUEST_POST_GET_PACK_SERVICE(:id_service, :id_guest, :date_post)
        returning_values  :id_pack_service;
      end
    end else begin
      short_code = '';
      select first 1 APU.rdb$db_key
      from   ACCOUNT_POST APU
      where  APU.ID_MASTER_ADDINS_ACC_POST = :id_master_account_post
             and APU.ID_SERVICE = :id_service
      order by apu.IS_ANUL asc, apu.ID_ACCOUNT_POST asc
      into   :ap_db_key;

      if ((:ap_db_key is null) and (:is_base_account <> 1)) then id_account = :id_extra_account;
    end

    if (:ap_db_key is null) then begin
      execute procedure ACCOUNT_POSTING_ADD$INT(
        :id_account, :id_guest, -1, :date_post, :id_service, :id_tariff, :id_room, :is_base, :qty_post,
        :price_orig, :curr_orig, :rate_orig, :short_code, :gfrom_date, :gto_date, 'PACK='||:id_pack_service, '',
        :recalc_marker, :id_master_account_post)
      returning_values  :err_code, :err_text, :id_acc_post;
      if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

      if (:is_base = 1) then id_master_account_post = :id_acc_post;

    end else begin
      execute procedure ACCOUNT_POSTING_UPDATE$INT(
        :ap_db_key, :id_service, :id_tariff, :id_room, :qty_post, 0, :price_orig, :curr_orig, :rate_orig,
        :recalc_marker, :short_code, :gfrom_date, :gto_date, 1, :id_account)
      returning_values  :no_use, :no_use, :no_use;
    end

  end

  ap_db_key = null;
  id_guest = null;
  for
    select distinct TCP.ID_GUEST
    from   TAR_CALC_POST$TMP TCP
    where  tcp.ID_TAR_CALC = :ID_TAR_CALC
    into   :id_guest
  do begin
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.CHANGED_TEXT is distinct from :recalc_marker
             and AP.ID_MASTER_ADDINS_ACC_POST > 0
             and AP.IS_ANUL = 0
      into   :ap_db_key
    do begin
      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_db_key, :recalc_marker);
    end
  end

  delete from RESERV_PREPOST RP where RP.ID_RESERV_DETAIL = :id_reserv_detail;
  execute procedure RES_TAKE_POSTING_RESPONSIBILITY (:ID_RESERV_DETAIL);
end
^

/* Alter (RES_TRANSFER_FINALIZE$RSV) */
ALTER PROCEDURE RES_TRANSFER_FINALIZE$RSV(ID_RESERV_DETAIL_NEW INTEGER,
ID_RESERV_DETAIL_OLD INTEGER)
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
begin
  execute procedure RES_ANUL_DETAIL$RSV(:id_reserv_detail_old, 'TRANSFER')
  returning_values  :WARN_CODE, :EXTRA_POSTS_LEFT;
end
^

/* Alter (RESERVS_EXPIRE$INT) */
ALTER PROCEDURE RESERVS_EXPIRE$INT(CLEAR_TODATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable day_keep_number integer;
  declare variable rd_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable nouse integer;
  declare variable day_keep_types integer;
begin
  /*AA NA IONEA I?AAE I?EEE??AAIA -BF END WORK-*/
  execute procedure SETTING_GET_VALUE('DAY_KEEP_NUMBERS', :ID_HOTEL)
  returning_values  :day_keep_number;
  /*************************************************************/
  /*    REMOVE ROOM NUMBERS FROM EXPIRED RESERV DETAILS        */
  /*************************************************************/
  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.IS_ANUL = 0
           and RD.CHECK_STATUS < 0
           and RD.IS_VIP = 0
           and RD.ID_ROOM > 0
           and (RD.FROM_DATE <=  cast(:clear_todate - :day_keep_number as date))
    into   :rd_dbkey, :id_reserv_detail
  do begin
    execute procedure RES_ROOM_REMOVE$INT(:rd_dbkey)
    returning_values  :nouse;

    when any do begin
      -- nothing
    end
  end
  /*************************************************************/
  /*    EXPIRED NON VIP or VIP TYPES                           */
  /*************************************************************/
  execute procedure SETTING_GET_VALUE('DAY_KEEP_TYPES', :ID_HOTEL)
  returning_values  :day_keep_types;

  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.CHECK_STATUS < 0
           and RD.IS_ANUL = 0
           --and RD.EXP_DATE <= :clear_todate
           and RD.FROM_DATE <= cast(:clear_todate - :day_keep_types as date)
           and RD.IS_VIP = 0
    union
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.CHECK_STATUS < 0
           and RD.IS_ANUL = 0
           and RD.TO_DATE < :clear_todate
           and RD.IS_VIP = 1
    into   :rd_dbkey, :id_reserv_detail
  do begin
    execute procedure sys_dbg('res RESERVS_EXPIRE: id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

    execute procedure RES_ANUL_NOSHOW$INT(:rd_dbkey)
    returning_values  :nouse;

    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_NOSHOW', '');

    when any do begin
      -- nothing
    end
  end
end
^

/* Alter (RESGRP_GET_INFO$RSV) */
ALTER PROCEDURE RESGRP_GET_INFO$RSV(ID_INFO_GROUP INTEGER)
 RETURNS(AGENT_PROFILE_NAME VARCHAR(100),
ARRIVALS VARCHAR(255),
DEPARTURES VARCHAR(255),
ROOM_DATA VARCHAR(255),
ROOMS VARCHAR(255),
ID_ROOM INTEGER,
GUESTS VARCHAR(255),
PERSON_PROFILE_NAME VARCHAR(100),
RATES VARCHAR(255),
BOARDS VARCHAR(255),
PACKETS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY VARCHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
BALANCE VARCHAR(255),
OPEN_CHARGES INTEGER,
CHECK_STATUS VARCHAR(255),
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
NOTE VARCHAR(2000),
NOTE_GRP VARCHAR(255),
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
FIRST_ARRIVAL DATE,
FIRST_DEPARTURE DATE,
HOTELS VARCHAR(255),
ID_HOTEL INTEGER,
ACC_ROUTING VARCHAR(255),
RES_NUMBER VARCHAR(62))
 AS
declare variable arrival date;
  declare variable departure date;
  declare variable room varchar(10);
  declare variable type_room varchar(20);
  declare variable stay_length varchar(60);
  declare variable id_reserv_detail integer;
  declare variable no_use varchar(255);
  declare variable rd_adult_count integer;
  declare variable rd_child_count integer;
  declare variable is_group integer;
  declare variable current_arrival varchar(60);
  declare variable current_departure varchar(60);
  declare variable nights varchar(255);
  declare variable roomcount integer;
  declare variable adultcount integer;
  declare variable childrencount integer;
  declare variable groupname varchar(100);
  declare variable rd_check_status integer;
  declare variable is_anul_detail integer;
  declare variable reason_of_anul varchar(100);
  declare variable hotel_code varchar(10);
  declare variable current_acc_routing varchar(255);
begin
  arrivals = '';
  departures = '';
  rooms = '';
  nights = '';
  rates = '';
  hotels = '';
  roomcount = 0;
  adultcount = 0;
  childrencount = 0;
  check_status = '';
  acc_routing = '';
  arrival = null;
  first_arrival = null;
  first_departure = null;

  ATTENTION_STATUS = null;  -- OUT of use ?!
  NOTE_GRP = null;

  for
    select RD.FROM_DATE, RD.ADULT_COUNT, RD.CHILD_COUNT, R.ROOM_NAME, RT.TYPE_ROOM,
           cast(RD.TO_DATE - RD.FROM_DATE as integer), RD.CHECK_STATUS, PP.PROFILE_NAME,
           RD.ROOM_PRICE, RD.ROOM_CURRENCY, RD.ROOM_PRICE_DETAILS, RD.ID_RESERV_DETAIL,
           RD.TO_DATE, R.ID_ROOM, RD.IS_ANUL, RD.REASON_OF_ANUL, RD.NOTE, H.CODE,
           RD.NUMBER, RD.ACC_ROUTING,
           AP.PROFILE_NAME, RG.GROUP_NAME, RD.ID_HOTEL, iif(RD.ID_GROUP is not null, 1, 0)
    from   RESERV_GROUP RG
           join HOTEL H on H.ID_HOTEL = RG.ID_HOTEL
           left outer join RESERV_DETAIL RD on RG.ID_RESERV_GROUP = RD.ID_GROUP and RD.IS_ANUL = 0
           left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
           left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = coalesce(R.ID_ROOM_TYPE, RD.ID_ROOM_TYPE)
           left outer join PROFILE PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
           left outer join PROFILE AP on AP.ID_PROFILE = RD.ID_AGENT_PROFILE
    where  RG.ID_RESERV_GROUP = :id_info_group
    order by RD.FROM_DATE asc
    into   :arrival, :rd_adult_count, :rd_child_count, :room, :type_room,
           :stay_length, :rd_check_status, :person_profile_name,
           :room_price, :room_currency, :room_price_details, :id_reserv_detail,
           :departure, :id_room, :is_anul_detail, :reason_of_anul, :note, :hotel_code,
           :res_number, :current_acc_routing,
           :agent_profile_name, :groupname, :id_hotel, :is_group
  do begin
    if (:first_arrival is null) then first_arrival = :arrival;
    if (:first_departure is null) then first_departure = :departure;

    if (:arrival is not null) then begin
      if (extract(year from current_date) = extract(year from :arrival)) then
        current_arrival = formatDate(:arrival, 'D;dd.mm');
      else
        current_arrival = formatDate(:arrival, 'D;dd.mm.yy');
  
      if (:arrivals not containing :current_arrival) then begin
        nights = :stay_length;
        if (:arrivals = '') then arrivals = :current_arrival||' ('||:stay_length;
        else if (char_length(:arrivals) < 100) then arrivals = :arrivals||')  '||:current_arrival||' ('||:stay_length;
      end else begin
        if (:nights not containing :stay_length) then begin
          nights = :nights ||','||:stay_length;
          arrivals = :arrivals||','||:stay_length;
        end
      end
    end

    if (:departure is not null) then begin
      if (extract(year from current_date) = extract(year from :departure)) then
        current_departure = formatDate(:departure, 'D;dd.mm');
      else
        current_departure = formatDate(:departure, 'D;dd.mm.yy');
  
      if (:departures not containing :current_departure) then begin
        if (:departures = '') then departures = :current_departure;
        else if (char_length(:departures) < 100) then departures = :departures||'  '||:current_departure;
      end
    end

    if (:acc_routing not containing :current_acc_routing) then begin
      if (:acc_routing = '') then acc_routing = :current_acc_routing;
      else if (char_length(:acc_routing) < 100) then acc_routing = :acc_routing||'  '||:current_acc_routing;
    end

    if (:check_status not containing :rd_check_status) then begin
      if (:check_status = '') then check_status = :rd_check_status;
      else check_status = :check_status||', '||:rd_check_status;
    end

    if (:hotels not containing :hotel_code) then begin
      if (:hotels = '') then hotels = :hotel_code;
      else hotels = :hotels||','||:hotel_code;
    end

    if (:is_group is distinct from 1) then begin
      if (:room is null) then room_data = :type_room;
      else room_data = :room || ' / ' || :type_room;
    end

    if (:is_group = 1) then begin
      in_share = null;
      balance = '-';
      res_number = '';
    end else begin
      execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'RENDER', null)
      returning_values  :in_share, :no_use, :shares_preview;

      execute procedure RES_GET_BALLANCE$INT(:id_reserv_detail)
      returning_values  :balance, :no_use, :no_use, :open_charges, :no_use;
    end
    adultcount = :adultcount + :rd_adult_count;
    childrencount = :childrencount + :rd_child_count;
  end
  if (coalesce(:groupname, '') <> '') then agent_profile_name = coalesce(:agent_profile_name, ' ') || ' / ' || :groupname;
  if (:is_group = 1) then person_profile_name = '';
  if (:arrivals <> '') then arrivals = :arrivals||')';
  guests = :adultcount || ' + ' || :childrencount || ' ';

  if (:arrivals <> '') then begin
    if (:is_group = 1) then begin
      note = '';
      room_data = '';
      for
        select RT.TYPE_ROOM, count(*)
        from   RESERV_DETAIL RD
               left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
               join ROOM_TYPES RT on RT.ID_ROOM_TYPE = coalesce(R.ID_ROOM_TYPE, RD.ID_ROOM_TYPE)
        where  RD.ID_GROUP = :id_info_group
               and RD.IS_ANUL = 0
        group by 1
        into   :type_room, :roomcount
      do begin
        if (:room_data = '') then room_data = :roomcount ||'x '||:type_room;
        else room_data = room_data ||', '|| :roomcount ||'x '||:type_room;
      end
    end
/*
    execute procedure RES_GET_ATTENTION_STATUS$INT(:arrival, :departure, :rd_check_status)
    returning_values  :attention_status;
*/
    execute procedure RES_GET_GUEST_DATA$INT('GROUP', :id_info_group)
    returning_values  :boards, :rates, :packets, :no_use;
  
    annul_status = :is_anul_detail;
    if (:reason_of_anul = 'EXPIRE') then annul_status = 2;
  end

  if (char_length(:arrivals) >= 100) then arrivals = :arrivals||'...';
  if (char_length(:departures) >= 100) then departures = :departures||'...';
  suspend;
end
^

/* Alter (RESMULTI_COMMON_MODIFY$RSV) */
ALTER PROCEDURE RESMULTI_COMMON_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
CHECK_STATUS SMALLINT,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
NOTE VARCHAR(255),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(30),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
NOTE_REMINDERS VARCHAR(50),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(WARN_CODE TYPE OF TRANGE)
 AS
declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable old_id_room_type integer;
  declare variable old_status integer;
begin
  select RD.RDB$DB_KEY, RD.ID_ROOM, RD.ID_ROOM_TYPE, rd.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_id_room, :old_id_room_type, :old_status;

  execute procedure RES_SAVE_GUESTCOUNT$INT(:rd_dbkey, :adult_count, :children_count);

  execute procedure RES_SAVE_NOTE$RSV(:id_reserv_detail, :note, null);

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, :id_room_type, 'nrttAsIs')
  returning_values (:WARN_CODE);

  execute procedure RES_SAVE_ROOM_LOG$INT(:rd_dbkey, :old_id_room, :old_id_room_type);

  execute procedure RES_SAVE_ACCOUNTING$INT(:rd_dbkey, :id_agent_profile, :id_agent_account, :acc_routing,
                    :id_person_payment, :id_agent_payment, :id_group);

  update RESERV_DETAIL RD
  set    RD.CUSTOM_PRICE = :CUSTOM_PRICE,
         RD.CUSTOM_CURRENCY = :CUSTOM_CURRENCY,
         RD.SPLIT_ON_CHECKIN = :SPLIT_ON_CHECKIN,
         RD.NOTE_REMINDERS = :NOTE_REMINDERS,
         rd.ID_HK_PLAN = :ID_HK_PLAN
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_status <> :CHECK_STATUS) then begin
    if (:CHECK_STATUS >= 0) then exception BOOKING_EXCEPTION 'Can not set status ''CHECKED IN'' or ''CHECKED OUT'' manually!';
  
    execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, :check_status);
  end
  --
end
^

/* Alter (RESMULTI_FINALIZE$RSV) */
ALTER PROCEDURE RESMULTI_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER,
DISABLE_WARNING SMALLINT)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  /*savedbg('------------ RES DET: ' || :ID_RESERV_DETAIL);
  savedbg('err_code: ' || :ERR_CODE);
  savedbg('share_err_code: ' || :SHARE_ERR_CODE);
  savedbg('warn_code: ' || :WARN_CODE);*/
  if (:disable_warning = 1) then warn_code = 0;
end
^

/* Alter (RESOURCE_RESERVATION_CHECK_IN) */
ALTER PROCEDURE RESOURCE_RESERVATION_CHECK_IN(ID_RESOURCE_RESERVATION INTEGER,
SERVICE_PRICE NUMERIC(15,2),
SERVICE_CURR VARCHAR(3))
 RETURNS(OUT_ID_ACCOUNT INTEGER,
OUT_ID_ACCOUNT_POST INTEGER)
 AS
declare variable old_status varchar(20);
  declare variable new_status varchar(20);
  declare variable dbkey char(8);
  declare variable id_service id_ref;
  declare variable price_post tprice;
  declare variable curr_post TCURRENCY;
  declare variable is_manual_price TLOGICAL;
  declare variable is_details tlogical;
  declare variable post_description tobject_text;
  declare variable id_reserv_detail integer;
  declare variable post_date tdate;
  declare variable from_datetime tdatetime;
  declare variable to_datetime tdatetime;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  new_status = 'CHECKED_IN';

  select r.RDB$DB_KEY, R.STATUS, rd.ID_RESERV_DETAIL
  from   RESOURCE_RESERVATION R
         left outer join RESERV_DETAIL rd on rd.NUMBER = r.BOOKING_NUMBER
                                             and rd.IS_ANUL = 0
                                             and rd.SUBSCRIBER_ID is not distinct from r.SUBSCRIBER_ID
  where  R.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION
  into   :dbkey, :old_status, :id_reserv_detail;

  if (:old_status = :NEW_STATUS) then exit;
 
  if (:old_status is distinct from 'RESERVED') then exception ASSERT '-511';

  if (exists (select RP.ID_RESOURCE_RESERVATION
              from   RESOURCE_RESERV_POST RP
                     join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = RP.ID_ACCOUNNT_POST
              where  RP.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION)) then
  begin
    exception ASSERT '-505';
  end

  if (:id_reserv_detail is not null) then begin
    execute procedure RESOURCE_RESERV_SERVICE_GET (:ID_RESOURCE_RESERVATION)
    returning_values (:id_service, :price_post, :curr_post, :is_manual_price, :is_details, :post_description,
                     :post_date, :from_datetime, :to_datetime);
  
    if (:is_manual_price = 1) then begin
      price_post = :SERVICE_PRICE;
      curr_post = :SERVICE_CURR;
    end

    if (:price_post is null) then exception ASSERT 'Unspecified service price!';
    if (:curr_post is null) then exception ASSERT 'Unspecified price currency!';
  
    execute procedure POST_SERVICE_ON_RESERVATION$INT (:id_reserv_detail, :id_service, 1, 0,
            1, :price_post, :curr_post, :from_datetime, :to_datetime,
            '', '', :post_date, 'RESOURCE', :post_description)
    returning_values (:ERR_CODE, :ERR_TEXT, :OUT_ID_ACCOUNT, :OUT_ID_ACCOUNT_POST);
    if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
  
    insert into RESOURCE_RESERV_POST(ID_RESOURCE_RESERVATION, ID_ACCOUNNT_POST)
    values (:ID_RESOURCE_RESERVATION, :OUT_ID_ACCOUNT_POST);
  end

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = :NEW_STATUS
  where  RR.RDB$DB_KEY = :dbkey;

end
^

/* empty dependent procedure body */
/* Clear: REVENUE_STATISTIC_REBUILD for: REVENUE_EW_SUMMARIZE$INT */
ALTER PROCEDURE REVENUE_STATISTIC_REBUILD(ID_HOTEL INTEGER,
TO_DATE DATE = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: REVENUE_STATISTIC_REMAKE$SYS for: REVENUE_EW_SUMMARIZE$INT */
ALTER PROCEDURE REVENUE_STATISTIC_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: REVENUE_SUMMARY_REMAKE$SYS for: REVENUE_EW_SUMMARIZE$INT */
ALTER PROCEDURE REVENUE_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
STATISTIC_ONLY SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SUMMARY_FINANCE_SAVE$INT for: REVENUE_EW_SUMMARIZE$INT */
ALTER PROCEDURE SUMMARY_FINANCE_SAVE$INT(ID_END_WORK INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (REVENUE_EW_SUMMARIZE$INT) */
ALTER PROCEDURE REVENUE_EW_SUMMARIZE$INT(ID_END_WORK INTEGER,
SUMMARY_OPTION VARCHAR(20) = 'full')
 AS
declare variable id_sale_taxation integer;
  declare variable id_profile integer;
  declare variable market_segment varchar(3);
  declare variable source_code varchar(3);
  declare variable channel_code varchar(3);
  declare variable hear_reason varchar(3);
  declare variable come_reason varchar(3) ;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable revenue_account varchar(50);
  declare variable revenue_sub_account varchar(50);
  declare variable revenue_group varchar(50);
  declare variable service_name varchar(80);
  declare variable rev_amount numeric(15,4);
  declare variable corr_amount numeric(15,4);
  declare variable total_rev_amount numeric(15,4);
  declare variable total_corr_amount numeric(15,4);
  declare variable total_vat_amount numeric(15,4);
  declare variable vat_amount numeric(15,4);
  declare variable country_code varchar(10);
  declare variable no_use varchar(255);
  declare variable id_summary_rev_group integer;
  declare variable is_primary_post integer;
  declare variable posts_cnt integer;
  declare variable id_hotel integer;
  declare variable id_room_type integer;
  declare variable ew_date date;
  declare variable round_to numeric(15,6);
  declare variable id_sale_tax integer;
  declare variable tax_value numeric(15,4);
  declare variable revenue_deduction_tax_value tprice;
begin
  /****************************************************************************/
  /*  Description:                                                            */
  /*  DATE_POST      occurence date                                           */
  /*  ARISE_DATE     noticed date                                             */
  /*  POST_TYPE      BASE, ADD_INS, EXTRA                                     */
  /****************************************************************************/
  /*  */
  TOTAL_REV_AMOUNT = 0;
  TOTAL_CORR_AMOUNT = 0;
  TOTAL_VAT_AMOUNT = 0;
  select EW.PREV_DATE, EW.ID_HOTEL, CU.ROUND_TO
  from   END_WORKS EW
         join HOTEL H on H.ID_HOTEL = EW.ID_HOTEL
         join CURRS CU on CU.CURR = H.NATION_CURR
  where  EW.ID_END_WORK = :ID_END_WORK
  into   :EW_DATE, :ID_HOTEL, :ROUND_TO;

  if (:SUMMARY_OPTION = 'full') then begin
    delete from SUMMARY_REV_GROUPS$REV SR
    where  SR.ID_END_WORK = :ID_END_WORK;

  end else if (:SUMMARY_OPTION = 'statistic') then begin
    /* delete from statistic tables */
    for
      select SR.ID_SUMMARY_REV_GROUP
      from   SUMMARY_REV_GROUPS$REV SR
      where  SR.ID_END_WORK = :ID_END_WORK
      into   :ID_SUMMARY_REV_GROUP
    do begin
      delete from SUMMARY_MARKET_SEGMENTS$REV SM
      where  SM.ID_SUMMARY_REV_GROUP = :ID_SUMMARY_REV_GROUP;

      delete from SUMMARY_PROFILES$REV SP
      where  SP.ID_SUMMARY_REVENUE_GROUP = :ID_SUMMARY_REV_GROUP;

      delete from SUMMARY_NATIONALITY$REV SN
      where  SN.ID_SUMMARY_REVENUE_GROUP = :ID_SUMMARY_REV_GROUP;
    end
  end

  for
    select  AP.ID_SALE_TAXATION, coalesce(PA.ID_PROFILE, PH.ID_PROFILE), coalesce(PD.COUNTRY_CODE, ''),
            MS.MARKET_CODE, SC.SOURCE_CODE, CC.CHANNEL_CODE, HR.HEAR_REASON_CODE, CR.COME_REASON_CODE,
            AP.REVENUE_GROUP, AP.REVENUE_ACCOUNT, AP.REVENUE_SUB_ACCOUNT, S.SERVICE_NAME || coalesce(' / ' || APO.DESCRIPTION, '') as SERVICE_NAME,
            AP.IS_PRIMARY_POST, coalesce(rm.ID_ROOM_TYPE, r.ID_ROOM_TYPE),
            coalesce(sum(AP.NAT_NET_VALUE), 0), coalesce(sum(AP.NAT_GROSS_VALUE), 0), coalesce(sum(ap.REVENUE_DEDUCTION_TAX_VALUE), 0)
    from    ACCOUNT_DEBT AP
            join SERVICES S on S.ID_SERVICE = AP.ID_SERVICE
            left outer join ACCOUNT_POST APO on APO.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
            left outer join ACCOUNT ACC on ACC.ID_ACCOUNT = AP.ID_ACCOUNT
            left outer join GUEST G on G.ID_GUEST = AP.ID_GUEST
            left outer join GUEST_DATA GD on G.ID_GUEST = GD.ID_GUEST
            left outer join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = coalesce(G.ID_RESERV_DETAIL, ACC.ID_RESERV_DETAIL)
            left outer join NOM_CHANNEL_CODES CC on CC.ID_NOM_CHANNEL_CODE = GD.ID_NOM_CHANNEL_CODE--RD.ID_NOM_CHANNEL_CODE
            left outer join NOM_COME_REASONS CR on CR.ID_NOM_COME_REASON = GD.ID_NOM_COME_REASON--RD.ID_NOM_COME_REASON
            left outer join NOM_HEAR_REASONS HR on HR.ID_NOM_HEAR_REASON = GD.ID_NOM_HEAR_REASON--RD.ID_NOM_HEAR_REASON
            left outer join NOM_SOURCE_CODES SC on SC.ID_NOM_SOURCE_CODE = GD.ID_NOM_SOURCE_CODE--RD.ID_NOM_SOURCE_CODE
            left outer join NOM_MARKET_SEGMENTS MS on MS.ID_NOM_MARKET_SEGMENT = GD.ID_NOM_MARKET_SEGMENT--RD.ID_NOM_MARKET_SEGMENT
            left outer join PROFILE_AGENT PA on PA.ID_PROFILE = iif(rd.ID_RESERV_DETAIL is not null, RD.ID_AGENT_PROFILE, ACC.ID_PROFILE) --coalesce(RD.ID_AGENT_PROFILE, A.ID_PROFILE)
            left outer join PROFILE_PERSON PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
            left outer join PERSON_DATA PD on PD.ID_PERSON_DATA = PP.ID_PERSON_DATA
            left outer join PROFILE_HOUSE PH on PH.ID_PROFILE = ACC.ID_PROFILE
            left outer join ROOMS R on rd.ID_ROOM = r.ID_ROOM
            left outer join ROOM_MAGIC RM on RM.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                             and rm.BUSY_DATE = ap.POST_DATE
    where   AP.ID_HOTEL = :id_hotel
            and AP.DEBT_DATE = :ew_date
    group by 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14 --, 15
    into   :id_sale_taxation, :id_profile, :country_code,
           :market_segment, :source_code, :channel_code, :hear_reason, :come_reason,
           :revenue_group, :revenue_account, :revenue_sub_account, :service_name,
           :is_primary_post, :id_room_type, :post_net_value, :post_gross_value, :revenue_deduction_tax_value
  do begin
    POSTS_CNT = 0; /* TODO - must be initialized!!!! */
    if (:SUMMARY_OPTION = 'full') then begin
      VAT_AMOUNT = :POST_GROSS_VALUE - :POST_NET_VALUE;
      execute procedure REVENUE_SUMMARY_MODIFY$INT (:id_end_work, :ew_date, :id_sale_taxation,
              :id_profile, :market_segment, :source_code, :channel_code, :hear_reason, :come_reason,
              :is_primary_post, :post_net_value, :vat_amount, :revenue_group, :revenue_account,
              :revenue_sub_account, :service_name, :country_code, :id_room_type,
              :revenue_deduction_tax_value, :posts_cnt)
      returning_values (:rev_amount, :corr_amount, :id_summary_rev_group, :no_use, :no_use, :no_use, :no_use, :no_use, :no_use);

      total_rev_amount = :total_rev_amount + :rev_amount;
      total_corr_amount = :total_corr_amount + :corr_amount;
      total_vat_amount = :total_vat_amount + :vat_amount;

    end else if (:SUMMARY_OPTION = 'statistic') then begin

      select first 1 RG.ID_SUMMARY_REV_GROUP
      from   SUMMARY_REV_GROUPS$REV RG
      where  RG.ID_END_WORK = :ID_END_WORK
             and RG.ID_SALE_TAXATION = :id_sale_taxation
             and RG.REVENUE_GROUP is not distinct from :REVENUE_GROUP
      into   :ID_SUMMARY_REV_GROUP;

      VAT_AMOUNT = :POST_GROSS_VALUE - :POST_NET_VALUE;
      execute procedure REVENUE_STATISTIC_UPDATE$INT (:id_summary_rev_group, :is_primary_post, :id_profile,
              :market_segment, :source_code, :channel_code, :hear_reason, :come_reason,
              :post_net_value, :vat_amount, :country_code, :id_room_type, :ew_date, :revenue_deduction_tax_value)
      returning_values (:no_use, :no_use, :no_use, :no_use, :no_use, :no_use);
    end
  end
  
  if (:SUMMARY_OPTION = 'full') then begin
    for
      select  AP.ID_SALE_TAXATION, AP.REVENUE_GROUP, TVD.ID_SALE_TAX, sum(TVD.TAX_VALUE)
      from    ACCOUNT_DEBT AP
              join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
              left outer join TAX_VALUE_DEDUCT(AP.NAT_GROSS_VALUE, :round_to, AP.ID_SALE_TAXATION, 1) TVD on 1=1
      where   A.ID_HOTEL = :id_hotel
              and AP.DEBT_DATE = :ew_date
      group by 1, 2, 3
      into    :id_sale_taxation, :revenue_group, :id_sale_tax, :tax_value
    do begin
      select SRG.ID_SUMMARY_REV_GROUP
      from   SUMMARY_REV_GROUPS$REV SRG
      where  SRG.ID_END_WORK = :id_end_work
             and SRG.REVENUE_GROUP = :revenue_group
             and SRG.ID_SALE_TAXATION = :id_sale_taxation
      into   :id_summary_rev_group;

      insert into SUMMARY_TAXES(ID_SUMMARY_REV_GROUP, ID_SALE_TAXES, VAT_AMOUNT)
      values (:id_summary_rev_group, :id_sale_tax, :tax_value);
    end

    update SUMMARY_END_WORK SE
    set    SE.REVENUE_AMOUNT = :TOTAL_REV_AMOUNT,
           SE.CORRECTION_AMOUNT = :TOTAL_CORR_AMOUNT,
           SE.VAT_AMOUNT = :TOTAL_VAT_AMOUNT
    where  SE.ID_END_WORK = :ID_END_WORK;
  end
end
^

/* Alter (REVENUE_STATISTIC_REBUILD) */
ALTER PROCEDURE REVENUE_STATISTIC_REBUILD(ID_HOTEL INTEGER,
TO_DATE DATE = null)
 AS
declare variable id_end_work integer;
  declare variable summary_date date;
begin
  if (:TO_DATE is null) then begin
    execute procedure SYSTEM_DATE_GET (:ID_HOTEL)
    returning_values :TO_DATE;
    TO_DATE = :TO_DATE - 1;
  end

  for
    select cast(d.FROM_TIMESTAMP as date)
    from   REVENUE_STATISTIC_REBUILD_DATES (:id_hotel, :to_date) SP
           left outer join SYSTEM_DIVIDE_PERIOD (SP.OUT_FROM_DATE, sp.OUT_TO_DATE, 'date') d on 1=1
    into   :summary_date
  do begin
    if (:summary_date is null) then exit;

    for
      select EW.ID_END_WORK
      from   END_WORKS EW
      where  EW.PREV_DATE = :summary_date
             and EW.NEXT_DATE > :summary_date
             and EW.END_WORK_KIND = '3'
             and EW.ID_HOTEL = :id_hotel
      into   :id_end_work
    do begin
      execute procedure REVENUE_EW_SUMMARIZE$INT (:id_end_work, 'statistic');
    end
  end 

  delete from RESERV_CHANGE_SP; -- delete save points after summary update;

end
^

/* Alter (REVENUE_STATISTIC_REMAKE$SYS) */
ALTER PROCEDURE REVENUE_STATISTIC_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
declare variable id_end_work integer;
begin
  if (not exists (select h.ID_HOTEL
                  from   HOTEL H
                  where  h.ID_HOTEL = :ID_HOTEL)) then exception WRONG_VALUE 'Non-existing hotel!';

  for
    select EW.ID_END_WORK
    from   SUMMARY_END_WORK EW
    where  ew.ID_HOTEL = :ID_HOTEL
           and ew.SUMMARY_DATE between :FROM_DATE and :TO_DATE
    order by ew.ID_END_WORK
    into   :id_end_work
  do begin
    execute procedure REVENUE_EW_SUMMARIZE$INT (:id_end_work, 'statistic');
  end

end
^

/* Alter (REVENUE_SUMMARY_DMY$RPT) */
ALTER PROCEDURE REVENUE_SUMMARY_DMY$RPT(TO_DATE TYPE OF TDATE,
ID_HOTEL TYPE OF ID,
COMPARE_DATE TYPE OF TDATE = null)
 RETURNS(PERIOD VARCHAR(30),
YEAR_OF_PER TYPE OF TRANGE,
ID_END_WORK TYPE OF ID,
ID_SUMMARY_REV_GROUP TYPE OF ID,
REVENUE_GROUP TYPE OF TOBJECT_NAME,
ID_SALE_TAXATION TYPE OF ID,
TOTAL_AMOUNT TYPE OF TPRICE,
REVENUE_AMOUNT TYPE OF TPRICE,
CORRECTION_AMOUNT TYPE OF TPRICE,
VAT_AMOUNT TYPE OF TPRICE,
REVENUE_DEDUCTION_TAX_AMOUNT TYPE OF TPRICE)
 AS
declare variable no_use varchar(255) ;
  declare variable y_from_date date;
begin

  for
    select cast(:TO_DATE as date)
    from   RDB$DATABASE d
    union all
    select cast(:COMPARE_DATE as date)
    from   RDB$DATABASE d2
    where  :COMPARE_DATE is not null

    into   :TO_DATE
  do begin
    y_from_date = :TO_DATE - extract(yearday from :TO_DATE);
    YEAR_OF_PER = extract(year from :TO_DATE);
    for
      select P.FROM_TIMESTAMP, P.OUT_PERIOD as period, S.ID_END_WORK,
             SRG.REVENUE_GROUP, SRG.ID_SALE_TAXATION, SRG.ID_SUMMARY_REV_GROUP,
             sum(SRG.REVENUE_AMOUNT), sum(SRG.CORRECTION_AMOUNT), sum(srg.VAT_AMOUNT),
             sum(srg.REVENUE_DEDUCTION_TAX_AMOUNT)
      from   SYSTEM_DIVIDE_PERIOD (:y_from_date, :TO_DATE, 'DMY') P
             left outer join SUMMARY_END_WORK S on S.ID_HOTEL = :ID_HOTEL
                                                   and s.SUMMARY_DATE between P.FROM_TIMESTAMP and P.TO_TIMESTAMP
             left outer join SUMMARY_REV_GROUPS$REV SRG on SRG.ID_END_WORK = S.ID_END_WORK
      where  srg.ID_SUMMARY_REV_GROUP is not null
      group by 1, 2, 3, 4, 5, 6
      order by 1 desc, 2 asc, 3 asc
      into   :no_use, :PERIOD, :ID_END_WORK,
             :REVENUE_GROUP, :ID_SALE_TAXATION, :ID_SUMMARY_REV_GROUP,
             :REVENUE_AMOUNT, :CORRECTION_AMOUNT, :VAT_AMOUNT, :REVENUE_DEDUCTION_TAX_AMOUNT
    do begin
      TOTAL_AMOUNT = :REVENUE_AMOUNT + :CORRECTION_AMOUNT;
      suspend;
    end
  end
end
^

/* Alter (REVENUE_SUMMARY_REMAKE$SYS) */
ALTER PROCEDURE REVENUE_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
STATISTIC_ONLY SMALLINT)
 AS
declare variable id_end_work integer;
declare variable ad_dbkey char(8);
declare variable id_service integer;
declare variable id_guest integer;
declare variable id_account integer;
declare variable revenue_group varchar(50);
declare variable revenue_account varchar(50);
declare variable revenue_sub_account varchar(50);
begin
  if (not exists (select h.ID_HOTEL
                  from   HOTEL H
                  where  h.ID_HOTEL = :ID_HOTEL)) then exception WRONG_VALUE 'Non-existing hotel!';

  if (:STATISTIC_ONLY = 1) then begin

    execute procedure REVENUE_STATISTIC_REMAKE$SYS (:ID_HOTEL, :FROM_DATE, :TO_DATE);

    execute procedure SYSTEM_LOG_ADD ('HOTEL', :id_hotel, 'REV_REGEN_PART',
                                      f_character(29) || formatdate(:from_date, 'D;dd/mm/yyyy') ||
                                      f_character(28) || formatdate(:to_date, 'D;dd/mm/yyyy'));
  end else begin
    for
      select ad.RDB$DB_KEY, ad.ID_SERVICE, ad.ID_GUEST, ad.ID_ACCOUNT
      from   ACCOUNT_DEBT AD
      where  AD.ID_HOTEL = :id_hotel
             and ad.DEBT_DATE between :FROM_DATE and :TO_DATE
      order by ad.DEBT_DATE asc, ad.ID_ACCOUNT_POST asc
      into   :ad_dbkey, :id_service, :id_guest, :id_account
    do begin
      select  S.REVENUE_GROUP, RA.REVENUE_ACCOUNT, RA.REVENUE_SUB_ACCOUNT
      from    ACCOUNT A
              left outer join SERVICES S on s.ID_SERVICE = :id_service
              left outer join GUEST G on G.ID_GUEST = :id_guest
              left outer join PROFILE_HOUSE PH on PH.ID_PROFILE = A.ID_PROFILE
              left outer join REVENUE_ACCOUNT_PARSE$INT (S.REVENUE_ACCOUNT, coalesce(G.ID_RESERV_DETAIL, A.ID_RESERV_DETAIL)) RA on 1=1
      where   a.ID_ACCOUNT = :id_account
              and PH.HOUSE_TYPE is distinct from 'hptComplimentary'
      into    :revenue_group, :revenue_account, :revenue_sub_account;
  
      update ACCOUNT_DEBT d
      set    d.REVENUE_GROUP = :revenue_group,
             d.REVENUE_ACCOUNT = :revenue_account,
             d.REVENUE_SUB_ACCOUNT = :revenue_sub_account
             -- TODO - revenue deduction tax recalc ???
      where  d.RDB$DB_KEY = :ad_dbkey;
    end
  
  
    for
      select se.ID_END_WORK
      from   SUMMARY_END_WORK SE
      where  se.ID_HOTEL = :ID_HOTEL
             and se.SUMMARY_DATE between :FROM_DATE and :TO_DATE
      order by se.ID_END_WORK
      into   :id_end_work
    do begin
  
      update SUMMARY_END_WORK s
      set    s.REVENUE_AMOUNT = 0,
             s.CORRECTION_AMOUNT = 0,
             s.VAT_AMOUNT = 0
      where  s.ID_END_WORK = :id_end_work;
  
      execute procedure REVENUE_EW_SUMMARIZE$INT (:id_end_work, 'full');
    end

    execute procedure SYSTEM_LOG_ADD ('HOTEL', :id_hotel, 'REV_REGEN_FULL',
                                      f_character(29) || formatdate(:from_date, 'D;dd/mm/yyyy') || f_character(28) ||
                                      formatdate(:to_date, 'D;dd/mm/yyyy'));
  end
end
^

/* Alter (RIGHTS_GROUP_USER_MODIFY) */
ALTER PROCEDURE RIGHTS_GROUP_USER_MODIFY(USER_NAME VARCHAR(30),
ID_RIGHT_GROUP INTEGER,
OPERATION VARCHAR(50))
 AS
declare variable right_group varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add,del');

  if (:USER_NAME = 'SYSDBA') then exit;

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS RG
  where  RG.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'add') then begin
    insert into RIGHTS_USER_GROUPS (USER_NAME, ID_RIGHT_GROUP)
    values (:user_name, :id_right_group);

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_ADDED',
            f_character(29) || :USER_NAME  || f_character(28) || :right_group);

  end else begin
    delete from RIGHTS_USER_GROUPS
    where USER_NAME = :user_name
          and ID_RIGHT_GROUP = :id_right_group;

    if (row_count > 0) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_REMOVED',
              f_character(29) || :USER_NAME || f_character(28) || :right_group);

  end

  when sqlcode -803 do begin
    /* ERR_TEXT = '       ! ' ;*/
    exit;
  end
end
^

/* Alter (ROOM_OWNER_MODIFY$PMS) */
ALTER PROCEDURE ROOM_OWNER_MODIFY$PMS(ID_ROOM_OWNER INTEGER,
ID_ROOM_CONTRACT INTEGER,
ID_OWNER INTEGER,
OWNERSHIP_PERCENT NUMERIC(15,4),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_OWNER INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_hotel integer;
  declare variable id_acc_template_pms integer;
  declare variable id_currency varchar(3);
  declare variable owner_name varchar(100);
  declare variable old_owner_name varchar(100);
  declare variable old_ownership_percent NUMERIC(15,4);
  declare variable old_id_room_contract integer;
  declare variable action_text varchar(255);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');
  new_id_room_owner = :id_room_owner;

  if ( (:operation in ('add', 'mod')) and (not exists ( select * from OWNER$PMS P where P.ID_OWNER = :ID_OWNER ) )) then begin
    exception PMS_EXCEPTION '-610';
    exit;
  end

  select RT.ID_HOTEL
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS RP on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
         join ROOMS R on RP.ID_ROOM = R.ID_ROOM
         join ROOM_TYPES RT on R.ID_ROOM_TYPE = RT.ID_ROOM_TYPE
  where  RC.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
  into   :id_hotel;

  if (:operation not in ('add')) then begin
    select coalesce(PR.PROFILE_NAME, ' '), RO.OWNERSHIP_PERCENT, RO.ID_ROOM_CONTRACT
    from ROOM_OWNER$PMS RO
      left outer join PROFILE PR ON PR.ID_PROFILE = RO.ID_OWNER
    where RO.ID_ROOM_OWNER = :ID_ROOM_OWNER
    into :old_owner_name, :old_ownership_percent, :old_id_room_contract;
  end

  select PRO.PROFILE_NAME
  from PROFILE PRO
    where PRO.ID_PROFILE = :ID_OWNER
  into :owner_name;

  if (:operation in ('add', 'mod')) then begin
    if (coalesce(:OWNERSHIP_PERCENT, 0) <= 0) then begin
      exception PMS_EXCEPTION '-611';
      exit;
    end
  end

  if (:operation = 'add') then begin
    if (coalesce(:ID_ROOM_OWNER, -1) < 0) then
         NEW_ID_ROOM_OWNER = gen_id(GEN_ROOM_OWNER$PMS_ID, 1);
    else NEW_ID_ROOM_OWNER = :ID_ROOM_OWNER;

    insert into ROOM_OWNER$PMS (ID_ROOM_OWNER, ID_ROOM_CONTRACT, ID_OWNER, OWNERSHIP_PERCENT)
    values (:NEW_ID_ROOM_OWNER, :ID_ROOM_CONTRACT, :ID_OWNER, :OWNERSHIP_PERCENT);

    action_text = f_character(29) || :owner_name || f_character(28) || formatfloat(:ownership_percent, '0.00');
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_OWNER_ADDED', :ACTION_TEXT);

    if (not exists ( select *
                     from   ACCOUNT A
                     where  A.IS_PMS_ACCOUNT = 1
                            and A.ID_HOTEL = :id_hotel
                            and A.ID_PROFILE = :ID_OWNER ))
    then begin
      select O.ID_ACC_TEMPLATE_PMS, O.ID_CURRENCY
      from   OWNER$PMS O
      where  O.ID_OWNER = :ID_OWNER
      into   :id_acc_template_pms, :id_currency;

      execute procedure ACCOUNT_CREATE_PMS$PMS(:ID_OWNER, :ID_ACC_TEMPLATE_PMS,
              :ID_CURRENCY, :ID_HOTEL)
      returning_values (:dbg);
    end

    when sqlcode -803 do begin
      exception PMS_EXCEPTION '-1057';
      exit;
    end

  end else if (:operation = 'mod') then begin
    if (not exists ( select *
                     from   ROOM_OWNER$PMS R
                     where  R.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
                            and R.ID_OWNER = :ID_OWNER ))
    then begin /* smenen e sobstwenik */
      if (not exists ( select *
                       from   ACCOUNT A
                       where  A.IS_PMS_ACCOUNT = 1
                              and A.ID_HOTEL = :id_hotel
                              and A.ID_PROFILE = :ID_OWNER ))
      then begin
        select O.ID_ACC_TEMPLATE_PMS, O.ID_CURRENCY
        from   OWNER$PMS O
        where  O.ID_OWNER = :ID_OWNER
        into   :id_acc_template_pms, :id_currency;
  
        execute procedure ACCOUNT_CREATE_PMS$PMS(:ID_OWNER, :ID_ACC_TEMPLATE_PMS,
                :ID_CURRENCY, :ID_HOTEL)
        returning_values (:dbg);
      end
    end

    update ROOM_OWNER$PMS
    set ID_OWNER = :ID_OWNER,
        OWNERSHIP_PERCENT = :OWNERSHIP_PERCENT
    where (ID_ROOM_OWNER = :ID_ROOM_OWNER);

    if ((:old_owner_name <> :owner_name) or (:old_ownership_percent <> :ownership_percent)) then begin
      action_text = f_character(29) || :old_owner_name || f_character(28) || formatfloat(:old_ownership_percent, '0.00') ||
                    f_character(28) || :owner_name || f_character(28) || formatfloat(:ownership_percent, '0.00');
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_OWNER_CHANGED', :ACTION_TEXT);
    end
  end else if (:operation = 'del') then begin
    action_text = f_character(29) || :old_owner_name || f_character(28) || formatfloat(:old_ownership_percent, '0.00');
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :OLD_ID_ROOM_CONTRACT, 'ROOM_OWNER_REMOVED', :ACTION_TEXT);

    delete from ROOM_OWNER$PMS
    where (ID_ROOM_OWNER = :ID_ROOM_OWNER);
  end
end
^

/* empty dependent procedure body */
/* Clear: OCCUPANCY_SHARES_COMPLETE$INT for: ROOM_SHARE$INT */
ALTER PROCEDURE OCCUPANCY_SHARES_COMPLETE$INT(ID_OCCUPANT INTEGER)
 RETURNS(NEW_SHARES_ARISE INTEGER,
SHARE_MARK_TRANSACTION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ROOM_SHARE$INT) */
ALTER PROCEDURE ROOM_SHARE$INT(RM_DBKEY CHAR(8),
ID_SHARE_TRANSACTION INTEGER)
 RETURNS(EXISTENT_SHARE SMALLINT)
 AS
declare variable id_room_magic integer;
  declare variable id_reserv_detail integer;
  declare variable rs_dbkey char(8);
  declare variable id_room integer;
  declare variable busy_date date;
  declare variable tmp_busy_group_type integer;
  declare variable tmp_day_action_int integer;
  declare variable id_agent integer;
  declare variable busy_type varchar(30);
begin

  select RM.ID_ROOM_MAGIC, RM.ID_RESERV_DETAIL, RM.ID_ROOM, RM.BUSY_DATE, RM.BUSY_GROUP_TYPE,
         RM.DAY_ACTION_INT, RM.ID_AGENT, RM.BUSY_TYPE
  from   ROOM_MAGIC RM
  where  RM.RDB$DB_KEY = :rm_dbkey
  into   :id_room_magic, :id_reserv_detail, :id_room, :busy_date, :tmp_busy_group_type,
         :tmp_day_action_int, :id_agent, :busy_type;

  rs_dbkey = null;
  select RS.RDB$DB_KEY
  from   ROOMS_SHARE RS
  where  RS.ID_ROOM_SHARE = :id_room_magic
  into   :rs_dbkey;

  if (:rs_dbkey is null) then begin
    insert into ROOMS_SHARE (ID_ROOM_SHARE, ID_RESERV_DETAIL, MARK_TRANSACTION,
           ID_ROOM, BUSY_DATE, IS_EX_SHARE, BUSY_GROUP_TYPE, DAY_ACTION_INT, ID_AGENT, BUSY_TYPE)
    values (:id_room_magic, :id_reserv_detail, :id_share_transaction,
           :id_room, :busy_date, 0, :tmp_busy_group_type, :tmp_day_action_int, :id_agent, :busy_type);
    EXISTENT_SHARE = 0;
  end else begin
    update ROOMS_SHARE RS
    set    RS.MARK_TRANSACTION = :id_share_transaction
    where  RS.RDB$DB_KEY = :rs_dbkey
           and RS.MARK_TRANSACTION is distinct from :id_share_transaction;

    EXISTENT_SHARE = iif(row_count = 0, 1, 0);
  end
end
^

/* empty dependent procedure body */
/* Clear: ROOM_SMART_LIST_FREE$INT for: ROOM_SMART_FILTER$INT */
ALTER PROCEDURE ROOM_SMART_LIST_FREE$INT(FROM_DATE DATE,
TO_DATE DATE,
REPORT_LEAVING VARCHAR(50),
SUPPRESS_PRIVATE SMALLINT = 1)
 RETURNS(ROOM_NAME VARCHAR(50),
DBEFORE INTEGER,
DAFTER INTEGER,
FREE_BASE INTEGER,
FREE_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
FEATURES BLOB)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_SMART_LIST_OOS$INT for: ROOM_SMART_FILTER$INT */
ALTER PROCEDURE ROOM_SMART_LIST_OOS$INT(FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ROOM_NAME VARCHAR(50),
DESCRIPTION VARCHAR(100),
PERIOD VARCHAR(100),
FREE_BASE INTEGER,
FREE_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
IS_CLEAN INTEGER,
FEATURES BLOB)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_SMART_LIST_SHARE$INT for: ROOM_SMART_FILTER$INT */
ALTER PROCEDURE ROOM_SMART_LIST_SHARE$INT(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(50),
SUPPRESS_PRIVATE SMALLINT = 1)
 RETURNS(ROOM_NAME VARCHAR(50),
DESCRIPTION VARCHAR(255),
PERIOD VARCHAR(255),
FREE_BASE INTEGER,
FREE_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
FEATURES BLOB)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ROOM_SMART_FILTER$INT) */
ALTER PROCEDURE ROOM_SMART_FILTER$INT(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(20),
RESTRICT_CLEANING INTEGER,
SUPPRESS_PRIVATE SMALLINT = 1)
 RETURNS(ROOM_NAME VARCHAR(50),
BEDS INTEGER,
EXTRA_BEDS INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
IS_CLEAN INTEGER,
FLOOR INTEGER,
CLEAN_TEXT VARCHAR(20),
FEATURES BLOB,
SYS_DATE DATE)
 AS
declare variable inactive_rooms_list varchar(5000);
  declare variable blocked_rooms_list varchar(5000);
  declare variable busy_rooms_list varchar(5000);
begin
  execute procedure sys_dbg('occ ROOM_SMART_FILTER$INT from_date = '||coalesce(:from_date, 'null'));
  execute procedure sys_dbg('occ ROOM_SMART_FILTER$INT to_date = '||coalesce(:to_date, 'null'));

  inactive_rooms_list  = 'x';
  blocked_rooms_list  = 'x';
  -- PREPARE EXCLUDING OF UNAVAILABLE ROOMS - PRIVATE USE, OR INACTIVE FOR THE PERIOD
  for
    select distinct R.ID_ROOM
    from   ROOM_PERIOD$PMS R
           join TMP_SMART_ROOMS TSR on TSR.ID_ROOM = R.ID_ROOM and TSR.ID_SESSION = current_connection
    where  R.FROM_DATE <= :to_date
           and R.TO_DATE >= :from_date
           and ((R.STATUS  = 'INACTIVE') or (:SUPPRESS_PRIVATE = 1 and R.STATUS = 'PRIVATE'))
    into   :id_room
  do inactive_rooms_list = :inactive_rooms_list || :id_room || 'x';

  execute procedure sys_dbg('occ ROOM_SMART_FILTER$INT unavailable blocked_rooms_list = '||coalesce(:blocked_rooms_list, 'null'));

  -- PREPARE EXCLUDING OF BLOCKED ROOMS
  for
    select distinct RM.ID_ROOM
    from   ROOM_MAGIC RM
           join TMP_SMART_ROOMS TSR on TSR.ID_ROOM = RM.ID_ROOM
                                       and TSR.ID_SESSION = current_connection
    where  RM.BUSY_DATE between :from_date and :to_date - 1
           and RM.BUSY_GROUP_TYPE IN (18, 20)
           and RM.DAY_ACTION not containing 'CHECK_OUT'
    into   :id_room
  do begin
    blocked_rooms_list = :blocked_rooms_list||:id_room||'x';
  end
  execute procedure sys_dbg('occ ROOM_SMART_FILTER$INT blocked blocked_rooms_list = '||coalesce(:blocked_rooms_list, 'null'));

  /*
  ||  PREPARE EXCLUDING OF NON CLEANED OR INSPECTED ROOMS
  ||  DEPENDING ON DB_SETTING AND FROM_DATE
  */
  if (:restrict_cleaning = '1') then begin
    for
      select R.ID_ROOM
      from   ROOMS R
             join TMP_SMART_ROOMS TSR on TSR.ID_ROOM = R.ID_ROOM and TSR.ID_SESSION = current_connection
      where  R.IS_CLEAN = 0
      into   :id_room
    do blocked_rooms_list = :blocked_rooms_list||:id_room||'x';
  end else if (:restrict_cleaning = '2') then begin
    for
      select R.ID_ROOM
      from   ROOMS R
             join TMP_SMART_ROOMS TSR on TSR.ID_ROOM = R.ID_ROOM and TSR.ID_SESSION = current_connection
      where  (R.IS_CLEAN = 0) or (R.IS_INSPECTED = 0)
      into   :id_room
    do blocked_rooms_list = :blocked_rooms_list||:id_room||'x';
  end
  execute procedure sys_dbg('occ ROOM_SMART_FILTER$INT dirty blocked_rooms_list = '||coalesce(:blocked_rooms_list, 'null'));

  /*
  ||  PREPARE EXCLUDING OF PARTIAL BUSY ROOMS
  ||  DEPENDING ON INPUT PARAM
  */
  busy_rooms_list = 'x';
  for
    select distinct RM.ID_ROOM
    from   ROOM_MAGIC RM
           join TMP_SMART_ROOMS TSR on TSR.ID_ROOM = RM.ID_ROOM and TSR.ID_SESSION = current_connection
    where  RM.BUSY_DATE between :from_date and :to_date - 1
           and RM.BUSY_GROUP_TYPE IN (1, 24) --RESERVATIONS AND CHECKINS
           and RM.ID_ROOM > 0
           and RM.DAY_ACTION not containing 'CHECK_OUT'
    into   :id_room
  do begin
    if (:busy_rooms_list not containing 'x'||:id_room||'x') then
      busy_rooms_list = :busy_rooms_list||:id_room||'x';
  end
  execute procedure sys_dbg('occ ROOM_SMART_FILTER$INT busy busy_rooms_list = '||coalesce(:busy_rooms_list, 'null'));
  /* GET THE REAL ROOMS ACCORDING TO THE GENERATED FILTER
  */
  if (:report_type = 'FREE') then begin
    blocked_rooms_list = :blocked_rooms_list||'x'||:busy_rooms_list||'x';
    for
      select R.ROOM_NAME, R.BEDS, R.EXTRA_BEDS, R.IS_CLEAN, RT.TYPE_ROOM, R.ID_ROOM,
             R.FLOOR, R.FEATURES, R.CLEAN_TEXT, H.SYSTEM_DATE
      from   (select P.ID_ROOM
              from   ROOM_EXIST_PERIOD P
              where  P.FROM_DATE <= :from_date
                     and P.TO_DATE >= :to_date) RP
             join ROOMS R on R.ID_ROOM = RP.iD_ROOM
             join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
             join HOTEL H on H.ID_HOTEL = RT.ID_HOTEL
             join TMP_SMART_ROOMS TSR on TSR.ID_ROOM = R.ID_ROOM and TSR.ID_SESSION = current_connection
      where  :blocked_rooms_list not containing 'x'||R.ID_ROOM||'x'
             and :inactive_rooms_list not containing 'x'||R.ID_ROOM||'x'
      into   :room_name, :beds, :extra_beds, :is_clean, :type_room, :id_room,
             :floor, :features, :clean_text, :sys_date
    do suspend;
  end else if (:report_type = 'SHARE') then begin
    for
      select R.ROOM_NAME, R.BEDS, R.EXTRA_BEDS, R.IS_CLEAN, RT.TYPE_ROOM, R.ID_ROOM,
             R.FLOOR, R.FEATURES, R.CLEAN_TEXT, H.SYSTEM_DATE
      from   (select P.ID_ROOM
              from   ROOM_EXIST_PERIOD P
              where  P.FROM_DATE <= :from_date
                     and P.TO_DATE >= :to_date) RP
             join ROOMS R on R.ID_ROOM = RP.iD_ROOM
             join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
             join HOTEL H on H.ID_HOTEL = RT.ID_HOTEL
             join TMP_SMART_ROOMS TSR on TSR.ID_ROOM = R.ID_ROOM and TSR.ID_SESSION = current_connection
      where  :busy_rooms_list containing 'x'||R.ID_ROOM||'x'
             and :blocked_rooms_list not containing 'x'||R.ID_ROOM||'x'
             and :inactive_rooms_list not containing 'x'||R.ID_ROOM||'x'
      into   :room_name, :beds, :extra_beds, :is_clean, :type_room, :id_room,
             :floor, :features, :clean_text, :sys_date
    do suspend;
  end else begin
    for
      select R.ROOM_NAME, R.BEDS, R.EXTRA_BEDS, R.IS_CLEAN, RT.TYPE_ROOM, R.ID_ROOM,
             R.FLOOR, R.FEATURES, R.CLEAN_TEXT, H.SYSTEM_DATE
      from   (select P.ID_ROOM
              from   ROOM_EXIST_PERIOD P
              where  P.FROM_DATE <= :from_date
                     and P.TO_DATE >= :to_date) RP
             join ROOMS R on R.ID_ROOM = RP.iD_ROOM
             join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
             join HOTEL H on H.ID_HOTEL = RT.ID_HOTEL
             join TMP_SMART_ROOMS TSR on TSR.ID_ROOM = R.ID_ROOM and TSR.ID_SESSION = current_connection
      where  :blocked_rooms_list containing 'x'||R.ID_ROOM||'x'
             and :inactive_rooms_list not containing 'x'||R.ID_ROOM||'x'
      into   :room_name, :beds, :extra_beds, :is_clean, :type_room, :id_room,
             :floor, :features, :clean_text, :sys_date
    do suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: ROOM_SMART_LIST$RSV for: ROOM_SMART_LIST_FREE$INT */
ALTER PROCEDURE ROOM_SMART_LIST$RSV(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(50))
 RETURNS(ROOM_NAME VARCHAR(50),
FREE_BEDS_BASE INTEGER,
FREE_BEDS_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
FEATURES BLOB,
BUSY_GROUP_TYPE INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
DATA1 VARCHAR(255),
DATA2 VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (ROOM_SMART_LIST_FREE$INT) */
ALTER PROCEDURE ROOM_SMART_LIST_FREE$INT(FROM_DATE DATE,
TO_DATE DATE,
REPORT_LEAVING VARCHAR(50),
SUPPRESS_PRIVATE SMALLINT = 1)
 RETURNS(ROOM_NAME VARCHAR(50),
DBEFORE INTEGER,
DAFTER INTEGER,
FREE_BASE INTEGER,
FREE_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
FEATURES BLOB)
 AS
declare variable magic_date date;
  declare variable sys_date date;
  declare variable dummy integer;
  declare variable beds integer;
  declare variable extra_beds integer;
begin
  for
    select SRLF.ROOM_NAME, SRLF.BEDS, SRLF.EXTRA_BEDS, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
           SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.CLEAN_TEXT, SRLF.SYS_DATE
    from   ROOM_SMART_FILTER$INT(:from_date, :to_date, 'FREE', 0, :SUPPRESS_PRIVATE) SRLF
    into   :room_name, :beds, :extra_beds, :is_clean, :type_room,
           :id_room, :floor, :features, :clean_text, :sys_date
  do begin
    atention = 0;
    execute procedure ROOM_SMART_OCCUP$INT(:id_room, :from_date, :to_date, 'AFTER')
    returning_values  :magic_date, :dummy;
    if ((:magic_date is null) or (:magic_date >= :to_date)) then begin
      -- THE ROOM IS EMPTY FOR THE PERIOD
      dafter = (:magic_date - :to_date);
      if (:dafter = 0) then atention = :atention+2;
      execute procedure ROOM_SMART_OCCUP$INT(:id_room, :from_date, :to_date/*ROGO old :sys_date*/, 'BEFORE')
      returning_values  :magic_date, :dummy;
      dbefore = (:from_date - :magic_date - 1);
      if ((:dbefore = 0) and (exists(
        select g.ID_GUEST
        from   GUEST G
               join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
        where  G.TO_DATE = :from_date
               and G.ID_ROOM = :id_room
               and G.CHECK_STATUS = 0
               and rd.IS_ANUL = 0
        ))) then begin
          atention = :atention+1;
          if (:report_leaving <> 'AS_FREE') then atention = 666;
        end
      free_base = :beds;
      free_extra = :extra_beds;
      if (:atention <> 666) then suspend;
    end/* else if (:fetch_partial_busy=1) then begin
      partial_busy = '!';
      dbefore = NULL;
      dafter  = NULL;
      execute procedure ROOM_SMART_OCCUP$INT(:id_room, :magic_date, :to_date, 'GUESTS')
      returning_values  :magic_date, :cnt_guests;
      if (:cnt_guests < (:beds+:extra_beds)) then begin
        if (:cnt_guests < :beds) then begin
          free_base = (:beds - :cnt_guests);
          free_extra = extra_beds;
        end else begin
          free_base = 0;
          free_extra = ((:beds+:extra_beds)-:cnt_guests);
        end
        suspend;
      end
    end   */
  end
end
^

/* Alter (ROOM_SMART_LIST_OOS$INT) */
ALTER PROCEDURE ROOM_SMART_LIST_OOS$INT(FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ROOM_NAME VARCHAR(50),
DESCRIPTION VARCHAR(100),
PERIOD VARCHAR(100),
FREE_BASE INTEGER,
FREE_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
IS_CLEAN INTEGER,
FEATURES BLOB)
 AS
declare variable id_reserv_detail integer;
  declare variable sys_date date;
  declare variable dummy integer;
  declare variable beds integer;
  declare variable extra_beds integer;
  declare variable guests_cnt integer;
begin
  if (:from_date >= :to_date) then exit;

  for
    select SRLF.ROOM_NAME, SRLF.BEDS, SRLF.EXTRA_BEDS, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
           SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.SYS_DATE
    from   ROOM_SMART_FILTER$INT(:from_date, :to_date, 'SHARE', 0, 1) SRLF
    into   :room_name, :beds, :extra_beds, :is_clean, :type_room,
           :id_room, :floor, :features, :sys_date
  do begin
    for
      select distinct RM.ID_RESERV_DETAIL
      from   ROOM_MAGIC RM
      where  RM.ID_ROOM = :id_room
             and RM.BUSY_DATE between :from_date and :to_date
             and RM.DAY_ACTION not containing 'CHECK_IN'
      into   :id_reserv_detail
    do begin
      select RGI.NUMBER ||', '|| RGI.PERSON_PROFILE_NAME ||', '||  RGI.AGENT_PROFILE_NAME,
             RGI.ARRIVALS ||' '|| RGI.DEPARTURES, RGI.GUESTS_CNT
      from   RES_GET_INFO$RSV(:id_reserv_detail, 0, 0, 0) RGI
      into   :description, :period, :guests_cnt;

      if (:guests_cnt < (:beds+:extra_beds)) then begin
        if (:guests_cnt < :beds) then begin
          free_base = (:beds - :guests_cnt);
          free_extra = extra_beds;
        end else begin
          free_base = 0;
          free_extra = ((:beds+:extra_beds)-:guests_cnt);
        end
        suspend;
      end
    end
  end
end
^

/* Alter (ROOM_SMART_LIST_SHARE$INT) */
ALTER PROCEDURE ROOM_SMART_LIST_SHARE$INT(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(50),
SUPPRESS_PRIVATE SMALLINT = 1)
 RETURNS(ROOM_NAME VARCHAR(50),
DESCRIPTION VARCHAR(255),
PERIOD VARCHAR(255),
FREE_BASE INTEGER,
FREE_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
FEATURES BLOB)
 AS
declare variable id_reserv_detail integer;
  declare variable beds integer;
  declare variable extra_beds integer;
  declare variable guests_cnt integer;
  declare variable busy_group_type integer;
  declare variable r_guests_cnt integer;
  declare variable r_description varchar(255);
  declare variable r_period varchar(255);
  declare variable min_day_action integer;
begin
  if (:from_date >= :to_date) then exit;
  report_type = iif(:report_type = 'POTENTIAL_SHARE', 'SHARE', 'BLOCKED');
  for
    select SRLF.ROOM_NAME, SRLF.BEDS, SRLF.EXTRA_BEDS, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
           SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.CLEAN_TEXT
    from   ROOM_SMART_FILTER$INT(:from_date, :to_date, :report_type, 0, :SUPPRESS_PRIVATE) SRLF
    into   :room_name, :beds, :extra_beds, :is_clean, :type_room,
           :id_room, :floor, :features, :clean_text
  do begin
    guests_cnt = 0;
    description = '';
    for
      select RM.ID_RESERV_DETAIL, RM.BUSY_GROUP_TYPE, min(RM.DAY_ACTION_INT)
      from   ROOM_MAGIC RM   --TODO order by arrival
      where  RM.ID_ROOM = :id_room
             and RM.BUSY_DATE between :from_date and :to_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
      group by 1, 2
      into   :id_reserv_detail, :busy_group_type, :min_day_action
    do begin
      if ((:busy_group_type in (1, 24)) or (:min_day_action > 0)) then begin
        select substring(RGI.NUMBER ||', '|| RGI.PERSON_PROFILE_NAME ||', '||  RGI.AGENT_PROFILE_NAME from 1 for 254),
               substring(RGI.ARRIVALS ||' '|| RGI.DEPARTURES from 1 for 254), RGI.GUESTS_CNT
        from   RES_GET_INFO$RSV(:id_reserv_detail, 0, 0, 0) RGI
        into   :r_description, :r_period, :r_guests_cnt;
      end else begin
        select iif(BR.BLOCK_GRP=18, 'OOO', 'OOI') ||', ' || substring(BR.REASON ||', '|| BR.NOTE from 1 for 254),
               substring(formatDate(BR.FROM_DATE, 'D;dd.mm')||' ('|| cast((BR.TO_DATE - BR.FROM_DATE) as integer) ||') '||formatDate(BR.TO_DATE, 'D;dd.mm') from 1 for 254)
        from   BLOCK_ROOM BR
        where  BR.ID_BLOCK_ROOM = :id_reserv_detail
        into   :r_description, :r_period;
        r_guests_cnt = 0;
      end
      if (:r_guests_cnt > :guests_cnt) then guests_cnt = :r_guests_cnt;

      if (:description <> '') then description = :description || F_CRLF();
      description = substring(:description || :r_description || ', ' || :r_period from 1 for 250);
    end
    if (:guests_cnt < (:beds+:extra_beds)) then begin
      if (:guests_cnt < :beds) then begin
        free_base = (:beds - :guests_cnt);
        free_extra = extra_beds;
      end else begin
        free_base = 0;
        free_extra = ((:beds+:extra_beds)-:guests_cnt);
      end
    end
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_MODIFY for: SAFE_OCCUPANCY_POSTING$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE /* TYPE OF ID */ INTEGER,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100))
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_NEW for: SAFE_OCCUPANCY_POSTING$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE /* TYPE OF ID */ INTEGER,
FROM_DATETIME /* TDATETIME */ TIMESTAMP,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100),
BOOKING_NUMBER /* TYPE OF TRES_NUMBER */ VARCHAR(62),
ID_EXTERNAL_CLIENT_ACCCOUNT /* TYPE OF ID_REF */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER,
ID_RESOURCE_RESERVATION /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SAFE_OCCUPANCY_POSTING$INT) */
ALTER PROCEDURE SAFE_OCCUPANCY_POSTING$INT(ID_RESOURCE_RESERVATION TYPE OF ID,
ID_SERVICE TYPE OF ID,
PRICE TYPE OF TPRICE,
CURRENCY TYPE OF TCURRENCY,
PRICE_DESCRIPTION TYPE OF TDESCRIPTION_SHORT,
ID_RESERV_DETAIL TYPE OF ID,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF = null)
 RETURNS(DOC_SELECTED TYPE OF TRANGE)
 AS
declare variable from_datetime timestamp;
  declare variable to_datetime timestamp;
  declare variable ap_dbkey TDB_KEY;
  declare variable id_account_post integer;
  declare variable safe_name TOBJECT_NAME;
  declare variable no_use varchar(255);
  declare variable new_ac varchar(2);
  declare variable err_code integer;
  declare variable err_text varchar(255) ;
  declare variable occupant_name tperson_name;
  declare variable id_room integer;
  declare variable id_tariff integer;
begin
  DOC_SELECTED = null;
  select od.FROM_DATETIME, od.TO_DATETIME, ap.RDB$DB_KEY, ap.ID_ACCOUNT_POST,
         s.SAFE_NAME, rr.OCCUPANT_NAME, ap.ID_ROOM, ap.ID_TARIFF
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join SAFES s on s.ID_SAFE = od.ID_RESOURCE
         left outer join RESOURCE_RESERV_POST rrp on rrp.ID_RESOURCE_RESERVATION = rr.ID_RESOURCE_RESERVATION
         left outer join ACCOUNT_POST ap on ap.ID_ACCOUNT_POST = rrp.ID_ACCOUNNT_POST
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :from_datetime, :to_datetime, :ap_dbkey, :id_account_post,
         :safe_name, :occupant_name, :id_room, :id_tariff;

  new_ac = null;
  if (:id_account_post is not null) then begin
    execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
            :id_tariff, :id_room, 1, 0, :price, :currency, null, null, 'RESOURCE', :from_datetime, :TO_DATETIME, 1)
    returning_values :no_use, :no_use, :new_ac;
  end else begin
    if (:id_reserv_detail is not null) then begin
      execute procedure POST_SERVICE_ON_RESERVATION$INT (:id_reserv_detail, :id_service, 1, 0,
              1, :price, :currency, :from_datetime, :to_datetime,
              '', '', cast(:from_datetime as date), 'RESOURCE', null)
      returning_values (:ERR_CODE, :ERR_TEXT, :no_use, :id_account_post);
      if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      new_ac = '00';
    end else if (:ID_EXTERNAL_CLIENT_ACCCOUNT is not null) then begin
      execute procedure POST_SERVICE_ON_ACCOUNT$INT (:ID_EXTERNAL_CLIENT_ACCCOUNT, :id_service,
              1, 0, 1, :price, :currency, :from_datetime, :TO_DATETIME, '', '',
              cast(:from_datetime as date), 'RESOURCE', null, null)
      returning_values (:err_code, :err_text, :id_account_post);
      if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      new_ac = '00';
    end
  end

  if (:new_ac is null) then
    exception ASSERT '-1067' || f_character(31) || f_character(29) || :safe_name || f_character(28) || :occupant_name;

  if (:new_ac = '00') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);
    update ACCOUNT_POST AP
    set    ap.DOC_SELECTED = :DOC_SELECTED
    where  ap.ID_ACCOUNT_POST = :id_account_post;
  end

  update or insert into ACCOUNT_POSTING_DET (ID_ACCOUNT_POST, POST_TEXT, QTY,
         FROM_DATETIME, TO_DATETIME, RESOURCE_TEXT, EXT_USER_ANUL)
  values (:id_account_post, :safe_name ||' / '||formatdate(:from_datetime, 'D;dd.mm.yy(hh:mm)')||' - '||formatdate(:to_datetime, 'D;dd.mm.yy(hh:mm)')||' / '
          ||substring(replace(:price_description, F_CRLF(), ';') from 1 for 100), 1, :from_datetime, :to_datetime, :safe_name, null);

  if (not exists (select rp.ID_ACCOUNNT_POST
                  from   RESOURCE_RESERV_POST rp
                  where  rp.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION
                         and rp.ID_ACCOUNNT_POST = :id_account_post)) then
  begin
    insert into RESOURCE_RESERV_POST (ID_RESOURCE_RESERVATION, ID_ACCOUNNT_POST)
    values (:id_resource_reservation, :id_account_post);
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_DEBT_FILL$INT for: SERVICE_POSTING_REVENUE$INT */
ALTER PROCEDURE ACCOUNT_DEBT_FILL$INT(ID_END_WORK INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTS_ON_DATE$RPT for: SERVICE_POSTING_REVENUE$INT */
ALTER PROCEDURE ACCOUNT_POSTS_ON_DATE$RPT(ID_HOTEL INTEGER,
TO_DATE DATE,
INCL_CORR SMALLINT,
INCL_POSTS SMALLINT,
IN_ID_ACCOUNT INTEGER = null)
 RETURNS(POST_ID INTEGER,
ID_ACCOUNT INTEGER,
ID_GUEST INTEGER,
ROOM_NAME VARCHAR(20),
ID_SERVICE INTEGER,
ARISE_DATE DATE,
DATE_POST DATE,
IS_PRIMARY_POST SMALLINT,
POST_TYPE VARCHAR(10),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,4),
POST_NET_VALUE NUMERIC(15,4),
POST_GROSS_VALUE NUMERIC(15,4),
RATE_POST NUMERIC(15,6),
CURR_POST VARCHAR(3),
DATETIME_POST TIMESTAMP,
USER_NAME VARCHAR(30),
POST_REASON VARCHAR(30),
ID_VAT_GROUP INTEGER,
ID_ACCOUNT_POST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SERVICE_POSTING_REVENUE$INT) */
ALTER PROCEDURE SERVICE_POSTING_REVENUE$INT(ID_END_WORK INTEGER)
 RETURNS(SEQUENCE_ID INTEGER,
POST_DBKEY CHAR(8),
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT INTEGER,
ID_SERVICE INTEGER,
ID_SALE_TAXATION INTEGER,
ID_GUEST INTEGER,
ROOM_NAME VARCHAR(10),
ARISE_DATE DATE,
DATE_POST DATE,
IS_PRIMARY_POST SMALLINT,
POST_TYPE VARCHAR(10),
QTY_POST NUMERIC(15,4),
PRICE_POST NUMERIC(15,4),
RATE_POST NUMERIC(15,6),
CURR_POST VARCHAR(3),
POST_NET_VALUE NUMERIC(15,4),
POST_GROSS_VALUE NUMERIC(15,4),
DATETIME_POST TIMESTAMP,
USER_NAME VARCHAR(30),
POST_REASON VARCHAR(30))
 AS
declare variable is_base integer;
  declare variable id_master_post integer;
  declare variable id_ew_arise integer;
  declare variable system_date date;
  declare variable id_base_doc integer;
  declare variable doc_net_diff numeric(15,4);
  declare variable doc_gross_diff numeric(15,4);
  declare variable round_to numeric(15,4);
begin
  system_date = null;
  room_name = null;

  select first 1 ew.PREV_DATE
  from   END_WORKS EW
  where  EW.ID_END_WORK = :id_end_work
         and EW.END_WORK_KIND = '3'
         and EW.PREV_DATE < EW.NEXT_DATE
  order by EW.PREV_DATE asc, EW.ID_END_WORK asc
  into   :system_date;

  for
    /* postings */
    select cast(1 as smallint), AP.RDB$DB_KEY, AP.ID_ACCOUNT_POST, ap.ID_ACCOUNT_POST,
           AP.ID_ACCOUNT, AP.ID_GUEST, AP.ROOM_NAME, AP.ID_END_WORK,
           AP.QTY_POST * (1-AP.IS_ANUL), AP.PRICE_POST, AP.RATE_POST, AP.CURR_POST,
           AP.DATE_POST, AP.ID_SERVICE, AP.IS_BASE, AP.ID_MASTER_ADDINS_ACC_POST,
           AP.POST_NET_VALUE, AP.POST_GROSS_VALUE,
           AP.POST_DATETIME, cast(AP.USER_NAME as varchar(30)) ,
           cast('' as varchar(30)) as POST_REASON, AP.ID_SALE_TAXATION, ap.ID_BASE_DOC
    from   ACCOUNT_POST AP
    where  AP.ID_END_WORK = :id_end_work
    union all
    /* corrections  */
    select 0, APC.RDB$DB_KEY, APC.ID_ACC_POST_CORRECT, APC.ID_ACCOUNT_POST,
           APC.ID_ACCOUNT, APC.ID_GUEST, AP.ROOM_NAME, AP.ID_END_WORK,
           iif(APC.IS_QTY_CORRECT = 0, APC.NEW_QTY, APC.NEW_QTY - APC.OLD_QTY) as QTY_POST,
           iif(APC.IS_QTY_CORRECT = 1, APC.NEW_PRICE, cast(APC.NEW_PRICE * APC.NEW_RATE_POST - APC.OLD_PRICE * APC.OLD_RATE_POST as double precision) / APC.NEW_RATE_POST) as PRICE_POST,
           apc.NEW_RATE_POST, apc.NEW_CURR_POST,
           apc.DATE_POST_ORIG, apc.ID_SERVICE, AP.IS_BASE, AP.ID_MASTER_ADDINS_ACC_POST,
           APC.NEW_POST_NET_VALUE - APC.OLD_POST_NET_VALUE, APC.NEW_POST_GROSS_VALUE - APC.OLD_POST_GROSS_VALUE,
           APC.DATETIME_CREATED, cast(APC.USER_CORRECT as varchar(30)),
           APC.REASON_OF_CORRECT, APC.ID_SALE_TAXATION, ap.ID_BASE_DOC
    from   ACCOUNT_POST_CORRECTION APC
           left join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = APC.ID_ACCOUNT_POST
    where  APC.ID_END_WORK = :ID_END_WORK
    into   :IS_PRIMARY_POST, :POST_DBKEY, :SEQUENCE_ID, :ID_ACCOUNT_POST,
           :ID_ACCOUNT, :ID_GUEST, :ROOM_NAME, :id_ew_arise,
           :QTY_POST, :PRICE_POST, :RATE_POST, :CURR_POST,
           :DATE_POST, :ID_SERVICE, :is_base, :id_master_post,
           :POST_NET_VALUE,  :POST_GROSS_VALUE,
           :DATETIME_POST, :USER_NAME, :POST_REASON, :ID_SALE_TAXATION, :id_base_doc
  do begin
    if (:IS_PRIMARY_POST = 1) then begin
      select first 1 APCC.ID_ACCOUNT, APCC.ID_SERVICE, APCC.ID_GUEST, APCC.ID_SALE_TAXATION,
             APCC.OLD_QTY, APCC.OLD_PRICE, APCC.OLD_RATE_POST, APCC.OLD_CURR_POST,
             APCC.OLD_POST_NET_VALUE, APCC.OLD_POST_GROSS_VALUE
      from   ACCOUNT_POST_CORRECTION APCC
      where  APCC.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
             and APCC.ID_END_WORK > :ID_END_WORK
      order by APCC.ID_END_WORK asc, APCC.ID_ACC_POST_CORRECT asc
      into   :ID_ACCOUNT, :ID_SERVICE, :ID_GUEST, :ID_SALE_TAXATION,
             :QTY_POST, :PRICE_POST, :RATE_POST, :CURR_POST,
             :POST_NET_VALUE, :POST_GROSS_VALUE;

      /* get round diffs from released documents for this posting */
      select sum(pv.NET_RATE_DIFF + pv.NET_ROUND_DIFF), sum(pv.GROSS_RATE_DIFF + pv.GROSS_ROUND_DIFF)
      from   DOC_LINE_POST_VALUES PV
             join DOC_LINE dl on dl.ID_DOC_LINE = pv.ID_DOC_LINE
             join DOC_HEAD D on D.ID_DOC = dl.ID_DOC_HEAD
      where  pv.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
             and d.DOC_DATE < :system_date
             and d.ID_BASE_DOC = :id_base_doc
      into   :doc_net_diff, :doc_gross_diff;

      POST_NET_VALUE = :POST_NET_VALUE + coalesce (:doc_net_diff, 0);
      POST_GROSS_VALUE = :POST_GROSS_VALUE + coalesce (:doc_gross_diff, 0);
    end

    if (:id_ew_arise = :id_end_work) then begin
      ARISE_DATE = mindate(:SYSTEM_DATE, :DATE_POST);
    end else begin
      select ewa.PREV_DATE
      from   END_WORKS ewa
      where  ewa.ID_END_WORK = :id_ew_arise
      into   :ARISE_DATE;
    end

    POST_TYPE = case when :is_base = 1 then 'BASE'
                     when :is_base = 0 and :id_master_post > 0 then 'ADD_INS'
                     else 'EXTRA'
                end;
                                                           
    select c.ROUND_TO
    from   CURRS c
    where  c.CURR = :CURR_POST
    into   :round_to;

    if (round_f(:QTY_POST * :PRICE_POST, :round_to/10) <> 0
        or (:POST_NET_VALUE <> 0)
        or (:POST_GROSS_VALUE <> 0)) then suspend;

  end
end
^

/* Alter (SPR_DOC_MATRIX) */
ALTER PROCEDURE SPR_DOC_MATRIX(FROM_DATE DATE,
TO_DATE DATE,
ID_CONTRAGENT INTEGER,
ID_TYPE_PAYMENT INTEGER,
ID_BASE_DOC_TYPE INTEGER,
SRV_GROUP_TAG VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(DOC_DATA VARCHAR(30),
IS_ANUL SMALLINT,
CONTRAGENT_NAME VARCHAR(100),
USER_NAME VARCHAR(50),
COL_NAME VARCHAR(30),
COL_VALUE NUMERIC(15,4),
COL_ORIG_VALUE NUMERIC(15,4),
SORT_ORDER SMALLINT)
 AS
declare variable id_doc integer;
  declare variable tmp_id_contragent integer;
  declare variable doc_num varchar(20);
  declare variable doc_date date;
  declare variable payment_allowed smallint;
  declare variable doc_rate numeric(15,6);
  declare variable value_corr_idx numeric(15,2);
  declare variable doc_value numeric(15,4);
  declare variable nontaxable_value numeric(15,4);
  declare variable taxable_value numeric(15,4);
  declare variable tax_value numeric(15,4);
  declare variable tax_name varchar(50);
begin
  /* GROUP_TAGs : 'SRV_ACC', 'SRV_GRP' */

  VALUE_CORR_IDX = 1;
  ID_CONTRAGENT = case when :ID_CONTRAGENT = -1 then null else :ID_CONTRAGENT end;
  ID_TYPE_PAYMENT = case when :ID_TYPE_PAYMENT = -1 then null else :ID_TYPE_PAYMENT end;
  ID_BASE_DOC_TYPE = case when :ID_BASE_DOC_TYPE = -1 then null else :ID_BASE_DOC_TYPE end;

  for
    select DH.ID_DOC, DH.USER_CREATED, DC.ID_CONTRAGENT, DH.DOC_NUM,
           DH.REAL_DOC_DATE, DH.DOC_RATE, DH.IS_ANNUL_FLAG, DH.VALUE_CORR_IDX,
           DH.DOC_VALUE_A
    from   DOCUMENT_RELEASE_S DH
           join DOC_CONTRAGENT DC on DC.ID_DOC_CONTRAGENT = DH.ID_DOC_CONTRAGENT
           join DOC_TYPE DT on DT.ID_DOC_TYPE = DH.ID_DOC_TYPE
           join ACCOUNT A on A.ID_ACCOUNT = DH.ID_ACCOUNT
    where  A.ID_HOTEL = :ID_HOTEL
           and DH.RPT_DOC_DATE between :FROM_DATE and :TO_DATE
           and DC.ID_CONTRAGENT is not distinct from coalesce(:ID_CONTRAGENT, DC.ID_CONTRAGENT)
           and DT.ID_DOC_TYPE is not distinct from coalesce(:ID_BASE_DOC_TYPE, DT.ID_DOC_TYPE)
    order by 1
    into   :id_doc, :user_name, :tmp_id_contragent, :doc_num,
           :doc_date, :doc_rate, :is_anul, :value_corr_idx, :doc_value
  do begin
    PAYMENT_ALLOWED = 0;
    if ((:ID_TYPE_PAYMENT is null)
        or (exists (select P.ID_PAYMENT_HEAD
                    from   DOCUMENT_PAYMENT P
                    where  P.ID_DOC_HEAD = :ID_DOC
                           and P.ID_PAYMENT_TYPE = :ID_TYPE_PAYMENT)) ) then
    begin
      PAYMENT_ALLOWED = 1;
    end

    if (:PAYMENT_ALLOWED = 1) then begin
      CONTRAGENT_NAME = null;
      select  C.CONTRAGENT_NAME
      from    CONTRAGENTS C
      where   C.ID_CONTRAGENT = :TMP_ID_CONTRAGENT
      into    :CONTRAGENT_NAME;
      CONTRAGENT_NAME = coalesce(:CONTRAGENT_NAME, '-');

      DOC_DATA = case when :is_anul = 1 then '*' else ' ' end
                 || f_padright(:doc_num, ' ', 10)
                 || ' / ' || formatdate(:doc_date, 'D;dd.mm.yyyy');

      for
        select   cast(case
                        when cast(:SRV_GROUP_TAG as varchar(20))  = 'SRV_ACC' then S.ACCOUNT_NAME
                        when cast(:SRV_GROUP_TAG as varchar(20)) = 'SRV_GRP' then SG.GROUP_NAME
                        else ''
                      end as varchar(30)),
                 sum(D.WOT_VAT * cast(:DOC_RATE as numeric(15,6)) * :VALUE_CORR_IDX), 100
        from     DOC_LINE D
                 join SERVICES S on D.ID_SERVICE = S.ID_SERVICE
                 join SERVICE_GROUPS SG on SG.ID_SERVICE_GROUP = S.ID_SERVICE_GROUP
        where    D.ID_DOC_HEAD = :ID_DOC     
                 and cast(:SRV_GROUP_TAG as varchar(20)) <> ''
        group by 1
        union all
        select   cast(PT.PAYMENT_TYPE as varchar(30)),
                 sum(PH.NAT_VALUE), 200
        from     DOCUMENT_PAYMENT PH
                 join PAYMENT_TYPE PT on PT.ID_PAYMENT_TYPE = PH.ID_PAYMENT_TYPE
        where    PH.ID_DOC_HEAD = :ID_DOC
                 and PH.REALIZE_DATE between :FROM_DATE and :TO_DATE
--                 and :is_anul = 0
        group by 1
        into     :COL_NAME, :COL_ORIG_VALUE, :SORT_ORDER
      do begin
        /********************/
        /*   FINAL MAKEUP   */  
        /********************/
        COL_NAME = substring(:COL_NAME from 1 for 11);
        COL_VALUE = :COL_ORIG_VALUE; --  * :VALUE_CORR_IDX;
        suspend;
      end
      /********************/  
      /*     SUMMARY      */  
      /********************/
      for
        select t.NONTAXABLE_VALUE, t.TAXABLE_VALUE, t.TAX_VALUE, t.TAX_NAME
        from   DOC_TAXES t
        where  t.ID_DOC_HEAD = :id_doc
        into   :nontaxable_value, :taxable_value, :tax_value, :tax_name
      do begin
        if (:nontaxable_value <> 0) then begin
          COL_NAME = '@nontaxable';
          COL_ORIG_VALUE = :nontaxable_value;
          COL_VALUE = :nontaxable_value * cast(:DOC_RATE as numeric(15,6)) * :VALUE_CORR_IDX;
          SORT_ORDER = 300;
          suspend;
        end
        if (:taxable_value <> 0) then begin
          COL_NAME = '@taxable';
          COL_ORIG_VALUE = :taxable_value;
          COL_VALUE = :taxable_value * cast(:DOC_RATE as numeric(15,6)) * :VALUE_CORR_IDX;
          SORT_ORDER = 301;
          suspend;
        end
        if (:tax_value <> 0) then begin
          COL_NAME = :tax_name;
          COL_ORIG_VALUE = :tax_value;
          COL_VALUE = :tax_value * cast(:DOC_RATE as numeric(15,6)) * :VALUE_CORR_IDX;
          SORT_ORDER = 302;
          suspend;
        end
      end
      COL_NAME = '@total';
      COL_ORIG_VALUE = :doc_value;
      COL_VALUE = :doc_value * cast(:DOC_RATE as numeric(15,6)) * :VALUE_CORR_IDX;
      SORT_ORDER = 303;
      suspend;
    end
  end
end
^

/* Alter (SUMMARY_FINANCE_SAVE$INT) */
ALTER PROCEDURE SUMMARY_FINANCE_SAVE$INT(ID_END_WORK INTEGER)
 AS
declare variable id_hotel integer;
  declare variable summary_date date;
begin
  select EW.ID_HOTEL, EW.PREV_DATE
  from   END_WORKS EW
  where  EW.ID_END_WORK = :ID_END_WORK
  into   :id_hotel, :summary_date;

  /* prepare postings */
  execute procedure ACCOUNT_POSTS_EW_MARK$INT (:ID_END_WORK);

  execute procedure ACCOUNT_DEBT_FILL$INT(:ID_END_WORK);

  insert into SUMMARY_END_WORK (ID_END_WORK, ID_HOTEL, SUMMARY_DATE,
         REVENUE_AMOUNT, CORRECTION_AMOUNT, DOC_TAXES_AMOUNT, VAT_AMOUNT,
         DISCOUNTS_AMOUNT, PAYMENT_AMOUNT, PAYMENT_TRANSACTIONS,
         FISCAL_PAY_AMOUNT, FISCAL_PAY_TRANSACTIONS, DEPOSIT_AMOUNT)
  values (:ID_END_WORK, :ID_HOTEL, :SUMMARY_DATE, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);

  execute procedure REVENUE_EW_SUMMARIZE$INT (:ID_END_WORK, 'full');

  execute procedure PAYMENTS_EW_SUMMARIZE$INT (:ID_END_WORK);

  /* update statistic revenue summary (sections by refenrenes) for previous affected dates */
  execute procedure REVENUE_STATISTIC_REBUILD (:id_hotel, :summary_date - 1);

end
^

/* empty dependent procedure body */
/* Clear: TAR_PRICES_SET_TAX_PERIOD for: TAR_CALC_APPLY_DISC$INT */
ALTER PROCEDURE TAR_PRICES_SET_TAX_PERIOD(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_SERVICE INTEGER,
SERVICE_TYPE VARCHAR(20),
PRICE NUMERIC(15,4),
PTEXT VARCHAR(20),
ID_TAR_INPUT INTEGER,
TARIFF_CURR CHAR(3),
DEDUCTION_DATE DATE,
DISC_TAG VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_APPLY_DISC$INT) */
ALTER PROCEDURE TAR_CALC_APPLY_DISC$INT(ID_TAR_CALC INTEGER,
ID_TAR_BO_PRICE INTEGER,
ID_BO_DISCOUNT INTEGER,
TARGET_VOUCHER_NUM VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
SERVICE_TYPE VARCHAR(20),
PRICE NUMERIC(15,4),
ID_SERVICE INTEGER,
ID_TAR_INPUT INTEGER,
DEDUCTION_DATE DATE)
 AS
declare variable price_type varchar(20);
  declare variable price_value varchar(2000);
  declare variable stay_value numeric(15, 4);
  declare variable no_use numeric(15, 4);
  declare variable rnd_method varchar(20);
  declare variable id_tar_input_detail integer;
  declare variable currency tcurrency;
  declare variable round_to numeric(15,4);
  declare variable check_round numeric(15,4);
begin
  err_code   = 0;
  check_round = 0.0001;
  select TBD.RND_METHOD
  from   TAR_BO_DISCOUNT_STAY TBD
  where  TBD.ID_TAR_DISCOUNT_STAY = :id_bo_discount
  into   :rnd_method;

  select TBP.PRICE_TYPE, TBP.PRICE_VALUE
  from   TAR_BO_PRICE_GET(:id_tar_bo_price) TBP
  into   :price_type, :price_value;
  for
    select TCO.ERR_CODE, TCO.ID_TAR_INPUT, TCO.ID_SERVICE_TAXABLE, TCO.SRS_SRV_TYPE,
           TCO.BASE_VALUE, tco.CURRENCY, TCO.DEDUCTION_DATE, TCO.ID_TAR_INPUT_DETAIL
    from   TAR_CALC_DISC_BASE$INT(:id_tar_calc, :id_bo_discount, :target_voucher_num) TCO
    into   :err_code, :id_tar_input, :id_service, :service_type,
           :stay_value, :currency, :deduction_date, :id_tar_input_detail
  do begin
    if (:err_code < 0) then begin suspend; exit; end

    if (:stay_value = 0) then begin
      -- do nothing
    end else begin
      execute procedure TAR_SET_VAR('base='||round_f(:stay_value, 0.00001), :id_tar_input_detail, :id_tar_calc);

      select c.ROUND_TO
      from   CURRS c
      where  c.CURR = :currency
      into   :round_to;

      execute procedure TAR_EVAL_PRICE(:price_type, :price_value, :stay_value, 0, :rnd_method, :round_to, :id_tar_input_detail)
      returning_values  :err_code, :price, :no_use;
      if (:err_code < 0) then begin suspend; exit; end

      if (round_f(:price, :check_round) <> 0) then suspend;
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_INPUT_RESERV$INT for: TAR_CALC_GET_GUESTS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_RESERV$INT(ID_RESERV_DETAIL INTEGER,
ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
ID_RATE_OVERRULE INTEGER = null)
 AS
 BEGIN EXIT; END
^

/* Alter (TAR_CALC_GET_GUESTS$INT) */
ALTER PROCEDURE TAR_CALC_GET_GUESTS$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_GUEST INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
G_DBKEY CHAR(8),
ID_GUEST_RESERV TYPE OF ID)
 AS
declare variable dbg varchar(2000);
declare variable share_status integer;
declare variable shared_reservations varchar(1024);
declare variable id_shared_detail integer;
declare variable unshared_reservations varchar(1024);
declare variable id_unshared_detail integer;
declare variable incremental_guest_list varchar(2000);
begin
  incremental_guest_list = ','; /*using for not suspend dublicated guests - otherwise calculations are wrong*/
  for
    select G.ID_GUEST, G.FROM_DATE, G.TO_DATE, G.RDB$DB_KEY, rd.ID_RESERV_DETAIL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  Rd.ID_RESERV_DETAIL = :id_reserv_detail
           and rd.IS_ANUL = 0
    into   :ID_GUEST, :FROM_DATE, :TO_DATE, :G_DBKEY, :ID_GUEST_RESERV
  do begin
    suspend;
    incremental_guest_list = :incremental_guest_list || :id_guest ||',';
  end

/*  execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'ENUM_SHARES', null)*/
  execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'FOR_RECALC', null)
  returning_values  :share_status, :shared_reservations, :dbg;
  execute procedure sys_dbg('calc TAR_CALC_GET_GUESTS$INT shared_reservations = '||coalesce(:shared_reservations, 'null'));

  if (:share_status = 1) then begin
    for
      select SP.ITEM
      from   SYSTEM_STRING_PARSER(:shared_reservations, ',') SP
      into   :id_shared_detail
    do begin
      for
        select G.ID_GUEST, G.FROM_DATE, G.TO_DATE, G.RDB$DB_KEY, G.ID_RESERV_DETAIL
        from   GUEST G
        where  G.ID_RESERV_DETAIL = :id_shared_detail
        into   :ID_GUEST, :FROM_DATE, :TO_DATE, :G_DBKEY, :ID_GUEST_RESERV
      do begin
        if (:incremental_guest_list not containing ','||:id_guest||',' ) then begin
          suspend;
          incremental_guest_list = :incremental_guest_list || :id_guest ||',';
        end
      end
    end
  end

  execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'ENUM_EX_SHARES', null)
  returning_values  :share_status, :unshared_reservations, :dbg;

  execute procedure sys_dbg('calc TAR_CALC_GET_GUESTS$INT unshared_reservations = '||coalesce(:unshared_reservations, 'null'));
  execute procedure sys_dbg('calc TAR_CALC_GET_GUESTS$INT incremental_guest_list = '||coalesce(:incremental_guest_list, 'null'));

  if (:unshared_reservations <> '') then begin
    for
      select SP.ITEM
      from   SYSTEM_STRING_PARSER(:unshared_reservations, ',') SP
      into   :id_unshared_detail
    do begin
      for
        select G.ID_GUEST, G.FROM_DATE, G.TO_DATE, G.RDB$DB_KEY, g.ID_RESERV_DETAIL
        from   GUEST G
        where  G.ID_RESERV_DETAIL = :id_unshared_detail
        into   :ID_GUEST, :FROM_DATE, :TO_DATE, :G_DBKEY, :ID_GUEST_RESERV
      do begin
        if (:incremental_guest_list not containing ','||:id_guest||',' ) then begin
          suspend;
          incremental_guest_list = :incremental_guest_list || :id_guest ||',';
        end
        execute procedure sys_dbg('calc TAR_CALC_GET_GUESTS$INT incremental_guest_list2 = '||coalesce(:incremental_guest_list, 'null'));
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_TEST$TAR for: TAR_CALC_INPUT_RESERV$INT */
ALTER PROCEDURE TAR_TEST$TAR(NUMBER VARCHAR(62),
ID_TAR_HEAD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_INPUT_RESERV$INT) */
ALTER PROCEDURE TAR_CALC_INPUT_RESERV$INT(ID_RESERV_DETAIL INTEGER,
ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
ID_RATE_OVERRULE INTEGER = null)
 AS
declare variable id_guest integer;
  declare variable g_dbkey char(8);
  declare variable from_date date;
  declare variable to_date  date;
  declare variable id_tariff_calc integer;
  declare variable err_code integer;
  declare variable err_text varchar(25);
  declare variable id_guest_reserv integer;
begin
  for
    select G.ID_GUEST, G.FROM_DATE, G.TO_DATE, G.G_DBKEY, g.ID_GUEST_RESERV
    from   TAR_CALC_GET_GUESTS$INT(:id_reserv_detail) G
    into   :id_guest, :from_date, :to_date, :g_dbkey, :id_guest_reserv
  do begin
    execute procedure sys_dbg('calc RES_RECALC$INT input guest_id '|| :id_guest || ', from:' || :from_date || ', to:' ||  :to_date);

    id_tariff_calc = null;
    if (:id_guest_reserv = :ID_RESERV_DETAIL and :ID_RATE_OVERRULE is not null) then id_tariff_calc = :ID_RATE_OVERRULE;
    -- skip ID_RATE_OVERRULE for shared bookings
    execute procedure TAR_CALC_INPUT_GUEST$INT(:id_tar_calc, :room_status, :g_dbkey, :id_tariff_calc, 1);
  end

  -- RECALCULATING DEPENDING ON THE TARIFF KIND
  execute procedure TAR_CALC_INPUT_DETAILS$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exception RATING_PREPARE_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
end
^

/* empty dependent procedure body */
/* Clear: PRODUCT_RATING$INT for: TAR_CALC_POST_PREPARE$INT */
ALTER PROCEDURE PRODUCT_RATING$INT(ID_HOTEL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
ADULT_AGES VARCHAR(100) = null,
CHILD_AGES VARCHAR(100) = null,
ID_TAR_CALC_COMMON INTEGER = null)
 RETURNS(ROOM_PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_POST_PREPARE$INT) */
ALTER PROCEDURE TAR_CALC_POST_PREPARE$INT(ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
  declare variable id_service integer;
  declare variable id_tariff integer;
  declare variable date_post date;
  declare variable qty_post integer;
  declare variable price_orig numeric(15,4);
  declare variable round_to numeric(15,4);
  declare variable curr_orig char(3);
  declare variable id_room integer;
  declare variable short_code varchar(255);
  declare variable id_reserv integer;
begin

  delete
  from   TAR_CALC_POST$TMP TCP
  where  TCP.ID_TAR_CALC = :id_tar_calc;

/* Find all Discounts with services : Move ID_DISCOUNT_SERVICE to ID_SERVICE; Change them to PACKETS - in order to receive separate postings */
  update  TAR_CALC_OUTPUT$TMP TCO
  set     tco.service_type = 'PACKETS',
          tco.id_service = tco.id_discount_service
  where   TCO.id_tar_calc = :id_tar_calc
          and tco.price_note = 'DISC'
          and tco.id_discount_service > 0;
    
  for
    select TOB.ID_GUEST, TOB.ID_RESERV, TOB.ID_SERVICE, TOB.ID_TARIFF, TOB.DATE_POST, TOB.QTY_POST,
           round_f(TOB.PRICE_ORIG, c.ROUND_TO), TOB.CURR_ORIG, TOB.ID_ROOM, TOB.SHORT_CODE, c.ROUND_TO
    from   TAR_OUTPUT_BASE(:id_tar_calc) TOB
           left outer join CURRS c on c.CURR = tob.CURR_ORIG
    into   :id_guest, :id_reserv, :id_service, :id_tariff, :date_post, :qty_post,
           :price_orig, :curr_orig, :id_room, :short_code, :round_to
  do begin
    insert into TAR_CALC_POST$TMP(ID_GUEST, ID_RESERV, ID_SERVICE, ID_TARIFF, DATE_POST, QTY_POST,
           PRICE_ORIG, CURR_ORIG, ID_ROOM, IS_BASE, ID_TAR_CALC, SHORT_CODE)
    values(:id_guest, :id_reserv, :id_service, :id_tariff, :date_post, :qty_post,
           :price_orig, :curr_orig, :id_room, 1, :id_tar_calc, :short_code);

    for
        select   TCO.ID_SERVICE,
                 max(TCO.QTY_POST), round_f(sum(TCO.PRICE_TARIFF), :round_to)
        from     TAR_CALC_OUTPUT$TMP TCO
                 join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCO.ID_TAR_INPUT
                 left outer join SERVICES S on S.ID_SERVICE = TCO.ID_SERVICE
        where    TCO.ID_TAR_CALC = :id_tar_calc
                 and TCO.SERVICE_TYPE = 'PACKETS'
                 and TCI.ID_GUEST = :id_guest
                 and TCO.FOR_DATE = :date_post
        group by 1
        into     :id_service, :qty_post, :price_orig
    do begin
      insert into TAR_CALC_POST$TMP(ID_GUEST, ID_RESERV, ID_SERVICE, ID_TARIFF, DATE_POST,
             QTY_POST, PRICE_ORIG, CURR_ORIG, ID_ROOM, IS_BASE, ID_TAR_CALC, SHORT_CODE)
      values(:id_guest, :id_reserv, :id_service, :id_tariff, :date_post, :qty_post,
             :price_orig, :curr_orig, :id_room, 0, :id_tar_calc, '');
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_EVAL_COMPLEX_RATE$INT for: TAR_MATCH_BOARD */
ALTER PROCEDURE TAR_CALC_EVAL_COMPLEX_RATE$INT(INPUT_DETAIL_DBKEY CHAR(8),
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
BEDS SMALLINT,
ID_TYPE_STAY INTEGER,
IS_MANUAL_TYPE_STAY SMALLINT,
ID_BOARD INTEGER,
ID_ROOM_TYPE INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
CHECKIN_DATE DATE,
DAY_OF_STAY INTEGER,
PAYORS INTEGER,
MINORS INTEGER,
PERIOD_DEPEND_ON_CHECKIN SMALLINT,
CNT_DAYS_BP INTEGER,
CNT_DAYS_BOARD INTEGER,
BOARD_TYPE_FIND VARCHAR(10),
TOTAL_GUESTS INTEGER,
SEQ_NUM INTEGER,
TARIFF_CURR CHAR(3),
REAL_RECALC SMALLINT)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_PAYORS INTEGER,
OUT_MINORS INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_MATCH_BOARD for: TAR_MATCH_BOARD */
ALTER PROCEDURE TAR_MATCH_BOARD(TID_DBKEY CHAR(8),
ID_TAR_BP INTEGER,
BOARD_TYPE_FIND VARCHAR(10),
ID_BOARD INTEGER,
ID_BOARD_INCLUDE INTEGER,
MATCH_DATE DATE,
BASE_PER_DAY NUMERIC(15,4),
DAY_OF_STAY INTEGER,
CNT_DAYS_BOARD INTEGER,
CNT_DAYS_BP INTEGER,
CUSTOM_PRICE NUMERIC(15,4))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SEPARATE_BOARD INTEGER,
SERVICE_TYPE VARCHAR(20),
BOARD_PRICE NUMERIC(15,4),
PTEXT VARCHAR(20),
ID_SERVICE INTEGER,
FOOD_PER_DAY NUMERIC(15,4),
PACKET_ITEM INTEGER,
DISC_TAG VARCHAR(50))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_MATCH_BOARD) */
ALTER PROCEDURE TAR_MATCH_BOARD(TID_DBKEY CHAR(8),
ID_TAR_BP INTEGER,
BOARD_TYPE_FIND VARCHAR(10),
ID_BOARD INTEGER,
ID_BOARD_INCLUDE INTEGER,
MATCH_DATE DATE,
BASE_PER_DAY NUMERIC(15,4),
DAY_OF_STAY INTEGER,
CNT_DAYS_BOARD INTEGER,
CNT_DAYS_BP INTEGER,
CUSTOM_PRICE NUMERIC(15,4))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SEPARATE_BOARD INTEGER,
SERVICE_TYPE VARCHAR(20),
BOARD_PRICE NUMERIC(15,4),
PTEXT VARCHAR(20),
ID_SERVICE INTEGER,
FOOD_PER_DAY NUMERIC(15,4),
PACKET_ITEM INTEGER,
DISC_TAG VARCHAR(50))
 AS
declare variable id_tar_head integer;
  declare variable id_tar_calc integer;
  declare variable ID_BO_BOARD integer;
  declare variable ID_TAR_BO_PRICE integer;
  declare variable param_filter varchar(2000);
  declare variable param_data varchar(2000);
  declare variable filter_result double precision;
  declare variable success integer;
  declare variable id_tar_board_tmp integer;
  declare variable board_name varchar(50);
  declare variable no_use numeric(15, 4);
  declare variable price_type varchar(20);
  declare variable is_board_in_bp integer;
  declare variable id_meal integer;
  declare variable delim integer;
  declare variable set_var varchar(255);
  declare variable rnd_method varchar(20);
  declare variable id_tar_input_detail integer;
  declare variable round_to numeric(15,4) ;
begin
  err_code = 0;
  err_text = '';
  id_tar_bo_price = -1;
  separate_board = 0;
  id_bo_board = -1;
  success = 0;
  packet_item = null;
  if (:id_board = 0) then exit;

  if (:board_type_find = 'HRANI') then begin
    for
      select BTF.ID_SERVICE
      from   BOARD_TO_FOODS(:id_board) BTF
      into   :id_meal
    do begin
      for
        select ERR_CODE, ERR_TEXT, SEPARATE_BOARD, SERVICE_TYPE, BOARD_PRICE,
               PTEXT, ID_SERVICE, FOOD_PER_DAY, DISC_TAG
        from   TAR_MATCH_BOARD(:tid_dbkey, :id_tar_bp, 'TO_HRANI',
                               :id_meal, :id_board_include, :match_date,
                               :base_per_day, :day_of_stay, :cnt_days_board, :cnt_days_bp, :custom_price)
        into   :err_code, :err_text, :separate_board, :service_type, :board_price,
               :ptext, :id_service, :food_per_day, :disc_tag
      do suspend;
    end
    exit;
  end

  for
    select   TBB.ID_TAR_BOARD, TRBP.PARAM_FILTER, TBB.ID_SERVICE, TBB.PACKET_ITEM, TBB.SET_VAR, TCI.ID_TAR_CALC,
             TCID.ID_TAR_HEAD, TCID.PARAM_VALUES, TBB.SEPARATE_BOARD, TBB.PTEXT, TBB.DISC_TAG, TBB.RND_METHOD,
             TCID.ID_TAR_INPUT_DETAIL
    from     TAR_CALC_INPUT_DETAIL$TMP TCID
             join  TAR_CALC_INPUT$TMP TCI
               on  TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
             join TAR_BO_BOARD TBB
               on  TBB.ID_TAR_HEAD = TCID.ID_TAR_HEAD
             join TAR_BO_RELATION TRBP
               on  TRBP.ID_BO = TBB.ID_TAR_BOARD
               and TRBP.BO_TYPE = 'BOARD'
    where    TCID.RDB$DB_KEY = :tid_dbkey
             and TBB.ID_BOARD is not distinct from :id_board
             and TRBP.ID_TAR_BP = :id_tar_bp
    into     :id_tar_board_tmp, :param_filter, :id_service, :packet_item, :set_var, :id_tar_calc,
             :id_tar_head, :param_data, :separate_board, :ptext, :disc_tag, :rnd_method,
             :id_tar_input_detail
  do begin
    execute procedure TAR_EVAL_FILTER(:param_filter, :param_data, :id_tar_input_detail)
    returning_values  :err_code, :filter_result;
    if (:err_code < 0) then begin suspend; exit; end
    if (:filter_result = 1) then begin
      id_bo_board = :id_tar_board_tmp;
      success = 1;
      break;
    end
  end
  execute procedure SETTING_GET_VALUE('RANGE_DATA_DELIMETER', null)
  returning_values  :delim;

  if (exists (select *
              from   TAR_HEAD TH
              where  TH.ID_TAR_HEAD = :id_tar_head
                     and f_character(:delim)||TH.BASE_BOARDS_LIST||f_character(:delim) containing f_character(:delim)||:id_board||f_character(:delim)))
  then begin
    service_type = 'BASE_BOARD';
    disc_tag = 'FB';
  end else begin
    service_type = 'EXTRA_BOARD';
    disc_tag = 'FE';
  end

  if (:success = 0) then begin
    if ((:board_type_find = 'BOARD') and (:id_board_include is distinct from :id_board)) then begin
      /* NOT FOUND BOARD */
      err_code = -234;
      select T.NAME
      from   MEALS T
      where  T.ID_BOARD = :id_board
      into   :board_name;
      err_text = 'BOARD='||coalesce(:board_name, '<null>');
      suspend;
      exit;
    end else if (:board_type_find = 'TO_HRANI') then begin
      if (not exists(
        select *
        from   BOARD_TO_FOODS(:id_board_include) BTF
        where  BTF.ID_SERVICE = :id_board
      )) then begin
        err_code = -234;
        select T.NAME
        from   MEALS T
        where  T.ID_BOARD = :id_board
        into   :board_name;
        err_text = 'BOARD='||coalesce(:board_name, '<null>');
        suspend;
        exit;
      end
    end
    /* ONLY IF THE BOARD IN THE BASE POSITION FULLY SATISFIES THE BOARD LOOKUP
    || OR IT IS PART OF THE LOOKING BOARD
    */
    update TAR_CALC_INPUT_DETAIL$TMP TID
    set    TID.ID_BOARD_INCLUDE = :id_board_include
    where  TID.RDB$DB_KEY = :tid_dbkey;

    exit;
  end

  if (:id_bo_board <> -1) then begin
    execute procedure TAR_SET_VAR(:set_var, :id_tar_input_detail, :id_tar_calc);
    --
    execute procedure TAR_MATCH_PRICE(:id_tar_head, :id_bo_board, 'BOARD', :match_date)
    returning_values  :err_code, :err_text, :id_tar_bo_price;
    if (:err_code < 0) then begin suspend; exit; end
    /* FIRST WE HAVE TO DECIDE WEATHER THE BOARD IS IN THE BASE PRICE */
    if (:custom_price is not null) then is_board_in_bp = 1;
    else if (:board_type_find = 'TO_HRANI') then begin
      if (exists (
        select *
        from   BOARD_TO_FOODS(:id_board_include) BTF
        where  BTF.ID_SERVICE = :id_board))
      then is_board_in_bp = 1;
      else is_board_in_bp = 0;
    end else begin
      if (:id_board_include = :id_board) then is_board_in_bp = 1;
      else is_board_in_bp = 0;
    end

    select TP.PRICE_VALUE, TP.PRICE_TYPE
    from   TAR_BO_PRICE_GET(:id_tar_bo_price) TP
    into   :board_price, :price_type;

    select c.ROUND_TO
    from   TARIFA t
           join CURRS c on c.CURR = t.CURR
    where  t.ID_TARIFA = :id_tar_head
    into   :round_to;

    execute procedure TAR_EVAL_PRICE(:price_type, :board_price, :base_per_day, :is_board_in_bp,
            :rnd_method, :round_to, :id_tar_input_detail)
    returning_values  :err_code, :board_price, :no_use;

    FOOD_PER_DAY = :BOARD_PRICE;
    if (:CNT_DAYS_BOARD > 1) then begin
      execute procedure TAR_EVAL_PRICE('DIVIDE', :CNT_DAYS_BOARD, :BOARD_PRICE, 0, :rnd_method, :round_to, :id_tar_input_detail)
      returning_values  :err_code, :food_per_day, :no_use;
      if (:err_code < 0) then exit;
      food_per_day = round_f(:food_per_day, 0.01);
  
      if ((mod(:DAY_OF_STAY, :CNT_DAYS_BOARD) = 0)) then food_per_day = :BOARD_PRICE - (:CNT_DAYS_BOARD - 1) * :FOOD_PER_DAY;
    end

    suspend;

    if (:is_board_in_bp = 1) then begin
      id_service = -1;
      service_type = 'BASE';
      disc_tag = 'F';
      FOOD_PER_DAY  = -:FOOD_PER_DAY;
       /* THIS SUSPEND IS FOR THE REDUCTION OF THE BASE PRICE */
      suspend;
    end
  end else begin
    board_price = 0;  /* !!!! suspend  */
  end
end
^

/* Alter (TAR_MATCH_BP) */
ALTER PROCEDURE TAR_MATCH_BP(TID_DBKEY CHAR(8),
MATCH_DATE DATE,
SEQ_NUM INTEGER,
TOTAL_GSTS INTEGER,
GUEST_BOARD_WEIGHT INTEGER,
REAL_RECALC INTEGER,
DAY_OF_STAY INTEGER,
CNT_DAYS_BP INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_BP INTEGER,
ID_BOARD_INCLUDE INTEGER,
INCOMPLETE_POSITION INTEGER,
BASE_PRICE NUMERIC(15,4),
PTEXT VARCHAR(20),
BASE_PER_DAY NUMERIC(15,4))
 AS
declare variable id_tar_bo_price integer;
  declare variable id_tar_head integer;
  declare variable param_filter varchar(2000);
  declare variable param_data varchar(2000);
  declare variable filter_result double precision;
  declare variable max_persons integer;
  declare variable success integer;
  declare variable id_tar_bp_tmp integer;
  declare variable id_board_include_tmp integer;
  declare variable id_tar_bp_last_success integer;
  declare variable id_board_include_last_success integer;
/*******************************************/
  declare variable is_price_for_room integer;
  declare variable price_type varchar(20);
  declare variable divisor integer;
  declare variable room_base_price numeric(15,4);
  declare variable no_use varchar(20);
  declare variable set_var varchar(255);
  declare variable rnd_method varchar(20);
  declare variable id_tar_calc integer;
  declare variable id_tar_input_detail integer;
  declare variable round_to numeric(15,4) ;
begin
  ID_TAR_BP = null;
  ID_BOARD_INCLUDE = null;
  ERR_CODE  = 0;
  success = 0;
  for
    select   TBP.ID_TAR_BP, TRBP.PARAM_FILTER, TBP.MAX_PERSONS, TCID.ID_TAR_HEAD,
             TBP.ID_BOARD_INCLUDE, TCID.PARAM_VALUES, TCI.ID_TAR_CALC, TCID.ID_TAR_INPUT_DETAIL
    from     TAR_BO_BASE_POSITION TBP
             join  TAR_CALC_INPUT_DETAIL$TMP TCID
               on  TBP.ID_TAR_HEAD = TCID.ID_TAR_HEAD
               and TBP.ID_ROOM_TYPE = TCID.ID_ROOM_TYPE
             join  TAR_CALC_INPUT$TMP TCI
               on  TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
             join  TAR_BO_RELATION TRBP
               on  TRBP.ID_TAR_BP = TBP.ID_TAR_BP
               and TRBP.BO_TYPE = 'BASE'
    where    TCID.RDB$DB_KEY = :tid_dbkey
             and TBP.BOARD_WEIGHT <= coalesce(:guest_board_weight, 0)
    order by TBP.MAX_PERSONS asc, TBP.BOARD_WEIGHT desc
    into     :id_tar_bp_tmp, :param_filter, :max_persons, :id_tar_head,
             :id_board_include_tmp, :param_data, :id_tar_calc, :id_tar_input_detail
  do begin
    execute procedure TAR_EVAL_FILTER(:param_filter, :param_data, :id_tar_input_detail)
    returning_values  :err_code, :filter_result;
    if (:err_code < 0) then exit;
    if (:filter_result = 1) then begin
      success = 1;
      id_tar_bp_last_success = :id_tar_bp_tmp;
      id_board_include_last_success = :id_board_include_tmp;

      if (:seq_num > :max_persons) then incomplete_position = 1;
      else incomplete_position = 0;

      if (:max_persons >= :total_gsts) then begin
        ID_TAR_BP = :id_tar_bp_tmp;
        ID_BOARD_INCLUDE = :id_board_include_tmp;
        break;
      end
    end
  end

  if (:success = 0) then begin
    /* NOT FOUND BASE POSITION */
    err_code = -231;
    err_text = '';
    exit;
  end
  if (:id_tar_bp is null) then begin
    ID_TAR_BP = :id_tar_bp_last_success;
    ID_BOARD_INCLUDE = :id_board_include_last_success;
  end

  execute procedure TAR_MATCH_PRICE(:id_tar_head, :ID_TAR_BP, 'BASE', :MATCH_DATE)
  returning_values  :err_code, :err_text, :id_tar_bo_price;
  if (:err_code < 0) then exit;

  if (:REAL_RECALC = 0) then exit;

  select TBP.IS_PRICE_FOR_ROOM, TBP.PTEXT, TBP.MAX_PERSONS, TBP.SET_VAR, TBP.RND_METHOD
  from   TAR_BO_BASE_POSITION TBP
  where  TBP.ID_TAR_BP = :ID_TAR_BP
  into   :is_price_for_room, :PTEXT, :max_persons, :set_var, :rnd_method;

  select TP.PRICE_VALUE, TP.PRICE_TYPE
  from   TAR_BO_PRICE_GET(:id_tar_bo_price) TP
  into   :BASE_PRICE, :price_type;

  if (:price_type <> 'EQUAL') then err_code = -2085; /* UNSUPPORTED PRICE TYPE FOR BASE POSITION !*/

  select c.round_to
  from   TARIFA t
         join CURRS c on c.CURR = t.CURR
  where  t.ID_TARIFA = :id_tar_head
  into   :round_to;

  if (:is_price_for_room = 1) then begin
    room_base_price = :BASE_PRICE;
    if (:max_persons >= :TOTAL_GSTS) then divisor = :TOTAL_GSTS;
    else divisor = :max_persons;

    execute procedure TAR_EVAL_PRICE('DIVIDE', :divisor, :room_base_price, 0, :rnd_method, :round_to, :id_tar_input_detail)
    returning_values  :err_code, :BASE_PRICE, :no_use;
    BASE_PRICE = round_f(:BASE_PRICE, :round_to);  -- ?!?!?!
    if (:err_code < 0) then exit;
    if (:divisor = :SEQ_NUM) then begin
      BASE_PRICE = :BASE_PRICE + :room_base_price - (:divisor * :BASE_PRICE);
    end
  end

  execute procedure sys_dbg('tar TAR_MATCH_BP cnt_days_bp = '||coalesce(:cnt_days_bp, 'null'));
  execute procedure sys_dbg('tar TAR_MATCH_BP day_of_stay = '||coalesce(:day_of_stay, 'null'));

  if (:cnt_days_bp > 1) then begin
    execute procedure TAR_EVAL_PRICE('DIVIDE', :CNT_DAYS_BP, :BASE_PRICE, 0, :rnd_method, :round_to, :id_tar_input_detail)
    returning_values  :err_code, :BASE_PER_DAY, :no_use;
    if (:err_code < 0) then exit;
    BASE_PER_DAY = round_f(:BASE_PER_DAY, :round_to);

    if ((mod(:DAY_OF_STAY, :CNT_DAYS_BP) = 0)) then BASE_PER_DAY = :BASE_PRICE - (:CNT_DAYS_BP - 1)*:BASE_PER_DAY;
  end else begin
    BASE_PER_DAY = :BASE_PRICE;
  end
  --
  execute procedure TAR_SET_VAR('total_base='||:BASE_PER_DAY, :id_tar_input_detail, :id_tar_calc);

  execute procedure TAR_SET_VAR(:set_var, :id_tar_input_detail, :id_tar_calc);
  --
end
^

/* empty dependent procedure body */
/* Clear: TAR_PRICES_SET_PACKS for: TAR_MATCH_PACKS */
ALTER PROCEDURE TAR_PRICES_SET_PACKS(TID_DBKEY CHAR(8),
ID_TAR_BP INTEGER,
DAY_OF_STAY INTEGER,
CUSTOM_PRICE NUMERIC(15,4))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_SERVICE INTEGER,
SERVICE_TYPE VARCHAR(20),
PRICE NUMERIC(15,4),
PRICE_TARIFF NUMERIC(15,4),
PACK_CURRENCY CHAR(3),
QTY_POST INTEGER,
PTEXT VARCHAR(20),
DISC_TAG VARCHAR(50),
PACKET_ITEM INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_MATCH_PACKS) */
ALTER PROCEDURE TAR_MATCH_PACKS(ID_TAR_BO_PRICE INTEGER,
ID_BO_PACK INTEGER,
TARIFF_CURR CHAR(3),
FOR_DATE DATE,
CUSTOM_PRICE NUMERIC(15,4),
ID_TAR_INPUT INTEGER,
ID_HOTEL INTEGER)
 RETURNS(ERR_CODE INTEGER,
SERVICE_TYPE VARCHAR(20),
DISC_TAG VARCHAR(50),
QTY_POST INTEGER,
PRICE NUMERIC(15,4),
PRICE_TARIFF NUMERIC(15,4),
ID_SERVICE INTEGER)
 AS
declare variable cnt_post integer;
  declare variable in_base_price integer;
  declare variable price_currency char(3);
  declare variable price_type varchar(20);
  declare variable price_value numeric(15, 4);
  declare variable rate_to_tariff double precision;
  declare variable set_var varchar(255);
  declare variable rnd_method varchar(20);
  declare variable no_use numeric(15, 4);
  declare variable id_tar_calc integer;
  declare variable id_tar_input_detail integer;
  declare variable round_to numeric(15,4) ;
begin
  err_code   = 0;

  select TBP.ID_SERVICE,  TBP.CNT_POST, TBP.SET_VAR, TBP.RND_METHOD,
         TBP.IS_IN_BASE_PRICE, TBP.PRICE_CURRENCY, TBP.DISC_TAG
  from   TAR_BO_PACK TBP
  where  TBP.ID_TAR_PACK = :id_bo_pack
  into   :id_service,  :cnt_post, :set_var, :rnd_method,
         :in_base_price, :price_currency, :disc_tag;

  execute procedure CURR_CROSS_RATE_GET(:price_currency, :tariff_curr, :for_date, :id_hotel)
  returning_values  :rate_to_tariff;

  select TBP.PRICE_TYPE, TBP.PRICE_VALUE
  from   TAR_BO_PRICE_GET(:id_tar_bo_price) TBP
  into   :price_type, :price_value;


  select TCI.ID_TAR_CALC, TCID.ID_TAR_INPUT_DETAIL
  from   TAR_CALC_INPUT$TMP TCI
         join TAR_CALC_INPUT_DETAIL$TMP TCID on TCID.ID_TAR_INPUT = TCI.ID_TAR_INPUT
  where  TCI.ID_TAR_INPUT = :id_tar_input
         and TCID.FOR_DATE = :for_date
  into   :id_tar_calc, :id_tar_input_detail;

  select c.round_to
  from   CURRS c
  where  c.CURR = :price_currency
  into   :round_to;

  execute procedure TAR_EVAL_PRICE(:price_type, :price_value, 0, 0, :rnd_method, :round_to, :id_tar_input_detail)
  returning_values  :err_code, :price, :no_use;
  if (:err_code < 0) then begin suspend; exit; end

  /*ROGO - move this from few lines beffore*/  -- ????
  price_tariff = :price * :rate_to_tariff;

  execute procedure TAR_SET_VAR(:set_var, :id_tar_input_detail, :id_tar_calc);
  --

  if (:cnt_post > 0) then begin
    qty_post = :cnt_post;
    service_type = 'PACKETS';
    suspend;
  end

  if (:custom_price is not null) then in_base_price = 1;
  if ((:in_base_price = 1) and (:cnt_post > 0)) then begin
    id_service = -1;
    service_type = 'BASE';
    disc_tag = 'P';
    price = -:price * :cnt_post;
    price_tariff = -:price_tariff * :cnt_post;
    qty_post = 1;
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_PRICES_SET_TAX for: TAR_MATCH_TAX */
ALTER PROCEDURE TAR_PRICES_SET_TAX(ID_TAR_INPUT INTEGER,
TID_DBKEY CHAR(8),
ID_TAR_BP INTEGER,
DAY_OF_STAY INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_SERVICE INTEGER,
SERVICE_TYPE VARCHAR(20),
PRICE NUMERIC(15,4),
PTEXT VARCHAR(20),
PACKET_ITEM INTEGER,
IS_INSIDE_BASE INTEGER,
DISC_TAG VARCHAR(50),
ID_DISCOUNT_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_MATCH_TAX) */
ALTER PROCEDURE TAR_MATCH_TAX(ID_TAR_INPUT INTEGER,
FOR_DATE DATE,
ID_TAR_BO_PRICE INTEGER,
ID_BO_DISCOUNT INTEGER)
 RETURNS(ERR_CODE INTEGER,
SERVICE_TYPE VARCHAR(20),
DISC_TAG VARCHAR(50),
PRICE NUMERIC(15,4),
ID_SERVICE INTEGER,
IS_INSIDE_BASE INTEGER,
ID_DISCOUNT_SERVICE INTEGER)
 AS
declare variable filtera varchar(2000);
  declare variable price_type varchar(20);
  declare variable price_value varchar(2000);
  declare variable price_source numeric(15, 4);
  declare variable no_use numeric(15, 4);
  declare variable set_var varchar(255);
  declare variable usr_filter varchar(2000);
  declare variable board_pack_filter varchar(2000);
  declare variable rnd_method varchar(20);
  declare variable id_tar_calc integer;
  declare variable id_tar_input_detail integer;
  declare variable base_filter varchar(20);
  declare variable round_to numeric(15,4);
  declare variable check_round numeric(15,4);
begin
  err_code   = 0;
  check_round = 0.0001;

  select TBD.ID_SERVICE, TBD.CALC_LIST,  --TBD.IS_IN_BASE_PRICE,
         TBD.DISC_TAG, TBD.SET_VAR, TBD.RND_METHOD
  from   TAR_BO_DISCOUNT TBD
  where  TBD.ID_TAR_DISCOUNT = :id_bo_discount
  into   :id_discount_service, :filtera,  --:in_base_price,
         :disc_tag, :set_var, :rnd_method;

  execute procedure TAR_CALC_DISCOUNT_FILTER(:filtera)
  returning_values  :base_filter, :board_pack_filter, :usr_filter;

  select TBP.PRICE_TYPE, TBP.PRICE_VALUE
  from   TAR_BO_PRICE_GET(:id_tar_bo_price) TBP
  into   :price_type, :price_value;

  select TCI.ID_TAR_CALC, TCID.ID_TAR_INPUT_DETAIL
  from   TAR_CALC_INPUT$TMP TCI
         join TAR_CALC_INPUT_DETAIL$TMP TCID on TCID.ID_TAR_INPUT = TCI.ID_TAR_INPUT
  where  TCI.ID_TAR_INPUT = :id_tar_input
         and TCID.FOR_DATE = :for_date
  into   :id_tar_calc, :id_tar_input_detail;

  -- MAIN LOGIC DETERMINING DISCOUNT BASE. see also TAR_CALC_DISC_BASE$INT with same logic
  -- !!! Service type and id_service of discount is as object that they discounting. in TAR_CALC_REPOST$INT type is changed to PACKAGES if discounts have ID_DISCOUNT_SERVICE
  -- If discount is Mejdinen Rezultat - then summm all amounts and THEN calculate and round the result - result by this method is different from normal discounting.
  for
    select iif (:id_discount_service = 0, -1, TCO.ID_SERVICE),
           iif (:id_discount_service = 0, 'BASE', TCO.SERVICE_TYPE),
           sum(TCO.PRICE_TARIFF),
           min(c.ROUND_TO)
    from   TAR_CALC_OUTPUT$TMP TCO
           join CURRS c on c.CURR = tco.CURRENCY_TARIFF
    where  (TCO.ID_TAR_INPUT = :id_tar_input)
           and (TCO.FOR_DATE = :for_date)
           and (
                 (:filtera = '')
                 or
                 (
                   (:board_pack_filter like '%'||f_character(28)||TCO.SERVICE_TYPE||f_character(28)||'%')
                   and (TCO.PRICE_NOTE not in ('DISC', 'DISC_STAY'))
                 )
                 or
                 ( (:base_filter = 'BASE1') and (TCO.SERVICE_TYPE = 'BASE') and (TCO.PRICE_NOTE = 'BASE') )
                 or
                 ( (:base_filter = 'BASE2') and (TCO.SERVICE_TYPE = 'BASE') and (TCO.PRICE_NOTE in ('BASE', 'EG')) )
                 or
                 ( (:base_filter = 'BASE3') and (TCO.SERVICE_TYPE = 'BASE') and (TCO.PRICE_NOTE in ('BASE', 'EG', 'FOOD', 'PACK')) )
                 or
                 (  :usr_filter like '%,'||TCO.DISC_TAG||',%' )
               )
    group by 1, 2
    into   :id_service, :service_type, :price_source, :round_to
  do begin
   /*
   savedbg ('tar TAR_MATCH_TAX ===== DISCOUNT =======' );
   savedbg ('tar TAR_MATCH_TAX :filtera:' || :filtera );
   savedbg ('tar TAR_MATCH_TAX :id_discount_service:' || :id_discount_service );
   savedbg ('tar TAR_MATCH_TAX :id_tar_input:' || :id_tar_input  );
   savedbg ('tar TAR_MATCH_TAX :for_date:' || :for_date  );
   savedbg ('tar TAR_MATCH_TAX :for_date:' || :for_date  );
   savedbg ('tar TAR_MATCH_TAX :board_pack_filter:' || :board_pack_filter );
   savedbg ('tar TAR_MATCH_TAX :base_filter:' || :base_filter  );
   savedbg ('tar TAR_MATCH_TAX :usr_filter:' || :usr_filter );
   savedbg ('tar TAR_MATCH_TAX :id_service:' || :id_service   );
   savedbg ('tar TAR_MATCH_TAX :service_type:' || :service_type  );
   savedbg ('tar TAR_MATCH_TAX :price_source:' || :price_source  );
   savedbg ('tar TAR_MATCH_TAX :price_type:' || :price_type  );
   savedbg ('tar TAR_MATCH_TAX :price_value:' || :price_value  );
   */
    --ALWAYS SET DISCOUNT BASE AS VARIABLE NAMED base (for eventual feature addressing)
    execute procedure TAR_SET_VAR('base='||round_f(:price_source, 0.00001), :id_tar_input_detail, :id_tar_calc);

    execute procedure TAR_EVAL_PRICE(:price_type, :price_value, :price_source, 0/*:in_base_price*/, :rnd_method, :round_to, :id_tar_input_detail)
    returning_values  :err_code, :price, :no_use;
    -- savedbg ('tar TAR_MATCH_TAX - Taraaaa !! :price:' || :price  );
    if (:err_code < 0) then begin
      suspend;
      exit;
    end

    if (round_f(:price, :check_round) <> 0) then begin
      /*if ((:id_service > 0) and (:in_base_price = 1)) then is_inside_base = 1;
      else*/
      is_inside_base = 0;
      suspend;
      /*
      if (:is_inside_base = 1) then begin
        service_type = 'BASE';
        price = -1 * :price;
        id_service = -1;
        suspend;
      end*/
    end
  end

  --SET USER DEFINED VARIABLES PER THIS DISCOUNT LINE
  execute procedure TAR_SET_VAR(:set_var, :id_tar_input_detail, :id_tar_calc);
  --
end
^

/* Alter (TAR_PRICES_SET_EG) */
ALTER PROCEDURE TAR_PRICES_SET_EG(ID_TAR_INPUT INTEGER,
FOR_DATE DATE,
DAY_OF_STAY INTEGER,
CNT_DAYS_BP INTEGER,
CNT_DAYS_BOARD INTEGER,
GUEST_BOARD_WEIGHT INTEGER,
ID_BO_EG INTEGER,
ID_EG_PRICE INTEGER,
BASE_PRICE NUMERIC(15,4))
 RETURNS(ID_SERVICE INTEGER,
SERVICE_TYPE VARCHAR(20),
PRICE NUMERIC(15,4),
PTEXT VARCHAR(20),
DISC_TAG VARCHAR(50),
ERR_CODE INTEGER)
 AS
declare variable price_type_extra varchar(20);
  declare variable upd_board_price_extra numeric(15, 4);
  declare variable ptext_extra varchar(20);
  declare variable price_type_base varchar(20);
  declare variable upd_board_price_base numeric(15, 4);
  declare variable ptext_base varchar(20);
  declare variable price_type varchar(20);
  declare variable upd_base_price numeric(15, 4);
  declare variable price_source numeric(15, 4);
  declare variable total_price numeric(15, 4);
  declare variable no_use integer;
  declare variable set_var varchar(255);
  declare variable is_packet_reduction integer;
  declare variable rnd_method varchar(20);
  declare variable id_tar_calc integer;
  declare variable id_tar_input_detail integer;
  declare variable round_to numeric(15,4);
  declare variable check_round numeric(15,4);
  declare variable tar_curr tcurrency;
begin
  err_code = 0;
  check_round = 0.0001;
  disc_tag = 'EG';
  /* BOARD_PRICE AND BASE_PRICE MUST BE FOR THE DAYS OF CORRESPONDING BUSINESS_OBJECT */

  if (:id_bo_eg < 0) then exit;

  select TEG.PTEXT, TEG.SET_VAR, TEG.IS_PACKET_REDUCTION, TEG.RND_METHOD, t.CURR
  from   TAR_BO_EXTRA_GUEST TEG
         join TARIFA t on t.ID_TARIFA = teg.ID_TAR_HEAD
  where  TEG.ID_TAR_EG = :id_bo_eg
  into   :ptext, :set_var, :is_packet_reduction, :rnd_method, :tar_curr;

  if (:GUEST_BOARD_WEIGHT <> 0) then begin
    -- calc FOOD price
    price = 0;
    price_type_extra = null;
    price_type_base  = null;
    select TPb.PRICE_TYPE, TPb.PRICE_VALUE, tpe.PRICE_TYPE, tpe.PRICE_VALUE
    from   TAR_BO_EXTRA_GUEST TEG
           left join TAR_BO_PRICE_GET (TEG.ID_PRICE_BB) tpb on 1=1
           left join TAR_BO_PRICE_GET (TEG.ID_PRICE_EB) tpe on 1=1
    where  TEG.ID_TAR_EG = :id_bo_eg
    into   :price_type_base, :upd_board_price_base, :price_type_extra, :upd_board_price_extra;

    ptext_extra = :ptext;
    ptext_base = :ptext;

    if ((:price_type_base is not null) or (price_type_extra is not null)) then begin
      for
        select TCO.ID_SERVICE, TCO.SERVICE_TYPE, sum(TCO.PRICE), min(c.ROUND_TO)
        from   TAR_CALC_OUTPUT$TMP TCO
               join CURRS c on c.CURR = tco.CURRENCY
        where  TCO.ID_TAR_INPUT = :id_tar_input
               and TCO.FOR_DATE = :for_date
               and TCO.PRICE_NOTE <> 'EG'
               and TCO.SERVICE_TYPE in ('EXTRA_BOARD', 'BASE_BOARD')
        group by TCO.ID_SERVICE, TCO.SERVICE_TYPE
        into   :id_service, :service_type, :price_source, :round_to
      do begin
        if (:service_type = 'EXTRA_BOARD') then begin
          if (:price_type_extra is null) then break;
          execute procedure TAR_EVAL_PRICE(:price_type_extra, :upd_board_price_extra, :price_source, 0,
                            :rnd_method, :round_to, null)
          returning_values  :err_code, :price, :no_use;
          ptext = :ptext_extra;
        end else begin
          if (:price_type_base is null) then break;
          execute procedure TAR_EVAL_PRICE(:price_type_base, :upd_board_price_base, :price_source, 0,
                            :rnd_method, :round_to, null)
          returning_values  :err_code, :price, :no_use;
          ptext = :ptext_base;
        end
        if (:id_service is null) then id_service = -1;
        if (:err_code < 0) then begin suspend; exit; end
        if (round_f(:price, :check_round) <> 0) then suspend;
      end
    end
  end

  select TCI.ID_TAR_CALC, TCID.ID_TAR_INPUT_DETAIL
  from   TAR_CALC_INPUT$TMP TCI
         join TAR_CALC_INPUT_DETAIL$TMP TCID on TCID.ID_TAR_INPUT = TCI.ID_TAR_INPUT
  where  TCI.ID_TAR_INPUT = :id_tar_input
         and TCID.FOR_DATE = :for_date
  into   :id_tar_calc, :id_tar_input_detail;

  execute procedure TAR_SET_VAR(:set_var, :id_tar_input_detail, :id_tar_calc);

  -- calc base service price
  service_type = 'BASE';
  id_service = -1;
  price_type = null;
  select TP.PRICE_VALUE, TP.PRICE_TYPE
  from   TAR_BO_PRICE_GET(:id_eg_price) TP
  into   :upd_base_price, :price_type;

  select c.ROUND_TO
  from   CURRS c
  where  c.CURR = :tar_curr
  into   :round_to;

  if (:price_type is null) then begin
    price = 0;
  end else if (:price_type = 'PERCENT') then begin
    -- calc percent over real daily base_price
    select sum(TCO.PRICE), min(c.ROUND_TO)
    from   TAR_CALC_OUTPUT$TMP TCO
           join CURRS c on c.CURR = tco.CURRENCY
    where  TCO.ID_TAR_INPUT = :id_tar_input
           and TCO.FOR_DATE = :for_date
           and TCO.PRICE_NOTE <> 'EG'
           and TCO.SERVICE_TYPE = 'BASE'
    into   :price_source, :round_to;

    execute procedure TAR_EVAL_PRICE(:price_type, :upd_base_price, :price_source, 0, :rnd_method, :round_to, :id_tar_input_detail)
    returning_values  :err_code, :price, :no_use;
  end else begin
    execute procedure TAR_EVAL_PRICE(:price_type, :upd_base_price, :base_price, 0, :rnd_method, :round_to, :id_tar_input_detail)
    returning_values  :err_code, :price, :no_use;

    if (:cnt_days_bp > 1) then begin
      total_price = :price;
      price = round_f(:price/:cnt_days_bp, :round_to);
      /*Obirane na razlikite ot deleneto - za wsiakakyw tip ceni - twardi ili procentni*/
      if ((mod(:day_of_stay, :cnt_days_bp) = 0)) then begin
        price = :total_price - (:cnt_days_bp - 1) * :price;
      end
    end
  end

  /*W eg_discount se slaga sydyrjanieto na kutiikata - moje da e % ili suma*/
  execute procedure TAR_SET_VAR('eg_discount='||:upd_base_price, :id_tar_input_detail, :id_tar_calc);

  if ((round_f(:price, :check_round) <> 0) and (:is_packet_reduction = 0)) then suspend;
end
^

/* Alter (TAR_PRICES_SET_PACKS) */
ALTER PROCEDURE TAR_PRICES_SET_PACKS(TID_DBKEY CHAR(8),
ID_TAR_BP INTEGER,
DAY_OF_STAY INTEGER,
CUSTOM_PRICE NUMERIC(15,4))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_SERVICE INTEGER,
SERVICE_TYPE VARCHAR(20),
PRICE NUMERIC(15,4),
PRICE_TARIFF NUMERIC(15,4),
PACK_CURRENCY CHAR(3),
QTY_POST INTEGER,
PTEXT VARCHAR(20),
DISC_TAG VARCHAR(50),
PACKET_ITEM INTEGER)
 AS
declare variable tariff_currency char(3);
  declare variable for_date date;
  declare variable id_tar_head integer;
  declare variable id_bo_pack integer;
  declare variable total_stay integer;
  declare variable param_filter varchar(2000);
  declare variable param_data varchar(2000);
  declare variable filter_result double precision;
  declare variable id_tar_bo_price integer;
  declare variable day_scheme varchar(20);
  declare variable day_scheme_num integer;
  declare variable dayscheme_result integer;
  declare variable id_hotel integer;
  declare variable id_tar_input integer;
  declare variable id_tar_input_detail integer;
  declare variable dbg varchar(2000);
begin
  err_code  = 0;
  id_tar_bo_price = -1;
  packet_item = null;
  for
    select   TBP.ID_TAR_PACK, TRBP.PARAM_FILTER, TCID.ID_TAR_HEAD, TBP.PACKET_ITEM, TCI.ID_TAR_INPUT, TCID.ID_TAR_INPUT_DETAIL,
             TBP.DAY_SCHEME, TBP.DAY_SCHEME_NUM, (TCI.TO_DATE - TCI.FROM_DATE), TCID.FOR_DATE,
             TBP.PTEXT, TBP.PRICE_CURRENCY, TCID.PARAM_VALUES, T.CURR, T.ID_HOTEL, TBP.DISC_TAG
    from     TAR_CALC_INPUT_DETAIL$TMP TCID
             join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
             join TAR_BO_PACK TBP on  TBP.ID_TAR_HEAD = TCID.ID_TAR_HEAD
             join TAR_BO_RELATION TRBP on  TRBP.ID_BO = TBP.ID_TAR_PACK and TRBP.BO_TYPE = 'PACK'
             join TAR_HEAD TH on TH.ID_TAR_HEAD = TCID.ID_TAR_HEAD
             join TARIFA T on T.ID_TARIFA = TH.ID_TAR_HEAD
    where    TCID.RDB$DB_KEY = :tid_dbkey
             and TRBP.ID_TAR_BP = :id_tar_bp
    /*first substract packages in base price until zero. Then add overprice packs*/
    order by TBP.IS_IN_BASE_PRICE
    into     :id_bo_pack, :param_filter, :id_tar_head, :packet_item, :id_tar_input, :id_tar_input_detail,
             :day_scheme, :day_scheme_num, :total_stay, :for_date,
             :ptext, :pack_currency, :param_data, :tariff_currency, :id_hotel, :disc_tag
  do begin
    execute procedure sys_dbg('tar TAR_PRICES_SET_PACKS param_filter = '||coalesce(:param_filter, 'null'));
    execute procedure sys_dbg('tar TAR_PRICES_SET_PACKS param_data = '||coalesce(:param_data, 'null'));

    execute procedure TAR_EVAL_FILTER(:param_filter, :param_data, :id_tar_input_detail)
    returning_values  :err_code, :filter_result;
    execute procedure sys_dbg('tar TAR_PRICES_SET_PACKS filter_result = '||coalesce(:filter_result, 'null'));

    if (:err_code < 0) then begin suspend; exit; end

    if (:filter_result = 1) then begin
      execute procedure TAR_EVAL_DAYSCHEME(:day_of_stay, :total_stay, :day_scheme, :day_scheme_num)
      returning_values  :err_code, :dayscheme_result;
      if (:err_code < 0) then begin suspend; exit; end

      if (:dayscheme_result = 1) then begin
        execute procedure TAR_MATCH_PRICE(:id_tar_head, :id_bo_pack, 'PACK', null)
        returning_values  :err_code, :err_text, :id_tar_bo_price;
        if (:err_code < 0) then begin suspend; exit; end

        for
          select TMP.ERR_CODE, TMP.SERVICE_TYPE, TMP.PRICE, TMP.PRICE_TARIFF, TMP.ID_SERVICE, TMP.QTY_POST
          from   TAR_MATCH_PACKS(:id_tar_bo_price, :id_bo_pack, :tariff_currency, :for_date, :custom_price, :id_tar_input, :id_hotel) TMP
          into   :err_code, :service_type, :price, :price_tariff, :id_service, :qty_post
        do begin
          suspend;
        end
      end
    end
  end
end
^

/* Alter (TAR_PRICES_SET_TAX) */
ALTER PROCEDURE TAR_PRICES_SET_TAX(ID_TAR_INPUT INTEGER,
TID_DBKEY CHAR(8),
ID_TAR_BP INTEGER,
DAY_OF_STAY INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_SERVICE INTEGER,
SERVICE_TYPE VARCHAR(20),
PRICE NUMERIC(15,4),
PTEXT VARCHAR(20),
PACKET_ITEM INTEGER,
IS_INSIDE_BASE INTEGER,
DISC_TAG VARCHAR(50),
ID_DISCOUNT_SERVICE INTEGER)
 AS
declare variable id_tar_head integer;
  declare variable id_bo_discount integer;
  declare variable total_stay integer;
  declare variable for_date date;
  declare variable param_filter varchar(2000);
  declare variable param_data varchar(2000);
  declare variable dbg varchar(2000);
  declare variable filter_result double precision;
  declare variable id_tar_bo_price integer;
  declare variable day_scheme varchar(20);
  declare variable day_scheme_num integer;
  declare variable dayscheme_result integer;
  declare variable id_tar_calc integer;
  declare variable id_tar_input_detail integer;
begin
  err_code  = 0;
  id_tar_bo_price = -1;
  packet_item = null;
  for
    select   TBD.ID_TAR_DISCOUNT, TRBP.PARAM_FILTER, TCID.ID_TAR_HEAD, TCI.ID_TAR_CALC, TCID.ID_TAR_INPUT_DETAIL,
             TBD.DAY_SCHEME, TBD.DAY_SCHEME_NUM, (TCI.TO_DATE - TCI.FROM_DATE), TCID.FOR_DATE,
             TBD.PTEXT, TCID.PARAM_VALUES, TBD.PACKET_ITEM
    from     TAR_CALC_INPUT_DETAIL$TMP TCID
             join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
             join TAR_BO_DISCOUNT TBD on TBD.ID_TAR_HEAD = TCID.ID_TAR_HEAD
             join TAR_BO_RELATION TRBP on TRBP.ID_BO = TBD.ID_TAR_DISCOUNT
                  and TRBP.BO_TYPE = 'DISCOUNT'
    where    TCID.RDB$DB_KEY = :tid_dbkey
             and TRBP.ID_TAR_BP = :id_tar_bp
    order by TBD.PRIORITET asc
    into     :id_bo_discount, :param_filter, :id_tar_head, :id_tar_calc, :id_tar_input_detail,
             :day_scheme, :day_scheme_num, :total_stay, :for_date,
             :ptext, :param_data, :packet_item
  do begin
    execute procedure TAR_EVAL_FILTER(:param_filter, :param_data, :id_tar_input_detail)
    returning_values  :err_code, :filter_result;
    if (:err_code < 0) then begin suspend; exit; end
    if (:filter_result = 1) then begin
      execute procedure TAR_EVAL_DAYSCHEME(:day_of_stay, :total_stay, :day_scheme, :day_scheme_num)
      returning_values  :err_code, :dayscheme_result;
      if (:err_code < 0) then begin suspend; exit; end
      if (:dayscheme_result = 1) then begin
        execute procedure TAR_MATCH_PRICE(:id_tar_head, :id_bo_discount, 'DISCOUNT', null)
        returning_values  :err_code, :err_text, :id_tar_bo_price;
        if (:err_code < 0) then begin suspend; exit; end
        for
          select TMT.ERR_CODE, TMT.SERVICE_TYPE, TMT.PRICE, TMT.ID_SERVICE, TMT.DISC_TAG, TMT.IS_INSIDE_BASE, TMT.ID_DISCOUNT_SERVICE
          from   TAR_MATCH_TAX(
                   :id_tar_input, :for_date, :id_tar_bo_price,
                   :id_bo_discount) TMT
          into   :err_code, :service_type, :price, :id_service, :disc_tag, :is_inside_base, :id_discount_service
        do suspend;
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_EVAL_PERIOD$INT for: TAR_PRICES_SET_TAX_PERIOD */
ALTER PROCEDURE TAR_CALC_EVAL_PERIOD$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_PRICES_SET_TAX_PERIOD) */
ALTER PROCEDURE TAR_PRICES_SET_TAX_PERIOD(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_SERVICE INTEGER,
SERVICE_TYPE VARCHAR(20),
PRICE NUMERIC(15,4),
PTEXT VARCHAR(20),
ID_TAR_INPUT INTEGER,
TARIFF_CURR CHAR(3),
DEDUCTION_DATE DATE,
DISC_TAG VARCHAR(20))
 AS
declare variable dbg varchar(2000);
  declare variable bo_type varchar(200);
  declare variable id_tar_head integer;
  declare variable id_bo_discount integer;
  declare variable id_tar_bo_price integer;
  declare variable target_voucher_num varchar(20);
begin
  err_code  = 0;
  bo_type = 'DISCOUNT_PERIOD';
  for
    select distinct
           TCID.ID_TAR_HEAD, T.CURR, TCI.VOUCHER_NUM
    from   TAR_CALC_INPUT$TMP TCI
           join TAR_CALC_INPUT_DETAIL$TMP TCID on TCID.ID_TAR_INPUT = TCI.ID_TAR_INPUT
           join TAR_HEAD TH on TH.ID_TAR_HEAD = TCID.ID_TAR_HEAD
           join TARIFA T on T.ID_TARIFA = TH.ID_TAR_HEAD
    where  TCI.ID_TAR_CALC = :id_tar_calc
           and exists(
             select *
             from   TAR_BO_DISCOUNT_STAY TBD
             where  TBD.ID_TAR_HEAD = TH.ID_TAR_HEAD
           )
    into   :id_tar_head, :tariff_curr, :target_voucher_num
  do begin
--    dbg = savedbg('id_tar_head = '||coalesce(:id_tar_head, 'null'));
--    dbg = savedbg('target_voucher_num = '||coalesce(:target_voucher_num, 'null'));

    id_tar_bo_price = -1;
    for
      select   TBD.ID_TAR_DISCOUNT_STAY, TBD.PTEXT, TBD.DISC_TAG
      from     TAR_BO_DISCOUNT_STAY TBD
      where    TBD.ID_TAR_HEAD = :id_tar_head
      order by TBD.PRIORITET asc
      into     :id_bo_discount, :ptext, :disc_tag
    do begin
      execute procedure TAR_MATCH_PRICE(:id_tar_head, :id_bo_discount, :bo_type, null)
      returning_values  :err_code, :err_text, :id_tar_bo_price;
      if (:err_code < 0) then begin suspend; exit; end
      for
        select TMT.ERR_CODE, TMT.SERVICE_TYPE, TMT.PRICE, TMT.ID_SERVICE, TMT.ID_TAR_INPUT, TMT.DEDUCTION_DATE
        from   TAR_CALC_APPLY_DISC$INT(:id_tar_calc, :id_tar_bo_price, :id_bo_discount, :target_voucher_num) TMT
        into   :err_code, :service_type, :price, :id_service, :id_tar_input, :deduction_date
      do begin
        suspend;
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_BO_BOARD for: TAR_SAVE_PARSE_PARAM */
ALTER PROCEDURE TAR_SAVE_BO_BOARD(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_BO_BP for: TAR_SAVE_PARSE_PARAM */
ALTER PROCEDURE TAR_SAVE_BO_BP(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_BO_DISC for: TAR_SAVE_PARSE_PARAM */
ALTER PROCEDURE TAR_SAVE_BO_DISC(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_BO_DISC_PERIOD for: TAR_SAVE_PARSE_PARAM */
ALTER PROCEDURE TAR_SAVE_BO_DISC_PERIOD(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_BO_EG for: TAR_SAVE_PARSE_PARAM */
ALTER PROCEDURE TAR_SAVE_BO_EG(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_BO_PACK for: TAR_SAVE_PARSE_PARAM */
ALTER PROCEDURE TAR_SAVE_BO_PACK(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_SAVE_PARSE_PARAM) */
ALTER PROCEDURE TAR_SAVE_PARSE_PARAM(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
PARAM_FILTER VARCHAR(2000))
 RETURNS(ERR_CODE INTEGER)
 AS
declare variable delim integer;
  declare variable parse_filter varchar(2000);
  declare variable db_param_name varchar(30);
  declare variable param_type varchar(20);
  declare variable is_interface integer;
  declare variable is_date_dependant integer;
  declare variable script_testing integer;
  declare variable param_data varchar(2000);
  declare variable param_name varchar(40);
  declare variable data_type varchar(20);
  declare variable pdata varchar(20);
  declare variable no_use double precision;
  declare variable var_testing_data varchar(2000);
begin
  err_code = 0;
  script_testing = 1;
  var_testing_data = '';
  param_data = '';
  execute procedure SETTING_GET_VALUE('RANGE_DATA_DELIMETER', null)
  returning_values  :delim;

  select f_parse_params(:param_filter, f_character(:delim))
  from   RDB$DATABASE
  into   :parse_filter;

  for
    select SPD.ITEM
    from   SYSTEM_STRING_PARSER(:parse_filter, f_character(:delim)) SPD
    into   :db_param_name
  do begin
    if (not exists(
         select *
         from   TAR_BO_PARAMS TBP
         where  TBP.ID_TAR_HEAD = :id_tar_head
                and TBP.BO_TYPE = :bo_type
                and TBP.PARAM_NAME = :db_param_name
    )) then begin
       is_interface = null;
       select  coalesce(TP.IS_INTERFACE, 0), coalesce(TP.IS_DATE_DEPENDANT, 0)
       from    TARIFA_PARAMS TP
       where   TP.PARAM_CODE = :db_param_name
               and TP.IS_USE = 1
       into    :is_interface, :is_date_dependant;
       if (:is_interface is not null) then begin
         if (:is_interface = 1) then param_type = 'USER_INTERFACE';
         else if (:is_date_dependant = 1) then param_type = 'DATE_DEPENDANT';
         else param_type = 'NORMAL';
         insert into TAR_BO_PARAMS (ID_TAR_HEAD, BO_TYPE, PARAM_NAME, PARAM_TYPE)
         values (:id_tar_head, :bo_type, :db_param_name, :param_type);
       end else begin
         var_testing_data = :var_testing_data || ';:' || :db_param_name || ',' ||'FLOAT' || ',1';
         -- TODO this may be replaced with VAR INIT SP   /  ?!?!??!
       end
    end
  end
  script_testing = 0;
  if (:script_testing = 1) then begin
    param_data = '';
    for
      select   TP.PARAM_CODE, TP.DATA_TYPE
      from     TAR_BO_PARAMS TBP
               join TARIFA_PARAMS TP on TP.PARAM_CODE = TBP.PARAM_NAME
      where    TBP.ID_TAR_HEAD = :id_tar_head
      group by TP.PARAM_CODE, TP.DATA_TYPE
      into     :param_name, :data_type
    do begin
      if (:data_type = 'DATE') then pdata = '01/01/2000';
      else pdata = '1';
      if ((:param_name is not null) and (:data_type is not null)) then begin
        param_data = :param_data||';:'||:param_name||','||:data_type||','||:pdata;
      end
    end
    execute procedure TAR_EVAL_FILTER(:param_filter, :param_data, null)
    returning_values  :err_code, :no_use;
  end

  when any do begin
    err_code = -207;
    execute procedure sys_dbg('tar_save_parse_param ' || substring('param_data = '||:param_data from 1 for 1000)|| f_crlf()
                              || substring('param_filter = '||:param_filter from 1 for 1000));
  end
end
^

/* Alter (TAR_TEST$TAR) */
ALTER PROCEDURE TAR_TEST$TAR(NUMBER VARCHAR(62),
ID_TAR_HEAD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_reserv_detail integer;
begin
  id_tar_calc = -1 * :id_tar_head;
  delete from TAR_CALC_OUTPUT$TMP where id_tar_calc = :id_tar_calc;
  delete from TAR_CALC_INPUT$TMP  where id_tar_calc = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP  where id_tar_calc = :id_tar_calc;

  err_code = 0;

  id_reserv_detail = null;
  select RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.NUMBER = :number
         and rd.IS_ANUL = 0
  into   :id_reserv_detail;

  if (:id_reserv_detail is null) then begin
    select first 1 RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.NUMBER_2 = :number
           and rd.IS_ANUL = 0
    into   :id_reserv_detail;
  end

  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NEW_ROOM', :ID_TAR_HEAD);

  execute procedure TAR_CALC_EVAL_ALL$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_PARAMS$INT for: TARIFA_GET_PARAM */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TARIFA_GET_PARAM) */
ALTER PROCEDURE TARIFA_GET_PARAM(ID_PARAM INTEGER,
FOR_DATE DATE,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER)
 RETURNS(OUT_VALUE VARCHAR(255))
 AS
declare variable is_interface integer;
  declare variable param_code varchar(30);
  declare variable is_value integer;
  declare variable int1 integer;
  declare variable data_type varchar(10);
  declare variable pvalue varchar(20);
  declare variable from_ date;
  declare variable to_ date;
begin
  select TP.IS_INTERFACE, TP.PARAM_CODE, TP.IS_VALUE, TP.DATA_TYPE, TP.PVALUE
  from   TARIFA_PARAMS TP
  where  ID_TARIFA_PARAM = :ID_PARAM 
  into   :is_interface, :param_code, :is_value, :data_type, :pvalue;
  /*get interface params*/
  if (:PARAM_CODE = 'NATION2') then
    PARAM_CODE = 'NATION'; /* !!!!!!!!!! */

  /*get value params*/
  if (:IS_VALUE = 1) then
    OUT_VALUE = :pvalue;

  /*get internal params*/
  OUT_VALUE = null;
  if (:IS_INTERFACE = 0) then begin
    if (:PARAM_CODE = 'TODAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE, 'D;dd/mm/yyyy');

    end else if (:PARAM_CODE = 'WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE, 'DW;MON');

    end else if (:PARAM_CODE = 'NEXT_DATE_WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE + 1, 'DW;MON');

    end else if (:PARAM_CODE = 'PREV_DATE_WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE - 1, 'DW;MON');

    end else if (:PARAM_CODE = 'REQUIRED_WEEK_DAYS') then begin
      select maxdate(ti.FROM_DATE, :FOR_DATE -3), mindate(ti.TO_DATE -1, :FOR_DATE +3)
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :from_, :to_;
      
      for
        select formatdate(RLP.OUT_DATE, 'DW;MON')
        from   SYSTEM_LOOP_PERIOD(:from_, :to_) RLP
        into   :int1
      do OUT_VALUE = :OUT_VALUE||','||:int1;

    end else if (:PARAM_CODE = 'ARRIVAL_WEEK_DAYS') then begin
      select formatdate(ti.FROM_DATE, 'DW;MON')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'PRESTOI') then begin
      select cast(ti.TO_DATE - ti.FROM_DATE as integer)
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'FROM_DATE') then begin
      select formatdate(ti.FROM_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TO_DATE') then begin
      select formatdate(ti.TO_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'DAYS_PASSED') then begin
       /* 01  03 -  01-1, 02-2   (        )*/   
       select cast((:FOR_DATE - G.FROM_DATE + 1) as integer)
       from   TAR_CALC_INPUT$TMP G
       where  G.ID_TAR_INPUT = :ID_TAR_INPUT
       into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'DAYS_TO_STAY') then begin
       /* 01  03 -  01-2, 02-1    (  )*/
       select cast((G.TO_DATE - :FOR_DATE - 1) as integer)
       from   TAR_CALC_INPUT$TMP G
       where  G.ID_TAR_INPUT = :ID_TAR_INPUT
       into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_GUESTS') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_CHILDREN') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.IS_CHILD = 1
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_ADULTS') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.IS_CHILD is distinct from 1
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_GUESTS_BY_ACCOUNT') then begin
      select (select count(*)
              from   GUEST G
                     join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
              where  G.ID_BASE_ACCOUNT = ti.ID_BASE_ACCOUNT
                     and G.FROM_DATE <= :FOR_DATE
                     and G.TO_DATE > :FOR_DATE
                     and RD.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP ti
      where  ti.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TYPE_ROOM') then begin
      select rt.TYPE_ROOM
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join ROOM_TYPES RT on RT.ID_ROOM_TYPE = tid.ID_ROOM_TYPE
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
      into   :OUT_VALUE;
      /* TO PRESEVE COMPATIBILITY WITH OLD TARIFF VERSIONS */
      /* WE HAVE TO RETURN THE NAME NOT THE ID !           */

    end else if (:PARAM_CODE = 'TYPE_STAY') then begin
      select ts.TYPE_STAY
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join TYPE_STAY TS on ts.ID_TYPE_STAY = tid.ID_TYPE_STAY
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TYPE_HRANA') then  begin
      select m.NAME
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join MEALS m on m.ID_BOARD = tid.ID_BOARD
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;
      OUT_VALUE = trim(coalesce(:OUT_VALUE, ''));

    end else if (:PARAM_CODE = 'PACK_ITEMS') then begin
      OUT_VALUE = null;
      select TID.PACKET_ITEMS
      from   TAR_CALC_INPUT$TMP TID
      where  TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;
      OUT_VALUE = coalesce(:OUT_VALUE, '~~');
      -- strfloateval('POS("~2~", :PACK_ITEMS)>0', ';:PACK_ITEMS,STRING,~2~3~D~')

    end else if (:PARAM_CODE = 'AGE') then begin
      select ti.GUEST_AGE
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_SEX') then begin
      select G.GUEST_SEX
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE ;
      if ((:OUT_VALUE is null) or (:OUT_VALUE = '')) then OUT_VALUE = '-' ;

    end else if (:PARAM_CODE = 'NATION') then begin
      select tid.COUNTRY_CODE
      from   TAR_CALC_INPUT$TMP TID
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_FIRST_DATE') then begin
      select cast(iif(G.FROM_DATE = :FOR_DATE, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_LAST_DATE') then begin
      select cast(iif(G.TO_DATE -1 = :FOR_DATE, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_LATE_CHECKOUT') then begin
      select g.IS_LATE_CHECKOUT
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_FIRST_GUEST_IN_ROOM') then begin
      select (select count(ti.ID_TAR_INPUT)
              from   TAR_CALC_INPUT$TMP ti
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and ti.ID_GUEST < t.ID_GUEST)
      from   TAR_CALC_INPUT$TMP t
      where  t.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :int1;

      if (:int1 = 0) then OUT_VALUE = 1; else OUT_VALUE = 0;
      
    end else if (:PARAM_CODE = 'IS_DIFER_NATIONS') then begin
      select (select cast(iif(count(distinct ti.COUNTRY_CODE) > 1, 1, 0) as integer)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_GROUP') then begin
      select cast(iif(g.ID_GROUP is not null, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_NIGHTS_BY_ACCOUNT') then begin
      /*          . */
      select (select cast(sum (G_IN_R.TO_DATE - G_IN_R.FROM_DATE) as integer)
              from   GUEST G_IN_R
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_R.ID_RESERV_DETAIL
              where  G_IN_R.ID_BASE_ACCOUNT = G.ID_BASE_ACCOUNT
                     and G_IN_R.CHECK_STATUS = 0
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_INTURN_BYACCOUNT') then begin
      select (select cast(count(G.ID_GUEST) as integer)
              from   GUEST G
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL and rd.IS_ANUL = 0
              where  G.ID_BASE_ACCOUNT = t.ID_BASE_ACCOUNT
                     and G.ID_GUEST <= t.ID_GUEST)
      from   TAR_CALC_INPUT$TMP t
      where  t.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'PAX_PRICE_WO_ADDINS') then begin
      /*             */
      /* PRICE_ORIG          */
      -- ?????    ???
      /*select  max(AP.PRICE_ORIG)
      from    ACCOUNT_POST AP 
      where   AP.ID_GUEST = :ID_GUEST
              and AP.DATE_POST = :FOR_DATE
              and AP.IS_BASE = 1
      plan    (AP index (ACCOUNT_POST_IDX6))
      into    :OUT_VALUE;
      */
      OUT_VALUE = null;

    end else if (:PARAM_CODE = 'ROOM_FEATURES') then begin
      select substring(R.FEATURES from 1 for 255)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join ROOMS R on r.ID_ROOM = tid.ID_ROOM
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_NIGHTS') then begin
      select (select cast(sum (G_IN_V.TO_DATE - G_IN_V.FROM_DATE) as integer)
              from   GUEST G_IN_V
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_V.ID_RESERV_DETAIL
              where  rd.ID_AGENT_PROFILE is not distinct from G.ID_AGENT_PROFILE
                     and G_IN_V.VAUCHER_NUM = G.VOUCHER_NUM
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE ;

    end else if (:PARAM_CODE = 'VAUCHER_GUESTS') then begin
      select (select count (G_IN_V.ID_GUEST)
              from   GUEST G_IN_V
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_V.ID_RESERV_DETAIL and rd.IS_ANUL = 0
              where  rd.ID_AGENT_PROFILE is not distinct from G.ID_AGENT_PROFILE
                     and G_IN_V.VAUCHER_NUM = G.VOUCHER_NUM
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_DATE') then begin
      select formatdate(G.VOUCHER_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_TEXT') then begin
      select G.VOUCHER_TEXT
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_INTURN_BYROOM') then begin
      select (select count(*)
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_GUEST <= t.ID_GUEST)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'ADULT_INTURN_BYROOM') then begin
      OUT_VALUE = 0;
      select (select count(*)
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_GUEST <= t.ID_GUEST
                     and ti.IS_CHILD = 0)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
             and t.IS_CHILD = 0
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'CHILD_INTURN_BYROOM') then begin
      OUT_VALUE = 0;
      select (select count(*)
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_GUEST <= t.ID_GUEST
                     and ti.IS_CHILD = 1)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
             and t.IS_CHILD = 1
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_TYPE') then begin
      select G.ID_GUEST_TYPE
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else begin
      exception RATING_EXCEPTION 'Unsupported param - '||:PARAM_CODE;
    end

  end /*PART OF INTERNAL PARAMS*/


  /**********************************************/
  begin
    /* the source of the next check is gone with the wind
    /* but we must distinguish different data types */
    if ((:OUT_VALUE is null) or (:OUT_VALUE = '')) then begin
      /*not allow nulls*/
      if (:DATA_TYPE = 'DATE') then OUT_VALUE = '01/01/1899';
      else OUT_VALUE = '-1';  -- Unspecified
    end else if (:DATA_TYPE = 'INTEGER') then begin
      OUT_VALUE = cast(:OUT_VALUE as integer);
      /* to prevent errors like OUT_VALUE = '00001' */
    end

    when any do exception RATING_EXCEPTION 'Unsupported param value: ' || :param_code || ' = "' || coalesce(:OUT_VALUE, '<null>') || '"';
  end
  /**********************************************/
end
^

/* Alter (TEST_DOC) */
ALTER PROCEDURE TEST_DOC(ID_ACCOUNT INTEGER,
DOC_SELECTED INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER)
 AS
declare variable is_dep_doc integer;
  declare variable id_hotel integer;
  declare variable dummy varchar(255);
begin
  is_dep_doc = 0;

  execute procedure DOCUMENT_INITIALIZE$DOC (:id_account, :doc_selected, null)
  returning_values (:id_doc_head, :id_hotel, :dummy);

  execute procedure DOCUMENT_ADD_DEF_PAYMENT$DOC (:id_doc_head, null);

  execute procedure DOCUMENT_VALIDATE$DOC (:id_doc_head)
  returning_values :dummy, :dummy, :dummy;
  suspend;
end
^

/* Alter (TEST_RATING) */
ALTER PROCEDURE TEST_RATING RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
declare variable from_date date;
 declare variable to_date date;
 declare variable hotels varchar(255);
begin
  from_date = '01.01.2010';
  to_date = '08.01.2010';
  hotels = '2';

  execute procedure AVAILABILITY_OCCUPANCY$INT (:from_date,  :from_date + 30, 1, 0, 1, 1, 0, 0, 0, :hotels);

  execute procedure AVAILABILITY_OCCUPANCY_OPT$INT (0, 0, 1, 1, 0, 0, 0);

  execute procedure AVAILABILITY_RATING$AVL (null, :from_date, :to_date, 2,
          2, 0, '33,31,55,30,32,54,62,59,71,72', '2301,2210,2347,1633,2300,2342,2353,2362', '6,0,8,7,22,21,23', :hotels)
  returning_values (:ID_OCCUPANCY_SESSION);

end
^

/* empty dependent procedure body */
/* Clear: IMPORT_BOOKING$EXC for: UPDATE_BOOKING$EXC */
ALTER PROCEDURE IMPORT_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(250),
MAINTANCE_SHEMA VARCHAR(30),
POSTING_ROUTING VARCHAR(20),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
COMPLIMENTARY_ACCOUNT VARCHAR(50),
EATING_OBJECT VARCHAR(50),
CREATE_DATETIME TIMESTAMP)
 RETURNS(HOTEL_ID INTEGER,
BOOKING_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (UPDATE_BOOKING$EXC) */
ALTER PROCEDURE UPDATE_BOOKING$EXC(BOOKING_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE INTEGER,
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA_ID INTEGER,
POSTING_ROUTING VARCHAR(20),
ID_AGENT_ACCOUNT INTEGER,
RATE_ID INTEGER,
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD_CODE TFOOD_CODE,
ARRANGER_PROFILE_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable hotel_id integer;
  declare variable warn_code integer;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable rd_dbkey char(8);
  declare variable current_status_code smallint;
BEGIN
  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => START(' || :booking_id || ')');

  select RD.RDB$DB_KEY, RD.ID_HOTEL, RD.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :booking_id
  into  :rd_dbkey, :hotel_id, :current_status_code;

  execute procedure update_posting_transaction$exc(:rd_dbkey, :posting_transaction_uuid, 0);

  /* lock all guests */
  update guest set ORPHANED_IMPORT$EXC=1 where id_reserv_detail=:booking_id;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_GUARANTEE$RSV');
  execute procedure RES_SAVE_GUARANTEE$RSV(
    :booking_id, :is_vip, :current_status_code, :id_guarantee_policy,
    :deposit_required, :deposit_required_currency, :block_cc,
    :guarantee_deposit_percent, :guarantee_deposit_nights, :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_STAY$RSV');
  execute procedure RES_SAVE_STAY$RSV(
    :booking_id, :arrival, :departure, :is_late_departure,
    :arrival_type, 0
  ) returning_values :share_err_code, :err_text, :share_transaction_id, :warn_code;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_BOARD$INT');
  execute procedure RES_SAVE_BOARD$INT(
    :rd_dbkey, :board_id
  ) ;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_OTHER$RSV');
  execute procedure RES_SAVE_OTHER$RSV(
    :booking_id, :transfer_in_time, :transfer_in_note,
    :transfer_out_time, transfer_out_note, :first_food_code
  ) ;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_ROOM$EXC(room_type_id=>' || coalesce(:room_type_id, '<null>') || ')');
  execute procedure RES_SAVE_ROOM$EXC(
    :rd_dbkey, :room_type_id, :maintance_shema_id, :room_preferences, :special_treatment, :split_on_checkin
  ) returning_values :err_text, :warn_code, :share_transaction_id, :share_err_code;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_MARKETING$RSV');
  execute procedure RES_SAVE_MARKETING$RSV(
    :booking_id, :marketing1_id, :marketing2_id, :marketing3_id, :marketing4_id, :marketing5_id
  ) returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_RATE$RSV(:rate_id=>'
  || coalesce(:rate_id, '<null>')
  || ', :booking_id=>' || coalesce(:booking_id, '<null>')
  || ', :manual_price=>' || coalesce(:manual_price, '<null>')
  || ', :manual_price_currency=>' || coalesce(:manual_price_currency, '<null>')
  || ', :is_different_rate=>' || coalesce(:is_different_rate, '<null>')
  || ')');
  execute procedure RES_SAVE_RATE$RSV(
    :booking_id, :rate_id, :manual_price, :manual_price_currency,
    :is_different_rate, :is_different_price, 0
  );

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_VOUCHER$RSV');
  execute procedure RES_SAVE_VOUCHER$RSV(
    :booking_id, :voucher, :voucher_date, :voucher_text, null,  null
  );

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_NOTE$RSV');
  execute procedure RES_SAVE_NOTE$RSV(
    :booking_id, :note, :note_reminders);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_ACCOUNTING$RSV(arranger_profile_id=>'
    || coalesce(:arranger_profile_id, '<null>')
    || ', posting_routing=>' || coalesce(:posting_routing, '<null>')
    || ', id_agent_account=>' || coalesce(:id_agent_account, '<null>')
    || ')');
  execute procedure RES_SAVE_ACCOUNTING$INT(
    :rd_dbkey, :arranger_profile_id,
    :id_agent_account,
    :posting_routing,
    :guest_payment_type_id,
    :arranger_payment_type_id,
    :reserv_group_id
  ) ;

  /*execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_PACKET$RSV');
  execute procedure RES_SAVE_PACKET$RSV(
    :booking_id, :packet_id, 0
  );
  */
  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_EATING_OBJECT$RSV');
  execute procedure RES_SAVE_EATING_OBJECT$RSV(:booking_id, :id_eating_object);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => END(' || :booking_id || ')');
END
^

/* Restore proc. body: ACCOUNT_BALANCE$INT */
ALTER PROCEDURE ACCOUNT_BALANCE$INT(ID_ACCOUNT INTEGER,
EW_INCL_ONLY SMALLINT = 0)
 RETURNS(ACCOUNT_CURR CHAR(3),
CURR_DISPLAY_FORMAT VARCHAR(10),
ACCOUNT_BALANCE NUMERIC(15,4),
POST_VALUE NUMERIC(15,4),
DEP_VALUE NUMERIC(15,4),
DEP_MONEY_BAG VARCHAR(255),
OPEN_CHARGES INTEGER)
 AS
declare variable dep_curr_value numeric(15,4);
  declare variable dep_curr varchar(3);
  declare variable round_to numeric(15,4);
  declare variable open_charges_int integer;
  declare variable cached_balances integer;
begin
  select A.ACCOUNT_CURR, C.ROUND_TO, C.DISPLAY_FORMAT
  from   ACCOUNT A
         join CURRS C on C.CURR = A.ACCOUNT_CURR
  where  A.ID_ACCOUNT = :id_account
  into   :account_curr, :round_to, :curr_display_format;

  account_balance = null;
  if (:EW_INCL_ONLY is distinct from 1) then begin
    select count(*),
           min(AC.ACCOUNT_BALANCE), min(AC.POST_VALUE), min(AC.DEP_VALUE),
           min(AC.DEP_MONEY_BAG), min(AC.OPEN_CHARGES)
    from   ACCOUNT_BALANCE_CACHE AC
    where  AC.ID_ACCOUNT = :id_account
    into   :cached_balances,
           :account_balance, :post_value, :dep_value, :dep_money_bag, :open_charges;
  
    if (:cached_balances <> 1) then account_balance = null;
  --    execute procedure ACCOUNT_BALANCE_INVALIDATE$INT (:id_account);
  end

  if (:account_balance is null) then begin
    account_balance = 0;
    post_value = 0;
    dep_value = 0;
    dep_money_bag = '';
    open_charges = 0;
    for
      select :POST_VALUE + round_f(AB.POST_BAL_VALUE, :round_to), :DEP_VALUE + round_f(AB.DEP_BAL_VALUE, :round_to),
             AB.DEP_ORIG_VALUE, AB.CURR_ORIG, AB.OPEN_CHARGES
      from   ACCOUNT_CURR_BALANCE$INT (:id_account, :account_curr, :ew_incl_only) AB
      into   :post_value, :dep_value, :dep_curr_value, :dep_curr, :open_charges_int
    do begin
      if (:open_charges_int = 1) then open_charges = 1;
      if (:dep_curr is not null and :dep_value > 0) then
        dep_money_bag = :dep_money_bag || formatfloat (:dep_curr_value, :curr_display_format) || ' ' || :dep_curr || ';';
    end
    account_balance = :post_value - :dep_value;

    if (:EW_INCL_ONLY is distinct from 1) then begin
      execute procedure ACCOUNT_BALANCE_CACHE$INT(:id_account, :account_balance, :post_value, :dep_value, :dep_money_bag, :open_charges);
    end
  end

  suspend;
end
^

/* Restore proc. body: ACCOUNT_DEBT_FILL$INT */
ALTER PROCEDURE ACCOUNT_DEBT_FILL$INT(ID_END_WORK INTEGER)
 AS
declare variable id_account_post integer;
  declare variable id_account integer;
  declare variable id_sale_taxation integer;
  declare variable is_primary_post integer;
  declare variable date_post date;
  declare variable id_service integer;
  declare variable revenue_group varchar(50);
  declare variable revenue_account varchar(50);
  declare variable revenue_sub_account varchar(50);
  declare variable curr_post varchar(3);
  declare variable post_amount double precision;
  declare variable nat_net_value numeric(15,4);
  declare variable nat_gross_value numeric(15,4);
  declare variable id_hotel integer;
  declare variable id_guest integer;
  declare variable ew_date date;
  declare variable post_type varchar(10);
  declare variable round_to numeric(15,4);
  declare variable qty_post tqty;
  declare variable rev_deduction_tax_value tprice;
  declare variable nat_round_to tprice;
begin
  select EW.PREV_DATE, EW.ID_HOTEL, c.ROUND_TO
  from   END_WORKS EW
         join HOTEL h on h.ID_HOTEL = ew.ID_HOTEL
         join CURRS  c on c.CURR = h.NATION_CURR
  where  EW.ID_END_WORK = :ID_END_WORK
  into   :EW_DATE, :ID_HOTEL, :nat_round_to;

  for
    select  AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_SALE_TAXATION, AP.DATE_POST,
            iif(AP.ID_ACCOUNT_POST = AP.SEQUENCE_ID, 1, 0), AP.ID_SERVICE, AP.ID_GUEST, AP.CURR_POST,
            S.REVENUE_GROUP, RA.REVENUE_ACCOUNT, RA.REVENUE_SUB_ACCOUNT, AP.POST_TYPE,
            sum(PRA.OUT_POST_AMOUNT), sum(PRA.OUT_POST_NET_VALUE), sum(PRA.OUT_POST_GROSS_VALUE),
            max(ap.QTY_POST)
    from    SERVICE_POSTING_REVENUE$INT (:ID_END_WORK) AP
            left outer join SERVICES S on S.ID_SERVICE = AP.ID_SERVICE
            left outer join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
            left outer join GUEST G on G.ID_GUEST = AP.ID_GUEST
            left outer join PROFILE_HOUSE PH on PH.ID_PROFILE = A.ID_PROFILE
            left outer join REVENUE_ACCOUNT_PARSE$INT (S.REVENUE_ACCOUNT, coalesce(G.ID_RESERV_DETAIL, A.ID_RESERV_DETAIL)) RA on 1=1
            left outer join ACCOUNT_POST_REVENUE_GET$INT (AP.POST_DBKEY, AP.QTY_POST * AP.PRICE_POST,
                            AP.POST_NET_VALUE, AP.POST_GROSS_VALUE,
                            S.REVENUE_GROUP, RA.REVENUE_ACCOUNT, RA.REVENUE_SUB_ACCOUNT) PRA on 1=1
    where   PH.HOUSE_TYPE is distinct from 'hptComplimentary'
    group by 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12
    union all
    select  DR.ID_ACCOUNT_POST, DR.ID_ACCOUNT, DR.ID_SALE_TAXATION, DR.DATE_POST,
            iif(DR.ID_ACCOUNT_POST is null , 1, 0), DR.ID_SERVICE, DR.ID_GUEST, DR.ACC_CURR,
            S.REVENUE_GROUP, RA.REVENUE_ACCOUNT, RA.REVENUE_SUB_ACCOUNT, DR.POST_TYPE,
            sum(DR.ACC_POST_AMOUNT), sum(DR.NET_VALUE), sum(DR.GROSS_VALUE),
            max(dr.QTY_POST)
    from    DOCUMENT_REVENUE DR
            left outer join SERVICES S on S.ID_SERVICE = DR.ID_SERVICE
            left outer join ACCOUNT A on A.ID_ACCOUNT = DR.ID_ACCOUNT
            left outer join GUEST G on G.ID_GUEST = DR.ID_GUEST
            left outer join PROFILE_HOUSE PH on PH.ID_PROFILE = A.ID_PROFILE
            left outer join REVENUE_ACCOUNT_PARSE$INT (S.REVENUE_ACCOUNT, coalesce(G.ID_RESERV_DETAIL, A.ID_RESERV_DETAIL)) RA on 1=1
    where   DR.DOC_DATE = :EW_DATE
            and DR.ID_HOTEL = :ID_HOTEL
            and PH.HOUSE_TYPE is distinct from 'hptComplimentary'
    group by 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12
--    order by 1 asc nulls last -- get postings and corrections first, ascending
    into   :id_account_post, :id_account, :id_sale_taxation, :date_post,
           :is_primary_post, :id_service, :id_guest, :curr_post,
           :revenue_group, :revenue_account, :revenue_sub_account, :post_type,
           :post_amount, :nat_net_value, :nat_gross_value, :qty_post
  do begin
    select c.ROUND_TO
    from   CURRS c
    where  c.CURR = :curr_post
    into   :round_to;

    if ((round_f (:post_amount, :round_to/10) <> 0) or (:nat_net_value <> 0) or (:nat_gross_value <> 0) ) then begin
      select sum(rd.TAX_AMOUNT)
      from   REVENUE_DEDUCTION_TAXES$INT (:nat_gross_value, iif(:is_primary_post = 1, :qty_post, 0), :nat_round_to, :id_sale_taxation) rd
      into   :rev_deduction_tax_value;

      insert into ACCOUNT_DEBT (ID_ACCOUNT, ID_SERVICE, ID_SALE_TAXATION, DEBT_DATE, POST_DATE, POST_CURR,
             POST_AMOUNT, NAT_NET_VALUE, NAT_GROSS_VALUE, ID_ACCOUNT_POST, IS_PRIMARY_POST, ID_GUEST,
             REVENUE_GROUP, REVENUE_ACCOUNT, REVENUE_SUB_ACCOUNT, POST_TYPE, ID_HOTEL,
             REVENUE_DEDUCTION_TAX_VALUE)
      values (:id_account, :id_service, :id_sale_taxation, :ew_date, :date_post, :curr_post,
             :post_amount, :nat_net_value, :nat_gross_value, :id_account_post, :is_primary_post, nullif(:id_guest, -1),
             :revenue_group, :revenue_account, :revenue_sub_account, :post_type, :id_hotel,
             :rev_deduction_tax_value);
    end
  end
end
^

/* Restore proc. body: ACCOUNT_POST_MODIFY$PMS */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
declare variable id_account integer;
  declare variable id_service integer;
  declare variable date_post date;
  declare variable is_owner_income smallint;
  declare variable is_account_post_item smallint;
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable no_use_id_acc_post integer;
  declare variable ap_dbkey char(8);
begin
  -- da se wika samo ot GUI
  if ( (:ID_ACCOUNT_POST is null) and (:ID_ACCOUNT_POST_PMS is null) ) then begin
    exception WRONG_PARAM_VALUE;
    exit;
  end

  is_account_post_item = iif(:id_account_post is not null, 1, 0);

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'mod, anul');

  if (:operation in ('mod', 'anul')) then begin
    -- prowerka: ot GUI-to mogat da se anulirat samo nedokumentirani i neanulirani nachisleniq
    if (:is_account_post_item = 1) then begin
      if ( (:ID_PMS_EVENT > 0) and
           not exists ( select *
                        from   PMS_EVENT_POST PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      select ap.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  ap.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
      into   :ap_dbkey;

      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_dbkey, 'PMS GUI VOID');

      update PMS_EVENT_POST PP
      set    PP.LINE_STATUS = 22
      where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST;

    end else if (:ID_ACCOUNT_POST_PMS is not null) then begin
      if ( not exists ( select *
                        from   ACCOUNT_POST$PMS PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      execute procedure ACCOUNT_POST_PMS_ANUL$INT(:ID_PMS_EVENT, :ID_ACCOUNT_POST_PMS);
    end

    if (:operation = 'mod') then begin
      id_account = null;
      if (:is_account_post_item = 1) then begin
        select AP.ID_ACCOUNT, AP.ID_SERVICE, AP.DATE_POST, PP.ID_OWNER, 0, ap.id_room
        from   ACCOUNT_POST AP
               join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and PP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :id_owner, :is_owner_income, :id_room;
      end else begin
        select AP.ID_ACCOUNT_PMS, AP.ID_SERVICE, AP.DATE_POST, AP.IS_OWNER_INCOME, AP.ID_OWNER
        from   ACCOUNT_POST$PMS AP
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
               and AP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :is_owner_income, :id_owner;
      end
      if (:id_account is null) then exit;

      execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_account, :id_service, :id_owner, :date_post,
              :in_curr_orig, :in_value_orig, 1 - :is_account_post_item, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* Restore proc. body: ACCOUNT_POSTING_ANUL */
ALTER PROCEDURE ACCOUNT_POSTING_ANUL(IN_ID_ACCOUNT_POST INTEGER,
IN_ANUL_REASON VARCHAR(70))
 AS
declare variable action_text varchar(255);
  declare variable id_account integer;
  declare variable qty_post numeric(15,2);
  declare variable price_post double precision;
  declare variable date_post date;
  declare variable id_service integer;
  declare variable curr_post varchar(3);
  declare variable ap_dbkey char(8);
begin
  /* called only from GUI - manual anullment */
  select AP.RDB$DB_KEY, AP.ID_ACCOUNT, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST
  from   ACCOUNT_POST AP
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :ap_dbkey, :id_account, :qty_post, :price_post,
         :date_post, :id_service, :curr_post;

  execute procedure ACCOUNT_POSTING_ANUL$INT (:ap_dbkey, :IN_ANUL_REASON);

  select S.SERVICE_NAME
  from   SERVICES S
  where  S.ID_SERVICE = :id_service
  into   :action_text;

  action_text = f_character(29) || :action_text
                || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:qty_post * :price_post, 'F;0.00') || ' ' || :curr_post
                || f_character(28) || f_replstr(:IN_ANUL_REASON, 'MANUAL', '');
  execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_ANUL', :action_text);
end
^

/* Restore proc. body: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER)
 AS
declare variable id_current_account integer;
  declare variable id_service integer;
  declare variable is_anul integer;
  declare variable id_tariff integer;
  declare variable qty_post numeric(15,2);
  declare variable qty_free numeric(15,2);
  declare variable price_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable id_room integer;
  declare variable id_base_doc integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  if ((:AP_DBKEY is null) or (:id_target_account is null) or (:id_target_account < 0)) then
     exception POSTING_TRANSFER_EXCEPTION '-31';

  select AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST, AP.QTY_FREE,
         AP.PRICE_ORIG, AP.CURR_ORIG, AP.RATE_ORIG, ap.from_date, ap.to_date,
         AP.IS_ANUL, AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_BASE_DOC, A.ID_HOTEL
  from   ACCOUNT_POST AP
         left join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :id_service, :id_tariff, :id_room, :qty_post, :qty_free,
         :price_orig, :curr_orig, :rate_orig, :from_date, :to_date,
         :is_anul, :id_account_post, :id_current_account, :id_base_doc, :id_hotel;

  if (:id_current_account = :id_target_account) then EXIT;

  if (:is_anul = 1 ) then exception POSTING_TRANSFER_EXCEPTION '-33';

  if (:id_base_doc is not null) then exception POSTING_TRANSFER_EXCEPTION '-32';

  if (not exists(select A.ID_ACCOUNT
                 from   ACCOUNT A
                 where  A.ID_ACCOUNT = :ID_TARGET_ACCOUNT
                        and A.ID_HOTEL = :id_hotel)) then exception POSTING_TRANSFER_EXCEPTION '-376';

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
                    :id_tariff, :id_room, :qty_post, :qty_free, :price_orig, :curr_orig,
                    :rate_orig, 'TRANSFER_POSTING', null, :from_date, :to_date, 0, :id_target_account)
  returning_values  :no_use, :no_use, :no_use;

  insert into ACCOUNT_TRANSFER_HISTORY(ID_ACCOUNT_POST, FROM_ID_ACCOUNT, TO_ID_ACCOUNT)
  values (:id_account_post, :id_current_account, :id_target_account);
end
^

/* Restore proc. body: ACCOUNT_POSTING_UPDATE */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable in_db_key char(8);
begin
  /* GUI facade for manual update */
  select AP.ID_ACCOUNT, AP.ID_GUEST, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :id_guest, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date)
  returning_values  (:new_qty_post, :new_price_post, :new_ac);

  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    if (coalesce(:id_guest, 0) > 0) then begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || :id_account
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'POST_UPDATE', :action_text);
    end else begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
    end
  end

end
^

/* Restore proc. body: ACCOUNT_POSTS_ON_DATE$RPT */
ALTER PROCEDURE ACCOUNT_POSTS_ON_DATE$RPT(ID_HOTEL INTEGER,
TO_DATE DATE,
INCL_CORR SMALLINT,
INCL_POSTS SMALLINT,
IN_ID_ACCOUNT INTEGER = null)
 RETURNS(POST_ID INTEGER,
ID_ACCOUNT INTEGER,
ID_GUEST INTEGER,
ROOM_NAME VARCHAR(20),
ID_SERVICE INTEGER,
ARISE_DATE DATE,
DATE_POST DATE,
IS_PRIMARY_POST SMALLINT,
POST_TYPE VARCHAR(10),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,4),
POST_NET_VALUE NUMERIC(15,4),
POST_GROSS_VALUE NUMERIC(15,4),
RATE_POST NUMERIC(15,6),
CURR_POST VARCHAR(3),
DATETIME_POST TIMESTAMP,
USER_NAME VARCHAR(30),
POST_REASON VARCHAR(30),
ID_VAT_GROUP INTEGER,
ID_ACCOUNT_POST INTEGER)
 AS
declare variable ID_EW integer;
begin
  select ew.ID_END_WORK
  from   END_WORKS EW
  where  EW.ID_HOTEL = :ID_HOTEL
         and ew.PREV_DATE = :to_date
         and ew.END_WORK_KIND = '3'
         and ew.PREV_DATE is distinct from ew.NEXT_DATE
  into   :id_ew;

  for
    select R.SEQUENCE_ID, R.ID_ACCOUNT, R.ID_GUEST, R.ROOM_NAME, R.ID_SERVICE,
           R.ARISE_DATE, R.DATE_POST, R.IS_PRIMARY_POST, R.POST_TYPE,
           R.QTY_POST, R.PRICE_POST, R.POST_NET_VALUE, R.POST_GROSS_VALUE, R.RATE_POST, R.CURR_POST,
           R.DATETIME_POST, R.USER_NAME, R.POST_REASON, R.ID_SALE_TAXATION, R.ID_ACCOUNT_POST
    from   SERVICE_POSTING_REVENUE$INT(:ID_EW) R
           left outer join ACCOUNT A on A.ID_ACCOUNT = R.ID_ACCOUNT
           left outer join PROFILE_HOUSE PH on PH.ID_PROFILE = A.ID_PROFILE
    where  PH.HOUSE_TYPE is distinct from 'hptComplimentary'
           and ((:IN_ID_ACCOUNT is null) or (R.ID_ACCOUNT = :IN_ID_ACCOUNT))
    into   :POST_ID, :ID_ACCOUNT, :ID_GUEST, :ROOM_NAME, ID_SERVICE,
           :ARISE_DATE, :DATE_POST, :IS_PRIMARY_POST, :POST_TYPE,
           :QTY_POST, :PRICE_POST, :POST_NET_VALUE, :POST_GROSS_VALUE, :RATE_POST, :CURR_POST,
           :DATETIME_POST, :USER_NAME, :POST_REASON, :ID_VAT_GROUP, :id_account_post
  do begin
    if ((:INCL_POSTS = 1 and :IS_PRIMARY_POST = 1)
        or (:INCL_CORR = 1 and :IS_PRIMARY_POST = 0)
       ) then suspend;
  end
end
^

/* Restore proc. body: APPLY_BOOKING_STATUS$EXC */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20)
 AS
declare variable err_text varchar(255);
declare variable dummy_int integer;
declare variable anul_reason varchar(30);
declare variable selection_id integer;

declare variable status_code smallint;
declare variable current_anul_code smallint;
declare variable current_status_code smallint;
declare variable current_status_text varchar(50);
declare variable new_status_text varchar(50);
declare variable extra_posts_left integer;
begin
  if (:booking_db_key is null) then begin
    select rd.RDB$DB_KEY, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.ID_RESERV_DETAIL = :BOOKING_ID
    into   :booking_db_key, :current_status_code, :current_anul_code;
  end else begin
    select rd.id_reserv_detail, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.rdb$db_key = :booking_db_key
    into   :booking_id, :current_status_code, :current_anul_code;
  end

  execute procedure IMPORT_BOOKING_STATUS$EXC(:status, -2)
  returning_values :status_code;

  execute procedure EXPORT_BOOKING_STATUS$EXC(:current_status_code, :current_anul_code)
  returning_values :current_status_text;
  execute procedure IMPORT_BOOKING_STATUS$EXC(:current_status_text, :current_status_code)
  returning_values :current_status_code;

  /* nop - exit */
  if (:current_status_code = :status_code) then exit;

  /* validate status transition */
  if (
     /* terminal status values - void booking */
    (:current_status_code in (1004/*no show*/, 1005/*canceled*/))

    /* void over checkin */
    or ((:current_status_code >= 0) and (:status_code in (1004/*no show*/, 1005/*canceled*/)))

    /* positive status downgrade */
    or ((:current_status_code > 0) and (:current_status_code > :status_code))
  )  then begin
    execute procedure PRINT_BOOKING_STATUS$EXC(:current_status_code) returning_values :current_status_text;
    execute procedure PRINT_BOOKING_STATUS$EXC(:status_code) returning_values :new_status_text;

    exception VALIDATE_EXCEPTION '-1022' || f_character(31) || '@{invalid_status_transition} ' || :current_status_text || ' -> ' || :new_status_text;
  end

  anul_reason = null;
  if (1004 = :status_code) then begin
    anul_reason = 'NOSHOW';
  end else if (1005 = :status_code) then begin
    anul_reason = 'CANCELED';
  end

  if (:anul_reason is null) then begin
    if (0 > :status_code) then begin
      execute procedure RES_SAVE_STATUS$INT(:booking_db_key, :status_code, :CONFIRMATION_NUMBER);
    end else begin
      if (:status_code in (0, 1) and 0 > :current_status_code) then begin
        -- checkin
        execute procedure RES_SET_CHECKIN$INT (:booking_db_key)
        returning_values (:dummy_int, :err_text, :dummy_int, :dummy_int);
      end
      if (1 = :status_code and 1 > :current_status_code) then begin
        -- checkout
        selection_id = gen_id(SELECTION_GEN, 1);
        update RESERV_DETAIL
        set    selection_id=:selection_id
        where  rdb$db_key=:booking_db_key;
    
        execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id);
      end
    end
  end else begin
    -- void
    execute procedure RES_ANUL_DETAIL$INT(:booking_db_key, :anul_reason, :CANCELATION_NUMBER)
    returning_values  :dummy_int, :extra_posts_left;
    if (:extra_posts_left = 1) then exception BOOKING_EXCEPTION '-1042';

  end
end
^

/* Restore proc. body: AR_OWING_ADD$AR */
ALTER PROCEDURE AR_OWING_ADD$AR(ID_PROFILE TYPE OF ID,
SUM_OWING TYPE OF TPRICE,
CURR_OWING TYPE OF TCURRENCY,
DUE_DATE TYPE OF TDATE,
SYSTEM_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
ID_AR_TYPE TYPE OF ID,
ID_HOTEL TYPE OF ID)
 RETURNS(NEW_ID_AR_OWING TYPE OF ID)
 AS
begin

  execute procedure AR_OWING_ADD$INT (:ID_PROFILE,
          :SUM_OWING, :CURR_OWING, null, :DUE_DATE,
          :SYSTEM_DATE, :DESCRIPTION, :ID_AR_TYPE, :ID_HOTEL)
  returning_values  (:NEW_ID_AR_OWING);

end
^

/* Restore proc. body: AR_OWING_ANUL$AR */
ALTER PROCEDURE AR_OWING_ANUL$AR(ID_AR_OWING TYPE OF ID,
DESCRIPTION TYPE OF TDESCRIPTION_LONG)
 RETURNS(NEW_ID_AR_OWING TYPE OF ID)
 AS
begin

  execute procedure AR_OWING_ANUL$INT (:ID_AR_OWING, :DESCRIPTION, 1)
  returning_values  (:NEW_ID_AR_OWING);

end
^

/* Restore proc. body: AVAILABILITY_OCCUP_PREPARE$AVL */
ALTER PROCEDURE AVAILABILITY_OCCUP_PREPARE$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS INTEGER,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
begin

  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, :FETCH_TOTALS, 1, 1, 1, 1, 1, 1, :HOTELS);
   
  execute procedure AVAILABILITY_OCCUPANCY_OPT$INT (:RELEASE_DATES, :OVERBOOK,
          :RES_CONFIRMED, :RES_NOTCONFIRMED, :RES_WAITING, :BOOKING_POSITIONS, :CONTINGENT);

end
^

/* Restore proc. body: AVAILABILITY_OCCUPANCY$AVL */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
begin

  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, :FETCH_TOTALS, 1, 1, 1, 1, 1, 1, :HOTELS);

  ID_OCCUPANCY_SESSION = current_transaction;
end
^

/* Restore proc. body: BLOCK_MODIFY$INT */
ALTER PROCEDURE BLOCK_MODIFY$INT(ID_BLOCK_ROOM INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
BLOCK_GRP INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_BLOCK_ROOM INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable b_dbkey char(8);
  declare variable edit_status varchar(255);
  declare variable old_id_room integer;
  declare variable min_affected_date date;
  declare variable old_from_date date;
  declare variable old_to_date date;
begin

  if (:block_grp not in (18, 20)) then exception BLOCK_EXCEPTION '-85' || f_character(31) || 'Unknown block type';

  if (:operation = 'add') then begin
    new_id_block_room = gen_id(ID_RESERV_DETAIL_GEN, 1);
    insert into BLOCK_ROOM (ID_BLOCK_ROOM, ID_ROOM, FROM_DATE, TO_DATE,
           BLOCK_GRP, REASON, NOTE)
    values (:new_id_block_room, :id_room, :from_date, :to_date,
           :block_grp, :reason, :note)
    returning RDB$DB_KEY into :b_dbkey;
    edit_status = 'JUST_CREATED';
    min_affected_date = :from_date;
  end else begin
    select BR.RDB$DB_KEY, BR.FROM_DATE, BR.TO_DATE, BR.ID_ROOM
    from   BLOCK_ROOM BR
    where  BR.ID_BLOCK_ROOM = :id_block_room
    into   :b_dbkey, :old_from_date, :old_to_date, :old_id_room;

    min_affected_date = null;
    if (:old_from_date <> :from_date) then min_affected_date = mindate(:old_from_date, :from_date);
    else if (:old_to_date <> :to_date) then min_affected_date = mindate(:old_to_date, :to_date) + 1;
    edit_status = iif(:min_affected_date is not null, 'DATE_CHANGED', '');
    if (:id_room <> :old_id_room) then edit_status = :edit_status || ',ROOM_CHANGED';

    update BLOCK_ROOM BRU
    set    BRU.ID_ROOM = :id_room,
           BRU.FROM_DATE = :from_date,
           BRU.TO_DATE = :to_date,
           BRU.BLOCK_GRP = :block_grp,
           BRU.REASON = :reason,
           BRU.NOTE = :note
    where  BRU.RDB$DB_KEY = :b_dbkey;

    new_id_block_room = :id_block_room;
  end

  execute procedure BLOCK_MODIFY_CONTROL$INT(:b_dbkey, :min_affected_date);

  execute procedure LIST_ITEM_MODIFY(:block_grp, null, :reason, 'add');

  ------------------------------------
  execute procedure OCCUPANCY_BLOCK$INT(:b_dbkey, :edit_status);

  execute procedure OCCUPANCY_ROOMS_CHECK$INT(:b_dbkey, :block_grp)
  returning_values  :share_err_code, :share_err_text, :share_transaction_id, :warn_code;

  execute procedure sys_dbg('occ BLOCK_MODIFY$INT share_err_code = '||coalesce(:share_err_code, 'null'));
  execute procedure sys_dbg('occ BLOCK_MODIFY$INT share_err_text = '||coalesce(:share_err_text, 'null'));
  execute procedure sys_dbg('occ BLOCK_MODIFY$INT share_transaction_id = '||coalesce(:share_transaction_id, 'null'));

  execute procedure RES_FINALIZE_CLEAR$INT(:b_dbkey, :new_id_block_room);
  --
  delete from RESERV_STAY$TMP t
  where  t.id_session = RDB$GET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION');
end
^

/* Restore proc. body: CLEAR_ORPHAN_GUESTS$EXC */
ALTER PROCEDURE CLEAR_ORPHAN_GUESTS$EXC(BOOKING_ID INTEGER)
 AS
declare variable guest_id integer;
  declare variable guest_uuid varchar(50);
begin

  for
    select g.id_guest, g.uuid
    from guest g
    where g.id_reserv_detail=:booking_id and g.orphaned_import$exc=1
    into :guest_id, :guest_uuid do
  begin
    execute procedure sys_dbg('exc CLEAR_ORPHAN_GUESTS$EXC - RES_GUEST_DEL$RSV(:guest_id=>' || coalesce(:guest_id, '<null>') || ', :guest_uuid=>' || coalesce(:guest_uuid, '<null>') || ')');

    execute procedure RES_GUEST_DEL$RSV(:guest_id);
  end
end
^

/* Restore proc. body: CONTRACT_EXPENSE_POST$INT */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT TYPE OF ID,
ID_HOTEL INTEGER,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
ID_OWNER TYPE OF ID,
OWNERSHIP_PERCENT TYPE OF TPERCENT,
ID_RENTAL_POOL TYPE OF ID_REF,
VALUE_ORIG TYPE OF TPRICE,
CURR_ORIG TYPE OF TCURRENCY,
POST_DATE TYPE OF TDATE,
STAY TYPE OF TCOUNT,
MAX_GUEST_CNT TYPE OF TCOUNT,
BED_NIGHT_CNT TYPE OF TCOUNT,
RESERVS TYPE OF TCOUNT)
 AS
declare variable service_price numeric(15,4);
  declare variable id_currency varchar(3);
  declare variable contract_expense_type varchar(50);
  declare variable id_account integer;
  declare variable post_value numeric(15,4);
  declare variable post_currency varchar(3);
  declare variable id_service integer;
  declare variable is_owner_income smallint;
  declare variable is_client_acc_post smallint;
  declare variable multiplier_type varchar(50);
  declare variable multiplier integer;
  declare variable id_room integer;
  declare variable use_shadow_account integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
begin
  is_owner_income = 0;
  use_shadow_account = iif(:SUB_CONTRACT = 'SHADOW_ACC', 1, 0);

  select r.ID_HOTEL
  from   PMS_EVENT$PMS p
         join ROOMS R on r.ID_ROOM = p.ID_ROOM
  where  p.ID_PMS_EVENT = :ID_PMS_EVENT
  into   :id_hotel;
-- CONTRACT_EXPENSE_TYPE in ( 'PERCENT', 'RUNNING_TOTAL_PERCENT', 'CURR_VALUE' )
-- MULTIPLIER_TYPE in ('RESERVATION', 'STAY', 'GUESTS', 'BED_NIGHTS')
  for
    select C.SERVICE_PRICE, C.ID_CURRENCY, C.CONTRACT_EXPENSE_TYPE, C.IS_ACC_POST_ITEM,
           C.ID_SERVICE, C.MULTIPLIER_TYPE
    from   CONTRACT_EXPENSE$PMS C
    where  C.ID_CONTRACT = :id_contract
           and c.SUB_CONTRACT = :SUB_CONTRACT
    order by C.ORDER_TAG asc
    into   :service_price, :id_currency, :contract_expense_type, :is_client_acc_post,
           :ID_SERVICE, :multiplier_type
  do begin

    execute procedure OWNER_ACCOUNT_GET$INT (coalesce(:ID_RENTAL_POOL,:ID_OWNER),
            :id_hotel, :use_shadow_account, :is_client_acc_post)
    returning_values (:id_account, :is_account$pms);

    multiplier = case
                   when :multiplier_type = 'RESERVATION' then iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'STAY' then :STAY
                   when :multiplier_type = 'GUESTS' then :MAX_GUEST_CNT * iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'BED_NIGHTS' then :BED_NIGHT_CNT
                   else null
                 end;

    if (:multiplier is not null) then begin
      if (:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE') then begin
        post_value = cast(:service_price as double precision) * :ownership_percent / 100 * :multiplier;
        post_currency = :id_currency;
      end else if (:CONTRACT_EXPENSE_TYPE = 'PERCENT') then begin
        post_value = :VALUE_ORIG * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end else if (:CONTRACT_EXPENSE_TYPE = 'RUNNING_TOTAL_PERCENT') then begin
        execute procedure PMS_RUNNING_TOTAL_GET(:ID_PMS_EVENT, coalesce(:ID_RENTAL_POOL,:ID_OWNER), :ID_HOTEL, :POST_DATE, :CURR_ORIG)
        returning_values :post_value;
        if (:post_value < 0) then post_value = 0;
    
        post_value = :post_value * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end

      select pe.ID_ROOM
      from   PMS_EVENT$PMS PE
      where  pe.ID_PMS_EVENT = :ID_PMS_EVENT
      into   :id_room;

      select c.ROUND_TO
      from   CURRS C
      where  c.CURR = :post_currency
      into   :round_to;

      execute procedure PMS_POSTING_CREATE$INT(:ID_PMS_EVENT, :id_account, :id_service, :ID_OWNER,
              :POST_DATE, :post_currency, round_f(:post_value, :round_to), :is_account$pms, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* Restore proc. body: CONTRACT_MANAGEMENT_POST$INT */
ALTER PROCEDURE CONTRACT_MANAGEMENT_POST$INT(ID_PMS_EVENT TYPE OF ID,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
CONTRACT_TYPE VARCHAR(30),
ID_OWNER TYPE OF ID,
ID_RENTAL_POOL TYPE OF ID_REF,
VALUE_ORIG TYPE OF TPRICE,
CURR_ORIG TYPE OF TCURRENCY,
POST_DATE TYPE OF TDATE,
STAY TYPE OF TCOUNT,
OWNERSHIP_PERCENT TYPE OF TPERCENT)
 RETURNS(POSTED_VALUE TYPE OF TPRICE,
POSTED_CURRENCY TYPE OF TCURRENCY)
 AS
declare variable night_price numeric(15,4);
  declare variable night_price_curr varchar(3);
  declare variable id_account integer;
  declare variable my_value numeric(15,4);
  declare variable my_currency varchar(3);
  declare variable id_service integer;
  declare variable do_post smallint;
  declare variable is_owner_income smallint;
  declare variable id_account_post_pms integer;
  declare variable use_shadow_account integer;
  declare variable id_hotel integer;
  declare variable is_account$pms integer;
  declare variable round_to numeric(15,4);
begin

  do_post = 0;
  posted_value = null;
  posted_currency = null;
  is_owner_income = 1;
  use_shadow_account = iif(:SUB_CONTRACT = 'SHADOW_ACC', 1, 0);

  select c.ROUND_TO
  from   CURRS c
  where  c.CURR = :curr_orig
  into   :round_to;

  /*select P.ID_ACCOUNT
  from   ACCOUNT$PMS P
  where  P.ID_OWNER = coalesce(:ID_RENTAL_POOL,:ID_OWNER)
         and P.IS_SHADOW = :use_shadow_account
         and P.IS_CLIENT_POOL_ACCOUNT = 0
  into   :id_account;*/
  select r.ID_HOTEL
  from   PMS_EVENT$PMS p
         join ROOMS R on R.ID_ROOM = p.ID_ROOM
  where  p.ID_PMS_EVENT = :ID_PMS_EVENT
  into   :id_hotel;

  execute procedure OWNER_ACCOUNT_GET$INT (coalesce(:ID_RENTAL_POOL,:ID_OWNER),
          :id_hotel, :use_shadow_account, 0)
  returning_values (:id_account, :is_account$pms);

  for
    select C.NIGHT_PRICE, C.NIGHT_PRICE_CURR, C.ID_SERVICE
    from   CONTRACT_MANAGEMENT$PMS C
    where  C.ID_CONTRACT = :id_contract
           and c.SUB_CONTRACT = :SUB_CONTRACT
    into   :night_price, :night_price_curr, :ID_SERVICE
  do begin
    if (:CONTRACT_TYPE = 'PRIVATE_USE' and :use_shadow_account = 0) then begin
      do_post = 0;
    end
    if (:CONTRACT_TYPE = 'TO_PRICE' and :use_shadow_account = 0) then begin
      my_value = :VALUE_ORIG;
      my_currency = :CURR_ORIG;
      do_post = 1;
    end
    if (:CONTRACT_TYPE = 'FIXED_PRICE' and :use_shadow_account = 0) then begin
      my_value = :night_price * :stay;
      my_currency = :night_price_curr;
      do_post = 1;
    end
    if (:CONTRACT_TYPE = 'GUARANTEE_INCOME_FIXED_PRICE' and :use_shadow_account = 1) then begin
      my_value = :night_price * :stay;
      my_currency = :night_price_curr;
      do_post = 1;
    end
    if (:CONTRACT_TYPE = 'GUARANTEE_INCOME_TO_PRICE' and :use_shadow_account = 1) then begin
      my_value = :VALUE_ORIG;
      my_currency = :CURR_ORIG;
      do_post = 1;
    end
    if (:CONTRACT_TYPE = 'TO_PRICE_FIXED_PRICE') then begin
      if (:use_shadow_account = 0) then begin
        my_value = :VALUE_ORIG;
        my_currency = :CURR_ORIG;
      end else if (:USE_SHADOW_ACCOUNT = 1) then begin
        my_value = :night_price * :stay;
        my_currency = :night_price_curr;
      end
      do_post = 1;
    end
    if (:CONTRACT_TYPE = 'FIXED_PRICE_TO_PRICE') then begin
      if (:use_shadow_account = 0) then begin
        my_value = :night_price * :stay;
        my_currency = :night_price_curr;
      end else if (:USE_SHADOW_ACCOUNT = 1) then begin
        my_value = :VALUE_ORIG;
        my_currency = :CURR_ORIG;
      end
      do_post = 1;
    end
  
    if (:do_post = 1 and :id_service is not null) then begin
      my_value = round_f(cast(:my_value as double precision) * :ownership_percent / 100, :round_to);
      execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account,
              :id_owner, :my_currency, :my_value, :id_service, :is_owner_income, :post_date)
      returning_values  (:id_account_post_pms);
      posted_value = :my_value;
      posted_currency = :my_currency;
    end
  end
end
^

/* Restore proc. body: CREATE_BOOKING$WBE */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
declare variable RATE varchar(50);
declare variable ROOM_TYPE varchar(20);
declare variable ARRIVAL date;
declare variable DEPARTURE date;
declare variable ADULTS integer;
declare variable CHILDREN integer;
declare variable PROFILE_NAME varchar(100);
declare variable ARANGER_NAME varchar(100);
declare variable GUEST_PROFILE_UUID varchar(40);
declare variable ARANGER_PROFILE_UUID varchar(40);
declare variable HOTEL_NAME varchar(50);
declare variable WBE_SESSION_ID bigint;
declare variable MAIN_GUEST_PROFILE_ID integer;
declare variable BOARD varchar(50);
declare variable HOTEL_ID integer;
declare variable GUARANTEE_POLICY_NAME varchar(50);
declare variable GUARANTEE_DEPOSIT_PERCENT numeric(15,4);
declare variable GUARANTEE_DEPOSIT_NIGHTS integer;
declare variable GUARANTEE_DUE_DAYS_BEF_ARRIVAL integer;
declare variable GUARANTEE_DUE_DAYS_AFTER_CREATE integer;
declare variable ERR_CODE integer;
declare variable ERR_TEXT varchar(255);
declare variable PROFILE_TYPE varchar(20);
declare variable PROFILE_IMPORT_TIME timestamp;
declare variable B_COUNT integer;
declare variable AGE integer;
declare variable IS_CHILD smallint;
declare variable GUEST_ID integer;
declare variable SPECIAL_TREATMENT varchar(250);
declare variable MAINTENANCE varchar(30);
declare variable ROUTING varchar(20);
declare variable ARRANGER_PAYMENY_TYPE varchar(20);
declare variable MARKET_SEGMENT varchar(30);
declare variable MARKET_SOURCE varchar(30);
declare variable MARKET_CHANNEL varchar(30);
declare variable MARKET_HEAR_REASON varchar(30);
declare variable MARKET_COME_REASON varchar(30);
declare variable FIRST_FOOD varchar(30);
declare variable BNOTE varchar(2000);
begin
  -- get wbe product selection
  select  PA.rate_name,PA.room_name, AQ.first_date, AQ.first_date+AQ.day_count,
          PS.adults, PS.children, PS.person_name, H.hotel_name, H.id_hotel,
          WS.id, PA.board_name, GP.name, GP.deposit_totalsum_part, GP.deposit_nights_count, GP.due_days_before_arrival, GP.due_days_after_create,
          PS.bnote
   from   PRODUCT_SELECTION$WBE PS
          join WBE_SESSION$WBE WS on WS.id = PS.wbe_session_id
          join PRODUCT_AVAILABILITY$WBE PA on pa.id = PS.product_availability_id
          join AVAILABILITY_QUERY$WBE AQ on aq.id = WS.product_query_id
          join HOTEL H on H.id_hotel = WS.hotel_id
          join GUARANTEE_POLICY GP on GP.id_guarantee_policy = PS.guarantee_policy_id
   where  PS.id = :product_selection_id
   into   :rate, :room_type, :arrival, :departure,
          :adults,  :children, :profile_name, :hotel_name, :hotel_id,
          :wbe_session_id, :board, :guarantee_policy_name,
          :guarantee_deposit_percent, :guarantee_deposit_nights,
          :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create,
          :bnote;

  select PA.uuid , PA.profile_name, PA.profile_type
  from   profile PA
  where  PA.id_profile = :aranger_profile_id
  into   :aranger_profile_uuid,:aranger_name,  :profile_type;

  if (:aranger_name = :profile_name and :profile_type = 'PERSON') then begin
    -- aranger is main guest
    select count(*) from PRODUCT_SELECTION$WBE PSC
        where PSC.wbe_session_id = :wbe_session_id
        into :b_count;
       -- only if single reservation bugfix 2228
    if (1 = :b_count) then begin
     guest_profile_uuid =  aranger_profile_uuid;
     aranger_profile_uuid = null;
    end
  end else begin
    -- create profile for main guest
    execute procedure IMPORT_PERSON_PROFILE$EXC(
      uuid_create(),:profile_name,null,null,null,null,null,null,null,null,null,null, null,
      null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
      null,null,null,null,null, null, null)
    returning_values :main_guest_profile_id, :profile_import_time;

    select P.uuid
    from   profile P
    where  P.id_profile = :main_guest_profile_id
    into   :guest_profile_uuid;
  end

    -- apply default map + forced arranger
    special_treatment = null;
    maintenance = null;
    routing = null;
    arranger_paymeny_type = null;
    market_segment = null;
    market_source = null;
    market_channel = null;
    market_hear_reason = null;
    market_come_reason = null;


  select hc.special_treatment,hk.plan_name,hc.routing,
        pt.payment_type, ms.segment_name,sc.description,cc.description,
        hr.description,cr.description,hc.first_food
  from  hotel_product_cfg$wbe hc
        left join hk_plan hk on hk.id_plan = hc.id_hk_plan
        left join payment_type pt on pt.id_payment_type = hc.arranger_id_payment_type
        left join nom_market_segments ms on ms.id_nom_market_segment = hc.id_m_segment
        left join nom_source_codes sc on sc.id_nom_source_code = hc.id_m_source
        left join nom_channel_codes cc on cc.id_nom_channel_code = hc.id_m_channel
        left join nom_hear_reasons hr on hr.id_nom_hear_reason = hc.id_m_hear_reason
        left join nom_come_reasons cr on cr.id_nom_come_reason = hc.id_m_come_reason
  where hc.hotel_id = :hotel_id
  into  :special_treatment,:maintenance,:routing,:arranger_paymeny_type,
        :market_segment,:market_source,:market_channel,:market_hear_reason,:market_come_reason,:first_food;
  -- create reseravation
  execute procedure IMPORT_BOOKING$EXC(
    :hotel_name, :number, null, null, 0,
    :arrival, null, :departure, null, null, null, null, null, :room_type, :board, null,
     :special_treatment, :maintenance, :routing, :rate, null, null, null, null, :arranger_paymeny_type, null, null, null, null,
     :market_segment, :market_source,:market_channel, :market_hear_reason, :market_come_reason,
     :bnote, null, :first_food, :adults, :children, :aranger_profile_uuid, null, :guest_profile_uuid,
     0, 0, null, :guarantee_policy_name, null, :guarantee_deposit_percent, :guarantee_deposit_nights,
     :guarantee_due_days_bef_arrival,  :guarantee_due_days_after_create, null, null, null, null,  null, null, null, null, null, null)
   returning_values
    :hotel_id ,
    :booking_id,
    :err_code,
    :err_text;

  if (0 <> :err_code) then exception wrong_value ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');

  -- import guests
  for select psg.guest_name,psg.is_child,psg.age from product_selection_guests$wbe psg
  where psg.product_selection_id = :product_selection_id
  into :profile_name,:is_child,:age
  do begin
    execute procedure import_guest$exc(:booking_id, null, null, :profile_name, :is_child, :age, null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null)
    returning_values :guest_id, :err_code,:err_text;
    if (0 <> :err_code) then exception wrong_value ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');
  end
  ----------------

  select RD.number_2
  from   reserv_detail RD
  where  RD.id_reserv_detail = :booking_id
  into   :number_2;

  update product_selection$wbe uPS
  set    uPS.booking_id = :booking_id, uPS.selection_id = :number_2
  where  uPS.id = :product_selection_id;
end
^

/* Restore proc. body: CREATE_SESSION_BOOKINGS$WBE */
ALTER PROCEDURE CREATE_SESSION_BOOKINGS$WBE(WBE_SESSION_ID BIGINT,
ARANGER_ID INTEGER,
LANG_CODE VARCHAR(3))
 RETURNS(SELECTION_ID VARCHAR(20),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable product_selection_id bigint;
declare variable next_num integer;
declare variable sel_cnt integer;
declare variable aranger_name varchar(100);
declare variable aranger_email varchar(50);
declare variable aranger_phone varchar(50);
declare variable booking_id integer;
declare variable record_timestamp timestamp;
declare variable new_res_number varchar(62);
declare variable room_types_src varchar(255) = '';
declare variable rates_src varchar(255) = '';
declare variable hotel_id integer;
declare variable profile_id integer;
declare variable from_date date;
declare variable to_date date;
declare variable day_count integer;
declare variable room_type_id integer;
declare variable rate_id integer;
declare variable query_id_tmp integer;
declare variable rooms_required integer;
declare variable rooms_available integer;
declare variable profile_import_time timestamp;
begin
  execute procedure EXPORT_LOG_FORCE$EXC(1);
  /* test overbook (multiuser) */
   for select ws.hotel_id,ws.profile,aq.first_date,(aq.first_date+aq.day_count)-1,pa.room_type_id,pa.rate_id,aq.day_count
    from   PRODUCT_availability$WBE PA
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    join availability_query$wbe aq on aq.id = pa.query_id
   where ws.id = :wbe_session_id and coalesce(pa.room_count,0) > 0
   into  :hotel_id, :profile_id, :from_date, :to_date, :room_type_id, :rate_id , :day_count
   do begin
       room_types_src = :room_types_src||','||cast(:room_type_id as varchar(10));
       rates_src = :rates_src||','||cast(rate_id as varchar(10));
   end

   query_id_tmp = GEN_ID(AVAILABILITY_QUERY$WBE_SEQ,1);
   insert into availability_query$wbe(ID, WBE_SESSION_ID, FIRST_DATE, DAY_COUNT)    -- prevent FK exception
    values (:query_id_tmp,:wbe_session_id,:from_date,:day_count) ;

   execute procedure availability_occup_small$wbe(:from_date,:to_date,:hotel_id,:query_id_tmp,1,:rates_src,:room_types_src) ;

   --  check minimum available rooms for every day
   err_code = null;
   err_text = '';
   for select pa.room_type_id,pa.room_count,
    (select coalesce(min(art.available_rooms),0) from availability_room_type$wbe art
      where art.query_id = :query_id_tmp and art.room_type_id = pa.room_type_id)
    from product_availability$wbe pa
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    where ws.id = :wbe_session_id
    and coalesce(pa.room_count,0) > 0   into :room_type_id,:rooms_required,:rooms_available
   do begin
       if (rooms_required > rooms_available) then
       begin
        err_code = 1;
        ERR_TEXT = coalesce(ERR_TEXT,'')||:room_type_id||';';
       end
   end
   delete from availability_query$wbe aqt where aqt.id = :query_id_tmp;       -- remove temp query
   if (err_code is not null) then exit;

  /* create profile if not exist and reservations > 1*/
  if (aranger_id is NULL) then
  begin
    select WS.person_name,WS.address,WS.phone
    from   WBE_SESSION$WBE WS
    where  WS.id = :wbe_session_id
    into   :aranger_name,:aranger_email,:aranger_phone;

    execute procedure IMPORT_PERSON_PROFILE$EXC(
       uuid_create(),:aranger_name,null,null,null,null,null,null,null,null,null,null,
       null,null,null,null,:aranger_phone,null,:aranger_email,null,null,null,null,null,null,
       STRHASH_LARGE(substring(uuid_create() from 1 for 4)),null,null,null,null,null,null,null,null, null, null)
    returning_values :aranger_id, :profile_import_time;

    update WBE_SESSION$WBE uWS
    set    uWS.profile = :aranger_id
    where  uWS.id = :wbe_session_id;
  end else begin
    -- da podmeni email, phone ako !!
  end
  /* create reservations */
  for
    select PS.id
    from   PRODUCT_SELECTION$WBE PS
    where  PS.wbe_session_id = :wbe_session_id
           and PS.booking_id is null
           and coalesce(PS.is_deleted,0) <> 1
    into   :product_selection_id
  do begin
     if (next_num = 1) then begin      -- increment first reservation number_3
      execute procedure res_number_suffix_gen(:booking_id) returning_values :new_res_number;
      next_num = next_num + 1;
     end
     execute procedure CREATE_BOOKING$WBE(:product_selection_id,:aranger_id,'WBE.'||:selection_id||'.'||:next_num) returning_values :booking_id,:selection_id;
     execute procedure IMPORT_BOOKING_FINALIZE$EXC(:booking_id) returning_values  record_timestamp,:err_code,:err_text;
     insert into SCHEDULER$WBE(booking_id,status,last_action_time,lang_code,guarantee_passed) values (:booking_id, NULL, current_timestamp, :lang_code,0);

     if (next_num is NULL) then begin
      next_num = 1;
     end else begin
      next_num = next_num + 1;
     end
  end
end
^

/* Restore proc. body: DEPOSIT_REFUND$DOC */
ALTER PROCEDURE DEPOSIT_REFUND$DOC(ID_DEPOSIT INTEGER,
REFUND_AMOUNT NUMERIC(15,4),
REFUND_CURRENCY VARCHAR(3),
ID_PAY_DOC_TYPE INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_REFUND_PAYMENT INTEGER,
ID_STORNO_DOC INTEGER,
WARN_CODE INTEGER)
 AS
declare variable no_use varchar(2000);
  declare variable id_account integer;
  declare variable avail_value numeric(15,4);
  declare variable id_doc_head integer;
  declare variable pay_currency varchar(3);
  declare variable pay_rate numeric(15,6);
  declare variable sys_date date;
  declare variable round_to numeric(15,4);
  declare variable p_dbkey char(8);
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable id_account_payment integer;
  declare variable id_doc_type integer;
  declare variable account_curr varchar(3);
  declare variable account_rate numeric(15,6);
  declare variable id_reserv_detail integer;
  declare variable is_posting_stopped integer;
  declare variable firm_data type of tnote_blob;
begin
  WARN_CODE = null;
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_REFUND');

  select D.ID_ACCOUNT, DH.ID_DOC, dh.ID_DOC_TYPE, c.ROUND_TO, d.ID_RESERV_DETAIL,
         D.AVAIL_VALUE, D.PAY_CURRENCY, D.PAY_RATE, A.ID_HOTEL, A.ACCOUNT_CURR
  from   DEPOSIT_AVAILABLE D
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join CURRS C on c.CURR = d.PAY_CURRENCY
         left outer join DOC_HEAD DH on DH.ID_DOC = D.ID_DOC_HEAD
                                        and DH.IS_STORNED = 0
                                        and DH.IS_ANUL = 0
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_account, :id_doc_head, :id_doc_type, :round_to, :id_reserv_detail,
         :avail_value, :pay_currency, :pay_rate, :id_hotel, :account_curr;

  if (:pay_currency is distinct from :refund_currency) then exception PAYMENT_EXCEPTION 'Currency mismatch!';

  if (round_f(:avail_value - :REFUND_AMOUNT, :round_to) < 0) then exception PAYMENT_EXCEPTION '-305';
  --'Issued value is more than available deposit amount.';

  select r.IS_POSTING_STOPPED
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :is_posting_stopped;

  if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';

  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET(:id_hotel) SD
  into   :sys_date;

  select first 1 ap.ACC_RATE
  from   ACCOUNT_PAYMENTS ap
  where  ap.ID_DEPOSIT = :ID_DEPOSIT
  order by ap.ID_ACCOUNT_PAYMENT asc
  into   :account_rate;

  execute procedure PAYMENT_CREATE$INT (:ID_PAY_DOC_TYPE, :ID_ACCOUNT, :SYS_DATE,
          -:REFUND_AMOUNT, :PAY_CURRENCY, :PAY_RATE, :account_curr, :account_rate, :DESCRIPTION)
  returning_values  (:id_refund_payment, :id_account_payment, :no_use);

  insert into DEPOSIT_REFUND (ID_DEPOSIT, ID_PAYMENT_HEAD, DESCRIPTION)
  values (:ID_DEPOSIT, :ID_REFUND_PAYMENT, :DESCRIPTION);

  update ACCOUNT_PAYMENTS AP
  set    AP.ID_DEPOSIT = :ID_DEPOSIT
  where  ap.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT;

  if (:ID_DOC_HEAD is not null) then begin
    execute procedure DOC_TYPE_EVALUATE$INT (:id_doc_type, :id_hotel, 0, :ID_REFUND_PAYMENT);

    execute procedure DOCUMENT_ADVANCE_STORNO$INT (:ID_DEPOSIT, :REFUND_AMOUNT, :DESCRIPTION)
    returning_values  (:ID_STORNO_DOC, :WARN_CODE);

    execute procedure DOCUMENT_ATTACH_PAYMENT$INT (:ID_STORNO_DOC, :id_account_payment, :pay_rate, null)
    returning_values :no_use;
     
    update  PAYMENT_HEAD P
    set     P.ID_DOC_HEAD = :ID_STORNO_DOC
    where   P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT;

    execute procedure DOCUMENT_VALIDATE$DOC (:ID_STORNO_DOC)
    returning_values (:firm_data, :no_use, :no_use);
  end else begin
    select P.RDB$DB_KEY
    from   PAYMENT_HEAD P
    where  P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT
    into   :P_DBKEY;
     
    execute procedure PAYMENT_SET_NUMBER$INT (:P_DBKEY);
  end

  action_text = F_CHARACTER(29) || :REFUND_AMOUNT || ' ' || :PAY_CURRENCY;
  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'REFUND', :ACTION_TEXT);
end
^

/* Restore proc. body: DEVICE_READING_POST$PMS */
ALTER PROCEDURE DEVICE_READING_POST$PMS(ID_DEVICE_READING TYPE OF ID)
 AS
declare variable id_service type of id_ref;
  declare variable post_value type of tprice;
  declare variable curr type of tcurrency;
  declare variable id_room type of id_ref;
  declare variable is_client_acc_post type of tlogical;
  declare variable date_post tdate;
  declare variable id_account_post id_ref;
  declare variable id_account_post$pms id_ref;
  declare variable id_device_reading_evidence id_ref;
  declare variable descr tdescription_long;
begin
  if(exists(select DR.ID_DEVICE_READING
            from   DEVICE_READING DR
            where  DR.ID_DEVICE_READING = :id_device_reading
                   and dr.status = 1)) then exception assert '-1051';
  for
    select CDC.ID_SERVICE,
           sum((CDC.QTY * cast(coalesce(CDC.UNIT_PRICE, 0) as double precision)) + coalesce(CDC.PRICE, 0)),
           CDC.CURR, D.ID_ROOM, CDC.IS_CLIENT_ACC_POST, DR.DATE_POST, DRQ.ID_DEVICE_READING_EVIDENCE,
           substring(list(coalesce(CDC.price || '+', '') || '(' || CDC.QTY || ' ' || coalesce(DT.MEASURE, '') || ' x '
                          || coalesce(CDC.UNIT_PRICE, 0) || ') ' || CDC.CURR) from 1 for 255)
    from DEVICE_READING DR
         join DEVICE_READING_EVIDENCE DRQ on DRQ.ID_DEVICE_READING = DR.ID_DEVICE_READING
         join DEVICE D on D.ID_DEVICE = DRQ.ID_DEVICE
         join DEVICE_TYPE DT on DT.ID_DEVICE_TYPE = D.ID_DEVICE_TYPE
         left outer join CREATE_DEVICE_CALC (D.ID_DEVICE_TYPE, DR.DATE_POST, DRQ.NEW_EVIDENCE - DRQ.OLD_EVIDENCE) CDC on 1=1
    where DR.ID_DEVICE_READING = :id_device_reading
    group by 1, 3, 4, 5, 6, 7
    into  :id_service, :post_value, :curr, :id_room, :is_client_acc_post, :date_post,
          :id_device_reading_evidence, :descr
  do begin
    if (coalesce(:post_value, -1) >= 0) then begin
      for
        select PEP.NEW_ID_ACCOUNT_POST, PEP.NEW_ID_ACCOUNT_POST$PMS
        from   PMS_EXPENSE_POSTS_CREATE$INT(:ID_ROOM, null, null, :ID_SERVICE, :CURR, :POST_VALUE,
                                            :IS_CLIENT_ACC_POST, :DATE_POST, :DESCR, 0) PEP
        into   :id_account_post, :id_account_post$pms
      do begin
        insert into DEVICE_READING_POST (ID_DEVICE_READING_EVIDENCE, ID_ACCOUNT_POST,
               ID_ACCOUNT_POST$PMS)
        values (:ID_DEVICE_READING_EVIDENCE, :ID_ACCOUNT_POST, :ID_ACCOUNT_POST$PMS);
      end
    end
  end
  update DEVICE_READING DR
  set    DR.STATUS = 1
  where  DR.ID_DEVICE_READING = :id_device_reading;
end
^

/* Restore proc. body: EAI_EXT_POST_TO_MH_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  if (:CODE_TYPE = 'EXT_CODE') then begin
    execute procedure EAI_MAP_SERVICE(:SERVICE_CODE, :SERVICE_CODE, 'UNKNOWN', :id_hotel)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_SERVICE;
    if (:ERR_CODE < 0) then exit;
  end else begin
    select S.ID_SERVICE
    from   SERVICES S
    where  S.ID_SERVICE = :SERVICE_CODE
           and s.ID_HOTEL = :ID_HOTEL
    into   :ID_SERVICE;
    if (:ID_SERVICE is null) then begin
      ERR_CODE = -85;   /* Wrong value! */
      exit;
    end
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Restore proc. body: EAI_EXT_SERVICE_POST */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable max_id_service integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_ROOM  = null;
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  select min(S.ID_SERVICE) as id_service, max(s.id_service) as max_id_service
  from   SERVICES S
  where  S.EXT_CODE = :SERVICE_EXT_CODE
         and s.IS_BASE = 0
         and s.IS_DELETED = 0
  into   :ID_SERVICE, :max_id_service;
  if (:ID_SERVICE is null) then begin
      ERR_CODE = -388;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end else if (:ID_SERVICE <> :max_id_service) then begin
      ERR_CODE = -389;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_EXT_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Restore proc. body: EAI_IMPORT_ALOYALTY_CLIENT */
ALTER PROCEDURE EAI_IMPORT_ALOYALTY_CLIENT(CLIENT_UUID VARCHAR(40),
CLIENT_NAME VARCHAR(100),
CARD_CODE VARCHAR(50),
IS_ARHIVE SMALLINT,
DATE_OF_BIRTH DATE)
 AS
declare variable PROFILE_ID integer;
  declare variable IMPORT_TIME timestamp;
begin
  execute procedure IMPORT_PERSON_PROFILE$EXC(:CLIENT_UUID, :CLIENT_NAME, null, :DATE_OF_BIRTH, null, null,
    null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null,
    :IS_ARHIVE, :CARD_CODE, null, null, null, null, null, null, null, null, null, null, 'null-uuid')
  returning_values :PROFILE_ID, :IMPORT_TIME;
end
^

/* Restore proc. body: EAI_POS_POSTING_ADD$P2E */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
declare variable id_service integer;
  declare variable my_post_text varchar(255);
  declare variable my_resource_text varchar(255);
  declare variable no_use integer;
  declare variable nation_curr varchar(3);
  declare variable post_short_code varchar(10);
  declare variable id_hotel integer;
begin
  /* in_on_guest = 0 (account), 1 (guest), -1 (ew)
  */
  if (:IN_ON_GUEST = 1) then begin
    select rd.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :IN_ID_GUEST
    into   :id_hotel;
  end else begin
    select a.ID_HOTEL
    from   account a
    where  a.ID_ACCOUNT = :in_id_account
    into   :id_hotel;
  end

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :nation_curr;

  if ('END_WORK' = :in_smetka_num) then begin
    post_short_code='POS_EW';
  end else begin
    post_short_code='POS';
  end

  /* FIND SERVICE */
  execute procedure EAI_MAP_SERVICE(:in_service_tag, :in_service_name, 'POS', :id_hotel)
  returning_values  :err_code, :err_text, :id_service;
  if (:err_code < 0) then exit;

  my_post_text = 'date:'|| formatdate(:in_date_smetka, 'D;dd.mm.yyyy') ||
                 ' num:'|| :in_smetka_num ||
                 ' obj:'|| :in_obj_name ||
                 ' tbl:'|| :in_table ||
                 ' site:'|| :in_site;

  my_resource_text = 'POS_ID_SMETKA:'||:in_id_smetka;
  my_post_text = substring(:my_post_text from 1 for 100);
  my_resource_text = substring(:my_resource_text from 1 for 49);

  if (:in_on_guest = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:in_id_guest, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code, '')
    returning_values  :err_code, :err_text, :out_id_account, :no_use;
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:in_id_account, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code)
    returning_values  :err_code, :err_text, :no_use;
    out_id_account = :in_id_account;
  end
end
^

/* Restore proc. body: EAI_RES_CHECK_OUT_FAST */
ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
declare variable selection_id integer;
  declare variable is_early_check_out smallint;
  declare variable early_check_out_dep_date date;
  declare variable check_out_date date;
begin
  selection_id = gen_id(selection_gen, 1);

  update RESERV_DETAIL RD
  set RD.SELECTION_ID = :SELECTION_ID
  where RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL;

  execute procedure RES_CHECK_OUT_CHECK$RSV(:selection_id)
  returning_values :is_early_check_out, :early_check_out_dep_date, :check_out_date;

  if (:is_early_check_out = 1) then
    exception BOOKING_EXCEPTION '-1043';

  execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id, 0);
end
^

/* Restore proc. body: EAI_TELECOUNT_TRANSFER */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* Restore proc. body: EXPORT_BOOKING$EXC */
ALTER PROCEDURE EXPORT_BOOKING$EXC(BOOKING_ID INTEGER)
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20,
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_ID INTEGER,
IS_GUEST_ARRANGER INTEGER,
POSTING_ROUTING VARCHAR(20),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IS_DIFFERENT_TARIFF SMALLINT,
IS_DIFFERENT_BOARD SMALLINT,
IS_CUSTOM_PRICE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
EXC_LOCAL_VERSION BIGINT,
EXC_REMOTE_VERSION BIGINT,
CREATE_DATETIME TIMESTAMP,
EATING_OBJECT VARCHAR(50))
 AS
declare variable arrival_type_code smallint;
BEGIN
  number = null;
  select h.hotel_name, b.number, bei.confirmation_number, bei.cancelation_number,
        bs.status, rg.id_reserv_group, rg.group_name, rg.uuid, b.is_vip, b.arrival_date, b.comming_kind,
        b.departure_date, b.is_late_departure, b.transfer_in_time, b.transfer_in_note,
        b.transfer_out_time, b.transfer_out_note, rt.type_room, board.name,
        b.room_features, b.i_special_treatment, hk.plan_name, r.tarifa_name, b.custom_price, b.custom_currency,
        b.deposit_required, b.deposit_required_currency, apt.payment_type, ppt.payment_type,
        b.voucher_num, b.voucher_date, b.voucher_text, ms.segment_name, sc.description,
        cc.description, hr.description, cr.description, b.note, b.note_reminders,
        b.code_first_food, ap.id_profile, isperson.id_profile as is_guest_arranger,
        b.acc_routing, b.is_different_room_type, b.is_different_stay_type, b.is_different_tariff,
        b.is_different_board, b.is_custom_price, b.is_different_price, bei.split_on_checkin,
        gp.name, b.block_cc, bei.guarantee_deposit_percent, bei.guarantee_deposit_nights,
        bei.guarantee_due_days_bef_arrival, bei.guarantee_due_days_after_create, bx.minibar_rights,
        bx.paytv_rights, bx.video_rights, bx.nopost_pms, bx.phone_rights, bx.seminar_cahnnel_rights,
        bei.posting_transaction_uuid, bei.exc_local_version, bei.exc_remote_version, bei.create_datetime,
        eo.name
  from  RES_LOAD(:booking_id) b
        join reserv_detail bei on bei.id_reserv_detail = :booking_id
        join HOTEL h on h.id_hotel = b.id_hotel
        join export_booking_status$exc(b.check_status, b.annul_status) bs on 1=1
        left outer join RESERV_GROUP RG on RG.ID_RESERV_GROUP = b.ID_GROUP
        join room_types rt on rt.id_room_type = b.id_res_room_type
        left outer join hk_plan hk on hk.id_plan = b.id_hk_plan
        join tarifa r on r.id_tarifa = b.id_tariff
        left outer join payment_type apt on apt.id_payment_type = b.id_agent_payment
        left outer join payment_type ppt on ppt.id_payment_type = b.id_person_payment
        left outer join nom_market_segments ms on ms.id_nom_market_segment = b.id_nom_market_segment
        left outer join nom_source_codes sc on sc.id_nom_source_code = b.id_nom_source_code
        left outer join nom_channel_codes cc on cc.id_nom_channel_code = b.id_nom_channel_code
        left outer join nom_hear_reasons hr on hr.id_nom_hear_reason = b.id_nom_hear_reason
        left outer join nom_come_reasons cr on cr.id_nom_come_reason = b.id_nom_come_reason
        left outer join profile ap on ap.id_profile = b.id_agent_profile
        left outer join profile_person isperson on isperson.id_profile = b.id_agent_profile
        left outer join meals board on board.ID_BOARD = bei.ID_BOARD
        left outer join guarantee_policy gp on gp.id_guarantee_policy=b.id_guarantee_policy
        left outer join reserv_detail_external bx on bx.id_reserv_detail = :booking_id
        left outer join eating_object eo on eo.id_eating_object = b.id_eating_object
  into  :hotel,
        :number,
        :confirmation_number,
        :cancelation_number,
        :status,
        :group_id,
        :group_name,
        :group_uuid,
        :is_vip,
        :arrival,
        :arrival_type_code,
        :departure,
        :is_late_departure,
        :transfer_in_time,
        :transfer_in_note,
        :transfer_out_time,
        :transfer_out_note,
        :room_type,
        :board,
        :room_preferences,
        :special_treatment,
        :maintance_shema,
        :rate,
        :manual_price,
        :manual_price_currency,
        :deposit_required,
        :deposit_required_currency,
        :arranger_payment_type,
        :guest_payment_type,
        :voucher,
        :voucher_date,
        :voucher_text,
        :marketing_segment,
        :marketing_source_code,
        :marketing_channel_code,
        :marketing_hear_reason,
        :marketing_come_reason,
        :note,
        :note_reminders,
        :first_food,
        :arranger_profile_id,
        :is_guest_arranger,
        :posting_routing,
        :is_different_room_type,
        :is_different_stay_type,
        :is_different_tariff,
        :is_different_board,
        :is_custom_price,
        :is_different_price,
        :split_on_checkin,
        :guarantee_policy,
        :block_cc,
        :guarantee_deposit_percent,
        :guarantee_deposit_nights,
        :guarantee_due_days_bef_arrival,
        :guarantee_due_days_after_create,
        :minibar_rights,
        :paytv_rights,
        :video_rights,
        :nopost_pms,
        :phone_rights,
        :seminar_cahnnel_rights,
        :posting_transaction_uuid,
        :exc_local_version,
        :exc_remote_version,
        :create_datetime,
        :eating_object
  ;

  if (:number is not null) then begin -- Check if we have export
    arrival_type = null;
    if (0 = :arrival_type_code) then begin
      arrival_type = 'early';
    end else if (2 = :arrival_type_code) then begin
      arrival_type = 'late';
    end
    suspend;
  end
END
^

/* Restore proc. body: EXT_PRATE_EXPORT_MAP_SET */
ALTER PROCEDURE EXT_PRATE_EXPORT_MAP_SET(ID_PRATE_MAP INTEGER,
MAX_ROOMS INTEGER,
IS_ACTIVE SMALLINT)
 AS
begin
  update or insert into EXT_PRATE_EXPORT_MAP (ID_PRATE_MAP, MAX_ROOMS, IS_ACTIVE)
  values (:ID_PRATE_MAP, :MAX_ROOMS, :IS_ACTIVE) matching (ID_PRATE_MAP);
end
^

/* Restore proc. body: EXT_PRATE_HOTEL_MAP_MODIFY */
ALTER PROCEDURE EXT_PRATE_HOTEL_MAP_MODIFY(ID_HOTEL INTEGER,
PRATE_ID_HOTEL VARCHAR(10),
USER_NAME VARCHAR(30),
"PASSWORD" VARCHAR(50),
IS_ACTIVE SMALLINT,
OPERATION VARCHAR(3))
 AS
declare variable ID_MAP integer;
begin
  if (OPERATION = 'set') then begin
    update or insert into EXT_PRATE_HOTEL_MAP (ID_HOTEL, PRATE_ID_HOTEL, USER_NAME, "PASSWORD", IS_ACTIVE)
    values (:ID_HOTEL, :PRATE_ID_HOTEL, :USER_NAME, :"PASSWORD", :IS_ACTIVE) matching (ID_HOTEL);
  end else if (OPERATION = 'del') then begin
    delete from EXT_PRATE_HOTEL_MAP
    where ID_HOTEL = :ID_HOTEL;
    execute procedure EXT_PRATE_MAP_MODIFY(null, :ID_HOTEL, null, null, null, null, null, 'clear')
    returning_values :ID_MAP;
  end
end
^

/* Restore proc. body: EXT_PRATE_MAP_MODIFY */
ALTER PROCEDURE EXT_PRATE_MAP_MODIFY(ID_PRATE_MAP INTEGER,
ID_HOTEL INTEGER,
ID_OBJECT VARCHAR(20),
OBJECT_TYPE VARCHAR(100),
EXTERNAL_CODE VARCHAR(10),
EXTERNAL_DESCRIPTION VARCHAR(50),
IS_EXPORT SMALLINT,
OPERATION VARCHAR(5))
 RETURNS(NEW_ID_PRATE_MAP INTEGER)
 AS
begin
  NEW_ID_PRATE_MAP = ID_PRATE_MAP;
  if (OPERATION = 'add') then begin
    NEW_ID_PRATE_MAP = gen_id(GEN_ID_PRATE_MAP, 1);
    insert into EXT_PRATE_MAP
      (ID_PRATE_MAP, ID_HOTEL, ID_OBJECT, OBJECT_TYPE, EXTERNAL_CODE, EXTERNAL_DESCRIPTION, IS_EXPORT)
    values
      (:NEW_ID_PRATE_MAP, :ID_HOTEL, :ID_OBJECT, :OBJECT_TYPE, :EXTERNAL_CODE, :EXTERNAL_DESCRIPTION, :IS_EXPORT);
  end else if (OPERATION = 'mod') then begin
    update EXT_PRATE_MAP pm
    set pm.ID_HOTEL = :ID_HOTEL,
        pm.ID_OBJECT = :ID_OBJECT,
        pm.OBJECT_TYPE = :OBJECT_TYPE,
        pm.EXTERNAL_CODE = :EXTERNAL_CODE,
        pm.EXTERNAL_DESCRIPTION = :EXTERNAL_DESCRIPTION,
        pm.IS_EXPORT = :IS_EXPORT
    where pm.ID_PRATE_MAP = :ID_PRATE_MAP;
  end else if (OPERATION = 'del') then begin
    delete from EXT_PRATE_MAP pm
      where pm.ID_PRATE_MAP = :ID_PRATE_MAP;
  end else if (OPERATION = 'clear') then begin
    delete from EXT_PRATE_MAP pm
      where pm.ID_HOTEL = :ID_HOTEL;
  end
end
^

/* Restore proc. body: IMPORT_BOOKING$EXC */
ALTER PROCEDURE IMPORT_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(250),
MAINTANCE_SHEMA VARCHAR(30),
POSTING_ROUTING VARCHAR(20),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
COMPLIMENTARY_ACCOUNT VARCHAR(50),
EATING_OBJECT VARCHAR(50),
CREATE_DATETIME TIMESTAMP)
 RETURNS(HOTEL_ID INTEGER,
BOOKING_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable current_hotel_id integer;
declare variable booking_update_id integer;
declare variable warn_code integer;
declare variable share_transaction_id integer;
declare variable share_err_code integer;
declare variable arranger_profile_id integer;
declare variable main_guest_profile_id integer;
declare variable rate_id integer;
declare variable room_type_id integer;
declare variable board_id integer;
declare variable maintance_shema_id integer;
declare variable arranger_payment_type_id integer;
declare variable guest_payment_type_id integer;
declare variable marketing_segment_id integer;
declare variable marketing_source_code_id integer;
declare variable marketing_channel_code_id integer;
declare variable marketing_hear_reason_id integer;
declare variable marketing_come_reason_id integer;
declare variable arranger_account_id integer;
declare variable packet_id integer;
declare variable id_guarantee_policy integer;
declare variable first_food_code tfood_code;
declare variable arrival_type_code smallint;
declare variable booking_dbkey char(8);
declare variable reserv_group_id integer;
declare variable id_complimentary_account integer;
declare variable id_eating_object integer;
begin
  /*execute procedure sys_dbg('exc IMPORT_BOOKING$EXC('
  || 'hotel => ' || coalesce(:hotel, '<null>')
  || ', booking_number => ' || coalesce(:number, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  ||')');
  */
  execute procedure import_mark_transaction$exc;

  /* init */
  err_code = 0;
  err_text = '';
  booking_update_id = null;
  booking_dbkey = null;
  current_hotel_id = null;
  if (:voucher_date is not null) then begin
    voucher_date = striptime(:voucher_date);
  end
  posting_routing = upper(:posting_routing);

  /* detect inser/update mode */
  select b.id_reserv_detail, b.rdb$db_key, b.id_hotel
  from   reserv_detail b
  where  b.number=:number
         and b.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and b.id_log_event_annul is null
  into   :booking_update_id, :booking_dbkey, :current_hotel_id;

  if (:booking_update_id is null) then begin
    booking_id = gen_id (id_reserv_detail_gen, 1);
  end else begin
    booking_id = :booking_update_id;
  end

  /* text to id map */
  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => MAP_BOOKING_RELATIONS$EXC');
  execute procedure MAP_BOOKING_RELATIONS$EXC(
    :booking_id,
    :hotel,
    :room_type,
    :board,
    :maintance_shema,
    :rate,
    :arranger_payment_type,
    :guest_payment_type,
    :marketing_segment,
    :marketing_source_code,
    :marketing_channel_code,
    :marketing_hear_reason,
    :marketing_come_reason,
    :first_food,
    :arranger_profile_uuid,
    :arranger_profile_name,
    :main_guest_profile_uuid,
    :arrival_type,
    :guarantee_policy,
    :eating_object
  ) returning_values
    :arranger_profile_id,
    :main_guest_profile_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :hotel_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :first_food_code,
    :arrival_type_code,
    :id_guarantee_policy,
    :id_eating_object;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* hotel change test */
  if (coalesce(:current_hotel_id, :hotel_id) <> :hotel_id) then begin
    execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', null, :hotel, 'booking hotel changed');
  end

  id_complimentary_account = null;
  if (complimentary_account is not null) then begin
    execute procedure lookup_account$exc(:hotel_id, :complimentary_account, 'booking', :booking_id)
    returning_values :id_complimentary_account;
  end

  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => CREATE_PACK_INSTANCE$EXC');
  packet_id = null;
  /*execute procedure CREATE_PACK_INSTANCE$EXC(
    :hotel_id, :booking_id, :package
  )
  returning_values :packet_id, :err_code, :err_text;
  if (0 <> :err_code) then exit;
  */
  /* merge input and default/persistent database values */
  execute procedure DEFAULT_BOOKING_VALUES$EXC(
    :booking_dbkey, :hotel_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :group_name,
    :group_uuid,
    :is_late_departure,
    :id_eating_object
  ) returning_values
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :arranger_account_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :reserv_group_id,
    :is_late_departure,
    :id_eating_object;

  if ('' = :board) then board_id = null; /* preserve "empty board" state and discard default value */

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC DEFAULTED => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* if the booking is complimentary use complimentary account */
  arranger_account_id = coalesce(:id_complimentary_account, :arranger_account_id);

  /* CREATE or UPDATE */
  if (:booking_update_id is not null) then begin
    /* UPDATE booking */
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => UPDATE_BOOKING$EXC');
    execute procedure UPDATE_BOOKING$EXC(
      :booking_id,
      :reserv_group_id,
      :is_vip,
      :arrival,
      :arrival_type_code,
      :departure,
      :is_late_departure,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :room_type_id,
      :board_id,
      :room_preferences,
      :special_treatment,
      :maintance_shema_id,
      :posting_routing,
      :arranger_account_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :deposit_required,
      :deposit_required_currency,
      :arranger_payment_type_id,
      :guest_payment_type_id,
      :voucher,
      :voucher_date,
      :voucher_text,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :note,
      :note_reminders,
      :first_food_code,
      :arranger_profile_id,
      :main_guest_profile_id,
      :is_different_rate,
      :is_different_price,
      :split_on_checkin,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object
    ) returning_values :err_code, :err_text;
    if (0 <> :err_code) then begin
      exit;
    end
  end else begin
    /* CREATE booking */
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => RES_CREATE_SET$EXC');
    execute procedure RES_CREATE_SET$EXC (
      :booking_id,
      :number,
      :arranger_profile_id,
      :main_guest_profile_id,
      :arrival,
      :departure,
      :adult_count,
      :children_count,
      :room_type_id,
      null,
      :board_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :voucher,
      :voucher_date,
      :voucher_text,
      null,
      null,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :arrival_type_code,
      :is_late_departure,
      :is_vip,
      :first_food_code,
      :special_treatment,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :arranger_account_id,
      :posting_routing,
      :guest_payment_type_id,
      :arranger_payment_type_id,
      null,
      :room_preferences,
      :maintance_shema_id,
      :note,
      :note_reminders,
      :deposit_required,
      :deposit_required_currency,
      :hotel_id,
      :reserv_group_id,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object,
      :create_datetime
      )
    returning_values :err_code, :err_text, :warn_code, :booking_id, :share_transaction_id, :share_err_code;
  end

  execute procedure GUEST_STAY_INITIALIZE$INT (:booking_id);
  /* final error check */
  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;

  delete from PENDING_DEPOSIT d
  where  d.ID_RESERV_DETAIL = :BOOKING_ID;
end
^

/* Restore proc. body: IMPORT_BOOKING_FINALIZE$EXC */
ALTER PROCEDURE IMPORT_BOOKING_FINALIZE$EXC(BOOKING_ID INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1,
STATUS VARCHAR(50) = null,
CONFIRMATION_NUMBER NAME_20 = null,
CANCELATION_NUMBER NAME_20 = null)
 RETURNS(RECORD_TIMESTAMP TIMESTAMP,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable booking_db_key char(8);
  declare variable dummy_int integer;
  declare variable dummy_text varchar(255) ;
  declare variable res_id_room integer;
  declare variable id_room integer;
  declare variable id_room_type integer;
  declare variable id_hotel integer;
  declare variable system_date date;
  declare variable from_date date;
  declare variable gs_dbkey char(8);
begin
  ERR_CODE=0;
  ERR_TEXT=null;
  id_room = null;
  force_res_finalize = coalesce(:force_res_finalize, 1);

  execute procedure sys_dbg('exc IMPORT_BOOKING_FINALIZE$EXC => CLEAR_ORPHAN_GUESTS$EXC');
  execute procedure CLEAR_ORPHAN_GUESTS$EXC(:booking_id);

  select b.rdb$db_key, b.ID_ROOM, b.ID_ROOM_TYPE, b.ID_HOTEL, b.FROM_DATE
  from   reserv_detail b
  where  b.id_reserv_detail = :booking_id
  into   :booking_db_key, :res_id_room, :id_room_type, :id_hotel, :from_date;

  execute procedure RES_GUEST_SAVE_DIFF$INT(:booking_db_key);

  if (:res_id_room < 0) then begin
    select sd.SYSTEM_DATE
    from   SYSTEM_DATE_GET (:id_hotel) sd
    into   :system_date;

    select ro.ID_ROOM, ro.ID_ROOM_TYPE
    from   RES_OCCUPANCY_ROOM$INT (:BOOKING_ID, maxdate(:system_date, :from_date), null, :id_room_type) ro
    into   :id_room, :id_room_type;

--    has_different_room_type = null;
    if (:id_room <> :res_id_room) then begin
      for
        select gs.RDB$DB_KEY
        from   GUEST_STAY GS
               join GUEST G on g.ID_GUEST = gs.ID_GUEST
        where  g.ID_RESERV_DETAIL = :BOOKING_ID
               and gs.FOR_DATE >= maxdate(:system_date, :from_date)
               and gs.ID_ROOM <> :id_room
        into   :gs_dbkey
      do begin
        update GUEST_STAY gsu
        set    gsu.ID_ROOM = :id_room
               --gsu.ID_ROOM_TYPE = iif (gsu.ID_ROOM_TYPE = -1, :id_room_type, gsu.ID_ROOM_TYPE)
        where  gsu.RDB$DB_KEY = :gs_dbkey;
        --has_different_room_type = 1;
      end

      update GUEST G
      set    G.ID_ROOM = :id_room
      where  g.ID_RESERV_DETAIL = :BOOKING_ID;
    end
  end

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null,   --force recalculation
         rd.ID_ROOM = coalesce(:id_room, :res_id_room)
         --rd.HAS_DIFFERENT_ROOM_TYPE = coalesce(:has_different_room_type,  rd.HAS_DIFFERENT_ROOM_TYPE)
  where  rd.RDB$DB_KEY = :booking_db_key;

  if (1 = :force_res_finalize) then begin
    execute procedure sys_dbg('exc IMPORT_BOOKING_FINALIZE$EXC => RES_FINALIZE_SHAREOPTION$INT');
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:booking_db_key, 0)
    returning_values  :dummy_int, :dummy_text, :dummy_int, :dummy_int;
  end

  execute procedure APPLY_BOOKING_STATUS$EXC(
    null, :booking_db_key, :status, :confirmation_number, :cancelation_number
  );

  select b.change_time
  from   reserv_detail b
  where  b.rdb$db_key =:booking_db_key
  into   :record_timestamp;
end
^

/* Restore proc. body: IMPORT_NOM_CHANNEL_CODE$EXC */
ALTER PROCEDURE IMPORT_NOM_CHANNEL_CODE$EXC(CODE VARCHAR(3),
DESCRIPTION VARCHAR(30),
UUID VARCHAR(40))
 RETURNS(ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable OPERATION VARCHAR(3);
begin
  ID = null;
  ERR_CODE = 0;
  ERR_TEXT = '';
  
  execute procedure sys_dbg(
  'exc IMPORT_NOM_CHANNEL_CODE$EXC(:CODE=>' || coalesce(:CODE, '<null>')
    || ', :DESCRIPTION=>' || coalesce(:DESCRIPTION, '<null>')
    || ', :UUID=>' || coalesce(:UUID, '<null>')
  || ')');

  select cc.ID_NOM_CHANNEL_CODE
  from NOM_CHANNEL_CODES cc
  where cc.UUID = :UUID and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :ID;

  OPERATION = 'mod';
  if (ID is null) then begin
    OPERATION = 'add';
  end

  execute procedure NOM_MODIFY_CHANNEL_CODES(:ID,  :CODE, :DESCRIPTION, :OPERATION)
  returning_values :ID, :ERR_CODE, :ERR_TEXT;

  update NOM_CHANNEL_CODES cc
    set cc.UUID = :UUID
    where cc.ID_NOM_CHANNEL_CODE = :ID;
end
^

/* Restore proc. body: LOG_ID_LOOKUP_ERROR$EXC */
ALTER PROCEDURE LOG_ID_LOOKUP_ERROR$EXC(OBJECT_ID VARCHAR(100),
OBJECT_TYPE VARCHAR(100),
LOOKUP_VALUE INTEGER,
LOOKUP_KEY VARCHAR(255),
LOOKUP_TYPE VARCHAR(255))
 AS
begin
  execute procedure sys_dbg(
    'exc LOG_ID_LOOKUP_ERROR$EXC(:object_id=>' || coalesce(:OBJECT_ID, '<null>')
    || ', :object_type=>' || coalesce(:OBJECT_TYPE, '<null>')
    || ', :lookup_key=>' || coalesce(:LOOKUP_KEY, '<null>')
    || ', :lookup_value=>' || coalesce(:LOOKUP_VALUE, '<null>')
    || ', :lookup_type=>' || coalesce(:LOOKUP_TYPE, '<null>')
   || ')');
  if (:LOOKUP_VALUE is not null) then begin
    exit;
  end
  if ((:LOOKUP_KEY is null) or ('' = :LOOKUP_KEY))  then begin
    exit;
  end

  if (:OBJECT_TYPE = 'BOOKING') then begin
    execute procedure RES_FINALIZE_ERRHANDLING$INT(
      :OBJECT_ID, -1019, coalesce(:LOOKUP_TYPE || ': ',  '') || :LOOKUP_KEY, 'IMPORT', 1);
  end else begin
    insert into IMPORT_LOOKUP_ERRORS$TMP(ERROR_ID, OBJECT_TYPE, OBJECT_ID, LOOKUP_KEY, ERR_CODE, ERR_TEXT)
    values (gen_id(GEN_IMPORT_LOOKUP_ERROR_ID, 1), :OBJECT_TYPE, :OBJECT_ID, :LOOKUP_KEY, -1019, :LOOKUP_TYPE);
  end
end
^

/* Restore proc. body: OCCUPANCY_SHARES_COMPLETE$INT */
ALTER PROCEDURE OCCUPANCY_SHARES_COMPLETE$INT(ID_OCCUPANT INTEGER)
 RETURNS(NEW_SHARES_ARISE INTEGER,
SHARE_MARK_TRANSACTION INTEGER)
 AS
declare variable id_room integer;
declare variable rm_dbkey char(8);
declare variable share_date date;
declare variable found_reservaions integer;
declare variable existent_share integer;
declare variable tmp_res_detail integer;
declare variable has_share integer;
begin
  /* -- SHARES detection and clean section --*/
  has_share = 0;
  new_shares_arise = 0;
  execute procedure OCCUPANCY_GET_TRANSACTION$INT
  returning_values (:share_mark_transaction);

  /* -- we check old stay and rooms + new stay and rooms and will regenerate shares --*/
  for
    select distinct trs.for_date, trs.id_room
    from   RESERV_STAY$TMP trs
    where  trs.id_session = :share_mark_transaction
    union
    select rm.busy_date, rm.id_room
    from   ROOM_MAGIC rm
    where  rm.id_reserv_detail = :id_occupant
           and RM.DAY_ACTION not containing 'CHECK_OUT'
    into   :share_date, :id_room
  do begin
    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT Now will check share status.......... :'|| :share_date || ' ID_ROOM =' || :id_room);
    /* Count reservations for this date and room*/
    for
      select RM.BUSY_DATE, count(distinct RM.ID_RESERV_DETAIL)
      from   ROOM_MAGIC RM
      where  RM.BUSY_DATE = :share_date
             and RM.ID_ROOM = :id_room
             and RM.DAY_ACTION not containing 'CHECK_OUT' -- exclude 'CHECK_OUT' and 'CHEKC_IN,CHECK_OUT' day actions
      group by 1
      into   :share_date, :found_reservaions
    do begin
      if (:found_reservaions > 1) then begin
        has_share = 1;
        /* CREATE/UPDATE SHARES */
        for
          select RM.RDB$DB_KEY, RM.ID_RESERV_DETAIL
          from   ROOM_MAGIC RM
          where  RM.BUSY_DATE = :share_date
                 and RM.ID_ROOM = :id_room
                 and RM.DAY_ACTION not containing 'CHECK_OUT' -- exclude 'CHECK_OUT' and 'CHEKC_IN,CHECK_OUT' day actions
          into   :rm_dbkey, :tmp_res_detail
        do begin
          execute procedure ROOM_SHARE$INT(:rm_dbkey, :share_mark_transaction)
          returning_values  :existent_share;

          if (:existent_share = 0 and :tmp_res_detail <> :id_occupant) then new_shares_arise = 1;
        end
      end else begin
        /* CLEAN SHARES IF ANY */
        update ROOMS_SHARE RS
        set    RS.IS_EX_SHARE = 1,
               RS.MARK_TRANSACTION = :share_mark_transaction
        where  RS.BUSY_DATE = :share_date
               and RS.ID_ROOM = :id_room;
      end
    end
  end

  if (:has_share = 0) then SHARE_MARK_TRANSACTION = null;
end
^

/* Restore proc. body: OWNER_BILL_MODIFY$PMS */
ALTER PROCEDURE OWNER_BILL_MODIFY$PMS(ID_OWNER_BILL INTEGER,
ID_OWNER INTEGER,
BILLING_DATE DATE,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_OWNER_BILL INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_anul smallint;
  declare variable bill_num integer;
  declare variable id_account_post_pms integer;
  declare variable id_account_post integer;
  declare variable prev_id_owner_bill integer;
  declare variable prev_billing_date date;

  declare variable id_account integer;
  declare variable id_account_pms integer;
  declare variable value_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable value_post numeric(15,4);
  declare variable curr_post varchar(3);
  declare variable is_owner_income smallint;
  declare variable id_service integer;
  declare variable id_room integer;
  declare variable date_post date;
  declare variable id_reserv_detail integer;
  declare variable doc_description varchar(255);
  declare variable id_doc_head integer;
  declare variable description varchar(255);
  declare variable id_pms_event integer;
  declare variable is_client_account_post smallint;
begin
  err_code = 0;
  err_text = '';
  is_client_account_post = null;
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'create, anul');

  if ( exists ( select *
                from   OWNER$PMS O
                where  O.ID_OWNER = :ID_OWNER
                       and O.ID_RENTAL_POOL_UNIT is not null ) ) then
  begin
    exception PMS_EXCEPTION 'selected owner is pool!';
  end

  if (:operation = 'create') then begin
    is_anul = 0;

    if ( (:ID_OWNER_BILL is null) or (:ID_OWNER_BILL <= 0) )  then
      NEW_ID_OWNER_BILL = gen_id(GEN_OWNER_BILL$PMS_ID, 1);
    else
      NEW_ID_OWNER_BILL = :ID_OWNER_BILL;

    BILL_NUM = :NEW_ID_OWNER_BILL;
    insert into OWNER_BILL$PMS (ID_OWNER_BILL, ID_OWNER, BILL_DATE, IS_ANUL, BILL_NUM,
           IS_EXPORTED_TO_INTRANET, IS_POOL_DISTRIBUTION_STATEMENT)
    values (:NEW_ID_OWNER_BILL, :ID_OWNER, :BILLING_DATE, :IS_ANUL, :BILL_NUM, 0, 0);

    update OWNER$PMS O
    set    O.LAST_BILLING_DATE = :billing_date,
           O.ID_OWNER_BILL = :NEW_ID_OWNER_BILL
    where  O.ID_OWNER = :ID_OWNER;

    for
    /*  select ID_ACCOUNT_POST, ID_ACCOUNT_POST_PMS
      from   PMS_ACC_POST_TO_BILL_GET$INT(:ID_OWNER, null, '01.01.1500', :BILLING_DATE, 1)
      into   :ID_ACCOUNT_POST, :ID_ACCOUNT_POST_PMS */
      select   OP.ID_ACCOUNT_POST, OP.ID_ACCOUNT_POST$PMS
      from     OWNER_POST OP
      where    OP.ID_OWNER = :id_owner
               and OP.POST_DATE between cast('01.01.1500' as date) and :billing_date
               and OP.IS_ANUL = 0
      order by OP.ID_ACCOUNT_POST$PMS nulls last
      into     :ID_ACCOUNT_POST, :ID_ACCOUNT_POST_PMS
    do begin
      if (:id_account_post_pms is not null) then begin

        update ACCOUNT_POST$PMS A
        set    A.LINE_STATUS = 21
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS;

        id_account = null;
        select ACC.ID_SERVICE, ACC.VALUE_ORIG, ACC.CURR_ORIG, ACC.VALUE_POST, ACC.CURR_POST,
               ACC.IS_OWNER_INCOME, ACC.DATE_POST, ACC.ID_ACCOUNT_PMS, E.ID_ROOM,
               E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION, A.IS_CLIENT_POOL_ACCOUNT
        from   ACCOUNT_POST$PMS ACC
               join ACCOUNT$PMS A on A.ID_ACCOUNT = ACC.ID_ACCOUNT_PMS
               join PMS_EVENT$PMS E on E.ID_PMS_EVENT = ACC.ID_PMS_EVENT
        where  ACC.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
        into   :ID_SERVICE, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
               :IS_OWNER_INCOME, :DATE_POST, :ID_ACCOUNT_PMS, :ID_ROOM,
               :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION, :is_client_account_post;
      end

      if (:id_account_post is not null) then begin
        exception PMS_EXCEPTION '-613';
          
        is_client_account_post = 1;
        update PMS_EVENT_POST A
        set    A.LINE_STATUS = 21
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST;

        id_account_pms = null;
        select ACC.ID_SERVICE, ACC.PRICE_ORIG, ACC.CURR_ORIG, ACC.PRICE_POST, ACC.CURR_POST,
               0, ACC.DATE_POST, ACC.ID_ACCOUNT, E.ID_ROOM,
               E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION
        from   ACCOUNT_POST ACC
               join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = ACC.ID_ACCOUNT_POST
               join PMS_EVENT$PMS E on E.ID_PMS_EVENT = PP.ID_PMS_EVENT
        where  ACC.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
        into   :ID_SERVICE, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
               :IS_OWNER_INCOME, :DATE_POST, :ID_ACCOUNT, :ID_ROOM,
               :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION;
      end

      insert into OWNER_BILL_ROW$PMS (ID_OWNER_BILL, ID_ACCOUNT_POST,
             ID_ACCOUNT, ID_ACCOUNT_POST_PMS, ID_ACCOUNT_PMS, ID_SERVICE, VALUE_ORIG,
             CURR_ORIG, VALUE_POST, CURR_POST, IS_OWNER_INCOME, ID_ROOM, DATE_POST,
             ID_RESERV_DETAIL, DOC_DESCRIPTION, ID_DOC_HEAD, DESCRIPTION, IS_CLIENT_ACCOUNT_POST)
      values (:new_id_owner_bill, :ID_ACCOUNT_POST, :ID_ACCOUNT,
             :ID_ACCOUNT_POST_PMS, :ID_ACCOUNT_PMS, :ID_SERVICE, :VALUE_ORIG,
             :CURR_ORIG, :VALUE_POST, :CURR_POST, :IS_OWNER_INCOME, :ID_ROOM, :DATE_POST,
             :ID_RESERV_DETAIL, :DOC_DESCRIPTION, :ID_DOC_HEAD, :DESCRIPTION, :is_client_account_post);
    end
  end
  if (:operation = 'anul') then begin
    select O.ID_OWNER, O.IS_ANUL
    from   OWNER_BILL$PMS O
    where  O.ID_OWNER_BILL = :ID_OWNER_BILL
    into   :id_owner, :is_anul;
    if (:is_anul = 1) then exit;

    select first 1 B.ID_OWNER_BILL
    from   OWNER_BILL$PMS B
    where  B.ID_OWNER = :id_owner
           and B.IS_ANUL = 0
    order by B.BILL_DATE desc
    into   :prev_id_owner_bill;
    if (:prev_id_owner_bill <> :id_owner_bill) then exception PMS_EXCEPTION '-619';

    select first 1 O.ID_OWNER_BILL, O.BILL_DATE
    from   OWNER_BILL$PMS O
    where  O.ID_OWNER = :ID_OWNER
           and o.IS_ANUL = 0
           and O.ID_OWNER_BILL <> :ID_OWNER_BILL
    order by O.BILL_DATE desc
    into   :prev_id_owner_bill, :prev_billing_date;

    update OWNER$PMS O
    set    O.LAST_BILLING_DATE = :prev_billing_date,
           O.ID_OWNER_BILL = :prev_id_owner_bill
    where  O.ID_OWNER = :ID_OWNER;

    update OWNER_BILL$PMS B
    set    B.IS_EXPORTED_TO_INTRANET = 0,
           B.IS_ANUL = 1
    where  B.ID_OWNER_BILL = :ID_OWNER_BILL;

    for
      select O.ID_ACCOUNT_POST, O.ID_ACCOUNT_POST_PMS
      from   OWNER_BILL_ROW$PMS O
      where  O.ID_OWNER_BILL = :ID_OWNER_BILL
      into   :id_account_post, :id_account_post_pms
    do begin
      if (:id_account_post_pms is not null) then begin
        update ACCOUNT_POST$PMS A
        set    A.LINE_STATUS = 11
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
               and A.LINE_STATUS = 21;
      end

      if (:id_account_post is not null) then begin
        update PMS_EVENT_POST A
        set    A.LINE_STATUS = 11
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and A.LINE_STATUS = 21;
      end
    end

    for
      select distinct AP.ID_PMS_EVENT
      from   OWNER_BILL_ROW$PMS R
             join OWNER_BILL$PMS B on B.ID_OWNER_BILL = R.ID_OWNER_BILL
             join ACCOUNT_POST$PMS AP on AP.ID_ACCOUNT_POST = R.ID_ACCOUNT_POST_PMS
             join PMS_EVENT$PMS E on E.ID_PMS_EVENT = AP.ID_PMS_EVENT
      where  R.ID_OWNER_BILL = :ID_OWNER_BILL
             and E.EVENT_TYPE = 'POOL_DISTRIBUTION'
             and B.IS_POOL_DISTRIBUTION_STATEMENT = 1
      into   :id_pms_event
    do begin
      execute procedure PMS_EVENT_VOID$INT(:id_pms_event);
    end
  end
end
^

/* Restore proc. body: PHONECALL_POST$TC */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Restore proc. body: PHONECALLS_POST_TO_ACCOUNT$TC */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* Restore proc. body: PMS_EVENT_ANUL$PMS */
ALTER PROCEDURE PMS_EVENT_ANUL$PMS(ID_PMS_EVENT INTEGER)
 AS
begin
  execute procedure PMS_EVENT_VOID$INT(:id_pms_event);
end
^

/* Restore proc. body: PMS_EXPENSE_POSTING_CREATE$PMS */
ALTER PROCEDURE PMS_EXPENSE_POSTING_CREATE$PMS(ID_ROOM TYPE OF ID,
ID_OWNER TYPE OF ID,
ID_RENTAL_POOL TYPE OF ID_REF,
ID_SERVICE TYPE OF ID,
ID_CURRENCY TYPE OF TCURRENCY,
POST_VALUE TYPE OF TPRICE,
IS_ACC_POST_ITEM TYPE OF TLOGICAL,
MANUAL_POST_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
IS_POST_PER_POOL TYPE OF TLOGICAL)
 AS
declare variable no_use_id_acc_post integer;
declare variable no_use_id_acc_post$pms integer;
begin
  for
    select PE.NEW_ID_ACCOUNT_POST, PE.NEW_ID_ACCOUNT_POST$PMS
    from PMS_EXPENSE_POSTS_CREATE$INT(:ID_ROOM, :ID_OWNER, :ID_RENTAL_POOL, :ID_SERVICE,
         :ID_CURRENCY, :POST_VALUE, :IS_ACC_POST_ITEM, :MANUAL_POST_DATE, :DESCRIPTION, :IS_POST_PER_POOL) PE
    into :no_use_id_acc_post, :no_use_id_acc_post$pms
  do begin

  end
end
^

/* Restore proc. body: PMS_POOL_DISTRIBUTION */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION(ID_RENTAL_POOL INTEGER,
FOR_DATE DATE)
 AS
declare variable total_value_per_service numeric(15,4);
  declare variable id_service integer;
  declare variable curr varchar(3);
  declare variable id_room_param integer;
  declare variable is_room_pool smallint;
  declare variable is_owner_income smallint;

  declare variable is_acc_post_item smallint;
  declare variable new_id_owner_bill integer;
  declare variable id_account_post_pms integer;
  declare variable id_pool_account integer;

  declare variable id_account_pms integer;
  declare variable value_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable value_post numeric(15,4);
  declare variable curr_post varchar(3);
  declare variable id_room integer;
  declare variable date_post date;
  declare variable id_reserv_detail integer;
  declare variable doc_description varchar(255);
  declare variable id_doc_head integer;
  declare variable description varchar(255);
  declare variable is_client_account_post smallint;
  declare variable id_event_lst varchar(5000);
begin
  is_room_pool = null;
  select U.IS_ROOM_POOL, U.ID_ROOM_PARAM
  from   OWNER$PMS O
         join RENTAL_POOL_UNIT$PMS U on U.ID_RENTAL_POOL_UNIT = O.ID_RENTAL_POOL_UNIT
  where  O.ID_OWNER = :ID_RENTAL_POOL
  into   :is_room_pool, :id_room_param;
  if (:is_room_pool is null) then exception PMS_EXCEPTION;

  select cast(list(distinct AP.ID_PMS_EVENT) as varchar(5000))
  from   ACCOUNT_POST$PMS AP
         join ACCOUNT$PMS AC on AC.ID_ACCOUNT = AP.ID_ACCOUNT_PMS
  where  AP.DATE_POST <= :FOR_DATE
         and AP.LINE_STATUS = 11
         and AC.ID_OWNER = :ID_RENTAL_POOL
         and AC.IS_SHADOW = 0
  into   :id_event_lst;

  for
    select sum(AP1.VALUE_POST), AP1.ID_SERVICE, AP1.CURR_POST, AP1.IS_OWNER_INCOME,
           ACC.IS_CLIENT_POOL_ACCOUNT, ACC.ID_ACCOUNT
    from   ACCOUNT_POST$PMS AP1
           join ACCOUNT$PMS ACC on ACC.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS
           join SYSTEM_STRING_PARSER(:id_event_lst, ',') S on S.ITEM = AP1.ID_PMS_EVENT
    where  AP1.LINE_STATUS = 11
           and ACC.IS_SHADOW = 0
    group by 2,3,4,5,6
    into   :total_value_per_service, :id_service, :curr, :is_owner_income,
           :is_acc_post_item, :id_pool_account
  do begin
    execute procedure PMS_POOL_DISTRIBUTION_SUB(:ID_RENTAL_POOL, :id_pool_account,
            :IS_ROOM_POOL, :ID_ROOM_PARAM, :total_value_per_service,
            :ID_SERVICE, :CURR, :IS_OWNER_INCOME, :FOR_DATE, :is_acc_post_item);
  end

  NEW_ID_OWNER_BILL = gen_id(GEN_OWNER_BILL$PMS_ID, 1);

  insert into OWNER_BILL$PMS (ID_OWNER_BILL, ID_OWNER, BILL_DATE, IS_ANUL, BILL_NUM,
         IS_EXPORTED_TO_INTRANET, IS_POOL_DISTRIBUTION_STATEMENT)
  values (:NEW_ID_OWNER_BILL, :ID_RENTAL_POOL, :FOR_DATE, 0, :NEW_ID_OWNER_BILL, 0, 1);

  update OWNER$PMS O
  set    O.LAST_BILLING_DATE = :for_date,
         O.ID_OWNER_BILL = :NEW_ID_OWNER_BILL
  where  O.ID_OWNER = :ID_RENTAL_POOL;

  for
    select AP.ID_ACCOUNT_POST, AP.VALUE_ORIG, AP.CURR_ORIG, AP.VALUE_POST, AP.CURR_POST,
           ACC.ID_ACCOUNT, AP.IS_OWNER_INCOME, AP.ID_SERVICE, E.ID_ROOM, AP.DATE_POST,
           E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION, ACC.IS_CLIENT_POOL_ACCOUNT
    from   PMS_EVENT$PMS E
           join ACCOUNT_POST$PMS AP on ap.ID_PMS_EVENT = e.ID_PMS_EVENT
                                       and AP.LINE_STATUS = 11
           join ACCOUNT$PMS ACC on ACC.ID_ACCOUNT = AP.ID_ACCOUNT_PMS
                                   and ACC.ID_OWNER = :ID_RENTAL_POOL
                                   and ACC.IS_SHADOW = 0
    where  ((E.ID_SESSION = current_transaction) or (','||:id_event_lst||',' containing  ','||E.ID_PMS_EVENT||','))
    into   :id_account_post_pms, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
           :ID_ACCOUNT_PMS, :IS_OWNER_INCOME, :ID_SERVICE, :ID_ROOM, :DATE_POST,
           :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION, :is_client_account_post
  do begin
    insert into OWNER_BILL_ROW$PMS (ID_OWNER_BILL, ID_ACCOUNT_POST, ID_ACCOUNT,
           ID_ACCOUNT_POST_PMS, ID_ACCOUNT_PMS, ID_SERVICE, VALUE_ORIG,
           CURR_ORIG, VALUE_POST, CURR_POST, IS_OWNER_INCOME, ID_ROOM, DATE_POST,
           ID_RESERV_DETAIL, DOC_DESCRIPTION, ID_DOC_HEAD, DESCRIPTION, IS_CLIENT_ACCOUNT_POST)
    values (:new_id_owner_bill, null, null,
           :ID_ACCOUNT_POST_PMS, :ID_ACCOUNT_PMS, :ID_SERVICE, :VALUE_ORIG,
           :CURR_ORIG, :VALUE_POST, :CURR_POST, :IS_OWNER_INCOME, :ID_ROOM, :DATE_POST,
           :ID_RESERV_DETAIL, :DOC_DESCRIPTION, :ID_DOC_HEAD, :DESCRIPTION, :is_client_account_post);

    update ACCOUNT_POST$PMS A
    set    A.LINE_STATUS = 21
    where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS;
  end
end
^

/* Restore proc. body: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_OWNER TYPE OF ID,
POST_DATE TYPE OF TDATE,
CURR_ORIG TYPE OF TCURRENCY,
VALUE_ORIG TYPE OF TPRICE,
POST_ON_PMS_ACCOUNT TYPE OF TLOGICAL,
IS_OWNER_INCOME TYPE OF TLOGICAL,
ID_ROOM TYPE OF ID_REF = null)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  if (:POST_ON_PMS_ACCOUNT = 1) then begin
    execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account, :id_owner,
            :CURR_ORIG, :VALUE_ORIG, :id_service, :is_owner_income, :POST_DATE)
    returning_values  (:new_id_account_post);
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :ID_SERVICE, 1, 0, 1,
            :VALUE_ORIG, :CURR_ORIG, current_date, current_date,
            '', '', :POST_DATE, 'PMS', :ID_ROOM)
    returning_values  :err_code, :err_text, :new_id_account_post;
    if (:err_code <> 0) then exception PMS_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

    insert into PMS_EVENT_POST (ID_PMS_EVENT, ID_ACCOUNT_POST, ID_OWNER, LINE_STATUS)
    values (:ID_PMS_EVENT, :NEW_ID_ACCOUNT_POST, :ID_OWNER, 11);
  end
end
^

/* Restore proc. body: POST_PREPARE$INT */
ALTER PROCEDURE POST_PREPARE$INT(ID_ACCOUNT ID_REF,
ID_GUEST ID_REF,
ID_SERVICE ID_REF,
QTY TQTY,
ID_SEQUENCE TRANGE,
PRICE_POST TPRICE,
CURR_POST TCURRENCY,
POST_TEXT TOBJECT_TEXT,
FROM_DATE TDATE,
TO_DATE TDATE,
ID_PHONECALL ID_REF = null)
 RETURNS(NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable date_post date;
begin

  execute procedure POST_PRICE_CHECK$INT (:QTY, :PRICE_POST, :CURR_POST);

  for
    select sp.OUT_DATE
    from   SYSTEM_LOOP_PERIOD (:FROM_DATE, :TO_DATE) sp
    into   :date_post
  do begin
    insert into TMP_SERVICE_POST (ID_SERVICE, ID_ACCOUNT, ID_GUEST,
           PRICE_POST, CURR_POST, QTY_POST, DATE_POST, ID_SEQUENCE, POST_TEXT, ID_PHONECALL)
    values (:ID_SERVICE, :ID_ACCOUNT, :ID_GUEST,
           :PRICE_POST, :CURR_POST, :QTY, :date_post, :ID_SEQUENCE, :POST_TEXT, :ID_PHONECALL);
  end

  select cast('31.12.1899' as date) + count(p.ID_ACCOUNT_POST)
  from   (select first 2000 ap.ID_ACCOUNT_POST
          from   ACCOUNT_POST ap
          where  ap.DATE_POST is not null
          order by ap.ID_ACCOUNT_POST) p
  into   :NEW_FROM_DATE;

end
^

/* Restore proc. body: POST_SERVICE_FINALIZE$POST */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
  declare variable id_acc_post integer;
  declare variable id_service integer;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable date_post date;
  declare variable price_post numeric(15,4);
  declare variable qty_post numeric(15,2);
  declare variable post_text varchar(100);
  declare variable curr_post varchar(3);
  declare variable id_phonecall integer;
  declare variable p_dbkey char(8);
begin

  if (:OPERATION = 'clear') then begin
    delete from TMP_SERVICE_POST T
    where  T.ID_SEQUENCE = :ID_SEQUENCE;

  end else if (:OPERATION = 'store') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);

    for
      select TS.RDB$DB_KEY, TS.ID_SERVICE, TS.ID_ACCOUNT, TS.ID_GUEST, TS.DATE_POST,
             TS.PRICE_POST, TS.QTY_POST, TS.CURR_POST, TS.POST_TEXT, TS.ID_PHONECALL
      from   TMP_SERVICE_POST TS
      where  TS.ID_SEQUENCE = :ID_SEQUENCE
      into   :p_dbkey, :id_service, :id_account, :id_guest, :date_post,
             :price_post, :qty_post, :curr_post, :post_text, :id_phonecall
    do begin
      id_acc_post = null;
      if (:id_guest is not null) then begin
        execute procedure POST_SERVICE_ON_GUEST$INT (:id_guest, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :CURR_POST,
                :date_post, :date_post, :post_text, '', :date_post, '', '')
        returning_values  (:err_code, :err_text, :no_use, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end else begin
        execute procedure POST_SERVICE_ON_ACCOUNT$INT (:id_account, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :curr_post, :date_post, :date_post, :post_text,
                '', :date_post, '')
        returning_values  (:err_code, :err_text, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end

      update TMP_SERVICE_POST
      set ID_ACCOUNT_POST = :id_acc_post
      where RDB$DB_KEY = :p_dbkey;

      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :DOC_SELECTED,
             AP.SHORT_CODE = case
                               when :id_phonecall is not null then 'TELECOUNT'
                               else null
                             end
      where  AP.ID_ACCOUNT_POST = :id_acc_post;

      if (:id_phonecall is not null) then begin
        update PHONECALLS P
        set    P.ID_ACCOUNT_POST = :id_acc_post
        where  P.ID_PHONECALL = :id_phonecall;
      end
    end
  end
end
^

/* Restore proc. body: PRODUCT_RATING$INT */
ALTER PROCEDURE PRODUCT_RATING$INT(ID_HOTEL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
ADULT_AGES VARCHAR(100) = null,
CHILD_AGES VARCHAR(100) = null,
ID_TAR_CALC_COMMON INTEGER = null)
 RETURNS(ROOM_PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100))
 AS
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable id_reserv integer;
declare variable id_tar_calc integer;
declare variable rate_currency char(3);
begin
  id_tar_calc = null;
  select T.CURR
  from   TARIFA T
  where  t.ID_TARIFA = :ID_RATE
  into   :rate_currency;

  execute procedure TAR_CALC_INPUT_PLAIN$INT (:adult_count, :children_count,
          :id_room_type, :id_board, :arrival_date, :departure_date,
          '', '', null, '', null, null, :id_rate, :adult_ages, :child_ages, :ID_TAR_CALC_COMMON)
  returning_values (:id_tar_calc, :id_reserv, :err_code, :err_text);
  --if (:err_code < 0) then exit;

  if (:err_code = 0) then begin
    execute procedure TAR_CALC_EVAL_ALL$INT(:id_tar_calc)
    returning_values  :err_code, :err_text;
    /*savedbg('-----------------------------');
    savedbg('id_rate: ' || :id_rate);
    savedbg('id_board: ' || :id_board);
    savedbg('id_room_type: ' || :id_room_type);
    savedbg('id_tar_calc: ' || :id_tar_calc);
    savedbg('err_code: ' || :ERR_CODE);
    savedbg('err_text: ' || :ERR_TEXT);
    */
    if (:err_code = 0) then begin
      execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

      price_currency = :rate_currency;
      execute procedure TAR_CALC_GET_PRICE$INT (:id_tar_calc, :id_hotel, :id_reserv, :price_currency)
      returning_values  :room_price, :room_price_details;
    end
  end
end
^

/* Restore proc. body: REP_ROOM_STATUS_BUILD$INT */
ALTER PROCEDURE REP_ROOM_STATUS_BUILD$INT(ID_ROOM INTEGER,
FOR_DATE DATE,
STAT_OPTIONS VARCHAR(255))
 RETURNS(IS_LEAVING SMALLINT,
IS_COMMING SMALLINT,
IS_SHARED SMALLINT,
IS_LEAVING_WORDS VARCHAR(30),
BUSY_GRP INTEGER,
DAYS_THIS_STATUS INTEGER,
DTS_CONTEXT VARCHAR(10),
COMMING_OCCUPANTS VARCHAR(1024),
ID_BLOCK_ROOM INTEGER,
OTHER_OCCUPANTS VARCHAR(1024),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER)
 AS
declare variable report_leaving varchar(50);
  declare variable as_busy_grp_type integer;

  declare variable day_action varchar(50);
  declare variable occup_grp integer;
  declare variable occupant_id integer;
  declare variable busygrp_leaving integer;
  declare variable busygrp_other integer;
  declare variable check_status integer;
  declare variable int_adult_count integer;
  declare variable int_children_count integer;
  declare variable id_hotel integer;
begin
  select r.ID_HOTEL
  from   ROOMS R
  where  R.ID_ROOM = :ID_ROOM
  into   :id_hotel;

  execute procedure SETTING_GET_VALUE('REPORT_LEAVING', :id_hotel)
  returning_values  :report_leaving;

  is_leaving = 0;
  is_comming = 0;
  is_shared = 0;
  comming_occupants = '';
  id_block_room = null;
  other_occupants = '';
  busygrp_leaving = 0;
  busygrp_other = 0;
  adult_count = 0;
  children_count = 0;

  for
    select RM.ID_RESERV_DETAIL, coalesce(RS.BUSY_GROUP_TYPE, rm.BUSY_GROUP_TYPE), RM.DAY_ACTION,
           RD.CHECK_STATUS, RM.ADULT_COUNT, RM.CHILDREN_COUNT
    from   TMP_HM_ROOM_STATUS HM
           join ROOM_MAGIC RM on RM.ID_ROOM_MAGIC = HM.ID_ROOMS_MAGIC
           left outer join ROOMS_SHARE RS on RS.ID_ROOM_SHARE = RM.ID_ROOM_MAGIC
           left outer join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = RM.ID_RESERV_DETAIL
    where  HM.ID_SESSION = current_transaction
           and HM.ID_ROOM = :id_room
    order by RD.CHECK_STATUS asc nulls first, rd.FROM_DATE asc nulls first
    into   :occupant_id, :occup_grp, :day_action,
           :check_status, :int_adult_count, :int_children_count
  do begin
    --is_comming = 0;
    --is_leaving = 0;
    if (:occup_grp in (18, 20) and :DAY_ACTION = 'BLOCK') then begin
      id_block_room = :occupant_id;
      busygrp_other = :occup_grp;
    end else if (:DAY_ACTION = 'CHECK_IN') then begin
      is_comming = 1;
      if (','||:comming_occupants||',' not containing ','||:occupant_id||',') then
        comming_occupants = :comming_occupants || iif(:comming_occupants = '', '', ',') || :occupant_id;
      busygrp_other = :occup_grp;
    end else if (:DAY_ACTION containing 'CHECK_OUT') then begin
      if (:check_status < 1) then begin
        if ((:check_status < 0) and (:stat_options containing 'HOUSEKEEPING')) then begin
          -- do nothing. House keeping is not interested in leaving reservations
        end
        is_leaving = 1;
        busygrp_leaving = :occup_grp;
        if (','||:other_occupants||',' not containing ','||:occupant_id||',') then
          other_occupants = :other_occupants || iif(:other_occupants = '', '', ',') || :occupant_id;
      end else begin
        -- nothing, room is alreay checked out
      end
    end else begin
      -- DAY_ACTION = 'STAY'
      busygrp_other = :occup_grp;
      if (','||:other_occupants||',' not containing ','||:occupant_id||',') then
        other_occupants = :other_occupants || iif(:other_occupants = '', '', ',') || :occupant_id;
    end

    adult_count = :adult_count + :int_adult_count;
    children_count = :children_count + :int_children_count;

  end

  if (:report_leaving = 'AS_FREE') then begin
    busy_grp = :busygrp_other;
  end else begin
    busy_grp = iif(:busygrp_leaving in (0, 1), :busygrp_other, :busygrp_leaving);
  end

  if (exists(
    select *
    from   ROOMS_SHARE RS
    where  RS.ID_ROOM = :id_room
           and RS.BUSY_DATE = :for_date
  )) then is_shared = 1;
  else is_shared = 0;

  if (:stat_options containing 'DAYS_THIS_STATUS') then begin
    if (:is_leaving = 1) then begin
      if (exists(  -- !!! this select must be changed
           select * from ROOM_MAGIC RM
           where  RM.BUSY_DATE = :for_date
                  and RM.ID_ROOM = :id_room
                  and RM.BUSY_TYPE <> 'VALUE_RESERVS'
                  and RM.DAY_ACTION not containing 'CHECK_OUT')
      ) then as_busy_grp_type = :busy_grp;
      else begin
        /* TODAY THE ROOM IS LEAVING AND NO BODY IS EXPECTED TO COME
        || SO WE MUST SHOW HOW MANY DAYS THE ROOM WILL BE FREE
        */
        as_busy_grp_type = 0;
      end
    end else as_busy_grp_type = :busy_grp;

    if (:as_busy_grp_type = 0) then dts_context = 'FREE';
    else dts_context = 'BUSY';
    execute procedure REP_ROOM_STATUS_DTS$INT(:as_busy_grp_type, :for_date, :id_room)
    returning_values  :days_this_status;

--    if (:days_this_status is null) then days_this_status_txt = '~';
--    else days_this_status_txt = :days_this_status;
  end
end
^

/* Restore proc. body: RES_CHECKIN$RSV */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable old_check_status integer;
  declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable is_anul integer;
  declare variable arrival_date date;
  declare variable system_date date;
begin
  /*  Description:
  ||
  */
  select RD.CHECK_STATUS, RD.RDB$DB_KEY, RD.FROM_DATE, RD.ID_HOTEL,
         RD.ID_ROOM, RD.IS_ANUL
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_check_status, :rd_dbkey, :arrival_date, :id_hotel,
         :old_id_room, :is_anul;

  if (:is_anul = 1) then exception BOOKING_EXCEPTION '-2';

  if (:old_check_status >= 0) then exception BOOKING_EXCEPTION '-1003';

  if (:old_id_room < 0 and coalesce(:ID_ROOM, 0) <= 0) then exception BOOKING_EXCEPTION '-1018';

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date < :arrival_date) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CHECK_IN_FUTURE');
  end
  /*----*/
  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'lock');

  execute procedure sys_dbg('occ RES_CHECKIN$RSV id_room = '||coalesce(:id_room, 'null'));
  execute procedure sys_dbg('occ RES_CHECKIN$RSV old_id_room = '||coalesce(:old_id_room, 'null'));

  if (:id_room is not null) then begin
    if (:old_check_status = -3) then begin
      execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, -2);
    end

    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option)
    returning_values (:WARN_CODE);
  end

  execute procedure RES_SET_CHECKIN$INT (:rd_dbkey)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'release');
  /*----*/
  select f_character(29) || R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = coalesce(:ID_ROOM, :old_id_room)
  into   :action_text;
   
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'CHECK_IN', :action_text);

end
^

/* Restore proc. body: RES_CHECKIN_MULTI$RSV */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable checkin_count integer;
  declare variable split_on_checkin integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
  declare variable tmp_warn_code integer;
begin
  checkin_count = 0;
  warn_code = null;
  for
    select RD.ID_RESERV_DETAIL, RD.CHECK_STATUS, RD.SPLIT_ON_CHECKIN, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :SELECTION_ID
    into   :id_reserv_detail, :check_status, :split_on_checkin, :id_titular
  do begin
    if (:check_status >= 0) then begin
      checkin_count = :checkin_count + 1;
    end else begin
      if (:split_on_checkin = 1) then begin
        for
          select G.ID_GUEST
          from   GUEST G
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and G.ID_GUEST <> :id_titular
          into   :id_guest
        do begin
          execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
          returning_values  :id_splited_reservation;

          execute procedure RES_CHECKIN$RSV (:id_splited_reservation)
          returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

          update RESERV_DETAIL RD
          set    RD.SELECTION_ID = :selection_id
          where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
        end
      end

      execute procedure RES_CHECKIN$RSV (:id_reserv_detail)
      returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
      WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end

  if (:checkin_count > 0) then begin
    execute procedure SYSTEM_WARNING_ADD(-1011, f_character(29)||:checkin_count)
    returning_values  :warn_code;
  end
end
^

/* Restore proc. body: RES_CREATE_ROOM$INT */
ALTER PROCEDURE RES_CREATE_ROOM$INT(CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_COUNT INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_AGENT_PROFILE INTEGER,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_PERSON_PROFILE INTEGER,
ACC_ROUTING VARCHAR(50),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ID_GROUP INTEGER = null,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_GUARANTEE_POLICY INTEGER = null,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
RD_DBKEY CHAR(8),
NEW_ID_PERSON_PROFILE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable day_keep_types integer;
  declare variable exp_date date;
  declare variable leaving_kind integer;
  declare variable cnt_processed integer;
begin
  execute procedure SETTING_GET_VALUE('DAY_KEEP_TYPES', :ID_HOTEL)
  returning_values  :day_keep_types;
  exp_date = :arrival_date + :day_keep_types;
  leaving_kind = coalesce(:is_late_departure, 0) + 1;
  comming_kind = coalesce(:comming_kind, 1);

  cnt_processed = 0;
  while (:room_count > :cnt_processed) do begin
    if (:res_number is null) then begin
      execute procedure SYSTEM_GEN_NUM('BOOKING', 0)
      returning_values  :dbg, :res_number;
    end
    
    if (:id_person_profile is null) then begin
      execute procedure PROFILE_PERSON_CREATEQ$PROFILE(:res_number, '', null, null, null,
              :country_code, null, null, null, :ID_HOTEL)
      returning_values  :new_id_person_profile, :dbg, :dbg;
      execute procedure sys_dbg('res RES_CREATE_ROOM$INT autocreate id_person_profile = '||coalesce(:id_person_profile, 'null'));
    end else begin
      new_id_person_profile = :id_person_profile;
    end

    execute procedure RES_CREATE_DETAIL$INT(:id_reserv_detail, :id_agent_profile, :res_number, :check_status,
                      :arrival_date, :departure_date, :code_first_food, :exp_date, :comming_kind, :leaving_kind,
                      :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                      0, 0, :note, :i_special_treatment, :id_board, -1, :id_rate,
                      :id_room_type, :country_code, '30.12.1899', null, null, '30.12.1899', null, null, null,
                      :room_features, :id_hk_plan, :new_id_person_profile, :id_hotel, :acc_routing, :id_acc_template_person,
                      :id_group, :id_agent_account, :id_guarantee_policy, :ID_EATING_OBJECT)
    returning_values  :new_id_reserv_detail, :rd_dbkey;
    res_number = null;

    execute procedure RES_GUESTCOUNT_ADD$INT(:rd_dbkey, :adult_count, :child_count);

    cnt_processed = :cnt_processed + 1;
    suspend;
  end
end
^

/* Restore proc. body: RES_CREATE_SET$INT */
ALTER PROCEDURE RES_CREATE_SET$INT(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(255),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_HOTEL INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
SPLIT_ON_CHECKIN SMALLINT,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_ACC_TEMPLATE_PERSON INTEGER = null,
ID_GUARANTEE_POLICY INTEGER = null,
BLOCK_CC VARCHAR(255) = null,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(RD_DBKEY CHAR(8),
NEW_ID_RESERV_DETAIL INTEGER,
WARN_CODE TYPE OF TRANGE)
 AS
declare variable guarantee_deposit_percent numeric(15,4);
  declare variable guarantee_deposit_nights integer;
  declare variable guarantee_due_days_bef_arrival integer;
  declare variable guarantee_due_days_after_create integer;
  declare variable gp_check_status integer;
  declare variable log_suppressed integer;
  declare variable id_guest integer;
  declare variable minibar_rights varchar(50);
  declare variable video_rights varchar(50);
  declare variable nopost_pms varchar(50);
  declare variable phone_rights varchar(50);
  declare variable paytv_rights varchar(50);
  declare variable is_profile_exclusive_debt_ownership integer;
  declare variable id_base_account integer;
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CREATE');

  select GP.DEPOSIT_NIGHTS_COUNT, GP.DEPOSIT_TOTALSUM_PART,
         GP.DUE_DAYS_BEFORE_ARRIVAL, GP.DUE_DAYS_AFTER_CREATE, gp.CHECK_STATUS
  from   GUARANTEE_POLICY GP
  where  GP.ID_GUARANTEE_POLICY = :ID_GUARANTEE_POLICY
         and gp.ID_HOTEL = :ID_HOTEL
  into   :guarantee_deposit_nights, :guarantee_deposit_percent,
         :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create, :gp_check_status;

  CHECK_STATUS = coalesce(:CHECK_STATUS, :gp_check_status, -2);

  execute procedure RES_CREATE_ROOM$INT(:check_status, :arrival_date, :departure_date, :adult_count, :child_count,
                    :id_room_type, 1, :id_board, :id_tariff, comming_kind, :is_late_departure, :country_code, :code_first_food,
                    :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note, :i_special_treatment, :id_agent_profile,
                    :id_hk_plan, '', :room_features, :id_person_profile, :acc_routing, :id_acc_template_person, :id_hotel, :id_agent_account,
                    :id_group, :id_reserv_detail, :res_number, :id_guarantee_policy, :id_eating_object)
  returning_values  :new_id_reserv_detail, :rd_dbkey, :id_person_profile;

  if (RDB$GET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE') is not distinct from 'disable') then begin
    log_suppressed = 1;
  end else begin
    log_suppressed = 0;
    RDB$SET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE', 'disable');
    -- disable only for intermediate changes
  end

  execute procedure RES_SAVE_ACCOUNTING$INT (:rd_dbkey, :id_agent_profile, :id_agent_account, :acc_routing,
          :id_person_payment, :id_agent_payment, :id_group);

  execute procedure RES_SAVE_MARKETING$INT(:rd_dbkey, :id_nom_market_segment,
                    :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason);

  execute procedure sys_dbg('res RES_CREATE_SET$INT id_room = '||coalesce(:id_room, 'null'));
  if (:id_room is not null) then begin
    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, :id_room_type, 'nrttRoom')
    returning_values (:WARN_CODE);
  end

  execute procedure RES_SAVE_VOUCHER$INT(:RD_DBKEY, :voucher_num, :voucher_date, :voucher_text, :voucher2_num, :voucher2_date);

  execute procedure RES_SAVE_NOTE$RSV(:new_id_reserv_detail, :note, :note_reminders);

  for
    select  g.ID_GUEST
    from    GUEST G
    where   G.ID_RESERV_DETAIL = :NEW_ID_RESERV_DETAIL
    into    :id_guest
  do begin
    execute procedure RES_GUEST_SAVE_PACKET$RSV (:id_guest, :PACKET_ITEM_IDS);
  end 

  update RESERV_DETAIL RD
  set    RD.CUSTOM_PRICE = :CUSTOM_PRICE,
         RD.CUSTOM_CURRENCY = :CUSTOM_CURRENCY,
         RD.SPLIT_ON_CHECKIN = :SPLIT_ON_CHECKIN,
         RD.IS_VIP = coalesce(:IS_VIP, RD.IS_VIP),
         RD.ID_GUARANTEE_POLICY = :ID_GUARANTEE_POLICY,
         RD.GUARANTEE_DEPOSIT = :GUARANTEE_DEPOSIT,
         RD.GUARANTEE_CURRENCY = :GUARANTEE_CURRENCY,
         RD.BLOCK_CC = :BLOCK_CC,
         RD.GUARANTEE_DEPOSIT_PERCENT = :guarantee_deposit_percent,
         RD.GUARANTEE_DEPOSIT_NIGHTS = :guarantee_deposit_nights,
         RD.GUARANTEE_DUE_DAYS_BEF_ARRIVAL = :guarantee_due_days_bef_arrival,
         RD.GUARANTEE_DUE_DAYS_AFTER_CREATE = :guarantee_due_days_after_create
         /*rd.POSTING_TRANSACTION_UUID =  (select iif(p.IS_EXCLUSIVE_DEBT_OWNERSHIP = 1, uuid_create(), null)
                                         from   ACCOUNT A
                                                join PROFILE P on P.ID_PROFILE = a.ID_PROFILE
                                         where  a.ID_ACCOUNT = rd.ID_BASE_ACCOUNT)*/
  where  RD.RDB$DB_KEY = :rd_dbkey
  returning new.ID_BASE_ACCOUNT
  into      :id_base_account;

  select p.IS_EXCLUSIVE_DEBT_OWNERSHIP
  from   ACCOUNT A
         join PROFILE P on P.ID_PROFILE = a.ID_PROFILE
  where  a.ID_ACCOUNT = :id_base_account
  into   :is_profile_exclusive_debt_ownership;

  if (:is_profile_exclusive_debt_ownership = 1) then begin
    execute procedure RES_TAKE_POSTING_RESPONSIBILITY (:NEW_ID_RESERV_DETAIL);
  end

  select rt.MINIBAR_RIGHTS, rt.VIDEO_RIGHTS, rt.NOPOST_PMS, rt.PHONE_RIGHTS, rt.PAYTV_RIGHTS
  from   RES_TEMPLATE RT
  where  rt.ID_HOTEL = :ID_HOTEL
  into   :minibar_rights, :video_rights, :nopost_pms, :phone_rights, :paytv_rights;

  execute procedure RESERV_DETAIL_EXTERNAL_MOD$RSV (:NEW_ID_RESERV_DETAIL,
          :minibar_rights, :paytv_rights, :video_rights, :nopost_pms, :phone_rights, null, null);

  if (:log_suppressed = 0) then RDB$SET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE', 'enable');

  execute procedure RES_CREATE_LOG$INT (:RD_DBKEY);

end
^

/* Restore proc. body: RES_CREATE_SET$RSV */
ALTER PROCEDURE RES_CREATE_SET$RSV(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
SUPPRESS_WARNINGS INTEGER,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER,
NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable rd_dbkey char(8);
declare variable tmp_warn_code integer;
begin
  WARN_CODE = null;
  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, :check_status, :arrival_date, :departure_date,
                    :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff, :PACKET_ITEM_IDS,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
                    :guarantee_deposit, :guarantee_currency, :split_on_checkin, null, null, :ID_ACC_TEMPLATE_PERSON,
                    :ID_GUARANTEE_POLICY, null, :ID_EATING_OBJECT)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :WARN_CODE;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :ERR_TEXT, :share_transaction_id, :tmp_warn_code;
  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

  if (:suppress_warnings = 1) then begin
    delete from SYSTEM_WARNINGS W
    where W.ID_TRANSACTION = :warn_code;
    warn_code = null;
  end

  update RESERV_DETAIL RD
  set    RD.NOTE_REMINDERS = :note_reminders
  where  RD.RDB$DB_KEY = :rd_dbkey;

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;

end
^

/* Restore proc. body: RES_DELETE$INT */
ALTER PROCEDURE RES_DELETE$INT(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable rd_dbkey char(8);
  declare variable id_guest integer;
  declare variable action_text varchar(255);
  declare variable from_date date;
  declare variable to_date date;
  declare variable room_type varchar(20);
  declare variable number varchar(62);
  declare variable tmp_extra_posts_left integer;
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_DELETE');

  select RD.RDB$DB_KEY, RD.FROM_DATE, rd.TO_DATE, RT.TYPE_ROOM, rd.NUMBER
  from   RESERV_DETAIL RD
         left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = RD.ID_ROOM_TYPE
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey, :from_date, :to_date, :room_type, :number;

  update RESERV_DETAIL R
  set    r.ID_TITULAR = null
  where  r.RDB$DB_KEY = :rd_dbkey;

  EXTRA_POSTS_LEFT = 0;
  for
    select G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_guest
  do begin
    execute procedure RES_GUEST_DEL$INT(:id_guest, :id_reserv_detail, :REASON)
    returning_values  :tmp_extra_posts_left;
    EXTRA_POSTS_LEFT = iif(:EXTRA_POSTS_LEFT = 1, 1, :tmp_extra_posts_left);
  end

  execute procedure RES_FINALIZE$INT (:RD_DBKEY, 1)
  returning_values (:warn_code);


  execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

  action_text = f_character(29) || coalesce(:number, '')
                || f_character(28) || coalesce(:room_type, '')
                || f_character(28) || :from_date
                || f_character(28) || :to_date
                || f_character(28) || :reason;
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'DELETE', :action_text);

  delete from RESERV_DETAIL RDD
  where  RDD.RDB$DB_KEY = :rd_dbkey;

  delete from XML_MESSAGE$EXC xml
  where  xml.OBJECT_TYPE = 'BOOKING'
         and xml.OBJECT_ID = :number;

end
^

/* Restore proc. body: RES_FINALIZE$INT */
ALTER PROCEDURE RES_FINALIZE$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable err_text varchar(255);
begin
  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, :SUPPRESS_NON_INSTANT_ERRORS)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;
  if (:share_err_code < 0) then exception BOOKING_EXCEPTION :share_err_code || f_character(31) || :ERR_TEXT;
end
^

/* Restore proc. body: RES_GET_INFO$RSV */
ALTER PROCEDURE RES_GET_INFO$RSV(ID_RESERV_DETAIL INTEGER,
RETURN_BALANCE SMALLINT = 1,
RETURN_SHARE SMALLINT = 1,
RETURN_GEUSTDATA SMALLINT = 1)
 RETURNS(NUMBER VARCHAR(62),
AGENT_PROFILE_NAME VARCHAR(100),
ARRIVALS VARCHAR(255),
DEPARTURES VARCHAR(255),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
ID_ROOM INTEGER,
ROOM VARCHAR(60),
ID_ROOM_TYPE INTEGER,
ROOM_FEATURES BLOB,
GUESTS VARCHAR(255),
GUESTS_CNT INTEGER,
PERSON_PROFILE_NAME VARCHAR(150),
RATES VARCHAR(255),
BOARDS VARCHAR(255),
PACKETS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY VARCHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
BALANCE VARCHAR(255),
OPEN_CHARGES INTEGER,
CHECK_STATUS INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
NOTE VARCHAR(2000),
NOTE_GRP VARCHAR(255),
VOUCHER_RENDER VARCHAR(512),
ACC_ROUTING VARCHAR(255),
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
BUSY_GRP INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
GUEST_TYPE_COLOR INTEGER,
IS_CLEAN INTEGER,
ROOM_PRIVATE_STATUS TLOGICAL)
 AS
declare variable arrival varchar(20);
declare variable departure varchar(20);
declare variable rd_dbkey char(8);
declare variable no_use varchar(1024);
declare variable rd_adult_count integer;
declare variable rd_child_count integer;
declare variable groupname varchar(100);
declare variable virtual_room varchar(10);
declare variable earlycheckout_date date;
begin
  arrivals = '';
  departures = '';
  rates = '';
  NOTE_GRP = null;

  IS_CLEAN = 0;

  select AP.PROFILE_NAME, RD.ADULT_COUNT, RD.CHILD_COUNT,
         R.ID_ROOM, R.ROOM_NAME, coalesce(rd.VIRTUAL_ROOM, 'i'||RM.ID_ROOM), coalesce(R.ID_ROOM_TYPE, RM.ID_ROOM_TYPE, RD.ID_ROOM_TYPE),
         RD.CHECK_STATUS, PP.PROFILE_NAME || coalesce(' (' || GT.GUEST_TYPE_NAME || ')', ''),
         RD.FROM_DATE, RD.TO_DATE, RG.GROUP_NAME,
         RD.ID_GROUP, RD.ROOM_FEATURES, RD.COMMING_KIND, RD.LEAVING_KIND - 1,
         RD.NUMBER, RD.NOTE, RD.RDB$DB_KEY, RD.ID_HOTEL, RD.ACC_ROUTING,
         GT.GUEST_TYPE_COLOR, coalesce(r.IS_CLEAN, 1), g.EARLYCHECKOUT_DATE
  from   RESERV_DETAIL RD
         left outer join RESERV_GROUP RG on RG.ID_RESERV_GROUP = RD.ID_GROUP
         left outer join PROFILE AP on AP.ID_PROFILE = RD.ID_AGENT_PROFILE
         left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
         left outer join ROOM_MAP$EXC RM on RM.ID_ROOM = RD.ID_ROOM
         left outer join PROFILE PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
         left outer join PROFILE_PERSON PPp on PPp.ID_PROFILE = PP.ID_PROFILE
         left outer join GUEST_TYPE GT on GT.ID_GUEST_TYPE = PPp.ID_GUEST_TYPE
         left outer join GUEST G on g.ID_GUEST = rd.ID_TITULAR
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :agent_profile_name, :rd_adult_count, :rd_child_count,
         :id_room, :room, :virtual_room, :id_room_type,
         :check_status, :person_profile_name,
         :arrival_date, :departure_date, :groupname,
         :id_group, :room_features, :comming_kind, :is_late_departure,
         :number, :note, :rd_dbkey, :id_hotel, :acc_routing,
         :guest_type_color, :is_clean, :earlycheckout_date;


  ARRIVALS = iif(extract(year from current_date) = extract(year from :ARRIVAL_DATE),
               formatDate(:ARRIVAL_DATE, 'D;dd.mm')||' ('||(:DEPARTURE_DATE - :ARRIVAL_DATE)||')',
               formatDate(:ARRIVAL_DATE, 'D;dd.mm.yy')||' ('||(:DEPARTURE_DATE - ARRIVAL_DATE)||')');
  DEPARTURES = iif(extract(year from current_date) = extract(year from :DEPARTURE_DATE),
               formatDate(:DEPARTURE_DATE, 'D;dd.mm'),
               formatDate(:DEPARTURE_DATE, 'D;dd.mm.yy'));
  for
    select iif(extract(year from current_date) = extract(year from g.FROM_DATE),
               formatDate(g.FROM_DATE, 'D;dd.mm')||' ('||(G.TO_DATE - G.FROM_DATE)||')',
               formatDate(g.FROM_DATE, 'D;dd.mm.yy')||' ('||(G.TO_DATE - G.FROM_DATE)||')'),
           iif(extract(year from current_date) = extract(year from g.TO_DATE),
               formatDate(g.TO_DATE, 'D;dd.mm'),
               formatDate(g.TO_DATE, 'D;dd.mm.yy'))
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
           and ((g.FROM_DATE <> :ARRIVAL_DATE) or (g.TO_DATE <> :DEPARTURE_DATE))
    into   :arrival, :departure
  do begin
    if (:ARRIVALS not containing :arrival) then ARRIVALS = :ARRIVALS || ','||:arrival;
    if (:DEPARTURES not containing :departure) then DEPARTURES = :DEPARTURES || ','||:departure;
  end

  execute procedure RES_GET_PRICE$INT(:rd_dbkey, 'SECURITY')
  returning_values  :room_price, :room_currency, :room_price_details, :no_use, :no_use;

  if (coalesce(:return_balance,1)=1) then
    execute procedure RES_GET_BALLANCE$INT(:id_reserv_detail)
    returning_values  :balance, :no_use, :no_use, :open_charges, :no_use;

  if (:groupname <> '') then agent_profile_name = substring(coalesce(:agent_profile_name, '') || ' / ' || coalesce(:groupname, '') from 1 for 100);

  execute procedure RES_GET_ATTENTION_STATUS$INT(:arrival_date, :departure_date, :check_status, :id_hotel)
  returning_values  :attention_status;

  if (coalesce(:return_share,1)=1) then begin
    execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'RENDER', null)
    returning_values  :in_share, :no_use, :shares_preview;
    if (:IN_SHARE = 1) then ROOM = coalesce(:ROOM, :virtual_room);
  end

  if (coalesce(:return_geustdata,1)=1) then begin
    execute procedure RES_GET_GUEST_DATA$INT('DETAIL', :id_reserv_detail)
    returning_values  :boards, :rates, :packets, :voucher_render;
  end

  execute procedure RES_GET_ANNULSTATUS(:rd_dbkey)
  returning_values  :annul_status;

  guests = :rd_adult_count || ' + ' || :rd_child_count || ' ';
  guests_cnt = :rd_adult_count + :rd_child_count;

  if (:check_status > 1) then  busy_grp = 24;
  else busy_grp = 1;

  ROOM_PRIVATE_STATUS = 0;
  select cast(1 as smallint)
  from   SYSTEM_DATE_GET (:ID_HOTEL) sd
         join ROOM_MAGIC rm on rm.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                               and rm.ROOM_STATUS = 'PRIVATE'
                               and rm.BUSY_DATE = mindate(maxdate(:ARRIVAL_DATE, sd.SYSTEM_DATE), coalesce(:earlycheckout_date, :DEPARTURE_DATE) - 1)
  into   :ROOM_PRIVATE_STATUS;

  suspend;
end
^

/* Restore proc. body: RES_RECALC$INT */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable num_prefix varchar(20);
  declare variable number_1 varchar(20);
begin
  /* CALLER_KIND = {NORMAL, FORCED} */
  err_code = 0;
  /* 1. GET DATA */
  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL, rd.NUMBER_1
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :check_status, :id_reserv_detail, :number_1;

  if (:check_status = 1) then begin
    -- CHECKED OUT
    select sn.LEADING_PART
    from   SYSTEM_NUMERATOR SN
    where  sn.ID_NUMERATOR = 0
    into   :num_prefix;

    if (trim('.' from coalesce(:num_prefix, '')) = coalesce(:number_1, '')) then
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_MINE');
    else
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_ELSE');

    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :id_guest
    do begin
      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'MANUAL_EDIT_DATA', '');
    end
  end
  /* 2. FIND DEPENDANT GUESTS AND THEIR TARIFFS */
  execute procedure sys_dbg('calc RES_RECALC$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

  id_tar_calc = gen_id(gen_id_tar_calc, 1);
  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NONE');

  execute procedure TAR_CALC_EVAL_ALL$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  -- 3. UPDATE ROOM PRICE and REPOST ALL AFFECTED BOOKINGS
  execute procedure RES_TAR_CALC_FINALIZE$INT (:ERR_CODE, :ID_TAR_CALC, :RD_DBKEY, :CALLER_KIND, :FORCE_POSTING);

end
^

/* Restore proc. body: RES_ROOM_REMOVE$INT */
ALTER PROCEDURE RES_ROOM_REMOVE$INT(RD_DBKEY CHAR(8))
 RETURNS(WARN_CODE INTEGER)
 AS
begin

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, gen_id(DETAIL_WITHOUT_ROOMING_LIST, -1), null, 'nrttAsIs')
  returning_values (:WARN_CODE);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 0)
  returning_values  :WARN_CODE;

end
^

/* Restore proc. body: RES_SAVE_ROOM$EXC */
ALTER PROCEDURE RES_SAVE_ROOM$EXC(RD_DBKEY CHAR(8),
ID_RES_ROOM_TYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(250),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_room integer;
begin
  select RD.ID_ROOM, RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_room, :id_reserv_detail;

  execute procedure RES_SAVE_ROOM$RSV(
    :id_reserv_detail,
    :old_id_room,
    :id_res_room_type,
    'nrttAsIs',
    1,
    :id_hk_plan,
    :room_features,
    :i_special_treatment,
    :split_on_checkin,
    0
  ) returning_values :share_err_code, :err_text, :share_transaction_id, :warn_code;
end
^

/* Restore proc. body: RES_TAR_CALC_FINALIZE$INT */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(TAR_CALC_ERR INTEGER,
ID_TAR_CALC INTEGER,
RD_DBKEY_INIT CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
begin
  --  Razpiswa cenata na staia, kakto i price_detailite.

  if (:tar_calc_err = 0) then begin
    room_price = 0;
    room_price_details = '';

    execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

    for
      select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, rd.IS_POSTING_STOPPED,
             coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
             coalesce(max((select first 1 AP.IS_BASE
                           from   GUEST G
                                  join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                           where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                  and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (eventually)
      from   TAR_CALC_INPUT$TMP TI
             join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
             join TARIFA t on t.ID_TARIFA = rd.ID_RATE
      where  ti.ID_TAR_CALC = :ID_TAR_CALC
      group by 1, 2, 3, 4, 5, 6
      into   :id_reserv_detail, :check_status, :is_posting_stopped,
             :room_currency, :id_hotel, :is_anul, :has_postings
    do begin
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);

      if ( (not (:is_posting_stopped = 1 and :has_postings = 0))                                -- posting is not stopped
           and                                                                                  -- and
           ( (coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1) ) -- there are reasons to repost
         ) then
      begin

        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);

      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;

        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end

      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end else begin

    update RESERV_DETAIL RD
    set    RD.ROOM_PRICE = null,
           RD.ROOM_CURRENCY = null,
           RD.ROOM_PRICE_DETAILS = null,
           RD.LAST_ID_TAR_CALC = null
    where  RD.RDB$DB_KEY = :RD_DBKEY_INIT;
  end
  
  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;
end
^

/* Restore proc. body: RESERV_STATISTIC_CANCELED$INT */
ALTER PROCEDURE RESERV_STATISTIC_CANCELED$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(BUSY_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_PROFILE_AGENT INTEGER,
COUNTRY_CODE VARCHAR(20),
MARKET_SEGMENT_CODE VARCHAR(3),
SOURCE_CODE VARCHAR(3),
CHANNEL_CODE VARCHAR(3),
HEAR_REASON_CODE VARCHAR(3),
COME_REASON_CODE VARCHAR(3),
ROOMS_NOSHOW SMALLINT,
GUESTS_NOSHOW SMALLINT,
ROOMS_CANCELED SMALLINT)
 AS
begin
  -- {NOSHOW, CANCELED, USERERROR}
  for
    select P.OUT_DATE, RD.ID_ROOM_TYPE, S.ID_PROFILE_AGENT, coalesce(RD.COUNTRY, ''),
           S.MARKET_SEGMENT_CODE, S.SOURCE_CODE, S.CHANNEL_CODE, S.HEAR_REASON_CODE, S.COME_REASON_CODE,
           count(distinct iif(RD.REASON_OF_ANUL = 'NOSHOW', RD.ID_ROOM, null)),
           sum(iif(RD.REASON_OF_ANUL = 'NOSHOW', RD.ADULT_COUNT + RD.CHILD_COUNT, 0)),
           count(distinct iif(RD.REASON_OF_ANUL = 'CANCELED', RD.ID_ROOM, null))
    from   RESERV_DETAIL RD
           left outer join RESERV_STATISTIC_SLICE$INT(RD.ID_RESERV_DETAIL) S on 0=0
           left outer join SYSTEM_LOOP_PERIOD(maxdate(:from_date, RD.FROM_DATE), mindate(:to_date, RD.TO_DATE-1)) P on 0=0
    where  RD.ID_HOTEL = :id_hotel
           and RD.FROM_DATE <= :to_date
           and RD.TO_DATE > :from_date
           and RD.IS_ANUL = 1
           and RD.REASON_OF_ANUL in ('NOSHOW', 'CANCELED')
    group by 1, 2, 3, 4, 5, 6, 7, 8, 9
    into   :busy_date, :id_room_type, :id_profile_agent, :country_code,
           :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
           :rooms_noshow,
           :guests_noshow,
           :rooms_canceled
  do begin
    suspend;
  end
end
^

/* Restore proc. body: RESERV_STATISTIC_SLICE$INT */
ALTER PROCEDURE RESERV_STATISTIC_SLICE$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_PROFILE_AGENT INTEGER,
COUNTRY_CODE VARCHAR(20),
MARKET_SEGMENT_CODE VARCHAR(3),
SOURCE_CODE VARCHAR(3),
CHANNEL_CODE VARCHAR(3),
HEAR_REASON_CODE VARCHAR(3),
COME_REASON_CODE VARCHAR(3))
 AS
begin
  select iif(PA.ID_AGENT > 0, PA.ID_PROFILE, null), GC.COUNTRY,
         MS.MARKET_CODE, SC.SOURCE_CODE, CC.CHANNEL_CODE, HR.HEAR_REASON_CODE, CR.COME_REASON_CODE
  from   RESERV_DETAIL RD
         left outer join GUEST_CARD GC on GC.ID_GUEST = RD.ID_TITULAR
         left outer join PROFILE_AGENT PA on PA.ID_PROFILE = RD.ID_AGENT_PROFILE
         left outer join NOM_CHANNEL_CODES CC on CC.ID_NOM_CHANNEL_CODE = RD.ID_NOM_CHANNEL_CODE
         left outer join NOM_COME_REASONS CR on CR.ID_NOM_COME_REASON = RD.ID_NOM_COME_REASON
         left outer join NOM_HEAR_REASONS HR on HR.ID_NOM_HEAR_REASON = RD.ID_NOM_HEAR_REASON
         left outer join NOM_SOURCE_CODES SC on SC.ID_NOM_SOURCE_CODE = RD.ID_NOM_SOURCE_CODE
         left outer join NOM_MARKET_SEGMENTS MS on MS.ID_NOM_MARKET_SEGMENT = RD.ID_NOM_MARKET_SEGMENT
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :ID_PROFILE_AGENT, :COUNTRY_CODE,
         :MARKET_SEGMENT_CODE, :SOURCE_CODE, :CHANNEL_CODE, :HEAR_REASON_CODE, :COME_REASON_CODE;

  COUNTRY_CODE = coalesce(:COUNTRY_CODE, '');

  suspend;
end
^

/* Restore proc. body: ROOM_SMART_LIST$RSV */
ALTER PROCEDURE ROOM_SMART_LIST$RSV(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(50))
 RETURNS(ROOM_NAME VARCHAR(50),
FREE_BEDS_BASE INTEGER,
FREE_BEDS_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
FEATURES BLOB,
BUSY_GROUP_TYPE INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
DATA1 VARCHAR(255),
DATA2 VARCHAR(255))
 AS
declare variable report_leaving varchar(20);
declare variable suppress_private integer;
begin
  if (:from_date >= :to_date) then exit;
  execute procedure SYSTEM_CHECK_OPERATION(:report_type, 'FREE_ONLY,FREE_AND_LEAVING,BLOCKED,POTENTIAL_SHARE,PRIVATE_USE,ALL');

  suppress_private = iif(:REPORT_TYPE = 'ALL', 0, 1);
  if (:report_type in ('FREE_ONLY','FREE_AND_LEAVING')) then begin
    if (:report_type = 'FREE_AND_LEAVING') then report_leaving = 'AS_FREE';
    else report_leaving = 'AS_LEAVING';
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DBEFORE, SRLF.DAFTER, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_FREE$INT(:from_date, :to_date, :report_leaving, :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end else if (:report_type in ('BLOCKED','POTENTIAL_SHARE')) then begin
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DESCRIPTION, SRLF.PERIOD, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_SHARE$INT(:from_date, :to_date, :report_type, :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end else if (:report_type in ('ALL')) then begin
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DBEFORE, SRLF.DAFTER, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_FREE$INT(:from_date, :to_date, 'FREE_AND_LEAVING', :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;

    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DESCRIPTION, SRLF.PERIOD, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_SHARE$INT(:from_date, :to_date, 'POTENTIAL_SHARE', :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end
end
^

/* Restore proc. body: SAFE_OCCUPANCY_MODIFY */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE TYPE OF ID,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable old_booking_number tres_number;
  declare variable id_resource_reservation id_ref;
  declare variable from_datetime tdatetime;
  declare variable action_text tdescription_long;
  declare variable old_occupant varchar(100);
  declare variable old_to_dt timestamp;
  declare variable id_reserv_detail integer;
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation;

  select rr.BOOKING_NUMBER, od.FROM_DATETIME,
         RR.OCCUPANT_NAME, od.TO_DATETIME, rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESERV_DETAIL rd on rd.NUMBER = rr.BOOKING_NUMBER and rd.IS_ANUL = 0
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :old_booking_number, :from_datetime,
         :old_occupant, :old_to_dt, :id_reserv_detail, :id_agent_profile;

  --if (:old_booking_number <> :BOOKING_NUMBER) then exception ASSERT 'Can not change booking number!';
  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  update SAFE_RESOURCE_RESERV rr
  set    rr.PRICE_DESCRIPTION = :price_description,
         rr.ID_RATE_PRICE_PROFILE = :id_agent_profile,
         rr.RATING_UNITS = :rating_units,
         rr.RATE_PRICE = :price,
         rr.RATE_CURR = :currency
  where  rr.ID_RESOURCE_RESERV = :id_resource_reservation;

  execute procedure RESOURCE_RESERVATION_MODIFY (:id_resource_reservation, :ID_SAFE, :from_datetime,
          :TO_DATETIME, :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :old_booking_number, 'mod')
  returning_values :id_resource_reservation, :no_use;

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail)
  returning_values (:DOC_SELECTED);

  /* Log changes */
  if ((:old_occupant <> :OCCUPANT_NAME) or (:old_to_dt <> :TO_DATETIME)) then begin
    action_text = f_character(29) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                  || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                  || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');
  
    execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_CHANGED', :action_text);
  end
end
^

/* Restore proc. body: SAFE_OCCUPANCY_NEW */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE TYPE OF ID,
FROM_DATETIME TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME,
BOOKING_NUMBER TYPE OF TRES_NUMBER,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
ID_RESOURCE_RESERVATION TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable action_text tdescription_long;
  declare variable id_reserv_detail integer;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, s.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  if (:id_resource_reservation is not null) then exception ASSERT '-1064'|| f_character(31) || f_character(29) || :safe_name;

  select rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESERV_DETAIL rd
  where  rd.NUMBER = :BOOKING_NUMBER
         and rd.IS_ANUL = 0
  into   :id_reserv_detail, :id_agent_profile;

  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  execute procedure  RESOURCE_RESERVATION_MODIFY (null, :ID_SAFE, :FROM_DATETIME, :TO_DATETIME,
          :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :BOOKING_NUMBER, 'add')
  returning_values (:id_resource_reservation, :no_use) ;

  insert into SAFE_RESOURCE_RESERV (ID_RESOURCE_RESERV, PRICE_DESCRIPTION, ID_RATE_PRICE_PROFILE,
         RATING_UNITS, RATE_PRICE, RATE_CURR)
  values (:id_resource_reservation, :price_description, :id_agent_profile,
         :rating_units, :price, :currency);

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail, :ID_EXTERNAL_CLIENT_ACCCOUNT)
  returning_values (:DOC_SELECTED);

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = 'CHECKED_IN'
  where  RR.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = :id_resource_reservation
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                || f_character(28) || coalesce(:BOOKING_NUMBER, '')
                || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUPIED', :action_text);
end
^

/* Restore proc. body: SUMMARY_OCCUPANCY_STATISTIC$INT */
ALTER PROCEDURE SUMMARY_OCCUPANCY_STATISTIC$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
declare variable busy_date date;
  declare variable id_room_type integer;
  declare variable id_profile_agent integer;
  declare variable country_code varchar(20);
  declare variable market_segment_code varchar(3);
  declare variable source_code varchar(3);
  declare variable channel_code varchar(3);
  declare variable hear_reason_code varchar(3);
  declare variable come_reason_code varchar(3);
  declare variable rooms_noshow smallint;
  declare variable rooms_canceled smallint;

  declare variable rooms_ooi smallint;
  declare variable rooms_ooo smallint;

  declare variable rooms_sold smallint;
  declare variable rooms_sold_multiple_gst smallint;
  declare variable rooms_arrival smallint;
  declare variable rooms_departure smallint;
  declare variable ad_in_house smallint;
  declare variable ad_arrival smallint;
  declare variable ad_departure smallint;
  declare variable ch_in_house smallint;
  declare variable ch_arrival smallint;
  declare variable ch_departure smallint;
  declare variable guests_noshow smallint;
  declare variable guests_day_use smallint;
begin
  -- REBUILD THE "NO SLICE"
  delete from SUMMARY_OCCUPANCY D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY (ID_ROOM_TYPE, FOR_DATE, ROOMS_AVAILABLE, ID_HOTEL)
  select RC.ID_ROOM_TYPE, RC.FOR_DATE, sum(RC.CNT_DEFINED), :id_hotel
  from   HOTEL H
         left outer join ALLOTMENT_GET$INT(H.ID_INVENTORY_ALLOTMENT, :from_date, :to_date, null, 'PLAIN_PERIOD', H.ID_HOTEL) RC on 0=0
  where  H.ID_HOTEL = :id_hotel
         and RC.ID_ROOM_TYPE is not null
  group by 1, 2;

  for
    select RO.ID_ROOM_TYPE, RO.BUSY_DATE,
           sum(RO.OOI_ROOM), sum(RO.OOO_ROOM),
           sum(RO.ARRIVAL_ROOM + ro.STAYOVER_ROOM) as sold_rooms,
           sum(RO.MULTIPLE_GUEST_ROOM),
           sum(RO.ARRIVAL_ROOM),
           sum(RO.DEPARTURE_ROOM),
           sum(RO.ARRIVAL_ADULTS + ro.STAYOVER_ADULTS - ro.DAY_USE_ADULTS) as AD_IN_HOUSE,
           sum(RO.ARRIVAL_ADULTS),
           sum(RO.DEPARTURE_ADULTS),
           sum(RO.ARRIVAL_CHILDREN + ro.STAYOVER_CHILDREN - ro.DAY_USE_CHILDREN) as CH_IN_HOUSE,
           sum(RO.ARRIVAL_CHILDREN),
           sum(RO.DEPARTURE_CHILDREN),
           sum(RO.DAY_USE_ADULTS + ro.DAY_USE_CHILDREN)
    from   HOTEL_ROOM_OCCUPANCY ro
    where  ro.ID_HOTEL = :id_hotel
           and ro.BUSY_DATE between :from_date and :to_date
           and ro.BUSY_GROUP_TYPE > 1 -- excludes expected bookings
    group by RO.ID_ROOM_TYPE, RO.BUSY_DATE
    into   :id_room_type, :busy_date,
           :rooms_ooi, :rooms_ooo,
           :rooms_sold, :rooms_sold_multiple_gst, :rooms_arrival, :rooms_departure,
           :ad_in_house, :ad_arrival, :ad_departure,
           :ch_in_house, :ch_arrival, :ch_departure, :guests_day_use
  do begin
    update or insert into SUMMARY_OCCUPANCY (ID_ROOM_TYPE, FOR_DATE, ROOMS_OOI, ROOMS_OOO, ROOMS_SOLD, ROOMS_SOLD_MULTIPLE_GST,
           ROOMS_ARRIVAL, ROOMS_DEPARTURE, GST_AD_IN_HOUSE, GST_AD_ARRIVAL, GST_AD_DEPARTURE,
           GST_CH_IN_HOUSE, GST_CH_ARRIVAL, GST_CH_DEPARTURE, GUESTS_DAY_USE)
    values (:id_room_type, :busy_date, :rooms_ooi, :rooms_ooo, :rooms_sold, :rooms_sold_multiple_gst,
           :rooms_arrival, :rooms_departure, :ad_in_house, :ad_arrival, :ad_departure,
           :ch_in_house, :ch_arrival, :ch_departure, :guests_day_use)
    matching (ID_ROOM_TYPE, FOR_DATE);
  end

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, 
           sum(M.ROOMS_NOSHOW), sum(M.ROOMS_CANCELED), sum(M.GUESTS_NOSHOW)
    from   RESERV_STATISTIC_CANCELED$INT(:id_hotel, :from_date, :to_date) M
    group by M.ID_ROOM_TYPE, M.BUSY_DATE
    into   :id_room_type, :busy_date, 
           :rooms_noshow, :rooms_canceled, :guests_noshow
  do begin
    update SUMMARY_OCCUPANCY SO
    set    SO.ROOMS_NOSHOW = :rooms_noshow,
           SO.ROOMS_CANCELED = :rooms_canceled,
           SO.GUESTS_NOSHOW = :guests_noshow
    where  SO.FOR_DATE = :busy_date
           and SO.ID_ROOM_TYPE = :id_room_type;

  end

  -- REBUILD THE "MARKET SLICE"
  delete from SUMMARY_OCCUPANCY_MARKET D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY_MARKET (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL,
         MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
         ROOMS_SOLD, ROOMS_SOLD_MULTIPLE_GST, ROOMS_ARRIVAL, ROOMS_DEPARTURE,
         ROOMS_NOSHOW, ROOMS_CANCELED, GUESTS_IN_HOUSE,
         GUESTS_ARRIVAL, GUESTS_DEPARTURE, GUESTS_DAY_USE)
  select M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL,
         S.MARKET_SEGMENT_CODE, S.SOURCE_CODE, S.CHANNEL_CODE, S.HEAR_REASON_CODE, S.COME_REASON_CODE,
         sum(m.ARRIVAL_ROOM + m.STAYOVER_ROOM), sum(M.MULTIPLE_GUEST_ROOM), sum(M.ARRIVAL_ROOM), sum(M.DEPARTURE_ROOM),
         0, 0, sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN + m.STAYOVER_ADULTS + m.STAYOVER_CHILDREN - m.DAY_USE_ADULTS - m.DAY_USE_CHILDREN),
         sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN), sum(M.DEPARTURE_ADULTS + m.DEPARTURE_CHILDREN), sum(M.DAY_USE_ADULTS + m.DAY_USE_CHILDREN)
  from   HOTEL_ROOM_OCCUPANCY M
         left outer join RESERV_STATISTIC_SLICE$INT (m.ID_RESERV_STATISTICS) s on 1=1
  where  m.ID_HOTEL = :id_hotel
         and m.BUSY_DATE between :from_date and :to_date
         and m.BUSY_GROUP_TYPE > 1 -- excludes expected bookings
  group by M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL,
         S.MARKET_SEGMENT_CODE, S.SOURCE_CODE, S.CHANNEL_CODE, S.HEAR_REASON_CODE, S.COME_REASON_CODE;

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, 
           M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE,
           sum(M.ROOMS_NOSHOW), sum(M.ROOMS_CANCELED)
    from   RESERV_STATISTIC_CANCELED$INT(:id_hotel, :from_date, :to_date) M
    group by M.ID_ROOM_TYPE, M.BUSY_DATE, M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE
    into   :id_room_type, :busy_date,
           :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
           :rooms_noshow, :rooms_canceled
  do begin
    update SUMMARY_OCCUPANCY_MARKET MA
    set    MA.ROOMS_NOSHOW = :rooms_noshow,
           MA.ROOMS_CANCELED = :rooms_canceled
    where  MA.FOR_DATE = :busy_date
           and MA.ID_ROOM_TYPE = :id_room_type
           and MA.MARKET_SEGMENT_CODE = :market_segment_code
           and MA.SOURCE_CODE = :source_code
           and MA.CHANNEL_CODE = :channel_code
           and MA.HEAR_REASON_CODE = :hear_reason_code
           and MA.COME_REASON_CODE = :come_reason_code;
    if (row_count = 0) then begin
      insert into SUMMARY_OCCUPANCY_MARKET (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL,
             MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
             ROOMS_NOSHOW, ROOMS_CANCELED)
      values (:id_room_type, :busy_date, :id_hotel,
             :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
             :rooms_noshow, :rooms_canceled);
    end
  end

  -- REBUILD THE "PROFILE/COUNTRY SLICE"
  delete from SUMMARY_OCCUPANCY_OTHER D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY_OTHER (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL, ID_PROFILE_AGENT, COUNTRY_CODE,
         ROOMS_SOLD, ROOMS_SOLD_MULTIPLE_GST, ROOMS_ARRIVAL, ROOMS_DEPARTURE,
         ROOMS_NOSHOW, ROOMS_CANCELED, GUESTS_IN_HOUSE, GUESTS_ARRIVAL, GUESTS_DEPARTURE, GUESTS_DAY_USE)
  select M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL, S.ID_PROFILE_AGENT, S.COUNTRY_CODE,
         sum(m.ARRIVAL_ROOM + m.STAYOVER_ROOM), sum(M.MULTIPLE_GUEST_ROOM), sum(M.ARRIVAL_ROOM), sum(M.DEPARTURE_ROOM),
         0, 0, sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN + m.STAYOVER_ADULTS + m.STAYOVER_CHILDREN - m.DAY_USE_ADULTS - m.DAY_USE_CHILDREN),
         sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN), sum(M.DEPARTURE_ADULTS + m.DEPARTURE_CHILDREN), sum(M.DAY_USE_ADULTS + m.DAY_USE_CHILDREN)
  from   HOTEL_ROOM_OCCUPANCY M
         left outer join RESERV_STATISTIC_SLICE$INT (m.ID_RESERV_STATISTICS) s on 1=1
  where  m.ID_HOTEL = :id_hotel
         and m.BUSY_DATE between :from_date and :to_date
         and m.BUSY_GROUP_TYPE > 1 -- excludes expected bookings
  group by M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL, S.ID_PROFILE_AGENT, S.COUNTRY_CODE;

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, M.ID_PROFILE_AGENT, M.COUNTRY_CODE,
           sum(M.ROOMS_NOSHOW), sum(M.ROOMS_CANCELED)
    from   RESERV_STATISTIC_CANCELED$INT(:id_hotel, :from_date, :to_date) M
    group by M.ID_ROOM_TYPE, M.BUSY_DATE, M.ID_PROFILE_AGENT, M.COUNTRY_CODE
    into   :id_room_type, :busy_date, :id_profile_agent, :country_code,
           :rooms_noshow, :rooms_canceled
  do begin

    update SUMMARY_OCCUPANCY_OTHER MA
    set    MA.ROOMS_NOSHOW = :rooms_noshow,
           MA.ROOMS_CANCELED = :rooms_canceled
    where  MA.FOR_DATE = :busy_date
           and MA.ID_ROOM_TYPE = :id_room_type
           and MA.ID_PROFILE_AGENT = :id_profile_agent
           and MA.COUNTRY_CODE = :country_code;
    if (row_count = 0) then begin
      insert into SUMMARY_OCCUPANCY_OTHER (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL,
             ID_PROFILE_AGENT, COUNTRY_CODE, ROOMS_NOSHOW, ROOMS_CANCELED)
      values (:id_room_type, :busy_date, :id_hotel,
             :id_profile_agent, :country_code, :rooms_noshow, :rooms_canceled);
    end
  end

  -- REBUILD THE "PROFILE/MARKETING SLICE"
  delete from SUMMARY_OCCUPANCY_PROFILE_MRKT D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY_PROFILE_MRKT (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL, ID_PROFILE_AGENT,
         MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
         ROOMS_SOLD, ROOMS_SOLD_MULTIPLE_GST, ROOMS_ARRIVAL, ROOMS_DEPARTURE,
         ROOMS_NOSHOW, ROOMS_CANCELED, GUESTS_IN_HOUSE, GUESTS_ARRIVAL, GUESTS_DEPARTURE, GUESTS_DAY_USE)
  select M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL, S.ID_PROFILE_AGENT,
         S.MARKET_SEGMENT_CODE, S.SOURCE_CODE, S.CHANNEL_CODE, S.HEAR_REASON_CODE, S.COME_REASON_CODE,
         sum(m.ARRIVAL_ROOM + m.STAYOVER_ROOM), sum(M.MULTIPLE_GUEST_ROOM), sum(M.ARRIVAL_ROOM), sum(M.DEPARTURE_ROOM),
         0, 0, sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN + m.STAYOVER_ADULTS + m.STAYOVER_CHILDREN - m.DAY_USE_ADULTS - m.DAY_USE_CHILDREN),
         sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN), sum(M.DEPARTURE_ADULTS + m.DEPARTURE_CHILDREN), sum(M.DAY_USE_ADULTS + m.DAY_USE_CHILDREN)
  from   HOTEL_ROOM_OCCUPANCY M
         left outer join RESERV_STATISTIC_SLICE$INT (m.ID_RESERV_STATISTICS) s on 1=1
  where  m.ID_HOTEL = :id_hotel
         and m.BUSY_DATE between :from_date and :to_date
         and m.BUSY_GROUP_TYPE > 1 -- excludes expected bookings
  group by M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL, s.ID_PROFILE_AGENT,
         S.MARKET_SEGMENT_CODE, S.SOURCE_CODE, S.CHANNEL_CODE, S.HEAR_REASON_CODE, S.COME_REASON_CODE;

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, M.ID_PROFILE_AGENT,
           M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE,
           sum(M.ROOMS_NOSHOW), sum(M.ROOMS_CANCELED)
    from   RESERV_STATISTIC_CANCELED$INT(:id_hotel, :from_date, :to_date) M
    group by M.ID_ROOM_TYPE, M.BUSY_DATE, M.ID_PROFILE_AGENT,
           M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE
    into   :id_room_type, :busy_date,  :id_profile_agent,
           :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
           :rooms_noshow, :rooms_canceled
  do begin

    update SUMMARY_OCCUPANCY_PROFILE_MRKT MA
    set    MA.ROOMS_NOSHOW = :rooms_noshow,
           MA.ROOMS_CANCELED = :rooms_canceled
    where  MA.FOR_DATE = :busy_date
           and MA.ID_ROOM_TYPE = :id_room_type
           and MA.ID_PROFILE_AGENT = :id_profile_agent
           and MA.MARKET_SEGMENT_CODE = :market_segment_code
           and MA.SOURCE_CODE = :source_code
           and MA.CHANNEL_CODE = :channel_code
           and MA.HEAR_REASON_CODE = :hear_reason_code
           and MA.COME_REASON_CODE = :come_reason_code;
    if (row_count = 0) then begin
      insert into SUMMARY_OCCUPANCY_PROFILE_MRKT (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL, ID_PROFILE_AGENT,
             MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
             ROOMS_NOSHOW, ROOMS_CANCELED)
      values (:id_room_type, :busy_date, :id_hotel, :id_profile_agent,
             :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
             :rooms_noshow, :rooms_canceled);
    end
  end
end
^

/* Restore proc. body: TAR_BO_PRICE_GET */
ALTER PROCEDURE TAR_BO_PRICE_GET(ID_TAR_BO_PRICE ID)
 RETURNS(PRICE_VALUE TYPE OF TTEXT_FORMULA,
PRICE_TYPE TYPE OF NAME_20)
 AS
begin
  select p.PRICE_TYPE, p.PRICE_VALUE
  from   TAR_BO_PRICES p
  where  p.ID_TAR_BO_PRICE = :ID_TAR_BO_PRICE
  into   :PRICE_TYPE, :PRICE_VALUE;

  begin
    if (cast(:PRICE_VALUE as TPRICE) is not null) then suspend;

    when any do exception RATING_EXCEPTION '-62' || f_character(31) || f_character(29) || coalesce(:PRICE_VALUE, '');
  end
end
^

/* Restore proc. body: TAR_CALC_EVAL_COMPLEX_RATE$INT */
ALTER PROCEDURE TAR_CALC_EVAL_COMPLEX_RATE$INT(INPUT_DETAIL_DBKEY CHAR(8),
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
BEDS SMALLINT,
ID_TYPE_STAY INTEGER,
IS_MANUAL_TYPE_STAY SMALLINT,
ID_BOARD INTEGER,
ID_ROOM_TYPE INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
CHECKIN_DATE DATE,
DAY_OF_STAY INTEGER,
PAYORS INTEGER,
MINORS INTEGER,
PERIOD_DEPEND_ON_CHECKIN SMALLINT,
CNT_DAYS_BP INTEGER,
CNT_DAYS_BOARD INTEGER,
BOARD_TYPE_FIND VARCHAR(10),
TOTAL_GUESTS INTEGER,
SEQ_NUM INTEGER,
TARIFF_CURR CHAR(3),
REAL_RECALC SMALLINT)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_PAYORS INTEGER,
OUT_MINORS INTEGER)
 AS
declare variable id_tar_input_detail integer;
  declare variable price numeric(15,4);
  declare variable auto_stay_type integer;
  declare variable base_per_day numeric(15,4);
  declare variable board_per_day numeric(15,4);
  declare variable guest_board_weight integer;
--  declare variable guest_food varchar(20);
  declare variable match_date date;
  declare variable manual_total_gsts integer;
  declare variable manual_payors integer;
  declare variable manual_minors integer;
  declare variable service_type varchar(20);
  declare variable base_price numeric(15,4);
  declare variable board_price numeric(15,4);
  declare variable food_per_day numeric(15,4);
  declare variable base_price_tar numeric(15,4);
  declare variable custom_cross_rate double precision;
  declare variable ptext varchar(20);
  declare variable id_service integer;
  declare variable qty_post integer;
  declare variable pack_currency char(3);
  declare variable minors_input integer;
  declare variable packet_item integer;
  declare variable price_tariff numeric(15,4);
  declare variable is_inside_base integer;
  declare variable id_bo_bp integer;
  declare variable id_board_include integer;
  declare variable separate_board integer;
  declare variable incomplete_bp integer;
  declare variable id_bo_eg integer;
  declare variable id_eg_price integer;
  declare variable disc_tag varchar(50);
  declare variable id_discount_service integer;
  declare variable var_board_price numeric(15,4);
  declare variable type_stay_code varchar(10);
begin
  base_per_day = 0;
  board_per_day = 0;

  select TH.WEIGHT_TAG
  from   MEALS TH
  where  TH.ID_BOARD = :ID_BOARD
  into   :guest_board_weight;
  guest_board_weight = coalesce(:guest_board_weight, 0);

  /*if (:guest_board_weight = 0) then GUEST_FOOD = 'NONE';
  else GUEST_FOOD = 'SOME';*/
  if (:PERIOD_DEPEND_ON_CHECKIN = 1) then MATCH_DATE = :CHECKIN_DATE;
  else MATCH_DATE = :FOR_DATE;

  select st.TYPE_STAY_CODE
  from   TYPE_STAY st
  where  st.ID_TYPE_STAY = :id_type_stay
  into   :type_stay_code;

  if (:IS_MANUAL_TYPE_STAY = 1) then begin
    if (:type_stay_code = 'ALONE') then begin
      MANUAL_TOTAL_GSTS = 1;
      MANUAL_PAYORS = 0;
      MANUAL_MINORS = 0;
    end else if (:type_stay_code = 'BED') then begin
      MANUAL_TOTAL_GSTS = 2;
      MANUAL_PAYORS = 1;
      MANUAL_MINORS = 0;
    end else if (:type_stay_code = 'EXTRA_BED') then begin
      MANUAL_TOTAL_GSTS = :BEDS+1;
      MANUAL_PAYORS = :BEDS;
      MANUAL_MINORS = :MINORS;
    end

    execute procedure TAR_MATCH_BP(:INPUT_DETAIL_DBKEY, :MATCH_DATE, :MANUAL_TOTAL_GSTS, :MANUAL_TOTAL_GSTS,
                      :GUEST_BOARD_WEIGHT, :REAL_RECALC, :DAY_OF_STAY, :CNT_DAYS_BP)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_BP, :ID_BOARD_INCLUDE,
                      :INCOMPLETE_BP, :BASE_PRICE, :PTEXT, :BASE_PER_DAY;
  end else begin
    execute procedure TAR_MATCH_BP(:INPUT_DETAIL_DBKEY, :MATCH_DATE, :SEQ_NUM, :TOTAL_GUESTS,
                      :GUEST_BOARD_WEIGHT, :REAL_RECALC, :DAY_OF_STAY, :CNT_DAYS_BP)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_BP, :ID_BOARD_INCLUDE,
                      :INCOMPLETE_BP, :BASE_PRICE, :PTEXT, :BASE_PER_DAY;
  end

  execute procedure sys_dbg('tar base_per_day = '||coalesce(:BASE_PER_DAY, 'null'));
  execute procedure sys_dbg('tar base_price = '||coalesce(:BASE_PRICE, 'null'));
  if (:ERR_CODE < 0) then exit;

  SEPARATE_BOARD = 0;
  if (:REAL_RECALC = 1) then begin
    if (:CUSTOM_PRICE is not null) then begin
      base_price = :CUSTOM_PRICE;
      execute procedure CURR_CROSS_RATE_GET(:CUSTOM_CURRENCY, :TARIFF_CURR, current_timestamp, 1)
      returning_values  :custom_cross_rate;
      base_price_tar = (:custom_cross_rate * :base_price);
      pack_currency = :custom_currency;
    end else begin
      base_price_tar = :base_per_day;
      pack_currency = :tariff_curr;
    end
    /*DEBUG*/
    if (:base_price is null) then exception RATING_EXCEPTION ('4. base price is null');
    if (:base_price_tar is null) then exception RATING_EXCEPTION ('5. base price tar is null');

    select TBP.PACKET_ITEM
    from   TAR_BO_BASE_POSITION TBP
    where  TBP.ID_TAR_BP = :id_bo_bp
    into   :packet_item;

    insert into TAR_CALC_OUTPUT$TMP (
           ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
           FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
           CURRENCY, CURRENCY_TARIFF, REQUIRED_ID_PACKET_ITEM)
    values (:ID_TAR_INPUT, :ID_TAR_CALC, -1, 'BASE',
           :FOR_DATE, :BASE_PER_DAY, :BASE_PRICE_TAR, 'BASE', 1, :PTEXT,
           :PACK_CURRENCY, :TARIFF_CURR, :packet_item);
    /* BOARDS */
    var_board_price = 0;
    for
      select TMB.ERR_CODE, TMB.ERR_TEXT, TMB.SEPARATE_BOARD, TMB.BOARD_PRICE, TMB.PTEXT,
             TMB.SERVICE_TYPE, TMB.ID_SERVICE, TMB.FOOD_PER_DAY, TMB.PACKET_ITEM
      from   TAR_MATCH_BOARD(:INPUT_DETAIL_DBKEY, :id_bo_bp, :BOARD_TYPE_FIND,
             :ID_BOARD, :id_board_include, :match_date, :base_per_day,
             :DAY_OF_STAY, :CNT_DAYS_BOARD, :CNT_DAYS_BP, :CUSTOM_PRICE) TMB
      into   :err_code, :err_text, :separate_board, :board_price, :ptext,
             :service_type, :id_service, :food_per_day, :packet_item
    do begin
      if (:ERR_CODE < 0) then exit;

      /*DEBUG*/
      if (:board_price is null) then exception RATING_EXCEPTION ('6. board_price is null');
      if (:id_service is null) then exception RATING_EXCEPTION ('7. id_service is null');

      insert into TAR_CALC_OUTPUT$TMP (
             ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
             FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
             CURRENCY, CURRENCY_TARIFF, REQUIRED_ID_PACKET_ITEM)
      values (:ID_TAR_INPUT, :ID_TAR_CALC, :ID_SERVICE, :SERVICE_TYPE,
             :FOR_DATE, :food_per_day, :food_per_day, 'FOOD', 1, :PTEXT,
             :TARIFF_CURR, :TARIFF_CURR, :packet_item);

      -- board_per_day = (:board_per_day + :food_per_day); ???
      var_board_price = :var_board_price + iif(:service_type in ('BASE_BOARD', 'EXTRA_BOARD'), :food_per_day, 0);
    end

    select TID.ID_TAR_INPUT_DETAIL
    from   TAR_CALC_INPUT_DETAIL$TMP TID
    where  tid.RDB$DB_KEY = :INPUT_DETAIL_DBKEY
    into   :id_tar_input_detail;

    execute procedure TAR_SET_VAR('board='||:VAR_BOARD_PRICE, :id_tar_input_detail, :id_tar_calc);
  end

  if (:SEPARATE_BOARD is null) then SEPARATE_BOARD = 0;
  minors_input = :MINORS;

  if (:IS_MANUAL_TYPE_STAY = 1) then begin
    /* ONLY TO FIND THE REAL POSITION PAYORS, MINORS ARE NOT IMPORTANT
    || ALL OTHER GUESTS IN THE ROOM MUST SEE THE MANUAL ONE AS AUTOMATIC. SO
    || HERE WE ARE FINDING HIS AUTOMATIC TYPE STAY.
    */
    execute procedure TAR_MATCH_EG(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :total_guests, :PAYORS, :MINORS, :MATCH_DATE, :INCOMPLETE_BP, :ID_ROOM_TYPE, 1)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_EG, :ID_EG_PRICE, :PAYORS, :MINORS, :AUTO_STAY_TYPE;
    if (:ERR_CODE < 0) then exit;
    /* REAL PRICE FIND AND EVAL */
    execute procedure TAR_MATCH_MANUAL_EG(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :MANUAL_TOTAL_GSTS, :MANUAL_PAYORS, :MANUAL_MINORS, :MATCH_DATE, :INCOMPLETE_BP, :ID_TYPE_STAY)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_EG, :ID_EG_PRICE, :AUTO_STAY_TYPE;
    if (:ERR_CODE < 0) then exit;

    if ((:MINORS = :minors_input) and
        (exists (select *
                 from   TYPE_STAY TS
                 where  TS.ID_TYPE_STAY = :ID_TYPE_STAY
                        and TS.TYPE_STAY_CODE = 'EXTRA_BED'))) then begin
      /* TO MANAGE PARAMETER "EXTRA GUEST IN TURN" WHEN MANUAL SET TO ADD */
      MINORS = :MINORS + 1;
      PAYORS = :PAYORS - 1;
    end
  end else begin
    execute procedure TAR_MATCH_EG(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :TOTAL_GUESTS, :PAYORS, :MINORS, :MATCH_DATE, :INCOMPLETE_BP, :ID_ROOM_TYPE, 0)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_EG, :ID_EG_PRICE, :PAYORS, :MINORS, :AUTO_STAY_TYPE;
    if (:ERR_CODE < 0) then exit;
  end

  update TAR_CALC_INPUT_DETAIL$TMP TID
  set    TID.SEPARATE_BOARD = :SEPARATE_BOARD,
         TID.ID_TYPE_STAY   = :AUTO_STAY_TYPE
  where  TID.RDB$DB_KEY = :INPUT_DETAIL_DBKEY;

  if (:REAL_RECALC = 1) then begin
    if (:CUSTOM_PRICE is null) then begin
      for
        select TSP.SERVICE_TYPE, TSP.PRICE,  TSP.PTEXT, TSP.ERR_CODE, TSP.ID_SERVICE
        from   TAR_PRICES_SET_EG(:ID_TAR_INPUT, :FOR_DATE, :DAY_OF_STAY, :CNT_DAYS_BP,
               :CNT_DAYS_BOARD, :guest_board_weight, :id_bo_eg, :id_eg_price, :base_price) TSP
        into   :service_type, :price,  :ptext, :ERR_CODE, :id_service
      do begin
        if (:ERR_CODE < 0) then exit; -- exception INTERNAL_RATING_EXCEPTION;

        /*DEBUG*/
        if (:PRICE is null) then exception RATING_EXCEPTION ('8. price is null');
        if (:ID_SERVICE is null) then exception RATING_EXCEPTION ('9. id_service is null');

        insert into TAR_CALC_OUTPUT$TMP (
               ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
               FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
               CURRENCY, CURRENCY_TARIFF, REQUIRED_ID_PACKET_ITEM)
        values (:ID_TAR_INPUT, :ID_TAR_CALC, :id_service, :service_type,
               :FOR_DATE, :price, :price, 'EG', 1, :ptext,
               :TARIFF_CURR, :TARIFF_CURR, :packet_item);
      end
    end

    for
      select TMT.ID_SERVICE, TMT.SERVICE_TYPE, TMT.PRICE, TMT.PRICE_TARIFF, TMT.QTY_POST,
             TMT.PTEXT, TMT.PACK_CURRENCY, TMT.ERR_CODE, TMT.ERR_TEXT, TMT.PACKET_ITEM, TMT.DISC_TAG
      from   TAR_PRICES_SET_PACKS(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :DAY_OF_STAY, :CUSTOM_PRICE) TMT
      into   :ID_SERVICE, :SERVICE_TYPE, :PRICE, :PRICE_TARIFF, :QTY_POST,
             :PTEXT, :PACK_CURRENCY, :ERR_CODE, :ERR_TEXT, :PACKET_ITEM, :DISC_TAG
    do begin
      if (:ERR_CODE < 0) then exit; --exception INTERNAL_RATING_EXCEPTION;
      /*DEBUG*/
      if (:price_tariff is null) then exception RATING_EXCEPTION ('10. PRICE_TARIFF is null');
      if (:id_service is null) then exception RATING_EXCEPTION ('11. ID_SERVICE is null');

      insert into TAR_CALC_OUTPUT$TMP (
             ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
             FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
             CURRENCY, CURRENCY_TARIFF, DISC_TAG, REQUIRED_ID_PACKET_ITEM)
      values (:ID_TAR_INPUT, :ID_TAR_CALC, :ID_SERVICE, :SERVICE_TYPE,
             :FOR_DATE, :PRICE, :PRICE_TARIFF, 'PACK', :QTY_POST, :PTEXT,
             :PACK_CURRENCY, :TARIFF_CURR, :DISC_TAG, :packet_item);

    end

    for
      select TMT.ID_SERVICE, TMT.SERVICE_TYPE, TMT.PRICE, TMT.PTEXT, TMT.ERR_CODE, TMT.ERR_TEXT, TMT.PACKET_ITEM,
             TMT.IS_INSIDE_BASE, TMT.DISC_TAG, TMT.ID_DISCOUNT_SERVICE
      from   TAR_PRICES_SET_TAX(:ID_TAR_INPUT, :INPUT_DETAIL_DBKEY, :ID_BO_BP, :DAY_OF_STAY) tmt
      into   :ID_SERVICE, :SERVICE_TYPE, :PRICE, :PTEXT, :ERR_CODE, :ERR_TEXT, :PACKET_ITEM,
             :IS_INSIDE_BASE, :DISC_TAG, :ID_DISCOUNT_SERVICE
    do begin
      if (:ERR_CODE < 0) then exit; --exception INTERNAL_RATING_EXCEPTION;
      if ((:IS_INSIDE_BASE = 0) and (:CUSTOM_PRICE is not null)) then begin
        -- SKIP IT. SIMPLE DISCOUNTS MUST NOT CHANGE THE CUSTOM PRICE
      end else begin
        /*DEBUG*/
        if (:PRICE is null) then exception RATING_EXCEPTION ('12. price is null');
        if (:ID_SERVICE is null) then exception RATING_EXCEPTION ('13. id_service is null');
        -- !!! Service type and id_service of discount is as object that they discounting but in TAR_CALC_REPOST$INT type and id_service is changed to PACKAGES if discounts have ID_DISCOUNT_SERVICE
        if ((:DISC_TAG = '') or (:DISC_TAG is null)) then DISC_TAG =  'DISC';
        insert into TAR_CALC_OUTPUT$TMP (
               ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
               FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
               CURRENCY, CURRENCY_TARIFF, DISC_TAG, ID_DISCOUNT_SERVICE, REQUIRED_ID_PACKET_ITEM)
        values (:ID_TAR_INPUT, :ID_TAR_CALC, :ID_SERVICE, :SERVICE_TYPE,
               :FOR_DATE, :PRICE, :PRICE, 'DISC', 1, :PTEXT,
               :TARIFF_CURR, :TARIFF_CURR, :DISC_TAG, :id_discount_service, :packet_item);

        execute procedure sys_dbg('tar TAR_CALC_EVAL_DATE$INT - :DISC_TAG=' || coalesce(:DISC_TAG, 'null') );
      end
    end
  end

  OUT_MINORS = :MINORS;
  OUT_PAYORS = :PAYORS;
end
^

/* Restore proc. body: TAR_CALC_EVAL_PERIOD$INT */
ALTER PROCEDURE TAR_CALC_EVAL_PERIOD$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_input integer;
  declare variable int_err_text varchar(255);
  declare variable disc_tag varchar(50);
  declare variable deduction_date date;
  declare variable service_type varchar(20);
  declare variable id_service integer;
  declare variable price numeric(15, 4);
  declare variable ptext varchar(20);
  declare variable tariff_curr char(3);
begin
  err_code = 0;
  for
    select TMT.ID_SERVICE, TMT.SERVICE_TYPE, TMT.PRICE, TMT.PTEXT, TMT.ERR_CODE, TMT.ERR_TEXT,
           TMT.ID_TAR_INPUT, TMT.TARIFF_CURR, TMT.DEDUCTION_DATE, TMT.DISC_TAG
    from   TAR_PRICES_SET_TAX_PERIOD(:id_tar_calc) TMT
    into   :id_service, :service_type, :price, :ptext, :err_code, :int_err_text,
           :id_tar_input, :tariff_curr, :deduction_date, :disc_tag
  do begin
    if (:err_code < 0) then begin err_text = substring(err_text||:int_err_text from 1 for 255); exit; end
    insert into TAR_CALC_OUTPUT$TMP (
           ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE, DISC_TAG, PRICE_NOTE,
           FOR_DATE, PRICE, PRICE_TARIFF, QTY_POST, PTEXT, CURRENCY, CURRENCY_TARIFF)
    values (:id_tar_input, :id_tar_calc, :id_service, :service_type, :disc_tag, 'DISC_STAY',
           :deduction_date, :price, :price, 1, :ptext, :tariff_curr, :tariff_curr);
  end
end
^

/* Restore proc. body: TAR_CALC_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
declare variable param_code varchar(40);
  declare variable id_param integer;
  declare variable param_value varchar(255);
  declare variable data_type  varchar(30);
  declare variable rate_list varchar(2000);
begin
  err_code = 0;
  param_values = '';

  if (coalesce(:rate_list_replace, '') = '') then rate_list = ',' || :id_rate || ',';
  else rate_list = :rate_list_replace;

  for
    select distinct TBP.PARAM_NAME
    from   SYSTEM_STRING_PARSER (:rate_list, ',') sp
           left join TAR_BO_PARAMS TBP on TBP.ID_TAR_HEAD = sp.ITEM
    where  (TBP.PARAM_TYPE <> 'DATE_DEPENDANT' and :for_date is null)
           or (TBP.PARAM_TYPE = 'DATE_DEPENDANT' and :for_date is not null)
    into   :param_code
  do begin
    if (:param_code is not null) then begin
      id_param = null;
      select TP.ID_TARIFA_PARAM, TP.DATA_TYPE
      from   TARIFA_PARAMS TP
      where  TP.PARAM_CODE = :param_code
             and tp.IS_USE = 1
      into   :id_param, :data_type;
  
      if (:id_param is null) then begin
        err_code = -202;
        execute procedure sys_dbg ('tar calc params err_code: ' || :err_code || F_CRLF() || 'PARAM_CODE = ' || :param_code);
        exit;
      end
  
      execute procedure TARIFA_GET_PARAM (:id_param, :for_date, :id_tar_input, :id_tar_calc)
      returning_values (:param_value);
  
      param_code = ':'||param_code;
  
      if ((:param_code is not null) and (:param_code is not null) and (:data_type is not null)) then
         param_values = :param_values||';'||:param_code||','||:data_type||','||:param_value;
    end
  end
end
^

/* Restore proc. body: TAR_SAVE_BO_BOARD */
ALTER PROCEDURE TAR_SAVE_BO_BOARD(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable id_tar_season integer;
  declare variable iteration varchar(20);
/*****************************************************/
  declare variable id_tar_board integer;
  declare variable id_board integer;
  declare variable id_service integer;
  declare variable pos_numbers varchar(2000);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable separate_board integer;
  declare variable id_bo_price integer;
  declare variable price_type varchar(20);
  declare variable price_type_equal_exists integer;
  declare variable is_board integer;
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  err_text = '';
  iteration = 'FIRST';
  price_type_equal_exists = 0;

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :id_tar_season, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_board, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
      if (:price_type_equal_exists = 1) then begin
        if (exists(
          select *
          from   TAR_BO_RELATION TBR
                 join TAR_BO_BASE_POSITION TBB on TBR.ID_TAR_BP = TBB.ID_TAR_BP
          where  TBR.ID_BO = :id_tar_board
                 and TBR.BO_TYPE = 'BOARD'
                 and TBB.ID_BOARD_INCLUDE is not distinct from :id_board
        )) then begin
          err_code = -237;
          exit;
        end
      end
      price_type_equal_exists = 0;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_board = gen_id(GEN_TAR_BO_BOARD_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers = '';
      id_board = null;
      separate_board = 0;
      ptext = '';
      disc_tag = 'F';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      packet_item = null;
    end
    if (:iteration = 'MIDDLE') then begin
      if (:param_name = 'PTEXT') then ptext = :data;
      else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
      else if (:param_name = 'SET_VAR')       then set_var = :data;
      else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
      else if (:param_name = 'LIST_BASE_POS') then pos_numbers = :data;
      else if (:param_name = 'SEPARATE_BOARD') then begin
        separate_board = :data;
        if ((:separate_board = 0) and (:board_type = 'HRANI')) then err_code = -226;
      end else if (:param_name = 'CHECKIN_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'NIGHT_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'PACKET_ITEM') then begin
        packet_item = :data;
      end else if (:param_name = 'HRANI') then begin
        if (:data = -1) then err_code = -210;
        else begin
          id_service = :data;
          select m.IS_BOARD
          from   MEALS M
          where  M.ID_SERVICE = :id_service
          into   :is_board;
          id_board = :id_service;

          if ((:is_board = 1) and (:board_type = 'HRANI')) then err_code = -228;
          else if ((:is_board = 0) and (:board_type = 'BOARD')) then err_code = -229;
        end
      end
      if (:err_code < 0) then exit;
      if ((:id_tar_season <> -1) and (:iteration = 'MIDDLE')) then begin
        /* WE ARE STARTING THE SEASON PRICES SO: */
        if ((:id_board is null) or (:id_board = -1)) then err_code = -210;
        else if ((:separate_board = 0) and (:board_type = 'HRANI')) then err_code = -226;
        if (:err_code < 0) then exit;
        if ((:separate_board = 1) and (:board_type = 'HRANI')) then separate_board = 2;
        insert into TAR_BO_BOARD(ID_TAR_BOARD, ID_TAR_HEAD, ID_SERVICE, ID_BOARD, PTEXT, SEPARATE_BOARD,
                    PACKET_ITEM, DISC_TAG, SET_VAR, RND_METHOD)
        values (:id_tar_board, :id_tar_head, :id_service, :id_board, :ptext, :separate_board,
               :packet_item, :disc_tag, :set_var, :rnd_method);
        iteration = 'SEASON_PRICES';
      end
    end
    if (:iteration = 'SEASON_PRICES') then begin
      execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_board, :bo_type, :id_tar_season)
      returning_values  :err_code, :id_bo_price, :price_type;
      if (:price_type = 'EQUAL') then begin
        if (:board_type = 'HRANI') then err_code = -225;
        price_type_equal_exists = 1;
      end
      if (:err_code < 0) then exit;
    end
  end
  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:BO_TYPE||', '||:err_text;
  end
end
^

/* Restore proc. body: TAR_SAVE_BO_BP */
ALTER PROCEDURE TAR_SAVE_BO_BP(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable no_use integer;
  declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable id_tar_season integer;
  declare variable iteration varchar(20);
/*****************************************************/
  declare variable id_tar_bp integer;
  declare variable position_number varchar(20);
  declare variable id_room_type integer;
  declare variable max_persons integer;
  declare variable id_board_include integer;
  declare variable is_price_for_room integer;
  declare variable ptext varchar(20);
  declare variable price_type varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable board_weight integer;
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :id_tar_season, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      param_filter = :data||season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      insert into TAR_BO_RELATION(ID_TAR_BP, BO_TYPE, ID_BO, PARAM_FILTER)
      values (:id_tar_bp, :bo_type, :id_tar_bp, :param_filter);
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_bp = gen_id(GEN_TAR_BO_BP_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      position_number = null;
      id_room_type = null;
      max_persons = null;
      id_board_include = -1;
      is_price_for_room = 0;
      ptext = '';
      disc_tag = 'B';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      packet_item = null;
    end
    if (:iteration = 'MIDDLE') then begin
      if (:param_name = 'BASE_POS')            then begin
        if (:data = '') then err_code = -203;
        else position_number = :data;
      end else if (:param_name = 'ROOM_TYPE')  then begin
        if (:data = '') then err_code = -204;
        else id_room_type = :data;
      end else if (:param_name = 'MAX_PERSONS')then begin
        if (:data = '') then err_code = -205;
        else max_persons = :data;
      end else if (:param_name = 'CHECKIN_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'NIGHT_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'BOARD')      then id_board_include = :data;
      else if (:param_name = 'BPRICE_ROOM')    then is_price_for_room = :data;
      else if (:param_name = 'PACKET_ITEM')    then packet_item = :data;
      else if (:param_name = 'PTEXT')          then ptext = :data;
      else if (:param_name = 'DISC_TAG')       then disc_tag = :data;
      else if (:param_name = 'SET_VAR')        then set_var = :data;
      else if (:param_name = 'ROUND_TYPE')     then rnd_method = :data;
      if (:err_code < 0) then exit;
      if ((:id_tar_season <> -1) and (:iteration = 'MIDDLE')) then begin
        /* WE ARE STARTING THE SEASON PRICES SO: */
        board_weight = null;
        select m.WEIGHT_TAG
        from   MEALS M
        where  m.ID_BOARD = :id_board_include
        into   :board_weight;
        board_weight = coalesce(:board_weight, 0);

        insert into TAR_BO_BASE_POSITION(
          ID_TAR_BP, ID_TAR_HEAD, POSITION_NUMBER, ID_ROOM_TYPE, MAX_PERSONS, SET_VAR, RND_METHOD,
          ID_BOARD_INCLUDE, BOARD_WEIGHT, IS_PRICE_FOR_ROOM, PTEXT, PACKET_ITEM, DISC_TAG)
        values (
          :id_tar_bp, :id_tar_head, :position_number, :id_room_type, :max_persons, :set_var, :rnd_method,
          :id_board_include, :board_weight, :is_price_for_room, :ptext, :packet_item, :disc_tag);
       iteration = 'SEASON_PRICES';
      end
    end
    if (:iteration = 'SEASON_PRICES') then begin
      execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_bp, :bo_type, :id_tar_season)
      returning_values  :err_code, :no_use, :price_type;
      if (:err_code < 0) then exit;
    end
  end
  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:BO_TYPE||', '||:err_text;
  end
end
^

/* Restore proc. body: TAR_SAVE_BO_DISC */
ALTER PROCEDURE TAR_SAVE_BO_DISC(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_disc integer;
  declare variable pos_numbers varchar(2000);
  declare variable id_service integer;
  declare variable prioritet integer;
  declare variable day_scheme varchar(20);
  declare variable day_scheme_num integer;
  declare variable price_type varchar(20);
  declare variable price varchar(2000);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable calc_type varchar(20);
  declare variable calc_list varchar(2000);
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  err_text = '';
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      if (:price = '') then err_code = -219;
      if (:err_code < 0) then exit;
      rnd_method = iif(coalesce(:rnd_method, '') = '', 'NONE', :rnd_method);
      insert into TAR_BO_DISCOUNT (
        ID_TAR_DISCOUNT, ID_TAR_HEAD, PRIORITET, DAY_SCHEME, DAY_SCHEME_NUM, DISC_TAG, SET_VAR, RND_METHOD,
        /*IS_IN_BASE_PRICE,*/  CALC_LIST, ID_SERVICE, PTEXT, PACKET_ITEM)
      values (
        :id_tar_disc, :id_tar_head, :prioritet, :day_scheme, :day_scheme_num, :disc_tag, :set_var, :rnd_method,
        /*:in_base_price,*/ :calc_list, :id_service, :ptext, :packet_item);
      param_filter = :data||:season_filter;
      execute procedure tar_save_parse_param(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure tar_save_parse_pnum(:id_tar_head, :id_tar_disc, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_disc = gen_id(GEN_TAR_BO_DISCOUNT_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers   = '';
      id_service    = -1;
      day_scheme     = 'EVERY';
      day_scheme_num = 1;
      calc_type     = 'NONE';
      calc_list     = '';
      price         = '';
      prioritet     = 1;
      ptext         = '';
      disc_tag      = '';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      --in_base_price = 0;
      packet_item   = null;
    end
    if (:param_name = 'SERVICE')            then begin
      if (:data = '') then id_service = -1;
      else id_service = :data;
    end else if (:param_name = 'PTEXT')     then ptext = :data;
    else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
    else if (:param_name = 'SET_VAR')       then set_var = :data;
    else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
    else if (:param_name = 'PRIORITET')     then prioritet     = :data;
    --else if (:param_name = 'IN_BASE_PRICE') then in_base_price = :data;
    else if (:param_name = 'PACKET_ITEM')   then packet_item   = :data;
--    else if (:param_name = 'PRICE_NOTEQUAL') then begin
    else if (:param_name = 'PRICE_FORMULA') then begin
      price = trim(:data);
      /*if ((:id_service > 0) and (:in_base_price = 1) and (substring(:price from 1 for 1) = '-')) then err_code = -240;
      else*/ if (:price = '') then err_code = -219;
      else
        execute procedure tar_save_parse_price(:price, :id_tar_disc, :bo_type, -1)
        returning_values  :err_code, :no_use, :price_type;
    end else if (:param_name = 'LIST_BASE_POS') then pos_numbers   = :data;
    else if (:param_name = 'DAY_SCHEME') then begin
      execute procedure tar_save_parse_dayschm(:data)
      returning_values  :err_code, :day_scheme, :day_scheme_num;
    end else if (:param_name = 'CALC_TYPE') then begin
      calc_list = :data;
--      execute procedure tar_save_parse_calctype(:data)
--      returning_values  :err_code, :calc_type, :calc_list;
    end else if (:param_name = 'CHECKIN_SEASON') then begin
      execute procedure tar_save_parse_season(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end else if (:param_name = 'NIGHT_SEASON') then begin
      execute procedure tar_save_parse_season(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end
    if (:err_code < 0) then exit;
  end
/*  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
  end*/
end
^

/* Restore proc. body: TAR_SAVE_BO_DISC_PERIOD */
ALTER PROCEDURE TAR_SAVE_BO_DISC_PERIOD(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_disc integer;
  declare variable pos_numbers varchar(2000);
  declare variable id_service integer;
  declare variable prioritet integer;
  declare variable calc_position varchar(20);
  declare variable price_type varchar(20);
  declare variable price varchar(2000);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable calc_list varchar(2000);
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  err_text = 'OBJECT='||:bo_type;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      if (:price = '') then err_code = -219;
      if (:calc_position = '') then err_code = -244;
      if (:err_code < 0) then exit;
      insert into TAR_BO_DISCOUNT_STAY (ID_TAR_DISCOUNT_STAY, ID_TAR_HEAD, PRIORITET, CALC_POSITION,
             CALC_LIST, ID_SERVICE, PTEXT, DISC_TAG, SET_VAR, RND_METHOD)
      values (:id_tar_disc, :id_tar_head, :prioritet, :calc_position,
             :calc_list, :id_service, :ptext, :disc_tag, :set_var, :rnd_method);

      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_disc, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration = 'MIDDLE';
      id_tar_disc = gen_id(GEN_TAR_BO_DISCOUNT_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers   = '';
      id_service    = -1;
      calc_list     = '';
      price         = '';
      prioritet     = 1;
      calc_position = 'GUEST_PERIOD';
      ptext         = '';
      disc_tag      = '';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
    end
    if (:param_name = 'SERVICE')            then begin
      if (:data = '') then id_service = -1;
      else id_service = :data;
    end else if (:param_name = 'PTEXT')     then ptext = :data;
    else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
    else if (:param_name = 'SET_VAR')       then set_var = :data;
    else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
    else if (:param_name = 'PRIORITET')     then prioritet     = :data;
    else if (:param_name = 'PERIOD_BASE_TYPE')    then calc_position = :data;
    else if (:param_name = 'PRICE_FORMULA') then begin
      price = trim(:data);
      if (:price = '') then err_code = -219;
      else begin
        execute procedure TAR_SAVE_PARSE_PRICE(:price, :id_tar_disc, :bo_type, -1)
        returning_values  :err_code, :no_use, :price_type;
        if (:err_code < 0) then exit;
      end
    end else if (:param_name = 'LIST_BASE_POS') then pos_numbers   = :data;
    else if (:param_name = 'CALC_TYPE') then begin
      calc_list = :data;
--      execute procedure tar_save_parse_calctype(:data)
--      returning_values  :err_code, :calc_type, :calc_list;
    end else if (:param_name = 'CHECKIN_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end else if (:param_name = 'NIGHT_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end
    if (:err_code < 0) then exit;
  end
  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
--    exception;
  end
end
^

/* Restore proc. body: TAR_SAVE_BO_EG */
ALTER PROCEDURE TAR_SAVE_BO_EG(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable id_tar_season integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_eg integer;
  declare variable pos_numbers varchar(2000);
  declare variable min_payors integer;
  declare variable max_extra_guests integer;
  declare variable order_num integer; /* !!!! */
  declare variable id_price_bb integer;
  declare variable id_price_eb integer;
  declare variable price_type varchar(20);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable is_packet_reduction integer;
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :id_tar_season, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_eg, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_eg = gen_id(GEN_TAR_BO_EG_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers = '';
      min_payors  = null;
      id_price_eb = -1;
      id_price_bb = -1;
      order_num   = 99;
      ptext       = '';
      disc_tag    = '';
      set_var = '';
      is_packet_reduction = 0;
      rnd_method = 'MATH';
      season_filter = '';
      max_extra_guests = null;
      packet_item = null;
    end
    if (:iteration = 'MIDDLE') then begin
      if (:param_name = 'LIST_BASE_POS')   then pos_numbers = :data;
      else if (:param_name = 'SET_VAR')    then set_var = :data;
      else if (:param_name = 'ROUND_TYPE') then rnd_method = :data;
      else if (:param_name = 'MIN_PAYORS') then begin
        if (:data = '') then err_code = -213;
        else min_payors = :data;
      end else if (:param_name = 'MAX_EG') then begin
        if (:data = '') then err_code = -214;
        else max_extra_guests = :data;
      end else if (:param_name = 'EG_ORDER')   then begin
        if (:data = '') then order_num = 99;
        else order_num = :data;
        if (:order_num < 1) then err_code = -215;
      end else if (:param_name = 'CHECKIN_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'NIGHT_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'PTEXT')     then ptext = :data;
      else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
      else if (:param_name = 'EG_POST_TYPE')  then is_packet_reduction = :data;
      else if (:param_name = 'PACKET_ITEM')   then packet_item = :data;
      else if (:param_name = 'BB_PRICE')   then begin
        if (:data <> '') then begin
          execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_eg, :bo_type, -1)
          returning_values  :err_code, :id_price_bb, :price_type;
          if ((:board_type = 'HRANI') and (:price_type <> 'PERCENT')) then begin
            err_code = -227;
            exit;
          end
        end
      end else if (:param_name = 'EB_PRICE') then begin
        if (:data <> '') then begin
          execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_eg, :bo_type, -1)
          returning_values  :err_code, :id_price_eb, :price_type;
          if ((:board_type = 'HRANI') and (:price_type <> 'PERCENT')) then begin
            err_code = -227;
            exit;
          end
        end
      end
      if (:err_code < 0) then exit;
      if ((:id_tar_season <> -1) and (:iteration = 'MIDDLE')) then begin
        if (:min_payors is null) then err_code = -213;
        if (:max_extra_guests is null) then err_code = -214;
        if (:err_code < 0) then exit;
        /* WE ARE STARTING THE SEASON PRICES SO: */
        insert into TAR_BO_EXTRA_GUEST(
          ID_TAR_EG, ID_TAR_HEAD, MIN_PAYORS, MAX_EXTRA_GUESTS, EG_ORDER, IS_PACKET_REDUCTION,
          ID_PRICE_BB, ID_PRICE_EB, PTEXT, PACKET_ITEM, DISC_TAG, SET_VAR, RND_METHOD)
        values (
          :id_tar_eg, :id_tar_head, :min_payors, :max_extra_guests, :order_num, :is_packet_reduction,
          :id_price_bb, :id_price_eb, :ptext, :packet_item, :disc_tag, :set_var, :rnd_method);
        iteration = 'SEASON_PRICES';
      end
    end
    if (:iteration = 'SEASON_PRICES') then begin
      execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_eg, :bo_type, :id_tar_season)
      returning_values  :err_code, :no_use, :price_type;
      if (:err_code < 0) then exit;
    end
  end
  when any do begin
    err_code = -200;
    err_text = ''||:iteration||' '||:id_price_bb||' '||:id_price_eb;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
/*    err_text = ' '||:min_payors||' '||:max_extra_guests||' '||:order_num;*/
  end
end
^

/* Restore proc. body: TAR_SAVE_BO_PACK */
ALTER PROCEDURE TAR_SAVE_BO_PACK(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_pack integer;
  declare variable pos_numbers varchar(2000);
  declare variable id_service integer;
  declare variable day_scheme varchar(20);
  declare variable day_scheme_num integer;
  declare variable cnt_post integer;
  declare variable pack_currency char(3);
  declare variable in_base_price integer;
  declare variable grp_rpt varchar(20);
  declare variable grp_docs varchar(20);
  declare variable price_type varchar(20);
  declare variable price_pack varchar(20);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      if (:price_pack = '') then err_code = -216;
      if (:id_service is null) then err_code = -217;
      if (:err_code < 0) then exit;
      insert into TAR_BO_PACK(
        ID_TAR_PACK, ID_TAR_HEAD, ID_SERVICE, PRICE_CURRENCY, IS_IN_BASE_PRICE,
        CNT_POST,  DAY_SCHEME, DAY_SCHEME_NUM, GRP_IN_REPORTS,
        GRP_IN_DOCUMENTS, PTEXT, PACKET_ITEM, DISC_TAG, SET_VAR, RND_METHOD)
      values (
        :id_tar_pack, :id_tar_head, :id_service, :pack_currency, :in_base_price,
        :cnt_post, :day_scheme, :day_scheme_num, :grp_rpt,
        :grp_docs, :ptext, :packet_item, :disc_tag, :set_var, :rnd_method);
      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_pack, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_pack = gen_id(GEN_TAR_BO_PACK_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers   = '';
      id_service    = null;
      day_scheme     = 'EVERY';
      day_scheme_num = 1;
      cnt_post      = 0;
/*
        select TH.TARIFA_CURR
        from   TAR_HEAD TH
        where  TH.ID_TAR_HEAD = :id_tar_head
        into   :pack_currency;
*/    pack_currency = '';
      in_base_price = 0;
      grp_rpt       = '';
      grp_docs      = '';
      price_pack    = '';
      ptext         = '';
      disc_tag      = '';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      packet_item   = null;
    end
    if (:param_name = 'SERVICE') then begin
      if ((:data = '') or (:data = '-1')) then err_code = -217;
      else if (:data = '0') then err_code = -222;
      else id_service = :data;
    end else if (:param_name = 'CNT_POST')  then cnt_post      = :data;
    else if (:param_name = 'IN_BASE_PRICE') then in_base_price = :data;
    else if (:param_name = 'GRP_RPT')       then grp_rpt       = :data;
    else if (:param_name = 'GRP_DOCS')      then grp_docs      = :data;
    else if (:param_name = 'PTEXT')         then ptext         = :data;
    else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
    else if (:param_name = 'SET_VAR')        then set_var = :data;
    else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
    else if (:param_name = 'PACKET_ITEM')   then packet_item   = :data;
    else if (:param_name = 'PRICE')         then begin
      price_pack    = :data;
      if (:price_pack = '') then err_code = -216;
      else
        execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_pack, :bo_type, -1)
        returning_values  :err_code, :no_use, :price_type;
    end else if (:param_name = 'LIST_BASE_POS') then pos_numbers   = :data;
    else if (:param_name = 'CURRENCY') then begin
      if ((:data <> upper(:data)) or (char_length(:data) <> 3)) then err_code = -218;
      else pack_currency = :data;
    end else if (:param_name = 'DAY_SCHEME') then begin
      execute procedure TAR_SAVE_PARSE_DAYSCHM(:data)
      returning_values  :err_code, :day_scheme, :day_scheme_num;
    end else if (:param_name = 'CHECKIN_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end else if (:param_name = 'NIGHT_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end
    if (:err_code < 0) then exit;
  end
  when any do begin
    err_code = -200;
/*    err_text = ' '||:id_service||' '||:pack_currency||' '||:in_base_price;*/
/*    err_text = ' '||:day_scheme||' '||:day_scheme_num;*/
    err_text = ' '||:cnt_post||' '||:grp_rpt||' '||:grp_docs||' '||:ptext;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
  end
end
^

/* Create Views... */

/* Dropping generators... */
SET TERM ; ^

DROP GENERATOR GEN_AR_PAYMENT_ACCOUNT_ID;


/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: ACCOUNT_BALANCE$RPT for: ACCOUNT_BALANCE$INT */
SET TERM ^ ;

ALTER PROCEDURE ACCOUNT_BALANCE$RPT(ID_ACCOUNT INTEGER,
EW_INCL_ONLY SMALLINT = 0)
 RETURNS(ACCOUNT_CURR CHAR(3),
ACCOUNT_BALANCE NUMERIC(15,4),
POST_VALUE NUMERIC(15,4),
DEP_VALUE NUMERIC(15,4),
OPEN_CHARGES INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_CHECK_CREDIT_STATUS$INT for: ACCOUNT_BALANCE$INT */
ALTER PROCEDURE ACCOUNT_CHECK_CREDIT_STATUS$INT(ID_ACCOUNT /* TYPE OF ID_REF */ INTEGER,
POST_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_SET_ARCHIVE_STATUS for: ACCOUNT_BALANCE$INT */
ALTER PROCEDURE ACCOUNT_SET_ARCHIVE_STATUS(ID_ACCOUNT INTEGER,
IS_ARCHIVE SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: CACHES_RESOLVE for: ACCOUNT_BALANCE$INT */
ALTER PROCEDURE CACHES_RESOLVE AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_GET_ACCOUNT$PROFILE for: ACCOUNT_BALANCE$INT */
ALTER PROCEDURE PROFILE_GET_ACCOUNT$PROFILE(ID_PROFILE INTEGER,
SHOW_ARCHIVE SMALLINT)
 RETURNS(ID_ACCOUNT INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
DEPOSIT_VALUE NUMERIC(15,4),
BALANCE_VALUE NUMERIC(15,4),
IS_DEFAULT SMALLINT,
IS_CREDIT SMALLINT,
CREDIT_LIMIT NUMERIC(15,4),
ID_TYPE_PAYMENT INTEGER,
IS_LEVEL_1 INTEGER,
IS_ARCHIVE INTEGER,
HOTEL_NAME VARCHAR(50))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GET_BALLANCE$INT for: ACCOUNT_BALANCE$INT */
ALTER PROCEDURE RES_GET_BALLANCE$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(RESERVATION_BALLANCE VARCHAR(255),
RECIEVED_DEPOSITS VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_BALANCE$INT) */
ALTER PROCEDURE ACCOUNT_BALANCE$INT(ID_ACCOUNT INTEGER,
EW_INCL_ONLY SMALLINT = 0)
 RETURNS(ACCOUNT_CURR CHAR(3),
CURR_DISPLAY_FORMAT VARCHAR(10),
ACCOUNT_BALANCE NUMERIC(15,4),
POST_VALUE NUMERIC(15,4),
DEP_VALUE NUMERIC(15,4),
DEP_MONEY_BAG VARCHAR(255),
OPEN_CHARGES INTEGER)
 AS
declare variable dep_curr_value numeric(15,4);
  declare variable dep_curr varchar(3);
  declare variable round_to numeric(15,4);
  declare variable open_charges_int integer;
  declare variable cached_balances integer;
begin
  select A.ACCOUNT_CURR, C.ROUND_TO, C.DISPLAY_FORMAT
  from   ACCOUNT A
         join CURRS C on C.CURR = A.ACCOUNT_CURR
  where  A.ID_ACCOUNT = :id_account
  into   :account_curr, :round_to, :curr_display_format;

  account_balance = null;
  if (:EW_INCL_ONLY is distinct from 1) then begin
    select count(*),
           min(AC.ACCOUNT_BALANCE), min(AC.POST_VALUE), min(AC.DEP_VALUE),
           min(AC.DEP_MONEY_BAG), min(AC.OPEN_CHARGES)
    from   ACCOUNT_BALANCE_CACHE AC
    where  AC.ID_ACCOUNT = :id_account
    into   :cached_balances,
           :account_balance, :post_value, :dep_value, :dep_money_bag, :open_charges;
  
    if (:cached_balances <> 1) then account_balance = null;
  --    execute procedure ACCOUNT_BALANCE_INVALIDATE$INT (:id_account);
  end

  if (:account_balance is null) then begin
    account_balance = 0;
    post_value = 0;
    dep_value = 0;
    dep_money_bag = '';
    open_charges = 0;
    for
      select :POST_VALUE + round_f(AB.POST_BAL_VALUE, :round_to), :DEP_VALUE + round_f(AB.DEP_BAL_VALUE, :round_to),
             AB.DEP_ORIG_VALUE, AB.CURR_ORIG, AB.OPEN_CHARGES
      from   ACCOUNT_CURR_BALANCE$INT (:id_account, :account_curr, :ew_incl_only) AB
      into   :post_value, :dep_value, :dep_curr_value, :dep_curr, :open_charges_int
    do begin
      if (:open_charges_int = 1) then open_charges = 1;
      if (:dep_curr is not null and :dep_value > 0) then
        dep_money_bag = :dep_money_bag || formatfloat (:dep_curr_value, :curr_display_format) || ' ' || :dep_curr || ';';
    end
    account_balance = :post_value - :dep_value;

    if (:EW_INCL_ONLY is distinct from 1) then begin
      execute procedure ACCOUNT_BALANCE_CACHE$INT(:id_account, :account_balance, :post_value, :dep_value, :dep_money_bag, :open_charges);
    end
  end

  suspend;
end
^

/* Alter (ACCOUNT_BALANCE$RPT) */
ALTER PROCEDURE ACCOUNT_BALANCE$RPT(ID_ACCOUNT INTEGER,
EW_INCL_ONLY SMALLINT = 0)
 RETURNS(ACCOUNT_CURR CHAR(3),
ACCOUNT_BALANCE NUMERIC(15,4),
POST_VALUE NUMERIC(15,4),
DEP_VALUE NUMERIC(15,4),
OPEN_CHARGES INTEGER)
 AS
begin

  select AB.ACCOUNT_CURR, AB.ACCOUNT_BALANCE, AB.POST_VALUE, AB.DEP_VALUE, AB.OPEN_CHARGES
  from   ACCOUNT_BALANCE$INT (:ID_ACCOUNT, :EW_INCL_ONLY) AB
  into   :ACCOUNT_CURR, :ACCOUNT_BALANCE, :POST_VALUE, :DEP_VALUE, :OPEN_CHARGES;
   
  suspend;
end
^

/* Alter (ACCOUNT_CHECK_CREDIT_STATUS$INT) */
ALTER PROCEDURE ACCOUNT_CHECK_CREDIT_STATUS$INT(ID_ACCOUNT TYPE OF ID_REF,
POST_VALUE TYPE OF TPRICE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_credit_account integer;
  declare variable id_reserv_detail integer;
  declare variable credit_limit tprice;
  declare variable b_post_sum tprice;
  declare variable b_pay_sum tprice;
  declare variable difference_value tprice;
  declare variable no_use varchar(255);
  declare variable account_currency tcurrency;
  declare variable round_to numeric(15,4);
begin
  if (:POST_VALUE = 0) then exit;

  select a.IS_CREDIT_ACCOUNT, a.CREDIT_LIMIT, a.ID_RESERV_DETAIL
  from   ACCOUNT A
  where  a.ID_ACCOUNT = :ID_ACCOUNT
  into   :is_credit_account, :credit_limit, :id_reserv_detail;

  if (:is_credit_account = 0
      and exists (select rd.ID_RESERV_DETAIL
                  from   RESERV_DETAIL rd
                  where  rd.ID_RESERV_DETAIL = :id_reserv_detail
                         and rd.CHECK_STATUS = 1)) then
  begin
    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, :credit_limit, 1);
  end

  if (coalesce(:credit_limit, 0) > 0) then begin
    /* FIND BALANCE OF ACCOUNT */
    execute procedure ACCOUNT_BALANCE$INT(:id_account)
    returning_values  :account_currency, :round_to, :no_use, :b_post_sum, :b_pay_sum, :no_use, :no_use;
    b_post_sum = coalesce(:b_post_sum, 0);
    b_pay_sum  = coalesce(:b_pay_sum, 0);

    /* IS THIS POST IS IN LIMIT */
    if ((:b_post_sum + :POST_VALUE) > :credit_limit) then begin
      err_code = -13; /*  */
      difference_value = :b_post_sum + :POST_VALUE - :credit_limit;
      err_text = f_character(29)||FormatFloat(:credit_limit, :round_to)||' '||:account_currency||
                 f_character(28)||FormatFloat(:difference_value, :round_to);
    end
  end
end
^

/* Alter (ACCOUNT_DEBT_FILL$INT) */
ALTER PROCEDURE ACCOUNT_DEBT_FILL$INT(ID_END_WORK INTEGER)
 AS
declare variable id_account_post integer;
  declare variable id_account integer;
  declare variable id_sale_taxation integer;
  declare variable is_primary_post integer;
  declare variable date_post date;
  declare variable id_service integer;
  declare variable revenue_group varchar(50);
  declare variable revenue_account varchar(50);
  declare variable revenue_sub_account varchar(50);
  declare variable curr_post varchar(3);
  declare variable post_amount double precision;
  declare variable nat_net_value numeric(15,4);
  declare variable nat_gross_value numeric(15,4);
  declare variable id_hotel integer;
  declare variable id_guest integer;
  declare variable ew_date date;
  declare variable post_type varchar(10);
  declare variable round_to numeric(15,4);
  declare variable qty_post tqty;
  declare variable rev_deduction_tax_value tprice;
  declare variable nat_round_to tprice;
begin
  select EW.PREV_DATE, EW.ID_HOTEL, c.ROUND_TO
  from   END_WORKS EW
         join HOTEL h on h.ID_HOTEL = ew.ID_HOTEL
         join CURRS  c on c.CURR = h.NATION_CURR
  where  EW.ID_END_WORK = :ID_END_WORK
  into   :EW_DATE, :ID_HOTEL, :nat_round_to;

  for
    select  AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_SALE_TAXATION, AP.DATE_POST,
            iif(AP.ID_ACCOUNT_POST = AP.SEQUENCE_ID, 1, 0), AP.ID_SERVICE, AP.ID_GUEST, AP.CURR_POST,
            S.REVENUE_GROUP, RA.REVENUE_ACCOUNT, RA.REVENUE_SUB_ACCOUNT, AP.POST_TYPE,
            sum(PRA.OUT_POST_AMOUNT), sum(PRA.OUT_POST_NET_VALUE), sum(PRA.OUT_POST_GROSS_VALUE),
            max(ap.QTY_POST)
    from    SERVICE_POSTING_REVENUE$INT (:ID_END_WORK) AP
            left outer join SERVICES S on S.ID_SERVICE = AP.ID_SERVICE
            left outer join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
            left outer join GUEST G on G.ID_GUEST = AP.ID_GUEST
            left outer join PROFILE_HOUSE PH on PH.ID_PROFILE = A.ID_PROFILE
            left outer join REVENUE_ACCOUNT_PARSE$INT (S.REVENUE_ACCOUNT, coalesce(G.ID_RESERV_DETAIL, A.ID_RESERV_DETAIL)) RA on 1=1
            left outer join ACCOUNT_POST_REVENUE_GET$INT (AP.POST_DBKEY, AP.QTY_POST * AP.PRICE_POST,
                            AP.POST_NET_VALUE, AP.POST_GROSS_VALUE,
                            S.REVENUE_GROUP, RA.REVENUE_ACCOUNT, RA.REVENUE_SUB_ACCOUNT) PRA on 1=1
    where   PH.HOUSE_TYPE is distinct from 'hptComplimentary'
    group by 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12
    union all
    select  DR.ID_ACCOUNT_POST, DR.ID_ACCOUNT, DR.ID_SALE_TAXATION, DR.DATE_POST,
            iif(DR.ID_ACCOUNT_POST is null , 1, 0), DR.ID_SERVICE, DR.ID_GUEST, DR.ACC_CURR,
            S.REVENUE_GROUP, RA.REVENUE_ACCOUNT, RA.REVENUE_SUB_ACCOUNT, DR.POST_TYPE,
            sum(DR.ACC_POST_AMOUNT), sum(DR.NET_VALUE), sum(DR.GROSS_VALUE),
            max(dr.QTY_POST)
    from    DOCUMENT_REVENUE DR
            left outer join SERVICES S on S.ID_SERVICE = DR.ID_SERVICE
            left outer join ACCOUNT A on A.ID_ACCOUNT = DR.ID_ACCOUNT
            left outer join GUEST G on G.ID_GUEST = DR.ID_GUEST
            left outer join PROFILE_HOUSE PH on PH.ID_PROFILE = A.ID_PROFILE
            left outer join REVENUE_ACCOUNT_PARSE$INT (S.REVENUE_ACCOUNT, coalesce(G.ID_RESERV_DETAIL, A.ID_RESERV_DETAIL)) RA on 1=1
    where   DR.DOC_DATE = :EW_DATE
            and DR.ID_HOTEL = :ID_HOTEL
            and PH.HOUSE_TYPE is distinct from 'hptComplimentary'
    group by 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12
--    order by 1 asc nulls last -- get postings and corrections first, ascending
    into   :id_account_post, :id_account, :id_sale_taxation, :date_post,
           :is_primary_post, :id_service, :id_guest, :curr_post,
           :revenue_group, :revenue_account, :revenue_sub_account, :post_type,
           :post_amount, :nat_net_value, :nat_gross_value, :qty_post
  do begin
    select c.ROUND_TO
    from   CURRS c
    where  c.CURR = :curr_post
    into   :round_to;

    if ((round_f (:post_amount, :round_to/10) <> 0) or (:nat_net_value <> 0) or (:nat_gross_value <> 0) ) then begin
      select sum(rd.TAX_AMOUNT)
      from   REVENUE_DEDUCTION_TAXES$INT (:nat_gross_value, iif(:is_primary_post = 1, :qty_post, 0), :nat_round_to, :id_sale_taxation) rd
      into   :rev_deduction_tax_value;

      insert into ACCOUNT_DEBT (ID_ACCOUNT, ID_SERVICE, ID_SALE_TAXATION, DEBT_DATE, POST_DATE, POST_CURR,
             POST_AMOUNT, NAT_NET_VALUE, NAT_GROSS_VALUE, ID_ACCOUNT_POST, IS_PRIMARY_POST, ID_GUEST,
             REVENUE_GROUP, REVENUE_ACCOUNT, REVENUE_SUB_ACCOUNT, POST_TYPE, ID_HOTEL,
             REVENUE_DEDUCTION_TAX_VALUE)
      values (:id_account, :id_service, :id_sale_taxation, :ew_date, :date_post, :curr_post,
             :post_amount, :nat_net_value, :nat_gross_value, :id_account_post, :is_primary_post, nullif(:id_guest, -1),
             :revenue_group, :revenue_account, :revenue_sub_account, :post_type, :id_hotel,
             :rev_deduction_tax_value);
    end
  end
end
^

/* Alter (ACCOUNT_POST_MODIFY$PMS) */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
declare variable id_account integer;
  declare variable id_service integer;
  declare variable date_post date;
  declare variable is_owner_income smallint;
  declare variable is_account_post_item smallint;
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable no_use_id_acc_post integer;
  declare variable ap_dbkey char(8);
begin
  -- da se wika samo ot GUI
  if ( (:ID_ACCOUNT_POST is null) and (:ID_ACCOUNT_POST_PMS is null) ) then begin
    exception WRONG_PARAM_VALUE;
    exit;
  end

  is_account_post_item = iif(:id_account_post is not null, 1, 0);

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'mod, anul');

  if (:operation in ('mod', 'anul')) then begin
    -- prowerka: ot GUI-to mogat da se anulirat samo nedokumentirani i neanulirani nachisleniq
    if (:is_account_post_item = 1) then begin
      if ( (:ID_PMS_EVENT > 0) and
           not exists ( select *
                        from   PMS_EVENT_POST PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      select ap.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  ap.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
      into   :ap_dbkey;

      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_dbkey, 'PMS GUI VOID');

      update PMS_EVENT_POST PP
      set    PP.LINE_STATUS = 22
      where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST;

    end else if (:ID_ACCOUNT_POST_PMS is not null) then begin
      if ( not exists ( select *
                        from   ACCOUNT_POST$PMS PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      execute procedure ACCOUNT_POST_PMS_ANUL$INT(:ID_PMS_EVENT, :ID_ACCOUNT_POST_PMS);
    end

    if (:operation = 'mod') then begin
      id_account = null;
      if (:is_account_post_item = 1) then begin
        select AP.ID_ACCOUNT, AP.ID_SERVICE, AP.DATE_POST, PP.ID_OWNER, 0, ap.id_room
        from   ACCOUNT_POST AP
               join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and PP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :id_owner, :is_owner_income, :id_room;
      end else begin
        select AP.ID_ACCOUNT_PMS, AP.ID_SERVICE, AP.DATE_POST, AP.IS_OWNER_INCOME, AP.ID_OWNER
        from   ACCOUNT_POST$PMS AP
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
               and AP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :is_owner_income, :id_owner;
      end
      if (:id_account is null) then exit;

      execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_account, :id_service, :id_owner, :date_post,
              :in_curr_orig, :in_value_orig, 1 - :is_account_post_item, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: DEVICE_READING_ANUL$PMS for: ACCOUNT_POSTING_ANUL */
ALTER PROCEDURE DEVICE_READING_ANUL$PMS(ID_DEVICE_READING /* TYPE OF ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: EAI_POS_POSTING_ANUL$P2E for: ACCOUNT_POSTING_ANUL */
ALTER PROCEDURE EAI_POS_POSTING_ANUL$P2E(IN_ID_SMETKA INTEGER,
IN_USER_ANUL VARCHAR(100))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_ANNUL for: ACCOUNT_POSTING_ANUL */
ALTER PROCEDURE SAFE_OCCUPANCY_ANNUL(ID_SAFE /* TYPE OF ID */ INTEGER,
REASON /* TYPE OF TREASON */ VARCHAR(50))
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_POSTING_ANUL) */
ALTER PROCEDURE ACCOUNT_POSTING_ANUL(IN_ID_ACCOUNT_POST INTEGER,
IN_ANUL_REASON VARCHAR(70))
 AS
declare variable action_text varchar(255);
  declare variable id_account integer;
  declare variable qty_post numeric(15,2);
  declare variable price_post double precision;
  declare variable date_post date;
  declare variable id_service integer;
  declare variable curr_post varchar(3);
  declare variable ap_dbkey char(8);
begin
  /* called only from GUI - manual anullment */
  select AP.RDB$DB_KEY, AP.ID_ACCOUNT, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST
  from   ACCOUNT_POST AP
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :ap_dbkey, :id_account, :qty_post, :price_post,
         :date_post, :id_service, :curr_post;

  execute procedure ACCOUNT_POSTING_ANUL$INT (:ap_dbkey, :IN_ANUL_REASON);

  select S.SERVICE_NAME
  from   SERVICES S
  where  S.ID_SERVICE = :id_service
  into   :action_text;

  action_text = f_character(29) || :action_text
                || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:qty_post * :price_post, 'F;0.00') || ' ' || :curr_post
                || f_character(28) || f_replstr(:IN_ANUL_REASON, 'MANUAL', '');
  execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_ANUL', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_TRANSFER$ACC for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: GUEST_ACCOUNT_TRANSFER$INT for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE GUEST_ACCOUNT_TRANSFER$INT(ID_GUEST INTEGER,
ID_SOURCE_ACCOUNT INTEGER,
ID_TARGET_ACCOUNT INTEGER,
SERVICE_TYPE VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: GUEST_REROUTE_POSTINGS$INT for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE GUEST_REROUTE_POSTINGS$INT(ID_GUEST INTEGER,
ID_BASE_ACCOUNT INTEGER,
ID_EXTRA_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_TRANSFER$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER)
 AS
declare variable id_current_account integer;
  declare variable id_service integer;
  declare variable is_anul integer;
  declare variable id_tariff integer;
  declare variable qty_post numeric(15,2);
  declare variable qty_free numeric(15,2);
  declare variable price_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable id_room integer;
  declare variable id_base_doc integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  if ((:AP_DBKEY is null) or (:id_target_account is null) or (:id_target_account < 0)) then
     exception POSTING_TRANSFER_EXCEPTION '-31';

  select AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST, AP.QTY_FREE,
         AP.PRICE_ORIG, AP.CURR_ORIG, AP.RATE_ORIG, ap.from_date, ap.to_date,
         AP.IS_ANUL, AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_BASE_DOC, A.ID_HOTEL
  from   ACCOUNT_POST AP
         left join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :id_service, :id_tariff, :id_room, :qty_post, :qty_free,
         :price_orig, :curr_orig, :rate_orig, :from_date, :to_date,
         :is_anul, :id_account_post, :id_current_account, :id_base_doc, :id_hotel;

  if (:id_current_account = :id_target_account) then EXIT;

  if (:is_anul = 1 ) then exception POSTING_TRANSFER_EXCEPTION '-33';

  if (:id_base_doc is not null) then exception POSTING_TRANSFER_EXCEPTION '-32';

  if (not exists(select A.ID_ACCOUNT
                 from   ACCOUNT A
                 where  A.ID_ACCOUNT = :ID_TARGET_ACCOUNT
                        and A.ID_HOTEL = :id_hotel)) then exception POSTING_TRANSFER_EXCEPTION '-376';

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
                    :id_tariff, :id_room, :qty_post, :qty_free, :price_orig, :curr_orig,
                    :rate_orig, 'TRANSFER_POSTING', null, :from_date, :to_date, 0, :id_target_account)
  returning_values  :no_use, :no_use, :no_use;

  insert into ACCOUNT_TRANSFER_HISTORY(ID_ACCOUNT_POST, FROM_ID_ACCOUNT, TO_ID_ACCOUNT)
  values (:id_account_post, :id_current_account, :id_target_account);
end
^

/* Alter (ACCOUNT_POSTING_UPDATE) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable in_db_key char(8);
begin
  /* GUI facade for manual update */
  select AP.ID_ACCOUNT, AP.ID_GUEST, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :id_guest, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date)
  returning_values  (:new_qty_post, :new_price_post, :new_ac);

  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    if (coalesce(:id_guest, 0) > 0) then begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || :id_account
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'POST_UPDATE', :action_text);
    end else begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
    end
  end

end
^

/* Alter (ACCOUNT_POSTS_ON_DATE$RPT) */
ALTER PROCEDURE ACCOUNT_POSTS_ON_DATE$RPT(ID_HOTEL INTEGER,
TO_DATE DATE,
INCL_CORR SMALLINT,
INCL_POSTS SMALLINT,
IN_ID_ACCOUNT INTEGER = null)
 RETURNS(POST_ID INTEGER,
ID_ACCOUNT INTEGER,
ID_GUEST INTEGER,
ROOM_NAME VARCHAR(20),
ID_SERVICE INTEGER,
ARISE_DATE DATE,
DATE_POST DATE,
IS_PRIMARY_POST SMALLINT,
POST_TYPE VARCHAR(10),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,4),
POST_NET_VALUE NUMERIC(15,4),
POST_GROSS_VALUE NUMERIC(15,4),
RATE_POST NUMERIC(15,6),
CURR_POST VARCHAR(3),
DATETIME_POST TIMESTAMP,
USER_NAME VARCHAR(30),
POST_REASON VARCHAR(30),
ID_VAT_GROUP INTEGER,
ID_ACCOUNT_POST INTEGER)
 AS
declare variable ID_EW integer;
begin
  select ew.ID_END_WORK
  from   END_WORKS EW
  where  EW.ID_HOTEL = :ID_HOTEL
         and ew.PREV_DATE = :to_date
         and ew.END_WORK_KIND = '3'
         and ew.PREV_DATE is distinct from ew.NEXT_DATE
  into   :id_ew;

  for
    select R.SEQUENCE_ID, R.ID_ACCOUNT, R.ID_GUEST, R.ROOM_NAME, R.ID_SERVICE,
           R.ARISE_DATE, R.DATE_POST, R.IS_PRIMARY_POST, R.POST_TYPE,
           R.QTY_POST, R.PRICE_POST, R.POST_NET_VALUE, R.POST_GROSS_VALUE, R.RATE_POST, R.CURR_POST,
           R.DATETIME_POST, R.USER_NAME, R.POST_REASON, R.ID_SALE_TAXATION, R.ID_ACCOUNT_POST
    from   SERVICE_POSTING_REVENUE$INT(:ID_EW) R
           left outer join ACCOUNT A on A.ID_ACCOUNT = R.ID_ACCOUNT
           left outer join PROFILE_HOUSE PH on PH.ID_PROFILE = A.ID_PROFILE
    where  PH.HOUSE_TYPE is distinct from 'hptComplimentary'
           and ((:IN_ID_ACCOUNT is null) or (R.ID_ACCOUNT = :IN_ID_ACCOUNT))
    into   :POST_ID, :ID_ACCOUNT, :ID_GUEST, :ROOM_NAME, ID_SERVICE,
           :ARISE_DATE, :DATE_POST, :IS_PRIMARY_POST, :POST_TYPE,
           :QTY_POST, :PRICE_POST, :POST_NET_VALUE, :POST_GROSS_VALUE, :RATE_POST, :CURR_POST,
           :DATETIME_POST, :USER_NAME, :POST_REASON, :ID_VAT_GROUP, :id_account_post
  do begin
    if ((:INCL_POSTS = 1 and :IS_PRIMARY_POST = 1)
        or (:INCL_CORR = 1 and :IS_PRIMARY_POST = 0)
       ) then suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_MODIFY$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE ACCOUNT_MODIFY$INT(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL /* TYPE OF ID_REF */ INTEGER,
IS_PMS_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PAYMENT_STORNO$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE PAYMENT_STORNO$INT(ID_PAYMENT_HEAD INTEGER,
ID_ACCOUNT INTEGER,
NEW_ID_DOC_HEAD INTEGER,
STORNO_AMOUNT NUMERIC(15,4),
DESCRIPTION VARCHAR(100),
TARGET_DOC_AMOUNT NUMERIC(15,4))
 RETURNS(ID_STORNO_PAYMENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_GET_ACCOUNT$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE PROFILE_GET_ACCOUNT$INT(ID_PROFILE INTEGER,
ID_RESERV_DETAIL INTEGER,
ACCOUNT_CURR VARCHAR(3),
ID_ACC_TEMPLATE INTEGER,
IS_BASE_ENABLE SMALLINT = 1,
IS_EXTRA_ENABLE SMALLINT = 1)
 RETURNS(ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_SET_ARCHIVE$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE PROFILE_SET_ARCHIVE$INT(P_DBKEY CHAR(8),
ARCHIVE_STATUS SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_ACCOUNTS_RECIEVE$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE RES_ACCOUNTS_RECIEVE$INT(ID_RESERV_DETAIL INTEGER,
OLD_ID_BASE_ACCOUNT INTEGER,
OLD_ID_EXTRA_ACCOUNT INTEGER,
ID_AGENT_ACCOUNT_RULE INTEGER,
ID_BASE_ACCOUNT_PROFILE INTEGER,
ID_EXTRA_ACCOUNT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ID_ACC_TEMPLATE_PERSON INTEGER,
IS_SEPARATE_ACCOUNTS SMALLINT)
 RETURNS(NEW_ID_BASE_ACCOUNT INTEGER,
NEW_ID_EXTRA_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_ARCHIVATE_ACCOUNTS$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE RES_ARCHIVATE_ACCOUNTS$INT(ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACC_ARCHIVE$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE RES_SAVE_ACC_ARCHIVE$INT(ACCOUNTS_FOR_ARCHIVE VARCHAR(2000),
ID_PROFILE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTS_FINALIZE$INT for: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE RES_SAVE_ACCOUNTS_FINALIZE$INT(ID_RESERV_DETAIL INTEGER,
OLD_ID_BASE_ACCOUNT INTEGER,
OLD_ID_EXTRA_ACCOUNT INTEGER,
NEW_ID_BASE_ACCOUNT INTEGER,
NEW_ID_EXTRA_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_SET_ARCHIVE_STATUS) */
ALTER PROCEDURE ACCOUNT_SET_ARCHIVE_STATUS(ID_ACCOUNT INTEGER,
IS_ARCHIVE SMALLINT)
 AS
declare variable post_sum numeric (15,2);
  declare variable dep_sum numeric (15,2);
  declare variable open_charges integer;
  declare variable old_is_archive integer;
  declare variable id_profile integer;
  declare variable id_hotel integer;
  declare variable p_dbkey char(8);
  declare variable acc_dbkey char(8);
  declare variable archived_date date;
  declare variable is_used integer;
  declare variable action_text varchar(255);
  declare variable account_name varchar(50);
begin

  select A.RDB$DB_KEY, A.IS_ARCHIVE, A.ID_PROFILE, A.ID_HOTEL, A.ACCOUNT_NAME
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :acc_dbkey, :old_is_archive, :id_profile, :id_hotel, :account_name;
  /* --------------------------------------- */
  if (:old_is_archive = :IS_ARCHIVE) then exit;
  /* --------------------------------------- */
  if (:IS_ARCHIVE = 0) then begin
    -- unarchive
    update ACCOUNT A
    set    A.IS_ARCHIVE = 0
    where  A.RDB$DB_KEY = :acc_dbkey;

    p_dbkey = null;
    select P.RDB$DB_KEY
    from   PROFILE P
    where  P.ID_PROFILE = :id_profile
           and p.IS_ARCHIVE = 1
    into   :p_dbkey;

    if (:p_dbkey is not null) then begin
      /* restore profile active status */
      execute procedure PROFILE_SET_ARCHIVE$INT (:p_dbkey, 0);
    end

  end else begin
    execute procedure ACCOUNT_USE_CHECK$INT (:ID_ACCOUNT)
    returning_values (:is_used);

    if (:is_used = 1) then begin
      select AB.POST_VALUE, AB.DEP_VALUE, AB.OPEN_CHARGES
      from   ACCOUNT_BALANCE$INT(:id_account) AB
      into   :post_sum, :dep_sum, :open_charges;
  
      if ((:post_sum <> 0) or (:open_charges = 1)) then
        exception ACCOUNT_EXCEPTION '-44' || f_character(31) || :ID_ACCOUNT;

      if (:dep_sum <> 0) then
        exception ACCOUNT_EXCEPTION '-40' || f_character(31) || :ID_ACCOUNT;
    
      execute procedure SYSTEM_DATE_GET (:id_hotel)
      returning_values (:archived_date);
    end else begin
      archived_date = null;  /* mark account as unused */
    end

    update ACCOUNT A
    set    A.IS_ARCHIVE = 1,
           A.ARCHIVED_DATE = :archived_date
    where  A.RDB$DB_KEY = :acc_dbkey;

    action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'ARCHIVE_ACCOUNT', :action_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: CANCEL_BOOKING$EXC for: APPLY_BOOKING_STATUS$EXC */
ALTER PROCEDURE CANCEL_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20),
STATUS VARCHAR(20))
 RETURNS(BOOKING_ID INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (APPLY_BOOKING_STATUS$EXC) */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20)
 AS
declare variable err_text varchar(255);
declare variable dummy_int integer;
declare variable anul_reason varchar(30);
declare variable selection_id integer;

declare variable status_code smallint;
declare variable current_anul_code smallint;
declare variable current_status_code smallint;
declare variable current_status_text varchar(50);
declare variable new_status_text varchar(50);
declare variable extra_posts_left integer;
begin
  if (:booking_db_key is null) then begin
    select rd.RDB$DB_KEY, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.ID_RESERV_DETAIL = :BOOKING_ID
    into   :booking_db_key, :current_status_code, :current_anul_code;
  end else begin
    select rd.id_reserv_detail, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.rdb$db_key = :booking_db_key
    into   :booking_id, :current_status_code, :current_anul_code;
  end

  execute procedure IMPORT_BOOKING_STATUS$EXC(:status, -2)
  returning_values :status_code;

  execute procedure EXPORT_BOOKING_STATUS$EXC(:current_status_code, :current_anul_code)
  returning_values :current_status_text;
  execute procedure IMPORT_BOOKING_STATUS$EXC(:current_status_text, :current_status_code)
  returning_values :current_status_code;

  /* nop - exit */
  if (:current_status_code = :status_code) then exit;

  /* validate status transition */
  if (
     /* terminal status values - void booking */
    (:current_status_code in (1004/*no show*/, 1005/*canceled*/))

    /* void over checkin */
    or ((:current_status_code >= 0) and (:status_code in (1004/*no show*/, 1005/*canceled*/)))

    /* positive status downgrade */
    or ((:current_status_code > 0) and (:current_status_code > :status_code))
  )  then begin
    execute procedure PRINT_BOOKING_STATUS$EXC(:current_status_code) returning_values :current_status_text;
    execute procedure PRINT_BOOKING_STATUS$EXC(:status_code) returning_values :new_status_text;

    exception VALIDATE_EXCEPTION '-1022' || f_character(31) || '@{invalid_status_transition} ' || :current_status_text || ' -> ' || :new_status_text;
  end

  anul_reason = null;
  if (1004 = :status_code) then begin
    anul_reason = 'NOSHOW';
  end else if (1005 = :status_code) then begin
    anul_reason = 'CANCELED';
  end

  if (:anul_reason is null) then begin
    if (0 > :status_code) then begin
      execute procedure RES_SAVE_STATUS$INT(:booking_db_key, :status_code, :CONFIRMATION_NUMBER);
    end else begin
      if (:status_code in (0, 1) and 0 > :current_status_code) then begin
        -- checkin
        execute procedure RES_SET_CHECKIN$INT (:booking_db_key)
        returning_values (:dummy_int, :err_text, :dummy_int, :dummy_int);
      end
      if (1 = :status_code and 1 > :current_status_code) then begin
        -- checkout
        selection_id = gen_id(SELECTION_GEN, 1);
        update RESERV_DETAIL
        set    selection_id=:selection_id
        where  rdb$db_key=:booking_db_key;
    
        execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id);
      end
    end
  end else begin
    -- void
    execute procedure RES_ANUL_DETAIL$INT(:booking_db_key, :anul_reason, :CANCELATION_NUMBER)
    returning_values  :dummy_int, :extra_posts_left;
    if (:extra_posts_left = 1) then exception BOOKING_EXCEPTION '-1042';

  end
end
^

/* Alter (AR_OWING_ADD$AR) */
ALTER PROCEDURE AR_OWING_ADD$AR(ID_PROFILE TYPE OF ID,
SUM_OWING TYPE OF TPRICE,
CURR_OWING TYPE OF TCURRENCY,
DUE_DATE TYPE OF TDATE,
SYSTEM_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
ID_AR_TYPE TYPE OF ID,
ID_HOTEL TYPE OF ID)
 RETURNS(NEW_ID_AR_OWING TYPE OF ID)
 AS
begin

  execute procedure AR_OWING_ADD$INT (:ID_PROFILE,
          :SUM_OWING, :CURR_OWING, null, :DUE_DATE,
          :SYSTEM_DATE, :DESCRIPTION, :ID_AR_TYPE, :ID_HOTEL)
  returning_values  (:NEW_ID_AR_OWING);

end
^

/* Alter (AR_OWING_ANUL$AR) */
ALTER PROCEDURE AR_OWING_ANUL$AR(ID_AR_OWING TYPE OF ID,
DESCRIPTION TYPE OF TDESCRIPTION_LONG)
 RETURNS(NEW_ID_AR_OWING TYPE OF ID)
 AS
begin

  execute procedure AR_OWING_ANUL$INT (:ID_AR_OWING, :DESCRIPTION, 1)
  returning_values  (:NEW_ID_AR_OWING);

end
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUPANCY$RPT for: AVAILABILITY_OCCUP_PREPARE$AVL */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$RPT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ID_ROOM_TYPE INTEGER,
FOR_DATE DATE,
ID_PROFILE INTEGER,
ROOMS_AVAILABLE SMALLINT,
ROOMS_OOI SMALLINT,
ROOMS_OOO SMALLINT,
ROOMS_SOLD_CONFIRMED SMALLINT,
ROOMS_SOLD_NOTCONFIRMED SMALLINT,
ROOMS_SOLD SMALLINT,
ROOMS_SOLD_MULTIPLE_GST SMALLINT,
ROOMS_ARRIVAL SMALLINT,
ROOMS_DEPARTURE SMALLINT,
GUESTS_IN_HOUSE BIGINT,
GUESTS_ARRIVAL BIGINT,
GUESTS_DEPARTURE BIGINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: OCCUPANCY_RTI_BP$RPT for: AVAILABILITY_OCCUP_PREPARE$AVL */
ALTER PROCEDURE OCCUPANCY_RTI_BP$RPT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ROOM_TYPES VARCHAR(255))
 RETURNS(OUT_DATE DATE,
CATEGORY VARCHAR(50),
AGENT_NAME VARCHAR(50),
ROOM_CNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SUMMARY_FORECAST$INT for: AVAILABILITY_OCCUP_PREPARE$AVL */
ALTER PROCEDURE SUMMARY_FORECAST$INT(ID_HOTEL INTEGER,
SUMMARY_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* Alter (AVAILABILITY_OCCUP_PREPARE$AVL) */
ALTER PROCEDURE AVAILABILITY_OCCUP_PREPARE$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS INTEGER,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
begin

  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, :FETCH_TOTALS, 1, 1, 1, 1, 1, 1, :HOTELS);
   
  execute procedure AVAILABILITY_OCCUPANCY_OPT$INT (:RELEASE_DATES, :OVERBOOK,
          :RES_CONFIRMED, :RES_NOTCONFIRMED, :RES_WAITING, :BOOKING_POSITIONS, :CONTINGENT);

end
^

/* empty dependent procedure body */
/* Clear: TEST_AVAILABILITY for: AVAILABILITY_OCCUPANCY$AVL */
ALTER PROCEDURE TEST_AVAILABILITY RETURNS(FOR_DATE DATE,
MINUS_ROOM_TYE INTEGER,
ID_AGENT INTEGER,
AGENT_NAME VARCHAR(100),
SOLD INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
CONT_BP_REMAIN INTEGER,
RES_WAITING INTEGER,
CONT_PLAIN INTEGER,
CONT_BP INTEGER,
CONT_BP_PLAIN INTEGER,
CONT_PLAIN_REMAIN INTEGER,
RES_TOTAL INTEGER,
ROOM_TYPE_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* Alter (AVAILABILITY_OCCUPANCY$AVL) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
begin

  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, :FETCH_TOTALS, 1, 1, 1, 1, 1, 1, :HOTELS);

  ID_OCCUPANCY_SESSION = current_transaction;
end
^

/* Alter (AVAILABILITY_OCCUPANCY$RPT) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$RPT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ID_ROOM_TYPE INTEGER,
FOR_DATE DATE,
ID_PROFILE INTEGER,
ROOMS_AVAILABLE SMALLINT,
ROOMS_OOI SMALLINT,
ROOMS_OOO SMALLINT,
ROOMS_SOLD_CONFIRMED SMALLINT,
ROOMS_SOLD_NOTCONFIRMED SMALLINT,
ROOMS_SOLD SMALLINT,
ROOMS_SOLD_MULTIPLE_GST SMALLINT,
ROOMS_ARRIVAL SMALLINT,
ROOMS_DEPARTURE SMALLINT,
GUESTS_IN_HOUSE BIGINT,
GUESTS_ARRIVAL BIGINT,
GUESTS_DEPARTURE BIGINT)
 AS
begin

  execute procedure AVAILABILITY_OCCUP_PREPARE$AVL (:FROM_DATE, :TO_DATE, 1, 0, 0, 1, 1, 0, 0, 0, :ID_HOTEL);

  for
    select SO.ID_ROOM_TYPE,
           SO.FOR_DATE,
           pa.id_profile,
           sum(SO.G_CAPACITY),
           sum(so.G_OOI),
           sum(so.G_OOO),
           sum(so.SOLD + so.RES_CONFIRMED),
           sum(so.RES_NOTCONFIRMED),
           sum(so.SOLD + so.RES_CONFIRMED + so.RES_NOTCONFIRMED),
           sum(iif(so.GUESTS_INHOUSE > 1, so.SOLD, 0)),
           sum(so.ROOMS_COME),
           sum(so.ROOMS_GONE),
           sum(so.GUESTS_INHOUSE),
           sum(so.GUESTS_COME),
           sum(so.GUESTS_GONE)
    from   SMART_OCCUP$TMP SO
           left outer join PROFILE_AGENT pa on pa.id_agent = so.id_agent
    group by 1, 2, 3
    into   :ID_ROOM_TYPE, :FOR_DATE, :id_profile, :ROOMS_AVAILABLE, :ROOMS_OOI, :ROOMS_OOO,
           :ROOMS_SOLD_CONFIRMED, :ROOMS_SOLD_NOTCONFIRMED,
           :ROOMS_SOLD, :ROOMS_SOLD_MULTIPLE_GST, :ROOMS_ARRIVAL, :ROOMS_DEPARTURE,
           :GUESTS_IN_HOUSE, :GUESTS_ARRIVAL, :GUESTS_DEPARTURE
  do begin
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: BLOCK_ANNUL$BLK for: BLOCK_MODIFY$INT */
ALTER PROCEDURE BLOCK_ANNUL$BLK(ID_BLOCK_ROOM INTEGER,
OPERATION VARCHAR(30))
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: BLOCK_CREATE$BLK for: BLOCK_MODIFY$INT */
ALTER PROCEDURE BLOCK_CREATE$BLK(ROOM_NAMES /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_HOTEL /* TYPE OF ID */ INTEGER,
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
BLOCK_GRP /* TYPE OF TRANGE */ INTEGER,
REASON /* TYPE OF TREASON */ VARCHAR(50),
NOTE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IS_FULL_FROM /* TYPE OF TRANGE */ INTEGER,
IS_FULL_TO /* TYPE OF TRANGE */ INTEGER)
 RETURNS(NEW_ID_BLOCK_ROOM /* TYPE OF ID */ INTEGER,
SHARE_TRANSACTION_ID /* TYPE OF ID */ INTEGER,
SHARE_ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE /* TYPE OF ID */ INTEGER,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: BLOCK_MODIFY$BLK for: BLOCK_MODIFY$INT */
ALTER PROCEDURE BLOCK_MODIFY$BLK(ID_BLOCK_ROOM INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
BLOCK_GRP INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
IS_FULL_FROM INTEGER,
IS_FULL_TO INTEGER)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (BLOCK_MODIFY$INT) */
ALTER PROCEDURE BLOCK_MODIFY$INT(ID_BLOCK_ROOM INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
BLOCK_GRP INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_BLOCK_ROOM INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable b_dbkey char(8);
  declare variable edit_status varchar(255);
  declare variable old_id_room integer;
  declare variable min_affected_date date;
  declare variable old_from_date date;
  declare variable old_to_date date;
begin

  if (:block_grp not in (18, 20)) then exception BLOCK_EXCEPTION '-85' || f_character(31) || 'Unknown block type';

  if (:operation = 'add') then begin
    new_id_block_room = gen_id(ID_RESERV_DETAIL_GEN, 1);
    insert into BLOCK_ROOM (ID_BLOCK_ROOM, ID_ROOM, FROM_DATE, TO_DATE,
           BLOCK_GRP, REASON, NOTE)
    values (:new_id_block_room, :id_room, :from_date, :to_date,
           :block_grp, :reason, :note)
    returning RDB$DB_KEY into :b_dbkey;
    edit_status = 'JUST_CREATED';
    min_affected_date = :from_date;
  end else begin
    select BR.RDB$DB_KEY, BR.FROM_DATE, BR.TO_DATE, BR.ID_ROOM
    from   BLOCK_ROOM BR
    where  BR.ID_BLOCK_ROOM = :id_block_room
    into   :b_dbkey, :old_from_date, :old_to_date, :old_id_room;

    min_affected_date = null;
    if (:old_from_date <> :from_date) then min_affected_date = mindate(:old_from_date, :from_date);
    else if (:old_to_date <> :to_date) then min_affected_date = mindate(:old_to_date, :to_date) + 1;
    edit_status = iif(:min_affected_date is not null, 'DATE_CHANGED', '');
    if (:id_room <> :old_id_room) then edit_status = :edit_status || ',ROOM_CHANGED';

    update BLOCK_ROOM BRU
    set    BRU.ID_ROOM = :id_room,
           BRU.FROM_DATE = :from_date,
           BRU.TO_DATE = :to_date,
           BRU.BLOCK_GRP = :block_grp,
           BRU.REASON = :reason,
           BRU.NOTE = :note
    where  BRU.RDB$DB_KEY = :b_dbkey;

    new_id_block_room = :id_block_room;
  end

  execute procedure BLOCK_MODIFY_CONTROL$INT(:b_dbkey, :min_affected_date);

  execute procedure LIST_ITEM_MODIFY(:block_grp, null, :reason, 'add');

  ------------------------------------
  execute procedure OCCUPANCY_BLOCK$INT(:b_dbkey, :edit_status);

  execute procedure OCCUPANCY_ROOMS_CHECK$INT(:b_dbkey, :block_grp)
  returning_values  :share_err_code, :share_err_text, :share_transaction_id, :warn_code;

  execute procedure sys_dbg('occ BLOCK_MODIFY$INT share_err_code = '||coalesce(:share_err_code, 'null'));
  execute procedure sys_dbg('occ BLOCK_MODIFY$INT share_err_text = '||coalesce(:share_err_text, 'null'));
  execute procedure sys_dbg('occ BLOCK_MODIFY$INT share_transaction_id = '||coalesce(:share_transaction_id, 'null'));

  execute procedure RES_FINALIZE_CLEAR$INT(:b_dbkey, :new_id_block_room);
  --
  delete from RESERV_STAY$TMP t
  where  t.id_session = RDB$GET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION');
end
^

/* Alter (CACHES_RESOLVE) */
ALTER PROCEDURE CACHES_RESOLVE AS
declare variable id_res_detail integer;
  declare variable id_group integer;
  declare variable cache_cnt integer;
  declare variable id_account integer;
  declare variable no_use varchar(1024);
begin
  /* resolve reservs cache conflicts */
  for
    select first 20 RG.ID_RESERV_DETAIL, rg.ID_GROUP, sum(iif(rg.BOARD_NAMES is null, 2, 1))
    from   RESERV_GUESTDATA_CACHE RG
    group by RG.ID_RESERV_DETAIL, rg.ID_GROUP
    having sum(iif(rg.BOARD_NAMES is null, 2, 1)) > 1
    into   :id_res_detail, :id_group, :cache_cnt
  do begin
    execute procedure RES_GET_GUEST_DATA$INT (iif(:id_res_detail is not null, 'DETAIL', 'GROUP'), coalesce(:id_res_detail, :id_group))
    returning_values  (:no_use, :no_use, :no_use, :no_use);

    when any do begin
      execute procedure sys_dbg('all Cache resolve error for reserv '|| iif(:id_res_detail is not null, 'DETAIL', 'GROUP') || ': ' || coalesce(:id_res_detail, :id_group));
    end
  end 

  /* resolve account balances cache conflicts */
  for
    select first 20 AC.ID_ACCOUNT, sum(iif(AC.ACCOUNT_BALANCE is null, 2, 1))
    from   ACCOUNT_BALANCE_CACHE AC
    group by AC.ID_ACCOUNT
    having sum(iif(AC.ACCOUNT_BALANCE is null, 2, 1)) > 1
    into   :id_account, :cache_cnt
  do begin
    execute procedure ACCOUNT_BALANCE$INT (:id_account, 0)
    returning_values  (:no_use, :no_use, :no_use, :no_use, :no_use, :no_use, :no_use);

    when any do begin
      execute procedure sys_dbg('all Cache resolve error for account: ' || :id_account);
    end
  end 
end
^

/* Alter (CANCEL_BOOKING$EXC) */
ALTER PROCEDURE CANCEL_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20,
STATUS VARCHAR(20))
 RETURNS(BOOKING_ID INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable hotel_id integer;
declare variable cancel_event_log_id integer;
begin
  /* init */
  err_code = 0;
  err_text = '';

  execute procedure import_mark_transaction$exc;

  select first 1 b.id_reserv_detail, b.id_log_event_annul, b.from_date, b.to_date
  from   reserv_detail b
  where  b.number=:number
         and b.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  order by id_log_event_annul nulls first
  into   :booking_id, cancel_event_log_id, :from_date, :to_date;

  if ((:booking_id is null) or (:cancel_event_log_id is not null)) then begin
    /* not found or found but already in void status - ignore and exit */
    exit;
  end

  /* verify hotel */
  execute procedure lookup_hotel$exc(:hotel, 'BOOKING', :booking_id)
  returning_values :hotel_id;

  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  execute procedure APPLY_BOOKING_STATUS$EXC(
    :booking_id, null, :status, :confirmation_number, :cancelation_number
  );
end
^

/* Alter (CLEAR_ORPHAN_GUESTS$EXC) */
ALTER PROCEDURE CLEAR_ORPHAN_GUESTS$EXC(BOOKING_ID INTEGER)
 AS
declare variable guest_id integer;
  declare variable guest_uuid varchar(50);
begin

  for
    select g.id_guest, g.uuid
    from guest g
    where g.id_reserv_detail=:booking_id and g.orphaned_import$exc=1
    into :guest_id, :guest_uuid do
  begin
    execute procedure sys_dbg('exc CLEAR_ORPHAN_GUESTS$EXC - RES_GUEST_DEL$RSV(:guest_id=>' || coalesce(:guest_id, '<null>') || ', :guest_uuid=>' || coalesce(:guest_uuid, '<null>') || ')');

    execute procedure RES_GUEST_DEL$RSV(:guest_id);
  end
end
^

/* empty dependent procedure body */
/* Clear: PMS_EVENT_POST$INT for: CONTRACT_EXPENSE_POST$INT */
ALTER PROCEDURE PMS_EVENT_POST$INT(ID_PMS_EVENT INTEGER,
ID_ROOM_CONTRACT INTEGER,
ID_RENTAL_POOL INTEGER,
POST_DATE DATE,
PRICE_WITH_VAT NUMERIC(15,4),
PRICE_WO_VAT NUMERIC(15,4),
CURR VARCHAR(3),
MAX_ADULT_CNT INTEGER,
STAY INTEGER,
BED_NIGHT_CNT INTEGER,
BOOKING_CNT INTEGER,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (CONTRACT_EXPENSE_POST$INT) */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT TYPE OF ID,
ID_HOTEL INTEGER,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
ID_OWNER TYPE OF ID,
OWNERSHIP_PERCENT TYPE OF TPERCENT,
ID_RENTAL_POOL TYPE OF ID_REF,
VALUE_ORIG TYPE OF TPRICE,
CURR_ORIG TYPE OF TCURRENCY,
POST_DATE TYPE OF TDATE,
STAY TYPE OF TCOUNT,
MAX_GUEST_CNT TYPE OF TCOUNT,
BED_NIGHT_CNT TYPE OF TCOUNT,
RESERVS TYPE OF TCOUNT)
 AS
declare variable service_price numeric(15,4);
  declare variable id_currency varchar(3);
  declare variable contract_expense_type varchar(50);
  declare variable id_account integer;
  declare variable post_value numeric(15,4);
  declare variable post_currency varchar(3);
  declare variable id_service integer;
  declare variable is_owner_income smallint;
  declare variable is_client_acc_post smallint;
  declare variable multiplier_type varchar(50);
  declare variable multiplier integer;
  declare variable id_room integer;
  declare variable use_shadow_account integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
begin
  is_owner_income = 0;
  use_shadow_account = iif(:SUB_CONTRACT = 'SHADOW_ACC', 1, 0);

  select r.ID_HOTEL
  from   PMS_EVENT$PMS p
         join ROOMS R on r.ID_ROOM = p.ID_ROOM
  where  p.ID_PMS_EVENT = :ID_PMS_EVENT
  into   :id_hotel;
-- CONTRACT_EXPENSE_TYPE in ( 'PERCENT', 'RUNNING_TOTAL_PERCENT', 'CURR_VALUE' )
-- MULTIPLIER_TYPE in ('RESERVATION', 'STAY', 'GUESTS', 'BED_NIGHTS')
  for
    select C.SERVICE_PRICE, C.ID_CURRENCY, C.CONTRACT_EXPENSE_TYPE, C.IS_ACC_POST_ITEM,
           C.ID_SERVICE, C.MULTIPLIER_TYPE
    from   CONTRACT_EXPENSE$PMS C
    where  C.ID_CONTRACT = :id_contract
           and c.SUB_CONTRACT = :SUB_CONTRACT
    order by C.ORDER_TAG asc
    into   :service_price, :id_currency, :contract_expense_type, :is_client_acc_post,
           :ID_SERVICE, :multiplier_type
  do begin

    execute procedure OWNER_ACCOUNT_GET$INT (coalesce(:ID_RENTAL_POOL,:ID_OWNER),
            :id_hotel, :use_shadow_account, :is_client_acc_post)
    returning_values (:id_account, :is_account$pms);

    multiplier = case
                   when :multiplier_type = 'RESERVATION' then iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'STAY' then :STAY
                   when :multiplier_type = 'GUESTS' then :MAX_GUEST_CNT * iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'BED_NIGHTS' then :BED_NIGHT_CNT
                   else null
                 end;

    if (:multiplier is not null) then begin
      if (:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE') then begin
        post_value = cast(:service_price as double precision) * :ownership_percent / 100 * :multiplier;
        post_currency = :id_currency;
      end else if (:CONTRACT_EXPENSE_TYPE = 'PERCENT') then begin
        post_value = :VALUE_ORIG * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end else if (:CONTRACT_EXPENSE_TYPE = 'RUNNING_TOTAL_PERCENT') then begin
        execute procedure PMS_RUNNING_TOTAL_GET(:ID_PMS_EVENT, coalesce(:ID_RENTAL_POOL,:ID_OWNER), :ID_HOTEL, :POST_DATE, :CURR_ORIG)
        returning_values :post_value;
        if (:post_value < 0) then post_value = 0;
    
        post_value = :post_value * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end

      select pe.ID_ROOM
      from   PMS_EVENT$PMS PE
      where  pe.ID_PMS_EVENT = :ID_PMS_EVENT
      into   :id_room;

      select c.ROUND_TO
      from   CURRS C
      where  c.CURR = :post_currency
      into   :round_to;

      execute procedure PMS_POSTING_CREATE$INT(:ID_PMS_EVENT, :id_account, :id_service, :ID_OWNER,
              :POST_DATE, :post_currency, round_f(:post_value, :round_to), :is_account$pms, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* Alter (CONTRACT_MANAGEMENT_POST$INT) */
ALTER PROCEDURE CONTRACT_MANAGEMENT_POST$INT(ID_PMS_EVENT TYPE OF ID,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
CONTRACT_TYPE VARCHAR(30),
ID_OWNER TYPE OF ID,
ID_RENTAL_POOL TYPE OF ID_REF,
VALUE_ORIG TYPE OF TPRICE,
CURR_ORIG TYPE OF TCURRENCY,
POST_DATE TYPE OF TDATE,
STAY TYPE OF TCOUNT,
OWNERSHIP_PERCENT TYPE OF TPERCENT)
 RETURNS(POSTED_VALUE TYPE OF TPRICE,
POSTED_CURRENCY TYPE OF TCURRENCY)
 AS
declare variable night_price numeric(15,4);
  declare variable night_price_curr varchar(3);
  declare variable id_account integer;
  declare variable my_value numeric(15,4);
  declare variable my_currency varchar(3);
  declare variable id_service integer;
  declare variable do_post smallint;
  declare variable is_owner_income smallint;
  declare variable id_account_post_pms integer;
  declare variable use_shadow_account integer;
  declare variable id_hotel integer;
  declare variable is_account$pms integer;
  declare variable round_to numeric(15,4);
begin

  do_post = 0;
  posted_value = null;
  posted_currency = null;
  is_owner_income = 1;
  use_shadow_account = iif(:SUB_CONTRACT = 'SHADOW_ACC', 1, 0);

  select c.ROUND_TO
  from   CURRS c
  where  c.CURR = :curr_orig
  into   :round_to;

  /*select P.ID_ACCOUNT
  from   ACCOUNT$PMS P
  where  P.ID_OWNER = coalesce(:ID_RENTAL_POOL,:ID_OWNER)
         and P.IS_SHADOW = :use_shadow_account
         and P.IS_CLIENT_POOL_ACCOUNT = 0
  into   :id_account;*/
  select r.ID_HOTEL
  from   PMS_EVENT$PMS p
         join ROOMS R on R.ID_ROOM = p.ID_ROOM
  where  p.ID_PMS_EVENT = :ID_PMS_EVENT
  into   :id_hotel;

  execute procedure OWNER_ACCOUNT_GET$INT (coalesce(:ID_RENTAL_POOL,:ID_OWNER),
          :id_hotel, :use_shadow_account, 0)
  returning_values (:id_account, :is_account$pms);

  for
    select C.NIGHT_PRICE, C.NIGHT_PRICE_CURR, C.ID_SERVICE
    from   CONTRACT_MANAGEMENT$PMS C
    where  C.ID_CONTRACT = :id_contract
           and c.SUB_CONTRACT = :SUB_CONTRACT
    into   :night_price, :night_price_curr, :ID_SERVICE
  do begin
    if (:CONTRACT_TYPE = 'PRIVATE_USE' and :use_shadow_account = 0) then begin
      do_post = 0;
    end
    if (:CONTRACT_TYPE = 'TO_PRICE' and :use_shadow_account = 0) then begin
      my_value = :VALUE_ORIG;
      my_currency = :CURR_ORIG;
      do_post = 1;
    end
    if (:CONTRACT_TYPE = 'FIXED_PRICE' and :use_shadow_account = 0) then begin
      my_value = :night_price * :stay;
      my_currency = :night_price_curr;
      do_post = 1;
    end
    if (:CONTRACT_TYPE = 'GUARANTEE_INCOME_FIXED_PRICE' and :use_shadow_account = 1) then begin
      my_value = :night_price * :stay;
      my_currency = :night_price_curr;
      do_post = 1;
    end
    if (:CONTRACT_TYPE = 'GUARANTEE_INCOME_TO_PRICE' and :use_shadow_account = 1) then begin
      my_value = :VALUE_ORIG;
      my_currency = :CURR_ORIG;
      do_post = 1;
    end
    if (:CONTRACT_TYPE = 'TO_PRICE_FIXED_PRICE') then begin
      if (:use_shadow_account = 0) then begin
        my_value = :VALUE_ORIG;
        my_currency = :CURR_ORIG;
      end else if (:USE_SHADOW_ACCOUNT = 1) then begin
        my_value = :night_price * :stay;
        my_currency = :night_price_curr;
      end
      do_post = 1;
    end
    if (:CONTRACT_TYPE = 'FIXED_PRICE_TO_PRICE') then begin
      if (:use_shadow_account = 0) then begin
        my_value = :night_price * :stay;
        my_currency = :night_price_curr;
      end else if (:USE_SHADOW_ACCOUNT = 1) then begin
        my_value = :VALUE_ORIG;
        my_currency = :CURR_ORIG;
      end
      do_post = 1;
    end
  
    if (:do_post = 1 and :id_service is not null) then begin
      my_value = round_f(cast(:my_value as double precision) * :ownership_percent / 100, :round_to);
      execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account,
              :id_owner, :my_currency, :my_value, :id_service, :is_owner_income, :post_date)
      returning_values  (:id_account_post_pms);
      posted_value = :my_value;
      posted_currency = :my_currency;
    end
  end
end
^

/* Alter (CREATE_BOOKING$WBE) */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
declare variable RATE varchar(50);
declare variable ROOM_TYPE varchar(20);
declare variable ARRIVAL date;
declare variable DEPARTURE date;
declare variable ADULTS integer;
declare variable CHILDREN integer;
declare variable PROFILE_NAME varchar(100);
declare variable ARANGER_NAME varchar(100);
declare variable GUEST_PROFILE_UUID varchar(40);
declare variable ARANGER_PROFILE_UUID varchar(40);
declare variable HOTEL_NAME varchar(50);
declare variable WBE_SESSION_ID bigint;
declare variable MAIN_GUEST_PROFILE_ID integer;
declare variable BOARD varchar(50);
declare variable HOTEL_ID integer;
declare variable GUARANTEE_POLICY_NAME varchar(50);
declare variable GUARANTEE_DEPOSIT_PERCENT numeric(15,4);
declare variable GUARANTEE_DEPOSIT_NIGHTS integer;
declare variable GUARANTEE_DUE_DAYS_BEF_ARRIVAL integer;
declare variable GUARANTEE_DUE_DAYS_AFTER_CREATE integer;
declare variable ERR_CODE integer;
declare variable ERR_TEXT varchar(255);
declare variable PROFILE_TYPE varchar(20);
declare variable PROFILE_IMPORT_TIME timestamp;
declare variable B_COUNT integer;
declare variable AGE integer;
declare variable IS_CHILD smallint;
declare variable GUEST_ID integer;
declare variable SPECIAL_TREATMENT varchar(250);
declare variable MAINTENANCE varchar(30);
declare variable ROUTING varchar(20);
declare variable ARRANGER_PAYMENY_TYPE varchar(20);
declare variable MARKET_SEGMENT varchar(30);
declare variable MARKET_SOURCE varchar(30);
declare variable MARKET_CHANNEL varchar(30);
declare variable MARKET_HEAR_REASON varchar(30);
declare variable MARKET_COME_REASON varchar(30);
declare variable FIRST_FOOD varchar(30);
declare variable BNOTE varchar(2000);
begin
  -- get wbe product selection
  select  PA.rate_name,PA.room_name, AQ.first_date, AQ.first_date+AQ.day_count,
          PS.adults, PS.children, PS.person_name, H.hotel_name, H.id_hotel,
          WS.id, PA.board_name, GP.name, GP.deposit_totalsum_part, GP.deposit_nights_count, GP.due_days_before_arrival, GP.due_days_after_create,
          PS.bnote
   from   PRODUCT_SELECTION$WBE PS
          join WBE_SESSION$WBE WS on WS.id = PS.wbe_session_id
          join PRODUCT_AVAILABILITY$WBE PA on pa.id = PS.product_availability_id
          join AVAILABILITY_QUERY$WBE AQ on aq.id = WS.product_query_id
          join HOTEL H on H.id_hotel = WS.hotel_id
          join GUARANTEE_POLICY GP on GP.id_guarantee_policy = PS.guarantee_policy_id
   where  PS.id = :product_selection_id
   into   :rate, :room_type, :arrival, :departure,
          :adults,  :children, :profile_name, :hotel_name, :hotel_id,
          :wbe_session_id, :board, :guarantee_policy_name,
          :guarantee_deposit_percent, :guarantee_deposit_nights,
          :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create,
          :bnote;

  select PA.uuid , PA.profile_name, PA.profile_type
  from   profile PA
  where  PA.id_profile = :aranger_profile_id
  into   :aranger_profile_uuid,:aranger_name,  :profile_type;

  if (:aranger_name = :profile_name and :profile_type = 'PERSON') then begin
    -- aranger is main guest
    select count(*) from PRODUCT_SELECTION$WBE PSC
        where PSC.wbe_session_id = :wbe_session_id
        into :b_count;
       -- only if single reservation bugfix 2228
    if (1 = :b_count) then begin
     guest_profile_uuid =  aranger_profile_uuid;
     aranger_profile_uuid = null;
    end
  end else begin
    -- create profile for main guest
    execute procedure IMPORT_PERSON_PROFILE$EXC(
      uuid_create(),:profile_name,null,null,null,null,null,null,null,null,null,null, null,
      null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
      null,null,null,null,null, null, null)
    returning_values :main_guest_profile_id, :profile_import_time;

    select P.uuid
    from   profile P
    where  P.id_profile = :main_guest_profile_id
    into   :guest_profile_uuid;
  end

    -- apply default map + forced arranger
    special_treatment = null;
    maintenance = null;
    routing = null;
    arranger_paymeny_type = null;
    market_segment = null;
    market_source = null;
    market_channel = null;
    market_hear_reason = null;
    market_come_reason = null;


  select hc.special_treatment,hk.plan_name,hc.routing,
        pt.payment_type, ms.segment_name,sc.description,cc.description,
        hr.description,cr.description,hc.first_food
  from  hotel_product_cfg$wbe hc
        left join hk_plan hk on hk.id_plan = hc.id_hk_plan
        left join payment_type pt on pt.id_payment_type = hc.arranger_id_payment_type
        left join nom_market_segments ms on ms.id_nom_market_segment = hc.id_m_segment
        left join nom_source_codes sc on sc.id_nom_source_code = hc.id_m_source
        left join nom_channel_codes cc on cc.id_nom_channel_code = hc.id_m_channel
        left join nom_hear_reasons hr on hr.id_nom_hear_reason = hc.id_m_hear_reason
        left join nom_come_reasons cr on cr.id_nom_come_reason = hc.id_m_come_reason
  where hc.hotel_id = :hotel_id
  into  :special_treatment,:maintenance,:routing,:arranger_paymeny_type,
        :market_segment,:market_source,:market_channel,:market_hear_reason,:market_come_reason,:first_food;
  -- create reseravation
  execute procedure IMPORT_BOOKING$EXC(
    :hotel_name, :number, null, null, 0,
    :arrival, null, :departure, null, null, null, null, null, :room_type, :board, null,
     :special_treatment, :maintenance, :routing, :rate, null, null, null, null, :arranger_paymeny_type, null, null, null, null,
     :market_segment, :market_source,:market_channel, :market_hear_reason, :market_come_reason,
     :bnote, null, :first_food, :adults, :children, :aranger_profile_uuid, null, :guest_profile_uuid,
     0, 0, null, :guarantee_policy_name, null, :guarantee_deposit_percent, :guarantee_deposit_nights,
     :guarantee_due_days_bef_arrival,  :guarantee_due_days_after_create, null, null, null, null,  null, null, null, null, null, null)
   returning_values
    :hotel_id ,
    :booking_id,
    :err_code,
    :err_text;

  if (0 <> :err_code) then exception wrong_value ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');

  -- import guests
  for select psg.guest_name,psg.is_child,psg.age from product_selection_guests$wbe psg
  where psg.product_selection_id = :product_selection_id
  into :profile_name,:is_child,:age
  do begin
    execute procedure import_guest$exc(:booking_id, null, null, :profile_name, :is_child, :age, null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null)
    returning_values :guest_id, :err_code,:err_text;
    if (0 <> :err_code) then exception wrong_value ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');
  end
  ----------------

  select RD.number_2
  from   reserv_detail RD
  where  RD.id_reserv_detail = :booking_id
  into   :number_2;

  update product_selection$wbe uPS
  set    uPS.booking_id = :booking_id, uPS.selection_id = :number_2
  where  uPS.id = :product_selection_id;
end
^

/* Alter (CREATE_SESSION_BOOKINGS$WBE) */
ALTER PROCEDURE CREATE_SESSION_BOOKINGS$WBE(WBE_SESSION_ID BIGINT,
ARANGER_ID INTEGER,
LANG_CODE VARCHAR(3))
 RETURNS(SELECTION_ID VARCHAR(20),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable product_selection_id bigint;
declare variable next_num integer;
declare variable sel_cnt integer;
declare variable aranger_name varchar(100);
declare variable aranger_email varchar(50);
declare variable aranger_phone varchar(50);
declare variable booking_id integer;
declare variable record_timestamp timestamp;
declare variable new_res_number varchar(62);
declare variable room_types_src varchar(255) = '';
declare variable rates_src varchar(255) = '';
declare variable hotel_id integer;
declare variable profile_id integer;
declare variable from_date date;
declare variable to_date date;
declare variable day_count integer;
declare variable room_type_id integer;
declare variable rate_id integer;
declare variable query_id_tmp integer;
declare variable rooms_required integer;
declare variable rooms_available integer;
declare variable profile_import_time timestamp;
begin
  execute procedure EXPORT_LOG_FORCE$EXC(1);
  /* test overbook (multiuser) */
   for select ws.hotel_id,ws.profile,aq.first_date,(aq.first_date+aq.day_count)-1,pa.room_type_id,pa.rate_id,aq.day_count
    from   PRODUCT_availability$WBE PA
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    join availability_query$wbe aq on aq.id = pa.query_id
   where ws.id = :wbe_session_id and coalesce(pa.room_count,0) > 0
   into  :hotel_id, :profile_id, :from_date, :to_date, :room_type_id, :rate_id , :day_count
   do begin
       room_types_src = :room_types_src||','||cast(:room_type_id as varchar(10));
       rates_src = :rates_src||','||cast(rate_id as varchar(10));
   end

   query_id_tmp = GEN_ID(AVAILABILITY_QUERY$WBE_SEQ,1);
   insert into availability_query$wbe(ID, WBE_SESSION_ID, FIRST_DATE, DAY_COUNT)    -- prevent FK exception
    values (:query_id_tmp,:wbe_session_id,:from_date,:day_count) ;

   execute procedure availability_occup_small$wbe(:from_date,:to_date,:hotel_id,:query_id_tmp,1,:rates_src,:room_types_src) ;

   --  check minimum available rooms for every day
   err_code = null;
   err_text = '';
   for select pa.room_type_id,pa.room_count,
    (select coalesce(min(art.available_rooms),0) from availability_room_type$wbe art
      where art.query_id = :query_id_tmp and art.room_type_id = pa.room_type_id)
    from product_availability$wbe pa
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    where ws.id = :wbe_session_id
    and coalesce(pa.room_count,0) > 0   into :room_type_id,:rooms_required,:rooms_available
   do begin
       if (rooms_required > rooms_available) then
       begin
        err_code = 1;
        ERR_TEXT = coalesce(ERR_TEXT,'')||:room_type_id||';';
       end
   end
   delete from availability_query$wbe aqt where aqt.id = :query_id_tmp;       -- remove temp query
   if (err_code is not null) then exit;

  /* create profile if not exist and reservations > 1*/
  if (aranger_id is NULL) then
  begin
    select WS.person_name,WS.address,WS.phone
    from   WBE_SESSION$WBE WS
    where  WS.id = :wbe_session_id
    into   :aranger_name,:aranger_email,:aranger_phone;

    execute procedure IMPORT_PERSON_PROFILE$EXC(
       uuid_create(),:aranger_name,null,null,null,null,null,null,null,null,null,null,
       null,null,null,null,:aranger_phone,null,:aranger_email,null,null,null,null,null,null,
       STRHASH_LARGE(substring(uuid_create() from 1 for 4)),null,null,null,null,null,null,null,null, null, null)
    returning_values :aranger_id, :profile_import_time;

    update WBE_SESSION$WBE uWS
    set    uWS.profile = :aranger_id
    where  uWS.id = :wbe_session_id;
  end else begin
    -- da podmeni email, phone ako !!
  end
  /* create reservations */
  for
    select PS.id
    from   PRODUCT_SELECTION$WBE PS
    where  PS.wbe_session_id = :wbe_session_id
           and PS.booking_id is null
           and coalesce(PS.is_deleted,0) <> 1
    into   :product_selection_id
  do begin
     if (next_num = 1) then begin      -- increment first reservation number_3
      execute procedure res_number_suffix_gen(:booking_id) returning_values :new_res_number;
      next_num = next_num + 1;
     end
     execute procedure CREATE_BOOKING$WBE(:product_selection_id,:aranger_id,'WBE.'||:selection_id||'.'||:next_num) returning_values :booking_id,:selection_id;
     execute procedure IMPORT_BOOKING_FINALIZE$EXC(:booking_id) returning_values  record_timestamp,:err_code,:err_text;
     insert into SCHEDULER$WBE(booking_id,status,last_action_time,lang_code,guarantee_passed) values (:booking_id, NULL, current_timestamp, :lang_code,0);

     if (next_num is NULL) then begin
      next_num = 1;
     end else begin
      next_num = next_num + 1;
     end
  end
end
^

/* Alter (DEPOSIT_REFUND$DOC) */
ALTER PROCEDURE DEPOSIT_REFUND$DOC(ID_DEPOSIT INTEGER,
REFUND_AMOUNT NUMERIC(15,4),
REFUND_CURRENCY VARCHAR(3),
ID_PAY_DOC_TYPE INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_REFUND_PAYMENT INTEGER,
ID_STORNO_DOC INTEGER,
WARN_CODE INTEGER)
 AS
declare variable no_use varchar(2000);
  declare variable id_account integer;
  declare variable avail_value numeric(15,4);
  declare variable id_doc_head integer;
  declare variable pay_currency varchar(3);
  declare variable pay_rate numeric(15,6);
  declare variable sys_date date;
  declare variable round_to numeric(15,4);
  declare variable p_dbkey char(8);
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable id_account_payment integer;
  declare variable id_doc_type integer;
  declare variable account_curr varchar(3);
  declare variable account_rate numeric(15,6);
  declare variable id_reserv_detail integer;
  declare variable is_posting_stopped integer;
  declare variable firm_data type of tnote_blob;
begin
  WARN_CODE = null;
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_REFUND');

  select D.ID_ACCOUNT, DH.ID_DOC, dh.ID_DOC_TYPE, c.ROUND_TO, d.ID_RESERV_DETAIL,
         D.AVAIL_VALUE, D.PAY_CURRENCY, D.PAY_RATE, A.ID_HOTEL, A.ACCOUNT_CURR
  from   DEPOSIT_AVAILABLE D
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join CURRS C on c.CURR = d.PAY_CURRENCY
         left outer join DOC_HEAD DH on DH.ID_DOC = D.ID_DOC_HEAD
                                        and DH.IS_STORNED = 0
                                        and DH.IS_ANUL = 0
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_account, :id_doc_head, :id_doc_type, :round_to, :id_reserv_detail,
         :avail_value, :pay_currency, :pay_rate, :id_hotel, :account_curr;

  if (:pay_currency is distinct from :refund_currency) then exception PAYMENT_EXCEPTION 'Currency mismatch!';

  if (round_f(:avail_value - :REFUND_AMOUNT, :round_to) < 0) then exception PAYMENT_EXCEPTION '-305';
  --'Issued value is more than available deposit amount.';

  select r.IS_POSTING_STOPPED
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :is_posting_stopped;

  if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';

  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET(:id_hotel) SD
  into   :sys_date;

  select first 1 ap.ACC_RATE
  from   ACCOUNT_PAYMENTS ap
  where  ap.ID_DEPOSIT = :ID_DEPOSIT
  order by ap.ID_ACCOUNT_PAYMENT asc
  into   :account_rate;

  execute procedure PAYMENT_CREATE$INT (:ID_PAY_DOC_TYPE, :ID_ACCOUNT, :SYS_DATE,
          -:REFUND_AMOUNT, :PAY_CURRENCY, :PAY_RATE, :account_curr, :account_rate, :DESCRIPTION)
  returning_values  (:id_refund_payment, :id_account_payment, :no_use);

  insert into DEPOSIT_REFUND (ID_DEPOSIT, ID_PAYMENT_HEAD, DESCRIPTION)
  values (:ID_DEPOSIT, :ID_REFUND_PAYMENT, :DESCRIPTION);

  update ACCOUNT_PAYMENTS AP
  set    AP.ID_DEPOSIT = :ID_DEPOSIT
  where  ap.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT;

  if (:ID_DOC_HEAD is not null) then begin
    execute procedure DOC_TYPE_EVALUATE$INT (:id_doc_type, :id_hotel, 0, :ID_REFUND_PAYMENT);

    execute procedure DOCUMENT_ADVANCE_STORNO$INT (:ID_DEPOSIT, :REFUND_AMOUNT, :DESCRIPTION)
    returning_values  (:ID_STORNO_DOC, :WARN_CODE);

    execute procedure DOCUMENT_ATTACH_PAYMENT$INT (:ID_STORNO_DOC, :id_account_payment, :pay_rate, null)
    returning_values :no_use;
     
    update  PAYMENT_HEAD P
    set     P.ID_DOC_HEAD = :ID_STORNO_DOC
    where   P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT;

    execute procedure DOCUMENT_VALIDATE$DOC (:ID_STORNO_DOC)
    returning_values (:firm_data, :no_use, :no_use);
  end else begin
    select P.RDB$DB_KEY
    from   PAYMENT_HEAD P
    where  P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT
    into   :P_DBKEY;
     
    execute procedure PAYMENT_SET_NUMBER$INT (:P_DBKEY);
  end

  action_text = F_CHARACTER(29) || :REFUND_AMOUNT || ' ' || :PAY_CURRENCY;
  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'REFUND', :ACTION_TEXT);
end
^

/* Alter (DEVICE_READING_ANUL$PMS) */
ALTER PROCEDURE DEVICE_READING_ANUL$PMS(ID_DEVICE_READING TYPE OF ID)
 AS
declare variable id_account_post id_ref;
  declare variable id_account_post$pms id_ref;
  declare variable id_pms_event id_ref;
begin
  for
    select DRP.ID_ACCOUNT_POST, DRP.ID_ACCOUNT_POST$PMS
    from   DEVICE_READING DR
           join DEVICE_READING_EVIDENCE DRQ on DRQ.ID_DEVICE_READING = DR.ID_DEVICE_READING
           join DEVICE_READING_POST DRP on DRP.ID_DEVICE_READING_EVIDENCE = DRQ.ID_DEVICE_READING_EVIDENCE
    where  DR.ID_DEVICE_READING = :id_device_reading
           and DR.STATUS <> 2
    into   :id_account_post, :id_account_post$pms
  do begin
    if (:id_account_post is not null) then begin
      if (exists(select AP.ID_ACCOUNT_POST
                 from   ACCOUNT_POST AP
                 where  AP.ID_ACCOUNT_POST = :id_account_post
                        and ap.is_anul = 0)) then begin
        execute procedure ACCOUNT_POSTING_ANUL(:id_account_post, '');
      end
    end else if (:id_account_post$pms is not null) then begin
      if (exists (select APP.ID_ACCOUNT_POST
                  from   ACCOUNT_POST$PMS APP
                  where  APP.ID_ACCOUNT_POST = :id_account_post$pms
                         and app.line_status <> 22)) then begin
        select APP.ID_PMS_EVENT
        from   ACCOUNT_POST$PMS APP
        where  app.id_account_post = :id_account_post$pms
        into   :id_pms_event;

        execute procedure PMS_EVENT_ANUL$PMS(:id_pms_event);
      end
    end
  end
  update DEVICE_READING DR
  set    DR.STATUS = 2
  where  DR.ID_DEVICE_READING = :ID_DEVICE_READING
         and DR.STATUS <> 2;
end
^

/* Alter (DEVICE_READING_POST$PMS) */
ALTER PROCEDURE DEVICE_READING_POST$PMS(ID_DEVICE_READING TYPE OF ID)
 AS
declare variable id_service type of id_ref;
  declare variable post_value type of tprice;
  declare variable curr type of tcurrency;
  declare variable id_room type of id_ref;
  declare variable is_client_acc_post type of tlogical;
  declare variable date_post tdate;
  declare variable id_account_post id_ref;
  declare variable id_account_post$pms id_ref;
  declare variable id_device_reading_evidence id_ref;
  declare variable descr tdescription_long;
begin
  if(exists(select DR.ID_DEVICE_READING
            from   DEVICE_READING DR
            where  DR.ID_DEVICE_READING = :id_device_reading
                   and dr.status = 1)) then exception assert '-1051';
  for
    select CDC.ID_SERVICE,
           sum((CDC.QTY * cast(coalesce(CDC.UNIT_PRICE, 0) as double precision)) + coalesce(CDC.PRICE, 0)),
           CDC.CURR, D.ID_ROOM, CDC.IS_CLIENT_ACC_POST, DR.DATE_POST, DRQ.ID_DEVICE_READING_EVIDENCE,
           substring(list(coalesce(CDC.price || '+', '') || '(' || CDC.QTY || ' ' || coalesce(DT.MEASURE, '') || ' x '
                          || coalesce(CDC.UNIT_PRICE, 0) || ') ' || CDC.CURR) from 1 for 255)
    from DEVICE_READING DR
         join DEVICE_READING_EVIDENCE DRQ on DRQ.ID_DEVICE_READING = DR.ID_DEVICE_READING
         join DEVICE D on D.ID_DEVICE = DRQ.ID_DEVICE
         join DEVICE_TYPE DT on DT.ID_DEVICE_TYPE = D.ID_DEVICE_TYPE
         left outer join CREATE_DEVICE_CALC (D.ID_DEVICE_TYPE, DR.DATE_POST, DRQ.NEW_EVIDENCE - DRQ.OLD_EVIDENCE) CDC on 1=1
    where DR.ID_DEVICE_READING = :id_device_reading
    group by 1, 3, 4, 5, 6, 7
    into  :id_service, :post_value, :curr, :id_room, :is_client_acc_post, :date_post,
          :id_device_reading_evidence, :descr
  do begin
    if (coalesce(:post_value, -1) >= 0) then begin
      for
        select PEP.NEW_ID_ACCOUNT_POST, PEP.NEW_ID_ACCOUNT_POST$PMS
        from   PMS_EXPENSE_POSTS_CREATE$INT(:ID_ROOM, null, null, :ID_SERVICE, :CURR, :POST_VALUE,
                                            :IS_CLIENT_ACC_POST, :DATE_POST, :DESCR, 0) PEP
        into   :id_account_post, :id_account_post$pms
      do begin
        insert into DEVICE_READING_POST (ID_DEVICE_READING_EVIDENCE, ID_ACCOUNT_POST,
               ID_ACCOUNT_POST$PMS)
        values (:ID_DEVICE_READING_EVIDENCE, :ID_ACCOUNT_POST, :ID_ACCOUNT_POST$PMS);
      end
    end
  end
  update DEVICE_READING DR
  set    DR.STATUS = 1
  where  DR.ID_DEVICE_READING = :id_device_reading;
end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_POST_TO_FRONT_ONLINE for: EAI_EXT_POST_TO_MH_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_EXT_POST_TO_MH_FRONT_ONLINE) */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  if (:CODE_TYPE = 'EXT_CODE') then begin
    execute procedure EAI_MAP_SERVICE(:SERVICE_CODE, :SERVICE_CODE, 'UNKNOWN', :id_hotel)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_SERVICE;
    if (:ERR_CODE < 0) then exit;
  end else begin
    select S.ID_SERVICE
    from   SERVICES S
    where  S.ID_SERVICE = :SERVICE_CODE
           and s.ID_HOTEL = :ID_HOTEL
    into   :ID_SERVICE;
    if (:ID_SERVICE is null) then begin
      ERR_CODE = -85;   /* Wrong value! */
      exit;
    end
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Alter (EAI_EXT_SERVICE_POST) */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable max_id_service integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_ROOM  = null;
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  select min(S.ID_SERVICE) as id_service, max(s.id_service) as max_id_service
  from   SERVICES S
  where  S.EXT_CODE = :SERVICE_EXT_CODE
         and s.IS_BASE = 0
         and s.IS_DELETED = 0
  into   :ID_SERVICE, :max_id_service;
  if (:ID_SERVICE is null) then begin
      ERR_CODE = -388;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end else if (:ID_SERVICE <> :max_id_service) then begin
      ERR_CODE = -389;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_EXT_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Alter (EAI_IMPORT_ALOYALTY_CLIENT) */
ALTER PROCEDURE EAI_IMPORT_ALOYALTY_CLIENT(CLIENT_UUID VARCHAR(40),
CLIENT_NAME VARCHAR(100),
CARD_CODE VARCHAR(50),
IS_ARHIVE SMALLINT,
DATE_OF_BIRTH DATE)
 AS
declare variable PROFILE_ID integer;
  declare variable IMPORT_TIME timestamp;
begin
  execute procedure IMPORT_PERSON_PROFILE$EXC(:CLIENT_UUID, :CLIENT_NAME, null, :DATE_OF_BIRTH, null, null,
    null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null,
    :IS_ARHIVE, :CARD_CODE, null, null, null, null, null, null, null, null, null, null, 'null-uuid')
  returning_values :PROFILE_ID, :IMPORT_TIME;
end
^

/* empty dependent procedure body */
/* Clear: EAI_POS_POSTING_ADD for: EAI_POS_POSTING_ADD$P2E */
ALTER PROCEDURE EAI_POS_POSTING_ADD(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_POS_POSTING_ADD$P2E) */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
declare variable id_service integer;
  declare variable my_post_text varchar(255);
  declare variable my_resource_text varchar(255);
  declare variable no_use integer;
  declare variable nation_curr varchar(3);
  declare variable post_short_code varchar(10);
  declare variable id_hotel integer;
begin
  /* in_on_guest = 0 (account), 1 (guest), -1 (ew)
  */
  if (:IN_ON_GUEST = 1) then begin
    select rd.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :IN_ID_GUEST
    into   :id_hotel;
  end else begin
    select a.ID_HOTEL
    from   account a
    where  a.ID_ACCOUNT = :in_id_account
    into   :id_hotel;
  end

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :nation_curr;

  if ('END_WORK' = :in_smetka_num) then begin
    post_short_code='POS_EW';
  end else begin
    post_short_code='POS';
  end

  /* FIND SERVICE */
  execute procedure EAI_MAP_SERVICE(:in_service_tag, :in_service_name, 'POS', :id_hotel)
  returning_values  :err_code, :err_text, :id_service;
  if (:err_code < 0) then exit;

  my_post_text = 'date:'|| formatdate(:in_date_smetka, 'D;dd.mm.yyyy') ||
                 ' num:'|| :in_smetka_num ||
                 ' obj:'|| :in_obj_name ||
                 ' tbl:'|| :in_table ||
                 ' site:'|| :in_site;

  my_resource_text = 'POS_ID_SMETKA:'||:in_id_smetka;
  my_post_text = substring(:my_post_text from 1 for 100);
  my_resource_text = substring(:my_resource_text from 1 for 49);

  if (:in_on_guest = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:in_id_guest, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code, '')
    returning_values  :err_code, :err_text, :out_id_account, :no_use;
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:in_id_account, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code)
    returning_values  :err_code, :err_text, :no_use;
    out_id_account = :in_id_account;
  end
end
^

/* Alter (EAI_POS_POSTING_ANUL$P2E) */
ALTER PROCEDURE EAI_POS_POSTING_ANUL$P2E(IN_ID_SMETKA INTEGER,
IN_USER_ANUL VARCHAR(100))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable resource_text varchar(100);
  declare variable id_account_post integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = 0;
  resource_text = 'POS_ID_SMETKA:'||:in_id_smetka ;
  in_user_anul = substring('POS ANULIRANE - '||:in_user_anul from 1 for 49);

  /* PROTECTION AGAINST DA NE SE ANULIRAT WSI4KI POSTOWE */
  if ((:resource_text is null) or (:resource_text = '')) then begin
    err_code = -85;
    err_text = 'Bill number can not be blank';
    exit;
  end
  err_code = 0;
  for
    select AP.ID_ACCOUNT_POST
    from   ACCOUNT_POSTING_DET AD
           join ACCOUNT_POST AP on AD.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
    where  AD.RESOURCE_TEXT = :resource_text
           and AP.IS_ANUL = 0
    into   :id_account_post
  do begin
    /* call ACCOUNT_POSTING_ANUL - to log changes */
    execute procedure ACCOUNT_POSTING_ANUL(:id_account_post, :in_user_anul);

    update ACCOUNT_POSTING_DET apd
    set    apd.ext_user_anul = coalesce(:in_user_anul, '')
    where  apd.id_account_post = :id_account_post;
  end
end
^

/* Alter (EAI_RES_CHECK_OUT_FAST) */
ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
declare variable selection_id integer;
  declare variable is_early_check_out smallint;
  declare variable early_check_out_dep_date date;
  declare variable check_out_date date;
begin
  selection_id = gen_id(selection_gen, 1);

  update RESERV_DETAIL RD
  set RD.SELECTION_ID = :SELECTION_ID
  where RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL;

  execute procedure RES_CHECK_OUT_CHECK$RSV(:selection_id)
  returning_values :is_early_check_out, :early_check_out_dep_date, :check_out_date;

  if (:is_early_check_out = 1) then
    exception BOOKING_EXCEPTION '-1043';

  execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id, 0);
end
^

/* Alter (EAI_TELECOUNT_TRANSFER) */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* empty dependent procedure body */
/* Clear: EXPORT_BOOKING$RSV for: EXPORT_BOOKING$EXC */
ALTER PROCEDURE EXPORT_BOOKING$RSV(DATA_RANGE VARCHAR(50))
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20),
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_NAME VARCHAR(100),
POSTING_ROUTING VARCHAR(20),
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EXPORT_BOOKING$EXC) */
ALTER PROCEDURE EXPORT_BOOKING$EXC(BOOKING_ID INTEGER)
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20,
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_ID INTEGER,
IS_GUEST_ARRANGER INTEGER,
POSTING_ROUTING VARCHAR(20),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IS_DIFFERENT_TARIFF SMALLINT,
IS_DIFFERENT_BOARD SMALLINT,
IS_CUSTOM_PRICE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
EXC_LOCAL_VERSION BIGINT,
EXC_REMOTE_VERSION BIGINT,
CREATE_DATETIME TIMESTAMP,
EATING_OBJECT VARCHAR(50))
 AS
declare variable arrival_type_code smallint;
BEGIN
  number = null;
  select h.hotel_name, b.number, bei.confirmation_number, bei.cancelation_number,
        bs.status, rg.id_reserv_group, rg.group_name, rg.uuid, b.is_vip, b.arrival_date, b.comming_kind,
        b.departure_date, b.is_late_departure, b.transfer_in_time, b.transfer_in_note,
        b.transfer_out_time, b.transfer_out_note, rt.type_room, board.name,
        b.room_features, b.i_special_treatment, hk.plan_name, r.tarifa_name, b.custom_price, b.custom_currency,
        b.deposit_required, b.deposit_required_currency, apt.payment_type, ppt.payment_type,
        b.voucher_num, b.voucher_date, b.voucher_text, ms.segment_name, sc.description,
        cc.description, hr.description, cr.description, b.note, b.note_reminders,
        b.code_first_food, ap.id_profile, isperson.id_profile as is_guest_arranger,
        b.acc_routing, b.is_different_room_type, b.is_different_stay_type, b.is_different_tariff,
        b.is_different_board, b.is_custom_price, b.is_different_price, bei.split_on_checkin,
        gp.name, b.block_cc, bei.guarantee_deposit_percent, bei.guarantee_deposit_nights,
        bei.guarantee_due_days_bef_arrival, bei.guarantee_due_days_after_create, bx.minibar_rights,
        bx.paytv_rights, bx.video_rights, bx.nopost_pms, bx.phone_rights, bx.seminar_cahnnel_rights,
        bei.posting_transaction_uuid, bei.exc_local_version, bei.exc_remote_version, bei.create_datetime,
        eo.name
  from  RES_LOAD(:booking_id) b
        join reserv_detail bei on bei.id_reserv_detail = :booking_id
        join HOTEL h on h.id_hotel = b.id_hotel
        join export_booking_status$exc(b.check_status, b.annul_status) bs on 1=1
        left outer join RESERV_GROUP RG on RG.ID_RESERV_GROUP = b.ID_GROUP
        join room_types rt on rt.id_room_type = b.id_res_room_type
        left outer join hk_plan hk on hk.id_plan = b.id_hk_plan
        join tarifa r on r.id_tarifa = b.id_tariff
        left outer join payment_type apt on apt.id_payment_type = b.id_agent_payment
        left outer join payment_type ppt on ppt.id_payment_type = b.id_person_payment
        left outer join nom_market_segments ms on ms.id_nom_market_segment = b.id_nom_market_segment
        left outer join nom_source_codes sc on sc.id_nom_source_code = b.id_nom_source_code
        left outer join nom_channel_codes cc on cc.id_nom_channel_code = b.id_nom_channel_code
        left outer join nom_hear_reasons hr on hr.id_nom_hear_reason = b.id_nom_hear_reason
        left outer join nom_come_reasons cr on cr.id_nom_come_reason = b.id_nom_come_reason
        left outer join profile ap on ap.id_profile = b.id_agent_profile
        left outer join profile_person isperson on isperson.id_profile = b.id_agent_profile
        left outer join meals board on board.ID_BOARD = bei.ID_BOARD
        left outer join guarantee_policy gp on gp.id_guarantee_policy=b.id_guarantee_policy
        left outer join reserv_detail_external bx on bx.id_reserv_detail = :booking_id
        left outer join eating_object eo on eo.id_eating_object = b.id_eating_object
  into  :hotel,
        :number,
        :confirmation_number,
        :cancelation_number,
        :status,
        :group_id,
        :group_name,
        :group_uuid,
        :is_vip,
        :arrival,
        :arrival_type_code,
        :departure,
        :is_late_departure,
        :transfer_in_time,
        :transfer_in_note,
        :transfer_out_time,
        :transfer_out_note,
        :room_type,
        :board,
        :room_preferences,
        :special_treatment,
        :maintance_shema,
        :rate,
        :manual_price,
        :manual_price_currency,
        :deposit_required,
        :deposit_required_currency,
        :arranger_payment_type,
        :guest_payment_type,
        :voucher,
        :voucher_date,
        :voucher_text,
        :marketing_segment,
        :marketing_source_code,
        :marketing_channel_code,
        :marketing_hear_reason,
        :marketing_come_reason,
        :note,
        :note_reminders,
        :first_food,
        :arranger_profile_id,
        :is_guest_arranger,
        :posting_routing,
        :is_different_room_type,
        :is_different_stay_type,
        :is_different_tariff,
        :is_different_board,
        :is_custom_price,
        :is_different_price,
        :split_on_checkin,
        :guarantee_policy,
        :block_cc,
        :guarantee_deposit_percent,
        :guarantee_deposit_nights,
        :guarantee_due_days_bef_arrival,
        :guarantee_due_days_after_create,
        :minibar_rights,
        :paytv_rights,
        :video_rights,
        :nopost_pms,
        :phone_rights,
        :seminar_cahnnel_rights,
        :posting_transaction_uuid,
        :exc_local_version,
        :exc_remote_version,
        :create_datetime,
        :eating_object
  ;

  if (:number is not null) then begin -- Check if we have export
    arrival_type = null;
    if (0 = :arrival_type_code) then begin
      arrival_type = 'early';
    end else if (2 = :arrival_type_code) then begin
      arrival_type = 'late';
    end
    suspend;
  end
END
^

/* Alter (EXPORT_BOOKING$RSV) */
ALTER PROCEDURE EXPORT_BOOKING$RSV(DATA_RANGE VARCHAR(50))
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20,
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_NAME VARCHAR(100),
POSTING_ROUTING VARCHAR(20),
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER)
 AS
BEGIN
  for select EB.HOTEL,
             EB.NUMBER, 
             EB.CONFIRMATION_NUMBER, 
             EB.CANCELATION_NUMBER,
             EB.STATUS, 
             EB.GROUP_ID, 
             EB.GROUP_NAME, 
             EB.IS_VIP,
             EB.ARRIVAL, 
             EB.ARRIVAL_TYPE, 
             EB.DEPARTURE, 
             EB.IS_LATE_DEPARTURE, 
             EB.TRANSFER_IN_TIME, 
             EB.TRANSFER_IN_NOTE, 
             EB.TRANSFER_OUT_TIME, 
             EB.TRANSFER_OUT_NOTE, 
             EB.ROOM_TYPE, 
             EB.BOARD, 
             EB.ROOM_PREFERENCES,
             EB.SPECIAL_TREATMENT, 
             EB.MAINTANCE_SHEMA, 
             EB.RATE, 
             EB.MANUAL_PRICE, 
             EB.MANUAL_PRICE_CURRENCY, 
             EB.DEPOSIT_REQUIRED, 
             EB.DEPOSIT_REQUIRED_CURRENCY, 
             EB.ARRANGER_PAYMENT_TYPE, 
             EB.GUEST_PAYMENT_TYPE, 
             EB.VOUCHER, 
             EB.VOUCHER_DATE, 
             EB.VOUCHER_TEXT, 
             EB.MARKETING_SEGMENT, 
             EB.MARKETING_SOURCE_CODE, 
             EB.MARKETING_CHANNEL_CODE, 
             EB.MARKETING_HEAR_REASON, 
             EB.MARKETING_COME_REASON, 
             EB.NOTE, 
             EB.NOTE_REMINDERS, 
             EB.FIRST_FOOD, 
             P.PROFILE_NAME,
             EB.POSTING_ROUTING, 
             EB.SPLIT_ON_CHECKIN, 
             EB.GUARANTEE_POLICY, 
             EB.GUARANTEE_DEPOSIT_PERCENT, 
             EB.GUARANTEE_DEPOSIT_NIGHTS, 
             EB.GUARANTEE_DUE_DAYS_BEF_ARRIVAL, 
             EB.GUARANTEE_DUE_DAYS_AFTER_CREATE
  from TMP_IDS ids
       left outer join EXPORT_BOOKING$EXC(ids.ID) EB on 1=1
       left outer join PROFILE P on P.ID_PROFILE = EB.ARRANGER_PROFILE_ID
  where ids.CONTEXT = :data_range
  into :hotel,
       :number, 
       :confirmation_number, 
       :cancelation_number,
       :status,
       :group_id, 
       :group_name, 
       :is_vip,
       :arrival, 
       :arrival_type, 
       :departure, 
       :is_late_departure, 
       :transfer_in_time, 
       :transfer_in_note, 
       :transfer_out_time, 
       :transfer_out_note, 
       :room_type, 
       :board, 
       :room_preferences,
       :special_treatment, 
       :maintance_shema, 
       :rate, 
       :manual_price, 
       :manual_price_currency, 
       :deposit_required, 
       :deposit_required_currency, 
       :arranger_payment_type, 
       :guest_payment_type, 
       :voucher, 
       :voucher_date, 
       :voucher_text, 
       :marketing_segment, 
       :marketing_source_code, 
       :marketing_channel_code, 
       :marketing_hear_reason, 
       :marketing_come_reason, 
       :note, 
       :note_reminders, 
       :first_food, 
       :arranger_profile_name,
       :posting_routing, 
       :split_on_checkin, 
       :guarantee_policy, 
       :guarantee_deposit_percent, 
       :guarantee_deposit_nights, 
       :guarantee_due_days_bef_arrival, 
       :guarantee_due_days_after_create
  do suspend;
END
^

/* Alter (GUEST_ACCOUNT_TRANSFER$INT) */
ALTER PROCEDURE GUEST_ACCOUNT_TRANSFER$INT(ID_GUEST INTEGER,
ID_SOURCE_ACCOUNT INTEGER,
ID_TARGET_ACCOUNT INTEGER,
SERVICE_TYPE VARCHAR(20))
 AS
declare variable dbkey char(8);
begin

  if (:service_type = 'BASE') then begin
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.ID_ACCOUNT = :id_source_account
             and AP.AC = '00'
             and AP.ID_BASE_DOC is null
             and ((AP.IS_BASE = 1) or (AP.ID_MASTER_ADDINS_ACC_POST <> -1))
      into   :dbkey
    do
      execute procedure ACCOUNT_POSTING_TRANSFER$INT(:dbkey, :id_target_account);

  end else begin
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.ID_ACCOUNT = :id_source_account
             and AP.AC = '00'
             and AP.ID_BASE_DOC is null
             and ((AP.IS_BASE = 0) and (AP.ID_MASTER_ADDINS_ACC_POST = -1))
      into   :dbkey
    do
      execute procedure ACCOUNT_POSTING_TRANSFER$INT(:dbkey, :id_target_account);

  end
end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTS$INT for: GUEST_REROUTE_POSTINGS$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTS$INT(RD_DBKEY CHAR(8))
 AS
 BEGIN EXIT; END
^

/* Alter (GUEST_REROUTE_POSTINGS$INT) */
ALTER PROCEDURE GUEST_REROUTE_POSTINGS$INT(ID_GUEST INTEGER,
ID_BASE_ACCOUNT INTEGER,
ID_EXTRA_ACCOUNT INTEGER)
 AS
declare variable ap_dbkey char(8);
  declare variable is_packet_post integer;
  declare variable packet_option varchar(50);
  declare variable id_target_account integer;
  declare variable id_current_account integer;
begin
  update GUEST G
  set    G.ID_BASE_ACCOUNT = :ID_BASE_ACCOUNT,
         G.ID_ACCOUNT = :ID_EXTRA_ACCOUNT
  where  G.ID_GUEST = :ID_GUEST;

  for
    select AP.RDB$DB_KEY, iif(AP.ID_MASTER_ADDINS_ACC_POST > 0, 1, 0), S.VAUCHER_PACKET,
           ap.ID_ACCOUNT
    from   ACCOUNT_POST AP
           join SERVICES S on S.ID_SERVICE = AP.ID_SERVICE
    where  AP.ID_GUEST = :ID_GUEST
           and AP.AC = '00'
           and AP.ID_BASE_DOC is null
    into   :ap_dbkey, :is_packet_post, :packet_option, :id_current_account
  do begin
    if ((:is_packet_post = 1) and (:packet_option <> 'NONE')) then id_target_account = :id_base_account;
    else id_target_account = :id_extra_account;

    if (:id_current_account <> :id_target_account) then begin
      execute procedure ACCOUNT_POSTING_TRANSFER$INT(:ap_dbkey, :id_target_account);
    end
  end

end
^

/* empty dependent procedure body */
/* Clear: TEST_BOOKING_IMPORT for: IMPORT_BOOKING$EXC */
ALTER PROCEDURE TEST_BOOKING_IMPORT AS
 BEGIN EXIT; END
^

/* Alter (IMPORT_BOOKING$EXC) */
ALTER PROCEDURE IMPORT_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(250),
MAINTANCE_SHEMA VARCHAR(30),
POSTING_ROUTING VARCHAR(20),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
COMPLIMENTARY_ACCOUNT VARCHAR(50),
EATING_OBJECT VARCHAR(50),
CREATE_DATETIME TIMESTAMP)
 RETURNS(HOTEL_ID INTEGER,
BOOKING_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable current_hotel_id integer;
declare variable booking_update_id integer;
declare variable warn_code integer;
declare variable share_transaction_id integer;
declare variable share_err_code integer;
declare variable arranger_profile_id integer;
declare variable main_guest_profile_id integer;
declare variable rate_id integer;
declare variable room_type_id integer;
declare variable board_id integer;
declare variable maintance_shema_id integer;
declare variable arranger_payment_type_id integer;
declare variable guest_payment_type_id integer;
declare variable marketing_segment_id integer;
declare variable marketing_source_code_id integer;
declare variable marketing_channel_code_id integer;
declare variable marketing_hear_reason_id integer;
declare variable marketing_come_reason_id integer;
declare variable arranger_account_id integer;
declare variable packet_id integer;
declare variable id_guarantee_policy integer;
declare variable first_food_code tfood_code;
declare variable arrival_type_code smallint;
declare variable booking_dbkey char(8);
declare variable reserv_group_id integer;
declare variable id_complimentary_account integer;
declare variable id_eating_object integer;
begin
  /*execute procedure sys_dbg('exc IMPORT_BOOKING$EXC('
  || 'hotel => ' || coalesce(:hotel, '<null>')
  || ', booking_number => ' || coalesce(:number, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  ||')');
  */
  execute procedure import_mark_transaction$exc;

  /* init */
  err_code = 0;
  err_text = '';
  booking_update_id = null;
  booking_dbkey = null;
  current_hotel_id = null;
  if (:voucher_date is not null) then begin
    voucher_date = striptime(:voucher_date);
  end
  posting_routing = upper(:posting_routing);

  /* detect inser/update mode */
  select b.id_reserv_detail, b.rdb$db_key, b.id_hotel
  from   reserv_detail b
  where  b.number=:number
         and b.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and b.id_log_event_annul is null
  into   :booking_update_id, :booking_dbkey, :current_hotel_id;

  if (:booking_update_id is null) then begin
    booking_id = gen_id (id_reserv_detail_gen, 1);
  end else begin
    booking_id = :booking_update_id;
  end

  /* text to id map */
  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => MAP_BOOKING_RELATIONS$EXC');
  execute procedure MAP_BOOKING_RELATIONS$EXC(
    :booking_id,
    :hotel,
    :room_type,
    :board,
    :maintance_shema,
    :rate,
    :arranger_payment_type,
    :guest_payment_type,
    :marketing_segment,
    :marketing_source_code,
    :marketing_channel_code,
    :marketing_hear_reason,
    :marketing_come_reason,
    :first_food,
    :arranger_profile_uuid,
    :arranger_profile_name,
    :main_guest_profile_uuid,
    :arrival_type,
    :guarantee_policy,
    :eating_object
  ) returning_values
    :arranger_profile_id,
    :main_guest_profile_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :hotel_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :first_food_code,
    :arrival_type_code,
    :id_guarantee_policy,
    :id_eating_object;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* hotel change test */
  if (coalesce(:current_hotel_id, :hotel_id) <> :hotel_id) then begin
    execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', null, :hotel, 'booking hotel changed');
  end

  id_complimentary_account = null;
  if (complimentary_account is not null) then begin
    execute procedure lookup_account$exc(:hotel_id, :complimentary_account, 'booking', :booking_id)
    returning_values :id_complimentary_account;
  end

  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => CREATE_PACK_INSTANCE$EXC');
  packet_id = null;
  /*execute procedure CREATE_PACK_INSTANCE$EXC(
    :hotel_id, :booking_id, :package
  )
  returning_values :packet_id, :err_code, :err_text;
  if (0 <> :err_code) then exit;
  */
  /* merge input and default/persistent database values */
  execute procedure DEFAULT_BOOKING_VALUES$EXC(
    :booking_dbkey, :hotel_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :group_name,
    :group_uuid,
    :is_late_departure,
    :id_eating_object
  ) returning_values
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :arranger_account_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :reserv_group_id,
    :is_late_departure,
    :id_eating_object;

  if ('' = :board) then board_id = null; /* preserve "empty board" state and discard default value */

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC DEFAULTED => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* if the booking is complimentary use complimentary account */
  arranger_account_id = coalesce(:id_complimentary_account, :arranger_account_id);

  /* CREATE or UPDATE */
  if (:booking_update_id is not null) then begin
    /* UPDATE booking */
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => UPDATE_BOOKING$EXC');
    execute procedure UPDATE_BOOKING$EXC(
      :booking_id,
      :reserv_group_id,
      :is_vip,
      :arrival,
      :arrival_type_code,
      :departure,
      :is_late_departure,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :room_type_id,
      :board_id,
      :room_preferences,
      :special_treatment,
      :maintance_shema_id,
      :posting_routing,
      :arranger_account_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :deposit_required,
      :deposit_required_currency,
      :arranger_payment_type_id,
      :guest_payment_type_id,
      :voucher,
      :voucher_date,
      :voucher_text,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :note,
      :note_reminders,
      :first_food_code,
      :arranger_profile_id,
      :main_guest_profile_id,
      :is_different_rate,
      :is_different_price,
      :split_on_checkin,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object
    ) returning_values :err_code, :err_text;
    if (0 <> :err_code) then begin
      exit;
    end
  end else begin
    /* CREATE booking */
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => RES_CREATE_SET$EXC');
    execute procedure RES_CREATE_SET$EXC (
      :booking_id,
      :number,
      :arranger_profile_id,
      :main_guest_profile_id,
      :arrival,
      :departure,
      :adult_count,
      :children_count,
      :room_type_id,
      null,
      :board_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :voucher,
      :voucher_date,
      :voucher_text,
      null,
      null,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :arrival_type_code,
      :is_late_departure,
      :is_vip,
      :first_food_code,
      :special_treatment,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :arranger_account_id,
      :posting_routing,
      :guest_payment_type_id,
      :arranger_payment_type_id,
      null,
      :room_preferences,
      :maintance_shema_id,
      :note,
      :note_reminders,
      :deposit_required,
      :deposit_required_currency,
      :hotel_id,
      :reserv_group_id,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object,
      :create_datetime
      )
    returning_values :err_code, :err_text, :warn_code, :booking_id, :share_transaction_id, :share_err_code;
  end

  execute procedure GUEST_STAY_INITIALIZE$INT (:booking_id);
  /* final error check */
  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;

  delete from PENDING_DEPOSIT d
  where  d.ID_RESERV_DETAIL = :BOOKING_ID;
end
^

/* Alter (IMPORT_BOOKING_FINALIZE$EXC) */
ALTER PROCEDURE IMPORT_BOOKING_FINALIZE$EXC(BOOKING_ID INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1,
STATUS VARCHAR(50) = null,
CONFIRMATION_NUMBER NAME_20 = null,
CANCELATION_NUMBER NAME_20 = null)
 RETURNS(RECORD_TIMESTAMP TIMESTAMP,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable booking_db_key char(8);
  declare variable dummy_int integer;
  declare variable dummy_text varchar(255) ;
  declare variable res_id_room integer;
  declare variable id_room integer;
  declare variable id_room_type integer;
  declare variable id_hotel integer;
  declare variable system_date date;
  declare variable from_date date;
  declare variable gs_dbkey char(8);
begin
  ERR_CODE=0;
  ERR_TEXT=null;
  id_room = null;
  force_res_finalize = coalesce(:force_res_finalize, 1);

  execute procedure sys_dbg('exc IMPORT_BOOKING_FINALIZE$EXC => CLEAR_ORPHAN_GUESTS$EXC');
  execute procedure CLEAR_ORPHAN_GUESTS$EXC(:booking_id);

  select b.rdb$db_key, b.ID_ROOM, b.ID_ROOM_TYPE, b.ID_HOTEL, b.FROM_DATE
  from   reserv_detail b
  where  b.id_reserv_detail = :booking_id
  into   :booking_db_key, :res_id_room, :id_room_type, :id_hotel, :from_date;

  execute procedure RES_GUEST_SAVE_DIFF$INT(:booking_db_key);

  if (:res_id_room < 0) then begin
    select sd.SYSTEM_DATE
    from   SYSTEM_DATE_GET (:id_hotel) sd
    into   :system_date;

    select ro.ID_ROOM, ro.ID_ROOM_TYPE
    from   RES_OCCUPANCY_ROOM$INT (:BOOKING_ID, maxdate(:system_date, :from_date), null, :id_room_type) ro
    into   :id_room, :id_room_type;

--    has_different_room_type = null;
    if (:id_room <> :res_id_room) then begin
      for
        select gs.RDB$DB_KEY
        from   GUEST_STAY GS
               join GUEST G on g.ID_GUEST = gs.ID_GUEST
        where  g.ID_RESERV_DETAIL = :BOOKING_ID
               and gs.FOR_DATE >= maxdate(:system_date, :from_date)
               and gs.ID_ROOM <> :id_room
        into   :gs_dbkey
      do begin
        update GUEST_STAY gsu
        set    gsu.ID_ROOM = :id_room
               --gsu.ID_ROOM_TYPE = iif (gsu.ID_ROOM_TYPE = -1, :id_room_type, gsu.ID_ROOM_TYPE)
        where  gsu.RDB$DB_KEY = :gs_dbkey;
        --has_different_room_type = 1;
      end

      update GUEST G
      set    G.ID_ROOM = :id_room
      where  g.ID_RESERV_DETAIL = :BOOKING_ID;
    end
  end

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null,   --force recalculation
         rd.ID_ROOM = coalesce(:id_room, :res_id_room)
         --rd.HAS_DIFFERENT_ROOM_TYPE = coalesce(:has_different_room_type,  rd.HAS_DIFFERENT_ROOM_TYPE)
  where  rd.RDB$DB_KEY = :booking_db_key;

  if (1 = :force_res_finalize) then begin
    execute procedure sys_dbg('exc IMPORT_BOOKING_FINALIZE$EXC => RES_FINALIZE_SHAREOPTION$INT');
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:booking_db_key, 0)
    returning_values  :dummy_int, :dummy_text, :dummy_int, :dummy_int;
  end

  execute procedure APPLY_BOOKING_STATUS$EXC(
    null, :booking_db_key, :status, :confirmation_number, :cancelation_number
  );

  select b.change_time
  from   reserv_detail b
  where  b.rdb$db_key =:booking_db_key
  into   :record_timestamp;
end
^

/* Alter (IMPORT_NOM_CHANNEL_CODE$EXC) */
ALTER PROCEDURE IMPORT_NOM_CHANNEL_CODE$EXC(CODE VARCHAR(3),
DESCRIPTION VARCHAR(30),
UUID VARCHAR(40))
 RETURNS(ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable OPERATION VARCHAR(3);
begin
  ID = null;
  ERR_CODE = 0;
  ERR_TEXT = '';
  
  execute procedure sys_dbg(
  'exc IMPORT_NOM_CHANNEL_CODE$EXC(:CODE=>' || coalesce(:CODE, '<null>')
    || ', :DESCRIPTION=>' || coalesce(:DESCRIPTION, '<null>')
    || ', :UUID=>' || coalesce(:UUID, '<null>')
  || ')');

  select cc.ID_NOM_CHANNEL_CODE
  from NOM_CHANNEL_CODES cc
  where cc.UUID = :UUID and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :ID;

  OPERATION = 'mod';
  if (ID is null) then begin
    OPERATION = 'add';
  end

  execute procedure NOM_MODIFY_CHANNEL_CODES(:ID,  :CODE, :DESCRIPTION, :OPERATION)
  returning_values :ID, :ERR_CODE, :ERR_TEXT;

  update NOM_CHANNEL_CODES cc
    set cc.UUID = :UUID
    where cc.ID_NOM_CHANNEL_CODE = :ID;
end
^

/* empty dependent procedure body */
/* Clear: CLEAR_BP_ALLOTMENT$EXC for: LOG_ID_LOOKUP_ERROR$EXC */
ALTER PROCEDURE CLEAR_BP_ALLOTMENT$EXC(HOTEL_NAME VARCHAR(50),
AGENT_UUID /* TYPE OF UUID */ VARCHAR(40))
 RETURNS(ID_HOTEL INTEGER,
ID_ALLOTMENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: CLEAR_CONTINGENT_ALLOTMENT$EXC for: LOG_ID_LOOKUP_ERROR$EXC */
ALTER PROCEDURE CLEAR_CONTINGENT_ALLOTMENT$EXC(HOTEL_NAME VARCHAR(50),
AGENT_UUID /* TYPE OF UUID */ VARCHAR(40))
 RETURNS(ID_HOTEL INTEGER,
ID_ALLOTMENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: LOOKUP_ACCOUNT$EXC for: LOG_ID_LOOKUP_ERROR$EXC */
ALTER PROCEDURE LOOKUP_ACCOUNT$EXC(ID_HOTEL INTEGER,
NAME VARCHAR(50),
LOG_OBJECT_TYPE VARCHAR(100) = null,
LOG_OBJECT_ID VARCHAR(100) = null)
 RETURNS(ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: LOOKUP_BOARD$EXC for: LOG_ID_LOOKUP_ERROR$EXC */
ALTER PROCEDURE LOOKUP_BOARD$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30),
ONLY_BOARDS SMALLINT)
 RETURNS(ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: LOOKUP_BONUSPOINT_SCHEME$EXC for: LOG_ID_LOOKUP_ERROR$EXC */
ALTER PROCEDURE LOOKUP_BONUSPOINT_SCHEME$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(50))
 RETURNS(ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: LOOKUP_CHANNEL$EXC for: LOG_ID_LOOKUP_ERROR$EXC */
ALTER PROCEDURE LOOKUP_CHANNEL$EXC(OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30))
 RETURNS(ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: LOOKUP_EATING_OBJECT$EXC for: LOG_ID_LOOKUP_ERROR$EXC */
ALTER PROCEDURE LOOKUP_EATING_OBJECT$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(100),
OBJECT_TYPE VARCHAR(100),
NAME VARCHAR(100))
 RETURNS(ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: LOOKUP_GUARANTEE_POLICY$EXC for: LOG_ID_LOOKUP_ERROR$EXC */
ALTER PROCEDURE LOOKUP_GUARANTEE_POLICY$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(100),
OBJECT_TYPE VARCHAR(100),
NAME VARCHAR(100))
 RETURNS(ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: LOOKUP_GUEST_TYPE$EXC for: LOG_ID_LOOKUP_ERROR$EXC */
ALTER PROCEDURE LOOKUP_GUEST_TYPE$EXC(OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30))
 RETURNS(ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: LOOKUP_HK_PLAN$EXC for: LOG_ID_LOOKUP_ERROR$EXC */
ALTER PROCEDURE LOOKUP_HK_PLAN$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30))
 RETURNS(ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: LOOKUP_HK_PLAN_ITEM$EXC for: LOG_ID_LOOKUP_ERROR$EXC */
ALTER PROCEDURE LOOKUP_HK_PLAN_ITEM$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(50))
 RETURNS(ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: LOOKUP_HOTEL$EXC for: LOG_ID_LOOKUP_ERROR$EXC */
ALTER PROCEDURE LOOKUP_HOTEL$EXC(NAME VARCHAR(50),
OBJECT_TYPE VARCHAR(100) = null,
OBJECT_ID VARCHAR(100) = null)
 RETURNS(ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: LOOKUP_MARKET_SEGMENT$EXC for: LOG_ID_LOOKUP_ERROR$EXC */
ALTER PROCEDURE LOOKUP_MARKET_SEGMENT$EXC(OBJECT_ID VARCHAR(100),
OBJECT_TYPE VARCHAR(100),
NAME VARCHAR(100))
 RETURNS(ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: LOOKUP_PACKET_ITEM$EXC for: LOG_ID_LOOKUP_ERROR$EXC */
ALTER PROCEDURE LOOKUP_PACKET_ITEM$EXC(ID_HOTEL INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(50))
 RETURNS(ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: LOOKUP_PAYMENT_TYPE$EXC for: LOG_ID_LOOKUP_ERROR$EXC */
ALTER PROCEDURE LOOKUP_PAYMENT_TYPE$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30))
 RETURNS(ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: LOOKUP_RATE$EXC for: LOG_ID_LOOKUP_ERROR$EXC */
ALTER PROCEDURE LOOKUP_RATE$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(50))
 RETURNS(ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: LOOKUP_ROOM_TYPE$EXC for: LOG_ID_LOOKUP_ERROR$EXC */
ALTER PROCEDURE LOOKUP_ROOM_TYPE$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30))
 RETURNS(ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: LOOKUP_SALE_DISCOUNT$EXC for: LOG_ID_LOOKUP_ERROR$EXC */
ALTER PROCEDURE LOOKUP_SALE_DISCOUNT$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30))
 RETURNS(ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: LOOKUP_SERVICE$EXC for: LOG_ID_LOOKUP_ERROR$EXC */
ALTER PROCEDURE LOOKUP_SERVICE$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30))
 RETURNS(ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: LOOKUP_STAY_TYPE$EXC for: LOG_ID_LOOKUP_ERROR$EXC */
ALTER PROCEDURE LOOKUP_STAY_TYPE$EXC(OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30))
 RETURNS(ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: LOOKUP_TAX_POLICY$EXC for: LOG_ID_LOOKUP_ERROR$EXC */
ALTER PROCEDURE LOOKUP_TAX_POLICY$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30))
 RETURNS(ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: MAP_BOOKING_RELATIONS$EXC for: LOG_ID_LOOKUP_ERROR$EXC */
ALTER PROCEDURE MAP_BOOKING_RELATIONS$EXC(BOOKING_ID INTEGER,
HOTEL VARCHAR(50),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
MARKETING1 VARCHAR(30),
MARKETING2 VARCHAR(30),
MARKETING3 VARCHAR(30),
MARKETING4 VARCHAR(30),
MARKETING5 VARCHAR(30),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
ARRIVAL_TYPE VARCHAR(20),
GUARANTEE_POLICY VARCHAR(50),
EATING_OBJECT VARCHAR(50))
 RETURNS(ARRANGER_PROFILE_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
RATE_ID INTEGER,
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
HOTEL_ID INTEGER,
MAINTANCE_SHEMA_ID INTEGER,
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
FIRST_FOOD_CODE /* TFOOD_CODE */ VARCHAR(20),
ARRIVAL_TYPE_CODE SMALLINT,
GUARANTEE_POLICY_ID INTEGER,
EATING_OBJECT_ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (LOG_ID_LOOKUP_ERROR$EXC) */
ALTER PROCEDURE LOG_ID_LOOKUP_ERROR$EXC(OBJECT_ID VARCHAR(100),
OBJECT_TYPE VARCHAR(100),
LOOKUP_VALUE INTEGER,
LOOKUP_KEY VARCHAR(255),
LOOKUP_TYPE VARCHAR(255))
 AS
begin
  execute procedure sys_dbg(
    'exc LOG_ID_LOOKUP_ERROR$EXC(:object_id=>' || coalesce(:OBJECT_ID, '<null>')
    || ', :object_type=>' || coalesce(:OBJECT_TYPE, '<null>')
    || ', :lookup_key=>' || coalesce(:LOOKUP_KEY, '<null>')
    || ', :lookup_value=>' || coalesce(:LOOKUP_VALUE, '<null>')
    || ', :lookup_type=>' || coalesce(:LOOKUP_TYPE, '<null>')
   || ')');
  if (:LOOKUP_VALUE is not null) then begin
    exit;
  end
  if ((:LOOKUP_KEY is null) or ('' = :LOOKUP_KEY))  then begin
    exit;
  end

  if (:OBJECT_TYPE = 'BOOKING') then begin
    execute procedure RES_FINALIZE_ERRHANDLING$INT(
      :OBJECT_ID, -1019, coalesce(:LOOKUP_TYPE || ': ',  '') || :LOOKUP_KEY, 'IMPORT', 1);
  end else begin
    insert into IMPORT_LOOKUP_ERRORS$TMP(ERROR_ID, OBJECT_TYPE, OBJECT_ID, LOOKUP_KEY, ERR_CODE, ERR_TEXT)
    values (gen_id(GEN_IMPORT_LOOKUP_ERROR_ID, 1), :OBJECT_TYPE, :OBJECT_ID, :LOOKUP_KEY, -1019, :LOOKUP_TYPE);
  end
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_ACCOUNT$EXC for: LOOKUP_ACCOUNT$EXC */
ALTER PROCEDURE IMPORT_ACCOUNT$EXC(ACCOUNT_NAME VARCHAR(50),
ACCOUNT_CURR VARCHAR(3),
IS_CREDIT_ACCOUNT SMALLINT,
CREDIT_LIMIT NUMERIC(15,4),
PAYMENT_TYPE VARCHAR(20),
NOTE VARCHAR(255),
IS_BLOCKED SMALLINT,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE SMALLINT,
IS_EXTRA SMALLINT,
IS_ALOWED_POS_INTERFACE SMALLINT,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
IS_DEFAULT SMALLINT,
HOTEL_NAME VARCHAR(50))
 RETURNS(ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (LOOKUP_ACCOUNT$EXC) */
ALTER PROCEDURE LOOKUP_ACCOUNT$EXC(ID_HOTEL INTEGER,
NAME VARCHAR(50),
LOG_OBJECT_TYPE VARCHAR(100) = null,
LOG_OBJECT_ID VARCHAR(100) = null)
 RETURNS(ID INTEGER)
 AS
begin
  ID = null;
  select first 1 a.ID_ACCOUNT
    from ACCOUNT a
    where a.ACCOUNT_NAME = :NAME and a.ID_HOTEL = :ID_HOTEL
    into :ID;

  if ((:LOG_OBJECT_ID || :LOG_OBJECT_TYPE) is not null) then begin
    execute procedure log_id_lookup_error$exc(:LOG_OBJECT_ID, :LOG_OBJECT_TYPE, :ID, :NAME, 'account');
  end

  suspend;
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_RATE$EXC for: LOOKUP_BOARD$EXC */
ALTER PROCEDURE IMPORT_RATE$EXC(TARIFA_NAME VARCHAR(50),
TARIFA_GROUP VARCHAR(30),
HOTEL_NAME VARCHAR(50),
TARIFA_CURR VARCHAR(3),
IS_ACTIVE SMALLINT,
TARIFA_NOTE VARCHAR(500),
PERIOD_DEPEND_ON_CHECKIN SMALLINT,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BOARD_TYPE VARCHAR(10),
SOURCE_BASE_BOARDS_LIST VARCHAR(255),
TMP_DATA BLOB SUB_TYPE 1,
LOCK_KEY VARCHAR(100),
LOCK_STAMP TIMESTAMP,
UUID VARCHAR(40),
RATE_TYPE VARCHAR(20),
IS_SIMPLE SMALLINT,
CHILD_AGE_INCL INTEGER,
IS_PUBLIC /* TYPE OF TLOGICAL */ SMALLINT,
EXPLICIT_TAX_POLICY_NAME /* TDESCRIPTION_SHORT */ VARCHAR(100) = null,
EXPLICIT_POLICY_NIGHTS_REQUIRED /* TCOUNT */ INTEGER = null)
 RETURNS(ID_TARIFA INTEGER,
ID_TARIFA_GROUP INTEGER,
ID_HOTEL INTEGER,
ID_TAR_SIMPLE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_RATE_SIMPLE_BOARD$EXC for: LOOKUP_BOARD$EXC */
ALTER PROCEDURE IMPORT_RATE_SIMPLE_BOARD$EXC(ID_HOTEL INTEGER,
ID_TAR_SIMPLE_SEASON INTEGER,
RATE_NAME VARCHAR(30),
BOARD_NAME VARCHAR(30),
ADULT_PRICE NUMERIC(15,4),
CHILD_PRICE NUMERIC(15,4))
 RETURNS(ID_TAR_SIMPLE_BOARDS INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_RATE_SIMPLE_PRICE$EXC for: LOOKUP_BOARD$EXC */
ALTER PROCEDURE IMPORT_RATE_SIMPLE_PRICE$EXC(ID_TAR_SIMPLE_SEASON INTEGER,
RATE_NAME VARCHAR(30),
HOTEL_NAME VARCHAR(50),
ROOM_TYPE VARCHAR(20),
BOARD_NAME VARCHAR(30),
SINGLE_PRICE NUMERIC(15,4),
DOUBLE_PRICE NUMERIC(15,4),
GUEST3_PRICE NUMERIC(15,4),
GUEST4PLUS_PRICE NUMERIC(15,4),
CHILD1_W_ADULT1_PRICE NUMERIC(15,4),
CHILD1_W_ADULT2PLUS_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT1_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT2PLUS_PRICE NUMERIC(15,4),
IS_BASE_DAYS_PRICE SMALLINT)
 AS
 BEGIN EXIT; END
^

/* Alter (LOOKUP_BOARD$EXC) */
ALTER PROCEDURE LOOKUP_BOARD$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30),
ONLY_BOARDS SMALLINT)
 RETURNS(ID INTEGER)
 AS
begin
  ID = null;
  select first 1 m.ID_SERVICE
  from   MEALS m
  where  m.ID_HOTEL = :HOTEL_ID
         and m.NAME = :NAME
         and ((:ONLY_BOARDS is distinct from 1) or (m.IS_BOARD = 1))
  into   :ID;

  execute procedure LOG_ID_LOOKUP_ERROR$EXC(:OBJECT_ID, :OBJECT_TYPE, :ID, :NAME, 'board');
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_PROFILE_BONUS_SCHEME$EXC for: LOOKUP_BONUSPOINT_SCHEME$EXC */
ALTER PROCEDURE IMPORT_PROFILE_BONUS_SCHEME$EXC(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PROFILE_TYPE VARCHAR(50),
BONUSPOINT_SCHEME_NAME VARCHAR(50),
HOTEL_NAME VARCHAR(100))
 AS
 BEGIN EXIT; END
^

/* Alter (LOOKUP_BONUSPOINT_SCHEME$EXC) */
ALTER PROCEDURE LOOKUP_BONUSPOINT_SCHEME$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(50))
 RETURNS(ID INTEGER)
 AS
begin
  id = null;
  select first 1 bs.ID_BONUSPOINT_SCHEME
  from   BONUSPOINT_SCHEME bs
  where  (bs.ID_HOTEL = :HOTEL_ID) and (bs.NAME = :NAME)
  into   :ID;

  execute procedure log_id_lookup_error$exc(:OBJECT_ID, :OBJECT_TYPE, :ID, :NAME, 'bonus_scheme');
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_CHANNEL_MAPPED_RATE$EXC for: LOOKUP_CHANNEL$EXC */
ALTER PROCEDURE IMPORT_CHANNEL_MAPPED_RATE$EXC(IMPORT_ID VARCHAR(40),
CHANNEL_NAME VARCHAR(30),
HOTEL_NAME VARCHAR(50),
RATE_NAME VARCHAR(50),
IS_PUBLIC SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_CHANNEL_MAPPED_RT$EXC for: LOOKUP_CHANNEL$EXC */
ALTER PROCEDURE IMPORT_CHANNEL_MAPPED_RT$EXC(IMPORT_ID VARCHAR(40),
CHANNEL_NAME VARCHAR(30),
HOTEL_NAME VARCHAR(50),
ROOM_TYPE VARCHAR(20),
MAX_GUEST_COUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (LOOKUP_CHANNEL$EXC) */
ALTER PROCEDURE LOOKUP_CHANNEL$EXC(OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30))
 RETURNS(ID INTEGER)
 AS
begin
  ID = null;
  select first 1 c.ID_CHANNEL
    from CHANNEL c
    where (c.NAME = :NAME)
    into :ID;

  execute procedure LOG_ID_LOOKUP_ERROR$EXC(:OBJECT_ID, :OBJECT_TYPE, :ID, :NAME, 'channel');
end
^

/* Alter (LOOKUP_EATING_OBJECT$EXC) */
ALTER PROCEDURE LOOKUP_EATING_OBJECT$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(100),
OBJECT_TYPE VARCHAR(100),
NAME VARCHAR(100))
 RETURNS(ID INTEGER)
 AS
begin
  ID = null;
  select first 1 eo.ID_EATING_OBJECT
  from   EATING_OBJECT eo
  where  eo.NAME = :NAME
         and eo.ID_HOTEL = :HOTEL_ID
  into   :ID;

  execute procedure LOG_ID_LOOKUP_ERROR$EXC(:OBJECT_ID, :OBJECT_TYPE, :ID, :NAME, 'eating_object');
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_PROFILE_BOOKING_DEF$EXC for: LOOKUP_GUARANTEE_POLICY$EXC */
ALTER PROCEDURE IMPORT_PROFILE_BOOKING_DEF$EXC(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PROFILE_TYPE VARCHAR(50),
HOTEL_NAME VARCHAR(100),
HK_PLAN_NAME VARCHAR(30),
GUARANTEE_POLICY_NAME VARCHAR(50),
I_SPECIAL_TREATMENT VARCHAR(30))
 AS
 BEGIN EXIT; END
^

/* Alter (LOOKUP_GUARANTEE_POLICY$EXC) */
ALTER PROCEDURE LOOKUP_GUARANTEE_POLICY$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(100),
OBJECT_TYPE VARCHAR(100),
NAME VARCHAR(100))
 RETURNS(ID INTEGER)
 AS
begin
  ID = null;
  select first 1 gp.ID_GUARANTEE_POLICY
  from   GUARANTEE_POLICY gp
  where  gp.NAME = :NAME
         and gp.ID_HOTEL = :HOTEL_ID
  into   :ID;

  execute procedure LOG_ID_LOOKUP_ERROR$EXC(:OBJECT_ID, :OBJECT_TYPE, :ID, :NAME, 'guarantee_policy');
end
^

/* Alter (LOOKUP_GUEST_TYPE$EXC) */
ALTER PROCEDURE LOOKUP_GUEST_TYPE$EXC(OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30))
 RETURNS(ID INTEGER)
 AS
begin
  ID = null;
  select first 1 gt.ID_GUEST_TYPE
    from GUEST_TYPE gt
    where (gt.GUEST_TYPE_NAME = :NAME) and (gt.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID'))
    into :ID;

  execute procedure LOG_ID_LOOKUP_ERROR$EXC(:OBJECT_ID, :OBJECT_TYPE, :ID, :NAME, 'guest_type');
end
^

/* Alter (LOOKUP_HK_PLAN$EXC) */
ALTER PROCEDURE LOOKUP_HK_PLAN$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30))
 RETURNS(ID INTEGER)
 AS
begin
  ID = null;
  select first 1 hkp.ID_PLAN
  from   HK_PLAN hkp
  where  hkp.ID_HOTEL = :HOTEL_ID and hkp.PLAN_NAME = :NAME
  into   :ID;

  execute procedure LOG_ID_LOOKUP_ERROR$EXC(:OBJECT_ID, :OBJECT_TYPE, :ID, :NAME, 'HK_PLAN');
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_HK_PLAN_LINE$EXC for: LOOKUP_HK_PLAN_ITEM$EXC */
ALTER PROCEDURE IMPORT_HK_PLAN_LINE$EXC(PLAN_NAME VARCHAR(30),
ID_PLAN_PERIOD INTEGER,
USE_PER_ARRIVAL SMALLINT,
USE_PER_DEPARTURE SMALLINT,
CYCLE_DURATION INTEGER,
QTY INTEGER,
MULTIPLY_TYPE VARCHAR(20),
PLAN_ITEM VARCHAR(50),
HOTEL_NAME VARCHAR(50),
ROOM_TYPE_LIST VARCHAR(500))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_PLAN_LINE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (LOOKUP_HK_PLAN_ITEM$EXC) */
ALTER PROCEDURE LOOKUP_HK_PLAN_ITEM$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(50))
 RETURNS(ID INTEGER)
 AS
begin
  ID = null;
  select first 1 pi.ID_PLAN_ITEM
    from HK_PLAN_ITEM pi
    where (pi.ID_HOTEL = :HOTEL_ID) and (pi.ITEM_NAME = :NAME)
    into :ID;

  execute procedure log_id_lookup_error$exc(:OBJECT_ID, :OBJECT_TYPE, :ID, :NAME, 'plan_item');
end
^

/* empty dependent procedure body */
/* Clear: CLEAR_EOCC_ALLOTMENT$EXC for: LOOKUP_HOTEL$EXC */
ALTER PROCEDURE CLEAR_EOCC_ALLOTMENT$EXC(HOTEL_NAME VARCHAR(50))
 RETURNS(ID_HOTEL INTEGER,
ID_ALLOTMENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: CLEAR_INVENTORY_ALLOTMENT$EXC for: LOOKUP_HOTEL$EXC */
ALTER PROCEDURE CLEAR_INVENTORY_ALLOTMENT$EXC(HOTEL_NAME VARCHAR(50))
 RETURNS(ID_HOTEL INTEGER,
ID_ALLOTMENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_AGENT_PROFILE_DSCNT$EXC for: LOOKUP_HOTEL$EXC */
ALTER PROCEDURE IMPORT_AGENT_PROFILE_DSCNT$EXC(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
HOTEL_NAME VARCHAR(100),
SALE_DISCOUNT_NAME VARCHAR(50),
DISCOUNT_ORDER SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_CHANNEL_ALLOTMENT$EXC for: LOOKUP_HOTEL$EXC */
ALTER PROCEDURE IMPORT_CHANNEL_ALLOTMENT$EXC(IMPORT_ID VARCHAR(40),
CHANNEL_NAME VARCHAR(30),
HOTEL_NAME VARCHAR(50),
ROOM_TYPE VARCHAR(20),
FOR_DATE DATE,
FROM_DATE DATE,
TO_DATE DATE,
STATUS SMALLINT,
ROOM_COUNT INTEGER,
AUTO_FREE_ROOMS INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_EATING_OBJECT$EXC for: LOOKUP_HOTEL$EXC */
ALTER PROCEDURE IMPORT_EATING_OBJECT$EXC(NAME VARCHAR(30),
IS_ARCHIVE SMALLINT,
UUID VARCHAR(40),
HOTEL_NAME VARCHAR(50))
 RETURNS(ID_EATING_OBJECT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_GUARANTEE_POLICY$EXC for: LOOKUP_HOTEL$EXC */
ALTER PROCEDURE IMPORT_GUARANTEE_POLICY$EXC(UUID VARCHAR(40),
NAME VARCHAR(50),
DESCRIPTION VARCHAR(255),
WBE_DESCRIPTION VARCHAR(255),
WBE_DESCRIPTION_FULL BLOB,
CHECK_STATUS SMALLINT,
DEPOSIT_TOTALSUM_PART NUMERIC(15,4),
DEPOSIT_NIGHTS_COUNT INTEGER,
DUE_DAYS_BEFORE_ARRIVAL INTEGER,
DUE_DAYS_AFTER_CREATE INTEGER,
IS_ACTIVE SMALLINT,
WBE_PUBLIC SMALLINT,
HOTEL_NAME VARCHAR(50))
 RETURNS(ID_GUARANTEE_POLICY INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_HK_PLAN$EXC for: LOOKUP_HOTEL$EXC */
ALTER PROCEDURE IMPORT_HK_PLAN$EXC(PLAN_NAME VARCHAR(30),
IS_USE SMALLINT,
UUID VARCHAR(40),
HOTEL_NAME VARCHAR(50))
 RETURNS(ID_PLAN INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_HK_PLAN_ITEM$EXC for: LOOKUP_HOTEL$EXC */
ALTER PROCEDURE IMPORT_HK_PLAN_ITEM$EXC(ITEM_NAME VARCHAR(50),
ITEM_TYPE VARCHAR(20),
COST_VALUE NUMERIC(15,2),
EXT_CODE VARCHAR(20),
HOTEL_NAME VARCHAR(50),
UUID VARCHAR(40))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_PLAN_ITEM INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_LIST_ITEM$EXC for: LOOKUP_HOTEL$EXC */
ALTER PROCEDURE IMPORT_LIST_ITEM$EXC(LIST_GROUP VARCHAR(50),
HOTEL_NAME VARCHAR(50),
LIST_ITEM VARCHAR(50))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_PACKET_ITEM$EXC for: LOOKUP_HOTEL$EXC */
ALTER PROCEDURE IMPORT_PACKET_ITEM$EXC(PACKET_ITEM_TAG VARCHAR(30),
DESCRIPTION VARCHAR(50),
HOTEL_NAME VARCHAR(50),
UUID VARCHAR(40))
 RETURNS(ID_PACKET_ITEM INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_PAYMENT_TYPE$EXC for: LOOKUP_HOTEL$EXC */
ALTER PROCEDURE IMPORT_PAYMENT_TYPE$EXC(UUID VARCHAR(40),
NAME VARCHAR(50),
GROUP_TAG VARCHAR(20),
DESCRIPTION VARCHAR(100),
IS_AR_DEBT SMALLINT,
IS_CASH SMALLINT,
IS_CC SMALLINT,
IS_USE SMALLINT,
FISCAL_CODE VARCHAR(50),
HOTEL_NAME VARCHAR(50))
 RETURNS(PAYMENT_TYPE_ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_PROFILE_HOTEL_RATE$EXC for: LOOKUP_HOTEL$EXC */
ALTER PROCEDURE IMPORT_PROFILE_HOTEL_RATE$EXC(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PROFILE_TYPE VARCHAR(50),
HOTEL_NAME VARCHAR(100),
RATE_NAME VARCHAR(50))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_RATE_AVAILABILITY$EXC for: LOOKUP_HOTEL$EXC */
ALTER PROCEDURE IMPORT_RATE_AVAILABILITY$EXC(IMPORT_ID VARCHAR(40),
HOTEL_NAME VARCHAR(50),
RATE_NAME VARCHAR(50),
FOR_DATE DATE,
FROM_DATE DATE,
TO_DATE DATE,
STATUS INTEGER,
AUTO_PERCENT NUMERIC(15,4),
CONDITIONS VARCHAR(100))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_RATE_COMMON$EXC for: LOOKUP_HOTEL$EXC */
ALTER PROCEDURE IMPORT_RATE_COMMON$EXC(TARIFA_NAME VARCHAR(50),
TARIFA_GROUP VARCHAR(30),
HOTEL_NAME VARCHAR(50),
TARIFA_CURR VARCHAR(3),
IS_BASE SMALLINT,
IS_ACTIVE SMALLINT,
TARIFA_NOTE VARCHAR(500),
UUID VARCHAR(40),
RATE_TYPE VARCHAR(20),
IS_SIMPLE SMALLINT,
IS_PUBLIC /* TYPE OF TLOGICAL */ SMALLINT,
CHILD_AGE_INCL INTEGER)
 RETURNS(ID_TARIFA INTEGER,
ID_TARIFA_GROUP INTEGER,
ID_HOTEL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_RATE_EXTRA$EXC for: LOOKUP_HOTEL$EXC */
ALTER PROCEDURE IMPORT_RATE_EXTRA$EXC(TARIFA_NAME VARCHAR(50),
TARIFA_GROUP VARCHAR(30),
HOTEL_NAME VARCHAR(50),
TARIFA_CURR VARCHAR(3),
IS_ACTIVE SMALLINT,
TARIFA_NOTE VARCHAR(500),
UUID VARCHAR(40))
 RETURNS(ID_TARIFA INTEGER,
ID_TARIFA_GROUP INTEGER,
ID_HOTEL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_ROOM_TYPE$EXC for: LOOKUP_HOTEL$EXC */
ALTER PROCEDURE IMPORT_ROOM_TYPE$EXC(TYPE_ROOM VARCHAR(20),
BEDS INTEGER,
EXT_CODE VARCHAR(30),
UUID VARCHAR(40),
HOTEL_NAME VARCHAR(50))
 RETURNS(ID_ROOM_TYPE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_SALE_DISCOUNT$EXC for: LOOKUP_HOTEL$EXC */
ALTER PROCEDURE IMPORT_SALE_DISCOUNT$EXC(UUID VARCHAR(40),
DISCOUNT_NAME VARCHAR(50),
DISCOUNTED_VALUE_TYPE VARCHAR(50),
DISCOUNT_VALUE NUMERIC(15,4),
DISCOUNT_CALC_METHOD VARCHAR(50),
SERVICE_NAME VARCHAR(50),
SERVICE_DEPENDENCE_TYPE VARCHAR(50),
DEPENDENCE_SRV_GROUPS VARCHAR(1000),
IS_ARCHIVE SMALLINT,
FIXED_DISCOUNT_CURRENCY CHAR(3),
HOTEL_NAME VARCHAR(50))
 RETURNS(SALE_DISCOUNT_ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_SERVICE$EXC for: LOOKUP_HOTEL$EXC */
ALTER PROCEDURE IMPORT_SERVICE$EXC(SERVICE_NAME VARCHAR(30),
SERVICE_GROUP VARCHAR(30),
SERVICE_TYPE VARCHAR(50),
IS_DELETED SMALLINT,
IS_MANUAL_PRICE SMALLINT,
IS_DETAILS SMALLINT,
REVENUE_GROUP VARCHAR(50),
REVENUE_ACCOUNT VARCHAR(50),
ACCOUNT_NAME VARCHAR(30),
EXT_CODE VARCHAR(30),
VAUCHER_PACKET VARCHAR(20),
EXTRA_PACKET_NAME VARCHAR(10),
IS_RATE_PRICE SMALLINT,
IS_BREAKFAST SMALLINT,
IS_LUNCH SMALLINT,
IS_DINNER SMALLINT,
IS_EXTRAFOOD1 SMALLINT,
IS_EXTRAFOOD2 SMALLINT,
IS_BOARD SMALLINT,
PRICE NUMERIC(15,4),
PRICE_CURR VARCHAR(3),
HOTEL_NAME VARCHAR(50),
UUID VARCHAR(40))
 RETURNS(ID_SERVICE INTEGER,
ID_SERVICE_GROUP INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_SETTING_HOTEL_VALUE$EXC for: LOOKUP_HOTEL$EXC */
ALTER PROCEDURE IMPORT_SETTING_HOTEL_VALUE$EXC(SETTING_CODE VARCHAR(30),
SETTING_VALUE VARCHAR(50),
HOTEL_NAME VARCHAR(50))
 AS
 BEGIN EXIT; END
^

/* Alter (LOOKUP_HOTEL$EXC) */
ALTER PROCEDURE LOOKUP_HOTEL$EXC(NAME VARCHAR(50),
OBJECT_TYPE VARCHAR(100) = null,
OBJECT_ID VARCHAR(100) = null)
 RETURNS(ID INTEGER)
 AS
begin
  execute procedure sys_dbg(
    'exc LOOKUP_HOTEL$EXC(:NAME=>' || coalesce(:NAME, '<null>')
    || ', :subscriber_context=>' || coalesce(RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID'), '<null>')
   || ')');

  id = null;
  select first 1 h.id_hotel from HOTEL h
  where h.hotel_name=:name and h.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :id;

  if ((:object_id || :object_type) is not null) then begin
    execute procedure log_id_lookup_error$exc(:object_id, :object_type, :id, :name, 'hotel');
  end

  suspend;
end
^

/* Alter (LOOKUP_MARKET_SEGMENT$EXC) */
ALTER PROCEDURE LOOKUP_MARKET_SEGMENT$EXC(OBJECT_ID VARCHAR(100),
OBJECT_TYPE VARCHAR(100),
NAME VARCHAR(100))
 RETURNS(ID INTEGER)
 AS
begin
  id = null;
  select first 1 m1.id_nom_market_segment from nom_market_segments m1
  where m1.SEGMENT_NAME = :name and m1.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :id;

  execute procedure LOG_ID_LOOKUP_ERROR$EXC(:OBJECT_ID, :OBJECT_TYPE, :ID, :NAME, 'market_segment');
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_GUEST_PACK$EXC for: LOOKUP_PACKET_ITEM$EXC */
ALTER PROCEDURE IMPORT_GUEST_PACK$EXC(GUEST_ID INTEGER,
PACK_ITEMS VARCHAR(255))
 AS
 BEGIN EXIT; END
^

/* Alter (LOOKUP_PACKET_ITEM$EXC) */
ALTER PROCEDURE LOOKUP_PACKET_ITEM$EXC(ID_HOTEL INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(50))
 RETURNS(ID INTEGER)
 AS
begin

  ID = null;
  select first 1 pi.ID_PACKET_ITEM
  from   PACKET_ITEM pi
  where  pi.id_hotel=:id_hotel
         and pi.DESCRIPTION = :NAME
  into   :ID;

  execute procedure LOG_ID_LOOKUP_ERROR$EXC(:OBJECT_ID, :OBJECT_TYPE, :ID, :NAME, 'packet_item');
end
^

/* Alter (LOOKUP_PAYMENT_TYPE$EXC) */
ALTER PROCEDURE LOOKUP_PAYMENT_TYPE$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30))
 RETURNS(ID INTEGER)
 AS
begin
  ID = null;
  select first 1 pt.id_payment_type
    from PAYMENT_TYPE pt
    where pt.PAYMENT_TYPE = :NAME and pt.ID_HOTEL = :HOTEL_ID
    into :ID;

  execute procedure LOG_ID_LOOKUP_ERROR$EXC(:OBJECT_ID, :OBJECT_TYPE, :ID, :NAME, 'payment_type');
end
^

/* Alter (LOOKUP_RATE$EXC) */
ALTER PROCEDURE LOOKUP_RATE$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(50))
 RETURNS(ID INTEGER)
 AS
begin
  id = null;
  select first 1 t.ID_TARIFA
  from   TARIFA t
  where  (t.ID_HOTEL = :HOTEL_ID) and (t.TARIFA_NAME = :NAME)
  into   :ID;

  execute procedure log_id_lookup_error$exc(:OBJECT_ID, :OBJECT_TYPE, :ID, :NAME, 'rate');
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_ALLOTMENT_DETAIL$EXC for: LOOKUP_ROOM_TYPE$EXC */
ALTER PROCEDURE IMPORT_ALLOTMENT_DETAIL$EXC(ID_HOTEL INTEGER,
ID_ALLOTMENT INTEGER,
ROOM_TYPE VARCHAR(30),
FROM_DATE DATE,
TO_DATE DATE,
ROOM_COUNT INTEGER)
 RETURNS(ID_ALLOTMENT_DETAIL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (LOOKUP_ROOM_TYPE$EXC) */
ALTER PROCEDURE LOOKUP_ROOM_TYPE$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30))
 RETURNS(ID INTEGER)
 AS
begin
  ID = null;
  select first 1 rt.ID_ROOM_TYPE
    from ROOM_TYPES rt
    where (rt.ID_HOTEL = :HOTEL_ID) and (rt.TYPE_ROOM = :NAME)
    into :ID;

  execute procedure log_id_lookup_error$exc(:OBJECT_ID, :OBJECT_TYPE, :ID, :NAME, 'room_type');
end
^

/* Alter (LOOKUP_SALE_DISCOUNT$EXC) */
ALTER PROCEDURE LOOKUP_SALE_DISCOUNT$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30))
 RETURNS(ID INTEGER)
 AS
begin
  ID = null;
  select first 1 sd.ID_SALE_DISCOUNT
  from   SALE_DISCOUNT sd
  where  sd.DISCOUNT_NAME = :NAME
         and sd.ID_HOTEL = :HOTEL_ID
  into   :ID;

  execute procedure LOG_ID_LOOKUP_ERROR$EXC(:OBJECT_ID, :OBJECT_TYPE, :ID, :NAME, 'SALE_DISCOUNT');
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_RATE_PRICE$EXC for: LOOKUP_SERVICE$EXC */
ALTER PROCEDURE IMPORT_RATE_PRICE$EXC(ID_RATE_PERIOD INTEGER,
PRICE NUMERIC(15,2),
SERVICE VARCHAR(30))
 AS
 BEGIN EXIT; END
^

/* Alter (LOOKUP_SERVICE$EXC) */
ALTER PROCEDURE LOOKUP_SERVICE$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30))
 RETURNS(ID INTEGER)
 AS
begin
  ID = null;
  select first 1 s.ID_SERVICE
    from SERVICES s
    where s.SERVICE_NAME = :NAME and s.ID_HOTEL = :HOTEL_ID
    into :ID;

  execute procedure LOG_ID_LOOKUP_ERROR$EXC(:OBJECT_ID, :OBJECT_TYPE, :ID, :NAME, 'service');
end
^

/* Alter (LOOKUP_STAY_TYPE$EXC) */
ALTER PROCEDURE LOOKUP_STAY_TYPE$EXC(OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30))
 RETURNS(ID INTEGER)
 AS
begin
  ID = null;
  select first 1 ts.ID_TYPE_STAY
    from TYPE_STAY ts
    where ts.type_stay_code = :NAME
    into :ID;
  execute procedure LOG_ID_LOOKUP_ERROR$EXC(:OBJECT_ID, :OBJECT_TYPE, :id, :name, 'stay_type');
end
^

/* Alter (LOOKUP_TAX_POLICY$EXC) */
ALTER PROCEDURE LOOKUP_TAX_POLICY$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30))
 RETURNS(ID INTEGER)
 AS
begin
  ID = null;

  select tp.ID_TAX_POLICY
    from TAX_POLICY tp
    where tp.ID_HOTEL = :HOTEL_ID
      and tp.POLICY_NAME = :NAME
    into :ID;

  execute procedure LOG_ID_LOOKUP_ERROR$EXC(:OBJECT_ID, :OBJECT_TYPE, :ID, :NAME, 'tax_policy');
end
^

/* Alter (MAP_BOOKING_RELATIONS$EXC) */
ALTER PROCEDURE MAP_BOOKING_RELATIONS$EXC(BOOKING_ID INTEGER,
HOTEL VARCHAR(50),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
MARKETING1 VARCHAR(30),
MARKETING2 VARCHAR(30),
MARKETING3 VARCHAR(30),
MARKETING4 VARCHAR(30),
MARKETING5 VARCHAR(30),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
ARRIVAL_TYPE VARCHAR(20),
GUARANTEE_POLICY VARCHAR(50),
EATING_OBJECT VARCHAR(50))
 RETURNS(ARRANGER_PROFILE_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
RATE_ID INTEGER,
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
HOTEL_ID INTEGER,
MAINTANCE_SHEMA_ID INTEGER,
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
FIRST_FOOD_CODE TFOOD_CODE,
ARRIVAL_TYPE_CODE SMALLINT,
GUARANTEE_POLICY_ID INTEGER,
EATING_OBJECT_ID INTEGER)
 AS
declare variable dummy char(8);
BEGIN
  execute procedure lookup_hotel$exc(:hotel, 'BOOKING', :booking_id)
  returning_values :hotel_id;

  execute procedure lookup_rate$exc(:hotel_id, :booking_id, 'BOOKING', :rate)
  returning_values :rate_id;

  execute procedure lookup_room_type$exc(:hotel_id, :booking_id, 'BOOKING', :room_type)
  returning_values :room_type_id;

  execute procedure LOOKUP_BOARD$EXC(:hotel_id, :booking_id, 'BOOKING', :board, 0)
  returning_values :board_id;

  maintance_shema_id = null;
  select first 1 ms.id_plan
  from   hk_plan ms
  where  ms.id_hotel=:hotel_id
         and ms.is_use=1
         and ms.plan_name=:maintance_shema
  into   :maintance_shema_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :maintance_shema_id, :maintance_shema, 'maintance_shema');

  arranger_payment_type_id = null;
  select first 1 pt.id_payment_type
  from   payment_type pt
  where  pt.payment_type=:arranger_payment_type
         and pt.ID_HOTEL = :HOTEL_ID
         and pt.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :arranger_payment_type_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :arranger_payment_type_id, :arranger_payment_type, 'arranger_payment_type');

  guest_payment_type_id = null;
  select first 1 pt.id_payment_type
  from   payment_type pt
  where  pt.payment_type=:guest_payment_type
         and pt.ID_HOTEL = :HOTEL_ID
         and pt.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :guest_payment_type_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :guest_payment_type_id, :guest_payment_type, 'guest_payment_type');

  execute procedure LOOKUP_MARKET_SEGMENT$EXC(:booking_id, 'BOOKING', :marketing1)
  returning_values :marketing1_id;

  marketing2_id = null;
  select first 1 m2.id_nom_source_code from nom_source_codes m2
  where m2.description = :marketing2 and m2.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :marketing2_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :marketing2_id, :marketing2, 'marketing2');

  marketing3_id = null;
  select first 1 m3.id_nom_channel_code from nom_channel_codes m3
  where m3.description = :marketing3 and m3.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :marketing3_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :marketing3_id, :marketing3, 'marketing3');

  marketing4_id = null;
  select first 1 m4.id_nom_hear_reason from nom_hear_reasons m4
  where m4.description = :marketing4 and m4.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :marketing4_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :marketing4_id, :marketing4, 'marketing4');

  marketing5_id = null;
  select first 1 m5.id_nom_come_reason from nom_come_reasons m5
  where m5.description = :marketing5 and m5.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :marketing5_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :marketing5_id, :marketing5, 'marketing5');

  execute procedure lookup_profile$exc(:arranger_profile_uuid, :arranger_profile_name)
  returning_values :dummy, :arranger_profile_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :arranger_profile_id, :arranger_profile_uuid, 'arranger_profile');

  main_guest_profile_id = null;
  select first 1 p.id_profile from profile p where p.uuid=:main_guest_profile_uuid and p.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :main_guest_profile_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :main_guest_profile_id, :main_guest_profile_uuid, 'main_guest_profile');

  execute procedure LOOKUP_FIRST_FOOD$EXC(:first_food)
  returning_values :first_food_code;

  execute procedure LOOKUP_GUARANTEE_POLICY$EXC(:hotel_id, :booking_id, 'BOOKING', :guarantee_policy)
  returning_values :guarantee_policy_id;

  execute procedure LOOKUP_EATING_OBJECT$EXC(:hotel_id, :booking_id, 'BOOKING', :eating_object)
  returning_values :eating_object_id;

  arrival_type_code = 1; /*normal*/
  if ('early' = :arrival_type) then begin
    arrival_type_code = 0;
  end else if ('late' = :arrival_type) then begin
    arrival_type_code = 2;
  end
END
^

/* Alter (OCCUPANCY_RTI_BP$RPT) */
ALTER PROCEDURE OCCUPANCY_RTI_BP$RPT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ROOM_TYPES VARCHAR(255))
 RETURNS(OUT_DATE DATE,
CATEGORY VARCHAR(50),
AGENT_NAME VARCHAR(50),
ROOM_CNT INTEGER)
 AS
declare variable capacity integer;
declare variable ooi integer;
declare variable busy integer;
declare variable res_conf integer;
declare variable res_notconf integer;
declare variable bp_total integer;
declare variable sold_total integer;
declare variable total_bp_remains integer;
begin
  execute procedure AVAILABILITY_OCCUP_PREPARE$AVL (:FROM_DATE, :TO_DATE, 1, 1, 0, 1, 1, 0, 1, 0, :ID_HOTEL);

  for
    select t.FOR_DATE,
           sum(t.G_CAPACITY),
           sum(t.G_OOI),
           sum(t.SOLD),
           sum(t.RES_CONFIRMED),
           sum(t.RES_NOTCONFIRMED)
    from   SMART_OCCUP$TMP T
           join ROOM_TYPES rt on rt.ID_ROOM_TYPE = t.ID_ROOM_TYPE
    where  ','||:room_types||',' containing ','||rt.type_room||','
    group by 1
    into  :OUT_DATE, :capacity, :ooi, :busy, :res_conf, :res_notconf
  do begin
    CATEGORY = '1.Capacity';
    AGENT_NAME = '';
    ROOM_CNT = :capacity;
    suspend;
    CATEGORY = '2.OOI';
    AGENT_NAME = '';
    ROOM_CNT = :ooi;
    suspend;
    CATEGORY = '3.Available';
    AGENT_NAME = '';
    ROOM_CNT = :capacity - :ooi;
    suspend;
    CATEGORY = '4.Check in';
    AGENT_NAME = '';
    ROOM_CNT = :busy;
    suspend;
    CATEGORY = '5.Confirmed';
    AGENT_NAME = '';
    ROOM_CNT = :res_conf;
    suspend;
    CATEGORY = '6.Tentative';
    AGENT_NAME = '';
    ROOM_CNT = :res_notconf;
    suspend;
    CATEGORY = '7.Total sold';
    AGENT_NAME = '';
    ROOM_CNT = :busy + :res_conf + :res_notconf;
    suspend;
    CATEGORY = '8.Free';
    AGENT_NAME = '';
    ROOM_CNT = :capacity - :ooi - :busy - :res_conf - :res_notconf;
    suspend;

    CATEGORY = '9.RTI-BP';
    total_bp_remains = 0;
    for
      select '9.'||P.PROFILE_NAME as agent_name, sum(AO.CONT_BP), sum(ao.SOLD + ao.RES_CONFIRMED + ao.RES_NOTCONFIRMED)
      from   SMART_OCCUP$TMP AO
             join ROOM_TYPES rt on rt.id_room_type = ao.id_room_type
             left outer join PROFILE_AGENT PA on PA.ID_AGENT = AO.ID_AGENT
             left outer join PROFILE P on P.ID_PROFILE = pa.ID_PROFILE
      where  AO.FOR_DATE = :OUT_DATE
             and ','||:room_types||',' containing ','||rt.type_room||','
      group by 1
      having (sum(AO.CONT_BP) > 0) or (sum(ao.SOLD + ao.RES_CONFIRMED + ao.RES_NOTCONFIRMED) > 0)
      into   :CATEGORY/*:AGENT_NAME*/, :bp_total, :sold_total
    do begin
      AGENT_NAME = 'Total BP';
      ROOM_CNT = :bp_total;
      suspend;

      AGENT_NAME = 'Sold rooms';
      ROOM_CNT = :sold_total;
      suspend;

      AGENT_NAME = 'BP-remain';
      if (:bp_total < :sold_total) then ROOM_CNT = 0;
      else ROOM_CNT = :bp_total - :sold_total;
      suspend;

      total_bp_remains = :total_bp_remains + :ROOM_CNT;
    end 

    CATEGORY = 'Occupancy %';
    AGENT_NAME = '';
    ROOM_CNT =  iif((:capacity - :ooi) = 0, 0, cast(:busy + :res_conf + :res_notconf + :total_bp_remains as double precision) / (:capacity - :ooi)) * 100;
    suspend;

    CATEGORY = 'Remain';
    AGENT_NAME = '';
    ROOM_CNT = :capacity - :ooi - :busy - :res_conf - :res_notconf - :total_bp_remains;
    suspend;
  end
end
^

/* Alter (OCCUPANCY_SHARES_COMPLETE$INT) */
ALTER PROCEDURE OCCUPANCY_SHARES_COMPLETE$INT(ID_OCCUPANT INTEGER)
 RETURNS(NEW_SHARES_ARISE INTEGER,
SHARE_MARK_TRANSACTION INTEGER)
 AS
declare variable id_room integer;
declare variable rm_dbkey char(8);
declare variable share_date date;
declare variable found_reservaions integer;
declare variable existent_share integer;
declare variable tmp_res_detail integer;
declare variable has_share integer;
begin
  /* -- SHARES detection and clean section --*/
  has_share = 0;
  new_shares_arise = 0;
  execute procedure OCCUPANCY_GET_TRANSACTION$INT
  returning_values (:share_mark_transaction);

  /* -- we check old stay and rooms + new stay and rooms and will regenerate shares --*/
  for
    select distinct trs.for_date, trs.id_room
    from   RESERV_STAY$TMP trs
    where  trs.id_session = :share_mark_transaction
    union
    select rm.busy_date, rm.id_room
    from   ROOM_MAGIC rm
    where  rm.id_reserv_detail = :id_occupant
           and RM.DAY_ACTION not containing 'CHECK_OUT'
    into   :share_date, :id_room
  do begin
    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT Now will check share status.......... :'|| :share_date || ' ID_ROOM =' || :id_room);
    /* Count reservations for this date and room*/
    for
      select RM.BUSY_DATE, count(distinct RM.ID_RESERV_DETAIL)
      from   ROOM_MAGIC RM
      where  RM.BUSY_DATE = :share_date
             and RM.ID_ROOM = :id_room
             and RM.DAY_ACTION not containing 'CHECK_OUT' -- exclude 'CHECK_OUT' and 'CHEKC_IN,CHECK_OUT' day actions
      group by 1
      into   :share_date, :found_reservaions
    do begin
      if (:found_reservaions > 1) then begin
        has_share = 1;
        /* CREATE/UPDATE SHARES */
        for
          select RM.RDB$DB_KEY, RM.ID_RESERV_DETAIL
          from   ROOM_MAGIC RM
          where  RM.BUSY_DATE = :share_date
                 and RM.ID_ROOM = :id_room
                 and RM.DAY_ACTION not containing 'CHECK_OUT' -- exclude 'CHECK_OUT' and 'CHEKC_IN,CHECK_OUT' day actions
          into   :rm_dbkey, :tmp_res_detail
        do begin
          execute procedure ROOM_SHARE$INT(:rm_dbkey, :share_mark_transaction)
          returning_values  :existent_share;

          if (:existent_share = 0 and :tmp_res_detail <> :id_occupant) then new_shares_arise = 1;
        end
      end else begin
        /* CLEAN SHARES IF ANY */
        update ROOMS_SHARE RS
        set    RS.IS_EX_SHARE = 1,
               RS.MARK_TRANSACTION = :share_mark_transaction
        where  RS.BUSY_DATE = :share_date
               and RS.ID_ROOM = :id_room;
      end
    end
  end

  if (:has_share = 0) then SHARE_MARK_TRANSACTION = null;
end
^

/* Alter (OWNER_BILL_MODIFY$PMS) */
ALTER PROCEDURE OWNER_BILL_MODIFY$PMS(ID_OWNER_BILL INTEGER,
ID_OWNER INTEGER,
BILLING_DATE DATE,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_OWNER_BILL INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_anul smallint;
  declare variable bill_num integer;
  declare variable id_account_post_pms integer;
  declare variable id_account_post integer;
  declare variable prev_id_owner_bill integer;
  declare variable prev_billing_date date;

  declare variable id_account integer;
  declare variable id_account_pms integer;
  declare variable value_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable value_post numeric(15,4);
  declare variable curr_post varchar(3);
  declare variable is_owner_income smallint;
  declare variable id_service integer;
  declare variable id_room integer;
  declare variable date_post date;
  declare variable id_reserv_detail integer;
  declare variable doc_description varchar(255);
  declare variable id_doc_head integer;
  declare variable description varchar(255);
  declare variable id_pms_event integer;
  declare variable is_client_account_post smallint;
begin
  err_code = 0;
  err_text = '';
  is_client_account_post = null;
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'create, anul');

  if ( exists ( select *
                from   OWNER$PMS O
                where  O.ID_OWNER = :ID_OWNER
                       and O.ID_RENTAL_POOL_UNIT is not null ) ) then
  begin
    exception PMS_EXCEPTION 'selected owner is pool!';
  end

  if (:operation = 'create') then begin
    is_anul = 0;

    if ( (:ID_OWNER_BILL is null) or (:ID_OWNER_BILL <= 0) )  then
      NEW_ID_OWNER_BILL = gen_id(GEN_OWNER_BILL$PMS_ID, 1);
    else
      NEW_ID_OWNER_BILL = :ID_OWNER_BILL;

    BILL_NUM = :NEW_ID_OWNER_BILL;
    insert into OWNER_BILL$PMS (ID_OWNER_BILL, ID_OWNER, BILL_DATE, IS_ANUL, BILL_NUM,
           IS_EXPORTED_TO_INTRANET, IS_POOL_DISTRIBUTION_STATEMENT)
    values (:NEW_ID_OWNER_BILL, :ID_OWNER, :BILLING_DATE, :IS_ANUL, :BILL_NUM, 0, 0);

    update OWNER$PMS O
    set    O.LAST_BILLING_DATE = :billing_date,
           O.ID_OWNER_BILL = :NEW_ID_OWNER_BILL
    where  O.ID_OWNER = :ID_OWNER;

    for
    /*  select ID_ACCOUNT_POST, ID_ACCOUNT_POST_PMS
      from   PMS_ACC_POST_TO_BILL_GET$INT(:ID_OWNER, null, '01.01.1500', :BILLING_DATE, 1)
      into   :ID_ACCOUNT_POST, :ID_ACCOUNT_POST_PMS */
      select   OP.ID_ACCOUNT_POST, OP.ID_ACCOUNT_POST$PMS
      from     OWNER_POST OP
      where    OP.ID_OWNER = :id_owner
               and OP.POST_DATE between cast('01.01.1500' as date) and :billing_date
               and OP.IS_ANUL = 0
      order by OP.ID_ACCOUNT_POST$PMS nulls last
      into     :ID_ACCOUNT_POST, :ID_ACCOUNT_POST_PMS
    do begin
      if (:id_account_post_pms is not null) then begin

        update ACCOUNT_POST$PMS A
        set    A.LINE_STATUS = 21
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS;

        id_account = null;
        select ACC.ID_SERVICE, ACC.VALUE_ORIG, ACC.CURR_ORIG, ACC.VALUE_POST, ACC.CURR_POST,
               ACC.IS_OWNER_INCOME, ACC.DATE_POST, ACC.ID_ACCOUNT_PMS, E.ID_ROOM,
               E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION, A.IS_CLIENT_POOL_ACCOUNT
        from   ACCOUNT_POST$PMS ACC
               join ACCOUNT$PMS A on A.ID_ACCOUNT = ACC.ID_ACCOUNT_PMS
               join PMS_EVENT$PMS E on E.ID_PMS_EVENT = ACC.ID_PMS_EVENT
        where  ACC.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
        into   :ID_SERVICE, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
               :IS_OWNER_INCOME, :DATE_POST, :ID_ACCOUNT_PMS, :ID_ROOM,
               :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION, :is_client_account_post;
      end

      if (:id_account_post is not null) then begin
        exception PMS_EXCEPTION '-613';
          
        is_client_account_post = 1;
        update PMS_EVENT_POST A
        set    A.LINE_STATUS = 21
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST;

        id_account_pms = null;
        select ACC.ID_SERVICE, ACC.PRICE_ORIG, ACC.CURR_ORIG, ACC.PRICE_POST, ACC.CURR_POST,
               0, ACC.DATE_POST, ACC.ID_ACCOUNT, E.ID_ROOM,
               E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION
        from   ACCOUNT_POST ACC
               join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = ACC.ID_ACCOUNT_POST
               join PMS_EVENT$PMS E on E.ID_PMS_EVENT = PP.ID_PMS_EVENT
        where  ACC.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
        into   :ID_SERVICE, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
               :IS_OWNER_INCOME, :DATE_POST, :ID_ACCOUNT, :ID_ROOM,
               :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION;
      end

      insert into OWNER_BILL_ROW$PMS (ID_OWNER_BILL, ID_ACCOUNT_POST,
             ID_ACCOUNT, ID_ACCOUNT_POST_PMS, ID_ACCOUNT_PMS, ID_SERVICE, VALUE_ORIG,
             CURR_ORIG, VALUE_POST, CURR_POST, IS_OWNER_INCOME, ID_ROOM, DATE_POST,
             ID_RESERV_DETAIL, DOC_DESCRIPTION, ID_DOC_HEAD, DESCRIPTION, IS_CLIENT_ACCOUNT_POST)
      values (:new_id_owner_bill, :ID_ACCOUNT_POST, :ID_ACCOUNT,
             :ID_ACCOUNT_POST_PMS, :ID_ACCOUNT_PMS, :ID_SERVICE, :VALUE_ORIG,
             :CURR_ORIG, :VALUE_POST, :CURR_POST, :IS_OWNER_INCOME, :ID_ROOM, :DATE_POST,
             :ID_RESERV_DETAIL, :DOC_DESCRIPTION, :ID_DOC_HEAD, :DESCRIPTION, :is_client_account_post);
    end
  end
  if (:operation = 'anul') then begin
    select O.ID_OWNER, O.IS_ANUL
    from   OWNER_BILL$PMS O
    where  O.ID_OWNER_BILL = :ID_OWNER_BILL
    into   :id_owner, :is_anul;
    if (:is_anul = 1) then exit;

    select first 1 B.ID_OWNER_BILL
    from   OWNER_BILL$PMS B
    where  B.ID_OWNER = :id_owner
           and B.IS_ANUL = 0
    order by B.BILL_DATE desc
    into   :prev_id_owner_bill;
    if (:prev_id_owner_bill <> :id_owner_bill) then exception PMS_EXCEPTION '-619';

    select first 1 O.ID_OWNER_BILL, O.BILL_DATE
    from   OWNER_BILL$PMS O
    where  O.ID_OWNER = :ID_OWNER
           and o.IS_ANUL = 0
           and O.ID_OWNER_BILL <> :ID_OWNER_BILL
    order by O.BILL_DATE desc
    into   :prev_id_owner_bill, :prev_billing_date;

    update OWNER$PMS O
    set    O.LAST_BILLING_DATE = :prev_billing_date,
           O.ID_OWNER_BILL = :prev_id_owner_bill
    where  O.ID_OWNER = :ID_OWNER;

    update OWNER_BILL$PMS B
    set    B.IS_EXPORTED_TO_INTRANET = 0,
           B.IS_ANUL = 1
    where  B.ID_OWNER_BILL = :ID_OWNER_BILL;

    for
      select O.ID_ACCOUNT_POST, O.ID_ACCOUNT_POST_PMS
      from   OWNER_BILL_ROW$PMS O
      where  O.ID_OWNER_BILL = :ID_OWNER_BILL
      into   :id_account_post, :id_account_post_pms
    do begin
      if (:id_account_post_pms is not null) then begin
        update ACCOUNT_POST$PMS A
        set    A.LINE_STATUS = 11
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
               and A.LINE_STATUS = 21;
      end

      if (:id_account_post is not null) then begin
        update PMS_EVENT_POST A
        set    A.LINE_STATUS = 11
        where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and A.LINE_STATUS = 21;
      end
    end

    for
      select distinct AP.ID_PMS_EVENT
      from   OWNER_BILL_ROW$PMS R
             join OWNER_BILL$PMS B on B.ID_OWNER_BILL = R.ID_OWNER_BILL
             join ACCOUNT_POST$PMS AP on AP.ID_ACCOUNT_POST = R.ID_ACCOUNT_POST_PMS
             join PMS_EVENT$PMS E on E.ID_PMS_EVENT = AP.ID_PMS_EVENT
      where  R.ID_OWNER_BILL = :ID_OWNER_BILL
             and E.EVENT_TYPE = 'POOL_DISTRIBUTION'
             and B.IS_POOL_DISTRIBUTION_STATEMENT = 1
      into   :id_pms_event
    do begin
      execute procedure PMS_EVENT_VOID$INT(:id_pms_event);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ADD_DEF_PAYMENT$DOC for: PAYMENT_STORNO$INT */
ALTER PROCEDURE DOCUMENT_ADD_DEF_PAYMENT$DOC(ID_DOC_HEAD INTEGER,
ID_PAY_DOC_TYPE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_STORNO_PAYS_SET$DOC for: PAYMENT_STORNO$INT */
ALTER PROCEDURE DOCUMENT_STORNO_PAYS_SET$DOC(ID_STORNO_DOC INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (PAYMENT_STORNO$INT) */
ALTER PROCEDURE PAYMENT_STORNO$INT(ID_PAYMENT_HEAD INTEGER,
ID_ACCOUNT INTEGER,
NEW_ID_DOC_HEAD INTEGER,
STORNO_AMOUNT NUMERIC(15,4),
DESCRIPTION VARCHAR(100),
TARGET_DOC_AMOUNT NUMERIC(15,4))
 RETURNS(ID_STORNO_PAYMENT INTEGER)
 AS
declare variable payment_date date;
  declare variable acc_currency varchar(3);
  declare variable id_doc_type integer;
  declare variable doc_type_name varchar(50);
  declare variable id_doc_num integer;
  declare variable is_storno integer;
  declare variable round_to numeric(15,4);
  declare variable pay_rate numeric(15,6);
  declare variable pay_curr varchar(3);
  declare variable doc_value numeric(15,4);
  declare variable acc_value numeric(15,4);
  declare variable acc_rate numeric(15,6);
  declare variable doc_rate numeric(15,6);
  declare variable doc_curr varchar(3);
  declare variable id_doc_contragent integer;
  declare variable id_storned_doc_head integer;
  declare variable id_payment_type integer;
  declare variable id_hotel integer;
  declare variable due_date date;
  declare variable equal_pay_doc_rate double precision;
  declare variable is_partial_storno numeric(15,4);
  declare variable id_account_payment integer;
  declare variable id_deposit integer;
  declare variable avail_pay_amount numeric(15,4);
begin
  execute procedure PAYMENT_VOID_CHECK$INT (:ID_PAYMENT_HEAD, substring(:DESCRIPTION from 1 for 50));

  select PH.ID_DOC_TYPE, DTP.STORNO_DOC_NAME, PH.ID_DOC_NUM, PH.ID_PAYMENT_TYPE, PH.DUE_DATE,
         ph.IS_STORNO, PH.PAY_CURRENCY, PH.PAY_RATE, PH.ID_DOC_HEAD,
         A.ID_HOTEL, c.ROUND_TO
  from   PAYMENT_HEAD PH
         join DOC_TYPE DP on DP.ID_DOC_TYPE = PH.ID_DOC_TYPE
         join DOC_TYPE_PAY dtp on dtp.ID_DOC_TYPE = dp.ID_DOC_TYPE
         join ACCOUNT A on A.ID_ACCOUNT = PH.ID_ACCOUNT
         join CURRS c on c.CURR = ph.PAY_CURRENCY
  where  PH.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  into   :id_doc_type, :doc_type_name, :id_doc_num, :id_payment_type, :due_date,
         :is_storno, :pay_curr, :pay_rate, :id_storned_doc_head,
         :id_hotel, :round_to;

  if (:is_storno = 1) then
    exception PAYMENT_EXCEPTION 'Storno payment cannot be voided !';

  select sum(AP.PAY_AMOUNT)
  from   ACCOUNT_PAYMENTS AP
  where  AP.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  into   :avail_pay_amount;

  if ((:STORNO_AMOUNT is null) or (round_f(:STORNO_AMOUNT - :avail_pay_amount, :round_to) = 0) ) then begin
    /* storn whole available payment */
    is_partial_storno = 0;
    STORNO_AMOUNT = :avail_pay_amount;
  end else begin
    is_partial_storno =1;
  end

  if (:STORNO_AMOUNT = 0 ) then
    exception PAYMENT_EXCEPTION '-340' || f_character(31) || '' || f_character(29) || :storno_amount;
    --'Payment value iz zero.' ;

  execute procedure SYSTEM_DATE_GET (:ID_HOTEL)
  returning_values  (:payment_date);
   
  /* CHECK FOR VALID ACCOUNT */
  select A.ACCOUNT_CURR
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :acc_currency;

  execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:ID_ACCOUNT, 0);
  /*-------------------- PAYMENT HEADER ---------------------*/
  select D.DOC_CURRENCY, D.ID_DOC_CONTRAGENT, D.DOC_RATE
  from   DOC_HEAD D
  where  D.ID_DOC = :NEW_ID_DOC_HEAD
  into   :doc_curr, :id_doc_contragent, :doc_rate;

  ID_STORNO_PAYMENT = gen_id(G_ID_PAYMENT_HEAD, 1);
  insert into PAYMENT_HEAD
         (ID_PAYMENT_HEAD, ID_ACCOUNT, ID_DOC_TYPE, ID_DOC_NUM,
         ID_PAYMENT_TYPE, DOC_TYPE_NAME, PAYMENT_DATE, DUE_DATE,
         PAY_VALUE, PAY_VALUE_A, PAY_CURRENCY, PAY_RATE, IS_STORNO, ID_DOC_HEAD,
         DESCRIPTION, ID_DOC_CONTRAGENT, ID_PAYMENT_STORNED)
  values (:ID_STORNO_PAYMENT, :ID_ACCOUNT, :id_doc_type, :id_doc_num,
         :id_payment_type, :doc_type_name, :payment_date, :due_date,
         -:STORNO_AMOUNT, -:STORNO_AMOUNT, :pay_curr, :pay_rate, 1, :NEW_ID_DOC_HEAD,
         :DESCRIPTION, :id_doc_contragent, :ID_PAYMENT_HEAD);
  /*-------------------- ACCOUNT_PAYMENT ---------------------*/
  execute procedure CURR_RATE_GET (:acc_currency, :payment_date, :id_hotel)
  returning_values  (:acc_rate);

  if (:is_partial_storno = 1 /*and :TARGET_DOC_AMOUNT is not null */) then begin
    if (:pay_curr = :doc_curr) then pay_rate = :doc_rate;
    execute procedure PAYMENT_EQUIVALENCE_CALC$INT (:pay_rate, -:STORNO_AMOUNT, :round_to, :doc_rate, :round_to, :TARGET_DOC_AMOUNT)
    returning_values  (:doc_value, :equal_pay_doc_rate);
    --doc_rate = :pay_rate / :equal_pay_doc_rate;
     
    if (:acc_currency = :doc_curr) then begin
      acc_value = :doc_value;
      acc_rate = :pay_rate / :equal_pay_doc_rate; --:doc_rate;
    end else begin
      acc_value = (-:storno_amount) * cast(:pay_rate/:acc_rate as double precision);
    end

    insert into ACCOUNT_PAYMENTS (ID_ACCOUNT, ID_PAYMENT_HEAD, PAY_AMOUNT, PAY_RATE,
           ACC_AMOUNT, ACC_RATE, TRANSACTION_DATE, ID_DEPOSIT, IS_INITIAL_PAYMENT)
    values (:ID_ACCOUNT, :ID_STORNO_PAYMENT, -:STORNO_AMOUNT , :pay_rate,
           :acc_value, :acc_rate, :payment_date, null, 1)
    returning id_account_payment into :id_account_payment;
  
    if (:NEW_ID_DOC_HEAD is not null) then begin
      insert into DOC_PAY_USAGE (ID_DOC_HEAD, ID_ACCOUNT_PAYMENT, PAY_AMOUNT, PAY_RATE,
             DOC_AMOUNT, /*DOC_RATE,*/ EQUAL_PAY_DOC_RATE)
      values (:NEW_ID_DOC_HEAD, :id_account_payment, -:storno_amount, :pay_rate,
             :doc_value, /*:doc_rate,*/ :equal_pay_doc_rate);
    end
  end else begin
    /* whole paymnent is storned */
    select dp.EQUAL_PAY_DOC_RATE
    from   DOC_PAY_USAGE DP
           join ACCOUNT_PAYMENTS AP on AP.ID_ACCOUNT_PAYMENT = dp.ID_ACCOUNT_PAYMENT
    where  DP.ID_DOC_HEAD = :id_storned_doc_head
           and AP.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
    into   :equal_pay_doc_rate;

    for
      select ap.ID_DEPOSIT, ap.id_account, ap.PAY_RATE, ap.ACC_RATE,
             sum(ap.PAY_AMOUNT), sum(ap.ACC_AMOUNT)
      from   ACCOUNT_PAYMENTS AP
      where  AP.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
      group by 1, 2, 3, 4
      having round_f(sum(AP.PAY_AMOUNT), :round_to) <> 0
      into   :id_deposit, :ID_ACCOUNT, :pay_rate, :acc_rate,
             :STORNO_AMOUNT, :acc_value
    do begin
      insert into ACCOUNT_PAYMENTS (ID_ACCOUNT, ID_PAYMENT_HEAD, PAY_AMOUNT, PAY_RATE,
             ACC_AMOUNT, ACC_RATE, TRANSACTION_DATE, ID_DEPOSIT, IS_INITIAL_PAYMENT)
      values (:ID_ACCOUNT, :ID_STORNO_PAYMENT, -:STORNO_AMOUNT, :pay_rate,
             -:acc_value, :acc_rate, :payment_date, :id_deposit, 1)
      returning id_account_payment into :id_account_payment;

      if (:NEW_ID_DOC_HEAD is not null) then begin
        doc_value = :storno_amount * :equal_pay_doc_rate;
        --doc_rate = :pay_rate / :equal_pay_doc_rate;
        insert into DOC_PAY_USAGE (ID_DOC_HEAD, ID_ACCOUNT_PAYMENT, PAY_AMOUNT, PAY_RATE,
               DOC_AMOUNT, /*DOC_RATE, */EQUAL_PAY_DOC_RATE)
        values (:NEW_ID_DOC_HEAD, :id_account_payment, -:storno_amount, :pay_rate,
               -:doc_value, /*:doc_rate, */:equal_pay_doc_rate);
      end
    end

  end

  insert into PAYMENT_CREDIT_CARD (ID_PAYMENT_HEAD, CARD_CODE, ID_CC_TYPE,
         HOLDER_NAME, HOLDER_ADDRESS, VALIDITY_YEAR, VALIDITY_MONTH, VERIFICTION_CODE, CARD_CODE_PREVIEW)
  select :ID_STORNO_PAYMENT, CARD_CODE, ID_CC_TYPE,
         HOLDER_NAME, HOLDER_ADDRESS, VALIDITY_YEAR, VALIDITY_MONTH, VERIFICTION_CODE, CARD_CODE_PREVIEW
  from   PAYMENT_CREDIT_CARD pcc
  where  pcc.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;

  /* Mark storned pay doc and account payments for it as storned */
  if (:is_partial_storno = 0) then begin
    update PAYMENT_HEAD P
    set    P.IS_STORNED = 1
    where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;
  end
end
^

/* Alter (PHONECALL_POST$TC) */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Alter (PHONECALLS_POST_TO_ACCOUNT$TC) */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* Alter (PMS_EVENT_ANUL$PMS) */
ALTER PROCEDURE PMS_EVENT_ANUL$PMS(ID_PMS_EVENT INTEGER)
 AS
begin
  execute procedure PMS_EVENT_VOID$INT(:id_pms_event);
end
^

/* empty dependent procedure body */
/* Clear: PMS_IMPORT$INT for: PMS_EVENT_POST$INT */
ALTER PROCEDURE PMS_IMPORT$INT(ID_EXPORT_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_EVENT_POST$INT) */
ALTER PROCEDURE PMS_EVENT_POST$INT(ID_PMS_EVENT INTEGER,
ID_ROOM_CONTRACT INTEGER,
ID_RENTAL_POOL INTEGER,
POST_DATE DATE,
PRICE_WITH_VAT NUMERIC(15,4),
PRICE_WO_VAT NUMERIC(15,4),
CURR VARCHAR(3),
MAX_ADULT_CNT INTEGER,
STAY INTEGER,
BED_NIGHT_CNT INTEGER,
BOOKING_CNT INTEGER,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL INTEGER)
 AS
declare variable ownership_percent numeric(15,4);
  declare variable id_owner integer;
  declare variable contract_type varchar(50);
  declare variable posted_orig_value numeric(15,4);
  declare variable posted_orig_curr varchar(3);
  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable owner_use smallint;
  declare variable price_to_post numeric(15,4);
  declare variable id_owner_post_to integer;
  declare variable reserv_no varchar(62);
  declare variable sub_contract varchar(10);
begin
  id_owner_post_to = null;
  owner_use = 0;

  select RD.ID_AGENT_PROFILE, RD.ID_PERSON_PROFILE, iif(RD.ACC_ROUTING = 'OWNER', 1, 0), rd.NUMBER
  from   RESERV_DETAIL RD                      
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :id_agent_profile, :id_person_profile, :owner_use, :reserv_no;

  /* if RESERV_DETAIL.ACC_ROUTING = 'OWNER', ediniqt profil w reserv. e garantirano owner
     pyrwo se prowerqwa dali id_agent_profile e owner, ako ne e se wzema person_profile */

  if (:owner_use = 1) then begin
    /* ako reserv. e owner-ska, ne se generirat prihodi, a razhodite otiwat po smetkata na gosta, a ne na sobstwenicite
     gosta se tyrsi w posledowatelnost ID_AGENT_PROFILE, ID_PERSON_PROFILE*/
    if ( exists ( select p.ID_ROOM
                  from   ROOM_PERIOD$PMS P
                         join ROOM_CONTRACT$PMS C on C.ID_ROOM_PERIOD = P.ID_ROOM_PERIOD
                         join ROOM_OWNER$PMS O on O.ID_ROOM_CONTRACT = C.ID_ROOM_CONTRACT
                  where  O.ID_OWNER = :id_agent_profile
                         and :POST_DATE between P.FROM_DATE and P.TO_DATE  ) ) then
    begin
      --prowerka dali kym momenta(post_date) ima aktiwen dogowor
      id_owner_post_to = :id_agent_profile;
    end else if ( exists ( select p.ID_ROOM
                      from   ROOM_PERIOD$PMS P
                             join ROOM_CONTRACT$PMS C on C.ID_ROOM_PERIOD = P.ID_ROOM_PERIOD
                             join ROOM_OWNER$PMS O on O.ID_ROOM_CONTRACT = C.ID_ROOM_CONTRACT
                      where  O.ID_OWNER = :id_person_profile
                             and :POST_DATE between P.FROM_DATE and P.TO_DATE  ) ) then
    begin
      id_owner_post_to = :id_person_profile;
    end

    if (:id_owner_post_to is null) then begin
      exception PMS_EXCEPTION '-616' || f_character(31) || f_character(29) ||:POST_DATE|| f_character(28) ||:reserv_no;
    end
  end

  for
    select RO.OWNERSHIP_PERCENT,
           RO.ID_OWNER,
           iif(RC.IMPORT_INCOME_WITH_VAT = 1, :price_with_vat, :price_wo_vat),
           RC.CONTRACT_TYPE
    from   ROOM_CONTRACT$PMS RC
           join ROOM_OWNER$PMS RO on RO.ID_ROOM_CONTRACT = RC.ID_ROOM_CONTRACT
    where  RC.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
    into   :ownership_percent,
           :id_owner,
           :price_to_post,
           :contract_type
  do begin
    if (:owner_use = 1) then begin
      /*    za sobstwenik ne se poddyrjat prihodi!    */
      sub_contract = 'OWNER_USE';
      posted_orig_value = :price_to_post;
      posted_orig_curr = :curr;
      execute procedure CONTRACT_EXPENSE_POST$INT(:ID_PMS_EVENT, :ID_HOTEL, :ID_ROOM_CONTRACT, :sub_contract,
              :id_owner_post_to, :ownership_percent, null, :posted_orig_value, :posted_orig_curr, :POST_DATE,
              :stay, :max_adult_cnt, :BED_NIGHT_CNT, :BOOKING_CNT);
    end else begin
      sub_contract = 'GUEST_USE';
      execute procedure CONTRACT_MANAGEMENT_POST$INT(:ID_PMS_EVENT, :ID_ROOM_CONTRACT, :sub_contract,
              :contract_type, :ID_OWNER, :ID_RENTAL_POOL, :price_to_post, :curr, :POST_DATE, :stay, :ownership_percent)
      returning_values  (:posted_orig_value, :posted_orig_curr);
      if (:posted_orig_curr is null) then begin
        posted_orig_value = :price_to_post;
        posted_orig_curr = :curr;
      end
      execute procedure CONTRACT_EXPENSE_POST$INT(:ID_PMS_EVENT, :ID_HOTEL, :ID_ROOM_CONTRACT, :sub_contract,
              :ID_OWNER, :ownership_percent, :ID_RENTAL_POOL, :posted_orig_value, :posted_orig_curr, :POST_DATE,
              :stay, :max_adult_cnt, :BED_NIGHT_CNT, :BOOKING_CNT);
    end


    begin -- SHADOW ACCOUNT POSTING
      sub_contract = 'SHADOW_ACC';
      /* da ne se nachislqwa, ako e USE_OWNER_CONTRACT = 1 */
      if (:owner_use = 0) then begin
        execute procedure CONTRACT_MANAGEMENT_POST$INT(:ID_PMS_EVENT, :ID_ROOM_CONTRACT, :sub_contract,
                :contract_type, :ID_OWNER, :ID_RENTAL_POOL, :price_to_post, :curr, :POST_DATE, :stay, :ownership_percent)
        returning_values  (:posted_orig_value, :posted_orig_curr);
        if (:posted_orig_curr is null) then begin
          posted_orig_value = :price_to_post;
          posted_orig_curr = :curr;
        end
      end else begin
        posted_orig_value = :price_to_post;
        posted_orig_curr = :curr;
      end
  
      execute procedure CONTRACT_EXPENSE_POST$INT(:ID_PMS_EVENT, :ID_HOTEL, :ID_ROOM_CONTRACT, :sub_contract,
              iif(:owner_use = 0, :ID_OWNER, :ID_OWNER_POST_TO), :ownership_percent,
              iif(:owner_use = 0, :ID_RENTAL_POOL, null), :posted_orig_value, :posted_orig_curr, :POST_DATE,
              :stay, :max_adult_cnt, :BED_NIGHT_CNT, :BOOKING_CNT);
    end
  end
end
^

/* Alter (PMS_EXPENSE_POSTING_CREATE$PMS) */
ALTER PROCEDURE PMS_EXPENSE_POSTING_CREATE$PMS(ID_ROOM TYPE OF ID,
ID_OWNER TYPE OF ID,
ID_RENTAL_POOL TYPE OF ID_REF,
ID_SERVICE TYPE OF ID,
ID_CURRENCY TYPE OF TCURRENCY,
POST_VALUE TYPE OF TPRICE,
IS_ACC_POST_ITEM TYPE OF TLOGICAL,
MANUAL_POST_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
IS_POST_PER_POOL TYPE OF TLOGICAL)
 AS
declare variable no_use_id_acc_post integer;
declare variable no_use_id_acc_post$pms integer;
begin
  for
    select PE.NEW_ID_ACCOUNT_POST, PE.NEW_ID_ACCOUNT_POST$PMS
    from PMS_EXPENSE_POSTS_CREATE$INT(:ID_ROOM, :ID_OWNER, :ID_RENTAL_POOL, :ID_SERVICE,
         :ID_CURRENCY, :POST_VALUE, :IS_ACC_POST_ITEM, :MANUAL_POST_DATE, :DESCRIPTION, :IS_POST_PER_POOL) PE
    into :no_use_id_acc_post, :no_use_id_acc_post$pms
  do begin

  end
end
^

/* empty dependent procedure body */
/* Clear: PMS_IMPORT for: PMS_IMPORT$INT */
ALTER PROCEDURE PMS_IMPORT(ID_EXPORT_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_IMPORT$INT) */
ALTER PROCEDURE PMS_IMPORT$INT(ID_EXPORT_HEAD INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_room_contract integer;
  declare variable id_pms_event integer;
  declare variable imp_period_from date;
  declare variable event_price_with_vat numeric(15,4);
  declare variable event_price_wo_vat numeric(15,4);
  declare variable curr varchar(3);
  declare variable adult_count integer;
  declare variable id_rental_pool integer;
  declare variable reservs integer;
  declare variable stay integer;
  declare variable bednights integer;
  declare variable id_hotel integer;
begin
  for
    select E.ID_PMS_EVENT, E.ID_RESERV_DETAIL, E.IMP_PERIOD_FROM,
           E.CURR, r.ID_HOTEL, e.PRICE_WO_VAT, e.PRICE_WITH_VAT,
           e.RESERVS, e.STAY, e.BEDNIGHTS, rc.ID_ROOM_CONTRACT, rc.ID_RENTAL_POOL
    from   PMS_EVENT$PMS E
           join ROOMS R on R.ID_ROOM = e.ID_ROOM
           join ROOM_CONTRACT$PMS rc on rc.ID_ROOM_CONTRACT = e.ID_ROOM_CONTRACT
    where  E.ID_EXPORT_HEAD = :ID_EXPORT_HEAD
           and E.EVENT_STATUS = 11
    order by 1
    into   :id_pms_event, :id_reserv_detail, :imp_period_from,
           :curr, :id_hotel, :event_price_wo_vat, :event_price_with_vat,
           :reservs, :stay, :bednights, :id_room_contract, :id_rental_pool
  do begin
/* */
    select r.ADULT_COUNT
    from   RESERV_DETAIL r
    where  r.ID_RESERV_DETAIL = :id_reserv_detail
    into   :adult_count;

    execute procedure PMS_EVENT_POST$INT (:id_pms_event, :id_room_contract, :id_rental_pool,
            :imp_period_from, :event_price_with_vat, :event_price_wo_vat, :curr,
            :adult_count, :stay, :bednights, :reservs, :id_hotel, :id_reserv_detail);

    execute procedure PMS_EVENT_SET_ACTIVE$INT(:id_pms_event);

  end
end
^

/* Alter (PMS_POOL_DISTRIBUTION) */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION(ID_RENTAL_POOL INTEGER,
FOR_DATE DATE)
 AS
declare variable total_value_per_service numeric(15,4);
  declare variable id_service integer;
  declare variable curr varchar(3);
  declare variable id_room_param integer;
  declare variable is_room_pool smallint;
  declare variable is_owner_income smallint;

  declare variable is_acc_post_item smallint;
  declare variable new_id_owner_bill integer;
  declare variable id_account_post_pms integer;
  declare variable id_pool_account integer;

  declare variable id_account_pms integer;
  declare variable value_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable value_post numeric(15,4);
  declare variable curr_post varchar(3);
  declare variable id_room integer;
  declare variable date_post date;
  declare variable id_reserv_detail integer;
  declare variable doc_description varchar(255);
  declare variable id_doc_head integer;
  declare variable description varchar(255);
  declare variable is_client_account_post smallint;
  declare variable id_event_lst varchar(5000);
begin
  is_room_pool = null;
  select U.IS_ROOM_POOL, U.ID_ROOM_PARAM
  from   OWNER$PMS O
         join RENTAL_POOL_UNIT$PMS U on U.ID_RENTAL_POOL_UNIT = O.ID_RENTAL_POOL_UNIT
  where  O.ID_OWNER = :ID_RENTAL_POOL
  into   :is_room_pool, :id_room_param;
  if (:is_room_pool is null) then exception PMS_EXCEPTION;

  select cast(list(distinct AP.ID_PMS_EVENT) as varchar(5000))
  from   ACCOUNT_POST$PMS AP
         join ACCOUNT$PMS AC on AC.ID_ACCOUNT = AP.ID_ACCOUNT_PMS
  where  AP.DATE_POST <= :FOR_DATE
         and AP.LINE_STATUS = 11
         and AC.ID_OWNER = :ID_RENTAL_POOL
         and AC.IS_SHADOW = 0
  into   :id_event_lst;

  for
    select sum(AP1.VALUE_POST), AP1.ID_SERVICE, AP1.CURR_POST, AP1.IS_OWNER_INCOME,
           ACC.IS_CLIENT_POOL_ACCOUNT, ACC.ID_ACCOUNT
    from   ACCOUNT_POST$PMS AP1
           join ACCOUNT$PMS ACC on ACC.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS
           join SYSTEM_STRING_PARSER(:id_event_lst, ',') S on S.ITEM = AP1.ID_PMS_EVENT
    where  AP1.LINE_STATUS = 11
           and ACC.IS_SHADOW = 0
    group by 2,3,4,5,6
    into   :total_value_per_service, :id_service, :curr, :is_owner_income,
           :is_acc_post_item, :id_pool_account
  do begin
    execute procedure PMS_POOL_DISTRIBUTION_SUB(:ID_RENTAL_POOL, :id_pool_account,
            :IS_ROOM_POOL, :ID_ROOM_PARAM, :total_value_per_service,
            :ID_SERVICE, :CURR, :IS_OWNER_INCOME, :FOR_DATE, :is_acc_post_item);
  end

  NEW_ID_OWNER_BILL = gen_id(GEN_OWNER_BILL$PMS_ID, 1);

  insert into OWNER_BILL$PMS (ID_OWNER_BILL, ID_OWNER, BILL_DATE, IS_ANUL, BILL_NUM,
         IS_EXPORTED_TO_INTRANET, IS_POOL_DISTRIBUTION_STATEMENT)
  values (:NEW_ID_OWNER_BILL, :ID_RENTAL_POOL, :FOR_DATE, 0, :NEW_ID_OWNER_BILL, 0, 1);

  update OWNER$PMS O
  set    O.LAST_BILLING_DATE = :for_date,
         O.ID_OWNER_BILL = :NEW_ID_OWNER_BILL
  where  O.ID_OWNER = :ID_RENTAL_POOL;

  for
    select AP.ID_ACCOUNT_POST, AP.VALUE_ORIG, AP.CURR_ORIG, AP.VALUE_POST, AP.CURR_POST,
           ACC.ID_ACCOUNT, AP.IS_OWNER_INCOME, AP.ID_SERVICE, E.ID_ROOM, AP.DATE_POST,
           E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION, ACC.IS_CLIENT_POOL_ACCOUNT
    from   PMS_EVENT$PMS E
           join ACCOUNT_POST$PMS AP on ap.ID_PMS_EVENT = e.ID_PMS_EVENT
                                       and AP.LINE_STATUS = 11
           join ACCOUNT$PMS ACC on ACC.ID_ACCOUNT = AP.ID_ACCOUNT_PMS
                                   and ACC.ID_OWNER = :ID_RENTAL_POOL
                                   and ACC.IS_SHADOW = 0
    where  ((E.ID_SESSION = current_transaction) or (','||:id_event_lst||',' containing  ','||E.ID_PMS_EVENT||','))
    into   :id_account_post_pms, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
           :ID_ACCOUNT_PMS, :IS_OWNER_INCOME, :ID_SERVICE, :ID_ROOM, :DATE_POST,
           :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION, :is_client_account_post
  do begin
    insert into OWNER_BILL_ROW$PMS (ID_OWNER_BILL, ID_ACCOUNT_POST, ID_ACCOUNT,
           ID_ACCOUNT_POST_PMS, ID_ACCOUNT_PMS, ID_SERVICE, VALUE_ORIG,
           CURR_ORIG, VALUE_POST, CURR_POST, IS_OWNER_INCOME, ID_ROOM, DATE_POST,
           ID_RESERV_DETAIL, DOC_DESCRIPTION, ID_DOC_HEAD, DESCRIPTION, IS_CLIENT_ACCOUNT_POST)
    values (:new_id_owner_bill, null, null,
           :ID_ACCOUNT_POST_PMS, :ID_ACCOUNT_PMS, :ID_SERVICE, :VALUE_ORIG,
           :CURR_ORIG, :VALUE_POST, :CURR_POST, :IS_OWNER_INCOME, :ID_ROOM, :DATE_POST,
           :ID_RESERV_DETAIL, :DOC_DESCRIPTION, :ID_DOC_HEAD, :DESCRIPTION, :is_client_account_post);

    update ACCOUNT_POST$PMS A
    set    A.LINE_STATUS = 21
    where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS;
  end
end
^

/* Alter (PMS_POSTING_CREATE$INT) */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_OWNER TYPE OF ID,
POST_DATE TYPE OF TDATE,
CURR_ORIG TYPE OF TCURRENCY,
VALUE_ORIG TYPE OF TPRICE,
POST_ON_PMS_ACCOUNT TYPE OF TLOGICAL,
IS_OWNER_INCOME TYPE OF TLOGICAL,
ID_ROOM TYPE OF ID_REF = null)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  if (:POST_ON_PMS_ACCOUNT = 1) then begin
    execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account, :id_owner,
            :CURR_ORIG, :VALUE_ORIG, :id_service, :is_owner_income, :POST_DATE)
    returning_values  (:new_id_account_post);
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :ID_SERVICE, 1, 0, 1,
            :VALUE_ORIG, :CURR_ORIG, current_date, current_date,
            '', '', :POST_DATE, 'PMS', :ID_ROOM)
    returning_values  :err_code, :err_text, :new_id_account_post;
    if (:err_code <> 0) then exception PMS_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

    insert into PMS_EVENT_POST (ID_PMS_EVENT, ID_ACCOUNT_POST, ID_OWNER, LINE_STATUS)
    values (:ID_PMS_EVENT, :NEW_ID_ACCOUNT_POST, :ID_OWNER, 11);
  end
end
^

/* Alter (POST_SERVICE_FINALIZE$POST) */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
  declare variable id_acc_post integer;
  declare variable id_service integer;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable date_post date;
  declare variable price_post numeric(15,4);
  declare variable qty_post numeric(15,2);
  declare variable post_text varchar(100);
  declare variable curr_post varchar(3);
  declare variable id_phonecall integer;
  declare variable p_dbkey char(8);
begin

  if (:OPERATION = 'clear') then begin
    delete from TMP_SERVICE_POST T
    where  T.ID_SEQUENCE = :ID_SEQUENCE;

  end else if (:OPERATION = 'store') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);

    for
      select TS.RDB$DB_KEY, TS.ID_SERVICE, TS.ID_ACCOUNT, TS.ID_GUEST, TS.DATE_POST,
             TS.PRICE_POST, TS.QTY_POST, TS.CURR_POST, TS.POST_TEXT, TS.ID_PHONECALL
      from   TMP_SERVICE_POST TS
      where  TS.ID_SEQUENCE = :ID_SEQUENCE
      into   :p_dbkey, :id_service, :id_account, :id_guest, :date_post,
             :price_post, :qty_post, :curr_post, :post_text, :id_phonecall
    do begin
      id_acc_post = null;
      if (:id_guest is not null) then begin
        execute procedure POST_SERVICE_ON_GUEST$INT (:id_guest, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :CURR_POST,
                :date_post, :date_post, :post_text, '', :date_post, '', '')
        returning_values  (:err_code, :err_text, :no_use, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end else begin
        execute procedure POST_SERVICE_ON_ACCOUNT$INT (:id_account, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :curr_post, :date_post, :date_post, :post_text,
                '', :date_post, '')
        returning_values  (:err_code, :err_text, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end

      update TMP_SERVICE_POST
      set ID_ACCOUNT_POST = :id_acc_post
      where RDB$DB_KEY = :p_dbkey;

      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :DOC_SELECTED,
             AP.SHORT_CODE = case
                               when :id_phonecall is not null then 'TELECOUNT'
                               else null
                             end
      where  AP.ID_ACCOUNT_POST = :id_acc_post;

      if (:id_phonecall is not null) then begin
        update PHONECALLS P
        set    P.ID_ACCOUNT_POST = :id_acc_post
        where  P.ID_PHONECALL = :id_phonecall;
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_RATING_LOOP$INT for: PRODUCT_RATING$INT */
ALTER PROCEDURE AVAILABILITY_RATING_LOOP$INT(ID_SESSION INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ROOMS_COUNT INTEGER,
ADULTS_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ROOMTYPE_LIST VARCHAR(2000),
RATE_LIST VARCHAR(2000),
BOARD_LIST VARCHAR(2000),
HOTELS VARCHAR(255) = '')
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PRODUCT_SELECTION_RECALC$WBE for: PRODUCT_RATING$INT */
ALTER PROCEDURE PRODUCT_SELECTION_RECALC$WBE(WBE_SESSION_ID INTEGER)
 RETURNS(ERR_COUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PRODUCT_RATING$INT) */
ALTER PROCEDURE PRODUCT_RATING$INT(ID_HOTEL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
ADULT_AGES VARCHAR(100) = null,
CHILD_AGES VARCHAR(100) = null,
ID_TAR_CALC_COMMON INTEGER = null)
 RETURNS(ROOM_PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100))
 AS
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable id_reserv integer;
declare variable id_tar_calc integer;
declare variable rate_currency char(3);
begin
  id_tar_calc = null;
  select T.CURR
  from   TARIFA T
  where  t.ID_TARIFA = :ID_RATE
  into   :rate_currency;

  execute procedure TAR_CALC_INPUT_PLAIN$INT (:adult_count, :children_count,
          :id_room_type, :id_board, :arrival_date, :departure_date,
          '', '', null, '', null, null, :id_rate, :adult_ages, :child_ages, :ID_TAR_CALC_COMMON)
  returning_values (:id_tar_calc, :id_reserv, :err_code, :err_text);
  --if (:err_code < 0) then exit;

  if (:err_code = 0) then begin
    execute procedure TAR_CALC_EVAL_ALL$INT(:id_tar_calc)
    returning_values  :err_code, :err_text;
    /*savedbg('-----------------------------');
    savedbg('id_rate: ' || :id_rate);
    savedbg('id_board: ' || :id_board);
    savedbg('id_room_type: ' || :id_room_type);
    savedbg('id_tar_calc: ' || :id_tar_calc);
    savedbg('err_code: ' || :ERR_CODE);
    savedbg('err_text: ' || :ERR_TEXT);
    */
    if (:err_code = 0) then begin
      execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

      price_currency = :rate_currency;
      execute procedure TAR_CALC_GET_PRICE$INT (:id_tar_calc, :id_hotel, :id_reserv, :price_currency)
      returning_values  :room_price, :room_price_details;
    end
  end
end
^

/* Alter (PRODUCT_SELECTION_RECALC$WBE) */
ALTER PROCEDURE PRODUCT_SELECTION_RECALC$WBE(WBE_SESSION_ID INTEGER)
 RETURNS(ERR_COUNT INTEGER)
 AS
declare variable arrival date;
declare variable departure date;
declare variable adults integer;
declare variable children integer;
declare variable room_type_id integer;
declare variable rate_id integer;
declare variable board_id integer;
declare variable hotel_id integer;
declare variable product_selection_dbkey char(8);
declare variable product_value numeric(15,4);
declare variable product_currency char(3);
declare variable adults_ages varchar(100);
declare variable children_ages varchar(100);
declare variable no_use varchar(255);
begin
  err_count = 0;

  for
    select ps.rdb$db_key, aq.first_date, aq.first_date + aq.day_count, ps.adults, ps.children,
           pa.room_type_id, pa.rate_id, pa.board_id, ws.hotel_id,
           (select list(coalesce(g.AGE, ''))
            from   PRODUCT_SELECTION_GUESTS$WBE g
            where  g.PRODUCT_SELECTION_ID = ps.ID
                   and g.IS_CHILD = 0),
           (select list(coalesce(g.AGE, ''))
            from   PRODUCT_SELECTION_GUESTS$WBE g
            where  g.PRODUCT_SELECTION_ID = ps.ID
                   and g.IS_CHILD = 1)
    from   PRODUCT_SELECTION$WBE PS
           join PRODUCT_AVAILABILITY$WBE PA on PA.ID = PS.PRODUCT_AVAILABILITY_ID
           join WBE_SESSION$WBE WS on WS.ID=PS.WBE_SESSION_ID
           join AVAILABILITY_QUERY$WBE AQ on AQ.ID = WS.PRODUCT_QUERY_ID
    where  ps.wbe_session_id = :wbe_session_id
    into   :product_selection_dbkey, :arrival, :departure, :adults, :children,
    :room_type_id, :rate_id, :board_id, :hotel_id, :adults_ages, :children_ages
  do begin
    /*calc prices for request in TMP_AVAILABILITY */
    product_value = null;
    product_currency = null;
    execute procedure PRODUCT_RATING$INT (:hotel_id, :arrival, :departure,
            :adults, :children, :room_type_id, :board_id, :rate_id, :adults_ages, :children_ages)
    returning_values  :product_value, :product_currency, :no_use;

    if (:product_value is null) then begin
      err_count = :err_count + 1;
    end

    update PRODUCT_SELECTION$WBE ps
    set    ps.total_value = :product_value,
           ps.currency = :product_currency
    where  ps.rdb$db_key = :product_selection_dbkey;
  end
end
^

/* Alter (PROFILE_GET_ACCOUNT$INT) */
ALTER PROCEDURE PROFILE_GET_ACCOUNT$INT(ID_PROFILE INTEGER,
ID_RESERV_DETAIL INTEGER,
ACCOUNT_CURR VARCHAR(3),
ID_ACC_TEMPLATE INTEGER,
IS_BASE_ENABLE SMALLINT = 1,
IS_EXTRA_ENABLE SMALLINT = 1)
 RETURNS(ID_ACCOUNT INTEGER)
 AS
declare variable is_archive integer;
declare variable id_hotel integer;
begin
  id_account = null;

  select first 1 A.ID_ACCOUNT, a.IS_ARCHIVE
  from   ACCOUNT A
  where  A.ID_PROFILE = :id_profile
         and A.ACCOUNT_CURR = :account_curr
         and A.ID_RESERV_DETAIL is not distinct from :id_reserv_detail
         and A.IS_BASE >= :IS_BASE_ENABLE
         and A.IS_EXTRA >= :IS_EXTRA_ENABLE
  order by A.IS_ARCHIVE asc, A.ID_ACCOUNT asc
  into   :id_account, :is_archive;

  if (:id_account is null) then begin
    if (:id_acc_template is null) then begin
      select rd.ID_HOTEL
      from   RESERV_DETAIL RD
      where  rd.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
      into   :id_hotel;

      select P.ID_ACCOUNT_TEMPLATE
      from   PROFILE_BOOKING_DEFAULTS P
      where  P.ID_PROFILE = :id_profile
             and P.ID_HOTEL = :id_hotel
      into   :id_acc_template;
    end

    execute procedure RES_ACCOUNT_CREATE$INT(:id_profile, :id_acc_template, :account_curr,
            :id_reserv_detail, :IS_BASE_ENABLE, :IS_EXTRA_ENABLE)
    returning_values  :id_account;

  end else if (:is_archive = 1) then begin
    execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 0);
  end
end
^

/* Alter (PROFILE_GET_ACCOUNT$PROFILE) */
ALTER PROCEDURE PROFILE_GET_ACCOUNT$PROFILE(ID_PROFILE INTEGER,
SHOW_ARCHIVE SMALLINT)
 RETURNS(ID_ACCOUNT INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
DEPOSIT_VALUE NUMERIC(15,4),
BALANCE_VALUE NUMERIC(15,4),
IS_DEFAULT SMALLINT,
IS_CREDIT SMALLINT,
CREDIT_LIMIT NUMERIC(15,4),
ID_TYPE_PAYMENT INTEGER,
IS_LEVEL_1 INTEGER,
IS_ARCHIVE INTEGER,
HOTEL_NAME VARCHAR(50))
 AS
begin
  for
    select A.ID_ACCOUNT, A.ACCOUNT_CURR, A.ACCOUNT_NAME, A.CREDIT_LIMIT,
           A.IS_CREDIT_ACCOUNT, A.ID_TYPE_PAYMENT, AB.DEP_VALUE, AB.ACCOUNT_BALANCE,
           A.IS_DEFAULT,
           case
             when A.SECURITY_LEVEL = 1 then 1
             else 0
           end,
           A.IS_ARCHIVE, H.HOTEL_NAME
    from  ACCOUNT_S A
          join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
          join HOTEL_S H on H.ID_HOTEL = A.ID_HOTEL
          left outer join ACCOUNT_BALANCE$INT(A.ID_ACCOUNT) AB on 0=0
    where A.ID_PROFILE = :ID_PROFILE
          and (:SHOW_ARCHIVE = 1 or A.IS_ARCHIVE = 0)
    into  :ID_ACCOUNT, :ACCOUNT_CURR, :ACCOUNT_NAME, :CREDIT_LIMIT,
          :IS_CREDIT, :ID_TYPE_PAYMENT, :DEPOSIT_VALUE, :BALANCE_VALUE,
          :IS_DEFAULT, :IS_LEVEL_1, :IS_ARCHIVE, :HOTEL_NAME
  do begin
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: PROFILE_COMMON_MODIFY$INT for: PROFILE_SET_ARCHIVE$INT */
ALTER PROCEDURE PROFILE_COMMON_MODIFY$INT(ID_PROFILE INTEGER,
PROFILE_TYPE VARCHAR(20),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
IS_ARCHIVE INTEGER,
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PROFILE_SET_ARCHIVE$INT) */
ALTER PROCEDURE PROFILE_SET_ARCHIVE$INT(P_DBKEY CHAR(8),
ARCHIVE_STATUS SMALLINT)
 AS
declare variable old_is_archive smallint;
  declare variable id_profile integer;
  declare variable id_account integer;
  declare variable id_merge_profile integer;
begin
  select P.IS_ARCHIVE, P.ID_PROFILE, p.ID_MERGE_PROFILE
  from   PROFILE P
  where  P.RDB$DB_KEY = :P_DBKEY
  into   :old_is_archive, :id_profile, :id_merge_profile;
   
  if (:ARCHIVE_STATUS > :old_is_archive) then begin
    /* archive */
    if (exists (select app.ID_ACCOUNT_POST
                from   ACCOUNT_POST$PMS APP
                where  app.ID_OWNER = :id_profile
                       and app.LINE_STATUS = 11)) then
      exception PROFILE_EXCEPTION '-1050';

    for
      select A.ID_ACCOUNT
      from   ACCOUNT A
      where  A.ID_PROFILE = :id_profile
             and a.IS_ARCHIVE is distinct from 1
      into   :id_account
    do begin
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS (:id_account, 1);
    end 

  end else if (:ARCHIVE_STATUS < :old_is_archive) then begin
    /* unarchive */
    if (:id_merge_profile is not null) then exception PROFILE_EXCEPTION '-1045';

    for
      select A.ID_ACCOUNT
      from   ACCOUNT A
      where  A.ID_PROFILE = :id_profile
             and a.IS_PMS_ACCOUNT = 1
             and a.IS_ARCHIVE = 1
      into   :id_account
    do begin
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS (:id_account, 0);
    end 

  end

  update PROFILE P
  set    P.IS_ARCHIVE = :ARCHIVE_STATUS
  where  P.RDB$DB_KEY = :P_DBKEY;
   
end
^

/* empty dependent procedure body */
/* Clear: REP_ROOM_STATUS$INT for: REP_ROOM_STATUS_BUILD$INT */
ALTER PROCEDURE REP_ROOM_STATUS$INT(FOR_DATE DATE,
STAT_OPTIONS VARCHAR(255),
PRIVATE_STATUS_ADDING SMALLINT = 0)
 RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
SECTOR INTEGER,
ID_ROOM_TYPE INTEGER,
TYPE_ROOM VARCHAR(20),
IS_CLEAN INTEGER,
IS_INSPECTED INTEGER,
CLEAN_TEXT VARCHAR(30),
IS_LEAVING SMALLINT,
IS_COMMING SMALLINT,
IS_SHARED SMALLINT,
IS_LEAVING_WORDS VARCHAR(30),
BUSY_GRP INTEGER,
DAYS_THIS_STATUS INTEGER,
DTS_CONTEXT VARCHAR(10),
COMMING_OCCUPANTS VARCHAR(1024),
ID_BLOCK_ROOM INTEGER,
OTHER_OCCUPANTS VARCHAR(1024),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ID_HOTEL INTEGER,
HAS_OPENED_POSTINGS SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (REP_ROOM_STATUS_BUILD$INT) */
ALTER PROCEDURE REP_ROOM_STATUS_BUILD$INT(ID_ROOM INTEGER,
FOR_DATE DATE,
STAT_OPTIONS VARCHAR(255))
 RETURNS(IS_LEAVING SMALLINT,
IS_COMMING SMALLINT,
IS_SHARED SMALLINT,
IS_LEAVING_WORDS VARCHAR(30),
BUSY_GRP INTEGER,
DAYS_THIS_STATUS INTEGER,
DTS_CONTEXT VARCHAR(10),
COMMING_OCCUPANTS VARCHAR(1024),
ID_BLOCK_ROOM INTEGER,
OTHER_OCCUPANTS VARCHAR(1024),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER)
 AS
declare variable report_leaving varchar(50);
  declare variable as_busy_grp_type integer;

  declare variable day_action varchar(50);
  declare variable occup_grp integer;
  declare variable occupant_id integer;
  declare variable busygrp_leaving integer;
  declare variable busygrp_other integer;
  declare variable check_status integer;
  declare variable int_adult_count integer;
  declare variable int_children_count integer;
  declare variable id_hotel integer;
begin
  select r.ID_HOTEL
  from   ROOMS R
  where  R.ID_ROOM = :ID_ROOM
  into   :id_hotel;

  execute procedure SETTING_GET_VALUE('REPORT_LEAVING', :id_hotel)
  returning_values  :report_leaving;

  is_leaving = 0;
  is_comming = 0;
  is_shared = 0;
  comming_occupants = '';
  id_block_room = null;
  other_occupants = '';
  busygrp_leaving = 0;
  busygrp_other = 0;
  adult_count = 0;
  children_count = 0;

  for
    select RM.ID_RESERV_DETAIL, coalesce(RS.BUSY_GROUP_TYPE, rm.BUSY_GROUP_TYPE), RM.DAY_ACTION,
           RD.CHECK_STATUS, RM.ADULT_COUNT, RM.CHILDREN_COUNT
    from   TMP_HM_ROOM_STATUS HM
           join ROOM_MAGIC RM on RM.ID_ROOM_MAGIC = HM.ID_ROOMS_MAGIC
           left outer join ROOMS_SHARE RS on RS.ID_ROOM_SHARE = RM.ID_ROOM_MAGIC
           left outer join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = RM.ID_RESERV_DETAIL
    where  HM.ID_SESSION = current_transaction
           and HM.ID_ROOM = :id_room
    order by RD.CHECK_STATUS asc nulls first, rd.FROM_DATE asc nulls first
    into   :occupant_id, :occup_grp, :day_action,
           :check_status, :int_adult_count, :int_children_count
  do begin
    --is_comming = 0;
    --is_leaving = 0;
    if (:occup_grp in (18, 20) and :DAY_ACTION = 'BLOCK') then begin
      id_block_room = :occupant_id;
      busygrp_other = :occup_grp;
    end else if (:DAY_ACTION = 'CHECK_IN') then begin
      is_comming = 1;
      if (','||:comming_occupants||',' not containing ','||:occupant_id||',') then
        comming_occupants = :comming_occupants || iif(:comming_occupants = '', '', ',') || :occupant_id;
      busygrp_other = :occup_grp;
    end else if (:DAY_ACTION containing 'CHECK_OUT') then begin
      if (:check_status < 1) then begin
        if ((:check_status < 0) and (:stat_options containing 'HOUSEKEEPING')) then begin
          -- do nothing. House keeping is not interested in leaving reservations
        end
        is_leaving = 1;
        busygrp_leaving = :occup_grp;
        if (','||:other_occupants||',' not containing ','||:occupant_id||',') then
          other_occupants = :other_occupants || iif(:other_occupants = '', '', ',') || :occupant_id;
      end else begin
        -- nothing, room is alreay checked out
      end
    end else begin
      -- DAY_ACTION = 'STAY'
      busygrp_other = :occup_grp;
      if (','||:other_occupants||',' not containing ','||:occupant_id||',') then
        other_occupants = :other_occupants || iif(:other_occupants = '', '', ',') || :occupant_id;
    end

    adult_count = :adult_count + :int_adult_count;
    children_count = :children_count + :int_children_count;

  end

  if (:report_leaving = 'AS_FREE') then begin
    busy_grp = :busygrp_other;
  end else begin
    busy_grp = iif(:busygrp_leaving in (0, 1), :busygrp_other, :busygrp_leaving);
  end

  if (exists(
    select *
    from   ROOMS_SHARE RS
    where  RS.ID_ROOM = :id_room
           and RS.BUSY_DATE = :for_date
  )) then is_shared = 1;
  else is_shared = 0;

  if (:stat_options containing 'DAYS_THIS_STATUS') then begin
    if (:is_leaving = 1) then begin
      if (exists(  -- !!! this select must be changed
           select * from ROOM_MAGIC RM
           where  RM.BUSY_DATE = :for_date
                  and RM.ID_ROOM = :id_room
                  and RM.BUSY_TYPE <> 'VALUE_RESERVS'
                  and RM.DAY_ACTION not containing 'CHECK_OUT')
      ) then as_busy_grp_type = :busy_grp;
      else begin
        /* TODAY THE ROOM IS LEAVING AND NO BODY IS EXPECTED TO COME
        || SO WE MUST SHOW HOW MANY DAYS THE ROOM WILL BE FREE
        */
        as_busy_grp_type = 0;
      end
    end else as_busy_grp_type = :busy_grp;

    if (:as_busy_grp_type = 0) then dts_context = 'FREE';
    else dts_context = 'BUSY';
    execute procedure REP_ROOM_STATUS_DTS$INT(:as_busy_grp_type, :for_date, :id_room)
    returning_values  :days_this_status;

--    if (:days_this_status is null) then days_this_status_txt = '~';
--    else days_this_status_txt = :days_this_status;
  end
end
^

/* Alter (RES_ACCOUNTS_RECIEVE$INT) */
ALTER PROCEDURE RES_ACCOUNTS_RECIEVE$INT(ID_RESERV_DETAIL INTEGER,
OLD_ID_BASE_ACCOUNT INTEGER,
OLD_ID_EXTRA_ACCOUNT INTEGER,
ID_AGENT_ACCOUNT_RULE INTEGER,
ID_BASE_ACCOUNT_PROFILE INTEGER,
ID_EXTRA_ACCOUNT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ID_ACC_TEMPLATE_PERSON INTEGER,
IS_SEPARATE_ACCOUNTS SMALLINT)
 RETURNS(NEW_ID_BASE_ACCOUNT INTEGER,
NEW_ID_EXTRA_ACCOUNT INTEGER)
 AS
declare variable id_acc_profile integer;
  declare variable base_account_curr varchar(3);
  declare variable base_tariff_currency char(3);
  declare variable extra_tariff_currency char(3);
  declare variable id_hotel integer;
  declare variable id_base_acc_reserv integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
begin
  id_acc_profile = null;
  select A.ID_PROFILE, A.ACCOUNT_CURR, A.ID_RESERV_DETAIL
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :old_id_base_account
  into   :id_acc_profile, :base_account_curr, :id_base_acc_reserv;

  select first 1 T.CURR, T.ID_HOTEL
  from   GUEST G
         join GUEST_STAY GS on gs.ID_GUEST = g.ID_GUEST
         join TARIFA T on T.ID_TARIFA = GS.ID_TARIFF
  where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  order by GS.FOR_DATE asc
  into   :base_tariff_currency, :id_hotel;

  if (:base_tariff_currency is null) then EXIT;

  select first 1 T.CURR
  from   TARIFA T
  where  T.IS_EXTRA = 1
         and T.ID_HOTEL = :id_hotel
  into   :extra_tariff_currency;

  if (coalesce(:id_agent_account_rule, 0) > 0) then begin
    /* get specified account */
    new_id_base_account = :id_agent_account_rule;
    execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:NEW_ID_BASE_ACCOUNT, 0);
  end else if (:id_acc_profile = :id_base_account_profile
               and :base_account_curr = :base_tariff_currency
               and :id_base_acc_reserv is not distinct from :ID_RESERV_DETAIL) then
  begin
    /* preserve old base personal account */
    new_id_base_account = :old_id_base_account;
  end else begin
    /* get new personal account */
    execute procedure PROFILE_GET_ACCOUNT$INT (:id_base_account_profile, :id_reserv_detail, 
            :base_tariff_currency, iif(:id_base_account_profile = :id_person_profile, :id_acc_template_person, null),
            1, iif(:IS_SEPARATE_ACCOUNTS = 0, 1, 0))
    returning_values (:new_id_base_account);
  end

  select ba.ACCOUNT_CURR
  from   ACCOUNT BA
  where  ba.ID_ACCOUNT = :NEW_ID_BASE_ACCOUNT
  into   :base_account_curr;

  if (:IS_SEPARATE_ACCOUNTS = 1
      and :base_account_curr = :extra_tariff_currency
      and :ID_BASE_ACCOUNT_PROFILE = :ID_EXTRA_ACCOUNT_PROFILE)
  then IS_SEPARATE_ACCOUNTS = 0;


  if (:IS_SEPARATE_ACCOUNTS = 0) then begin
    new_id_extra_account = :new_id_base_account;
    update ACCOUNT A
    set    a.IS_EXTRA = 1
    where  a.ID_ACCOUNT = :NEW_ID_EXTRA_ACCOUNT
           and a.IS_EXTRA is distinct from 1;
  end else begin
    id_acc_profile = null;
    select A.ID_PROFILE/*, A.ACCOUNT_CURR*/
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :old_id_extra_account
    into   :id_acc_profile/*, :account_curr*/;

    if (:id_acc_profile = :id_extra_account_profile /*and :account_curr = :extra_tariff_currency*/ and :old_id_extra_account is not null) then begin
      -- CHANGED after p27 -> condition {:account_curr = :extra_tariff_currency} is removed;
      -- if exists extra account by this profile, it must be preserve, independent of currency,
      -- because of unnecessary posting transfer and archiving of unused accounts (by the same profile);
      -- this can be forced with ACC_ROUTING changing (MIXED -> AGENT -> MIXED)
      new_id_extra_account = :old_id_extra_account;
    end else begin
      execute procedure PROFILE_GET_ACCOUNT$INT (:id_extra_account_profile, :id_reserv_detail,
              :extra_tariff_currency, iif(:id_extra_account_profile = :id_person_profile, :id_acc_template_person, null),
              1, 1)
      returning_values (:new_id_extra_account);
    end
  end
  /*  */
  if (:NEW_ID_BASE_ACCOUNT is distinct from :OLD_ID_BASE_ACCOUNT) then begin
    execute procedure ACCOUNT_VALIDATE$INT(:NEW_ID_BASE_ACCOUNT, 'IS_BASE')
    returning_values  :err_code, :err_text, :no_use, :no_use, :no_use, :no_use;
    if (:err_code < 0) then exception ACCOUNT_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end
  if (:NEW_ID_EXTRA_ACCOUNT is distinct from :OLD_ID_EXTRA_ACCOUNT) then begin
    execute procedure ACCOUNT_VALIDATE$INT(:NEW_ID_EXTRA_ACCOUNT, 'IS_EXTRA')
    returning_values  :err_code, :err_text, :no_use, :no_use, :no_use, :no_use;
    if (:err_code < 0) then exception ACCOUNT_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end

end
^

/* Alter (RES_ARCHIVATE_ACCOUNTS$INT) */
ALTER PROCEDURE RES_ARCHIVATE_ACCOUNTS$INT(ID_RESERV_DETAIL INTEGER)
 AS
declare variable id_account integer;
begin
  for
    select RA.ID_ACCOUNT
    from   RES_GET_ACCOUNTS(:id_reserv_detail, 'BALANCE') RA
    into   :id_account
  do begin
    execute procedure ACCOUNT_BALANCE_INVALIDATE$INT (:id_account);

    execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 1);
  end

end
^

/* Alter (RES_CHECKIN$RSV) */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable old_check_status integer;
  declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable is_anul integer;
  declare variable arrival_date date;
  declare variable system_date date;
begin
  /*  Description:
  ||
  */
  select RD.CHECK_STATUS, RD.RDB$DB_KEY, RD.FROM_DATE, RD.ID_HOTEL,
         RD.ID_ROOM, RD.IS_ANUL
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_check_status, :rd_dbkey, :arrival_date, :id_hotel,
         :old_id_room, :is_anul;

  if (:is_anul = 1) then exception BOOKING_EXCEPTION '-2';

  if (:old_check_status >= 0) then exception BOOKING_EXCEPTION '-1003';

  if (:old_id_room < 0 and coalesce(:ID_ROOM, 0) <= 0) then exception BOOKING_EXCEPTION '-1018';

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date < :arrival_date) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CHECK_IN_FUTURE');
  end
  /*----*/
  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'lock');

  execute procedure sys_dbg('occ RES_CHECKIN$RSV id_room = '||coalesce(:id_room, 'null'));
  execute procedure sys_dbg('occ RES_CHECKIN$RSV old_id_room = '||coalesce(:old_id_room, 'null'));

  if (:id_room is not null) then begin
    if (:old_check_status = -3) then begin
      execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, -2);
    end

    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option)
    returning_values (:WARN_CODE);
  end

  execute procedure RES_SET_CHECKIN$INT (:rd_dbkey)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'release');
  /*----*/
  select f_character(29) || R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = coalesce(:ID_ROOM, :old_id_room)
  into   :action_text;
   
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'CHECK_IN', :action_text);

end
^

/* Alter (RES_CHECKIN_MULTI$RSV) */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable checkin_count integer;
  declare variable split_on_checkin integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
  declare variable tmp_warn_code integer;
begin
  checkin_count = 0;
  warn_code = null;
  for
    select RD.ID_RESERV_DETAIL, RD.CHECK_STATUS, RD.SPLIT_ON_CHECKIN, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :SELECTION_ID
    into   :id_reserv_detail, :check_status, :split_on_checkin, :id_titular
  do begin
    if (:check_status >= 0) then begin
      checkin_count = :checkin_count + 1;
    end else begin
      if (:split_on_checkin = 1) then begin
        for
          select G.ID_GUEST
          from   GUEST G
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and G.ID_GUEST <> :id_titular
          into   :id_guest
        do begin
          execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
          returning_values  :id_splited_reservation;

          execute procedure RES_CHECKIN$RSV (:id_splited_reservation)
          returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

          update RESERV_DETAIL RD
          set    RD.SELECTION_ID = :selection_id
          where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
        end
      end

      execute procedure RES_CHECKIN$RSV (:id_reserv_detail)
      returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
      WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end

  if (:checkin_count > 0) then begin
    execute procedure SYSTEM_WARNING_ADD(-1011, f_character(29)||:checkin_count)
    returning_values  :warn_code;
  end
end
^

/* Alter (RES_CREATE_ROOM$INT) */
ALTER PROCEDURE RES_CREATE_ROOM$INT(CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_COUNT INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_AGENT_PROFILE INTEGER,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_PERSON_PROFILE INTEGER,
ACC_ROUTING VARCHAR(50),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ID_GROUP INTEGER = null,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_GUARANTEE_POLICY INTEGER = null,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
RD_DBKEY CHAR(8),
NEW_ID_PERSON_PROFILE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable day_keep_types integer;
  declare variable exp_date date;
  declare variable leaving_kind integer;
  declare variable cnt_processed integer;
begin
  execute procedure SETTING_GET_VALUE('DAY_KEEP_TYPES', :ID_HOTEL)
  returning_values  :day_keep_types;
  exp_date = :arrival_date + :day_keep_types;
  leaving_kind = coalesce(:is_late_departure, 0) + 1;
  comming_kind = coalesce(:comming_kind, 1);

  cnt_processed = 0;
  while (:room_count > :cnt_processed) do begin
    if (:res_number is null) then begin
      execute procedure SYSTEM_GEN_NUM('BOOKING', 0)
      returning_values  :dbg, :res_number;
    end
    
    if (:id_person_profile is null) then begin
      execute procedure PROFILE_PERSON_CREATEQ$PROFILE(:res_number, '', null, null, null,
              :country_code, null, null, null, :ID_HOTEL)
      returning_values  :new_id_person_profile, :dbg, :dbg;
      execute procedure sys_dbg('res RES_CREATE_ROOM$INT autocreate id_person_profile = '||coalesce(:id_person_profile, 'null'));
    end else begin
      new_id_person_profile = :id_person_profile;
    end

    execute procedure RES_CREATE_DETAIL$INT(:id_reserv_detail, :id_agent_profile, :res_number, :check_status,
                      :arrival_date, :departure_date, :code_first_food, :exp_date, :comming_kind, :leaving_kind,
                      :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                      0, 0, :note, :i_special_treatment, :id_board, -1, :id_rate,
                      :id_room_type, :country_code, '30.12.1899', null, null, '30.12.1899', null, null, null,
                      :room_features, :id_hk_plan, :new_id_person_profile, :id_hotel, :acc_routing, :id_acc_template_person,
                      :id_group, :id_agent_account, :id_guarantee_policy, :ID_EATING_OBJECT)
    returning_values  :new_id_reserv_detail, :rd_dbkey;
    res_number = null;

    execute procedure RES_GUESTCOUNT_ADD$INT(:rd_dbkey, :adult_count, :child_count);

    cnt_processed = :cnt_processed + 1;
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_SET$EXC for: RES_CREATE_SET$INT */
ALTER PROCEDURE RES_CREATE_SET$EXC(ID_RESERV_DETAIL INTEGER,
RES_NUMBER VARCHAR(62),
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER,
CREATE_DATETIME TIMESTAMP)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_RESERV_DETAIL INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_CREATE$RSV for: RES_CREATE_SET$INT */
ALTER PROCEDURE RESMULTI_CREATE$RSV(ID_HOTEL INTEGER,
ID_ROOM_TYPE INTEGER,
TRANSFER_OUT_TIME TIME,
TRANSFER_IN_TIME TIME,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
TRANSFER_OUT_NOTE VARCHAR(50),
TRANSFER_IN_NOTE VARCHAR(50),
NOTE VARCHAR(255),
ID_BOARD INTEGER,
VOUCHER_DATE DATE,
VOUCHER_NUMBER VARCHAR(20),
VOUCHER_TEXT VARCHAR(30),
CHECK_STATUS INTEGER,
ID_TARIFF INTEGER,
COUNTRY_CODE VARCHAR(20),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
NOTE_REMINDERS VARCHAR(50),
TITULAR_NAME VARCHAR(100),
SPLIT_ON_CHECKIN INTEGER,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
NUMBER VARCHAR(62),
NEW_ID_TITULAR INTEGER,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE,
WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_CREATE_SET$INT) */
ALTER PROCEDURE RES_CREATE_SET$INT(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(255),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_HOTEL INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
SPLIT_ON_CHECKIN SMALLINT,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_ACC_TEMPLATE_PERSON INTEGER = null,
ID_GUARANTEE_POLICY INTEGER = null,
BLOCK_CC VARCHAR(255) = null,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(RD_DBKEY CHAR(8),
NEW_ID_RESERV_DETAIL INTEGER,
WARN_CODE TYPE OF TRANGE)
 AS
declare variable guarantee_deposit_percent numeric(15,4);
  declare variable guarantee_deposit_nights integer;
  declare variable guarantee_due_days_bef_arrival integer;
  declare variable guarantee_due_days_after_create integer;
  declare variable gp_check_status integer;
  declare variable log_suppressed integer;
  declare variable id_guest integer;
  declare variable minibar_rights varchar(50);
  declare variable video_rights varchar(50);
  declare variable nopost_pms varchar(50);
  declare variable phone_rights varchar(50);
  declare variable paytv_rights varchar(50);
  declare variable is_profile_exclusive_debt_ownership integer;
  declare variable id_base_account integer;
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CREATE');

  select GP.DEPOSIT_NIGHTS_COUNT, GP.DEPOSIT_TOTALSUM_PART,
         GP.DUE_DAYS_BEFORE_ARRIVAL, GP.DUE_DAYS_AFTER_CREATE, gp.CHECK_STATUS
  from   GUARANTEE_POLICY GP
  where  GP.ID_GUARANTEE_POLICY = :ID_GUARANTEE_POLICY
         and gp.ID_HOTEL = :ID_HOTEL
  into   :guarantee_deposit_nights, :guarantee_deposit_percent,
         :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create, :gp_check_status;

  CHECK_STATUS = coalesce(:CHECK_STATUS, :gp_check_status, -2);

  execute procedure RES_CREATE_ROOM$INT(:check_status, :arrival_date, :departure_date, :adult_count, :child_count,
                    :id_room_type, 1, :id_board, :id_tariff, comming_kind, :is_late_departure, :country_code, :code_first_food,
                    :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note, :i_special_treatment, :id_agent_profile,
                    :id_hk_plan, '', :room_features, :id_person_profile, :acc_routing, :id_acc_template_person, :id_hotel, :id_agent_account,
                    :id_group, :id_reserv_detail, :res_number, :id_guarantee_policy, :id_eating_object)
  returning_values  :new_id_reserv_detail, :rd_dbkey, :id_person_profile;

  if (RDB$GET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE') is not distinct from 'disable') then begin
    log_suppressed = 1;
  end else begin
    log_suppressed = 0;
    RDB$SET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE', 'disable');
    -- disable only for intermediate changes
  end

  execute procedure RES_SAVE_ACCOUNTING$INT (:rd_dbkey, :id_agent_profile, :id_agent_account, :acc_routing,
          :id_person_payment, :id_agent_payment, :id_group);

  execute procedure RES_SAVE_MARKETING$INT(:rd_dbkey, :id_nom_market_segment,
                    :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason);

  execute procedure sys_dbg('res RES_CREATE_SET$INT id_room = '||coalesce(:id_room, 'null'));
  if (:id_room is not null) then begin
    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, :id_room_type, 'nrttRoom')
    returning_values (:WARN_CODE);
  end

  execute procedure RES_SAVE_VOUCHER$INT(:RD_DBKEY, :voucher_num, :voucher_date, :voucher_text, :voucher2_num, :voucher2_date);

  execute procedure RES_SAVE_NOTE$RSV(:new_id_reserv_detail, :note, :note_reminders);

  for
    select  g.ID_GUEST
    from    GUEST G
    where   G.ID_RESERV_DETAIL = :NEW_ID_RESERV_DETAIL
    into    :id_guest
  do begin
    execute procedure RES_GUEST_SAVE_PACKET$RSV (:id_guest, :PACKET_ITEM_IDS);
  end 

  update RESERV_DETAIL RD
  set    RD.CUSTOM_PRICE = :CUSTOM_PRICE,
         RD.CUSTOM_CURRENCY = :CUSTOM_CURRENCY,
         RD.SPLIT_ON_CHECKIN = :SPLIT_ON_CHECKIN,
         RD.IS_VIP = coalesce(:IS_VIP, RD.IS_VIP),
         RD.ID_GUARANTEE_POLICY = :ID_GUARANTEE_POLICY,
         RD.GUARANTEE_DEPOSIT = :GUARANTEE_DEPOSIT,
         RD.GUARANTEE_CURRENCY = :GUARANTEE_CURRENCY,
         RD.BLOCK_CC = :BLOCK_CC,
         RD.GUARANTEE_DEPOSIT_PERCENT = :guarantee_deposit_percent,
         RD.GUARANTEE_DEPOSIT_NIGHTS = :guarantee_deposit_nights,
         RD.GUARANTEE_DUE_DAYS_BEF_ARRIVAL = :guarantee_due_days_bef_arrival,
         RD.GUARANTEE_DUE_DAYS_AFTER_CREATE = :guarantee_due_days_after_create
         /*rd.POSTING_TRANSACTION_UUID =  (select iif(p.IS_EXCLUSIVE_DEBT_OWNERSHIP = 1, uuid_create(), null)
                                         from   ACCOUNT A
                                                join PROFILE P on P.ID_PROFILE = a.ID_PROFILE
                                         where  a.ID_ACCOUNT = rd.ID_BASE_ACCOUNT)*/
  where  RD.RDB$DB_KEY = :rd_dbkey
  returning new.ID_BASE_ACCOUNT
  into      :id_base_account;

  select p.IS_EXCLUSIVE_DEBT_OWNERSHIP
  from   ACCOUNT A
         join PROFILE P on P.ID_PROFILE = a.ID_PROFILE
  where  a.ID_ACCOUNT = :id_base_account
  into   :is_profile_exclusive_debt_ownership;

  if (:is_profile_exclusive_debt_ownership = 1) then begin
    execute procedure RES_TAKE_POSTING_RESPONSIBILITY (:NEW_ID_RESERV_DETAIL);
  end

  select rt.MINIBAR_RIGHTS, rt.VIDEO_RIGHTS, rt.NOPOST_PMS, rt.PHONE_RIGHTS, rt.PAYTV_RIGHTS
  from   RES_TEMPLATE RT
  where  rt.ID_HOTEL = :ID_HOTEL
  into   :minibar_rights, :video_rights, :nopost_pms, :phone_rights, :paytv_rights;

  execute procedure RESERV_DETAIL_EXTERNAL_MOD$RSV (:NEW_ID_RESERV_DETAIL,
          :minibar_rights, :paytv_rights, :video_rights, :nopost_pms, :phone_rights, null, null);

  if (:log_suppressed = 0) then RDB$SET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE', 'enable');

  execute procedure RES_CREATE_LOG$INT (:RD_DBKEY);

end
^

/* Alter (RES_CREATE_SET$RSV) */
ALTER PROCEDURE RES_CREATE_SET$RSV(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
SUPPRESS_WARNINGS INTEGER,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER,
NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable rd_dbkey char(8);
declare variable tmp_warn_code integer;
begin
  WARN_CODE = null;
  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, :check_status, :arrival_date, :departure_date,
                    :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff, :PACKET_ITEM_IDS,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
                    :guarantee_deposit, :guarantee_currency, :split_on_checkin, null, null, :ID_ACC_TEMPLATE_PERSON,
                    :ID_GUARANTEE_POLICY, null, :ID_EATING_OBJECT)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :WARN_CODE;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :ERR_TEXT, :share_transaction_id, :tmp_warn_code;
  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

  if (:suppress_warnings = 1) then begin
    delete from SYSTEM_WARNINGS W
    where W.ID_TRANSACTION = :warn_code;
    warn_code = null;
  end

  update RESERV_DETAIL RD
  set    RD.NOTE_REMINDERS = :note_reminders
  where  RD.RDB$DB_KEY = :rd_dbkey;

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;

end
^

/* empty dependent procedure body */
/* Clear: RES_DELETE$RSV for: RES_DELETE$INT */
ALTER PROCEDURE RES_DELETE$RSV(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESGRP_DELETE$RSV for: RES_DELETE$INT */
ALTER PROCEDURE RESGRP_DELETE$RSV(ID_GROUP INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_DELETE$INT) */
ALTER PROCEDURE RES_DELETE$INT(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable rd_dbkey char(8);
  declare variable id_guest integer;
  declare variable action_text varchar(255);
  declare variable from_date date;
  declare variable to_date date;
  declare variable room_type varchar(20);
  declare variable number varchar(62);
  declare variable tmp_extra_posts_left integer;
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_DELETE');

  select RD.RDB$DB_KEY, RD.FROM_DATE, rd.TO_DATE, RT.TYPE_ROOM, rd.NUMBER
  from   RESERV_DETAIL RD
         left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = RD.ID_ROOM_TYPE
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey, :from_date, :to_date, :room_type, :number;

  update RESERV_DETAIL R
  set    r.ID_TITULAR = null
  where  r.RDB$DB_KEY = :rd_dbkey;

  EXTRA_POSTS_LEFT = 0;
  for
    select G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_guest
  do begin
    execute procedure RES_GUEST_DEL$INT(:id_guest, :id_reserv_detail, :REASON)
    returning_values  :tmp_extra_posts_left;
    EXTRA_POSTS_LEFT = iif(:EXTRA_POSTS_LEFT = 1, 1, :tmp_extra_posts_left);
  end

  execute procedure RES_FINALIZE$INT (:RD_DBKEY, 1)
  returning_values (:warn_code);


  execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

  action_text = f_character(29) || coalesce(:number, '')
                || f_character(28) || coalesce(:room_type, '')
                || f_character(28) || :from_date
                || f_character(28) || :to_date
                || f_character(28) || :reason;
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'DELETE', :action_text);

  delete from RESERV_DETAIL RDD
  where  RDD.RDB$DB_KEY = :rd_dbkey;

  delete from XML_MESSAGE$EXC xml
  where  xml.OBJECT_TYPE = 'BOOKING'
         and xml.OBJECT_ID = :number;

end
^

/* Alter (RES_DELETE$RSV) */
ALTER PROCEDURE RES_DELETE$RSV(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT,
NEW_FROM_DATE TYPE OF TDATE)
 AS
begin

  execute procedure RES_DELETE$INT(:ID_RESERV_DETAIL, :REASON)
  returning_values :WARN_CODE, :EXTRA_POSTS_LEFT;

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;
end
^

/* empty dependent procedure body */
/* Clear: RES_EARLY_DEPARTURE_SET$RSV for: RES_FINALIZE$INT */
ALTER PROCEDURE RES_EARLY_DEPARTURE_SET$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND INTEGER)
 RETURNS(RECALC_MARKER_LIST VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_FINALIZE$RSV for: RES_FINALIZE$INT */
ALTER PROCEDURE RES_GUEST_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER,
ALL_ERRORS_ARE_INSTANT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUESTLIST_REMOVE$RSV for: RES_FINALIZE$INT */
ALTER PROCEDURE RES_GUESTLIST_REMOVE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTING$RSV for: RES_FINALIZE$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$RSV(ID_RESERV_DETAIL INTEGER,
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER,
ID_CREDIT_CARD INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_GUARANTEE$RSV for: RES_FINALIZE$INT */
ALTER PROCEDURE RES_SAVE_GUARANTEE$RSV(ID_RESERV_DETAIL INTEGER,
IS_VIP SMALLINT,
CHECK_STATUS INTEGER,
ID_GUARANTEE_POLICY INTEGER,
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_FINALIZE$INT) */
ALTER PROCEDURE RES_FINALIZE$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable err_text varchar(255);
begin
  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, :SUPPRESS_NON_INSTANT_ERRORS)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;
  if (:share_err_code < 0) then exception BOOKING_EXCEPTION :share_err_code || f_character(31) || :ERR_TEXT;
end
^

/* empty dependent procedure body */
/* Clear: RES_GET_BALLANCE$RPT for: RES_GET_BALLANCE$INT */
ALTER PROCEDURE RES_GET_BALLANCE$RPT(ID_RESERV_DETAIL INTEGER)
 RETURNS(RESERVATION_BALLANCE VARCHAR(255),
RECIEVED_DEPOSITS VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GET_BALLANCE$INT) */
ALTER PROCEDURE RES_GET_BALLANCE$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(RESERVATION_BALLANCE VARCHAR(255),
RECIEVED_DEPOSITS VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER)
 AS
declare variable account_balance numeric(15,2);
  declare variable account_curr char(3);
  declare variable dep_money_bag varchar(255);
  declare variable dep_value numeric(15,2);
  declare variable curr_display_format varchar(10);
  declare variable open_charges_int integer;
  declare variable account_curr_current char(3);
  declare variable account_balance_current numeric (15,4);
  declare variable partial_ballance integer;
  declare variable id_account integer;
  declare variable round_to numeric(15,4) ;
begin
  /*  Description:
  ||
  */
  RESERVATION_BALLANCE = '';
  RECIEVED_DEPOSITS = '';
  PARTIAL_BALLANCE = 0;
  OPEN_DEPOSIT = 0;
  OPEN_CHARGES = 0;
  HAS_CHARGES = 0;

  ACCOUNT_BALANCE = 0;
  ACCOUNT_CURR = '';

  for
    select AB.ACCOUNT_CURR, AB.CURR_DISPLAY_FORMAT, AB.ACCOUNT_BALANCE, AB.OPEN_CHARGES,
           AB.DEP_VALUE, AB.DEP_MONEY_BAG, RA.ID_ACCOUNT
    from   RES_GET_ACCOUNTS(:ID_RESERV_DETAIL, 'BALANCE') RA
           left outer join ACCOUNT_BALANCE$INT(RA.ID_ACCOUNT) AB on 0=0
    union all
    select 'ZZZ', null, null, null,
           null, null, null
    from   RDB$DATABASE
    order by 1 asc
    into   :ACCOUNT_CURR_CURRENT, :CURR_DISPLAY_FORMAT, :ACCOUNT_BALANCE_CURRENT, :OPEN_CHARGES_INT,
           :DEP_VALUE, :DEP_MONEY_BAG, :ID_ACCOUNT
  do begin
    if ((:ACCOUNT_CURR_CURRENT <> 'ZZZ') and (not exists(
      select *
      from   ACCOUNT_S A
      where  A.ID_ACCOUNT = :ID_ACCOUNT
    ))) then PARTIAL_BALLANCE = 1;
    else begin
      if (:ACCOUNT_CURR_CURRENT = :ACCOUNT_CURR) then begin
        ACCOUNT_BALANCE = :ACCOUNT_BALANCE + :ACCOUNT_BALANCE_CURRENT;
      end else begin
        select c.ROUND_TO
        from   currs c
        where  c.CURR = :ACCOUNT_CURR_CURRENT
        into   :round_to;

        if (round_f(:ACCOUNT_BALANCE, :round_to) <> 0) then begin
          if (:RESERVATION_BALLANCE = '') then RESERVATION_BALLANCE = formatfloat (:ACCOUNT_BALANCE, :CURR_DISPLAY_FORMAT) ||' '|| :ACCOUNT_CURR;
          else RESERVATION_BALLANCE = :RESERVATION_BALLANCE ||', '||formatfloat (:ACCOUNT_BALANCE, :CURR_DISPLAY_FORMAT) ||' '|| :ACCOUNT_CURR;
        end
  
        ACCOUNT_BALANCE = :ACCOUNT_BALANCE_CURRENT;
        ACCOUNT_CURR = :ACCOUNT_CURR_CURRENT;
      end
  
      if (:ACCOUNT_CURR_CURRENT <> 'ZZZ') then begin
        if (:OPEN_CHARGES_INT = 1) then OPEN_CHARGES = 1;
        if (:DEP_VALUE > 0) then OPEN_DEPOSIT = 1;

        if (:RECIEVED_DEPOSITS = '') then RECIEVED_DEPOSITS = :DEP_MONEY_BAG;
        else if (:DEP_MONEY_BAG <> '') then RECIEVED_DEPOSITS = :RECIEVED_DEPOSITS || :DEP_MONEY_BAG;
      end
    end

    if (:HAS_CHARGES = 0) then begin
      if (:OPEN_CHARGES = 1) then HAS_CHARGES = 1;
      else if (exists (select ap.ID_ACCOUNT_POST
                       from   ACCOUNT_POST AP
                       where  ap.ID_ACCOUNT = :ID_ACCOUNT)) then HAS_CHARGES = 1;
    end
  end

  if (:PARTIAL_BALLANCE = 1) then RESERVATION_BALLANCE = :RESERVATION_BALLANCE || ' xxx';
end
^

/* Alter (RES_GET_BALLANCE$RPT) */
ALTER PROCEDURE RES_GET_BALLANCE$RPT(ID_RESERV_DETAIL INTEGER)
 RETURNS(RESERVATION_BALLANCE VARCHAR(255),
RECIEVED_DEPOSITS VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER)
 AS
begin
  execute procedure RES_GET_BALLANCE$INT (:ID_RESERV_DETAIL)
  returning_values  (:RESERVATION_BALLANCE, :RECIEVED_DEPOSITS, :HAS_CHARGES, :OPEN_CHARGES, :OPEN_DEPOSIT);

  suspend;
end
^

/* empty dependent procedure body */
/* Clear: MONITOR_ROOM_GANTT$HM for: RES_GET_INFO$RSV */
ALTER PROCEDURE MONITOR_ROOM_GANTT$HM(FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ID_ROOM INTEGER,
GFROM_DATE DATE,
IS_MOVED_FROM INTEGER,
GTO_DATE DATE,
IS_MOVED_TO INTEGER,
BUSY_GRP INTEGER,
OCCUPANT_ID INTEGER,
IN_SHARE SMALLINT,
ID_GROUP INTEGER,
ATTENTION_STATUS SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: MONITOR_ROOM_GANTT_OCCUPANT$HM for: RES_GET_INFO$RSV */
ALTER PROCEDURE MONITOR_ROOM_GANTT_OCCUPANT$HM(FROM_DATE DATE,
TO_DATE DATE,
REQUEST_OCCUPANT_ID INTEGER)
 RETURNS(ID_ROOM INTEGER,
GFROM_DATE DATE,
IS_MOVED_FROM INTEGER,
GTO_DATE DATE,
IS_MOVED_TO INTEGER,
BUSY_GRP INTEGER,
OCCUPANT_ID INTEGER,
IN_SHARE SMALLINT,
ID_GROUP INTEGER,
ATTENTION_STATUS SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: OCCUPANT_GET_INFO for: RES_GET_INFO$RSV */
ALTER PROCEDURE OCCUPANT_GET_INFO(ID_OCCUPANT INTEGER,
IN_BUSY_GRP INTEGER = null)
 RETURNS(BUSY_GRP INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
INFO VARCHAR(1024))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GET_INFO$RSV) */
ALTER PROCEDURE RES_GET_INFO$RSV(ID_RESERV_DETAIL INTEGER,
RETURN_BALANCE SMALLINT = 1,
RETURN_SHARE SMALLINT = 1,
RETURN_GEUSTDATA SMALLINT = 1)
 RETURNS(NUMBER VARCHAR(62),
AGENT_PROFILE_NAME VARCHAR(100),
ARRIVALS VARCHAR(255),
DEPARTURES VARCHAR(255),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
ID_ROOM INTEGER,
ROOM VARCHAR(60),
ID_ROOM_TYPE INTEGER,
ROOM_FEATURES BLOB,
GUESTS VARCHAR(255),
GUESTS_CNT INTEGER,
PERSON_PROFILE_NAME VARCHAR(150),
RATES VARCHAR(255),
BOARDS VARCHAR(255),
PACKETS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY VARCHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
BALANCE VARCHAR(255),
OPEN_CHARGES INTEGER,
CHECK_STATUS INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
NOTE VARCHAR(2000),
NOTE_GRP VARCHAR(255),
VOUCHER_RENDER VARCHAR(512),
ACC_ROUTING VARCHAR(255),
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
BUSY_GRP INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
GUEST_TYPE_COLOR INTEGER,
IS_CLEAN INTEGER,
ROOM_PRIVATE_STATUS TLOGICAL)
 AS
declare variable arrival varchar(20);
declare variable departure varchar(20);
declare variable rd_dbkey char(8);
declare variable no_use varchar(1024);
declare variable rd_adult_count integer;
declare variable rd_child_count integer;
declare variable groupname varchar(100);
declare variable virtual_room varchar(10);
declare variable earlycheckout_date date;
begin
  arrivals = '';
  departures = '';
  rates = '';
  NOTE_GRP = null;

  IS_CLEAN = 0;

  select AP.PROFILE_NAME, RD.ADULT_COUNT, RD.CHILD_COUNT,
         R.ID_ROOM, R.ROOM_NAME, coalesce(rd.VIRTUAL_ROOM, 'i'||RM.ID_ROOM), coalesce(R.ID_ROOM_TYPE, RM.ID_ROOM_TYPE, RD.ID_ROOM_TYPE),
         RD.CHECK_STATUS, PP.PROFILE_NAME || coalesce(' (' || GT.GUEST_TYPE_NAME || ')', ''),
         RD.FROM_DATE, RD.TO_DATE, RG.GROUP_NAME,
         RD.ID_GROUP, RD.ROOM_FEATURES, RD.COMMING_KIND, RD.LEAVING_KIND - 1,
         RD.NUMBER, RD.NOTE, RD.RDB$DB_KEY, RD.ID_HOTEL, RD.ACC_ROUTING,
         GT.GUEST_TYPE_COLOR, coalesce(r.IS_CLEAN, 1), g.EARLYCHECKOUT_DATE
  from   RESERV_DETAIL RD
         left outer join RESERV_GROUP RG on RG.ID_RESERV_GROUP = RD.ID_GROUP
         left outer join PROFILE AP on AP.ID_PROFILE = RD.ID_AGENT_PROFILE
         left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
         left outer join ROOM_MAP$EXC RM on RM.ID_ROOM = RD.ID_ROOM
         left outer join PROFILE PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
         left outer join PROFILE_PERSON PPp on PPp.ID_PROFILE = PP.ID_PROFILE
         left outer join GUEST_TYPE GT on GT.ID_GUEST_TYPE = PPp.ID_GUEST_TYPE
         left outer join GUEST G on g.ID_GUEST = rd.ID_TITULAR
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :agent_profile_name, :rd_adult_count, :rd_child_count,
         :id_room, :room, :virtual_room, :id_room_type,
         :check_status, :person_profile_name,
         :arrival_date, :departure_date, :groupname,
         :id_group, :room_features, :comming_kind, :is_late_departure,
         :number, :note, :rd_dbkey, :id_hotel, :acc_routing,
         :guest_type_color, :is_clean, :earlycheckout_date;


  ARRIVALS = iif(extract(year from current_date) = extract(year from :ARRIVAL_DATE),
               formatDate(:ARRIVAL_DATE, 'D;dd.mm')||' ('||(:DEPARTURE_DATE - :ARRIVAL_DATE)||')',
               formatDate(:ARRIVAL_DATE, 'D;dd.mm.yy')||' ('||(:DEPARTURE_DATE - ARRIVAL_DATE)||')');
  DEPARTURES = iif(extract(year from current_date) = extract(year from :DEPARTURE_DATE),
               formatDate(:DEPARTURE_DATE, 'D;dd.mm'),
               formatDate(:DEPARTURE_DATE, 'D;dd.mm.yy'));
  for
    select iif(extract(year from current_date) = extract(year from g.FROM_DATE),
               formatDate(g.FROM_DATE, 'D;dd.mm')||' ('||(G.TO_DATE - G.FROM_DATE)||')',
               formatDate(g.FROM_DATE, 'D;dd.mm.yy')||' ('||(G.TO_DATE - G.FROM_DATE)||')'),
           iif(extract(year from current_date) = extract(year from g.TO_DATE),
               formatDate(g.TO_DATE, 'D;dd.mm'),
               formatDate(g.TO_DATE, 'D;dd.mm.yy'))
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
           and ((g.FROM_DATE <> :ARRIVAL_DATE) or (g.TO_DATE <> :DEPARTURE_DATE))
    into   :arrival, :departure
  do begin
    if (:ARRIVALS not containing :arrival) then ARRIVALS = :ARRIVALS || ','||:arrival;
    if (:DEPARTURES not containing :departure) then DEPARTURES = :DEPARTURES || ','||:departure;
  end

  execute procedure RES_GET_PRICE$INT(:rd_dbkey, 'SECURITY')
  returning_values  :room_price, :room_currency, :room_price_details, :no_use, :no_use;

  if (coalesce(:return_balance,1)=1) then
    execute procedure RES_GET_BALLANCE$INT(:id_reserv_detail)
    returning_values  :balance, :no_use, :no_use, :open_charges, :no_use;

  if (:groupname <> '') then agent_profile_name = substring(coalesce(:agent_profile_name, '') || ' / ' || coalesce(:groupname, '') from 1 for 100);

  execute procedure RES_GET_ATTENTION_STATUS$INT(:arrival_date, :departure_date, :check_status, :id_hotel)
  returning_values  :attention_status;

  if (coalesce(:return_share,1)=1) then begin
    execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'RENDER', null)
    returning_values  :in_share, :no_use, :shares_preview;
    if (:IN_SHARE = 1) then ROOM = coalesce(:ROOM, :virtual_room);
  end

  if (coalesce(:return_geustdata,1)=1) then begin
    execute procedure RES_GET_GUEST_DATA$INT('DETAIL', :id_reserv_detail)
    returning_values  :boards, :rates, :packets, :voucher_render;
  end

  execute procedure RES_GET_ANNULSTATUS(:rd_dbkey)
  returning_values  :annul_status;

  guests = :rd_adult_count || ' + ' || :rd_child_count || ' ';
  guests_cnt = :rd_adult_count + :rd_child_count;

  if (:check_status > 1) then  busy_grp = 24;
  else busy_grp = 1;

  ROOM_PRIVATE_STATUS = 0;
  select cast(1 as smallint)
  from   SYSTEM_DATE_GET (:ID_HOTEL) sd
         join ROOM_MAGIC rm on rm.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                               and rm.ROOM_STATUS = 'PRIVATE'
                               and rm.BUSY_DATE = mindate(maxdate(:ARRIVAL_DATE, sd.SYSTEM_DATE), coalesce(:earlycheckout_date, :DEPARTURE_DATE) - 1)
  into   :ROOM_PRIVATE_STATUS;

  suspend;
end
^

/* Alter (RES_GUEST_FINALIZE$RSV) */
ALTER PROCEDURE RES_GUEST_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER,
ALL_ERRORS_ARE_INSTANT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, iif (:all_errors_are_instant = 1, 0, 1))
  returning_values  :warn_code;

end
^

/* Alter (RES_GUESTLIST_REMOVE$RSV) */
ALTER PROCEDURE RES_GUESTLIST_REMOVE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable g_dbkey char(8);
  declare variable rd_dbkey char(8);
begin
  /*  Description:
  ||
  */

  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  for
    select G.RDB$DB_KEY
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :g_dbkey
  do begin
    execute procedure RES_GUEST_AUTO$INT(:g_dbkey, :rd_dbkey, 0);
  end

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
  returning_values  :WARN_CODE;

end
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE_RECALC$INT for: RES_RECALC$INT */
ALTER PROCEDURE RES_FINALIZE_RECALC$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_RECALC$RSV for: RES_RECALC$INT */
ALTER PROCEDURE RES_RECALC$RSV(ID_RESERV_DETAIL INTEGER,
FORCE_POSTING SMALLINT = null)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_RECALC$INT) */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable num_prefix varchar(20);
  declare variable number_1 varchar(20);
begin
  /* CALLER_KIND = {NORMAL, FORCED} */
  err_code = 0;
  /* 1. GET DATA */
  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL, rd.NUMBER_1
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :check_status, :id_reserv_detail, :number_1;

  if (:check_status = 1) then begin
    -- CHECKED OUT
    select sn.LEADING_PART
    from   SYSTEM_NUMERATOR SN
    where  sn.ID_NUMERATOR = 0
    into   :num_prefix;

    if (trim('.' from coalesce(:num_prefix, '')) = coalesce(:number_1, '')) then
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_MINE');
    else
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_ELSE');

    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :id_guest
    do begin
      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'MANUAL_EDIT_DATA', '');
    end
  end
  /* 2. FIND DEPENDANT GUESTS AND THEIR TARIFFS */
  execute procedure sys_dbg('calc RES_RECALC$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

  id_tar_calc = gen_id(gen_id_tar_calc, 1);
  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NONE');

  execute procedure TAR_CALC_EVAL_ALL$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  -- 3. UPDATE ROOM PRICE and REPOST ALL AFFECTED BOOKINGS
  execute procedure RES_TAR_CALC_FINALIZE$INT (:ERR_CODE, :ID_TAR_CALC, :RD_DBKEY, :CALLER_KIND, :FORCE_POSTING);

end
^

/* Alter (RES_RECALC$RSV) */
ALTER PROCEDURE RES_RECALC$RSV(ID_RESERV_DETAIL INTEGER,
FORCE_POSTING SMALLINT = null)
 AS
declare variable id_tar_calc integer;
declare variable err_text varchar(255);
  declare variable err_code integer;
  declare variable rd_dbkey char(8);
begin
  -- FORCED, user activated recalculation
  execute procedure RIGHTS_CHECK_GRANTED$INT ('GUEST_RECALC_POST');

  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_RECALC$INT(:rd_dbkey, 'FORCED', :FORCE_POSTING)
  returning_values  :err_code, :err_text, :id_tar_calc;
  if (:err_code < 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'FORCED_RECALC', null);

end
^

/* Alter (RES_ROOM_REMOVE$INT) */
ALTER PROCEDURE RES_ROOM_REMOVE$INT(RD_DBKEY CHAR(8))
 RETURNS(WARN_CODE INTEGER)
 AS
begin

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, gen_id(DETAIL_WITHOUT_ROOMING_LIST, -1), null, 'nrttAsIs')
  returning_values (:WARN_CODE);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 0)
  returning_values  :WARN_CODE;

end
^

/* Alter (RES_SAVE_ACC_ARCHIVE$INT) */
ALTER PROCEDURE RES_SAVE_ACC_ARCHIVE$INT(ACCOUNTS_FOR_ARCHIVE VARCHAR(2000),
ID_PROFILE INTEGER)
 AS
declare variable id_account integer;
  declare variable old_id_profile integer;
  declare variable is_used integer;
  declare variable errtxt_acc_name varchar(50);
  declare variable errtxt_prof_name varchar(100);
begin
  /*  Description:
  ||
  */
  for
    select ITEM
    from   SYSTEM_STRING_PARSER(:accounts_for_archive, ',')
    into   :id_account                                 
  do begin
    select A.ID_PROFILE
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :old_id_profile;

    execute procedure sys_dbg('acc RES_SAVE_ACC_ARCHIVE$INT old_id_profile = '||coalesce(:old_id_profile, 'null'));
    execute procedure sys_dbg('acc RES_SAVE_ACC_ARCHIVE$INT id_profile = '||coalesce(:id_profile, 'null'));

    execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 1);
    execute procedure sys_dbg('acc RES_SAVE_ACC_ARCHIVE$INT id_account = '||coalesce(:id_account, 'null'));

    if (:old_id_profile is distinct from :id_profile) then begin
      execute procedure ACCOUNT_USE_CHECK$INT(:id_account)
      returning_values  :is_used;
      if (:is_used = 0) then
        delete from ACCOUNT A
        where  A.ID_ACCOUNT = :id_account;
    end

    when exception ACCOUNT_EXCEPTION do begin
      -- catch the exception raised from archivate procedure (err_code = -44)
      select A.ACCOUNT_NAME
      from   ACCOUNT A
      where  A.ID_ACCOUNT = :id_account
      into   :errtxt_acc_name;
  
      select P.PROFILE_NAME
      from   PROFILE P
      where  P.ID_PROFILE = :old_id_profile
      into   :errtxt_prof_name;
      -- override error code with most concrete
      exception ACCOUNT_EXCEPTION '-1009' || f_character(31) || '' || f_character(29)||:errtxt_acc_name||f_character(28)||:errtxt_prof_name;
    end

  end
end
^

/* Alter (RES_SAVE_ACCOUNTING$RSV) */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$RSV(ID_RESERV_DETAIL INTEGER,
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER,
ID_CREDIT_CARD INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);


begin
  /* Description : ACC_ROUTING = {GUEST, AGENT, MIXED, OWNER,  }
  ||
  */
  select rd.RDB$DB_KEY
  from   RESERV_DETAIL rd
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SAVE_ACCOUNTING$INT(:rd_dbkey, :id_agent_profile, :id_agent_account, :acc_routing,
                    :id_person_payment, :id_agent_payment, :id_group);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
  returning_values  :warn_code;

  --
end
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_CHANGE$RSV for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTING$INT for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SAVE_ACCOUNTS$INT) */
ALTER PROCEDURE RES_SAVE_ACCOUNTS$INT(RD_DBKEY CHAR(8))
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_base_account integer;
  declare variable old_id_extra_account integer;
  declare variable new_id_base_account integer;
  declare variable new_id_extra_account integer;
  declare variable acc_routing varchar(30);
  declare variable is_sep_accounts integer;
  declare variable id_base_account_profile integer;
  declare variable id_extra_account_profile integer;
  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable id_agent_account_rule integer;
  declare variable id_acc_template_person integer;
  declare variable id_guest integer;
  declare variable id_hotel integer;
begin

  select RD.ID_RESERV_DETAIL, RD.ID_PERSON_PROFILE, RD.ID_ACC_TEMPLATE_PERSON,
         RD.ACC_ROUTING, RD.ID_BASE_ACCOUNT, RD.ID_EXTRA_ACCOUNT,
         RD.ID_AGENT_PROFILE, RD.ID_AGENT_ACCOUNT_RULE, rd.id_hotel
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :RD_DBKEY
  into   :id_reserv_detail, :id_person_profile, :id_acc_template_person,
         :acc_routing, :old_id_base_account, :old_id_extra_account,
         :id_agent_profile, :id_agent_account_rule, :id_hotel;

  id_agent_account_rule = nullif(:id_agent_account_rule, -1);
  /* --- new */
  execute procedure SETTING_GET_VALUE ('SEPARATE_ACCOUNTS_PER_PAYER', :id_hotel)
  returning_values (:IS_SEP_ACCOUNTS);

  NEW_ID_BASE_ACCOUNT = null; --:old_id_base_account;
  NEW_ID_EXTRA_ACCOUNT = null; --:old_id_extra_account;

  /* identify profiles for base and extra account */
  if (:ACC_ROUTING in ('MIXED')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else if (:ACC_ROUTING in ('AGENT')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
  end else if (:ACC_ROUTING in ('FULL_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = null;
    IS_SEP_ACCOUNTS = 0;  -- never
  end else if (:ACC_ROUTING in ('PART_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else begin -- if (:acc_routing in ('GUEST', 'OWNER'))
    ID_BASE_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_AGENT_ACCOUNT_RULE = null;
  end

  execute procedure RES_ACCOUNTS_RECIEVE$INT (:ID_RESERV_DETAIL, :old_id_base_account, :old_id_extra_account,
          :id_agent_account_rule, :id_base_account_profile, :id_extra_account_profile, :id_person_profile,
          :id_acc_template_person, :is_sep_accounts)
  returning_values (:new_id_base_account, :new_id_extra_account);

--  if (:new_id_base_account is null) then exception WRONG_VALUE 'Invalid base account!';
--  if (:new_id_extra_account is null) then exception WRONG_VALUE 'Invalid extra account!';
  if ((:old_id_base_account is distinct from :new_id_base_account)
       or (:old_id_extra_account is distinct from :new_id_extra_account)) then
  begin
    update RESERV_DETAIL RD
    set    RD.ID_BASE_ACCOUNT = :new_id_base_account,
           RD.ID_EXTRA_ACCOUNT = :new_id_extra_account
    where  RD.RDB$DB_KEY = :RD_DBKEY;
    /* end --- */
    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
             --and G.CHECK_STATUS < 1
      into   :id_guest
    do begin
      execute procedure GUEST_REROUTE_POSTINGS$INT(:id_guest, :new_id_base_account, :new_id_extra_account);
    end

    -- Log account changes
    execute procedure RES_SAVE_ACCOUNTS_FINALIZE$INT(:id_reserv_detail, :old_id_base_account, :old_id_extra_account,
            :new_id_base_account, :new_id_extra_account);
  end

end
^

/* Alter (RES_SAVE_ACCOUNTS_FINALIZE$INT) */
ALTER PROCEDURE RES_SAVE_ACCOUNTS_FINALIZE$INT(ID_RESERV_DETAIL INTEGER,
OLD_ID_BASE_ACCOUNT INTEGER,
OLD_ID_EXTRA_ACCOUNT INTEGER,
NEW_ID_BASE_ACCOUNT INTEGER,
NEW_ID_EXTRA_ACCOUNT INTEGER)
 AS
declare variable id_old_account integer;
  declare variable action_text varchar(255);
  declare variable acc_name varchar(50);
  declare variable is_used integer;
begin
  if (:NEW_ID_BASE_ACCOUNT is distinct from :OLD_ID_BASE_ACCOUNT) then begin
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :OLD_ID_BASE_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = F_CHARACTER(29) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:OLD_ID_BASE_ACCOUNT, '')  || ')';
    ACC_NAME = null;
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :NEW_ID_BASE_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = :ACTION_TEXT || F_CHARACTER(28) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:NEW_ID_BASE_ACCOUNT, '')  || ')';

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_MOD_BASE_ACCOUNT', :ACTION_TEXT);
  end

  ACTION_TEXT = '';
  ACC_NAME = null;
  if (:NEW_ID_EXTRA_ACCOUNT is distinct from :OLD_ID_EXTRA_ACCOUNT) then begin
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :OLD_ID_EXTRA_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = F_CHARACTER(29) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:OLD_ID_EXTRA_ACCOUNT, '')  || ')';
    ACC_NAME = null;
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :NEW_ID_EXTRA_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = :ACTION_TEXT || F_CHARACTER(28) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:NEW_ID_EXTRA_ACCOUNT, '')  || ')';

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_MOD_EXTRA_ACCOUNT', :ACTION_TEXT);
  end

  -- Archivate old unused accounts
  for
    select A.ID_ACCOUNT
    from   ACCOUNT_S A
    where  A.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
           and A.IS_ARCHIVE = 0
           and A.ID_ACCOUNT <> :NEW_ID_BASE_ACCOUNT
           and A.ID_ACCOUNT <> :NEW_ID_EXTRA_ACCOUNT
           and A.IS_CREDIT_ACCOUNT = 0
           and not exists(select G.ID_GUEST
                          from   GUEST G
                          where  (G.ID_BASE_ACCOUNT = A.ID_ACCOUNT)
                                 or (G.ID_ACCOUNT = A.ID_ACCOUNT))
    into   :ID_OLD_ACCOUNT
  do begin
    select auc.is_used
    from   ACCOUNT_USE_CHECK$INT(:id_old_account) auc
    into   :is_used;

    if (:is_used = 0) then begin
      delete from ACCOUNT A
      where  a.ID_ACCOUNT = :id_old_account;
    end else begin
      -- cannot be deleted, because of available postings,corrections or payments (deposits)
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS (:ID_OLD_ACCOUNT, 1);
  
      when exception ACCOUNT_EXCEPTION do post_event 'dummy';
    end
  end 
end
^

/* Alter (RES_SAVE_GUARANTEE$RSV) */
ALTER PROCEDURE RES_SAVE_GUARANTEE$RSV(ID_RESERV_DETAIL INTEGER,
IS_VIP SMALLINT,
CHECK_STATUS INTEGER,
ID_GUARANTEE_POLICY INTEGER,
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER)
 AS
declare variable old_check_status integer;
declare variable warn_code integer;
declare variable rd_dbkey char(8);
declare variable action_text varchar(255);
begin
  /*  Description:
  ||  GUI facade
  */
  select RD.RDB$DB_KEY, rd.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_check_status;

  update RESERV_DETAIL RDU
  set    RDU.IS_VIP = coalesce(:is_vip, RDU.IS_VIP),
         RDU.ID_GUARANTEE_POLICY = :id_guarantee_policy,
         RDU.GUARANTEE_DEPOSIT = :guarantee_deposit,
         RDU.GUARANTEE_CURRENCY = :guarantee_currency,
         RDU.BLOCK_CC = :BLOCK_CC,
         GUARANTEE_DEPOSIT_PERCENT = :GUARANTEE_DEPOSIT_PERCENT,
         GUARANTEE_DEPOSIT_NIGHTS = :GUARANTEE_DEPOSIT_NIGHTS,
         GUARANTEE_DUE_DAYS_BEF_ARRIVAL = :GUARANTEE_DUE_DAYS_BEF_ARRIVAL,
         GUARANTEE_DUE_DAYS_AFTER_CREATE = :GUARANTEE_DUE_DAYS_AFTER_CREATE
  where  RDU.RDB$DB_KEY = :rd_dbkey;

  action_text = '';
  if (:GUARANTEE_DEPOSIT_PERCENT is not null) then begin
    action_text = f_character(29) || '@{caption.guaranteetype.percent} ' || formatfloat(:GUARANTEE_DEPOSIT_PERCENT, '0.00') || f_character(28)
                  || '[' || coalesce(:GUARANTEE_DUE_DAYS_AFTER_CREATE, ' ') || ']'
                  || f_character(28) || '[' || coalesce(:GUARANTEE_DUE_DAYS_BEF_ARRIVAL, ' ') || ']';
  end
  else if (:GUARANTEE_DEPOSIT_NIGHTS is not null) then begin
    action_text = f_character(29) || '@{caption.guaranteetype.nights} ' || :GUARANTEE_DEPOSIT_NIGHTS || f_character(28)
                  || '[' || coalesce(:GUARANTEE_DUE_DAYS_AFTER_CREATE, ' ') || ']'
                  || f_character(28) || '[' || coalesce(:GUARANTEE_DUE_DAYS_BEF_ARRIVAL, ' ') || ']';
  end
  else if (:GUARANTEE_DEPOSIT is not null) then begin
    action_text = f_character(29) || '@{caption.guaranteetype.fixed} ' || formatfloat(:GUARANTEE_DEPOSIT, '0.00') || ' ' || :GUARANTEE_CURRENCY || f_character(28)
                  || '[' || coalesce(:GUARANTEE_DUE_DAYS_AFTER_CREATE, ' ') || ']'
                  || f_character(28) || '[' || coalesce(:GUARANTEE_DUE_DAYS_BEF_ARRIVAL, ' ') || ']';
  end

  if (:action_text <> '') then begin
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_GUARANTEE_CHANGED', :action_text);
  end

  CHECK_STATUS = coalesce(:CHECK_STATUS, :old_check_status);
  if (:CHECK_STATUS <> :old_check_status) then begin

    if (:CHECK_STATUS >= 0) then exception BOOKING_EXCEPTION 'Can not set status ''CHECKED IN'' or ''CHECKED OUT'' manually!';

    execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, :check_status);

    execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
    returning_values  :warn_code;
  end
end
^

/* Alter (RES_SAVE_ROOM$EXC) */
ALTER PROCEDURE RES_SAVE_ROOM$EXC(RD_DBKEY CHAR(8),
ID_RES_ROOM_TYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(250),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_room integer;
begin
  select RD.ID_ROOM, RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_room, :id_reserv_detail;

  execute procedure RES_SAVE_ROOM$RSV(
    :id_reserv_detail,
    :old_id_room,
    :id_res_room_type,
    'nrttAsIs',
    1,
    :id_hk_plan,
    :room_features,
    :i_special_treatment,
    :split_on_checkin,
    0
  ) returning_values :share_err_code, :err_text, :share_transaction_id, :warn_code;
end
^

/* Alter (RES_TAR_CALC_FINALIZE$INT) */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(TAR_CALC_ERR INTEGER,
ID_TAR_CALC INTEGER,
RD_DBKEY_INIT CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
begin
  --  Razpiswa cenata na staia, kakto i price_detailite.

  if (:tar_calc_err = 0) then begin
    room_price = 0;
    room_price_details = '';

    execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

    for
      select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, rd.IS_POSTING_STOPPED,
             coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
             coalesce(max((select first 1 AP.IS_BASE
                           from   GUEST G
                                  join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                           where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                  and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (eventually)
      from   TAR_CALC_INPUT$TMP TI
             join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
             join TARIFA t on t.ID_TARIFA = rd.ID_RATE
      where  ti.ID_TAR_CALC = :ID_TAR_CALC
      group by 1, 2, 3, 4, 5, 6
      into   :id_reserv_detail, :check_status, :is_posting_stopped,
             :room_currency, :id_hotel, :is_anul, :has_postings
    do begin
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);

      if ( (not (:is_posting_stopped = 1 and :has_postings = 0))                                -- posting is not stopped
           and                                                                                  -- and
           ( (coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1) ) -- there are reasons to repost
         ) then
      begin

        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);

      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;

        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end

      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end else begin

    update RESERV_DETAIL RD
    set    RD.ROOM_PRICE = null,
           RD.ROOM_CURRENCY = null,
           RD.ROOM_PRICE_DETAILS = null,
           RD.LAST_ID_TAR_CALC = null
    where  RD.RDB$DB_KEY = :RD_DBKEY_INIT;
  end
  
  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;
end
^

/* Alter (RESGRP_DELETE$RSV) */
ALTER PROCEDURE RESGRP_DELETE$RSV(ID_GROUP INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable id_reserv_detail integer;
  declare variable tmp_warn_code integer;
begin

  for
    select RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
           left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = rd.ID_ROOM_TYPE
    where  RD.ID_GROUP = :id_group
    into   :id_reserv_detail
  do begin
    execute procedure RES_DELETE$INT(:id_reserv_detail, :REASON)
    returning_values :tmp_warn_code, :extra_posts_left;
    if (:warn_code is null) then WARN_CODE = :tmp_warn_code;
  end
end
^

/* Alter (RESMULTI_CREATE$RSV) */
ALTER PROCEDURE RESMULTI_CREATE$RSV(ID_HOTEL INTEGER,
ID_ROOM_TYPE INTEGER,
TRANSFER_OUT_TIME TIME,
TRANSFER_IN_TIME TIME,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
TRANSFER_OUT_NOTE VARCHAR(50),
TRANSFER_IN_NOTE VARCHAR(50),
NOTE VARCHAR(255),
ID_BOARD INTEGER,
VOUCHER_DATE DATE,
VOUCHER_NUMBER VARCHAR(20),
VOUCHER_TEXT VARCHAR(30),
CHECK_STATUS INTEGER,
ID_TARIFF INTEGER,
COUNTRY_CODE VARCHAR(20),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
NOTE_REMINDERS VARCHAR(50),
TITULAR_NAME VARCHAR(100),
SPLIT_ON_CHECKIN INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
NUMBER VARCHAR(62),
NEW_ID_TITULAR INTEGER,
NEW_FROM_DATE TYPE OF TDATE,
WARN_CODE TYPE OF TRANGE)
 AS
declare variable rd_dbkey char(8);
  declare variable id_person_profile integer;
  declare variable pd_dbkey char(8);
  declare variable id_acc_template_person integer;
  declare variable first_name varchar(30);
  declare variable surname varchar(30);
  declare variable family_name varchar(30);
begin

  select sv.SETTING_VALUE
  from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :ID_HOTEL) sv
  into   :id_acc_template_person;

  execute procedure RES_CREATE_SET$INT(:id_agent_profile, null, :check_status, :arrival_date, :departure_date,
                    :adult_count, :children_count, :id_room_type, null, :id_board, :id_tariff, null,
                    null, null, :voucher_number, :voucher_date, :voucher_text, '',
                    null, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    1, 0, 0, :country_code, :code_first_food, '',
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    '', :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders, null, null,
                    :split_on_checkin, null, null, :id_acc_template_person, null, null, :ID_EATING_OBJECT)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :WARN_CODE;

  select RD.NUMBER, RD.ID_PERSON_PROFILE, RD.ID_TITULAR
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :number, :id_person_profile, :new_id_titular;

  if (:titular_name <> '') then begin
    select PD.RDB$DB_KEY
    from   PROFILE P
           join PROFILE_PERSON PP on PP.ID_PROFILE = P.ID_PROFILE
           join PERSON_DATA PD on PD.ID_PERSON_DATA = PP.ID_PERSON_DATA
    where  P.ID_PROFILE = :id_person_profile
    into   :pd_dbkey;

    select PP.FIRST_NAME, PP.SURNAME, PP.FAMILY_NAME
    from   PERSON_NAME_PARSE$INT (:TITULAR_NAME) PP
    into   :first_name, :surname, :family_name;

    update PERSON_DATA PD
    set    PD.PERSON_NAME2 = :titular_name,
           PD.FIRST_NAME = :first_name,
           PD.SURNAME = :surname,
           PD.FAMILY_NAME = :family_name
    where  PD.RDB$DB_KEY = :pd_dbkey;
  end

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;
end
^

/* Alter (ROOM_SMART_LIST$RSV) */
ALTER PROCEDURE ROOM_SMART_LIST$RSV(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(50))
 RETURNS(ROOM_NAME VARCHAR(50),
FREE_BEDS_BASE INTEGER,
FREE_BEDS_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
FEATURES BLOB,
BUSY_GROUP_TYPE INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
DATA1 VARCHAR(255),
DATA2 VARCHAR(255))
 AS
declare variable report_leaving varchar(20);
declare variable suppress_private integer;
begin
  if (:from_date >= :to_date) then exit;
  execute procedure SYSTEM_CHECK_OPERATION(:report_type, 'FREE_ONLY,FREE_AND_LEAVING,BLOCKED,POTENTIAL_SHARE,PRIVATE_USE,ALL');

  suppress_private = iif(:REPORT_TYPE = 'ALL', 0, 1);
  if (:report_type in ('FREE_ONLY','FREE_AND_LEAVING')) then begin
    if (:report_type = 'FREE_AND_LEAVING') then report_leaving = 'AS_FREE';
    else report_leaving = 'AS_LEAVING';
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DBEFORE, SRLF.DAFTER, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_FREE$INT(:from_date, :to_date, :report_leaving, :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end else if (:report_type in ('BLOCKED','POTENTIAL_SHARE')) then begin
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DESCRIPTION, SRLF.PERIOD, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_SHARE$INT(:from_date, :to_date, :report_type, :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end else if (:report_type in ('ALL')) then begin
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DBEFORE, SRLF.DAFTER, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_FREE$INT(:from_date, :to_date, 'FREE_AND_LEAVING', :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;

    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DESCRIPTION, SRLF.PERIOD, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_SHARE$INT(:from_date, :to_date, 'POTENTIAL_SHARE', :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end
end
^

/* Alter (SAFE_OCCUPANCY_ANNUL) */
ALTER PROCEDURE SAFE_OCCUPANCY_ANNUL(ID_SAFE TYPE OF ID,
REASON TYPE OF TREASON)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_resource_reservation integer;
  declare variable from_datetime timestamp;
  declare variable to_datetime timestamp;
  declare variable action_text varchar(255);
  declare variable id_account_post integer;
begin
  select s.ID_CURRENT_OCCUPANCY, od.FROM_DATETIME, od.TO_DATETIME, rp.ID_ACCOUNNT_POST
  from   SAFE S
         join RESOURCE_RESERVATION rr on rr.ID_RESOURCE_RESERVATION = s.ID_CURRENT_OCCUPANCY
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESOURCE_RESERV_POST rp on rp.ID_RESOURCE_RESERVATION = rr.ID_RESOURCE_RESERVATION
  where  s.ID_SAFE = :ID_SAFE
  into   :id_resource_reservation, :from_datetime, :to_datetime, :id_account_post;

  execute procedure RESOURCE_RESERVATION_CANCEL (:id_resource_reservation, :REASON);

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = null
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:REASON, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_ANNUL', :action_text);

  execute procedure ACCOUNT_POSTING_ANUL (:id_account_post, :REASON);

  DOC_SELECTED = null;
  update ACCOUNT_POST AP
  set    ap.DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1)
  where  ap.ID_ACCOUNT_POST = :id_account_post
         and ap.ac = '00'
  returning new.doc_selected
  into   :DOC_SELECTED;

end
^

/* empty dependent procedure body */
/* Clear: SAFE_CHECK_OUT for: SAFE_OCCUPANCY_MODIFY */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE /* TYPE OF ID */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER,
WARN_CODE /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SAFE_OCCUPANCY_MODIFY) */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE TYPE OF ID,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable old_booking_number tres_number;
  declare variable id_resource_reservation id_ref;
  declare variable from_datetime tdatetime;
  declare variable action_text tdescription_long;
  declare variable old_occupant varchar(100);
  declare variable old_to_dt timestamp;
  declare variable id_reserv_detail integer;
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation;

  select rr.BOOKING_NUMBER, od.FROM_DATETIME,
         RR.OCCUPANT_NAME, od.TO_DATETIME, rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESERV_DETAIL rd on rd.NUMBER = rr.BOOKING_NUMBER and rd.IS_ANUL = 0
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :old_booking_number, :from_datetime,
         :old_occupant, :old_to_dt, :id_reserv_detail, :id_agent_profile;

  --if (:old_booking_number <> :BOOKING_NUMBER) then exception ASSERT 'Can not change booking number!';
  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  update SAFE_RESOURCE_RESERV rr
  set    rr.PRICE_DESCRIPTION = :price_description,
         rr.ID_RATE_PRICE_PROFILE = :id_agent_profile,
         rr.RATING_UNITS = :rating_units,
         rr.RATE_PRICE = :price,
         rr.RATE_CURR = :currency
  where  rr.ID_RESOURCE_RESERV = :id_resource_reservation;

  execute procedure RESOURCE_RESERVATION_MODIFY (:id_resource_reservation, :ID_SAFE, :from_datetime,
          :TO_DATETIME, :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :old_booking_number, 'mod')
  returning_values :id_resource_reservation, :no_use;

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail)
  returning_values (:DOC_SELECTED);

  /* Log changes */
  if ((:old_occupant <> :OCCUPANT_NAME) or (:old_to_dt <> :TO_DATETIME)) then begin
    action_text = f_character(29) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                  || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                  || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');
  
    execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_CHANGED', :action_text);
  end
end
^

/* Alter (SAFE_OCCUPANCY_NEW) */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE TYPE OF ID,
FROM_DATETIME TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME,
BOOKING_NUMBER TYPE OF TRES_NUMBER,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
ID_RESOURCE_RESERVATION TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable action_text tdescription_long;
  declare variable id_reserv_detail integer;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, s.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  if (:id_resource_reservation is not null) then exception ASSERT '-1064'|| f_character(31) || f_character(29) || :safe_name;

  select rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESERV_DETAIL rd
  where  rd.NUMBER = :BOOKING_NUMBER
         and rd.IS_ANUL = 0
  into   :id_reserv_detail, :id_agent_profile;

  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  execute procedure  RESOURCE_RESERVATION_MODIFY (null, :ID_SAFE, :FROM_DATETIME, :TO_DATETIME,
          :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :BOOKING_NUMBER, 'add')
  returning_values (:id_resource_reservation, :no_use) ;

  insert into SAFE_RESOURCE_RESERV (ID_RESOURCE_RESERV, PRICE_DESCRIPTION, ID_RATE_PRICE_PROFILE,
         RATING_UNITS, RATE_PRICE, RATE_CURR)
  values (:id_resource_reservation, :price_description, :id_agent_profile,
         :rating_units, :price, :currency);

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail, :ID_EXTERNAL_CLIENT_ACCCOUNT)
  returning_values (:DOC_SELECTED);

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = 'CHECKED_IN'
  where  RR.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = :id_resource_reservation
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                || f_character(28) || coalesce(:BOOKING_NUMBER, '')
                || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUPIED', :action_text);
end
^

/* Alter (SUMMARY_FORECAST$INT) */
ALTER PROCEDURE SUMMARY_FORECAST$INT(ID_HOTEL INTEGER,
SUMMARY_DATE DATE)
 AS
declare variable to_date date;
begin
  select max(rm.busy_date)
  from   ROOM_MAGIC rm
  where  rm.id_hotel = :id_hotel
  into   :to_date;
  to_date = maxdate(:TO_DATE, :SUMMARY_DATE + 1);

  execute procedure AVAILABILITY_OCCUP_PREPARE$AVL (:SUMMARY_DATE + 1, :TO_DATE, 1, 1, 0, 1, 1, 1, 1, 1, :ID_HOTEL);

  insert into SUMMARY_FORECAST (
         summary_date, forecast_date, id_room_type, id_hotel,
         rooms_capacity, rooms_ooi, res_confirmed, res_notconfirmed, res_waiting,
         res_checked_in, cont_remain, bp_remain)
  select :summary_date, tso.for_date, tso.id_room_type, tso.ID_HOTEL,
         sum(tso.g_capacity), sum(tso.g_ooi), sum(tso.res_confirmed), sum(tso.res_notconfirmed), sum(tso.res_waiting),
         sum(tso.sold), sum(tso.cont_plain_remain), sum(tso.cont_bp_remain)
  from   SMART_OCCUP$TMP tso
  where  tso.ID_HOTEL = :ID_HOTEL
  group by 2, 3, 4;

  delete
  from   SUMMARY_FORECAST sf
  where  sf.summary_date = sf.forecast_date
         and sf.ID_HOTEL = :ID_HOTEL;

  insert into SUMMARY_FORECAST (
         summary_date, forecast_date, id_room_type, id_hotel,
         rooms_capacity, rooms_ooi, res_confirmed, res_notconfirmed, res_waiting,
         res_checked_in, cont_remain, bp_remain)
  select so.for_date, so.for_date, so.id_room_type, so.id_hotel,
         sum(so.rooms_available), sum(so.rooms_ooi), 0, 0, 0,
         sum(so.rooms_sold), 0, 0
  from   SUMMARY_OCCUPANCY so
  where  so.ID_HOTEL = :ID_HOTEL
         and so.for_date <= :summary_date
  group by 1, 2, 3, 4;

end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_EVAL_DATE$INT for: TAR_CALC_EVAL_COMPLEX_RATE$INT */
ALTER PROCEDURE TAR_CALC_EVAL_DATE$INT(ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
FOR_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_EVAL_COMPLEX_RATE$INT) */
ALTER PROCEDURE TAR_CALC_EVAL_COMPLEX_RATE$INT(INPUT_DETAIL_DBKEY CHAR(8),
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
BEDS SMALLINT,
ID_TYPE_STAY INTEGER,
IS_MANUAL_TYPE_STAY SMALLINT,
ID_BOARD INTEGER,
ID_ROOM_TYPE INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
CHECKIN_DATE DATE,
DAY_OF_STAY INTEGER,
PAYORS INTEGER,
MINORS INTEGER,
PERIOD_DEPEND_ON_CHECKIN SMALLINT,
CNT_DAYS_BP INTEGER,
CNT_DAYS_BOARD INTEGER,
BOARD_TYPE_FIND VARCHAR(10),
TOTAL_GUESTS INTEGER,
SEQ_NUM INTEGER,
TARIFF_CURR CHAR(3),
REAL_RECALC SMALLINT)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_PAYORS INTEGER,
OUT_MINORS INTEGER)
 AS
declare variable id_tar_input_detail integer;
  declare variable price numeric(15,4);
  declare variable auto_stay_type integer;
  declare variable base_per_day numeric(15,4);
  declare variable board_per_day numeric(15,4);
  declare variable guest_board_weight integer;
--  declare variable guest_food varchar(20);
  declare variable match_date date;
  declare variable manual_total_gsts integer;
  declare variable manual_payors integer;
  declare variable manual_minors integer;
  declare variable service_type varchar(20);
  declare variable base_price numeric(15,4);
  declare variable board_price numeric(15,4);
  declare variable food_per_day numeric(15,4);
  declare variable base_price_tar numeric(15,4);
  declare variable custom_cross_rate double precision;
  declare variable ptext varchar(20);
  declare variable id_service integer;
  declare variable qty_post integer;
  declare variable pack_currency char(3);
  declare variable minors_input integer;
  declare variable packet_item integer;
  declare variable price_tariff numeric(15,4);
  declare variable is_inside_base integer;
  declare variable id_bo_bp integer;
  declare variable id_board_include integer;
  declare variable separate_board integer;
  declare variable incomplete_bp integer;
  declare variable id_bo_eg integer;
  declare variable id_eg_price integer;
  declare variable disc_tag varchar(50);
  declare variable id_discount_service integer;
  declare variable var_board_price numeric(15,4);
  declare variable type_stay_code varchar(10);
begin
  base_per_day = 0;
  board_per_day = 0;

  select TH.WEIGHT_TAG
  from   MEALS TH
  where  TH.ID_BOARD = :ID_BOARD
  into   :guest_board_weight;
  guest_board_weight = coalesce(:guest_board_weight, 0);

  /*if (:guest_board_weight = 0) then GUEST_FOOD = 'NONE';
  else GUEST_FOOD = 'SOME';*/
  if (:PERIOD_DEPEND_ON_CHECKIN = 1) then MATCH_DATE = :CHECKIN_DATE;
  else MATCH_DATE = :FOR_DATE;

  select st.TYPE_STAY_CODE
  from   TYPE_STAY st
  where  st.ID_TYPE_STAY = :id_type_stay
  into   :type_stay_code;

  if (:IS_MANUAL_TYPE_STAY = 1) then begin
    if (:type_stay_code = 'ALONE') then begin
      MANUAL_TOTAL_GSTS = 1;
      MANUAL_PAYORS = 0;
      MANUAL_MINORS = 0;
    end else if (:type_stay_code = 'BED') then begin
      MANUAL_TOTAL_GSTS = 2;
      MANUAL_PAYORS = 1;
      MANUAL_MINORS = 0;
    end else if (:type_stay_code = 'EXTRA_BED') then begin
      MANUAL_TOTAL_GSTS = :BEDS+1;
      MANUAL_PAYORS = :BEDS;
      MANUAL_MINORS = :MINORS;
    end

    execute procedure TAR_MATCH_BP(:INPUT_DETAIL_DBKEY, :MATCH_DATE, :MANUAL_TOTAL_GSTS, :MANUAL_TOTAL_GSTS,
                      :GUEST_BOARD_WEIGHT, :REAL_RECALC, :DAY_OF_STAY, :CNT_DAYS_BP)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_BP, :ID_BOARD_INCLUDE,
                      :INCOMPLETE_BP, :BASE_PRICE, :PTEXT, :BASE_PER_DAY;
  end else begin
    execute procedure TAR_MATCH_BP(:INPUT_DETAIL_DBKEY, :MATCH_DATE, :SEQ_NUM, :TOTAL_GUESTS,
                      :GUEST_BOARD_WEIGHT, :REAL_RECALC, :DAY_OF_STAY, :CNT_DAYS_BP)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_BP, :ID_BOARD_INCLUDE,
                      :INCOMPLETE_BP, :BASE_PRICE, :PTEXT, :BASE_PER_DAY;
  end

  execute procedure sys_dbg('tar base_per_day = '||coalesce(:BASE_PER_DAY, 'null'));
  execute procedure sys_dbg('tar base_price = '||coalesce(:BASE_PRICE, 'null'));
  if (:ERR_CODE < 0) then exit;

  SEPARATE_BOARD = 0;
  if (:REAL_RECALC = 1) then begin
    if (:CUSTOM_PRICE is not null) then begin
      base_price = :CUSTOM_PRICE;
      execute procedure CURR_CROSS_RATE_GET(:CUSTOM_CURRENCY, :TARIFF_CURR, current_timestamp, 1)
      returning_values  :custom_cross_rate;
      base_price_tar = (:custom_cross_rate * :base_price);
      pack_currency = :custom_currency;
    end else begin
      base_price_tar = :base_per_day;
      pack_currency = :tariff_curr;
    end
    /*DEBUG*/
    if (:base_price is null) then exception RATING_EXCEPTION ('4. base price is null');
    if (:base_price_tar is null) then exception RATING_EXCEPTION ('5. base price tar is null');

    select TBP.PACKET_ITEM
    from   TAR_BO_BASE_POSITION TBP
    where  TBP.ID_TAR_BP = :id_bo_bp
    into   :packet_item;

    insert into TAR_CALC_OUTPUT$TMP (
           ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
           FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
           CURRENCY, CURRENCY_TARIFF, REQUIRED_ID_PACKET_ITEM)
    values (:ID_TAR_INPUT, :ID_TAR_CALC, -1, 'BASE',
           :FOR_DATE, :BASE_PER_DAY, :BASE_PRICE_TAR, 'BASE', 1, :PTEXT,
           :PACK_CURRENCY, :TARIFF_CURR, :packet_item);
    /* BOARDS */
    var_board_price = 0;
    for
      select TMB.ERR_CODE, TMB.ERR_TEXT, TMB.SEPARATE_BOARD, TMB.BOARD_PRICE, TMB.PTEXT,
             TMB.SERVICE_TYPE, TMB.ID_SERVICE, TMB.FOOD_PER_DAY, TMB.PACKET_ITEM
      from   TAR_MATCH_BOARD(:INPUT_DETAIL_DBKEY, :id_bo_bp, :BOARD_TYPE_FIND,
             :ID_BOARD, :id_board_include, :match_date, :base_per_day,
             :DAY_OF_STAY, :CNT_DAYS_BOARD, :CNT_DAYS_BP, :CUSTOM_PRICE) TMB
      into   :err_code, :err_text, :separate_board, :board_price, :ptext,
             :service_type, :id_service, :food_per_day, :packet_item
    do begin
      if (:ERR_CODE < 0) then exit;

      /*DEBUG*/
      if (:board_price is null) then exception RATING_EXCEPTION ('6. board_price is null');
      if (:id_service is null) then exception RATING_EXCEPTION ('7. id_service is null');

      insert into TAR_CALC_OUTPUT$TMP (
             ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
             FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
             CURRENCY, CURRENCY_TARIFF, REQUIRED_ID_PACKET_ITEM)
      values (:ID_TAR_INPUT, :ID_TAR_CALC, :ID_SERVICE, :SERVICE_TYPE,
             :FOR_DATE, :food_per_day, :food_per_day, 'FOOD', 1, :PTEXT,
             :TARIFF_CURR, :TARIFF_CURR, :packet_item);

      -- board_per_day = (:board_per_day + :food_per_day); ???
      var_board_price = :var_board_price + iif(:service_type in ('BASE_BOARD', 'EXTRA_BOARD'), :food_per_day, 0);
    end

    select TID.ID_TAR_INPUT_DETAIL
    from   TAR_CALC_INPUT_DETAIL$TMP TID
    where  tid.RDB$DB_KEY = :INPUT_DETAIL_DBKEY
    into   :id_tar_input_detail;

    execute procedure TAR_SET_VAR('board='||:VAR_BOARD_PRICE, :id_tar_input_detail, :id_tar_calc);
  end

  if (:SEPARATE_BOARD is null) then SEPARATE_BOARD = 0;
  minors_input = :MINORS;

  if (:IS_MANUAL_TYPE_STAY = 1) then begin
    /* ONLY TO FIND THE REAL POSITION PAYORS, MINORS ARE NOT IMPORTANT
    || ALL OTHER GUESTS IN THE ROOM MUST SEE THE MANUAL ONE AS AUTOMATIC. SO
    || HERE WE ARE FINDING HIS AUTOMATIC TYPE STAY.
    */
    execute procedure TAR_MATCH_EG(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :total_guests, :PAYORS, :MINORS, :MATCH_DATE, :INCOMPLETE_BP, :ID_ROOM_TYPE, 1)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_EG, :ID_EG_PRICE, :PAYORS, :MINORS, :AUTO_STAY_TYPE;
    if (:ERR_CODE < 0) then exit;
    /* REAL PRICE FIND AND EVAL */
    execute procedure TAR_MATCH_MANUAL_EG(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :MANUAL_TOTAL_GSTS, :MANUAL_PAYORS, :MANUAL_MINORS, :MATCH_DATE, :INCOMPLETE_BP, :ID_TYPE_STAY)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_EG, :ID_EG_PRICE, :AUTO_STAY_TYPE;
    if (:ERR_CODE < 0) then exit;

    if ((:MINORS = :minors_input) and
        (exists (select *
                 from   TYPE_STAY TS
                 where  TS.ID_TYPE_STAY = :ID_TYPE_STAY
                        and TS.TYPE_STAY_CODE = 'EXTRA_BED'))) then begin
      /* TO MANAGE PARAMETER "EXTRA GUEST IN TURN" WHEN MANUAL SET TO ADD */
      MINORS = :MINORS + 1;
      PAYORS = :PAYORS - 1;
    end
  end else begin
    execute procedure TAR_MATCH_EG(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :TOTAL_GUESTS, :PAYORS, :MINORS, :MATCH_DATE, :INCOMPLETE_BP, :ID_ROOM_TYPE, 0)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_EG, :ID_EG_PRICE, :PAYORS, :MINORS, :AUTO_STAY_TYPE;
    if (:ERR_CODE < 0) then exit;
  end

  update TAR_CALC_INPUT_DETAIL$TMP TID
  set    TID.SEPARATE_BOARD = :SEPARATE_BOARD,
         TID.ID_TYPE_STAY   = :AUTO_STAY_TYPE
  where  TID.RDB$DB_KEY = :INPUT_DETAIL_DBKEY;

  if (:REAL_RECALC = 1) then begin
    if (:CUSTOM_PRICE is null) then begin
      for
        select TSP.SERVICE_TYPE, TSP.PRICE,  TSP.PTEXT, TSP.ERR_CODE, TSP.ID_SERVICE
        from   TAR_PRICES_SET_EG(:ID_TAR_INPUT, :FOR_DATE, :DAY_OF_STAY, :CNT_DAYS_BP,
               :CNT_DAYS_BOARD, :guest_board_weight, :id_bo_eg, :id_eg_price, :base_price) TSP
        into   :service_type, :price,  :ptext, :ERR_CODE, :id_service
      do begin
        if (:ERR_CODE < 0) then exit; -- exception INTERNAL_RATING_EXCEPTION;

        /*DEBUG*/
        if (:PRICE is null) then exception RATING_EXCEPTION ('8. price is null');
        if (:ID_SERVICE is null) then exception RATING_EXCEPTION ('9. id_service is null');

        insert into TAR_CALC_OUTPUT$TMP (
               ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
               FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
               CURRENCY, CURRENCY_TARIFF, REQUIRED_ID_PACKET_ITEM)
        values (:ID_TAR_INPUT, :ID_TAR_CALC, :id_service, :service_type,
               :FOR_DATE, :price, :price, 'EG', 1, :ptext,
               :TARIFF_CURR, :TARIFF_CURR, :packet_item);
      end
    end

    for
      select TMT.ID_SERVICE, TMT.SERVICE_TYPE, TMT.PRICE, TMT.PRICE_TARIFF, TMT.QTY_POST,
             TMT.PTEXT, TMT.PACK_CURRENCY, TMT.ERR_CODE, TMT.ERR_TEXT, TMT.PACKET_ITEM, TMT.DISC_TAG
      from   TAR_PRICES_SET_PACKS(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :DAY_OF_STAY, :CUSTOM_PRICE) TMT
      into   :ID_SERVICE, :SERVICE_TYPE, :PRICE, :PRICE_TARIFF, :QTY_POST,
             :PTEXT, :PACK_CURRENCY, :ERR_CODE, :ERR_TEXT, :PACKET_ITEM, :DISC_TAG
    do begin
      if (:ERR_CODE < 0) then exit; --exception INTERNAL_RATING_EXCEPTION;
      /*DEBUG*/
      if (:price_tariff is null) then exception RATING_EXCEPTION ('10. PRICE_TARIFF is null');
      if (:id_service is null) then exception RATING_EXCEPTION ('11. ID_SERVICE is null');

      insert into TAR_CALC_OUTPUT$TMP (
             ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
             FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
             CURRENCY, CURRENCY_TARIFF, DISC_TAG, REQUIRED_ID_PACKET_ITEM)
      values (:ID_TAR_INPUT, :ID_TAR_CALC, :ID_SERVICE, :SERVICE_TYPE,
             :FOR_DATE, :PRICE, :PRICE_TARIFF, 'PACK', :QTY_POST, :PTEXT,
             :PACK_CURRENCY, :TARIFF_CURR, :DISC_TAG, :packet_item);

    end

    for
      select TMT.ID_SERVICE, TMT.SERVICE_TYPE, TMT.PRICE, TMT.PTEXT, TMT.ERR_CODE, TMT.ERR_TEXT, TMT.PACKET_ITEM,
             TMT.IS_INSIDE_BASE, TMT.DISC_TAG, TMT.ID_DISCOUNT_SERVICE
      from   TAR_PRICES_SET_TAX(:ID_TAR_INPUT, :INPUT_DETAIL_DBKEY, :ID_BO_BP, :DAY_OF_STAY) tmt
      into   :ID_SERVICE, :SERVICE_TYPE, :PRICE, :PTEXT, :ERR_CODE, :ERR_TEXT, :PACKET_ITEM,
             :IS_INSIDE_BASE, :DISC_TAG, :ID_DISCOUNT_SERVICE
    do begin
      if (:ERR_CODE < 0) then exit; --exception INTERNAL_RATING_EXCEPTION;
      if ((:IS_INSIDE_BASE = 0) and (:CUSTOM_PRICE is not null)) then begin
        -- SKIP IT. SIMPLE DISCOUNTS MUST NOT CHANGE THE CUSTOM PRICE
      end else begin
        /*DEBUG*/
        if (:PRICE is null) then exception RATING_EXCEPTION ('12. price is null');
        if (:ID_SERVICE is null) then exception RATING_EXCEPTION ('13. id_service is null');
        -- !!! Service type and id_service of discount is as object that they discounting but in TAR_CALC_REPOST$INT type and id_service is changed to PACKAGES if discounts have ID_DISCOUNT_SERVICE
        if ((:DISC_TAG = '') or (:DISC_TAG is null)) then DISC_TAG =  'DISC';
        insert into TAR_CALC_OUTPUT$TMP (
               ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
               FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
               CURRENCY, CURRENCY_TARIFF, DISC_TAG, ID_DISCOUNT_SERVICE, REQUIRED_ID_PACKET_ITEM)
        values (:ID_TAR_INPUT, :ID_TAR_CALC, :ID_SERVICE, :SERVICE_TYPE,
               :FOR_DATE, :PRICE, :PRICE, 'DISC', 1, :PTEXT,
               :TARIFF_CURR, :TARIFF_CURR, :DISC_TAG, :id_discount_service, :packet_item);

        execute procedure sys_dbg('tar TAR_CALC_EVAL_DATE$INT - :DISC_TAG=' || coalesce(:DISC_TAG, 'null') );
      end
    end
  end

  OUT_MINORS = :MINORS;
  OUT_PAYORS = :PAYORS;
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_EVAL_ALL$INT for: TAR_CALC_EVAL_DATE$INT */
ALTER PROCEDURE TAR_CALC_EVAL_ALL$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_EVAL_DATE$INT) */
ALTER PROCEDURE TAR_CALC_EVAL_DATE$INT(ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
FOR_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_input integer;
declare variable checkin_date date;
declare variable day_of_stay integer;
declare variable real_recalc integer;
declare variable id_guest integer;
declare variable input_detail_dbkey char(8);
declare variable id_room_type integer;
declare variable id_board integer;
declare variable id_tar_head integer;
declare variable id_type_stay integer;
declare variable id_hotel integer;
declare variable period_depend_on_checkin integer;
declare variable cnt_days_board integer;
declare variable cnt_days_bp integer;
declare variable tariff_curr char(3);
declare variable board_type_find varchar(10);
declare variable id_room integer;
declare variable custom_price numeric(15,4);
declare variable custom_currency char(3);
declare variable id_tar_input_detail integer;
declare variable is_simple integer;
declare variable guest_age integer;
declare variable tar_name varchar(50);
declare variable guest_name varchar(50);
declare variable total_guests integer;
declare variable old_id_room integer;
declare variable beds integer;
declare variable payors integer;
declare variable minors integer;
declare variable int_err_text varchar(255);
declare variable is_manual_type_stay smallint;
declare variable seq_num integer;
declare variable current_child_num integer;
declare variable current_adult_num integer;
begin
  ERR_CODE = 0;
  OLD_ID_ROOM = NULL;
  for
    select   TCI.ID_TAR_INPUT, TCI.FROM_DATE, (:FOR_DATE - TCI.FROM_DATE + 1),
             TCI.REAL_RECALC, TCI.ID_GUEST, TCID.RDB$DB_KEY, TCID.ID_ROOM_TYPE,
             TCID.ID_BOARD, TCID.ID_TAR_HEAD, TCID.ID_TYPE_STAY, TCID.IS_MANUAL_TYPE_STAY, T.ID_HOTEL,
             TH.PERIOD_DEPEND_ON_CHECKIN, TH.CNT_DAYS_PRICE_BOARD, TH.CNT_DAYS_PRICE_BP, T.CURR, TH.BOARD_TYPE,
             TCID.ID_ROOM, TCID.CUSTOM_PRICE, TCID.CUSTOM_CURRENCY,
             TCID.ID_TAR_INPUT_DETAIL, TH.IS_SIMPLE, TCI.GUEST_AGE
    from     TAR_CALC_INPUT_DETAIL$TMP TCID
             join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
             join TAR_HEAD TH on TH.ID_TAR_HEAD = TCID.ID_TAR_HEAD
             join TARIFA T on T.ID_TARIFA = TH.ID_TAR_HEAD
    where    TCI.ID_TAR_CALC = :ID_TAR_CALC
             and TCI.ROOM_STATUS = :ROOM_STATUS
             and TCID.FOR_DATE = :FOR_DATE
    order by TCID.ID_ROOM asc,
             iif(TCI.GUEST_AGE > 16, 999, TCI.GUEST_AGE) desc,
             TCID.CHECKIN_ORDER asc,
             TCI.ID_GUEST asc
             /* ADULTS MUST BE HANDLED FIRST, THEN BY CHECKIN ORDER and ID_GUEST because of shares */
    into     :id_tar_input, :checkin_date, :day_of_stay,
             :real_recalc, :id_guest, :input_detail_dbkey, :id_room_type,
             :id_board, :id_tar_head, :id_type_stay, :is_manual_type_stay, :id_hotel,
             :period_depend_on_checkin, :cnt_days_board, :cnt_days_bp, :tariff_curr, :board_type_find,
             :id_room, :custom_price, :custom_currency,
             :id_tar_input_detail, :is_simple, :guest_age

  do begin
    if (coalesce(:id_room_type, -1) < 0) then exception RATING_EXCEPTION 'Unspecified room type!';
    if (coalesce(:id_type_stay, -1) < 0) then exception RATING_EXCEPTION 'Unspecified type stay!';
    --if (coalesce(:id_board, -1) < 0) then exception ASSERT 'Unspecified board!';
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    /* - - - - - PART 1 - For Both Simple and Complex Rates - */
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    select count(*)
    from   TAR_CALC_INPUT_DETAIL$TMP TCID
           join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
    where  TCI.ID_TAR_CALC = :ID_TAR_CALC
           and TCID.FOR_DATE = :FOR_DATE
           and TCID.ID_ROOM = :ID_ROOM
    into   :TOTAL_GUESTS;

    if (:TOTAL_GUESTS = 0) then exit;
  
    select RT.BEDS
    from   ROOM_TYPES RT
    where  RT.ID_ROOM_TYPE = :ID_ROOM_TYPE
    into   :BEDS;

    if (:IS_SIMPLE = 1) then begin
      /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
      /* - - - - - - - PART 2 - Simple Rates - - - - - - - - -  */
      /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
      if (:old_id_room is distinct from :id_room) then begin
        current_adult_num = 0;
        current_child_num = 0;
        old_id_room = :id_room;
      end

      execute procedure TAR_CALC_EVAL_SIMPLE_RATE$INT (:id_tar_input_detail, :id_tar_input, :ID_TAR_CALC,
              :FOR_DATE, :id_tar_head, :beds, :guest_age, :id_type_stay, :is_manual_type_stay, :id_board, :id_room_type,
              :custom_price, :custom_currency, :id_hotel, :total_guests, :current_adult_num, :current_child_num)
      returning_values (:ERR_CODE, :int_err_text, :current_adult_num, :current_child_num);
      if (:ERR_CODE < 0) then exception INTERNAL_RATING_EXCEPTION;

    end else begin
      /* - - -  - - - - - - - - - - - -  - - - - - - - - */
      /* - - -  - PART 3 - Complex Rates - - - - - - - - */
      /* - - -  - - - - - - - - - - - -  - - - - - - - - */
      if (:old_id_room is distinct from :id_room) then begin
        payors  = 0;
        minors  = 0;
        old_id_room = :id_room;
        seq_num = 0;
      end
      seq_num = :seq_num + 1;

      execute procedure TAR_CALC_EVAL_COMPLEX_RATE$INT (:input_detail_dbkey, :id_tar_input, :ID_TAR_CALC,
              :FOR_DATE, :beds, :id_type_stay, :is_manual_type_stay, :id_board, :id_room_type, :custom_price, :custom_currency,
              :checkin_date, :day_of_stay, :payors, :minors, :period_depend_on_checkin, :cnt_days_bp, :cnt_days_board,
              :board_type_find, :total_guests, :seq_num, :tariff_curr, :real_recalc)
      returning_values (:ERR_CODE, :int_err_text, :payors, :minors);
      if (:ERR_CODE < 0) then exception INTERNAL_RATING_EXCEPTION;
    end
  /* - --- - END PART 3 - complex Rates*/
  end

  when exception INTERNAL_RATING_EXCEPTION do begin
    if (coalesce(:ERR_CODE, 0) = 0) then ERR_CODE = -211;
    select TH.TARIFA_NAME
    from   TARIFA TH
    where  TH.ID_TARIFA = :ID_TAR_HEAD
    into   :TAR_NAME;

    select GC.GUEST_NAME1
    from   GUEST_CARD GC
    where  GC.ID_GUEST = :ID_GUEST
    into   :GUEST_NAME;
    ERR_TEXT = substring('GUEST='||cast(:ID_GUEST as varchar(20))||'-'||:GUEST_NAME||f_crlf()
                         || 'DATE='||:FOR_DATE||f_crlf()
                         || 'TARIFF='||:TAR_NAME||f_crlf()
                         || :int_err_text
                        from 1 for 255);

    exit;
  end
end
^

/* Alter (TAR_CALC_EVAL_PERIOD$INT) */
ALTER PROCEDURE TAR_CALC_EVAL_PERIOD$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_input integer;
  declare variable int_err_text varchar(255);
  declare variable disc_tag varchar(50);
  declare variable deduction_date date;
  declare variable service_type varchar(20);
  declare variable id_service integer;
  declare variable price numeric(15, 4);
  declare variable ptext varchar(20);
  declare variable tariff_curr char(3);
begin
  err_code = 0;
  for
    select TMT.ID_SERVICE, TMT.SERVICE_TYPE, TMT.PRICE, TMT.PTEXT, TMT.ERR_CODE, TMT.ERR_TEXT,
           TMT.ID_TAR_INPUT, TMT.TARIFF_CURR, TMT.DEDUCTION_DATE, TMT.DISC_TAG
    from   TAR_PRICES_SET_TAX_PERIOD(:id_tar_calc) TMT
    into   :id_service, :service_type, :price, :ptext, :err_code, :int_err_text,
           :id_tar_input, :tariff_curr, :deduction_date, :disc_tag
  do begin
    if (:err_code < 0) then begin err_text = substring(err_text||:int_err_text from 1 for 255); exit; end
    insert into TAR_CALC_OUTPUT$TMP (
           ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE, DISC_TAG, PRICE_NOTE,
           FOR_DATE, PRICE, PRICE_TARIFF, QTY_POST, PTEXT, CURRENCY, CURRENCY_TARIFF)
    values (:id_tar_input, :id_tar_calc, :id_service, :service_type, :disc_tag, 'DISC_STAY',
           :deduction_date, :price, :price, 1, :ptext, :tariff_curr, :tariff_curr);
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_INPUT_PARAMS$INT for: TAR_CALC_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_PARAMS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_PARAMS$INT) */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
declare variable param_code varchar(40);
  declare variable id_param integer;
  declare variable param_value varchar(255);
  declare variable data_type  varchar(30);
  declare variable rate_list varchar(2000);
begin
  err_code = 0;
  param_values = '';

  if (coalesce(:rate_list_replace, '') = '') then rate_list = ',' || :id_rate || ',';
  else rate_list = :rate_list_replace;

  for
    select distinct TBP.PARAM_NAME
    from   SYSTEM_STRING_PARSER (:rate_list, ',') sp
           left join TAR_BO_PARAMS TBP on TBP.ID_TAR_HEAD = sp.ITEM
    where  (TBP.PARAM_TYPE <> 'DATE_DEPENDANT' and :for_date is null)
           or (TBP.PARAM_TYPE = 'DATE_DEPENDANT' and :for_date is not null)
    into   :param_code
  do begin
    if (:param_code is not null) then begin
      id_param = null;
      select TP.ID_TARIFA_PARAM, TP.DATA_TYPE
      from   TARIFA_PARAMS TP
      where  TP.PARAM_CODE = :param_code
             and tp.IS_USE = 1
      into   :id_param, :data_type;
  
      if (:id_param is null) then begin
        err_code = -202;
        execute procedure sys_dbg ('tar calc params err_code: ' || :err_code || F_CRLF() || 'PARAM_CODE = ' || :param_code);
        exit;
      end
  
      execute procedure TARIFA_GET_PARAM (:id_param, :for_date, :id_tar_input, :id_tar_calc)
      returning_values (:param_value);
  
      param_code = ':'||param_code;
  
      if ((:param_code is not null) and (:param_code is not null) and (:data_type is not null)) then
         param_values = :param_values||';'||:param_code||','||:data_type||','||:param_value;
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE for: TAR_SAVE_BO_BOARD */
ALTER PROCEDURE TAR_SAVE(ID_TAR_HEAD INTEGER,
PERIOD_DEPEND_ON_CHECKIN INTEGER,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BASE_BOARDS_LIST VARCHAR(255),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
BO_TYPE VARCHAR(20),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_SAVE_BO_BOARD) */
ALTER PROCEDURE TAR_SAVE_BO_BOARD(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable id_tar_season integer;
  declare variable iteration varchar(20);
/*****************************************************/
  declare variable id_tar_board integer;
  declare variable id_board integer;
  declare variable id_service integer;
  declare variable pos_numbers varchar(2000);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable separate_board integer;
  declare variable id_bo_price integer;
  declare variable price_type varchar(20);
  declare variable price_type_equal_exists integer;
  declare variable is_board integer;
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  err_text = '';
  iteration = 'FIRST';
  price_type_equal_exists = 0;

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :id_tar_season, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_board, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
      if (:price_type_equal_exists = 1) then begin
        if (exists(
          select *
          from   TAR_BO_RELATION TBR
                 join TAR_BO_BASE_POSITION TBB on TBR.ID_TAR_BP = TBB.ID_TAR_BP
          where  TBR.ID_BO = :id_tar_board
                 and TBR.BO_TYPE = 'BOARD'
                 and TBB.ID_BOARD_INCLUDE is not distinct from :id_board
        )) then begin
          err_code = -237;
          exit;
        end
      end
      price_type_equal_exists = 0;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_board = gen_id(GEN_TAR_BO_BOARD_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers = '';
      id_board = null;
      separate_board = 0;
      ptext = '';
      disc_tag = 'F';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      packet_item = null;
    end
    if (:iteration = 'MIDDLE') then begin
      if (:param_name = 'PTEXT') then ptext = :data;
      else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
      else if (:param_name = 'SET_VAR')       then set_var = :data;
      else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
      else if (:param_name = 'LIST_BASE_POS') then pos_numbers = :data;
      else if (:param_name = 'SEPARATE_BOARD') then begin
        separate_board = :data;
        if ((:separate_board = 0) and (:board_type = 'HRANI')) then err_code = -226;
      end else if (:param_name = 'CHECKIN_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'NIGHT_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'PACKET_ITEM') then begin
        packet_item = :data;
      end else if (:param_name = 'HRANI') then begin
        if (:data = -1) then err_code = -210;
        else begin
          id_service = :data;
          select m.IS_BOARD
          from   MEALS M
          where  M.ID_SERVICE = :id_service
          into   :is_board;
          id_board = :id_service;

          if ((:is_board = 1) and (:board_type = 'HRANI')) then err_code = -228;
          else if ((:is_board = 0) and (:board_type = 'BOARD')) then err_code = -229;
        end
      end
      if (:err_code < 0) then exit;
      if ((:id_tar_season <> -1) and (:iteration = 'MIDDLE')) then begin
        /* WE ARE STARTING THE SEASON PRICES SO: */
        if ((:id_board is null) or (:id_board = -1)) then err_code = -210;
        else if ((:separate_board = 0) and (:board_type = 'HRANI')) then err_code = -226;
        if (:err_code < 0) then exit;
        if ((:separate_board = 1) and (:board_type = 'HRANI')) then separate_board = 2;
        insert into TAR_BO_BOARD(ID_TAR_BOARD, ID_TAR_HEAD, ID_SERVICE, ID_BOARD, PTEXT, SEPARATE_BOARD,
                    PACKET_ITEM, DISC_TAG, SET_VAR, RND_METHOD)
        values (:id_tar_board, :id_tar_head, :id_service, :id_board, :ptext, :separate_board,
               :packet_item, :disc_tag, :set_var, :rnd_method);
        iteration = 'SEASON_PRICES';
      end
    end
    if (:iteration = 'SEASON_PRICES') then begin
      execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_board, :bo_type, :id_tar_season)
      returning_values  :err_code, :id_bo_price, :price_type;
      if (:price_type = 'EQUAL') then begin
        if (:board_type = 'HRANI') then err_code = -225;
        price_type_equal_exists = 1;
      end
      if (:err_code < 0) then exit;
    end
  end
  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:BO_TYPE||', '||:err_text;
  end
end
^

/* Alter (TAR_SAVE_BO_BP) */
ALTER PROCEDURE TAR_SAVE_BO_BP(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable no_use integer;
  declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable id_tar_season integer;
  declare variable iteration varchar(20);
/*****************************************************/
  declare variable id_tar_bp integer;
  declare variable position_number varchar(20);
  declare variable id_room_type integer;
  declare variable max_persons integer;
  declare variable id_board_include integer;
  declare variable is_price_for_room integer;
  declare variable ptext varchar(20);
  declare variable price_type varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable board_weight integer;
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :id_tar_season, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      param_filter = :data||season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      insert into TAR_BO_RELATION(ID_TAR_BP, BO_TYPE, ID_BO, PARAM_FILTER)
      values (:id_tar_bp, :bo_type, :id_tar_bp, :param_filter);
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_bp = gen_id(GEN_TAR_BO_BP_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      position_number = null;
      id_room_type = null;
      max_persons = null;
      id_board_include = -1;
      is_price_for_room = 0;
      ptext = '';
      disc_tag = 'B';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      packet_item = null;
    end
    if (:iteration = 'MIDDLE') then begin
      if (:param_name = 'BASE_POS')            then begin
        if (:data = '') then err_code = -203;
        else position_number = :data;
      end else if (:param_name = 'ROOM_TYPE')  then begin
        if (:data = '') then err_code = -204;
        else id_room_type = :data;
      end else if (:param_name = 'MAX_PERSONS')then begin
        if (:data = '') then err_code = -205;
        else max_persons = :data;
      end else if (:param_name = 'CHECKIN_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'NIGHT_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'BOARD')      then id_board_include = :data;
      else if (:param_name = 'BPRICE_ROOM')    then is_price_for_room = :data;
      else if (:param_name = 'PACKET_ITEM')    then packet_item = :data;
      else if (:param_name = 'PTEXT')          then ptext = :data;
      else if (:param_name = 'DISC_TAG')       then disc_tag = :data;
      else if (:param_name = 'SET_VAR')        then set_var = :data;
      else if (:param_name = 'ROUND_TYPE')     then rnd_method = :data;
      if (:err_code < 0) then exit;
      if ((:id_tar_season <> -1) and (:iteration = 'MIDDLE')) then begin
        /* WE ARE STARTING THE SEASON PRICES SO: */
        board_weight = null;
        select m.WEIGHT_TAG
        from   MEALS M
        where  m.ID_BOARD = :id_board_include
        into   :board_weight;
        board_weight = coalesce(:board_weight, 0);

        insert into TAR_BO_BASE_POSITION(
          ID_TAR_BP, ID_TAR_HEAD, POSITION_NUMBER, ID_ROOM_TYPE, MAX_PERSONS, SET_VAR, RND_METHOD,
          ID_BOARD_INCLUDE, BOARD_WEIGHT, IS_PRICE_FOR_ROOM, PTEXT, PACKET_ITEM, DISC_TAG)
        values (
          :id_tar_bp, :id_tar_head, :position_number, :id_room_type, :max_persons, :set_var, :rnd_method,
          :id_board_include, :board_weight, :is_price_for_room, :ptext, :packet_item, :disc_tag);
       iteration = 'SEASON_PRICES';
      end
    end
    if (:iteration = 'SEASON_PRICES') then begin
      execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_bp, :bo_type, :id_tar_season)
      returning_values  :err_code, :no_use, :price_type;
      if (:err_code < 0) then exit;
    end
  end
  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:BO_TYPE||', '||:err_text;
  end
end
^

/* Alter (TAR_SAVE_BO_DISC) */
ALTER PROCEDURE TAR_SAVE_BO_DISC(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_disc integer;
  declare variable pos_numbers varchar(2000);
  declare variable id_service integer;
  declare variable prioritet integer;
  declare variable day_scheme varchar(20);
  declare variable day_scheme_num integer;
  declare variable price_type varchar(20);
  declare variable price varchar(2000);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable calc_type varchar(20);
  declare variable calc_list varchar(2000);
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  err_text = '';
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      if (:price = '') then err_code = -219;
      if (:err_code < 0) then exit;
      rnd_method = iif(coalesce(:rnd_method, '') = '', 'NONE', :rnd_method);
      insert into TAR_BO_DISCOUNT (
        ID_TAR_DISCOUNT, ID_TAR_HEAD, PRIORITET, DAY_SCHEME, DAY_SCHEME_NUM, DISC_TAG, SET_VAR, RND_METHOD,
        /*IS_IN_BASE_PRICE,*/  CALC_LIST, ID_SERVICE, PTEXT, PACKET_ITEM)
      values (
        :id_tar_disc, :id_tar_head, :prioritet, :day_scheme, :day_scheme_num, :disc_tag, :set_var, :rnd_method,
        /*:in_base_price,*/ :calc_list, :id_service, :ptext, :packet_item);
      param_filter = :data||:season_filter;
      execute procedure tar_save_parse_param(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure tar_save_parse_pnum(:id_tar_head, :id_tar_disc, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_disc = gen_id(GEN_TAR_BO_DISCOUNT_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers   = '';
      id_service    = -1;
      day_scheme     = 'EVERY';
      day_scheme_num = 1;
      calc_type     = 'NONE';
      calc_list     = '';
      price         = '';
      prioritet     = 1;
      ptext         = '';
      disc_tag      = '';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      --in_base_price = 0;
      packet_item   = null;
    end
    if (:param_name = 'SERVICE')            then begin
      if (:data = '') then id_service = -1;
      else id_service = :data;
    end else if (:param_name = 'PTEXT')     then ptext = :data;
    else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
    else if (:param_name = 'SET_VAR')       then set_var = :data;
    else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
    else if (:param_name = 'PRIORITET')     then prioritet     = :data;
    --else if (:param_name = 'IN_BASE_PRICE') then in_base_price = :data;
    else if (:param_name = 'PACKET_ITEM')   then packet_item   = :data;
--    else if (:param_name = 'PRICE_NOTEQUAL') then begin
    else if (:param_name = 'PRICE_FORMULA') then begin
      price = trim(:data);
      /*if ((:id_service > 0) and (:in_base_price = 1) and (substring(:price from 1 for 1) = '-')) then err_code = -240;
      else*/ if (:price = '') then err_code = -219;
      else
        execute procedure tar_save_parse_price(:price, :id_tar_disc, :bo_type, -1)
        returning_values  :err_code, :no_use, :price_type;
    end else if (:param_name = 'LIST_BASE_POS') then pos_numbers   = :data;
    else if (:param_name = 'DAY_SCHEME') then begin
      execute procedure tar_save_parse_dayschm(:data)
      returning_values  :err_code, :day_scheme, :day_scheme_num;
    end else if (:param_name = 'CALC_TYPE') then begin
      calc_list = :data;
--      execute procedure tar_save_parse_calctype(:data)
--      returning_values  :err_code, :calc_type, :calc_list;
    end else if (:param_name = 'CHECKIN_SEASON') then begin
      execute procedure tar_save_parse_season(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end else if (:param_name = 'NIGHT_SEASON') then begin
      execute procedure tar_save_parse_season(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end
    if (:err_code < 0) then exit;
  end
/*  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
  end*/
end
^

/* Alter (TAR_SAVE_BO_DISC_PERIOD) */
ALTER PROCEDURE TAR_SAVE_BO_DISC_PERIOD(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_disc integer;
  declare variable pos_numbers varchar(2000);
  declare variable id_service integer;
  declare variable prioritet integer;
  declare variable calc_position varchar(20);
  declare variable price_type varchar(20);
  declare variable price varchar(2000);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable calc_list varchar(2000);
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  err_text = 'OBJECT='||:bo_type;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      if (:price = '') then err_code = -219;
      if (:calc_position = '') then err_code = -244;
      if (:err_code < 0) then exit;
      insert into TAR_BO_DISCOUNT_STAY (ID_TAR_DISCOUNT_STAY, ID_TAR_HEAD, PRIORITET, CALC_POSITION,
             CALC_LIST, ID_SERVICE, PTEXT, DISC_TAG, SET_VAR, RND_METHOD)
      values (:id_tar_disc, :id_tar_head, :prioritet, :calc_position,
             :calc_list, :id_service, :ptext, :disc_tag, :set_var, :rnd_method);

      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_disc, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration = 'MIDDLE';
      id_tar_disc = gen_id(GEN_TAR_BO_DISCOUNT_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers   = '';
      id_service    = -1;
      calc_list     = '';
      price         = '';
      prioritet     = 1;
      calc_position = 'GUEST_PERIOD';
      ptext         = '';
      disc_tag      = '';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
    end
    if (:param_name = 'SERVICE')            then begin
      if (:data = '') then id_service = -1;
      else id_service = :data;
    end else if (:param_name = 'PTEXT')     then ptext = :data;
    else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
    else if (:param_name = 'SET_VAR')       then set_var = :data;
    else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
    else if (:param_name = 'PRIORITET')     then prioritet     = :data;
    else if (:param_name = 'PERIOD_BASE_TYPE')    then calc_position = :data;
    else if (:param_name = 'PRICE_FORMULA') then begin
      price = trim(:data);
      if (:price = '') then err_code = -219;
      else begin
        execute procedure TAR_SAVE_PARSE_PRICE(:price, :id_tar_disc, :bo_type, -1)
        returning_values  :err_code, :no_use, :price_type;
        if (:err_code < 0) then exit;
      end
    end else if (:param_name = 'LIST_BASE_POS') then pos_numbers   = :data;
    else if (:param_name = 'CALC_TYPE') then begin
      calc_list = :data;
--      execute procedure tar_save_parse_calctype(:data)
--      returning_values  :err_code, :calc_type, :calc_list;
    end else if (:param_name = 'CHECKIN_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end else if (:param_name = 'NIGHT_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end
    if (:err_code < 0) then exit;
  end
  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
--    exception;
  end
end
^

/* Alter (TAR_SAVE_BO_EG) */
ALTER PROCEDURE TAR_SAVE_BO_EG(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable id_tar_season integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_eg integer;
  declare variable pos_numbers varchar(2000);
  declare variable min_payors integer;
  declare variable max_extra_guests integer;
  declare variable order_num integer; /* !!!! */
  declare variable id_price_bb integer;
  declare variable id_price_eb integer;
  declare variable price_type varchar(20);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable is_packet_reduction integer;
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :id_tar_season, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_eg, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_eg = gen_id(GEN_TAR_BO_EG_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers = '';
      min_payors  = null;
      id_price_eb = -1;
      id_price_bb = -1;
      order_num   = 99;
      ptext       = '';
      disc_tag    = '';
      set_var = '';
      is_packet_reduction = 0;
      rnd_method = 'MATH';
      season_filter = '';
      max_extra_guests = null;
      packet_item = null;
    end
    if (:iteration = 'MIDDLE') then begin
      if (:param_name = 'LIST_BASE_POS')   then pos_numbers = :data;
      else if (:param_name = 'SET_VAR')    then set_var = :data;
      else if (:param_name = 'ROUND_TYPE') then rnd_method = :data;
      else if (:param_name = 'MIN_PAYORS') then begin
        if (:data = '') then err_code = -213;
        else min_payors = :data;
      end else if (:param_name = 'MAX_EG') then begin
        if (:data = '') then err_code = -214;
        else max_extra_guests = :data;
      end else if (:param_name = 'EG_ORDER')   then begin
        if (:data = '') then order_num = 99;
        else order_num = :data;
        if (:order_num < 1) then err_code = -215;
      end else if (:param_name = 'CHECKIN_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'NIGHT_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'PTEXT')     then ptext = :data;
      else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
      else if (:param_name = 'EG_POST_TYPE')  then is_packet_reduction = :data;
      else if (:param_name = 'PACKET_ITEM')   then packet_item = :data;
      else if (:param_name = 'BB_PRICE')   then begin
        if (:data <> '') then begin
          execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_eg, :bo_type, -1)
          returning_values  :err_code, :id_price_bb, :price_type;
          if ((:board_type = 'HRANI') and (:price_type <> 'PERCENT')) then begin
            err_code = -227;
            exit;
          end
        end
      end else if (:param_name = 'EB_PRICE') then begin
        if (:data <> '') then begin
          execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_eg, :bo_type, -1)
          returning_values  :err_code, :id_price_eb, :price_type;
          if ((:board_type = 'HRANI') and (:price_type <> 'PERCENT')) then begin
            err_code = -227;
            exit;
          end
        end
      end
      if (:err_code < 0) then exit;
      if ((:id_tar_season <> -1) and (:iteration = 'MIDDLE')) then begin
        if (:min_payors is null) then err_code = -213;
        if (:max_extra_guests is null) then err_code = -214;
        if (:err_code < 0) then exit;
        /* WE ARE STARTING THE SEASON PRICES SO: */
        insert into TAR_BO_EXTRA_GUEST(
          ID_TAR_EG, ID_TAR_HEAD, MIN_PAYORS, MAX_EXTRA_GUESTS, EG_ORDER, IS_PACKET_REDUCTION,
          ID_PRICE_BB, ID_PRICE_EB, PTEXT, PACKET_ITEM, DISC_TAG, SET_VAR, RND_METHOD)
        values (
          :id_tar_eg, :id_tar_head, :min_payors, :max_extra_guests, :order_num, :is_packet_reduction,
          :id_price_bb, :id_price_eb, :ptext, :packet_item, :disc_tag, :set_var, :rnd_method);
        iteration = 'SEASON_PRICES';
      end
    end
    if (:iteration = 'SEASON_PRICES') then begin
      execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_eg, :bo_type, :id_tar_season)
      returning_values  :err_code, :no_use, :price_type;
      if (:err_code < 0) then exit;
    end
  end
  when any do begin
    err_code = -200;
    err_text = ''||:iteration||' '||:id_price_bb||' '||:id_price_eb;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
/*    err_text = ' '||:min_payors||' '||:max_extra_guests||' '||:order_num;*/
  end
end
^

/* Alter (TAR_SAVE_BO_PACK) */
ALTER PROCEDURE TAR_SAVE_BO_PACK(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_pack integer;
  declare variable pos_numbers varchar(2000);
  declare variable id_service integer;
  declare variable day_scheme varchar(20);
  declare variable day_scheme_num integer;
  declare variable cnt_post integer;
  declare variable pack_currency char(3);
  declare variable in_base_price integer;
  declare variable grp_rpt varchar(20);
  declare variable grp_docs varchar(20);
  declare variable price_type varchar(20);
  declare variable price_pack varchar(20);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      if (:price_pack = '') then err_code = -216;
      if (:id_service is null) then err_code = -217;
      if (:err_code < 0) then exit;
      insert into TAR_BO_PACK(
        ID_TAR_PACK, ID_TAR_HEAD, ID_SERVICE, PRICE_CURRENCY, IS_IN_BASE_PRICE,
        CNT_POST,  DAY_SCHEME, DAY_SCHEME_NUM, GRP_IN_REPORTS,
        GRP_IN_DOCUMENTS, PTEXT, PACKET_ITEM, DISC_TAG, SET_VAR, RND_METHOD)
      values (
        :id_tar_pack, :id_tar_head, :id_service, :pack_currency, :in_base_price,
        :cnt_post, :day_scheme, :day_scheme_num, :grp_rpt,
        :grp_docs, :ptext, :packet_item, :disc_tag, :set_var, :rnd_method);
      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_pack, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_pack = gen_id(GEN_TAR_BO_PACK_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers   = '';
      id_service    = null;
      day_scheme     = 'EVERY';
      day_scheme_num = 1;
      cnt_post      = 0;
/*
        select TH.TARIFA_CURR
        from   TAR_HEAD TH
        where  TH.ID_TAR_HEAD = :id_tar_head
        into   :pack_currency;
*/    pack_currency = '';
      in_base_price = 0;
      grp_rpt       = '';
      grp_docs      = '';
      price_pack    = '';
      ptext         = '';
      disc_tag      = '';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      packet_item   = null;
    end
    if (:param_name = 'SERVICE') then begin
      if ((:data = '') or (:data = '-1')) then err_code = -217;
      else if (:data = '0') then err_code = -222;
      else id_service = :data;
    end else if (:param_name = 'CNT_POST')  then cnt_post      = :data;
    else if (:param_name = 'IN_BASE_PRICE') then in_base_price = :data;
    else if (:param_name = 'GRP_RPT')       then grp_rpt       = :data;
    else if (:param_name = 'GRP_DOCS')      then grp_docs      = :data;
    else if (:param_name = 'PTEXT')         then ptext         = :data;
    else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
    else if (:param_name = 'SET_VAR')        then set_var = :data;
    else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
    else if (:param_name = 'PACKET_ITEM')   then packet_item   = :data;
    else if (:param_name = 'PRICE')         then begin
      price_pack    = :data;
      if (:price_pack = '') then err_code = -216;
      else
        execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_pack, :bo_type, -1)
        returning_values  :err_code, :no_use, :price_type;
    end else if (:param_name = 'LIST_BASE_POS') then pos_numbers   = :data;
    else if (:param_name = 'CURRENCY') then begin
      if ((:data <> upper(:data)) or (char_length(:data) <> 3)) then err_code = -218;
      else pack_currency = :data;
    end else if (:param_name = 'DAY_SCHEME') then begin
      execute procedure TAR_SAVE_PARSE_DAYSCHM(:data)
      returning_values  :err_code, :day_scheme, :day_scheme_num;
    end else if (:param_name = 'CHECKIN_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end else if (:param_name = 'NIGHT_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end
    if (:err_code < 0) then exit;
  end
  when any do begin
    err_code = -200;
/*    err_text = ' '||:id_service||' '||:pack_currency||' '||:in_base_price;*/
/*    err_text = ' '||:day_scheme||' '||:day_scheme_num;*/
    err_text = ' '||:cnt_post||' '||:grp_rpt||' '||:grp_docs||' '||:ptext;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
  end
end
^

/* Alter (TEST_AVAILABILITY) */
ALTER PROCEDURE TEST_AVAILABILITY RETURNS(FOR_DATE DATE,
MINUS_ROOM_TYE INTEGER,
ID_AGENT INTEGER,
AGENT_NAME VARCHAR(100),
SOLD INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
CONT_BP_REMAIN INTEGER,
RES_WAITING INTEGER,
CONT_PLAIN INTEGER,
CONT_BP INTEGER,
CONT_BP_PLAIN INTEGER,
CONT_PLAIN_REMAIN INTEGER,
RES_TOTAL INTEGER,
ROOM_TYPE_NAME VARCHAR(20))
 AS
declare variable FROM_DATE date;
  declare variable TO_DATE date;
  declare variable HOTELS varchar(255);
  declare variable ID_OCCUPANCY_SESSION integer;
begin
  from_date = '01.06.2009';
  to_date = '30.06.2009';
  hotels = '4';
  execute procedure AVAILABILITY_OCCUPANCY$AVL (:from_date, :to_date,  0, :hotels)
  returning_values (:id_occupancy_session);

  execute procedure AVAILABILITY_OCCUPANCY_OPT$AVL (:id_occupancy_session, 0, 0, 1, 1, 0, 0, 0);

  for
    SELECT
        SOT.FOR_DATE,
        -SOT.ID_ROOM_TYPE as MINUS_ROOM_TYE,
        SOT.ID_AGENT,
        RT.TYPE_ROOM as ROOM_TYPE_NAME,
        P.PROFILE_NAME as AGENT_NAME,
        sum(SOT.SOLD) as SOLD,
        sum(SOT.RES_CONFIRMED) as RES_CONFIRMED,
        sum(SOT.RES_NOTCONFIRMED) as RES_NOTCONFIRMED,
        sum(SOT.RES_WAITING) as RES_WAITING,
        sum(SOT.CONT_PLAIN  ) as CONT_PLAIN,
        sum(SOT.CONT_BP) as CONT_BP,
        sum(SOT.CONT_BP_REMAIN) as CONT_BP_REMAIN,
        sum(SOT.CONT_PLAIN_REMAIN  ) as CONT_PLAIN_REMAIN,
        sum(0 + (SOT.RES_CONFIRMED+SOT.RES_NOTCONFIRMED) ) as RES_TOTAL
    from SMART_OCCUP$TMP SOT
         left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = SOT.ID_ROOM_TYPE
         left outer join PROFILE_AGENT PA on SOT.ID_AGENT = PA.ID_AGENT
         left outer join PROFILE P on PA.ID_PROFILE = P.ID_PROFILE
    where  SOT.ID_SESSION = :id_occupancy_session
      and RT.ID_HOTEL = 4
      and  1=0
      
      
      and SOT.ID_AGENT > -100
    group by SOT.ID_AGENT,
             SOT.FOR_DATE,
             SOT.ID_ROOM_TYPE,
             RT.TYPE_ROOM,
             P.PROFILE_NAME
    union
    SELECT
        FOR_DATE,
        1,
        SOT.ID_AGENT,
        cast('' as varchar(20)),
        P.PROFILE_NAME as AGENT_NAME,
        sum(SOT.SOLD) as SOLD,
        sum(SOT.RES_CONFIRMED) as RES_CONFIRMED,
        sum(SOT.RES_NOTCONFIRMED) as RES_NOTCONFIRMED,
        sum(SOT.RES_WAITING) as RES_WAITING,
        sum(SOT.CONT_PLAIN  ) as CONT_PLAIN,
        sum(SOT.CONT_BP) as CONT_BP,
        sum(SOT.CONT_BP_REMAIN) as CONT_BP_REMAIN,
        sum(SOT.CONT_PLAIN_REMAIN  ) as CONT_PLAIN_REMAIN,
        sum(0 + (SOT.RES_CONFIRMED+SOT.RES_NOTCONFIRMED) ) as RES_TOTAL
    from SMART_OCCUP$TMP SOT
         left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = SOT.ID_ROOM_TYPE
         left outer join PROFILE_AGENT PA on SOT.ID_AGENT = PA.ID_AGENT
         left outer join PROFILE P on PA.ID_PROFILE = P.ID_PROFILE
    where  SOT.ID_SESSION = :id_occupancy_session
      and RT.ID_HOTEL = 4
      and  1=1
      
      and SOT.ID_AGENT > -100
    group by SOT.ID_AGENT,
             SOT.FOR_DATE,
             P.PROFILE_NAME
    order by 5,3,1,2
    into  :for_date, :MINUS_ROOM_TYE, :id_agent, :room_type_name, :agent_name, :sold,
          :res_confirmed, :res_notconfirmed, :res_waiting, :cont_plain, :cont_bp,
          :cont_bp_remain, :cont_plain_remain, :res_total
  do suspend;

end
^

/* Alter (TEST_BOOKING_IMPORT) */
ALTER PROCEDURE TEST_BOOKING_IMPORT AS
declare variable dbg varchar(255);
  declare variable booking_id integer;
begin
  dbg = null;
  EXECUTE PROCEDURE IMPORT_BOOKING$EXC ('SOL NESSEBAR BAY', 'EXP.3', null, null, 0,
  cast('17.11.2008' as date), null, cast('19.11.2008' as date),
  null, null, null, null, null, 'LARGE_ROOM', 'BB', null, null, '????????', 'MIXED', 'EXPEDIA-BAY',
  null, null, null, null, '?????? ??????', null, null, null, null, 'Business - Corporate',
  'Companies (FIR)', 'E-Mail (EMA)', 'Advert (ANZ)', 'Activities (ANI)', 'A room with a view.(4)',
  null, null, 2, 2, 'e43a4cc0-7d73-47cc-bd07-a98c18c714a3', null, '0D074F966A187B2A9912B5F0E213FEB4',
  0, 0, 0, null, null, null, null, null, null, null, null, null, null,  null, null, null, null, null, null)
  returning_values (:dbg, :booking_id, :dbg, :dbg);
  dbg = null;
end
^

/* Restore proc. body: ACCOUNT_MODIFY$INT */
ALTER PROCEDURE ACCOUNT_MODIFY$INT(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL TYPE OF ID_REF,
IS_PMS_ACCOUNT TYPE OF TLOGICAL,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
declare variable a_dbkey char(8);
  declare variable old_sec_level integer;
  declare variable action_text varchar(255);
  declare variable old_acc_name varchar(50);
  declare variable old_acc_curr varchar(3);
  declare variable old_tax_policy integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, archive');

  new_id_account = :id_account;
  if (:operation = 'add') then begin
    if ((:new_id_account is null) or (:new_id_account <= 0)) then new_id_account = gen_id(ID_ACCOUNT_GEN, 1);

    insert into ACCOUNT(ID_ACCOUNT, ACCOUNT_CURR, ACCOUNT_NAME, IS_CREDIT_ACCOUNT, CREDIT_LIMIT,
           ID_TYPE_PAYMENT, NOTE, IS_BLOCKED, BLOCK_TEXT, SECURITY_LEVEL, IS_BASE, IS_EXTRA,
           IS_ALOWED_POS_INTERFACE, POS_INTERFACE_NOTE, EXT_CODE, ID_TAX_POLICY, ID_PROFILE,
           ID_HOTEL, IS_DEFAULT, IS_PMS_ACCOUNT, ID_RESERV_DETAIL)
    values (:new_id_account, :account_curr, :account_name, 0, null,
           :id_type_payment, :note, :is_blocked, :block_text, :security_level, :is_base, :is_extra,
           :is_alowed_pos_interface, :pos_interface_note, :ext_code, :id_tax_policy, :id_profile,
           :id_hotel, :is_default, coalesce(:IS_PMS_ACCOUNT, 0), :ID_RESERV_DETAIL)
    returning RDB$DB_KEY
    into   :a_dbkey;

    action_text = f_character(29) || :new_id_account || '/' || :account_name;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'ADD_ACCOUNT', :action_text);

    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:NEW_ID_ACCOUNT, :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT);
    -- check special right and log event

  end else begin
    ID_RESERV_DETAIL = null;
    select A.RDB$DB_KEY, A.ID_RESERV_DETAIL, A.SECURITY_LEVEL,
           A.ACCOUNT_NAME, A.ACCOUNT_CURR, A.ID_TAX_POLICY
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :a_dbkey, :id_reserv_detail, :old_sec_level,
           :old_acc_name, :old_acc_curr, :old_tax_policy;
    if (:operation = 'mod') then begin
  
      update ACCOUNT A
      set    A.ACCOUNT_NAME = :account_name,
             A.ID_TYPE_PAYMENT = :id_type_payment,
             A.NOTE = :note,
             A.IS_BLOCKED = :is_blocked,
             A.BLOCK_TEXT = :block_text,
             A.SECURITY_LEVEL = :security_level,
             A.IS_BASE = :is_base,
             A.IS_EXTRA = :is_extra,
             A.IS_ALOWED_POS_INTERFACE = :is_alowed_pos_interface,
             A.POS_INTERFACE_NOTE = :pos_interface_note,
             A.EXT_CODE = :ext_code,
             A.ID_TAX_POLICY = :id_tax_policy,
             A.IS_DEFAULT = :is_default
      where  A.RDB$DB_KEY = :a_dbkey;
  
      execute procedure ACCOUNT_SET_CURRENCY$INT (:a_dbkey, :account_curr);
  
      if (:old_acc_name <> :account_name) then begin
        action_text = f_character(29 ) || :ID_ACCOUNT || '/' || :old_acc_name || ', ' || :old_acc_curr
                      || f_character(28) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME || ', ' || :ACCOUNT_CURR;
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'EDIT_ACCOUNT', :action_text);
      end
  
      if (:old_sec_level <> :SECURITY_LEVEL) then begin
        action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME
                      || f_character(28) || :SECURITY_LEVEL;
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'SET_ACC_SEC_LEVEL', :action_text);
      end
  
      if (:old_tax_policy <> :id_tax_policy) then begin
        execute procedure ACCOUNT_TAXATION_RECALC$INT (:ID_ACCOUNT, :ID_TAX_POLICY);
  
        action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME;                        
  
        select :action_text || f_character(28) || OTP.POLICY_NAME
        from   TAX_POLICY OTP
        where  OTP.ID_TAX_POLICY = :old_tax_policy
        into   :action_text;
        select :action_text || f_character(28) || NTP.POLICY_NAME
        from   TAX_POLICY NTP
        where  NTP.ID_TAX_POLICY = :ID_TAX_POLICY
        into   :action_text;
         
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'VAT_POLICY_CHNG', :action_text);
      end
  
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:ID_ACCOUNT, :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT); -- check special right and log event
  
    end else if (:operation = 'archive') then begin
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 1);

    end
  end

  if ((:id_reserv_detail is null) and (:IS_CREDIT_ACCOUNT = 0)) then begin
    exception ACCOUNT_EXCEPTION '-1010';
    -- The account must have active credit status
    exit;
  end

  if (:is_default = 1) then begin
    update ACCOUNT A
    set    A.IS_DEFAULT = 0
    where  A.ID_HOTEL = :id_hotel
           and A.ID_PROFILE = :id_profile
           and A.ID_ACCOUNT <> :new_id_account;
  end
end
^

/* Restore proc. body: ACCOUNT_POSTING_TRANSFER$ACC */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
declare variable ap_dbkey char(8);
  declare variable transfer_value double precision;
  declare variable post_value double precision;
  declare variable id_account integer;
  declare variable tmp_id_account integer;
  declare variable curr_post varchar(3);
  declare variable acc_name varchar(50);
  declare variable action_text varchar(255);
  declare variable is_pms_account integer;
  declare variable dest_acc_name varchar(50);
begin

  id_account = null;
  transfer_value = 0;

  select ACC.ACCOUNT_NAME, acc.IS_PMS_ACCOUNT
  from   ACCOUNT ACC
  where  ACC.ID_ACCOUNT = :ID_DEST_ACCOUNT
  into   :dest_acc_name, is_pms_account;

  if (:is_pms_account = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('PMS_TRANSFER_POSTINGS');
  end

  for
    select AP.RDB$DB_KEY, AP.ID_ACCOUNT, ap.PRICE_POST * ap.QTY_POST
    from   ACCOUNT_POST AP
    where  AP.DOC_SELECTED = :DOC_SELECTED
           and AP.ID_ACCOUNT = coalesce(:ID_SRC_ACCOUNT, AP.ID_ACCOUNT)
           and AP.ID_ACCOUNT is distinct from :ID_DEST_ACCOUNT
    order by AP.ID_ACCOUNT asc
    into   :ap_dbkey, :tmp_id_account, :post_value
  do begin
    execute procedure ACCOUNT_POSTING_TRANSFER$INT (:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:id_account is null) then id_account = :tmp_id_account;

    /* update from/to pms account */
    execute procedure ACCOUNT_POST_EVENT_REROUTE$INT(:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:tmp_id_account is distinct from :id_account) then begin
      select A.ACCOUNT_NAME, A.ACCOUNT_CURR
      from   ACCOUNT A
      where  A.ID_ACCOUNT = :id_account
      into   :acc_name, :curr_post;

      action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                    f_character(28) || :id_account || '/' || :acc_name ||
                    f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
      execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
      id_account = :tmp_id_account;
      transfer_value = 0;
    end
    transfer_value = :transfer_value + :post_value;
  end

  if (:id_account is not null) then begin
    select A.ACCOUNT_NAME, A.ACCOUNT_CURR
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :acc_name, :curr_post;
  
    action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                  f_character(28) || :id_account || '/' || :acc_name ||
                  f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
  end
end
^

/* Restore proc. body: AVAILABILITY_RATING_LOOP$INT */
ALTER PROCEDURE AVAILABILITY_RATING_LOOP$INT(ID_SESSION INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ROOMS_COUNT INTEGER,
ADULTS_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ROOMTYPE_LIST VARCHAR(2000),
RATE_LIST VARCHAR(2000),
BOARD_LIST VARCHAR(2000),
HOTELS VARCHAR(255) = '')
 AS
declare variable id_rate integer;
declare variable id_board integer;
declare variable id_room_type integer;
declare variable price_currency char(3);
declare variable price numeric (15,4);
declare variable total_price numeric (15,4);
declare variable round_to numeric (15,4);
declare variable price_details varchar(100);
declare variable stay_length integer;
declare variable calc_adult_count integer;
declare variable calc_children_count integer;
declare variable beds integer;
declare variable id_hotel integer;
declare variable id_tar_calc integer;
begin
  /* This proc produced calculations in result table TMP_AVAILABILITY*/
  stay_length = :departure_date - :arrival_date;
  calc_children_count = coalesce(:children_count, 0);
  /* 1. LOOP RATES */
  id_tar_calc = gen_id(GEN_ID_TAR_CALC, 1);
  for
    select distinct T.ID_TARIFA, t.ID_HOTEL,
           rt.ID_ROOM_TYPE, rt.BEDS, tbt.ID_BOARD
    from   SYSTEM_STRING_PARSER (:RATE_LIST, ',') SP
           join TARIFA T on t.ID_TARIFA = sp.ITEM
                            and T.IS_ACTIVE = 1
                            and (
                                  (cast(:hotels as varchar(2000))  = '')
                                 or
                                  (','||(cast(:hotels as varchar(2000)))||',' containing ','||T.ID_HOTEL||',')
                                )
           join TAR_HEAD th on t.id_tarifa = th.id_tar_head
           left outer join TAR_SIMPLE ts on ts.id_tar_head = th.ID_TAR_HEAD
           left outer join TARIFA_ROOM_TYPES_SUPPORTED (th.ID_TAR_HEAD) trt on 1=1
           left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = trt.ID_ROOM_TYPE
           left outer join TARIFA_BOARDS_SUPPORTED (th.ID_TAR_HEAD) tbt on 1=1
           left outer join MEALS b on b.ID_BOARD = tbt.ID_BOARD
    where  cast(:roomtype_list as varchar(2000)) containing ','|| TRT.ID_ROOM_TYPE ||','
           and cast(:board_list as varchar(2000)) containing ','|| coalesce(tbt.ID_BOARD, 0) ||','
    order by th.ID_TAR_HEAD asc,
           rt.beds desc, rt.ID_ROOM_TYPE asc
    into   :id_rate, :id_hotel, :id_room_type, :beds, :id_board
  do begin
    /* fall back to room type bed count but max 2 */
    calc_adult_count = coalesce(:adults_count, iif(:beds >= 2, 2, 1));

    if ((:calc_adult_count is null) or (:calc_children_count is null)) then
      exception assert ('null for calc_adult_count or calc_children_count parameter!' );

    price_currency = null;
    price = null;
    total_price = null;
    price_details = null;

    execute procedure PRODUCT_RATING$INT (:id_hotel, :ARRIVAL_DATE, :DEPARTURE_DATE,
            :calc_adult_count, :calc_children_count, :id_room_type, :id_board, :id_rate, null, null, :id_tar_calc)
    returning_values  :total_price, :price_currency, :price_details;

    if (:total_price is not null) then begin
      select c.ROUND_TO
      from   CURRS c
      where  c.CURR = :price_currency
      into   :round_to;

      price = round_f(:total_price/:stay_length, :round_to);
      total_price = :rooms_count * :total_price;
      insert into TMP_AVAILABILITY (ID_SESSION, ID_ROOM_TYPE, ID_RATE, ID_BOARD, CURRENCY,
              PRICE, TOTAL_PRICE, PRICE_DETAILS, TOTAL_ROOMS, ALLOTMENT_ROOMS)
      values (:id_session, :id_room_type, :id_rate, :id_board, :price_currency,
              :price, :total_price, :price_details, 0, 0);
    end

  end
end
^

/* Restore proc. body: BLOCK_ANNUL$BLK */
ALTER PROCEDURE BLOCK_ANNUL$BLK(ID_BLOCK_ROOM INTEGER,
OPERATION VARCHAR(30))
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable share_err_text varchar(255);
  declare variable system_date date;
  declare variable cancel_date date;
  declare variable from_date date;
  declare variable b_dbkey char(8);
  declare variable new_id_block_room integer;
  declare variable id_room integer;
  declare variable block_grp integer;
  declare variable reason varchar(50);
  declare variable note varchar(255);
  declare variable action_text varchar(255);
  declare variable room_name varchar(10);
  declare variable id_hotel integer;
  declare variable mark_dirty_expired_block integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION (:operation, 'cancel, annul');

  select BR.FROM_DATE, BR.RDB$DB_KEY, R.ID_HOTEL
  from   BLOCK_ROOM BR
         join ROOMS R on R.ID_ROOM = BR.ID_ROOM
  where  BR.ID_BLOCK_ROOM = :id_block_room
  into   :from_date, :b_dbkey, :id_hotel;

  if (:operation = 'annul') then begin
    update BLOCK_ROOM BR
    set    BR.IS_ANNUL = 1
    where  BR.RDB$DB_KEY = :b_dbkey;
  
    execute procedure BLOCK_MODIFY_CONTROL$INT(:b_dbkey, :from_date);
    execute procedure ROOM_MAGIC_CLEAR(:id_block_room);
    action_text = '';
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :id_block_room, 'ANNUL_BLOCK', :action_text);
  end else begin
    select BR.ID_ROOM, BR.BLOCK_GRP, BR.REASON, BR.NOTE, R.ROOM_NAME
    from   BLOCK_ROOM BR
           join ROOMS R on R.ID_ROOM = BR.ID_ROOM
    where  BR.RDB$DB_KEY = :b_dbkey
    into   :id_room, :block_grp, :reason, :note, :room_name;

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :system_date;
    cancel_date = :system_date - 1;

    execute procedure BLOCK_MODIFY$INT(:id_block_room, :id_room, :from_date, :cancel_date, :block_grp, :reason,
                      :note, 'mod')
    returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :share_err_text, :warn_code;
    --ignore possible entering into share

    execute procedure SETTING_GET_VALUE('MARK_DIRTY_EXPIRED_BLOCK', :id_hotel)
    returning_values  :mark_dirty_expired_block;
    if (:mark_dirty_expired_block = '1') then begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'BLOCK_STOP', 'set_dirty');
    end

    action_text = f_character(29) || :room_name || f_character(28) || formatdate(:cancel_date, 'D;dd.mm.yyyy');
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :new_id_block_room, 'CANCEL_BLOCK', :action_text);
  end
end
^

/* Restore proc. body: BLOCK_CREATE$BLK */
ALTER PROCEDURE BLOCK_CREATE$BLK(ROOM_NAMES TYPE OF TDESCRIPTION_LONG,
ID_HOTEL TYPE OF ID,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
BLOCK_GRP TYPE OF TRANGE,
REASON TYPE OF TREASON,
NOTE TYPE OF TDESCRIPTION_LONG,
IS_FULL_FROM TYPE OF TRANGE,
IS_FULL_TO TYPE OF TRANGE)
 RETURNS(NEW_ID_BLOCK_ROOM TYPE OF ID,
SHARE_TRANSACTION_ID TYPE OF ID,
SHARE_ERR_CODE TYPE OF ID,
ERR_TEXT VARCHAR(255),
WARN_CODE TYPE OF ID,
NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable room_name varchar(50);
  declare variable id_room integer;
  declare variable action_text varchar(255);
  declare variable block_name varchar(30);
begin
  id_room = null;
  warn_code = null;
  SHARE_ERR_CODE = 0;

  for
    select ITEM
    from   SYSTEM_STRING_PARSER(:room_names, ',')
    into   :room_name
  do begin
    id_room = null;
    select R.ID_ROOM
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ROOM_NAME = :room_name
           and RT.ID_HOTEL = :id_hotel
    into   :id_room;

    if (:id_room is null) then exception BLOCK_EXCEPTION '-5' || f_character(31) || :room_name;

    execute procedure BLOCK_MODIFY$INT(null, :id_room, :from_date, :to_date, :block_grp,
                      :reason, :note, 'add')
    returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :err_text, :warn_code;

    block_name = iif(:block_grp = 18, 'OUT OF ORDER', 'OUT OF INVENTORY');
    action_text = f_character(29) || :room_name
                  || f_character(28) || formatdate(:from_date, 'D;dd.mm.yyyy') || '-' || formatdate(:to_date, 'D;dd.mm.yyyy')
                  || f_character(28) || :block_name;
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :new_id_block_room, 'BLOCK_ROOM', :action_text);

  end

  select cast('31.12.1899' as date) + count(b.ID_BLOCK_ROOM)
  from   BLOCK_ROOM b
  where  b.ID_ROOM is not null
  into   :NEW_FROM_DATE;
end
^

/* Restore proc. body: BLOCK_MODIFY$BLK */
ALTER PROCEDURE BLOCK_MODIFY$BLK(ID_BLOCK_ROOM INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
BLOCK_GRP INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
IS_FULL_FROM INTEGER,
IS_FULL_TO INTEGER)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable new_id_block_room integer;
  declare variable action_text varchar(255);
  declare variable old_from_date date;
  declare variable old_to_date date;
  declare variable old_group integer;
  declare variable room_name varchar(10);
  declare variable block_name varchar(30);
begin
  --  IS_FULL_FROM  - deprecated
  --  IS_FULL_TO  - deprecated

  select BR.FROM_DATE, BR.TO_DATE, BR.BLOCK_GRP, R.ROOM_NAME
  from   BLOCK_ROOM BR
         join ROOMS R on R.ID_ROOM = BR.ID_ROOM
  where  BR.ID_BLOCK_ROOM = :ID_BLOCK_ROOM              
  into   :old_from_date, :old_to_date, :old_group, :room_name;

  execute procedure BLOCK_MODIFY$INT(:id_block_room, :id_room, :from_date, :to_date, :block_grp,
                    :reason, :note, 'mod')
  returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :err_text, :warn_code;

  if ( (:old_from_date <> :FROM_DATE) or (:old_to_date <> :TO_DATE) or (:old_group <> :BLOCK_GRP) ) then begin
    block_name = iif(:block_grp = 18, 'OUT OF ORDER', 'OUT OF INVENTORY');
    action_text = f_character(29) || :room_name
                  || f_character(28) || formatdate(:FROM_DATE, 'D;dd.mm.yyyy') || '-' || formatdate(:TO_DATE, 'D;dd.mm.yyyy')
                  || f_character(28) || :block_name;
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :NEW_ID_BLOCK_ROOM, 'EDIT_BLOCK', :action_text);
  end
end
^

/* Restore proc. body: CLEAR_BP_ALLOTMENT$EXC */
ALTER PROCEDURE CLEAR_BP_ALLOTMENT$EXC(HOTEL_NAME VARCHAR(50),
AGENT_UUID TYPE OF UUID)
 RETURNS(ID_HOTEL INTEGER,
ID_ALLOTMENT INTEGER)
 AS
declare variable profile_id integer;
declare variable agent_dbkey char(8);
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_PROFILE$EXC(:agent_uuid)
  returning_values :agent_dbkey, :profile_id;
  agent_dbkey = null; /* clear dummy value - ath this point this is profile db key not agent_profile */
  execute procedure log_id_lookup_error$exc(:HOTEL_NAME, 'AGENT_ALLOTMENT(BP)', :profile_id, :agent_uuid, 'agent_profile');

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'AGENT_ALLOTMENT(BP)', :HOTEL_NAME)
  returning_values :ID_HOTEL;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:HOTEL_NAME, 'AGENT_ALLOTMENT(BP)');

  ID_ALLOTMENT = null;
  select a.rdb$db_key, a.id_booking_position
  from profile_agent a
  where a.id_profile = :profile_id
  into :agent_dbkey, :id_allotment;

  if (:id_allotment is null) then begin
    execute procedure ALLOTMENT_CREATE$INT
    returning_values :id_allotment;

    update profile_agent set id_booking_position = :id_allotment
    where rdb$db_key = :agent_dbkey;
  end else begin
    delete from ALLOTMENT_DETAIL ad where ad.ID_ALLOTMENT = :ID_ALLOTMENT;
  end
end
^

/* Restore proc. body: CLEAR_CONTINGENT_ALLOTMENT$EXC */
ALTER PROCEDURE CLEAR_CONTINGENT_ALLOTMENT$EXC(HOTEL_NAME VARCHAR(50),
AGENT_UUID TYPE OF UUID)
 RETURNS(ID_HOTEL INTEGER,
ID_ALLOTMENT INTEGER)
 AS
declare variable profile_id integer;
declare variable agent_dbkey char(8);
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_PROFILE$EXC(:agent_uuid)
  returning_values :agent_dbkey, :profile_id;
  agent_dbkey = null; /* clear dummy value - ath this point this is profile db key not agent_profile */
  execute procedure log_id_lookup_error$exc(:HOTEL_NAME, 'AGENT_ALLOTMENT(CONTINGENT)', :profile_id, :agent_uuid, 'agent_profile');

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'AGENT_ALLOTMENT(CONTINGENT)', :HOTEL_NAME)
  returning_values :ID_HOTEL;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:HOTEL_NAME, 'AGENT_ALLOTMENT(CONTINGENT)');

  ID_ALLOTMENT = null;
  select a.rdb$db_key, a.id_contingent
  from profile_agent a
  where a.id_profile = :profile_id
  into :agent_dbkey, :id_allotment;

  if (:id_allotment is null) then begin
    execute procedure ALLOTMENT_CREATE$INT
    returning_values :id_allotment;

    update profile_agent set id_contingent = :id_allotment
    where rdb$db_key = :agent_dbkey;
  end else begin
    delete from ALLOTMENT_DETAIL ad where ad.ID_ALLOTMENT = :ID_ALLOTMENT;
  end
end
^

/* Restore proc. body: CLEAR_EOCC_ALLOTMENT$EXC */
ALTER PROCEDURE CLEAR_EOCC_ALLOTMENT$EXC(HOTEL_NAME VARCHAR(50))
 RETURNS(ID_HOTEL INTEGER,
ID_ALLOTMENT INTEGER)
 AS
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'EOCC_ALLOTMENT', :HOTEL_NAME)
  returning_values :ID_HOTEL;
  execute procedure CHECK_LOOKUP_ERRORS$EXC(:HOTEL_NAME, 'EOCC_ALLOTMENT');

  ID_ALLOTMENT = null;
  select h.id_external_occupancy_allotment
  from HOTEL h
  where h.ID_HOTEL = :ID_HOTEL
  into :ID_ALLOTMENT;

  if (:id_allotment is null) then begin
    execute procedure ALLOTMENT_CREATE$INT
    returning_values :id_allotment;

    update hotel set id_external_occupancy_allotment=:id_allotment
    where id_hotel = :id_hotel;
  end else begin
    delete from ALLOTMENT_DETAIL ad where ad.ID_ALLOTMENT = :ID_ALLOTMENT;
  end
end
^

/* Restore proc. body: CLEAR_INVENTORY_ALLOTMENT$EXC */
ALTER PROCEDURE CLEAR_INVENTORY_ALLOTMENT$EXC(HOTEL_NAME VARCHAR(50))
 RETURNS(ID_HOTEL INTEGER,
ID_ALLOTMENT INTEGER)
 AS
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'ALLOTMENT', :HOTEL_NAME)
  returning_values :ID_HOTEL;
  execute procedure CHECK_LOOKUP_ERRORS$EXC(:HOTEL_NAME, 'ALLOTMENT');

  ID_ALLOTMENT = null;
  select h.ID_INVENTORY_ALLOTMENT
    from HOTEL h
    where h.ID_HOTEL = :ID_HOTEL
    into :ID_ALLOTMENT;

  if (ID_ALLOTMENT is not null) then begin
    delete from ALLOTMENT_DETAIL ad
      where ad.ID_ALLOTMENT = :ID_ALLOTMENT;
  end
end
^

/* Restore proc. body: DOCUMENT_ADD_DEF_PAYMENT$DOC */
ALTER PROCEDURE DOCUMENT_ADD_DEF_PAYMENT$DOC(ID_DOC_HEAD INTEGER,
ID_PAY_DOC_TYPE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable pay_curr varchar(3);
  declare variable doc_curr varchar(3);
  declare variable id_account integer;
  declare variable doc_sub_type integer;
  declare variable id_base_doc integer;
  declare variable paydocs_cnt integer;
  declare variable id_payment_head integer;
  declare variable storno_amount numeric(15,4);
  declare variable rest_value numeric(15,4);
  declare variable doc_rnd_to numeric(15,4);
  declare variable doc_value numeric(15,4);
  declare variable pay_rate numeric(15,6);
  declare variable doc_rate numeric(15,6);
  declare variable extra_info_needed smallint;
  declare variable id_doc_type integer;
begin                         /* create payment */
  PAY_CURR = null;
  select D.ID_ACCOUNT, D.DOC_SUB_TYPE, D.ID_BASE_DOC,
         D.DOC_CURRENCY, D.DOC_VALUE_A, d.DOC_RATE, d.ID_DOC_TYPE
  from   DOC_HEAD D
         join DOC_TYPE DT on dt.ID_DOC_TYPE = d.ID_DOC_TYPE
  where  D.ID_DOC = :ID_DOC_HEAD
  into   :id_account, :doc_sub_type, :id_base_doc,
         :doc_curr, :doc_value, :doc_rate, :id_doc_type;

  if (:doc_sub_type < 2) then begin
    if (:ID_PAY_DOC_TYPE is null) then begin
      /* = case */
      execute procedure PAYMENT_GET_DEFAULT$INT (:ID_ACCOUNT)
      returning_values  (:ID_PAY_DOC_TYPE, :pay_curr);

      if (:pay_curr <> :doc_curr) then begin
        execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, null)
        returning_values  (:dbg, :dbg, :dbg, :dbg, :rest_value);

        select C.ROUND_TO
        from   CURRS C
        where  C.CURR = :DOC_CURR
        into   :doc_rnd_to;
         
        if (:REST_VALUE = :DOC_RND_TO) then begin
          select iif(pdt.CURRENCY_LIST containing :doc_curr, :doc_curr, null)
          from   DOC_TYPE pdt
          where  pdt.ID_DOC_TYPE = :ID_DOC_TYPE
          into   :pay_curr;
        end
      end
    end else begin
      select  PDT.DEF_CURRENCY
      from    PAY_DOC_TYPE_S PDT
      where   PDT.ID_DOC_TYPE = :ID_PAY_DOC_TYPE
              and PDT.IS_ARCHIVE = 0
              and PDT.DOC_DIRECTION = 1
      into    :PAY_CURR;
    end

    if (:ID_PAY_DOC_TYPE is not null and :PAY_CURR is not null) then begin
      select coalesce(dtp.IS_CC, 0) + coalesce(dtp.IS_AR_DEBT, 0)
      from   DOC_TYPE_PAY DTp
      where  DTP.ID_DOC_TYPE = :ID_PAY_DOC_TYPE
      into   :extra_info_needed;

      if (:extra_info_needed = 0) then begin
        execute procedure DOCUMENT_ADD_PAYMENT$DOC (:ID_DOC_HEAD, :ID_PAY_DOC_TYPE, null, :PAY_CURR, '')
        returning_values :DBG;
      end
    end
  end else begin
    select count(P.ID_PAYMENT_HEAD)
    from   PAYMENT_HEAD P
    where  P.ID_DOC_HEAD = :ID_BASE_DOC
    into   :PAYDOCS_CNT;

    if (:PAYDOCS_CNT = 1) then begin
      select P.ID_PAYMENT_HEAD, P.PAY_CURRENCY, P.PAY_RATE
      from   PAYMENT_HEAD P
      where  P.ID_DOC_HEAD = :ID_BASE_DOC
      into   :id_payment_head, :pay_curr, :pay_rate;

      if (:pay_curr = :doc_curr) then pay_rate = :doc_rate;
      execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, :pay_curr, :pay_rate)
      returning_values  (:dbg, :dbg, :dbg, :dbg, :rest_value);

      STORNO_AMOUNT = -:REST_VALUE;

      execute procedure PAYMENT_STORNO$INT (:ID_PAYMENT_HEAD, :ID_ACCOUNT, :ID_DOC_HEAD, :STORNO_AMOUNT, '', :DOC_VALUE)
      returning_values  :DBG;

      when any do exit;
       
    end
  end
end
^

/* Restore proc. body: DOCUMENT_STORNO_PAYS_SET$DOC */
ALTER PROCEDURE DOCUMENT_STORNO_PAYS_SET$DOC(ID_STORNO_DOC INTEGER)
 AS
declare variable id_account integer;
  declare variable id_payment_head integer;
  declare variable id_storned_doc integer;
  declare variable description varchar(100);
  declare variable id_storno_payment integer;
  declare variable storno_amount numeric(15,4);
  declare variable doc_amount numeric(15,4);
begin
  execute procedure DOCUMENT_PAYMENTS_CLEAR$DOC (:ID_STORNO_DOC);

  select D.ID_BASE_DOC, D.DESCRIPTION
  from   DOC_HEAD D
  where  D.ID_DOC = :ID_STORNO_DOC
  into   :id_storned_doc, :description;
   
  for
    select P.ID_PAYMENT_HEAD, BD.ID_ACCOUNT, sum(dp.PAY_AMOUNT), sum(dp.DOC_AMOUNT)
    from   DOC_HEAD BD
           join PAYMENT_HEAD P on P.ID_DOC_HEAD = BD.ID_DOC
           join ACCOUNT_PAYMENTS AP on AP.ID_PAYMENT_HEAD = p.ID_PAYMENT_HEAD
           join DOC_PAY_USAGE DP on dp.ID_ACCOUNT_PAYMENT = ap.ID_ACCOUNT_PAYMENT
                                   and dp.ID_DOC_HEAD = bd.ID_DOC
    where  BD.ID_BASE_DOC = :id_storned_doc
           and P.IS_STORNED = 0
           and P.IS_STORNO = 0
           and P.IS_ANUL = 0
    group by 1, 2
    into   :id_payment_head, :id_account, :storno_amount, :doc_amount
  do begin
    select :storno_amount + coalesce(sum(sdp.PAY_AMOUNT), 0),
           :doc_amount + coalesce(sum(sdp.DOC_AMOUNT), 0)
    from   PAYMENT_HEAD SP
           join ACCOUNT_PAYMENTS sap on sap.ID_PAYMENT_HEAD = sp.ID_PAYMENT_HEAD
           join DOC_PAY_USAGE sdp on sdp.ID_ACCOUNT_PAYMENT = sap.ID_ACCOUNT_PAYMENT
    where  sp.ID_PAYMENT_STORNED = :id_payment_head
           and sp.IS_ANUL = 0
    into   :storno_amount, :doc_amount;

    execute procedure PAYMENT_STORNO$INT (:id_payment_head, :id_account, :ID_STORNO_DOC, :storno_amount, :DESCRIPTION, :doc_amount)
    returning_values  (:id_storno_payment);

  end
end
^

/* Restore proc. body: EAI_EXT_POST_TO_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable ID_HOTEL integer;
begin
  if (singular(select HS.ID_HOTEL
               from HOTEL_S HS
               where HS.IS_USE = 1)) then
    select H.ID_HOTEL
    from   HOTEL_S H
    where H.IS_USE = 1
    into   :id_hotel;
  else begin
    err_code = -1044;
    exit;
  end

  execute procedure EAI_EXT_POST_TO_MH_FRONT_ONLINE(:ID_HOTEL, :ROOM_NAME,
    :SERVICE_CODE, :CODE_TYPE, :QTY_POST, :PRICE_POST, :CURR_POST, :POST_TEXT)
  returning_values (:ERR_CODE, :ERR_TEXT, :ID_ROOM, :ID_GUEST, :GUEST_NAME1,
    :ID_ACCOUNT, :ID_ACCOUNT_POST, :ID_SERVICE);

end
^

/* Restore proc. body: EAI_POS_POSTING_ADD */
ALTER PROCEDURE EAI_POS_POSTING_ADD(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
begin
  -- used external inteface - for compatability with Front 2008
  execute procedure EAI_POS_POSTING_ADD$P2E (:IN_ON_GUEST, :IN_ID_ACCOUNT, :IN_ID_GUEST, :IN_DATE_SMETKA,
          :IN_PRICE, :IN_DATETIME, :IN_OBJ_NAME, :IN_TABLE, :IN_SITE, :IN_SMETKA_NUM, :IN_POS_USER,
          :IN_ID_SMETKA, :IN_SERVICE_TAG, :IN_SERVICE_NAME)
  returning_values (:ERR_CODE, :ERR_TEXT, :OUT_ID_ACCOUNT);

end
^

/* Restore proc. body: IMPORT_ACCOUNT$EXC */
ALTER PROCEDURE IMPORT_ACCOUNT$EXC(ACCOUNT_NAME VARCHAR(50),
ACCOUNT_CURR VARCHAR(3),
IS_CREDIT_ACCOUNT SMALLINT,
CREDIT_LIMIT NUMERIC(15,4),
PAYMENT_TYPE VARCHAR(20),
NOTE VARCHAR(255),
IS_BLOCKED SMALLINT,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE SMALLINT,
IS_EXTRA SMALLINT,
IS_ALOWED_POS_INTERFACE SMALLINT,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
IS_DEFAULT SMALLINT,
HOTEL_NAME VARCHAR(50))
 RETURNS(ID_ACCOUNT INTEGER)
 AS
declare variable id_hotel integer;
declare variable id_payment_type integer;
declare variable id_profile integer;
declare variable id_tax_policy integer;
declare variable id_acc_template integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'ACCOUNT', :ACCOUNT_NAME)
  returning_values :ID_HOTEL;

  execute procedure LOOKUP_PAYMENT_TYPE$EXC(:ID_HOTEL, :ACCOUNT_NAME, 'ACCOUNT', :PAYMENT_TYPE)
  returning_values :ID_PAYMENT_TYPE;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:ACCOUNT_NAME, 'ACCOUNT');

  execute procedure LOOKUP_ACCOUNT$EXC(:ID_HOTEL, :ACCOUNT_NAME)
  returning_values :ID_ACCOUNT;

  select ph.ID_PROFILE
  from   PROFILE_HOUSE ph
  where  ph.HOUSE_TYPE = 'hptComplimentary'
  into   :id_profile;

  select sv.SETTING_VALUE
  from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :ID_HOTEL) sv
  into   :id_acc_template;

  select ac.ID_TAX_POLICY
  from   ACC_TEMPLATE ac
  where  ac.ID_ACC_TEMPLATE = :id_acc_template
  into   :id_tax_policy;

  if (:ID_ACCOUNT is null) then begin
    execute procedure ACCOUNT_MODIFY$INT(null, :ID_PROFILE, :ACCOUNT_CURR, :ACCOUNT_NAME,
      :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT, :ID_PAYMENT_TYPE, :NOTE, :IS_BLOCKED, :BLOCK_TEXT,
      :SECURITY_LEVEL, :IS_BASE, :IS_EXTRA, :IS_ALOWED_POS_INTERFACE, :POS_INTERFACE_NOTE,
      :EXT_CODE, :ID_TAX_POLICY, :IS_DEFAULT, :ID_HOTEL, null, 0, 'add')
    returning_values :ID_ACCOUNT;
  end
end
^

/* Restore proc. body: IMPORT_AGENT_PROFILE_DSCNT$EXC */
ALTER PROCEDURE IMPORT_AGENT_PROFILE_DSCNT$EXC(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
HOTEL_NAME VARCHAR(100),
SALE_DISCOUNT_NAME VARCHAR(50),
DISCOUNT_ORDER SMALLINT)
 AS
declare variable ID_HOTEL integer;
  declare variable ID_SALE_DISCOUNT integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME)
  returning_values :ID_HOTEL;

  if (:ID_HOTEL is null) then exit; /* ignore */

  execute procedure LOOKUP_SALE_DISCOUNT$EXC(:ID_HOTEL, :PROFILE_NAME, 'AGENT_PROFILE', :SALE_DISCOUNT_NAME)
  returning_values :ID_SALE_DISCOUNT;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:PROFILE_NAME, 'AGENT_PROFILE');

  insert into PROFILE_DISCOUNT
    (ID_PROFILE, ID_SALE_DISCOUNT, /*ID_HOTEL,*/ DISCOUNT_ORDER)
  values
    (:ID_PROFILE, :ID_SALE_DISCOUNT, /*:ID_HOTEL, */:DISCOUNT_ORDER);
end
^

/* Restore proc. body: IMPORT_ALLOTMENT_DETAIL$EXC */
ALTER PROCEDURE IMPORT_ALLOTMENT_DETAIL$EXC(ID_HOTEL INTEGER,
ID_ALLOTMENT INTEGER,
ROOM_TYPE VARCHAR(30),
FROM_DATE DATE,
TO_DATE DATE,
ROOM_COUNT INTEGER)
 RETURNS(ID_ALLOTMENT_DETAIL INTEGER)
 AS
declare variable ID_ROOM_TYPE INTEGER;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_ROOM_TYPE$EXC(:ID_HOTEL, :ID_HOTEL, 'ALLOTMENT', :ROOM_TYPE)
  returning_values :ID_ROOM_TYPE;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:ID_HOTEL, 'ALLOTMENT');

  ID_ALLOTMENT_DETAIL = gen_id(GEN_ALLOTMENT_DETAIL_ID, 1);
  insert into ALLOTMENT_DETAIL
    (ID_ALLOTMENT_DETAIL, ID_ALLOTMENT, ID_ROOM_TYPE, FROM_DATE, TO_DATE, CNT_ROOMS)
  values
    (:ID_ALLOTMENT_DETAIL, :ID_ALLOTMENT, :ID_ROOM_TYPE, :FROM_DATE, :TO_DATE, :ROOM_COUNT);

end
^

/* Restore proc. body: IMPORT_CHANNEL_ALLOTMENT$EXC */
ALTER PROCEDURE IMPORT_CHANNEL_ALLOTMENT$EXC(IMPORT_ID VARCHAR(40),
CHANNEL_NAME VARCHAR(30),
HOTEL_NAME VARCHAR(50),
ROOM_TYPE VARCHAR(20),
FOR_DATE DATE,
FROM_DATE DATE,
TO_DATE DATE,
STATUS SMALLINT,
ROOM_COUNT INTEGER,
AUTO_FREE_ROOMS INTEGER)
 AS
declare variable ID_CHANNEL INTEGER;
declare variable ID_HOTEL INTEGER;
declare variable ID_ROOM_TYPE INTEGER;
begin
  execute procedure import_mark_transaction$exc;

  ID_CHANNEL = null;
  select c.ID_CHANNEL
    from CHANNEL c
    where c.NAME = :CHANNEL_NAME
    into :ID_CHANNEL;

  if (ID_CHANNEL is null) then begin
    execute procedure CHANNEL_MODIFY$CFG(:ID_CHANNEL, :CHANNEL_NAME, 'add')
    returning_values :ID_CHANNEL;
  end

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'CHANNEL_MANAGEMENT', :IMPORT_ID)
  returning_values :ID_HOTEL;

  execute procedure LOOKUP_ROOM_TYPE$EXC(:ID_HOTEL, :IMPORT_ID, 'CHANNEL_MANAGEMENT', :ROOM_TYPE)
  returning_values :ID_ROOM_TYPE;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:IMPORT_ID, 'CHANNEL_MANAGEMENT');

  if (FOR_DATE is not null) then begin
    execute procedure CHANNEL_ALLOTMENT_MODIFY$CHM(:ID_CHANNEL, :ID_ROOM_TYPE, :FOR_DATE, :STATUS, :AUTO_FREE_ROOMS, :ROOM_COUNT);
  end else begin
    FOR_DATE = FROM_DATE;
    while (FOR_DATE <= TO_DATE) do begin
      execute procedure CHANNEL_ALLOTMENT_MODIFY$CHM(:ID_CHANNEL, :ID_ROOM_TYPE, :FOR_DATE, :STATUS, :AUTO_FREE_ROOMS, :ROOM_COUNT);      
      FOR_DATE = FOR_DATE + 1;
    end
  end
end
^

/* Restore proc. body: IMPORT_CHANNEL_MAPPED_RATE$EXC */
ALTER PROCEDURE IMPORT_CHANNEL_MAPPED_RATE$EXC(IMPORT_ID VARCHAR(40),
CHANNEL_NAME VARCHAR(30),
HOTEL_NAME VARCHAR(50),
RATE_NAME VARCHAR(50),
IS_PUBLIC SMALLINT)
 AS
declare variable ID_CHANNEL INTEGER;
declare variable ID_HOTEL INTEGER;
declare variable ID_RATE INTEGER;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME)
  returning_values :ID_HOTEL;

  if (:ID_HOTEL is null) then exit; /* ignore */

  execute procedure LOOKUP_CHANNEL$EXC(:IMPORT_ID, 'CHANNEL_MANAGEMENT', :CHANNEL_NAME)
  returning_values :ID_CHANNEL;

  execute procedure LOOKUP_RATE$EXC(:ID_HOTEL, :IMPORT_ID, 'CHANNEL_MANAGEMENT', :RATE_NAME)
  returning_values :ID_RATE;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:IMPORT_ID, 'CHANNEL_MANAGEMENT');

  execute procedure CHANNEL_MAPPED_RATE_SET$EXC(:ID_CHANNEL, :ID_HOTEL, :ID_RATE, :IS_PUBLIC, 'set');

end
^

/* Restore proc. body: IMPORT_CHANNEL_MAPPED_RT$EXC */
ALTER PROCEDURE IMPORT_CHANNEL_MAPPED_RT$EXC(IMPORT_ID VARCHAR(40),
CHANNEL_NAME VARCHAR(30),
HOTEL_NAME VARCHAR(50),
ROOM_TYPE VARCHAR(20),
MAX_GUEST_COUNT INTEGER)
 AS
declare variable ID_CHANNEL INTEGER;
declare variable ID_HOTEL INTEGER;
declare variable ID_ROOM_TYPE INTEGER;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME)
  returning_values :ID_HOTEL;

  if (:ID_HOTEL is null) then exit; /* ignore */

  execute procedure LOOKUP_CHANNEL$EXC(:IMPORT_ID, 'CHANNEL_MANAGEMENT', :CHANNEL_NAME)
  returning_values :ID_CHANNEL;

  execute procedure LOOKUP_ROOM_TYPE$EXC(:ID_HOTEL, :IMPORT_ID, 'CHANNEL_MANAGEMENT', :ROOM_TYPE)
  returning_values :ID_ROOM_TYPE;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:IMPORT_ID, 'CHANNEL_MANAGEMENT');

  execute procedure CHANNEL_MAPPED_RT_SET$EXC(:ID_CHANNEL, :ID_HOTEL, :ID_ROOM_TYPE, :max_guest_count, 'set');
end
^

/* Restore proc. body: IMPORT_EATING_OBJECT$EXC */
ALTER PROCEDURE IMPORT_EATING_OBJECT$EXC(NAME VARCHAR(30),
IS_ARCHIVE SMALLINT,
UUID VARCHAR(40),
HOTEL_NAME VARCHAR(50))
 RETURNS(ID_EATING_OBJECT INTEGER)
 AS
declare variable ID_HOTEL INTEGER;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure sys_dbg(
  'exc IMPORT_EATING_OBJECT$EXC(:NAME=>' || coalesce(:NAME, '<null>')
    || ', :IS_ARCHIVE=>' || coalesce(:IS_ARCHIVE, '<null>')
    || ', :HOTEL_NAME=>' || coalesce(:HOTEL_NAME, '<null>')
    || ', :UUID=>' || coalesce(:UUID, '<null>')
  || ')');

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'EATING_OBJECT', :NAME)
  returning_values :ID_HOTEL;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:NAME, 'EATING_OBJECT');

  ID_EATING_OBJECT = null;
  select eo.ID_EATING_OBJECT
  from   EATING_OBJECT eo
  where  eo.UUID = :UUID
  into   :ID_EATING_OBJECT;

  execute procedure EATING_OBJECT_MODIFY(:ID_EATING_OBJECT, :ID_HOTEL, :NAME, :IS_ARCHIVE)
  returning_values :ID_EATING_OBJECT;

  update EATING_OBJECT eo
  set    eo.UUID = :UUID
  where  eo.ID_EATING_OBJECT = :ID_EATING_OBJECT;
end
^

/* Restore proc. body: IMPORT_GUARANTEE_POLICY$EXC */
ALTER PROCEDURE IMPORT_GUARANTEE_POLICY$EXC(UUID VARCHAR(40),
NAME VARCHAR(50),
DESCRIPTION VARCHAR(255),
WBE_DESCRIPTION VARCHAR(255),
WBE_DESCRIPTION_FULL BLOB,
CHECK_STATUS SMALLINT,
DEPOSIT_TOTALSUM_PART NUMERIC(15,4),
DEPOSIT_NIGHTS_COUNT INTEGER,
DUE_DAYS_BEFORE_ARRIVAL INTEGER,
DUE_DAYS_AFTER_CREATE INTEGER,
IS_ACTIVE SMALLINT,
WBE_PUBLIC SMALLINT,
HOTEL_NAME VARCHAR(50))
 RETURNS(ID_GUARANTEE_POLICY INTEGER)
 AS
declare variable OPERATION VARCHAR(3);
  declare variable ID_HOTEL INTEGER;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'GUARANTEE_POLICY', :NAME)
  returning_values :ID_HOTEL;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:NAME, 'GUARANTEE_POLICY');

  ID_GUARANTEE_POLICY = null;
  select gp.ID_GUARANTEE_POLICY
  from   GUARANTEE_POLICY gp
  where  gp.UUID = :UUID
         and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :ID_GUARANTEE_POLICY;

  if (:ID_GUARANTEE_POLICY is null) then begin
    OPERATION = 'add';
  end else begin
    OPERATION = 'mod';
  end

  execute procedure GUARANTEE_POLICY_MODIFY(:ID_GUARANTEE_POLICY, :NAME, :DESCRIPTION, :WBE_DESCRIPTION, :WBE_DESCRIPTION_FULL,
    :CHECK_STATUS, :DEPOSIT_TOTALSUM_PART, :DEPOSIT_NIGHTS_COUNT, :DUE_DAYS_BEFORE_ARRIVAL, :DUE_DAYS_AFTER_CREATE, :IS_ACTIVE,
    :WBE_PUBLIC, :OPERATION, :ID_HOTEL)
  returning_values :ID_GUARANTEE_POLICY;
end
^

/* Restore proc. body: IMPORT_GUEST_PACK$EXC */
ALTER PROCEDURE IMPORT_GUEST_PACK$EXC(GUEST_ID INTEGER,
PACK_ITEMS VARCHAR(255))
 AS
declare variable hotel_id integer;
declare variable booking_id integer;
declare variable pack_item_ids varchar(255);
declare variable pack_item_name varchar(50);
declare variable pack_item_id integer;
begin
  execute procedure import_mark_transaction$exc;

  select rd.id_hotel, rd.id_reserv_detail
  from guest g
  join reserv_detail rd on rd.id_reserv_detail=g.id_reserv_detail
  where g.id_guest = :guest_id
  into :hotel_id, :booking_id;

  pack_item_ids = null;
  for
    select trim(sp.item)
    from   SYSTEM_STRING_PARSER(:pack_items, ',') sp
    into   :pack_item_name
  do begin
    execute procedure LOOKUP_PACKET_ITEM$EXC(:hotel_id, :booking_id, 0, :pack_item_name)
    returning_values  :pack_item_id;
    if (:pack_item_id is null) then exception ASSERT '-1019' || f_character(31) || 'packet_item';

    pack_item_ids = coalesce(:pack_item_ids || ',', '') || :pack_item_id;
  end
  pack_item_ids = coalesce(:pack_item_ids || ',', '');

  execute procedure RES_GUEST_SAVE_PACKET$RSV(:guest_id, :pack_item_ids);
end
^

/* Restore proc. body: IMPORT_HK_PLAN$EXC */
ALTER PROCEDURE IMPORT_HK_PLAN$EXC(PLAN_NAME VARCHAR(30),
IS_USE SMALLINT,
UUID VARCHAR(40),
HOTEL_NAME VARCHAR(50))
 RETURNS(ID_PLAN INTEGER)
 AS
declare variable ID_HOTEL INTEGER;
declare variable OPERATION VARCHAR(3);
begin
  execute procedure import_mark_transaction$exc;

  execute procedure sys_dbg(
  'exc IMPORT_HK_PLAN$EXC(:PLAN_NAME=>' || coalesce(:PLAN_NAME, '<null>')
    || ', :IS_USE=>' || coalesce(:IS_USE, '<null>')
    || ', :HOTEL_NAME=>' || coalesce(:HOTEL_NAME, '<null>')
    || ', :UUID=>' || coalesce(:UUID, '<null>')
  || ')');

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'HK_PLAN', :PLAN_NAME)
  returning_values :ID_HOTEL;
  execute procedure CHECK_LOOKUP_ERRORS$EXC(:PLAN_NAME, 'HK_PLAN');

  ID_PLAN = null;
  select p.ID_PLAN
  from HK_PLAN P
  where p.UUID = :UUID and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :ID_PLAN;

  if (ID_PLAN is null) then begin
    OPERATION = 'add';
  end else begin
    OPERATION = 'mod';
    delete from HK_PLAN_PERIOD pp
      where pp.ID_PLAN = :ID_PLAN;
  end

  execute procedure HK_PLAN_MODIFY$HK(:ID_PLAN, :PLAN_NAME, :IS_USE, :ID_HOTEL, :OPERATION)
  returning_values :ID_PLAN;

  update HK_PLAN p
    set p.UUID = :UUID
    where p.ID_PLAN = :ID_PLAN;
end
^

/* Restore proc. body: IMPORT_HK_PLAN_ITEM$EXC */
ALTER PROCEDURE IMPORT_HK_PLAN_ITEM$EXC(ITEM_NAME VARCHAR(50),
ITEM_TYPE VARCHAR(20),
COST_VALUE NUMERIC(15,2),
EXT_CODE VARCHAR(20),
HOTEL_NAME VARCHAR(50),
UUID VARCHAR(40))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_PLAN_ITEM INTEGER)
 AS
declare variable ID_HOTEL INTEGER;
declare variable OPERATION VARCHAR(3);
begin
  execute procedure import_mark_transaction$exc;

  execute procedure sys_dbg(
  'exc IMPORT_HK_PLAN_ITEM$EXC(:ITEM_NAME=>' || coalesce(:ITEM_NAME, '<null>')
    || ', :ITEM_TYPE=>' || coalesce(:ITEM_TYPE, '<null>')
    || ', :COST_VALUE=>' || coalesce(:COST_VALUE, '<null>')
    || ', :EXT_CODE=>' || coalesce(:EXT_CODE, '<null>')
    || ', :HOTEL_NAME=>' || coalesce(:HOTEL_NAME, '<null>')
    || ', :UUID=>' || coalesce(:UUID, '<null>')
  || ')');

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'HK_PLAN_ITEM', :ITEM_NAME)
  returning_values :ID_HOTEL;
  execute procedure CHECK_LOOKUP_ERRORS$EXC(:ITEM_NAME, 'HK_PLAN');

  ID_PLAN_ITEM = null;
  select pi.ID_PLAN_ITEM
  from HK_PLAN_ITEM pi
  where pi.UUID = :UUID and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :ID_PLAN_ITEM;

  if (ID_PLAN_ITEM is null) then begin
    OPERATION = 'add';
  end else begin
    OPERATION = 'mod';
  end

  execute procedure HK_PLAN_ITEM_MODIFY$HK(:ID_PLAN_ITEM, :ITEM_NAME, :ITEM_TYPE, :COST_VALUE, :EXT_CODE, :ID_HOTEL, :OPERATION)
  returning_values  :ID_PLAN_ITEM;

  update HK_PLAN_ITEM pi
  set    pi.UUID = :UUID
  where  pi.ID_PLAN_ITEM = :ID_PLAN_ITEM;
end
^

/* Restore proc. body: IMPORT_HK_PLAN_LINE$EXC */
ALTER PROCEDURE IMPORT_HK_PLAN_LINE$EXC(PLAN_NAME VARCHAR(30),
ID_PLAN_PERIOD INTEGER,
USE_PER_ARRIVAL SMALLINT,
USE_PER_DEPARTURE SMALLINT,
CYCLE_DURATION INTEGER,
QTY INTEGER,
MULTIPLY_TYPE VARCHAR(20),
PLAN_ITEM VARCHAR(50),
HOTEL_NAME VARCHAR(50),
ROOM_TYPE_LIST VARCHAR(500))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_PLAN_LINE INTEGER)
 AS
declare variable ID_HOTEL INTEGER;
declare variable ID_PLAN_ITEM INTEGER;
declare variable WARN_CODE INTEGER;
declare variable ROOM_TYPE VARCHAR(20);
declare variable ID_ROOM_TYPE INTEGER;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure sys_dbg(
  'exc IMPORT_HK_PLAN_LINE$EXC(:PLAN_NAME=>' || coalesce(:PLAN_NAME, '<null>')
    || ', :ID_PLAN_PERIOD=>' || coalesce(:ID_PLAN_PERIOD, '<null>')
    || ', :USE_PER_ARRIVAL=>' || coalesce(:USE_PER_ARRIVAL, '<null>')
    || ', :USE_PER_DEPARTURE=>' || coalesce(:USE_PER_DEPARTURE, '<null>')
    || ', :CYCLE_DURATION=>' || coalesce(:CYCLE_DURATION, '<null>')
    || ', :QTY=>' || coalesce(:QTY, '<null>')
    || ', :MULTIPLY_TYPE=>' || coalesce(:MULTIPLY_TYPE, '<null>')
    || ', :PLAN_ITEM=>' || coalesce(:PLAN_ITEM, '<null>')
    || ', :HOTEL_NAME=>' || coalesce(:HOTEL_NAME, '<null>')
    || ', :ROOM_TYPE_LIST=>' || coalesce(:ROOM_TYPE_LIST, '<null>')
  || ')');

  ID_PLAN_LINE = null;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'HK_PLAN', :PLAN_NAME)
  returning_values :ID_HOTEL;

  execute procedure LOOKUP_HK_PLAN_ITEM$EXC(:ID_HOTEL, :PLAN_NAME, 'HK_PLAN', :PLAN_ITEM)
  returning_values :ID_PLAN_ITEM;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:PLAN_NAME, 'HK_PLAN');

  execute procedure HK_PLAN_LINE_MODIFY$HK(null, :ID_PLAN_PERIOD, :ID_PLAN_ITEM, :USE_PER_ARRIVAL, :USE_PER_DEPARTURE, :CYCLE_DURATION, :QTY, :MULTIPLY_TYPE, 'add')
  returning_values :ID_PLAN_LINE, :WARN_CODE;

  for
    select ITEM
      from SYSTEM_STRING_PARSER(:ROOM_TYPE_LIST, ',')
      into :ROOM_TYPE
  do begin
    execute procedure LOOKUP_ROOM_TYPE$EXC(:ID_HOTEL, :PLAN_NAME, 'HK_PLAN', :ROOM_TYPE)
    returning_values :ID_ROOM_TYPE;

    execute procedure CHECK_LOOKUP_ERRORS$EXC(:PLAN_NAME, 'HK_PLAN');

    execute procedure HK_PLAN_ROOM_TYPE_MODIFY$HK(:ID_PLAN_LINE, :ID_ROOM_TYPE, 'add')
    returning_values :WARN_CODE;

  end
end
^

/* Restore proc. body: IMPORT_LIST_ITEM$EXC */
ALTER PROCEDURE IMPORT_LIST_ITEM$EXC(LIST_GROUP VARCHAR(50),
HOTEL_NAME VARCHAR(50),
LIST_ITEM VARCHAR(50))
 AS
declare variable ID_HOTEL INTEGER;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure sys_dbg(
  'exc IMPORT_LIST_ITEM$EXC(:LIST_GROUP=>' || coalesce(:LIST_GROUP, '<null>')
    || ', :HOTEL_NAME=>' || coalesce(:HOTEL_NAME, '<null>')
    || ', :LIST_ITEM=>' || coalesce(:LIST_ITEM, '<null>')
  || ')');

  ID_HOTEL = null;
  if ((HOTEL_NAME is not null) and (HOTEL_NAME <> '')) then begin
    execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME)
    returning_values :ID_HOTEL;

    if (:ID_HOTEL is null) then exit; /* don't raise - just skip unknown hotels */
  end

  if (
    not exists(
      select li.id_hotel
      from LISTS_ITEMS li
      where (li.LIST_ITEM = :LIST_ITEM and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID'))
    )
  ) then begin
    execute procedure sys_dbg(
    'exc LIST_ITEM_MODIFY(:LIST_GROUP=>' || coalesce(:LIST_GROUP, '<null>')
      || ', :ID_HOTEL=>' || coalesce(:ID_HOTEL, id_hotel, '<null>')
      || ', :LIST_ITEM=>' || coalesce(:LIST_ITEM, '<null>')
    || ':OPERATION=>add)');
    execute procedure LIST_ITEM_MODIFY(:list_group, :id_hotel, :list_item, 'add');
  end

end
^

/* Restore proc. body: IMPORT_PACKET_ITEM$EXC */
ALTER PROCEDURE IMPORT_PACKET_ITEM$EXC(PACKET_ITEM_TAG VARCHAR(30),
DESCRIPTION VARCHAR(50),
HOTEL_NAME VARCHAR(50),
UUID VARCHAR(40))
 RETURNS(ID_PACKET_ITEM INTEGER)
 AS
declare variable id_hotel integer;
declare variable operation varchar(3);
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'PACKAGE_ITEM', :DESCRIPTION)
  returning_values :ID_HOTEL;
  execute procedure CHECK_LOOKUP_ERRORS$EXC(:DESCRIPTION, 'PACKAGE_ITEM');

  ID_PACKET_ITEM = null;
  select pi.ID_PACKET_ITEM
  from   PACKET_ITEM pi
  where  pi.UUID = :UUID
         and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :ID_PACKET_ITEM;


  if (:ID_PACKET_ITEM is null) then begin
    OPERATION = 'add';
  end else begin
    OPERATION = 'mod';
  end

  execute procedure PACKET_ITEM_MODIFY(:ID_PACKET_ITEM, :PACKET_ITEM_TAG, :DESCRIPTION, :ID_HOTEL, :OPERATION)
  returning_values  :ID_PACKET_ITEM;

  update PACKET_ITEM pi
  set    pi.UUID = :UUID
  where  pi.ID_PACKET_ITEM = :ID_PACKET_ITEM;
end
^

/* Restore proc. body: IMPORT_PAYMENT_TYPE$EXC */
ALTER PROCEDURE IMPORT_PAYMENT_TYPE$EXC(UUID VARCHAR(40),
NAME VARCHAR(50),
GROUP_TAG VARCHAR(20),
DESCRIPTION VARCHAR(100),
IS_AR_DEBT SMALLINT,
IS_CASH SMALLINT,
IS_CC SMALLINT,
IS_USE SMALLINT,
FISCAL_CODE VARCHAR(50),
HOTEL_NAME VARCHAR(50))
 RETURNS(PAYMENT_TYPE_ID INTEGER)
 AS
declare variable id_hotel integer;
  declare variable old_name varchar(50);
  declare variable old_group_tag        varchar(20);
  declare variable old_description      varchar(100);
  declare variable old_is_ar_debt       smallint;
  declare variable old_is_cash          smallint;
  declare variable old_is_cc            smallint;
  declare variable old_is_use           smallint;
  declare variable old_fiscal_code      varchar(50);
  declare variable mod_op varchar(10);
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'PAYMENT_TYPE', :NAME)
  returning_values :ID_HOTEL;
  execute procedure CHECK_LOOKUP_ERRORS$EXC(:NAME, 'PAYMENT_TYPE');

  select
    id_payment_type,
    payment_type,
    group_tag,
    description,
    is_ar_debt,
    is_cash,
    is_cc,
    is_use,
    fiscal_code
  from payment_type
  where uuid=:uuid and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into
    :payment_type_id,
    :old_name,
    :old_group_tag,
    :old_description,
    :old_is_ar_debt,
    :old_is_cash,
    :old_is_cc,
    :old_is_use,
    :old_fiscal_code;

  name = coalesce(:name, :old_name);
  group_tag = coalesce(:group_tag, :old_group_tag);
  description = coalesce(:description, :old_description);
  is_ar_debt = coalesce(:is_ar_debt, :old_is_ar_debt);
  is_cash = coalesce(:is_cash, :old_is_cash);
  is_cc = coalesce(:is_cc, :old_is_cc);
  is_use = coalesce(:is_use, :old_is_use);
  fiscal_code = coalesce(:fiscal_code, :old_fiscal_code);

  if (:payment_type_id is null) then begin
    mod_op = 'add';
  end else begin
    mod_op = 'mod';
  end

  execute procedure payment_type_modify$cfg(
    :payment_type_id,
    :name,
    :group_tag,
    :description,
    :is_ar_debt,
    :is_cash,
    :is_cc,
    :is_use,
    :fiscal_code,
    :mod_op,
    :id_hotel) returning_values :payment_type_id;

  /* sync uuid field */
  update payment_type
  set uuid=:uuid
  where id_payment_type=:payment_type_id;
end
^

/* Restore proc. body: IMPORT_PROFILE_BONUS_SCHEME$EXC */
ALTER PROCEDURE IMPORT_PROFILE_BONUS_SCHEME$EXC(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PROFILE_TYPE VARCHAR(50),
BONUSPOINT_SCHEME_NAME VARCHAR(50),
HOTEL_NAME VARCHAR(100))
 AS
declare variable ID_HOTEL integer;
declare variable ID_BONUSPOINT_SCHEME integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME)
  returning_values :ID_HOTEL;

  if (:ID_HOTEL is null) then exit; /* ignore */

  execute procedure LOOKUP_BONUSPOINT_SCHEME$EXC(:ID_HOTEL, :PROFILE_NAME, :PROFILE_TYPE, :BONUSPOINT_SCHEME_NAME)
  returning_values :ID_BONUSPOINT_SCHEME;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:PROFILE_NAME, :PROFILE_TYPE);

  execute procedure PROFILE_BP_SCHEME_SET$PROFILE(:ID_PROFILE, :ID_HOTEL, :ID_BONUSPOINT_SCHEME);

end
^

/* Restore proc. body: IMPORT_PROFILE_BOOKING_DEF$EXC */
ALTER PROCEDURE IMPORT_PROFILE_BOOKING_DEF$EXC(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PROFILE_TYPE VARCHAR(50),
HOTEL_NAME VARCHAR(100),
HK_PLAN_NAME VARCHAR(30),
GUARANTEE_POLICY_NAME VARCHAR(50),
I_SPECIAL_TREATMENT VARCHAR(30))
 AS
declare variable ID_HOTEL integer;
  declare variable ID_HK_PLAN integer;
  declare variable ID_GUARANTEE_POLICY integer;
  declare variable ID_ACCOUNT_TEMPLATE integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME)
  returning_values :ID_HOTEL;

  if (:ID_HOTEL is null) then exit; /* ignore */

  execute procedure LOOKUP_HK_PLAN$EXC(:ID_HOTEL, :PROFILE_NAME, :PROFILE_TYPE, :HK_PLAN_NAME)
  returning_values :ID_HK_PLAN;

  execute procedure LOOKUP_GUARANTEE_POLICY$EXC(:ID_HOTEL, :PROFILE_NAME, :PROFILE_TYPE, :GUARANTEE_POLICY_NAME)
  returning_values :ID_GUARANTEE_POLICY;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:PROFILE_NAME, :PROFILE_TYPE);

  select pbd.ID_ACCOUNT_TEMPLATE
  from   PROFILE_BOOKING_DEFAULTS pbd
  where  pbd.ID_PROFILE = :ID_PROFILE and pbd.ID_HOTEL = :ID_HOTEL
  into   :ID_ACCOUNT_TEMPLATE;

  execute procedure PROFILE_BOOKING_DEFAULTS_MODIFY(:ID_PROFILE, :ID_HOTEL,
    :ID_HK_PLAN, :ID_GUARANTEE_POLICY, :ID_ACCOUNT_TEMPLATE, :I_SPECIAL_TREATMENT);
end
^

/* Restore proc. body: IMPORT_PROFILE_HOTEL_RATE$EXC */
ALTER PROCEDURE IMPORT_PROFILE_HOTEL_RATE$EXC(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PROFILE_TYPE VARCHAR(50),
HOTEL_NAME VARCHAR(100),
RATE_NAME VARCHAR(50))
 AS
declare variable ID_HOTEL integer;
  declare variable ID_RATE integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME)
  returning_values :ID_HOTEL;

  if (:ID_HOTEL is null) then exit; /* ignore */

  execute procedure LOOKUP_RATE$EXC(:ID_HOTEL, :PROFILE_NAME, :PROFILE_TYPE, :RATE_NAME)
  returning_values :ID_RATE;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:PROFILE_NAME, :PROFILE_TYPE);

  insert into PROFILE_HOTEL_RATE
    (ID_PROFILE, ID_HOTEL, ID_TARIFF)
  values
    (:ID_PROFILE, :ID_HOTEL, :ID_RATE);
end
^

/* Restore proc. body: IMPORT_RATE$EXC */
ALTER PROCEDURE IMPORT_RATE$EXC(TARIFA_NAME VARCHAR(50),
TARIFA_GROUP VARCHAR(30),
HOTEL_NAME VARCHAR(50),
TARIFA_CURR VARCHAR(3),
IS_ACTIVE SMALLINT,
TARIFA_NOTE VARCHAR(500),
PERIOD_DEPEND_ON_CHECKIN SMALLINT,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BOARD_TYPE VARCHAR(10),
SOURCE_BASE_BOARDS_LIST VARCHAR(255),
TMP_DATA BLOB SUB_TYPE 1,
LOCK_KEY VARCHAR(100),
LOCK_STAMP TIMESTAMP,
UUID VARCHAR(40),
RATE_TYPE VARCHAR(20),
IS_SIMPLE SMALLINT,
CHILD_AGE_INCL INTEGER,
IS_PUBLIC TYPE OF TLOGICAL,
EXPLICIT_TAX_POLICY_NAME TDESCRIPTION_SHORT = null,
EXPLICIT_POLICY_NIGHTS_REQUIRED TCOUNT = null)
 RETURNS(ID_TARIFA INTEGER,
ID_TARIFA_GROUP INTEGER,
ID_HOTEL INTEGER,
ID_TAR_SIMPLE INTEGER)
 AS
declare variable BASE_BOARDS_LIST varchar(255);
  declare variable BOARD_NAME varchar(30);
  declare variable ID_BOARD integer;
  declare variable EXPLICIT_TAX_POLICY integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure IMPORT_RATE_COMMON$EXC(:TARIFA_NAME, :TARIFA_GROUP, :HOTEL_NAME, :TARIFA_CURR, 1, :IS_ACTIVE,
    :TARIFA_NOTE, :UUID, :RATE_TYPE, :IS_SIMPLE, :IS_PUBLIC, :CHILD_AGE_INCL)
  returning_values :ID_TARIFA, :ID_TARIFA_GROUP, :ID_HOTEL;

  select ts.ID_TAR_SIMPLE
  from   TAR_SIMPLE ts
  where  ts.ID_TAR_HEAD = :ID_TARIFA
  into   :ID_TAR_SIMPLE;

  BASE_BOARDS_LIST = '';
  for
    select ITEM
    from   SYSTEM_STRING_PARSER(:SOURCE_BASE_BOARDS_LIST, ',')
    into   :BOARD_NAME
  do begin
    execute procedure LOOKUP_BOARD$EXC(:ID_HOTEL, :TARIFA_NAME, :RATE_TYPE, :BOARD_NAME, 0)
    returning_values :ID_BOARD;
    BASE_BOARDS_LIST = BASE_BOARDS_LIST || F_CHARACTER(28) || ID_BOARD;
  end

  if (:EXPLICIT_TAX_POLICY_NAME is not null) then begin
    execute procedure LOOKUP_TAX_POLICY$EXC(:ID_HOTEL, :TARIFA_NAME, :RATE_TYPE, :EXPLICIT_TAX_POLICY_NAME)
    returning_values :EXPLICIT_TAX_POLICY;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:TARIFA_NAME, :RATE_TYPE);

  update TAR_HEAD th
  set    th.PERIOD_DEPEND_ON_CHECKIN = :PERIOD_DEPEND_ON_CHECKIN,
         th.CNT_DAYS_PRICE_BP = :CNT_DAYS_PRICE_BP,
         th.CNT_DAYS_PRICE_BOARD = :CNT_DAYS_PRICE_BOARD,
         th.BASE_BOARDS_LIST = :BASE_BOARDS_LIST,
         th.BOARD_TYPE = :BOARD_TYPE,
         th.TMP_DATA = :TMP_DATA,
         th.LOCK_KEY = :LOCK_KEY,
         th.LOCK_STAMP = :LOCK_STAMP,
         th.EXPLICIT_TAX_POLICY = :EXPLICIT_TAX_POLICY,
         th.EXPLICIT_POLICY_NIGHTS_REQUIRED = :EXPLICIT_POLICY_NIGHTS_REQUIRED
  where  th.ID_TAR_HEAD = :ID_TARIFA;
end
^

/* Restore proc. body: IMPORT_RATE_AVAILABILITY$EXC */
ALTER PROCEDURE IMPORT_RATE_AVAILABILITY$EXC(IMPORT_ID VARCHAR(40),
HOTEL_NAME VARCHAR(50),
RATE_NAME VARCHAR(50),
FOR_DATE DATE,
FROM_DATE DATE,
TO_DATE DATE,
STATUS INTEGER,
AUTO_PERCENT NUMERIC(15,4),
CONDITIONS VARCHAR(100))
 AS
declare variable ID_HOTEL INTEGER;
declare variable ID_RATE INTEGER;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'CHANNEL_MANAGEMENT', :IMPORT_ID)
  returning_values :ID_HOTEL;

  execute procedure LOOKUP_RATE$EXC(:ID_HOTEL, :IMPORT_ID, 'CHANNEL_MANAGEMENT', :RATE_NAME)
  returning_values :ID_RATE;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:IMPORT_ID, 'CHANNEL_MANAGEMENT');

  if (FOR_DATE is not null) then begin
    execute procedure RATE_AVAILABILITY_MODIFY$CFG(:ID_RATE, :FOR_DATE, :STATUS, :AUTO_PERCENT, :CONDITIONS);
  end else begin
    FOR_DATE = FROM_DATE;
    while (FOR_DATE <= TO_DATE) do begin
      execute procedure RATE_AVAILABILITY_MODIFY$CFG(:ID_RATE, :FOR_DATE, :STATUS, :AUTO_PERCENT, :CONDITIONS);    
      FOR_DATE = FOR_DATE + 1;
    end
  end

end
^

/* Restore proc. body: IMPORT_RATE_COMMON$EXC */
ALTER PROCEDURE IMPORT_RATE_COMMON$EXC(TARIFA_NAME VARCHAR(50),
TARIFA_GROUP VARCHAR(30),
HOTEL_NAME VARCHAR(50),
TARIFA_CURR VARCHAR(3),
IS_BASE SMALLINT,
IS_ACTIVE SMALLINT,
TARIFA_NOTE VARCHAR(500),
UUID VARCHAR(40),
RATE_TYPE VARCHAR(20),
IS_SIMPLE SMALLINT,
IS_PUBLIC TYPE OF TLOGICAL,
CHILD_AGE_INCL INTEGER)
 RETURNS(ID_TARIFA INTEGER,
ID_TARIFA_GROUP INTEGER,
ID_HOTEL INTEGER)
 AS
declare variable OPERATION VARCHAR(10);
declare variable ID_TAR_SIMPLE integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure sys_dbg(
    'exc import_rate_common$exc(:tarifa_name=>' || coalesce(:tarifa_name, '<null>')
    || ', :uuid=>' || coalesce(:uuid, '<null>')
    || ', :hotel_name=>' || coalesce(:hotel_name, '<null>')
    || ', :rate_type=>' || coalesce(:rate_type, '<null>')
    || ', :is_simple=>' || coalesce(:is_simple, '<null>')
   || ')');

  execute procedure LOOKUP_HOTEL$EXC(HOTEL_NAME, :RATE_TYPE, :TARIFA_NAME)
  returning_values :ID_HOTEL;
  execute procedure CHECK_LOOKUP_ERRORS$EXC(:TARIFA_NAME, :RATE_TYPE);

  execute procedure IMPORT_RATE_GROUP$EXC(:TARIFA_GROUP)
  returning_values :ID_TARIFA_GROUP;

  ID_TARIFA = null;
  select t.ID_TARIFA
  from   TARIFA t
  where  t.UUID = :UUID
         and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :ID_TARIFA;

  if (:IS_BASE > 0) then begin
    OPERATION = 'import';
  end else begin
    OPERATION = 'addextra';
  end

  if (:ID_TARIFA is not null) then begin
    OPERATION = 'mod';
    if (:IS_BASE > 0) then begin
      -- delete base rate dependant objects
      if (:IS_SIMPLE = 0) then begin
        delete from TAR_UI_BUSINESS_OBJECTS_DEF bo
        where  bo.ID_TAR_HEAD = :ID_TARIFA;

        delete from TAR_UI_DEFINE_COLUMNS c
        where  c.ID_TAR_HEAD = :ID_TARIFA;
      end else begin
        select ts.ID_TAR_SIMPLE
        from   TAR_SIMPLE ts
        where  ts.ID_TAR_HEAD = :ID_TARIFA
        into   :ID_TAR_SIMPLE;

        if (:ID_TAR_SIMPLE is not null) then begin
          delete from TAR_SIMPLE_SEASON tss
          where  tss.ID_TAR_SIMPLE = :ID_TAR_SIMPLE;
        end
      end
    end else begin
      -- delete nonbase rate dependant objects
      delete from TARIFA_PERIODS tp
      where  tp.ID_TARIFA = :ID_TARIFA;
    end
  end

  execute procedure sys_dbg(
    'exc import_rate_common$exc => tarifa_modify$cfg(:id_tarifa=>' || coalesce(:id_tarifa, '<null>')
    || ', :operation=>' || coalesce(:operation, '<null>')
    || ', :tarifa_name=>' || coalesce(:tarifa_name, '<null>')
    || ', :id_hotel=>' || coalesce(:id_hotel, '<null>')
    || ', :is_simple=>' || coalesce(:is_simple, '<null>')
   || ')');

  execute procedure TARIFA_MODIFY$CFG(:ID_TARIFA, null, :TARIFA_NAME, :ID_TARIFA_GROUP,
    :TARIFA_CURR, :IS_ACTIVE, :TARIFA_NOTE, :ID_HOTEL, :IS_SIMPLE, :CHILD_AGE_INCL, :IS_PUBLIC, :OPERATION)
  returning_values :ID_TARIFA;

  update TARIFA t
  set    t.UUID = :UUID
  where  t.ID_TARIFA = :ID_TARIFA;
end
^

/* Restore proc. body: IMPORT_RATE_EXTRA$EXC */
ALTER PROCEDURE IMPORT_RATE_EXTRA$EXC(TARIFA_NAME VARCHAR(50),
TARIFA_GROUP VARCHAR(30),
HOTEL_NAME VARCHAR(50),
TARIFA_CURR VARCHAR(3),
IS_ACTIVE SMALLINT,
TARIFA_NOTE VARCHAR(500),
UUID VARCHAR(40))
 RETURNS(ID_TARIFA INTEGER,
ID_TARIFA_GROUP INTEGER,
ID_HOTEL INTEGER)
 AS
declare variable rate_type varchar(10);
begin
  execute procedure import_mark_transaction$exc;
  rate_type = 'RATE_EXTRA';

  execute procedure LOOKUP_HOTEL$EXC(HOTEL_NAME, :rate_type, :TARIFA_NAME)
  returning_values :ID_HOTEL;
  execute procedure CHECK_LOOKUP_ERRORS$EXC(:TARIFA_NAME, :rate_type);

  /* there should be ONLY one extra rate per hotel, so assign the UUID and continue */
  update tarifa set uuid = :uuid
  where id_tarifa = (/* update ONLY one of the extra rates (in theory ONLY one should exist)  */
                     select first 1 id_tarifa from tarifa where id_hotel = :id_hotel and is_extra=1);

  execute procedure IMPORT_RATE_COMMON$EXC(:TARIFA_NAME, :TARIFA_GROUP, :HOTEL_NAME, :TARIFA_CURR, 0,
    :IS_ACTIVE, :TARIFA_NOTE, :UUID, :rate_type, 0, 1, null)
  returning_values :ID_TARIFA, :ID_TARIFA_GROUP, :ID_HOTEL;

end
^

/* Restore proc. body: IMPORT_RATE_PRICE$EXC */
ALTER PROCEDURE IMPORT_RATE_PRICE$EXC(ID_RATE_PERIOD INTEGER,
PRICE NUMERIC(15,2),
SERVICE VARCHAR(30))
 AS
declare variable id_service integer;
  declare variable rate_name varchar(50);
  declare variable id_hotel integer;
begin
  execute procedure import_mark_transaction$exc;

  select t.TARIFA_NAME, t.ID_HOTEL
  from   TARIFA_PERIODS tp
         join TARIFA t on tp.ID_TARIFA = t.ID_TARIFA
  where  tp.ID_TARIFA_PERIOD = :ID_RATE_PERIOD
  into   :rate_name, :id_hotel;

  execute procedure LOOKUP_SERVICE$EXC(:id_hotel, :RATE_NAME, 'RATE_EXTRA', :SERVICE)
  returning_values :ID_SERVICE;
  execute procedure CHECK_LOOKUP_ERRORS$EXC(:RATE_NAME, 'RATE_EXTRA');

  execute procedure TARIFA_PRICE_MODIFY$CFG(:ID_RATE_PERIOD, :PRICE, :ID_SERVICE);
end
^

/* Restore proc. body: IMPORT_RATE_SIMPLE_BOARD$EXC */
ALTER PROCEDURE IMPORT_RATE_SIMPLE_BOARD$EXC(ID_HOTEL INTEGER,
ID_TAR_SIMPLE_SEASON INTEGER,
RATE_NAME VARCHAR(30),
BOARD_NAME VARCHAR(30),
ADULT_PRICE NUMERIC(15,4),
CHILD_PRICE NUMERIC(15,4))
 RETURNS(ID_TAR_SIMPLE_BOARDS INTEGER)
 AS
declare variable ID_BOARD_TYPE integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_BOARD$EXC(:ID_HOTEL, :RATE_NAME, 'RATE_SIMPLE', :BOARD_NAME, 1)
  returning_values :ID_BOARD_TYPE;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:RATE_NAME, 'ROOM_TYPE');

  execute procedure TAR_SIMPLE_BOARD_MODIFY$CFG(null,
                                                :ID_TAR_SIMPLE_SEASON,
                                                :ID_BOARD_TYPE,
                                                :ADULT_PRICE,
                                                :CHILD_PRICE,
                                                'add')
  returning_values :ID_TAR_SIMPLE_BOARDS;
end
^

/* Restore proc. body: IMPORT_RATE_SIMPLE_PRICE$EXC */
ALTER PROCEDURE IMPORT_RATE_SIMPLE_PRICE$EXC(ID_TAR_SIMPLE_SEASON INTEGER,
RATE_NAME VARCHAR(30),
HOTEL_NAME VARCHAR(50),
ROOM_TYPE VARCHAR(20),
BOARD_NAME VARCHAR(30),
SINGLE_PRICE NUMERIC(15,4),
DOUBLE_PRICE NUMERIC(15,4),
GUEST3_PRICE NUMERIC(15,4),
GUEST4PLUS_PRICE NUMERIC(15,4),
CHILD1_W_ADULT1_PRICE NUMERIC(15,4),
CHILD1_W_ADULT2PLUS_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT1_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT2PLUS_PRICE NUMERIC(15,4),
IS_BASE_DAYS_PRICE SMALLINT)
 AS
declare variable ID_HOTEL integer;
declare variable ID_ROOM_TYPE integer;
declare variable ID_BOARD_TYPE integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'RATE_SIMPLE', :RATE_NAME)
  returning_values :ID_HOTEL;

  execute procedure LOOKUP_ROOM_TYPE$EXC(:ID_HOTEL, :RATE_NAME, 'RATE_SIMPLE', :ROOM_TYPE)
  returning_values :ID_ROOM_TYPE;

  execute procedure LOOKUP_BOARD$EXC(:ID_HOTEL, :RATE_NAME, 'RATE_SIMPLE', :BOARD_NAME, 1)
  returning_values :ID_BOARD_TYPE;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:RATE_NAME, 'RATE_SIMPLE');

  execute procedure TAR_SIMPLE_PRICE_MODIFY$CFG(:ID_TAR_SIMPLE_SEASON,
                                                :ID_ROOM_TYPE,
                                                :ID_BOARD_TYPE,
                                                :SINGLE_PRICE,
                                                :DOUBLE_PRICE,
                                                :GUEST3_PRICE,
                                                :GUEST4PLUS_PRICE,
                                                :CHILD1_W_ADULT1_PRICE,
                                                :CHILD1_W_ADULT2PLUS_PRICE,
                                                :CHILD2PLUS_W_ADULT1_PRICE,
                                                :CHILD2PLUS_W_ADULT2PLUS_PRICE,
                                                :IS_BASE_DAYS_PRICE);
end
^

/* Restore proc. body: IMPORT_ROOM_TYPE$EXC */
ALTER PROCEDURE IMPORT_ROOM_TYPE$EXC(TYPE_ROOM VARCHAR(20),
BEDS INTEGER,
EXT_CODE VARCHAR(30),
UUID VARCHAR(40),
HOTEL_NAME VARCHAR(50))
 RETURNS(ID_ROOM_TYPE INTEGER)
 AS
declare variable ID_HOTEL INTEGER;
declare variable OPERATION VARCHAR(3);
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'ROOM_TYPE', :TYPE_ROOM)
  returning_values :ID_HOTEL;
  execute procedure CHECK_LOOKUP_ERRORS$EXC(:TYPE_ROOM, 'ROOM_TYPE');

  ID_ROOM_TYPE = null;
  select rt.ID_ROOM_TYPE
  from ROOM_TYPES rt
  where rt.UUID = :UUID and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :ID_ROOM_TYPE;

  if (ID_ROOM_TYPE is null) then begin
    OPERATION = 'add';
  end else begin
    OPERATION = 'mod';
  end

  execute procedure ROOM_TYPE_MODIFY$CFG(:ID_HOTEL, :ID_ROOM_TYPE, :TYPE_ROOM, :BEDS, :EXT_CODE, :OPERATION)
  returning_values :ID_ROOM_TYPE;

  update ROOM_TYPES rt
    set rt.UUID = :UUID
    where rt.ID_ROOM_TYPE = :ID_ROOM_TYPE;
end
^

/* Restore proc. body: IMPORT_SALE_DISCOUNT$EXC */
ALTER PROCEDURE IMPORT_SALE_DISCOUNT$EXC(UUID VARCHAR(40),
DISCOUNT_NAME VARCHAR(50),
DISCOUNTED_VALUE_TYPE VARCHAR(50),
DISCOUNT_VALUE NUMERIC(15,4),
DISCOUNT_CALC_METHOD VARCHAR(50),
SERVICE_NAME VARCHAR(50),
SERVICE_DEPENDENCE_TYPE VARCHAR(50),
DEPENDENCE_SRV_GROUPS VARCHAR(1000),
IS_ARCHIVE SMALLINT,
FIXED_DISCOUNT_CURRENCY CHAR(3),
HOTEL_NAME VARCHAR(50))
 RETURNS(SALE_DISCOUNT_ID INTEGER)
 AS
declare variable old_discount_name varchar(50);
  declare variable old_discounted_value_type varchar(50);
  declare variable old_discount_value numeric(15,4);
  declare variable old_discount_calc_method varchar(50);
  declare variable old_service_dependence_type varchar(50);
  declare variable dependence_srv_groups_idlist varchar(1000);
  declare variable old_is_archive smallint;
  declare variable old_fixed_discount_currency char(3);
  declare variable mod_op varchar(10);
  declare variable id_service INTEGER;
  declare variable sg_id INTEGER;
  declare variable sg_name varchar(50);
  declare variable id_hotel integer;
begin
  -- TODO - discounts are per hotel by now
  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'SALE_DISCOUNT', :DISCOUNT_NAME)
  returning_values :ID_HOTEL;
  execute procedure CHECK_LOOKUP_ERRORS$EXC(:DISCOUNT_NAME, 'SALE_DISCOUNT');

  if (:service_name is not null) then begin
    execute procedure lookup_service$exc(:id_hotel, :uuid, 'SALE_DISCOUNT', :service_name)
    returning_values :id_service;
    execute procedure check_lookup_errors$exc(:UUID, 'SALE_DISCOUNT');
  end else begin
    id_service = null;
  end

  select
      id_sale_discount,
      discount_name,
      discounted_value_type,
      discount_value,
      discount_calc_method,
      service_dependence_type,
      is_archive,
      fixed_discount_currency
  from sale_discount
  where uuid=:uuid and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :sale_discount_id,
      :old_discount_name,
      :old_discounted_value_type,
      :old_discount_value,
      :old_discount_calc_method,
      :old_service_dependence_type,
      :old_is_archive,
      :old_fixed_discount_currency;

  discount_name = coalesce(:discount_name, old_discount_name);
  discounted_value_type = coalesce(:discounted_value_type, old_discounted_value_type);
  discount_value = coalesce(:discount_value, old_discount_value);
  discount_calc_method = coalesce(:discount_calc_method, old_discount_calc_method);
  service_dependence_type = coalesce(:service_dependence_type, old_service_dependence_type);
  is_archive = coalesce(:is_archive, old_is_archive);
  fixed_discount_currency = coalesce(:fixed_discount_currency, old_fixed_discount_currency);

  dependence_srv_groups_idlist = null;
  for select sp.item
  from system_string_parser (:dependence_srv_groups, ',') sp
  into :sg_name
  do begin
    execute procedure import_service_group$exc(:id_hotel, :sg_name)
    returning_values :sg_id;
    if (:dependence_srv_groups_idlist is null) then begin
      dependence_srv_groups_idlist = '' || :sg_id;
    end else begin
      dependence_srv_groups_idlist = :dependence_srv_groups_idlist || ',' || :sg_id;
    end
  end

  if (:sale_discount_id is null) then begin
    mod_op = 'add';
  end else begin
    mod_op = 'mod';
    if (dependence_srv_groups_idlist is null) then begin
      for select ds.id_service_group
      from sale_discount_services ds
      where ds.id_sale_discount = :sale_discount_id
      into :sg_id
      do begin
        if (:dependence_srv_groups_idlist is null) then begin
          dependence_srv_groups_idlist = '' || :sg_id;
        end else begin
          dependence_srv_groups_idlist = :dependence_srv_groups_idlist || ',' || :sg_id;
        end
      end
    end
  end

  execute procedure sale_discount_modify$cfg(
    :sale_discount_id,
    :discount_name,
    :discounted_value_type,
    :discount_value,
    :discount_calc_method,
    :id_service,
    :fixed_discount_currency,
    :service_dependence_type,
    :dependence_srv_groups_idlist,
    :is_archive,
    :mod_op,
    :id_hotel) returning_values :sale_discount_id;

  /* sync uuid field */
  update sale_discount
  set uuid=:uuid
  where id_sale_discount=:sale_discount_id;
end
^

/* Restore proc. body: IMPORT_SERVICE$EXC */
ALTER PROCEDURE IMPORT_SERVICE$EXC(SERVICE_NAME VARCHAR(30),
SERVICE_GROUP VARCHAR(30),
SERVICE_TYPE VARCHAR(50),
IS_DELETED SMALLINT,
IS_MANUAL_PRICE SMALLINT,
IS_DETAILS SMALLINT,
REVENUE_GROUP VARCHAR(50),
REVENUE_ACCOUNT VARCHAR(50),
ACCOUNT_NAME VARCHAR(30),
EXT_CODE VARCHAR(30),
VAUCHER_PACKET VARCHAR(20),
EXTRA_PACKET_NAME VARCHAR(10),
IS_RATE_PRICE SMALLINT,
IS_BREAKFAST SMALLINT,
IS_LUNCH SMALLINT,
IS_DINNER SMALLINT,
IS_EXTRAFOOD1 SMALLINT,
IS_EXTRAFOOD2 SMALLINT,
IS_BOARD SMALLINT,
PRICE NUMERIC(15,4),
PRICE_CURR VARCHAR(3),
HOTEL_NAME VARCHAR(50),
UUID VARCHAR(40))
 RETURNS(ID_SERVICE INTEGER,
ID_SERVICE_GROUP INTEGER)
 AS
declare variable ID_HOTEL integer;
declare variable OPERATION VARCHAR(3);
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'SERVICE', :SERVICE_NAME)
  returning_values :ID_HOTEL;
  execute procedure CHECK_LOOKUP_ERRORS$EXC(:SERVICE_NAME, 'SERVICE');

  execute procedure IMPORT_SERVICE_GROUP$EXC(:ID_HOTEL, :SERVICE_GROUP)
  returning_values :ID_SERVICE_GROUP;

  ID_SERVICE = null;
  select s.ID_SERVICE
  from   SERVICES s
  where  s.UUID = :UUID
         and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :ID_SERVICE;

  if (:ID_SERVICE is null) then begin
    OPERATION = 'add';
  end else begin
    OPERATION = 'mod';
  end

  if (:EXTRA_PACKET_NAME is null) then begin
    EXTRA_PACKET_NAME = '';
  end

  execute procedure SERVICE_MODIFY(:ID_SERVICE, :ID_SERVICE_GROUP, :SERVICE_TYPE, :SERVICE_NAME,
    :IS_DELETED, :IS_MANUAL_PRICE, :IS_DETAILS, :REVENUE_GROUP, :REVENUE_ACCOUNT,
    :ACCOUNT_NAME, :EXT_CODE, :VAUCHER_PACKET, :EXTRA_PACKET_NAME, :IS_RATE_PRICE,
    :OPERATION, :ID_HOTEL, :IS_BREAKFAST, :IS_LUNCH, :IS_DINNER, :IS_EXTRAFOOD1, :IS_EXTRAFOOD2,
    :IS_BOARD, :PRICE, :PRICE_CURR)
  returning_values :ID_SERVICE;

  update SERVICES s
  set    s.UUID = :UUID
  where  s.ID_SERVICE = :ID_SERVICE;
end
^

/* Restore proc. body: IMPORT_SETTING_HOTEL_VALUE$EXC */
ALTER PROCEDURE IMPORT_SETTING_HOTEL_VALUE$EXC(SETTING_CODE VARCHAR(30),
SETTING_VALUE VARCHAR(50),
HOTEL_NAME VARCHAR(50))
 AS
declare variable ID_HOTEL integer;
begin
  execute procedure IMPORT_MARK_TRANSACTION$EXC;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'SETTING', :SETTING_CODE)
  returning_values :ID_HOTEL;
  execute procedure CHECK_LOOKUP_ERRORS$EXC(:SETTING_CODE, 'SETTING');


  update SETTING_HOTEL_VALUE sv
    set sv.SETTING_VALUE = :SETTING_VALUE
    where sv.SETTING_CODE = :SETTING_CODE and sv.ID_HOTEL = :ID_HOTEL;

  if (row_count = 0) then begin
    insert into SETTING_HOTEL_VALUE (SETTING_CODE, ID_HOTEL, SETTING_VALUE)
    values (:SETTING_CODE, :ID_HOTEL, :SETTING_VALUE);
  end

end
^

/* Restore proc. body: MONITOR_ROOM_GANTT$HM */
ALTER PROCEDURE MONITOR_ROOM_GANTT$HM(FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ID_ROOM INTEGER,
GFROM_DATE DATE,
IS_MOVED_FROM INTEGER,
GTO_DATE DATE,
IS_MOVED_TO INTEGER,
BUSY_GRP INTEGER,
OCCUPANT_ID INTEGER,
IN_SHARE SMALLINT,
ID_GROUP INTEGER,
ATTENTION_STATUS SMALLINT)
 AS
declare variable contiguous_id_room integer;
begin
  for
    select ID_ROOM, GFROM_DATE, IS_MOVED_FROM, GTO_DATE,
           IS_MOVED_TO, BUSY_GRP, OCCUPANT_ID
    from   MONITOR_ROOM_GANTT$INT(:from_date, :to_date)
    into   :id_room, :gfrom_date, :is_moved_from, :gto_date,
           :is_moved_to, :busy_grp, :occupant_id
  do begin
    if (:gfrom_date = :from_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gfrom_date - 1)
      into   :contiguous_id_room;

      if ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_from = 1;

      select O.FROM_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gfrom_date;
    end

    if (:gto_date = :to_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gto_date + 1)
      into   :contiguous_id_room;

      if ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_to = 1;

      select O.TO_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gto_date;
    end

    if (:busy_grp in (1, 24)) then begin
      select RI.ATTENTION_STATUS, RI.ID_GROUP, RI.IN_SHARE
      from   RES_GET_INFO$RSV(:occupant_id, 0, 1, 0) RI
      into   :attention_status, :id_group, :in_share;
    end else begin
      id_group = null;
      attention_status = null;
      in_share = null;
      if (exists(
        select *
        from   ROOMS_SHARE RS
        where  RS.ID_RESERV_DETAIL = :occupant_id
      )) then in_share = 1;
      else in_share = 0;
    end
    suspend;
  end
end
^

/* Restore proc. body: MONITOR_ROOM_GANTT_OCCUPANT$HM */
ALTER PROCEDURE MONITOR_ROOM_GANTT_OCCUPANT$HM(FROM_DATE DATE,
TO_DATE DATE,
REQUEST_OCCUPANT_ID INTEGER)
 RETURNS(ID_ROOM INTEGER,
GFROM_DATE DATE,
IS_MOVED_FROM INTEGER,
GTO_DATE DATE,
IS_MOVED_TO INTEGER,
BUSY_GRP INTEGER,
OCCUPANT_ID INTEGER,
IN_SHARE SMALLINT,
ID_GROUP INTEGER,
ATTENTION_STATUS SMALLINT)
 AS
declare variable contiguous_id_room integer;
begin
  for
    select ID_ROOM, GFROM_DATE, IS_MOVED_FROM, GTO_DATE,
           IS_MOVED_TO, BUSY_GRP, OCCUPANT_ID
    from   MONITOR_ROOM_GANTT$INT(:from_date, :to_date, :request_occupant_id)
    into   :id_room, :gfrom_date, :is_moved_from, :gto_date,
           :is_moved_to, :busy_grp, :occupant_id
  do begin
    if (:gfrom_date = :from_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gfrom_date - 1)
      into   :contiguous_id_room;

      if     ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_from = 1;

      select O.FROM_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gfrom_date;
    end

    if (:gto_date = :to_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gto_date + 1)
      into   :contiguous_id_room;

      if ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_to = 1;

      select O.TO_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gto_date;
    end

    if (exists(
      select *
      from   ROOMS_SHARE RS
      where  RS.ID_ROOM = :id_room
             and RS.BUSY_DATE between :from_date and :to_date
    )) then in_share = 1;
    else in_share = 0;
  
    if (:busy_grp in (1,24)) then begin
      select RI.ATTENTION_STATUS, RI.ID_GROUP
      from   RES_GET_INFO$RSV(:occupant_id, 0, 0, 0) RI
      into   :attention_status, :id_group;
    end else begin
      id_group = null;
      attention_status = null;
    end
    suspend;
  end
end
^

/* Restore proc. body: OCCUPANT_GET_INFO */
ALTER PROCEDURE OCCUPANT_GET_INFO(ID_OCCUPANT INTEGER,
IN_BUSY_GRP INTEGER = null)
 RETURNS(BUSY_GRP INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
INFO VARCHAR(1024))
 AS
declare variable max_day_action integer;
begin
  --busy_grp = :in_busy_grp;

  select max(RM.DAY_ACTION_INT), min(rm.BUSY_GROUP_TYPE)
  from   ROOM_MAGIC RM
  where  RM.ID_RESERV_DETAIL = :ID_OCCUPANT
         --and RM.BUSY_GROUP_TYPE = :busy_grp
  into   :max_day_action, :busy_grp;

  if (:busy_grp in (18, 20) and :max_day_action = 0) then begin
    select BGI.BUSY_GRP, BGI.REASON, BGI.FROM_DATE, BGI.TO_DATE
    from   BLOCK_GET_INFO(:id_occupant) BGI
    into   :busy_grp, :info, :from_date, :to_date;
  end else begin
    -- when :busy_grp in (1, 24) or (:max_day_action > 0) - reservation with block busy group type - owners, as an example
    select RGI.BUSY_GRP, RGI.NUMBER, RGI.ARRIVAL_DATE, RGI.DEPARTURE_DATE
    from   RES_GET_INFO$RSV(:id_occupant, 0, 0, 0) RGI
    into   :busy_grp, :info, :from_date, :to_date;
  end

  suspend;
end
^

/* Restore proc. body: PMS_IMPORT */
ALTER PROCEDURE PMS_IMPORT(ID_EXPORT_HEAD INTEGER)
 AS
begin

  execute procedure PMS_IMPORT$INT(:ID_EXPORT_HEAD);

end
^

/* Restore proc. body: PROFILE_COMMON_MODIFY$INT */
ALTER PROCEDURE PROFILE_COMMON_MODIFY$INT(ID_PROFILE INTEGER,
PROFILE_TYPE VARCHAR(20),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
IS_ARCHIVE INTEGER,
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable action_text varchar(255);
  declare variable old_profile_name varchar(100);
  declare variable old_is_archive integer;
  declare variable p_dbkey char(8);
begin
  p_dbkey = null;
  select P.RDB$DB_KEY, P.PROFILE_NAME, P.IS_ARCHIVE
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :p_dbkey, :old_profile_name, :old_is_archive;
   
  is_exclusive_debt_ownership = coalesce(:is_exclusive_debt_ownership, 0);
  new_id_profile = :id_profile;
  if (:p_dbkey is null) then begin
    execute procedure SYSTEM_CHECK_OPERATION (:PROFILE_TYPE, 'PERSON,AGENT,HOUSE', 'Profile type');

    new_id_profile = gen_id(gen_profile_id, 1);
    insert into PROFILE (ID_PROFILE, PROFILE_NAME, PROFILE_TYPE,
           PHONE, FAX, EMAIL, CITY, ADDRESS, NOTE, MSG,
           ID_DEF_CONTRAGENT, ID_NOM_MARKET_SEGMENT, IS_ARCHIVE, ACCOUNT_NO,
           WBE_PASSWORD, IS_EXCLUSIVE_DEBT_OWNERSHIP)
    values (:new_id_profile, :profile_name, :profile_type,
           :phone, :fax, :email, :contact_city, :contact_address, :note, :msg,
           :id_def_contragent, :id_nom_market_segment, 0, :account_no,
           nullif(:wbe_password, ''), :is_exclusive_debt_ownership)
    returning RDB$DB_KEY into :p_dbkey;
  end else begin
    update PROFILE PU
    set    PU.PROFILE_NAME = :profile_name,
           PU.PHONE = :phone,
           PU.FAX = :fax,
           PU.EMAIL = :email,
           PU.CITY = :contact_city,
           PU.ADDRESS = :contact_address,
           PU.NOTE = :note,
           PU.MSG = :msg,
           PU.ID_DEF_CONTRAGENT = :id_def_contragent,
           PU.ID_NOM_MARKET_SEGMENT = :id_nom_market_segment,
           PU.ACCOUNT_NO = :ACCOUNT_NO,
           PU.WBE_PASSWORD = iif(PU.WBE_PASSWORD is null and :wbe_password = '', null, :wbe_password),
           -- empty ('') new password should not relpace NULLs,
           -- empty password indicate for 'deleted real password'
           PU.IS_EXCLUSIVE_DEBT_OWNERSHIP = :IS_EXCLUSIVE_DEBT_OWNERSHIP
    where  PU.RDB$DB_KEY = :p_dbkey;
  
    if (:old_profile_name <> :profile_name) then begin
      action_text = f_character(29) || :old_profile_name || f_character(28) || :profile_name;
      execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'EDIT_NAME', :action_text);
    end
  
    if (:is_archive is distinct from :old_is_archive) then
      execute procedure PROFILE_SET_ARCHIVE$INT (:P_DBKEY, :IS_ARCHIVE);
   end
end
^

/* Restore proc. body: REP_ROOM_STATUS$INT */
ALTER PROCEDURE REP_ROOM_STATUS$INT(FOR_DATE DATE,
STAT_OPTIONS VARCHAR(255),
PRIVATE_STATUS_ADDING SMALLINT = 0)
 RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
SECTOR INTEGER,
ID_ROOM_TYPE INTEGER,
TYPE_ROOM VARCHAR(20),
IS_CLEAN INTEGER,
IS_INSPECTED INTEGER,
CLEAN_TEXT VARCHAR(30),
IS_LEAVING SMALLINT,
IS_COMMING SMALLINT,
IS_SHARED SMALLINT,
IS_LEAVING_WORDS VARCHAR(30),
BUSY_GRP INTEGER,
DAYS_THIS_STATUS INTEGER,
DTS_CONTEXT VARCHAR(10),
COMMING_OCCUPANTS VARCHAR(1024),
ID_BLOCK_ROOM INTEGER,
OTHER_OCCUPANTS VARCHAR(1024),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ID_HOTEL INTEGER,
HAS_OPENED_POSTINGS SMALLINT)
 AS
declare variable dbg varchar(6000);
  declare variable id_room_tmp integer;
  declare variable id_room_magic integer;
  declare variable occupant_id integer;
begin
  for
    select RM.ID_ROOM_MAGIC, RM.ID_ROOM
    from   ROOMS R
           join TMP_SMART_ROOMS TSR on TSR.ID_ROOM = R.ID_ROOM
                and TSR.ID_SESSION = current_connection
           join ROOM_MAGIC RM on RM.ID_ROOM = R.ID_ROOM
    where  RM.BUSY_DATE = :for_date
    into   :id_room_magic, :id_room_tmp
  do begin
    insert into TMP_HM_ROOM_STATUS (ID_ROOMS_MAGIC, ID_SESSION, ID_ROOM)
    values (:id_room_magic, current_transaction, :id_room_tmp);
  end

  for
    select R.ID_ROOM, R.ROOM_NAME, R.FLOOR, R.ID_ROOM_TYPE,
           R.IS_CLEAN, R.CLEAN_TEXT, R.IS_INSPECTED,
           RT.TYPE_ROOM, RT.ID_HOTEL, R.SECTOR
    from   (select distinct P.ID_ROOM
            from   TMP_SMART_ROOMS TSR
                   join ROOM_PERIOD$PMS P on P.ID_ROOM = TSR.ID_ROOM
            where  TSR.ID_SESSION = current_connection
                   and ((P.IS_AVAILABLE = 1) or (:private_status_adding = 1))
                   and P.FROM_DATE <= :for_date
                   and P.TO_DATE >= :for_date) AVR
           join ROOMS R on AVR.ID_ROOM = R.ID_ROOM
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    into   :id_room, :room_name, :floor, :id_room_type,
           :is_clean, :clean_text, :is_inspected,
           :type_room, :id_hotel, :sector
  do begin

    execute procedure REP_ROOM_STATUS_BUILD$INT(:id_room, :for_date, :stat_options)
    returning_values  :is_leaving, :is_comming, :is_shared, :is_leaving_words, :busy_grp,
                      :days_this_status, :dts_context, :comming_occupants, :id_block_room,
                      :other_occupants, :adult_count, :children_count;

    is_comming = iif(:comming_occupants = '', 0, 1);

    HAS_OPENED_POSTINGS = 0;
    for
      select distinct sp.ITEM
      from   SYSTEM_STRING_PARSER (:other_occupants || ',' || :COMMING_OCCUPANTS, ',') SP
      into   :occupant_id
    do begin
      execute procedure RES_GET_BALLANCE$INT (:occupant_id)
      returning_values :dbg, :dbg, :dbg, :HAS_OPENED_POSTINGS, :dbg;
      if (:HAS_OPENED_POSTINGS = 1) then break;
    end

    suspend;

  end

  delete from TMP_HM_ROOM_STATUS HM
  where  HM.ID_SESSION = current_transaction;
end
^

/* Restore proc. body: RES_CREATE_SET$EXC */
ALTER PROCEDURE RES_CREATE_SET$EXC(ID_RESERV_DETAIL INTEGER,
RES_NUMBER VARCHAR(62),
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER,
CREATE_DATETIME TIMESTAMP)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_RESERV_DETAIL INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  WARN_CODE = 0;
  SHARE_TRANSACTION_ID = 0;
  SHARE_ERR_CODE = 0;

  execute procedure sys_dbg('exc RES_CREATE_SET$EXC => RES_CREATE_SET$INT('
  || 'code_first_food=>' || coalesce(:code_first_food, '<null>')
  || ', id_person_payment=>' || coalesce(:id_person_payment, '<null>')
  || ')');

  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, null, :arrival_date, :departure_date,
                    :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, '', :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders, :guarantee_deposit,
                    :guarantee_currency, 0, :id_reserv_detail, :res_number, null,  :id_guarantee_policy, :block_cc,
                    :id_eating_object)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :warn_code;

  execute procedure UPDATE_POSTING_TRANSACTION$EXC(:rd_dbkey, :posting_transaction_uuid, 1);

  execute procedure RES_SAVE_GUARANTEE$RSV(:id_reserv_detail, :is_vip, null,
    :id_guarantee_policy, :guarantee_deposit, :guarantee_currency, :block_cc, :guarantee_deposit_percent,
    :guarantee_deposit_nights, :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create
  );

  execute procedure RESERV_DETAIL_EXTERNAL_MOD$RSV(:id_reserv_detail,
    :minibar_rights, :paytv_rights, :video_rights, :nopost_pms, :phone_rights,
    :seminar_cahnnel_rights, null
  );

  if (:create_datetime is not null) then begin
    update reserv_detail set create_datetime = :create_datetime where rdb$db_key = :rd_dbkey;
  end
end
^

/* Restore proc. body: RES_EARLY_DEPARTURE_SET$RSV */
ALTER PROCEDURE RES_EARLY_DEPARTURE_SET$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND INTEGER)
 RETURNS(RECALC_MARKER_LIST VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable sys_date date;
  declare variable stay integer;
  declare variable rd_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable id_hotel integer;
  declare variable hotels_cnt integer;
  declare variable arrival_date date;
  declare variable is_late_departure smallint;
  declare variable comming_kind smallint;
  declare variable dep_date date;
begin
  /* CHECK_OUT_kind =
  || 1 - DO NOT MODIFY GUEST
  || 2 - SHRINK PERIOD AND OCCUPANCY
  || 3 - DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
  */
  execute procedure RIGHTS_CHECK_GRANTED$INT('CHECK_OUT_EARLY');

  select min(RD.ID_HOTEL), count(distinct RD.ID_HOTEL)
  from   RESERV_DETAIL RD
  where  RD.SELECTION_ID = :SELECTION_ID
  into   :id_hotel, :hotels_cnt;

  if (:hotels_cnt > 1) then exception RESERV_CHECK_OUT_EXCEPTION '-1020';

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values  :sys_date;

  RECALC_MARKER_LIST = null;
  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL, rd.FROM_DATE, rd.TO_DATE, RD.LEAVING_KIND - 1, rd.COMMING_KIND
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :rd_dbkey, :id_reserv_detail, :arrival_date, :dep_date, :is_late_departure, :comming_kind
  do begin
    if ((:check_out_kind = 2) and (:dep_date > :sys_date)) then begin
      -- SHRINK PERIOD AND OCCUPANCY
      execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :sys_date, :is_late_departure, :comming_kind);
    
      execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
      returning_values  :warn_code;

    end else if ((:check_out_kind = 1) and (:dep_date > :sys_date)) then begin
      /* KEEP BOOKING STAY PERIOD AND ROOM OCCUPANCY */
      for
        select G.TO_DATE - :sys_date
        from   GUEST G
        where  G.ID_RESERV_DETAIL = :id_reserv_detail
        into   :stay
      do begin
  --      if (:check_out_kind = 1) then begin
        if (:stay > 1) then begin
            --THE DEPARTURE DATE IS LATER THAN NEXT DATE. STAY SHOULD BE CHANGED MANUALY.;
            exception RESERV_CHECK_OUT_EXCEPTION '-323';
        end
      end
    end
  end
end
^

/* Restore proc. body: RES_FINALIZE_RECALC$INT */
ALTER PROCEDURE RES_FINALIZE_RECALC$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_calc integer;
begin
  -- NORMAL recalculation processing
  execute procedure RES_RECALC$INT(:rd_dbkey, 'NORMAL', 0)
  returning_values  :err_code, :err_text, :id_tar_calc;
  if (:err_code < 0) then exit;

end
^

/* Restore proc. body: RES_GUEST_CHANGE$RSV */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable id_guest integer;
  declare variable check_status integer;
  declare variable id_person_data integer;
  declare variable old_person_profile integer;
  declare variable old_profile_name varchar(100);
  declare variable new_profile_name varchar(100);
begin
  select r.RDB$DB_KEY, r.ID_TITULAR, r.CHECK_STATUS, r.ID_PERSON_PROFILE, p.PROFILE_NAME
  from   RESERV_DETAIL R
         join PROFILE P on P.ID_PROFILE = r.ID_PERSON_PROFILE
  where  R.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey, :id_guest, :check_status, :old_person_profile, :old_profile_name;

  if (:old_person_profile = :ID_PERSON_PROFILE) then exit; -- NO CHANGES!

  id_person_data = null;
  select pp.ID_PERSON_DATA, p.PROFILE_NAME
  from   PROFILE_PERSON PP
         join PROFILE P on P.ID_PROFILE = pp.ID_PROFILE
  where  pp.ID_PROFILE = :ID_PERSON_PROFILE
  into   :id_person_data, :new_profile_name;

  if (:id_person_data is null) then exception BOOKING_EXCEPTION '-1039';

  update RESERV_DETAIL RD
  set    rd.ID_PERSON_PROFILE = :ID_PERSON_PROFILE
  where  rd.RDB$DB_KEY = :rd_dbkey;

  if (:check_status = 1) then begin
    execute procedure PERSON_DATA_COPY$INT (:id_person_data)
    returning_values (:id_person_data);
  end

  update GUEST_DATA GD
  set    gd.ID_PERSON_DATA = :id_person_data
  where  gd.ID_GUEST = :id_guest;

  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey);

  if (exists (select ap.ID_ACCOUNT_POST
              from   ACCOUNT_POST AP
                     join ACCOUNT A on A.ID_ACCOUNT = ap.ID_ACCOUNT
              where  a.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                     and a.ID_PROFILE = :old_person_profile
                     and ap.IS_ANUL = 0)) then
    exception BOOKING_EXCEPTION '-1038';

  if (exists (select d.ID_DEPOSIT
              from   DEPOSITS D
                     join ACCOUNT A on A.ID_ACCOUNT = d.ID_ACCOUNT
              where  a.ID_PROFILE = :old_person_profile
                     and coalesce(d.ID_RESERV_DETAIL, a.ID_RESERV_DETAIL) = :ID_RESERV_DETAIL
                     and d.RECEIVED_AMOUNT > 0)) then
    exception BOOKING_EXCEPTION '-1040';

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'TITULAR_CHANGED',
          f_character(29) || :old_profile_name || f_character(28) || :new_profile_name, null);

end
^

/* Restore proc. body: RES_SAVE_ACCOUNTING$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
declare variable old_id_agent_profile integer;
  declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable action_text varchar(255);
  declare variable old_account_routing varchar(30);
  declare variable id_acc_profile integer;
begin
  /* Description : ACC_ROUTING = {GUEST, AGENT, MIXED, OWNER, GUEST_SEPARATE_ACCOUNTS, PART_COMPLIMENTARY, FULL_COMPLIMENTARY }
  ||
  *//*
  execute procedure RES_SAVE_PROFILING$INT (:RD_DBKEY, :ID_AGENT_PROFILE, :ID_AGENT_ACCOUNT, :ID_AGENT_PAYMENT,
          :id_person_profile, :ID_PERSON_PAYMENT, :ACC_ROUTING, :ID_GROUP);
  */
  execute procedure SYSTEM_CHECK_OPERATION(:acc_routing, 'GUEST, AGENT, MIXED, OWNER, FULL_COMPLIMENTARY, PART_COMPLIMENTARY', 'Account routing');

  if (exists (select *
              from   PROFILE_HOUSE PH
              where  PH.ID_PROFILE = :id_agent_profile)) then
  begin
    exception BOOKING_EXCEPTION '-1016';
  end

  execute procedure RESERV_TRACK_CHANGES$INT(:rd_dbkey);

  select RD.ID_AGENT_PROFILE, RD.ID_RESERV_DETAIL, RD.ACC_ROUTING
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_agent_profile, :id_reserv_detail, :old_account_routing;

  if (:ACC_ROUTING in ('AGENT','MIXED') and :ID_AGENT_ACCOUNT is not null) then begin
    select A.ID_PROFILE
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :ID_AGENT_ACCOUNT
    into   :id_acc_profile;
    -- check up agent account ownership
    if (:id_acc_profile is distinct from :ID_AGENT_PROFILE) then ID_AGENT_ACCOUNT = null;
--    if (:id_acc_profile is distinct from :ID_AGENT_PROFILE) then exception BOOKING_EXCEPTION '-1026';
  end

  update RESERV_DETAIL RD
  set    RD.ID_AGENT_ACCOUNT_RULE = :ID_AGENT_ACCOUNT,
         RD.ACC_ROUTING = :ACC_ROUTING,
         RD.ID_AGENT_PROFILE = :ID_AGENT_PROFILE,
         RD.ID_AGENT_PAYMENT = :ID_AGENT_PAYMENT,
         --RD.ID_PERSON_PROFILE = :ID_PERSON_PROFILE,
         RD.ID_PERSON_PAYMENT = coalesce(:ID_PERSON_PAYMENT, RD.ID_PERSON_PAYMENT),
         RD.ID_GROUP = :ID_GROUP
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_id_agent_profile is distinct from :id_agent_profile) then begin
    execute procedure RES_SET_EDIT_STATUS$INT(:RD_DBKEY, 'AGENT', 'add');

    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :g_dbkey
    do begin
      execute procedure GUEST_AGENT_SET$INT(:g_dbkey, :id_agent_profile);
    end

    select f_character(29)||coalesce(old_A.PROFILE_NAME, '')||f_character(28)||coalesce(new_A.PROFILE_NAME, '')
    from   PROFILE old_A, PROFILE new_A
    where  old_A.ID_PROFILE = :old_id_agent_profile
           and new_A.ID_PROFILE = :ID_AGENT_PROFILE
    into   :action_text;

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_AGENT', :action_text);
  end

  if (:ACC_ROUTING <> :old_account_routing) then begin
    action_text = f_character(29) || coalesce(:old_account_routing, '')
                  || f_character(28) || coalesce(:acc_routing, '');

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_ACC_ROUTING', :action_text);
  end

  execute procedure RES_SAVE_ACCOUNTS$INT (:RD_DBKEY);
end
^

/* Restore proc. body: SAFE_CHECK_OUT */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE TYPE OF ID)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
WARN_CODE TYPE OF ID_REF)
 AS
declare variable to_dt timestamp;
  declare variable is_occupied integer;
  declare variable expire_tollerance integer;
  declare variable occupant_name varchar(100);
  declare variable id_resource_reservation integer;
  declare variable check_out_datetime timestamp;
begin
  DOC_SELECTED = null;
  select s.IS_OCCUPIED, od.TO_DATETIME,
         st.EXPIRE_TOLLERANCE, rr.OCCUPANT_NAME, rr.ID_RESOURCE_RESERVATION
  from   SAFE s
         join RESOURCE$INT r on r.ID_RESOURCE = s.ID_SAFE
         join SAFE_TYPES st on st.ID_SAFE_TYPE = r.ID_RESOURCE_TYPE
         join RESOURCE_RESERVATION rr on rr.ID_RESOURCE_RESERVATION = s.ID_CURRENT_OCCUPANCY
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join RESOURCE_OCCUPANCY ro on ro.ID_RESOURCE_OCCUPANCY_DATA = od.ID_RESOURCE_OCCUPANCY_DATA
  where  s.ID_SAFE = :ID_SAFE
  into   :is_occupied, :to_dt, :expire_tollerance, :occupant_name, :id_resource_reservation;

  if (:is_occupied = 0) then exit;

  expire_tollerance = coalesce(:expire_tollerance, 0);
  check_out_datetime = current_timestamp;

  execute procedure SAFE_OCCUPANCY_MODIFY (:id_safe, current_timestamp, :occupant_name)
  returning_values  :DOC_SELECTED;

  if (:check_out_datetime > (:to_dt + cast(:expire_tollerance as double precision) / 60 / 24)) then begin
    execute procedure SYSTEM_WARNING_ADD (-1066, f_character(29) || :expire_tollerance || f_character(28) || formatdate(:to_dt + cast(:expire_tollerance as double precision) / 60 / 24, 'D;dd/mm/yyyy HH:MM'))
    returning_values (:WARN_CODE);
  end

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = null
  where  s.ID_SAFE = :ID_SAFE;

  update RESOURCE_RESERVATION rr
  set    rr.STATUS = 'CHECKED_OUT'
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_CHECKED_OUT', :occupant_name);
end
^

/* Restore proc. body: TAR_CALC_EVAL_ALL$INT */
ALTER PROCEDURE TAR_CALC_EVAL_ALL$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable room_status varchar(20);
  declare variable from_date date;
  declare variable to_date date;
  declare variable idate date;
  declare variable is_static integer;
  declare variable id_tar_input integer;
  declare variable id_type_stay integer;
  declare variable separate_board integer;
  declare variable id_board_include integer;
  declare variable id_tar_head integer;
  declare variable is_manual_type_stay smallint;
  declare variable seasson_name varchar(50);
begin
  err_code = 0;

  delete from TAR_CALC_OUTPUT$TMP TCO where TCO.ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP TCV where TCV.ID_TAR_CALC = :id_tar_calc;

  execute procedure TAR_CALC_INIT_VARS$INT(:id_tar_calc);

  for
    select TCI.ROOM_STATUS, min(TCI.FROM_DATE_CALC), max(TCI.TO_DATE_CALC), min(TCI.IS_STATIC)
    from   TAR_CALC_INPUT$TMP TCI
    where  TCI.ID_TAR_CALC = :id_tar_calc
    group by TCI.ROOM_STATUS
    into   :room_status, :from_date, :to_date, :is_static
  do begin
    for
      select RLP.OUT_DATE
      from   SYSTEM_LOOP_PERIOD(:from_date, :to_date) RLP
      into   :idate
    do begin
      if ((:is_static = 1) and (:idate > :from_date)) then begin
        insert into TAR_CALC_OUTPUT$TMP (ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
               FOR_DATE, PRICE, CURRENCY, PRICE_TARIFF, CURRENCY_TARIFF, PRICE_NOTE, QTY_POST,
               PTEXT, DISC_TAG, ID_DISCOUNT_SERVICE, REQUIRED_ID_PACKET_ITEM)
        select tco.ID_TAR_INPUT, tco.ID_TAR_CALC, tco.ID_SERVICE, tco.SERVICE_TYPE,
               :idate, PRICE, tco.CURRENCY, tco.PRICE_TARIFF, tco.CURRENCY_TARIFF, tco.PRICE_NOTE, tco.QTY_POST,
               tco.PTEXT, tco.DISC_TAG, tco.ID_DISCOUNT_SERVICE, tco.REQUIRED_ID_PACKET_ITEM
        from   TAR_CALC_OUTPUT$TMP TCO
        where  TCO.FOR_DATE = :from_date
               and TCO.ID_TAR_CALC = :id_tar_calc;
        for
          select TCID.ID_TAR_INPUT, TCID.ID_TYPE_STAY, TCID.SEPARATE_BOARD, TCID.ID_BOARD_INCLUDE,
                 TCID.IS_MANUAL_TYPE_STAY, TCID.ID_TAR_HEAD
          from   TAR_CALC_INPUT_DETAIL$TMP TCID
                 join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
          where  TCID.FOR_DATE = :from_date
                 and TCI.ID_TAR_CALC = :id_tar_calc
          into   :id_tar_input, :id_type_stay, :separate_board, :id_board_include,
                 :is_manual_type_stay, :id_tar_head
        do begin
          seasson_name = null;
          select tp.SEASON_NAME
          from   TARIFA_GET_PERIOD_FOR_DATE (:id_tar_head, :idate) tp
          into   :seasson_name;
          if (:seasson_name is null) then begin
            ERR_CODE = -231;
            ERR_TEXT = '';
            exit;
          end

          update TAR_CALC_INPUT_DETAIL$TMP TCID
          set    TCID.ID_TYPE_STAY = :id_type_stay,
                 TCID.IS_MANUAL_TYPE_STAY = :is_manual_type_stay,
                 TCID.SEPARATE_BOARD = :separate_board,
                 TCID.ID_BOARD_INCLUDE = :id_board_include
          where  TCID.ID_TAR_INPUT = :id_tar_input;
        end
      end else begin
        execute procedure TAR_CALC_EVAL_DATE$INT(:id_tar_calc, :room_status, :idate)
        returning_values  :err_code, :err_text;
        if (:err_code < 0) then exit;
      end
    end
  end

  execute procedure TAR_CALC_EVAL_ZERO$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  if (:err_code is null) then begin
    err_code = -230; /*WRONG INPUT PARAMS - MISSING GUESTS*/
    err_text = 'Missing input data for calculation';
    exit;
  end

  execute procedure TAR_CALC_EVAL_PERIOD$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  execute procedure TAR_CALC_CHECK_PACKETS$INT (:ID_TAR_CALC)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;
end
^

/* Restore proc. body: TAR_CALC_INPUT_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_PARAMS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_input integer;
  declare variable id_guest integer;
  declare variable for_date date;
  declare variable id_calc_tariff integer;
  declare variable td_dbkey char(8);
  declare variable date_independent_param_values varchar(2000);
  declare variable date_dep_param_values varchar(2000);
  declare variable prev_id_guest integer;
  declare variable prev_id_tariff integer;
begin
  prev_id_guest = null;
  prev_id_tariff = null;
  for
    select Td.RDB$DB_KEY, TI.ID_TAR_INPUT, ti.ID_GUEST, td.FOR_DATE, td.ID_TAR_HEAD
    from   TAR_CALC_INPUT$TMP TI
           join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
    where  TI.ID_TAR_CALC = :id_tar_calc
    order by ti.ID_GUEST asc, td.FOR_DATE asc
    into   :td_dbkey, :id_tar_input, :id_guest, :for_date, :id_calc_tariff
  do begin
    if ((:id_guest is distinct from :prev_id_guest)
        or (:id_calc_tariff is distinct from :prev_id_tariff)) then
    begin
      /* get date independent params */
      execute procedure TAR_CALC_PARAMS$INT (:id_calc_tariff, :id_tar_input, :ID_TAR_CALC, null, null)
      returning_values (:ERR_CODE, :date_independent_param_values);
      if (:ERR_CODE < 0) then exit;
      prev_id_guest = :id_guest;
      prev_id_tariff = :id_calc_tariff;
    end

    execute procedure TAR_CALC_PARAMS$INT (:id_calc_tariff, :id_tar_input, :ID_TAR_CALC, :for_date, null)
    returning_values (:ERR_CODE, :date_dep_param_values);
    if (:ERR_CODE < 0) then exit;

    update TAR_CALC_INPUT_DETAIL$TMP d
    set    d.PARAM_VALUES = coalesce(:date_independent_param_values, '') || ';'
                            || coalesce(:date_dep_param_values, '')
    where  d.RDB$DB_KEY = :td_dbkey;
  end
end
^

/* Restore proc. body: TAR_SAVE */
ALTER PROCEDURE TAR_SAVE(ID_TAR_HEAD INTEGER,
PERIOD_DEPEND_ON_CHECKIN INTEGER,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BASE_BOARDS_LIST VARCHAR(255),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
BO_TYPE VARCHAR(20),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable delim integer;
  declare variable id_hotel integer;
  declare variable action_text varchar(255);
begin
  if (:base_boards_list is null) then base_boards_list = '';
  if (:board_type not in ('BOARD', 'HRANI')) then begin
    if (:board_type = '0') then board_type = 'BOARD';
    else board_type = 'HRANI';
  end
  err_code = 0;
  err_text = '';
  execute procedure SETTING_GET_VALUE('RANGE_DATA_DELIMETER', null)
  returning_values  :delim;

  -- TAR_BO_PRICES are never cleared
  delete from TAR_BO_SEASON
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_BASE_POSITION
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_BOARD
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_EXTRA_GUEST
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_DISCOUNT
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_PACK
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_PARAMS
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_DISCOUNT_STAY
  where  ID_TAR_HEAD = :id_tar_head;
  update TAR_HEAD TH
  set    PERIOD_DEPEND_ON_CHECKIN = :period_depend_on_checkin,
         CNT_DAYS_PRICE_BP        = :cnt_days_price_bp,
         CNT_DAYS_PRICE_BOARD     = :cnt_days_price_board,
         BASE_BOARDS_LIST         = f_character(:delim)||:base_boards_list||f_character(:delim),
         BOARD_TYPE               = :board_type,
         LOCK_STAMP               = current_timestamp
  where  TH.ID_TAR_HEAD = :id_tar_head;
  update TARIFA T
  set    T.IS_BASE = 1
  where  T.ID_TARIFA = :id_tar_head;
  bo_type = 'SEASON';
  execute procedure TAR_SAVE_BO_SEASON(:id_tar_head)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'BASE';
  execute procedure TAR_SAVE_BO_BP(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'BOARD';
  execute procedure TAR_SAVE_BO_BOARD(:id_tar_head, :bo_type, :board_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'EXTRA_GUEST';
  execute procedure TAR_SAVE_BO_EG(:id_tar_head, :bo_type, :board_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'PACK';
  execute procedure TAR_SAVE_BO_PACK(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'DISCOUNT';
  execute procedure TAR_SAVE_BO_DISC(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'DISCOUNT_PERIOD';
  execute procedure TAR_SAVE_BO_DISC_PERIOD(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end

  select f_character(29) || T.TARIFA_NAME, T.id_hotel
  from   TARIFA T
  where  T.ID_TARIFA = :ID_TAR_HEAD
  into   :action_text, :id_hotel;

  execute procedure EXPORT_LOG_INSERT$EXC ('RATE_BASE', :id_tar_head, :id_hotel, 0);

  execute procedure SYSTEM_LOG_ADD ('RATE', :ID_TAR_HEAD, 'RATE_CHANGED', :action_text);

  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||'NONE'||', '||:err_text;
--    suspend;
    exception;
  end
end
^

SET TERM ; ^

ALTER TABLE AR_OWING ALTER COLUMN ID_AR_OWING POSITION 1;

ALTER TABLE AR_OWING ALTER COLUMN ID_AR_OWING_BASE POSITION 2;

ALTER TABLE AR_OWING ALTER COLUMN ID_AR_TYPE POSITION 3;

ALTER TABLE AR_OWING ALTER COLUMN ID_PROFILE POSITION 4;

ALTER TABLE AR_OWING ALTER COLUMN ID_HOTEL POSITION 5;

ALTER TABLE AR_OWING ALTER COLUMN ID_DOC POSITION 6;

ALTER TABLE AR_OWING ALTER COLUMN SYSTEM_DATE POSITION 7;

ALTER TABLE AR_OWING ALTER COLUMN DUE_DATE POSITION 8;

ALTER TABLE AR_OWING ALTER COLUMN DESCRIPTION POSITION 9;

ALTER TABLE AR_OWING ALTER COLUMN SUM_OWING POSITION 10;

ALTER TABLE AR_OWING ALTER COLUMN CURR_OWING POSITION 11;

ALTER TABLE AR_OWING ALTER COLUMN REST_OWING POSITION 12;

ALTER TABLE AR_OWING ALTER COLUMN OWING_STATUS POSITION 13;

ALTER TABLE AR_OWING ALTER COLUMN USER_CREATED POSITION 14;

ALTER TABLE AR_OWING ALTER COLUMN DATETIME_CREATED POSITION 15;

ALTER TABLE AR_OWING_PAYMENT_POST ALTER COLUMN ID_AR_OWING_PAYMENT_POST POSITION 1;

ALTER TABLE AR_OWING_PAYMENT_POST ALTER COLUMN ID_AR_OWING POSITION 2;

ALTER TABLE AR_OWING_PAYMENT_POST ALTER COLUMN ID_AR_PAYMENT POSITION 3;

ALTER TABLE AR_OWING_PAYMENT_POST ALTER COLUMN ID_AR_OWING_PAYMENT_BASE POSITION 4;

ALTER TABLE AR_OWING_PAYMENT_POST ALTER COLUMN ID_PROFILE POSITION 5;

ALTER TABLE AR_OWING_PAYMENT_POST ALTER COLUMN SUM_OWING POSITION 6;

ALTER TABLE AR_OWING_PAYMENT_POST ALTER COLUMN CURR_OWING POSITION 7;

ALTER TABLE AR_OWING_PAYMENT_POST ALTER COLUMN SUM_PAYMENT POSITION 8;

ALTER TABLE AR_OWING_PAYMENT_POST ALTER COLUMN CURR_PAYMENT POSITION 9;

ALTER TABLE AR_OWING_PAYMENT_POST ALTER COLUMN IS_ANUL POSITION 10;

ALTER TABLE AR_OWING_PAYMENT_POST ALTER COLUMN DESCRIPTION POSITION 11;

ALTER TABLE AR_OWING_PAYMENT_POST ALTER COLUMN PAYMENT_RATE_TO_BGN POSITION 12;

ALTER TABLE AR_OWING_PAYMENT_POST ALTER COLUMN OWING_RATE_TO_BGN POSITION 13;

ALTER TABLE AR_OWING_PAYMENT_POST ALTER COLUMN ID_TRANSACTION POSITION 14;

ALTER TABLE AR_OWING_PAYMENT_POST ALTER COLUMN SYSTEM_DATE POSITION 15;

ALTER TABLE AR_OWING_PAYMENT_POST ALTER COLUMN USER_CREATED POSITION 16;

ALTER TABLE AR_OWING_PAYMENT_POST ALTER COLUMN DATETIME_CREATED POSITION 17;

ALTER TABLE AR_PAYMENT ALTER COLUMN ID_AR_PAYMENT POSITION 1;

ALTER TABLE AR_PAYMENT ALTER COLUMN ID_AR_PAYMENT_BASE POSITION 2;

ALTER TABLE AR_PAYMENT ALTER COLUMN ID_AR_PAYMENT_TYPE POSITION 3;

ALTER TABLE AR_PAYMENT ALTER COLUMN ID_PROFILE POSITION 4;

ALTER TABLE AR_PAYMENT ALTER COLUMN DATE_PAYMENT POSITION 5;

ALTER TABLE AR_PAYMENT ALTER COLUMN DESCRIPTION POSITION 6;

ALTER TABLE AR_PAYMENT ALTER COLUMN SUM_PAYMENT POSITION 7;

ALTER TABLE AR_PAYMENT ALTER COLUMN CURR_PAYMENT POSITION 8;

ALTER TABLE AR_PAYMENT ALTER COLUMN REST_PAYMENT POSITION 9;

ALTER TABLE AR_PAYMENT ALTER COLUMN PAYMENT_STATUS POSITION 10;

ALTER TABLE AR_PAYMENT ALTER COLUMN ACCOUNT_NAME POSITION 11;

ALTER TABLE AR_PAYMENT ALTER COLUMN USER_CREATED POSITION 12;

ALTER TABLE AR_PAYMENT ALTER COLUMN DATETIME_CREATED POSITION 13;

ALTER TABLE AR_PAYMENT_TYPE ALTER COLUMN ID_AR_PAYMENT_TYPE POSITION 1;

ALTER TABLE AR_PAYMENT_TYPE ALTER COLUMN PAYMENT_TYPE POSITION 2;

ALTER TABLE AR_PAYMENT_TYPE ALTER COLUMN IS_USE POSITION 3;

ALTER TABLE AR_TYPE ALTER COLUMN ID_AR_TYPE POSITION 1;

ALTER TABLE AR_TYPE ALTER COLUMN TYPE_CODE POSITION 2;

ALTER TABLE AR_TYPE ALTER COLUMN IS_RECEIVABLE POSITION 3;

ALTER TABLE AR_TYPE ALTER COLUMN IS_DUTY POSITION 4;

ALTER TABLE AR_TYPE ALTER COLUMN IS_SYSTEM POSITION 5;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN ID_DOC_HEAD POSITION 1;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN ID_BASE_DOC POSITION 2;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN ID_DOC_TYPE POSITION 3;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN DOC_SUB_TYPE POSITION 4;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN DOC_TYPE_NAME POSITION 5;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN DOC_DATE POSITION 6;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN ID_DOC_NUM POSITION 7;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN DOC_NUM POSITION 8;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN NUM POSITION 9;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN IS_ANUL POSITION 10;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN IS_STORNED POSITION 11;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN IS_STORNO POSITION 12;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN ID_ACCOUNT POSITION 13;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN ID_DOC_CONTRAGENT POSITION 14;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN ID_DOC_SUPPLIER POSITION 15;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN FOR_DEPOSIT POSITION 16;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN DOC_CURRENCY POSITION 17;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN DOC_RATE POSITION 18;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN DOC_VALUE POSITION 19;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN DOC_VALUE_A POSITION 20;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN DOC_NET_VALUE POSITION 21;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN DOC_VALUE_ROUNDLESS POSITION 22;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN TAXABLE_VALUE POSITION 23;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN SECOND_CURRENCY POSITION 24;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN SECOND_CURR_RATE POSITION 25;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN SECOND_CURR_NET_VALUE POSITION 26;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN SECOND_CURR_GROSS_VALUE POSITION 27;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN DOC_ACC_RATE POSITION 28;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN DESCRIPTION POSITION 29;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN ONE_LINE_TEXT POSITION 30;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN DIFF_VAT_REASON POSITION 31;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN PROFORMA_EXP_DATE POSITION 32;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN USER_CREATED POSITION 33;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN DATETIME_CREATED POSITION 34;

ALTER TABLE DOC_HEAD$INT ALTER COLUMN SELECTION_ID POSITION 35;

ALTER TABLE ROOM_MAGIC ALTER COLUMN ID_ROOM_MAGIC POSITION 1;

ALTER TABLE ROOM_MAGIC ALTER COLUMN BUSY_DATE POSITION 2;

ALTER TABLE ROOM_MAGIC ALTER COLUMN ID_RESERV_DETAIL POSITION 3;

ALTER TABLE ROOM_MAGIC ALTER COLUMN ID_HOTEL POSITION 4;

ALTER TABLE ROOM_MAGIC ALTER COLUMN ID_ROOM_TYPE POSITION 5;

ALTER TABLE ROOM_MAGIC ALTER COLUMN ID_ROOM$INT POSITION 6;

ALTER TABLE ROOM_MAGIC ALTER COLUMN ID_ROOM POSITION 7;

ALTER TABLE ROOM_MAGIC ALTER COLUMN ROOM_STATUS POSITION 8;

ALTER TABLE ROOM_MAGIC ALTER COLUMN BUSY_GROUP_TYPE POSITION 9;

ALTER TABLE ROOM_MAGIC ALTER COLUMN BUSY_TYPE POSITION 10;

ALTER TABLE ROOM_MAGIC ALTER COLUMN DAY_ACTION_INT POSITION 11;

ALTER TABLE ROOM_MAGIC ALTER COLUMN DAY_ACTION POSITION 12;

ALTER TABLE ROOM_MAGIC ALTER COLUMN ID_AGENT POSITION 13;

ALTER TABLE ROOM_MAGIC ALTER COLUMN COUNTRY POSITION 14;

ALTER TABLE ROOM_MAGIC ALTER COLUMN GST_AD_IN POSITION 15;

ALTER TABLE ROOM_MAGIC ALTER COLUMN GST_AD_OUT POSITION 16;

ALTER TABLE ROOM_MAGIC ALTER COLUMN GST_AD_STAY POSITION 17;

ALTER TABLE ROOM_MAGIC ALTER COLUMN GST_CH_IN POSITION 18;

ALTER TABLE ROOM_MAGIC ALTER COLUMN GST_CH_OUT POSITION 19;

ALTER TABLE ROOM_MAGIC ALTER COLUMN GST_CH_STAY POSITION 20;

ALTER TABLE ROOM_MAGIC ALTER COLUMN ADULT_COUNT POSITION 21;

ALTER TABLE ROOM_MAGIC ALTER COLUMN CHILDREN_COUNT POSITION 22;

