/* Server version: WI-V6.3.3.18185 Firebird 2.1 
   SQLDialect: 3. ODS: 11.1. Forced writes: On. Sweep inteval: 20000.
   Page size: 8192. Cache pages: 2048 (16384 Kb). Read-only: False. */
SET SQL DIALECT 3;

ALTER TABLE PMS_ROOM_DOCS$TMP ADD ID_ROOM_PERIOD ID_REF;

ALTER TABLE RESERV_DETAIL ADD CHECK_OUT_KIND TENUM_SMALL;

ALTER TABLE RESERV_DETAIL ADD EARLYCHECKOUT_DATE TDATE;

UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='TPERSON_NAME' WHERE RDB$FIELD_NAME='MOL' AND RDB$RELATION_NAME='CONTRAGENTS';

UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='TPERSON_NAME' WHERE RDB$FIELD_NAME='MOL' AND RDB$RELATION_NAME='DOC_CONTRAGENT';

/* Create Procedure... */
SET TERM ^ ;

CREATE PROCEDURE EAI_ARRIVING_ROOMS RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(50),
ID_HOTEL INTEGER,
PHONE_LINE VARCHAR(50))
 AS
 BEGIN SUSPEND; END
^

CREATE PROCEDURE EAI_LEFT_ROOMS RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(50),
ID_HOTEL INTEGER,
PHONE_LINE VARCHAR(50))
 AS
 BEGIN SUSPEND; END
^

CREATE PROCEDURE EAI_ROOMS_OCCUPIED_STATUS RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(50),
ID_HOTEL INTEGER,
PHONE_LINE VARCHAR(50),
IS_OCCUPIED SMALLINT)
 AS
 BEGIN SUSPEND; END
^


SET TERM ; ^

DROP VIEW ENA_DOC_HEAD_ADVANCE;

/* Create view: ENA_DOC_HEAD_ADVANCE */
CREATE VIEW ENA_DOC_HEAD_ADVANCE(
ID_HOTEL,
ID_DOC,
ID_BASE_DOC,
ID_DOC_TYPE,
DOC_SUB_TYPE,
DOC_TYPE_NAME,
DOC_TYPE_EXPORT_TAG,
DOC_TYPE_DESCRIPTION,
DOC_NUM,
DOC_DATE,
SYSTEM_DATE,
IS_ANUL,
DOC_FISC_STATUS,
DOC_CURRENCY,
DOC_TOTAL_VALUE,
DOC_RATE,
DOC_ACC_RATE,
TAX_EVENT_DATE,
DOC_DESCRIPTION,
ONE_LINE_TEXT,
DIFF_VAT_REASON,
DOC_SECOND_CURRENCY,
DOC_SECOND_CURR_RATE,
CLIENT_IS_LEGAL_ENTITY,
CLIENT_NAME,
CLIENT_IDENT_NO,
CLIENT_TAX_REG_NUM,
CLIENT_COUNTRY_CODE,
CLIENT_POST_ADDRESS,
CLIENT_ZIP_CODE,
CLIENT_MOL,
CLIENT_RECIPIENT_NAME,
CLIENT_BANK_NAME,
CLIENT_BIC,
CLIENT_IBAN,
CLIENT_EMAIL,
SUPPLIER_SEND_NAME,
ACCOUNT_ID,
ANNUL_PROT_NUM,
DOC_NET_VALUE,
DOC_SECOND_CURR_NET_VALUE,
DOC_SECOND_CURR_GROSS_VALUE)
 AS 
select
       A.ID_HOTEL,
       dh.ID_DOC_HEAD,
       dh.ID_BASE_DOC,
       dh.ID_DOC_TYPE,
       dh.DOC_SUB_TYPE,
       dh.DOC_TYPE_NAME,
       case
         when dh.DOC_SUB_TYPE = 0 then dt.EXPORT_TAG
         when dh.DOC_SUB_TYPE = 1 then dti.DEBIT_EXPORT_TAG
         when dh.DOC_SUB_TYPE = 2 then dti.CREDIT_EXPORT_TAG
       end as EXPORT_TAG,
       dt.DESCRIPTION,
       dh.DOC_NUM,
       dh.DOC_DATE,
       rd.RELEASE_DATE,
       iif((RD.VALUE_CORR_INDEX = -1) or (m.TAG = 1), 1, 0),
       dc.FISC_STATUS,
       dh.DOC_CURRENCY,
       dh.DOC_VALUE_A,
       dh.DOC_RATE,
       dh.DOC_ACC_RATE,
       dc.TAX_EVENT_DATE,
       dh.DESCRIPTION,
       dh.ONE_LINE_TEXT,
       dh.DIFF_VAT_REASON,
       dh.SECOND_CURRENCY,
       dh.SECOND_CURR_RATE,
       c.IS_JURIDICAL_PERSON,
       c.CONTRAGENT_NAME,
       c.IDENT_NO,
       c.VAT_REG_NUM,
       c.COUNTRY_CODE,
       c.POST_ADDRESS,
       c.ZIP_CODE,
       c.MOL,
       c.RECIPIENT_NAME,
       c.BANK_NAME,
       c.BIC,
       c.IBAN,
       c.EMAIL,
       ds.SEND_NAME,
       a.ID_ACCOUNT,
       da.PROT_DOC_NUM,
       dh.DOC_NET_VALUE,
       dh.SECOND_CURR_NET_VALUE,
       dh.SECOND_CURR_GROSS_VALUE
from DOC_HEAD$INT dh
     join DOC_COMPLETION dc on dc.ID_DOC_HEAD = dh.ID_DOC_HEAD
     join DOC_RELEASE_DATE rd on rd.ID_DOC_HEAD = dh.ID_DOC_HEAD
     join ACCOUNT a on a.ID_ACCOUNT = dh.ID_ACCOUNT
     join DOC_TYPE dt on dt.ID_DOC_TYPE = dh.ID_DOC_TYPE
     join DOC_TYPE_INV dti on dti.ID_DOC_TYPE = dh.ID_DOC_TYPE
     join DOC_SUPPLIER ds on ds.ID_DOC_SUPPLIER = dh.ID_DOC_SUPPLIER
     join DOC_CONTRAGENT c on c.ID_DOC_CONTRAGENT = dh.ID_DOC_CONTRAGENT
     left outer join RECORD_MULTIPLIER m on 0 = rd.VALUE_CORR_INDEX
     left outer join DOC_ANNULMENT da on da.ID_DOC_HEAD = dh.ID_DOC_HEAD
                                         and ((RD.VALUE_CORR_INDEX = -1) or (m.TAG = 1))
where dh.FOR_DEPOSIT = 1
;

COMMENT ON VIEW ENA_DOC_HEAD_ADVANCE IS
'!      ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC IS
'  .             .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_ADVANCE.ID_DOC.  .     - , ..       ,      - .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SUB_TYPE IS
'   . ,  : 0 - / , 1 -  ,  , 2 -  ,  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_NAME IS
'    . ,       .              .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_DESCRIPTION IS
'   .         .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_NUM IS
'   ,        .      . ,     ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DATE IS
'        . .    SYSTEM_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.IS_ANUL IS
'        . . 0 - , 1 - .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TOTAL_VALUE IS
' (, )       . .      .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ONE_LINE_TEXT IS
' ,         .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURR_RATE IS
'   ()    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_POST_ADDRESS IS
'    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_ZIP_CODE IS
'     ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_MOL IS
'    ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_RECIPIENT_NAME IS
'     ()';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BANK_NAME IS
'  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BIC IS
'BIC  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IBAN IS
'IBAN  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_EMAIL IS
'email  .        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SUPPLIER_SEND_NAME IS
'     .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ACCOUNT_ID IS
'        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

DROP VIEW ENA_DOC_HEAD_SERVICE;

/* Create view: ENA_DOC_HEAD_SERVICE */
CREATE VIEW ENA_DOC_HEAD_SERVICE(
ID_HOTEL,
ID_DOC,
ID_BASE_DOC,
ID_DOC_TYPE,
DOC_SUB_TYPE,
DOC_TYPE_NAME,
DOC_TYPE_EXPORT_TAG,
DOC_TYPE_DESCRIPTION,
DOC_NUM,
DOC_DATE,
SYSTEM_DATE,
IS_ANUL,
DOC_FISC_STATUS,
DOC_CURRENCY,
DOC_TOTAL_VALUE,
DOC_RATE,
DOC_ACC_RATE,
TAX_EVENT_DATE,
DOC_DESCRIPTION,
ONE_LINE_TEXT,
DIFF_VAT_REASON,
DOC_SECOND_CURRENCY,
DOC_SECOND_CURR_RATE,
DOC_PROFORMA_DATE,
DOC_PROFORMA_NUM,
CLIENT_IS_LEGAL_ENTITY,
CLIENT_NAME,
CLIENT_IDENT_NO,
CLIENT_TAX_REG_NUM,
CLIENT_COUNTRY_CODE,
CLIENT_POST_ADDRESS,
CLIENT_ZIP_CODE,
CLIENT_MOL,
CLIENT_RECIPIENT_NAME,
CLIENT_BANK_NAME,
CLIENT_BIC,
CLIENT_IBAN,
CLIENT_EMAIL,
SUPPLIER_SEND_NAME,
ACCOUNT_ID,
ANNUL_PROT_NUM,
DOC_NET_VALUE,
DOC_SECOND_CURR_NET_VALUE,
DOC_SECOND_CURR_GROSS_VALUE)
 AS 
select
       A.ID_HOTEL,
       dh.ID_DOC_HEAD,
       dh.ID_BASE_DOC,
       dh.ID_DOC_TYPE,
       dh.DOC_SUB_TYPE,
       dh.DOC_TYPE_NAME,
       case
         when dh.DOC_SUB_TYPE = 0 then dt.EXPORT_TAG
         when dh.DOC_SUB_TYPE = 1 then dti.DEBIT_EXPORT_TAG
         when dh.DOC_SUB_TYPE = 2 then dti.CREDIT_EXPORT_TAG
       end as EXPORT_TAG,
       dt.DESCRIPTION,
       dh.DOC_NUM,
       dh.DOC_DATE,
       rd.RELEASE_DATE,
       iif((RD.VALUE_CORR_INDEX = -1) or (m.TAG = 1), 1, 0),
       dc.FISC_STATUS,
       dh.DOC_CURRENCY,
       dh.DOC_VALUE_A,
       dh.DOC_RATE,
       dh.DOC_ACC_RATE,
       dc.TAX_EVENT_DATE,
       dh.DESCRIPTION,
       dh.ONE_LINE_TEXT,
       dh.DIFF_VAT_REASON,
       dh.SECOND_CURRENCY,
       dh.SECOND_CURR_RATE,
       di.DOC_DATE,
       di.DOC_NUM,
       c.IS_JURIDICAL_PERSON,
       c.CONTRAGENT_NAME,
       c.IDENT_NO,
       c.VAT_REG_NUM,
       c.COUNTRY_CODE,
       c.POST_ADDRESS,
       c.ZIP_CODE,
       c.MOL,
       c.RECIPIENT_NAME,
       c.BANK_NAME,
       c.BIC,
       c.IBAN,
       c.EMAIL,
       ds.SEND_NAME,
       a.ID_ACCOUNT,
       da.PROT_DOC_NUM,
       dh.DOC_NET_VALUE,
       dh.SECOND_CURR_NET_VALUE,
       dh.SECOND_CURR_GROSS_VALUE
from DOC_HEAD$INT dh
     join DOC_COMPLETION dc on dc.ID_DOC_HEAD = dh.ID_DOC_HEAD
     join DOC_RELEASE_DATE rd on rd.ID_DOC_HEAD = dh.ID_DOC_HEAD
     join ACCOUNT a on a.ID_ACCOUNT = dh.ID_ACCOUNT
     join DOC_TYPE dt on dt.ID_DOC_TYPE = dh.ID_DOC_TYPE
     join DOC_TYPE_INV dti on dti.ID_DOC_TYPE = dt.ID_DOC_TYPE
     join DOC_SUPPLIER ds on ds.ID_DOC_SUPPLIER = dh.ID_DOC_SUPPLIER
     join DOC_CONTRAGENT c on c.ID_DOC_CONTRAGENT = dh.ID_DOC_CONTRAGENT
     left outer join RECORD_MULTIPLIER m on 0 = rd.VALUE_CORR_INDEX
     left outer join DOC_HEAD$INT di on di.ID_DOC_HEAD = dc.ID_DOC_PROFORMA
     left outer join DOC_ANNULMENT da on da.ID_DOC_HEAD = dh.ID_DOC_HEAD
                                         and ((RD.VALUE_CORR_INDEX = -1) or (m.TAG = 1))
where dh.FOR_DEPOSIT = 0
;

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC IS
'  .             .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_SERVICE.ID_DOC.     - , ..       ,      - .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC_TYPE IS
'    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SUB_TYPE IS
'   .  : 0 - / , 1 -  ,  , 2 -  ,  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_NAME IS
'    .              .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_DESCRIPTION IS
'   .         .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_NUM IS
'   ,        .      .  -       ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DATE IS
'        .    SYSTEM_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.IS_ANUL IS
'        . 0 - , 1 - .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_CURRENCY IS
'  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TOTAL_VALUE IS
' (, )       .      .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ONE_LINE_TEXT IS
' ,         .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURR_RATE IS
'   ()    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_DATE IS
'   ,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_NUM IS
'  -,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_POST_ADDRESS IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_ZIP_CODE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_MOL IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_RECIPIENT_NAME IS
'     (). .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BANK_NAME IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BIC IS
'BIC  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IBAN IS
'IBAN  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_EMAIL IS
'email  .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SUPPLIER_SEND_NAME IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ACCOUNT_ID IS
'        .    ENA_ACCOUNT.ID_ACCOUNT. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

COMMENT ON COLUMN ENA_ACCOUNT.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_ACCOUNT.ID_ACCOUNT IS
'  . .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_NAME IS
'   .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_EXT_CODE IS
'             .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ID IS
'         . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_NAME IS
'    .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ACCOUNT_NO IS
'             .  -    .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_TYPE IS
'       .  : AGENT -  , PERSON -  , HOUSE -    . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_HOUSE_TYPE IS
'      (PROFILE_TYPE = ''HOUSE''),    -.  : hptExternalClient -          ( ,      ); hptExternalRevenue -                (,   ..); hptComplimentary -           ,  ,        . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_HOTEL IS
'       .  ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_ACCOUNT_POST_HISTORY IS
'   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_ACCOUNT IS
'      .  ENA_ACCOUNT.ID_ACCOUNT. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_SERVICE IS
'   .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_SALE_TAXATION IS
'         .       . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.SYSTEM_DATE IS
'    / . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_DATE IS
'        (). .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_CURR IS
'  . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_AMOUNT IS
'    (   )    . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.NAT_NET_VALUE IS
'    ( )   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.NAT_GROSS_VALUE IS
'    ( )   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_TYPE IS
'  . BASE -  ; ADD_INS -  - ,    ; EXTRA -     ,     ; TAX -            ,     .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_GUEST IS
'       .  ENA_GUEST.ID_GUEST.        : 1.    "  "; 2.           ; 3.        ,      . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_GROUP IS
'       .    : ''ROOMS'', ''Food and Beverage'', ''Other Operated Departments'', ''Rentals and Other Income''. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_ACCOUNT IS
' -      .    . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_SUB_ACCOUNT IS
' --      . ,     -. .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.ID_HOTEL IS
'   ,    . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.ID_DOC_HEAD IS
'        .  ENA_DOC_HEAD_ADVANCE.ID_DOC. .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.SYSTEM_DATE IS
'      . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAYMENT_DATE IS
'     . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.SRC_ID_ACCOUNT IS
'   . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.DEST_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAY_AMOUNT IS
' .        . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAY_CURRENCY IS
' . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.USER_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.DATETIME_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_HOTEL IS
'   ,    . .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_DEPOSIT_PAYMENT IS
'  .         . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_DATE IS
'        .            . .';

COMMENT ON COLUMN ENA_DEPOSIT.SYSTEM_DATE IS
'   .         PAYMENT_DATE.        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_NUM IS
'           .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_DIRECTION IS
'0 -   , 1 -   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_TYPE_NAME IS
'       .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_ACCOUNT IS
'        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_AMOUNT IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DEPOSIT.IS_ANUL IS
'   . 0 - , 1 - .           /    .     IS_ANUL = 0,    1.           ID_DEPOSIT.  .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_CREATED IS
'     .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_CREATED IS
'       . .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_ANNUL IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_ANNUL IS
'     .  .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.ID_HOTEL IS
'       .  .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.ID_DEPOSIT_PAYMENT IS
'   ,   .  ENA_DEPOSIT.ID_DEPOSIT_PAYMENT. .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SYSTEM_DATE IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAYMENT_DATE IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SRC_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DEST_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAY_AMOUNT IS
' .        . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAY_CURRENCY IS
' . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.USER_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DATETIME_CREATED IS
'     . .';

COMMENT ON VIEW ENA_DOC_DEPOSIT_CONSUMPTION IS
' !!!!!!    ID_DOC_TYPE - za mapowe.';


COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.DOC_TYPE_NAME IS
'       . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_NUM IS
'         .  .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_DATE IS
'      .          . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_VALUE IS
'         . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_DOC_RATE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.EQUAL_DOC_VALUE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.NAT_VALUE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.ID_DEPOSIT_PAYMENT IS
'      (  ENA_DEPOSIT.ID_DEPOSIT_PAYMENT ). .';

COMMENT ON VIEW ENA_DOC_HEAD_ADVANCE IS
'!      ';


COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC IS
'  .             .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_ADVANCE.ID_DOC.  .     - , ..       ,      - .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SUB_TYPE IS
'   . ,  : 0 - / , 1 -  ,  , 2 -  ,  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_NAME IS
'    . ,       .              .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_DESCRIPTION IS
'   .         .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_NUM IS
'   ,        .      . ,     ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DATE IS
'        . .    SYSTEM_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.IS_ANUL IS
'        . . 0 - , 1 - .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TOTAL_VALUE IS
' (, )       . .      .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ONE_LINE_TEXT IS
' ,         .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURR_RATE IS
'   ()    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_POST_ADDRESS IS
'    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_ZIP_CODE IS
'     ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_MOL IS
'    ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_RECIPIENT_NAME IS
'     ()';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BANK_NAME IS
'  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BIC IS
'BIC  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IBAN IS
'IBAN  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_EMAIL IS
'email  .        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SUPPLIER_SEND_NAME IS
'     .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ACCOUNT_ID IS
'        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC IS
'  .             .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_SERVICE.ID_DOC.     - , ..       ,      - .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC_TYPE IS
'    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SUB_TYPE IS
'   .  : 0 - / , 1 -  ,  , 2 -  ,  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_NAME IS
'    .              .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_DESCRIPTION IS
'   .         .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_NUM IS
'   ,        .      .  -       ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DATE IS
'        .    SYSTEM_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.IS_ANUL IS
'        . 0 - , 1 - .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_CURRENCY IS
'  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TOTAL_VALUE IS
' (, )       .      .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ONE_LINE_TEXT IS
' ,         .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURR_RATE IS
'   ()    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_DATE IS
'   ,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_NUM IS
'  -,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_POST_ADDRESS IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_ZIP_CODE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_MOL IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_RECIPIENT_NAME IS
'     (). .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BANK_NAME IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BIC IS
'BIC  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IBAN IS
'IBAN  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_EMAIL IS
'email  .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SUPPLIER_SEND_NAME IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ACCOUNT_ID IS
'        .    ENA_ACCOUNT.ID_ACCOUNT. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_SERVICE IS
'     .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.DATE_POST IS
'    . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_SERVICE IS
'      .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_SERVICE IS
'   .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.IS_CORRECT IS
'            .      1,        . 0 -   ; 1 -      0. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_GUEST IS
'   ,        .    null,       ''  ''     .    ENA_GUEST.ID_GUEST. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.DATE_POST IS
'        .    ,    . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ROOM_NAME IS
'       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ACCOUNT_PRICE IS
'         /.             /. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_SERVICE IS
'    (, , , ,  ).  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_SALE_TAXATION IS
'         .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON VIEW ENA_DOC_PAYMENT IS
'   ,     .';


COMMENT ON COLUMN ENA_DOC_PAYMENT.ID_DOC_HEAD IS
'  ( ENA_DOC_HEAD.ID_DOC)      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DOC_TYPE_NAME IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_NUM IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_DATE IS
'     .        ,                 . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_CURRENCY IS
'  .        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DUE_DATE IS
'       .          ,      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_VALUE IS
'           . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_DOC_RATE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.EQUAL_DOC_VALUE IS
'      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.NAT_VALUE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.ID_DOC_HEAD IS
'         . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNT_VALUE IS
'      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNTABLE_VALUE IS
'  .       . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.IS_PERCENT_DISCOUNT IS
'  .         . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.FIXED_DISCOUNT_CURRENCY IS
'  .       -     . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNT_PERCENT_OR_AMOUNT IS
'  .       . .';

COMMENT ON COLUMN ENA_DOC_TAX.ID_DOC_HEAD IS
'         ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_TAX.ID_SALE_TAX IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.NONTAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_VALUE IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_NAME IS
'  .  -        .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_PERCENT IS
'   ().  .';

COMMENT ON COLUMN ENA_DOC_TAX.FISCAL_CODE IS
' .        .  -      .';

COMMENT ON COLUMN ENA_DOC_TAX.ACCOUNT_NAME IS
' .              . .';

COMMENT ON COLUMN ENA_GUEST.ID_GUEST IS
'   ( )   . .';

COMMENT ON COLUMN ENA_GUEST.ID_RESERV_DETAIL IS
'        ( ENA_RESERV_DETAIL.ID_RESERV_DETAIL). .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME2 IS
'      . .';

COMMENT ON COLUMN ENA_GUEST.IS_CHILD IS
'   . 0 - ; 1 - . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE IS
'    . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_TEXT IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.RATING_AGE IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.COUNTRY_CODE IS
'    .        ISO. .';

COMMENT ON COLUMN ENA_GUEST.MASK IS
'  .         . .';

COMMENT ON COLUMN ENA_HOTEL.ID_HOTEL IS
'  . .';

COMMENT ON COLUMN ENA_HOTEL.HOTEL_NAME IS
'  . .';

COMMENT ON COLUMN ENA_HOTEL.CODE IS
'   . .';

COMMENT ON COLUMN ENA_HOTEL.SYSTEM_DATE IS
'     .                  ENA.                . .';

COMMENT ON COLUMN ENA_HOTEL.IS_USE IS
'    (  ). 0 -   , 1 -  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_RESERV_DETAIL IS
'   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NUMBER IS
'  .    (   ). .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_GUEST_MAIN IS
'      .      .  -     .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME IS
'    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME2 IS
'       . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.FROM_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.TO_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NIGHTS IS
'. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ADULT_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHILD_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_EATING_OBJECT IS
'          . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHECK_STATUS IS
'  . -3 =  ; -2 =   ; -1 =  ; 0 =  ; 1 =  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.IS_ANUL IS
'   . 0 - , 1 - .  -       0  1.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ID IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_NAME IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_TYPE IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ACCOUNT_NO IS
'             .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SEGMENT_CODE IS
'   ''segment''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SOURCE_CODE IS
'   ''source''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_CHANNEL_CODE IS
'   ''channel''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_HEAR_CODE IS
'   ''hear reason''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_COME_CODE IS
'   ''come reason''.   . .';

COMMENT ON COLUMN ENA_SERVICES.ID_HOTEL IS
'       . .';

COMMENT ON COLUMN ENA_SERVICES.ID_SERVICE IS
'   . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_NAME IS
'  . .';

COMMENT ON COLUMN ENA_SERVICES.GROUP_NAME IS
'    .            a       . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_TYPE IS
'  .  : ''BASE'',''EXTRA'',''COMMISSION'',''MEAL''. ''BASE'' -    ,     ,''EXTRA'' -  , ''MEAL'' - , ''COMMISSION'' - ,        (  ). .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_GROUP IS
'       .  : ''ROOMS'', ''Food and Beverage'', ''Other Operated Departments'', ''Rentals and Other Income''. .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_ACCOUNT IS
' -      . .';

COMMENT ON COLUMN ENA_SERVICES.ACCOUNT_NAME IS
'      (. ),      .          . .';

COMMENT ON COLUMN ENA_SERVICES.EXT_CODE IS
'         . .';

COMMENT ON COLUMN ENA_SERVICES.IS_BREAKFAST IS
'   . 0 - , 1 - .    1,   SERVICE_TYPE e ''BASE''  ''MEAL''.  -          .';

COMMENT ON COLUMN ENA_SERVICES.IS_LUNCH IS
'   .   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_DINNER IS
'   .   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_EXTRAFOOD1 IS
'     1.   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_EXTRAFOOD2 IS
'     2.   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.ID_ROOM_TYPE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ). .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  -             .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM_EXT_CODE IS
'    ( )     ,      .  -        .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_STAY_CODE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  : ''ALONE'' -      , ''BED'' -            , ''EXTRA_BED'' -      . .';

COMMENT ON COLUMN OWNER_POST.POST_STATUS IS
'11  
22  ';

/*  Empty DOC_CONTRAGENT_SET$DOC for CONTRAGENT_MODIFY$CONTR(param list change)  */
SET TERM ^ ;

ALTER PROCEDURE DOC_CONTRAGENT_SET$DOC(ID_DOC INTEGER,
IS_PAY_DOC SMALLINT,
ID_CONTRAGENT INTEGER,
IS_JURIDICAL_PERSON SMALLINT,
CONTRAGENT_NAME VARCHAR(100),
VAT_REG_NUM VARCHAR(30),
IDENT_NO VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
POST_ADDRESS VARCHAR(100),
ZIP_CODE VARCHAR(10),
EMAIL VARCHAR(50),
MOL VARCHAR(30),
RECIPIENT_NAME VARCHAR(100),
RECIPIENT_PAS_NUM VARCHAR(20),
RECIPIENT_PAS_DATE DATE,
RECIPIENT_PAS_FROM VARCHAR(30),
RECIPIENT_LETTER VARCHAR(30),
NUM_DOGOVOR VARCHAR(30),
NUM_SPECIF VARCHAR(30),
ADD_PERMANENTLY SMALLINT,
BANK_NAME VARCHAR(50),
BIC VARCHAR(30),
IBAN VARCHAR(30))
 RETURNS(ID_DOC_CONTRAGENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty IMPORT_CONTRAGENT$EXC for CONTRAGENT_MODIFY$CONTR(param list change)  */
ALTER PROCEDURE IMPORT_CONTRAGENT$EXC(CONTRAGENT_NAME VARCHAR(100),
IS_JURIDICAL_PERSON SMALLINT,
IDENT_NO VARCHAR(20),
VAT_REG_NUM VARCHAR(30),
POST_ADDRESS VARCHAR(100),
ZIP_CODE VARCHAR(10),
EMAIL VARCHAR(50),
MOL VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
BANK_NAME VARCHAR(50),
BIC VARCHAR(30),
IBAN VARCHAR(30),
UUID VARCHAR(40),
CREATE_ONLY SMALLINT)
 RETURNS(ID_CONTRAGENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty DOC_CONTRAGENT_INITIALIZE$INT for DOC_CONTRAGENT_SET$DOC(param list change)  */
ALTER PROCEDURE DOC_CONTRAGENT_INITIALIZE$INT(ID_DOC INTEGER,
IS_PAY_DOC SMALLINT,
ID_PROFILE INTEGER)
 AS
 BEGIN EXIT; END
^

/*  Empty EXPORT_BOOKING$RSV for EXPORT_BOOKING$EXC(param list change)  */
ALTER PROCEDURE EXPORT_BOOKING$RSV(DATA_RANGE VARCHAR(50))
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20),
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_NAME VARCHAR(100),
POSTING_ROUTING VARCHAR(20),
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty CREATE_BOOKING$WBE for IMPORT_BOOKING$EXC(param list change)  */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
 BEGIN SUSPEND; END
^

/*  Empty TEST_BOOKING_IMPORT for IMPORT_BOOKING$EXC(param list change)  */
ALTER PROCEDURE TEST_BOOKING_IMPORT AS
 BEGIN EXIT; END
^

/*  Empty APPLY_BOOKING_STATUS$EXC for RES_CHECK_OUT_GUESTS$RSV(param list change)  */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/*  Empty EAI_RES_CHECK_OUT_FAST for RES_CHECK_OUT_GUESTS$RSV(param list change)  */
ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN EXIT; END
^

/*  Empty EXPORT_BOOKING$EXC for RES_LOAD(param list change)  */
ALTER PROCEDURE EXPORT_BOOKING$EXC(BOOKING_ID INTEGER)
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20),
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_ID INTEGER,
IS_GUEST_ARRANGER INTEGER,
POSTING_ROUTING VARCHAR(20),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IS_DIFFERENT_TARIFF SMALLINT,
IS_DIFFERENT_BOARD SMALLINT,
IS_CUSTOM_PRICE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
EXC_LOCAL_VERSION BIGINT,
EXC_REMOTE_VERSION BIGINT,
CREATE_DATETIME TIMESTAMP,
EATING_OBJECT VARCHAR(50))
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure CONTRAGENT_MODIFY$CONTR with new param-list */
ALTER PROCEDURE CONTRAGENT_MODIFY$CONTR(ID_CONTRAGENT INTEGER,
CONTRAGENT_NAME VARCHAR(100),
IS_JURIDICAL_PERSON SMALLINT,
IDENT_NO VARCHAR(30),
VAT_REG_NUM VARCHAR(30),
POST_ADDRESS VARCHAR(100),
ZIP_CODE VARCHAR(10),
EMAIL VARCHAR(50),
MOL VARCHAR(100),
COUNTRY_CODE VARCHAR(10),
BANK_NAME VARCHAR(50),
BIC VARCHAR(30),
IBAN VARCHAR(30))
 RETURNS(NEW_ID_CONTRAGENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure DOC_CONTRAGENT_SET$DOC with new param-list */
ALTER PROCEDURE DOC_CONTRAGENT_SET$DOC(ID_DOC INTEGER,
IS_PAY_DOC SMALLINT,
ID_CONTRAGENT INTEGER,
IS_JURIDICAL_PERSON SMALLINT,
CONTRAGENT_NAME VARCHAR(100),
VAT_REG_NUM VARCHAR(30),
IDENT_NO VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
POST_ADDRESS VARCHAR(100),
ZIP_CODE VARCHAR(10),
EMAIL VARCHAR(50),
MOL VARCHAR(100),
RECIPIENT_NAME VARCHAR(100),
RECIPIENT_PAS_NUM VARCHAR(20),
RECIPIENT_PAS_DATE DATE,
RECIPIENT_PAS_FROM VARCHAR(30),
RECIPIENT_LETTER VARCHAR(30),
NUM_DOGOVOR VARCHAR(30),
NUM_SPECIF VARCHAR(30),
ADD_PERMANENTLY SMALLINT,
BANK_NAME VARCHAR(50),
BIC VARCHAR(30),
IBAN VARCHAR(30))
 RETURNS(ID_DOC_CONTRAGENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure EXPORT_BOOKING$EXC with new param-list */
ALTER PROCEDURE EXPORT_BOOKING$EXC(BOOKING_ID INTEGER)
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20,
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_ID INTEGER,
IS_GUEST_ARRANGER INTEGER,
POSTING_ROUTING VARCHAR(20),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IS_DIFFERENT_TARIFF SMALLINT,
IS_DIFFERENT_BOARD SMALLINT,
IS_CUSTOM_PRICE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
EXC_LOCAL_VERSION BIGINT,
EXC_REMOTE_VERSION BIGINT,
CREATE_DATETIME TIMESTAMP,
EATING_OBJECT VARCHAR(50),
CHECK_OUT_KIND SMALLINT,
EARLYCHECKOUT_DATE DATE)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure IMPORT_BOOKING$EXC with new param-list */
ALTER PROCEDURE IMPORT_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(250),
MAINTANCE_SHEMA VARCHAR(30),
POSTING_ROUTING VARCHAR(20),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
COMPLIMENTARY_ACCOUNT VARCHAR(50),
EATING_OBJECT VARCHAR(50),
CREATE_DATETIME TIMESTAMP,
CHECK_OUT_KIND SMALLINT,
EARLYCHECKOUT_DATE DATE)
 RETURNS(HOTEL_ID INTEGER,
BOOKING_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure PROFILE_GET_CONTRAGENT_DATA$INT with new param-list */
ALTER PROCEDURE PROFILE_GET_CONTRAGENT_DATA$INT(ID_PROFILE INTEGER)
 RETURNS(ID_CONTRAGENT INTEGER,
IS_JURIDICAL_PERSON SMALLINT,
CONTRAGENT_NAME VARCHAR(100),
VAT_REG_NUM VARCHAR(30),
IDENT_NO VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
POST_ADDRESS VARCHAR(100),
ZIP_CODE VARCHAR(10),
EMAIL VARCHAR(50),
MOL VARCHAR(100),
RECIPIENT_NAME VARCHAR(100),
RECIPIENT_PAS_NUM VARCHAR(20),
RECIPIENT_PAS_DATE DATE,
RECIPIENT_PAS_FROM VARCHAR(30),
BANK_NAME VARCHAR(50),
BIC VARCHAR(30),
IBAN VARCHAR(30))
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure RES_CHECK_OUT_GUESTS$RSV with new param-list */
ALTER PROCEDURE RES_CHECK_OUT_GUESTS$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND SMALLINT = 0,
EARLYCHECKOUT_DATE DATE = null)
 AS
 BEGIN EXIT; END
^

/* Alter empty procedure RES_LOAD with new param-list */
ALTER PROCEDURE RES_LOAD(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_AGENT_PROFILE INTEGER,
AGENT_PROFILE_NAME VARCHAR(100),
ID_PERSON_PROFILE INTEGER,
PERSON_PROFILE_NAME VARCHAR(100),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_RES_ROOM_TYPE INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
BOARD_NAMES VARCHAR(255),
TARIFF_NAMES VARCHAR(255),
PACKET_NAMES VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100),
VOUCHER_RENDER VARCHAR(512),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
TRANSFER_RENDER VARCHAR(255),
CODE_FIRST_FOOD_RENDER VARCHAR(255),
IS_LATE_DEPARTURE INTEGER,
CODE_FIRST_FOOD VARCHAR(20),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
I_SPECIAL_TREATMENT VARCHAR(255),
COMMING_KIND SMALLINT,
IS_VIP SMALLINT,
HAS_GUEST_LIST SMALLINT,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
AGENT_ACCOUNT_NAME VARCHAR(100),
IS_DIFFERENT_VOUCHER INTEGER,
IS_DIFFERENT_OTHER INTEGER,
IS_DIFFERENT_BOARD INTEGER,
IS_DIFFERENT_TARIFF INTEGER,
IS_CUSTOM_PRICE INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
ID_RATE INTEGER,
ROOM_FEATURES BLOB,
ID_GROUP INTEGER,
NUMBER VARCHAR(62),
CHECK_STATUS INTEGER,
BALANCE VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER,
RECIEVED_DEPOSITS VARCHAR(255),
ROOM_HISTORY VARCHAR(200),
TAR_ROOM_TYPE VARCHAR(100),
ID_HK_PLAN INTEGER,
COUNTRIES VARCHAR(812),
IS_RESGRP INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
IS_ANUL INTEGER,
NOTE VARCHAR(2000),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
GROUP_NAME VARCHAR(50),
ID_HOTEL INTEGER,
NOTE_REMINDERS VARCHAR(50),
IS_DIFFERENT_PRICE INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ID_EATING_OBJECT TYPE OF ID_REF,
ROOM_PRIVATE_STATUS TLOGICAL)
 AS
 BEGIN SUSPEND; END
^

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_ADD$INT for: ACCOUNT_CHECK_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_POSTING_ADD$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_GUEST /* TYPE OF ID_REF */ INTEGER,
ID_SECQUENCE /* TYPE OF ID_REF */ INTEGER,
DATE_POST /* TYPE OF TDATE */ DATE,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_TARIFF /* TYPE OF ID_REF */ INTEGER,
ID_ROOM /* TYPE OF ID_REF */ INTEGER,
IS_BASE /* TYPE OF TLOGICAL */ SMALLINT,
QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
ORIG_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
RATE /* TYPE OF TRATE */ NUMERIC(15,6),
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
CHANGED_TEXT /* TYPE OF TTEXT_SHORT */ VARCHAR(30),
ID_MASTER_ADDINS_ACC_POST /* TYPE OF ID_REF */ INTEGER,
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
NEW_ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE$INT for: ACCOUNT_CHECK_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE$INT(AP_DBKEY /* TYPE OF TDB_KEY */ CHAR(8),
ID_SERVICE /* TYPE OF ID_REF */ INTEGER,
ID_TARIFF /* TYPE OF ID_REF */ INTEGER,
ID_ROOM /* TYPE OF ID_REF */ INTEGER,
QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
QTY_FREE /* TYPE OF TQTY */ NUMERIC(15,2),
PRICE /* TYPE OF TVALUE */ DOUBLE PRECISION,
CURR /* TYPE OF TCURRENCY */ CHAR(3),
RATE /* TYPE OF TRATE */ NUMERIC(15,6),
CHANGED_TEXT VARCHAR(40),
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
IS_CONSEQUENTIAL_UPDATE /* TYPE OF TBOOLEAN */ SMALLINT = 0,
RE_ROUTE_ACCOUNT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(OUT_QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
OUT_PRICE_POST /* TYPE OF TVALUE */ DOUBLE PRECISION,
OUT_AC VARCHAR(2))
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_CHECK_CREDIT_STATUS$INT) */
ALTER PROCEDURE ACCOUNT_CHECK_CREDIT_STATUS$INT(ID_ACCOUNT TYPE OF ID_REF,
POST_VALUE TYPE OF TPRICE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_credit_account integer;
  declare variable id_reserv_detail integer;
  declare variable credit_limit tprice;
  declare variable b_post_sum tprice;
  declare variable b_pay_sum tprice;
  declare variable difference_value tprice;
  declare variable no_use varchar(255);
  declare variable account_currency tcurrency;
  declare variable round_to numeric(15,4);
begin
  if (:POST_VALUE = 0) then exit;

  select a.IS_CREDIT_ACCOUNT, a.CREDIT_LIMIT, a.ID_RESERV_DETAIL
  from   ACCOUNT A
  where  a.ID_ACCOUNT = :ID_ACCOUNT
  into   :is_credit_account, :credit_limit, :id_reserv_detail;

  if (:is_credit_account = 0
      and exists (select rd.ID_RESERV_DETAIL
                  from   RESERV_DETAIL rd
                  where  rd.ID_RESERV_DETAIL = :id_reserv_detail
                         and rd.CHECK_STATUS = 1)) then
  begin
    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, :credit_limit, 1);
  end

  if (coalesce(:credit_limit, 0) > 0) then begin
    /* FIND BALANCE OF ACCOUNT */
    execute procedure ACCOUNT_BALANCE$INT(:id_account)
    returning_values  :account_currency, :round_to, :no_use, :b_post_sum, :b_pay_sum, :no_use, :no_use;
    b_post_sum = coalesce(:b_post_sum, 0);
    b_pay_sum  = coalesce(:b_pay_sum, 0);

    /* IS THIS POST IS IN LIMIT */
    if ((:b_post_sum + :POST_VALUE) > :credit_limit) then begin
      err_code = -13; /*  */
      difference_value = :b_post_sum + :POST_VALUE - :credit_limit;
      err_text = f_character(29)||FormatFloat(:credit_limit, :round_to)||' '||:account_currency||
                 f_character(28)||FormatFloat(:difference_value, :round_to);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_CREATE_PMS$PMS for: ACCOUNT_MODIFY$INT */
ALTER PROCEDURE ACCOUNT_CREATE_PMS$PMS(ID_OWNER INTEGER,
ID_ACC_TEMPLATE INTEGER,
ID_CURRENCY CHAR(3),
ID_HOTEL INTEGER)
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_MODIFY$PROFILE for: ACCOUNT_MODIFY$INT */
ALTER PROCEDURE ACCOUNT_MODIFY$PROFILE(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_ACCOUNT$EXC for: ACCOUNT_MODIFY$INT */
ALTER PROCEDURE IMPORT_ACCOUNT$EXC(ACCOUNT_NAME VARCHAR(50),
ACCOUNT_CURR VARCHAR(3),
IS_CREDIT_ACCOUNT SMALLINT,
CREDIT_LIMIT NUMERIC(15,4),
PAYMENT_TYPE VARCHAR(20),
NOTE VARCHAR(255),
IS_BLOCKED SMALLINT,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE SMALLINT,
IS_EXTRA SMALLINT,
IS_ALOWED_POS_INTERFACE SMALLINT,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
IS_DEFAULT SMALLINT,
HOTEL_NAME VARCHAR(50))
 RETURNS(ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_ACCOUNT_CREATE$INT for: ACCOUNT_MODIFY$INT */
ALTER PROCEDURE RES_ACCOUNT_CREATE$INT(ID_PROFILE INTEGER,
ID_ACC_TEMPLATE INTEGER,
ACC_CURRENCY CHAR(3),
ID_RESERV_DETAIL INTEGER,
IS_BASE_ENABLE SMALLINT = 1,
IS_EXTRA_ENABLE SMALLINT = 1)
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_MODIFY$INT) */
ALTER PROCEDURE ACCOUNT_MODIFY$INT(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL TYPE OF ID_REF,
IS_PMS_ACCOUNT TYPE OF TLOGICAL,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
declare variable a_dbkey char(8);
  declare variable old_sec_level integer;
  declare variable action_text varchar(255);
  declare variable old_acc_name varchar(50);
  declare variable old_acc_curr varchar(3);
  declare variable old_tax_policy integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, archive');

  new_id_account = :id_account;
  if (:operation = 'add') then begin
    if ((:new_id_account is null) or (:new_id_account <= 0)) then new_id_account = gen_id(ID_ACCOUNT_GEN, 1);

    insert into ACCOUNT(ID_ACCOUNT, ACCOUNT_CURR, ACCOUNT_NAME, IS_CREDIT_ACCOUNT, CREDIT_LIMIT,
           ID_TYPE_PAYMENT, NOTE, IS_BLOCKED, BLOCK_TEXT, SECURITY_LEVEL, IS_BASE, IS_EXTRA,
           IS_ALOWED_POS_INTERFACE, POS_INTERFACE_NOTE, EXT_CODE, ID_TAX_POLICY, ID_PROFILE,
           ID_HOTEL, IS_DEFAULT, IS_PMS_ACCOUNT, ID_RESERV_DETAIL)
    values (:new_id_account, :account_curr, :account_name, 0, null,
           :id_type_payment, :note, :is_blocked, :block_text, :security_level, :is_base, :is_extra,
           :is_alowed_pos_interface, :pos_interface_note, :ext_code, :id_tax_policy, :id_profile,
           :id_hotel, :is_default, coalesce(:IS_PMS_ACCOUNT, 0), :ID_RESERV_DETAIL)
    returning RDB$DB_KEY
    into   :a_dbkey;

    action_text = f_character(29) || :new_id_account || '/' || :account_name;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'ADD_ACCOUNT', :action_text);

    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:NEW_ID_ACCOUNT, :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT);
    -- check special right and log event

  end else begin
    ID_RESERV_DETAIL = null;
    select A.RDB$DB_KEY, A.ID_RESERV_DETAIL, A.SECURITY_LEVEL,
           A.ACCOUNT_NAME, A.ACCOUNT_CURR, A.ID_TAX_POLICY
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :a_dbkey, :id_reserv_detail, :old_sec_level,
           :old_acc_name, :old_acc_curr, :old_tax_policy;
    if (:operation = 'mod') then begin
  
      update ACCOUNT A
      set    A.ACCOUNT_NAME = :account_name,
             A.ID_TYPE_PAYMENT = :id_type_payment,
             A.NOTE = :note,
             A.IS_BLOCKED = :is_blocked,
             A.BLOCK_TEXT = :block_text,
             A.SECURITY_LEVEL = :security_level,
             A.IS_BASE = :is_base,
             A.IS_EXTRA = :is_extra,
             A.IS_ALOWED_POS_INTERFACE = :is_alowed_pos_interface,
             A.POS_INTERFACE_NOTE = :pos_interface_note,
             A.EXT_CODE = :ext_code,
             A.ID_TAX_POLICY = :id_tax_policy,
             A.IS_DEFAULT = :is_default
      where  A.RDB$DB_KEY = :a_dbkey;
  
      execute procedure ACCOUNT_SET_CURRENCY$INT (:a_dbkey, :account_curr);
  
      if (:old_acc_name <> :account_name) then begin
        action_text = f_character(29 ) || :ID_ACCOUNT || '/' || :old_acc_name || ', ' || :old_acc_curr
                      || f_character(28) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME || ', ' || :ACCOUNT_CURR;
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'EDIT_ACCOUNT', :action_text);
      end
  
      if (:old_sec_level <> :SECURITY_LEVEL) then begin
        action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME
                      || f_character(28) || :SECURITY_LEVEL;
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'SET_ACC_SEC_LEVEL', :action_text);
      end
  
      if (:old_tax_policy <> :id_tax_policy) then begin
        execute procedure ACCOUNT_TAXATION_RECALC$INT (:ID_ACCOUNT, :ID_TAX_POLICY);
  
        action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME;                        
  
        select :action_text || f_character(28) || OTP.POLICY_NAME
        from   TAX_POLICY OTP
        where  OTP.ID_TAX_POLICY = :old_tax_policy
        into   :action_text;
        select :action_text || f_character(28) || NTP.POLICY_NAME
        from   TAX_POLICY NTP
        where  NTP.ID_TAX_POLICY = :ID_TAX_POLICY
        into   :action_text;
         
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'VAT_POLICY_CHNG', :action_text);
      end
  
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:ID_ACCOUNT, :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT); -- check special right and log event
  
    end else if (:operation = 'archive') then begin
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 1);

    end
  end

  if ((:id_reserv_detail is null) and (:IS_CREDIT_ACCOUNT = 0)) then begin
    exception ACCOUNT_EXCEPTION '-1010';
    -- The account must have active credit status
    exit;
  end

  if (:is_default = 1) then begin
    update ACCOUNT A
    set    A.IS_DEFAULT = 0
    where  A.ID_HOTEL = :id_hotel
           and A.ID_PROFILE = :id_profile
           and A.ID_ACCOUNT <> :new_id_account;
  end
end
^

/* Alter (ACCOUNT_MODIFY$PROFILE) */
ALTER PROCEDURE ACCOUNT_MODIFY$PROFILE(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable is_pms_account tlogical;
begin

  select a.ID_RESERV_DETAIL, a.IS_PMS_ACCOUNT
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :id_reserv_detail, :is_pms_account;

  execute procedure ACCOUNT_MODIFY$INT (:ID_ACCOUNT, :ID_PROFILE, :ACCOUNT_CURR, :ACCOUNT_NAME,
          :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT, :ID_TYPE_PAYMENT, :NOTE, :IS_BLOCKED, :BLOCK_TEXT,
          :SECURITY_LEVEL, :IS_BASE, :IS_EXTRA, :IS_ALOWED_POS_INTERFACE, :POS_INTERFACE_NOTE,
          :EXT_CODE, :ID_TAX_POLICY, :IS_DEFAULT, :ID_HOTEL, :id_reserv_detail, :is_pms_account, :OPERATION)
  returning_values (:NEW_ID_ACCOUNT);
end
^

/* empty dependent procedure body */
/* Clear: CONTRACT_MANAGEMENT_POST$INT for: ACCOUNT_POST_PMS_ADD$INT */
ALTER PROCEDURE CONTRACT_MANAGEMENT_POST$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_CONTRACT /* TYPE OF ID */ INTEGER,
SUB_CONTRACT /* TYPE OF TSUB_CONTRACT */ VARCHAR(10),
CONTRACT_TYPE VARCHAR(30),
ID_OWNER /* TYPE OF ID */ INTEGER,
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
POST_DATE /* TYPE OF TDATE */ DATE,
STAY /* TYPE OF TCOUNT */ INTEGER,
OWNERSHIP_PERCENT /* TYPE OF TPERCENT */ NUMERIC(15,4))
 RETURNS(POSTED_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
POSTED_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PMS_INCOME_POSTING_CREATE$PMS for: ACCOUNT_POST_PMS_ADD$INT */
ALTER PROCEDURE PMS_INCOME_POSTING_CREATE$PMS(ID_ROOM INTEGER,
ID_OWNER INTEGER,
ID_RENTAL_POOL INTEGER,
ID_CURRENCY VARCHAR(3),
ID_SERVICE INTEGER,
POST_VALUE NUMERIC(15,4),
MANUAL_POST_DATE DATE,
DESCRIPTION VARCHAR(255),
IS_POST_PER_POOL SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PMS_POSTING_CREATE$INT for: ACCOUNT_POST_PMS_ADD$INT */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
POST_DATE /* TYPE OF TDATE */ DATE,
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
POST_ON_PMS_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT,
IS_OWNER_INCOME /* TYPE OF TLOGICAL */ SMALLINT,
ID_ROOM /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_ACCOUNT_POST /* ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_POST_PMS_ADD$INT) */
ALTER PROCEDURE ACCOUNT_POST_PMS_ADD$INT(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_PMS INTEGER,
ID_OWNER INTEGER,
CURR_ORIG VARCHAR(3),
VALUE_ORIG NUMERIC(15,4),
ID_SERVICE INTEGER,
IS_OWNER_INCOME SMALLINT,
DATE_POST DATE)
 RETURNS(NEW_ID_ACCOUNT_POST_PMS INTEGER)
 AS
declare variable line_status smallint;
  declare variable value_post numeric(15,4);
  declare variable curr_post varchar(3);
  declare variable round_to_ numeric(15,6);
  declare variable rate_ double precision;
  declare variable id_hotel integer;
begin

  new_id_account_post_pms = gen_id(ID_ACCOUNT_POST_GEN, 1);
  line_status = 11;

  select O.ID_CURRENCY, A.ID_HOTEL
  from   ACCOUNT$PMS A
         join OWNER$PMS O on O.ID_OWNER = A.ID_OWNER
  where  A.ID_ACCOUNT = :ID_ACCOUNT_PMS
  into   :curr_post, :id_hotel;

  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :CURR_POST
  into   :round_to_;

  select RATE
  from   CURR_CROSS_RATE_GET(:CURR_ORIG, :CURR_POST, :DATE_POST, :id_hotel)
  into   :rate_;

  value_post = round_f(:value_orig * :rate_, :round_to_);

  insert into ACCOUNT_POST$PMS (ID_ACCOUNT_POST, ID_ACCOUNT_PMS, CURR_ORIG,
         VALUE_ORIG, VALUE_POST, CURR_POST, ID_SERVICE, ID_PMS_EVENT, LINE_STATUS,
         IS_OWNER_INCOME, DATE_POST, ID_OWNER)
  values (:NEW_ID_ACCOUNT_POST_PMS, :ID_ACCOUNT_PMS, :CURR_ORIG,
         :VALUE_ORIG, :VALUE_POST, :CURR_POST, :ID_SERVICE, :id_pms_event, :line_status,
         :IS_OWNER_INCOME, :DATE_POST, :ID_OWNER);
end
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_ACCOUNT$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
QTY /* TYPE OF TQTY */ NUMERIC(15,2),
ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
DATE_POST /* TYPE OF TDATE */ DATE,
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ROOM /* TYPE OF ID */ INTEGER = null,
POST_DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_GUEST$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ACCOUNT_ROUTING /* TYPE OF TSHORT_CODE */ VARCHAR(10),
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_TAR_CALC_REPOST$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE RES_TAR_CALC_REPOST$INT(ID_TAR_CALC /* TYPE OF ID_REF */ INTEGER,
ID_RESERV_DETAIL /* TYPE OF ID_REF */ INTEGER,
RECALC_MARKER VARCHAR(40))
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_ADD$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_ADD$INT(ID_ACCOUNT TYPE OF ID,
ID_GUEST TYPE OF ID_REF,
ID_SECQUENCE TYPE OF ID_REF,
DATE_POST TYPE OF TDATE,
ID_SERVICE TYPE OF ID,
ID_TARIFF TYPE OF ID_REF,
ID_ROOM TYPE OF ID_REF,
IS_BASE TYPE OF TLOGICAL,
QTY_POST TYPE OF TQTY,
PRICE TYPE OF TPRICE,
ORIG_CURRENCY TYPE OF TCURRENCY,
RATE TYPE OF TRATE,
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
POST_TEXT TYPE OF TDESCRIPTION_SHORT,
RESOURCE_TEXT TYPE OF TREASON,
CHANGED_TEXT TYPE OF TTEXT_SHORT,
ID_MASTER_ADDINS_ACC_POST TYPE OF ID_REF,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
NEW_ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable price_post double precision;
  declare variable post_rate numeric (15, 6);
  declare variable curr_post char(3);
  declare variable account_currency char(3);
  declare variable id_pack_service integer;
  declare variable id_room_type integer;
  declare variable room_name varchar(30);
  declare variable is_archive integer;
  declare variable id_tax_policy integer;
  declare variable id_sale_taxation integer;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable check_option varchar(255);
  declare variable id_hotel integer;
  declare variable id_srv_hotel integer;
  declare variable service_name varchar(30);
  declare variable account_name varchar(50);
begin
  ID_GUEST = nullif(:ID_GUEST, -1);

  execute procedure POST_PRICE_CHECK$INT (:QTY_POST, :PRICE, :ORIG_CURRENCY);

  if ( (:IS_BASE = 1) or (:ID_MASTER_ADDINS_ACC_POST > 0) ) then
    check_option = 'IS_BASE;ALLOW_POSTING';
  else
    check_option = 'IS_EXTRA;ALLOW_POSTING';

  execute procedure ACCOUNT_VALIDATE$INT(:id_account, :check_option)
  returning_values  (:err_code, :err_text, :account_currency, :id_tax_policy, :id_hotel, :account_name);
  if (:err_code < 0) then EXIT; --  exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;

  select s.ID_HOTEL, s.SERVICE_NAME
  from   SERVICES S
  where  s.ID_SERVICE = :ID_SERVICE
  into   :id_srv_hotel, :service_name;

  if (:id_srv_hotel is distinct from :id_hotel) then
    exception POSTING_EXCEPTION '-1056' || f_character(31) || f_character(29) || :service_name || f_character(28) || :account_name;

  if (:rate is null) then begin
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :orig_currency, :date_post, :id_guest)
    returning_values  :rate;
  end

  curr_post  = :account_currency;
  if (:orig_currency = :account_currency) then begin
    post_rate  = :rate;
  end else begin
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :account_currency, :date_post, :id_guest)
    returning_values  :post_rate;
  end

  execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :id_tax_policy, :ID_TARIFF, :DATE_POST - :FROM_DATE)
  returning_values (:id_sale_taxation);

  execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:QTY_POST, :PRICE,
                    :RATE, :post_rate, :id_sale_taxation)
  returning_values  :price_post, :post_net_value, :post_gross_value;

  execute procedure ACCOUNT_CHECK_CREDIT_STATUS$INT (:ID_ACCOUNT, :price_post * :QTY_POST)
  returning_values (:ERR_CODE, :ERR_TEXT);
  if (:ERR_CODE <> 0) then exit;

  --
  new_id_account_post = gen_id (id_account_post_gen, 1);

  if (:post_text starting with 'PACK') then begin
    id_pack_service = substring(:post_text from 6 for 20);
    post_text = '';
  end else begin
    id_pack_service = -1;
  end
  if (:is_base = 1) then id_master_addins_acc_post = :new_id_account_post;

  select R.ROOM_NAME, R.ID_ROOM_TYPE
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :room_name, :id_room_type;

  if (:id_guest is null) then begin
    is_archive = 1;
  end else begin
    select iif(G.CHECK_STATUS = 1, 1, 0)
    from   GUEST G
    where  G.ID_GUEST = :id_guest
    into   :is_archive;
  end

  insert into ACCOUNT_POST (
    ID_ACCOUNT_POST, ID_ACCOUNT, ID_GUEST, ID_SERVICE, ID_TARIFF, ID_ROOM,
    IS_BASE, DATE_POST, QTY_POST, QTY_FREE, PRICE_POST, POST_NET_VALUE, POST_GROSS_VALUE, CURR_POST, RATE_POST,
    PRICE_ORIG, CURR_ORIG, RATE_ORIG, IS_LOCKED_FOR_UPDATE, TO_DATE, FROM_DATE, ID_SEQUENCE,
    SHORT_CODE, CHANGED_TEXT, ID_MASTER_ADDINS_ACC_POST, ID_PACK_SERVICE, ROOM_NAME, ID_ROOM_TYPE,
    ID_SALE_TAXATION, AC, IS_ARCHIVE, IN_DOC_QTY, IN_DOC_VALUE, DESCRIPTION)
  values (
    :new_id_account_post, :id_account, :id_guest, :id_service, :id_tariff, coalesce(:id_room, -1),
    :is_base, :date_post, :qty_post, 0, :price_post, :post_net_value, :post_gross_value, :curr_post, :post_rate,
    :price, :orig_currency, :rate, 0, :TO_DATE, :FROM_DATE, :id_secquence,
    :short_code, :changed_text, :id_master_addins_acc_post, :id_pack_service, :room_name, :id_room_type,
    :id_sale_taxation, '00', :is_archive, 0, 0, :DESCRIPTION);

  if ((coalesce(:post_text, '') <> '') or (coalesce(:resource_text, '') <> '')) then begin
    insert into ACCOUNT_POSTING_DET (ID_ACCOUNT_POST, POST_TEXT, QTY, FROM_DATETIME, TO_DATETIME, RESOURCE_TEXT)
    values (:new_id_account_post, :post_text, :qty_post, :FROM_DATE, :TO_DATE, :resource_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_TAXATION_RECALC$INT for: ACCOUNT_POSTING_TAXATION_GET */
ALTER PROCEDURE ACCOUNT_TAXATION_RECALC$INT(ID_ACCOUNT INTEGER,
NEW_ID_TAX_POLICY INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SERVICE_TAXATION_MODIFY$CFG for: ACCOUNT_POSTING_TAXATION_GET */
ALTER PROCEDURE SERVICE_TAXATION_MODIFY$CFG(ID_TAX_POLICY /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_SALE_TAXATION /* TYPE OF ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_TAXATION_GET) */
ALTER PROCEDURE ACCOUNT_POSTING_TAXATION_GET(ID_SERVICE ID_REF,
ID_ACCOUNT_TAX_POLICY ID_REF,
ID_RATE ID_REF,
PASSED_NIGHTS TCOUNT)
 RETURNS(ID_SALE_TAXATION ID_REF)
 AS
declare variable id_rate_tax_policy id_ref;
declare variable service_name varchar(30);
declare variable policy_name varchar(200);
declare variable tarifa_name varchar(50);
begin
  id_rate_tax_policy = null;
  select t.EXPLICIT_TAX_POLICY, tr.TARIFA_NAME
  from   TAR_HEAD T
         left outer join TARIFA TR on tr.ID_TARIFA = t.ID_TAR_HEAD
  where  t.ID_TAR_HEAD = nullif(:ID_RATE, -1)
         and t.EXPLICIT_TAX_POLICY is not null
         and coalesce(t.EXPLICIT_POLICY_NIGHTS_REQUIRED, 0) <= :PASSED_NIGHTS
  into   :id_rate_tax_policy, :tarifa_name;

  select ST.ID_SALE_TAXATION
  from   SERVICE_TAXATION ST
  where  ST.ID_SERVICE = :ID_SERVICE
         and ST.ID_TAX_POLICY = coalesce(:id_rate_tax_policy, :ID_ACCOUNT_TAX_POLICY)
  into   :id_sale_taxation;

  if (:ID_SALE_TAXATION is null) then begin
    select s.SERVICE_NAME
    from   SERVICES s
    where  s.ID_SERVICE = :ID_SERVICE
    into   :service_name;

    select tp.POLICY_NAME || coalesce('('|| :tarifa_name ||')', '')
    from   TAX_POLICY tp
    where  tp.ID_TAX_POLICY = coalesce(:id_rate_tax_policy, :ID_ACCOUNT_TAX_POLICY)
    into   :policy_name;

    exception POSTING_EXCEPTION '-384' || f_character(31) || f_character(29) || :service_name || f_character(28) || :policy_name || f_character(28);
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_TRANSFER$INT for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE_PERC for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_PERC(IN_ID_ACCOUNT_POST VARCHAR(4000),
IN_PERC NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(30))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_POSTING$INT for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_POSTING$INT(ID_RESOURCE_RESERVATION /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
PRICE_DESCRIPTION /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
ID_RESERV_DETAIL /* TYPE OF ID */ INTEGER,
ID_EXTERNAL_CLIENT_ACCCOUNT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(DOC_SELECTED /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_POSTING_UPDATE$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE$INT(AP_DBKEY TYPE OF TDB_KEY,
ID_SERVICE TYPE OF ID_REF,
ID_TARIFF TYPE OF ID_REF,
ID_ROOM TYPE OF ID_REF,
QTY_POST TYPE OF TQTY,
QTY_FREE TYPE OF TQTY,
PRICE TYPE OF TVALUE,
CURR TYPE OF TCURRENCY,
RATE TYPE OF TRATE,
CHANGED_TEXT VARCHAR(40),
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
IS_CONSEQUENTIAL_UPDATE TYPE OF TBOOLEAN = 0,
RE_ROUTE_ACCOUNT TYPE OF ID_REF = null)
 RETURNS(OUT_QTY_POST TYPE OF TQTY,
OUT_PRICE_POST TYPE OF TVALUE,
OUT_AC VARCHAR(2))
 AS
declare variable date_post date;
  declare variable orig_is_base integer;
  declare variable orig_id_service integer;
  declare variable orig_id_room integer;
  declare variable orig_short_code varchar(255);
  declare variable orig_qty_post integer;
  declare variable orig_ac varchar(2);
  declare variable is_locked_for_update integer;
  declare variable orig_locked_for_update integer;
  declare variable orig_id_tariff integer;
  declare variable orig_id_guest integer;
  declare variable id_type_stay integer;
  declare variable id_room_type integer;
  declare variable id_board integer;
  declare variable id_pack_service integer;
  declare variable new_id_pack_service integer;
  declare variable post_currency char(3);
  declare variable room_name varchar(30);
  declare variable original_post varchar(30);
  declare variable new_ac varchar(2);
  declare variable orig_in_doc_qty numeric(15,2);
  declare variable orig_in_doc_value double precision;
  declare variable rate_post numeric(15,6);
  declare variable id_base_doc integer;
  declare variable id_tax_policy integer;
  declare variable price_post double precision;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable id_sale_taxation integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable orig_price_post tprice;
  declare variable round_to numeric(15,4);
  declare variable account_name tobject_name;
  declare variable err_code integer;
  declare variable err_text varchar(100);
  declare variable id_account integer;
  declare variable orig_id_master_addins_acc_post integer;
  declare variable check_options varchar(255);
begin
  /* GET DATA */
  original_post = '';
  new_id_pack_service = null;

  select AP.DATE_POST, AP.IS_BASE, AP.ID_SERVICE, AP.ID_BASE_DOC,
         AP.SHORT_CODE, AP.QTY_POST, ap.PRICE_POST, AP.IS_LOCKED_FOR_UPDATE,
         AP.AC, AP.ID_TARIFF, AP.ID_GUEST, AP.ID_ROOM,
         AP.CURR_POST, AP.ID_PACK_SERVICE, AP.ID_ROOM_TYPE,
         AP.IN_DOC_QTY, AP.IN_DOC_VALUE, AP.RATE_POST, ap.ID_SALE_TAXATION,
         ap.ID_ACCOUNT, ap.ID_ACCOUNT_POST, ap.ID_MASTER_ADDINS_ACC_POST
  from   ACCOUNT_POST AP
  where  AP.rdb$db_key = :AP_DBKEY
  into   :date_post, :orig_is_base, :orig_id_service, :id_base_doc,
         :orig_short_code, :orig_qty_post, :orig_price_post, :orig_locked_for_update,
         :orig_ac, :orig_id_tariff, :orig_id_guest, :orig_id_room,
         :post_currency, :id_pack_service, :id_room_type,
         :orig_in_doc_qty, :orig_in_doc_value, :rate_post, :id_sale_taxation,
         :id_account, :id_account_post, :orig_id_master_addins_acc_post;

  check_options = 'ALLOW_POSTING;';
  if (:RE_ROUTE_ACCOUNT is not null and :id_base_doc is null and :id_account <> :RE_ROUTE_ACCOUNT) then begin
    -- IMPORTANT !!! Re-routing is possible only in this case!
    id_account = :RE_ROUTE_ACCOUNT;
    if ( (:orig_is_base = 1) or (:orig_id_master_addins_acc_post > 0) ) then
      check_options = :check_options || 'IS_BASE;';
    else
      check_options = :check_options || 'IS_EXTRA;';
  end
  is_locked_for_update = :orig_locked_for_update; /* to initialize and preserve from null */

  execute procedure ACCOUNT_VALIDATE$INT(:id_account, :check_options)
  returning_values  (:err_code, :err_text, :post_currency, :id_tax_policy, :id_hotel, :account_name);
  if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;

  if (:IS_CONSEQUENTIAL_UPDATE is distinct from 1) then begin
    -- direct post update - manual edition restrictions check
    if (:QTY_POST = -1) then QTY_POST = :orig_qty_post;   -- preserve current qty

    if (:QTY_POST <> :orig_qty_post) then exception POSTING_EXCEPTION '-379';

    if ((:orig_is_base = 1) and ((:QTY_POST <> 1) or (:ID_SERVICE <> :orig_id_service))) then
      exception POSTING_EXCEPTION '-223';

    if (:orig_ac = '01') then execute procedure RIGHTS_CHECK_GRANTED$INT('BALANCES_EDIT_CLOSED');

    short_code = :orig_short_code;
    id_tariff  = :orig_id_tariff;
    id_room    = :orig_id_room;
    is_locked_for_update = 1;  /* manual corrections must lock the postings  */

  end else begin
    /* post changes is a result from some user operation, indirect update ('NORMAL', 'FORCED', safes recalc, etc....) */
    is_locked_for_update = 0;

    if (:orig_is_base = 1) then begin
      /* PREPARING THE PACKET SERVICE */
      select S.ID_TYPE_STAY, S.ID_ROOM_TYPE
      from   SERVICE_PACKET S
      where  S.ID_SERVICE = :id_service
      into   :id_type_stay, :id_room_type;

      select GS.ID_BOARD
      from   GUEST_STAY GS
      where  GS.ID_GUEST = :orig_id_guest
             and GS.FOR_DATE = :date_post
      into   :id_board;

      execute procedure TAR_GET_BASE_SERVICE$INT(:id_type_stay, :id_room_type, :id_board, :id_hotel)
      returning_values  :id_pack_service;
      /* detecting change of STAY_TYPE or ROOM_TYPE */
      if (exists(
        select *
        from   SERVICE_PACKET S
        where  S.ID_SERVICE = :orig_id_service
               and ((S.ID_TYPE_STAY is distinct from :id_type_stay) or (S.ID_ROOM_TYPE is distinct from :id_room_type))
      )) then original_post = 'CHANGED';
    end
  end

  select R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :room_name;

  if (:orig_locked_for_update = 1
      and :changed_text starting with 'NORMALRECALC'
      and :id_service = :orig_id_service
      --and :orig_is_anul = 0
      and :id_tariff = :orig_id_tariff) then
  begin
    -- price is locked for update
    update ACCOUNT_POST AP
    set    AP.ID_ROOM      = :id_room,
           AP.ROOM_NAME    = :room_name,
           Ap.FROM_DATE    = :from_date,
           Ap.TO_DATE      = :to_date,
           AP.ID_PACK_SERVICE  = :id_pack_service,
           AP.CHANGED_TEXT     = :changed_text,
           AP.USER_CHANGED     = current_user,
           AP.DATETIME_CHANGED = current_timestamp
    where  AP.rdb$db_key   = :AP_DBKEY;
    OUT_QTY_POST = :orig_qty_post;
    OUT_PRICE_POST = :orig_price_post;
    OUT_AC = :orig_ac;
  end else begin
    -- fully update
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :curr, :date_post, :orig_id_guest)
    returning_values  :rate;
  
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :post_currency, :date_post, :orig_id_guest)
    returning_values  :rate_post;
  
    if (:id_base_doc is null) then begin
      execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :id_tax_policy, :ID_TARIFF, :date_post - :from_date)
      returning_values (:id_sale_taxation);
    end

    execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:QTY_POST, :PRICE,
                      :RATE, :rate_post, :id_sale_taxation)
    returning_values  :price_post, :post_net_value, :post_gross_value;

    select c.ROUND_TO
    from   CURRS c
    where  c.CURR = :post_currency
    into   :round_to;

    if ( (:id_base_doc is not null)
         and (:qty_post = :orig_in_doc_qty)
         and (round_f(:price_post * :qty_post - :orig_in_doc_value * :orig_in_doc_qty, :round_to) = 0))
    then new_ac = '01';
    else new_ac = '00';                   
  
    if (:new_ac = '00') then begin
      execute procedure ACCOUNT_CHECK_CREDIT_STATUS$INT (:id_account, :price_post * :QTY_POST - :orig_price_post * :orig_qty_post)
      returning_values (:err_code, :err_text);
      if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;
    end

    update ACCOUNT_POST AP
    set    AP.ID_ACCOUNT           = :id_account,
           AP.ID_SERVICE           = :id_service,
  
           AP.QTY_POST             = :qty_post,
           AP.QTY_FREE             = :qty_free,
           AP.PRICE_POST           = :price_post,
           AP.CURR_POST            = :post_currency,
           AP.RATE_POST            = :rate_post,
           AP.RATE_ORIG            = :rate,
           AP.PRICE_ORIG           = :price,
           AP.CURR_ORIG            = :curr,
           AP.POST_NET_VALUE       = :post_net_value,
           AP.POST_GROSS_VALUE     = :post_gross_value,
  
           AP.AC                   = :new_ac,
           AP.IS_ANUL              = 0,
           AP.ANUL_REASON          = '',
           AP.IS_LOCKED_FOR_UPDATE = :is_locked_for_update,
           AP.ID_TARIFF            = :id_tariff,
           AP.ID_PACK_SERVICE      = :id_pack_service,
           AP.ID_ROOM              = :id_room,
           AP.ID_ROOM_TYPE         = :id_room_type,
           AP.ROOM_NAME            = :room_name,
           AP.ID_SALE_TAXATION     = :id_sale_taxation,
           AP.ORIGINAL_POST        = :original_post,
           AP.SHORT_CODE           = :short_code,
           AP.CHANGED_TEXT         = :changed_text,
           AP.USER_CHANGED         = current_user,
           AP.DATETIME_CHANGED     = current_timestamp,
           Ap.FROM_DATE            = :from_date,
           Ap.TO_DATE              = :to_date
    where  AP.rdb$db_key = :AP_DBKEY
    returning new.id_account_post, new.id_pack_service
    into   :id_account_post, :new_id_pack_service;
  
    if (:new_ac = '01') then begin
      update ACCOUNT_POST_CORRECTION APC
      set    APC.IS_OPEN = 0
      where  APC.ID_ACCOUNT_POST = :id_account_post
             and APC.IS_OPEN = 1;
    end

    if (:orig_is_base = 1 and :new_id_pack_service <> :id_pack_service) then begin
      -- update add_inses with new pack service
      update ACCOUNT_POST AP
      set    ap.ID_PACK_SERVICE = :new_id_pack_service
      where  ap.ID_MASTER_ADDINS_ACC_POST = :id_account_post
             and ap.IS_BASE = 0;
    end

    OUT_QTY_POST = :qty_post;
    OUT_PRICE_POST = :price_post;
    OUT_AC = :new_ac;
  end
end
^

/* Alter (ACCOUNT_POSTING_UPDATE_PERC) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_PERC(IN_ID_ACCOUNT_POST VARCHAR(4000),
IN_PERC NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(30))
 AS
declare variable id_account_post integer;
  declare variable ap_dbkey char(8);
  declare variable id_service integer;
  declare variable id_tariff integer;
  declare variable id_room integer;
  declare variable qty_post numeric (15,4);
  declare variable qty_free numeric (15,4);
  declare variable short_code varchar(255);
  declare variable orig_currency char(3);
  declare variable orig_rate numeric (15,4);
  declare variable orig_price numeric (15,4);
  declare variable new_orig_price double precision;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  for
    select item
    from   SYSTEM_STRING_PARSER(:in_id_account_post, ',')
    into   :id_account_post
  do begin
    select AP.rdb$db_key, AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST,
           AP.QTY_FREE, AP.SHORT_CODE, AP.CURR_ORIG, AP.RATE_ORIG, AP.PRICE_ORIG,
           ap.FROM_DATE, ap.TO_DATE
    from   ACCOUNT_POST AP
    where  AP.ID_ACCOUNT_POST = :id_account_post
    into   :ap_dbkey, :id_service, :id_tariff, :id_room, :qty_post,
           :qty_free, :short_code, :orig_currency, :orig_rate, :orig_price,
           :from_date, :to_date;

    new_orig_price = :orig_price + :orig_price * :in_perc;

    execute procedure ACCOUNT_POSTING_UPDATE$INT(:ap_dbkey,
            :id_service, :id_tariff, :id_room,
            :qty_post, :qty_free, :new_orig_price, :orig_currency, :orig_rate,
            :in_changed_text, :short_code, :from_date, :to_date)
    returning_values  :no_use, :no_use, :no_use;
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_CHECK_CREDIT_STATUS$INT for: ACCOUNT_SET_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_CHECK_CREDIT_STATUS$INT(ID_ACCOUNT /* TYPE OF ID_REF */ INTEGER,
POST_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_MODIFY$INT for: ACCOUNT_SET_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_MODIFY$INT(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL /* TYPE OF ID_REF */ INTEGER,
IS_PMS_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ANUL$DOC for: ACCOUNT_SET_CREDIT_STATUS$INT */
ALTER PROCEDURE DOCUMENT_ANUL$DOC(ID_DOC_HEAD INTEGER,
ANUL_REASON VARCHAR(100),
MAKE_ANNUL_REPORT SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_STORNO$INT for: ACCOUNT_SET_CREDIT_STATUS$INT */
ALTER PROCEDURE DOCUMENT_STORNO$INT(ID_DOC_HEAD INTEGER,
DESCRIPTION VARCHAR(100),
STORNO_PAYMENTS SMALLINT)
 RETURNS(ID_STORNO_DOC INTEGER,
ID_HOTEL INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_SET_CREDIT_STATUS$INT) */
ALTER PROCEDURE ACCOUNT_SET_CREDIT_STATUS$INT(ID_ACCOUNT TYPE OF ID,
IS_CREDIT_ACCOUNT TYPE OF TLOGICAL,
CREDIT_LIMIT TYPE OF TPRICE,
SET_UNCONDITIONAL TYPE OF TLOGICAL = 0)
 AS
declare variable account_name varchar(50);
  declare variable old_is_credit_account smallint;
  declare variable action_code varchar(50);
  declare variable action_text varchar(255);
  declare variable id_profile integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable a_dbkey char(8);
  declare variable old_credit_limit tprice;
begin

  select A.IS_CREDIT_ACCOUNT, a.CREDIT_LIMIT, A.ID_ACCOUNT, A.ACCOUNT_NAME,
         A.ID_PROFILE, A.ID_RESERV_DETAIL, a.RDB$DB_KEY
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :old_is_credit_account, :old_credit_limit, :id_account, :account_name,
         :id_profile, :id_reserv_detail, :a_dbkey;
  /* --------------------------------------- */
  if (:IS_CREDIT_ACCOUNT is not distinct from :old_is_credit_account
      and :CREDIT_LIMIT is not distinct from :old_credit_limit) then exit;
  /* --------------------------------------- */
  if (:is_credit_account > :old_is_credit_account and :set_unconditional = 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('ACC_SET_CREDIT');

  end else if (:is_credit_account < :old_is_credit_account and :id_reserv_detail is not null) then begin
    select RD.CHECK_STATUS
    from   RESERV_DETAIL RD
    where  RD.ID_RESERV_DETAIL = :id_reserv_detail
    into   :check_status;

    if (:check_status = 1) then exception ACCOUNT_EXCEPTION '-1017';
  end

  update ACCOUNT A
  set    A.IS_CREDIT_ACCOUNT = :is_credit_account,
         A.CREDIT_LIMIT = :credit_limit
  where  A.RDB$DB_KEY = :a_dbkey;

  if (:old_is_credit_account <> :is_credit_account) then begin
    action_code = iif(:is_credit_account = 1, 'SET_CREDIT_ACCOUNT', 'RESET_CREDIT_ACCOUNT');
    action_text = f_character(29) || :id_account || '/' || :account_name;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, :action_code, :action_text);
  end
end
^

/* Alter (ACCOUNT_TAXATION_RECALC$INT) */
ALTER PROCEDURE ACCOUNT_TAXATION_RECALC$INT(ID_ACCOUNT INTEGER,
NEW_ID_TAX_POLICY INTEGER)
 AS
declare variable nat_round_to numeric(15,4);
  declare variable ap_dbkey char(8);
  declare variable id_account_sale_taxation integer;
  declare variable id_sale_taxation integer;
  declare variable nat_curr varchar(3);
  declare variable id_service integer;
  declare variable id_rate integer;
  declare variable passed_nights integer;
begin
  select h.NATION_CURR
  from   ACCOUNT A
         join HOTEL H on h.ID_HOTEL = a.ID_HOTEL
  where  a.ID_ACCOUNT = :ID_ACCOUNT
  into   :nat_curr;

  select C.ROUND_TO
  from   CURRS C
  where  c.CURR = :nat_curr
  into   :nat_round_to;

  for
    select ap.RDB$DB_KEY, ST.ID_SALE_TAXATION, ap.ID_SERVICE, ap.ID_TARIFF, ap.DATE_POST - ap.FROM_DATE
    from   ACCOUNT_POST AP
           join SERVICE_TAXATION ST on ST.ID_SERVICE = ap.ID_SERVICE
    where  AP.ID_ACCOUNT = :ID_ACCOUNT
           and AP.ID_BASE_DOC is null
           and ST.ID_TAX_POLICY = :NEW_ID_TAX_POLICY
           and ap.IS_ANUL = 0
    into   :ap_dbkey, :id_account_sale_taxation, :id_service, :id_rate, :passed_nights
  do begin
    execute procedure ACCOUNT_POSTING_TAXATION_GET (:id_service, :NEW_ID_TAX_POLICY, :id_rate, :passed_nights)
    returning_values (:id_sale_taxation);

    if (:id_account_sale_taxation = :id_sale_taxation) then begin
      -- no differential taxation (produced from rate)
      execute procedure ACCOUNT_POSTING_UPDATE_TAX$INT (:ap_dbkey, :id_account_sale_taxation,
              :nat_round_to, 'ACCOUNT VAT POLICY CHANGED');
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: CANCEL_BOOKING$EXC for: APPLY_BOOKING_STATUS$EXC */
ALTER PROCEDURE CANCEL_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20),
STATUS VARCHAR(20))
 RETURNS(BOOKING_ID INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_BOOKING_FINALIZE$EXC for: APPLY_BOOKING_STATUS$EXC */
ALTER PROCEDURE IMPORT_BOOKING_FINALIZE$EXC(BOOKING_ID INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1,
STATUS VARCHAR(50) = null,
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20) = null,
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20) = null)
 RETURNS(RECORD_TIMESTAMP TIMESTAMP,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE RES_CHECK_OUT_GUESTS$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND SMALLINT = 0,
EARLYCHECKOUT_DATE DATE = null)
 AS
declare variable action_code varchar(100);
  declare variable cleaning_restriction varchar(10);
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable id_reserv_detail integer;
  declare variable id_guest integer;
  declare variable id_room integer;
  declare variable rd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable checkout_status integer;
  declare variable sys_date date;
  declare variable id_hotel integer;
begin
  checkout_status = 1;
  action_code = case when :check_out_kind = 0 then 'CHECK_OUT'
                     when :check_out_kind = 1 then 'CHECK_OUT_EARLY1'
                     when :check_out_kind = 2 then 'CHECK_OUT_EARLY2'
                     when :check_out_kind = 3 then 'CHECK_OUT_EARLY3'
                end;

  for
    select RD.ID_RESERV_DETAIL, RD.ID_ROOM, RD.RDB$DB_KEY, rd.ID_HOTEL,
           (select sd.SYSTEM_DATE
            from   SYSTEM_DATE_GET (rd.ID_HOTEL) sd)
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :id_reserv_detail, :id_room, :rd_dbkey, :id_hotel, :sys_date
  do begin

    for
      select G.ID_GUEST, G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.CHECK_STATUS = 0 /* checked in */
      into   :id_guest, :g_dbkey
    do begin
      if (:CHECK_OUT_KIND = 3) then begin
        -- DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
        update GUEST G
        set    G.EARLYCHECKOUT_DATE = coalesce(:EARLYCHECKOUT_DATE, :sys_date)
        where  g.RDB$DB_KEY = :g_dbkey;

        execute procedure GUEST_SET_MANUAL_STAY$INT(:rd_dbkey, :id_guest, coalesce(:EARLYCHECKOUT_DATE, :sys_date))
        returning_values  :err_code, :err_text;
        if (:err_code < 0) then exception RESERV_CHECK_OUT_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
      end

      update ACCOUNT_POST AP
      set    AP.IS_ARCHIVE = 1
      where  AP.ID_GUEST = :id_guest;
    
      execute procedure GUEST_SET_STATUS$INT (:g_dbkey, :checkout_status);

      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, :action_code, '');
    end

    if (:CHECK_OUT_KIND = 3) then begin
      -- DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
      execute procedure OCCUPANCY_RESERV$INT(:rd_dbkey);
    end

    execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

    execute procedure SETTING_GET_VALUE('CLEANING_RESTRICTION', :id_hotel)
    returning_values  :cleaning_restriction;
  
    if (:cleaning_restriction <> '0' and :id_room > 0) then begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'CHECK_OUT', 'set_dirty');
    end

    execute procedure RES_SAVE_STATUS$INT (:rd_dbkey, :checkout_status);

    update RESERV_DETAIL rd
    set    rd.CHECK_OUT_KIND = :CHECK_OUT_KIND,
           rd.EARLYCHECKOUT_DATE = iif(:check_out_kind > 0, coalesce(:EARLYCHECKOUT_DATE, :sys_date), null)
    where  rd.RDB$DB_KEY = :rd_dbkey;

    execute procedure RES_BONUSPOINTS_APPLY$CL (:id_reserv_detail);
  end

end
^

/* Alter (APPLY_BOOKING_STATUS$EXC) */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20)
 AS
declare variable err_text varchar(255);
declare variable dummy_int integer;
declare variable anul_reason varchar(30);
declare variable selection_id integer;

declare variable status_code smallint;
declare variable current_anul_code smallint;
declare variable current_status_code smallint;
declare variable current_status_text varchar(50);
declare variable new_status_text varchar(50);
declare variable extra_posts_left integer;
declare variable check_out_kind smallint;
declare variable earlycheckout_date date;
begin
  if (:booking_db_key is null) then begin
    select rd.RDB$DB_KEY, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.ID_RESERV_DETAIL = :BOOKING_ID
    into   :booking_db_key, :current_status_code, :current_anul_code;
  end else begin
    select rd.id_reserv_detail, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.rdb$db_key = :booking_db_key
    into   :booking_id, :current_status_code, :current_anul_code;
  end

  execute procedure IMPORT_BOOKING_STATUS$EXC(:status, -2)
  returning_values :status_code;

  execute procedure EXPORT_BOOKING_STATUS$EXC(:current_status_code, :current_anul_code)
  returning_values :current_status_text;
  execute procedure IMPORT_BOOKING_STATUS$EXC(:current_status_text, :current_status_code)
  returning_values :current_status_code;

  /* nop - exit */
  if (:current_status_code = :status_code) then exit;

  /* validate status transition */
  if (
     /* terminal status values - void booking */
    (:current_status_code in (1004/*no show*/, 1005/*canceled*/))

    /* void over checkin */
    or ((:current_status_code >= 0) and (:status_code in (1004/*no show*/, 1005/*canceled*/)))

    /* positive status downgrade */
    or ((:current_status_code > 0) and (:current_status_code > :status_code))
  )  then begin
    execute procedure PRINT_BOOKING_STATUS$EXC(:current_status_code) returning_values :current_status_text;
    execute procedure PRINT_BOOKING_STATUS$EXC(:status_code) returning_values :new_status_text;

    exception VALIDATE_EXCEPTION '-1022' || f_character(31) || '@{invalid_status_transition} ' || :current_status_text || ' -> ' || :new_status_text;
  end

  anul_reason = null;
  if (1004 = :status_code) then begin
    anul_reason = 'NOSHOW';
  end else if (1005 = :status_code) then begin
    anul_reason = 'CANCELED';
  end

  if (:anul_reason is null) then begin
    if (0 > :status_code) then begin
      execute procedure RES_SAVE_STATUS$INT(:booking_db_key, :status_code, :CONFIRMATION_NUMBER);
    end else begin
      if (:status_code in (0, 1) and 0 > :current_status_code) then begin
        -- checkin
        execute procedure RES_SET_CHECKIN$INT (:booking_db_key)
        returning_values (:dummy_int, :err_text, :dummy_int, :dummy_int);
      end
      if (1 = :status_code and 1 > :current_status_code) then begin
        -- checkout
        selection_id = gen_id(SELECTION_GEN, 1);
        update RESERV_DETAIL
        set    selection_id=:selection_id
        where  rdb$db_key=:booking_db_key
        returning new.CHECK_OUT_KIND, new.EARLYCHECKOUT_DATE
        into   :check_out_kind, :earlycheckout_date;
    
        execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id, :check_out_kind, :earlycheckout_date);
      end
    end
  end else begin
    -- void
    execute procedure RES_ANUL_DETAIL$INT(:booking_db_key, :anul_reason, :CANCELATION_NUMBER)
    returning_values  :dummy_int, :extra_posts_left;
    if (:extra_posts_left = 1) then exception BOOKING_EXCEPTION '-1042';

  end
end
^

/* Alter (CANCEL_BOOKING$EXC) */
ALTER PROCEDURE CANCEL_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20,
STATUS VARCHAR(20))
 RETURNS(BOOKING_ID INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable hotel_id integer;
declare variable cancel_event_log_id integer;
begin
  /* init */
  err_code = 0;
  err_text = '';

  execute procedure import_mark_transaction$exc;

  select first 1 b.id_reserv_detail, b.id_log_event_annul, b.from_date, b.to_date
  from   reserv_detail b
  where  b.number=:number
         and b.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  order by id_log_event_annul nulls first
  into   :booking_id, cancel_event_log_id, :from_date, :to_date;

  if ((:booking_id is null) or (:cancel_event_log_id is not null)) then begin
    /* not found or found but already in void status - ignore and exit */
    exit;
  end

  /* verify hotel */
  execute procedure lookup_hotel$exc(:hotel, 'BOOKING', :booking_id)
  returning_values :hotel_id;

  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  execute procedure APPLY_BOOKING_STATUS$EXC(
    :booking_id, null, :status, :confirmation_number, :cancelation_number
  );
end
^

/* empty dependent procedure body */
/* Clear: PMS_EVENT_POST$INT for: CONTRACT_MANAGEMENT_POST$INT */
ALTER PROCEDURE PMS_EVENT_POST$INT(ID_PMS_EVENT INTEGER,
ID_ROOM_CONTRACT INTEGER,
ID_RENTAL_POOL INTEGER,
POST_DATE DATE,
PRICE_WITH_VAT NUMERIC(15,4),
PRICE_WO_VAT NUMERIC(15,4),
CURR VARCHAR(3),
MAX_ADULT_CNT INTEGER,
STAY INTEGER,
BED_NIGHT_CNT INTEGER,
BOOKING_CNT INTEGER,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (CONTRACT_MANAGEMENT_POST$INT) */
ALTER PROCEDURE CONTRACT_MANAGEMENT_POST$INT(ID_PMS_EVENT TYPE OF ID,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
CONTRACT_TYPE VARCHAR(30),
ID_OWNER TYPE OF ID,
ID_RENTAL_POOL TYPE OF ID_REF,
VALUE_ORIG TYPE OF TPRICE,
CURR_ORIG TYPE OF TCURRENCY,
POST_DATE TYPE OF TDATE,
STAY TYPE OF TCOUNT,
OWNERSHIP_PERCENT TYPE OF TPERCENT)
 RETURNS(POSTED_VALUE TYPE OF TPRICE,
POSTED_CURRENCY TYPE OF TCURRENCY)
 AS
declare variable night_price numeric(15,4);
  declare variable night_price_curr varchar(3);
  declare variable id_account integer;
  declare variable my_value numeric(15,4);
  declare variable my_currency varchar(3);
  declare variable id_service integer;
  declare variable do_post smallint;
  declare variable is_owner_income smallint;
  declare variable id_account_post_pms integer;
  declare variable use_shadow_account integer;
  declare variable id_hotel integer;
  declare variable is_account$pms integer;
  declare variable round_to numeric(15,4);
begin

  do_post = 0;
  posted_value = null;
  posted_currency = null;
  is_owner_income = 1;
  use_shadow_account = iif(:SUB_CONTRACT = 'SHADOW_ACC', 1, 0);

  select c.ROUND_TO
  from   CURRS c
  where  c.CURR = :curr_orig
  into   :round_to;

  /*select P.ID_ACCOUNT
  from   ACCOUNT$PMS P
  where  P.ID_OWNER = coalesce(:ID_RENTAL_POOL,:ID_OWNER)
         and P.IS_SHADOW = :use_shadow_account
         and P.IS_CLIENT_POOL_ACCOUNT = 0
  into   :id_account;*/
  select r.ID_HOTEL
  from   PMS_EVENT$PMS p
         join ROOMS R on R.ID_ROOM = p.ID_ROOM
  where  p.ID_PMS_EVENT = :ID_PMS_EVENT
  into   :id_hotel;

  execute procedure OWNER_ACCOUNT_GET$INT (coalesce(:ID_RENTAL_POOL,:ID_OWNER),
          :id_hotel, :use_shadow_account, 0)
  returning_values (:id_account, :is_account$pms);

  for
    select C.NIGHT_PRICE, C.NIGHT_PRICE_CURR, C.ID_SERVICE
    from   CONTRACT_MANAGEMENT$PMS C
    where  C.ID_CONTRACT = :id_contract
           and c.SUB_CONTRACT = :SUB_CONTRACT
    into   :night_price, :night_price_curr, :ID_SERVICE
  do begin
    if (:CONTRACT_TYPE = 'PRIVATE_USE' and :use_shadow_account = 0) then begin
      do_post = 0;
    end
    if (:CONTRACT_TYPE = 'TO_PRICE' and :use_shadow_account = 0) then begin
      my_value = :VALUE_ORIG;
      my_currency = :CURR_ORIG;
      do_post = 1;
    end
    if (:CONTRACT_TYPE = 'FIXED_PRICE' and :use_shadow_account = 0) then begin
      my_value = :night_price * :stay;
      my_currency = :night_price_curr;
      do_post = 1;
    end
    if (:CONTRACT_TYPE = 'GUARANTEE_INCOME_FIXED_PRICE' and :use_shadow_account = 1) then begin
      my_value = :night_price * :stay;
      my_currency = :night_price_curr;
      do_post = 1;
    end
    if (:CONTRACT_TYPE = 'GUARANTEE_INCOME_TO_PRICE' and :use_shadow_account = 1) then begin
      my_value = :VALUE_ORIG;
      my_currency = :CURR_ORIG;
      do_post = 1;
    end
    if (:CONTRACT_TYPE = 'TO_PRICE_FIXED_PRICE') then begin
      if (:use_shadow_account = 0) then begin
        my_value = :VALUE_ORIG;
        my_currency = :CURR_ORIG;
      end else if (:USE_SHADOW_ACCOUNT = 1) then begin
        my_value = :night_price * :stay;
        my_currency = :night_price_curr;
      end
      do_post = 1;
    end
    if (:CONTRACT_TYPE = 'FIXED_PRICE_TO_PRICE') then begin
      if (:use_shadow_account = 0) then begin
        my_value = :night_price * :stay;
        my_currency = :night_price_curr;
      end else if (:USE_SHADOW_ACCOUNT = 1) then begin
        my_value = :VALUE_ORIG;
        my_currency = :CURR_ORIG;
      end
      do_post = 1;
    end
  
    if (:do_post = 1 and :id_service is not null) then begin
      my_value = round_f(cast(:my_value as double precision) * :ownership_percent / 100, :round_to);
      execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account,
              :id_owner, :my_currency, :my_value, :id_service, :is_owner_income, :post_date)
      returning_values  (:id_account_post_pms);
      posted_value = :my_value;
      posted_currency = :my_currency;
    end
  end
end
^

/* Alter (CONTRAGENT_MODIFY$CONTR) */
ALTER PROCEDURE CONTRAGENT_MODIFY$CONTR(ID_CONTRAGENT INTEGER,
CONTRAGENT_NAME VARCHAR(100),
IS_JURIDICAL_PERSON SMALLINT,
IDENT_NO VARCHAR(30),
VAT_REG_NUM VARCHAR(30),
POST_ADDRESS VARCHAR(100),
ZIP_CODE VARCHAR(10),
EMAIL VARCHAR(50),
MOL VARCHAR(100),
COUNTRY_CODE VARCHAR(10),
BANK_NAME VARCHAR(50),
BIC VARCHAR(30),
IBAN VARCHAR(30))
 RETURNS(NEW_ID_CONTRAGENT INTEGER)
 AS
declare variable id_profile integer;
begin

  if (:ID_CONTRAGENT is null) then begin
    insert into CONTRAGENTS (CONTRAGENT_NAME, IS_JURIDICAL_PERSON,
           IDENT_NO, VAT_REG_NUM, POST_ADDRESS, ZIP_CODE,
           MOL, BANK_NAME, BIC, IBAN, COUNTRY, EMAIL)
    values (:CONTRAGENT_NAME, :IS_JURIDICAL_PERSON,
           :IDENT_NO, :VAT_REG_NUM, :POST_ADDRESS, :ZIP_CODE,
           :MOL, :BANK_NAME, :BIC, :IBAN, :COUNTRY_CODE, :EMAIL)
    returning ID_CONTRAGENT into :NEW_ID_CONTRAGENT;
  end else begin
    update CONTRAGENTS C
    set    C.CONTRAGENT_NAME = :CONTRAGENT_NAME,
           C.IS_JURIDICAL_PERSON = :IS_JURIDICAL_PERSON,
           C.IDENT_NO = :IDENT_NO,
           C.VAT_REG_NUM = :VAT_REG_NUM,
           C.POST_ADDRESS = :POST_ADDRESS,
           C.ZIP_CODE = :ZIP_CODE,
           C.MOL = :MOL,
           C.COUNTRY = :COUNTRY_CODE,
           C.BANK_NAME = :BANK_NAME,
           C.BIC = :BIC,
           C.IBAN = :IBAN,
           C.EMAIL = :EMAIL
    where  C.ID_CONTRAGENT = :ID_CONTRAGENT;
    NEW_ID_CONTRAGENT = :ID_CONTRAGENT;
  end

  for
    select p.ID_PROFILE
    from   PROFILE p
    where  p.ID_DEF_CONTRAGENT = :ID_CONTRAGENT
           and p.PROFILE_TYPE = 'AGENT'
    into   :id_profile
  do begin
    update PROFILE p
    set    p.MERGE_IDENT_NUM = (select trim(ss.UNICODE_STRING) from SYSTEM_STRING_TO_UNICODE(:IDENT_NO) ss),
           p.MERGE_IDENT_NUM_ALT = (select trim(ss.UNICODE_STRING) from SYSTEM_STRING_TO_UNICODE(:VAT_REG_NUM) ss)
    where  p.ID_PROFILE = :id_profile;
  end
end
^

/* empty dependent procedure body */
/* Clear: CREATE_SESSION_BOOKINGS$WBE for: CREATE_BOOKING$WBE */
ALTER PROCEDURE CREATE_SESSION_BOOKINGS$WBE(WBE_SESSION_ID BIGINT,
ARANGER_ID INTEGER,
LANG_CODE VARCHAR(3))
 RETURNS(SELECTION_ID VARCHAR(20),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE IMPORT_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(250),
MAINTANCE_SHEMA VARCHAR(30),
POSTING_ROUTING VARCHAR(20),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
COMPLIMENTARY_ACCOUNT VARCHAR(50),
EATING_OBJECT VARCHAR(50),
CREATE_DATETIME TIMESTAMP,
CHECK_OUT_KIND SMALLINT,
EARLYCHECKOUT_DATE DATE)
 RETURNS(HOTEL_ID INTEGER,
BOOKING_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable current_hotel_id integer;
declare variable booking_update_id integer;
declare variable warn_code integer;
declare variable share_transaction_id integer;
declare variable share_err_code integer;
declare variable arranger_profile_id integer;
declare variable main_guest_profile_id integer;
declare variable rate_id integer;
declare variable room_type_id integer;
declare variable board_id integer;
declare variable maintance_shema_id integer;
declare variable arranger_payment_type_id integer;
declare variable guest_payment_type_id integer;
declare variable marketing_segment_id integer;
declare variable marketing_source_code_id integer;
declare variable marketing_channel_code_id integer;
declare variable marketing_hear_reason_id integer;
declare variable marketing_come_reason_id integer;
declare variable arranger_account_id integer;
declare variable packet_id integer;
declare variable id_guarantee_policy integer;
declare variable first_food_code tfood_code;
declare variable arrival_type_code smallint;
declare variable booking_dbkey char(8);
declare variable reserv_group_id integer;
declare variable id_complimentary_account integer;
declare variable id_eating_object integer;
begin
  /*execute procedure sys_dbg('exc IMPORT_BOOKING$EXC('
  || 'hotel => ' || coalesce(:hotel, '<null>')
  || ', booking_number => ' || coalesce(:number, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  ||')');
  */
  execute procedure import_mark_transaction$exc;

  /* init */
  err_code = 0;
  err_text = '';
  booking_update_id = null;
  booking_dbkey = null;
  current_hotel_id = null;
  if (:voucher_date is not null) then begin
    voucher_date = striptime(:voucher_date);
  end
  posting_routing = upper(:posting_routing);

  /* detect inser/update mode */
  select b.id_reserv_detail, b.rdb$db_key, b.id_hotel
  from   reserv_detail b
  where  b.number=:number
         and b.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and b.id_log_event_annul is null
  into   :booking_update_id, :booking_dbkey, :current_hotel_id;

  if (:booking_update_id is null) then begin
    booking_id = gen_id (id_reserv_detail_gen, 1);
  end else begin
    booking_id = :booking_update_id;
  end

  /* text to id map */
  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => MAP_BOOKING_RELATIONS$EXC');
  execute procedure MAP_BOOKING_RELATIONS$EXC(
    :booking_id,
    :hotel,
    :room_type,
    :board,
    :maintance_shema,
    :rate,
    :arranger_payment_type,
    :guest_payment_type,
    :marketing_segment,
    :marketing_source_code,
    :marketing_channel_code,
    :marketing_hear_reason,
    :marketing_come_reason,
    :first_food,
    :arranger_profile_uuid,
    :arranger_profile_name,
    :main_guest_profile_uuid,
    :arrival_type,
    :guarantee_policy,
    :eating_object
  ) returning_values
    :arranger_profile_id,
    :main_guest_profile_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :hotel_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :first_food_code,
    :arrival_type_code,
    :id_guarantee_policy,
    :id_eating_object;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* hotel change test */
  if (coalesce(:current_hotel_id, :hotel_id) <> :hotel_id) then begin
    execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', null, :hotel, 'booking hotel changed');
  end

  id_complimentary_account = null;
  if (complimentary_account is not null) then begin
    execute procedure lookup_account$exc(:hotel_id, :complimentary_account, 'booking', :booking_id)
    returning_values :id_complimentary_account;
  end

  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => CREATE_PACK_INSTANCE$EXC');
  packet_id = null;
  /*execute procedure CREATE_PACK_INSTANCE$EXC(
    :hotel_id, :booking_id, :package
  )
  returning_values :packet_id, :err_code, :err_text;
  if (0 <> :err_code) then exit;
  */
  /* merge input and default/persistent database values */
  execute procedure DEFAULT_BOOKING_VALUES$EXC(
    :booking_dbkey, :hotel_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :group_name,
    :group_uuid,
    :is_late_departure,
    :id_eating_object
  ) returning_values
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :arranger_account_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :reserv_group_id,
    :is_late_departure,
    :id_eating_object;

  if ('' = :board) then board_id = null; /* preserve "empty board" state and discard default value */

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC DEFAULTED => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* if the booking is complimentary use complimentary account */
  arranger_account_id = coalesce(:id_complimentary_account, :arranger_account_id);

  /* CREATE or UPDATE */
  if (:booking_update_id is not null) then begin
    /* UPDATE booking */
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => UPDATE_BOOKING$EXC');
    execute procedure UPDATE_BOOKING$EXC(
      :booking_id,
      :reserv_group_id,
      :is_vip,
      :arrival,
      :arrival_type_code,
      :departure,
      :is_late_departure,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :room_type_id,
      :board_id,
      :room_preferences,
      :special_treatment,
      :maintance_shema_id,
      :posting_routing,
      :arranger_account_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :deposit_required,
      :deposit_required_currency,
      :arranger_payment_type_id,
      :guest_payment_type_id,
      :voucher,
      :voucher_date,
      :voucher_text,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :note,
      :note_reminders,
      :first_food_code,
      :arranger_profile_id,
      :main_guest_profile_id,
      :is_different_rate,
      :is_different_price,
      :split_on_checkin,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object
    ) returning_values :err_code, :err_text;
    if (0 <> :err_code) then begin
      exit;
    end
  end else begin
    /* CREATE booking */
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => RES_CREATE_SET$EXC');
    execute procedure RES_CREATE_SET$EXC (
      :booking_id,
      :number,
      :arranger_profile_id,
      :main_guest_profile_id,
      :arrival,
      :departure,
      :adult_count,
      :children_count,
      :room_type_id,
      null,
      :board_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :voucher,
      :voucher_date,
      :voucher_text,
      null,
      null,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :arrival_type_code,
      :is_late_departure,
      :is_vip,
      :first_food_code,
      :special_treatment,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :arranger_account_id,
      :posting_routing,
      :guest_payment_type_id,
      :arranger_payment_type_id,
      null,
      :room_preferences,
      :maintance_shema_id,
      :note,
      :note_reminders,
      :deposit_required,
      :deposit_required_currency,
      :hotel_id,
      :reserv_group_id,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object,
      :create_datetime
      )
    returning_values :err_code, :err_text, :warn_code, :booking_id, :share_transaction_id, :share_err_code;
  end

  update reserv_detail rd
  set    rd.CHECK_OUT_KIND = :CHECK_OUT_KIND,
         rd.EARLYCHECKOUT_DATE = :EARLYCHECKOUT_DATE
  where  rd.ID_RESERV_DETAIL = :BOOKING_ID;

  execute procedure GUEST_STAY_INITIALIZE$INT (:booking_id);
  /* final error check */
  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;

  delete from PENDING_DEPOSIT d
  where  d.ID_RESERV_DETAIL = :BOOKING_ID;
end
^

/* Alter (CREATE_BOOKING$WBE) */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
declare variable rate varchar(50);
declare variable room_type varchar(20);
declare variable arrival date;
declare variable departure date;
declare variable adults integer;
declare variable children integer;
declare variable profile_name varchar(100);
declare variable aranger_name varchar(100);
declare variable guest_profile_uuid varchar(40);
declare variable aranger_profile_uuid varchar(40);
declare variable hotel_name varchar(50);
declare variable wbe_session_id bigint;
declare variable main_guest_profile_id integer;
declare variable board varchar(50);
declare variable hotel_id integer;
declare variable guarantee_policy_name varchar(50);
declare variable guarantee_deposit_percent numeric(15,4);
declare variable guarantee_deposit_nights integer;
declare variable guarantee_due_days_bef_arrival integer;
declare variable guarantee_due_days_after_create integer;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable profile_type varchar(20);
declare variable profile_import_time timestamp;
declare variable b_count integer;
declare variable age integer;
declare variable is_child smallint;
declare variable guest_id integer;
declare variable special_treatment varchar(250);
declare variable maintenance varchar(30);
declare variable routing varchar(20);
declare variable arranger_paymeny_type varchar(20);
declare variable market_segment varchar(30);
declare variable market_source varchar(30);
declare variable market_channel varchar(30);
declare variable market_hear_reason varchar(30);
declare variable market_come_reason varchar(30);
declare variable first_food varchar(30);
declare variable bnote varchar(2000);
begin
  -- get wbe product selection
  select  PA.rate_name,PA.room_name, AQ.first_date, AQ.first_date+AQ.day_count,
          PS.adults, PS.children, PS.person_name, H.hotel_name, H.id_hotel,
          WS.id, PA.board_name, GP.name, GP.deposit_totalsum_part, GP.deposit_nights_count, GP.due_days_before_arrival, GP.due_days_after_create,
          PS.bnote
   from   PRODUCT_SELECTION$WBE PS
          join WBE_SESSION$WBE WS on WS.id = PS.wbe_session_id
          join PRODUCT_AVAILABILITY$WBE PA on pa.id = PS.product_availability_id
          join AVAILABILITY_QUERY$WBE AQ on aq.id = WS.product_query_id
          join HOTEL H on H.id_hotel = WS.hotel_id
          join GUARANTEE_POLICY GP on GP.id_guarantee_policy = PS.guarantee_policy_id
   where  PS.id = :product_selection_id
   into   :rate, :room_type, :arrival, :departure,
          :adults,  :children, :profile_name, :hotel_name, :hotel_id,
          :wbe_session_id, :board, :guarantee_policy_name,
          :guarantee_deposit_percent, :guarantee_deposit_nights,
          :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create,
          :bnote;

  select PA.uuid , PA.profile_name, PA.profile_type
  from   PROFILE PA
  where  PA.id_profile = :aranger_profile_id
  into   :aranger_profile_uuid,:aranger_name,  :profile_type;

  if (:aranger_name = :profile_name and :profile_type = 'PERSON') then begin
    -- aranger is main guest
    select count(*)
    from   PRODUCT_SELECTION$WBE PSC
    where  PSC.wbe_session_id = :wbe_session_id
    into   :b_count;
       -- only if single reservation bugfix 2228
    if (1 = :b_count) then begin
     guest_profile_uuid =  aranger_profile_uuid;
     aranger_profile_uuid = null;
    end
  end else begin
    -- create profile for main guest
    execute procedure IMPORT_PERSON_PROFILE$EXC(
      uuid_create(),:profile_name,null,null,null,null,null,null,null,null,null,null, null,
      null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
      null,null,null,null,null, null, null)
    returning_values :main_guest_profile_id, :profile_import_time;

    select P.uuid
    from   PROFILE P
    where  P.id_profile = :main_guest_profile_id
    into   :guest_profile_uuid;
  end

    -- apply default map + forced arranger
    special_treatment = null;
    maintenance = null;
    routing = null;
    arranger_paymeny_type = null;
    market_segment = null;
    market_source = null;
    market_channel = null;
    market_hear_reason = null;
    market_come_reason = null;


  select hc.special_treatment, hk.plan_name, hc.routing,
         pt.payment_type, ms.segment_name, sc.description, cc.description,
         hr.description, cr.description, hc.first_food
  from   HOTEL_PRODUCT_CFG$WBE hc
         left join HK_PLAN hk on hk.id_plan = hc.id_hk_plan
         left join PAYMENT_TYPE pt on pt.id_payment_type = hc.arranger_id_payment_type
         left join NOM_MARKET_SEGMENTS ms on ms.id_nom_market_segment = hc.id_m_segment
         left join NOM_SOURCE_CODES sc on sc.id_nom_source_code = hc.id_m_source
         left join NOM_CHANNEL_CODES cc on cc.id_nom_channel_code = hc.id_m_channel
         left join NOM_HEAR_REASONS hr on hr.id_nom_hear_reason = hc.id_m_hear_reason
         left join NOM_COME_REASONS cr on cr.id_nom_come_reason = hc.id_m_come_reason
  where  hc.hotel_id = :hotel_id
  into   :special_treatment,:maintenance,:routing,:arranger_paymeny_type,
         :market_segment,:market_source,:market_channel,:market_hear_reason,:market_come_reason,:first_food;
  -- create reseravation
  execute procedure IMPORT_BOOKING$EXC(
     :hotel_name, :number, null, null, 0,
     :arrival, null, :departure, null, null, null, null, null, :room_type, :board, null,
     :special_treatment, :maintenance, :routing, :rate, null, null, null, null, :arranger_paymeny_type, null, null, null, null,
     :market_segment, :market_source,:market_channel, :market_hear_reason, :market_come_reason,
     :bnote, null, :first_food, :adults, :children, :aranger_profile_uuid, null, :guest_profile_uuid,
     0, 0, null, :guarantee_policy_name, null, :guarantee_deposit_percent, :guarantee_deposit_nights,
     :guarantee_due_days_bef_arrival,  :guarantee_due_days_after_create, null, null, null, null,  null, null, null, null, null, null, null, null)
  returning_values
     :hotel_id, :booking_id, :err_code, err_text;
  if (0 <> :err_code) then exception WRONG_VALUE ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');

  -- import guests
  for
    select psg.guest_name, psg.is_child, psg.age
    from   PRODUCT_SELECTION_GUESTS$WBE psg
    where  psg.product_selection_id = :product_selection_id
    into   :profile_name,:is_child,:age
  do begin
    execute procedure IMPORT_GUEST$EXC(:booking_id, null, null, :profile_name, :is_child, :age, null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null)
    returning_values :guest_id, :err_code,:err_text;
    if (0 <> :err_code) then exception WRONG_VALUE ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');
  end
  ----------------

  select RD.number_2
  from   RESERV_DETAIL RD
  where  RD.id_reserv_detail = :booking_id
  into   :number_2;

  update PRODUCT_SELECTION$WBE uPS
  set    uPS.booking_id = :booking_id, uPS.selection_id = :number_2
  where  uPS.id = :product_selection_id;
end
^

/* Alter (CREATE_SESSION_BOOKINGS$WBE) */
ALTER PROCEDURE CREATE_SESSION_BOOKINGS$WBE(WBE_SESSION_ID BIGINT,
ARANGER_ID INTEGER,
LANG_CODE VARCHAR(3))
 RETURNS(SELECTION_ID VARCHAR(20),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable product_selection_id bigint;
declare variable next_num integer;
declare variable sel_cnt integer;
declare variable aranger_name varchar(100);
declare variable aranger_email varchar(50);
declare variable aranger_phone varchar(50);
declare variable booking_id integer;
declare variable record_timestamp timestamp;
declare variable new_res_number varchar(62);
declare variable room_types_src varchar(255) = '';
declare variable rates_src varchar(255) = '';
declare variable hotel_id integer;
declare variable profile_id integer;
declare variable from_date date;
declare variable to_date date;
declare variable day_count integer;
declare variable room_type_id integer;
declare variable rate_id integer;
declare variable query_id_tmp integer;
declare variable rooms_required integer;
declare variable rooms_available integer;
declare variable profile_import_time timestamp;
begin
  execute procedure EXPORT_LOG_FORCE$EXC(1);
  /* test overbook (multiuser) */
   for select ws.hotel_id,ws.profile,aq.first_date,(aq.first_date+aq.day_count)-1,pa.room_type_id,pa.rate_id,aq.day_count
    from   PRODUCT_availability$WBE PA
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    join availability_query$wbe aq on aq.id = pa.query_id
   where ws.id = :wbe_session_id and coalesce(pa.room_count,0) > 0
   into  :hotel_id, :profile_id, :from_date, :to_date, :room_type_id, :rate_id , :day_count
   do begin
       room_types_src = :room_types_src||','||cast(:room_type_id as varchar(10));
       rates_src = :rates_src||','||cast(rate_id as varchar(10));
   end

   query_id_tmp = GEN_ID(AVAILABILITY_QUERY$WBE_SEQ,1);
   insert into availability_query$wbe(ID, WBE_SESSION_ID, FIRST_DATE, DAY_COUNT)    -- prevent FK exception
    values (:query_id_tmp,:wbe_session_id,:from_date,:day_count) ;

   execute procedure availability_occup_small$wbe(:from_date,:to_date,:hotel_id,:query_id_tmp,1,:rates_src,:room_types_src) ;

   --  check minimum available rooms for every day
   err_code = null;
   err_text = '';
   for select pa.room_type_id,pa.room_count,
    (select coalesce(min(art.available_rooms),0) from availability_room_type$wbe art
      where art.query_id = :query_id_tmp and art.room_type_id = pa.room_type_id)
    from product_availability$wbe pa
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    where ws.id = :wbe_session_id
    and coalesce(pa.room_count,0) > 0   into :room_type_id,:rooms_required,:rooms_available
   do begin
       if (rooms_required > rooms_available) then
       begin
        err_code = 1;
        ERR_TEXT = coalesce(ERR_TEXT,'')||:room_type_id||';';
       end
   end
   delete from availability_query$wbe aqt where aqt.id = :query_id_tmp;       -- remove temp query
   if (err_code is not null) then exit;

  /* create profile if not exist and reservations > 1*/
  if (aranger_id is NULL) then
  begin
    select WS.person_name,WS.address,WS.phone
    from   WBE_SESSION$WBE WS
    where  WS.id = :wbe_session_id
    into   :aranger_name,:aranger_email,:aranger_phone;

    execute procedure IMPORT_PERSON_PROFILE$EXC(
       uuid_create(),:aranger_name,null,null,null,null,null,null,null,null,null,null,
       null,null,null,null,:aranger_phone,null,:aranger_email,null,null,null,null,null,null,
       STRHASH_LARGE(substring(uuid_create() from 1 for 4)),null,null,null,null,null,null,null,null, null, null)
    returning_values :aranger_id, :profile_import_time;

    update WBE_SESSION$WBE uWS
    set    uWS.profile = :aranger_id
    where  uWS.id = :wbe_session_id;
  end else begin
    -- da podmeni email, phone ako !!
  end
  /* create reservations */
  for
    select PS.id
    from   PRODUCT_SELECTION$WBE PS
    where  PS.wbe_session_id = :wbe_session_id
           and PS.booking_id is null
           and coalesce(PS.is_deleted,0) <> 1
    into   :product_selection_id
  do begin
     if (next_num = 1) then begin      -- increment first reservation number_3
      execute procedure res_number_suffix_gen(:booking_id) returning_values :new_res_number;
      next_num = next_num + 1;
     end
     execute procedure CREATE_BOOKING$WBE(:product_selection_id,:aranger_id,'WBE.'||:selection_id||'.'||:next_num) returning_values :booking_id,:selection_id;
     execute procedure IMPORT_BOOKING_FINALIZE$EXC(:booking_id) returning_values  record_timestamp,:err_code,:err_text;
     insert into SCHEDULER$WBE(booking_id,status,last_action_time,lang_code,guarantee_passed) values (:booking_id, NULL, current_timestamp, :lang_code,0);

     if (next_num is NULL) then begin
      next_num = 1;
     end else begin
      next_num = next_num + 1;
     end
  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_INITIALIZE$DOC for: DOC_CONTRAGENT_INITIALIZE$DOC */
ALTER PROCEDURE DOCUMENT_INITIALIZE$DOC(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
DOC_SELECTED /* TYPE OF ID */ INTEGER,
PROFORMA_NAME_PREFIX VARCHAR(30) = null)
 RETURNS(ID_DOC_HEAD INTEGER,
ID_HOTEL INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOC_CONTRAGENT_INITIALIZE$DOC) */
ALTER PROCEDURE DOC_CONTRAGENT_INITIALIZE$DOC(ID_DOC_HEAD INTEGER,
ID_CONTRAGENT INTEGER,
ID_DOC_CONTRAGENT INTEGER = null)
 AS
declare variable id_current_doc_contragent integer;
  declare variable new_id_doc_contragent integer;
  declare variable is_juridical_person integer;
  declare variable contragent_name varchar(100);
  declare variable vat_reg_num varchar(30);
  declare variable ident_no varchar(30);
  declare variable post_address varchar(100);
  declare variable zip_code varchar(10);
  declare variable country_code varchar(10);
  declare variable mol varchar(100);
  declare variable email varchar(50);
begin

  select D.ID_DOC_CONTRAGENT
  from   DOC_HEAD$INT D
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :id_current_doc_contragent;

  if (:ID_CONTRAGENT is not null) then begin
    /* get data from contragents nomenclature */
    select C.IS_JURIDICAL_PERSON, C.CONTRAGENT_NAME, C.VAT_REG_NUM, C.IDENT_NO,
           C.POST_ADDRESS, C.ZIP_CODE, C.COUNTRY, C.MOL, c.EMAIL
    from   CONTRAGENTS C
    where  C.ID_CONTRAGENT = :ID_CONTRAGENT
    into   :is_juridical_person, :contragent_name, :vat_reg_num, :ident_no,
           :post_address, :zip_code, :country_code, :mol, :email;
  end else if (:ID_DOC_CONTRAGENT is not null) then begin
    /* get cleint data from other document - copy */
    select dC.IS_JURIDICAL_PERSON, dC.CONTRAGENT_NAME, dC.VAT_REG_NUM, dC.IDENT_NO,
           dC.POST_ADDRESS, dC.ZIP_CODE, dC.COUNTRY_CODE, dC.MOL, dc.EMAIL, dc.ID_CONTRAGENT
    from   DOC_CONTRAGENT DC
    where  DC.ID_DOC_CONTRAGENT = :ID_DOC_CONTRAGENT
    into   :is_juridical_person, :contragent_name, :vat_reg_num, :ident_no,
           :post_address, :zip_code, :country_code, :mol, :email, :ID_CONTRAGENT;
  end else begin
    exit;
  end

  if (:id_current_doc_contragent is null) then begin
    new_id_doc_contragent = gen_id(GEN_DOC_CONTRAGENT_ID, 1);
    insert into DOC_CONTRAGENT (
           ID_DOC_CONTRAGENT, ID_CONTRAGENT, IS_JURIDICAL_PERSON, CONTRAGENT_NAME,
           VAT_REG_NUM, IDENT_NO, POST_ADDRESS, ZIP_CODE, COUNTRY_CODE, MOL, EMAIL)
    values (:new_id_doc_contragent, :ID_CONTRAGENT, :is_juridical_person, :contragent_name,
           :vat_reg_num, :ident_no, :post_address, :zip_code, :country_code, :mol, :email);

    update DOC_HEAD$INT d
    set    d.ID_DOC_CONTRAGENT = :new_id_doc_contragent
    where  d.ID_DOC_HEAD = :ID_DOC_HEAD;
     
  end else begin
    new_id_doc_contragent = :id_current_doc_contragent;
    update DOC_CONTRAGENT DC
    set    ID_CONTRAGENT = :ID_CONTRAGENT,
           IS_JURIDICAL_PERSON = coalesce(:is_juridical_person, 0),
           CONTRAGENT_NAME = :contragent_name,
           VAT_REG_NUM = :vat_reg_num,
           IDENT_NO = :ident_no,
           POST_ADDRESS = :post_address,
           ZIP_CODE = :zip_code,
           COUNTRY_CODE = :country_code,
           MOL = :mol,
           /*RECIPIENT_NAME = null,
           RECIPIENT_PAS_NUM = null,
           RECIPIENT_PAS_DATE = null,
           RECIPIENT_PAS_FROM = null,
           RECIPIENT_LETTER = null,  */
           NUM_DOGOVOR = null,
           NUM_SPECIF = null,
           EMAIL = :EMAIL
    where  DC.ID_DOC_CONTRAGENT = :id_current_doc_contragent;
  end
end
^

ALTER PROCEDURE PROFILE_GET_CONTRAGENT_DATA$INT(ID_PROFILE INTEGER)
 RETURNS(ID_CONTRAGENT INTEGER,
IS_JURIDICAL_PERSON SMALLINT,
CONTRAGENT_NAME VARCHAR(100),
VAT_REG_NUM VARCHAR(30),
IDENT_NO VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
POST_ADDRESS VARCHAR(100),
ZIP_CODE VARCHAR(10),
EMAIL VARCHAR(50),
MOL VARCHAR(100),
RECIPIENT_NAME VARCHAR(100),
RECIPIENT_PAS_NUM VARCHAR(20),
RECIPIENT_PAS_DATE DATE,
RECIPIENT_PAS_FROM VARCHAR(30),
BANK_NAME VARCHAR(50),
BIC VARCHAR(30),
IBAN VARCHAR(30))
 AS
declare variable profile_type varchar(20);
  declare variable id_doc_contragent_last integer;
begin
  IS_JURIDICAL_PERSON = 0;
  BANK_NAME = null;
  BIC = null;
  IBAN = null;

  select P.PROFILE_TYPE, P.ID_DEF_CONTRAGENT as profile_contragent,
         (select first 1 D.ID_DOC_CONTRAGENT
          from   ACCOUNT A
                 join DOC_HEAD D on D.ID_ACCOUNT = A.ID_ACCOUNT
          where  A.ID_PROFILE = P.ID_PROFILE
          order by D.DOC_DATE desc, D.DATETIME_CREATED desc) as last_doc_contragent
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :profile_type, :id_contragent, :id_doc_contragent_last;

  if (:profile_type = 'HOUSE') then begin
    ID_CONTRAGENT = null;
    EXIT;
  end

  if (:id_contragent is not null) then begin
    select C.ID_CONTRAGENT, C.IS_JURIDICAL_PERSON, C.CONTRAGENT_NAME, C.VAT_REG_NUM, C.IDENT_NO,
           C.COUNTRY, C.POST_ADDRESS, C.ZIP_CODE, C.MOL, c.BANK_NAME, c.BIC, c.IBAN, c.EMAIL
    from   CONTRAGENTS C
    where  C.ID_CONTRAGENT = :ID_CONTRAGENT
    into   :ID_CONTRAGENT, :IS_JURIDICAL_PERSON, :CONTRAGENT_NAME, :VAT_REG_NUM, :IDENT_NO,
           :COUNTRY_CODE, :POST_ADDRESS, :ZIP_CODE, :MOL, :BANK_NAME, :BIC, :IBAN, :EMAIL;

  end else if (:id_doc_contragent_last is not null) then begin
    select DC.ID_CONTRAGENT, DC.IS_JURIDICAL_PERSON, DC.CONTRAGENT_NAME, DC.VAT_REG_NUM, DC.IDENT_NO,
           DC.COUNTRY_CODE, DC.POST_ADDRESS, DC.ZIP_CODE, DC.MOL, DC.RECIPIENT_NAME,
           DC.RECIPIENT_PAS_NUM, DC.RECIPIENT_PAS_DATE, DC.RECIPIENT_PAS_FROM,
           DC.BANK_NAME, DC.BIC, DC.IBAN, dc.EMAIL
    from   DOC_CONTRAGENT DC
    where  DC.ID_DOC_CONTRAGENT = :id_doc_contragent_last
    into   :ID_CONTRAGENT, :IS_JURIDICAL_PERSON, :CONTRAGENT_NAME, :VAT_REG_NUM, :IDENT_NO,
           :COUNTRY_CODE, :POST_ADDRESS, :ZIP_CODE, :MOL, :RECIPIENT_NAME,
           :RECIPIENT_PAS_NUM, :RECIPIENT_PAS_DATE, :RECIPIENT_PAS_FROM,
           :BANK_NAME, :BIC, :IBAN, :EMAIL;

  end else if (:profile_type = 'PERSON') then begin
    select GF.PERSON_NAME, GF.COUNTRY_CODE, GF.EGN, substring(GF.CITY || ' ' || GF.ADDRESS from 1 for 100),
           GF.PERSON_NAME, GF.PASS_NUM, GF.PASS_DATE, GF.PASS_PLACE, P.EMAIL
    from   PROFILE_PERSON PP
           join PERSON_DATA GF on GF.ID_PERSON_DATA = PP.ID_PERSON_DATA
           join PROFILE P on P.ID_PROFILE = PP.ID_PROFILE
    where  PP.ID_PROFILE = :ID_PROFILE
    into   :CONTRAGENT_NAME, :COUNTRY_CODE, :IDENT_NO, :POST_ADDRESS,
           :RECIPIENT_NAME, :RECIPIENT_PAS_NUM, :RECIPIENT_PAS_DATE, :RECIPIENT_PAS_FROM, :EMAIL;
     
  end else if (:profile_type = 'AGENT') then begin
    select P.PROFILE_NAME, '', '',
           null, null, null, null, P.EMAIL
    from   PROFILE_AGENT PA
           join PROFILE P on P.ID_PROFILE = PA.ID_PROFILE
    where  PA.ID_PROFILE = :ID_PROFILE
    into   :CONTRAGENT_NAME, :COUNTRY_CODE, :POST_ADDRESS,
           :RECIPIENT_NAME, :RECIPIENT_PAS_NUM, :RECIPIENT_PAS_DATE, :RECIPIENT_PAS_FROM, :EMAIL;
  end

   
end
^

ALTER PROCEDURE DOC_CONTRAGENT_SET$DOC(ID_DOC INTEGER,
IS_PAY_DOC SMALLINT,
ID_CONTRAGENT INTEGER,
IS_JURIDICAL_PERSON SMALLINT,
CONTRAGENT_NAME VARCHAR(100),
VAT_REG_NUM VARCHAR(30),
IDENT_NO VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
POST_ADDRESS VARCHAR(100),
ZIP_CODE VARCHAR(10),
EMAIL VARCHAR(50),
MOL VARCHAR(100),
RECIPIENT_NAME VARCHAR(100),
RECIPIENT_PAS_NUM VARCHAR(20),
RECIPIENT_PAS_DATE DATE,
RECIPIENT_PAS_FROM VARCHAR(30),
RECIPIENT_LETTER VARCHAR(30),
NUM_DOGOVOR VARCHAR(30),
NUM_SPECIF VARCHAR(30),
ADD_PERMANENTLY SMALLINT,
BANK_NAME VARCHAR(50),
BIC VARCHAR(30),
IBAN VARCHAR(30))
 RETURNS(ID_DOC_CONTRAGENT INTEGER)
 AS
declare variable doc_num varchar(20);
begin

  if (:IS_PAY_DOC = 1) then begin
    select P.ID_DOC_CONTRAGENT, P.PAYMENT_NUM
    from   PAYMENT_HEAD P
    where  p.ID_PAYMENT_HEAD = :ID_DOC
    into   :id_doc_contragent, :doc_num;
  end else begin
    select D.ID_DOC_CONTRAGENT, D.DOC_NUM
    from   DOC_HEAD$INT D
    where  D.ID_DOC_HEAD = :ID_DOC
    into   :id_doc_contragent, :doc_num;
  end

  if (trim(:doc_num) <> '') then
    exception DOCUMENT_EXCEPTION '-354'; --'Cannot edit valid document!';
   
  if (:IS_JURIDICAL_PERSON = 1 and ((:ID_CONTRAGENT is null) or (:ADD_PERMANENTLY = 1)) ) then begin
    execute procedure CONTRAGENT_MODIFY$CONTR (:ID_CONTRAGENT, :CONTRAGENT_NAME,
            :IS_JURIDICAL_PERSON, :IDENT_NO, :VAT_REG_NUM, :POST_ADDRESS, :ZIP_CODE, :EMAIL,
            :MOL, :COUNTRY_CODE, :BANK_NAME, :BIC, :IBAN)
    returning_values (:ID_CONTRAGENT);
  end

  if (:id_doc_contragent is null) then begin
    id_doc_contragent = gen_id(GEN_DOC_CONTRAGENT_ID, 1);
    insert into DOC_CONTRAGENT (
         ID_DOC_CONTRAGENT, ID_CONTRAGENT, IS_JURIDICAL_PERSON, CONTRAGENT_NAME,
         VAT_REG_NUM, IDENT_NO, POST_ADDRESS, ZIP_CODE, COUNTRY_CODE,
         MOL, RECIPIENT_NAME, RECIPIENT_PAS_NUM, RECIPIENT_PAS_DATE, RECIPIENT_PAS_FROM,
         RECIPIENT_LETTER, NUM_DOGOVOR, NUM_SPECIF, BANK_NAME, BIC, IBAN, EMAIL)
    values (:ID_DOC_CONTRAGENT, :ID_CONTRAGENT, :IS_JURIDICAL_PERSON, :CONTRAGENT_NAME,
         :VAT_REG_NUM, :IDENT_NO, :POST_ADDRESS, :ZIP_CODE, :COUNTRY_CODE,
         :MOL, :RECIPIENT_NAME, :RECIPIENT_PAS_NUM, :RECIPIENT_PAS_DATE, :RECIPIENT_PAS_FROM,
         :RECIPIENT_LETTER, :NUM_DOGOVOR, :NUM_SPECIF, :BANK_NAME, :BIC, :IBAN, :EMAIL);

    if (:IS_PAY_DOC = 1) then begin
      update PAYMENT_HEAD P
      set    P.ID_DOC_CONTRAGENT = :id_doc_contragent
      where  P.ID_PAYMENT_HEAD = :ID_DOC;
    end else begin
      update DOC_HEAD$INT D
      set    D.ID_DOC_CONTRAGENT = :id_doc_contragent
      where  D.ID_DOC_HEAD = :ID_DOC;
    end

  end else begin
    update DOC_CONTRAGENT DC
    set    DC.ID_CONTRAGENT = :ID_CONTRAGENT,
           DC.IS_JURIDICAL_PERSON = :IS_JURIDICAL_PERSON,
           DC.CONTRAGENT_NAME = :CONTRAGENT_NAME,
           DC.VAT_REG_NUM = :VAT_REG_NUM,
           DC.IDENT_NO = :IDENT_NO,
           DC.POST_ADDRESS = :POST_ADDRESS,
           DC.ZIP_CODE = :ZIP_CODE,
           DC.COUNTRY_CODE = :COUNTRY_CODE,
           dc.EMAIL = :EMAIL,
           DC.MOL = :MOL,
           DC.RECIPIENT_NAME = :RECIPIENT_NAME,
           DC.RECIPIENT_PAS_NUM = :RECIPIENT_PAS_NUM,
           DC.RECIPIENT_PAS_DATE = :RECIPIENT_PAS_DATE,
           DC.RECIPIENT_PAS_FROM = :RECIPIENT_PAS_FROM,
           DC.RECIPIENT_LETTER = :RECIPIENT_LETTER,
           DC.NUM_DOGOVOR = :NUM_DOGOVOR,
           DC.NUM_SPECIF = :NUM_SPECIF,
           DC.BANK_NAME = :BANK_NAME,
           DC.BIC = :BIC,
           DC.IBAN = :IBAN
    where  DC.ID_DOC_CONTRAGENT = :ID_DOC_CONTRAGENT;
  end
end
^

/* Alter (DOC_CONTRAGENT_INITIALIZE$INT) */
ALTER PROCEDURE DOC_CONTRAGENT_INITIALIZE$INT(ID_DOC INTEGER,
IS_PAY_DOC SMALLINT,
ID_PROFILE INTEGER)
 AS
declare variable is_juridical_person integer;
  declare variable contragent_name varchar(100);
  declare variable vat_reg_num varchar(30);
  declare variable ident_no varchar(30);
  declare variable post_address varchar(100);
  declare variable zip_code varchar(10);
  declare variable country_code varchar(20);
  declare variable mol varchar(100);
  declare variable id_contragent integer;
  declare variable recipient_name varchar(100);
  declare variable recipient_pas_num varchar(20);
  declare variable recipient_pas_date date;
  declare variable recipient_pas_from varchar(30);
  declare variable bank_name varchar(50);
  declare variable bic varchar(30);
  declare variable iban varchar(30);
  declare variable id_doc_contragent integer;
  declare variable email varchar(50);
begin

  execute procedure PROFILE_GET_CONTRAGENT_DATA$INT (:id_profile)
  returning_values (:id_contragent, :is_juridical_person, :contragent_name,
                    :vat_reg_num, :ident_no, :country_code, :post_address, :zip_code, :email,
                    :mol, :recipient_name, :recipient_pas_num, :recipient_pas_date, :recipient_pas_from,
                    :bank_name, :bic, :iban);

  if (:id_contragent is null and trim(coalesce(:contragent_name, '')) = '') then exit; /* not valid contragent */

  execute procedure DOC_CONTRAGENT_SET$DOC (:ID_DOC, :IS_PAY_DOC, :id_contragent,
          coalesce(:is_juridical_person, 0), :contragent_name, :vat_reg_num, :ident_no,
          :country_code, :post_address, :zip_code, :email, :mol, :recipient_name,
          :recipient_pas_num, :recipient_pas_date, :recipient_pas_from, null, null, null,
          0, :bank_name, :bic, :iban)
  returning_values :id_doc_contragent;

end
^

/* Alter (DOC_LINES_SUSPEND_INVOICE) */
ALTER PROCEDURE DOC_LINES_SUSPEND_INVOICE(ID_DOC_HEAD INTEGER,
CORRECTION_INDEX INTEGER,
RPT_TYPE VARCHAR(20),
RPT_CURR VARCHAR(10),
RPT_VAT VARCHAR(20),
IN_VAUCHER_NUM VARCHAR(20))
 RETURNS(TAX_STATUS INTEGER,
ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
VAUCHER_NUM VARCHAR(20),
GUEST_NAME VARCHAR(100),
IS_CHILD INTEGER,
AGES_NAME VARCHAR(50),
GFROM_DATE DATE,
GTO_DATE DATE,
PACKET_NAME VARCHAR(50),
LINE_NAME VARCHAR(100),
ID_SERVICE INTEGER,
DATE_POST DATE,
QTY_POST NUMERIC(15,2),
SINGLE_PRICE NUMERIC(15,4),
LINE_VALUE NUMERIC(15,4),
PACKET_PRICE NUMERIC(15,4),
PACKET_PRICE_WOT_DIFF DOUBLE PRECISION,
ID_TARIFA INTEGER,
BIRTH_DATE DATE,
NIGHTS INTEGER,
IS_BASE INTEGER)
 AS
declare variable DOC_VAT_STATUS integer;
  declare variable DL_DBKEY char(8);
  declare variable NO_USE varchar(255);
  declare variable VAUCHER_PACKET varchar(20);
begin
  /*  Description:
  ||  RPT_TYPE - PACKETS, OTHER, TAX_STATUS, TAXES
  */
  select DT.IS_VAT
  from   DOC_HEAD$INT DH
         join DOC_TYPE DT on DT.ID_DOC_TYPE = DH.ID_DOC_TYPE
  where  DH.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :DOC_VAT_STATUS;

  if (:RPT_TYPE = 'PACKETS') then begin
    for
      select DL.RDB$DB_KEY, DL.TAX_STATUS, DL.ID_GUEST, DL.DATE_POST, G.ID_TARIFA, coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET), PV.IS_BASE,
             GC.GUEST_NAME1, G.IS_CHILD, AG.AGES_NAME, G.FROM_DATE, G.TO_DATE, G.ID_RESERV_DETAIL,
             case when coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'SECONDARY' then G.VAUCHER_NUM2 else G.VAUCHER_NUM end,
             GC.BIRTH_DAY, S.ID_SERVICE
      from   DOC_LINE DL
             join SERVICES S on S.ID_SERVICE = DL.ID_SERVICE
             left outer join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE
             left outer join GUEST G on G.ID_GUEST = DL.ID_GUEST
             left outer join AGENT_PACKET APA on APA.ID_AGENT = G.ID_AGENT and APA.ID_SERVICE = DL.ID_SERVICE
             left outer join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
             left outer join AGENT_AGES AG on AG.ID_AGENT_AGES = G.ID_AGENT_AGES
             left outer join AGENT_TYPE_STAY ATS on ATS.ID_AGENT = G.ID_AGENT and ATS.ID_SERVICE = case when coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'BASE' then PV.ID_PACK_SERVICE else DL.ID_SERVICE end
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
             and ((PV.IS_BASE = 1) or (coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) in ('SECONDARY', 'PARALLEL')))
             and ((:IN_VAUCHER_NUM = '') or (case when coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'SECONDARY' then G.VAUCHER_NUM2 else G.VAUCHER_NUM end = :IN_VAUCHER_NUM))
      into   :DL_DBKEY, :TAX_STATUS, :ID_GUEST, :DATE_POST, :ID_TARIFA, :VAUCHER_PACKET, :IS_BASE,
             :GUEST_NAME, :IS_CHILD, :AGES_NAME, :GFROM_DATE, :GTO_DATE, :ID_RESERV_DETAIL,
             :VAUCHER_NUM, :BIRTH_DATE, :ID_SERVICE
    do begin
      if (:IS_BASE = 0) then begin
        execute procedure DOC_LINES_SUSPEND_LINE(:DL_DBKEY, :RPT_CURR, :RPT_VAT, 'NONE', :DOC_VAT_STATUS, :CORRECTION_INDEX)
        returning_values :NO_USE, :PACKET_NAME, :PACKET_PRICE, :PACKET_PRICE_WOT_DIFF, :SINGLE_PRICE, :LINE_VALUE,
                         :NO_USE, :NO_USE, :QTY_POST, :QTY_POST, :NO_USE, :NO_USE, :NO_USE;

        PACKET_PRICE = :LINE_VALUE;
        NIGHTS = 0;
      end else begin
        execute procedure DOC_LINES_SUSPEND_LINE(:DL_DBKEY, :RPT_CURR, :RPT_VAT, 'IN_PACKET', :DOC_VAT_STATUS, :CORRECTION_INDEX)
        returning_values :ID_SERVICE, :PACKET_NAME, :PACKET_PRICE, :PACKET_PRICE_WOT_DIFF, :NO_USE, :NO_USE,
                         :NO_USE, :NO_USE, :QTY_POST, :QTY_POST, :NO_USE, :NO_USE, :NO_USE;                                      

        NIGHTS = 1;
      end
      suspend;
    end
  end if (:RPT_TYPE = 'OTHER') then begin
    for
      select DL.RDB$DB_KEY, DL.LINE_NAME, G.ID_GUEST, G.ID_RESERV_DETAIL, DL.ID_SERVICE
      from   DOC_LINE DL
             join SERVICES S on S.ID_SERVICE = DL.ID_SERVICE
             left outer join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE
             left outer join GUEST G on G.ID_GUEST = DL.ID_GUEST
             left outer join AGENT_PACKET APA on APA.ID_AGENT = G.ID_AGENT and APA.ID_SERVICE = DL.ID_SERVICE
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
             and DL.TAX_STATUS in (0, 1)
             and coalesce(PV.IS_BASE, 0) = 0
             and ((coalesce(PV.ID_MASTER_ADDINS, -1) = -1)
                  or (coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'OTHER')
                  or ((coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) not in ('SECONDARY', 'PARALLEL'))
                       and not exists (select DML.ID_DOC_LINE
                                  from   DOC_LINE DML
                                         join DOC_LINE_POST_VALUES DPV on DPV.ID_DOC_LINE = DML.ID_DOC_LINE
                                  where  DML.ID_DOC_HEAD = DL.ID_DOC_HEAD
                                         and DPV.ID_ACCOUNT_POST = PV.ID_MASTER_ADDINS)) )
      into   :DL_DBKEY, :LINE_NAME, :ID_GUEST, :ID_RESERV_DETAIL, :ID_SERVICE
    do begin
      execute procedure DOC_LINES_SUSPEND_LINE(:DL_DBKEY, :RPT_CURR, :RPT_VAT, 'NONE',
        :DOC_VAT_STATUS, :CORRECTION_INDEX)
      returning_values (:NO_USE, :NO_USE, :PACKET_PRICE,
        :PACKET_PRICE_WOT_DIFF, :SINGLE_PRICE, :LINE_VALUE, :NO_USE, :NO_USE,
        :QTY_POST, :QTY_POST, :NO_USE, :NO_USE, :NO_USE);
      suspend;
    end
  end if (:RPT_TYPE = 'TAXES') then begin
    for
      select DL.RDB$DB_KEY, DL.LINE_NAME, DL.ID_SERVICE
      from   DOC_LINE DL
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
             and DL.TAX_STATUS > 1
      into   :DL_DBKEY, :LINE_NAME, :ID_SERVICE
    do begin
      execute procedure DOC_LINES_SUSPEND_LINE(:DL_DBKEY, :RPT_CURR, :RPT_VAT, 'NONE',
        :DOC_VAT_STATUS, :CORRECTION_INDEX)
      returning_values (:NO_USE, :NO_USE, :PACKET_PRICE,
        :PACKET_PRICE_WOT_DIFF, :SINGLE_PRICE, :LINE_VALUE, :NO_USE, :NO_USE,
        :QTY_POST, :QTY_POST, :NO_USE, :NO_USE, :NO_USE);
      suspend;
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: DOC_LINES_SUSPEND_INVOICE for: DOC_LINES_SUSPEND_LINE */
ALTER PROCEDURE DOC_LINES_SUSPEND_INVOICE(ID_DOC_HEAD INTEGER,
CORRECTION_INDEX INTEGER,
RPT_TYPE VARCHAR(20),
RPT_CURR VARCHAR(10),
RPT_VAT VARCHAR(20),
IN_VAUCHER_NUM VARCHAR(20))
 RETURNS(TAX_STATUS INTEGER,
ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
VAUCHER_NUM VARCHAR(20),
GUEST_NAME VARCHAR(100),
IS_CHILD INTEGER,
AGES_NAME VARCHAR(50),
GFROM_DATE DATE,
GTO_DATE DATE,
PACKET_NAME VARCHAR(50),
LINE_NAME VARCHAR(100),
ID_SERVICE INTEGER,
DATE_POST DATE,
QTY_POST NUMERIC(15,2),
SINGLE_PRICE NUMERIC(15,4),
LINE_VALUE NUMERIC(15,4),
PACKET_PRICE NUMERIC(15,4),
PACKET_PRICE_WOT_DIFF DOUBLE PRECISION,
ID_TARIFA INTEGER,
BIRTH_DATE DATE,
NIGHTS INTEGER,
IS_BASE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: DOC_LINES_SUSPEND_SUB for: DOC_LINES_SUSPEND_LINE */
ALTER PROCEDURE DOC_LINES_SUSPEND_SUB(ID_DOC_HEAD INTEGER,
CORRECTION_INDEX INTEGER,
SUBSTITUTE_PACK_NAME VARCHAR(50),
RPT_VAT VARCHAR(20),
RPT_CURR VARCHAR(20),
RPT_PACKETS VARCHAR(20))
 RETURNS(ID_DOC_LINE INTEGER,
LINE_NAME VARCHAR(100),
ID_GUEST INTEGER,
ROOM_NAME VARCHAR(10),
FROM_DATE DATE,
TO_DATE DATE,
DATE_POST DATE,
IS_BASE SMALLINT,
IS_CORRECT SMALLINT,
IS_FOR_PAY SMALLINT,
GROUP_TAG INTEGER,
TAX_STATUS INTEGER,
ID_SERVICE INTEGER,
ID_SERVICE_GROUP INTEGER,
GROUP_NAME VARCHAR(30),
IS_PACKET_POST SMALLINT,
ID_PACK_SERVICE INTEGER,
PACK_SERVICE_NAME VARCHAR(50),
QTY_POST NUMERIC(15,4),
PACK_QTY NUMERIC(15,4),
SINGLE_PRICE NUMERIC(15,4),
LINE_VALUE NUMERIC(15,4),
VAT_VALUE NUMERIC(15,4),
PACK_PRICE NUMERIC(15,4),
PACK_PRICE_WOT_DIFF DOUBLE PRECISION,
SINGLE_WOT_DIFF DOUBLE PRECISION,
SEC_CURR_LINE_VALUE NUMERIC(15,4),
SEC_CURR_GROSS_VALUE NUMERIC(15,4),
ID_SALE_TAXATION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOC_LINES_SUSPEND_LINE) */
ALTER PROCEDURE DOC_LINES_SUSPEND_LINE(DL_DBKEY CHAR(8),
RPT_CURR VARCHAR(20),
RPT_VAT VARCHAR(20),
RPT_PACKETS VARCHAR(10),
DOC_VAT_STATUS INTEGER,
CORRECTION_INDEX INTEGER)
 RETURNS(ID_PACK_SERVICE INTEGER,
PACK_NAME VARCHAR(50),
PACK_PRICE NUMERIC(15,2),
PACK_PRICE_WOT_DIFF DOUBLE PRECISION,
SINGLE_PRICE NUMERIC(15,4),
LINE_VALUE NUMERIC(15,4),
VAT_VALUE NUMERIC(15,4),
SINGLE_WOT_DIFF DOUBLE PRECISION,
QTY_POST NUMERIC(15,4),
PACK_QTY NUMERIC(15,4),
IS_PACKET_POST INTEGER,
SEC_CURR_LINE_VALUE NUMERIC(15,4),
SEC_CURR_GROSS_VALUE NUMERIC(15,4))
 AS
declare variable id_master_addins integer;
  declare variable id_doc_head integer;
  declare variable vat_status integer;
  declare variable is_base integer;                             
  declare variable is_base_packet_post integer;
  declare variable is_correct integer;
  declare variable id_account_post integer;
  declare variable single_with_vat numeric (15,4);
  declare variable single_wot_vat numeric (15,4);
  declare variable line_with_vat numeric (15,4);
  declare variable line_wot_vat numeric (15,4);
  declare variable pack_price_with_vat numeric (15,4);
  declare variable pack_price_wot_vat numeric (15,4);
  declare variable addins_price_wot_vat numeric (15,4);
  declare variable addins_price_with_vat numeric (15,4);
  declare variable addins_pack_price_wot_diff double precision;
  declare variable id_vat_group integer;
  declare variable round_to numeric(15,4);
  declare variable add_pack_name varchar(50);
  declare variable add_pack_name_int varchar(50);
  declare variable id_service integer;
  declare variable id_pack_hrana integer;
  declare variable is_separate_pansion integer;
  declare variable is_separate_pansion_int integer;
  declare variable line_sec_curr_wot_vat numeric(15,4);
  declare variable line_sec_curr_with_vat numeric(15,4);
  declare variable addins_sec_curr_wot_vat numeric(15,4);
  declare variable addins_sec_curr_with_vat numeric(15,4);
  declare variable pack_sec_curr_wot_vat numeric(15,4);
  declare variable pack_sec_curr_with_vat numeric(15,4);
  declare variable line_name varchar(100);
begin
  /* RPT_PACKETS - 'ALL', 'IN_PACKET', 'NONE'
  || RPT_VAT:
  ||  'line' - single price to be without vat,
  ||  'total' - single price with vat, document total by vat groups,
  ||  'none' - do not show values without vat.
  */
  round_to = 0.0001;
  if ((:rpt_vat is null) or (:rpt_vat = '')) then rpt_vat = 'as_doc';
  if (:rpt_vat = 'line') then vat_status = 2;
  else if (:rpt_vat in ('total', 'none')) then vat_status = 1;
  else vat_status = :doc_vat_status;

  select coalesce(PV.IS_BASE, 0), DL.IS_CORRECT, iif(DL.IS_CORRECT = 0, DL.QTY_POST * cast(:correction_index as smallint), DL.qty_post),
         iif(DL.is_correct <> 0, dl.single_wot_vat * cast(:correction_index as smallint), DL.SINGLE_WOT_VAT),
         iif(dl.is_correct <> 0, dl.single_value * cast(:correction_index as smallint), DL.SINGLE_VALUE),
         DL.WOT_VAT * cast(:correction_index as smallint), DL.QTY_POST * DL.SINGLE_VALUE * cast(:correction_index as smallint),
         iif(:rpt_curr = 'doc', DL.WOT_DIFF, coalesce(PV.ACCOUNT_PRICE, DL.WOT_DIFF * D.DOC_ACC_RATE)),
         PV.ID_MASTER_ADDINS, PV.ID_ACCOUNT_POST, DL.ID_DOC_HEAD, DL.ID_SALE_TAXATION,
         PV.ID_PACK_SERVICE, DL.ID_SERVICE, Sp.ID_BOARD, dl.sec_curr_net_value, dl.sec_curr_gross_value, dl.LINE_NAME
  from   DOC_LINE DL
         left join DOC_HEAD$INT D on D.ID_DOC_HEAD = Dl.ID_DOC_HEAD
         left outer join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE
         left outer join SERVICES S on S.ID_SERVICE = PV.ID_PACK_SERVICE
         left outer join SERVICE_PACKET sp on sp.ID_SERVICE = s.ID_SERVICE
  where  DL.RDB$DB_KEY = :dl_dbkey
  into   :is_base, :is_correct, :qty_post, :single_wot_vat, :single_with_vat,
         :line_wot_vat, :line_with_vat, :single_wot_diff,
         :id_master_addins, :id_account_post, :id_doc_head, :id_vat_group,
         :id_pack_service, :id_service, :id_pack_hrana, :line_sec_curr_wot_vat, :line_sec_curr_with_vat, :line_name;

  if (:is_base = 1) then begin
    is_packet_post = 1;
    id_master_addins = :id_account_post;
  end else if (:id_master_addins is not null) then begin
    select count(dlpv.id_account_post)
    from   DOC_LINE_POST_VALUES DLPV
           join DOC_LINE doc_l on doc_l.id_doc_line = dlpv.id_doc_line
    where  dlpv.id_account_post = :id_master_addins
           and dlpv.is_base = 1
           and doc_l.id_doc_head = :id_doc_head
    into   :is_base_packet_post;
    if (:is_base_packet_post > 0) then is_packet_post = 1; else is_packet_post = 0;
  end else begin
    is_packet_post = 0;
  end

  if (:rpt_curr = 'acc') then begin
    single_with_vat = :single_wot_diff;
    select sv.VALUE_WOT_TAX
    from   TAX_VALUE_DEDUCT (:single_with_vat, :round_to, :id_vat_group) sv
    into   :single_wot_vat;
    line_with_vat = :single_wot_diff*:qty_post; --*:correction_index;
    select sv.VALUE_WOT_TAX
    from   TAX_VALUE_DEDUCT (:line_with_vat, :round_to, :id_vat_group) sv
    into   :line_wot_vat;
  end
  add_pack_name = '';

  if ((:is_packet_post = 1) and (:rpt_packets <> 'NONE')) then begin
    pack_price_wot_vat  = 0;
    pack_price_with_vat = 0;
    pack_price_wot_diff = 0;
    is_separate_pansion = 1;
    pack_sec_curr_wot_vat = 0;
    pack_sec_curr_with_vat = 0;
    /* GET SUM OF ADDINS PRICES  */
    for
      select DLM.ID_SALE_TAXATION,
             S.EXTRA_PACKET_NAME,
             min(iif(Sp.ID_BOARD = :id_pack_hrana, 0, 1)),
             sum(DLM.SINGLE_WOT_VAT * DLM.QTY_POST * cast(:correction_index as smallint)),
             sum(DLM.SINGLE_VALUE * DLM.QTY_POST * cast(:correction_index as smallint)),
             sum(case when :rpt_curr = 'doc' then DLM.WOT_DIFF else PV.ACCOUNT_PRICE end * DLM.QTY_POST * cast(:correction_index as smallint)),
             sum(dlm.sec_curr_net_value),
             sum(dlm.sec_curr_gross_value)
      from   DOC_LINE DLM
             join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DLM.ID_DOC_LINE
             left outer join GUEST G on G.ID_GUEST = DLM.ID_GUEST
             left outer join AGENT_PACKET APA on APA.ID_AGENT = G.ID_AGENT and APA.ID_SERVICE = DLM.ID_SERVICE
             left outer join SERVICES S on S.ID_SERVICE = DLM.ID_SERVICE
             left outer join SERVICE_PACKET sp on sp.ID_SERVICE = s.ID_SERVICE
      where  DLM.ID_DOC_HEAD = :id_doc_head
             and PV.ID_MASTER_ADDINS = :id_master_addins
             and ((:rpt_packets = 'ALL') or (coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'BASE'))
      group by 1, 2
      into   :id_vat_group, :add_pack_name_int, :is_separate_pansion_int,
             :addins_price_wot_vat, :addins_price_with_vat, :addins_pack_price_wot_diff, :addins_sec_curr_wot_vat, :addins_sec_curr_with_vat
    do begin
      if (:add_pack_name_int <> '') then add_pack_name = :add_pack_name ||'\'|| :add_pack_name_int;
      if (:is_separate_pansion_int = 0) then is_separate_pansion = 0;
      addins_price_wot_vat = coalesce(:addins_price_wot_vat, 0);
      addins_price_with_vat = coalesce(:addins_price_with_vat, 0);
      addins_pack_price_wot_diff = coalesce(:addins_pack_price_wot_diff, 0);
      addins_sec_curr_wot_vat = coalesce(:addins_sec_curr_wot_vat, 0);
      addins_sec_curr_with_vat = coalesce(:addins_sec_curr_with_vat, 0);
      if (:rpt_curr = 'acc') then begin
        addins_price_with_vat = :addins_pack_price_wot_diff;
        select SV.VALUE_WOT_TAX
        from   TAX_VALUE_DEDUCT (:addins_price_with_vat, :round_to, :id_vat_group) sv
        into   :addins_price_wot_vat;
      end
      pack_price_wot_diff = :pack_price_wot_diff + :addins_pack_price_wot_diff;
      pack_price_with_vat = :pack_price_with_vat + :addins_price_with_vat;
      pack_price_wot_vat  = :pack_price_wot_vat + :addins_price_wot_vat;
      pack_sec_curr_wot_vat = :pack_sec_curr_wot_vat + :addins_sec_curr_wot_vat;
      pack_sec_curr_with_vat = :pack_sec_curr_with_vat + :addins_sec_curr_with_vat;
    end
    pack_qty = :qty_post * :is_base;
    if (:is_separate_pansion = 0) then id_service = :id_pack_service;

    select S.SERVICE_NAME||:add_pack_name
    from   SERVICES S
    where  S.ID_SERVICE = :ID_PACK_SERVICE
    into   :pack_name;
  end else begin
    /* NO PACKETS */
    pack_qty = :qty_post;
    pack_price_wot_vat  = :single_wot_vat;
    pack_price_with_vat = :single_with_vat;
    pack_price_wot_diff = :SINGLE_WOT_DIFF;
    is_packet_post = 0;
    pack_sec_curr_wot_vat = coalesce(:line_sec_curr_wot_vat, 0);
    pack_sec_curr_with_vat = coalesce(:line_sec_curr_with_vat, 0);
    ID_PACK_SERVICE = :id_service;
    PACK_NAME = substring(:line_name from 1 for 50);
  end

  vat_value     = :line_with_vat - :line_wot_vat;

  if (:vat_status = 1) then begin
    single_price = :single_with_vat;
    line_value   = :line_with_vat;
    pack_price   = :pack_price_with_vat;
    sec_curr_line_value  = :line_sec_curr_with_vat * :correction_index; --:pack_sec_curr_with_vat * :correction_index;
  end else if (:vat_status = 2) then begin
    single_price = :single_wot_vat;
    line_value   = :line_wot_vat;
    pack_price   = :pack_price_wot_vat;
    sec_curr_line_value = :line_sec_curr_wot_vat * :correction_index; --:pack_sec_curr_wot_vat * :correction_index;
  end
  sec_curr_gross_value = :line_sec_curr_with_vat * :correction_index; --:pack_sec_curr_with_vat * :correction_index;
  suspend;
end
^

/* empty dependent procedure body */
/* Clear: DOC_LINES_SUSPEND for: DOC_LINES_SUSPEND_SUB */
ALTER PROCEDURE DOC_LINES_SUSPEND(ID_DOC_HEAD INTEGER,
CORRECTION_INDEX INTEGER,
SUBSTITUTE_PACK_NAME VARCHAR(50),
REPORT_TYPE VARCHAR(20),
RPT_CURR VARCHAR(10),
RPT_VAT VARCHAR(20),
EXTRA_DATA_SUSPEND SMALLINT)
 RETURNS(ID_DOC_LINE INTEGER,
LINE_NAME VARCHAR(100),
ID_GUEST INTEGER,
ROOM_NAME VARCHAR(10),
FROM_DATE DATE,
TO_DATE DATE,
DATE_POST DATE,
IS_BASE SMALLINT,
IS_CORRECT SMALLINT,
IS_FOR_PAY SMALLINT,
GROUP_TAG INTEGER,
TAX_STATUS INTEGER,
ID_SERVICE INTEGER,
ID_SERVICE_GROUP INTEGER,
GROUP_NAME VARCHAR(30),
IS_PACKET_POST SMALLINT,
ID_PACK_SERVICE INTEGER,
PACK_SERVICE_NAME VARCHAR(50),
QTY_POST NUMERIC(15,4),
PACK_QTY NUMERIC(15,4),
SINGLE_PRICE NUMERIC(15,4),
LINE_VALUE NUMERIC(15,4),
VAT_VALUE NUMERIC(15,4),
PACK_PRICE NUMERIC(15,4),
PACK_PRICE_WOT_DIFF DOUBLE PRECISION,
POST_PRICE_WOT_DIFF DOUBLE PRECISION,
SEC_CURR_LINE_VALUE NUMERIC(15,4),
SEC_CURR_GROSS_VALUE NUMERIC(15,4),
ID_SALE_TAXATION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOC_LINES_SUSPEND_SUB) */
ALTER PROCEDURE DOC_LINES_SUSPEND_SUB(ID_DOC_HEAD INTEGER,
CORRECTION_INDEX INTEGER,
SUBSTITUTE_PACK_NAME VARCHAR(50),
RPT_VAT VARCHAR(20),
RPT_CURR VARCHAR(20),
RPT_PACKETS VARCHAR(20))
 RETURNS(ID_DOC_LINE INTEGER,
LINE_NAME VARCHAR(100),
ID_GUEST INTEGER,
ROOM_NAME VARCHAR(10),
FROM_DATE DATE,
TO_DATE DATE,
DATE_POST DATE,
IS_BASE SMALLINT,
IS_CORRECT SMALLINT,
IS_FOR_PAY SMALLINT,
GROUP_TAG INTEGER,
TAX_STATUS INTEGER,
ID_SERVICE INTEGER,
ID_SERVICE_GROUP INTEGER,
GROUP_NAME VARCHAR(30),
IS_PACKET_POST SMALLINT,
ID_PACK_SERVICE INTEGER,
PACK_SERVICE_NAME VARCHAR(50),
QTY_POST NUMERIC(15,4),
PACK_QTY NUMERIC(15,4),
SINGLE_PRICE NUMERIC(15,4),
LINE_VALUE NUMERIC(15,4),
VAT_VALUE NUMERIC(15,4),
PACK_PRICE NUMERIC(15,4),
PACK_PRICE_WOT_DIFF DOUBLE PRECISION,
SINGLE_WOT_DIFF DOUBLE PRECISION,
SEC_CURR_LINE_VALUE NUMERIC(15,4),
SEC_CURR_GROSS_VALUE NUMERIC(15,4),
ID_SALE_TAXATION INTEGER)
 AS
declare variable doc_vat_status integer;
  declare variable dl_dbkey char(8);
begin
  /* PACK_PRICE_WOT_DIFF and POST_PRICE_WOT_DIFF are only for grouping
  || Params: REPORT_TYPE, EXTRA_DATA_SUSPEND - for future use
  */
  select DT.IS_VAT
  from   DOC_HEAD$INT DH
         join DOC_TYPE DT on DT.ID_DOC_TYPE = DH.ID_DOC_TYPE
  where  DH.ID_DOC_HEAD = :id_doc_head
  into   :doc_vat_status;

  group_tag = null;

  for
    select  DL.RDB$DB_KEY, DL.ID_DOC_LINE, DL.LINE_NAME, DL.ID_GUEST, DL.ROOM_NAME,
            DL.FROM_DATE, DL.TO_DATE, coalesce(PV.IS_BASE, 0), DL.IS_CORRECT,
            iif(DV.ID_DOC_LINE is not null, 1, 0),
            DL.DATE_POST, DL.TAX_STATUS, DL.ID_SERVICE,
            SG.ID_SERVICE_GROUP, SG.GROUP_NAME, dl.id_sale_taxation
    from    DOC_LINE DL
            left outer join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE
            left outer join DOC_LINE_DEP_VALUES DV on DV.ID_DOC_LINE = DL.ID_DOC_LINE
            left outer join SERVICES s on S.ID_SERVICE = DL.ID_SERVICE
            left outer join SERVICE_GROUPS SG on SG.ID_SERVICE_GROUP = S.ID_SERVICE_GROUP
    where   DL.ID_DOC_HEAD = :id_doc_head
    into    :dl_dbkey, :id_doc_line, :line_name, :id_guest, :room_name,
            :from_date, :to_date, :is_base, :is_correct, :is_for_pay,
            :date_post, :tax_status, :id_service,
            :id_service_group, :group_name, :id_sale_taxation
  do begin
    execute procedure DOC_LINES_SUSPEND_LINE(:dl_dbkey, :rpt_curr, :rpt_vat, :rpt_packets,
      :doc_vat_status, :correction_index)
    returning_values :id_pack_service, :pack_service_name, :pack_price,
      :pack_price_wot_diff, :single_price, :line_value, :vat_value, :single_wot_diff,
      :qty_post, :pack_qty, :is_packet_post, :sec_curr_line_value, :sec_curr_gross_value;
    /* REPLACE PACK SERVICE NAME WITH SUBSTITUTE_PACK_NAME (IF NOT '') ONLY FOR PACKET SERVICES */
    if ((:rpt_packets <> 'NONE') and (:IS_PACKET_POST = 1) and (:substitute_pack_name is not null) and (trim(:substitute_pack_name) <> '')) then begin
      pack_service_name = :substitute_pack_name;
      id_pack_service = 0;    /* BECAUSE OF GROUPING */
    end else begin
      --pack_service_name = :line_name;
    end
    suspend;
  end
end
^

/* Alter (DOCUMENT_ANUL$DOC) */
ALTER PROCEDURE DOCUMENT_ANUL$DOC(ID_DOC_HEAD INTEGER,
ANUL_REASON VARCHAR(100),
MAKE_ANNUL_REPORT SMALLINT)
 AS
/**/
  declare variable id_account  integer;
  declare variable id_payment_head integer;
  declare variable for_deposit integer;
  declare variable id_base_doc integer;
  declare variable is_anul integer;
  declare variable dh_dbkey char(8);
  declare variable id_annul_protocol_num integer;
  declare variable num integer;
  declare variable doc_num varchar(20);
  declare variable system_date date;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable doc_date date;
  declare variable id_system_log integer;
  declare variable id_hotel integer;
  declare variable is_storno_doc integer;
  declare variable no_use integer;
begin

  select H.RDB$DB_KEY, H.ID_ACCOUNT, H.FOR_DEPOSIT, H.ID_BASE_DOC, H.IS_ANUL, A.ID_HOTEL,
         A.ID_RESERV_DETAIL, T.ID_ANNUL_DOC_NUM, h.DOC_DATE, H.IS_STORNO
  from   DOC_HEAD$INT H
         join DOC_COMPLETION dc on dc.ID_DOC_HEAD = h.ID_DOC_HEAD
         join DOC_TYPE T on H.ID_DOC_TYPE = T.ID_DOC_TYPE
         join DOC_TYPE_INV DTI on DTI.ID_DOC_TYPE = T.ID_DOC_TYPE
         join ACCOUNT A on A.ID_ACCOUNT = H.ID_ACCOUNT
  where  H.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :dh_dbkey, :id_account, :for_deposit, :id_base_doc, :is_anul, :id_hotel,
         :id_reserv_detail, :id_annul_protocol_num, :doc_date, :is_storno_doc;

  if (:is_anul = 1) then
    exception DOCUMENT_ANNUL_EXCEPTION '-352'; --'Document is already annul';

  if (exists (select D.ID_DOC
              from   DOC_HEAD D
              where  D.ID_BASE_DOC = :ID_BASE_DOC
                     and D.ID_DOC > :ID_DOC_HEAD
                     and D.IS_ANUL = 0))
  then exception DOCUMENT_ANNUL_EXCEPTION '-314';

  if (exists (select D.ID_DEPOSIT
              from   DEPOSIT_DEDUCT DD
                     join DEPOSITS d on d.ID_DEPOSIT = dd.ID_DEPOSIT
              where  DD.ID_DOC_USED = :ID_DOC_HEAD
                     and D.RECEIVED_AMOUNT = 0))
  then exception DOCUMENT_ANNUL_EXCEPTION '-315';

  execute procedure SYSTEM_DATE_GET(:ID_HOTEL)
  returning_values  :system_date;

  if (:DOC_DATE < :SYSTEM_DATE) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_PREV_DATE');
  end
  /* unarchive account and set as credit account, for shecked out bookings only */
  execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:ID_ACCOUNT, 0);

  if (:ID_RESERV_DETAIL is not null) then begin
    select RD.CHECK_STATUS
    from   RESERV_DETAIL RD
    where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :check_status;

    if (:check_status = 1) then begin
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, null, 1);
    end
  end
  /* MARK THE DOCUMENT AS ANUL - before posting and payment updates */
  update DOC_HEAD$INT DH
  set    DH.IS_ANUL = 1
  where  DH.RDB$DB_KEY = :dh_dbkey;

  update DOC_COMPLETION Dc
  set    Dc.IS_EFAKTURA_EXPORTED = 0
  where  Dc.ID_DOC_HEAD = :ID_DOC_HEAD;


  if (:is_storno_doc = 1) then begin
    /* annul storno doc */
    update DOC_HEAD$INT BD
    set    BD.IS_STORNED = 0
    where  BD.ID_DOC_HEAD = :id_base_doc
           and BD.IS_STORNED = 1;
  end
  /* RELEASE ACCOUNT_POSTS */
  if (:for_deposit = 0) then
    execute procedure ACCOUNT_POSTING_DOC_UPDATE$INT (:DH_DBKEY)
    returning_values (:no_use);

  /* PAYMENTS REFLECTION */
  for
    select PH.ID_PAYMENT_HEAD
    from   PAYMENT_HEAD PH
           join DOC_TYPE_PAY dt on dt.ID_DOC_TYPE = ph.ID_DOC_TYPE
    where  PH.ID_DOC_HEAD = :ID_DOC_HEAD
           and PH.IS_STORNED = 0
    into   :ID_PAYMENT_HEAD
  do begin

    execute procedure PAYMENT_ANUL$INT (:ID_PAYMENT_HEAD, :ANUL_REASON);
  end

  /* ANNUL_PROTOCOL creating section */
  NUM = null;
  DOC_NUM = null;
  if (:MAKE_ANNUL_REPORT = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_WITH_PROT');

    if (:ID_ANNUL_PROTOCOL_NUM is null) then exception DOCUMENT_ANNUL_EXCEPTION '-345';

    execute procedure SYSTEM_GEN_NUM ('ANNUL_PROT', :ID_ANNUL_PROTOCOL_NUM)
    returning_values  (:num, :doc_num);
  end
  /* log annul event */
  execute procedure SYSTEM_EVENT_LOG$INT ('DOCUMENT', :ID_DOC_HEAD, 'ANNUL', f_character(29)||:ANUL_REASON)
  returning_values  :id_system_log;

  insert into DOC_ANNULMENT (ID_DOC_HEAD, ANNULMENT_DATE, ID_PROT_DOC_NUM, PROT_NUM, PROT_DOC_NUM, ID_LOG_EVENT)
  values (:ID_DOC_HEAD, :SYSTEM_DATE, :ID_ANNUL_PROTOCOL_NUM, :NUM, :DOC_NUM, :ID_SYSTEM_LOG);
  /* reflect annul date on doc release dates */
  if (:DOC_DATE < :SYSTEM_DATE) then begin
    insert into DOC_RELEASE_DATE (ID_DOC_HEAD, RELEASE_DATE, VALUE_CORR_INDEX)
    values (:ID_DOC_HEAD, :SYSTEM_DATE, -1);
  end else begin
    update DOC_RELEASE_DATE RD
    set    RD.VALUE_CORR_INDEX = 0
    where  RD.ID_DOC_HEAD = :ID_DOC_HEAD
           and RD.RELEASE_DATE = :DOC_DATE;
  end
  /* reflect on AR module */
  execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT (:DH_DBKEY, :ANUL_REASON);
  /* reflect on client loyalty module */
  execute procedure DOCUMENT_BONUSPOINTS_VOID$CL (:ID_DOC_HEAD);

end
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_DOCUMENT_INITIALIZE$DOC for: DOCUMENT_INITIALIZE$DOC */
ALTER PROCEDURE DEPOSIT_DOCUMENT_INITIALIZE$DOC(ID_PAYMENT_HEAD /* TYPE OF ID */ INTEGER,
ID_BILLING_SERVICE /* TYPE OF ID */ INTEGER)
 RETURNS(ID_DOC_HEAD /* TYPE OF ID */ INTEGER,
ID_HOTEL /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TEST_DOC for: DOCUMENT_INITIALIZE$DOC */
ALTER PROCEDURE TEST_DOC(ID_ACCOUNT INTEGER,
DOC_SELECTED INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOCUMENT_INITIALIZE$DOC) */
ALTER PROCEDURE DOCUMENT_INITIALIZE$DOC(ID_ACCOUNT TYPE OF ID,
DOC_SELECTED TYPE OF ID,
PROFORMA_NAME_PREFIX VARCHAR(30) = null)
 RETURNS(ID_DOC_HEAD INTEGER,
ID_HOTEL INTEGER,
WARN_CODE INTEGER)
 AS
declare variable id_doc_type integer;
  declare variable id_base_doc integer;
  declare variable tax_event_date date;
  declare variable doc_date date;
  declare variable doc_curr varchar(3);
  declare variable id_doc_contragent integer;
  declare variable id_profile integer;
  declare variable doc_sub_type integer;
  declare variable firm_data blob sub_type 1 segment size 80 character set none;
  declare variable id_advance_payment integer;
  declare variable is_proforma tlogical;
  declare variable is_archive tlogical;
  declare variable doc_type_name varchar(50);
begin
  is_proforma = iif(:PROFORMA_NAME_PREFIX is null, 0, 1);

  if (:IS_PROFORMA is distinct from 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_NOPAY_CREATE');
  end else begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('PROFORMA_CREATE');
  end

  select A.ID_HOTEL, A.ID_PROFILE, H.FIRM_DATA
  from   ACCOUNT A
         join HOTEL H on H.ID_HOTEL  = A.ID_HOTEL
  where  A.ID_ACCOUNT = :id_account
  into   :id_hotel, :id_profile, :firm_data;

  id_advance_payment = null;
  execute procedure DOCUMENT_CHECK_SELECTION$INT (:DOC_SELECTED, :ID_ACCOUNT)
  returning_values  (:id_doc_type, :id_base_doc, :doc_curr, :id_doc_contragent, :id_advance_payment);

  if (:is_proforma = 1 and :id_base_doc is not null) then exception DOCUMENT_EXCEPTION '-1062';

  if (:id_doc_type is null) then begin
    execute procedure DOC_TYPE_GET$INT (:id_hotel, :IS_PROFORMA, :id_advance_payment)
    returning_values (:id_doc_type);
  end

  execute procedure CURR_RATES_PREPARE$INT (:DOC_SELECTED, :ID_ACCOUNT, :doc_date);

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :doc_date;
  tax_event_date = :doc_date;
                                                    
  select coalesce(:doc_curr, DT.DOC_CURR),
         iif (:is_proforma = 1, substring(trim(:PROFORMA_NAME_PREFIX) || ' ' || dt.doc_type_name from 1 for 50), dt.DOC_TYPE_NAME),
         dt.IS_ARCHIVE
  from   DOC_TYPE DT
  where  DT.ID_DOC_TYPE = :id_doc_type
  into   :doc_curr, :DOC_TYPE_NAME, :is_archive;

  if (:is_archive = 1) then execute procedure SYSTEM_WARNING_ADD(-312, '') returning_values :WARN_CODE;

  execute procedure DOCUMENT_CREATE$INT (:DOC_SELECTED, :ID_ACCOUNT, :id_doc_type, :doc_type_name, :doc_date, :doc_curr, :id_base_doc, :tax_event_date, :is_proforma, :id_advance_payment)
  returning_values  (:ID_DOC_HEAD, :doc_sub_type);

  if (:ID_ADVANCE_PAYMENT is null and :IS_PROFORMA is distinct from 1 and :doc_sub_type < 2) then begin
    execute procedure DOCUMENT_ATTACH_AVAIL_PAYS$INT (:ID_DOC_HEAD, :ID_ACCOUNT);
  end

  if (:id_doc_contragent is not null) then begin
    execute procedure DOC_CONTRAGENT_INITIALIZE$DOC (:ID_DOC_HEAD, null, :id_doc_contragent);
  end else begin
    execute procedure DOC_CONTRAGENT_INITIALIZE$INT (:ID_DOC_HEAD, 0, :id_profile);
  end

  execute procedure DOC_SUPPLIER_SET$DOC (:ID_DOC_HEAD, :firm_data);

  when exception DOC_ON_EMPTY_SELECTION do begin
    ID_DOC_HEAD = null;
  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_STORNO$DOC for: DOCUMENT_STORNO$INT */
ALTER PROCEDURE DOCUMENT_STORNO$DOC(ID_DOC_HEAD INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_STORNO_DOC INTEGER,
ID_HOTEL INTEGER,
ID_ACCOUNT INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOCUMENT_STORNO$INT) */
ALTER PROCEDURE DOCUMENT_STORNO$INT(ID_DOC_HEAD INTEGER,
DESCRIPTION VARCHAR(100),
STORNO_PAYMENTS SMALLINT)
 RETURNS(ID_STORNO_DOC INTEGER,
ID_HOTEL INTEGER,
WARN_CODE INTEGER)
 AS
declare variable id_deposit integer;
  declare variable id_account integer;
  declare variable is_storned integer;
  declare variable is_anul integer;
  declare variable doc_sub_type integer;
  declare variable id_doc_line integer;
  declare variable new_id_doc_line integer;
  declare variable post_value numeric(15,4);
  declare variable doc_value_a numeric(15,4);
  declare variable doc_net_value numeric(15,4);
  declare variable line_value numeric(15,4);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable doc_date date;
  declare variable id_doc_supplier integer;
  declare variable taxable_value numeric(15,4);
  declare variable second_curr_net_value numeric(15,4);
  declare variable second_curr_gross_value numeric(15,4);
  declare variable tax_event_date date;
  declare variable doc_value_roundless double precision;
  declare variable is_archive integer;
begin
  WARN_CODE = null;

  select D.ID_ACCOUNT, D.IS_STORNED, D.DOC_SUB_TYPE, D.IS_ANUL,
         A.ID_RESERV_DETAIL, D.ID_DOC_SUPPLIER, A.ID_HOTEL, d.TAX_EVENT_DATE, dt.is_archive
  from   DOC_HEAD D
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join DOC_TYPE dt on dt.ID_DOC_TYPE = d.ID_DOC_TYPE
  where  D.ID_DOC = :ID_DOC_HEAD
  into   :ID_ACCOUNT, :IS_STORNED, :DOC_SUB_TYPE, :IS_ANUL,
         :ID_RESERV_DETAIL, :ID_DOC_SUPPLIER, :ID_HOTEL, :tax_event_date, :is_archive;

  if (:DOC_SUB_TYPE <> 0) then
    exception DOCUMENT_EXCEPTION '-316';
  if (:IS_ANUL = 1) then
    exception DOCUMENT_EXCEPTION '-352';
  if (:IS_STORNED = 1) then
    exception MULTIPLE_STORNO_ON_DOC;

  if (:is_archive = 1) then execute procedure SYSTEM_WARNING_ADD(-312, '') returning_values :WARN_CODE;

  execute procedure SYSTEM_DATE_GET(:ID_HOTEL)
  returning_values  (:DOC_DATE);

  ID_STORNO_DOC = gen_id(DOC_SELECTED_GEN, 1);

  execute procedure CURR_RATES_PREPARE$INT (:ID_STORNO_DOC, :ID_ACCOUNT, :DOC_DATE);

  execute procedure DOC_SUPPLIER_GET_COPY$DOC (:ID_DOC_SUPPLIER)
  returning_values  :ID_DOC_SUPPLIER;

  insert into DOC_HEAD$INT(ID_DOC_HEAD, ID_DOC_TYPE, DOC_SUB_TYPE, ID_ACCOUNT,
         DOC_CURRENCY, DOC_RATE, DOC_ACC_RATE, DOC_TYPE_NAME, ID_DOC_NUM, DOC_DATE,
         DOC_VALUE_A, DOC_VALUE, DOC_NET_VALUE, ID_BASE_DOC, FOR_DEPOSIT,
         ID_DOC_CONTRAGENT, ID_DOC_SUPPLIER, DESCRIPTION, IS_STORNO, TAXABLE_VALUE,
         SECOND_CURRENCY, SECOND_CURR_RATE, SECOND_CURR_NET_VALUE, SECOND_CURR_GROSS_VALUE, DOC_VALUE_ROUNDLESS)
  select :ID_STORNO_DOC, D.ID_DOC_TYPE, 2, D.ID_ACCOUNT,
         D.DOC_CURRENCY, D.DOC_RATE, D.DOC_ACC_RATE, DT.CREDIT_DOC_NAME, ID_DOC_NUM, :doc_date,
         0, D.DOC_VALUE, d.DOC_NET_VALUE, D.ID_BASE_DOC, D.FOR_DEPOSIT,
         D.ID_DOC_CONTRAGENT, :ID_DOC_SUPPLIER, :DESCRIPTION, 1, D.TAXABLE_VALUE,
         d.SECOND_CURRENCY, d.SECOND_CURR_RATE, d.SECOND_CURR_NET_VALUE, d.SECOND_CURR_GROSS_VALUE, d.DOC_VALUE_ROUNDLESS
  from   DOC_HEAD$INT D
         join DOC_TYPE_INV DT on DT.ID_DOC_TYPE = D.ID_DOC_TYPE
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD;

  execute procedure DOCUMENT_COMPLETE$INT (:ID_STORNO_DOC, :DOC_DATE, :TAX_EVENT_DATE, null);

  /* doc lines */
  POST_VALUE = 0;
  DOC_VALUE_A = 0;
  for
    select DL.ID_DOC_LINE, -(DL.SINGLE_VALUE * DL.QTY_POST)
    from   DOC_HEAD BD
           join DOC_LINE DL on BD.ID_DOC = DL.ID_DOC_HEAD
    where  BD.ID_BASE_DOC = :ID_DOC_HEAD
           and BD.IS_ANUL = 0
           and DL.ID_DOC_HEAD is distinct from :ID_STORNO_DOC
    order by DL.ID_DOC_LINE asc
    into   :ID_DOC_LINE, :LINE_VALUE
  do begin
    NEW_ID_DOC_LINE = gen_id(G_AUTO_INC_DOC_LINES, 1);
    insert into DOC_LINE(ID_DOC_LINE, ID_DOC_HEAD, DATE_POST, LINE_NAME,
           ID_SERVICE, QTY_POST, TO_DATE, FROM_DATE, VAT_PERCENT, ID_SALE_TAXATION,
           SINGLE_VALUE, SINGLE_WOT_VAT, WOT_VAT, WOT_DIFF,
           TAX_STATUS, IS_CORRECT, GROUP_TAG,
           ID_GUEST, ROOM_NAME, NAT_NET_VALUE, NAT_GROSS_VALUE, SEC_CURR_NET_VALUE, SEC_CURR_GROSS_VALUE)
    select :NEW_ID_DOC_LINE, :ID_STORNO_DOC, DL.DATE_POST, DL.LINE_NAME,
           DL.ID_SERVICE, DL.QTY_POST*(2*DL.IS_CORRECT-1), DL.TO_DATE, DL.FROM_DATE, DL.VAT_PERCENT, DL.ID_SALE_TAXATION,
           DL.SINGLE_VALUE*(1-2*DL.IS_CORRECT), DL.SINGLE_WOT_VAT*(1-2*DL.IS_CORRECT), -DL.WOT_VAT, DL.WOT_DIFF*(1-2*DL.IS_CORRECT),
           DL.TAX_STATUS, DL.IS_CORRECT, DL.GROUP_TAG,
           DL.ID_GUEST, DL.ROOM_NAME, -DL.NAT_NET_VALUE, -DL.NAT_GROSS_VALUE, -DL.SEC_CURR_NET_VALUE, -DL.SEC_CURR_GROSS_VALUE
    from   DOC_LINE DL
    where  DL.ID_DOC_LINE = :ID_DOC_LINE;

    insert into DOC_LINE_DISCOUNTED (ID_DOC_LINE, ID_DOC_DISCOUNT)
    select :NEW_ID_DOC_LINE, DLT.ID_DOC_DISCOUNT
    from   DOC_LINE_DISCOUNTED DLT
    where  DLT.ID_DOC_LINE = :ID_DOC_LINE;

    insert into DOC_LINE_POST_VALUES (
           ID_DOC_LINE, ID_ACCOUNT_POST,POST_RATE_IN_ACC, POST_RATE_IN_DOC,
           NET_RATE_DIFF, GROSS_RATE_DIFF, NET_ROUND_DIFF, GROSS_ROUND_DIFF,
           ID_MASTER_ADDINS, ID_PACK_SERVICE, IS_BASE, ACCOUNT_PRICE)
    select :NEW_ID_DOC_LINE, ID_ACCOUNT_POST, POST_RATE_IN_ACC, POST_RATE_IN_DOC,
           -NET_RATE_DIFF, -GROSS_RATE_DIFF, -NET_ROUND_DIFF, -GROSS_ROUND_DIFF,
           ID_MASTER_ADDINS, ID_PACK_SERVICE, IS_BASE, ACCOUNT_PRICE
    from   DOC_LINE_POST_VALUES PV
    where  PV.ID_DOC_LINE = :ID_DOC_LINE;

    if (row_count = 1) then POST_VALUE = :POST_VALUE + :LINE_VALUE;

    insert into DOC_LINE_DEP_VALUES (
           ID_DOC_LINE, DEP_RATE_IN_ACC, DEP_RATE_IN_DOC, ID_DEPOSIT)
    select :NEW_ID_DOC_LINE, DEP_RATE_IN_ACC, DEP_RATE_IN_DOC, ID_DEPOSIT
    from   DOC_LINE_DEP_VALUES DV
    where  DV.ID_DOC_LINE = :ID_DOC_LINE;

    insert into DOC_LINE_REV_DEDUCTION_TAX (ID_DOC_LINE, ID_SALE_TAX, TAX_NAME, TAX_UNIT, TAX_VALUE, NAT_TAX_VALUE)
    select :NEW_ID_DOC_LINE, rdt.ID_SALE_TAX, rdt.TAX_NAME, rdt.TAX_UNIT, -rdt.TAX_VALUE, -rdt.NAT_TAX_VALUE
    from   DOC_LINE_REV_DEDUCTION_TAX rdt
    where  rdt.ID_DOC_LINE = :id_doc_line;

    insert into DOC_FOOTER (
           ID_DOC_HEAD, ID_DOC_LINE, ID_TAX, TAX_ORDER, TAXABLE_VALUE, FOOTER_VALUE, DESCRIPTION,
           SECOND_CURR_DISCOUNTABLE_VALUE, SECOND_CURR_DISCOUNT_VALUE)
    select :ID_STORNO_DOC, :NEW_ID_DOC_LINE, ID_TAX, TAX_ORDER, -TAXABLE_VALUE, -DF.FOOTER_VALUE, DF.DESCRIPTION,
           -df.SECOND_CURR_DISCOUNTABLE_VALUE, -df.SECOND_CURR_DISCOUNT_VALUE
    from   DOC_FOOTER DF
    where  DF.ID_DOC_LINE = :ID_DOC_LINE;
    DOC_VALUE_A = :DOC_VALUE_A + :LINE_VALUE;
    /* payment footer lines ?!?!?!? */
  end
  /* totals */
  select -sum(d.DOC_VALUE), -sum(d.DOC_VALUE_A), -sum(d.DOC_VALUE_ROUNDLESS), -sum(d.TAXABLE_VALUE),
         -sum(d.DOC_NET_VALUE), -sum(d.SECOND_CURR_NET_VALUE), -sum(d.SECOND_CURR_GROSS_VALUE)
  from   DOC_HEAD$INT D
  where  D.ID_BASE_DOC = :ID_DOC_HEAD
         and D.IS_ANUL = 0
         and D.ID_DOC_HEAD is distinct from :ID_STORNO_DOC
  into   :POST_VALUE, :DOC_VALUE_A, :doc_value_roundless, :taxable_value,
         :doc_net_value, :second_curr_net_value, :second_curr_gross_value;

  update DOC_HEAD$INT SD
  set    SD.DOC_VALUE = :POST_VALUE,
         SD.DOC_VALUE_A = :DOC_VALUE_A,
         SD.DOC_NET_VALUE = :doc_net_value,
         sd.DOC_VALUE_ROUNDLESS = :doc_value_roundless,
         sd.TAXABLE_VALUE = :taxable_value,
         sd.SECOND_CURR_NET_VALUE = :second_curr_net_value,
         sd.SECOND_CURR_GROSS_VALUE = :second_curr_gross_value
  where  SD.ID_DOC_HEAD = :ID_STORNO_DOC;

  insert into DOC_TAXES (ID_DOC_HEAD, ID_SALE_TAX, TAX_NAME, TAX_PERCENT, NONTAXABLE_VALUE, TAXABLE_VALUE, TAX_VALUE,
         TAXATION_REASON, SEC_CURR_NONTAXABLE_VALUE, SEC_CURR_TAXABLE_VALUE, SEC_CURR_TAX_VALUE)
  select :ID_STORNO_DOC, DT.ID_SALE_TAX, DT.TAX_NAME, DT.TAX_PERCENT, -sum(DT.NONTAXABLE_VALUE), -sum(DT.TAXABLE_VALUE), -sum(DT.TAX_VALUE),
         DT.TAXATION_REASON, -sum(dt.SEC_CURR_NONTAXABLE_VALUE), -sum(dt.SEC_CURR_TAXABLE_VALUE), -sum(dt.SEC_CURR_TAX_VALUE)
  from   DOC_HEAD D
         join DOC_TAXES DT on DT.ID_DOC_HEAD = D.ID_DOC
  where  D.ID_BASE_DOC = :ID_DOC_HEAD
         and D.IS_ANUL = 0
         and D.ID_DOC is distinct from :ID_STORNO_DOC
  group by DT.ID_SALE_TAX, DT.TAX_NAME, DT.TAX_PERCENT, DT.TAXATION_REASON;

  update DOC_HEAD$INT D
  set    D.IS_STORNED = 1
  where  D.ID_BASE_DOC = :ID_DOC_HEAD
         --and D.ID_DOC is distinct from :ID_STORNO_DOC
         and D.IS_ANUL = 0
         and d.DOC_SUB_TYPE < 2;

  /* discounts */
  insert into DOC_FOOTER (ID_DOC_HEAD, ID_TAX, ID_DOC_LINE, TAX_ORDER, DESCRIPTION,
         TAXABLE_VALUE, FOOTER_VALUE, SECOND_CURR_DISCOUNTABLE_VALUE, SECOND_CURR_DISCOUNT_VALUE)
  select :ID_STORNO_DOC, DF.ID_TAX, null, DF.TAX_ORDER, DF.DESCRIPTION,
         sum(-DF.TAXABLE_VALUE), sum(-DF.FOOTER_VALUE), sum(-df.SECOND_CURR_DISCOUNTABLE_VALUE), sum(-df.SECOND_CURR_DISCOUNT_VALUE)
  from   DOC_HEAD D
         join DOC_FOOTER DF on DF.ID_DOC_HEAD = D.ID_DOC
  where  DF.ID_DOC_HEAD = :ID_DOC_HEAD
         and DF.ID_DOC_LINE is null
  group by DF.ID_TAX, DF.DESCRIPTION, DF.TAX_ORDER;

  /* storno payments */
  if (:STORNO_PAYMENTS = 1/* and :for_deposit = 0*/) then begin
    execute procedure DOCUMENT_STORNO_PAYS_SET$DOC (:ID_STORNO_DOC);

    /* free deposits */
    for
      select D.ID_DEPOSIT
      from   DEPOSIT_DEDUCT D
      where  D.ID_DOC_USED = :ID_DOC_HEAD
      into   :ID_DEPOSIT
    do begin
      execute procedure DOCUMENT_DETACH_DEPOSIT$INT (:ID_DOC_HEAD, :ID_DEPOSIT, :ID_STORNO_DOC);
    end
  end

  if (:ID_RESERV_DETAIL is not null) then begin
    select RD.CHECK_STATUS
    from   RESERV_DETAIL RD
    where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :CHECK_STATUS;

    if (:CHECK_STATUS = 1) then begin
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, null, 1);
    end
  end

end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ATTACH_AVAIL_PAYS$INT for: DOCUMENT_USE_DEPOSIT$DOC */
ALTER PROCEDURE DOCUMENT_ATTACH_AVAIL_PAYS$INT(ID_DOC_HEAD INTEGER,
ID_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_REUSE_DEPOSITS$INT for: DOCUMENT_USE_DEPOSIT$DOC */
ALTER PROCEDURE DOCUMENT_REUSE_DEPOSITS$INT(OLD_ID_DOC_HEAD INTEGER,
NEW_ID_DOC_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (DOCUMENT_USE_DEPOSIT$DOC) */
ALTER PROCEDURE DOCUMENT_USE_DEPOSIT$DOC(ID_DOC_HEAD INTEGER,
ID_DEPOSIT INTEGER,
DEPOSIT_AMOUNT NUMERIC(15,4))
 AS
declare variable id_deposit_doc integer;
  declare variable id_dep_doc_type integer;
  declare variable id_new_doc_type integer;
  declare variable id_dep_taxation integer;
  declare variable dep_doc_curr varchar(3);
  declare variable new_doc_curr varchar(3);
  declare variable pay_curr varchar(3);
  declare variable deposit_doc_value numeric(15,4);
  declare variable id_doc_line integer;
  declare variable doc_round_to numeric(15,4);
  declare variable pay_round_to numeric(15,4);
  declare variable pay_rate numeric(15,6);
  declare variable doc_sub_type integer;
  declare variable id_account_payment integer;
  declare variable service_amount numeric(15,4);
begin
  ID_DEPOSIT_DOC = null;
  select DH.DOC_SUB_TYPE
  from   DOC_HEAD DH
  where  DH.ID_DOC = :ID_DOC_HEAD
  into   :doc_sub_type;
   
  if (:doc_sub_type = 2) then exception DOCUMENT_EXCEPTION '-372';  /* Can not use deposit into credit doc */
  /*  */
  execute procedure DOCUMENT_DETACH_DEPOSIT$INT (:ID_DOC_HEAD, :ID_DEPOSIT);

  select DH.ID_DOC, DH.ID_DOC_TYPE, DH.DOC_CURRENCY, ph.PAY_CURRENCY
  from   DEPOSIT D
         join PAYMENT_HEAD PH on PH.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
         left outer join DOC_HEAD DH on DH.ID_DOC = PH.ID_DOC_HEAD
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_deposit_doc, :id_dep_doc_type, :dep_doc_curr, :pay_curr;

  execute procedure DOCUMENT_CURR_RATE_GET$INT (:ID_DOC_HEAD, :pay_curr)
  returning_values (:pay_rate, :pay_round_to);
  /*********************************************************/
  if (round_f(:DEPOSIT_AMOUNT, :PAY_ROUND_TO) = 0) then exit;
  /*********************************************************/
  select first 1 AP.ID_ACCOUNT_PAYMENT
  from   ACCOUNT_PAYMENTS AP
  where  AP.ID_DEPOSIT = :ID_DEPOSIT
  order by ap.ID_ACCOUNT_PAYMENT asc
  into   :id_account_payment;

  execute procedure DOCUMENT_ATTACH_PAYMENT$INT (:ID_DOC_HEAD, :id_account_payment, :pay_rate, :DEPOSIT_AMOUNT)
  returning_values :deposit_doc_value;
   
  if (:ID_DEPOSIT_DOC is not null) then begin
    select first 1 DDL.ID_SALE_TAXATION
    from   DOC_LINE DDL
           join DOC_LINE_DEP_VALUES DV on DV.ID_DOC_LINE = DDL.ID_DOC_LINE
    where  DDL.ID_DOC_HEAD = :ID_DEPOSIT_DOC
    into   :id_dep_taxation;
     
    select  D.ID_DOC_TYPE, D.DOC_CURRENCY, c.ROUND_TO
    from    DOC_HEAD D
            join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
            join CURRS c on c.CURR = d.DOC_CURRENCY
    where   D.ID_DOC = :ID_DOC_HEAD
    into    :id_new_doc_type, :new_doc_curr, :doc_round_to;

    if (not (:id_dep_doc_type = :id_new_doc_type and :dep_doc_curr = :new_doc_curr) ) then
       exception DOCUMENT_EXCEPTION '-374';

    select round_f(sum(dl.QTY_POST * dl.SINGLE_VALUE), :doc_round_to)
    from   DOC_LINE DL
           join SALE_TAXATION_TAX ST on ST.ID_SALE_TAXATION = DL.ID_SALE_TAXATION
           join SALE_TAXES t on t.ID_SALE_TAX = st.ID_SALE_TAX and t.REVENUE_DEDUCTION_TAX is distinct from 1
    where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
           and ST.ID_SALE_TAX in (select STT.ID_SALE_TAX
                                  from   SALE_TAXATION_TAX STT
                                         join SALE_TAXES t2 on t2.ID_SALE_TAX = stt.ID_SALE_TAX
                                                               and t2.REVENUE_DEDUCTION_TAX is distinct from 1
                                         where  STT.ID_SALE_TAXATION = :id_dep_taxation)
    into   :service_amount;

    if (coalesce(:service_amount, 0) < :deposit_doc_value) then
      exception DOCUMENT_EXCEPTION '-334' || f_character(31) || f_character(29) || formatfloat(:service_amount, 'F;0.00') || ' ' || :new_doc_curr;

    deposit_doc_value = -:deposit_doc_value; /* !!! Value should be NEGATIVE - to reduce document total amount */
    execute procedure DOCUMENT_ADD_PAYMENT_LINE$INT (:ID_DEPOSIT, :ID_DOC_HEAD, :deposit_doc_value, :id_dep_taxation)
    returning_values  (:id_doc_line);
  
    execute procedure DOCUMENT_SAVE_TOTAL$INT (:ID_DOC_HEAD)
    returning_values :doc_sub_type;
  end
end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_POST_TO_MH_FRONT_ONLINE for: EAI_MAP_SERVICE */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: EAI_POS_POSTING_ADD$P2E for: EAI_MAP_SERVICE */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_TELECOUNT_CALL$INT for: EAI_MAP_SERVICE */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_MAP_SERVICE) */
ALTER PROCEDURE EAI_MAP_SERVICE(SERVICE_TAG VARCHAR(30),
SERVICE_NAME VARCHAR(30),
EXTERNAL_IFC VARCHAR(30),
ID_HOTEL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_MAPPED_SERVICE INTEGER)
 AS
declare variable id_service_group integer;
  declare variable setting_code varchar(30);
  declare variable revenue_group varchar(30);
  declare variable is_base integer;
  declare variable is_deleted integer;
begin
  /*  Description:
  ||
  */
  err_code = 0;
  err_text = '';
  id_mapped_service = null;
  select first 1 S.ID_SERVICE, S.IS_BASE, s.IS_DELETED
  from   SERVICES S
  where  S.EXT_CODE = :service_tag
         and s.ID_HOTEL = :id_hotel
  order by s.ID_SERVICE asc
  into   :id_mapped_service, :is_base, :is_deleted;

  if (:is_base = 1) then begin
    ERR_CODE = -63;
    ERR_TEXT= '';
    exit;
  end
  if (:is_deleted = 1) then begin
    ERR_CODE = -64;
    ERR_TEXT= '';
    exit;
  end
  if (:id_mapped_service is not null) then exit;

  if (:external_ifc = 'POS') then revenue_group = 'Food and Beverage';
  else revenue_group = 'Other Operated departments';

  setting_code = 'IFC_'||:external_ifc||'_SRVGRP';
  execute procedure SETTING_GET_VALUE(:setting_code, :ID_HOTEL)
  returning_values  :id_service_group;

  execute procedure SERVICE_MODIFY(null, :id_service_group, 'EXTRA', :service_name, 0, 1, 0,
                    :revenue_group, null, null, :service_tag, 'BASE', '', 0, 'add', :ID_HOTEL,
                    0, 0, 0, 0, 0, 0, null, null)
  returning_values  :id_mapped_service;
end
^

/* Alter (EAI_POS_GET_GUESTS$P2E) */
ALTER PROCEDURE EAI_POS_GET_GUESTS$P2E(IN_ROOM_NAME VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(OUT_ID_GUEST INTEGER,
OUT_GUEST_NAME VARCHAR(100),
OUT_FROM_DATE DATE,
OUT_TO_DATE DATE,
OUT_OK_FOR_POST INTEGER,
OUT_COUNTRY VARCHAR(30),
OUT_TEXT VARCHAR(100),
OUT_BOARD_NAME VARCHAR(30),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100))
 AS
declare variable id_room integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  OUT_GUEST_NAME = null;

  /*FIND ROOM*/
  select R.ID_ROOM
  from   ROOMS R
         join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
  where  R.ROOM_NAME = :IN_ROOM_NAME
         and RT.ID_HOTEL = :ID_HOTEL
  into   :ID_ROOM;
  if ((:ID_ROOM is null) or (:ID_ROOM <= 0) ) then begin
    ERR_CODE = -5;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Room number not found!    ! ';
    suspend;
    exit;
  end

  /*FIND GUESTS*/
  for
    select G.ID_GUEST, GC.GUEST_NAME1, G.FROM_DATE, G.TO_DATE, C.COUNTRY_NAME,
           (select m.NAME
            from   GUEST_STAY gs
                   join MEALS M on m.ID_BOARD = gs.ID_BOARD
            where  gs.ID_GUEST = g.ID_GUEST
                   and gs.FOR_DATE = iif(current_date = g.to_date, current_date - 1, current_date))
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
           left outer join GUEST_CARD GC on G.ID_GUEST = GC.ID_GUEST
           left outer join COUNTRY C on C.COUNTRY_CODE = GC.COUNTRY
    where  G.ID_ROOM = :ID_ROOM
           and G.CHECK_STATUS = 0
           and rd.IS_ANUL = 0
    into   :OUT_ID_GUEST, :OUT_GUEST_NAME, :OUT_FROM_DATE,  :OUT_TO_DATE, :OUT_COUNTRY, :OUT_BOARD_NAME
  do begin
    OUT_OK_FOR_POST = iif(:OUT_TO_DATE < current_date, 0, 1) ;
    suspend;
  end

  if (:OUT_GUEST_NAME is null) then begin
    ERR_CODE = -1;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Guests not found!     !';
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: EAI_POS_POSTING_ADD for: EAI_POS_POSTING_ADD$P2E */
ALTER PROCEDURE EAI_POS_POSTING_ADD(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_POS_POSTING_ADD$P2E) */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
declare variable id_service integer;
  declare variable my_post_text varchar(255);
  declare variable my_resource_text varchar(255);
  declare variable no_use integer;
  declare variable nation_curr varchar(3);
  declare variable post_short_code varchar(10);
  declare variable id_hotel integer;
begin
  /* in_on_guest = 0 (account), 1 (guest), -1 (ew)
  */
  if (:IN_ON_GUEST = 1) then begin
    select rd.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :IN_ID_GUEST
    into   :id_hotel;
  end else begin
    select a.ID_HOTEL
    from   account a
    where  a.ID_ACCOUNT = :in_id_account
    into   :id_hotel;
  end

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :nation_curr;

  if ('END_WORK' = :in_smetka_num) then begin
    post_short_code='POS_EW';
  end else begin
    post_short_code='POS';
  end

  /* FIND SERVICE */
  execute procedure EAI_MAP_SERVICE(:in_service_tag, :in_service_name, 'POS', :id_hotel)
  returning_values  :err_code, :err_text, :id_service;
  if (:err_code < 0) then exit;

  my_post_text = 'date:'|| formatdate(:in_date_smetka, 'D;dd.mm.yyyy') ||
                 ' num:'|| :in_smetka_num ||
                 ' obj:'|| :in_obj_name ||
                 ' tbl:'|| :in_table ||
                 ' site:'|| :in_site;

  my_resource_text = 'POS_ID_SMETKA:'||:in_id_smetka;
  my_post_text = substring(:my_post_text from 1 for 100);
  my_resource_text = substring(:my_resource_text from 1 for 49);

  if (:in_on_guest = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:in_id_guest, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code, '')
    returning_values  :err_code, :err_text, :out_id_account, :no_use;
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:in_id_account, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code)
    returning_values  :err_code, :err_text, :no_use;
    out_id_account = :in_id_account;
  end
end
^

/* Alter (EAI_RES_CHECK_OUT_FAST) */
ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
declare variable selection_id integer;
  declare variable is_early_check_out smallint;
  declare variable early_check_out_dep_date date;
  declare variable check_out_date date;
begin
  selection_id = gen_id(selection_gen, 1);

  update RESERV_DETAIL RD
  set RD.SELECTION_ID = :SELECTION_ID
  where RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL;

  execute procedure RES_CHECK_OUT_CHECK$RSV(:selection_id)
  returning_values :is_early_check_out, :early_check_out_dep_date, :check_out_date;

  if (:is_early_check_out = 1) then
    exception BOOKING_EXCEPTION '-1043';

  execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id, 0);
end
^

ALTER PROCEDURE RES_LOAD(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_AGENT_PROFILE INTEGER,
AGENT_PROFILE_NAME VARCHAR(100),
ID_PERSON_PROFILE INTEGER,
PERSON_PROFILE_NAME VARCHAR(100),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_RES_ROOM_TYPE INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
BOARD_NAMES VARCHAR(255),
TARIFF_NAMES VARCHAR(255),
PACKET_NAMES VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100),
VOUCHER_RENDER VARCHAR(512),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
TRANSFER_RENDER VARCHAR(255),
CODE_FIRST_FOOD_RENDER VARCHAR(255),
IS_LATE_DEPARTURE INTEGER,
CODE_FIRST_FOOD VARCHAR(20),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
I_SPECIAL_TREATMENT VARCHAR(255),
COMMING_KIND SMALLINT,
IS_VIP SMALLINT,
HAS_GUEST_LIST SMALLINT,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
AGENT_ACCOUNT_NAME VARCHAR(100),
IS_DIFFERENT_VOUCHER INTEGER,
IS_DIFFERENT_OTHER INTEGER,
IS_DIFFERENT_BOARD INTEGER,
IS_DIFFERENT_TARIFF INTEGER,
IS_CUSTOM_PRICE INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
ID_RATE INTEGER,
ROOM_FEATURES BLOB,
ID_GROUP INTEGER,
NUMBER VARCHAR(62),
CHECK_STATUS INTEGER,
BALANCE VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER,
RECIEVED_DEPOSITS VARCHAR(255),
ROOM_HISTORY VARCHAR(200),
TAR_ROOM_TYPE VARCHAR(100),
ID_HK_PLAN INTEGER,
COUNTRIES VARCHAR(812),
IS_RESGRP INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
IS_ANUL INTEGER,
NOTE VARCHAR(2000),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
GROUP_NAME VARCHAR(50),
ID_HOTEL INTEGER,
NOTE_REMINDERS VARCHAR(50),
IS_DIFFERENT_PRICE INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ID_EATING_OBJECT TYPE OF ID_REF,
ROOM_PRIVATE_STATUS TLOGICAL)
 AS
declare variable rd_dbkey char(8);
  declare variable reason_of_anul varchar(100);
  declare variable shared_resvations varchar(1024);
  declare variable virtual_room varchar(10);
  declare variable packet_item_ids varchar(255);
  declare variable earlycheckout_date date;
begin
  select RD.RDB$DB_KEY, RD.ID_AGENT_PROFILE, PA.PROFILE_NAME,
         RD.ID_NOM_MARKET_SEGMENT, RD.ID_NOM_SOURCE_CODE, RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_HEAR_REASON, RD.ID_NOM_COME_REASON,
         RD.ADULT_COUNT, RD.CHILD_COUNT, RD.CUSTOM_PRICE, RD.CUSTOM_CURRENCY,
         RD.IS_VIP, RD.CHECK_STATUS, RD.ID_AGENT_ACCOUNT,
         RD.ACC_ROUTING, RD.ID_PERSON_PAYMENT,
         RD.ID_AGENT_PAYMENT, RD.ID_PERSON_PROFILE, PP.PROFILE_NAME, RD.ID_GROUP,
         RD.COMMING_KIND, RD.I_SPECIAL_TREATMENT, ACC.ACCOUNT_NAME, RD.ROOM_FEATURES, RD.ID_HK_PLAN,
         RD.NUMBER, RD.IS_ANUL, RD.REASON_OF_ANUL, RD.NOTE,
         RD.HAS_DIFFERENT_VOUCHERS, RD.HAS_DIFFERENT_OTHER,
         RD.HAS_DIFFERENT_BOARD, RD.HAS_DIFFERENT_TARIFF, RD.HAS_DIFFERENT_TYPE_STAY, RD.HAS_DIFFERENT_ROOM_TYPE,
         RD.ID_HOTEL, RG.GROUP_NAME, RD.ID_RATE, RD.NOTE_REMINDERS, RD.has_different_price,
         RD.ID_GUARANTEE_POLICY, RD.BLOCK_CC, rd.ID_EATING_OBJECT, g.EARLYCHECKOUT_DATE
  from   RESERV_DETAIL RD
         left outer join RESERV_GROUP RG on RG.ID_RESERV_GROUP = RD.ID_GROUP
         left outer join PROFILE PA on PA.ID_PROFILE = RD.ID_AGENT_PROFILE
         left outer join PROFILE PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
         left outer join ACCOUNT ACC on ACC.ID_ACCOUNT = RD.ID_AGENT_ACCOUNT
         left outer join GUEST G on g.ID_GUEST = rd.ID_TITULAR
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :id_agent_profile, :agent_profile_name,
         :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason,
         :adult_count, :child_count, :custom_price, :custom_currency,
         :is_vip, :check_status, :id_agent_account, :acc_routing, :id_person_payment,
         :id_agent_payment, :id_person_profile, :person_profile_name, :id_group,
         :comming_kind, :i_special_treatment, :agent_account_name, :room_features, :id_hk_plan,
         :number, :is_anul, :reason_of_anul, :note,
         :is_different_voucher, :is_different_other,
         :is_different_board, :is_different_tariff, :is_different_stay_type, :is_different_room_type,
         :id_hotel, :group_name, :id_rate, :note_reminders, :is_different_price,
         :id_guarantee_policy, :block_cc, :id_eating_object, :earlycheckout_date;

  is_resgrp = iif(:id_group is not null, 1, 0);

  if ((:is_different_price = 1) or (:custom_price is not null) ) then
    IS_CUSTOM_PRICE = 1;
  else
    IS_CUSTOM_PRICE = 0;

  execute procedure RES_GET_PRICE$INT(:rd_dbkey, 'SECURITY')
  returning_values  :room_price, :room_currency, :room_price_details,
                    :deposit_required, :deposit_required_currency;

  execute procedure RES_GET_BALLANCE$INT(:id_reserv_detail)
  returning_values  :balance, :recieved_deposits, :has_charges, :open_charges, :open_deposit;

  execute procedure RES_GET_STATIC_DATA$INT(:rd_dbkey)
  returning_values  :arrival_date, :departure_date, :voucher_num, :voucher_date,
                    :voucher_text, :voucher2_num, :voucher2_date, :transfer_in_time,
                    :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :is_late_departure, :code_first_food;

  execute procedure RES_GET_DYNAMIC_DATA$INT(:rd_dbkey, 1)
  returning_values  :id_res_room_type, :id_room_type, :id_room, :id_board,
                    :id_tariff, :packet_item_ids, :room_name, :room_history, :tar_room_type, :virtual_room;

  execute procedure RES_GET_GUEST_DATA$INT('DETAIL', :id_reserv_detail)
  returning_values  :board_names, :tariff_names, :packet_names, :voucher_render;

  execute procedure RES_GET_GUEST_DATA2$INT(:id_reserv_detail)
  returning_values  :has_guest_list, :countries, :transfer_render, :code_first_food_render;

  execute procedure RES_GET_ATTENTION_STATUS$INT(:arrival_date, :departure_date, :check_status, :id_hotel)
  returning_values  :attention_status;

  execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'RENDER', null)
  returning_values  :in_share, :shared_resvations, :shares_preview;
  if (:IN_SHARE = 1) then ROOM_NAME = coalesce(:ROOM_NAME, :virtual_room);

  annul_status = :is_anul;
  if (:reason_of_anul = 'EXPIRE') then annul_status = 2;
  execute procedure sys_dbg('res RES_LOAD comming_kind = '||coalesce(:comming_kind, 'null'));

  ROOM_PRIVATE_STATUS = 0;
  select cast(1 as smallint)
  from   SYSTEM_DATE_GET (:ID_HOTEL) sd
         join ROOM_MAGIC rm on rm.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                               and rm.ROOM_STATUS = 'PRIVATE'
                               and rm.BUSY_DATE = mindate(maxdate(:ARRIVAL_DATE, sd.SYSTEM_DATE), coalesce(:earlycheckout_date, :DEPARTURE_DATE) - 1)
  into   :ROOM_PRIVATE_STATUS;

  suspend;
end
^

/* Alter (EXPORT_BOOKING$EXC) */
ALTER PROCEDURE EXPORT_BOOKING$EXC(BOOKING_ID INTEGER)
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20,
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_ID INTEGER,
IS_GUEST_ARRANGER INTEGER,
POSTING_ROUTING VARCHAR(20),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IS_DIFFERENT_TARIFF SMALLINT,
IS_DIFFERENT_BOARD SMALLINT,
IS_CUSTOM_PRICE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
EXC_LOCAL_VERSION BIGINT,
EXC_REMOTE_VERSION BIGINT,
CREATE_DATETIME TIMESTAMP,
EATING_OBJECT VARCHAR(50),
CHECK_OUT_KIND SMALLINT,
EARLYCHECKOUT_DATE DATE)
 AS
declare variable arrival_type_code smallint;
BEGIN
  number = null;
  select h.hotel_name, b.number, bei.confirmation_number, bei.cancelation_number,
        bs.status, rg.id_reserv_group, rg.group_name, rg.uuid, b.is_vip, b.arrival_date, b.comming_kind,
        b.departure_date, b.is_late_departure, b.transfer_in_time, b.transfer_in_note,
        b.transfer_out_time, b.transfer_out_note, rt.type_room, board.name,
        b.room_features, b.i_special_treatment, hk.plan_name, r.tarifa_name, b.custom_price, b.custom_currency,
        b.deposit_required, b.deposit_required_currency, apt.payment_type, ppt.payment_type,
        b.voucher_num, b.voucher_date, b.voucher_text, ms.segment_name, sc.description,
        cc.description, hr.description, cr.description, b.note, b.note_reminders,
        b.code_first_food, ap.id_profile, isperson.id_profile as is_guest_arranger,
        b.acc_routing, b.is_different_room_type, b.is_different_stay_type, b.is_different_tariff,
        b.is_different_board, b.is_custom_price, b.is_different_price, bei.split_on_checkin,
        gp.name, b.block_cc, bei.guarantee_deposit_percent, bei.guarantee_deposit_nights,
        bei.guarantee_due_days_bef_arrival, bei.guarantee_due_days_after_create, bx.minibar_rights,
        bx.paytv_rights, bx.video_rights, bx.nopost_pms, bx.phone_rights, bx.seminar_cahnnel_rights,
        bei.posting_transaction_uuid, bei.exc_local_version, bei.exc_remote_version, bei.create_datetime,
        eo.name, bei.check_out_kind, bei.earlycheckout_date
  from  RES_LOAD(:booking_id) b
        join reserv_detail bei on bei.id_reserv_detail = :booking_id
        join HOTEL h on h.id_hotel = b.id_hotel
        join export_booking_status$exc(b.check_status, b.annul_status) bs on 1=1
        left outer join RESERV_GROUP RG on RG.ID_RESERV_GROUP = b.ID_GROUP
        join room_types rt on rt.id_room_type = b.id_res_room_type
        left outer join hk_plan hk on hk.id_plan = b.id_hk_plan
        join tarifa r on r.id_tarifa = b.id_tariff
        left outer join payment_type apt on apt.id_payment_type = b.id_agent_payment
        left outer join payment_type ppt on ppt.id_payment_type = b.id_person_payment
        left outer join nom_market_segments ms on ms.id_nom_market_segment = b.id_nom_market_segment
        left outer join nom_source_codes sc on sc.id_nom_source_code = b.id_nom_source_code
        left outer join nom_channel_codes cc on cc.id_nom_channel_code = b.id_nom_channel_code
        left outer join nom_hear_reasons hr on hr.id_nom_hear_reason = b.id_nom_hear_reason
        left outer join nom_come_reasons cr on cr.id_nom_come_reason = b.id_nom_come_reason
        left outer join profile ap on ap.id_profile = b.id_agent_profile
        left outer join profile_person isperson on isperson.id_profile = b.id_agent_profile
        left outer join meals board on board.ID_BOARD = bei.ID_BOARD
        left outer join guarantee_policy gp on gp.id_guarantee_policy=b.id_guarantee_policy
        left outer join reserv_detail_external bx on bx.id_reserv_detail = :booking_id
        left outer join eating_object eo on eo.id_eating_object = b.id_eating_object
  into  :hotel,
        :number,
        :confirmation_number,
        :cancelation_number,
        :status,
        :group_id,
        :group_name,
        :group_uuid,
        :is_vip,
        :arrival,
        :arrival_type_code,
        :departure,
        :is_late_departure,
        :transfer_in_time,
        :transfer_in_note,
        :transfer_out_time,
        :transfer_out_note,
        :room_type,
        :board,
        :room_preferences,
        :special_treatment,
        :maintance_shema,
        :rate,
        :manual_price,
        :manual_price_currency,
        :deposit_required,
        :deposit_required_currency,
        :arranger_payment_type,
        :guest_payment_type,
        :voucher,
        :voucher_date,
        :voucher_text,
        :marketing_segment,
        :marketing_source_code,
        :marketing_channel_code,
        :marketing_hear_reason,
        :marketing_come_reason,
        :note,
        :note_reminders,
        :first_food,
        :arranger_profile_id,
        :is_guest_arranger,
        :posting_routing,
        :is_different_room_type,
        :is_different_stay_type,
        :is_different_tariff,
        :is_different_board,
        :is_custom_price,
        :is_different_price,
        :split_on_checkin,
        :guarantee_policy,
        :block_cc,
        :guarantee_deposit_percent,
        :guarantee_deposit_nights,
        :guarantee_due_days_bef_arrival,
        :guarantee_due_days_after_create,
        :minibar_rights,
        :paytv_rights,
        :video_rights,
        :nopost_pms,
        :phone_rights,
        :seminar_cahnnel_rights,
        :posting_transaction_uuid,
        :exc_local_version,
        :exc_remote_version,
        :create_datetime,
        :eating_object,
        :check_out_kind,
        :earlycheckout_date;

  if (:number is not null) then begin -- Check if we have export
    arrival_type = null;
    if (0 = :arrival_type_code) then begin
      arrival_type = 'early';
    end else if (2 = :arrival_type_code) then begin
      arrival_type = 'late';
    end
    suspend;
  end
END
^

/* Alter (EXPORT_BOOKING$RSV) */
ALTER PROCEDURE EXPORT_BOOKING$RSV(DATA_RANGE VARCHAR(50))
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20,
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_NAME VARCHAR(100),
POSTING_ROUTING VARCHAR(20),
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER)
 AS
BEGIN
  for select EB.HOTEL,
             EB.NUMBER, 
             EB.CONFIRMATION_NUMBER, 
             EB.CANCELATION_NUMBER,
             EB.STATUS, 
             EB.GROUP_ID, 
             EB.GROUP_NAME, 
             EB.IS_VIP,
             EB.ARRIVAL, 
             EB.ARRIVAL_TYPE, 
             EB.DEPARTURE, 
             EB.IS_LATE_DEPARTURE, 
             EB.TRANSFER_IN_TIME, 
             EB.TRANSFER_IN_NOTE, 
             EB.TRANSFER_OUT_TIME, 
             EB.TRANSFER_OUT_NOTE, 
             EB.ROOM_TYPE, 
             EB.BOARD, 
             EB.ROOM_PREFERENCES,
             EB.SPECIAL_TREATMENT, 
             EB.MAINTANCE_SHEMA, 
             EB.RATE, 
             EB.MANUAL_PRICE, 
             EB.MANUAL_PRICE_CURRENCY, 
             EB.DEPOSIT_REQUIRED, 
             EB.DEPOSIT_REQUIRED_CURRENCY, 
             EB.ARRANGER_PAYMENT_TYPE, 
             EB.GUEST_PAYMENT_TYPE, 
             EB.VOUCHER, 
             EB.VOUCHER_DATE, 
             EB.VOUCHER_TEXT, 
             EB.MARKETING_SEGMENT, 
             EB.MARKETING_SOURCE_CODE, 
             EB.MARKETING_CHANNEL_CODE, 
             EB.MARKETING_HEAR_REASON, 
             EB.MARKETING_COME_REASON, 
             EB.NOTE, 
             EB.NOTE_REMINDERS, 
             EB.FIRST_FOOD, 
             P.PROFILE_NAME,
             EB.POSTING_ROUTING, 
             EB.SPLIT_ON_CHECKIN, 
             EB.GUARANTEE_POLICY, 
             EB.GUARANTEE_DEPOSIT_PERCENT, 
             EB.GUARANTEE_DEPOSIT_NIGHTS, 
             EB.GUARANTEE_DUE_DAYS_BEF_ARRIVAL, 
             EB.GUARANTEE_DUE_DAYS_AFTER_CREATE
  from TMP_IDS ids
       left outer join EXPORT_BOOKING$EXC(ids.ID) EB on 1=1
       left outer join PROFILE P on P.ID_PROFILE = EB.ARRANGER_PROFILE_ID
  where ids.CONTEXT = :data_range
  into :hotel,
       :number, 
       :confirmation_number, 
       :cancelation_number,
       :status,
       :group_id, 
       :group_name, 
       :is_vip,
       :arrival, 
       :arrival_type, 
       :departure, 
       :is_late_departure, 
       :transfer_in_time, 
       :transfer_in_note, 
       :transfer_out_time, 
       :transfer_out_note, 
       :room_type, 
       :board, 
       :room_preferences,
       :special_treatment, 
       :maintance_shema, 
       :rate, 
       :manual_price, 
       :manual_price_currency, 
       :deposit_required, 
       :deposit_required_currency, 
       :arranger_payment_type, 
       :guest_payment_type, 
       :voucher, 
       :voucher_date, 
       :voucher_text, 
       :marketing_segment, 
       :marketing_source_code, 
       :marketing_channel_code, 
       :marketing_hear_reason, 
       :marketing_come_reason, 
       :note, 
       :note_reminders, 
       :first_food, 
       :arranger_profile_name,
       :posting_routing, 
       :split_on_checkin, 
       :guarantee_policy, 
       :guarantee_deposit_percent, 
       :guarantee_deposit_nights, 
       :guarantee_due_days_bef_arrival, 
       :guarantee_due_days_after_create
  do suspend;
END
^

/* Alter (EXPORT_DOCUMENT) */
ALTER PROCEDURE EXPORT_DOCUMENT(FROM_DATE DATE,
TO_DATE DATE,
DOC_TAG VARCHAR(20),
PAY_TAG VARCHAR(20),
NO_PAY_DOCS VARCHAR(20),
GROUP_TAG VARCHAR(20),
ID_HOTEL INTEGER = null,
RETURN_CLIENT_PERSON_ID SMALLINT = 0)
 RETURNS(DOC_TYPE_ID INTEGER,
DOC_SUB_TYPE SMALLINT,
DOC_TYPE_NAME VARCHAR(50),
DOC_DATE DATE,
DOC_FOR_DEPOSIT SMALLINT,
TAX_EVENT_DATE DATE,
DIFF_VAT_REASON VARCHAR(254),
DOC_NUM VARCHAR(20),
DOC_CURRENCY CHAR(3),
DOC_RATE NUMERIC(15,4),
DOC_IS_STORNED SMALLINT,
DOC_IS_STORNO SMALLINT,
DOC_ID_BASE_DOC INTEGER,
DOC_EXPORT_TAG VARCHAR(20),
DOC_SEND_NAME VARCHAR(100),
DOC_DOGOVOR_NUM VARCHAR(30),
DOC_NOTE VARCHAR(100),
DOC_SUPPLIER_ID INTEGER,
CLT_ID INTEGER,
CLT_NAME VARCHAR(100),
CLT_VAT_REG_NUM VARCHAR(30),
CLT_IDENT_NO VARCHAR(30),
CLT_MOL VARCHAR(100),
CLT_ADDRESS VARCHAR(100),
CLT_COUNTRY_CODE VARCHAR(10),
CLT_ZIP_CODE VARCHAR(10),
CLT_RECIEVE_NAME VARCHAR(100),
PAY_TYPE_ID INTEGER,
PAY_TYPE VARCHAR(20),
PAY_CURRENCY CHAR(3),
PAY_VALUE NUMERIC(15,4),
PAY_RATE NUMERIC(15,6),
PAY_CC_NAME VARCHAR(50),
PAY_CC_NUM VARCHAR(50),
PAY_CC_BANK VARCHAR(50),
PAY_EXPORT_TAG VARCHAR(20),
LINE_ID INTEGER,
LINE_NAME VARCHAR(50),
LINE_WOT_VAT NUMERIC(15,4),
LINE_VAT_FREE NUMERIC(15,4),
LINE_VAT_BASE NUMERIC(15,4),
LINE_VAT NUMERIC(15,4),
VAT_VALUE NUMERIC(15,4),
ID_VAT_GROUP INTEGER,
ID_SALE_TAXATION INTEGER,
LINE_QTY NUMERIC(15,4),
ACC_NO VARCHAR(30),
POSITION_NO INTEGER)
 AS
declare variable id_doc_head integer;
  declare variable doc_grand_total numeric(15,4);
  declare variable pay_coeficient double precision;
  declare variable value_corr_idx numeric(15,2);
  declare variable doc_total numeric(15,2);
  declare variable doc_rate_int numeric(15,4);
  declare variable curr_sel varchar(10);
  declare variable delim_pos integer;
begin
  /*  Description:
  ||
  */

  POSITION_NO = 1;
  delim_pos = strpos(';', :GROUP_TAG);
  if (:delim_pos > 0) then begin
    curr_sel = substring(:GROUP_TAG from :delim_pos + 1 for char_length(:group_tag) - :delim_pos);
    GROUP_TAG = substring(:GROUP_TAG from 1 for :delim_pos - 1);
  end

  for
    select DH.ID_DOC, DH.DOC_TYPE_NAME, DH.REAL_DOC_DATE, DH.DOC_NUM,
           coalesce(DD.ID_CONTRAGENT, iif(:RETURN_CLIENT_PERSON_ID = 1, 1000000000 + a.ID_PROFILE, null)),
           DH.ID_DOC_TYPE, DH.DOC_RATE, DD.CONTRAGENT_NAME, DD.VAT_REG_NUM, DD.IDENT_NO,
           DD.MOL, DD.POST_ADDRESS, DD.COUNTRY_CODE, DD.ZIP_CODE,
           DS.SEND_NAME, DD.RECIPIENT_NAME, DH.DESCRIPTION, DD.NUM_DOGOVOR,
           DH.DOC_VALUE_A, DH.DOC_CURRENCY, DH.ID_BASE_DOC,
           DH.IS_STORNED, DH.IS_STORNO,
           case when D.DOC_SUB_TYPE = 2 then DI.CREDIT_EXPORT_TAG
                when D.DOC_SUB_TYPE = 1 then DI.DEBIT_EXPORT_TAG
                else DT.EXPORT_TAG
           end as EXPORT_TAG, DH.TAX_EVENT_DATE, DH.DIFF_VAT_REASON,
           DH.FOR_DEPOSIT,
           iif(dh.ANNULMENT_DATE between :from_date and :to_date /*and dh.VALUE_CORR_IDX = 1*/, 0, DH.VALUE_CORR_IDX) as VALUE_CORR_IDX,
           D.DOC_SUB_TYPE, DS.ID_DOC_SUPPLIER, DH.DOC_VALUE_A
    from   DOCUMENT_RELEASE DH
           join DOC_CONTRAGENT DD on DD.ID_DOC_CONTRAGENT = DH.ID_DOC_CONTRAGENT
           join DOC_SUPPLIER DS on DS.ID_DOC_SUPPLIER = DH.ID_DOC_SUPPLIER
           join DOC_TYPE DT on DT.ID_DOC_TYPE = DH.ID_DOC_TYPE
           join DOC_TYPE_INV DI on DI.ID_DOC_TYPE = DT.ID_DOC_TYPE
           join DOC_HEAD D on D.ID_DOC = DH.ID_DOC
           join ACCOUNT A on A.ID_ACCOUNT = DH.ID_ACCOUNT
    where  DH.RPT_DOC_DATE between :from_date and :to_date
           and ((upper(:doc_tag) = 'ALL') or (coalesce(DI.ANNUL_EXPORT_TAG, DT.EXPORT_TAG) = :doc_tag))
           --and DH.IS_ANNUL_ON_DATE = 0
           and ((:ID_HOTEL is null) or (A.ID_HOTEL = :ID_HOTEL))
           and not (dh.REAL_DOC_DATE between :from_date and :to_date
                    and dh.ANNULMENT_DATE between :from_date and :to_date
                    and dh.VALUE_CORR_IDX = -1)  -- skip annul records into same period
    into   :id_doc_head, :doc_type_name, :doc_date, :doc_num, :clt_id,
           :doc_type_id, :doc_rate, :clt_name, :clt_vat_reg_num, :clt_ident_no,
           :clt_mol, :clt_address, :clt_country_code, :clt_zip_code,
           :doc_send_name, :clt_recieve_name, :doc_note, :doc_dogovor_num,
           :doc_grand_total, :doc_currency, :doc_id_base_doc,
           :doc_is_storned, :doc_is_storno, :doc_export_tag, :tax_event_date, :diff_vat_reason,
           :DOC_FOR_DEPOSIT, :value_corr_idx, :doc_sub_type, :doc_supplier_id, :doc_total
  do begin
    if (:curr_sel = 'ORIG') then doc_rate_int = 1; else doc_rate_int = :DOC_RATE;
    /****************************************/
    if (upper(:group_tag) = 'DOC_TOTAL') then begin
      line_vat_free = null;
      line_vat_base = null;
      line_vat = null;
      doc_total = null;

      select sum(dt.NONTAXABLE_VALUE), sum(dt.TAXABLE_VALUE), sum(dt.TAX_VALUE), min(dt.ID_SALE_TAX)
      from   DOC_TAXES DT
      where  DT.ID_DOC_HEAD = :id_doc_head
      into   :LINE_VAT_FREE, :LINE_VAT_BASE, :LINE_VAT, :ID_VAT_GROUP;
      line_vat_free = coalesce(:line_vat_free, 0) * :value_corr_idx;
      line_vat_base = coalesce(:line_vat_base, 0) * :value_corr_idx;
      line_vat = coalesce(:line_vat, 0) * :value_corr_idx;
      doc_total = coalesce(:doc_total, 0)* :value_corr_idx;

      select st.TAX_PERCENT
      from   SALE_TAXES ST
      where  ST.ID_SALE_TAX = :ID_VAT_GROUP
      into   :VAT_VALUE;
       
      LINE_WOT_VAT = (:LINE_VAT_BASE + :LINE_VAT_FREE) * :value_corr_idx; /*:doc_total - :LINE_VAT;*/
      LINE_ID = :id_doc_head;
      LINE_NAME = '';
      LINE_QTY = 1;
      ACC_NO = '';

      select   first 1 EDP.PAY_TYPE_ID, EDP.PAY_TYPE, EDP.PAY_CURRENCY, EDP.PAY_RATE, EDP.PAY_VALUE,
               EDP.PAY_CC_NUM, EDP.PAY_CC_NAME, EDP.PAY_CC_BANK, EDP.PAY_COEFICIENT, EDP.EXPORT_TAG
      from     EXPORT_DOCUMENT_PAYMENT(:id_doc_head, :pay_tag, :no_pay_docs, :doc_currency,
                                       :doc_id_base_doc, :doc_grand_total) EDP
      into     :pay_type_id, :pay_type, :pay_currency, :pay_rate, :pay_value,
               :pay_cc_num, :pay_cc_name, :pay_cc_bank, :pay_coeficient, :pay_export_tag;

      PAY_VALUE = :PAY_VALUE * :value_corr_idx;
      suspend;
      POSITION_NO = :POSITION_NO + 1;
    end else if (upper(:group_tag) = 'TAXES') then begin
      ID_SALE_TAXATION = null;
      POSITION_NO = 1;
      for
        select dt.TAX_NAME, 1, dt.ID_SALE_TAX,
               (dt.TAXABLE_VALUE + dt.NONTAXABLE_VALUE) * :value_corr_idx,
               dt.NONTAXABLE_VALUE * :value_corr_idx,
               dt.TAXABLE_VALUE * :value_corr_idx,
               dt.TAX_VALUE * :value_corr_idx,
               dt.TAX_PERCENT, st.ACCOUNT_NAME, dt.ID_SALE_TAX
        from   DOC_TAXES dt
               join SALE_TAXES st on st.ID_SALE_TAX = dt.ID_SALE_TAX
        where  dt.ID_DOC_HEAD = :ID_DOC_HEAD
        into   :line_name, :line_qty, :LINE_ID, :line_wot_vat, :line_vat_free, :line_vat_base,
               :line_vat, :vat_value, :acc_no, :id_vat_group
      do begin
      
        suspend;
        POSITION_NO = :POSITION_NO + 1;
      end 
    end else begin
      LINE_VAT_BASE = null;
      LINE_VAT_FREE = null;
      ID_VAT_GROUP = null;
      for
        select   EDP.PAY_TYPE_ID, EDP.PAY_TYPE, EDP.PAY_CURRENCY, EDP.PAY_RATE, EDP.PAY_VALUE,
                 EDP.PAY_CC_NUM, EDP.PAY_CC_NAME, EDP.PAY_CC_BANK, EDP.PAY_COEFICIENT, EDP.EXPORT_TAG
        from     EXPORT_DOCUMENT_PAYMENT(:id_doc_head, :pay_tag, :no_pay_docs, :doc_currency,
                                         :doc_id_base_doc, :doc_grand_total) EDP
        into     :pay_type_id, :pay_type, :pay_currency, :pay_rate, :pay_value,
                 :pay_cc_num, :pay_cc_name, :pay_cc_bank, :pay_coeficient, :pay_export_tag
      do begin
        PAY_VALUE = :PAY_VALUE * :value_corr_idx;
        for
          select EDL.LINE_ID, EDL.LINE_NAME, EDL.LINE_WOT_TAX, EDL.LINE_TAX, EDL.LINE_QTY,
                 EDL.ACC_NO, EDL.TAX_PERCENT, EDL.POSITION_NO, EDL.ID_SALE_TAXATION
          from   EXPORT_DOCUMENT_LINES(:id_doc_head, :group_tag, :pay_coeficient, :doc_rate_int) EDL
          into   :line_id, :line_name, :line_wot_vat, :line_vat, :line_qty,
                 :acc_no, :vat_value, :POSITION_NO, :ID_SALE_TAXATION
        do begin
          LINE_WOT_VAT = :LINE_WOT_VAT * :value_corr_idx;
          LINE_VAT = :LINE_VAT * :value_corr_idx;
          select min(st.ID_SALE_TAX)
          from   SALE_TAXATION_TAX ST
                 join SALE_TAXES t on t.ID_SALE_TAX = st.ID_SALE_TAX
          where  ST.ID_SALE_TAXATION = :ID_SALE_TAXATION
                 and t.REVENUE_DEDUCTION_TAX is distinct from 1
          having count(st.ID_SALE_TAX) = 1
          into   :ID_VAT_GROUP;

          suspend;
        end
      end
    end
  end
end
^

/* Alter (IMPORT_ACCOUNT$EXC) */
ALTER PROCEDURE IMPORT_ACCOUNT$EXC(ACCOUNT_NAME VARCHAR(50),
ACCOUNT_CURR VARCHAR(3),
IS_CREDIT_ACCOUNT SMALLINT,
CREDIT_LIMIT NUMERIC(15,4),
PAYMENT_TYPE VARCHAR(20),
NOTE VARCHAR(255),
IS_BLOCKED SMALLINT,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE SMALLINT,
IS_EXTRA SMALLINT,
IS_ALOWED_POS_INTERFACE SMALLINT,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
IS_DEFAULT SMALLINT,
HOTEL_NAME VARCHAR(50))
 RETURNS(ID_ACCOUNT INTEGER)
 AS
declare variable id_hotel integer;
declare variable id_payment_type integer;
declare variable id_profile integer;
declare variable id_tax_policy integer;
declare variable id_acc_template integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'ACCOUNT', :ACCOUNT_NAME)
  returning_values :ID_HOTEL;

  execute procedure LOOKUP_PAYMENT_TYPE$EXC(:ID_HOTEL, :ACCOUNT_NAME, 'ACCOUNT', :PAYMENT_TYPE)
  returning_values :ID_PAYMENT_TYPE;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:ACCOUNT_NAME, 'ACCOUNT');

  execute procedure LOOKUP_ACCOUNT$EXC(:ID_HOTEL, :ACCOUNT_NAME)
  returning_values :ID_ACCOUNT;

  select ph.ID_PROFILE
  from   PROFILE_HOUSE ph
  where  ph.HOUSE_TYPE = 'hptComplimentary'
  into   :id_profile;

  select sv.SETTING_VALUE
  from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :ID_HOTEL) sv
  into   :id_acc_template;

  select ac.ID_TAX_POLICY
  from   ACC_TEMPLATE ac
  where  ac.ID_ACC_TEMPLATE = :id_acc_template
  into   :id_tax_policy;

  if (:ID_ACCOUNT is null) then begin
    execute procedure ACCOUNT_MODIFY$INT(null, :ID_PROFILE, :ACCOUNT_CURR, :ACCOUNT_NAME,
      :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT, :ID_PAYMENT_TYPE, :NOTE, :IS_BLOCKED, :BLOCK_TEXT,
      :SECURITY_LEVEL, :IS_BASE, :IS_EXTRA, :IS_ALOWED_POS_INTERFACE, :POS_INTERFACE_NOTE,
      :EXT_CODE, :ID_TAX_POLICY, :IS_DEFAULT, :ID_HOTEL, null, 0, 'add')
    returning_values :ID_ACCOUNT;
  end
end
^

/* Alter (IMPORT_BOOKING_FINALIZE$EXC) */
ALTER PROCEDURE IMPORT_BOOKING_FINALIZE$EXC(BOOKING_ID INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1,
STATUS VARCHAR(50) = null,
CONFIRMATION_NUMBER NAME_20 = null,
CANCELATION_NUMBER NAME_20 = null)
 RETURNS(RECORD_TIMESTAMP TIMESTAMP,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable booking_db_key char(8);
  declare variable dummy_int integer;
  declare variable dummy_text varchar(255) ;
  declare variable res_id_room integer;
  declare variable id_room integer;
  declare variable id_room_type integer;
  declare variable id_hotel integer;
  declare variable system_date date;
  declare variable from_date date;
  declare variable gs_dbkey char(8);
begin
  ERR_CODE=0;
  ERR_TEXT=null;
  id_room = null;
  force_res_finalize = coalesce(:force_res_finalize, 1);

  execute procedure sys_dbg('exc IMPORT_BOOKING_FINALIZE$EXC => CLEAR_ORPHAN_GUESTS$EXC');
  execute procedure CLEAR_ORPHAN_GUESTS$EXC(:booking_id);

  select b.rdb$db_key, b.ID_ROOM, b.ID_ROOM_TYPE, b.ID_HOTEL, b.FROM_DATE
  from   reserv_detail b
  where  b.id_reserv_detail = :booking_id
  into   :booking_db_key, :res_id_room, :id_room_type, :id_hotel, :from_date;

  execute procedure RES_GUEST_SAVE_DIFF$INT(:booking_db_key);

  if (:res_id_room < 0) then begin
    select sd.SYSTEM_DATE
    from   SYSTEM_DATE_GET (:id_hotel) sd
    into   :system_date;

    select ro.ID_ROOM, ro.ID_ROOM_TYPE
    from   RES_OCCUPANCY_ROOM$INT (:BOOKING_ID, maxdate(:system_date, :from_date), null, :id_room_type) ro
    into   :id_room, :id_room_type;

--    has_different_room_type = null;
    if (:id_room <> :res_id_room) then begin
      for
        select gs.RDB$DB_KEY
        from   GUEST_STAY GS
               join GUEST G on g.ID_GUEST = gs.ID_GUEST
        where  g.ID_RESERV_DETAIL = :BOOKING_ID
               and gs.FOR_DATE >= maxdate(:system_date, :from_date)
               and gs.ID_ROOM <> :id_room
        into   :gs_dbkey
      do begin
        update GUEST_STAY gsu
        set    gsu.ID_ROOM = :id_room
               --gsu.ID_ROOM_TYPE = iif (gsu.ID_ROOM_TYPE = -1, :id_room_type, gsu.ID_ROOM_TYPE)
        where  gsu.RDB$DB_KEY = :gs_dbkey;
        --has_different_room_type = 1;
      end

      update GUEST G
      set    G.ID_ROOM = :id_room
      where  g.ID_RESERV_DETAIL = :BOOKING_ID;
    end
  end

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null,   --force recalculation
         rd.ID_ROOM = coalesce(:id_room, :res_id_room)
         --rd.HAS_DIFFERENT_ROOM_TYPE = coalesce(:has_different_room_type,  rd.HAS_DIFFERENT_ROOM_TYPE)
  where  rd.RDB$DB_KEY = :booking_db_key;

  if (1 = :force_res_finalize) then begin
    execute procedure sys_dbg('exc IMPORT_BOOKING_FINALIZE$EXC => RES_FINALIZE_SHAREOPTION$INT');
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:booking_db_key, 0)
    returning_values  :dummy_int, :dummy_text, :dummy_int, :dummy_int;
  end

  execute procedure APPLY_BOOKING_STATUS$EXC(
    null, :booking_db_key, :status, :confirmation_number, :cancelation_number
  );

  select b.change_time
  from   reserv_detail b
  where  b.rdb$db_key =:booking_db_key
  into   :record_timestamp;
end
^

/* Alter (IMPORT_CONTRAGENT$EXC) */
ALTER PROCEDURE IMPORT_CONTRAGENT$EXC(CONTRAGENT_NAME VARCHAR(100),
IS_JURIDICAL_PERSON SMALLINT,
IDENT_NO VARCHAR(30),
VAT_REG_NUM VARCHAR(30),
POST_ADDRESS VARCHAR(100),
ZIP_CODE VARCHAR(10),
EMAIL VARCHAR(50),
MOL VARCHAR(100),
COUNTRY_CODE VARCHAR(10),
BANK_NAME VARCHAR(50),
BIC VARCHAR(30),
IBAN VARCHAR(30),
UUID VARCHAR(40),
CREATE_ONLY SMALLINT)
 RETURNS(ID_CONTRAGENT INTEGER)
 AS
declare variable IS_INSERT smallint;
begin
  execute procedure import_mark_transaction$exc;

  ID_CONTRAGENT = null;
  select c.ID_CONTRAGENT
  from CONTRAGENTS c
  where c.uuid = :UUID and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :ID_CONTRAGENT;

  /* FIXME - remove this fallback lookup by name (depends on the separate contragents exchange implementation)*/
  if (:ID_CONTRAGENT is null) then begin
    select c.ID_CONTRAGENT
    from CONTRAGENTS c
    where c.contragent_name = :contragent_name and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
    into :ID_CONTRAGENT;
  end

  IS_INSERT = 0;
  if (ID_CONTRAGENT is null) then begin
    IS_INSERT = 1;
  end else if (1 = :create_only) then begin
    exit;
  end

  execute procedure CONTRAGENT_MODIFY$CONTR(:ID_CONTRAGENT, :CONTRAGENT_NAME,
    :IS_JURIDICAL_PERSON, :IDENT_NO, :VAT_REG_NUM, :POST_ADDRESS, :ZIP_CODE,
    :EMAIL, :MOL, :COUNTRY_CODE, :BANK_NAME, :BIC, :IBAN)
  returning_values :ID_CONTRAGENT;

  if (IS_INSERT = 1) then begin
    update CONTRAGENTS c
      set c.UUID = :UUID
      where c.ID_CONTRAGENT = :ID_CONTRAGENT;
  end
end
^

/* empty dependent procedure body */
/* Clear: BLOCK_MODIFY$INT for: OCCUPANCY_BLOCK$INT */
ALTER PROCEDURE BLOCK_MODIFY$INT(ID_BLOCK_ROOM INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
BLOCK_GRP INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_BLOCK_ROOM INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (OCCUPANCY_BLOCK$INT) */
ALTER PROCEDURE OCCUPANCY_BLOCK$INT(B_DBKEY CHAR(8),
EDIT_STATUS VARCHAR(255))
 AS
declare variable id_reserv_detail integer;
  declare variable from_date date;
  declare variable to_date date;
  declare variable id_room integer;
  declare variable id_room_type integer;
  declare variable id_agent integer;
  declare variable country_code varchar(50);
  declare variable busy_group_type integer;
  declare variable busy_type varchar(50);
  declare variable busy_date date;
  declare variable block_type varchar(50);
  declare variable id_hotel integer;
  declare variable room_status troom_status;
begin

  select BR.ID_BLOCK_ROOM, BR.FROM_DATE, BR.TO_DATE,
         BR.ID_ROOM, R.ID_ROOM_TYPE, BR.BLOCK_GRP, BR.REASON, R.ID_HOTEL
  from   BLOCK_ROOM BR
         join ROOMS R on R.ID_ROOM = BR.ID_ROOM
  where  BR.RDB$DB_KEY = :b_dbkey
  into   :id_reserv_detail, :from_date, :to_date,
         :id_room, :id_room_type, :busy_group_type, :block_type, :id_hotel;

  id_agent = null;
  country_code = '';
  busy_type = :block_type;

  if ((:edit_status containing 'JUST_CREATED')
     or (:edit_status containing 'DATE_CHANGED')
     or (:edit_status containing 'ROOM_CHANGED'))
  then begin
    execute procedure ROOM_MAGIC_CLEAR(:id_reserv_detail);

    for
      select OUT_DATE
      from   SYSTEM_LOOP_PERIOD(:from_date, :to_date)
      into   :busy_date
    do begin
      select rp.STATUS
      from   ROOM_PERIOD$PMS rp
      where  rp.ID_ROOM = :id_room
             and rp.FROM_DATE <= :busy_date
             and rp.TO_DATE >= :busy_date
      into   :room_status;

      insert into ROOM_MAGIC(ID_ROOM_MAGIC, BUSY_DATE, ID_ROOM, ID_ROOM_TYPE, DAY_ACTION_INT, ID_HOTEL,
             BUSY_GROUP_TYPE, ID_AGENT, BUSY_TYPE, COUNTRY, ID_RESERV_DETAIL, ROOM_STATUS)
      values (gen_id(g_auto_inc_rooms_magic, 1), :busy_date, :id_room, :id_room_type, 0, :id_hotel,
             :busy_group_type, :id_agent, :busy_type, :country_code, :id_reserv_detail, :room_status);
    end
  end else begin
    update ROOM_MAGIC RMU
    set    RMU.BUSY_TYPE = :busy_type,
           RMU.ID_ROOM_TYPE = :id_room_type
    where  RMU.ID_RESERV_DETAIL = :id_reserv_detail;
  end
end
^

/* empty dependent procedure body */
/* Clear: PMS_IMPORT$INT for: PMS_EVENT_POST$INT */
ALTER PROCEDURE PMS_IMPORT$INT(ID_EXPORT_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_EVENT_POST$INT) */
ALTER PROCEDURE PMS_EVENT_POST$INT(ID_PMS_EVENT INTEGER,
ID_ROOM_CONTRACT INTEGER,
ID_RENTAL_POOL INTEGER,
POST_DATE DATE,
PRICE_WITH_VAT NUMERIC(15,4),
PRICE_WO_VAT NUMERIC(15,4),
CURR VARCHAR(3),
MAX_ADULT_CNT INTEGER,
STAY INTEGER,
BED_NIGHT_CNT INTEGER,
BOOKING_CNT INTEGER,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL INTEGER)
 AS
declare variable ownership_percent numeric(15,4);
  declare variable id_owner integer;
  declare variable contract_type varchar(50);
  declare variable posted_orig_value numeric(15,4);
  declare variable posted_orig_curr varchar(3);
  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable owner_use smallint;
  declare variable price_to_post numeric(15,4);
  declare variable id_owner_post_to integer;
  declare variable reserv_no varchar(62);
  declare variable sub_contract varchar(10);
begin
  id_owner_post_to = null;
  owner_use = 0;

  select RD.ID_AGENT_PROFILE, RD.ID_PERSON_PROFILE, iif(RD.ACC_ROUTING = 'OWNER', 1, 0), rd.NUMBER
  from   RESERV_DETAIL RD                      
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :id_agent_profile, :id_person_profile, :owner_use, :reserv_no;

  /* if RESERV_DETAIL.ACC_ROUTING = 'OWNER', ediniqt profil w reserv. e garantirano owner
     pyrwo se prowerqwa dali id_agent_profile e owner, ako ne e se wzema person_profile */

  if (:owner_use = 1) then begin
    /* ako reserv. e owner-ska, ne se generirat prihodi, a razhodite otiwat po smetkata na gosta, a ne na sobstwenicite
     gosta se tyrsi w posledowatelnost ID_AGENT_PROFILE, ID_PERSON_PROFILE*/
    if ( exists ( select p.ID_ROOM
                  from   ROOM_PERIOD$PMS P
                         join ROOM_CONTRACT$PMS C on C.ID_ROOM_PERIOD = P.ID_ROOM_PERIOD
                         join ROOM_OWNER$PMS O on O.ID_ROOM_CONTRACT = C.ID_ROOM_CONTRACT
                  where  O.ID_OWNER = :id_agent_profile
                         and :POST_DATE between P.FROM_DATE and P.TO_DATE  ) ) then
    begin
      --prowerka dali kym momenta(post_date) ima aktiwen dogowor
      id_owner_post_to = :id_agent_profile;
    end else if ( exists ( select p.ID_ROOM
                      from   ROOM_PERIOD$PMS P
                             join ROOM_CONTRACT$PMS C on C.ID_ROOM_PERIOD = P.ID_ROOM_PERIOD
                             join ROOM_OWNER$PMS O on O.ID_ROOM_CONTRACT = C.ID_ROOM_CONTRACT
                      where  O.ID_OWNER = :id_person_profile
                             and :POST_DATE between P.FROM_DATE and P.TO_DATE  ) ) then
    begin
      id_owner_post_to = :id_person_profile;
    end

    if (:id_owner_post_to is null) then begin
      exception PMS_EXCEPTION '-616' || f_character(31) || f_character(29) ||:POST_DATE|| f_character(28) ||:reserv_no;
    end
  end

  for
    select RO.OWNERSHIP_PERCENT,
           RO.ID_OWNER,
           iif(RC.IMPORT_INCOME_WITH_VAT = 1, :price_with_vat, :price_wo_vat),
           RC.CONTRACT_TYPE
    from   ROOM_CONTRACT$PMS RC
           join ROOM_OWNER$PMS RO on RO.ID_ROOM_CONTRACT = RC.ID_ROOM_CONTRACT
    where  RC.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
    into   :ownership_percent,
           :id_owner,
           :price_to_post,
           :contract_type
  do begin
    if (:owner_use = 1) then begin
      /*    za sobstwenik ne se poddyrjat prihodi!    */
      sub_contract = 'OWNER_USE';
      posted_orig_value = :price_to_post;
      posted_orig_curr = :curr;
      execute procedure CONTRACT_EXPENSE_POST$INT(:ID_PMS_EVENT, :ID_HOTEL, :ID_ROOM_CONTRACT, :sub_contract,
              :id_owner_post_to, :ownership_percent, null, :posted_orig_value, :posted_orig_curr, :POST_DATE,
              :stay, :max_adult_cnt, :BED_NIGHT_CNT, :BOOKING_CNT);
    end else begin
      sub_contract = 'GUEST_USE';
      execute procedure CONTRACT_MANAGEMENT_POST$INT(:ID_PMS_EVENT, :ID_ROOM_CONTRACT, :sub_contract,
              :contract_type, :ID_OWNER, :ID_RENTAL_POOL, :price_to_post, :curr, :POST_DATE, :stay, :ownership_percent)
      returning_values  (:posted_orig_value, :posted_orig_curr);
      if (:posted_orig_curr is null) then begin
        posted_orig_value = :price_to_post;
        posted_orig_curr = :curr;
      end
      execute procedure CONTRACT_EXPENSE_POST$INT(:ID_PMS_EVENT, :ID_HOTEL, :ID_ROOM_CONTRACT, :sub_contract,
              :ID_OWNER, :ownership_percent, :ID_RENTAL_POOL, :posted_orig_value, :posted_orig_curr, :POST_DATE,
              :stay, :max_adult_cnt, :BED_NIGHT_CNT, :BOOKING_CNT);
    end


    begin -- SHADOW ACCOUNT POSTING
      sub_contract = 'SHADOW_ACC';
      /* da ne se nachislqwa, ako e USE_OWNER_CONTRACT = 1 */
      if (:owner_use = 0) then begin
        execute procedure CONTRACT_MANAGEMENT_POST$INT(:ID_PMS_EVENT, :ID_ROOM_CONTRACT, :sub_contract,
                :contract_type, :ID_OWNER, :ID_RENTAL_POOL, :price_to_post, :curr, :POST_DATE, :stay, :ownership_percent)
        returning_values  (:posted_orig_value, :posted_orig_curr);
        if (:posted_orig_curr is null) then begin
          posted_orig_value = :price_to_post;
          posted_orig_curr = :curr;
        end
      end else begin
        posted_orig_value = :price_to_post;
        posted_orig_curr = :curr;
      end
  
      execute procedure CONTRACT_EXPENSE_POST$INT(:ID_PMS_EVENT, :ID_HOTEL, :ID_ROOM_CONTRACT, :sub_contract,
              iif(:owner_use = 0, :ID_OWNER, :ID_OWNER_POST_TO), :ownership_percent,
              iif(:owner_use = 0, :ID_RENTAL_POOL, null), :posted_orig_value, :posted_orig_curr, :POST_DATE,
              :stay, :max_adult_cnt, :BED_NIGHT_CNT, :BOOKING_CNT);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: PMS_IMPORT for: PMS_IMPORT$INT */
ALTER PROCEDURE PMS_IMPORT(ID_EXPORT_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_IMPORT$INT) */
ALTER PROCEDURE PMS_IMPORT$INT(ID_EXPORT_HEAD INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_room_contract integer;
  declare variable id_pms_event integer;
  declare variable imp_period_from date;
  declare variable event_price_with_vat numeric(15,4);
  declare variable event_price_wo_vat numeric(15,4);
  declare variable curr varchar(3);
  declare variable adult_count integer;
  declare variable id_rental_pool integer;
  declare variable reservs integer;
  declare variable stay integer;
  declare variable bednights integer;
  declare variable id_hotel integer;
begin
  for
    select E.ID_PMS_EVENT, E.ID_RESERV_DETAIL, E.IMP_PERIOD_FROM,
           E.CURR, r.ID_HOTEL, e.PRICE_WO_VAT, e.PRICE_WITH_VAT,
           e.RESERVS, e.STAY, e.BEDNIGHTS, rc.ID_ROOM_CONTRACT, rc.ID_RENTAL_POOL
    from   PMS_EVENT$PMS E
           join ROOMS R on R.ID_ROOM = e.ID_ROOM
           join ROOM_CONTRACT$PMS rc on rc.ID_ROOM_CONTRACT = e.ID_ROOM_CONTRACT
    where  E.ID_EXPORT_HEAD = :ID_EXPORT_HEAD
           and E.EVENT_STATUS = 11
    order by 1
    into   :id_pms_event, :id_reserv_detail, :imp_period_from,
           :curr, :id_hotel, :event_price_wo_vat, :event_price_with_vat,
           :reservs, :stay, :bednights, :id_room_contract, :id_rental_pool
  do begin
/* */
    select r.ADULT_COUNT
    from   RESERV_DETAIL r
    where  r.ID_RESERV_DETAIL = :id_reserv_detail
    into   :adult_count;

    execute procedure PMS_EVENT_POST$INT (:id_pms_event, :id_room_contract, :id_rental_pool,
            :imp_period_from, :event_price_with_vat, :event_price_wo_vat, :curr,
            :adult_count, :stay, :bednights, :reservs, :id_hotel, :id_reserv_detail);

    execute procedure PMS_EVENT_SET_ACTIVE$INT(:id_pms_event);

  end
end
^

/* empty dependent procedure body */
/* Clear: PMS_REGULAR_POST_CREATE$PMS for: PMS_INCOME_POSTING_CREATE$PMS */
ALTER PROCEDURE PMS_REGULAR_POST_CREATE$PMS(ID_CONTRACT_CALENDAR_POST INTEGER,
ID_ROOM INTEGER,
ID_OWNER INTEGER,
ID_CURRENCY VARCHAR(3),
ID_SERVICE INTEGER,
POST_VALUE NUMERIC(15,4),
IS_ACC_POST_ITEM SMALLINT,
MANUAL_POST_DATE DATE,
DESCRIPTION VARCHAR(255),
IS_POST_PER_POOL SMALLINT,
ID_RENTAL_POOL INTEGER,
IS_INCOME_POST SMALLINT)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_INCOME_POSTING_CREATE$PMS) */
ALTER PROCEDURE PMS_INCOME_POSTING_CREATE$PMS(ID_ROOM INTEGER,
ID_OWNER INTEGER,
ID_RENTAL_POOL INTEGER,
ID_CURRENCY VARCHAR(3),
ID_SERVICE INTEGER,
POST_VALUE NUMERIC(15,4),
MANUAL_POST_DATE DATE,
DESCRIPTION VARCHAR(255),
IS_POST_PER_POOL SMALLINT)
 AS
declare variable ownership_percent numeric(15,4);
  declare variable id_room_contract integer;
  declare variable id_account integer;
  declare variable percent_value numeric(15,4);
  declare variable curr_total_ownership numeric(15,4);
  declare variable curr_total_value numeric(15,4);
  declare variable new_id_pms_event integer;
  declare variable id_account_post_pms integer;
  declare variable curr_contract_owner integer;
  declare variable event_type varchar(30);
  declare variable round_to_orig numeric(15,6);
  declare variable id_hotel integer;
  declare variable is_account$pms integer;
begin
  id_room_contract = null;
  curr_total_value = 0;
  curr_total_ownership = 0;
  event_type = 'MANUAL_INCOME';

  select RC.ID_ROOM_CONTRACT
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS P on RC.ID_ROOM_PERIOD = P.ID_ROOM_PERIOD
  where  :MANUAL_POST_DATE between P.FROM_DATE and P.TO_DATE
         and P.STATUS in ('PRIVATE','CONTRACT')
         and P.ID_ROOM = :ID_ROOM
  into   :id_room_contract;
  if (:ID_ROOM_CONTRACT is null) then exception PMS_EXCEPTION '-615';

  execute procedure PMS_EVENT_CREATE$INT(:EVENT_TYPE, :ID_ROOM, :ID_OWNER, :DESCRIPTION,
          :MANUAL_POST_DATE, null, null, null, null,
          :POST_VALUE, :POST_VALUE, :ID_CURRENCY, null, :id_room_contract)
  returning_values :new_id_pms_event;

  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :ID_CURRENCY
  into   :round_to_orig;

  for
    select iif(:ID_OWNER is null, O.OWNERSHIP_PERCENT, 100), O.ID_OWNER, r.ID_HOTEL
    from   ROOM_CONTRACT$PMS RC
           join ROOM_OWNER$PMS O on O.ID_ROOM_CONTRACT = RC.ID_ROOM_CONTRACT
           join ROOM_PERIOD$PMS rp on rp.ID_ROOM_PERIOD = rc.ID_ROOM_PERIOD
           join ROOMS R on r.ID_ROOM = rp.ID_ROOM
    where  RC.ID_ROOM_CONTRACT = :id_room_contract
           and ((:id_owner is null) or (O.ID_OWNER = :id_owner))
    order by 1 asc
    into   :ownership_percent, :curr_contract_owner, :id_hotel
  do begin
    curr_total_ownership = :curr_total_ownership + :ownership_percent;
    if (:curr_total_ownership = 100) then begin
      percent_value = :POST_VALUE - :curr_total_value;
    end else
      percent_value = round_f(:POST_VALUE * :ownership_percent / 100, :round_to_orig);

    curr_total_value = :curr_total_value + :percent_value;

    execute procedure OWNER_ACCOUNT_GET$INT (iif(:IS_POST_PER_POOL = 0, :curr_contract_owner, :ID_RENTAL_POOL),
            :id_hotel, 0, 0)
    returning_values (:id_account, :is_account$pms);

    execute procedure ACCOUNT_POST_PMS_ADD$INT(:new_id_pms_event, :id_account,
            :curr_contract_owner, :ID_CURRENCY, :percent_value, :id_service, 1, :MANUAL_POST_DATE)
    returning_values  (:id_account_post_pms);
  end

  execute procedure PMS_EVENT_SET_ACTIVE$INT(:new_id_pms_event);
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POST_MODIFY$PMS for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: CONTRACT_EXPENSE_POST$INT for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_HOTEL INTEGER,
ID_CONTRACT /* TYPE OF ID */ INTEGER,
SUB_CONTRACT /* TYPE OF TSUB_CONTRACT */ VARCHAR(10),
ID_OWNER /* TYPE OF ID */ INTEGER,
OWNERSHIP_PERCENT /* TYPE OF TPERCENT */ NUMERIC(15,4),
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
POST_DATE /* TYPE OF TDATE */ DATE,
STAY /* TYPE OF TCOUNT */ INTEGER,
MAX_GUEST_CNT /* TYPE OF TCOUNT */ INTEGER,
BED_NIGHT_CNT /* TYPE OF TCOUNT */ INTEGER,
RESERVS /* TYPE OF TCOUNT */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PMS_EXPENSE_POSTS_CREATE$INT for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_EXPENSE_POSTS_CREATE$INT(ID_ROOM /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
POST_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
IS_CLIENT_ACC_POST /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_POST_DATE /* TYPE OF TDATE */ DATE,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IS_POST_PER_POOL /* TYPE OF TLOGICAL */ SMALLINT)
 RETURNS(NEW_ID_ACCOUNT_POST /* ID_REF */ INTEGER,
NEW_ID_ACCOUNT_POST$PMS /* ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PMS_POOL_DISTRIBUTION_SUB for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_POSTING_CREATE$INT) */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_OWNER TYPE OF ID,
POST_DATE TYPE OF TDATE,
CURR_ORIG TYPE OF TCURRENCY,
VALUE_ORIG TYPE OF TPRICE,
POST_ON_PMS_ACCOUNT TYPE OF TLOGICAL,
IS_OWNER_INCOME TYPE OF TLOGICAL,
ID_ROOM TYPE OF ID_REF = null)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  if (:POST_ON_PMS_ACCOUNT = 1) then begin
    execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account, :id_owner,
            :CURR_ORIG, :VALUE_ORIG, :id_service, :is_owner_income, :POST_DATE)
    returning_values  (:new_id_account_post);
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :ID_SERVICE, 1, 0, 1,
            :VALUE_ORIG, :CURR_ORIG, current_date, current_date,
            '', '', :POST_DATE, 'PMS', :ID_ROOM)
    returning_values  :err_code, :err_text, :new_id_account_post;
    if (:err_code <> 0) then exception PMS_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

    insert into PMS_EVENT_POST (ID_PMS_EVENT, ID_ACCOUNT_POST, ID_OWNER, LINE_STATUS)
    values (:ID_PMS_EVENT, :NEW_ID_ACCOUNT_POST, :ID_OWNER, 11);
  end
end
^

/* Alter (PMS_REGULAR_POST_CREATE$PMS) */
ALTER PROCEDURE PMS_REGULAR_POST_CREATE$PMS(ID_CONTRACT_CALENDAR_POST INTEGER,
ID_ROOM INTEGER,
ID_OWNER INTEGER,
ID_CURRENCY VARCHAR(3),
ID_SERVICE INTEGER,
POST_VALUE NUMERIC(15,4),
IS_ACC_POST_ITEM SMALLINT,
MANUAL_POST_DATE DATE,
DESCRIPTION VARCHAR(255),
IS_POST_PER_POOL SMALLINT,
ID_RENTAL_POOL INTEGER,
IS_INCOME_POST SMALLINT)
 AS
declare variable no_use varchar(1000);
begin

  if (:IS_INCOME_POST = 1) then begin
    execute procedure PMS_INCOME_POSTING_CREATE$PMS(:ID_ROOM, :ID_OWNER, :ID_RENTAL_POOL,
            :ID_CURRENCY, :ID_SERVICE, :POST_VALUE, :MANUAL_POST_DATE, :DESCRIPTION, :IS_POST_PER_POOL);
  end else begin
    execute procedure PMS_EXPENSE_POSTING_CREATE$PMS(:ID_ROOM, :ID_OWNER, :ID_RENTAL_POOL,
            :ID_SERVICE, :ID_CURRENCY, :POST_VALUE, :IS_ACC_POST_ITEM, :MANUAL_POST_DATE,
            :DESCRIPTION, :IS_POST_PER_POOL);
  end

  delete from CONTRACT_CALENDAR_SCHEME$PMS S
  where  S.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST
         and S.POST_DATE = :MANUAL_POST_DATE;

  execute procedure CONTRACT_CALENDAR_MODIFY$PMS(:ID_CONTRACT_CALENDAR_POST,
          null, null, null, null, null, null, null, null, null,  null, 'mod_next_date')
  returning_values (:no_use);

end
^

/* Alter (PMS_ROOM_DOCS_PREPARE$RPT) */
ALTER PROCEDURE PMS_ROOM_DOCS_PREPARE$RPT(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER)
 RETURNS(REC_COUNT INTEGER)
 AS
begin
  delete from PMS_ROOM_DOCS$TMP;


  insert into PMS_ROOM_DOCS$TMP (id_room, id_doc_head,  for_date, ID_RESERV_DETAIL, id_room_contract, ID_ROOM_PERIOD,
         post_net_value, post_gross_value, nat_net_value, nat_gross_value, nights)
  select ap.ID_ROOM, dh.ID_DOC, dh.RPT_DOC_DATE, g.ID_RESERV_DETAIL, rc.ID_ROOM_CONTRACT, RP.ID_ROOM_PERIOD,
         sum(SV.VALUE_WOT_TAX * dh.VALUE_CORR_IDX),
         sum(pv.ACCOUNT_PRICE * dl.QTY_POST * dh.VALUE_CORR_IDX),
         sum(dl.NAT_NET_VALUE * dh.VALUE_CORR_IDX),
         sum(dl.NAT_GROSS_VALUE * dh.VALUE_CORR_IDX),
         --count(distinct dl.DATE_POST),
         floor(sum(DH.VALUE_CORR_IDX*DL.QTY_POST*(1-dl.IS_CORRECT))/max(rd.ADULT_COUNT + rd.CHILD_COUNT))
  from   DOCUMENT_RELEASE DH
         join DOC_LINE DL on DL.ID_DOC_HEAD = DH.ID_DOC
         join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE
         join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = PV.ID_ACCOUNT_POST and ap.IS_BASE = 1
         join ROOMS R on R.ID_ROOM = AP.ID_ROOM
         join GUEST G on G.ID_GUEST = ap.ID_GUEST
         join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
         join CURRS c on c.CURR = ap.CURR_POST
         left outer join TAX_VALUE_DEDUCT (pv.ACCOUNT_PRICE * dl.QTY_POST, c.ROUND_TO, dl.ID_SALE_TAXATION) SV on 1=1
         left outer join ROOM_PERIOD$PMS rp on rp.ID_ROOM = r.id_room
                                      and rp.FROM_DATE <= dl.DATE_POST
                                      and rp.TO_DATE >= dl.DATE_POST
         left outer join ROOM_CONTRACT$PMS rc on rc.ID_ROOM_PERIOD = rp.ID_ROOM_PERIOD
  where  DH.RPT_DOC_DATE between :FROM_DATE and :TO_DATE
         and R.ID_HOTEL = :ID_HOTEL
  group by 1, 2, 3, 4, 5, 6;

  REC_COUNT = row_count;
  suspend;
end
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_FINALIZE$POST for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_ACCOUNT$INT) */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
QTY TYPE OF TQTY,
ID_SECQUENCE TYPE OF ID,
IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
POST_TEXT TYPE OF TDESCRIPTION_SHORT,
RESOURCE_TEXT TYPE OF TREASON,
DATE_POST TYPE OF TDATE,
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ID_ROOM TYPE OF ID = null,
POST_DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable action_text varchar(255);
begin
  if (:date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :date_post;
  end
/* NO AUTO PRICE !!!!!!
  if (:in_is_manual_price = 0) then begin

    select P.ID_EXTRA_TARIFF
    from   ACCOUNT A
           join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
    where  A.ID_ACCOUNT = :in_id_account
    into   :id_extra_tarifa;
    if ((:id_extra_tarifa is null) or (:id_extra_tarifa < 0)) then begin
      err_code = -14;
      exit;
    end
    execute procedure TAR_RECALC_EXTRASRV(:id_extra_tarifa, :in_id_service, :in_date_post)
    returning_values  :err_code, :err_text, :post_price, :post_currency;
    if (:err_code < 0) then exit;
  end else begin
    --MANUAL PRICE
    post_currency = :manual_curr ;
    post_price = :manual_price ;
  end
*/

  post_currency = :manual_curr ;
  post_price = :manual_price ;
  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, -1, :id_secquence, :date_post, :id_service, -1, :id_room, 0, :qty, :post_price,
    :post_currency, null, :short_code, :from_date, :to_date, :post_text, :resource_text, '', -1, :POST_DESCRIPTION)
  returning_values :err_code, :err_text, :id_account_post;
  if (:err_code <> 0) then exit;

  select S.SERVICE_NAME
  from   SERVICES S
  where  S.ID_SERVICE = :ID_SERVICE
  into   :action_text;
   
  action_text = f_character(29) || coalesce(:action_text, '')
                || f_character(28) || formatdate(:DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || coalesce(:post_currency, '');
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_RESERVATION$INT for: POST_SERVICE_ON_GUEST$INT */
ALTER PROCEDURE POST_SERVICE_ON_RESERVATION$INT(ID_RESERV_DETAIL /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_ROOM for: POST_SERVICE_ON_GUEST$INT */
ALTER PROCEDURE POST_SERVICE_ON_ROOM(IN_ID_ROOM /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255))
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_GUEST /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_GUEST$INT) */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TDESCRIPTION_SHORT,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ACCOUNT_ROUTING TYPE OF TSHORT_CODE,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable id_room integer;
  declare variable no_use varchar(255);
  declare variable action_text varchar(255);
  declare variable is_guest_check_in smallint;
  declare variable service_name varchar(50);
begin
  err_code = 0;
  err_text = '';

  select g.check_status
  from   guest g
  where  g.id_guest = :in_id_guest
  into   :is_guest_check_in;

  if (:is_guest_check_in < 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
  end

  execute procedure GUEST_GET_POSTING_ACCOUNT$INT (:in_id_guest, :account_routing)
  returning_values  :id_account, :id_room;

  if (:in_date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :in_date_post;
  end

  if (:in_is_manual_price = 0) then begin
    execute procedure SERVICE_GET_POSTING_DETAILS(:in_id_service, :IN_DATE_POST)
    returning_values  :no_use, :no_use, :service_name, :post_price, :post_currency;
  end else begin
    /* MANUAL PRICE */
    post_currency = :manual_curr;
    post_price = :manual_price;
    select s.SERVICE_NAME
    from   SERVICES s
    where  s.ID_SERVICE = :IN_ID_SERVICE
    into   :service_name;
  end

  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, :in_id_guest, :in_id_secquence, :in_date_post, :in_id_service, -1, :id_room, 0, :in_qty,
    :post_price, :post_currency, null, :in_short_code, :in_from_datetime, :in_to_datetime, :in_post_text,
    :in_resource_text, '', -1, :DESCRIPTION)
  returning_values  :err_code, :err_text, :id_account_post;

  action_text = f_character(29) || coalesce(:service_name, '')
                || f_character(28) || formatdate(:IN_DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:IN_QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || coalesce(:post_currency, '');
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: RESOURCE_RESERVATION_CHECK_IN for: POST_SERVICE_ON_RESERVATION$INT */
ALTER PROCEDURE RESOURCE_RESERVATION_CHECK_IN(ID_RESOURCE_RESERVATION INTEGER,
SERVICE_PRICE NUMERIC(15,2),
SERVICE_CURR VARCHAR(3))
 RETURNS(OUT_ID_ACCOUNT INTEGER,
OUT_ID_ACCOUNT_POST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_RESERVATION$INT) */
ALTER PROCEDURE POST_SERVICE_ON_RESERVATION$INT(ID_RESERV_DETAIL TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TREASON,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable id_guest integer;
begin
  err_code = 0;
  err_text = '';

  id_guest = null;
  select RD.ID_TITULAR
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :id_guest;

  execute procedure POST_SERVICE_ON_GUEST$INT(:id_guest, :in_id_service, :in_qty, :in_id_secquence,
                    :in_is_manual_price, :manual_price, :manual_curr, :in_from_datetime, :in_to_datetime,
                    :in_post_text, :in_resource_text, :in_date_post, :in_short_code, '', :DESCRIPTION)
  returning_values  :err_code, :err_text, :id_account, :id_account_post;
end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_SERVICE_POST for: POST_SERVICE_ON_ROOM */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_ROOM) */
ALTER PROCEDURE POST_SERVICE_ON_ROOM(IN_ID_ROOM TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TREASON,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_GUEST TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
begin
  err_code = 0;
  err_text = '';

  id_guest = null;
  select first 1 G.ID_GUEST
  from   GUEST G
  where  G.ID_ROOM = :in_id_room
         and G.CHECK_STATUS = 0
  order by G.FROM_DATE desc, G.ID_GUEST asc
        /************************************************/
        /* DESCENDANT ORDER IS VERY IMPORTANT!!         */
        /* IF TWO GUESTS HAVE:                          */
        /* TO_DATE OF THE 1'ST = FROM_DATE OF THE 2'ND, */
        /* THEN PHONACALLS SHOULD GO TO THE 2'ND        */         
        /************************************************/
  into   :id_guest;

  if (:id_guest is null) then begin
    err_code = -24;   /* NO GUESTS ARE CHECKED_IN INTO THE REQUESTED ROOM! */
    exit;
  end

  execute procedure POST_SERVICE_ON_GUEST$INT(:id_guest, :in_id_service, :in_qty, :in_id_secquence, :in_is_manual_price,
    :manual_price, :manual_curr, :in_from_datetime, :in_to_datetime, :in_post_text, :in_resource_text,
    :in_date_post, :in_short_code, '')
  returning_values  :err_code, :err_text, :id_account, :id_account_post;
end
^

/* empty dependent procedure body */
/* Clear: EAI_TELECOUNT_TRANSFER for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALL_POST$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL /* ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALLS_POST_TO_ACCOUNT$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_TELECOUNT_TRANSFER$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_TELECOUNT_CALL$INT) */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ext_ifc_name varchar(20);
  declare variable room_name varchar(30);
  declare variable datetime_call timestamp;
  declare variable price numeric(15,2);
  declare variable dial_number varchar(50);
  declare variable units integer;
  declare variable pc_id_service integer;
  declare variable def_manual_curr char(3);
  declare variable post_text varchar(50);
  declare variable id_account_post integer;
  declare variable is_archive integer;
  declare variable id_account integer;
  declare variable new_id_account_post integer;
  declare variable pc_tag varchar(30);
  declare variable number_zone varchar(50);
  declare variable id_hotel integer;
  declare variable id_phonecall integer;
  declare variable no_use varchar(255);
begin
  /* Description:
  || POST_TO_TYPE = 0 - ACCOUNT, 1 - GUEST, 2 - RESERV_DETAIL, 3 - JUST PREPARE, FOR EXTERNAL CLIENT
  */
  err_code = 0;
  err_text = '';
  ext_ifc_name = 'TELECOUNT';

  select PC.ID_PHONECALL, PC.ROOM_NAME, PC.DATETIME_CALL, PC.PRICE, PC.DIAL_NUMBER, PC.UNITS,
         PC.ID_ACCOUNT_POST, PC.IS_ARCHIVE, PC.TAG, substring(PC.NUMBER_ZONE from 1 for 30), pc.ID_HOTEL
  from   PHONECALLS PC 
  where  PC.rdb$db_key = :ph_dbkey
  into   :id_phonecall, :room_name, :datetime_call, :price, :dial_number, :units,
         :id_account_post, :is_archive, :pc_tag, :number_zone, :id_hotel;

  if ((:is_archive = 1) or (coalesce(:id_account_post, 0) > 0)) then exit;

  if ((:pc_tag is null) or (:pc_tag = '')) then pc_tag = 'TELECOUNT_DEFAULT';
  else pc_tag = 'TELECOUNT_' || :pc_tag;

  execute procedure EAI_MAP_SERVICE(:pc_tag, :number_zone, :ext_ifc_name, :id_hotel)
  returning_values  :err_code, :err_text, :pc_id_service;
  if (:err_code < 0) then exit;

  post_text = substring(:dial_number || ', impulses ' || :units from 1 for 50);

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :def_manual_curr;

  new_id_account_post = null;
  if (:post_to_type = 0) then begin
    id_account = :post_to_id;
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name)
    returning_values :err_code, :err_text, :new_id_account_post;
  end else if (:post_to_type = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:post_to_id, :pc_id_service, 1, -1, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name, '')
    returning_values :err_code, :err_text, :id_account, :new_id_account_post;
  end else if (:post_to_type = 2) then begin
    execute procedure POST_SERVICE_ON_RESERVATION$INT(:post_to_id, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name)
    returning_values :err_code, :err_text, :id_account, :new_id_account_post;
  end else if (:post_to_type = 3) then begin
    execute procedure POST_PREPARE_ON_ACCOUNT$POST (:post_to_id, :pc_id_service,
      1, :ID_SEQUENCE, :price, :def_manual_curr, :post_text, null, null, :ID_PHONECALL)
    returning_values :no_use;
  end
  if (:err_code < 0) then exit;

  if (:new_id_account_post is not null) then begin
    update PHONECALLS PC
    set    PC.ID_ACCOUNT_POST = :new_id_account_post,
           pc.POSTING_ERROR = null
    where  PC.rdb$db_key = :ph_dbkey;
  end

end
^

/* Alter (POST_TELECOUNT_TRANSFER$TC) */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ph_dbkey char(8);
  declare variable id_account_post integer;
  declare variable account_name varchar(50);
begin
  err_code = 0;
  err_text = '';

  for
    select PC.RDB$DB_KEY, PC.ID_ACCOUNT_POST
    from   PHONECALLS PC
    where  PC.SELECTION_ID = :selection_id
    into   :ph_dbkey, :id_account_post
  do begin
    if ((:id_account_post is not null) and (:id_account_post <> -1)) then begin
      err_code = -117;
      select A.ACCOUNT_NAME
      from   ACCOUNT_POST AP
             join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
      where  AP.ID_ACCOUNT_POST = :id_account_post
      into   :account_name;
      err_text = f_character(29) || :account_name;
      exit;
    end

    execute procedure POST_TELECOUNT_CALL$INT(2, :id_reserv_detail, :ph_dbkey, 0)
    returning_values :err_code, :err_text;
    if (:err_code < 0) then exit;
  end
end
^

/* Alter (RATE_GET_AVAILABILITY$CHM) */
ALTER PROCEDURE RATE_GET_AVAILABILITY$CHM(ID_RATE INTEGER,
FOR_DATE DATE)
 RETURNS(ACTIVE_STATUS INTEGER,
MIN_LOS INTEGER,
MAX_LOS INTEGER)
 AS
declare variable date_from date;
  declare variable date_to date;
  declare variable RATE_capacity integer;
  declare variable to_sell integer;
begin
  --ACTIVE_STATUS 0 - closed
  --ACTIVE_STATUS 1 - closed fro arrival
  --ACTIVE_STATUS 2 - opened
  --opala ID_HOTEL
--  date_from = null;
--  ACTIVE_STATUS -  autoclose, t.e. AUTO_PERCENT






/*  select min(FOR_DATE), max(FOR_DATE)
  from RATE_ALLOTMENT
  where ID_RATE = :id_RATE
  into :date_from, :date_to;
  if (date_from is null) then exit;

  for select distinct ID_ROOM_TYPE
      from RATE_ALLOTMENT
      where ID_RATE = :id_RATE
        and FOR_DATE between :date_from and :date_to
      into :id_room_type
  do begin
    for select RTR.FOR_DATE,
               CA.STATUS,
               CA.AUTO_FREE_ROOMS, CA.ROOM_COUNT, RTR.AVAILABLE as FREE_ROOMS
        from ROOM_TYPE_GET_FREE$CHM(:date_from, :date_to, :id_room_type) RTR
             join RATE_ALLOTMENT CA on CA.ID_ROOM_TYPE = :id_room_type
                                      and CA.ID_RATE = :id_RATE
                                      and CA.FOR_DATE = RTR.FOR_DATE
    into :for_date, :status,
         :auto_free_rooms, :RATE_capacity, :free_rooms
    do begin
      if (:auto_free_rooms is not null) then
        if (coalesce(:free_rooms,0) >= :auto_free_rooms) then
          is_active = 1;
        else is_active = 0;
      else if (:status = 0) then
             is_active = 1;
           else is_active = 0;

      to_sell = coalesce(:free_rooms,0) - coalesce(:auto_free_rooms,0);
      if (to_sell < 0) then to_sell = 0;

      room_count = :to_sell;
      if (:RATE_capacity is not null) then
        if (RATE_capacity < room_count) then
          room_count = :RATE_capacity;

      suspend;
    end
  end*/
end
^

/* empty dependent procedure body */
/* Clear: PROFILE_GET_ACCOUNT$INT for: RES_ACCOUNT_CREATE$INT */
ALTER PROCEDURE PROFILE_GET_ACCOUNT$INT(ID_PROFILE INTEGER,
ID_RESERV_DETAIL INTEGER,
ACCOUNT_CURR VARCHAR(3),
ID_ACC_TEMPLATE INTEGER,
IS_BASE_ENABLE SMALLINT = 1,
IS_EXTRA_ENABLE SMALLINT = 1)
 RETURNS(ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_ACCOUNT_CREATE$INT) */
ALTER PROCEDURE RES_ACCOUNT_CREATE$INT(ID_PROFILE INTEGER,
ID_ACC_TEMPLATE INTEGER,
ACC_CURRENCY CHAR(3),
ID_RESERV_DETAIL INTEGER,
IS_BASE_ENABLE SMALLINT = 1,
IS_EXTRA_ENABLE SMALLINT = 1)
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
declare variable acc_name varchar(50);
  declare variable id_hotel integer;
  declare variable is_credit_account integer;
  declare variable credit_limit numeric (15,4);
  declare variable sec_level integer;
  declare variable is_pos_allowed integer;
  declare variable id_tax_policy integer;
begin
  select 'res. ' || substring(RD.NUMBER from 1 for 45), RD.ID_HOTEL
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :acc_name, :id_hotel;

  if (:id_acc_template is null) then begin
    select sv.SETTING_VALUE
    from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :id_hotel) sv
    into   :id_acc_template;
  end

  is_credit_account = null;
  select ACT.IS_CREDIT_ACCOUNT, ACT.CREDIT_LIMIT, ACT.SECURITY_LEVEL,
         ACT.IS_ALOWED_POS_INTERFACE, ACT.ID_TAX_POLICY
  from   ACC_TEMPLATE ACT
  where  ACT.ID_ACC_TEMPLATE = :id_acc_template
         and act.ID_HOTEL = :id_hotel
  into   :is_credit_account, :credit_limit, :sec_level,
         :is_pos_allowed, :id_tax_policy;

  if (:is_credit_account is null) then exception ACCOUNT_EXCEPTION '-50';

  execute procedure ACCOUNT_MODIFY$INT (null, :ID_PROFILE, :ACC_CURRENCY, :acc_name, :is_credit_account, :credit_limit,
          null, null, 0, '', :sec_level, :IS_BASE_ENABLE, :IS_EXTRA_ENABLE, :is_pos_allowed, null,
          null, :id_tax_policy, null, :id_hotel, :ID_RESERV_DETAIL, 0, 'add')
  returning_values (:NEW_ID_ACCOUNT);
end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTS$INT for: RES_SAVE_ACCOUNTS_FINALIZE$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTS$INT(RD_DBKEY CHAR(8))
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SAVE_ACCOUNTS_FINALIZE$INT) */
ALTER PROCEDURE RES_SAVE_ACCOUNTS_FINALIZE$INT(ID_RESERV_DETAIL INTEGER,
OLD_ID_BASE_ACCOUNT INTEGER,
OLD_ID_EXTRA_ACCOUNT INTEGER,
NEW_ID_BASE_ACCOUNT INTEGER,
NEW_ID_EXTRA_ACCOUNT INTEGER)
 AS
declare variable id_old_account integer;
  declare variable action_text varchar(255);
  declare variable acc_name varchar(50);
  declare variable is_used integer;
begin
  if (:NEW_ID_BASE_ACCOUNT is distinct from :OLD_ID_BASE_ACCOUNT) then begin
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :OLD_ID_BASE_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = F_CHARACTER(29) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:OLD_ID_BASE_ACCOUNT, '')  || ')';
    ACC_NAME = null;
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :NEW_ID_BASE_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = :ACTION_TEXT || F_CHARACTER(28) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:NEW_ID_BASE_ACCOUNT, '')  || ')';

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_MOD_BASE_ACCOUNT', :ACTION_TEXT);
  end

  ACTION_TEXT = '';
  ACC_NAME = null;
  if (:NEW_ID_EXTRA_ACCOUNT is distinct from :OLD_ID_EXTRA_ACCOUNT) then begin
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :OLD_ID_EXTRA_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = F_CHARACTER(29) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:OLD_ID_EXTRA_ACCOUNT, '')  || ')';
    ACC_NAME = null;
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :NEW_ID_EXTRA_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = :ACTION_TEXT || F_CHARACTER(28) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:NEW_ID_EXTRA_ACCOUNT, '')  || ')';

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_MOD_EXTRA_ACCOUNT', :ACTION_TEXT);
  end

  -- Archivate old unused accounts
  for
    select A.ID_ACCOUNT
    from   ACCOUNT_S A
    where  A.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
           and A.IS_ARCHIVE = 0
           and A.ID_ACCOUNT <> :NEW_ID_BASE_ACCOUNT
           and A.ID_ACCOUNT <> :NEW_ID_EXTRA_ACCOUNT
           and A.IS_CREDIT_ACCOUNT = 0
           and not exists(select G.ID_GUEST
                          from   GUEST G
                          where  (G.ID_BASE_ACCOUNT = A.ID_ACCOUNT)
                                 or (G.ID_ACCOUNT = A.ID_ACCOUNT))
    into   :ID_OLD_ACCOUNT
  do begin
    select auc.is_used
    from   ACCOUNT_USE_CHECK$INT(:id_old_account) auc
    into   :is_used;

    if (:is_used = 0) then begin
      delete from ACCOUNT A
      where  a.ID_ACCOUNT = :id_old_account;
    end else if (not exists(select ap.ID_ACCOUNT_POST from account_post ap where ap.ID_ACCOUNT = :id_old_account and ap.IS_ANUL = 0)) then  begin
      -- archive only used accounts without valid postings
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS (:ID_OLD_ACCOUNT, 1);
  
      when exception ACCOUNT_EXCEPTION do post_event 'dummy';
    end
  end 
end
^

/* empty dependent procedure body */
/* Clear: RES_TAR_CALC_FINALIZE$INT for: RES_TAR_CALC_REPOST$INT */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(TAR_CALC_ERR INTEGER,
ID_TAR_CALC INTEGER,
RD_DBKEY_INIT CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_TAR_CALC_REPOST$INT) */
ALTER PROCEDURE RES_TAR_CALC_REPOST$INT(ID_TAR_CALC TYPE OF ID_REF,
ID_RESERV_DETAIL TYPE OF ID_REF,
RECALC_MARKER VARCHAR(40))
 AS
declare variable id_guest type of id_ref;
  declare variable id_service type of id_ref;
  declare variable id_tariff type of id_ref;
  declare variable date_post type of tdate;
  declare variable qty_post type of tqty;
  declare variable price_orig type of tprice;
  declare variable curr_orig type of tcurrency;
  declare variable id_room type of id_ref;
  declare variable is_base type of tlogical;
  declare variable short_code type of tdescription_long;
  declare variable id_account type of id_ref;
  declare variable gfrom_date type of tdate;
  declare variable gto_date type of tdate;
  declare variable ap_db_key char(8);
  declare variable id_pack_service type of id_ref;
  declare variable err_code type of id_ref;
  declare variable err_text type of tdescription_long;
  declare variable id_master_account_post type of id_ref;
  declare variable id_acc_post type of id_ref;
  declare variable is_base_account type of id_ref;
  declare variable id_extra_account type of id_ref;
  declare variable no_use varchar(255);
begin
  for
    select   TCP.ID_GUEST, TCP.ID_SERVICE, TCP.ID_TARIFF, TCP.DATE_POST, TCP.QTY_POST,
             round_f(TCP.PRICE_ORIG, c.ROUND_TO), TCP.CURR_ORIG, TCP.ID_ROOM, TCP.IS_BASE,
             TCP.SHORT_CODE, iif(coalesce(AGP.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'NONE', 0, 1),
             G.ID_BASE_ACCOUNT, G.FROM_DATE, G.TO_DATE, G.ID_ACCOUNT
    from     TAR_CALC_POST$TMP TCP
             join GUEST G on G.ID_GUEST = TCP.ID_GUEST
             join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
             join SERVICES S on S.ID_SERVICE = TCP.ID_SERVICE
             join CURRS c on c.CURR = tcp.CURR_ORIG
             left outer join AGENT_PACKET AGP on AGP.ID_SERVICE = S.ID_SERVICE and AGP.ID_AGENT = G.ID_AGENT
    where    TCP.ID_TAR_CALC = :id_tar_calc
             and ((rd.ID_RESERV_DETAIL = :ID_RESERV_DETAIL)
                  or (coalesce(RD.IS_POSTING_STOPPED, 0) = 0 and RD.POSTING_TRANSACTION_UUID is not null))
    order by TCP.ID_GUEST asc, TCP.DATE_POST asc, TCP.IS_BASE desc
    into     :id_guest, :id_service, :id_tariff, :date_post, :qty_post,
             :price_orig, :curr_orig, :id_room, :is_base, :short_code, :is_base_account,
             :id_account, :gfrom_date, :gto_date, :id_extra_account
  do begin
    ap_db_key = null;
    if (:is_base = 1) then begin
      select AP.RDB$DB_KEY, AP.ID_MASTER_ADDINS_ACC_POST, AP.ID_PACK_SERVICE
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.DATE_POST = :date_post
             and AP.IS_BASE = 1
      into   :ap_db_key, :id_master_account_post, :id_pack_service;

      execute procedure sys_dbg('tar TAR_CALC_REPOST$INT price_orig = '||coalesce(:price_orig, 'null'));
      execute procedure sys_dbg('tar TAR_CALC_REPOST$INT ap_db_key = '||coalesce(:ap_db_key, 'null'));

      if (:ap_db_key is null) then begin
        id_master_account_post = -1;
        execute procedure GUEST_POST_GET_PACK_SERVICE(:id_service, :id_guest, :date_post)
        returning_values  :id_pack_service;
      end
    end else begin
      short_code = '';
      select first 1 APU.rdb$db_key
      from   ACCOUNT_POST APU
      where  APU.ID_MASTER_ADDINS_ACC_POST = :id_master_account_post
             and APU.ID_SERVICE = :id_service
      order by apu.IS_ANUL asc, apu.ID_ACCOUNT_POST asc
      into   :ap_db_key;

      if ((:is_base_account <> 1)) then id_account = :id_extra_account;
    end

    if (:ap_db_key is null) then begin
      execute procedure ACCOUNT_POSTING_ADD$INT(
        :id_account, :id_guest, -1, :date_post, :id_service, :id_tariff, :id_room, :is_base, :qty_post,
        :price_orig, :curr_orig, null, :short_code, :gfrom_date, :gto_date, 'PACK='||:id_pack_service, '',
        :recalc_marker, :id_master_account_post)
      returning_values  :err_code, :err_text, :id_acc_post;
      if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

      if (:is_base = 1) then id_master_account_post = :id_acc_post;

    end else begin
      execute procedure ACCOUNT_POSTING_UPDATE$INT(
        :ap_db_key, :id_service, :id_tariff, :id_room, :qty_post, 0, :price_orig, :curr_orig, null,
        :recalc_marker, :short_code, :gfrom_date, :gto_date, 1, :id_account)
      returning_values  :no_use, :no_use, :no_use;
    end

  end

  ap_db_key = null;
  id_guest = null;
  for
    select distinct TCP.ID_GUEST
    from   TAR_CALC_POST$TMP TCP
    where  tcp.ID_TAR_CALC = :ID_TAR_CALC
    into   :id_guest
  do begin
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.CHANGED_TEXT is distinct from :recalc_marker
             and AP.ID_MASTER_ADDINS_ACC_POST > 0
             and AP.IS_ANUL = 0
      into   :ap_db_key
    do begin
      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_db_key, :recalc_marker);
    end
  end

  delete from RESERV_PREPOST RP where RP.ID_RESERV_DETAIL = :id_reserv_detail;
  execute procedure RES_TAKE_POSTING_RESPONSIBILITY (:ID_RESERV_DETAIL);
end
^

/* Alter (RESGRP_GET_INFO$RSV) */
ALTER PROCEDURE RESGRP_GET_INFO$RSV(ID_INFO_GROUP INTEGER)
 RETURNS(AGENT_PROFILE_NAME VARCHAR(100),
ARRIVALS VARCHAR(255),
DEPARTURES VARCHAR(255),
ROOM_DATA VARCHAR(255),
ROOMS VARCHAR(255),
ID_ROOM INTEGER,
GUESTS VARCHAR(255),
PERSON_PROFILE_NAME VARCHAR(100),
RATES VARCHAR(255),
BOARDS VARCHAR(255),
PACKETS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY VARCHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
BALANCE VARCHAR(255),
OPEN_CHARGES INTEGER,
CHECK_STATUS VARCHAR(255),
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
NOTE VARCHAR(2000),
NOTE_GRP VARCHAR(255),
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
FIRST_ARRIVAL DATE,
FIRST_DEPARTURE DATE,
HOTELS VARCHAR(255),
ID_HOTEL INTEGER,
ACC_ROUTING VARCHAR(255),
RES_NUMBER VARCHAR(62))
 AS
declare variable arrival date;
  declare variable departure date;
  declare variable room varchar(10);
  declare variable type_room varchar(20);
  declare variable stay_length varchar(60);
  declare variable id_reserv_detail integer;
  declare variable no_use varchar(255);
  declare variable rd_adult_count integer;
  declare variable rd_child_count integer;
  declare variable is_group integer;
  declare variable current_arrival varchar(60);
  declare variable current_departure varchar(60);
  declare variable nights varchar(255);
  declare variable roomcount integer;
  declare variable adultcount integer;
  declare variable childrencount integer;
  declare variable groupname varchar(100);
  declare variable rd_check_status integer;
  declare variable is_anul_detail integer;
  declare variable reason_of_anul varchar(100);
  declare variable hotel_code varchar(10);
  declare variable current_acc_routing varchar(255);
begin
  arrivals = '';
  departures = '';
  rooms = '';
  nights = '';
  rates = '';
  hotels = '';
  roomcount = 0;
  adultcount = 0;
  childrencount = 0;
  check_status = '';
  acc_routing = '';
  arrival = null;
  first_arrival = null;
  first_departure = null;

  ATTENTION_STATUS = null;  -- OUT of use ?!
  NOTE_GRP = null;

  for
    select RD.FROM_DATE, RD.ADULT_COUNT, RD.CHILD_COUNT, R.ROOM_NAME, RT.TYPE_ROOM,
           cast(RD.TO_DATE - RD.FROM_DATE as integer), RD.CHECK_STATUS, PP.PROFILE_NAME,
           RD.ROOM_PRICE, RD.ROOM_CURRENCY, RD.ROOM_PRICE_DETAILS, RD.ID_RESERV_DETAIL,
           RD.TO_DATE, R.ID_ROOM, RD.IS_ANUL, RD.REASON_OF_ANUL, RD.NOTE, H.CODE,
           RD.NUMBER, RD.ACC_ROUTING,
           AP.PROFILE_NAME, RG.GROUP_NAME, RD.ID_HOTEL, iif(RD.ID_GROUP is not null, 1, 0)
    from   RESERV_GROUP RG
           join HOTEL H on H.ID_HOTEL = RG.ID_HOTEL
           left outer join RESERV_DETAIL RD on RG.ID_RESERV_GROUP = RD.ID_GROUP and RD.IS_ANUL = 0
           left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
           left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = coalesce(R.ID_ROOM_TYPE, RD.ID_ROOM_TYPE)
           left outer join PROFILE PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
           left outer join PROFILE AP on AP.ID_PROFILE = RD.ID_AGENT_PROFILE
    where  RG.ID_RESERV_GROUP = :id_info_group
    order by RD.FROM_DATE asc
    into   :arrival, :rd_adult_count, :rd_child_count, :room, :type_room,
           :stay_length, :rd_check_status, :person_profile_name,
           :room_price, :room_currency, :room_price_details, :id_reserv_detail,
           :departure, :id_room, :is_anul_detail, :reason_of_anul, :note, :hotel_code,
           :res_number, :current_acc_routing,
           :agent_profile_name, :groupname, :id_hotel, :is_group
  do begin
    if (:first_arrival is null) then first_arrival = :arrival;
    if (:first_departure is null) then first_departure = :departure;

    if (:arrival is not null) then begin
      if (extract(year from current_date) = extract(year from :arrival)) then
        current_arrival = formatDate(:arrival, 'D;dd.mm');
      else
        current_arrival = formatDate(:arrival, 'D;dd.mm.yy');
  
      if (:arrivals not containing :current_arrival) then begin
        nights = :stay_length;
        if (:arrivals = '') then arrivals = :current_arrival||' ('||:stay_length;
        else if (char_length(:arrivals) < 100) then arrivals = :arrivals||')  '||:current_arrival||' ('||:stay_length;
      end else begin
        if (:nights not containing :stay_length) then begin
          nights = :nights ||','||:stay_length;
          arrivals = :arrivals||','||:stay_length;
        end
      end
    end

    if (:departure is not null) then begin
      if (extract(year from current_date) = extract(year from :departure)) then
        current_departure = formatDate(:departure, 'D;dd.mm');
      else
        current_departure = formatDate(:departure, 'D;dd.mm.yy');
  
      if (:departures not containing :current_departure) then begin
        if (:departures = '') then departures = :current_departure;
        else if (char_length(:departures) < 100) then departures = :departures||'  '||:current_departure;
      end
    end

    if (:acc_routing not containing :current_acc_routing) then begin
      if (:acc_routing = '') then acc_routing = :current_acc_routing;
      else if (char_length(:acc_routing) < 100) then acc_routing = :acc_routing||'  '||:current_acc_routing;
    end

    if (:check_status not containing :rd_check_status) then begin
      if (:check_status = '') then check_status = :rd_check_status;
      else check_status = :check_status||', '||:rd_check_status;
    end

    if (:hotels not containing :hotel_code) then begin
      if (:hotels = '') then hotels = :hotel_code;
      else hotels = :hotels||','||:hotel_code;
    end

    if (:is_group is distinct from 1) then begin
      if (:room is null) then room_data = :type_room;
      else room_data = :room || ' / ' || :type_room;
    end

    if (:is_group = 1) then begin
      in_share = null;
      balance = '-';
      res_number = '';
    end else begin
      execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'RENDER', null)
      returning_values  :in_share, :no_use, :shares_preview;

      execute procedure RES_GET_BALLANCE$INT(:id_reserv_detail)
      returning_values  :balance, :no_use, :no_use, :open_charges, :no_use;
    end
    adultcount = :adultcount + :rd_adult_count;
    childrencount = :childrencount + :rd_child_count;
  end
  if (coalesce(:groupname, '') <> '') then agent_profile_name = substring(coalesce(:agent_profile_name, ' ') || ' / ' || :groupname from 1 for 100);
  if (:is_group = 1) then person_profile_name = '';
  if (:arrivals <> '') then arrivals = :arrivals||')';
  guests = :adultcount || ' + ' || :childrencount || ' ';

  if (:arrivals <> '') then begin
    if (:is_group = 1) then begin
      note = '';
      room_data = '';
      for
        select RT.TYPE_ROOM, count(*)
        from   RESERV_DETAIL RD
               left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
               join ROOM_TYPES RT on RT.ID_ROOM_TYPE = coalesce(R.ID_ROOM_TYPE, RD.ID_ROOM_TYPE)
        where  RD.ID_GROUP = :id_info_group
               and RD.IS_ANUL = 0
        group by 1
        into   :type_room, :roomcount
      do begin
        if (:room_data = '') then room_data = :roomcount ||'x '||:type_room;
        else room_data = room_data ||', '|| :roomcount ||'x '||:type_room;
      end
    end
/*
    execute procedure RES_GET_ATTENTION_STATUS$INT(:arrival, :departure, :rd_check_status)
    returning_values  :attention_status;
*/
    execute procedure RES_GET_GUEST_DATA$INT('GROUP', :id_info_group)
    returning_values  :boards, :rates, :packets, :no_use;
  
    annul_status = :is_anul_detail;
    if (:reason_of_anul = 'EXPIRE') then annul_status = 2;
  end

  if (char_length(:arrivals) >= 100) then arrivals = :arrivals||'...';
  if (char_length(:departures) >= 100) then departures = :departures||'...';
  suspend;
end
^

/* Alter (RESOURCE_RESERVATION_CHECK_IN) */
ALTER PROCEDURE RESOURCE_RESERVATION_CHECK_IN(ID_RESOURCE_RESERVATION INTEGER,
SERVICE_PRICE NUMERIC(15,2),
SERVICE_CURR VARCHAR(3))
 RETURNS(OUT_ID_ACCOUNT INTEGER,
OUT_ID_ACCOUNT_POST INTEGER)
 AS
declare variable old_status varchar(20);
  declare variable new_status varchar(20);
  declare variable dbkey char(8);
  declare variable id_service id_ref;
  declare variable price_post tprice;
  declare variable curr_post TCURRENCY;
  declare variable is_manual_price TLOGICAL;
  declare variable is_details tlogical;
  declare variable post_description tobject_text;
  declare variable id_reserv_detail integer;
  declare variable post_date tdate;
  declare variable from_datetime tdatetime;
  declare variable to_datetime tdatetime;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  new_status = 'CHECKED_IN';

  select r.RDB$DB_KEY, R.STATUS, rd.ID_RESERV_DETAIL
  from   RESOURCE_RESERVATION R
         left outer join RESERV_DETAIL rd on rd.NUMBER = r.BOOKING_NUMBER
                                             and rd.IS_ANUL = 0
                                             and rd.SUBSCRIBER_ID is not distinct from r.SUBSCRIBER_ID
  where  R.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION
  into   :dbkey, :old_status, :id_reserv_detail;

  if (:old_status = :NEW_STATUS) then exit;
 
  if (:old_status is distinct from 'RESERVED') then exception ASSERT '-511';

  if (exists (select RP.ID_RESOURCE_RESERVATION
              from   RESOURCE_RESERV_POST RP
                     join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = RP.ID_ACCOUNNT_POST
              where  RP.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION)) then
  begin
    exception ASSERT '-505';
  end

  if (:id_reserv_detail is not null) then begin
    execute procedure RESOURCE_RESERV_SERVICE_GET (:ID_RESOURCE_RESERVATION)
    returning_values (:id_service, :price_post, :curr_post, :is_manual_price, :is_details, :post_description,
                     :post_date, :from_datetime, :to_datetime);
  
    if (:is_manual_price = 1) then begin
      price_post = :SERVICE_PRICE;
      curr_post = :SERVICE_CURR;
    end

    if (:price_post is null) then exception ASSERT 'Unspecified service price!';
    if (:curr_post is null) then exception ASSERT 'Unspecified price currency!';
  
    execute procedure POST_SERVICE_ON_RESERVATION$INT (:id_reserv_detail, :id_service, 1, 0,
            1, :price_post, :curr_post, :from_datetime, :to_datetime,
            '', '', :post_date, 'RESOURCE', :post_description)
    returning_values (:ERR_CODE, :ERR_TEXT, :OUT_ID_ACCOUNT, :OUT_ID_ACCOUNT_POST);
    if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
  
    insert into RESOURCE_RESERV_POST(ID_RESOURCE_RESERVATION, ID_ACCOUNNT_POST)
    values (:ID_RESOURCE_RESERVATION, :OUT_ID_ACCOUNT_POST);
  end

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = :NEW_STATUS
  where  RR.RDB$DB_KEY = :dbkey;

end
^

/* Alter (RIGHTS_GROUP_USER_MODIFY) */
ALTER PROCEDURE RIGHTS_GROUP_USER_MODIFY(USER_NAME VARCHAR(30),
ID_RIGHT_GROUP INTEGER,
OPERATION VARCHAR(50))
 AS
declare variable right_group varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add,del');

  if (:USER_NAME = 'SYSDBA') then exit;

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS RG
  where  RG.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'add') then begin
    insert into RIGHTS_USER_GROUPS (USER_NAME, ID_RIGHT_GROUP)
    values (:user_name, :id_right_group);

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_ADDED',
            f_character(29) || :USER_NAME  || f_character(28) || :right_group);

  end else begin
    delete from RIGHTS_USER_GROUPS
    where USER_NAME = :user_name
          and ID_RIGHT_GROUP = :id_right_group;

    if (row_count > 0) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_REMOVED',
              f_character(29) || :USER_NAME || f_character(28) || :right_group);

  end

  when sqlcode -803 do begin
    /* ERR_TEXT = '       ! ' ;*/
    exit;
  end
end
^

/* Alter (ROOM_MODIFY$PMS) */
ALTER PROCEDURE ROOM_MODIFY$PMS(ID_ROOM INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
BEDS INTEGER,
EXTRA_BEDS INTEGER,
SECTOR INTEGER,
SORT_ORDER INTEGER,
FEATURES BLOB SUB_TYPE 1 SEGMENT SIZE 100,
EXTERNAL_NAME VARCHAR(10),
ID_EATING_OBJECT TYPE OF ID_REF,
OPERATION VARCHAR(20))
 RETURNS(OVERRULE_NEED SMALLINT,
OVERRULE_CONTEXT VARCHAR(255),
NEW_ID_ROOM INTEGER)
 AS
declare variable old_id_room_type integer;
  declare variable old_room_name varchar(10);
  declare variable rebuild_id_hotel integer;
  declare variable rebuild_id_room_type integer;
  declare variable guests_max integer;
  declare variable no_use varchar(20);
  declare variable old_capacity integer;
  declare variable busy_group_type integer;
  declare variable sys_date date;
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable action_text varchar(255);
  declare variable old_floor integer;
  declare variable old_sector integer;
  declare variable old_extra_beds integer;
  declare variable id_hotel integer;
begin
  overrule_need = 0;
  overrule_context = '';
  new_id_room = null;
  --if OVERRULE_NEED = 1 then OVERRULE_CONTEXT = ERR_TEXT like ERR_CODE = -9
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    if (coalesce(:room_name, '') = '') then
      exception ASSERT '-119';

    if ((:room_name containing '<') or (:room_name containing '>') or (:room_name starting with 'i')) then
      exception ASSERT '-120';
  end

  room_name = upper(:room_name);

  if (:operation='mod') then begin
    select R.ROOM_NAME, R.ID_ROOM_TYPE, R.BEDS+R.EXTRA_BEDS, r.floor, r.sector, r.extra_beds
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :id_room
    into   :old_room_name, :old_id_room_type, :old_capacity, :old_floor, :old_sector, :old_extra_beds;

    if (:id_room_type <> :old_id_room_type) then begin
      exception OCCUPANCY_EXCEPTION '-65';
    end

    new_id_room = :id_room;
    guests_max = 0;
    if (:old_capacity > (:beds + :extra_beds)) then begin
      select first 1 sum(RM.ADULT_COUNT+RM.CHILDREN_COUNT), max(rm.BUSY_GROUP_TYPE)
      from   ROOM_MAGIC RM
             join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = RM.ID_RESERV_DETAIL
      where  RM.ID_ROOM = :id_room
             and RD.CHECK_STATUS in (-3, -2, -1, 0)
      group by RM.BUSY_DATE
      order by 1 desc
      into   :guests_max, :busy_group_type;
    end
    if ((:beds + :extra_beds) < :guests_max) then begin
      err_code = -8;
      err_text = f_character(29)||:ROOM_NAME||f_character(28)||:guests_max||f_character(28)||(:beds + :extra_beds);
      if (:busy_group_type in (1)) then begin
        overrule_need = :err_code;
        overrule_context = :err_text;
        err_code = 0;
        err_text = '';
      end else begin
        exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      end
    end

    update ROOMS RU
    set    RU.ID_ROOM_TYPE = :id_room_type,
           RU.ROOM_NAME = :room_name,
           RU.FLOOR = :floor,
           RU.BEDS = :beds,
           RU.EXTRA_BEDS = :extra_beds,
           RU.SECTOR = :sector,
           RU.FEATURES = :features,
           RU.SORT_ORDER = :sort_order,
           --RU.ID_HOTEL = :rebuild_id_hotel,
           RU.EXTERNAL_NAME = :external_name,
           RU.ID_EATING_OBJECT = :ID_EATING_OBJECT
    where  RU.ID_ROOM = :id_room;

    if ((:room_name <> :old_room_name)
        or (:floor <> :old_floor)
        or (:sector <> :old_sector)
        or (:extra_beds <> :old_extra_beds)) then
    begin
      action_text = f_character(29) || '(' || :old_room_name || '/' || :old_floor || '/' || :old_sector || '/'
                    || :old_extra_beds || ')' || f_character(28) || '(' || :room_name || '/' || :floor || '/'
                    || :sector || '/' || :extra_beds || ')';
      execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_PARAMS_CHANGED', :action_text);
    end

    if (:room_name <> :old_room_name) then begin
      update ACCOUNT_POST AP
      set    AP.ROOM_NAME = :room_name
      where  AP.ROOM_NAME = :old_room_name;
    end

  end else if (:operation = 'add') then begin
    select rt.ID_HOTEL
    from   ROOM_TYPES RT
    where  rt.ID_ROOM_TYPE = :ID_ROOM_TYPE
    into   :id_hotel;

    insert into ROOMS (
      ID_ROOM, ID_ROOM_TYPE, ROOM_NAME, FLOOR, BEDS, EXTRA_BEDS, SECTOR,
      FEATURES, SORT_ORDER, ID_HOTEL, EXTERNAL_NAME, ID_EATING_OBJECT)
    values (gen_id(ID_ROOM_GEN, 1), :id_room_type, :room_name, :floor, :beds, :extra_beds, :sector,
      :features, :sort_order, :id_hotel, :external_name, :ID_EATING_OBJECT)
    returning ID_ROOM into :NEW_ID_ROOM;

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :sys_date;

    execute procedure ROOM_PERIOD_MODIFY$PMS(null, :new_id_room, :sys_date, 'HOTEL', 'add')
    returning_values  :no_use;

    insert into ROOMS_ADD (ID_ROOM, PMS_MARKERS, ADDRESS)
    values (:new_id_room, null, null);
  end else if (:operation = 'del') then begin
    -- Booked rooms are preserved with FK constraint on room_magic
    execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'DELETE', '');

    select RT.ID_ROOM_TYPE, RT.ID_HOTEL
    from   ROOM_TYPES RT
    where  RT.ID_ROOM_TYPE = :id_room_type
    into   :rebuild_id_room_type, :rebuild_id_hotel;

    delete from ROOMS where ID_ROOM = :id_room;

    execute procedure ALLOTMENT_PHYS_REBUILD$INT(:rebuild_id_hotel, :rebuild_id_room_type);

    when sqlcode -530 do begin
      -- Violation of FOREIGN KEY constraint "%s" on table "%s"
      exception ASSERT '-34';
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: ROOM_PERIOD_MODIFY$PMS for: ROOM_PERIOD_MODIFY$INT */
ALTER PROCEDURE ROOM_PERIOD_MODIFY$PMS(ID_ROOM_PERIOD INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
STATUS VARCHAR(30),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_PERIOD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ROOM_PERIOD_MODIFY$INT) */
ALTER PROCEDURE ROOM_PERIOD_MODIFY$INT(ID_ROOM_PERIOD INTEGER,
FROM_DATE DATE,
STATUS VARCHAR(30))
 AS
declare variable id_room integer;
  declare variable old_status varchar(30);
  declare variable old_from_date date;
  declare variable id_account_post integer;
  declare variable id_pms_event integer;
  declare variable action_text varchar(255);
  declare variable to_date date;
  declare variable prev_period_status varchar(30);
  declare variable old_id_room_contract integer;
begin
  select R.STATUS, R.FROM_DATE, r.TO_DATE, r.ID_ROOM
  from   ROOM_PERIOD$PMS R
  where  R.ID_ROOM_PERIOD = :id_room_period
  into   :old_status, :old_from_date, :to_date, :id_room;

  select first 1 rpm.status
  from   ROOM_PERIOD$PMS rpm
  where  rpm.id_room = :id_room
         and rpm.from_date < :old_from_date
  order by rpm.from_date desc
  into   :prev_period_status;

  if (:STATUS <> :old_status) then begin
    execute procedure ROOM_STATUS_CHECK$INT (:ID_ROOM, :from_date, :to_date, :old_status, :STATUS);
  end

  if (:old_from_date < :FROM_DATE) then begin
    execute procedure ROOM_STATUS_CHECK$INT (:ID_ROOM, :old_from_date, :from_date, :old_status, :prev_period_status);
  end else if (:old_from_date > :FROM_DATE) then begin
    execute procedure ROOM_STATUS_CHECK$INT (:ID_ROOM, :from_date, :old_from_date, :prev_period_status, :STATUS);
  end

  if ((:old_from_date <> :FROM_DATE) or (:STATUS <> :old_status)) then begin
    for
      select AP1.ID_ACCOUNT_POST, AP1.ID_PMS_EVENT
      from   ACCOUNT_POST$PMS AP1
             join ACCOUNT$PMS A1 on A1.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS
             join PMS_EVENT$PMS E1 on E1.ID_PMS_EVENT = AP1.ID_PMS_EVENT
      where  AP1.DATE_POST between :old_from_date and :to_date
             and E1.ID_ROOM = :id_room
             and A1.IS_SHADOW = 1
             and AP1.LINE_STATUS = 11 /*  anulirat se samo aktiwnite nachisleniq. Ako ima dokumentirani?! ili anulirani, ne se pipat  */
      into   :id_account_post, :id_pms_event
    do begin
      execute procedure ACCOUNT_POST_PMS_ANUL$INT(:id_pms_event, :id_account_post);
    end
  end
  
  update ROOM_PERIOD$PMS p
  set    p.FROM_DATE = :from_date,
         p.STATUS = :status
  where  p.ID_ROOM_PERIOD = :id_room_period;

  execute procedure ROOM_PERIOD_TODATE$INT(:id_room);

  action_text = f_character(29) || '@{period_room_status.'||:old_status||'}'
                || f_character(28) || iif(extract(year from :old_from_date) = 2500, '~', formatdate(:old_from_date, 'dd.mm.yyyy'))
                || f_character(28) || iif(extract(year from :to_date) = 2500, '~', formatdate(:to_date, 'dd.mm.yyyy'))
                || f_character(28) || '@{period_room_status.'||:status||'}'
                || f_character(28) || iif(extract(year from :from_date) = 2500, '~', formatdate(:from_date, 'dd.mm.yyyy'))
                || f_character(28) || iif(extract(year from :to_date) = 2500, '~', formatdate(:to_date, 'dd.mm.yyyy'));

  execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_STATUS_CHANGED', :action_text);

  if((:status in ('PRIVATE', 'CONTRACT')) and (:from_date <> :old_from_date)) then begin
    select first 1 rcp.id_room_contract
    from   ROOM_CONTRACT$PMS rcp
    where  rcp.id_room_period = :id_room_period
    into   :old_id_room_contract;

    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :OLD_ID_ROOM_CONTRACT, 'ROOM_STATUS_CHANGED', :action_text);
  end

end
^

/* empty dependent procedure body */
/* Clear: ROOM_CONTRACT_MODIFY$PMS for: ROOM_PERIOD_MODIFY$PMS */
ALTER PROCEDURE ROOM_CONTRACT_MODIFY$PMS(ID_ROOM_CONTRACT INTEGER,
ID_ROOM_PERIOD INTEGER,
CONTRACT_TYPE VARCHAR(50),
PMS_MARKERS BLOB SUB_TYPE 1 SEGMENT SIZE 100,
IMPORT_INCOME_WITH_VAT SMALLINT,
ID_RENTAL_POOL INTEGER,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_CONTRACT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_MODIFY$PMS for: ROOM_PERIOD_MODIFY$PMS */
ALTER PROCEDURE ROOM_MODIFY$PMS(ID_ROOM INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
BEDS INTEGER,
EXTRA_BEDS INTEGER,
SECTOR INTEGER,
SORT_ORDER INTEGER,
FEATURES BLOB SUB_TYPE 1 SEGMENT SIZE 100,
EXTERNAL_NAME VARCHAR(10),
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER,
OPERATION VARCHAR(20))
 RETURNS(OVERRULE_NEED SMALLINT,
OVERRULE_CONTEXT VARCHAR(255),
NEW_ID_ROOM INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ROOM_PERIOD_MODIFY$PMS) */
ALTER PROCEDURE ROOM_PERIOD_MODIFY$PMS(ID_ROOM_PERIOD INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
STATUS VARCHAR(30),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_PERIOD INTEGER)
 AS
declare variable id_hotel integer;
  declare variable old_status varchar(30);
  declare variable old_from_date date;
  declare variable id_room_type integer;
  declare variable to_date date;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  execute procedure SYSTEM_CHECK_OPERATION(:status, 'HOTEL, PRIVATE, CONTRACT, INACTIVE', 'Status');

  if (:operation = 'add') then begin
     execute procedure ROOM_PERIOD_ADD$INT (:ID_ROOM_PERIOD, :ID_ROOM, :FROM_DATE, :STATUS)
     returning_values (:NEW_ID_ROOM_PERIOD);

  end else if (:operation = 'mod') then begin
    if (exists (select *
                from   ROOM_PERIOD$PMS R
                where  R.ID_ROOM = :ID_ROOM
                       and R.FROM_DATE = :FROM_DATE
                       and r.ID_ROOM_PERIOD <> :ID_ROOM_PERIOD)) then exception PMS_EXCEPTION '-612';
  
    select R.STATUS, R.FROM_DATE, r.TO_DATE
    from   ROOM_PERIOD$PMS R
    where  R.ID_ROOM_PERIOD = :id_room_period
    into   :old_status, :old_from_date, :to_date;

    if ((:FROM_DATE > :to_date)
        or exists (select pp.ID_ROOM_PERIOD
                   from   ROOM_PERIOD$PMS pp
                   where  pp.ID_ROOM = :id_room
                          and pp.FROM_DATE < :old_from_date
                          and pp.FROM_DATE > :FROM_DATE) ) then
    begin
      -- spring over neighbour period (from date)
      execute procedure ROOM_PERIOD_DEL$INT (:ID_ROOM_PERIOD);

      execute procedure ROOM_PERIOD_ADD$INT (:ID_ROOM_PERIOD, :ID_ROOM, :FROM_DATE, :STATUS)
      returning_values (:NEW_ID_ROOM_PERIOD);
    end else if ((:old_status <> :status) or (:old_from_date <> :from_date)) then begin
      execute procedure ROOM_PERIOD_MODIFY$INT (:ID_ROOM_PERIOD, :FROM_DATE, :STATUS);
      NEW_ID_ROOM_PERIOD = :ID_ROOM_PERIOD;
    end

  end else if (:operation = 'del') then begin
    execute procedure ROOM_PERIOD_DEL$INT (:ID_ROOM_PERIOD);
    NEW_ID_ROOM_PERIOD = null;

  end

  /* rebuild physical allotment */
  if ( (:operation in ('add', 'del'))
       or
       ((:operation = 'mod') and ((:old_status <> :status) or (:old_from_date <> :from_date)))) then
  begin
    select RT.ID_HOTEL, R.ID_ROOM_TYPE
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :id_room
    into   :id_hotel, :id_room_type;

    execute procedure ALLOTMENT_PHYS_REBUILD$INT(:id_hotel, :id_room_type);
  end

end
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_MODIFY for: SAFE_OCCUPANCY_POSTING$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE /* TYPE OF ID */ INTEGER,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100))
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_NEW for: SAFE_OCCUPANCY_POSTING$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE /* TYPE OF ID */ INTEGER,
FROM_DATETIME /* TDATETIME */ TIMESTAMP,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100),
BOOKING_NUMBER /* TYPE OF TRES_NUMBER */ VARCHAR(62),
ID_EXTERNAL_CLIENT_ACCCOUNT /* TYPE OF ID_REF */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER,
ID_RESOURCE_RESERVATION /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SAFE_OCCUPANCY_POSTING$INT) */
ALTER PROCEDURE SAFE_OCCUPANCY_POSTING$INT(ID_RESOURCE_RESERVATION TYPE OF ID,
ID_SERVICE TYPE OF ID,
PRICE TYPE OF TPRICE,
CURRENCY TYPE OF TCURRENCY,
PRICE_DESCRIPTION TYPE OF TDESCRIPTION_SHORT,
ID_RESERV_DETAIL TYPE OF ID,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF = null)
 RETURNS(DOC_SELECTED TYPE OF TRANGE)
 AS
declare variable from_datetime timestamp;
  declare variable to_datetime timestamp;
  declare variable ap_dbkey TDB_KEY;
  declare variable id_account_post integer;
  declare variable safe_name TOBJECT_NAME;
  declare variable no_use varchar(255);
  declare variable new_ac varchar(2);
  declare variable err_code integer;
  declare variable err_text varchar(255) ;
  declare variable occupant_name tperson_name;
  declare variable id_room integer;
  declare variable id_tariff integer;
begin
  DOC_SELECTED = null;
  select od.FROM_DATETIME, od.TO_DATETIME, ap.RDB$DB_KEY, ap.ID_ACCOUNT_POST,
         s.SAFE_NAME, rr.OCCUPANT_NAME, ap.ID_ROOM, ap.ID_TARIFF
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join SAFES s on s.ID_SAFE = od.ID_RESOURCE
         left outer join RESOURCE_RESERV_POST rrp on rrp.ID_RESOURCE_RESERVATION = rr.ID_RESOURCE_RESERVATION
         left outer join ACCOUNT_POST ap on ap.ID_ACCOUNT_POST = rrp.ID_ACCOUNNT_POST
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :from_datetime, :to_datetime, :ap_dbkey, :id_account_post,
         :safe_name, :occupant_name, :id_room, :id_tariff;

  new_ac = null;
  if (:id_account_post is not null) then begin
    execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
            :id_tariff, :id_room, 1, 0, :price, :currency, null, null, 'RESOURCE', :from_datetime, :TO_DATETIME, 1)
    returning_values :no_use, :no_use, :new_ac;
  end else begin
    if (:id_reserv_detail is not null) then begin
      execute procedure POST_SERVICE_ON_RESERVATION$INT (:id_reserv_detail, :id_service, 1, 0,
              1, :price, :currency, :from_datetime, :to_datetime,
              '', '', cast(:from_datetime as date), 'RESOURCE', null)
      returning_values (:ERR_CODE, :ERR_TEXT, :no_use, :id_account_post);
      if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      new_ac = '00';
    end else if (:ID_EXTERNAL_CLIENT_ACCCOUNT is not null) then begin
      execute procedure POST_SERVICE_ON_ACCOUNT$INT (:ID_EXTERNAL_CLIENT_ACCCOUNT, :id_service,
              1, 0, 1, :price, :currency, :from_datetime, :TO_DATETIME, '', '',
              cast(:from_datetime as date), 'RESOURCE', null, null)
      returning_values (:err_code, :err_text, :id_account_post);
      if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      new_ac = '00';
    end
  end

  if (:new_ac is null) then
    exception ASSERT '-1067' || f_character(31) || f_character(29) || :safe_name || f_character(28) || :occupant_name;

  if (:new_ac = '00') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);
    update ACCOUNT_POST AP
    set    ap.DOC_SELECTED = :DOC_SELECTED
    where  ap.ID_ACCOUNT_POST = :id_account_post;
  end

  update or insert into ACCOUNT_POSTING_DET (ID_ACCOUNT_POST, POST_TEXT, QTY,
         FROM_DATETIME, TO_DATETIME, RESOURCE_TEXT, EXT_USER_ANUL)
  values (:id_account_post, :safe_name ||' / '||formatdate(:from_datetime, 'D;dd.mm.yy(hh:mm)')||' - '||formatdate(:to_datetime, 'D;dd.mm.yy(hh:mm)')||' / '
          ||substring(replace(:price_description, F_CRLF(), ';') from 1 for 100), 1, :from_datetime, :to_datetime, :safe_name, null);

  if (not exists (select rp.ID_ACCOUNNT_POST
                  from   RESOURCE_RESERV_POST rp
                  where  rp.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION
                         and rp.ID_ACCOUNNT_POST = :id_account_post)) then
  begin
    insert into RESOURCE_RESERV_POST (ID_RESOURCE_RESERVATION, ID_ACCOUNNT_POST)
    values (:id_resource_reservation, :id_account_post);
  end
end
^

/* Alter (SAFE_USAGE_RATING) */
ALTER PROCEDURE SAFE_USAGE_RATING(ID_SAFE_TYPE TYPE OF ID,
FROM_DATETIME TYPE OF TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
ID_AGENT_PROFILE TYPE OF ID_REF)
 RETURNS(ID_SERVICE TYPE OF ID,
PRICE TYPE OF TPRICE,
CURRENCY TYPE OF TCURRENCY,
RATING_UNITS TYPE OF TQTY,
PRICE_DESCRIPTION TDESCRIPTION_LONG)
 AS
declare variable expire_tolerance integer;
  declare variable usage_duration double precision;
  declare variable remain_units numeric(15,2);
  declare variable expire double precision;
  declare variable id_resource_rate integer;
  declare variable units_price tprice;
  declare variable units TRANGE;
  declare variable id_resource_rate_price integer;
  declare variable id_rrp_list varchar(4000);
  declare variable units_cnt integer;
begin
  PRICE = null;
  id_rrp_list = null;

  select rr.ID_SERVICE, rr.CURRENCY, rt.EXPIRE_TOLERANCE, rt.ID_RESOURCE_RATE
  from   SAFE_TYPE RT
         join RESOURCE_RATE rr on rr.ID_RESOURCE_RATE = rt.ID_RESOURCE_RATE
  where  rt.ID_SAFE_TYPE = :ID_SAFE_TYPE
  into   :ID_SERVICE, :CURRENCY, :expire_tolerance, :id_resource_rate;

  expire_tolerance = coalesce(:EXPIRE_TOLERANCE, 0);
  usage_duration = :TO_DATETIME - :FROM_DATETIME;
  if (:usage_duration < 0) then exception ASSERT '-1063';

  rating_units = floor(:usage_duration);
  expire = floor((:usage_duration - :rating_units) * 24 * 60);
  if ((:expire > :expire_tolerance) or (:RATING_UNITS = 0)) then rating_units = :rating_units + 1;

  remain_units = :RATING_UNITS;
  while (:remain_units > 0) do begin
    units_price = null;
    -- get first smaller unit pack price
    select first 1 rp.UNITS, rp.PRICE, RP.ID_RESOURCE_RATE_PRICE
    from   RESOURCE_RATE_PRICE rp
    where  rp.ID_RESOURCE_RATE = :id_resource_rate
           and ((rp.ID_AGENT_PROFILE = :ID_AGENT_PROFILE) or (rp.ID_AGENT_PROFILE is null))
           and rp.UNITS <= :remain_units
    order by rp.ID_AGENT_PROFILE asc nulls last, rp.UNITS desc
    into   :units, :units_price, :id_resource_rate_price;

    if (:units_price is null) then begin
      -- get first greater unit pack price
      select first 1 rp.UNITS, rp.PRICE, RP.ID_RESOURCE_RATE_PRICE
      from   RESOURCE_RATE_PRICE rp
      where  rp.ID_RESOURCE_RATE = :id_resource_rate
             and ((rp.ID_AGENT_PROFILE = :ID_AGENT_PROFILE) or (rp.ID_AGENT_PROFILE is null))
             and rp.UNITS > :remain_units
      order by rp.ID_AGENT_PROFILE asc nulls last, rp.UNITS asc
      into   :units, :units_price, :id_resource_rate_price;
    end
    if (:units_price is null) then exception ASSERT '-1063';

    id_rrp_list = coalesce(:id_rrp_list || ',', '') || :id_resource_rate_price;
    price = coalesce(:PRICE, 0) + :units_price;
    --PRICE_DESCRIPTION = substring(coalesce(:PRICE_DESCRIPTION || F_CRLF(), '') || :units || ' = ' || :units_price || ' ' || :CURRENCY from 1 for 255);
    remain_units = :remain_units - coalesce(:units, 0);
  end

  for
    select   RP.ID_RESOURCE_RATE_PRICE,
             sum(1),
             min(RP.PRICE)
    from     SYSTEM_STRING_PARSER(:id_rrp_list, ',') SP
             join RESOURCE_RATE_PRICE RP on RP.ID_RESOURCE_RATE_PRICE = SP.ITEM
    group by 1
    order by 2 desc
    into   :id_resource_rate_price, :units_cnt, :units_price
  do begin
    PRICE_DESCRIPTION = substring(coalesce(:PRICE_DESCRIPTION || F_CRLF(), '') || :units_cnt || ' x ' || formatfloat(:units_price, 'F;0.00') || ' ' || :CURRENCY from 1 for 255);
  end

  suspend;
end
^

/* Alter (SERVICE_TAXATION_MODIFY$CFG) */
ALTER PROCEDURE SERVICE_TAXATION_MODIFY$CFG(ID_TAX_POLICY TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_SALE_TAXATION TYPE OF ID)
 AS
declare variable dbkey char(8);
  declare variable nat_round_to numeric(15,4);
  declare variable nat_curr varchar(3);
  declare variable action_text varchar(255);
  declare variable old_sale_taxation_name varchar(50);
  declare variable service_name varchar(30);
  declare variable id_hotel integer;
  declare variable id_rate integer;
  declare variable passed_nights integer;
  declare variable id_posting_sale_taxation integer;
begin
  if (:ID_SALE_TAXATION is null) then begin
    delete from SERVICE_TAXATION T
    where  t.ID_TAX_POLICY = :ID_TAX_POLICY
           and t.ID_SERVICE = :ID_SERVICE;

    select f_character(29) || se.service_name
    from   SERVICES se
    where  se.id_service = :id_service
    into   :action_text;
    execute procedure SYSTEM_LOG_ADD ('TAX_POLICY', :id_tax_policy, 'TAX_POLICY_SERVICE_DELETED', :action_text);
  end else begin
    select sta.name, se.service_name, se.ID_HOTEL
    from   SERVICE_TAXATION TPT
           join SALE_TAXATION sta on sta.id_sale_taxation = tpt.id_sale_taxation
           join SERVICES se on se.id_service = tpt.id_service
    where  TPT.ID_TAX_POLICY = :ID_TAX_POLICY
           and TPT.ID_SERVICE = :ID_SERVICE
    into   :old_sale_taxation_name, :service_name, :id_hotel;

    update SERVICE_TAXATION T
    set    T.ID_SALE_TAXATION = :ID_SALE_TAXATION
    where  T.ID_TAX_POLICY = :ID_TAX_POLICY
           and T.ID_SERVICE = :ID_SERVICE;

    if (row_count > 0) then begin
      select st.name
      from   SALE_TAXATION st
      where  st.id_sale_taxation = :id_sale_taxation
      into   :action_text;
      action_text = f_character(29) || :service_name || f_character(28) || :old_sale_taxation_name || f_character(28) || :action_text;
      execute procedure SYSTEM_LOG_ADD ('TAX_POLICY', :id_tax_policy, 'TAX_POLICY_SERVICE_UPDATED', :action_text);
    end else begin
      insert into SERVICE_TAXATION (ID_TAX_POLICY, ID_SERVICE, ID_SALE_TAXATION)
      values (:ID_TAX_POLICY, :ID_SERVICE, :ID_SALE_TAXATION);
    end
  
    select h.NATION_CURR
    from   HOTEL H
    where  h.ID_HOTEL = :id_hotel
    into   :nat_curr;

    select C.ROUND_TO
    from   CURRS C
    where  c.CURR = :nat_curr
    into   :nat_round_to;
  
    for
      select AP.RDB$DB_KEY, ap.ID_TARIFF, ap.DATE_POST - ap.FROM_DATE
      from   ACCOUNT A
             join ACCOUNT_POST AP on AP.ID_ACCOUNT = A.ID_ACCOUNT
      where  A.ID_TAX_POLICY = :ID_TAX_POLICY
             and A.IS_ARCHIVE = 0
             and AP.ID_SERVICE = :ID_SERVICE
             and AP.ID_BASE_DOC is null
             and AP.ID_SALE_TAXATION is distinct from :ID_SALE_TAXATION
             and ap.IS_ANUL = 0
      into   :dbkey, :id_rate, :passed_nights
    do begin
      execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :ID_TAX_POLICY, :id_rate, :passed_nights)
      returning_values (:id_posting_sale_taxation);

      if (:id_posting_sale_taxation = :ID_SALE_TAXATION) then begin
        execute procedure ACCOUNT_POSTING_UPDATE_TAX$INT (:dbkey, :ID_SALE_TAXATION, :nat_round_to, 'SERVICE VAT CHANGED');
      end

    end
  end
end
^

/* empty dependent procedure body */
/* Clear: ACC_STATEMENT_INVOICES_GET$PMS for: SETTING_GET_VALUE */
ALTER PROCEDURE ACC_STATEMENT_INVOICES_GET$PMS(ID_BILL INTEGER)
 RETURNS(ID_DOC INTEGER,
ID_SERVICE INTEGER,
DATE_POST DATE,
ROOM_NAME VARCHAR(100),
LINE_DESC VARCHAR(100),
OUTGO_VALUE NUMERIC(15,4),
CURR_POST VARCHAR(3),
IS_ANUL SMALLINT,
INV_DESCRIPTION VARCHAR(100))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_RATE_GET for: SETTING_GET_VALUE */
ALTER PROCEDURE ACCOUNT_POSTING_RATE_GET(ID_HOTEL /* TYPE OF ID */ INTEGER,
CURR /* TYPE OF TCURRENCY */ CHAR(3),
FOR_DATE /* TYPE OF TDATE */ DATE,
ID_GUEST /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(CURR_RATE /* TYPE OF TRATE */ NUMERIC(15,6))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTS_EW_MARK$INT for: SETTING_GET_VALUE */
ALTER PROCEDURE ACCOUNT_POSTS_EW_MARK$INT(ID_END_WORK INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: BLOCK_ANNUL$BLK for: SETTING_GET_VALUE */
ALTER PROCEDURE BLOCK_ANNUL$BLK(ID_BLOCK_ROOM INTEGER,
OPERATION VARCHAR(30))
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: CURR_RATE_MODIFY for: SETTING_GET_VALUE */
ALTER PROCEDURE CURR_RATE_MODIFY(CURR CHAR(3),
ID_HOTEL INTEGER,
RATE NUMERIC(15,6),
FOR_DATE DATE = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: CURR_RATES_PREPARE$INT for: SETTING_GET_VALUE */
ALTER PROCEDURE CURR_RATES_PREPARE$INT(DOC_SELECTED INTEGER,
ID_ACCOUNT INTEGER,
DOC_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOC_TYPE_GET$INT for: SETTING_GET_VALUE */
ALTER PROCEDURE DOC_TYPE_GET$INT(ID_HOTEL /* TYPE OF ID */ INTEGER,
IS_PROFORMA /* TYPE OF TLOGICAL */ SMALLINT,
ID_ADVANCE_PAYMENT /* TYPE OF ID */ INTEGER = null)
 RETURNS(ID_DOC_TYPE /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_POSTINGS_GET$INT for: SETTING_GET_VALUE */
ALTER PROCEDURE DOCUMENT_POSTINGS_GET$INT(IN_UNIQ_SELECT INTEGER,
ID_ACCOUNT INTEGER,
DOC_CURR VARCHAR(3),
DOC_RATE NUMERIC(15,6))
 RETURNS(AP_DBKEY CHAR(8),
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER,
DATE_POST DATE,
SERVICE_NAME VARCHAR(100),
QTY_POST NUMERIC(15,4),
PRICE_POST DOUBLE PRECISION,
TO_DATE DATE,
FROM_DATE DATE,
ID_SALE_TAXATION INTEGER,
IS_CORRECT INTEGER,
ID_GUEST INTEGER,
ROOM_NAME VARCHAR(10),
IS_BASE SMALLINT,
GROUP_TAG INTEGER,
MASTER_ADDINS INTEGER,
ID_PACK_SERVICE INTEGER,
RATE_POST NUMERIC(15,6),
POST_RATE_IN_DOC NUMERIC(15,6),
DOC_PRICE_WOT_DIFF DOUBLE PRECISION)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_TAXES_EVAL$INT for: SETTING_GET_VALUE */
ALTER PROCEDURE DOCUMENT_TAXES_EVAL$INT(ID_DOC_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: EAI_MAP_SERVICE for: SETTING_GET_VALUE */
ALTER PROCEDURE EAI_MAP_SERVICE(SERVICE_TAG VARCHAR(30),
SERVICE_NAME VARCHAR(30),
EXTERNAL_IFC VARCHAR(30),
ID_HOTEL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_MAPPED_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: END_WORK for: SETTING_GET_VALUE */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: GUEST_ADDRESSCARD_SET$RSV for: SETTING_GET_VALUE */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$RSV(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
EGN VARCHAR(30),
COUNTRY VARCHAR(10),
ID_STAY_REASON INTEGER,
IS_REGISTRED INTEGER,
PASS_PLACE VARCHAR(20),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_PLACE VARCHAR(30),
SEX CHAR,
MASK VARCHAR(10),
IS_CHILD INTEGER,
CAR VARCHAR(30),
KPP INTEGER,
KPP_DATE DATE,
PASS_EXP_DATE DATE,
AGE INTEGER,
BIRTH_DAY DATE,
VISA /* TDESCRIPTION_SHORT */ VARCHAR(100),
RATING_AGE INTEGER = null,
TITLE VARCHAR(10) = null,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: GUESTS_TT_NUM_REGENERATE for: SETTING_GET_VALUE */
ALTER PROCEDURE GUESTS_TT_NUM_REGENERATE(ID_HOTEL /* ID */ INTEGER,
FROM_DATE /* TDATE */ DATE)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: OCCUPANCY_OVERBOOK_CHECK$INT for: SETTING_GET_VALUE */
ALTER PROCEDURE OCCUPANCY_OVERBOOK_CHECK$INT(ID_AGENT INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM_TYPE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: OCCUPANCY_ROOM_VALIDATE$INT for: SETTING_GET_VALUE */
ALTER PROCEDURE OCCUPANCY_ROOM_VALIDATE$INT(ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_OCCUPANT INTEGER,
OCC_BUSY_GRP_TYPE INTEGER,
REQUEST_GUEST_CNT INTEGER,
CHECK_OPTIONS VARCHAR(255))
 RETURNS(SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PAYMENT_GET_DEFAULT$INT for: SETTING_GET_VALUE */
ALTER PROCEDURE PAYMENT_GET_DEFAULT$INT(ID_ACCOUNT INTEGER)
 RETURNS(ID_PAY_DOC_TYPE INTEGER,
PAY_CURR VARCHAR(3))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_PERSON_CREATEQ$PROFILE for: SETTING_GET_VALUE */
ALTER PROCEDURE PROFILE_PERSON_CREATEQ$PROFILE(PROFILE_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100),
PHONE /* TYPE OF TPHONE */ VARCHAR(50),
ID_PASSPORT_TYPE /* TYPE OF ID */ INTEGER,
PASS_NUM /* TYPE OF NAME_20 */ VARCHAR(20),
EGN /* TYPE OF TTEXT_SHORT */ VARCHAR(30),
COUNTRY_CODE /* TYPE OF TSHORT_CODE */ VARCHAR(10),
CARD_CODE /* TYPE OF TCARD_CODE */ VARCHAR(50),
ID_PERSON_DATA /* TYPE OF ID_REF */ INTEGER = null,
TITLE /* TYPE OF TSHORT_CODE */ VARCHAR(10) = null,
ID_HOTEL /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_PROFILE /* TYPE OF ID */ INTEGER,
P_DBKEY /* TYPE OF TDB_KEY */ CHAR(8),
PD_DBKEY /* TYPE OF TDB_KEY */ CHAR(8))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: REP_ROOM_STATUS_BUILD$INT for: SETTING_GET_VALUE */
ALTER PROCEDURE REP_ROOM_STATUS_BUILD$INT(ID_ROOM INTEGER,
FOR_DATE DATE,
STAT_OPTIONS VARCHAR(255))
 RETURNS(IS_LEAVING SMALLINT,
IS_COMMING SMALLINT,
IS_SHARED SMALLINT,
IS_LEAVING_WORDS VARCHAR(30),
BUSY_GRP INTEGER,
DAYS_THIS_STATUS INTEGER,
DTS_CONTEXT VARCHAR(10),
COMMING_OCCUPANTS VARCHAR(1024),
ID_BLOCK_ROOM INTEGER,
OTHER_OCCUPANTS VARCHAR(1024),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_DETAIL$INT for: SETTING_GET_VALUE */
ALTER PROCEDURE RES_CREATE_DETAIL$INT(ID_RESERV_DETAIL INTEGER,
ID_AGENT_PROFILE INTEGER,
NUMBER VARCHAR(62),
CHECK_STATUS INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
EXP_DATE DATE,
COMMING_KIND INTEGER,
LEAVING_KIND INTEGER,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
NOTE VARCHAR(2000),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_BOARD INTEGER,
ID_ROOM INTEGER,
ID_RATE INTEGER,
ID_ROOM_TYPE INTEGER,
COUNTRY VARCHAR(20),
VAUCHER_DATE DATE,
VAUCHER_NUM VARCHAR(20),
VAUCHER_TEXT VARCHAR(30),
VAUCHER_DATE2 DATE,
VAUCHER_NUM2 VARCHAR(20),
CUSTOM_PRICE NUMERIC(15,2),
CUSTOM_CURRENCY VARCHAR(3),
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
ID_PERSON_PROFILE INTEGER,
ID_HOTEL INTEGER,
ACC_ROUTING VARCHAR(50),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_GROUP INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
RD_DBKEY CHAR(8))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_GET$RSV for: SETTING_GET_VALUE */
ALTER PROCEDURE RES_CREATE_GET$RSV(ID_HOTEL INTEGER)
 RETURNS(ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIMESTAMP,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIMESTAMP,
TRANSFER_OUT_NOTE VARCHAR(30),
IS_LATE_DEPARTURE INTEGER,
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
COUNTRY_CODE VARCHAR(20),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
CHECK_STATUS INTEGER,
ID_HK_PLAN INTEGER,
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_ROOM$INT for: SETTING_GET_VALUE */
ALTER PROCEDURE RES_CREATE_ROOM$INT(CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_COUNT INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_AGENT_PROFILE INTEGER,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_PERSON_PROFILE INTEGER,
ACC_ROUTING VARCHAR(50),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ID_GROUP INTEGER = null,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_GUARANTEE_POLICY INTEGER = null,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
RD_DBKEY CHAR(8),
NEW_ID_PERSON_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_ADD$INT for: SETTING_GET_VALUE */
ALTER PROCEDURE RES_GUEST_ADD$INT(RD_DBKEY CHAR(8),
IS_CHILD INTEGER)
 RETURNS(NEW_ID_GUEST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_PENDING_DEPOSITS_POST$INT for: SETTING_GET_VALUE */
ALTER PROCEDURE RES_PENDING_DEPOSITS_POST$INT(ID_RESERV_DETAIL /* ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ROOM$INT for: SETTING_GET_VALUE */
ALTER PROCEDURE RES_SAVE_ROOM$INT(RD_DBKEY /* TYPE OF TDB_KEY */ CHAR(8),
ID_ROOM /* TYPE OF ID */ INTEGER,
ID_RES_ROOM_TYPE /* TYPE OF ID */ INTEGER,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE /* TYPE OF TLOGICAL */ SMALLINT = null)
 RETURNS(WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_STAY$INT for: SETTING_GET_VALUE */
ALTER PROCEDURE RES_SAVE_STAY$INT(RD_DBKEY CHAR(8),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RESERVS_EXPIRE$INT for: SETTING_GET_VALUE */
ALTER PROCEDURE RESERVS_EXPIRE$INT(CLEAR_TODATE DATE,
ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_CREATE$RSV for: SETTING_GET_VALUE */
ALTER PROCEDURE RESMULTI_CREATE$RSV(ID_HOTEL INTEGER,
ID_ROOM_TYPE INTEGER,
TRANSFER_OUT_TIME TIME,
TRANSFER_IN_TIME TIME,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
TRANSFER_OUT_NOTE VARCHAR(50),
TRANSFER_IN_NOTE VARCHAR(50),
NOTE VARCHAR(255),
ID_BOARD INTEGER,
VOUCHER_DATE DATE,
VOUCHER_NUMBER VARCHAR(20),
VOUCHER_TEXT VARCHAR(30),
CHECK_STATUS INTEGER,
ID_TARIFF INTEGER,
COUNTRY_CODE VARCHAR(20),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
NOTE_REMINDERS VARCHAR(50),
TITULAR_NAME VARCHAR(100),
SPLIT_ON_CHECKIN INTEGER,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
NUMBER VARCHAR(62),
NEW_ID_TITULAR INTEGER,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE,
WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_PICKUP$INT for: SETTING_GET_VALUE */
ALTER PROCEDURE ROOM_PICKUP$INT(ID_ROOM_TYPE INTEGER,
RES_FROM_DATE DATE,
RES_TO_DATE DATE,
IS_EARLY_ARRIVAL SMALLINT,
IS_LATE_DEPARTURE SMALLINT,
OFFER_METHOD VARCHAR(20),
FROM_ROOM VARCHAR(20),
ROOM_REQUIREMENTS BLOB SUB_TYPE 1 SEGMENT SIZE 100,
MIN_BEDS_COUNT SMALLINT)
 RETURNS(OUT_ID_ROOM INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SPR_HOTEL_REGISTER for: SETTING_GET_VALUE */
ALTER PROCEDURE SPR_HOTEL_REGISTER(IN_FROM DATE,
IN_TO DATE,
IN_FROM_GUEST INTEGER,
IN_TO_GUEST INTEGER,
IN_MASK VARCHAR(10),
ID_HOTEL INTEGER = null)
 RETURNS(ID_GUEST INTEGER,
GUEST_NAME VARCHAR(50),
ROOM_NAME VARCHAR(10),
CITIZENSHIP_EGN VARCHAR(65),
PERIOD_FROM DATE,
PERIOD_TO DATE,
NIGHTS INTEGER,
RESERVATION VARCHAR(100),
ID_ACCOUNT_NIGHTS VARCHAR(30),
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
ADDRESS_BULGARIAN VARCHAR(100),
PASSPORT VARCHAR(40),
NOTE VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_MATCH_BOARD for: SETTING_GET_VALUE */
ALTER PROCEDURE TAR_MATCH_BOARD(TID_DBKEY CHAR(8),
ID_TAR_BP INTEGER,
BOARD_TYPE_FIND VARCHAR(10),
ID_BOARD INTEGER,
ID_BOARD_INCLUDE INTEGER,
MATCH_DATE DATE,
BASE_PER_DAY NUMERIC(15,4),
DAY_OF_STAY INTEGER,
CNT_DAYS_BOARD INTEGER,
CNT_DAYS_BP INTEGER,
CUSTOM_PRICE NUMERIC(15,4))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SEPARATE_BOARD INTEGER,
SERVICE_TYPE VARCHAR(20),
BOARD_PRICE NUMERIC(15,4),
PTEXT VARCHAR(20),
ID_SERVICE INTEGER,
FOOD_PER_DAY NUMERIC(15,4),
PACKET_ITEM INTEGER,
DISC_TAG VARCHAR(50))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE for: SETTING_GET_VALUE */
ALTER PROCEDURE TAR_SAVE(ID_TAR_HEAD INTEGER,
PERIOD_DEPEND_ON_CHECKIN INTEGER,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BASE_BOARDS_LIST VARCHAR(255),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
BO_TYPE VARCHAR(20),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_BO_SEASON for: SETTING_GET_VALUE */
ALTER PROCEDURE TAR_SAVE_BO_SEASON(ID_TAR_HEAD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_PARSE_DAYSCHM for: SETTING_GET_VALUE */
ALTER PROCEDURE TAR_SAVE_PARSE_DAYSCHM(DAY_SCHEME_DATA VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
DAY_SCHEME VARCHAR(20),
DAY_SCHEME_NUM INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_PARSE_PARAM for: SETTING_GET_VALUE */
ALTER PROCEDURE TAR_SAVE_PARSE_PARAM(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
PARAM_FILTER VARCHAR(2000))
 RETURNS(ERR_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_PARSE_PNUM for: SETTING_GET_VALUE */
ALTER PROCEDURE TAR_SAVE_PARSE_PNUM(ID_TAR_HEAD INTEGER,
ID_BO INTEGER,
BO_TYPE VARCHAR(20),
POS_NUMBERS VARCHAR(2000),
PARAM_FILTER VARCHAR(2000))
 RETURNS(ERR_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_PARSE_PRICE for: SETTING_GET_VALUE */
ALTER PROCEDURE TAR_SAVE_PARSE_PRICE(PRICE_DATA VARCHAR(2000),
ID_BO INTEGER,
BO_TYPE VARCHAR(20),
ID_TAR_SEASON INTEGER)
 RETURNS(ERR_CODE INTEGER,
ID_BO_PRICE INTEGER,
PRICE_TYPE VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_PARSE_SEASON for: SETTING_GET_VALUE */
ALTER PROCEDURE TAR_SAVE_PARSE_SEASON(ID_TAR_HEAD INTEGER,
SEASON_DATA VARCHAR(2000))
 RETURNS(ERR_CODE INTEGER,
SEASON_FILTER VARCHAR(2000))
 AS
 BEGIN SUSPEND; END
^

/* Alter (SETTING_GET_VALUE) */
ALTER PROCEDURE SETTING_GET_VALUE(SETTING_CODE TYPE OF TSEARCH_CODE,
ID_HOTEL TYPE OF ID_REF)
 RETURNS(SETTING_VALUE TYPE OF TDESCRIPTION_LONG)
 AS
declare variable hotel_name varchar(50);
declare variable ctx_key varchar(255);
begin
  setting_value = null;
  if (:SETTING_CODE = 'ASCI_DELIMITER') then SETTING_CODE = 'RANGE_DATA_DELIMETER';

  ctx_key = 'SETTING_VALUE#:' || coalesce(:ID_HOTEL, 0) || '#' || coalesce(:SETTING_CODE, '') || '#';
  if (:ctx_key is not null) then SETTING_VALUE = RDB$GET_CONTEXT ('USER_TRANSACTION', :ctx_key);

  if (:SETTING_VALUE is null) then begin
    select sv.SETTING_VALUE
    from   SETTING_HOTEL_VALUE sv
    where  sv.SETTING_CODE = :SETTING_CODE
           and sv.ID_HOTEL = :ID_HOTEL
    into   :SETTING_VALUE;
  end

  if (:SETTING_VALUE is null) then begin
    execute procedure SYSTEM_INFO_GET (:SETTING_CODE)
    returning_values (:SETTING_VALUE);
  end

  if (:SETTING_VALUE is null ) then begin
    execute procedure sys_dbg('err SETTING_NOT_FOUND - "' || :SETTING_CODE || '"');
    select h.HOTEL_NAME
    from   HOTEL H
    where  h.ID_HOTEL = :ID_HOTEL
    into   :hotel_name;

    exception SETING_VALUE_NOT_FOUND f_character(29) || '@{set_name.' || :SETTING_CODE || '}'
              || f_character(28) || :hotel_name;
  end

  begin
    RDB$SET_CONTEXT ('USER_TRANSACTION', :ctx_key, :SETTING_VALUE);
    when sqlcode -901 do begin end
  end

  suspend;
end
^

/* Alter (SPR_HOTEL_REGISTER) */
ALTER PROCEDURE SPR_HOTEL_REGISTER(IN_FROM DATE,
IN_TO DATE,
IN_FROM_GUEST INTEGER,
IN_TO_GUEST INTEGER,
IN_MASK VARCHAR(10),
ID_HOTEL INTEGER = null)
 RETURNS(ID_GUEST INTEGER,
GUEST_NAME VARCHAR(50),
ROOM_NAME VARCHAR(10),
CITIZENSHIP_EGN VARCHAR(65),
PERIOD_FROM DATE,
PERIOD_TO DATE,
NIGHTS INTEGER,
RESERVATION VARCHAR(100),
ID_ACCOUNT_NIGHTS VARCHAR(30),
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
ADDRESS_BULGARIAN VARCHAR(100),
PASSPORT VARCHAR(40),
NOTE VARCHAR(255))
 AS
declare variable egn varchar(50);
  declare variable country_code varchar(20);
  declare variable country varchar(50);
  declare variable id_account integer;
  declare variable address varchar(100);
  declare variable city varchar(100);
  declare variable pass_num varchar(20);
  declare variable pass_date date;
  declare variable mask varchar(10);
begin
  select  coalesce((select first 1 cast(:in_mask as varchar(10))
                   from   USER_RIGHTS R
                   where  R.RIGHT_CODE = 'MASK_DIFF_FROM_DEF'),
                  (select iif(coalesce(nullif(cast(:in_mask as varchar(10)), ''), SGV.SETTING_VALUE) is distinct from SGV.SETTING_VALUE, 'unknown', SGV.SETTING_VALUE)
                   from   SETTING_GET_VALUE('DEF_GUEST_MASK', :id_hotel) SGV))
  from    dummy
  into    :in_mask;
  
  for
    select G.ID_GUEST, GC.GUEST_NAME1, R.ROOM_NAME, GC.COUNTRY, CN.COUNTRY_NAME,
           GC.EGN, G.FROM_DATE, G.TO_DATE, G.ID_ACCOUNT, GC.BIRTH_DAY, GC.BIRTH_PLACE,
           GC.ADDRESS, gc.SITY, GC.PASS_NUM, GC.PASS_DATE, GC.MASK, RD.NUMBER
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
           left outer join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
           left outer join ROOMS R on G.ID_ROOM = R.ID_ROOM
           left outer join COUNTRY CN on CN.COUNTRY_CODE = GC.COUNTRY
    where  G.FROM_DATE between :IN_FROM and :IN_TO
           and rd.IS_ANUL = 0
           and RD.CHECK_STATUS >= 0
           and ((RD.ID_HOTEL = :id_hotel) or (:id_hotel is null))
    into   :ID_GUEST, :GUEST_NAME, :ROOM_NAME, :COUNTRY_CODE, :COUNTRY,
           :EGN, :PERIOD_FROM, :PERIOD_TO, :ID_ACCOUNT, :BIRTH_DATE, :BIRTH_PLACE,
           :ADDRESS, :city, :PASS_NUM, :PASS_DATE, :MASK, :RESERVATION
  do begin
    CITIZENSHIP_EGN = :COUNTRY;

    if ((:EGN is not null) and (EGN <> '')) then
      CITIZENSHIP_EGN = :CITIZENSHIP_EGN || ' (' || :EGN || ')';

    if (upper(:COUNTRY_CODE) = 'BG') then begin
      ADDRESS_BULGARIAN = substring(iif(trim(coalesce(:city, '')) <> '', :city || ' ' || :address, :address) from 1 for 100);
    end else begin
      ADDRESS_BULGARIAN = '';
    end

    if (:PASS_NUM is null) then PASS_NUM = '';
    PASSPORT = :PASS_NUM;
    if (:PASS_DATE is not null and :PASS_DATE <> '30.12.1899') then
      PASSPORT = trim(:PASSPORT || FORMATDATE(:PASS_DATE,'D; dd/mm/yyyy'));

    NIGHTS = :PERIOD_TO - :PERIOD_FROM;
    ID_ACCOUNT_NIGHTS = ''|| :ID_ACCOUNT || ' (' || :NIGHTS || ')';
    NOTE = '';
    if (((:IN_FROM_GUEST is null) or (:ID_GUEST >= :IN_FROM_GUEST))
        and ((:IN_TO_GUEST is null) or (:ID_GUEST <= IN_TO_GUEST))
        and ((:IN_MASK is null) or (:IN_MASK = '') or (:MASK like '%' || :IN_MASK||'%'))) then
      suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: GUEST_NUMERATOR_MODIFY$INT for: SYSTEM_NUMERATOR_MODIFY$INT */
ALTER PROCEDURE GUEST_NUMERATOR_MODIFY$INT(ID_NUMERATOR INTEGER,
NUM_NAME VARCHAR(50),
NUM_NEXT INTEGER,
OPERATION VARCHAR(20),
ID_HOTEL /* TYPE OF ID_REF */ INTEGER)
 RETURNS(NEW_ID_NUMERATOR INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: NUMERATOR_MODIFY$CFG for: SYSTEM_NUMERATOR_MODIFY$INT */
ALTER PROCEDURE NUMERATOR_MODIFY$CFG(ID_NUMERATOR INTEGER,
NUM_NAME VARCHAR(50),
NUM_NEXT INTEGER,
LEADING_PART VARCHAR(20),
NUM_LENGTH INTEGER,
NUM_CLASS /* TYPE OF TNAME_SHORT */ VARCHAR(30),
ID_HOTEL /* TYPE OF ID_REF */ INTEGER,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_NUMERATOR INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SYSTEM_NUMERATOR_MODIFY$INT) */
ALTER PROCEDURE SYSTEM_NUMERATOR_MODIFY$INT(ID_NUMERATOR INTEGER,
NUM_CLASS VARCHAR(30),
NUM_NAME VARCHAR(50),
NUM_VALUE INTEGER,
LEADING_PART VARCHAR(20),
NUM_LENGTH INTEGER,
ID_HOTEL TYPE OF ID_REF,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_NUMERATOR INTEGER)
 AS
declare variable restart_condition varchar(30);
  declare variable num_object integer;
  declare variable last_date date;
  declare variable old_num_value integer;
begin 
  restart_condition = 'NONE';
  num_object = :id_numerator;
  last_date = current_timestamp;

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:NUM_CLASS not in ('BOOKING', 'GUEST_NUM', 'DOCUMENT', 'PROFORMA', 'ANNUL_PROT', 'PAYMENT')) then
    exception NUMERATOR_EXCEPTION 'Invalid numerator class: ' || coalesce(:NUM_CLASS, '<null>');

  if (:OPERATION in ('add', 'mod') and ((:NUM_LENGTH > 20) or (char_length(coalesce(:LEADING_PART, '')) + char_length(:NUM_VALUE) > 20)) ) then
    exception NUMERATOR_EXCEPTION '-79';

  if (:operation = 'mod') then begin
    select SN.NUM_VALUE
    from   SYSTEM_NUMERATOR SN
    where  SN.ID_NUMERATOR = :id_numerator
    into   :old_num_value;

    if (:old_num_value > :NUM_VALUE) then exception NUMERATOR_EXCEPTION '-361';

    update SYSTEM_NUMERATOR
    set    NUM_NAME = :num_name,
           NUM_CLASS = :num_class,
           NUM_OBJECT = :num_object,
           RESTART_CONDITION = :restart_condition,
           NUM_VALUE = :NUM_VALUE,
           LAST_DATE = :last_date,
           LEADING_PART = :leading_part,
           NUM_LENGTH = :num_length,
           ID_HOTEL = :ID_HOTEL
    where  ID_NUMERATOR = :id_numerator;
    new_id_numerator = :id_numerator;
  end else if (:operation = 'add') then begin
    new_id_numerator = gen_id(GEN_SYSTEM_NUMERATOR_ID, 1);
    num_object = :new_id_numerator;

    insert into SYSTEM_NUMERATOR (ID_NUMERATOR, NUM_NAME, NUM_CLASS, NUM_OBJECT,
           RESTART_CONDITION, NUM_VALUE, LAST_DATE, LEADING_PART, NUM_LENGTH, ID_HOTEL)
    values (:new_id_numerator, :num_name, :num_class, :num_object,
           :restart_condition, :num_value, :last_date, :leading_part, :num_length, :id_hotel);
  end else if (:operation = 'del') then begin
    if (:NUM_CLASS = 'BOOKING') then exception NUMERATOR_EXCEPTION 'Unallowable operation! Can not delete booking numerator!';

    delete from SYSTEM_NUMERATOR
    where  ID_NUMERATOR = :id_numerator;

    when any do exception REF_INTEGRITY_DELETE;
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_EVAL_ALL$INT for: TAR_CALC_EVAL_DATE$INT */
ALTER PROCEDURE TAR_CALC_EVAL_ALL$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_EVAL_DATE$INT) */
ALTER PROCEDURE TAR_CALC_EVAL_DATE$INT(ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
FOR_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_input integer;
declare variable checkin_date date;
declare variable day_of_stay integer;
declare variable real_recalc integer;
declare variable id_guest integer;
declare variable input_detail_dbkey char(8);
declare variable id_room_type integer;
declare variable id_board integer;
declare variable id_tar_head integer;
declare variable id_type_stay integer;
declare variable id_hotel integer;
declare variable period_depend_on_checkin integer;
declare variable cnt_days_board integer;
declare variable cnt_days_bp integer;
declare variable tariff_curr char(3);
declare variable board_type_find varchar(10);
declare variable id_room integer;
declare variable custom_price numeric(15,4);
declare variable custom_currency char(3);
declare variable id_tar_input_detail integer;
declare variable is_simple integer;
declare variable guest_age integer;
declare variable tar_name varchar(50);
declare variable guest_name varchar(50);
declare variable total_guests integer;
declare variable old_id_room integer;
declare variable beds integer;
declare variable payors integer;
declare variable minors integer;
declare variable int_err_text varchar(255);
declare variable is_manual_type_stay smallint;
declare variable seq_num integer;
declare variable current_child_num integer;
declare variable current_adult_num integer;
begin
  ERR_CODE = 0;
  OLD_ID_ROOM = NULL;
  for
    select   TCI.ID_TAR_INPUT, TCI.FROM_DATE, (:FOR_DATE - TCI.FROM_DATE + 1),
             TCI.REAL_RECALC, TCI.ID_GUEST, TCID.RDB$DB_KEY, TCID.ID_ROOM_TYPE,
             TCID.ID_BOARD, TCID.ID_TAR_HEAD, TCID.ID_TYPE_STAY, TCID.IS_MANUAL_TYPE_STAY, T.ID_HOTEL,
             TH.PERIOD_DEPEND_ON_CHECKIN, TH.CNT_DAYS_PRICE_BOARD, TH.CNT_DAYS_PRICE_BP, T.CURR, TH.BOARD_TYPE,
             TCID.ID_ROOM, TCID.CUSTOM_PRICE, TCID.CUSTOM_CURRENCY,
             TCID.ID_TAR_INPUT_DETAIL, TH.IS_SIMPLE, TCI.GUEST_AGE
    from     TAR_CALC_INPUT_DETAIL$TMP TCID
             join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
             join TAR_HEAD TH on TH.ID_TAR_HEAD = TCID.ID_TAR_HEAD
             join TARIFA T on T.ID_TARIFA = TH.ID_TAR_HEAD
    where    TCI.ID_TAR_CALC = :ID_TAR_CALC
             and TCI.ROOM_STATUS = :ROOM_STATUS
             and TCID.FOR_DATE = :FOR_DATE
    order by TCID.ID_ROOM asc,
             iif(TCI.IS_CHILD = 1, TCI.GUEST_AGE, 999) desc,
             --iif(TCI.GUEST_AGE > 16, 999, TCI.GUEST_AGE) desc,
             TCID.CHECKIN_ORDER asc,
             TCI.ID_GUEST asc
             /* ADULTS MUST BE HANDLED FIRST, THEN BY CHECKIN ORDER and ID_GUEST because of shares */
    into     :id_tar_input, :checkin_date, :day_of_stay,
             :real_recalc, :id_guest, :input_detail_dbkey, :id_room_type,
             :id_board, :id_tar_head, :id_type_stay, :is_manual_type_stay, :id_hotel,
             :period_depend_on_checkin, :cnt_days_board, :cnt_days_bp, :tariff_curr, :board_type_find,
             :id_room, :custom_price, :custom_currency,
             :id_tar_input_detail, :is_simple, :guest_age

  do begin
    if (coalesce(:id_room_type, -1) < 0) then exception RATING_EXCEPTION 'Unspecified room type!';
    if (coalesce(:id_type_stay, -1) < 0) then exception RATING_EXCEPTION 'Unspecified type stay!';
    --if (coalesce(:id_board, -1) < 0) then exception ASSERT 'Unspecified board!';
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    /* - - - - - PART 1 - For Both Simple and Complex Rates - */
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    select count(*)
    from   TAR_CALC_INPUT_DETAIL$TMP TCID
           join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
    where  TCI.ID_TAR_CALC = :ID_TAR_CALC
           and TCID.FOR_DATE = :FOR_DATE
           and TCID.ID_ROOM = :ID_ROOM
    into   :TOTAL_GUESTS;

    if (:TOTAL_GUESTS = 0) then exit;
  
    select RT.BEDS
    from   ROOM_TYPES RT
    where  RT.ID_ROOM_TYPE = :ID_ROOM_TYPE
    into   :BEDS;

    if (:IS_SIMPLE = 1) then begin
      /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
      /* - - - - - - - PART 2 - Simple Rates - - - - - - - - -  */
      /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
      if (:old_id_room is distinct from :id_room) then begin
        current_adult_num = 0;
        current_child_num = 0;
        old_id_room = :id_room;
      end

      execute procedure TAR_CALC_EVAL_SIMPLE_RATE$INT (:id_tar_input_detail, :id_tar_input, :ID_TAR_CALC,
              :FOR_DATE, :id_tar_head, :beds, :guest_age, :id_type_stay, :is_manual_type_stay, :id_board, :id_room_type,
              :custom_price, :custom_currency, :id_hotel, :total_guests, :current_adult_num, :current_child_num)
      returning_values (:ERR_CODE, :int_err_text, :current_adult_num, :current_child_num);
      if (:ERR_CODE < 0) then exception INTERNAL_RATING_EXCEPTION;

    end else begin
      /* - - -  - - - - - - - - - - - -  - - - - - - - - */
      /* - - -  - PART 3 - Complex Rates - - - - - - - - */
      /* - - -  - - - - - - - - - - - -  - - - - - - - - */
      if (:old_id_room is distinct from :id_room) then begin
        payors  = 0;
        minors  = 0;
        old_id_room = :id_room;
        seq_num = 0;
      end
      seq_num = :seq_num + 1;

      execute procedure TAR_CALC_EVAL_COMPLEX_RATE$INT (:input_detail_dbkey, :id_tar_input, :ID_TAR_CALC,
              :FOR_DATE, :beds, :id_type_stay, :is_manual_type_stay, :id_board, :id_room_type, :custom_price, :custom_currency,
              :checkin_date, :day_of_stay, :payors, :minors, :period_depend_on_checkin, :cnt_days_bp, :cnt_days_board,
              :board_type_find, :total_guests, :seq_num, :tariff_curr, :real_recalc)
      returning_values (:ERR_CODE, :int_err_text, :payors, :minors);
      if (:ERR_CODE < 0) then exception INTERNAL_RATING_EXCEPTION;
    end
  /* - --- - END PART 3 - complex Rates*/
  end

  when exception INTERNAL_RATING_EXCEPTION do begin
    if (coalesce(:ERR_CODE, 0) = 0) then ERR_CODE = -211;
    select TH.TARIFA_NAME
    from   TARIFA TH
    where  TH.ID_TARIFA = :ID_TAR_HEAD
    into   :TAR_NAME;

    select GC.GUEST_NAME1
    from   GUEST_CARD GC
    where  GC.ID_GUEST = :ID_GUEST
    into   :GUEST_NAME;
    ERR_TEXT = substring('GUEST='||cast(:ID_GUEST as varchar(20))||'-'||:GUEST_NAME||f_crlf()
                         || 'DATE='||:FOR_DATE||f_crlf()
                         || 'TARIFF='||:TAR_NAME||f_crlf()
                         || :int_err_text
                        from 1 for 255);

    exit;
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_EVAL_COMPLEX_RATE$INT for: TAR_MATCH_BOARD */
ALTER PROCEDURE TAR_CALC_EVAL_COMPLEX_RATE$INT(INPUT_DETAIL_DBKEY CHAR(8),
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
BEDS SMALLINT,
ID_TYPE_STAY INTEGER,
IS_MANUAL_TYPE_STAY SMALLINT,
ID_BOARD INTEGER,
ID_ROOM_TYPE INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
CHECKIN_DATE DATE,
DAY_OF_STAY INTEGER,
PAYORS INTEGER,
MINORS INTEGER,
PERIOD_DEPEND_ON_CHECKIN SMALLINT,
CNT_DAYS_BP INTEGER,
CNT_DAYS_BOARD INTEGER,
BOARD_TYPE_FIND VARCHAR(10),
TOTAL_GUESTS INTEGER,
SEQ_NUM INTEGER,
TARIFF_CURR CHAR(3),
REAL_RECALC SMALLINT)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_PAYORS INTEGER,
OUT_MINORS INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_MATCH_BOARD) */
ALTER PROCEDURE TAR_MATCH_BOARD(TID_DBKEY CHAR(8),
ID_TAR_BP INTEGER,
BOARD_TYPE_FIND VARCHAR(10),
ID_BOARD INTEGER,
ID_BOARD_INCLUDE INTEGER,
MATCH_DATE DATE,
BASE_PER_DAY NUMERIC(15,4),
DAY_OF_STAY INTEGER,
CNT_DAYS_BOARD INTEGER,
CNT_DAYS_BP INTEGER,
CUSTOM_PRICE NUMERIC(15,4))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SEPARATE_BOARD INTEGER,
SERVICE_TYPE VARCHAR(20),
BOARD_PRICE NUMERIC(15,4),
PTEXT VARCHAR(20),
ID_SERVICE INTEGER,
FOOD_PER_DAY NUMERIC(15,4),
PACKET_ITEM INTEGER,
DISC_TAG VARCHAR(50))
 AS
declare variable id_tar_head integer;
  declare variable id_tar_calc integer;
  declare variable ID_BO_BOARD integer;
  declare variable ID_TAR_BO_PRICE integer;
  declare variable param_filter varchar(2000);
  declare variable param_data varchar(2000);
  declare variable filter_result double precision;
  declare variable success integer;
  declare variable id_tar_board_tmp integer;
  declare variable board_name varchar(50);
  declare variable no_use numeric(15, 4);
  declare variable price_type varchar(20);
  declare variable is_board_in_bp integer;
  declare variable id_meal integer;
  declare variable delim integer;
  declare variable set_var varchar(255);
  declare variable rnd_method varchar(20);
  declare variable id_tar_input_detail integer;
  declare variable round_to numeric(15,4) ;
begin
  err_code = 0;
  err_text = '';
  id_tar_bo_price = -1;
  separate_board = 0;
  id_bo_board = -1;
  success = 0;
  packet_item = null;
  if (:id_board = 0) then exit;

  if (:board_type_find = 'HRANI') then begin
    for
      select BTF.ID_SERVICE
      from   BOARD_TO_FOODS(:id_board) BTF
      into   :id_meal
    do begin
      for
        select ERR_CODE, ERR_TEXT, SEPARATE_BOARD, SERVICE_TYPE, BOARD_PRICE,
               PTEXT, ID_SERVICE, FOOD_PER_DAY, DISC_TAG
        from   TAR_MATCH_BOARD(:tid_dbkey, :id_tar_bp, 'TO_HRANI',
                               :id_meal, :id_board_include, :match_date,
                               :base_per_day, :day_of_stay, :cnt_days_board, :cnt_days_bp, :custom_price)
        into   :err_code, :err_text, :separate_board, :service_type, :board_price,
               :ptext, :id_service, :food_per_day, :disc_tag
      do suspend;
    end
    exit;
  end

  for
    select   TBB.ID_TAR_BOARD, TRBP.PARAM_FILTER, TBB.ID_SERVICE, TBB.PACKET_ITEM, TBB.SET_VAR, TCI.ID_TAR_CALC,
             TCID.ID_TAR_HEAD, TCID.PARAM_VALUES, TBB.SEPARATE_BOARD, TBB.PTEXT, TBB.DISC_TAG, TBB.RND_METHOD,
             TCID.ID_TAR_INPUT_DETAIL
    from     TAR_CALC_INPUT_DETAIL$TMP TCID
             join  TAR_CALC_INPUT$TMP TCI
               on  TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
             join TAR_BO_BOARD TBB
               on  TBB.ID_TAR_HEAD = TCID.ID_TAR_HEAD
             join TAR_BO_RELATION TRBP
               on  TRBP.ID_BO = TBB.ID_TAR_BOARD
               and TRBP.BO_TYPE = 'BOARD'
    where    TCID.RDB$DB_KEY = :tid_dbkey
             and TBB.ID_BOARD is not distinct from :id_board
             and TRBP.ID_TAR_BP = :id_tar_bp
    into     :id_tar_board_tmp, :param_filter, :id_service, :packet_item, :set_var, :id_tar_calc,
             :id_tar_head, :param_data, :separate_board, :ptext, :disc_tag, :rnd_method,
             :id_tar_input_detail
  do begin
    execute procedure TAR_EVAL_FILTER(:param_filter, :param_data, :id_tar_input_detail)
    returning_values  :err_code, :filter_result;
    if (:err_code < 0) then begin suspend; exit; end
    if (:filter_result = 1) then begin
      id_bo_board = :id_tar_board_tmp;
      success = 1;
      break;
    end
  end
  execute procedure SETTING_GET_VALUE('RANGE_DATA_DELIMETER', null)
  returning_values  :delim;

  if (exists (select *
              from   TAR_HEAD TH
              where  TH.ID_TAR_HEAD = :id_tar_head
                     and f_character(:delim)||TH.BASE_BOARDS_LIST||f_character(:delim) containing f_character(:delim)||:id_board||f_character(:delim)))
  then begin
    service_type = 'BASE_BOARD';
    disc_tag = 'FB';
  end else begin
    service_type = 'EXTRA_BOARD';
    disc_tag = 'FE';
  end

  if (:success = 0) then begin
    if ((:board_type_find = 'BOARD') and (:id_board_include is distinct from :id_board)) then begin
      /* NOT FOUND BOARD */
      err_code = -234;
      select T.NAME
      from   MEALS T
      where  T.ID_BOARD = :id_board
      into   :board_name;
      err_text = 'BOARD='||coalesce(:board_name, '<null>');
      suspend;
      exit;
    end else if (:board_type_find = 'TO_HRANI') then begin
      if (not exists(
        select *
        from   BOARD_TO_FOODS(:id_board_include) BTF
        where  BTF.ID_SERVICE = :id_board
      )) then begin
        err_code = -234;
        select T.NAME
        from   MEALS T
        where  T.ID_BOARD = :id_board
        into   :board_name;
        err_text = 'BOARD='||coalesce(:board_name, '<null>');
        suspend;
        exit;
      end
    end
    /* ONLY IF THE BOARD IN THE BASE POSITION FULLY SATISFIES THE BOARD LOOKUP
    || OR IT IS PART OF THE LOOKING BOARD
    */
    update TAR_CALC_INPUT_DETAIL$TMP TID
    set    TID.ID_BOARD_INCLUDE = :id_board_include
    where  TID.RDB$DB_KEY = :tid_dbkey;

    exit;
  end

  if (:id_bo_board <> -1) then begin
    execute procedure TAR_SET_VAR(:set_var, :id_tar_input_detail, :id_tar_calc);
    --
    execute procedure TAR_MATCH_PRICE(:id_tar_head, :id_bo_board, 'BOARD', :match_date)
    returning_values  :err_code, :err_text, :id_tar_bo_price;
    if (:err_code < 0) then begin suspend; exit; end
    /* FIRST WE HAVE TO DECIDE WEATHER THE BOARD IS IN THE BASE PRICE */
    if (:custom_price is not null) then is_board_in_bp = 1;
    else if (:board_type_find = 'TO_HRANI') then begin
      if (exists (
        select *
        from   BOARD_TO_FOODS(:id_board_include) BTF
        where  BTF.ID_SERVICE = :id_board))
      then is_board_in_bp = 1;
      else is_board_in_bp = 0;
    end else begin
      if (:id_board_include = :id_board) then is_board_in_bp = 1;
      else is_board_in_bp = 0;
    end

    select TP.PRICE_VALUE, TP.PRICE_TYPE
    from   TAR_BO_PRICE_GET(:id_tar_bo_price) TP
    into   :board_price, :price_type;

    select c.ROUND_TO
    from   TARIFA t
           join CURRS c on c.CURR = t.CURR
    where  t.ID_TARIFA = :id_tar_head
    into   :round_to;

    execute procedure TAR_EVAL_PRICE(:price_type, :board_price, :base_per_day, :is_board_in_bp,
            :rnd_method, :round_to, :id_tar_input_detail)
    returning_values  :err_code, :board_price, :no_use;

    FOOD_PER_DAY = :BOARD_PRICE;
    if (:CNT_DAYS_BOARD > 1) then begin
      execute procedure TAR_EVAL_PRICE('DIVIDE', :CNT_DAYS_BOARD, :BOARD_PRICE, 0, :rnd_method, :round_to, :id_tar_input_detail)
      returning_values  :err_code, :food_per_day, :no_use;
      if (:err_code < 0) then exit;
      food_per_day = round_f(:food_per_day, 0.01);
  
      if ((mod(:DAY_OF_STAY, :CNT_DAYS_BOARD) = 0)) then food_per_day = :BOARD_PRICE - (:CNT_DAYS_BOARD - 1) * :FOOD_PER_DAY;
    end

    suspend;

    if (:is_board_in_bp = 1) then begin
      id_service = -1;
      service_type = 'BASE';
      disc_tag = 'F';
      FOOD_PER_DAY  = -:FOOD_PER_DAY;
       /* THIS SUSPEND IS FOR THE REDUCTION OF THE BASE PRICE */
      suspend;
    end
  end else begin
    board_price = 0;  /* !!!! suspend  */
  end
end
^

/* Alter (TAR_MATCH_EG) */
ALTER PROCEDURE TAR_MATCH_EG(TID_DBKEY CHAR(8),
ID_TAR_BP INTEGER,
TOTAL_GSTS INTEGER,
PAYORS INTEGER,
MINORS INTEGER,
MATCH_DATE DATE,
INCOMPLETE_BP INTEGER,
ID_ROOM_TYPE INTEGER,
POSITION_ONLY INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_BO_EG INTEGER,
ID_TAR_BO_PRICE INTEGER,
OUT_PAYORS INTEGER,
OUT_MINORS INTEGER,
ID_TYPE_STAY INTEGER)
 AS
declare variable beds integer;
  declare variable type_stay_code varchar(30);
  declare variable param_filter varchar(2000);
  declare variable param_data varchar(2000);
  declare variable filter_result double precision;
  declare variable position_found integer;
  declare variable id_tar_head integer;
  declare variable max_extra_guests integer;
  declare variable id_tar_eg_tmp integer;
  declare variable id_tar_input_detail integer;
  declare variable calc_date date;
  declare variable id_guest integer;
  declare variable room_type varchar(20);
begin
  err_code = 0;
  err_text = ' ';
  position_found = 0;
  out_minors   = :minors;
  out_payors   = :payors;
  for
    select   TEG.ID_TAR_EG, TRBP.PARAM_FILTER, TCID.ID_TAR_HEAD,
             TEG.MAX_EXTRA_GUESTS, TCID.PARAM_VALUES, TCID.ID_TAR_INPUT_DETAIL,
             TCID.FOR_DATE
    from     TAR_CALC_INPUT_DETAIL$TMP TCID
             join TAR_BO_EXTRA_GUEST TEG
               on  TEG.ID_TAR_HEAD = TCID.ID_TAR_HEAD
             join TAR_BO_RELATION TRBP
               on  TRBP.ID_BO = TEG.ID_TAR_EG
               and TRBP.BO_TYPE = 'EXTRA_GUEST'
    where    TCID.RDB$DB_KEY = :tid_dbkey
             and TRBP.ID_TAR_BP = :id_tar_bp
             and (TEG.MIN_PAYORS + TEG.MAX_EXTRA_GUESTS) >= :total_gsts
             and TEG.MIN_PAYORS <= :payors
             and TEG.EG_ORDER /* IF NOT EXPLICIT SET IT IS 99 */ > :minors
    order by TEG.MIN_PAYORS desc, TEG.MAX_EXTRA_GUESTS asc, TEG.EG_ORDER asc
    into     :id_tar_eg_tmp, :param_filter, :id_tar_head,
             :max_extra_guests, :param_data, :id_tar_input_detail,
             :calc_date
  do begin
    execute procedure TAR_EVAL_FILTER(:param_filter, :param_data, :id_tar_input_detail)
    returning_values  :err_code, :filter_result;
    if (:err_code < 0) then exit;

    if (:filter_result = 1) then begin
      if (:max_extra_guests > :minors) then begin
        position_found = 1;
        out_minors = (:minors + 1);
        id_bo_eg = :id_tar_eg_tmp;
        break;
      end
    end
  end

  if (:position_found = 0) then begin
    if (:incomplete_bp = 1) then begin
      /* NOT FOUND EXTRA GUEST POSITION */
      err_code = -236;
      err_text = '';
      exit;
    end else begin
      out_payors = (:payors + 1);
    end
  end

  if (:POSITION_ONLY = 1) then exit;
  /********************************/
  id_type_stay = null;
  select RT.BEDS
  from   ROOM_TYPES RT
  where  RT.ID_ROOM_TYPE = :id_room_type
  into   :beds;

  if (:total_gsts = 1) then type_stay_code = 'ALONE';
  else if ((:out_payors + :out_minors) <= :beds) then type_stay_code = 'BED';
  else type_stay_code = 'EXTRA_BED';

  select ID_TYPE_STAY
  from   TYPE_STAY
  where  TYPE_STAY_CODE = :type_stay_code
  into   :id_type_stay;

  if (coalesce(:id_type_stay, -1) < 0) then begin
    select ti.ID_GUEST
    from   TAR_CALC_INPUT_DETAIL$TMP TD
           join TAR_CALC_INPUT$TMP ti on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
    where  td.RDB$DB_KEY = :TID_DBKEY
    into   :id_guest;

    select rt.TYPE_ROOM
    from   ROOM_TYPES RT
    where  rt.ID_ROOM_TYPE = :id_room_type
    into   :room_type;
    err_code = -17;
    err_text = f_character(29) || :id_guest || f_character(28) || :calc_date || f_character(28) || coalesce(:room_type, '');
    exit;
  end

  if (:out_minors = :minors) then begin
    id_tar_bo_price = -1;
    id_bo_eg = -1;
    /* ONLY EXTRA GUESTS RECIEVE DISCOUNTS */
    exit;
  end

  execute procedure TAR_MATCH_PRICE(:id_tar_head, :id_bo_eg, 'EXTRA_GUEST', :MATCH_DATE)
  returning_values  :err_code, :err_text, :id_tar_bo_price;
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_RATE_RECORD_RELINK$EXC for: TAR_SAVE */
ALTER PROCEDURE IMPORT_RATE_RECORD_RELINK$EXC(ID_RATE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_SAVE) */
ALTER PROCEDURE TAR_SAVE(ID_TAR_HEAD INTEGER,
PERIOD_DEPEND_ON_CHECKIN INTEGER,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BASE_BOARDS_LIST VARCHAR(255),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
BO_TYPE VARCHAR(20),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable delim integer;
  declare variable id_hotel integer;
  declare variable action_text varchar(255);
begin
  if (:base_boards_list is null) then base_boards_list = '';
  if (:board_type not in ('BOARD', 'HRANI')) then begin
    if (:board_type = '0') then board_type = 'BOARD';
    else board_type = 'HRANI';
  end
  err_code = 0;
  err_text = '';
  execute procedure SETTING_GET_VALUE('RANGE_DATA_DELIMETER', null)
  returning_values  :delim;

  -- TAR_BO_PRICES are never cleared
  delete from TAR_BO_SEASON
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_BASE_POSITION
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_BOARD
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_EXTRA_GUEST
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_DISCOUNT
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_PACK
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_PARAMS
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_DISCOUNT_STAY
  where  ID_TAR_HEAD = :id_tar_head;
  update TAR_HEAD TH
  set    PERIOD_DEPEND_ON_CHECKIN = :period_depend_on_checkin,
         CNT_DAYS_PRICE_BP        = :cnt_days_price_bp,
         CNT_DAYS_PRICE_BOARD     = :cnt_days_price_board,
         BASE_BOARDS_LIST         = coalesce(f_character(:delim)|| (select list(p.item, f_character(:delim)) from SYSTEM_STRING_PARSER(:base_boards_list, f_character(:delim)) p) || f_character(:delim), ''),
         BOARD_TYPE               = :board_type,
         LOCK_STAMP               = current_timestamp
  where  TH.ID_TAR_HEAD = :id_tar_head;
  update TARIFA T
  set    T.IS_BASE = 1
  where  T.ID_TARIFA = :id_tar_head;
  bo_type = 'SEASON';
  execute procedure TAR_SAVE_BO_SEASON(:id_tar_head)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'BASE';
  execute procedure TAR_SAVE_BO_BP(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'BOARD';
  execute procedure TAR_SAVE_BO_BOARD(:id_tar_head, :bo_type, :board_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'EXTRA_GUEST';
  execute procedure TAR_SAVE_BO_EG(:id_tar_head, :bo_type, :board_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'PACK';
  execute procedure TAR_SAVE_BO_PACK(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'DISCOUNT';
  execute procedure TAR_SAVE_BO_DISC(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'DISCOUNT_PERIOD';
  execute procedure TAR_SAVE_BO_DISC_PERIOD(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end

  select f_character(29) || T.TARIFA_NAME, T.id_hotel
  from   TARIFA T
  where  T.ID_TARIFA = :ID_TAR_HEAD
  into   :action_text, :id_hotel;

  execute procedure EXPORT_LOG_INSERT$EXC ('RATE_BASE', :id_tar_head, :id_hotel, 0);

  execute procedure SYSTEM_LOG_ADD ('RATE', :ID_TAR_HEAD, 'RATE_CHANGED', :action_text);

  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||'NONE'||', '||:err_text;
    exception;
  end
end
^

/* Alter (TAR_SAVE_BO_SEASON) */
ALTER PROCEDURE TAR_SAVE_BO_SEASON(ID_TAR_HEAD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable delim integer;
  declare variable id_dim2 integer;
  declare variable id_season integer;
  declare variable from_date date;
  declare variable to_date date;
  declare variable idate date;
begin
  err_code = 0;
  execute procedure SETTING_GET_VALUE('RANGE_DATA_DELIMETER', null)
  returning_values  :delim;
  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, 'SEASON') TSP
    into    :param_name, :row_id, :id_dim2, :data, :col_id
  do begin
    if (:param_name = 'NAME') then begin
      id_season = gen_id(GEN_TAR_BO_SEASON_ID, 1);
      insert into TAR_BO_SEASON(ID_TAR_SEASON, ID_TAR_HEAD, SEASON_NAME, ID_DIM2)
      values (:id_season, :id_tar_head, :data, :id_dim2);
    end else if ((:param_name = 'PERIOD') and (:data <> '')) then begin
      from_date = null; to_date =null;
      for
        select SPD.ITEM
        from   SYSTEM_STRING_PARSER(:data, f_character(:delim)) SPD
        into   :idate
      do begin
        if (:from_date is null) then from_date = :idate;
        else to_date = :idate;
      end
      /* CHECK VALIDITY */
      if (exists(
        select *
        from   TAR_BO_SEASON TBS
               join TAR_BO_SEASON_PERIOD TSP
                 on TSP.ID_TAR_SEASON = TBS.ID_TAR_SEASON
        where  TBS.ID_TAR_HEAD = :id_tar_head
               and TSP.FROM_DATE <= :to_date
               and TSP.TO_DATE >= :from_date
      )) then begin
        err_code = -201;
        exit;
      end
      insert into TAR_BO_SEASON_PERIOD (ID_TAR_SEASON, FROM_DATE, TO_DATE)
      values (:id_season, :from_date, :to_date);
    end
  end
  when any do begin
    err_code = -200;
    err_text = :data;
    err_text = 'OBJECT='||'SEASONS'||', '||:err_text;
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_BO_DISC for: TAR_SAVE_PARSE_DAYSCHM */
ALTER PROCEDURE TAR_SAVE_BO_DISC(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_BO_PACK for: TAR_SAVE_PARSE_DAYSCHM */
ALTER PROCEDURE TAR_SAVE_BO_PACK(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_SAVE_PARSE_DAYSCHM) */
ALTER PROCEDURE TAR_SAVE_PARSE_DAYSCHM(DAY_SCHEME_DATA VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
DAY_SCHEME VARCHAR(20),
DAY_SCHEME_NUM INTEGER)
 AS
declare variable delim integer;
  declare variable idata varchar(20);
begin
  err_code = 0;
  if (:day_scheme_data = '') then begin
    day_scheme = 'EVERY';
    day_scheme_num = 1;
    exit;
  end
  execute procedure SETTING_GET_VALUE('RANGE_DATA_DELIMETER', null)
  returning_values  :delim;
  day_scheme     = null;
  day_scheme_num = null;
  for
    select SPD.ITEM
    from   SYSTEM_STRING_PARSER(:day_scheme_data, f_character(:delim)) SPD
    into   :idata
  do begin
    if (:day_scheme is null) then day_scheme = :idata;
    else day_scheme_num = :idata;
  end
  when any do begin
    err_code = -238;
    execute procedure sys_dbg('tar_save_parse_dayschm err_code = '||:err_code|| f_crlf()
                              || 'day_scheme = '||:day_scheme);
    exit;
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_BO_BOARD for: TAR_SAVE_PARSE_PARAM */
ALTER PROCEDURE TAR_SAVE_BO_BOARD(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_BO_BP for: TAR_SAVE_PARSE_PARAM */
ALTER PROCEDURE TAR_SAVE_BO_BP(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_BO_DISC_PERIOD for: TAR_SAVE_PARSE_PARAM */
ALTER PROCEDURE TAR_SAVE_BO_DISC_PERIOD(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE_BO_EG for: TAR_SAVE_PARSE_PARAM */
ALTER PROCEDURE TAR_SAVE_BO_EG(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_SAVE_PARSE_PARAM) */
ALTER PROCEDURE TAR_SAVE_PARSE_PARAM(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
PARAM_FILTER VARCHAR(2000))
 RETURNS(ERR_CODE INTEGER)
 AS
declare variable delim integer;
  declare variable parse_filter varchar(2000);
  declare variable db_param_name varchar(30);
  declare variable param_type varchar(20);
  declare variable is_interface integer;
  declare variable is_date_dependant integer;
  declare variable script_testing integer;
  declare variable param_data varchar(2000);
  declare variable param_name varchar(40);
  declare variable data_type varchar(20);
  declare variable pdata varchar(20);
  declare variable no_use double precision;
  declare variable var_testing_data varchar(2000);
begin
  err_code = 0;
  script_testing = 1;
  var_testing_data = '';
  param_data = '';
  execute procedure SETTING_GET_VALUE('RANGE_DATA_DELIMETER', null)
  returning_values  :delim;

  select f_parse_params(:param_filter, f_character(:delim))
  from   RDB$DATABASE
  into   :parse_filter;

  for
    select SPD.ITEM
    from   SYSTEM_STRING_PARSER(:parse_filter, f_character(:delim)) SPD
    into   :db_param_name
  do begin
    if (not exists(
         select *
         from   TAR_BO_PARAMS TBP
         where  TBP.ID_TAR_HEAD = :id_tar_head
                and TBP.BO_TYPE = :bo_type
                and TBP.PARAM_NAME = :db_param_name
    )) then begin
       is_interface = null;
       select  coalesce(TP.IS_INTERFACE, 0), coalesce(TP.IS_DATE_DEPENDANT, 0)
       from    TARIFA_PARAMS TP
       where   TP.PARAM_CODE = :db_param_name
               and TP.IS_USE = 1
       into    :is_interface, :is_date_dependant;
       if (:is_interface is not null) then begin
         if (:is_interface = 1) then param_type = 'USER_INTERFACE';
         else if (:is_date_dependant = 1) then param_type = 'DATE_DEPENDANT';
         else param_type = 'NORMAL';
         insert into TAR_BO_PARAMS (ID_TAR_HEAD, BO_TYPE, PARAM_NAME, PARAM_TYPE)
         values (:id_tar_head, :bo_type, :db_param_name, :param_type);
       end else begin
         var_testing_data = :var_testing_data || ';:' || :db_param_name || ',' ||'FLOAT' || ',1';
         -- TODO this may be replaced with VAR INIT SP   /  ?!?!??!
       end
    end
  end
  script_testing = 0;
  if (:script_testing = 1) then begin
    param_data = '';
    for
      select   TP.PARAM_CODE, TP.DATA_TYPE
      from     TAR_BO_PARAMS TBP
               join TARIFA_PARAMS TP on TP.PARAM_CODE = TBP.PARAM_NAME
      where    TBP.ID_TAR_HEAD = :id_tar_head
      group by TP.PARAM_CODE, TP.DATA_TYPE
      into     :param_name, :data_type
    do begin
      if (:data_type = 'DATE') then pdata = '01/01/2000';
      else pdata = '1';
      if ((:param_name is not null) and (:data_type is not null)) then begin
        param_data = :param_data||';:'||:param_name||','||:data_type||','||:pdata;
      end
    end
    execute procedure TAR_EVAL_FILTER(:param_filter, :param_data, null)
    returning_values  :err_code, :no_use;
  end

  when any do begin
    err_code = -207;
    execute procedure sys_dbg('tar_save_parse_param ' || substring('param_data = '||:param_data from 1 for 1000)|| f_crlf()
                              || substring('param_filter = '||:param_filter from 1 for 1000));
  end
end
^

/* Alter (TAR_SAVE_PARSE_PNUM) */
ALTER PROCEDURE TAR_SAVE_PARSE_PNUM(ID_TAR_HEAD INTEGER,
ID_BO INTEGER,
BO_TYPE VARCHAR(20),
POS_NUMBERS VARCHAR(2000),
PARAM_FILTER VARCHAR(2000))
 RETURNS(ERR_CODE INTEGER)
 AS
declare variable id_tar_bp integer;
  declare variable delim integer;
begin
  execute procedure SETTING_GET_VALUE('RANGE_DATA_DELIMETER', null)
  returning_values  :delim;
  for
    select TBP.ID_TAR_BP
    from   TAR_BO_BASE_POSITION TBP
    where  TBP.ID_TAR_HEAD = :id_tar_head
           and ((:pos_numbers = '')
               or
               (f_character(:delim)||:pos_numbers||f_character(:delim) like '%'||f_character(:delim)||TBP.POSITION_NUMBER||f_character(:delim)||'%')
               )
    into   :id_tar_bp
  do begin
    insert into TAR_BO_RELATION(ID_TAR_BP, BO_TYPE, ID_BO, PARAM_FILTER)
    values (:id_tar_bp, :bo_type, :id_bo, :param_filter);
  end
  when any do begin
    err_code = -212;
  end
end
^

/* Alter (TAR_SAVE_PARSE_PRICE) */
ALTER PROCEDURE TAR_SAVE_PARSE_PRICE(PRICE_DATA VARCHAR(2000),
ID_BO INTEGER,
BO_TYPE VARCHAR(20),
ID_TAR_SEASON INTEGER)
 RETURNS(ERR_CODE INTEGER,
ID_BO_PRICE INTEGER,
PRICE_TYPE VARCHAR(20))
 AS
declare variable idata varchar(2000);
  declare variable delim integer;
  declare variable price_value varchar(2000);
begin
  err_code = 0;

  if (:price_data = '') then begin
    id_bo_price = -1;
    if (:bo_type in ('DISCOUNT', 'PACKET')) then err_code = -209;
    exit;
  end
  execute procedure SETTING_GET_VALUE('RANGE_DATA_DELIMETER', null)
  returning_values  :delim;
  price_type = null;
  price_value = null;
  for
    select SPD.ITEM
    from   SYSTEM_STRING_PARSER(:price_data, f_character(:delim)) SPD
    into   :idata
  do begin
    if (:price_type is null) then price_type = :idata;
    else price_value = :idata;
  end
  if (:price_type not in ('EQUAL', 'PERCENT', 'ADDITION', 'FORMULA'))  then err_code = -2081;
  if ((:bo_type = 'BASE')     and (:price_type <> 'EQUAL')) then err_code = -2082;
  if ((:bo_type = 'DISCOUNT') and (:price_type  = 'EQUAL')) then err_code = -2083;
  if ((:bo_type = 'PACKET')   and (:price_type <> 'EQUAL')) then err_code = -2084;
  if (:err_code < 0) then exit;
/*  if (:id_tar_season = -1) then */ id_bo_price = gen_id(GEN_TAR_BO_PRICES_ID, 1);
/*  else id_bo_price = null;*/
  insert into TAR_BO_PRICES(
    ID_TAR_BO_PRICE, ID_TAR_SEASON, ID_BO, BO_TYPE, PRICE_VALUE, PRICE_TYPE)
  values (
    :id_bo_price, nullif(:id_tar_season, -1), :id_bo, :bo_type, :price_value, :price_type);

  when any do err_code = -208;
end
^

/* Alter (TAR_SAVE_PARSE_SEASON) */
ALTER PROCEDURE TAR_SAVE_PARSE_SEASON(ID_TAR_HEAD INTEGER,
SEASON_DATA VARCHAR(2000))
 RETURNS(ERR_CODE INTEGER,
SEASON_FILTER VARCHAR(2000))
 AS
declare variable delim integer;
  declare variable idata varchar(255);
  declare variable season_name varchar(50);
  declare variable param_name varchar(50);
  declare variable from_date date;
  declare variable to_date date;
  declare variable fd varchar(50);
  declare variable td varchar(50);
begin
  err_code = 0;
  season_filter = '';
  season_name = null;
  param_name  = null;
  execute procedure SETTING_GET_VALUE('RANGE_DATA_DELIMETER', null)
  returning_values  :delim;
  for
    select SPD.ITEM
    from   SYSTEM_STRING_PARSER(:season_data, f_character(:delim)) SPD
    into   :idata
  do begin
    if (:param_name is null) then param_name = :idata;
    else begin
      season_name = :idata;
      for
        select TSP.FROM_DATE, TSP.TO_DATE
        from   TAR_BO_SEASON TS
               join TAR_BO_SEASON_PERIOD TSP on TSP.ID_TAR_SEASON = TS.ID_TAR_SEASON
        where  TS.ID_TAR_HEAD = :id_tar_head
               and TS.SEASON_NAME = :season_name
        into   :from_date, :to_date
      do begin
        fd = formatDate(:from_date, 'D;dd/mm/yyyy');
        td = formatDate(:to_date, 'D;dd/mm/yyyy');

        if (:season_filter <> '') then season_filter = (:season_filter||' or ');
        season_filter = (:season_filter||' ((:'||:param_name||'>=DT("'||:fd||'")) and (:'||:param_name||'<=DT("'||:td||'")))');
      end
    end
  end
  when any do begin
    err_code = -239;
    execute procedure sys_dbg ('tar_save_parse_season err_code = '||:err_code|| f_crlf()
                              || substring('season_data = '||:season_data from 1 for 1000));
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_PARAMS$INT for: TARIFA_GET_PARAM */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TARIFA_GET_PARAM) */
ALTER PROCEDURE TARIFA_GET_PARAM(ID_PARAM INTEGER,
FOR_DATE DATE,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER)
 RETURNS(OUT_VALUE VARCHAR(255))
 AS
declare variable is_interface integer;
  declare variable param_code varchar(30);
  declare variable is_value integer;
  declare variable int1 integer;
  declare variable data_type varchar(10);
  declare variable pvalue varchar(20);
  declare variable from_ date;
  declare variable to_ date;
begin
  select TP.IS_INTERFACE, TP.PARAM_CODE, TP.IS_VALUE, TP.DATA_TYPE, TP.PVALUE
  from   TARIFA_PARAMS TP
  where  ID_TARIFA_PARAM = :ID_PARAM 
  into   :is_interface, :param_code, :is_value, :data_type, :pvalue;
  /*get interface params*/
  if (:PARAM_CODE = 'NATION2') then
    PARAM_CODE = 'NATION'; /* !!!!!!!!!! */

  /*get value params*/
  if (:IS_VALUE = 1) then
    OUT_VALUE = :pvalue;

  /*get internal params*/
  OUT_VALUE = null;
  if (:IS_INTERFACE = 0) then begin
    if (:PARAM_CODE = 'TODAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE, 'D;dd/mm/yyyy');

    end else if (:PARAM_CODE = 'WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE, 'DW;MON');

    end else if (:PARAM_CODE = 'NEXT_DATE_WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE + 1, 'DW;MON');

    end else if (:PARAM_CODE = 'PREV_DATE_WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE - 1, 'DW;MON');

    end else if (:PARAM_CODE = 'REQUIRED_WEEK_DAYS') then begin
      select maxdate(ti.FROM_DATE, :FOR_DATE -3), mindate(ti.TO_DATE -1, :FOR_DATE +3)
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :from_, :to_;
      
      for
        select formatdate(RLP.OUT_DATE, 'DW;MON')
        from   SYSTEM_LOOP_PERIOD(:from_, :to_) RLP
        into   :int1
      do OUT_VALUE = :OUT_VALUE||','||:int1;

    end else if (:PARAM_CODE = 'ARRIVAL_WEEK_DAYS') then begin
      select formatdate(ti.FROM_DATE, 'DW;MON')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'PRESTOI') then begin
      select cast(ti.TO_DATE - ti.FROM_DATE as integer)
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'FROM_DATE') then begin
      select formatdate(ti.FROM_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TO_DATE') then begin
      select formatdate(ti.TO_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'FIRST_NIGHT') then begin
      select formatdate(ti.FROM_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'LAST_NIGHT') then begin
      select formatdate(ti.TO_DATE - 1, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'DAYS_PASSED') then begin
       /* 01  03 -  01-1, 02-2   (        )*/   
       select cast((:FOR_DATE - G.FROM_DATE + 1) as integer)
       from   TAR_CALC_INPUT$TMP G
       where  G.ID_TAR_INPUT = :ID_TAR_INPUT
       into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'DAYS_TO_STAY') then begin
       /* 01  03 -  01-2, 02-1    (  )*/
       select cast((G.TO_DATE - :FOR_DATE - 1) as integer)
       from   TAR_CALC_INPUT$TMP G
       where  G.ID_TAR_INPUT = :ID_TAR_INPUT
       into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_GUESTS') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_CHILDREN') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.IS_CHILD = 1
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_ADULTS') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.IS_CHILD is distinct from 1
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_GUESTS_BY_ACCOUNT') then begin
      select (select count(*)
              from   GUEST G
                     join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
              where  G.ID_BASE_ACCOUNT = ti.ID_BASE_ACCOUNT
                     and G.FROM_DATE <= :FOR_DATE
                     and G.TO_DATE > :FOR_DATE
                     and RD.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP ti
      where  ti.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TYPE_ROOM') then begin
      select rt.TYPE_ROOM
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join ROOM_TYPES RT on RT.ID_ROOM_TYPE = tid.ID_ROOM_TYPE
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
      into   :OUT_VALUE;
      /* TO PRESEVE COMPATIBILITY WITH OLD TARIFF VERSIONS */
      /* WE HAVE TO RETURN THE NAME NOT THE ID !           */

    end else if (:PARAM_CODE = 'TYPE_STAY') then begin
      select ts.TYPE_STAY
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join TYPE_STAY TS on ts.ID_TYPE_STAY = tid.ID_TYPE_STAY
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TYPE_HRANA') then  begin
      select m.NAME
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join MEALS m on m.ID_BOARD = tid.ID_BOARD
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;
      OUT_VALUE = trim(coalesce(:OUT_VALUE, ''));

    end else if (:PARAM_CODE = 'PACK_ITEMS') then begin
      OUT_VALUE = null;
      select TID.PACKET_ITEMS
      from   TAR_CALC_INPUT$TMP TID
      where  TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;
      OUT_VALUE = coalesce(:OUT_VALUE, '~~');
      -- strfloateval('POS("~2~", :PACK_ITEMS)>0', ';:PACK_ITEMS,STRING,~2~3~D~')

    end else if (:PARAM_CODE = 'AGE') then begin
      select ti.GUEST_AGE
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_SEX') then begin
      select G.GUEST_SEX
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE ;
      if ((:OUT_VALUE is null) or (:OUT_VALUE = '')) then OUT_VALUE = '-' ;

    end else if (:PARAM_CODE = 'NATION') then begin
      select tid.COUNTRY_CODE
      from   TAR_CALC_INPUT$TMP TID
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_FIRST_DATE') then begin
      select cast(iif(G.FROM_DATE = :FOR_DATE, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_LAST_DATE') then begin
      select cast(iif(G.TO_DATE -1 = :FOR_DATE, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_LATE_CHECKOUT') then begin
      select g.IS_LATE_CHECKOUT
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_FIRST_GUEST_IN_ROOM') then begin
      select (select count(ti.ID_TAR_INPUT)
              from   TAR_CALC_INPUT$TMP ti
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and ti.ID_GUEST < t.ID_GUEST)
      from   TAR_CALC_INPUT$TMP t
      where  t.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :int1;

      if (:int1 = 0) then OUT_VALUE = 1; else OUT_VALUE = 0;
      
    end else if (:PARAM_CODE = 'IS_DIFER_NATIONS') then begin
      select (select cast(iif(count(distinct ti.COUNTRY_CODE) > 1, 1, 0) as integer)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_GROUP') then begin
      select cast(iif(g.ID_GROUP is not null, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_NIGHTS_BY_ACCOUNT') then begin
      /*          . */
      select (select cast(sum (G_IN_R.TO_DATE - G_IN_R.FROM_DATE) as integer)
              from   GUEST G_IN_R
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_R.ID_RESERV_DETAIL
              where  G_IN_R.ID_BASE_ACCOUNT = G.ID_BASE_ACCOUNT
                     and G_IN_R.CHECK_STATUS = 0
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_INTURN_BYACCOUNT') then begin
      select (select cast(count(G.ID_GUEST) as integer)
              from   GUEST G
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL and rd.IS_ANUL = 0
              where  G.ID_BASE_ACCOUNT = t.ID_BASE_ACCOUNT
                     and G.ID_GUEST <= t.ID_GUEST)
      from   TAR_CALC_INPUT$TMP t
      where  t.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'PAX_PRICE_WO_ADDINS') then begin
      /*             */
      /* PRICE_ORIG          */
      -- ?????    ???
      /*select  max(AP.PRICE_ORIG)
      from    ACCOUNT_POST AP 
      where   AP.ID_GUEST = :ID_GUEST
              and AP.DATE_POST = :FOR_DATE
              and AP.IS_BASE = 1
      plan    (AP index (ACCOUNT_POST_IDX6))
      into    :OUT_VALUE;
      */
      OUT_VALUE = null;

    end else if (:PARAM_CODE = 'ROOM_FEATURES') then begin
      select substring(R.FEATURES from 1 for 255)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join ROOMS R on r.ID_ROOM = tid.ID_ROOM
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_NIGHTS') then begin
      select (select cast(sum (G_IN_V.TO_DATE - G_IN_V.FROM_DATE) as integer)
              from   GUEST G_IN_V
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_V.ID_RESERV_DETAIL
              where  rd.ID_AGENT_PROFILE is not distinct from G.ID_AGENT_PROFILE
                     and G_IN_V.VAUCHER_NUM = G.VOUCHER_NUM
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE ;

    end else if (:PARAM_CODE = 'VAUCHER_GUESTS') then begin
      select (select count (G_IN_V.ID_GUEST)
              from   GUEST G_IN_V
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_V.ID_RESERV_DETAIL and rd.IS_ANUL = 0
              where  rd.ID_AGENT_PROFILE is not distinct from G.ID_AGENT_PROFILE
                     and G_IN_V.VAUCHER_NUM = G.VOUCHER_NUM
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_DATE') then begin
      select formatdate(G.VOUCHER_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_TEXT') then begin
      select G.VOUCHER_TEXT
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_INTURN_BYROOM') then begin
      select (select count(*) + 1
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ((t.IS_CHILD = 0 and ti.IS_CHILD = 0 and td.CHECKIN_ORDER < tid.CHECKIN_ORDER)
                          or (t.IS_CHILD = 1 and ((ti.IS_CHILD = 0) or (ti.GUEST_AGE > t.GUEST_AGE) or (ti.GUEST_AGE = t.GUEST_AGE and td.CHECKIN_ORDER < tid.CHECKIN_ORDER) )))
              )
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'ADULT_INTURN_BYROOM') then begin
      OUT_VALUE = 0;
      select (select count(*) + 1
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and td.CHECKIN_ORDER < tid.CHECKIN_ORDER
                     and ti.IS_CHILD = 0)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
             and t.IS_CHILD = 0
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'CHILD_INTURN_BYROOM') then begin
      OUT_VALUE = 0;
      select (select count(*) + 1
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ( (ti.GUEST_AGE > t.GUEST_AGE) or (ti.GUEST_AGE = t.GUEST_AGE and td.CHECKIN_ORDER < tid.CHECKIN_ORDER) )
                     and ti.IS_CHILD = 1)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
             and t.IS_CHILD = 1
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_TYPE') then begin
      select G.ID_GUEST_TYPE
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else begin
      exception RATING_EXCEPTION 'Unsupported param - '||:PARAM_CODE;
    end

  end /*PART OF INTERNAL PARAMS*/


  /**********************************************/
  begin
    /* the source of the next check is gone with the wind
    /* but we must distinguish different data types */
    if ((:OUT_VALUE is null) or (:OUT_VALUE = '')) then begin
      /*not allow nulls*/
      if (:DATA_TYPE = 'DATE') then OUT_VALUE = '01/01/1899';
      else OUT_VALUE = '-1';  -- Unspecified
    end else if (:DATA_TYPE = 'INTEGER') then begin
      OUT_VALUE = cast(:OUT_VALUE as integer);
      /* to prevent errors like OUT_VALUE = '00001' */
    end

    when any do exception RATING_EXCEPTION 'Unsupported param value: ' || :param_code || ' = "' || coalesce(:OUT_VALUE, '<null>') || '"';
  end
  /**********************************************/
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_DOC_UPDATE$INT for: TAX_VALUE_DEDUCT */
ALTER PROCEDURE ACCOUNT_POSTING_DOC_UPDATE$INT(DH_DBKEY /* TYPE OF TDB_KEY */ CHAR(8))
 RETURNS(WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_PRICE_CALC$INT for: TAX_VALUE_DEDUCT */
ALTER PROCEDURE ACCOUNT_POSTING_PRICE_CALC$INT(QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
PRICE_ORIG /* TYPE OF TVALUE */ DOUBLE PRECISION,
RATE_ORIG /* TYPE OF TRATE */ NUMERIC(15,6),
POST_RATE /* TYPE OF TRATE */ NUMERIC(15,6),
ID_SALE_TAXATION /* TYPE OF ID_REF */ INTEGER)
 RETURNS(PRICE_POST DOUBLE PRECISION,
POST_NET_VALUE NUMERIC(15,4),
POST_GROSS_VALUE NUMERIC(15,4))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE_TAX$INT for: TAX_VALUE_DEDUCT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_TAX$INT(AP_DBKEY CHAR(8),
ID_SALE_TAXATION INTEGER,
ROUND_TO NUMERIC(15,4),
CHANGE_REASON VARCHAR(30))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOC_LINES_SUSPEND_LINE for: TAX_VALUE_DEDUCT */
ALTER PROCEDURE DOC_LINES_SUSPEND_LINE(DL_DBKEY CHAR(8),
RPT_CURR VARCHAR(20),
RPT_VAT VARCHAR(20),
RPT_PACKETS VARCHAR(10),
DOC_VAT_STATUS INTEGER,
CORRECTION_INDEX INTEGER)
 RETURNS(ID_PACK_SERVICE INTEGER,
PACK_NAME VARCHAR(50),
PACK_PRICE NUMERIC(15,2),
PACK_PRICE_WOT_DIFF DOUBLE PRECISION,
SINGLE_PRICE NUMERIC(15,4),
LINE_VALUE NUMERIC(15,4),
VAT_VALUE NUMERIC(15,4),
SINGLE_WOT_DIFF DOUBLE PRECISION,
QTY_POST NUMERIC(15,4),
PACK_QTY NUMERIC(15,4),
IS_PACKET_POST INTEGER,
SEC_CURR_LINE_VALUE NUMERIC(15,4),
SEC_CURR_GROSS_VALUE NUMERIC(15,4))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_LINE_ADD$INT for: TAX_VALUE_DEDUCT */
ALTER PROCEDURE DOCUMENT_LINE_ADD$INT(ID_DOC_HEAD /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_SALE_TAXATION /* TYPE OF ID */ INTEGER,
LINE_NAME /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
ID_GUEST /* TYPE OF ID */ INTEGER,
DATE_POST /* TYPE OF TDATE */ DATE,
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
ROOM_NAME /* TYPE OF TROOM_NAME */ VARCHAR(10),
QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
WOT_DIFF /* TYPE OF TVALUE */ DOUBLE PRECISION,
DOC_CURR_GROSS_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
DOC_CURR_ROUND /* TYPE OF TPRICE */ NUMERIC(15,4),
NAT_CURR_GROSS_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
NAT_CURR_ROUND /* TYPE OF TPRICE */ NUMERIC(15,4),
SEC_CURR /* TYPE OF TCURRENCY */ CHAR(3),
SEC_CURR_GROSS_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
SEC_CURR_ROUND /* TYPE OF TPRICE */ NUMERIC(15,4),
TAX_STATUS /* TYPE OF TENUM_SMALL */ SMALLINT,
IS_CORRECT /* TYPE OF TLOGICAL */ SMALLINT,
GROUP_TAG /* TYPE OF TRANGE */ INTEGER)
 RETURNS(ID_DOC_LINE /* TYPE OF ID */ INTEGER,
DOC_CURR_NET_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
NAT_CURR_NET_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
SEC_CURR_NET_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_POSTING_DIFFS_SET$INT for: TAX_VALUE_DEDUCT */
ALTER PROCEDURE DOCUMENT_POSTING_DIFFS_SET$INT(ID_DOC_LINE INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SALE_TAXATION INTEGER,
POST_QTY NUMERIC(15,4),
POST_PRICE NUMERIC(15,4),
POST_RATE_IN_ACC NUMERIC(15,6),
POST_RATE_IN_DOC NUMERIC(15,6),
LINE_NAT_NET_VALUE NUMERIC(15,4),
LINE_NAT_GROSS_VALUE NUMERIC(15,4),
NAT_ROUND_TO NUMERIC(15,4))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PMS_ROOM_DOCS_PREPARE$RPT for: TAX_VALUE_DEDUCT */
ALTER PROCEDURE PMS_ROOM_DOCS_PREPARE$RPT(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER)
 RETURNS(REC_COUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: REVENUE_EW_SUMMARIZE$INT for: TAX_VALUE_DEDUCT */
ALTER PROCEDURE REVENUE_EW_SUMMARIZE$INT(ID_END_WORK INTEGER,
SUMMARY_OPTION VARCHAR(20) = 'full')
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SUMMARY_TAXES_REGEN for: TAX_VALUE_DEDUCT */
ALTER PROCEDURE SUMMARY_TAXES_REGEN AS
 BEGIN EXIT; END
^

/* Alter (TAX_VALUE_DEDUCT) */
ALTER PROCEDURE TAX_VALUE_DEDUCT(TOTAL_VALUE DOUBLE PRECISION,
ROUND_TO NUMERIC(15,4),
ID_SALE_TAXATION INTEGER,
BY_TAXES SMALLINT = 0)
 RETURNS(VALUE_WOT_TAX NUMERIC(15,4),
TAXABLE_VALUE NUMERIC(15,4),
TAX_PERCENT NUMERIC(15,4),
TAX_VALUE NUMERIC(15,4),
TAX_DIFF_VALUE DOUBLE PRECISION,
ID_SALE_TAX INTEGER)
 AS
declare variable tax_val_roundless double precision;
  declare variable total_real_tax_percent double precision;
  declare variable total_tax_value numeric(15,4);
  declare variable tmp_diff_value numeric(15,6);
  declare variable taxes_cnt integer;
  declare variable max_tbp integer;
  declare variable cnt integer;
  declare variable total_round_value numeric(15,4);
begin
  /* !!! The procedure returns ROUNDED values always!!!              */
  /* This is the algorythm for tax value deduction from TOTAL VALUE  */
  /* VALUE_WOT_TAX + TAX_VALUE = TOTAL_VALUE (rounded)         */
  /* TAXABLE_VALUE = VALUE_WOT_TAX * TAXABLE_VALUE_PERCENT           */
  if (:ROUND_TO is null) then begin
    /* undefined round scheme */
    exception WRONG_VALUE 'Undefined currency precision!';
  end
  /* get TAX param  - tax percent and taxable value percent  */
  select sum(T.TAX_PERCENT), sum(T.TAX_PERCENT * t.TAXABLE_BASE_PERCENT/100),
         count(t.ID_SALE_TAX), max(t.TAXABLE_BASE_PERCENT), iif(count(t.ID_SALE_TAX) = 1, min(t.ID_SALE_TAX), null)
  from   SALE_TAXATION_TAX ST
         join SALE_TAXES T on T.ID_SALE_TAX = st.ID_SALE_TAX
  where  ST.ID_SALE_TAXATION = :ID_SALE_TAXATION
         and t.REVENUE_DEDUCTION_TAX is distinct from 1
  into   :TAX_PERCENT, :total_real_tax_percent, :taxes_cnt, :max_tbp, :ID_SALE_TAX;

  if (:taxes_cnt = 0) then exception SALE_TAX_EXCEPTION '-303';
  /* calculate result values  */
  total_round_value = round_f(:TOTAL_VALUE, :ROUND_TO);
    /* Deduct rounded TAX value from total value */
  if (round_f(abs(:total_round_value), :ROUND_TO) < :ROUND_TO) then begin
    /* rounded TOTAL VALUE is ZERO - return values are likewise zero */
    value_wot_tax = 0;
    total_tax_value = 0;
    /*****************************************************************/
  end else begin
    tax_val_roundless = (:total_real_tax_percent * :total_round_value)
                         / (100 + :total_real_tax_percent);
    total_tax_value = round_f(:tax_val_roundless, :ROUND_TO);
    /* Calcucate difference between round and roundless TAX value */
    tax_diff_value  = :total_tax_value - :tax_val_roundless;
    /* calculate remaind value  */
    value_wot_tax = :total_round_value - :total_tax_value;
  end

  if (:BY_TAXES = 1 and :taxes_cnt > 1) then begin
    tmp_diff_value = 0;
    cnt = 0;
    for
      select ST.ID_SALE_TAX, T.TAX_PERCENT,
             (:VALUE_WOT_TAX * t.TAXABLE_BASE_PERCENT/100) * (t.TAX_PERCENT/100),
             round_f(:VALUE_WOT_TAX * t.taxable_base_percent/100, :ROUND_TO)
      from   SALE_TAXATION_TAX ST
             join SALE_TAXES T on T.ID_SALE_TAX = st.ID_SALE_TAX
                                  and t.REVENUE_DEDUCTION_TAX is distinct from 1
      where  ST.ID_SALE_TAXATION = :ID_SALE_TAXATION
      order by abs(round_f((:VALUE_WOT_TAX*t.TAXABLE_BASE_PERCENT/100)*(t.TAX_PERCENT/100), :ROUND_TO)
                 - (:VALUE_WOT_TAX*t.TAXABLE_BASE_PERCENT/100)*(t.TAX_PERCENT/100)) asc
              -- get taxes with maximum diff value last - to get accumulated diffs inconspicuously
      into   :ID_SALE_TAX, :TAX_PERCENT, :tax_val_roundless, :TAXABLE_VALUE
    do begin
      cnt = :cnt + 1;
      TAX_VALUE = round_f(:tax_val_roundless, :ROUND_TO);
      total_tax_value = :total_tax_value - :TAX_VALUE;  -- control total tax value
      TAX_DIFF_VALUE = :TAX_VALUE - :tax_val_roundless;
      tmp_diff_value = :tmp_diff_value + :TAX_DIFF_VALUE;
      /*if (round_f(:tmp_diff_value, :ROUND_TO) <> 0 and :total_tax_value <> 0) then begin
        -- accumulated diffs is greather than :round_to
        TAX_VALUE = :TAX_VALUE - round_f(:tmp_diff_value, :ROUND_TO);
        tmp_diff_value = :tmp_diff_value - :TAX_DIFF_VALUE;
        TAX_DIFF_VALUE = :TAX_VALUE - :tax_val_roundless;  -- calc new diff value
        tmp_diff_value = :tmp_diff_value + :TAX_DIFF_VALUE;
      end*/
      if (:cnt = :taxes_cnt and round_f(:total_tax_value, :ROUND_TO) <> 0) then begin
        -- control that total tax value is equal than sum of taxes values (on last tax)
        TAX_VALUE = :TAX_VALUE + round_f(:total_tax_value, :ROUND_TO);
        TAX_DIFF_VALUE = :TAX_VALUE - :tax_val_roundless;  -- calc new diff value
      end
      suspend;
    end
  end else begin
    TAX_VALUE = :total_tax_value;
    /* calculate real taxable value - it may be % from remaind value */
    taxable_value = round_f(:VALUE_WOT_TAX * :max_tbp/100, :ROUND_TO);
    suspend;
  end
end
^

/* Alter (TEST_BOOKING_IMPORT) */
ALTER PROCEDURE TEST_BOOKING_IMPORT AS
declare variable dbg varchar(255);
  declare variable booking_id integer;
begin
  dbg = null;
  EXECUTE PROCEDURE IMPORT_BOOKING$EXC ('SOL NESSEBAR BAY', 'EXP.3', null, null, 0,
  cast('17.11.2008' as date), null, cast('19.11.2008' as date),
  null, null, null, null, null, 'LARGE_ROOM', 'BB', null, null, '????????', 'MIXED', 'EXPEDIA-BAY',
  null, null, null, null, '?????? ??????', null, null, null, null, 'Business - Corporate',
  'Companies (FIR)', 'E-Mail (EMA)', 'Advert (ANZ)', 'Activities (ANI)', 'A room with a view.(4)',
  null, null, 2, 2, 'e43a4cc0-7d73-47cc-bd07-a98c18c714a3', null, '0D074F966A187B2A9912B5F0E213FEB4',
  0, 0, 0, null, null, null, null, null, null, null, null, null, null,  null, null, null, null, null, null, null, null)
  returning_values (:dbg, :booking_id, :dbg, :dbg);
  dbg = null;
end
^

/* Alter (TEST_DOC) */
ALTER PROCEDURE TEST_DOC(ID_ACCOUNT INTEGER,
DOC_SELECTED INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER)
 AS
declare variable is_dep_doc integer;
  declare variable id_hotel integer;
  declare variable dummy varchar(255);
begin
  is_dep_doc = 0;

  execute procedure DOCUMENT_INITIALIZE$DOC (:id_account, :doc_selected, null)
  returning_values (:id_doc_head, :id_hotel, :dummy);

  execute procedure DOCUMENT_ADD_DEF_PAYMENT$DOC (:id_doc_head, null);

  execute procedure DOCUMENT_VALIDATE$DOC (:id_doc_head)
  returning_values :dummy, :dummy, :dummy;
  suspend;
end
^

/* Restore proc. body: ACC_STATEMENT_INVOICES_GET$PMS */
ALTER PROCEDURE ACC_STATEMENT_INVOICES_GET$PMS(ID_BILL INTEGER)
 RETURNS(ID_DOC INTEGER,
ID_SERVICE INTEGER,
DATE_POST DATE,
ROOM_NAME VARCHAR(100),
LINE_DESC VARCHAR(100),
OUTGO_VALUE NUMERIC(15,4),
CURR_POST VARCHAR(3),
IS_ANUL SMALLINT,
INV_DESCRIPTION VARCHAR(100))
 AS
declare variable id_hotel integer;
  declare variable sign_ smallint;
  declare variable doc_sub_type smallint;
begin

  for
    select distinct DL.ID_DOC_HEAD, DH.DOC_SUB_TYPE, O.ID_CURRENCY,
           DT.DOC_TYPE_NAME || ' ' || DH.DOC_NUM || ', ' || formatdate(DH.DOC_DATE,'D;dd/mm/yyyy'),
           DH.IS_ANUL, B.ID_SERVICE, a.ID_HOTEL
    from   OWNER_BILL_ROW$PMS B
           join OWNER_BILL$PMS BH on BH.ID_OWNER_BILL = B.ID_OWNER_BILL
           join OWNER$PMS O on O.ID_OWNER = BH.ID_OWNER
           join DOC_LINE_POST_VALUES PV on B.ID_ACCOUNT_POST = PV.ID_ACCOUNT_POST
           join DOC_LINE DL on PV.ID_DOC_LINE = DL.ID_DOC_LINE
           join DOC_HEAD DH on DH.ID_DOC = DL.ID_DOC_HEAD
           join ACCOUNT A on A.ID_ACCOUNT = dh.ID_ACCOUNT
           join DOC_TYPE DT on DT.ID_DOC_TYPE = DH.ID_DOC_TYPE
    where  B.ID_OWNER_BILL = :ID_BILL
           and B.ID_ACCOUNT_POST is not null
    into   :id_doc, :doc_sub_type, :CURR_POST, :INV_DESCRIPTION, :IS_ANUL, :ID_SERVICE, :id_hotel
  do begin
    select case when SGV.SETTING_VALUE = 'AS_POSITIVE' and :DOC_SUB_TYPE = 2 then -1 else 1 end
    from   SETTING_GET_VALUE('VIEW_STORNO_SUMS_IN_DOCUMENTS', :id_hotel) SGV
    into   :sign_;

    for
      select
        DL.LINE_NAME,
        DL.ROOM_NAME,
        DL.DATE_POST,
        DL.LINE_VALUE as line_sum
      from
        DOC_LINES_SUSPEND (:ID_DOC, :sign_, '', 'details', 'acc', 'as_doc', 0) DL
      order by
        DL.IS_FOR_PAY asc, DL.DATE_POST, DL.IS_BASE desc, DL.ROOM_NAME, DL.LINE_NAME asc
      into :LINE_DESC,
           :ROOM_NAME,
           :DATE_POST,
           :OUTGO_VALUE
    do begin
      suspend;
    end
  end

end
^

/* Restore proc. body: ACCOUNT_CHECK_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_CHECK_CREDIT_STATUS$INT(ID_ACCOUNT TYPE OF ID_REF,
POST_VALUE TYPE OF TPRICE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_credit_account integer;
  declare variable id_reserv_detail integer;
  declare variable credit_limit tprice;
  declare variable b_post_sum tprice;
  declare variable b_pay_sum tprice;
  declare variable difference_value tprice;
  declare variable no_use varchar(255);
  declare variable account_currency tcurrency;
  declare variable round_to numeric(15,4);
begin
  if (:POST_VALUE = 0) then exit;

  select a.IS_CREDIT_ACCOUNT, a.CREDIT_LIMIT, a.ID_RESERV_DETAIL
  from   ACCOUNT A
  where  a.ID_ACCOUNT = :ID_ACCOUNT
  into   :is_credit_account, :credit_limit, :id_reserv_detail;

  if (:is_credit_account = 0
      and exists (select rd.ID_RESERV_DETAIL
                  from   RESERV_DETAIL rd
                  where  rd.ID_RESERV_DETAIL = :id_reserv_detail
                         and rd.CHECK_STATUS = 1)) then
  begin
    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, :credit_limit, 1);
  end

  if (coalesce(:credit_limit, 0) > 0) then begin
    /* FIND BALANCE OF ACCOUNT */
    execute procedure ACCOUNT_BALANCE$INT(:id_account)
    returning_values  :account_currency, :round_to, :no_use, :b_post_sum, :b_pay_sum, :no_use, :no_use;
    b_post_sum = coalesce(:b_post_sum, 0);
    b_pay_sum  = coalesce(:b_pay_sum, 0);

    /* IS THIS POST IS IN LIMIT */
    if ((:b_post_sum + :POST_VALUE) > :credit_limit) then begin
      err_code = -13; /*  */
      difference_value = :b_post_sum + :POST_VALUE - :credit_limit;
      err_text = f_character(29)||FormatFloat(:credit_limit, :round_to)||' '||:account_currency||
                 f_character(28)||FormatFloat(:difference_value, :round_to);
    end
  end
end
^

/* Restore proc. body: ACCOUNT_CREATE_PMS$PMS */
ALTER PROCEDURE ACCOUNT_CREATE_PMS$PMS(ID_OWNER INTEGER,
ID_ACC_TEMPLATE INTEGER,
ID_CURRENCY CHAR(3),
ID_HOTEL INTEGER)
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
declare variable hotel_name varchar(50);
  declare variable account_name varchar(50);
  declare variable is_owner_pool smallint;
  declare variable is_credit_account integer;
  declare variable credit_limit numeric (15,4);
  declare variable sec_level integer;
  declare variable is_pos_allowed integer;
  declare variable id_tax_policy integer;
begin
  -- klientska smetka za pool ne triabwa da se syzdawa!
  select iif(O.ID_RENTAL_POOL_UNIT is null, 0, 1)
  from   OWNER$PMS O
  where  O.ID_OWNER = :ID_OWNER
  into   :is_owner_pool;
  if (:is_owner_pool = 1) then exit;

  select H.HOTEL_NAME
  from   HOTEL H
  where  H.ID_HOTEL = :ID_HOTEL
  into   :hotel_name;
  account_name = substring('Owner account - '||:hotel_name from 1 for 50);

  if (:ID_ACC_TEMPLATE is null) then begin
    select sv.SETTING_VALUE
    from   SETTING_GET_VALUE ('DEF_OWNER_ACC_TEMPLATE', :ID_HOTEL) sv
    into   :id_acc_template;

    if (not exists (select t.ID_ACC_TEMPLATE
                    from   ACC_TEMPLATE t
                    where  t.ID_ACC_TEMPLATE = :ID_ACC_TEMPLATE
                           and t.ID_HOTEL = :ID_HOTEL)) then
    begin
      select sv.SETTING_VALUE
      from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :id_hotel) sv
      into   :id_acc_template;
    end
  end

  is_credit_account = null;
  select ACT.IS_CREDIT_ACCOUNT, ACT.CREDIT_LIMIT, ACT.SECURITY_LEVEL,
         ACT.IS_ALOWED_POS_INTERFACE, ACT.ID_TAX_POLICY
  from   ACC_TEMPLATE ACT
  where  ACT.ID_ACC_TEMPLATE = :id_acc_template
         and act.ID_HOTEL = :id_hotel
  into   :is_credit_account, :credit_limit, :sec_level,
         :is_pos_allowed, :id_tax_policy;

  if (:is_credit_account is null) then exception ACCOUNT_EXCEPTION '-50';

  execute procedure ACCOUNT_MODIFY$INT (null, :ID_OWNER, :ID_CURRENCY, :account_name, 1, :credit_limit,
          null, null, 0, null, :sec_level, 1, 1, :is_pos_allowed, null,
          null, :id_tax_policy, null, :ID_HOTEL, null, 1, 'add')
  returning_values (:NEW_ID_ACCOUNT);
end
^

/* Restore proc. body: ACCOUNT_MODIFY$INT */
ALTER PROCEDURE ACCOUNT_MODIFY$INT(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL TYPE OF ID_REF,
IS_PMS_ACCOUNT TYPE OF TLOGICAL,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
declare variable a_dbkey char(8);
  declare variable old_sec_level integer;
  declare variable action_text varchar(255);
  declare variable old_acc_name varchar(50);
  declare variable old_acc_curr varchar(3);
  declare variable old_tax_policy integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, archive');

  new_id_account = :id_account;
  if (:operation = 'add') then begin
    if ((:new_id_account is null) or (:new_id_account <= 0)) then new_id_account = gen_id(ID_ACCOUNT_GEN, 1);

    insert into ACCOUNT(ID_ACCOUNT, ACCOUNT_CURR, ACCOUNT_NAME, IS_CREDIT_ACCOUNT, CREDIT_LIMIT,
           ID_TYPE_PAYMENT, NOTE, IS_BLOCKED, BLOCK_TEXT, SECURITY_LEVEL, IS_BASE, IS_EXTRA,
           IS_ALOWED_POS_INTERFACE, POS_INTERFACE_NOTE, EXT_CODE, ID_TAX_POLICY, ID_PROFILE,
           ID_HOTEL, IS_DEFAULT, IS_PMS_ACCOUNT, ID_RESERV_DETAIL)
    values (:new_id_account, :account_curr, :account_name, 0, null,
           :id_type_payment, :note, :is_blocked, :block_text, :security_level, :is_base, :is_extra,
           :is_alowed_pos_interface, :pos_interface_note, :ext_code, :id_tax_policy, :id_profile,
           :id_hotel, :is_default, coalesce(:IS_PMS_ACCOUNT, 0), :ID_RESERV_DETAIL)
    returning RDB$DB_KEY
    into   :a_dbkey;

    action_text = f_character(29) || :new_id_account || '/' || :account_name;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'ADD_ACCOUNT', :action_text);

    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:NEW_ID_ACCOUNT, :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT);
    -- check special right and log event

  end else begin
    ID_RESERV_DETAIL = null;
    select A.RDB$DB_KEY, A.ID_RESERV_DETAIL, A.SECURITY_LEVEL,
           A.ACCOUNT_NAME, A.ACCOUNT_CURR, A.ID_TAX_POLICY
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :a_dbkey, :id_reserv_detail, :old_sec_level,
           :old_acc_name, :old_acc_curr, :old_tax_policy;
    if (:operation = 'mod') then begin
  
      update ACCOUNT A
      set    A.ACCOUNT_NAME = :account_name,
             A.ID_TYPE_PAYMENT = :id_type_payment,
             A.NOTE = :note,
             A.IS_BLOCKED = :is_blocked,
             A.BLOCK_TEXT = :block_text,
             A.SECURITY_LEVEL = :security_level,
             A.IS_BASE = :is_base,
             A.IS_EXTRA = :is_extra,
             A.IS_ALOWED_POS_INTERFACE = :is_alowed_pos_interface,
             A.POS_INTERFACE_NOTE = :pos_interface_note,
             A.EXT_CODE = :ext_code,
             A.ID_TAX_POLICY = :id_tax_policy,
             A.IS_DEFAULT = :is_default
      where  A.RDB$DB_KEY = :a_dbkey;
  
      execute procedure ACCOUNT_SET_CURRENCY$INT (:a_dbkey, :account_curr);
  
      if (:old_acc_name <> :account_name) then begin
        action_text = f_character(29 ) || :ID_ACCOUNT || '/' || :old_acc_name || ', ' || :old_acc_curr
                      || f_character(28) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME || ', ' || :ACCOUNT_CURR;
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'EDIT_ACCOUNT', :action_text);
      end
  
      if (:old_sec_level <> :SECURITY_LEVEL) then begin
        action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME
                      || f_character(28) || :SECURITY_LEVEL;
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'SET_ACC_SEC_LEVEL', :action_text);
      end
  
      if (:old_tax_policy <> :id_tax_policy) then begin
        execute procedure ACCOUNT_TAXATION_RECALC$INT (:ID_ACCOUNT, :ID_TAX_POLICY);
  
        action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME;                        
  
        select :action_text || f_character(28) || OTP.POLICY_NAME
        from   TAX_POLICY OTP
        where  OTP.ID_TAX_POLICY = :old_tax_policy
        into   :action_text;
        select :action_text || f_character(28) || NTP.POLICY_NAME
        from   TAX_POLICY NTP
        where  NTP.ID_TAX_POLICY = :ID_TAX_POLICY
        into   :action_text;
         
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'VAT_POLICY_CHNG', :action_text);
      end
  
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:ID_ACCOUNT, :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT); -- check special right and log event
  
    end else if (:operation = 'archive') then begin
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 1);

    end
  end

  if ((:id_reserv_detail is null) and (:IS_CREDIT_ACCOUNT = 0)) then begin
    exception ACCOUNT_EXCEPTION '-1010';
    -- The account must have active credit status
    exit;
  end

  if (:is_default = 1) then begin
    update ACCOUNT A
    set    A.IS_DEFAULT = 0
    where  A.ID_HOTEL = :id_hotel
           and A.ID_PROFILE = :id_profile
           and A.ID_ACCOUNT <> :new_id_account;
  end
end
^

/* Restore proc. body: ACCOUNT_POST_MODIFY$PMS */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
declare variable id_account integer;
  declare variable id_service integer;
  declare variable date_post date;
  declare variable is_owner_income smallint;
  declare variable is_account_post_item smallint;
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable no_use_id_acc_post integer;
  declare variable ap_dbkey char(8);
begin
  -- da se wika samo ot GUI
  if ( (:ID_ACCOUNT_POST is null) and (:ID_ACCOUNT_POST_PMS is null) ) then begin
    exception WRONG_PARAM_VALUE;
    exit;
  end

  is_account_post_item = iif(:id_account_post is not null, 1, 0);

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'mod, anul');

  if (:operation in ('mod', 'anul')) then begin
    -- prowerka: ot GUI-to mogat da se anulirat samo nedokumentirani i neanulirani nachisleniq
    if (:is_account_post_item = 1) then begin
      if ( (:ID_PMS_EVENT > 0) and
           not exists ( select *
                        from   PMS_EVENT_POST PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      select ap.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  ap.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
      into   :ap_dbkey;

      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_dbkey, 'PMS GUI VOID');

      update PMS_EVENT_POST PP
      set    PP.LINE_STATUS = 22
      where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST;

    end else if (:ID_ACCOUNT_POST_PMS is not null) then begin
      if ( not exists ( select *
                        from   ACCOUNT_POST$PMS PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      execute procedure ACCOUNT_POST_PMS_ANUL$INT(:ID_PMS_EVENT, :ID_ACCOUNT_POST_PMS);
    end

    if (:operation = 'mod') then begin
      id_account = null;
      if (:is_account_post_item = 1) then begin
        select AP.ID_ACCOUNT, AP.ID_SERVICE, AP.DATE_POST, PP.ID_OWNER, 0, ap.id_room
        from   ACCOUNT_POST AP
               join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and PP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :id_owner, :is_owner_income, :id_room;
      end else begin
        select AP.ID_ACCOUNT_PMS, AP.ID_SERVICE, AP.DATE_POST, AP.IS_OWNER_INCOME, AP.ID_OWNER
        from   ACCOUNT_POST$PMS AP
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
               and AP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :is_owner_income, :id_owner;
      end
      if (:id_account is null) then exit;

      execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_account, :id_service, :id_owner, :date_post,
              :in_curr_orig, :in_value_orig, 1 - :is_account_post_item, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* Restore proc. body: ACCOUNT_POSTING_DOC_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_DOC_UPDATE$INT(DH_DBKEY TYPE OF TDB_KEY)
 RETURNS(WARN_CODE TYPE OF TRANGE)
 AS
declare variable date_post date;
  declare variable old_date_post date;
  declare variable curr_post varchar(3);
  declare variable old_curr_post varchar(3);
  declare variable rate_post numeric(15,6);
  declare variable curr_orig varchar(3);
  declare variable old_curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable dbkey char(8);
  declare variable id_account_post integer;
  declare variable doc_date date;
  declare variable doc_release_ap integer;
  declare variable qty_post numeric(15,2);
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable price_orig numeric(15,4);
  declare variable price_post double precision;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable id_sale_taxation integer;
  declare variable id_base_doc integer;
  declare variable doc_operation varchar(10);
  declare variable is_anul_doc integer;
  declare variable is_storno integer;
  declare variable id_doc_head integer;
  declare variable posts_value double precision;
  declare variable line_value double precision ;
  declare variable action_text varchar(255);
  declare variable action_code varchar(30);
  declare variable account_curr varchar(3);
  declare variable id_ap_base_doc integer;
  declare variable new_is_anul integer;
  declare variable new_is_closed integer;
  declare variable doc_qty numeric(15,2);
  declare variable doc_price double precision;
  declare variable id_hotel integer;
  declare variable round_to numeric(15,4);
  declare variable proforma_dt_created timestamp;
  declare variable new_ac varchar(2);
  declare variable id_tax_policy integer;
  declare variable id_service integer;
  declare variable nat_round_to numeric(15,4);
begin

  select D.ID_DOC_HEAD, iif(D.IS_ANUL = 0, D.DOC_DATE, DA.ANNULMENT_DATE),
         D.ID_BASE_DOC, D.IS_ANUL, D.IS_STORNO, a.ID_TAX_POLICY, c.ROUND_TO,
         A.ID_ACCOUNT, A.ACCOUNT_CURR, a.id_hotel, pd.DATETIME_CREATED
  from   DOC_HEAD$INT D
         join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join HOTEL h on h.ID_HOTEL = a.ID_HOTEL
         join CURRS c on c.CURR = h.NATION_CURR
         left outer join DOC_ANNULMENT DA on DA.ID_DOC_HEAD = D.ID_DOC_HEAD
         left outer join DOC_HEAD$INT pd on pd.ID_DOC_HEAD = dc.ID_DOC_PROFORMA
  where  D.RDB$DB_KEY = :DH_DBKEY
  into   :id_doc_head, :doc_date, :id_base_doc, :is_anul_doc, :is_storno, :id_tax_policy, :nat_round_to,
         :id_account, :account_curr, :id_hotel, :proforma_dt_created;

  if (:id_doc_head is null) then exit;

  doc_operation = case when :is_anul_doc = 1 then 'anul'
                       when :is_storno   = 1 then 'storno'
                       else 'new'
                  end;

  doc_release_ap = -gen_id(DOC_SELECTED_GEN, 1);
  /*   */
  posts_value = 0;
  if (:doc_operation = 'new') then begin
    for
      select AP.RDB$DB_KEY, AP.ID_ACCOUNT_POST, DL.QTY_POST, PV.ACCOUNT_PRICE,
             ap.QTY_POST, ap.PRICE_POST, c.ROUND_TO
      from   ACCOUNT_POST AP
             join DOC_LINE_POST_VALUES PV on PV.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
             join DOC_LINE DL on DL.ID_DOC_LINE = PV.ID_DOC_LINE
             join CURRS C on c.CURR = ap.CURR_POST
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
      into   :dbkey, :id_account_post, :doc_qty, :doc_price,
             :qty_post, :price_post, :round_to
    do begin
      /*  if (:is_anul = 1) - annul corrective document, else - new valid document */
      /* annulment/storno of base document is in other case - operation "anul"  */
      if (:proforma_dt_created is not null) then begin
        new_is_anul = 0;
        new_is_closed = iif(cast(round_f(:qty_post - :doc_qty, :round_to) as numeric(15,2)) = 0
                            and cast(round_f(:price_post - :doc_price, :round_to) as numeric(15,2)) = 0,
                            1,
                            0);
      end else begin
        new_is_anul = 0;
        new_is_closed = 1;
        doc_qty = :qty_post;
        doc_price = :price_post;
      end

      update ACCOUNT_POST AP
      set    AP.ID_BASE_DOC   = :id_base_doc,
             AP.IN_DOC_QTY    = :doc_qty,
             AP.IN_DOC_VALUE  = :doc_price,
             AP.IS_ANUL       = :new_is_anul,
             AP.AC            = :new_is_anul || :new_is_closed,
             AP.DOC_SELECTED  = :doc_release_ap,
             AP.DATETIME_CHANGED = current_timestamp
      where  AP.RDB$DB_KEY = :DBKEY
      returning ap.ac into :new_ac;
      if (:new_ac = '00') then begin
        execute procedure SYSTEM_WARNING_ADD (-1061, '')
        returning_values (:warn_code);
      end

      update ACCOUNT_POST_CORRECTION APCU
      set    APCU.ID_DOC_HEAD  = iif(apcu.DATETIME_CREATED < coalesce(:proforma_dt_created, current_timestamp), :ID_DOC_HEAD, -1),
             APCU.IS_OPEN      = iif(apcu.DATETIME_CREATED < coalesce(:proforma_dt_created, current_timestamp), 0, 1)
      where  APCU.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
             and coalesce(APCU.ID_DOC_HEAD, -1) = -1;

      posts_value = :posts_value + :doc_price * :doc_qty;
    end

    action_text = f_character(29) || formatfloat(abs(:posts_value), 'F;0.00') || ' ' || :account_curr;
    action_code = 'CLOSE_POSTINGS';
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, :action_code, :action_text);

  end else if (:doc_operation in ('anul', 'storno')) then begin
    /* annulment/storno of base document - release all postings */
    /*   */
    old_date_post = '01.01.1900';
    old_curr_post = '';
    old_curr_orig = '';
    posts_value = 0;
    /*   */
    for
      select distinct AP.RDB$DB_KEY, AP.ID_ACCOUNT, AP.ID_GUEST, AP.ID_SALE_TAXATION, AP.ID_BASE_DOC,
             AP.QTY_POST, AP.PRICE_POST, AP.DATE_POST, AP.CURR_POST, AP.CURR_ORIG, AP.PRICE_ORIG,
             AP.ID_ACCOUNT_POST, AP.POST_NET_VALUE, AP.POST_GROSS_VALUE, AP.RATE_POST, AP.RATE_ORIG,
             PV.ACCOUNT_PRICE * DL.QTY_POST, c.ROUND_TO, ap.ID_SERVICE
      from   ACCOUNT_POST AP
             join DOC_LINE_POST_VALUES PV on PV.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
             join DOC_LINE DL on DL.ID_DOC_LINE = PV.ID_DOC_LINE
             join CURRS C on c.CURR = ap.CURR_POST
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
      order by AP.DATE_POST, AP.CURR_POST, AP.CURR_ORIG
      into   :dbkey, :id_account, :id_guest, :id_sale_taxation, :id_ap_base_doc,
             :qty_post, :price_post, :date_post, :curr_post, :curr_orig, :price_orig,
             :id_account_post, :post_net_value, :post_gross_value, :rate_post, :rate_orig,
             :line_value, :round_to, :id_service
    do begin
      if (:id_ap_base_doc is not null and :id_ap_base_doc is distinct from :id_base_doc) then
        exception DOCUMENT_EXCEPTION '-365';

      doc_qty = null;
      doc_price = 0;
      if (:DOC_OPERATION = 'anul') then begin
        select sum(DL.QTY_POST * (1 - DL.IS_CORRECT)) as DOC_QTY,
               sum(DLP.ACCOUNT_PRICE * DL.QTY_POST) /* / sum(DL.QTY_POST * (1 - DL.IS_CORRECT))*/ as DOC_VALUE
        from   DOC_HEAD DH
               join DOC_LINE DL on DL.ID_DOC_HEAD = DH.ID_DOC
               join DOC_LINE_POST_VALUES DLP on dlp.ID_DOC_LINE = dl.ID_DOC_LINE
        where  DH.IS_ANUL = 0
               and DLP.ID_ACCOUNT_POST = :id_account_post
               and DH.ID_BASE_DOC = :id_base_doc
        into   :doc_qty, :doc_price;
        if (:doc_qty = 0) then doc_price = 0;
        else doc_price = :doc_price / :doc_qty;
      end

      if (:doc_qty is null) then begin
        -- update prices only for released posting
        select tp.ID_SALE_TAXATION
        from   SERVICE_TAXATION tp
        where  tp.ID_TAX_POLICY = :id_tax_policy
               and tp.ID_SERVICE = :id_service
        into   :id_sale_taxation;  -- get actual taxation

        if (:date_post >= :doc_date) then begin
          /* update rates for prepaid postings (date_post >= doc_date) if base doc is annul */
          if ((:old_date_post <> :date_post) or (:old_curr_post <> :curr_post) ) then begin
            execute procedure ACCOUNT_POSTING_RATE_GET (:id_hotel, :curr_post, :date_post, :id_guest)
            returning_values  :RATE_POST;
          end
    
          if ((:OLD_DATE_POST <> :DATE_POST) or (:OLD_CURR_ORIG <> :CURR_ORIG) ) then begin
            execute procedure ACCOUNT_POSTING_RATE_GET (:id_hotel, :curr_orig, :date_post, :id_guest)
            returning_values  :rate_orig;
          end
  
          execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:qty_post, :price_orig,
                            :rate_orig, :rate_post, :id_sale_taxation)
          returning_values  :price_post, :post_net_value, :post_gross_value;
        end else begin
          -- recalc only nat net value with actual taxation
          select tv.VALUE_WOT_TAX
          from   TAX_VALUE_DEDUCT (:qty_post * :price_post * :rate_post, :nat_round_to, :id_sale_taxation) tv
          into   :post_net_value;
        end
      end

      new_is_anul = iif(:qty_post = 0 and :doc_qty is null, 1, 0);
      new_is_closed = iif(:doc_qty is not null
                          and cast(round_f(:qty_post - :doc_qty, :round_to) as numeric(15,2)) = 0
                          and cast(round_f(:price_post - :doc_price, :round_to)  as numeric(15,2)) = 0,
                          1,
                          0);

      update ACCOUNT_POST AP
      set    AP.IN_DOC_VALUE  = iif(:doc_qty is null, 0, :doc_price),
             AP.IN_DOC_QTY    = iif(:doc_qty is null, 0, :doc_qty),
             AP.RATE_ORIG     = :rate_orig,
             AP.RATE_POST     = :rate_post,
             AP.PRICE_POST    = :price_post,
             AP.POST_NET_VALUE = :post_net_value,
             AP.POST_GROSS_VALUE = :post_gross_value,
             AP.ID_SALE_TAXATION  = :id_sale_taxation,
             AP.ID_BASE_DOC   = iif(:doc_qty is null, null, :ID_BASE_DOC),
             AP.IS_ANUL       = :new_is_anul,
             AP.AC            = :new_is_anul || :new_is_closed,
             AP.ANUL_DATETIME = iif(:new_is_anul = 1, current_timestamp, ap.anul_datetime),
             AP.DATETIME_CHANGED = current_timestamp
      where  AP.RDB$DB_KEY = :DBKEY;

      if (:doc_operation = 'anul') then begin
        update ACCOUNT_POST_CORRECTION APCU
        set    APCU.ID_DOC_HEAD  = -1,
               APCU.IS_OPEN      = iif(:DOC_QTY is not null, 1, apcu.IS_OPEN)
        where  APCU.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and APCU.ID_DOC_HEAD = :ID_DOC_HEAD;
      end else begin  -- 'storno'
        update ACCOUNT_POST_CORRECTION APCU
        set    APCU.ID_DOC_HEAD  = -1,
               APCU.IS_OPEN      = iif(:DOC_QTY is not null, 1, apcu.IS_OPEN)
        where  APCU.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and APCU.ID_DOC_HEAD in (select d.ID_DOC from DOC_HEAD d where d.ID_BASE_DOC = :id_base_doc);
      end

      old_curr_post = :curr_post;
      old_curr_orig = :curr_orig;

      posts_value = :posts_value + :line_value;
    end  /* for select ... do begin  */

    action_text = f_character(29) || formatfloat(abs(:posts_value), 'F;0.00') || ' ' || :account_curr;
    action_code = 'OPEN_POSTINGS';
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, :action_code, :action_text);
  end  /* call type in (STORNO, ANUL)  */
end
^

/* Restore proc. body: ACCOUNT_POSTING_PRICE_CALC$INT */
ALTER PROCEDURE ACCOUNT_POSTING_PRICE_CALC$INT(QTY_POST TYPE OF TQTY,
PRICE_ORIG TYPE OF TVALUE,
RATE_ORIG TYPE OF TRATE,
POST_RATE TYPE OF TRATE,
ID_SALE_TAXATION TYPE OF ID_REF)
 RETURNS(PRICE_POST DOUBLE PRECISION,
POST_NET_VALUE NUMERIC(15,4),
POST_GROSS_VALUE NUMERIC(15,4))
 AS
declare variable round_to numeric(15,4);
begin

  PRICE_POST = :PRICE_ORIG * cast(:RATE_ORIG / :POST_RATE as double precision);

  if (:ID_SALE_TAXATION is null) then exception UNDEFINED_VAT_GROUP;

  select c.ROUND_TO
  from   SALE_TAXATION st
         join HOTEL H on h.ID_HOTEL = st.ID_HOTEL
         join CURRS C on c.CURR = h.NATION_CURR
  where  st.ID_SALE_TAXATION = :ID_SALE_TAXATION
  into   :round_to;
   
  POST_GROSS_VALUE = round_f(:PRICE_POST * :QTY_POST * :POST_RATE, :round_to);

  select SV.VALUE_WOT_TAX
  from   TAX_VALUE_DEDUCT (:POST_GROSS_VALUE, :round_to, :id_sale_taxation) SV
  into   :POST_NET_VALUE;

end
^

/* Restore proc. body: ACCOUNT_POSTING_RATE_GET */
ALTER PROCEDURE ACCOUNT_POSTING_RATE_GET(ID_HOTEL TYPE OF ID,
CURR TYPE OF TCURRENCY,
FOR_DATE TYPE OF TDATE,
ID_GUEST TYPE OF ID_REF = null)
 RETURNS(CURR_RATE TYPE OF TRATE)
 AS
declare variable guest_posting_rate varchar(20);
  declare variable arrival_date date;
begin
  curr_rate = null;
  execute procedure SETTING_GET_VALUE('GUEST_POSTING_RATE', :id_hotel)
  returning_values  :guest_posting_rate;

  if (:guest_posting_rate = 'CHECKIN_DATE') then begin
    arrival_date = null;
    select G.FROM_DATE
    from   GUEST G
    where  G.ID_GUEST = :id_guest
    into   :arrival_date;
    for_date = coalesce(:arrival_date, :for_date);
  end

  execute procedure CURR_RATE_GET(:curr, :for_date, :id_hotel)
  returning_values  :curr_rate;

end
^

/* Restore proc. body: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER)
 AS
declare variable id_current_account integer;
  declare variable id_service integer;
  declare variable is_anul integer;
  declare variable id_tariff integer;
  declare variable qty_post numeric(15,2);
  declare variable qty_free numeric(15,2);
  declare variable price_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable id_room integer;
  declare variable id_base_doc integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  if ((:AP_DBKEY is null) or (:id_target_account is null) or (:id_target_account < 0)) then
     exception POSTING_TRANSFER_EXCEPTION '-31';

  select AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST, AP.QTY_FREE,
         AP.PRICE_ORIG, AP.CURR_ORIG, AP.RATE_ORIG, ap.from_date, ap.to_date,
         AP.IS_ANUL, AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_BASE_DOC, A.ID_HOTEL
  from   ACCOUNT_POST AP
         left join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :id_service, :id_tariff, :id_room, :qty_post, :qty_free,
         :price_orig, :curr_orig, :rate_orig, :from_date, :to_date,
         :is_anul, :id_account_post, :id_current_account, :id_base_doc, :id_hotel;

  if (:id_current_account = :id_target_account) then EXIT;

  if (:is_anul = 1 ) then exception POSTING_TRANSFER_EXCEPTION '-33';

  if (:id_base_doc is not null) then exception POSTING_TRANSFER_EXCEPTION '-32';

  if (not exists(select A.ID_ACCOUNT
                 from   ACCOUNT A
                 where  A.ID_ACCOUNT = :ID_TARGET_ACCOUNT
                        and A.ID_HOTEL = :id_hotel)) then exception POSTING_TRANSFER_EXCEPTION '-376';

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
                    :id_tariff, :id_room, :qty_post, :qty_free, :price_orig, :curr_orig,
                    :rate_orig, 'TRANSFER_POSTING', null, :from_date, :to_date, 0, :id_target_account)
  returning_values  :no_use, :no_use, :no_use;

  insert into ACCOUNT_TRANSFER_HISTORY(ID_ACCOUNT_POST, FROM_ID_ACCOUNT, TO_ID_ACCOUNT)
  values (:id_account_post, :id_current_account, :id_target_account);
end
^

/* Restore proc. body: ACCOUNT_POSTING_UPDATE */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable in_db_key char(8);
begin
  /* GUI facade for manual update */
  select AP.ID_ACCOUNT, AP.ID_GUEST, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :id_guest, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date)
  returning_values  (:new_qty_post, :new_price_post, :new_ac);

  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    if (coalesce(:id_guest, 0) > 0) then begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || :id_account
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'POST_UPDATE', :action_text);
    end else begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
    end
  end

end
^

/* Restore proc. body: ACCOUNT_POSTING_UPDATE_TAX$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_TAX$INT(AP_DBKEY CHAR(8),
ID_SALE_TAXATION INTEGER,
ROUND_TO NUMERIC(15,4),
CHANGE_REASON VARCHAR(30))
 AS
begin
  /* to change ONLY taxation of account_post */
  update ACCOUNT_POST APU
  set    APU.ID_SALE_TAXATION = :ID_SALE_TAXATION,
         APU.POST_NET_VALUE =
           (select VV.VALUE_WOT_TAX
            from   TAX_VALUE_DEDUCT(APU.PRICE_POST * APU.QTY_POST * APU.RATE_POST, :ROUND_TO, :ID_SALE_TAXATION) VV),
         APU.CHANGED_TEXT = iif(not :CHANGE_REASON = '', :CHANGE_REASON, APU.CHANGED_TEXT),
         APU.DATETIME_CHANGED = current_timestamp
  where  APU.RDB$DB_KEY = :AP_DBKEY;
end
^

/* Restore proc. body: ACCOUNT_POSTS_EW_MARK$INT */
ALTER PROCEDURE ACCOUNT_POSTS_EW_MARK$INT(ID_END_WORK INTEGER)
 AS
declare variable revenue_account_method integer;
  declare variable doc_selected integer;
  declare variable ap_dbkey char(8);
  declare variable ew_date date;
  declare variable id_hotel integer;
begin
  select EW.ID_HOTEL, EW.PREV_DATE
  from   END_WORKS EW
  where  EW.ID_END_WORK = :ID_END_WORK
  into   :id_hotel, :ew_date;

  execute procedure SETTING_GET_VALUE ('REVENUE_ACCOUNT_METHOD', :id_hotel)
  returning_values  :revenue_account_method;

  doc_selected = -gen_id(DOC_SELECTED_GEN, 1); /* to prevent correction checks on trigger  */
  /* UPDATE POSTINGS FOR SUMMARY ********************************************/
  for
    select AP.RDB$DB_KEY
    from   ACCOUNT_POST AP
           join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
    where  AP.ID_END_WORK is null
           and AP.DATE_POST <= :ew_date
           and A.ID_HOTEL = :id_hotel
    union all
    select APP.RDB$DB_KEY
    from   ACCOUNT_POST APP
           join ACCOUNT A on A.ID_ACCOUNT = APP.ID_ACCOUNT
           join DOC_HEAD D on D.ID_DOC = APP.ID_BASE_DOC
    where  :revenue_account_method = 1  /* SELECT PREPAIED POSTINGS FOR SUMMARY */
           and APP.ID_END_WORK is null
           and APP.DATE_POST > :ew_date
           and A.ID_HOTEL = :id_hotel
           and D.DOC_DATE = :ew_date
    into   :ap_dbkey
  do begin
    update ACCOUNT_POST APU
    set    APU.ID_END_WORK = :id_end_work,
           APU.DOC_SELECTED = :doc_selected
    where  APU.RDB$DB_KEY = :ap_dbkey;
  end

  for
    select APC.RDB$DB_KEY
    from   ACCOUNT_POST_CORRECTION APC
           join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = APC.ID_ACCOUNT_POST
           join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
    where  apc.CORRECTION_DATE = :ew_date
           and apc.ID_END_WORK is null
           and a.ID_HOTEL = :id_hotel
           and AP.ID_END_WORK < :ID_END_WORK
    into   :ap_dbkey
  do begin
    update ACCOUNT_POST_CORRECTION C
    set    C.ID_END_WORK = :ID_END_WORK
    where  c.RDB$DB_KEY = :ap_dbkey;
  end

end
^

/* Restore proc. body: BLOCK_ANNUL$BLK */
ALTER PROCEDURE BLOCK_ANNUL$BLK(ID_BLOCK_ROOM INTEGER,
OPERATION VARCHAR(30))
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable share_err_text varchar(255);
  declare variable system_date date;
  declare variable cancel_date date;
  declare variable from_date date;
  declare variable b_dbkey char(8);
  declare variable new_id_block_room integer;
  declare variable id_room integer;
  declare variable block_grp integer;
  declare variable reason varchar(50);
  declare variable note varchar(255);
  declare variable action_text varchar(255);
  declare variable room_name varchar(10);
  declare variable id_hotel integer;
  declare variable mark_dirty_expired_block integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION (:operation, 'cancel, annul');

  select BR.FROM_DATE, BR.RDB$DB_KEY, R.ID_HOTEL
  from   BLOCK_ROOM BR
         join ROOMS R on R.ID_ROOM = BR.ID_ROOM
  where  BR.ID_BLOCK_ROOM = :id_block_room
  into   :from_date, :b_dbkey, :id_hotel;

  if (:operation = 'annul') then begin
    update BLOCK_ROOM BR
    set    BR.IS_ANNUL = 1
    where  BR.RDB$DB_KEY = :b_dbkey;
  
    execute procedure BLOCK_MODIFY_CONTROL$INT(:b_dbkey, :from_date);
    execute procedure ROOM_MAGIC_CLEAR(:id_block_room);
    action_text = '';
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :id_block_room, 'ANNUL_BLOCK', :action_text);
  end else begin
    select BR.ID_ROOM, BR.BLOCK_GRP, BR.REASON, BR.NOTE, R.ROOM_NAME
    from   BLOCK_ROOM BR
           join ROOMS R on R.ID_ROOM = BR.ID_ROOM
    where  BR.RDB$DB_KEY = :b_dbkey
    into   :id_room, :block_grp, :reason, :note, :room_name;

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :system_date;
    cancel_date = :system_date - 1;

    execute procedure BLOCK_MODIFY$INT(:id_block_room, :id_room, :from_date, :cancel_date, :block_grp, :reason,
                      :note, 'mod')
    returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :share_err_text, :warn_code;
    --ignore possible entering into share

    execute procedure SETTING_GET_VALUE('MARK_DIRTY_EXPIRED_BLOCK', :id_hotel)
    returning_values  :mark_dirty_expired_block;
    if (:mark_dirty_expired_block = '1') then begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'BLOCK_STOP', 'set_dirty');
    end

    action_text = f_character(29) || :room_name || f_character(28) || formatdate(:cancel_date, 'D;dd.mm.yyyy');
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :new_id_block_room, 'CANCEL_BLOCK', :action_text);
  end
end
^

/* Restore proc. body: BLOCK_MODIFY$INT */
ALTER PROCEDURE BLOCK_MODIFY$INT(ID_BLOCK_ROOM INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
BLOCK_GRP INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_BLOCK_ROOM INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable b_dbkey char(8);
  declare variable edit_status varchar(255);
  declare variable old_id_room integer;
  declare variable min_affected_date date;
  declare variable old_from_date date;
  declare variable old_to_date date;
begin

  if (:block_grp not in (18, 20)) then exception BLOCK_EXCEPTION '-85' || f_character(31) || 'Unknown block type';

  if (:operation = 'add') then begin
    new_id_block_room = gen_id(ID_RESERV_DETAIL_GEN, 1);
    insert into BLOCK_ROOM (ID_BLOCK_ROOM, ID_ROOM, FROM_DATE, TO_DATE,
           BLOCK_GRP, REASON, NOTE)
    values (:new_id_block_room, :id_room, :from_date, :to_date,
           :block_grp, :reason, :note)
    returning RDB$DB_KEY into :b_dbkey;
    edit_status = 'JUST_CREATED';
    min_affected_date = :from_date;
  end else begin
    select BR.RDB$DB_KEY, BR.FROM_DATE, BR.TO_DATE, BR.ID_ROOM
    from   BLOCK_ROOM BR
    where  BR.ID_BLOCK_ROOM = :id_block_room
    into   :b_dbkey, :old_from_date, :old_to_date, :old_id_room;

    min_affected_date = null;
    if (:old_from_date <> :from_date) then min_affected_date = mindate(:old_from_date, :from_date);
    else if (:old_to_date <> :to_date) then min_affected_date = mindate(:old_to_date, :to_date) + 1;
    edit_status = iif(:min_affected_date is not null, 'DATE_CHANGED', '');
    if (:id_room <> :old_id_room) then edit_status = :edit_status || ',ROOM_CHANGED';

    update BLOCK_ROOM BRU
    set    BRU.ID_ROOM = :id_room,
           BRU.FROM_DATE = :from_date,
           BRU.TO_DATE = :to_date,
           BRU.BLOCK_GRP = :block_grp,
           BRU.REASON = :reason,
           BRU.NOTE = :note
    where  BRU.RDB$DB_KEY = :b_dbkey;

    new_id_block_room = :id_block_room;
  end

  execute procedure BLOCK_MODIFY_CONTROL$INT(:b_dbkey, :min_affected_date);

  execute procedure LIST_ITEM_MODIFY(:block_grp, null, :reason, 'add');

  ------------------------------------
  execute procedure OCCUPANCY_BLOCK$INT(:b_dbkey, :edit_status);

  execute procedure OCCUPANCY_ROOMS_CHECK$INT(:b_dbkey, :block_grp)
  returning_values  :share_err_code, :share_err_text, :share_transaction_id, :warn_code;

  execute procedure sys_dbg('occ BLOCK_MODIFY$INT share_err_code = '||coalesce(:share_err_code, 'null'));
  execute procedure sys_dbg('occ BLOCK_MODIFY$INT share_err_text = '||coalesce(:share_err_text, 'null'));
  execute procedure sys_dbg('occ BLOCK_MODIFY$INT share_transaction_id = '||coalesce(:share_transaction_id, 'null'));

  execute procedure RES_FINALIZE_CLEAR$INT(:b_dbkey, :new_id_block_room);
  --
  delete from RESERV_STAY$TMP t
  where  t.id_session = RDB$GET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION');
end
^

/* Restore proc. body: CONTRACT_EXPENSE_POST$INT */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT TYPE OF ID,
ID_HOTEL INTEGER,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
ID_OWNER TYPE OF ID,
OWNERSHIP_PERCENT TYPE OF TPERCENT,
ID_RENTAL_POOL TYPE OF ID_REF,
VALUE_ORIG TYPE OF TPRICE,
CURR_ORIG TYPE OF TCURRENCY,
POST_DATE TYPE OF TDATE,
STAY TYPE OF TCOUNT,
MAX_GUEST_CNT TYPE OF TCOUNT,
BED_NIGHT_CNT TYPE OF TCOUNT,
RESERVS TYPE OF TCOUNT)
 AS
declare variable service_price numeric(15,4);
  declare variable id_currency varchar(3);
  declare variable contract_expense_type varchar(50);
  declare variable id_account integer;
  declare variable post_value numeric(15,4);
  declare variable post_currency varchar(3);
  declare variable id_service integer;
  declare variable is_owner_income smallint;
  declare variable is_client_acc_post smallint;
  declare variable multiplier_type varchar(50);
  declare variable multiplier integer;
  declare variable id_room integer;
  declare variable use_shadow_account integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
begin
  is_owner_income = 0;
  use_shadow_account = iif(:SUB_CONTRACT = 'SHADOW_ACC', 1, 0);

  select r.ID_HOTEL
  from   PMS_EVENT$PMS p
         join ROOMS R on r.ID_ROOM = p.ID_ROOM
  where  p.ID_PMS_EVENT = :ID_PMS_EVENT
  into   :id_hotel;
-- CONTRACT_EXPENSE_TYPE in ( 'PERCENT', 'RUNNING_TOTAL_PERCENT', 'CURR_VALUE' )
-- MULTIPLIER_TYPE in ('RESERVATION', 'STAY', 'GUESTS', 'BED_NIGHTS')
  for
    select C.SERVICE_PRICE, C.ID_CURRENCY, C.CONTRACT_EXPENSE_TYPE, C.IS_ACC_POST_ITEM,
           C.ID_SERVICE, C.MULTIPLIER_TYPE
    from   CONTRACT_EXPENSE$PMS C
    where  C.ID_CONTRACT = :id_contract
           and c.SUB_CONTRACT = :SUB_CONTRACT
    order by C.ORDER_TAG asc
    into   :service_price, :id_currency, :contract_expense_type, :is_client_acc_post,
           :ID_SERVICE, :multiplier_type
  do begin

    execute procedure OWNER_ACCOUNT_GET$INT (coalesce(:ID_RENTAL_POOL,:ID_OWNER),
            :id_hotel, :use_shadow_account, :is_client_acc_post)
    returning_values (:id_account, :is_account$pms);

    multiplier = case
                   when :multiplier_type = 'RESERVATION' then iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'STAY' then :STAY
                   when :multiplier_type = 'GUESTS' then :MAX_GUEST_CNT * iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'BED_NIGHTS' then :BED_NIGHT_CNT
                   else null
                 end;

    if (:multiplier is not null) then begin
      if (:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE') then begin
        post_value = cast(:service_price as double precision) * :ownership_percent / 100 * :multiplier;
        post_currency = :id_currency;
      end else if (:CONTRACT_EXPENSE_TYPE = 'PERCENT') then begin
        post_value = :VALUE_ORIG * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end else if (:CONTRACT_EXPENSE_TYPE = 'RUNNING_TOTAL_PERCENT') then begin
        execute procedure PMS_RUNNING_TOTAL_GET(:ID_PMS_EVENT, coalesce(:ID_RENTAL_POOL,:ID_OWNER), :ID_HOTEL, :POST_DATE, :CURR_ORIG)
        returning_values :post_value;
        if (:post_value < 0) then post_value = 0;
    
        post_value = :post_value * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end

      select pe.ID_ROOM
      from   PMS_EVENT$PMS PE
      where  pe.ID_PMS_EVENT = :ID_PMS_EVENT
      into   :id_room;

      select c.ROUND_TO
      from   CURRS C
      where  c.CURR = :post_currency
      into   :round_to;

      execute procedure PMS_POSTING_CREATE$INT(:ID_PMS_EVENT, :id_account, :id_service, :ID_OWNER,
              :POST_DATE, :post_currency, round_f(:post_value, :round_to), :is_account$pms, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* Restore proc. body: CURR_RATE_MODIFY */
ALTER PROCEDURE CURR_RATE_MODIFY(CURR CHAR(3),
ID_HOTEL INTEGER,
RATE NUMERIC(15,6),
FOR_DATE DATE = null)
 AS
declare variable ap_dbkey char(8);
  declare variable guest_posting_rate varchar(20);
  declare variable from_date date;
  declare variable cr_dbkey char(8);
  declare variable old_rate numeric(15,6);
  declare variable id_curr_rate integer;
  declare variable hotel_name varchar(50);
  declare variable action_text varchar(255);
  declare variable nation_curr tcurrency;
begin
  for_date = coalesce(:FOR_DATE, current_date);

  select h.HOTEL_NAME, h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :ID_HOTEL
  into   :hotel_name, :nation_curr;

  if (:nation_curr = :CURR and :RATE <> 1) then exception ASSERT '-35';

  select cr.RDB$DB_KEY, cr.CURR_RATE
  from   CURR_RATES CR
  where  CR.CURR = :CURR
         and cr.ID_HOTEL = :ID_HOTEL
         and cr.DATE_ = :FOR_DATE
  into   :cr_dbkey, :old_rate;

  if (:old_rate is null) then begin
    insert into CURR_RATES (CURR, ID_HOTEL, DATE_, CURR_RATE)
    values (:CURR, :ID_HOTEL, :FOR_DATE, :RATE)
    returning ID_CURR_RATE into :id_curr_rate;

    select first 1 r.CURR_RATE
    from   CURR_RATES r
    where  r.ID_HOTEL = :ID_HOTEL
           and r.CURR = :CURR
           and r.DATE_ < :FOR_DATE
    order by r.DATE_ desc
    into   :old_rate;

  end else if (:old_rate <> :RATE) then begin
    update CURR_RATES r
    set    r.CURR_RATE = :RATE
    where  r.RDB$DB_KEY = :cr_dbkey;
  end else begin
    exit;
  end

  action_text = f_character(29) || :hotel_name || f_character(28)
                || formatdate(:FOR_DATE, 'D;dd.mm.yyyy') || f_character(28)
                || coalesce(:old_rate, 'N/A') || f_character(28)
                || coalesce(:RATE, 'N/A');

  execute procedure SYSTEM_LOG_ADD ('CURRENCY', :id_curr_rate, 'RATE_CHANGED', :action_text, :RATE);

  if (:old_rate is not null) then begin   -- this is not first, initial rate
    /* CHANGE THE CURRENR_RATE OF THE OPEN POSTINGS */
    execute procedure SETTING_GET_VALUE('GUEST_POSTING_RATE', :ID_HOTEL)
    returning_values  :guest_posting_rate;
  
    for
      select AP.rdb$db_key, G.FROM_DATE
      from   ACCOUNT_POST AP
             join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
             left outer join GUEST G on G.ID_GUEST = AP.ID_GUEST
      where  ((AP.CURR_POST = :CURR) or (AP.CURR_ORIG = :CURR))
             and AP.AC = '00'
             and AP.ID_BASE_DOC is null
             and AP.DATE_POST >= current_date
             and A.ID_HOTEL = :ID_HOTEL
      into   :ap_dbkey, :from_date
    do begin
      if (:guest_posting_rate = 'CHECKIN_DATE' and :from_date < current_date) then begin
        /* Do nothing. Theese postings are by guest check_in date rate,
        || which is not changing now
        */
      end else begin
        execute procedure ACCOUNT_POSTING_UPDATE_RATE$INT (:ap_dbkey, :CURR, :RATE);
      end
    end
  end
end
^

/* Restore proc. body: CURR_RATES_PREPARE$INT */
ALTER PROCEDURE CURR_RATES_PREPARE$INT(DOC_SELECTED INTEGER,
ID_ACCOUNT INTEGER,
DOC_DATE DATE)
 AS
declare variable account_to_doc_rate varchar(30);
  declare variable post_value double precision;
  declare variable doc_value double precision ;
  declare variable from_date date;
  declare variable curr varchar(3);
  declare variable curr_rate numeric(15,6);
  declare variable round_to numeric(15,4);
  declare variable id_hotel integer;
begin
  /****************************************************************************/
  /*  calc and set into TMP_RATES availabe currency rates                     */
  /*  used in document processing (called only once at begining)              */
  /****************************************************************************/
  curr_rate = null;

  select A.ID_HOTEL, c.ROUND_TO
  from   ACCOUNT A
         join HOTEL h on h.ID_HOTEL = a.ID_HOTEL
         join CURRS c on c.CURR = h.NATION_CURR
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :id_hotel, :round_to;

  execute procedure SETTING_GET_VALUE('ACCOUNT_TO_DOC_RATE', :id_hotel)
  returning_values  :account_to_doc_rate;

  delete from CURR_RATES$TMP cr
  where  cr.DOC_SELECTED = :DOC_SELECTED;

  if (:account_to_doc_rate = 'POSTING_RATE') then begin
    /* calc average rates for different guest check-in rates */
    insert into CURR_RATES$TMP (DOC_SELECTED, CURR, CURR_RATE)
    select :DOC_SELECTED, C.CURR, 0
    from   CURRS C;

    doc_value = 0;
    for
      select coalesce(G.FROM_DATE, AP.DATE_POST, :DOC_DATE),
             sum(cast(AP.QTY_POST * AP.PRICE_POST * AP.RATE_POST as double precision))
      from   ACCOUNT_POST AP
             left outer join GUEST G on G.ID_GUEST = AP.ID_GUEST
      where  AP.DOC_SELECTED = :DOC_SELECTED
             and AP.ID_ACCOUNT = :ID_ACCOUNT
      group by 1
      into   :from_date, :post_value
    do begin
      for
        select C.CURR
        from   CURRS C
        into   :curr
      do begin
        execute procedure CURR_RATE_GET(:CURR, :from_date, :id_hotel)
        returning_values  (:curr_rate);

        update CURR_RATES$TMP TR
        set    TR.CURR_RATE = TR.CURR_RATE + cast(:post_value / :curr_rate as double precision )
        where  TR.DOC_SELECTED = :DOC_SELECTED
               and TR.CURR = :CURR;
      end
      doc_value = :doc_value + :post_value;
    end

    if (round_f(abs(:doc_value), :round_to) < :round_to) then begin
      delete from  CURR_RATES$TMP TRD
      where  TRD.DOC_SELECTED = :DOC_SELECTED;
    end else begin
      update CURR_RATES$TMP TRU
      set    TRU.CURR_RATE = cast(:doc_value / TRU.CURR_RATE  as double precision)
      where  TRU.DOC_SELECTED = :DOC_SELECTED;
    end
  end

  /* get current rates (default) */
  for
    select C.CURR
    from   CURRS C
    where  not exists (select T.CURR_RATE
                       from   CURR_RATES$TMP T
                       where  T.CURR = C.CURR
                              and T.DOC_SELECTED = :DOC_SELECTED)
    into   :curr
  do begin
    execute procedure CURR_RATE_GET(:curr, :doc_date, :id_hotel)
    returning_values  :curr_rate;

    insert into CURR_RATES$TMP (DOC_SELECTED, CURR, CURR_RATE)
    values (:DOC_SELECTED, :curr, :curr_rate);

    when exception UNDEFIND_CURRENCY_RATE do post_event 'dummy';
  end

end
^

/* Restore proc. body: DEPOSIT_DOCUMENT_INITIALIZE$DOC */
ALTER PROCEDURE DEPOSIT_DOCUMENT_INITIALIZE$DOC(ID_PAYMENT_HEAD TYPE OF ID,
ID_BILLING_SERVICE TYPE OF ID)
 RETURNS(ID_DOC_HEAD TYPE OF ID,
ID_HOTEL TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
WARN_CODE TYPE OF TRANGE)
 AS
declare variable id_dep_doc integer;
declare variable doc_selected integer;
declare variable payment_date date;
declare variable system_date date;
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_BILLING');

  id_dep_doc = null;

  select p.ID_DOC_HEAD, p.ID_ACCOUNT, p.PAYMENT_DATE, a.ID_HOTEL
  from   PAYMENT_HEAD P
         join DEPOSIT d on d.ID_PAYMENT_HEAD = p.ID_PAYMENT_HEAD
         join ACCOUNT a on a.ID_ACCOUNT = p.ID_ACCOUNT
  where  p.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
         and p.IS_ANUL = 0
  into   :id_dep_doc, :id_account, :payment_date, :id_hotel;

  if (:id_account is null) then
    exception DOCUMENT_EXCEPTION '-355';

  if (:id_dep_doc is not null) then
    exception DOCUMENT_EXCEPTION '-364';

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :system_date;

  if (:payment_date < :system_date) then
    exception DOCUMENT_EXCEPTION '-399';

  doc_selected = gen_id(DOC_SELECTED_GEN, 1);

  update DEPOSIT P
  set    p.DOC_SELECTED = :doc_selected,
         p.ID_BILLING_SERVICE = :ID_BILLING_SERVICE
  where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;

  execute procedure DOCUMENT_INITIALIZE$DOC (:ID_ACCOUNT, :doc_selected)
  returning_values  (:ID_DOC_HEAD, :ID_HOTEL, :WARN_CODE);

end
^

/* Restore proc. body: DOC_LINES_SUSPEND */
ALTER PROCEDURE DOC_LINES_SUSPEND(ID_DOC_HEAD INTEGER,
CORRECTION_INDEX INTEGER,
SUBSTITUTE_PACK_NAME VARCHAR(50),
REPORT_TYPE VARCHAR(20),
RPT_CURR VARCHAR(10),
RPT_VAT VARCHAR(20),
EXTRA_DATA_SUSPEND SMALLINT)
 RETURNS(ID_DOC_LINE INTEGER,
LINE_NAME VARCHAR(100),
ID_GUEST INTEGER,
ROOM_NAME VARCHAR(10),
FROM_DATE DATE,
TO_DATE DATE,
DATE_POST DATE,
IS_BASE SMALLINT,
IS_CORRECT SMALLINT,
IS_FOR_PAY SMALLINT,
GROUP_TAG INTEGER,
TAX_STATUS INTEGER,
ID_SERVICE INTEGER,
ID_SERVICE_GROUP INTEGER,
GROUP_NAME VARCHAR(30),
IS_PACKET_POST SMALLINT,
ID_PACK_SERVICE INTEGER,
PACK_SERVICE_NAME VARCHAR(50),
QTY_POST NUMERIC(15,4),
PACK_QTY NUMERIC(15,4),
SINGLE_PRICE NUMERIC(15,4),
LINE_VALUE NUMERIC(15,4),
VAT_VALUE NUMERIC(15,4),
PACK_PRICE NUMERIC(15,4),
PACK_PRICE_WOT_DIFF DOUBLE PRECISION,
POST_PRICE_WOT_DIFF DOUBLE PRECISION,
SEC_CURR_LINE_VALUE NUMERIC(15,4),
SEC_CURR_GROSS_VALUE NUMERIC(15,4),
ID_SALE_TAXATION INTEGER)
 AS
declare variable prev_id_service integer;
  declare variable prev_id_guest integer;
  declare variable prev_price numeric(15,4);
  declare variable prev_date date;
  declare variable no_use varchar(255);
  declare variable dbg varchar(1000);
  declare variable round_to numeric(15,4);
begin
  /* PACK_PRICE_WOT_DIFF and POST_PRICE_WOT_DIFF are only for grouping */
  /* Params: REPORT_TYPE, EXTRA_DATA_SUSPEND - for future use */
  dbg = null;
  correction_index = coalesce(:correction_index, 1);
  if (:report_type is null) then report_type = '';
  if (:extra_data_suspend is null) then extra_data_suspend = 0;
  prev_id_guest   = null;
  prev_id_service = null;
  prev_date       = null;
  prev_price      = 0;
  group_tag       = 0;
  select C.ROUND_TO
  from   DOC_HEAD$INT D
         join CURRS C on C.CURR = D.DOC_CURRENCY
  where  D.ID_DOC_HEAD = :id_doc_head
  into   :round_to;

  if (:report_type = 'services') then begin
    /* SERVICE GROUPING */
    for
      select cast(DLS.SINGLE_WOT_DIFF/:round_to as integer),
             ID_DOC_LINE, LINE_NAME, ID_GUEST, ROOM_NAME, FROM_DATE,
             TO_DATE, DATE_POST, IS_BASE, IS_CORRECT, IS_FOR_PAY, GROUP_TAG, TAX_STATUS,
             ID_SERVICE, ID_SERVICE_GROUP, GROUP_NAME, IS_PACKET_POST, ID_PACK_SERVICE,
             PACK_SERVICE_NAME, QTY_POST, PACK_QTY,
             SINGLE_PRICE, LINE_VALUE, VAT_VALUE, PACK_PRICE,
             round_f(PACK_PRICE_WOT_DIFF, :round_to), round_f(SINGLE_WOT_DIFF, :round_to),
             DLS.SEC_CURR_LINE_VALUE, DLS.SEC_CURR_GROSS_VALUE, DLS.ID_SALE_TAXATION
      from   DOC_LINES_SUSPEND_SUB (:id_doc_head, :correction_index, :substitute_pack_name, :rpt_vat, :rpt_curr, 'NONE') DLS
      order by DLS.IS_BASE desc, DLS.IS_CORRECT asc, DLS.ID_SERVICE asc, /*DLS.POST_PRICE_WOT_DIFF*/ 1 asc, DLS.DATE_POST asc
      into   :no_use, :id_doc_line, :line_name, :id_guest, :room_name, :from_date,
             :to_date, :date_post, :is_base, :is_correct, :is_for_pay, :no_use, :tax_status,
             :id_service, :id_service_group, :group_name, :is_packet_post, :id_pack_service,
             :pack_service_name, :qty_post, :pack_qty,
             :single_price, :line_value, :VAT_VALUE, :pack_price,
             :pack_price_wot_diff, :post_price_wot_diff,
             :SEC_CURR_LINE_VALUE, :SEC_CURR_GROSS_VALUE, :id_sale_taxation
    do begin
      if ((:prev_id_service is null) /*or (:prev_id_service <> :id_service)*/) then begin
        prev_id_service = :id_service;
        prev_price = :post_price_wot_diff;
        prev_date = :date_post;
      end
      if ((:prev_id_service <> :id_service)
          or (:prev_price <> :post_price_wot_diff)
          or (:date_post - :prev_date > 1 and :is_base = 1)
      ) then begin
        group_tag = :group_tag + 1;
        prev_id_service = :id_service;
        prev_price = :post_price_wot_diff;
      end
      prev_date = :date_post;
      suspend;
    end
  end else if (:report_type = 'packages') then begin
    /* PACKAGE GROUPING */
    for
      select cast(DLS.PACK_PRICE_WOT_DIFF/:round_to as integer),
             ID_DOC_LINE, LINE_NAME, ID_GUEST, ROOM_NAME, FROM_DATE,
             TO_DATE, DATE_POST, IS_BASE, IS_CORRECT, IS_FOR_PAY, GROUP_TAG, TAX_STATUS,
             ID_SERVICE , ID_SERVICE_GROUP, GROUP_NAME, IS_PACKET_POST, ID_PACK_SERVICE,
             PACK_SERVICE_NAME, QTY_POST, PACK_QTY,
             SINGLE_PRICE, LINE_VALUE, VAT_VALUE, PACK_PRICE,
             round_f(PACK_PRICE_WOT_DIFF, :round_to), round_f(SINGLE_WOT_DIFF, :round_to),
             DLS.SEC_CURR_LINE_VALUE, DLS.SEC_CURR_GROSS_VALUE, DLS.ID_SALE_TAXATION
      from   DOC_LINES_SUSPEND_SUB (:id_doc_head, :correction_index, :substitute_pack_name, :rpt_vat, :rpt_curr, 'ALL') DLS
      order by /*DLS.IS_BASE desc,*/ DLS.IS_PACKET_POST desc, DLS.IS_CORRECT asc,
             DLS.ID_PACK_SERVICE asc, /*DLS.PACK_PRICE_WOT_DIFF*/ 1 asc, DLS.DATE_POST asc
      into   :no_use, :id_doc_line, :line_name, :id_guest, :room_name, :from_date,
             :to_date, :date_post, :is_base, :is_correct, :is_for_pay, :no_use, :tax_status,
             :id_service , :id_service_group, :group_name, :is_packet_post, :id_pack_service,
             :pack_service_name, :qty_post, :pack_qty,
             :single_price, :line_value, :VAT_VALUE ,:pack_price,
             :pack_price_wot_diff, :post_price_wot_diff,
             :SEC_CURR_LINE_VALUE, :SEC_CURR_GROSS_VALUE, :id_sale_taxation
    do begin
      if ((:prev_id_service is null) /*or (:prev_id_service <> :id_pack_service)*/) then begin
        prev_id_service = :id_pack_service;
        prev_price = :pack_price_wot_diff;
        prev_date = :date_post;
      end
      if ((:prev_id_service <> :id_pack_service)
          or (:prev_price <> :pack_price_wot_diff)
          or (:date_post - :prev_date > 1 and :is_base = 1)
      ) then begin
        group_tag = :group_tag + 1;
        prev_id_service = :id_pack_service;
        prev_price = :pack_price_wot_diff;
      end
      prev_date = :date_post;
      suspend;
    end
  end else if (:report_type = 'groups') then begin
    /* SERVICE_GROUP GROUPING  */
    for
      select cast(DLS.SINGLE_WOT_DIFF/:round_to as integer),
             ID_DOC_LINE, LINE_NAME, ID_GUEST, ROOM_NAME, FROM_DATE,
             TO_DATE, DATE_POST, IS_BASE, IS_CORRECT, IS_FOR_PAY, GROUP_TAG, TAX_STATUS,
             ID_SERVICE , ID_SERVICE_GROUP, GROUP_NAME, IS_PACKET_POST, ID_PACK_SERVICE,
             PACK_SERVICE_NAME, QTY_POST, PACK_QTY,
             SINGLE_PRICE, LINE_VALUE, VAT_VALUE, PACK_PRICE,
             round_f(PACK_PRICE_WOT_DIFF, :round_to), round_f(SINGLE_WOT_DIFF, :round_to),
             DLS.SEC_CURR_LINE_VALUE, DLS.SEC_CURR_GROSS_VALUE, DLS.ID_SALE_TAXATION
      from   DOC_LINES_SUSPEND_SUB (:id_doc_head, :correction_index, :substitute_pack_name, :rpt_vat, :rpt_curr, 'NONE') DLS
      order by DLS.IS_BASE desc, DLS.IS_CORRECT asc, DLS.ID_SERVICE_GROUP asc, /*DLS.POST_PRICE_WOT_DIFF*/ 1 asc, DLS.DATE_POST asc
      into   :no_use, :id_doc_line, :line_name, :id_guest, :room_name, :from_date,
             :to_date, :date_post, :is_base, :is_correct, :is_for_pay, :no_use, :tax_status,
             :id_service , :id_service_group, :group_name, :is_packet_post, :id_pack_service,
             :pack_service_name, :qty_post, :pack_qty,
             :single_price, :line_value, :VAT_VALUE, :pack_price,
             :pack_price_wot_diff, :post_price_wot_diff,
             :SEC_CURR_LINE_VALUE, :SEC_CURR_GROSS_VALUE, :id_sale_taxation
    do begin
      if ((:prev_id_service is null) /*or (:prev_id_service <> :ID_SERVICE_GROUP)*/) then begin
        prev_id_service = :id_service_group;
        prev_price = :post_price_wot_diff;
        prev_date = :date_post;
      end
      if ((:prev_id_service <> :id_service_group)
         or (:prev_price <> :post_price_wot_diff)
         or (:date_post - :prev_date > 1 and :is_base = 1)
      ) then begin
        group_tag = :group_tag + 1;
        prev_id_service = :id_service_group;
        prev_price = :post_price_wot_diff;
      end
      prev_date = :date_post;
      suspend;
    end
  end else begin
    /* DETAIL GROUPING - BY DEFAULT */
    for
      select ID_DOC_LINE, LINE_NAME, ID_GUEST, ROOM_NAME, FROM_DATE,
             TO_DATE, DATE_POST, IS_BASE, IS_CORRECT, IS_FOR_PAY, GROUP_TAG, TAX_STATUS,
             ID_SERVICE , ID_SERVICE_GROUP, GROUP_NAME, IS_PACKET_POST, ID_PACK_SERVICE,
             PACK_SERVICE_NAME, QTY_POST, PACK_QTY,
             SINGLE_PRICE, LINE_VALUE, VAT_VALUE, PACK_PRICE,
             round_f(PACK_PRICE_WOT_DIFF, :round_to), round_f(SINGLE_WOT_DIFF, :round_to),
             DLS.SEC_CURR_LINE_VALUE, DLS.SEC_CURR_GROSS_VALUE, DLS.ID_SALE_TAXATION
      from   DOC_LINES_SUSPEND_SUB (:id_doc_head, :correction_index, :substitute_pack_name, :rpt_vat, :rpt_curr, 'NONE') DLS
      order by DLS.IS_BASE desc, DLS.IS_CORRECT asc, DLS.ID_GUEST asc, DLS.ID_SERVICE asc, /*DLS.POST_PRICE_WOT_DIFF asc,*/ DLS.DATE_POST asc
      into   :id_doc_line, :line_name, :id_guest, :room_name, :from_date,
             :to_date, :date_post, :is_base, :is_correct, :is_for_pay, :no_use, :tax_status,
             :id_service , :id_service_group, :group_name, :is_packet_post, :id_pack_service,
             :pack_service_name, :qty_post, :pack_qty,
             :single_price, :line_value, :VAT_VALUE, :pack_price,
             :pack_price_wot_diff, :post_price_wot_diff,
             :SEC_CURR_LINE_VALUE, :SEC_CURR_GROSS_VALUE, :id_sale_taxation
    do begin
      if ((:prev_id_guest is null) /*or (:prev_id_guest <> :id_guest)*/) then begin
        prev_id_guest = :id_guest;
        prev_id_service = :id_service;
        prev_price = :post_price_wot_diff;
        prev_date = :date_post;
      end
      if ((:prev_id_guest <> :id_guest)
         or (:prev_id_service <> :id_service)
         or (:prev_price <> :post_price_wot_diff)
         or (:date_post - :prev_date > 1 and :is_base = 1)
      ) then begin
        group_tag = :group_tag + 1;
        prev_id_guest = :id_guest;
        prev_id_service = :id_service;
        prev_price = :post_price_wot_diff;
      end
      prev_date = :date_post;
      suspend;
    end
  end
end
^

/* Restore proc. body: DOC_LINES_SUSPEND_INVOICE */
ALTER PROCEDURE DOC_LINES_SUSPEND_INVOICE(ID_DOC_HEAD INTEGER,
CORRECTION_INDEX INTEGER,
RPT_TYPE VARCHAR(20),
RPT_CURR VARCHAR(10),
RPT_VAT VARCHAR(20),
IN_VAUCHER_NUM VARCHAR(20))
 RETURNS(TAX_STATUS INTEGER,
ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
VAUCHER_NUM VARCHAR(20),
GUEST_NAME VARCHAR(100),
IS_CHILD INTEGER,
AGES_NAME VARCHAR(50),
GFROM_DATE DATE,
GTO_DATE DATE,
PACKET_NAME VARCHAR(50),
LINE_NAME VARCHAR(100),
ID_SERVICE INTEGER,
DATE_POST DATE,
QTY_POST NUMERIC(15,2),
SINGLE_PRICE NUMERIC(15,4),
LINE_VALUE NUMERIC(15,4),
PACKET_PRICE NUMERIC(15,4),
PACKET_PRICE_WOT_DIFF DOUBLE PRECISION,
ID_TARIFA INTEGER,
BIRTH_DATE DATE,
NIGHTS INTEGER,
IS_BASE INTEGER)
 AS
declare variable DOC_VAT_STATUS integer;
  declare variable DL_DBKEY char(8);
  declare variable NO_USE varchar(255);
  declare variable VAUCHER_PACKET varchar(20);
begin
  /*  Description:
  ||  RPT_TYPE - PACKETS, OTHER, TAX_STATUS, TAXES
  */
  select DT.IS_VAT
  from   DOC_HEAD$INT DH
         join DOC_TYPE DT on DT.ID_DOC_TYPE = DH.ID_DOC_TYPE
  where  DH.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :DOC_VAT_STATUS;

  if (:RPT_TYPE = 'PACKETS') then begin
    for
      select DL.RDB$DB_KEY, DL.TAX_STATUS, DL.ID_GUEST, DL.DATE_POST, G.ID_TARIFA, coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET), PV.IS_BASE,
             GC.GUEST_NAME1, G.IS_CHILD, AG.AGES_NAME, G.FROM_DATE, G.TO_DATE, G.ID_RESERV_DETAIL,
             case when coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'SECONDARY' then G.VAUCHER_NUM2 else G.VAUCHER_NUM end,
             GC.BIRTH_DAY, S.ID_SERVICE
      from   DOC_LINE DL
             join SERVICES S on S.ID_SERVICE = DL.ID_SERVICE
             left outer join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE
             left outer join GUEST G on G.ID_GUEST = DL.ID_GUEST
             left outer join AGENT_PACKET APA on APA.ID_AGENT = G.ID_AGENT and APA.ID_SERVICE = DL.ID_SERVICE
             left outer join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
             left outer join AGENT_AGES AG on AG.ID_AGENT_AGES = G.ID_AGENT_AGES
             left outer join AGENT_TYPE_STAY ATS on ATS.ID_AGENT = G.ID_AGENT and ATS.ID_SERVICE = case when coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'BASE' then PV.ID_PACK_SERVICE else DL.ID_SERVICE end
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
             and ((PV.IS_BASE = 1) or (coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) in ('SECONDARY', 'PARALLEL')))
             and ((:IN_VAUCHER_NUM = '') or (case when coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'SECONDARY' then G.VAUCHER_NUM2 else G.VAUCHER_NUM end = :IN_VAUCHER_NUM))
      into   :DL_DBKEY, :TAX_STATUS, :ID_GUEST, :DATE_POST, :ID_TARIFA, :VAUCHER_PACKET, :IS_BASE,
             :GUEST_NAME, :IS_CHILD, :AGES_NAME, :GFROM_DATE, :GTO_DATE, :ID_RESERV_DETAIL,
             :VAUCHER_NUM, :BIRTH_DATE, :ID_SERVICE
    do begin
      if (:IS_BASE = 0) then begin
        execute procedure DOC_LINES_SUSPEND_LINE(:DL_DBKEY, :RPT_CURR, :RPT_VAT, 'NONE', :DOC_VAT_STATUS, :CORRECTION_INDEX)
        returning_values :NO_USE, :PACKET_NAME, :PACKET_PRICE, :PACKET_PRICE_WOT_DIFF, :SINGLE_PRICE, :LINE_VALUE,
                         :NO_USE, :NO_USE, :QTY_POST, :QTY_POST, :NO_USE, :NO_USE, :NO_USE;

        PACKET_PRICE = :LINE_VALUE;
        NIGHTS = 0;
      end else begin
        execute procedure DOC_LINES_SUSPEND_LINE(:DL_DBKEY, :RPT_CURR, :RPT_VAT, 'IN_PACKET', :DOC_VAT_STATUS, :CORRECTION_INDEX)
        returning_values :ID_SERVICE, :PACKET_NAME, :PACKET_PRICE, :PACKET_PRICE_WOT_DIFF, :NO_USE, :NO_USE,
                         :NO_USE, :NO_USE, :QTY_POST, :QTY_POST, :NO_USE, :NO_USE, :NO_USE;                                      

        NIGHTS = 1;
      end
      suspend;
    end
  end if (:RPT_TYPE = 'OTHER') then begin
    for
      select DL.RDB$DB_KEY, DL.LINE_NAME, G.ID_GUEST, G.ID_RESERV_DETAIL, DL.ID_SERVICE
      from   DOC_LINE DL
             join SERVICES S on S.ID_SERVICE = DL.ID_SERVICE
             left outer join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE
             left outer join GUEST G on G.ID_GUEST = DL.ID_GUEST
             left outer join AGENT_PACKET APA on APA.ID_AGENT = G.ID_AGENT and APA.ID_SERVICE = DL.ID_SERVICE
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
             and DL.TAX_STATUS in (0, 1)
             and coalesce(PV.IS_BASE, 0) = 0
             and ((coalesce(PV.ID_MASTER_ADDINS, -1) = -1)
                  or (coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'OTHER')
                  or ((coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) not in ('SECONDARY', 'PARALLEL'))
                       and not exists (select DML.ID_DOC_LINE
                                  from   DOC_LINE DML
                                         join DOC_LINE_POST_VALUES DPV on DPV.ID_DOC_LINE = DML.ID_DOC_LINE
                                  where  DML.ID_DOC_HEAD = DL.ID_DOC_HEAD
                                         and DPV.ID_ACCOUNT_POST = PV.ID_MASTER_ADDINS)) )
      into   :DL_DBKEY, :LINE_NAME, :ID_GUEST, :ID_RESERV_DETAIL, :ID_SERVICE
    do begin
      execute procedure DOC_LINES_SUSPEND_LINE(:DL_DBKEY, :RPT_CURR, :RPT_VAT, 'NONE',
        :DOC_VAT_STATUS, :CORRECTION_INDEX)
      returning_values (:NO_USE, :NO_USE, :PACKET_PRICE,
        :PACKET_PRICE_WOT_DIFF, :SINGLE_PRICE, :LINE_VALUE, :NO_USE, :NO_USE,
        :QTY_POST, :QTY_POST, :NO_USE, :NO_USE, :NO_USE);
      suspend;
    end
  end if (:RPT_TYPE = 'TAXES') then begin
    for
      select DL.RDB$DB_KEY, DL.LINE_NAME, DL.ID_SERVICE
      from   DOC_LINE DL
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
             and DL.TAX_STATUS > 1
      into   :DL_DBKEY, :LINE_NAME, :ID_SERVICE
    do begin
      execute procedure DOC_LINES_SUSPEND_LINE(:DL_DBKEY, :RPT_CURR, :RPT_VAT, 'NONE',
        :DOC_VAT_STATUS, :CORRECTION_INDEX)
      returning_values (:NO_USE, :NO_USE, :PACKET_PRICE,
        :PACKET_PRICE_WOT_DIFF, :SINGLE_PRICE, :LINE_VALUE, :NO_USE, :NO_USE,
        :QTY_POST, :QTY_POST, :NO_USE, :NO_USE, :NO_USE);
      suspend;
    end
  end
end
^

/* Restore proc. body: DOC_LINES_SUSPEND_LINE */
ALTER PROCEDURE DOC_LINES_SUSPEND_LINE(DL_DBKEY CHAR(8),
RPT_CURR VARCHAR(20),
RPT_VAT VARCHAR(20),
RPT_PACKETS VARCHAR(10),
DOC_VAT_STATUS INTEGER,
CORRECTION_INDEX INTEGER)
 RETURNS(ID_PACK_SERVICE INTEGER,
PACK_NAME VARCHAR(50),
PACK_PRICE NUMERIC(15,2),
PACK_PRICE_WOT_DIFF DOUBLE PRECISION,
SINGLE_PRICE NUMERIC(15,4),
LINE_VALUE NUMERIC(15,4),
VAT_VALUE NUMERIC(15,4),
SINGLE_WOT_DIFF DOUBLE PRECISION,
QTY_POST NUMERIC(15,4),
PACK_QTY NUMERIC(15,4),
IS_PACKET_POST INTEGER,
SEC_CURR_LINE_VALUE NUMERIC(15,4),
SEC_CURR_GROSS_VALUE NUMERIC(15,4))
 AS
declare variable id_master_addins integer;
  declare variable id_doc_head integer;
  declare variable vat_status integer;
  declare variable is_base integer;                             
  declare variable is_base_packet_post integer;
  declare variable is_correct integer;
  declare variable id_account_post integer;
  declare variable single_with_vat numeric (15,4);
  declare variable single_wot_vat numeric (15,4);
  declare variable line_with_vat numeric (15,4);
  declare variable line_wot_vat numeric (15,4);
  declare variable pack_price_with_vat numeric (15,4);
  declare variable pack_price_wot_vat numeric (15,4);
  declare variable addins_price_wot_vat numeric (15,4);
  declare variable addins_price_with_vat numeric (15,4);
  declare variable addins_pack_price_wot_diff double precision;
  declare variable id_vat_group integer;
  declare variable round_to numeric(15,4);
  declare variable add_pack_name varchar(50);
  declare variable add_pack_name_int varchar(50);
  declare variable id_service integer;
  declare variable id_pack_hrana integer;
  declare variable is_separate_pansion integer;
  declare variable is_separate_pansion_int integer;
  declare variable line_sec_curr_wot_vat numeric(15,4);
  declare variable line_sec_curr_with_vat numeric(15,4);
  declare variable addins_sec_curr_wot_vat numeric(15,4);
  declare variable addins_sec_curr_with_vat numeric(15,4);
  declare variable pack_sec_curr_wot_vat numeric(15,4);
  declare variable pack_sec_curr_with_vat numeric(15,4);
  declare variable line_name varchar(100);
begin
  /* RPT_PACKETS - 'ALL', 'IN_PACKET', 'NONE'
  || RPT_VAT:
  ||  'line' - single price to be without vat,
  ||  'total' - single price with vat, document total by vat groups,
  ||  'none' - do not show values without vat.
  */
  round_to = 0.0001;
  if ((:rpt_vat is null) or (:rpt_vat = '')) then rpt_vat = 'as_doc';
  if (:rpt_vat = 'line') then vat_status = 2;
  else if (:rpt_vat in ('total', 'none')) then vat_status = 1;
  else vat_status = :doc_vat_status;

  select coalesce(PV.IS_BASE, 0), DL.IS_CORRECT, iif(DL.IS_CORRECT = 0, DL.QTY_POST * cast(:correction_index as smallint), DL.qty_post),
         iif(DL.is_correct <> 0, dl.single_wot_vat * cast(:correction_index as smallint), DL.SINGLE_WOT_VAT),
         iif(dl.is_correct <> 0, dl.single_value * cast(:correction_index as smallint), DL.SINGLE_VALUE),
         DL.WOT_VAT * cast(:correction_index as smallint), DL.QTY_POST * DL.SINGLE_VALUE * cast(:correction_index as smallint),
         iif(:rpt_curr = 'doc', DL.WOT_DIFF, coalesce(PV.ACCOUNT_PRICE, DL.WOT_DIFF * D.DOC_ACC_RATE)),
         PV.ID_MASTER_ADDINS, PV.ID_ACCOUNT_POST, DL.ID_DOC_HEAD, DL.ID_SALE_TAXATION,
         PV.ID_PACK_SERVICE, DL.ID_SERVICE, Sp.ID_BOARD, dl.sec_curr_net_value, dl.sec_curr_gross_value, dl.LINE_NAME
  from   DOC_LINE DL
         left join DOC_HEAD$INT D on D.ID_DOC_HEAD = Dl.ID_DOC_HEAD
         left outer join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE
         left outer join SERVICES S on S.ID_SERVICE = PV.ID_PACK_SERVICE
         left outer join SERVICE_PACKET sp on sp.ID_SERVICE = s.ID_SERVICE
  where  DL.RDB$DB_KEY = :dl_dbkey
  into   :is_base, :is_correct, :qty_post, :single_wot_vat, :single_with_vat,
         :line_wot_vat, :line_with_vat, :single_wot_diff,
         :id_master_addins, :id_account_post, :id_doc_head, :id_vat_group,
         :id_pack_service, :id_service, :id_pack_hrana, :line_sec_curr_wot_vat, :line_sec_curr_with_vat, :line_name;

  if (:is_base = 1) then begin
    is_packet_post = 1;
    id_master_addins = :id_account_post;
  end else if (:id_master_addins is not null) then begin
    select count(dlpv.id_account_post)
    from   DOC_LINE_POST_VALUES DLPV
           join DOC_LINE doc_l on doc_l.id_doc_line = dlpv.id_doc_line
    where  dlpv.id_account_post = :id_master_addins
           and dlpv.is_base = 1
           and doc_l.id_doc_head = :id_doc_head
    into   :is_base_packet_post;
    if (:is_base_packet_post > 0) then is_packet_post = 1; else is_packet_post = 0;
  end else begin
    is_packet_post = 0;
  end

  if (:rpt_curr = 'acc') then begin
    single_with_vat = :single_wot_diff;
    select sv.VALUE_WOT_TAX
    from   TAX_VALUE_DEDUCT (:single_with_vat, :round_to, :id_vat_group) sv
    into   :single_wot_vat;
    line_with_vat = :single_wot_diff*:qty_post; --*:correction_index;
    select sv.VALUE_WOT_TAX
    from   TAX_VALUE_DEDUCT (:line_with_vat, :round_to, :id_vat_group) sv
    into   :line_wot_vat;
  end
  add_pack_name = '';

  if ((:is_packet_post = 1) and (:rpt_packets <> 'NONE')) then begin
    pack_price_wot_vat  = 0;
    pack_price_with_vat = 0;
    pack_price_wot_diff = 0;
    is_separate_pansion = 1;
    pack_sec_curr_wot_vat = 0;
    pack_sec_curr_with_vat = 0;
    /* GET SUM OF ADDINS PRICES  */
    for
      select DLM.ID_SALE_TAXATION,
             S.EXTRA_PACKET_NAME,
             min(iif(Sp.ID_BOARD = :id_pack_hrana, 0, 1)),
             sum(DLM.SINGLE_WOT_VAT * DLM.QTY_POST * cast(:correction_index as smallint)),
             sum(DLM.SINGLE_VALUE * DLM.QTY_POST * cast(:correction_index as smallint)),
             sum(case when :rpt_curr = 'doc' then DLM.WOT_DIFF else PV.ACCOUNT_PRICE end * DLM.QTY_POST * cast(:correction_index as smallint)),
             sum(dlm.sec_curr_net_value),
             sum(dlm.sec_curr_gross_value)
      from   DOC_LINE DLM
             join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DLM.ID_DOC_LINE
             left outer join GUEST G on G.ID_GUEST = DLM.ID_GUEST
             left outer join AGENT_PACKET APA on APA.ID_AGENT = G.ID_AGENT and APA.ID_SERVICE = DLM.ID_SERVICE
             left outer join SERVICES S on S.ID_SERVICE = DLM.ID_SERVICE
             left outer join SERVICE_PACKET sp on sp.ID_SERVICE = s.ID_SERVICE
      where  DLM.ID_DOC_HEAD = :id_doc_head
             and PV.ID_MASTER_ADDINS = :id_master_addins
             and ((:rpt_packets = 'ALL') or (coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'BASE'))
      group by 1, 2
      into   :id_vat_group, :add_pack_name_int, :is_separate_pansion_int,
             :addins_price_wot_vat, :addins_price_with_vat, :addins_pack_price_wot_diff, :addins_sec_curr_wot_vat, :addins_sec_curr_with_vat
    do begin
      if (:add_pack_name_int <> '') then add_pack_name = :add_pack_name ||'\'|| :add_pack_name_int;
      if (:is_separate_pansion_int = 0) then is_separate_pansion = 0;
      addins_price_wot_vat = coalesce(:addins_price_wot_vat, 0);
      addins_price_with_vat = coalesce(:addins_price_with_vat, 0);
      addins_pack_price_wot_diff = coalesce(:addins_pack_price_wot_diff, 0);
      addins_sec_curr_wot_vat = coalesce(:addins_sec_curr_wot_vat, 0);
      addins_sec_curr_with_vat = coalesce(:addins_sec_curr_with_vat, 0);
      if (:rpt_curr = 'acc') then begin
        addins_price_with_vat = :addins_pack_price_wot_diff;
        select SV.VALUE_WOT_TAX
        from   TAX_VALUE_DEDUCT (:addins_price_with_vat, :round_to, :id_vat_group) sv
        into   :addins_price_wot_vat;
      end
      pack_price_wot_diff = :pack_price_wot_diff + :addins_pack_price_wot_diff;
      pack_price_with_vat = :pack_price_with_vat + :addins_price_with_vat;
      pack_price_wot_vat  = :pack_price_wot_vat + :addins_price_wot_vat;
      pack_sec_curr_wot_vat = :pack_sec_curr_wot_vat + :addins_sec_curr_wot_vat;
      pack_sec_curr_with_vat = :pack_sec_curr_with_vat + :addins_sec_curr_with_vat;
    end
    pack_qty = :qty_post * :is_base;
    if (:is_separate_pansion = 0) then id_service = :id_pack_service;

    select S.SERVICE_NAME||:add_pack_name
    from   SERVICES S
    where  S.ID_SERVICE = :ID_PACK_SERVICE
    into   :pack_name;
  end else begin
    /* NO PACKETS */
    pack_qty = :qty_post;
    pack_price_wot_vat  = :single_wot_vat;
    pack_price_with_vat = :single_with_vat;
    pack_price_wot_diff = :SINGLE_WOT_DIFF;
    is_packet_post = 0;
    pack_sec_curr_wot_vat = coalesce(:line_sec_curr_wot_vat, 0);
    pack_sec_curr_with_vat = coalesce(:line_sec_curr_with_vat, 0);
    ID_PACK_SERVICE = :id_service;
    PACK_NAME = substring(:line_name from 1 for 50);
  end

  vat_value     = :line_with_vat - :line_wot_vat;

  if (:vat_status = 1) then begin
    single_price = :single_with_vat;
    line_value   = :line_with_vat;
    pack_price   = :pack_price_with_vat;
    sec_curr_line_value  = :line_sec_curr_with_vat * :correction_index; --:pack_sec_curr_with_vat * :correction_index;
  end else if (:vat_status = 2) then begin
    single_price = :single_wot_vat;
    line_value   = :line_wot_vat;
    pack_price   = :pack_price_wot_vat;
    sec_curr_line_value = :line_sec_curr_wot_vat * :correction_index; --:pack_sec_curr_wot_vat * :correction_index;
  end
  sec_curr_gross_value = :line_sec_curr_with_vat * :correction_index; --:pack_sec_curr_with_vat * :correction_index;
  suspend;
end
^

/* Restore proc. body: DOC_TYPE_GET$INT */
ALTER PROCEDURE DOC_TYPE_GET$INT(ID_HOTEL TYPE OF ID,
IS_PROFORMA TYPE OF TLOGICAL,
ID_ADVANCE_PAYMENT TYPE OF ID = null)
 RETURNS(ID_DOC_TYPE TYPE OF ID)
 AS
begin
  if (:IS_PROFORMA = 1 and :ID_ADVANCE_PAYMENT is not null) then
     exception DOCUMENT_EXCEPTION '-392';

  execute procedure SETTING_GET_VALUE ('DEF_DOC_TYPE', :ID_HOTEL)
  returning_values  :id_doc_type;

  if (:id_doc_type is not null) then begin
    execute procedure DOC_TYPE_EVALUATE$INT (:id_doc_type, :ID_HOTEL, :IS_PROFORMA, :ID_ADVANCE_PAYMENT);

    when any do id_doc_type = null;  -- evaluation doesn't passed
  end

  if (:id_doc_type is null) then begin
    for
      select DT.ID_DOC_TYPE
      from   DOC_TYPE_INV DT
             join DOC_TYPE TH on TH.ID_DOC_TYPE = DT.ID_DOC_TYPE
      where  TH.ID_HOTEL = :ID_HOTEL
             and TH.IS_ARCHIVE = 0
      order by dt.ID_DOC_TYPE asc
      into   :ID_DOC_TYPE
    do begin
      execute procedure DOC_TYPE_EVALUATE$INT (:id_doc_type, :ID_HOTEL, :IS_PROFORMA, :ID_ADVANCE_PAYMENT);
      break;
      when any do id_doc_type = null;  -- evaluation doesn't passed
    end
  end

  if (:id_doc_type is null) then exception DOCUMENT_EXCEPTION '-304';

end
^

/* Restore proc. body: DOCUMENT_ATTACH_AVAIL_PAYS$INT */
ALTER PROCEDURE DOCUMENT_ATTACH_AVAIL_PAYS$INT(ID_DOC_HEAD INTEGER,
ID_ACCOUNT INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_deposit integer;
  declare variable pay_curr varchar(3);
  declare variable dep_value numeric(15,4);
  declare variable rest_value numeric(15,4);
begin

  for
    select D.ID_DEPOSIT, D.PAY_CURRENCY, D.AVAIL_VALUE
    from   DEPOSIT_AVAILABLE D
    where  D.ID_ACCOUNT = :ID_ACCOUNT
    order by D.DATETIME_CREATED asc
    into   :ID_DEPOSIT, :PAY_CURR, :DEP_VALUE
  do begin

    execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, :PAY_CURR)
    returning_values  (:dbg, :dbg, :dbg, :dbg, :REST_VALUE);

    if (:REST_VALUE > 0) then begin
      DEP_VALUE = iif(:DEP_VALUE > :REST_VALUE, :REST_VALUE, :DEP_VALUE);
      execute procedure DOCUMENT_USE_DEPOSIT$DOC (:ID_DOC_HEAD, :ID_DEPOSIT, :DEP_VALUE);

   end else begin
      exit;
    end

    when exception DOCUMENT_EXCEPTION do post_event 'dummy';
  end

end
^

/* Restore proc. body: DOCUMENT_LINE_ADD$INT */
ALTER PROCEDURE DOCUMENT_LINE_ADD$INT(ID_DOC_HEAD TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_SALE_TAXATION TYPE OF ID,
LINE_NAME TYPE OF TDESCRIPTION_SHORT,
ID_GUEST TYPE OF ID,
DATE_POST TYPE OF TDATE,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
ROOM_NAME TYPE OF TROOM_NAME,
QTY_POST TYPE OF TQTY,
WOT_DIFF TYPE OF TVALUE,
DOC_CURR_GROSS_VALUE TYPE OF TPRICE,
DOC_CURR_ROUND TYPE OF TPRICE,
NAT_CURR_GROSS_VALUE TYPE OF TPRICE,
NAT_CURR_ROUND TYPE OF TPRICE,
SEC_CURR TYPE OF TCURRENCY,
SEC_CURR_GROSS_VALUE TYPE OF TPRICE,
SEC_CURR_ROUND TYPE OF TPRICE,
TAX_STATUS TYPE OF TENUM_SMALL,
IS_CORRECT TYPE OF TLOGICAL,
GROUP_TAG TYPE OF TRANGE)
 RETURNS(ID_DOC_LINE TYPE OF ID,
DOC_CURR_NET_VALUE TYPE OF TPRICE,
NAT_CURR_NET_VALUE TYPE OF TPRICE,
SEC_CURR_NET_VALUE TYPE OF TPRICE)
 AS
declare variable vat_percent numeric(15,4);
  declare variable single_value numeric(15,4);
  declare variable single_wot_vat double precision;
begin
  select cv.VALUE_WOT_TAX, cv.TAX_PERCENT
  from   TAX_VALUE_DEDUCT (:DOC_CURR_GROSS_VALUE, :DOC_CURR_ROUND, :ID_SALE_TAXATION) cv
  into   :DOC_CURR_NET_VALUE, :vat_percent;

  single_value   = :DOC_CURR_GROSS_VALUE / :QTY_POST;
  single_wot_vat = :DOC_CURR_NET_VALUE / :QTY_POST;

  select SV.VALUE_WOT_TAX
  from   TAX_VALUE_DEDUCT(:NAT_CURR_GROSS_VALUE, :NAT_CURR_ROUND, :ID_SALE_TAXATION) sv
  into   :NAT_CURR_NET_VALUE;

  if (:SEC_CURR is not null) then begin
    select SV.VALUE_WOT_TAX
    from   TAX_VALUE_DEDUCT(:SEC_CURR_GROSS_VALUE, :SEC_CURR_ROUND, :ID_SALE_TAXATION) sv
    into   :SEC_CURR_NET_VALUE;
  end else begin
    SEC_CURR_NET_VALUE = null;
  end

  insert into DOC_LINE (ID_DOC_HEAD, ID_SERVICE,
         ID_SALE_TAXATION, VAT_PERCENT, QTY_POST, WOT_DIFF, SINGLE_VALUE,
         SINGLE_WOT_VAT, WOT_VAT, TAX_STATUS, IS_CORRECT, LINE_NAME,
         GROUP_TAG, ID_GUEST, DATE_POST, FROM_DATE, TO_DATE, ROOM_NAME,
         NAT_NET_VALUE, NAT_GROSS_VALUE, SEC_CURR_NET_VALUE, SEC_CURR_GROSS_VALUE)
  values (:ID_DOC_HEAD, :ID_SERVICE,
         :ID_SALE_TAXATION, :VAT_PERCENT, :QTY_POST, :WOT_DIFF, :SINGLE_VALUE,
         :SINGLE_WOT_VAT, :DOC_CURR_NET_VALUE, :TAX_STATUS, :IS_CORRECT, :LINE_NAME,
         :GROUP_TAG, :ID_GUEST, :DATE_POST, :FROM_DATE, :TO_DATE, :ROOM_NAME,
         :nat_curr_net_value, :NAT_CURR_GROSS_VALUE, :sec_curr_net_value, :SEC_CURR_GROSS_VALUE)
  returning id_doc_line into :id_doc_line;

end
^

/* Restore proc. body: DOCUMENT_POSTING_DIFFS_SET$INT */
ALTER PROCEDURE DOCUMENT_POSTING_DIFFS_SET$INT(ID_DOC_LINE INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SALE_TAXATION INTEGER,
POST_QTY NUMERIC(15,4),
POST_PRICE NUMERIC(15,4),
POST_RATE_IN_ACC NUMERIC(15,6),
POST_RATE_IN_DOC NUMERIC(15,6),
LINE_NAT_NET_VALUE NUMERIC(15,4),
LINE_NAT_GROSS_VALUE NUMERIC(15,4),
NAT_ROUND_TO NUMERIC(15,4))
 AS
declare variable nat_net_value numeric(15,4);
  declare variable nat_gross_value numeric(15,4);
  declare variable post_nat_net_value numeric(15,4);
  declare variable post_nat_gross_value numeric(15,4);
  declare variable is_corr_line smallint;
  declare variable net_rate_diff numeric(15,4);
  declare variable gross_rate_diff numeric(15,4);
  declare variable net_round_diff numeric(15,4);
  declare variable gross_round_diff numeric(15,4);
  declare variable id_pack_service integer;
  declare variable id_master_addins integer;
  declare variable is_base integer;
begin
  -- IMPORTANT !!!
  -- Incoming LINE_NAT_..._VALUE is stored into doc line national currency value.
  -- It is actually calculted nat value, EVENTUALLY modified with (+/-) NAT_ROUND_TO (as a result of doc line rounding algorithm),
  -- therefore CAN'T BE USED of rate diff calculations
  -- and new calculations of actual nat value is needed.
  -- Rounding differences will be stored in ..._ROUND_DIFF fields at last


  select SV.VALUE_WOT_TAX, SV.VALUE_WOT_TAX + SV.TAX_VALUE
  from   TAX_VALUE_DEDUCT(:POST_QTY * :POST_PRICE * cast(:POST_RATE_IN_DOC as double precision), :NAT_ROUND_TO, :ID_SALE_TAXATION) sv
  into   :nat_net_value, :nat_gross_value;

  select AP.POST_NET_VALUE, AP.POST_GROSS_VALUE,
         iif(AP.ID_BASE_DOC is null, 0, 1) as is_corr_line,
         AP.IS_BASE,
         iif(AP.ID_PACK_SERVICE is not null and AP.ID_PACK_SERVICE > 0, AP.ID_PACK_SERVICE, null),
         iif(AP.ID_MASTER_ADDINS_ACC_POST is not null and AP.ID_MASTER_ADDINS_ACC_POST > 0, AP.ID_MASTER_ADDINS_ACC_POST, null)
  from   ACCOUNT_POST AP
  where  AP.ID_ACCOUNT_POST = :id_account_post
  into   :post_nat_net_value, :post_nat_gross_value, :is_corr_line,
         :is_base, :id_pack_service, :id_master_addins;

  if (:is_corr_line = 1) then begin
    -- Get sum of nat value changes, after previous invoicing of this posting
    -- (open corrections nat_curr value)
    select sum(apc.NEW_POST_NET_VALUE - apc.OLD_POST_NET_VALUE),
           sum(apc.NEW_POST_GROSS_VALUE - apc.OLD_POST_GROSS_VALUE)
    from   ACCOUNT_POST_CORRECTION APC
    where  APC.ID_ACCOUNT_POST = :id_account_post
           and APC.ID_DOC_HEAD = -1
           and APC.IS_OPEN = 1
    into   :post_nat_net_value, :post_nat_gross_value;
  end

  net_rate_diff = :nat_net_value - :post_nat_net_value;
  gross_rate_diff = :nat_gross_value - :post_nat_gross_value;

  net_round_diff = :line_nat_net_value - :nat_net_value;
  gross_round_diff = :line_nat_gross_value - :nat_gross_value;

  insert into DOC_LINE_POST_VALUES (
         ID_DOC_LINE, ID_ACCOUNT_POST, IS_BASE, ID_PACK_SERVICE, ID_MASTER_ADDINS,
         ACCOUNT_PRICE, POST_RATE_IN_ACC, POST_RATE_IN_DOC,
         NET_RATE_DIFF, GROSS_RATE_DIFF, NET_ROUND_DIFF, GROSS_ROUND_DIFF)
  values (:ID_DOC_LINE, :ID_ACCOUNT_POST, :is_base, :id_pack_service, :id_master_addins,
         :POST_PRICE, :POST_RATE_IN_ACC, :POST_RATE_IN_DOC,
         :net_rate_diff, :gross_rate_diff, :net_round_diff, :gross_round_diff);

end
^

/* Restore proc. body: DOCUMENT_POSTINGS_GET$INT */
ALTER PROCEDURE DOCUMENT_POSTINGS_GET$INT(IN_UNIQ_SELECT INTEGER,
ID_ACCOUNT INTEGER,
DOC_CURR VARCHAR(3),
DOC_RATE NUMERIC(15,6))
 RETURNS(AP_DBKEY CHAR(8),
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER,
DATE_POST DATE,
SERVICE_NAME VARCHAR(100),
QTY_POST NUMERIC(15,4),
PRICE_POST DOUBLE PRECISION,
TO_DATE DATE,
FROM_DATE DATE,
ID_SALE_TAXATION INTEGER,
IS_CORRECT INTEGER,
ID_GUEST INTEGER,
ROOM_NAME VARCHAR(10),
IS_BASE SMALLINT,
GROUP_TAG INTEGER,
MASTER_ADDINS INTEGER,
ID_PACK_SERVICE INTEGER,
RATE_POST NUMERIC(15,6),
POST_RATE_IN_DOC NUMERIC(15,6),
DOC_PRICE_WOT_DIFF DOUBLE PRECISION)
 AS
declare variable qty_post1 numeric(15,4);
  declare variable qty_post2 numeric(15,4);
  declare variable price_post1 double precision;
  declare variable price_post2 double precision;
  declare variable id_base_doc integer;
  declare variable err_text varchar(255);
  declare variable prev_id_guest integer;
  declare variable prev_id_service integer;
  declare variable apfrom_date date;
  declare variable apto_date date;
  declare variable rate_date date;
  declare variable acc_to_doc_rate varchar(30);
  declare variable is_fixed_rates integer;
  declare variable id_hotel integer;
  declare variable acc_doc_rate double precision;
  declare variable round_to numeric(15,4);
  declare variable acc_rate numeric(15,6);
  declare variable acc_curr varchar(3);
  declare variable description varchar(50);
begin
  group_tag = 0;

  /* CHECKS BY WHICH RATE CHOULD BE CONVERT ACCOUNT VALUES TO DOC VALUES ****/
  select A.ID_HOTEL, A.ACCOUNT_CURR
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :id_hotel, :acc_curr;

  execute procedure DOCUMENT_CURR_RATE_GET$INT (:IN_UNIQ_SELECT, :acc_curr)
  returning_values (:acc_rate, :round_to);

  is_fixed_rates = 0;
  execute procedure SETTING_GET_VALUE('ACCOUNT_TO_DOC_RATE', :id_hotel)
  returning_values  :acc_to_doc_rate;  /* USE 'CHECKIN_DATE' RATES */
  if (:acc_to_doc_rate = 'POSTING_RATE') then is_fixed_rates = 1;
  /* IS_FIXED_RATES = 0 - ONLY WHEN DOC_POST_RATE IS DIFFERENT FROM RATE_POST (OLD METHOD) */
  /* get postings for doc *****************************************************/
  prev_id_guest   = null;
  prev_id_service = null;
  for
    select A.RDB$DB_KEY, A.ID_ACCOUNT_POST, A.ID_SERVICE, A.ID_GUEST, A.ROOM_NAME, A.IS_BASE,
           A.DATE_POST, A.ID_PACK_SERVICE, A.ID_MASTER_ADDINS_ACC_POST,
           A.QTY_POST, A.IN_DOC_QTY, A.PRICE_POST, A.IN_DOC_VALUE, A.ID_SALE_TAXATION,
           A.ID_BASE_DOC, A.FROM_DATE, A.TO_DATE, A.RATE_POST, A.DESCRIPTION
    from   ACCOUNT_POST A
    where  A.DOC_SELECTED = :IN_UNIQ_SELECT
           and A.ID_ACCOUNT = :ID_ACCOUNT
    order by A.IS_BASE desc, A.ID_GUEST asc nulls last, A.DATE_POST asc, A.ID_SERVICE asc
    with lock
    into   :AP_DBKEY, :id_account_post, :id_service, :id_guest, :room_name, :is_base,
           :date_post, :id_pack_service, :master_addins,
           :qty_post1, :qty_post2, :price_post1, :price_post2, :id_sale_taxation,
           :id_base_doc, :apfrom_date, :apto_date, :rate_post, :description
  do begin
    if (:ID_SALE_TAXATION is null) then begin
       select :service_name||'/'||A.ID_ACCOUNT||' - '||A.ACCOUNT_NAME
       from   ACCOUNT A
       where  A.ID_ACCOUNT = :ID_ACCOUNT
       into   :err_text;

       exception UNDEFINED_VAT_GROUP :err_text;
    end

    select S.SERVICE_NAME || coalesce(' / ' || :description, '')
    from   SERVICES S
    where  S.ID_SERVICE = :ID_SERVICE
    into   :service_name;

    select G.TO_DATE, G.FROM_DATE
    from   GUEST G
    where  G.ID_GUEST = :ID_GUEST
    into   :to_date, :from_date;
    /* PREPARING DOC_LINE VALUES */
    if (:from_date is null) then from_date = :apfrom_date;
    if (:to_date is null) then to_date = :apto_date;

    if (:is_base = 1) then begin
      /* CALCULATING OUT_GROUP_TAG */
      if ((:prev_id_guest is distinct from :id_guest)) then begin
        prev_id_guest   = :id_guest;
        prev_id_service = :id_service;
      end
      if (:prev_id_service <> :id_service) then begin
        group_tag = :group_tag + 1;
        prev_id_service = :id_service;
      end
    end
    if (:is_fixed_rates = 1) then begin
      if (:acc_to_doc_rate = 'POSTING_RATE') then begin
        rate_date = :from_date;
        execute procedure CURR_RATE_GET (:doc_curr, :rate_date, :id_hotel)
        returning_values  (:doc_rate);
      end
      POST_RATE_IN_DOC = :rate_post;
      acc_doc_rate = cast(:POST_RATE_IN_DOC / :doc_rate as double precision);
    end else begin
      POST_RATE_IN_DOC = :acc_rate;
      acc_doc_rate = cast(:POST_RATE_IN_DOC / :doc_rate as double precision);
    end

    qty_post1 = round_f(:qty_post1, 1); qty_post2 = round_f(:qty_post2, 1);
    if (:id_base_doc is null) then begin
      /* NOT PAYED POSTING */
      is_correct = 0;
      qty_post = :qty_post1;
      price_post = :price_post1;
      doc_price_wot_diff = cast(:price_post * :acc_doc_rate as double precision);
      suspend;
    end else begin
      /* PARTIAL PAYED POSTING */
      if (:qty_post1 <> :qty_post2) then begin
        is_correct = 0;
        qty_post = :qty_post1 - :qty_post2;
        price_post = :price_post2;
        doc_price_wot_diff = cast(:price_post * :acc_doc_rate as double precision);
        suspend;
      end
      if (round_f(:price_post1 - :price_post2, :round_to) <> 0 and (:qty_post1 <> 0)) then begin
        is_correct = 1;
        qty_post = :qty_post1;
        price_post = :price_post1 - :price_post2;
        doc_price_wot_diff = cast(:price_post * :acc_doc_rate  as double precision );
        suspend;
      end
    end
  end
  /* end of postings select  **************************************************/
end
^

/* Restore proc. body: DOCUMENT_REUSE_DEPOSITS$INT */
ALTER PROCEDURE DOCUMENT_REUSE_DEPOSITS$INT(OLD_ID_DOC_HEAD INTEGER,
NEW_ID_DOC_HEAD INTEGER)
 AS
declare variable ID_DEPOSIT integer;
declare variable DEPOSIT_AMOUNT numeric(15,4);
begin

  for
    select  D.ID_DEPOSIT, sum(D.USED_PAY_VALUE)
    from    DEPOSIT_DEDUCT D
    where   D.ID_DOC_USED = :OLD_ID_DOC_HEAD
    group by D.ID_DEPOSIT
    into    :ID_DEPOSIT, :DEPOSIT_AMOUNT
  do begin
    execute procedure DOCUMENT_DETACH_DEPOSIT$INT (:OLD_ID_DOC_HEAD, :ID_DEPOSIT);

    if (:NEW_ID_DOC_HEAD is not null) then begin
      execute procedure DOCUMENT_USE_DEPOSIT$DOC (:NEW_ID_DOC_HEAD, :ID_DEPOSIT, :DEPOSIT_AMOUNT);

      when exception DOCUMENT_EXCEPTION do post_event 'dummy';
    end
  end

end
^

/* Restore proc. body: DOCUMENT_STORNO$DOC */
ALTER PROCEDURE DOCUMENT_STORNO$DOC(ID_DOC_HEAD INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_STORNO_DOC INTEGER,
ID_HOTEL INTEGER,
ID_ACCOUNT INTEGER,
WARN_CODE INTEGER)
 AS
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_STORN_WITHP');

  execute procedure DOCUMENT_STORNO$INT (:ID_DOC_HEAD, :DESCRIPTION, 1)
  returning_values  (:ID_STORNO_DOC, :ID_HOTEL, :WARN_CODE);

  select D.ID_ACCOUNT
  from   DOC_HEAD D
  where  D.ID_DOC = :id_storno_doc
  into   :id_account;

  execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :ID_DOC_HEAD, 'STORNO', f_character(29)||:DESCRIPTION);

end
^

/* Restore proc. body: DOCUMENT_TAXES_EVAL$INT */
ALTER PROCEDURE DOCUMENT_TAXES_EVAL$INT(ID_DOC_HEAD INTEGER)
 AS
declare variable id_sale_tax integer;
declare variable value_wot_tax numeric(15,4);
declare variable nat_value_wot_tax numeric(15,4);
declare variable sec_value_wot_tax numeric(15,4);
declare variable tax_value numeric(15,4);
declare variable eval_wot_tax numeric(15,4);
declare variable eval_nat_wot_tax numeric(15,4);
declare variable eval_sec_wot_tax numeric(15,4);
declare variable taxable_value numeric(15,4);
declare variable total_value numeric(15,4);
declare variable sec_curr_total_value numeric(15,4);
declare variable tax_percent numeric(15,4);
declare variable wot_tax_diff numeric(15,4);
declare variable nat_wot_tax_diff numeric(15,4);
declare variable sec_wot_tax_diff numeric(15,4);
declare variable wot_vat numeric(15,4);
declare variable nat_wot_vat numeric(15,4);
declare variable sec_wot_vat numeric(15,4);
declare variable tax_name varchar(50);
declare variable dl_dbkey char(8);
declare variable pv_dbkey char(8);
declare variable compensation_idx integer;
declare variable nat_compensation_idx integer;
declare variable sec_compensation_idx integer;
declare variable doc_curr varchar(3);
declare variable nat_curr varchar(3);
declare variable sec_curr varchar(3);
declare variable doc_round_to numeric(15,4);
declare variable nat_round_to numeric(15,4);
declare variable sec_round_to numeric(15,4);
declare variable is_dep_doc integer;
declare variable taxes_cnt integer;
declare variable vat_restriction integer;
declare variable id_calc_taxation integer;
declare variable no_use varchar(255);
declare variable same_taxation_list varchar(255);
declare variable id_hotel integer;
declare variable taxation_reason type of tdescription_long;
begin
  select D.FOR_DEPOSIT, a.ID_HOTEL
  from   DOC_HEAD$INT D
         join ACCOUNT A on a.ID_ACCOUNT = d.ID_ACCOUNT
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :is_dep_doc, :id_hotel;

  execute procedure DOCUMENT_CURRS_GET$INT (:ID_DOC_HEAD)
  returning_values (:doc_curr, :no_use, :doc_round_to, :nat_curr, :nat_round_to, :sec_curr, :no_use, :sec_round_to);

  execute procedure SETTING_GET_VALUE('RESTRICT_VATS_IN_DOC', :id_hotel)
  returning_values  :vat_restriction;

  delete from DOC_TAXES DT where dt.ID_DOC_HEAD = :ID_DOC_HEAD;
  ----------------
  taxes_cnt = 0;

  for
    select  STV.TAXATION_LIST,
            STV.ID_SALE_TAXATION,
            STV.TOTAL_VALUE,
            STV.SEC_GROSS_VALUE,
            STV.WOT_TAX,
            STV.NAT_NET_VALUE,
            STV.SEC_NET_VALUE,
            TVD.VALUE_WOT_TAX,
            NTV.VALUE_WOT_TAX,
            SCV.VALUE_WOT_TAX
    from   (select dli.tax_list,
                   cast(',' || list(distinct dl.ID_SALE_TAXATION) || ',' as varchar(255)) as taxation_list,
                   min(dl.ID_SALE_TAXATION) as ID_SALE_TAXATION,
                   sum(dl.QTY_POST * dl.SINGLE_VALUE) as total_value,
                   sum(dl.NAT_GROSS_VALUE) as nat_gross_value,
                   sum(dl.SEC_CURR_GROSS_VALUE) as sec_gross_value,
                   sum(dl.WOT_VAT) as wot_tax,
                   sum(dl.NAT_NET_VALUE) as nat_net_value,
                   sum(dl.SEC_CURR_NET_VALUE) as sec_net_value
            from  (select i.ID_DOC_LINE, cast(',' || list(st.ID_SALE_TAX) || ',' as varchar(255)) as tax_list
                   from   DOC_LINE i
                          join SALE_TAXATION_TAX stt on stt.ID_SALE_TAXATION = i.ID_SALE_TAXATION
                          join SALE_TAXES st on st.ID_SALE_TAX = stt.ID_SALE_TAX
                                                and st.REVENUE_DEDUCTION_TAX is distinct from 1
                   where  I.ID_DOC_HEAD = :ID_DOC_HEAD
                   group by i.ID_DOC_LINE) dli
                  join  DOC_LINE DL on dl.id_doc_line = dli.id_doc_line
            group by dli.tax_list) STV
            left outer join TAX_VALUE_DEDUCT (STV.TOTAL_VALUE, :doc_round_to, STV.ID_SALE_TAXATION) TVD on 1=1
            left outer join TAX_VALUE_DEDUCT (STV.NAT_GROSS_VALUE, :nat_round_to, STV.ID_SALE_TAXATION) NTV on 1=1
            left outer join TAX_VALUE_DEDUCT (STV.SEC_GROSS_VALUE, coalesce(:sec_round_to, :doc_round_to), STV.ID_SALE_TAXATION) SCV on 1=1
    into    :same_taxation_list, :id_calc_taxation, :total_value, :sec_curr_total_value, :value_wot_tax, :nat_value_wot_tax, :sec_value_wot_tax,
            :eval_wot_tax, :eval_nat_wot_tax, :eval_sec_wot_tax
  do begin
    wot_tax_diff = :eval_wot_tax     -- wanted wot_tax value
                   - :value_wot_tax; -- current vot_tax value
    -- diffs must be added to doc lines
    -- line wot_vat is smaller than target wot_vat
    compensation_idx = case when :wot_tax_diff > 0 then 1
                            when :wot_tax_diff < 0 then -1
                            else 0 end;
    if (:doc_curr = :nat_curr) then begin
      nat_wot_tax_diff = :wot_tax_diff;
      nat_compensation_idx = :compensation_idx;
    end else begin
      nat_wot_tax_diff = :eval_nat_wot_tax - :nat_value_wot_tax;
      nat_compensation_idx = case when :nat_wot_tax_diff > 0 then 1
                                  when :nat_wot_tax_diff < 0 then -1
                                  else 0 end;
    end
    if (:sec_curr = :doc_curr) then begin
      sec_wot_tax_diff = :wot_tax_diff;
      sec_compensation_idx = :compensation_idx;
    end else if (:sec_curr = :nat_curr) then begin
      sec_wot_tax_diff = :nat_wot_tax_diff;
      sec_compensation_idx = :nat_compensation_idx;
    end else begin
      sec_wot_tax_diff = :eval_sec_wot_tax - :sec_value_wot_tax;
      sec_compensation_idx = case when :sec_wot_tax_diff > 0 then 1
                                  when :sec_wot_tax_diff < 0 then -1
                                  else 0 end;
    end
    --if (round_f(:wot_tax_diff, :doc_round_to) <> 0) then begin
    if ((:compensation_idx <> 0) or (:nat_compensation_idx <> 0) or (:sec_compensation_idx <> 0)) then begin
      for
        select l.RDB$DB_KEY, l.WOT_VAT, l.NAT_NET_VALUE, l.SEC_CURR_NET_VALUE, pv.RDB$DB_KEY
        from   DOC_LINE L
               left outer join TAX_VALUE_DEDUCT (l.SINGLE_VALUE * l.QTY_POST, :doc_round_to, :id_calc_taxation, 0) TV on 1=1
               left outer join DOC_LINE_DEP_VALUES DV on DV.ID_DOC_LINE = L.ID_DOC_LINE
               left outer join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = L.ID_DOC_LINE
        where  L.ID_DOC_HEAD = :ID_DOC_HEAD                                             
               and :same_taxation_list containing ',' || l.ID_SALE_TAXATION || ','
               and ((DV.ID_DEPOSIT is null) or (:is_dep_doc = 1))
               --and coalesce(L.WOT_VAT_DIFF, 0) = 0
        order by (pv.NET_ROUND_DIFF * :compensation_idx) asc nulls last,
               (tv.tax_diff_value * :compensation_idx) desc,  -- biggest wot_tax difss first
               l.SINGLE_VALUE desc
        into   :dl_dbkey, :wot_vat, :nat_wot_vat, :sec_wot_vat, :pv_dbkey
      do begin
        if (round_f(:wot_tax_diff, :doc_round_to) <> 0) then begin
          WOT_VAT = :wot_vat + :doc_round_to * :compensation_idx;
          value_wot_tax = :value_wot_tax + :doc_round_to * :compensation_idx;
          wot_tax_diff = :wot_tax_diff - :doc_round_to * :compensation_idx;
        end else begin
          compensation_idx = 0;
        end

        if ((round_f(:nat_wot_tax_diff, :nat_round_to) <> 0) and (:nat_compensation_idx * :compensation_idx  >= 0)) then begin
          -- has diff ant it isn't oposite to wot_tax_diff
          nat_wot_vat = :nat_wot_vat + :nat_round_to * :nat_compensation_idx;
          nat_wot_tax_diff = :nat_wot_tax_diff - :nat_round_to * :nat_compensation_idx;
        end else if (round_f(:nat_wot_tax_diff, :nat_round_to) = 0) then begin
          -- hasn't more diffs
          nat_compensation_idx = 0;
        end

        if ((round_f(:sec_wot_tax_diff, :sec_round_to) <> 0) and (:sec_compensation_idx * :compensation_idx  >= 0)) then begin
          -- has diff ant it isn't oposite to wot_tax_diff
          sec_wot_vat = :sec_wot_vat + :sec_round_to * :sec_compensation_idx;
          sec_wot_tax_diff = :sec_wot_tax_diff - :sec_round_to * :sec_compensation_idx;
        end else if (round_f(:sec_wot_tax_diff, :sec_round_to) = 0) then begin
          -- hasn't more diffs
          sec_compensation_idx = 0;
        end

        if ((:compensation_idx <> 0) or (:nat_compensation_idx <> 0) or (:sec_compensation_idx <> 0)) then begin
          update DOC_LINE Dl
          set    Dl.WOT_VAT = :wot_vat,
                 dl.SINGLE_WOT_VAT = :wot_vat / dl.QTY_POST,
                 dl.NAT_NET_VALUE = :nat_wot_vat,
                 dl.SEC_CURR_NET_VALUE = :sec_wot_vat
          where  DL.RDB$DB_KEY = :dl_dbkey;
  
          update DOC_LINE_POST_VALUES PV
          set    PV.NET_ROUND_DIFF = pv.NET_ROUND_DIFF + :nat_round_to * :nat_compensation_idx
          where  :nat_compensation_idx <> 0
                 and pv.RDB$DB_KEY = :pv_dbkey;
        end else begin
          leave;
        end

      end
    end
    /* insert final, evaluated tax values */
    for
      select td.ID_SALE_TAX, td.TAX_PERCENT, st.TAX_NAME, ST.TAXATION_REASON,
             sum(td.VALUE_WOT_TAX), sum(td.TAXABLE_VALUE), sum(td.TAX_VALUE)
      from   TAX_VALUE_DEDUCT (:total_value, :doc_round_to, :id_calc_taxation, 1) td
             left outer join SALE_TAXES ST on st.ID_SALE_TAX = td.ID_SALE_TAX
      group by 1, 2, 3, 4
      into   :id_sale_tax, :tax_percent, :tax_name, :taxation_reason,
             :value_wot_tax, :taxable_value, :tax_value
    do begin
      update or insert into DOC_TAXES (ID_DOC_HEAD, ID_SALE_TAX, NONTAXABLE_VALUE,
             TAXABLE_VALUE, TAX_VALUE, TAX_NAME, TAX_PERCENT, TAXATION_REASON)
      values (:ID_DOC_HEAD, :id_sale_tax, :value_wot_tax - :taxable_value,
             :taxable_value, :tax_value, :tax_name, :tax_percent, :taxation_reason)
      matching (ID_DOC_HEAD, ID_SALE_TAX);
      taxes_cnt = :taxes_cnt + 1;
    end

    if (:sec_curr is not null) then begin
      for
        select td.ID_SALE_TAX, sum(td.VALUE_WOT_TAX), sum(td.TAXABLE_VALUE), sum(td.TAX_VALUE)
        from   TAX_VALUE_DEDUCT (:sec_curr_total_value, :sec_round_to, :id_calc_taxation, 1) td
        group by 1
        into   :id_sale_tax, :value_wot_tax, :taxable_value, :tax_value
      do begin
        update DOC_TAXES DT
        set    dt.SEC_CURR_NONTAXABLE_VALUE = coalesce(dt.SEC_CURR_NONTAXABLE_VALUE, 0) + :value_wot_tax - :taxable_value,
               dt.SEC_CURR_TAXABLE_VALUE = coalesce(dt.SEC_CURR_TAXABLE_VALUE, 0) + :taxable_value,
               dt.SEC_CURR_TAX_VALUE = coalesce(dt.SEC_CURR_TAX_VALUE, 0) + :tax_value
        where  DT.ID_DOC_HEAD = :ID_DOC_HEAD
               and dt.ID_SALE_TAX = :id_sale_tax;
      end
    end
  end

  if (:vat_restriction = 1 and :taxes_cnt > 1) then exception DOCUMENT_EXCEPTION '-367';
end
^

/* Restore proc. body: EAI_ARRIVING_ROOMS */
ALTER PROCEDURE EAI_ARRIVING_ROOMS RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(50),
ID_HOTEL INTEGER,
PHONE_LINE VARCHAR(50))
 AS
begin
  for
    select distinct
           R.ID_ROOM,
           R.ROOM_NAME,
           r.ID_HOTEL,
           plc.LINE
    from   RESERV_DETAIL RD
           join ROOMS R on R.ID_ROOM = rd.ID_ROOM
           left outer join PHONE_LINE_CONVERT PLC on PLC.ROOM_NAME = R.ROOM_NAME
                                                   and PLC.ID_HOTEL = R.ID_HOTEL
    where  RD.FROM_DATE = current_date
           and RD.CHECK_STATUS < 0
           and RD.IS_ANUL = 0
    into   :ID_ROOM, :ROOM_NAME, :id_hotel, :PHONE_LINE
  do begin
    suspend;
  end

end
^

/* Restore proc. body: EAI_EXT_POST_TO_MH_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  if (:CODE_TYPE = 'EXT_CODE') then begin
    execute procedure EAI_MAP_SERVICE(:SERVICE_CODE, :SERVICE_CODE, 'UNKNOWN', :id_hotel)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_SERVICE;
    if (:ERR_CODE < 0) then exit;
  end else begin
    select S.ID_SERVICE
    from   SERVICES S
    where  S.ID_SERVICE = :SERVICE_CODE
           and s.ID_HOTEL = :ID_HOTEL
    into   :ID_SERVICE;
    if (:ID_SERVICE is null) then begin
      ERR_CODE = -85;   /* Wrong value! */
      exit;
    end
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Restore proc. body: EAI_EXT_SERVICE_POST */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable max_id_service integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_ROOM  = null;
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  select min(S.ID_SERVICE) as id_service, max(s.id_service) as max_id_service
  from   SERVICES S
  where  S.EXT_CODE = :SERVICE_EXT_CODE
         and s.IS_BASE = 0
         and s.IS_DELETED = 0
  into   :ID_SERVICE, :max_id_service;
  if (:ID_SERVICE is null) then begin
      ERR_CODE = -388;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end else if (:ID_SERVICE <> :max_id_service) then begin
      ERR_CODE = -389;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_EXT_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Restore proc. body: EAI_LEFT_ROOMS */
ALTER PROCEDURE EAI_LEFT_ROOMS RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(50),
ID_HOTEL INTEGER,
PHONE_LINE VARCHAR(50))
 AS
begin
  for
    select distinct
           R.ID_ROOM,
           R.ROOM_NAME,
           r.ID_HOTEL,
           plc.LINE
    from   RESERV_DETAIL RD
           join ROOMS R on R.ID_ROOM = rd.ID_ROOM
           left outer join PHONE_LINE_CONVERT PLC on PLC.ROOM_NAME = R.ROOM_NAME
                                                   and PLC.ID_HOTEL = R.ID_HOTEL
    where  RD.TO_DATE = current_date
           and RD.CHECK_STATUS = 1
    into   :ID_ROOM, :ROOM_NAME, :id_hotel, :PHONE_LINE
  do begin
    suspend;
  end

end
^

/* Restore proc. body: EAI_MAP_SERVICE */
ALTER PROCEDURE EAI_MAP_SERVICE(SERVICE_TAG VARCHAR(30),
SERVICE_NAME VARCHAR(30),
EXTERNAL_IFC VARCHAR(30),
ID_HOTEL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_MAPPED_SERVICE INTEGER)
 AS
declare variable id_service_group integer;
  declare variable setting_code varchar(30);
  declare variable revenue_group varchar(30);
  declare variable is_base integer;
  declare variable is_deleted integer;
begin
  /*  Description:
  ||
  */
  err_code = 0;
  err_text = '';
  id_mapped_service = null;
  select first 1 S.ID_SERVICE, S.IS_BASE, s.IS_DELETED
  from   SERVICES S
  where  S.EXT_CODE = :service_tag
         and s.ID_HOTEL = :id_hotel
  order by s.ID_SERVICE asc
  into   :id_mapped_service, :is_base, :is_deleted;

  if (:is_base = 1) then begin
    ERR_CODE = -63;
    ERR_TEXT= '';
    exit;
  end
  if (:is_deleted = 1) then begin
    ERR_CODE = -64;
    ERR_TEXT= '';
    exit;
  end
  if (:id_mapped_service is not null) then exit;

  if (:external_ifc = 'POS') then revenue_group = 'Food and Beverage';
  else revenue_group = 'Other Operated departments';

  setting_code = 'IFC_'||:external_ifc||'_SRVGRP';
  execute procedure SETTING_GET_VALUE(:setting_code, :ID_HOTEL)
  returning_values  :id_service_group;

  execute procedure SERVICE_MODIFY(null, :id_service_group, 'EXTRA', :service_name, 0, 1, 0,
                    :revenue_group, null, null, :service_tag, 'BASE', '', 0, 'add', :ID_HOTEL,
                    0, 0, 0, 0, 0, 0, null, null)
  returning_values  :id_mapped_service;
end
^

/* Restore proc. body: EAI_POS_POSTING_ADD */
ALTER PROCEDURE EAI_POS_POSTING_ADD(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
begin
  -- used external inteface - for compatability with Front 2008
  execute procedure EAI_POS_POSTING_ADD$P2E (:IN_ON_GUEST, :IN_ID_ACCOUNT, :IN_ID_GUEST, :IN_DATE_SMETKA,
          :IN_PRICE, :IN_DATETIME, :IN_OBJ_NAME, :IN_TABLE, :IN_SITE, :IN_SMETKA_NUM, :IN_POS_USER,
          :IN_ID_SMETKA, :IN_SERVICE_TAG, :IN_SERVICE_NAME)
  returning_values (:ERR_CODE, :ERR_TEXT, :OUT_ID_ACCOUNT);

end
^

/* Restore proc. body: EAI_ROOMS_OCCUPIED_STATUS */
ALTER PROCEDURE EAI_ROOMS_OCCUPIED_STATUS RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(50),
ID_HOTEL INTEGER,
PHONE_LINE VARCHAR(50),
IS_OCCUPIED SMALLINT)
 AS
begin
  /*  Occupied rooms are checked-in rooms only !!! */
  for
    select R.ID_ROOM,
           R.ROOM_NAME,
           R.ID_HOTEL,
           (select substring(list(plc.LINE) from 1 for 50)
            from   PHONE_LINE_CONVERT PLC
            where  PLC.ROOM_NAME = R.ROOM_NAME and PLC.ID_HOTEL = R.ID_HOTEL),
            iif((select max(rd.ID_RESERV_DETAIL)
                 from   RESERV_DETAIL RD
                        join ROOM_MAGIC RM on RD.ID_RESERV_DETAIL = RM.ID_RESERV_DETAIL and RD.CHECK_STATUS = 0
                 where  RM.BUSY_DATE = current_date and RM.ID_ROOM$INT = R.ID_ROOM ) is not null,  1, 0)
    from   ROOM_PERIOD$PMS RP
           join ROOMS R on r.ID_ROOM = rp.ID_ROOM
    where  rp.FROM_DATE <= current_date
           and rp.TO_DATE >= current_date
           and rp.STATUS is distinct from 'INACTIVE'
    into   :ID_ROOM, :ROOM_NAME, :id_hotel, :PHONE_LINE, :IS_OCCUPIED
  do begin
    suspend;
  end

end
^

/* Restore proc. body: EAI_TELECOUNT_TRANSFER */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* Restore proc. body: END_WORK */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable system_date date;
  declare variable id_room integer;
  declare variable id_end_work integer;
  declare variable last_closed_date date;
  declare variable mark_dirty_expired_block varchar(10);
  declare variable mark_dirty_occ_room varchar(10);
  declare variable lock_id integer;
  declare variable shift_no integer;
  declare variable init_hotel_date date;
begin

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;
  if (:system_date >= :in_next_date) then exception END_WORK_EXCEPTION '-43';
  if (:IN_NEXT_DATE > current_date + 1) then exception END_WORK_EXCEPTION '-60';

  last_closed_date = :in_next_date - 1;

  /* LOCK THE CURRENT FINANCIAL (SYSTEM) DATE  */
  lock_id = null;
  while (:lock_id is null) do begin
    lock_id = strhash_large(:system_date || :id_hotel);
    execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'lock');
  
    when any do begin
      exception END_WORK_EXCEPTION '-337' || f_character(31) || f_character(29) || FormatDate(:system_date, 'D;dd.mm.yyyy');
    end
  end

  /* RIGHT IS REQUIRED TO CHANGE THE FINANCIAL DATE IF THERE ARE GUESTS WITH OVERDUE CHECK OUT */
  if (exists(
    select *
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
    where  G.TO_DATE <= :last_closed_date
           and G.CHECK_STATUS < 1
           and RD.ID_HOTEL = :id_hotel
           and rd.IS_ANUL = 0
  )) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('EW_OVERDUE_CHECKOUT');
  end

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', 'EW');
  -- Suppress eventual right checks into next procedures - all is permitted. Is this needed(?!?)

  update ACCOUNT_POST AP
  set    ap.ROOM_NAME = (select R.ROOM_NAME
                         from   GUEST G
                                join ROOMS R on R.ID_ROOM = G.ID_ROOM
                         where  G.ID_GUEST = ap.ID_GUEST)
  where  ap.DATE_POST between :system_date and :last_closed_date
         and ap.ID_GUEST > 0;

  select coalesce(max(ew.SHIFT_NO), 0) + 1
  from   END_WORKS ew
  where  ew.PREV_DATE = :system_date
  into   :shift_no;

  id_end_work = gen_id(G_AUTO_INC_END_WORKS, 1);
  insert into END_WORKS (ID_END_WORK, PREV_DATE, NEXT_DATE, END_WORK_KIND, SHIFT_NO, ID_HOTEL)
  values (:id_end_work, :system_date, :in_next_date, 3, :shift_no, :id_hotel);

  /* CHANGE SYSTEM DATE */
  execute procedure SYSTEM_DATE_SET(:id_hotel, :in_next_date);

  /* AUTO EXPIRATION OF ROOM NUMBERS, ROOMS AND BOOKING POSITIONS */
  execute procedure RESERVS_EXPIRE$INT(:last_closed_date, :id_hotel);

  execute procedure AGENT_CONTINGENT_EXPIRE(:system_date, :last_closed_date, null, 0, 1, :id_hotel);

  /* DELETE PERSON PROFILES WITH EXPIRATION DATE */
  execute procedure PROFILE_PERSON_EXPIRE (:in_next_date);

  execute procedure SETTING_GET_VALUE('MARK_DIRTY_EXPIRED_BLOCK', :ID_HOTEL)
  returning_values  :mark_dirty_expired_block;
  if (:mark_dirty_expired_block = '1') then begin
    for
      select distinct BR.ID_ROOM
      from   BLOCK_ROOM BR
             join ROOMS R on R.ID_ROOM = BR.ID_ROOM
      where  R.ID_HOTEL = :id_hotel
             and BR.TO_DATE >= :system_date
             and BR.TO_DATE < :in_next_date
             and BR.IS_ANNUL = 0
         into :id_room
    do begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'BLOCK_EXP', 'set_dirty');

      when any do post_event 'dummy';  -- nothing
    end
  end

  execute procedure SETTING_GET_VALUE('MARK_DIRTY_OCC_ROOM', :ID_HOTEL)
  returning_values  :mark_dirty_occ_room;
  if (:mark_dirty_occ_room = '1') then begin
    for
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
             join ROOMS R on R.ID_ROOM = rm.ID_ROOM
      where  R.ID_HOTEL = :id_hotel
             and RM.BUSY_DATE = :system_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and RM.BUSY_GROUP_TYPE = 24
      into   :id_room
    do begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'EW_DAY', 'set_dirty');

      when any do post_event 'dummy';  -- nothing
    end
  end

  /* Summary data prepare */
  if (:in_next_date > :system_date) then begin
    execute procedure SUMMARY_FINANCE_SAVE$INT (:id_end_work);

    select min(e.PREV_DATE)
    from   END_WORKS E
    where  E.ID_HOTEL = :ID_HOTEL
    into   :init_hotel_date;

    execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:id_hotel, :init_hotel_date, :last_closed_date); --TODO precise the period

    execute procedure SUMMARY_FORECAST$INT(:ID_HOTEL, :system_date);
  end

  /* Delete data from temporal tables */
  delete from RESERV_ERROR;
  delete from TMP_SMALL_OCCUP;
--  delete from GUEST g where g.id_reserv_detail is null; pri regenerirane na statistikata ne vurshi rabota
  /*  */

  execute procedure CACHES_RESOLVE;

  execute procedure SYSTEM_LOG_ADD('SYSTEM', :id_end_work, 'DAY_EW', f_character(29) || :last_closed_date);

  execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'release');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', null);

  post_event 'invalidate.end_work';
end
^

/* Restore proc. body: GUEST_ADDRESSCARD_SET$RSV */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$RSV(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
EGN VARCHAR(30),
COUNTRY VARCHAR(10),
ID_STAY_REASON INTEGER,
IS_REGISTRED INTEGER,
PASS_PLACE VARCHAR(20),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_PLACE VARCHAR(30),
SEX CHAR,
MASK VARCHAR(10),
IS_CHILD INTEGER,
CAR VARCHAR(30),
KPP INTEGER,
KPP_DATE DATE,
PASS_EXP_DATE DATE,
AGE INTEGER,
BIRTH_DAY DATE,
VISA TDESCRIPTION_SHORT,
RATING_AGE INTEGER = null,
TITLE VARCHAR(10) = null,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable gd_dbkey char(8);
  declare variable pd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable rd_dbkey char(8);
  declare variable old_is_registred integer;
  declare variable old_guest_name1 varchar(250);
  declare variable old_guest_name2 varchar(250);
  declare variable old_id_pass_type integer;
  declare variable old_pass_num varchar(20);
  declare variable old_pass_date date;
  declare variable old_egn varchar(30);
  declare variable old_country varchar(20);
  declare variable old_id_stay_reason integer;
  declare variable old_kpp integer;
  declare variable old_kpp_date date;
  declare variable old_pass_exp_date date;
  declare variable old_birth_day date;
  declare variable old_pass_place varchar(20);
  declare variable old_city varchar(100);
  declare variable old_address varchar(100);
  declare variable old_visa TDESCRIPTION_SHORT;
  declare variable old_birth_place varchar(30);
  declare variable old_sex char(1);
  declare variable action_text varchar(250);
  declare variable tt_reg_number integer;
  declare variable id_hotel integer;
  declare variable id_tt_numerator integer;
  declare variable domestic_nation varchar(10);
  declare variable no_use varchar(255);
  declare variable is_anul smallint;
  declare variable acc_routing varchar(20);
begin
  err_code = 0;
  err_text = '';

  select G.RDB$DB_KEY, GD.RDB$DB_KEY, PD.RDB$DB_KEY,
         GD.IS_REGISTRED, PD.PERSON_NAME, PD.PERSON_NAME2, PD.ID_PASSPORT_TYPE, PD.PASS_NUM, PD.PASS_DATE,
         PD.EGN, PD.COUNTRY_CODE, GD.ID_STAY_REASON, GD.KPP, GD.KPP_DATE, PD.PASS_EXP_DATE,
         PD.BIRTH_DAY, PD.PASS_PLACE, PD.CITY, PD.ADDRESS, PD.BIRTH_PLACE, PD.SEX, rd.RDB$DB_KEY,
         g.TT_REG_NUMBER, rd.ID_HOTEL, rd.IS_ANUL, rd.ACC_ROUTING, GD.VISA
  from   GUEST G
         join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
         join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
         join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
  where  G.ID_GUEST = :id_guest
  into   :g_dbkey, :gd_dbkey, :pd_dbkey,
         :old_is_registred, :old_guest_name1, :old_guest_name2, :old_id_pass_type, :old_pass_num, :old_pass_date,
         :old_egn, :old_country, :old_id_stay_reason, :old_kpp, :old_kpp_date, :old_pass_exp_date,
         :old_birth_day, :old_pass_place, :old_city, :old_address, :old_birth_place, :old_sex, :rd_dbkey,
         :tt_reg_number, :id_hotel, :is_anul, :acc_routing, :old_visa;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, :birth_place, :egn, :id_passport_type, :pass_num, :pass_date, :pass_place,
          :pass_exp_date, :city, :address, :sex, :mask);

  update  GUEST_DATA GD
  set     GD.KPP_DATE = :kpp_date,
          GD.KPP = :kpp,
          GD.VISA = :visa,
          GD.ID_STAY_REASON = :id_stay_reason,
          GD.IS_REGISTRED = :is_registred,
          GD.USER_REGISTRED = iif(:IS_REGISTRED = 1, coalesce(GD.USER_REGISTRED, current_user), null),
          GD.CAR = :car,
          GD.RATING_AGE = :RATING_AGE
  where   GD.RDB$DB_KEY = :gd_dbkey;

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name1, :guest_name2, :country,
          :is_child, :age, :birth_day, :TITLE);

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -1);

  /*  */
  if (:IS_REGISTRED = 1 and :tt_reg_number is null and :is_anul = 0 and :acc_routing is distinct from 'OWNER') then begin
    execute procedure SETTING_GET_VALUE ('NATIVE_NATION', :id_hotel)
    returning_values :domestic_nation;

    select iif(:COUNTRY not in (:domestic_nation, '') and h.USE_DIFFERENT_TT_NUMERATORS = 1,
               h.ID_TT_NUMERATOR_2,
               h.ID_TT_NUMERATOR_1)
    from   HOTEL H
    where  h.ID_HOTEL = :id_hotel
    into   :id_tt_numerator;

    if (:id_tt_numerator is not null) then begin
      execute procedure SYSTEM_GEN_NUM('GUEST_NUM', :id_tt_numerator)
      returning_values :tt_reg_number, :no_use;
  
      update GUEST G
      set    g.TT_REG_NUMBER = :tt_reg_number
      where  G.RDB$DB_KEY = :g_dbkey;
    end
  end else if (:IS_REGISTRED is distinct from 1 and :tt_reg_number is not null) then begin
    update GUEST G
    set    g.TT_REG_NUMBER = null
    where  G.RDB$DB_KEY = :g_dbkey;
  end
  /*  */
  if ((:old_is_registred = 0) and (:is_registred = 1)) then begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'REGISTRED', '');
  end

  if ((:old_is_registred = 1) and (:old_guest_name1 <> :guest_name1)) then begin
    action_text = f_character(29)||:old_guest_name1||f_character(28)||:guest_name1;
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'CHANGE_CARD', :action_text);
  end

  if ((:old_IS_REGISTRED = 1)
      and
      ((:old_guest_name1 <> :guest_name1)
        or (:old_guest_name2 <> :guest_name2)
        or (:old_egn <> :egn)
        or (:old_id_pass_type <> :id_passport_type)
        or (:old_pass_num <> :pass_num)
        or (:old_pass_date <> :pass_date)
        or (:old_pass_exp_date <> :pass_exp_date)
        or (:old_pass_place <> :pass_place)
        or (:old_country <> :country)
        or (:old_city <> :city)
        or (:old_address <> :address)
        or (:old_visa <> :visa)
        or (:old_birth_day <> :birth_day)
        or (:old_birth_place <> :birth_place)
        or (:old_sex  <> :sex)
        or (:old_kpp <> :kpp)
        or (coalesce(:old_id_stay_reason,0) <> coalesce(:id_stay_reason,0))
        or (:old_kpp_date <> :kpp_date)
      )) then
  begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'PREREGISTRED', '');
  end

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
    returning_values  :warn_code;

  end

end
^

/* Restore proc. body: GUEST_NUMERATOR_MODIFY$INT */
ALTER PROCEDURE GUEST_NUMERATOR_MODIFY$INT(ID_NUMERATOR INTEGER,
NUM_NAME VARCHAR(50),
NUM_NEXT INTEGER,
OPERATION VARCHAR(20),
ID_HOTEL TYPE OF ID_REF)
 RETURNS(NEW_ID_NUMERATOR INTEGER)
 AS
begin
/*  if (:operation = 'add') then in_use = 0;
  else in_use = 1;
*/
  execute procedure SYSTEM_NUMERATOR_MODIFY$INT(:id_numerator, 'GUEST_NUM',
          :num_name, :num_next - 1, '', 20, :ID_HOTEL, :operation)
  returning_values  :new_id_numerator;
end
^

/* Restore proc. body: GUESTS_TT_NUM_REGENERATE */
ALTER PROCEDURE GUESTS_TT_NUM_REGENERATE(ID_HOTEL ID,
FROM_DATE TDATE)
 AS
declare variable id_numerator_1 integer;
declare variable id_numerator_2 integer;
declare variable id_numerator integer;
declare variable domestic_nation varchar(10);
declare variable use_different_tt_numerators smallint;
declare variable g_dbkey char(8);
declare variable guest_tt_number integer;
declare variable no_use varchar(255);
declare variable num1_reset_value integer;
declare variable num2_reset_value integer;
begin
  select h.ID_TT_NUMERATOR_1, h.ID_TT_NUMERATOR_2, h.USE_DIFFERENT_TT_NUMERATORS
  from   HOTEL H
  where  h.ID_HOTEL = :ID_HOTEL
  into   :id_numerator_1, :id_numerator_2, :use_different_tt_numerators;

  if (:id_numerator_1 is null) then exit;

  execute procedure SETTING_GET_VALUE ('NATIVE_NATION', :ID_HOTEL)
  returning_values  :domestic_nation;

  select coalesce(max(g.TT_REG_NUMBER), 0),
         coalesce(max(iif(pd.COUNTRY_CODE not in (:domestic_nation, '') and :use_different_tt_numerators = 1, g.TT_REG_NUMBER, null)), 0)
  from   GUEST g
         join GUEST_DATA GD on gd.ID_GUEST = g.ID_GUEST
         join PERSON_DATA pd on pd.ID_PERSON_DATA = gd.ID_PERSON_DATA
         join RESERV_DETAIL rd on rd.id_reserv_detail = g.id_reserv_detail
  where  rd.ID_HOTEL = :id_hotel
         and g.IS_CHECK_IN = 1
         and gd.IS_REGISTRED = 1
         and g.FROM_DATE between (:FROM_DATE - extract(yearday from :FROM_DATE)) and (:FROM_DATE - 1)
         and rd.IS_ANUL = 0
         and RD.ACC_ROUTING is distinct from 'OWNER'
  into   :num1_reset_value, :num2_reset_value;

  update SYSTEM_NUMERATOR sn
  set    sn.NUM_VALUE = :num1_reset_value
  where  sn.ID_NUMERATOR = :id_numerator_1;

  update SYSTEM_NUMERATOR sn
  set    sn.NUM_VALUE = :num2_reset_value
  where  sn.ID_NUMERATOR = :id_numerator_2;

  for
    select g.RDB$DB_KEY,
           iif(pd.COUNTRY_CODE not in (:domestic_nation, '') and :use_different_tt_numerators = 1,
               :id_numerator_2, :id_numerator_1),
           g.TT_REG_NUMBER
    from   GUEST g
           join GUEST_DATA GD on gd.ID_GUEST = g.ID_GUEST
           join PERSON_DATA pd on pd.ID_PERSON_DATA = gd.ID_PERSON_DATA
           join RESERV_DETAIL rd on rd.id_reserv_detail = g.id_reserv_detail
    where  rd.ID_HOTEL = :id_hotel
           and g.IS_CHECK_IN = 1
           and gd.IS_REGISTRED = 1
           and g.FROM_DATE >= :FROM_DATE
           and rd.IS_ANUL = 0
           and RD.ACC_ROUTING is distinct from 'OWNER'
    order by rd.FROM_DATE asc,
           rd.TRANSFER_IN_TIME asc nulls last,
           rd.ID_RESERV_DETAIL asc,
           g.ID_GUEST asc
    into   :g_dbkey, :id_numerator, :guest_tt_number
  do begin
    execute procedure SYSTEM_GEN_NUM('GUEST_NUM', :id_numerator)
    returning_values :guest_tt_number, :no_use;

    update GUEST G
    set    g.TT_REG_NUMBER = :guest_tt_number
    where  G.RDB$DB_KEY = :g_dbkey;
  end
end
^

/* Restore proc. body: IMPORT_RATE_RECORD_RELINK$EXC */
ALTER PROCEDURE IMPORT_RATE_RECORD_RELINK$EXC(ID_RATE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ID_COLUMN integer;
declare variable ID_NEW_MASTER_RECORD integer;

declare variable PERIOD_DEPEND_ON_CHECKIN INTEGER;
declare variable CNT_DAYS_PRICE_BP INTEGER;
declare variable CNT_DAYS_PRICE_BOARD INTEGER;
declare variable BASE_BOARDS_LIST VARCHAR(255);
declare variable BOARD_TYPE VARCHAR(10);
begin
  execute procedure import_mark_transaction$exc;

  ERR_CODE = 0;
  ERR_TEXT = '';
  for
    select c.ID_TAR_DEFINE_COLUMN, im.ID_NEW
    from   TAR_UI_DEFINE_COLUMNS c
           join IDS_MAP$TMP im on c.ID_DIM2 = im.ID_OLD
    where  c.ID_TAR_HEAD = :ID_RATE
    into   :ID_COLUMN, :ID_NEW_MASTER_RECORD
  do begin
    update TAR_UI_DEFINE_COLUMNS c
    set    c.ID_DIM2 = :ID_NEW_MASTER_RECORD
    where  c.ID_TAR_DEFINE_COLUMN = :ID_COLUMN;
  end

  delete from IDS_MAP$TMP;


  select
        th.PERIOD_DEPEND_ON_CHECKIN,
        th.CNT_DAYS_PRICE_BP,
        th.CNT_DAYS_PRICE_BOARD,
        th.BASE_BOARDS_LIST,
        th.BOARD_TYPE
  from  TAR_HEAD th
  where th.ID_TAR_HEAD = :ID_RATE
  into  :PERIOD_DEPEND_ON_CHECKIN, :CNT_DAYS_PRICE_BP, :CNT_DAYS_PRICE_BOARD, :BASE_BOARDS_LIST, :BOARD_TYPE;

  for
    select ERR_CODE, ERR_TEXT
    from   TAR_SAVE(:ID_RATE, :PERIOD_DEPEND_ON_CHECKIN, :CNT_DAYS_PRICE_BP, :CNT_DAYS_PRICE_BOARD, :BASE_BOARDS_LIST, :BOARD_TYPE)
    into   :err_code, :err_text
  do begin
    if (0 <> :err_code) then begin
      exit;
    end
  end
end
^

/* Restore proc. body: NUMERATOR_MODIFY$CFG */
ALTER PROCEDURE NUMERATOR_MODIFY$CFG(ID_NUMERATOR INTEGER,
NUM_NAME VARCHAR(50),
NUM_NEXT INTEGER,
LEADING_PART VARCHAR(20),
NUM_LENGTH INTEGER,
NUM_CLASS TYPE OF TNAME_SHORT,
ID_HOTEL TYPE OF ID_REF,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_NUMERATOR INTEGER)
 AS
begin

  if (:NUM_CLASS = 'BOOKING') then ID_HOTEL = null;

  execute procedure SYSTEM_NUMERATOR_MODIFY$INT(:id_numerator, :num_class, :num_name, :num_next - 1, :leading_part,
                    :num_length, :id_hotel, :operation)
  returning_values  :new_id_numerator;
end
^

/* Restore proc. body: OCCUPANCY_OVERBOOK_CHECK$INT */
ALTER PROCEDURE OCCUPANCY_OVERBOOK_CHECK$INT(ID_AGENT INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM_TYPE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable must_check_overbook integer;
  declare variable maxbook_date  date;
  declare variable maxbook_rooms  integer;
  declare variable agent_maxbook_date date;
  declare variable agent_maxbook_rooms integer;
  declare variable id_inventory_allotment integer;
  declare variable id_agent_contingent integer;
  declare variable available_rooms integer;
  declare variable problem_date date;
  declare variable room_type varchar(20);
  declare variable id_hotel integer;
begin
  /* 1. DEALING WITH THE TOTAL OVERBOOK.
  || 2. DEALING WITH THE CONTINGENT OVERBOOK.
  */
  err_code = 0;
  err_text = '';
  warn_code = null;

  /* CHECK THE TOTAL HOTEL AVAILABILITY*/
  select H.ID_INVENTORY_ALLOTMENT, RT.TYPE_ROOM, h.ID_HOTEL
  from   ROOM_TYPES RT
         join HOTEL H on H.ID_HOTEL = RT.ID_HOTEL
  where  RT.ID_ROOM_TYPE = :id_room_type
  into   :id_inventory_allotment, :room_type, :id_hotel;

  execute procedure SETTING_GET_VALUE('CHECK_OVERBOOK', :id_hotel)
  returning_values  :must_check_overbook;

  if (:must_check_overbook = 0) then exit;
  /* ********************************** */
  execute procedure OCCUPANCY_OVERBOOK_MAX$INT(:from_date, :to_date, :id_inventory_allotment, :id_room_type)
  returning_values  :maxbook_date, :maxbook_rooms, :available_rooms;

  if (:available_rooms < 0) then begin
    problem_date = :maxbook_date;
    err_text = substring(f_character(29)||cast(abs(:available_rooms) as integer)||f_character(28)||FormatDate(:problem_date, 'D;dd.mm.yyyy')||f_character(28)||:room_type from 1 for 255);

    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_TOTAL_OVERBOOK');

    execute procedure SYSTEM_WARNING_ADD(-95, :err_text)
    returning_values :warn_code;

    when exception RIGHT_NOT_GRANTED do begin
      err_code = -94;
      exit;
    end
  end

  /* check agent contingent overbooko *****************************************/
  select PA.ID_CONTINGENT
  from   PROFILE_AGENT PA
  where  PA.ID_AGENT = :id_agent
  into   :id_agent_contingent;

  if (:id_agent_contingent is not null) then begin
    /* CHECK THE AGENT CONTINGENT AVAILABILITY*/
    execute procedure OCCUPANCY_OVERBOOK_MAX$INT(:from_date, :to_date, :id_agent_contingent, :id_room_type, :id_agent)
    returning_values  :agent_maxbook_date, :agent_maxbook_rooms, :available_rooms;
  
    if (:available_rooms < 0) then begin
      problem_date = :agent_maxbook_date;
      err_text = f_character(29)||FormatDate(:problem_date, 'D;dd.mm.yyyy')||f_character(28)||:room_type||f_character(28)||cast(abs(:available_rooms) as integer);
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CONT_OVERBOOK');

      execute procedure SYSTEM_WARNING_ADD(-97, :err_text)
      returning_values :warn_code;

      when exception RIGHT_NOT_GRANTED do begin
        err_code = -96;
        exit;
      end
    end
  end
end
^

/* Restore proc. body: OCCUPANCY_ROOM_VALIDATE$INT */
ALTER PROCEDURE OCCUPANCY_ROOM_VALIDATE$INT(ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_OCCUPANT INTEGER,
OCC_BUSY_GRP_TYPE INTEGER,
REQUEST_GUEST_CNT INTEGER,
CHECK_OPTIONS VARCHAR(255))
 RETURNS(SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
declare variable must_check_cleaning integer;
  declare variable room_capacity integer;
  declare variable real_id_room_type integer;
  declare variable room_name varchar(20);
  declare variable id_other_occupant integer;
  declare variable other_busy_grp_type integer;
  declare variable is_clean integer;
  declare variable clean_txt varchar(20);
  declare variable id_hotel integer;
begin
  /*  Description:
  ||  CONTEXT   CLEAN, BEDS, ROOM_TYPE, OCCUP
  ||  RESERV    N      Y     Y          FULL
  ||  CHECKIN   Y      Y     N          RES (  ONLY RESERVATIONS)
  ||  BLOCK     N      N     N          FULL
  ||  ROOMEDIT  N      Y     N          RES2 (ONLY RESERVATIONS,NO PERIOD)
  ||----------------------------------------------------
  || CHECK_OPTIONS = (clean, beds, occup_res)
  */
  SHARE_ERR_CODE = 0;
  SHARE_ERR_TEXT = '';
  execute procedure sys_dbg('occ ROOM_VALIDATE ID_ROOM = '||coalesce(:id_room, 'null'));
  execute procedure sys_dbg('occ ROOM_VALIDATE FROM_DATE = '||coalesce(:from_date, 'null'));
  execute procedure sys_dbg('occ ROOM_VALIDATE TO_DATE = '||coalesce(:to_date, 'null'));
  execute procedure sys_dbg('occ ROOM_VALIDATE REQUEST_GUEST_CNT = '||coalesce(:request_guest_cnt, 'null'));
  execute procedure sys_dbg('occ ROOM_VALIDATE CHECK_OPTIONS = '||coalesce(:check_options, 'null'));

  other_busy_grp_type = null;
  real_id_room_type = null;

  select R.ID_ROOM_TYPE, R.BEDS + R.EXTRA_BEDS, R.ROOM_NAME, R.IS_CLEAN, r.ID_HOTEL
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :real_id_room_type, :room_capacity, :room_name, :is_clean, :id_hotel;
  if (:real_id_room_type is null
      and ((:CHECK_OPTIONS containing 'beds') or (:CHECK_OPTIONS containing 'clean')) ) then begin
    exception OCCUPANCY_EXCEPTION '-5';
  end

  if (:check_options like '%clean%'
      and not exists (select rp.ID_ROOM_PERIOD       --skip private rooms for cleaning validation
                      from   ROOM_PERIOD$PMS RP
                      where  RP.ID_ROOM = :ID_ROOM
                             and rp.FROM_DATE <= :FROM_DATE
                             and rp.TO_DATE >= :TO_DATE
                             and rp.STATUS = 'PRIVATE')) then
  begin
    execute procedure SETTING_GET_VALUE('CLEANING_RESTRICTION', :id_hotel)
    returning_values  :must_check_cleaning;
    if ((:must_check_cleaning = 1) and (:is_clean = 0)) then begin
      clean_txt = '@{other.not}';
      exception OCCUPANCY_EXCEPTION '-46' || f_character(31) || f_character(29)||:room_name||f_character(28)||:clean_txt;
    end
  end

  if (:check_options like '%beds%') then begin
    /* CHECK BEDS */
    select max(DRM.day_guests)
    from   (select rm.BUSY_DATE, sum(rm.ADULT_COUNT + rm.CHILDREN_COUNT) as day_guests
            from   ROOM_MAGIC RM
            where  Rm.ID_ROOM = :ID_ROOM
                   and rm.BUSY_DATE between :FROM_DATE and :TO_DATE
                   and rm.DAY_ACTION not containing 'CHECK_OUT'
            group by rm.BUSY_DATE) DRM
    into   :REQUEST_GUEST_CNT;

    if (:room_capacity < :request_guest_cnt) then begin
      exception OCCUPANCY_EXCEPTION '-8' || f_character(31) || f_character(29)||:room_name||f_character(28)||:request_guest_cnt||f_character(28)||:room_capacity;
    end
  end

  /* CHECK OCCUPANCY */
  id_other_occupant = null;
  if (:check_options containing 'occup_res') then begin
    if (exists (select R.ID_ROOM
                from   ROOMS R
                       join ROOM_PERIOD$PMS P on P.ID_ROOM = R.ID_ROOM
                where  P.ID_ROOM = :id_room
                       and P.STATUS = 'INACTIVE' -- allow PRIVATE
                       and P.FROM_DATE <= :to_date
                       and P.TO_DATE >= :from_date)) then
    begin
      exception OCCUPANCY_EXCEPTION '-118';
    end

    --execute procedure sys_dbg('occ ROOM_VALIDATE id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));
    select first 1 RM.ID_RESERV_DETAIL, RM.BUSY_GROUP_TYPE
    from   ROOM_MAGIC RM
    where  RM.BUSY_DATE between :from_date and :to_date
           and RM.ID_ROOM = :id_room
           and RM.DAY_ACTION not containing 'CHECK_OUT'
           and RM.ID_RESERV_DETAIL <> :ID_OCCUPANT
    into   :id_other_occupant, :other_busy_grp_type;
  end
  --execute procedure sys_dbg('occ ROOM_VALIDATE id_arise_source = '||coalesce(:id_arise_source, 'null'));

  if (:id_other_occupant is not null) then begin
    -- other occupant has detected
    if (:other_busy_grp_type in (1, 24)) then begin
      if (:other_busy_grp_type = 1) then share_err_code = -9;
      else share_err_code = -10;

      select substring(f_character(29)||:room_name||f_character(28)||RD.NUMBER||'-'|| P.PROFILE_NAME||', '||FormatDate(RD.FROM_DATE, 'D;dd.mm.yyyy')||'-'||FormatDate(RD.TO_DATE, 'D;dd.mm.yyyy') from 1 for 255)
      from   RESERV_DETAIL RD
             join PROFILE P on P.ID_PROFILE = RD.ID_PERSON_PROFILE
      where  RD.ID_RESERV_DETAIL = :id_other_occupant
      into   :share_err_text;
    end else begin
      share_err_code = -106;
      execute procedure sys_dbg('occ ROOM_VALIDATE err_code = -106 room_name = '||coalesce(:room_name, 'null'));
      select substring(
               f_character(29)||:room_name||f_character(28)||iif(BR.BLOCK_GRP=18, 'Out of order', 'Out of inventory')||
               ' - '||BR.REASON||f_character(28)||FormatDate(BR.FROM_DATE, 'D;dd.mm.yyyy')||'-'||FormatDate(BR.TO_DATE, 'D;dd.mm.yyyy')
             from 1 for 255)
      from   BLOCK_ROOM BR
      where  BR.ID_BLOCK_ROOM = :id_other_occupant
      into   :share_err_text;
    end

    if (((:OCC_BUSY_GRP_TYPE in (1, 24)) and (:other_busy_grp_type in (1, 24, 18, 20)))
       or
       ((:OCC_BUSY_GRP_TYPE in (18, 20)) and (:other_busy_grp_type in (1, 24)))) then
    begin
      -- occupants are compatible for room sharing
      exit;
    end else begin
      exception OCCUPANCY_EXCEPTION :SHARE_ERR_CODE || f_character(31) || :SHARE_ERR_TEXT;
    end
  end
  --
end
^

/* Restore proc. body: PAYMENT_GET_DEFAULT$INT */
ALTER PROCEDURE PAYMENT_GET_DEFAULT$INT(ID_ACCOUNT INTEGER)
 RETURNS(ID_PAY_DOC_TYPE INTEGER,
PAY_CURR VARCHAR(3))
 AS
declare variable id_profile integer;
  declare variable id_reserv_detail integer;
  declare variable id_payment_type integer;
  declare variable id_acc_payment_type integer;
  declare variable id_hotel integer;
  declare variable acc_curr varchar(3);
  declare variable def_curr varchar(3);
  declare variable id_def_pay_doc_type integer;
begin
  ID_PAY_DOC_TYPE = null;
  PAY_CURR = null;
  id_payment_type = null;

  select A.ID_PROFILE, A.ID_RESERV_DETAIL, A.ACCOUNT_CURR, A.ID_HOTEL,
         (select pt.ID_PAYMENT_TYPE
          from   PAYMENT_TYPE pt
          where  pt.ID_PAYMENT_TYPE = a.ID_TYPE_PAYMENT)
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :id_profile, :id_reserv_detail, :acc_curr, :id_hotel, :id_acc_payment_type;

  if (:id_reserv_detail is not null) then begin
    select case
             when RD.ID_PERSON_PROFILE = :ID_PROFILE then RD.ID_PERSON_PAYMENT
             when RD.ID_AGENT_PROFILE = :ID_PROFILE then RD.ID_AGENT_PAYMENT
             else null
           end as RESERV_PAYMENT_TYPE
    from   RESERV_DETAIL RD
    where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :id_payment_type;
  end

  id_payment_type = coalesce(:id_payment_type, :id_acc_payment_type);

  if (:id_payment_type is not null) then begin
    select first 1 DT.ID_DOC_TYPE, DT.DEF_CURRENCY,
           iif (dt.CURRENCY_LIST containing :ACC_CURR, :ACC_CURR, null) as PAY_CURR,
           iif (dt.ID_DOC_TYPE = :id_def_pay_doc_type, dt.ID_DOC_TYPE, null)
    from   PAY_DOC_TYPE_S DT
    where  DT.ID_PAYMENT_TYPE = :id_payment_type
           and DT.DOC_DIRECTION = 0
           and DT.ID_HOTEL = :ID_HOTEL
           and DT.IS_ARCHIVE = 0
    order by 3 desc nulls last, 4 asc nulls last, 1 asc    /* pull up doc types, that supports account currency */
    into   :ID_PAY_DOC_TYPE, :def_curr, :PAY_CURR, :id_def_pay_doc_type;
  end else begin
    begin
      execute procedure SETTING_GET_VALUE ('DEF_CASH_PAY_DOC', :id_hotel)
      returning_values  :id_def_pay_doc_type;

      when any do begin end
    end

    select dt.ID_DOC_TYPE, DT.DEF_CURRENCY, iif (dt.CURRENCY_LIST containing :ACC_CURR, :ACC_CURR, null) as PAY_CURR
    from   PAY_DOC_TYPE_S DT
    where  DT.ID_DOC_TYPE = :id_def_pay_doc_type
           and DT.DOC_DIRECTION = 0
           and DT.ID_HOTEL = :ID_HOTEL
           and dt.IS_ARCHIVE = 0
    into   :ID_PAY_DOC_TYPE, :def_curr, :PAY_CURR;
  end

  if (:PAY_CURR is null) then PAY_CURR = :DEF_CURR;

end
^

/* Restore proc. body: PHONECALL_POST$TC */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Restore proc. body: PHONECALLS_POST_TO_ACCOUNT$TC */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* Restore proc. body: PMS_EXPENSE_POSTS_CREATE$INT */
ALTER PROCEDURE PMS_EXPENSE_POSTS_CREATE$INT(ID_ROOM TYPE OF ID,
ID_OWNER TYPE OF ID,
ID_RENTAL_POOL TYPE OF ID_REF,
ID_SERVICE TYPE OF ID,
ID_CURRENCY TYPE OF TCURRENCY,
POST_VALUE TYPE OF TPRICE,
IS_CLIENT_ACC_POST TYPE OF TLOGICAL,
MANUAL_POST_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
IS_POST_PER_POOL TYPE OF TLOGICAL)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF,
NEW_ID_ACCOUNT_POST$PMS ID_REF)
 AS
declare variable event_type varchar(30);
  declare variable id_room_contract integer;
  declare variable new_id_pms_event integer;
  declare variable round_to_orig numeric(15,6);
  declare variable ownership_percent numeric(15,4);
  declare variable curr_contract_owner integer;
  declare variable curr_total_ownership numeric(15,4);
  declare variable curr_total_value numeric(15,4);
  declare variable percent_value numeric(15,4);
  declare variable id_account integer;
  declare variable id_hotel integer;
  declare variable is_account$pms integer;
  declare variable id_acc_post integer;
BEGIN
  event_type = 'MANUAL_EXPENSE';
  curr_total_value = 0;
  curr_total_ownership = 0;

  select RC.ID_ROOM_CONTRACT, r.ID_HOTEL
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS P on RC.ID_ROOM_PERIOD = P.ID_ROOM_PERIOD
         join ROOMS R on R.ID_ROOM = p.ID_ROOM
  where  :MANUAL_POST_DATE between P.FROM_DATE and P.TO_DATE
         and P.ID_ROOM = :ID_ROOM
         and P.STATUS in ('PRIVATE','CONTRACT')
  into   :id_room_contract, :id_hotel;

  if (:ID_ROOM_CONTRACT is null) then exception PMS_EXCEPTION '-615';

  execute procedure PMS_EVENT_CREATE$INT(:EVENT_TYPE, :ID_ROOM, :ID_OWNER, :DESCRIPTION,
          :MANUAL_POST_DATE, null, null, null, null, :POST_VALUE, :POST_VALUE, :ID_CURRENCY, null, :id_room_contract)
  returning_values :new_id_pms_event;

  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :ID_CURRENCY
  into   :round_to_orig;

  for
    select iif(:ID_OWNER is null, O.OWNERSHIP_PERCENT, 100), O.ID_OWNER
    from   ROOM_CONTRACT$PMS RC
           join ROOM_OWNER$PMS O on O.ID_ROOM_CONTRACT = RC.ID_ROOM_CONTRACT
    where  RC.ID_ROOM_CONTRACT = :id_room_contract
           and ((:ID_OWNER is null) or (O.ID_OWNER = :ID_OWNER))
    into   :ownership_percent, :curr_contract_owner
  do begin
    curr_total_ownership = :curr_total_ownership + :ownership_percent;
    if (:curr_total_ownership = 100) then begin
      percent_value = :post_value - :curr_total_value;
    end else
      percent_value = round_f(:post_value * :ownership_percent / 100, :round_to_orig);

    curr_total_value = :curr_total_value + :percent_value;

    execute procedure OWNER_ACCOUNT_GET$INT (iif(:is_post_per_pool = 1, :id_rental_pool, :curr_contract_owner),
            :id_hotel, 0, :IS_CLIENT_ACC_POST)
    returning_values (:id_account, :is_account$pms);

    execute procedure PMS_POSTING_CREATE$INT(:new_id_pms_event, :ID_ACCOUNT, :ID_SERVICE,
            :curr_contract_owner, :MANUAL_POST_DATE, :ID_CURRENCY, :PERCENT_VALUE, :is_account$pms, 0, :ID_ROOM)
    returning_values :id_acc_post;

    new_id_account_post = null;
    new_id_account_post$pms = null;

    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 1)) then new_id_account_post$pms = :id_acc_post;
    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 0)) then new_id_account_post = :id_acc_post;
    suspend;
  end

  execute procedure PMS_EVENT_SET_ACTIVE$INT(:new_id_pms_event);
END
^

/* Restore proc. body: PMS_IMPORT */
ALTER PROCEDURE PMS_IMPORT(ID_EXPORT_HEAD INTEGER)
 AS
begin

  execute procedure PMS_IMPORT$INT(:ID_EXPORT_HEAD);

end
^

/* Restore proc. body: PMS_POOL_DISTRIBUTION_SUB */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
declare variable cnt_room smallint;
  declare variable curr_total_posted numeric(15,4);
  declare variable cnt integer;
  declare variable value_to_post numeric(15,4);
  declare variable value_to_post_per_owner numeric(15,4);
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable id_room_contract integer;
  declare variable id_owner_account integer;
  declare variable id_pms_event integer;
  declare variable id_hotel integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
begin
  select c.ROUND_TO
  from   CURRS c
  where  c.CURR = :CURR
  into   :round_to;

  cnt_room = 0;
  select count(distinct RP.ID_ROOM)
  from   ROOM_PERIOD$PMS RP
         join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
  where  RC.ID_RENTAL_POOL = :id_rental_pool
         and RP.STATUS in ('PRIVATE','CONTRACT')
         and RP.FROM_DATE <= :FOR_DATE
         and RP.TO_DATE >= :FOR_DATE
  into   :cnt_room;

  if (:cnt_room = 0) then exception PMS_EXCEPTION 'The pool has not assigned room contracts for selected date (' || :FOR_DATE || ') !';

  if (:is_room_pool = 1) then begin
    curr_total_posted = 0;
    cnt = 0;
    id_pms_event = null;
    id_hotel = null;
    for
      select distinct RP.ID_ROOM, RC.ID_ROOM_CONTRACT, R.ID_HOTEL
      from   ROOM_PERIOD$PMS RP
             join ROOMS R on R.ID_ROOM = RP.ID_ROOM
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.FROM_DATE <= :FOR_DATE
             and RP.TO_DATE >= :FOR_DATE
      into   :id_room, :id_room_contract, :id_hotel
    do begin
      id_pms_event = null;

      select E.ID_PMS_EVENT
      from   PMS_EVENT$PMS E
      where  E.ID_ROOM = :id_room
             and E.ID_SESSION = current_transaction
      into   :ID_PMS_EVENT;

      if (:ID_PMS_EVENT is null) then begin
        execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, :id_room_contract)
        returning_values :id_pms_event;
        -- FIXME nakraq da se update total_event_value
      end
      if (:cnt_room - :cnt = 1) then begin
        value_to_post = :TOTAL_VALUE_PER_SERVICE - :curr_total_posted;
      end else begin
        value_to_post = round_f(:TOTAL_VALUE_PER_SERVICE / :cnt_room, :round_to);
      end

      curr_total_posted = :curr_total_posted + :value_to_post;
      cnt = :cnt + 1;

      /* ...i se razpredelq mejdu sobstwenicite na staqta */
      value_to_post = abs(:value_to_post);
      for
        select R.ID_OWNER, R.OUT_VALUE
        from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
        into   :id_owner, :value_to_post_per_owner
      do begin
        /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_pool_account,
                :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                1, :IS_OWNER_INCOME, :id_room)
        returning_values :no_use_id_acc_post;
        /* ... i se nachislqwa po sobswtenik */
        execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
        returning_values (:id_owner_account, :is_account$pms);

        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                :is_account$pms, :is_owner_income, :id_room)
        returning_values :no_use_id_acc_post;
      end
    end
  end else begin
    /* distribution by room_param */
    insert into TMP_SELECT$PMS(ID_SESSION, ID_ROOM, ID_OWNER)
    select distinct current_transaction, RP.ID_ROOM, null
    from   ROOM_PERIOD$PMS RP
           join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
    where  RC.ID_RENTAL_POOL = :ID_RENTAL_POOL
           and RP.STATUS in ('PRIVATE','CONTRACT')
           and RP.FROM_DATE <= :FOR_DATE
           and RP.TO_DATE >= :FOR_DATE;

    id_hotel = null;
    for
      select P.OUT_VALUE, P.OUT_ID_ROOM, R.ID_HOTEL
      from   PMS_CALC_VALUE_BY_PARAM(:ID_ROOM_PARAM, :TOTAL_VALUE_PER_SERVICE, :round_to) P
             join ROOMS R on R.ID_ROOM = P.OUT_ID_ROOM
      into   :value_to_post, :id_room, :id_hotel
    do begin
      id_pms_event = null;
      id_room_contract = null;
      -- room contract must be only one for this period
      select RC.ID_ROOM_CONTRACT
      from   ROOM_PERIOD$PMS RP
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.ID_ROOM = :id_room
             and :for_date between RP.FROM_DATE and RP.TO_DATE
      into   :id_room_contract;

      if (:id_room_contract is not null) then begin
        select E.ID_PMS_EVENT
        from   PMS_EVENT$PMS E
        where  E.ID_ROOM = :id_room
               and E.ID_SESSION = current_transaction
        into   :ID_PMS_EVENT;
  
        if (:ID_PMS_EVENT is null) then begin
          execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                  'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, id_room_contract)
          returning_values :id_pms_event;
          -- FIXME nakraq da se update total_event_value
        end
  
        /* ...i se razpredelq mejdu sobstwenicite na staqta */
        for
          select R.ID_OWNER, R.OUT_VALUE
          from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
          into   :id_owner, :value_to_post_per_owner
        do begin
          /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :ID_POOL_ACCOUNT,
                  :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                  1, :IS_OWNER_INCOME, :id_room)
          returning_values :no_use_id_acc_post;
  
          /* ... i se nachislqwa po sobswtenik */
          execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
          returning_values (:id_owner_account, :is_account$pms);

          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                  :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                  :is_account$pms, :is_owner_income, :id_room)
          returning_values :no_use_id_acc_post;
        end
      end
    end

    delete from TMP_SELECT$PMS T
    where  T.ID_SESSION = current_transaction;
  end
end
^

/* Restore proc. body: PMS_ROOM_DOCS_PREPARE$RPT */
ALTER PROCEDURE PMS_ROOM_DOCS_PREPARE$RPT(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER)
 RETURNS(REC_COUNT INTEGER)
 AS
begin
  delete from PMS_ROOM_DOCS$TMP;


  insert into PMS_ROOM_DOCS$TMP (id_room, id_doc_head,  for_date, ID_RESERV_DETAIL, id_room_contract, ID_ROOM_PERIOD,
         post_net_value, post_gross_value, nat_net_value, nat_gross_value, nights)
  select ap.ID_ROOM, dh.ID_DOC, dh.RPT_DOC_DATE, g.ID_RESERV_DETAIL, rc.ID_ROOM_CONTRACT, RP.ID_ROOM_PERIOD,
         sum(SV.VALUE_WOT_TAX * dh.VALUE_CORR_IDX),
         sum(pv.ACCOUNT_PRICE * dl.QTY_POST * dh.VALUE_CORR_IDX),
         sum(dl.NAT_NET_VALUE * dh.VALUE_CORR_IDX),
         sum(dl.NAT_GROSS_VALUE * dh.VALUE_CORR_IDX),
         --count(distinct dl.DATE_POST),
         floor(sum(DH.VALUE_CORR_IDX*DL.QTY_POST*(1-dl.IS_CORRECT))/max(rd.ADULT_COUNT + rd.CHILD_COUNT))
  from   DOCUMENT_RELEASE DH
         join DOC_LINE DL on DL.ID_DOC_HEAD = DH.ID_DOC
         join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE
         join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = PV.ID_ACCOUNT_POST and ap.IS_BASE = 1
         join ROOMS R on R.ID_ROOM = AP.ID_ROOM
         join GUEST G on G.ID_GUEST = ap.ID_GUEST
         join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
         join CURRS c on c.CURR = ap.CURR_POST
         left outer join TAX_VALUE_DEDUCT (pv.ACCOUNT_PRICE * dl.QTY_POST, c.ROUND_TO, dl.ID_SALE_TAXATION) SV on 1=1
         left outer join ROOM_PERIOD$PMS rp on rp.ID_ROOM = r.id_room
                                      and rp.FROM_DATE <= dl.DATE_POST
                                      and rp.TO_DATE >= dl.DATE_POST
         left outer join ROOM_CONTRACT$PMS rc on rc.ID_ROOM_PERIOD = rp.ID_ROOM_PERIOD
  where  DH.RPT_DOC_DATE between :FROM_DATE and :TO_DATE
         and R.ID_HOTEL = :ID_HOTEL
  group by 1, 2, 3, 4, 5, 6;

  REC_COUNT = row_count;
  suspend;
end
^

/* Restore proc. body: POST_SERVICE_FINALIZE$POST */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
  declare variable id_acc_post integer;
  declare variable id_service integer;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable date_post date;
  declare variable price_post numeric(15,4);
  declare variable qty_post numeric(15,2);
  declare variable post_text varchar(100);
  declare variable curr_post varchar(3);
  declare variable id_phonecall integer;
  declare variable p_dbkey char(8);
begin

  if (:OPERATION = 'clear') then begin
    delete from TMP_SERVICE_POST T
    where  T.ID_SEQUENCE = :ID_SEQUENCE;

  end else if (:OPERATION = 'store') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);

    for
      select TS.RDB$DB_KEY, TS.ID_SERVICE, TS.ID_ACCOUNT, TS.ID_GUEST, TS.DATE_POST,
             TS.PRICE_POST, TS.QTY_POST, TS.CURR_POST, TS.POST_TEXT, TS.ID_PHONECALL
      from   TMP_SERVICE_POST TS
      where  TS.ID_SEQUENCE = :ID_SEQUENCE
      into   :p_dbkey, :id_service, :id_account, :id_guest, :date_post,
             :price_post, :qty_post, :curr_post, :post_text, :id_phonecall
    do begin
      id_acc_post = null;
      if (:id_guest is not null) then begin
        execute procedure POST_SERVICE_ON_GUEST$INT (:id_guest, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :CURR_POST,
                :date_post, :date_post, :post_text, '', :date_post, '', '')
        returning_values  (:err_code, :err_text, :no_use, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end else begin
        execute procedure POST_SERVICE_ON_ACCOUNT$INT (:id_account, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :curr_post, :date_post, :date_post, :post_text,
                '', :date_post, '')
        returning_values  (:err_code, :err_text, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end

      update TMP_SERVICE_POST
      set ID_ACCOUNT_POST = :id_acc_post
      where RDB$DB_KEY = :p_dbkey;

      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :DOC_SELECTED,
             AP.SHORT_CODE = case
                               when :id_phonecall is not null then 'TELECOUNT'
                               else null
                             end
      where  AP.ID_ACCOUNT_POST = :id_acc_post;

      if (:id_phonecall is not null) then begin
        update PHONECALLS P
        set    P.ID_ACCOUNT_POST = :id_acc_post
        where  P.ID_PHONECALL = :id_phonecall;
      end
    end
  end
end
^

/* Restore proc. body: PROFILE_GET_ACCOUNT$INT */
ALTER PROCEDURE PROFILE_GET_ACCOUNT$INT(ID_PROFILE INTEGER,
ID_RESERV_DETAIL INTEGER,
ACCOUNT_CURR VARCHAR(3),
ID_ACC_TEMPLATE INTEGER,
IS_BASE_ENABLE SMALLINT = 1,
IS_EXTRA_ENABLE SMALLINT = 1)
 RETURNS(ID_ACCOUNT INTEGER)
 AS
declare variable is_archive integer;
declare variable id_hotel integer;
begin
  id_account = null;

  select first 1 A.ID_ACCOUNT, a.IS_ARCHIVE
  from   ACCOUNT A
  where  A.ID_PROFILE = :id_profile
         and A.ACCOUNT_CURR = :account_curr
         and A.ID_RESERV_DETAIL is not distinct from :id_reserv_detail
         and A.IS_BASE >= :IS_BASE_ENABLE
         and A.IS_EXTRA >= :IS_EXTRA_ENABLE
  order by A.IS_ARCHIVE asc, A.ID_ACCOUNT asc
  into   :id_account, :is_archive;

  if (:id_account is null) then begin
    if (:id_acc_template is null) then begin
      select rd.ID_HOTEL
      from   RESERV_DETAIL RD
      where  rd.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
      into   :id_hotel;

      select P.ID_ACCOUNT_TEMPLATE
      from   PROFILE_BOOKING_DEFAULTS P
      where  P.ID_PROFILE = :id_profile
             and P.ID_HOTEL = :id_hotel
      into   :id_acc_template;
    end

    execute procedure RES_ACCOUNT_CREATE$INT(:id_profile, :id_acc_template, :account_curr,
            :id_reserv_detail, :IS_BASE_ENABLE, :IS_EXTRA_ENABLE)
    returning_values  :id_account;

  end else if (:is_archive = 1) then begin
    execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 0);
  end
end
^

/* Restore proc. body: PROFILE_PERSON_CREATEQ$PROFILE */
ALTER PROCEDURE PROFILE_PERSON_CREATEQ$PROFILE(PROFILE_NAME TYPE OF TPERSON_NAME,
PHONE TYPE OF TPHONE,
ID_PASSPORT_TYPE TYPE OF ID,
PASS_NUM TYPE OF NAME_20,
EGN TYPE OF TTEXT_SHORT,
COUNTRY_CODE TYPE OF TSHORT_CODE,
CARD_CODE TYPE OF TCARD_CODE,
ID_PERSON_DATA TYPE OF ID_REF = null,
TITLE TYPE OF TSHORT_CODE = null,
ID_HOTEL TYPE OF ID_REF = null)
 RETURNS(NEW_ID_PROFILE TYPE OF ID,
P_DBKEY TYPE OF TDB_KEY,
PD_DBKEY TYPE OF TDB_KEY)
 AS
declare variable action_text varchar(255);
  declare variable mask varchar(10);
  declare variable first_name varchar(30);
  declare variable surname varchar(30);
  declare variable family_name varchar(30);
  declare variable merge_ident_num tname_unicode;
  declare variable merge_ident_num_alt tname_unicode;
begin
  select trim(ss.UNICODE_STRING) from SYSTEM_STRING_TO_UNICODE(:EGN) ss into :merge_ident_num;
  select trim(ss.UNICODE_STRING) from SYSTEM_STRING_TO_UNICODE(:PASS_NUM) ss into :merge_ident_num_alt;

  new_id_profile = gen_id(gen_profile_id, 1);
  insert into PROFILE (ID_PROFILE, PROFILE_NAME, PROFILE_TYPE, PHONE, IS_ARCHIVE, MERGE_IDENT_NUM, MERGE_IDENT_NUM_ALT)
  values (:new_id_profile, :profile_name, 'PERSON', :phone, 0, :merge_ident_num, :merge_ident_num_alt)
  returning RDB$DB_KEY into :p_dbkey;

  if (:id_person_data is null) then begin
    id_person_data = gen_id(gen_person_data_id, 1);

    if (:ID_HOTEL is not null) then begin
      execute procedure SETTING_GET_VALUE ('DEF_GUEST_MASK', :ID_HOTEL)
      returning_values  :mask;
    end

    select PP.FIRST_NAME,  PP.SURNAME, PP.FAMILY_NAME
    from   PERSON_NAME_PARSE$INT (:PROFILE_NAME) PP
    into   :first_name,  :surname, :family_name;

    insert into PERSON_DATA(ID_PERSON_DATA, PERSON_NAME2, ID_PASSPORT_TYPE, PASS_NUM, EGN, MASK,
           FIRST_NAME, SURNAME, FAMILY_NAME, COUNTRY_CODE)
    values (:id_person_data, :profile_name, :id_passport_type, :pass_num, :egn, :mask,
           :first_name, :surname, :family_name, :country_code)
    returning RDB$DB_KEY into :pd_dbkey;

    execute procedure PERSON_DATA_SET$INT(:p_dbkey, :pd_dbkey, :profile_name, :profile_name, :country_code,
            null, null, :TITLE);
  end

  insert into PROFILE_PERSON (ID_PROFILE, ID_PERSON_DATA, CARD_CODE)
  values (:new_id_profile, :id_person_data, :card_code);

  action_text = f_character(29) || :profile_name;
  execute procedure SYSTEM_LOG_ADD ('PROFILE', :new_id_profile, 'CREATE_PERS_PROFILE', :action_text);
end
^

/* Restore proc. body: REP_ROOM_STATUS_BUILD$INT */
ALTER PROCEDURE REP_ROOM_STATUS_BUILD$INT(ID_ROOM INTEGER,
FOR_DATE DATE,
STAT_OPTIONS VARCHAR(255))
 RETURNS(IS_LEAVING SMALLINT,
IS_COMMING SMALLINT,
IS_SHARED SMALLINT,
IS_LEAVING_WORDS VARCHAR(30),
BUSY_GRP INTEGER,
DAYS_THIS_STATUS INTEGER,
DTS_CONTEXT VARCHAR(10),
COMMING_OCCUPANTS VARCHAR(1024),
ID_BLOCK_ROOM INTEGER,
OTHER_OCCUPANTS VARCHAR(1024),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER)
 AS
declare variable report_leaving varchar(50);
  declare variable as_busy_grp_type integer;

  declare variable day_action varchar(50);
  declare variable occup_grp integer;
  declare variable occupant_id integer;
  declare variable busygrp_leaving integer;
  declare variable busygrp_other integer;
  declare variable check_status integer;
  declare variable int_adult_count integer;
  declare variable int_children_count integer;
  declare variable id_hotel integer;
begin
  select r.ID_HOTEL
  from   ROOMS R
  where  R.ID_ROOM = :ID_ROOM
  into   :id_hotel;

  execute procedure SETTING_GET_VALUE('REPORT_LEAVING', :id_hotel)
  returning_values  :report_leaving;

  is_leaving = 0;
  is_comming = 0;
  is_shared = 0;
  comming_occupants = '';
  id_block_room = null;
  other_occupants = '';
  busygrp_leaving = 0;
  busygrp_other = 0;
  adult_count = 0;
  children_count = 0;

  for
    select RM.ID_RESERV_DETAIL, coalesce(RS.BUSY_GROUP_TYPE, rm.BUSY_GROUP_TYPE), RM.DAY_ACTION,
           RD.CHECK_STATUS, RM.ADULT_COUNT, RM.CHILDREN_COUNT
    from   TMP_HM_ROOM_STATUS HM
           join ROOM_MAGIC RM on RM.ID_ROOM_MAGIC = HM.ID_ROOMS_MAGIC
           left outer join ROOMS_SHARE RS on RS.ID_ROOM_SHARE = RM.ID_ROOM_MAGIC
           left outer join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = RM.ID_RESERV_DETAIL
    where  HM.ID_SESSION = current_transaction
           and HM.ID_ROOM = :id_room
    order by RD.CHECK_STATUS asc nulls first, rd.FROM_DATE asc nulls first
    into   :occupant_id, :occup_grp, :day_action,
           :check_status, :int_adult_count, :int_children_count
  do begin
    --is_comming = 0;
    --is_leaving = 0;
    if (:occup_grp in (18, 20) and :DAY_ACTION = 'BLOCK') then begin
      id_block_room = :occupant_id;
      busygrp_other = :occup_grp;
    end else if (:DAY_ACTION = 'CHECK_IN') then begin
      is_comming = 1;
      if (','||:comming_occupants||',' not containing ','||:occupant_id||',') then
        comming_occupants = :comming_occupants || iif(:comming_occupants = '', '', ',') || :occupant_id;
      busygrp_other = :occup_grp;
    end else if (:DAY_ACTION containing 'CHECK_OUT') then begin
      if (:check_status < 1) then begin
        if ((:check_status < 0) and (:stat_options containing 'HOUSEKEEPING')) then begin
          -- do nothing. House keeping is not interested in leaving reservations
        end
        is_leaving = 1;
        busygrp_leaving = :occup_grp;
        if (','||:other_occupants||',' not containing ','||:occupant_id||',') then
          other_occupants = :other_occupants || iif(:other_occupants = '', '', ',') || :occupant_id;
      end else begin
        -- nothing, room is alreay checked out
      end
    end else begin
      -- DAY_ACTION = 'STAY'
      busygrp_other = :occup_grp;
      if (','||:other_occupants||',' not containing ','||:occupant_id||',') then
        other_occupants = :other_occupants || iif(:other_occupants = '', '', ',') || :occupant_id;
    end

    adult_count = :adult_count + :int_adult_count;
    children_count = :children_count + :int_children_count;

  end

  if (:report_leaving = 'AS_FREE') then begin
    busy_grp = :busygrp_other;
  end else begin
    busy_grp = iif(:busygrp_leaving in (0, 1), :busygrp_other, :busygrp_leaving);
  end

  if (exists(
    select *
    from   ROOMS_SHARE RS
    where  RS.ID_ROOM = :id_room
           and RS.BUSY_DATE = :for_date
  )) then is_shared = 1;
  else is_shared = 0;

  if (:stat_options containing 'DAYS_THIS_STATUS') then begin
    if (:is_leaving = 1) then begin
      if (exists(  -- !!! this select must be changed
           select * from ROOM_MAGIC RM
           where  RM.BUSY_DATE = :for_date
                  and RM.ID_ROOM = :id_room
                  and RM.BUSY_TYPE <> 'VALUE_RESERVS'
                  and RM.DAY_ACTION not containing 'CHECK_OUT')
      ) then as_busy_grp_type = :busy_grp;
      else begin
        /* TODAY THE ROOM IS LEAVING AND NO BODY IS EXPECTED TO COME
        || SO WE MUST SHOW HOW MANY DAYS THE ROOM WILL BE FREE
        */
        as_busy_grp_type = 0;
      end
    end else as_busy_grp_type = :busy_grp;

    if (:as_busy_grp_type = 0) then dts_context = 'FREE';
    else dts_context = 'BUSY';
    execute procedure REP_ROOM_STATUS_DTS$INT(:as_busy_grp_type, :for_date, :id_room)
    returning_values  :days_this_status;

--    if (:days_this_status is null) then days_this_status_txt = '~';
--    else days_this_status_txt = :days_this_status;
  end
end
^

/* Restore proc. body: RES_CREATE_DETAIL$INT */
ALTER PROCEDURE RES_CREATE_DETAIL$INT(ID_RESERV_DETAIL INTEGER,
ID_AGENT_PROFILE INTEGER,
NUMBER VARCHAR(62),
CHECK_STATUS INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
EXP_DATE DATE,
COMMING_KIND INTEGER,
LEAVING_KIND INTEGER,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
NOTE VARCHAR(2000),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_BOARD INTEGER,
ID_ROOM INTEGER,
ID_RATE INTEGER,
ID_ROOM_TYPE INTEGER,
COUNTRY VARCHAR(20),
VAUCHER_DATE DATE,
VAUCHER_NUM VARCHAR(20),
VAUCHER_TEXT VARCHAR(30),
VAUCHER_DATE2 DATE,
VAUCHER_NUM2 VARCHAR(20),
CUSTOM_PRICE NUMERIC(15,2),
CUSTOM_CURRENCY VARCHAR(3),
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
ID_PERSON_PROFILE INTEGER,
ID_HOTEL INTEGER,
ACC_ROUTING VARCHAR(50),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_GROUP INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
RD_DBKEY CHAR(8))
 AS
declare variable id_default_payment integer;
  declare variable number1 varchar(20);
  declare variable number2 varchar(20);
  declare variable number3 varchar(20);
begin
  execute procedure SETTING_GET_VALUE('DEF_PAY_TYPE', :ID_HOTEL)
  returning_values  :id_default_payment;

  if (:id_room = -1) then id_room = gen_id(DETAIL_WITHOUT_ROOMING_LIST, -1);
  else select R.ID_ROOM_TYPE from ROOMS R where R.ID_ROOM = :id_room into :id_room_type;

  if (:id_reserv_detail is null) then new_id_reserv_detail = gen_id (id_reserv_detail_gen, 1);
  else new_id_reserv_detail = :id_reserv_detail;

  execute procedure RES_NUMBER_SPLIT$INT (:NUMBER)
  returning_values (:number1, :number2, :number3);

  insert into RESERV_DETAIL (ID_RESERV_DETAIL, ID_AGENT_PROFILE, NUMBER_1, NUMBER_2, NUMBER_3, CHECK_STATUS,
    FROM_DATE, TO_DATE, CODE_FIRST_FOOD, EXP_DATE, COMMING_KIND, LEAVING_KIND,
    TRANSFER_IN_TIME, TRANSFER_IN_NOTE, TRANSFER_OUT_TIME, TRANSFER_OUT_NOTE,
    ADULT_COUNT, CHILD_COUNT, NOTE, IS_ANUL, I_SPECIAL_TREATMENT, ID_BOARD,
    ID_ROOM, REASON_OF_ANUL, COUNTRY, ID_RATE, VAUCHER_DATE, VAUCHER_NUM,
    VAUCHER_TEXT, VAUCHER_DATE2, VAUCHER_NUM2, ID_ROOM_TYPE, CUSTOM_PRICE, CUSTOM_CURRENCY,
    ID_HK_PLAN, ID_PERSON_PAYMENT, ID_HOTEL, ID_PERSON_PROFILE, ACC_ROUTING,
    ID_ACC_TEMPLATE_PERSON, ROOM_FEATURES, ID_GROUP, ID_AGENT_ACCOUNT_RULE, ID_GUARANTEE_POLICY,
    CONFIRMATION_NUMBER, ID_EATING_OBJECT)
  values (:new_id_reserv_detail, :id_agent_profile, :number1, :number2, :number3, :check_status,
    :from_date, :to_date, coalesce(:code_first_food, 'dinner'), :exp_date, :comming_kind, :leaving_kind,
    :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
    :adult_count, :child_count, :note, 0, :i_special_treatment,  :ID_BOARD,
    :id_room, '', coalesce(:country, ''), :id_rate, :vaucher_date, :vaucher_num,
    :vaucher_text, :vaucher_date2, :vaucher_num2, :id_room_type, :custom_price, :custom_currency,
    :id_hk_plan, :id_default_payment, :id_hotel, :id_person_profile, :acc_routing,
    :id_acc_template_person, :room_features, :id_group, :id_agent_account, :id_guarantee_policy,
    iif (:CHECK_STATUS = -1, strhash_large(:NUMBER || 'CONFIRMATION'), null), :ID_EATING_OBJECT)
  returning RDB$DB_KEY into :rd_dbkey;

  execute procedure RES_SET_EDIT_STATUS$INT (:RD_DBKEY, 'JUST_CREATED');
end
^

/* Restore proc. body: RES_CREATE_GET$RSV */
ALTER PROCEDURE RES_CREATE_GET$RSV(ID_HOTEL INTEGER)
 RETURNS(ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIMESTAMP,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIMESTAMP,
TRANSFER_OUT_NOTE VARCHAR(30),
IS_LATE_DEPARTURE INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
COUNTRY_CODE VARCHAR(20),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
CHECK_STATUS INTEGER,
ID_HK_PLAN INTEGER,
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF)
 AS
declare variable stay_length integer;
  declare variable sys_date date;
begin
/* on the GUI
id_room_type;
id_tariff;
id_board;
code_first_food;

adult_count
child_count
check_status
*/

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :sys_date;
   
  select sv.SETTING_VALUE
  from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :ID_HOTEL) sv
  into   :ID_ACC_TEMPLATE_PERSON;
--  ID_ACC_TEMPLATE_PERSON = 0;
  select RT.ARRIVAL_DATE, RT.DEPARTURE_DATE, RT.ADULT_COUNT, RT.CHILD_COUNT, RT.STAY_LENGTH,
         RT.ID_ROOM_TYPE, RT.ID_ROOM, m.ID_BOARD, T.ID_TARIFA, RT.CUSTOM_PRICE,
         RT.CUSTOM_CURRENCY, RT.VOUCHER_NUM, RT.VOUCHER_DATE, RT.VOUCHER_TEXT, RT.VOUCHER2_NUM,
         RT.VOUCHER2_DATE, RT.TRANSFER_IN_TIME, RT.TRANSFER_IN_NOTE, RT.TRANSFER_OUT_TIME,
         RT.TRANSFER_OUT_NOTE, RT.IS_LATE_DEPARTURE, RT.CODE_FIRST_FOOD, RT.ID_NOM_MARKET_SEGMENT,
         RT.ID_NOM_SOURCE_CODE, RT.ID_NOM_CHANNEL_CODE, RT.ID_NOM_HEAR_REASON, RT.ID_NOM_COME_REASON,
         RT.ID_AGENT_PROFILE, RT.ID_PERSON_PROFILE, RT.COUNTRY_CODE, RT.ACC_ROUTING,
         RT.ID_PERSON_PAYMENT, RT.ID_AGENT_PAYMENT, RT.ID_AGENT_ACCOUNT, RT.CHECK_STATUS, RT.ID_HK_PLAN,
         RT.ID_GUARANTEE_POLICY, e.ID_EATING_OBJECT
  from   RES_TEMPLATE RT
         left outer join MEALS m on m.ID_BOARD = rt.ID_BOARD and m.IS_ARCHIVE = 0
         left outer join TARIFA t on t.ID_TARIFA = rt.ID_TARIFF and t.IS_ACTIVE = 1
         left outer join EATING_OBJECT e on e.ID_EATING_OBJECT = rt.ID_EATING_OBJECT and e.IS_ARCHIVE = 0
  where  RT.ID_HOTEL = :id_hotel
  into   :arrival_date, :departure_date, :adult_count, :child_count, :stay_length,
         :id_room_type, :id_room, :id_board, :id_tariff, :custom_price,
         :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
         :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time,
         :transfer_out_note, :is_late_departure, :code_first_food, :id_nom_market_segment,
         :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason,
         :id_agent_profile, :id_person_profile, :country_code, :acc_routing,
         :id_person_payment, :id_agent_payment, :id_agent_account, :check_status, :id_hk_plan,
         :id_guarantee_policy, :id_eating_object;


  if (:arrival_date is null) then arrival_date = :sys_date;
  if (:stay_length is null) then stay_length = 1;
  if (:departure_date is null) then departure_date = :arrival_date + :stay_length;
  if (:is_late_departure is null) then is_late_departure = 0; 
  if (:adult_count is null) then adult_count = 2;
  if (:child_count is null) then child_count = 0;

  if (:country_code is null) then begin
    execute procedure SETTING_GET_VALUE('DEF_COUNTRY', :ID_HOTEL)
    returning_values  :country_code;
  end
  if (:id_person_payment is null) then begin
    execute procedure SETTING_GET_VALUE('DEF_PAY_TYPE', :ID_HOTEL)
    returning_values  :id_person_payment;
  end
  if (:id_agent_payment is null) then begin
    execute procedure SETTING_GET_VALUE('DEF_PAY_TYPE', :ID_HOTEL)
    returning_values  :id_agent_payment;
  end

  if (:acc_routing is null) then acc_routing = 'GUEST';
  if (:check_status is null) then check_status = -3;

  guarantee_deposit = null;
  guarantee_currency = null;
  suspend;
end
^

/* Restore proc. body: RES_CREATE_ROOM$INT */
ALTER PROCEDURE RES_CREATE_ROOM$INT(CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_COUNT INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_AGENT_PROFILE INTEGER,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_PERSON_PROFILE INTEGER,
ACC_ROUTING VARCHAR(50),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ID_GROUP INTEGER = null,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_GUARANTEE_POLICY INTEGER = null,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
RD_DBKEY CHAR(8),
NEW_ID_PERSON_PROFILE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable day_keep_types integer;
  declare variable exp_date date;
  declare variable leaving_kind integer;
  declare variable cnt_processed integer;
begin
  execute procedure SETTING_GET_VALUE('DAY_KEEP_TYPES', :ID_HOTEL)
  returning_values  :day_keep_types;
  exp_date = :arrival_date + :day_keep_types;
  leaving_kind = coalesce(:is_late_departure, 0) + 1;
  comming_kind = coalesce(:comming_kind, 1);

  cnt_processed = 0;
  while (:room_count > :cnt_processed) do begin
    if (:res_number is null) then begin
      execute procedure SYSTEM_GEN_NUM('BOOKING', 0)
      returning_values  :dbg, :res_number;
    end
    
    if (:id_person_profile is null) then begin
      execute procedure PROFILE_PERSON_CREATEQ$PROFILE(:res_number, '', null, null, null,
              :country_code, null, null, null, :ID_HOTEL)
      returning_values  :new_id_person_profile, :dbg, :dbg;
      execute procedure sys_dbg('res RES_CREATE_ROOM$INT autocreate id_person_profile = '||coalesce(:id_person_profile, 'null'));
    end else begin
      new_id_person_profile = :id_person_profile;
    end

    execute procedure RES_CREATE_DETAIL$INT(:id_reserv_detail, :id_agent_profile, :res_number, :check_status,
                      :arrival_date, :departure_date, :code_first_food, :exp_date, :comming_kind, :leaving_kind,
                      :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                      0, 0, :note, :i_special_treatment, :id_board, -1, :id_rate,
                      :id_room_type, :country_code, '30.12.1899', null, null, '30.12.1899', null, null, null,
                      :room_features, :id_hk_plan, :new_id_person_profile, :id_hotel, :acc_routing, :id_acc_template_person,
                      :id_group, :id_agent_account, :id_guarantee_policy, :ID_EATING_OBJECT)
    returning_values  :new_id_reserv_detail, :rd_dbkey;
    res_number = null;

    execute procedure RES_GUESTCOUNT_ADD$INT(:rd_dbkey, :adult_count, :child_count);

    cnt_processed = :cnt_processed + 1;
    suspend;
  end
end
^

/* Restore proc. body: RES_GUEST_ADD$INT */
ALTER PROCEDURE RES_GUEST_ADD$INT(RD_DBKEY CHAR(8),
IS_CHILD INTEGER)
 RETURNS(NEW_ID_GUEST INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable pd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable check_status integer;

  declare variable from_date date;
  declare variable to_date date;
  declare variable id_room integer;
  declare variable id_agent integer;
  declare variable id_tarrif integer;
  declare variable guest_name varchar(100);
  declare variable country_code varchar(10);
  declare variable guest_status varchar(50);
  declare variable default_mask varchar(50);
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable id_titular integer;
  declare variable id_profile_data integer;
  declare variable id_person_data integer;
  declare variable id_base_account integer;
  declare variable id_extra_account integer;
  declare variable id_hotel integer;
begin
  select RD.FROM_DATE, RD.TO_DATE, RD.ID_ROOM, PA.ID_AGENT, RD.ID_RATE,
         RD.ID_RESERV_DETAIL, RD.ID_TITULAR, PP.ID_PERSON_DATA,
         RD.CHECK_STATUS, RD.ADULT_COUNT, RD.CHILD_COUNT, RD.COUNTRY,
         rd.ID_BASE_ACCOUNT, rd.ID_EXTRA_ACCOUNT, rd.ID_HOTEL
  from   RESERV_DETAIL RD
         left outer join PROFILE_PERSON PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
         left outer join PROFILE_AGENT PA on PA.ID_PROFILE = RD.ID_AGENT_PROFILE
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :from_date, :to_date, :id_room, :id_agent, :id_tarrif,
         :id_reserv_detail, :id_titular, :id_profile_data,
         :check_status, :adult_count, :child_count, :country_code,
         :id_base_account, :id_extra_account, :id_hotel;

  if (:check_status < 0) then begin
    guest_status = '';
    check_status = -2;
  end else if (:check_status = 0) then begin
    guest_status = 'CHECKING_IN';
  end else begin  /* checked out */
    exception BOOKING_EXCEPTION '-1032';
  end


  new_id_guest = gen_id (id_guest_gen, 1);
  insert into GUEST (ID_GUEST, ID_BASE_ACCOUNT, ID_ACCOUNT, FROM_DATE, TO_DATE, ID_ROOM, ID_AGENT, ID_TARIFA,
         ID_RESERV_DETAIL, IS_CHILD, CHECK_STATUS, GUEST_EDIT_STATUS)
  values (:new_id_guest,  :id_base_account, :id_extra_account, :from_date, :to_date, :id_room, :id_agent, :id_tarrif,
         :id_reserv_detail, :is_child, -2, :guest_status)
  returning RDB$DB_KEY into :g_dbkey;

  execute procedure sys_dbg('res RES_GUEST_ADD$INT new_id_guest = '||coalesce(:new_id_guest, 'null'));

  insert into GUEST_CHANGE_STATUS (ID_GUEST, FROM_DATE_ORIG, TO_DATE_ORIG)
  values (:new_id_guest, :from_date, :to_date);

  if (:is_child = 1) then begin
    child_count = :child_count + 1;
    guest_name = '-';
  end else begin
    adult_count = :adult_count + 1;
    guest_name = '-';
  end

  if (:id_titular is null) then begin
    id_titular = :new_id_guest;
    id_person_data = :id_profile_data;
  end else begin
    execute procedure SETTING_GET_VALUE('DEF_GUEST_MASK', :id_hotel)
    returning_values  :default_mask;

    id_person_data = gen_id(GEN_PERSON_DATA_ID, 1);
    insert into PERSON_DATA (ID_PERSON_DATA, MASK)
    values (:id_person_data, :default_mask)
    returning RDB$DB_KEY into :pd_dbkey;

  end

  insert into GUEST_DATA (ID_GUEST, ID_PERSON_DATA)
  values (:new_id_guest, :id_person_data);

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name, :guest_name, coalesce(:country_code, ''),
          :is_child, null, null, null);

  execute procedure RES_GUEST_AUTO$INT(:g_dbkey, :rd_dbkey, 1);

  update RESERV_DETAIL RD
  set    RD.ADULT_COUNT = :adult_count,
         RD.CHILD_COUNT = :child_count,
         RD.ID_TITULAR = :id_titular
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SET_EDIT_STATUS$INT (:RD_DBKEY, 'ADDGUEST', 'add');

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, :check_status);

end
^

/* Restore proc. body: RES_PENDING_DEPOSITS_POST$INT */
ALTER PROCEDURE RES_PENDING_DEPOSITS_POST$INT(ID_RESERV_DETAIL ID)
 AS
declare variable id_doc_type integer;
  declare variable deposit_value numeric(15,4);
  declare variable currency char(3);
  declare variable id_account integer;
  declare variable id_payment_head integer;
  declare variable id_deposit integer;
  declare variable def_text varchar(255);
  declare variable description type of TDESCRIPTION_SHORT ;
  declare variable uuid uuid;
  declare variable mapped_doc_type integer;
  declare variable booking_prefix varchar(20);
  declare variable map_prefix varchar(20);
  declare variable hotel_name varchar(50);
begin
  id_doc_type = null;
  id_account = null;

  if (exists (select pd.ID_PENDING_DEPOSIT
              from   PENDING_DEPOSIT pd
              where  pd.ID_RESERV_DETAIL = :ID_RESERV_DETAIL)) then
  begin
    def_text = '';
    map_prefix = null;
    mapped_doc_type = null;
    select sv.SETTING_VALUE, h.hotel_name, r.number_1, ddm.prefix, ddm.doc_type_id, dt.id_doc_type
    from   RESERV_DETAIL r 
           join HOTEL h on h.id_hotel = r.id_hotel
           left outer join DEPOSIT_DOCTYPE_MAP$EXC ddm on ddm.prefix = r.number_1
                                                       and ddm.ID_HOTEL = r.ID_HOTEL
           left outer join DOC_TYPE dt on dt.id_doc_type = ddm.doc_type_id
                                          and dt.id_hotel = r.id_hotel
                                          and dt.IS_ARCHIVE = 0
           left outer join SETTING_GET_VALUE ('DEFAULT_DEPOSIT_DESCRIPTION', r.ID_HOTEL) sv on 1=1
    where  r.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :def_text, :hotel_name, :booking_prefix, :map_prefix, :mapped_doc_type, :id_doc_type;
  
    if (:map_prefix is null) then begin
    /* missed map - raise exception */
      exception DOC_TYPE_EXCEPTION '-1058' || f_character(31) || f_character(29) || :booking_prefix || f_character(28) || :hotel_name;
    end
  
    if (:mapped_doc_type is null) then exit;
    /* empty map (null id_doc_type) supports - skip deposit for this database */
  
    if (:ID_DOC_TYPE is null) then begin
      /* mapped to inexisting doc_type */
      exception DOC_TYPE_EXCEPTION '-1059' || f_character(31) || f_character(29) || :hotel_name;
    end
    /* get reserv account */
    select first 1 ra.ID_ACCOUNT
    from   RES_GET_ACCOUNTS (:ID_RESERV_DETAIL, 'GUARANTEE_DEPOSIT_CREATE') ra
    into   :id_account;
  end

  for
    select pd.DESCRIPTION, pd.DEPOSIT_VALUE, pd.CURRENCY, pd.UUID
    from   PENDING_DEPOSIT pd
    where  pd.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    with lock
    into   :description, :deposit_value, :currency, :uuid
  do begin
    execute procedure DEPOSIT_NEW$DOC (:id_account, :id_doc_type, :deposit_value, :currency,
            substring(:def_text || ' (' || :description || ')' from 1 for 100), :ID_RESERV_DETAIL)
    returning_values (:id_deposit, :id_payment_head);

    update DEPOSIT D
    set    d.UUID = :uuid
    where  d.ID_DEPOSIT = :id_deposit;
  end
end
^

/* Restore proc. body: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTS$INT(RD_DBKEY CHAR(8))
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_base_account integer;
  declare variable old_id_extra_account integer;
  declare variable new_id_base_account integer;
  declare variable new_id_extra_account integer;
  declare variable acc_routing varchar(30);
  declare variable is_sep_accounts integer;
  declare variable id_base_account_profile integer;
  declare variable id_extra_account_profile integer;
  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable id_agent_account_rule integer;
  declare variable id_acc_template_person integer;
  declare variable id_guest integer;
  declare variable id_hotel integer;
begin

  select RD.ID_RESERV_DETAIL, RD.ID_PERSON_PROFILE, RD.ID_ACC_TEMPLATE_PERSON,
         RD.ACC_ROUTING, RD.ID_BASE_ACCOUNT, RD.ID_EXTRA_ACCOUNT,
         RD.ID_AGENT_PROFILE, RD.ID_AGENT_ACCOUNT_RULE, rd.id_hotel
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :RD_DBKEY
  into   :id_reserv_detail, :id_person_profile, :id_acc_template_person,
         :acc_routing, :old_id_base_account, :old_id_extra_account,
         :id_agent_profile, :id_agent_account_rule, :id_hotel;

  id_agent_account_rule = nullif(:id_agent_account_rule, -1);
  /* --- new */
  execute procedure SETTING_GET_VALUE ('SEPARATE_ACCOUNTS_PER_PAYER', :id_hotel)
  returning_values (:IS_SEP_ACCOUNTS);

  NEW_ID_BASE_ACCOUNT = null; --:old_id_base_account;
  NEW_ID_EXTRA_ACCOUNT = null; --:old_id_extra_account;

  /* identify profiles for base and extra account */
  if (:ACC_ROUTING in ('MIXED')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else if (:ACC_ROUTING in ('AGENT')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
  end else if (:ACC_ROUTING in ('FULL_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = null;
    IS_SEP_ACCOUNTS = 0;  -- never
  end else if (:ACC_ROUTING in ('PART_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else begin -- if (:acc_routing in ('GUEST', 'OWNER'))
    ID_BASE_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_AGENT_ACCOUNT_RULE = null;
  end

  execute procedure RES_ACCOUNTS_RECIEVE$INT (:ID_RESERV_DETAIL, :old_id_base_account, :old_id_extra_account,
          :id_agent_account_rule, :id_base_account_profile, :id_extra_account_profile, :id_person_profile,
          :id_acc_template_person, :is_sep_accounts)
  returning_values (:new_id_base_account, :new_id_extra_account);

--  if (:new_id_base_account is null) then exception WRONG_VALUE 'Invalid base account!';
--  if (:new_id_extra_account is null) then exception WRONG_VALUE 'Invalid extra account!';
  if ((:old_id_base_account is distinct from :new_id_base_account)
       or (:old_id_extra_account is distinct from :new_id_extra_account)) then
  begin
    update RESERV_DETAIL RD
    set    RD.ID_BASE_ACCOUNT = :new_id_base_account,
           RD.ID_EXTRA_ACCOUNT = :new_id_extra_account
    where  RD.RDB$DB_KEY = :RD_DBKEY;
    /* end --- */
    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
             --and G.CHECK_STATUS < 1
      into   :id_guest
    do begin
      execute procedure GUEST_REROUTE_POSTINGS$INT(:id_guest, :new_id_base_account, :new_id_extra_account);
    end

    -- Log account changes
    execute procedure RES_SAVE_ACCOUNTS_FINALIZE$INT(:id_reserv_detail, :old_id_base_account, :old_id_extra_account,
            :new_id_base_account, :new_id_extra_account);
  end

end
^

/* Restore proc. body: RES_SAVE_ROOM$INT */
ALTER PROCEDURE RES_SAVE_ROOM$INT(RD_DBKEY TYPE OF TDB_KEY,
ID_ROOM TYPE OF ID,
ID_RES_ROOM_TYPE TYPE OF ID,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE TYPE OF TLOGICAL = null)
 RETURNS(WARN_CODE TYPE OF TRANGE)
 AS
declare variable id_reserv_detail integer;
  declare variable id_tar_room_type integer;
  declare variable old_id_room_type integer;
  declare variable old_id_room integer;
  declare variable departure_date date;
  declare variable id_guest integer;
  declare variable g_dbkey char(8);
  declare variable system_date date;
  declare variable system_date_for_room date;
  declare variable check_status integer;
  declare variable cleaning_restriction varchar(50);
  declare variable guest_status varchar(50) default '';
  declare variable id_hotel integer;
  declare variable has_different_room_type integer;
  declare variable acc_routing varchar(30);
  declare variable res_number varchar(62);
begin
  select RD.ID_ROOM_TYPE, RD.CHECK_STATUS, RD.ID_ROOM, RD.TO_DATE, RD.ID_RESERV_DETAIL, RD.ID_HOTEL, rd.ACC_ROUTING, rd.NUMBER
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_room_type, :check_status, :old_id_room, :departure_date, :id_reserv_detail, :id_hotel, :acc_routing, :res_number;

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date_for_room;
  /**/
  system_date = null;
  /*  */
  if (:check_status >= 0 and :old_id_room > 0 and coalesce(:id_room, 0) <= 0) then
    exception BOOKING_EXCEPTION '-111';

  if ((:old_id_room > 0) and (:id_room is distinct from :old_id_room)) then begin
    guest_status = 'ROOM_CHANGED';
    if ((:old_id_room > 0) and (:id_room > 0)) then begin
      execute procedure SYSTEM_DATE_GET(:id_hotel)
      returning_values  :system_date;
      execute procedure sys_dbg('res RES_SAVE_ROOM$INT old_id_room = '||coalesce(:old_id_room, 'null'));
      execute procedure sys_dbg('res RES_SAVE_ROOM$INT check_status = '||coalesce(:check_status, 'null'));

      if ((:departure_date <= :system_date) and (:check_status >= 0)) then exception BOOKING_EXCEPTION '-51';
    end
  end

  if (:id_room is null and :old_id_room < 0) then id_room = :old_id_room; -- preserve old fictious ID, because of mapped rooms

  if (coalesce(:id_room, 0) <= 0) then begin
    delete from ROOM_MAP$EXC m
    where  m.id_room = :id_room
           and m.ID_SRC_ROOM < 0;  -- delete wrong mappings (bug 2827)

    select ro.ID_ROOM
    from   RES_OCCUPANCY_ROOM$INT (:id_reserv_detail, :system_date_for_room, :id_room, :ID_RES_ROOM_TYPE) RO
    into   :id_room;

  end else begin
    -- real room is
    id_res_room_type = :old_id_room_type;
    if (:acc_routing <> 'OWNER'
        and :id_room is distinct from :old_id_room
        and exists (select rp.ID_ROOM_PERIOD
                    from   ROOM_PERIOD$PMS rp
                    where  rp.ID_ROOM = :ID_ROOM
                           and rp.FROM_DATE <= :system_date_for_room
                           and rp.TO_DATE >= :system_date_for_room
                           and rp.STATUS = 'PRIVATE')) then
    begin
      execute procedure SYSTEM_WARNING_ADD (-61, f_character(29) || :res_number)
      returning_values  :WARN_CODE;
    end
  end
  id_res_room_type = coalesce(:id_res_room_type, :old_id_room_type);
  -- null is permissible for id_res_room_type, treat of "keep the same"

  /* tar_option : nrttAsIs, nrttRoom, nrttReserv */
  id_tar_room_type = null;
  has_different_room_type = null;
  if (:tar_option = 'nrttAsIs') then begin
    id_tar_room_type = null;
    has_different_room_type = null;
  end else if (:tar_option = 'nrttRoom') then begin
    --id_tar_room_type = iif(coalesce(:id_room, 0) <= 0 and :room_id_room_type <> :ID_RES_ROOM_TYPE, :room_id_room_type, -1);
    id_tar_room_type = iif (:ID_ROOM > 0, -1, null); -- if not room - like a AsIs
    has_different_room_type = iif(:id_tar_room_type = -1, 0, null);
    -- preserve tar_room_type from mapped(unexisted) room
  end else begin /* nrttReserv */
    id_tar_room_type = :id_res_room_type;
    has_different_room_type = 1;
  end

  update RESERV_DETAIL RD
  set    RD.ID_ROOM = :id_room,
         rd.ROOM_PRICE = case
                           when rd.CHECK_STATUS >= 0 then null
                           -- 'checked in' bookings - force recalculation always
                           when rd.CHECK_STATUS < 0
                                and ((rd.ID_ROOM_TYPE <> :id_res_room_type) or (:id_room is distinct from :old_id_room)) then null
                           -- not 'checked in', but room/room type changed - force too
                           else rd.ROOM_PRICE
                         end,   -- <null> room_price will be force booking recalculation !!!
         RD.ID_ROOM_TYPE = :id_res_room_type,  -- this field update must be after room_price update
         rd.HAS_DIFFERENT_ROOM_TYPE = coalesce(:has_different_room_type, rd.HAS_DIFFERENT_ROOM_TYPE) --iif(coalesce(:id_tar_room_type, 0) > 0, 1, rd.HAS_DIFFERENT_ROOM_TYPE)
  where  RD.RDB$DB_KEY = :rd_dbkey;

  for
    select G.RDB$DB_KEY, G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :g_dbkey, :id_guest
  do begin
    update GUEST GU
    set    GU.OLD_ID_ROOM = GU.ID_ROOM,
           GU.ID_ROOM = :id_room
    where  GU.RDB$DB_KEY = :g_dbkey;

    execute procedure GUEST_SET_EDIT_STATUS$INT (:g_dbkey, :guest_status, 'add');
   
    /*Old code if (:system_date is null) update room_type and type stay*/
    update GUEST_STAY GS
    set    GS.ID_ROOM_TYPE = iif(:id_tar_room_type is null, GS.ID_ROOM_TYPE, :id_tar_room_type),
           GS.ID_TYPE_STAY = iif(:is_auto_staytype = 1, -1, GS.ID_TYPE_STAY)
    where  GS.ID_GUEST = :id_guest
           and ((:system_date is null) or (GS.FOR_DATE >= :system_date));

    /*New part - Room number never be updated in past - important for shares and calulations*/
    /* will be updated in pass only if there was no room assigned*/
    update GUEST_STAY GS
    set    GS.ID_ROOM = :id_room
    where  GS.ID_GUEST = :id_guest
           and ((GS.FOR_DATE >= :system_date_for_room)
                 or (:check_status < 0) -- new - always change id_room from begining, for non checked in reservs
               ) ;
  end

  if ((:check_status = 0) and (:guest_status = 'ROOM_CHANGED') and (:old_id_room > 0)) then begin
    /* IF THE CLEANING RESTRICTION IS ACTIVATED AND THE OLD
    || GUEST'S ROOM IS VACANT THEN IT MUST BE MARKED DIRTY.
    */
    execute procedure SETTING_GET_VALUE('CLEANING_RESTRICTION', :id_hotel)
    returning_values  :cleaning_restriction;
    if ((:cleaning_restriction <> '0') and (not exists (
      select *
      from   GUEST G
             join GUEST_STAY GS on GS.ID_GUEST = G.ID_GUEST
      where  GS.FOR_DATE >= :system_date
             and G.CHECK_STATUS = 0
             and GS.ID_ROOM = :old_id_room
             and G.ID_RESERV_DETAIL <> :id_reserv_detail
    ))) then begin
      execute procedure ROOM_HOUSEKEEPING(:old_id_room, 'GST_MOVED', 'set_dirty');
    end
  end

  execute procedure RES_SAVE_ROOM_LOG$INT(:RD_DBKEY, :old_id_room, :old_id_room_type);

end
^

/* Restore proc. body: RES_SAVE_STAY$INT */
ALTER PROCEDURE RES_SAVE_STAY$INT(RD_DBKEY CHAR(8),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER)
 AS
declare variable day_keep_types integer;
  declare variable exp_date date;
  declare variable leaving_kind integer;
  declare variable old_arrival date;
  declare variable old_departure date;
  declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable old_comming_kind integer;
  declare variable old_leaving_kind integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable is_stay_changed integer;
begin
  -- TODO exp_date must become input parameter, because the user may change it! or add exp_scheme!

  select RD.FROM_DATE, RD.TO_DATE, RD.COMMING_KIND, RD.LEAVING_KIND, RD.ID_HOTEL,
         rd.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_arrival, :old_departure, :old_comming_kind, :old_leaving_kind, :id_hotel,
         :id_reserv_detail;

  if (:DEPARTURE_DATE <= :ARRIVAL_DATE) then exception BOOKING_EXCEPTION '-53';

  execute procedure SETTING_GET_VALUE('DAY_KEEP_TYPES', :id_hotel)
  returning_values  :day_keep_types;

  exp_date = :arrival_date + :day_keep_types;
  leaving_kind = coalesce(:is_late_departure + 1, :old_leaving_kind);
  comming_kind = coalesce(:comming_kind, :old_comming_kind);

  if ((:arrival_date <> :old_arrival) or (:departure_date <> :old_departure)) then begin
    execute procedure RESERV_TRACK_CHANGES$INT (:RD_DBKEY);
  end

  if ((:arrival_date <> :old_arrival)
      or (:departure_date <> :old_departure)
      or (:comming_kind <> :old_comming_kind)
      or (:leaving_kind <> :old_leaving_kind)) then is_stay_changed = 1;
  else is_stay_changed = 0;

  update RESERV_DETAIL RD
  set    RD.COMMING_KIND = :comming_kind,
         RD.LEAVING_KIND = :leaving_kind,
         RD.EXP_DATE = :exp_date,
         RD.FROM_DATE = :arrival_date,
         RD.TO_DATE = :departure_date,
         rd.ROOM_PRICE = iif(:is_stay_changed = 1, null, rd.ROOM_PRICE) -- force recalculation
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:is_stay_changed = 1) then begin
    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :g_dbkey
    do begin
      execute procedure RES_GUEST_SAVE_STAY$INT(:g_dbkey, :arrival_date, :departure_date, :id_hotel);
    end

    execute procedure RES_SET_EDIT_STATUS$INT (:RD_DBKEY, 'DATE_CHANGED');

    --Remove manual prices (if any) outer new period--/
    if (:old_arrival < :arrival_date) then
      delete from RESERV_CUSTOM_PRICE rcp
      where  rcp.id_reserv_detail = :id_reserv_detail
             and rcp.FOR_DATE < :arrival_date;

    if (:old_departure > :departure_date) then
      delete from RESERV_CUSTOM_PRICE rcp
      where  rcp.id_reserv_detail = :id_reserv_detail
             and RCP.FOR_DATE >= :departure_date;

    if (not exists (select * from RESERV_CUSTOM_PRICE rmp where rmp.id_reserv_detail = :id_reserv_detail)) then
        update RESERV_DETAIL set  has_different_price = 0 where id_reserv_detail = :id_reserv_detail;
    ----
  end

  if ((:old_arrival <> :arrival_date) or (:old_departure <> :departure_date) ) then begin
    action_text = f_character(29) || '{' || formatdate(:old_arrival, 'D;dd.mm.yyyy') || '-' || formatdate(:old_departure, 'D;dd.mm.yyyy') || '}'
                  || f_character(28) || '{' || formatdate(:arrival_date, 'D;dd.mm.yyyy') || '-' || formatdate(:departure_date, 'D;dd.mm.yyyy') || '}';
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_MOD_PERIOD', :action_text);
  end
end
^

/* Restore proc. body: RES_TAR_CALC_FINALIZE$INT */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(TAR_CALC_ERR INTEGER,
ID_TAR_CALC INTEGER,
RD_DBKEY_INIT CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
begin
  --  Razpiswa cenata na staia, kakto i price_detailite.

  if (:tar_calc_err = 0) then begin
    room_price = 0;
    room_price_details = '';

    execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

    for
      select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, rd.IS_POSTING_STOPPED,
             coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
             coalesce(max((select first 1 AP.IS_BASE
                           from   GUEST G
                                  join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                           where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                  and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (eventually)
      from   TAR_CALC_INPUT$TMP TI
             join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
             join TARIFA t on t.ID_TARIFA = rd.ID_RATE
      where  ti.ID_TAR_CALC = :ID_TAR_CALC
      group by 1, 2, 3, 4, 5, 6
      into   :id_reserv_detail, :check_status, :is_posting_stopped,
             :room_currency, :id_hotel, :is_anul, :has_postings
    do begin
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);

      if ( (not (:is_posting_stopped = 1 and :has_postings = 0))                                -- posting is not stopped
           and                                                                                  -- and
           ( (coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1) ) -- there are reasons to repost
         ) then
      begin

        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);

      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;

        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end

      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end else begin

    update RESERV_DETAIL RD
    set    RD.ROOM_PRICE = null,
           RD.ROOM_CURRENCY = null,
           RD.ROOM_PRICE_DETAILS = null,
           RD.LAST_ID_TAR_CALC = null
    where  RD.RDB$DB_KEY = :RD_DBKEY_INIT;
  end
  
  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;
end
^

/* Restore proc. body: RESERVS_EXPIRE$INT */
ALTER PROCEDURE RESERVS_EXPIRE$INT(CLEAR_TODATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable day_keep_number integer;
  declare variable rd_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable nouse integer;
  declare variable day_keep_types integer;
begin
  /*AA NA IONEA I?AAE I?EEE??AAIA -BF END WORK-*/
  execute procedure SETTING_GET_VALUE('DAY_KEEP_NUMBERS', :ID_HOTEL)
  returning_values  :day_keep_number;
  /*************************************************************/
  /*    REMOVE ROOM NUMBERS FROM EXPIRED RESERV DETAILS        */
  /*************************************************************/
  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.IS_ANUL = 0
           and RD.CHECK_STATUS < 0
           and RD.IS_VIP = 0
           and RD.ID_ROOM > 0
           and (RD.FROM_DATE <=  cast(:clear_todate - :day_keep_number as date))
    into   :rd_dbkey, :id_reserv_detail
  do begin
    execute procedure RES_ROOM_REMOVE$INT(:rd_dbkey)
    returning_values  :nouse;

    when any do begin
      -- nothing
    end
  end
  /*************************************************************/
  /*    EXPIRED NON VIP or VIP TYPES                           */
  /*************************************************************/
  execute procedure SETTING_GET_VALUE('DAY_KEEP_TYPES', :ID_HOTEL)
  returning_values  :day_keep_types;

  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.CHECK_STATUS < 0
           and RD.IS_ANUL = 0
           --and RD.EXP_DATE <= :clear_todate
           and RD.FROM_DATE <= cast(:clear_todate - :day_keep_types as date)
           and RD.IS_VIP = 0
    union
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.CHECK_STATUS < 0
           and RD.IS_ANUL = 0
           and RD.TO_DATE < :clear_todate
           and RD.IS_VIP = 1
    into   :rd_dbkey, :id_reserv_detail
  do begin
    execute procedure sys_dbg('res RESERVS_EXPIRE: id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

    execute procedure RES_ANUL_NOSHOW$INT(:rd_dbkey)
    returning_values  :nouse;

    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_NOSHOW', '');

    when any do begin
      -- nothing
    end
  end
end
^

/* Restore proc. body: RESMULTI_CREATE$RSV */
ALTER PROCEDURE RESMULTI_CREATE$RSV(ID_HOTEL INTEGER,
ID_ROOM_TYPE INTEGER,
TRANSFER_OUT_TIME TIME,
TRANSFER_IN_TIME TIME,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
TRANSFER_OUT_NOTE VARCHAR(50),
TRANSFER_IN_NOTE VARCHAR(50),
NOTE VARCHAR(255),
ID_BOARD INTEGER,
VOUCHER_DATE DATE,
VOUCHER_NUMBER VARCHAR(20),
VOUCHER_TEXT VARCHAR(30),
CHECK_STATUS INTEGER,
ID_TARIFF INTEGER,
COUNTRY_CODE VARCHAR(20),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
NOTE_REMINDERS VARCHAR(50),
TITULAR_NAME VARCHAR(100),
SPLIT_ON_CHECKIN INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
NUMBER VARCHAR(62),
NEW_ID_TITULAR INTEGER,
NEW_FROM_DATE TYPE OF TDATE,
WARN_CODE TYPE OF TRANGE)
 AS
declare variable rd_dbkey char(8);
  declare variable id_person_profile integer;
  declare variable pd_dbkey char(8);
  declare variable id_acc_template_person integer;
  declare variable first_name varchar(30);
  declare variable surname varchar(30);
  declare variable family_name varchar(30);
begin

  select sv.SETTING_VALUE
  from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :ID_HOTEL) sv
  into   :id_acc_template_person;

  execute procedure RES_CREATE_SET$INT(:id_agent_profile, null, :check_status, :arrival_date, :departure_date,
                    :adult_count, :children_count, :id_room_type, null, :id_board, :id_tariff, null,
                    null, null, :voucher_number, :voucher_date, :voucher_text, '',
                    null, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    1, 0, 0, :country_code, :code_first_food, '',
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    '', :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders, null, null,
                    :split_on_checkin, null, null, :id_acc_template_person, null, null, :ID_EATING_OBJECT)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :WARN_CODE;

  select RD.NUMBER, RD.ID_PERSON_PROFILE, RD.ID_TITULAR
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :number, :id_person_profile, :new_id_titular;

  if (:titular_name <> '') then begin
    select PD.RDB$DB_KEY
    from   PROFILE P
           join PROFILE_PERSON PP on PP.ID_PROFILE = P.ID_PROFILE
           join PERSON_DATA PD on PD.ID_PERSON_DATA = PP.ID_PERSON_DATA
    where  P.ID_PROFILE = :id_person_profile
    into   :pd_dbkey;

    select PP.FIRST_NAME, PP.SURNAME, PP.FAMILY_NAME
    from   PERSON_NAME_PARSE$INT (:TITULAR_NAME) PP
    into   :first_name, :surname, :family_name;

    update PERSON_DATA PD
    set    PD.PERSON_NAME2 = :titular_name,
           PD.FIRST_NAME = :first_name,
           PD.SURNAME = :surname,
           PD.FAMILY_NAME = :family_name
    where  PD.RDB$DB_KEY = :pd_dbkey;
  end

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;
end
^

/* Restore proc. body: REVENUE_EW_SUMMARIZE$INT */
ALTER PROCEDURE REVENUE_EW_SUMMARIZE$INT(ID_END_WORK INTEGER,
SUMMARY_OPTION VARCHAR(20) = 'full')
 AS
declare variable id_sale_taxation integer;
  declare variable id_profile integer;
  declare variable market_segment varchar(3);
  declare variable source_code varchar(3);
  declare variable channel_code varchar(3);
  declare variable hear_reason varchar(3);
  declare variable come_reason varchar(3) ;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable revenue_account varchar(50);
  declare variable revenue_sub_account varchar(50);
  declare variable revenue_group varchar(50);
  declare variable service_name varchar(80);
  declare variable rev_amount numeric(15,4);
  declare variable corr_amount numeric(15,4);
  declare variable total_rev_amount numeric(15,4);
  declare variable total_corr_amount numeric(15,4);
  declare variable total_vat_amount numeric(15,4);
  declare variable vat_amount numeric(15,4);
  declare variable country_code varchar(10);
  declare variable no_use varchar(255);
  declare variable id_summary_rev_group integer;
  declare variable is_primary_post integer;
  declare variable posts_cnt integer;
  declare variable id_hotel integer;
  declare variable id_room_type integer;
  declare variable ew_date date;
  declare variable round_to numeric(15,6);
  declare variable id_sale_tax integer;
  declare variable tax_value numeric(15,4);
  declare variable revenue_deduction_tax_value tprice;
begin
  /****************************************************************************/
  /*  Description:                                                            */
  /*  DATE_POST      occurence date                                           */
  /*  ARISE_DATE     noticed date                                             */
  /*  POST_TYPE      BASE, ADD_INS, EXTRA                                     */
  /****************************************************************************/
  /*  */
  TOTAL_REV_AMOUNT = 0;
  TOTAL_CORR_AMOUNT = 0;
  TOTAL_VAT_AMOUNT = 0;
  select EW.PREV_DATE, EW.ID_HOTEL, CU.ROUND_TO
  from   END_WORKS EW
         join HOTEL H on H.ID_HOTEL = EW.ID_HOTEL
         join CURRS CU on CU.CURR = H.NATION_CURR
  where  EW.ID_END_WORK = :ID_END_WORK
  into   :EW_DATE, :ID_HOTEL, :ROUND_TO;

  if (:SUMMARY_OPTION = 'full') then begin
    delete from SUMMARY_REV_GROUPS$REV SR
    where  SR.ID_END_WORK = :ID_END_WORK;

  end else if (:SUMMARY_OPTION = 'statistic') then begin
    /* delete from statistic tables */
    for
      select SR.ID_SUMMARY_REV_GROUP
      from   SUMMARY_REV_GROUPS$REV SR
      where  SR.ID_END_WORK = :ID_END_WORK
      into   :ID_SUMMARY_REV_GROUP
    do begin
      delete from SUMMARY_MARKET_SEGMENTS$REV SM
      where  SM.ID_SUMMARY_REV_GROUP = :ID_SUMMARY_REV_GROUP;

      delete from SUMMARY_PROFILES$REV SP
      where  SP.ID_SUMMARY_REVENUE_GROUP = :ID_SUMMARY_REV_GROUP;

      delete from SUMMARY_NATIONALITY$REV SN
      where  SN.ID_SUMMARY_REVENUE_GROUP = :ID_SUMMARY_REV_GROUP;
    end
  end

  for
    select  AP.ID_SALE_TAXATION, coalesce(PA.ID_PROFILE, PH.ID_PROFILE), coalesce(PD.COUNTRY_CODE, ''),
            MS.MARKET_CODE, SC.SOURCE_CODE, CC.CHANNEL_CODE, HR.HEAR_REASON_CODE, CR.COME_REASON_CODE,
            AP.REVENUE_GROUP, AP.REVENUE_ACCOUNT, AP.REVENUE_SUB_ACCOUNT, S.SERVICE_NAME || coalesce(' / ' || APO.DESCRIPTION, '') as SERVICE_NAME,
            AP.IS_PRIMARY_POST, coalesce(rm.ID_ROOM_TYPE, r.ID_ROOM_TYPE),
            coalesce(sum(AP.NAT_NET_VALUE), 0), coalesce(sum(AP.NAT_GROSS_VALUE), 0), coalesce(sum(ap.REVENUE_DEDUCTION_TAX_VALUE), 0)
    from    ACCOUNT_DEBT AP
            join SERVICES S on S.ID_SERVICE = AP.ID_SERVICE
            left outer join ACCOUNT_POST APO on APO.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
            left outer join ACCOUNT ACC on ACC.ID_ACCOUNT = AP.ID_ACCOUNT
            left outer join GUEST G on G.ID_GUEST = AP.ID_GUEST
            left outer join GUEST_DATA GD on G.ID_GUEST = GD.ID_GUEST
            left outer join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = coalesce(G.ID_RESERV_DETAIL, ACC.ID_RESERV_DETAIL)
            left outer join NOM_CHANNEL_CODES CC on CC.ID_NOM_CHANNEL_CODE = GD.ID_NOM_CHANNEL_CODE--RD.ID_NOM_CHANNEL_CODE
            left outer join NOM_COME_REASONS CR on CR.ID_NOM_COME_REASON = GD.ID_NOM_COME_REASON--RD.ID_NOM_COME_REASON
            left outer join NOM_HEAR_REASONS HR on HR.ID_NOM_HEAR_REASON = GD.ID_NOM_HEAR_REASON--RD.ID_NOM_HEAR_REASON
            left outer join NOM_SOURCE_CODES SC on SC.ID_NOM_SOURCE_CODE = GD.ID_NOM_SOURCE_CODE--RD.ID_NOM_SOURCE_CODE
            left outer join NOM_MARKET_SEGMENTS MS on MS.ID_NOM_MARKET_SEGMENT = GD.ID_NOM_MARKET_SEGMENT--RD.ID_NOM_MARKET_SEGMENT
            left outer join PROFILE_AGENT PA on PA.ID_PROFILE = iif(rd.ID_RESERV_DETAIL is not null, RD.ID_AGENT_PROFILE, ACC.ID_PROFILE) --coalesce(RD.ID_AGENT_PROFILE, A.ID_PROFILE)
            left outer join PROFILE_PERSON PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
            left outer join PERSON_DATA PD on PD.ID_PERSON_DATA = PP.ID_PERSON_DATA
            left outer join PROFILE_HOUSE PH on PH.ID_PROFILE = ACC.ID_PROFILE
            left outer join ROOMS R on rd.ID_ROOM = r.ID_ROOM
            left outer join ROOM_MAGIC RM on RM.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                             and rm.BUSY_DATE = ap.POST_DATE
    where   AP.ID_HOTEL = :id_hotel
            and AP.DEBT_DATE = :ew_date
    group by 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14 --, 15
    into   :id_sale_taxation, :id_profile, :country_code,
           :market_segment, :source_code, :channel_code, :hear_reason, :come_reason,
           :revenue_group, :revenue_account, :revenue_sub_account, :service_name,
           :is_primary_post, :id_room_type, :post_net_value, :post_gross_value, :revenue_deduction_tax_value
  do begin
    POSTS_CNT = 0; /* TODO - must be initialized!!!! */
    if (:SUMMARY_OPTION = 'full') then begin
      VAT_AMOUNT = :POST_GROSS_VALUE - :POST_NET_VALUE;
      execute procedure REVENUE_SUMMARY_MODIFY$INT (:id_end_work, :ew_date, :id_sale_taxation,
              :id_profile, :market_segment, :source_code, :channel_code, :hear_reason, :come_reason,
              :is_primary_post, :post_net_value, :vat_amount, :revenue_group, :revenue_account,
              :revenue_sub_account, :service_name, :country_code, :id_room_type,
              :revenue_deduction_tax_value, :posts_cnt)
      returning_values (:rev_amount, :corr_amount, :id_summary_rev_group, :no_use, :no_use, :no_use, :no_use, :no_use, :no_use);

      total_rev_amount = :total_rev_amount + :rev_amount;
      total_corr_amount = :total_corr_amount + :corr_amount;
      total_vat_amount = :total_vat_amount + :vat_amount;

    end else if (:SUMMARY_OPTION = 'statistic') then begin

      select first 1 RG.ID_SUMMARY_REV_GROUP
      from   SUMMARY_REV_GROUPS$REV RG
      where  RG.ID_END_WORK = :ID_END_WORK
             and RG.ID_SALE_TAXATION = :id_sale_taxation
             and RG.REVENUE_GROUP is not distinct from :REVENUE_GROUP
      into   :ID_SUMMARY_REV_GROUP;

      VAT_AMOUNT = :POST_GROSS_VALUE - :POST_NET_VALUE;
      execute procedure REVENUE_STATISTIC_UPDATE$INT (:id_summary_rev_group, :is_primary_post, :id_profile,
              :market_segment, :source_code, :channel_code, :hear_reason, :come_reason,
              :post_net_value, :vat_amount, :country_code, :id_room_type, :ew_date, :revenue_deduction_tax_value)
      returning_values (:no_use, :no_use, :no_use, :no_use, :no_use, :no_use);
    end
  end
  
  if (:SUMMARY_OPTION = 'full') then begin
    for
      select  AP.ID_SALE_TAXATION, AP.REVENUE_GROUP, TVD.ID_SALE_TAX, sum(TVD.TAX_VALUE)
      from    ACCOUNT_DEBT AP
              join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
              left outer join TAX_VALUE_DEDUCT(AP.NAT_GROSS_VALUE, :round_to, AP.ID_SALE_TAXATION, 1) TVD on 1=1
      where   A.ID_HOTEL = :id_hotel
              and AP.DEBT_DATE = :ew_date
      group by 1, 2, 3
      into    :id_sale_taxation, :revenue_group, :id_sale_tax, :tax_value
    do begin
      select SRG.ID_SUMMARY_REV_GROUP
      from   SUMMARY_REV_GROUPS$REV SRG
      where  SRG.ID_END_WORK = :id_end_work
             and SRG.REVENUE_GROUP = :revenue_group
             and SRG.ID_SALE_TAXATION = :id_sale_taxation
      into   :id_summary_rev_group;

      insert into SUMMARY_TAXES(ID_SUMMARY_REV_GROUP, ID_SALE_TAXES, VAT_AMOUNT)
      values (:id_summary_rev_group, :id_sale_tax, :tax_value);
    end

    update SUMMARY_END_WORK SE
    set    SE.REVENUE_AMOUNT = :TOTAL_REV_AMOUNT,
           SE.CORRECTION_AMOUNT = :TOTAL_CORR_AMOUNT,
           SE.VAT_AMOUNT = :TOTAL_VAT_AMOUNT
    where  SE.ID_END_WORK = :ID_END_WORK;
  end
end
^

/* Restore proc. body: ROOM_CONTRACT_MODIFY$PMS */
ALTER PROCEDURE ROOM_CONTRACT_MODIFY$PMS(ID_ROOM_CONTRACT INTEGER,
ID_ROOM_PERIOD INTEGER,
CONTRACT_TYPE VARCHAR(50),
PMS_MARKERS BLOB SUB_TYPE 1 SEGMENT SIZE 100,
IMPORT_INCOME_WITH_VAT SMALLINT,
ID_RENTAL_POOL INTEGER,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_CONTRACT INTEGER)
 AS
declare variable permissible_value_list varchar(255);
  declare variable from_date date;
  declare variable rental_pool_unit_name varchar(100);
  declare variable room_name varchar(10);
  declare variable old_contract_type varchar(50);
  declare variable old_import_income_with_vat smallint;
  declare variable old_from_date date;
  declare variable old_rental_pool_unit_name varchar(100);
  declare variable old_room_name varchar(10);
  declare variable old_id_room_period integer;
  declare variable id_room integer;
  declare variable action_text varchar(255);
  declare variable no_use varchar(255);
begin

  permissible_value_list = '';
  select list(trim(S.KEY_))
  from   SYSTEM_ENUM S
  where  S.GROUP_ = 'pms.contract_type'
  into   :permissible_value_list;

  if (:operation in ('add', 'mod')) then begin
    execute procedure SYSTEM_CHECK_OPERATION(:contract_type, :permissible_value_list, 'contract type');

    select PRO.PROFILE_NAME
    from   PROFILE PRO
    where  PRO.ID_PROFILE = :ID_RENTAL_POOL
    into   :rental_pool_unit_name;

    select ROO.ROOM_NAME, RPP.FROM_DATE
    from   ROOM_PERIOD$PMS RPP
           join ROOMS ROO on ROO.ID_ROOM = RPP.ID_ROOM
    where  RPP.ID_ROOM_PERIOD = :ID_ROOM_PERIOD
    into   :room_name, :from_date;
  end

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');
  NEW_ID_ROOM_CONTRACT = :id_room_contract;

  if (:operation = 'add') then begin
    if (coalesce(:ID_ROOM_CONTRACT, -1) < 0) then begin
      NEW_ID_ROOM_CONTRACT = gen_id(GEN_ROOM_CONTRACT$PMS_ID, 1);
      ID_ROOM_CONTRACT = :NEW_ID_ROOM_CONTRACT;
    end
    else
      NEW_ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT;

    insert into ROOM_CONTRACT$PMS (ID_ROOM_CONTRACT, ID_ROOM_PERIOD,
           CONTRACT_TYPE, PMS_MARKERS, IMPORT_INCOME_WITH_VAT, ID_RENTAL_POOL)
    values (:NEW_ID_ROOM_CONTRACT, :ID_ROOM_PERIOD,
           :CONTRACT_TYPE, :PMS_MARKERS, :IMPORT_INCOME_WITH_VAT, :ID_RENTAL_POOL);

    action_text = substring(f_character(29) || '@{pms.contract_type.' || :contract_type || '}' || f_character(28) ||
                  formatdate(:from_date, 'D;dd.mm.yyyy') ||
                  f_character(28) || :room_name || f_character(28) || coalesce(:rental_pool_unit_name, ' ') || f_character(28)
                  || coalesce(:import_income_with_vat, 0) from 1 for 255);
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_ADDED', :ACTION_TEXT);

  end else begin
    select RC.CONTRACT_TYPE, RC.IMPORT_INCOME_WITH_VAT,
           RO.ROOM_NAME, PR.PROFILE_NAME, RP.FROM_DATE, RC.ID_ROOM_PERIOD, RP.ID_ROOM
    from   ROOM_CONTRACT$PMS RC
           join ROOM_PERIOD$PMS RP on RP.ID_ROOM_PERIOD = RC.ID_ROOM_PERIOD
           join ROOMS RO on RO.ID_ROOM = RP.ID_ROOM
           left outer join PROFILE PR on PR.ID_PROFILE = RC.ID_RENTAL_POOL
    where  RC.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
    into   :old_contract_type, :old_import_income_with_vat,
           :old_room_name, :old_rental_pool_unit_name, :old_from_date, :old_id_room_period, :id_room;

    if (:operation = 'mod') then begin
      update ROOM_CONTRACT$PMS
      set    CONTRACT_TYPE = :CONTRACT_TYPE,
             PMS_MARKERS = :PMS_MARKERS,
             IMPORT_INCOME_WITH_VAT = :IMPORT_INCOME_WITH_VAT,
             ID_RENTAL_POOL = :ID_RENTAL_POOL
      where (ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT);

      if ((:contract_type <> :old_contract_type) or (:import_income_with_vat <> :old_import_income_with_vat) or
         (coalesce(:rental_pool_unit_name, ' ') <> coalesce(:old_rental_pool_unit_name, ' ')) or
         (:from_date <> :old_from_date) or (:room_name <> :old_room_name)) then begin
        action_text = substring(f_character(29) || '@{pms.contract_type.' || :old_contract_type || '}' || f_character(28) ||
                      formatdate(:old_from_date, 'D;dd.mm.yyyy') ||
                      f_character(28) || :old_room_name ||
                      f_character(28) || coalesce(:old_rental_pool_unit_name, ' ') || f_character(28) || coalesce(:old_import_income_with_vat, 0) ||
                      f_character(28) || '@{pms.contract_type.' || :contract_type || '}' || f_character(28) || formatdate(:from_date, 'D;dd.mm.yyyy') ||
                      f_character(28) || :room_name || f_character(28) || coalesce(:rental_pool_unit_name, ' ') || f_character(28)
                      || coalesce(:import_income_with_vat, 0) from 1 for 255);
        execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_CHANGED', :ACTION_TEXT);
      end

    end

    if (:operation = 'del') then begin
      action_text = substring(f_character(29) || '@{pms.contract_type.' || :old_contract_type || '}' || f_character(28) ||
                    formatdate(:old_from_date, 'D;dd.mm.yyyy') ||
                    f_character(28) || :old_room_name || f_character(28) || coalesce(:old_rental_pool_unit_name, ' ') || f_character(28)
                    || coalesce(:old_import_income_with_vat, 0) from 1 for 255);
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_REMOVED', :ACTION_TEXT);

      delete from ROOM_CONTRACT$PMS where (ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT);

      execute procedure ROOM_PERIOD_MODIFY$PMS (:OLD_ID_ROOM_PERIOD, :id_room,  :old_from_date,
              iif(:contract_type in ('PRIVATE_USE'), 'PRIVATE', 'CONTRACT'),  'del')
      returning_values :no_use;
    end
  end
end
^

/* Restore proc. body: ROOM_MODIFY$PMS */
ALTER PROCEDURE ROOM_MODIFY$PMS(ID_ROOM INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
BEDS INTEGER,
EXTRA_BEDS INTEGER,
SECTOR INTEGER,
SORT_ORDER INTEGER,
FEATURES BLOB SUB_TYPE 1 SEGMENT SIZE 100,
EXTERNAL_NAME VARCHAR(10),
ID_EATING_OBJECT TYPE OF ID_REF,
OPERATION VARCHAR(20))
 RETURNS(OVERRULE_NEED SMALLINT,
OVERRULE_CONTEXT VARCHAR(255),
NEW_ID_ROOM INTEGER)
 AS
declare variable old_id_room_type integer;
  declare variable old_room_name varchar(10);
  declare variable rebuild_id_hotel integer;
  declare variable rebuild_id_room_type integer;
  declare variable guests_max integer;
  declare variable no_use varchar(20);
  declare variable old_capacity integer;
  declare variable busy_group_type integer;
  declare variable sys_date date;
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable action_text varchar(255);
  declare variable old_floor integer;
  declare variable old_sector integer;
  declare variable old_extra_beds integer;
  declare variable id_hotel integer;
begin
  overrule_need = 0;
  overrule_context = '';
  new_id_room = null;
  --if OVERRULE_NEED = 1 then OVERRULE_CONTEXT = ERR_TEXT like ERR_CODE = -9
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    if (coalesce(:room_name, '') = '') then
      exception ASSERT '-119';

    if ((:room_name containing '<') or (:room_name containing '>') or (:room_name starting with 'i')) then
      exception ASSERT '-120';
  end

  room_name = upper(:room_name);

  if (:operation='mod') then begin
    select R.ROOM_NAME, R.ID_ROOM_TYPE, R.BEDS+R.EXTRA_BEDS, r.floor, r.sector, r.extra_beds
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :id_room
    into   :old_room_name, :old_id_room_type, :old_capacity, :old_floor, :old_sector, :old_extra_beds;

    if (:id_room_type <> :old_id_room_type) then begin
      exception OCCUPANCY_EXCEPTION '-65';
    end

    new_id_room = :id_room;
    guests_max = 0;
    if (:old_capacity > (:beds + :extra_beds)) then begin
      select first 1 sum(RM.ADULT_COUNT+RM.CHILDREN_COUNT), max(rm.BUSY_GROUP_TYPE)
      from   ROOM_MAGIC RM
             join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = RM.ID_RESERV_DETAIL
      where  RM.ID_ROOM = :id_room
             and RD.CHECK_STATUS in (-3, -2, -1, 0)
      group by RM.BUSY_DATE
      order by 1 desc
      into   :guests_max, :busy_group_type;
    end
    if ((:beds + :extra_beds) < :guests_max) then begin
      err_code = -8;
      err_text = f_character(29)||:ROOM_NAME||f_character(28)||:guests_max||f_character(28)||(:beds + :extra_beds);
      if (:busy_group_type in (1)) then begin
        overrule_need = :err_code;
        overrule_context = :err_text;
        err_code = 0;
        err_text = '';
      end else begin
        exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      end
    end

    update ROOMS RU
    set    RU.ID_ROOM_TYPE = :id_room_type,
           RU.ROOM_NAME = :room_name,
           RU.FLOOR = :floor,
           RU.BEDS = :beds,
           RU.EXTRA_BEDS = :extra_beds,
           RU.SECTOR = :sector,
           RU.FEATURES = :features,
           RU.SORT_ORDER = :sort_order,
           --RU.ID_HOTEL = :rebuild_id_hotel,
           RU.EXTERNAL_NAME = :external_name,
           RU.ID_EATING_OBJECT = :ID_EATING_OBJECT
    where  RU.ID_ROOM = :id_room;

    if ((:room_name <> :old_room_name)
        or (:floor <> :old_floor)
        or (:sector <> :old_sector)
        or (:extra_beds <> :old_extra_beds)) then
    begin
      action_text = f_character(29) || '(' || :old_room_name || '/' || :old_floor || '/' || :old_sector || '/'
                    || :old_extra_beds || ')' || f_character(28) || '(' || :room_name || '/' || :floor || '/'
                    || :sector || '/' || :extra_beds || ')';
      execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_PARAMS_CHANGED', :action_text);
    end

    if (:room_name <> :old_room_name) then begin
      update ACCOUNT_POST AP
      set    AP.ROOM_NAME = :room_name
      where  AP.ROOM_NAME = :old_room_name;
    end

  end else if (:operation = 'add') then begin
    select rt.ID_HOTEL
    from   ROOM_TYPES RT
    where  rt.ID_ROOM_TYPE = :ID_ROOM_TYPE
    into   :id_hotel;

    insert into ROOMS (
      ID_ROOM, ID_ROOM_TYPE, ROOM_NAME, FLOOR, BEDS, EXTRA_BEDS, SECTOR,
      FEATURES, SORT_ORDER, ID_HOTEL, EXTERNAL_NAME, ID_EATING_OBJECT)
    values (gen_id(ID_ROOM_GEN, 1), :id_room_type, :room_name, :floor, :beds, :extra_beds, :sector,
      :features, :sort_order, :id_hotel, :external_name, :ID_EATING_OBJECT)
    returning ID_ROOM into :NEW_ID_ROOM;

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :sys_date;

    execute procedure ROOM_PERIOD_MODIFY$PMS(null, :new_id_room, :sys_date, 'HOTEL', 'add')
    returning_values  :no_use;

    insert into ROOMS_ADD (ID_ROOM, PMS_MARKERS, ADDRESS)
    values (:new_id_room, null, null);
  end else if (:operation = 'del') then begin
    -- Booked rooms are preserved with FK constraint on room_magic
    execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'DELETE', '');

    select RT.ID_ROOM_TYPE, RT.ID_HOTEL
    from   ROOM_TYPES RT
    where  RT.ID_ROOM_TYPE = :id_room_type
    into   :rebuild_id_room_type, :rebuild_id_hotel;

    delete from ROOMS where ID_ROOM = :id_room;

    execute procedure ALLOTMENT_PHYS_REBUILD$INT(:rebuild_id_hotel, :rebuild_id_room_type);

    when sqlcode -530 do begin
      -- Violation of FOREIGN KEY constraint "%s" on table "%s"
      exception ASSERT '-34';
    end
  end
end
^

/* Restore proc. body: ROOM_PICKUP$INT */
ALTER PROCEDURE ROOM_PICKUP$INT(ID_ROOM_TYPE INTEGER,
RES_FROM_DATE DATE,
RES_TO_DATE DATE,
IS_EARLY_ARRIVAL SMALLINT,
IS_LATE_DEPARTURE SMALLINT,
OFFER_METHOD VARCHAR(20),
FROM_ROOM VARCHAR(20),
ROOM_REQUIREMENTS BLOB SUB_TYPE 1 SEGMENT SIZE 100,
MIN_BEDS_COUNT SMALLINT)
 RETURNS(OUT_ID_ROOM INTEGER)
 AS
declare variable rooms_list_blocked varchar(5000);
  declare variable rooms_list_allowed varchar(5000);
  declare variable id_room integer;
  declare variable room_found integer;
  declare variable id_hotel integer;
begin
  /* offer_method :
      set_number_asc
      set_number_desc
      set_max_occupancy
      set_max_usage - FILING FACTOR(EQUAL ROOM USAGE)
  */
  -- INITIALIZE
  rooms_list_blocked = 'x';
  rooms_list_allowed = 'x';
  if (:from_room is null) then from_room = '';
  if (:offer_method is null) then begin
    select rt.ID_HOTEL
    from   ROOM_TYPES rt
    where  rt.ID_ROOM_TYPE = :ID_ROOM_TYPE
    into   :id_hotel;

    execute procedure SETTING_GET_VALUE('ROOMS_PREFERD_SORT_ORDER', :id_hotel )
    returning_values :offer_method;
  end

  /*
  ||  PREPARE EXCLUDING BUSY ROOMS, FOR THE FUTURE WE MAY
  ||  EXCLUDE ONLY BLOCKED WITH "RM.DAY_ACTION = 'BLOCK'".
  */
  for
    select distinct RM.ID_ROOM
    from   ROOM_MAGIC RM
           join ROOMS R on R.ID_ROOM = RM.ID_ROOM
           left outer join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = rm.ID_RESERV_DETAIL
    where  RM.BUSY_DATE between :res_from_date and :res_to_date
           and RM.ID_ROOM_TYPE = :id_room_type
           and ((RM.DAY_ACTION <> 'CHECK_OUT' and RM.BUSY_DATE <> :res_to_date)
                or (RM.BUSY_DATE = :res_from_date and :is_early_arrival = 1)
                or (RM.BUSY_DATE = :res_from_date and rd.LEAVING_KIND is not distinct from 2)
                or (RM.BUSY_DATE = :res_to_date and :is_late_departure = 1)
                or (RM.BUSY_DATE = :res_to_date and rd.COMMING_KIND is not distinct from 0))
    into   :id_room
  do begin
    rooms_list_blocked = :rooms_list_blocked||:id_room||'x';
  end

  if ((:room_requirements is not null) and (f_blobaspchar(:room_requirements) <> '')) then begin
    select 'x' || coalesce(list(R.ID_ROOM, 'x'), '') || 'x'
    from   ROOMS R
           left outer join SYSTEM_PICKUP_FEATURES$INT(R.FEATURES, :room_requirements, 38, R.ID_HOTEL) RPF on 0=0
    where  r.ID_ROOM_TYPE = :ID_ROOM_TYPE
           and not exists (select *
                       from   ROOM_PERIOD$PMS rp
                       where  rp.ID_ROOM = r.ID_ROOM
                              and rp.FROM_DATE <= :RES_FROM_DATE
                              and rp.TO_DATE >= (:RES_TO_DATE - 1)
                              and rp.IS_AVAILABLE = 0)
           and RPF.IS_MATCHING = 1
    into   :rooms_list_allowed;
  end

  room_found = 0;
  while (:room_found = 0) do begin
    out_id_room = null;
    execute procedure ROOM_PICKUP_OFFER$INT(:rooms_list_blocked, :rooms_list_allowed, :id_room_type,
                      :offer_method, :from_room, :res_from_date, :res_to_date, :min_beds_count)
    returning_values  :out_id_room;

    if (:out_id_room is null) then
      exit; /* NO MORE CHOICES ! */
    else begin
      room_found = 1;
    end
  end

  suspend;
end
^

/* Restore proc. body: SAFE_OCCUPANCY_MODIFY */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE TYPE OF ID,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable old_booking_number tres_number;
  declare variable id_resource_reservation id_ref;
  declare variable from_datetime tdatetime;
  declare variable action_text tdescription_long;
  declare variable old_occupant varchar(100);
  declare variable old_to_dt timestamp;
  declare variable id_reserv_detail integer;
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation;

  select rr.BOOKING_NUMBER, od.FROM_DATETIME,
         RR.OCCUPANT_NAME, od.TO_DATETIME, rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESERV_DETAIL rd on rd.NUMBER = rr.BOOKING_NUMBER and rd.IS_ANUL = 0
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :old_booking_number, :from_datetime,
         :old_occupant, :old_to_dt, :id_reserv_detail, :id_agent_profile;

  --if (:old_booking_number <> :BOOKING_NUMBER) then exception ASSERT 'Can not change booking number!';
  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  update SAFE_RESOURCE_RESERV rr
  set    rr.PRICE_DESCRIPTION = :price_description,
         rr.ID_RATE_PRICE_PROFILE = :id_agent_profile,
         rr.RATING_UNITS = :rating_units,
         rr.RATE_PRICE = :price,
         rr.RATE_CURR = :currency
  where  rr.ID_RESOURCE_RESERV = :id_resource_reservation;

  execute procedure RESOURCE_RESERVATION_MODIFY (:id_resource_reservation, :ID_SAFE, :from_datetime,
          :TO_DATETIME, :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :old_booking_number, 'mod')
  returning_values :id_resource_reservation, :no_use;

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail)
  returning_values (:DOC_SELECTED);

  /* Log changes */
  if ((:old_occupant <> :OCCUPANT_NAME) or (:old_to_dt <> :TO_DATETIME)) then begin
    action_text = f_character(29) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                  || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                  || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');
  
    execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_CHANGED', :action_text);
  end
end
^

/* Restore proc. body: SAFE_OCCUPANCY_NEW */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE TYPE OF ID,
FROM_DATETIME TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME,
BOOKING_NUMBER TYPE OF TRES_NUMBER,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
ID_RESOURCE_RESERVATION TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable action_text tdescription_long;
  declare variable id_reserv_detail integer;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, s.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  if (:id_resource_reservation is not null) then exception ASSERT '-1064'|| f_character(31) || f_character(29) || :safe_name;

  select rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESERV_DETAIL rd
  where  rd.NUMBER = :BOOKING_NUMBER
         and rd.IS_ANUL = 0
  into   :id_reserv_detail, :id_agent_profile;

  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  execute procedure  RESOURCE_RESERVATION_MODIFY (null, :ID_SAFE, :FROM_DATETIME, :TO_DATETIME,
          :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :BOOKING_NUMBER, 'add')
  returning_values (:id_resource_reservation, :no_use) ;

  insert into SAFE_RESOURCE_RESERV (ID_RESOURCE_RESERV, PRICE_DESCRIPTION, ID_RATE_PRICE_PROFILE,
         RATING_UNITS, RATE_PRICE, RATE_CURR)
  values (:id_resource_reservation, :price_description, :id_agent_profile,
         :rating_units, :price, :currency);

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail, :ID_EXTERNAL_CLIENT_ACCCOUNT)
  returning_values (:DOC_SELECTED);

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = 'CHECKED_IN'
  where  RR.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = :id_resource_reservation
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                || f_character(28) || coalesce(:BOOKING_NUMBER, '')
                || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUPIED', :action_text);
end
^

/* Restore proc. body: SUMMARY_TAXES_REGEN */
ALTER PROCEDURE SUMMARY_TAXES_REGEN AS
declare variable id_sale_taxation integer;
  declare variable revenue_group varchar(50);
  declare variable round_to numeric(15,6);
  declare variable id_sale_tax integer;
  declare variable tax_value numeric(15,4);
  declare variable ew_date date;
  declare variable id_end_work integer;
  declare variable id_hotel integer;
  declare variable id_summary_rev_group integer;
begin
  delete
  from   SUMMARY_TAXES;

  for
    select   EW.ID_END_WORK, EW.ID_HOTEL, CU.ROUND_TO,
             EW.SUMMARY_DATE
    from     SUMMARY_END_WORK EW
             join HOTEL H on H.ID_HOTEL = EW.ID_HOTEL
             join CURRS CU on CU.CURR = H.NATION_CURR
    into     :id_end_work, :id_hotel, :round_to, :ew_date
  do begin
    for
      select  AP.ID_SALE_TAXATION, AP.REVENUE_GROUP, TVD.ID_SALE_TAX, sum(TVD.TAX_VALUE)
      from    ACCOUNT_DEBT AP
              join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
              left outer join TAX_VALUE_DEDUCT(AP.NAT_GROSS_VALUE, :round_to, AP.ID_SALE_TAXATION, 1) TVD on 1=1
      where   A.ID_HOTEL = :id_hotel
              and AP.DEBT_DATE = :ew_date
      group by 1, 2, 3
      into    :id_sale_taxation, :revenue_group, :id_sale_tax, :tax_value
    do begin
      select SRG.ID_SUMMARY_REV_GROUP
      from   SUMMARY_REV_GROUPS$REV SRG
      where  SRG.ID_END_WORK = :id_end_work
             and SRG.REVENUE_GROUP = :revenue_group
             and SRG.ID_SALE_TAXATION = :id_sale_taxation
      into   :id_summary_rev_group;

      insert into SUMMARY_TAXES(ID_SUMMARY_REV_GROUP, ID_SALE_TAXES, VAT_AMOUNT)
      values (:id_summary_rev_group, :id_sale_tax, :tax_value);
    end
  end
end
^

/* Restore proc. body: TAR_CALC_EVAL_ALL$INT */
ALTER PROCEDURE TAR_CALC_EVAL_ALL$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable room_status varchar(20);
  declare variable from_date date;
  declare variable to_date date;
  declare variable idate date;
  declare variable is_static integer;
  declare variable id_tar_input integer;
  declare variable id_type_stay integer;
  declare variable separate_board integer;
  declare variable id_board_include integer;
  declare variable id_tar_head integer;
  declare variable is_manual_type_stay smallint;
  declare variable seasson_name varchar(50);
begin
  err_code = 0;

  delete from TAR_CALC_OUTPUT$TMP TCO where TCO.ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP TCV where TCV.ID_TAR_CALC = :id_tar_calc;

  execute procedure TAR_CALC_INIT_VARS$INT(:id_tar_calc);

  for
    select TCI.ROOM_STATUS, min(TCI.FROM_DATE_CALC), max(TCI.TO_DATE_CALC), min(TCI.IS_STATIC)
    from   TAR_CALC_INPUT$TMP TCI
    where  TCI.ID_TAR_CALC = :id_tar_calc
    group by TCI.ROOM_STATUS
    into   :room_status, :from_date, :to_date, :is_static
  do begin
    for
      select RLP.OUT_DATE
      from   SYSTEM_LOOP_PERIOD(:from_date, :to_date) RLP
      into   :idate
    do begin
      if ((:is_static = 1) and (:idate > :from_date)) then begin
        insert into TAR_CALC_OUTPUT$TMP (ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
               FOR_DATE, PRICE, CURRENCY, PRICE_TARIFF, CURRENCY_TARIFF, PRICE_NOTE, QTY_POST,
               PTEXT, DISC_TAG, ID_DISCOUNT_SERVICE, REQUIRED_ID_PACKET_ITEM)
        select tco.ID_TAR_INPUT, tco.ID_TAR_CALC, tco.ID_SERVICE, tco.SERVICE_TYPE,
               :idate, PRICE, tco.CURRENCY, tco.PRICE_TARIFF, tco.CURRENCY_TARIFF, tco.PRICE_NOTE, tco.QTY_POST,
               tco.PTEXT, tco.DISC_TAG, tco.ID_DISCOUNT_SERVICE, tco.REQUIRED_ID_PACKET_ITEM
        from   TAR_CALC_OUTPUT$TMP TCO
        where  TCO.FOR_DATE = :from_date
               and TCO.ID_TAR_CALC = :id_tar_calc;
        for
          select TCID.ID_TAR_INPUT, TCID.ID_TYPE_STAY, TCID.SEPARATE_BOARD, TCID.ID_BOARD_INCLUDE,
                 TCID.IS_MANUAL_TYPE_STAY, TCID.ID_TAR_HEAD
          from   TAR_CALC_INPUT_DETAIL$TMP TCID
                 join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
          where  TCID.FOR_DATE = :from_date
                 and TCI.ID_TAR_CALC = :id_tar_calc
          into   :id_tar_input, :id_type_stay, :separate_board, :id_board_include,
                 :is_manual_type_stay, :id_tar_head
        do begin
          seasson_name = null;
          select tp.SEASON_NAME
          from   TARIFA_GET_PERIOD_FOR_DATE (:id_tar_head, :idate) tp
          into   :seasson_name;
          if (:seasson_name is null) then begin
            ERR_CODE = -231;
            ERR_TEXT = '';
            exit;
          end

          update TAR_CALC_INPUT_DETAIL$TMP TCID
          set    TCID.ID_TYPE_STAY = :id_type_stay,
                 TCID.IS_MANUAL_TYPE_STAY = :is_manual_type_stay,
                 TCID.SEPARATE_BOARD = :separate_board,
                 TCID.ID_BOARD_INCLUDE = :id_board_include
          where  TCID.ID_TAR_INPUT = :id_tar_input;
        end
      end else begin
        execute procedure TAR_CALC_EVAL_DATE$INT(:id_tar_calc, :room_status, :idate)
        returning_values  :err_code, :err_text;
        if (:err_code < 0) then exit;
      end
    end
  end

  execute procedure TAR_CALC_EVAL_ZERO$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  if (:err_code is null) then begin
    err_code = -230; /*WRONG INPUT PARAMS - MISSING GUESTS*/
    err_text = 'Missing input data for calculation';
    exit;
  end

  execute procedure TAR_CALC_EVAL_PERIOD$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  execute procedure TAR_CALC_CHECK_PACKETS$INT (:ID_TAR_CALC)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;
end
^

/* Restore proc. body: TAR_CALC_EVAL_COMPLEX_RATE$INT */
ALTER PROCEDURE TAR_CALC_EVAL_COMPLEX_RATE$INT(INPUT_DETAIL_DBKEY CHAR(8),
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
BEDS SMALLINT,
ID_TYPE_STAY INTEGER,
IS_MANUAL_TYPE_STAY SMALLINT,
ID_BOARD INTEGER,
ID_ROOM_TYPE INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
CHECKIN_DATE DATE,
DAY_OF_STAY INTEGER,
PAYORS INTEGER,
MINORS INTEGER,
PERIOD_DEPEND_ON_CHECKIN SMALLINT,
CNT_DAYS_BP INTEGER,
CNT_DAYS_BOARD INTEGER,
BOARD_TYPE_FIND VARCHAR(10),
TOTAL_GUESTS INTEGER,
SEQ_NUM INTEGER,
TARIFF_CURR CHAR(3),
REAL_RECALC SMALLINT)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_PAYORS INTEGER,
OUT_MINORS INTEGER)
 AS
declare variable id_tar_input_detail integer;
  declare variable price numeric(15,4);
  declare variable auto_stay_type integer;
  declare variable base_per_day numeric(15,4);
  declare variable board_per_day numeric(15,4);
  declare variable guest_board_weight integer;
--  declare variable guest_food varchar(20);
  declare variable match_date date;
  declare variable manual_total_gsts integer;
  declare variable manual_payors integer;
  declare variable manual_minors integer;
  declare variable service_type varchar(20);
  declare variable base_price numeric(15,4);
  declare variable board_price numeric(15,4);
  declare variable food_per_day numeric(15,4);
  declare variable base_price_tar numeric(15,4);
  declare variable custom_cross_rate double precision;
  declare variable ptext varchar(20);
  declare variable id_service integer;
  declare variable qty_post integer;
  declare variable pack_currency char(3);
  declare variable minors_input integer;
  declare variable packet_item integer;
  declare variable price_tariff numeric(15,4);
  declare variable is_inside_base integer;
  declare variable id_bo_bp integer;
  declare variable id_board_include integer;
  declare variable separate_board integer;
  declare variable incomplete_bp integer;
  declare variable id_bo_eg integer;
  declare variable id_eg_price integer;
  declare variable disc_tag varchar(50);
  declare variable id_discount_service integer;
  declare variable var_board_price numeric(15,4);
  declare variable type_stay_code varchar(10);
begin
  base_per_day = 0;
  board_per_day = 0;

  select TH.WEIGHT_TAG
  from   MEALS TH
  where  TH.ID_BOARD = :ID_BOARD
  into   :guest_board_weight;
  guest_board_weight = coalesce(:guest_board_weight, 0);

  /*if (:guest_board_weight = 0) then GUEST_FOOD = 'NONE';
  else GUEST_FOOD = 'SOME';*/
  if (:PERIOD_DEPEND_ON_CHECKIN = 1) then MATCH_DATE = :CHECKIN_DATE;
  else MATCH_DATE = :FOR_DATE;

  select st.TYPE_STAY_CODE
  from   TYPE_STAY st
  where  st.ID_TYPE_STAY = :id_type_stay
  into   :type_stay_code;

  if (:IS_MANUAL_TYPE_STAY = 1) then begin
    if (:type_stay_code = 'ALONE') then begin
      MANUAL_TOTAL_GSTS = 1;
      MANUAL_PAYORS = 0;
      MANUAL_MINORS = 0;
    end else if (:type_stay_code = 'BED') then begin
      MANUAL_TOTAL_GSTS = 2;
      MANUAL_PAYORS = 1;
      MANUAL_MINORS = 0;
    end else if (:type_stay_code = 'EXTRA_BED') then begin
      MANUAL_TOTAL_GSTS = :BEDS+1;
      MANUAL_PAYORS = :BEDS;
      MANUAL_MINORS = :MINORS;
    end

    execute procedure TAR_MATCH_BP(:INPUT_DETAIL_DBKEY, :MATCH_DATE, :MANUAL_TOTAL_GSTS, :MANUAL_TOTAL_GSTS,
                      :GUEST_BOARD_WEIGHT, :REAL_RECALC, :DAY_OF_STAY, :CNT_DAYS_BP)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_BP, :ID_BOARD_INCLUDE,
                      :INCOMPLETE_BP, :BASE_PRICE, :PTEXT, :BASE_PER_DAY;
  end else begin
    execute procedure TAR_MATCH_BP(:INPUT_DETAIL_DBKEY, :MATCH_DATE, :SEQ_NUM, :TOTAL_GUESTS,
                      :GUEST_BOARD_WEIGHT, :REAL_RECALC, :DAY_OF_STAY, :CNT_DAYS_BP)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_BP, :ID_BOARD_INCLUDE,
                      :INCOMPLETE_BP, :BASE_PRICE, :PTEXT, :BASE_PER_DAY;
  end

  execute procedure sys_dbg('tar base_per_day = '||coalesce(:BASE_PER_DAY, 'null'));
  execute procedure sys_dbg('tar base_price = '||coalesce(:BASE_PRICE, 'null'));
  if (:ERR_CODE < 0) then exit;

  SEPARATE_BOARD = 0;
  if (:REAL_RECALC = 1) then begin
    if (:CUSTOM_PRICE is not null) then begin
      base_price = :CUSTOM_PRICE;
      execute procedure CURR_CROSS_RATE_GET(:CUSTOM_CURRENCY, :TARIFF_CURR, current_timestamp, 1)
      returning_values  :custom_cross_rate;
      base_price_tar = (:custom_cross_rate * :base_price);
      pack_currency = :custom_currency;
    end else begin
      base_price_tar = :base_per_day;
      pack_currency = :tariff_curr;
    end
    /*DEBUG*/
    if (:base_price is null) then exception RATING_EXCEPTION ('4. base price is null');
    if (:base_price_tar is null) then exception RATING_EXCEPTION ('5. base price tar is null');

    select TBP.PACKET_ITEM
    from   TAR_BO_BASE_POSITION TBP
    where  TBP.ID_TAR_BP = :id_bo_bp
    into   :packet_item;

    insert into TAR_CALC_OUTPUT$TMP (
           ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
           FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
           CURRENCY, CURRENCY_TARIFF, REQUIRED_ID_PACKET_ITEM)
    values (:ID_TAR_INPUT, :ID_TAR_CALC, -1, 'BASE',
           :FOR_DATE, :BASE_PER_DAY, :BASE_PRICE_TAR, 'BASE', 1, :PTEXT,
           :PACK_CURRENCY, :TARIFF_CURR, :packet_item);
    /* BOARDS */
    var_board_price = 0;
    for
      select TMB.ERR_CODE, TMB.ERR_TEXT, TMB.SEPARATE_BOARD, TMB.BOARD_PRICE, TMB.PTEXT,
             TMB.SERVICE_TYPE, TMB.ID_SERVICE, TMB.FOOD_PER_DAY, TMB.PACKET_ITEM
      from   TAR_MATCH_BOARD(:INPUT_DETAIL_DBKEY, :id_bo_bp, :BOARD_TYPE_FIND,
             :ID_BOARD, :id_board_include, :match_date, :base_per_day,
             :DAY_OF_STAY, :CNT_DAYS_BOARD, :CNT_DAYS_BP, :CUSTOM_PRICE) TMB
      into   :err_code, :err_text, :separate_board, :board_price, :ptext,
             :service_type, :id_service, :food_per_day, :packet_item
    do begin
      if (:ERR_CODE < 0) then exit;

      /*DEBUG*/
      if (:board_price is null) then exception RATING_EXCEPTION ('6. board_price is null');
      if (:id_service is null) then exception RATING_EXCEPTION ('7. id_service is null');

      insert into TAR_CALC_OUTPUT$TMP (
             ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
             FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
             CURRENCY, CURRENCY_TARIFF, REQUIRED_ID_PACKET_ITEM)
      values (:ID_TAR_INPUT, :ID_TAR_CALC, :ID_SERVICE, :SERVICE_TYPE,
             :FOR_DATE, :food_per_day, :food_per_day, 'FOOD', 1, :PTEXT,
             :TARIFF_CURR, :TARIFF_CURR, :packet_item);

      -- board_per_day = (:board_per_day + :food_per_day); ???
      var_board_price = :var_board_price + iif(:service_type in ('BASE_BOARD', 'EXTRA_BOARD'), :food_per_day, 0);
    end

    select TID.ID_TAR_INPUT_DETAIL
    from   TAR_CALC_INPUT_DETAIL$TMP TID
    where  tid.RDB$DB_KEY = :INPUT_DETAIL_DBKEY
    into   :id_tar_input_detail;

    execute procedure TAR_SET_VAR('board='||:VAR_BOARD_PRICE, :id_tar_input_detail, :id_tar_calc);
  end

  if (:SEPARATE_BOARD is null) then SEPARATE_BOARD = 0;
  minors_input = :MINORS;

  if (:IS_MANUAL_TYPE_STAY = 1) then begin
    /* ONLY TO FIND THE REAL POSITION PAYORS, MINORS ARE NOT IMPORTANT
    || ALL OTHER GUESTS IN THE ROOM MUST SEE THE MANUAL ONE AS AUTOMATIC. SO
    || HERE WE ARE FINDING HIS AUTOMATIC TYPE STAY.
    */
    execute procedure TAR_MATCH_EG(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :total_guests, :PAYORS, :MINORS, :MATCH_DATE, :INCOMPLETE_BP, :ID_ROOM_TYPE, 1)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_EG, :ID_EG_PRICE, :PAYORS, :MINORS, :AUTO_STAY_TYPE;
    if (:ERR_CODE < 0) then exit;
    /* REAL PRICE FIND AND EVAL */
    execute procedure TAR_MATCH_MANUAL_EG(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :MANUAL_TOTAL_GSTS, :MANUAL_PAYORS, :MANUAL_MINORS, :MATCH_DATE, :INCOMPLETE_BP, :ID_TYPE_STAY)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_EG, :ID_EG_PRICE, :AUTO_STAY_TYPE;
    if (:ERR_CODE < 0) then exit;

    if ((:MINORS = :minors_input) and
        (exists (select *
                 from   TYPE_STAY TS
                 where  TS.ID_TYPE_STAY = :ID_TYPE_STAY
                        and TS.TYPE_STAY_CODE = 'EXTRA_BED'))) then begin
      /* TO MANAGE PARAMETER "EXTRA GUEST IN TURN" WHEN MANUAL SET TO ADD */
      MINORS = :MINORS + 1;
      PAYORS = :PAYORS - 1;
    end
  end else begin
    execute procedure TAR_MATCH_EG(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :TOTAL_GUESTS, :PAYORS, :MINORS, :MATCH_DATE, :INCOMPLETE_BP, :ID_ROOM_TYPE, 0)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_EG, :ID_EG_PRICE, :PAYORS, :MINORS, :AUTO_STAY_TYPE;
    if (:ERR_CODE < 0) then exit;
  end

  update TAR_CALC_INPUT_DETAIL$TMP TID
  set    TID.SEPARATE_BOARD = :SEPARATE_BOARD,
         TID.ID_TYPE_STAY   = :AUTO_STAY_TYPE
  where  TID.RDB$DB_KEY = :INPUT_DETAIL_DBKEY;

  if (:REAL_RECALC = 1) then begin
    if (:CUSTOM_PRICE is null) then begin
      for
        select TSP.SERVICE_TYPE, TSP.PRICE,  TSP.PTEXT, TSP.ERR_CODE, TSP.ID_SERVICE
        from   TAR_PRICES_SET_EG(:ID_TAR_INPUT, :FOR_DATE, :DAY_OF_STAY, :CNT_DAYS_BP,
               :CNT_DAYS_BOARD, :guest_board_weight, :id_bo_eg, :id_eg_price, :base_price) TSP
        into   :service_type, :price,  :ptext, :ERR_CODE, :id_service
      do begin
        if (:ERR_CODE < 0) then exit; -- exception INTERNAL_RATING_EXCEPTION;

        /*DEBUG*/
        if (:PRICE is null) then exception RATING_EXCEPTION ('8. price is null');
        if (:ID_SERVICE is null) then exception RATING_EXCEPTION ('9. id_service is null');

        insert into TAR_CALC_OUTPUT$TMP (
               ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
               FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
               CURRENCY, CURRENCY_TARIFF, REQUIRED_ID_PACKET_ITEM)
        values (:ID_TAR_INPUT, :ID_TAR_CALC, :id_service, :service_type,
               :FOR_DATE, :price, :price, 'EG', 1, :ptext,
               :TARIFF_CURR, :TARIFF_CURR, :packet_item);
      end
    end

    for
      select TMT.ID_SERVICE, TMT.SERVICE_TYPE, TMT.PRICE, TMT.PRICE_TARIFF, TMT.QTY_POST,
             TMT.PTEXT, TMT.PACK_CURRENCY, TMT.ERR_CODE, TMT.ERR_TEXT, TMT.PACKET_ITEM, TMT.DISC_TAG
      from   TAR_PRICES_SET_PACKS(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :DAY_OF_STAY, :CUSTOM_PRICE) TMT
      into   :ID_SERVICE, :SERVICE_TYPE, :PRICE, :PRICE_TARIFF, :QTY_POST,
             :PTEXT, :PACK_CURRENCY, :ERR_CODE, :ERR_TEXT, :PACKET_ITEM, :DISC_TAG
    do begin
      if (:ERR_CODE < 0) then exit; --exception INTERNAL_RATING_EXCEPTION;
      /*DEBUG*/
      if (:price_tariff is null) then exception RATING_EXCEPTION ('10. PRICE_TARIFF is null');
      if (:id_service is null) then exception RATING_EXCEPTION ('11. ID_SERVICE is null');

      insert into TAR_CALC_OUTPUT$TMP (
             ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
             FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
             CURRENCY, CURRENCY_TARIFF, DISC_TAG, REQUIRED_ID_PACKET_ITEM)
      values (:ID_TAR_INPUT, :ID_TAR_CALC, :ID_SERVICE, :SERVICE_TYPE,
             :FOR_DATE, :PRICE, :PRICE_TARIFF, 'PACK', :QTY_POST, :PTEXT,
             :PACK_CURRENCY, :TARIFF_CURR, :DISC_TAG, :packet_item);

    end

    for
      select TMT.ID_SERVICE, TMT.SERVICE_TYPE, TMT.PRICE, TMT.PTEXT, TMT.ERR_CODE, TMT.ERR_TEXT, TMT.PACKET_ITEM,
             TMT.IS_INSIDE_BASE, TMT.DISC_TAG, TMT.ID_DISCOUNT_SERVICE
      from   TAR_PRICES_SET_TAX(:ID_TAR_INPUT, :INPUT_DETAIL_DBKEY, :ID_BO_BP, :DAY_OF_STAY) tmt
      into   :ID_SERVICE, :SERVICE_TYPE, :PRICE, :PTEXT, :ERR_CODE, :ERR_TEXT, :PACKET_ITEM,
             :IS_INSIDE_BASE, :DISC_TAG, :ID_DISCOUNT_SERVICE
    do begin
      if (:ERR_CODE < 0) then exit; --exception INTERNAL_RATING_EXCEPTION;
      if ((:IS_INSIDE_BASE = 0) and (:CUSTOM_PRICE is not null)) then begin
        -- SKIP IT. SIMPLE DISCOUNTS MUST NOT CHANGE THE CUSTOM PRICE
      end else begin
        /*DEBUG*/
        if (:PRICE is null) then exception RATING_EXCEPTION ('12. price is null');
        if (:ID_SERVICE is null) then exception RATING_EXCEPTION ('13. id_service is null');
        -- !!! Service type and id_service of discount is as object that they discounting but in TAR_CALC_REPOST$INT type and id_service is changed to PACKAGES if discounts have ID_DISCOUNT_SERVICE
        if ((:DISC_TAG = '') or (:DISC_TAG is null)) then DISC_TAG =  'DISC';
        insert into TAR_CALC_OUTPUT$TMP (
               ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
               FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
               CURRENCY, CURRENCY_TARIFF, DISC_TAG, ID_DISCOUNT_SERVICE, REQUIRED_ID_PACKET_ITEM)
        values (:ID_TAR_INPUT, :ID_TAR_CALC, :ID_SERVICE, :SERVICE_TYPE,
               :FOR_DATE, :PRICE, :PRICE, 'DISC', 1, :PTEXT,
               :TARIFF_CURR, :TARIFF_CURR, :DISC_TAG, :id_discount_service, :packet_item);

        execute procedure sys_dbg('tar TAR_CALC_EVAL_DATE$INT - :DISC_TAG=' || coalesce(:DISC_TAG, 'null') );
      end
    end
  end

  OUT_MINORS = :MINORS;
  OUT_PAYORS = :PAYORS;
end
^

/* Restore proc. body: TAR_CALC_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
declare variable param_code varchar(40);
  declare variable id_param integer;
  declare variable param_value varchar(255);
  declare variable data_type  varchar(30);
  declare variable rate_list varchar(2000);
begin
  err_code = 0;
  param_values = '';

  if (coalesce(:rate_list_replace, '') = '') then rate_list = ',' || :id_rate || ',';
  else rate_list = :rate_list_replace;

  for
    select distinct TBP.PARAM_NAME
    from   SYSTEM_STRING_PARSER (:rate_list, ',') sp
           left join TAR_BO_PARAMS TBP on TBP.ID_TAR_HEAD = sp.ITEM
    where  (TBP.PARAM_TYPE <> 'DATE_DEPENDANT' and :for_date is null)
           or (TBP.PARAM_TYPE = 'DATE_DEPENDANT' and :for_date is not null)
    into   :param_code
  do begin
    if (:param_code is not null) then begin
      id_param = null;
      select TP.ID_TARIFA_PARAM, TP.DATA_TYPE
      from   TARIFA_PARAMS TP
      where  TP.PARAM_CODE = :param_code
             and tp.IS_USE = 1
      into   :id_param, :data_type;
  
      if (:id_param is null) then begin
        err_code = -202;
        execute procedure sys_dbg ('tar calc params err_code: ' || :err_code || F_CRLF() || 'PARAM_CODE = ' || :param_code);
        exit;
      end
  
      execute procedure TARIFA_GET_PARAM (:id_param, :for_date, :id_tar_input, :id_tar_calc)
      returning_values (:param_value);
  
      param_code = ':'||param_code;
  
      if ((:param_code is not null) and (:param_code is not null) and (:data_type is not null)) then
         param_values = :param_values||';'||:param_code||','||:data_type||','||:param_value;
    end
  end
end
^

/* Restore proc. body: TAR_SAVE_BO_BOARD */
ALTER PROCEDURE TAR_SAVE_BO_BOARD(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable id_tar_season integer;
  declare variable iteration varchar(20);
/*****************************************************/
  declare variable id_tar_board integer;
  declare variable id_board integer;
  declare variable id_service integer;
  declare variable pos_numbers varchar(2000);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable separate_board integer;
  declare variable id_bo_price integer;
  declare variable price_type varchar(20);
  declare variable price_type_equal_exists integer;
  declare variable is_board integer;
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  err_text = '';
  iteration = 'FIRST';
  price_type_equal_exists = 0;

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :id_tar_season, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_board, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
      if (:price_type_equal_exists = 1) then begin
        if (exists(
          select *
          from   TAR_BO_RELATION TBR
                 join TAR_BO_BASE_POSITION TBB on TBR.ID_TAR_BP = TBB.ID_TAR_BP
          where  TBR.ID_BO = :id_tar_board
                 and TBR.BO_TYPE = 'BOARD'
                 and TBB.ID_BOARD_INCLUDE is not distinct from :id_board
        )) then begin
          err_code = -237;
          exit;
        end
      end
      price_type_equal_exists = 0;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_board = gen_id(GEN_TAR_BO_BOARD_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers = '';
      id_board = null;
      separate_board = 0;
      ptext = '';
      disc_tag = 'F';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      packet_item = null;
    end
    if (:iteration = 'MIDDLE') then begin
      if (:param_name = 'PTEXT') then ptext = :data;
      else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
      else if (:param_name = 'SET_VAR')       then set_var = :data;
      else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
      else if (:param_name = 'LIST_BASE_POS') then pos_numbers = :data;
      else if (:param_name = 'SEPARATE_BOARD') then begin
        separate_board = :data;
        if ((:separate_board = 0) and (:board_type = 'HRANI')) then err_code = -226;
      end else if (:param_name = 'CHECKIN_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'NIGHT_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'PACKET_ITEM') then begin
        packet_item = :data;
      end else if (:param_name = 'HRANI') then begin
        if (:data = -1) then err_code = -210;
        else begin
          id_service = :data;
          select m.IS_BOARD
          from   MEALS M
          where  M.ID_SERVICE = :id_service
          into   :is_board;
          id_board = :id_service;

          if ((:is_board = 1) and (:board_type = 'HRANI')) then err_code = -228;
          else if ((:is_board = 0) and (:board_type = 'BOARD')) then err_code = -229;
        end
      end
      if (:err_code < 0) then exit;
      if ((:id_tar_season <> -1) and (:iteration = 'MIDDLE')) then begin
        /* WE ARE STARTING THE SEASON PRICES SO: */
        if ((:id_board is null) or (:id_board = -1)) then err_code = -210;
        else if ((:separate_board = 0) and (:board_type = 'HRANI')) then err_code = -226;
        if (:err_code < 0) then exit;
        if ((:separate_board = 1) and (:board_type = 'HRANI')) then separate_board = 2;
        insert into TAR_BO_BOARD(ID_TAR_BOARD, ID_TAR_HEAD, ID_SERVICE, ID_BOARD, PTEXT, SEPARATE_BOARD,
                    PACKET_ITEM, DISC_TAG, SET_VAR, RND_METHOD)
        values (:id_tar_board, :id_tar_head, :id_service, :id_board, :ptext, :separate_board,
               :packet_item, :disc_tag, :set_var, :rnd_method);
        iteration = 'SEASON_PRICES';
      end
    end
    if (:iteration = 'SEASON_PRICES') then begin
      execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_board, :bo_type, :id_tar_season)
      returning_values  :err_code, :id_bo_price, :price_type;
      if (:price_type = 'EQUAL') then begin
        if (:board_type = 'HRANI') then err_code = -225;
        price_type_equal_exists = 1;
      end
      if (:err_code < 0) then exit;
    end
  end
  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:BO_TYPE||', '||:err_text;
  end
end
^

/* Restore proc. body: TAR_SAVE_BO_BP */
ALTER PROCEDURE TAR_SAVE_BO_BP(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable no_use integer;
  declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable id_tar_season integer;
  declare variable iteration varchar(20);
/*****************************************************/
  declare variable id_tar_bp integer;
  declare variable position_number varchar(20);
  declare variable id_room_type integer;
  declare variable max_persons integer;
  declare variable id_board_include integer;
  declare variable is_price_for_room integer;
  declare variable ptext varchar(20);
  declare variable price_type varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable board_weight integer;
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :id_tar_season, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      param_filter = :data||season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      insert into TAR_BO_RELATION(ID_TAR_BP, BO_TYPE, ID_BO, PARAM_FILTER)
      values (:id_tar_bp, :bo_type, :id_tar_bp, :param_filter);
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_bp = gen_id(GEN_TAR_BO_BP_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      position_number = null;
      id_room_type = null;
      max_persons = null;
      id_board_include = -1;
      is_price_for_room = 0;
      ptext = '';
      disc_tag = 'B';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      packet_item = null;
    end
    if (:iteration = 'MIDDLE') then begin
      if (:param_name = 'BASE_POS')            then begin
        if (:data = '') then err_code = -203;
        else position_number = :data;
      end else if (:param_name = 'ROOM_TYPE')  then begin
        if (:data = '') then err_code = -204;
        else id_room_type = :data;
      end else if (:param_name = 'MAX_PERSONS')then begin
        if (:data = '') then err_code = -205;
        else max_persons = :data;
      end else if (:param_name = 'CHECKIN_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'NIGHT_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'BOARD')      then id_board_include = :data;
      else if (:param_name = 'BPRICE_ROOM')    then is_price_for_room = :data;
      else if (:param_name = 'PACKET_ITEM')    then packet_item = :data;
      else if (:param_name = 'PTEXT')          then ptext = :data;
      else if (:param_name = 'DISC_TAG')       then disc_tag = :data;
      else if (:param_name = 'SET_VAR')        then set_var = :data;
      else if (:param_name = 'ROUND_TYPE')     then rnd_method = :data;
      if (:err_code < 0) then exit;
      if ((:id_tar_season <> -1) and (:iteration = 'MIDDLE')) then begin
        /* WE ARE STARTING THE SEASON PRICES SO: */
        board_weight = null;
        select m.WEIGHT_TAG
        from   MEALS M
        where  m.ID_BOARD = :id_board_include
        into   :board_weight;
        board_weight = coalesce(:board_weight, 0);

        insert into TAR_BO_BASE_POSITION(
          ID_TAR_BP, ID_TAR_HEAD, POSITION_NUMBER, ID_ROOM_TYPE, MAX_PERSONS, SET_VAR, RND_METHOD,
          ID_BOARD_INCLUDE, BOARD_WEIGHT, IS_PRICE_FOR_ROOM, PTEXT, PACKET_ITEM, DISC_TAG)
        values (
          :id_tar_bp, :id_tar_head, :position_number, :id_room_type, :max_persons, :set_var, :rnd_method,
          :id_board_include, :board_weight, :is_price_for_room, :ptext, :packet_item, :disc_tag);
       iteration = 'SEASON_PRICES';
      end
    end
    if (:iteration = 'SEASON_PRICES') then begin
      execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_bp, :bo_type, :id_tar_season)
      returning_values  :err_code, :no_use, :price_type;
      if (:err_code < 0) then exit;
    end
  end
  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:BO_TYPE||', '||:err_text;
  end
end
^

/* Restore proc. body: TAR_SAVE_BO_DISC */
ALTER PROCEDURE TAR_SAVE_BO_DISC(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_disc integer;
  declare variable pos_numbers varchar(2000);
  declare variable id_service integer;
  declare variable prioritet integer;
  declare variable day_scheme varchar(20);
  declare variable day_scheme_num integer;
  declare variable price_type varchar(20);
  declare variable price varchar(2000);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable calc_type varchar(20);
  declare variable calc_list varchar(2000);
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  err_text = '';
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      if (:price = '') then err_code = -219;
      if (:err_code < 0) then exit;
      rnd_method = iif(coalesce(:rnd_method, '') = '', 'NONE', :rnd_method);
      insert into TAR_BO_DISCOUNT (
        ID_TAR_DISCOUNT, ID_TAR_HEAD, PRIORITET, DAY_SCHEME, DAY_SCHEME_NUM, DISC_TAG, SET_VAR, RND_METHOD,
        /*IS_IN_BASE_PRICE,*/  CALC_LIST, ID_SERVICE, PTEXT, PACKET_ITEM)
      values (
        :id_tar_disc, :id_tar_head, :prioritet, :day_scheme, :day_scheme_num, :disc_tag, :set_var, :rnd_method,
        /*:in_base_price,*/ :calc_list, :id_service, :ptext, :packet_item);
      param_filter = :data||:season_filter;
      execute procedure tar_save_parse_param(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure tar_save_parse_pnum(:id_tar_head, :id_tar_disc, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_disc = gen_id(GEN_TAR_BO_DISCOUNT_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers   = '';
      id_service    = -1;
      day_scheme     = 'EVERY';
      day_scheme_num = 1;
      calc_type     = 'NONE';
      calc_list     = '';
      price         = '';
      prioritet     = 1;
      ptext         = '';
      disc_tag      = '';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      --in_base_price = 0;
      packet_item   = null;
    end
    if (:param_name = 'SERVICE')            then begin
      if (:data = '') then id_service = -1;
      else id_service = :data;
    end else if (:param_name = 'PTEXT')     then ptext = :data;
    else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
    else if (:param_name = 'SET_VAR')       then set_var = :data;
    else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
    else if (:param_name = 'PRIORITET')     then prioritet     = :data;
    --else if (:param_name = 'IN_BASE_PRICE') then in_base_price = :data;
    else if (:param_name = 'PACKET_ITEM')   then packet_item   = :data;
--    else if (:param_name = 'PRICE_NOTEQUAL') then begin
    else if (:param_name = 'PRICE_FORMULA') then begin
      price = trim(:data);
      /*if ((:id_service > 0) and (:in_base_price = 1) and (substring(:price from 1 for 1) = '-')) then err_code = -240;
      else*/ if (:price = '') then err_code = -219;
      else
        execute procedure tar_save_parse_price(:price, :id_tar_disc, :bo_type, -1)
        returning_values  :err_code, :no_use, :price_type;
    end else if (:param_name = 'LIST_BASE_POS') then pos_numbers   = :data;
    else if (:param_name = 'DAY_SCHEME') then begin
      execute procedure tar_save_parse_dayschm(:data)
      returning_values  :err_code, :day_scheme, :day_scheme_num;
    end else if (:param_name = 'CALC_TYPE') then begin
      calc_list = :data;
--      execute procedure tar_save_parse_calctype(:data)
--      returning_values  :err_code, :calc_type, :calc_list;
    end else if (:param_name = 'CHECKIN_SEASON') then begin
      execute procedure tar_save_parse_season(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end else if (:param_name = 'NIGHT_SEASON') then begin
      execute procedure tar_save_parse_season(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end
    if (:err_code < 0) then exit;
  end
/*  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
  end*/
end
^

/* Restore proc. body: TAR_SAVE_BO_DISC_PERIOD */
ALTER PROCEDURE TAR_SAVE_BO_DISC_PERIOD(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_disc integer;
  declare variable pos_numbers varchar(2000);
  declare variable id_service integer;
  declare variable prioritet integer;
  declare variable calc_position varchar(20);
  declare variable price_type varchar(20);
  declare variable price varchar(2000);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable calc_list varchar(2000);
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  err_text = 'OBJECT='||:bo_type;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      if (:price = '') then err_code = -219;
      if (:calc_position = '') then err_code = -244;
      if (:err_code < 0) then exit;
      insert into TAR_BO_DISCOUNT_STAY (ID_TAR_DISCOUNT_STAY, ID_TAR_HEAD, PRIORITET, CALC_POSITION,
             CALC_LIST, ID_SERVICE, PTEXT, DISC_TAG, SET_VAR, RND_METHOD)
      values (:id_tar_disc, :id_tar_head, :prioritet, :calc_position,
             :calc_list, :id_service, :ptext, :disc_tag, :set_var, :rnd_method);

      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_disc, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration = 'MIDDLE';
      id_tar_disc = gen_id(GEN_TAR_BO_DISCOUNT_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers   = '';
      id_service    = -1;
      calc_list     = '';
      price         = '';
      prioritet     = 1;
      calc_position = 'GUEST_PERIOD';
      ptext         = '';
      disc_tag      = '';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
    end
    if (:param_name = 'SERVICE')            then begin
      if (:data = '') then id_service = -1;
      else id_service = :data;
    end else if (:param_name = 'PTEXT')     then ptext = :data;
    else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
    else if (:param_name = 'SET_VAR')       then set_var = :data;
    else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
    else if (:param_name = 'PRIORITET')     then prioritet     = :data;
    else if (:param_name = 'PERIOD_BASE_TYPE')    then calc_position = :data;
    else if (:param_name = 'PRICE_FORMULA') then begin
      price = trim(:data);
      if (:price = '') then err_code = -219;
      else begin
        execute procedure TAR_SAVE_PARSE_PRICE(:price, :id_tar_disc, :bo_type, -1)
        returning_values  :err_code, :no_use, :price_type;
        if (:err_code < 0) then exit;
      end
    end else if (:param_name = 'LIST_BASE_POS') then pos_numbers   = :data;
    else if (:param_name = 'CALC_TYPE') then begin
      calc_list = :data;
--      execute procedure tar_save_parse_calctype(:data)
--      returning_values  :err_code, :calc_type, :calc_list;
    end else if (:param_name = 'CHECKIN_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end else if (:param_name = 'NIGHT_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end
    if (:err_code < 0) then exit;
  end
  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
--    exception;
  end
end
^

/* Restore proc. body: TAR_SAVE_BO_EG */
ALTER PROCEDURE TAR_SAVE_BO_EG(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable id_tar_season integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_eg integer;
  declare variable pos_numbers varchar(2000);
  declare variable min_payors integer;
  declare variable max_extra_guests integer;
  declare variable order_num integer; /* !!!! */
  declare variable id_price_bb integer;
  declare variable id_price_eb integer;
  declare variable price_type varchar(20);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable is_packet_reduction integer;
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :id_tar_season, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_eg, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_eg = gen_id(GEN_TAR_BO_EG_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers = '';
      min_payors  = null;
      id_price_eb = -1;
      id_price_bb = -1;
      order_num   = 99;
      ptext       = '';
      disc_tag    = '';
      set_var = '';
      is_packet_reduction = 0;
      rnd_method = 'MATH';
      season_filter = '';
      max_extra_guests = null;
      packet_item = null;
    end
    if (:iteration = 'MIDDLE') then begin
      if (:param_name = 'LIST_BASE_POS')   then pos_numbers = :data;
      else if (:param_name = 'SET_VAR')    then set_var = :data;
      else if (:param_name = 'ROUND_TYPE') then rnd_method = :data;
      else if (:param_name = 'MIN_PAYORS') then begin
        if (:data = '') then err_code = -213;
        else min_payors = :data;
      end else if (:param_name = 'MAX_EG') then begin
        if (:data = '') then err_code = -214;
        else max_extra_guests = :data;
      end else if (:param_name = 'EG_ORDER')   then begin
        if (:data = '') then order_num = 99;
        else order_num = :data;
        if (:order_num < 1) then err_code = -215;
      end else if (:param_name = 'CHECKIN_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'NIGHT_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'PTEXT')     then ptext = :data;
      else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
      else if (:param_name = 'EG_POST_TYPE')  then is_packet_reduction = :data;
      else if (:param_name = 'PACKET_ITEM')   then packet_item = :data;
      else if (:param_name = 'BB_PRICE')   then begin
        if (:data <> '') then begin
          execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_eg, :bo_type, -1)
          returning_values  :err_code, :id_price_bb, :price_type;
          if ((:board_type = 'HRANI') and (:price_type <> 'PERCENT')) then begin
            err_code = -227;
            exit;
          end
        end
      end else if (:param_name = 'EB_PRICE') then begin
        if (:data <> '') then begin
          execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_eg, :bo_type, -1)
          returning_values  :err_code, :id_price_eb, :price_type;
          if ((:board_type = 'HRANI') and (:price_type <> 'PERCENT')) then begin
            err_code = -227;
            exit;
          end
        end
      end
      if (:err_code < 0) then exit;
      if ((:id_tar_season <> -1) and (:iteration = 'MIDDLE')) then begin
        if (:min_payors is null) then err_code = -213;
        if (:max_extra_guests is null) then err_code = -214;
        if (:err_code < 0) then exit;
        /* WE ARE STARTING THE SEASON PRICES SO: */
        insert into TAR_BO_EXTRA_GUEST(
          ID_TAR_EG, ID_TAR_HEAD, MIN_PAYORS, MAX_EXTRA_GUESTS, EG_ORDER, IS_PACKET_REDUCTION,
          ID_PRICE_BB, ID_PRICE_EB, PTEXT, PACKET_ITEM, DISC_TAG, SET_VAR, RND_METHOD)
        values (
          :id_tar_eg, :id_tar_head, :min_payors, :max_extra_guests, :order_num, :is_packet_reduction,
          :id_price_bb, :id_price_eb, :ptext, :packet_item, :disc_tag, :set_var, :rnd_method);
        iteration = 'SEASON_PRICES';
      end
    end
    if (:iteration = 'SEASON_PRICES') then begin
      execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_eg, :bo_type, :id_tar_season)
      returning_values  :err_code, :no_use, :price_type;
      if (:err_code < 0) then exit;
    end
  end
  when any do begin
    err_code = -200;
    err_text = ''||:iteration||' '||:id_price_bb||' '||:id_price_eb;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
/*    err_text = ' '||:min_payors||' '||:max_extra_guests||' '||:order_num;*/
  end
end
^

/* Restore proc. body: TAR_SAVE_BO_PACK */
ALTER PROCEDURE TAR_SAVE_BO_PACK(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_pack integer;
  declare variable pos_numbers varchar(2000);
  declare variable id_service integer;
  declare variable day_scheme varchar(20);
  declare variable day_scheme_num integer;
  declare variable cnt_post integer;
  declare variable pack_currency char(3);
  declare variable in_base_price integer;
  declare variable grp_rpt varchar(20);
  declare variable grp_docs varchar(20);
  declare variable price_type varchar(20);
  declare variable price_pack varchar(20);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      if (:price_pack = '') then err_code = -216;
      if (:id_service is null) then err_code = -217;
      if (:err_code < 0) then exit;
      insert into TAR_BO_PACK(
        ID_TAR_PACK, ID_TAR_HEAD, ID_SERVICE, PRICE_CURRENCY, IS_IN_BASE_PRICE,
        CNT_POST,  DAY_SCHEME, DAY_SCHEME_NUM, GRP_IN_REPORTS,
        GRP_IN_DOCUMENTS, PTEXT, PACKET_ITEM, DISC_TAG, SET_VAR, RND_METHOD)
      values (
        :id_tar_pack, :id_tar_head, :id_service, :pack_currency, :in_base_price,
        :cnt_post, :day_scheme, :day_scheme_num, :grp_rpt,
        :grp_docs, :ptext, :packet_item, :disc_tag, :set_var, :rnd_method);
      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_pack, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_pack = gen_id(GEN_TAR_BO_PACK_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers   = '';
      id_service    = null;
      day_scheme     = 'EVERY';
      day_scheme_num = 1;
      cnt_post      = 0;
/*
        select TH.TARIFA_CURR
        from   TAR_HEAD TH
        where  TH.ID_TAR_HEAD = :id_tar_head
        into   :pack_currency;
*/    pack_currency = '';
      in_base_price = 0;
      grp_rpt       = '';
      grp_docs      = '';
      price_pack    = '';
      ptext         = '';
      disc_tag      = '';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      packet_item   = null;
    end
    if (:param_name = 'SERVICE') then begin
      if ((:data = '') or (:data = '-1')) then err_code = -217;
      else if (:data = '0') then err_code = -222;
      else id_service = :data;
    end else if (:param_name = 'CNT_POST')  then cnt_post      = :data;
    else if (:param_name = 'IN_BASE_PRICE') then in_base_price = :data;
    else if (:param_name = 'GRP_RPT')       then grp_rpt       = :data;
    else if (:param_name = 'GRP_DOCS')      then grp_docs      = :data;
    else if (:param_name = 'PTEXT')         then ptext         = :data;
    else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
    else if (:param_name = 'SET_VAR')        then set_var = :data;
    else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
    else if (:param_name = 'PACKET_ITEM')   then packet_item   = :data;
    else if (:param_name = 'PRICE')         then begin
      price_pack    = :data;
      if (:price_pack = '') then err_code = -216;
      else
        execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_pack, :bo_type, -1)
        returning_values  :err_code, :no_use, :price_type;
    end else if (:param_name = 'LIST_BASE_POS') then pos_numbers   = :data;
    else if (:param_name = 'CURRENCY') then begin
      if ((:data <> upper(:data)) or (char_length(:data) <> 3)) then err_code = -218;
      else pack_currency = :data;
    end else if (:param_name = 'DAY_SCHEME') then begin
      execute procedure TAR_SAVE_PARSE_DAYSCHM(:data)
      returning_values  :err_code, :day_scheme, :day_scheme_num;
    end else if (:param_name = 'CHECKIN_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end else if (:param_name = 'NIGHT_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end
    if (:err_code < 0) then exit;
  end
  when any do begin
    err_code = -200;
/*    err_text = ' '||:id_service||' '||:pack_currency||' '||:in_base_price;*/
/*    err_text = ' '||:day_scheme||' '||:day_scheme_num;*/
    err_text = ' '||:cnt_post||' '||:grp_rpt||' '||:grp_docs||' '||:ptext;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
  end
end
^

/* Alter Procedure... */
/* Alter (ACC_STATEMENT_INVOICES_GET$PMS) */
ALTER PROCEDURE ACC_STATEMENT_INVOICES_GET$PMS(ID_BILL INTEGER)
 RETURNS(ID_DOC INTEGER,
ID_SERVICE INTEGER,
DATE_POST DATE,
ROOM_NAME VARCHAR(100),
LINE_DESC VARCHAR(100),
OUTGO_VALUE NUMERIC(15,4),
CURR_POST VARCHAR(3),
IS_ANUL SMALLINT,
INV_DESCRIPTION VARCHAR(100))
 AS
declare variable id_hotel integer;
  declare variable sign_ smallint;
  declare variable doc_sub_type smallint;
begin

  for
    select distinct DL.ID_DOC_HEAD, DH.DOC_SUB_TYPE, O.ID_CURRENCY,
           DT.DOC_TYPE_NAME || ' ' || DH.DOC_NUM || ', ' || formatdate(DH.DOC_DATE,'D;dd/mm/yyyy'),
           DH.IS_ANUL, B.ID_SERVICE, a.ID_HOTEL
    from   OWNER_BILL_ROW$PMS B
           join OWNER_BILL$PMS BH on BH.ID_OWNER_BILL = B.ID_OWNER_BILL
           join OWNER$PMS O on O.ID_OWNER = BH.ID_OWNER
           join DOC_LINE_POST_VALUES PV on B.ID_ACCOUNT_POST = PV.ID_ACCOUNT_POST
           join DOC_LINE DL on PV.ID_DOC_LINE = DL.ID_DOC_LINE
           join DOC_HEAD DH on DH.ID_DOC = DL.ID_DOC_HEAD
           join ACCOUNT A on A.ID_ACCOUNT = dh.ID_ACCOUNT
           join DOC_TYPE DT on DT.ID_DOC_TYPE = DH.ID_DOC_TYPE
    where  B.ID_OWNER_BILL = :ID_BILL
           and B.ID_ACCOUNT_POST is not null
    into   :id_doc, :doc_sub_type, :CURR_POST, :INV_DESCRIPTION, :IS_ANUL, :ID_SERVICE, :id_hotel
  do begin
    select case when SGV.SETTING_VALUE = 'AS_POSITIVE' and :DOC_SUB_TYPE = 2 then -1 else 1 end
    from   SETTING_GET_VALUE('VIEW_STORNO_SUMS_IN_DOCUMENTS', :id_hotel) SGV
    into   :sign_;

    for
      select
        DL.LINE_NAME,
        DL.ROOM_NAME,
        DL.DATE_POST,
        DL.LINE_VALUE as line_sum
      from
        DOC_LINES_SUSPEND (:ID_DOC, :sign_, '', 'details', 'acc', 'as_doc', 0) DL
      order by
        DL.IS_FOR_PAY asc, DL.DATE_POST, DL.IS_BASE desc, DL.ROOM_NAME, DL.LINE_NAME asc
      into :LINE_DESC,
           :ROOM_NAME,
           :DATE_POST,
           :OUTGO_VALUE
    do begin
      suspend;
    end
  end

end
^

/* Alter (ACCOUNT_CHECK_CREDIT_STATUS$INT) */
ALTER PROCEDURE ACCOUNT_CHECK_CREDIT_STATUS$INT(ID_ACCOUNT TYPE OF ID_REF,
POST_VALUE TYPE OF TPRICE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_credit_account integer;
  declare variable id_reserv_detail integer;
  declare variable credit_limit tprice;
  declare variable b_post_sum tprice;
  declare variable b_pay_sum tprice;
  declare variable difference_value tprice;
  declare variable no_use varchar(255);
  declare variable account_currency tcurrency;
  declare variable round_to numeric(15,4);
begin
  if (:POST_VALUE = 0) then exit;

  select a.IS_CREDIT_ACCOUNT, a.CREDIT_LIMIT, a.ID_RESERV_DETAIL
  from   ACCOUNT A
  where  a.ID_ACCOUNT = :ID_ACCOUNT
  into   :is_credit_account, :credit_limit, :id_reserv_detail;

  if (:is_credit_account = 0
      and exists (select rd.ID_RESERV_DETAIL
                  from   RESERV_DETAIL rd
                  where  rd.ID_RESERV_DETAIL = :id_reserv_detail
                         and rd.CHECK_STATUS = 1)) then
  begin
    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, :credit_limit, 1);
  end

  if (coalesce(:credit_limit, 0) > 0) then begin
    /* FIND BALANCE OF ACCOUNT */
    execute procedure ACCOUNT_BALANCE$INT(:id_account)
    returning_values  :account_currency, :round_to, :no_use, :b_post_sum, :b_pay_sum, :no_use, :no_use;
    b_post_sum = coalesce(:b_post_sum, 0);
    b_pay_sum  = coalesce(:b_pay_sum, 0);

    /* IS THIS POST IS IN LIMIT */
    if ((:b_post_sum + :POST_VALUE) > :credit_limit) then begin
      err_code = -13; /*  */
      difference_value = :b_post_sum + :POST_VALUE - :credit_limit;
      err_text = f_character(29)||FormatFloat(:credit_limit, :round_to)||' '||:account_currency||
                 f_character(28)||FormatFloat(:difference_value, :round_to);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: OWNER_ACCOUNT_GET$INT for: ACCOUNT_CREATE_PMS$PMS */
ALTER PROCEDURE OWNER_ACCOUNT_GET$INT(ID_OWNER /* TYPE OF ID */ INTEGER,
ID_HOTEL /* TYPE OF ID */ INTEGER,
IS_SHADOW_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT,
IS_CLIENT_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT)
 RETURNS(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
IS_ACCOUNT$PMS /* TYPE OF TLOGICAL */ SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_OWNER_MODIFY$PMS for: ACCOUNT_CREATE_PMS$PMS */
ALTER PROCEDURE ROOM_OWNER_MODIFY$PMS(ID_ROOM_OWNER INTEGER,
ID_ROOM_CONTRACT INTEGER,
ID_OWNER INTEGER,
OWNERSHIP_PERCENT NUMERIC(15,4),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_OWNER INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_CREATE_PMS$PMS) */
ALTER PROCEDURE ACCOUNT_CREATE_PMS$PMS(ID_OWNER INTEGER,
ID_ACC_TEMPLATE INTEGER,
ID_CURRENCY CHAR(3),
ID_HOTEL INTEGER)
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
declare variable hotel_name varchar(50);
  declare variable account_name varchar(50);
  declare variable is_owner_pool smallint;
  declare variable is_credit_account integer;
  declare variable credit_limit numeric (15,4);
  declare variable sec_level integer;
  declare variable is_pos_allowed integer;
  declare variable id_tax_policy integer;
begin
  -- klientska smetka za pool ne triabwa da se syzdawa!
  select iif(O.ID_RENTAL_POOL_UNIT is null, 0, 1)
  from   OWNER$PMS O
  where  O.ID_OWNER = :ID_OWNER
  into   :is_owner_pool;
  if (:is_owner_pool = 1) then exit;

  select H.HOTEL_NAME
  from   HOTEL H
  where  H.ID_HOTEL = :ID_HOTEL
  into   :hotel_name;
  account_name = substring('Owner account - '||:hotel_name from 1 for 50);

  if (:ID_ACC_TEMPLATE is null) then begin
    select sv.SETTING_VALUE
    from   SETTING_GET_VALUE ('DEF_OWNER_ACC_TEMPLATE', :ID_HOTEL) sv
    into   :id_acc_template;

    if (not exists (select t.ID_ACC_TEMPLATE
                    from   ACC_TEMPLATE t
                    where  t.ID_ACC_TEMPLATE = :ID_ACC_TEMPLATE
                           and t.ID_HOTEL = :ID_HOTEL)) then
    begin
      select sv.SETTING_VALUE
      from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :id_hotel) sv
      into   :id_acc_template;
    end
  end

  is_credit_account = null;
  select ACT.IS_CREDIT_ACCOUNT, ACT.CREDIT_LIMIT, ACT.SECURITY_LEVEL,
         ACT.IS_ALOWED_POS_INTERFACE, ACT.ID_TAX_POLICY
  from   ACC_TEMPLATE ACT
  where  ACT.ID_ACC_TEMPLATE = :id_acc_template
         and act.ID_HOTEL = :id_hotel
  into   :is_credit_account, :credit_limit, :sec_level,
         :is_pos_allowed, :id_tax_policy;

  if (:is_credit_account is null) then exception ACCOUNT_EXCEPTION '-50';

  execute procedure ACCOUNT_MODIFY$INT (null, :ID_OWNER, :ID_CURRENCY, :account_name, 1, :credit_limit,
          null, null, 0, null, :sec_level, 1, 1, :is_pos_allowed, null,
          null, :id_tax_policy, null, :ID_HOTEL, null, 1, 'add')
  returning_values (:NEW_ID_ACCOUNT);
end
^

/* Alter (ACCOUNT_MODIFY$INT) */
ALTER PROCEDURE ACCOUNT_MODIFY$INT(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL TYPE OF ID_REF,
IS_PMS_ACCOUNT TYPE OF TLOGICAL,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
declare variable a_dbkey char(8);
  declare variable old_sec_level integer;
  declare variable action_text varchar(255);
  declare variable old_acc_name varchar(50);
  declare variable old_acc_curr varchar(3);
  declare variable old_tax_policy integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, archive');

  new_id_account = :id_account;
  if (:operation = 'add') then begin
    if ((:new_id_account is null) or (:new_id_account <= 0)) then new_id_account = gen_id(ID_ACCOUNT_GEN, 1);

    insert into ACCOUNT(ID_ACCOUNT, ACCOUNT_CURR, ACCOUNT_NAME, IS_CREDIT_ACCOUNT, CREDIT_LIMIT,
           ID_TYPE_PAYMENT, NOTE, IS_BLOCKED, BLOCK_TEXT, SECURITY_LEVEL, IS_BASE, IS_EXTRA,
           IS_ALOWED_POS_INTERFACE, POS_INTERFACE_NOTE, EXT_CODE, ID_TAX_POLICY, ID_PROFILE,
           ID_HOTEL, IS_DEFAULT, IS_PMS_ACCOUNT, ID_RESERV_DETAIL)
    values (:new_id_account, :account_curr, :account_name, 0, null,
           :id_type_payment, :note, :is_blocked, :block_text, :security_level, :is_base, :is_extra,
           :is_alowed_pos_interface, :pos_interface_note, :ext_code, :id_tax_policy, :id_profile,
           :id_hotel, :is_default, coalesce(:IS_PMS_ACCOUNT, 0), :ID_RESERV_DETAIL)
    returning RDB$DB_KEY
    into   :a_dbkey;

    action_text = f_character(29) || :new_id_account || '/' || :account_name;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'ADD_ACCOUNT', :action_text);

    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:NEW_ID_ACCOUNT, :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT);
    -- check special right and log event

  end else begin
    ID_RESERV_DETAIL = null;
    select A.RDB$DB_KEY, A.ID_RESERV_DETAIL, A.SECURITY_LEVEL,
           A.ACCOUNT_NAME, A.ACCOUNT_CURR, A.ID_TAX_POLICY
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :a_dbkey, :id_reserv_detail, :old_sec_level,
           :old_acc_name, :old_acc_curr, :old_tax_policy;
    if (:operation = 'mod') then begin
  
      update ACCOUNT A
      set    A.ACCOUNT_NAME = :account_name,
             A.ID_TYPE_PAYMENT = :id_type_payment,
             A.NOTE = :note,
             A.IS_BLOCKED = :is_blocked,
             A.BLOCK_TEXT = :block_text,
             A.SECURITY_LEVEL = :security_level,
             A.IS_BASE = :is_base,
             A.IS_EXTRA = :is_extra,
             A.IS_ALOWED_POS_INTERFACE = :is_alowed_pos_interface,
             A.POS_INTERFACE_NOTE = :pos_interface_note,
             A.EXT_CODE = :ext_code,
             A.ID_TAX_POLICY = :id_tax_policy,
             A.IS_DEFAULT = :is_default
      where  A.RDB$DB_KEY = :a_dbkey;
  
      execute procedure ACCOUNT_SET_CURRENCY$INT (:a_dbkey, :account_curr);
  
      if (:old_acc_name <> :account_name) then begin
        action_text = f_character(29 ) || :ID_ACCOUNT || '/' || :old_acc_name || ', ' || :old_acc_curr
                      || f_character(28) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME || ', ' || :ACCOUNT_CURR;
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'EDIT_ACCOUNT', :action_text);
      end
  
      if (:old_sec_level <> :SECURITY_LEVEL) then begin
        action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME
                      || f_character(28) || :SECURITY_LEVEL;
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'SET_ACC_SEC_LEVEL', :action_text);
      end
  
      if (:old_tax_policy <> :id_tax_policy) then begin
        execute procedure ACCOUNT_TAXATION_RECALC$INT (:ID_ACCOUNT, :ID_TAX_POLICY);
  
        action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME;                        
  
        select :action_text || f_character(28) || OTP.POLICY_NAME
        from   TAX_POLICY OTP
        where  OTP.ID_TAX_POLICY = :old_tax_policy
        into   :action_text;
        select :action_text || f_character(28) || NTP.POLICY_NAME
        from   TAX_POLICY NTP
        where  NTP.ID_TAX_POLICY = :ID_TAX_POLICY
        into   :action_text;
         
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'VAT_POLICY_CHNG', :action_text);
      end
  
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:ID_ACCOUNT, :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT); -- check special right and log event
  
    end else if (:operation = 'archive') then begin
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 1);

    end
  end

  if ((:id_reserv_detail is null) and (:IS_CREDIT_ACCOUNT = 0)) then begin
    exception ACCOUNT_EXCEPTION '-1010';
    -- The account must have active credit status
    exit;
  end

  if (:is_default = 1) then begin
    update ACCOUNT A
    set    A.IS_DEFAULT = 0
    where  A.ID_HOTEL = :id_hotel
           and A.ID_PROFILE = :id_profile
           and A.ID_ACCOUNT <> :new_id_account;
  end
end
^

/* Alter (ACCOUNT_POST_MODIFY$PMS) */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
declare variable id_account integer;
  declare variable id_service integer;
  declare variable date_post date;
  declare variable is_owner_income smallint;
  declare variable is_account_post_item smallint;
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable no_use_id_acc_post integer;
  declare variable ap_dbkey char(8);
begin
  -- da se wika samo ot GUI
  if ( (:ID_ACCOUNT_POST is null) and (:ID_ACCOUNT_POST_PMS is null) ) then begin
    exception WRONG_PARAM_VALUE;
    exit;
  end

  is_account_post_item = iif(:id_account_post is not null, 1, 0);

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'mod, anul');

  if (:operation in ('mod', 'anul')) then begin
    -- prowerka: ot GUI-to mogat da se anulirat samo nedokumentirani i neanulirani nachisleniq
    if (:is_account_post_item = 1) then begin
      if ( (:ID_PMS_EVENT > 0) and
           not exists ( select *
                        from   PMS_EVENT_POST PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      select ap.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  ap.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
      into   :ap_dbkey;

      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_dbkey, 'PMS GUI VOID');

      update PMS_EVENT_POST PP
      set    PP.LINE_STATUS = 22
      where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST;

    end else if (:ID_ACCOUNT_POST_PMS is not null) then begin
      if ( not exists ( select *
                        from   ACCOUNT_POST$PMS PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      execute procedure ACCOUNT_POST_PMS_ANUL$INT(:ID_PMS_EVENT, :ID_ACCOUNT_POST_PMS);
    end

    if (:operation = 'mod') then begin
      id_account = null;
      if (:is_account_post_item = 1) then begin
        select AP.ID_ACCOUNT, AP.ID_SERVICE, AP.DATE_POST, PP.ID_OWNER, 0, ap.id_room
        from   ACCOUNT_POST AP
               join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and PP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :id_owner, :is_owner_income, :id_room;
      end else begin
        select AP.ID_ACCOUNT_PMS, AP.ID_SERVICE, AP.DATE_POST, AP.IS_OWNER_INCOME, AP.ID_OWNER
        from   ACCOUNT_POST$PMS AP
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
               and AP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :is_owner_income, :id_owner;
      end
      if (:id_account is null) then exit;

      execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_account, :id_service, :id_owner, :date_post,
              :in_curr_orig, :in_value_orig, 1 - :is_account_post_item, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_VALIDATE$DOC for: ACCOUNT_POSTING_DOC_UPDATE$INT */
ALTER PROCEDURE DOCUMENT_VALIDATE$DOC(ID_DOC_HEAD /* TYPE OF ID_REF */ INTEGER)
 RETURNS(FIRM_DATA /* TYPE OF TNOTE_BLOB */ BLOB SUB_TYPE 1,
WARN_CODE /* TYPE OF TRANGE */ INTEGER,
NEW_DOC_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_POSTING_DOC_UPDATE$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_DOC_UPDATE$INT(DH_DBKEY TYPE OF TDB_KEY)
 RETURNS(WARN_CODE TYPE OF TRANGE)
 AS
declare variable date_post date;
  declare variable old_date_post date;
  declare variable curr_post varchar(3);
  declare variable old_curr_post varchar(3);
  declare variable rate_post numeric(15,6);
  declare variable curr_orig varchar(3);
  declare variable old_curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable dbkey char(8);
  declare variable id_account_post integer;
  declare variable doc_date date;
  declare variable doc_release_ap integer;
  declare variable qty_post numeric(15,2);
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable price_orig numeric(15,4);
  declare variable price_post double precision;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable id_sale_taxation integer;
  declare variable id_base_doc integer;
  declare variable doc_operation varchar(10);
  declare variable is_anul_doc integer;
  declare variable is_storno integer;
  declare variable id_doc_head integer;
  declare variable posts_value double precision;
  declare variable line_value double precision ;
  declare variable action_text varchar(255);
  declare variable action_code varchar(30);
  declare variable account_curr varchar(3);
  declare variable id_ap_base_doc integer;
  declare variable new_is_anul integer;
  declare variable new_is_closed integer;
  declare variable doc_qty numeric(15,2);
  declare variable doc_price double precision;
  declare variable id_hotel integer;
  declare variable round_to numeric(15,4);
  declare variable proforma_dt_created timestamp;
  declare variable new_ac varchar(2);
  declare variable id_tax_policy integer;
  declare variable id_service integer;
  declare variable nat_round_to numeric(15,4);
begin

  select D.ID_DOC_HEAD, iif(D.IS_ANUL = 0, D.DOC_DATE, DA.ANNULMENT_DATE),
         D.ID_BASE_DOC, D.IS_ANUL, D.IS_STORNO, a.ID_TAX_POLICY, c.ROUND_TO,
         A.ID_ACCOUNT, A.ACCOUNT_CURR, a.id_hotel, pd.DATETIME_CREATED
  from   DOC_HEAD$INT D
         join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join HOTEL h on h.ID_HOTEL = a.ID_HOTEL
         join CURRS c on c.CURR = h.NATION_CURR
         left outer join DOC_ANNULMENT DA on DA.ID_DOC_HEAD = D.ID_DOC_HEAD
         left outer join DOC_HEAD$INT pd on pd.ID_DOC_HEAD = dc.ID_DOC_PROFORMA
  where  D.RDB$DB_KEY = :DH_DBKEY
  into   :id_doc_head, :doc_date, :id_base_doc, :is_anul_doc, :is_storno, :id_tax_policy, :nat_round_to,
         :id_account, :account_curr, :id_hotel, :proforma_dt_created;

  if (:id_doc_head is null) then exit;

  doc_operation = case when :is_anul_doc = 1 then 'anul'
                       when :is_storno   = 1 then 'storno'
                       else 'new'
                  end;

  doc_release_ap = -gen_id(DOC_SELECTED_GEN, 1);
  /*   */
  posts_value = 0;
  if (:doc_operation = 'new') then begin
    for
      select AP.RDB$DB_KEY, AP.ID_ACCOUNT_POST, DL.QTY_POST, PV.ACCOUNT_PRICE,
             ap.QTY_POST, ap.PRICE_POST, c.ROUND_TO
      from   ACCOUNT_POST AP
             join DOC_LINE_POST_VALUES PV on PV.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
             join DOC_LINE DL on DL.ID_DOC_LINE = PV.ID_DOC_LINE
             join CURRS C on c.CURR = ap.CURR_POST
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
      into   :dbkey, :id_account_post, :doc_qty, :doc_price,
             :qty_post, :price_post, :round_to
    do begin
      /*  if (:is_anul = 1) - annul corrective document, else - new valid document */
      /* annulment/storno of base document is in other case - operation "anul"  */
      if (:proforma_dt_created is not null) then begin
        new_is_anul = 0;
        new_is_closed = iif(cast(round_f(:qty_post - :doc_qty, :round_to) as numeric(15,2)) = 0
                            and cast(round_f(:price_post - :doc_price, :round_to) as numeric(15,2)) = 0,
                            1,
                            0);
      end else begin
        new_is_anul = 0;
        new_is_closed = 1;
        doc_qty = :qty_post;
        doc_price = :price_post;
      end

      update ACCOUNT_POST AP
      set    AP.ID_BASE_DOC   = :id_base_doc,
             AP.IN_DOC_QTY    = :doc_qty,
             AP.IN_DOC_VALUE  = :doc_price,
             AP.IS_ANUL       = :new_is_anul,
             AP.AC            = :new_is_anul || :new_is_closed,
             AP.DOC_SELECTED  = :doc_release_ap,
             AP.DATETIME_CHANGED = current_timestamp
      where  AP.RDB$DB_KEY = :DBKEY
      returning ap.ac into :new_ac;
      if (:new_ac = '00') then begin
        execute procedure SYSTEM_WARNING_ADD (-1061, '')
        returning_values (:warn_code);
      end

      update ACCOUNT_POST_CORRECTION APCU
      set    APCU.ID_DOC_HEAD  = iif(apcu.DATETIME_CREATED < coalesce(:proforma_dt_created, current_timestamp), :ID_DOC_HEAD, -1),
             APCU.IS_OPEN      = iif(apcu.DATETIME_CREATED < coalesce(:proforma_dt_created, current_timestamp), 0, 1)
      where  APCU.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
             and coalesce(APCU.ID_DOC_HEAD, -1) = -1;

      posts_value = :posts_value + :doc_price * :doc_qty;
    end

    action_text = f_character(29) || formatfloat(abs(:posts_value), 'F;0.00') || ' ' || :account_curr;
    action_code = 'CLOSE_POSTINGS';
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, :action_code, :action_text);

  end else if (:doc_operation in ('anul', 'storno')) then begin
    /* annulment/storno of base document - release all postings */
    /*   */
    old_date_post = '01.01.1900';
    old_curr_post = '';
    old_curr_orig = '';
    posts_value = 0;
    /*   */
    for
      select distinct AP.RDB$DB_KEY, AP.ID_ACCOUNT, AP.ID_GUEST, AP.ID_SALE_TAXATION, AP.ID_BASE_DOC,
             AP.QTY_POST, AP.PRICE_POST, AP.DATE_POST, AP.CURR_POST, AP.CURR_ORIG, AP.PRICE_ORIG,
             AP.ID_ACCOUNT_POST, AP.POST_NET_VALUE, AP.POST_GROSS_VALUE, AP.RATE_POST, AP.RATE_ORIG,
             PV.ACCOUNT_PRICE * DL.QTY_POST, c.ROUND_TO, ap.ID_SERVICE
      from   ACCOUNT_POST AP
             join DOC_LINE_POST_VALUES PV on PV.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
             join DOC_LINE DL on DL.ID_DOC_LINE = PV.ID_DOC_LINE
             join CURRS C on c.CURR = ap.CURR_POST
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
      order by AP.DATE_POST, AP.CURR_POST, AP.CURR_ORIG
      into   :dbkey, :id_account, :id_guest, :id_sale_taxation, :id_ap_base_doc,
             :qty_post, :price_post, :date_post, :curr_post, :curr_orig, :price_orig,
             :id_account_post, :post_net_value, :post_gross_value, :rate_post, :rate_orig,
             :line_value, :round_to, :id_service
    do begin
      if (:id_ap_base_doc is not null and :id_ap_base_doc is distinct from :id_base_doc) then
        exception DOCUMENT_EXCEPTION '-365';

      doc_qty = null;
      doc_price = 0;
      if (:DOC_OPERATION = 'anul') then begin
        select sum(DL.QTY_POST * (1 - DL.IS_CORRECT)) as DOC_QTY,
               sum(DLP.ACCOUNT_PRICE * DL.QTY_POST) /* / sum(DL.QTY_POST * (1 - DL.IS_CORRECT))*/ as DOC_VALUE
        from   DOC_HEAD DH
               join DOC_LINE DL on DL.ID_DOC_HEAD = DH.ID_DOC
               join DOC_LINE_POST_VALUES DLP on dlp.ID_DOC_LINE = dl.ID_DOC_LINE
        where  DH.IS_ANUL = 0
               and DLP.ID_ACCOUNT_POST = :id_account_post
               and DH.ID_BASE_DOC = :id_base_doc
        into   :doc_qty, :doc_price;
        if (:doc_qty = 0) then doc_price = 0;
        else doc_price = :doc_price / :doc_qty;
      end

      if (:doc_qty is null) then begin
        -- update prices only for released posting
        select tp.ID_SALE_TAXATION
        from   SERVICE_TAXATION tp
        where  tp.ID_TAX_POLICY = :id_tax_policy
               and tp.ID_SERVICE = :id_service
        into   :id_sale_taxation;  -- get actual taxation

        if (:date_post >= :doc_date) then begin
          /* update rates for prepaid postings (date_post >= doc_date) if base doc is annul */
          if ((:old_date_post <> :date_post) or (:old_curr_post <> :curr_post) ) then begin
            execute procedure ACCOUNT_POSTING_RATE_GET (:id_hotel, :curr_post, :date_post, :id_guest)
            returning_values  :RATE_POST;
          end
    
          if ((:OLD_DATE_POST <> :DATE_POST) or (:OLD_CURR_ORIG <> :CURR_ORIG) ) then begin
            execute procedure ACCOUNT_POSTING_RATE_GET (:id_hotel, :curr_orig, :date_post, :id_guest)
            returning_values  :rate_orig;
          end
  
          execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:qty_post, :price_orig,
                            :rate_orig, :rate_post, :id_sale_taxation)
          returning_values  :price_post, :post_net_value, :post_gross_value;
        end else begin
          -- recalc only nat net value with actual taxation
          select tv.VALUE_WOT_TAX
          from   TAX_VALUE_DEDUCT (:qty_post * :price_post * :rate_post, :nat_round_to, :id_sale_taxation) tv
          into   :post_net_value;
        end
      end

      new_is_anul = iif(:qty_post = 0 and :doc_qty is null, 1, 0);
      new_is_closed = iif(:doc_qty is not null
                          and cast(round_f(:qty_post - :doc_qty, :round_to) as numeric(15,2)) = 0
                          and cast(round_f(:price_post - :doc_price, :round_to)  as numeric(15,2)) = 0,
                          1,
                          0);

      update ACCOUNT_POST AP
      set    AP.IN_DOC_VALUE  = iif(:doc_qty is null, 0, :doc_price),
             AP.IN_DOC_QTY    = iif(:doc_qty is null, 0, :doc_qty),
             AP.RATE_ORIG     = :rate_orig,
             AP.RATE_POST     = :rate_post,
             AP.PRICE_POST    = :price_post,
             AP.POST_NET_VALUE = :post_net_value,
             AP.POST_GROSS_VALUE = :post_gross_value,
             AP.ID_SALE_TAXATION  = :id_sale_taxation,
             AP.ID_BASE_DOC   = iif(:doc_qty is null, null, :ID_BASE_DOC),
             AP.IS_ANUL       = :new_is_anul,
             AP.AC            = :new_is_anul || :new_is_closed,
             AP.ANUL_DATETIME = iif(:new_is_anul = 1, current_timestamp, ap.anul_datetime),
             AP.DATETIME_CHANGED = current_timestamp
      where  AP.RDB$DB_KEY = :DBKEY;

      if (:doc_operation = 'anul') then begin
        update ACCOUNT_POST_CORRECTION APCU
        set    APCU.ID_DOC_HEAD  = -1,
               APCU.IS_OPEN      = iif(:DOC_QTY is not null, 1, apcu.IS_OPEN)
        where  APCU.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and APCU.ID_DOC_HEAD = :ID_DOC_HEAD;
      end else begin  -- 'storno'
        update ACCOUNT_POST_CORRECTION APCU
        set    APCU.ID_DOC_HEAD  = -1,
               APCU.IS_OPEN      = iif(:DOC_QTY is not null, 1, apcu.IS_OPEN)
        where  APCU.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and APCU.ID_DOC_HEAD in (select d.ID_DOC from DOC_HEAD d where d.ID_BASE_DOC = :id_base_doc);
      end

      old_curr_post = :curr_post;
      old_curr_orig = :curr_orig;

      posts_value = :posts_value + :line_value;
    end  /* for select ... do begin  */

    action_text = f_character(29) || formatfloat(abs(:posts_value), 'F;0.00') || ' ' || :account_curr;
    action_code = 'OPEN_POSTINGS';
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, :action_code, :action_text);
  end  /* call type in (STORNO, ANUL)  */
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE_RATE$INT for: ACCOUNT_POSTING_PRICE_CALC$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_RATE$INT(AP_DBKEY CHAR(8),
CURRENCY_ VARCHAR(3),
NEW_RATE NUMERIC(15,6))
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_PRICE_CALC$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_PRICE_CALC$INT(QTY_POST TYPE OF TQTY,
PRICE_ORIG TYPE OF TVALUE,
RATE_ORIG TYPE OF TRATE,
POST_RATE TYPE OF TRATE,
ID_SALE_TAXATION TYPE OF ID_REF)
 RETURNS(PRICE_POST DOUBLE PRECISION,
POST_NET_VALUE NUMERIC(15,4),
POST_GROSS_VALUE NUMERIC(15,4))
 AS
declare variable round_to numeric(15,4);
begin

  PRICE_POST = :PRICE_ORIG * cast(:RATE_ORIG / :POST_RATE as double precision);

  if (:ID_SALE_TAXATION is null) then exception UNDEFINED_VAT_GROUP;

  select c.ROUND_TO
  from   SALE_TAXATION st
         join HOTEL H on h.ID_HOTEL = st.ID_HOTEL
         join CURRS C on c.CURR = h.NATION_CURR
  where  st.ID_SALE_TAXATION = :ID_SALE_TAXATION
  into   :round_to;
   
  POST_GROSS_VALUE = round_f(:PRICE_POST * :QTY_POST * :POST_RATE, :round_to);

  select SV.VALUE_WOT_TAX
  from   TAX_VALUE_DEDUCT (:POST_GROSS_VALUE, :round_to, :id_sale_taxation) SV
  into   :POST_NET_VALUE;

end
^

/* empty dependent procedure body */
/* Clear: CURR_MODIFY_ACCOUNT for: ACCOUNT_POSTING_RATE_GET */
ALTER PROCEDURE CURR_MODIFY_ACCOUNT(ID_ACCOUNT INTEGER,
CHANGED_CURR CHAR(3))
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_RATE_GET) */
ALTER PROCEDURE ACCOUNT_POSTING_RATE_GET(ID_HOTEL TYPE OF ID,
CURR TYPE OF TCURRENCY,
FOR_DATE TYPE OF TDATE,
ID_GUEST TYPE OF ID_REF = null)
 RETURNS(CURR_RATE TYPE OF TRATE)
 AS
declare variable guest_posting_rate varchar(20);
  declare variable arrival_date date;
begin
  curr_rate = null;
  execute procedure SETTING_GET_VALUE('GUEST_POSTING_RATE', :id_hotel)
  returning_values  :guest_posting_rate;

  if (:guest_posting_rate = 'CHECKIN_DATE') then begin
    arrival_date = null;
    select G.FROM_DATE
    from   GUEST G
    where  G.ID_GUEST = :id_guest
    into   :arrival_date;
    for_date = coalesce(:arrival_date, :for_date);
  end

  execute procedure CURR_RATE_GET(:curr, :for_date, :id_hotel)
  returning_values  :curr_rate;

end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_TRANSFER$ACC for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: GUEST_ACCOUNT_TRANSFER$INT for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE GUEST_ACCOUNT_TRANSFER$INT(ID_GUEST INTEGER,
ID_SOURCE_ACCOUNT INTEGER,
ID_TARGET_ACCOUNT INTEGER,
SERVICE_TYPE VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: GUEST_REROUTE_POSTINGS$INT for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE GUEST_REROUTE_POSTINGS$INT(ID_GUEST INTEGER,
ID_BASE_ACCOUNT INTEGER,
ID_EXTRA_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_TRANSFER$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER)
 AS
declare variable id_current_account integer;
  declare variable id_service integer;
  declare variable is_anul integer;
  declare variable id_tariff integer;
  declare variable qty_post numeric(15,2);
  declare variable qty_free numeric(15,2);
  declare variable price_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable id_room integer;
  declare variable id_base_doc integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  if ((:AP_DBKEY is null) or (:id_target_account is null) or (:id_target_account < 0)) then
     exception POSTING_TRANSFER_EXCEPTION '-31';

  select AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST, AP.QTY_FREE,
         AP.PRICE_ORIG, AP.CURR_ORIG, AP.RATE_ORIG, ap.from_date, ap.to_date,
         AP.IS_ANUL, AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_BASE_DOC, A.ID_HOTEL
  from   ACCOUNT_POST AP
         left join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :id_service, :id_tariff, :id_room, :qty_post, :qty_free,
         :price_orig, :curr_orig, :rate_orig, :from_date, :to_date,
         :is_anul, :id_account_post, :id_current_account, :id_base_doc, :id_hotel;

  if (:id_current_account = :id_target_account) then EXIT;

  if (:is_anul = 1 ) then exception POSTING_TRANSFER_EXCEPTION '-33';

  if (:id_base_doc is not null) then exception POSTING_TRANSFER_EXCEPTION '-32';

  if (not exists(select A.ID_ACCOUNT
                 from   ACCOUNT A
                 where  A.ID_ACCOUNT = :ID_TARGET_ACCOUNT
                        and A.ID_HOTEL = :id_hotel)) then exception POSTING_TRANSFER_EXCEPTION '-376';

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
                    :id_tariff, :id_room, :qty_post, :qty_free, :price_orig, :curr_orig,
                    :rate_orig, 'TRANSFER_POSTING', null, :from_date, :to_date, 0, :id_target_account)
  returning_values  :no_use, :no_use, :no_use;

  insert into ACCOUNT_TRANSFER_HISTORY(ID_ACCOUNT_POST, FROM_ID_ACCOUNT, TO_ID_ACCOUNT)
  values (:id_account_post, :id_current_account, :id_target_account);
end
^

/* Alter (ACCOUNT_POSTING_UPDATE) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable in_db_key char(8);
begin
  /* GUI facade for manual update */
  select AP.ID_ACCOUNT, AP.ID_GUEST, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :id_guest, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date)
  returning_values  (:new_qty_post, :new_price_post, :new_ac);

  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    if (coalesce(:id_guest, 0) > 0) then begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || :id_account
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'POST_UPDATE', :action_text);
    end else begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
    end
  end

end
^

/* Alter (ACCOUNT_POSTING_UPDATE_RATE$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_RATE$INT(AP_DBKEY CHAR(8),
CURRENCY_ VARCHAR(3),
NEW_RATE NUMERIC(15,6))
 AS
declare variable qty_post numeric(15,2);
  declare variable price_orig double precision;
  declare variable price_post double precision;
  declare variable rate_orig numeric(15,6);
  declare variable rate_post numeric(15,6);
  declare variable id_sale_taxation integer;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
begin
  select AP.QTY_POST, AP.PRICE_ORIG,
         case when AP.CURR_ORIG = :CURRENCY_ then :NEW_RATE else AP.RATE_ORIG end as rate_orig,
         case when AP.CURR_POST = :CURRENCY_ then :NEW_RATE else AP.RATE_POST end as rate_post,
         AP.ID_SALE_TAXATION
  from   ACCOUNT_POST AP
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :qty_post, :price_orig, :rate_orig, :rate_post,
         :id_sale_taxation;
   
  execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:qty_post, :price_orig,
                    :rate_orig, :rate_post, :id_sale_taxation)
  returning_values  (:price_post, :post_net_value, :post_gross_value);

  update ACCOUNT_POST APU
  set    APU.RATE_ORIG = :rate_orig,
         APU.RATE_POST = :rate_post,
         APU.PRICE_POST = :price_post,
         APU.POST_NET_VALUE = :post_net_value,
         APU.POST_GROSS_VALUE = :post_gross_value,
         APU.CHANGED_TEXT = 'CURRENCY RATE CHANGED',
         APU.DATETIME_CHANGED = current_timestamp
  where  APU.rdb$db_key = :ap_dbkey;
end
^

/* Alter (ACCOUNT_POSTING_UPDATE_TAX$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_TAX$INT(AP_DBKEY CHAR(8),
ID_SALE_TAXATION INTEGER,
ROUND_TO NUMERIC(15,4),
CHANGE_REASON VARCHAR(30))
 AS
begin
  /* to change ONLY taxation of account_post */
  update ACCOUNT_POST APU
  set    APU.ID_SALE_TAXATION = :ID_SALE_TAXATION,
         APU.POST_NET_VALUE =
           (select VV.VALUE_WOT_TAX
            from   TAX_VALUE_DEDUCT(APU.PRICE_POST * APU.QTY_POST * APU.RATE_POST, :ROUND_TO, :ID_SALE_TAXATION) VV),
         APU.CHANGED_TEXT = iif(not :CHANGE_REASON = '', :CHANGE_REASON, APU.CHANGED_TEXT),
         APU.DATETIME_CHANGED = current_timestamp
  where  APU.RDB$DB_KEY = :AP_DBKEY;
end
^

/* empty dependent procedure body */
/* Clear: SUMMARY_FINANCE_SAVE$INT for: ACCOUNT_POSTS_EW_MARK$INT */
ALTER PROCEDURE SUMMARY_FINANCE_SAVE$INT(ID_END_WORK INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTS_EW_MARK$INT) */
ALTER PROCEDURE ACCOUNT_POSTS_EW_MARK$INT(ID_END_WORK INTEGER)
 AS
declare variable revenue_account_method integer;
  declare variable doc_selected integer;
  declare variable ap_dbkey char(8);
  declare variable ew_date date;
  declare variable id_hotel integer;
begin
  select EW.ID_HOTEL, EW.PREV_DATE
  from   END_WORKS EW
  where  EW.ID_END_WORK = :ID_END_WORK
  into   :id_hotel, :ew_date;

  execute procedure SETTING_GET_VALUE ('REVENUE_ACCOUNT_METHOD', :id_hotel)
  returning_values  :revenue_account_method;

  doc_selected = -gen_id(DOC_SELECTED_GEN, 1); /* to prevent correction checks on trigger  */
  /* UPDATE POSTINGS FOR SUMMARY ********************************************/
  for
    select AP.RDB$DB_KEY
    from   ACCOUNT_POST AP
           join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
    where  AP.ID_END_WORK is null
           and AP.DATE_POST <= :ew_date
           and A.ID_HOTEL = :id_hotel
    union all
    select APP.RDB$DB_KEY
    from   ACCOUNT_POST APP
           join ACCOUNT A on A.ID_ACCOUNT = APP.ID_ACCOUNT
           join DOC_HEAD D on D.ID_DOC = APP.ID_BASE_DOC
    where  :revenue_account_method = 1  /* SELECT PREPAIED POSTINGS FOR SUMMARY */
           and APP.ID_END_WORK is null
           and APP.DATE_POST > :ew_date
           and A.ID_HOTEL = :id_hotel
           and D.DOC_DATE = :ew_date
    into   :ap_dbkey
  do begin
    update ACCOUNT_POST APU
    set    APU.ID_END_WORK = :id_end_work,
           APU.DOC_SELECTED = :doc_selected
    where  APU.RDB$DB_KEY = :ap_dbkey;
  end

  for
    select APC.RDB$DB_KEY
    from   ACCOUNT_POST_CORRECTION APC
           join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = APC.ID_ACCOUNT_POST
           join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
    where  apc.CORRECTION_DATE = :ew_date
           and apc.ID_END_WORK is null
           and a.ID_HOTEL = :id_hotel
           and AP.ID_END_WORK < :ID_END_WORK
    into   :ap_dbkey
  do begin
    update ACCOUNT_POST_CORRECTION C
    set    C.ID_END_WORK = :ID_END_WORK
    where  c.RDB$DB_KEY = :ap_dbkey;
  end

end
^

/* Alter (BLOCK_ANNUL$BLK) */
ALTER PROCEDURE BLOCK_ANNUL$BLK(ID_BLOCK_ROOM INTEGER,
OPERATION VARCHAR(30))
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable share_err_text varchar(255);
  declare variable system_date date;
  declare variable cancel_date date;
  declare variable from_date date;
  declare variable b_dbkey char(8);
  declare variable new_id_block_room integer;
  declare variable id_room integer;
  declare variable block_grp integer;
  declare variable reason varchar(50);
  declare variable note varchar(255);
  declare variable action_text varchar(255);
  declare variable room_name varchar(10);
  declare variable id_hotel integer;
  declare variable mark_dirty_expired_block integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION (:operation, 'cancel, annul');

  select BR.FROM_DATE, BR.RDB$DB_KEY, R.ID_HOTEL
  from   BLOCK_ROOM BR
         join ROOMS R on R.ID_ROOM = BR.ID_ROOM
  where  BR.ID_BLOCK_ROOM = :id_block_room
  into   :from_date, :b_dbkey, :id_hotel;

  if (:operation = 'annul') then begin
    update BLOCK_ROOM BR
    set    BR.IS_ANNUL = 1
    where  BR.RDB$DB_KEY = :b_dbkey;
  
    execute procedure BLOCK_MODIFY_CONTROL$INT(:b_dbkey, :from_date);
    execute procedure ROOM_MAGIC_CLEAR(:id_block_room);
    action_text = '';
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :id_block_room, 'ANNUL_BLOCK', :action_text);
  end else begin
    select BR.ID_ROOM, BR.BLOCK_GRP, BR.REASON, BR.NOTE, R.ROOM_NAME
    from   BLOCK_ROOM BR
           join ROOMS R on R.ID_ROOM = BR.ID_ROOM
    where  BR.RDB$DB_KEY = :b_dbkey
    into   :id_room, :block_grp, :reason, :note, :room_name;

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :system_date;
    cancel_date = :system_date - 1;

    execute procedure BLOCK_MODIFY$INT(:id_block_room, :id_room, :from_date, :cancel_date, :block_grp, :reason,
                      :note, 'mod')
    returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :share_err_text, :warn_code;
    --ignore possible entering into share

    execute procedure SETTING_GET_VALUE('MARK_DIRTY_EXPIRED_BLOCK', :id_hotel)
    returning_values  :mark_dirty_expired_block;
    if (:mark_dirty_expired_block = '1') then begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'BLOCK_STOP', 'set_dirty');
    end

    action_text = f_character(29) || :room_name || f_character(28) || formatdate(:cancel_date, 'D;dd.mm.yyyy');
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :new_id_block_room, 'CANCEL_BLOCK', :action_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: BLOCK_CREATE$BLK for: BLOCK_MODIFY$INT */
ALTER PROCEDURE BLOCK_CREATE$BLK(ROOM_NAMES /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_HOTEL /* TYPE OF ID */ INTEGER,
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
BLOCK_GRP /* TYPE OF TRANGE */ INTEGER,
REASON /* TYPE OF TREASON */ VARCHAR(50),
NOTE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IS_FULL_FROM /* TYPE OF TRANGE */ INTEGER,
IS_FULL_TO /* TYPE OF TRANGE */ INTEGER)
 RETURNS(NEW_ID_BLOCK_ROOM /* TYPE OF ID */ INTEGER,
SHARE_TRANSACTION_ID /* TYPE OF ID */ INTEGER,
SHARE_ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE /* TYPE OF ID */ INTEGER,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: BLOCK_MODIFY$BLK for: BLOCK_MODIFY$INT */
ALTER PROCEDURE BLOCK_MODIFY$BLK(ID_BLOCK_ROOM INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
BLOCK_GRP INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
IS_FULL_FROM INTEGER,
IS_FULL_TO INTEGER)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (BLOCK_MODIFY$INT) */
ALTER PROCEDURE BLOCK_MODIFY$INT(ID_BLOCK_ROOM INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
BLOCK_GRP INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_BLOCK_ROOM INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable b_dbkey char(8);
  declare variable edit_status varchar(255);
  declare variable old_id_room integer;
  declare variable min_affected_date date;
  declare variable old_from_date date;
  declare variable old_to_date date;
begin

  if (:block_grp not in (18, 20)) then exception BLOCK_EXCEPTION '-85' || f_character(31) || 'Unknown block type';

  if (:operation = 'add') then begin
    new_id_block_room = gen_id(ID_RESERV_DETAIL_GEN, 1);
    insert into BLOCK_ROOM (ID_BLOCK_ROOM, ID_ROOM, FROM_DATE, TO_DATE,
           BLOCK_GRP, REASON, NOTE)
    values (:new_id_block_room, :id_room, :from_date, :to_date,
           :block_grp, :reason, :note)
    returning RDB$DB_KEY into :b_dbkey;
    edit_status = 'JUST_CREATED';
    min_affected_date = :from_date;
  end else begin
    select BR.RDB$DB_KEY, BR.FROM_DATE, BR.TO_DATE, BR.ID_ROOM
    from   BLOCK_ROOM BR
    where  BR.ID_BLOCK_ROOM = :id_block_room
    into   :b_dbkey, :old_from_date, :old_to_date, :old_id_room;

    min_affected_date = null;
    if (:old_from_date <> :from_date) then min_affected_date = mindate(:old_from_date, :from_date);
    else if (:old_to_date <> :to_date) then min_affected_date = mindate(:old_to_date, :to_date) + 1;
    edit_status = iif(:min_affected_date is not null, 'DATE_CHANGED', '');
    if (:id_room <> :old_id_room) then edit_status = :edit_status || ',ROOM_CHANGED';

    update BLOCK_ROOM BRU
    set    BRU.ID_ROOM = :id_room,
           BRU.FROM_DATE = :from_date,
           BRU.TO_DATE = :to_date,
           BRU.BLOCK_GRP = :block_grp,
           BRU.REASON = :reason,
           BRU.NOTE = :note
    where  BRU.RDB$DB_KEY = :b_dbkey;

    new_id_block_room = :id_block_room;
  end

  execute procedure BLOCK_MODIFY_CONTROL$INT(:b_dbkey, :min_affected_date);

  execute procedure LIST_ITEM_MODIFY(:block_grp, null, :reason, 'add');

  ------------------------------------
  execute procedure OCCUPANCY_BLOCK$INT(:b_dbkey, :edit_status);

  execute procedure OCCUPANCY_ROOMS_CHECK$INT(:b_dbkey, :block_grp)
  returning_values  :share_err_code, :share_err_text, :share_transaction_id, :warn_code;

  execute procedure sys_dbg('occ BLOCK_MODIFY$INT share_err_code = '||coalesce(:share_err_code, 'null'));
  execute procedure sys_dbg('occ BLOCK_MODIFY$INT share_err_text = '||coalesce(:share_err_text, 'null'));
  execute procedure sys_dbg('occ BLOCK_MODIFY$INT share_transaction_id = '||coalesce(:share_transaction_id, 'null'));

  execute procedure RES_FINALIZE_CLEAR$INT(:b_dbkey, :new_id_block_room);
  --
  delete from RESERV_STAY$TMP t
  where  t.id_session = RDB$GET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION');
end
^

/* Alter (CONTRACT_EXPENSE_POST$INT) */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT TYPE OF ID,
ID_HOTEL INTEGER,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
ID_OWNER TYPE OF ID,
OWNERSHIP_PERCENT TYPE OF TPERCENT,
ID_RENTAL_POOL TYPE OF ID_REF,
VALUE_ORIG TYPE OF TPRICE,
CURR_ORIG TYPE OF TCURRENCY,
POST_DATE TYPE OF TDATE,
STAY TYPE OF TCOUNT,
MAX_GUEST_CNT TYPE OF TCOUNT,
BED_NIGHT_CNT TYPE OF TCOUNT,
RESERVS TYPE OF TCOUNT)
 AS
declare variable service_price numeric(15,4);
  declare variable id_currency varchar(3);
  declare variable contract_expense_type varchar(50);
  declare variable id_account integer;
  declare variable post_value numeric(15,4);
  declare variable post_currency varchar(3);
  declare variable id_service integer;
  declare variable is_owner_income smallint;
  declare variable is_client_acc_post smallint;
  declare variable multiplier_type varchar(50);
  declare variable multiplier integer;
  declare variable id_room integer;
  declare variable use_shadow_account integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
begin
  is_owner_income = 0;
  use_shadow_account = iif(:SUB_CONTRACT = 'SHADOW_ACC', 1, 0);

  select r.ID_HOTEL
  from   PMS_EVENT$PMS p
         join ROOMS R on r.ID_ROOM = p.ID_ROOM
  where  p.ID_PMS_EVENT = :ID_PMS_EVENT
  into   :id_hotel;
-- CONTRACT_EXPENSE_TYPE in ( 'PERCENT', 'RUNNING_TOTAL_PERCENT', 'CURR_VALUE' )
-- MULTIPLIER_TYPE in ('RESERVATION', 'STAY', 'GUESTS', 'BED_NIGHTS')
  for
    select C.SERVICE_PRICE, C.ID_CURRENCY, C.CONTRACT_EXPENSE_TYPE, C.IS_ACC_POST_ITEM,
           C.ID_SERVICE, C.MULTIPLIER_TYPE
    from   CONTRACT_EXPENSE$PMS C
    where  C.ID_CONTRACT = :id_contract
           and c.SUB_CONTRACT = :SUB_CONTRACT
    order by C.ORDER_TAG asc
    into   :service_price, :id_currency, :contract_expense_type, :is_client_acc_post,
           :ID_SERVICE, :multiplier_type
  do begin

    execute procedure OWNER_ACCOUNT_GET$INT (coalesce(:ID_RENTAL_POOL,:ID_OWNER),
            :id_hotel, :use_shadow_account, :is_client_acc_post)
    returning_values (:id_account, :is_account$pms);

    multiplier = case
                   when :multiplier_type = 'RESERVATION' then iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'STAY' then :STAY
                   when :multiplier_type = 'GUESTS' then :MAX_GUEST_CNT * iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'BED_NIGHTS' then :BED_NIGHT_CNT
                   else null
                 end;

    if (:multiplier is not null) then begin
      if (:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE') then begin
        post_value = cast(:service_price as double precision) * :ownership_percent / 100 * :multiplier;
        post_currency = :id_currency;
      end else if (:CONTRACT_EXPENSE_TYPE = 'PERCENT') then begin
        post_value = :VALUE_ORIG * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end else if (:CONTRACT_EXPENSE_TYPE = 'RUNNING_TOTAL_PERCENT') then begin
        execute procedure PMS_RUNNING_TOTAL_GET(:ID_PMS_EVENT, coalesce(:ID_RENTAL_POOL,:ID_OWNER), :ID_HOTEL, :POST_DATE, :CURR_ORIG)
        returning_values :post_value;
        if (:post_value < 0) then post_value = 0;
    
        post_value = :post_value * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end

      select pe.ID_ROOM
      from   PMS_EVENT$PMS PE
      where  pe.ID_PMS_EVENT = :ID_PMS_EVENT
      into   :id_room;

      select c.ROUND_TO
      from   CURRS C
      where  c.CURR = :post_currency
      into   :round_to;

      execute procedure PMS_POSTING_CREATE$INT(:ID_PMS_EVENT, :id_account, :id_service, :ID_OWNER,
              :POST_DATE, :post_currency, round_f(:post_value, :round_to), :is_account$pms, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* Alter (CURR_MODIFY_ACCOUNT) */
ALTER PROCEDURE CURR_MODIFY_ACCOUNT(ID_ACCOUNT INTEGER,
CHANGED_CURR CHAR(3))
 AS
declare variable ap_dbkey char(8);
  declare variable curr_orig char(3);
  declare variable new_rate numeric (15,6);
  declare variable curr_post char(3);
  declare variable id_guest integer;
  declare variable date_post date;
  declare variable is_archive integer;
  declare variable id_hotel integer;
begin
  /*  Description:
  ||
  */
  select A.IS_ARCHIVE, a.ID_HOTEL
  from   ACCOUNT A
         join HOTEL H on h.ID_HOTEL = a.ID_HOTEL
  where  A.ID_ACCOUNT = :id_account
  into   :is_archive, :id_hotel;

  if (:is_archive = 0) then begin
    for
      select AP.rdb$db_key, AP.CURR_ORIG, AP.CURR_POST, AP.ID_GUEST, AP.DATE_POST
      from   ACCOUNT_POST AP
      where  AP.ID_ACCOUNT = :id_account
             and AP.AC = '00'
             and AP.ID_BASE_DOC is null
             and ((:changed_curr = 'ALL') or (AP.CURR_ORIG = :changed_curr) or (AP.CURR_POST = :changed_curr))
      into   :ap_dbkey, :curr_orig, :curr_post, :id_guest, :date_post
    do begin
      if ((:changed_curr = 'ALL') or (:curr_orig = :changed_curr)) then begin
        execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :curr_orig, :date_post, :id_guest)
        returning_values  :new_rate;

        execute procedure ACCOUNT_POSTING_UPDATE_RATE$INT (:ap_dbkey, :curr_orig, :new_rate);
      end
      /*************************************/
      if (:curr_post = :curr_orig) then EXIT;
      /*************************************/
      if ((:changed_curr = 'ALL') or (:curr_post = :changed_curr)) then begin
        execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :curr_post, :date_post, :id_guest)
        returning_values  :new_rate;

        execute procedure ACCOUNT_POSTING_UPDATE_RATE$INT (:ap_dbkey, :curr_post, :new_rate);
      end

    end
  end
end
^

/* empty dependent procedure body */
/* Clear: HOTEL_MODIFY$CFG for: CURR_RATE_MODIFY */
ALTER PROCEDURE HOTEL_MODIFY$CFG(ID_HOTEL INTEGER,
HOTEL_NAME VARCHAR(50),
IS_USE SMALLINT,
CODE VARCHAR(10),
LETTER_FOOTER BLOB SUB_TYPE 1,
FIRM_DATA BLOB SUB_TYPE 1,
LETTER_HEADER BLOB SUB_TYPE 1,
ID_LOGO INTEGER,
ORDER_TAG INTEGER,
RES_CONFIRM_TEXT BLOB SUB_TYPE 1,
DOC_PACK_SRV_TEXT VARCHAR(50),
DOC_ONE_LINE_TEXT VARCHAR(50),
EXTERNAL_TYPE VARCHAR(50),
HOTEL_ADDRESS VARCHAR(100),
OPERATION VARCHAR(10),
NATION_CURR CHAR(3),
REG_CARD_TEXT BLOB SUB_TYPE 1 = null,
USE_DIFFERENT_TT_NUMERATORS /* TLOGICAL */ SMALLINT = null)
 RETURNS(NEW_ID_HOTEL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_CURRENCY_RATE$EXC for: CURR_RATE_MODIFY */
ALTER PROCEDURE IMPORT_CURRENCY_RATE$EXC(ID_HOTEL INTEGER,
CURRENCY CHAR(3),
ROUND_TO NUMERIC(15,6),
DATETIME TIMESTAMP,
RATE NUMERIC(15,6))
 AS
 BEGIN EXIT; END
^

/* Alter (CURR_RATE_MODIFY) */
ALTER PROCEDURE CURR_RATE_MODIFY(CURR CHAR(3),
ID_HOTEL INTEGER,
RATE NUMERIC(15,6),
FOR_DATE DATE = null)
 AS
declare variable ap_dbkey char(8);
  declare variable guest_posting_rate varchar(20);
  declare variable from_date date;
  declare variable cr_dbkey char(8);
  declare variable old_rate numeric(15,6);
  declare variable id_curr_rate integer;
  declare variable hotel_name varchar(50);
  declare variable action_text varchar(255);
  declare variable nation_curr tcurrency;
begin
  for_date = coalesce(:FOR_DATE, current_date);

  select h.HOTEL_NAME, h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :ID_HOTEL
  into   :hotel_name, :nation_curr;

  if (:nation_curr = :CURR and :RATE <> 1) then exception ASSERT '-35';

  select cr.RDB$DB_KEY, cr.CURR_RATE
  from   CURR_RATES CR
  where  CR.CURR = :CURR
         and cr.ID_HOTEL = :ID_HOTEL
         and cr.DATE_ = :FOR_DATE
  into   :cr_dbkey, :old_rate;

  if (:old_rate is null) then begin
    insert into CURR_RATES (CURR, ID_HOTEL, DATE_, CURR_RATE)
    values (:CURR, :ID_HOTEL, :FOR_DATE, :RATE)
    returning ID_CURR_RATE into :id_curr_rate;

    select first 1 r.CURR_RATE
    from   CURR_RATES r
    where  r.ID_HOTEL = :ID_HOTEL
           and r.CURR = :CURR
           and r.DATE_ < :FOR_DATE
    order by r.DATE_ desc
    into   :old_rate;

  end else if (:old_rate <> :RATE) then begin
    update CURR_RATES r
    set    r.CURR_RATE = :RATE
    where  r.RDB$DB_KEY = :cr_dbkey;
  end else begin
    exit;
  end

  action_text = f_character(29) || :hotel_name || f_character(28)
                || formatdate(:FOR_DATE, 'D;dd.mm.yyyy') || f_character(28)
                || coalesce(:old_rate, 'N/A') || f_character(28)
                || coalesce(:RATE, 'N/A');

  execute procedure SYSTEM_LOG_ADD ('CURRENCY', :id_curr_rate, 'RATE_CHANGED', :action_text, :RATE);

  if (:old_rate is not null) then begin   -- this is not first, initial rate
    /* CHANGE THE CURRENR_RATE OF THE OPEN POSTINGS */
    execute procedure SETTING_GET_VALUE('GUEST_POSTING_RATE', :ID_HOTEL)
    returning_values  :guest_posting_rate;
  
    for
      select AP.rdb$db_key, G.FROM_DATE
      from   ACCOUNT_POST AP
             join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
             left outer join GUEST G on G.ID_GUEST = AP.ID_GUEST
      where  ((AP.CURR_POST = :CURR) or (AP.CURR_ORIG = :CURR))
             and AP.AC = '00'
             and AP.ID_BASE_DOC is null
             and AP.DATE_POST >= current_date
             and A.ID_HOTEL = :ID_HOTEL
      into   :ap_dbkey, :from_date
    do begin
      if (:guest_posting_rate = 'CHECKIN_DATE' and :from_date < current_date) then begin
        /* Do nothing. Theese postings are by guest check_in date rate,
        || which is not changing now
        */
      end else begin
        execute procedure ACCOUNT_POSTING_UPDATE_RATE$INT (:ap_dbkey, :CURR, :RATE);
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ON_PROFORMA_INIT$DOC for: CURR_RATES_PREPARE$INT */
ALTER PROCEDURE DOCUMENT_ON_PROFORMA_INIT$DOC(ID_PROFORMA_DOC /* TYPE OF ID */ INTEGER)
 RETURNS(ID_DOC_HEAD /* TYPE OF ID */ INTEGER,
ID_HOTEL /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (CURR_RATES_PREPARE$INT) */
ALTER PROCEDURE CURR_RATES_PREPARE$INT(DOC_SELECTED INTEGER,
ID_ACCOUNT INTEGER,
DOC_DATE DATE)
 AS
declare variable account_to_doc_rate varchar(30);
  declare variable post_value double precision;
  declare variable doc_value double precision ;
  declare variable from_date date;
  declare variable curr varchar(3);
  declare variable curr_rate numeric(15,6);
  declare variable round_to numeric(15,4);
  declare variable id_hotel integer;
begin
  /****************************************************************************/
  /*  calc and set into TMP_RATES availabe currency rates                     */
  /*  used in document processing (called only once at begining)              */
  /****************************************************************************/
  curr_rate = null;

  select A.ID_HOTEL, c.ROUND_TO
  from   ACCOUNT A
         join HOTEL h on h.ID_HOTEL = a.ID_HOTEL
         join CURRS c on c.CURR = h.NATION_CURR
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :id_hotel, :round_to;

  execute procedure SETTING_GET_VALUE('ACCOUNT_TO_DOC_RATE', :id_hotel)
  returning_values  :account_to_doc_rate;

  delete from CURR_RATES$TMP cr
  where  cr.DOC_SELECTED = :DOC_SELECTED;

  if (:account_to_doc_rate = 'POSTING_RATE') then begin
    /* calc average rates for different guest check-in rates */
    insert into CURR_RATES$TMP (DOC_SELECTED, CURR, CURR_RATE)
    select :DOC_SELECTED, C.CURR, 0
    from   CURRS C;

    doc_value = 0;
    for
      select coalesce(G.FROM_DATE, AP.DATE_POST, :DOC_DATE),
             sum(cast(AP.QTY_POST * AP.PRICE_POST * AP.RATE_POST as double precision))
      from   ACCOUNT_POST AP
             left outer join GUEST G on G.ID_GUEST = AP.ID_GUEST
      where  AP.DOC_SELECTED = :DOC_SELECTED
             and AP.ID_ACCOUNT = :ID_ACCOUNT
      group by 1
      into   :from_date, :post_value
    do begin
      for
        select C.CURR
        from   CURRS C
        into   :curr
      do begin
        execute procedure CURR_RATE_GET(:CURR, :from_date, :id_hotel)
        returning_values  (:curr_rate);

        update CURR_RATES$TMP TR
        set    TR.CURR_RATE = TR.CURR_RATE + cast(:post_value / :curr_rate as double precision )
        where  TR.DOC_SELECTED = :DOC_SELECTED
               and TR.CURR = :CURR;
      end
      doc_value = :doc_value + :post_value;
    end

    if (round_f(abs(:doc_value), :round_to) < :round_to) then begin
      delete from  CURR_RATES$TMP TRD
      where  TRD.DOC_SELECTED = :DOC_SELECTED;
    end else begin
      update CURR_RATES$TMP TRU
      set    TRU.CURR_RATE = cast(:doc_value / TRU.CURR_RATE  as double precision)
      where  TRU.DOC_SELECTED = :DOC_SELECTED;
    end
  end

  /* get current rates (default) */
  for
    select C.CURR
    from   CURRS C
    where  not exists (select T.CURR_RATE
                       from   CURR_RATES$TMP T
                       where  T.CURR = C.CURR
                              and T.DOC_SELECTED = :DOC_SELECTED)
    into   :curr
  do begin
    execute procedure CURR_RATE_GET(:curr, :doc_date, :id_hotel)
    returning_values  :curr_rate;

    insert into CURR_RATES$TMP (DOC_SELECTED, CURR, CURR_RATE)
    values (:DOC_SELECTED, :curr, :curr_rate);

    when exception UNDEFIND_CURRENCY_RATE do post_event 'dummy';
  end

end
^

/* Alter (DEPOSIT_DOCUMENT_INITIALIZE$DOC) */
ALTER PROCEDURE DEPOSIT_DOCUMENT_INITIALIZE$DOC(ID_PAYMENT_HEAD TYPE OF ID,
ID_BILLING_SERVICE TYPE OF ID)
 RETURNS(ID_DOC_HEAD TYPE OF ID,
ID_HOTEL TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
WARN_CODE TYPE OF TRANGE)
 AS
declare variable id_dep_doc integer;
declare variable doc_selected integer;
declare variable payment_date date;
declare variable system_date date;
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_BILLING');

  id_dep_doc = null;

  select p.ID_DOC_HEAD, p.ID_ACCOUNT, p.PAYMENT_DATE, a.ID_HOTEL
  from   PAYMENT_HEAD P
         join DEPOSIT d on d.ID_PAYMENT_HEAD = p.ID_PAYMENT_HEAD
         join ACCOUNT a on a.ID_ACCOUNT = p.ID_ACCOUNT
  where  p.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
         and p.IS_ANUL = 0
  into   :id_dep_doc, :id_account, :payment_date, :id_hotel;

  if (:id_account is null) then
    exception DOCUMENT_EXCEPTION '-355';

  if (:id_dep_doc is not null) then
    exception DOCUMENT_EXCEPTION '-364';

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :system_date;

  if (:payment_date < :system_date) then
    exception DOCUMENT_EXCEPTION '-399';

  doc_selected = gen_id(DOC_SELECTED_GEN, 1);

  update DEPOSIT P
  set    p.DOC_SELECTED = :doc_selected,
         p.ID_BILLING_SERVICE = :ID_BILLING_SERVICE
  where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;

  execute procedure DOCUMENT_INITIALIZE$DOC (:ID_ACCOUNT, :doc_selected)
  returning_values  (:ID_DOC_HEAD, :ID_HOTEL, :WARN_CODE);

end
^

/* Alter (DOC_LINES_SUSPEND) */
ALTER PROCEDURE DOC_LINES_SUSPEND(ID_DOC_HEAD INTEGER,
CORRECTION_INDEX INTEGER,
SUBSTITUTE_PACK_NAME VARCHAR(50),
REPORT_TYPE VARCHAR(20),
RPT_CURR VARCHAR(10),
RPT_VAT VARCHAR(20),
EXTRA_DATA_SUSPEND SMALLINT)
 RETURNS(ID_DOC_LINE INTEGER,
LINE_NAME VARCHAR(100),
ID_GUEST INTEGER,
ROOM_NAME VARCHAR(10),
FROM_DATE DATE,
TO_DATE DATE,
DATE_POST DATE,
IS_BASE SMALLINT,
IS_CORRECT SMALLINT,
IS_FOR_PAY SMALLINT,
GROUP_TAG INTEGER,
TAX_STATUS INTEGER,
ID_SERVICE INTEGER,
ID_SERVICE_GROUP INTEGER,
GROUP_NAME VARCHAR(30),
IS_PACKET_POST SMALLINT,
ID_PACK_SERVICE INTEGER,
PACK_SERVICE_NAME VARCHAR(50),
QTY_POST NUMERIC(15,4),
PACK_QTY NUMERIC(15,4),
SINGLE_PRICE NUMERIC(15,4),
LINE_VALUE NUMERIC(15,4),
VAT_VALUE NUMERIC(15,4),
PACK_PRICE NUMERIC(15,4),
PACK_PRICE_WOT_DIFF DOUBLE PRECISION,
POST_PRICE_WOT_DIFF DOUBLE PRECISION,
SEC_CURR_LINE_VALUE NUMERIC(15,4),
SEC_CURR_GROSS_VALUE NUMERIC(15,4),
ID_SALE_TAXATION INTEGER)
 AS
declare variable prev_id_service integer;
  declare variable prev_id_guest integer;
  declare variable prev_price numeric(15,4);
  declare variable prev_date date;
  declare variable no_use varchar(255);
  declare variable dbg varchar(1000);
  declare variable round_to numeric(15,4);
begin
  /* PACK_PRICE_WOT_DIFF and POST_PRICE_WOT_DIFF are only for grouping */
  /* Params: REPORT_TYPE, EXTRA_DATA_SUSPEND - for future use */
  dbg = null;
  correction_index = coalesce(:correction_index, 1);
  if (:report_type is null) then report_type = '';
  if (:extra_data_suspend is null) then extra_data_suspend = 0;
  prev_id_guest   = null;
  prev_id_service = null;
  prev_date       = null;
  prev_price      = 0;
  group_tag       = 0;
  select C.ROUND_TO
  from   DOC_HEAD$INT D
         join CURRS C on C.CURR = D.DOC_CURRENCY
  where  D.ID_DOC_HEAD = :id_doc_head
  into   :round_to;

  if (:report_type = 'services') then begin
    /* SERVICE GROUPING */
    for
      select cast(DLS.SINGLE_WOT_DIFF/:round_to as integer),
             ID_DOC_LINE, LINE_NAME, ID_GUEST, ROOM_NAME, FROM_DATE,
             TO_DATE, DATE_POST, IS_BASE, IS_CORRECT, IS_FOR_PAY, GROUP_TAG, TAX_STATUS,
             ID_SERVICE, ID_SERVICE_GROUP, GROUP_NAME, IS_PACKET_POST, ID_PACK_SERVICE,
             PACK_SERVICE_NAME, QTY_POST, PACK_QTY,
             SINGLE_PRICE, LINE_VALUE, VAT_VALUE, PACK_PRICE,
             round_f(PACK_PRICE_WOT_DIFF, :round_to), round_f(SINGLE_WOT_DIFF, :round_to),
             DLS.SEC_CURR_LINE_VALUE, DLS.SEC_CURR_GROSS_VALUE, DLS.ID_SALE_TAXATION
      from   DOC_LINES_SUSPEND_SUB (:id_doc_head, :correction_index, :substitute_pack_name, :rpt_vat, :rpt_curr, 'NONE') DLS
      order by DLS.IS_BASE desc, DLS.IS_CORRECT asc, DLS.ID_SERVICE asc, /*DLS.POST_PRICE_WOT_DIFF*/ 1 asc, DLS.DATE_POST asc
      into   :no_use, :id_doc_line, :line_name, :id_guest, :room_name, :from_date,
             :to_date, :date_post, :is_base, :is_correct, :is_for_pay, :no_use, :tax_status,
             :id_service, :id_service_group, :group_name, :is_packet_post, :id_pack_service,
             :pack_service_name, :qty_post, :pack_qty,
             :single_price, :line_value, :VAT_VALUE, :pack_price,
             :pack_price_wot_diff, :post_price_wot_diff,
             :SEC_CURR_LINE_VALUE, :SEC_CURR_GROSS_VALUE, :id_sale_taxation
    do begin
      if ((:prev_id_service is null) /*or (:prev_id_service <> :id_service)*/) then begin
        prev_id_service = :id_service;
        prev_price = :post_price_wot_diff;
        prev_date = :date_post;
      end
      if ((:prev_id_service <> :id_service)
          or (:prev_price <> :post_price_wot_diff)
          or (:date_post - :prev_date > 1 and :is_base = 1)
      ) then begin
        group_tag = :group_tag + 1;
        prev_id_service = :id_service;
        prev_price = :post_price_wot_diff;
      end
      prev_date = :date_post;
      suspend;
    end
  end else if (:report_type = 'packages') then begin
    /* PACKAGE GROUPING */
    for
      select cast(DLS.PACK_PRICE_WOT_DIFF/:round_to as integer),
             ID_DOC_LINE, LINE_NAME, ID_GUEST, ROOM_NAME, FROM_DATE,
             TO_DATE, DATE_POST, IS_BASE, IS_CORRECT, IS_FOR_PAY, GROUP_TAG, TAX_STATUS,
             ID_SERVICE , ID_SERVICE_GROUP, GROUP_NAME, IS_PACKET_POST, ID_PACK_SERVICE,
             PACK_SERVICE_NAME, QTY_POST, PACK_QTY,
             SINGLE_PRICE, LINE_VALUE, VAT_VALUE, PACK_PRICE,
             round_f(PACK_PRICE_WOT_DIFF, :round_to), round_f(SINGLE_WOT_DIFF, :round_to),
             DLS.SEC_CURR_LINE_VALUE, DLS.SEC_CURR_GROSS_VALUE, DLS.ID_SALE_TAXATION
      from   DOC_LINES_SUSPEND_SUB (:id_doc_head, :correction_index, :substitute_pack_name, :rpt_vat, :rpt_curr, 'ALL') DLS
      order by /*DLS.IS_BASE desc,*/ DLS.IS_PACKET_POST desc, DLS.IS_CORRECT asc,
             DLS.ID_PACK_SERVICE asc, /*DLS.PACK_PRICE_WOT_DIFF*/ 1 asc, DLS.DATE_POST asc
      into   :no_use, :id_doc_line, :line_name, :id_guest, :room_name, :from_date,
             :to_date, :date_post, :is_base, :is_correct, :is_for_pay, :no_use, :tax_status,
             :id_service , :id_service_group, :group_name, :is_packet_post, :id_pack_service,
             :pack_service_name, :qty_post, :pack_qty,
             :single_price, :line_value, :VAT_VALUE ,:pack_price,
             :pack_price_wot_diff, :post_price_wot_diff,
             :SEC_CURR_LINE_VALUE, :SEC_CURR_GROSS_VALUE, :id_sale_taxation
    do begin
      if ((:prev_id_service is null) /*or (:prev_id_service <> :id_pack_service)*/) then begin
        prev_id_service = :id_pack_service;
        prev_price = :pack_price_wot_diff;
        prev_date = :date_post;
      end
      if ((:prev_id_service <> :id_pack_service)
          or (:prev_price <> :pack_price_wot_diff)
          or (:date_post - :prev_date > 1 and :is_base = 1)
      ) then begin
        group_tag = :group_tag + 1;
        prev_id_service = :id_pack_service;
        prev_price = :pack_price_wot_diff;
      end
      prev_date = :date_post;
      suspend;
    end
  end else if (:report_type = 'groups') then begin
    /* SERVICE_GROUP GROUPING  */
    for
      select cast(DLS.SINGLE_WOT_DIFF/:round_to as integer),
             ID_DOC_LINE, LINE_NAME, ID_GUEST, ROOM_NAME, FROM_DATE,
             TO_DATE, DATE_POST, IS_BASE, IS_CORRECT, IS_FOR_PAY, GROUP_TAG, TAX_STATUS,
             ID_SERVICE , ID_SERVICE_GROUP, GROUP_NAME, IS_PACKET_POST, ID_PACK_SERVICE,
             PACK_SERVICE_NAME, QTY_POST, PACK_QTY,
             SINGLE_PRICE, LINE_VALUE, VAT_VALUE, PACK_PRICE,
             round_f(PACK_PRICE_WOT_DIFF, :round_to), round_f(SINGLE_WOT_DIFF, :round_to),
             DLS.SEC_CURR_LINE_VALUE, DLS.SEC_CURR_GROSS_VALUE, DLS.ID_SALE_TAXATION
      from   DOC_LINES_SUSPEND_SUB (:id_doc_head, :correction_index, :substitute_pack_name, :rpt_vat, :rpt_curr, 'NONE') DLS
      order by DLS.IS_BASE desc, DLS.IS_CORRECT asc, DLS.ID_SERVICE_GROUP asc, /*DLS.POST_PRICE_WOT_DIFF*/ 1 asc, DLS.DATE_POST asc
      into   :no_use, :id_doc_line, :line_name, :id_guest, :room_name, :from_date,
             :to_date, :date_post, :is_base, :is_correct, :is_for_pay, :no_use, :tax_status,
             :id_service , :id_service_group, :group_name, :is_packet_post, :id_pack_service,
             :pack_service_name, :qty_post, :pack_qty,
             :single_price, :line_value, :VAT_VALUE, :pack_price,
             :pack_price_wot_diff, :post_price_wot_diff,
             :SEC_CURR_LINE_VALUE, :SEC_CURR_GROSS_VALUE, :id_sale_taxation
    do begin
      if ((:prev_id_service is null) /*or (:prev_id_service <> :ID_SERVICE_GROUP)*/) then begin
        prev_id_service = :id_service_group;
        prev_price = :post_price_wot_diff;
        prev_date = :date_post;
      end
      if ((:prev_id_service <> :id_service_group)
         or (:prev_price <> :post_price_wot_diff)
         or (:date_post - :prev_date > 1 and :is_base = 1)
      ) then begin
        group_tag = :group_tag + 1;
        prev_id_service = :id_service_group;
        prev_price = :post_price_wot_diff;
      end
      prev_date = :date_post;
      suspend;
    end
  end else begin
    /* DETAIL GROUPING - BY DEFAULT */
    for
      select ID_DOC_LINE, LINE_NAME, ID_GUEST, ROOM_NAME, FROM_DATE,
             TO_DATE, DATE_POST, IS_BASE, IS_CORRECT, IS_FOR_PAY, GROUP_TAG, TAX_STATUS,
             ID_SERVICE , ID_SERVICE_GROUP, GROUP_NAME, IS_PACKET_POST, ID_PACK_SERVICE,
             PACK_SERVICE_NAME, QTY_POST, PACK_QTY,
             SINGLE_PRICE, LINE_VALUE, VAT_VALUE, PACK_PRICE,
             round_f(PACK_PRICE_WOT_DIFF, :round_to), round_f(SINGLE_WOT_DIFF, :round_to),
             DLS.SEC_CURR_LINE_VALUE, DLS.SEC_CURR_GROSS_VALUE, DLS.ID_SALE_TAXATION
      from   DOC_LINES_SUSPEND_SUB (:id_doc_head, :correction_index, :substitute_pack_name, :rpt_vat, :rpt_curr, 'NONE') DLS
      order by DLS.IS_BASE desc, DLS.IS_CORRECT asc, DLS.ID_GUEST asc, DLS.ID_SERVICE asc, /*DLS.POST_PRICE_WOT_DIFF asc,*/ DLS.DATE_POST asc
      into   :id_doc_line, :line_name, :id_guest, :room_name, :from_date,
             :to_date, :date_post, :is_base, :is_correct, :is_for_pay, :no_use, :tax_status,
             :id_service , :id_service_group, :group_name, :is_packet_post, :id_pack_service,
             :pack_service_name, :qty_post, :pack_qty,
             :single_price, :line_value, :VAT_VALUE, :pack_price,
             :pack_price_wot_diff, :post_price_wot_diff,
             :SEC_CURR_LINE_VALUE, :SEC_CURR_GROSS_VALUE, :id_sale_taxation
    do begin
      if ((:prev_id_guest is null) /*or (:prev_id_guest <> :id_guest)*/) then begin
        prev_id_guest = :id_guest;
        prev_id_service = :id_service;
        prev_price = :post_price_wot_diff;
        prev_date = :date_post;
      end
      if ((:prev_id_guest <> :id_guest)
         or (:prev_id_service <> :id_service)
         or (:prev_price <> :post_price_wot_diff)
         or (:date_post - :prev_date > 1 and :is_base = 1)
      ) then begin
        group_tag = :group_tag + 1;
        prev_id_guest = :id_guest;
        prev_id_service = :id_service;
        prev_price = :post_price_wot_diff;
      end
      prev_date = :date_post;
      suspend;
    end
  end
end
^

/* Alter (DOC_LINES_SUSPEND_INVOICE) */
ALTER PROCEDURE DOC_LINES_SUSPEND_INVOICE(ID_DOC_HEAD INTEGER,
CORRECTION_INDEX INTEGER,
RPT_TYPE VARCHAR(20),
RPT_CURR VARCHAR(10),
RPT_VAT VARCHAR(20),
IN_VAUCHER_NUM VARCHAR(20))
 RETURNS(TAX_STATUS INTEGER,
ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
VAUCHER_NUM VARCHAR(20),
GUEST_NAME VARCHAR(100),
IS_CHILD INTEGER,
AGES_NAME VARCHAR(50),
GFROM_DATE DATE,
GTO_DATE DATE,
PACKET_NAME VARCHAR(50),
LINE_NAME VARCHAR(100),
ID_SERVICE INTEGER,
DATE_POST DATE,
QTY_POST NUMERIC(15,2),
SINGLE_PRICE NUMERIC(15,4),
LINE_VALUE NUMERIC(15,4),
PACKET_PRICE NUMERIC(15,4),
PACKET_PRICE_WOT_DIFF DOUBLE PRECISION,
ID_TARIFA INTEGER,
BIRTH_DATE DATE,
NIGHTS INTEGER,
IS_BASE INTEGER)
 AS
declare variable DOC_VAT_STATUS integer;
  declare variable DL_DBKEY char(8);
  declare variable NO_USE varchar(255);
  declare variable VAUCHER_PACKET varchar(20);
begin
  /*  Description:
  ||  RPT_TYPE - PACKETS, OTHER, TAX_STATUS, TAXES
  */
  select DT.IS_VAT
  from   DOC_HEAD$INT DH
         join DOC_TYPE DT on DT.ID_DOC_TYPE = DH.ID_DOC_TYPE
  where  DH.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :DOC_VAT_STATUS;

  if (:RPT_TYPE = 'PACKETS') then begin
    for
      select DL.RDB$DB_KEY, DL.TAX_STATUS, DL.ID_GUEST, DL.DATE_POST, G.ID_TARIFA, coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET), PV.IS_BASE,
             GC.GUEST_NAME1, G.IS_CHILD, AG.AGES_NAME, G.FROM_DATE, G.TO_DATE, G.ID_RESERV_DETAIL,
             case when coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'SECONDARY' then G.VAUCHER_NUM2 else G.VAUCHER_NUM end,
             GC.BIRTH_DAY, S.ID_SERVICE
      from   DOC_LINE DL
             join SERVICES S on S.ID_SERVICE = DL.ID_SERVICE
             left outer join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE
             left outer join GUEST G on G.ID_GUEST = DL.ID_GUEST
             left outer join AGENT_PACKET APA on APA.ID_AGENT = G.ID_AGENT and APA.ID_SERVICE = DL.ID_SERVICE
             left outer join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
             left outer join AGENT_AGES AG on AG.ID_AGENT_AGES = G.ID_AGENT_AGES
             left outer join AGENT_TYPE_STAY ATS on ATS.ID_AGENT = G.ID_AGENT and ATS.ID_SERVICE = case when coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'BASE' then PV.ID_PACK_SERVICE else DL.ID_SERVICE end
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
             and ((PV.IS_BASE = 1) or (coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) in ('SECONDARY', 'PARALLEL')))
             and ((:IN_VAUCHER_NUM = '') or (case when coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'SECONDARY' then G.VAUCHER_NUM2 else G.VAUCHER_NUM end = :IN_VAUCHER_NUM))
      into   :DL_DBKEY, :TAX_STATUS, :ID_GUEST, :DATE_POST, :ID_TARIFA, :VAUCHER_PACKET, :IS_BASE,
             :GUEST_NAME, :IS_CHILD, :AGES_NAME, :GFROM_DATE, :GTO_DATE, :ID_RESERV_DETAIL,
             :VAUCHER_NUM, :BIRTH_DATE, :ID_SERVICE
    do begin
      if (:IS_BASE = 0) then begin
        execute procedure DOC_LINES_SUSPEND_LINE(:DL_DBKEY, :RPT_CURR, :RPT_VAT, 'NONE', :DOC_VAT_STATUS, :CORRECTION_INDEX)
        returning_values :NO_USE, :PACKET_NAME, :PACKET_PRICE, :PACKET_PRICE_WOT_DIFF, :SINGLE_PRICE, :LINE_VALUE,
                         :NO_USE, :NO_USE, :QTY_POST, :QTY_POST, :NO_USE, :NO_USE, :NO_USE;

        PACKET_PRICE = :LINE_VALUE;
        NIGHTS = 0;
      end else begin
        execute procedure DOC_LINES_SUSPEND_LINE(:DL_DBKEY, :RPT_CURR, :RPT_VAT, 'IN_PACKET', :DOC_VAT_STATUS, :CORRECTION_INDEX)
        returning_values :ID_SERVICE, :PACKET_NAME, :PACKET_PRICE, :PACKET_PRICE_WOT_DIFF, :NO_USE, :NO_USE,
                         :NO_USE, :NO_USE, :QTY_POST, :QTY_POST, :NO_USE, :NO_USE, :NO_USE;                                      

        NIGHTS = 1;
      end
      suspend;
    end
  end if (:RPT_TYPE = 'OTHER') then begin
    for
      select DL.RDB$DB_KEY, DL.LINE_NAME, G.ID_GUEST, G.ID_RESERV_DETAIL, DL.ID_SERVICE
      from   DOC_LINE DL
             join SERVICES S on S.ID_SERVICE = DL.ID_SERVICE
             left outer join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE
             left outer join GUEST G on G.ID_GUEST = DL.ID_GUEST
             left outer join AGENT_PACKET APA on APA.ID_AGENT = G.ID_AGENT and APA.ID_SERVICE = DL.ID_SERVICE
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
             and DL.TAX_STATUS in (0, 1)
             and coalesce(PV.IS_BASE, 0) = 0
             and ((coalesce(PV.ID_MASTER_ADDINS, -1) = -1)
                  or (coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'OTHER')
                  or ((coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) not in ('SECONDARY', 'PARALLEL'))
                       and not exists (select DML.ID_DOC_LINE
                                  from   DOC_LINE DML
                                         join DOC_LINE_POST_VALUES DPV on DPV.ID_DOC_LINE = DML.ID_DOC_LINE
                                  where  DML.ID_DOC_HEAD = DL.ID_DOC_HEAD
                                         and DPV.ID_ACCOUNT_POST = PV.ID_MASTER_ADDINS)) )
      into   :DL_DBKEY, :LINE_NAME, :ID_GUEST, :ID_RESERV_DETAIL, :ID_SERVICE
    do begin
      execute procedure DOC_LINES_SUSPEND_LINE(:DL_DBKEY, :RPT_CURR, :RPT_VAT, 'NONE',
        :DOC_VAT_STATUS, :CORRECTION_INDEX)
      returning_values (:NO_USE, :NO_USE, :PACKET_PRICE,
        :PACKET_PRICE_WOT_DIFF, :SINGLE_PRICE, :LINE_VALUE, :NO_USE, :NO_USE,
        :QTY_POST, :QTY_POST, :NO_USE, :NO_USE, :NO_USE);
      suspend;
    end
  end if (:RPT_TYPE = 'TAXES') then begin
    for
      select DL.RDB$DB_KEY, DL.LINE_NAME, DL.ID_SERVICE
      from   DOC_LINE DL
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
             and DL.TAX_STATUS > 1
      into   :DL_DBKEY, :LINE_NAME, :ID_SERVICE
    do begin
      execute procedure DOC_LINES_SUSPEND_LINE(:DL_DBKEY, :RPT_CURR, :RPT_VAT, 'NONE',
        :DOC_VAT_STATUS, :CORRECTION_INDEX)
      returning_values (:NO_USE, :NO_USE, :PACKET_PRICE,
        :PACKET_PRICE_WOT_DIFF, :SINGLE_PRICE, :LINE_VALUE, :NO_USE, :NO_USE,
        :QTY_POST, :QTY_POST, :NO_USE, :NO_USE, :NO_USE);
      suspend;
    end
  end
end
^

/* Alter (DOC_LINES_SUSPEND_LINE) */
ALTER PROCEDURE DOC_LINES_SUSPEND_LINE(DL_DBKEY CHAR(8),
RPT_CURR VARCHAR(20),
RPT_VAT VARCHAR(20),
RPT_PACKETS VARCHAR(10),
DOC_VAT_STATUS INTEGER,
CORRECTION_INDEX INTEGER)
 RETURNS(ID_PACK_SERVICE INTEGER,
PACK_NAME VARCHAR(50),
PACK_PRICE NUMERIC(15,2),
PACK_PRICE_WOT_DIFF DOUBLE PRECISION,
SINGLE_PRICE NUMERIC(15,4),
LINE_VALUE NUMERIC(15,4),
VAT_VALUE NUMERIC(15,4),
SINGLE_WOT_DIFF DOUBLE PRECISION,
QTY_POST NUMERIC(15,4),
PACK_QTY NUMERIC(15,4),
IS_PACKET_POST INTEGER,
SEC_CURR_LINE_VALUE NUMERIC(15,4),
SEC_CURR_GROSS_VALUE NUMERIC(15,4))
 AS
declare variable id_master_addins integer;
  declare variable id_doc_head integer;
  declare variable vat_status integer;
  declare variable is_base integer;                             
  declare variable is_base_packet_post integer;
  declare variable is_correct integer;
  declare variable id_account_post integer;
  declare variable single_with_vat numeric (15,4);
  declare variable single_wot_vat numeric (15,4);
  declare variable line_with_vat numeric (15,4);
  declare variable line_wot_vat numeric (15,4);
  declare variable pack_price_with_vat numeric (15,4);
  declare variable pack_price_wot_vat numeric (15,4);
  declare variable addins_price_wot_vat numeric (15,4);
  declare variable addins_price_with_vat numeric (15,4);
  declare variable addins_pack_price_wot_diff double precision;
  declare variable id_vat_group integer;
  declare variable round_to numeric(15,4);
  declare variable add_pack_name varchar(50);
  declare variable add_pack_name_int varchar(50);
  declare variable id_service integer;
  declare variable id_pack_hrana integer;
  declare variable is_separate_pansion integer;
  declare variable is_separate_pansion_int integer;
  declare variable line_sec_curr_wot_vat numeric(15,4);
  declare variable line_sec_curr_with_vat numeric(15,4);
  declare variable addins_sec_curr_wot_vat numeric(15,4);
  declare variable addins_sec_curr_with_vat numeric(15,4);
  declare variable pack_sec_curr_wot_vat numeric(15,4);
  declare variable pack_sec_curr_with_vat numeric(15,4);
  declare variable line_name varchar(100);
begin
  /* RPT_PACKETS - 'ALL', 'IN_PACKET', 'NONE'
  || RPT_VAT:
  ||  'line' - single price to be without vat,
  ||  'total' - single price with vat, document total by vat groups,
  ||  'none' - do not show values without vat.
  */
  round_to = 0.0001;
  if ((:rpt_vat is null) or (:rpt_vat = '')) then rpt_vat = 'as_doc';
  if (:rpt_vat = 'line') then vat_status = 2;
  else if (:rpt_vat in ('total', 'none')) then vat_status = 1;
  else vat_status = :doc_vat_status;

  select coalesce(PV.IS_BASE, 0), DL.IS_CORRECT, iif(DL.IS_CORRECT = 0, DL.QTY_POST * cast(:correction_index as smallint), DL.qty_post),
         iif(DL.is_correct <> 0, dl.single_wot_vat * cast(:correction_index as smallint), DL.SINGLE_WOT_VAT),
         iif(dl.is_correct <> 0, dl.single_value * cast(:correction_index as smallint), DL.SINGLE_VALUE),
         DL.WOT_VAT * cast(:correction_index as smallint), DL.QTY_POST * DL.SINGLE_VALUE * cast(:correction_index as smallint),
         iif(:rpt_curr = 'doc', DL.WOT_DIFF, coalesce(PV.ACCOUNT_PRICE, DL.WOT_DIFF * D.DOC_ACC_RATE)),
         PV.ID_MASTER_ADDINS, PV.ID_ACCOUNT_POST, DL.ID_DOC_HEAD, DL.ID_SALE_TAXATION,
         PV.ID_PACK_SERVICE, DL.ID_SERVICE, Sp.ID_BOARD, dl.sec_curr_net_value, dl.sec_curr_gross_value, dl.LINE_NAME
  from   DOC_LINE DL
         left join DOC_HEAD$INT D on D.ID_DOC_HEAD = Dl.ID_DOC_HEAD
         left outer join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE
         left outer join SERVICES S on S.ID_SERVICE = PV.ID_PACK_SERVICE
         left outer join SERVICE_PACKET sp on sp.ID_SERVICE = s.ID_SERVICE
  where  DL.RDB$DB_KEY = :dl_dbkey
  into   :is_base, :is_correct, :qty_post, :single_wot_vat, :single_with_vat,
         :line_wot_vat, :line_with_vat, :single_wot_diff,
         :id_master_addins, :id_account_post, :id_doc_head, :id_vat_group,
         :id_pack_service, :id_service, :id_pack_hrana, :line_sec_curr_wot_vat, :line_sec_curr_with_vat, :line_name;

  if (:is_base = 1) then begin
    is_packet_post = 1;
    id_master_addins = :id_account_post;
  end else if (:id_master_addins is not null) then begin
    select count(dlpv.id_account_post)
    from   DOC_LINE_POST_VALUES DLPV
           join DOC_LINE doc_l on doc_l.id_doc_line = dlpv.id_doc_line
    where  dlpv.id_account_post = :id_master_addins
           and dlpv.is_base = 1
           and doc_l.id_doc_head = :id_doc_head
    into   :is_base_packet_post;
    if (:is_base_packet_post > 0) then is_packet_post = 1; else is_packet_post = 0;
  end else begin
    is_packet_post = 0;
  end

  if (:rpt_curr = 'acc') then begin
    single_with_vat = :single_wot_diff;
    select sv.VALUE_WOT_TAX
    from   TAX_VALUE_DEDUCT (:single_with_vat, :round_to, :id_vat_group) sv
    into   :single_wot_vat;
    line_with_vat = :single_wot_diff*:qty_post; --*:correction_index;
    select sv.VALUE_WOT_TAX
    from   TAX_VALUE_DEDUCT (:line_with_vat, :round_to, :id_vat_group) sv
    into   :line_wot_vat;
  end
  add_pack_name = '';

  if ((:is_packet_post = 1) and (:rpt_packets <> 'NONE')) then begin
    pack_price_wot_vat  = 0;
    pack_price_with_vat = 0;
    pack_price_wot_diff = 0;
    is_separate_pansion = 1;
    pack_sec_curr_wot_vat = 0;
    pack_sec_curr_with_vat = 0;
    /* GET SUM OF ADDINS PRICES  */
    for
      select DLM.ID_SALE_TAXATION,
             S.EXTRA_PACKET_NAME,
             min(iif(Sp.ID_BOARD = :id_pack_hrana, 0, 1)),
             sum(DLM.SINGLE_WOT_VAT * DLM.QTY_POST * cast(:correction_index as smallint)),
             sum(DLM.SINGLE_VALUE * DLM.QTY_POST * cast(:correction_index as smallint)),
             sum(case when :rpt_curr = 'doc' then DLM.WOT_DIFF else PV.ACCOUNT_PRICE end * DLM.QTY_POST * cast(:correction_index as smallint)),
             sum(dlm.sec_curr_net_value),
             sum(dlm.sec_curr_gross_value)
      from   DOC_LINE DLM
             join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DLM.ID_DOC_LINE
             left outer join GUEST G on G.ID_GUEST = DLM.ID_GUEST
             left outer join AGENT_PACKET APA on APA.ID_AGENT = G.ID_AGENT and APA.ID_SERVICE = DLM.ID_SERVICE
             left outer join SERVICES S on S.ID_SERVICE = DLM.ID_SERVICE
             left outer join SERVICE_PACKET sp on sp.ID_SERVICE = s.ID_SERVICE
      where  DLM.ID_DOC_HEAD = :id_doc_head
             and PV.ID_MASTER_ADDINS = :id_master_addins
             and ((:rpt_packets = 'ALL') or (coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'BASE'))
      group by 1, 2
      into   :id_vat_group, :add_pack_name_int, :is_separate_pansion_int,
             :addins_price_wot_vat, :addins_price_with_vat, :addins_pack_price_wot_diff, :addins_sec_curr_wot_vat, :addins_sec_curr_with_vat
    do begin
      if (:add_pack_name_int <> '') then add_pack_name = :add_pack_name ||'\'|| :add_pack_name_int;
      if (:is_separate_pansion_int = 0) then is_separate_pansion = 0;
      addins_price_wot_vat = coalesce(:addins_price_wot_vat, 0);
      addins_price_with_vat = coalesce(:addins_price_with_vat, 0);
      addins_pack_price_wot_diff = coalesce(:addins_pack_price_wot_diff, 0);
      addins_sec_curr_wot_vat = coalesce(:addins_sec_curr_wot_vat, 0);
      addins_sec_curr_with_vat = coalesce(:addins_sec_curr_with_vat, 0);
      if (:rpt_curr = 'acc') then begin
        addins_price_with_vat = :addins_pack_price_wot_diff;
        select SV.VALUE_WOT_TAX
        from   TAX_VALUE_DEDUCT (:addins_price_with_vat, :round_to, :id_vat_group) sv
        into   :addins_price_wot_vat;
      end
      pack_price_wot_diff = :pack_price_wot_diff + :addins_pack_price_wot_diff;
      pack_price_with_vat = :pack_price_with_vat + :addins_price_with_vat;
      pack_price_wot_vat  = :pack_price_wot_vat + :addins_price_wot_vat;
      pack_sec_curr_wot_vat = :pack_sec_curr_wot_vat + :addins_sec_curr_wot_vat;
      pack_sec_curr_with_vat = :pack_sec_curr_with_vat + :addins_sec_curr_with_vat;
    end
    pack_qty = :qty_post * :is_base;
    if (:is_separate_pansion = 0) then id_service = :id_pack_service;

    select S.SERVICE_NAME||:add_pack_name
    from   SERVICES S
    where  S.ID_SERVICE = :ID_PACK_SERVICE
    into   :pack_name;
  end else begin
    /* NO PACKETS */
    pack_qty = :qty_post;
    pack_price_wot_vat  = :single_wot_vat;
    pack_price_with_vat = :single_with_vat;
    pack_price_wot_diff = :SINGLE_WOT_DIFF;
    is_packet_post = 0;
    pack_sec_curr_wot_vat = coalesce(:line_sec_curr_wot_vat, 0);
    pack_sec_curr_with_vat = coalesce(:line_sec_curr_with_vat, 0);
    ID_PACK_SERVICE = :id_service;
    PACK_NAME = substring(:line_name from 1 for 50);
  end

  vat_value     = :line_with_vat - :line_wot_vat;

  if (:vat_status = 1) then begin
    single_price = :single_with_vat;
    line_value   = :line_with_vat;
    pack_price   = :pack_price_with_vat;
    sec_curr_line_value  = :line_sec_curr_with_vat * :correction_index; --:pack_sec_curr_with_vat * :correction_index;
  end else if (:vat_status = 2) then begin
    single_price = :single_wot_vat;
    line_value   = :line_wot_vat;
    pack_price   = :pack_price_wot_vat;
    sec_curr_line_value = :line_sec_curr_wot_vat * :correction_index; --:pack_sec_curr_wot_vat * :correction_index;
  end
  sec_curr_gross_value = :line_sec_curr_with_vat * :correction_index; --:pack_sec_curr_with_vat * :correction_index;
  suspend;
end
^

/* Alter (DOC_TYPE_GET$INT) */
ALTER PROCEDURE DOC_TYPE_GET$INT(ID_HOTEL TYPE OF ID,
IS_PROFORMA TYPE OF TLOGICAL,
ID_ADVANCE_PAYMENT TYPE OF ID = null)
 RETURNS(ID_DOC_TYPE TYPE OF ID)
 AS
begin
  if (:IS_PROFORMA = 1 and :ID_ADVANCE_PAYMENT is not null) then
     exception DOCUMENT_EXCEPTION '-392';

  execute procedure SETTING_GET_VALUE ('DEF_DOC_TYPE', :ID_HOTEL)
  returning_values  :id_doc_type;

  if (:id_doc_type is not null) then begin
    execute procedure DOC_TYPE_EVALUATE$INT (:id_doc_type, :ID_HOTEL, :IS_PROFORMA, :ID_ADVANCE_PAYMENT);

    when any do id_doc_type = null;  -- evaluation doesn't passed
  end

  if (:id_doc_type is null) then begin
    for
      select DT.ID_DOC_TYPE
      from   DOC_TYPE_INV DT
             join DOC_TYPE TH on TH.ID_DOC_TYPE = DT.ID_DOC_TYPE
      where  TH.ID_HOTEL = :ID_HOTEL
             and TH.IS_ARCHIVE = 0
      order by dt.ID_DOC_TYPE asc
      into   :ID_DOC_TYPE
    do begin
      execute procedure DOC_TYPE_EVALUATE$INT (:id_doc_type, :ID_HOTEL, :IS_PROFORMA, :ID_ADVANCE_PAYMENT);
      break;
      when any do id_doc_type = null;  -- evaluation doesn't passed
    end
  end

  if (:id_doc_type is null) then exception DOCUMENT_EXCEPTION '-304';

end
^

/* Alter (DOCUMENT_ATTACH_AVAIL_PAYS$INT) */
ALTER PROCEDURE DOCUMENT_ATTACH_AVAIL_PAYS$INT(ID_DOC_HEAD INTEGER,
ID_ACCOUNT INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_deposit integer;
  declare variable pay_curr varchar(3);
  declare variable dep_value numeric(15,4);
  declare variable rest_value numeric(15,4);
begin

  for
    select D.ID_DEPOSIT, D.PAY_CURRENCY, D.AVAIL_VALUE
    from   DEPOSIT_AVAILABLE D
    where  D.ID_ACCOUNT = :ID_ACCOUNT
    order by D.DATETIME_CREATED asc
    into   :ID_DEPOSIT, :PAY_CURR, :DEP_VALUE
  do begin

    execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, :PAY_CURR)
    returning_values  (:dbg, :dbg, :dbg, :dbg, :REST_VALUE);

    if (:REST_VALUE > 0) then begin
      DEP_VALUE = iif(:DEP_VALUE > :REST_VALUE, :REST_VALUE, :DEP_VALUE);
      execute procedure DOCUMENT_USE_DEPOSIT$DOC (:ID_DOC_HEAD, :ID_DEPOSIT, :DEP_VALUE);

   end else begin
      exit;
    end

    when exception DOCUMENT_EXCEPTION do post_event 'dummy';
  end

end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ADD_DISCOUNTS$INT for: DOCUMENT_LINE_ADD$INT */
ALTER PROCEDURE DOCUMENT_ADD_DISCOUNTS$INT(ID_DOC_HEAD /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ADD_PAY_TAXES$INT for: DOCUMENT_LINE_ADD$INT */
ALTER PROCEDURE DOCUMENT_ADD_PAY_TAXES$INT(ID_DOC_HEAD INTEGER,
ID_PAYMENT_HEAD INTEGER,
ID_TAX_POLICY INTEGER,
DOC_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ADD_PAYMENT_LINE$INT for: DOCUMENT_LINE_ADD$INT */
ALTER PROCEDURE DOCUMENT_ADD_PAYMENT_LINE$INT(ID_DEPOSIT /* TYPE OF ID */ INTEGER,
ID_DOC_HEAD /* TYPE OF ID */ INTEGER,
DOC_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
ID_SALE_TAXATION INTEGER = null)
 RETURNS(ID_DOC_LINE /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ADD_SERVICES$INT for: DOCUMENT_LINE_ADD$INT */
ALTER PROCEDURE DOCUMENT_ADD_SERVICES$INT(ID_DOC_HEAD INTEGER,
ID_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ADVANCE_STORNO$INT for: DOCUMENT_LINE_ADD$INT */
ALTER PROCEDURE DOCUMENT_ADVANCE_STORNO$INT(ID_DEPOSIT INTEGER,
PAY_AMOUNT NUMERIC(15,2),
DESCRIPTION VARCHAR(100))
 RETURNS(ID_STORNO_DOC INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOCUMENT_LINE_ADD$INT) */
ALTER PROCEDURE DOCUMENT_LINE_ADD$INT(ID_DOC_HEAD TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_SALE_TAXATION TYPE OF ID,
LINE_NAME TYPE OF TDESCRIPTION_SHORT,
ID_GUEST TYPE OF ID,
DATE_POST TYPE OF TDATE,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
ROOM_NAME TYPE OF TROOM_NAME,
QTY_POST TYPE OF TQTY,
WOT_DIFF TYPE OF TVALUE,
DOC_CURR_GROSS_VALUE TYPE OF TPRICE,
DOC_CURR_ROUND TYPE OF TPRICE,
NAT_CURR_GROSS_VALUE TYPE OF TPRICE,
NAT_CURR_ROUND TYPE OF TPRICE,
SEC_CURR TYPE OF TCURRENCY,
SEC_CURR_GROSS_VALUE TYPE OF TPRICE,
SEC_CURR_ROUND TYPE OF TPRICE,
TAX_STATUS TYPE OF TENUM_SMALL,
IS_CORRECT TYPE OF TLOGICAL,
GROUP_TAG TYPE OF TRANGE)
 RETURNS(ID_DOC_LINE TYPE OF ID,
DOC_CURR_NET_VALUE TYPE OF TPRICE,
NAT_CURR_NET_VALUE TYPE OF TPRICE,
SEC_CURR_NET_VALUE TYPE OF TPRICE)
 AS
declare variable vat_percent numeric(15,4);
  declare variable single_value numeric(15,4);
  declare variable single_wot_vat double precision;
begin
  select cv.VALUE_WOT_TAX, cv.TAX_PERCENT
  from   TAX_VALUE_DEDUCT (:DOC_CURR_GROSS_VALUE, :DOC_CURR_ROUND, :ID_SALE_TAXATION) cv
  into   :DOC_CURR_NET_VALUE, :vat_percent;

  single_value   = :DOC_CURR_GROSS_VALUE / :QTY_POST;
  single_wot_vat = :DOC_CURR_NET_VALUE / :QTY_POST;

  select SV.VALUE_WOT_TAX
  from   TAX_VALUE_DEDUCT(:NAT_CURR_GROSS_VALUE, :NAT_CURR_ROUND, :ID_SALE_TAXATION) sv
  into   :NAT_CURR_NET_VALUE;

  if (:SEC_CURR is not null) then begin
    select SV.VALUE_WOT_TAX
    from   TAX_VALUE_DEDUCT(:SEC_CURR_GROSS_VALUE, :SEC_CURR_ROUND, :ID_SALE_TAXATION) sv
    into   :SEC_CURR_NET_VALUE;
  end else begin
    SEC_CURR_NET_VALUE = null;
  end

  insert into DOC_LINE (ID_DOC_HEAD, ID_SERVICE,
         ID_SALE_TAXATION, VAT_PERCENT, QTY_POST, WOT_DIFF, SINGLE_VALUE,
         SINGLE_WOT_VAT, WOT_VAT, TAX_STATUS, IS_CORRECT, LINE_NAME,
         GROUP_TAG, ID_GUEST, DATE_POST, FROM_DATE, TO_DATE, ROOM_NAME,
         NAT_NET_VALUE, NAT_GROSS_VALUE, SEC_CURR_NET_VALUE, SEC_CURR_GROSS_VALUE)
  values (:ID_DOC_HEAD, :ID_SERVICE,
         :ID_SALE_TAXATION, :VAT_PERCENT, :QTY_POST, :WOT_DIFF, :SINGLE_VALUE,
         :SINGLE_WOT_VAT, :DOC_CURR_NET_VALUE, :TAX_STATUS, :IS_CORRECT, :LINE_NAME,
         :GROUP_TAG, :ID_GUEST, :DATE_POST, :FROM_DATE, :TO_DATE, :ROOM_NAME,
         :nat_curr_net_value, :NAT_CURR_GROSS_VALUE, :sec_curr_net_value, :SEC_CURR_GROSS_VALUE)
  returning id_doc_line into :id_doc_line;

end
^

/* Alter (DOCUMENT_ON_PROFORMA_INIT$DOC) */
ALTER PROCEDURE DOCUMENT_ON_PROFORMA_INIT$DOC(ID_PROFORMA_DOC TYPE OF ID)
 RETURNS(ID_DOC_HEAD TYPE OF ID,
ID_HOTEL TYPE OF ID,
ID_ACCOUNT TYPE OF ID)
 AS
declare variable id_account_post id_ref;
  declare variable id_base_doc integer;
  declare variable id_doc_num integer;
  declare variable doc_date date;
  declare variable no_use varchar(255);
  declare variable proforma_date date;
  declare variable proforma_exp_date date;
  declare variable doc_type_name varchar(50);
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_NOPAY_CREATE');

  select dt.ID_DOC_NUM, a.ID_HOTEL, a.ID_ACCOUNT, d.PROFORMA_EXP_DATE, d.DOC_DATE, dt.DOC_TYPE_NAME
  from   DOC_PROFORMA d
         join DOC_TYPE dt on dt.ID_DOC_TYPE = d.ID_DOC_TYPE
         join ACCOUNT a on a.ID_ACCOUNT = d.ID_ACCOUNT
  where  d.ID_DOC = :ID_PROFORMA_DOC
  into   :id_doc_num, :id_hotel, :id_account, :proforma_exp_date, :proforma_date, :doc_type_name;

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :doc_date;

  if (:proforma_exp_date < :doc_date) then exception DOCUMENT_EXCEPTION '-394';

  if (exists (select d.ID_DOC_HEAD
              from   DOC_HEAD$INT d
                     join  DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
              where  dc.ID_DOC_PROFORMA = :ID_PROFORMA_DOC
                     and d.IS_ANUL = 0)) then exception DOCUMENT_EXCEPTION '-396';

  execute procedure DOCUMENT_DRAFT_COPY$INT (:ID_PROFORMA_DOC, :doc_date)
  returning_values (:ID_DOC_HEAD);

  for
    select dp.ID_ACCOUNT_POST
    from   DOC_LINE dl
           join DOC_LINE_POST_VALUES dp on dp.ID_DOC_LINE = dl.ID_DOC_LINE
    where  dl.ID_DOC_HEAD = :ID_PROFORMA_DOC
    into   :id_account_post
  do begin
    update ACCOUNT_POST ap
    set    ap.DOC_SELECTED = :ID_DOC_HEAD
    where  ap.ID_ACCOUNT_POST = :id_account_post;
  end 

  execute procedure DOCUMENT_CHECK_SELECTION$INT (:ID_DOC_HEAD, :id_account)
  returning_values  (:no_use, :id_base_doc, :no_use, :no_use, :no_use);

  if (:id_base_doc is not null) then exception DOCUMENT_EXCEPTION '-395';

  execute procedure CURR_RATES_PREPARE$INT (:ID_DOC_HEAD, :id_account, :proforma_date);

  execute procedure DOCUMENT_COMPLETE$INT (:ID_DOC_HEAD, :doc_date, :doc_date, :ID_PROFORMA_DOC);

  update DOC_HEAD$INT d
  set    d.DOC_TYPE_NAME = :doc_type_name,
         d.ID_DOC_NUM = :id_doc_num
  where  d.ID_DOC_HEAD = :ID_DOC_HEAD;
end
^

/* Alter (DOCUMENT_POSTING_DIFFS_SET$INT) */
ALTER PROCEDURE DOCUMENT_POSTING_DIFFS_SET$INT(ID_DOC_LINE INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SALE_TAXATION INTEGER,
POST_QTY NUMERIC(15,4),
POST_PRICE NUMERIC(15,4),
POST_RATE_IN_ACC NUMERIC(15,6),
POST_RATE_IN_DOC NUMERIC(15,6),
LINE_NAT_NET_VALUE NUMERIC(15,4),
LINE_NAT_GROSS_VALUE NUMERIC(15,4),
NAT_ROUND_TO NUMERIC(15,4))
 AS
declare variable nat_net_value numeric(15,4);
  declare variable nat_gross_value numeric(15,4);
  declare variable post_nat_net_value numeric(15,4);
  declare variable post_nat_gross_value numeric(15,4);
  declare variable is_corr_line smallint;
  declare variable net_rate_diff numeric(15,4);
  declare variable gross_rate_diff numeric(15,4);
  declare variable net_round_diff numeric(15,4);
  declare variable gross_round_diff numeric(15,4);
  declare variable id_pack_service integer;
  declare variable id_master_addins integer;
  declare variable is_base integer;
begin
  -- IMPORTANT !!!
  -- Incoming LINE_NAT_..._VALUE is stored into doc line national currency value.
  -- It is actually calculted nat value, EVENTUALLY modified with (+/-) NAT_ROUND_TO (as a result of doc line rounding algorithm),
  -- therefore CAN'T BE USED of rate diff calculations
  -- and new calculations of actual nat value is needed.
  -- Rounding differences will be stored in ..._ROUND_DIFF fields at last


  select SV.VALUE_WOT_TAX, SV.VALUE_WOT_TAX + SV.TAX_VALUE
  from   TAX_VALUE_DEDUCT(:POST_QTY * :POST_PRICE * cast(:POST_RATE_IN_DOC as double precision), :NAT_ROUND_TO, :ID_SALE_TAXATION) sv
  into   :nat_net_value, :nat_gross_value;

  select AP.POST_NET_VALUE, AP.POST_GROSS_VALUE,
         iif(AP.ID_BASE_DOC is null, 0, 1) as is_corr_line,
         AP.IS_BASE,
         iif(AP.ID_PACK_SERVICE is not null and AP.ID_PACK_SERVICE > 0, AP.ID_PACK_SERVICE, null),
         iif(AP.ID_MASTER_ADDINS_ACC_POST is not null and AP.ID_MASTER_ADDINS_ACC_POST > 0, AP.ID_MASTER_ADDINS_ACC_POST, null)
  from   ACCOUNT_POST AP
  where  AP.ID_ACCOUNT_POST = :id_account_post
  into   :post_nat_net_value, :post_nat_gross_value, :is_corr_line,
         :is_base, :id_pack_service, :id_master_addins;

  if (:is_corr_line = 1) then begin
    -- Get sum of nat value changes, after previous invoicing of this posting
    -- (open corrections nat_curr value)
    select sum(apc.NEW_POST_NET_VALUE - apc.OLD_POST_NET_VALUE),
           sum(apc.NEW_POST_GROSS_VALUE - apc.OLD_POST_GROSS_VALUE)
    from   ACCOUNT_POST_CORRECTION APC
    where  APC.ID_ACCOUNT_POST = :id_account_post
           and APC.ID_DOC_HEAD = -1
           and APC.IS_OPEN = 1
    into   :post_nat_net_value, :post_nat_gross_value;
  end

  net_rate_diff = :nat_net_value - :post_nat_net_value;
  gross_rate_diff = :nat_gross_value - :post_nat_gross_value;

  net_round_diff = :line_nat_net_value - :nat_net_value;
  gross_round_diff = :line_nat_gross_value - :nat_gross_value;

  insert into DOC_LINE_POST_VALUES (
         ID_DOC_LINE, ID_ACCOUNT_POST, IS_BASE, ID_PACK_SERVICE, ID_MASTER_ADDINS,
         ACCOUNT_PRICE, POST_RATE_IN_ACC, POST_RATE_IN_DOC,
         NET_RATE_DIFF, GROSS_RATE_DIFF, NET_ROUND_DIFF, GROSS_ROUND_DIFF)
  values (:ID_DOC_LINE, :ID_ACCOUNT_POST, :is_base, :id_pack_service, :id_master_addins,
         :POST_PRICE, :POST_RATE_IN_ACC, :POST_RATE_IN_DOC,
         :net_rate_diff, :gross_rate_diff, :net_round_diff, :gross_round_diff);

end
^

/* Alter (DOCUMENT_POSTINGS_GET$INT) */
ALTER PROCEDURE DOCUMENT_POSTINGS_GET$INT(IN_UNIQ_SELECT INTEGER,
ID_ACCOUNT INTEGER,
DOC_CURR VARCHAR(3),
DOC_RATE NUMERIC(15,6))
 RETURNS(AP_DBKEY CHAR(8),
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER,
DATE_POST DATE,
SERVICE_NAME VARCHAR(100),
QTY_POST NUMERIC(15,4),
PRICE_POST DOUBLE PRECISION,
TO_DATE DATE,
FROM_DATE DATE,
ID_SALE_TAXATION INTEGER,
IS_CORRECT INTEGER,
ID_GUEST INTEGER,
ROOM_NAME VARCHAR(10),
IS_BASE SMALLINT,
GROUP_TAG INTEGER,
MASTER_ADDINS INTEGER,
ID_PACK_SERVICE INTEGER,
RATE_POST NUMERIC(15,6),
POST_RATE_IN_DOC NUMERIC(15,6),
DOC_PRICE_WOT_DIFF DOUBLE PRECISION)
 AS
declare variable qty_post1 numeric(15,4);
  declare variable qty_post2 numeric(15,4);
  declare variable price_post1 double precision;
  declare variable price_post2 double precision;
  declare variable id_base_doc integer;
  declare variable err_text varchar(255);
  declare variable prev_id_guest integer;
  declare variable prev_id_service integer;
  declare variable apfrom_date date;
  declare variable apto_date date;
  declare variable rate_date date;
  declare variable acc_to_doc_rate varchar(30);
  declare variable is_fixed_rates integer;
  declare variable id_hotel integer;
  declare variable acc_doc_rate double precision;
  declare variable round_to numeric(15,4);
  declare variable acc_rate numeric(15,6);
  declare variable acc_curr varchar(3);
  declare variable description varchar(50);
begin
  group_tag = 0;

  /* CHECKS BY WHICH RATE CHOULD BE CONVERT ACCOUNT VALUES TO DOC VALUES ****/
  select A.ID_HOTEL, A.ACCOUNT_CURR
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :id_hotel, :acc_curr;

  execute procedure DOCUMENT_CURR_RATE_GET$INT (:IN_UNIQ_SELECT, :acc_curr)
  returning_values (:acc_rate, :round_to);

  is_fixed_rates = 0;
  execute procedure SETTING_GET_VALUE('ACCOUNT_TO_DOC_RATE', :id_hotel)
  returning_values  :acc_to_doc_rate;  /* USE 'CHECKIN_DATE' RATES */
  if (:acc_to_doc_rate = 'POSTING_RATE') then is_fixed_rates = 1;
  /* IS_FIXED_RATES = 0 - ONLY WHEN DOC_POST_RATE IS DIFFERENT FROM RATE_POST (OLD METHOD) */
  /* get postings for doc *****************************************************/
  prev_id_guest   = null;
  prev_id_service = null;
  for
    select A.RDB$DB_KEY, A.ID_ACCOUNT_POST, A.ID_SERVICE, A.ID_GUEST, A.ROOM_NAME, A.IS_BASE,
           A.DATE_POST, A.ID_PACK_SERVICE, A.ID_MASTER_ADDINS_ACC_POST,
           A.QTY_POST, A.IN_DOC_QTY, A.PRICE_POST, A.IN_DOC_VALUE, A.ID_SALE_TAXATION,
           A.ID_BASE_DOC, A.FROM_DATE, A.TO_DATE, A.RATE_POST, A.DESCRIPTION
    from   ACCOUNT_POST A
    where  A.DOC_SELECTED = :IN_UNIQ_SELECT
           and A.ID_ACCOUNT = :ID_ACCOUNT
    order by A.IS_BASE desc, A.ID_GUEST asc nulls last, A.DATE_POST asc, A.ID_SERVICE asc
    with lock
    into   :AP_DBKEY, :id_account_post, :id_service, :id_guest, :room_name, :is_base,
           :date_post, :id_pack_service, :master_addins,
           :qty_post1, :qty_post2, :price_post1, :price_post2, :id_sale_taxation,
           :id_base_doc, :apfrom_date, :apto_date, :rate_post, :description
  do begin
    if (:ID_SALE_TAXATION is null) then begin
       select :service_name||'/'||A.ID_ACCOUNT||' - '||A.ACCOUNT_NAME
       from   ACCOUNT A
       where  A.ID_ACCOUNT = :ID_ACCOUNT
       into   :err_text;

       exception UNDEFINED_VAT_GROUP :err_text;
    end

    select S.SERVICE_NAME || coalesce(' / ' || :description, '')
    from   SERVICES S
    where  S.ID_SERVICE = :ID_SERVICE
    into   :service_name;

    select G.TO_DATE, G.FROM_DATE
    from   GUEST G
    where  G.ID_GUEST = :ID_GUEST
    into   :to_date, :from_date;
    /* PREPARING DOC_LINE VALUES */
    if (:from_date is null) then from_date = :apfrom_date;
    if (:to_date is null) then to_date = :apto_date;

    if (:is_base = 1) then begin
      /* CALCULATING OUT_GROUP_TAG */
      if ((:prev_id_guest is distinct from :id_guest)) then begin
        prev_id_guest   = :id_guest;
        prev_id_service = :id_service;
      end
      if (:prev_id_service <> :id_service) then begin
        group_tag = :group_tag + 1;
        prev_id_service = :id_service;
      end
    end
    if (:is_fixed_rates = 1) then begin
      if (:acc_to_doc_rate = 'POSTING_RATE') then begin
        rate_date = :from_date;
        execute procedure CURR_RATE_GET (:doc_curr, :rate_date, :id_hotel)
        returning_values  (:doc_rate);
      end
      POST_RATE_IN_DOC = :rate_post;
      acc_doc_rate = cast(:POST_RATE_IN_DOC / :doc_rate as double precision);
    end else begin
      POST_RATE_IN_DOC = :acc_rate;
      acc_doc_rate = cast(:POST_RATE_IN_DOC / :doc_rate as double precision);
    end

    qty_post1 = round_f(:qty_post1, 1); qty_post2 = round_f(:qty_post2, 1);
    if (:id_base_doc is null) then begin
      /* NOT PAYED POSTING */
      is_correct = 0;
      qty_post = :qty_post1;
      price_post = :price_post1;
      doc_price_wot_diff = cast(:price_post * :acc_doc_rate as double precision);
      suspend;
    end else begin
      /* PARTIAL PAYED POSTING */
      if (:qty_post1 <> :qty_post2) then begin
        is_correct = 0;
        qty_post = :qty_post1 - :qty_post2;
        price_post = :price_post2;
        doc_price_wot_diff = cast(:price_post * :acc_doc_rate as double precision);
        suspend;
      end
      if (round_f(:price_post1 - :price_post2, :round_to) <> 0 and (:qty_post1 <> 0)) then begin
        is_correct = 1;
        qty_post = :qty_post1;
        price_post = :price_post1 - :price_post2;
        doc_price_wot_diff = cast(:price_post * :acc_doc_rate  as double precision );
        suspend;
      end
    end
  end
  /* end of postings select  **************************************************/
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_CLEAR_DEPOSITS$DOC for: DOCUMENT_REUSE_DEPOSITS$INT */
ALTER PROCEDURE DOCUMENT_CLEAR_DEPOSITS$DOC(ID_DOC_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_RESET_TYPE$DOC for: DOCUMENT_REUSE_DEPOSITS$INT */
ALTER PROCEDURE DOCUMENT_RESET_TYPE$DOC(ID_DOC_HEAD INTEGER,
ID_DOC_TYPE INTEGER,
DOC_CURRENCY VARCHAR(3),
PROFORMA_NAME_PREFIX VARCHAR(30))
 AS
 BEGIN EXIT; END
^

/* Alter (DOCUMENT_REUSE_DEPOSITS$INT) */
ALTER PROCEDURE DOCUMENT_REUSE_DEPOSITS$INT(OLD_ID_DOC_HEAD INTEGER,
NEW_ID_DOC_HEAD INTEGER)
 AS
declare variable ID_DEPOSIT integer;
declare variable DEPOSIT_AMOUNT numeric(15,4);
begin

  for
    select  D.ID_DEPOSIT, sum(D.USED_PAY_VALUE)
    from    DEPOSIT_DEDUCT D
    where   D.ID_DOC_USED = :OLD_ID_DOC_HEAD
    group by D.ID_DEPOSIT
    into    :ID_DEPOSIT, :DEPOSIT_AMOUNT
  do begin
    execute procedure DOCUMENT_DETACH_DEPOSIT$INT (:OLD_ID_DOC_HEAD, :ID_DEPOSIT);

    if (:NEW_ID_DOC_HEAD is not null) then begin
      execute procedure DOCUMENT_USE_DEPOSIT$DOC (:NEW_ID_DOC_HEAD, :ID_DEPOSIT, :DEPOSIT_AMOUNT);

      when exception DOCUMENT_EXCEPTION do post_event 'dummy';
    end
  end

end
^

/* Alter (DOCUMENT_STORNO$DOC) */
ALTER PROCEDURE DOCUMENT_STORNO$DOC(ID_DOC_HEAD INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_STORNO_DOC INTEGER,
ID_HOTEL INTEGER,
ID_ACCOUNT INTEGER,
WARN_CODE INTEGER)
 AS
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_STORN_WITHP');

  execute procedure DOCUMENT_STORNO$INT (:ID_DOC_HEAD, :DESCRIPTION, 1)
  returning_values  (:ID_STORNO_DOC, :ID_HOTEL, :WARN_CODE);

  select D.ID_ACCOUNT
  from   DOC_HEAD D
  where  D.ID_DOC = :id_storno_doc
  into   :id_account;

  execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :ID_DOC_HEAD, 'STORNO', f_character(29)||:DESCRIPTION);

end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_SAVE_TOTAL$INT for: DOCUMENT_TAXES_EVAL$INT */
ALTER PROCEDURE DOCUMENT_SAVE_TOTAL$INT(ID_DOC_HEAD /* ID */ INTEGER)
 RETURNS(DOC_SUB_TYPE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOCUMENT_TAXES_EVAL$INT) */
ALTER PROCEDURE DOCUMENT_TAXES_EVAL$INT(ID_DOC_HEAD INTEGER)
 AS
declare variable id_sale_tax integer;
declare variable value_wot_tax numeric(15,4);
declare variable nat_value_wot_tax numeric(15,4);
declare variable sec_value_wot_tax numeric(15,4);
declare variable tax_value numeric(15,4);
declare variable eval_wot_tax numeric(15,4);
declare variable eval_nat_wot_tax numeric(15,4);
declare variable eval_sec_wot_tax numeric(15,4);
declare variable taxable_value numeric(15,4);
declare variable total_value numeric(15,4);
declare variable sec_curr_total_value numeric(15,4);
declare variable tax_percent numeric(15,4);
declare variable wot_tax_diff numeric(15,4);
declare variable nat_wot_tax_diff numeric(15,4);
declare variable sec_wot_tax_diff numeric(15,4);
declare variable wot_vat numeric(15,4);
declare variable nat_wot_vat numeric(15,4);
declare variable sec_wot_vat numeric(15,4);
declare variable tax_name varchar(50);
declare variable dl_dbkey char(8);
declare variable pv_dbkey char(8);
declare variable compensation_idx integer;
declare variable nat_compensation_idx integer;
declare variable sec_compensation_idx integer;
declare variable doc_curr varchar(3);
declare variable nat_curr varchar(3);
declare variable sec_curr varchar(3);
declare variable doc_round_to numeric(15,4);
declare variable nat_round_to numeric(15,4);
declare variable sec_round_to numeric(15,4);
declare variable is_dep_doc integer;
declare variable taxes_cnt integer;
declare variable vat_restriction integer;
declare variable id_calc_taxation integer;
declare variable no_use varchar(255);
declare variable same_taxation_list varchar(255);
declare variable id_hotel integer;
declare variable taxation_reason type of tdescription_long;
begin
  select D.FOR_DEPOSIT, a.ID_HOTEL
  from   DOC_HEAD$INT D
         join ACCOUNT A on a.ID_ACCOUNT = d.ID_ACCOUNT
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :is_dep_doc, :id_hotel;

  execute procedure DOCUMENT_CURRS_GET$INT (:ID_DOC_HEAD)
  returning_values (:doc_curr, :no_use, :doc_round_to, :nat_curr, :nat_round_to, :sec_curr, :no_use, :sec_round_to);

  execute procedure SETTING_GET_VALUE('RESTRICT_VATS_IN_DOC', :id_hotel)
  returning_values  :vat_restriction;

  delete from DOC_TAXES DT where dt.ID_DOC_HEAD = :ID_DOC_HEAD;
  ----------------
  taxes_cnt = 0;

  for
    select  STV.TAXATION_LIST,
            STV.ID_SALE_TAXATION,
            STV.TOTAL_VALUE,
            STV.SEC_GROSS_VALUE,
            STV.WOT_TAX,
            STV.NAT_NET_VALUE,
            STV.SEC_NET_VALUE,
            TVD.VALUE_WOT_TAX,
            NTV.VALUE_WOT_TAX,
            SCV.VALUE_WOT_TAX
    from   (select dli.tax_list,
                   cast(',' || list(distinct dl.ID_SALE_TAXATION) || ',' as varchar(255)) as taxation_list,
                   min(dl.ID_SALE_TAXATION) as ID_SALE_TAXATION,
                   sum(dl.QTY_POST * dl.SINGLE_VALUE) as total_value,
                   sum(dl.NAT_GROSS_VALUE) as nat_gross_value,
                   sum(dl.SEC_CURR_GROSS_VALUE) as sec_gross_value,
                   sum(dl.WOT_VAT) as wot_tax,
                   sum(dl.NAT_NET_VALUE) as nat_net_value,
                   sum(dl.SEC_CURR_NET_VALUE) as sec_net_value
            from  (select i.ID_DOC_LINE, cast(',' || list(st.ID_SALE_TAX) || ',' as varchar(255)) as tax_list
                   from   DOC_LINE i
                          join SALE_TAXATION_TAX stt on stt.ID_SALE_TAXATION = i.ID_SALE_TAXATION
                          join SALE_TAXES st on st.ID_SALE_TAX = stt.ID_SALE_TAX
                                                and st.REVENUE_DEDUCTION_TAX is distinct from 1
                   where  I.ID_DOC_HEAD = :ID_DOC_HEAD
                   group by i.ID_DOC_LINE) dli
                  join  DOC_LINE DL on dl.id_doc_line = dli.id_doc_line
            group by dli.tax_list) STV
            left outer join TAX_VALUE_DEDUCT (STV.TOTAL_VALUE, :doc_round_to, STV.ID_SALE_TAXATION) TVD on 1=1
            left outer join TAX_VALUE_DEDUCT (STV.NAT_GROSS_VALUE, :nat_round_to, STV.ID_SALE_TAXATION) NTV on 1=1
            left outer join TAX_VALUE_DEDUCT (STV.SEC_GROSS_VALUE, coalesce(:sec_round_to, :doc_round_to), STV.ID_SALE_TAXATION) SCV on 1=1
    into    :same_taxation_list, :id_calc_taxation, :total_value, :sec_curr_total_value, :value_wot_tax, :nat_value_wot_tax, :sec_value_wot_tax,
            :eval_wot_tax, :eval_nat_wot_tax, :eval_sec_wot_tax
  do begin
    wot_tax_diff = :eval_wot_tax     -- wanted wot_tax value
                   - :value_wot_tax; -- current vot_tax value
    -- diffs must be added to doc lines
    -- line wot_vat is smaller than target wot_vat
    compensation_idx = case when :wot_tax_diff > 0 then 1
                            when :wot_tax_diff < 0 then -1
                            else 0 end;
    if (:doc_curr = :nat_curr) then begin
      nat_wot_tax_diff = :wot_tax_diff;
      nat_compensation_idx = :compensation_idx;
    end else begin
      nat_wot_tax_diff = :eval_nat_wot_tax - :nat_value_wot_tax;
      nat_compensation_idx = case when :nat_wot_tax_diff > 0 then 1
                                  when :nat_wot_tax_diff < 0 then -1
                                  else 0 end;
    end
    if (:sec_curr = :doc_curr) then begin
      sec_wot_tax_diff = :wot_tax_diff;
      sec_compensation_idx = :compensation_idx;
    end else if (:sec_curr = :nat_curr) then begin
      sec_wot_tax_diff = :nat_wot_tax_diff;
      sec_compensation_idx = :nat_compensation_idx;
    end else begin
      sec_wot_tax_diff = :eval_sec_wot_tax - :sec_value_wot_tax;
      sec_compensation_idx = case when :sec_wot_tax_diff > 0 then 1
                                  when :sec_wot_tax_diff < 0 then -1
                                  else 0 end;
    end
    --if (round_f(:wot_tax_diff, :doc_round_to) <> 0) then begin
    if ((:compensation_idx <> 0) or (:nat_compensation_idx <> 0) or (:sec_compensation_idx <> 0)) then begin
      for
        select l.RDB$DB_KEY, l.WOT_VAT, l.NAT_NET_VALUE, l.SEC_CURR_NET_VALUE, pv.RDB$DB_KEY
        from   DOC_LINE L
               left outer join TAX_VALUE_DEDUCT (l.SINGLE_VALUE * l.QTY_POST, :doc_round_to, :id_calc_taxation, 0) TV on 1=1
               left outer join DOC_LINE_DEP_VALUES DV on DV.ID_DOC_LINE = L.ID_DOC_LINE
               left outer join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = L.ID_DOC_LINE
        where  L.ID_DOC_HEAD = :ID_DOC_HEAD                                             
               and :same_taxation_list containing ',' || l.ID_SALE_TAXATION || ','
               and ((DV.ID_DEPOSIT is null) or (:is_dep_doc = 1))
               --and coalesce(L.WOT_VAT_DIFF, 0) = 0
        order by (pv.NET_ROUND_DIFF * :compensation_idx) asc nulls last,
               (tv.tax_diff_value * :compensation_idx) desc,  -- biggest wot_tax difss first
               l.SINGLE_VALUE desc
        into   :dl_dbkey, :wot_vat, :nat_wot_vat, :sec_wot_vat, :pv_dbkey
      do begin
        if (round_f(:wot_tax_diff, :doc_round_to) <> 0) then begin
          WOT_VAT = :wot_vat + :doc_round_to * :compensation_idx;
          value_wot_tax = :value_wot_tax + :doc_round_to * :compensation_idx;
          wot_tax_diff = :wot_tax_diff - :doc_round_to * :compensation_idx;
        end else begin
          compensation_idx = 0;
        end

        if ((round_f(:nat_wot_tax_diff, :nat_round_to) <> 0) and (:nat_compensation_idx * :compensation_idx  >= 0)) then begin
          -- has diff ant it isn't oposite to wot_tax_diff
          nat_wot_vat = :nat_wot_vat + :nat_round_to * :nat_compensation_idx;
          nat_wot_tax_diff = :nat_wot_tax_diff - :nat_round_to * :nat_compensation_idx;
        end else if (round_f(:nat_wot_tax_diff, :nat_round_to) = 0) then begin
          -- hasn't more diffs
          nat_compensation_idx = 0;
        end

        if ((round_f(:sec_wot_tax_diff, :sec_round_to) <> 0) and (:sec_compensation_idx * :compensation_idx  >= 0)) then begin
          -- has diff ant it isn't oposite to wot_tax_diff
          sec_wot_vat = :sec_wot_vat + :sec_round_to * :sec_compensation_idx;
          sec_wot_tax_diff = :sec_wot_tax_diff - :sec_round_to * :sec_compensation_idx;
        end else if (round_f(:sec_wot_tax_diff, :sec_round_to) = 0) then begin
          -- hasn't more diffs
          sec_compensation_idx = 0;
        end

        if ((:compensation_idx <> 0) or (:nat_compensation_idx <> 0) or (:sec_compensation_idx <> 0)) then begin
          update DOC_LINE Dl
          set    Dl.WOT_VAT = :wot_vat,
                 dl.SINGLE_WOT_VAT = :wot_vat / dl.QTY_POST,
                 dl.NAT_NET_VALUE = :nat_wot_vat,
                 dl.SEC_CURR_NET_VALUE = :sec_wot_vat
          where  DL.RDB$DB_KEY = :dl_dbkey;
  
          update DOC_LINE_POST_VALUES PV
          set    PV.NET_ROUND_DIFF = pv.NET_ROUND_DIFF + :nat_round_to * :nat_compensation_idx
          where  :nat_compensation_idx <> 0
                 and pv.RDB$DB_KEY = :pv_dbkey;
        end else begin
          leave;
        end

      end
    end
    /* insert final, evaluated tax values */
    for
      select td.ID_SALE_TAX, td.TAX_PERCENT, st.TAX_NAME, ST.TAXATION_REASON,
             sum(td.VALUE_WOT_TAX), sum(td.TAXABLE_VALUE), sum(td.TAX_VALUE)
      from   TAX_VALUE_DEDUCT (:total_value, :doc_round_to, :id_calc_taxation, 1) td
             left outer join SALE_TAXES ST on st.ID_SALE_TAX = td.ID_SALE_TAX
      group by 1, 2, 3, 4
      into   :id_sale_tax, :tax_percent, :tax_name, :taxation_reason,
             :value_wot_tax, :taxable_value, :tax_value
    do begin
      update or insert into DOC_TAXES (ID_DOC_HEAD, ID_SALE_TAX, NONTAXABLE_VALUE,
             TAXABLE_VALUE, TAX_VALUE, TAX_NAME, TAX_PERCENT, TAXATION_REASON)
      values (:ID_DOC_HEAD, :id_sale_tax, :value_wot_tax - :taxable_value,
             :taxable_value, :tax_value, :tax_name, :tax_percent, :taxation_reason)
      matching (ID_DOC_HEAD, ID_SALE_TAX);
      taxes_cnt = :taxes_cnt + 1;
    end

    if (:sec_curr is not null) then begin
      for
        select td.ID_SALE_TAX, sum(td.VALUE_WOT_TAX), sum(td.TAXABLE_VALUE), sum(td.TAX_VALUE)
        from   TAX_VALUE_DEDUCT (:sec_curr_total_value, :sec_round_to, :id_calc_taxation, 1) td
        group by 1
        into   :id_sale_tax, :value_wot_tax, :taxable_value, :tax_value
      do begin
        update DOC_TAXES DT
        set    dt.SEC_CURR_NONTAXABLE_VALUE = coalesce(dt.SEC_CURR_NONTAXABLE_VALUE, 0) + :value_wot_tax - :taxable_value,
               dt.SEC_CURR_TAXABLE_VALUE = coalesce(dt.SEC_CURR_TAXABLE_VALUE, 0) + :taxable_value,
               dt.SEC_CURR_TAX_VALUE = coalesce(dt.SEC_CURR_TAX_VALUE, 0) + :tax_value
        where  DT.ID_DOC_HEAD = :ID_DOC_HEAD
               and dt.ID_SALE_TAX = :id_sale_tax;
      end
    end
  end

  if (:vat_restriction = 1 and :taxes_cnt > 1) then exception DOCUMENT_EXCEPTION '-367';
end
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_REFUND$DOC for: DOCUMENT_VALIDATE$DOC */
ALTER PROCEDURE DEPOSIT_REFUND$DOC(ID_DEPOSIT INTEGER,
REFUND_AMOUNT NUMERIC(15,4),
REFUND_CURRENCY VARCHAR(3),
ID_PAY_DOC_TYPE INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_REFUND_PAYMENT INTEGER,
ID_STORNO_DOC INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOCUMENT_VALIDATE$DOC) */
ALTER PROCEDURE DOCUMENT_VALIDATE$DOC(ID_DOC_HEAD TYPE OF ID_REF)
 RETURNS(FIRM_DATA TYPE OF TNOTE_BLOB,
WARN_CODE TYPE OF TRANGE,
NEW_DOC_DATE TYPE OF TDATE)
 AS
declare variable no_use varchar(255);
  declare variable doc_value numeric(15,4);
  declare variable rest_value numeric(15,4);
  declare variable lines_value numeric(15,4);
  declare variable lines_wot_vat numeric(15,4);
  declare variable tax_value numeric(15,4);
  declare variable taxable_value numeric(15,4);
  declare variable round_to numeric(15,4);
  declare variable id_doc_contragent integer;
  declare variable id_doc_supplier integer;
  declare variable for_deposit integer;
  declare variable id_profile integer;
  declare variable dbkey char(8);
  declare variable id_contragent integer;
  declare variable ident_no varchar(30) ;
  declare variable action_text varchar(255);
  declare variable doc_currency varchar(3);
  declare variable is_juridical_person smallint;
  declare variable vat_ident_no varchar(30);
  declare variable id_doc_type integer;
  declare variable doc_sub_type integer;
  declare variable required_ident_no smallint;
  declare variable required_vat_no smallint;
  declare variable required_egn smallint;
  declare variable required_recipient_name smallint;
  declare variable lines_count integer;
  declare variable recipient_name varchar(100);
  declare variable id_doc_completed integer;
  declare variable action_code varchar(50);
begin

  select D.RDB$DB_KEY, D.DOC_VALUE_A, C.ROUND_TO,
         D.ID_DOC_CONTRAGENT, D.ID_DOC_SUPPLIER, D.FOR_DEPOSIT,
         A.ID_PROFILE, D.DOC_CURRENCY, D.TAXABLE_VALUE, d.ID_DOC_TYPE, d.DOC_SUB_TYPE,
         dc.ID_DOC_HEAD, ds.FIRM_DATA
  from   DOC_HEAD$INT D
         join CURRS C on C.CURR = D.DOC_CURRENCY
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         left outer join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
         left outer join DOC_SUPPLIER ds on ds.ID_DOC_SUPPLIER = d.ID_DOC_SUPPLIER
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :dbkey, :doc_value, :round_to,
         :id_doc_contragent, :id_doc_supplier, :for_deposit,
         :id_profile, :doc_currency, :taxable_value, :id_doc_type, :doc_sub_type,
         :id_doc_completed, :FIRM_DATA;

  if (:id_doc_contragent is null) then
    exception DOCUMENT_EXCEPTION '-356'; --'Contragent is not set!';

  if (:id_doc_supplier is null) then
    exception DOCUMENT_EXCEPTION '-357'; --'Supplier is not set!';

  select sum(DT.TAX_VALUE)
  from   DOC_TAXES DT
  where  DT.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :tax_value;

  /*if (round_f(:doc_value - :total_value, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Total value is not correct!';
  */
  select round_f(sum(DL.SINGLE_VALUE * DL.QTY_POST), :round_to),
         round_f(sum(DL.WOT_VAT), :round_to),
         count(*)
  from   DOC_LINE DL
  where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :lines_value, :lines_wot_vat, :lines_count;
 
  if (:lines_count = 0) then
    exception INTERNAL_DOC_EXCEPTION 'Document is empty! Not exists sale lines!';

  if (round_f(:doc_value - :lines_value, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines total value is not correct!' || :doc_value ||  ' / ' || :lines_value || ' ; '|| (:doc_value - :tax_value) ||  ' / ' || :lines_wot_vat;

  if (round_f(:doc_value - :tax_value - :lines_wot_vat, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines wot tax value is not correct!';

  if (round_f(abs(:lines_wot_vat) - abs(:taxable_value), :round_to) < 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines wot tax value is less than total taxable value!';

  if (:id_doc_completed is not null) then begin
    select DV.PAYABLE_VALUE
    from   DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, null) DV
    into   :rest_value;
  
    if (round_f(:rest_value, :round_to) <> 0) then
      exception DOCUMENT_EXCEPTION '-371'; --'Insufficient amount of payments !';
  end

  /* Validate contragent data */
  select dt.REQUIRED_IDENT_NO, dt.REQUIRED_VAT_NO, dt.REQUIRED_EGN, dt.REQUIRED_RECIPIENT_NAME
  from   DOC_TYPE_INV DT
  where  dt.ID_DOC_TYPE = :id_doc_type
  into   :required_ident_no, :required_vat_no, :required_egn, :required_recipient_name;

  select dc.ID_CONTRAGENT, dc.IS_JURIDICAL_PERSON,
         trim(coalesce(dc.IDENT_NO, '')), trim(coalesce(dc.VAT_REG_NUM, '')),
         trim(coalesce(dc.RECIPIENT_NAME, ''))
  from   DOC_CONTRAGENT dc
  where  dc.ID_DOC_CONTRAGENT = :id_doc_contragent
  into   :id_contragent, :is_juridical_person, :ident_no, :vat_ident_no, :recipient_name;

  if (:doc_sub_type = 0 and :required_ident_no = 1 and :is_juridical_person = 1 and :ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-324'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_egn = 1 and :is_juridical_person = 0 and :ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-324'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_vat_no = 1 and :is_juridical_person = 1 and :vat_ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-326'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_recipient_name = 1 and :recipient_name = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-327'; --'Recipient_name is empty.';
  /*if (:post_address = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-325'; --'Contragent address is empty.';
  /* save contragent link for profile */
  if (:id_contragent is not null) then begin
    update PROFILE P
    set    P.ID_DEF_CONTRAGENT = :id_contragent
    where  P.ID_PROFILE = :id_profile
           and P.ID_DEF_CONTRAGENT is null;
  end

  /*  */
  execute procedure DOC_CHECK_FISCAL$INT(:dbkey);
  /*  */
  execute procedure DOCUMENT_SET_NUMBER$INT (:dbkey)
  returning_values (:no_use, :no_use);
  /*  */
  if (:id_doc_completed is not null) then begin
    if (:for_deposit = 0) then begin
      /* update account posts */
      execute procedure ACCOUNT_POSTING_DOC_UPDATE$INT (:dbkey)
      returning_values :WARN_CODE;
    end

    execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT (:dbkey);
    /* ... */
    execute procedure DOCUMENT_BONUSPOINTS_APPLY$CL (:ID_DOC_HEAD);
    /* ... */
  end
  /*  */
  action_text = f_character(29) || formatfloat(:doc_value, 'F;0.00') || ' ' || :doc_currency;
  action_code = iif(:id_doc_completed is null,  'PROFORMA_CREATE', 'CREATE');
  execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :ID_DOC_HEAD, :action_code, :action_text);

  select cast('31.12.1899' as date) + count(d.ID_DOC_HEAD)
  from   DOC_HEAD$INT d
  where  d.DOC_DATE is not null
  into   :NEW_DOC_DATE;

end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_POST_TO_FRONT_ONLINE for: EAI_EXT_POST_TO_MH_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_EXT_POST_TO_MH_FRONT_ONLINE) */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  if (:CODE_TYPE = 'EXT_CODE') then begin
    execute procedure EAI_MAP_SERVICE(:SERVICE_CODE, :SERVICE_CODE, 'UNKNOWN', :id_hotel)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_SERVICE;
    if (:ERR_CODE < 0) then exit;
  end else begin
    select S.ID_SERVICE
    from   SERVICES S
    where  S.ID_SERVICE = :SERVICE_CODE
           and s.ID_HOTEL = :ID_HOTEL
    into   :ID_SERVICE;
    if (:ID_SERVICE is null) then begin
      ERR_CODE = -85;   /* Wrong value! */
      exit;
    end
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Alter (EAI_EXT_SERVICE_POST) */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable max_id_service integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_ROOM  = null;
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  select min(S.ID_SERVICE) as id_service, max(s.id_service) as max_id_service
  from   SERVICES S
  where  S.EXT_CODE = :SERVICE_EXT_CODE
         and s.IS_BASE = 0
         and s.IS_DELETED = 0
  into   :ID_SERVICE, :max_id_service;
  if (:ID_SERVICE is null) then begin
      ERR_CODE = -388;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end else if (:ID_SERVICE <> :max_id_service) then begin
      ERR_CODE = -389;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_EXT_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Alter (EAI_MAP_SERVICE) */
ALTER PROCEDURE EAI_MAP_SERVICE(SERVICE_TAG VARCHAR(30),
SERVICE_NAME VARCHAR(30),
EXTERNAL_IFC VARCHAR(30),
ID_HOTEL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_MAPPED_SERVICE INTEGER)
 AS
declare variable id_service_group integer;
  declare variable setting_code varchar(30);
  declare variable revenue_group varchar(30);
  declare variable is_base integer;
  declare variable is_deleted integer;
begin
  /*  Description:
  ||
  */
  err_code = 0;
  err_text = '';
  id_mapped_service = null;
  select first 1 S.ID_SERVICE, S.IS_BASE, s.IS_DELETED
  from   SERVICES S
  where  S.EXT_CODE = :service_tag
         and s.ID_HOTEL = :id_hotel
  order by s.ID_SERVICE asc
  into   :id_mapped_service, :is_base, :is_deleted;

  if (:is_base = 1) then begin
    ERR_CODE = -63;
    ERR_TEXT= '';
    exit;
  end
  if (:is_deleted = 1) then begin
    ERR_CODE = -64;
    ERR_TEXT= '';
    exit;
  end
  if (:id_mapped_service is not null) then exit;

  if (:external_ifc = 'POS') then revenue_group = 'Food and Beverage';
  else revenue_group = 'Other Operated departments';

  setting_code = 'IFC_'||:external_ifc||'_SRVGRP';
  execute procedure SETTING_GET_VALUE(:setting_code, :ID_HOTEL)
  returning_values  :id_service_group;

  execute procedure SERVICE_MODIFY(null, :id_service_group, 'EXTRA', :service_name, 0, 1, 0,
                    :revenue_group, null, null, :service_tag, 'BASE', '', 0, 'add', :ID_HOTEL,
                    0, 0, 0, 0, 0, 0, null, null)
  returning_values  :id_mapped_service;
end
^

/* Alter (EAI_POS_POSTING_ADD) */
ALTER PROCEDURE EAI_POS_POSTING_ADD(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
begin
  -- used external inteface - for compatability with Front 2008
  execute procedure EAI_POS_POSTING_ADD$P2E (:IN_ON_GUEST, :IN_ID_ACCOUNT, :IN_ID_GUEST, :IN_DATE_SMETKA,
          :IN_PRICE, :IN_DATETIME, :IN_OBJ_NAME, :IN_TABLE, :IN_SITE, :IN_SMETKA_NUM, :IN_POS_USER,
          :IN_ID_SMETKA, :IN_SERVICE_TAG, :IN_SERVICE_NAME)
  returning_values (:ERR_CODE, :ERR_TEXT, :OUT_ID_ACCOUNT);

end
^

/* Alter (EAI_TELECOUNT_TRANSFER) */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* Alter (END_WORK) */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable system_date date;
  declare variable id_room integer;
  declare variable id_end_work integer;
  declare variable last_closed_date date;
  declare variable mark_dirty_expired_block varchar(10);
  declare variable mark_dirty_occ_room varchar(10);
  declare variable lock_id integer;
  declare variable shift_no integer;
  declare variable init_hotel_date date;
begin

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;
  if (:system_date >= :in_next_date) then exception END_WORK_EXCEPTION '-43';
  if (:IN_NEXT_DATE > current_date + 1) then exception END_WORK_EXCEPTION '-60';

  last_closed_date = :in_next_date - 1;

  /* LOCK THE CURRENT FINANCIAL (SYSTEM) DATE  */
  lock_id = null;
  while (:lock_id is null) do begin
    lock_id = strhash_large(:system_date || :id_hotel);
    execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'lock');
  
    when any do begin
      exception END_WORK_EXCEPTION '-337' || f_character(31) || f_character(29) || FormatDate(:system_date, 'D;dd.mm.yyyy');
    end
  end

  /* RIGHT IS REQUIRED TO CHANGE THE FINANCIAL DATE IF THERE ARE GUESTS WITH OVERDUE CHECK OUT */
  if (exists(
    select *
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
    where  G.TO_DATE <= :last_closed_date
           and G.CHECK_STATUS < 1
           and RD.ID_HOTEL = :id_hotel
           and rd.IS_ANUL = 0
  )) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('EW_OVERDUE_CHECKOUT');
  end

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', 'EW');
  -- Suppress eventual right checks into next procedures - all is permitted. Is this needed(?!?)

  update ACCOUNT_POST AP
  set    ap.ROOM_NAME = (select R.ROOM_NAME
                         from   GUEST G
                                join ROOMS R on R.ID_ROOM = G.ID_ROOM
                         where  G.ID_GUEST = ap.ID_GUEST)
  where  ap.DATE_POST between :system_date and :last_closed_date
         and ap.ID_GUEST > 0;

  select coalesce(max(ew.SHIFT_NO), 0) + 1
  from   END_WORKS ew
  where  ew.PREV_DATE = :system_date
  into   :shift_no;

  id_end_work = gen_id(G_AUTO_INC_END_WORKS, 1);
  insert into END_WORKS (ID_END_WORK, PREV_DATE, NEXT_DATE, END_WORK_KIND, SHIFT_NO, ID_HOTEL)
  values (:id_end_work, :system_date, :in_next_date, 3, :shift_no, :id_hotel);

  /* CHANGE SYSTEM DATE */
  execute procedure SYSTEM_DATE_SET(:id_hotel, :in_next_date);

  /* AUTO EXPIRATION OF ROOM NUMBERS, ROOMS AND BOOKING POSITIONS */
  execute procedure RESERVS_EXPIRE$INT(:last_closed_date, :id_hotel);

  execute procedure AGENT_CONTINGENT_EXPIRE(:system_date, :last_closed_date, null, 0, 1, :id_hotel);

  /* DELETE PERSON PROFILES WITH EXPIRATION DATE */
  execute procedure PROFILE_PERSON_EXPIRE (:in_next_date);

  execute procedure SETTING_GET_VALUE('MARK_DIRTY_EXPIRED_BLOCK', :ID_HOTEL)
  returning_values  :mark_dirty_expired_block;
  if (:mark_dirty_expired_block = '1') then begin
    for
      select distinct BR.ID_ROOM
      from   BLOCK_ROOM BR
             join ROOMS R on R.ID_ROOM = BR.ID_ROOM
      where  R.ID_HOTEL = :id_hotel
             and BR.TO_DATE >= :system_date
             and BR.TO_DATE < :in_next_date
             and BR.IS_ANNUL = 0
         into :id_room
    do begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'BLOCK_EXP', 'set_dirty');

      when any do post_event 'dummy';  -- nothing
    end
  end

  execute procedure SETTING_GET_VALUE('MARK_DIRTY_OCC_ROOM', :ID_HOTEL)
  returning_values  :mark_dirty_occ_room;
  if (:mark_dirty_occ_room = '1') then begin
    for
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
             join ROOMS R on R.ID_ROOM = rm.ID_ROOM
      where  R.ID_HOTEL = :id_hotel
             and RM.BUSY_DATE = :system_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and RM.BUSY_GROUP_TYPE = 24
      into   :id_room
    do begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'EW_DAY', 'set_dirty');

      when any do post_event 'dummy';  -- nothing
    end
  end

  /* Summary data prepare */
  if (:in_next_date > :system_date) then begin
    execute procedure SUMMARY_FINANCE_SAVE$INT (:id_end_work);

    select min(e.PREV_DATE)
    from   END_WORKS E
    where  E.ID_HOTEL = :ID_HOTEL
    into   :init_hotel_date;

    execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:id_hotel, :init_hotel_date, :last_closed_date); --TODO precise the period

    execute procedure SUMMARY_FORECAST$INT(:ID_HOTEL, :system_date);
  end

  /* Delete data from temporal tables */
  delete from RESERV_ERROR;
  delete from TMP_SMALL_OCCUP;
--  delete from GUEST g where g.id_reserv_detail is null; pri regenerirane na statistikata ne vurshi rabota
  /*  */

  execute procedure CACHES_RESOLVE;

  execute procedure SYSTEM_LOG_ADD('SYSTEM', :id_end_work, 'DAY_EW', f_character(29) || :last_closed_date);

  execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'release');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', null);

  post_event 'invalidate.end_work';
end
^

/* Alter (GUEST_ACCOUNT_TRANSFER$INT) */
ALTER PROCEDURE GUEST_ACCOUNT_TRANSFER$INT(ID_GUEST INTEGER,
ID_SOURCE_ACCOUNT INTEGER,
ID_TARGET_ACCOUNT INTEGER,
SERVICE_TYPE VARCHAR(20))
 AS
declare variable dbkey char(8);
begin

  if (:service_type = 'BASE') then begin
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.ID_ACCOUNT = :id_source_account
             and AP.AC = '00'
             and AP.ID_BASE_DOC is null
             and ((AP.IS_BASE = 1) or (AP.ID_MASTER_ADDINS_ACC_POST <> -1))
      into   :dbkey
    do
      execute procedure ACCOUNT_POSTING_TRANSFER$INT(:dbkey, :id_target_account);

  end else begin
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.ID_ACCOUNT = :id_source_account
             and AP.AC = '00'
             and AP.ID_BASE_DOC is null
             and ((AP.IS_BASE = 0) and (AP.ID_MASTER_ADDINS_ACC_POST = -1))
      into   :dbkey
    do
      execute procedure ACCOUNT_POSTING_TRANSFER$INT(:dbkey, :id_target_account);

  end
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_GUEST$EXC for: GUEST_ADDRESSCARD_SET$RSV */
ALTER PROCEDURE IMPORT_GUEST$EXC(BOOKING_ID INTEGER,
PROFILE_UUID VARCHAR(40),
GUEST_UUID VARCHAR(40),
GUEST_NAME VARCHAR(100),
IS_CHILD SMALLINT,
AGE INTEGER,
IS_DIFFERENT_ARRANGER SMALLINT,
ARRIVAL DATE,
DEPARTURE DATE,
VOUCHER VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
RATING_AGE INTEGER,
KPP VARCHAR(50),
KPP_DATE DATE,
STAY_REASON VARCHAR(255),
CAR VARCHAR(30),
IS_REGISTRED SMALLINT,
PERSONAL_NUMBER VARCHAR(30),
TITLE VARCHAR(10),
PT_NAME VARCHAR(100),
PT_EXTCODE VARCHAR(50),
PASS_NUM VARCHAR(20),
PASS_PLACE VARCHAR(20),
PASS_DATE DATE,
PASS_EXP_DATE DATE,
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_DATE DATE,
SEX CHAR,
BIRTH_PLACE VARCHAR(30),
MASK VARCHAR(10),
PACKAGE VARCHAR(255),
VISA /* TDESCRIPTION_SHORT */ VARCHAR(100))
 RETURNS(GUEST_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (GUEST_ADDRESSCARD_SET$RSV) */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$RSV(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
EGN VARCHAR(30),
COUNTRY VARCHAR(10),
ID_STAY_REASON INTEGER,
IS_REGISTRED INTEGER,
PASS_PLACE VARCHAR(20),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_PLACE VARCHAR(30),
SEX CHAR,
MASK VARCHAR(10),
IS_CHILD INTEGER,
CAR VARCHAR(30),
KPP INTEGER,
KPP_DATE DATE,
PASS_EXP_DATE DATE,
AGE INTEGER,
BIRTH_DAY DATE,
VISA TDESCRIPTION_SHORT,
RATING_AGE INTEGER = null,
TITLE VARCHAR(10) = null,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable gd_dbkey char(8);
  declare variable pd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable rd_dbkey char(8);
  declare variable old_is_registred integer;
  declare variable old_guest_name1 varchar(250);
  declare variable old_guest_name2 varchar(250);
  declare variable old_id_pass_type integer;
  declare variable old_pass_num varchar(20);
  declare variable old_pass_date date;
  declare variable old_egn varchar(30);
  declare variable old_country varchar(20);
  declare variable old_id_stay_reason integer;
  declare variable old_kpp integer;
  declare variable old_kpp_date date;
  declare variable old_pass_exp_date date;
  declare variable old_birth_day date;
  declare variable old_pass_place varchar(20);
  declare variable old_city varchar(100);
  declare variable old_address varchar(100);
  declare variable old_visa TDESCRIPTION_SHORT;
  declare variable old_birth_place varchar(30);
  declare variable old_sex char(1);
  declare variable action_text varchar(250);
  declare variable tt_reg_number integer;
  declare variable id_hotel integer;
  declare variable id_tt_numerator integer;
  declare variable domestic_nation varchar(10);
  declare variable no_use varchar(255);
  declare variable is_anul smallint;
  declare variable acc_routing varchar(20);
begin
  err_code = 0;
  err_text = '';

  select G.RDB$DB_KEY, GD.RDB$DB_KEY, PD.RDB$DB_KEY,
         GD.IS_REGISTRED, PD.PERSON_NAME, PD.PERSON_NAME2, PD.ID_PASSPORT_TYPE, PD.PASS_NUM, PD.PASS_DATE,
         PD.EGN, PD.COUNTRY_CODE, GD.ID_STAY_REASON, GD.KPP, GD.KPP_DATE, PD.PASS_EXP_DATE,
         PD.BIRTH_DAY, PD.PASS_PLACE, PD.CITY, PD.ADDRESS, PD.BIRTH_PLACE, PD.SEX, rd.RDB$DB_KEY,
         g.TT_REG_NUMBER, rd.ID_HOTEL, rd.IS_ANUL, rd.ACC_ROUTING, GD.VISA
  from   GUEST G
         join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
         join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
         join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
  where  G.ID_GUEST = :id_guest
  into   :g_dbkey, :gd_dbkey, :pd_dbkey,
         :old_is_registred, :old_guest_name1, :old_guest_name2, :old_id_pass_type, :old_pass_num, :old_pass_date,
         :old_egn, :old_country, :old_id_stay_reason, :old_kpp, :old_kpp_date, :old_pass_exp_date,
         :old_birth_day, :old_pass_place, :old_city, :old_address, :old_birth_place, :old_sex, :rd_dbkey,
         :tt_reg_number, :id_hotel, :is_anul, :acc_routing, :old_visa;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, :birth_place, :egn, :id_passport_type, :pass_num, :pass_date, :pass_place,
          :pass_exp_date, :city, :address, :sex, :mask);

  update  GUEST_DATA GD
  set     GD.KPP_DATE = :kpp_date,
          GD.KPP = :kpp,
          GD.VISA = :visa,
          GD.ID_STAY_REASON = :id_stay_reason,
          GD.IS_REGISTRED = :is_registred,
          GD.USER_REGISTRED = iif(:IS_REGISTRED = 1, coalesce(GD.USER_REGISTRED, current_user), null),
          GD.CAR = :car,
          GD.RATING_AGE = :RATING_AGE
  where   GD.RDB$DB_KEY = :gd_dbkey;

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name1, :guest_name2, :country,
          :is_child, :age, :birth_day, :TITLE);

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -1);

  /*  */
  if (:IS_REGISTRED = 1 and :tt_reg_number is null and :is_anul = 0 and :acc_routing is distinct from 'OWNER') then begin
    execute procedure SETTING_GET_VALUE ('NATIVE_NATION', :id_hotel)
    returning_values :domestic_nation;

    select iif(:COUNTRY not in (:domestic_nation, '') and h.USE_DIFFERENT_TT_NUMERATORS = 1,
               h.ID_TT_NUMERATOR_2,
               h.ID_TT_NUMERATOR_1)
    from   HOTEL H
    where  h.ID_HOTEL = :id_hotel
    into   :id_tt_numerator;

    if (:id_tt_numerator is not null) then begin
      execute procedure SYSTEM_GEN_NUM('GUEST_NUM', :id_tt_numerator)
      returning_values :tt_reg_number, :no_use;
  
      update GUEST G
      set    g.TT_REG_NUMBER = :tt_reg_number
      where  G.RDB$DB_KEY = :g_dbkey;
    end
  end else if (:IS_REGISTRED is distinct from 1 and :tt_reg_number is not null) then begin
    update GUEST G
    set    g.TT_REG_NUMBER = null
    where  G.RDB$DB_KEY = :g_dbkey;
  end
  /*  */
  if ((:old_is_registred = 0) and (:is_registred = 1)) then begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'REGISTRED', '');
  end

  if ((:old_is_registred = 1) and (:old_guest_name1 <> :guest_name1)) then begin
    action_text = f_character(29)||:old_guest_name1||f_character(28)||:guest_name1;
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'CHANGE_CARD', :action_text);
  end

  if ((:old_IS_REGISTRED = 1)
      and
      ((:old_guest_name1 <> :guest_name1)
        or (:old_guest_name2 <> :guest_name2)
        or (:old_egn <> :egn)
        or (:old_id_pass_type <> :id_passport_type)
        or (:old_pass_num <> :pass_num)
        or (:old_pass_date <> :pass_date)
        or (:old_pass_exp_date <> :pass_exp_date)
        or (:old_pass_place <> :pass_place)
        or (:old_country <> :country)
        or (:old_city <> :city)
        or (:old_address <> :address)
        or (:old_visa <> :visa)
        or (:old_birth_day <> :birth_day)
        or (:old_birth_place <> :birth_place)
        or (:old_sex  <> :sex)
        or (:old_kpp <> :kpp)
        or (coalesce(:old_id_stay_reason,0) <> coalesce(:id_stay_reason,0))
        or (:old_kpp_date <> :kpp_date)
      )) then
  begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'PREREGISTRED', '');
  end

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
    returning_values  :warn_code;

  end

end
^

/* Alter (GUEST_NUMERATOR_MODIFY$INT) */
ALTER PROCEDURE GUEST_NUMERATOR_MODIFY$INT(ID_NUMERATOR INTEGER,
NUM_NAME VARCHAR(50),
NUM_NEXT INTEGER,
OPERATION VARCHAR(20),
ID_HOTEL TYPE OF ID_REF)
 RETURNS(NEW_ID_NUMERATOR INTEGER)
 AS
begin
/*  if (:operation = 'add') then in_use = 0;
  else in_use = 1;
*/
  execute procedure SYSTEM_NUMERATOR_MODIFY$INT(:id_numerator, 'GUEST_NUM',
          :num_name, :num_next - 1, '', 20, :ID_HOTEL, :operation)
  returning_values  :new_id_numerator;
end
^

/* Alter (GUEST_REROUTE_POSTINGS$INT) */
ALTER PROCEDURE GUEST_REROUTE_POSTINGS$INT(ID_GUEST INTEGER,
ID_BASE_ACCOUNT INTEGER,
ID_EXTRA_ACCOUNT INTEGER)
 AS
declare variable ap_dbkey char(8);
  declare variable is_packet_post integer;
  declare variable packet_option varchar(50);
  declare variable id_target_account integer;
  declare variable id_current_account integer;
begin
  update GUEST G
  set    G.ID_BASE_ACCOUNT = :ID_BASE_ACCOUNT,
         G.ID_ACCOUNT = :ID_EXTRA_ACCOUNT
  where  G.ID_GUEST = :ID_GUEST;

  for
    select AP.RDB$DB_KEY, iif(AP.ID_MASTER_ADDINS_ACC_POST > 0, 1, 0), S.VAUCHER_PACKET,
           ap.ID_ACCOUNT
    from   ACCOUNT_POST AP
           join SERVICES S on S.ID_SERVICE = AP.ID_SERVICE
    where  AP.ID_GUEST = :ID_GUEST
           and AP.AC = '00'
           and AP.ID_BASE_DOC is null
    into   :ap_dbkey, :is_packet_post, :packet_option, :id_current_account
  do begin
    if ((:is_packet_post = 1) and (:packet_option <> 'NONE')) then id_target_account = :id_base_account;
    else id_target_account = :id_extra_account;

    if (:id_current_account <> :id_target_account) then begin
      execute procedure ACCOUNT_POSTING_TRANSFER$INT(:ap_dbkey, :id_target_account);
    end
  end

end
^

/* Alter (GUESTS_TT_NUM_REGENERATE) */
ALTER PROCEDURE GUESTS_TT_NUM_REGENERATE(ID_HOTEL ID,
FROM_DATE TDATE)
 AS
declare variable id_numerator_1 integer;
declare variable id_numerator_2 integer;
declare variable id_numerator integer;
declare variable domestic_nation varchar(10);
declare variable use_different_tt_numerators smallint;
declare variable g_dbkey char(8);
declare variable guest_tt_number integer;
declare variable no_use varchar(255);
declare variable num1_reset_value integer;
declare variable num2_reset_value integer;
begin
  select h.ID_TT_NUMERATOR_1, h.ID_TT_NUMERATOR_2, h.USE_DIFFERENT_TT_NUMERATORS
  from   HOTEL H
  where  h.ID_HOTEL = :ID_HOTEL
  into   :id_numerator_1, :id_numerator_2, :use_different_tt_numerators;

  if (:id_numerator_1 is null) then exit;

  execute procedure SETTING_GET_VALUE ('NATIVE_NATION', :ID_HOTEL)
  returning_values  :domestic_nation;

  select coalesce(max(g.TT_REG_NUMBER), 0),
         coalesce(max(iif(pd.COUNTRY_CODE not in (:domestic_nation, '') and :use_different_tt_numerators = 1, g.TT_REG_NUMBER, null)), 0)
  from   GUEST g
         join GUEST_DATA GD on gd.ID_GUEST = g.ID_GUEST
         join PERSON_DATA pd on pd.ID_PERSON_DATA = gd.ID_PERSON_DATA
         join RESERV_DETAIL rd on rd.id_reserv_detail = g.id_reserv_detail
  where  rd.ID_HOTEL = :id_hotel
         and g.IS_CHECK_IN = 1
         and gd.IS_REGISTRED = 1
         and g.FROM_DATE between (:FROM_DATE - extract(yearday from :FROM_DATE)) and (:FROM_DATE - 1)
         and rd.IS_ANUL = 0
         and RD.ACC_ROUTING is distinct from 'OWNER'
  into   :num1_reset_value, :num2_reset_value;

  update SYSTEM_NUMERATOR sn
  set    sn.NUM_VALUE = :num1_reset_value
  where  sn.ID_NUMERATOR = :id_numerator_1;

  update SYSTEM_NUMERATOR sn
  set    sn.NUM_VALUE = :num2_reset_value
  where  sn.ID_NUMERATOR = :id_numerator_2;

  for
    select g.RDB$DB_KEY,
           iif(pd.COUNTRY_CODE not in (:domestic_nation, '') and :use_different_tt_numerators = 1,
               :id_numerator_2, :id_numerator_1),
           g.TT_REG_NUMBER
    from   GUEST g
           join GUEST_DATA GD on gd.ID_GUEST = g.ID_GUEST
           join PERSON_DATA pd on pd.ID_PERSON_DATA = gd.ID_PERSON_DATA
           join RESERV_DETAIL rd on rd.id_reserv_detail = g.id_reserv_detail
    where  rd.ID_HOTEL = :id_hotel
           and g.IS_CHECK_IN = 1
           and gd.IS_REGISTRED = 1
           and g.FROM_DATE >= :FROM_DATE
           and rd.IS_ANUL = 0
           and RD.ACC_ROUTING is distinct from 'OWNER'
    order by rd.FROM_DATE asc,
           rd.TRANSFER_IN_TIME asc nulls last,
           rd.ID_RESERV_DETAIL asc,
           g.ID_GUEST asc
    into   :g_dbkey, :id_numerator, :guest_tt_number
  do begin
    execute procedure SYSTEM_GEN_NUM('GUEST_NUM', :id_numerator)
    returning_values :guest_tt_number, :no_use;

    update GUEST G
    set    g.TT_REG_NUMBER = :guest_tt_number
    where  G.RDB$DB_KEY = :g_dbkey;
  end
end
^

/* empty dependent procedure body */
/* Clear: HOTEL_AUTO_IMPORT$WBE for: HOTEL_MODIFY$CFG */
ALTER PROCEDURE HOTEL_AUTO_IMPORT$WBE(NAME VARCHAR(50),
UUID VARCHAR(40))
 RETURNS(ID_HOTEL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_HOTEL$EXC for: HOTEL_MODIFY$CFG */
ALTER PROCEDURE IMPORT_HOTEL$EXC(HOTEL_NAME VARCHAR(50),
IS_USE SMALLINT,
CODE VARCHAR(10),
LETTER_FOOTER BLOB SUB_TYPE 1,
FIRM_DATA BLOB SUB_TYPE 1,
LETTER_HEADER BLOB SUB_TYPE 1,
ORDER_TAG INTEGER,
RES_CONFIRM_TEXT BLOB SUB_TYPE 1,
DOC_PACK_SRV_TEXT VARCHAR(50),
DOC_ONE_LINE_TEXT VARCHAR(50),
MONITOR_MAP BLOB SUB_TYPE 1,
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
UUID VARCHAR(40),
EXTERNAL_TYPE VARCHAR(50),
WBE_ENABLED SMALLINT,
CREATE_IF_NOT_FOUND SMALLINT,
NATION_CURR CHAR(3),
REG_CARD_TEXT BLOB SUB_TYPE 1 = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100),
ID_HOTEL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (HOTEL_MODIFY$CFG) */
ALTER PROCEDURE HOTEL_MODIFY$CFG(ID_HOTEL INTEGER,
HOTEL_NAME VARCHAR(50),
IS_USE SMALLINT,
CODE VARCHAR(10),
LETTER_FOOTER BLOB SUB_TYPE 1,
FIRM_DATA BLOB SUB_TYPE 1,
LETTER_HEADER BLOB SUB_TYPE 1,
ID_LOGO INTEGER,
ORDER_TAG INTEGER,
RES_CONFIRM_TEXT BLOB SUB_TYPE 1,
DOC_PACK_SRV_TEXT VARCHAR(50),
DOC_ONE_LINE_TEXT VARCHAR(50),
EXTERNAL_TYPE VARCHAR(50),
HOTEL_ADDRESS VARCHAR(100),
OPERATION VARCHAR(10),
NATION_CURR CHAR(3),
REG_CARD_TEXT BLOB SUB_TYPE 1 = null,
USE_DIFFERENT_TT_NUMERATORS TLOGICAL = null)
 RETURNS(NEW_ID_HOTEL INTEGER)
 AS
declare variable id_extra_rate integer;
  declare variable init_sys_date date;
  declare variable new_id_physical_allotment integer;
  declare variable new_id_overbook_allotment integer;
  declare variable id_guest_numerator integer;
  declare variable tt_numerator_use integer;
  declare variable tt_numerator_1 integer;
  declare variable tt_numerator_2 integer;
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  new_id_hotel = :id_hotel;
  if (:operation = 'add') then begin

    execute procedure ALLOTMENT_CREATE$INT
    returning_values  :new_id_overbook_allotment;

    execute procedure ALLOTMENT_CREATE$INT
    returning_values  :new_id_physical_allotment;

    new_id_hotel = gen_id(GEN_HOTEL_ID,1);
    init_sys_date = '01.01.2011';
    code = coalesce(:code, :NEW_ID_HOTEL);

    insert into HOTEL (ID_HOTEL, HOTEL_NAME, IS_USE, CODE, FIRM_DATA, LETTER_HEADER, LETTER_FOOTER, ID_LOGO, SYSTEM_DATE,
           ID_OVERBOOK_ALLOTMENT, ID_PHYSICAL_ALLOTMENT, ID_INVENTORY_ALLOTMENT, ORDER_TAG,
           RES_CONFIRM_TEXT, DOC_PACK_SRV_TEXT, DOC_ONE_LINE_TEXT, EXTERNAL_TYPE, HOTEL_ADDRESS, NATION_CURR, REG_CARD_TEXT)
    values (:new_id_hotel, :hotel_name, :is_use, :code, :firm_data, :letter_header, :letter_footer, :id_logo, :init_sys_date,
           :new_id_overbook_allotment, :new_id_physical_allotment, :new_id_physical_allotment, :order_tag,
           :res_confirm_text, :doc_pack_srv_text, :doc_one_line_text, :external_type, :hotel_address, :nation_curr, :reg_card_text);
    --returning subscriber_id into :subscriber_id;

    execute procedure GUEST_NUMERATOR_MODIFY$INT (null, :CODE || '_GUEST_NUM', 1, 'add', :NEW_ID_HOTEL)
    returning_values  :id_guest_numerator;

    select si.INFO_VALUE
    from   SYSTEM_INFO_GET ('TT_NUMERATOR_USE') si
    into   :tt_numerator_use;

    if (:tt_numerator_use = 1) then begin
      execute procedure GUEST_NUMERATOR_MODIFY$INT (null, :CODE || '_TT_NUM_1', 1, 'add', :new_id_hotel)
      returning_values  :tt_numerator_1;
      execute procedure GUEST_NUMERATOR_MODIFY$INT (null, :CODE || '_TT_NUM_2', 1, 'add', :new_id_hotel)
      returning_values  :tt_numerator_2;
    end

    execute procedure TARIFA_MODIFY$CFG(null, null, 'Extra service rates', null, :NATION_CURR, 1, '', :new_id_hotel, 0, null, 1, 'addextra')
    returning_values  :id_extra_rate;

    update HOTEL H
    set    h.ID_GUEST_NUMERATOR = :id_guest_numerator,
           h.ID_TT_NUMERATOR_1 = :tt_numerator_1,
           h.ID_TT_NUMERATOR_2 = :tt_numerator_2,
           h.USE_DIFFERENT_TT_NUMERATORS = :USE_DIFFERENT_TT_NUMERATORS,
           H.ID_EXTRA_RATE = :id_extra_rate
    where  h.ID_HOTEL = :NEW_ID_HOTEL;

    execute procedure RES_TEMPLATE_MODIFY$CFG (gen_id(GEN_RES_TEMPLATE_ID,1),
      1, 0, null, null, null, 'dinner', -2, null, null, null, :new_id_hotel,
      '', 'TU', 'VA', '', '', NULL);

    execute procedure CURR_RATE_MODIFY (:NATION_CURR, :NEW_ID_HOTEL, 1, :init_sys_date);

    insert into RIGHTS_USER_HOTEL (USER_NAME, ID_HOTEL)
    values (current_user, :NEW_ID_HOTEL);

  end else if (:operation = 'mod') then begin
    update HOTEL h
    set    HOTEL_NAME = :hotel_name,
           IS_USE = :is_use,
           CODE = :code,
           FIRM_DATA = :firm_data,
           LETTER_HEADER = :letter_header,
           LETTER_FOOTER = :letter_footer,
           ID_LOGO = :id_logo,
           ORDER_TAG = :order_tag,
           RES_CONFIRM_TEXT = :res_confirm_text,
           DOC_PACK_SRV_TEXT = :doc_pack_srv_text,
           DOC_ONE_LINE_TEXT = :doc_one_line_text,
           EXTERNAL_TYPE = :external_type,
           HOTEL_ADDRESS = :hotel_address,
           REG_CARD_TEXT = :reg_card_text,
           USE_DIFFERENT_TT_NUMERATORS = coalesce(:USE_DIFFERENT_TT_NUMERATORS, h.USE_DIFFERENT_TT_NUMERATORS)
    where  ID_HOTEL = :id_hotel;
  end else if (:operation = 'del') then begin
    select h.ID_LOGO
    from   HOTEL h
    where  h.ID_HOTEL = :id_hotel
    into   :ID_LOGO;

    delete from HOTEL
    where  ID_HOTEL = :id_hotel;

    if (:ID_LOGO is not null) then begin
      execute procedure PICTURE_MODIFY(:ID_LOGO, null, null, null, 'del')
      returning_values  (:ID_LOGO);
    end
  end
end
^

/* Alter (IMPORT_CURRENCY_RATE$EXC) */
ALTER PROCEDURE IMPORT_CURRENCY_RATE$EXC(ID_HOTEL INTEGER,
CURRENCY CHAR(3),
ROUND_TO NUMERIC(15,6),
DATETIME TIMESTAMP,
RATE NUMERIC(15,6))
 AS
begin
  if (:CURRENCY is null) then exit;

  execute procedure import_mark_transaction$exc;

  if (:ROUND_TO is null) then begin
    ROUND_TO = 0.01;
  end

  if (not exists(select curr from CURRS where curr = :CURRENCY)) then begin
    execute procedure CURR_MODIFY(:CURRENCY, null, :ROUND_TO, '0.00', 'add');
  end

  /*update currs_history
  set rate=:rate
  where id_hotel=:id_hotel and currency = :currency and datetime = :datetime;

  if (0 = row_count) then begin
    execute procedure curr_rate_modify(:currency,  :id_hotel, :rate);
  end*/

  execute procedure CURR_RATE_MODIFY(:currency, :id_hotel, :rate, :DATETIME);
end
^

/* Alter (IMPORT_GUEST$EXC) */
ALTER PROCEDURE IMPORT_GUEST$EXC(BOOKING_ID INTEGER,
PROFILE_UUID VARCHAR(40),
GUEST_UUID VARCHAR(40),
GUEST_NAME VARCHAR(100),
IS_CHILD SMALLINT,
AGE INTEGER,
IS_DIFFERENT_ARRANGER SMALLINT,
ARRIVAL DATE,
DEPARTURE DATE,
VOUCHER VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
RATING_AGE INTEGER,
KPP VARCHAR(50),
KPP_DATE DATE,
STAY_REASON VARCHAR(255),
CAR VARCHAR(30),
IS_REGISTRED SMALLINT,
PERSONAL_NUMBER VARCHAR(30),
TITLE VARCHAR(10),
PT_NAME VARCHAR(100),
PT_EXTCODE VARCHAR(50),
PASS_NUM VARCHAR(20),
PASS_PLACE VARCHAR(20),
PASS_DATE DATE,
PASS_EXP_DATE DATE,
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_DATE DATE,
SEX CHAR,
BIRTH_PLACE VARCHAR(30),
MASK VARCHAR(10),
PACKAGE VARCHAR(255),
VISA TDESCRIPTION_SHORT)
 RETURNS(GUEST_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable warn_code integer;

declare variable birth_date_old date;
declare variable title_old varchar(10);
declare variable id_passport_type_old integer;
declare variable pass_num_old varchar(20);
declare variable pass_date_old date;
declare variable personal_number_old varchar(30);
declare variable id_stay_reason_old integer;
declare variable is_registred_old integer;
declare variable pass_place_old varchar(20);
declare variable city_old varchar(100);
declare variable address_old varchar(100);
declare variable birth_place_old varchar(30);
declare variable sex_old char(1);
declare variable mask_old varchar(10);
declare variable car_old varchar(30);
declare variable kpp_id_old integer;
declare variable kpp_date_old date;
declare variable pass_exp_date_old date;
declare variable rating_age_old integer;
declare variable visa_old tdescription_short;

declare variable guest_name_old varchar(100);
declare variable is_child_old integer;
declare variable is_different_arranger_old smallint;
declare variable arrival_old date;
declare variable departure_old date;
declare variable voucher_old varchar(30);
declare variable voucher_date_old date;
declare variable voucher_text_old varchar(30);
declare variable country_code_old varchar(10);

declare variable id_passport_type integer;
declare variable kpp_id integer;
declare variable id_stay_reason integer;
begin
  execute procedure import_mark_transaction$exc;

  guest_name = substring(:guest_name from 1 for 50);

  execute procedure sys_dbg('exc IMPORT_GUEST$EXC(:guest_uuid=>' || coalesce(:guest_uuid, '<null>') || ')');
  guest_id = null;

  select pd.person_name, --g.is_different_organizer,
         g.id_guest, g.from_date, g.to_date,
         pd.birthday_internal, pd.title, pd.id_passport_type,
         pd.pass_num, pd.pass_date, pd.egn, gd.id_stay_reason,
         gd.is_registred, pd.pass_place, pd.city, pd.address, pd.birth_place,
         pd.sex, pd.mask, g.is_child, gd.car, gd.kpp, gd.kpp_date,
         pd.pass_exp_date, gd.rating_age, g.vaucher_num, g.vaucher_date, g.vaucher_text, pd.country_code,
         gd.id_stay_reason, gd.visa
  from   GUEST g
         join guest_data gd on gd.id_guest=g.id_guest
         join person_data pd on pd.id_person_data=gd.id_person_data
  where  g.uuid=:guest_uuid
         and g.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and g.id_reserv_detail=:booking_id
  into   :guest_name_old, --:is_different_arranger_old,
         :guest_id, :arrival_old, :departure_old, :birth_date_old,
         :title_old, :id_passport_type_old,
         :pass_num_old, :pass_date_old, :personal_number_old, :id_stay_reason_old,
         :is_registred_old, :pass_place_old, :city_old, :address_old, :birth_place_old,
         :sex_old, :mask_old, :is_child_old, :car_old, :kpp_id_old, :kpp_date_old,
         :pass_exp_date_old, :rating_age_old, :voucher_old, :voucher_date_old,
         :voucher_text_old, :country_code_old, :id_stay_reason_old, :visa_old;

  execute procedure import_passport_type$exc(:pt_name, pt_extcode)
  returning_values :id_passport_type;

  execute procedure import_kpp$exc(:kpp, null)
  returning_values :kpp_id;

  execute procedure import_stay_reason$exc(:stay_reason, null)
  returning_values :id_stay_reason;

  guest_name = coalesce(:guest_name, :guest_name_old);
--  DISABLE age/is_child merge (RIU rating cases)
--  is_child = coalesce(:is_child, :is_child_old);
--  is_different_arranger = coalesce(:is_different_arranger, :is_different_arranger_old);
  arrival = coalesce(:arrival, :arrival_old);
  departure = coalesce(:departure, :departure_old);
  voucher = coalesce(:voucher, :voucher_old);
  voucher_date = coalesce(:voucher_date, :voucher_date_old);
  voucher_text = coalesce(:voucher_text, :voucher_text_old);
  country_code = coalesce(:country_code, :country_code_old);

--  DISABLE age/is_child merge (RIU rating cases)
--  rating_age = coalesce(:rating_age, :rating_age_old);
  kpp_id = coalesce(:kpp_id, :kpp_id_old);
  kpp_date = coalesce(:kpp_date, :kpp_date_old);
  id_stay_reason = coalesce(:id_stay_reason, :id_stay_reason_old);
  car = coalesce(:car, :car_old);
  is_registred = coalesce(:is_registred, 0);
  if (1 = :is_registred_old) then begin --one way update
    is_registred = 1;
  end
  personal_number = coalesce(:personal_number, :personal_number_old);
  title = coalesce(:title, :title_old);
  id_passport_type = coalesce(:id_passport_type, :id_passport_type_old);
  pass_num = coalesce(:pass_num, :pass_num_old);
  pass_place = coalesce(:pass_place, :pass_place_old);
  pass_date = coalesce(:pass_date, :pass_date_old);
  pass_exp_date = coalesce(:pass_exp_date, :pass_exp_date_old);
  city = coalesce(:city, :city_old);
  address = coalesce(:address, :address_old);
  birth_date = coalesce(:birth_date, :birth_date_old);
  sex = coalesce(:sex, :sex_old);
  birth_place = coalesce(:birth_place, :birth_place_old);
  mask = coalesce(:mask, :mask_old);
  visa = coalesce(:visa, :visa_old);

  if (guest_id is null) then begin
    execute procedure RES_GUEST_SAVE$RSV(null, :booking_id, :guest_name, null, null, :is_child, :COUNTRY_CODE)
    returning_values :guest_id;

    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - get_next_auto_guest = :guest_id=>' || coalesce(:guest_id, '<null>'));
    if (:guest_id is null) then begin 
      execute procedure sys_dbg('exc IMPORT_GUEST$EXC - exhausted auto guests list - create new guest');
      execute procedure RES_GUEST_ADD$RSV(:booking_id, :is_child)
      returning_values :err_code, :err_text, :warn_code, :guest_id;
      if (0 <> :err_code) then exit;
    end

    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - update_new_guest_uuid(:guest_id=>' || coalesce(:guest_id, '<null>') || ', :uuid=>' || coalesce(:guest_uuid, '<null>') || ')');
    update GUEST
    set    uuid = :guest_uuid
    where  id_guest=:guest_id;

    /* preserve default mask */
    if (:mask is null) then begin
      select pd.mask
      from   guest_data gd
             join person_data pd on pd.id_person_data=gd.id_person_data
      where  gd.id_guest=:guest_id
      into   :mask;
    end          
  end else begin
    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - update_guest(:update_guest_id=>' || coalesce(:guest_id, '<null>') || ')');

--    DISABLE age/is_child merge (RIU rating cases) 
--    if (:age is null) then begin
--      select age from GUEST_AGE_CALC(:guest_id)
--      into :age;
--    end
  end

  /*
  execute procedure sys_dbg('exc IMPORT_GUEST$EXC->GUEST_ADDRESSCARD_SET$RSV('
  || 'update_guest_id => ' || coalesce(:update_guest_id, '<null>')
  || ', guest_name => ' || coalesce(:guest_name, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  || ', :id_passport_type => ' || coalesce(:id_passport_type, '<null>')
  || ', :pass_num => ' || coalesce(:pass_num, '<null>')
  || ', :pass_date => ' || coalesce(:pass_date, '<null>')
  || ', :egn => ' || coalesce(:egn_old, '<null>')
  || ', :country => ' || coalesce(:country_old, '<null>')
  || ', :id_stay_reason => ' || coalesce(:id_stay_reason, '<null>')
  || ', :is_registred => ' || coalesce(:is_registred, '<null>')
  || ', :pass_place => ' || coalesce(:pass_place, '<null>')
  || ', :city => ' || coalesce(:city, '<null>')
  || ', :address => ' || coalesce(:address, '<null>')
  || ', :birth_place => ' || coalesce(:birth_place, '<null>')
  || ', :sex => ' || coalesce(:sex, '<null>')
  || ', :mask => ' || coalesce(:mask, '<null>')
  || ', :is_child => ' || coalesce(:is_child, '<null>')
  || ', :car => ' || coalesce(:car, '<null>')
  || ', :kpp => ' || coalesce(:kpp_old, '<null>')
  || ', :kpp_date => ' || coalesce(:kpp_date, '<null>')
  || ', :pass_exp_date => ' || coalesce(:pass_exp_date, '<null>')
  || ', :age => ' || coalesce(:age, '<null>')
  || ', :birth_date => ' || coalesce(:birth_date, '<null>')
  || ', :rating_age => ' || coalesce(:rating_age, '<null>')
  || ', :title => ' || coalesce(:title, '<null>')
  ||')');
  */
  execute procedure GUEST_ADDRESSCARD_SET$RSV(
    :guest_id,
    :guest_name,
    null,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :personal_number,
    :country_code,
    :id_stay_reason,
    :is_registred,
    :pass_place,
    :city,
    :address,
    :birth_place,
    :sex,
    :mask,
    :is_child,
    :car,
    :kpp_id,
    :kpp_date,
    :pass_exp_date,
    :age,
    :birth_date,
    :visa,
    :rating_age,
    :title,
    0
  )
  returning_values :err_code, :err_text, :warn_code;
  if (0 <> :err_code) then exit;

  --execute procedure RES_GUEST_SAVE_ORGANIZER$RSV(:guest_id, :is_different_arranger);

  if ((:arrival is not null) and (:departure is not null)) then begin
    execute procedure RES_GUEST_SAVE_STAY$RSV(:guest_id, :arrival, :departure)
    returning_values :err_code, :err_text, :warn_code;
    if (0 <> :err_code) then exit;
  end

  if (:voucher is not null) then begin
    execute procedure RES_GUEST_SAVE_VOUCHER$RSV(:guest_id, :voucher,
            :voucher_date, :voucher_text, null, null);
  end

  execute procedure IMPORT_GUEST_PACK$EXC(:guest_id, :package);

  update GUEST
  set    ORPHANED_IMPORT$EXC = null
  where  id_guest=:guest_id;
end
^

/* Alter (IMPORT_HOTEL$EXC) */
ALTER PROCEDURE IMPORT_HOTEL$EXC(HOTEL_NAME VARCHAR(50),
IS_USE SMALLINT,
CODE VARCHAR(10),
LETTER_FOOTER BLOB SUB_TYPE 1,
FIRM_DATA BLOB SUB_TYPE 1,
LETTER_HEADER BLOB SUB_TYPE 1,
ORDER_TAG INTEGER,
RES_CONFIRM_TEXT BLOB SUB_TYPE 1,
DOC_PACK_SRV_TEXT VARCHAR(50),
DOC_ONE_LINE_TEXT VARCHAR(50),
MONITOR_MAP BLOB SUB_TYPE 1,
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
UUID VARCHAR(40),
EXTERNAL_TYPE VARCHAR(50),
WBE_ENABLED SMALLINT,
CREATE_IF_NOT_FOUND SMALLINT,
NATION_CURR CHAR(3),
REG_CARD_TEXT BLOB SUB_TYPE 1 = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100),
ID_HOTEL INTEGER)
 AS
declare variable logo_operation varchar(10);
declare variable hotel_operation varchar(10);
declare variable id_logo integer;
declare variable hotel_address varchar(100);
begin
  execute procedure import_mark_transaction$exc;

  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_HOTEL = null;
  ID_LOGO = null;

  select h.ID_HOTEL, h.ID_LOGO, H.HOTEL_ADDRESS
  from   HOTEL h
  where  h.UUID = :UUID
         and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :id_hotel, :id_logo, :hotel_address;

  if (:ID_HOTEL is null) then begin
    if (:create_if_not_found is distinct from 1) then exit;

    hotel_operation = 'add';
  end else begin
    hotel_operation = 'mod';
  end

  if (ID_LOGO is null) then begin
    LOGO_OPERATION = 'add';
  end else begin
    LOGO_OPERATION = 'mod';
  end

  execute procedure PICTURE_MODIFY(:ID_LOGO, :PICTURE, :PICTURE_TYPE, :PICTURE_LAYOUT, :LOGO_OPERATION)
  returning_values :ID_LOGO;

  execute procedure HOTEL_MODIFY$CFG(:ID_HOTEL, :HOTEL_NAME, :IS_USE, :CODE,
    :LETTER_FOOTER, :FIRM_DATA, :LETTER_HEADER, :ID_LOGO, :ORDER_TAG,
    :RES_CONFIRM_TEXT, :DOC_PACK_SRV_TEXT, :DOC_ONE_LINE_TEXT, :EXTERNAL_TYPE, :hotel_address, :HOTEL_OPERATION, :NATION_CURR, :REG_CARD_TEXT)
  returning_values :ID_HOTEL;

  update HOTEL h
  set    h.MONITOR_MAP = :MONITOR_MAP,
         h.UUID = :UUID,
         h.WBE_ENABLED = :WBE_ENABLED
  where  h.ID_HOTEL = :ID_HOTEL;
end
^

/* Alter (IMPORT_RATE_RECORD_RELINK$EXC) */
ALTER PROCEDURE IMPORT_RATE_RECORD_RELINK$EXC(ID_RATE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ID_COLUMN integer;
declare variable ID_NEW_MASTER_RECORD integer;

declare variable PERIOD_DEPEND_ON_CHECKIN INTEGER;
declare variable CNT_DAYS_PRICE_BP INTEGER;
declare variable CNT_DAYS_PRICE_BOARD INTEGER;
declare variable BASE_BOARDS_LIST VARCHAR(255);
declare variable BOARD_TYPE VARCHAR(10);
begin
  execute procedure import_mark_transaction$exc;

  ERR_CODE = 0;
  ERR_TEXT = '';
  for
    select c.ID_TAR_DEFINE_COLUMN, im.ID_NEW
    from   TAR_UI_DEFINE_COLUMNS c
           join IDS_MAP$TMP im on c.ID_DIM2 = im.ID_OLD
    where  c.ID_TAR_HEAD = :ID_RATE
    into   :ID_COLUMN, :ID_NEW_MASTER_RECORD
  do begin
    update TAR_UI_DEFINE_COLUMNS c
    set    c.ID_DIM2 = :ID_NEW_MASTER_RECORD
    where  c.ID_TAR_DEFINE_COLUMN = :ID_COLUMN;
  end

  delete from IDS_MAP$TMP;


  select
        th.PERIOD_DEPEND_ON_CHECKIN,
        th.CNT_DAYS_PRICE_BP,
        th.CNT_DAYS_PRICE_BOARD,
        th.BASE_BOARDS_LIST,
        th.BOARD_TYPE
  from  TAR_HEAD th
  where th.ID_TAR_HEAD = :ID_RATE
  into  :PERIOD_DEPEND_ON_CHECKIN, :CNT_DAYS_PRICE_BP, :CNT_DAYS_PRICE_BOARD, :BASE_BOARDS_LIST, :BOARD_TYPE;

  for
    select ERR_CODE, ERR_TEXT
    from   TAR_SAVE(:ID_RATE, :PERIOD_DEPEND_ON_CHECKIN, :CNT_DAYS_PRICE_BP, :CNT_DAYS_PRICE_BOARD, :BASE_BOARDS_LIST, :BOARD_TYPE)
    into   :err_code, :err_text
  do begin
    if (0 <> :err_code) then begin
      exit;
    end
  end
end
^

/* Alter (NUMERATOR_MODIFY$CFG) */
ALTER PROCEDURE NUMERATOR_MODIFY$CFG(ID_NUMERATOR INTEGER,
NUM_NAME VARCHAR(50),
NUM_NEXT INTEGER,
LEADING_PART VARCHAR(20),
NUM_LENGTH INTEGER,
NUM_CLASS TYPE OF TNAME_SHORT,
ID_HOTEL TYPE OF ID_REF,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_NUMERATOR INTEGER)
 AS
begin

  if (:NUM_CLASS = 'BOOKING') then ID_HOTEL = null;

  execute procedure SYSTEM_NUMERATOR_MODIFY$INT(:id_numerator, :num_class, :num_name, :num_next - 1, :leading_part,
                    :num_length, :id_hotel, :operation)
  returning_values  :new_id_numerator;
end
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE_OCCUPANCY$INT for: OCCUPANCY_OVERBOOK_CHECK$INT */
ALTER PROCEDURE RES_FINALIZE_OCCUPANCY$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ERROR_CONTEXT VARCHAR(200),
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (OCCUPANCY_OVERBOOK_CHECK$INT) */
ALTER PROCEDURE OCCUPANCY_OVERBOOK_CHECK$INT(ID_AGENT INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM_TYPE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable must_check_overbook integer;
  declare variable maxbook_date  date;
  declare variable maxbook_rooms  integer;
  declare variable agent_maxbook_date date;
  declare variable agent_maxbook_rooms integer;
  declare variable id_inventory_allotment integer;
  declare variable id_agent_contingent integer;
  declare variable available_rooms integer;
  declare variable problem_date date;
  declare variable room_type varchar(20);
  declare variable id_hotel integer;
begin
  /* 1. DEALING WITH THE TOTAL OVERBOOK.
  || 2. DEALING WITH THE CONTINGENT OVERBOOK.
  */
  err_code = 0;
  err_text = '';
  warn_code = null;

  /* CHECK THE TOTAL HOTEL AVAILABILITY*/
  select H.ID_INVENTORY_ALLOTMENT, RT.TYPE_ROOM, h.ID_HOTEL
  from   ROOM_TYPES RT
         join HOTEL H on H.ID_HOTEL = RT.ID_HOTEL
  where  RT.ID_ROOM_TYPE = :id_room_type
  into   :id_inventory_allotment, :room_type, :id_hotel;

  execute procedure SETTING_GET_VALUE('CHECK_OVERBOOK', :id_hotel)
  returning_values  :must_check_overbook;

  if (:must_check_overbook = 0) then exit;
  /* ********************************** */
  execute procedure OCCUPANCY_OVERBOOK_MAX$INT(:from_date, :to_date, :id_inventory_allotment, :id_room_type)
  returning_values  :maxbook_date, :maxbook_rooms, :available_rooms;

  if (:available_rooms < 0) then begin
    problem_date = :maxbook_date;
    err_text = substring(f_character(29)||cast(abs(:available_rooms) as integer)||f_character(28)||FormatDate(:problem_date, 'D;dd.mm.yyyy')||f_character(28)||:room_type from 1 for 255);

    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_TOTAL_OVERBOOK');

    execute procedure SYSTEM_WARNING_ADD(-95, :err_text)
    returning_values :warn_code;

    when exception RIGHT_NOT_GRANTED do begin
      err_code = -94;
      exit;
    end
  end

  /* check agent contingent overbooko *****************************************/
  select PA.ID_CONTINGENT
  from   PROFILE_AGENT PA
  where  PA.ID_AGENT = :id_agent
  into   :id_agent_contingent;

  if (:id_agent_contingent is not null) then begin
    /* CHECK THE AGENT CONTINGENT AVAILABILITY*/
    execute procedure OCCUPANCY_OVERBOOK_MAX$INT(:from_date, :to_date, :id_agent_contingent, :id_room_type, :id_agent)
    returning_values  :agent_maxbook_date, :agent_maxbook_rooms, :available_rooms;
  
    if (:available_rooms < 0) then begin
      problem_date = :agent_maxbook_date;
      err_text = f_character(29)||FormatDate(:problem_date, 'D;dd.mm.yyyy')||f_character(28)||:room_type||f_character(28)||cast(abs(:available_rooms) as integer);
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CONT_OVERBOOK');

      execute procedure SYSTEM_WARNING_ADD(-97, :err_text)
      returning_values :warn_code;

      when exception RIGHT_NOT_GRANTED do begin
        err_code = -96;
        exit;
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: OCCUPANCY_ROOMS_CHECK$INT for: OCCUPANCY_ROOM_VALIDATE$INT */
ALTER PROCEDURE OCCUPANCY_ROOMS_CHECK$INT(OCCUPANT_DBKEY CHAR(8),
BUSY_GROUP_SOURCE INTEGER)
 RETURNS(SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (OCCUPANCY_ROOM_VALIDATE$INT) */
ALTER PROCEDURE OCCUPANCY_ROOM_VALIDATE$INT(ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_OCCUPANT INTEGER,
OCC_BUSY_GRP_TYPE INTEGER,
REQUEST_GUEST_CNT INTEGER,
CHECK_OPTIONS VARCHAR(255))
 RETURNS(SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
declare variable must_check_cleaning integer;
  declare variable room_capacity integer;
  declare variable real_id_room_type integer;
  declare variable room_name varchar(20);
  declare variable id_other_occupant integer;
  declare variable other_busy_grp_type integer;
  declare variable is_clean integer;
  declare variable clean_txt varchar(20);
  declare variable id_hotel integer;
begin
  /*  Description:
  ||  CONTEXT   CLEAN, BEDS, ROOM_TYPE, OCCUP
  ||  RESERV    N      Y     Y          FULL
  ||  CHECKIN   Y      Y     N          RES (  ONLY RESERVATIONS)
  ||  BLOCK     N      N     N          FULL
  ||  ROOMEDIT  N      Y     N          RES2 (ONLY RESERVATIONS,NO PERIOD)
  ||----------------------------------------------------
  || CHECK_OPTIONS = (clean, beds, occup_res)
  */
  SHARE_ERR_CODE = 0;
  SHARE_ERR_TEXT = '';
  execute procedure sys_dbg('occ ROOM_VALIDATE ID_ROOM = '||coalesce(:id_room, 'null'));
  execute procedure sys_dbg('occ ROOM_VALIDATE FROM_DATE = '||coalesce(:from_date, 'null'));
  execute procedure sys_dbg('occ ROOM_VALIDATE TO_DATE = '||coalesce(:to_date, 'null'));
  execute procedure sys_dbg('occ ROOM_VALIDATE REQUEST_GUEST_CNT = '||coalesce(:request_guest_cnt, 'null'));
  execute procedure sys_dbg('occ ROOM_VALIDATE CHECK_OPTIONS = '||coalesce(:check_options, 'null'));

  other_busy_grp_type = null;
  real_id_room_type = null;

  select R.ID_ROOM_TYPE, R.BEDS + R.EXTRA_BEDS, R.ROOM_NAME, R.IS_CLEAN, r.ID_HOTEL
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :real_id_room_type, :room_capacity, :room_name, :is_clean, :id_hotel;
  if (:real_id_room_type is null
      and ((:CHECK_OPTIONS containing 'beds') or (:CHECK_OPTIONS containing 'clean')) ) then begin
    exception OCCUPANCY_EXCEPTION '-5';
  end

  if (:check_options like '%clean%'
      and not exists (select rp.ID_ROOM_PERIOD       --skip private rooms for cleaning validation
                      from   ROOM_PERIOD$PMS RP
                      where  RP.ID_ROOM = :ID_ROOM
                             and rp.FROM_DATE <= :FROM_DATE
                             and rp.TO_DATE >= :TO_DATE
                             and rp.STATUS = 'PRIVATE')) then
  begin
    execute procedure SETTING_GET_VALUE('CLEANING_RESTRICTION', :id_hotel)
    returning_values  :must_check_cleaning;
    if ((:must_check_cleaning = 1) and (:is_clean = 0)) then begin
      clean_txt = '@{other.not}';
      exception OCCUPANCY_EXCEPTION '-46' || f_character(31) || f_character(29)||:room_name||f_character(28)||:clean_txt;
    end
  end

  if (:check_options like '%beds%') then begin
    /* CHECK BEDS */
    select max(DRM.day_guests)
    from   (select rm.BUSY_DATE, sum(rm.ADULT_COUNT + rm.CHILDREN_COUNT) as day_guests
            from   ROOM_MAGIC RM
            where  Rm.ID_ROOM = :ID_ROOM
                   and rm.BUSY_DATE between :FROM_DATE and :TO_DATE
                   and rm.DAY_ACTION not containing 'CHECK_OUT'
            group by rm.BUSY_DATE) DRM
    into   :REQUEST_GUEST_CNT;

    if (:room_capacity < :request_guest_cnt) then begin
      exception OCCUPANCY_EXCEPTION '-8' || f_character(31) || f_character(29)||:room_name||f_character(28)||:request_guest_cnt||f_character(28)||:room_capacity;
    end
  end

  /* CHECK OCCUPANCY */
  id_other_occupant = null;
  if (:check_options containing 'occup_res') then begin
    if (exists (select R.ID_ROOM
                from   ROOMS R
                       join ROOM_PERIOD$PMS P on P.ID_ROOM = R.ID_ROOM
                where  P.ID_ROOM = :id_room
                       and P.STATUS = 'INACTIVE' -- allow PRIVATE
                       and P.FROM_DATE <= :to_date
                       and P.TO_DATE >= :from_date)) then
    begin
      exception OCCUPANCY_EXCEPTION '-118';
    end

    --execute procedure sys_dbg('occ ROOM_VALIDATE id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));
    select first 1 RM.ID_RESERV_DETAIL, RM.BUSY_GROUP_TYPE
    from   ROOM_MAGIC RM
    where  RM.BUSY_DATE between :from_date and :to_date
           and RM.ID_ROOM = :id_room
           and RM.DAY_ACTION not containing 'CHECK_OUT'
           and RM.ID_RESERV_DETAIL <> :ID_OCCUPANT
    into   :id_other_occupant, :other_busy_grp_type;
  end
  --execute procedure sys_dbg('occ ROOM_VALIDATE id_arise_source = '||coalesce(:id_arise_source, 'null'));

  if (:id_other_occupant is not null) then begin
    -- other occupant has detected
    if (:other_busy_grp_type in (1, 24)) then begin
      if (:other_busy_grp_type = 1) then share_err_code = -9;
      else share_err_code = -10;

      select substring(f_character(29)||:room_name||f_character(28)||RD.NUMBER||'-'|| P.PROFILE_NAME||', '||FormatDate(RD.FROM_DATE, 'D;dd.mm.yyyy')||'-'||FormatDate(RD.TO_DATE, 'D;dd.mm.yyyy') from 1 for 255)
      from   RESERV_DETAIL RD
             join PROFILE P on P.ID_PROFILE = RD.ID_PERSON_PROFILE
      where  RD.ID_RESERV_DETAIL = :id_other_occupant
      into   :share_err_text;
    end else begin
      share_err_code = -106;
      execute procedure sys_dbg('occ ROOM_VALIDATE err_code = -106 room_name = '||coalesce(:room_name, 'null'));
      select substring(
               f_character(29)||:room_name||f_character(28)||iif(BR.BLOCK_GRP=18, 'Out of order', 'Out of inventory')||
               ' - '||BR.REASON||f_character(28)||FormatDate(BR.FROM_DATE, 'D;dd.mm.yyyy')||'-'||FormatDate(BR.TO_DATE, 'D;dd.mm.yyyy')
             from 1 for 255)
      from   BLOCK_ROOM BR
      where  BR.ID_BLOCK_ROOM = :id_other_occupant
      into   :share_err_text;
    end

    if (((:OCC_BUSY_GRP_TYPE in (1, 24)) and (:other_busy_grp_type in (1, 24, 18, 20)))
       or
       ((:OCC_BUSY_GRP_TYPE in (18, 20)) and (:other_busy_grp_type in (1, 24)))) then
    begin
      -- occupants are compatible for room sharing
      exit;
    end else begin
      exception OCCUPANCY_EXCEPTION :SHARE_ERR_CODE || f_character(31) || :SHARE_ERR_TEXT;
    end
  end
  --
end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_FINALIZE$RSV for: OCCUPANCY_ROOMS_CHECK$INT */
ALTER PROCEDURE RES_SAVE_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_RESERV_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* Alter (OCCUPANCY_ROOMS_CHECK$INT) */
ALTER PROCEDURE OCCUPANCY_ROOMS_CHECK$INT(OCCUPANT_DBKEY CHAR(8),
BUSY_GROUP_SOURCE INTEGER)
 RETURNS(SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable from_date date;
declare variable to_date date;
declare variable id_room integer;
declare variable guests_in_room integer;
declare variable id_occupant integer;
declare variable validate_options varchar(255);
declare variable tmp_err_code integer;
declare variable tmp_err_text varchar(255);
declare variable new_shares_arise integer;
begin
  share_err_code = 0;
  share_transaction_id = null;
  tmp_err_code = 0;
  WARN_CODE = null;

  for
    select ORV.ID_ROOM, ORV.FROM_DATE, ORV.TO_DATE, ORV.GUESTS_INROOM, ORV.ID_OCCUPANT, ORV.VALIDATE_OPTIONS
    from   OCCUPANT_ROOMS$INT(:occupant_dbkey, :busy_group_source) ORV
    into   :id_room, :from_date, :to_date, :guests_in_room, :id_occupant, :validate_options
  do begin
    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT from_date = '||coalesce(:from_date, 'null'));
    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT to_date = '||coalesce(:to_date, 'null'));
    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT validate_options = '||coalesce(:validate_options, 'null'));

    execute procedure OCCUPANCY_ROOM_VALIDATE$INT(:id_room, :from_date, :to_date, :id_occupant, :busy_group_source, :guests_in_room, :validate_options)
    returning_values  :tmp_err_code, :tmp_err_text;

    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT err_code = '||coalesce(:tmp_err_code, 'null'));
    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT err_text = '||coalesce(:tmp_err_text, 'null'));
    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT busy_group_source = '||coalesce(:busy_group_source, 'null'));

    if (:share_err_code = 0 and :tmp_err_code <> 0) then begin
      -- room share has detected
      share_err_code = :tmp_err_code;
      share_err_text = :tmp_err_text;
    end
  end
  /*
  Look for shares which:
    - are not own by this reservation
    - are brand new
  if found new - user must be asked for new shares entering permission
  */
  execute procedure OCCUPANCY_SHARES_COMPLETE$INT (:id_occupant)
  returning_values (:new_shares_arise, :share_transaction_id);

  execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT new_shares_arise = '||coalesce(:new_shares_arise, 'null'));
  execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT share_transaction_id = '||coalesce(:share_transaction_id, 'null'));
  /*  */
  if (:new_shares_arise = 0) then begin
    -- ALL SHARES ARE KNOWN...
    -- suppress new shares entering question
    share_err_code = 0;
    share_err_text = '';
    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT no new shares found ');
  end

  /* check for overlaping on arrival or departure date */
  execute procedure OCCUPANCY_OVERLAP_CHECK$INT (:id_occupant, :busy_group_source)
  returning_values :warn_code;
end
^

/* Alter (OWNER_ACCOUNT_GET$INT) */
ALTER PROCEDURE OWNER_ACCOUNT_GET$INT(ID_OWNER TYPE OF ID,
ID_HOTEL TYPE OF ID,
IS_SHADOW_ACCOUNT TYPE OF TLOGICAL,
IS_CLIENT_ACCOUNT TYPE OF TLOGICAL)
 RETURNS(ID_ACCOUNT TYPE OF ID,
IS_ACCOUNT$PMS TYPE OF TLOGICAL)
 AS
declare variable is_rental_pool smallint;
  declare variable acc_curr char(3);
begin
  ID_ACCOUNT = null;

  select iif(o.ID_RENTAL_POOL_UNIT is null, 0, 1), o.ID_CURRENCY
  from   OWNER$PMS O
  where  o.ID_OWNER = :ID_OWNER
  into   :is_rental_pool, :acc_curr;

  if (:IS_CLIENT_ACCOUNT = 1 and :is_rental_pool = 0) then begin
    select a.ID_ACCOUNT
    from   ACCOUNT A
    where  a.ID_PROFILE = :ID_OWNER
           and a.ID_HOTEL = :ID_HOTEL
           and a.IS_PMS_ACCOUNT = 1
    into   :ID_ACCOUNT;

    if (:ID_ACCOUNT is null) then begin
      execute procedure ACCOUNT_CREATE_PMS$PMS (:ID_OWNER, null, :acc_curr, :ID_HOTEL)
      returning_values (:ID_ACCOUNT);
    end
    IS_ACCOUNT$PMS = 0;
  end else begin
    select a.ID_ACCOUNT
    from   ACCOUNT$PMS a
    where  a.ID_OWNER = :ID_OWNER
           and a.ID_HOTEL = :ID_HOTEL
           and a.IS_SHADOW = :IS_SHADOW_ACCOUNT
           and a.IS_CLIENT_POOL_ACCOUNT = :IS_CLIENT_ACCOUNT
    into   :ID_ACCOUNT;

    if (:ID_ACCOUNT is null) then begin
      insert into ACCOUNT$PMS (ID_OWNER, IS_SHADOW, IS_CLIENT_POOL_ACCOUNT, ID_HOTEL)
      values (:ID_OWNER, :IS_SHADOW_ACCOUNT, :IS_CLIENT_ACCOUNT, :ID_HOTEL)
      returning ID_ACCOUNT into :ID_ACCOUNT;
    end
    IS_ACCOUNT$PMS = 1;
  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ADD_DEF_PAYMENT$DOC for: PAYMENT_GET_DEFAULT$INT */
ALTER PROCEDURE DOCUMENT_ADD_DEF_PAYMENT$DOC(ID_DOC_HEAD INTEGER,
ID_PAY_DOC_TYPE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_GET_VALUE$INT for: PAYMENT_GET_DEFAULT$INT */
ALTER PROCEDURE DOCUMENT_GET_VALUE$INT(ID_DOC_HEAD INTEGER,
TARGET_CURR VARCHAR(3),
TARGET_RATE NUMERIC(15,6) = null)
 RETURNS(ID_PAY_DOC_DEF INTEGER,
TOTAL_CURR VARCHAR(3),
TOTAL_RATE NUMERIC(15,6),
TOTAL_VALUE NUMERIC(15,4),
PAYABLE_VALUE NUMERIC(15,4))
 AS
 BEGIN SUSPEND; END
^

/* Alter (PAYMENT_GET_DEFAULT$INT) */
ALTER PROCEDURE PAYMENT_GET_DEFAULT$INT(ID_ACCOUNT INTEGER)
 RETURNS(ID_PAY_DOC_TYPE INTEGER,
PAY_CURR VARCHAR(3))
 AS
declare variable id_profile integer;
  declare variable id_reserv_detail integer;
  declare variable id_payment_type integer;
  declare variable id_acc_payment_type integer;
  declare variable id_hotel integer;
  declare variable acc_curr varchar(3);
  declare variable def_curr varchar(3);
  declare variable id_def_pay_doc_type integer;
begin
  ID_PAY_DOC_TYPE = null;
  PAY_CURR = null;
  id_payment_type = null;

  select A.ID_PROFILE, A.ID_RESERV_DETAIL, A.ACCOUNT_CURR, A.ID_HOTEL,
         (select pt.ID_PAYMENT_TYPE
          from   PAYMENT_TYPE pt
          where  pt.ID_PAYMENT_TYPE = a.ID_TYPE_PAYMENT)
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :id_profile, :id_reserv_detail, :acc_curr, :id_hotel, :id_acc_payment_type;

  if (:id_reserv_detail is not null) then begin
    select case
             when RD.ID_PERSON_PROFILE = :ID_PROFILE then RD.ID_PERSON_PAYMENT
             when RD.ID_AGENT_PROFILE = :ID_PROFILE then RD.ID_AGENT_PAYMENT
             else null
           end as RESERV_PAYMENT_TYPE
    from   RESERV_DETAIL RD
    where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :id_payment_type;
  end

  id_payment_type = coalesce(:id_payment_type, :id_acc_payment_type);

  if (:id_payment_type is not null) then begin
    select first 1 DT.ID_DOC_TYPE, DT.DEF_CURRENCY,
           iif (dt.CURRENCY_LIST containing :ACC_CURR, :ACC_CURR, null) as PAY_CURR,
           iif (dt.ID_DOC_TYPE = :id_def_pay_doc_type, dt.ID_DOC_TYPE, null)
    from   PAY_DOC_TYPE_S DT
    where  DT.ID_PAYMENT_TYPE = :id_payment_type
           and DT.DOC_DIRECTION = 0
           and DT.ID_HOTEL = :ID_HOTEL
           and DT.IS_ARCHIVE = 0
    order by 3 desc nulls last, 4 asc nulls last, 1 asc    /* pull up doc types, that supports account currency */
    into   :ID_PAY_DOC_TYPE, :def_curr, :PAY_CURR, :id_def_pay_doc_type;
  end else begin
    begin
      execute procedure SETTING_GET_VALUE ('DEF_CASH_PAY_DOC', :id_hotel)
      returning_values  :id_def_pay_doc_type;

      when any do begin end
    end

    select dt.ID_DOC_TYPE, DT.DEF_CURRENCY, iif (dt.CURRENCY_LIST containing :ACC_CURR, :ACC_CURR, null) as PAY_CURR
    from   PAY_DOC_TYPE_S DT
    where  DT.ID_DOC_TYPE = :id_def_pay_doc_type
           and DT.DOC_DIRECTION = 0
           and DT.ID_HOTEL = :ID_HOTEL
           and dt.IS_ARCHIVE = 0
    into   :ID_PAY_DOC_TYPE, :def_curr, :PAY_CURR;
  end

  if (:PAY_CURR is null) then PAY_CURR = :DEF_CURR;

end
^

/* Alter (PHONECALL_POST$TC) */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Alter (PHONECALLS_POST_TO_ACCOUNT$TC) */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* empty dependent procedure body */
/* Clear: DEVICE_READING_POST$PMS for: PMS_EXPENSE_POSTS_CREATE$INT */
ALTER PROCEDURE DEVICE_READING_POST$PMS(ID_DEVICE_READING /* TYPE OF ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PMS_EXPENSE_POSTING_CREATE$PMS for: PMS_EXPENSE_POSTS_CREATE$INT */
ALTER PROCEDURE PMS_EXPENSE_POSTING_CREATE$PMS(ID_ROOM /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
POST_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
IS_ACC_POST_ITEM /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_POST_DATE /* TYPE OF TDATE */ DATE,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IS_POST_PER_POOL /* TYPE OF TLOGICAL */ SMALLINT)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_EXPENSE_POSTS_CREATE$INT) */
ALTER PROCEDURE PMS_EXPENSE_POSTS_CREATE$INT(ID_ROOM TYPE OF ID,
ID_OWNER TYPE OF ID,
ID_RENTAL_POOL TYPE OF ID_REF,
ID_SERVICE TYPE OF ID,
ID_CURRENCY TYPE OF TCURRENCY,
POST_VALUE TYPE OF TPRICE,
IS_CLIENT_ACC_POST TYPE OF TLOGICAL,
MANUAL_POST_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
IS_POST_PER_POOL TYPE OF TLOGICAL)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF,
NEW_ID_ACCOUNT_POST$PMS ID_REF)
 AS
declare variable event_type varchar(30);
  declare variable id_room_contract integer;
  declare variable new_id_pms_event integer;
  declare variable round_to_orig numeric(15,6);
  declare variable ownership_percent numeric(15,4);
  declare variable curr_contract_owner integer;
  declare variable curr_total_ownership numeric(15,4);
  declare variable curr_total_value numeric(15,4);
  declare variable percent_value numeric(15,4);
  declare variable id_account integer;
  declare variable id_hotel integer;
  declare variable is_account$pms integer;
  declare variable id_acc_post integer;
BEGIN
  event_type = 'MANUAL_EXPENSE';
  curr_total_value = 0;
  curr_total_ownership = 0;

  select RC.ID_ROOM_CONTRACT, r.ID_HOTEL
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS P on RC.ID_ROOM_PERIOD = P.ID_ROOM_PERIOD
         join ROOMS R on R.ID_ROOM = p.ID_ROOM
  where  :MANUAL_POST_DATE between P.FROM_DATE and P.TO_DATE
         and P.ID_ROOM = :ID_ROOM
         and P.STATUS in ('PRIVATE','CONTRACT')
  into   :id_room_contract, :id_hotel;

  if (:ID_ROOM_CONTRACT is null) then exception PMS_EXCEPTION '-615';

  execute procedure PMS_EVENT_CREATE$INT(:EVENT_TYPE, :ID_ROOM, :ID_OWNER, :DESCRIPTION,
          :MANUAL_POST_DATE, null, null, null, null, :POST_VALUE, :POST_VALUE, :ID_CURRENCY, null, :id_room_contract)
  returning_values :new_id_pms_event;

  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :ID_CURRENCY
  into   :round_to_orig;

  for
    select iif(:ID_OWNER is null, O.OWNERSHIP_PERCENT, 100), O.ID_OWNER
    from   ROOM_CONTRACT$PMS RC
           join ROOM_OWNER$PMS O on O.ID_ROOM_CONTRACT = RC.ID_ROOM_CONTRACT
    where  RC.ID_ROOM_CONTRACT = :id_room_contract
           and ((:ID_OWNER is null) or (O.ID_OWNER = :ID_OWNER))
    into   :ownership_percent, :curr_contract_owner
  do begin
    curr_total_ownership = :curr_total_ownership + :ownership_percent;
    if (:curr_total_ownership = 100) then begin
      percent_value = :post_value - :curr_total_value;
    end else
      percent_value = round_f(:post_value * :ownership_percent / 100, :round_to_orig);

    curr_total_value = :curr_total_value + :percent_value;

    execute procedure OWNER_ACCOUNT_GET$INT (iif(:is_post_per_pool = 1, :id_rental_pool, :curr_contract_owner),
            :id_hotel, 0, :IS_CLIENT_ACC_POST)
    returning_values (:id_account, :is_account$pms);

    execute procedure PMS_POSTING_CREATE$INT(:new_id_pms_event, :ID_ACCOUNT, :ID_SERVICE,
            :curr_contract_owner, :MANUAL_POST_DATE, :ID_CURRENCY, :PERCENT_VALUE, :is_account$pms, 0, :ID_ROOM)
    returning_values :id_acc_post;

    new_id_account_post = null;
    new_id_account_post$pms = null;

    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 1)) then new_id_account_post$pms = :id_acc_post;
    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 0)) then new_id_account_post = :id_acc_post;
    suspend;
  end

  execute procedure PMS_EVENT_SET_ACTIVE$INT(:new_id_pms_event);
END
^

/* Alter (PMS_IMPORT) */
ALTER PROCEDURE PMS_IMPORT(ID_EXPORT_HEAD INTEGER)
 AS
begin

  execute procedure PMS_IMPORT$INT(:ID_EXPORT_HEAD);

end
^

/* empty dependent procedure body */
/* Clear: PMS_POOL_DISTRIBUTION for: PMS_POOL_DISTRIBUTION_SUB */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION(ID_RENTAL_POOL INTEGER,
FOR_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_POOL_DISTRIBUTION_SUB) */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
declare variable cnt_room smallint;
  declare variable curr_total_posted numeric(15,4);
  declare variable cnt integer;
  declare variable value_to_post numeric(15,4);
  declare variable value_to_post_per_owner numeric(15,4);
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable id_room_contract integer;
  declare variable id_owner_account integer;
  declare variable id_pms_event integer;
  declare variable id_hotel integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
begin
  select c.ROUND_TO
  from   CURRS c
  where  c.CURR = :CURR
  into   :round_to;

  cnt_room = 0;
  select count(distinct RP.ID_ROOM)
  from   ROOM_PERIOD$PMS RP
         join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
  where  RC.ID_RENTAL_POOL = :id_rental_pool
         and RP.STATUS in ('PRIVATE','CONTRACT')
         and RP.FROM_DATE <= :FOR_DATE
         and RP.TO_DATE >= :FOR_DATE
  into   :cnt_room;

  if (:cnt_room = 0) then exception PMS_EXCEPTION 'The pool has not assigned room contracts for selected date (' || :FOR_DATE || ') !';

  if (:is_room_pool = 1) then begin
    curr_total_posted = 0;
    cnt = 0;
    id_pms_event = null;
    id_hotel = null;
    for
      select distinct RP.ID_ROOM, RC.ID_ROOM_CONTRACT, R.ID_HOTEL
      from   ROOM_PERIOD$PMS RP
             join ROOMS R on R.ID_ROOM = RP.ID_ROOM
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.FROM_DATE <= :FOR_DATE
             and RP.TO_DATE >= :FOR_DATE
      into   :id_room, :id_room_contract, :id_hotel
    do begin
      id_pms_event = null;

      select E.ID_PMS_EVENT
      from   PMS_EVENT$PMS E
      where  E.ID_ROOM = :id_room
             and E.ID_SESSION = current_transaction
      into   :ID_PMS_EVENT;

      if (:ID_PMS_EVENT is null) then begin
        execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, :id_room_contract)
        returning_values :id_pms_event;
        -- FIXME nakraq da se update total_event_value
      end
      if (:cnt_room - :cnt = 1) then begin
        value_to_post = :TOTAL_VALUE_PER_SERVICE - :curr_total_posted;
      end else begin
        value_to_post = round_f(:TOTAL_VALUE_PER_SERVICE / :cnt_room, :round_to);
      end

      curr_total_posted = :curr_total_posted + :value_to_post;
      cnt = :cnt + 1;

      /* ...i se razpredelq mejdu sobstwenicite na staqta */
      value_to_post = abs(:value_to_post);
      for
        select R.ID_OWNER, R.OUT_VALUE
        from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
        into   :id_owner, :value_to_post_per_owner
      do begin
        /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_pool_account,
                :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                1, :IS_OWNER_INCOME, :id_room)
        returning_values :no_use_id_acc_post;
        /* ... i se nachislqwa po sobswtenik */
        execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
        returning_values (:id_owner_account, :is_account$pms);

        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                :is_account$pms, :is_owner_income, :id_room)
        returning_values :no_use_id_acc_post;
      end
    end
  end else begin
    /* distribution by room_param */
    insert into TMP_SELECT$PMS(ID_SESSION, ID_ROOM, ID_OWNER)
    select distinct current_transaction, RP.ID_ROOM, null
    from   ROOM_PERIOD$PMS RP
           join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
    where  RC.ID_RENTAL_POOL = :ID_RENTAL_POOL
           and RP.STATUS in ('PRIVATE','CONTRACT')
           and RP.FROM_DATE <= :FOR_DATE
           and RP.TO_DATE >= :FOR_DATE;

    id_hotel = null;
    for
      select P.OUT_VALUE, P.OUT_ID_ROOM, R.ID_HOTEL
      from   PMS_CALC_VALUE_BY_PARAM(:ID_ROOM_PARAM, :TOTAL_VALUE_PER_SERVICE, :round_to) P
             join ROOMS R on R.ID_ROOM = P.OUT_ID_ROOM
      into   :value_to_post, :id_room, :id_hotel
    do begin
      id_pms_event = null;
      id_room_contract = null;
      -- room contract must be only one for this period
      select RC.ID_ROOM_CONTRACT
      from   ROOM_PERIOD$PMS RP
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.ID_ROOM = :id_room
             and :for_date between RP.FROM_DATE and RP.TO_DATE
      into   :id_room_contract;

      if (:id_room_contract is not null) then begin
        select E.ID_PMS_EVENT
        from   PMS_EVENT$PMS E
        where  E.ID_ROOM = :id_room
               and E.ID_SESSION = current_transaction
        into   :ID_PMS_EVENT;
  
        if (:ID_PMS_EVENT is null) then begin
          execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                  'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, id_room_contract)
          returning_values :id_pms_event;
          -- FIXME nakraq da se update total_event_value
        end
  
        /* ...i se razpredelq mejdu sobstwenicite na staqta */
        for
          select R.ID_OWNER, R.OUT_VALUE
          from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
          into   :id_owner, :value_to_post_per_owner
        do begin
          /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :ID_POOL_ACCOUNT,
                  :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                  1, :IS_OWNER_INCOME, :id_room)
          returning_values :no_use_id_acc_post;
  
          /* ... i se nachislqwa po sobswtenik */
          execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
          returning_values (:id_owner_account, :is_account$pms);

          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                  :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                  :is_account$pms, :is_owner_income, :id_room)
          returning_values :no_use_id_acc_post;
        end
      end
    end

    delete from TMP_SELECT$PMS T
    where  T.ID_SESSION = current_transaction;
  end
end
^

/* Alter (PMS_ROOM_DOCS_PREPARE$RPT) */
ALTER PROCEDURE PMS_ROOM_DOCS_PREPARE$RPT(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER)
 RETURNS(REC_COUNT INTEGER)
 AS
begin
  delete from PMS_ROOM_DOCS$TMP;


  insert into PMS_ROOM_DOCS$TMP (id_room, id_doc_head,  for_date, ID_RESERV_DETAIL, id_room_contract, ID_ROOM_PERIOD,
         post_net_value, post_gross_value, nat_net_value, nat_gross_value, nights)
  select ap.ID_ROOM, dh.ID_DOC, dh.RPT_DOC_DATE, g.ID_RESERV_DETAIL, rc.ID_ROOM_CONTRACT, RP.ID_ROOM_PERIOD,
         sum(SV.VALUE_WOT_TAX * dh.VALUE_CORR_IDX),
         sum(pv.ACCOUNT_PRICE * dl.QTY_POST * dh.VALUE_CORR_IDX),
         sum(dl.NAT_NET_VALUE * dh.VALUE_CORR_IDX),
         sum(dl.NAT_GROSS_VALUE * dh.VALUE_CORR_IDX),
         --count(distinct dl.DATE_POST),
         floor(sum(DH.VALUE_CORR_IDX*DL.QTY_POST*(1-dl.IS_CORRECT))/max(rd.ADULT_COUNT + rd.CHILD_COUNT))
  from   DOCUMENT_RELEASE DH
         join DOC_LINE DL on DL.ID_DOC_HEAD = DH.ID_DOC
         join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE
         join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = PV.ID_ACCOUNT_POST and ap.IS_BASE = 1
         join ROOMS R on R.ID_ROOM = AP.ID_ROOM
         join GUEST G on G.ID_GUEST = ap.ID_GUEST
         join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
         join CURRS c on c.CURR = ap.CURR_POST
         left outer join TAX_VALUE_DEDUCT (pv.ACCOUNT_PRICE * dl.QTY_POST, c.ROUND_TO, dl.ID_SALE_TAXATION) SV on 1=1
         left outer join ROOM_PERIOD$PMS rp on rp.ID_ROOM = r.id_room
                                      and rp.FROM_DATE <= dl.DATE_POST
                                      and rp.TO_DATE >= dl.DATE_POST
         left outer join ROOM_CONTRACT$PMS rc on rc.ID_ROOM_PERIOD = rp.ID_ROOM_PERIOD
  where  DH.RPT_DOC_DATE between :FROM_DATE and :TO_DATE
         and R.ID_HOTEL = :ID_HOTEL
  group by 1, 2, 3, 4, 5, 6;

  REC_COUNT = row_count;
  suspend;
end
^

/* Alter (POST_SERVICE_FINALIZE$POST) */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
  declare variable id_acc_post integer;
  declare variable id_service integer;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable date_post date;
  declare variable price_post numeric(15,4);
  declare variable qty_post numeric(15,2);
  declare variable post_text varchar(100);
  declare variable curr_post varchar(3);
  declare variable id_phonecall integer;
  declare variable p_dbkey char(8);
begin

  if (:OPERATION = 'clear') then begin
    delete from TMP_SERVICE_POST T
    where  T.ID_SEQUENCE = :ID_SEQUENCE;

  end else if (:OPERATION = 'store') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);

    for
      select TS.RDB$DB_KEY, TS.ID_SERVICE, TS.ID_ACCOUNT, TS.ID_GUEST, TS.DATE_POST,
             TS.PRICE_POST, TS.QTY_POST, TS.CURR_POST, TS.POST_TEXT, TS.ID_PHONECALL
      from   TMP_SERVICE_POST TS
      where  TS.ID_SEQUENCE = :ID_SEQUENCE
      into   :p_dbkey, :id_service, :id_account, :id_guest, :date_post,
             :price_post, :qty_post, :curr_post, :post_text, :id_phonecall
    do begin
      id_acc_post = null;
      if (:id_guest is not null) then begin
        execute procedure POST_SERVICE_ON_GUEST$INT (:id_guest, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :CURR_POST,
                :date_post, :date_post, :post_text, '', :date_post, '', '')
        returning_values  (:err_code, :err_text, :no_use, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end else begin
        execute procedure POST_SERVICE_ON_ACCOUNT$INT (:id_account, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :curr_post, :date_post, :date_post, :post_text,
                '', :date_post, '')
        returning_values  (:err_code, :err_text, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end

      update TMP_SERVICE_POST
      set ID_ACCOUNT_POST = :id_acc_post
      where RDB$DB_KEY = :p_dbkey;

      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :DOC_SELECTED,
             AP.SHORT_CODE = case
                               when :id_phonecall is not null then 'TELECOUNT'
                               else null
                             end
      where  AP.ID_ACCOUNT_POST = :id_acc_post;

      if (:id_phonecall is not null) then begin
        update PHONECALLS P
        set    P.ID_ACCOUNT_POST = :id_acc_post
        where  P.ID_PHONECALL = :id_phonecall;
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_ACCOUNTS_RECIEVE$INT for: PROFILE_GET_ACCOUNT$INT */
ALTER PROCEDURE RES_ACCOUNTS_RECIEVE$INT(ID_RESERV_DETAIL INTEGER,
OLD_ID_BASE_ACCOUNT INTEGER,
OLD_ID_EXTRA_ACCOUNT INTEGER,
ID_AGENT_ACCOUNT_RULE INTEGER,
ID_BASE_ACCOUNT_PROFILE INTEGER,
ID_EXTRA_ACCOUNT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ID_ACC_TEMPLATE_PERSON INTEGER,
IS_SEPARATE_ACCOUNTS SMALLINT)
 RETURNS(NEW_ID_BASE_ACCOUNT INTEGER,
NEW_ID_EXTRA_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PROFILE_GET_ACCOUNT$INT) */
ALTER PROCEDURE PROFILE_GET_ACCOUNT$INT(ID_PROFILE INTEGER,
ID_RESERV_DETAIL INTEGER,
ACCOUNT_CURR VARCHAR(3),
ID_ACC_TEMPLATE INTEGER,
IS_BASE_ENABLE SMALLINT = 1,
IS_EXTRA_ENABLE SMALLINT = 1)
 RETURNS(ID_ACCOUNT INTEGER)
 AS
declare variable is_archive integer;
declare variable id_hotel integer;
begin
  id_account = null;

  select first 1 A.ID_ACCOUNT, a.IS_ARCHIVE
  from   ACCOUNT A
  where  A.ID_PROFILE = :id_profile
         and A.ACCOUNT_CURR = :account_curr
         and A.ID_RESERV_DETAIL is not distinct from :id_reserv_detail
         and A.IS_BASE >= :IS_BASE_ENABLE
         and A.IS_EXTRA >= :IS_EXTRA_ENABLE
  order by A.IS_ARCHIVE asc, A.ID_ACCOUNT asc
  into   :id_account, :is_archive;

  if (:id_account is null) then begin
    if (:id_acc_template is null) then begin
      select rd.ID_HOTEL
      from   RESERV_DETAIL RD
      where  rd.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
      into   :id_hotel;

      select P.ID_ACCOUNT_TEMPLATE
      from   PROFILE_BOOKING_DEFAULTS P
      where  P.ID_PROFILE = :id_profile
             and P.ID_HOTEL = :id_hotel
      into   :id_acc_template;
    end

    execute procedure RES_ACCOUNT_CREATE$INT(:id_profile, :id_acc_template, :account_curr,
            :id_reserv_detail, :IS_BASE_ENABLE, :IS_EXTRA_ENABLE)
    returning_values  :id_account;

  end else if (:is_archive = 1) then begin
    execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 0);
  end
end
^

/* empty dependent procedure body */
/* Clear: PROFILE_PERSON_MODIFY$PROFILE for: PROFILE_PERSON_CREATEQ$PROFILE */
ALTER PROCEDURE PROFILE_PERSON_MODIFY$PROFILE(ID_PROFILE INTEGER,
ID_GUEST_TYPE INTEGER,
PROFILE_NAME VARCHAR(100),
PERSON_NAME2 VARCHAR(100),
SEX CHAR,
BIRTH_DAY DATE,
BIRTH_PLACE VARCHAR(30),
EGN VARCHAR(30),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
COUNTRY_CODE VARCHAR(20),
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
MASK VARCHAR(10),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
IS_ARCHIVE INTEGER,
ID_PHOTO INTEGER,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
TITLE VARCHAR(10) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GET_PERSON_PROFILE$INT for: PROFILE_PERSON_CREATEQ$PROFILE */
ALTER PROCEDURE RES_GET_PERSON_PROFILE$INT(ID_GUEST INTEGER)
 RETURNS(ID_PERSON_PROFILE INTEGER,
ID_PERSON_DATA INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PROFILE_PERSON_CREATEQ$PROFILE) */
ALTER PROCEDURE PROFILE_PERSON_CREATEQ$PROFILE(PROFILE_NAME TYPE OF TPERSON_NAME,
PHONE TYPE OF TPHONE,
ID_PASSPORT_TYPE TYPE OF ID,
PASS_NUM TYPE OF NAME_20,
EGN TYPE OF TTEXT_SHORT,
COUNTRY_CODE TYPE OF TSHORT_CODE,
CARD_CODE TYPE OF TCARD_CODE,
ID_PERSON_DATA TYPE OF ID_REF = null,
TITLE TYPE OF TSHORT_CODE = null,
ID_HOTEL TYPE OF ID_REF = null)
 RETURNS(NEW_ID_PROFILE TYPE OF ID,
P_DBKEY TYPE OF TDB_KEY,
PD_DBKEY TYPE OF TDB_KEY)
 AS
declare variable action_text varchar(255);
  declare variable mask varchar(10);
  declare variable first_name varchar(30);
  declare variable surname varchar(30);
  declare variable family_name varchar(30);
  declare variable merge_ident_num tname_unicode;
  declare variable merge_ident_num_alt tname_unicode;
begin
  select trim(ss.UNICODE_STRING) from SYSTEM_STRING_TO_UNICODE(:EGN) ss into :merge_ident_num;
  select trim(ss.UNICODE_STRING) from SYSTEM_STRING_TO_UNICODE(:PASS_NUM) ss into :merge_ident_num_alt;

  new_id_profile = gen_id(gen_profile_id, 1);
  insert into PROFILE (ID_PROFILE, PROFILE_NAME, PROFILE_TYPE, PHONE, IS_ARCHIVE, MERGE_IDENT_NUM, MERGE_IDENT_NUM_ALT)
  values (:new_id_profile, :profile_name, 'PERSON', :phone, 0, :merge_ident_num, :merge_ident_num_alt)
  returning RDB$DB_KEY into :p_dbkey;

  if (:id_person_data is null) then begin
    id_person_data = gen_id(gen_person_data_id, 1);

    if (:ID_HOTEL is not null) then begin
      execute procedure SETTING_GET_VALUE ('DEF_GUEST_MASK', :ID_HOTEL)
      returning_values  :mask;
    end

    select PP.FIRST_NAME,  PP.SURNAME, PP.FAMILY_NAME
    from   PERSON_NAME_PARSE$INT (:PROFILE_NAME) PP
    into   :first_name,  :surname, :family_name;

    insert into PERSON_DATA(ID_PERSON_DATA, PERSON_NAME2, ID_PASSPORT_TYPE, PASS_NUM, EGN, MASK,
           FIRST_NAME, SURNAME, FAMILY_NAME, COUNTRY_CODE)
    values (:id_person_data, :profile_name, :id_passport_type, :pass_num, :egn, :mask,
           :first_name, :surname, :family_name, :country_code)
    returning RDB$DB_KEY into :pd_dbkey;

    execute procedure PERSON_DATA_SET$INT(:p_dbkey, :pd_dbkey, :profile_name, :profile_name, :country_code,
            null, null, :TITLE);
  end

  insert into PROFILE_PERSON (ID_PROFILE, ID_PERSON_DATA, CARD_CODE)
  values (:new_id_profile, :id_person_data, :card_code);

  action_text = f_character(29) || :profile_name;
  execute procedure SYSTEM_LOG_ADD ('PROFILE', :new_id_profile, 'CREATE_PERS_PROFILE', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_PERSON_PROFILE$EXC for: PROFILE_PERSON_MODIFY$PROFILE */
ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PROFILE_PERSON_MODIFY$PROFILE) */
ALTER PROCEDURE PROFILE_PERSON_MODIFY$PROFILE(ID_PROFILE INTEGER,
ID_GUEST_TYPE INTEGER,
PROFILE_NAME VARCHAR(100),
PERSON_NAME2 VARCHAR(100),
SEX CHAR,
BIRTH_DAY DATE,
BIRTH_PLACE VARCHAR(30),
EGN VARCHAR(30),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
COUNTRY_CODE VARCHAR(20),
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
MASK VARCHAR(10),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
IS_ARCHIVE INTEGER,
ID_PHOTO INTEGER,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
TITLE VARCHAR(10) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable p_dbkey char(8);
  declare variable pd_dbkey char(8);
  declare variable old_birth_day date;
  declare variable id_picture integer;
  declare variable birthday_internal date;
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    new_id_profile = :id_profile;

    if (:operation = 'add') then begin
      execute procedure PROFILE_PERSON_CREATEQ$PROFILE(:profile_name, :phone,
              :id_passport_type, :pass_num, :egn, :country_code, :card_code, null, :TITLE, null)
      returning_values  :new_id_profile, :p_dbkey, :pd_dbkey;

      if (:MASK is null) then begin
        -- keep the default mask if input mask is <null> - inexplicit
        -- empty mask is '' - passed by GUI, but <null> is passed from booking import, etc.
        select PD.MASK
        from   PERSON_DATA PD
        where  PD.RDB$DB_KEY = :pd_dbkey
        into   :mask;
      end
    end

    select P.RDB$DB_KEY, PD.RDB$DB_KEY, pd.BIRTH_DAY
    from   PROFILE P
           join PROFILE_PERSON PP on PP.ID_PROFILE = P.ID_PROFILE
           join PERSON_DATA PD on PD.ID_PERSON_DATA = PP.ID_PERSON_DATA
    where  P.ID_PROFILE = :new_id_profile
    into   :p_dbkey, :pd_dbkey, :old_birth_day;

    execute procedure PROFILE_COMMON_MODIFY$INT(:new_id_profile, 'PERSON', :profile_name,
            :phone, :fax, :email, :contact_city, :contact_address,
            :note, :msg, :is_archive, :id_def_contragent, :id_nom_market_segment,
            :wbe_password, :account_no, :is_exclusive_debt_ownership)
    returning_values (:new_id_profile);

    execute procedure PERSON_DATA_SET$INT(:p_dbkey, :pd_dbkey, :profile_name, :person_name2, :country_code,
            :old_birth_day, :birth_day, :TITLE);

    execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, :birth_place, :egn, :id_passport_type, :pass_num, :pass_date, :pass_place,
            :pass_exp_date, :pass_city, :pass_address, :sex, :mask);

    update PROFILE_PERSON PP
    set    PP.ID_GUEST_TYPE = :id_guest_type,
           PP.ID_PHOTO = :id_photo,
           PP.CARD_CODE = :card_code
    where  PP.ID_PROFILE = :new_id_profile;

  end else if (:operation = 'del') then begin
    id_picture = null;

    select PP.ID_PHOTO
    from   PROFILE_PERSON PP
    where  PP.ID_PROFILE = :id_profile
    into   :id_picture;

    execute procedure PICTURE_MODIFY (:id_picture, null, null, null, 'del')
    returning_values :id_picture;

    execute procedure PROFILE_DELETE$INT(:id_profile);
    new_id_profile = null;
  end
end
^

/* empty dependent procedure body */
/* Clear: REP_ROOM_STATUS$INT for: REP_ROOM_STATUS_BUILD$INT */
ALTER PROCEDURE REP_ROOM_STATUS$INT(FOR_DATE DATE,
STAT_OPTIONS VARCHAR(255),
PRIVATE_STATUS_ADDING SMALLINT = 0)
 RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
SECTOR INTEGER,
ID_ROOM_TYPE INTEGER,
TYPE_ROOM VARCHAR(20),
IS_CLEAN INTEGER,
IS_INSPECTED INTEGER,
CLEAN_TEXT VARCHAR(30),
IS_LEAVING SMALLINT,
IS_COMMING SMALLINT,
IS_SHARED SMALLINT,
IS_LEAVING_WORDS VARCHAR(30),
BUSY_GRP INTEGER,
DAYS_THIS_STATUS INTEGER,
DTS_CONTEXT VARCHAR(10),
COMMING_OCCUPANTS VARCHAR(1024),
ID_BLOCK_ROOM INTEGER,
OTHER_OCCUPANTS VARCHAR(1024),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ID_HOTEL INTEGER,
HAS_OPENED_POSTINGS SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (REP_ROOM_STATUS_BUILD$INT) */
ALTER PROCEDURE REP_ROOM_STATUS_BUILD$INT(ID_ROOM INTEGER,
FOR_DATE DATE,
STAT_OPTIONS VARCHAR(255))
 RETURNS(IS_LEAVING SMALLINT,
IS_COMMING SMALLINT,
IS_SHARED SMALLINT,
IS_LEAVING_WORDS VARCHAR(30),
BUSY_GRP INTEGER,
DAYS_THIS_STATUS INTEGER,
DTS_CONTEXT VARCHAR(10),
COMMING_OCCUPANTS VARCHAR(1024),
ID_BLOCK_ROOM INTEGER,
OTHER_OCCUPANTS VARCHAR(1024),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER)
 AS
declare variable report_leaving varchar(50);
  declare variable as_busy_grp_type integer;

  declare variable day_action varchar(50);
  declare variable occup_grp integer;
  declare variable occupant_id integer;
  declare variable busygrp_leaving integer;
  declare variable busygrp_other integer;
  declare variable check_status integer;
  declare variable int_adult_count integer;
  declare variable int_children_count integer;
  declare variable id_hotel integer;
begin
  select r.ID_HOTEL
  from   ROOMS R
  where  R.ID_ROOM = :ID_ROOM
  into   :id_hotel;

  execute procedure SETTING_GET_VALUE('REPORT_LEAVING', :id_hotel)
  returning_values  :report_leaving;

  is_leaving = 0;
  is_comming = 0;
  is_shared = 0;
  comming_occupants = '';
  id_block_room = null;
  other_occupants = '';
  busygrp_leaving = 0;
  busygrp_other = 0;
  adult_count = 0;
  children_count = 0;

  for
    select RM.ID_RESERV_DETAIL, coalesce(RS.BUSY_GROUP_TYPE, rm.BUSY_GROUP_TYPE), RM.DAY_ACTION,
           RD.CHECK_STATUS, RM.ADULT_COUNT, RM.CHILDREN_COUNT
    from   TMP_HM_ROOM_STATUS HM
           join ROOM_MAGIC RM on RM.ID_ROOM_MAGIC = HM.ID_ROOMS_MAGIC
           left outer join ROOMS_SHARE RS on RS.ID_ROOM_SHARE = RM.ID_ROOM_MAGIC
           left outer join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = RM.ID_RESERV_DETAIL
    where  HM.ID_SESSION = current_transaction
           and HM.ID_ROOM = :id_room
    order by RD.CHECK_STATUS asc nulls first, rd.FROM_DATE asc nulls first
    into   :occupant_id, :occup_grp, :day_action,
           :check_status, :int_adult_count, :int_children_count
  do begin
    --is_comming = 0;
    --is_leaving = 0;
    if (:occup_grp in (18, 20) and :DAY_ACTION = 'BLOCK') then begin
      id_block_room = :occupant_id;
      busygrp_other = :occup_grp;
    end else if (:DAY_ACTION = 'CHECK_IN') then begin
      is_comming = 1;
      if (','||:comming_occupants||',' not containing ','||:occupant_id||',') then
        comming_occupants = :comming_occupants || iif(:comming_occupants = '', '', ',') || :occupant_id;
      busygrp_other = :occup_grp;
    end else if (:DAY_ACTION containing 'CHECK_OUT') then begin
      if (:check_status < 1) then begin
        if ((:check_status < 0) and (:stat_options containing 'HOUSEKEEPING')) then begin
          -- do nothing. House keeping is not interested in leaving reservations
        end
        is_leaving = 1;
        busygrp_leaving = :occup_grp;
        if (','||:other_occupants||',' not containing ','||:occupant_id||',') then
          other_occupants = :other_occupants || iif(:other_occupants = '', '', ',') || :occupant_id;
      end else begin
        -- nothing, room is alreay checked out
      end
    end else begin
      -- DAY_ACTION = 'STAY'
      busygrp_other = :occup_grp;
      if (','||:other_occupants||',' not containing ','||:occupant_id||',') then
        other_occupants = :other_occupants || iif(:other_occupants = '', '', ',') || :occupant_id;
    end

    adult_count = :adult_count + :int_adult_count;
    children_count = :children_count + :int_children_count;

  end

  if (:report_leaving = 'AS_FREE') then begin
    busy_grp = :busygrp_other;
  end else begin
    busy_grp = iif(:busygrp_leaving in (0, 1), :busygrp_other, :busygrp_leaving);
  end

  if (exists(
    select *
    from   ROOMS_SHARE RS
    where  RS.ID_ROOM = :id_room
           and RS.BUSY_DATE = :for_date
  )) then is_shared = 1;
  else is_shared = 0;

  if (:stat_options containing 'DAYS_THIS_STATUS') then begin
    if (:is_leaving = 1) then begin
      if (exists(  -- !!! this select must be changed
           select * from ROOM_MAGIC RM
           where  RM.BUSY_DATE = :for_date
                  and RM.ID_ROOM = :id_room
                  and RM.BUSY_TYPE <> 'VALUE_RESERVS'
                  and RM.DAY_ACTION not containing 'CHECK_OUT')
      ) then as_busy_grp_type = :busy_grp;
      else begin
        /* TODAY THE ROOM IS LEAVING AND NO BODY IS EXPECTED TO COME
        || SO WE MUST SHOW HOW MANY DAYS THE ROOM WILL BE FREE
        */
        as_busy_grp_type = 0;
      end
    end else as_busy_grp_type = :busy_grp;

    if (:as_busy_grp_type = 0) then dts_context = 'FREE';
    else dts_context = 'BUSY';
    execute procedure REP_ROOM_STATUS_DTS$INT(:as_busy_grp_type, :for_date, :id_room)
    returning_values  :days_this_status;

--    if (:days_this_status is null) then days_this_status_txt = '~';
--    else days_this_status_txt = :days_this_status;
  end
end
^

/* Alter (RES_ACCOUNTS_RECIEVE$INT) */
ALTER PROCEDURE RES_ACCOUNTS_RECIEVE$INT(ID_RESERV_DETAIL INTEGER,
OLD_ID_BASE_ACCOUNT INTEGER,
OLD_ID_EXTRA_ACCOUNT INTEGER,
ID_AGENT_ACCOUNT_RULE INTEGER,
ID_BASE_ACCOUNT_PROFILE INTEGER,
ID_EXTRA_ACCOUNT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ID_ACC_TEMPLATE_PERSON INTEGER,
IS_SEPARATE_ACCOUNTS SMALLINT)
 RETURNS(NEW_ID_BASE_ACCOUNT INTEGER,
NEW_ID_EXTRA_ACCOUNT INTEGER)
 AS
declare variable id_acc_profile integer;
  declare variable base_account_curr varchar(3);
  declare variable base_tariff_currency char(3);
  declare variable extra_tariff_currency char(3);
  declare variable id_hotel integer;
  declare variable id_base_acc_reserv integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
begin
  id_acc_profile = null;
  select A.ID_PROFILE, A.ACCOUNT_CURR, A.ID_RESERV_DETAIL
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :old_id_base_account
  into   :id_acc_profile, :base_account_curr, :id_base_acc_reserv;

  select first 1 T.CURR, T.ID_HOTEL
  from   GUEST G
         join GUEST_STAY GS on gs.ID_GUEST = g.ID_GUEST
         join TARIFA T on T.ID_TARIFA = GS.ID_TARIFF
  where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  order by GS.FOR_DATE asc
  into   :base_tariff_currency, :id_hotel;

  if (:base_tariff_currency is null) then EXIT;

  select first 1 T.CURR
  from   TARIFA T
  where  T.IS_EXTRA = 1
         and T.ID_HOTEL = :id_hotel
  into   :extra_tariff_currency;

  if (coalesce(:id_agent_account_rule, 0) > 0) then begin
    /* get specified account */
    new_id_base_account = :id_agent_account_rule;
    execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:NEW_ID_BASE_ACCOUNT, 0);
  end else if (:id_acc_profile = :id_base_account_profile
               and :base_account_curr = :base_tariff_currency
               and :id_base_acc_reserv is not distinct from :ID_RESERV_DETAIL) then
  begin
    /* preserve old base personal account */
    new_id_base_account = :old_id_base_account;
  end else begin
    /* get new personal account */
    execute procedure PROFILE_GET_ACCOUNT$INT (:id_base_account_profile, :id_reserv_detail, 
            :base_tariff_currency, iif(:id_base_account_profile = :id_person_profile, :id_acc_template_person, null),
            1, iif(:IS_SEPARATE_ACCOUNTS = 0, 1, 0))
    returning_values (:new_id_base_account);
  end

  select ba.ACCOUNT_CURR
  from   ACCOUNT BA
  where  ba.ID_ACCOUNT = :NEW_ID_BASE_ACCOUNT
  into   :base_account_curr;

  if (:IS_SEPARATE_ACCOUNTS = 1
      and :base_account_curr = :extra_tariff_currency
      and :ID_BASE_ACCOUNT_PROFILE = :ID_EXTRA_ACCOUNT_PROFILE)
  then IS_SEPARATE_ACCOUNTS = 0;


  if (:IS_SEPARATE_ACCOUNTS = 0) then begin
    new_id_extra_account = :new_id_base_account;
    update ACCOUNT A
    set    a.IS_EXTRA = 1
    where  a.ID_ACCOUNT = :NEW_ID_EXTRA_ACCOUNT
           and a.IS_EXTRA is distinct from 1;
  end else begin
    id_acc_profile = null;
    select A.ID_PROFILE/*, A.ACCOUNT_CURR*/
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :old_id_extra_account
    into   :id_acc_profile/*, :account_curr*/;

    if (:id_acc_profile = :id_extra_account_profile /*and :account_curr = :extra_tariff_currency*/ and :old_id_extra_account is not null) then begin
      -- CHANGED after p27 -> condition {:account_curr = :extra_tariff_currency} is removed;
      -- if exists extra account by this profile, it must be preserve, independent of currency,
      -- because of unnecessary posting transfer and archiving of unused accounts (by the same profile);
      -- this can be forced with ACC_ROUTING changing (MIXED -> AGENT -> MIXED)
      new_id_extra_account = :old_id_extra_account;
    end else begin
      execute procedure PROFILE_GET_ACCOUNT$INT (:id_extra_account_profile, :id_reserv_detail,
              :extra_tariff_currency, iif(:id_extra_account_profile = :id_person_profile, :id_acc_template_person, null),
              1, 1)
      returning_values (:new_id_extra_account);
    end
  end
  /*  */
  if (:NEW_ID_BASE_ACCOUNT is distinct from :OLD_ID_BASE_ACCOUNT) then begin
    execute procedure ACCOUNT_VALIDATE$INT(:NEW_ID_BASE_ACCOUNT, 'IS_BASE')
    returning_values  :err_code, :err_text, :no_use, :no_use, :no_use, :no_use;
    if (:err_code < 0) then exception ACCOUNT_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end
  if (:NEW_ID_EXTRA_ACCOUNT is distinct from :OLD_ID_EXTRA_ACCOUNT) then begin
    execute procedure ACCOUNT_VALIDATE$INT(:NEW_ID_EXTRA_ACCOUNT, 'IS_EXTRA')
    returning_values  :err_code, :err_text, :no_use, :no_use, :no_use, :no_use;
    if (:err_code < 0) then exception ACCOUNT_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end

end
^

/* Alter (RES_CREATE_DETAIL$INT) */
ALTER PROCEDURE RES_CREATE_DETAIL$INT(ID_RESERV_DETAIL INTEGER,
ID_AGENT_PROFILE INTEGER,
NUMBER VARCHAR(62),
CHECK_STATUS INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
EXP_DATE DATE,
COMMING_KIND INTEGER,
LEAVING_KIND INTEGER,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
NOTE VARCHAR(2000),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_BOARD INTEGER,
ID_ROOM INTEGER,
ID_RATE INTEGER,
ID_ROOM_TYPE INTEGER,
COUNTRY VARCHAR(20),
VAUCHER_DATE DATE,
VAUCHER_NUM VARCHAR(20),
VAUCHER_TEXT VARCHAR(30),
VAUCHER_DATE2 DATE,
VAUCHER_NUM2 VARCHAR(20),
CUSTOM_PRICE NUMERIC(15,2),
CUSTOM_CURRENCY VARCHAR(3),
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
ID_PERSON_PROFILE INTEGER,
ID_HOTEL INTEGER,
ACC_ROUTING VARCHAR(50),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_GROUP INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
RD_DBKEY CHAR(8))
 AS
declare variable id_default_payment integer;
  declare variable number1 varchar(20);
  declare variable number2 varchar(20);
  declare variable number3 varchar(20);
begin
  execute procedure SETTING_GET_VALUE('DEF_PAY_TYPE', :ID_HOTEL)
  returning_values  :id_default_payment;

  if (:id_room = -1) then id_room = gen_id(DETAIL_WITHOUT_ROOMING_LIST, -1);
  else select R.ID_ROOM_TYPE from ROOMS R where R.ID_ROOM = :id_room into :id_room_type;

  if (:id_reserv_detail is null) then new_id_reserv_detail = gen_id (id_reserv_detail_gen, 1);
  else new_id_reserv_detail = :id_reserv_detail;

  execute procedure RES_NUMBER_SPLIT$INT (:NUMBER)
  returning_values (:number1, :number2, :number3);

  insert into RESERV_DETAIL (ID_RESERV_DETAIL, ID_AGENT_PROFILE, NUMBER_1, NUMBER_2, NUMBER_3, CHECK_STATUS,
    FROM_DATE, TO_DATE, CODE_FIRST_FOOD, EXP_DATE, COMMING_KIND, LEAVING_KIND,
    TRANSFER_IN_TIME, TRANSFER_IN_NOTE, TRANSFER_OUT_TIME, TRANSFER_OUT_NOTE,
    ADULT_COUNT, CHILD_COUNT, NOTE, IS_ANUL, I_SPECIAL_TREATMENT, ID_BOARD,
    ID_ROOM, REASON_OF_ANUL, COUNTRY, ID_RATE, VAUCHER_DATE, VAUCHER_NUM,
    VAUCHER_TEXT, VAUCHER_DATE2, VAUCHER_NUM2, ID_ROOM_TYPE, CUSTOM_PRICE, CUSTOM_CURRENCY,
    ID_HK_PLAN, ID_PERSON_PAYMENT, ID_HOTEL, ID_PERSON_PROFILE, ACC_ROUTING,
    ID_ACC_TEMPLATE_PERSON, ROOM_FEATURES, ID_GROUP, ID_AGENT_ACCOUNT_RULE, ID_GUARANTEE_POLICY,
    CONFIRMATION_NUMBER, ID_EATING_OBJECT)
  values (:new_id_reserv_detail, :id_agent_profile, :number1, :number2, :number3, :check_status,
    :from_date, :to_date, coalesce(:code_first_food, 'dinner'), :exp_date, :comming_kind, :leaving_kind,
    :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
    :adult_count, :child_count, :note, 0, :i_special_treatment,  :ID_BOARD,
    :id_room, '', coalesce(:country, ''), :id_rate, :vaucher_date, :vaucher_num,
    :vaucher_text, :vaucher_date2, :vaucher_num2, :id_room_type, :custom_price, :custom_currency,
    :id_hk_plan, :id_default_payment, :id_hotel, :id_person_profile, :acc_routing,
    :id_acc_template_person, :room_features, :id_group, :id_agent_account, :id_guarantee_policy,
    iif (:CHECK_STATUS = -1, strhash_large(:NUMBER || 'CONFIRMATION'), null), :ID_EATING_OBJECT)
  returning RDB$DB_KEY into :rd_dbkey;

  execute procedure RES_SET_EDIT_STATUS$INT (:RD_DBKEY, 'JUST_CREATED');
end
^

/* empty dependent procedure body */
/* Clear: DEFAULT_BOOKING_VALUES$EXC for: RES_CREATE_GET$RSV */
ALTER PROCEDURE DEFAULT_BOOKING_VALUES$EXC(BOOKING_DBKEY CHAR(8),
HOTEL_ID INTEGER,
RATE_ID_IN INTEGER,
ROOM_TYPE_ID_IN INTEGER,
BOARD_ID_IN INTEGER,
MAINTANCE_SHEMA_ID_IN INTEGER,
ARRANGER_PAYMENT_TYPE_ID_IN INTEGER,
GUEST_PAYMENT_TYPE_ID_IN INTEGER,
MARKETING1_ID_IN INTEGER,
MARKETING2_ID_IN INTEGER,
MARKETING3_ID_IN INTEGER,
MARKETING4_ID_IN INTEGER,
MARKETING5_ID_IN INTEGER,
ARRANGER_PROFILE_ID_IN INTEGER,
MAIN_GUEST_PROFILE_ID_IN INTEGER,
POSTING_ROUTING_IN VARCHAR(50),
FIRST_FOOD_CODE_IN /* TFOOD_CODE */ VARCHAR(20),
GUARANTEE_POLICY_ID_IN INTEGER,
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_LATE_DEPARTURE_IN INTEGER,
EATING_OBJECT_ID_IN INTEGER)
 RETURNS(RATE_ID INTEGER,
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
MAINTANCE_SHEMA_ID INTEGER,
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
ARRANGER_PROFILE_ID INTEGER,
ARRANGER_ACCOUNT_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
POSTING_ROUTING VARCHAR(50),
FIRST_FOOD_CODE /* TFOOD_CODE */ VARCHAR(20),
GUARANTEE_POLICY_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_LATE_DEPARTURE INTEGER,
EATING_OBJECT_ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_CREATE_GET$RSV) */
ALTER PROCEDURE RES_CREATE_GET$RSV(ID_HOTEL INTEGER)
 RETURNS(ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIMESTAMP,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIMESTAMP,
TRANSFER_OUT_NOTE VARCHAR(30),
IS_LATE_DEPARTURE INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
COUNTRY_CODE VARCHAR(20),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
CHECK_STATUS INTEGER,
ID_HK_PLAN INTEGER,
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF)
 AS
declare variable stay_length integer;
  declare variable sys_date date;
begin
/* on the GUI
id_room_type;
id_tariff;
id_board;
code_first_food;

adult_count
child_count
check_status
*/

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :sys_date;
   
  select sv.SETTING_VALUE
  from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :ID_HOTEL) sv
  into   :ID_ACC_TEMPLATE_PERSON;
--  ID_ACC_TEMPLATE_PERSON = 0;
  select RT.ARRIVAL_DATE, RT.DEPARTURE_DATE, RT.ADULT_COUNT, RT.CHILD_COUNT, RT.STAY_LENGTH,
         RT.ID_ROOM_TYPE, RT.ID_ROOM, m.ID_BOARD, T.ID_TARIFA, RT.CUSTOM_PRICE,
         RT.CUSTOM_CURRENCY, RT.VOUCHER_NUM, RT.VOUCHER_DATE, RT.VOUCHER_TEXT, RT.VOUCHER2_NUM,
         RT.VOUCHER2_DATE, RT.TRANSFER_IN_TIME, RT.TRANSFER_IN_NOTE, RT.TRANSFER_OUT_TIME,
         RT.TRANSFER_OUT_NOTE, RT.IS_LATE_DEPARTURE, RT.CODE_FIRST_FOOD, RT.ID_NOM_MARKET_SEGMENT,
         RT.ID_NOM_SOURCE_CODE, RT.ID_NOM_CHANNEL_CODE, RT.ID_NOM_HEAR_REASON, RT.ID_NOM_COME_REASON,
         RT.ID_AGENT_PROFILE, RT.ID_PERSON_PROFILE, RT.COUNTRY_CODE, RT.ACC_ROUTING,
         RT.ID_PERSON_PAYMENT, RT.ID_AGENT_PAYMENT, RT.ID_AGENT_ACCOUNT, RT.CHECK_STATUS, RT.ID_HK_PLAN,
         RT.ID_GUARANTEE_POLICY, e.ID_EATING_OBJECT
  from   RES_TEMPLATE RT
         left outer join MEALS m on m.ID_BOARD = rt.ID_BOARD and m.IS_ARCHIVE = 0
         left outer join TARIFA t on t.ID_TARIFA = rt.ID_TARIFF and t.IS_ACTIVE = 1
         left outer join EATING_OBJECT e on e.ID_EATING_OBJECT = rt.ID_EATING_OBJECT and e.IS_ARCHIVE = 0
  where  RT.ID_HOTEL = :id_hotel
  into   :arrival_date, :departure_date, :adult_count, :child_count, :stay_length,
         :id_room_type, :id_room, :id_board, :id_tariff, :custom_price,
         :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
         :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time,
         :transfer_out_note, :is_late_departure, :code_first_food, :id_nom_market_segment,
         :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason,
         :id_agent_profile, :id_person_profile, :country_code, :acc_routing,
         :id_person_payment, :id_agent_payment, :id_agent_account, :check_status, :id_hk_plan,
         :id_guarantee_policy, :id_eating_object;


  if (:arrival_date is null) then arrival_date = :sys_date;
  if (:stay_length is null) then stay_length = 1;
  if (:departure_date is null) then departure_date = :arrival_date + :stay_length;
  if (:is_late_departure is null) then is_late_departure = 0; 
  if (:adult_count is null) then adult_count = 2;
  if (:child_count is null) then child_count = 0;

  if (:country_code is null) then begin
    execute procedure SETTING_GET_VALUE('DEF_COUNTRY', :ID_HOTEL)
    returning_values  :country_code;
  end
  if (:id_person_payment is null) then begin
    execute procedure SETTING_GET_VALUE('DEF_PAY_TYPE', :ID_HOTEL)
    returning_values  :id_person_payment;
  end
  if (:id_agent_payment is null) then begin
    execute procedure SETTING_GET_VALUE('DEF_PAY_TYPE', :ID_HOTEL)
    returning_values  :id_agent_payment;
  end

  if (:acc_routing is null) then acc_routing = 'GUEST';
  if (:check_status is null) then check_status = -3;

  guarantee_deposit = null;
  guarantee_currency = null;
  suspend;
end
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_SET$INT for: RES_CREATE_ROOM$INT */
ALTER PROCEDURE RES_CREATE_SET$INT(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_HOTEL INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
SPLIT_ON_CHECKIN SMALLINT,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_ACC_TEMPLATE_PERSON INTEGER = null,
ID_GUARANTEE_POLICY INTEGER = null,
BLOCK_CC VARCHAR(255) = null,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(RD_DBKEY CHAR(8),
NEW_ID_RESERV_DETAIL INTEGER,
WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_CREATE_ROOM$INT) */
ALTER PROCEDURE RES_CREATE_ROOM$INT(CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_COUNT INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_AGENT_PROFILE INTEGER,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_PERSON_PROFILE INTEGER,
ACC_ROUTING VARCHAR(50),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ID_GROUP INTEGER = null,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_GUARANTEE_POLICY INTEGER = null,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
RD_DBKEY CHAR(8),
NEW_ID_PERSON_PROFILE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable day_keep_types integer;
  declare variable exp_date date;
  declare variable leaving_kind integer;
  declare variable cnt_processed integer;
begin
  execute procedure SETTING_GET_VALUE('DAY_KEEP_TYPES', :ID_HOTEL)
  returning_values  :day_keep_types;
  exp_date = :arrival_date + :day_keep_types;
  leaving_kind = coalesce(:is_late_departure, 0) + 1;
  comming_kind = coalesce(:comming_kind, 1);

  cnt_processed = 0;
  while (:room_count > :cnt_processed) do begin
    if (:res_number is null) then begin
      execute procedure SYSTEM_GEN_NUM('BOOKING', 0)
      returning_values  :dbg, :res_number;
    end
    
    if (:id_person_profile is null) then begin
      execute procedure PROFILE_PERSON_CREATEQ$PROFILE(:res_number, '', null, null, null,
              :country_code, null, null, null, :ID_HOTEL)
      returning_values  :new_id_person_profile, :dbg, :dbg;
      execute procedure sys_dbg('res RES_CREATE_ROOM$INT autocreate id_person_profile = '||coalesce(:id_person_profile, 'null'));
    end else begin
      new_id_person_profile = :id_person_profile;
    end

    execute procedure RES_CREATE_DETAIL$INT(:id_reserv_detail, :id_agent_profile, :res_number, :check_status,
                      :arrival_date, :departure_date, :code_first_food, :exp_date, :comming_kind, :leaving_kind,
                      :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                      0, 0, :note, :i_special_treatment, :id_board, -1, :id_rate,
                      :id_room_type, :country_code, '30.12.1899', null, null, '30.12.1899', null, null, null,
                      :room_features, :id_hk_plan, :new_id_person_profile, :id_hotel, :acc_routing, :id_acc_template_person,
                      :id_group, :id_agent_account, :id_guarantee_policy, :ID_EATING_OBJECT)
    returning_values  :new_id_reserv_detail, :rd_dbkey;
    res_number = null;

    execute procedure RES_GUESTCOUNT_ADD$INT(:rd_dbkey, :adult_count, :child_count);

    cnt_processed = :cnt_processed + 1;
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_SET$EXC for: RES_CREATE_SET$INT */
ALTER PROCEDURE RES_CREATE_SET$EXC(ID_RESERV_DETAIL INTEGER,
RES_NUMBER VARCHAR(62),
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER,
CREATE_DATETIME TIMESTAMP)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_RESERV_DETAIL INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_SET$RSV for: RES_CREATE_SET$INT */
ALTER PROCEDURE RES_CREATE_SET$RSV(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
SUPPRESS_WARNINGS INTEGER,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT$RSV for: RES_CREATE_SET$INT */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_CREATE_SET$INT) */
ALTER PROCEDURE RES_CREATE_SET$INT(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(255),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_HOTEL INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
SPLIT_ON_CHECKIN SMALLINT,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_ACC_TEMPLATE_PERSON INTEGER = null,
ID_GUARANTEE_POLICY INTEGER = null,
BLOCK_CC VARCHAR(255) = null,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(RD_DBKEY CHAR(8),
NEW_ID_RESERV_DETAIL INTEGER,
WARN_CODE TYPE OF TRANGE)
 AS
declare variable guarantee_deposit_percent numeric(15,4);
  declare variable guarantee_deposit_nights integer;
  declare variable guarantee_due_days_bef_arrival integer;
  declare variable guarantee_due_days_after_create integer;
  declare variable gp_check_status integer;
  declare variable log_suppressed integer;
  declare variable id_guest integer;
  declare variable minibar_rights varchar(50);
  declare variable video_rights varchar(50);
  declare variable nopost_pms varchar(50);
  declare variable phone_rights varchar(50);
  declare variable paytv_rights varchar(50);
  declare variable is_profile_exclusive_debt_ownership integer;
  declare variable id_base_account integer;
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CREATE');

  select GP.DEPOSIT_NIGHTS_COUNT, GP.DEPOSIT_TOTALSUM_PART,
         GP.DUE_DAYS_BEFORE_ARRIVAL, GP.DUE_DAYS_AFTER_CREATE, gp.CHECK_STATUS
  from   GUARANTEE_POLICY GP
  where  GP.ID_GUARANTEE_POLICY = :ID_GUARANTEE_POLICY
         and gp.ID_HOTEL = :ID_HOTEL
  into   :guarantee_deposit_nights, :guarantee_deposit_percent,
         :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create, :gp_check_status;

  CHECK_STATUS = coalesce(:CHECK_STATUS, :gp_check_status, -2);

  execute procedure RES_CREATE_ROOM$INT(:check_status, :arrival_date, :departure_date, :adult_count, :child_count,
                    :id_room_type, 1, :id_board, :id_tariff, comming_kind, :is_late_departure, :country_code, :code_first_food,
                    :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note, :i_special_treatment, :id_agent_profile,
                    :id_hk_plan, '', :room_features, :id_person_profile, :acc_routing, :id_acc_template_person, :id_hotel, :id_agent_account,
                    :id_group, :id_reserv_detail, :res_number, :id_guarantee_policy, :id_eating_object)
  returning_values  :new_id_reserv_detail, :rd_dbkey, :id_person_profile;

  if (RDB$GET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE') is not distinct from 'disable') then begin
    log_suppressed = 1;
  end else begin
    log_suppressed = 0;
    RDB$SET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE', 'disable');
    -- disable only for intermediate changes
  end

  execute procedure RES_SAVE_ACCOUNTING$INT (:rd_dbkey, :id_agent_profile, :id_agent_account, :acc_routing,
          :id_person_payment, :id_agent_payment, :id_group);

  execute procedure RES_SAVE_MARKETING$INT(:rd_dbkey, :id_nom_market_segment,
                    :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason);

  execute procedure sys_dbg('res RES_CREATE_SET$INT id_room = '||coalesce(:id_room, 'null'));
  if (:id_room is not null) then begin
    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, :id_room_type, 'nrttRoom')
    returning_values (:WARN_CODE);
  end

  execute procedure RES_SAVE_VOUCHER$INT(:RD_DBKEY, :voucher_num, :voucher_date, :voucher_text, :voucher2_num, :voucher2_date);

  execute procedure RES_SAVE_NOTE$RSV(:new_id_reserv_detail, :note, :note_reminders);

  for
    select  g.ID_GUEST
    from    GUEST G
    where   G.ID_RESERV_DETAIL = :NEW_ID_RESERV_DETAIL
    into    :id_guest
  do begin
    execute procedure RES_GUEST_SAVE_PACKET$RSV (:id_guest, :PACKET_ITEM_IDS);
  end 

  update RESERV_DETAIL RD
  set    RD.CUSTOM_PRICE = :CUSTOM_PRICE,
         RD.CUSTOM_CURRENCY = :CUSTOM_CURRENCY,
         RD.SPLIT_ON_CHECKIN = :SPLIT_ON_CHECKIN,
         RD.IS_VIP = coalesce(:IS_VIP, RD.IS_VIP),
         RD.ID_GUARANTEE_POLICY = :ID_GUARANTEE_POLICY,
         RD.GUARANTEE_DEPOSIT = :GUARANTEE_DEPOSIT,
         RD.GUARANTEE_CURRENCY = :GUARANTEE_CURRENCY,
         RD.BLOCK_CC = :BLOCK_CC,
         RD.GUARANTEE_DEPOSIT_PERCENT = :guarantee_deposit_percent,
         RD.GUARANTEE_DEPOSIT_NIGHTS = :guarantee_deposit_nights,
         RD.GUARANTEE_DUE_DAYS_BEF_ARRIVAL = :guarantee_due_days_bef_arrival,
         RD.GUARANTEE_DUE_DAYS_AFTER_CREATE = :guarantee_due_days_after_create
         /*rd.POSTING_TRANSACTION_UUID =  (select iif(p.IS_EXCLUSIVE_DEBT_OWNERSHIP = 1, uuid_create(), null)
                                         from   ACCOUNT A
                                                join PROFILE P on P.ID_PROFILE = a.ID_PROFILE
                                         where  a.ID_ACCOUNT = rd.ID_BASE_ACCOUNT)*/
  where  RD.RDB$DB_KEY = :rd_dbkey
  returning new.ID_BASE_ACCOUNT
  into      :id_base_account;

  select p.IS_EXCLUSIVE_DEBT_OWNERSHIP
  from   ACCOUNT A
         join PROFILE P on P.ID_PROFILE = a.ID_PROFILE
  where  a.ID_ACCOUNT = :id_base_account
  into   :is_profile_exclusive_debt_ownership;

  if (:is_profile_exclusive_debt_ownership = 1) then begin
    execute procedure RES_TAKE_POSTING_RESPONSIBILITY (:NEW_ID_RESERV_DETAIL);
  end

  select rt.MINIBAR_RIGHTS, rt.VIDEO_RIGHTS, rt.NOPOST_PMS, rt.PHONE_RIGHTS, rt.PAYTV_RIGHTS
  from   RES_TEMPLATE RT
  where  rt.ID_HOTEL = :ID_HOTEL
  into   :minibar_rights, :video_rights, :nopost_pms, :phone_rights, :paytv_rights;

  execute procedure RESERV_DETAIL_EXTERNAL_MOD$RSV (:NEW_ID_RESERV_DETAIL,
          :minibar_rights, :paytv_rights, :video_rights, :nopost_pms, :phone_rights, null, null);

  if (:log_suppressed = 0) then RDB$SET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE', 'enable');

  execute procedure RES_CREATE_LOG$INT (:RD_DBKEY);

end
^

/* Alter (RES_CREATE_SET$RSV) */
ALTER PROCEDURE RES_CREATE_SET$RSV(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
SUPPRESS_WARNINGS INTEGER,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER,
NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable rd_dbkey char(8);
declare variable tmp_warn_code integer;
begin
  WARN_CODE = null;
  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, :check_status, :arrival_date, :departure_date,
                    :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff, :PACKET_ITEM_IDS,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
                    :guarantee_deposit, :guarantee_currency, :split_on_checkin, null, null, :ID_ACC_TEMPLATE_PERSON,
                    :ID_GUARANTEE_POLICY, null, :ID_EATING_OBJECT)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :WARN_CODE;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :ERR_TEXT, :share_transaction_id, :tmp_warn_code;
  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

  if (:suppress_warnings = 1) then begin
    delete from SYSTEM_WARNINGS W
    where W.ID_TRANSACTION = :warn_code;
    warn_code = null;
  end

  update RESERV_DETAIL RD
  set    RD.NOTE_REMINDERS = :note_reminders
  where  RD.RDB$DB_KEY = :rd_dbkey;

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;

end
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE_SHAREOPTION$INT for: RES_FINALIZE_OCCUPANCY$INT */
ALTER PROCEDURE RES_FINALIZE_SHAREOPTION$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_FINALIZE_OCCUPANCY$INT) */
ALTER PROCEDURE RES_FINALIZE_OCCUPANCY$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ERROR_CONTEXT VARCHAR(200),
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable busy_group_source integer;
declare variable tmp_warn_code integer;
declare variable id_room_type integer;
declare variable id_agent integer;
declare variable check_status integer;
declare variable from_date date;
declare variable to_date date;
begin
  err_code = 0;
  warn_code = null;
  tmp_warn_code = null;

  select iif(RD.CHECK_STATUS = 1, 24, 1), coalesce(R.ID_ROOM_TYPE, RD.ID_ROOM_TYPE), P.ID_AGENT,
         rd.CHECK_STATUS, rd.FROM_DATE, rd.TO_DATE
  from   RESERV_DETAIL RD
         left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
         left outer join PROFILE_AGENT P on P.ID_PROFILE = RD.ID_AGENT_PROFILE
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :busy_group_source, :id_room_type, :id_agent, :check_status, :from_date, :to_date;

  error_context = 'OCCUPANCY';
  execute procedure OCCUPANCY_RESERV$INT(:rd_dbkey);

  if (:id_agent is not null) then begin
    execute procedure OCCUPANCY_ACTIVE_FRAME_CHK$INT(:id_agent, :from_date, :to_date - 1, :id_room_type)
    returning_values  :err_code, :err_text;
    if (:err_code < 0) then exit;
  end

  if (:check_status > -3) then begin
    execute procedure OCCUPANCY_OVERBOOK_CHECK$INT (:id_agent, :from_date, :to_date - 1, :id_room_type)
    returning_values  :err_code, :err_text, :warn_code;
    if (:err_code < 0) then exit;
  end
  ---------------------------------
  error_context = 'ROOM_VALIDATION';
  execute procedure OCCUPANCY_ROOMS_CHECK$INT(:rd_dbkey, :busy_group_source)
  returning_values  :share_err_code, :share_err_text, :share_transaction_id, :tmp_warn_code;

  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

  /* empty shares helper table*/
  delete from RESERV_STAY$TMP t
  where  t.id_session = RDB$GET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION');

end
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE$INT for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_FINALIZE$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ROOM$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SAVE_ROOM$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
ID_RES_ROOM_TYPE INTEGER,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(255),
SPLIT_ON_CHECKIN SMALLINT,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_STAY$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SAVE_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_CHECKIN$INT for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SET_CHECKIN$INT(RD_DBKEY CHAR(8))
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM$INT for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SET_ROOM$INT(RD_DBKEY CHAR(8),
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_STAY$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SET_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_FINALIZE$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RESMULTI_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER,
DISABLE_WARNING SMALLINT)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_FINALIZE_SHAREOPTION$INT) */
ALTER PROCEDURE RES_FINALIZE_SHAREOPTION$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable error_context varchar(200);
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable room_price numeric(15,4);
  declare variable is_anul smallint;
begin
  WARN_CODE = null;

  select RD.ID_RESERV_DETAIL, RD.CHECK_STATUS, rd.ROOM_PRICE, rd.IS_ANUL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail, :check_status, :room_price, :is_anul;

  execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));
  execute procedure RES_FINALIZE_OCCUPANCY$INT(:rd_dbkey)
  returning_values  :err_code, :err_text, :error_context, :share_transaction_id, :share_err_code, :share_err_text, :warn_code;

  --execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT share_err_code = '||coalesce(:share_err_code, 'null'));
  --execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT share_err_text = '||coalesce(:share_err_text, 'null'));
  --execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT err_code = '||coalesce(:err_code, 'null'));

  execute procedure RES_FINALIZE_ERRHANDLING$INT(:id_reserv_detail, :err_code, :err_text, :error_context, :SUPPRESS_NON_INSTANT_ERRORS);

  if (((:check_status >= 0) or (:room_price is null) or (:is_anul = 1) ) /*and (:is_anul = 0)*/) then begin
    execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    returning_values  :err_code, :err_text;

    execute procedure RES_FINALIZE_ERRHANDLING$INT(:id_reserv_detail, :err_code, :err_text, 'RECALC', :SUPPRESS_NON_INSTANT_ERRORS);
  end

  execute procedure RES_FINALIZE_CLEAR$INT(:rd_dbkey, :id_reserv_detail);

  warn_code = coalesce(:WARN_CODE, RDB$GET_CONTEXT('USER_TRANSACTION', 'WARN_CODE'));
  RDB$SET_CONTEXT('USER_TRANSACTION', 'WARN_CODE', null);

end
^

/* Alter (RES_GET_PERSON_PROFILE$INT) */
ALTER PROCEDURE RES_GET_PERSON_PROFILE$INT(ID_GUEST INTEGER)
 RETURNS(ID_PERSON_PROFILE INTEGER,
ID_PERSON_DATA INTEGER)
 AS
declare variable p_dbkey char(8);
  declare variable profile_name varchar(100);
  declare variable pd_dbkey char(8);
  declare variable id_hotel integer;
  declare variable title varchar(10);
begin
  select PD.ID_PERSON_DATA, PD.PERSON_NAME, PP.ID_PROFILE, rd.ID_HOTEL, pd.TITLE
  from   GUEST G
         join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
         join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
         join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
         left outer join PROFILE_PERSON PP on PP.ID_PERSON_DATA = GD.ID_PERSON_DATA
  where  G.ID_GUEST = :id_guest
  into   :id_person_data, :profile_name, :id_person_profile, :id_hotel, :title;

  if (:id_person_profile is null) then begin
    execute procedure PROFILE_PERSON_CREATEQ$PROFILE(:profile_name, '', null, null, null, null, null, :id_person_data, :title, :id_hotel)
    returning_values  :id_person_profile, :p_dbkey, :pd_dbkey;
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_ADD$RSV for: RES_GUEST_ADD$INT */
ALTER PROCEDURE RES_GUEST_ADD$RSV(ID_RESERV_DETAIL INTEGER,
IS_CHILD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_GUEST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUESTCOUNT_ADD$INT for: RES_GUEST_ADD$INT */
ALTER PROCEDURE RES_GUESTCOUNT_ADD$INT(RD_DBKEY CHAR(8),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_GUEST_ADD$INT) */
ALTER PROCEDURE RES_GUEST_ADD$INT(RD_DBKEY CHAR(8),
IS_CHILD INTEGER)
 RETURNS(NEW_ID_GUEST INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable pd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable check_status integer;

  declare variable from_date date;
  declare variable to_date date;
  declare variable id_room integer;
  declare variable id_agent integer;
  declare variable id_tarrif integer;
  declare variable guest_name varchar(100);
  declare variable country_code varchar(10);
  declare variable guest_status varchar(50);
  declare variable default_mask varchar(50);
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable id_titular integer;
  declare variable id_profile_data integer;
  declare variable id_person_data integer;
  declare variable id_base_account integer;
  declare variable id_extra_account integer;
  declare variable id_hotel integer;
begin
  select RD.FROM_DATE, RD.TO_DATE, RD.ID_ROOM, PA.ID_AGENT, RD.ID_RATE,
         RD.ID_RESERV_DETAIL, RD.ID_TITULAR, PP.ID_PERSON_DATA,
         RD.CHECK_STATUS, RD.ADULT_COUNT, RD.CHILD_COUNT, RD.COUNTRY,
         rd.ID_BASE_ACCOUNT, rd.ID_EXTRA_ACCOUNT, rd.ID_HOTEL
  from   RESERV_DETAIL RD
         left outer join PROFILE_PERSON PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
         left outer join PROFILE_AGENT PA on PA.ID_PROFILE = RD.ID_AGENT_PROFILE
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :from_date, :to_date, :id_room, :id_agent, :id_tarrif,
         :id_reserv_detail, :id_titular, :id_profile_data,
         :check_status, :adult_count, :child_count, :country_code,
         :id_base_account, :id_extra_account, :id_hotel;

  if (:check_status < 0) then begin
    guest_status = '';
    check_status = -2;
  end else if (:check_status = 0) then begin
    guest_status = 'CHECKING_IN';
  end else begin  /* checked out */
    exception BOOKING_EXCEPTION '-1032';
  end


  new_id_guest = gen_id (id_guest_gen, 1);
  insert into GUEST (ID_GUEST, ID_BASE_ACCOUNT, ID_ACCOUNT, FROM_DATE, TO_DATE, ID_ROOM, ID_AGENT, ID_TARIFA,
         ID_RESERV_DETAIL, IS_CHILD, CHECK_STATUS, GUEST_EDIT_STATUS)
  values (:new_id_guest,  :id_base_account, :id_extra_account, :from_date, :to_date, :id_room, :id_agent, :id_tarrif,
         :id_reserv_detail, :is_child, -2, :guest_status)
  returning RDB$DB_KEY into :g_dbkey;

  execute procedure sys_dbg('res RES_GUEST_ADD$INT new_id_guest = '||coalesce(:new_id_guest, 'null'));

  insert into GUEST_CHANGE_STATUS (ID_GUEST, FROM_DATE_ORIG, TO_DATE_ORIG)
  values (:new_id_guest, :from_date, :to_date);

  if (:is_child = 1) then begin
    child_count = :child_count + 1;
    guest_name = '-';
  end else begin
    adult_count = :adult_count + 1;
    guest_name = '-';
  end

  if (:id_titular is null) then begin
    id_titular = :new_id_guest;
    id_person_data = :id_profile_data;
  end else begin
    execute procedure SETTING_GET_VALUE('DEF_GUEST_MASK', :id_hotel)
    returning_values  :default_mask;

    id_person_data = gen_id(GEN_PERSON_DATA_ID, 1);
    insert into PERSON_DATA (ID_PERSON_DATA, MASK)
    values (:id_person_data, :default_mask)
    returning RDB$DB_KEY into :pd_dbkey;

  end

  insert into GUEST_DATA (ID_GUEST, ID_PERSON_DATA)
  values (:new_id_guest, :id_person_data);

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name, :guest_name, coalesce(:country_code, ''),
          :is_child, null, null, null);

  execute procedure RES_GUEST_AUTO$INT(:g_dbkey, :rd_dbkey, 1);

  update RESERV_DETAIL RD
  set    RD.ADULT_COUNT = :adult_count,
         RD.CHILD_COUNT = :child_count,
         RD.ID_TITULAR = :id_titular
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SET_EDIT_STATUS$INT (:RD_DBKEY, 'ADDGUEST', 'add');

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, :check_status);

end
^

/* Alter (RES_GUEST_ADD$RSV) */
ALTER PROCEDURE RES_GUEST_ADD$RSV(ID_RESERV_DETAIL INTEGER,
IS_CHILD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_GUEST INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable action_text varchar(255);
begin
  warn_code = 0;
  err_code = 0;
  err_text = '';

  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey;

  execute procedure RES_GUEST_ADD$INT(:rd_dbkey, :IS_CHILD)
  returning_values  :NEW_ID_GUEST;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :NEW_ID_GUEST
  into   :ACTION_TEXT;
   
  ACTION_TEXT = F_CHARACTER(29) || '"' || :ACTION_TEXT || '" (' || :NEW_ID_GUEST || ')';
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_GUEST_ADD', :ACTION_TEXT);

end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_GUESTCOUNT$INT for: RES_GUESTCOUNT_ADD$INT */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$INT(RD_DBKEY CHAR(8),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_GUESTCOUNT_ADD$INT) */
ALTER PROCEDURE RES_GUESTCOUNT_ADD$INT(RD_DBKEY CHAR(8),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 AS
declare variable i integer;
  declare variable is_child integer;
  declare variable new_id_guest integer;
begin
  i = 1;
  while (:i <= (coalesce(:adult_count, 0) + coalesce(:child_count, 0))) do begin
    if (:i <= :adult_count) then is_child = 0;
    else is_child = 1;

    execute procedure RES_GUEST_ADD$INT(:rd_dbkey, :is_child)
    returning_values  :new_id_guest;
    i = :i + 1;

  end
end
^

/* empty dependent procedure body */
/* Clear: RES_TAKE_POSTING_RESPONSIBILITY for: RES_PENDING_DEPOSITS_POST$INT */
ALTER PROCEDURE RES_TAKE_POSTING_RESPONSIBILITY(ID_RESERV_DETAIL /* ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_PENDING_DEPOSITS_POST$INT) */
ALTER PROCEDURE RES_PENDING_DEPOSITS_POST$INT(ID_RESERV_DETAIL ID)
 AS
declare variable id_doc_type integer;
  declare variable deposit_value numeric(15,4);
  declare variable currency char(3);
  declare variable id_account integer;
  declare variable id_payment_head integer;
  declare variable id_deposit integer;
  declare variable def_text varchar(255);
  declare variable description type of TDESCRIPTION_SHORT ;
  declare variable uuid uuid;
  declare variable mapped_doc_type integer;
  declare variable booking_prefix varchar(20);
  declare variable map_prefix varchar(20);
  declare variable hotel_name varchar(50);
begin
  id_doc_type = null;
  id_account = null;

  if (exists (select pd.ID_PENDING_DEPOSIT
              from   PENDING_DEPOSIT pd
              where  pd.ID_RESERV_DETAIL = :ID_RESERV_DETAIL)) then
  begin
    def_text = '';
    map_prefix = null;
    mapped_doc_type = null;
    select sv.SETTING_VALUE, h.hotel_name, r.number_1, ddm.prefix, ddm.doc_type_id, dt.id_doc_type
    from   RESERV_DETAIL r 
           join HOTEL h on h.id_hotel = r.id_hotel
           left outer join DEPOSIT_DOCTYPE_MAP$EXC ddm on ddm.prefix = r.number_1
                                                       and ddm.ID_HOTEL = r.ID_HOTEL
           left outer join DOC_TYPE dt on dt.id_doc_type = ddm.doc_type_id
                                          and dt.id_hotel = r.id_hotel
                                          and dt.IS_ARCHIVE = 0
           left outer join SETTING_GET_VALUE ('DEFAULT_DEPOSIT_DESCRIPTION', r.ID_HOTEL) sv on 1=1
    where  r.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :def_text, :hotel_name, :booking_prefix, :map_prefix, :mapped_doc_type, :id_doc_type;
  
    if (:map_prefix is null) then begin
    /* missed map - raise exception */
      exception DOC_TYPE_EXCEPTION '-1058' || f_character(31) || f_character(29) || :booking_prefix || f_character(28) || :hotel_name;
    end
  
    if (:mapped_doc_type is null) then exit;
    /* empty map (null id_doc_type) supports - skip deposit for this database */
  
    if (:ID_DOC_TYPE is null) then begin
      /* mapped to inexisting doc_type */
      exception DOC_TYPE_EXCEPTION '-1059' || f_character(31) || f_character(29) || :hotel_name;
    end
    /* get reserv account */
    select first 1 ra.ID_ACCOUNT
    from   RES_GET_ACCOUNTS (:ID_RESERV_DETAIL, 'GUARANTEE_DEPOSIT_CREATE') ra
    into   :id_account;
  end

  for
    select pd.DESCRIPTION, pd.DEPOSIT_VALUE, pd.CURRENCY, pd.UUID
    from   PENDING_DEPOSIT pd
    where  pd.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    with lock
    into   :description, :deposit_value, :currency, :uuid
  do begin
    execute procedure DEPOSIT_NEW$DOC (:id_account, :id_doc_type, :deposit_value, :currency,
            substring(:def_text || ' (' || :description || ')' from 1 for 100), :ID_RESERV_DETAIL)
    returning_values (:id_deposit, :id_payment_head);

    update DEPOSIT D
    set    d.UUID = :uuid
    where  d.ID_DEPOSIT = :id_deposit;
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_CHANGE$RSV for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTING$INT for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_GUESTCOUNT$RSV for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_ACCOUNTS$INT) */
ALTER PROCEDURE RES_SAVE_ACCOUNTS$INT(RD_DBKEY CHAR(8))
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_base_account integer;
  declare variable old_id_extra_account integer;
  declare variable new_id_base_account integer;
  declare variable new_id_extra_account integer;
  declare variable acc_routing varchar(30);
  declare variable is_sep_accounts integer;
  declare variable id_base_account_profile integer;
  declare variable id_extra_account_profile integer;
  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable id_agent_account_rule integer;
  declare variable id_acc_template_person integer;
  declare variable id_guest integer;
  declare variable id_hotel integer;
begin

  select RD.ID_RESERV_DETAIL, RD.ID_PERSON_PROFILE, RD.ID_ACC_TEMPLATE_PERSON,
         RD.ACC_ROUTING, RD.ID_BASE_ACCOUNT, RD.ID_EXTRA_ACCOUNT,
         RD.ID_AGENT_PROFILE, RD.ID_AGENT_ACCOUNT_RULE, rd.id_hotel
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :RD_DBKEY
  into   :id_reserv_detail, :id_person_profile, :id_acc_template_person,
         :acc_routing, :old_id_base_account, :old_id_extra_account,
         :id_agent_profile, :id_agent_account_rule, :id_hotel;

  id_agent_account_rule = nullif(:id_agent_account_rule, -1);
  /* --- new */
  execute procedure SETTING_GET_VALUE ('SEPARATE_ACCOUNTS_PER_PAYER', :id_hotel)
  returning_values (:IS_SEP_ACCOUNTS);

  NEW_ID_BASE_ACCOUNT = null; --:old_id_base_account;
  NEW_ID_EXTRA_ACCOUNT = null; --:old_id_extra_account;

  /* identify profiles for base and extra account */
  if (:ACC_ROUTING in ('MIXED')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else if (:ACC_ROUTING in ('AGENT')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
  end else if (:ACC_ROUTING in ('FULL_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = null;
    IS_SEP_ACCOUNTS = 0;  -- never
  end else if (:ACC_ROUTING in ('PART_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else begin -- if (:acc_routing in ('GUEST', 'OWNER'))
    ID_BASE_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_AGENT_ACCOUNT_RULE = null;
  end

  execute procedure RES_ACCOUNTS_RECIEVE$INT (:ID_RESERV_DETAIL, :old_id_base_account, :old_id_extra_account,
          :id_agent_account_rule, :id_base_account_profile, :id_extra_account_profile, :id_person_profile,
          :id_acc_template_person, :is_sep_accounts)
  returning_values (:new_id_base_account, :new_id_extra_account);

--  if (:new_id_base_account is null) then exception WRONG_VALUE 'Invalid base account!';
--  if (:new_id_extra_account is null) then exception WRONG_VALUE 'Invalid extra account!';
  if ((:old_id_base_account is distinct from :new_id_base_account)
       or (:old_id_extra_account is distinct from :new_id_extra_account)) then
  begin
    update RESERV_DETAIL RD
    set    RD.ID_BASE_ACCOUNT = :new_id_base_account,
           RD.ID_EXTRA_ACCOUNT = :new_id_extra_account
    where  RD.RDB$DB_KEY = :RD_DBKEY;
    /* end --- */
    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
             --and G.CHECK_STATUS < 1
      into   :id_guest
    do begin
      execute procedure GUEST_REROUTE_POSTINGS$INT(:id_guest, :new_id_base_account, :new_id_extra_account);
    end

    -- Log account changes
    execute procedure RES_SAVE_ACCOUNTS_FINALIZE$INT(:id_reserv_detail, :old_id_base_account, :old_id_extra_account,
            :new_id_base_account, :new_id_extra_account);
  end

end
^

/* Alter (RES_SAVE_FINALIZE$RSV) */
ALTER PROCEDURE RES_SAVE_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_RESERV_DATE TYPE OF TDATE)
 AS
declare variable rd_dbkey char(8);
  declare variable busy_group_source integer;
  declare variable res_edit_status varchar(255);
  declare variable err_code integer;
  declare variable tmp_err_text varchar(255);
  declare variable id_hotel integer;
begin
  execute procedure sys_dbg('occ RES_SAVE_FINALIZE$RSV enter');

  select RD.RDB$DB_KEY, iif(RD.CHECK_STATUS = 1, 24, 1), rd.RES_EDIT_STATUS, rd.ID_HOTEL
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :busy_group_source, :res_edit_status, :id_hotel;

  if (:res_edit_status containing 'ADDGUEST') then begin
    execute procedure RES_GUEST_FINALIZE$RSV (:ID_RESERV_DETAIL, 0)
    returning_values (:warn_code);
  end

  execute procedure OCCUPANCY_ROOMS_CHECK$INT(:rd_dbkey, :busy_group_source)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :WARN_CODE;
  --if (:share_err_code <> 0) then err_code = 0;      -- offer share entering
  --if (:share_err_code = 1) then share_err_code = 0; -- all shares are known

  execute procedure sys_dbg('occup RES_SAVE_FINALIZE$RSV share_err_code = '||coalesce(:share_err_code, 'null'));

  execute procedure RES_FINALIZE_CLEAR$INT(:rd_dbkey, :id_reserv_detail);

  delete from RESERV_STAY$TMP t
  where  t.id_session = RDB$GET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION', null);  -- Excplicitly set to null !!!

  err_code = 0;
  select first 1 RE.ERR_CODE, RE.ERR_TEXT
  from   RESERV_ERROR RE
  where  RE.ID_RESERV_DETAIL = :id_reserv_detail
  into   :err_code, :tmp_err_text;

  if (:err_code <> 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || :tmp_err_text;

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :NEW_RESERV_DATE;
end
^

/* empty dependent procedure body */
/* Clear: RESMULTI_COMMON_MODIFY$RSV for: RES_SAVE_GUESTCOUNT$INT */
ALTER PROCEDURE RESMULTI_COMMON_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
CHECK_STATUS SMALLINT,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
NOTE VARCHAR(255),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(30),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
NOTE_REMINDERS VARCHAR(50),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_GUESTCOUNT$INT) */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$INT(RD_DBKEY CHAR(8),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 AS
declare variable old_adult_count integer;
  declare variable old_child_count integer;
  declare variable add_adult_count integer;
  declare variable add_child_count integer;
  declare variable del_adult_count integer;
  declare variable del_child_count integer;
begin

  if (((:adult_count + :child_count) <= 0) or (:adult_count < 0) or (:child_count < 0)) then begin
    exception BOOKING_EXCEPTION '-1005' || f_character(31) || f_character(29) || :adult_count || f_character(28) || :child_count;
  end

  select RD.ADULT_COUNT, RD.CHILD_COUNT
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_adult_count, :old_child_count;
  add_adult_count = 0;
  add_child_count = 0;
  del_adult_count = 0;
  del_child_count = 0;
  if (:old_adult_count < :adult_count) then add_adult_count = adult_count - :old_adult_count;
  else del_adult_count = :old_adult_count - :adult_count;
  if (:old_child_count < :child_count) then add_child_count = child_count - :old_child_count;
  else del_child_count = :old_child_count - :child_count;

  execute procedure RES_GUESTCOUNT_ADD$INT(:rd_dbkey, :add_adult_count, :add_child_count);

  execute procedure RES_GUESTCOUNT_DEL$INT(:rd_dbkey, :del_adult_count, :del_child_count);
end
^

/* Alter (RES_SAVE_GUESTCOUNT$RSV) */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select rd.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  rd.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SAVE_GUESTCOUNT$INT(:rd_dbkey, :adult_count, :child_count);

  execute procedure RES_SAVE_ACCOUNTS$INT (:rd_dbkey);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 0)
  returning_values  :warn_code;

end
^

/* empty dependent procedure body */
/* Clear: RES_CHECKIN$RSV for: RES_SAVE_ROOM$INT */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_ROOM_REMOVE$INT for: RES_SAVE_ROOM$INT */
ALTER PROCEDURE RES_ROOM_REMOVE$INT(RD_DBKEY CHAR(8))
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_ROOM$INT) */
ALTER PROCEDURE RES_SAVE_ROOM$INT(RD_DBKEY TYPE OF TDB_KEY,
ID_ROOM TYPE OF ID,
ID_RES_ROOM_TYPE TYPE OF ID,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE TYPE OF TLOGICAL = null)
 RETURNS(WARN_CODE TYPE OF TRANGE)
 AS
declare variable id_reserv_detail integer;
  declare variable id_tar_room_type integer;
  declare variable old_id_room_type integer;
  declare variable old_id_room integer;
  declare variable departure_date date;
  declare variable id_guest integer;
  declare variable g_dbkey char(8);
  declare variable system_date date;
  declare variable system_date_for_room date;
  declare variable check_status integer;
  declare variable cleaning_restriction varchar(50);
  declare variable guest_status varchar(50) default '';
  declare variable id_hotel integer;
  declare variable has_different_room_type integer;
  declare variable acc_routing varchar(30);
  declare variable res_number varchar(62);
begin
  select RD.ID_ROOM_TYPE, RD.CHECK_STATUS, RD.ID_ROOM, RD.TO_DATE, RD.ID_RESERV_DETAIL, RD.ID_HOTEL, rd.ACC_ROUTING, rd.NUMBER
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_room_type, :check_status, :old_id_room, :departure_date, :id_reserv_detail, :id_hotel, :acc_routing, :res_number;

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date_for_room;
  /**/
  system_date = null;
  /*  */
  if (:check_status >= 0 and :old_id_room > 0 and coalesce(:id_room, 0) <= 0) then
    exception BOOKING_EXCEPTION '-111';

  if ((:old_id_room > 0) and (:id_room is distinct from :old_id_room)) then begin
    guest_status = 'ROOM_CHANGED';
    if ((:old_id_room > 0) and (:id_room > 0)) then begin
      execute procedure SYSTEM_DATE_GET(:id_hotel)
      returning_values  :system_date;
      execute procedure sys_dbg('res RES_SAVE_ROOM$INT old_id_room = '||coalesce(:old_id_room, 'null'));
      execute procedure sys_dbg('res RES_SAVE_ROOM$INT check_status = '||coalesce(:check_status, 'null'));

      if ((:departure_date <= :system_date) and (:check_status >= 0)) then exception BOOKING_EXCEPTION '-51';
    end
  end

  if (:id_room is null and :old_id_room < 0) then id_room = :old_id_room; -- preserve old fictious ID, because of mapped rooms

  if (coalesce(:id_room, 0) <= 0) then begin
    delete from ROOM_MAP$EXC m
    where  m.id_room = :id_room
           and m.ID_SRC_ROOM < 0;  -- delete wrong mappings (bug 2827)

    select ro.ID_ROOM
    from   RES_OCCUPANCY_ROOM$INT (:id_reserv_detail, :system_date_for_room, :id_room, :ID_RES_ROOM_TYPE) RO
    into   :id_room;

  end else begin
    -- real room is
    id_res_room_type = :old_id_room_type;
    if (:acc_routing <> 'OWNER'
        and :id_room is distinct from :old_id_room
        and exists (select rp.ID_ROOM_PERIOD
                    from   ROOM_PERIOD$PMS rp
                    where  rp.ID_ROOM = :ID_ROOM
                           and rp.FROM_DATE <= :system_date_for_room
                           and rp.TO_DATE >= :system_date_for_room
                           and rp.STATUS = 'PRIVATE')) then
    begin
      execute procedure SYSTEM_WARNING_ADD (-61, f_character(29) || :res_number)
      returning_values  :WARN_CODE;
    end
  end
  id_res_room_type = coalesce(:id_res_room_type, :old_id_room_type);
  -- null is permissible for id_res_room_type, treat of "keep the same"

  /* tar_option : nrttAsIs, nrttRoom, nrttReserv */
  id_tar_room_type = null;
  has_different_room_type = null;
  if (:tar_option = 'nrttAsIs') then begin
    id_tar_room_type = null;
    has_different_room_type = null;
  end else if (:tar_option = 'nrttRoom') then begin
    --id_tar_room_type = iif(coalesce(:id_room, 0) <= 0 and :room_id_room_type <> :ID_RES_ROOM_TYPE, :room_id_room_type, -1);
    id_tar_room_type = iif (:ID_ROOM > 0, -1, null); -- if not room - like a AsIs
    has_different_room_type = iif(:id_tar_room_type = -1, 0, null);
    -- preserve tar_room_type from mapped(unexisted) room
  end else begin /* nrttReserv */
    id_tar_room_type = :id_res_room_type;
    has_different_room_type = 1;
  end

  update RESERV_DETAIL RD
  set    RD.ID_ROOM = :id_room,
         rd.ROOM_PRICE = case
                           when rd.CHECK_STATUS >= 0 then null
                           -- 'checked in' bookings - force recalculation always
                           when rd.CHECK_STATUS < 0
                                and ((rd.ID_ROOM_TYPE <> :id_res_room_type) or (:id_room is distinct from :old_id_room)) then null
                           -- not 'checked in', but room/room type changed - force too
                           else rd.ROOM_PRICE
                         end,   -- <null> room_price will be force booking recalculation !!!
         RD.ID_ROOM_TYPE = :id_res_room_type,  -- this field update must be after room_price update
         rd.HAS_DIFFERENT_ROOM_TYPE = coalesce(:has_different_room_type, rd.HAS_DIFFERENT_ROOM_TYPE) --iif(coalesce(:id_tar_room_type, 0) > 0, 1, rd.HAS_DIFFERENT_ROOM_TYPE)
  where  RD.RDB$DB_KEY = :rd_dbkey;

  for
    select G.RDB$DB_KEY, G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :g_dbkey, :id_guest
  do begin
    update GUEST GU
    set    GU.OLD_ID_ROOM = GU.ID_ROOM,
           GU.ID_ROOM = :id_room
    where  GU.RDB$DB_KEY = :g_dbkey;

    execute procedure GUEST_SET_EDIT_STATUS$INT (:g_dbkey, :guest_status, 'add');
   
    /*Old code if (:system_date is null) update room_type and type stay*/
    update GUEST_STAY GS
    set    GS.ID_ROOM_TYPE = iif(:id_tar_room_type is null, GS.ID_ROOM_TYPE, :id_tar_room_type),
           GS.ID_TYPE_STAY = iif(:is_auto_staytype = 1, -1, GS.ID_TYPE_STAY)
    where  GS.ID_GUEST = :id_guest
           and ((:system_date is null) or (GS.FOR_DATE >= :system_date));

    /*New part - Room number never be updated in past - important for shares and calulations*/
    /* will be updated in pass only if there was no room assigned*/
    update GUEST_STAY GS
    set    GS.ID_ROOM = :id_room
    where  GS.ID_GUEST = :id_guest
           and ((GS.FOR_DATE >= :system_date_for_room)
                 or (:check_status < 0) -- new - always change id_room from begining, for non checked in reservs
               ) ;
  end

  if ((:check_status = 0) and (:guest_status = 'ROOM_CHANGED') and (:old_id_room > 0)) then begin
    /* IF THE CLEANING RESTRICTION IS ACTIVATED AND THE OLD
    || GUEST'S ROOM IS VACANT THEN IT MUST BE MARKED DIRTY.
    */
    execute procedure SETTING_GET_VALUE('CLEANING_RESTRICTION', :id_hotel)
    returning_values  :cleaning_restriction;
    if ((:cleaning_restriction <> '0') and (not exists (
      select *
      from   GUEST G
             join GUEST_STAY GS on GS.ID_GUEST = G.ID_GUEST
      where  GS.FOR_DATE >= :system_date
             and G.CHECK_STATUS = 0
             and GS.ID_ROOM = :old_id_room
             and G.ID_RESERV_DETAIL <> :id_reserv_detail
    ))) then begin
      execute procedure ROOM_HOUSEKEEPING(:old_id_room, 'GST_MOVED', 'set_dirty');
    end
  end

  execute procedure RES_SAVE_ROOM_LOG$INT(:RD_DBKEY, :old_id_room, :old_id_room_type);

end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ROOM$EXC for: RES_SAVE_ROOM$RSV */
ALTER PROCEDURE RES_SAVE_ROOM$EXC(RD_DBKEY CHAR(8),
ID_RES_ROOM_TYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(250),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_ROOM$RSV) */
ALTER PROCEDURE RES_SAVE_ROOM$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
ID_RES_ROOM_TYPE INTEGER,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(255),
SPLIT_ON_CHECKIN SMALLINT,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
declare variable tmp_warn_code integer;
begin
  WARN_CODE = null;
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, :id_res_room_type, :TAR_OPTION, :is_auto_staytype)
  returning_values (:WARN_CODE);

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 1)
    returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :tmp_warn_code;
  end
  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

  update RESERV_DETAIL R
  set    r.SPLIT_ON_CHECKIN = :split_on_checkin,
         r.ID_HK_PLAN = :ID_HK_PLAN,
         r.I_SPECIAL_TREATMENT = :I_SPECIAL_TREATMENT,
         r.ROOM_FEATURES = :ROOM_FEATURES
  where  r.ID_RESERV_DETAIL = :id_reserv_detail;
end
^

/* empty dependent procedure body */
/* Clear: RES_EARLY_DEPARTURE_SET$RSV for: RES_SAVE_STAY$INT */
ALTER PROCEDURE RES_EARLY_DEPARTURE_SET$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND INTEGER)
 RETURNS(RECALC_MARKER_LIST VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_STAY_MODIFY$RSV for: RES_SAVE_STAY$INT */
ALTER PROCEDURE RESMULTI_STAY_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SAVE_STAY$INT) */
ALTER PROCEDURE RES_SAVE_STAY$INT(RD_DBKEY CHAR(8),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER)
 AS
declare variable day_keep_types integer;
  declare variable exp_date date;
  declare variable leaving_kind integer;
  declare variable old_arrival date;
  declare variable old_departure date;
  declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable old_comming_kind integer;
  declare variable old_leaving_kind integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable is_stay_changed integer;
begin
  -- TODO exp_date must become input parameter, because the user may change it! or add exp_scheme!

  select RD.FROM_DATE, RD.TO_DATE, RD.COMMING_KIND, RD.LEAVING_KIND, RD.ID_HOTEL,
         rd.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_arrival, :old_departure, :old_comming_kind, :old_leaving_kind, :id_hotel,
         :id_reserv_detail;

  if (:DEPARTURE_DATE <= :ARRIVAL_DATE) then exception BOOKING_EXCEPTION '-53';

  execute procedure SETTING_GET_VALUE('DAY_KEEP_TYPES', :id_hotel)
  returning_values  :day_keep_types;

  exp_date = :arrival_date + :day_keep_types;
  leaving_kind = coalesce(:is_late_departure + 1, :old_leaving_kind);
  comming_kind = coalesce(:comming_kind, :old_comming_kind);

  if ((:arrival_date <> :old_arrival) or (:departure_date <> :old_departure)) then begin
    execute procedure RESERV_TRACK_CHANGES$INT (:RD_DBKEY);
  end

  if ((:arrival_date <> :old_arrival)
      or (:departure_date <> :old_departure)
      or (:comming_kind <> :old_comming_kind)
      or (:leaving_kind <> :old_leaving_kind)) then is_stay_changed = 1;
  else is_stay_changed = 0;

  update RESERV_DETAIL RD
  set    RD.COMMING_KIND = :comming_kind,
         RD.LEAVING_KIND = :leaving_kind,
         RD.EXP_DATE = :exp_date,
         RD.FROM_DATE = :arrival_date,
         RD.TO_DATE = :departure_date,
         rd.ROOM_PRICE = iif(:is_stay_changed = 1, null, rd.ROOM_PRICE) -- force recalculation
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:is_stay_changed = 1) then begin
    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :g_dbkey
    do begin
      execute procedure RES_GUEST_SAVE_STAY$INT(:g_dbkey, :arrival_date, :departure_date, :id_hotel);
    end

    execute procedure RES_SET_EDIT_STATUS$INT (:RD_DBKEY, 'DATE_CHANGED');

    --Remove manual prices (if any) outer new period--/
    if (:old_arrival < :arrival_date) then
      delete from RESERV_CUSTOM_PRICE rcp
      where  rcp.id_reserv_detail = :id_reserv_detail
             and rcp.FOR_DATE < :arrival_date;

    if (:old_departure > :departure_date) then
      delete from RESERV_CUSTOM_PRICE rcp
      where  rcp.id_reserv_detail = :id_reserv_detail
             and RCP.FOR_DATE >= :departure_date;

    if (not exists (select * from RESERV_CUSTOM_PRICE rmp where rmp.id_reserv_detail = :id_reserv_detail)) then
        update RESERV_DETAIL set  has_different_price = 0 where id_reserv_detail = :id_reserv_detail;
    ----
  end

  if ((:old_arrival <> :arrival_date) or (:old_departure <> :departure_date) ) then begin
    action_text = f_character(29) || '{' || formatdate(:old_arrival, 'D;dd.mm.yyyy') || '-' || formatdate(:old_departure, 'D;dd.mm.yyyy') || '}'
                  || f_character(28) || '{' || formatdate(:arrival_date, 'D;dd.mm.yyyy') || '-' || formatdate(:departure_date, 'D;dd.mm.yyyy') || '}';
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_MOD_PERIOD', :action_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: UPDATE_BOOKING$EXC for: RES_SAVE_STAY$RSV */
ALTER PROCEDURE UPDATE_BOOKING$EXC(BOOKING_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE INTEGER,
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA_ID INTEGER,
POSTING_ROUTING VARCHAR(20),
ID_AGENT_ACCOUNT INTEGER,
RATE_ID INTEGER,
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD_CODE /* TFOOD_CODE */ VARCHAR(20),
ARRANGER_PROFILE_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_STAY$RSV) */
ALTER PROCEDURE RES_SAVE_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure sys_dbg('res RES_SAVE_STAY$RSV comming_kind = '||coalesce(:comming_kind, 'null'));
  execute procedure sys_dbg('res RES_SAVE_STAY$RSV is_late_departure = '||coalesce(:is_late_departure, 'null'));

  execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :departure_date, :is_late_departure, :comming_kind);

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 1)
    returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;
    execute procedure sys_dbg('res RES_SAVE_STAY$RSV share_err_code = '||coalesce(:share_err_code, 'null'));
  end
  --
end
^

/* Alter (RES_SET_CHECKIN$INT) */
ALTER PROCEDURE RES_SET_CHECKIN$INT(RD_DBKEY CHAR(8))
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
begin
  select r.ID_RESERV_DETAIL
  from   RESERV_DETAIL R
  where  r.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail;

  execute procedure ROOM_MAGIC_CLEAR(:id_reserv_detail);   -- ?!?

  execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, 0);

  for
    select G.RDB$DB_KEY
    from   GUEST G
    where  g.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :g_dbkey
  do begin
    execute procedure GUEST_SET_STATUS$INT(:g_dbkey, 0);
  end

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;
end
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_CO_RENTERS$INT for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_CO_RENTERS$INT(VIRTUAL_ID_ROOM INTEGER,
NEW_ID_ROOM INTEGER,
INIT_ID_RES_DETAIL INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_FAST$RSV for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_FAST$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_MULTI$RSV for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_MULTI$RSV(OPERATION VARCHAR(20),
FROM_ROOM VARCHAR(20),
SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_SHARED$RSV for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_SHARED$RSV(SELECTION_ID INTEGER,
ROOM_NAME VARCHAR(10))
 RETURNS(VIRTUAL_ROOM VARCHAR(10),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SET_ROOM$INT) */
ALTER PROCEDURE RES_SET_ROOM$INT(RD_DBKEY CHAR(8),
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
declare variable tmp_warn_code integer;
begin
  WARN_CODE = null;
  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option)
  returning_values (:WARN_CODE);

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :SHARE_ERR_TEXT, :share_transaction_id, :tmp_warn_code;

  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
end
^

/* Alter (RES_SET_ROOM_CO_RENTERS$INT) */
ALTER PROCEDURE RES_SET_ROOM_CO_RENTERS$INT(VIRTUAL_ID_ROOM INTEGER,
NEW_ID_ROOM INTEGER,
INIT_ID_RES_DETAIL INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
declare variable shared_rd_dbkey char(8);
declare variable shared_booking_ids varchar(255);
declare variable id_reserv_detail integer;
declare variable tmp_share_err_code integer;
declare variable tmp_share_err_text varchar(255);
begin
  -- distribute the same room to shared bookings

  if (coalesce(:NEW_ID_ROOM, 0) < 0) then exit; -- only for real rooms!1
  SHARE_ERR_CODE = 0;
  shared_booking_ids = ',' || :INIT_ID_RES_DETAIL || ',';
  for
    select vrd.RDB$DB_KEY, vrd.ID_RESERV_DETAIL
    from   RESERV_DETAIL VRD
    where  vrd.ID_ROOM = :VIRTUAL_ID_ROOM
           and vrd.IS_ANUL = 0
           and vrd.ID_RESERV_DETAIL is distinct from :INIT_ID_RES_DETAIL
    into   :shared_rd_dbkey, :id_reserv_detail
  do begin
    shared_booking_ids = :shared_booking_ids || :id_reserv_detail || ',';

    execute procedure RES_SET_ROOM$INT (:shared_rd_dbkey, :NEW_ID_ROOM, :TAR_OPTION)
    returning_values  :WARN_CODE, :share_transaction_id, :tmp_share_err_code, :tmp_share_err_text;

    if (:SHARE_ERR_CODE = 0 and :tmp_share_err_code < 0) then begin
      -- check for share with other bookings
      if (exists (select rs.ID_RESERV_DETAIL
                      from   ROOMS_SHARE rs
                      where  rs.MARK_TRANSACTION = :SHARE_TRANSACTION_ID
                             and :shared_booking_ids not containing ','||rs.ID_RESERV_DETAIL||','
                             and rs.IS_EX_SHARE = 0)) then
      begin
        SHARE_ERR_CODE = :tmp_share_err_code;
        SHARE_ERR_TEXT = :tmp_share_err_text;
      end
    end
  end 
end
^

/* Alter (RES_SET_ROOM_FAST$RSV) */
ALTER PROCEDURE RES_SET_ROOM_FAST$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable old_id_room integer;
  declare variable virtual_room varchar(10);
  declare variable rd_dbkey char(8);
  declare variable tmp_warn_code integer;
  declare variable tmp_share_err_code integer;
  declare variable tmp_share_err_text varchar(255);
begin

  select RD.ID_ROOM, rd.VIRTUAL_ROOM, rd.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_id_room, :virtual_room, :rd_dbkey;

  execute procedure RES_SET_ROOM$INT (:rd_dbkey, :ID_ROOM, :TAR_OPTION)
  returning_values (:warn_code, :share_transaction_id, :share_err_code, :ERR_TEXT);

  if (:virtual_room is not null and :old_id_room < 0) then begin
    execute procedure RES_SET_ROOM_CO_RENTERS$INT (:old_id_room, :ID_ROOM, :ID_RESERV_DETAIL, :TAR_OPTION)
    returning_values (:tmp_warn_code, :share_transaction_id, :tmp_share_err_code, :tmp_share_err_text);
    WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
    SHARE_ERR_CODE = coalesce(:SHARE_ERR_CODE, :tmp_share_err_code);
    ERR_TEXT = coalesce(:ERR_TEXT, :tmp_share_err_text);
  end
end
^

/* Alter (RES_SET_ROOM_MULTI$RSV) */
ALTER PROCEDURE RES_SET_ROOM_MULTI$RSV(OPERATION VARCHAR(20),
FROM_ROOM VARCHAR(20),
SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable cnt_requested integer;
  declare variable cnt_old_room integer;
  declare variable cnt_found integer;
  declare variable is_already_planned integer;
  declare variable is_satisfied integer;
  declare variable new_id_room integer;
  declare variable current_id_room integer;
  declare variable id_res_room_type integer;
  declare variable room_requirements blob sub_type 1 segment size 100;
  declare variable from_date date;
  declare variable to_date date;
  declare variable action_text varchar(255);
  declare variable is_early_arrival smallint;
  declare variable is_late_departure smallint;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable id_reserv_detail integer;
  declare variable tmp_warn_code integer;
  declare variable min_beds integer;
  declare variable virtual_room varchar(10);
  declare variable share_err_text varchar(255);
begin
  /* offer_method :
  ||     0 - NUMBER desc,
  ||     1 - NUMBER asc,
  ||     2 - DAYS FREE(MAX OCCUPANCY),
  ||     3 - FILING FACTOR(EQUAL ROOM USAGE)
  */
  warn_code = null;

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'set_number_asc, set_number_desc, set_max_occupancy, set_max_usage');

  cnt_requested = 0;
  cnt_old_room = 0;
  cnt_found = 0;
  for
    select RD.RDB$DB_KEY, rd.ID_RESERV_DETAIL, rd.ID_ROOM, rd.VIRTUAL_ROOM, RD.ID_ROOM_TYPE, RD.ROOM_FEATURES,
           RD.FROM_DATE, RD.TO_DATE, iif(rd.COMMING_KIND = 0, 1, 0), iif(rd.LEAVING_KIND = 2, 1, 0),
           rd.ADULT_COUNT + rd.CHILD_COUNT
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
           and RD.IS_ANUL = 0
    into   :rd_dbkey, :id_reserv_detail, :current_id_room, :virtual_room, :id_res_room_type, :room_requirements,
           :from_date, :to_date, :is_early_arrival, :is_late_departure, :min_beds
  do begin
    cnt_requested = :cnt_requested + 1;
    new_id_room = null;
    if (:current_id_room < 0) then begin
      if (:virtual_room is not null) then begin
        -- has related bookings with shared virtual room
        -- get cumulative stay for all shared bookings
        select min(vrd.FROM_DATE), min(vrd.FROM_DATE) - min(vrd.FROM_DATE - iif(vrd.COMMING_KIND = 0, 1, 0)),
               max(vrd.TO_DATE), max(vrd.TO_DATE + iif(vrd.LEAVING_KIND = 2, 1, 0)) - max(vrd.TO_DATE),
               sum(vrd.ADULT_COUNT + vrd.CHILD_COUNT)
        from   RESERV_DETAIL VRD
        where  vrd.ID_ROOM = :current_id_room
               and vrd.IS_ANUL = 0
        into   :from_date, :is_early_arrival, :to_date, :is_late_departure, :min_beds;
      end
      -- from_date and to_date are arrival and departure date of reservation,
      -- not first and last accomodation dates !!! this is need to check early arrivals and late departures
      execute procedure ROOM_PICKUP$INT(:id_res_room_type, :from_date, :to_date,
              :is_early_arrival, :is_late_departure,:operation, :from_room, :room_requirements, :min_beds)
      returning_values  :new_id_room;  -- offered room

      if (:new_id_room is not null) then begin
        is_satisfied = 1;
        select R.ROOM_NAME
        from   ROOMS R
        where  r.ID_ROOM = :new_id_room
        into   :action_text;

        execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'ROOM_SET_AUTO', :action_text);

        execute procedure RES_SET_ROOM$INT (:rd_dbkey, :new_id_room, 'nrttAsIs')
        returning_values (:tmp_warn_code, :share_transaction_id, :share_err_code, :share_err_text);
        if (:share_err_code < 0) then exception BOOKING_EXCEPTION 'Unallowable share!!!';
        WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

        if (:virtual_room is not null) then begin
          -- distribute the same room to shared bookings
          execute procedure RES_SET_ROOM_CO_RENTERS$INT (:current_id_room, :new_id_room, :id_reserv_detail, 'nrttAsIs')
          returning_values (:tmp_warn_code, :share_transaction_id, :share_err_code, :share_err_text);
          if (:share_err_code < 0) then exception BOOKING_EXCEPTION 'Unallowable share!!!';
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
        end
      end

    end else begin
      is_already_planned = 1;
    end

    cnt_old_room = :cnt_old_room + :is_already_planned;
    cnt_found = :cnt_found + :is_satisfied;

    when exception BOOKING_EXCEPTION do begin
      -- nothing, skip this booking
    end
  end

  if ((:cnt_found + :cnt_old_room) < :cnt_requested) then begin
    execute procedure SYSTEM_WARNING_ADD(-3, f_character(29)||:cnt_found||f_character(28)||:cnt_requested)
    returning_values  :warn_code;
  end
end
^

/* Alter (RES_SET_ROOM_SHARED$RSV) */
ALTER PROCEDURE RES_SET_ROOM_SHARED$RSV(SELECTION_ID INTEGER,
ROOM_NAME VARCHAR(10))
 RETURNS(VIRTUAL_ROOM VARCHAR(10),
WARN_CODE INTEGER)
 AS
declare variable r_dbkey char(8);
  declare variable is_anul integer;
  declare variable shared_id_room integer;
  declare variable current_id_room integer;
  declare variable tmp_warn_code integer;
  declare variable share_trans integer;
  declare variable share_err_code integer;
  declare variable id_hotel integer;
  declare variable cnt_hotels integer;
  declare variable id_room integer;
  declare variable res_counter integer;
  declare variable min_departure date;
  declare variable max_arrival date;
  declare variable share_err_text varchar(255);
begin
  VIRTUAL_ROOM = null;
  select min(r.ID_HOTEL), count(distinct r.ID_HOTEL),
         min(r.TO_DATE), max(r.FROM_DATE)
  from   RESERV_DETAIL R
  where  R.SELECTION_ID = :SELECTION_ID
  into   :id_hotel, :cnt_hotels, :min_departure, :max_arrival;

  if (:cnt_hotels > 1) then exception BOOKING_EXCEPTION '-1035';
  if (:min_departure <= :max_arrival) then exception BOOKING_EXCEPTION '-1037';

  if (:ROOM_NAME is not null) then begin
    execute procedure ROOM_GET_BY_NAME(:ROOM_NAME, :id_hotel)
    returning_values (:id_room);
    shared_id_room = :ID_ROOM;
  end else begin
    id_room = null;
    shared_id_room = gen_id(DETAIL_WITHOUT_ROOMING_LIST, -1);
    VIRTUAL_ROOM = gen_id(GEN_VIRTUAL_ROOM, 1);
  end

  res_counter = 0;
  for
    select r.RDB$DB_KEY, r.IS_ANUL, r.ID_ROOM
    from   RESERV_DETAIL R
    where  R.SELECTION_ID = :SELECTION_ID
    into   :r_dbkey, :is_anul, :current_id_room
  do begin
    res_counter = :res_counter + 1;
    if (:is_anul = 1) then
      exception BOOKING_EXCEPTION '-1036';

    if (:current_id_room > 0 and :ID_ROOM is null) then
      exception BOOKING_EXCEPTION '-1034';

    execute procedure RES_SET_ROOM$INT(:r_dbkey, :shared_id_room, 'nrttAsIs')
    returning_values  :tmp_warn_code, :share_trans, :share_err_code, :share_err_text;
    WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
  end

  if (:VIRTUAL_ROOM is not null and :share_trans is not null) then begin
    update RESERV_DETAIL RD
    set    rd.VIRTUAL_ROOM = '<'||:VIRTUAL_ROOM||'>'
    where  rd.ID_ROOM = :shared_id_room;
  end
end
^

/* Alter (RES_SET_STAY$RSV) */
ALTER PROCEDURE RES_SET_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable is_late_departure integer;
  declare variable comming_kind integer;
begin
  select RD.COMMING_KIND, RD.LEAVING_KIND - 1, RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :comming_kind, :is_late_departure, :rd_dbkey;

  execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :departure_date, :is_late_departure, :comming_kind);

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 1)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

end
^

/* empty dependent procedure body */
/* Clear: RES_CHECKIN_MULTI$RSV for: RES_SPLIT$RSV */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT_MULTI$RSV for: RES_SPLIT$RSV */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SPLIT$RSV) */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
declare variable rd_dbkey_old char(8);
  declare variable rd_dbkey_new char(8);
  declare variable id_guest integer;
  declare variable warn_code integer;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;

  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable check_status integer;
  declare variable arrival_date date;
  declare variable departure_date date;
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable id_room_type integer;
  declare variable id_room integer;
  declare variable id_board integer;
  declare variable id_tariff integer;
  declare variable custom_price numeric(15,4);
  declare variable custom_currency char(3);
  declare variable voucher_num varchar(30);
  declare variable voucher_date date;
  declare variable voucher_text varchar(30);
  declare variable voucher2_num varchar(30);
  declare variable voucher2_date date;
  declare variable transfer_in_time time;
  declare variable transfer_in_note varchar(255);
  declare variable transfer_out_time time;
  declare variable transfer_out_note varchar(255);
  declare variable comming_kind integer;
  declare variable is_late_departure integer;
  declare variable is_vip integer;
  declare variable country_code varchar(20);
  declare variable code_first_food tfood_code;
  declare variable i_special_treatment varchar(255);
  declare variable id_nom_market_segment integer;
  declare variable id_nom_source_code integer;
  declare variable id_nom_channel_code integer;
  declare variable id_nom_hear_reason integer;
  declare variable id_nom_come_reason integer;
  declare variable id_agent_account integer;
  declare variable acc_routing varchar(50);
  declare variable id_person_payment integer;
  declare variable id_agent_payment integer;
  declare variable room_features blob sub_type 1 segment size 80;
  declare variable id_hk_plan integer;
  declare variable id_group integer;
  declare variable id_hotel integer;
  declare variable note varchar(2000);
  declare variable note_reminders varchar(50);
  declare variable guarantee_deposit numeric(15,4);
  declare variable guarantee_currency char(3);
  declare variable id_titular integer;
  declare variable id_profile_data integer;
  declare variable id_acc_template_person integer;
  declare variable number_1 varchar(20);
  declare variable number_2 varchar(20);
  declare variable new_res_number varchar(62);
  declare variable g_dbkey char(8);
  declare variable is_child integer;
  declare variable id_guarantee_policy integer;
  declare variable block_cc varchar(255);
  declare variable virtual_room varchar(10);
  declare variable err_text varchar(255);
  declare variable is_posting_stopped integer;
  declare variable id_eating_object integer;
begin
  select RD.RDB$DB_KEY, RD.ID_AGENT_PROFILE, RD.CHECK_STATUS, RD.FROM_DATE, RD.TO_DATE,
         RD.ADULT_COUNT, RD.CHILD_COUNT, RD.ID_ROOM_TYPE, RD.ID_ROOM, RD.ID_BOARD, RD.ID_RATE,
         RD.CUSTOM_PRICE, RD.CUSTOM_CURRENCY, RD.VAUCHER_NUM, RD.VAUCHER_DATE, RD.VAUCHER_TEXT, RD.VAUCHER_NUM2,
         RD.VAUCHER_DATE2, RD.TRANSFER_IN_TIME, RD.TRANSFER_IN_NOTE, RD.TRANSFER_OUT_TIME, RD.TRANSFER_OUT_NOTE,
         RD.COMMING_KIND, RD.LEAVING_KIND - 1, RD.IS_VIP, RD.COUNTRY, RD.CODE_FIRST_FOOD, RD.I_SPECIAL_TREATMENT,
         RD.ID_NOM_MARKET_SEGMENT, RD.ID_NOM_SOURCE_CODE, RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_HEAR_REASON,
         RD.ID_NOM_COME_REASON, RD.ID_AGENT_ACCOUNT_RULE, RD.ACC_ROUTING, RD.ID_PERSON_PAYMENT, RD.ID_AGENT_PAYMENT,
         RD.ROOM_FEATURES, RD.ID_HK_PLAN, RD.ID_GROUP, RD.ID_HOTEL, RD.NOTE, RD.NOTE_REMINDERS,
         RD.GUARANTEE_DEPOSIT, RD.GUARANTEE_CURRENCY, RD.ID_ACC_TEMPLATE_PERSON,
         RD.NUMBER_1, rd.NUMBER_2, rd.ID_GUARANTEE_POLICY, rd.BLOCK_CC, rd.IS_POSTING_STOPPED, rd.ID_EATING_OBJECT
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail_source
  into   :rd_dbkey_old, :id_agent_profile, :check_status, :arrival_date, :departure_date,
         :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff,
         :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
         :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
         :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
         :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
         :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
         :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
         :guarantee_deposit, :guarantee_currency, :id_acc_template_person,
         :number_1, :number_2,:id_guarantee_policy, :block_cc, :is_posting_stopped, :id_eating_object;

  select first 1 sp.ITEM
  from   SYSTEM_STRING_PARSER(:guest_ids, ',') sp
  into   :id_titular;

  select min(g.FROM_DATE), max(g.TO_DATE)
  from   GUEST G
  where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL_SOURCE
         and ','||:GUEST_IDS||',' containing ','||g.ID_GUEST||','
  into   :arrival_date, :departure_date;

  if (exists (select *
              from   RESERV_DETAIL RD
              where  RD.ID_TITULAR = :id_titular
                     and RD.ID_RESERV_DETAIL = :id_reserv_detail_source))
  then exception BOOKING_EXCEPTION 'Titular can not be splited in new reservation';

  execute procedure RES_GET_PERSON_PROFILE$INT(:id_titular)
  returning_values  :id_person_profile, :id_profile_data;

  new_res_number = iif(coalesce(:number_1,'')='','.',:number_1||'.')
                   || coalesce(:number_2, '')
                   || '.0';  -- fictive suffix, needed for unique constraint limitation, that will be replaced with real one


  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, :check_status, :arrival_date, :departure_date,
                    0, 0, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
                    :guarantee_deposit, :guarantee_currency, 0, null, :new_res_number, :id_acc_template_person,
                    :id_guarantee_policy, :block_cc, :id_eating_object)
  returning_values  :rd_dbkey_new, :new_id_reserv_detail, :warn_code;

  execute procedure RES_NUMBER_SUFFIX_GEN (:NEW_ID_RESERV_DETAIL)
  returning_values  (:new_res_number);  -- add suffix to new (splited) booking number (empty on create)

  update RESERV_DETAIL NR
  set    nr.IS_POSTING_STOPPED = :is_posting_stopped
  where  nr.RDB$DB_KEY = :rd_dbkey_new;

  -- there is no need guests deleting, because new splited reservation is created with 0 guests
  adult_count = 0; child_count = 0;
  for
    select G.ID_GUEST, G.RDB$DB_KEY, G.IS_CHILD
    from   SYSTEM_STRING_PARSER(:guest_ids, ',') SP
           join GUEST G on G.ID_GUEST = SP.ITEM
    into   :id_guest, :g_dbkey, :is_child
  do begin
    execute procedure GUEST_SET_EDIT_STATUS$INT (:g_dbkey, 'REBUILD', 'add');

    update GUEST G
    set    G.ID_RESERV_DETAIL = :new_id_reserv_detail
    where  G.ID_GUEST = :id_guest;

    adult_count = :adult_count + (1-:is_child);
    child_count = :child_count + :is_child;

    if (:id_guest = :id_titular) then begin
      update RESERV_DETAIL RD
      set    RD.ID_TITULAR = :id_titular
      where  RD.RDB$DB_KEY = :rd_dbkey_new;

      update GUEST_DATA GD
      set    GD.ID_PERSON_DATA = :id_profile_data
      where  GD.ID_GUEST = :id_titular;
    end
  end

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL_SOURCE, 'RES_SPLIT',
          f_character(29) || :new_res_number || f_character(28) || :adult_count || ' + ' || :child_count);

  -- calling RES_SAVE_PROFILING$INT is unnecessary, it is called into RES_CREATE_SET$INT with same params
  -- here is needed to set reserv accounts per splited guests and reroute posting only (accomplished in next procedure)
  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey_new);

  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_old);
  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_new);

  update RESERV_DETAIL ORD
  set    ord.ROOM_PRICE = null
  where  ord.RDB$DB_KEY = :rd_dbkey_old;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_old, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_new, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  if (:id_room < 0) then begin
    virtual_room = gen_id(GEN_VIRTUAL_ROOM, 1);
    update RESERV_DETAIL RD
    set    rd.VIRTUAL_ROOM = '<'||:virtual_room||'>'
    where  rd.ID_ROOM = :id_room;
  end
end
^

/* Alter (RES_SPLIT_MULTI$RSV) */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
begin
  for
    select RD.ID_RESERV_DETAIL, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :id_reserv_detail, :id_titular
  do begin
    for
      select G.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.ID_GUEST <> :id_titular
      into   :id_guest
    do begin
      execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
      returning_values  :id_splited_reservation;

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ATTACH_PAYMENT$INT for: RES_TAKE_POSTING_RESPONSIBILITY */
ALTER PROCEDURE DOCUMENT_ATTACH_PAYMENT$INT(ID_DOC_HEAD INTEGER,
ID_ACCOUNT_PAYMENT INTEGER,
PAY_CURR_RATE NUMERIC(15,6),
PAY_VALUE NUMERIC(15,4))
 RETURNS(DOC_VALUE NUMERIC(15,4))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_TAKE_POSTING_RESPONSIBILITY) */
ALTER PROCEDURE RES_TAKE_POSTING_RESPONSIBILITY(ID_RESERV_DETAIL ID)
 AS
declare variable is_posting_stopped tboolean;
  declare variable old_posting_transaction_uuid uuid;
  declare variable new_posting_transaction_uuid uuid;
begin
  update RESERV_DETAIL RD
  set    rd.POSTING_TRANSACTION_UUID = iif(rd.POSTING_TRANSACTION_UUID is null, uuid_create(), rd.POSTING_TRANSACTION_UUID)
  where  rd.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  returning old.IS_POSTING_STOPPED, old.POSTING_TRANSACTION_UUID, new.POSTING_TRANSACTION_UUID
  into   :is_posting_stopped, :old_posting_transaction_uuid, :new_posting_transaction_uuid;

  if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION 'Can not get posting responsibility! (is_posting_stopped = 1)';

  if (:new_posting_transaction_uuid is distinct from :old_posting_transaction_uuid) then begin
    -- executing once - on real responsibility taking, when posting_transaction_uuid is generated
    execute procedure RES_PENDING_DEPOSITS_POST$INT (:ID_RESERV_DETAIL);
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_RECALC$INT for: RES_TAR_CALC_FINALIZE$INT */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_TAR_CALC_FINALIZE$INT) */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(TAR_CALC_ERR INTEGER,
ID_TAR_CALC INTEGER,
RD_DBKEY_INIT CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
begin
  --  Razpiswa cenata na staia, kakto i price_detailite.

  if (:tar_calc_err = 0) then begin
    room_price = 0;
    room_price_details = '';

    execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

    for
      select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, rd.IS_POSTING_STOPPED,
             coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
             coalesce(max((select first 1 AP.IS_BASE
                           from   GUEST G
                                  join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                           where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                  and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (eventually)
      from   TAR_CALC_INPUT$TMP TI
             join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
             join TARIFA t on t.ID_TARIFA = rd.ID_RATE
      where  ti.ID_TAR_CALC = :ID_TAR_CALC
      group by 1, 2, 3, 4, 5, 6
      into   :id_reserv_detail, :check_status, :is_posting_stopped,
             :room_currency, :id_hotel, :is_anul, :has_postings
    do begin
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);

      if ( (not (:is_posting_stopped = 1 and :has_postings = 0))                                -- posting is not stopped
           and                                                                                  -- and
           ( (coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1) ) -- there are reasons to repost
         ) then
      begin

        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);

      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;

        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end

      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end else begin

    update RESERV_DETAIL RD
    set    RD.ROOM_PRICE = null,
           RD.ROOM_CURRENCY = null,
           RD.ROOM_PRICE_DETAILS = null,
           RD.LAST_ID_TAR_CALC = null
    where  RD.RDB$DB_KEY = :RD_DBKEY_INIT;
  end
  
  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;
end
^

/* Alter (RESERVS_EXPIRE$INT) */
ALTER PROCEDURE RESERVS_EXPIRE$INT(CLEAR_TODATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable day_keep_number integer;
  declare variable rd_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable nouse integer;
  declare variable day_keep_types integer;
begin
  /*AA NA IONEA I?AAE I?EEE??AAIA -BF END WORK-*/
  execute procedure SETTING_GET_VALUE('DAY_KEEP_NUMBERS', :ID_HOTEL)
  returning_values  :day_keep_number;
  /*************************************************************/
  /*    REMOVE ROOM NUMBERS FROM EXPIRED RESERV DETAILS        */
  /*************************************************************/
  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.IS_ANUL = 0
           and RD.CHECK_STATUS < 0
           and RD.IS_VIP = 0
           and RD.ID_ROOM > 0
           and (RD.FROM_DATE <=  cast(:clear_todate - :day_keep_number as date))
    into   :rd_dbkey, :id_reserv_detail
  do begin
    execute procedure RES_ROOM_REMOVE$INT(:rd_dbkey)
    returning_values  :nouse;

    when any do begin
      -- nothing
    end
  end
  /*************************************************************/
  /*    EXPIRED NON VIP or VIP TYPES                           */
  /*************************************************************/
  execute procedure SETTING_GET_VALUE('DAY_KEEP_TYPES', :ID_HOTEL)
  returning_values  :day_keep_types;

  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.CHECK_STATUS < 0
           and RD.IS_ANUL = 0
           --and RD.EXP_DATE <= :clear_todate
           and RD.FROM_DATE <= cast(:clear_todate - :day_keep_types as date)
           and RD.IS_VIP = 0
    union
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.CHECK_STATUS < 0
           and RD.IS_ANUL = 0
           and RD.TO_DATE < :clear_todate
           and RD.IS_VIP = 1
    into   :rd_dbkey, :id_reserv_detail
  do begin
    execute procedure sys_dbg('res RESERVS_EXPIRE: id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

    execute procedure RES_ANUL_NOSHOW$INT(:rd_dbkey)
    returning_values  :nouse;

    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_NOSHOW', '');

    when any do begin
      -- nothing
    end
  end
end
^

/* Alter (RESMULTI_COMMON_MODIFY$RSV) */
ALTER PROCEDURE RESMULTI_COMMON_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
CHECK_STATUS SMALLINT,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
NOTE VARCHAR(255),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(30),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
NOTE_REMINDERS VARCHAR(50),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(WARN_CODE TYPE OF TRANGE)
 AS
declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable old_id_room_type integer;
  declare variable old_status integer;
begin
  select RD.RDB$DB_KEY, RD.ID_ROOM, RD.ID_ROOM_TYPE, rd.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_id_room, :old_id_room_type, :old_status;

  execute procedure RES_SAVE_GUESTCOUNT$INT(:rd_dbkey, :adult_count, :children_count);

  execute procedure RES_SAVE_NOTE$RSV(:id_reserv_detail, :note, null);

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, :id_room_type, 'nrttAsIs')
  returning_values (:WARN_CODE);

  execute procedure RES_SAVE_ROOM_LOG$INT(:rd_dbkey, :old_id_room, :old_id_room_type);

  execute procedure RES_SAVE_ACCOUNTING$INT(:rd_dbkey, :id_agent_profile, :id_agent_account, :acc_routing,
                    :id_person_payment, :id_agent_payment, :id_group);

  update RESERV_DETAIL RD
  set    RD.CUSTOM_PRICE = :CUSTOM_PRICE,
         RD.CUSTOM_CURRENCY = :CUSTOM_CURRENCY,
         RD.SPLIT_ON_CHECKIN = :SPLIT_ON_CHECKIN,
         RD.NOTE_REMINDERS = :NOTE_REMINDERS,
         rd.ID_HK_PLAN = :ID_HK_PLAN
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_status <> :CHECK_STATUS) then begin
    if (:CHECK_STATUS >= 0) then exception BOOKING_EXCEPTION 'Can not set status ''CHECKED IN'' or ''CHECKED OUT'' manually!';
  
    execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, :check_status);
  end
  --
end
^

/* Alter (RESMULTI_CREATE$RSV) */
ALTER PROCEDURE RESMULTI_CREATE$RSV(ID_HOTEL INTEGER,
ID_ROOM_TYPE INTEGER,
TRANSFER_OUT_TIME TIME,
TRANSFER_IN_TIME TIME,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
TRANSFER_OUT_NOTE VARCHAR(50),
TRANSFER_IN_NOTE VARCHAR(50),
NOTE VARCHAR(255),
ID_BOARD INTEGER,
VOUCHER_DATE DATE,
VOUCHER_NUMBER VARCHAR(20),
VOUCHER_TEXT VARCHAR(30),
CHECK_STATUS INTEGER,
ID_TARIFF INTEGER,
COUNTRY_CODE VARCHAR(20),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
NOTE_REMINDERS VARCHAR(50),
TITULAR_NAME VARCHAR(100),
SPLIT_ON_CHECKIN INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
NUMBER VARCHAR(62),
NEW_ID_TITULAR INTEGER,
NEW_FROM_DATE TYPE OF TDATE,
WARN_CODE TYPE OF TRANGE)
 AS
declare variable rd_dbkey char(8);
  declare variable id_person_profile integer;
  declare variable pd_dbkey char(8);
  declare variable id_acc_template_person integer;
  declare variable first_name varchar(30);
  declare variable surname varchar(30);
  declare variable family_name varchar(30);
begin

  select sv.SETTING_VALUE
  from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :ID_HOTEL) sv
  into   :id_acc_template_person;

  execute procedure RES_CREATE_SET$INT(:id_agent_profile, null, :check_status, :arrival_date, :departure_date,
                    :adult_count, :children_count, :id_room_type, null, :id_board, :id_tariff, null,
                    null, null, :voucher_number, :voucher_date, :voucher_text, '',
                    null, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    1, 0, 0, :country_code, :code_first_food, '',
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    '', :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders, null, null,
                    :split_on_checkin, null, null, :id_acc_template_person, null, null, :ID_EATING_OBJECT)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :WARN_CODE;

  select RD.NUMBER, RD.ID_PERSON_PROFILE, RD.ID_TITULAR
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :number, :id_person_profile, :new_id_titular;

  if (:titular_name <> '') then begin
    select PD.RDB$DB_KEY
    from   PROFILE P
           join PROFILE_PERSON PP on PP.ID_PROFILE = P.ID_PROFILE
           join PERSON_DATA PD on PD.ID_PERSON_DATA = PP.ID_PERSON_DATA
    where  P.ID_PROFILE = :id_person_profile
    into   :pd_dbkey;

    select PP.FIRST_NAME, PP.SURNAME, PP.FAMILY_NAME
    from   PERSON_NAME_PARSE$INT (:TITULAR_NAME) PP
    into   :first_name, :surname, :family_name;

    update PERSON_DATA PD
    set    PD.PERSON_NAME2 = :titular_name,
           PD.FIRST_NAME = :first_name,
           PD.SURNAME = :surname,
           PD.FAMILY_NAME = :family_name
    where  PD.RDB$DB_KEY = :pd_dbkey;
  end

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;
end
^

/* Alter (RESMULTI_FINALIZE$RSV) */
ALTER PROCEDURE RESMULTI_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER,
DISABLE_WARNING SMALLINT)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  /*savedbg('------------ RES DET: ' || :ID_RESERV_DETAIL);
  savedbg('err_code: ' || :ERR_CODE);
  savedbg('share_err_code: ' || :SHARE_ERR_CODE);
  savedbg('warn_code: ' || :WARN_CODE);*/
  if (:disable_warning = 1) then warn_code = 0;
end
^

/* Alter (RESMULTI_STAY_MODIFY$RSV) */
ALTER PROCEDURE RESMULTI_STAY_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 AS
declare variable rd_dbkey char(8);
  declare variable is_late_departure integer;
  declare variable comming_kind integer;
begin

  select RD.RDB$DB_KEY, RD.COMMING_KIND, RD.LEAVING_KIND - 1
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :comming_kind, :is_late_departure;

  execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :departure_date, :is_late_departure, :comming_kind);
end
^

/* empty dependent procedure body */
/* Clear: REVENUE_STATISTIC_REBUILD for: REVENUE_EW_SUMMARIZE$INT */
ALTER PROCEDURE REVENUE_STATISTIC_REBUILD(ID_HOTEL INTEGER,
TO_DATE DATE = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: REVENUE_STATISTIC_REMAKE$SYS for: REVENUE_EW_SUMMARIZE$INT */
ALTER PROCEDURE REVENUE_STATISTIC_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: REVENUE_SUMMARY_REMAKE$SYS for: REVENUE_EW_SUMMARIZE$INT */
ALTER PROCEDURE REVENUE_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
STATISTIC_ONLY SMALLINT)
 AS
 BEGIN EXIT; END
^

/* Alter (REVENUE_EW_SUMMARIZE$INT) */
ALTER PROCEDURE REVENUE_EW_SUMMARIZE$INT(ID_END_WORK INTEGER,
SUMMARY_OPTION VARCHAR(20) = 'full')
 AS
declare variable id_sale_taxation integer;
  declare variable id_profile integer;
  declare variable market_segment varchar(3);
  declare variable source_code varchar(3);
  declare variable channel_code varchar(3);
  declare variable hear_reason varchar(3);
  declare variable come_reason varchar(3) ;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable revenue_account varchar(50);
  declare variable revenue_sub_account varchar(50);
  declare variable revenue_group varchar(50);
  declare variable service_name varchar(80);
  declare variable rev_amount numeric(15,4);
  declare variable corr_amount numeric(15,4);
  declare variable total_rev_amount numeric(15,4);
  declare variable total_corr_amount numeric(15,4);
  declare variable total_vat_amount numeric(15,4);
  declare variable vat_amount numeric(15,4);
  declare variable country_code varchar(10);
  declare variable no_use varchar(255);
  declare variable id_summary_rev_group integer;
  declare variable is_primary_post integer;
  declare variable posts_cnt integer;
  declare variable id_hotel integer;
  declare variable id_room_type integer;
  declare variable ew_date date;
  declare variable round_to numeric(15,6);
  declare variable id_sale_tax integer;
  declare variable tax_value numeric(15,4);
  declare variable revenue_deduction_tax_value tprice;
begin
  /****************************************************************************/
  /*  Description:                                                            */
  /*  DATE_POST      occurence date                                           */
  /*  ARISE_DATE     noticed date                                             */
  /*  POST_TYPE      BASE, ADD_INS, EXTRA                                     */
  /****************************************************************************/
  /*  */
  TOTAL_REV_AMOUNT = 0;
  TOTAL_CORR_AMOUNT = 0;
  TOTAL_VAT_AMOUNT = 0;
  select EW.PREV_DATE, EW.ID_HOTEL, CU.ROUND_TO
  from   END_WORKS EW
         join HOTEL H on H.ID_HOTEL = EW.ID_HOTEL
         join CURRS CU on CU.CURR = H.NATION_CURR
  where  EW.ID_END_WORK = :ID_END_WORK
  into   :EW_DATE, :ID_HOTEL, :ROUND_TO;

  if (:SUMMARY_OPTION = 'full') then begin
    delete from SUMMARY_REV_GROUPS$REV SR
    where  SR.ID_END_WORK = :ID_END_WORK;

  end else if (:SUMMARY_OPTION = 'statistic') then begin
    /* delete from statistic tables */
    for
      select SR.ID_SUMMARY_REV_GROUP
      from   SUMMARY_REV_GROUPS$REV SR
      where  SR.ID_END_WORK = :ID_END_WORK
      into   :ID_SUMMARY_REV_GROUP
    do begin
      delete from SUMMARY_MARKET_SEGMENTS$REV SM
      where  SM.ID_SUMMARY_REV_GROUP = :ID_SUMMARY_REV_GROUP;

      delete from SUMMARY_PROFILES$REV SP
      where  SP.ID_SUMMARY_REVENUE_GROUP = :ID_SUMMARY_REV_GROUP;

      delete from SUMMARY_NATIONALITY$REV SN
      where  SN.ID_SUMMARY_REVENUE_GROUP = :ID_SUMMARY_REV_GROUP;
    end
  end

  for
    select  AP.ID_SALE_TAXATION, coalesce(PA.ID_PROFILE, PH.ID_PROFILE), coalesce(PD.COUNTRY_CODE, ''),
            MS.MARKET_CODE, SC.SOURCE_CODE, CC.CHANNEL_CODE, HR.HEAR_REASON_CODE, CR.COME_REASON_CODE,
            AP.REVENUE_GROUP, AP.REVENUE_ACCOUNT, AP.REVENUE_SUB_ACCOUNT, S.SERVICE_NAME || coalesce(' / ' || APO.DESCRIPTION, '') as SERVICE_NAME,
            AP.IS_PRIMARY_POST, coalesce(rm.ID_ROOM_TYPE, r.ID_ROOM_TYPE),
            coalesce(sum(AP.NAT_NET_VALUE), 0), coalesce(sum(AP.NAT_GROSS_VALUE), 0), coalesce(sum(ap.REVENUE_DEDUCTION_TAX_VALUE), 0)
    from    ACCOUNT_DEBT AP
            join SERVICES S on S.ID_SERVICE = AP.ID_SERVICE
            left outer join ACCOUNT_POST APO on APO.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
            left outer join ACCOUNT ACC on ACC.ID_ACCOUNT = AP.ID_ACCOUNT
            left outer join GUEST G on G.ID_GUEST = AP.ID_GUEST
            left outer join GUEST_DATA GD on G.ID_GUEST = GD.ID_GUEST
            left outer join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = coalesce(G.ID_RESERV_DETAIL, ACC.ID_RESERV_DETAIL)
            left outer join NOM_CHANNEL_CODES CC on CC.ID_NOM_CHANNEL_CODE = GD.ID_NOM_CHANNEL_CODE--RD.ID_NOM_CHANNEL_CODE
            left outer join NOM_COME_REASONS CR on CR.ID_NOM_COME_REASON = GD.ID_NOM_COME_REASON--RD.ID_NOM_COME_REASON
            left outer join NOM_HEAR_REASONS HR on HR.ID_NOM_HEAR_REASON = GD.ID_NOM_HEAR_REASON--RD.ID_NOM_HEAR_REASON
            left outer join NOM_SOURCE_CODES SC on SC.ID_NOM_SOURCE_CODE = GD.ID_NOM_SOURCE_CODE--RD.ID_NOM_SOURCE_CODE
            left outer join NOM_MARKET_SEGMENTS MS on MS.ID_NOM_MARKET_SEGMENT = GD.ID_NOM_MARKET_SEGMENT--RD.ID_NOM_MARKET_SEGMENT
            left outer join PROFILE_AGENT PA on PA.ID_PROFILE = iif(rd.ID_RESERV_DETAIL is not null, RD.ID_AGENT_PROFILE, ACC.ID_PROFILE) --coalesce(RD.ID_AGENT_PROFILE, A.ID_PROFILE)
            left outer join PROFILE_PERSON PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
            left outer join PERSON_DATA PD on PD.ID_PERSON_DATA = PP.ID_PERSON_DATA
            left outer join PROFILE_HOUSE PH on PH.ID_PROFILE = ACC.ID_PROFILE
            left outer join ROOMS R on rd.ID_ROOM = r.ID_ROOM
            left outer join ROOM_MAGIC RM on RM.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                             and rm.BUSY_DATE = ap.POST_DATE
    where   AP.ID_HOTEL = :id_hotel
            and AP.DEBT_DATE = :ew_date
    group by 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14 --, 15
    into   :id_sale_taxation, :id_profile, :country_code,
           :market_segment, :source_code, :channel_code, :hear_reason, :come_reason,
           :revenue_group, :revenue_account, :revenue_sub_account, :service_name,
           :is_primary_post, :id_room_type, :post_net_value, :post_gross_value, :revenue_deduction_tax_value
  do begin
    POSTS_CNT = 0; /* TODO - must be initialized!!!! */
    if (:SUMMARY_OPTION = 'full') then begin
      VAT_AMOUNT = :POST_GROSS_VALUE - :POST_NET_VALUE;
      execute procedure REVENUE_SUMMARY_MODIFY$INT (:id_end_work, :ew_date, :id_sale_taxation,
              :id_profile, :market_segment, :source_code, :channel_code, :hear_reason, :come_reason,
              :is_primary_post, :post_net_value, :vat_amount, :revenue_group, :revenue_account,
              :revenue_sub_account, :service_name, :country_code, :id_room_type,
              :revenue_deduction_tax_value, :posts_cnt)
      returning_values (:rev_amount, :corr_amount, :id_summary_rev_group, :no_use, :no_use, :no_use, :no_use, :no_use, :no_use);

      total_rev_amount = :total_rev_amount + :rev_amount;
      total_corr_amount = :total_corr_amount + :corr_amount;
      total_vat_amount = :total_vat_amount + :vat_amount;

    end else if (:SUMMARY_OPTION = 'statistic') then begin

      select first 1 RG.ID_SUMMARY_REV_GROUP
      from   SUMMARY_REV_GROUPS$REV RG
      where  RG.ID_END_WORK = :ID_END_WORK
             and RG.ID_SALE_TAXATION = :id_sale_taxation
             and RG.REVENUE_GROUP is not distinct from :REVENUE_GROUP
      into   :ID_SUMMARY_REV_GROUP;

      VAT_AMOUNT = :POST_GROSS_VALUE - :POST_NET_VALUE;
      execute procedure REVENUE_STATISTIC_UPDATE$INT (:id_summary_rev_group, :is_primary_post, :id_profile,
              :market_segment, :source_code, :channel_code, :hear_reason, :come_reason,
              :post_net_value, :vat_amount, :country_code, :id_room_type, :ew_date, :revenue_deduction_tax_value)
      returning_values (:no_use, :no_use, :no_use, :no_use, :no_use, :no_use);
    end
  end
  
  if (:SUMMARY_OPTION = 'full') then begin
    for
      select  AP.ID_SALE_TAXATION, AP.REVENUE_GROUP, TVD.ID_SALE_TAX, sum(TVD.TAX_VALUE)
      from    ACCOUNT_DEBT AP
              join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
              left outer join TAX_VALUE_DEDUCT(AP.NAT_GROSS_VALUE, :round_to, AP.ID_SALE_TAXATION, 1) TVD on 1=1
      where   A.ID_HOTEL = :id_hotel
              and AP.DEBT_DATE = :ew_date
      group by 1, 2, 3
      into    :id_sale_taxation, :revenue_group, :id_sale_tax, :tax_value
    do begin
      select SRG.ID_SUMMARY_REV_GROUP
      from   SUMMARY_REV_GROUPS$REV SRG
      where  SRG.ID_END_WORK = :id_end_work
             and SRG.REVENUE_GROUP = :revenue_group
             and SRG.ID_SALE_TAXATION = :id_sale_taxation
      into   :id_summary_rev_group;

      insert into SUMMARY_TAXES(ID_SUMMARY_REV_GROUP, ID_SALE_TAXES, VAT_AMOUNT)
      values (:id_summary_rev_group, :id_sale_tax, :tax_value);
    end

    update SUMMARY_END_WORK SE
    set    SE.REVENUE_AMOUNT = :TOTAL_REV_AMOUNT,
           SE.CORRECTION_AMOUNT = :TOTAL_CORR_AMOUNT,
           SE.VAT_AMOUNT = :TOTAL_VAT_AMOUNT
    where  SE.ID_END_WORK = :ID_END_WORK;
  end
end
^

/* Alter (REVENUE_STATISTIC_REBUILD) */
ALTER PROCEDURE REVENUE_STATISTIC_REBUILD(ID_HOTEL INTEGER,
TO_DATE DATE = null)
 AS
declare variable id_end_work integer;
  declare variable summary_date date;
begin
  if (:TO_DATE is null) then begin
    execute procedure SYSTEM_DATE_GET (:ID_HOTEL)
    returning_values :TO_DATE;
    TO_DATE = :TO_DATE - 1;
  end

  for
    select cast(d.FROM_TIMESTAMP as date)
    from   REVENUE_STATISTIC_REBUILD_DATES (:id_hotel, :to_date) SP
           left outer join SYSTEM_DIVIDE_PERIOD (SP.OUT_FROM_DATE, sp.OUT_TO_DATE, 'date') d on 1=1
    into   :summary_date
  do begin
    if (:summary_date is null) then exit;

    for
      select EW.ID_END_WORK
      from   END_WORKS EW
      where  EW.PREV_DATE = :summary_date
             and EW.NEXT_DATE > :summary_date
             and EW.END_WORK_KIND = '3'
             and EW.ID_HOTEL = :id_hotel
      into   :id_end_work
    do begin
      execute procedure REVENUE_EW_SUMMARIZE$INT (:id_end_work, 'statistic');
    end
  end 

  delete from RESERV_CHANGE_SP; -- delete save points after summary update;

end
^

/* Alter (REVENUE_STATISTIC_REMAKE$SYS) */
ALTER PROCEDURE REVENUE_STATISTIC_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
declare variable id_end_work integer;
begin
  if (not exists (select h.ID_HOTEL
                  from   HOTEL H
                  where  h.ID_HOTEL = :ID_HOTEL)) then exception WRONG_VALUE 'Non-existing hotel!';

  for
    select EW.ID_END_WORK
    from   SUMMARY_END_WORK EW
    where  ew.ID_HOTEL = :ID_HOTEL
           and ew.SUMMARY_DATE between :FROM_DATE and :TO_DATE
    order by ew.ID_END_WORK
    into   :id_end_work
  do begin
    execute procedure REVENUE_EW_SUMMARIZE$INT (:id_end_work, 'statistic');
  end

end
^

/* Alter (REVENUE_SUMMARY_REMAKE$SYS) */
ALTER PROCEDURE REVENUE_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
STATISTIC_ONLY SMALLINT)
 AS
declare variable id_end_work integer;
declare variable ad_dbkey char(8);
declare variable id_service integer;
declare variable id_guest integer;
declare variable id_account integer;
declare variable revenue_group varchar(50);
declare variable revenue_account varchar(50);
declare variable revenue_sub_account varchar(50);
begin
  if (not exists (select h.ID_HOTEL
                  from   HOTEL H
                  where  h.ID_HOTEL = :ID_HOTEL)) then exception WRONG_VALUE 'Non-existing hotel!';

  if (:STATISTIC_ONLY = 1) then begin

    execute procedure REVENUE_STATISTIC_REMAKE$SYS (:ID_HOTEL, :FROM_DATE, :TO_DATE);

    execute procedure SYSTEM_LOG_ADD ('HOTEL', :id_hotel, 'REV_REGEN_PART',
                                      f_character(29) || formatdate(:from_date, 'D;dd/mm/yyyy') ||
                                      f_character(28) || formatdate(:to_date, 'D;dd/mm/yyyy'));
  end else begin
    for
      select ad.RDB$DB_KEY, ad.ID_SERVICE, ad.ID_GUEST, ad.ID_ACCOUNT
      from   ACCOUNT_DEBT AD
      where  AD.ID_HOTEL = :id_hotel
             and ad.DEBT_DATE between :FROM_DATE and :TO_DATE
      order by ad.DEBT_DATE asc, ad.ID_ACCOUNT_POST asc
      into   :ad_dbkey, :id_service, :id_guest, :id_account
    do begin
      select  S.REVENUE_GROUP, RA.REVENUE_ACCOUNT, RA.REVENUE_SUB_ACCOUNT
      from    ACCOUNT A
              left outer join SERVICES S on s.ID_SERVICE = :id_service
              left outer join GUEST G on G.ID_GUEST = :id_guest
              left outer join PROFILE_HOUSE PH on PH.ID_PROFILE = A.ID_PROFILE
              left outer join REVENUE_ACCOUNT_PARSE$INT (S.REVENUE_ACCOUNT, coalesce(G.ID_RESERV_DETAIL, A.ID_RESERV_DETAIL)) RA on 1=1
      where   a.ID_ACCOUNT = :id_account
              and PH.HOUSE_TYPE is distinct from 'hptComplimentary'
      into    :revenue_group, :revenue_account, :revenue_sub_account;
  
      update ACCOUNT_DEBT d
      set    d.REVENUE_GROUP = :revenue_group,
             d.REVENUE_ACCOUNT = :revenue_account,
             d.REVENUE_SUB_ACCOUNT = :revenue_sub_account
             -- TODO - revenue deduction tax recalc ???
      where  d.RDB$DB_KEY = :ad_dbkey;
    end
  
  
    for
      select se.ID_END_WORK
      from   SUMMARY_END_WORK SE
      where  se.ID_HOTEL = :ID_HOTEL
             and se.SUMMARY_DATE between :FROM_DATE and :TO_DATE
      order by se.ID_END_WORK
      into   :id_end_work
    do begin
  
      update SUMMARY_END_WORK s
      set    s.REVENUE_AMOUNT = 0,
             s.CORRECTION_AMOUNT = 0,
             s.VAT_AMOUNT = 0
      where  s.ID_END_WORK = :id_end_work;
  
      execute procedure REVENUE_EW_SUMMARIZE$INT (:id_end_work, 'full');
    end

    execute procedure SYSTEM_LOG_ADD ('HOTEL', :id_hotel, 'REV_REGEN_FULL',
                                      f_character(29) || formatdate(:from_date, 'D;dd/mm/yyyy') || f_character(28) ||
                                      formatdate(:to_date, 'D;dd/mm/yyyy'));
  end
end
^

/* Alter (ROOM_CONTRACT_MODIFY$PMS) */
ALTER PROCEDURE ROOM_CONTRACT_MODIFY$PMS(ID_ROOM_CONTRACT INTEGER,
ID_ROOM_PERIOD INTEGER,
CONTRACT_TYPE VARCHAR(50),
PMS_MARKERS BLOB SUB_TYPE 1 SEGMENT SIZE 100,
IMPORT_INCOME_WITH_VAT SMALLINT,
ID_RENTAL_POOL INTEGER,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_CONTRACT INTEGER)
 AS
declare variable permissible_value_list varchar(255);
  declare variable from_date date;
  declare variable rental_pool_unit_name varchar(100);
  declare variable room_name varchar(10);
  declare variable old_contract_type varchar(50);
  declare variable old_import_income_with_vat smallint;
  declare variable old_from_date date;
  declare variable old_rental_pool_unit_name varchar(100);
  declare variable old_room_name varchar(10);
  declare variable old_id_room_period integer;
  declare variable id_room integer;
  declare variable action_text varchar(255);
  declare variable no_use varchar(255);
begin

  permissible_value_list = '';
  select list(trim(S.KEY_))
  from   SYSTEM_ENUM S
  where  S.GROUP_ = 'pms.contract_type'
  into   :permissible_value_list;

  if (:operation in ('add', 'mod')) then begin
    execute procedure SYSTEM_CHECK_OPERATION(:contract_type, :permissible_value_list, 'contract type');

    select PRO.PROFILE_NAME
    from   PROFILE PRO
    where  PRO.ID_PROFILE = :ID_RENTAL_POOL
    into   :rental_pool_unit_name;

    select ROO.ROOM_NAME, RPP.FROM_DATE
    from   ROOM_PERIOD$PMS RPP
           join ROOMS ROO on ROO.ID_ROOM = RPP.ID_ROOM
    where  RPP.ID_ROOM_PERIOD = :ID_ROOM_PERIOD
    into   :room_name, :from_date;
  end

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');
  NEW_ID_ROOM_CONTRACT = :id_room_contract;

  if (:operation = 'add') then begin
    if (coalesce(:ID_ROOM_CONTRACT, -1) < 0) then begin
      NEW_ID_ROOM_CONTRACT = gen_id(GEN_ROOM_CONTRACT$PMS_ID, 1);
      ID_ROOM_CONTRACT = :NEW_ID_ROOM_CONTRACT;
    end
    else
      NEW_ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT;

    insert into ROOM_CONTRACT$PMS (ID_ROOM_CONTRACT, ID_ROOM_PERIOD,
           CONTRACT_TYPE, PMS_MARKERS, IMPORT_INCOME_WITH_VAT, ID_RENTAL_POOL)
    values (:NEW_ID_ROOM_CONTRACT, :ID_ROOM_PERIOD,
           :CONTRACT_TYPE, :PMS_MARKERS, :IMPORT_INCOME_WITH_VAT, :ID_RENTAL_POOL);

    action_text = substring(f_character(29) || '@{pms.contract_type.' || :contract_type || '}' || f_character(28) ||
                  formatdate(:from_date, 'D;dd.mm.yyyy') ||
                  f_character(28) || :room_name || f_character(28) || coalesce(:rental_pool_unit_name, ' ') || f_character(28)
                  || coalesce(:import_income_with_vat, 0) from 1 for 255);
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_ADDED', :ACTION_TEXT);

  end else begin
    select RC.CONTRACT_TYPE, RC.IMPORT_INCOME_WITH_VAT,
           RO.ROOM_NAME, PR.PROFILE_NAME, RP.FROM_DATE, RC.ID_ROOM_PERIOD, RP.ID_ROOM
    from   ROOM_CONTRACT$PMS RC
           join ROOM_PERIOD$PMS RP on RP.ID_ROOM_PERIOD = RC.ID_ROOM_PERIOD
           join ROOMS RO on RO.ID_ROOM = RP.ID_ROOM
           left outer join PROFILE PR on PR.ID_PROFILE = RC.ID_RENTAL_POOL
    where  RC.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
    into   :old_contract_type, :old_import_income_with_vat,
           :old_room_name, :old_rental_pool_unit_name, :old_from_date, :old_id_room_period, :id_room;

    if (:operation = 'mod') then begin
      update ROOM_CONTRACT$PMS
      set    CONTRACT_TYPE = :CONTRACT_TYPE,
             PMS_MARKERS = :PMS_MARKERS,
             IMPORT_INCOME_WITH_VAT = :IMPORT_INCOME_WITH_VAT,
             ID_RENTAL_POOL = :ID_RENTAL_POOL
      where (ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT);

      if ((:contract_type <> :old_contract_type) or (:import_income_with_vat <> :old_import_income_with_vat) or
         (coalesce(:rental_pool_unit_name, ' ') <> coalesce(:old_rental_pool_unit_name, ' ')) or
         (:from_date <> :old_from_date) or (:room_name <> :old_room_name)) then begin
        action_text = substring(f_character(29) || '@{pms.contract_type.' || :old_contract_type || '}' || f_character(28) ||
                      formatdate(:old_from_date, 'D;dd.mm.yyyy') ||
                      f_character(28) || :old_room_name ||
                      f_character(28) || coalesce(:old_rental_pool_unit_name, ' ') || f_character(28) || coalesce(:old_import_income_with_vat, 0) ||
                      f_character(28) || '@{pms.contract_type.' || :contract_type || '}' || f_character(28) || formatdate(:from_date, 'D;dd.mm.yyyy') ||
                      f_character(28) || :room_name || f_character(28) || coalesce(:rental_pool_unit_name, ' ') || f_character(28)
                      || coalesce(:import_income_with_vat, 0) from 1 for 255);
        execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_CHANGED', :ACTION_TEXT);
      end

    end

    if (:operation = 'del') then begin
      action_text = substring(f_character(29) || '@{pms.contract_type.' || :old_contract_type || '}' || f_character(28) ||
                    formatdate(:old_from_date, 'D;dd.mm.yyyy') ||
                    f_character(28) || :old_room_name || f_character(28) || coalesce(:old_rental_pool_unit_name, ' ') || f_character(28)
                    || coalesce(:old_import_income_with_vat, 0) from 1 for 255);
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_REMOVED', :ACTION_TEXT);

      delete from ROOM_CONTRACT$PMS where (ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT);

      execute procedure ROOM_PERIOD_MODIFY$PMS (:OLD_ID_ROOM_PERIOD, :id_room,  :old_from_date,
              iif(:contract_type in ('PRIVATE_USE'), 'PRIVATE', 'CONTRACT'),  'del')
      returning_values :no_use;
    end
  end
end
^

/* Alter (ROOM_MODIFY$PMS) */
ALTER PROCEDURE ROOM_MODIFY$PMS(ID_ROOM INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
BEDS INTEGER,
EXTRA_BEDS INTEGER,
SECTOR INTEGER,
SORT_ORDER INTEGER,
FEATURES BLOB SUB_TYPE 1 SEGMENT SIZE 100,
EXTERNAL_NAME VARCHAR(10),
ID_EATING_OBJECT TYPE OF ID_REF,
OPERATION VARCHAR(20))
 RETURNS(OVERRULE_NEED SMALLINT,
OVERRULE_CONTEXT VARCHAR(255),
NEW_ID_ROOM INTEGER)
 AS
declare variable old_id_room_type integer;
  declare variable old_room_name varchar(10);
  declare variable rebuild_id_hotel integer;
  declare variable rebuild_id_room_type integer;
  declare variable guests_max integer;
  declare variable no_use varchar(20);
  declare variable old_capacity integer;
  declare variable busy_group_type integer;
  declare variable sys_date date;
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable action_text varchar(255);
  declare variable old_floor integer;
  declare variable old_sector integer;
  declare variable old_extra_beds integer;
  declare variable id_hotel integer;
begin
  overrule_need = 0;
  overrule_context = '';
  new_id_room = null;
  --if OVERRULE_NEED = 1 then OVERRULE_CONTEXT = ERR_TEXT like ERR_CODE = -9
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    if (coalesce(:room_name, '') = '') then
      exception ASSERT '-119';

    if ((:room_name containing '<') or (:room_name containing '>') or (:room_name starting with 'i')) then
      exception ASSERT '-120';
  end

  room_name = upper(:room_name);

  if (:operation='mod') then begin
    select R.ROOM_NAME, R.ID_ROOM_TYPE, R.BEDS+R.EXTRA_BEDS, r.floor, r.sector, r.extra_beds
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :id_room
    into   :old_room_name, :old_id_room_type, :old_capacity, :old_floor, :old_sector, :old_extra_beds;

    if (:id_room_type <> :old_id_room_type) then begin
      exception OCCUPANCY_EXCEPTION '-65';
    end

    new_id_room = :id_room;
    guests_max = 0;
    if (:old_capacity > (:beds + :extra_beds)) then begin
      select first 1 sum(RM.ADULT_COUNT+RM.CHILDREN_COUNT), max(rm.BUSY_GROUP_TYPE)
      from   ROOM_MAGIC RM
             join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = RM.ID_RESERV_DETAIL
      where  RM.ID_ROOM = :id_room
             and RD.CHECK_STATUS in (-3, -2, -1, 0)
      group by RM.BUSY_DATE
      order by 1 desc
      into   :guests_max, :busy_group_type;
    end
    if ((:beds + :extra_beds) < :guests_max) then begin
      err_code = -8;
      err_text = f_character(29)||:ROOM_NAME||f_character(28)||:guests_max||f_character(28)||(:beds + :extra_beds);
      if (:busy_group_type in (1)) then begin
        overrule_need = :err_code;
        overrule_context = :err_text;
        err_code = 0;
        err_text = '';
      end else begin
        exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      end
    end

    update ROOMS RU
    set    RU.ID_ROOM_TYPE = :id_room_type,
           RU.ROOM_NAME = :room_name,
           RU.FLOOR = :floor,
           RU.BEDS = :beds,
           RU.EXTRA_BEDS = :extra_beds,
           RU.SECTOR = :sector,
           RU.FEATURES = :features,
           RU.SORT_ORDER = :sort_order,
           --RU.ID_HOTEL = :rebuild_id_hotel,
           RU.EXTERNAL_NAME = :external_name,
           RU.ID_EATING_OBJECT = :ID_EATING_OBJECT
    where  RU.ID_ROOM = :id_room;

    if ((:room_name <> :old_room_name)
        or (:floor <> :old_floor)
        or (:sector <> :old_sector)
        or (:extra_beds <> :old_extra_beds)) then
    begin
      action_text = f_character(29) || '(' || :old_room_name || '/' || :old_floor || '/' || :old_sector || '/'
                    || :old_extra_beds || ')' || f_character(28) || '(' || :room_name || '/' || :floor || '/'
                    || :sector || '/' || :extra_beds || ')';
      execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_PARAMS_CHANGED', :action_text);
    end

    if (:room_name <> :old_room_name) then begin
      update ACCOUNT_POST AP
      set    AP.ROOM_NAME = :room_name
      where  AP.ROOM_NAME = :old_room_name;
    end

  end else if (:operation = 'add') then begin
    select rt.ID_HOTEL
    from   ROOM_TYPES RT
    where  rt.ID_ROOM_TYPE = :ID_ROOM_TYPE
    into   :id_hotel;

    insert into ROOMS (
      ID_ROOM, ID_ROOM_TYPE, ROOM_NAME, FLOOR, BEDS, EXTRA_BEDS, SECTOR,
      FEATURES, SORT_ORDER, ID_HOTEL, EXTERNAL_NAME, ID_EATING_OBJECT)
    values (gen_id(ID_ROOM_GEN, 1), :id_room_type, :room_name, :floor, :beds, :extra_beds, :sector,
      :features, :sort_order, :id_hotel, :external_name, :ID_EATING_OBJECT)
    returning ID_ROOM into :NEW_ID_ROOM;

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :sys_date;

    execute procedure ROOM_PERIOD_MODIFY$PMS(null, :new_id_room, :sys_date, 'HOTEL', 'add')
    returning_values  :no_use;

    insert into ROOMS_ADD (ID_ROOM, PMS_MARKERS, ADDRESS)
    values (:new_id_room, null, null);
  end else if (:operation = 'del') then begin
    -- Booked rooms are preserved with FK constraint on room_magic
    execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'DELETE', '');

    select RT.ID_ROOM_TYPE, RT.ID_HOTEL
    from   ROOM_TYPES RT
    where  RT.ID_ROOM_TYPE = :id_room_type
    into   :rebuild_id_room_type, :rebuild_id_hotel;

    delete from ROOMS where ID_ROOM = :id_room;

    execute procedure ALLOTMENT_PHYS_REBUILD$INT(:rebuild_id_hotel, :rebuild_id_room_type);

    when sqlcode -530 do begin
      -- Violation of FOREIGN KEY constraint "%s" on table "%s"
      exception ASSERT '-34';
    end
  end
end
^

/* Alter (ROOM_OWNER_MODIFY$PMS) */
ALTER PROCEDURE ROOM_OWNER_MODIFY$PMS(ID_ROOM_OWNER INTEGER,
ID_ROOM_CONTRACT INTEGER,
ID_OWNER INTEGER,
OWNERSHIP_PERCENT NUMERIC(15,4),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_OWNER INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_hotel integer;
  declare variable id_acc_template_pms integer;
  declare variable id_currency varchar(3);
  declare variable owner_name varchar(100);
  declare variable old_owner_name varchar(100);
  declare variable old_ownership_percent NUMERIC(15,4);
  declare variable old_id_room_contract integer;
  declare variable action_text varchar(255);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');
  new_id_room_owner = :id_room_owner;

  if ( (:operation in ('add', 'mod')) and (not exists ( select * from OWNER$PMS P where P.ID_OWNER = :ID_OWNER ) )) then begin
    exception PMS_EXCEPTION '-610';
    exit;
  end

  select RT.ID_HOTEL
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS RP on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
         join ROOMS R on RP.ID_ROOM = R.ID_ROOM
         join ROOM_TYPES RT on R.ID_ROOM_TYPE = RT.ID_ROOM_TYPE
  where  RC.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
  into   :id_hotel;

  if (:operation not in ('add')) then begin
    select coalesce(PR.PROFILE_NAME, ' '), RO.OWNERSHIP_PERCENT, RO.ID_ROOM_CONTRACT
    from ROOM_OWNER$PMS RO
      left outer join PROFILE PR ON PR.ID_PROFILE = RO.ID_OWNER
    where RO.ID_ROOM_OWNER = :ID_ROOM_OWNER
    into :old_owner_name, :old_ownership_percent, :old_id_room_contract;
  end

  select PRO.PROFILE_NAME
  from PROFILE PRO
    where PRO.ID_PROFILE = :ID_OWNER
  into :owner_name;

  if (:operation in ('add', 'mod')) then begin
    if (coalesce(:OWNERSHIP_PERCENT, 0) <= 0) then begin
      exception PMS_EXCEPTION '-611';
      exit;
    end
  end

  if (:operation = 'add') then begin
    if (coalesce(:ID_ROOM_OWNER, -1) < 0) then
         NEW_ID_ROOM_OWNER = gen_id(GEN_ROOM_OWNER$PMS_ID, 1);
    else NEW_ID_ROOM_OWNER = :ID_ROOM_OWNER;

    insert into ROOM_OWNER$PMS (ID_ROOM_OWNER, ID_ROOM_CONTRACT, ID_OWNER, OWNERSHIP_PERCENT)
    values (:NEW_ID_ROOM_OWNER, :ID_ROOM_CONTRACT, :ID_OWNER, :OWNERSHIP_PERCENT);

    action_text = f_character(29) || :owner_name || f_character(28) || formatfloat(:ownership_percent, '0.00');
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_OWNER_ADDED', :ACTION_TEXT);

    if (not exists ( select *
                     from   ACCOUNT A
                     where  A.IS_PMS_ACCOUNT = 1
                            and A.ID_HOTEL = :id_hotel
                            and A.ID_PROFILE = :ID_OWNER ))
    then begin
      select O.ID_ACC_TEMPLATE_PMS, O.ID_CURRENCY
      from   OWNER$PMS O
      where  O.ID_OWNER = :ID_OWNER
      into   :id_acc_template_pms, :id_currency;

      execute procedure ACCOUNT_CREATE_PMS$PMS(:ID_OWNER, :ID_ACC_TEMPLATE_PMS,
              :ID_CURRENCY, :ID_HOTEL)
      returning_values (:dbg);
    end

    when sqlcode -803 do begin
      exception PMS_EXCEPTION '-1057';
      exit;
    end

  end else if (:operation = 'mod') then begin
    if (not exists ( select *
                     from   ROOM_OWNER$PMS R
                     where  R.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
                            and R.ID_OWNER = :ID_OWNER ))
    then begin /* smenen e sobstwenik */
      if (not exists ( select *
                       from   ACCOUNT A
                       where  A.IS_PMS_ACCOUNT = 1
                              and A.ID_HOTEL = :id_hotel
                              and A.ID_PROFILE = :ID_OWNER ))
      then begin
        select O.ID_ACC_TEMPLATE_PMS, O.ID_CURRENCY
        from   OWNER$PMS O
        where  O.ID_OWNER = :ID_OWNER
        into   :id_acc_template_pms, :id_currency;
  
        execute procedure ACCOUNT_CREATE_PMS$PMS(:ID_OWNER, :ID_ACC_TEMPLATE_PMS,
                :ID_CURRENCY, :ID_HOTEL)
        returning_values (:dbg);
      end
    end

    update ROOM_OWNER$PMS
    set ID_OWNER = :ID_OWNER,
        OWNERSHIP_PERCENT = :OWNERSHIP_PERCENT
    where (ID_ROOM_OWNER = :ID_ROOM_OWNER);

    if ((:old_owner_name <> :owner_name) or (:old_ownership_percent <> :ownership_percent)) then begin
      action_text = f_character(29) || :old_owner_name || f_character(28) || formatfloat(:old_ownership_percent, '0.00') ||
                    f_character(28) || :owner_name || f_character(28) || formatfloat(:ownership_percent, '0.00');
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_OWNER_CHANGED', :ACTION_TEXT);
    end
  end else if (:operation = 'del') then begin
    action_text = f_character(29) || :old_owner_name || f_character(28) || formatfloat(:old_ownership_percent, '0.00');
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :OLD_ID_ROOM_CONTRACT, 'ROOM_OWNER_REMOVED', :ACTION_TEXT);

    delete from ROOM_OWNER$PMS
    where (ID_ROOM_OWNER = :ID_ROOM_OWNER);
  end
end
^

/* Alter (ROOM_PICKUP$INT) */
ALTER PROCEDURE ROOM_PICKUP$INT(ID_ROOM_TYPE INTEGER,
RES_FROM_DATE DATE,
RES_TO_DATE DATE,
IS_EARLY_ARRIVAL SMALLINT,
IS_LATE_DEPARTURE SMALLINT,
OFFER_METHOD VARCHAR(20),
FROM_ROOM VARCHAR(20),
ROOM_REQUIREMENTS BLOB SUB_TYPE 1 SEGMENT SIZE 100,
MIN_BEDS_COUNT SMALLINT)
 RETURNS(OUT_ID_ROOM INTEGER)
 AS
declare variable rooms_list_blocked varchar(5000);
  declare variable rooms_list_allowed varchar(5000);
  declare variable id_room integer;
  declare variable room_found integer;
  declare variable id_hotel integer;
begin
  /* offer_method :
      set_number_asc
      set_number_desc
      set_max_occupancy
      set_max_usage - FILING FACTOR(EQUAL ROOM USAGE)
  */
  -- INITIALIZE
  rooms_list_blocked = 'x';
  rooms_list_allowed = 'x';
  if (:from_room is null) then from_room = '';
  if (:offer_method is null) then begin
    select rt.ID_HOTEL
    from   ROOM_TYPES rt
    where  rt.ID_ROOM_TYPE = :ID_ROOM_TYPE
    into   :id_hotel;

    execute procedure SETTING_GET_VALUE('ROOMS_PREFERD_SORT_ORDER', :id_hotel )
    returning_values :offer_method;
  end

  /*
  ||  PREPARE EXCLUDING BUSY ROOMS, FOR THE FUTURE WE MAY
  ||  EXCLUDE ONLY BLOCKED WITH "RM.DAY_ACTION = 'BLOCK'".
  */
  for
    select distinct RM.ID_ROOM
    from   ROOM_MAGIC RM
           join ROOMS R on R.ID_ROOM = RM.ID_ROOM
           left outer join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = rm.ID_RESERV_DETAIL
    where  RM.BUSY_DATE between :res_from_date and :res_to_date
           and RM.ID_ROOM_TYPE = :id_room_type
           and ((RM.DAY_ACTION <> 'CHECK_OUT' and RM.BUSY_DATE <> :res_to_date)
                or (RM.BUSY_DATE = :res_from_date and :is_early_arrival = 1)
                or (RM.BUSY_DATE = :res_from_date and rd.LEAVING_KIND is not distinct from 2)
                or (RM.BUSY_DATE = :res_to_date and :is_late_departure = 1)
                or (RM.BUSY_DATE = :res_to_date and rd.COMMING_KIND is not distinct from 0))
    into   :id_room
  do begin
    rooms_list_blocked = :rooms_list_blocked||:id_room||'x';
  end

  if ((:room_requirements is not null) and (f_blobaspchar(:room_requirements) <> '')) then begin
    select 'x' || coalesce(list(R.ID_ROOM, 'x'), '') || 'x'
    from   ROOMS R
           left outer join SYSTEM_PICKUP_FEATURES$INT(R.FEATURES, :room_requirements, 38, R.ID_HOTEL) RPF on 0=0
    where  r.ID_ROOM_TYPE = :ID_ROOM_TYPE
           and not exists (select *
                       from   ROOM_PERIOD$PMS rp
                       where  rp.ID_ROOM = r.ID_ROOM
                              and rp.FROM_DATE <= :RES_FROM_DATE
                              and rp.TO_DATE >= (:RES_TO_DATE - 1)
                              and rp.IS_AVAILABLE = 0)
           and RPF.IS_MATCHING = 1
    into   :rooms_list_allowed;
  end

  room_found = 0;
  while (:room_found = 0) do begin
    out_id_room = null;
    execute procedure ROOM_PICKUP_OFFER$INT(:rooms_list_blocked, :rooms_list_allowed, :id_room_type,
                      :offer_method, :from_room, :res_from_date, :res_to_date, :min_beds_count)
    returning_values  :out_id_room;

    if (:out_id_room is null) then
      exit; /* NO MORE CHOICES ! */
    else begin
      room_found = 1;
    end
  end

  suspend;
end
^

/* empty dependent procedure body */
/* Clear: SAFE_CHECK_OUT for: SAFE_OCCUPANCY_MODIFY */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE /* TYPE OF ID */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER,
WARN_CODE /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SAFE_OCCUPANCY_MODIFY) */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE TYPE OF ID,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable old_booking_number tres_number;
  declare variable id_resource_reservation id_ref;
  declare variable from_datetime tdatetime;
  declare variable action_text tdescription_long;
  declare variable old_occupant varchar(100);
  declare variable old_to_dt timestamp;
  declare variable id_reserv_detail integer;
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation;

  select rr.BOOKING_NUMBER, od.FROM_DATETIME,
         RR.OCCUPANT_NAME, od.TO_DATETIME, rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESERV_DETAIL rd on rd.NUMBER = rr.BOOKING_NUMBER and rd.IS_ANUL = 0
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :old_booking_number, :from_datetime,
         :old_occupant, :old_to_dt, :id_reserv_detail, :id_agent_profile;

  --if (:old_booking_number <> :BOOKING_NUMBER) then exception ASSERT 'Can not change booking number!';
  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  update SAFE_RESOURCE_RESERV rr
  set    rr.PRICE_DESCRIPTION = :price_description,
         rr.ID_RATE_PRICE_PROFILE = :id_agent_profile,
         rr.RATING_UNITS = :rating_units,
         rr.RATE_PRICE = :price,
         rr.RATE_CURR = :currency
  where  rr.ID_RESOURCE_RESERV = :id_resource_reservation;

  execute procedure RESOURCE_RESERVATION_MODIFY (:id_resource_reservation, :ID_SAFE, :from_datetime,
          :TO_DATETIME, :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :old_booking_number, 'mod')
  returning_values :id_resource_reservation, :no_use;

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail)
  returning_values (:DOC_SELECTED);

  /* Log changes */
  if ((:old_occupant <> :OCCUPANT_NAME) or (:old_to_dt <> :TO_DATETIME)) then begin
    action_text = f_character(29) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                  || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                  || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');
  
    execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_CHANGED', :action_text);
  end
end
^

/* Alter (SAFE_OCCUPANCY_NEW) */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE TYPE OF ID,
FROM_DATETIME TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME,
BOOKING_NUMBER TYPE OF TRES_NUMBER,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
ID_RESOURCE_RESERVATION TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable action_text tdescription_long;
  declare variable id_reserv_detail integer;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, s.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  if (:id_resource_reservation is not null) then exception ASSERT '-1064'|| f_character(31) || f_character(29) || :safe_name;

  select rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESERV_DETAIL rd
  where  rd.NUMBER = :BOOKING_NUMBER
         and rd.IS_ANUL = 0
  into   :id_reserv_detail, :id_agent_profile;

  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  execute procedure  RESOURCE_RESERVATION_MODIFY (null, :ID_SAFE, :FROM_DATETIME, :TO_DATETIME,
          :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :BOOKING_NUMBER, 'add')
  returning_values (:id_resource_reservation, :no_use) ;

  insert into SAFE_RESOURCE_RESERV (ID_RESOURCE_RESERV, PRICE_DESCRIPTION, ID_RATE_PRICE_PROFILE,
         RATING_UNITS, RATE_PRICE, RATE_CURR)
  values (:id_resource_reservation, :price_description, :id_agent_profile,
         :rating_units, :price, :currency);

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail, :ID_EXTERNAL_CLIENT_ACCCOUNT)
  returning_values (:DOC_SELECTED);

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = 'CHECKED_IN'
  where  RR.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = :id_resource_reservation
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                || f_character(28) || coalesce(:BOOKING_NUMBER, '')
                || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUPIED', :action_text);
end
^

/* Alter (SUMMARY_FINANCE_SAVE$INT) */
ALTER PROCEDURE SUMMARY_FINANCE_SAVE$INT(ID_END_WORK INTEGER)
 AS
declare variable id_hotel integer;
  declare variable summary_date date;
begin
  select EW.ID_HOTEL, EW.PREV_DATE
  from   END_WORKS EW
  where  EW.ID_END_WORK = :ID_END_WORK
  into   :id_hotel, :summary_date;

  /* prepare postings */
  execute procedure ACCOUNT_POSTS_EW_MARK$INT (:ID_END_WORK);

  execute procedure ACCOUNT_DEBT_FILL$INT(:ID_END_WORK);

  insert into SUMMARY_END_WORK (ID_END_WORK, ID_HOTEL, SUMMARY_DATE,
         REVENUE_AMOUNT, CORRECTION_AMOUNT, DOC_TAXES_AMOUNT, VAT_AMOUNT,
         DISCOUNTS_AMOUNT, PAYMENT_AMOUNT, PAYMENT_TRANSACTIONS,
         FISCAL_PAY_AMOUNT, FISCAL_PAY_TRANSACTIONS, DEPOSIT_AMOUNT)
  values (:ID_END_WORK, :ID_HOTEL, :SUMMARY_DATE, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);

  execute procedure REVENUE_EW_SUMMARIZE$INT (:ID_END_WORK, 'full');

  execute procedure PAYMENTS_EW_SUMMARIZE$INT (:ID_END_WORK);

  /* update statistic revenue summary (sections by refenrenes) for previous affected dates */
  execute procedure REVENUE_STATISTIC_REBUILD (:id_hotel, :summary_date - 1);

end
^

/* Alter (SUMMARY_TAXES_REGEN) */
ALTER PROCEDURE SUMMARY_TAXES_REGEN AS
declare variable id_sale_taxation integer;
  declare variable revenue_group varchar(50);
  declare variable round_to numeric(15,6);
  declare variable id_sale_tax integer;
  declare variable tax_value numeric(15,4);
  declare variable ew_date date;
  declare variable id_end_work integer;
  declare variable id_hotel integer;
  declare variable id_summary_rev_group integer;
begin
  delete
  from   SUMMARY_TAXES;

  for
    select   EW.ID_END_WORK, EW.ID_HOTEL, CU.ROUND_TO,
             EW.SUMMARY_DATE
    from     SUMMARY_END_WORK EW
             join HOTEL H on H.ID_HOTEL = EW.ID_HOTEL
             join CURRS CU on CU.CURR = H.NATION_CURR
    into     :id_end_work, :id_hotel, :round_to, :ew_date
  do begin
    for
      select  AP.ID_SALE_TAXATION, AP.REVENUE_GROUP, TVD.ID_SALE_TAX, sum(TVD.TAX_VALUE)
      from    ACCOUNT_DEBT AP
              join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
              left outer join TAX_VALUE_DEDUCT(AP.NAT_GROSS_VALUE, :round_to, AP.ID_SALE_TAXATION, 1) TVD on 1=1
      where   A.ID_HOTEL = :id_hotel
              and AP.DEBT_DATE = :ew_date
      group by 1, 2, 3
      into    :id_sale_taxation, :revenue_group, :id_sale_tax, :tax_value
    do begin
      select SRG.ID_SUMMARY_REV_GROUP
      from   SUMMARY_REV_GROUPS$REV SRG
      where  SRG.ID_END_WORK = :id_end_work
             and SRG.REVENUE_GROUP = :revenue_group
             and SRG.ID_SALE_TAXATION = :id_sale_taxation
      into   :id_summary_rev_group;

      insert into SUMMARY_TAXES(ID_SUMMARY_REV_GROUP, ID_SALE_TAXES, VAT_AMOUNT)
      values (:id_summary_rev_group, :id_sale_tax, :tax_value);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: PRODUCT_RATING$INT for: TAR_CALC_EVAL_ALL$INT */
ALTER PROCEDURE PRODUCT_RATING$INT(ID_HOTEL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
ADULT_AGES VARCHAR(100) = null,
CHILD_AGES VARCHAR(100) = null,
ID_TAR_CALC_COMMON INTEGER = null)
 RETURNS(ROOM_PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_TEST$TAR for: TAR_CALC_EVAL_ALL$INT */
ALTER PROCEDURE TAR_TEST$TAR(NUMBER VARCHAR(62),
ID_TAR_HEAD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_EVAL_ALL$INT) */
ALTER PROCEDURE TAR_CALC_EVAL_ALL$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable room_status varchar(20);
  declare variable from_date date;
  declare variable to_date date;
  declare variable idate date;
  declare variable is_static integer;
  declare variable id_tar_input integer;
  declare variable id_type_stay integer;
  declare variable separate_board integer;
  declare variable id_board_include integer;
  declare variable id_tar_head integer;
  declare variable is_manual_type_stay smallint;
  declare variable seasson_name varchar(50);
begin
  err_code = 0;

  delete from TAR_CALC_OUTPUT$TMP TCO where TCO.ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP TCV where TCV.ID_TAR_CALC = :id_tar_calc;

  execute procedure TAR_CALC_INIT_VARS$INT(:id_tar_calc);

  for
    select TCI.ROOM_STATUS, min(TCI.FROM_DATE_CALC), max(TCI.TO_DATE_CALC), min(TCI.IS_STATIC)
    from   TAR_CALC_INPUT$TMP TCI
    where  TCI.ID_TAR_CALC = :id_tar_calc
    group by TCI.ROOM_STATUS
    into   :room_status, :from_date, :to_date, :is_static
  do begin
    for
      select RLP.OUT_DATE
      from   SYSTEM_LOOP_PERIOD(:from_date, :to_date) RLP
      into   :idate
    do begin
      if ((:is_static = 1) and (:idate > :from_date)) then begin
        insert into TAR_CALC_OUTPUT$TMP (ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
               FOR_DATE, PRICE, CURRENCY, PRICE_TARIFF, CURRENCY_TARIFF, PRICE_NOTE, QTY_POST,
               PTEXT, DISC_TAG, ID_DISCOUNT_SERVICE, REQUIRED_ID_PACKET_ITEM)
        select tco.ID_TAR_INPUT, tco.ID_TAR_CALC, tco.ID_SERVICE, tco.SERVICE_TYPE,
               :idate, PRICE, tco.CURRENCY, tco.PRICE_TARIFF, tco.CURRENCY_TARIFF, tco.PRICE_NOTE, tco.QTY_POST,
               tco.PTEXT, tco.DISC_TAG, tco.ID_DISCOUNT_SERVICE, tco.REQUIRED_ID_PACKET_ITEM
        from   TAR_CALC_OUTPUT$TMP TCO
        where  TCO.FOR_DATE = :from_date
               and TCO.ID_TAR_CALC = :id_tar_calc;
        for
          select TCID.ID_TAR_INPUT, TCID.ID_TYPE_STAY, TCID.SEPARATE_BOARD, TCID.ID_BOARD_INCLUDE,
                 TCID.IS_MANUAL_TYPE_STAY, TCID.ID_TAR_HEAD
          from   TAR_CALC_INPUT_DETAIL$TMP TCID
                 join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
          where  TCID.FOR_DATE = :from_date
                 and TCI.ID_TAR_CALC = :id_tar_calc
          into   :id_tar_input, :id_type_stay, :separate_board, :id_board_include,
                 :is_manual_type_stay, :id_tar_head
        do begin
          seasson_name = null;
          select tp.SEASON_NAME
          from   TARIFA_GET_PERIOD_FOR_DATE (:id_tar_head, :idate) tp
          into   :seasson_name;
          if (:seasson_name is null) then begin
            ERR_CODE = -231;
            ERR_TEXT = '';
            exit;
          end

          update TAR_CALC_INPUT_DETAIL$TMP TCID
          set    TCID.ID_TYPE_STAY = :id_type_stay,
                 TCID.IS_MANUAL_TYPE_STAY = :is_manual_type_stay,
                 TCID.SEPARATE_BOARD = :separate_board,
                 TCID.ID_BOARD_INCLUDE = :id_board_include
          where  TCID.ID_TAR_INPUT = :id_tar_input;
        end
      end else begin
        execute procedure TAR_CALC_EVAL_DATE$INT(:id_tar_calc, :room_status, :idate)
        returning_values  :err_code, :err_text;
        if (:err_code < 0) then exit;
      end
    end
  end

  execute procedure TAR_CALC_EVAL_ZERO$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  if (:err_code is null) then begin
    err_code = -230; /*WRONG INPUT PARAMS - MISSING GUESTS*/
    err_text = 'Missing input data for calculation';
    exit;
  end

  execute procedure TAR_CALC_EVAL_PERIOD$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  execute procedure TAR_CALC_CHECK_PACKETS$INT (:ID_TAR_CALC)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_EVAL_DATE$INT for: TAR_CALC_EVAL_COMPLEX_RATE$INT */
ALTER PROCEDURE TAR_CALC_EVAL_DATE$INT(ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
FOR_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_EVAL_COMPLEX_RATE$INT) */
ALTER PROCEDURE TAR_CALC_EVAL_COMPLEX_RATE$INT(INPUT_DETAIL_DBKEY CHAR(8),
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
BEDS SMALLINT,
ID_TYPE_STAY INTEGER,
IS_MANUAL_TYPE_STAY SMALLINT,
ID_BOARD INTEGER,
ID_ROOM_TYPE INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
CHECKIN_DATE DATE,
DAY_OF_STAY INTEGER,
PAYORS INTEGER,
MINORS INTEGER,
PERIOD_DEPEND_ON_CHECKIN SMALLINT,
CNT_DAYS_BP INTEGER,
CNT_DAYS_BOARD INTEGER,
BOARD_TYPE_FIND VARCHAR(10),
TOTAL_GUESTS INTEGER,
SEQ_NUM INTEGER,
TARIFF_CURR CHAR(3),
REAL_RECALC SMALLINT)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_PAYORS INTEGER,
OUT_MINORS INTEGER)
 AS
declare variable id_tar_input_detail integer;
  declare variable price numeric(15,4);
  declare variable auto_stay_type integer;
  declare variable base_per_day numeric(15,4);
  declare variable board_per_day numeric(15,4);
  declare variable guest_board_weight integer;
--  declare variable guest_food varchar(20);
  declare variable match_date date;
  declare variable manual_total_gsts integer;
  declare variable manual_payors integer;
  declare variable manual_minors integer;
  declare variable service_type varchar(20);
  declare variable base_price numeric(15,4);
  declare variable board_price numeric(15,4);
  declare variable food_per_day numeric(15,4);
  declare variable base_price_tar numeric(15,4);
  declare variable custom_cross_rate double precision;
  declare variable ptext varchar(20);
  declare variable id_service integer;
  declare variable qty_post integer;
  declare variable pack_currency char(3);
  declare variable minors_input integer;
  declare variable packet_item integer;
  declare variable price_tariff numeric(15,4);
  declare variable is_inside_base integer;
  declare variable id_bo_bp integer;
  declare variable id_board_include integer;
  declare variable separate_board integer;
  declare variable incomplete_bp integer;
  declare variable id_bo_eg integer;
  declare variable id_eg_price integer;
  declare variable disc_tag varchar(50);
  declare variable id_discount_service integer;
  declare variable var_board_price numeric(15,4);
  declare variable type_stay_code varchar(10);
begin
  base_per_day = 0;
  board_per_day = 0;

  select TH.WEIGHT_TAG
  from   MEALS TH
  where  TH.ID_BOARD = :ID_BOARD
  into   :guest_board_weight;
  guest_board_weight = coalesce(:guest_board_weight, 0);

  /*if (:guest_board_weight = 0) then GUEST_FOOD = 'NONE';
  else GUEST_FOOD = 'SOME';*/
  if (:PERIOD_DEPEND_ON_CHECKIN = 1) then MATCH_DATE = :CHECKIN_DATE;
  else MATCH_DATE = :FOR_DATE;

  select st.TYPE_STAY_CODE
  from   TYPE_STAY st
  where  st.ID_TYPE_STAY = :id_type_stay
  into   :type_stay_code;

  if (:IS_MANUAL_TYPE_STAY = 1) then begin
    if (:type_stay_code = 'ALONE') then begin
      MANUAL_TOTAL_GSTS = 1;
      MANUAL_PAYORS = 0;
      MANUAL_MINORS = 0;
    end else if (:type_stay_code = 'BED') then begin
      MANUAL_TOTAL_GSTS = 2;
      MANUAL_PAYORS = 1;
      MANUAL_MINORS = 0;
    end else if (:type_stay_code = 'EXTRA_BED') then begin
      MANUAL_TOTAL_GSTS = :BEDS+1;
      MANUAL_PAYORS = :BEDS;
      MANUAL_MINORS = :MINORS;
    end

    execute procedure TAR_MATCH_BP(:INPUT_DETAIL_DBKEY, :MATCH_DATE, :MANUAL_TOTAL_GSTS, :MANUAL_TOTAL_GSTS,
                      :GUEST_BOARD_WEIGHT, :REAL_RECALC, :DAY_OF_STAY, :CNT_DAYS_BP)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_BP, :ID_BOARD_INCLUDE,
                      :INCOMPLETE_BP, :BASE_PRICE, :PTEXT, :BASE_PER_DAY;
  end else begin
    execute procedure TAR_MATCH_BP(:INPUT_DETAIL_DBKEY, :MATCH_DATE, :SEQ_NUM, :TOTAL_GUESTS,
                      :GUEST_BOARD_WEIGHT, :REAL_RECALC, :DAY_OF_STAY, :CNT_DAYS_BP)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_BP, :ID_BOARD_INCLUDE,
                      :INCOMPLETE_BP, :BASE_PRICE, :PTEXT, :BASE_PER_DAY;
  end

  execute procedure sys_dbg('tar base_per_day = '||coalesce(:BASE_PER_DAY, 'null'));
  execute procedure sys_dbg('tar base_price = '||coalesce(:BASE_PRICE, 'null'));
  if (:ERR_CODE < 0) then exit;

  SEPARATE_BOARD = 0;
  if (:REAL_RECALC = 1) then begin
    if (:CUSTOM_PRICE is not null) then begin
      base_price = :CUSTOM_PRICE;
      execute procedure CURR_CROSS_RATE_GET(:CUSTOM_CURRENCY, :TARIFF_CURR, current_timestamp, 1)
      returning_values  :custom_cross_rate;
      base_price_tar = (:custom_cross_rate * :base_price);
      pack_currency = :custom_currency;
    end else begin
      base_price_tar = :base_per_day;
      pack_currency = :tariff_curr;
    end
    /*DEBUG*/
    if (:base_price is null) then exception RATING_EXCEPTION ('4. base price is null');
    if (:base_price_tar is null) then exception RATING_EXCEPTION ('5. base price tar is null');

    select TBP.PACKET_ITEM
    from   TAR_BO_BASE_POSITION TBP
    where  TBP.ID_TAR_BP = :id_bo_bp
    into   :packet_item;

    insert into TAR_CALC_OUTPUT$TMP (
           ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
           FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
           CURRENCY, CURRENCY_TARIFF, REQUIRED_ID_PACKET_ITEM)
    values (:ID_TAR_INPUT, :ID_TAR_CALC, -1, 'BASE',
           :FOR_DATE, :BASE_PER_DAY, :BASE_PRICE_TAR, 'BASE', 1, :PTEXT,
           :PACK_CURRENCY, :TARIFF_CURR, :packet_item);
    /* BOARDS */
    var_board_price = 0;
    for
      select TMB.ERR_CODE, TMB.ERR_TEXT, TMB.SEPARATE_BOARD, TMB.BOARD_PRICE, TMB.PTEXT,
             TMB.SERVICE_TYPE, TMB.ID_SERVICE, TMB.FOOD_PER_DAY, TMB.PACKET_ITEM
      from   TAR_MATCH_BOARD(:INPUT_DETAIL_DBKEY, :id_bo_bp, :BOARD_TYPE_FIND,
             :ID_BOARD, :id_board_include, :match_date, :base_per_day,
             :DAY_OF_STAY, :CNT_DAYS_BOARD, :CNT_DAYS_BP, :CUSTOM_PRICE) TMB
      into   :err_code, :err_text, :separate_board, :board_price, :ptext,
             :service_type, :id_service, :food_per_day, :packet_item
    do begin
      if (:ERR_CODE < 0) then exit;

      /*DEBUG*/
      if (:board_price is null) then exception RATING_EXCEPTION ('6. board_price is null');
      if (:id_service is null) then exception RATING_EXCEPTION ('7. id_service is null');

      insert into TAR_CALC_OUTPUT$TMP (
             ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
             FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
             CURRENCY, CURRENCY_TARIFF, REQUIRED_ID_PACKET_ITEM)
      values (:ID_TAR_INPUT, :ID_TAR_CALC, :ID_SERVICE, :SERVICE_TYPE,
             :FOR_DATE, :food_per_day, :food_per_day, 'FOOD', 1, :PTEXT,
             :TARIFF_CURR, :TARIFF_CURR, :packet_item);

      -- board_per_day = (:board_per_day + :food_per_day); ???
      var_board_price = :var_board_price + iif(:service_type in ('BASE_BOARD', 'EXTRA_BOARD'), :food_per_day, 0);
    end

    select TID.ID_TAR_INPUT_DETAIL
    from   TAR_CALC_INPUT_DETAIL$TMP TID
    where  tid.RDB$DB_KEY = :INPUT_DETAIL_DBKEY
    into   :id_tar_input_detail;

    execute procedure TAR_SET_VAR('board='||:VAR_BOARD_PRICE, :id_tar_input_detail, :id_tar_calc);
  end

  if (:SEPARATE_BOARD is null) then SEPARATE_BOARD = 0;
  minors_input = :MINORS;

  if (:IS_MANUAL_TYPE_STAY = 1) then begin
    /* ONLY TO FIND THE REAL POSITION PAYORS, MINORS ARE NOT IMPORTANT
    || ALL OTHER GUESTS IN THE ROOM MUST SEE THE MANUAL ONE AS AUTOMATIC. SO
    || HERE WE ARE FINDING HIS AUTOMATIC TYPE STAY.
    */
    execute procedure TAR_MATCH_EG(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :total_guests, :PAYORS, :MINORS, :MATCH_DATE, :INCOMPLETE_BP, :ID_ROOM_TYPE, 1)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_EG, :ID_EG_PRICE, :PAYORS, :MINORS, :AUTO_STAY_TYPE;
    if (:ERR_CODE < 0) then exit;
    /* REAL PRICE FIND AND EVAL */
    execute procedure TAR_MATCH_MANUAL_EG(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :MANUAL_TOTAL_GSTS, :MANUAL_PAYORS, :MANUAL_MINORS, :MATCH_DATE, :INCOMPLETE_BP, :ID_TYPE_STAY)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_EG, :ID_EG_PRICE, :AUTO_STAY_TYPE;
    if (:ERR_CODE < 0) then exit;

    if ((:MINORS = :minors_input) and
        (exists (select *
                 from   TYPE_STAY TS
                 where  TS.ID_TYPE_STAY = :ID_TYPE_STAY
                        and TS.TYPE_STAY_CODE = 'EXTRA_BED'))) then begin
      /* TO MANAGE PARAMETER "EXTRA GUEST IN TURN" WHEN MANUAL SET TO ADD */
      MINORS = :MINORS + 1;
      PAYORS = :PAYORS - 1;
    end
  end else begin
    execute procedure TAR_MATCH_EG(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :TOTAL_GUESTS, :PAYORS, :MINORS, :MATCH_DATE, :INCOMPLETE_BP, :ID_ROOM_TYPE, 0)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_EG, :ID_EG_PRICE, :PAYORS, :MINORS, :AUTO_STAY_TYPE;
    if (:ERR_CODE < 0) then exit;
  end

  update TAR_CALC_INPUT_DETAIL$TMP TID
  set    TID.SEPARATE_BOARD = :SEPARATE_BOARD,
         TID.ID_TYPE_STAY   = :AUTO_STAY_TYPE
  where  TID.RDB$DB_KEY = :INPUT_DETAIL_DBKEY;

  if (:REAL_RECALC = 1) then begin
    if (:CUSTOM_PRICE is null) then begin
      for
        select TSP.SERVICE_TYPE, TSP.PRICE,  TSP.PTEXT, TSP.ERR_CODE, TSP.ID_SERVICE
        from   TAR_PRICES_SET_EG(:ID_TAR_INPUT, :FOR_DATE, :DAY_OF_STAY, :CNT_DAYS_BP,
               :CNT_DAYS_BOARD, :guest_board_weight, :id_bo_eg, :id_eg_price, :base_price) TSP
        into   :service_type, :price,  :ptext, :ERR_CODE, :id_service
      do begin
        if (:ERR_CODE < 0) then exit; -- exception INTERNAL_RATING_EXCEPTION;

        /*DEBUG*/
        if (:PRICE is null) then exception RATING_EXCEPTION ('8. price is null');
        if (:ID_SERVICE is null) then exception RATING_EXCEPTION ('9. id_service is null');

        insert into TAR_CALC_OUTPUT$TMP (
               ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
               FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
               CURRENCY, CURRENCY_TARIFF, REQUIRED_ID_PACKET_ITEM)
        values (:ID_TAR_INPUT, :ID_TAR_CALC, :id_service, :service_type,
               :FOR_DATE, :price, :price, 'EG', 1, :ptext,
               :TARIFF_CURR, :TARIFF_CURR, :packet_item);
      end
    end

    for
      select TMT.ID_SERVICE, TMT.SERVICE_TYPE, TMT.PRICE, TMT.PRICE_TARIFF, TMT.QTY_POST,
             TMT.PTEXT, TMT.PACK_CURRENCY, TMT.ERR_CODE, TMT.ERR_TEXT, TMT.PACKET_ITEM, TMT.DISC_TAG
      from   TAR_PRICES_SET_PACKS(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :DAY_OF_STAY, :CUSTOM_PRICE) TMT
      into   :ID_SERVICE, :SERVICE_TYPE, :PRICE, :PRICE_TARIFF, :QTY_POST,
             :PTEXT, :PACK_CURRENCY, :ERR_CODE, :ERR_TEXT, :PACKET_ITEM, :DISC_TAG
    do begin
      if (:ERR_CODE < 0) then exit; --exception INTERNAL_RATING_EXCEPTION;
      /*DEBUG*/
      if (:price_tariff is null) then exception RATING_EXCEPTION ('10. PRICE_TARIFF is null');
      if (:id_service is null) then exception RATING_EXCEPTION ('11. ID_SERVICE is null');

      insert into TAR_CALC_OUTPUT$TMP (
             ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
             FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
             CURRENCY, CURRENCY_TARIFF, DISC_TAG, REQUIRED_ID_PACKET_ITEM)
      values (:ID_TAR_INPUT, :ID_TAR_CALC, :ID_SERVICE, :SERVICE_TYPE,
             :FOR_DATE, :PRICE, :PRICE_TARIFF, 'PACK', :QTY_POST, :PTEXT,
             :PACK_CURRENCY, :TARIFF_CURR, :DISC_TAG, :packet_item);

    end

    for
      select TMT.ID_SERVICE, TMT.SERVICE_TYPE, TMT.PRICE, TMT.PTEXT, TMT.ERR_CODE, TMT.ERR_TEXT, TMT.PACKET_ITEM,
             TMT.IS_INSIDE_BASE, TMT.DISC_TAG, TMT.ID_DISCOUNT_SERVICE
      from   TAR_PRICES_SET_TAX(:ID_TAR_INPUT, :INPUT_DETAIL_DBKEY, :ID_BO_BP, :DAY_OF_STAY) tmt
      into   :ID_SERVICE, :SERVICE_TYPE, :PRICE, :PTEXT, :ERR_CODE, :ERR_TEXT, :PACKET_ITEM,
             :IS_INSIDE_BASE, :DISC_TAG, :ID_DISCOUNT_SERVICE
    do begin
      if (:ERR_CODE < 0) then exit; --exception INTERNAL_RATING_EXCEPTION;
      if ((:IS_INSIDE_BASE = 0) and (:CUSTOM_PRICE is not null)) then begin
        -- SKIP IT. SIMPLE DISCOUNTS MUST NOT CHANGE THE CUSTOM PRICE
      end else begin
        /*DEBUG*/
        if (:PRICE is null) then exception RATING_EXCEPTION ('12. price is null');
        if (:ID_SERVICE is null) then exception RATING_EXCEPTION ('13. id_service is null');
        -- !!! Service type and id_service of discount is as object that they discounting but in TAR_CALC_REPOST$INT type and id_service is changed to PACKAGES if discounts have ID_DISCOUNT_SERVICE
        if ((:DISC_TAG = '') or (:DISC_TAG is null)) then DISC_TAG =  'DISC';
        insert into TAR_CALC_OUTPUT$TMP (
               ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
               FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
               CURRENCY, CURRENCY_TARIFF, DISC_TAG, ID_DISCOUNT_SERVICE, REQUIRED_ID_PACKET_ITEM)
        values (:ID_TAR_INPUT, :ID_TAR_CALC, :ID_SERVICE, :SERVICE_TYPE,
               :FOR_DATE, :PRICE, :PRICE, 'DISC', 1, :PTEXT,
               :TARIFF_CURR, :TARIFF_CURR, :DISC_TAG, :id_discount_service, :packet_item);

        execute procedure sys_dbg('tar TAR_CALC_EVAL_DATE$INT - :DISC_TAG=' || coalesce(:DISC_TAG, 'null') );
      end
    end
  end

  OUT_MINORS = :MINORS;
  OUT_PAYORS = :PAYORS;
end
^

/* Alter (TAR_CALC_EVAL_DATE$INT) */
ALTER PROCEDURE TAR_CALC_EVAL_DATE$INT(ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
FOR_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_input integer;
declare variable checkin_date date;
declare variable day_of_stay integer;
declare variable real_recalc integer;
declare variable id_guest integer;
declare variable input_detail_dbkey char(8);
declare variable id_room_type integer;
declare variable id_board integer;
declare variable id_tar_head integer;
declare variable id_type_stay integer;
declare variable id_hotel integer;
declare variable period_depend_on_checkin integer;
declare variable cnt_days_board integer;
declare variable cnt_days_bp integer;
declare variable tariff_curr char(3);
declare variable board_type_find varchar(10);
declare variable id_room integer;
declare variable custom_price numeric(15,4);
declare variable custom_currency char(3);
declare variable id_tar_input_detail integer;
declare variable is_simple integer;
declare variable guest_age integer;
declare variable tar_name varchar(50);
declare variable guest_name varchar(50);
declare variable total_guests integer;
declare variable old_id_room integer;
declare variable beds integer;
declare variable payors integer;
declare variable minors integer;
declare variable int_err_text varchar(255);
declare variable is_manual_type_stay smallint;
declare variable seq_num integer;
declare variable current_child_num integer;
declare variable current_adult_num integer;
begin
  ERR_CODE = 0;
  OLD_ID_ROOM = NULL;
  for
    select   TCI.ID_TAR_INPUT, TCI.FROM_DATE, (:FOR_DATE - TCI.FROM_DATE + 1),
             TCI.REAL_RECALC, TCI.ID_GUEST, TCID.RDB$DB_KEY, TCID.ID_ROOM_TYPE,
             TCID.ID_BOARD, TCID.ID_TAR_HEAD, TCID.ID_TYPE_STAY, TCID.IS_MANUAL_TYPE_STAY, T.ID_HOTEL,
             TH.PERIOD_DEPEND_ON_CHECKIN, TH.CNT_DAYS_PRICE_BOARD, TH.CNT_DAYS_PRICE_BP, T.CURR, TH.BOARD_TYPE,
             TCID.ID_ROOM, TCID.CUSTOM_PRICE, TCID.CUSTOM_CURRENCY,
             TCID.ID_TAR_INPUT_DETAIL, TH.IS_SIMPLE, TCI.GUEST_AGE
    from     TAR_CALC_INPUT_DETAIL$TMP TCID
             join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
             join TAR_HEAD TH on TH.ID_TAR_HEAD = TCID.ID_TAR_HEAD
             join TARIFA T on T.ID_TARIFA = TH.ID_TAR_HEAD
    where    TCI.ID_TAR_CALC = :ID_TAR_CALC
             and TCI.ROOM_STATUS = :ROOM_STATUS
             and TCID.FOR_DATE = :FOR_DATE
    order by TCID.ID_ROOM asc,
             iif(TCI.IS_CHILD = 1, TCI.GUEST_AGE, 999) desc,
             --iif(TCI.GUEST_AGE > 16, 999, TCI.GUEST_AGE) desc,
             TCID.CHECKIN_ORDER asc,
             TCI.ID_GUEST asc
             /* ADULTS MUST BE HANDLED FIRST, THEN BY CHECKIN ORDER and ID_GUEST because of shares */
    into     :id_tar_input, :checkin_date, :day_of_stay,
             :real_recalc, :id_guest, :input_detail_dbkey, :id_room_type,
             :id_board, :id_tar_head, :id_type_stay, :is_manual_type_stay, :id_hotel,
             :period_depend_on_checkin, :cnt_days_board, :cnt_days_bp, :tariff_curr, :board_type_find,
             :id_room, :custom_price, :custom_currency,
             :id_tar_input_detail, :is_simple, :guest_age

  do begin
    if (coalesce(:id_room_type, -1) < 0) then exception RATING_EXCEPTION 'Unspecified room type!';
    if (coalesce(:id_type_stay, -1) < 0) then exception RATING_EXCEPTION 'Unspecified type stay!';
    --if (coalesce(:id_board, -1) < 0) then exception ASSERT 'Unspecified board!';
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    /* - - - - - PART 1 - For Both Simple and Complex Rates - */
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    select count(*)
    from   TAR_CALC_INPUT_DETAIL$TMP TCID
           join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
    where  TCI.ID_TAR_CALC = :ID_TAR_CALC
           and TCID.FOR_DATE = :FOR_DATE
           and TCID.ID_ROOM = :ID_ROOM
    into   :TOTAL_GUESTS;

    if (:TOTAL_GUESTS = 0) then exit;
  
    select RT.BEDS
    from   ROOM_TYPES RT
    where  RT.ID_ROOM_TYPE = :ID_ROOM_TYPE
    into   :BEDS;

    if (:IS_SIMPLE = 1) then begin
      /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
      /* - - - - - - - PART 2 - Simple Rates - - - - - - - - -  */
      /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
      if (:old_id_room is distinct from :id_room) then begin
        current_adult_num = 0;
        current_child_num = 0;
        old_id_room = :id_room;
      end

      execute procedure TAR_CALC_EVAL_SIMPLE_RATE$INT (:id_tar_input_detail, :id_tar_input, :ID_TAR_CALC,
              :FOR_DATE, :id_tar_head, :beds, :guest_age, :id_type_stay, :is_manual_type_stay, :id_board, :id_room_type,
              :custom_price, :custom_currency, :id_hotel, :total_guests, :current_adult_num, :current_child_num)
      returning_values (:ERR_CODE, :int_err_text, :current_adult_num, :current_child_num);
      if (:ERR_CODE < 0) then exception INTERNAL_RATING_EXCEPTION;

    end else begin
      /* - - -  - - - - - - - - - - - -  - - - - - - - - */
      /* - - -  - PART 3 - Complex Rates - - - - - - - - */
      /* - - -  - - - - - - - - - - - -  - - - - - - - - */
      if (:old_id_room is distinct from :id_room) then begin
        payors  = 0;
        minors  = 0;
        old_id_room = :id_room;
        seq_num = 0;
      end
      seq_num = :seq_num + 1;

      execute procedure TAR_CALC_EVAL_COMPLEX_RATE$INT (:input_detail_dbkey, :id_tar_input, :ID_TAR_CALC,
              :FOR_DATE, :beds, :id_type_stay, :is_manual_type_stay, :id_board, :id_room_type, :custom_price, :custom_currency,
              :checkin_date, :day_of_stay, :payors, :minors, :period_depend_on_checkin, :cnt_days_bp, :cnt_days_board,
              :board_type_find, :total_guests, :seq_num, :tariff_curr, :real_recalc)
      returning_values (:ERR_CODE, :int_err_text, :payors, :minors);
      if (:ERR_CODE < 0) then exception INTERNAL_RATING_EXCEPTION;
    end
  /* - --- - END PART 3 - complex Rates*/
  end

  when exception INTERNAL_RATING_EXCEPTION do begin
    if (coalesce(:ERR_CODE, 0) = 0) then ERR_CODE = -211;
    select TH.TARIFA_NAME
    from   TARIFA TH
    where  TH.ID_TARIFA = :ID_TAR_HEAD
    into   :TAR_NAME;

    select GC.GUEST_NAME1
    from   GUEST_CARD GC
    where  GC.ID_GUEST = :ID_GUEST
    into   :GUEST_NAME;
    ERR_TEXT = substring('GUEST='||cast(:ID_GUEST as varchar(20))||'-'||:GUEST_NAME||f_crlf()
                         || 'DATE='||:FOR_DATE||f_crlf()
                         || 'TARIFF='||:TAR_NAME||f_crlf()
                         || :int_err_text
                        from 1 for 255);

    exit;
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_INPUT_PARAMS$INT for: TAR_CALC_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_PARAMS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_PARAMS$INT) */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
declare variable param_code varchar(40);
  declare variable id_param integer;
  declare variable param_value varchar(255);
  declare variable data_type  varchar(30);
  declare variable rate_list varchar(2000);
begin
  err_code = 0;
  param_values = '';

  if (coalesce(:rate_list_replace, '') = '') then rate_list = ',' || :id_rate || ',';
  else rate_list = :rate_list_replace;

  for
    select distinct TBP.PARAM_NAME
    from   SYSTEM_STRING_PARSER (:rate_list, ',') sp
           left join TAR_BO_PARAMS TBP on TBP.ID_TAR_HEAD = sp.ITEM
    where  (TBP.PARAM_TYPE <> 'DATE_DEPENDANT' and :for_date is null)
           or (TBP.PARAM_TYPE = 'DATE_DEPENDANT' and :for_date is not null)
    into   :param_code
  do begin
    if (:param_code is not null) then begin
      id_param = null;
      select TP.ID_TARIFA_PARAM, TP.DATA_TYPE
      from   TARIFA_PARAMS TP
      where  TP.PARAM_CODE = :param_code
             and tp.IS_USE = 1
      into   :id_param, :data_type;
  
      if (:id_param is null) then begin
        err_code = -202;
        execute procedure sys_dbg ('tar calc params err_code: ' || :err_code || F_CRLF() || 'PARAM_CODE = ' || :param_code);
        exit;
      end
  
      execute procedure TARIFA_GET_PARAM (:id_param, :for_date, :id_tar_input, :id_tar_calc)
      returning_values (:param_value);
  
      param_code = ':'||param_code;
  
      if ((:param_code is not null) and (:param_code is not null) and (:data_type is not null)) then
         param_values = :param_values||';'||:param_code||','||:data_type||','||:param_value;
    end
  end
end
^

/* Alter (TAR_SAVE_BO_BOARD) */
ALTER PROCEDURE TAR_SAVE_BO_BOARD(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable id_tar_season integer;
  declare variable iteration varchar(20);
/*****************************************************/
  declare variable id_tar_board integer;
  declare variable id_board integer;
  declare variable id_service integer;
  declare variable pos_numbers varchar(2000);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable separate_board integer;
  declare variable id_bo_price integer;
  declare variable price_type varchar(20);
  declare variable price_type_equal_exists integer;
  declare variable is_board integer;
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  err_text = '';
  iteration = 'FIRST';
  price_type_equal_exists = 0;

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :id_tar_season, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_board, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
      if (:price_type_equal_exists = 1) then begin
        if (exists(
          select *
          from   TAR_BO_RELATION TBR
                 join TAR_BO_BASE_POSITION TBB on TBR.ID_TAR_BP = TBB.ID_TAR_BP
          where  TBR.ID_BO = :id_tar_board
                 and TBR.BO_TYPE = 'BOARD'
                 and TBB.ID_BOARD_INCLUDE is not distinct from :id_board
        )) then begin
          err_code = -237;
          exit;
        end
      end
      price_type_equal_exists = 0;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_board = gen_id(GEN_TAR_BO_BOARD_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers = '';
      id_board = null;
      separate_board = 0;
      ptext = '';
      disc_tag = 'F';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      packet_item = null;
    end
    if (:iteration = 'MIDDLE') then begin
      if (:param_name = 'PTEXT') then ptext = :data;
      else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
      else if (:param_name = 'SET_VAR')       then set_var = :data;
      else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
      else if (:param_name = 'LIST_BASE_POS') then pos_numbers = :data;
      else if (:param_name = 'SEPARATE_BOARD') then begin
        separate_board = :data;
        if ((:separate_board = 0) and (:board_type = 'HRANI')) then err_code = -226;
      end else if (:param_name = 'CHECKIN_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'NIGHT_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'PACKET_ITEM') then begin
        packet_item = :data;
      end else if (:param_name = 'HRANI') then begin
        if (:data = -1) then err_code = -210;
        else begin
          id_service = :data;
          select m.IS_BOARD
          from   MEALS M
          where  M.ID_SERVICE = :id_service
          into   :is_board;
          id_board = :id_service;

          if ((:is_board = 1) and (:board_type = 'HRANI')) then err_code = -228;
          else if ((:is_board = 0) and (:board_type = 'BOARD')) then err_code = -229;
        end
      end
      if (:err_code < 0) then exit;
      if ((:id_tar_season <> -1) and (:iteration = 'MIDDLE')) then begin
        /* WE ARE STARTING THE SEASON PRICES SO: */
        if ((:id_board is null) or (:id_board = -1)) then err_code = -210;
        else if ((:separate_board = 0) and (:board_type = 'HRANI')) then err_code = -226;
        if (:err_code < 0) then exit;
        if ((:separate_board = 1) and (:board_type = 'HRANI')) then separate_board = 2;
        insert into TAR_BO_BOARD(ID_TAR_BOARD, ID_TAR_HEAD, ID_SERVICE, ID_BOARD, PTEXT, SEPARATE_BOARD,
                    PACKET_ITEM, DISC_TAG, SET_VAR, RND_METHOD)
        values (:id_tar_board, :id_tar_head, :id_service, :id_board, :ptext, :separate_board,
               :packet_item, :disc_tag, :set_var, :rnd_method);
        iteration = 'SEASON_PRICES';
      end
    end
    if (:iteration = 'SEASON_PRICES') then begin
      execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_board, :bo_type, :id_tar_season)
      returning_values  :err_code, :id_bo_price, :price_type;
      if (:price_type = 'EQUAL') then begin
        if (:board_type = 'HRANI') then err_code = -225;
        price_type_equal_exists = 1;
      end
      if (:err_code < 0) then exit;
    end
  end
  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:BO_TYPE||', '||:err_text;
  end
end
^

/* Alter (TAR_SAVE_BO_BP) */
ALTER PROCEDURE TAR_SAVE_BO_BP(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable no_use integer;
  declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable id_tar_season integer;
  declare variable iteration varchar(20);
/*****************************************************/
  declare variable id_tar_bp integer;
  declare variable position_number varchar(20);
  declare variable id_room_type integer;
  declare variable max_persons integer;
  declare variable id_board_include integer;
  declare variable is_price_for_room integer;
  declare variable ptext varchar(20);
  declare variable price_type varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable board_weight integer;
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :id_tar_season, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      param_filter = :data||season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      insert into TAR_BO_RELATION(ID_TAR_BP, BO_TYPE, ID_BO, PARAM_FILTER)
      values (:id_tar_bp, :bo_type, :id_tar_bp, :param_filter);
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_bp = gen_id(GEN_TAR_BO_BP_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      position_number = null;
      id_room_type = null;
      max_persons = null;
      id_board_include = -1;
      is_price_for_room = 0;
      ptext = '';
      disc_tag = 'B';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      packet_item = null;
    end
    if (:iteration = 'MIDDLE') then begin
      if (:param_name = 'BASE_POS')            then begin
        if (:data = '') then err_code = -203;
        else position_number = :data;
      end else if (:param_name = 'ROOM_TYPE')  then begin
        if (:data = '') then err_code = -204;
        else id_room_type = :data;
      end else if (:param_name = 'MAX_PERSONS')then begin
        if (:data = '') then err_code = -205;
        else max_persons = :data;
      end else if (:param_name = 'CHECKIN_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'NIGHT_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'BOARD')      then id_board_include = :data;
      else if (:param_name = 'BPRICE_ROOM')    then is_price_for_room = :data;
      else if (:param_name = 'PACKET_ITEM')    then packet_item = :data;
      else if (:param_name = 'PTEXT')          then ptext = :data;
      else if (:param_name = 'DISC_TAG')       then disc_tag = :data;
      else if (:param_name = 'SET_VAR')        then set_var = :data;
      else if (:param_name = 'ROUND_TYPE')     then rnd_method = :data;
      if (:err_code < 0) then exit;
      if ((:id_tar_season <> -1) and (:iteration = 'MIDDLE')) then begin
        /* WE ARE STARTING THE SEASON PRICES SO: */
        board_weight = null;
        select m.WEIGHT_TAG
        from   MEALS M
        where  m.ID_BOARD = :id_board_include
        into   :board_weight;
        board_weight = coalesce(:board_weight, 0);

        insert into TAR_BO_BASE_POSITION(
          ID_TAR_BP, ID_TAR_HEAD, POSITION_NUMBER, ID_ROOM_TYPE, MAX_PERSONS, SET_VAR, RND_METHOD,
          ID_BOARD_INCLUDE, BOARD_WEIGHT, IS_PRICE_FOR_ROOM, PTEXT, PACKET_ITEM, DISC_TAG)
        values (
          :id_tar_bp, :id_tar_head, :position_number, :id_room_type, :max_persons, :set_var, :rnd_method,
          :id_board_include, :board_weight, :is_price_for_room, :ptext, :packet_item, :disc_tag);
       iteration = 'SEASON_PRICES';
      end
    end
    if (:iteration = 'SEASON_PRICES') then begin
      execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_bp, :bo_type, :id_tar_season)
      returning_values  :err_code, :no_use, :price_type;
      if (:err_code < 0) then exit;
    end
  end
  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:BO_TYPE||', '||:err_text;
  end
end
^

/* Alter (TAR_SAVE_BO_DISC) */
ALTER PROCEDURE TAR_SAVE_BO_DISC(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_disc integer;
  declare variable pos_numbers varchar(2000);
  declare variable id_service integer;
  declare variable prioritet integer;
  declare variable day_scheme varchar(20);
  declare variable day_scheme_num integer;
  declare variable price_type varchar(20);
  declare variable price varchar(2000);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable calc_type varchar(20);
  declare variable calc_list varchar(2000);
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  err_text = '';
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      if (:price = '') then err_code = -219;
      if (:err_code < 0) then exit;
      rnd_method = iif(coalesce(:rnd_method, '') = '', 'NONE', :rnd_method);
      insert into TAR_BO_DISCOUNT (
        ID_TAR_DISCOUNT, ID_TAR_HEAD, PRIORITET, DAY_SCHEME, DAY_SCHEME_NUM, DISC_TAG, SET_VAR, RND_METHOD,
        /*IS_IN_BASE_PRICE,*/  CALC_LIST, ID_SERVICE, PTEXT, PACKET_ITEM)
      values (
        :id_tar_disc, :id_tar_head, :prioritet, :day_scheme, :day_scheme_num, :disc_tag, :set_var, :rnd_method,
        /*:in_base_price,*/ :calc_list, :id_service, :ptext, :packet_item);
      param_filter = :data||:season_filter;
      execute procedure tar_save_parse_param(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure tar_save_parse_pnum(:id_tar_head, :id_tar_disc, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_disc = gen_id(GEN_TAR_BO_DISCOUNT_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers   = '';
      id_service    = -1;
      day_scheme     = 'EVERY';
      day_scheme_num = 1;
      calc_type     = 'NONE';
      calc_list     = '';
      price         = '';
      prioritet     = 1;
      ptext         = '';
      disc_tag      = '';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      --in_base_price = 0;
      packet_item   = null;
    end
    if (:param_name = 'SERVICE')            then begin
      if (:data = '') then id_service = -1;
      else id_service = :data;
    end else if (:param_name = 'PTEXT')     then ptext = :data;
    else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
    else if (:param_name = 'SET_VAR')       then set_var = :data;
    else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
    else if (:param_name = 'PRIORITET')     then prioritet     = :data;
    --else if (:param_name = 'IN_BASE_PRICE') then in_base_price = :data;
    else if (:param_name = 'PACKET_ITEM')   then packet_item   = :data;
--    else if (:param_name = 'PRICE_NOTEQUAL') then begin
    else if (:param_name = 'PRICE_FORMULA') then begin
      price = trim(:data);
      /*if ((:id_service > 0) and (:in_base_price = 1) and (substring(:price from 1 for 1) = '-')) then err_code = -240;
      else*/ if (:price = '') then err_code = -219;
      else
        execute procedure tar_save_parse_price(:price, :id_tar_disc, :bo_type, -1)
        returning_values  :err_code, :no_use, :price_type;
    end else if (:param_name = 'LIST_BASE_POS') then pos_numbers   = :data;
    else if (:param_name = 'DAY_SCHEME') then begin
      execute procedure tar_save_parse_dayschm(:data)
      returning_values  :err_code, :day_scheme, :day_scheme_num;
    end else if (:param_name = 'CALC_TYPE') then begin
      calc_list = :data;
--      execute procedure tar_save_parse_calctype(:data)
--      returning_values  :err_code, :calc_type, :calc_list;
    end else if (:param_name = 'CHECKIN_SEASON') then begin
      execute procedure tar_save_parse_season(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end else if (:param_name = 'NIGHT_SEASON') then begin
      execute procedure tar_save_parse_season(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end
    if (:err_code < 0) then exit;
  end
/*  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
  end*/
end
^

/* Alter (TAR_SAVE_BO_DISC_PERIOD) */
ALTER PROCEDURE TAR_SAVE_BO_DISC_PERIOD(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_disc integer;
  declare variable pos_numbers varchar(2000);
  declare variable id_service integer;
  declare variable prioritet integer;
  declare variable calc_position varchar(20);
  declare variable price_type varchar(20);
  declare variable price varchar(2000);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable calc_list varchar(2000);
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  err_text = 'OBJECT='||:bo_type;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      if (:price = '') then err_code = -219;
      if (:calc_position = '') then err_code = -244;
      if (:err_code < 0) then exit;
      insert into TAR_BO_DISCOUNT_STAY (ID_TAR_DISCOUNT_STAY, ID_TAR_HEAD, PRIORITET, CALC_POSITION,
             CALC_LIST, ID_SERVICE, PTEXT, DISC_TAG, SET_VAR, RND_METHOD)
      values (:id_tar_disc, :id_tar_head, :prioritet, :calc_position,
             :calc_list, :id_service, :ptext, :disc_tag, :set_var, :rnd_method);

      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_disc, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration = 'MIDDLE';
      id_tar_disc = gen_id(GEN_TAR_BO_DISCOUNT_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers   = '';
      id_service    = -1;
      calc_list     = '';
      price         = '';
      prioritet     = 1;
      calc_position = 'GUEST_PERIOD';
      ptext         = '';
      disc_tag      = '';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
    end
    if (:param_name = 'SERVICE')            then begin
      if (:data = '') then id_service = -1;
      else id_service = :data;
    end else if (:param_name = 'PTEXT')     then ptext = :data;
    else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
    else if (:param_name = 'SET_VAR')       then set_var = :data;
    else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
    else if (:param_name = 'PRIORITET')     then prioritet     = :data;
    else if (:param_name = 'PERIOD_BASE_TYPE')    then calc_position = :data;
    else if (:param_name = 'PRICE_FORMULA') then begin
      price = trim(:data);
      if (:price = '') then err_code = -219;
      else begin
        execute procedure TAR_SAVE_PARSE_PRICE(:price, :id_tar_disc, :bo_type, -1)
        returning_values  :err_code, :no_use, :price_type;
        if (:err_code < 0) then exit;
      end
    end else if (:param_name = 'LIST_BASE_POS') then pos_numbers   = :data;
    else if (:param_name = 'CALC_TYPE') then begin
      calc_list = :data;
--      execute procedure tar_save_parse_calctype(:data)
--      returning_values  :err_code, :calc_type, :calc_list;
    end else if (:param_name = 'CHECKIN_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end else if (:param_name = 'NIGHT_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end
    if (:err_code < 0) then exit;
  end
  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
--    exception;
  end
end
^

/* Alter (TAR_SAVE_BO_EG) */
ALTER PROCEDURE TAR_SAVE_BO_EG(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable id_tar_season integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_eg integer;
  declare variable pos_numbers varchar(2000);
  declare variable min_payors integer;
  declare variable max_extra_guests integer;
  declare variable order_num integer; /* !!!! */
  declare variable id_price_bb integer;
  declare variable id_price_eb integer;
  declare variable price_type varchar(20);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable is_packet_reduction integer;
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :id_tar_season, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_eg, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_eg = gen_id(GEN_TAR_BO_EG_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers = '';
      min_payors  = null;
      id_price_eb = -1;
      id_price_bb = -1;
      order_num   = 99;
      ptext       = '';
      disc_tag    = '';
      set_var = '';
      is_packet_reduction = 0;
      rnd_method = 'MATH';
      season_filter = '';
      max_extra_guests = null;
      packet_item = null;
    end
    if (:iteration = 'MIDDLE') then begin
      if (:param_name = 'LIST_BASE_POS')   then pos_numbers = :data;
      else if (:param_name = 'SET_VAR')    then set_var = :data;
      else if (:param_name = 'ROUND_TYPE') then rnd_method = :data;
      else if (:param_name = 'MIN_PAYORS') then begin
        if (:data = '') then err_code = -213;
        else min_payors = :data;
      end else if (:param_name = 'MAX_EG') then begin
        if (:data = '') then err_code = -214;
        else max_extra_guests = :data;
      end else if (:param_name = 'EG_ORDER')   then begin
        if (:data = '') then order_num = 99;
        else order_num = :data;
        if (:order_num < 1) then err_code = -215;
      end else if (:param_name = 'CHECKIN_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'NIGHT_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'PTEXT')     then ptext = :data;
      else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
      else if (:param_name = 'EG_POST_TYPE')  then is_packet_reduction = :data;
      else if (:param_name = 'PACKET_ITEM')   then packet_item = :data;
      else if (:param_name = 'BB_PRICE')   then begin
        if (:data <> '') then begin
          execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_eg, :bo_type, -1)
          returning_values  :err_code, :id_price_bb, :price_type;
          if ((:board_type = 'HRANI') and (:price_type <> 'PERCENT')) then begin
            err_code = -227;
            exit;
          end
        end
      end else if (:param_name = 'EB_PRICE') then begin
        if (:data <> '') then begin
          execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_eg, :bo_type, -1)
          returning_values  :err_code, :id_price_eb, :price_type;
          if ((:board_type = 'HRANI') and (:price_type <> 'PERCENT')) then begin
            err_code = -227;
            exit;
          end
        end
      end
      if (:err_code < 0) then exit;
      if ((:id_tar_season <> -1) and (:iteration = 'MIDDLE')) then begin
        if (:min_payors is null) then err_code = -213;
        if (:max_extra_guests is null) then err_code = -214;
        if (:err_code < 0) then exit;
        /* WE ARE STARTING THE SEASON PRICES SO: */
        insert into TAR_BO_EXTRA_GUEST(
          ID_TAR_EG, ID_TAR_HEAD, MIN_PAYORS, MAX_EXTRA_GUESTS, EG_ORDER, IS_PACKET_REDUCTION,
          ID_PRICE_BB, ID_PRICE_EB, PTEXT, PACKET_ITEM, DISC_TAG, SET_VAR, RND_METHOD)
        values (
          :id_tar_eg, :id_tar_head, :min_payors, :max_extra_guests, :order_num, :is_packet_reduction,
          :id_price_bb, :id_price_eb, :ptext, :packet_item, :disc_tag, :set_var, :rnd_method);
        iteration = 'SEASON_PRICES';
      end
    end
    if (:iteration = 'SEASON_PRICES') then begin
      execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_eg, :bo_type, :id_tar_season)
      returning_values  :err_code, :no_use, :price_type;
      if (:err_code < 0) then exit;
    end
  end
  when any do begin
    err_code = -200;
    err_text = ''||:iteration||' '||:id_price_bb||' '||:id_price_eb;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
/*    err_text = ' '||:min_payors||' '||:max_extra_guests||' '||:order_num;*/
  end
end
^

/* Alter (TAR_SAVE_BO_PACK) */
ALTER PROCEDURE TAR_SAVE_BO_PACK(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable iteration varchar(20);
  declare variable no_use varchar(20);
/*****************************************************/
  declare variable id_tar_pack integer;
  declare variable pos_numbers varchar(2000);
  declare variable id_service integer;
  declare variable day_scheme varchar(20);
  declare variable day_scheme_num integer;
  declare variable cnt_post integer;
  declare variable pack_currency char(3);
  declare variable in_base_price integer;
  declare variable grp_rpt varchar(20);
  declare variable grp_docs varchar(20);
  declare variable price_type varchar(20);
  declare variable price_pack varchar(20);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      if (:price_pack = '') then err_code = -216;
      if (:id_service is null) then err_code = -217;
      if (:err_code < 0) then exit;
      insert into TAR_BO_PACK(
        ID_TAR_PACK, ID_TAR_HEAD, ID_SERVICE, PRICE_CURRENCY, IS_IN_BASE_PRICE,
        CNT_POST,  DAY_SCHEME, DAY_SCHEME_NUM, GRP_IN_REPORTS,
        GRP_IN_DOCUMENTS, PTEXT, PACKET_ITEM, DISC_TAG, SET_VAR, RND_METHOD)
      values (
        :id_tar_pack, :id_tar_head, :id_service, :pack_currency, :in_base_price,
        :cnt_post, :day_scheme, :day_scheme_num, :grp_rpt,
        :grp_docs, :ptext, :packet_item, :disc_tag, :set_var, :rnd_method);
      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_pack, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_pack = gen_id(GEN_TAR_BO_PACK_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers   = '';
      id_service    = null;
      day_scheme     = 'EVERY';
      day_scheme_num = 1;
      cnt_post      = 0;
/*
        select TH.TARIFA_CURR
        from   TAR_HEAD TH
        where  TH.ID_TAR_HEAD = :id_tar_head
        into   :pack_currency;
*/    pack_currency = '';
      in_base_price = 0;
      grp_rpt       = '';
      grp_docs      = '';
      price_pack    = '';
      ptext         = '';
      disc_tag      = '';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      packet_item   = null;
    end
    if (:param_name = 'SERVICE') then begin
      if ((:data = '') or (:data = '-1')) then err_code = -217;
      else if (:data = '0') then err_code = -222;
      else id_service = :data;
    end else if (:param_name = 'CNT_POST')  then cnt_post      = :data;
    else if (:param_name = 'IN_BASE_PRICE') then in_base_price = :data;
    else if (:param_name = 'GRP_RPT')       then grp_rpt       = :data;
    else if (:param_name = 'GRP_DOCS')      then grp_docs      = :data;
    else if (:param_name = 'PTEXT')         then ptext         = :data;
    else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
    else if (:param_name = 'SET_VAR')        then set_var = :data;
    else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
    else if (:param_name = 'PACKET_ITEM')   then packet_item   = :data;
    else if (:param_name = 'PRICE')         then begin
      price_pack    = :data;
      if (:price_pack = '') then err_code = -216;
      else
        execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_pack, :bo_type, -1)
        returning_values  :err_code, :no_use, :price_type;
    end else if (:param_name = 'LIST_BASE_POS') then pos_numbers   = :data;
    else if (:param_name = 'CURRENCY') then begin
      if ((:data <> upper(:data)) or (char_length(:data) <> 3)) then err_code = -218;
      else pack_currency = :data;
    end else if (:param_name = 'DAY_SCHEME') then begin
      execute procedure TAR_SAVE_PARSE_DAYSCHM(:data)
      returning_values  :err_code, :day_scheme, :day_scheme_num;
    end else if (:param_name = 'CHECKIN_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end else if (:param_name = 'NIGHT_SEASON') then begin
      execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
      returning_values  :err_code, :season_filter;
      if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
    end
    if (:err_code < 0) then exit;
  end
  when any do begin
    err_code = -200;
/*    err_text = ' '||:id_service||' '||:pack_currency||' '||:in_base_price;*/
/*    err_text = ' '||:day_scheme||' '||:day_scheme_num;*/
    err_text = ' '||:cnt_post||' '||:grp_rpt||' '||:grp_docs||' '||:ptext;
    err_text = 'OBJECT='||:bo_type||', '||:err_text;
  end
end
^

/* Alter (TAR_TEST$TAR) */
ALTER PROCEDURE TAR_TEST$TAR(NUMBER VARCHAR(62),
ID_TAR_HEAD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_reserv_detail integer;
begin
  id_tar_calc = -1 * :id_tar_head;
  delete from TAR_CALC_OUTPUT$TMP where id_tar_calc = :id_tar_calc;
  delete from TAR_CALC_INPUT$TMP  where id_tar_calc = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP  where id_tar_calc = :id_tar_calc;

  err_code = 0;

  id_reserv_detail = null;
  select RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.NUMBER = :number
         and rd.IS_ANUL = 0
  into   :id_reserv_detail;

  if (:id_reserv_detail is null) then begin
    select first 1 RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.NUMBER_2 = :number
           and rd.IS_ANUL = 0
    into   :id_reserv_detail;
  end

  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NEW_ROOM', :ID_TAR_HEAD);

  execute procedure TAR_CALC_EVAL_ALL$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;
end
^

/* Alter (UPDATE_BOOKING$EXC) */
ALTER PROCEDURE UPDATE_BOOKING$EXC(BOOKING_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE INTEGER,
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA_ID INTEGER,
POSTING_ROUTING VARCHAR(20),
ID_AGENT_ACCOUNT INTEGER,
RATE_ID INTEGER,
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD_CODE TFOOD_CODE,
ARRANGER_PROFILE_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable hotel_id integer;
  declare variable warn_code integer;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable rd_dbkey char(8);
  declare variable current_status_code smallint;
BEGIN
  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => START(' || :booking_id || ')');

  select RD.RDB$DB_KEY, RD.ID_HOTEL, RD.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :booking_id
  into  :rd_dbkey, :hotel_id, :current_status_code;

  execute procedure update_posting_transaction$exc(:rd_dbkey, :posting_transaction_uuid, 0);

  /* lock all guests */
  update guest set ORPHANED_IMPORT$EXC=1 where id_reserv_detail=:booking_id;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_GUARANTEE$RSV');
  execute procedure RES_SAVE_GUARANTEE$RSV(
    :booking_id, :is_vip, :current_status_code, :id_guarantee_policy,
    :deposit_required, :deposit_required_currency, :block_cc,
    :guarantee_deposit_percent, :guarantee_deposit_nights, :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_STAY$RSV');
  execute procedure RES_SAVE_STAY$RSV(
    :booking_id, :arrival, :departure, :is_late_departure,
    :arrival_type, 0
  ) returning_values :share_err_code, :err_text, :share_transaction_id, :warn_code;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_BOARD$INT');
  execute procedure RES_SAVE_BOARD$INT(
    :rd_dbkey, :board_id
  ) ;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_OTHER$RSV');
  execute procedure RES_SAVE_OTHER$RSV(
    :booking_id, :transfer_in_time, :transfer_in_note,
    :transfer_out_time, transfer_out_note, :first_food_code
  ) ;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_ROOM$EXC(room_type_id=>' || coalesce(:room_type_id, '<null>') || ')');
  execute procedure RES_SAVE_ROOM$EXC(
    :rd_dbkey, :room_type_id, :maintance_shema_id, :room_preferences, :special_treatment, :split_on_checkin
  ) returning_values :err_text, :warn_code, :share_transaction_id, :share_err_code;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_MARKETING$RSV');
  execute procedure RES_SAVE_MARKETING$RSV(
    :booking_id, :marketing1_id, :marketing2_id, :marketing3_id, :marketing4_id, :marketing5_id
  ) returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_RATE$RSV(:rate_id=>'
  || coalesce(:rate_id, '<null>')
  || ', :booking_id=>' || coalesce(:booking_id, '<null>')
  || ', :manual_price=>' || coalesce(:manual_price, '<null>')
  || ', :manual_price_currency=>' || coalesce(:manual_price_currency, '<null>')
  || ', :is_different_rate=>' || coalesce(:is_different_rate, '<null>')
  || ')');
  execute procedure RES_SAVE_RATE$RSV(
    :booking_id, :rate_id, :manual_price, :manual_price_currency,
    :is_different_rate, :is_different_price, 0
  );

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_VOUCHER$RSV');
  execute procedure RES_SAVE_VOUCHER$RSV(
    :booking_id, :voucher, :voucher_date, :voucher_text, null,  null
  );

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_NOTE$RSV');
  execute procedure RES_SAVE_NOTE$RSV(
    :booking_id, :note, :note_reminders);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_ACCOUNTING$RSV(arranger_profile_id=>'
    || coalesce(:arranger_profile_id, '<null>')
    || ', posting_routing=>' || coalesce(:posting_routing, '<null>')
    || ', id_agent_account=>' || coalesce(:id_agent_account, '<null>')
    || ')');
  execute procedure RES_SAVE_ACCOUNTING$INT(
    :rd_dbkey, :arranger_profile_id,
    :id_agent_account,
    :posting_routing,
    :guest_payment_type_id,
    :arranger_payment_type_id,
    :reserv_group_id
  ) ;

  /*execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_PACKET$RSV');
  execute procedure RES_SAVE_PACKET$RSV(
    :booking_id, :packet_id, 0
  );
  */
  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_EATING_OBJECT$RSV');
  execute procedure RES_SAVE_EATING_OBJECT$RSV(:booking_id, :id_eating_object);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => END(' || :booking_id || ')');
END
^

/* Restore proc. body: ACCOUNT_POSTING_TRANSFER$ACC */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
declare variable ap_dbkey char(8);
  declare variable transfer_value double precision;
  declare variable post_value double precision;
  declare variable id_account integer;
  declare variable tmp_id_account integer;
  declare variable curr_post varchar(3);
  declare variable acc_name varchar(50);
  declare variable action_text varchar(255);
  declare variable is_pms_account integer;
  declare variable dest_acc_name varchar(50);
begin

  id_account = null;
  transfer_value = 0;

  select ACC.ACCOUNT_NAME, acc.IS_PMS_ACCOUNT
  from   ACCOUNT ACC
  where  ACC.ID_ACCOUNT = :ID_DEST_ACCOUNT
  into   :dest_acc_name, is_pms_account;

  if (:is_pms_account = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('PMS_TRANSFER_POSTINGS');
  end

  for
    select AP.RDB$DB_KEY, AP.ID_ACCOUNT, ap.PRICE_POST * ap.QTY_POST
    from   ACCOUNT_POST AP
    where  AP.DOC_SELECTED = :DOC_SELECTED
           and AP.ID_ACCOUNT = coalesce(:ID_SRC_ACCOUNT, AP.ID_ACCOUNT)
           and AP.ID_ACCOUNT is distinct from :ID_DEST_ACCOUNT
    order by AP.ID_ACCOUNT asc
    into   :ap_dbkey, :tmp_id_account, :post_value
  do begin
    execute procedure ACCOUNT_POSTING_TRANSFER$INT (:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:id_account is null) then id_account = :tmp_id_account;

    /* update from/to pms account */
    execute procedure ACCOUNT_POST_EVENT_REROUTE$INT(:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:tmp_id_account is distinct from :id_account) then begin
      select A.ACCOUNT_NAME, A.ACCOUNT_CURR
      from   ACCOUNT A
      where  A.ID_ACCOUNT = :id_account
      into   :acc_name, :curr_post;

      action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                    f_character(28) || :id_account || '/' || :acc_name ||
                    f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
      execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
      id_account = :tmp_id_account;
      transfer_value = 0;
    end
    transfer_value = :transfer_value + :post_value;
  end

  if (:id_account is not null) then begin
    select A.ACCOUNT_NAME, A.ACCOUNT_CURR
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :acc_name, :curr_post;
  
    action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                  f_character(28) || :id_account || '/' || :acc_name ||
                  f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
  end
end
^

/* Restore proc. body: BLOCK_CREATE$BLK */
ALTER PROCEDURE BLOCK_CREATE$BLK(ROOM_NAMES TYPE OF TDESCRIPTION_LONG,
ID_HOTEL TYPE OF ID,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
BLOCK_GRP TYPE OF TRANGE,
REASON TYPE OF TREASON,
NOTE TYPE OF TDESCRIPTION_LONG,
IS_FULL_FROM TYPE OF TRANGE,
IS_FULL_TO TYPE OF TRANGE)
 RETURNS(NEW_ID_BLOCK_ROOM TYPE OF ID,
SHARE_TRANSACTION_ID TYPE OF ID,
SHARE_ERR_CODE TYPE OF ID,
ERR_TEXT VARCHAR(255),
WARN_CODE TYPE OF ID,
NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable room_name varchar(50);
  declare variable id_room integer;
  declare variable action_text varchar(255);
  declare variable block_name varchar(30);
begin
  id_room = null;
  warn_code = null;
  SHARE_ERR_CODE = 0;

  for
    select ITEM
    from   SYSTEM_STRING_PARSER(:room_names, ',')
    into   :room_name
  do begin
    id_room = null;
    select R.ID_ROOM
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ROOM_NAME = :room_name
           and RT.ID_HOTEL = :id_hotel
    into   :id_room;

    if (:id_room is null) then exception BLOCK_EXCEPTION '-5' || f_character(31) || :room_name;

    execute procedure BLOCK_MODIFY$INT(null, :id_room, :from_date, :to_date, :block_grp,
                      :reason, :note, 'add')
    returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :err_text, :warn_code;

    block_name = iif(:block_grp = 18, 'OUT OF ORDER', 'OUT OF INVENTORY');
    action_text = f_character(29) || :room_name
                  || f_character(28) || formatdate(:from_date, 'D;dd.mm.yyyy') || '-' || formatdate(:to_date, 'D;dd.mm.yyyy')
                  || f_character(28) || :block_name;
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :new_id_block_room, 'BLOCK_ROOM', :action_text);

  end

  select cast('31.12.1899' as date) + count(b.ID_BLOCK_ROOM)
  from   BLOCK_ROOM b
  where  b.ID_ROOM is not null
  into   :NEW_FROM_DATE;
end
^

/* Restore proc. body: BLOCK_MODIFY$BLK */
ALTER PROCEDURE BLOCK_MODIFY$BLK(ID_BLOCK_ROOM INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
BLOCK_GRP INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
IS_FULL_FROM INTEGER,
IS_FULL_TO INTEGER)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable new_id_block_room integer;
  declare variable action_text varchar(255);
  declare variable old_from_date date;
  declare variable old_to_date date;
  declare variable old_group integer;
  declare variable room_name varchar(10);
  declare variable block_name varchar(30);
begin
  --  IS_FULL_FROM  - deprecated
  --  IS_FULL_TO  - deprecated

  select BR.FROM_DATE, BR.TO_DATE, BR.BLOCK_GRP, R.ROOM_NAME
  from   BLOCK_ROOM BR
         join ROOMS R on R.ID_ROOM = BR.ID_ROOM
  where  BR.ID_BLOCK_ROOM = :ID_BLOCK_ROOM              
  into   :old_from_date, :old_to_date, :old_group, :room_name;

  execute procedure BLOCK_MODIFY$INT(:id_block_room, :id_room, :from_date, :to_date, :block_grp,
                    :reason, :note, 'mod')
  returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :err_text, :warn_code;

  if ( (:old_from_date <> :FROM_DATE) or (:old_to_date <> :TO_DATE) or (:old_group <> :BLOCK_GRP) ) then begin
    block_name = iif(:block_grp = 18, 'OUT OF ORDER', 'OUT OF INVENTORY');
    action_text = f_character(29) || :room_name
                  || f_character(28) || formatdate(:FROM_DATE, 'D;dd.mm.yyyy') || '-' || formatdate(:TO_DATE, 'D;dd.mm.yyyy')
                  || f_character(28) || :block_name;
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :NEW_ID_BLOCK_ROOM, 'EDIT_BLOCK', :action_text);
  end
end
^

/* Restore proc. body: DEFAULT_BOOKING_VALUES$EXC */
ALTER PROCEDURE DEFAULT_BOOKING_VALUES$EXC(BOOKING_DBKEY CHAR(8),
HOTEL_ID INTEGER,
RATE_ID_IN INTEGER,
ROOM_TYPE_ID_IN INTEGER,
BOARD_ID_IN INTEGER,
MAINTANCE_SHEMA_ID_IN INTEGER,
ARRANGER_PAYMENT_TYPE_ID_IN INTEGER,
GUEST_PAYMENT_TYPE_ID_IN INTEGER,
MARKETING1_ID_IN INTEGER,
MARKETING2_ID_IN INTEGER,
MARKETING3_ID_IN INTEGER,
MARKETING4_ID_IN INTEGER,
MARKETING5_ID_IN INTEGER,
ARRANGER_PROFILE_ID_IN INTEGER,
MAIN_GUEST_PROFILE_ID_IN INTEGER,
POSTING_ROUTING_IN VARCHAR(50),
FIRST_FOOD_CODE_IN TFOOD_CODE,
GUARANTEE_POLICY_ID_IN INTEGER,
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_LATE_DEPARTURE_IN INTEGER,
EATING_OBJECT_ID_IN INTEGER)
 RETURNS(RATE_ID INTEGER,
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
MAINTANCE_SHEMA_ID INTEGER,
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
ARRANGER_PROFILE_ID INTEGER,
ARRANGER_ACCOUNT_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
POSTING_ROUTING VARCHAR(50),
FIRST_FOOD_CODE TFOOD_CODE,
GUARANTEE_POLICY_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_LATE_DEPARTURE INTEGER,
EATING_OBJECT_ID INTEGER)
 AS
declare variable arrival_date_def date;
  declare variable departure_date_def date;
  declare variable adult_count_def integer;
  declare variable child_count_def integer;
  declare variable id_room_def integer;
  declare variable custom_price_def numeric(15,4);
  declare variable custom_currency_def char(3);
  declare variable voucher_num_def varchar(30);
  declare variable voucher_date_def date;
  declare variable voucher_text_def varchar(30);
  declare variable voucher2_num_def varchar(30);
  declare variable voucher2_date_def date;
  declare variable transfer_in_time_def timestamp;
  declare variable transfer_in_note_def varchar(30);
  declare variable transfer_out_time_def timestamp;
  declare variable transfer_out_note_def varchar(30);
  declare variable is_late_departure_def integer;
  declare variable country_code_def varchar(20);
  declare variable check_status_def integer;
  declare variable id_acc_template_person_def integer;
  declare variable arranger_marketing1_id integer;
  declare variable arranger_rate_id integer;
  declare variable arranger_maintance_shema_id integer;
  declare variable deposit_def numeric(15,4);
  declare variable deposit_currency_def char(3);
  declare variable group_name_old varchar(50);
  declare variable group_uuid_old varchar(40);
begin
  if (:booking_dbkey is null) then begin
    execute procedure RES_CREATE_GET$RSV (:hotel_id)
    returning_values
      :arrival_date_def,
      :departure_date_def,
      :arranger_profile_id,
      :main_guest_profile_id,
      :adult_count_def,
      :child_count_def,
      :room_type_id,
      :id_room_def,
      :board_id,
      :rate_id,
      :custom_price_def,
      :custom_currency_def,
      :voucher_num_def,
      :voucher_date_def,
      :voucher_text_def,
      :voucher2_num_def,
      :voucher2_date_def,
      :transfer_in_time_def,
      :transfer_in_note_def,
      :transfer_out_time_def,
      :transfer_out_note_def,
      :is_late_departure_def,
      :first_food_code,
      :country_code_def,
      :marketing1_id,
      :marketing2_id,
      :marketing3_id,
      :marketing4_id,
      :marketing5_id,
      :arranger_account_id,
      :posting_routing,
      :guest_payment_type_id,
      :arranger_payment_type_id,
      :check_status_def,
      :maintance_shema_id,
      :deposit_def,
      :deposit_currency_def,
      :id_acc_template_person_def,
      :guarantee_policy_id,
      :eating_object_id;
  end else begin
    select RD.id_rate, rd.id_room_type, rd.id_board, rd.id_hk_plan,
      rd.id_agent_payment, rd.id_person_payment, rd.id_nom_market_segment,
      rd.id_nom_source_code, rd.id_nom_channel_code, rd.id_nom_hear_reason,
      rd.id_nom_come_reason, rd.id_agent_profile, rd.id_person_profile,
      rd.acc_routing, rd.id_agent_account_rule, rd.code_first_food,
      rd.id_guarantee_policy, rg.group_name, rg.uuid, (rd.leaving_kind - 1) as is_late_departure
    from   RESERV_DETAIL RD
    left outer join reserv_group rg on rg.id_reserv_group=rd.id_group
    where  RD.RDB$DB_KEY = :booking_dbkey
    into  :rate_id, :room_type_id, :board_id, :maintance_shema_id,
      :arranger_payment_type_id, :guest_payment_type_id, :marketing1_id,
      :marketing2_id, :marketing3_id, :marketing4_id,
      :marketing5_id, :arranger_profile_id, :main_guest_profile_id,
      :posting_routing, :arranger_account_id, :first_food_code,
      :guarantee_policy_id, :group_name_old, :group_uuid_old, :is_late_departure_def;
  end

  /* MERGE ARRANGER PROFILE VALUE  */
  arranger_profile_id = coalesce(:arranger_profile_id_in, :arranger_profile_id);
  posting_routing = coalesce(:posting_routing_in, :posting_routing);

  /* APPLY ARRANGER DEFAULTS TO NEW BOOKINGS */
  if ((:booking_dbkey is null) and (:arranger_profile_id is not null)) then begin
    select p.id_nom_market_segment,
           (select min(id_tariff)
            from profile_hotel_rate aa
            where aa.id_hotel=:hotel_id and aa.id_profile = p.ID_PROFILE
            group by aa.id_profile
            having count(aa.id_profile)=1) as rate_id,
           pbd.ID_HK_PLAN
    from   profile p
    left outer join PROFILE_BOOKING_DEFAULTS pbd on pbd.ID_PROFILE = p.id_profile and pbd.ID_HOTEL = :hotel_id
    where p.id_profile=:arranger_profile_id
    into :arranger_marketing1_id, :arranger_rate_id, :arranger_maintance_shema_id;
    
    marketing1_id = coalesce(:arranger_marketing1_id, :marketing1_id);
    rate_id = coalesce(:arranger_rate_id, :rate_id);
    maintance_shema_id = coalesce(:arranger_maintance_shema_id, :maintance_shema_id);

    if (upper(:posting_routing) in ('AGENT', 'MIXED')) then begin
      select first 1 a.id_account
      from account a
      where
        a.id_profile = :arranger_profile_id
        and a.id_hotel=:hotel_id
        and a.is_credit_account=1
        and a.is_default=1
      into :arranger_account_id;
    end
  end

  /* MERGE THE REST OF THE *_IN VALUES */
  rate_id = coalesce(:rate_id_in, :rate_id);
  room_type_id = coalesce(:room_type_id_in, :room_type_id);
  board_id = coalesce(:board_id_in, :board_id);
  maintance_shema_id = coalesce(:maintance_shema_id_in, :maintance_shema_id);
  arranger_payment_type_id = coalesce(:arranger_payment_type_id_in, :arranger_payment_type_id);
  guest_payment_type_id = coalesce(:guest_payment_type_id_in, :guest_payment_type_id);
  marketing1_id = coalesce(:marketing1_id_in, :marketing1_id);
  marketing2_id = coalesce(:marketing2_id_in, :marketing2_id);
  marketing3_id = coalesce(:marketing3_id_in, :marketing3_id);
  marketing4_id = coalesce(:marketing4_id_in, :marketing4_id);
  marketing5_id = coalesce(:marketing5_id_in, :marketing5_id);
  main_guest_profile_id = coalesce(:main_guest_profile_id_in, :main_guest_profile_id);
  first_food_code = coalesce(:first_food_code_in, :first_food_code);
  guarantee_policy_id = coalesce(:guarantee_policy_id_in, :guarantee_policy_id);
  group_name = coalesce(:group_name, :group_name_old);
  group_uuid = coalesce(:group_uuid, :group_uuid_old);
  is_late_departure = coalesce(:is_late_departure_in, :is_late_departure_def);
  eating_object_id = coalesce(:eating_object_id_in, :eating_object_id);

  execute procedure sys_dbg('exc DEFAULT_BOOKING_VALUES$EXC => IMPORT_GROUP$EXC');
  execute procedure IMPORT_GROUP$EXC(:hotel_id, :group_uuid, :group_name)
  returning_values :reserv_group_id;
end
^

/* Restore proc. body: DEPOSIT_REFUND$DOC */
ALTER PROCEDURE DEPOSIT_REFUND$DOC(ID_DEPOSIT INTEGER,
REFUND_AMOUNT NUMERIC(15,4),
REFUND_CURRENCY VARCHAR(3),
ID_PAY_DOC_TYPE INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_REFUND_PAYMENT INTEGER,
ID_STORNO_DOC INTEGER,
WARN_CODE INTEGER)
 AS
declare variable no_use varchar(2000);
  declare variable id_account integer;
  declare variable avail_value numeric(15,4);
  declare variable id_doc_head integer;
  declare variable pay_currency varchar(3);
  declare variable pay_rate numeric(15,6);
  declare variable sys_date date;
  declare variable round_to numeric(15,4);
  declare variable p_dbkey char(8);
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable id_account_payment integer;
  declare variable id_doc_type integer;
  declare variable account_curr varchar(3);
  declare variable account_rate numeric(15,6);
  declare variable id_reserv_detail integer;
  declare variable is_posting_stopped integer;
  declare variable firm_data type of tnote_blob;
begin
  WARN_CODE = null;
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_REFUND');

  select D.ID_ACCOUNT, DH.ID_DOC, dh.ID_DOC_TYPE, c.ROUND_TO, d.ID_RESERV_DETAIL,
         D.AVAIL_VALUE, D.PAY_CURRENCY, D.PAY_RATE, A.ID_HOTEL, A.ACCOUNT_CURR
  from   DEPOSIT_AVAILABLE D
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join CURRS C on c.CURR = d.PAY_CURRENCY
         left outer join DOC_HEAD DH on DH.ID_DOC = D.ID_DOC_HEAD
                                        and DH.IS_STORNED = 0
                                        and DH.IS_ANUL = 0
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_account, :id_doc_head, :id_doc_type, :round_to, :id_reserv_detail,
         :avail_value, :pay_currency, :pay_rate, :id_hotel, :account_curr;

  if (:pay_currency is distinct from :refund_currency) then exception PAYMENT_EXCEPTION 'Currency mismatch!';

  if (round_f(:avail_value - :REFUND_AMOUNT, :round_to) < 0) then exception PAYMENT_EXCEPTION '-305';
  --'Issued value is more than available deposit amount.';

  select r.IS_POSTING_STOPPED
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :is_posting_stopped;

  if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';

  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET(:id_hotel) SD
  into   :sys_date;

  select first 1 ap.ACC_RATE
  from   ACCOUNT_PAYMENTS ap
  where  ap.ID_DEPOSIT = :ID_DEPOSIT
  order by ap.ID_ACCOUNT_PAYMENT asc
  into   :account_rate;

  execute procedure PAYMENT_CREATE$INT (:ID_PAY_DOC_TYPE, :ID_ACCOUNT, :SYS_DATE,
          -:REFUND_AMOUNT, :PAY_CURRENCY, :PAY_RATE, :account_curr, :account_rate, :DESCRIPTION)
  returning_values  (:id_refund_payment, :id_account_payment, :no_use);

  insert into DEPOSIT_REFUND (ID_DEPOSIT, ID_PAYMENT_HEAD, DESCRIPTION)
  values (:ID_DEPOSIT, :ID_REFUND_PAYMENT, :DESCRIPTION);

  update ACCOUNT_PAYMENTS AP
  set    AP.ID_DEPOSIT = :ID_DEPOSIT
  where  ap.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT;

  if (:ID_DOC_HEAD is not null) then begin
    execute procedure DOC_TYPE_EVALUATE$INT (:id_doc_type, :id_hotel, 0, :ID_REFUND_PAYMENT);

    execute procedure DOCUMENT_ADVANCE_STORNO$INT (:ID_DEPOSIT, :REFUND_AMOUNT, :DESCRIPTION)
    returning_values  (:ID_STORNO_DOC, :WARN_CODE);

    execute procedure DOCUMENT_ATTACH_PAYMENT$INT (:ID_STORNO_DOC, :id_account_payment, :pay_rate, null)
    returning_values :no_use;
     
    update  PAYMENT_HEAD P
    set     P.ID_DOC_HEAD = :ID_STORNO_DOC
    where   P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT;

    execute procedure DOCUMENT_VALIDATE$DOC (:ID_STORNO_DOC)
    returning_values (:firm_data, :no_use, :no_use);
  end else begin
    select P.RDB$DB_KEY
    from   PAYMENT_HEAD P
    where  P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT
    into   :P_DBKEY;
     
    execute procedure PAYMENT_SET_NUMBER$INT (:P_DBKEY);
  end

  action_text = F_CHARACTER(29) || :REFUND_AMOUNT || ' ' || :PAY_CURRENCY;
  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'REFUND', :ACTION_TEXT);
end
^

/* Restore proc. body: DEVICE_READING_POST$PMS */
ALTER PROCEDURE DEVICE_READING_POST$PMS(ID_DEVICE_READING TYPE OF ID)
 AS
declare variable id_service type of id_ref;
  declare variable post_value type of tprice;
  declare variable curr type of tcurrency;
  declare variable id_room type of id_ref;
  declare variable is_client_acc_post type of tlogical;
  declare variable date_post tdate;
  declare variable id_account_post id_ref;
  declare variable id_account_post$pms id_ref;
  declare variable id_device_reading_evidence id_ref;
  declare variable descr tdescription_long;
begin
  if(exists(select DR.ID_DEVICE_READING
            from   DEVICE_READING DR
            where  DR.ID_DEVICE_READING = :id_device_reading
                   and dr.status = 1)) then exception assert '-1051';
  for
    select CDC.ID_SERVICE,
           sum((CDC.QTY * cast(coalesce(CDC.UNIT_PRICE, 0) as double precision)) + coalesce(CDC.PRICE, 0)),
           CDC.CURR, D.ID_ROOM, CDC.IS_CLIENT_ACC_POST, DR.DATE_POST, DRQ.ID_DEVICE_READING_EVIDENCE,
           substring(list(coalesce(CDC.price || '+', '') || '(' || CDC.QTY || ' ' || coalesce(DT.MEASURE, '') || ' x '
                          || coalesce(CDC.UNIT_PRICE, 0) || ') ' || CDC.CURR) from 1 for 255)
    from DEVICE_READING DR
         join DEVICE_READING_EVIDENCE DRQ on DRQ.ID_DEVICE_READING = DR.ID_DEVICE_READING
         join DEVICE D on D.ID_DEVICE = DRQ.ID_DEVICE
         join DEVICE_TYPE DT on DT.ID_DEVICE_TYPE = D.ID_DEVICE_TYPE
         left outer join CREATE_DEVICE_CALC (D.ID_DEVICE_TYPE, DR.DATE_POST, DRQ.NEW_EVIDENCE - DRQ.OLD_EVIDENCE) CDC on 1=1
    where DR.ID_DEVICE_READING = :id_device_reading
    group by 1, 3, 4, 5, 6, 7
    into  :id_service, :post_value, :curr, :id_room, :is_client_acc_post, :date_post,
          :id_device_reading_evidence, :descr
  do begin
    if (coalesce(:post_value, -1) >= 0) then begin
      for
        select PEP.NEW_ID_ACCOUNT_POST, PEP.NEW_ID_ACCOUNT_POST$PMS
        from   PMS_EXPENSE_POSTS_CREATE$INT(:ID_ROOM, null, null, :ID_SERVICE, :CURR, :POST_VALUE,
                                            :IS_CLIENT_ACC_POST, :DATE_POST, :DESCR, 0) PEP
        into   :id_account_post, :id_account_post$pms
      do begin
        insert into DEVICE_READING_POST (ID_DEVICE_READING_EVIDENCE, ID_ACCOUNT_POST,
               ID_ACCOUNT_POST$PMS)
        values (:ID_DEVICE_READING_EVIDENCE, :ID_ACCOUNT_POST, :ID_ACCOUNT_POST$PMS);
      end
    end
  end
  update DEVICE_READING DR
  set    DR.STATUS = 1
  where  DR.ID_DEVICE_READING = :id_device_reading;
end
^

/* Restore proc. body: DOCUMENT_ADD_DEF_PAYMENT$DOC */
ALTER PROCEDURE DOCUMENT_ADD_DEF_PAYMENT$DOC(ID_DOC_HEAD INTEGER,
ID_PAY_DOC_TYPE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable pay_curr varchar(3);
  declare variable doc_curr varchar(3);
  declare variable id_account integer;
  declare variable doc_sub_type integer;
  declare variable id_base_doc integer;
  declare variable paydocs_cnt integer;
  declare variable id_payment_head integer;
  declare variable storno_amount numeric(15,4);
  declare variable rest_value numeric(15,4);
  declare variable doc_rnd_to numeric(15,4);
  declare variable doc_value numeric(15,4);
  declare variable pay_rate numeric(15,6);
  declare variable doc_rate numeric(15,6);
  declare variable extra_info_needed smallint;
  declare variable id_doc_type integer;
begin                         /* create payment */
  PAY_CURR = null;
  select D.ID_ACCOUNT, D.DOC_SUB_TYPE, D.ID_BASE_DOC,
         D.DOC_CURRENCY, D.DOC_VALUE_A, d.DOC_RATE, d.ID_DOC_TYPE
  from   DOC_HEAD D
         join DOC_TYPE DT on dt.ID_DOC_TYPE = d.ID_DOC_TYPE
  where  D.ID_DOC = :ID_DOC_HEAD
  into   :id_account, :doc_sub_type, :id_base_doc,
         :doc_curr, :doc_value, :doc_rate, :id_doc_type;

  if (:doc_sub_type < 2) then begin
    if (:ID_PAY_DOC_TYPE is null) then begin
      /* = case */
      execute procedure PAYMENT_GET_DEFAULT$INT (:ID_ACCOUNT)
      returning_values  (:ID_PAY_DOC_TYPE, :pay_curr);

      if (:pay_curr <> :doc_curr) then begin
        execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, null)
        returning_values  (:dbg, :dbg, :dbg, :dbg, :rest_value);

        select C.ROUND_TO
        from   CURRS C
        where  C.CURR = :DOC_CURR
        into   :doc_rnd_to;
         
        if (:REST_VALUE = :DOC_RND_TO) then begin
          select iif(pdt.CURRENCY_LIST containing :doc_curr, :doc_curr, null)
          from   DOC_TYPE pdt
          where  pdt.ID_DOC_TYPE = :ID_DOC_TYPE
          into   :pay_curr;
        end
      end
    end else begin
      select  PDT.DEF_CURRENCY
      from    PAY_DOC_TYPE_S PDT
      where   PDT.ID_DOC_TYPE = :ID_PAY_DOC_TYPE
              and PDT.IS_ARCHIVE = 0
              and PDT.DOC_DIRECTION = 1
      into    :PAY_CURR;
    end

    if (:ID_PAY_DOC_TYPE is not null and :PAY_CURR is not null) then begin
      select coalesce(dtp.IS_CC, 0) + coalesce(dtp.IS_AR_DEBT, 0)
      from   DOC_TYPE_PAY DTp
      where  DTP.ID_DOC_TYPE = :ID_PAY_DOC_TYPE
      into   :extra_info_needed;

      if (:extra_info_needed = 0) then begin
        execute procedure DOCUMENT_ADD_PAYMENT$DOC (:ID_DOC_HEAD, :ID_PAY_DOC_TYPE, null, :PAY_CURR, '')
        returning_values :DBG;
      end
    end
  end else begin
    select count(P.ID_PAYMENT_HEAD)
    from   PAYMENT_HEAD P
    where  P.ID_DOC_HEAD = :ID_BASE_DOC
    into   :PAYDOCS_CNT;

    if (:PAYDOCS_CNT = 1) then begin
      select P.ID_PAYMENT_HEAD, P.PAY_CURRENCY, P.PAY_RATE
      from   PAYMENT_HEAD P
      where  P.ID_DOC_HEAD = :ID_BASE_DOC
      into   :id_payment_head, :pay_curr, :pay_rate;

      if (:pay_curr = :doc_curr) then pay_rate = :doc_rate;
      execute procedure DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, :pay_curr, :pay_rate)
      returning_values  (:dbg, :dbg, :dbg, :dbg, :rest_value);

      STORNO_AMOUNT = -:REST_VALUE;

      execute procedure PAYMENT_STORNO$INT (:ID_PAYMENT_HEAD, :ID_ACCOUNT, :ID_DOC_HEAD, :STORNO_AMOUNT, '', :DOC_VALUE)
      returning_values  :DBG;

      when any do exit;
       
    end
  end
end
^

/* Restore proc. body: DOCUMENT_ADD_DISCOUNTS$INT */
ALTER PROCEDURE DOCUMENT_ADD_DISCOUNTS$INT(ID_DOC_HEAD TYPE OF ID,
ID_ACCOUNT TYPE OF ID)
 AS
declare variable sys_date date;
  declare variable doc_round_to numeric(15,4);
  declare variable nat_curr_round_to numeric(15,4);
  declare variable sec_curr_round_to numeric(15,4);
  declare variable id_doc_line integer;
  declare variable id_service integer;
  declare variable service_name varchar(50);
  declare variable single_value numeric(15,4);
  declare variable nat_gross_value numeric(15,4);
  declare variable sec_curr_gross_value numeric(15,4);
  declare variable id_hotel integer;
  declare variable df_dbkey char(8);
  declare variable discount_calc_method varchar(50);
  declare variable footer_value double precision;
  declare variable id_sale_taxation integer;
  declare variable id_tax_policy integer;
  declare variable id_profile integer;
  declare variable discount_value numeric(15,4);
  declare variable doc_curr varchar(3);
  declare variable sec_curr varchar(3);
  declare variable doc_curr_rate numeric(15,6);
  declare variable sec_curr_rate numeric(15,6);
  declare variable no_use varchar(255);
begin
  /* GET SOME SETTINGS VALUES *************************************************/
  select A.ID_HOTEL, A.ID_TAX_POLICY, A.ID_PROFILE
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :id_hotel, :id_tax_policy, :id_profile;

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values :sys_date;

  execute procedure DOCUMENT_CURRS_GET$INT (:ID_DOC_HEAD)
  returning_values (:doc_curr, :doc_curr_rate, :doc_round_to, :no_use, :nat_curr_round_to,
                    :sec_curr, :sec_curr_rate, :sec_curr_round_to);
  /* CALC DOCUMENT DISCOUNTS ******************************************************/
  execute procedure DOCUMENT_CALC_DISCOUNTS$INT (:ID_DOC_HEAD, :doc_curr, :sec_curr, :id_profile, :id_hotel);

  for
    select df.RDB$DB_KEY, df.FOOTER_VALUE, sd.DISCOUNT_CALC_METHOD, tp.ID_SALE_TAXATION,
           sd.ID_SERVICE, s.SERVICE_NAME, sd.DISCOUNT_VALUE, df.SECOND_CURR_DISCOUNT_VALUE
    from   DOC_FOOTER DF
           join SALE_DISCOUNT SD on sd.ID_SALE_DISCOUNT = df.ID_TAX
           left outer join SERVICES S on S.ID_SERVICE = SD.ID_SERVICE
           left outer join SERVICE_TAXATION TP on tp.ID_SERVICE = sd.ID_SERVICE and tp.ID_TAX_POLICY = :id_tax_policy
    where  DF.ID_DOC_HEAD = :ID_DOC_HEAD
           and sd.DISCOUNTED_VALUE_TYPE = 'taxableValue'
    into   :df_dbkey, :footer_value, :discount_calc_method, :id_sale_taxation,
           :id_service, :service_name, :discount_value, :sec_curr_gross_value
  do begin
    single_value = round_f(:footer_value, :doc_round_to);
    id_doc_line = null;

    nat_gross_value = round_f(:footer_value * :doc_curr_rate, :nat_curr_round_to);
    --sec_curr_gross_value = round_f(:footer_value * cast(:doc_curr_rate / :sec_curr_rate as double precision), :sec_curr_round_to);
    sec_curr_gross_value = round_f(:sec_curr_gross_value, :sec_curr_round_to);

    execute procedure DOCUMENT_LINE_ADD$INT (
            :ID_DOC_HEAD, :id_service, :id_sale_taxation,
            :service_name || ' ' || iif(:discount_calc_method = 'fixedValue', '', ' ' || formatfloat(:discount_value, '0.00') ||' %'),
            -1, :sys_date, :sys_date, :sys_date, null,
            1, :footer_value, :single_value, :doc_round_to, :nat_gross_value, :nat_curr_round_to,
            :sec_curr, :sec_curr_gross_value, :sec_curr_round_to, iif(:single_value >= 0, 2, 3),
            0, null)
    returning_values (:id_doc_line, :no_use, :no_use, :no_use);

    update DOC_FOOTER df
    set    df.ID_DOC_LINE = :id_doc_line
    where  df.RDB$DB_KEY = :df_dbkey;
  end 

end
^

/* Restore proc. body: DOCUMENT_ADD_PAY_TAXES$INT */
ALTER PROCEDURE DOCUMENT_ADD_PAY_TAXES$INT(ID_DOC_HEAD INTEGER,
ID_PAYMENT_HEAD INTEGER,
ID_TAX_POLICY INTEGER,
DOC_DATE DATE)
 AS
declare variable id_service integer;
  declare variable id_sale_taxation integer;
  declare variable tax_value numeric(15,4);
  declare variable single_value numeric(15,4);
  declare variable nat_gross_value numeric(15,4);
  declare variable sec_gross_value numeric(15,4);
  declare variable wot_diff double precision ;
  declare variable service_name varchar(50);
  declare variable id_doc_line integer;
  declare variable nat_round_to numeric(15,4);
  declare variable doc_round_to numeric(15,4);
  declare variable sec_round_to numeric(15,4);
  declare variable id_payment_footer integer;
  declare variable pay_rate numeric(15,6);
  declare variable doc_rate numeric(15,6);
  declare variable sec_curr_rate numeric(15,6);
  declare variable sec_curr varchar(3);
  declare variable no_use varchar(255);
begin
  execute procedure DOCUMENT_CURRS_GET$INT (:ID_DOC_HEAD)
  returning_values (:no_use, :doc_rate, :doc_round_to, :no_use, :nat_round_to,
                   :sec_curr, :sec_curr_rate, :sec_round_to);
  /* calc pay doc taxes */
  for
    select PF.ID_PAYMENT_FOOTER, PF.ID_SERVICE, PF.TAX_VALUE,
           PF.LINE_NAME, P.PAY_RATE
    from   PAYMENT_FOOTER PF
           join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = PF.ID_PAYMENT_HEAD
    where  P.ID_PAYMENT_HEAD = :id_payment_head
    into   :id_payment_footer, :id_service, :tax_value,
           :service_name, :pay_rate
  do begin
    /* tax value is in payment currency  */
    wot_diff = :tax_value * cast(:pay_rate/:doc_rate as double precision);
    single_value = round_f(:wot_diff, :doc_round_to);
                                                     
    select T.ID_SALE_TAXATION
    from   SERVICE_TAXATION T
    where  T.ID_SERVICE = :id_service
           and T.ID_TAX_POLICY = :ID_TAX_POLICY
    into   :id_sale_taxation;
     
    nat_gross_value = round_f(:wot_diff * :doc_rate, :nat_round_to);
    sec_gross_value = round_f(:wot_diff * cast(:doc_rate / :sec_curr_rate as double precision), :sec_round_to);

    execute procedure DOCUMENT_LINE_ADD$INT (:ID_DOC_HEAD, :id_service, :id_sale_taxation,
            :service_name, -1, :DOC_DATE, :DOC_DATE, :DOC_DATE, null,
            1, :wot_diff, :single_value, :doc_round_to, :nat_gross_value, :nat_round_to,
            :sec_curr, :sec_gross_value, :sec_round_to, iif(:single_value >= 0, 4, 5),
            0, null)
    returning_values (:id_doc_line, :no_use, :no_use, :no_use);

    update PAYMENT_FOOTER F                                
    set    F.ID_DOC_LINE = :id_doc_line
    where  F.ID_PAYMENT_FOOTER = :id_payment_footer;

  end

end
^

/* Restore proc. body: DOCUMENT_ADD_PAYMENT_LINE$INT */
ALTER PROCEDURE DOCUMENT_ADD_PAYMENT_LINE$INT(ID_DEPOSIT TYPE OF ID,
ID_DOC_HEAD TYPE OF ID,
DOC_VALUE TYPE OF TPRICE,
ID_SALE_TAXATION INTEGER = null)
 RETURNS(ID_DOC_LINE TYPE OF ID)
 AS
declare variable pay_date date;
  declare variable round_to numeric(15,4);
  declare variable nat_round_to numeric(15,4);
  declare variable nat_gross_value numeric(15,4);
  declare variable service_name varchar(50);
  declare variable id_service integer;
  declare variable id_tax_policy integer;
  declare variable no_use varchar(255);
  declare variable sec_curr_rate numeric(15,6);
  declare variable sec_curr_round numeric(15,4);
  declare variable sec_gross_value numeric(15,4);
  declare variable doc_rate numeric(15,6);
  declare variable sec_curr varchar(3);
  declare variable pay_curr varchar(3);
  declare variable nat_curr varchar(3);
  declare variable id_pay_doc_head integer;
begin

  select P.PAYMENT_DATE, A.ID_TAX_POLICY, d.ID_BILLING_SERVICE, p.PAY_CURRENCY, h.NATION_CURR, p.ID_DOC_HEAD
  from   DEPOSIT D
         join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join HOTEL H on h.ID_HOTEL = a.ID_HOTEL
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :pay_date, :id_tax_policy, :id_service, :pay_curr, :nat_curr, :id_pay_doc_head;

  service_name = null;
  select S.SERVICE_NAME
  from   SERVICES S
  where  S.ID_SERVICE = :id_service
  into   :service_name;

  if (:service_name is null) then exception DOCUMENT_EXCEPTION '-378';

  execute procedure DOCUMENT_CURRS_GET$INT (:ID_DOC_HEAD)
  returning_values (:no_use, :doc_rate, :round_to, :no_use, :nat_round_to,
                   :sec_curr, :sec_curr_rate, :sec_curr_round);

  if (:ID_SALE_TAXATION is null) then begin
    select t.ID_SALE_TAXATION
    from   SERVICE_TAXATION t
    where  t.ID_SERVICE = :id_service
           and t.ID_TAX_POLICY = :id_tax_policy
    into   :ID_SALE_TAXATION;
  end
  ----------
  nat_gross_value = null;
  if (:nat_curr is not distinct from :pay_curr and :ID_DOC_HEAD <> :id_pay_doc_head) then begin
    select -sum(dd.USED_PAY_VALUE)
    from   DEPOSIT_DEDUCT dd
    where  dd.ID_DEPOSIT = :ID_DEPOSIT
           and dd.ID_DOC_USED = :ID_DOC_HEAD
    into   :nat_gross_value;
  end

  if (:nat_gross_value is null) then begin
    nat_gross_value = :doc_value * :doc_rate;
  end
  ----------
  sec_gross_value = null;
  if (:sec_curr is not distinct from :pay_curr and :ID_DOC_HEAD <> :id_pay_doc_head) then begin
    select -sum(dd.USED_PAY_VALUE)
    from   DEPOSIT_DEDUCT dd
    where  dd.ID_DEPOSIT = :ID_DEPOSIT
           and dd.ID_DOC_USED = :ID_DOC_HEAD
    into   :sec_gross_value;
  end

  if (:sec_gross_value is null) then begin
    sec_gross_value = :doc_value * cast(:doc_rate / :sec_curr_rate as double precision);
  end
  ----------
  execute procedure DOCUMENT_LINE_ADD$INT (:ID_DOC_HEAD, :id_service, :ID_SALE_TAXATION,
          :service_name, -1, :pay_date, :pay_date, :pay_date, null,
          1, :DOC_VALUE, round_f(:doc_value, :round_to), :round_to,
          round_f(:nat_gross_value, :nat_round_to), :nat_round_to, :sec_curr, round_f(:sec_gross_value, :sec_curr_round), :sec_curr_round,
          0, 1, 0)
  returning_values (:id_doc_line, :no_use, :no_use, :no_use);

  insert into DOC_LINE_DEP_VALUES (ID_DOC_LINE, ID_DEPOSIT)
  values (:id_doc_line, :ID_DEPOSIT);

end
^

/* Restore proc. body: DOCUMENT_ADD_SERVICES$INT */
ALTER PROCEDURE DOCUMENT_ADD_SERVICES$INT(ID_DOC_HEAD INTEGER,
ID_ACCOUNT INTEGER)
 AS
declare variable line_value numeric(15,4);
  declare variable compensation_idx integer;
  declare variable compensation_nat_idx integer;
  declare variable compensation_sec_idx integer;
  declare variable round_to numeric(15,4);
  declare variable nat_curr varchar(3);
  declare variable sec_curr varchar(3);
  declare variable nat_round_to numeric(15,4);
  declare variable sec_round_to numeric(15,4);
  declare variable id_doc_line integer;
  declare variable id_service integer;
  declare variable date_post date;
  declare variable line_name varchar(100);
  declare variable qty_post numeric(15,4);
  declare variable price_post double precision;
  declare variable wot_diff double precision ;
  declare variable to_date date;
  declare variable from_date date;
  declare variable is_correct integer;
  declare variable id_guest integer;
  declare variable room_name varchar(10);
  declare variable group_tag integer;
  declare variable nat_net_value numeric(15,4);
  declare variable nat_gross_value numeric(15,4);
  declare variable sec_curr_gross_value numeric(15,4);
  declare variable acc_post_rate numeric(15,6);
  declare variable post_doc_rate numeric(15,6);
  declare variable id_sale_taxation integer;
  declare variable id_account_post integer;
  declare variable doc_curr_round_diff numeric(15,4);
  declare variable nat_curr_round_diff numeric(15,4);
  declare variable sec_curr_round_diff numeric(15,4);
  declare variable doc_posts_value numeric(15,4);
  declare variable no_use varchar(255);
  declare variable doc_curr varchar(3);
  declare variable doc_curr_rate numeric(15,6);
  declare variable sec_curr_rate numeric(15,6);
begin
  execute procedure DOCUMENT_CURRS_GET$INT (:ID_DOC_HEAD)
  returning_values (:doc_curr, :doc_curr_rate, :round_to, :nat_curr, :nat_round_to,
                   :sec_curr, :sec_curr_rate, :sec_round_to);

  DOC_POSTS_VALUE = 0;

  select sum(round_f(Dl.DOC_PRICE_WOT_DIFF * dl.QTY_POST, :round_to))    -- line rounded value sum
         - round_f(sum(Dl.DOC_PRICE_WOT_DIFF * dl.QTY_POST), :round_to),  -- doc target value
         sum(round_f(dl.price_post * dl.qty_post * dl.post_rate_in_doc, :nat_round_to))    -- line rounded value sum
         - round_f(sum(dl.price_post * dl.qty_post * dl.post_rate_in_doc), :nat_round_to),
         sum(round_f(dl.price_post * dl.qty_post * cast(dl.post_rate_in_doc / :sec_curr_rate as double precision), :round_to))    -- line rounded value sum
         - round_f(sum(dl.price_post * dl.qty_post * cast(dl.post_rate_in_doc / :sec_curr_rate as double precision)), :round_to)
  from   DOCUMENT_POSTINGS_GET$INT(:ID_DOC_HEAD, :id_account, :doc_curr, :doc_curr_rate) DL
  into   :doc_curr_round_diff, :nat_curr_round_diff, :sec_curr_round_diff;

  compensation_idx = case when :doc_curr_round_diff > 0 then 1
                          when :doc_curr_round_diff < 0 then -1
                          else 0 end;
  compensation_nat_idx = case when :nat_curr_round_diff > 0 then 1
                              when :nat_curr_round_diff < 0 then -1
                              else 0 end;
  compensation_sec_idx = case when :sec_curr_round_diff > 0 then 1
                              when :sec_curr_round_diff < 0 then -1
                              else 0 end;
  /**************************************************************************/
  for
     select DL.ID_SERVICE, DL.ID_GUEST, DL.ROOM_NAME,
            DL.DATE_POST, DL.SERVICE_NAME, DL.QTY_POST, DL.PRICE_POST,
            DL.TO_DATE, DL.FROM_DATE, DL.ID_SALE_TAXATION,
            DL.IS_CORRECT, DL.GROUP_TAG,
            DL.RATE_POST,
            DL.POST_RATE_IN_DOC, DL.DOC_PRICE_WOT_DIFF, dl.ID_ACCOUNT_POST
     from   DOCUMENT_POSTINGS_GET$INT(:ID_DOC_HEAD, :id_account, :doc_curr, :doc_curr_rate) DL
     order by ((round_f(Dl.DOC_PRICE_WOT_DIFF * dl.QTY_POST, :round_to)
                - Dl.DOC_PRICE_WOT_DIFF * dl.QTY_POST) * :compensation_idx) desc, /* pull up lines with bigger negative/positive diffs */
            dl.PRICE_POST desc, 
            dl.DATE_POST asc
     into   :id_service, :id_guest, :room_name,
            :date_post, :line_name, :qty_post, :price_post,
            :to_date, :from_date, :id_sale_taxation,
            :is_correct, :group_tag,
            :acc_post_rate,
            :post_doc_rate, :wot_diff, :id_account_post
  do begin
    if (:qty_post=0) then
      exception DOCUMENT_EXCEPTION 'Internal lines error: ' || :line_name || ' qty = 0';
    /* paranoid check - this case should be impossible !!!  */
    /********************************************************/
    line_value = round_f(:WOT_DIFF * :QTY_POST, :ROUND_TO);
    if (round_f(:doc_curr_round_diff, :round_to) <> 0) then begin
      line_value = :line_value - :round_to * :compensation_idx;
      doc_curr_round_diff = :doc_curr_round_diff - :round_to * :compensation_idx;
    end else begin
      compensation_idx = 0;
    end
    /* ********************************************************* */
    if (:DOC_CURR = :nat_curr) then begin
      /* to prevent from round differences */
      nat_gross_value = :line_value;
    end else begin
      nat_gross_value = round_f(:price_post * :qty_post * :post_doc_rate, :nat_round_to);
      if ((round_f(:nat_curr_round_diff, :nat_round_to) <> 0)
          and (:compensation_nat_idx * :compensation_idx >= 0)) then
      begin
        nat_gross_value = :nat_gross_value - :nat_round_to * :compensation_nat_idx;
        nat_curr_round_diff = :nat_curr_round_diff - :nat_round_to * :compensation_nat_idx;
      end
    end
    /* ********************************************************* */
    if (:sec_curr = :DOC_CURR) then begin
      /* to prevent from round differences */
      sec_curr_gross_value = :line_value;
    end else if (:sec_curr = :nat_curr) then begin
      /* to prevent from round differences */
      sec_curr_gross_value = :nat_gross_value;
    end else begin
      sec_curr_gross_value = round_f(:price_post * :qty_post * cast(:post_doc_rate / :sec_curr_rate as double precision), :sec_round_to);
      if ((round_f(:sec_curr_round_diff, :sec_round_to) <> 0)
          and (:compensation_sec_idx * :compensation_idx >= 0)) then
      begin
        sec_curr_gross_value = :sec_curr_gross_value - :sec_round_to * :compensation_sec_idx;
        sec_curr_round_diff = :sec_curr_round_diff - :sec_round_to * :compensation_sec_idx;
      end
    end

    execute procedure DOCUMENT_LINE_ADD$INT (
            :ID_DOC_HEAD, :id_service, :id_sale_taxation, :line_name,
            :id_guest, :date_post, :from_date, :to_date, :room_name,
            :qty_post, :wot_diff, :line_value, :round_to, :nat_gross_value, :nat_round_to,
            :sec_curr, :sec_curr_gross_value, :sec_round_to,
            0, :is_correct, :group_tag)
    returning_values (:id_doc_line, :no_use, :nat_net_value, :no_use);

    execute procedure DOCUMENT_POSTING_DIFFS_SET$INT (:id_doc_line, :id_account_post,
    :id_sale_taxation, :qty_post, :price_post, :acc_post_rate, :post_doc_rate,
    :nat_net_value, :nat_gross_value, :nat_round_to);

    doc_posts_value = :doc_posts_value + :line_value;

    insert into DOC_LINE_REV_DEDUCTION_TAX(ID_DOC_LINE, ID_SALE_TAX, TAX_NAME, TAX_UNIT,
           TAX_VALUE, NAT_TAX_VALUE)
    select :id_doc_line, RD.ID_SALE_TAX, SAT.TAX_NAME, RD.TAX_VALUE,
           iif(sat.IS_PERCENT_TAX = 1, RD.TAX_AMOUNT, round_f(rd.TAX_AMOUNT / :doc_curr_rate, :round_to)), -- doc currency value
           iif(sat.IS_PERCENT_TAX = 1, round_f(rd.TAX_AMOUNT * :doc_curr_rate, :round_to), rd.TAX_AMOUNT)  -- nation curr value
    from   REVENUE_DEDUCTION_TAXES$INT(:line_value, :qty_post, :round_to, :id_sale_taxation) RD
           join SALE_TAXES SAT on SAT.ID_SALE_TAX = RD.ID_SALE_TAX
    where  ((sat.IS_PERCENT_TAX = 1) or (:is_correct = 0)) ;
  end

  update DOC_HEAD$INT D
  set    D.DOC_VALUE = :doc_posts_value
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD;

end
^

/* Restore proc. body: DOCUMENT_ADVANCE_STORNO$INT */
ALTER PROCEDURE DOCUMENT_ADVANCE_STORNO$INT(ID_DEPOSIT INTEGER,
PAY_AMOUNT NUMERIC(15,2),
DESCRIPTION VARCHAR(100))
 RETURNS(ID_STORNO_DOC INTEGER,
WARN_CODE INTEGER)
 AS
declare variable no_use varchar(2000);
  declare variable id_doc_head integer;
  declare variable doc_date date;
  declare variable doc_value numeric(15,4);
  declare variable pay_rate numeric(15,6);
  declare variable doc_rate numeric(15,6);
  declare variable id_vat_group integer;
  declare variable is_storned integer;
  declare variable is_full_storno integer;
  declare variable is_anul integer;
  declare variable id_doc_supplier integer;
  declare variable id_hotel integer;
  declare variable id_account integer;
  declare variable received_amount numeric(15,4);
  declare variable sec_gross_value numeric(15,4);
  declare variable nat_gross_value numeric(15,4);
  declare variable nat_round_to numeric(15,4);
  declare variable doc_round_to numeric(15,4);
  declare variable sec_round_to numeric(15,4);
  declare variable sec_curr_rate numeric(15,6);
  declare variable line_name varchar(100) ;
  declare variable id_service integer;
  declare variable id_doc_line integer;
  declare variable id_payment_head integer;
  declare variable sec_curr varchar(3);
  declare variable round_to numeric(15,4);
  declare variable tax_event_date date;
  declare variable is_archive integer;
begin
  id_doc_head = null;
  WARN_CODE = null;
  select DH.ID_DOC, ph.PAY_RATE, DH.DOC_RATE, DH.IS_STORNED, DH.IS_ANUL,
         DH.ID_DOC_SUPPLIER, A.ID_HOTEL, A.ID_ACCOUNT, ph.ID_PAYMENT_HEAD, dh.TAX_EVENT_DATE, dt.IS_ARCHIVE
  from   DEPOSIT D
         join PAYMENT_HEAD PH on PH.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
         join DOC_HEAD DH on DH.ID_DOC = PH.ID_DOC_HEAD
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join DOC_TYPE dt on dt.ID_DOC_TYPE = dh.ID_DOC_TYPE
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_doc_head, :pay_rate, :doc_rate, :is_storned, :is_anul,
         :id_doc_supplier, :id_hotel, :id_account, :id_payment_head, :tax_event_date, :is_archive;

  if (:id_doc_head is null) then EXIT; /* !?! */

  if (:is_anul = 1) then
    exception DOCUMENT_EXCEPTION '-352';
  if (:is_storned = 1) then
    exception MULTIPLE_STORNO_ON_DOC;

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values  (:doc_date);

  select sum(d.RECEIVED_AMOUNT), min(c.ROUND_TO)
  from   DEPOSITS D
         join CURRS c on c.CURR = d.PAY_CURRENCY
  where  D.ID_PAYMENT_HEAD = :id_payment_head
  into   :received_amount, :round_to;

  if (round_f(:received_amount, :round_to) = 0) then is_full_storno = 1;  -- Refund whole deposit payment
  else is_full_storno = 0;
   
  execute procedure DOC_SUPPLIER_GET_COPY$DOC (:id_doc_supplier)
  returning_values  (:id_doc_supplier);
   
  ID_STORNO_DOC = gen_id(DOC_SELECTED_GEN, 1);
  insert into DOC_HEAD$INT
         (ID_DOC_HEAD, ID_DOC_TYPE, ID_DOC_NUM, ID_ACCOUNT, DOC_CURRENCY, DOC_DATE,
         DOC_TYPE_NAME, IS_ANUL, IS_STORNED, DESCRIPTION,
         DOC_RATE, DOC_VALUE, DOC_VALUE_A, DOC_NET_VALUE, DOC_ACC_RATE, ID_BASE_DOC, FOR_DEPOSIT,
         ID_DOC_CONTRAGENT, ID_DOC_SUPPLIER, DOC_SUB_TYPE,
         IS_STORNO, SECOND_CURRENCY, SECOND_CURR_RATE, SECOND_CURR_NET_VALUE, SECOND_CURR_GROSS_VALUE, DOC_VALUE_ROUNDLESS)
  select :ID_STORNO_DOC, ID_DOC_TYPE, ID_DOC_NUM, :id_account, DOC_CURRENCY, :doc_date,
         DOC_TYPE_NAME, IS_ANUL, IS_STORNED, :DESCRIPTION,
         DOC_RATE, 0, 0, DOC_NET_VALUE, DOC_ACC_RATE, ID_BASE_DOC, FOR_DEPOSIT,
         ID_DOC_CONTRAGENT, :id_doc_supplier, 2,
         :is_full_storno, dh.SECOND_CURRENCY, dh.SECOND_CURR_RATE, dh.SECOND_CURR_NET_VALUE, dh.SECOND_CURR_GROSS_VALUE, dh.DOC_VALUE_ROUNDLESS
  from   DOC_HEAD$INT DH
  where  DH.ID_DOC_HEAD = :id_doc_head;

  execute procedure DOCUMENT_COMPLETE$INT (:ID_STORNO_DOC, :DOC_DATE, :TAX_EVENT_DATE, null);

  -- sum all invoice lines for this payment
  select min(dl.ID_SALE_TAXATION), min(dl.LINE_NAME), min(dl.ID_SERVICE),
         -sum(dl.SINGLE_VALUE * dl.QTY_POST), -sum(dl.NAT_GROSS_VALUE), -sum(dl.SEC_CURR_GROSS_VALUE)
  from   DEPOSIT d
         join DOC_LINE_DEP_VALUES DV on dv.ID_DEPOSIT = d.ID_DEPOSIT
         join DOC_LINE DL on dl.ID_DOC_LINE = dv.ID_DOC_LINE
         join DOC_HEAD$INT dh on dh.ID_DOC_HEAD = dl.ID_DOC_HEAD
  where  d.ID_PAYMENT_HEAD = :id_payment_head
         and dh.FOR_DEPOSIT = 1
         and dh.IS_ANUL = 0
  into   :id_vat_group, :line_name, :id_service, :doc_value, :nat_gross_value, :sec_gross_value;

  execute procedure DOCUMENT_CURRS_GET$INT (:ID_STORNO_DOC)
  returning_values (:no_use, :doc_rate, :doc_round_to, :no_use, :nat_round_to, :sec_curr, :sec_curr_rate, :sec_round_to);

  if (:is_full_storno = 0) then begin
    doc_value = -:PAY_AMOUNT * cast(:pay_rate / :doc_rate as double precision);
    nat_gross_value = round_f(:doc_value * :doc_rate, :nat_round_to);
    sec_gross_value = round_f(:doc_value * cast(:doc_rate / :sec_curr_rate as double precision), :sec_round_to);
  end

  execute procedure DOCUMENT_LINE_ADD$INT (:ID_STORNO_DOC, :id_service, :id_vat_group,
          :line_name, -1, :doc_date, :doc_date, :doc_date, null,
          1, :DOC_VALUE, round_f(:doc_value, :doc_round_to), :doc_round_to,
          :nat_gross_value, :nat_round_to, :sec_curr, :sec_gross_value, :sec_round_to,
          0, 1, 0)
  returning_values (:id_doc_line, :no_use, :no_use, :no_use);

  insert into DOC_LINE_DEP_VALUES (ID_DOC_LINE, ID_DEPOSIT)
  values (:id_doc_line, :ID_DEPOSIT);
  /*  */

  execute procedure DOCUMENT_SAVE_TOTAL$INT (:ID_STORNO_DOC)
  returning_values :no_use;

  if (:is_full_storno = 1) then begin
    update DOC_HEAD$INT D
    set    D.IS_STORNED = 1
    where  D.ID_DOC_HEAD = :id_doc_head;
  end

  if (:is_archive = 1) then execute procedure SYSTEM_WARNING_ADD(-312, '') returning_values :WARN_CODE;
end
^

/* Restore proc. body: DOCUMENT_ATTACH_PAYMENT$INT */
ALTER PROCEDURE DOCUMENT_ATTACH_PAYMENT$INT(ID_DOC_HEAD INTEGER,
ID_ACCOUNT_PAYMENT INTEGER,
PAY_CURR_RATE NUMERIC(15,6),
PAY_VALUE NUMERIC(15,4))
 RETURNS(DOC_VALUE NUMERIC(15,4))
 AS
declare variable doc_rate numeric(15,6);
  declare variable doc_curr varchar(3);
  declare variable rest_value numeric(15,4);
  declare variable doc_round_to numeric(15,4);
  declare variable pay_round_to numeric(15,4);
  declare variable pay_amount numeric(15,4);
  declare variable equal_pay_doc_rate double precision;
  declare variable id_deposit integer;
  declare variable id_reserv_detail integer;
begin
  if (:PAY_CURR_RATE is null) then exception DOCUMENT_EXCEPTION 'Unspecified payment currency rate!';

  select D.DOC_RATE, D.DOC_CURRENCY, C.ROUND_TO
  from   DOC_HEAD D
         join CURRS C on C.CURR = D.DOC_CURRENCY
  where  D.ID_DOC = :ID_DOC_HEAD
  into   :doc_rate, :doc_curr, :doc_round_to;

  select AP.PAY_AMOUNT, c.ROUND_TO, ap.ID_DEPOSIT
  from   ACCOUNT_PAYMENTS AP
         join PAYMENT_HEAD P on p.ID_PAYMENT_HEAD = ap.ID_PAYMENT_HEAD
         join CURRS C on C.CURR = p.PAY_CURRENCY
  where  aP.ID_ACCOUNT_PAYMENT = :ID_ACCOUNT_PAYMENT
  into   :pay_amount, :pay_round_to, :id_deposit;

  if (:id_deposit is not null) then begin
    select d.ID_RESERV_DETAIL
    from   DEPOSIT D
    where  d.ID_DEPOSIT = :id_deposit
    into   :id_reserv_detail;

    if (:id_reserv_detail is not null) then begin
      execute procedure RES_TAKE_POSTING_RESPONSIBILITY (:id_reserv_detail);
  
      when any do begin
        exception DOCUMENT_EXCEPTION 'Can not manipulate deposit!';
      end
    end
  end

  if (:PAY_VALUE is null) then PAY_VALUE = :pay_amount;

  select first 1 DV.PAYABLE_VALUE
  from   DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, :doc_curr, :doc_rate) DV
  into   :rest_value;

  execute procedure PAYMENT_EQUIVALENCE_CALC$INT (:PAY_CURR_RATE, :PAY_VALUE, :pay_round_to, :doc_rate, :doc_round_to, :rest_value)
  returning_values  (:DOC_VALUE, :equal_pay_doc_rate);
  --doc_rate = :PAY_CURR_RATE / :equal_pay_doc_rate;

  insert into DOC_PAY_USAGE (ID_DOC_HEAD, ID_ACCOUNT_PAYMENT, PAY_AMOUNT, PAY_RATE,
         DOC_AMOUNT, /*DOC_RATE,*/ EQUAL_PAY_DOC_RATE)
  values (:id_doc_head, :id_account_payment, :pay_value, :PAY_CURR_RATE,
         :DOC_VALUE, /*:doc_rate,*/ :equal_pay_doc_rate);

end
^

/* Restore proc. body: DOCUMENT_CLEAR_DEPOSITS$DOC */
ALTER PROCEDURE DOCUMENT_CLEAR_DEPOSITS$DOC(ID_DOC_HEAD INTEGER)
 AS
declare variable is_storno_doc smallint;
begin

  execute procedure DOCUMENT_REUSE_DEPOSITS$INT (:ID_DOC_HEAD, null);

end
^

/* Restore proc. body: DOCUMENT_GET_VALUE$INT */
ALTER PROCEDURE DOCUMENT_GET_VALUE$INT(ID_DOC_HEAD INTEGER,
TARGET_CURR VARCHAR(3),
TARGET_RATE NUMERIC(15,6) = null)
 RETURNS(ID_PAY_DOC_DEF INTEGER,
TOTAL_CURR VARCHAR(3),
TOTAL_RATE NUMERIC(15,6),
TOTAL_VALUE NUMERIC(15,4),
PAYABLE_VALUE NUMERIC(15,4))
 AS
declare variable doc_curr varchar(3);
  declare variable doc_round_to numeric(15,4);
  declare variable target_round_to numeric(15,4);
  declare variable doc_rate numeric(15,6);
  declare variable pays_value numeric(15,4);
  declare variable used_dep_value numeric(15,4);
  declare variable ded_dep_value numeric(15,4);
  declare variable discounts numeric(15,4);
  declare variable is_dep_doc integer;
  declare variable id_account integer;
  declare variable doc_sub_type integer;
  declare variable dummy varchar(255);
  declare variable doc_value_a numeric(15,4);
  declare variable total_value_int numeric(15,4);
begin
  select d.DOC_VALUE_ROUNDLESS, d.DOC_VALUE_A,
         D.DOC_CURRENCY, D.DOC_RATE, D.FOR_DEPOSIT, D.ID_ACCOUNT, D.DOC_SUB_TYPE, c.ROUND_TO
  from   DOC_HEAD$INT D
         join DOC_TYPE DT on DT.ID_DOC_TYPE = D.ID_DOC_TYPE
         join CURRS c on C.CURR = d.DOC_CURRENCY
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :total_value_int, :doc_value_a,
         :doc_curr, :doc_rate, :is_dep_doc, :id_account, :doc_sub_type, :doc_round_to;
   
  if (cast(round_f(:total_value_int, :doc_round_to) as numeric(15,4)) <> :doc_value_a) then total_value_int = :doc_value_a;

  select sum(round_f(DD.FOOTER_VALUE, :doc_round_to))
  from   DOC_FOOTER DD
  where  DD.ID_DOC_HEAD = :ID_DOC_HEAD
         and DD.ID_DOC_LINE is null
  into   :discounts;

  select sum(round_f(P.DOC_AMOUNT, :doc_round_to))
  from   DOC_PAY_USAGE P
  where  P.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :pays_value;
  /*  */
  ded_dep_value = 0;  used_dep_value = 0;
  if (:is_dep_doc = 0) then begin
    select sum(round_f(DL.SINGLE_VALUE * DL.QTY_POST, :doc_round_to))
    from   DOC_LINE DL
           join DOC_LINE_DEP_VALUES DV on DV.ID_DOC_LINE = DL.ID_DOC_LINE
    where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
    into   :ded_dep_value;
  end

  PAYABLE_VALUE = :total_value_int
                  - coalesce(:ded_dep_value, 0)
                  - coalesce(:pays_value, 0)
                  - coalesce(:used_dep_value, 0)
                  + coalesce(:discounts, 0);

  if (:TARGET_CURR is null) then begin
    TOTAL_CURR = :doc_curr;
    TARGET_RATE = :doc_rate;
    target_round_to = :doc_round_to;
  end else begin
    TOTAL_CURR = :TARGET_CURR;
    if (:TARGET_RATE is null) then begin
      execute procedure DOC_GET_CURR_RATE$DOC (:ID_DOC_HEAD, :TOTAL_CURR)
      returning_values  (:TARGET_RATE);
    end

    select C.ROUND_TO
    from   CURRS C
    where  C.CURR = :TOTAL_CURR
    into   :target_round_to;
  end

  TOTAL_RATE = :TARGET_RATE;
  if (:TARGET_RATE = :doc_rate) then begin
    TOTAL_VALUE = round_f(:total_value_int, :target_round_to);
  end else begin
    TOTAL_VALUE = round_f(:total_value_int * cast(:doc_rate / :TARGET_RATE as double precision), :target_round_to);
  end

  if ((round_f(:PAYABLE_VALUE, :doc_round_to) = 0) or (cast(abs(:PAYABLE_VALUE) as numeric(15,4)) = :doc_round_to/2)) then begin
    PAYABLE_VALUE = 0;
  end else if (:TARGET_RATE = :doc_rate) then begin
    PAYABLE_VALUE = round_f(:PAYABLE_VALUE, :target_round_to);
  end else begin
    PAYABLE_VALUE = round_f(:PAYABLE_VALUE * cast(:doc_rate / :TARGET_RATE as double precision), :target_round_to);
  end

  if (:doc_sub_type < 2) then begin
    execute procedure PAYMENT_GET_DEFAULT$INT (:id_account)
    returning_values  (:ID_PAY_DOC_DEF, :dummy);
  end

  suspend;
end
^

/* Restore proc. body: DOCUMENT_RESET_TYPE$DOC */
ALTER PROCEDURE DOCUMENT_RESET_TYPE$DOC(ID_DOC_HEAD INTEGER,
ID_DOC_TYPE INTEGER,
DOC_CURRENCY VARCHAR(3),
PROFORMA_NAME_PREFIX VARCHAR(30))
 AS
declare variable id_account integer;
  declare variable old_id_doc_type integer;
  declare variable id_doc_contragent integer;
  declare variable id_doc_supplier integer;
  declare variable is_deposit integer;
  declare variable old_doc_curr varchar(3);
  declare variable doc_date date;
  declare variable tax_event_date date;
  declare variable id_base_doc integer;
  declare variable dbg varchar(1000);
  declare variable d_dbkey char(8);
  declare variable bonuspoints integer;
  declare variable id_advance_payment integer;
  declare variable id_payment_head integer;
  declare variable id_hotel integer;
  declare variable is_proforma tlogical;
  declare variable doc_type_name varchar(50);
  declare variable doc_sub_type smallint;
begin
  is_proforma = iif(:PROFORMA_NAME_PREFIX is null, 0, 1);

  select D.ID_ACCOUNT, D.ID_DOC_TYPE, D.ID_DOC_CONTRAGENT, D.ID_DOC_SUPPLIER,
         D.FOR_DEPOSIT, D.DOC_CURRENCY, D.DOC_DATE, DC.TAX_EVENT_DATE,
         D.ID_BASE_DOC, D.RDB$DB_KEY, a.ID_HOTEL, d.DOC_SUB_TYPE
  from   DOC_HEAD$INT D
         join ACCOUNT A on a.ID_ACCOUNT = d.ID_ACCOUNT
         left outer join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :id_account, :old_id_doc_type, :id_doc_contragent, :id_doc_supplier,
         :is_deposit, :old_doc_curr, :doc_date, :tax_event_date,
         :id_base_doc, :d_dbkey, :id_hotel, :doc_sub_type;
  /***************/
  if (:doc_sub_type > 0) then exit; -- can't change type for credit or debit document
  /***************/
  if ((:old_id_doc_type <> :ID_DOC_TYPE) or (:old_doc_curr <> :DOC_CURRENCY)) then begin
    for
      select p.ID_PAYMENT_HEAD
      from   PAYMENT_HEAD p
      where  p.ID_DOC_HEAD = :ID_DOC_HEAD
      into   :id_payment_head
    do begin
      execute procedure DOC_TYPE_EVALUATE$INT (:ID_DOC_TYPE, :id_hotel, :is_proforma, :id_payment_head);
    end

    id_advance_payment = null;
    if (:is_deposit = 1) then begin
      select first 1 p.ID_PAYMENT_HEAD
      from   PAYMENT_HEAD p
      where  p.ID_DOC_HEAD = :ID_DOC_HEAD
      into   :id_advance_payment;

      update PAYMENT_HEAD DP
      set    DP.ID_DOC_HEAD = null
      where  DP.ID_DOC_HEAD = :ID_DOC_HEAD;
    end
    /* update old document with reverse ID, to be deleted on the end */
    update DOC_HEAD$INT OD
    set    OD.ID_DOC_HEAD = -OD.ID_DOC_HEAD
    where  OD.RDB$DB_KEY = :d_dbkey;
    /* recreate document */
    select iif (:is_proforma = 1, substring(trim(:PROFORMA_NAME_PREFIX) || ' ' || dt.doc_type_name from 1 for 50), dt.DOC_TYPE_NAME)
    from   DOC_TYPE dt
    where  dt.ID_DOC_TYPE = :ID_DOC_TYPE
    into   :doc_type_name;

    execute procedure DOCUMENT_CREATE$INT (:ID_DOC_HEAD, :id_account, :ID_DOC_TYPE,
            :doc_type_name, :doc_date, :DOC_CURRENCY, :id_base_doc, :tax_event_date, :is_proforma, :id_advance_payment)
    returning_values  (:dbg, :dbg);
    /* reuse bonuspoints discounts */
    for
      select DF.TAXABLE_VALUE
      from   DOC_FOOTER DF
      where  DF.ID_DOC_HEAD = -:ID_DOC_HEAD
             and DF.ID_TAX is null
      into   :bonuspoints
    do begin
      execute procedure DOCUMENT_BONUSPOINTS_SPEND (:ID_DOC_HEAD, :bonuspoints)
      returning_values (:dbg);
    end 
    /* reuse deposits and payments */
    if (:is_deposit = 0) then begin
      execute procedure DOCUMENT_REUSE_DEPOSITS$INT (-:ID_DOC_HEAD, :ID_DOC_HEAD);

      execute procedure DOCUMENT_REUSE_PAYMENTS$INT (-:ID_DOC_HEAD, :ID_DOC_HEAD);
    end
    /* get client and sipplier data */
    update DOC_HEAD$INT D
    set    D.ID_DOC_CONTRAGENT = :id_doc_contragent,
           D.ID_DOC_SUPPLIER = :id_doc_supplier
    where  D.ID_DOC_HEAD = :ID_DOC_HEAD;
    /* delete old document */
    delete from DOC_HEAD$INT D
    where  D.ID_DOC_HEAD = -:ID_DOC_HEAD;
    /*  */
  end
end
^

/* Restore proc. body: DOCUMENT_SAVE_TOTAL$INT */
ALTER PROCEDURE DOCUMENT_SAVE_TOTAL$INT(ID_DOC_HEAD ID)
 RETURNS(DOC_SUB_TYPE INTEGER)
 AS
declare variable doc_grand_total numeric(15,4);
declare variable doc_net_total numeric(15,4);
declare variable sec_curr_total_value numeric(15,4);
declare variable sec_curr_net_value numeric(15,4);
  declare variable id_base_doc integer;
  declare variable taxable_value numeric(15,4);
  declare variable doc_num varchar(20);
  declare variable id_doc_type integer;
  declare variable doc_name varchar(50);
  declare variable dh_dbkey char(8);
  declare variable round_to numeric(15,4);
  declare variable sc_round_to numeric(15,4);
  declare variable taxation_reason varchar(255);
  declare variable value_roundless double precision;
begin
  select DH.RDB$DB_KEY, DH.ID_BASE_DOC, Dh.DOC_NUM, DH.ID_DOC_TYPE, C.ROUND_TO, sc.ROUND_TO
  from   DOC_HEAD$INT DH
         join CURRS C on C.CURR = DH.DOC_CURRENCY
         join ACCOUNT A on A.ID_ACCOUNT = DH.ID_ACCOUNT
         left outer join CURRS Sc on  sc.CURR = dh.SECOND_CURRENCY
  where  DH.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :dh_dbkey, :id_base_doc, :doc_num, :id_doc_type, :round_to, :sc_round_to;

  if (trim(:doc_num) <> '') then
    exception DOCUMENT_EXCEPTION '-354';

  /* ************************************************************************ */
  /* MOST IMPORTANT PROCEDURE - EVALUATE LINE TAX DIFFS                       */
  execute procedure DOCUMENT_TAXES_EVAL$INT(:ID_DOC_HEAD);
  /* ************************************************************************ */

  select round_f(sum(l.wot_vat * (select max(st.TAXABLE_BASE_PERCENT)/100
                                  from   SALE_TAXATION_TAX STT
                                         join SALE_TAXES ST on ST.ID_SALE_TAX = stt.ID_SALE_TAX
                                  where  STT.ID_SALE_TAXATION = l.ID_SALE_TAXATION
                                         and st.REVENUE_DEDUCTION_TAX is distinct from 1)), :round_to),
         round_f(sum(L.TOTAL_VALUE), :round_to),
         round_f(sum(L.WOT_VAT), :round_to),
         round_f(sum(L.SEC_CURR_TOTAL_VALUE), :sc_round_to),
         round_f(sum(L.SEC_CURR_NET_VALUE), :sc_round_to),
         sum(l.value_roundless)
  from   (select dl.ID_SALE_TAXATION,
                 sum(dl.WOT_VAT) as wot_vat,
                 sum(dl.QTY_POST *  dl.SINGLE_VALUE) as total_value,
                 sum(dl.WOT_DIFF * dl.QTY_POST) as value_roundless,
                 sum(dl.SEC_CURR_GROSS_VALUE) as sec_curr_total_value,
                 sum(dl.SEC_CURR_NET_VALUE) as sec_curr_net_value
          from   DOC_LINE DL     
          where  Dl.ID_DOC_HEAD = :ID_DOC_HEAD
          group by dl.ID_SALE_TAXATION) L
  into   :taxable_value, :doc_grand_total, :doc_net_total, :sec_curr_total_value, :sec_curr_net_value, :value_roundless;

  doc_sub_type = 0;
  if (:id_base_doc = :ID_DOC_HEAD ) then begin
    if (:doc_grand_total < 0) then exception DOCUMENT_EXCEPTION '-370';
  end else begin
    if (:taxable_value <> 0) then doc_sub_type = iif(:taxable_value < 0, 2, 1);
    else doc_sub_type = iif(:doc_grand_total < 0, 2, 1);

    select iif(:doc_sub_type = 1, DT.DEBIT_DOC_NAME, DT.CREDIT_DOC_NAME)
    from   DOC_TYPE_INV DT
    where  DT.ID_DOC_TYPE = :id_doc_type
    into   :doc_name;
  end

  select cast(substring(list(DT.TAXATION_REASON) from 1 for 255) as varchar(255))
  from   DOC_TAXES DT
  where  DT.ID_DOC_HEAD = :id_doc_head
  into   :taxation_reason;

  update DOC_HEAD$INT D
  set    D.TAXABLE_VALUE = :taxable_value,
         D.DOC_NET_VALUE = :doc_net_total,
         D.DOC_VALUE_A = :doc_grand_total,
         D.DOC_SUB_TYPE = :DOC_SUB_TYPE,
         D.DOC_TYPE_NAME = iif(:DOC_SUB_TYPE = 0, D.DOC_TYPE_NAME, :doc_name),
         D.DIFF_VAT_REASON = :taxation_reason,
         D.DOC_VALUE_ROUNDLESS = :value_roundless,
         d.SECOND_CURR_NET_VALUE = :sec_curr_net_value,
         d.SECOND_CURR_GROSS_VALUE = :sec_curr_total_value
  where  D.RDB$DB_KEY = :DH_DBKEY;

end
^

/* Restore proc. body: EAI_EXT_POST_TO_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable ID_HOTEL integer;
begin
  if (singular(select HS.ID_HOTEL
               from HOTEL_S HS
               where HS.IS_USE = 1)) then
    select H.ID_HOTEL
    from   HOTEL_S H
    where H.IS_USE = 1
    into   :id_hotel;
  else begin
    err_code = -1044;
    exit;
  end

  execute procedure EAI_EXT_POST_TO_MH_FRONT_ONLINE(:ID_HOTEL, :ROOM_NAME,
    :SERVICE_CODE, :CODE_TYPE, :QTY_POST, :PRICE_POST, :CURR_POST, :POST_TEXT)
  returning_values (:ERR_CODE, :ERR_TEXT, :ID_ROOM, :ID_GUEST, :GUEST_NAME1,
    :ID_ACCOUNT, :ID_ACCOUNT_POST, :ID_SERVICE);

end
^

/* Restore proc. body: HOTEL_AUTO_IMPORT$WBE */
ALTER PROCEDURE HOTEL_AUTO_IMPORT$WBE(NAME VARCHAR(50),
UUID VARCHAR(40))
 RETURNS(ID_HOTEL INTEGER)
 AS
declare variable tmp_id integer;
declare variable nation_curr tcurrency;
declare variable id_sale_tax integer;
declare variable id_sale_taxation integer;
declare variable id_tax_policy integer;
declare variable id_acc_template integer;
begin
  select id_hotel
  from   hotel
  where  uuid = :uuid
         and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :id_hotel;

  execute procedure sys_dbg('wbe HOTEL_AUTO_IMPORT$WBE('
  || 'name => ' || coalesce(:name, '<null>')
  || ', uuid => ' || coalesce(:uuid, '<null>')
  ||') => {:id_hotel => ' || coalesce(:id_hotel, '<null>')
  || '}');

  if (:id_hotel is null) then begin
    execute procedure PICTURE_MODIFY (null, null, 'ptEmpty', 'plAsIs', 'add')
    returning_values :tmp_id;

    nation_curr = 'BGN';

    execute procedure HOTEL_MODIFY$CFG(null, :uuid, 1, null, null, null, null, :tmp_id, null, null, null, null, null, null, 'add', :nation_curr, null)
    returning_values  :id_hotel;

    update hotel
    set    uuid=:uuid
    where  id_hotel=:id_hotel;

    execute procedure SALE_TAX_MODIFY$CFG(null, 'WBE default', 0, 0, null, 0, 0, 'A', null, 'add', :id_hotel, '')
    returning_values :id_sale_tax;

    execute procedure SALE_TAXATION_MODIFY$CFG(null, 'WBE default',
            :id_sale_tax, null, 'add', :id_hotel)
    returning_values :id_sale_taxation;

    execute procedure TAX_POLICY_MODIFY$CFG(null, 'WBE default', 0, 'add', :id_hotel)
    returning_values :id_tax_policy;

    execute procedure SETTINGS_MODIFY_VALUE ('DEF_SERVICE_TAXATION', :id_sale_taxation, :id_hotel);

    execute procedure ACCOUNT_MODIFY_TEMPLATE$PROFILE(null,
        :ID_HOTEL || ' - WBE default', 0, null, 0, 1, :id_tax_policy, 0, 'add', :id_hotel)
    returning_values :id_acc_template;

    execute procedure SETTINGS_MODIFY_VALUE ('DEF_ACC_TEMPLATE', :id_acc_template, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('DEF_OWNER_ACC_TEMPLATE', :id_acc_template, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('NATIVE_NATION', 'BG', :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('DEF_COUNTRY', 'BG', :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('ROOMTYPE_ON_CHANGE_ROOM', 'ASK', :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('ROOMS_PREFERD_SORT_ORDER', 2, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('GUEST_POSTING_RATE', 'OCCUR_DATE', :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('MARK_DIRTY_EXPIRED_BLOCK', 0, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('MARK_DIRTY_OCC_ROOM', 0, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('DAY_KEEP_TYPES', 1, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('DAY_KEEP_NUMBERS', 0, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('CLEANING_RESTRICTION', 0, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('DEF_GUEST_MASK', '', :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('DEFAULT_DEPOSIT_DESCRIPTION', 'Booking deposit', :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('REPORT_LEAVING', 'AS_LEAVING', :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('CHECK_OVERBOOK', 1, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('RESTRICT_VATS_IN_DOC', 1, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('NEGATIVE_POSTINGS', 0, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('REVENUE_ACCOUNT_METHOD', 0, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('ACCOUNT_TO_DOC_RATE', 'CURRENT_RATE', :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('CHILDREN_MAX_AGE', 18, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('FEMALE_2ND_GROUP_MIN_AGE', 55, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('MALE_2ND_GROUP_MIN_AGE', 60, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('MARKETING_SEGMENT_REQUIRED', 0, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('VIEW_STORNO_SUMS_IN_DOCUMENTS', 'AS_POSITIVE', :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('STORNO_PAYMENTS_RESTRICT', 1, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('CHECK_OUT_HOUR', 12, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('CHECK_IN_HOUR', 14, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('SEPARATE_ACCOUNTS_PER_PAYER', 0, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('IFC_USE_FOLIO_NO', 1, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('IFC_AUTO_ATTACH_FOLIO_NUM', 0, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('ACTIVITY_OFFER_COPY', 0, :id_hotel);

  end
end
^

/* Restore proc. body: IMPORT_PERSON_PROFILE$EXC */
ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
declare variable op varchar(10);
  declare variable market_segment_id integer;
  declare variable sex_old char(1);
  declare variable birth_date_old date;
  declare variable birth_place_old varchar(30);
  declare variable personal_number_old varchar(30);
  declare variable pass_num_old varchar(20);
  declare variable pass_date_old date;
  declare variable pass_place_old varchar(20);
  declare variable pass_exp_date_old date;
  declare variable pass_city_old varchar(100);
  declare variable pass_address_old varchar(100);
  declare variable country_old varchar(10);
  declare variable mask_old varchar(10);
  declare variable title_old varchar(10);
  declare variable id_photo integer;
  declare variable id_def_contragent integer;
  declare variable id_passport_type integer;
  declare variable account_no_old varchar(20);
  declare variable msg_old varchar(255);
  declare variable id_guest_type integer;
  declare variable id_guest_type_old integer;
  declare variable card_code_old varchar(50);
  declare variable is_exclusive_debt_ownership smallint;
  declare variable profile_receiver_id integer;
begin
  profile_id = null;
  import_time = null;

  execute procedure import_mark_transaction$exc;

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC(:profile_uuid=>' || coalesce(:profile_uuid, '<null>')
                          || ', email=>' || coalesce(:email, '<null>') || ')');

  profile_id = null;
  if (profile_uuid is null) then begin
    execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC <null> :profile_uuid - exit;');
    exit;
  end

  select p.profile_id, p.profile_name, p.phone, p.fax, p.email, p.city,
         p.address, p.market_segment, p.note, p.is_archive, pp.card_code,
         pd.sex, pd.birthday_internal, pd.birth_place, pd.egn, pd.pass_num,
         pd.pass_date, pd.pass_place, pd.pass_exp_date, pd.city, pd.address, pd.country_code,
         pd.mask, p.id_def_contragent, p.wbe_password,
         pd.title, p.account_no, p.msg, pp.id_guest_type, pp.id_photo, pd.id_passport_type,
         p.is_exclusive_debt_ownership
  from   import_common_profile$exc(:profile_uuid, 0, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :wbe_password, :ACCOUNT_NO, :MSG, 'PERSON_PROFILE', :HOTEL_UUID_LIST) p
         left outer join profile_person pp on pp.id_profile = p.profile_id
         left outer join person_data pd on pd.id_person_data=pp.id_person_data
  into   :profile_id, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :card_code_old,
         :sex_old, :birth_date_old, :birth_place_old, :personal_number_old, :pass_num_old,
         :pass_date_old, :pass_place_old, :pass_exp_date_old, :pass_city_old, :pass_address_old, :country_old,
         :mask_old, :id_def_contragent, :wbe_password, :title_old,
         :account_no_old, :msg_old, :id_guest_type_old, :id_photo, :id_passport_type, :is_exclusive_debt_ownership;

  if (:profile_id is null) then begin
    op = 'add';
  end else if (:hotel_uuid_list is null) then begin
    profile_id = null;
    exit;
  end else begin
    op = 'mod';
    delete from PROFILE_BONUSPOINT_SCHEME bs
      where bs.ID_PROFILE = :profile_id;
  end

  sex=coalesce(:sex, :sex_old);
  birth_date=coalesce(:birth_date, :birth_date_old);
  birth_place=coalesce(:birth_place, :birth_place_old);
  personal_number=coalesce(:personal_number, :personal_number_old);
  pass_num=coalesce(:pass_num, :pass_num_old);
  pass_date=coalesce(:pass_date, :pass_date_old);
  pass_place=coalesce(:pass_place, :pass_place_old);
  pass_exp_date=coalesce(:pass_exp_date, :pass_exp_date_old);
  pass_city=coalesce(:pass_city, :pass_city_old);
  pass_address=coalesce(:pass_address, :pass_address_old);
  country=upper(coalesce(:country, :country_old));
  mask=coalesce(:mask, :mask_old);
  title=coalesce(:title, :title_old);
  account_no=coalesce(:account_no, :account_no_old);
  msg=coalesce(:msg, :msg_old);
  card_code=coalesce(:card_code, :card_code_old);

  execute procedure IMPORT_PASSPORT_TYPE$EXC(:pass_type_name, :pass_type_external_code)
  returning_values :id_passport_type;

  execute procedure lookup_market_segment$exc(:profile_name, 'PERSON_PROFILE', :market_segment)
  returning_values :market_segment_id;

  if (guest_type_name is not null) then begin
    execute procedure lookup_guest_type$exc(:profile_name, 'PERSON_PROFILE', :guest_type_name)
    returning_values :id_guest_type;
  end

  if ((def_contragent_name is not null) and (def_contragent_name <> '')) then begin
    execute procedure LOOKUP_CONTRAGENT$EXC(:profile_name, 'PERSON_PROFILE', :def_contragent_name)
    returning_values :id_def_contragent;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:profile_name, 'PERSON_PROFILE');

  id_guest_type=coalesce(:id_guest_type, :id_guest_type_old);

  if (id_photo is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, null, null, null, 'del')
    returning_values :id_photo;
  end
  id_photo = null;
  if (picture is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, :picture, :picture_type, :picture_layout, 'add')
    returning_values :id_photo;
  end

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC - profile_person_modify$profile(:profile_uuid=>'
    || coalesce(:profile_uuid, '<null>')
    || ', :operation=>' || coalesce(:op, '<null>')
    || ', :email=>' || coalesce(:email, '<null>')
    || ', :birth_date=>' || coalesce(:birth_date, '<null>')
  || ')');
  execute procedure profile_person_modify$profile(
    :profile_id,
    :id_guest_type,
    :profile_name,
    null,
    :sex,
    :birth_date,
    :birth_place,
    :personal_number,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :pass_place,
    :pass_exp_date,
    :country,
    :pass_city,
    :pass_address,
    :mask,
    :phone,
    :fax,
    :email,
    :city,
    :address,
    :note,
    :msg,
    :id_def_contragent,
    :market_segment_id,
    :is_archive,
    :id_photo,
    :card_code,
    :wbe_password,
    :op,
    :account_no,
    :title,
    :is_exclusive_debt_ownership
  ) returning_values
    :profile_id;

  /*assign uuid to the new profiles*/
  if ('add' = :op) then begin
    update profile set uuid=:profile_uuid where id_profile=:profile_id;
  end

  select record_timestamp from profile where id_profile=:profile_id
  into :import_time;

  if (:MERGE_TARGET_UUID is not null) then begin
    select p.ID_PROFILE
    from   PROFILE P
    where  P.UUID = :MERGE_TARGET_UUID
    into   :profile_receiver_id;

    execute procedure PROFILE_MERGE$PROFILE (:PROFILE_ID, :profile_receiver_id, 'merge');

  end

end
^

/* Restore proc. body: PMS_EXPENSE_POSTING_CREATE$PMS */
ALTER PROCEDURE PMS_EXPENSE_POSTING_CREATE$PMS(ID_ROOM TYPE OF ID,
ID_OWNER TYPE OF ID,
ID_RENTAL_POOL TYPE OF ID_REF,
ID_SERVICE TYPE OF ID,
ID_CURRENCY TYPE OF TCURRENCY,
POST_VALUE TYPE OF TPRICE,
IS_ACC_POST_ITEM TYPE OF TLOGICAL,
MANUAL_POST_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
IS_POST_PER_POOL TYPE OF TLOGICAL)
 AS
declare variable no_use_id_acc_post integer;
declare variable no_use_id_acc_post$pms integer;
begin
  for
    select PE.NEW_ID_ACCOUNT_POST, PE.NEW_ID_ACCOUNT_POST$PMS
    from PMS_EXPENSE_POSTS_CREATE$INT(:ID_ROOM, :ID_OWNER, :ID_RENTAL_POOL, :ID_SERVICE,
         :ID_CURRENCY, :POST_VALUE, :IS_ACC_POST_ITEM, :MANUAL_POST_DATE, :DESCRIPTION, :IS_POST_PER_POOL) PE
    into :no_use_id_acc_post, :no_use_id_acc_post$pms
  do begin

  end
end
^

/* Restore proc. body: PMS_POOL_DISTRIBUTION */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION(ID_RENTAL_POOL INTEGER,
FOR_DATE DATE)
 AS
declare variable total_value_per_service numeric(15,4);
  declare variable id_service integer;
  declare variable curr varchar(3);
  declare variable id_room_param integer;
  declare variable is_room_pool smallint;
  declare variable is_owner_income smallint;

  declare variable is_acc_post_item smallint;
  declare variable new_id_owner_bill integer;
  declare variable id_account_post_pms integer;
  declare variable id_pool_account integer;

  declare variable id_account_pms integer;
  declare variable value_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable value_post numeric(15,4);
  declare variable curr_post varchar(3);
  declare variable id_room integer;
  declare variable date_post date;
  declare variable id_reserv_detail integer;
  declare variable doc_description varchar(255);
  declare variable id_doc_head integer;
  declare variable description varchar(255);
  declare variable is_client_account_post smallint;
  declare variable id_event_lst varchar(5000);
begin
  is_room_pool = null;
  select U.IS_ROOM_POOL, U.ID_ROOM_PARAM
  from   OWNER$PMS O
         join RENTAL_POOL_UNIT$PMS U on U.ID_RENTAL_POOL_UNIT = O.ID_RENTAL_POOL_UNIT
  where  O.ID_OWNER = :ID_RENTAL_POOL
  into   :is_room_pool, :id_room_param;
  if (:is_room_pool is null) then exception PMS_EXCEPTION;

  select cast(list(distinct AP.ID_PMS_EVENT) as varchar(5000))
  from   ACCOUNT_POST$PMS AP
         join ACCOUNT$PMS AC on AC.ID_ACCOUNT = AP.ID_ACCOUNT_PMS
  where  AP.DATE_POST <= :FOR_DATE
         and AP.LINE_STATUS = 11
         and AC.ID_OWNER = :ID_RENTAL_POOL
         and AC.IS_SHADOW = 0
  into   :id_event_lst;

  for
    select sum(AP1.VALUE_POST), AP1.ID_SERVICE, AP1.CURR_POST, AP1.IS_OWNER_INCOME,
           ACC.IS_CLIENT_POOL_ACCOUNT, ACC.ID_ACCOUNT
    from   ACCOUNT_POST$PMS AP1
           join ACCOUNT$PMS ACC on ACC.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS
           join SYSTEM_STRING_PARSER(:id_event_lst, ',') S on S.ITEM = AP1.ID_PMS_EVENT
    where  AP1.LINE_STATUS = 11
           and ACC.IS_SHADOW = 0
    group by 2,3,4,5,6
    into   :total_value_per_service, :id_service, :curr, :is_owner_income,
           :is_acc_post_item, :id_pool_account
  do begin
    execute procedure PMS_POOL_DISTRIBUTION_SUB(:ID_RENTAL_POOL, :id_pool_account,
            :IS_ROOM_POOL, :ID_ROOM_PARAM, :total_value_per_service,
            :ID_SERVICE, :CURR, :IS_OWNER_INCOME, :FOR_DATE, :is_acc_post_item);
  end

  NEW_ID_OWNER_BILL = gen_id(GEN_OWNER_BILL$PMS_ID, 1);

  insert into OWNER_BILL$PMS (ID_OWNER_BILL, ID_OWNER, BILL_DATE, IS_ANUL, BILL_NUM,
         IS_EXPORTED_TO_INTRANET, IS_POOL_DISTRIBUTION_STATEMENT)
  values (:NEW_ID_OWNER_BILL, :ID_RENTAL_POOL, :FOR_DATE, 0, :NEW_ID_OWNER_BILL, 0, 1);

  update OWNER$PMS O
  set    O.LAST_BILLING_DATE = :for_date,
         O.ID_OWNER_BILL = :NEW_ID_OWNER_BILL
  where  O.ID_OWNER = :ID_RENTAL_POOL;

  for
    select AP.ID_ACCOUNT_POST, AP.VALUE_ORIG, AP.CURR_ORIG, AP.VALUE_POST, AP.CURR_POST,
           ACC.ID_ACCOUNT, AP.IS_OWNER_INCOME, AP.ID_SERVICE, E.ID_ROOM, AP.DATE_POST,
           E.ID_RESERV_DETAIL, E.ID_DOC_HEAD, E.DOC_DESCRIPTION, E.DESCRIPTION, ACC.IS_CLIENT_POOL_ACCOUNT
    from   PMS_EVENT$PMS E
           join ACCOUNT_POST$PMS AP on ap.ID_PMS_EVENT = e.ID_PMS_EVENT
                                       and AP.LINE_STATUS = 11
           join ACCOUNT$PMS ACC on ACC.ID_ACCOUNT = AP.ID_ACCOUNT_PMS
                                   and ACC.ID_OWNER = :ID_RENTAL_POOL
                                   and ACC.IS_SHADOW = 0
    where  ((E.ID_SESSION = current_transaction) or (','||:id_event_lst||',' containing  ','||E.ID_PMS_EVENT||','))
    into   :id_account_post_pms, :VALUE_ORIG, :CURR_ORIG, :VALUE_POST, :CURR_POST,
           :ID_ACCOUNT_PMS, :IS_OWNER_INCOME, :ID_SERVICE, :ID_ROOM, :DATE_POST,
           :ID_RESERV_DETAIL, :ID_DOC_HEAD, :DOC_DESCRIPTION, :DESCRIPTION, :is_client_account_post
  do begin
    insert into OWNER_BILL_ROW$PMS (ID_OWNER_BILL, ID_ACCOUNT_POST, ID_ACCOUNT,
           ID_ACCOUNT_POST_PMS, ID_ACCOUNT_PMS, ID_SERVICE, VALUE_ORIG,
           CURR_ORIG, VALUE_POST, CURR_POST, IS_OWNER_INCOME, ID_ROOM, DATE_POST,
           ID_RESERV_DETAIL, DOC_DESCRIPTION, ID_DOC_HEAD, DESCRIPTION, IS_CLIENT_ACCOUNT_POST)
    values (:new_id_owner_bill, null, null,
           :ID_ACCOUNT_POST_PMS, :ID_ACCOUNT_PMS, :ID_SERVICE, :VALUE_ORIG,
           :CURR_ORIG, :VALUE_POST, :CURR_POST, :IS_OWNER_INCOME, :ID_ROOM, :DATE_POST,
           :ID_RESERV_DETAIL, :DOC_DESCRIPTION, :ID_DOC_HEAD, :DESCRIPTION, :is_client_account_post);

    update ACCOUNT_POST$PMS A
    set    A.LINE_STATUS = 21
    where  A.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS;
  end
end
^

/* Restore proc. body: PRODUCT_RATING$INT */
ALTER PROCEDURE PRODUCT_RATING$INT(ID_HOTEL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
ADULT_AGES VARCHAR(100) = null,
CHILD_AGES VARCHAR(100) = null,
ID_TAR_CALC_COMMON INTEGER = null)
 RETURNS(ROOM_PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100))
 AS
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable id_reserv integer;
declare variable id_tar_calc integer;
declare variable rate_currency char(3);
begin
  id_tar_calc = null;
  select T.CURR
  from   TARIFA T
  where  t.ID_TARIFA = :ID_RATE
  into   :rate_currency;

  execute procedure TAR_CALC_INPUT_PLAIN$INT (:adult_count, :children_count,
          :id_room_type, :id_board, :arrival_date, :departure_date,
          '', '', null, '', null, null, :id_rate, :adult_ages, :child_ages, :ID_TAR_CALC_COMMON)
  returning_values (:id_tar_calc, :id_reserv, :err_code, :err_text);
  --if (:err_code < 0) then exit;

  if (:err_code = 0) then begin
    execute procedure TAR_CALC_EVAL_ALL$INT(:id_tar_calc)
    returning_values  :err_code, :err_text;
    /*savedbg('-----------------------------');
    savedbg('id_rate: ' || :id_rate);
    savedbg('id_board: ' || :id_board);
    savedbg('id_room_type: ' || :id_room_type);
    savedbg('id_tar_calc: ' || :id_tar_calc);
    savedbg('err_code: ' || :ERR_CODE);
    savedbg('err_text: ' || :ERR_TEXT);
    */
    if (:err_code = 0) then begin
      execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

      price_currency = :rate_currency;
      execute procedure TAR_CALC_GET_PRICE$INT (:id_tar_calc, :id_hotel, :id_reserv, :price_currency)
      returning_values  :room_price, :room_price_details;
    end
  end
end
^

/* Restore proc. body: REP_ROOM_STATUS$INT */
ALTER PROCEDURE REP_ROOM_STATUS$INT(FOR_DATE DATE,
STAT_OPTIONS VARCHAR(255),
PRIVATE_STATUS_ADDING SMALLINT = 0)
 RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
SECTOR INTEGER,
ID_ROOM_TYPE INTEGER,
TYPE_ROOM VARCHAR(20),
IS_CLEAN INTEGER,
IS_INSPECTED INTEGER,
CLEAN_TEXT VARCHAR(30),
IS_LEAVING SMALLINT,
IS_COMMING SMALLINT,
IS_SHARED SMALLINT,
IS_LEAVING_WORDS VARCHAR(30),
BUSY_GRP INTEGER,
DAYS_THIS_STATUS INTEGER,
DTS_CONTEXT VARCHAR(10),
COMMING_OCCUPANTS VARCHAR(1024),
ID_BLOCK_ROOM INTEGER,
OTHER_OCCUPANTS VARCHAR(1024),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ID_HOTEL INTEGER,
HAS_OPENED_POSTINGS SMALLINT)
 AS
declare variable dbg varchar(6000);
  declare variable id_room_tmp integer;
  declare variable id_room_magic integer;
  declare variable occupant_id integer;
begin
  for
    select RM.ID_ROOM_MAGIC, RM.ID_ROOM
    from   ROOMS R
           join TMP_SMART_ROOMS TSR on TSR.ID_ROOM = R.ID_ROOM
                and TSR.ID_SESSION = current_connection
           join ROOM_MAGIC RM on RM.ID_ROOM = R.ID_ROOM
    where  RM.BUSY_DATE = :for_date
    into   :id_room_magic, :id_room_tmp
  do begin
    insert into TMP_HM_ROOM_STATUS (ID_ROOMS_MAGIC, ID_SESSION, ID_ROOM)
    values (:id_room_magic, current_transaction, :id_room_tmp);
  end

  for
    select R.ID_ROOM, R.ROOM_NAME, R.FLOOR, R.ID_ROOM_TYPE,
           R.IS_CLEAN, R.CLEAN_TEXT, R.IS_INSPECTED,
           RT.TYPE_ROOM, RT.ID_HOTEL, R.SECTOR
    from   (select distinct P.ID_ROOM
            from   TMP_SMART_ROOMS TSR
                   join ROOM_PERIOD$PMS P on P.ID_ROOM = TSR.ID_ROOM
            where  TSR.ID_SESSION = current_connection
                   and ((P.IS_AVAILABLE = 1) or (:private_status_adding = 1))
                   and P.FROM_DATE <= :for_date
                   and P.TO_DATE >= :for_date) AVR
           join ROOMS R on AVR.ID_ROOM = R.ID_ROOM
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    into   :id_room, :room_name, :floor, :id_room_type,
           :is_clean, :clean_text, :is_inspected,
           :type_room, :id_hotel, :sector
  do begin

    execute procedure REP_ROOM_STATUS_BUILD$INT(:id_room, :for_date, :stat_options)
    returning_values  :is_leaving, :is_comming, :is_shared, :is_leaving_words, :busy_grp,
                      :days_this_status, :dts_context, :comming_occupants, :id_block_room,
                      :other_occupants, :adult_count, :children_count;

    is_comming = iif(:comming_occupants = '', 0, 1);

    HAS_OPENED_POSTINGS = 0;
    for
      select distinct sp.ITEM
      from   SYSTEM_STRING_PARSER (:other_occupants || ',' || :COMMING_OCCUPANTS, ',') SP
      into   :occupant_id
    do begin
      execute procedure RES_GET_BALLANCE$INT (:occupant_id)
      returning_values :dbg, :dbg, :dbg, :HAS_OPENED_POSTINGS, :dbg;
      if (:HAS_OPENED_POSTINGS = 1) then break;
    end

    suspend;

  end

  delete from TMP_HM_ROOM_STATUS HM
  where  HM.ID_SESSION = current_transaction;
end
^

/* Restore proc. body: RES_CHECKIN$RSV */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable old_check_status integer;
  declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable is_anul integer;
  declare variable arrival_date date;
  declare variable system_date date;
begin
  /*  Description:
  ||
  */
  select RD.CHECK_STATUS, RD.RDB$DB_KEY, RD.FROM_DATE, RD.ID_HOTEL,
         RD.ID_ROOM, RD.IS_ANUL
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_check_status, :rd_dbkey, :arrival_date, :id_hotel,
         :old_id_room, :is_anul;

  if (:is_anul = 1) then exception BOOKING_EXCEPTION '-2';

  if (:old_check_status >= 0) then exception BOOKING_EXCEPTION '-1003';

  if (:old_id_room < 0 and coalesce(:ID_ROOM, 0) <= 0) then exception BOOKING_EXCEPTION '-1018';

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date < :arrival_date) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CHECK_IN_FUTURE');
  end
  /*----*/
  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'lock');

  execute procedure sys_dbg('occ RES_CHECKIN$RSV id_room = '||coalesce(:id_room, 'null'));
  execute procedure sys_dbg('occ RES_CHECKIN$RSV old_id_room = '||coalesce(:old_id_room, 'null'));

  if (:id_room is not null) then begin
    if (:old_check_status = -3) then begin
      execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, -2);
    end

    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option)
    returning_values (:WARN_CODE);
  end

  execute procedure RES_SET_CHECKIN$INT (:rd_dbkey)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'release');
  /*----*/
  select f_character(29) || R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = coalesce(:ID_ROOM, :old_id_room)
  into   :action_text;
   
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'CHECK_IN', :action_text);

end
^

/* Restore proc. body: RES_CHECKIN_MULTI$RSV */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable checkin_count integer;
  declare variable split_on_checkin integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
  declare variable tmp_warn_code integer;
begin
  checkin_count = 0;
  warn_code = null;
  for
    select RD.ID_RESERV_DETAIL, RD.CHECK_STATUS, RD.SPLIT_ON_CHECKIN, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :SELECTION_ID
    into   :id_reserv_detail, :check_status, :split_on_checkin, :id_titular
  do begin
    if (:check_status >= 0) then begin
      checkin_count = :checkin_count + 1;
    end else begin
      if (:split_on_checkin = 1) then begin
        for
          select G.ID_GUEST
          from   GUEST G
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and G.ID_GUEST <> :id_titular
          into   :id_guest
        do begin
          execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
          returning_values  :id_splited_reservation;

          execute procedure RES_CHECKIN$RSV (:id_splited_reservation)
          returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

          update RESERV_DETAIL RD
          set    RD.SELECTION_ID = :selection_id
          where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
        end
      end

      execute procedure RES_CHECKIN$RSV (:id_reserv_detail)
      returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
      WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end

  if (:checkin_count > 0) then begin
    execute procedure SYSTEM_WARNING_ADD(-1011, f_character(29)||:checkin_count)
    returning_values  :warn_code;
  end
end
^

/* Restore proc. body: RES_CREATE_SET$EXC */
ALTER PROCEDURE RES_CREATE_SET$EXC(ID_RESERV_DETAIL INTEGER,
RES_NUMBER VARCHAR(62),
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER,
CREATE_DATETIME TIMESTAMP)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_RESERV_DETAIL INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  WARN_CODE = 0;
  SHARE_TRANSACTION_ID = 0;
  SHARE_ERR_CODE = 0;

  execute procedure sys_dbg('exc RES_CREATE_SET$EXC => RES_CREATE_SET$INT('
  || 'code_first_food=>' || coalesce(:code_first_food, '<null>')
  || ', id_person_payment=>' || coalesce(:id_person_payment, '<null>')
  || ')');

  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, null, :arrival_date, :departure_date,
                    :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, '', :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders, :guarantee_deposit,
                    :guarantee_currency, 0, :id_reserv_detail, :res_number, null,  :id_guarantee_policy, :block_cc,
                    :id_eating_object)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :warn_code;

  execute procedure UPDATE_POSTING_TRANSACTION$EXC(:rd_dbkey, :posting_transaction_uuid, 1);

  execute procedure RES_SAVE_GUARANTEE$RSV(:id_reserv_detail, :is_vip, null,
    :id_guarantee_policy, :guarantee_deposit, :guarantee_currency, :block_cc, :guarantee_deposit_percent,
    :guarantee_deposit_nights, :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create
  );

  execute procedure RESERV_DETAIL_EXTERNAL_MOD$RSV(:id_reserv_detail,
    :minibar_rights, :paytv_rights, :video_rights, :nopost_pms, :phone_rights,
    :seminar_cahnnel_rights, null
  );

  if (:create_datetime is not null) then begin
    update reserv_detail set create_datetime = :create_datetime where rdb$db_key = :rd_dbkey;
  end
end
^

/* Restore proc. body: RES_EARLY_DEPARTURE_SET$RSV */
ALTER PROCEDURE RES_EARLY_DEPARTURE_SET$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND INTEGER)
 RETURNS(RECALC_MARKER_LIST VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable sys_date date;
  declare variable stay integer;
  declare variable rd_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable id_hotel integer;
  declare variable hotels_cnt integer;
  declare variable arrival_date date;
  declare variable is_late_departure smallint;
  declare variable comming_kind smallint;
  declare variable dep_date date;
begin
  /* CHECK_OUT_kind =
  || 1 - DO NOT MODIFY GUEST
  || 2 - SHRINK PERIOD AND OCCUPANCY
  || 3 - DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
  */
  execute procedure RIGHTS_CHECK_GRANTED$INT('CHECK_OUT_EARLY');

  select min(RD.ID_HOTEL), count(distinct RD.ID_HOTEL)
  from   RESERV_DETAIL RD
  where  RD.SELECTION_ID = :SELECTION_ID
  into   :id_hotel, :hotels_cnt;

  if (:hotels_cnt > 1) then exception RESERV_CHECK_OUT_EXCEPTION '-1020';

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values  :sys_date;

  RECALC_MARKER_LIST = null;
  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL, rd.FROM_DATE, rd.TO_DATE, RD.LEAVING_KIND - 1, rd.COMMING_KIND
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :rd_dbkey, :id_reserv_detail, :arrival_date, :dep_date, :is_late_departure, :comming_kind
  do begin
    if ((:check_out_kind = 2) and (:dep_date > :sys_date)) then begin
      -- SHRINK PERIOD AND OCCUPANCY
      execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :sys_date, :is_late_departure, :comming_kind);
    
      execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
      returning_values  :warn_code;

    end else if ((:check_out_kind = 1) and (:dep_date > :sys_date)) then begin
      /* KEEP BOOKING STAY PERIOD AND ROOM OCCUPANCY */
      for
        select G.TO_DATE - :sys_date
        from   GUEST G
        where  G.ID_RESERV_DETAIL = :id_reserv_detail
        into   :stay
      do begin
  --      if (:check_out_kind = 1) then begin
        if (:stay > 1) then begin
            --THE DEPARTURE DATE IS LATER THAN NEXT DATE. STAY SHOULD BE CHANGED MANUALY.;
            exception RESERV_CHECK_OUT_EXCEPTION '-323';
        end
      end
    end
  end
end
^

/* Restore proc. body: RES_FINALIZE$INT */
ALTER PROCEDURE RES_FINALIZE$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable err_text varchar(255);
begin
  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, :SUPPRESS_NON_INSTANT_ERRORS)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;
  if (:share_err_code < 0) then exception BOOKING_EXCEPTION :share_err_code || f_character(31) || :ERR_TEXT;
end
^

/* Restore proc. body: RES_GUEST_CHANGE$RSV */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable id_guest integer;
  declare variable check_status integer;
  declare variable id_person_data integer;
  declare variable old_person_profile integer;
  declare variable old_profile_name varchar(100);
  declare variable new_profile_name varchar(100);
begin
  select r.RDB$DB_KEY, r.ID_TITULAR, r.CHECK_STATUS, r.ID_PERSON_PROFILE, p.PROFILE_NAME
  from   RESERV_DETAIL R
         join PROFILE P on P.ID_PROFILE = r.ID_PERSON_PROFILE
  where  R.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey, :id_guest, :check_status, :old_person_profile, :old_profile_name;

  if (:old_person_profile = :ID_PERSON_PROFILE) then exit; -- NO CHANGES!

  id_person_data = null;
  select pp.ID_PERSON_DATA, p.PROFILE_NAME
  from   PROFILE_PERSON PP
         join PROFILE P on P.ID_PROFILE = pp.ID_PROFILE
  where  pp.ID_PROFILE = :ID_PERSON_PROFILE
  into   :id_person_data, :new_profile_name;

  if (:id_person_data is null) then exception BOOKING_EXCEPTION '-1039';

  update RESERV_DETAIL RD
  set    rd.ID_PERSON_PROFILE = :ID_PERSON_PROFILE
  where  rd.RDB$DB_KEY = :rd_dbkey;

  if (:check_status = 1) then begin
    execute procedure PERSON_DATA_COPY$INT (:id_person_data)
    returning_values (:id_person_data);
  end

  update GUEST_DATA GD
  set    gd.ID_PERSON_DATA = :id_person_data
  where  gd.ID_GUEST = :id_guest;

  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey);

  if (exists (select ap.ID_ACCOUNT_POST
              from   ACCOUNT_POST AP
                     join ACCOUNT A on A.ID_ACCOUNT = ap.ID_ACCOUNT
              where  a.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                     and a.ID_PROFILE = :old_person_profile
                     and ap.IS_ANUL = 0)) then
    exception BOOKING_EXCEPTION '-1038';

  if (exists (select d.ID_DEPOSIT
              from   DEPOSITS D
                     join ACCOUNT A on A.ID_ACCOUNT = d.ID_ACCOUNT
              where  a.ID_PROFILE = :old_person_profile
                     and coalesce(d.ID_RESERV_DETAIL, a.ID_RESERV_DETAIL) = :ID_RESERV_DETAIL
                     and d.RECEIVED_AMOUNT > 0)) then
    exception BOOKING_EXCEPTION '-1040';

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'TITULAR_CHANGED',
          f_character(29) || :old_profile_name || f_character(28) || :new_profile_name, null);

end
^

/* Restore proc. body: RES_RECALC$INT */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable num_prefix varchar(20);
  declare variable number_1 varchar(20);
begin
  /* CALLER_KIND = {NORMAL, FORCED} */
  err_code = 0;
  /* 1. GET DATA */
  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL, rd.NUMBER_1
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :check_status, :id_reserv_detail, :number_1;

  if (:check_status = 1) then begin
    -- CHECKED OUT
    select sn.LEADING_PART
    from   SYSTEM_NUMERATOR SN
    where  sn.ID_NUMERATOR = 0
    into   :num_prefix;

    if (trim('.' from coalesce(:num_prefix, '')) = coalesce(:number_1, '')) then
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_MINE');
    else
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_ELSE');

    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :id_guest
    do begin
      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'MANUAL_EDIT_DATA', '');
    end
  end
  /* 2. FIND DEPENDANT GUESTS AND THEIR TARIFFS */
  execute procedure sys_dbg('calc RES_RECALC$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

  id_tar_calc = gen_id(gen_id_tar_calc, 1);
  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NONE');

  execute procedure TAR_CALC_EVAL_ALL$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  -- 3. UPDATE ROOM PRICE and REPOST ALL AFFECTED BOOKINGS
  execute procedure RES_TAR_CALC_FINALIZE$INT (:ERR_CODE, :ID_TAR_CALC, :RD_DBKEY, :CALLER_KIND, :FORCE_POSTING);

end
^

/* Restore proc. body: RES_ROOM_REMOVE$INT */
ALTER PROCEDURE RES_ROOM_REMOVE$INT(RD_DBKEY CHAR(8))
 RETURNS(WARN_CODE INTEGER)
 AS
begin

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, gen_id(DETAIL_WITHOUT_ROOMING_LIST, -1), null, 'nrttAsIs')
  returning_values (:WARN_CODE);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 0)
  returning_values  :WARN_CODE;

end
^

/* Restore proc. body: RES_SAVE_ACCOUNTING$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
declare variable old_id_agent_profile integer;
  declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable action_text varchar(255);
  declare variable old_account_routing varchar(30);
  declare variable id_acc_profile integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:acc_routing, 'GUEST, AGENT, MIXED, OWNER, FULL_COMPLIMENTARY, PART_COMPLIMENTARY', 'Account routing');

  if (exists (select *
              from   PROFILE_HOUSE PH
              where  PH.ID_PROFILE = :id_agent_profile)) then
  begin
    exception BOOKING_EXCEPTION '-1016';
  end

  execute procedure RESERV_TRACK_CHANGES$INT(:rd_dbkey);

  select RD.ID_AGENT_PROFILE, RD.ID_RESERV_DETAIL, RD.ACC_ROUTING
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_agent_profile, :id_reserv_detail, :old_account_routing;

  if (:ACC_ROUTING in ('AGENT','MIXED') and :ID_AGENT_ACCOUNT is not null) then begin
    select A.ID_PROFILE
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :ID_AGENT_ACCOUNT
    into   :id_acc_profile;
    -- check up agent account ownership
    if (:id_acc_profile is distinct from :ID_AGENT_PROFILE) then ID_AGENT_ACCOUNT = null;
  end

  update RESERV_DETAIL RD
  set    RD.ID_AGENT_ACCOUNT_RULE = :ID_AGENT_ACCOUNT,
         RD.ACC_ROUTING = :ACC_ROUTING,
         RD.ID_AGENT_PROFILE = :ID_AGENT_PROFILE,
         RD.ID_AGENT_PAYMENT = :ID_AGENT_PAYMENT,
         RD.ID_PERSON_PAYMENT = coalesce(:ID_PERSON_PAYMENT, RD.ID_PERSON_PAYMENT),
         RD.ID_GROUP = :ID_GROUP
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_id_agent_profile is distinct from :id_agent_profile) then begin
    execute procedure RES_SET_EDIT_STATUS$INT(:RD_DBKEY, 'AGENT', 'add');

    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :g_dbkey
    do begin
      execute procedure GUEST_AGENT_SET$INT(:g_dbkey, :id_agent_profile);
    end

    select f_character(29)||coalesce(old_A.PROFILE_NAME, '')||f_character(28)||coalesce(new_A.PROFILE_NAME, '')
    from   PROFILE old_A, PROFILE new_A
    where  old_A.ID_PROFILE = :old_id_agent_profile
           and new_A.ID_PROFILE = :ID_AGENT_PROFILE
    into   :action_text;

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_AGENT', :action_text);
  end

  if (:ACC_ROUTING <> :old_account_routing) then begin
    action_text = f_character(29) || coalesce(:old_account_routing, '')
                  || f_character(28) || coalesce(:acc_routing, '');

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_ACC_ROUTING', :action_text);
  end

  execute procedure RES_SAVE_ACCOUNTS$INT (:RD_DBKEY);
end
^

/* Restore proc. body: RES_SAVE_ROOM$EXC */
ALTER PROCEDURE RES_SAVE_ROOM$EXC(RD_DBKEY CHAR(8),
ID_RES_ROOM_TYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(250),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_room integer;
begin
  select RD.ID_ROOM, RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_room, :id_reserv_detail;

  execute procedure RES_SAVE_ROOM$RSV(
    :id_reserv_detail,
    :old_id_room,
    :id_res_room_type,
    'nrttAsIs',
    1,
    :id_hk_plan,
    :room_features,
    :i_special_treatment,
    :split_on_checkin,
    0
  ) returning_values :share_err_code, :err_text, :share_transaction_id, :warn_code;
end
^

/* Restore proc. body: SAFE_CHECK_OUT */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE TYPE OF ID)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
WARN_CODE TYPE OF ID_REF)
 AS
declare variable to_dt timestamp;
  declare variable is_occupied integer;
  declare variable expire_tollerance integer;
  declare variable occupant_name varchar(100);
  declare variable id_resource_reservation integer;
  declare variable check_out_datetime timestamp;
begin
  DOC_SELECTED = null;
  select s.IS_OCCUPIED, od.TO_DATETIME,
         st.EXPIRE_TOLLERANCE, rr.OCCUPANT_NAME, rr.ID_RESOURCE_RESERVATION
  from   SAFE s
         join RESOURCE$INT r on r.ID_RESOURCE = s.ID_SAFE
         join SAFE_TYPES st on st.ID_SAFE_TYPE = r.ID_RESOURCE_TYPE
         join RESOURCE_RESERVATION rr on rr.ID_RESOURCE_RESERVATION = s.ID_CURRENT_OCCUPANCY
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join RESOURCE_OCCUPANCY ro on ro.ID_RESOURCE_OCCUPANCY_DATA = od.ID_RESOURCE_OCCUPANCY_DATA
  where  s.ID_SAFE = :ID_SAFE
  into   :is_occupied, :to_dt, :expire_tollerance, :occupant_name, :id_resource_reservation;

  if (:is_occupied = 0) then exit;

  expire_tollerance = coalesce(:expire_tollerance, 0);
  check_out_datetime = current_timestamp;

  execute procedure SAFE_OCCUPANCY_MODIFY (:id_safe, current_timestamp, :occupant_name)
  returning_values  :DOC_SELECTED;

  if (:check_out_datetime > (:to_dt + cast(:expire_tollerance as double precision) / 60 / 24)) then begin
    execute procedure SYSTEM_WARNING_ADD (-1066, f_character(29) || :expire_tollerance || f_character(28) || formatdate(:to_dt + cast(:expire_tollerance as double precision) / 60 / 24, 'D;dd/mm/yyyy HH:MM'))
    returning_values (:WARN_CODE);
  end

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = null
  where  s.ID_SAFE = :ID_SAFE;

  update RESOURCE_RESERVATION rr
  set    rr.STATUS = 'CHECKED_OUT'
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_CHECKED_OUT', :occupant_name);
end
^

/* Restore proc. body: TAR_CALC_INPUT_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_PARAMS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_input integer;
  declare variable id_guest integer;
  declare variable for_date date;
  declare variable id_calc_tariff integer;
  declare variable td_dbkey char(8);
  declare variable date_independent_param_values varchar(2000);
  declare variable date_dep_param_values varchar(2000);
  declare variable prev_id_guest integer;
  declare variable prev_id_tariff integer;
begin
  prev_id_guest = null;
  prev_id_tariff = null;
  for
    select Td.RDB$DB_KEY, TI.ID_TAR_INPUT, ti.ID_GUEST, td.FOR_DATE, td.ID_TAR_HEAD
    from   TAR_CALC_INPUT$TMP TI
           join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
    where  TI.ID_TAR_CALC = :id_tar_calc
    order by ti.ID_GUEST asc, td.FOR_DATE asc
    into   :td_dbkey, :id_tar_input, :id_guest, :for_date, :id_calc_tariff
  do begin
    if ((:id_guest is distinct from :prev_id_guest)
        or (:id_calc_tariff is distinct from :prev_id_tariff)) then
    begin
      /* get date independent params */
      execute procedure TAR_CALC_PARAMS$INT (:id_calc_tariff, :id_tar_input, :ID_TAR_CALC, null, null)
      returning_values (:ERR_CODE, :date_independent_param_values);
      if (:ERR_CODE < 0) then exit;
      prev_id_guest = :id_guest;
      prev_id_tariff = :id_calc_tariff;
    end

    execute procedure TAR_CALC_PARAMS$INT (:id_calc_tariff, :id_tar_input, :ID_TAR_CALC, :for_date, null)
    returning_values (:ERR_CODE, :date_dep_param_values);
    if (:ERR_CODE < 0) then exit;

    update TAR_CALC_INPUT_DETAIL$TMP d
    set    d.PARAM_VALUES = coalesce(:date_independent_param_values, '') || ';'
                            || coalesce(:date_dep_param_values, '')
    where  d.RDB$DB_KEY = :td_dbkey;
  end
end
^

SET TERM ; ^

ALTER TABLE PMS_ROOM_DOCS$TMP ALTER COLUMN ID_ROOM POSITION 1;

ALTER TABLE PMS_ROOM_DOCS$TMP ALTER COLUMN FOR_DATE POSITION 2;

ALTER TABLE PMS_ROOM_DOCS$TMP ALTER COLUMN ID_DOC_HEAD POSITION 3;

ALTER TABLE PMS_ROOM_DOCS$TMP ALTER COLUMN ID_RESERV_DETAIL POSITION 4;

ALTER TABLE PMS_ROOM_DOCS$TMP ALTER COLUMN POST_NET_VALUE POSITION 5;

ALTER TABLE PMS_ROOM_DOCS$TMP ALTER COLUMN POST_GROSS_VALUE POSITION 6;

ALTER TABLE PMS_ROOM_DOCS$TMP ALTER COLUMN NAT_NET_VALUE POSITION 7;

ALTER TABLE PMS_ROOM_DOCS$TMP ALTER COLUMN NAT_GROSS_VALUE POSITION 8;

ALTER TABLE PMS_ROOM_DOCS$TMP ALTER COLUMN NIGHTS POSITION 9;

ALTER TABLE PMS_ROOM_DOCS$TMP ALTER COLUMN ID_ROOM_CONTRACT POSITION 10;

ALTER TABLE PMS_ROOM_DOCS$TMP ALTER COLUMN ID_ROOM_PERIOD POSITION 11;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_RESERV_DETAIL POSITION 1;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_HOTEL POSITION 2;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_ROOM_TYPE POSITION 3;

ALTER TABLE RESERV_DETAIL ALTER COLUMN FROM_DATE POSITION 4;

ALTER TABLE RESERV_DETAIL ALTER COLUMN TO_DATE POSITION 5;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ADULT_COUNT POSITION 6;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CHILD_COUNT POSITION 7;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CHECK_STATUS POSITION 8;

ALTER TABLE RESERV_DETAIL ALTER COLUMN IS_ANUL POSITION 9;

ALTER TABLE RESERV_DETAIL ALTER COLUMN REASON_OF_ANUL POSITION 10;

ALTER TABLE RESERV_DETAIL ALTER COLUMN RES_STATUS POSITION 11;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_ROOM POSITION 12;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ROOM_FEATURES POSITION 13;

ALTER TABLE RESERV_DETAIL ALTER COLUMN VIRTUAL_ROOM POSITION 14;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_BOARD POSITION 15;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CODE_FIRST_FOOD POSITION 16;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_GROUP POSITION 17;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_AGENT_PROFILE POSITION 18;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_AGENT_PAYMENT POSITION 19;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_AGENT_ACCOUNT_RULE POSITION 20;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ACC_ROUTING POSITION 21;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_BASE_ACCOUNT POSITION 22;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_EXTRA_ACCOUNT POSITION 23;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_AGENT_ACCOUNT POSITION 24;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_PERSON_PROFILE POSITION 25;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_ACC_TEMPLATE_PERSON POSITION 26;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_PERSON_PAYMENT POSITION 27;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_TITULAR POSITION 28;

ALTER TABLE RESERV_DETAIL ALTER COLUMN COUNTRY POSITION 29;

ALTER TABLE RESERV_DETAIL ALTER COLUMN VAUCHER_NUM POSITION 30;

ALTER TABLE RESERV_DETAIL ALTER COLUMN VAUCHER_DATE POSITION 31;

ALTER TABLE RESERV_DETAIL ALTER COLUMN VAUCHER_NUM2 POSITION 32;

ALTER TABLE RESERV_DETAIL ALTER COLUMN VAUCHER_DATE2 POSITION 33;

ALTER TABLE RESERV_DETAIL ALTER COLUMN VAUCHER_TEXT POSITION 34;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_RATE POSITION 35;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ROOM_PRICE POSITION 36;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ROOM_CURRENCY POSITION 37;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ROOM_PRICE_DETAILS POSITION 38;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CUSTOM_PRICE POSITION 39;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CUSTOM_CURRENCY POSITION 40;

ALTER TABLE RESERV_DETAIL ALTER COLUMN HAS_DIFFERENT_VOUCHERS POSITION 41;

ALTER TABLE RESERV_DETAIL ALTER COLUMN HAS_DIFFERENT_ROOM_TYPE POSITION 42;

ALTER TABLE RESERV_DETAIL ALTER COLUMN HAS_DIFFERENT_BOARD POSITION 43;

ALTER TABLE RESERV_DETAIL ALTER COLUMN HAS_DIFFERENT_TYPE_STAY POSITION 44;

ALTER TABLE RESERV_DETAIL ALTER COLUMN HAS_DIFFERENT_TARIFF POSITION 45;

ALTER TABLE RESERV_DETAIL ALTER COLUMN HAS_DIFFERENT_OTHER POSITION 46;

ALTER TABLE RESERV_DETAIL ALTER COLUMN HAS_DIFFERENT_PRICE POSITION 47;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_HK_PLAN POSITION 48;

ALTER TABLE RESERV_DETAIL ALTER COLUMN IS_VIP POSITION 49;

ALTER TABLE RESERV_DETAIL ALTER COLUMN I_SPECIAL_TREATMENT POSITION 50;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_NOM_MARKET_SEGMENT POSITION 51;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_NOM_SOURCE_CODE POSITION 52;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_NOM_CHANNEL_CODE POSITION 53;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_NOM_HEAR_REASON POSITION 54;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_NOM_COME_REASON POSITION 55;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CREATE_DATETIME POSITION 56;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CHANGE_TIME POSITION 57;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_LOG_EVENT_CREATE POSITION 58;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_LOG_EVENT_ANNUL POSITION 59;

ALTER TABLE RESERV_DETAIL ALTER COLUMN RES_EDIT_STATUS POSITION 60;

ALTER TABLE RESERV_DETAIL ALTER COLUMN NOTE POSITION 61;

ALTER TABLE RESERV_DETAIL ALTER COLUMN NOTE_REMINDERS POSITION 62;

ALTER TABLE RESERV_DETAIL ALTER COLUMN SPLIT_ON_CHECKIN POSITION 63;

ALTER TABLE RESERV_DETAIL ALTER COLUMN EXP_DATE POSITION 64;

ALTER TABLE RESERV_DETAIL ALTER COLUMN COMMING_KIND POSITION 65;

ALTER TABLE RESERV_DETAIL ALTER COLUMN LEAVING_KIND POSITION 66;

ALTER TABLE RESERV_DETAIL ALTER COLUMN TRANSFER_IN_TIME POSITION 67;

ALTER TABLE RESERV_DETAIL ALTER COLUMN TRANSFER_IN_NOTE POSITION 68;

ALTER TABLE RESERV_DETAIL ALTER COLUMN TRANSFER_OUT_TIME POSITION 69;

ALTER TABLE RESERV_DETAIL ALTER COLUMN TRANSFER_OUT_NOTE POSITION 70;

ALTER TABLE RESERV_DETAIL ALTER COLUMN SELECTION_ID POSITION 71;

ALTER TABLE RESERV_DETAIL ALTER COLUMN SUBSCRIBER_ID POSITION 72;

ALTER TABLE RESERV_DETAIL ALTER COLUMN NUMBER_1 POSITION 73;

ALTER TABLE RESERV_DETAIL ALTER COLUMN NUMBER_2 POSITION 74;

ALTER TABLE RESERV_DETAIL ALTER COLUMN NUMBER_3 POSITION 75;

ALTER TABLE RESERV_DETAIL ALTER COLUMN NUMBER POSITION 76;

ALTER TABLE RESERV_DETAIL ALTER COLUMN BLOCK_CC POSITION 77;

ALTER TABLE RESERV_DETAIL ALTER COLUMN GUARANTEE_DEPOSIT POSITION 78;

ALTER TABLE RESERV_DETAIL ALTER COLUMN GUARANTEE_CURRENCY POSITION 79;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_GUARANTEE_POLICY POSITION 80;

ALTER TABLE RESERV_DETAIL ALTER COLUMN GUARANTEE_DEPOSIT_PERCENT POSITION 81;

ALTER TABLE RESERV_DETAIL ALTER COLUMN GUARANTEE_DEPOSIT_NIGHTS POSITION 82;

ALTER TABLE RESERV_DETAIL ALTER COLUMN GUARANTEE_DUE_DAYS_BEF_ARRIVAL POSITION 83;

ALTER TABLE RESERV_DETAIL ALTER COLUMN GUARANTEE_DUE_DAYS_AFTER_CREATE POSITION 84;

ALTER TABLE RESERV_DETAIL ALTER COLUMN GUARANTEE_EXPIRE_DATE POSITION 85;

ALTER TABLE RESERV_DETAIL ALTER COLUMN IS_POSTING_STOPPED POSITION 86;

ALTER TABLE RESERV_DETAIL ALTER COLUMN POSTING_TRANSACTION_UUID POSITION 87;

ALTER TABLE RESERV_DETAIL ALTER COLUMN EXC_LOCAL_VERSION POSITION 88;

ALTER TABLE RESERV_DETAIL ALTER COLUMN EXC_REMOTE_VERSION POSITION 89;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CONFIRMATION_NUMBER POSITION 90;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CANCELATION_NUMBER POSITION 91;

ALTER TABLE RESERV_DETAIL ALTER COLUMN TMP$ORIG_BOARD POSITION 92;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_EATING_OBJECT POSITION 93;

ALTER TABLE RESERV_DETAIL ALTER COLUMN LAST_ID_TAR_CALC POSITION 94;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CHECK_OUT_KIND POSITION 95;

ALTER TABLE RESERV_DETAIL ALTER COLUMN EARLYCHECKOUT_DATE POSITION 96;

