/* Server version: WI-V6.3.4.18393 Firebird 2.1 
   SQLDialect: 3. ODS: 11.1. Forced writes: On. Sweep inteval: 20000.
   Page size: 8192. Cache pages: 2048 (16384 Kb). Read-only: False. */
SET NAMES NONE;

SET SQL DIALECT 3;

ALTER TABLE PERSON_DATA ADD FIRST_NAME_UTF TNAME_UNICODE;

ALTER TABLE PERSON_DATA ADD SURNAME_UTF TNAME_UNICODE;

ALTER TABLE PERSON_DATA ADD FAMILY_NAME_UTF TNAME_UNICODE;

ALTER TABLE PERSON_DATA ADD PERSON_NAME_UTF TNAME_UNICODE;

UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='TDESCRIPTION_SHORT' WHERE RDB$FIELD_NAME='EXTERNAL_DESCRIPTION' AND RDB$RELATION_NAME='EXT_PRATE_MAP';

UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='NAME_20' WHERE RDB$FIELD_NAME='ROOM_NAME' AND RDB$RELATION_NAME='ROOM_KEY_LOG';

UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='NAME_20' WHERE RDB$FIELD_NAME='EXTERNAL_NAME' AND RDB$RELATION_NAME='ROOMS';

/* Create Procedure... */
SET TERM ^ ;

CREATE PROCEDURE ROOM_CAPACITY_CHECK$INT(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
OLD_CAPACITY INTEGER,
NEW_CAPACITY INTEGER)
 RETURNS(OVERRULE_NEED SMALLINT,
OVERRULE_CONTEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^


SET TERM ; ^

DROP VIEW ACCOUNT_PREVIEW;

/* Create view: ACCOUNT_PREVIEW */
CREATE VIEW ACCOUNT_PREVIEW(
ID_ACCOUNT,
ACCOUNT_NAME,
ID_PROFILE,
PROFILE_NAME,
PROFILE_TYPE,
ROOM_NAME,
ACCOUNT_CURR,
IS_CREDIT_ACCOUNT,
IS_BLOCKED,
IS_ARCHIVE,
ID_HOTEL,
NOTE)
 AS 
select A.ID_ACCOUNT,
       A.ACCOUNT_NAME,
       P.ID_PROFILE,
       P.PROFILE_NAME,
       P.PROFILE_TYPE,
       R.ROOM_NAME,
       A.ACCOUNT_CURR,
       A.IS_CREDIT_ACCOUNT,
       A.IS_BLOCKED,
       A.IS_ARCHIVE,
       A.ID_HOTEL,
       A.NOTE
from   ACCOUNT_S A
       join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
       left outer join RESERV_DETAIL RD ON RD.ID_RESERV_DETAIL = A.ID_RESERV_DETAIL
       left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
;

DROP VIEW ENA_RESERV_DETAIL;

/* Alter view (drop/create): MEALS for view: ENA_RESERV_DETAIL */
/* Alter view (drop): MEALS for view: ENA_RESERV_DETAIL */
SET TERM ^ ;

ALTER PROCEDURE AVAILABILITY_RATE_SMALL$WBE(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER,
ROOMS INTEGER,
ADULTS INTEGER,
CHILDREN INTEGER,
QUERY_ID INTEGER,
PROFILE_ID INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE AVAILABILITY_RATING_LOOP$INT(ID_SESSION INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ROOMS_COUNT INTEGER,
ADULTS_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ROOMTYPE_LIST VARCHAR(2000),
RATE_LIST VARCHAR(2000),
BOARD_LIST VARCHAR(2000),
HOTELS VARCHAR(255) = '')
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE BASE_SERVICES_GEN$INT(ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE BOARD_TO_FOODS(ID_BOARD /* TYPE OF ID */ INTEGER)
 RETURNS(ID_SERVICE /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE EAI_POS_CHECK_CARD$P2E(IN_CARD_NUMBER VARCHAR(50),
ID_HOTEL INTEGER)
 RETURNS(ID_GUEST INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100),
GUEST_NAME VARCHAR(100),
ROOM_NAME VARCHAR(20),
BOARD_NAME VARCHAR(30))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE EAI_POS_GET_GUESTS$P2E(IN_ROOM_NAME VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(OUT_ID_GUEST INTEGER,
OUT_GUEST_NAME VARCHAR(100),
OUT_FROM_DATE DATE,
OUT_TO_DATE DATE,
OUT_OK_FOR_POST INTEGER,
OUT_COUNTRY VARCHAR(30),
OUT_TEXT VARCHAR(100),
OUT_BOARD_NAME VARCHAR(30),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE EXPORT_BOOKING$EXC(BOOKING_ID INTEGER)
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20),
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_ID INTEGER,
IS_GUEST_ARRANGER INTEGER,
POSTING_ROUTING VARCHAR(20),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IS_DIFFERENT_TARIFF SMALLINT,
IS_DIFFERENT_BOARD SMALLINT,
IS_CUSTOM_PRICE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
EXC_LOCAL_VERSION BIGINT,
EXC_REMOTE_VERSION BIGINT,
CREATE_DATETIME TIMESTAMP,
EATING_OBJECT VARCHAR(50),
CHECK_OUT_KIND SMALLINT,
EARLYCHECKOUT_DATE DATE)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE LOOKUP_BOARD$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30),
ONLY_BOARDS SMALLINT)
 RETURNS(ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE RES_CREATE_GET$RSV(ID_HOTEL INTEGER)
 RETURNS(ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIMESTAMP,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIMESTAMP,
TRANSFER_OUT_NOTE VARCHAR(30),
IS_LATE_DEPARTURE INTEGER,
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
COUNTRY_CODE VARCHAR(20),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
CHECK_STATUS INTEGER,
ID_HK_PLAN INTEGER,
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE RES_CREATE_LOG$INT(RD_DBKEY CHAR(8))
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE RES_GET_GUEST_BOARDS$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(BOARD_NAMES VARCHAR(255),
ID_BOARD INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE RES_GET_GUEST_DATA$INT(RESERV_DATA VARCHAR(20),
ID_RESERV_DATA /* TYPE OF ID */ INTEGER)
 RETURNS(BOARD_NAMES /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
TARIFF_NAMES /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
PACKET_NAMES /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
VOUCHERS_RENDER /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE RES_GUEST_SAVE_BOARD$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_BOARD INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE RES_SAVE_BOARD$INT(RD_DBKEY CHAR(8),
ID_BOARD INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE TAR_BOARD_DECOMPOSE$INT(ID_BOARD /* TYPE OF ID */ INTEGER,
ID_TAR_HEAD /* TYPE OF ID */ INTEGER)
 RETURNS(ID_SERVICE /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE TAR_CALC_EVAL_COMPLEX_RATE$INT(INPUT_DETAIL_DBKEY CHAR(8),
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
BEDS SMALLINT,
ID_TYPE_STAY INTEGER,
IS_MANUAL_TYPE_STAY SMALLINT,
ID_BOARD INTEGER,
ID_ROOM_TYPE INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
CHECKIN_DATE DATE,
DAY_OF_STAY INTEGER,
PAYORS INTEGER,
MINORS INTEGER,
PERIOD_DEPEND_ON_CHECKIN SMALLINT,
CNT_DAYS_BP INTEGER,
CNT_DAYS_BOARD INTEGER,
BOARD_TYPE_FIND VARCHAR(10),
TOTAL_GUESTS INTEGER,
SEQ_NUM INTEGER,
TARIFF_CURR CHAR(3),
REAL_RECALC SMALLINT)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_PAYORS INTEGER,
OUT_MINORS INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE TAR_CALC_EVAL_SIMPLE_RATE$INT(ID_TAR_INPUT_DETAIL INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
ID_TAR_HEAD INTEGER,
BEDS SMALLINT,
GUEST_AGE INTEGER,
ID_TYPE_STAY INTEGER,
IS_MANUAL_TYPE_STAY INTEGER,
ID_BOARD INTEGER,
ID_ROOM_TYPE INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
ID_HOTEL INTEGER,
TOTAL_GUESTS INTEGER,
CURRENT_ADULT_NUM INTEGER,
CURRENT_CHILD_NUM INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
NEW_CURRENT_ADULT_NUM INTEGER,
NEW_CURRENT_CHILD_NUM INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE TAR_GET_BASE_SERVICE$INT(ID_TYPE_STAY INTEGER,
ID_ROOM_TYPE INTEGER,
ID_BOARD INTEGER,
ID_HOTEL INTEGER)
 RETURNS(ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE TAR_MATCH_BOARD(TID_DBKEY CHAR(8),
ID_TAR_BP INTEGER,
BOARD_TYPE_FIND VARCHAR(10),
ID_BOARD INTEGER,
ID_BOARD_INCLUDE INTEGER,
MATCH_DATE DATE,
BASE_PER_DAY NUMERIC(15,4),
DAY_OF_STAY INTEGER,
CNT_DAYS_BOARD INTEGER,
CNT_DAYS_BP INTEGER,
CUSTOM_PRICE NUMERIC(15,4))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SEPARATE_BOARD INTEGER,
SERVICE_TYPE VARCHAR(20),
BOARD_PRICE NUMERIC(15,4),
PTEXT VARCHAR(20),
ID_SERVICE INTEGER,
FOOD_PER_DAY NUMERIC(15,4),
PACKET_ITEM INTEGER,
DISC_TAG VARCHAR(50))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE TAR_OUTPUT_BASE(ID_TAR_CALC INTEGER)
 RETURNS(ID_GUEST INTEGER,
ID_RESERV INTEGER,
ID_SERVICE INTEGER,
ID_TARIFF INTEGER,
DATE_POST DATE,
QTY_POST INTEGER,
PRICE_ORIG NUMERIC(15,4),
CURR_ORIG CHAR(3),
SHORT_CODE VARCHAR(255),
ID_ROOM INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE TAR_SAVE_BO_BOARD(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE TAR_SAVE_BO_BP(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE TARIFA_BOARDS_SUPPORTED(ID_TAR_HEAD INTEGER)
 RETURNS(ID_BOARD INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE TARIFA_GET_PARAM(ID_PARAM INTEGER,
FOR_DATE DATE,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER)
 RETURNS(OUT_VALUE VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP VIEW MEALS;

/* Alter view (create): MEALS for view: ENA_RESERV_DETAIL */
/* Create view: MEALS */
CREATE VIEW MEALS(
ID_SERVICE,
NAME,
IS_BREAKFAST,
IS_LUNCH,
IS_DINNER,
IS_EXTRAFOOD1,
IS_EXTRAFOOD2,
WEIGHT_TAG,
ID_BOARD,
IS_BOARD,
ID_HOTEL,
IS_ARCHIVE,
CHKSUM)
 AS 
select s.ID_SERVICE,
       s.SERVICE_NAME,
       sm.IS_BREAKFAST,
       sm.IS_LUNCH,
       sm.IS_DINNER,
       sm.IS_EXTRAFOOD1,
       sm.IS_EXTRAFOOD2,
       sm.WEIGHT_TAG,
       sm.ID_BOARD,
       sm.IS_BOARD,
       s.ID_HOTEL,
       s.IS_DELETED as is_archive,
       sm.IS_BREAKFAST*1+sm.IS_EXTRAFOOD1*2+sm.IS_LUNCH*4+sm.IS_EXTRAFOOD2*8+sm.IS_DINNER*16+100*s.id_hotel
from   SERVICE_MEALS sm
       join SERVICES s on s.ID_SERVICE = sm.ID_SERVICE
;

/* Create view: ENA_RESERV_DETAIL */
CREATE VIEW ENA_RESERV_DETAIL(
ID_HOTEL,
ID_RESERV_DETAIL,
NUMBER,
ID_GUEST_MAIN,
GUEST_MAIN_NAME,
GUEST_MAIN_NAME2,
TITLE,
FROM_DATE,
TO_DATE,
NIGHTS,
ADULT_COUNT,
CHILD_COUNT,
ID_EATING_OBJECT,
CHECK_STATUS,
IS_ANUL,
ARRANGER_PROFILE_ID,
ARRANGER_PROFILE_NAME,
ARRANGER_PROFILE_TYPE,
ARRANGER_PROFILE_ACCOUNT_NO,
MARKET_SEGMENT_CODE,
MARKET_SOURCE_CODE,
MARKET_CHANNEL_CODE,
MARKET_HEAR_CODE,
MARKET_COME_CODE,
ROOM_TYPE,
RATE_NAME,
RESERV_PRICE,
PRICE_CURRENCY,
BOARD,
EMAIL,
NATIONALITY,
NOTE)
 AS 
select
rd.ID_HOTEL,
rd.ID_RESERV_DETAIL,
rd.NUMBER,
rd.ID_TITULAR,
pd.PERSON_NAME,
pd.PERSON_NAME2,
pd.TITLE,
rd.FROM_DATE,
rd.TO_DATE,
rd.TO_DATE - rd.FROM_DATE,
rd.ADULT_COUNT,
rd.CHILD_COUNT,
rd.ID_EATING_OBJECT,
rd.CHECK_STATUS,
rd.IS_ANUL,
rd.ID_AGENT_PROFILE,
(select p1.PROFILE_NAME from PROFILE p1 where p1.ID_PROFILE = rd.ID_AGENT_PROFILE),
(select p2.PROFILE_TYPE from PROFILE p2 where p2.ID_PROFILE = rd.ID_AGENT_PROFILE),
(select p3.ACCOUNT_NO from PROFILE p3 where p3.ID_PROFILE = rd.ID_AGENT_PROFILE),
(select M1.MARKET_CODE from NOM_MARKET_SEGMENTS M1 where m1.ID_NOM_MARKET_SEGMENT = rd.ID_NOM_MARKET_SEGMENT),
(select M2.SOURCE_CODE from NOM_SOURCE_CODES M2 where m2.ID_NOM_SOURCE_CODE = rd.ID_NOM_SOURCE_CODE),
(select M3.CHANNEL_CODE from NOM_CHANNEL_CODES M3 where m3.ID_NOM_CHANNEL_CODE = rd.ID_NOM_CHANNEL_CODE),
(select M4.HEAR_REASON_CODE from NOM_HEAR_REASONS M4 where m4.ID_NOM_HEAR_REASON = rd.ID_NOM_HEAR_REASON),
(select M5.COME_REASON_CODE from NOM_COME_REASONS M5 where m5.ID_NOM_COME_REASON = rd.ID_NOM_COME_REASON),
coalesce((select rrt.TYPE_ROOM from ROOM_TYPES rrt join ROOMS r on r.ID_ROOM_TYPE = rrt.ID_ROOM_TYPE where r.ID_ROOM = rd.ID_ROOM),
         (select rrt.TYPE_ROOM from ROOM_TYPES rrt join ROOM_MAP$EXC rmp on rmp.ID_ROOM_TYPE = rrt.ID_ROOM_TYPE where rmp.ID_ROOM = rd.ID_ROOM),
         (select rrt.TYPE_ROOM from ROOM_TYPES rrt where rrt.ID_ROOM_TYPE = rd.ID_ROOM_TYPE)),
t.TARIFA_NAME,
rd.ROOM_PRICE,
rd.ROOM_CURRENCY,
M.NAME,
(select p.EMAIL
 from   PROFILE P
 where  p.ID_PROFILE = rd.ID_PERSON_PROFILE) as EMAIL,
rd.COUNTRY,
rd.NOTE
from RESERV_DETAIL rd
    join GUEST g on g.ID_GUEST = rd.ID_TITULAR
    join GUEST_DATA gd on gd.ID_GUEST = g.ID_GUEST
    join PERSON_DATA pd on pd.ID_PERSON_DATA = gd.ID_PERSON_DATA
    join TARIFA T on t.ID_TARIFA = rd.ID_RATE
    join MEALS M on M.ID_BOARD = rd.ID_BOARD
;

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_RESERV_DETAIL IS
'   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NUMBER IS
'  .    (   ). .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_GUEST_MAIN IS
'      .      .  -     .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME IS
'    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME2 IS
'       . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.FROM_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.TO_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NIGHTS IS
'. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ADULT_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHILD_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_EATING_OBJECT IS
'          . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHECK_STATUS IS
'  . -3 =  ; -2 =   ; -1 =  ; 0 =  ; 1 =  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.IS_ANUL IS
'   . 0 - , 1 - .  -       0  1.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ID IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_NAME IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_TYPE IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ACCOUNT_NO IS
'             .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SEGMENT_CODE IS
'   ''segment''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SOURCE_CODE IS
'   ''source''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_CHANNEL_CODE IS
'   ''channel''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_HEAR_CODE IS
'   ''hear reason''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_COME_CODE IS
'   ''come reason''.   . .';

DROP VIEW RES_ROOM_TYPES;

/* Create view: RES_ROOM_TYPES */
CREATE VIEW RES_ROOM_TYPES(
ID_RESERV_DETAIL,
RES_ID_ROOM_TYPE,
ROOM_ID_ROOM_TYPE)
 AS 
select rd.ID_RESERV_DETAIL,
       rd.ID_ROOM_TYPE,
       coalesce(r.ID_ROOM_TYPE, rm.ID_ROOM_TYPE)
from   RESERV_DETAIL RD
       left outer join ROOMS r on r.ID_ROOM = rd.ID_ROOM
       left outer join ROOM_MAP$EXC rm on rm.ID_ROOM = rd.ID_ROOM
;

COMMENT ON COLUMN ENA_ACCOUNT.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_ACCOUNT.ID_ACCOUNT IS
'  . .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_NAME IS
'   .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_EXT_CODE IS
'             .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ID IS
'         . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_NAME IS
'    .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ACCOUNT_NO IS
'             .  -    .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_TYPE IS
'       .  : AGENT -  , PERSON -  , HOUSE -    . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_HOUSE_TYPE IS
'      (PROFILE_TYPE = ''HOUSE''),    -.  : hptExternalClient -          ( ,      ); hptExternalRevenue -                (,   ..); hptComplimentary -           ,  ,        . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_HOTEL IS
'       .  ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_ACCOUNT_POST_HISTORY IS
'   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_ACCOUNT IS
'      .  ENA_ACCOUNT.ID_ACCOUNT. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_SERVICE IS
'   .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_SALE_TAXATION IS
'         .       . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.SYSTEM_DATE IS
'    / . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_DATE IS
'        (). .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_CURR IS
'  . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_AMOUNT IS
'    (   )    . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.NAT_NET_VALUE IS
'    ( )   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.NAT_GROSS_VALUE IS
'    ( )   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_TYPE IS
'  . BASE -  ; ADD_INS -  - ,    ; EXTRA -     ,     ; TAX -            ,     .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_GUEST IS
'       .  ENA_GUEST.ID_GUEST.        : 1.    "  "; 2.           ; 3.        ,      . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_GROUP IS
'       .    : ''ROOMS'', ''Food and Beverage'', ''Other Operated Departments'', ''Rentals and Other Income''. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_ACCOUNT IS
' -      .    . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_SUB_ACCOUNT IS
' --      . ,     -. .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.ID_HOTEL IS
'   ,    . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.ID_DOC_HEAD IS
'        .  ENA_DOC_HEAD_ADVANCE.ID_DOC. .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.SYSTEM_DATE IS
'      . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAYMENT_DATE IS
'     . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.SRC_ID_ACCOUNT IS
'   . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.DEST_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAY_AMOUNT IS
' .        . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAY_CURRENCY IS
' . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.USER_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.DATETIME_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_HOTEL IS
'   ,    . .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_DEPOSIT_PAYMENT IS
'  .         . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_DATE IS
'        .            . .';

COMMENT ON COLUMN ENA_DEPOSIT.SYSTEM_DATE IS
'   .         PAYMENT_DATE.        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_NUM IS
'           .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_DIRECTION IS
'0 -   , 1 -   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_TYPE_NAME IS
'       .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_ACCOUNT IS
'        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_AMOUNT IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DEPOSIT.IS_ANUL IS
'   . 0 - , 1 - .           /    .     IS_ANUL = 0,    1.           ID_DEPOSIT.  .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_CREATED IS
'     .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_CREATED IS
'       . .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_ANNUL IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_ANNUL IS
'     .  .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.ID_HOTEL IS
'       .  .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.ID_DEPOSIT_PAYMENT IS
'   ,   .  ENA_DEPOSIT.ID_DEPOSIT_PAYMENT. .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SYSTEM_DATE IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAYMENT_DATE IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SRC_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DEST_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAY_AMOUNT IS
' .        . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAY_CURRENCY IS
' . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.USER_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DATETIME_CREATED IS
'     . .';

COMMENT ON VIEW ENA_DOC_DEPOSIT_CONSUMPTION IS
' !!!!!!    ID_DOC_TYPE - za mapowe.';


COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.DOC_TYPE_NAME IS
'       . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_NUM IS
'         .  .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_DATE IS
'      .          . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_VALUE IS
'         . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_DOC_RATE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.EQUAL_DOC_VALUE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.NAT_VALUE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.ID_DEPOSIT_PAYMENT IS
'      (  ENA_DEPOSIT.ID_DEPOSIT_PAYMENT ). .';

COMMENT ON VIEW ENA_DOC_HEAD_ADVANCE IS
'!      ';


COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC IS
'  .             .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_ADVANCE.ID_DOC.  .     - , ..       ,      - .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SUB_TYPE IS
'   . ,  : 0 - / , 1 -  ,  , 2 -  ,  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_NAME IS
'    . ,       .              .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_DESCRIPTION IS
'   .         .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_NUM IS
'   ,        .      . ,     ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DATE IS
'        . .    SYSTEM_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.IS_ANUL IS
'        . . 0 - , 1 - .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TOTAL_VALUE IS
' (, )       . .      .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ONE_LINE_TEXT IS
' ,         .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURR_RATE IS
'   ()    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_POST_ADDRESS IS
'    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_ZIP_CODE IS
'     ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_MOL IS
'    ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_RECIPIENT_NAME IS
'     ()';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BANK_NAME IS
'  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BIC IS
'BIC  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IBAN IS
'IBAN  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_EMAIL IS
'email  .        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SUPPLIER_SEND_NAME IS
'     .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ACCOUNT_ID IS
'        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC IS
'  .             .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_SERVICE.ID_DOC.     - , ..       ,      - .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC_TYPE IS
'    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SUB_TYPE IS
'   .  : 0 - / , 1 -  ,  , 2 -  ,  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_NAME IS
'    .              .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_DESCRIPTION IS
'   .         .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_NUM IS
'   ,        .      .  -       ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DATE IS
'        .    SYSTEM_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.IS_ANUL IS
'        . 0 - , 1 - .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_CURRENCY IS
'  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TOTAL_VALUE IS
' (, )       .      .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ONE_LINE_TEXT IS
' ,         .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURR_RATE IS
'   ()    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_DATE IS
'   ,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_NUM IS
'  -,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_POST_ADDRESS IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_ZIP_CODE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_MOL IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_RECIPIENT_NAME IS
'     (). .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BANK_NAME IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BIC IS
'BIC  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IBAN IS
'IBAN  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_EMAIL IS
'email  .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SUPPLIER_SEND_NAME IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ACCOUNT_ID IS
'        .    ENA_ACCOUNT.ID_ACCOUNT. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_SERVICE IS
'     .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.DATE_POST IS
'    . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_SERVICE IS
'      .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_SERVICE IS
'   .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.IS_CORRECT IS
'            .      1,        . 0 -   ; 1 -      0. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_GUEST IS
'   ,        .    null,       ''  ''     .    ENA_GUEST.ID_GUEST. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.DATE_POST IS
'        .    ,    . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ROOM_NAME IS
'       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ACCOUNT_PRICE IS
'         /.             /. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_SERVICE IS
'    (, , , ,  ).  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_SALE_TAXATION IS
'         .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON VIEW ENA_DOC_PAYMENT IS
'   ,     .';


COMMENT ON COLUMN ENA_DOC_PAYMENT.ID_DOC_HEAD IS
'  ( ENA_DOC_HEAD.ID_DOC)      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DOC_TYPE_NAME IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_NUM IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_DATE IS
'     .        ,                 . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_CURRENCY IS
'  .        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DUE_DATE IS
'       .          ,      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_VALUE IS
'           . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_DOC_RATE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.EQUAL_DOC_VALUE IS
'      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.NAT_VALUE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.ID_DOC_HEAD IS
'         . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNT_VALUE IS
'      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNTABLE_VALUE IS
'  .       . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.IS_PERCENT_DISCOUNT IS
'  .         . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.FIXED_DISCOUNT_CURRENCY IS
'  .       -     . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNT_PERCENT_OR_AMOUNT IS
'  .       . .';

COMMENT ON COLUMN ENA_DOC_TAX.ID_DOC_HEAD IS
'         ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_TAX.ID_SALE_TAX IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.NONTAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_VALUE IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_NAME IS
'  .  -        .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_PERCENT IS
'   ().  .';

COMMENT ON COLUMN ENA_DOC_TAX.FISCAL_CODE IS
' .        .  -      .';

COMMENT ON COLUMN ENA_DOC_TAX.ACCOUNT_NAME IS
' .              . .';

COMMENT ON COLUMN ENA_GUEST.ID_GUEST IS
'   ( )   . .';

COMMENT ON COLUMN ENA_GUEST.ID_RESERV_DETAIL IS
'        ( ENA_RESERV_DETAIL.ID_RESERV_DETAIL). .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME2 IS
'      . .';

COMMENT ON COLUMN ENA_GUEST.IS_CHILD IS
'   . 0 - ; 1 - . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE IS
'    . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_TEXT IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.RATING_AGE IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.COUNTRY_CODE IS
'    .        ISO. .';

COMMENT ON COLUMN ENA_GUEST.MASK IS
'  .         . .';

COMMENT ON COLUMN ENA_HOTEL.ID_HOTEL IS
'  . .';

COMMENT ON COLUMN ENA_HOTEL.HOTEL_NAME IS
'  . .';

COMMENT ON COLUMN ENA_HOTEL.CODE IS
'   . .';

COMMENT ON COLUMN ENA_HOTEL.SYSTEM_DATE IS
'     .                  ENA.                . .';

COMMENT ON COLUMN ENA_HOTEL.IS_USE IS
'    (  ). 0 -   , 1 -  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_RESERV_DETAIL IS
'   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NUMBER IS
'  .    (   ). .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_GUEST_MAIN IS
'      .      .  -     .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME IS
'    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME2 IS
'       . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.FROM_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.TO_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NIGHTS IS
'. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ADULT_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHILD_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_EATING_OBJECT IS
'          . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHECK_STATUS IS
'  . -3 =  ; -2 =   ; -1 =  ; 0 =  ; 1 =  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.IS_ANUL IS
'   . 0 - , 1 - .  -       0  1.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ID IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_NAME IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_TYPE IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ACCOUNT_NO IS
'             .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SEGMENT_CODE IS
'   ''segment''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SOURCE_CODE IS
'   ''source''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_CHANNEL_CODE IS
'   ''channel''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_HEAR_CODE IS
'   ''hear reason''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_COME_CODE IS
'   ''come reason''.   . .';

COMMENT ON COLUMN ENA_SERVICES.ID_HOTEL IS
'       . .';

COMMENT ON COLUMN ENA_SERVICES.ID_SERVICE IS
'   . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_NAME IS
'  . .';

COMMENT ON COLUMN ENA_SERVICES.GROUP_NAME IS
'    .            a       . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_TYPE IS
'  .  : ''BASE'',''EXTRA'',''COMMISSION'',''MEAL''. ''BASE'' -    ,     ,''EXTRA'' -  , ''MEAL'' - , ''COMMISSION'' - ,        (  ). .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_GROUP IS
'       .  : ''ROOMS'', ''Food and Beverage'', ''Other Operated Departments'', ''Rentals and Other Income''. .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_ACCOUNT IS
' -      . .';

COMMENT ON COLUMN ENA_SERVICES.ACCOUNT_NAME IS
'      (. ),      .          . .';

COMMENT ON COLUMN ENA_SERVICES.EXT_CODE IS
'         . .';

COMMENT ON COLUMN ENA_SERVICES.IS_BREAKFAST IS
'   . 0 - , 1 - .    1,   SERVICE_TYPE e ''BASE''  ''MEAL''.  -          .';

COMMENT ON COLUMN ENA_SERVICES.IS_LUNCH IS
'   .   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_DINNER IS
'   .   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_EXTRAFOOD1 IS
'     1.   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_EXTRAFOOD2 IS
'     2.   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.ID_ROOM_TYPE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ). .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  -             .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM_EXT_CODE IS
'    ( )     ,      .  -        .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_STAY_CODE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  : ''ALONE'' -      , ''BED'' -            , ''EXTRA_BED'' -      . .';

/* Alter View (Drop, Create)... */
/* Drop altered view: FB_GUESTS */
DROP VIEW FB_GUESTS;

/* Create altered view: FB_GUESTS */
/* Create view: FB_GUESTS */
CREATE VIEW FB_GUESTS(
ID_HOTEL,
MEAL_DATE,
ID_GUEST,
IS_CHILD,
ID_ROOM,
ID_RESERV_DETAIL,
ID_ORGANIZER_PROFILE,
GFROM_DATE,
GTO_DATE,
ID_BOARD,
SOURCE,
BREAKFAST_CNT,
EXTRAFOOD1_CNT,
LUNCH_CNT,
EXTRAFOOD2_CNT,
DINER_CNT)
 AS 
select RD1.ID_HOTEL,
       GS1.FOR_DATE,
       G1.ID_GUEST,
       G1.IS_CHILD,
       G1.ID_ROOM,
       RD1.ID_RESERV_DETAIL,
       RD1.ID_AGENT_PROFILE,
       G1.FROM_DATE,
       G1.TO_DATE,
       GS1.ID_BOARD,
       cast(iif(RD1.CHECK_STATUS in (0, 1), 'GUESTS', 'RESERVS') as varchar(10)),
       iif(G1.FIRST_FOOD_ORDER <= 1, TH1.IS_BREAKFAST, 0),
       iif(G1.FIRST_FOOD_ORDER <= 2, TH1.IS_EXTRAFOOD1, 0),
       iif(G1.FIRST_FOOD_ORDER <= 3, TH1.IS_LUNCH, 0),
       iif(G1.FIRST_FOOD_ORDER <= 4, TH1.IS_EXTRAFOOD2, 0),
       iif(G1.FIRST_FOOD_ORDER <= 5, TH1.IS_DINNER, 0)
from   GUEST G1
       join RESERV_DETAIL RD1 on RD1.ID_RESERV_DETAIL = G1.ID_RESERV_DETAIL
                                 and RD1.CHECK_STATUS > -3
                                 and RD1.IS_ANUL = 0
       join GUEST_STAY GS1 on GS1.ID_GUEST = G1.ID_GUEST
                              and GS1.FOR_DATE < coalesce(G1.EARLYCHECKOUT_DATE, GS1.FOR_DATE + 1)
       join SERVICE_MEALS TH1 on TH1.ID_BOARD = GS1.ID_BOARD
union
select RD2.ID_HOTEL,
       GS2.FOR_DATE + 1,
       G2.ID_GUEST,
       G2.IS_CHILD,
       G2.ID_ROOM,
       RD2.ID_RESERV_DETAIL,
       RD2.ID_AGENT_PROFILE,
       G2.FROM_DATE,
       G2.TO_DATE,
       GS2.ID_BOARD,
       cast(iif(RD2.CHECK_STATUS in (0, 1), 'GUESTS', 'RESERVS') as varchar(10)),
       iif(G2.FIRST_FOOD_ORDER > 1, TH2.IS_BREAKFAST, 0),
       iif(G2.FIRST_FOOD_ORDER > 2, TH2.IS_EXTRAFOOD1, 0),
       iif(G2.FIRST_FOOD_ORDER > 3, TH2.IS_LUNCH, 0),
       iif(G2.FIRST_FOOD_ORDER > 4, TH2.IS_EXTRAFOOD2, 0),
       iif(G2.FIRST_FOOD_ORDER > 5, TH2.IS_DINNER, 0)
from   GUEST G2
       join RESERV_DETAIL RD2 on RD2.ID_RESERV_DETAIL = G2.ID_RESERV_DETAIL
                                 and RD2.CHECK_STATUS > -3
                                 and RD2.IS_ANUL = 0
       join GUEST_STAY GS2 on GS2.ID_GUEST = G2.ID_GUEST
                              and GS2.FOR_DATE < coalesce(G2.EARLYCHECKOUT_DATE, GS2.FOR_DATE + 1)
       join SERVICE_MEALS TH2 on TH2.ID_BOARD = GS2.ID_BOARD
union all
select A3.ID_HOTEL,
       AP3.DATE_POST,
       G3.ID_GUEST,
       coalesce(G3.IS_CHILD, 0),
       AP3.ID_ROOM,
       G3.ID_RESERV_DETAIL,
       coalesce(RD3.ID_AGENT_PROFILE, A3.ID_PROFILE),
       G3.FROM_DATE,
       G3.TO_DATE,
       null as id_board,
       cast('POSTS' as varchar(10)),
       cast((TH3.IS_BREAKFAST * AP3.QTY_POST) as integer),
       cast((TH3.IS_EXTRAFOOD1 * AP3.QTY_POST) as integer),
       cast((TH3.IS_LUNCH * AP3.QTY_POST) as integer),
       cast((TH3.IS_EXTRAFOOD2 * AP3.QTY_POST) as integer),
       cast((TH3.IS_DINNER * AP3.QTY_POST) as integer)
from   ACCOUNT_POST AP3
       join ACCOUNT A3 on A3.ID_ACCOUNT = AP3.ID_ACCOUNT
       join SERVICE_MEALS TH3 on TH3.ID_SERVICE = ap3.ID_SERVICE
       left outer join GUEST G3 on G3.ID_GUEST = AP3.ID_GUEST
       left outer join RESERV_DETAIL RD3 on RD3.ID_RESERV_DETAIL = G3.ID_RESERV_DETAIL
where  AP3.IS_BASE = 0
       and AP3.IS_ANUL = 0
       and ((AP3.ID_MASTER_ADDINS_ACC_POST = -1) or (AP3.SHORT_CODE = 'PACK'))
;

COMMENT ON COLUMN OWNER_POST.POST_STATUS IS
'11  
22  ';

/* Create index... */
CREATE INDEX PD_FAMILY_NAME_UTF_IDX ON PERSON_DATA COMPUTED BY(upper(trim(FAMILY_NAME_UTF)));

CREATE INDEX PD_FIRST_NAME_UTF_IDX ON PERSON_DATA COMPUTED BY(upper(trim(FIRST_NAME_UTF)));

CREATE INDEX PD_PERSON_NAME_IDX ON PERSON_DATA COMPUTED BY(upper(trim(PERSON_NAME_UTF)));

CREATE INDEX PD_SURNAME_UTF_IDX ON PERSON_DATA COMPUTED BY(upper(trim(SURNAME_UTF)));

CREATE INDEX RD_ANNUL_CHECK_STATUS_IDX ON RESERV_DETAIL(IS_ANUL, CHECK_STATUS);

CREATE INDEX RESOURCE_RESERVATION_IDX1 ON RESOURCE_RESERVATION(BOOKING_NUMBER);


/*  Empty IMPORT_BOOKING$EXC for DEFAULT_BOOKING_VALUES$EXC(param list change)  */
SET TERM ^ ;

ALTER PROCEDURE IMPORT_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(250),
MAINTANCE_SHEMA VARCHAR(30),
POSTING_ROUTING VARCHAR(20),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
COMPLIMENTARY_ACCOUNT VARCHAR(50),
EATING_OBJECT VARCHAR(50),
CREATE_DATETIME TIMESTAMP,
CHECK_OUT_KIND SMALLINT,
EARLYCHECKOUT_DATE DATE)
 RETURNS(HOTEL_ID INTEGER,
BOOKING_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/*  Empty EXT_PRATE_HOTEL_MAP_MODIFY for EXT_PRATE_MAP_MODIFY(param list change)  */
ALTER PROCEDURE EXT_PRATE_HOTEL_MAP_MODIFY(ID_HOTEL INTEGER,
PRATE_ID_HOTEL VARCHAR(10),
USER_NAME VARCHAR(30),
"PASSWORD" VARCHAR(50),
IS_ACTIVE SMALLINT,
OPERATION VARCHAR(3))
 AS
 BEGIN EXIT; END
^

/*  Empty DEFAULT_BOOKING_VALUES$EXC for RES_CREATE_GET$RSV(param list change)  */
ALTER PROCEDURE DEFAULT_BOOKING_VALUES$EXC(BOOKING_DBKEY CHAR(8),
HOTEL_ID INTEGER,
RATE_ID_IN INTEGER,
ROOM_TYPE_ID_IN INTEGER,
BOARD_ID_IN INTEGER,
MAINTANCE_SHEMA_ID_IN INTEGER,
ARRANGER_PAYMENT_TYPE_ID_IN INTEGER,
GUEST_PAYMENT_TYPE_ID_IN INTEGER,
MARKETING1_ID_IN INTEGER,
MARKETING2_ID_IN INTEGER,
MARKETING3_ID_IN INTEGER,
MARKETING4_ID_IN INTEGER,
MARKETING5_ID_IN INTEGER,
ARRANGER_PROFILE_ID_IN INTEGER,
MAIN_GUEST_PROFILE_ID_IN INTEGER,
POSTING_ROUTING_IN VARCHAR(50),
FIRST_FOOD_CODE_IN /* TFOOD_CODE */ VARCHAR(20),
GUARANTEE_POLICY_ID_IN INTEGER,
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_LATE_DEPARTURE_IN INTEGER,
EATING_OBJECT_ID_IN INTEGER)
 RETURNS(RATE_ID INTEGER,
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
MAINTANCE_SHEMA_ID INTEGER,
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
ARRANGER_PROFILE_ID INTEGER,
ARRANGER_ACCOUNT_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
POSTING_ROUTING VARCHAR(50),
FIRST_FOOD_CODE /* TFOOD_CODE */ VARCHAR(20),
GUARANTEE_POLICY_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_LATE_DEPARTURE INTEGER,
EATING_OBJECT_ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty RES_RECALC$INT for RES_TAR_CALC_FINALIZE$INT(param list change)  */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty IMPORT_ROOM_TYPE$EXC for ROOM_TYPE_MODIFY$CFG(param list change)  */
ALTER PROCEDURE IMPORT_ROOM_TYPE$EXC(TYPE_ROOM VARCHAR(20),
BEDS INTEGER,
EXT_CODE VARCHAR(30),
UUID VARCHAR(40),
HOTEL_NAME VARCHAR(50))
 RETURNS(ID_ROOM_TYPE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure DEFAULT_BOOKING_VALUES$EXC with new param-list */
ALTER PROCEDURE DEFAULT_BOOKING_VALUES$EXC(BOOKING_DBKEY CHAR(8),
HOTEL_ID INTEGER,
RATE_ID_IN INTEGER,
ROOM_TYPE_ID_IN INTEGER,
BOARD_ID_IN INTEGER,
MAINTANCE_SHEMA_ID_IN INTEGER,
ARRANGER_PAYMENT_TYPE_ID_IN INTEGER,
GUEST_PAYMENT_TYPE_ID_IN INTEGER,
MARKETING1_ID_IN INTEGER,
MARKETING2_ID_IN INTEGER,
MARKETING3_ID_IN INTEGER,
MARKETING4_ID_IN INTEGER,
MARKETING5_ID_IN INTEGER,
ARRANGER_PROFILE_ID_IN INTEGER,
MAIN_GUEST_PROFILE_ID_IN INTEGER,
POSTING_ROUTING_IN VARCHAR(50),
FIRST_FOOD_CODE_IN TFOOD_CODE,
GUARANTEE_POLICY_ID_IN INTEGER,
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_LATE_DEPARTURE_IN INTEGER,
EATING_OBJECT_ID_IN INTEGER)
 RETURNS(RATE_ID INTEGER,
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
MAINTANCE_SHEMA_ID INTEGER,
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
ARRANGER_PROFILE_ID INTEGER,
ARRANGER_ACCOUNT_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
POSTING_ROUTING VARCHAR(50),
FIRST_FOOD_CODE TFOOD_CODE,
GUARANTEE_POLICY_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_LATE_DEPARTURE INTEGER,
EATING_OBJECT_ID INTEGER,
DEFAULT_GUEST_MASK VARCHAR(10))
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure EXT_PRATE_MAP_MODIFY with new param-list */
ALTER PROCEDURE EXT_PRATE_MAP_MODIFY(ID_PRATE_MAP INTEGER,
ID_HOTEL INTEGER,
ID_OBJECT VARCHAR(20),
OBJECT_TYPE VARCHAR(100),
EXTERNAL_CODE VARCHAR(10),
EXTERNAL_DESCRIPTION VARCHAR(100),
IS_EXPORT SMALLINT,
OPERATION VARCHAR(5))
 RETURNS(NEW_ID_PRATE_MAP INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure RES_CREATE_GET$RSV with new param-list */
ALTER PROCEDURE RES_CREATE_GET$RSV(ID_HOTEL INTEGER)
 RETURNS(ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIMESTAMP,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIMESTAMP,
TRANSFER_OUT_NOTE VARCHAR(30),
IS_LATE_DEPARTURE INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
COUNTRY_CODE VARCHAR(20),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
CHECK_STATUS INTEGER,
ID_HK_PLAN INTEGER,
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF,
DEFAULT_GUEST_MASK VARCHAR(10))
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure RES_TAR_CALC_FINALIZE$INT with new param-list */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(ID_TAR_CALC INTEGER,
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure ROOM_TYPE_MODIFY$CFG with new param-list */
ALTER PROCEDURE ROOM_TYPE_MODIFY$CFG(ID_HOTEL INTEGER,
ID_ROOM_TYPE INTEGER,
TYPE_ROOM VARCHAR(20),
BEDS INTEGER,
EXT_CODE VARCHAR(30),
OPERATION VARCHAR(10))
 RETURNS(NEW_ID_ROOM_TYPE INTEGER,
OVERRULE_NEED SMALLINT,
OVERRULE_CONTEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_ADD$INT for: ACCOUNT_CHECK_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_POSTING_ADD$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_GUEST /* TYPE OF ID_REF */ INTEGER,
ID_SECQUENCE /* TYPE OF ID_REF */ INTEGER,
DATE_POST /* TYPE OF TDATE */ DATE,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_TARIFF /* TYPE OF ID_REF */ INTEGER,
ID_ROOM /* TYPE OF ID_REF */ INTEGER,
IS_BASE /* TYPE OF TLOGICAL */ SMALLINT,
QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
ORIG_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
RATE /* TYPE OF TRATE */ NUMERIC(15,6),
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
CHANGED_TEXT /* TYPE OF TTEXT_SHORT */ VARCHAR(30),
ID_MASTER_ADDINS_ACC_POST /* TYPE OF ID_REF */ INTEGER,
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
NEW_ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE$INT for: ACCOUNT_CHECK_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE$INT(AP_DBKEY /* TYPE OF TDB_KEY */ CHAR(8),
ID_SERVICE /* TYPE OF ID_REF */ INTEGER,
ID_TARIFF /* TYPE OF ID_REF */ INTEGER,
ID_ROOM /* TYPE OF ID_REF */ INTEGER,
QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
QTY_FREE /* TYPE OF TQTY */ NUMERIC(15,2),
PRICE /* TYPE OF TVALUE */ DOUBLE PRECISION,
CURR /* TYPE OF TCURRENCY */ CHAR(3),
RATE /* TYPE OF TRATE */ NUMERIC(15,6),
CHANGED_TEXT VARCHAR(40),
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
IS_CONSEQUENTIAL_UPDATE /* TYPE OF TBOOLEAN */ SMALLINT = 0,
RE_ROUTE_ACCOUNT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(OUT_QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
OUT_PRICE_POST /* TYPE OF TVALUE */ DOUBLE PRECISION,
OUT_AC VARCHAR(2))
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_CHECK_CREDIT_STATUS$INT) */
ALTER PROCEDURE ACCOUNT_CHECK_CREDIT_STATUS$INT(ID_ACCOUNT TYPE OF ID_REF,
POST_VALUE TYPE OF TPRICE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_credit_account integer;
  declare variable id_reserv_detail integer;
  declare variable credit_limit tprice;
  declare variable b_post_sum tprice;
  declare variable b_pay_sum tprice;
  declare variable difference_value tprice;
  declare variable no_use varchar(255);
  declare variable account_currency tcurrency;
  declare variable round_to numeric(15,4);
begin
  if (:POST_VALUE = 0) then exit;

  select a.IS_CREDIT_ACCOUNT, a.CREDIT_LIMIT, a.ID_RESERV_DETAIL
  from   ACCOUNT A
  where  a.ID_ACCOUNT = :ID_ACCOUNT
  into   :is_credit_account, :credit_limit, :id_reserv_detail;

  if (:is_credit_account = 0
      and exists (select rd.ID_RESERV_DETAIL
                  from   RESERV_DETAIL rd
                  where  rd.ID_RESERV_DETAIL = :id_reserv_detail
                         and rd.CHECK_STATUS = 1)) then
  begin
    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, :credit_limit, 1);
  end

  if (coalesce(:credit_limit, 0) > 0) then begin
    /* FIND BALANCE OF ACCOUNT */
    execute procedure ACCOUNT_BALANCE$INT(:id_account)
    returning_values  :account_currency, :round_to, :no_use, :b_post_sum, :b_pay_sum, :no_use, :no_use;
    b_post_sum = coalesce(:b_post_sum, 0);
    b_pay_sum  = coalesce(:b_pay_sum, 0);

    /* IS THIS POST IS IN LIMIT */
    if ((:b_post_sum + :POST_VALUE) > :credit_limit) then begin
      err_code = -13; /*  */
      difference_value = :b_post_sum + :POST_VALUE - :credit_limit;
      err_text = f_character(29)||FormatFloat(:credit_limit, :round_to)||' '||:account_currency||
                 f_character(28)||FormatFloat(:difference_value, :round_to);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_ACCOUNT$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
QTY /* TYPE OF TQTY */ NUMERIC(15,2),
ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
DATE_POST /* TYPE OF TDATE */ DATE,
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ROOM /* TYPE OF ID */ INTEGER = null,
POST_DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_GUEST$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ACCOUNT_ROUTING /* TYPE OF TSHORT_CODE */ VARCHAR(10),
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_TAR_CALC_REPOST$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE RES_TAR_CALC_REPOST$INT(ID_TAR_CALC /* TYPE OF ID_REF */ INTEGER,
ID_RESERV_DETAIL /* TYPE OF ID_REF */ INTEGER,
RECALC_MARKER VARCHAR(40))
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_ADD$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_ADD$INT(ID_ACCOUNT TYPE OF ID,
ID_GUEST TYPE OF ID_REF,
ID_SECQUENCE TYPE OF ID_REF,
DATE_POST TYPE OF TDATE,
ID_SERVICE TYPE OF ID,
ID_TARIFF TYPE OF ID_REF,
ID_ROOM TYPE OF ID_REF,
IS_BASE TYPE OF TLOGICAL,
QTY_POST TYPE OF TQTY,
PRICE TYPE OF TPRICE,
ORIG_CURRENCY TYPE OF TCURRENCY,
RATE TYPE OF TRATE,
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
POST_TEXT TYPE OF TDESCRIPTION_SHORT,
RESOURCE_TEXT TYPE OF TREASON,
CHANGED_TEXT TYPE OF TTEXT_SHORT,
ID_MASTER_ADDINS_ACC_POST TYPE OF ID_REF,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
NEW_ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable price_post double precision;
  declare variable post_rate numeric (15, 6);
  declare variable curr_post char(3);
  declare variable account_currency char(3);
  declare variable id_pack_service integer;
  declare variable id_room_type integer;
  declare variable room_name varchar(30);
  declare variable is_archive integer;
  declare variable id_tax_policy integer;
  declare variable id_sale_taxation integer;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable check_option varchar(255);
  declare variable id_hotel integer;
  declare variable id_srv_hotel integer;
  declare variable service_name varchar(30);
  declare variable account_name varchar(50);
begin
  ID_GUEST = nullif(:ID_GUEST, -1);

  execute procedure POST_PRICE_CHECK$INT (:QTY_POST, :PRICE, :ORIG_CURRENCY);

  if ( (:IS_BASE = 1) or (:ID_MASTER_ADDINS_ACC_POST > 0) ) then
    check_option = 'IS_BASE;ALLOW_POSTING';
  else
    check_option = 'IS_EXTRA;ALLOW_POSTING';

  execute procedure ACCOUNT_VALIDATE$INT(:id_account, :check_option)
  returning_values  (:err_code, :err_text, :account_currency, :id_tax_policy, :id_hotel, :account_name);
  if (:err_code < 0) then EXIT; --  exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;

  select s.ID_HOTEL, s.SERVICE_NAME
  from   SERVICES S
  where  s.ID_SERVICE = :ID_SERVICE
  into   :id_srv_hotel, :service_name;

  if (:id_srv_hotel is distinct from :id_hotel) then
    exception POSTING_EXCEPTION '-1056' || f_character(31) || f_character(29) || :service_name || f_character(28) || :account_name;

  if (:rate is null) then begin
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :orig_currency, :date_post, :id_guest)
    returning_values  :rate;
  end

  curr_post  = :account_currency;
  if (:orig_currency = :account_currency) then begin
    post_rate  = :rate;
  end else begin
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :account_currency, :date_post, :id_guest)
    returning_values  :post_rate;
  end

  execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :id_tax_policy, :ID_TARIFF, :DATE_POST - :FROM_DATE)
  returning_values (:id_sale_taxation);

  execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:QTY_POST, :PRICE,
                    :RATE, :post_rate, :id_sale_taxation)
  returning_values  :price_post, :post_net_value, :post_gross_value;

  execute procedure ACCOUNT_CHECK_CREDIT_STATUS$INT (:ID_ACCOUNT, :price_post * :QTY_POST)
  returning_values (:ERR_CODE, :ERR_TEXT);
  if (:ERR_CODE <> 0) then exit;

  --
  new_id_account_post = gen_id (id_account_post_gen, 1);

  if (:post_text starting with 'PACK') then begin
    id_pack_service = substring(:post_text from 6 for 20);
    post_text = '';
  end else begin
    id_pack_service = -1;
  end
  if (:is_base = 1) then id_master_addins_acc_post = :new_id_account_post;

  select R.ROOM_NAME, R.ID_ROOM_TYPE
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :room_name, :id_room_type;

  if (:id_guest is null) then begin
    is_archive = 1;
  end else begin
    select iif(G.CHECK_STATUS = 1, 1, 0)
    from   GUEST G
    where  G.ID_GUEST = :id_guest
    into   :is_archive;
  end

  insert into ACCOUNT_POST (
    ID_ACCOUNT_POST, ID_ACCOUNT, ID_GUEST, ID_SERVICE, ID_TARIFF, ID_ROOM,
    IS_BASE, DATE_POST, QTY_POST, QTY_FREE, PRICE_POST, POST_NET_VALUE, POST_GROSS_VALUE, CURR_POST, RATE_POST,
    PRICE_ORIG, CURR_ORIG, RATE_ORIG, IS_LOCKED_FOR_UPDATE, TO_DATE, FROM_DATE, ID_SEQUENCE,
    SHORT_CODE, CHANGED_TEXT, ID_MASTER_ADDINS_ACC_POST, ID_PACK_SERVICE, ROOM_NAME, ID_ROOM_TYPE,
    ID_SALE_TAXATION, AC, IS_ARCHIVE, IN_DOC_QTY, IN_DOC_VALUE, DESCRIPTION)
  values (
    :new_id_account_post, :id_account, :id_guest, :id_service, :id_tariff, coalesce(:id_room, -1),
    :is_base, :date_post, :qty_post, 0, :price_post, :post_net_value, :post_gross_value, :curr_post, :post_rate,
    :price, :orig_currency, :rate, 0, :TO_DATE, :FROM_DATE, :id_secquence,
    :short_code, :changed_text, :id_master_addins_acc_post, :id_pack_service, :room_name, :id_room_type,
    :id_sale_taxation, '00', :is_archive, 0, 0, :DESCRIPTION);

  if ((coalesce(:post_text, '') <> '') or (coalesce(:resource_text, '') <> '')) then begin
    insert into ACCOUNT_POSTING_DET (ID_ACCOUNT_POST, POST_TEXT, QTY, FROM_DATETIME, TO_DATETIME, RESOURCE_TEXT)
    values (:new_id_account_post, :post_text, :qty_post, :FROM_DATE, :TO_DATE, :resource_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_TRANSFER$INT for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE_PERC for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_PERC(IN_ID_ACCOUNT_POST VARCHAR(4000),
IN_PERC NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(30))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_POSTING$INT for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_POSTING$INT(ID_RESOURCE_RESERVATION /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
PRICE_DESCRIPTION /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
ID_RESERV_DETAIL /* TYPE OF ID */ INTEGER,
ID_EXTERNAL_CLIENT_ACCCOUNT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(DOC_SELECTED /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_POSTING_UPDATE$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE$INT(AP_DBKEY TYPE OF TDB_KEY,
ID_SERVICE TYPE OF ID_REF,
ID_TARIFF TYPE OF ID_REF,
ID_ROOM TYPE OF ID_REF,
QTY_POST TYPE OF TQTY,
QTY_FREE TYPE OF TQTY,
PRICE TYPE OF TVALUE,
CURR TYPE OF TCURRENCY,
RATE TYPE OF TRATE,
CHANGED_TEXT VARCHAR(40),
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
IS_CONSEQUENTIAL_UPDATE TYPE OF TBOOLEAN = 0,
RE_ROUTE_ACCOUNT TYPE OF ID_REF = null)
 RETURNS(OUT_QTY_POST TYPE OF TQTY,
OUT_PRICE_POST TYPE OF TVALUE,
OUT_AC VARCHAR(2))
 AS
declare variable date_post date;
  declare variable orig_is_base integer;
  declare variable orig_id_service integer;
  declare variable orig_id_room integer;
  declare variable orig_short_code varchar(255);
  declare variable orig_qty_post integer;
  declare variable orig_ac varchar(2);
  declare variable is_locked_for_update integer;
  declare variable orig_locked_for_update integer;
  declare variable orig_id_tariff integer;
  declare variable orig_id_guest integer;
  declare variable id_type_stay integer;
  declare variable id_room_type integer;
  declare variable id_board integer;
  declare variable id_pack_service integer;
  declare variable new_id_pack_service integer;
  declare variable post_currency char(3);
  declare variable room_name varchar(30);
  declare variable original_post varchar(30);
  declare variable new_ac varchar(2);
  declare variable orig_in_doc_qty numeric(15,2);
  declare variable orig_in_doc_value double precision;
  declare variable rate_post numeric(15,6);
  declare variable id_base_doc integer;
  declare variable id_tax_policy integer;
  declare variable price_post double precision;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable id_sale_taxation integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable orig_price_post tprice;
  declare variable round_to numeric(15,4);
  declare variable account_name tobject_name;
  declare variable err_code integer;
  declare variable err_text varchar(100);
  declare variable id_account integer;
  declare variable orig_id_master_addins_acc_post integer;
  declare variable check_options varchar(255);
begin
  /* GET DATA */
  original_post = '';
  new_id_pack_service = null;

  select AP.DATE_POST, AP.IS_BASE, AP.ID_SERVICE, AP.ID_BASE_DOC,
         AP.SHORT_CODE, AP.QTY_POST, ap.PRICE_POST, AP.IS_LOCKED_FOR_UPDATE,
         AP.AC, AP.ID_TARIFF, AP.ID_GUEST, AP.ID_ROOM,
         AP.CURR_POST, AP.ID_PACK_SERVICE, AP.ID_ROOM_TYPE,
         AP.IN_DOC_QTY, AP.IN_DOC_VALUE, AP.RATE_POST, ap.ID_SALE_TAXATION,
         ap.ID_ACCOUNT, ap.ID_ACCOUNT_POST, ap.ID_MASTER_ADDINS_ACC_POST
  from   ACCOUNT_POST AP
  where  AP.rdb$db_key = :AP_DBKEY
  into   :date_post, :orig_is_base, :orig_id_service, :id_base_doc,
         :orig_short_code, :orig_qty_post, :orig_price_post, :orig_locked_for_update,
         :orig_ac, :orig_id_tariff, :orig_id_guest, :orig_id_room,
         :post_currency, :id_pack_service, :id_room_type,
         :orig_in_doc_qty, :orig_in_doc_value, :rate_post, :id_sale_taxation,
         :id_account, :id_account_post, :orig_id_master_addins_acc_post;

  check_options = 'ALLOW_POSTING;';
  if (:RE_ROUTE_ACCOUNT is not null and :id_base_doc is null and :id_account <> :RE_ROUTE_ACCOUNT) then begin
    -- IMPORTANT !!! Re-routing is possible only in this case!
    id_account = :RE_ROUTE_ACCOUNT;
    if ( (:orig_is_base = 1) or (:orig_id_master_addins_acc_post > 0) ) then
      check_options = :check_options || 'IS_BASE;';
    else
      check_options = :check_options || 'IS_EXTRA;';
  end
  is_locked_for_update = :orig_locked_for_update; /* to initialize and preserve from null */

  execute procedure ACCOUNT_VALIDATE$INT(:id_account, :check_options)
  returning_values  (:err_code, :err_text, :post_currency, :id_tax_policy, :id_hotel, :account_name);
  if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;

  if (:IS_CONSEQUENTIAL_UPDATE is distinct from 1) then begin
    -- direct post update - manual edition restrictions check
    if (:QTY_POST = -1) then QTY_POST = :orig_qty_post;   -- preserve current qty

    if (:QTY_POST <> :orig_qty_post) then exception POSTING_EXCEPTION '-379';

    if ((:orig_is_base = 1) and ((:QTY_POST <> 1) or (:ID_SERVICE <> :orig_id_service))) then
      exception POSTING_EXCEPTION '-223';

    if (:orig_ac = '01') then execute procedure RIGHTS_CHECK_GRANTED$INT('BALANCES_EDIT_CLOSED');

    short_code = :orig_short_code;
    id_tariff  = :orig_id_tariff;
    id_room    = :orig_id_room;
    is_locked_for_update = 1;  /* manual corrections must lock the postings  */

  end else begin
    /* post changes is a result from some user operation, indirect update ('NORMAL', 'FORCED', safes recalc, etc....) */
    is_locked_for_update = 0;

    if (:orig_is_base = 1) then begin
      /* PREPARING THE PACKET SERVICE */
      select S.ID_TYPE_STAY, S.ID_ROOM_TYPE
      from   SERVICE_PACKET S
      where  S.ID_SERVICE = :id_service
      into   :id_type_stay, :id_room_type;

      select GS.ID_BOARD
      from   GUEST_STAY GS
      where  GS.ID_GUEST = :orig_id_guest
             and GS.FOR_DATE = :date_post
      into   :id_board;

      execute procedure TAR_GET_BASE_SERVICE$INT(:id_type_stay, :id_room_type, :id_board, :id_hotel)
      returning_values  :id_pack_service;
      /* detecting change of STAY_TYPE or ROOM_TYPE */
      if (exists(
        select *
        from   SERVICE_PACKET S
        where  S.ID_SERVICE = :orig_id_service
               and ((S.ID_TYPE_STAY is distinct from :id_type_stay) or (S.ID_ROOM_TYPE is distinct from :id_room_type))
      )) then original_post = 'CHANGED';
    end
  end

  select R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :room_name;

  if (:orig_locked_for_update = 1
      and :changed_text starting with 'NORMALRECALC'
      and :id_service = :orig_id_service
      --and :orig_is_anul = 0
      and :id_tariff = :orig_id_tariff) then
  begin
    -- price is locked for update
    update ACCOUNT_POST AP
    set    AP.ID_ROOM      = :ID_ROOM,
           AP.ROOM_NAME    = :room_name,
           Ap.FROM_DATE    = :FROM_DATE,
           Ap.TO_DATE      = :TO_DATE,
           AP.ID_PACK_SERVICE  = :id_pack_service,
           AP.CHANGED_TEXT     = :CHANGED_TEXT,
           AP.USER_CHANGED     = current_user,
           AP.DATETIME_CHANGED = current_timestamp,
           AP.SHORT_CODE       = :SHORT_CODE
    where  AP.rdb$db_key   = :AP_DBKEY;
    OUT_QTY_POST = :orig_qty_post;
    OUT_PRICE_POST = :orig_price_post;
    OUT_AC = :orig_ac;
  end else begin
    -- fully update
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :curr, :date_post, :orig_id_guest)
    returning_values  :rate;
  
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :post_currency, :date_post, :orig_id_guest)
    returning_values  :rate_post;
  
    if (:id_base_doc is null) then begin
      execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :id_tax_policy, :ID_TARIFF, :date_post - :from_date)
      returning_values (:id_sale_taxation);
    end

    execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:QTY_POST, :PRICE,
                      :RATE, :rate_post, :id_sale_taxation)
    returning_values  :price_post, :post_net_value, :post_gross_value;

    select c.ROUND_TO
    from   CURRS c
    where  c.CURR = :post_currency
    into   :round_to;

    if ( (:id_base_doc is not null)
         and (:qty_post = :orig_in_doc_qty)
         and (round_f(:price_post * :qty_post - :orig_in_doc_value * :orig_in_doc_qty, :round_to) = 0))
    then new_ac = '01';
    else new_ac = '00';                   
  
    if (:new_ac = '00') then begin
      execute procedure ACCOUNT_CHECK_CREDIT_STATUS$INT (:id_account, :price_post * :QTY_POST - :orig_price_post * :orig_qty_post)
      returning_values (:err_code, :err_text);
      if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;
    end

    update ACCOUNT_POST AP
    set    AP.ID_ACCOUNT           = :id_account,
           AP.ID_SERVICE           = :id_service,
  
           AP.QTY_POST             = :qty_post,
           AP.QTY_FREE             = :qty_free,
           AP.PRICE_POST           = :price_post,
           AP.CURR_POST            = :post_currency,
           AP.RATE_POST            = :rate_post,
           AP.RATE_ORIG            = :rate,
           AP.PRICE_ORIG           = :price,
           AP.CURR_ORIG            = :curr,
           AP.POST_NET_VALUE       = :post_net_value,
           AP.POST_GROSS_VALUE     = :post_gross_value,
  
           AP.AC                   = :new_ac,
           AP.IS_ANUL              = 0,
           AP.ANUL_REASON          = '',
           AP.IS_LOCKED_FOR_UPDATE = :is_locked_for_update,
           AP.ID_TARIFF            = :id_tariff,
           AP.ID_PACK_SERVICE      = :id_pack_service,
           AP.ID_ROOM              = :id_room,
           AP.ID_ROOM_TYPE         = :id_room_type,
           AP.ROOM_NAME            = :room_name,
           AP.ID_SALE_TAXATION     = :id_sale_taxation,
           AP.ORIGINAL_POST        = :original_post,
           AP.SHORT_CODE           = :short_code,
           AP.CHANGED_TEXT         = :changed_text,
           AP.USER_CHANGED         = current_user,
           AP.DATETIME_CHANGED     = current_timestamp,
           Ap.FROM_DATE            = :from_date,
           Ap.TO_DATE              = :to_date
    where  AP.rdb$db_key = :AP_DBKEY
    returning new.id_account_post, new.id_pack_service
    into   :id_account_post, :new_id_pack_service;
  
    if (:new_ac = '01') then begin
      update ACCOUNT_POST_CORRECTION APC
      set    APC.IS_OPEN = 0
      where  APC.ID_ACCOUNT_POST = :id_account_post
             and APC.IS_OPEN = 1;
    end

    if (:orig_is_base = 1 and :new_id_pack_service <> :id_pack_service) then begin
      -- update add_inses with new pack service
      update ACCOUNT_POST AP
      set    ap.ID_PACK_SERVICE = :new_id_pack_service
      where  ap.ID_MASTER_ADDINS_ACC_POST = :id_account_post
             and ap.IS_BASE = 0;
    end

    OUT_QTY_POST = :qty_post;
    OUT_PRICE_POST = :price_post;
    OUT_AC = :new_ac;
  end
end
^

/* Alter (ACCOUNT_POSTING_UPDATE_PERC) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_PERC(IN_ID_ACCOUNT_POST VARCHAR(4000),
IN_PERC NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(30))
 AS
declare variable id_account_post integer;
  declare variable ap_dbkey char(8);
  declare variable id_service integer;
  declare variable id_tariff integer;
  declare variable id_room integer;
  declare variable qty_post numeric (15,4);
  declare variable qty_free numeric (15,4);
  declare variable short_code varchar(255);
  declare variable orig_currency char(3);
  declare variable orig_rate numeric (15,4);
  declare variable orig_price numeric (15,4);
  declare variable new_orig_price double precision;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  for
    select item
    from   SYSTEM_STRING_PARSER(:in_id_account_post, ',')
    into   :id_account_post
  do begin
    select AP.rdb$db_key, AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST,
           AP.QTY_FREE, AP.SHORT_CODE, AP.CURR_ORIG, AP.RATE_ORIG, AP.PRICE_ORIG,
           ap.FROM_DATE, ap.TO_DATE
    from   ACCOUNT_POST AP
    where  AP.ID_ACCOUNT_POST = :id_account_post
    into   :ap_dbkey, :id_service, :id_tariff, :id_room, :qty_post,
           :qty_free, :short_code, :orig_currency, :orig_rate, :orig_price,
           :from_date, :to_date;

    new_orig_price = :orig_price + :orig_price * :in_perc;

    execute procedure ACCOUNT_POSTING_UPDATE$INT(:ap_dbkey,
            :id_service, :id_tariff, :id_room,
            :qty_post, :qty_free, :new_orig_price, :orig_currency, :orig_rate,
            :in_changed_text, :short_code, :from_date, :to_date)
    returning_values  :no_use, :no_use, :no_use;
  end
end
^

/* Alter (AVAILABILITY_RATE_SMALL$WBE) */
ALTER PROCEDURE AVAILABILITY_RATE_SMALL$WBE(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER,
ROOMS INTEGER,
ADULTS INTEGER,
CHILDREN INTEGER,
QUERY_ID INTEGER,
PROFILE_ID INTEGER)
 AS
declare variable id_room_type integer;
declare variable nonavaialbility_note varchar(255);
declare variable is_available smallint;
declare variable id_rate integer;
declare variable id_board integer;
declare variable roomtype_list varchar(2000);
declare variable rate_list varchar(2000);
declare variable board_list varchar(2000);
declare variable hotels varchar(255);
declare variable room_status integer;
declare variable rate_status integer;
declare variable rate_min_los integer;
declare variable rate_max_los integer;
declare variable id_channel integer;
declare variable helper_session_id integer;
declare variable error_check integer;
declare variable available_roomtype_list varchar(2000);
declare variable special_rate_list varchar(2000);
declare variable available_rooms integer;
declare variable is_public smallint;
begin
    
  /*Produces data in result table availabiliti_rate$wbe.
   Get availability as AVAILABILITY_OCCUP_SMALL$WBE see there for notes */

  /*empty WBE specific table*/
  delete from product_availability$wbe p
  where p.query_id = :query_id;

  /* find id_channel for wbe*/
  select max(c.id_channel), count(c.id_channel)  from channel c where c.name = 'WBE'
  into :id_channel, :error_check;
  if (not (:error_check = 1)) then  exception WRONG_VALUE 'Missing channel WBE or dublicated definition!';

  /*First check chennel management - find rates, room type for sale and restrictions*/
  special_rate_list = ',';
  available_roomtype_list = ',';
  helper_session_id =  gen_id(SELECTION_GEN, 1);
  for
    select c.id_room_type, c.id_tar_head, c.is_product_avaialable, c.room_status, c.rate_status,
           c.rate_min_los, c.rate_max_los, c.available_rooms, c.is_public
    from   channel_product_avail_req$int (:id_channel, :id_hotel, :from_date, :to_date, :rooms) c
    into   :id_room_type, :id_rate, :is_available, :room_status, :rate_status,
           :rate_min_los, :rate_max_los, :available_rooms, :is_public
  do begin
      /*make a list of available roomt types - needed for special rate product building*/
      if ((:room_status = 2) and (','|| :available_roomtype_list ||',' not containing ','|| :id_room_type ||',')) then
        available_roomtype_list = :available_roomtype_list || :id_room_type ||',';

      /*set nonavaialbility_note*/
      nonavaialbility_note = '';
      if (:is_available = 0) then begin
        if ((:room_status = 0) or (:room_status is null) ) then nonavaialbility_note = '@{No rooms available.} ';
        else begin
            if (:rate_status = 0) then nonavaialbility_note = nonavaialbility_note || '@{Rate is closed.} ';
            if (:rate_status = 1) then nonavaialbility_note = nonavaialbility_note || '@{Rate is closed for arrival.} ';
            if (:rate_status = 2 and :rate_min_los = :rate_max_los) then nonavaialbility_note = nonavaialbility_note || '@{Required stay} ' || rate_min_los || ' @{days.} ';
            if ((:rate_status = 2) and (:rate_min_los > 0) and (:rate_min_los is distinct from :rate_max_los)) then  nonavaialbility_note = nonavaialbility_note || '@{Minimum stay} ' || rate_min_los || ' @{days.} ';
            if ((:rate_status = 2) and (:rate_max_los > 0) and (:rate_min_los is distinct from :rate_max_los)) then  nonavaialbility_note = nonavaialbility_note || '@{Maximum stay} ' || rate_max_los || ' @{days.} ';
        end
      end

      /*insert status and note in int table for this product IF RATE IS PUBLIC or If it is Private but allowed in current profile. Supress 'closed' rate, but show closed for arrival, min los, etc.*/
      /* !! new behaviour - SPECIAL/PRIVATE rates must be managed from CHANNEL MANAGEMENT too */
      if (:rate_status <> 0) then begin
        if (:is_public = 1) then begin
          insert into product_availability$int (session_id, room_type_id, rate_id, is_available, nonavaialbility_note, available_rooms)
          values (:helper_session_id, :id_room_type, :id_rate, :is_available, :nonavaialbility_note, :available_rooms);
        end else begin /* If it is PRIVATE */
          if (exists ( select phr.id_tariff
                        from profile_hotel_rate phr
                        where phr.id_profile = :profile_id
                          and phr.id_hotel = :id_hotel
                          and phr.id_tariff = :id_rate )) then
          begin
              insert into product_availability$int (session_id, room_type_id, rate_id, is_available, nonavaialbility_note, available_rooms)
              values (:helper_session_id, :id_room_type, :id_rate, :is_available, :nonavaialbility_note, :available_rooms);
              /*Making special rate list for indicating in WBE GUI. Rate will be indicated as special if they are private */
              special_rate_list = :special_rate_list || :id_rate ||',';
          end
        end
      end

  end


  /* for available rates - make a rate list. */
  rate_list = ',';
  for
    select distinct pa.rate_id
    from   product_availability$int pa
    where  pa.session_id = :helper_session_id
      /*$$IBEC$$   and pa.is_available = 1 $$IBEC$$*/
    into :id_rate
  do begin
    rate_list = :rate_list || :id_rate || ',';
  end

  /* make a room type list from prepared int table*/
  ROOMTYPE_LIST = ',';
  for
    select distinct pa.room_type_id
    from product_availability$int pa
    where pa.session_id = :helper_session_id
       /*$$IBEC$$  and pa.is_available = 1 $$IBEC$$*/
    into :id_room_type
  do begin
    roomtype_list = :roomtype_list || :id_room_type || ',';
  end

  /* make a list of all boards. Rating will remove non used boards */
  --BOARD_LIST = ',0,'; -- without board
  BOARD_LIST = ',';
  for
    select th.ID_BOARD
    from   MEALS th
    where  th.IS_ARCHIVE = 0
           and th.IS_BOARD = 1
           and th.ID_HOTEL = :ID_HOTEL
           --and th.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
    into   :id_board
  do begin
    BOARD_LIST = :BOARD_LIST || coalesce(:id_board, 0) || ',';
  end

  hotels = ',' || :id_hotel ||',';

  execute procedure sys_dbg('wbe PARAMS FOR  availability_raiting_sub$int :');
  execute procedure sys_dbg('wbe -:helper_session_id = '|| :helper_session_id);
  execute procedure sys_dbg('wbe -:from_date = '|| :from_date);
  execute procedure sys_dbg('wbe -:to_date = '|| :to_date);
  execute procedure sys_dbg('wbe -:rooms = '|| :rooms);
  execute procedure sys_dbg('wbe -:adults = '|| :adults);
  execute procedure sys_dbg('wbe -:children = '|| :children);
  execute procedure sys_dbg('wbe -:roomtype_list = '|| :roomtype_list);
  execute procedure sys_dbg('wbe -:rate_list = '|| :rate_list);
  execute procedure sys_dbg('wbe -:board_list = '|| :board_list);
  execute procedure sys_dbg('wbe -:hotels = '|| :hotels  );
  execute procedure sys_dbg('wbe -:available_roomtype_list = '|| :available_roomtype_list );

  /*calc prices for request in TMP_AVAILABILITY */
  execute procedure AVAILABILITY_RATING_LOOP$INT (:helper_session_id,  :from_date, :to_date,
                    :rooms, :adults, :children, :roomtype_list, :rate_list, :board_list, :hotels);

  /*Copy data to WBE specific table*/
  insert into PRODUCT_AVAILABILITY$WBE
       (query_id, room_type_id, room_name, rate_id, rate_name, board_id, board_name,
       price_night, price_total, currency, is_available, nonavailability_note,
       is_special_rate, available_rooms)
  select :query_id, pa.room_type_id, rt.type_room, pa.rate_id, t.tarifa_name, ta.id_board, th.NAME,
        ta.price, ta.total_price, ta.currency, coalesce( pa.is_available, 0), pa.nonavaialbility_note,
        iif( ','|| :special_rate_list ||',' containing ','|| pa.rate_id ||',', 1, 0), pa.available_rooms
  from  PRODUCT_AVAILABILITY$INT pa /*left outer join*/
        join TMP_AVAILABILITY ta on pa.room_type_id = ta.id_room_type
                                    and pa.rate_id = ta.id_rate
                                    and pa.session_id = ta.ID_SESSION
        join ROOM_TYPES rt on rt.id_room_type =  ta.id_room_type
        join TARIFA t on t.id_tarifa = ta.id_rate
        join MEALS th on th.ID_BOARD = ta.id_board
  where pa.session_id = :helper_session_id;
        --and ta.id_board is not null; -- ???

/*Empty tmp_availability*/
  delete from TMP_AVAILABILITY ta
  where  ta.ID_SESSION = :helper_session_id;

  /*Empty helper in table product_availability$int*/
  delete from  PRODUCT_AVAILABILITY$INT p
  where p.session_id = :helper_session_id;

end
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_RATING$AVL for: AVAILABILITY_RATING_LOOP$INT */
ALTER PROCEDURE AVAILABILITY_RATING$AVL(ID_AGENT_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ROOMS_COUNT INTEGER,
ADULTS_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ROOMTYPE_LIST VARCHAR(2000),
RATE_LIST VARCHAR(2000),
BOARD_LIST VARCHAR(2000),
HOTELS VARCHAR(255) = '')
 RETURNS(ID_SESSION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (AVAILABILITY_RATING_LOOP$INT) */
ALTER PROCEDURE AVAILABILITY_RATING_LOOP$INT(ID_SESSION INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ROOMS_COUNT INTEGER,
ADULTS_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ROOMTYPE_LIST VARCHAR(2000),
RATE_LIST VARCHAR(2000),
BOARD_LIST VARCHAR(2000),
HOTELS VARCHAR(255) = '')
 AS
declare variable id_rate integer;
declare variable id_board integer;
declare variable id_room_type integer;
declare variable price_currency char(3);
declare variable price numeric (15,4);
declare variable total_price numeric (15,4);
declare variable round_to numeric (15,4);
declare variable price_details varchar(100);
declare variable stay_length integer;
declare variable calc_adult_count integer;
declare variable calc_children_count integer;
declare variable beds integer;
declare variable id_hotel integer;
declare variable id_tar_calc integer;
begin
  /* This proc produced calculations in result table TMP_AVAILABILITY*/
  stay_length = :departure_date - :arrival_date;
  calc_children_count = coalesce(:children_count, 0);
  /* 1. LOOP RATES */
  id_tar_calc = gen_id(GEN_ID_TAR_CALC, 1);
  for
    select distinct T.ID_TARIFA, t.ID_HOTEL,
           rt.ID_ROOM_TYPE, rt.BEDS, tbt.ID_BOARD
    from   SYSTEM_STRING_PARSER (:RATE_LIST, ',') SP
           join TARIFA T on t.ID_TARIFA = sp.ITEM
                            and T.IS_ACTIVE = 1
                            and (
                                  (cast(:hotels as varchar(2000))  = '')
                                 or
                                  (','||(cast(:hotels as varchar(2000)))||',' containing ','||T.ID_HOTEL||',')
                                )
           join TAR_HEAD th on t.id_tarifa = th.id_tar_head
           left outer join TAR_SIMPLE ts on ts.id_tar_head = th.ID_TAR_HEAD
           left outer join TARIFA_ROOM_TYPES_SUPPORTED (th.ID_TAR_HEAD) trt on 1=1
           left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = trt.ID_ROOM_TYPE
           left outer join TARIFA_BOARDS_SUPPORTED (th.ID_TAR_HEAD) tbt on 1=1
           left outer join MEALS b on b.ID_BOARD = tbt.ID_BOARD
    where  cast(:roomtype_list as varchar(2000)) containing ','|| TRT.ID_ROOM_TYPE ||','
           and cast(:board_list as varchar(2000)) containing ','|| coalesce(tbt.ID_BOARD, 0) ||','
    order by th.ID_TAR_HEAD asc,
           rt.beds desc, rt.ID_ROOM_TYPE asc
    into   :id_rate, :id_hotel, :id_room_type, :beds, :id_board
  do begin
    /* fall back to room type bed count but max 2 */
    calc_adult_count = coalesce(:adults_count, iif(:beds >= 2, 2, 1));

    if ((:calc_adult_count is null) or (:calc_children_count is null)) then
      exception assert ('null for calc_adult_count or calc_children_count parameter!' );

    price_currency = null;
    price = null;
    total_price = null;
    price_details = null;

    execute procedure PRODUCT_RATING$INT (:id_hotel, :ARRIVAL_DATE, :DEPARTURE_DATE,
            :calc_adult_count, :calc_children_count, :id_room_type, :id_board, :id_rate, null, null, :id_tar_calc)
    returning_values  :total_price, :price_currency, :price_details;

    if (:total_price is not null) then begin
      select c.ROUND_TO
      from   CURRS c
      where  c.CURR = :price_currency
      into   :round_to;

      price = round_f(:total_price/:stay_length, :round_to);
      total_price = :rooms_count * :total_price;
      insert into TMP_AVAILABILITY (ID_SESSION, ID_ROOM_TYPE, ID_RATE, ID_BOARD, CURRENCY,
              PRICE, TOTAL_PRICE, PRICE_DETAILS, TOTAL_ROOMS, ALLOTMENT_ROOMS)
      values (:id_session, :id_room_type, :id_rate, :id_board, :price_currency,
              :price, :total_price, :price_details, 0, 0);
    end

  end
end
^

/* empty dependent procedure body */
/* Clear: SERVICE_MEAL_MODIFY$INT for: BASE_SERVICES_GEN$INT */
ALTER PROCEDURE SERVICE_MEAL_MODIFY$INT(ID_SERVICE /* TYPE OF ID */ INTEGER,
IS_BREAKFAST /* TYPE OF TLOGICAL */ SMALLINT,
IS_LUNCH /* TYPE OF TLOGICAL */ SMALLINT,
IS_DINNER /* TYPE OF TLOGICAL */ SMALLINT,
IS_EXTRAFOOD1 /* TYPE OF TLOGICAL */ SMALLINT,
IS_EXTRAFOOD2 /* TYPE OF TLOGICAL */ SMALLINT,
IS_BOARD /* TYPE OF TLOGICAL */ SMALLINT,
ID_HOTEL /* TYPE OF ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (BASE_SERVICES_GEN$INT) */
ALTER PROCEDURE BASE_SERVICES_GEN$INT(ID_HOTEL INTEGER)
 AS
declare variable id_board integer;
  declare variable type_hrana varchar(30);
  declare variable id_room_type integer;
  declare variable type_room varchar(30);
  declare variable id_type_stay integer;
  declare variable type_stay varchar(30);
  declare variable id_service integer;
  declare variable new_service_name varchar(30);
  declare variable existing_id_service integer;
  declare variable id_service_group integer;
begin

  select min(sg.ID_SERVICE_GROUP)
  from   SERVICE_GROUPS sg
  where  sg.ID_HOTEL = :id_hotel
  into   :id_service_group;

  /*
    CRS/WBE support
    when running the wizard in replication environment the groups are replicated
    as emebeded component and the current subscriber may heve no records in SERVICE_GROUPS
    to resolve this autocreate the default group
   */
  if (:id_service_group is null) then begin
    execute procedure IMPORT_SERVICE_GROUP$EXC(:id_hotel, '-')
    returning_values :id_service_group;
  end

  /* CREATE BASE SERVICES FOR THE FULL COMBINATION FROM HRANI, ROOM_TYPES AND STAY TYPES */
  for
    select sm.ID_BOARD, sm.NAME, ts.ID_TYPE_STAY, ts.TYPE_STAY, rt.ID_ROOM_TYPE, rt.TYPE_ROOM
    from   MEALS sm,
           ROOM_TYPES rt,
           TYPE_STAY ts
    where  sm.ID_HOTEL = :ID_HOTEL
           and sm.IS_BOARD = 1
           and rt.ID_HOTEL = :id_hotel
    into   :id_board, :type_hrana, :id_type_stay, :type_stay, :id_room_type, :type_room
  do begin
    new_service_name = substring(:type_hrana from 1 for 9)||'\'
                       ||substring(:type_room from 1 for 9)||'\'
                       ||substring(:type_stay from 1 for 9);
    existing_id_service = null;
    select sp.ID_SERVICE
    from   SERVICE_PACKET sp
           join SERVICES s on s.ID_SERVICE = sp.ID_SERVICE
    where  s.ID_HOTEL = :id_hotel
           --and s.IS_BASE = 1
           and sp.ID_ROOM_TYPE = :id_room_type
           and sp.ID_TYPE_STAY = :id_type_stay
           and sp.ID_BOARD = :id_board
    into   :existing_id_service;

    if (:existing_id_service is null) then begin
      id_service = gen_id(ID_SERVICE_GEN, 1);
      insert into SERVICES (ID_SERVICE, ID_SERVICE_GROUP, SERVICE_TYPE, /*IS_BASE,*/ SERVICE_NAME,
             IS_DELETED, IS_MANUAL_PRICE, IS_DETAILS,
             REVENUE_GROUP, REVENUE_ACCOUNT, ACCOUNT_NAME, VAUCHER_PACKET, ID_HOTEL)
      values (:id_service, :id_service_group, 'BASE', /*1,*/ :new_service_name,
             0, 0, 0,
             'ROOMS', '<Market segment>', '', 'BASE', :ID_HOTEL);
    end else begin
      id_service = :existing_id_service;
    end

    update or insert into SERVICE_PACKET (ID_SERVICE, ID_TYPE_STAY, ID_ROOM_TYPE, ID_BOARD)
    values (:id_service, :id_type_stay, :id_room_type, :id_board)
    matching(ID_SERVICE);

    update SERVICES s
    set    s.ID_SERVICE_PACKET = :id_service,
           s.SERVICE_NAME = :new_service_name,
           s.IS_DELETED = 0
    where  s.ID_SERVICE = :id_service;

  end

end
^

/* Alter (BOARD_TO_FOODS) */
ALTER PROCEDURE BOARD_TO_FOODS(ID_BOARD TYPE OF ID)
 RETURNS(ID_SERVICE TYPE OF ID_REF)
 AS
declare variable is_breakfast integer;
  declare variable is_lunch integer;
  declare variable IS_DINNER integer;
  declare variable is_extrafood1 integer;
  declare variable is_extrafood2 integer;
  declare variable id_hotel integer;
begin

  select TH.IS_BREAKFAST, TH.IS_LUNCH, TH.IS_DINNER, TH.IS_EXTRAFOOD1, TH.IS_EXTRAFOOD2, TH.ID_HOTEL
  from   MEALS TH
  where  TH.ID_BOARD = :id_board
  into   :is_breakfast, :is_lunch, :IS_DINNER, :is_extrafood1, :is_extrafood2, :ID_HOTEL;

  if (:is_breakfast = 1) then begin
    ID_SERVICE = -1;
    select first 1 TH.ID_SERVICE
    from   MEALS TH
    where  TH.IS_BREAKFAST = 1
           and TH.IS_LUNCH = 0
           and TH.IS_DINNER = 0
           and TH.IS_EXTRAFOOD1 = 0
           and TH.IS_EXTRAFOOD2 = 0
           and TH.IS_BOARD = 0
           and TH.ID_HOTEL = :ID_HOTEL
    order by th.IS_ARCHIVE asc, TH.ID_SERVICE asc
    into   :ID_SERVICE;
    suspend;
  end

  if (:is_lunch = 1) then begin
    ID_SERVICE = -1;
    select first 1 TH.ID_SERVICE
    from   MEALS TH
    where  TH.IS_BREAKFAST = 0
           and TH.IS_LUNCH = 1
           and TH.IS_DINNER = 0
           and TH.IS_EXTRAFOOD1 = 0
           and TH.IS_EXTRAFOOD2 = 0
           and TH.IS_BOARD = 0
           and TH.ID_HOTEL = :ID_HOTEL
    order by th.IS_ARCHIVE asc, TH.ID_SERVICE asc
    into   :ID_SERVICE;
    suspend;
  end

  if (:IS_DINNER = 1) then begin
    ID_SERVICE = -1;
    select first 1 TH.ID_SERVICE
    from   MEALS TH
    where  TH.IS_BREAKFAST = 0
           and TH.IS_LUNCH = 0
           and TH.IS_DINNER = 1
           and TH.IS_EXTRAFOOD1 = 0
           and TH.IS_EXTRAFOOD2 = 0
           and TH.IS_BOARD = 0
           and TH.ID_HOTEL = :ID_HOTEL
    order by th.IS_ARCHIVE asc, TH.ID_SERVICE asc
    into   :ID_SERVICE;
    suspend;
  end

 if (:is_extrafood1 = 1) then begin
    ID_SERVICE = -1;
    select first 1 TH.ID_SERVICE
    from   MEALS TH
    where  TH.IS_BREAKFAST = 0
           and TH.IS_LUNCH = 0
           and TH.IS_DINNER = 0
           and TH.IS_EXTRAFOOD1 = 1
           and TH.IS_EXTRAFOOD2 = 0
           and TH.IS_BOARD = 0
           and TH.ID_HOTEL = :ID_HOTEL
    order by th.IS_ARCHIVE asc, TH.ID_SERVICE asc
    into   :ID_SERVICE;
    suspend;
  end

  if (:is_extrafood2 = 1) then begin
    ID_SERVICE = -1;
    select first 1 TH.ID_SERVICE
    from   MEALS TH
    where  TH.IS_BREAKFAST = 0
           and TH.IS_LUNCH = 0
           and TH.IS_DINNER = 0
           and TH.IS_EXTRAFOOD1 = 0
           and TH.IS_EXTRAFOOD2 = 1
           and TH.IS_BOARD = 0
           and TH.ID_HOTEL = :ID_HOTEL
    order by th.IS_ARCHIVE asc, TH.ID_SERVICE asc
    into   :ID_SERVICE;
    suspend;
  end
end
^

ALTER PROCEDURE RES_CREATE_GET$RSV(ID_HOTEL INTEGER)
 RETURNS(ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIMESTAMP,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIMESTAMP,
TRANSFER_OUT_NOTE VARCHAR(30),
IS_LATE_DEPARTURE INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
COUNTRY_CODE VARCHAR(20),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
CHECK_STATUS INTEGER,
ID_HK_PLAN INTEGER,
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF,
DEFAULT_GUEST_MASK VARCHAR(10))
 AS
declare variable stay_length integer;
  declare variable sys_date date;
begin
/* on the GUI
id_room_type;
id_tariff;
id_board;
code_first_food;

adult_count
child_count
check_status
*/

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :sys_date;
   
  select sv.SETTING_VALUE
  from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :ID_HOTEL) sv
  into   :ID_ACC_TEMPLATE_PERSON;
--  ID_ACC_TEMPLATE_PERSON = 0;
  select RT.ARRIVAL_DATE, RT.DEPARTURE_DATE, RT.ADULT_COUNT, RT.CHILD_COUNT, RT.STAY_LENGTH,
         RT.ID_ROOM_TYPE, RT.ID_ROOM, m.ID_BOARD, T.ID_TARIFA, RT.CUSTOM_PRICE,
         RT.CUSTOM_CURRENCY, RT.VOUCHER_NUM, RT.VOUCHER_DATE, RT.VOUCHER_TEXT, RT.VOUCHER2_NUM,
         RT.VOUCHER2_DATE, RT.TRANSFER_IN_TIME, RT.TRANSFER_IN_NOTE, RT.TRANSFER_OUT_TIME,
         RT.TRANSFER_OUT_NOTE, RT.IS_LATE_DEPARTURE, RT.CODE_FIRST_FOOD, RT.ID_NOM_MARKET_SEGMENT,
         RT.ID_NOM_SOURCE_CODE, RT.ID_NOM_CHANNEL_CODE, RT.ID_NOM_HEAR_REASON, RT.ID_NOM_COME_REASON,
         RT.ID_AGENT_PROFILE, RT.ID_PERSON_PROFILE, RT.COUNTRY_CODE, RT.ACC_ROUTING,
         RT.ID_PERSON_PAYMENT, RT.ID_AGENT_PAYMENT, RT.ID_AGENT_ACCOUNT, RT.CHECK_STATUS, RT.ID_HK_PLAN,
         RT.ID_GUARANTEE_POLICY, e.ID_EATING_OBJECT
  from   RES_TEMPLATE RT
         left outer join MEALS m on m.ID_BOARD = rt.ID_BOARD and m.IS_ARCHIVE = 0
         left outer join TARIFA t on t.ID_TARIFA = rt.ID_TARIFF and t.IS_ACTIVE = 1
         left outer join EATING_OBJECT e on e.ID_EATING_OBJECT = rt.ID_EATING_OBJECT and e.IS_ARCHIVE = 0
  where  RT.ID_HOTEL = :id_hotel
  into   :arrival_date, :departure_date, :adult_count, :child_count, :stay_length,
         :id_room_type, :id_room, :id_board, :id_tariff, :custom_price,
         :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
         :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time,
         :transfer_out_note, :is_late_departure, :code_first_food, :id_nom_market_segment,
         :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason,
         :id_agent_profile, :id_person_profile, :country_code, :acc_routing,
         :id_person_payment, :id_agent_payment, :id_agent_account, :check_status, :id_hk_plan,
         :id_guarantee_policy, :id_eating_object;


  if (:arrival_date is null) then arrival_date = :sys_date;
  if (:stay_length is null) then stay_length = 1;
  if (:departure_date is null) then departure_date = :arrival_date + :stay_length;
  if (:is_late_departure is null) then is_late_departure = 0; 
  if (:adult_count is null) then adult_count = 2;
  if (:child_count is null) then child_count = 0;

  if (:country_code is null) then begin
    execute procedure SETTING_GET_VALUE('DEF_COUNTRY', :ID_HOTEL)
    returning_values  :country_code;
  end
  if (:id_person_payment is null) then begin
    execute procedure SETTING_GET_VALUE('DEF_PAY_TYPE', :ID_HOTEL)
    returning_values  :id_person_payment;
  end
  if (:id_agent_payment is null) then begin
    execute procedure SETTING_GET_VALUE('DEF_PAY_TYPE', :ID_HOTEL)
    returning_values  :id_agent_payment;
  end
  if (:ID_PERSON_PROFILE is null) then begin
    execute procedure SETTING_GET_VALUE ('DEF_GUEST_MASK', :ID_HOTEL)
    returning_values  :DEFAULT_GUEST_MASK;
  end

  if (:acc_routing is null) then acc_routing = 'GUEST';
  if (:check_status is null) then check_status = -3;

  guarantee_deposit = null;
  guarantee_currency = null;
  suspend;
end
^

/* Alter (DEFAULT_BOOKING_VALUES$EXC) */
ALTER PROCEDURE DEFAULT_BOOKING_VALUES$EXC(BOOKING_DBKEY CHAR(8),
HOTEL_ID INTEGER,
RATE_ID_IN INTEGER,
ROOM_TYPE_ID_IN INTEGER,
BOARD_ID_IN INTEGER,
MAINTANCE_SHEMA_ID_IN INTEGER,
ARRANGER_PAYMENT_TYPE_ID_IN INTEGER,
GUEST_PAYMENT_TYPE_ID_IN INTEGER,
MARKETING1_ID_IN INTEGER,
MARKETING2_ID_IN INTEGER,
MARKETING3_ID_IN INTEGER,
MARKETING4_ID_IN INTEGER,
MARKETING5_ID_IN INTEGER,
ARRANGER_PROFILE_ID_IN INTEGER,
MAIN_GUEST_PROFILE_ID_IN INTEGER,
POSTING_ROUTING_IN VARCHAR(50),
FIRST_FOOD_CODE_IN TFOOD_CODE,
GUARANTEE_POLICY_ID_IN INTEGER,
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_LATE_DEPARTURE_IN INTEGER,
EATING_OBJECT_ID_IN INTEGER)
 RETURNS(RATE_ID INTEGER,
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
MAINTANCE_SHEMA_ID INTEGER,
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
ARRANGER_PROFILE_ID INTEGER,
ARRANGER_ACCOUNT_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
POSTING_ROUTING VARCHAR(50),
FIRST_FOOD_CODE TFOOD_CODE,
GUARANTEE_POLICY_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_LATE_DEPARTURE INTEGER,
EATING_OBJECT_ID INTEGER,
DEFAULT_GUEST_MASK VARCHAR(10))
 AS
declare variable arrival_date_def date;
  declare variable departure_date_def date;
  declare variable adult_count_def integer;
  declare variable child_count_def integer;
  declare variable id_room_def integer;
  declare variable custom_price_def numeric(15,4);
  declare variable custom_currency_def char(3);
  declare variable voucher_num_def varchar(30);
  declare variable voucher_date_def date;
  declare variable voucher_text_def varchar(30);
  declare variable voucher2_num_def varchar(30);
  declare variable voucher2_date_def date;
  declare variable transfer_in_time_def timestamp;
  declare variable transfer_in_note_def varchar(30);
  declare variable transfer_out_time_def timestamp;
  declare variable transfer_out_note_def varchar(30);
  declare variable is_late_departure_def integer;
  declare variable country_code_def varchar(20);
  declare variable check_status_def integer;
  declare variable id_acc_template_person_def integer;
  declare variable arranger_marketing1_id integer;
  declare variable arranger_rate_id integer;
  declare variable arranger_maintance_shema_id integer;
  declare variable deposit_def numeric(15,4);
  declare variable deposit_currency_def char(3);
  declare variable group_name_old varchar(50);
  declare variable group_uuid_old varchar(40);
begin
  if (:booking_dbkey is null) then begin
    execute procedure RES_CREATE_GET$RSV (:hotel_id)
    returning_values
      :arrival_date_def,
      :departure_date_def,
      :arranger_profile_id,
      :main_guest_profile_id,
      :adult_count_def,
      :child_count_def,
      :room_type_id,
      :id_room_def,
      :board_id,
      :rate_id,
      :custom_price_def,
      :custom_currency_def,
      :voucher_num_def,
      :voucher_date_def,
      :voucher_text_def,
      :voucher2_num_def,
      :voucher2_date_def,
      :transfer_in_time_def,
      :transfer_in_note_def,
      :transfer_out_time_def,
      :transfer_out_note_def,
      :is_late_departure_def,
      :first_food_code,
      :country_code_def,
      :marketing1_id,
      :marketing2_id,
      :marketing3_id,
      :marketing4_id,
      :marketing5_id,
      :arranger_account_id,
      :posting_routing,
      :guest_payment_type_id,
      :arranger_payment_type_id,
      :check_status_def,
      :maintance_shema_id,
      :deposit_def,
      :deposit_currency_def,
      :id_acc_template_person_def,
      :guarantee_policy_id,
      :eating_object_id,
      :DEFAULT_GUEST_MASK;
  end else begin
    select RD.id_rate, rd.id_room_type, rd.id_board, rd.id_hk_plan,
      rd.id_agent_payment, rd.id_person_payment, rd.id_nom_market_segment,
      rd.id_nom_source_code, rd.id_nom_channel_code, rd.id_nom_hear_reason,
      rd.id_nom_come_reason, rd.id_agent_profile, rd.id_person_profile,
      rd.acc_routing, rd.id_agent_account_rule, rd.code_first_food,
      rd.id_guarantee_policy, rg.group_name, rg.uuid, (rd.leaving_kind - 1) as is_late_departure
    from   RESERV_DETAIL RD
    left outer join reserv_group rg on rg.id_reserv_group=rd.id_group
    where  RD.RDB$DB_KEY = :booking_dbkey
    into  :rate_id, :room_type_id, :board_id, :maintance_shema_id,
      :arranger_payment_type_id, :guest_payment_type_id, :marketing1_id,
      :marketing2_id, :marketing3_id, :marketing4_id,
      :marketing5_id, :arranger_profile_id, :main_guest_profile_id,
      :posting_routing, :arranger_account_id, :first_food_code,
      :guarantee_policy_id, :group_name_old, :group_uuid_old, :is_late_departure_def;
  end

  /* MERGE ARRANGER PROFILE VALUE  */
  arranger_profile_id = coalesce(:arranger_profile_id_in, :arranger_profile_id);
  posting_routing = coalesce(:posting_routing_in, :posting_routing);

  /* APPLY ARRANGER DEFAULTS TO NEW BOOKINGS */
  if ((:booking_dbkey is null) and (:arranger_profile_id is not null)) then begin
    select p.id_nom_market_segment,
           (select min(id_tariff)
            from profile_hotel_rate aa
            where aa.id_hotel=:hotel_id and aa.id_profile = p.ID_PROFILE
            group by aa.id_profile
            having count(aa.id_profile)=1) as rate_id,
           pbd.ID_HK_PLAN
    from   profile p
    left outer join PROFILE_BOOKING_DEFAULTS pbd on pbd.ID_PROFILE = p.id_profile and pbd.ID_HOTEL = :hotel_id
    where p.id_profile=:arranger_profile_id
    into :arranger_marketing1_id, :arranger_rate_id, :arranger_maintance_shema_id;
    
    marketing1_id = coalesce(:arranger_marketing1_id, :marketing1_id);
    rate_id = coalesce(:arranger_rate_id, :rate_id);
    maintance_shema_id = coalesce(:arranger_maintance_shema_id, :maintance_shema_id);

    if (upper(:posting_routing) in ('AGENT', 'MIXED')) then begin
      select first 1 a.id_account
      from account a
      where
        a.id_profile = :arranger_profile_id
        and a.id_hotel=:hotel_id
        and a.is_credit_account=1
        and a.is_default=1
      into :arranger_account_id;
    end
  end

  /* MERGE THE REST OF THE *_IN VALUES */
  rate_id = coalesce(:rate_id_in, :rate_id);
  room_type_id = coalesce(:room_type_id_in, :room_type_id);
  board_id = coalesce(:board_id_in, :board_id);
  maintance_shema_id = coalesce(:maintance_shema_id_in, :maintance_shema_id);
  arranger_payment_type_id = coalesce(:arranger_payment_type_id_in, :arranger_payment_type_id);
  guest_payment_type_id = coalesce(:guest_payment_type_id_in, :guest_payment_type_id);
  marketing1_id = coalesce(:marketing1_id_in, :marketing1_id);
  marketing2_id = coalesce(:marketing2_id_in, :marketing2_id);
  marketing3_id = coalesce(:marketing3_id_in, :marketing3_id);
  marketing4_id = coalesce(:marketing4_id_in, :marketing4_id);
  marketing5_id = coalesce(:marketing5_id_in, :marketing5_id);
  main_guest_profile_id = coalesce(:main_guest_profile_id_in, :main_guest_profile_id);
  first_food_code = coalesce(:first_food_code_in, :first_food_code);
  guarantee_policy_id = coalesce(:guarantee_policy_id_in, :guarantee_policy_id);
  group_name = coalesce(:group_name, :group_name_old);
  group_uuid = coalesce(:group_uuid, :group_uuid_old);
  is_late_departure = coalesce(:is_late_departure_in, :is_late_departure_def);
  eating_object_id = coalesce(:eating_object_id_in, :eating_object_id);

  execute procedure sys_dbg('exc DEFAULT_BOOKING_VALUES$EXC => IMPORT_GROUP$EXC');
  execute procedure IMPORT_GROUP$EXC(:hotel_id, :group_uuid, :group_name)
  returning_values :reserv_group_id;
end
^

/* Alter (EAI_EVENTQ_PUSHBACK) */
ALTER PROCEDURE EAI_EVENTQ_PUSHBACK(EAI_IFC VARCHAR(50),
ID_EVENT INTEGER)
 AS
begin
  /*
  id_first_pushedback = null;
  select M.RDB$DB_KEY, M.ID_FIRST_PUSHEDBACK
  from   EAI_EVENTQ_MARK M
  where  M.EAI_IFC = :eai_ifc
  into   :m_dbkey, :id_first_pushedback;

  if ((:id_first_pushedback is null) or (:id_first_pushedback > :id_event)) then begin
    update EAI_EVENTQ_MARK M
    set    M.ID_FIRST_PUSHEDBACK = :id_event
    where  M.RDB$DB_KEY = :m_dbkey;
  end
  */
  update EAI_EVENTQ_MARK M
  set    M.ID_FIRST_PUSHEDBACK = :id_event
  where  M.EAI_IFC = :eai_ifc
         and ((m.ID_FIRST_PUSHEDBACK is null) or (m.ID_FIRST_PUSHEDBACK > :ID_EVENT));

  update EAI_EVENTQ_STATUS EP
  set    EP.STATUS = -1
  where  EP.ID_EVENT = :id_event
         and EP.EAI_IFC = :eai_ifc;
end
^

/* Alter (EAI_POS_CHECK_CARD$P2E) */
ALTER PROCEDURE EAI_POS_CHECK_CARD$P2E(IN_CARD_NUMBER VARCHAR(50),
ID_HOTEL INTEGER)
 RETURNS(ID_GUEST INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100),
GUEST_NAME VARCHAR(100),
ROOM_NAME VARCHAR(20),
BOARD_NAME VARCHAR(30))
 AS
declare variable id_guest_check integer;
  declare variable check_status integer;
  declare variable to_date date;
  declare variable check_date date;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  if (coalesce(:IN_CARD_NUMBER, '') = '') then begin
     ERR_CODE = -401;
     ERR_TEXT = '';
     suspend;
     exit ;
  end

  select max(GD.ID_GUEST), min(GD.ID_GUEST)
  from   GUEST_DATA GD
         join GUEST G on G.ID_GUEST = GD.ID_GUEST
         join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
  where  GD.GUEST_CODE = :IN_CARD_NUMBER
         and RD.ID_HOTEL = :ID_HOTEL
         and rd.IS_ANUL = 0
  into   :ID_GUEST, :ID_GUEST_CHECK;

  if (:ID_GUEST is null) then begin
     ERR_CODE = -402;
     ERR_TEXT = '';
     suspend;
     exit;
  end

  if (:ID_GUEST <> :ID_GUEST_CHECK) then begin
     ERR_CODE = -403;
     ERR_TEXT = '';
     suspend;
     exit;
  end
  /*FIND SYSTEM DATE - check to today, not to system date - for security*/

  select  TO_DATE, G.CHECK_STATUS
  from    GUEST G
  where   ID_GUEST = :ID_GUEST
  into    :TO_DATE, :CHECK_STATUS;

  if ((:TO_DATE < current_date) or (:CHECK_STATUS = 1)) then  begin
     ERR_CODE = -404;
     ERR_TEXT = '';
     suspend;
     exit;
  end

  check_date = iif(current_date = :to_date, current_date - 1, current_date);

  select GC.GUEST_NAME1, R.ROOM_NAME,
         (select m.NAME
          from   GUEST_STAY gs
                 join MEALS M on m.ID_BOARD = gs.ID_BOARD
          where  gs.ID_GUEST = g.ID_GUEST
                 and gs.FOR_DATE = :check_date)
  from   GUEST_CARD GC
         join GUEST G on G.ID_GUEST = GC.ID_GUEST
         join ROOMS R on G.ID_ROOM = R.ID_ROOM
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME, :ROOM_NAME, :BOARD_NAME;

  suspend;
end
^

/* Alter (EAI_POS_GET_GUESTS$P2E) */
ALTER PROCEDURE EAI_POS_GET_GUESTS$P2E(IN_ROOM_NAME VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(OUT_ID_GUEST INTEGER,
OUT_GUEST_NAME VARCHAR(100),
OUT_FROM_DATE DATE,
OUT_TO_DATE DATE,
OUT_OK_FOR_POST INTEGER,
OUT_COUNTRY VARCHAR(30),
OUT_TEXT VARCHAR(100),
OUT_BOARD_NAME VARCHAR(30),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100))
 AS
declare variable id_room integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  OUT_GUEST_NAME = null;

  /*FIND ROOM*/
  select R.ID_ROOM
  from   ROOMS R
         join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
  where  R.ROOM_NAME = :IN_ROOM_NAME
         and RT.ID_HOTEL = :ID_HOTEL
  into   :ID_ROOM;
  if ((:ID_ROOM is null) or (:ID_ROOM <= 0) ) then begin
    ERR_CODE = -5;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Room number not found!    ! ';
    suspend;
    exit;
  end

  /*FIND GUESTS*/
  for
    select G.ID_GUEST, GC.GUEST_NAME1, G.FROM_DATE, G.TO_DATE, C.COUNTRY_NAME,
           (select m.NAME
            from   GUEST_STAY gs
                   join MEALS M on m.ID_BOARD = gs.ID_BOARD
            where  gs.ID_GUEST = g.ID_GUEST
                   and gs.FOR_DATE = iif(current_date = g.to_date, current_date - 1, current_date))
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
           left outer join GUEST_CARD GC on G.ID_GUEST = GC.ID_GUEST
           left outer join COUNTRY C on C.COUNTRY_CODE = GC.COUNTRY
    where  G.ID_ROOM = :ID_ROOM
           and G.CHECK_STATUS = 0
           and rd.IS_ANUL = 0
    into   :OUT_ID_GUEST, :OUT_GUEST_NAME, :OUT_FROM_DATE,  :OUT_TO_DATE, :OUT_COUNTRY, :OUT_BOARD_NAME
  do begin
    OUT_OK_FOR_POST = iif(:OUT_TO_DATE < current_date, 0, 1) ;
    suspend;
  end

  if (:OUT_GUEST_NAME is null) then begin
    ERR_CODE = -1;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Guests not found!     !';
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: EXPORT_BOOKING$RSV for: EXPORT_BOOKING$EXC */
ALTER PROCEDURE EXPORT_BOOKING$RSV(DATA_RANGE VARCHAR(50))
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20),
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_NAME VARCHAR(100),
POSTING_ROUTING VARCHAR(20),
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EXPORT_BOOKING$EXC) */
ALTER PROCEDURE EXPORT_BOOKING$EXC(BOOKING_ID INTEGER)
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20,
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_ID INTEGER,
IS_GUEST_ARRANGER INTEGER,
POSTING_ROUTING VARCHAR(20),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IS_DIFFERENT_TARIFF SMALLINT,
IS_DIFFERENT_BOARD SMALLINT,
IS_CUSTOM_PRICE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
EXC_LOCAL_VERSION BIGINT,
EXC_REMOTE_VERSION BIGINT,
CREATE_DATETIME TIMESTAMP,
EATING_OBJECT VARCHAR(50),
CHECK_OUT_KIND SMALLINT,
EARLYCHECKOUT_DATE DATE)
 AS
declare variable arrival_type_code smallint;
BEGIN
  number = null;
  select h.hotel_name, b.number, bei.confirmation_number, bei.cancelation_number,
        bs.status, rg.id_reserv_group, rg.group_name, rg.uuid, b.is_vip, b.arrival_date, b.comming_kind,
        b.departure_date, b.is_late_departure, b.transfer_in_time, b.transfer_in_note,
        b.transfer_out_time, b.transfer_out_note, rt.type_room, board.name,
        b.room_features, b.i_special_treatment, hk.plan_name, r.tarifa_name, b.custom_price, b.custom_currency,
        b.deposit_required, b.deposit_required_currency, apt.payment_type, ppt.payment_type,
        b.voucher_num, b.voucher_date, b.voucher_text, ms.segment_name, sc.description,
        cc.description, hr.description, cr.description, b.note, b.note_reminders,
        b.code_first_food, ap.id_profile, isperson.id_profile as is_guest_arranger,
        b.acc_routing, b.is_different_room_type, b.is_different_stay_type, b.is_different_tariff,
        b.is_different_board, b.is_custom_price, b.is_different_price, bei.split_on_checkin,
        gp.name, b.block_cc, bei.guarantee_deposit_percent, bei.guarantee_deposit_nights,
        bei.guarantee_due_days_bef_arrival, bei.guarantee_due_days_after_create, bx.minibar_rights,
        bx.paytv_rights, bx.video_rights, bx.nopost_pms, bx.phone_rights, bx.seminar_cahnnel_rights,
        bei.posting_transaction_uuid, bei.exc_local_version, bei.exc_remote_version, bei.create_datetime,
        eo.name, bei.check_out_kind, bei.earlycheckout_date
  from  RES_LOAD(:booking_id) b
        join reserv_detail bei on bei.id_reserv_detail = :booking_id
        join HOTEL h on h.id_hotel = b.id_hotel
        join export_booking_status$exc(b.check_status, b.annul_status) bs on 1=1
        left outer join RESERV_GROUP RG on RG.ID_RESERV_GROUP = b.ID_GROUP
        join room_types rt on rt.id_room_type = b.id_res_room_type
        left outer join hk_plan hk on hk.id_plan = b.id_hk_plan
        join tarifa r on r.id_tarifa = b.id_tariff
        left outer join payment_type apt on apt.id_payment_type = b.id_agent_payment
        left outer join payment_type ppt on ppt.id_payment_type = b.id_person_payment
        left outer join nom_market_segments ms on ms.id_nom_market_segment = b.id_nom_market_segment
        left outer join nom_source_codes sc on sc.id_nom_source_code = b.id_nom_source_code
        left outer join nom_channel_codes cc on cc.id_nom_channel_code = b.id_nom_channel_code
        left outer join nom_hear_reasons hr on hr.id_nom_hear_reason = b.id_nom_hear_reason
        left outer join nom_come_reasons cr on cr.id_nom_come_reason = b.id_nom_come_reason
        left outer join profile ap on ap.id_profile = b.id_agent_profile
        left outer join profile_person isperson on isperson.id_profile = b.id_agent_profile
        left outer join meals board on board.ID_BOARD = bei.ID_BOARD
        left outer join guarantee_policy gp on gp.id_guarantee_policy=b.id_guarantee_policy
        left outer join reserv_detail_external bx on bx.id_reserv_detail = :booking_id
        left outer join eating_object eo on eo.id_eating_object = b.id_eating_object
  into  :hotel,
        :number,
        :confirmation_number,
        :cancelation_number,
        :status,
        :group_id,
        :group_name,
        :group_uuid,
        :is_vip,
        :arrival,
        :arrival_type_code,
        :departure,
        :is_late_departure,
        :transfer_in_time,
        :transfer_in_note,
        :transfer_out_time,
        :transfer_out_note,
        :room_type,
        :board,
        :room_preferences,
        :special_treatment,
        :maintance_shema,
        :rate,
        :manual_price,
        :manual_price_currency,
        :deposit_required,
        :deposit_required_currency,
        :arranger_payment_type,
        :guest_payment_type,
        :voucher,
        :voucher_date,
        :voucher_text,
        :marketing_segment,
        :marketing_source_code,
        :marketing_channel_code,
        :marketing_hear_reason,
        :marketing_come_reason,
        :note,
        :note_reminders,
        :first_food,
        :arranger_profile_id,
        :is_guest_arranger,
        :posting_routing,
        :is_different_room_type,
        :is_different_stay_type,
        :is_different_tariff,
        :is_different_board,
        :is_custom_price,
        :is_different_price,
        :split_on_checkin,
        :guarantee_policy,
        :block_cc,
        :guarantee_deposit_percent,
        :guarantee_deposit_nights,
        :guarantee_due_days_bef_arrival,
        :guarantee_due_days_after_create,
        :minibar_rights,
        :paytv_rights,
        :video_rights,
        :nopost_pms,
        :phone_rights,
        :seminar_cahnnel_rights,
        :posting_transaction_uuid,
        :exc_local_version,
        :exc_remote_version,
        :create_datetime,
        :eating_object,
        :check_out_kind,
        :earlycheckout_date;

  if (:number is not null) then begin -- Check if we have export
    arrival_type = null;
    if (0 = :arrival_type_code) then begin
      arrival_type = 'early';
    end else if (2 = :arrival_type_code) then begin
      arrival_type = 'late';
    end
    suspend;
  end
END
^

/* Alter (EXPORT_BOOKING$RSV) */
ALTER PROCEDURE EXPORT_BOOKING$RSV(DATA_RANGE VARCHAR(50))
 RETURNS(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20,
STATUS VARCHAR(50),
GROUP_ID INTEGER,
GROUP_NAME VARCHAR(50),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES BLOB,
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_NAME VARCHAR(100),
POSTING_ROUTING VARCHAR(20),
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER)
 AS
BEGIN
  for select EB.HOTEL,
             EB.NUMBER, 
             EB.CONFIRMATION_NUMBER, 
             EB.CANCELATION_NUMBER,
             EB.STATUS, 
             EB.GROUP_ID, 
             EB.GROUP_NAME, 
             EB.IS_VIP,
             EB.ARRIVAL, 
             EB.ARRIVAL_TYPE, 
             EB.DEPARTURE, 
             EB.IS_LATE_DEPARTURE, 
             EB.TRANSFER_IN_TIME, 
             EB.TRANSFER_IN_NOTE, 
             EB.TRANSFER_OUT_TIME, 
             EB.TRANSFER_OUT_NOTE, 
             EB.ROOM_TYPE, 
             EB.BOARD, 
             EB.ROOM_PREFERENCES,
             EB.SPECIAL_TREATMENT, 
             EB.MAINTANCE_SHEMA, 
             EB.RATE, 
             EB.MANUAL_PRICE, 
             EB.MANUAL_PRICE_CURRENCY, 
             EB.DEPOSIT_REQUIRED, 
             EB.DEPOSIT_REQUIRED_CURRENCY, 
             EB.ARRANGER_PAYMENT_TYPE, 
             EB.GUEST_PAYMENT_TYPE, 
             EB.VOUCHER, 
             EB.VOUCHER_DATE, 
             EB.VOUCHER_TEXT, 
             EB.MARKETING_SEGMENT, 
             EB.MARKETING_SOURCE_CODE, 
             EB.MARKETING_CHANNEL_CODE, 
             EB.MARKETING_HEAR_REASON, 
             EB.MARKETING_COME_REASON, 
             EB.NOTE, 
             EB.NOTE_REMINDERS, 
             EB.FIRST_FOOD, 
             P.PROFILE_NAME,
             EB.POSTING_ROUTING, 
             EB.SPLIT_ON_CHECKIN, 
             EB.GUARANTEE_POLICY, 
             EB.GUARANTEE_DEPOSIT_PERCENT, 
             EB.GUARANTEE_DEPOSIT_NIGHTS, 
             EB.GUARANTEE_DUE_DAYS_BEF_ARRIVAL, 
             EB.GUARANTEE_DUE_DAYS_AFTER_CREATE
  from TMP_IDS ids
       left outer join EXPORT_BOOKING$EXC(ids.ID) EB on 1=1
       left outer join PROFILE P on P.ID_PROFILE = EB.ARRANGER_PROFILE_ID
  where ids.CONTEXT = :data_range
  into :hotel,
       :number, 
       :confirmation_number, 
       :cancelation_number,
       :status,
       :group_id, 
       :group_name, 
       :is_vip,
       :arrival, 
       :arrival_type, 
       :departure, 
       :is_late_departure, 
       :transfer_in_time, 
       :transfer_in_note, 
       :transfer_out_time, 
       :transfer_out_note, 
       :room_type, 
       :board, 
       :room_preferences,
       :special_treatment, 
       :maintance_shema, 
       :rate, 
       :manual_price, 
       :manual_price_currency, 
       :deposit_required, 
       :deposit_required_currency, 
       :arranger_payment_type, 
       :guest_payment_type, 
       :voucher, 
       :voucher_date, 
       :voucher_text, 
       :marketing_segment, 
       :marketing_source_code, 
       :marketing_channel_code, 
       :marketing_hear_reason, 
       :marketing_come_reason, 
       :note, 
       :note_reminders, 
       :first_food, 
       :arranger_profile_name,
       :posting_routing, 
       :split_on_checkin, 
       :guarantee_policy, 
       :guarantee_deposit_percent, 
       :guarantee_deposit_nights, 
       :guarantee_due_days_bef_arrival, 
       :guarantee_due_days_after_create
  do suspend;
END
^

/* Alter (EXPORT_OCCUPANCY_TO_WBE$EXC) */
ALTER PROCEDURE EXPORT_OCCUPANCY_TO_WBE$EXC(ID_HOTEL INTEGER,
RES_PREFIX_EXCLUDE VARCHAR(10) = 'WBE')
 RETURNS(ID_ROOM_TYPE INTEGER,
TYPE_ROOM VARCHAR(20),
HOTEL_NAME VARCHAR(50),
FROM_DATE DATE,
TO_DATE DATE,
CNT_ROOMS INTEGER)
 AS
declare variable id_helper_session integer;
declare variable starting_date date;
declare variable for_date date;
declare variable max_date date;
declare variable t_id_room_type integer;
declare variable t_occupied integer;
declare variable t_cnt_rooms integer;
begin

  /* Get all reservations that a NOT WBE reservations and export occupancy in allotment format */
  /* !!! Export only PRESENT and FUTURE (date >= today) */
  /* !! Returns OCCUPEIED rooms, not Avalable*/
  starting_date = 'now';
  starting_date = starting_date - 1; /* include today */
  max_date = starting_date;
  select h.hotel_name from hotel h where h.id_hotel = :id_hotel into :hotel_name;

  id_helper_session = gen_id(SELECTION_GEN, 1);

  /*put reservations in tmp table*/
  for
    select RM.BUSY_DATE, RM.ID_ROOM_TYPE, count(distinct RM.ID_ROOM)
    from   ROOM_MAGIC RM
           join ROOM_TYPES rt on Rt.id_room_type = rm.id_room_type
           join RESERV_DETAIL rd on rm.id_reserv_detail = rd.id_reserv_detail
           /*left outer join ROOM_PERIOD$PMS RP on RP.ID_ROOM = rm.ID_ROOM
                                        and RM.BUSY_DATE between RP.FROM_DATE and RP.TO_DATE
                                        and RP.IS_AVAILABLE = 1*/
    where  RM.BUSY_DATE >= :starting_date
           and rt.ID_HOTEL = :ID_HOTEL
           and RM.DAY_ACTION not containing 'CHECK_OUT'
           and RM.BUSY_TYPE is distinct from 'VALUE_RESERVS' /* skip waiting bookings */
           and RM.busy_group_type <> 18                      /* skip OOO              */
           and RM.busy_group_type <> 20                      /* skip OOI              */
           and RD.number_1 is distinct from :res_prefix_exclude
           --and ((RM.ID_ROOM < 0) or (rp.IS_AVAILABLE is not distinct from 1))
           and rm.ROOM_STATUS is distinct from 'PRIVATE' -- replace previous clause
    group by 1,2
    into   :for_date, :t_id_room_type, :t_occupied
  do begin
    insert into TMP_SMALL_OCCUP (id_session, for_date, id_room_type,  occupied)
    values (:id_helper_session, :for_date, :t_id_room_type,  :t_occupied );
    if (:for_date > :max_date) then max_date = for_date;
  end
  /**/

  /*loop room types in tmp table, join missing dates, then compress result in periods (allotment format)*/
  for
    select tso.id_room_type, max(rt.type_room)
    from   TMP_SMALL_OCCUP tso
           join ROOM_TYPES rt on tso.id_room_type = rt.id_room_type
    where  tso.id_session = :id_helper_session
    group by 1
    into   :id_room_type, :type_room
  do begin
    FROM_DATE = starting_date;
    TO_DATE = null;
    CNT_ROOMS = null;
    for
      select p.OUT_DATE, coalesce( tso.occupied, 0)
      from   SYSTEM_LOOP_PERIOD ( :starting_date, :max_date )  P
             left outer join TMP_SMALL_OCCUP tso on tso.id_session = :id_helper_session
                                                and tso.for_date = p.OUT_DATE
                                                and tso.id_room_type = :id_room_type
      into :for_date, :t_cnt_rooms
    do begin
      if (:CNT_ROOMS is null) then CNT_ROOMS = :t_cnt_rooms;
      if (:CNT_ROOMS is distinct from :t_cnt_rooms) then begin
        suspend;
        CNT_ROOMS = :t_cnt_rooms;
        FROM_DATE = :for_date;
      end
      TO_DATE = :for_date;
    end
    if (:TO_DATE is not null) then suspend;
  end

  /**/
  delete from TMP_SMALL_OCCUP tso where tso.id_session = :id_helper_session;
  /**/


end
^

ALTER PROCEDURE EXT_PRATE_MAP_MODIFY(ID_PRATE_MAP INTEGER,
ID_HOTEL INTEGER,
ID_OBJECT VARCHAR(20),
OBJECT_TYPE VARCHAR(100),
EXTERNAL_CODE VARCHAR(10),
EXTERNAL_DESCRIPTION VARCHAR(100),
IS_EXPORT SMALLINT,
OPERATION VARCHAR(5))
 RETURNS(NEW_ID_PRATE_MAP INTEGER)
 AS
begin
  NEW_ID_PRATE_MAP = ID_PRATE_MAP;
  if (OPERATION = 'add') then begin
    NEW_ID_PRATE_MAP = gen_id(GEN_ID_PRATE_MAP, 1);
    insert into EXT_PRATE_MAP
      (ID_PRATE_MAP, ID_HOTEL, ID_OBJECT, OBJECT_TYPE, EXTERNAL_CODE, EXTERNAL_DESCRIPTION, IS_EXPORT)
    values
      (:NEW_ID_PRATE_MAP, :ID_HOTEL, :ID_OBJECT, :OBJECT_TYPE, :EXTERNAL_CODE, :EXTERNAL_DESCRIPTION, :IS_EXPORT);
  end else if (OPERATION = 'mod') then begin
    update EXT_PRATE_MAP pm
    set pm.ID_HOTEL = :ID_HOTEL,
        pm.ID_OBJECT = :ID_OBJECT,
        pm.OBJECT_TYPE = :OBJECT_TYPE,
        pm.EXTERNAL_CODE = :EXTERNAL_CODE,
        pm.EXTERNAL_DESCRIPTION = :EXTERNAL_DESCRIPTION,
        pm.IS_EXPORT = :IS_EXPORT
    where pm.ID_PRATE_MAP = :ID_PRATE_MAP;
  end else if (OPERATION = 'del') then begin
    delete from EXT_PRATE_MAP pm
      where pm.ID_PRATE_MAP = :ID_PRATE_MAP;
  end else if (OPERATION = 'clear') then begin
    delete from EXT_PRATE_MAP pm
      where pm.ID_HOTEL = :ID_HOTEL;
  end
end
^

/* Alter (EXT_PRATE_HOTEL_MAP_MODIFY) */
ALTER PROCEDURE EXT_PRATE_HOTEL_MAP_MODIFY(ID_HOTEL INTEGER,
PRATE_ID_HOTEL VARCHAR(10),
USER_NAME VARCHAR(30),
"PASSWORD" VARCHAR(50),
IS_ACTIVE SMALLINT,
OPERATION VARCHAR(3))
 AS
declare variable ID_MAP integer;
begin
  if (OPERATION = 'set') then begin
    update or insert into EXT_PRATE_HOTEL_MAP (ID_HOTEL, PRATE_ID_HOTEL, USER_NAME, "PASSWORD", IS_ACTIVE)
    values (:ID_HOTEL, :PRATE_ID_HOTEL, :USER_NAME, :"PASSWORD", :IS_ACTIVE) matching (ID_HOTEL);
  end else if (OPERATION = 'del') then begin
    delete from EXT_PRATE_HOTEL_MAP
    where ID_HOTEL = :ID_HOTEL;
    execute procedure EXT_PRATE_MAP_MODIFY(null, :ID_HOTEL, null, null, null, null, null, 'clear')
    returning_values :ID_MAP;
  end
end
^

/* Alter (GUEST_STAY_INITIALIZE$INT) */
ALTER PROCEDURE GUEST_STAY_INITIALIZE$INT(ID_RESERV_DETAIL INTEGER)
 AS
declare variable id_board integer;
   declare variable id_room integer;
   declare variable id_guest integer;
   declare variable id_rate integer;
   declare variable system_date date;
begin
  -- used to pre-initialize guest stay conditions, before importing the differences
  -- only for CRS imports !!!
  select r.ID_BOARD, r.ID_ROOM, r.ID_RATE,
         (select sd.SYSTEM_DATE from SYSTEM_DATE_GET(r.ID_HOTEL) sd) as system_date
  from   RESERV_DETAIL R
  where  R.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :id_board, :id_room, :id_rate, :system_date;

  for
    select g.ID_GUEST
    from   GUEST G
    where  g.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :id_guest
  do begin
    update GUEST_STAY GS
    set    gs.ID_ROOM_TYPE = -1,
           gs.ID_BOARD = :id_board,
           gs.ID_TYPE_STAY = -1,
           gs.ID_ROOM = iif(gs.FOR_DATE < :system_date, gs.ID_ROOM, :id_room),
           gs.ID_TARIFF = :id_rate
    where  gs.ID_GUEST = :id_guest;
  end 
end
^

/* empty dependent procedure body */
/* Clear: CREATE_BOOKING$WBE for: IMPORT_BOOKING$EXC */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TEST_BOOKING_IMPORT for: IMPORT_BOOKING$EXC */
ALTER PROCEDURE TEST_BOOKING_IMPORT AS
 BEGIN EXIT; END
^

/* Alter (IMPORT_BOOKING$EXC) */
ALTER PROCEDURE IMPORT_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(250),
MAINTANCE_SHEMA VARCHAR(30),
POSTING_ROUTING VARCHAR(20),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
COMPLIMENTARY_ACCOUNT VARCHAR(50),
EATING_OBJECT VARCHAR(50),
CREATE_DATETIME TIMESTAMP,
CHECK_OUT_KIND SMALLINT,
EARLYCHECKOUT_DATE DATE)
 RETURNS(HOTEL_ID INTEGER,
BOOKING_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable current_hotel_id integer;
declare variable booking_update_id integer;
declare variable warn_code integer;
declare variable share_transaction_id integer;
declare variable share_err_code integer;
declare variable arranger_profile_id integer;
declare variable main_guest_profile_id integer;
declare variable rate_id integer;
declare variable room_type_id integer;
declare variable board_id integer;
declare variable maintance_shema_id integer;
declare variable arranger_payment_type_id integer;
declare variable guest_payment_type_id integer;
declare variable marketing_segment_id integer;
declare variable marketing_source_code_id integer;
declare variable marketing_channel_code_id integer;
declare variable marketing_hear_reason_id integer;
declare variable marketing_come_reason_id integer;
declare variable arranger_account_id integer;
declare variable packet_id integer;
declare variable id_guarantee_policy integer;
declare variable first_food_code tfood_code;
declare variable arrival_type_code smallint;
declare variable booking_dbkey char(8);
declare variable reserv_group_id integer;
declare variable id_complimentary_account integer;
declare variable id_eating_object integer;
declare variable default_guest_mask varchar(10);
declare variable id_person_data integer;
begin
  /*execute procedure sys_dbg('exc IMPORT_BOOKING$EXC('
  || 'hotel => ' || coalesce(:hotel, '<null>')
  || ', booking_number => ' || coalesce(:number, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  ||')');
  */
  execute procedure import_mark_transaction$exc;

  /* init */
  err_code = 0;
  err_text = '';
  booking_update_id = null;
  booking_dbkey = null;
  current_hotel_id = null;
  if (:voucher_date is not null) then begin
    voucher_date = striptime(:voucher_date);
  end
  posting_routing = upper(:posting_routing);

  /* detect inser/update mode */
  select b.id_reserv_detail, b.rdb$db_key, b.id_hotel
  from   reserv_detail b
  where  b.number=:number
         and b.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and b.id_log_event_annul is null
  into   :booking_update_id, :booking_dbkey, :current_hotel_id;

  if (:booking_update_id is null) then begin
    booking_id = gen_id (id_reserv_detail_gen, 1);
  end else begin
    booking_id = :booking_update_id;
  end

  /* text to id map */
  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => MAP_BOOKING_RELATIONS$EXC');
  execute procedure MAP_BOOKING_RELATIONS$EXC(
    :booking_id,
    :hotel,
    :room_type,
    :board,
    :maintance_shema,
    :rate,
    :arranger_payment_type,
    :guest_payment_type,
    :marketing_segment,
    :marketing_source_code,
    :marketing_channel_code,
    :marketing_hear_reason,
    :marketing_come_reason,
    :first_food,
    :arranger_profile_uuid,
    :arranger_profile_name,
    :main_guest_profile_uuid,
    :arrival_type,
    :guarantee_policy,
    :eating_object
  ) returning_values
    :arranger_profile_id,
    :main_guest_profile_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :hotel_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :first_food_code,
    :arrival_type_code,
    :id_guarantee_policy,
    :id_eating_object;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* hotel change test */
  if (coalesce(:current_hotel_id, :hotel_id) <> :hotel_id) then begin
    execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', null, :hotel, 'booking hotel changed');
  end

  id_complimentary_account = null;
  if (complimentary_account is not null) then begin
    execute procedure lookup_account$exc(:hotel_id, :complimentary_account, 'booking', :booking_id)
    returning_values :id_complimentary_account;
  end

  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => CREATE_PACK_INSTANCE$EXC');
  packet_id = null;
  /*execute procedure CREATE_PACK_INSTANCE$EXC(
    :hotel_id, :booking_id, :package
  )
  returning_values :packet_id, :err_code, :err_text;
  if (0 <> :err_code) then exit;
  */
  /* merge input and default/persistent database values */
  execute procedure DEFAULT_BOOKING_VALUES$EXC(
    :booking_dbkey, :hotel_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :group_name,
    :group_uuid,
    :is_late_departure,
    :id_eating_object
  ) returning_values
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :arranger_account_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :reserv_group_id,
    :is_late_departure,
    :id_eating_object,
    :default_guest_mask;

  if ('' = :board) then board_id = null; /* preserve "empty board" state and discard default value */

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC DEFAULTED => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* if the booking is complimentary use complimentary account */
  arranger_account_id = coalesce(:id_complimentary_account, :arranger_account_id);

  /* CREATE or UPDATE */
  if (:booking_update_id is not null) then begin
    /* UPDATE booking */
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => UPDATE_BOOKING$EXC');
    execute procedure UPDATE_BOOKING$EXC(
      :booking_id,
      :reserv_group_id,
      :is_vip,
      :arrival,
      :arrival_type_code,
      :departure,
      :is_late_departure,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :room_type_id,
      :board_id,
      :room_preferences,
      :special_treatment,
      :maintance_shema_id,
      :posting_routing,
      :arranger_account_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :deposit_required,
      :deposit_required_currency,
      :arranger_payment_type_id,
      :guest_payment_type_id,
      :voucher,
      :voucher_date,
      :voucher_text,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :note,
      :note_reminders,
      :first_food_code,
      :arranger_profile_id,
      :main_guest_profile_id,
      :is_different_rate,
      :is_different_price,
      :split_on_checkin,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object
    ) returning_values :err_code, :err_text;
    if (0 <> :err_code) then begin
      exit;
    end
  end else begin
    /* CREATE booking */
    if (:default_guest_mask is not null
        and :main_guest_profile_id is not null
        and not exists (select rd.ID_RESERV_DETAIL from reserv_detail rd where rd.ID_PERSON_PROFILE = :main_guest_profile_id)) then
    begin
      -- fill the mask with a default value if its is empty
      select p.id_person_data
      from   PROFILE_PERSON p
      where  p.ID_PROFILE = :main_guest_profile_id
      into   :id_person_data;

      update PERSON_DATA pd
      set    pd.MASK = :default_guest_mask
      where  pd.ID_PERSON_DATA = :id_person_data
             and pd.MASK is null;
    end
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => RES_CREATE_SET$EXC');
    execute procedure RES_CREATE_SET$EXC (
      :booking_id,
      :number,
      :arranger_profile_id,
      :main_guest_profile_id,
      :arrival,
      :departure,
      :adult_count,
      :children_count,
      :room_type_id,
      null,
      :board_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :voucher,
      :voucher_date,
      :voucher_text,
      null,
      null,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :arrival_type_code,
      :is_late_departure,
      :is_vip,
      :first_food_code,
      :special_treatment,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :arranger_account_id,
      :posting_routing,
      :guest_payment_type_id,
      :arranger_payment_type_id,
      null,
      :room_preferences,
      :maintance_shema_id,
      :note,
      :note_reminders,
      :deposit_required,
      :deposit_required_currency,
      :hotel_id,
      :reserv_group_id,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object,
      :create_datetime
      )
    returning_values :err_code, :err_text, :warn_code, :booking_id, :share_transaction_id, :share_err_code;
  end

  update reserv_detail rd
  set    rd.CHECK_OUT_KIND = :CHECK_OUT_KIND,
         rd.EARLYCHECKOUT_DATE = :EARLYCHECKOUT_DATE
  where  rd.ID_RESERV_DETAIL = :BOOKING_ID;

  execute procedure GUEST_STAY_INITIALIZE$INT (:booking_id);
  /* final error check */
  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;

  delete from PENDING_DEPOSIT d
  where  d.ID_RESERV_DETAIL = :BOOKING_ID;
end
^

/* empty dependent procedure body */
/* Clear: CREATE_SESSION_BOOKINGS$WBE for: IMPORT_BOOKING_FINALIZE$EXC */
ALTER PROCEDURE CREATE_SESSION_BOOKINGS$WBE(WBE_SESSION_ID BIGINT,
ARANGER_ID INTEGER,
LANG_CODE VARCHAR(3))
 RETURNS(SELECTION_ID VARCHAR(20),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (IMPORT_BOOKING_FINALIZE$EXC) */
ALTER PROCEDURE IMPORT_BOOKING_FINALIZE$EXC(BOOKING_ID INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1,
STATUS VARCHAR(50) = null,
CONFIRMATION_NUMBER NAME_20 = null,
CANCELATION_NUMBER NAME_20 = null)
 RETURNS(RECORD_TIMESTAMP TIMESTAMP,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable booking_db_key char(8);
  declare variable dummy_int integer;
  declare variable dummy_text varchar(255) ;
  declare variable res_id_room integer;
  declare variable id_room integer;
  declare variable id_room_type integer;
  declare variable system_date date;
  declare variable from_date date;
  declare variable to_date date;
  declare variable gs_dbkey char(8);
begin
  ERR_CODE=0;
  ERR_TEXT=null;
  id_room = null;
  force_res_finalize = coalesce(:force_res_finalize, 1);

  execute procedure sys_dbg('exc IMPORT_BOOKING_FINALIZE$EXC => CLEAR_ORPHAN_GUESTS$EXC');
  execute procedure CLEAR_ORPHAN_GUESTS$EXC(:booking_id);

  select b.rdb$db_key, b.ID_ROOM, b.ID_ROOM_TYPE, b.FROM_DATE, b.TO_DATE
  from   reserv_detail b
  where  b.id_reserv_detail = :booking_id
  into   :booking_db_key, :res_id_room, :id_room_type, :from_date, :to_date;

  execute procedure RES_GUEST_SAVE_DIFF$INT(:booking_db_key);

  if (:res_id_room < 0) then begin
    for
      select lp.OUT_DATE
      from   SYSTEM_LOOP_PERIOD (:from_date, :to_date-1) lp
      into   :system_date
    do begin
      select ro.ID_ROOM, ro.ID_ROOM_TYPE
      from   RES_OCCUPANCY_ROOM$INT (:BOOKING_ID, :system_date, null, :id_room_type) ro
      into   :id_room, :id_room_type;
  
      if (:id_room <> :res_id_room) then begin
        for
          select gs.RDB$DB_KEY
          from   GUEST_STAY GS
                 join GUEST G on g.ID_GUEST = gs.ID_GUEST
          where  g.ID_RESERV_DETAIL = :BOOKING_ID
                 and gs.FOR_DATE = :system_date
                 and gs.ID_ROOM <> :id_room
          into   :gs_dbkey
        do begin
          update GUEST_STAY gsu
          set    gsu.ID_ROOM = :id_room
                 --gsu.ID_ROOM_TYPE = iif (gsu.ID_ROOM_TYPE = -1, :id_room_type, gsu.ID_ROOM_TYPE)
          where  gsu.RDB$DB_KEY = :gs_dbkey;
        end
      end
    end
    update GUEST G
    set    G.ID_ROOM = coalesce(:id_room, :res_id_room)
    where  g.ID_RESERV_DETAIL = :BOOKING_ID;
  end

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null,   --force recalculation
         rd.ID_ROOM = coalesce(:id_room, :res_id_room)
         --rd.HAS_DIFFERENT_ROOM_TYPE = coalesce(:has_different_room_type,  rd.HAS_DIFFERENT_ROOM_TYPE)
  where  rd.RDB$DB_KEY = :booking_db_key;

  if (1 = :force_res_finalize) then begin
    execute procedure sys_dbg('exc IMPORT_BOOKING_FINALIZE$EXC => RES_FINALIZE_SHAREOPTION$INT');
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:booking_db_key, 0)
    returning_values  :dummy_int, :dummy_text, :dummy_int, :dummy_int;
  end

  execute procedure APPLY_BOOKING_STATUS$EXC(
    null, :booking_db_key, :status, :confirmation_number, :cancelation_number
  );

  select b.change_time
  from   reserv_detail b
  where  b.rdb$db_key =:booking_db_key
  into   :record_timestamp;
end
^

ALTER PROCEDURE ROOM_TYPE_MODIFY$CFG(ID_HOTEL INTEGER,
ID_ROOM_TYPE INTEGER,
TYPE_ROOM VARCHAR(20),
BEDS INTEGER,
EXT_CODE VARCHAR(30),
OPERATION VARCHAR(10))
 RETURNS(NEW_ID_ROOM_TYPE INTEGER,
OVERRULE_NEED SMALLINT,
OVERRULE_CONTEXT VARCHAR(255))
 AS
declare variable id_room integer;
  declare variable room_name varchar(10);
  declare variable old_beds integer;
  declare variable extra_beds integer;
  declare tmp_overrule_need integer;
  declare tmp_overrule_context varchar(255);
  declare variable old_type_room varchar(20);
  declare variable err_rooms varchar(255);
  declare variable err_beds varchar(255);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation = 'add') then begin
    new_id_room_type = gen_id(ID_ROOM_TYPE_GEN, 1);
    insert into ROOM_TYPES (ID_ROOM_TYPE, TYPE_ROOM, BEDS, EXT_CODE, ID_HOTEL)
    values      (:new_id_room_type, :type_room, :beds, :ext_code, :id_hotel);

    execute procedure BASE_SERVICES_GEN$INT(:ID_HOTEL);

  end else if (:operation = 'mod') then begin
    update ROOM_TYPES
    set    TYPE_ROOM = :type_room,
           BEDS = :beds,
           EXT_CODE = :ext_code
    where  ID_ROOM_TYPE = :id_room_type
    returning old.beds, old.type_room, new.id_room_type
    into   :old_beds, :old_type_room, :NEW_ID_ROOM_TYPE;

    if (:old_beds <> :beds) then begin
      err_rooms = '';
      err_beds = '';
      for
        select  r.ID_ROOM, r.ROOM_NAME, r.BEDS, r.EXTRA_BEDS
        from    ROOMS r
        where   r.ID_ROOM_TYPE = :ID_ROOM_TYPE
        into    :id_room, :room_name, :old_beds, :extra_beds
      do begin
        execute procedure ROOM_CAPACITY_CHECK$INT(:id_room, :room_name, :old_beds + :extra_beds, :BEDS + :extra_beds)
        returning_values (:tmp_overrule_need, :tmp_overrule_context);
        if (:tmp_overrule_need <> 0) then begin
          if (:OVERRULE_NEED = 0) then OVERRULE_NEED = :tmp_overrule_need;
          err_rooms = substring(:err_rooms||','||substring(:tmp_overrule_context from (position(f_character(29), :tmp_overrule_context)+1) for (position(f_character(28), :tmp_overrule_context)-1)) from 1 for 255);
          err_beds = substring(:err_beds||','||substring(:tmp_overrule_context from (position(f_character(28), :tmp_overrule_context)+1)) from 1 for 255);
        end
  
        update ROOMS r
        set    r.BEDS = :BEDS
        where  r.ID_ROOM = :id_room;
      end
      if (:OVERRULE_NEED <> 0) then OVERRULE_CONTEXT = substring(f_character(29)||:err_rooms||f_character(28)||:err_beds from 1 for 255);
    end

    if (:old_type_room <> :TYPE_ROOM) then
      execute procedure BASE_SERVICES_GEN$INT(:ID_HOTEL);

  end else if (:operation = 'del') then begin
    delete from ROOM_TYPES
    where  ID_ROOM_TYPE = :id_room_type;
    NEW_ID_ROOM_TYPE = null;
  end
end
^

/* Alter (IMPORT_ROOM_TYPE$EXC) */
ALTER PROCEDURE IMPORT_ROOM_TYPE$EXC(TYPE_ROOM VARCHAR(20),
BEDS INTEGER,
EXT_CODE VARCHAR(30),
UUID VARCHAR(40),
HOTEL_NAME VARCHAR(50))
 RETURNS(ID_ROOM_TYPE INTEGER)
 AS
declare variable id_hotel integer;
declare variable operation varchar(3);
declare variable overrule_need integer;
declare variable overrule_context varchar(255) ;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'ROOM_TYPE', :TYPE_ROOM)
  returning_values :ID_HOTEL;
  execute procedure CHECK_LOOKUP_ERRORS$EXC(:TYPE_ROOM, 'ROOM_TYPE');

  ID_ROOM_TYPE = null;
  select rt.ID_ROOM_TYPE
  from   ROOM_TYPES rt
  where  rt.UUID = :UUID and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :ID_ROOM_TYPE;

  if (:ID_ROOM_TYPE is null) then begin
    OPERATION = 'add';
  end else begin
    OPERATION = 'mod';
  end

  execute procedure ROOM_TYPE_MODIFY$CFG(:ID_HOTEL, :ID_ROOM_TYPE, :TYPE_ROOM, :BEDS, :EXT_CODE, :OPERATION)
  returning_values :ID_ROOM_TYPE, :overrule_need, :overrule_context;
  if (:overrule_need <> 0) then exception ASSERT :overrule_need || f_character(31) || coalesce(:overrule_context, '');

  update ROOM_TYPES rt
  set    rt.UUID = :UUID
  where  rt.ID_ROOM_TYPE = :ID_ROOM_TYPE;
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_RATE$EXC for: LOOKUP_BOARD$EXC */
ALTER PROCEDURE IMPORT_RATE$EXC(TARIFA_NAME VARCHAR(50),
TARIFA_GROUP VARCHAR(30),
HOTEL_NAME VARCHAR(50),
TARIFA_CURR VARCHAR(3),
IS_ACTIVE SMALLINT,
TARIFA_NOTE VARCHAR(500),
PERIOD_DEPEND_ON_CHECKIN SMALLINT,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BOARD_TYPE VARCHAR(10),
SOURCE_BASE_BOARDS_LIST VARCHAR(255),
TMP_DATA BLOB SUB_TYPE 1,
LOCK_KEY VARCHAR(100),
LOCK_STAMP TIMESTAMP,
UUID VARCHAR(40),
RATE_TYPE VARCHAR(20),
IS_SIMPLE SMALLINT,
CHILD_AGE_INCL INTEGER,
IS_PUBLIC /* TYPE OF TLOGICAL */ SMALLINT,
EXPLICIT_TAX_POLICY_NAME /* TDESCRIPTION_SHORT */ VARCHAR(100) = null,
EXPLICIT_POLICY_NIGHTS_REQUIRED /* TCOUNT */ INTEGER = null)
 RETURNS(ID_TARIFA INTEGER,
ID_TARIFA_GROUP INTEGER,
ID_HOTEL INTEGER,
ID_TAR_SIMPLE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_RATE_SIMPLE_BOARD$EXC for: LOOKUP_BOARD$EXC */
ALTER PROCEDURE IMPORT_RATE_SIMPLE_BOARD$EXC(ID_HOTEL INTEGER,
ID_TAR_SIMPLE_SEASON INTEGER,
RATE_NAME VARCHAR(30),
BOARD_NAME VARCHAR(30),
ADULT_PRICE NUMERIC(15,4),
CHILD_PRICE NUMERIC(15,4))
 RETURNS(ID_TAR_SIMPLE_BOARDS INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_RATE_SIMPLE_PRICE$EXC for: LOOKUP_BOARD$EXC */
ALTER PROCEDURE IMPORT_RATE_SIMPLE_PRICE$EXC(ID_TAR_SIMPLE_SEASON INTEGER,
RATE_NAME VARCHAR(30),
HOTEL_NAME VARCHAR(50),
ROOM_TYPE VARCHAR(20),
BOARD_NAME VARCHAR(30),
SINGLE_PRICE NUMERIC(15,4),
DOUBLE_PRICE NUMERIC(15,4),
GUEST3_PRICE NUMERIC(15,4),
GUEST4PLUS_PRICE NUMERIC(15,4),
CHILD1_W_ADULT1_PRICE NUMERIC(15,4),
CHILD1_W_ADULT2PLUS_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT1_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT2PLUS_PRICE NUMERIC(15,4),
IS_BASE_DAYS_PRICE SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: MAP_BOOKING_RELATIONS$EXC for: LOOKUP_BOARD$EXC */
ALTER PROCEDURE MAP_BOOKING_RELATIONS$EXC(BOOKING_ID INTEGER,
HOTEL VARCHAR(50),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
MARKETING1 VARCHAR(30),
MARKETING2 VARCHAR(30),
MARKETING3 VARCHAR(30),
MARKETING4 VARCHAR(30),
MARKETING5 VARCHAR(30),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
ARRIVAL_TYPE VARCHAR(20),
GUARANTEE_POLICY VARCHAR(50),
EATING_OBJECT VARCHAR(50))
 RETURNS(ARRANGER_PROFILE_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
RATE_ID INTEGER,
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
HOTEL_ID INTEGER,
MAINTANCE_SHEMA_ID INTEGER,
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
FIRST_FOOD_CODE /* TFOOD_CODE */ VARCHAR(20),
ARRIVAL_TYPE_CODE SMALLINT,
GUARANTEE_POLICY_ID INTEGER,
EATING_OBJECT_ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (LOOKUP_BOARD$EXC) */
ALTER PROCEDURE LOOKUP_BOARD$EXC(HOTEL_ID INTEGER,
OBJECT_ID VARCHAR(50),
OBJECT_TYPE VARCHAR(50),
NAME VARCHAR(30),
ONLY_BOARDS SMALLINT)
 RETURNS(ID INTEGER)
 AS
begin
  ID = null;
  select first 1 m.ID_SERVICE
  from   MEALS m
  where  m.ID_HOTEL = :HOTEL_ID
         and m.NAME = :NAME
         and ((:ONLY_BOARDS is distinct from 1) or (m.IS_BOARD = 1))
  into   :ID;

  execute procedure LOG_ID_LOOKUP_ERROR$EXC(:OBJECT_ID, :OBJECT_TYPE, :ID, :NAME, 'board');
end
^

/* Alter (MAP_BOOKING_RELATIONS$EXC) */
ALTER PROCEDURE MAP_BOOKING_RELATIONS$EXC(BOOKING_ID INTEGER,
HOTEL VARCHAR(50),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
MAINTANCE_SHEMA VARCHAR(30),
RATE VARCHAR(50),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
MARKETING1 VARCHAR(30),
MARKETING2 VARCHAR(30),
MARKETING3 VARCHAR(30),
MARKETING4 VARCHAR(30),
MARKETING5 VARCHAR(30),
FIRST_FOOD VARCHAR(30),
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
ARRIVAL_TYPE VARCHAR(20),
GUARANTEE_POLICY VARCHAR(50),
EATING_OBJECT VARCHAR(50))
 RETURNS(ARRANGER_PROFILE_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
RATE_ID INTEGER,
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
HOTEL_ID INTEGER,
MAINTANCE_SHEMA_ID INTEGER,
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
FIRST_FOOD_CODE TFOOD_CODE,
ARRIVAL_TYPE_CODE SMALLINT,
GUARANTEE_POLICY_ID INTEGER,
EATING_OBJECT_ID INTEGER)
 AS
declare variable dummy char(8);
BEGIN
  execute procedure lookup_hotel$exc(:hotel, 'BOOKING', :booking_id)
  returning_values :hotel_id;

  execute procedure lookup_rate$exc(:hotel_id, :booking_id, 'BOOKING', :rate)
  returning_values :rate_id;

  execute procedure lookup_room_type$exc(:hotel_id, :booking_id, 'BOOKING', :room_type)
  returning_values :room_type_id;

  execute procedure LOOKUP_BOARD$EXC(:hotel_id, :booking_id, 'BOOKING', :board, 0)
  returning_values :board_id;

  maintance_shema_id = null;
  select first 1 ms.id_plan
  from   hk_plan ms
  where  ms.id_hotel=:hotel_id
         and ms.is_use=1
         and ms.plan_name=:maintance_shema
  into   :maintance_shema_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :maintance_shema_id, :maintance_shema, 'maintance_shema');

  arranger_payment_type_id = null;
  select first 1 pt.id_payment_type
  from   payment_type pt
  where  pt.payment_type=:arranger_payment_type
         and pt.ID_HOTEL = :HOTEL_ID
         and pt.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :arranger_payment_type_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :arranger_payment_type_id, :arranger_payment_type, 'arranger_payment_type');

  guest_payment_type_id = null;
  select first 1 pt.id_payment_type
  from   payment_type pt
  where  pt.payment_type=:guest_payment_type
         and pt.ID_HOTEL = :HOTEL_ID
         and pt.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :guest_payment_type_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :guest_payment_type_id, :guest_payment_type, 'guest_payment_type');

  execute procedure LOOKUP_MARKET_SEGMENT$EXC(:booking_id, 'BOOKING', :marketing1)
  returning_values :marketing1_id;

  marketing2_id = null;
  select first 1 m2.id_nom_source_code from nom_source_codes m2
  where m2.description = :marketing2 and m2.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :marketing2_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :marketing2_id, :marketing2, 'marketing2');

  marketing3_id = null;
  select first 1 m3.id_nom_channel_code from nom_channel_codes m3
  where m3.description = :marketing3 and m3.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :marketing3_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :marketing3_id, :marketing3, 'marketing3');

  marketing4_id = null;
  select first 1 m4.id_nom_hear_reason from nom_hear_reasons m4
  where m4.description = :marketing4 and m4.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :marketing4_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :marketing4_id, :marketing4, 'marketing4');

  marketing5_id = null;
  select first 1 m5.id_nom_come_reason from nom_come_reasons m5
  where m5.description = :marketing5 and m5.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :marketing5_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :marketing5_id, :marketing5, 'marketing5');

  execute procedure lookup_profile$exc(:arranger_profile_uuid, :arranger_profile_name)
  returning_values :dummy, :arranger_profile_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :arranger_profile_id, :arranger_profile_uuid, 'arranger_profile');

  main_guest_profile_id = null;
  select first 1 p.id_profile from profile p where p.uuid=:main_guest_profile_uuid and p.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into :main_guest_profile_id;
  execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', :main_guest_profile_id, :main_guest_profile_uuid, 'main_guest_profile');

  execute procedure LOOKUP_FIRST_FOOD$EXC(:first_food)
  returning_values :first_food_code;

  execute procedure LOOKUP_GUARANTEE_POLICY$EXC(:hotel_id, :booking_id, 'BOOKING', :guarantee_policy)
  returning_values :guarantee_policy_id;

  execute procedure LOOKUP_EATING_OBJECT$EXC(:hotel_id, :booking_id, 'BOOKING', :eating_object)
  returning_values :eating_object_id;

  arrival_type_code = 1; /*normal*/
  if ('early' = :arrival_type) then begin
    arrival_type_code = 0;
  end else if ('late' = :arrival_type) then begin
    arrival_type_code = 2;
  end
END
^

/* empty dependent procedure body */
/* Clear: OCCUPANCY_ROOMS_CHECK$INT for: OCCUPANCY_ROOM_VALIDATE$INT */
ALTER PROCEDURE OCCUPANCY_ROOMS_CHECK$INT(OCCUPANT_DBKEY CHAR(8),
BUSY_GROUP_SOURCE INTEGER)
 RETURNS(SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (OCCUPANCY_ROOM_VALIDATE$INT) */
ALTER PROCEDURE OCCUPANCY_ROOM_VALIDATE$INT(ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ID_OCCUPANT INTEGER,
OCC_BUSY_GRP_TYPE INTEGER,
REQUEST_GUEST_CNT INTEGER,
CHECK_OPTIONS VARCHAR(255))
 RETURNS(SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
declare variable must_check_cleaning integer;
  declare variable room_capacity integer;
  declare variable real_id_room_type integer;
  declare variable room_name varchar(20);
  declare variable id_other_occupant integer;
  declare variable other_busy_grp_type integer;
  declare variable is_clean integer;
  declare variable clean_txt varchar(20);
  declare variable id_hotel integer;
  declare variable day_action varchar(20);
  declare variable busy_type varchar(50);
begin
  /*  Description:
  ||  CONTEXT   CLEAN, BEDS, ROOM_TYPE, OCCUP
  ||  RESERV    N      Y     Y          FULL
  ||  CHECKIN   Y      Y     N          RES (  ONLY RESERVATIONS)
  ||  BLOCK     N      N     N          FULL
  ||  ROOMEDIT  N      Y     N          RES2 (ONLY RESERVATIONS,NO PERIOD)
  ||----------------------------------------------------
  || CHECK_OPTIONS = (clean, beds, occup_res)
  */
  SHARE_ERR_CODE = 0;
  SHARE_ERR_TEXT = '';
  execute procedure sys_dbg('occ ROOM_VALIDATE ID_ROOM = '||coalesce(:id_room, 'null'));
  execute procedure sys_dbg('occ ROOM_VALIDATE FROM_DATE = '||coalesce(:from_date, 'null'));
  execute procedure sys_dbg('occ ROOM_VALIDATE TO_DATE = '||coalesce(:to_date, 'null'));
  execute procedure sys_dbg('occ ROOM_VALIDATE REQUEST_GUEST_CNT = '||coalesce(:request_guest_cnt, 'null'));
  execute procedure sys_dbg('occ ROOM_VALIDATE CHECK_OPTIONS = '||coalesce(:check_options, 'null'));

  other_busy_grp_type = null;
  real_id_room_type = null;

  select R.ID_ROOM_TYPE, R.BEDS + R.EXTRA_BEDS, R.ROOM_NAME, R.IS_CLEAN, r.ID_HOTEL
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :real_id_room_type, :room_capacity, :room_name, :is_clean, :id_hotel;
  if (:real_id_room_type is null
      and ((:CHECK_OPTIONS containing 'beds') or (:CHECK_OPTIONS containing 'clean')) ) then begin
    exception OCCUPANCY_EXCEPTION '-5';
  end

  if (:check_options like '%clean%'
      and not exists (select rp.ID_ROOM_PERIOD       --skip private rooms for cleaning validation
                      from   ROOM_PERIOD$PMS RP
                      where  RP.ID_ROOM = :ID_ROOM
                             and rp.FROM_DATE <= :FROM_DATE
                             and rp.TO_DATE >= :TO_DATE
                             and rp.STATUS = 'PRIVATE')) then
  begin
    execute procedure SETTING_GET_VALUE('CLEANING_RESTRICTION', :id_hotel)
    returning_values  :must_check_cleaning;
    if ((:must_check_cleaning = 1) and (:is_clean = 0)) then begin
      clean_txt = '@{other.not}';
      exception OCCUPANCY_EXCEPTION '-46' || f_character(31) || f_character(29)||:room_name||f_character(28)||:clean_txt;
    end
  end

  if (:check_options like '%beds%') then begin
    /* CHECK BEDS */
    select max(DRM.day_guests)
    from   (select rm.BUSY_DATE, sum(rm.ADULT_COUNT + rm.CHILDREN_COUNT) as day_guests
            from   ROOM_MAGIC RM
            where  Rm.ID_ROOM = :ID_ROOM
                   and rm.BUSY_DATE between :FROM_DATE and :TO_DATE
                   and rm.DAY_ACTION not containing 'CHECK_OUT'
            group by rm.BUSY_DATE) DRM
    into   :REQUEST_GUEST_CNT;

    if (:room_capacity < :request_guest_cnt) then begin
      exception OCCUPANCY_EXCEPTION '-8' || f_character(31) || f_character(29)||:room_name||f_character(28)||:request_guest_cnt||f_character(28)||:room_capacity;
    end
  end

  /* CHECK OCCUPANCY */
  if (:check_options containing 'occup_res') then begin
    if (exists (select R.ID_ROOM
                from   ROOMS R
                       join ROOM_PERIOD$PMS P on P.ID_ROOM = R.ID_ROOM
                where  P.ID_ROOM = :id_room
                       and P.STATUS = 'INACTIVE' -- allow PRIVATE
                       and P.FROM_DATE <= :to_date
                       and P.TO_DATE >= :from_date)) then
    begin
      exception OCCUPANCY_EXCEPTION '-118';
    end

    id_other_occupant = null;
    for
      select RM.ID_RESERV_DETAIL, RM.BUSY_GROUP_TYPE, rm.DAY_ACTION, rm.BUSY_TYPE
      from   ROOM_MAGIC RM
      where  RM.BUSY_DATE between :from_date and :to_date
             and RM.ID_ROOM = :id_room
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and RM.ID_RESERV_DETAIL <> :ID_OCCUPANT
      order by rm.DAY_ACTION_INT asc -- blocks first - MANDATORY !!!
      into   :id_other_occupant, :other_busy_grp_type, :day_action, :busy_type
    do begin
      -- other occupant has detected
      if ((:other_busy_grp_type in (1, 24)) or (:other_busy_grp_type = 20 and :day_action <> 'BLOCK') ) then begin
        -- other occupant is booking
        share_err_code = iif(:busy_type starting  with 'VALUE_', -9, -10);
  
        select substring(f_character(29)||:room_name||f_character(28)||RD.NUMBER||'-'|| P.PROFILE_NAME||', '||FormatDate(RD.FROM_DATE, 'D;dd.mm.yyyy')||'-'||FormatDate(RD.TO_DATE, 'D;dd.mm.yyyy') from 1 for 255)
        from   RESERV_DETAIL RD
               join PROFILE P on P.ID_PROFILE = RD.ID_PERSON_PROFILE
        where  RD.ID_RESERV_DETAIL = :id_other_occupant
        into   :share_err_text;
      end else begin
        -- other occupant is block
        share_err_code = -106;
        execute procedure sys_dbg('occ ROOM_VALIDATE err_code = -106 room_name = '||coalesce(:room_name, 'null'));
        select substring(
                 f_character(29)||:room_name||f_character(28)||iif(BR.BLOCK_GRP=18, 'Out of order', 'Out of inventory')||
                 ' - '||BR.REASON||f_character(28)||FormatDate(BR.FROM_DATE, 'D;dd.mm.yyyy')||'-'||FormatDate(BR.TO_DATE, 'D;dd.mm.yyyy')
               from 1 for 255)
        from   BLOCK_ROOM BR
        where  BR.ID_BLOCK_ROOM = :id_other_occupant
        into   :share_err_text;

        if (:OCC_BUSY_GRP_TYPE in (18, 20)) then
          exception OCCUPANCY_EXCEPTION :SHARE_ERR_CODE || f_character(31) || :SHARE_ERR_TEXT;
      end
      break; -- exit after first occupant check
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: BLOCK_MODIFY$INT for: OCCUPANCY_ROOMS_CHECK$INT */
ALTER PROCEDURE BLOCK_MODIFY$INT(ID_BLOCK_ROOM INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
BLOCK_GRP INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_BLOCK_ROOM INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE_OCCUPANCY$INT for: OCCUPANCY_ROOMS_CHECK$INT */
ALTER PROCEDURE RES_FINALIZE_OCCUPANCY$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ERROR_CONTEXT VARCHAR(200),
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_FINALIZE$RSV for: OCCUPANCY_ROOMS_CHECK$INT */
ALTER PROCEDURE RES_SAVE_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_RESERV_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* Alter (OCCUPANCY_ROOMS_CHECK$INT) */
ALTER PROCEDURE OCCUPANCY_ROOMS_CHECK$INT(OCCUPANT_DBKEY CHAR(8),
BUSY_GROUP_SOURCE INTEGER)
 RETURNS(SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable from_date date;
declare variable to_date date;
declare variable id_room integer;
declare variable guests_in_room integer;
declare variable id_occupant integer;
declare variable validate_options varchar(255);
declare variable tmp_err_code integer;
declare variable tmp_err_text varchar(255);
declare variable new_shares_arise integer;
begin
  share_err_code = 0;
  share_transaction_id = null;
  tmp_err_code = 0;
  WARN_CODE = null;

  for
    select ORV.ID_ROOM, ORV.FROM_DATE, ORV.TO_DATE, ORV.GUESTS_INROOM, ORV.ID_OCCUPANT, ORV.VALIDATE_OPTIONS
    from   OCCUPANT_ROOMS$INT(:occupant_dbkey, :busy_group_source) ORV
    into   :id_room, :from_date, :to_date, :guests_in_room, :id_occupant, :validate_options
  do begin
    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT from_date = '||coalesce(:from_date, 'null'));
    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT to_date = '||coalesce(:to_date, 'null'));
    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT validate_options = '||coalesce(:validate_options, 'null'));

    execute procedure OCCUPANCY_ROOM_VALIDATE$INT(:id_room, :from_date, :to_date, :id_occupant, :busy_group_source, :guests_in_room, :validate_options)
    returning_values  :tmp_err_code, :tmp_err_text;

    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT err_code = '||coalesce(:tmp_err_code, 'null'));
    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT err_text = '||coalesce(:tmp_err_text, 'null'));
    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT busy_group_source = '||coalesce(:busy_group_source, 'null'));

    if (:share_err_code = 0 and :tmp_err_code <> 0) then begin
      -- room share has detected
      share_err_code = :tmp_err_code;
      share_err_text = :tmp_err_text;
    end
  end
  /*
  Look for shares which:
    - are not own by this reservation
    - are brand new
  if found new - user must be asked for new shares entering permission
  */
  execute procedure OCCUPANCY_SHARES_COMPLETE$INT (:id_occupant)
  returning_values (:new_shares_arise, :share_transaction_id);

  execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT new_shares_arise = '||coalesce(:new_shares_arise, 'null'));
  execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT share_transaction_id = '||coalesce(:share_transaction_id, 'null'));
  /*  */
  if (:new_shares_arise = 0) then begin
    -- ALL SHARES ARE KNOWN...
    -- suppress new shares entering question
    share_err_code = 0;
    share_err_text = '';
    execute procedure sys_dbg('occ OCCUPANCY_ROOM$INT no new shares found ');
  end

  /* check for overlaping on arrival or departure date */
  execute procedure OCCUPANCY_OVERLAP_CHECK$INT (:id_occupant, :busy_group_source)
  returning_values :warn_code;
end
^

/* empty dependent procedure body */
/* Clear: EAI_POS_POSTING_ADD$P2E for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PMS_POSTING_CREATE$INT for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
POST_DATE /* TYPE OF TDATE */ DATE,
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
POST_ON_PMS_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT,
IS_OWNER_INCOME /* TYPE OF TLOGICAL */ SMALLINT,
ID_ROOM /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_ACCOUNT_POST /* ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_FINALIZE$POST for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_TELECOUNT_CALL$INT for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_ACCOUNT$INT) */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
QTY TYPE OF TQTY,
ID_SECQUENCE TYPE OF ID,
IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
POST_TEXT TYPE OF TDESCRIPTION_SHORT,
RESOURCE_TEXT TYPE OF TREASON,
DATE_POST TYPE OF TDATE,
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ID_ROOM TYPE OF ID = null,
POST_DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable action_text varchar(255);
begin
  if (:date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :date_post;
  end
/* NO AUTO PRICE !!!!!!
  if (:in_is_manual_price = 0) then begin

    select P.ID_EXTRA_TARIFF
    from   ACCOUNT A
           join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
    where  A.ID_ACCOUNT = :in_id_account
    into   :id_extra_tarifa;
    if ((:id_extra_tarifa is null) or (:id_extra_tarifa < 0)) then begin
      err_code = -14;
      exit;
    end
    execute procedure TAR_RECALC_EXTRASRV(:id_extra_tarifa, :in_id_service, :in_date_post)
    returning_values  :err_code, :err_text, :post_price, :post_currency;
    if (:err_code < 0) then exit;
  end else begin
    --MANUAL PRICE
    post_currency = :manual_curr ;
    post_price = :manual_price ;
  end
*/

  post_currency = :manual_curr ;
  post_price = :manual_price ;
  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, -1, :id_secquence, :date_post, :id_service, -1, :id_room, 0, :qty, :post_price,
    :post_currency, null, :short_code, :from_date, :to_date, :post_text, :resource_text, '', -1, :POST_DESCRIPTION)
  returning_values :err_code, :err_text, :id_account_post;
  if (:err_code <> 0) then exit;

  select S.SERVICE_NAME
  from   SERVICES S
  where  S.ID_SERVICE = :ID_SERVICE
  into   :action_text;
   
  action_text = f_character(29) || coalesce(:action_text, '')
                || f_character(28) || formatdate(:DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || coalesce(:post_currency, '');
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_RESERVATION$INT for: POST_SERVICE_ON_GUEST$INT */
ALTER PROCEDURE POST_SERVICE_ON_RESERVATION$INT(ID_RESERV_DETAIL /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_ROOM for: POST_SERVICE_ON_GUEST$INT */
ALTER PROCEDURE POST_SERVICE_ON_ROOM(IN_ID_ROOM /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255))
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_GUEST /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_GUEST$INT) */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TDESCRIPTION_SHORT,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ACCOUNT_ROUTING TYPE OF TSHORT_CODE,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable id_room integer;
  declare variable no_use varchar(255);
  declare variable action_text varchar(255);
  declare variable is_guest_check_in smallint;
  declare variable service_name varchar(50);
begin
  err_code = 0;
  err_text = '';

  select g.check_status
  from   guest g
  where  g.id_guest = :in_id_guest
  into   :is_guest_check_in;

  if (:is_guest_check_in < 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
  end

  execute procedure GUEST_GET_POSTING_ACCOUNT$INT (:in_id_guest, :account_routing)
  returning_values  :id_account, :id_room;

  if (:in_date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :in_date_post;
  end

  if (:in_is_manual_price = 0) then begin
    execute procedure SERVICE_GET_POSTING_DETAILS(:in_id_service, :IN_DATE_POST)
    returning_values  :no_use, :no_use, :service_name, :post_price, :post_currency;
  end else begin
    /* MANUAL PRICE */
    post_currency = :manual_curr;
    post_price = :manual_price;
    select s.SERVICE_NAME
    from   SERVICES s
    where  s.ID_SERVICE = :IN_ID_SERVICE
    into   :service_name;
  end

  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, :in_id_guest, :in_id_secquence, :in_date_post, :in_id_service, -1, :id_room, 0, :in_qty,
    :post_price, :post_currency, null, :in_short_code, :in_from_datetime, :in_to_datetime, :in_post_text,
    :in_resource_text, '', -1, :DESCRIPTION)
  returning_values  :err_code, :err_text, :id_account_post;

  action_text = f_character(29) || coalesce(:service_name, '')
                || f_character(28) || formatdate(:IN_DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:IN_QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || coalesce(:post_currency, '');
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: RESOURCE_RESERVATION_CHECK_IN for: POST_SERVICE_ON_RESERVATION$INT */
ALTER PROCEDURE RESOURCE_RESERVATION_CHECK_IN(ID_RESOURCE_RESERVATION INTEGER,
SERVICE_PRICE NUMERIC(15,2),
SERVICE_CURR VARCHAR(3))
 RETURNS(OUT_ID_ACCOUNT INTEGER,
OUT_ID_ACCOUNT_POST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_RESERVATION$INT) */
ALTER PROCEDURE POST_SERVICE_ON_RESERVATION$INT(ID_RESERV_DETAIL TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TREASON,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable id_guest integer;
begin
  err_code = 0;
  err_text = '';

  id_guest = null;
  select RD.ID_TITULAR
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :id_guest;

  execute procedure POST_SERVICE_ON_GUEST$INT(:id_guest, :in_id_service, :in_qty, :in_id_secquence,
                    :in_is_manual_price, :manual_price, :manual_curr, :in_from_datetime, :in_to_datetime,
                    :in_post_text, :in_resource_text, :in_date_post, :in_short_code, '', :DESCRIPTION)
  returning_values  :err_code, :err_text, :id_account, :id_account_post;
end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_POST_TO_MH_FRONT_ONLINE for: POST_SERVICE_ON_ROOM */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_SERVICE_POST for: POST_SERVICE_ON_ROOM */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_ROOM) */
ALTER PROCEDURE POST_SERVICE_ON_ROOM(IN_ID_ROOM TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TREASON,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_GUEST TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
begin
  err_code = 0;
  err_text = '';

  id_guest = null;
  select first 1 G.ID_GUEST
  from   GUEST G
  where  G.ID_ROOM = :in_id_room
         and G.CHECK_STATUS = 0
  order by G.FROM_DATE desc, G.ID_GUEST asc
        /************************************************/
        /* DESCENDANT ORDER IS VERY IMPORTANT!!         */
        /* IF TWO GUESTS HAVE:                          */
        /* TO_DATE OF THE 1'ST = FROM_DATE OF THE 2'ND, */
        /* THEN PHONACALLS SHOULD GO TO THE 2'ND        */         
        /************************************************/
  into   :id_guest;

  if (:id_guest is null) then begin
    err_code = -24;   /* NO GUESTS ARE CHECKED_IN INTO THE REQUESTED ROOM! */
    exit;
  end

  execute procedure POST_SERVICE_ON_GUEST$INT(:id_guest, :in_id_service, :in_qty, :in_id_secquence, :in_is_manual_price,
    :manual_price, :manual_curr, :in_from_datetime, :in_to_datetime, :in_post_text, :in_resource_text,
    :in_date_post, :in_short_code, '')
  returning_values  :err_code, :err_text, :id_account, :id_account_post;
end
^

/* empty dependent procedure body */
/* Clear: EAI_TELECOUNT_TRANSFER for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALL_POST$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL /* ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALLS_POST_TO_ACCOUNT$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_TELECOUNT_TRANSFER$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_TELECOUNT_CALL$INT) */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ext_ifc_name varchar(20);
  declare variable room_name varchar(30);
  declare variable datetime_call timestamp;
  declare variable price numeric(15,2);
  declare variable dial_number varchar(50);
  declare variable units integer;
  declare variable pc_id_service integer;
  declare variable def_manual_curr char(3);
  declare variable post_text varchar(50);
  declare variable id_account_post integer;
  declare variable is_archive integer;
  declare variable id_account integer;
  declare variable new_id_account_post integer;
  declare variable pc_tag varchar(30);
  declare variable number_zone varchar(50);
  declare variable id_hotel integer;
  declare variable id_phonecall integer;
  declare variable no_use varchar(255);
begin
  /* Description:
  || POST_TO_TYPE = 0 - ACCOUNT, 1 - GUEST, 2 - RESERV_DETAIL, 3 - JUST PREPARE, FOR EXTERNAL CLIENT
  */
  err_code = 0;
  err_text = '';
  ext_ifc_name = 'TELECOUNT';

  select PC.ID_PHONECALL, PC.ROOM_NAME, PC.DATETIME_CALL, PC.PRICE, PC.DIAL_NUMBER, PC.UNITS,
         PC.ID_ACCOUNT_POST, PC.IS_ARCHIVE, PC.TAG, substring(PC.NUMBER_ZONE from 1 for 30), pc.ID_HOTEL
  from   PHONECALLS PC 
  where  PC.rdb$db_key = :ph_dbkey
  into   :id_phonecall, :room_name, :datetime_call, :price, :dial_number, :units,
         :id_account_post, :is_archive, :pc_tag, :number_zone, :id_hotel;

  if ((:is_archive = 1) or (coalesce(:id_account_post, 0) > 0)) then exit;

  if ((:pc_tag is null) or (:pc_tag = '')) then pc_tag = 'TELECOUNT_DEFAULT';
  else pc_tag = 'TELECOUNT_' || :pc_tag;

  execute procedure EAI_MAP_SERVICE(:pc_tag, :number_zone, :ext_ifc_name, :id_hotel)
  returning_values  :err_code, :err_text, :pc_id_service;
  if (:err_code < 0) then exit;

  post_text = substring(:dial_number || ', impulses ' || :units from 1 for 50);

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :def_manual_curr;

  new_id_account_post = null;
  if (:post_to_type = 0) then begin
    id_account = :post_to_id;
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name)
    returning_values :err_code, :err_text, :new_id_account_post;
  end else if (:post_to_type = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:post_to_id, :pc_id_service, 1, -1, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name, '')
    returning_values :err_code, :err_text, :id_account, :new_id_account_post;
  end else if (:post_to_type = 2) then begin
    execute procedure POST_SERVICE_ON_RESERVATION$INT(:post_to_id, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name)
    returning_values :err_code, :err_text, :id_account, :new_id_account_post;
  end else if (:post_to_type = 3) then begin
    execute procedure POST_PREPARE_ON_ACCOUNT$POST (:post_to_id, :pc_id_service,
      1, :ID_SEQUENCE, :price, :def_manual_curr, :post_text, null, null, :ID_PHONECALL)
    returning_values :no_use;
  end
  if (:err_code < 0) then exit;

  if (:new_id_account_post is not null) then begin
    update PHONECALLS PC
    set    PC.ID_ACCOUNT_POST = :new_id_account_post,
           pc.POSTING_ERROR = null
    where  PC.rdb$db_key = :ph_dbkey;
  end

end
^

/* Alter (POST_TELECOUNT_TRANSFER$TC) */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ph_dbkey char(8);
  declare variable id_account_post integer;
  declare variable account_name varchar(50);
begin
  err_code = 0;
  err_text = '';

  for
    select PC.RDB$DB_KEY, PC.ID_ACCOUNT_POST
    from   PHONECALLS PC
    where  PC.SELECTION_ID = :selection_id
    into   :ph_dbkey, :id_account_post
  do begin
    if ((:id_account_post is not null) and (:id_account_post <> -1)) then begin
      err_code = -117;
      select A.ACCOUNT_NAME
      from   ACCOUNT_POST AP
             join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
      where  AP.ID_ACCOUNT_POST = :id_account_post
      into   :account_name;
      err_text = f_character(29) || :account_name;
      exit;
    end

    execute procedure POST_TELECOUNT_CALL$INT(2, :id_reserv_detail, :ph_dbkey, 0)
    returning_values :err_code, :err_text;
    if (:err_code < 0) then exit;
  end
end
^

/* empty dependent procedure body */
/* Clear: PROFILE_AGENT_MODIFY$PROFILE for: PROFILE_DELETE$INT */
ALTER PROCEDURE PROFILE_AGENT_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
IS_ARCHIVE INTEGER,
AGENT_GROUP VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IATA_NUMBER VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null,
THRESHOLD_NOTE VARCHAR(255) = null,
THRESHOLD_AMOUNT NUMERIC(15,4) = null,
THRESHOLD_CURR CHAR(3) = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_HOUSE_MODIFY$PROFILE for: PROFILE_DELETE$INT */
ALTER PROCEDURE PROFILE_HOUSE_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(20),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
IS_ARCHIVE INTEGER,
HOUSE_TYPE VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_PERSON_MODIFY$PROFILE for: PROFILE_DELETE$INT */
ALTER PROCEDURE PROFILE_PERSON_MODIFY$PROFILE(ID_PROFILE INTEGER,
ID_GUEST_TYPE INTEGER,
PROFILE_NAME VARCHAR(100),
PERSON_NAME2 VARCHAR(100),
SEX CHAR,
BIRTH_DAY DATE,
BIRTH_PLACE VARCHAR(30),
EGN VARCHAR(30),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
COUNTRY_CODE VARCHAR(20),
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
MASK VARCHAR(10),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
IS_ARCHIVE INTEGER,
ID_PHOTO INTEGER,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
TITLE VARCHAR(10) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PROFILE_DELETE$INT) */
ALTER PROCEDURE PROFILE_DELETE$INT(ID_PROFILE INTEGER)
 AS
declare variable action_text varchar(255);
declare variable id_agent integer;
begin
  id_agent = null;
  select pa.ID_AGENT
  from   PROFILE_AGENT pa
  where  pa.ID_PROFILE = :ID_PROFILE
  into   :id_agent;

  delete from PROFILE P
  where  P.ID_PROFILE = :id_profile;

  if (:id_agent is not null) then
    delete from AGENT A where a.ID_AGENT = :id_agent;

  action_text = '';
  execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'DELETE', :action_text);

end
^

/* Alter (PROFILE_HOUSE_MODIFY$PROFILE) */
ALTER PROCEDURE PROFILE_HOUSE_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(20),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
IS_ARCHIVE INTEGER,
HOUSE_TYPE VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable action_text varchar(255);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    execute procedure PROFILE_COMMON_MODIFY$INT(:id_profile, 'HOUSE', :profile_name,
            :phone, :fax, :email, :contact_city, :contact_address,
            :note, :msg, :is_archive, :id_def_contragent, :id_nom_market_segment,
            :wbe_password, :account_no, :is_exclusive_debt_ownership)
    returning_values (:new_id_profile);

    if (:operation = 'add') then begin
      insert into PROFILE_HOUSE(ID_PROFILE, HOUSE_TYPE)
      values (:new_id_profile, :house_type);

      action_text = f_character(29) || :PROFILE_NAME;
      execute procedure SYSTEM_LOG_ADD ('PROFILE', :new_id_profile, 'CREATE_HOUSE_PROFILE', :action_text);
    end
  end else if (:operation = 'del') then  begin
    execute procedure PROFILE_DELETE$INT(:id_profile);

    new_id_profile = null;
  end
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_PERSON_PROFILE$EXC for: PROFILE_PERSON_MODIFY$PROFILE */
ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PROFILE_PERSON_MODIFY$PROFILE) */
ALTER PROCEDURE PROFILE_PERSON_MODIFY$PROFILE(ID_PROFILE INTEGER,
ID_GUEST_TYPE INTEGER,
PROFILE_NAME VARCHAR(100),
PERSON_NAME2 VARCHAR(100),
SEX CHAR,
BIRTH_DAY DATE,
BIRTH_PLACE VARCHAR(30),
EGN VARCHAR(30),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
COUNTRY_CODE VARCHAR(20),
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
MASK VARCHAR(10),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
IS_ARCHIVE INTEGER,
ID_PHOTO INTEGER,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
TITLE VARCHAR(10) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable p_dbkey char(8);
  declare variable pd_dbkey char(8);
  declare variable old_birth_day date;
  declare variable id_picture integer;
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    new_id_profile = :id_profile;

    if (:operation = 'add') then begin
      execute procedure PROFILE_PERSON_CREATEQ$PROFILE(:profile_name, :phone,
              :id_passport_type, :pass_num, :egn, :country_code, :card_code, null, :TITLE, null)
      returning_values  :new_id_profile, :p_dbkey, :pd_dbkey;

      if (:MASK is null) then begin
        -- keep the default mask if input mask is <null> - undefined
        -- empty mask is '' - passed by GUI, but <null> is passed from booking import, etc.
        select PD.MASK
        from   PERSON_DATA PD
        where  PD.RDB$DB_KEY = :pd_dbkey
        into   :mask;
      end
    end

    select P.RDB$DB_KEY, PD.RDB$DB_KEY, pd.BIRTH_DAY
    from   PROFILE P
           join PROFILE_PERSON PP on PP.ID_PROFILE = P.ID_PROFILE
           join PERSON_DATA PD on PD.ID_PERSON_DATA = PP.ID_PERSON_DATA
    where  P.ID_PROFILE = :new_id_profile
    into   :p_dbkey, :pd_dbkey, :old_birth_day;

    execute procedure PROFILE_COMMON_MODIFY$INT(:new_id_profile, 'PERSON', :profile_name,
            :phone, :fax, :email, :contact_city, :contact_address,
            :note, :msg, :is_archive, :id_def_contragent, :id_nom_market_segment,
            :wbe_password, :account_no, :is_exclusive_debt_ownership)
    returning_values (:new_id_profile);

    execute procedure PERSON_DATA_SET$INT(:p_dbkey, :pd_dbkey, :profile_name, :person_name2, :country_code,
            :old_birth_day, :birth_day, :TITLE);

    execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, :birth_place, :egn, :id_passport_type, :pass_num, :pass_date, :pass_place,
            :pass_exp_date, :pass_city, :pass_address, :sex, :mask);

    update PROFILE_PERSON PP
    set    PP.ID_GUEST_TYPE = :id_guest_type,
           PP.ID_PHOTO = :id_photo,
           PP.CARD_CODE = :card_code
    where  PP.ID_PROFILE = :new_id_profile;

  end else if (:operation = 'del') then begin
    id_picture = null;

    select PP.ID_PHOTO
    from   PROFILE_PERSON PP
    where  PP.ID_PROFILE = :id_profile
    into   :id_picture;

    execute procedure PICTURE_MODIFY (:id_picture, null, null, null, 'del')
    returning_values :id_picture;

    execute procedure PROFILE_DELETE$INT(:id_profile);
    new_id_profile = null;
  end
end
^

/* Alter (RATE_GET_AVAILABILITY$CHM) */
ALTER PROCEDURE RATE_GET_AVAILABILITY$CHM(ID_RATE INTEGER,
FOR_DATE DATE)
 RETURNS(ACTIVE_STATUS INTEGER,
MIN_LOS INTEGER,
MAX_LOS INTEGER)
 AS
declare variable date_from date;
  declare variable date_to date;
  declare variable RATE_capacity integer;
  declare variable to_sell integer;
begin
  --ACTIVE_STATUS 0 - closed
  --ACTIVE_STATUS 1 - closed fro arrival
  --ACTIVE_STATUS 2 - opened
  --opala ID_HOTEL
--  date_from = null;
--  ACTIVE_STATUS -  autoclose, t.e. AUTO_PERCENT






/*  select min(FOR_DATE), max(FOR_DATE)
  from RATE_ALLOTMENT
  where ID_RATE = :id_RATE
  into :date_from, :date_to;
  if (date_from is null) then exit;

  for select distinct ID_ROOM_TYPE
      from RATE_ALLOTMENT
      where ID_RATE = :id_RATE
        and FOR_DATE between :date_from and :date_to
      into :id_room_type
  do begin
    for select RTR.FOR_DATE,
               CA.STATUS,
               CA.AUTO_FREE_ROOMS, CA.ROOM_COUNT, RTR.AVAILABLE as FREE_ROOMS
        from ROOM_TYPE_GET_FREE$CHM(:date_from, :date_to, :id_room_type) RTR
             join RATE_ALLOTMENT CA on CA.ID_ROOM_TYPE = :id_room_type
                                      and CA.ID_RATE = :id_RATE
                                      and CA.FOR_DATE = RTR.FOR_DATE
    into :for_date, :status,
         :auto_free_rooms, :RATE_capacity, :free_rooms
    do begin
      if (:auto_free_rooms is not null) then
        if (coalesce(:free_rooms,0) >= :auto_free_rooms) then
          is_active = 1;
        else is_active = 0;
      else if (:status = 0) then
             is_active = 1;
           else is_active = 0;

      to_sell = coalesce(:free_rooms,0) - coalesce(:auto_free_rooms,0);
      if (to_sell < 0) then to_sell = 0;

      room_count = :to_sell;
      if (:RATE_capacity is not null) then
        if (RATE_capacity < room_count) then
          room_count = :RATE_capacity;

      suspend;
    end
  end*/
end
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_SET$INT for: RES_CREATE_LOG$INT */
ALTER PROCEDURE RES_CREATE_SET$INT(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_HOTEL INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
SPLIT_ON_CHECKIN SMALLINT,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_ACC_TEMPLATE_PERSON INTEGER = null,
ID_GUARANTEE_POLICY INTEGER = null,
BLOCK_CC VARCHAR(255) = null,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(RD_DBKEY CHAR(8),
NEW_ID_RESERV_DETAIL INTEGER,
WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_CREATE_LOG$INT) */
ALTER PROCEDURE RES_CREATE_LOG$INT(RD_DBKEY CHAR(8))
 AS
declare variable action_text varchar(255);
  declare variable room_name varchar(30);
  declare variable agent_profile varchar(100);
  declare variable tarifa_name varchar(50);
  declare variable type_hrana varchar(30);
  declare variable id_reserv_detail integer;
  declare variable number varchar(62);
  declare variable arrival_date date;
  declare variable departure_date date;
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable custom_price numeric(15,4);
  declare variable custom_currency varchar(3);
  declare variable id_event_log integer;
begin
  select rd.ID_RESERV_DETAIL, rd.NUMBER, rd.FROM_DATE, rd.TO_DATE, rd.ADULT_COUNT, rd.CHILD_COUNT,
         rt.TYPE_ROOM || ' ' || coalesce (R.ROOM_NAME, ''),
         P.PROFILE_NAME, T.TARIFA_NAME, TH.NAME, rd.CUSTOM_PRICE, rd.CUSTOM_CURRENCY
  from   RESERV_DETAIL RD
         left outer join ROOM_TYPES RT on rt.ID_ROOM_TYPE = rd.ID_ROOM_TYPE
         left outer join ROOMS R on R.ID_ROOM_TYPE = RT.ID_ROOM_TYPE and R.ID_ROOM = rd.ID_ROOM
         left outer join PROFILE P on P.ID_PROFILE = rd.ID_AGENT_PROFILE
         left outer join TARIFA T on T.ID_TARIFA = RD.ID_RATE
         left outer join MEALS TH on TH.ID_BOARD = rd.ID_BOARD
  where  RD.RDB$DB_KEY = :RD_DBKEY
  into   :id_reserv_detail, :number, :arrival_date, :departure_date, :adult_count, :child_count,
         :room_name,
         :agent_profile, :tarifa_name, :type_hrana, :custom_price, :custom_currency;

  action_text = substring(f_character(29) || :number
                || f_character(28) || formatdate(:arrival_date, 'D;dd.mm.yyyy') || '-' || formatdate(:departure_date, 'D;dd.mm.yyyy')
                || f_character(28) || :room_name
                || f_character(28) || :ADULT_COUNT || '+' || :CHILD_COUNT
                || f_character(28) || coalesce(:type_hrana, '')
                || f_character(28) || coalesce(substring(:agent_profile from 1 for 50), '')
                || f_character(28) || :tarifa_name
                || f_character(28) || coalesce(formatfloat(:custom_price, '0.00') || ' ' || :custom_currency, '')
                from 1 for 255);

  execute procedure SYSTEM_EVENT_LOG$INT ('RES_DETAIL', :id_reserv_detail, 'RES_CREATE', :action_text)
  returning_values :id_event_log;

  if (:id_event_log is not null) then
    update RESERV_DETAIL R
    set    r.ID_LOG_EVENT_CREATE = :id_event_log
    where  r.RDB$DB_KEY = :RD_DBKEY;
end
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_SET$EXC for: RES_CREATE_SET$INT */
ALTER PROCEDURE RES_CREATE_SET$EXC(ID_RESERV_DETAIL INTEGER,
RES_NUMBER VARCHAR(62),
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER,
CREATE_DATETIME TIMESTAMP)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_RESERV_DETAIL INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_SET$RSV for: RES_CREATE_SET$INT */
ALTER PROCEDURE RES_CREATE_SET$RSV(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
SUPPRESS_WARNINGS INTEGER,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT$RSV for: RES_CREATE_SET$INT */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_CREATE$RSV for: RES_CREATE_SET$INT */
ALTER PROCEDURE RESMULTI_CREATE$RSV(ID_HOTEL INTEGER,
ID_ROOM_TYPE INTEGER,
TRANSFER_OUT_TIME TIME,
TRANSFER_IN_TIME TIME,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
TRANSFER_OUT_NOTE VARCHAR(50),
TRANSFER_IN_NOTE VARCHAR(50),
NOTE VARCHAR(255),
ID_BOARD INTEGER,
VOUCHER_DATE DATE,
VOUCHER_NUMBER VARCHAR(20),
VOUCHER_TEXT VARCHAR(30),
CHECK_STATUS INTEGER,
ID_TARIFF INTEGER,
COUNTRY_CODE VARCHAR(20),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
NOTE_REMINDERS VARCHAR(50),
TITULAR_NAME VARCHAR(100),
SPLIT_ON_CHECKIN INTEGER,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
NUMBER VARCHAR(62),
NEW_ID_TITULAR INTEGER,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE,
WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_CREATE_SET$INT) */
ALTER PROCEDURE RES_CREATE_SET$INT(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(255),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_HOTEL INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
SPLIT_ON_CHECKIN SMALLINT,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_ACC_TEMPLATE_PERSON INTEGER = null,
ID_GUARANTEE_POLICY INTEGER = null,
BLOCK_CC VARCHAR(255) = null,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(RD_DBKEY CHAR(8),
NEW_ID_RESERV_DETAIL INTEGER,
WARN_CODE TYPE OF TRANGE)
 AS
declare variable guarantee_deposit_percent numeric(15,4);
  declare variable guarantee_deposit_nights integer;
  declare variable guarantee_due_days_bef_arrival integer;
  declare variable guarantee_due_days_after_create integer;
  declare variable gp_check_status integer;
  declare variable log_suppressed integer;
  declare variable id_guest integer;
  declare variable minibar_rights varchar(50);
  declare variable video_rights varchar(50);
  declare variable nopost_pms varchar(50);
  declare variable phone_rights varchar(50);
  declare variable paytv_rights varchar(50);
  declare variable is_profile_exclusive_debt_ownership integer;
  declare variable id_base_account integer;
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CREATE');

  select GP.DEPOSIT_NIGHTS_COUNT, GP.DEPOSIT_TOTALSUM_PART,
         GP.DUE_DAYS_BEFORE_ARRIVAL, GP.DUE_DAYS_AFTER_CREATE, gp.CHECK_STATUS
  from   GUARANTEE_POLICY GP
  where  GP.ID_GUARANTEE_POLICY = :ID_GUARANTEE_POLICY
         and gp.ID_HOTEL = :ID_HOTEL
  into   :guarantee_deposit_nights, :guarantee_deposit_percent,
         :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create, :gp_check_status;

  CHECK_STATUS = coalesce(:CHECK_STATUS, :gp_check_status, -2);

  execute procedure RES_CREATE_ROOM$INT(:check_status, :arrival_date, :departure_date, :adult_count, :child_count,
                    :id_room_type, 1, :id_board, :id_tariff, comming_kind, :is_late_departure, :country_code, :code_first_food,
                    :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note, :i_special_treatment, :id_agent_profile,
                    :id_hk_plan, '', :room_features, :id_person_profile, :acc_routing, :id_acc_template_person, :id_hotel, :id_agent_account,
                    :id_group, :id_reserv_detail, :res_number, :id_guarantee_policy, :id_eating_object)
  returning_values  :new_id_reserv_detail, :rd_dbkey, :id_person_profile;

  if (RDB$GET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE') is not distinct from 'disable') then begin
    log_suppressed = 1;
  end else begin
    log_suppressed = 0;
    RDB$SET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE', 'disable');
    -- disable only for intermediate changes
  end

  execute procedure RES_SAVE_ACCOUNTING$INT (:rd_dbkey, :id_agent_profile, :id_agent_account, :acc_routing,
          :id_person_payment, :id_agent_payment, :id_group);

  execute procedure RES_SAVE_MARKETING$INT(:rd_dbkey, :id_nom_market_segment,
                    :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason);

  execute procedure sys_dbg('res RES_CREATE_SET$INT id_room = '||coalesce(:id_room, 'null'));
  if (:id_room is not null) then begin
    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, :id_room_type, 'nrttRoom')
    returning_values (:WARN_CODE);
  end

  execute procedure RES_SAVE_VOUCHER$INT(:RD_DBKEY, :voucher_num, :voucher_date, :voucher_text, :voucher2_num, :voucher2_date);

  execute procedure RES_SAVE_NOTE$RSV(:new_id_reserv_detail, :note, :note_reminders);

  for
    select  g.ID_GUEST
    from    GUEST G
    where   G.ID_RESERV_DETAIL = :NEW_ID_RESERV_DETAIL
    into    :id_guest
  do begin
    execute procedure RES_GUEST_SAVE_PACKET$RSV (:id_guest, :PACKET_ITEM_IDS);
  end 

  update RESERV_DETAIL RD
  set    RD.CUSTOM_PRICE = :CUSTOM_PRICE,
         RD.CUSTOM_CURRENCY = :CUSTOM_CURRENCY,
         RD.SPLIT_ON_CHECKIN = :SPLIT_ON_CHECKIN,
         RD.IS_VIP = coalesce(:IS_VIP, RD.IS_VIP),
         RD.ID_GUARANTEE_POLICY = :ID_GUARANTEE_POLICY,
         RD.GUARANTEE_DEPOSIT = :GUARANTEE_DEPOSIT,
         RD.GUARANTEE_CURRENCY = :GUARANTEE_CURRENCY,
         RD.BLOCK_CC = :BLOCK_CC,
         RD.GUARANTEE_DEPOSIT_PERCENT = :guarantee_deposit_percent,
         RD.GUARANTEE_DEPOSIT_NIGHTS = :guarantee_deposit_nights,
         RD.GUARANTEE_DUE_DAYS_BEF_ARRIVAL = :guarantee_due_days_bef_arrival,
         RD.GUARANTEE_DUE_DAYS_AFTER_CREATE = :guarantee_due_days_after_create
         /*rd.POSTING_TRANSACTION_UUID =  (select iif(p.IS_EXCLUSIVE_DEBT_OWNERSHIP = 1, uuid_create(), null)
                                         from   ACCOUNT A
                                                join PROFILE P on P.ID_PROFILE = a.ID_PROFILE
                                         where  a.ID_ACCOUNT = rd.ID_BASE_ACCOUNT)*/
  where  RD.RDB$DB_KEY = :rd_dbkey
  returning new.ID_BASE_ACCOUNT
  into      :id_base_account;

  select p.IS_EXCLUSIVE_DEBT_OWNERSHIP
  from   ACCOUNT A
         join PROFILE P on P.ID_PROFILE = a.ID_PROFILE
  where  a.ID_ACCOUNT = :id_base_account
  into   :is_profile_exclusive_debt_ownership;

  if (:is_profile_exclusive_debt_ownership = 1) then begin
    execute procedure RES_TAKE_POSTING_RESPONSIBILITY (:NEW_ID_RESERV_DETAIL);
  end

  select rt.MINIBAR_RIGHTS, rt.VIDEO_RIGHTS, rt.NOPOST_PMS, rt.PHONE_RIGHTS, rt.PAYTV_RIGHTS
  from   RES_TEMPLATE RT
  where  rt.ID_HOTEL = :ID_HOTEL
  into   :minibar_rights, :video_rights, :nopost_pms, :phone_rights, :paytv_rights;

  execute procedure RESERV_DETAIL_EXTERNAL_MOD$RSV (:NEW_ID_RESERV_DETAIL,
          :minibar_rights, :paytv_rights, :video_rights, :nopost_pms, :phone_rights, null, null);

  if (:log_suppressed = 0) then RDB$SET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE', 'enable');

  execute procedure RES_CREATE_LOG$INT (:RD_DBKEY);

end
^

/* Alter (RES_CREATE_SET$RSV) */
ALTER PROCEDURE RES_CREATE_SET$RSV(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
SUPPRESS_WARNINGS INTEGER,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER,
NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable rd_dbkey char(8);
declare variable tmp_warn_code integer;
begin
  WARN_CODE = null;
  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, :check_status, :arrival_date, :departure_date,
                    :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff, :PACKET_ITEM_IDS,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
                    :guarantee_deposit, :guarantee_currency, :split_on_checkin, null, null, :ID_ACC_TEMPLATE_PERSON,
                    :ID_GUARANTEE_POLICY, null, :ID_EATING_OBJECT)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :WARN_CODE;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :ERR_TEXT, :share_transaction_id, :tmp_warn_code;
  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

  if (:suppress_warnings = 1) then begin
    delete from SYSTEM_WARNINGS W
    where W.ID_TRANSACTION = :warn_code;
    warn_code = null;
  end

  update RESERV_DETAIL RD
  set    RD.NOTE_REMINDERS = :note_reminders
  where  RD.RDB$DB_KEY = :rd_dbkey;

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;

end
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE_SHAREOPTION$INT for: RES_FINALIZE_OCCUPANCY$INT */
ALTER PROCEDURE RES_FINALIZE_SHAREOPTION$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_FINALIZE_OCCUPANCY$INT) */
ALTER PROCEDURE RES_FINALIZE_OCCUPANCY$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ERROR_CONTEXT VARCHAR(200),
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable busy_group_source integer;
declare variable tmp_warn_code integer;
declare variable id_room_type integer;
declare variable id_agent integer;
declare variable check_status integer;
declare variable from_date date;
declare variable to_date date;
begin
  err_code = 0;
  warn_code = null;
  tmp_warn_code = null;

  select iif(RD.CHECK_STATUS = 1, 24, 1), coalesce(R.ID_ROOM_TYPE, RD.ID_ROOM_TYPE), P.ID_AGENT,
         rd.CHECK_STATUS, rd.FROM_DATE, rd.TO_DATE
  from   RESERV_DETAIL RD
         left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
         left outer join PROFILE_AGENT P on P.ID_PROFILE = RD.ID_AGENT_PROFILE
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :busy_group_source, :id_room_type, :id_agent, :check_status, :from_date, :to_date;

  error_context = 'OCCUPANCY';
  execute procedure OCCUPANCY_RESERV$INT(:rd_dbkey);

  if (:id_agent is not null) then begin
    execute procedure OCCUPANCY_ACTIVE_FRAME_CHK$INT(:id_agent, :from_date, :to_date - 1, :id_room_type)
    returning_values  :err_code, :err_text;
    if (:err_code < 0) then exit;
  end

  if (:check_status > -3) then begin
    execute procedure OCCUPANCY_OVERBOOK_CHECK$INT (:id_agent, :from_date, :to_date - 1, :id_room_type)
    returning_values  :err_code, :err_text, :warn_code;
    if (:err_code < 0) then exit;
  end
  ---------------------------------
  error_context = 'ROOM_VALIDATION';
  execute procedure OCCUPANCY_ROOMS_CHECK$INT(:rd_dbkey, :busy_group_source)
  returning_values  :share_err_code, :share_err_text, :share_transaction_id, :tmp_warn_code;

  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

  /* empty shares helper table*/
  delete from RESERV_STAY$TMP t
  where  t.id_session = RDB$GET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION');

end
^

/* empty dependent procedure body */
/* Clear: IMPORT_BOOKING_FINALIZE$EXC for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE IMPORT_BOOKING_FINALIZE$EXC(BOOKING_ID INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1,
STATUS VARCHAR(50) = null,
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20) = null,
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20) = null)
 RETURNS(RECORD_TIMESTAMP TIMESTAMP,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE$INT for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_FINALIZE$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ROOM$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SAVE_ROOM$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
ID_RES_ROOM_TYPE INTEGER,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(255),
SPLIT_ON_CHECKIN SMALLINT,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_STAY$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SAVE_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_CHECKIN$INT for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SET_CHECKIN$INT(RD_DBKEY CHAR(8))
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM$INT for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SET_ROOM$INT(RD_DBKEY CHAR(8),
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_STAY$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RES_SET_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_FINALIZE$RSV for: RES_FINALIZE_SHAREOPTION$INT */
ALTER PROCEDURE RESMULTI_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER,
DISABLE_WARNING SMALLINT)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_FINALIZE_SHAREOPTION$INT) */
ALTER PROCEDURE RES_FINALIZE_SHAREOPTION$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable error_context varchar(200);
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable room_price numeric(15,4);
  declare variable is_anul smallint;
begin
  WARN_CODE = null;

  select RD.ID_RESERV_DETAIL, RD.CHECK_STATUS, rd.ROOM_PRICE, rd.IS_ANUL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail, :check_status, :room_price, :is_anul;

  execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));
  execute procedure RES_FINALIZE_OCCUPANCY$INT(:rd_dbkey)
  returning_values  :err_code, :err_text, :error_context, :share_transaction_id, :share_err_code, :share_err_text, :warn_code;

  --execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT share_err_code = '||coalesce(:share_err_code, 'null'));
  --execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT share_err_text = '||coalesce(:share_err_text, 'null'));
  --execute procedure sys_dbg('occ RES_FINALIZE_SHAREOPTION$INT err_code = '||coalesce(:err_code, 'null'));

  execute procedure RES_FINALIZE_ERRHANDLING$INT(:id_reserv_detail, :err_code, :err_text, :error_context, :SUPPRESS_NON_INSTANT_ERRORS);

  if (((:check_status >= 0) or (:room_price is null) or (:is_anul = 1) ) /*and (:is_anul = 0)*/) then begin
    execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    returning_values  :err_code, :err_text;

    execute procedure RES_FINALIZE_ERRHANDLING$INT(:id_reserv_detail, :err_code, :err_text, 'RECALC', :SUPPRESS_NON_INSTANT_ERRORS);
  end

  execute procedure RES_FINALIZE_CLEAR$INT(:rd_dbkey, :id_reserv_detail);

  warn_code = coalesce(:WARN_CODE, RDB$GET_CONTEXT('USER_TRANSACTION', 'WARN_CODE'));
  RDB$SET_CONTEXT('USER_TRANSACTION', 'WARN_CODE', null);

end
^

/* Alter (RES_GET_GUEST_BOARDS$RSV) */
ALTER PROCEDURE RES_GET_GUEST_BOARDS$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(BOARD_NAMES VARCHAR(255),
ID_BOARD INTEGER)
 AS
declare variable board_name varchar(100);
  declare variable id_board_rd integer;
  declare variable hasDifference smallint;
begin
  /*  Description:
  ||
  */
  hasDifference = 0;
  board_names = '';

  select RD.ID_BOARD
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :id_board_rd;

  for
    select distinct
           TH.NAME, TH.ID_BOARD
    from   GUEST G
           join GUEST_STAY GS on GS.ID_GUEST = G.ID_GUEST
           left outer join MEALS TH on TH.ID_BOARD = GS.ID_BOARD
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :board_name, :id_board
  do begin
    if (:id_board_rd is distinct from :id_board) then
        hasDifference = 1;
    if (:board_names not containing :board_name) then begin
      board_names = case
                      when :board_names='' then :board_name
                      else :board_names||','||:board_name
                    end;
    end
  end

  if (:hasDifference = 1) then
    id_board = null;

  suspend;
end
^

/* empty dependent procedure body */
/* Clear: CACHES_RESOLVE for: RES_GET_GUEST_DATA$INT */
ALTER PROCEDURE CACHES_RESOLVE AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_GET_INFO$RSV for: RES_GET_GUEST_DATA$INT */
ALTER PROCEDURE RES_GET_INFO$RSV(ID_RESERV_DETAIL INTEGER,
RETURN_BALANCE SMALLINT = 1,
RETURN_SHARE SMALLINT = 1,
RETURN_GEUSTDATA SMALLINT = 1)
 RETURNS(NUMBER VARCHAR(62),
AGENT_PROFILE_NAME VARCHAR(100),
ARRIVALS VARCHAR(255),
DEPARTURES VARCHAR(255),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
ID_ROOM INTEGER,
ROOM VARCHAR(60),
ID_ROOM_TYPE INTEGER,
ROOM_FEATURES BLOB,
GUESTS VARCHAR(255),
GUESTS_CNT INTEGER,
PERSON_PROFILE_NAME VARCHAR(150),
RATES VARCHAR(255),
BOARDS VARCHAR(255),
PACKETS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY VARCHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
BALANCE VARCHAR(255),
OPEN_CHARGES INTEGER,
CHECK_STATUS INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
NOTE VARCHAR(2000),
NOTE_GRP VARCHAR(255),
VOUCHER_RENDER VARCHAR(512),
ACC_ROUTING VARCHAR(255),
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
BUSY_GRP INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
GUEST_TYPE_COLOR INTEGER,
IS_CLEAN INTEGER,
ROOM_PRIVATE_STATUS /* TLOGICAL */ SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_LOAD for: RES_GET_GUEST_DATA$INT */
ALTER PROCEDURE RES_LOAD(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_AGENT_PROFILE INTEGER,
AGENT_PROFILE_NAME VARCHAR(100),
ID_PERSON_PROFILE INTEGER,
PERSON_PROFILE_NAME VARCHAR(100),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_RES_ROOM_TYPE INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
BOARD_NAMES VARCHAR(255),
TARIFF_NAMES VARCHAR(255),
PACKET_NAMES VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100),
VOUCHER_RENDER VARCHAR(512),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
TRANSFER_RENDER VARCHAR(255),
CODE_FIRST_FOOD_RENDER VARCHAR(255),
IS_LATE_DEPARTURE INTEGER,
CODE_FIRST_FOOD VARCHAR(20),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
I_SPECIAL_TREATMENT VARCHAR(255),
COMMING_KIND SMALLINT,
IS_VIP SMALLINT,
HAS_GUEST_LIST SMALLINT,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
AGENT_ACCOUNT_NAME VARCHAR(100),
IS_DIFFERENT_VOUCHER INTEGER,
IS_DIFFERENT_OTHER INTEGER,
IS_DIFFERENT_BOARD INTEGER,
IS_DIFFERENT_TARIFF INTEGER,
IS_CUSTOM_PRICE INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
ID_RATE INTEGER,
ROOM_FEATURES BLOB,
ID_GROUP INTEGER,
NUMBER VARCHAR(62),
CHECK_STATUS INTEGER,
BALANCE VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER,
RECIEVED_DEPOSITS VARCHAR(255),
ROOM_HISTORY VARCHAR(200),
TAR_ROOM_TYPE VARCHAR(100),
ID_HK_PLAN INTEGER,
COUNTRIES VARCHAR(812),
IS_RESGRP INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
IS_ANUL INTEGER,
NOTE VARCHAR(2000),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
GROUP_NAME VARCHAR(50),
ID_HOTEL INTEGER,
NOTE_REMINDERS VARCHAR(50),
IS_DIFFERENT_PRICE INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER,
ROOM_PRIVATE_STATUS /* TLOGICAL */ SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESGRP_GET_INFO$RSV for: RES_GET_GUEST_DATA$INT */
ALTER PROCEDURE RESGRP_GET_INFO$RSV(ID_INFO_GROUP INTEGER)
 RETURNS(AGENT_PROFILE_NAME VARCHAR(100),
ARRIVALS VARCHAR(255),
DEPARTURES VARCHAR(255),
ROOM_DATA VARCHAR(255),
ROOMS VARCHAR(255),
ID_ROOM INTEGER,
GUESTS VARCHAR(255),
PERSON_PROFILE_NAME VARCHAR(100),
RATES VARCHAR(255),
BOARDS VARCHAR(255),
PACKETS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY VARCHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
BALANCE VARCHAR(255),
OPEN_CHARGES INTEGER,
CHECK_STATUS VARCHAR(255),
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
NOTE VARCHAR(2000),
NOTE_GRP VARCHAR(255),
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
FIRST_ARRIVAL DATE,
FIRST_DEPARTURE DATE,
HOTELS VARCHAR(255),
ID_HOTEL INTEGER,
ACC_ROUTING VARCHAR(255),
RES_NUMBER VARCHAR(62))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_LOAD$RSV for: RES_GET_GUEST_DATA$INT */
ALTER PROCEDURE RESMULTI_LOAD$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(CHECK_STATUS INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
IS_DIFFERENT_BOARD SMALLINT,
BOARDS VARCHAR(255),
IS_DIFFERENT_VOUCHER SMALLINT,
VOUCHERS VARCHAR(255),
IS_DIFFERENT_TRANSFER_IN_TIME SMALLINT,
TRANSFER_IN_TIMES VARCHAR(255),
IS_DIFFERENT_TRANSFER_OUT_TIME SMALLINT,
TRANSFER_OUT_TIMES VARCHAR(255),
IS_DIFFERENT_TRANSFER_IN_NOTE SMALLINT,
TRANSFER_IN_NOTES VARCHAR(500),
IS_DIFFERENT_TRANSFER_OUT_NOTE SMALLINT,
TRANSFER_OUT_NOTES VARCHAR(500))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GET_GUEST_DATA$INT) */
ALTER PROCEDURE RES_GET_GUEST_DATA$INT(RESERV_DATA VARCHAR(20),
ID_RESERV_DATA TYPE OF ID)
 RETURNS(BOARD_NAMES TYPE OF TDESCRIPTION_LONG,
TARIFF_NAMES TYPE OF TDESCRIPTION_LONG,
PACKET_NAMES TYPE OF TDESCRIPTION_LONG,
VOUCHERS_RENDER TYPE OF TDESCRIPTION_LONG)
 AS
declare variable board_name varchar(100);
  declare variable packet_name varchar(100);
  declare variable tarifa_name varchar(50);

  declare variable voucher_idx varchar(255);
  declare variable voucher2_idx varchar(255);

  declare variable voucher_num varchar(30);
  declare variable voucher_date date;
  declare variable voucher_text varchar(30);
  declare variable voucher2_num varchar(30);
  declare variable voucher2_date date;

  declare variable id_group integer;
  declare variable id_reserv_detail integer;
  declare variable cache_cnt integer;
  declare variable id_guest integer;
begin
  /*  Description:
  ||
  */
  id_reserv_detail = iif(:RESERV_DATA = 'DETAIL', :ID_RESERV_DATA, null);
  id_group = iif(:RESERV_DATA = 'GROUP', :ID_RESERV_DATA, null);

  select min(RGC.BOARD_NAMES), min(RGC.TARIFF_NAMES), min(RGC.PACKET_NAMES), min(RGC.VOUCHERS_RENDER),
         count(rgc.RDB$DB_KEY)
  from   RESERV_GUESTDATA_CACHE RGC
  where  RGC.ID_RESERV_DETAIL is not distinct from :id_reserv_detail
         and RGC.ID_GROUP is not distinct from :id_group
  into   :board_names, :tariff_names, :packet_names, :vouchers_render, :cache_cnt;

--  execute procedure sys_dbg('res RES_GET_GUEST_DATA$INT cached value board_names = '||coalesce(:board_names, 'null'));
--  execute procedure sys_dbg('res RES_GET_GUEST_DATA$INT cached value tariff_names = '||coalesce(:tariff_names, 'null'));

  if ((:cache_cnt <> 1) or (:board_names is null)) then begin
    board_names = '';
    tariff_names = '';
    packet_names = '';
    vouchers_render = '';voucher2_idx = 'x';voucher_idx = 'x';

    for
      select coalesce(G.VAUCHER_NUM, ''), G.VAUCHER_DATE, coalesce(G.VAUCHER_TEXT, ''),
             coalesce(G.VAUCHER_NUM2, ''), G.VAUCHER_DATE2, g.ID_GUEST
      from   RESERV_DETAIL RD
             join GUEST G on G.ID_RESERV_DETAIL = RD.ID_RESERV_DETAIL
      where  (rd.ID_RESERV_DETAIL = :id_reserv_detail)
             or (rd.ID_GROUP = :id_group and rd.IS_ANUL = 0)
      into   :voucher_num, :voucher_date, :voucher_text,
             :voucher2_num, :voucher2_date, :id_guest
    do begin
      for
        select distinct coalesce(m.NAME, ''), t.TARIFA_NAME
        from   GUEST_STAY GS
               left outer join MEALS M on M.ID_BOARD = GS.ID_BOARD
               left outer join TARIFA T on T.ID_TARIFA = GS.ID_TARIFF
        where  GS.ID_GUEST = :id_guest
        into   :board_name, :tarifa_name
      do begin
        if ( (:board_names || ',') not containing (:board_name || ',')) then
          board_names = substring(iif(:board_names='', :board_name, :board_names||','||:board_name) from 1 for 255);
        if ( (:tariff_names || ',') not containing (:tarifa_name || ',')) then
          tariff_names = substring(iif(:tariff_names='', :tarifa_name, :tariff_names||','||:tarifa_name) from 1 for 255);
      end

      for
        select p.PACKET_ITEM_TAG
        from   GUEST_PACKET Gp
               join PACKET_ITEM P on p.ID_PACKET_ITEM = gp.ID_PACKET_ITEM
        where  Gp.ID_GUEST = :id_guest
        into   :packet_name
      do begin
        if (:packet_names not containing :packet_name) then packet_names = substring(iif(:packet_names='', :packet_name, :packet_names||'/'||:packet_name) from 1 for 255);
      end

      if (:RESERV_DATA <> 'GROUP') then begin
        if ((:voucher_num <> '') and (:voucher_idx not containing :voucher_num)) then begin
          voucher_idx = :voucher_idx || :voucher_num || 'x';
          vouchers_render = substring(iif(:vouchers_render = '', :voucher_num, :vouchers_render || ' ' || :voucher_num) from 1 for 255);
          if (:voucher_date is not null) then vouchers_render = substring(iif(:vouchers_render = '', '', :vouchers_render || ' ') || FormatDate(:voucher_date, 'D;dd/mm') from 1 for 255);
          if (:voucher_text is not null) then vouchers_render = substring(iif(:vouchers_render = '', '', :vouchers_render || ' ') || ' (' || :voucher_text || ')' from 1 for 255);
        end
        
        if ((:voucher2_num <> '') and (:voucher2_idx not containing :voucher2_num)) then begin
          voucher2_idx = :voucher2_idx || :voucher2_num || 'x';
          vouchers_render = substring(iif(:vouchers_render = '', :voucher2_num, :vouchers_render || ' ' || :voucher2_num) from 1 for 255);
          if (:voucher2_date is not null) then vouchers_render = substring(iif(:vouchers_render = '', '', :vouchers_render || ' ') || FormatDate(:voucher2_date, 'D;dd/mm') from 1 for 255);
        end
      end
    end
--    execute procedure sys_dbg('res RES_GET_GUEST_DATA$INT calculated value board_names = '||coalesce(:board_names, 'null'));
--    execute procedure sys_dbg('res RES_GET_GUEST_DATA$INT calculated value tariff_names = '||coalesce(:tariff_names, 'null'));

    execute procedure RES_GUESTDATA_CACHE$INT(:RESERV_DATA, :id_reserv_data, :board_names, :tariff_names, :packet_names, :vouchers_render);
  end
end
^

/* empty dependent procedure body */
/* Clear: MONITOR_ROOM_GANTT$HM for: RES_GET_INFO$RSV */
ALTER PROCEDURE MONITOR_ROOM_GANTT$HM(FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ID_ROOM INTEGER,
GFROM_DATE DATE,
IS_MOVED_FROM INTEGER,
GTO_DATE DATE,
IS_MOVED_TO INTEGER,
BUSY_GRP INTEGER,
OCCUPANT_ID INTEGER,
IN_SHARE SMALLINT,
ID_GROUP INTEGER,
ATTENTION_STATUS SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: MONITOR_ROOM_GANTT_OCCUPANT$HM for: RES_GET_INFO$RSV */
ALTER PROCEDURE MONITOR_ROOM_GANTT_OCCUPANT$HM(FROM_DATE DATE,
TO_DATE DATE,
REQUEST_OCCUPANT_ID INTEGER)
 RETURNS(ID_ROOM INTEGER,
GFROM_DATE DATE,
IS_MOVED_FROM INTEGER,
GTO_DATE DATE,
IS_MOVED_TO INTEGER,
BUSY_GRP INTEGER,
OCCUPANT_ID INTEGER,
IN_SHARE SMALLINT,
ID_GROUP INTEGER,
ATTENTION_STATUS SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: OCCUPANT_GET_INFO for: RES_GET_INFO$RSV */
ALTER PROCEDURE OCCUPANT_GET_INFO(ID_OCCUPANT INTEGER,
IN_BUSY_GRP INTEGER = null)
 RETURNS(BUSY_GRP INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
INFO VARCHAR(1024))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_SMART_LIST_OOS$INT for: RES_GET_INFO$RSV */
ALTER PROCEDURE ROOM_SMART_LIST_OOS$INT(FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ROOM_NAME VARCHAR(50),
DESCRIPTION VARCHAR(100),
PERIOD VARCHAR(100),
FREE_BASE INTEGER,
FREE_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
IS_CLEAN INTEGER,
FEATURES BLOB)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_SMART_LIST_SHARE$INT for: RES_GET_INFO$RSV */
ALTER PROCEDURE ROOM_SMART_LIST_SHARE$INT(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(50),
SUPPRESS_PRIVATE SMALLINT = 1)
 RETURNS(ROOM_NAME VARCHAR(50),
DESCRIPTION VARCHAR(255),
PERIOD VARCHAR(255),
FREE_BASE INTEGER,
FREE_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
FEATURES BLOB)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GET_INFO$RSV) */
ALTER PROCEDURE RES_GET_INFO$RSV(ID_RESERV_DETAIL INTEGER,
RETURN_BALANCE SMALLINT = 1,
RETURN_SHARE SMALLINT = 1,
RETURN_GEUSTDATA SMALLINT = 1)
 RETURNS(NUMBER VARCHAR(62),
AGENT_PROFILE_NAME VARCHAR(100),
ARRIVALS VARCHAR(255),
DEPARTURES VARCHAR(255),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
ID_ROOM INTEGER,
ROOM VARCHAR(60),
ID_ROOM_TYPE INTEGER,
ROOM_FEATURES BLOB,
GUESTS VARCHAR(255),
GUESTS_CNT INTEGER,
PERSON_PROFILE_NAME VARCHAR(150),
RATES VARCHAR(255),
BOARDS VARCHAR(255),
PACKETS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY VARCHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
BALANCE VARCHAR(255),
OPEN_CHARGES INTEGER,
CHECK_STATUS INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
NOTE VARCHAR(2000),
NOTE_GRP VARCHAR(255),
VOUCHER_RENDER VARCHAR(512),
ACC_ROUTING VARCHAR(255),
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
BUSY_GRP INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
GUEST_TYPE_COLOR INTEGER,
IS_CLEAN INTEGER,
ROOM_PRIVATE_STATUS TLOGICAL)
 AS
declare variable arrival varchar(20);
declare variable departure varchar(20);
declare variable rd_dbkey char(8);
declare variable no_use varchar(1024);
declare variable rd_adult_count integer;
declare variable rd_child_count integer;
declare variable groupname varchar(100);
declare variable virtual_room varchar(10);
declare variable earlycheckout_date date;
begin
  arrivals = '';
  departures = '';
  rates = '';
  NOTE_GRP = null;

  IS_CLEAN = 0;

  select AP.PROFILE_NAME, RD.ADULT_COUNT, RD.CHILD_COUNT,
         R.ID_ROOM, R.ROOM_NAME, coalesce(rd.VIRTUAL_ROOM, 'i'||RM.ID_ROOM), coalesce(R.ID_ROOM_TYPE, RM.ID_ROOM_TYPE, RD.ID_ROOM_TYPE),
         RD.CHECK_STATUS, PP.PROFILE_NAME || coalesce(' (' || GT.GUEST_TYPE_NAME || ')', ''),
         RD.FROM_DATE, RD.TO_DATE, RG.GROUP_NAME,
         RD.ID_GROUP, RD.ROOM_FEATURES, RD.COMMING_KIND, RD.LEAVING_KIND - 1,
         RD.NUMBER, RD.NOTE, RD.RDB$DB_KEY, RD.ID_HOTEL, RD.ACC_ROUTING,
         GT.GUEST_TYPE_COLOR, coalesce(r.IS_CLEAN, 1), g.EARLYCHECKOUT_DATE
  from   RESERV_DETAIL RD
         left outer join RESERV_GROUP RG on RG.ID_RESERV_GROUP = RD.ID_GROUP
         left outer join PROFILE AP on AP.ID_PROFILE = RD.ID_AGENT_PROFILE
         left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
         left outer join ROOM_MAP$EXC RM on RM.ID_ROOM = RD.ID_ROOM
         left outer join PROFILE PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
         left outer join PROFILE_PERSON PPp on PPp.ID_PROFILE = PP.ID_PROFILE
         left outer join GUEST_TYPE GT on GT.ID_GUEST_TYPE = PPp.ID_GUEST_TYPE
         left outer join GUEST G on g.ID_GUEST = rd.ID_TITULAR
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :agent_profile_name, :rd_adult_count, :rd_child_count,
         :id_room, :room, :virtual_room, :id_room_type,
         :check_status, :person_profile_name,
         :arrival_date, :departure_date, :groupname,
         :id_group, :room_features, :comming_kind, :is_late_departure,
         :number, :note, :rd_dbkey, :id_hotel, :acc_routing,
         :guest_type_color, :is_clean, :earlycheckout_date;


  ARRIVALS = iif(extract(year from current_date) = extract(year from :ARRIVAL_DATE),
               formatDate(:ARRIVAL_DATE, 'D;dd.mm')||' ('||(:DEPARTURE_DATE - :ARRIVAL_DATE)||')',
               formatDate(:ARRIVAL_DATE, 'D;dd.mm.yy')||' ('||(:DEPARTURE_DATE - ARRIVAL_DATE)||')');
  DEPARTURES = iif(extract(year from current_date) = extract(year from :DEPARTURE_DATE),
               formatDate(:DEPARTURE_DATE, 'D;dd.mm'),
               formatDate(:DEPARTURE_DATE, 'D;dd.mm.yy'));
  for
    select iif(extract(year from current_date) = extract(year from g.FROM_DATE),
               formatDate(g.FROM_DATE, 'D;dd.mm')||' ('||(G.TO_DATE - G.FROM_DATE)||')',
               formatDate(g.FROM_DATE, 'D;dd.mm.yy')||' ('||(G.TO_DATE - G.FROM_DATE)||')'),
           iif(extract(year from current_date) = extract(year from g.TO_DATE),
               formatDate(g.TO_DATE, 'D;dd.mm'),
               formatDate(g.TO_DATE, 'D;dd.mm.yy'))
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
           and ((g.FROM_DATE <> :ARRIVAL_DATE) or (g.TO_DATE <> :DEPARTURE_DATE))
    into   :arrival, :departure
  do begin
    if (:ARRIVALS not containing :arrival) then ARRIVALS = :ARRIVALS || ','||:arrival;
    if (:DEPARTURES not containing :departure) then DEPARTURES = :DEPARTURES || ','||:departure;
  end

  execute procedure RES_GET_PRICE$INT(:rd_dbkey, 'SECURITY')
  returning_values  :room_price, :room_currency, :room_price_details, :no_use, :no_use;

  if (coalesce(:return_balance,1)=1) then
    execute procedure RES_GET_BALLANCE$INT(:id_reserv_detail)
    returning_values  :balance, :no_use, :no_use, :open_charges, :no_use;

  if (:groupname <> '') then agent_profile_name = substring(coalesce(:agent_profile_name, '') || ' / ' || coalesce(:groupname, '') from 1 for 100);

  execute procedure RES_GET_ATTENTION_STATUS$INT(:arrival_date, :departure_date, :check_status, :id_hotel)
  returning_values  :attention_status;

  if (coalesce(:return_share,1)=1) then begin
    execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'RENDER', null)
    returning_values  :in_share, :no_use, :shares_preview;
    if (:IN_SHARE = 1) then ROOM = coalesce(:ROOM, :virtual_room);
  end

  if (coalesce(:return_geustdata,1)=1) then begin
    execute procedure RES_GET_GUEST_DATA$INT('DETAIL', :id_reserv_detail)
    returning_values  :boards, :rates, :packets, :voucher_render;
  end

  execute procedure RES_GET_ANNULSTATUS(:rd_dbkey)
  returning_values  :annul_status;

  guests = :rd_adult_count || ' + ' || :rd_child_count || ' ';
  guests_cnt = :rd_adult_count + :rd_child_count;

  if (:check_status > 1) then  busy_grp = 24;
  else busy_grp = 1;

  ROOM_PRIVATE_STATUS = 0;
  select cast(1 as smallint)
  from   SYSTEM_DATE_GET (:ID_HOTEL) sd
         join ROOM_MAGIC rm on rm.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                               and rm.ROOM_STATUS = 'PRIVATE'
                               and rm.BUSY_DATE = mindate(maxdate(:ARRIVAL_DATE, sd.SYSTEM_DATE), coalesce(:earlycheckout_date, :DEPARTURE_DATE) - 1)
  into   :ROOM_PRIVATE_STATUS;

  suspend;
end
^

/* Alter (RES_GUEST_SAVE_BOARD$RSV) */
ALTER PROCEDURE RES_GUEST_SAVE_BOARD$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_BOARD INTEGER)
 AS
declare variable id_reserv_detail integer;
declare variable old_id_board integer;
  declare variable action_text varchar(255);
  declare variable guest_name varchar(50);
  declare variable old_board_name varchar(50);
  declare variable new_board_name varchar(50);
begin
  ID_BOARD = :ID_BOARD;
  if (:ID_BOARD = -1) then begin
    -- default to booking board
    select rd.ID_BOARD
    from   GUEST g
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :ID_GUEST
    into   :ID_BOARD;
  end

  update GUEST_STAY GS
  set    gs.ID_BOARD = :ID_BOARD
  where  gs.ID_GUEST = :ID_GUEST
         and gs.FOR_DATE = :FOR_DATE
  returning old.id_board
  into      :old_id_board;

  if (:old_id_board is distinct from :ID_BOARD) then begin
    select g.ID_RESERV_DETAIL, gc.GUEST_NAME1
    from   GUEST G
           left join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
    where  g.ID_GUEST = :ID_GUEST
    into   :id_reserv_detail, :guest_name;

    select M.NAME
    from   MEALS M
    where  M.ID_BOARD = :old_id_board
    into   :old_board_name;

    select M.NAME
    from   MEALS M
    where  M.ID_BOARD = :ID_BOARD
    into   :new_board_name;

    action_text = f_character(29) || :guest_name
                  || f_character(28) || formatdate(:for_date, 'd;dd.mm.yyyy')
                  || f_character(28) || coalesce(:new_board_name, '')
                  || f_character(28) || coalesce(:old_board_name, '');
    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'GUEST_DIFF_BOARD', :action_text);
  end
end
^

/* Alter (RES_LOAD) */
ALTER PROCEDURE RES_LOAD(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_AGENT_PROFILE INTEGER,
AGENT_PROFILE_NAME VARCHAR(100),
ID_PERSON_PROFILE INTEGER,
PERSON_PROFILE_NAME VARCHAR(100),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_RES_ROOM_TYPE INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
BOARD_NAMES VARCHAR(255),
TARIFF_NAMES VARCHAR(255),
PACKET_NAMES VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100),
VOUCHER_RENDER VARCHAR(512),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
TRANSFER_RENDER VARCHAR(255),
CODE_FIRST_FOOD_RENDER VARCHAR(255),
IS_LATE_DEPARTURE INTEGER,
CODE_FIRST_FOOD VARCHAR(20),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
I_SPECIAL_TREATMENT VARCHAR(255),
COMMING_KIND SMALLINT,
IS_VIP SMALLINT,
HAS_GUEST_LIST SMALLINT,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
AGENT_ACCOUNT_NAME VARCHAR(100),
IS_DIFFERENT_VOUCHER INTEGER,
IS_DIFFERENT_OTHER INTEGER,
IS_DIFFERENT_BOARD INTEGER,
IS_DIFFERENT_TARIFF INTEGER,
IS_CUSTOM_PRICE INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
ID_RATE INTEGER,
ROOM_FEATURES BLOB,
ID_GROUP INTEGER,
NUMBER VARCHAR(62),
CHECK_STATUS INTEGER,
BALANCE VARCHAR(255),
HAS_CHARGES INTEGER,
OPEN_CHARGES INTEGER,
OPEN_DEPOSIT INTEGER,
RECIEVED_DEPOSITS VARCHAR(255),
ROOM_HISTORY VARCHAR(200),
TAR_ROOM_TYPE VARCHAR(100),
ID_HK_PLAN INTEGER,
COUNTRIES VARCHAR(812),
IS_RESGRP INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
IS_ANUL INTEGER,
NOTE VARCHAR(2000),
IS_DIFFERENT_ROOM_TYPE SMALLINT,
IS_DIFFERENT_STAY_TYPE SMALLINT,
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
GROUP_NAME VARCHAR(50),
ID_HOTEL INTEGER,
NOTE_REMINDERS VARCHAR(50),
IS_DIFFERENT_PRICE INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ID_EATING_OBJECT TYPE OF ID_REF,
ROOM_PRIVATE_STATUS TLOGICAL)
 AS
declare variable rd_dbkey char(8);
  declare variable reason_of_anul varchar(100);
  declare variable shared_resvations varchar(1024);
  declare variable virtual_room varchar(10);
  declare variable packet_item_ids varchar(255);
  declare variable earlycheckout_date date;
begin
  select RD.RDB$DB_KEY, RD.ID_AGENT_PROFILE, PA.PROFILE_NAME,
         RD.ID_NOM_MARKET_SEGMENT, RD.ID_NOM_SOURCE_CODE, RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_HEAR_REASON, RD.ID_NOM_COME_REASON,
         RD.ADULT_COUNT, RD.CHILD_COUNT, RD.CUSTOM_PRICE, RD.CUSTOM_CURRENCY,
         RD.IS_VIP, RD.CHECK_STATUS, RD.ID_AGENT_ACCOUNT,
         RD.ACC_ROUTING, RD.ID_PERSON_PAYMENT,
         RD.ID_AGENT_PAYMENT, RD.ID_PERSON_PROFILE, PP.PROFILE_NAME, RD.ID_GROUP,
         RD.COMMING_KIND, RD.I_SPECIAL_TREATMENT, ACC.ACCOUNT_NAME, RD.ROOM_FEATURES, RD.ID_HK_PLAN,
         RD.NUMBER, RD.IS_ANUL, RD.REASON_OF_ANUL, RD.NOTE,
         RD.HAS_DIFFERENT_VOUCHERS, RD.HAS_DIFFERENT_OTHER,
         RD.HAS_DIFFERENT_BOARD, RD.HAS_DIFFERENT_TARIFF, RD.HAS_DIFFERENT_TYPE_STAY, RD.HAS_DIFFERENT_ROOM_TYPE,
         RD.ID_HOTEL, RG.GROUP_NAME, RD.ID_RATE, RD.NOTE_REMINDERS, RD.has_different_price,
         RD.ID_GUARANTEE_POLICY, RD.BLOCK_CC, rd.ID_EATING_OBJECT, g.EARLYCHECKOUT_DATE
  from   RESERV_DETAIL RD
         left outer join RESERV_GROUP RG on RG.ID_RESERV_GROUP = RD.ID_GROUP
         left outer join PROFILE PA on PA.ID_PROFILE = RD.ID_AGENT_PROFILE
         left outer join PROFILE PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
         left outer join ACCOUNT ACC on ACC.ID_ACCOUNT = RD.ID_AGENT_ACCOUNT
         left outer join GUEST G on g.ID_GUEST = rd.ID_TITULAR
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :id_agent_profile, :agent_profile_name,
         :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason,
         :adult_count, :child_count, :custom_price, :custom_currency,
         :is_vip, :check_status, :id_agent_account, :acc_routing, :id_person_payment,
         :id_agent_payment, :id_person_profile, :person_profile_name, :id_group,
         :comming_kind, :i_special_treatment, :agent_account_name, :room_features, :id_hk_plan,
         :number, :is_anul, :reason_of_anul, :note,
         :is_different_voucher, :is_different_other,
         :is_different_board, :is_different_tariff, :is_different_stay_type, :is_different_room_type,
         :id_hotel, :group_name, :id_rate, :note_reminders, :is_different_price,
         :id_guarantee_policy, :block_cc, :id_eating_object, :earlycheckout_date;

  is_resgrp = iif(:id_group is not null, 1, 0);

  if ((:is_different_price = 1) or (:custom_price is not null) ) then
    IS_CUSTOM_PRICE = 1;
  else
    IS_CUSTOM_PRICE = 0;

  execute procedure RES_GET_PRICE$INT(:rd_dbkey, 'SECURITY')
  returning_values  :room_price, :room_currency, :room_price_details,
                    :deposit_required, :deposit_required_currency;

  execute procedure RES_GET_BALLANCE$INT(:id_reserv_detail)
  returning_values  :balance, :recieved_deposits, :has_charges, :open_charges, :open_deposit;

  execute procedure RES_GET_STATIC_DATA$INT(:rd_dbkey)
  returning_values  :arrival_date, :departure_date, :voucher_num, :voucher_date,
                    :voucher_text, :voucher2_num, :voucher2_date, :transfer_in_time,
                    :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :is_late_departure, :code_first_food;

  execute procedure RES_GET_DYNAMIC_DATA$INT(:rd_dbkey, 1)
  returning_values  :id_res_room_type, :id_room_type, :id_room, :id_board,
                    :id_tariff, :packet_item_ids, :room_name, :room_history, :tar_room_type, :virtual_room;

  execute procedure RES_GET_GUEST_DATA$INT('DETAIL', :id_reserv_detail)
  returning_values  :board_names, :tariff_names, :packet_names, :voucher_render;

  execute procedure RES_GET_GUEST_DATA2$INT(:id_reserv_detail)
  returning_values  :has_guest_list, :countries, :transfer_render, :code_first_food_render;

  execute procedure RES_GET_ATTENTION_STATUS$INT(:arrival_date, :departure_date, :check_status, :id_hotel)
  returning_values  :attention_status;

  execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'RENDER', null)
  returning_values  :in_share, :shared_resvations, :shares_preview;
  if (:IN_SHARE = 1) then ROOM_NAME = coalesce(:ROOM_NAME, :virtual_room);

  annul_status = :is_anul;
  if (:reason_of_anul = 'EXPIRE') then annul_status = 2;
  execute procedure sys_dbg('res RES_LOAD comming_kind = '||coalesce(:comming_kind, 'null'));

  ROOM_PRIVATE_STATUS = 0;
  select cast(1 as smallint)
  from   SYSTEM_DATE_GET (:ID_HOTEL) sd
         join ROOM_MAGIC rm on rm.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                               and rm.ROOM_STATUS = 'PRIVATE'
                               and rm.BUSY_DATE = mindate(maxdate(:ARRIVAL_DATE, sd.SYSTEM_DATE), coalesce(:earlycheckout_date, :DEPARTURE_DATE) - 1)
  into   :ROOM_PRIVATE_STATUS;

  suspend;
end
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE_RECALC$INT for: RES_RECALC$INT */
ALTER PROCEDURE RES_FINALIZE_RECALC$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_RECALC$RSV for: RES_RECALC$INT */
ALTER PROCEDURE RES_RECALC$RSV(ID_RESERV_DETAIL INTEGER,
FORCE_POSTING SMALLINT = null)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(ID_TAR_CALC INTEGER,
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
  declare variable reserv_posting_disabled smallint;
  declare variable warn_code integer;
begin
  --  Razpiswa cenata na staia, kakto i price_detailite.

  execute procedure TAR_CALC_EVAL_ALL$INT(:ID_TAR_CALC)
  returning_values  :ERR_CODE, :ERR_TEXT;

  if (:ERR_CODE = 0) then execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

  for
    select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, rd.IS_POSTING_STOPPED,
           coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
           coalesce(max((select first 1 AP.IS_BASE
                         from   GUEST G
                                join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                         where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (it`s possible)
    from   TAR_CALC_INPUT$TMP TI
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
           join TARIFA t on t.ID_TARIFA = rd.ID_RATE
    where  ti.ID_TAR_CALC = :ID_TAR_CALC
    group by 1, 2, 3, 4, 5, 6
    into   :id_reserv_detail, :check_status, :is_posting_stopped,
           :room_currency, :id_hotel, :is_anul, :has_postings
  do begin
    reserv_posting_disabled = iif(:is_posting_stopped = 1 and :has_postings = 0, 1, 0);

    if (:ERR_CODE <> 0) then begin
      -- price calculation error handling  !!!!!
      if (:reserv_posting_disabled = 1) then begin
        -- set price to null, posting is disabled
        update RESERV_DETAIL RD
        set    RD.ROOM_PRICE = null,
               RD.ROOM_CURRENCY = null,
               RD.ROOM_PRICE_DETAILS = null,
               RD.LAST_ID_TAR_CALC = null
        where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
      end else begin
        -- exit on error in price calculation - cannot make valid posts
        EXIT;
      end
    end else begin
      room_price = 0;
      room_price_details = '';
    
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);
  
      if (:reserv_posting_disabled = 0 and ((coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1))) then begin
        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);
      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;
  
        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end
  
      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end

  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;

  if (:ERR_CODE <> 0) then begin
    execute procedure SYSTEM_WARNING_ADD(:ERR_CODE, :ERR_TEXT)
    returning_values :warn_code;
    ERR_CODE = 0;
    ERR_TEXT='';
  end
end
^

/* Alter (RES_RECALC$INT) */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable num_prefix varchar(20);
  declare variable number_1 varchar(20);
begin
  /* CALLER_KIND = {NORMAL, FORCED} */
  err_code = 0;
  /* 1. GET DATA */
  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL, rd.NUMBER_1
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :check_status, :id_reserv_detail, :number_1;

  if (:check_status = 1) then begin
    -- CHECKED OUT
    select sn.LEADING_PART
    from   SYSTEM_NUMERATOR SN
    where  sn.ID_NUMERATOR = 0
    into   :num_prefix;

    if (trim('.' from coalesce(:num_prefix, '')) = coalesce(:number_1, '')) then
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_MINE');
    else
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_ELSE');

    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :id_guest
    do begin
      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'MANUAL_EDIT_DATA', '');
    end
  end
  /* 2. FIND DEPENDANT GUESTS AND THEIR TARIFFS */
  --execute procedure sys_dbg('calc RES_RECALC$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

  ID_TAR_CALC = gen_id(gen_id_tar_calc, 1);
  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NONE');

  -- 3. UPDATE ROOM PRICE and REPOST ALL AFFECTED BOOKINGS
  execute procedure RES_TAR_CALC_FINALIZE$INT (:ID_TAR_CALC, :CALLER_KIND, :FORCE_POSTING)
  returning_values (:ERR_CODE, :ERR_TEXT);
end
^

/* Alter (RES_RECALC$RSV) */
ALTER PROCEDURE RES_RECALC$RSV(ID_RESERV_DETAIL INTEGER,
FORCE_POSTING SMALLINT = null)
 AS
declare variable id_tar_calc integer;
declare variable err_text varchar(255);
  declare variable err_code integer;
  declare variable rd_dbkey char(8);
begin
  -- FORCED, user activated recalculation
  execute procedure RIGHTS_CHECK_GRANTED$INT ('GUEST_RECALC_POST');

  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_RECALC$INT(:rd_dbkey, 'FORCED', :FORCE_POSTING)
  returning_values  :err_code, :err_text, :id_tar_calc;
  if (:err_code < 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'FORCED_RECALC', null);

end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_BOARD$RSV for: RES_SAVE_BOARD$INT */
ALTER PROCEDURE RES_SAVE_BOARD$RSV(ID_RESERV_DETAIL INTEGER,
ID_BOARD INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_MODIFY_BOARD$RSV for: RES_SAVE_BOARD$INT */
ALTER PROCEDURE RESMULTI_MODIFY_BOARD$RSV(ID_RESERV_DETAIL INTEGER,
ID_BOARD INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: UPDATE_BOOKING$EXC for: RES_SAVE_BOARD$INT */
ALTER PROCEDURE UPDATE_BOOKING$EXC(BOOKING_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE INTEGER,
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA_ID INTEGER,
POSTING_ROUTING VARCHAR(20),
ID_AGENT_ACCOUNT INTEGER,
RATE_ID INTEGER,
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD_CODE /* TFOOD_CODE */ VARCHAR(20),
ARRANGER_PROFILE_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_BOARD$INT) */
ALTER PROCEDURE RES_SAVE_BOARD$INT(RD_DBKEY CHAR(8),
ID_BOARD INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_guest integer;
  declare variable old_id_board integer;
  declare variable action_text varchar(255);
  declare variable old_board varchar(30);
  declare variable new_board varchar(30);
begin
  id_board = :ID_BOARD;
  select RD.ID_RESERV_DETAIL, RD.ID_BOARD, TH.NAME
  from   RESERV_DETAIL RD
         left outer join MEALS TH on TH.ID_BOARD = RD.ID_BOARD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail, :old_id_board, :old_board;

  update RESERV_DETAIL RD
  set    RD.ID_BOARD = :id_board,
         RD.HAS_DIFFERENT_BOARD = 0
  where  RD.RDB$DB_KEY = :rd_dbkey;

  for
    select G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_guest
  do begin
    update GUEST_STAY GS
    set    GS.ID_BOARD = :id_board
    where  GS.ID_GUEST = :id_guest;
  end

  execute procedure RES_GUESTDATA_INVALIDATE$INT(:rd_dbkey);

  if (:old_id_board is distinct from :id_board) then begin
    select TH.NAME
    from   MEALS TH
    where  TH.ID_BOARD = :id_board
    into   :new_board;

    action_text = f_character(29) || coalesce(:old_board, '') || f_character(28) || coalesce(:new_board, '');
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'BOARD_CHANGED', :action_text);
  end
end
^

/* Alter (RES_SAVE_BOARD$RSV) */
ALTER PROCEDURE RES_SAVE_BOARD$RSV(ID_RESERV_DETAIL INTEGER,
ID_BOARD INTEGER)
 AS
declare variable rd_dbkey char(8);
declare variable err_code integer;
declare variable err_text varchar(255);
begin

  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_SAVE_BOARD$INT(:rd_dbkey, :id_board);
   
  execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');

end
^

/* Alter (RES_SAVE_FINALIZE$RSV) */
ALTER PROCEDURE RES_SAVE_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_RESERV_DATE TYPE OF TDATE)
 AS
declare variable rd_dbkey char(8);
  declare variable busy_group_source integer;
  declare variable res_edit_status varchar(255);
  declare variable err_code integer;
  declare variable tmp_err_text varchar(255);
  declare variable id_hotel integer;
begin
  execute procedure sys_dbg('occ RES_SAVE_FINALIZE$RSV enter');

  select RD.RDB$DB_KEY, iif(RD.CHECK_STATUS = 1, 24, 1), rd.RES_EDIT_STATUS, rd.ID_HOTEL
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :busy_group_source, :res_edit_status, :id_hotel;

  if (:res_edit_status containing 'ADDGUEST') then begin
    execute procedure RES_GUEST_FINALIZE$RSV (:ID_RESERV_DETAIL, 0)
    returning_values (:warn_code);
  end

  execute procedure OCCUPANCY_ROOMS_CHECK$INT(:rd_dbkey, :busy_group_source)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :WARN_CODE;
  --if (:share_err_code <> 0) then err_code = 0;      -- offer share entering
  --if (:share_err_code = 1) then share_err_code = 0; -- all shares are known

  execute procedure sys_dbg('occup RES_SAVE_FINALIZE$RSV share_err_code = '||coalesce(:share_err_code, 'null'));

  execute procedure RES_FINALIZE_CLEAR$INT(:rd_dbkey, :id_reserv_detail);

  delete from RESERV_STAY$TMP t
  where  t.id_session = RDB$GET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION', null);  -- Excplicitly set to null !!!

  err_code = 0;
  select first 1 RE.ERR_CODE, RE.ERR_TEXT
  from   RESERV_ERROR RE
  where  RE.ID_RESERV_DETAIL = :id_reserv_detail
  into   :err_code, :tmp_err_text;

  if (:err_code <> 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || :tmp_err_text;

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :NEW_RESERV_DATE;
end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ROOM$EXC for: RES_SAVE_ROOM$RSV */
ALTER PROCEDURE RES_SAVE_ROOM$EXC(RD_DBKEY CHAR(8),
ID_RES_ROOM_TYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(250),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_ROOM$RSV) */
ALTER PROCEDURE RES_SAVE_ROOM$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
ID_RES_ROOM_TYPE INTEGER,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(255),
SPLIT_ON_CHECKIN SMALLINT,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
declare variable tmp_warn_code integer;
begin
  WARN_CODE = null;
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, :id_res_room_type, :TAR_OPTION, :is_auto_staytype)
  returning_values (:WARN_CODE);

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 1)
    returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :tmp_warn_code;
  end
  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

  update RESERV_DETAIL R
  set    r.SPLIT_ON_CHECKIN = :split_on_checkin,
         r.ID_HK_PLAN = :ID_HK_PLAN,
         r.I_SPECIAL_TREATMENT = :I_SPECIAL_TREATMENT,
         r.ROOM_FEATURES = :ROOM_FEATURES
  where  r.ID_RESERV_DETAIL = :id_reserv_detail;
end
^

/* Alter (RES_SAVE_STAY$RSV) */
ALTER PROCEDURE RES_SAVE_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure sys_dbg('res RES_SAVE_STAY$RSV comming_kind = '||coalesce(:comming_kind, 'null'));
  execute procedure sys_dbg('res RES_SAVE_STAY$RSV is_late_departure = '||coalesce(:is_late_departure, 'null'));

  execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :departure_date, :is_late_departure, :comming_kind);

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 1)
    returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;
    execute procedure sys_dbg('res RES_SAVE_STAY$RSV share_err_code = '||coalesce(:share_err_code, 'null'));
  end
  --
end
^

/* empty dependent procedure body */
/* Clear: APPLY_BOOKING_STATUS$EXC for: RES_SET_CHECKIN$INT */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_CHECKIN$RSV for: RES_SET_CHECKIN$INT */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SET_CHECKIN$INT) */
ALTER PROCEDURE RES_SET_CHECKIN$INT(RD_DBKEY CHAR(8))
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
begin
  select r.ID_RESERV_DETAIL
  from   RESERV_DETAIL R
  where  r.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail;

  execute procedure ROOM_MAGIC_CLEAR(:id_reserv_detail);   -- ?!?

  execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, 0);

  for
    select G.RDB$DB_KEY
    from   GUEST G
    where  g.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :g_dbkey
  do begin
    execute procedure GUEST_SET_STATUS$INT(:g_dbkey, 0);
  end

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;
end
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_CO_RENTERS$INT for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_CO_RENTERS$INT(VIRTUAL_ID_ROOM INTEGER,
NEW_ID_ROOM INTEGER,
INIT_ID_RES_DETAIL INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_FAST$RSV for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_FAST$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_MULTI$RSV for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_MULTI$RSV(OPERATION VARCHAR(20),
FROM_ROOM VARCHAR(20),
SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_SHARED$RSV for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_SHARED$RSV(SELECTION_ID INTEGER,
ROOM_NAME VARCHAR(10))
 RETURNS(VIRTUAL_ROOM VARCHAR(10),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SET_ROOM$INT) */
ALTER PROCEDURE RES_SET_ROOM$INT(RD_DBKEY CHAR(8),
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
declare variable tmp_warn_code integer;
begin
  WARN_CODE = null;
  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option)
  returning_values (:WARN_CODE);

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :SHARE_ERR_TEXT, :share_transaction_id, :tmp_warn_code;

  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
end
^

/* Alter (RES_SET_ROOM_CO_RENTERS$INT) */
ALTER PROCEDURE RES_SET_ROOM_CO_RENTERS$INT(VIRTUAL_ID_ROOM INTEGER,
NEW_ID_ROOM INTEGER,
INIT_ID_RES_DETAIL INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
declare variable shared_rd_dbkey char(8);
declare variable shared_booking_ids varchar(255);
declare variable id_reserv_detail integer;
declare variable tmp_share_err_code integer;
declare variable tmp_share_err_text varchar(255);
begin
  -- distribute the same room to shared bookings

  if (coalesce(:NEW_ID_ROOM, 0) < 0) then exit; -- only for real rooms!1
  SHARE_ERR_CODE = 0;
  shared_booking_ids = ',' || :INIT_ID_RES_DETAIL || ',';
  for
    select vrd.RDB$DB_KEY, vrd.ID_RESERV_DETAIL
    from   RESERV_DETAIL VRD
    where  vrd.ID_ROOM = :VIRTUAL_ID_ROOM
           and vrd.IS_ANUL = 0
           and vrd.ID_RESERV_DETAIL is distinct from :INIT_ID_RES_DETAIL
    into   :shared_rd_dbkey, :id_reserv_detail
  do begin
    shared_booking_ids = :shared_booking_ids || :id_reserv_detail || ',';

    execute procedure RES_SET_ROOM$INT (:shared_rd_dbkey, :NEW_ID_ROOM, :TAR_OPTION)
    returning_values  :WARN_CODE, :share_transaction_id, :tmp_share_err_code, :tmp_share_err_text;

    if (:SHARE_ERR_CODE = 0 and :tmp_share_err_code < 0) then begin
      -- check for share with other bookings
      if (exists (select rs.ID_RESERV_DETAIL
                      from   ROOMS_SHARE rs
                      where  rs.MARK_TRANSACTION = :SHARE_TRANSACTION_ID
                             and :shared_booking_ids not containing ','||rs.ID_RESERV_DETAIL||','
                             and rs.IS_EX_SHARE = 0)) then
      begin
        SHARE_ERR_CODE = :tmp_share_err_code;
        SHARE_ERR_TEXT = :tmp_share_err_text;
      end
    end
  end 
end
^

/* Alter (RES_SET_ROOM_FAST$RSV) */
ALTER PROCEDURE RES_SET_ROOM_FAST$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable old_id_room integer;
  declare variable virtual_room varchar(10);
  declare variable rd_dbkey char(8);
  declare variable tmp_warn_code integer;
  declare variable tmp_share_err_code integer;
  declare variable tmp_share_err_text varchar(255);
begin

  select RD.ID_ROOM, rd.VIRTUAL_ROOM, rd.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_id_room, :virtual_room, :rd_dbkey;

  execute procedure RES_SET_ROOM$INT (:rd_dbkey, :ID_ROOM, :TAR_OPTION)
  returning_values (:warn_code, :share_transaction_id, :share_err_code, :ERR_TEXT);

  if (:virtual_room is not null and :old_id_room < 0) then begin
    execute procedure RES_SET_ROOM_CO_RENTERS$INT (:old_id_room, :ID_ROOM, :ID_RESERV_DETAIL, :TAR_OPTION)
    returning_values (:tmp_warn_code, :share_transaction_id, :tmp_share_err_code, :tmp_share_err_text);
    WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
    SHARE_ERR_CODE = coalesce(:SHARE_ERR_CODE, :tmp_share_err_code);
    ERR_TEXT = coalesce(:ERR_TEXT, :tmp_share_err_text);
  end
end
^

/* Alter (RES_SET_ROOM_MULTI$RSV) */
ALTER PROCEDURE RES_SET_ROOM_MULTI$RSV(OPERATION VARCHAR(20),
FROM_ROOM VARCHAR(20),
SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable cnt_requested integer;
  declare variable cnt_old_room integer;
  declare variable cnt_found integer;
  declare variable is_already_planned integer;
  declare variable is_satisfied integer;
  declare variable new_id_room integer;
  declare variable current_id_room integer;
  declare variable id_res_room_type integer;
  declare variable room_requirements blob sub_type 1 segment size 100;
  declare variable from_date date;
  declare variable to_date date;
  declare variable action_text varchar(255);
  declare variable is_early_arrival smallint;
  declare variable is_late_departure smallint;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable id_reserv_detail integer;
  declare variable tmp_warn_code integer;
  declare variable min_beds integer;
  declare variable virtual_room varchar(10);
  declare variable share_err_text varchar(255);
begin
  /* offer_method :
  ||     0 - NUMBER desc,
  ||     1 - NUMBER asc,
  ||     2 - DAYS FREE(MAX OCCUPANCY),
  ||     3 - FILING FACTOR(EQUAL ROOM USAGE)
  */
  warn_code = null;

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'set_number_asc, set_number_desc, set_max_occupancy, set_max_usage');

  cnt_requested = 0;
  cnt_old_room = 0;
  cnt_found = 0;
  for
    select RD.RDB$DB_KEY, rd.ID_RESERV_DETAIL, rd.ID_ROOM, rd.VIRTUAL_ROOM, RD.ID_ROOM_TYPE, RD.ROOM_FEATURES,
           RD.FROM_DATE, RD.TO_DATE, iif(rd.COMMING_KIND = 0, 1, 0), iif(rd.LEAVING_KIND = 2, 1, 0),
           rd.ADULT_COUNT + rd.CHILD_COUNT
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
           and RD.IS_ANUL = 0
    into   :rd_dbkey, :id_reserv_detail, :current_id_room, :virtual_room, :id_res_room_type, :room_requirements,
           :from_date, :to_date, :is_early_arrival, :is_late_departure, :min_beds
  do begin
    cnt_requested = :cnt_requested + 1;
    new_id_room = null;
    if (:current_id_room < 0) then begin
      if (:virtual_room is not null) then begin
        -- has related bookings with shared virtual room
        -- get cumulative stay for all shared bookings
        select min(vrd.FROM_DATE), min(vrd.FROM_DATE) - min(vrd.FROM_DATE - iif(vrd.COMMING_KIND = 0, 1, 0)),
               max(vrd.TO_DATE), max(vrd.TO_DATE + iif(vrd.LEAVING_KIND = 2, 1, 0)) - max(vrd.TO_DATE),
               sum(vrd.ADULT_COUNT + vrd.CHILD_COUNT)
        from   RESERV_DETAIL VRD
        where  vrd.ID_ROOM = :current_id_room
               and vrd.IS_ANUL = 0
        into   :from_date, :is_early_arrival, :to_date, :is_late_departure, :min_beds;
      end
      -- from_date and to_date are arrival and departure date of reservation,
      -- not first and last accomodation dates !!! this is need to check early arrivals and late departures
      execute procedure ROOM_PICKUP$INT(:id_res_room_type, :from_date, :to_date,
              :is_early_arrival, :is_late_departure,:operation, :from_room, :room_requirements, :min_beds)
      returning_values  :new_id_room;  -- offered room

      if (:new_id_room is not null) then begin
        is_satisfied = 1;
        select R.ROOM_NAME
        from   ROOMS R
        where  r.ID_ROOM = :new_id_room
        into   :action_text;

        execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'ROOM_SET_AUTO', :action_text);

        execute procedure RES_SET_ROOM$INT (:rd_dbkey, :new_id_room, 'nrttAsIs')
        returning_values (:tmp_warn_code, :share_transaction_id, :share_err_code, :share_err_text);
        if (:share_err_code < 0) then exception BOOKING_EXCEPTION 'Unallowable share!!!';
        WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

        if (:virtual_room is not null) then begin
          -- distribute the same room to shared bookings
          execute procedure RES_SET_ROOM_CO_RENTERS$INT (:current_id_room, :new_id_room, :id_reserv_detail, 'nrttAsIs')
          returning_values (:tmp_warn_code, :share_transaction_id, :share_err_code, :share_err_text);
          if (:share_err_code < 0) then exception BOOKING_EXCEPTION 'Unallowable share!!!';
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
        end
      end

    end else begin
      is_already_planned = 1;
    end

    cnt_old_room = :cnt_old_room + :is_already_planned;
    cnt_found = :cnt_found + :is_satisfied;

    when exception BOOKING_EXCEPTION do begin
      -- nothing, skip this booking
    end
  end

  if ((:cnt_found + :cnt_old_room) < :cnt_requested) then begin
    execute procedure SYSTEM_WARNING_ADD(-3, f_character(29)||:cnt_found||f_character(28)||:cnt_requested)
    returning_values  :warn_code;
  end
end
^

/* Alter (RES_SET_ROOM_SHARED$RSV) */
ALTER PROCEDURE RES_SET_ROOM_SHARED$RSV(SELECTION_ID INTEGER,
ROOM_NAME VARCHAR(10))
 RETURNS(VIRTUAL_ROOM VARCHAR(10),
WARN_CODE INTEGER)
 AS
declare variable r_dbkey char(8);
  declare variable is_anul integer;
  declare variable shared_id_room integer;
  declare variable current_id_room integer;
  declare variable tmp_warn_code integer;
  declare variable share_trans integer;
  declare variable share_err_code integer;
  declare variable id_hotel integer;
  declare variable cnt_hotels integer;
  declare variable id_room integer;
  declare variable res_counter integer;
  declare variable min_departure date;
  declare variable max_arrival date;
  declare variable share_err_text varchar(255);
begin
  VIRTUAL_ROOM = null;
  select min(r.ID_HOTEL), count(distinct r.ID_HOTEL),
         min(r.TO_DATE), max(r.FROM_DATE)
  from   RESERV_DETAIL R
  where  R.SELECTION_ID = :SELECTION_ID
  into   :id_hotel, :cnt_hotels, :min_departure, :max_arrival;

  if (:cnt_hotels > 1) then exception BOOKING_EXCEPTION '-1035';
  if (:min_departure <= :max_arrival) then exception BOOKING_EXCEPTION '-1037';

  if (:ROOM_NAME is not null) then begin
    execute procedure ROOM_GET_BY_NAME(:ROOM_NAME, :id_hotel)
    returning_values (:id_room);
    shared_id_room = :ID_ROOM;
  end else begin
    id_room = null;
    shared_id_room = gen_id(DETAIL_WITHOUT_ROOMING_LIST, -1);
    VIRTUAL_ROOM = gen_id(GEN_VIRTUAL_ROOM, 1);
  end

  res_counter = 0;
  for
    select r.RDB$DB_KEY, r.IS_ANUL, r.ID_ROOM
    from   RESERV_DETAIL R
    where  R.SELECTION_ID = :SELECTION_ID
    into   :r_dbkey, :is_anul, :current_id_room
  do begin
    res_counter = :res_counter + 1;
    if (:is_anul = 1) then
      exception BOOKING_EXCEPTION '-1036';

    if (:current_id_room > 0 and :ID_ROOM is null) then
      exception BOOKING_EXCEPTION '-1034';

    execute procedure RES_SET_ROOM$INT(:r_dbkey, :shared_id_room, 'nrttAsIs')
    returning_values  :tmp_warn_code, :share_trans, :share_err_code, :share_err_text;
    WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
  end

  if (:VIRTUAL_ROOM is not null and :share_trans is not null) then begin
    update RESERV_DETAIL RD
    set    rd.VIRTUAL_ROOM = '<'||:VIRTUAL_ROOM||'>'
    where  rd.ID_ROOM = :shared_id_room;
  end
end
^

/* Alter (RES_SET_STATUS$RSV) */
ALTER PROCEDURE RES_SET_STATUS$RSV(SELECTION_ID INTEGER,
CHECK_STATUS SMALLINT)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  if (:CHECK_STATUS >= 0) then exception BOOKING_EXCEPTION 'Can not set status ''CHECKED IN'' or ''CHECKED OUT'' manually!';

  for
    select RD.RDB$DB_KEY
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :rd_dbkey
  do begin
    execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, :check_status);

    execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
    returning_values  :warn_code;
  end

end
^

/* Alter (RES_SET_STAY$RSV) */
ALTER PROCEDURE RES_SET_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable is_late_departure integer;
  declare variable comming_kind integer;
begin
  select RD.COMMING_KIND, RD.LEAVING_KIND - 1, RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :comming_kind, :is_late_departure, :rd_dbkey;

  execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :departure_date, :is_late_departure, :comming_kind);

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 1)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

end
^

/* empty dependent procedure body */
/* Clear: RES_CHECKIN_MULTI$RSV for: RES_SPLIT$RSV */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT_MULTI$RSV for: RES_SPLIT$RSV */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SPLIT$RSV) */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
declare variable rd_dbkey_old char(8);
  declare variable rd_dbkey_new char(8);
  declare variable id_guest integer;
  declare variable warn_code integer;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;

  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable check_status integer;
  declare variable arrival_date date;
  declare variable departure_date date;
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable id_room_type integer;
  declare variable id_room integer;
  declare variable id_board integer;
  declare variable id_tariff integer;
  declare variable custom_price numeric(15,4);
  declare variable custom_currency char(3);
  declare variable voucher_num varchar(30);
  declare variable voucher_date date;
  declare variable voucher_text varchar(30);
  declare variable voucher2_num varchar(30);
  declare variable voucher2_date date;
  declare variable transfer_in_time time;
  declare variable transfer_in_note varchar(255);
  declare variable transfer_out_time time;
  declare variable transfer_out_note varchar(255);
  declare variable comming_kind integer;
  declare variable is_late_departure integer;
  declare variable is_vip integer;
  declare variable country_code varchar(20);
  declare variable code_first_food tfood_code;
  declare variable i_special_treatment varchar(255);
  declare variable id_nom_market_segment integer;
  declare variable id_nom_source_code integer;
  declare variable id_nom_channel_code integer;
  declare variable id_nom_hear_reason integer;
  declare variable id_nom_come_reason integer;
  declare variable id_agent_account integer;
  declare variable acc_routing varchar(50);
  declare variable id_person_payment integer;
  declare variable id_agent_payment integer;
  declare variable room_features blob sub_type 1 segment size 80;
  declare variable id_hk_plan integer;
  declare variable id_group integer;
  declare variable id_hotel integer;
  declare variable note varchar(2000);
  declare variable note_reminders varchar(50);
  declare variable guarantee_deposit numeric(15,4);
  declare variable guarantee_currency char(3);
  declare variable id_titular integer;
  declare variable id_profile_data integer;
  declare variable id_acc_template_person integer;
  declare variable number_1 varchar(20);
  declare variable number_2 varchar(20);
  declare variable new_res_number varchar(62);
  declare variable g_dbkey char(8);
  declare variable is_child integer;
  declare variable id_guarantee_policy integer;
  declare variable block_cc varchar(255);
  declare variable virtual_room varchar(10);
  declare variable err_text varchar(255);
  declare variable is_posting_stopped integer;
  declare variable id_eating_object integer;
begin
  select RD.RDB$DB_KEY, RD.ID_AGENT_PROFILE, RD.CHECK_STATUS, RD.FROM_DATE, RD.TO_DATE,
         RD.ADULT_COUNT, RD.CHILD_COUNT, RD.ID_ROOM_TYPE, RD.ID_ROOM, RD.ID_BOARD, RD.ID_RATE,
         RD.CUSTOM_PRICE, RD.CUSTOM_CURRENCY, RD.VAUCHER_NUM, RD.VAUCHER_DATE, RD.VAUCHER_TEXT, RD.VAUCHER_NUM2,
         RD.VAUCHER_DATE2, RD.TRANSFER_IN_TIME, RD.TRANSFER_IN_NOTE, RD.TRANSFER_OUT_TIME, RD.TRANSFER_OUT_NOTE,
         RD.COMMING_KIND, RD.LEAVING_KIND - 1, RD.IS_VIP, RD.COUNTRY, RD.CODE_FIRST_FOOD, RD.I_SPECIAL_TREATMENT,
         RD.ID_NOM_MARKET_SEGMENT, RD.ID_NOM_SOURCE_CODE, RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_HEAR_REASON,
         RD.ID_NOM_COME_REASON, RD.ID_AGENT_ACCOUNT_RULE, RD.ACC_ROUTING, RD.ID_PERSON_PAYMENT, RD.ID_AGENT_PAYMENT,
         RD.ROOM_FEATURES, RD.ID_HK_PLAN, RD.ID_GROUP, RD.ID_HOTEL, RD.NOTE, RD.NOTE_REMINDERS,
         RD.GUARANTEE_DEPOSIT, RD.GUARANTEE_CURRENCY, RD.ID_ACC_TEMPLATE_PERSON,
         RD.NUMBER_1, rd.NUMBER_2, rd.ID_GUARANTEE_POLICY, rd.BLOCK_CC, rd.IS_POSTING_STOPPED, rd.ID_EATING_OBJECT
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail_source
  into   :rd_dbkey_old, :id_agent_profile, :check_status, :arrival_date, :departure_date,
         :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff,
         :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
         :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
         :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
         :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
         :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
         :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
         :guarantee_deposit, :guarantee_currency, :id_acc_template_person,
         :number_1, :number_2,:id_guarantee_policy, :block_cc, :is_posting_stopped, :id_eating_object;

  select first 1 sp.ITEM
  from   SYSTEM_STRING_PARSER(:guest_ids, ',') sp
  into   :id_titular;

  select min(g.FROM_DATE), max(g.TO_DATE)
  from   GUEST G
  where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL_SOURCE
         and ','||:GUEST_IDS||',' containing ','||g.ID_GUEST||','
  into   :arrival_date, :departure_date;

  if (exists (select *
              from   RESERV_DETAIL RD
              where  RD.ID_TITULAR = :id_titular
                     and RD.ID_RESERV_DETAIL = :id_reserv_detail_source))
  then exception BOOKING_EXCEPTION 'Titular can not be splited in new reservation';

  execute procedure RES_GET_PERSON_PROFILE$INT(:id_titular)
  returning_values  :id_person_profile, :id_profile_data;

  new_res_number = iif(coalesce(:number_1,'')='','.',:number_1||'.')
                   || coalesce(:number_2, '')
                   || '.0';  -- fictive suffix, needed for unique constraint limitation, that will be replaced with real one


  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, :check_status, :arrival_date, :departure_date,
                    0, 0, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
                    :guarantee_deposit, :guarantee_currency, 0, null, :new_res_number, :id_acc_template_person,
                    :id_guarantee_policy, :block_cc, :id_eating_object)
  returning_values  :rd_dbkey_new, :new_id_reserv_detail, :warn_code;

  execute procedure RES_NUMBER_SUFFIX_GEN (:NEW_ID_RESERV_DETAIL)
  returning_values  (:new_res_number);  -- add suffix to new (splited) booking number (empty on create)

  update RESERV_DETAIL NR
  set    nr.IS_POSTING_STOPPED = :is_posting_stopped
  where  nr.RDB$DB_KEY = :rd_dbkey_new;

  -- there is no need guests deleting, because new splited reservation is created with 0 guests
  adult_count = 0; child_count = 0;
  for
    select G.ID_GUEST, G.RDB$DB_KEY, G.IS_CHILD
    from   SYSTEM_STRING_PARSER(:guest_ids, ',') SP
           join GUEST G on G.ID_GUEST = SP.ITEM
    into   :id_guest, :g_dbkey, :is_child
  do begin
    execute procedure GUEST_SET_EDIT_STATUS$INT (:g_dbkey, 'REBUILD', 'add');

    update GUEST G
    set    G.ID_RESERV_DETAIL = :new_id_reserv_detail
    where  G.ID_GUEST = :id_guest;

    adult_count = :adult_count + (1-:is_child);
    child_count = :child_count + :is_child;

    if (:id_guest = :id_titular) then begin
      update RESERV_DETAIL RD
      set    RD.ID_TITULAR = :id_titular
      where  RD.RDB$DB_KEY = :rd_dbkey_new;

      update GUEST_DATA GD
      set    GD.ID_PERSON_DATA = :id_profile_data
      where  GD.ID_GUEST = :id_titular;
    end
  end

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL_SOURCE, 'RES_SPLIT',
          f_character(29) || :new_res_number || f_character(28) || :adult_count || ' + ' || :child_count);

  -- calling RES_SAVE_PROFILING$INT is unnecessary, it is called into RES_CREATE_SET$INT with same params
  -- here is needed to set reserv accounts per splited guests and reroute posting only (accomplished in next procedure)
  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey_new);

  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_old);
  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_new);

  update RESERV_DETAIL ORD
  set    ord.ROOM_PRICE = null
  where  ord.RDB$DB_KEY = :rd_dbkey_old;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_old, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_new, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  if (:id_room < 0) then begin
    virtual_room = gen_id(GEN_VIRTUAL_ROOM, 1);
    update RESERV_DETAIL RD
    set    rd.VIRTUAL_ROOM = '<'||:virtual_room||'>'
    where  rd.ID_ROOM = :id_room;
  end
end
^

/* Alter (RES_SPLIT_MULTI$RSV) */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
begin
  for
    select RD.ID_RESERV_DETAIL, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :id_reserv_detail, :id_titular
  do begin
    for
      select G.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.ID_GUEST <> :id_titular
      into   :id_guest
    do begin
      execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
      returning_values  :id_splited_reservation;

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
    end
  end
end
^

/* Alter (RES_TAR_CALC_REPOST$INT) */
ALTER PROCEDURE RES_TAR_CALC_REPOST$INT(ID_TAR_CALC TYPE OF ID_REF,
ID_RESERV_DETAIL TYPE OF ID_REF,
RECALC_MARKER VARCHAR(40))
 AS
declare variable id_guest type of id_ref;
  declare variable id_service type of id_ref;
  declare variable id_tariff type of id_ref;
  declare variable date_post type of tdate;
  declare variable qty_post type of tqty;
  declare variable price_orig type of tprice;
  declare variable curr_orig type of tcurrency;
  declare variable id_room type of id_ref;
  declare variable is_base type of tlogical;
  declare variable short_code type of tdescription_long;
  declare variable id_account type of id_ref;
  declare variable gfrom_date type of tdate;
  declare variable gto_date type of tdate;
  declare variable ap_db_key char(8);
  declare variable id_pack_service type of id_ref;
  declare variable err_code type of id_ref;
  declare variable err_text type of tdescription_long;
  declare variable id_master_account_post type of id_ref;
  declare variable id_acc_post type of id_ref;
  declare variable is_base_account type of id_ref;
  declare variable id_extra_account type of id_ref;
  declare variable no_use varchar(255);
begin
  for
    select   TCP.ID_GUEST, TCP.ID_SERVICE, TCP.ID_TARIFF, TCP.DATE_POST, TCP.QTY_POST,
             round_f(TCP.PRICE_ORIG, c.ROUND_TO), TCP.CURR_ORIG, TCP.ID_ROOM, TCP.IS_BASE,
             TCP.SHORT_CODE, iif(coalesce(AGP.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'NONE', 0, 1),
             G.ID_BASE_ACCOUNT, G.FROM_DATE, G.TO_DATE, G.ID_ACCOUNT
    from     TAR_CALC_POST$TMP TCP
             join GUEST G on G.ID_GUEST = TCP.ID_GUEST
             join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
             join SERVICES S on S.ID_SERVICE = TCP.ID_SERVICE
             join CURRS c on c.CURR = tcp.CURR_ORIG
             left outer join AGENT_PACKET AGP on AGP.ID_SERVICE = S.ID_SERVICE and AGP.ID_AGENT = G.ID_AGENT
    where    TCP.ID_TAR_CALC = :id_tar_calc
             and ((rd.ID_RESERV_DETAIL = :ID_RESERV_DETAIL)
                  or (coalesce(RD.IS_POSTING_STOPPED, 0) = 0 and RD.POSTING_TRANSACTION_UUID is not null))
    order by TCP.ID_GUEST asc, TCP.DATE_POST asc, TCP.IS_BASE desc
    into     :id_guest, :id_service, :id_tariff, :date_post, :qty_post,
             :price_orig, :curr_orig, :id_room, :is_base, :short_code, :is_base_account,
             :id_account, :gfrom_date, :gto_date, :id_extra_account
  do begin
    ap_db_key = null;
    if (:is_base = 1) then begin
      select AP.RDB$DB_KEY, AP.ID_MASTER_ADDINS_ACC_POST, AP.ID_PACK_SERVICE
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.DATE_POST = :date_post
             and AP.IS_BASE = 1
      into   :ap_db_key, :id_master_account_post, :id_pack_service;

      --execute procedure sys_dbg('tar TAR_CALC_REPOST$INT price_orig = '||coalesce(:price_orig, 'null'));
      --execute procedure sys_dbg('tar TAR_CALC_REPOST$INT ap_db_key = '||coalesce(:ap_db_key, 'null'));

      if (:ap_db_key is null) then begin
        id_master_account_post = -1;
        execute procedure GUEST_POST_GET_PACK_SERVICE(:id_service, :id_guest, :date_post)
        returning_values  :id_pack_service;
      end
    end else begin
      -- short_code = '';
      select first 1 APU.rdb$db_key
      from   ACCOUNT_POST APU
      where  APU.ID_MASTER_ADDINS_ACC_POST = :id_master_account_post
             and APU.ID_SERVICE = :id_service
             and APU.CHANGED_TEXT is distinct from :recalc_marker
      order by apu.IS_ANUL asc, apu.ID_ACCOUNT_POST asc
      into   :ap_db_key;

      if ((:is_base_account <> 1)) then id_account = :id_extra_account;
    end

    if (:ap_db_key is null) then begin
      execute procedure ACCOUNT_POSTING_ADD$INT(
        :id_account, :id_guest, -1, :date_post, :id_service, :id_tariff, :id_room, :is_base, :qty_post,
        :price_orig, :curr_orig, null, :short_code, :gfrom_date, :gto_date, 'PACK='||:id_pack_service, '',
        :recalc_marker, :id_master_account_post)
      returning_values  :err_code, :err_text, :id_acc_post;
      if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

      if (:is_base = 1) then id_master_account_post = :id_acc_post;

    end else begin
      execute procedure ACCOUNT_POSTING_UPDATE$INT(
        :ap_db_key, :id_service, :id_tariff, :id_room, :qty_post, 0, :price_orig, :curr_orig, null,
        :recalc_marker, :short_code, :gfrom_date, :gto_date, 1, :id_account)
      returning_values  :no_use, :no_use, :no_use;
    end

  end

  ap_db_key = null;
  id_guest = null;
  for
    select distinct TCP.ID_GUEST
    from   TAR_CALC_POST$TMP TCP
    where  tcp.ID_TAR_CALC = :ID_TAR_CALC
    into   :id_guest
  do begin
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.CHANGED_TEXT is distinct from :recalc_marker
             and AP.ID_MASTER_ADDINS_ACC_POST > 0
             and AP.IS_ANUL = 0
      into   :ap_db_key
    do begin
      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_db_key, :recalc_marker);
    end
  end

  delete from RESERV_PREPOST RP where RP.ID_RESERV_DETAIL = :id_reserv_detail;
  execute procedure RES_TAKE_POSTING_RESPONSIBILITY (:ID_RESERV_DETAIL);
end
^

/* Alter (RESGRP_GET_INFO$RSV) */
ALTER PROCEDURE RESGRP_GET_INFO$RSV(ID_INFO_GROUP INTEGER)
 RETURNS(AGENT_PROFILE_NAME VARCHAR(100),
ARRIVALS VARCHAR(255),
DEPARTURES VARCHAR(255),
ROOM_DATA VARCHAR(255),
ROOMS VARCHAR(255),
ID_ROOM INTEGER,
GUESTS VARCHAR(255),
PERSON_PROFILE_NAME VARCHAR(100),
RATES VARCHAR(255),
BOARDS VARCHAR(255),
PACKETS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY VARCHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
BALANCE VARCHAR(255),
OPEN_CHARGES INTEGER,
CHECK_STATUS VARCHAR(255),
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
NOTE VARCHAR(2000),
NOTE_GRP VARCHAR(255),
IN_SHARE SMALLINT,
SHARES_PREVIEW VARCHAR(1024),
FIRST_ARRIVAL DATE,
FIRST_DEPARTURE DATE,
HOTELS VARCHAR(255),
ID_HOTEL INTEGER,
ACC_ROUTING VARCHAR(255),
RES_NUMBER VARCHAR(62))
 AS
declare variable arrival date;
  declare variable departure date;
  declare variable room varchar(10);
  declare variable type_room varchar(20);
  declare variable stay_length varchar(60);
  declare variable id_reserv_detail integer;
  declare variable no_use varchar(255);
  declare variable rd_adult_count integer;
  declare variable rd_child_count integer;
  declare variable is_group integer;
  declare variable current_arrival varchar(60);
  declare variable current_departure varchar(60);
  declare variable nights varchar(255);
  declare variable roomcount integer;
  declare variable adultcount integer;
  declare variable childrencount integer;
  declare variable groupname varchar(100);
  declare variable rd_check_status integer;
  declare variable is_anul_detail integer;
  declare variable reason_of_anul varchar(100);
  declare variable hotel_code varchar(10);
  declare variable current_acc_routing varchar(255);
begin
  arrivals = '';
  departures = '';
  rooms = '';
  nights = '';
  rates = '';
  hotels = '';
  roomcount = 0;
  adultcount = 0;
  childrencount = 0;
  check_status = '';
  acc_routing = '';
  arrival = null;
  first_arrival = null;
  first_departure = null;

  ATTENTION_STATUS = null;  -- OUT of use ?!
  NOTE_GRP = null;

  for
    select RD.FROM_DATE, RD.ADULT_COUNT, RD.CHILD_COUNT, R.ROOM_NAME, RT.TYPE_ROOM,
           cast(RD.TO_DATE - RD.FROM_DATE as integer), RD.CHECK_STATUS, PP.PROFILE_NAME,
           RD.ROOM_PRICE, RD.ROOM_CURRENCY, RD.ROOM_PRICE_DETAILS, RD.ID_RESERV_DETAIL,
           RD.TO_DATE, R.ID_ROOM, RD.IS_ANUL, RD.REASON_OF_ANUL, RD.NOTE, H.CODE,
           RD.NUMBER, RD.ACC_ROUTING,
           AP.PROFILE_NAME, RG.GROUP_NAME, RD.ID_HOTEL, iif(RD.ID_GROUP is not null, 1, 0)
    from   RESERV_GROUP RG
           join HOTEL H on H.ID_HOTEL = RG.ID_HOTEL
           left outer join RESERV_DETAIL RD on RG.ID_RESERV_GROUP = RD.ID_GROUP and RD.IS_ANUL = 0
           left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
           left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = coalesce(R.ID_ROOM_TYPE, RD.ID_ROOM_TYPE)
           left outer join PROFILE PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
           left outer join PROFILE AP on AP.ID_PROFILE = RD.ID_AGENT_PROFILE
    where  RG.ID_RESERV_GROUP = :id_info_group
    order by RD.FROM_DATE asc
    into   :arrival, :rd_adult_count, :rd_child_count, :room, :type_room,
           :stay_length, :rd_check_status, :person_profile_name,
           :room_price, :room_currency, :room_price_details, :id_reserv_detail,
           :departure, :id_room, :is_anul_detail, :reason_of_anul, :note, :hotel_code,
           :res_number, :current_acc_routing,
           :agent_profile_name, :groupname, :id_hotel, :is_group
  do begin
    if (:first_arrival is null) then first_arrival = :arrival;
    if (:first_departure is null) then first_departure = :departure;

    if (:arrival is not null) then begin
      if (extract(year from current_date) = extract(year from :arrival)) then
        current_arrival = formatDate(:arrival, 'D;dd.mm');
      else
        current_arrival = formatDate(:arrival, 'D;dd.mm.yy');
  
      if (:arrivals not containing :current_arrival) then begin
        nights = :stay_length;
        if (:arrivals = '') then arrivals = :current_arrival||' ('||:stay_length;
        else if (char_length(:arrivals) < 100) then arrivals = :arrivals||')  '||:current_arrival||' ('||:stay_length;
      end else begin
        if (:nights not containing :stay_length) then begin
          nights = :nights ||','||:stay_length;
          arrivals = :arrivals||','||:stay_length;
        end
      end
    end

    if (:departure is not null) then begin
      if (extract(year from current_date) = extract(year from :departure)) then
        current_departure = formatDate(:departure, 'D;dd.mm');
      else
        current_departure = formatDate(:departure, 'D;dd.mm.yy');
  
      if (:departures not containing :current_departure) then begin
        if (:departures = '') then departures = :current_departure;
        else if (char_length(:departures) < 100) then departures = :departures||'  '||:current_departure;
      end
    end

    if (:acc_routing not containing :current_acc_routing) then begin
      if (:acc_routing = '') then acc_routing = :current_acc_routing;
      else if (char_length(:acc_routing) < 100) then acc_routing = :acc_routing||'  '||:current_acc_routing;
    end

    if (:check_status not containing :rd_check_status) then begin
      if (:check_status = '') then check_status = :rd_check_status;
      else check_status = :check_status||', '||:rd_check_status;
    end

    if (:hotels not containing :hotel_code) then begin
      if (:hotels = '') then hotels = :hotel_code;
      else hotels = :hotels||','||:hotel_code;
    end

    if (:is_group is distinct from 1) then begin
      if (:room is null) then room_data = :type_room;
      else room_data = :room || ' / ' || :type_room;
    end

    if (:is_group = 1) then begin
      in_share = null;
      balance = '-';
      res_number = '';
    end else begin
      execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'RENDER', null)
      returning_values  :in_share, :no_use, :shares_preview;

      execute procedure RES_GET_BALLANCE$INT(:id_reserv_detail)
      returning_values  :balance, :no_use, :no_use, :open_charges, :no_use;
    end
    adultcount = :adultcount + :rd_adult_count;
    childrencount = :childrencount + :rd_child_count;
  end
  if (coalesce(:groupname, '') <> '') then agent_profile_name = substring(coalesce(:agent_profile_name, ' ') || ' / ' || :groupname from 1 for 100);
  if (:is_group = 1) then person_profile_name = '';
  if (:arrivals <> '') then arrivals = :arrivals||')';
  guests = :adultcount || ' + ' || :childrencount || ' ';

  if (:arrivals <> '') then begin
    if (:is_group = 1) then begin
      note = '';
      room_data = '';
      for
        select RT.TYPE_ROOM, count(*)
        from   RESERV_DETAIL RD
               left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
               join ROOM_TYPES RT on RT.ID_ROOM_TYPE = coalesce(R.ID_ROOM_TYPE, RD.ID_ROOM_TYPE)
        where  RD.ID_GROUP = :id_info_group
               and RD.IS_ANUL = 0
        group by 1
        into   :type_room, :roomcount
      do begin
        if (:room_data = '') then room_data = :roomcount ||'x '||:type_room;
        else room_data = room_data ||', '|| :roomcount ||'x '||:type_room;
      end
    end
/*
    execute procedure RES_GET_ATTENTION_STATUS$INT(:arrival, :departure, :rd_check_status)
    returning_values  :attention_status;
*/
    execute procedure RES_GET_GUEST_DATA$INT('GROUP', :id_info_group)
    returning_values  :boards, :rates, :packets, :no_use;
  
    annul_status = :is_anul_detail;
    if (:reason_of_anul = 'EXPIRE') then annul_status = 2;
  end

  if (char_length(:arrivals) >= 100) then arrivals = :arrivals||'...';
  if (char_length(:departures) >= 100) then departures = :departures||'...';
  suspend;
end
^

/* Alter (RESMULTI_CREATE$RSV) */
ALTER PROCEDURE RESMULTI_CREATE$RSV(ID_HOTEL INTEGER,
ID_ROOM_TYPE INTEGER,
TRANSFER_OUT_TIME TIME,
TRANSFER_IN_TIME TIME,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
TRANSFER_OUT_NOTE VARCHAR(50),
TRANSFER_IN_NOTE VARCHAR(50),
NOTE VARCHAR(255),
ID_BOARD INTEGER,
VOUCHER_DATE DATE,
VOUCHER_NUMBER VARCHAR(20),
VOUCHER_TEXT VARCHAR(30),
CHECK_STATUS INTEGER,
ID_TARIFF INTEGER,
COUNTRY_CODE VARCHAR(20),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
NOTE_REMINDERS VARCHAR(50),
TITULAR_NAME VARCHAR(100),
SPLIT_ON_CHECKIN INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
NUMBER VARCHAR(62),
NEW_ID_TITULAR INTEGER,
NEW_FROM_DATE TYPE OF TDATE,
WARN_CODE TYPE OF TRANGE)
 AS
declare variable rd_dbkey char(8);
  declare variable id_person_profile integer;
  declare variable pd_dbkey char(8);
  declare variable id_acc_template_person integer;
  declare variable first_name varchar(30);
  declare variable surname varchar(30);
  declare variable family_name varchar(30);
begin

  select sv.SETTING_VALUE
  from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :ID_HOTEL) sv
  into   :id_acc_template_person;

  execute procedure RES_CREATE_SET$INT(:id_agent_profile, null, :check_status, :arrival_date, :departure_date,
                    :adult_count, :children_count, :id_room_type, null, :id_board, :id_tariff, null,
                    null, null, :voucher_number, :voucher_date, :voucher_text, '',
                    null, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    1, 0, 0, :country_code, :code_first_food, '',
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    '', :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders, null, null,
                    :split_on_checkin, null, null, :id_acc_template_person, null, null, :ID_EATING_OBJECT)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :WARN_CODE;

  select RD.NUMBER, RD.ID_PERSON_PROFILE, RD.ID_TITULAR
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :number, :id_person_profile, :new_id_titular;

  if (:titular_name <> '') then begin
    select PD.RDB$DB_KEY
    from   PROFILE P
           join PROFILE_PERSON PP on PP.ID_PROFILE = P.ID_PROFILE
           join PERSON_DATA PD on PD.ID_PERSON_DATA = PP.ID_PERSON_DATA
    where  P.ID_PROFILE = :id_person_profile
    into   :pd_dbkey;

    select PP.FIRST_NAME, PP.SURNAME, PP.FAMILY_NAME
    from   PERSON_NAME_PARSE$INT (:TITULAR_NAME) PP
    into   :first_name, :surname, :family_name;

    update PERSON_DATA PD
    set    PD.PERSON_NAME2 = :titular_name,
           PD.FIRST_NAME = :first_name,
           PD.SURNAME = :surname,
           PD.FAMILY_NAME = :family_name
    where  PD.RDB$DB_KEY = :pd_dbkey;
  end

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;
end
^

/* Alter (RESMULTI_FINALIZE$RSV) */
ALTER PROCEDURE RESMULTI_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER,
DISABLE_WARNING SMALLINT)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  if (:disable_warning = 1) then warn_code = 0;
end
^

/* Alter (RESMULTI_LOAD$RSV) */
ALTER PROCEDURE RESMULTI_LOAD$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(CHECK_STATUS INTEGER,
ATTENTION_STATUS INTEGER,
ANNUL_STATUS INTEGER,
IS_DIFFERENT_BOARD SMALLINT,
BOARDS VARCHAR(255),
IS_DIFFERENT_VOUCHER SMALLINT,
VOUCHERS VARCHAR(255),
IS_DIFFERENT_TRANSFER_IN_TIME SMALLINT,
TRANSFER_IN_TIMES VARCHAR(255),
IS_DIFFERENT_TRANSFER_OUT_TIME SMALLINT,
TRANSFER_OUT_TIMES VARCHAR(255),
IS_DIFFERENT_TRANSFER_IN_NOTE SMALLINT,
TRANSFER_IN_NOTES VARCHAR(500),
IS_DIFFERENT_TRANSFER_OUT_NOTE SMALLINT,
TRANSFER_OUT_NOTES VARCHAR(500))
 AS
declare variable is_different_other integer;
  declare variable rd_dbkey char(8);
  declare variable rates varchar(255);
  declare variable packets varchar(255);
  declare variable arrival date;
  declare variable departure date;
  declare variable id_hotel integer;
begin
  select RD.RDB$DB_KEY, RD.FROM_DATE, RD.TO_DATE, RD.CHECK_STATUS, RD.ID_HOTEL,
         RD.HAS_DIFFERENT_BOARD, RD.HAS_DIFFERENT_VOUCHERS, RD.HAS_DIFFERENT_OTHER
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :arrival, :departure, :check_status, :id_hotel,
         :is_different_board, :is_different_voucher, :is_different_other;

  is_different_transfer_in_time = :is_different_other;
  is_different_transfer_out_time = :is_different_other;
  is_different_transfer_in_note = :is_different_other;
  is_different_transfer_out_note = :is_different_other;

  execute procedure RES_GET_GUEST_DATA$INT('DETAIL', :id_reserv_detail)
  returning_values  :boards, :rates, :packets, :vouchers;

  execute procedure RES_GET_ANNULSTATUS(:rd_dbkey)
  returning_values  :annul_status;

  execute procedure RES_GET_ATTENTION_STATUS$INT(:arrival, :departure, :check_status, :id_hotel)
  returning_values  :attention_status;

  execute procedure RES_GET_GUEST_TRANSFERS$INT(:id_reserv_detail)
  returning_values  :transfer_in_times, :transfer_out_times, :transfer_in_notes, :transfer_out_notes;

  suspend;
end
^

/* Alter (RESMULTI_MODIFY_BOARD$RSV) */
ALTER PROCEDURE RESMULTI_MODIFY_BOARD$RSV(ID_RESERV_DETAIL INTEGER,
ID_BOARD INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_SAVE_BOARD$INT(:rd_dbkey, :id_board);
end
^

/* Alter (RESOURCE_RESERVATION_CHECK_IN) */
ALTER PROCEDURE RESOURCE_RESERVATION_CHECK_IN(ID_RESOURCE_RESERVATION INTEGER,
SERVICE_PRICE NUMERIC(15,2),
SERVICE_CURR VARCHAR(3))
 RETURNS(OUT_ID_ACCOUNT INTEGER,
OUT_ID_ACCOUNT_POST INTEGER)
 AS
declare variable old_status varchar(20);
  declare variable new_status varchar(20);
  declare variable dbkey char(8);
  declare variable id_service id_ref;
  declare variable price_post tprice;
  declare variable curr_post TCURRENCY;
  declare variable is_manual_price TLOGICAL;
  declare variable is_details tlogical;
  declare variable post_description tobject_text;
  declare variable id_reserv_detail integer;
  declare variable post_date tdate;
  declare variable from_datetime tdatetime;
  declare variable to_datetime tdatetime;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  new_status = 'CHECKED_IN';

  select r.RDB$DB_KEY, R.STATUS, rd.ID_RESERV_DETAIL
  from   RESOURCE_RESERVATION R
         left outer join RESERV_DETAIL rd on rd.NUMBER = r.BOOKING_NUMBER
                                             and rd.IS_ANUL = 0
                                             and rd.SUBSCRIBER_ID is not distinct from r.SUBSCRIBER_ID
  where  R.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION
  into   :dbkey, :old_status, :id_reserv_detail;

  if (:old_status = :NEW_STATUS) then exit;
 
  if (:old_status is distinct from 'RESERVED') then exception ASSERT '-511';

  if (exists (select RP.ID_RESOURCE_RESERVATION
              from   RESOURCE_RESERV_POST RP
                     join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = RP.ID_ACCOUNNT_POST
              where  RP.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION)) then
  begin
    exception ASSERT '-505';
  end

  if (:id_reserv_detail is not null) then begin
    execute procedure RESOURCE_RESERV_SERVICE_GET (:ID_RESOURCE_RESERVATION)
    returning_values (:id_service, :price_post, :curr_post, :is_manual_price, :is_details, :post_description,
                     :post_date, :from_datetime, :to_datetime);
  
    if (:is_manual_price = 1) then begin
      price_post = :SERVICE_PRICE;
      curr_post = :SERVICE_CURR;
    end

    if (:price_post is null) then exception ASSERT 'Unspecified service price!';
    if (:curr_post is null) then exception ASSERT 'Unspecified price currency!';
  
    execute procedure POST_SERVICE_ON_RESERVATION$INT (:id_reserv_detail, :id_service, 1, 0,
            1, :price_post, :curr_post, :from_datetime, :to_datetime,
            '', '', :post_date, 'RESOURCE', :post_description)
    returning_values (:ERR_CODE, :ERR_TEXT, :OUT_ID_ACCOUNT, :OUT_ID_ACCOUNT_POST);
    if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
  
    insert into RESOURCE_RESERV_POST(ID_RESOURCE_RESERVATION, ID_ACCOUNNT_POST)
    values (:ID_RESOURCE_RESERVATION, :OUT_ID_ACCOUNT_POST);
  end

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = :NEW_STATUS
  where  RR.RDB$DB_KEY = :dbkey;

end
^

/* Alter (RIGHTS_GROUP_USER_MODIFY) */
ALTER PROCEDURE RIGHTS_GROUP_USER_MODIFY(USER_NAME VARCHAR(30),
ID_RIGHT_GROUP INTEGER,
OPERATION VARCHAR(50))
 AS
declare variable right_group varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add,del');

  if (:USER_NAME = 'SYSDBA') then exit;

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS RG
  where  RG.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'add') then begin
    insert into RIGHTS_USER_GROUPS (USER_NAME, ID_RIGHT_GROUP)
    values (:user_name, :id_right_group);

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_ADDED',
            f_character(29) || :USER_NAME  || f_character(28) || :right_group);

  end else begin
    delete from RIGHTS_USER_GROUPS
    where USER_NAME = :user_name
          and ID_RIGHT_GROUP = :id_right_group;

    if (row_count > 0) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_REMOVED',
              f_character(29) || :USER_NAME || f_character(28) || :right_group);

  end

  when sqlcode -803 do begin
    /* ERR_TEXT = '       ! ' ;*/
    exit;
  end
end
^

/* Alter (ROOM_KEY_REGISTER) */
ALTER PROCEDURE ROOM_KEY_REGISTER(ROOM_NAME VARCHAR(20),
KEY_TYPE VARCHAR(20),
VALIDITY_FROM TIMESTAMP,
VALIDITY_TO TIMESTAMP,
ERROR_CODE INTEGER,
ERROR_TEXT VARCHAR(255),
REQUEST_PARAMS BLOB,
EXECUTE_PARAMS BLOB,
ID_CALLER INTEGER,
MACHINE_NAME VARCHAR(30),
ID_HOTEL INTEGER)
 RETURNS(NEW_ID_ROOM_KEY INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100))
 AS
begin
  err_code = 0;
  err_text = '';

  new_id_room_key = gen_id(GEN_ROOM_KEY_LOG_ID, 1);

  insert into ROOM_KEY_LOG(ID_ROOM_KEY, ROOM_NAME, KEY_TYPE, VALIDITY_FROM,
    VALIDITY_TO, REQUEST_PARAMS, EXECUTE_PARAMS, ERROR_CODE, ERROR_TEXT,
    USER_ISSUED, DATETIME_ISSUED, ID_CALLER, MACHINE_NAME, ID_HOTEL)
  values (:new_id_room_key, :room_name, :key_type, :validity_from,
    :validity_to, :request_params, :execute_params, :error_code, :error_text,
    current_user, current_timestamp, :id_caller, :machine_name, :id_hotel);
end
^

/* Alter (ROOM_MODIFY$PMS) */
ALTER PROCEDURE ROOM_MODIFY$PMS(ID_ROOM INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
BEDS INTEGER,
EXTRA_BEDS INTEGER,
SECTOR INTEGER,
SORT_ORDER INTEGER,
FEATURES BLOB SUB_TYPE 1 SEGMENT SIZE 100,
EXTERNAL_NAME VARCHAR(20),
ID_EATING_OBJECT TYPE OF ID_REF,
OPERATION VARCHAR(20))
 RETURNS(OVERRULE_NEED SMALLINT,
OVERRULE_CONTEXT VARCHAR(255),
NEW_ID_ROOM INTEGER)
 AS
declare variable old_id_room_type integer;
  declare variable old_room_name varchar(10);
  declare variable rebuild_id_hotel integer;
  declare variable rebuild_id_room_type integer;
  declare variable no_use varchar(20);
  declare variable old_capacity integer;
  declare variable sys_date date;
  declare variable action_text varchar(255);
  declare variable old_floor integer;
  declare variable old_sector integer;
  declare variable old_extra_beds integer;
  declare variable id_hotel integer;
begin
  overrule_need = 0;
  overrule_context = '';
  new_id_room = null;
  --if OVERRULE_NEED = 1 then OVERRULE_CONTEXT = ERR_TEXT like ERR_CODE = -9
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    if (coalesce(:room_name, '') = '') then
      exception ASSERT '-119';

    if ((:room_name containing '<') or (:room_name containing '>') or (:room_name starting with 'i')) then
      exception ASSERT '-120';
  end

  room_name = upper(:room_name);

  if (:operation='mod') then begin
    select R.ROOM_NAME, R.ID_ROOM_TYPE, R.BEDS+R.EXTRA_BEDS, r.floor, r.sector, r.extra_beds
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :id_room
    into   :old_room_name, :old_id_room_type, :old_capacity, :old_floor, :old_sector, :old_extra_beds;

    if (:id_room_type <> :old_id_room_type) then begin
      exception OCCUPANCY_EXCEPTION '-65';
    end

    new_id_room = :id_room;
    execute procedure ROOM_CAPACITY_CHECK$INT(:NEW_ID_ROOM, :ROOM_NAME, :old_capacity, :BEDS + :EXTRA_BEDS)
    returning_values (:OVERRULE_NEED, :OVERRULE_CONTEXT);

    update ROOMS RU
    set    RU.ID_ROOM_TYPE = :id_room_type,
           RU.ROOM_NAME = :room_name,
           RU.FLOOR = :floor,
           RU.BEDS = :beds,
           RU.EXTRA_BEDS = :extra_beds,
           RU.SECTOR = :sector,
           RU.FEATURES = :features,
           RU.SORT_ORDER = :sort_order,
           RU.EXTERNAL_NAME = :external_name,
           RU.ID_EATING_OBJECT = :ID_EATING_OBJECT
    where  RU.ID_ROOM = :id_room;

    if ((:room_name <> :old_room_name)
        or (:floor <> :old_floor)
        or (:sector <> :old_sector)
        or (:extra_beds <> :old_extra_beds)) then
    begin
      action_text = f_character(29) || '(' || :old_room_name || '/' || :old_floor || '/' || :old_sector || '/'
                    || :old_extra_beds || ')' || f_character(28) || '(' || :room_name || '/' || :floor || '/'
                    || :sector || '/' || :extra_beds || ')';
      execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_PARAMS_CHANGED', :action_text);
    end

    if (:room_name <> :old_room_name) then begin
      update ACCOUNT_POST AP
      set    AP.ROOM_NAME = :room_name
      where  AP.ROOM_NAME = :old_room_name;
    end

  end else if (:operation = 'add') then begin
    select rt.ID_HOTEL
    from   ROOM_TYPES RT
    where  rt.ID_ROOM_TYPE = :ID_ROOM_TYPE
    into   :id_hotel;

    insert into ROOMS (
      ID_ROOM, ID_ROOM_TYPE, ROOM_NAME, FLOOR, BEDS, EXTRA_BEDS, SECTOR,
      FEATURES, SORT_ORDER, ID_HOTEL, EXTERNAL_NAME, ID_EATING_OBJECT)
    values (gen_id(ID_ROOM_GEN, 1), :id_room_type, :room_name, :floor, :beds, :extra_beds, :sector,
      :features, :sort_order, :id_hotel, :external_name, :ID_EATING_OBJECT)
    returning ID_ROOM into :NEW_ID_ROOM;

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :sys_date;

    execute procedure ROOM_PERIOD_MODIFY$PMS(null, :new_id_room, :sys_date, 'HOTEL', 'add')
    returning_values  :no_use;

    insert into ROOMS_ADD (ID_ROOM, PMS_MARKERS, ADDRESS)
    values (:new_id_room, null, null);
  end else if (:operation = 'del') then begin
    -- Booked rooms are preserved with FK constraint on room_magic
    execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'DELETE', '');

    select RT.ID_ROOM_TYPE, RT.ID_HOTEL
    from   ROOM_TYPES RT
    where  RT.ID_ROOM_TYPE = :id_room_type
    into   :rebuild_id_room_type, :rebuild_id_hotel;

    delete from ROOMS where ID_ROOM = :id_room;

    execute procedure ALLOTMENT_PHYS_REBUILD$INT(:rebuild_id_hotel, :rebuild_id_room_type);

    when sqlcode -530 do begin
      -- Violation of FOREIGN KEY constraint "%s" on table "%s"
      exception ASSERT '-34';
    end
  end
end
^

/* Alter (ROOM_SMART_LIST_OOS$INT) */
ALTER PROCEDURE ROOM_SMART_LIST_OOS$INT(FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ROOM_NAME VARCHAR(50),
DESCRIPTION VARCHAR(100),
PERIOD VARCHAR(100),
FREE_BASE INTEGER,
FREE_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
IS_CLEAN INTEGER,
FEATURES BLOB)
 AS
declare variable id_reserv_detail integer;
  declare variable sys_date date;
  declare variable dummy integer;
  declare variable beds integer;
  declare variable extra_beds integer;
  declare variable guests_cnt integer;
begin
  if (:from_date >= :to_date) then exit;

  for
    select SRLF.ROOM_NAME, SRLF.BEDS, SRLF.EXTRA_BEDS, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
           SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.SYS_DATE
    from   ROOM_SMART_FILTER$INT(:from_date, :to_date, 'SHARE', 0, 1) SRLF
    into   :room_name, :beds, :extra_beds, :is_clean, :type_room,
           :id_room, :floor, :features, :sys_date
  do begin
    for
      select distinct RM.ID_RESERV_DETAIL
      from   ROOM_MAGIC RM
      where  RM.ID_ROOM = :id_room
             and RM.BUSY_DATE between :from_date and :to_date
             and RM.DAY_ACTION not containing 'CHECK_IN'
      into   :id_reserv_detail
    do begin
      select RGI.NUMBER ||', '|| RGI.PERSON_PROFILE_NAME ||', '||  RGI.AGENT_PROFILE_NAME,
             RGI.ARRIVALS ||' '|| RGI.DEPARTURES, RGI.GUESTS_CNT
      from   RES_GET_INFO$RSV(:id_reserv_detail, 0, 0, 0) RGI
      into   :description, :period, :guests_cnt;

      if (:guests_cnt < (:beds+:extra_beds)) then begin
        if (:guests_cnt < :beds) then begin
          free_base = (:beds - :guests_cnt);
          free_extra = extra_beds;
        end else begin
          free_base = 0;
          free_extra = ((:beds+:extra_beds)-:guests_cnt);
        end
        suspend;
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: ROOM_SMART_LIST$RSV for: ROOM_SMART_LIST_SHARE$INT */
ALTER PROCEDURE ROOM_SMART_LIST$RSV(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(50))
 RETURNS(ROOM_NAME VARCHAR(50),
FREE_BEDS_BASE INTEGER,
FREE_BEDS_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
FEATURES BLOB,
BUSY_GROUP_TYPE INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
DATA1 VARCHAR(255),
DATA2 VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (ROOM_SMART_LIST_SHARE$INT) */
ALTER PROCEDURE ROOM_SMART_LIST_SHARE$INT(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(50),
SUPPRESS_PRIVATE SMALLINT = 1)
 RETURNS(ROOM_NAME VARCHAR(50),
DESCRIPTION VARCHAR(255),
PERIOD VARCHAR(255),
FREE_BASE INTEGER,
FREE_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
FEATURES BLOB)
 AS
declare variable id_reserv_detail integer;
  declare variable beds integer;
  declare variable extra_beds integer;
  declare variable guests_cnt integer;
  declare variable busy_group_type integer;
  declare variable r_guests_cnt integer;
  declare variable r_description varchar(255);
  declare variable r_period varchar(255);
  declare variable min_day_action integer;
begin
  if (:from_date >= :to_date) then exit;
  report_type = iif(:report_type = 'POTENTIAL_SHARE', 'SHARE', 'BLOCKED');
  for
    select SRLF.ROOM_NAME, SRLF.BEDS, SRLF.EXTRA_BEDS, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
           SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.CLEAN_TEXT
    from   ROOM_SMART_FILTER$INT(:from_date, :to_date, :report_type, 0, :SUPPRESS_PRIVATE) SRLF
    into   :room_name, :beds, :extra_beds, :is_clean, :type_room,
           :id_room, :floor, :features, :clean_text
  do begin
    guests_cnt = 0;
    description = '';
    for
      select RM.ID_RESERV_DETAIL, RM.BUSY_GROUP_TYPE, min(RM.DAY_ACTION_INT)
      from   ROOM_MAGIC RM   --TODO order by arrival
      where  RM.ID_ROOM = :id_room
             and RM.BUSY_DATE between :from_date and :to_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
      group by 1, 2
      into   :id_reserv_detail, :busy_group_type, :min_day_action
    do begin
      if ((:busy_group_type in (1, 24)) or (:min_day_action > 0)) then begin
        select substring(RGI.NUMBER ||', '|| RGI.PERSON_PROFILE_NAME ||', '||  RGI.AGENT_PROFILE_NAME from 1 for 254),
               substring(RGI.ARRIVALS ||' '|| RGI.DEPARTURES from 1 for 254), RGI.GUESTS_CNT
        from   RES_GET_INFO$RSV(:id_reserv_detail, 0, 0, 0) RGI
        into   :r_description, :r_period, :r_guests_cnt;
      end else begin
        select iif(BR.BLOCK_GRP=18, 'OOO', 'OOI') ||', ' || substring(BR.REASON ||', '|| BR.NOTE from 1 for 254),
               substring(formatDate(BR.FROM_DATE, 'D;dd.mm')||' ('|| cast((BR.TO_DATE - BR.FROM_DATE) as integer) ||') '||formatDate(BR.TO_DATE, 'D;dd.mm') from 1 for 254)
        from   BLOCK_ROOM BR
        where  BR.ID_BLOCK_ROOM = :id_reserv_detail
        into   :r_description, :r_period;
        r_guests_cnt = 0;
      end
      if (:r_guests_cnt > :guests_cnt) then guests_cnt = :r_guests_cnt;

      if (:description <> '') then description = :description || F_CRLF();
      description = substring(:description || :r_description || ', ' || :r_period from 1 for 250);
    end
    if (:guests_cnt < (:beds+:extra_beds)) then begin
      if (:guests_cnt < :beds) then begin
        free_base = (:beds - :guests_cnt);
        free_extra = extra_beds;
      end else begin
        free_base = 0;
        free_extra = ((:beds+:extra_beds)-:guests_cnt);
      end
    end
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_MODIFY for: SAFE_OCCUPANCY_POSTING$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE /* TYPE OF ID */ INTEGER,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100))
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_NEW for: SAFE_OCCUPANCY_POSTING$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE /* TYPE OF ID */ INTEGER,
FROM_DATETIME /* TDATETIME */ TIMESTAMP,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100),
BOOKING_NUMBER /* TYPE OF TRES_NUMBER */ VARCHAR(62),
ID_EXTERNAL_CLIENT_ACCCOUNT /* TYPE OF ID_REF */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER,
ID_RESOURCE_RESERVATION /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SAFE_OCCUPANCY_POSTING$INT) */
ALTER PROCEDURE SAFE_OCCUPANCY_POSTING$INT(ID_RESOURCE_RESERVATION TYPE OF ID,
ID_SERVICE TYPE OF ID,
PRICE TYPE OF TPRICE,
CURRENCY TYPE OF TCURRENCY,
PRICE_DESCRIPTION TYPE OF TDESCRIPTION_SHORT,
ID_RESERV_DETAIL TYPE OF ID,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF = null)
 RETURNS(DOC_SELECTED TYPE OF TRANGE)
 AS
declare variable from_datetime timestamp;
  declare variable to_datetime timestamp;
  declare variable ap_dbkey TDB_KEY;
  declare variable id_account_post integer;
  declare variable safe_name TOBJECT_NAME;
  declare variable no_use varchar(255);
  declare variable new_ac varchar(2);
  declare variable err_code integer;
  declare variable err_text varchar(255) ;
  declare variable occupant_name tperson_name;
  declare variable id_room integer;
  declare variable id_tariff integer;
begin
  DOC_SELECTED = null;
  select od.FROM_DATETIME, od.TO_DATETIME, ap.RDB$DB_KEY, ap.ID_ACCOUNT_POST,
         s.SAFE_NAME, rr.OCCUPANT_NAME, ap.ID_ROOM, ap.ID_TARIFF
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join SAFES s on s.ID_SAFE = od.ID_RESOURCE
         left outer join RESOURCE_RESERV_POST rrp on rrp.ID_RESOURCE_RESERVATION = rr.ID_RESOURCE_RESERVATION
         left outer join ACCOUNT_POST ap on ap.ID_ACCOUNT_POST = rrp.ID_ACCOUNNT_POST
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :from_datetime, :to_datetime, :ap_dbkey, :id_account_post,
         :safe_name, :occupant_name, :id_room, :id_tariff;

  new_ac = null;
  if (:id_account_post is not null) then begin
    execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
            :id_tariff, :id_room, 1, 0, :price, :currency, null, null, 'RESOURCE', :from_datetime, :TO_DATETIME, 1)
    returning_values :no_use, :no_use, :new_ac;
  end else begin
    if (:id_reserv_detail is not null) then begin
      execute procedure POST_SERVICE_ON_RESERVATION$INT (:id_reserv_detail, :id_service, 1, 0,
              1, :price, :currency, :from_datetime, :to_datetime,
              '', '', cast(:from_datetime as date), 'RESOURCE', null)
      returning_values (:ERR_CODE, :ERR_TEXT, :no_use, :id_account_post);
      if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      new_ac = '00';
    end else if (:ID_EXTERNAL_CLIENT_ACCCOUNT is not null) then begin
      execute procedure POST_SERVICE_ON_ACCOUNT$INT (:ID_EXTERNAL_CLIENT_ACCCOUNT, :id_service,
              1, 0, 1, :price, :currency, :from_datetime, :TO_DATETIME, '', '',
              cast(:from_datetime as date), 'RESOURCE', null, null)
      returning_values (:err_code, :err_text, :id_account_post);
      if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      new_ac = '00';
    end
  end

  if (:new_ac is null) then
    exception ASSERT '-1067' || f_character(31) || f_character(29) || :safe_name || f_character(28) || :occupant_name;

  if (:new_ac = '00') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);
    update ACCOUNT_POST AP
    set    ap.DOC_SELECTED = :DOC_SELECTED
    where  ap.ID_ACCOUNT_POST = :id_account_post;
  end

  update or insert into ACCOUNT_POSTING_DET (ID_ACCOUNT_POST, POST_TEXT, QTY,
         FROM_DATETIME, TO_DATETIME, RESOURCE_TEXT, EXT_USER_ANUL)
  values (:id_account_post, :safe_name ||' / '||formatdate(:from_datetime, 'D;dd.mm.yy(hh:mm)')||' - '||formatdate(:to_datetime, 'D;dd.mm.yy(hh:mm)')||' / '
          ||substring(replace(:price_description, F_CRLF(), ';') from 1 for 100), 1, :from_datetime, :to_datetime, :safe_name, null);

  if (not exists (select rp.ID_ACCOUNNT_POST
                  from   RESOURCE_RESERV_POST rp
                  where  rp.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION
                         and rp.ID_ACCOUNNT_POST = :id_account_post)) then
  begin
    insert into RESOURCE_RESERV_POST (ID_RESOURCE_RESERVATION, ID_ACCOUNNT_POST)
    values (:id_resource_reservation, :id_account_post);
  end
end
^

/* empty dependent procedure body */
/* Clear: SERVICE_MODIFY for: SERVICE_MEAL_MODIFY$INT */
ALTER PROCEDURE SERVICE_MODIFY(ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_SERVICE_GROUP /* TYPE OF ID */ INTEGER,
SERVICE_TYPE /* TYPE OF TENUM_STRING */ VARCHAR(50),
SERVICE_NAME /* TYPE OF TNAME_SHORT */ VARCHAR(30),
IS_DELETED /* TYPE OF TLOGICAL */ SMALLINT,
IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
IS_DETAILS /* TYPE OF TLOGICAL */ SMALLINT,
REVENUE_GROUP /* TYPE OF TOBJECT_NAME */ VARCHAR(50),
REVENUE_ACCOUNT /* TYPE OF TOBJECT_NAME */ VARCHAR(50),
ACCOUNT_NAME /* TYPE OF TSEARCH_CODE */ VARCHAR(30),
EXT_CODE /* TYPE OF TSEARCH_CODE */ VARCHAR(30),
VAUCHER_PACKET VARCHAR(20),
EXTRA_PACKET_NAME /* TYPE OF TSHORT_CODE */ VARCHAR(10),
IS_RATE_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
OPERATION VARCHAR(20),
ID_HOTEL /* TYPE OF ID_REF */ INTEGER,
IS_BREAKFAST /* TYPE OF TLOGICAL */ SMALLINT = null,
IS_LUNCH /* TYPE OF TLOGICAL */ SMALLINT = null,
IS_DINNER /* TYPE OF TLOGICAL */ SMALLINT = null,
IS_EXTRAFOOD1 /* TYPE OF TLOGICAL */ SMALLINT = null,
IS_EXTRAFOOD2 /* TYPE OF TLOGICAL */ SMALLINT = null,
IS_BOARD /* TYPE OF TLOGICAL */ SMALLINT = null,
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4) = null,
PRICE_CURR /* TYPE OF TCURRENCY */ CHAR(3) = null)
 RETURNS(NEW_ID_SERVICE /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SERVICE_MEAL_MODIFY$INT) */
ALTER PROCEDURE SERVICE_MEAL_MODIFY$INT(ID_SERVICE TYPE OF ID,
IS_BREAKFAST TYPE OF TLOGICAL,
IS_LUNCH TYPE OF TLOGICAL,
IS_DINNER TYPE OF TLOGICAL,
IS_EXTRAFOOD1 TYPE OF TLOGICAL,
IS_EXTRAFOOD2 TYPE OF TLOGICAL,
IS_BOARD TYPE OF TLOGICAL,
ID_HOTEL TYPE OF ID)
 AS
declare variable id_board integer;
  declare variable weight_tag integer;
  declare variable old_id_board integer;
  declare variable old_is_breakfast integer;
  declare variable old_is_dinner integer;
  declare variable old_is_lunch integer;
  declare variable old_is_extrafood1 integer;
  declare variable old_is_extrafood2 integer;
begin
  IS_BREAKFAST = coalesce(:IS_BREAKFAST, 0);
  IS_LUNCH = coalesce(:IS_LUNCH, 0);
  IS_DINNER = coalesce(:IS_DINNER, 0);
  IS_EXTRAFOOD1 = coalesce(:IS_EXTRAFOOD1, 0);
  IS_EXTRAFOOD2 = coalesce(:IS_EXTRAFOOD2, 0);

  id_board = iif(:IS_BOARD = 1, :ID_SERVICE, null);
  weight_tag = :IS_BREAKFAST + :IS_LUNCH + :IS_DINNER + :IS_EXTRAFOOD1 + :IS_EXTRAFOOD2;

  if (:IS_BOARD = 0 and :weight_tag = 0) then exception ASSERT '-30';

  select sm.Id_BOARD, sm.IS_BREAKFAST, sm.IS_LUNCH, sm.IS_DINNER, sm.IS_EXTRAFOOD1, sm.IS_EXTRAFOOD2
  from   SERVICE_MEALS sm
  where  sm.ID_SERVICE = :ID_SERVICE
  into   :old_id_board, :old_is_breakfast, :old_is_lunch, :old_is_dinner, :old_is_extrafood1, :old_is_extrafood2;

  if ((:id_board is distinct from :old_id_board)
      or (:IS_BREAKFAST <> :old_is_breakfast)
      or (:IS_LUNCH <> :old_is_lunch)
      or (:IS_DINNER <> :old_is_dinner)
      or (:IS_EXTRAFOOD1 <> :old_is_extrafood1)
      or (:IS_EXTRAFOOD2 <> :old_is_extrafood2)) then
  begin
    -- to force FK validations, check usage !!!
    delete from SERVICE_MEALS sm
    where  sm.ID_SERVICE = :ID_SERVICE;

    when sqlcode -530 do begin
      exception ASSERT '-39';
    end
  end

  update or insert into SERVICE_MEALS (ID_SERVICE, IS_BREAKFAST, IS_LUNCH,
      IS_DINNER, IS_EXTRAFOOD1, IS_EXTRAFOOD2, WEIGHT_TAG, ID_BOARD)
  values (:ID_SERVICE, :IS_BREAKFAST, :IS_LUNCH,
      :IS_DINNER, :IS_EXTRAFOOD1, :IS_EXTRAFOOD2, :WEIGHT_TAG, :ID_BOARD)
  matching (id_service);

  if (:id_board is not null) then begin
    execute procedure BASE_SERVICES_GEN$INT (:ID_HOTEL);
  end

end
^

/* empty dependent procedure body */
/* Clear: EAI_MAP_SERVICE for: SERVICE_MODIFY */
ALTER PROCEDURE EAI_MAP_SERVICE(SERVICE_TAG VARCHAR(30),
SERVICE_NAME VARCHAR(30),
EXTERNAL_IFC VARCHAR(30),
ID_HOTEL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_MAPPED_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: IMPORT_SERVICE$EXC for: SERVICE_MODIFY */
ALTER PROCEDURE IMPORT_SERVICE$EXC(SERVICE_NAME VARCHAR(30),
SERVICE_GROUP VARCHAR(30),
SERVICE_TYPE VARCHAR(50),
IS_DELETED SMALLINT,
IS_MANUAL_PRICE SMALLINT,
IS_DETAILS SMALLINT,
REVENUE_GROUP VARCHAR(50),
REVENUE_ACCOUNT VARCHAR(50),
ACCOUNT_NAME VARCHAR(30),
EXT_CODE VARCHAR(30),
VAUCHER_PACKET VARCHAR(20),
EXTRA_PACKET_NAME VARCHAR(10),
IS_RATE_PRICE SMALLINT,
IS_BREAKFAST SMALLINT,
IS_LUNCH SMALLINT,
IS_DINNER SMALLINT,
IS_EXTRAFOOD1 SMALLINT,
IS_EXTRAFOOD2 SMALLINT,
IS_BOARD SMALLINT,
PRICE NUMERIC(15,4),
PRICE_CURR VARCHAR(3),
HOTEL_NAME VARCHAR(50),
UUID VARCHAR(40))
 RETURNS(ID_SERVICE INTEGER,
ID_SERVICE_GROUP INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SERVICE_MODIFY) */
ALTER PROCEDURE SERVICE_MODIFY(ID_SERVICE TYPE OF ID,
ID_SERVICE_GROUP TYPE OF ID,
SERVICE_TYPE TYPE OF TENUM_STRING,
SERVICE_NAME TYPE OF TNAME_SHORT,
IS_DELETED TYPE OF TLOGICAL,
IS_MANUAL_PRICE TYPE OF TLOGICAL,
IS_DETAILS TYPE OF TLOGICAL,
REVENUE_GROUP TYPE OF TOBJECT_NAME,
REVENUE_ACCOUNT TYPE OF TOBJECT_NAME,
ACCOUNT_NAME TYPE OF TSEARCH_CODE,
EXT_CODE TYPE OF TSEARCH_CODE,
VAUCHER_PACKET VARCHAR(20),
EXTRA_PACKET_NAME TYPE OF TSHORT_CODE,
IS_RATE_PRICE TYPE OF TLOGICAL,
OPERATION VARCHAR(20),
ID_HOTEL TYPE OF ID_REF,
IS_BREAKFAST TYPE OF TLOGICAL = null,
IS_LUNCH TYPE OF TLOGICAL = null,
IS_DINNER TYPE OF TLOGICAL = null,
IS_EXTRAFOOD1 TYPE OF TLOGICAL = null,
IS_EXTRAFOOD2 TYPE OF TLOGICAL = null,
IS_BOARD TYPE OF TLOGICAL = null,
PRICE TYPE OF TPRICE = null,
PRICE_CURR TYPE OF TCURRENCY = null)
 RETURNS(NEW_ID_SERVICE TYPE OF ID_REF)
 AS
declare variable check_srv_group integer;
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:OPERATION in ('add', 'mod')) then begin
    check_srv_group = null;
    select sg.ID_SERVICE_GROUP
    from   SERVICE_GROUPS sg
    where  sg.ID_SERVICE_GROUP = :ID_SERVICE_GROUP
           and sg.ID_HOTEL = :ID_HOTEL
    into   :check_srv_group;

    if (:check_srv_group is null) then
       exception ASSERT 'Hotel mismatch for service and service group!';
  end

  if (:operation = 'add') then begin
    if (:SERVICE_TYPE = 'BASE') then
       exception ASSERT 'Unsupported service type: ''' || coalesce(:SERVICE_TYPE, 'null') || ''' !';
       -- BASE services are creating by another procedure */

    if (coalesce(:id_service, 0) <= 0) then
      new_id_service = gen_id(ID_SERVICE_GEN, 1);
    else new_id_service = :id_service;

    /*if ((:ext_code is null) or (:ext_code = '')) then EXT_CODE = :new_id_service;   */

    insert into SERVICES (ID_SERVICE, ID_SERVICE_GROUP, SERVICE_TYPE,
      SERVICE_NAME, IS_DELETED, IS_MANUAL_PRICE,
      IS_DETAILS, REVENUE_GROUP, REVENUE_ACCOUNT, ACCOUNT_NAME, EXT_CODE, VAUCHER_PACKET,
      EXTRA_PACKET_NAME, IS_RATE_PRICE, ID_HOTEL, PRICE, PRICE_CURR)
    values (:new_id_service, :id_service_group, :SERVICE_TYPE,
      :service_name, :is_deleted, :is_manual_price,
      :is_details, :revenue_group, :revenue_account, :account_name, :ext_code, :vaucher_packet,
      :extra_packet_name, :is_rate_price, :id_hotel, :price, :price_curr)
    returning id_service into :NEW_ID_SERVICE;

  end else if (:operation = 'mod') then begin
    update SERVICES
    set    ID_SERVICE_GROUP = :id_service_group,
           SERVICE_NAME = :service_name,
           IS_RATE_PRICE = :is_rate_price,
           IS_DELETED = :is_deleted,
           IS_MANUAL_PRICE = :is_manual_price,
           IS_DETAILS = :is_details,
           REVENUE_GROUP = :revenue_group,
           REVENUE_ACCOUNT = :revenue_account,
           ACCOUNT_NAME = :account_name,
           EXT_CODE = :ext_code,
           VAUCHER_PACKET = :vaucher_packet,
           EXTRA_PACKET_NAME = :extra_packet_name,
           PRICE = :price,
           PRICE_CURR = :price_curr
    where  ID_SERVICE = :id_service
    returning new.id_service into :NEW_ID_SERVICE;

  end else if (:operation = 'del') then begin
    delete from SERVICES S
    where  S.ID_SERVICE = :id_service;
  end

  if (:OPERATION <> 'del') then begin
    if (:SERVICE_TYPE = 'MEAL') then begin
      execute procedure SERVICE_MEAL_MODIFY$INT (:NEW_ID_SERVICE, :IS_BREAKFAST,
              :IS_LUNCH, :IS_DINNER, :IS_EXTRAFOOD1, :IS_EXTRAFOOD2, :IS_BOARD, :ID_HOTEL);
    end

    execute procedure LIST_ITEM_MODIFY(:revenue_group, null, :revenue_account, 'add');
    execute procedure LIST_ITEM_MODIFY('service_account', null, :account_name, 'add');

    execute procedure SYSTEM_CACHE_APPLY ('service_account');
  end
end
^

/* empty dependent procedure body */
/* Clear: END_WORK for: SUMMARY_FORECAST$INT */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (SUMMARY_FORECAST$INT) */
ALTER PROCEDURE SUMMARY_FORECAST$INT(ID_HOTEL INTEGER,
SUMMARY_DATE DATE)
 AS
declare variable max_busy_date date;
declare variable to_date date;
begin
  select max(rm.busy_date)
  from   ROOM_MAGIC rm
  where  rm.id_hotel = :id_hotel
  into   :max_busy_date;
  to_date = maxdate(mindate(:max_busy_date, :SUMMARY_DATE + 2*365 + 1), :SUMMARY_DATE + 1);

  execute procedure AVAILABILITY_OCCUP_PREPARE$AVL (:SUMMARY_DATE + 1, :TO_DATE, 1, 1, 0, 1, 1, 1, 1, 1, :ID_HOTEL);

  insert into SUMMARY_FORECAST (
         summary_date, forecast_date, id_room_type, id_hotel,
         rooms_capacity, rooms_ooi, res_confirmed, res_notconfirmed, res_waiting,
         res_checked_in, cont_remain, bp_remain)
  select :summary_date, tso.for_date, tso.id_room_type, tso.ID_HOTEL,
         sum(tso.g_capacity), sum(tso.g_ooi), sum(tso.res_confirmed), sum(tso.res_notconfirmed), sum(tso.res_waiting),
         sum(tso.sold), sum(tso.cont_plain_remain), sum(tso.cont_bp_remain)
  from   SMART_OCCUP$TMP tso
  where  tso.ID_HOTEL = :ID_HOTEL
  group by 2, 3, 4;

  delete
  from   SUMMARY_FORECAST sf
  where  sf.summary_date = sf.forecast_date
         and sf.ID_HOTEL = :ID_HOTEL;

  insert into SUMMARY_FORECAST (
         summary_date, forecast_date, id_room_type, id_hotel,
         rooms_capacity, rooms_ooi, res_confirmed, res_notconfirmed, res_waiting,
         res_checked_in, cont_remain, bp_remain)
  select so.for_date, so.for_date, so.id_room_type, so.id_hotel,
         sum(so.rooms_available), sum(so.rooms_ooi), 0, 0, 0,
         sum(so.rooms_sold), 0, 0
  from   SUMMARY_OCCUPANCY so
  where  so.ID_HOTEL = :ID_HOTEL
         and so.for_date <= :summary_date
  group by 1, 2, 3, 4;

end
^

/* Alter (TAR_BOARD_DECOMPOSE$INT) */
ALTER PROCEDURE TAR_BOARD_DECOMPOSE$INT(ID_BOARD TYPE OF ID,
ID_TAR_HEAD TYPE OF ID)
 RETURNS(ID_SERVICE TYPE OF ID_REF)
 AS
declare variable is_breakfast integer;
  declare variable is_lunch integer;
  declare variable is_dinner integer;
  declare variable is_extrafood1 integer;
  declare variable is_extrafood2 integer;
  declare variable id_hotel integer;
begin

  select TH.IS_BREAKFAST, TH.IS_LUNCH, TH.IS_DINNER, TH.IS_EXTRAFOOD1, TH.IS_EXTRAFOOD2, TH.ID_HOTEL
  from   MEALS TH
  where  TH.ID_BOARD = :id_board
  into   :is_breakfast, :is_lunch, :IS_DINNER, :is_extrafood1, :is_extrafood2, :ID_HOTEL;

  if (:is_breakfast = 1) then begin
    ID_SERVICE = -1;
    select first 1 TH.ID_SERVICE
    from   MEALS TH
           join TAR_BO_BOARD tb on tb.ID_BOARD = th.ID_SERVICE and tb.ID_TAR_HEAD = :ID_TAR_HEAD
    where  TH.IS_BREAKFAST = 1
           and TH.IS_LUNCH = 0
           and TH.IS_DINNER = 0
           and TH.IS_EXTRAFOOD1 = 0
           and TH.IS_EXTRAFOOD2 = 0
           and TH.IS_BOARD = 0
           and TH.ID_HOTEL = :ID_HOTEL
    order by th.IS_ARCHIVE asc, TH.ID_SERVICE asc
    into   :ID_SERVICE;
    suspend;
  end

  if (:is_lunch = 1) then begin
    ID_SERVICE = -1;
    select first 1 TH.ID_SERVICE
    from   MEALS TH
           join TAR_BO_BOARD tb on tb.ID_BOARD = th.ID_SERVICE and tb.ID_TAR_HEAD = :ID_TAR_HEAD
    where  TH.IS_BREAKFAST = 0
           and TH.IS_LUNCH = 1
           and TH.IS_DINNER = 0
           and TH.IS_EXTRAFOOD1 = 0
           and TH.IS_EXTRAFOOD2 = 0
           and TH.IS_BOARD = 0
           and TH.ID_HOTEL = :ID_HOTEL
    order by th.IS_ARCHIVE asc, TH.ID_SERVICE asc
    into   :ID_SERVICE;
    suspend;
  end

  if (:IS_DINNER = 1) then begin
    ID_SERVICE = -1;
    select first 1 TH.ID_SERVICE
    from   MEALS TH
           join TAR_BO_BOARD tb on tb.ID_BOARD = th.ID_SERVICE and tb.ID_TAR_HEAD = :ID_TAR_HEAD
    where  TH.IS_BREAKFAST = 0
           and TH.IS_LUNCH = 0
           and TH.IS_DINNER = 1
           and TH.IS_EXTRAFOOD1 = 0
           and TH.IS_EXTRAFOOD2 = 0
           and TH.IS_BOARD = 0
           and TH.ID_HOTEL = :ID_HOTEL
    order by th.IS_ARCHIVE asc, TH.ID_SERVICE asc
    into   :ID_SERVICE;
    suspend;
  end

 if (:is_extrafood1 = 1) then begin
    ID_SERVICE = -1;
    select first 1 TH.ID_SERVICE
    from   MEALS TH
           join TAR_BO_BOARD tb on tb.ID_BOARD = th.ID_SERVICE and tb.ID_TAR_HEAD = :ID_TAR_HEAD
    where  TH.IS_BREAKFAST = 0
           and TH.IS_LUNCH = 0
           and TH.IS_DINNER = 0
           and TH.IS_EXTRAFOOD1 = 1
           and TH.IS_EXTRAFOOD2 = 0
           and TH.IS_BOARD = 0
           and TH.ID_HOTEL = :ID_HOTEL
    order by th.IS_ARCHIVE asc, TH.ID_SERVICE asc
    into   :ID_SERVICE;
    suspend;
  end

  if (:is_extrafood2 = 1) then begin
    ID_SERVICE = -1;
    select first 1 TH.ID_SERVICE
    from   MEALS TH
           join TAR_BO_BOARD tb on tb.ID_BOARD = th.ID_SERVICE and tb.ID_TAR_HEAD = :ID_TAR_HEAD
    where  TH.IS_BREAKFAST = 0
           and TH.IS_LUNCH = 0
           and TH.IS_DINNER = 0
           and TH.IS_EXTRAFOOD1 = 0
           and TH.IS_EXTRAFOOD2 = 1
           and TH.IS_BOARD = 0
           and TH.ID_HOTEL = :ID_HOTEL
    order by th.IS_ARCHIVE asc, TH.ID_SERVICE asc
    into   :ID_SERVICE;
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_EVAL_DATE$INT for: TAR_CALC_EVAL_COMPLEX_RATE$INT */
ALTER PROCEDURE TAR_CALC_EVAL_DATE$INT(ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
FOR_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_EVAL_COMPLEX_RATE$INT) */
ALTER PROCEDURE TAR_CALC_EVAL_COMPLEX_RATE$INT(INPUT_DETAIL_DBKEY CHAR(8),
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
BEDS SMALLINT,
ID_TYPE_STAY INTEGER,
IS_MANUAL_TYPE_STAY SMALLINT,
ID_BOARD INTEGER,
ID_ROOM_TYPE INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
CHECKIN_DATE DATE,
DAY_OF_STAY INTEGER,
PAYORS INTEGER,
MINORS INTEGER,
PERIOD_DEPEND_ON_CHECKIN SMALLINT,
CNT_DAYS_BP INTEGER,
CNT_DAYS_BOARD INTEGER,
BOARD_TYPE_FIND VARCHAR(10),
TOTAL_GUESTS INTEGER,
SEQ_NUM INTEGER,
TARIFF_CURR CHAR(3),
REAL_RECALC SMALLINT)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_PAYORS INTEGER,
OUT_MINORS INTEGER)
 AS
declare variable id_tar_input_detail integer;
  declare variable price numeric(15,4);
  declare variable auto_stay_type integer;
  declare variable base_per_day numeric(15,4);
  declare variable board_per_day numeric(15,4);
  declare variable guest_board_weight integer;
--  declare variable guest_food varchar(20);
  declare variable match_date date;
  declare variable manual_total_gsts integer;
  declare variable manual_payors integer;
  declare variable manual_minors integer;
  declare variable service_type varchar(20);
  declare variable base_price numeric(15,4);
  declare variable board_price numeric(15,4);
  declare variable food_per_day numeric(15,4);
  declare variable base_price_tar numeric(15,4);
  declare variable custom_cross_rate double precision;
  declare variable ptext varchar(20);
  declare variable id_service integer;
  declare variable qty_post integer;
  declare variable pack_currency char(3);
  declare variable minors_input integer;
  declare variable packet_item integer;
  declare variable price_tariff numeric(15,4);
  declare variable is_inside_base integer;
  declare variable id_bo_bp integer;
  declare variable id_board_include integer;
  declare variable separate_board integer;
  declare variable incomplete_bp integer;
  declare variable id_bo_eg integer;
  declare variable id_eg_price integer;
  declare variable disc_tag varchar(50);
  declare variable id_discount_service integer;
  declare variable var_board_price numeric(15,4);
  declare variable type_stay_code varchar(10);
  declare variable id_hotel integer;
begin
  base_per_day = 0;
  board_per_day = 0;

  select TH.WEIGHT_TAG
  from   MEALS TH
  where  TH.ID_BOARD = :ID_BOARD
  into   :guest_board_weight;
  guest_board_weight = coalesce(:guest_board_weight, 0);

  /*if (:guest_board_weight = 0) then GUEST_FOOD = 'NONE';
  else GUEST_FOOD = 'SOME';*/
  if (:PERIOD_DEPEND_ON_CHECKIN = 1) then MATCH_DATE = :CHECKIN_DATE;
  else MATCH_DATE = :FOR_DATE;

  select st.TYPE_STAY_CODE
  from   TYPE_STAY st
  where  st.ID_TYPE_STAY = :id_type_stay
  into   :type_stay_code;

  if (:IS_MANUAL_TYPE_STAY = 1) then begin
    if (:type_stay_code = 'ALONE') then begin
      MANUAL_TOTAL_GSTS = 1;
      MANUAL_PAYORS = 0;
      MANUAL_MINORS = 0;
    end else if (:type_stay_code = 'BED') then begin
      MANUAL_TOTAL_GSTS = 2;
      MANUAL_PAYORS = 1;
      MANUAL_MINORS = 0;
    end else if (:type_stay_code = 'EXTRA_BED') then begin
      MANUAL_TOTAL_GSTS = :BEDS+1;
      MANUAL_PAYORS = :BEDS;
      MANUAL_MINORS = :MINORS;
    end

    execute procedure TAR_MATCH_BP(:INPUT_DETAIL_DBKEY, :MATCH_DATE, :MANUAL_TOTAL_GSTS, :MANUAL_TOTAL_GSTS,
                      :GUEST_BOARD_WEIGHT, :REAL_RECALC, :DAY_OF_STAY, :CNT_DAYS_BP)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_BP, :ID_BOARD_INCLUDE,
                      :INCOMPLETE_BP, :BASE_PRICE, :PTEXT, :BASE_PER_DAY;
  end else begin
    execute procedure TAR_MATCH_BP(:INPUT_DETAIL_DBKEY, :MATCH_DATE, :SEQ_NUM, :TOTAL_GUESTS,
                      :GUEST_BOARD_WEIGHT, :REAL_RECALC, :DAY_OF_STAY, :CNT_DAYS_BP)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_BP, :ID_BOARD_INCLUDE,
                      :INCOMPLETE_BP, :BASE_PRICE, :PTEXT, :BASE_PER_DAY;
  end

  execute procedure sys_dbg('tar base_per_day = '||coalesce(:BASE_PER_DAY, 'null'));
  execute procedure sys_dbg('tar base_price = '||coalesce(:BASE_PRICE, 'null'));
  if (:ERR_CODE < 0) then exit;

  SEPARATE_BOARD = 0;
  if (:REAL_RECALC = 1) then begin
    if (:CUSTOM_PRICE is not null) then begin
      base_price = :CUSTOM_PRICE;
      select tr.ID_HOTEL
      from   TAR_CALC_INPUT_DETAIL$TMP t
             join TARIFA tr on tr.ID_TARIFA = t.ID_TAR_HEAD
      where  t.RDB$DB_KEY = :INPUT_DETAIL_DBKEY
      into   :id_hotel;

      execute procedure CURR_CROSS_RATE_GET(:CUSTOM_CURRENCY, :TARIFF_CURR, current_timestamp, :id_hotel)
      returning_values  :custom_cross_rate;
      base_price_tar = (:custom_cross_rate * :base_price);
      pack_currency = :custom_currency;
    end else begin
      base_price_tar = :base_per_day;
      pack_currency = :tariff_curr;
    end
    /*DEBUG*/
    if (:base_price is null) then exception RATING_EXCEPTION ('4. base price is null');
    if (:base_price_tar is null) then exception RATING_EXCEPTION ('5. base price tar is null');

    select TBP.PACKET_ITEM
    from   TAR_BO_BASE_POSITION TBP
    where  TBP.ID_TAR_BP = :id_bo_bp
    into   :packet_item;

    insert into TAR_CALC_OUTPUT$TMP (
           ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
           FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
           CURRENCY, CURRENCY_TARIFF, REQUIRED_ID_PACKET_ITEM)
    values (:ID_TAR_INPUT, :ID_TAR_CALC, -1, 'BASE',
           :FOR_DATE, :BASE_PER_DAY, :BASE_PRICE_TAR, 'BASE', 1, :PTEXT,
           :PACK_CURRENCY, :TARIFF_CURR, :packet_item);
    /* BOARDS */
    var_board_price = 0;
    for
      select TMB.ERR_CODE, TMB.ERR_TEXT, TMB.SEPARATE_BOARD, TMB.BOARD_PRICE, TMB.PTEXT,
             TMB.SERVICE_TYPE, TMB.ID_SERVICE, TMB.FOOD_PER_DAY, TMB.PACKET_ITEM
      from   TAR_MATCH_BOARD(:INPUT_DETAIL_DBKEY, :id_bo_bp, :BOARD_TYPE_FIND,
             :ID_BOARD, :id_board_include, :match_date, :base_per_day,
             :DAY_OF_STAY, :CNT_DAYS_BOARD, :CNT_DAYS_BP, :CUSTOM_PRICE) TMB
      into   :err_code, :err_text, :separate_board, :board_price, :ptext,
             :service_type, :id_service, :food_per_day, :packet_item
    do begin
      if (:ERR_CODE < 0) then exit;

      /*DEBUG*/
      if (:board_price is null) then exception RATING_EXCEPTION ('6. board_price is null');
      if (:id_service is null) then exception RATING_EXCEPTION ('7. id_service is null');

      insert into TAR_CALC_OUTPUT$TMP (
             ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
             FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
             CURRENCY, CURRENCY_TARIFF, REQUIRED_ID_PACKET_ITEM)
      values (:ID_TAR_INPUT, :ID_TAR_CALC, :ID_SERVICE, :SERVICE_TYPE,
             :FOR_DATE, :food_per_day, :food_per_day, 'FOOD', 1, :PTEXT,
             :TARIFF_CURR, :TARIFF_CURR, :packet_item);

      -- board_per_day = (:board_per_day + :food_per_day); ???
      var_board_price = :var_board_price + iif(:service_type in ('BASE_BOARD', 'EXTRA_BOARD'), :food_per_day, 0);
    end

    select TID.ID_TAR_INPUT_DETAIL
    from   TAR_CALC_INPUT_DETAIL$TMP TID
    where  tid.RDB$DB_KEY = :INPUT_DETAIL_DBKEY
    into   :id_tar_input_detail;

    execute procedure TAR_SET_VAR('board='||:VAR_BOARD_PRICE, :id_tar_input_detail, :id_tar_calc);
  end

  if (:SEPARATE_BOARD is null) then SEPARATE_BOARD = 0;
  minors_input = :MINORS;

  if (:IS_MANUAL_TYPE_STAY = 1) then begin
    /* ONLY TO FIND THE REAL POSITION PAYORS, MINORS ARE NOT IMPORTANT
    || ALL OTHER GUESTS IN THE ROOM MUST SEE THE MANUAL ONE AS AUTOMATIC. SO
    || HERE WE ARE FINDING HIS AUTOMATIC TYPE STAY.
    */
    execute procedure TAR_MATCH_EG(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :total_guests, :PAYORS, :MINORS, :MATCH_DATE, :INCOMPLETE_BP, :ID_ROOM_TYPE, 1)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_EG, :ID_EG_PRICE, :PAYORS, :MINORS, :AUTO_STAY_TYPE;
    if (:ERR_CODE < 0) then exit;
    /* REAL PRICE FIND AND EVAL */
    execute procedure TAR_MATCH_MANUAL_EG(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :MANUAL_TOTAL_GSTS, :MANUAL_PAYORS, :MANUAL_MINORS, :MATCH_DATE, :INCOMPLETE_BP, :ID_TYPE_STAY)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_EG, :ID_EG_PRICE, :AUTO_STAY_TYPE;
    if (:ERR_CODE < 0) then exit;

    if ((:MINORS = :minors_input) and
        (exists (select *
                 from   TYPE_STAY TS
                 where  TS.ID_TYPE_STAY = :ID_TYPE_STAY
                        and TS.TYPE_STAY_CODE = 'EXTRA_BED'))) then begin
      /* TO MANAGE PARAMETER "EXTRA GUEST IN TURN" WHEN MANUAL SET TO ADD */
      MINORS = :MINORS + 1;
      PAYORS = :PAYORS - 1;
    end
  end else begin
    execute procedure TAR_MATCH_EG(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :TOTAL_GUESTS, :PAYORS, :MINORS, :MATCH_DATE, :INCOMPLETE_BP, :ID_ROOM_TYPE, 0)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_BO_EG, :ID_EG_PRICE, :PAYORS, :MINORS, :AUTO_STAY_TYPE;
    if (:ERR_CODE < 0) then exit;
  end

  update TAR_CALC_INPUT_DETAIL$TMP TID
  set    TID.SEPARATE_BOARD = :SEPARATE_BOARD,
         TID.ID_TYPE_STAY   = :AUTO_STAY_TYPE
  where  TID.RDB$DB_KEY = :INPUT_DETAIL_DBKEY;

  if (:REAL_RECALC = 1) then begin
    if (:CUSTOM_PRICE is null) then begin
      for
        select TSP.SERVICE_TYPE, TSP.PRICE,  TSP.PTEXT, TSP.ERR_CODE, TSP.ID_SERVICE
        from   TAR_PRICES_SET_EG(:ID_TAR_INPUT, :FOR_DATE, :DAY_OF_STAY, :CNT_DAYS_BP,
               :CNT_DAYS_BOARD, :guest_board_weight, :id_bo_eg, :id_eg_price, :base_price) TSP
        into   :service_type, :price,  :ptext, :ERR_CODE, :id_service
      do begin
        if (:ERR_CODE < 0) then exit; -- exception INTERNAL_RATING_EXCEPTION;

        /*DEBUG*/
        if (:PRICE is null) then exception RATING_EXCEPTION ('8. price is null');
        if (:ID_SERVICE is null) then exception RATING_EXCEPTION ('9. id_service is null');

        insert into TAR_CALC_OUTPUT$TMP (
               ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
               FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
               CURRENCY, CURRENCY_TARIFF, REQUIRED_ID_PACKET_ITEM)
        values (:ID_TAR_INPUT, :ID_TAR_CALC, :id_service, :service_type,
               :FOR_DATE, :price, :price, 'EG', 1, :ptext,
               :TARIFF_CURR, :TARIFF_CURR, :packet_item);
      end
    end

    for
      select TMT.ID_SERVICE, TMT.SERVICE_TYPE, TMT.PRICE, TMT.PRICE_TARIFF, TMT.QTY_POST,
             TMT.PTEXT, TMT.PACK_CURRENCY, TMT.ERR_CODE, TMT.ERR_TEXT, TMT.PACKET_ITEM, TMT.DISC_TAG
      from   TAR_PRICES_SET_PACKS(:INPUT_DETAIL_DBKEY, :ID_BO_BP, :DAY_OF_STAY, :CUSTOM_PRICE) TMT
      into   :ID_SERVICE, :SERVICE_TYPE, :PRICE, :PRICE_TARIFF, :QTY_POST,
             :PTEXT, :PACK_CURRENCY, :ERR_CODE, :ERR_TEXT, :PACKET_ITEM, :DISC_TAG
    do begin
      if (:ERR_CODE < 0) then exit; --exception INTERNAL_RATING_EXCEPTION;
      /*DEBUG*/
      if (:price_tariff is null) then exception RATING_EXCEPTION ('10. PRICE_TARIFF is null');
      if (:id_service is null) then exception RATING_EXCEPTION ('11. ID_SERVICE is null');

      insert into TAR_CALC_OUTPUT$TMP (
             ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
             FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
             CURRENCY, CURRENCY_TARIFF, DISC_TAG, REQUIRED_ID_PACKET_ITEM)
      values (:ID_TAR_INPUT, :ID_TAR_CALC, :ID_SERVICE, :SERVICE_TYPE,
             :FOR_DATE, :PRICE, :PRICE_TARIFF, 'PACK', :QTY_POST, :PTEXT,
             :PACK_CURRENCY, :TARIFF_CURR, :DISC_TAG, :packet_item);

    end

    for
      select TMT.ID_SERVICE, TMT.SERVICE_TYPE, TMT.PRICE, TMT.PTEXT, TMT.ERR_CODE, TMT.ERR_TEXT, TMT.PACKET_ITEM,
             TMT.IS_INSIDE_BASE, TMT.DISC_TAG, TMT.ID_DISCOUNT_SERVICE
      from   TAR_PRICES_SET_TAX(:ID_TAR_INPUT, :INPUT_DETAIL_DBKEY, :ID_BO_BP, :DAY_OF_STAY) tmt
      into   :ID_SERVICE, :SERVICE_TYPE, :PRICE, :PTEXT, :ERR_CODE, :ERR_TEXT, :PACKET_ITEM,
             :IS_INSIDE_BASE, :DISC_TAG, :ID_DISCOUNT_SERVICE
    do begin
      if (:ERR_CODE < 0) then exit; --exception INTERNAL_RATING_EXCEPTION;
      if ((:IS_INSIDE_BASE = 0) and (:CUSTOM_PRICE is not null)) then begin
        -- SKIP IT. SIMPLE DISCOUNTS MUST NOT CHANGE THE CUSTOM PRICE
      end else begin
        /*DEBUG*/
        if (:PRICE is null) then exception RATING_EXCEPTION ('12. price is null');
        if (:ID_SERVICE is null) then exception RATING_EXCEPTION ('13. id_service is null');
        -- !!! Service type and id_service of discount is as object that they discounting but in TAR_CALC_REPOST$INT type and id_service is changed to PACKAGES if discounts have ID_DISCOUNT_SERVICE
        if ((:DISC_TAG = '') or (:DISC_TAG is null)) then DISC_TAG =  'DISC';
        insert into TAR_CALC_OUTPUT$TMP (
               ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
               FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT,
               CURRENCY, CURRENCY_TARIFF, DISC_TAG, ID_DISCOUNT_SERVICE, REQUIRED_ID_PACKET_ITEM)
        values (:ID_TAR_INPUT, :ID_TAR_CALC, :ID_SERVICE, :SERVICE_TYPE,
               :FOR_DATE, :PRICE, :PRICE, 'DISC', 1, :PTEXT,
               :TARIFF_CURR, :TARIFF_CURR, :DISC_TAG, :id_discount_service, :packet_item);

        execute procedure sys_dbg('tar TAR_CALC_EVAL_DATE$INT - :DISC_TAG=' || coalesce(:DISC_TAG, 'null') );
      end
    end
  end

  OUT_MINORS = :MINORS;
  OUT_PAYORS = :PAYORS;
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_EVAL_ALL$INT for: TAR_CALC_EVAL_DATE$INT */
ALTER PROCEDURE TAR_CALC_EVAL_ALL$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_EVAL_DATE$INT) */
ALTER PROCEDURE TAR_CALC_EVAL_DATE$INT(ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
FOR_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_input integer;
declare variable checkin_date date;
declare variable day_of_stay integer;
declare variable real_recalc integer;
declare variable id_guest integer;
declare variable input_detail_dbkey char(8);
declare variable id_room_type integer;
declare variable id_board integer;
declare variable id_tar_head integer;
declare variable id_type_stay integer;
declare variable id_hotel integer;
declare variable period_depend_on_checkin integer;
declare variable cnt_days_board integer;
declare variable cnt_days_bp integer;
declare variable tariff_curr char(3);
declare variable board_type_find varchar(10);
declare variable id_room integer;
declare variable custom_price numeric(15,4);
declare variable custom_currency char(3);
declare variable id_tar_input_detail integer;
declare variable is_simple integer;
declare variable guest_age integer;
declare variable tar_name varchar(50);
declare variable guest_name varchar(50);
declare variable total_guests integer;
declare variable old_id_room integer;
declare variable beds integer;
declare variable payors integer;
declare variable minors integer;
declare variable int_err_text varchar(255);
declare variable is_manual_type_stay smallint;
declare variable seq_num integer;
declare variable current_child_num integer;
declare variable current_adult_num integer;
begin
  ERR_CODE = 0;
  OLD_ID_ROOM = NULL;
  for
    select   TCI.ID_TAR_INPUT, TCI.FROM_DATE, (:FOR_DATE - TCI.FROM_DATE + 1),
             TCI.REAL_RECALC, TCI.ID_GUEST, TCID.RDB$DB_KEY, TCID.ID_ROOM_TYPE,
             TCID.ID_BOARD, TCID.ID_TAR_HEAD, TCID.ID_TYPE_STAY, TCID.IS_MANUAL_TYPE_STAY, T.ID_HOTEL,
             TH.PERIOD_DEPEND_ON_CHECKIN, TH.CNT_DAYS_PRICE_BOARD, TH.CNT_DAYS_PRICE_BP, T.CURR, TH.BOARD_TYPE,
             TCID.ID_ROOM, TCID.CUSTOM_PRICE, TCID.CUSTOM_CURRENCY,
             TCID.ID_TAR_INPUT_DETAIL, TH.IS_SIMPLE, TCI.GUEST_AGE
    from     TAR_CALC_INPUT_DETAIL$TMP TCID
             join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
             join TAR_HEAD TH on TH.ID_TAR_HEAD = TCID.ID_TAR_HEAD
             join TARIFA T on T.ID_TARIFA = TH.ID_TAR_HEAD
    where    TCI.ID_TAR_CALC = :ID_TAR_CALC
             and TCI.ROOM_STATUS = :ROOM_STATUS
             and TCID.FOR_DATE = :FOR_DATE
    order by TCID.ID_ROOM asc,
             iif(TCI.IS_CHILD = 1, TCI.GUEST_AGE, 999) desc,
             --iif(TCI.GUEST_AGE > 16, 999, TCI.GUEST_AGE) desc,
             TCID.CHECKIN_ORDER asc,
             TCI.ID_GUEST asc
             /* ADULTS MUST BE HANDLED FIRST, THEN BY CHECKIN ORDER and ID_GUEST because of shares */
    into     :id_tar_input, :checkin_date, :day_of_stay,
             :real_recalc, :id_guest, :input_detail_dbkey, :id_room_type,
             :id_board, :id_tar_head, :id_type_stay, :is_manual_type_stay, :id_hotel,
             :period_depend_on_checkin, :cnt_days_board, :cnt_days_bp, :tariff_curr, :board_type_find,
             :id_room, :custom_price, :custom_currency,
             :id_tar_input_detail, :is_simple, :guest_age

  do begin
    if (coalesce(:id_room_type, -1) < 0) then exception RATING_EXCEPTION 'Unspecified room type!';
    if (coalesce(:id_type_stay, -1) < 0) then exception RATING_EXCEPTION 'Unspecified type stay!';
    --if (coalesce(:id_board, -1) < 0) then exception ASSERT 'Unspecified board!';
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    /* - - - - - PART 1 - For Both Simple and Complex Rates - */
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    select count(*)
    from   TAR_CALC_INPUT_DETAIL$TMP TCID
           join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
    where  TCI.ID_TAR_CALC = :ID_TAR_CALC
           and TCID.FOR_DATE = :FOR_DATE
           and TCID.ID_ROOM = :ID_ROOM
    into   :TOTAL_GUESTS;

    if (:TOTAL_GUESTS = 0) then exit;
  
    select RT.BEDS
    from   ROOM_TYPES RT
    where  RT.ID_ROOM_TYPE = :ID_ROOM_TYPE
    into   :BEDS;

    if (:IS_SIMPLE = 1) then begin
      /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
      /* - - - - - - - PART 2 - Simple Rates - - - - - - - - -  */
      /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
      if (:old_id_room is distinct from :id_room) then begin
        current_adult_num = 0;
        current_child_num = 0;
        old_id_room = :id_room;
      end

      execute procedure TAR_CALC_EVAL_SIMPLE_RATE$INT (:id_tar_input_detail, :id_tar_input, :ID_TAR_CALC,
              :FOR_DATE, :id_tar_head, :beds, :guest_age, :id_type_stay, :is_manual_type_stay, :id_board, :id_room_type,
              :custom_price, :custom_currency, :id_hotel, :total_guests, :current_adult_num, :current_child_num)
      returning_values (:ERR_CODE, :int_err_text, :current_adult_num, :current_child_num);
      if (:ERR_CODE < 0) then exception INTERNAL_RATING_EXCEPTION;

    end else begin
      /* - - -  - - - - - - - - - - - -  - - - - - - - - */
      /* - - -  - PART 3 - Complex Rates - - - - - - - - */
      /* - - -  - - - - - - - - - - - -  - - - - - - - - */
      if (:old_id_room is distinct from :id_room) then begin
        payors  = 0;
        minors  = 0;
        old_id_room = :id_room;
        seq_num = 0;
      end
      seq_num = :seq_num + 1;

      execute procedure TAR_CALC_EVAL_COMPLEX_RATE$INT (:input_detail_dbkey, :id_tar_input, :ID_TAR_CALC,
              :FOR_DATE, :beds, :id_type_stay, :is_manual_type_stay, :id_board, :id_room_type, :custom_price, :custom_currency,
              :checkin_date, :day_of_stay, :payors, :minors, :period_depend_on_checkin, :cnt_days_bp, :cnt_days_board,
              :board_type_find, :total_guests, :seq_num, :tariff_curr, :real_recalc)
      returning_values (:ERR_CODE, :int_err_text, :payors, :minors);
      if (:ERR_CODE < 0) then exception INTERNAL_RATING_EXCEPTION;
    end
  /* - --- - END PART 3 - complex Rates*/
  end

  when exception INTERNAL_RATING_EXCEPTION do begin
    if (coalesce(:ERR_CODE, 0) = 0) then ERR_CODE = -211;
    select TH.TARIFA_NAME
    from   TARIFA TH
    where  TH.ID_TARIFA = :ID_TAR_HEAD
    into   :TAR_NAME;

    select GC.GUEST_NAME1
    from   GUEST_CARD GC
    where  GC.ID_GUEST = :ID_GUEST
    into   :GUEST_NAME;
    ERR_TEXT = substring('GUEST='||cast(:ID_GUEST as varchar(20))||'-'||:GUEST_NAME||f_crlf()
                         || 'DATE='||:FOR_DATE||f_crlf()
                         || 'TARIFF='||:TAR_NAME||f_crlf()
                         || :int_err_text
                        from 1 for 255);

    exit;
  end
end
^

/* Alter (TAR_CALC_EVAL_SIMPLE_RATE$INT) */
ALTER PROCEDURE TAR_CALC_EVAL_SIMPLE_RATE$INT(ID_TAR_INPUT_DETAIL INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
ID_TAR_HEAD INTEGER,
BEDS SMALLINT,
GUEST_AGE INTEGER,
ID_TYPE_STAY INTEGER,
IS_MANUAL_TYPE_STAY INTEGER,
ID_BOARD INTEGER,
ID_ROOM_TYPE INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
ID_HOTEL INTEGER,
TOTAL_GUESTS INTEGER,
CURRENT_ADULT_NUM INTEGER,
CURRENT_CHILD_NUM INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
NEW_CURRENT_ADULT_NUM INTEGER,
NEW_CURRENT_CHILD_NUM INTEGER)
 AS
declare variable id_tar_simple integer;
  declare variable child_age_incl integer;
  declare variable is_adult_by_sample_rate integer;
  declare variable type_stay_code varchar(10);
  declare variable board_price numeric(15,4);
  declare variable price numeric(15,4);
  declare variable calc_total_guests integer;
  declare variable calc_adult_num integer;
  declare variable calc_child_num integer;
  declare variable curr char(3);
  declare variable custom_cross_rate double precision ;
  declare variable board_id_service integer;
begin
  select TS.ID_TAR_SIMPLE, TS.CHILD_AGE_INCL
  from   TAR_SIMPLE TS
  where  ts.ID_TAR_HEAD = :ID_TAR_HEAD
  into   :id_tar_simple, :child_age_incl;

  /*Find current guest num */
  if (:GUEST_AGE <= :child_age_incl) then is_adult_by_sample_rate = 0; else is_adult_by_sample_rate = 1;
  if (:is_adult_by_sample_rate = 0) then begin
    NEW_CURRENT_ADULT_NUM = :CURRENT_ADULT_NUM;
    NEW_CURRENT_CHILD_NUM = :CURRENT_CHILD_NUM + 1;
  end else begin
    NEW_CURRENT_ADULT_NUM = :CURRENT_ADULT_NUM + 1;
    NEW_CURRENT_CHILD_NUM = :CURRENT_CHILD_NUM;
  end
  /*!!!!!!!!!! setup type stai according manual or room type  */

  select st.TYPE_STAY_CODE
  from   TYPE_STAY st
  where  st.ID_TYPE_STAY = :id_type_stay
  into   :type_stay_code;

  if (:IS_MANUAL_TYPE_STAY = 1) then begin
    if (:type_stay_code = 'ALONE') then begin  /*SGL*/
      calc_total_guests = 1;
      calc_adult_num = 1;
      calc_child_num = 1;
    end else if (:type_stay_code = 'BED') then begin  /*TWN*/
      calc_total_guests = 2;
      calc_adult_num = 1;
      calc_child_num = 1;
    end else if (:type_stay_code = 'EXTRA_BED') then begin  /*ADD*/
      calc_total_guests = :beds + 1;
      calc_adult_num = :beds + 1;
      calc_child_num = :beds + 1;
    end
  end else begin
    calc_total_guests = :TOTAL_GUESTS;
    calc_adult_num = :NEW_CURRENT_ADULT_NUM;
    calc_child_num = :NEW_CURRENT_CHILD_NUM;
  end
  /*Calc price */
  board_price = null;
  price = null;
  /* Calc base rate and board */
  execute procedure TAR_CALC_SIMPLERATE_PRICE$INT ( :id_tar_simple, :FOR_DATE, :CALC_TOTAL_GUESTS, :CALC_ADULT_NUM, :CALC_CHILD_NUM,
                    :is_adult_by_sample_rate, :ID_BOARD, :ID_ROOM_TYPE)
  returning_values (:ERR_CODE, :ERR_TEXT, :PRICE, :CURR, :BOARD_PRICE);
  if (:ERR_CODE < 0) then exit;

  /*Handle Custom price*/
  if (:CUSTOM_PRICE is not null ) then begin
    execute procedure CURR_CROSS_RATE_GET(:CUSTOM_CURRENCY, :CURR, current_timestamp, :id_hotel)
    returning_values  :CUSTOM_CROSS_RATE;
    PRICE = :CUSTOM_PRICE * :CUSTOM_CROSS_RATE;
  end
  /* Board price is always included in simple rates - deduct it from base*/
  if (:board_price is not null ) then begin
    price = :price - :board_price;
    /*if base price become minus - board is reduced to base and base become 0*/
    if (:price < 0) then begin
      board_price = board_price + price;
      price = 0;
    end
  end
  /*Put base price in output tbl*/
  /*DEBUG*/
  if (:price is null) then exception RATING_EXCEPTION ('1. price is null');

  insert into TAR_CALC_OUTPUT$TMP (
        ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
        FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT, CURRENCY, CURRENCY_TARIFF)
  values (:ID_TAR_INPUT, :ID_TAR_CALC, -1, 'BASE',
        :FOR_DATE, :price, :price, 'BASE', 1, '', :curr, :curr);
  /*Put Boards in output*/
  if (:board_price is not null ) then begin
    /*Allways separate boards if price is defined in rate*/
    update  TAR_CALC_INPUT_DETAIL$TMP TCID
    set     TCID.SEPARATE_BOARD = 1,
            TCID.ID_BOARD_INCLUDE = :ID_BOARD
    where   TCID.ID_TAR_INPUT_DETAIL = :ID_TAR_INPUT_DETAIL;

    select S.ID_SERVICE
    from   MEALS S
    where  S.ID_BOARD = :ID_BOARD
    into   :board_id_service;

    /*DEBUG*/
    if (:board_price is null) then exception RATING_EXCEPTION ('2. board price is null');
    if (:board_id_service is null) then exception RATING_EXCEPTION ('3. board_id_service is null');

    insert into TAR_CALC_OUTPUT$TMP (
         ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
         FOR_DATE, PRICE, PRICE_TARIFF, PRICE_NOTE, QTY_POST, PTEXT, CURRENCY, CURRENCY_TARIFF)
    values (:ID_TAR_INPUT, :ID_TAR_CALC, :BOARD_ID_SERVICE, 'BASE_BOARD',
         :FOR_DATE, :board_price, :board_price, 'FOOD', 1, '', :curr, :curr);
  end
end
^

/* empty dependent procedure body */
/* Clear: PRODUCT_RATING$INT for: TAR_CALC_POST_PREPARE$INT */
ALTER PROCEDURE PRODUCT_RATING$INT(ID_HOTEL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
ADULT_AGES VARCHAR(100) = null,
CHILD_AGES VARCHAR(100) = null,
ID_TAR_CALC_COMMON INTEGER = null)
 RETURNS(ROOM_PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_POST_PREPARE$INT) */
ALTER PROCEDURE TAR_CALC_POST_PREPARE$INT(ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
  declare variable id_service integer;
  declare variable id_tariff integer;
  declare variable date_post date;
  declare variable qty_post integer;
  declare variable price_orig numeric(15,4);
  declare variable round_to numeric(15,4);
  declare variable curr_orig char(3);
  declare variable id_room integer;
  declare variable short_code varchar(255);
  declare variable id_reserv integer;
begin

  delete
  from   TAR_CALC_POST$TMP TCP
  where  TCP.ID_TAR_CALC = :id_tar_calc;

/* Find all Discounts with services : Move ID_DISCOUNT_SERVICE to ID_SERVICE; Change them to PACKETS - in order to receive separate postings */
  update  TAR_CALC_OUTPUT$TMP TCO
  set     tco.service_type = 'PACKETS',
          tco.id_service = tco.id_discount_service
  where   TCO.id_tar_calc = :id_tar_calc
          and tco.price_note = 'DISC'
          and tco.id_discount_service > 0;
    
  for
    select TOB.ID_GUEST, TOB.ID_RESERV, TOB.ID_SERVICE, TOB.ID_TARIFF, TOB.DATE_POST, TOB.QTY_POST,
           round_f(TOB.PRICE_ORIG, c.ROUND_TO), TOB.CURR_ORIG, TOB.ID_ROOM, TOB.SHORT_CODE, c.ROUND_TO
    from   TAR_OUTPUT_BASE(:id_tar_calc) TOB
           left outer join CURRS c on c.CURR = tob.CURR_ORIG
    into   :id_guest, :id_reserv, :id_service, :id_tariff, :date_post, :qty_post,
           :price_orig, :curr_orig, :id_room, :short_code, :round_to
  do begin
    insert into TAR_CALC_POST$TMP(ID_GUEST, ID_RESERV, ID_SERVICE, ID_TARIFF, DATE_POST, QTY_POST,
           PRICE_ORIG, CURR_ORIG, ID_ROOM, IS_BASE, ID_TAR_CALC, SHORT_CODE)
    values(:id_guest, :id_reserv, :id_service, :id_tariff, :date_post, :qty_post,
           :price_orig, :curr_orig, :id_room, 1, :id_tar_calc, :short_code);

    for
        select   TCO.ID_SERVICE, TCO.PRICE_NOTE,
                 max(TCO.QTY_POST), round_f(sum(TCO.PRICE_TARIFF), :round_to)
        from     TAR_CALC_OUTPUT$TMP TCO
                 join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCO.ID_TAR_INPUT
                 left outer join SERVICES S on S.ID_SERVICE = TCO.ID_SERVICE
        where    TCO.ID_TAR_CALC = :id_tar_calc
                 and TCO.SERVICE_TYPE = 'PACKETS'
                 and TCI.ID_GUEST = :id_guest
                 and TCO.FOR_DATE = :date_post
        group by TCO.ID_SERVICE, TCO.PRICE_NOTE
        into     :id_service, :short_code, :qty_post, :price_orig
    do begin
      insert into TAR_CALC_POST$TMP(ID_GUEST, ID_RESERV, ID_SERVICE, ID_TARIFF, DATE_POST,
             QTY_POST, PRICE_ORIG, CURR_ORIG, ID_ROOM, IS_BASE, ID_TAR_CALC, SHORT_CODE)
      values(:id_guest, :id_reserv, :id_service, :id_tariff, :date_post, :qty_post,
             :price_orig, :curr_orig, :id_room, 0, :id_tar_calc, :short_code);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: GUEST_POST_GET_PACK_SERVICE for: TAR_GET_BASE_SERVICE$INT */
ALTER PROCEDURE GUEST_POST_GET_PACK_SERVICE(IN_ID_SERVICE INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_POST DATE)
 RETURNS(ID_PACK_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_GET_BASE_SERVICE$INT) */
ALTER PROCEDURE TAR_GET_BASE_SERVICE$INT(ID_TYPE_STAY INTEGER,
ID_ROOM_TYPE INTEGER,
ID_BOARD INTEGER,
ID_HOTEL INTEGER)
 RETURNS(ID_SERVICE INTEGER)
 AS
declare variable args varchar(255);
begin
  id_service = null;
  select first 1 S.ID_SERVICE
  from   SERVICE_PACKET SP
         join SERVICES s on s.ID_SERVICE = sp.ID_SERVICE
  where  Sp.ID_ROOM_TYPE = :id_room_type
         and Sp.ID_TYPE_STAY = :id_type_stay
         and sp.ID_BOARD = :id_board
  order by s.IS_DELETED asc, s.ID_SERVICE desc
  into   :id_service;

  if (:id_service is null) then begin
    select coalesce((select h.HOTEL_NAME from HOTEL H where h.ID_HOTEL = :ID_HOTEL), '<null>') || f_character(28)
           || coalesce((select rt.TYPE_ROOM from ROOM_TYPES RT where rt.ID_ROOM_TYPE = :ID_ROOM_TYPE), '<null>') || f_character(28)
           || coalesce((select ts.TYPE_STAY from TYPE_STAY ts where ts.ID_TYPE_STAY = :ID_TYPE_STAY), '<null>') || f_character(28)
           || coalesce((select s.NAME from MEALS s where s.ID_BOARD = :ID_BOARD), '<null>')
    from   RDB$DATABASE r
    into   :args;

    execute procedure sys_dbg('TAR_GET_BASE_SERVICE id_rt: '|| :ID_ROOM_TYPE|| f_crlf()
                              || 'id_ts: '|| :ID_TYPE_STAY|| f_crlf()
                              || 'id_board: ' || :ID_BOARD);
    exception RATING_EXCEPTION '-81' || f_character(31) || f_character(29) || :args;
  end
end
^

/* Alter (TAR_MATCH_BOARD) */
ALTER PROCEDURE TAR_MATCH_BOARD(TID_DBKEY CHAR(8),
ID_TAR_BP INTEGER,
BOARD_TYPE_FIND VARCHAR(10),
ID_BOARD INTEGER,
ID_BOARD_INCLUDE INTEGER,
MATCH_DATE DATE,
BASE_PER_DAY NUMERIC(15,4),
DAY_OF_STAY INTEGER,
CNT_DAYS_BOARD INTEGER,
CNT_DAYS_BP INTEGER,
CUSTOM_PRICE NUMERIC(15,4))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SEPARATE_BOARD INTEGER,
SERVICE_TYPE VARCHAR(20),
BOARD_PRICE NUMERIC(15,4),
PTEXT VARCHAR(20),
ID_SERVICE INTEGER,
FOOD_PER_DAY NUMERIC(15,4),
PACKET_ITEM INTEGER,
DISC_TAG VARCHAR(50))
 AS
declare variable id_tar_head integer;
  declare variable id_tar_calc integer;
  declare variable ID_BO_BOARD integer;
  declare variable ID_TAR_BO_PRICE integer;
  declare variable param_filter varchar(2000);
  declare variable param_data varchar(2000);
  declare variable filter_result double precision;
  declare variable success integer;
  declare variable id_tar_board_tmp integer;
  declare variable board_name varchar(50);
  declare variable no_use numeric(15, 4);
  declare variable price_type varchar(20);
  declare variable is_board_in_bp integer;
  declare variable id_meal integer;
  declare variable delim integer;
  declare variable set_var varchar(255);
  declare variable rnd_method varchar(20);
  declare variable id_tar_input_detail integer;
  declare variable round_to numeric(15,4) ;
  declare variable meal_chksum integer;
begin
  err_code = 0;
  err_text = '';
  id_tar_bo_price = -1;
  separate_board = 0;
  id_bo_board = -1;
  success = 0;
  packet_item = null;
  if (:id_board = 0) then exit;

  if (:board_type_find = 'HRANI') then begin
    for
      select BTF.ID_SERVICE
      from   BOARD_TO_FOODS(:id_board) BTF
      into   :id_meal
    do begin
      for
        select ERR_CODE, ERR_TEXT, SEPARATE_BOARD, SERVICE_TYPE, BOARD_PRICE,
               PTEXT, ID_SERVICE, FOOD_PER_DAY, DISC_TAG
        from   TAR_MATCH_BOARD(:tid_dbkey, :id_tar_bp, 'TO_HRANI',
                               :id_meal, :id_board_include, :match_date,
                               :base_per_day, :day_of_stay, :cnt_days_board, :cnt_days_bp, :custom_price)
        into   :err_code, :err_text, :separate_board, :service_type, :board_price,
               :ptext, :id_service, :food_per_day, :disc_tag
      do suspend;
    end
    exit;
  end

  meal_chksum = null;
  select m.CHKSUM
  from   MEALS m
  where  m.ID_SERVICE = :ID_BOARD
         and m.IS_BOARD = 0
  into   :meal_chksum;

  for
    select   TBB.ID_TAR_BOARD, TRBP.PARAM_FILTER, TBB.ID_SERVICE, TBB.PACKET_ITEM, TBB.SET_VAR, TCI.ID_TAR_CALC,
             TCID.ID_TAR_HEAD, TCID.PARAM_VALUES, TBB.SEPARATE_BOARD, TBB.PTEXT, TBB.DISC_TAG, TBB.RND_METHOD,
             TCID.ID_TAR_INPUT_DETAIL
    from     TAR_CALC_INPUT_DETAIL$TMP TCID
             join  TAR_CALC_INPUT$TMP TCI
               on  TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
             join TAR_BO_BOARD TBB
               on  TBB.ID_TAR_HEAD = TCID.ID_TAR_HEAD
             join TAR_BO_RELATION TRBP
               on  TRBP.ID_BO = TBB.ID_TAR_BOARD
               and TRBP.BO_TYPE = 'BOARD'
             join MEALS m on m.ID_SERVICE = tbb.ID_BOARD
    where    TCID.RDB$DB_KEY = :tid_dbkey
             and TRBP.ID_TAR_BP = :id_tar_bp
             and ((M.ID_SERVICE = :id_board) or (m.CHKSUM = :meal_chksum))
    into     :id_tar_board_tmp, :param_filter, :id_service, :packet_item, :set_var, :id_tar_calc,
             :id_tar_head, :param_data, :separate_board, :ptext, :disc_tag, :rnd_method,
             :id_tar_input_detail
  do begin
    execute procedure TAR_EVAL_FILTER(:param_filter, :param_data, :id_tar_input_detail)
    returning_values  :err_code, :filter_result;
    if (:err_code < 0) then begin suspend; exit; end
    if (:filter_result = 1) then begin
      id_bo_board = :id_tar_board_tmp;
      success = 1;
      break;
    end
  end
  execute procedure SETTING_GET_VALUE('RANGE_DATA_DELIMETER', null)
  returning_values  :delim;

  if (exists (select *
              from   TAR_HEAD TH
              where  TH.ID_TAR_HEAD = :id_tar_head
                     and f_character(:delim)||TH.BASE_BOARDS_LIST||f_character(:delim) containing f_character(:delim)||:id_board||f_character(:delim)))
  then begin
    service_type = 'BASE_BOARD';
    disc_tag = 'FB';
  end else begin
    service_type = 'EXTRA_BOARD';
    disc_tag = 'FE';
  end

  if (:success = 0) then begin
    if ((:board_type_find = 'BOARD') and (:id_board_include is distinct from :id_board)) then begin
      /* NOT FOUND BOARD */
      err_code = -234;
      select T.NAME
      from   MEALS T
      where  T.ID_BOARD = :id_board
      into   :board_name;
      err_text = 'BOARD='||coalesce(:board_name, '<null>');
      suspend;
      exit;
    end else if (:board_type_find = 'TO_HRANI') then begin
      if (not exists(
        select *
        from   BOARD_TO_FOODS(:id_board_include) BTF
        where  BTF.ID_SERVICE = :id_board
      )) then begin
        err_code = -234;
        select T.NAME
        from   MEALS T
        where  T.ID_BOARD = :id_board
        into   :board_name;
        err_text = 'BOARD='||coalesce(:board_name, '<null>');
        suspend;
        exit;
      end
    end
    /* ONLY IF THE BOARD IN THE BASE POSITION FULLY SATISFIES THE BOARD LOOKUP
    || OR IT IS PART OF THE LOOKING BOARD
    */
    update TAR_CALC_INPUT_DETAIL$TMP TID
    set    TID.ID_BOARD_INCLUDE = :id_board_include
    where  TID.RDB$DB_KEY = :tid_dbkey;

    exit;
  end

  if (:id_bo_board <> -1) then begin
    execute procedure TAR_SET_VAR(:set_var, :id_tar_input_detail, :id_tar_calc);
    --
    execute procedure TAR_MATCH_PRICE(:id_tar_head, :id_bo_board, 'BOARD', :match_date)
    returning_values  :err_code, :err_text, :id_tar_bo_price;
    if (:err_code < 0) then begin suspend; exit; end
    /* FIRST WE HAVE TO DECIDE WEATHER THE BOARD IS IN THE BASE PRICE */
    if (:custom_price is not null) then is_board_in_bp = 1;
    else if (:board_type_find = 'TO_HRANI') then begin
      if (exists (
        select *
        from   BOARD_TO_FOODS(:id_board_include) BTF
        where  BTF.ID_SERVICE = :id_board))
      then is_board_in_bp = 1;
      else is_board_in_bp = 0;
    end else begin
      if (:id_board_include = :id_board) then is_board_in_bp = 1;
      else is_board_in_bp = 0;
    end

    select TP.PRICE_VALUE, TP.PRICE_TYPE
    from   TAR_BO_PRICE_GET(:id_tar_bo_price) TP
    into   :board_price, :price_type;

    select c.ROUND_TO
    from   TARIFA t
           join CURRS c on c.CURR = t.CURR
    where  t.ID_TARIFA = :id_tar_head
    into   :round_to;

    execute procedure TAR_EVAL_PRICE(:price_type, :board_price, :base_per_day, :is_board_in_bp,
            :rnd_method, :round_to, :id_tar_input_detail)
    returning_values  :err_code, :board_price, :no_use;

    FOOD_PER_DAY = :BOARD_PRICE;
    if (:CNT_DAYS_BOARD > 1) then begin
      execute procedure TAR_EVAL_PRICE('DIVIDE', :CNT_DAYS_BOARD, :BOARD_PRICE, 0, :rnd_method, :round_to, :id_tar_input_detail)
      returning_values  :err_code, :food_per_day, :no_use;
      if (:err_code < 0) then exit;
      food_per_day = round_f(:food_per_day, 0.01);
  
      if ((mod(:DAY_OF_STAY, :CNT_DAYS_BOARD) = 0)) then food_per_day = :BOARD_PRICE - (:CNT_DAYS_BOARD - 1) * :FOOD_PER_DAY;
    end

    suspend;

    if (:is_board_in_bp = 1) then begin
      id_service = -1;
      service_type = 'BASE';
      disc_tag = 'F';
      FOOD_PER_DAY  = -:FOOD_PER_DAY;
       /* THIS SUSPEND IS FOR THE REDUCTION OF THE BASE PRICE */
      suspend;
    end
  end else begin
    board_price = 0;  /* !!!! suspend  */
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_POST_PREPARE$INT for: TAR_OUTPUT_BASE */
ALTER PROCEDURE TAR_CALC_POST_PREPARE$INT(ID_TAR_CALC INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (TAR_OUTPUT_BASE) */
ALTER PROCEDURE TAR_OUTPUT_BASE(ID_TAR_CALC INTEGER)
 RETURNS(ID_GUEST INTEGER,
ID_RESERV INTEGER,
ID_SERVICE INTEGER,
ID_TARIFF INTEGER,
DATE_POST DATE,
QTY_POST INTEGER,
PRICE_ORIG NUMERIC(15,4),
CURR_ORIG CHAR(3),
SHORT_CODE VARCHAR(255),
ID_ROOM INTEGER)
 AS
declare variable ptext varchar(20);
  declare variable id_tar_input integer;
  declare variable separate_board integer;
  declare variable id_type_stay integer;
  declare variable id_room_type integer;
  declare variable id_board integer;
  declare variable base_orig numeric(15,4);
  declare variable board_orig numeric(15,4);
  declare variable id_food_service integer;
  declare variable id_found_board integer;
  declare variable id_hotel integer;
begin

  for
    select   TCI.ID_TAR_INPUT, TCI.ID_GUEST, tci.ID_RESERV
    from     TAR_CALC_INPUT$TMP TCI
    where    TCI.ID_TAR_CALC = :id_tar_calc
    order by TCI.ID_GUEST asc
    into     :id_tar_input, :id_guest, :id_reserv
  do begin
    for
      select   TCO.FOR_DATE, TCO.CURRENCY_TARIFF, sum(TCO.PRICE_TARIFF)
      from     TAR_CALC_OUTPUT$TMP TCO
      where    TCO.ID_TAR_INPUT = :id_tar_input
               and TCO.SERVICE_TYPE = 'BASE'
      group by TCO.FOR_DATE, TCO.CURRENCY_TARIFF
      order by TCO.FOR_DATE asc
      into     :date_post, :curr_orig, :base_orig
    do begin
      if (:base_orig < 0) then base_orig = 0;
      qty_post = 1;
      select TCID.ID_BOARD, TCID.ID_ROOM_TYPE, TCID.ID_TYPE_STAY, TCID.SEPARATE_BOARD,
             TCID.ID_BOARD_INCLUDE, TCID.ID_TAR_HEAD, TCID.ID_ROOM, t.ID_HOTEL
      from   TAR_CALC_INPUT_DETAIL$TMP TCID
             join TARIFA T on T.ID_TARIFA = tcid.ID_TAR_HEAD
      where  TCID.ID_TAR_INPUT = :id_tar_input
             and TCID.FOR_DATE = :date_post
      into   :id_board, :id_room_type, :id_type_stay, :separate_board,
             :id_found_board, :id_tariff, :id_room, :id_hotel;

      short_code = '';
      for
        select TCO.PTEXT
        from   TAR_CALC_OUTPUT$TMP TCO
        where  TCO.ID_TAR_INPUT = :id_tar_input
               and TCO.SERVICE_TYPE = 'BASE'
               and TCO.FOR_DATE = :date_post
        into   :ptext
      do if ((:ptext <> '') and (StrPos(:ptext, short_code)=0)) then short_code = substring(:short_code||' '||:ptext from 1 for 255);

      if (:separate_board <> 0) then begin
        --TODO a new separate field may be used for modified SERVICE_TYPE
        update   TAR_CALC_OUTPUT$TMP TCO
        set      TCO.SERVICE_TYPE = 'PACKETS'
        where    TCO.ID_TAR_INPUT = :id_tar_input
                 and TCO.SERVICE_TYPE in ('BASE_BOARD', 'EXTRA_BOARD')
                 and TCO.FOR_DATE = :date_post;
        /* WEHAVE SEPARATE BOARD OR FOOD */
        price_orig = :base_orig;
        if ((:id_found_board is null) or (:id_found_board = -1)) then begin
          id_found_board = null;
          select first 1 m.ID_BOARD
          from   MEALS m
          where  m.IS_ARCHIVE = 0
                 and m.IS_BREAKFAST = 0
                 and m.IS_LUNCH = 0
                 and m.IS_DINNER = 0
                 and m.IS_EXTRAFOOD1 = 0
                 and m.IS_EXTRAFOOD2 = 0
                 and m.IS_BOARD = 1
                 and m.ID_HOTEL = :id_hotel
          order by m.ID_BOARD asc
          into   :id_found_board;
          if (:id_found_board is null) then exception RATING_EXCEPTION '-82';
        end

        execute procedure TAR_GET_BASE_SERVICE$INT(:id_type_stay, :id_room_type, :id_found_board, :id_hotel)
        returning_values  :id_service;
        suspend;

      end else begin
        /* THE BOARD IS IN THE BASE SERVICE */
        execute procedure TAR_GET_BASE_SERVICE$INT(:id_type_stay, :id_room_type, :id_board, :id_hotel)
        returning_values  :id_service;

        board_orig = null;
        for
          select   TCO.ID_SERVICE, sum(TCO.PRICE_TARIFF)
          from     TAR_CALC_OUTPUT$TMP TCO
          where    TCO.ID_TAR_INPUT = :id_tar_input
                   and TCO.SERVICE_TYPE in ('BASE_BOARD', 'EXTRA_BOARD')
                   and TCO.FOR_DATE = :date_post
          group by TCO.ID_SERVICE
          into     :id_food_service, :board_orig
        do begin
          for
            select TCO.PTEXT
            from   TAR_CALC_OUTPUT$TMP TCO
            where  TCO.ID_TAR_INPUT = :id_tar_input
                   and TCO.SERVICE_TYPE in ('BASE_BOARD', 'EXTRA_BOARD')
                   and TCO.FOR_DATE = :date_post
                   and TCO.ID_SERVICE = :id_food_service
            into   :ptext
          do if ((:ptext <> '') and (StrPos(:ptext, short_code)=0)) then short_code = substring(:short_code||' '||:ptext from 1 for 255);
        end

        price_orig = coalesce(:board_orig, 0) + :base_orig;

        suspend;
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE for: TAR_SAVE_BO_BOARD */
ALTER PROCEDURE TAR_SAVE(ID_TAR_HEAD INTEGER,
PERIOD_DEPEND_ON_CHECKIN INTEGER,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BASE_BOARDS_LIST VARCHAR(255),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
BO_TYPE VARCHAR(20),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_SAVE_BO_BOARD) */
ALTER PROCEDURE TAR_SAVE_BO_BOARD(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable id_tar_season integer;
  declare variable iteration varchar(20);
/*****************************************************/
  declare variable id_tar_board integer;
  declare variable id_board integer;
  declare variable id_service integer;
  declare variable pos_numbers varchar(2000);
  declare variable ptext varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable separate_board integer;
  declare variable id_bo_price integer;
  declare variable price_type varchar(20);
  declare variable price_type_equal_exists integer;
  declare variable is_board integer;
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  err_text = '';
  iteration = 'FIRST';
  price_type_equal_exists = 0;

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :id_tar_season, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      param_filter = :data||:season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      execute procedure TAR_SAVE_PARSE_PNUM(:id_tar_head, :id_tar_board, :bo_type, :pos_numbers, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then exit;
      if (:price_type_equal_exists = 1) then begin
        if (exists(
          select *
          from   TAR_BO_RELATION TBR
                 join TAR_BO_BASE_POSITION TBB on TBR.ID_TAR_BP = TBB.ID_TAR_BP
          where  TBR.ID_BO = :id_tar_board
                 and TBR.BO_TYPE = 'BOARD'
                 and TBB.ID_BOARD_INCLUDE is not distinct from :id_board
        )) then begin
          err_code = -237;
          exit;
        end
      end
      price_type_equal_exists = 0;
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_board = gen_id(GEN_TAR_BO_BOARD_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      pos_numbers = '';
      id_board = null;
      separate_board = 0;
      ptext = '';
      disc_tag = 'F';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      packet_item = null;
    end
    if (:iteration = 'MIDDLE') then begin
      if (:param_name = 'PTEXT') then ptext = :data;
      else if (:param_name = 'DISC_TAG')      then disc_tag = :data;
      else if (:param_name = 'SET_VAR')       then set_var = :data;
      else if (:param_name = 'ROUND_TYPE')    then rnd_method = :data;
      else if (:param_name = 'LIST_BASE_POS') then pos_numbers = :data;
      else if (:param_name = 'SEPARATE_BOARD') then begin
        separate_board = :data;
        if ((:separate_board = 0) and (:board_type = 'HRANI')) then err_code = -226;
      end else if (:param_name = 'CHECKIN_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'NIGHT_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'PACKET_ITEM') then begin
        packet_item = :data;
      end else if (:param_name = 'HRANI') then begin
        if (:data = -1) then err_code = -210;
        else begin
          id_service = :data;
          select m.IS_BOARD
          from   MEALS M
          where  M.ID_SERVICE = :id_service
          into   :is_board;
          id_board = :id_service;

          if ((:is_board = 1) and (:board_type = 'HRANI')) then err_code = -228;
          else if ((:is_board = 0) and (:board_type = 'BOARD')) then err_code = -229;
        end
      end
      if (:err_code < 0) then exit;
      if ((:id_tar_season <> -1) and (:iteration = 'MIDDLE')) then begin
        /* WE ARE STARTING THE SEASON PRICES SO: */
        if ((:id_board is null) or (:id_board = -1)) then err_code = -210;
        else if ((:separate_board = 0) and (:board_type = 'HRANI')) then err_code = -226;
        if (:err_code < 0) then exit;
        if ((:separate_board = 1) and (:board_type = 'HRANI')) then separate_board = 2;
        insert into TAR_BO_BOARD(ID_TAR_BOARD, ID_TAR_HEAD, ID_SERVICE, ID_BOARD, PTEXT, SEPARATE_BOARD,
                    PACKET_ITEM, DISC_TAG, SET_VAR, RND_METHOD)
        values (:id_tar_board, :id_tar_head, :id_service, :id_board, :ptext, :separate_board,
               :packet_item, :disc_tag, :set_var, :rnd_method);
        iteration = 'SEASON_PRICES';
      end
    end
    if (:iteration = 'SEASON_PRICES') then begin
      execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_board, :bo_type, :id_tar_season)
      returning_values  :err_code, :id_bo_price, :price_type;
      if (:price_type = 'EQUAL') then begin
        if (:board_type = 'HRANI') then err_code = -225;
        price_type_equal_exists = 1;
      end
      if (:err_code < 0) then exit;
    end
  end
  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:BO_TYPE||', '||:err_text;
  end
end
^

/* Alter (TAR_SAVE_BO_BP) */
ALTER PROCEDURE TAR_SAVE_BO_BP(ID_TAR_HEAD INTEGER,
BO_TYPE VARCHAR(20))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable no_use integer;
  declare variable data varchar(2000);
  declare variable end_of_line integer;
  declare variable id_tar_season integer;
  declare variable iteration varchar(20);
/*****************************************************/
  declare variable id_tar_bp integer;
  declare variable position_number varchar(20);
  declare variable id_room_type integer;
  declare variable max_persons integer;
  declare variable id_board_include integer;
  declare variable is_price_for_room integer;
  declare variable ptext varchar(20);
  declare variable price_type varchar(20);
  declare variable param_filter varchar(2000);
  declare variable season_filter varchar(2000);
  declare variable board_weight integer;
  declare variable packet_item integer;
  declare variable disc_tag varchar(20);
  declare variable set_var varchar(50);
  declare variable rnd_method varchar(20);
begin
  err_code = 0;
  iteration = 'FIRST';

  for
    select  TSP.COL_NAME, TSP.ROW_ID, TSP.ID_TAR_SEASON, TSP.DATA, TSP.END_OF_LINE, TSP.COL_ID
    from    TAR_SAVE_PARSE(:id_tar_head, :bo_type) TSP
    into    :param_name, :row_id, :id_tar_season, :data, :end_of_line, :col_id
  do begin
    if (:end_of_line = 1) then begin
      param_filter = :data||season_filter;
      execute procedure TAR_SAVE_PARSE_PARAM(:id_tar_head, :bo_type, :param_filter)
      returning_values  :err_code;
      if (:err_code < 0) then begin err_text = 'OBJECT='||:bo_type; exit; end
      insert into TAR_BO_RELATION(ID_TAR_BP, BO_TYPE, ID_BO, PARAM_FILTER)
      values (:id_tar_bp, :bo_type, :id_tar_bp, :param_filter);
    end
    if ((:end_of_line = 1) or (:iteration='FIRST')) then begin
      iteration='MIDDLE';
      id_tar_bp = gen_id(GEN_TAR_BO_BP_ID, 1);
      /* INITIALIZE WITH DEFAULT VALUES */
      position_number = null;
      id_room_type = null;
      max_persons = null;
      id_board_include = -1;
      is_price_for_room = 0;
      ptext = '';
      disc_tag = 'B';
      set_var = '';
      rnd_method = 'MATH';
      season_filter = '';
      packet_item = null;
    end
    if (:iteration = 'MIDDLE') then begin
      if (:param_name = 'BASE_POS')            then begin
        if (:data = '') then err_code = -203;
        else position_number = :data;
      end else if (:param_name = 'ROOM_TYPE')  then begin
        if (:data = '') then err_code = -204;
        else id_room_type = :data;
      end else if (:param_name = 'MAX_PERSONS')then begin
        if (:data = '') then err_code = -205;
        else max_persons = :data;
      end else if (:param_name = 'CHECKIN_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'NIGHT_SEASON') then begin
        execute procedure TAR_SAVE_PARSE_SEASON(:id_tar_head, :data)
        returning_values  :err_code, :season_filter;
        if (:season_filter <> '') then season_filter = ' and ('||:season_filter||')';
      end else if (:param_name = 'BOARD')      then id_board_include = :data;
      else if (:param_name = 'BPRICE_ROOM')    then is_price_for_room = :data;
      else if (:param_name = 'PACKET_ITEM')    then packet_item = :data;
      else if (:param_name = 'PTEXT')          then ptext = :data;
      else if (:param_name = 'DISC_TAG')       then disc_tag = :data;
      else if (:param_name = 'SET_VAR')        then set_var = :data;
      else if (:param_name = 'ROUND_TYPE')     then rnd_method = :data;
      if (:err_code < 0) then exit;
      if ((:id_tar_season <> -1) and (:iteration = 'MIDDLE')) then begin
        /* WE ARE STARTING THE SEASON PRICES SO: */
        board_weight = null;
        select m.WEIGHT_TAG
        from   MEALS M
        where  m.ID_BOARD = :id_board_include
        into   :board_weight;
        board_weight = coalesce(:board_weight, 0);

        insert into TAR_BO_BASE_POSITION(
          ID_TAR_BP, ID_TAR_HEAD, POSITION_NUMBER, ID_ROOM_TYPE, MAX_PERSONS, SET_VAR, RND_METHOD,
          ID_BOARD_INCLUDE, BOARD_WEIGHT, IS_PRICE_FOR_ROOM, PTEXT, PACKET_ITEM, DISC_TAG)
        values (
          :id_tar_bp, :id_tar_head, :position_number, :id_room_type, :max_persons, :set_var, :rnd_method,
          :id_board_include, :board_weight, :is_price_for_room, :ptext, :packet_item, :disc_tag);
       iteration = 'SEASON_PRICES';
      end
    end
    if (:iteration = 'SEASON_PRICES') then begin
      execute procedure TAR_SAVE_PARSE_PRICE(:data, :id_tar_bp, :bo_type, :id_tar_season)
      returning_values  :err_code, :no_use, :price_type;
      if (:err_code < 0) then exit;
    end
  end
  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||:BO_TYPE||', '||:err_text;
  end
end
^

/* Alter (TARIFA_BOARDS_SUPPORTED) */
ALTER PROCEDURE TARIFA_BOARDS_SUPPORTED(ID_TAR_HEAD INTEGER)
 RETURNS(ID_BOARD INTEGER)
 AS
declare variable is_simlpe integer;
declare variable id_hotel integer;
declare variable board_type varchar(10);
begin

  /*Looks into simple and complex rates and returns boards present in rate in format ,ID,ID, */

  select th.is_simple, t.ID_HOTEL, th.board_type
  from   TAR_HEAD th
         join TARIFA T on T.ID_TARIFA = th.ID_TAR_HEAD
  where  th.id_tar_head = :id_tar_head
  into   :is_simlpe, :id_hotel, :board_type;

  if (:is_simlpe is distinct from 1) then begin
    /*Complex*/
    if (:board_type = 'BOARD') then begin
      for
        select distinct tbpo.id_board_include
        from   TAR_BO_BASE_POSITION tbpo
        where  tbpo.id_tar_head = :id_tar_head
        union
        select distinct tbb.id_board
        from   TAR_BO_BOARD tbb
               join TAR_HEAD th on th.id_tar_head = tbb.id_tar_head
        where  th.id_tar_head = :id_tar_head

        into   :id_board
      do begin
        suspend;
      end
    end else begin
      -- board_type =  'HRANI' !!! MOJE DA SE POUMNI
      -- Ako tarifata e sa prosti hrani, ne se analizira kakwi kombinacii sa wazmojni, a se wra6tat wsi4ki hrani */
      for
        select h.ID_BOARD
        from   MEALS h
        where  h.IS_BOARD = 1
               and h.ID_HOTEL = :id_hotel
        into   :id_board
      do begin
        suspend;
      end
    end

  end else begin
    /*Simple*/
    for
      select distinct tsp.ID_BOARD
      from   TAR_SIMPLE_PRICE tsp
             join TAR_SIMPLE_SEASON tss on tsp.id_tar_simple_season = tss.id_tar_simple_season
             join TAR_SIMPLE ts on ts.id_tar_simple = tss.id_tar_simple
      where  ts.id_tar_head = :id_tar_head
      into   :id_board
    do begin
      suspend;
    end

  end

end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_PARAMS$INT for: TARIFA_GET_PARAM */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TARIFA_GET_PARAM) */
ALTER PROCEDURE TARIFA_GET_PARAM(ID_PARAM INTEGER,
FOR_DATE DATE,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER)
 RETURNS(OUT_VALUE VARCHAR(255))
 AS
declare variable is_interface integer;
  declare variable param_code varchar(30);
  declare variable is_value integer;
  declare variable int1 integer;
  declare variable data_type varchar(10);
  declare variable pvalue varchar(20);
  declare variable from_ date;
  declare variable to_ date;
begin
  select TP.IS_INTERFACE, TP.PARAM_CODE, TP.IS_VALUE, TP.DATA_TYPE, TP.PVALUE
  from   TARIFA_PARAMS TP
  where  ID_TARIFA_PARAM = :ID_PARAM 
  into   :is_interface, :param_code, :is_value, :data_type, :pvalue;
  /*get interface params*/
  if (:PARAM_CODE = 'NATION2') then
    PARAM_CODE = 'NATION'; /* !!!!!!!!!! */

  /*get value params*/
  if (:IS_VALUE = 1) then
    OUT_VALUE = :pvalue;

  /*get internal params*/
  OUT_VALUE = null;
  if (:IS_INTERFACE = 0) then begin
    if (:PARAM_CODE = 'TODAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE, 'D;dd/mm/yyyy');

    end else if (:PARAM_CODE = 'WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE, 'DW;MON');

    end else if (:PARAM_CODE = 'NEXT_DATE_WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE + 1, 'DW;MON');

    end else if (:PARAM_CODE = 'PREV_DATE_WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE - 1, 'DW;MON');

    end else if (:PARAM_CODE = 'REQUIRED_WEEK_DAYS') then begin
      select maxdate(ti.FROM_DATE, :FOR_DATE -3), mindate(ti.TO_DATE -1, :FOR_DATE +3)
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :from_, :to_;
      
      for
        select formatdate(RLP.OUT_DATE, 'DW;MON')
        from   SYSTEM_LOOP_PERIOD(:from_, :to_) RLP
        into   :int1
      do OUT_VALUE = :OUT_VALUE||','||:int1;

    end else if (:PARAM_CODE = 'ARRIVAL_WEEK_DAYS') then begin
      select formatdate(ti.FROM_DATE, 'DW;MON')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'PRESTOI') then begin
      select cast(ti.TO_DATE - ti.FROM_DATE as integer)
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'FROM_DATE') then begin
      select formatdate(ti.FROM_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TO_DATE') then begin
      select formatdate(ti.TO_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'FIRST_NIGHT') then begin
      select formatdate(ti.FROM_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'LAST_NIGHT') then begin
      select formatdate(ti.TO_DATE - 1, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'DAYS_PASSED') then begin
       /* 01  03 -  01-1, 02-2   (        )*/   
       select cast((:FOR_DATE - G.FROM_DATE + 1) as integer)
       from   TAR_CALC_INPUT$TMP G
       where  G.ID_TAR_INPUT = :ID_TAR_INPUT
       into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'DAYS_TO_STAY') then begin
       /* 01  03 -  01-2, 02-1    (  )*/
       select cast((G.TO_DATE - :FOR_DATE - 1) as integer)
       from   TAR_CALC_INPUT$TMP G
       where  G.ID_TAR_INPUT = :ID_TAR_INPUT
       into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_GUESTS') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_CHILDREN') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.IS_CHILD = 1
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_ADULTS') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.IS_CHILD is distinct from 1
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_GUESTS_BY_ACCOUNT') then begin
      select (select count(*)
              from   GUEST G
                     join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
              where  G.ID_BASE_ACCOUNT = ti.ID_BASE_ACCOUNT
                     and G.FROM_DATE <= :FOR_DATE
                     and G.TO_DATE > :FOR_DATE
                     and RD.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP ti
      where  ti.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TYPE_ROOM') then begin
      select trim(rt.TYPE_ROOM)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join ROOM_TYPES RT on RT.ID_ROOM_TYPE = tid.ID_ROOM_TYPE
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
      into   :OUT_VALUE;
      /* TO PRESEVE COMPATIBILITY WITH OLD TARIFF VERSIONS */
      /* WE HAVE TO RETURN THE NAME NOT THE ID !           */

    end else if (:PARAM_CODE = 'TYPE_STAY') then begin
      select trim(ts.TYPE_STAY)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join TYPE_STAY TS on ts.ID_TYPE_STAY = tid.ID_TYPE_STAY
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TYPE_HRANA') then  begin
      select trim(m.NAME)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join MEALS m on m.ID_BOARD = tid.ID_BOARD
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;
      OUT_VALUE = trim(coalesce(:OUT_VALUE, ''));

    end else if (:PARAM_CODE = 'PACK_ITEMS') then begin
      OUT_VALUE = null;
      select TID.PACKET_ITEMS
      from   TAR_CALC_INPUT$TMP TID
      where  TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;
      OUT_VALUE = coalesce(:OUT_VALUE, '~~');
      -- strfloateval('POS("~2~", :PACK_ITEMS)>0', ';:PACK_ITEMS,STRING,~2~3~D~')

    end else if (:PARAM_CODE = 'AGE') then begin
      select ti.GUEST_AGE
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_SEX') then begin
      select G.GUEST_SEX
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE ;
      if ((:OUT_VALUE is null) or (:OUT_VALUE = '')) then OUT_VALUE = '-' ;

    end else if (:PARAM_CODE = 'NATION') then begin
      select tid.COUNTRY_CODE
      from   TAR_CALC_INPUT$TMP TID
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_FIRST_DATE') then begin
      select cast(iif(G.FROM_DATE = :FOR_DATE, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_LAST_DATE') then begin
      select cast(iif(G.TO_DATE -1 = :FOR_DATE, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_LATE_CHECKOUT') then begin
      select g.IS_LATE_CHECKOUT
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_FIRST_GUEST_IN_ROOM') then begin
      select (select count(ti.ID_TAR_INPUT)
              from   TAR_CALC_INPUT$TMP ti
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and ti.ID_GUEST < t.ID_GUEST)
      from   TAR_CALC_INPUT$TMP t
      where  t.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :int1;

      if (:int1 = 0) then OUT_VALUE = 1; else OUT_VALUE = 0;
      
    end else if (:PARAM_CODE = 'IS_DIFER_NATIONS') then begin
      select (select cast(iif(count(distinct ti.COUNTRY_CODE) > 1, 1, 0) as integer)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_GROUP') then begin
      select cast(iif(g.ID_GROUP is not null, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_NIGHTS_BY_ACCOUNT') then begin
      /*          . */
      select (select cast(sum (G_IN_R.TO_DATE - G_IN_R.FROM_DATE) as integer)
              from   GUEST G_IN_R
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_R.ID_RESERV_DETAIL
              where  G_IN_R.ID_BASE_ACCOUNT = G.ID_BASE_ACCOUNT
                     and G_IN_R.CHECK_STATUS = 0
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_INTURN_BYACCOUNT') then begin
      select (select cast(count(G.ID_GUEST) as integer)
              from   GUEST G
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL and rd.IS_ANUL = 0
              where  G.ID_BASE_ACCOUNT = t.ID_BASE_ACCOUNT
                     and G.ID_GUEST <= t.ID_GUEST)
      from   TAR_CALC_INPUT$TMP t
      where  t.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'PAX_PRICE_WO_ADDINS') then begin
      /*             */
      /* PRICE_ORIG          */
      -- ?????    ???
      /*select  max(AP.PRICE_ORIG)
      from    ACCOUNT_POST AP 
      where   AP.ID_GUEST = :ID_GUEST
              and AP.DATE_POST = :FOR_DATE
              and AP.IS_BASE = 1
      plan    (AP index (ACCOUNT_POST_IDX6))
      into    :OUT_VALUE;
      */
      OUT_VALUE = null;

    end else if (:PARAM_CODE = 'ROOM_FEATURES') then begin
      select substring(R.FEATURES from 1 for 255)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join ROOMS R on r.ID_ROOM = tid.ID_ROOM
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_NIGHTS') then begin
      select (select cast(sum (G_IN_V.TO_DATE - G_IN_V.FROM_DATE) as integer)
              from   GUEST G_IN_V
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_V.ID_RESERV_DETAIL
              where  rd.ID_AGENT_PROFILE is not distinct from G.ID_AGENT_PROFILE
                     and G_IN_V.VAUCHER_NUM = G.VOUCHER_NUM
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE ;

    end else if (:PARAM_CODE = 'VAUCHER_GUESTS') then begin
      select (select count (G_IN_V.ID_GUEST)
              from   GUEST G_IN_V
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_V.ID_RESERV_DETAIL and rd.IS_ANUL = 0
              where  rd.ID_AGENT_PROFILE is not distinct from G.ID_AGENT_PROFILE
                     and G_IN_V.VAUCHER_NUM = G.VOUCHER_NUM
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_DATE') then begin
      select formatdate(G.VOUCHER_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_TEXT') then begin
      select G.VOUCHER_TEXT
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_INTURN_BYROOM') then begin
      select (select count(*) + 1
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ((t.IS_CHILD = 0 and ti.IS_CHILD = 0 and td.CHECKIN_ORDER < tid.CHECKIN_ORDER)
                          or (t.IS_CHILD = 1 and ((ti.IS_CHILD = 0) or (ti.GUEST_AGE > t.GUEST_AGE) or (ti.GUEST_AGE = t.GUEST_AGE and td.CHECKIN_ORDER < tid.CHECKIN_ORDER) )))
              )
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'ADULT_INTURN_BYROOM') then begin
      OUT_VALUE = 0;
      select (select count(*) + 1
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and td.CHECKIN_ORDER < tid.CHECKIN_ORDER
                     and ti.IS_CHILD = 0)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
             and t.IS_CHILD = 0
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'CHILD_INTURN_BYROOM') then begin
      OUT_VALUE = 0;
      select (select count(*) + 1
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ( (ti.GUEST_AGE > t.GUEST_AGE) or (ti.GUEST_AGE = t.GUEST_AGE and td.CHECKIN_ORDER < tid.CHECKIN_ORDER) )
                     and ti.IS_CHILD = 1)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
             and t.IS_CHILD = 1
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_TYPE') then begin
      select G.ID_GUEST_TYPE
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else begin
      exception RATING_EXCEPTION 'Unsupported param - '||:PARAM_CODE;
    end

  end /*PART OF INTERNAL PARAMS*/


  /**********************************************/
  begin
    /* the source of the next check is gone with the wind
    /* but we must distinguish different data types */
    if ((:OUT_VALUE is null) or (:OUT_VALUE = '')) then begin
      /*not allow nulls*/
      if (:DATA_TYPE = 'DATE') then OUT_VALUE = '01/01/1899';
      else OUT_VALUE = '-1';  -- Unspecified
    end else if (:DATA_TYPE = 'INTEGER') then begin
      OUT_VALUE = cast(:OUT_VALUE as integer);
      /* to prevent errors like OUT_VALUE = '00001' */
    end

    when any do exception RATING_EXCEPTION 'Unsupported param value: ' || :param_code || ' = "' || coalesce(:OUT_VALUE, '<null>') || '"';
  end
  /**********************************************/
end
^

/* Alter (TEST_BOOKING_IMPORT) */
ALTER PROCEDURE TEST_BOOKING_IMPORT AS
declare variable dbg varchar(255);
  declare variable booking_id integer;
begin
  dbg = null;
  EXECUTE PROCEDURE IMPORT_BOOKING$EXC ('SOL NESSEBAR BAY', 'EXP.3', null, null, 0,
  cast('17.11.2008' as date), null, cast('19.11.2008' as date),
  null, null, null, null, null, 'LARGE_ROOM', 'BB', null, null, '????????', 'MIXED', 'EXPEDIA-BAY',
  null, null, null, null, '?????? ??????', null, null, null, null, 'Business - Corporate',
  'Companies (FIR)', 'E-Mail (EMA)', 'Advert (ANZ)', 'Activities (ANI)', 'A room with a view.(4)',
  null, null, 2, 2, 'e43a4cc0-7d73-47cc-bd07-a98c18c714a3', null, '0D074F966A187B2A9912B5F0E213FEB4',
  0, 0, 0, null, null, null, null, null, null, null, null, null, null,  null, null, null, null, null, null, null, null)
  returning_values (:dbg, :booking_id, :dbg, :dbg);
  dbg = null;
end
^

/* Alter (UPDATE_BOOKING$EXC) */
ALTER PROCEDURE UPDATE_BOOKING$EXC(BOOKING_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE INTEGER,
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA_ID INTEGER,
POSTING_ROUTING VARCHAR(20),
ID_AGENT_ACCOUNT INTEGER,
RATE_ID INTEGER,
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD_CODE TFOOD_CODE,
ARRANGER_PROFILE_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable hotel_id integer;
  declare variable warn_code integer;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable rd_dbkey char(8);
  declare variable current_status_code smallint;
BEGIN
  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => START(' || :booking_id || ')');

  select RD.RDB$DB_KEY, RD.ID_HOTEL, RD.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :booking_id
  into  :rd_dbkey, :hotel_id, :current_status_code;

  execute procedure update_posting_transaction$exc(:rd_dbkey, :posting_transaction_uuid, 0);

  /* lock all guests */
  update guest set ORPHANED_IMPORT$EXC=1 where id_reserv_detail=:booking_id;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_GUARANTEE$RSV');
  execute procedure RES_SAVE_GUARANTEE$RSV(
    :booking_id, :is_vip, :current_status_code, :id_guarantee_policy,
    :deposit_required, :deposit_required_currency, :block_cc,
    :guarantee_deposit_percent, :guarantee_deposit_nights, :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_STAY$RSV');
  execute procedure RES_SAVE_STAY$RSV(
    :booking_id, :arrival, :departure, :is_late_departure,
    :arrival_type, 0
  ) returning_values :share_err_code, :err_text, :share_transaction_id, :warn_code;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_BOARD$INT');
  execute procedure RES_SAVE_BOARD$INT(
    :rd_dbkey, :board_id
  ) ;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_OTHER$RSV');
  execute procedure RES_SAVE_OTHER$RSV(
    :booking_id, :transfer_in_time, :transfer_in_note,
    :transfer_out_time, transfer_out_note, :first_food_code
  ) ;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_ROOM$EXC(room_type_id=>' || coalesce(:room_type_id, '<null>') || ')');
  execute procedure RES_SAVE_ROOM$EXC(
    :rd_dbkey, :room_type_id, :maintance_shema_id, :room_preferences, :special_treatment, :split_on_checkin
  ) returning_values :err_text, :warn_code, :share_transaction_id, :share_err_code;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_MARKETING$RSV');
  execute procedure RES_SAVE_MARKETING$RSV(
    :booking_id, :marketing1_id, :marketing2_id, :marketing3_id, :marketing4_id, :marketing5_id
  ) returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_RATE$RSV(:rate_id=>'
  || coalesce(:rate_id, '<null>')
  || ', :booking_id=>' || coalesce(:booking_id, '<null>')
  || ', :manual_price=>' || coalesce(:manual_price, '<null>')
  || ', :manual_price_currency=>' || coalesce(:manual_price_currency, '<null>')
  || ', :is_different_rate=>' || coalesce(:is_different_rate, '<null>')
  || ')');
  execute procedure RES_SAVE_RATE$RSV(
    :booking_id, :rate_id, :manual_price, :manual_price_currency,
    :is_different_rate, :is_different_price, 0
  );

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_VOUCHER$RSV');
  execute procedure RES_SAVE_VOUCHER$RSV(
    :booking_id, :voucher, :voucher_date, :voucher_text, null,  null
  );

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_NOTE$RSV');
  execute procedure RES_SAVE_NOTE$RSV(
    :booking_id, :note, :note_reminders);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_ACCOUNTING$RSV(arranger_profile_id=>'
    || coalesce(:arranger_profile_id, '<null>')
    || ', posting_routing=>' || coalesce(:posting_routing, '<null>')
    || ', id_agent_account=>' || coalesce(:id_agent_account, '<null>')
    || ')');
  execute procedure RES_SAVE_ACCOUNTING$INT(
    :rd_dbkey, :arranger_profile_id,
    :id_agent_account,
    :posting_routing,
    :guest_payment_type_id,
    :arranger_payment_type_id,
    :reserv_group_id
  ) ;

  /*execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_PACKET$RSV');
  execute procedure RES_SAVE_PACKET$RSV(
    :booking_id, :packet_id, 0
  );
  */
  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_EATING_OBJECT$RSV');
  execute procedure RES_SAVE_EATING_OBJECT$RSV(:booking_id, :id_eating_object);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => END(' || :booking_id || ')');
END
^

/* Restore proc. body: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER)
 AS
declare variable id_current_account integer;
  declare variable id_service integer;
  declare variable is_anul integer;
  declare variable id_tariff integer;
  declare variable qty_post numeric(15,2);
  declare variable qty_free numeric(15,2);
  declare variable price_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable id_room integer;
  declare variable id_base_doc integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  if ((:AP_DBKEY is null) or (:id_target_account is null) or (:id_target_account < 0)) then
     exception POSTING_TRANSFER_EXCEPTION '-31';

  select AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST, AP.QTY_FREE,
         AP.PRICE_ORIG, AP.CURR_ORIG, AP.RATE_ORIG, ap.from_date, ap.to_date,
         AP.IS_ANUL, AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_BASE_DOC, A.ID_HOTEL
  from   ACCOUNT_POST AP
         left join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :id_service, :id_tariff, :id_room, :qty_post, :qty_free,
         :price_orig, :curr_orig, :rate_orig, :from_date, :to_date,
         :is_anul, :id_account_post, :id_current_account, :id_base_doc, :id_hotel;

  if (:id_current_account = :id_target_account) then EXIT;

  if (:is_anul = 1 ) then exception POSTING_TRANSFER_EXCEPTION '-33';

  if (:id_base_doc is not null) then exception POSTING_TRANSFER_EXCEPTION '-32';

  if (not exists(select A.ID_ACCOUNT
                 from   ACCOUNT A
                 where  A.ID_ACCOUNT = :ID_TARGET_ACCOUNT
                        and A.ID_HOTEL = :id_hotel)) then exception POSTING_TRANSFER_EXCEPTION '-376';

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
                    :id_tariff, :id_room, :qty_post, :qty_free, :price_orig, :curr_orig,
                    :rate_orig, 'TRANSFER_POSTING', null, :from_date, :to_date, 0, :id_target_account)
  returning_values  :no_use, :no_use, :no_use;

  insert into ACCOUNT_TRANSFER_HISTORY(ID_ACCOUNT_POST, FROM_ID_ACCOUNT, TO_ID_ACCOUNT)
  values (:id_account_post, :id_current_account, :id_target_account);
end
^

/* Restore proc. body: ACCOUNT_POSTING_UPDATE */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable in_db_key char(8);
begin
  /* GUI facade for manual update */
  select AP.ID_ACCOUNT, AP.ID_GUEST, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :id_guest, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date)
  returning_values  (:new_qty_post, :new_price_post, :new_ac);

  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    if (coalesce(:id_guest, 0) > 0) then begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || :id_account
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'POST_UPDATE', :action_text);
    end else begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
    end
  end

end
^

/* Restore proc. body: APPLY_BOOKING_STATUS$EXC */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20)
 AS
declare variable err_text varchar(255);
declare variable dummy_int integer;
declare variable anul_reason varchar(30);
declare variable selection_id integer;

declare variable status_code smallint;
declare variable current_anul_code smallint;
declare variable current_status_code smallint;
declare variable current_status_text varchar(50);
declare variable new_status_text varchar(50);
declare variable extra_posts_left integer;
declare variable check_out_kind smallint;
declare variable earlycheckout_date date;
begin
  if (:booking_db_key is null) then begin
    select rd.RDB$DB_KEY, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.ID_RESERV_DETAIL = :BOOKING_ID
    into   :booking_db_key, :current_status_code, :current_anul_code;
  end else begin
    select rd.id_reserv_detail, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.rdb$db_key = :booking_db_key
    into   :booking_id, :current_status_code, :current_anul_code;
  end

  execute procedure IMPORT_BOOKING_STATUS$EXC(:status, -2)
  returning_values :status_code;

  execute procedure EXPORT_BOOKING_STATUS$EXC(:current_status_code, :current_anul_code)
  returning_values :current_status_text;
  execute procedure IMPORT_BOOKING_STATUS$EXC(:current_status_text, :current_status_code)
  returning_values :current_status_code;

  /* nop - exit */
  if (:current_status_code = :status_code) then exit;

  /* validate status transition */
  if (
     /* terminal status values - void booking */
    (:current_status_code in (1004/*no show*/, 1005/*canceled*/))

    /* void over checkin */
    or ((:current_status_code >= 0) and (:status_code in (1004/*no show*/, 1005/*canceled*/)))

    /* positive status downgrade */
    or ((:current_status_code > 0) and (:current_status_code > :status_code))
  )  then begin
    execute procedure PRINT_BOOKING_STATUS$EXC(:current_status_code) returning_values :current_status_text;
    execute procedure PRINT_BOOKING_STATUS$EXC(:status_code) returning_values :new_status_text;

    exception VALIDATE_EXCEPTION '-1022' || f_character(31) || '@{invalid_status_transition} ' || :current_status_text || ' -> ' || :new_status_text;
  end

  anul_reason = null;
  if (1004 = :status_code) then begin
    anul_reason = 'NOSHOW';
  end else if (1005 = :status_code) then begin
    anul_reason = 'CANCELED';
  end

  if (:anul_reason is null) then begin
    if (0 > :status_code) then begin
      execute procedure RES_SAVE_STATUS$INT(:booking_db_key, :status_code, :CONFIRMATION_NUMBER);
    end else begin
      if (:status_code in (0, 1) and 0 > :current_status_code) then begin
        -- checkin
        execute procedure RES_SET_CHECKIN$INT (:booking_db_key)
        returning_values (:dummy_int, :err_text, :dummy_int, :dummy_int);
      end
      if (1 = :status_code and 1 > :current_status_code) then begin
        -- checkout
        selection_id = gen_id(SELECTION_GEN, 1);
        update RESERV_DETAIL
        set    selection_id=:selection_id
        where  rdb$db_key=:booking_db_key
        returning new.CHECK_OUT_KIND, new.EARLYCHECKOUT_DATE
        into   :check_out_kind, :earlycheckout_date;
    
        execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id, :check_out_kind, :earlycheckout_date);
      end
    end
  end else begin
    -- void
    execute procedure RES_ANUL_DETAIL$INT(:booking_db_key, :anul_reason, :CANCELATION_NUMBER)
    returning_values  :dummy_int, :extra_posts_left;
    if (:extra_posts_left = 1) then exception BOOKING_EXCEPTION '-1042';

  end
end
^

/* Restore proc. body: AVAILABILITY_RATING$AVL */
ALTER PROCEDURE AVAILABILITY_RATING$AVL(ID_AGENT_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ROOMS_COUNT INTEGER,
ADULTS_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ROOMTYPE_LIST VARCHAR(2000),
RATE_LIST VARCHAR(2000),
BOARD_LIST VARCHAR(2000),
HOTELS VARCHAR(255) = '')
 RETURNS(ID_SESSION INTEGER)
 AS
declare variable id_room_type integer;
  declare variable total_rooms integer;
  declare variable allotment_rooms integer;
  declare variable id_agent integer;
  declare variable min_occ_date date;
  declare variable max_occ_date date;
begin
  /*
   this proc calculate prices and check availabiliti
   data is leaved in table TMP_AVAILABILITY
  */
  roomtype_list = ','||:roomtype_list||',';
  rate_list = ','||:rate_list||',';
  board_list = ','||:board_list||',';

  id_agent = null;
  select PA.ID_AGENT
  from   PROFILE_AGENT PA
  where  PA.ID_PROFILE = :id_agent_profile
  into   :id_agent;

  select min(SOT.FOR_DATE), max(SOT.FOR_DATE)
  from   SMART_OCCUP$TMP SOT
  where  ((:hotels = '') or (','||:hotels||',' containing ','||SOT.ID_HOTEL||','))
  into   :min_occ_date, :max_occ_date;
  if ((:min_occ_date > :arrival_date)
     or (:max_occ_date < :departure_date))
  then begin
    exception WRONG_VALUE 'Wrong input period for calculation! ';
  end

  /*New refactored procedure*/
  ID_SESSION = gen_id(SELECTION_GEN, 1);
  execute procedure AVAILABILITY_RATING_LOOP$INT (:ID_SESSION, :arrival_date, :departure_date,
          :rooms_count, :adults_count, :children_count, :roomtype_list, :rate_list, :board_list, :hotels);

  /*Update Available to output table*/
  for
    select RT.ID_ROOM_TYPE
    from   ROOM_TYPES RT
    where  :roomtype_list containing ','|| RT.ID_ROOM_TYPE ||','
            and ((:hotels = '') or (','||:hotels||',' containing ','||RT.ID_HOTEL||','))
    into   :id_room_type
  do begin
    total_rooms = null;
    execute procedure AVAILABILITY_GET_AVAIL$INT(:id_room_type, :arrival_date, :departure_date, :id_agent)
    returning_values  :total_rooms, :allotment_rooms;

    total_rooms = coalesce(:total_rooms, 0);

    update TMP_AVAILABILITY
    set    TOTAL_ROOMS =  :total_rooms,
           ALLOTMENT_ROOMS =  :allotment_rooms
    where  ID_SESSION  = :ID_SESSION
           and ID_ROOM_TYPE = :id_room_type;
  end

  /**/
  execute procedure AVAILABILITY_RATING_FILL$INT(:ID_SESSION, :roomtype_list, :rate_list,
          :arrival_date, :departure_date, :id_agent);
  --
end
^

/* Restore proc. body: BLOCK_MODIFY$INT */
ALTER PROCEDURE BLOCK_MODIFY$INT(ID_BLOCK_ROOM INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
BLOCK_GRP INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_BLOCK_ROOM INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable b_dbkey char(8);
  declare variable edit_status varchar(255);
  declare variable old_id_room integer;
  declare variable min_affected_date date;
  declare variable old_from_date date;
  declare variable old_to_date date;
begin

  if (:block_grp not in (18, 20)) then exception BLOCK_EXCEPTION '-85' || f_character(31) || 'Unknown block type';

  if (:operation = 'add') then begin
    new_id_block_room = gen_id(ID_RESERV_DETAIL_GEN, 1);
    insert into BLOCK_ROOM (ID_BLOCK_ROOM, ID_ROOM, FROM_DATE, TO_DATE,
           BLOCK_GRP, REASON, NOTE)
    values (:new_id_block_room, :id_room, :from_date, :to_date,
           :block_grp, :reason, :note)
    returning RDB$DB_KEY into :b_dbkey;
    edit_status = 'JUST_CREATED';
    min_affected_date = :from_date;
  end else begin
    select BR.RDB$DB_KEY, BR.FROM_DATE, BR.TO_DATE, BR.ID_ROOM
    from   BLOCK_ROOM BR
    where  BR.ID_BLOCK_ROOM = :id_block_room
    into   :b_dbkey, :old_from_date, :old_to_date, :old_id_room;

    min_affected_date = null;
    if (:old_from_date <> :from_date) then min_affected_date = mindate(:old_from_date, :from_date);
    else if (:old_to_date <> :to_date) then min_affected_date = mindate(:old_to_date, :to_date) + 1;
    edit_status = iif(:min_affected_date is not null, 'DATE_CHANGED', '');
    if (:id_room <> :old_id_room) then edit_status = :edit_status || ',ROOM_CHANGED';

    update BLOCK_ROOM BRU
    set    BRU.ID_ROOM = :id_room,
           BRU.FROM_DATE = :from_date,
           BRU.TO_DATE = :to_date,
           BRU.BLOCK_GRP = :block_grp,
           BRU.REASON = :reason,
           BRU.NOTE = :note
    where  BRU.RDB$DB_KEY = :b_dbkey;

    new_id_block_room = :id_block_room;
  end

  execute procedure BLOCK_MODIFY_CONTROL$INT(:b_dbkey, :min_affected_date);

  execute procedure LIST_ITEM_MODIFY(:block_grp, null, :reason, 'add');

  ------------------------------------
  execute procedure OCCUPANCY_BLOCK$INT(:b_dbkey, :edit_status);

  execute procedure OCCUPANCY_ROOMS_CHECK$INT(:b_dbkey, :block_grp)
  returning_values  :share_err_code, :share_err_text, :share_transaction_id, :warn_code;

  execute procedure sys_dbg('occ BLOCK_MODIFY$INT share_err_code = '||coalesce(:share_err_code, 'null'));
  execute procedure sys_dbg('occ BLOCK_MODIFY$INT share_err_text = '||coalesce(:share_err_text, 'null'));
  execute procedure sys_dbg('occ BLOCK_MODIFY$INT share_transaction_id = '||coalesce(:share_transaction_id, 'null'));

  execute procedure RES_FINALIZE_CLEAR$INT(:b_dbkey, :new_id_block_room);
  --
  delete from RESERV_STAY$TMP t
  where  t.id_session = RDB$GET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION');
end
^

/* Restore proc. body: CACHES_RESOLVE */
ALTER PROCEDURE CACHES_RESOLVE AS
declare variable id_res_detail integer;
  declare variable id_group integer;
  declare variable cache_cnt integer;
  declare variable id_account integer;
  declare variable no_use varchar(1024);
begin
  /* resolve reservs cache conflicts */
  for
    select first 20 RG.ID_RESERV_DETAIL, rg.ID_GROUP, sum(iif(rg.BOARD_NAMES is null, 2, 1))
    from   RESERV_GUESTDATA_CACHE RG
    group by RG.ID_RESERV_DETAIL, rg.ID_GROUP
    having sum(iif(rg.BOARD_NAMES is null, 2, 1)) > 1
    into   :id_res_detail, :id_group, :cache_cnt
  do begin
    execute procedure RES_GET_GUEST_DATA$INT (iif(:id_res_detail is not null, 'DETAIL', 'GROUP'), coalesce(:id_res_detail, :id_group))
    returning_values  (:no_use, :no_use, :no_use, :no_use);

    when any do begin
      execute procedure sys_dbg('all Cache resolve error for reserv '|| iif(:id_res_detail is not null, 'DETAIL', 'GROUP') || ': ' || coalesce(:id_res_detail, :id_group));
    end
  end 

  /* resolve account balances cache conflicts */
  for
    select first 20 AC.ID_ACCOUNT, sum(iif(AC.ACCOUNT_BALANCE is null, 2, 1))
    from   ACCOUNT_BALANCE_CACHE AC
    group by AC.ID_ACCOUNT
    having sum(iif(AC.ACCOUNT_BALANCE is null, 2, 1)) > 1
    into   :id_account, :cache_cnt
  do begin
    execute procedure ACCOUNT_BALANCE$INT (:id_account, 0)
    returning_values  (:no_use, :no_use, :no_use, :no_use, :no_use, :no_use, :no_use);

    when any do begin
      execute procedure sys_dbg('all Cache resolve error for account: ' || :id_account);
    end
  end 
end
^

/* Restore proc. body: CREATE_BOOKING$WBE */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
declare variable rate varchar(50);
declare variable room_type varchar(20);
declare variable arrival date;
declare variable departure date;
declare variable adults integer;
declare variable children integer;
declare variable profile_name varchar(100);
declare variable aranger_name varchar(100);
declare variable guest_profile_uuid varchar(40);
declare variable aranger_profile_uuid varchar(40);
declare variable hotel_name varchar(50);
declare variable wbe_session_id bigint;
declare variable main_guest_profile_id integer;
declare variable board varchar(50);
declare variable hotel_id integer;
declare variable guarantee_policy_name varchar(50);
declare variable guarantee_deposit_percent numeric(15,4);
declare variable guarantee_deposit_nights integer;
declare variable guarantee_due_days_bef_arrival integer;
declare variable guarantee_due_days_after_create integer;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable profile_type varchar(20);
declare variable profile_import_time timestamp;
declare variable b_count integer;
declare variable age integer;
declare variable is_child smallint;
declare variable guest_id integer;
declare variable special_treatment varchar(250);
declare variable maintenance varchar(30);
declare variable routing varchar(20);
declare variable arranger_paymeny_type varchar(20);
declare variable market_segment varchar(30);
declare variable market_source varchar(30);
declare variable market_channel varchar(30);
declare variable market_hear_reason varchar(30);
declare variable market_come_reason varchar(30);
declare variable first_food varchar(30);
declare variable bnote varchar(2000);
begin
  -- get wbe product selection
  select  PA.rate_name,PA.room_name, AQ.first_date, AQ.first_date+AQ.day_count,
          PS.adults, PS.children, PS.person_name, H.hotel_name, H.id_hotel,
          WS.id, PA.board_name, GP.name, GP.deposit_totalsum_part, GP.deposit_nights_count, GP.due_days_before_arrival, GP.due_days_after_create,
          PS.bnote
   from   PRODUCT_SELECTION$WBE PS
          join WBE_SESSION$WBE WS on WS.id = PS.wbe_session_id
          join PRODUCT_AVAILABILITY$WBE PA on pa.id = PS.product_availability_id
          join AVAILABILITY_QUERY$WBE AQ on aq.id = WS.product_query_id
          join HOTEL H on H.id_hotel = WS.hotel_id
          join GUARANTEE_POLICY GP on GP.id_guarantee_policy = PS.guarantee_policy_id
   where  PS.id = :product_selection_id
   into   :rate, :room_type, :arrival, :departure,
          :adults,  :children, :profile_name, :hotel_name, :hotel_id,
          :wbe_session_id, :board, :guarantee_policy_name,
          :guarantee_deposit_percent, :guarantee_deposit_nights,
          :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create,
          :bnote;

  select PA.uuid , PA.profile_name, PA.profile_type
  from   PROFILE PA
  where  PA.id_profile = :aranger_profile_id
  into   :aranger_profile_uuid,:aranger_name,  :profile_type;

  if (:aranger_name = :profile_name and :profile_type = 'PERSON') then begin
    -- aranger is main guest
    select count(*)
    from   PRODUCT_SELECTION$WBE PSC
    where  PSC.wbe_session_id = :wbe_session_id
    into   :b_count;
       -- only if single reservation bugfix 2228
    if (1 = :b_count) then begin
     guest_profile_uuid =  aranger_profile_uuid;
     aranger_profile_uuid = null;
    end
  end else begin
    -- create profile for main guest
    execute procedure IMPORT_PERSON_PROFILE$EXC(
      uuid_create(),:profile_name,null,null,null,null,null,null,null,null,null,null, null,
      null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
      null,null,null,null,null, null, null)
    returning_values :main_guest_profile_id, :profile_import_time;

    select P.uuid
    from   PROFILE P
    where  P.id_profile = :main_guest_profile_id
    into   :guest_profile_uuid;
  end

    -- apply default map + forced arranger
    special_treatment = null;
    maintenance = null;
    routing = null;
    arranger_paymeny_type = null;
    market_segment = null;
    market_source = null;
    market_channel = null;
    market_hear_reason = null;
    market_come_reason = null;


  select hc.special_treatment, hk.plan_name, hc.routing,
         pt.payment_type, ms.segment_name, sc.description, cc.description,
         hr.description, cr.description, hc.first_food
  from   HOTEL_PRODUCT_CFG$WBE hc
         left join HK_PLAN hk on hk.id_plan = hc.id_hk_plan
         left join PAYMENT_TYPE pt on pt.id_payment_type = hc.arranger_id_payment_type
         left join NOM_MARKET_SEGMENTS ms on ms.id_nom_market_segment = hc.id_m_segment
         left join NOM_SOURCE_CODES sc on sc.id_nom_source_code = hc.id_m_source
         left join NOM_CHANNEL_CODES cc on cc.id_nom_channel_code = hc.id_m_channel
         left join NOM_HEAR_REASONS hr on hr.id_nom_hear_reason = hc.id_m_hear_reason
         left join NOM_COME_REASONS cr on cr.id_nom_come_reason = hc.id_m_come_reason
  where  hc.hotel_id = :hotel_id
  into   :special_treatment,:maintenance,:routing,:arranger_paymeny_type,
         :market_segment,:market_source,:market_channel,:market_hear_reason,:market_come_reason,:first_food;
  -- create reseravation
  execute procedure IMPORT_BOOKING$EXC(
     :hotel_name, :number, null, null, 0,
     :arrival, null, :departure, null, null, null, null, null, :room_type, :board, null,
     :special_treatment, :maintenance, :routing, :rate, null, null, null, null, :arranger_paymeny_type, null, null, null, null,
     :market_segment, :market_source,:market_channel, :market_hear_reason, :market_come_reason,
     :bnote, null, :first_food, :adults, :children, :aranger_profile_uuid, null, :guest_profile_uuid,
     0, 0, null, :guarantee_policy_name, null, :guarantee_deposit_percent, :guarantee_deposit_nights,
     :guarantee_due_days_bef_arrival,  :guarantee_due_days_after_create, null, null, null, null,  null, null, null, null, null, null, null, null)
  returning_values
     :hotel_id, :booking_id, :err_code, err_text;
  if (0 <> :err_code) then exception WRONG_VALUE ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');

  -- import guests
  for
    select psg.guest_name, psg.is_child, psg.age
    from   PRODUCT_SELECTION_GUESTS$WBE psg
    where  psg.product_selection_id = :product_selection_id
    into   :profile_name,:is_child,:age
  do begin
    execute procedure IMPORT_GUEST$EXC(:booking_id, null, null, :profile_name, :is_child, :age, null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null)
    returning_values :guest_id, :err_code,:err_text;
    if (0 <> :err_code) then exception WRONG_VALUE ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');
  end
  ----------------

  select RD.number_2
  from   RESERV_DETAIL RD
  where  RD.id_reserv_detail = :booking_id
  into   :number_2;

  update PRODUCT_SELECTION$WBE uPS
  set    uPS.booking_id = :booking_id, uPS.selection_id = :number_2
  where  uPS.id = :product_selection_id;
end
^

/* Restore proc. body: CREATE_SESSION_BOOKINGS$WBE */
ALTER PROCEDURE CREATE_SESSION_BOOKINGS$WBE(WBE_SESSION_ID BIGINT,
ARANGER_ID INTEGER,
LANG_CODE VARCHAR(3))
 RETURNS(SELECTION_ID VARCHAR(20),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable product_selection_id bigint;
declare variable next_num integer;
declare variable sel_cnt integer;
declare variable aranger_name varchar(100);
declare variable aranger_email varchar(50);
declare variable aranger_phone varchar(50);
declare variable booking_id integer;
declare variable record_timestamp timestamp;
declare variable new_res_number varchar(62);
declare variable room_types_src varchar(255) = '';
declare variable rates_src varchar(255) = '';
declare variable hotel_id integer;
declare variable profile_id integer;
declare variable from_date date;
declare variable to_date date;
declare variable day_count integer;
declare variable room_type_id integer;
declare variable rate_id integer;
declare variable query_id_tmp integer;
declare variable rooms_required integer;
declare variable rooms_available integer;
declare variable profile_import_time timestamp;
begin
  execute procedure EXPORT_LOG_FORCE$EXC(1);
  /* test overbook (multiuser) */
   for select ws.hotel_id,ws.profile,aq.first_date,(aq.first_date+aq.day_count)-1,pa.room_type_id,pa.rate_id,aq.day_count
    from   PRODUCT_availability$WBE PA
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    join availability_query$wbe aq on aq.id = pa.query_id
   where ws.id = :wbe_session_id and coalesce(pa.room_count,0) > 0
   into  :hotel_id, :profile_id, :from_date, :to_date, :room_type_id, :rate_id , :day_count
   do begin
       room_types_src = :room_types_src||','||cast(:room_type_id as varchar(10));
       rates_src = :rates_src||','||cast(rate_id as varchar(10));
   end

   query_id_tmp = GEN_ID(AVAILABILITY_QUERY$WBE_SEQ,1);
   insert into availability_query$wbe(ID, WBE_SESSION_ID, FIRST_DATE, DAY_COUNT)    -- prevent FK exception
    values (:query_id_tmp,:wbe_session_id,:from_date,:day_count) ;

   execute procedure availability_occup_small$wbe(:from_date,:to_date,:hotel_id,:query_id_tmp,1,:rates_src,:room_types_src) ;

   --  check minimum available rooms for every day
   err_code = null;
   err_text = '';
   for select pa.room_type_id,pa.room_count,
    (select coalesce(min(art.available_rooms),0) from availability_room_type$wbe art
      where art.query_id = :query_id_tmp and art.room_type_id = pa.room_type_id)
    from product_availability$wbe pa
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    where ws.id = :wbe_session_id
    and coalesce(pa.room_count,0) > 0   into :room_type_id,:rooms_required,:rooms_available
   do begin
       if (rooms_required > rooms_available) then
       begin
        err_code = 1;
        ERR_TEXT = coalesce(ERR_TEXT,'')||:room_type_id||';';
       end
   end
   delete from availability_query$wbe aqt where aqt.id = :query_id_tmp;       -- remove temp query
   if (err_code is not null) then exit;

  /* create profile if not exist and reservations > 1*/
  if (aranger_id is NULL) then
  begin
    select WS.person_name,WS.address,WS.phone
    from   WBE_SESSION$WBE WS
    where  WS.id = :wbe_session_id
    into   :aranger_name,:aranger_email,:aranger_phone;

    execute procedure IMPORT_PERSON_PROFILE$EXC(
       uuid_create(),:aranger_name,null,null,null,null,null,null,null,null,null,null,
       null,null,null,null,:aranger_phone,null,:aranger_email,null,null,null,null,null,null,
       STRHASH_LARGE(substring(uuid_create() from 1 for 4)),null,null,null,null,null,null,null,null, null, null)
    returning_values :aranger_id, :profile_import_time;

    update WBE_SESSION$WBE uWS
    set    uWS.profile = :aranger_id
    where  uWS.id = :wbe_session_id;
  end else begin
    -- da podmeni email, phone ako !!
  end
  /* create reservations */
  for
    select PS.id
    from   PRODUCT_SELECTION$WBE PS
    where  PS.wbe_session_id = :wbe_session_id
           and PS.booking_id is null
           and coalesce(PS.is_deleted,0) <> 1
    into   :product_selection_id
  do begin
     if (next_num = 1) then begin      -- increment first reservation number_3
      execute procedure res_number_suffix_gen(:booking_id) returning_values :new_res_number;
      next_num = next_num + 1;
     end
     execute procedure CREATE_BOOKING$WBE(:product_selection_id,:aranger_id,'WBE.'||:selection_id||'.'||:next_num) returning_values :booking_id,:selection_id;
     execute procedure IMPORT_BOOKING_FINALIZE$EXC(:booking_id) returning_values  record_timestamp,:err_code,:err_text;
     insert into SCHEDULER$WBE(booking_id,status,last_action_time,lang_code,guarantee_passed) values (:booking_id, NULL, current_timestamp, :lang_code,0);

     if (next_num is NULL) then begin
      next_num = 1;
     end else begin
      next_num = next_num + 1;
     end
  end
end
^

/* Restore proc. body: EAI_EXT_POST_TO_MH_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  if (:CODE_TYPE = 'EXT_CODE') then begin
    execute procedure EAI_MAP_SERVICE(:SERVICE_CODE, :SERVICE_CODE, 'UNKNOWN', :id_hotel)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_SERVICE;
    if (:ERR_CODE < 0) then exit;
  end else begin
    select S.ID_SERVICE
    from   SERVICES S
    where  S.ID_SERVICE = :SERVICE_CODE
           and s.ID_HOTEL = :ID_HOTEL
    into   :ID_SERVICE;
    if (:ID_SERVICE is null) then begin
      ERR_CODE = -85;   /* Wrong value! */
      exit;
    end
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Restore proc. body: EAI_EXT_SERVICE_POST */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable max_id_service integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_ROOM  = null;
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  select min(S.ID_SERVICE) as id_service, max(s.id_service) as max_id_service
  from   SERVICES S
  where  S.EXT_CODE = :SERVICE_EXT_CODE
         and s.IS_BASE = 0
         and s.IS_DELETED = 0
  into   :ID_SERVICE, :max_id_service;
  if (:ID_SERVICE is null) then begin
      ERR_CODE = -388;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end else if (:ID_SERVICE <> :max_id_service) then begin
      ERR_CODE = -389;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_EXT_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Restore proc. body: EAI_MAP_SERVICE */
ALTER PROCEDURE EAI_MAP_SERVICE(SERVICE_TAG VARCHAR(30),
SERVICE_NAME VARCHAR(30),
EXTERNAL_IFC VARCHAR(30),
ID_HOTEL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_MAPPED_SERVICE INTEGER)
 AS
declare variable id_service_group integer;
  declare variable setting_code varchar(30);
  declare variable revenue_group varchar(30);
  declare variable is_base integer;
  declare variable is_deleted integer;
begin
  /*  Description:
  ||
  */
  err_code = 0;
  err_text = '';
  id_mapped_service = null;
  select first 1 S.ID_SERVICE, S.IS_BASE, s.IS_DELETED
  from   SERVICES S
  where  S.EXT_CODE = :service_tag
         and s.ID_HOTEL = :id_hotel
  order by s.ID_SERVICE asc
  into   :id_mapped_service, :is_base, :is_deleted;

  if (:is_base = 1) then begin
    ERR_CODE = -63;
    ERR_TEXT= '';
    exit;
  end
  if (:is_deleted = 1) then begin
    ERR_CODE = -64;
    ERR_TEXT= '';
    exit;
  end
  if (:id_mapped_service is not null) then exit;

  if (:external_ifc = 'POS') then revenue_group = 'Food and Beverage';
  else revenue_group = 'Other Operated departments';

  setting_code = 'IFC_'||:external_ifc||'_SRVGRP';
  execute procedure SETTING_GET_VALUE(:setting_code, :ID_HOTEL)
  returning_values  :id_service_group;

  execute procedure SERVICE_MODIFY(null, :id_service_group, 'EXTRA', :service_name, 0, 1, 0,
                    :revenue_group, null, null, :service_tag, 'BASE', '', 0, 'add', :ID_HOTEL,
                    0, 0, 0, 0, 0, 0, null, null)
  returning_values  :id_mapped_service;
end
^

/* Restore proc. body: EAI_POS_POSTING_ADD$P2E */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
declare variable id_service integer;
  declare variable my_post_text varchar(255);
  declare variable my_resource_text varchar(255);
  declare variable no_use integer;
  declare variable nation_curr varchar(3);
  declare variable post_short_code varchar(10);
  declare variable id_hotel integer;
begin
  /* in_on_guest = 0 (account), 1 (guest), -1 (ew)
  */
  if (:IN_ON_GUEST = 1) then begin
    select rd.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :IN_ID_GUEST
    into   :id_hotel;
  end else begin
    select a.ID_HOTEL
    from   account a
    where  a.ID_ACCOUNT = :in_id_account
    into   :id_hotel;
  end

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :nation_curr;

  if ('END_WORK' = :in_smetka_num) then begin
    post_short_code='POS_EW';
  end else begin
    post_short_code='POS';
  end

  /* FIND SERVICE */
  execute procedure EAI_MAP_SERVICE(:in_service_tag, :in_service_name, 'POS', :id_hotel)
  returning_values  :err_code, :err_text, :id_service;
  if (:err_code < 0) then exit;

  my_post_text = 'date:'|| formatdate(:in_date_smetka, 'D;dd.mm.yyyy') ||
                 ' num:'|| :in_smetka_num ||
                 ' obj:'|| :in_obj_name ||
                 ' tbl:'|| :in_table ||
                 ' site:'|| :in_site;

  my_resource_text = 'POS_ID_SMETKA:'||:in_id_smetka;
  my_post_text = substring(:my_post_text from 1 for 100);
  my_resource_text = substring(:my_resource_text from 1 for 49);

  if (:in_on_guest = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:in_id_guest, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code, '')
    returning_values  :err_code, :err_text, :out_id_account, :no_use;
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:in_id_account, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code)
    returning_values  :err_code, :err_text, :no_use;
    out_id_account = :in_id_account;
  end
end
^

/* Restore proc. body: EAI_TELECOUNT_TRANSFER */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* Restore proc. body: END_WORK */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable system_date date;
  declare variable id_room integer;
  declare variable id_end_work integer;
  declare variable last_closed_date date;
  declare variable mark_dirty_expired_block varchar(10);
  declare variable mark_dirty_occ_room varchar(10);
  declare variable lock_id integer;
  declare variable shift_no integer;
  declare variable init_hotel_date date;
begin

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;
  if (:system_date >= :in_next_date) then exception END_WORK_EXCEPTION '-43';
  if (:IN_NEXT_DATE > current_date + 1) then exception END_WORK_EXCEPTION '-60';

  last_closed_date = :in_next_date - 1;

  /* LOCK THE CURRENT FINANCIAL (SYSTEM) DATE  */
  lock_id = null;
  while (:lock_id is null) do begin
    lock_id = strhash_large(:system_date || :id_hotel);
    execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'lock');
  
    when any do begin
      exception END_WORK_EXCEPTION '-337' || f_character(31) || f_character(29) || FormatDate(:system_date, 'D;dd.mm.yyyy');
    end
  end

  /* RIGHT IS REQUIRED TO CHANGE THE FINANCIAL DATE IF THERE ARE GUESTS WITH OVERDUE CHECK OUT */
  if (exists(
    select *
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
    where  G.TO_DATE <= :last_closed_date
           and G.CHECK_STATUS < 1
           and RD.ID_HOTEL = :id_hotel
           and rd.IS_ANUL = 0
  )) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('EW_OVERDUE_CHECKOUT');
  end

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', 'EW');
  -- Suppress eventual right checks into next procedures - all is permitted. Is this needed(?!?)

  update ACCOUNT_POST AP
  set    ap.ROOM_NAME = (select R.ROOM_NAME
                         from   GUEST G
                                join ROOMS R on R.ID_ROOM = G.ID_ROOM
                         where  G.ID_GUEST = ap.ID_GUEST)
  where  ap.DATE_POST between :system_date and :last_closed_date
         and ap.ID_GUEST > 0;

  select coalesce(max(ew.SHIFT_NO), 0) + 1
  from   END_WORKS ew
  where  ew.PREV_DATE = :system_date
  into   :shift_no;

  id_end_work = gen_id(G_AUTO_INC_END_WORKS, 1);
  insert into END_WORKS (ID_END_WORK, PREV_DATE, NEXT_DATE, END_WORK_KIND, SHIFT_NO, ID_HOTEL)
  values (:id_end_work, :system_date, :in_next_date, 3, :shift_no, :id_hotel);

  /* CHANGE SYSTEM DATE */
  execute procedure SYSTEM_DATE_SET(:id_hotel, :in_next_date);

  /* AUTO EXPIRATION OF ROOM NUMBERS, ROOMS AND BOOKING POSITIONS */
  execute procedure RESERVS_EXPIRE$INT(:last_closed_date, :id_hotel);

  execute procedure AGENT_CONTINGENT_EXPIRE(:system_date, :last_closed_date, null, 0, 1, :id_hotel);

  /* DELETE PERSON PROFILES WITH EXPIRATION DATE */
  execute procedure PROFILE_PERSON_EXPIRE (:in_next_date);

  execute procedure SETTING_GET_VALUE('MARK_DIRTY_EXPIRED_BLOCK', :ID_HOTEL)
  returning_values  :mark_dirty_expired_block;
  if (:mark_dirty_expired_block = '1') then begin
    for
      select distinct BR.ID_ROOM
      from   BLOCK_ROOM BR
             join ROOMS R on R.ID_ROOM = BR.ID_ROOM
      where  R.ID_HOTEL = :id_hotel
             and BR.TO_DATE >= :system_date
             and BR.TO_DATE < :in_next_date
             and BR.IS_ANNUL = 0
         into :id_room
    do begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'BLOCK_EXP', 'set_dirty');

      when any do post_event 'dummy';  -- nothing
    end
  end

  execute procedure SETTING_GET_VALUE('MARK_DIRTY_OCC_ROOM', :ID_HOTEL)
  returning_values  :mark_dirty_occ_room;
  if (:mark_dirty_occ_room = '1') then begin
    for
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
             join ROOMS R on R.ID_ROOM = rm.ID_ROOM
      where  R.ID_HOTEL = :id_hotel
             and RM.BUSY_DATE = :system_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and RM.BUSY_GROUP_TYPE = 24
      into   :id_room
    do begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'EW_DAY', 'set_dirty');

      when any do post_event 'dummy';  -- nothing
    end
  end

  /* Summary data prepare */
  if (:in_next_date > :system_date) then begin
    execute procedure SUMMARY_FINANCE_SAVE$INT (:id_end_work);

    select min(e.PREV_DATE)
    from   END_WORKS E
    where  E.ID_HOTEL = :ID_HOTEL
    into   :init_hotel_date;

    execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:id_hotel, :init_hotel_date, :last_closed_date); --TODO precise the period

    execute procedure SUMMARY_FORECAST$INT(:ID_HOTEL, :system_date);
  end

  /* Delete data from temporal tables */
  delete from RESERV_ERROR;
  delete from TMP_SMALL_OCCUP;
--  delete from GUEST g where g.id_reserv_detail is null; pri regenerirane na statistikata ne vurshi rabota
  /*  */

  execute procedure CACHES_RESOLVE;

  execute procedure SYSTEM_LOG_ADD('SYSTEM', :id_end_work, 'DAY_EW', f_character(29) || :last_closed_date);

  execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'release');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', null);

  post_event 'invalidate.end_work';
end
^

/* Restore proc. body: GUEST_POST_GET_PACK_SERVICE */
ALTER PROCEDURE GUEST_POST_GET_PACK_SERVICE(IN_ID_SERVICE INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_POST DATE)
 RETURNS(ID_PACK_SERVICE INTEGER)
 AS
declare variable id_type_stay integer;
  declare variable id_room_type integer;
  declare variable id_board integer;
  declare variable id_hotel integer;
begin
  /*  Description:
  ||
  */
  id_pack_service = -1;
  select Sp.ID_TYPE_STAY, Sp.ID_ROOM_TYPE, s.ID_HOTEL
  from   SERVICE_PACKET Sp
         join SERVICES S on s.ID_SERVICE = sp.ID_SERVICE
  where  S.ID_SERVICE = :in_id_service
  into   :id_type_stay, :id_room_type, :id_hotel;

  select GS.ID_BOARD
  from   GUEST_STAY GS
  where  GS.ID_GUEST = :in_id_guest
         and GS.FOR_DATE = :in_date_post
  into   :id_board;

  /*dbg = savedbg('in_id_guest = '||:in_id_guest);
  dbg = savedbg('in_date_post = '||:in_date_post);
  dbg = savedbg('id_board = '||:id_board); */
  execute procedure TAR_GET_BASE_SERVICE$INT(:id_type_stay, :id_room_type, :id_board, :id_hotel)
  returning_values  :id_pack_service;

end
^

/* Restore proc. body: IMPORT_BOOKING_FINALIZE$EXC */
ALTER PROCEDURE IMPORT_BOOKING_FINALIZE$EXC(BOOKING_ID INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1,
STATUS VARCHAR(50) = null,
CONFIRMATION_NUMBER NAME_20 = null,
CANCELATION_NUMBER NAME_20 = null)
 RETURNS(RECORD_TIMESTAMP TIMESTAMP,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable booking_db_key char(8);
  declare variable dummy_int integer;
  declare variable dummy_text varchar(255) ;
  declare variable res_id_room integer;
  declare variable id_room integer;
  declare variable id_room_type integer;
  declare variable system_date date;
  declare variable from_date date;
  declare variable to_date date;
  declare variable gs_dbkey char(8);
begin
  ERR_CODE=0;
  ERR_TEXT=null;
  id_room = null;
  force_res_finalize = coalesce(:force_res_finalize, 1);

  execute procedure sys_dbg('exc IMPORT_BOOKING_FINALIZE$EXC => CLEAR_ORPHAN_GUESTS$EXC');
  execute procedure CLEAR_ORPHAN_GUESTS$EXC(:booking_id);

  select b.rdb$db_key, b.ID_ROOM, b.ID_ROOM_TYPE, b.FROM_DATE, b.TO_DATE
  from   reserv_detail b
  where  b.id_reserv_detail = :booking_id
  into   :booking_db_key, :res_id_room, :id_room_type, :from_date, :to_date;

  execute procedure RES_GUEST_SAVE_DIFF$INT(:booking_db_key);

  if (:res_id_room < 0) then begin
    for
      select lp.OUT_DATE
      from   SYSTEM_LOOP_PERIOD (:from_date, :to_date-1) lp
      into   :system_date
    do begin
      select ro.ID_ROOM, ro.ID_ROOM_TYPE
      from   RES_OCCUPANCY_ROOM$INT (:BOOKING_ID, :system_date, null, :id_room_type) ro
      into   :id_room, :id_room_type;
  
      if (:id_room <> :res_id_room) then begin
        for
          select gs.RDB$DB_KEY
          from   GUEST_STAY GS
                 join GUEST G on g.ID_GUEST = gs.ID_GUEST
          where  g.ID_RESERV_DETAIL = :BOOKING_ID
                 and gs.FOR_DATE = :system_date
                 and gs.ID_ROOM <> :id_room
          into   :gs_dbkey
        do begin
          update GUEST_STAY gsu
          set    gsu.ID_ROOM = :id_room
                 --gsu.ID_ROOM_TYPE = iif (gsu.ID_ROOM_TYPE = -1, :id_room_type, gsu.ID_ROOM_TYPE)
          where  gsu.RDB$DB_KEY = :gs_dbkey;
        end
      end
    end
    update GUEST G
    set    G.ID_ROOM = coalesce(:id_room, :res_id_room)
    where  g.ID_RESERV_DETAIL = :BOOKING_ID;
  end

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null,   --force recalculation
         rd.ID_ROOM = coalesce(:id_room, :res_id_room)
         --rd.HAS_DIFFERENT_ROOM_TYPE = coalesce(:has_different_room_type,  rd.HAS_DIFFERENT_ROOM_TYPE)
  where  rd.RDB$DB_KEY = :booking_db_key;

  if (1 = :force_res_finalize) then begin
    execute procedure sys_dbg('exc IMPORT_BOOKING_FINALIZE$EXC => RES_FINALIZE_SHAREOPTION$INT');
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:booking_db_key, 0)
    returning_values  :dummy_int, :dummy_text, :dummy_int, :dummy_int;
  end

  execute procedure APPLY_BOOKING_STATUS$EXC(
    null, :booking_db_key, :status, :confirmation_number, :cancelation_number
  );

  select b.change_time
  from   reserv_detail b
  where  b.rdb$db_key =:booking_db_key
  into   :record_timestamp;
end
^

/* Restore proc. body: IMPORT_PERSON_PROFILE$EXC */
ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
declare variable op varchar(10);
  declare variable market_segment_id integer;
  declare variable sex_old char(1);
  declare variable birth_date_old date;
  declare variable birth_place_old varchar(30);
  declare variable personal_number_old varchar(30);
  declare variable pass_num_old varchar(20);
  declare variable pass_date_old date;
  declare variable pass_place_old varchar(20);
  declare variable pass_exp_date_old date;
  declare variable pass_city_old varchar(100);
  declare variable pass_address_old varchar(100);
  declare variable country_old varchar(10);
  declare variable mask_old varchar(10);
  declare variable title_old varchar(10);
  declare variable id_photo integer;
  declare variable id_def_contragent integer;
  declare variable id_passport_type integer;
  declare variable account_no_old varchar(20);
  declare variable msg_old varchar(255);
  declare variable id_guest_type integer;
  declare variable id_guest_type_old integer;
  declare variable card_code_old varchar(50);
  declare variable is_exclusive_debt_ownership smallint;
  declare variable profile_receiver_id integer;
begin
  profile_id = null;
  import_time = null;

  execute procedure import_mark_transaction$exc;

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC(:profile_uuid=>' || coalesce(:profile_uuid, '<null>')
                          || ', email=>' || coalesce(:email, '<null>') || ')');

  profile_id = null;
  if (profile_uuid is null) then begin
    execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC <null> :profile_uuid - exit;');
    exit;
  end

  select p.profile_id, p.profile_name, p.phone, p.fax, p.email, p.city,
         p.address, p.market_segment, p.note, p.is_archive, pp.card_code,
         pd.sex, pd.birthday_internal, pd.birth_place, pd.egn, pd.pass_num,
         pd.pass_date, pd.pass_place, pd.pass_exp_date, pd.city, pd.address, pd.country_code,
         pd.mask, p.id_def_contragent, p.wbe_password,
         pd.title, p.account_no, p.msg, pp.id_guest_type, pp.id_photo, pd.id_passport_type,
         p.is_exclusive_debt_ownership
  from   import_common_profile$exc(:profile_uuid, 0, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :wbe_password, :ACCOUNT_NO, :MSG, 'PERSON_PROFILE', :HOTEL_UUID_LIST) p
         left outer join profile_person pp on pp.id_profile = p.profile_id
         left outer join person_data pd on pd.id_person_data=pp.id_person_data
  into   :profile_id, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :card_code_old,
         :sex_old, :birth_date_old, :birth_place_old, :personal_number_old, :pass_num_old,
         :pass_date_old, :pass_place_old, :pass_exp_date_old, :pass_city_old, :pass_address_old, :country_old,
         :mask_old, :id_def_contragent, :wbe_password, :title_old,
         :account_no_old, :msg_old, :id_guest_type_old, :id_photo, :id_passport_type, :is_exclusive_debt_ownership;

  if (:profile_id is null) then begin
    op = 'add';
  end else if (:hotel_uuid_list is null) then begin
    profile_id = null;
    exit;
  end else begin
    op = 'mod';
    delete from PROFILE_BONUSPOINT_SCHEME bs
      where bs.ID_PROFILE = :profile_id;
  end

  sex=coalesce(:sex, :sex_old);
  birth_date=coalesce(:birth_date, :birth_date_old);
  birth_place=coalesce(:birth_place, :birth_place_old);
  personal_number=coalesce(:personal_number, :personal_number_old);
  pass_num=coalesce(:pass_num, :pass_num_old);
  pass_date=coalesce(:pass_date, :pass_date_old);
  pass_place=coalesce(:pass_place, :pass_place_old);
  pass_exp_date=coalesce(:pass_exp_date, :pass_exp_date_old);
  pass_city=coalesce(:pass_city, :pass_city_old);
  pass_address=coalesce(:pass_address, :pass_address_old);
  country=upper(coalesce(:country, :country_old));
  mask=coalesce(:mask, :mask_old);
  title=coalesce(:title, :title_old);
  account_no=coalesce(:account_no, :account_no_old);
  msg=coalesce(:msg, :msg_old);
  card_code=coalesce(:card_code, :card_code_old);

  execute procedure IMPORT_PASSPORT_TYPE$EXC(:pass_type_name, :pass_type_external_code)
  returning_values :id_passport_type;

  execute procedure lookup_market_segment$exc(:profile_name, 'PERSON_PROFILE', :market_segment)
  returning_values :market_segment_id;

  if (guest_type_name is not null) then begin
    execute procedure lookup_guest_type$exc(:profile_name, 'PERSON_PROFILE', :guest_type_name)
    returning_values :id_guest_type;
  end

  if ((def_contragent_name is not null) and (def_contragent_name <> '')) then begin
    execute procedure LOOKUP_CONTRAGENT$EXC(:profile_name, 'PERSON_PROFILE', :def_contragent_name)
    returning_values :id_def_contragent;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:profile_name, 'PERSON_PROFILE');

  id_guest_type=coalesce(:id_guest_type, :id_guest_type_old);

  if (id_photo is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, null, null, null, 'del')
    returning_values :id_photo;
  end
  id_photo = null;
  if (picture is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, :picture, :picture_type, :picture_layout, 'add')
    returning_values :id_photo;
  end

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC - profile_person_modify$profile(:profile_uuid=>'
    || coalesce(:profile_uuid, '<null>')
    || ', :operation=>' || coalesce(:op, '<null>')
    || ', :email=>' || coalesce(:email, '<null>')
    || ', :birth_date=>' || coalesce(:birth_date, '<null>')
  || ')');
  execute procedure profile_person_modify$profile(
    :profile_id,
    :id_guest_type,
    :profile_name,
    null,
    :sex,
    :birth_date,
    :birth_place,
    :personal_number,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :pass_place,
    :pass_exp_date,
    :country,
    :pass_city,
    :pass_address,
    :mask,
    :phone,
    :fax,
    :email,
    :city,
    :address,
    :note,
    :msg,
    :id_def_contragent,
    :market_segment_id,
    :is_archive,
    :id_photo,
    :card_code,
    :wbe_password,
    :op,
    :account_no,
    :title,
    :is_exclusive_debt_ownership
  ) returning_values
    :profile_id;

  /*assign uuid to the new profiles*/
  if ('add' = :op) then begin
    update profile set uuid=:profile_uuid where id_profile=:profile_id;
  end

  select record_timestamp from profile where id_profile=:profile_id
  into :import_time;

  if (:MERGE_TARGET_UUID is not null) then begin
    select p.ID_PROFILE
    from   PROFILE P
    where  P.UUID = :MERGE_TARGET_UUID
    into   :profile_receiver_id;

    execute procedure PROFILE_MERGE$PROFILE (:PROFILE_ID, :profile_receiver_id, 'merge');

  end

end
^

/* Restore proc. body: IMPORT_RATE$EXC */
ALTER PROCEDURE IMPORT_RATE$EXC(TARIFA_NAME VARCHAR(50),
TARIFA_GROUP VARCHAR(30),
HOTEL_NAME VARCHAR(50),
TARIFA_CURR VARCHAR(3),
IS_ACTIVE SMALLINT,
TARIFA_NOTE VARCHAR(500),
PERIOD_DEPEND_ON_CHECKIN SMALLINT,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BOARD_TYPE VARCHAR(10),
SOURCE_BASE_BOARDS_LIST VARCHAR(255),
TMP_DATA BLOB SUB_TYPE 1,
LOCK_KEY VARCHAR(100),
LOCK_STAMP TIMESTAMP,
UUID VARCHAR(40),
RATE_TYPE VARCHAR(20),
IS_SIMPLE SMALLINT,
CHILD_AGE_INCL INTEGER,
IS_PUBLIC TYPE OF TLOGICAL,
EXPLICIT_TAX_POLICY_NAME TDESCRIPTION_SHORT = null,
EXPLICIT_POLICY_NIGHTS_REQUIRED TCOUNT = null)
 RETURNS(ID_TARIFA INTEGER,
ID_TARIFA_GROUP INTEGER,
ID_HOTEL INTEGER,
ID_TAR_SIMPLE INTEGER)
 AS
declare variable BASE_BOARDS_LIST varchar(255);
  declare variable BOARD_NAME varchar(30);
  declare variable ID_BOARD integer;
  declare variable EXPLICIT_TAX_POLICY integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure IMPORT_RATE_COMMON$EXC(:TARIFA_NAME, :TARIFA_GROUP, :HOTEL_NAME, :TARIFA_CURR, 1, :IS_ACTIVE,
    :TARIFA_NOTE, :UUID, :RATE_TYPE, :IS_SIMPLE, :IS_PUBLIC, :CHILD_AGE_INCL)
  returning_values :ID_TARIFA, :ID_TARIFA_GROUP, :ID_HOTEL;

  select ts.ID_TAR_SIMPLE
  from   TAR_SIMPLE ts
  where  ts.ID_TAR_HEAD = :ID_TARIFA
  into   :ID_TAR_SIMPLE;

  BASE_BOARDS_LIST = '';
  for
    select ITEM
    from   SYSTEM_STRING_PARSER(:SOURCE_BASE_BOARDS_LIST, ',')
    into   :BOARD_NAME
  do begin
    execute procedure LOOKUP_BOARD$EXC(:ID_HOTEL, :TARIFA_NAME, :RATE_TYPE, :BOARD_NAME, 0)
    returning_values :ID_BOARD;
    BASE_BOARDS_LIST = BASE_BOARDS_LIST || F_CHARACTER(28) || ID_BOARD;
  end

  if (:EXPLICIT_TAX_POLICY_NAME is not null) then begin
    execute procedure LOOKUP_TAX_POLICY$EXC(:ID_HOTEL, :TARIFA_NAME, :RATE_TYPE, :EXPLICIT_TAX_POLICY_NAME)
    returning_values :EXPLICIT_TAX_POLICY;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:TARIFA_NAME, :RATE_TYPE);

  update TAR_HEAD th
  set    th.PERIOD_DEPEND_ON_CHECKIN = :PERIOD_DEPEND_ON_CHECKIN,
         th.CNT_DAYS_PRICE_BP = :CNT_DAYS_PRICE_BP,
         th.CNT_DAYS_PRICE_BOARD = :CNT_DAYS_PRICE_BOARD,
         th.BASE_BOARDS_LIST = :BASE_BOARDS_LIST,
         th.BOARD_TYPE = :BOARD_TYPE,
         th.TMP_DATA = :TMP_DATA,
         th.LOCK_KEY = :LOCK_KEY,
         th.LOCK_STAMP = :LOCK_STAMP,
         th.EXPLICIT_TAX_POLICY = :EXPLICIT_TAX_POLICY,
         th.EXPLICIT_POLICY_NIGHTS_REQUIRED = :EXPLICIT_POLICY_NIGHTS_REQUIRED
  where  th.ID_TAR_HEAD = :ID_TARIFA;
end
^

/* Restore proc. body: IMPORT_RATE_SIMPLE_BOARD$EXC */
ALTER PROCEDURE IMPORT_RATE_SIMPLE_BOARD$EXC(ID_HOTEL INTEGER,
ID_TAR_SIMPLE_SEASON INTEGER,
RATE_NAME VARCHAR(30),
BOARD_NAME VARCHAR(30),
ADULT_PRICE NUMERIC(15,4),
CHILD_PRICE NUMERIC(15,4))
 RETURNS(ID_TAR_SIMPLE_BOARDS INTEGER)
 AS
declare variable ID_BOARD_TYPE integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_BOARD$EXC(:ID_HOTEL, :RATE_NAME, 'RATE_SIMPLE', :BOARD_NAME, 1)
  returning_values :ID_BOARD_TYPE;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:RATE_NAME, 'ROOM_TYPE');

  execute procedure TAR_SIMPLE_BOARD_MODIFY$CFG(null,
                                                :ID_TAR_SIMPLE_SEASON,
                                                :ID_BOARD_TYPE,
                                                :ADULT_PRICE,
                                                :CHILD_PRICE,
                                                'add')
  returning_values :ID_TAR_SIMPLE_BOARDS;
end
^

/* Restore proc. body: IMPORT_RATE_SIMPLE_PRICE$EXC */
ALTER PROCEDURE IMPORT_RATE_SIMPLE_PRICE$EXC(ID_TAR_SIMPLE_SEASON INTEGER,
RATE_NAME VARCHAR(30),
HOTEL_NAME VARCHAR(50),
ROOM_TYPE VARCHAR(20),
BOARD_NAME VARCHAR(30),
SINGLE_PRICE NUMERIC(15,4),
DOUBLE_PRICE NUMERIC(15,4),
GUEST3_PRICE NUMERIC(15,4),
GUEST4PLUS_PRICE NUMERIC(15,4),
CHILD1_W_ADULT1_PRICE NUMERIC(15,4),
CHILD1_W_ADULT2PLUS_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT1_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT2PLUS_PRICE NUMERIC(15,4),
IS_BASE_DAYS_PRICE SMALLINT)
 AS
declare variable ID_HOTEL integer;
declare variable ID_ROOM_TYPE integer;
declare variable ID_BOARD_TYPE integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'RATE_SIMPLE', :RATE_NAME)
  returning_values :ID_HOTEL;

  execute procedure LOOKUP_ROOM_TYPE$EXC(:ID_HOTEL, :RATE_NAME, 'RATE_SIMPLE', :ROOM_TYPE)
  returning_values :ID_ROOM_TYPE;

  execute procedure LOOKUP_BOARD$EXC(:ID_HOTEL, :RATE_NAME, 'RATE_SIMPLE', :BOARD_NAME, 1)
  returning_values :ID_BOARD_TYPE;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:RATE_NAME, 'RATE_SIMPLE');

  execute procedure TAR_SIMPLE_PRICE_MODIFY$CFG(:ID_TAR_SIMPLE_SEASON,
                                                :ID_ROOM_TYPE,
                                                :ID_BOARD_TYPE,
                                                :SINGLE_PRICE,
                                                :DOUBLE_PRICE,
                                                :GUEST3_PRICE,
                                                :GUEST4PLUS_PRICE,
                                                :CHILD1_W_ADULT1_PRICE,
                                                :CHILD1_W_ADULT2PLUS_PRICE,
                                                :CHILD2PLUS_W_ADULT1_PRICE,
                                                :CHILD2PLUS_W_ADULT2PLUS_PRICE,
                                                :IS_BASE_DAYS_PRICE);
end
^

/* Restore proc. body: IMPORT_SERVICE$EXC */
ALTER PROCEDURE IMPORT_SERVICE$EXC(SERVICE_NAME VARCHAR(30),
SERVICE_GROUP VARCHAR(30),
SERVICE_TYPE VARCHAR(50),
IS_DELETED SMALLINT,
IS_MANUAL_PRICE SMALLINT,
IS_DETAILS SMALLINT,
REVENUE_GROUP VARCHAR(50),
REVENUE_ACCOUNT VARCHAR(50),
ACCOUNT_NAME VARCHAR(30),
EXT_CODE VARCHAR(30),
VAUCHER_PACKET VARCHAR(20),
EXTRA_PACKET_NAME VARCHAR(10),
IS_RATE_PRICE SMALLINT,
IS_BREAKFAST SMALLINT,
IS_LUNCH SMALLINT,
IS_DINNER SMALLINT,
IS_EXTRAFOOD1 SMALLINT,
IS_EXTRAFOOD2 SMALLINT,
IS_BOARD SMALLINT,
PRICE NUMERIC(15,4),
PRICE_CURR VARCHAR(3),
HOTEL_NAME VARCHAR(50),
UUID VARCHAR(40))
 RETURNS(ID_SERVICE INTEGER,
ID_SERVICE_GROUP INTEGER)
 AS
declare variable ID_HOTEL integer;
declare variable OPERATION VARCHAR(3);
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'SERVICE', :SERVICE_NAME)
  returning_values :ID_HOTEL;
  execute procedure CHECK_LOOKUP_ERRORS$EXC(:SERVICE_NAME, 'SERVICE');

  execute procedure IMPORT_SERVICE_GROUP$EXC(:ID_HOTEL, :SERVICE_GROUP)
  returning_values :ID_SERVICE_GROUP;

  ID_SERVICE = null;
  select s.ID_SERVICE
  from   SERVICES s
  where  s.UUID = :UUID
         and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :ID_SERVICE;

  if (:ID_SERVICE is null) then begin
    OPERATION = 'add';
  end else begin
    OPERATION = 'mod';
  end

  if (:EXTRA_PACKET_NAME is null) then begin
    EXTRA_PACKET_NAME = '';
  end

  execute procedure SERVICE_MODIFY(:ID_SERVICE, :ID_SERVICE_GROUP, :SERVICE_TYPE, :SERVICE_NAME,
    :IS_DELETED, :IS_MANUAL_PRICE, :IS_DETAILS, :REVENUE_GROUP, :REVENUE_ACCOUNT,
    :ACCOUNT_NAME, :EXT_CODE, :VAUCHER_PACKET, :EXTRA_PACKET_NAME, :IS_RATE_PRICE,
    :OPERATION, :ID_HOTEL, :IS_BREAKFAST, :IS_LUNCH, :IS_DINNER, :IS_EXTRAFOOD1, :IS_EXTRAFOOD2,
    :IS_BOARD, :PRICE, :PRICE_CURR)
  returning_values :ID_SERVICE;

  update SERVICES s
  set    s.UUID = :UUID
  where  s.ID_SERVICE = :ID_SERVICE;
end
^

/* Restore proc. body: MONITOR_ROOM_GANTT$HM */
ALTER PROCEDURE MONITOR_ROOM_GANTT$HM(FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ID_ROOM INTEGER,
GFROM_DATE DATE,
IS_MOVED_FROM INTEGER,
GTO_DATE DATE,
IS_MOVED_TO INTEGER,
BUSY_GRP INTEGER,
OCCUPANT_ID INTEGER,
IN_SHARE SMALLINT,
ID_GROUP INTEGER,
ATTENTION_STATUS SMALLINT)
 AS
declare variable contiguous_id_room integer;
begin
  for
    select ID_ROOM, GFROM_DATE, IS_MOVED_FROM, GTO_DATE,
           IS_MOVED_TO, BUSY_GRP, OCCUPANT_ID
    from   MONITOR_ROOM_GANTT$INT(:from_date, :to_date)
    into   :id_room, :gfrom_date, :is_moved_from, :gto_date,
           :is_moved_to, :busy_grp, :occupant_id
  do begin
    if (:gfrom_date = :from_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gfrom_date - 1)
      into   :contiguous_id_room;

      if ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_from = 1;

      select O.FROM_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gfrom_date;
    end

    if (:gto_date = :to_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gto_date + 1)
      into   :contiguous_id_room;

      if ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_to = 1;

      select O.TO_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gto_date;
    end

    if (:busy_grp in (1, 24)) then begin
      select RI.ATTENTION_STATUS, RI.ID_GROUP, RI.IN_SHARE
      from   RES_GET_INFO$RSV(:occupant_id, 0, 1, 0) RI
      into   :attention_status, :id_group, :in_share;
    end else begin
      id_group = null;
      attention_status = null;
      in_share = null;
      if (exists(
        select *
        from   ROOMS_SHARE RS
        where  RS.ID_RESERV_DETAIL = :occupant_id
      )) then in_share = 1;
      else in_share = 0;
    end
    suspend;
  end
end
^

/* Restore proc. body: MONITOR_ROOM_GANTT_OCCUPANT$HM */
ALTER PROCEDURE MONITOR_ROOM_GANTT_OCCUPANT$HM(FROM_DATE DATE,
TO_DATE DATE,
REQUEST_OCCUPANT_ID INTEGER)
 RETURNS(ID_ROOM INTEGER,
GFROM_DATE DATE,
IS_MOVED_FROM INTEGER,
GTO_DATE DATE,
IS_MOVED_TO INTEGER,
BUSY_GRP INTEGER,
OCCUPANT_ID INTEGER,
IN_SHARE SMALLINT,
ID_GROUP INTEGER,
ATTENTION_STATUS SMALLINT)
 AS
declare variable contiguous_id_room integer;
begin
  for
    select ID_ROOM, GFROM_DATE, IS_MOVED_FROM, GTO_DATE,
           IS_MOVED_TO, BUSY_GRP, OCCUPANT_ID
    from   MONITOR_ROOM_GANTT$INT(:from_date, :to_date, :request_occupant_id)
    into   :id_room, :gfrom_date, :is_moved_from, :gto_date,
           :is_moved_to, :busy_grp, :occupant_id
  do begin
    if (:gfrom_date = :from_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gfrom_date - 1)
      into   :contiguous_id_room;

      if     ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_from = 1;

      select O.FROM_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gfrom_date;
    end

    if (:gto_date = :to_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gto_date + 1)
      into   :contiguous_id_room;

      if ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_to = 1;

      select O.TO_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gto_date;
    end

    if (exists(
      select *
      from   ROOMS_SHARE RS
      where  RS.ID_ROOM = :id_room
             and RS.BUSY_DATE between :from_date and :to_date
    )) then in_share = 1;
    else in_share = 0;
  
    if (:busy_grp in (1,24)) then begin
      select RI.ATTENTION_STATUS, RI.ID_GROUP
      from   RES_GET_INFO$RSV(:occupant_id, 0, 0, 0) RI
      into   :attention_status, :id_group;
    end else begin
      id_group = null;
      attention_status = null;
    end
    suspend;
  end
end
^

/* Restore proc. body: OCCUPANT_GET_INFO */
ALTER PROCEDURE OCCUPANT_GET_INFO(ID_OCCUPANT INTEGER,
IN_BUSY_GRP INTEGER = null)
 RETURNS(BUSY_GRP INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
INFO VARCHAR(1024))
 AS
declare variable max_day_action integer;
begin
  --busy_grp = :in_busy_grp;

  select max(RM.DAY_ACTION_INT), min(rm.BUSY_GROUP_TYPE)
  from   ROOM_MAGIC RM
  where  RM.ID_RESERV_DETAIL = :ID_OCCUPANT
         --and RM.BUSY_GROUP_TYPE = :busy_grp
  into   :max_day_action, :busy_grp;

  if (:busy_grp in (18, 20) and :max_day_action = 0) then begin
    select BGI.BUSY_GRP, BGI.REASON, BGI.FROM_DATE, BGI.TO_DATE
    from   BLOCK_GET_INFO(:id_occupant) BGI
    into   :busy_grp, :info, :from_date, :to_date;
  end else begin
    -- when :busy_grp in (1, 24) or (:max_day_action > 0) - reservation with block busy group type - owners, as an example
    select RGI.BUSY_GRP, RGI.NUMBER, RGI.ARRIVAL_DATE, RGI.DEPARTURE_DATE
    from   RES_GET_INFO$RSV(:id_occupant, 0, 0, 0) RGI
    into   :busy_grp, :info, :from_date, :to_date;
  end

  suspend;
end
^

/* Restore proc. body: PHONECALL_POST$TC */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Restore proc. body: PHONECALLS_POST_TO_ACCOUNT$TC */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* Restore proc. body: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_OWNER TYPE OF ID,
POST_DATE TYPE OF TDATE,
CURR_ORIG TYPE OF TCURRENCY,
VALUE_ORIG TYPE OF TPRICE,
POST_ON_PMS_ACCOUNT TYPE OF TLOGICAL,
IS_OWNER_INCOME TYPE OF TLOGICAL,
ID_ROOM TYPE OF ID_REF = null)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  if (:POST_ON_PMS_ACCOUNT = 1) then begin
    execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account, :id_owner,
            :CURR_ORIG, :VALUE_ORIG, :id_service, :is_owner_income, :POST_DATE)
    returning_values  (:new_id_account_post);
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :ID_SERVICE, 1, 0, 1,
            :VALUE_ORIG, :CURR_ORIG, current_date, current_date,
            '', '', :POST_DATE, 'PMS', :ID_ROOM)
    returning_values  :err_code, :err_text, :new_id_account_post;
    if (:err_code <> 0) then exception PMS_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

    insert into PMS_EVENT_POST (ID_PMS_EVENT, ID_ACCOUNT_POST, ID_OWNER, LINE_STATUS)
    values (:ID_PMS_EVENT, :NEW_ID_ACCOUNT_POST, :ID_OWNER, 11);
  end
end
^

/* Restore proc. body: POST_SERVICE_FINALIZE$POST */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
  declare variable id_acc_post integer;
  declare variable id_service integer;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable date_post date;
  declare variable price_post numeric(15,4);
  declare variable qty_post numeric(15,2);
  declare variable post_text varchar(100);
  declare variable curr_post varchar(3);
  declare variable id_phonecall integer;
  declare variable p_dbkey char(8);
begin

  if (:OPERATION = 'clear') then begin
    delete from TMP_SERVICE_POST T
    where  T.ID_SEQUENCE = :ID_SEQUENCE;

  end else if (:OPERATION = 'store') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);

    for
      select TS.RDB$DB_KEY, TS.ID_SERVICE, TS.ID_ACCOUNT, TS.ID_GUEST, TS.DATE_POST,
             TS.PRICE_POST, TS.QTY_POST, TS.CURR_POST, TS.POST_TEXT, TS.ID_PHONECALL
      from   TMP_SERVICE_POST TS
      where  TS.ID_SEQUENCE = :ID_SEQUENCE
      into   :p_dbkey, :id_service, :id_account, :id_guest, :date_post,
             :price_post, :qty_post, :curr_post, :post_text, :id_phonecall
    do begin
      id_acc_post = null;
      if (:id_guest is not null) then begin
        execute procedure POST_SERVICE_ON_GUEST$INT (:id_guest, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :CURR_POST,
                :date_post, :date_post, :post_text, '', :date_post, '', '')
        returning_values  (:err_code, :err_text, :no_use, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end else begin
        execute procedure POST_SERVICE_ON_ACCOUNT$INT (:id_account, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :curr_post, :date_post, :date_post, :post_text,
                '', :date_post, '')
        returning_values  (:err_code, :err_text, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end

      update TMP_SERVICE_POST
      set ID_ACCOUNT_POST = :id_acc_post
      where RDB$DB_KEY = :p_dbkey;

      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :DOC_SELECTED,
             AP.SHORT_CODE = case
                               when :id_phonecall is not null then 'TELECOUNT'
                               else null
                             end
      where  AP.ID_ACCOUNT_POST = :id_acc_post;

      if (:id_phonecall is not null) then begin
        update PHONECALLS P
        set    P.ID_ACCOUNT_POST = :id_acc_post
        where  P.ID_PHONECALL = :id_phonecall;
      end
    end
  end
end
^

/* Restore proc. body: PRODUCT_RATING$INT */
ALTER PROCEDURE PRODUCT_RATING$INT(ID_HOTEL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
ADULT_AGES VARCHAR(100) = null,
CHILD_AGES VARCHAR(100) = null,
ID_TAR_CALC_COMMON INTEGER = null)
 RETURNS(ROOM_PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100))
 AS
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable id_reserv integer;
declare variable id_tar_calc integer;
declare variable rate_currency char(3);
begin
  id_tar_calc = null;
  select T.CURR
  from   TARIFA T
  where  t.ID_TARIFA = :ID_RATE
  into   :rate_currency;

  execute procedure TAR_CALC_INPUT_PLAIN$INT (:adult_count, :children_count,
          :id_room_type, :id_board, :arrival_date, :departure_date,
          '', '', null, '', null, null, :id_rate, :adult_ages, :child_ages, :ID_TAR_CALC_COMMON)
  returning_values (:id_tar_calc, :id_reserv, :err_code, :err_text);
  --if (:err_code < 0) then exit;

  if (:err_code = 0) then begin
    execute procedure TAR_CALC_EVAL_ALL$INT(:id_tar_calc)
    returning_values  :err_code, :err_text;
    /*savedbg('-----------------------------');
    savedbg('id_rate: ' || :id_rate);
    savedbg('id_board: ' || :id_board);
    savedbg('id_room_type: ' || :id_room_type);
    savedbg('id_tar_calc: ' || :id_tar_calc);
    savedbg('err_code: ' || :ERR_CODE);
    savedbg('err_text: ' || :ERR_TEXT);
    */
    if (:err_code = 0) then begin
      execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

      price_currency = :rate_currency;
      execute procedure TAR_CALC_GET_PRICE$INT (:id_tar_calc, :id_hotel, :id_reserv, :price_currency)
      returning_values  :room_price, :room_price_details;
    end
  end
end
^

/* Restore proc. body: PROFILE_AGENT_MODIFY$PROFILE */
ALTER PROCEDURE PROFILE_AGENT_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
IS_ARCHIVE INTEGER,
AGENT_GROUP VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IATA_NUMBER VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null,
THRESHOLD_NOTE VARCHAR(255) = null,
THRESHOLD_AMOUNT NUMERIC(15,4) = null,
THRESHOLD_CURR CHAR(3) = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable id_agent integer;
  declare variable action_text varchar(255);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  AGENT_GROUP = nullif(trim(:AGENT_GROUP), '');

  if (:operation in ('add', 'mod')) then begin
    execute procedure PROFILE_COMMON_MODIFY$INT(:id_profile, 'AGENT', :profile_name,
            :phone, :fax, :email, :contact_city, :contact_address,
            :note, :msg, :is_archive, :id_def_contragent, :id_nom_market_segment,
            :wbe_password, :account_no, :is_exclusive_debt_ownership)
    returning_values (:NEW_ID_PROFILE);

    if (:new_id_profile is distinct from :id_profile) then begin
      id_agent = gen_id(G_AUTO_INC_AGENT,1);
      insert into AGENT (ID_AGENT, AGENT_NAME, IS_USE)
      values (:id_agent, :profile_name, 1-:is_archive);
  
      insert into PROFILE_AGENT(ID_PROFILE, ID_AGENT, AGENT_GROUP, COUNTRY_CODE, IATA_NUMBER, THRESHOLD_NOTE, THRESHOLD_AMOUNT, THRESHOLD_CURR)
      values (:new_id_profile, :id_agent, :agent_group, :country_code, :iata_number, :threshold_note, :threshold_amount, :threshold_curr);
  
      action_text = f_character(29) || :profile_name;
      execute procedure SYSTEM_LOG_ADD ('PROFILE', :new_id_profile, 'CREATE_AGENT_PROFILE', :action_text);
    end else begin
      select PA.ID_AGENT
      from   PROFILE_AGENT PA
      where  PA.ID_PROFILE = :NEW_ID_PROFILE
      into   :id_agent;

      update PROFILE_AGENT PA
      set    PA.IATA_NUMBER = :IATA_NUMBER,
             PA.COUNTRY_CODE = :COUNTRY_CODE,
             PA.AGENT_GROUP = :AGENT_GROUP,
             PA.THRESHOLD_NOTE = :THRESHOLD_NOTE,
             PA.THRESHOLD_AMOUNT = :THRESHOLD_AMOUNT,
             PA.THRESHOLD_CURR = :THRESHOLD_CURR
      where  PA.ID_PROFILE = :NEW_ID_PROFILE;

      update AGENT A
      set    A.AGENT_NAME = :profile_name,
             A.IS_USE = 1 - :is_archive
      where  A.ID_AGENT = :id_agent;
    end
  end else if (:operation = 'del') then  begin
    execute procedure PROFILE_DELETE$INT(:id_profile);

    new_id_profile = null;
  end
end
^

/* Restore proc. body: RES_CHECKIN$RSV */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable old_check_status integer;
  declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable is_anul integer;
  declare variable arrival_date date;
  declare variable system_date date;
begin
  /*  Description:
  ||
  */
  select RD.CHECK_STATUS, RD.RDB$DB_KEY, RD.FROM_DATE, RD.ID_HOTEL,
         RD.ID_ROOM, RD.IS_ANUL
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_check_status, :rd_dbkey, :arrival_date, :id_hotel,
         :old_id_room, :is_anul;

  if (:is_anul = 1) then exception BOOKING_EXCEPTION '-2';

  if (:old_check_status >= 0) then exception BOOKING_EXCEPTION '-1003';

  if (:old_id_room < 0 and coalesce(:ID_ROOM, 0) <= 0) then exception BOOKING_EXCEPTION '-1018';

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date < :arrival_date) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CHECK_IN_FUTURE');
  end
  /*----*/
  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'lock');

  execute procedure sys_dbg('occ RES_CHECKIN$RSV id_room = '||coalesce(:id_room, 'null'));
  execute procedure sys_dbg('occ RES_CHECKIN$RSV old_id_room = '||coalesce(:old_id_room, 'null'));

  if (:id_room is not null) then begin
    if (:old_check_status = -3) then begin
      execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, -2);
    end

    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option)
    returning_values (:WARN_CODE);
  end

  execute procedure RES_SET_CHECKIN$INT (:rd_dbkey)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'release');
  /*----*/
  select f_character(29) || R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = coalesce(:ID_ROOM, :old_id_room)
  into   :action_text;
   
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'CHECK_IN', :action_text);

end
^

/* Restore proc. body: RES_CHECKIN_MULTI$RSV */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable checkin_count integer;
  declare variable split_on_checkin integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
  declare variable tmp_warn_code integer;
begin
  checkin_count = 0;
  warn_code = null;
  for
    select RD.ID_RESERV_DETAIL, RD.CHECK_STATUS, RD.SPLIT_ON_CHECKIN, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :SELECTION_ID
    into   :id_reserv_detail, :check_status, :split_on_checkin, :id_titular
  do begin
    if (:check_status >= 0) then begin
      checkin_count = :checkin_count + 1;
    end else begin
      if (:split_on_checkin = 1) then begin
        for
          select G.ID_GUEST
          from   GUEST G
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and G.ID_GUEST <> :id_titular
          into   :id_guest
        do begin
          execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
          returning_values  :id_splited_reservation;

          execute procedure RES_CHECKIN$RSV (:id_splited_reservation)
          returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

          update RESERV_DETAIL RD
          set    RD.SELECTION_ID = :selection_id
          where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
        end
      end

      execute procedure RES_CHECKIN$RSV (:id_reserv_detail)
      returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
      WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end

  if (:checkin_count > 0) then begin
    execute procedure SYSTEM_WARNING_ADD(-1011, f_character(29)||:checkin_count)
    returning_values  :warn_code;
  end
end
^

/* Restore proc. body: RES_CREATE_SET$EXC */
ALTER PROCEDURE RES_CREATE_SET$EXC(ID_RESERV_DETAIL INTEGER,
RES_NUMBER VARCHAR(62),
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER,
CREATE_DATETIME TIMESTAMP)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_RESERV_DETAIL INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  WARN_CODE = 0;
  SHARE_TRANSACTION_ID = 0;
  SHARE_ERR_CODE = 0;

  execute procedure sys_dbg('exc RES_CREATE_SET$EXC => RES_CREATE_SET$INT('
  || 'code_first_food=>' || coalesce(:code_first_food, '<null>')
  || ', id_person_payment=>' || coalesce(:id_person_payment, '<null>')
  || ')');

  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, null, :arrival_date, :departure_date,
                    :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, '', :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders, :guarantee_deposit,
                    :guarantee_currency, 0, :id_reserv_detail, :res_number, null,  :id_guarantee_policy, :block_cc,
                    :id_eating_object)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :warn_code;

  execute procedure UPDATE_POSTING_TRANSACTION$EXC(:rd_dbkey, :posting_transaction_uuid, 1);

  execute procedure RES_SAVE_GUARANTEE$RSV(:id_reserv_detail, :is_vip, null,
    :id_guarantee_policy, :guarantee_deposit, :guarantee_currency, :block_cc, :guarantee_deposit_percent,
    :guarantee_deposit_nights, :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create
  );

  execute procedure RESERV_DETAIL_EXTERNAL_MOD$RSV(:id_reserv_detail,
    :minibar_rights, :paytv_rights, :video_rights, :nopost_pms, :phone_rights,
    :seminar_cahnnel_rights, null
  );

  if (:create_datetime is not null) then begin
    update reserv_detail set create_datetime = :create_datetime where rdb$db_key = :rd_dbkey;
  end
end
^

/* Restore proc. body: RES_FINALIZE$INT */
ALTER PROCEDURE RES_FINALIZE$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable err_text varchar(255);
begin
  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, :SUPPRESS_NON_INSTANT_ERRORS)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;
  if (:share_err_code < 0) then exception BOOKING_EXCEPTION :share_err_code || f_character(31) || :ERR_TEXT;
end
^

/* Restore proc. body: RES_FINALIZE_RECALC$INT */
ALTER PROCEDURE RES_FINALIZE_RECALC$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_calc integer;
begin
  -- NORMAL recalculation processing
  execute procedure RES_RECALC$INT(:rd_dbkey, 'NORMAL', 0)
  returning_values  :err_code, :err_text, :id_tar_calc;
  if (:err_code < 0) then exit;

end
^

/* Restore proc. body: RES_SAVE_ROOM$EXC */
ALTER PROCEDURE RES_SAVE_ROOM$EXC(RD_DBKEY CHAR(8),
ID_RES_ROOM_TYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(250),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_room integer;
begin
  select RD.ID_ROOM, RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_room, :id_reserv_detail;

  execute procedure RES_SAVE_ROOM$RSV(
    :id_reserv_detail,
    :old_id_room,
    :id_res_room_type,
    'nrttAsIs',
    1,
    :id_hk_plan,
    :room_features,
    :i_special_treatment,
    :split_on_checkin,
    0
  ) returning_values :share_err_code, :err_text, :share_transaction_id, :warn_code;
end
^

/* Restore proc. body: ROOM_CAPACITY_CHECK$INT */
ALTER PROCEDURE ROOM_CAPACITY_CHECK$INT(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(10),
OLD_CAPACITY INTEGER,
NEW_CAPACITY INTEGER)
 RETURNS(OVERRULE_NEED SMALLINT,
OVERRULE_CONTEXT VARCHAR(255))
 AS
declare variable guests_max integer;
  declare variable busy_types varchar(255) ;
  declare variable err_text varchar(255);
begin
  OVERRULE_NEED = 0;
  OVERRULE_CONTEXT = '';
  if (:NEW_CAPACITY < :OLD_CAPACITY) then begin
    guests_max = 0;
    select first 1 sum(RM.ADULT_COUNT+RM.CHILDREN_COUNT), list(rm.BUSY_TYPE)
    from   ROOM_MAGIC RM
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = RM.ID_RESERV_DETAIL
    where  RM.ID_ROOM = :id_room
           and RD.CHECK_STATUS in (-3, -2, -1, 0)
    group by RM.BUSY_DATE
    order by 1 desc
    into   :guests_max, :busy_types;
    err_text = '';
    if (:NEW_CAPACITY < :guests_max) then begin
      err_text = f_character(29)||:ROOM_NAME||f_character(28)||:NEW_CAPACITY||'/'||:guests_max;
      if (:busy_types containing 'CHECK_IN') then begin
        exception ASSERT '-67' || f_character(31) || coalesce(:err_text, '');
      end else begin
        OVERRULE_NEED = -66;
        OVERRULE_CONTEXT = :err_text;
      end
    end
  end
end
^

/* Restore proc. body: ROOM_SMART_LIST$RSV */
ALTER PROCEDURE ROOM_SMART_LIST$RSV(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(50))
 RETURNS(ROOM_NAME VARCHAR(50),
FREE_BEDS_BASE INTEGER,
FREE_BEDS_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
FEATURES BLOB,
BUSY_GROUP_TYPE INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
DATA1 VARCHAR(255),
DATA2 VARCHAR(255))
 AS
declare variable report_leaving varchar(20);
declare variable suppress_private integer;
begin
  if (:from_date >= :to_date) then exit;
  execute procedure SYSTEM_CHECK_OPERATION(:report_type, 'FREE_ONLY,FREE_AND_LEAVING,BLOCKED,POTENTIAL_SHARE,PRIVATE_USE,ALL');

  suppress_private = iif(:REPORT_TYPE = 'ALL', 0, 1);
  if (:report_type in ('FREE_ONLY','FREE_AND_LEAVING')) then begin
    if (:report_type = 'FREE_AND_LEAVING') then report_leaving = 'AS_FREE';
    else report_leaving = 'AS_LEAVING';
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DBEFORE, SRLF.DAFTER, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_FREE$INT(:from_date, :to_date, :report_leaving, :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end else if (:report_type in ('BLOCKED','POTENTIAL_SHARE')) then begin
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DESCRIPTION, SRLF.PERIOD, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_SHARE$INT(:from_date, :to_date, :report_type, :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end else if (:report_type in ('ALL')) then begin
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DBEFORE, SRLF.DAFTER, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_FREE$INT(:from_date, :to_date, 'FREE_AND_LEAVING', :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;

    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DESCRIPTION, SRLF.PERIOD, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_SHARE$INT(:from_date, :to_date, 'POTENTIAL_SHARE', :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end
end
^

/* Restore proc. body: SAFE_OCCUPANCY_MODIFY */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE TYPE OF ID,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable old_booking_number tres_number;
  declare variable id_resource_reservation id_ref;
  declare variable from_datetime tdatetime;
  declare variable action_text tdescription_long;
  declare variable old_occupant varchar(100);
  declare variable old_to_dt timestamp;
  declare variable id_reserv_detail integer;
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation;

  select rr.BOOKING_NUMBER, od.FROM_DATETIME,
         RR.OCCUPANT_NAME, od.TO_DATETIME, rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESERV_DETAIL rd on rd.NUMBER = rr.BOOKING_NUMBER and rd.IS_ANUL = 0
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :old_booking_number, :from_datetime,
         :old_occupant, :old_to_dt, :id_reserv_detail, :id_agent_profile;

  --if (:old_booking_number <> :BOOKING_NUMBER) then exception ASSERT 'Can not change booking number!';
  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  update SAFE_RESOURCE_RESERV rr
  set    rr.PRICE_DESCRIPTION = :price_description,
         rr.ID_RATE_PRICE_PROFILE = :id_agent_profile,
         rr.RATING_UNITS = :rating_units,
         rr.RATE_PRICE = :price,
         rr.RATE_CURR = :currency
  where  rr.ID_RESOURCE_RESERV = :id_resource_reservation;

  execute procedure RESOURCE_RESERVATION_MODIFY (:id_resource_reservation, :ID_SAFE, :from_datetime,
          :TO_DATETIME, :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :old_booking_number, 'mod')
  returning_values :id_resource_reservation, :no_use;

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail)
  returning_values (:DOC_SELECTED);

  /* Log changes */
  if ((:old_occupant <> :OCCUPANT_NAME) or (:old_to_dt <> :TO_DATETIME)) then begin
    action_text = f_character(29) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                  || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                  || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');
  
    execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_CHANGED', :action_text);
  end
end
^

/* Restore proc. body: SAFE_OCCUPANCY_NEW */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE TYPE OF ID,
FROM_DATETIME TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME,
BOOKING_NUMBER TYPE OF TRES_NUMBER,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
ID_RESOURCE_RESERVATION TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable action_text tdescription_long;
  declare variable id_reserv_detail integer;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, s.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  if (:id_resource_reservation is not null) then exception ASSERT '-1064'|| f_character(31) || f_character(29) || :safe_name;

  select rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESERV_DETAIL rd
  where  rd.NUMBER = :BOOKING_NUMBER
         and rd.IS_ANUL = 0
  into   :id_reserv_detail, :id_agent_profile;

  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  execute procedure  RESOURCE_RESERVATION_MODIFY (null, :ID_SAFE, :FROM_DATETIME, :TO_DATETIME,
          :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :BOOKING_NUMBER, 'add')
  returning_values (:id_resource_reservation, :no_use) ;

  insert into SAFE_RESOURCE_RESERV (ID_RESOURCE_RESERV, PRICE_DESCRIPTION, ID_RATE_PRICE_PROFILE,
         RATING_UNITS, RATE_PRICE, RATE_CURR)
  values (:id_resource_reservation, :price_description, :id_agent_profile,
         :rating_units, :price, :currency);

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail, :ID_EXTERNAL_CLIENT_ACCCOUNT)
  returning_values (:DOC_SELECTED);

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = 'CHECKED_IN'
  where  RR.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = :id_resource_reservation
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                || f_character(28) || coalesce(:BOOKING_NUMBER, '')
                || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUPIED', :action_text);
end
^

/* Restore proc. body: TAR_CALC_EVAL_ALL$INT */
ALTER PROCEDURE TAR_CALC_EVAL_ALL$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable room_status varchar(20);
  declare variable from_date date;
  declare variable to_date date;
  declare variable idate date;
  declare variable is_static integer;
  declare variable id_tar_input integer;
  declare variable id_type_stay integer;
  declare variable separate_board integer;
  declare variable id_board_include integer;
  declare variable id_tar_head integer;
  declare variable is_manual_type_stay smallint;
  declare variable seasson_name varchar(50);
begin
  err_code = 0;

  delete from TAR_CALC_OUTPUT$TMP TCO where TCO.ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP TCV where TCV.ID_TAR_CALC = :id_tar_calc;

  execute procedure TAR_CALC_INIT_VARS$INT(:id_tar_calc);

  for
    select TCI.ROOM_STATUS, min(TCI.FROM_DATE_CALC), max(TCI.TO_DATE_CALC), min(TCI.IS_STATIC)
    from   TAR_CALC_INPUT$TMP TCI
    where  TCI.ID_TAR_CALC = :id_tar_calc
    group by TCI.ROOM_STATUS
    into   :room_status, :from_date, :to_date, :is_static
  do begin
    for
      select RLP.OUT_DATE
      from   SYSTEM_LOOP_PERIOD(:from_date, :to_date) RLP
      into   :idate
    do begin
      if ((:is_static = 1) and (:idate > :from_date)) then begin
        insert into TAR_CALC_OUTPUT$TMP (ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
               FOR_DATE, PRICE, CURRENCY, PRICE_TARIFF, CURRENCY_TARIFF, PRICE_NOTE, QTY_POST,
               PTEXT, DISC_TAG, ID_DISCOUNT_SERVICE, REQUIRED_ID_PACKET_ITEM)
        select tco.ID_TAR_INPUT, tco.ID_TAR_CALC, tco.ID_SERVICE, tco.SERVICE_TYPE,
               :idate, PRICE, tco.CURRENCY, tco.PRICE_TARIFF, tco.CURRENCY_TARIFF, tco.PRICE_NOTE, tco.QTY_POST,
               tco.PTEXT, tco.DISC_TAG, tco.ID_DISCOUNT_SERVICE, tco.REQUIRED_ID_PACKET_ITEM
        from   TAR_CALC_OUTPUT$TMP TCO
        where  TCO.FOR_DATE = :from_date
               and TCO.ID_TAR_CALC = :id_tar_calc;
        for
          select TCID.ID_TAR_INPUT, TCID.ID_TYPE_STAY, TCID.SEPARATE_BOARD, TCID.ID_BOARD_INCLUDE,
                 TCID.IS_MANUAL_TYPE_STAY, TCID.ID_TAR_HEAD
          from   TAR_CALC_INPUT_DETAIL$TMP TCID
                 join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
          where  TCID.FOR_DATE = :from_date
                 and TCI.ID_TAR_CALC = :id_tar_calc
          into   :id_tar_input, :id_type_stay, :separate_board, :id_board_include,
                 :is_manual_type_stay, :id_tar_head
        do begin
          seasson_name = null;
          select tp.SEASON_NAME
          from   TARIFA_GET_PERIOD_FOR_DATE (:id_tar_head, :idate) tp
          into   :seasson_name;
          if (:seasson_name is null) then begin
            ERR_CODE = -231;
            ERR_TEXT = '';
            exit;
          end

          update TAR_CALC_INPUT_DETAIL$TMP TCID
          set    TCID.ID_TYPE_STAY = :id_type_stay,
                 TCID.IS_MANUAL_TYPE_STAY = :is_manual_type_stay,
                 TCID.SEPARATE_BOARD = :separate_board,
                 TCID.ID_BOARD_INCLUDE = :id_board_include
          where  TCID.ID_TAR_INPUT = :id_tar_input;
        end
      end else begin
        execute procedure TAR_CALC_EVAL_DATE$INT(:id_tar_calc, :room_status, :idate)
        returning_values  :err_code, :err_text;
        if (:err_code < 0) then exit;
      end
    end
  end

  execute procedure TAR_CALC_EVAL_ZERO$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  if (:err_code is null) then begin
    err_code = -230; /*WRONG INPUT PARAMS - MISSING GUESTS*/
    err_text = 'Missing input data for calculation';
    exit;
  end

  execute procedure TAR_CALC_EVAL_PERIOD$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  execute procedure TAR_CALC_CHECK_PACKETS$INT (:ID_TAR_CALC)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;
end
^

/* Restore proc. body: TAR_CALC_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
declare variable param_code varchar(40);
  declare variable id_param integer;
  declare variable param_value varchar(255);
  declare variable data_type  varchar(30);
  declare variable rate_list varchar(2000);
begin
  err_code = 0;
  param_values = '';

  if (coalesce(:rate_list_replace, '') = '') then rate_list = ',' || :id_rate || ',';
  else rate_list = :rate_list_replace;

  for
    select distinct TBP.PARAM_NAME
    from   SYSTEM_STRING_PARSER (:rate_list, ',') sp
           left join TAR_BO_PARAMS TBP on TBP.ID_TAR_HEAD = sp.ITEM
    where  (TBP.PARAM_TYPE <> 'DATE_DEPENDANT' and :for_date is null)
           or (TBP.PARAM_TYPE = 'DATE_DEPENDANT' and :for_date is not null)
    into   :param_code
  do begin
    if (:param_code is not null) then begin
      id_param = null;
      select TP.ID_TARIFA_PARAM, TP.DATA_TYPE
      from   TARIFA_PARAMS TP
      where  TP.PARAM_CODE = :param_code
             and tp.IS_USE = 1
      into   :id_param, :data_type;
  
      if (:id_param is null) then begin
        err_code = -202;
        execute procedure sys_dbg ('tar calc params err_code: ' || :err_code || F_CRLF() || 'PARAM_CODE = ' || :param_code);
        exit;
      end
  
      execute procedure TARIFA_GET_PARAM (:id_param, :for_date, :id_tar_input, :id_tar_calc)
      returning_values (:param_value);
  
      param_code = ':'||param_code;
  
      if ((:param_code is not null) and (:param_code is not null) and (:data_type is not null)) then
         param_values = :param_values||';'||:param_code||','||:data_type||','||:param_value;
    end
  end
end
^

/* Restore proc. body: TAR_CALC_POST_PREPARE$INT */
ALTER PROCEDURE TAR_CALC_POST_PREPARE$INT(ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
  declare variable id_service integer;
  declare variable id_tariff integer;
  declare variable date_post date;
  declare variable qty_post integer;
  declare variable price_orig numeric(15,4);
  declare variable round_to numeric(15,4);
  declare variable curr_orig char(3);
  declare variable id_room integer;
  declare variable short_code varchar(255);
  declare variable id_reserv integer;
begin

  delete
  from   TAR_CALC_POST$TMP TCP
  where  TCP.ID_TAR_CALC = :id_tar_calc;

/* Find all Discounts with services : Move ID_DISCOUNT_SERVICE to ID_SERVICE; Change them to PACKETS - in order to receive separate postings */
  update  TAR_CALC_OUTPUT$TMP TCO
  set     tco.service_type = 'PACKETS',
          tco.id_service = tco.id_discount_service
  where   TCO.id_tar_calc = :id_tar_calc
          and tco.price_note = 'DISC'
          and tco.id_discount_service > 0;
    
  for
    select TOB.ID_GUEST, TOB.ID_RESERV, TOB.ID_SERVICE, TOB.ID_TARIFF, TOB.DATE_POST, TOB.QTY_POST,
           round_f(TOB.PRICE_ORIG, c.ROUND_TO), TOB.CURR_ORIG, TOB.ID_ROOM, TOB.SHORT_CODE, c.ROUND_TO
    from   TAR_OUTPUT_BASE(:id_tar_calc) TOB
           left outer join CURRS c on c.CURR = tob.CURR_ORIG
    into   :id_guest, :id_reserv, :id_service, :id_tariff, :date_post, :qty_post,
           :price_orig, :curr_orig, :id_room, :short_code, :round_to
  do begin
    insert into TAR_CALC_POST$TMP(ID_GUEST, ID_RESERV, ID_SERVICE, ID_TARIFF, DATE_POST, QTY_POST,
           PRICE_ORIG, CURR_ORIG, ID_ROOM, IS_BASE, ID_TAR_CALC, SHORT_CODE)
    values(:id_guest, :id_reserv, :id_service, :id_tariff, :date_post, :qty_post,
           :price_orig, :curr_orig, :id_room, 1, :id_tar_calc, :short_code);

    for
        select   TCO.ID_SERVICE, TCO.PRICE_NOTE,
                 max(TCO.QTY_POST), round_f(sum(TCO.PRICE_TARIFF), :round_to)
        from     TAR_CALC_OUTPUT$TMP TCO
                 join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCO.ID_TAR_INPUT
                 left outer join SERVICES S on S.ID_SERVICE = TCO.ID_SERVICE
        where    TCO.ID_TAR_CALC = :id_tar_calc
                 and TCO.SERVICE_TYPE = 'PACKETS'
                 and TCI.ID_GUEST = :id_guest
                 and TCO.FOR_DATE = :date_post
        group by TCO.ID_SERVICE, TCO.PRICE_NOTE
        into     :id_service, :short_code, :qty_post, :price_orig
    do begin
      insert into TAR_CALC_POST$TMP(ID_GUEST, ID_RESERV, ID_SERVICE, ID_TARIFF, DATE_POST,
             QTY_POST, PRICE_ORIG, CURR_ORIG, ID_ROOM, IS_BASE, ID_TAR_CALC, SHORT_CODE)
      values(:id_guest, :id_reserv, :id_service, :id_tariff, :date_post, :qty_post,
             :price_orig, :curr_orig, :id_room, 0, :id_tar_calc, :short_code);
    end
  end
end
^

/* Restore proc. body: TAR_SAVE */
ALTER PROCEDURE TAR_SAVE(ID_TAR_HEAD INTEGER,
PERIOD_DEPEND_ON_CHECKIN INTEGER,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BASE_BOARDS_LIST VARCHAR(255),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
BO_TYPE VARCHAR(20),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable delim integer;
  declare variable id_hotel integer;
  declare variable action_text varchar(255);
begin
  if (:base_boards_list is null) then base_boards_list = '';
  if (:board_type not in ('BOARD', 'HRANI')) then begin
    if (:board_type = '0') then board_type = 'BOARD';
    else board_type = 'HRANI';
  end
  err_code = 0;
  err_text = '';
  execute procedure SETTING_GET_VALUE('RANGE_DATA_DELIMETER', null)
  returning_values  :delim;

  -- TAR_BO_PRICES are never cleared
  delete from TAR_BO_SEASON
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_BASE_POSITION
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_BOARD
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_EXTRA_GUEST
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_DISCOUNT
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_PACK
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_PARAMS
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_DISCOUNT_STAY
  where  ID_TAR_HEAD = :id_tar_head;
  update TAR_HEAD TH
  set    PERIOD_DEPEND_ON_CHECKIN = :period_depend_on_checkin,
         CNT_DAYS_PRICE_BP        = :cnt_days_price_bp,
         CNT_DAYS_PRICE_BOARD     = :cnt_days_price_board,
         BASE_BOARDS_LIST         = coalesce(f_character(:delim)|| (select list(p.item, f_character(:delim)) from SYSTEM_STRING_PARSER(:base_boards_list, f_character(:delim)) p) || f_character(:delim), ''),
         BOARD_TYPE               = :board_type,
         LOCK_STAMP               = current_timestamp
  where  TH.ID_TAR_HEAD = :id_tar_head;
  update TARIFA T
  set    T.IS_BASE = 1
  where  T.ID_TARIFA = :id_tar_head;
  bo_type = 'SEASON';
  execute procedure TAR_SAVE_BO_SEASON(:id_tar_head)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'BASE';
  execute procedure TAR_SAVE_BO_BP(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'BOARD';
  execute procedure TAR_SAVE_BO_BOARD(:id_tar_head, :bo_type, :board_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'EXTRA_GUEST';
  execute procedure TAR_SAVE_BO_EG(:id_tar_head, :bo_type, :board_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'PACK';
  execute procedure TAR_SAVE_BO_PACK(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'DISCOUNT';
  execute procedure TAR_SAVE_BO_DISC(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'DISCOUNT_PERIOD';
  execute procedure TAR_SAVE_BO_DISC_PERIOD(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end

  select f_character(29) || T.TARIFA_NAME, T.id_hotel
  from   TARIFA T
  where  T.ID_TARIFA = :ID_TAR_HEAD
  into   :action_text, :id_hotel;

  execute procedure EXPORT_LOG_INSERT$EXC ('RATE_BASE', :id_tar_head, :id_hotel, 0);

  execute procedure SYSTEM_LOG_ADD ('RATE', :ID_TAR_HEAD, 'RATE_CHANGED', :action_text);

  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||'NONE'||', '||:err_text;
    exception;
  end
end
^

/* Altering existing trigger... */
ALTER TRIGGER PERSON_DATA_BIU0
AS
  declare variable changed smallint;
begin
  changed = 0;
  new.COUNTRY_CODE = upper(coalesce(new.COUNTRY_CODE, ''));

  if (inserting or (new.FIRST_NAME is distinct from old.FIRST_NAME) ) then begin
    select ss.UNICODE_STRING
    from   SYSTEM_STRING_TO_UNICODE(new.FIRST_NAME) ss
    into   new.FIRST_NAME_UTF;
    changed = 1;
  end
  if (inserting or (new.SURNAME is distinct from old.SURNAME) ) then begin
    select ss.UNICODE_STRING
    from   SYSTEM_STRING_TO_UNICODE(new.FIRST_NAME) ss
    into   new.SURNAME_UTF;
    changed = 1;
  end
  if (inserting or (new.FAMILY_NAME is distinct from old.FAMILY_NAME) ) then begin
    select ss.UNICODE_STRING
    from   SYSTEM_STRING_TO_UNICODE(new.FAMILY_NAME) ss
    into   new.FAMILY_NAME_UTF;
    changed = 1;
  end
  if (:changed = 1) then begin
    select ss.UNICODE_STRING
    from   SYSTEM_STRING_TO_UNICODE(new.PERSON_NAME) ss
    into   new.PERSON_NAME_UTF;
  end
end
^

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_TRANSFER$ACC for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: GUEST_ACCOUNT_TRANSFER$INT for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE GUEST_ACCOUNT_TRANSFER$INT(ID_GUEST INTEGER,
ID_SOURCE_ACCOUNT INTEGER,
ID_TARGET_ACCOUNT INTEGER,
SERVICE_TYPE VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: GUEST_REROUTE_POSTINGS$INT for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE GUEST_REROUTE_POSTINGS$INT(ID_GUEST INTEGER,
ID_BASE_ACCOUNT INTEGER,
ID_EXTRA_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_TRANSFER$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER)
 AS
declare variable id_current_account integer;
  declare variable id_service integer;
  declare variable is_anul integer;
  declare variable id_tariff integer;
  declare variable qty_post numeric(15,2);
  declare variable qty_free numeric(15,2);
  declare variable price_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable id_room integer;
  declare variable id_base_doc integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  if ((:AP_DBKEY is null) or (:id_target_account is null) or (:id_target_account < 0)) then
     exception POSTING_TRANSFER_EXCEPTION '-31';

  select AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST, AP.QTY_FREE,
         AP.PRICE_ORIG, AP.CURR_ORIG, AP.RATE_ORIG, ap.from_date, ap.to_date,
         AP.IS_ANUL, AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_BASE_DOC, A.ID_HOTEL
  from   ACCOUNT_POST AP
         left join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :id_service, :id_tariff, :id_room, :qty_post, :qty_free,
         :price_orig, :curr_orig, :rate_orig, :from_date, :to_date,
         :is_anul, :id_account_post, :id_current_account, :id_base_doc, :id_hotel;

  if (:id_current_account = :id_target_account) then EXIT;

  if (:is_anul = 1 ) then exception POSTING_TRANSFER_EXCEPTION '-33';

  if (:id_base_doc is not null) then exception POSTING_TRANSFER_EXCEPTION '-32';

  if (not exists(select A.ID_ACCOUNT
                 from   ACCOUNT A
                 where  A.ID_ACCOUNT = :ID_TARGET_ACCOUNT
                        and A.ID_HOTEL = :id_hotel)) then exception POSTING_TRANSFER_EXCEPTION '-376';

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
                    :id_tariff, :id_room, :qty_post, :qty_free, :price_orig, :curr_orig,
                    :rate_orig, 'TRANSFER_POSTING', null, :from_date, :to_date, 0, :id_target_account)
  returning_values  :no_use, :no_use, :no_use;

  insert into ACCOUNT_TRANSFER_HISTORY(ID_ACCOUNT_POST, FROM_ID_ACCOUNT, TO_ID_ACCOUNT)
  values (:id_account_post, :id_current_account, :id_target_account);
end
^

/* Alter (ACCOUNT_POSTING_UPDATE) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable in_db_key char(8);
begin
  /* GUI facade for manual update */
  select AP.ID_ACCOUNT, AP.ID_GUEST, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :id_guest, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date)
  returning_values  (:new_qty_post, :new_price_post, :new_ac);

  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    if (coalesce(:id_guest, 0) > 0) then begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || :id_account
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'POST_UPDATE', :action_text);
    end else begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || f_replstr(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
    end
  end

end
^

/* empty dependent procedure body */
/* Clear: CANCEL_BOOKING$EXC for: APPLY_BOOKING_STATUS$EXC */
ALTER PROCEDURE CANCEL_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20),
STATUS VARCHAR(20))
 RETURNS(BOOKING_ID INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (APPLY_BOOKING_STATUS$EXC) */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20)
 AS
declare variable err_text varchar(255);
declare variable dummy_int integer;
declare variable anul_reason varchar(30);
declare variable selection_id integer;

declare variable status_code smallint;
declare variable current_anul_code smallint;
declare variable current_status_code smallint;
declare variable current_status_text varchar(50);
declare variable new_status_text varchar(50);
declare variable extra_posts_left integer;
declare variable check_out_kind smallint;
declare variable earlycheckout_date date;
begin
  if (:booking_db_key is null) then begin
    select rd.RDB$DB_KEY, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.ID_RESERV_DETAIL = :BOOKING_ID
    into   :booking_db_key, :current_status_code, :current_anul_code;
  end else begin
    select rd.id_reserv_detail, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.rdb$db_key = :booking_db_key
    into   :booking_id, :current_status_code, :current_anul_code;
  end

  execute procedure IMPORT_BOOKING_STATUS$EXC(:status, -2)
  returning_values :status_code;

  execute procedure EXPORT_BOOKING_STATUS$EXC(:current_status_code, :current_anul_code)
  returning_values :current_status_text;
  execute procedure IMPORT_BOOKING_STATUS$EXC(:current_status_text, :current_status_code)
  returning_values :current_status_code;

  /* nop - exit */
  if (:current_status_code = :status_code) then exit;

  /* validate status transition */
  if (
     /* terminal status values - void booking */
    (:current_status_code in (1004/*no show*/, 1005/*canceled*/))

    /* void over checkin */
    or ((:current_status_code >= 0) and (:status_code in (1004/*no show*/, 1005/*canceled*/)))

    /* positive status downgrade */
    or ((:current_status_code > 0) and (:current_status_code > :status_code))
  )  then begin
    execute procedure PRINT_BOOKING_STATUS$EXC(:current_status_code) returning_values :current_status_text;
    execute procedure PRINT_BOOKING_STATUS$EXC(:status_code) returning_values :new_status_text;

    exception VALIDATE_EXCEPTION '-1022' || f_character(31) || '@{invalid_status_transition} ' || :current_status_text || ' -> ' || :new_status_text;
  end

  anul_reason = null;
  if (1004 = :status_code) then begin
    anul_reason = 'NOSHOW';
  end else if (1005 = :status_code) then begin
    anul_reason = 'CANCELED';
  end

  if (:anul_reason is null) then begin
    if (0 > :status_code) then begin
      execute procedure RES_SAVE_STATUS$INT(:booking_db_key, :status_code, :CONFIRMATION_NUMBER);
    end else begin
      if (:status_code in (0, 1) and 0 > :current_status_code) then begin
        -- checkin
        execute procedure RES_SET_CHECKIN$INT (:booking_db_key)
        returning_values (:dummy_int, :err_text, :dummy_int, :dummy_int);
      end
      if (1 = :status_code and 1 > :current_status_code) then begin
        -- checkout
        selection_id = gen_id(SELECTION_GEN, 1);
        update RESERV_DETAIL
        set    selection_id=:selection_id
        where  rdb$db_key=:booking_db_key
        returning new.CHECK_OUT_KIND, new.EARLYCHECKOUT_DATE
        into   :check_out_kind, :earlycheckout_date;
    
        execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id, :check_out_kind, :earlycheckout_date);
      end
    end
  end else begin
    -- void
    execute procedure RES_ANUL_DETAIL$INT(:booking_db_key, :anul_reason, :CANCELATION_NUMBER)
    returning_values  :dummy_int, :extra_posts_left;
    if (:extra_posts_left = 1) then exception BOOKING_EXCEPTION '-1042';

  end
end
^

/* empty dependent procedure body */
/* Clear: TEST_RATING for: AVAILABILITY_RATING$AVL */
ALTER PROCEDURE TEST_RATING RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (AVAILABILITY_RATING$AVL) */
ALTER PROCEDURE AVAILABILITY_RATING$AVL(ID_AGENT_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ROOMS_COUNT INTEGER,
ADULTS_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ROOMTYPE_LIST VARCHAR(2000),
RATE_LIST VARCHAR(2000),
BOARD_LIST VARCHAR(2000),
HOTELS VARCHAR(255) = '')
 RETURNS(ID_SESSION INTEGER)
 AS
declare variable id_room_type integer;
  declare variable total_rooms integer;
  declare variable allotment_rooms integer;
  declare variable id_agent integer;
  declare variable min_occ_date date;
  declare variable max_occ_date date;
begin
  /*
   this proc calculate prices and check availabiliti
   data is leaved in table TMP_AVAILABILITY
  */
  roomtype_list = ','||:roomtype_list||',';
  rate_list = ','||:rate_list||',';
  board_list = ','||:board_list||',';

  id_agent = null;
  select PA.ID_AGENT
  from   PROFILE_AGENT PA
  where  PA.ID_PROFILE = :id_agent_profile
  into   :id_agent;

  select min(SOT.FOR_DATE), max(SOT.FOR_DATE)
  from   SMART_OCCUP$TMP SOT
  where  ((:hotels = '') or (','||:hotels||',' containing ','||SOT.ID_HOTEL||','))
  into   :min_occ_date, :max_occ_date;
  if ((:min_occ_date > :arrival_date)
     or (:max_occ_date < :departure_date))
  then begin
    exception WRONG_VALUE 'Wrong input period for calculation! ';
  end

  /*New refactored procedure*/
  ID_SESSION = gen_id(SELECTION_GEN, 1);
  execute procedure AVAILABILITY_RATING_LOOP$INT (:ID_SESSION, :arrival_date, :departure_date,
          :rooms_count, :adults_count, :children_count, :roomtype_list, :rate_list, :board_list, :hotels);

  /*Update Available to output table*/
  for
    select RT.ID_ROOM_TYPE
    from   ROOM_TYPES RT
    where  :roomtype_list containing ','|| RT.ID_ROOM_TYPE ||','
            and ((:hotels = '') or (','||:hotels||',' containing ','||RT.ID_HOTEL||','))
    into   :id_room_type
  do begin
    total_rooms = null;
    execute procedure AVAILABILITY_GET_AVAIL$INT(:id_room_type, :arrival_date, :departure_date, :id_agent)
    returning_values  :total_rooms, :allotment_rooms;

    total_rooms = coalesce(:total_rooms, 0);

    update TMP_AVAILABILITY
    set    TOTAL_ROOMS =  :total_rooms,
           ALLOTMENT_ROOMS =  :allotment_rooms
    where  ID_SESSION  = :ID_SESSION
           and ID_ROOM_TYPE = :id_room_type;
  end

  /**/
  execute procedure AVAILABILITY_RATING_FILL$INT(:ID_SESSION, :roomtype_list, :rate_list,
          :arrival_date, :departure_date, :id_agent);
  --
end
^

/* empty dependent procedure body */
/* Clear: BLOCK_ANNUL$BLK for: BLOCK_MODIFY$INT */
ALTER PROCEDURE BLOCK_ANNUL$BLK(ID_BLOCK_ROOM INTEGER,
OPERATION VARCHAR(30))
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: BLOCK_CREATE$BLK for: BLOCK_MODIFY$INT */
ALTER PROCEDURE BLOCK_CREATE$BLK(ROOM_NAMES /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_HOTEL /* TYPE OF ID */ INTEGER,
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
BLOCK_GRP /* TYPE OF TRANGE */ INTEGER,
REASON /* TYPE OF TREASON */ VARCHAR(50),
NOTE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IS_FULL_FROM /* TYPE OF TRANGE */ INTEGER,
IS_FULL_TO /* TYPE OF TRANGE */ INTEGER)
 RETURNS(NEW_ID_BLOCK_ROOM /* TYPE OF ID */ INTEGER,
SHARE_TRANSACTION_ID /* TYPE OF ID */ INTEGER,
SHARE_ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE /* TYPE OF ID */ INTEGER,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: BLOCK_MODIFY$BLK for: BLOCK_MODIFY$INT */
ALTER PROCEDURE BLOCK_MODIFY$BLK(ID_BLOCK_ROOM INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
BLOCK_GRP INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
IS_FULL_FROM INTEGER,
IS_FULL_TO INTEGER)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (BLOCK_MODIFY$INT) */
ALTER PROCEDURE BLOCK_MODIFY$INT(ID_BLOCK_ROOM INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
BLOCK_GRP INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_BLOCK_ROOM INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable b_dbkey char(8);
  declare variable edit_status varchar(255);
  declare variable old_id_room integer;
  declare variable min_affected_date date;
  declare variable old_from_date date;
  declare variable old_to_date date;
begin

  if (:block_grp not in (18, 20)) then exception BLOCK_EXCEPTION '-85' || f_character(31) || 'Unknown block type';

  if (:operation = 'add') then begin
    new_id_block_room = gen_id(ID_RESERV_DETAIL_GEN, 1);
    insert into BLOCK_ROOM (ID_BLOCK_ROOM, ID_ROOM, FROM_DATE, TO_DATE,
           BLOCK_GRP, REASON, NOTE)
    values (:new_id_block_room, :id_room, :from_date, :to_date,
           :block_grp, :reason, :note)
    returning RDB$DB_KEY into :b_dbkey;
    edit_status = 'JUST_CREATED';
    min_affected_date = :from_date;
  end else begin
    select BR.RDB$DB_KEY, BR.FROM_DATE, BR.TO_DATE, BR.ID_ROOM
    from   BLOCK_ROOM BR
    where  BR.ID_BLOCK_ROOM = :id_block_room
    into   :b_dbkey, :old_from_date, :old_to_date, :old_id_room;

    min_affected_date = null;
    if (:old_from_date <> :from_date) then min_affected_date = mindate(:old_from_date, :from_date);
    else if (:old_to_date <> :to_date) then min_affected_date = mindate(:old_to_date, :to_date) + 1;
    edit_status = iif(:min_affected_date is not null, 'DATE_CHANGED', '');
    if (:id_room <> :old_id_room) then edit_status = :edit_status || ',ROOM_CHANGED';

    update BLOCK_ROOM BRU
    set    BRU.ID_ROOM = :id_room,
           BRU.FROM_DATE = :from_date,
           BRU.TO_DATE = :to_date,
           BRU.BLOCK_GRP = :block_grp,
           BRU.REASON = :reason,
           BRU.NOTE = :note
    where  BRU.RDB$DB_KEY = :b_dbkey;

    new_id_block_room = :id_block_room;
  end

  execute procedure BLOCK_MODIFY_CONTROL$INT(:b_dbkey, :min_affected_date);

  execute procedure LIST_ITEM_MODIFY(:block_grp, null, :reason, 'add');

  ------------------------------------
  execute procedure OCCUPANCY_BLOCK$INT(:b_dbkey, :edit_status);

  execute procedure OCCUPANCY_ROOMS_CHECK$INT(:b_dbkey, :block_grp)
  returning_values  :share_err_code, :share_err_text, :share_transaction_id, :warn_code;

  execute procedure sys_dbg('occ BLOCK_MODIFY$INT share_err_code = '||coalesce(:share_err_code, 'null'));
  execute procedure sys_dbg('occ BLOCK_MODIFY$INT share_err_text = '||coalesce(:share_err_text, 'null'));
  execute procedure sys_dbg('occ BLOCK_MODIFY$INT share_transaction_id = '||coalesce(:share_transaction_id, 'null'));

  execute procedure RES_FINALIZE_CLEAR$INT(:b_dbkey, :new_id_block_room);
  --
  delete from RESERV_STAY$TMP t
  where  t.id_session = RDB$GET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION');
end
^

/* Alter (CACHES_RESOLVE) */
ALTER PROCEDURE CACHES_RESOLVE AS
declare variable id_res_detail integer;
  declare variable id_group integer;
  declare variable cache_cnt integer;
  declare variable id_account integer;
  declare variable no_use varchar(1024);
begin
  /* resolve reservs cache conflicts */
  for
    select first 20 RG.ID_RESERV_DETAIL, rg.ID_GROUP, sum(iif(rg.BOARD_NAMES is null, 2, 1))
    from   RESERV_GUESTDATA_CACHE RG
    group by RG.ID_RESERV_DETAIL, rg.ID_GROUP
    having sum(iif(rg.BOARD_NAMES is null, 2, 1)) > 1
    into   :id_res_detail, :id_group, :cache_cnt
  do begin
    execute procedure RES_GET_GUEST_DATA$INT (iif(:id_res_detail is not null, 'DETAIL', 'GROUP'), coalesce(:id_res_detail, :id_group))
    returning_values  (:no_use, :no_use, :no_use, :no_use);

    when any do begin
      execute procedure sys_dbg('all Cache resolve error for reserv '|| iif(:id_res_detail is not null, 'DETAIL', 'GROUP') || ': ' || coalesce(:id_res_detail, :id_group));
    end
  end 

  /* resolve account balances cache conflicts */
  for
    select first 20 AC.ID_ACCOUNT, sum(iif(AC.ACCOUNT_BALANCE is null, 2, 1))
    from   ACCOUNT_BALANCE_CACHE AC
    group by AC.ID_ACCOUNT
    having sum(iif(AC.ACCOUNT_BALANCE is null, 2, 1)) > 1
    into   :id_account, :cache_cnt
  do begin
    execute procedure ACCOUNT_BALANCE$INT (:id_account, 0)
    returning_values  (:no_use, :no_use, :no_use, :no_use, :no_use, :no_use, :no_use);

    when any do begin
      execute procedure sys_dbg('all Cache resolve error for account: ' || :id_account);
    end
  end 
end
^

/* Alter (CANCEL_BOOKING$EXC) */
ALTER PROCEDURE CANCEL_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20,
STATUS VARCHAR(20))
 RETURNS(BOOKING_ID INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable hotel_id integer;
declare variable cancel_event_log_id integer;
begin
  /* init */
  err_code = 0;
  err_text = '';

  execute procedure import_mark_transaction$exc;

  select first 1 b.id_reserv_detail, b.id_log_event_annul, b.from_date, b.to_date
  from   reserv_detail b
  where  b.number=:number
         and b.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  order by id_log_event_annul nulls first
  into   :booking_id, cancel_event_log_id, :from_date, :to_date;

  if ((:booking_id is null) or (:cancel_event_log_id is not null)) then begin
    /* not found or found but already in void status - ignore and exit */
    exit;
  end

  /* verify hotel */
  execute procedure lookup_hotel$exc(:hotel, 'BOOKING', :booking_id)
  returning_values :hotel_id;

  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  execute procedure APPLY_BOOKING_STATUS$EXC(
    :booking_id, null, :status, :confirmation_number, :cancelation_number
  );
end
^

/* Alter (CREATE_BOOKING$WBE) */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
declare variable rate varchar(50);
declare variable room_type varchar(20);
declare variable arrival date;
declare variable departure date;
declare variable adults integer;
declare variable children integer;
declare variable profile_name varchar(100);
declare variable aranger_name varchar(100);
declare variable guest_profile_uuid varchar(40);
declare variable aranger_profile_uuid varchar(40);
declare variable hotel_name varchar(50);
declare variable wbe_session_id bigint;
declare variable main_guest_profile_id integer;
declare variable board varchar(50);
declare variable hotel_id integer;
declare variable guarantee_policy_name varchar(50);
declare variable guarantee_deposit_percent numeric(15,4);
declare variable guarantee_deposit_nights integer;
declare variable guarantee_due_days_bef_arrival integer;
declare variable guarantee_due_days_after_create integer;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable profile_type varchar(20);
declare variable profile_import_time timestamp;
declare variable b_count integer;
declare variable age integer;
declare variable is_child smallint;
declare variable guest_id integer;
declare variable special_treatment varchar(250);
declare variable maintenance varchar(30);
declare variable routing varchar(20);
declare variable arranger_paymeny_type varchar(20);
declare variable market_segment varchar(30);
declare variable market_source varchar(30);
declare variable market_channel varchar(30);
declare variable market_hear_reason varchar(30);
declare variable market_come_reason varchar(30);
declare variable first_food varchar(30);
declare variable bnote varchar(2000);
begin
  -- get wbe product selection
  select  PA.rate_name,PA.room_name, AQ.first_date, AQ.first_date+AQ.day_count,
          PS.adults, PS.children, PS.person_name, H.hotel_name, H.id_hotel,
          WS.id, PA.board_name, GP.name, GP.deposit_totalsum_part, GP.deposit_nights_count, GP.due_days_before_arrival, GP.due_days_after_create,
          PS.bnote
   from   PRODUCT_SELECTION$WBE PS
          join WBE_SESSION$WBE WS on WS.id = PS.wbe_session_id
          join PRODUCT_AVAILABILITY$WBE PA on pa.id = PS.product_availability_id
          join AVAILABILITY_QUERY$WBE AQ on aq.id = WS.product_query_id
          join HOTEL H on H.id_hotel = WS.hotel_id
          join GUARANTEE_POLICY GP on GP.id_guarantee_policy = PS.guarantee_policy_id
   where  PS.id = :product_selection_id
   into   :rate, :room_type, :arrival, :departure,
          :adults,  :children, :profile_name, :hotel_name, :hotel_id,
          :wbe_session_id, :board, :guarantee_policy_name,
          :guarantee_deposit_percent, :guarantee_deposit_nights,
          :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create,
          :bnote;

  select PA.uuid , PA.profile_name, PA.profile_type
  from   PROFILE PA
  where  PA.id_profile = :aranger_profile_id
  into   :aranger_profile_uuid,:aranger_name,  :profile_type;

  if (:aranger_name = :profile_name and :profile_type = 'PERSON') then begin
    -- aranger is main guest
    select count(*)
    from   PRODUCT_SELECTION$WBE PSC
    where  PSC.wbe_session_id = :wbe_session_id
    into   :b_count;
       -- only if single reservation bugfix 2228
    if (1 = :b_count) then begin
     guest_profile_uuid =  aranger_profile_uuid;
     aranger_profile_uuid = null;
    end
  end else begin
    -- create profile for main guest
    execute procedure IMPORT_PERSON_PROFILE$EXC(
      uuid_create(),:profile_name,null,null,null,null,null,null,null,null,null,null, null,
      null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
      null,null,null,null,null, null, null)
    returning_values :main_guest_profile_id, :profile_import_time;

    select P.uuid
    from   PROFILE P
    where  P.id_profile = :main_guest_profile_id
    into   :guest_profile_uuid;
  end

    -- apply default map + forced arranger
    special_treatment = null;
    maintenance = null;
    routing = null;
    arranger_paymeny_type = null;
    market_segment = null;
    market_source = null;
    market_channel = null;
    market_hear_reason = null;
    market_come_reason = null;


  select hc.special_treatment, hk.plan_name, hc.routing,
         pt.payment_type, ms.segment_name, sc.description, cc.description,
         hr.description, cr.description, hc.first_food
  from   HOTEL_PRODUCT_CFG$WBE hc
         left join HK_PLAN hk on hk.id_plan = hc.id_hk_plan
         left join PAYMENT_TYPE pt on pt.id_payment_type = hc.arranger_id_payment_type
         left join NOM_MARKET_SEGMENTS ms on ms.id_nom_market_segment = hc.id_m_segment
         left join NOM_SOURCE_CODES sc on sc.id_nom_source_code = hc.id_m_source
         left join NOM_CHANNEL_CODES cc on cc.id_nom_channel_code = hc.id_m_channel
         left join NOM_HEAR_REASONS hr on hr.id_nom_hear_reason = hc.id_m_hear_reason
         left join NOM_COME_REASONS cr on cr.id_nom_come_reason = hc.id_m_come_reason
  where  hc.hotel_id = :hotel_id
  into   :special_treatment,:maintenance,:routing,:arranger_paymeny_type,
         :market_segment,:market_source,:market_channel,:market_hear_reason,:market_come_reason,:first_food;
  -- create reseravation
  execute procedure IMPORT_BOOKING$EXC(
     :hotel_name, :number, null, null, 0,
     :arrival, null, :departure, null, null, null, null, null, :room_type, :board, null,
     :special_treatment, :maintenance, :routing, :rate, null, null, null, null, :arranger_paymeny_type, null, null, null, null,
     :market_segment, :market_source,:market_channel, :market_hear_reason, :market_come_reason,
     :bnote, null, :first_food, :adults, :children, :aranger_profile_uuid, null, :guest_profile_uuid,
     0, 0, null, :guarantee_policy_name, null, :guarantee_deposit_percent, :guarantee_deposit_nights,
     :guarantee_due_days_bef_arrival,  :guarantee_due_days_after_create, null, null, null, null,  null, null, null, null, null, null, null, null)
  returning_values
     :hotel_id, :booking_id, :err_code, err_text;
  if (0 <> :err_code) then exception WRONG_VALUE ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');

  -- import guests
  for
    select psg.guest_name, psg.is_child, psg.age
    from   PRODUCT_SELECTION_GUESTS$WBE psg
    where  psg.product_selection_id = :product_selection_id
    into   :profile_name,:is_child,:age
  do begin
    execute procedure IMPORT_GUEST$EXC(:booking_id, null, null, :profile_name, :is_child, :age, null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null)
    returning_values :guest_id, :err_code,:err_text;
    if (0 <> :err_code) then exception WRONG_VALUE ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');
  end
  ----------------

  select RD.number_2
  from   RESERV_DETAIL RD
  where  RD.id_reserv_detail = :booking_id
  into   :number_2;

  update PRODUCT_SELECTION$WBE uPS
  set    uPS.booking_id = :booking_id, uPS.selection_id = :number_2
  where  uPS.id = :product_selection_id;
end
^

/* Alter (CREATE_SESSION_BOOKINGS$WBE) */
ALTER PROCEDURE CREATE_SESSION_BOOKINGS$WBE(WBE_SESSION_ID BIGINT,
ARANGER_ID INTEGER,
LANG_CODE VARCHAR(3))
 RETURNS(SELECTION_ID VARCHAR(20),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable product_selection_id bigint;
declare variable next_num integer;
declare variable sel_cnt integer;
declare variable aranger_name varchar(100);
declare variable aranger_email varchar(50);
declare variable aranger_phone varchar(50);
declare variable booking_id integer;
declare variable record_timestamp timestamp;
declare variable new_res_number varchar(62);
declare variable room_types_src varchar(255) = '';
declare variable rates_src varchar(255) = '';
declare variable hotel_id integer;
declare variable profile_id integer;
declare variable from_date date;
declare variable to_date date;
declare variable day_count integer;
declare variable room_type_id integer;
declare variable rate_id integer;
declare variable query_id_tmp integer;
declare variable rooms_required integer;
declare variable rooms_available integer;
declare variable profile_import_time timestamp;
begin
  execute procedure EXPORT_LOG_FORCE$EXC(1);
  /* test overbook (multiuser) */
   for select ws.hotel_id,ws.profile,aq.first_date,(aq.first_date+aq.day_count)-1,pa.room_type_id,pa.rate_id,aq.day_count
    from   PRODUCT_availability$WBE PA
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    join availability_query$wbe aq on aq.id = pa.query_id
   where ws.id = :wbe_session_id and coalesce(pa.room_count,0) > 0
   into  :hotel_id, :profile_id, :from_date, :to_date, :room_type_id, :rate_id , :day_count
   do begin
       room_types_src = :room_types_src||','||cast(:room_type_id as varchar(10));
       rates_src = :rates_src||','||cast(rate_id as varchar(10));
   end

   query_id_tmp = GEN_ID(AVAILABILITY_QUERY$WBE_SEQ,1);
   insert into availability_query$wbe(ID, WBE_SESSION_ID, FIRST_DATE, DAY_COUNT)    -- prevent FK exception
    values (:query_id_tmp,:wbe_session_id,:from_date,:day_count) ;

   execute procedure availability_occup_small$wbe(:from_date,:to_date,:hotel_id,:query_id_tmp,1,:rates_src,:room_types_src) ;

   --  check minimum available rooms for every day
   err_code = null;
   err_text = '';
   for select pa.room_type_id,pa.room_count,
    (select coalesce(min(art.available_rooms),0) from availability_room_type$wbe art
      where art.query_id = :query_id_tmp and art.room_type_id = pa.room_type_id)
    from product_availability$wbe pa
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    where ws.id = :wbe_session_id
    and coalesce(pa.room_count,0) > 0   into :room_type_id,:rooms_required,:rooms_available
   do begin
       if (rooms_required > rooms_available) then
       begin
        err_code = 1;
        ERR_TEXT = coalesce(ERR_TEXT,'')||:room_type_id||';';
       end
   end
   delete from availability_query$wbe aqt where aqt.id = :query_id_tmp;       -- remove temp query
   if (err_code is not null) then exit;

  /* create profile if not exist and reservations > 1*/
  if (aranger_id is NULL) then
  begin
    select WS.person_name,WS.address,WS.phone
    from   WBE_SESSION$WBE WS
    where  WS.id = :wbe_session_id
    into   :aranger_name,:aranger_email,:aranger_phone;

    execute procedure IMPORT_PERSON_PROFILE$EXC(
       uuid_create(),:aranger_name,null,null,null,null,null,null,null,null,null,null,
       null,null,null,null,:aranger_phone,null,:aranger_email,null,null,null,null,null,null,
       STRHASH_LARGE(substring(uuid_create() from 1 for 4)),null,null,null,null,null,null,null,null, null, null)
    returning_values :aranger_id, :profile_import_time;

    update WBE_SESSION$WBE uWS
    set    uWS.profile = :aranger_id
    where  uWS.id = :wbe_session_id;
  end else begin
    -- da podmeni email, phone ako !!
  end
  /* create reservations */
  for
    select PS.id
    from   PRODUCT_SELECTION$WBE PS
    where  PS.wbe_session_id = :wbe_session_id
           and PS.booking_id is null
           and coalesce(PS.is_deleted,0) <> 1
    into   :product_selection_id
  do begin
     if (next_num = 1) then begin      -- increment first reservation number_3
      execute procedure res_number_suffix_gen(:booking_id) returning_values :new_res_number;
      next_num = next_num + 1;
     end
     execute procedure CREATE_BOOKING$WBE(:product_selection_id,:aranger_id,'WBE.'||:selection_id||'.'||:next_num) returning_values :booking_id,:selection_id;
     execute procedure IMPORT_BOOKING_FINALIZE$EXC(:booking_id) returning_values  record_timestamp,:err_code,:err_text;
     insert into SCHEDULER$WBE(booking_id,status,last_action_time,lang_code,guarantee_passed) values (:booking_id, NULL, current_timestamp, :lang_code,0);

     if (next_num is NULL) then begin
      next_num = 1;
     end else begin
      next_num = next_num + 1;
     end
  end
end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_POST_TO_FRONT_ONLINE for: EAI_EXT_POST_TO_MH_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_EXT_POST_TO_MH_FRONT_ONLINE) */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  if (:CODE_TYPE = 'EXT_CODE') then begin
    execute procedure EAI_MAP_SERVICE(:SERVICE_CODE, :SERVICE_CODE, 'UNKNOWN', :id_hotel)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_SERVICE;
    if (:ERR_CODE < 0) then exit;
  end else begin
    select S.ID_SERVICE
    from   SERVICES S
    where  S.ID_SERVICE = :SERVICE_CODE
           and s.ID_HOTEL = :ID_HOTEL
    into   :ID_SERVICE;
    if (:ID_SERVICE is null) then begin
      ERR_CODE = -85;   /* Wrong value! */
      exit;
    end
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Alter (EAI_EXT_SERVICE_POST) */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable max_id_service integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_ROOM  = null;
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  select min(S.ID_SERVICE) as id_service, max(s.id_service) as max_id_service
  from   SERVICES S
  where  S.EXT_CODE = :SERVICE_EXT_CODE
         and s.IS_BASE = 0
         and s.IS_DELETED = 0
  into   :ID_SERVICE, :max_id_service;
  if (:ID_SERVICE is null) then begin
      ERR_CODE = -388;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end else if (:ID_SERVICE <> :max_id_service) then begin
      ERR_CODE = -389;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_EXT_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Alter (EAI_MAP_SERVICE) */
ALTER PROCEDURE EAI_MAP_SERVICE(SERVICE_TAG VARCHAR(30),
SERVICE_NAME VARCHAR(30),
EXTERNAL_IFC VARCHAR(30),
ID_HOTEL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_MAPPED_SERVICE INTEGER)
 AS
declare variable id_service_group integer;
  declare variable setting_code varchar(30);
  declare variable revenue_group varchar(30);
  declare variable is_base integer;
  declare variable is_deleted integer;
begin
  /*  Description:
  ||
  */
  err_code = 0;
  err_text = '';
  id_mapped_service = null;
  select first 1 S.ID_SERVICE, S.IS_BASE, s.IS_DELETED
  from   SERVICES S
  where  S.EXT_CODE = :service_tag
         and s.ID_HOTEL = :id_hotel
  order by s.ID_SERVICE asc
  into   :id_mapped_service, :is_base, :is_deleted;

  if (:is_base = 1) then begin
    ERR_CODE = -63;
    ERR_TEXT= '';
    exit;
  end
  if (:is_deleted = 1) then begin
    ERR_CODE = -64;
    ERR_TEXT= '';
    exit;
  end
  if (:id_mapped_service is not null) then exit;

  if (:external_ifc = 'POS') then revenue_group = 'Food and Beverage';
  else revenue_group = 'Other Operated departments';

  setting_code = 'IFC_'||:external_ifc||'_SRVGRP';
  execute procedure SETTING_GET_VALUE(:setting_code, :ID_HOTEL)
  returning_values  :id_service_group;

  execute procedure SERVICE_MODIFY(null, :id_service_group, 'EXTRA', :service_name, 0, 1, 0,
                    :revenue_group, null, null, :service_tag, 'BASE', '', 0, 'add', :ID_HOTEL,
                    0, 0, 0, 0, 0, 0, null, null)
  returning_values  :id_mapped_service;
end
^

/* empty dependent procedure body */
/* Clear: EAI_POS_POSTING_ADD for: EAI_POS_POSTING_ADD$P2E */
ALTER PROCEDURE EAI_POS_POSTING_ADD(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_POS_POSTING_ADD$P2E) */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
declare variable id_service integer;
  declare variable my_post_text varchar(255);
  declare variable my_resource_text varchar(255);
  declare variable no_use integer;
  declare variable nation_curr varchar(3);
  declare variable post_short_code varchar(10);
  declare variable id_hotel integer;
begin
  /* in_on_guest = 0 (account), 1 (guest), -1 (ew)
  */
  if (:IN_ON_GUEST = 1) then begin
    select rd.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :IN_ID_GUEST
    into   :id_hotel;
  end else begin
    select a.ID_HOTEL
    from   account a
    where  a.ID_ACCOUNT = :in_id_account
    into   :id_hotel;
  end

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :nation_curr;

  if ('END_WORK' = :in_smetka_num) then begin
    post_short_code='POS_EW';
  end else begin
    post_short_code='POS';
  end

  /* FIND SERVICE */
  execute procedure EAI_MAP_SERVICE(:in_service_tag, :in_service_name, 'POS', :id_hotel)
  returning_values  :err_code, :err_text, :id_service;
  if (:err_code < 0) then exit;

  my_post_text = 'date:'|| formatdate(:in_date_smetka, 'D;dd.mm.yyyy') ||
                 ' num:'|| :in_smetka_num ||
                 ' obj:'|| :in_obj_name ||
                 ' tbl:'|| :in_table ||
                 ' site:'|| :in_site;

  my_resource_text = 'POS_ID_SMETKA:'||:in_id_smetka;
  my_post_text = substring(:my_post_text from 1 for 100);
  my_resource_text = substring(:my_resource_text from 1 for 49);

  if (:in_on_guest = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:in_id_guest, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code, '')
    returning_values  :err_code, :err_text, :out_id_account, :no_use;
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:in_id_account, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code)
    returning_values  :err_code, :err_text, :no_use;
    out_id_account = :in_id_account;
  end
end
^

/* Alter (EAI_TELECOUNT_TRANSFER) */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* Alter (END_WORK) */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable system_date date;
  declare variable id_room integer;
  declare variable id_end_work integer;
  declare variable last_closed_date date;
  declare variable mark_dirty_expired_block varchar(10);
  declare variable mark_dirty_occ_room varchar(10);
  declare variable lock_id integer;
  declare variable shift_no integer;
  declare variable init_hotel_date date;
begin

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;
  if (:system_date >= :in_next_date) then exception END_WORK_EXCEPTION '-43';
  if (:IN_NEXT_DATE > current_date + 1) then exception END_WORK_EXCEPTION '-60';

  last_closed_date = :in_next_date - 1;

  /* LOCK THE CURRENT FINANCIAL (SYSTEM) DATE  */
  lock_id = null;
  while (:lock_id is null) do begin
    lock_id = strhash_large(:system_date || :id_hotel);
    execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'lock');
  
    when any do begin
      exception END_WORK_EXCEPTION '-337' || f_character(31) || f_character(29) || FormatDate(:system_date, 'D;dd.mm.yyyy');
    end
  end

  /* RIGHT IS REQUIRED TO CHANGE THE FINANCIAL DATE IF THERE ARE GUESTS WITH OVERDUE CHECK OUT */
  if (exists(
    select *
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
    where  G.TO_DATE <= :last_closed_date
           and G.CHECK_STATUS < 1
           and RD.ID_HOTEL = :id_hotel
           and rd.IS_ANUL = 0
  )) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('EW_OVERDUE_CHECKOUT');
  end

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', 'EW');
  -- Suppress eventual right checks into next procedures - all is permitted. Is this needed(?!?)

  update ACCOUNT_POST AP
  set    ap.ROOM_NAME = (select R.ROOM_NAME
                         from   GUEST G
                                join ROOMS R on R.ID_ROOM = G.ID_ROOM
                         where  G.ID_GUEST = ap.ID_GUEST)
  where  ap.DATE_POST between :system_date and :last_closed_date
         and ap.ID_GUEST > 0;

  select coalesce(max(ew.SHIFT_NO), 0) + 1
  from   END_WORKS ew
  where  ew.PREV_DATE = :system_date
  into   :shift_no;

  id_end_work = gen_id(G_AUTO_INC_END_WORKS, 1);
  insert into END_WORKS (ID_END_WORK, PREV_DATE, NEXT_DATE, END_WORK_KIND, SHIFT_NO, ID_HOTEL)
  values (:id_end_work, :system_date, :in_next_date, 3, :shift_no, :id_hotel);

  /* CHANGE SYSTEM DATE */
  execute procedure SYSTEM_DATE_SET(:id_hotel, :in_next_date);

  /* AUTO EXPIRATION OF ROOM NUMBERS, ROOMS AND BOOKING POSITIONS */
  execute procedure RESERVS_EXPIRE$INT(:last_closed_date, :id_hotel);

  execute procedure AGENT_CONTINGENT_EXPIRE(:system_date, :last_closed_date, null, 0, 1, :id_hotel);

  /* DELETE PERSON PROFILES WITH EXPIRATION DATE */
  execute procedure PROFILE_PERSON_EXPIRE (:in_next_date);

  execute procedure SETTING_GET_VALUE('MARK_DIRTY_EXPIRED_BLOCK', :ID_HOTEL)
  returning_values  :mark_dirty_expired_block;
  if (:mark_dirty_expired_block = '1') then begin
    for
      select distinct BR.ID_ROOM
      from   BLOCK_ROOM BR
             join ROOMS R on R.ID_ROOM = BR.ID_ROOM
      where  R.ID_HOTEL = :id_hotel
             and BR.TO_DATE >= :system_date
             and BR.TO_DATE < :in_next_date
             and BR.IS_ANNUL = 0
         into :id_room
    do begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'BLOCK_EXP', 'set_dirty');

      when any do post_event 'dummy';  -- nothing
    end
  end

  execute procedure SETTING_GET_VALUE('MARK_DIRTY_OCC_ROOM', :ID_HOTEL)
  returning_values  :mark_dirty_occ_room;
  if (:mark_dirty_occ_room = '1') then begin
    for
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
             join ROOMS R on R.ID_ROOM = rm.ID_ROOM
      where  R.ID_HOTEL = :id_hotel
             and RM.BUSY_DATE = :system_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and RM.BUSY_GROUP_TYPE = 24
      into   :id_room
    do begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'EW_DAY', 'set_dirty');

      when any do post_event 'dummy';  -- nothing
    end
  end

  /* Summary data prepare */
  if (:in_next_date > :system_date) then begin
    execute procedure SUMMARY_FINANCE_SAVE$INT (:id_end_work);

    select min(e.PREV_DATE)
    from   END_WORKS E
    where  E.ID_HOTEL = :ID_HOTEL
    into   :init_hotel_date;

    execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:id_hotel, :init_hotel_date, :last_closed_date); --TODO precise the period

    execute procedure SUMMARY_FORECAST$INT(:ID_HOTEL, :system_date);
  end

  /* Delete data from temporal tables */
  delete from RESERV_ERROR;
  delete from TMP_SMALL_OCCUP;
--  delete from GUEST g where g.id_reserv_detail is null; pri regenerirane na statistikata ne vurshi rabota
  /*  */

  execute procedure CACHES_RESOLVE;

  execute procedure SYSTEM_LOG_ADD('SYSTEM', :id_end_work, 'DAY_EW', f_character(29) || :last_closed_date);

  execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'release');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', null);

  post_event 'invalidate.end_work';
end
^

/* Alter (GUEST_ACCOUNT_TRANSFER$INT) */
ALTER PROCEDURE GUEST_ACCOUNT_TRANSFER$INT(ID_GUEST INTEGER,
ID_SOURCE_ACCOUNT INTEGER,
ID_TARGET_ACCOUNT INTEGER,
SERVICE_TYPE VARCHAR(20))
 AS
declare variable dbkey char(8);
begin

  if (:service_type = 'BASE') then begin
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.ID_ACCOUNT = :id_source_account
             and AP.AC = '00'
             and AP.ID_BASE_DOC is null
             and ((AP.IS_BASE = 1) or (AP.ID_MASTER_ADDINS_ACC_POST <> -1))
      into   :dbkey
    do
      execute procedure ACCOUNT_POSTING_TRANSFER$INT(:dbkey, :id_target_account);

  end else begin
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.ID_ACCOUNT = :id_source_account
             and AP.AC = '00'
             and AP.ID_BASE_DOC is null
             and ((AP.IS_BASE = 0) and (AP.ID_MASTER_ADDINS_ACC_POST = -1))
      into   :dbkey
    do
      execute procedure ACCOUNT_POSTING_TRANSFER$INT(:dbkey, :id_target_account);

  end
end
^

/* Alter (GUEST_POST_GET_PACK_SERVICE) */
ALTER PROCEDURE GUEST_POST_GET_PACK_SERVICE(IN_ID_SERVICE INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_POST DATE)
 RETURNS(ID_PACK_SERVICE INTEGER)
 AS
declare variable id_type_stay integer;
  declare variable id_room_type integer;
  declare variable id_board integer;
  declare variable id_hotel integer;
begin
  /*  Description:
  ||
  */
  id_pack_service = -1;
  select Sp.ID_TYPE_STAY, Sp.ID_ROOM_TYPE, s.ID_HOTEL
  from   SERVICE_PACKET Sp
         join SERVICES S on s.ID_SERVICE = sp.ID_SERVICE
  where  S.ID_SERVICE = :in_id_service
  into   :id_type_stay, :id_room_type, :id_hotel;

  select GS.ID_BOARD
  from   GUEST_STAY GS
  where  GS.ID_GUEST = :in_id_guest
         and GS.FOR_DATE = :in_date_post
  into   :id_board;

  /*dbg = savedbg('in_id_guest = '||:in_id_guest);
  dbg = savedbg('in_date_post = '||:in_date_post);
  dbg = savedbg('id_board = '||:id_board); */
  execute procedure TAR_GET_BASE_SERVICE$INT(:id_type_stay, :id_room_type, :id_board, :id_hotel)
  returning_values  :id_pack_service;

end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTS$INT for: GUEST_REROUTE_POSTINGS$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTS$INT(RD_DBKEY CHAR(8))
 AS
 BEGIN EXIT; END
^

/* Alter (GUEST_REROUTE_POSTINGS$INT) */
ALTER PROCEDURE GUEST_REROUTE_POSTINGS$INT(ID_GUEST INTEGER,
ID_BASE_ACCOUNT INTEGER,
ID_EXTRA_ACCOUNT INTEGER)
 AS
declare variable ap_dbkey char(8);
  declare variable is_packet_post integer;
  declare variable packet_option varchar(50);
  declare variable id_target_account integer;
  declare variable id_current_account integer;
begin
  update GUEST G
  set    G.ID_BASE_ACCOUNT = :ID_BASE_ACCOUNT,
         G.ID_ACCOUNT = :ID_EXTRA_ACCOUNT
  where  G.ID_GUEST = :ID_GUEST;

  for
    select AP.RDB$DB_KEY, iif(AP.ID_MASTER_ADDINS_ACC_POST > 0, 1, 0), S.VAUCHER_PACKET,
           ap.ID_ACCOUNT
    from   ACCOUNT_POST AP
           join SERVICES S on S.ID_SERVICE = AP.ID_SERVICE
    where  AP.ID_GUEST = :ID_GUEST
           and AP.AC = '00'
           and AP.ID_BASE_DOC is null
    into   :ap_dbkey, :is_packet_post, :packet_option, :id_current_account
  do begin
    if ((:is_packet_post = 1) and (:packet_option <> 'NONE')) then id_target_account = :id_base_account;
    else id_target_account = :id_extra_account;

    if (:id_current_account <> :id_target_account) then begin
      execute procedure ACCOUNT_POSTING_TRANSFER$INT(:ap_dbkey, :id_target_account);
    end
  end

end
^

/* Alter (IMPORT_BOOKING_FINALIZE$EXC) */
ALTER PROCEDURE IMPORT_BOOKING_FINALIZE$EXC(BOOKING_ID INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1,
STATUS VARCHAR(50) = null,
CONFIRMATION_NUMBER NAME_20 = null,
CANCELATION_NUMBER NAME_20 = null)
 RETURNS(RECORD_TIMESTAMP TIMESTAMP,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable booking_db_key char(8);
  declare variable dummy_int integer;
  declare variable dummy_text varchar(255) ;
  declare variable res_id_room integer;
  declare variable id_room integer;
  declare variable id_room_type integer;
  declare variable system_date date;
  declare variable from_date date;
  declare variable to_date date;
  declare variable gs_dbkey char(8);
begin
  ERR_CODE=0;
  ERR_TEXT=null;
  id_room = null;
  force_res_finalize = coalesce(:force_res_finalize, 1);

  execute procedure sys_dbg('exc IMPORT_BOOKING_FINALIZE$EXC => CLEAR_ORPHAN_GUESTS$EXC');
  execute procedure CLEAR_ORPHAN_GUESTS$EXC(:booking_id);

  select b.rdb$db_key, b.ID_ROOM, b.ID_ROOM_TYPE, b.FROM_DATE, b.TO_DATE
  from   reserv_detail b
  where  b.id_reserv_detail = :booking_id
  into   :booking_db_key, :res_id_room, :id_room_type, :from_date, :to_date;

  execute procedure RES_GUEST_SAVE_DIFF$INT(:booking_db_key);

  if (:res_id_room < 0) then begin
    for
      select lp.OUT_DATE
      from   SYSTEM_LOOP_PERIOD (:from_date, :to_date-1) lp
      into   :system_date
    do begin
      select ro.ID_ROOM, ro.ID_ROOM_TYPE
      from   RES_OCCUPANCY_ROOM$INT (:BOOKING_ID, :system_date, null, :id_room_type) ro
      into   :id_room, :id_room_type;
  
      if (:id_room <> :res_id_room) then begin
        for
          select gs.RDB$DB_KEY
          from   GUEST_STAY GS
                 join GUEST G on g.ID_GUEST = gs.ID_GUEST
          where  g.ID_RESERV_DETAIL = :BOOKING_ID
                 and gs.FOR_DATE = :system_date
                 and gs.ID_ROOM <> :id_room
          into   :gs_dbkey
        do begin
          update GUEST_STAY gsu
          set    gsu.ID_ROOM = :id_room
                 --gsu.ID_ROOM_TYPE = iif (gsu.ID_ROOM_TYPE = -1, :id_room_type, gsu.ID_ROOM_TYPE)
          where  gsu.RDB$DB_KEY = :gs_dbkey;
        end
      end
    end
    update GUEST G
    set    G.ID_ROOM = coalesce(:id_room, :res_id_room)
    where  g.ID_RESERV_DETAIL = :BOOKING_ID;
  end

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null,   --force recalculation
         rd.ID_ROOM = coalesce(:id_room, :res_id_room)
         --rd.HAS_DIFFERENT_ROOM_TYPE = coalesce(:has_different_room_type,  rd.HAS_DIFFERENT_ROOM_TYPE)
  where  rd.RDB$DB_KEY = :booking_db_key;

  if (1 = :force_res_finalize) then begin
    execute procedure sys_dbg('exc IMPORT_BOOKING_FINALIZE$EXC => RES_FINALIZE_SHAREOPTION$INT');
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:booking_db_key, 0)
    returning_values  :dummy_int, :dummy_text, :dummy_int, :dummy_int;
  end

  execute procedure APPLY_BOOKING_STATUS$EXC(
    null, :booking_db_key, :status, :confirmation_number, :cancelation_number
  );

  select b.change_time
  from   reserv_detail b
  where  b.rdb$db_key =:booking_db_key
  into   :record_timestamp;
end
^

/* empty dependent procedure body */
/* Clear: EAI_IMPORT_ALOYALTY_CLIENT for: IMPORT_PERSON_PROFILE$EXC */
ALTER PROCEDURE EAI_IMPORT_ALOYALTY_CLIENT(CLIENT_UUID VARCHAR(40),
CLIENT_NAME VARCHAR(100),
CARD_CODE VARCHAR(50),
IS_ARHIVE SMALLINT,
DATE_OF_BIRTH DATE)
 AS
 BEGIN EXIT; END
^

/* Alter (IMPORT_PERSON_PROFILE$EXC) */
ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
declare variable op varchar(10);
  declare variable market_segment_id integer;
  declare variable sex_old char(1);
  declare variable birth_date_old date;
  declare variable birth_place_old varchar(30);
  declare variable personal_number_old varchar(30);
  declare variable pass_num_old varchar(20);
  declare variable pass_date_old date;
  declare variable pass_place_old varchar(20);
  declare variable pass_exp_date_old date;
  declare variable pass_city_old varchar(100);
  declare variable pass_address_old varchar(100);
  declare variable country_old varchar(10);
  declare variable mask_old varchar(10);
  declare variable title_old varchar(10);
  declare variable id_photo integer;
  declare variable id_def_contragent integer;
  declare variable id_passport_type integer;
  declare variable account_no_old varchar(20);
  declare variable msg_old varchar(255);
  declare variable id_guest_type integer;
  declare variable id_guest_type_old integer;
  declare variable card_code_old varchar(50);
  declare variable is_exclusive_debt_ownership smallint;
  declare variable profile_receiver_id integer;
begin
  profile_id = null;
  import_time = null;

  execute procedure import_mark_transaction$exc;

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC(:profile_uuid=>' || coalesce(:profile_uuid, '<null>')
                          || ', email=>' || coalesce(:email, '<null>') || ')');

  profile_id = null;
  if (profile_uuid is null) then begin
    execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC <null> :profile_uuid - exit;');
    exit;
  end

  select p.profile_id, p.profile_name, p.phone, p.fax, p.email, p.city,
         p.address, p.market_segment, p.note, p.is_archive, pp.card_code,
         pd.sex, pd.birthday_internal, pd.birth_place, pd.egn, pd.pass_num,
         pd.pass_date, pd.pass_place, pd.pass_exp_date, pd.city, pd.address, pd.country_code,
         pd.mask, p.id_def_contragent, p.wbe_password,
         pd.title, p.account_no, p.msg, pp.id_guest_type, pp.id_photo, pd.id_passport_type,
         p.is_exclusive_debt_ownership
  from   import_common_profile$exc(:profile_uuid, 0, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :wbe_password, :ACCOUNT_NO, :MSG, 'PERSON_PROFILE', :HOTEL_UUID_LIST) p
         left outer join profile_person pp on pp.id_profile = p.profile_id
         left outer join person_data pd on pd.id_person_data=pp.id_person_data
  into   :profile_id, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :card_code_old,
         :sex_old, :birth_date_old, :birth_place_old, :personal_number_old, :pass_num_old,
         :pass_date_old, :pass_place_old, :pass_exp_date_old, :pass_city_old, :pass_address_old, :country_old,
         :mask_old, :id_def_contragent, :wbe_password, :title_old,
         :account_no_old, :msg_old, :id_guest_type_old, :id_photo, :id_passport_type, :is_exclusive_debt_ownership;

  if (:profile_id is null) then begin
    op = 'add';
  end else if (:hotel_uuid_list is null) then begin
    profile_id = null;
    exit;
  end else begin
    op = 'mod';
    delete from PROFILE_BONUSPOINT_SCHEME bs
      where bs.ID_PROFILE = :profile_id;
  end

  sex=coalesce(:sex, :sex_old);
  birth_date=coalesce(:birth_date, :birth_date_old);
  birth_place=coalesce(:birth_place, :birth_place_old);
  personal_number=coalesce(:personal_number, :personal_number_old);
  pass_num=coalesce(:pass_num, :pass_num_old);
  pass_date=coalesce(:pass_date, :pass_date_old);
  pass_place=coalesce(:pass_place, :pass_place_old);
  pass_exp_date=coalesce(:pass_exp_date, :pass_exp_date_old);
  pass_city=coalesce(:pass_city, :pass_city_old);
  pass_address=coalesce(:pass_address, :pass_address_old);
  country=upper(coalesce(:country, :country_old));
  mask=coalesce(:mask, :mask_old);
  title=coalesce(:title, :title_old);
  account_no=coalesce(:account_no, :account_no_old);
  msg=coalesce(:msg, :msg_old);
  card_code=coalesce(:card_code, :card_code_old);

  execute procedure IMPORT_PASSPORT_TYPE$EXC(:pass_type_name, :pass_type_external_code)
  returning_values :id_passport_type;

  execute procedure lookup_market_segment$exc(:profile_name, 'PERSON_PROFILE', :market_segment)
  returning_values :market_segment_id;

  if (guest_type_name is not null) then begin
    execute procedure lookup_guest_type$exc(:profile_name, 'PERSON_PROFILE', :guest_type_name)
    returning_values :id_guest_type;
  end

  if ((def_contragent_name is not null) and (def_contragent_name <> '')) then begin
    execute procedure LOOKUP_CONTRAGENT$EXC(:profile_name, 'PERSON_PROFILE', :def_contragent_name)
    returning_values :id_def_contragent;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:profile_name, 'PERSON_PROFILE');

  id_guest_type=coalesce(:id_guest_type, :id_guest_type_old);

  if (id_photo is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, null, null, null, 'del')
    returning_values :id_photo;
  end
  id_photo = null;
  if (picture is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, :picture, :picture_type, :picture_layout, 'add')
    returning_values :id_photo;
  end

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC - profile_person_modify$profile(:profile_uuid=>'
    || coalesce(:profile_uuid, '<null>')
    || ', :operation=>' || coalesce(:op, '<null>')
    || ', :email=>' || coalesce(:email, '<null>')
    || ', :birth_date=>' || coalesce(:birth_date, '<null>')
  || ')');
  execute procedure profile_person_modify$profile(
    :profile_id,
    :id_guest_type,
    :profile_name,
    null,
    :sex,
    :birth_date,
    :birth_place,
    :personal_number,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :pass_place,
    :pass_exp_date,
    :country,
    :pass_city,
    :pass_address,
    :mask,
    :phone,
    :fax,
    :email,
    :city,
    :address,
    :note,
    :msg,
    :id_def_contragent,
    :market_segment_id,
    :is_archive,
    :id_photo,
    :card_code,
    :wbe_password,
    :op,
    :account_no,
    :title,
    :is_exclusive_debt_ownership
  ) returning_values
    :profile_id;

  /*assign uuid to the new profiles*/
  if ('add' = :op) then begin
    update profile set uuid=:profile_uuid where id_profile=:profile_id;
  end

  select record_timestamp from profile where id_profile=:profile_id
  into :import_time;

  if (:MERGE_TARGET_UUID is not null) then begin
    select p.ID_PROFILE
    from   PROFILE P
    where  P.UUID = :MERGE_TARGET_UUID
    into   :profile_receiver_id;

    execute procedure PROFILE_MERGE$PROFILE (:PROFILE_ID, :profile_receiver_id, 'merge');

  end

end
^

/* Alter (IMPORT_RATE$EXC) */
ALTER PROCEDURE IMPORT_RATE$EXC(TARIFA_NAME VARCHAR(50),
TARIFA_GROUP VARCHAR(30),
HOTEL_NAME VARCHAR(50),
TARIFA_CURR VARCHAR(3),
IS_ACTIVE SMALLINT,
TARIFA_NOTE VARCHAR(500),
PERIOD_DEPEND_ON_CHECKIN SMALLINT,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BOARD_TYPE VARCHAR(10),
SOURCE_BASE_BOARDS_LIST VARCHAR(255),
TMP_DATA BLOB SUB_TYPE 1,
LOCK_KEY VARCHAR(100),
LOCK_STAMP TIMESTAMP,
UUID VARCHAR(40),
RATE_TYPE VARCHAR(20),
IS_SIMPLE SMALLINT,
CHILD_AGE_INCL INTEGER,
IS_PUBLIC TYPE OF TLOGICAL,
EXPLICIT_TAX_POLICY_NAME TDESCRIPTION_SHORT = null,
EXPLICIT_POLICY_NIGHTS_REQUIRED TCOUNT = null)
 RETURNS(ID_TARIFA INTEGER,
ID_TARIFA_GROUP INTEGER,
ID_HOTEL INTEGER,
ID_TAR_SIMPLE INTEGER)
 AS
declare variable BASE_BOARDS_LIST varchar(255);
  declare variable BOARD_NAME varchar(30);
  declare variable ID_BOARD integer;
  declare variable EXPLICIT_TAX_POLICY integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure IMPORT_RATE_COMMON$EXC(:TARIFA_NAME, :TARIFA_GROUP, :HOTEL_NAME, :TARIFA_CURR, 1, :IS_ACTIVE,
    :TARIFA_NOTE, :UUID, :RATE_TYPE, :IS_SIMPLE, :IS_PUBLIC, :CHILD_AGE_INCL)
  returning_values :ID_TARIFA, :ID_TARIFA_GROUP, :ID_HOTEL;

  select ts.ID_TAR_SIMPLE
  from   TAR_SIMPLE ts
  where  ts.ID_TAR_HEAD = :ID_TARIFA
  into   :ID_TAR_SIMPLE;

  BASE_BOARDS_LIST = '';
  for
    select ITEM
    from   SYSTEM_STRING_PARSER(:SOURCE_BASE_BOARDS_LIST, ',')
    into   :BOARD_NAME
  do begin
    execute procedure LOOKUP_BOARD$EXC(:ID_HOTEL, :TARIFA_NAME, :RATE_TYPE, :BOARD_NAME, 0)
    returning_values :ID_BOARD;
    BASE_BOARDS_LIST = BASE_BOARDS_LIST || F_CHARACTER(28) || ID_BOARD;
  end

  if (:EXPLICIT_TAX_POLICY_NAME is not null) then begin
    execute procedure LOOKUP_TAX_POLICY$EXC(:ID_HOTEL, :TARIFA_NAME, :RATE_TYPE, :EXPLICIT_TAX_POLICY_NAME)
    returning_values :EXPLICIT_TAX_POLICY;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:TARIFA_NAME, :RATE_TYPE);

  update TAR_HEAD th
  set    th.PERIOD_DEPEND_ON_CHECKIN = :PERIOD_DEPEND_ON_CHECKIN,
         th.CNT_DAYS_PRICE_BP = :CNT_DAYS_PRICE_BP,
         th.CNT_DAYS_PRICE_BOARD = :CNT_DAYS_PRICE_BOARD,
         th.BASE_BOARDS_LIST = :BASE_BOARDS_LIST,
         th.BOARD_TYPE = :BOARD_TYPE,
         th.TMP_DATA = :TMP_DATA,
         th.LOCK_KEY = :LOCK_KEY,
         th.LOCK_STAMP = :LOCK_STAMP,
         th.EXPLICIT_TAX_POLICY = :EXPLICIT_TAX_POLICY,
         th.EXPLICIT_POLICY_NIGHTS_REQUIRED = :EXPLICIT_POLICY_NIGHTS_REQUIRED
  where  th.ID_TAR_HEAD = :ID_TARIFA;
end
^

/* Alter (IMPORT_RATE_SIMPLE_BOARD$EXC) */
ALTER PROCEDURE IMPORT_RATE_SIMPLE_BOARD$EXC(ID_HOTEL INTEGER,
ID_TAR_SIMPLE_SEASON INTEGER,
RATE_NAME VARCHAR(30),
BOARD_NAME VARCHAR(30),
ADULT_PRICE NUMERIC(15,4),
CHILD_PRICE NUMERIC(15,4))
 RETURNS(ID_TAR_SIMPLE_BOARDS INTEGER)
 AS
declare variable ID_BOARD_TYPE integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_BOARD$EXC(:ID_HOTEL, :RATE_NAME, 'RATE_SIMPLE', :BOARD_NAME, 1)
  returning_values :ID_BOARD_TYPE;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:RATE_NAME, 'ROOM_TYPE');

  execute procedure TAR_SIMPLE_BOARD_MODIFY$CFG(null,
                                                :ID_TAR_SIMPLE_SEASON,
                                                :ID_BOARD_TYPE,
                                                :ADULT_PRICE,
                                                :CHILD_PRICE,
                                                'add')
  returning_values :ID_TAR_SIMPLE_BOARDS;
end
^

/* Alter (IMPORT_RATE_SIMPLE_PRICE$EXC) */
ALTER PROCEDURE IMPORT_RATE_SIMPLE_PRICE$EXC(ID_TAR_SIMPLE_SEASON INTEGER,
RATE_NAME VARCHAR(30),
HOTEL_NAME VARCHAR(50),
ROOM_TYPE VARCHAR(20),
BOARD_NAME VARCHAR(30),
SINGLE_PRICE NUMERIC(15,4),
DOUBLE_PRICE NUMERIC(15,4),
GUEST3_PRICE NUMERIC(15,4),
GUEST4PLUS_PRICE NUMERIC(15,4),
CHILD1_W_ADULT1_PRICE NUMERIC(15,4),
CHILD1_W_ADULT2PLUS_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT1_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT2PLUS_PRICE NUMERIC(15,4),
IS_BASE_DAYS_PRICE SMALLINT)
 AS
declare variable ID_HOTEL integer;
declare variable ID_ROOM_TYPE integer;
declare variable ID_BOARD_TYPE integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'RATE_SIMPLE', :RATE_NAME)
  returning_values :ID_HOTEL;

  execute procedure LOOKUP_ROOM_TYPE$EXC(:ID_HOTEL, :RATE_NAME, 'RATE_SIMPLE', :ROOM_TYPE)
  returning_values :ID_ROOM_TYPE;

  execute procedure LOOKUP_BOARD$EXC(:ID_HOTEL, :RATE_NAME, 'RATE_SIMPLE', :BOARD_NAME, 1)
  returning_values :ID_BOARD_TYPE;

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:RATE_NAME, 'RATE_SIMPLE');

  execute procedure TAR_SIMPLE_PRICE_MODIFY$CFG(:ID_TAR_SIMPLE_SEASON,
                                                :ID_ROOM_TYPE,
                                                :ID_BOARD_TYPE,
                                                :SINGLE_PRICE,
                                                :DOUBLE_PRICE,
                                                :GUEST3_PRICE,
                                                :GUEST4PLUS_PRICE,
                                                :CHILD1_W_ADULT1_PRICE,
                                                :CHILD1_W_ADULT2PLUS_PRICE,
                                                :CHILD2PLUS_W_ADULT1_PRICE,
                                                :CHILD2PLUS_W_ADULT2PLUS_PRICE,
                                                :IS_BASE_DAYS_PRICE);
end
^

/* Alter (IMPORT_SERVICE$EXC) */
ALTER PROCEDURE IMPORT_SERVICE$EXC(SERVICE_NAME VARCHAR(30),
SERVICE_GROUP VARCHAR(30),
SERVICE_TYPE VARCHAR(50),
IS_DELETED SMALLINT,
IS_MANUAL_PRICE SMALLINT,
IS_DETAILS SMALLINT,
REVENUE_GROUP VARCHAR(50),
REVENUE_ACCOUNT VARCHAR(50),
ACCOUNT_NAME VARCHAR(30),
EXT_CODE VARCHAR(30),
VAUCHER_PACKET VARCHAR(20),
EXTRA_PACKET_NAME VARCHAR(10),
IS_RATE_PRICE SMALLINT,
IS_BREAKFAST SMALLINT,
IS_LUNCH SMALLINT,
IS_DINNER SMALLINT,
IS_EXTRAFOOD1 SMALLINT,
IS_EXTRAFOOD2 SMALLINT,
IS_BOARD SMALLINT,
PRICE NUMERIC(15,4),
PRICE_CURR VARCHAR(3),
HOTEL_NAME VARCHAR(50),
UUID VARCHAR(40))
 RETURNS(ID_SERVICE INTEGER,
ID_SERVICE_GROUP INTEGER)
 AS
declare variable ID_HOTEL integer;
declare variable OPERATION VARCHAR(3);
begin
  execute procedure import_mark_transaction$exc;

  execute procedure LOOKUP_HOTEL$EXC(:HOTEL_NAME, 'SERVICE', :SERVICE_NAME)
  returning_values :ID_HOTEL;
  execute procedure CHECK_LOOKUP_ERRORS$EXC(:SERVICE_NAME, 'SERVICE');

  execute procedure IMPORT_SERVICE_GROUP$EXC(:ID_HOTEL, :SERVICE_GROUP)
  returning_values :ID_SERVICE_GROUP;

  ID_SERVICE = null;
  select s.ID_SERVICE
  from   SERVICES s
  where  s.UUID = :UUID
         and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :ID_SERVICE;

  if (:ID_SERVICE is null) then begin
    OPERATION = 'add';
  end else begin
    OPERATION = 'mod';
  end

  if (:EXTRA_PACKET_NAME is null) then begin
    EXTRA_PACKET_NAME = '';
  end

  execute procedure SERVICE_MODIFY(:ID_SERVICE, :ID_SERVICE_GROUP, :SERVICE_TYPE, :SERVICE_NAME,
    :IS_DELETED, :IS_MANUAL_PRICE, :IS_DETAILS, :REVENUE_GROUP, :REVENUE_ACCOUNT,
    :ACCOUNT_NAME, :EXT_CODE, :VAUCHER_PACKET, :EXTRA_PACKET_NAME, :IS_RATE_PRICE,
    :OPERATION, :ID_HOTEL, :IS_BREAKFAST, :IS_LUNCH, :IS_DINNER, :IS_EXTRAFOOD1, :IS_EXTRAFOOD2,
    :IS_BOARD, :PRICE, :PRICE_CURR)
  returning_values :ID_SERVICE;

  update SERVICES s
  set    s.UUID = :UUID
  where  s.ID_SERVICE = :ID_SERVICE;
end
^

/* Alter (MONITOR_ROOM_GANTT$HM) */
ALTER PROCEDURE MONITOR_ROOM_GANTT$HM(FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ID_ROOM INTEGER,
GFROM_DATE DATE,
IS_MOVED_FROM INTEGER,
GTO_DATE DATE,
IS_MOVED_TO INTEGER,
BUSY_GRP INTEGER,
OCCUPANT_ID INTEGER,
IN_SHARE SMALLINT,
ID_GROUP INTEGER,
ATTENTION_STATUS SMALLINT)
 AS
declare variable contiguous_id_room integer;
begin
  for
    select ID_ROOM, GFROM_DATE, IS_MOVED_FROM, GTO_DATE,
           IS_MOVED_TO, BUSY_GRP, OCCUPANT_ID
    from   MONITOR_ROOM_GANTT$INT(:from_date, :to_date)
    into   :id_room, :gfrom_date, :is_moved_from, :gto_date,
           :is_moved_to, :busy_grp, :occupant_id
  do begin
    if (:gfrom_date = :from_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gfrom_date - 1)
      into   :contiguous_id_room;

      if ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_from = 1;

      select O.FROM_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gfrom_date;
    end

    if (:gto_date = :to_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gto_date + 1)
      into   :contiguous_id_room;

      if ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_to = 1;

      select O.TO_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gto_date;
    end

    if (:busy_grp in (1, 24)) then begin
      select RI.ATTENTION_STATUS, RI.ID_GROUP, RI.IN_SHARE
      from   RES_GET_INFO$RSV(:occupant_id, 0, 1, 0) RI
      into   :attention_status, :id_group, :in_share;
    end else begin
      id_group = null;
      attention_status = null;
      in_share = null;
      if (exists(
        select *
        from   ROOMS_SHARE RS
        where  RS.ID_RESERV_DETAIL = :occupant_id
      )) then in_share = 1;
      else in_share = 0;
    end
    suspend;
  end
end
^

/* Alter (MONITOR_ROOM_GANTT_OCCUPANT$HM) */
ALTER PROCEDURE MONITOR_ROOM_GANTT_OCCUPANT$HM(FROM_DATE DATE,
TO_DATE DATE,
REQUEST_OCCUPANT_ID INTEGER)
 RETURNS(ID_ROOM INTEGER,
GFROM_DATE DATE,
IS_MOVED_FROM INTEGER,
GTO_DATE DATE,
IS_MOVED_TO INTEGER,
BUSY_GRP INTEGER,
OCCUPANT_ID INTEGER,
IN_SHARE SMALLINT,
ID_GROUP INTEGER,
ATTENTION_STATUS SMALLINT)
 AS
declare variable contiguous_id_room integer;
begin
  for
    select ID_ROOM, GFROM_DATE, IS_MOVED_FROM, GTO_DATE,
           IS_MOVED_TO, BUSY_GRP, OCCUPANT_ID
    from   MONITOR_ROOM_GANTT$INT(:from_date, :to_date, :request_occupant_id)
    into   :id_room, :gfrom_date, :is_moved_from, :gto_date,
           :is_moved_to, :busy_grp, :occupant_id
  do begin
    if (:gfrom_date = :from_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gfrom_date - 1)
      into   :contiguous_id_room;

      if     ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_from = 1;

      select O.FROM_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gfrom_date;
    end

    if (:gto_date = :to_date) then begin
      contiguous_id_room = null;
      select RM.ID_ROOM
      from   ROOM_MAGIC RM
      where  RM.ID_RESERV_DETAIL = :occupant_id
             and RM.BUSY_DATE = (:gto_date + 1)
      into   :contiguous_id_room;

      if ((:contiguous_id_room is not null) and (:contiguous_id_room <> :id_room)) then is_moved_to = 1;

      select O.TO_DATE
      from   OCCUPANT_GET_INFO(:occupant_id, :busy_grp) O
      into   :gto_date;
    end

    if (exists(
      select *
      from   ROOMS_SHARE RS
      where  RS.ID_ROOM = :id_room
             and RS.BUSY_DATE between :from_date and :to_date
    )) then in_share = 1;
    else in_share = 0;
  
    if (:busy_grp in (1,24)) then begin
      select RI.ATTENTION_STATUS, RI.ID_GROUP
      from   RES_GET_INFO$RSV(:occupant_id, 0, 0, 0) RI
      into   :attention_status, :id_group;
    end else begin
      id_group = null;
      attention_status = null;
    end
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: MONITOR_ROOM_GANT$HM for: OCCUPANT_GET_INFO */
ALTER PROCEDURE MONITOR_ROOM_GANT$HM(FROM_DATE DATE,
TO_DATE DATE,
IN_ROOM_NAME VARCHAR(10),
IN_ID_ROOM_TYPE INTEGER,
IN_FLOOR INTEGER,
ID_HOTEL INTEGER)
 RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(20),
GANT_FROM_DATE DATE,
GANT_TO_DATE DATE,
BUSY_GRP INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GET_SHARE_STATUS$INT for: OCCUPANT_GET_INFO */
ALTER PROCEDURE RES_GET_SHARE_STATUS$INT(ID_RESERV_DETAIL INTEGER,
OPTION_ VARCHAR(100),
FOR_DATE DATE)
 RETURNS(SHARE_STATUS INTEGER,
SHARED_RESERVATIONS VARCHAR(1024),
SHARE_RENDER VARCHAR(1024))
 AS
 BEGIN SUSPEND; END
^

/* Alter (OCCUPANT_GET_INFO) */
ALTER PROCEDURE OCCUPANT_GET_INFO(ID_OCCUPANT INTEGER,
IN_BUSY_GRP INTEGER = null)
 RETURNS(BUSY_GRP INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
INFO VARCHAR(1024))
 AS
declare variable max_day_action integer;
begin
  --busy_grp = :in_busy_grp;

  select max(RM.DAY_ACTION_INT), min(rm.BUSY_GROUP_TYPE)
  from   ROOM_MAGIC RM
  where  RM.ID_RESERV_DETAIL = :ID_OCCUPANT
         --and RM.BUSY_GROUP_TYPE = :busy_grp
  into   :max_day_action, :busy_grp;

  if (:busy_grp in (18, 20) and :max_day_action = 0) then begin
    select BGI.BUSY_GRP, BGI.REASON, BGI.FROM_DATE, BGI.TO_DATE
    from   BLOCK_GET_INFO(:id_occupant) BGI
    into   :busy_grp, :info, :from_date, :to_date;
  end else begin
    -- when :busy_grp in (1, 24) or (:max_day_action > 0) - reservation with block busy group type - owners, as an example
    select RGI.BUSY_GRP, RGI.NUMBER, RGI.ARRIVAL_DATE, RGI.DEPARTURE_DATE
    from   RES_GET_INFO$RSV(:id_occupant, 0, 0, 0) RGI
    into   :busy_grp, :info, :from_date, :to_date;
  end

  suspend;
end
^

/* Alter (PHONECALL_POST$TC) */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Alter (PHONECALLS_POST_TO_ACCOUNT$TC) */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POST_MODIFY$PMS for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: CONTRACT_EXPENSE_POST$INT for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_HOTEL INTEGER,
ID_CONTRACT /* TYPE OF ID */ INTEGER,
SUB_CONTRACT /* TYPE OF TSUB_CONTRACT */ VARCHAR(10),
ID_OWNER /* TYPE OF ID */ INTEGER,
OWNERSHIP_PERCENT /* TYPE OF TPERCENT */ NUMERIC(15,4),
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
POST_DATE /* TYPE OF TDATE */ DATE,
STAY /* TYPE OF TCOUNT */ INTEGER,
MAX_GUEST_CNT /* TYPE OF TCOUNT */ INTEGER,
BED_NIGHT_CNT /* TYPE OF TCOUNT */ INTEGER,
RESERVS /* TYPE OF TCOUNT */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PMS_EXPENSE_POSTS_CREATE$INT for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_EXPENSE_POSTS_CREATE$INT(ID_ROOM /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
POST_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
IS_CLIENT_ACC_POST /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_POST_DATE /* TYPE OF TDATE */ DATE,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IS_POST_PER_POOL /* TYPE OF TLOGICAL */ SMALLINT)
 RETURNS(NEW_ID_ACCOUNT_POST /* ID_REF */ INTEGER,
NEW_ID_ACCOUNT_POST$PMS /* ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PMS_POOL_DISTRIBUTION_SUB for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_POSTING_CREATE$INT) */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_OWNER TYPE OF ID,
POST_DATE TYPE OF TDATE,
CURR_ORIG TYPE OF TCURRENCY,
VALUE_ORIG TYPE OF TPRICE,
POST_ON_PMS_ACCOUNT TYPE OF TLOGICAL,
IS_OWNER_INCOME TYPE OF TLOGICAL,
ID_ROOM TYPE OF ID_REF = null)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  if (:POST_ON_PMS_ACCOUNT = 1) then begin
    execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account, :id_owner,
            :CURR_ORIG, :VALUE_ORIG, :id_service, :is_owner_income, :POST_DATE)
    returning_values  (:new_id_account_post);
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :ID_SERVICE, 1, 0, 1,
            :VALUE_ORIG, :CURR_ORIG, current_date, current_date,
            '', '', :POST_DATE, 'PMS', :ID_ROOM)
    returning_values  :err_code, :err_text, :new_id_account_post;
    if (:err_code <> 0) then exception PMS_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

    insert into PMS_EVENT_POST (ID_PMS_EVENT, ID_ACCOUNT_POST, ID_OWNER, LINE_STATUS)
    values (:ID_PMS_EVENT, :NEW_ID_ACCOUNT_POST, :ID_OWNER, 11);
  end
end
^

/* Alter (POST_SERVICE_FINALIZE$POST) */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
  declare variable id_acc_post integer;
  declare variable id_service integer;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable date_post date;
  declare variable price_post numeric(15,4);
  declare variable qty_post numeric(15,2);
  declare variable post_text varchar(100);
  declare variable curr_post varchar(3);
  declare variable id_phonecall integer;
  declare variable p_dbkey char(8);
begin

  if (:OPERATION = 'clear') then begin
    delete from TMP_SERVICE_POST T
    where  T.ID_SEQUENCE = :ID_SEQUENCE;

  end else if (:OPERATION = 'store') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);

    for
      select TS.RDB$DB_KEY, TS.ID_SERVICE, TS.ID_ACCOUNT, TS.ID_GUEST, TS.DATE_POST,
             TS.PRICE_POST, TS.QTY_POST, TS.CURR_POST, TS.POST_TEXT, TS.ID_PHONECALL
      from   TMP_SERVICE_POST TS
      where  TS.ID_SEQUENCE = :ID_SEQUENCE
      into   :p_dbkey, :id_service, :id_account, :id_guest, :date_post,
             :price_post, :qty_post, :curr_post, :post_text, :id_phonecall
    do begin
      id_acc_post = null;
      if (:id_guest is not null) then begin
        execute procedure POST_SERVICE_ON_GUEST$INT (:id_guest, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :CURR_POST,
                :date_post, :date_post, :post_text, '', :date_post, '', '')
        returning_values  (:err_code, :err_text, :no_use, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end else begin
        execute procedure POST_SERVICE_ON_ACCOUNT$INT (:id_account, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :curr_post, :date_post, :date_post, :post_text,
                '', :date_post, '')
        returning_values  (:err_code, :err_text, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end

      update TMP_SERVICE_POST
      set ID_ACCOUNT_POST = :id_acc_post
      where RDB$DB_KEY = :p_dbkey;

      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :DOC_SELECTED,
             AP.SHORT_CODE = case
                               when :id_phonecall is not null then 'TELECOUNT'
                               else null
                             end
      where  AP.ID_ACCOUNT_POST = :id_acc_post;

      if (:id_phonecall is not null) then begin
        update PHONECALLS P
        set    P.ID_ACCOUNT_POST = :id_acc_post
        where  P.ID_PHONECALL = :id_phonecall;
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: PRODUCT_SELECTION_RECALC$WBE for: PRODUCT_RATING$INT */
ALTER PROCEDURE PRODUCT_SELECTION_RECALC$WBE(WBE_SESSION_ID INTEGER)
 RETURNS(ERR_COUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PRODUCT_RATING$INT) */
ALTER PROCEDURE PRODUCT_RATING$INT(ID_HOTEL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
ADULT_AGES VARCHAR(100) = null,
CHILD_AGES VARCHAR(100) = null,
ID_TAR_CALC_COMMON INTEGER = null)
 RETURNS(ROOM_PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100))
 AS
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable id_reserv integer;
declare variable id_tar_calc integer;
declare variable rate_currency char(3);
begin
  id_tar_calc = null;
  select T.CURR
  from   TARIFA T
  where  t.ID_TARIFA = :ID_RATE
  into   :rate_currency;

  execute procedure TAR_CALC_INPUT_PLAIN$INT (:adult_count, :children_count,
          :id_room_type, :id_board, :arrival_date, :departure_date,
          '', '', null, '', null, null, :id_rate, :adult_ages, :child_ages, :ID_TAR_CALC_COMMON)
  returning_values (:id_tar_calc, :id_reserv, :err_code, :err_text);
  --if (:err_code < 0) then exit;

  if (:err_code = 0) then begin
    execute procedure TAR_CALC_EVAL_ALL$INT(:id_tar_calc)
    returning_values  :err_code, :err_text;
    /*savedbg('-----------------------------');
    savedbg('id_rate: ' || :id_rate);
    savedbg('id_board: ' || :id_board);
    savedbg('id_room_type: ' || :id_room_type);
    savedbg('id_tar_calc: ' || :id_tar_calc);
    savedbg('err_code: ' || :ERR_CODE);
    savedbg('err_text: ' || :ERR_TEXT);
    */
    if (:err_code = 0) then begin
      execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

      price_currency = :rate_currency;
      execute procedure TAR_CALC_GET_PRICE$INT (:id_tar_calc, :id_hotel, :id_reserv, :price_currency)
      returning_values  :room_price, :room_price_details;
    end
  end
end
^

/* Alter (PRODUCT_SELECTION_RECALC$WBE) */
ALTER PROCEDURE PRODUCT_SELECTION_RECALC$WBE(WBE_SESSION_ID INTEGER)
 RETURNS(ERR_COUNT INTEGER)
 AS
declare variable arrival date;
declare variable departure date;
declare variable adults integer;
declare variable children integer;
declare variable room_type_id integer;
declare variable rate_id integer;
declare variable board_id integer;
declare variable hotel_id integer;
declare variable product_selection_dbkey char(8);
declare variable product_value numeric(15,4);
declare variable product_currency char(3);
declare variable adults_ages varchar(100);
declare variable children_ages varchar(100);
declare variable no_use varchar(255);
begin
  err_count = 0;

  for
    select ps.rdb$db_key, aq.first_date, aq.first_date + aq.day_count, ps.adults, ps.children,
           pa.room_type_id, pa.rate_id, pa.board_id, ws.hotel_id,
           (select list(coalesce(g.AGE, ''))
            from   PRODUCT_SELECTION_GUESTS$WBE g
            where  g.PRODUCT_SELECTION_ID = ps.ID
                   and g.IS_CHILD = 0),
           (select list(coalesce(g.AGE, ''))
            from   PRODUCT_SELECTION_GUESTS$WBE g
            where  g.PRODUCT_SELECTION_ID = ps.ID
                   and g.IS_CHILD = 1)
    from   PRODUCT_SELECTION$WBE PS
           join PRODUCT_AVAILABILITY$WBE PA on PA.ID = PS.PRODUCT_AVAILABILITY_ID
           join WBE_SESSION$WBE WS on WS.ID=PS.WBE_SESSION_ID
           join AVAILABILITY_QUERY$WBE AQ on AQ.ID = WS.PRODUCT_QUERY_ID
    where  ps.wbe_session_id = :wbe_session_id
    into   :product_selection_dbkey, :arrival, :departure, :adults, :children,
    :room_type_id, :rate_id, :board_id, :hotel_id, :adults_ages, :children_ages
  do begin
    /*calc prices for request in TMP_AVAILABILITY */
    product_value = null;
    product_currency = null;
    execute procedure PRODUCT_RATING$INT (:hotel_id, :arrival, :departure,
            :adults, :children, :room_type_id, :board_id, :rate_id, :adults_ages, :children_ages)
    returning_values  :product_value, :product_currency, :no_use;

    if (:product_value is null) then begin
      err_count = :err_count + 1;
    end

    update PRODUCT_SELECTION$WBE ps
    set    ps.total_value = :product_value,
           ps.currency = :product_currency
    where  ps.rdb$db_key = :product_selection_dbkey;
  end
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_AGENT_PROFILE$EXC for: PROFILE_AGENT_MODIFY$PROFILE */
ALTER PROCEDURE IMPORT_AGENT_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
AGENT_GROUP VARCHAR(50),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
WBE_PASSWORD VARCHAR(20),
IATA_NUMBER VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
DEF_CONTRAGENT_NAME VARCHAR(100),
THRESHOLD_NOTE VARCHAR(255),
THRESHOLD_AMOUNT NUMERIC(15,4),
THRESHOLD_CURR CHAR(3),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PROFILE_AGENT_MODIFY$PROFILE) */
ALTER PROCEDURE PROFILE_AGENT_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
IS_ARCHIVE INTEGER,
AGENT_GROUP VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IATA_NUMBER VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null,
THRESHOLD_NOTE VARCHAR(255) = null,
THRESHOLD_AMOUNT NUMERIC(15,4) = null,
THRESHOLD_CURR CHAR(3) = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable id_agent integer;
  declare variable action_text varchar(255);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  AGENT_GROUP = nullif(trim(:AGENT_GROUP), '');

  if (:operation in ('add', 'mod')) then begin
    execute procedure PROFILE_COMMON_MODIFY$INT(:id_profile, 'AGENT', :profile_name,
            :phone, :fax, :email, :contact_city, :contact_address,
            :note, :msg, :is_archive, :id_def_contragent, :id_nom_market_segment,
            :wbe_password, :account_no, :is_exclusive_debt_ownership)
    returning_values (:NEW_ID_PROFILE);

    if (:new_id_profile is distinct from :id_profile) then begin
      id_agent = gen_id(G_AUTO_INC_AGENT,1);
      insert into AGENT (ID_AGENT, AGENT_NAME, IS_USE)
      values (:id_agent, :profile_name, 1-:is_archive);
  
      insert into PROFILE_AGENT(ID_PROFILE, ID_AGENT, AGENT_GROUP, COUNTRY_CODE, IATA_NUMBER, THRESHOLD_NOTE, THRESHOLD_AMOUNT, THRESHOLD_CURR)
      values (:new_id_profile, :id_agent, :agent_group, :country_code, :iata_number, :threshold_note, :threshold_amount, :threshold_curr);
  
      action_text = f_character(29) || :profile_name;
      execute procedure SYSTEM_LOG_ADD ('PROFILE', :new_id_profile, 'CREATE_AGENT_PROFILE', :action_text);
    end else begin
      select PA.ID_AGENT
      from   PROFILE_AGENT PA
      where  PA.ID_PROFILE = :NEW_ID_PROFILE
      into   :id_agent;

      update PROFILE_AGENT PA
      set    PA.IATA_NUMBER = :IATA_NUMBER,
             PA.COUNTRY_CODE = :COUNTRY_CODE,
             PA.AGENT_GROUP = :AGENT_GROUP,
             PA.THRESHOLD_NOTE = :THRESHOLD_NOTE,
             PA.THRESHOLD_AMOUNT = :THRESHOLD_AMOUNT,
             PA.THRESHOLD_CURR = :THRESHOLD_CURR
      where  PA.ID_PROFILE = :NEW_ID_PROFILE;

      update AGENT A
      set    A.AGENT_NAME = :profile_name,
             A.IS_USE = 1 - :is_archive
      where  A.ID_AGENT = :id_agent;
    end
  end else if (:operation = 'del') then  begin
    execute procedure PROFILE_DELETE$INT(:id_profile);

    new_id_profile = null;
  end
end
^

/* Alter (RES_CHECKIN$RSV) */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable old_check_status integer;
  declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable is_anul integer;
  declare variable arrival_date date;
  declare variable system_date date;
begin
  /*  Description:
  ||
  */
  select RD.CHECK_STATUS, RD.RDB$DB_KEY, RD.FROM_DATE, RD.ID_HOTEL,
         RD.ID_ROOM, RD.IS_ANUL
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_check_status, :rd_dbkey, :arrival_date, :id_hotel,
         :old_id_room, :is_anul;

  if (:is_anul = 1) then exception BOOKING_EXCEPTION '-2';

  if (:old_check_status >= 0) then exception BOOKING_EXCEPTION '-1003';

  if (:old_id_room < 0 and coalesce(:ID_ROOM, 0) <= 0) then exception BOOKING_EXCEPTION '-1018';

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date < :arrival_date) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CHECK_IN_FUTURE');
  end
  /*----*/
  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'lock');

  execute procedure sys_dbg('occ RES_CHECKIN$RSV id_room = '||coalesce(:id_room, 'null'));
  execute procedure sys_dbg('occ RES_CHECKIN$RSV old_id_room = '||coalesce(:old_id_room, 'null'));

  if (:id_room is not null) then begin
    if (:old_check_status = -3) then begin
      execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, -2);
    end

    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option)
    returning_values (:WARN_CODE);
  end

  execute procedure RES_SET_CHECKIN$INT (:rd_dbkey)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'release');
  /*----*/
  select f_character(29) || R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = coalesce(:ID_ROOM, :old_id_room)
  into   :action_text;
   
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'CHECK_IN', :action_text);

end
^

/* Alter (RES_CHECKIN_MULTI$RSV) */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable checkin_count integer;
  declare variable split_on_checkin integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
  declare variable tmp_warn_code integer;
begin
  checkin_count = 0;
  warn_code = null;
  for
    select RD.ID_RESERV_DETAIL, RD.CHECK_STATUS, RD.SPLIT_ON_CHECKIN, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :SELECTION_ID
    into   :id_reserv_detail, :check_status, :split_on_checkin, :id_titular
  do begin
    if (:check_status >= 0) then begin
      checkin_count = :checkin_count + 1;
    end else begin
      if (:split_on_checkin = 1) then begin
        for
          select G.ID_GUEST
          from   GUEST G
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and G.ID_GUEST <> :id_titular
          into   :id_guest
        do begin
          execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
          returning_values  :id_splited_reservation;

          execute procedure RES_CHECKIN$RSV (:id_splited_reservation)
          returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

          update RESERV_DETAIL RD
          set    RD.SELECTION_ID = :selection_id
          where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
        end
      end

      execute procedure RES_CHECKIN$RSV (:id_reserv_detail)
      returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
      WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end

  if (:checkin_count > 0) then begin
    execute procedure SYSTEM_WARNING_ADD(-1011, f_character(29)||:checkin_count)
    returning_values  :warn_code;
  end
end
^

/* Alter (RES_CREATE_SET$EXC) */
ALTER PROCEDURE RES_CREATE_SET$EXC(ID_RESERV_DETAIL INTEGER,
RES_NUMBER VARCHAR(62),
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER,
CREATE_DATETIME TIMESTAMP)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_RESERV_DETAIL INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  WARN_CODE = 0;
  SHARE_TRANSACTION_ID = 0;
  SHARE_ERR_CODE = 0;

  execute procedure sys_dbg('exc RES_CREATE_SET$EXC => RES_CREATE_SET$INT('
  || 'code_first_food=>' || coalesce(:code_first_food, '<null>')
  || ', id_person_payment=>' || coalesce(:id_person_payment, '<null>')
  || ')');

  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, null, :arrival_date, :departure_date,
                    :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, '', :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders, :guarantee_deposit,
                    :guarantee_currency, 0, :id_reserv_detail, :res_number, null,  :id_guarantee_policy, :block_cc,
                    :id_eating_object)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :warn_code;

  execute procedure UPDATE_POSTING_TRANSACTION$EXC(:rd_dbkey, :posting_transaction_uuid, 1);

  execute procedure RES_SAVE_GUARANTEE$RSV(:id_reserv_detail, :is_vip, null,
    :id_guarantee_policy, :guarantee_deposit, :guarantee_currency, :block_cc, :guarantee_deposit_percent,
    :guarantee_deposit_nights, :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create
  );

  execute procedure RESERV_DETAIL_EXTERNAL_MOD$RSV(:id_reserv_detail,
    :minibar_rights, :paytv_rights, :video_rights, :nopost_pms, :phone_rights,
    :seminar_cahnnel_rights, null
  );

  if (:create_datetime is not null) then begin
    update reserv_detail set create_datetime = :create_datetime where rdb$db_key = :rd_dbkey;
  end
end
^

/* empty dependent procedure body */
/* Clear: GUEST_ADDRESSCARD_SET$RSV for: RES_FINALIZE$INT */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$RSV(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
EGN VARCHAR(30),
COUNTRY VARCHAR(10),
ID_STAY_REASON INTEGER,
IS_REGISTRED INTEGER,
PASS_PLACE VARCHAR(20),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_PLACE VARCHAR(30),
SEX CHAR,
MASK VARCHAR(10),
IS_CHILD INTEGER,
CAR VARCHAR(30),
KPP INTEGER,
KPP_DATE DATE,
PASS_EXP_DATE DATE,
AGE INTEGER,
BIRTH_DAY DATE,
VISA /* TDESCRIPTION_SHORT */ VARCHAR(100),
RATING_AGE INTEGER = null,
TITLE VARCHAR(10) = null,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_ANUL_DETAIL$INT for: RES_FINALIZE$INT */
ALTER PROCEDURE RES_ANUL_DETAIL$INT(RD_DBKEY CHAR(8),
REASON VARCHAR(50),
CANCELATION_NUMBER /* TYPE OF NAME_20 */ VARCHAR(20) = null)
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_DELETE$INT for: RES_FINALIZE$INT */
ALTER PROCEDURE RES_DELETE$INT(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_EARLY_DEPARTURE_SET$RSV for: RES_FINALIZE$INT */
ALTER PROCEDURE RES_EARLY_DEPARTURE_SET$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND INTEGER)
 RETURNS(RECALC_MARKER_LIST VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_FINALIZE$RSV for: RES_FINALIZE$INT */
ALTER PROCEDURE RES_GUEST_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER,
ALL_ERRORS_ARE_INSTANT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUESTLIST_REMOVE$RSV for: RES_FINALIZE$INT */
ALTER PROCEDURE RES_GUESTLIST_REMOVE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_ROOM_REMOVE$INT for: RES_FINALIZE$INT */
ALTER PROCEDURE RES_ROOM_REMOVE$INT(RD_DBKEY CHAR(8))
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTING$RSV for: RES_FINALIZE$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$RSV(ID_RESERV_DETAIL INTEGER,
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER,
ID_CREDIT_CARD INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_GUARANTEE$RSV for: RES_FINALIZE$INT */
ALTER PROCEDURE RES_SAVE_GUARANTEE$RSV(ID_RESERV_DETAIL INTEGER,
IS_VIP SMALLINT,
CHECK_STATUS INTEGER,
ID_GUARANTEE_POLICY INTEGER,
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_GUESTCOUNT$RSV for: RES_FINALIZE$INT */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_FINALIZE$INT) */
ALTER PROCEDURE RES_FINALIZE$INT(RD_DBKEY CHAR(8),
SUPPRESS_NON_INSTANT_ERRORS SMALLINT = 0)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable err_text varchar(255);
begin
  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, :SUPPRESS_NON_INSTANT_ERRORS)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;
  if (:share_err_code < 0) then exception BOOKING_EXCEPTION :share_err_code || f_character(31) || :ERR_TEXT;
end
^

/* empty dependent procedure body */
/* Clear: RES_GET_PRICE$INT for: RES_FINALIZE_RECALC$INT */
ALTER PROCEDURE RES_GET_PRICE$INT(RD_DBKEY CHAR(8),
OPTIONS VARCHAR(255))
 RETURNS(ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
REQUIRED_DEPOSIT_VALUE NUMERIC(15,4),
REQUIRED_DEPOSIT_CURRENCY CHAR(3))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_RATE$RSV for: RES_FINALIZE_RECALC$INT */
ALTER PROCEDURE RES_SAVE_RATE$RSV(ID_RESERV_DETAIL INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
IS_DIFFERENT_TARIFF INTEGER,
IS_DIFFERENT_PRICE INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_FINALIZE_RECALC$INT) */
ALTER PROCEDURE RES_FINALIZE_RECALC$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_calc integer;
begin
  -- NORMAL recalculation processing
  execute procedure RES_RECALC$INT(:rd_dbkey, 'NORMAL', 0)
  returning_values  :err_code, :err_text, :id_tar_calc;
  if (:err_code < 0) then exit;

end
^

/* empty dependent procedure body */
/* Clear: RES_GET_DEPOSIT$INT for: RES_GET_PRICE$INT */
ALTER PROCEDURE RES_GET_DEPOSIT$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(DEPOSIT_VALUE NUMERIC(15,4),
DEPOSIT_CURRENCY CHAR(3))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GET_PRICE$RPT for: RES_GET_PRICE$INT */
ALTER PROCEDURE RES_GET_PRICE$RPT(ID_RESERV_DETAIL INTEGER,
OPTIONS VARCHAR(255) = 'FORCED')
 RETURNS(ROOM_PRICE NUMERIC(15,4),
PRICE_CURRENCY VARCHAR(3),
ROOM_DAY_PRICE NUMERIC(15,4),
ROOM_PRICE_DETAILS VARCHAR(255),
IS_MANUAL_PRICE SMALLINT,
REQUIRED_DEPOSIT_VALUE NUMERIC(15,4),
REQUIRED_DEPOSIT_CURRENCY CHAR(3))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GET_PRICE$RSV for: RES_GET_PRICE$INT */
ALTER PROCEDURE RES_GET_PRICE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(ROOM_PRICE_DETAILS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GET_PRICE$INT) */
ALTER PROCEDURE RES_GET_PRICE$INT(RD_DBKEY CHAR(8),
OPTIONS VARCHAR(255))
 RETURNS(ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(255),
REQUIRED_DEPOSIT_VALUE NUMERIC(15,4),
REQUIRED_DEPOSIT_CURRENCY CHAR(3))
 AS
declare variable id_reserv_detail integer;
  declare variable no_access integer;

  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable guarantee_deposit_percent integer;
  declare variable guarantee_deposit_nights integer;
  declare variable res_days integer;
begin
  /*  Description:
  ||  OPTIONS = [FORCED || SECURITY || POSTED ]
  */

  select RD.ROOM_PRICE, RD.ROOM_CURRENCY, RD.ROOM_PRICE_DETAILS,
         RD.ID_RESERV_DETAIL, rd.GUARANTEE_DEPOSIT_PERCENT, rd.GUARANTEE_DEPOSIT_NIGHTS,
         RD.GUARANTEE_DEPOSIT, rd.GUARANTEE_CURRENCY,rd.TO_DATE - rd.FROM_DATE
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :room_price, :room_currency, :room_price_details,
         :id_reserv_detail, :guarantee_deposit_percent, :guarantee_deposit_nights,
         :required_deposit_value, :required_deposit_currency, :res_days;

  if (:options containing 'POSTED' /*and (:check_status >= 0)*/) then begin
    -- can be posted and not checked in
    select sum(AP.PRICE_ORIG * AP.QTY_POST * CR.RATE)
    from   ACCOUNT_POST AP
           join GUEST G on G.ID_GUEST = AP.ID_GUEST
           join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
           left outer join CURR_CROSS_RATE_GET(AP.CURR_ORIG, :room_currency, AP.DATE_POST, A.ID_HOTEL) CR on 0=0
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
           and AP.IS_ANUL = 0
           and AP.ID_MASTER_ADDINS_ACC_POST > 0
    into   :room_price;
    room_price_details = '';
    REQUIRED_DEPOSIT_CURRENCY = null;
    REQUIRED_DEPOSIT_VALUE = null;
  end

  if (:options containing 'SECURITY') then begin
    select max(A.SECURITY_LEVEL - SEC.GRANTED_LEVEL)
    from   GUEST G
           join ACCOUNT A on A.ID_ACCOUNT = G.ID_BASE_ACCOUNT
           left outer join (select cast(iif(
                exists(
                  select *
                  from   USER_RIGHTS R
                  where  R.RIGHT_CODE  = 'ACCSECURLEVEL1'
                ) , 1, 0) as integer) as GRANTED_LEVEL
           from RDB$DATABASE) SEC on 0=0
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :no_access;
    if (:no_access = 1) then begin
      room_price = null;
      room_currency = null;
      room_price_details = '-';
      exit;
    end
  end

  if ((:room_price is null) and (:options containing 'FORCED')) then begin
    execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    returning_values  :err_code, :err_text;
    if (:err_code < 0) then exit;
  
    -- execute procedure TAR_CALC_FINALIZE$INT(:err_code, :id_tar_calc, :rd_dbkey);

    select RD.ROOM_PRICE, RD.ROOM_CURRENCY, RD.ROOM_PRICE_DETAILS
    from   RESERV_DETAIL RD
    where  RD.RDB$DB_KEY = :rd_dbkey
    into   :room_price, :room_currency, :room_price_details;

  end

  if (:REQUIRED_DEPOSIT_VALUE is null) then begin
    REQUIRED_DEPOSIT_CURRENCY = :ROOM_CURRENCY;
    if (:guarantee_deposit_percent is not null) then
      REQUIRED_DEPOSIT_VALUE = :ROOM_PRICE * cast(:guarantee_deposit_percent as double precision) / 100;
    else if (:guarantee_deposit_nights is not null) then
      REQUIRED_DEPOSIT_VALUE = :ROOM_PRICE * cast(:guarantee_deposit_nights as double precision) / :res_days;
  end

end
^

/* Alter (RES_GET_PRICE$RPT) */
ALTER PROCEDURE RES_GET_PRICE$RPT(ID_RESERV_DETAIL INTEGER,
OPTIONS VARCHAR(255) = 'FORCED')
 RETURNS(ROOM_PRICE NUMERIC(15,4),
PRICE_CURRENCY VARCHAR(3),
ROOM_DAY_PRICE NUMERIC(15,4),
ROOM_PRICE_DETAILS VARCHAR(255),
IS_MANUAL_PRICE SMALLINT,
REQUIRED_DEPOSIT_VALUE NUMERIC(15,4),
REQUIRED_DEPOSIT_CURRENCY CHAR(3))
 AS
declare variable rd_dbkey char(8);
  declare variable r_days integer;
begin
  /*  Description:
  ||
  */
  rd_dbkey = null;
  room_price = null;
  price_currency = null;
  select RD.RDB$DB_KEY, RD.TO_DATE - RD.FROM_DATE,
         iif((RD.HAS_DIFFERENT_PRICE = 1) or (RD.CUSTOM_PRICE is not null), 1, 0)
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
         and RD.IS_ANUL = 0
  into   :rd_dbkey, :r_days, :IS_MANUAL_PRICE;

  if (:rd_dbkey is null) then exit;
  execute procedure RES_GET_PRICE$INT(:rd_dbkey, :options)
  returning_values  :room_price, :price_currency, :room_price_details, :required_deposit_value, :required_deposit_currency;
  room_day_price = :room_price / :r_days;

  suspend;
end
^

/* Alter (RES_GET_PRICE$RSV) */
ALTER PROCEDURE RES_GET_PRICE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(ROOM_PRICE_DETAILS VARCHAR(255),
ROOM_PRICE NUMERIC(15,4),
ROOM_CURRENCY CHAR(3))
 AS
declare variable rd_dbkey char(8);
declare variable dummy varchar(255);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_GET_PRICE$INT(:rd_dbkey, 'SECURITY, FORCED')
  returning_values  :room_price, :room_currency, :room_price_details, :dummy, :dummy;

  room_price_details = formatFloat(:room_price, 'F;0.00')||:room_currency||' ('|| :room_price_details||')';
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_GET_GUESTS$INT for: RES_GET_SHARE_STATUS$INT */
ALTER PROCEDURE TAR_CALC_GET_GUESTS$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_GUEST INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
G_DBKEY CHAR(8),
ID_GUEST_RESERV /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GET_SHARE_STATUS$INT) */
ALTER PROCEDURE RES_GET_SHARE_STATUS$INT(ID_RESERV_DETAIL INTEGER,
OPTION_ VARCHAR(100),
FOR_DATE DATE)
 RETURNS(SHARE_STATUS INTEGER,
SHARED_RESERVATIONS VARCHAR(1024),
SHARE_RENDER VARCHAR(1024))
 AS
declare variable mark_transaction integer;
  declare variable shared_reservation_id integer;
  declare variable occupant_info varchar(2000);
  declare variable is_ex_share integer;
  declare variable check_status integer;
  declare variable split_on_checkin integer;
  declare variable res_from_date date;
  declare variable res_to_date date;
  declare variable related_reservations VARCHAR(1024);
  declare variable busy_group_type integer;
begin
  /*  OPTIONs:
    !!!! DONT mix options !!!.
    ENUM_SHARES - return id's of shared reservations (SHARED_RESERVATIONS) in this save session - usable for calculation and regenerations, but not for renders.
    ENUM_EX_SHARES - return id's of shared reservations just leaved share. As above..
    RENDER - render all reservations in share with current. Usabe for gui previews.
  */
  execute procedure SYSTEM_CHECK_OPERATION (:OPTION_, 'ENUM_SHARES,ENUM_EX_SHARES,RENDER,FOR_RECALC', 'option');

  execute procedure sys_dbg('calc RES_GET_SHARE_STATUS$INT options = '||coalesce(:OPTION_, 'null'));

  shared_reservations = '';
  share_render = '';

  select RD.CHECK_STATUS, RD.SPLIT_ON_CHECKIN, RD.FROM_DATE, RD.TO_DATE
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :check_status, :split_on_checkin, :res_from_date, :res_to_date;

  mark_transaction = RDB$GET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION');

  if (:mark_transaction is null) then begin
    -- THE CALLER IS outside saving/regeneration transaction - NOT FINALIZING BOOKING CHANGES
    select min(RS.IS_EX_SHARE)
    from   ROOMS_SHARE RS
    where  RS.ID_RESERV_DETAIL = :id_reserv_detail
           and ((:for_date is null) or (RS.BUSY_DATE = :for_date))
    into   :is_ex_share;
  end else begin
    -- THIS TRANSACTION IS Saving booking and REGENERATING ROOMS_MAGIC
    select min(RS.IS_EX_SHARE)
    from   ROOMS_SHARE RS
    where  RS.MARK_TRANSACTION = :mark_transaction
           and ((:for_date is null) or (RS.BUSY_DATE = :for_date))
    into   :is_ex_share;
  end

  execute procedure sys_dbg('calc RES_GET_SHARE_STATUS$INT mark_transaction = '||coalesce(:mark_transaction, 'null'));

  if (:is_ex_share = 0) then share_status = 1;
  /*else - null or 1*/
  else share_status = 0;

  execute procedure sys_dbg('calc RES_GET_SHARE_STATUS$INT share_status = '||coalesce(:share_status, 'null'));

  /*option will be changed if we want enum shares ouside modification transaction - for recalculation in example*/
  if ((:OPTION_ = 'ENUM_SHARES') and (:share_status = 1) and (:mark_transaction is null)) then begin
    option_ = 'RENDER';
    execute procedure sys_dbg('calc RES_GET_SHARE_STATUS$INT option was ENUM_SHARES but is changd to RENDER, because :mark_transaction is null' );
  end

  if ((:OPTION_ = 'ENUM_SHARES') and (:share_status = 1)) then begin
    for
      select distinct RS.ID_RESERV_DETAIL
      from   ROOMS_SHARE RS
      where  RS.MARK_TRANSACTION = :mark_transaction
             and RS.BUSY_DATE = coalesce(:for_date, RS.BUSY_DATE)
             and RS.IS_EX_SHARE = 0
      into   :shared_reservation_id
    do begin
      if (:shared_reservation_id <> :id_reserv_detail) then begin
        shared_reservations = :shared_reservations || iif(:shared_reservations = '', '', ',');
        shared_reservations = :shared_reservations || :shared_reservation_id;
      end
    end
  end

  if (:OPTION_ = 'RENDER') then begin
    if (:SHARE_STATUS = 0 ) then begin
      if (:check_status < 0 and :split_on_checkin = 1 and :OPTION_ = 'RENDER') then begin
        share_status = 2;
        exit;
      end
    end else begin
      if (:for_date is not null) then begin
        /*make render only for one date, otherwise for erservation period*/
        res_from_date = :for_date;
        res_to_date = :for_date;
      end

      for
        select distinct RS.ID_RESERV_DETAIL, rs.BUSY_GROUP_TYPE
        from   ROOM_MAGIC rm
               join ROOMS_SHARE RS on rm.id_room = rs.id_room
                                      and rm.busy_date = rs.busy_date
        where  rm.id_reserv_detail = :id_reserv_detail
               and RM.BUSY_DATE between :res_from_date and :res_to_date
               and RS.IS_EX_SHARE = 0
        into   :shared_reservation_id, :busy_group_type
      do begin
        if (:shared_reservation_id <> :id_reserv_detail) then begin
          shared_reservations = :shared_reservations || iif(:shared_reservations = '', '', ',');
          shared_reservations = :shared_reservations || :shared_reservation_id;
          select OGI.INFO
          from   OCCUPANT_GET_INFO(:shared_reservation_id, :busy_group_type) OGI
          into   :occupant_info;
          share_render = :share_render || iif(:share_render = '', '', ',');
          share_render = :share_render || :occupant_info;
        end
      end
    end
  end

  if (:OPTION_ = 'ENUM_EX_SHARES') then begin
    for
      select distinct
             RS.ID_RESERV_DETAIL
      from   ROOMS_SHARE RS
      where  RS.MARK_TRANSACTION = :mark_transaction
             and ((:for_date is null) or (RS.BUSY_DATE = :for_date))
             and RS.IS_EX_SHARE = 1
      into   :shared_reservation_id
    do begin
      if (:shared_reservation_id <> :id_reserv_detail) then begin
        shared_reservations = :shared_reservations || iif(:shared_reservations = '', '', ',');
        shared_reservations = :shared_reservations || :shared_reservation_id;
      end
    end
  end

  if (:OPTION_ = 'FOR_RECALC') then begin
    /*for recalculation is needed all reservations that are connected somehow with this and relaetd to this reservations */
    execute procedure RES_GET_SHARE_ALL_RELATIONS$INT (:ID_RESERV_DETAIL)
    returning_values  :related_reservations;
    /*remove current reservation from list (recursion include curent also)*/
    for
      select SP.ITEM
      from   SYSTEM_STRING_PARSER(:related_reservations, ',') SP
      into   :shared_reservation_id
    do begin
      if (:shared_reservation_id <> :id_reserv_detail) then begin
        shared_reservations = :shared_reservations || iif(:shared_reservations = '', '', ',');
        shared_reservations = :shared_reservations || :shared_reservation_id;
      end
    end
  end

  suspend;
end
^

/* Alter (RES_GUEST_FINALIZE$RSV) */
ALTER PROCEDURE RES_GUEST_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER,
ALL_ERRORS_ARE_INSTANT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, iif (:all_errors_are_instant = 1, 0, 1))
  returning_values  :warn_code;

end
^

/* Alter (RES_GUESTLIST_REMOVE$RSV) */
ALTER PROCEDURE RES_GUESTLIST_REMOVE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable g_dbkey char(8);
  declare variable rd_dbkey char(8);
begin
  /*  Description:
  ||
  */

  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  for
    select G.RDB$DB_KEY
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :g_dbkey
  do begin
    execute procedure RES_GUEST_AUTO$INT(:g_dbkey, :rd_dbkey, 0);
  end

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
  returning_values  :WARN_CODE;

end
^

/* empty dependent procedure body */
/* Clear: RES_ROOM_REMOVE$RSV for: RES_ROOM_REMOVE$INT */
ALTER PROCEDURE RES_ROOM_REMOVE$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESERVS_EXPIRE$INT for: RES_ROOM_REMOVE$INT */
ALTER PROCEDURE RESERVS_EXPIRE$INT(CLEAR_TODATE DATE,
ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_ROOM_REMOVE$INT) */
ALTER PROCEDURE RES_ROOM_REMOVE$INT(RD_DBKEY CHAR(8))
 RETURNS(WARN_CODE INTEGER)
 AS
begin

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, gen_id(DETAIL_WITHOUT_ROOMING_LIST, -1), null, 'nrttAsIs')
  returning_values (:WARN_CODE);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 0)
  returning_values  :WARN_CODE;

end
^

/* Alter (RES_ROOM_REMOVE$RSV) */
ALTER PROCEDURE RES_ROOM_REMOVE$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable tmp_warn_code integer;
begin

  warn_code = null;

  for
    select RD.RDB$DB_KEY
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
           and RD.IS_ANUL = 0
    into   :rd_dbkey
  do begin
    execute procedure RES_ROOM_REMOVE$INT (:rd_dbkey)
    returning_values (:tmp_warn_code);
    WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
  end

end
^

/* Alter (RES_SAVE_ACCOUNTING$RSV) */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$RSV(ID_RESERV_DETAIL INTEGER,
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER,
ID_CREDIT_CARD INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);


begin
  /* Description : ACC_ROUTING = {GUEST, AGENT, MIXED, OWNER,  }
  ||
  */
  select rd.RDB$DB_KEY
  from   RESERV_DETAIL rd
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SAVE_ACCOUNTING$INT(:rd_dbkey, :id_agent_profile, :id_agent_account, :acc_routing,
                    :id_person_payment, :id_agent_payment, :id_group);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
  returning_values  :warn_code;

  --
end
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_CHANGE$RSV for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTING$INT for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SAVE_ACCOUNTS$INT) */
ALTER PROCEDURE RES_SAVE_ACCOUNTS$INT(RD_DBKEY CHAR(8))
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_base_account integer;
  declare variable old_id_extra_account integer;
  declare variable new_id_base_account integer;
  declare variable new_id_extra_account integer;
  declare variable acc_routing varchar(30);
  declare variable is_sep_accounts integer;
  declare variable id_base_account_profile integer;
  declare variable id_extra_account_profile integer;
  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable id_agent_account_rule integer;
  declare variable id_acc_template_person integer;
  declare variable id_guest integer;
  declare variable id_hotel integer;
begin

  select RD.ID_RESERV_DETAIL, RD.ID_PERSON_PROFILE, RD.ID_ACC_TEMPLATE_PERSON,
         RD.ACC_ROUTING, RD.ID_BASE_ACCOUNT, RD.ID_EXTRA_ACCOUNT,
         RD.ID_AGENT_PROFILE, RD.ID_AGENT_ACCOUNT_RULE, rd.id_hotel
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :RD_DBKEY
  into   :id_reserv_detail, :id_person_profile, :id_acc_template_person,
         :acc_routing, :old_id_base_account, :old_id_extra_account,
         :id_agent_profile, :id_agent_account_rule, :id_hotel;

  id_agent_account_rule = nullif(:id_agent_account_rule, -1);
  /* --- new */
  execute procedure SETTING_GET_VALUE ('SEPARATE_ACCOUNTS_PER_PAYER', :id_hotel)
  returning_values (:IS_SEP_ACCOUNTS);

  NEW_ID_BASE_ACCOUNT = null; --:old_id_base_account;
  NEW_ID_EXTRA_ACCOUNT = null; --:old_id_extra_account;

  /* identify profiles for base and extra account */
  if (:ACC_ROUTING in ('MIXED')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else if (:ACC_ROUTING in ('AGENT')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
  end else if (:ACC_ROUTING in ('FULL_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = null;
    IS_SEP_ACCOUNTS = 0;  -- never
  end else if (:ACC_ROUTING in ('PART_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else begin -- if (:acc_routing in ('GUEST', 'OWNER'))
    ID_BASE_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_AGENT_ACCOUNT_RULE = null;
  end

  execute procedure RES_ACCOUNTS_RECIEVE$INT (:ID_RESERV_DETAIL, :old_id_base_account, :old_id_extra_account,
          :id_agent_account_rule, :id_base_account_profile, :id_extra_account_profile, :id_person_profile,
          :id_acc_template_person, :is_sep_accounts)
  returning_values (:new_id_base_account, :new_id_extra_account);

--  if (:new_id_base_account is null) then exception WRONG_VALUE 'Invalid base account!';
--  if (:new_id_extra_account is null) then exception WRONG_VALUE 'Invalid extra account!';
  if ((:old_id_base_account is distinct from :new_id_base_account)
       or (:old_id_extra_account is distinct from :new_id_extra_account)) then
  begin
    update RESERV_DETAIL RD
    set    RD.ID_BASE_ACCOUNT = :new_id_base_account,
           RD.ID_EXTRA_ACCOUNT = :new_id_extra_account
    where  RD.RDB$DB_KEY = :RD_DBKEY;
    /* end --- */
    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
             --and G.CHECK_STATUS < 1
      into   :id_guest
    do begin
      execute procedure GUEST_REROUTE_POSTINGS$INT(:id_guest, :new_id_base_account, :new_id_extra_account);
    end

    -- Log account changes
    execute procedure RES_SAVE_ACCOUNTS_FINALIZE$INT(:id_reserv_detail, :old_id_base_account, :old_id_extra_account,
            :new_id_base_account, :new_id_extra_account);
  end

end
^

/* Alter (RES_SAVE_GUARANTEE$RSV) */
ALTER PROCEDURE RES_SAVE_GUARANTEE$RSV(ID_RESERV_DETAIL INTEGER,
IS_VIP SMALLINT,
CHECK_STATUS INTEGER,
ID_GUARANTEE_POLICY INTEGER,
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER)
 AS
declare variable old_check_status integer;
declare variable warn_code integer;
declare variable rd_dbkey char(8);
declare variable action_text varchar(255);
begin
  /*  Description:
  ||  GUI facade
  */
  select RD.RDB$DB_KEY, rd.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_check_status;

  update RESERV_DETAIL RDU
  set    RDU.IS_VIP = coalesce(:is_vip, RDU.IS_VIP),
         RDU.ID_GUARANTEE_POLICY = :id_guarantee_policy,
         RDU.GUARANTEE_DEPOSIT = :guarantee_deposit,
         RDU.GUARANTEE_CURRENCY = :guarantee_currency,
         RDU.BLOCK_CC = :BLOCK_CC,
         GUARANTEE_DEPOSIT_PERCENT = :GUARANTEE_DEPOSIT_PERCENT,
         GUARANTEE_DEPOSIT_NIGHTS = :GUARANTEE_DEPOSIT_NIGHTS,
         GUARANTEE_DUE_DAYS_BEF_ARRIVAL = :GUARANTEE_DUE_DAYS_BEF_ARRIVAL,
         GUARANTEE_DUE_DAYS_AFTER_CREATE = :GUARANTEE_DUE_DAYS_AFTER_CREATE
  where  RDU.RDB$DB_KEY = :rd_dbkey;

  action_text = '';
  if (:GUARANTEE_DEPOSIT_PERCENT is not null) then begin
    action_text = f_character(29) || '@{caption.guaranteetype.percent} ' || formatfloat(:GUARANTEE_DEPOSIT_PERCENT, '0.00') || f_character(28)
                  || '[' || coalesce(:GUARANTEE_DUE_DAYS_AFTER_CREATE, ' ') || ']'
                  || f_character(28) || '[' || coalesce(:GUARANTEE_DUE_DAYS_BEF_ARRIVAL, ' ') || ']';
  end
  else if (:GUARANTEE_DEPOSIT_NIGHTS is not null) then begin
    action_text = f_character(29) || '@{caption.guaranteetype.nights} ' || :GUARANTEE_DEPOSIT_NIGHTS || f_character(28)
                  || '[' || coalesce(:GUARANTEE_DUE_DAYS_AFTER_CREATE, ' ') || ']'
                  || f_character(28) || '[' || coalesce(:GUARANTEE_DUE_DAYS_BEF_ARRIVAL, ' ') || ']';
  end
  else if (:GUARANTEE_DEPOSIT is not null) then begin
    action_text = f_character(29) || '@{caption.guaranteetype.fixed} ' || formatfloat(:GUARANTEE_DEPOSIT, '0.00') || ' ' || :GUARANTEE_CURRENCY || f_character(28)
                  || '[' || coalesce(:GUARANTEE_DUE_DAYS_AFTER_CREATE, ' ') || ']'
                  || f_character(28) || '[' || coalesce(:GUARANTEE_DUE_DAYS_BEF_ARRIVAL, ' ') || ']';
  end

  if (:action_text <> '') then begin
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_GUARANTEE_CHANGED', :action_text);
  end

  CHECK_STATUS = coalesce(:CHECK_STATUS, :old_check_status);
  if (:CHECK_STATUS <> :old_check_status) then begin

    if (:CHECK_STATUS >= 0) then exception BOOKING_EXCEPTION 'Can not set status ''CHECKED IN'' or ''CHECKED OUT'' manually!';

    execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, :check_status);

    execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
    returning_values  :warn_code;
  end
end
^

/* Alter (RES_SAVE_GUESTCOUNT$RSV) */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select rd.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  rd.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SAVE_GUESTCOUNT$INT(:rd_dbkey, :adult_count, :child_count);

  execute procedure RES_SAVE_ACCOUNTS$INT (:rd_dbkey);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 0)
  returning_values  :warn_code;

end
^

/* Alter (RES_SAVE_RATE$RSV) */
ALTER PROCEDURE RES_SAVE_RATE$RSV(ID_RESERV_DETAIL INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
IS_DIFFERENT_TARIFF INTEGER,
IS_DIFFERENT_PRICE INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 AS
declare variable rd_dbkey char(8);
  declare variable old_price numeric(14,4);
  declare variable old_price_currency char(3);
  declare variable action_text varchar(255);
  declare variable err_code integer;
  declare variable err_text varchar(255) ;
begin

  select RD.RDB$DB_KEY, RD.custom_price, rd.custom_currency
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_price, :old_price_currency;

  if (:is_different_tariff = 0) then begin
    execute procedure RES_SAVE_RATE$INT(:rd_dbkey, :id_tariff);
  end else begin
    execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey);
  end

  if (:IS_DIFFERENT_PRICE = 0) then begin
    delete from RESERV_CUSTOM_PRICE
    where  ID_RESERV_DETAIL  = :ID_RESERV_DETAIL;

    update RESERV_DETAIL RD
    set    RD.CUSTOM_PRICE = :custom_price,
           RD.CUSTOM_CURRENCY = :custom_currency
    where  RD.RDB$DB_KEY = :rd_dbkey;
  end else begin
    update RESERV_DETAIL RD
    set    RD.CUSTOM_PRICE = null,
           RD.CUSTOM_CURRENCY = null
    where  RD.RDB$DB_KEY = :rd_dbkey;
  end


  /*Maintain the flag in RD - HAS_DIFFERENT_PRICE*/
  if (exists (select * from RESERV_CUSTOM_PRICE rmp where rmp.id_reserv_detail = :id_reserv_detail)) then
    update RESERV_DETAIL set has_different_price = 1 where id_reserv_detail = :id_reserv_detail;
  else
    update RESERV_DETAIL set has_different_price = 0 where id_reserv_detail = :id_reserv_detail;

  /*Log modifications in custom price if here is diferent values*/
  if ((:old_price is distinct from :custom_price) or (:old_price_currency is distinct from :custom_currency) ) then begin
    action_text = f_character(29) || coalesce(:custom_price, 0) || '' || :custom_currency || f_character(28);
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_MANUAL_PRICE', :action_text);
  end

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    returning_values  :err_code, :err_text;
    if (:err_code < 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end
end
^

/* Alter (RES_SAVE_ROOM$EXC) */
ALTER PROCEDURE RES_SAVE_ROOM$EXC(RD_DBKEY CHAR(8),
ID_RES_ROOM_TYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(250),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_room integer;
begin
  select RD.ID_ROOM, RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_room, :id_reserv_detail;

  execute procedure RES_SAVE_ROOM$RSV(
    :id_reserv_detail,
    :old_id_room,
    :id_res_room_type,
    'nrttAsIs',
    1,
    :id_hk_plan,
    :room_features,
    :i_special_treatment,
    :split_on_checkin,
    0
  ) returning_values :share_err_code, :err_text, :share_transaction_id, :warn_code;
end
^

/* Alter (RESERVS_EXPIRE$INT) */
ALTER PROCEDURE RESERVS_EXPIRE$INT(CLEAR_TODATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable day_keep_number integer;
  declare variable rd_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable nouse integer;
  declare variable day_keep_types integer;
begin
  /*AA NA IONEA I?AAE I?EEE??AAIA -BF END WORK-*/
  execute procedure SETTING_GET_VALUE('DAY_KEEP_NUMBERS', :ID_HOTEL)
  returning_values  :day_keep_number;
  /*************************************************************/
  /*    REMOVE ROOM NUMBERS FROM EXPIRED RESERV DETAILS        */
  /*************************************************************/
  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.IS_ANUL = 0
           and RD.CHECK_STATUS < 0
           and RD.IS_VIP = 0
           and RD.ID_ROOM > 0
           and (RD.FROM_DATE <=  cast(:clear_todate - :day_keep_number as date))
    into   :rd_dbkey, :id_reserv_detail
  do begin
    execute procedure RES_ROOM_REMOVE$INT(:rd_dbkey)
    returning_values  :nouse;

    when any do begin
      -- nothing
    end
  end
  /*************************************************************/
  /*    EXPIRED NON VIP or VIP TYPES                           */
  /*************************************************************/
  execute procedure SETTING_GET_VALUE('DAY_KEEP_TYPES', :ID_HOTEL)
  returning_values  :day_keep_types;

  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.CHECK_STATUS < 0
           and RD.IS_ANUL = 0
           --and RD.EXP_DATE <= :clear_todate
           and RD.FROM_DATE <= cast(:clear_todate - :day_keep_types as date)
           and RD.IS_VIP = 0
    union
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.CHECK_STATUS < 0
           and RD.IS_ANUL = 0
           and RD.TO_DATE < :clear_todate
           and RD.IS_VIP = 1
    into   :rd_dbkey, :id_reserv_detail
  do begin
    execute procedure sys_dbg('res RESERVS_EXPIRE: id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

    execute procedure RES_ANUL_NOSHOW$INT(:rd_dbkey)
    returning_values  :nouse;

    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_NOSHOW', '');

    when any do begin
      -- nothing
    end
  end
end
^

/* Alter (ROOM_SMART_LIST$RSV) */
ALTER PROCEDURE ROOM_SMART_LIST$RSV(FROM_DATE DATE,
TO_DATE DATE,
REPORT_TYPE VARCHAR(50))
 RETURNS(ROOM_NAME VARCHAR(50),
FREE_BEDS_BASE INTEGER,
FREE_BEDS_EXTRA INTEGER,
TYPE_ROOM VARCHAR(20),
ID_ROOM INTEGER,
FLOOR INTEGER,
ATENTION INTEGER,
FEATURES BLOB,
BUSY_GROUP_TYPE INTEGER,
IS_CLEAN INTEGER,
CLEAN_TEXT VARCHAR(20),
DATA1 VARCHAR(255),
DATA2 VARCHAR(255))
 AS
declare variable report_leaving varchar(20);
declare variable suppress_private integer;
begin
  if (:from_date >= :to_date) then exit;
  execute procedure SYSTEM_CHECK_OPERATION(:report_type, 'FREE_ONLY,FREE_AND_LEAVING,BLOCKED,POTENTIAL_SHARE,PRIVATE_USE,ALL');

  suppress_private = iif(:REPORT_TYPE = 'ALL', 0, 1);
  if (:report_type in ('FREE_ONLY','FREE_AND_LEAVING')) then begin
    if (:report_type = 'FREE_AND_LEAVING') then report_leaving = 'AS_FREE';
    else report_leaving = 'AS_LEAVING';
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DBEFORE, SRLF.DAFTER, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_FREE$INT(:from_date, :to_date, :report_leaving, :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end else if (:report_type in ('BLOCKED','POTENTIAL_SHARE')) then begin
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DESCRIPTION, SRLF.PERIOD, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_SHARE$INT(:from_date, :to_date, :report_type, :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end else if (:report_type in ('ALL')) then begin
    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DBEFORE, SRLF.DAFTER, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_FREE$INT(:from_date, :to_date, 'FREE_AND_LEAVING', :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;

    for
      select SRLF.ROOM_NAME, SRLF.FREE_BASE, SRLF.FREE_EXTRA, SRLF.IS_CLEAN, SRLF.TYPE_ROOM,
             SRLF.ID_ROOM, SRLF.FLOOR, SRLF.FEATURES, SRLF.DESCRIPTION, SRLF.PERIOD, SRLF.CLEAN_TEXT
      from   ROOM_SMART_LIST_SHARE$INT(:from_date, :to_date, 'POTENTIAL_SHARE', :suppress_private) SRLF
      into   :room_name, :free_beds_base, :free_beds_extra, :is_clean, :type_room,
             :id_room, :floor, :features, :data1, :data2, :clean_text
    do suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: SAFE_CHECK_OUT for: SAFE_OCCUPANCY_MODIFY */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE /* TYPE OF ID */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER,
WARN_CODE /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SAFE_OCCUPANCY_MODIFY) */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE TYPE OF ID,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable old_booking_number tres_number;
  declare variable id_resource_reservation id_ref;
  declare variable from_datetime tdatetime;
  declare variable action_text tdescription_long;
  declare variable old_occupant varchar(100);
  declare variable old_to_dt timestamp;
  declare variable id_reserv_detail integer;
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation;

  select rr.BOOKING_NUMBER, od.FROM_DATETIME,
         RR.OCCUPANT_NAME, od.TO_DATETIME, rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESERV_DETAIL rd on rd.NUMBER = rr.BOOKING_NUMBER and rd.IS_ANUL = 0
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :old_booking_number, :from_datetime,
         :old_occupant, :old_to_dt, :id_reserv_detail, :id_agent_profile;

  --if (:old_booking_number <> :BOOKING_NUMBER) then exception ASSERT 'Can not change booking number!';
  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  update SAFE_RESOURCE_RESERV rr
  set    rr.PRICE_DESCRIPTION = :price_description,
         rr.ID_RATE_PRICE_PROFILE = :id_agent_profile,
         rr.RATING_UNITS = :rating_units,
         rr.RATE_PRICE = :price,
         rr.RATE_CURR = :currency
  where  rr.ID_RESOURCE_RESERV = :id_resource_reservation;

  execute procedure RESOURCE_RESERVATION_MODIFY (:id_resource_reservation, :ID_SAFE, :from_datetime,
          :TO_DATETIME, :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :old_booking_number, 'mod')
  returning_values :id_resource_reservation, :no_use;

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail)
  returning_values (:DOC_SELECTED);

  /* Log changes */
  if ((:old_occupant <> :OCCUPANT_NAME) or (:old_to_dt <> :TO_DATETIME)) then begin
    action_text = f_character(29) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                  || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                  || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');
  
    execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_CHANGED', :action_text);
  end
end
^

/* Alter (SAFE_OCCUPANCY_NEW) */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE TYPE OF ID,
FROM_DATETIME TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME,
BOOKING_NUMBER TYPE OF TRES_NUMBER,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
ID_RESOURCE_RESERVATION TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable action_text tdescription_long;
  declare variable id_reserv_detail integer;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, s.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  if (:id_resource_reservation is not null) then exception ASSERT '-1064'|| f_character(31) || f_character(29) || :safe_name;

  select rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESERV_DETAIL rd
  where  rd.NUMBER = :BOOKING_NUMBER
         and rd.IS_ANUL = 0
  into   :id_reserv_detail, :id_agent_profile;

  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  execute procedure  RESOURCE_RESERVATION_MODIFY (null, :ID_SAFE, :FROM_DATETIME, :TO_DATETIME,
          :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :BOOKING_NUMBER, 'add')
  returning_values (:id_resource_reservation, :no_use) ;

  insert into SAFE_RESOURCE_RESERV (ID_RESOURCE_RESERV, PRICE_DESCRIPTION, ID_RATE_PRICE_PROFILE,
         RATING_UNITS, RATE_PRICE, RATE_CURR)
  values (:id_resource_reservation, :price_description, :id_agent_profile,
         :rating_units, :price, :currency);

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail, :ID_EXTERNAL_CLIENT_ACCCOUNT)
  returning_values (:DOC_SELECTED);

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = 'CHECKED_IN'
  where  RR.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = :id_resource_reservation
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                || f_character(28) || coalesce(:BOOKING_NUMBER, '')
                || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUPIED', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: TAR_TEST$TAR for: TAR_CALC_EVAL_ALL$INT */
ALTER PROCEDURE TAR_TEST$TAR(NUMBER VARCHAR(62),
ID_TAR_HEAD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_EVAL_ALL$INT) */
ALTER PROCEDURE TAR_CALC_EVAL_ALL$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable room_status varchar(20);
  declare variable from_date date;
  declare variable to_date date;
  declare variable idate date;
  declare variable is_static integer;
  declare variable id_tar_input integer;
  declare variable id_type_stay integer;
  declare variable separate_board integer;
  declare variable id_board_include integer;
  declare variable id_tar_head integer;
  declare variable is_manual_type_stay smallint;
  declare variable seasson_name varchar(50);
begin
  err_code = 0;

  delete from TAR_CALC_OUTPUT$TMP TCO where TCO.ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP TCV where TCV.ID_TAR_CALC = :id_tar_calc;

  execute procedure TAR_CALC_INIT_VARS$INT(:id_tar_calc);

  for
    select TCI.ROOM_STATUS, min(TCI.FROM_DATE_CALC), max(TCI.TO_DATE_CALC), min(TCI.IS_STATIC)
    from   TAR_CALC_INPUT$TMP TCI
    where  TCI.ID_TAR_CALC = :id_tar_calc
    group by TCI.ROOM_STATUS
    into   :room_status, :from_date, :to_date, :is_static
  do begin
    for
      select RLP.OUT_DATE
      from   SYSTEM_LOOP_PERIOD(:from_date, :to_date) RLP
      into   :idate
    do begin
      if ((:is_static = 1) and (:idate > :from_date)) then begin
        insert into TAR_CALC_OUTPUT$TMP (ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
               FOR_DATE, PRICE, CURRENCY, PRICE_TARIFF, CURRENCY_TARIFF, PRICE_NOTE, QTY_POST,
               PTEXT, DISC_TAG, ID_DISCOUNT_SERVICE, REQUIRED_ID_PACKET_ITEM)
        select tco.ID_TAR_INPUT, tco.ID_TAR_CALC, tco.ID_SERVICE, tco.SERVICE_TYPE,
               :idate, PRICE, tco.CURRENCY, tco.PRICE_TARIFF, tco.CURRENCY_TARIFF, tco.PRICE_NOTE, tco.QTY_POST,
               tco.PTEXT, tco.DISC_TAG, tco.ID_DISCOUNT_SERVICE, tco.REQUIRED_ID_PACKET_ITEM
        from   TAR_CALC_OUTPUT$TMP TCO
        where  TCO.FOR_DATE = :from_date
               and TCO.ID_TAR_CALC = :id_tar_calc;
        for
          select TCID.ID_TAR_INPUT, TCID.ID_TYPE_STAY, TCID.SEPARATE_BOARD, TCID.ID_BOARD_INCLUDE,
                 TCID.IS_MANUAL_TYPE_STAY, TCID.ID_TAR_HEAD
          from   TAR_CALC_INPUT_DETAIL$TMP TCID
                 join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
          where  TCID.FOR_DATE = :from_date
                 and TCI.ID_TAR_CALC = :id_tar_calc
          into   :id_tar_input, :id_type_stay, :separate_board, :id_board_include,
                 :is_manual_type_stay, :id_tar_head
        do begin
          seasson_name = null;
          select tp.SEASON_NAME
          from   TARIFA_GET_PERIOD_FOR_DATE (:id_tar_head, :idate) tp
          into   :seasson_name;
          if (:seasson_name is null) then begin
            ERR_CODE = -231;
            ERR_TEXT = '';
            exit;
          end

          update TAR_CALC_INPUT_DETAIL$TMP TCID
          set    TCID.ID_TYPE_STAY = :id_type_stay,
                 TCID.IS_MANUAL_TYPE_STAY = :is_manual_type_stay,
                 TCID.SEPARATE_BOARD = :separate_board,
                 TCID.ID_BOARD_INCLUDE = :id_board_include
          where  TCID.ID_TAR_INPUT = :id_tar_input;
        end
      end else begin
        execute procedure TAR_CALC_EVAL_DATE$INT(:id_tar_calc, :room_status, :idate)
        returning_values  :err_code, :err_text;
        if (:err_code < 0) then exit;
      end
    end
  end

  execute procedure TAR_CALC_EVAL_ZERO$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  if (:err_code is null) then begin
    err_code = -230; /*WRONG INPUT PARAMS - MISSING GUESTS*/
    err_text = 'Missing input data for calculation';
    exit;
  end

  execute procedure TAR_CALC_EVAL_PERIOD$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  execute procedure TAR_CALC_CHECK_PACKETS$INT (:ID_TAR_CALC)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_INPUT_RESERV$INT for: TAR_CALC_GET_GUESTS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_RESERV$INT(ID_RESERV_DETAIL INTEGER,
ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
ID_RATE_OVERRULE INTEGER = null)
 AS
 BEGIN EXIT; END
^

/* Alter (TAR_CALC_GET_GUESTS$INT) */
ALTER PROCEDURE TAR_CALC_GET_GUESTS$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_GUEST INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
G_DBKEY CHAR(8),
ID_GUEST_RESERV TYPE OF ID)
 AS
declare variable dbg varchar(2000);
declare variable share_status integer;
declare variable shared_reservations varchar(1024);
declare variable id_shared_detail integer;
declare variable unshared_reservations varchar(1024);
declare variable id_unshared_detail integer;
declare variable incremental_guest_list varchar(2000);
begin
  incremental_guest_list = ','; /*using for not suspend dublicated guests - otherwise calculations are wrong*/
  for
    select G.ID_GUEST, G.FROM_DATE, G.TO_DATE, G.RDB$DB_KEY, rd.ID_RESERV_DETAIL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  Rd.ID_RESERV_DETAIL = :id_reserv_detail
           and rd.IS_ANUL = 0
    into   :ID_GUEST, :FROM_DATE, :TO_DATE, :G_DBKEY, :ID_GUEST_RESERV
  do begin
    suspend;
    incremental_guest_list = :incremental_guest_list || :id_guest ||',';
  end

/*  execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'ENUM_SHARES', null)*/
  execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'FOR_RECALC', null)
  returning_values  :share_status, :shared_reservations, :dbg;
  execute procedure sys_dbg('calc TAR_CALC_GET_GUESTS$INT shared_reservations = '||coalesce(:shared_reservations, 'null'));

  if (:share_status = 1) then begin
    for
      select SP.ITEM
      from   SYSTEM_STRING_PARSER(:shared_reservations, ',') SP
      into   :id_shared_detail
    do begin
      for
        select G.ID_GUEST, G.FROM_DATE, G.TO_DATE, G.RDB$DB_KEY, G.ID_RESERV_DETAIL
        from   GUEST G
        where  G.ID_RESERV_DETAIL = :id_shared_detail
        into   :ID_GUEST, :FROM_DATE, :TO_DATE, :G_DBKEY, :ID_GUEST_RESERV
      do begin
        if (:incremental_guest_list not containing ','||:id_guest||',' ) then begin
          suspend;
          incremental_guest_list = :incremental_guest_list || :id_guest ||',';
        end
      end
    end
  end

  execute procedure RES_GET_SHARE_STATUS$INT(:id_reserv_detail, 'ENUM_EX_SHARES', null)
  returning_values  :share_status, :unshared_reservations, :dbg;

  execute procedure sys_dbg('calc TAR_CALC_GET_GUESTS$INT unshared_reservations = '||coalesce(:unshared_reservations, 'null'));
  execute procedure sys_dbg('calc TAR_CALC_GET_GUESTS$INT incremental_guest_list = '||coalesce(:incremental_guest_list, 'null'));

  if (:unshared_reservations <> '') then begin
    for
      select SP.ITEM
      from   SYSTEM_STRING_PARSER(:unshared_reservations, ',') SP
      into   :id_unshared_detail
    do begin
      for
        select G.ID_GUEST, G.FROM_DATE, G.TO_DATE, G.RDB$DB_KEY, g.ID_RESERV_DETAIL
        from   GUEST G
        where  G.ID_RESERV_DETAIL = :id_unshared_detail
        into   :ID_GUEST, :FROM_DATE, :TO_DATE, :G_DBKEY, :ID_GUEST_RESERV
      do begin
        if (:incremental_guest_list not containing ','||:id_guest||',' ) then begin
          suspend;
          incremental_guest_list = :incremental_guest_list || :id_guest ||',';
        end
        execute procedure sys_dbg('calc TAR_CALC_GET_GUESTS$INT incremental_guest_list2 = '||coalesce(:incremental_guest_list, 'null'));
      end
    end
  end
end
^

/* Alter (TAR_CALC_INPUT_RESERV$INT) */
ALTER PROCEDURE TAR_CALC_INPUT_RESERV$INT(ID_RESERV_DETAIL INTEGER,
ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
ID_RATE_OVERRULE INTEGER = null)
 AS
declare variable id_guest integer;
  declare variable g_dbkey char(8);
  declare variable from_date date;
  declare variable to_date  date;
  declare variable id_tariff_calc integer;
  declare variable err_code integer;
  declare variable err_text varchar(25);
  declare variable id_guest_reserv integer;
begin
  for
    select G.ID_GUEST, G.FROM_DATE, G.TO_DATE, G.G_DBKEY, g.ID_GUEST_RESERV
    from   TAR_CALC_GET_GUESTS$INT(:id_reserv_detail) G
    into   :id_guest, :from_date, :to_date, :g_dbkey, :id_guest_reserv
  do begin
    execute procedure sys_dbg('calc RES_RECALC$INT input guest_id '|| :id_guest || ', from:' || :from_date || ', to:' ||  :to_date);

    id_tariff_calc = null;
    if (:id_guest_reserv = :ID_RESERV_DETAIL and :ID_RATE_OVERRULE is not null) then id_tariff_calc = :ID_RATE_OVERRULE;
    -- skip ID_RATE_OVERRULE for shared bookings
    execute procedure TAR_CALC_INPUT_GUEST$INT(:id_tar_calc, :room_status, :g_dbkey, :id_tariff_calc, 1);
  end

  -- RECALCULATING DEPENDING ON THE TARIFF KIND
  execute procedure TAR_CALC_INPUT_DETAILS$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exception RATING_PREPARE_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_INPUT_PARAMS$INT for: TAR_CALC_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_PARAMS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_PARAMS$INT) */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
declare variable param_code varchar(40);
  declare variable id_param integer;
  declare variable param_value varchar(255);
  declare variable data_type  varchar(30);
  declare variable rate_list varchar(2000);
begin
  err_code = 0;
  param_values = '';

  if (coalesce(:rate_list_replace, '') = '') then rate_list = ',' || :id_rate || ',';
  else rate_list = :rate_list_replace;

  for
    select distinct TBP.PARAM_NAME
    from   SYSTEM_STRING_PARSER (:rate_list, ',') sp
           left join TAR_BO_PARAMS TBP on TBP.ID_TAR_HEAD = sp.ITEM
    where  (TBP.PARAM_TYPE <> 'DATE_DEPENDANT' and :for_date is null)
           or (TBP.PARAM_TYPE = 'DATE_DEPENDANT' and :for_date is not null)
    into   :param_code
  do begin
    if (:param_code is not null) then begin
      id_param = null;
      select TP.ID_TARIFA_PARAM, TP.DATA_TYPE
      from   TARIFA_PARAMS TP
      where  TP.PARAM_CODE = :param_code
             and tp.IS_USE = 1
      into   :id_param, :data_type;
  
      if (:id_param is null) then begin
        err_code = -202;
        execute procedure sys_dbg ('tar calc params err_code: ' || :err_code || F_CRLF() || 'PARAM_CODE = ' || :param_code);
        exit;
      end
  
      execute procedure TARIFA_GET_PARAM (:id_param, :for_date, :id_tar_input, :id_tar_calc)
      returning_values (:param_value);
  
      param_code = ':'||param_code;
  
      if ((:param_code is not null) and (:param_code is not null) and (:data_type is not null)) then
         param_values = :param_values||';'||:param_code||','||:data_type||','||:param_value;
    end
  end
end
^

/* Alter (TAR_CALC_POST_PREPARE$INT) */
ALTER PROCEDURE TAR_CALC_POST_PREPARE$INT(ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
  declare variable id_service integer;
  declare variable id_tariff integer;
  declare variable date_post date;
  declare variable qty_post integer;
  declare variable price_orig numeric(15,4);
  declare variable round_to numeric(15,4);
  declare variable curr_orig char(3);
  declare variable id_room integer;
  declare variable short_code varchar(255);
  declare variable id_reserv integer;
begin

  delete
  from   TAR_CALC_POST$TMP TCP
  where  TCP.ID_TAR_CALC = :id_tar_calc;

/* Find all Discounts with services : Move ID_DISCOUNT_SERVICE to ID_SERVICE; Change them to PACKETS - in order to receive separate postings */
  update  TAR_CALC_OUTPUT$TMP TCO
  set     tco.service_type = 'PACKETS',
          tco.id_service = tco.id_discount_service
  where   TCO.id_tar_calc = :id_tar_calc
          and tco.price_note = 'DISC'
          and tco.id_discount_service > 0;
    
  for
    select TOB.ID_GUEST, TOB.ID_RESERV, TOB.ID_SERVICE, TOB.ID_TARIFF, TOB.DATE_POST, TOB.QTY_POST,
           round_f(TOB.PRICE_ORIG, c.ROUND_TO), TOB.CURR_ORIG, TOB.ID_ROOM, TOB.SHORT_CODE, c.ROUND_TO
    from   TAR_OUTPUT_BASE(:id_tar_calc) TOB
           left outer join CURRS c on c.CURR = tob.CURR_ORIG
    into   :id_guest, :id_reserv, :id_service, :id_tariff, :date_post, :qty_post,
           :price_orig, :curr_orig, :id_room, :short_code, :round_to
  do begin
    insert into TAR_CALC_POST$TMP(ID_GUEST, ID_RESERV, ID_SERVICE, ID_TARIFF, DATE_POST, QTY_POST,
           PRICE_ORIG, CURR_ORIG, ID_ROOM, IS_BASE, ID_TAR_CALC, SHORT_CODE)
    values(:id_guest, :id_reserv, :id_service, :id_tariff, :date_post, :qty_post,
           :price_orig, :curr_orig, :id_room, 1, :id_tar_calc, :short_code);

    for
        select   TCO.ID_SERVICE, TCO.PRICE_NOTE,
                 max(TCO.QTY_POST), round_f(sum(TCO.PRICE_TARIFF), :round_to)
        from     TAR_CALC_OUTPUT$TMP TCO
                 join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCO.ID_TAR_INPUT
                 left outer join SERVICES S on S.ID_SERVICE = TCO.ID_SERVICE
        where    TCO.ID_TAR_CALC = :id_tar_calc
                 and TCO.SERVICE_TYPE = 'PACKETS'
                 and TCI.ID_GUEST = :id_guest
                 and TCO.FOR_DATE = :date_post
        group by TCO.ID_SERVICE, TCO.PRICE_NOTE
        into     :id_service, :short_code, :qty_post, :price_orig
    do begin
      insert into TAR_CALC_POST$TMP(ID_GUEST, ID_RESERV, ID_SERVICE, ID_TARIFF, DATE_POST,
             QTY_POST, PRICE_ORIG, CURR_ORIG, ID_ROOM, IS_BASE, ID_TAR_CALC, SHORT_CODE)
      values(:id_guest, :id_reserv, :id_service, :id_tariff, :date_post, :qty_post,
             :price_orig, :curr_orig, :id_room, 0, :id_tar_calc, :short_code);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_RATE_RECORD_RELINK$EXC for: TAR_SAVE */
ALTER PROCEDURE IMPORT_RATE_RECORD_RELINK$EXC(ID_RATE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_SAVE) */
ALTER PROCEDURE TAR_SAVE(ID_TAR_HEAD INTEGER,
PERIOD_DEPEND_ON_CHECKIN INTEGER,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BASE_BOARDS_LIST VARCHAR(255),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
BO_TYPE VARCHAR(20),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable delim integer;
  declare variable id_hotel integer;
  declare variable action_text varchar(255);
begin
  if (:base_boards_list is null) then base_boards_list = '';
  if (:board_type not in ('BOARD', 'HRANI')) then begin
    if (:board_type = '0') then board_type = 'BOARD';
    else board_type = 'HRANI';
  end
  err_code = 0;
  err_text = '';
  execute procedure SETTING_GET_VALUE('RANGE_DATA_DELIMETER', null)
  returning_values  :delim;

  -- TAR_BO_PRICES are never cleared
  delete from TAR_BO_SEASON
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_BASE_POSITION
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_BOARD
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_EXTRA_GUEST
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_DISCOUNT
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_PACK
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_PARAMS
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_DISCOUNT_STAY
  where  ID_TAR_HEAD = :id_tar_head;
  update TAR_HEAD TH
  set    PERIOD_DEPEND_ON_CHECKIN = :period_depend_on_checkin,
         CNT_DAYS_PRICE_BP        = :cnt_days_price_bp,
         CNT_DAYS_PRICE_BOARD     = :cnt_days_price_board,
         BASE_BOARDS_LIST         = coalesce(f_character(:delim)|| (select list(p.item, f_character(:delim)) from SYSTEM_STRING_PARSER(:base_boards_list, f_character(:delim)) p) || f_character(:delim), ''),
         BOARD_TYPE               = :board_type,
         LOCK_STAMP               = current_timestamp
  where  TH.ID_TAR_HEAD = :id_tar_head;
  update TARIFA T
  set    T.IS_BASE = 1
  where  T.ID_TARIFA = :id_tar_head;
  bo_type = 'SEASON';
  execute procedure TAR_SAVE_BO_SEASON(:id_tar_head)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'BASE';
  execute procedure TAR_SAVE_BO_BP(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'BOARD';
  execute procedure TAR_SAVE_BO_BOARD(:id_tar_head, :bo_type, :board_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'EXTRA_GUEST';
  execute procedure TAR_SAVE_BO_EG(:id_tar_head, :bo_type, :board_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'PACK';
  execute procedure TAR_SAVE_BO_PACK(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'DISCOUNT';
  execute procedure TAR_SAVE_BO_DISC(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'DISCOUNT_PERIOD';
  execute procedure TAR_SAVE_BO_DISC_PERIOD(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end

  select f_character(29) || T.TARIFA_NAME, T.id_hotel
  from   TARIFA T
  where  T.ID_TARIFA = :ID_TAR_HEAD
  into   :action_text, :id_hotel;

  execute procedure EXPORT_LOG_INSERT$EXC ('RATE_BASE', :id_tar_head, :id_hotel, 0);

  execute procedure SYSTEM_LOG_ADD ('RATE', :ID_TAR_HEAD, 'RATE_CHANGED', :action_text);

  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||'NONE'||', '||:err_text;
    exception;
  end
end
^

/* Alter (TAR_TEST$TAR) */
ALTER PROCEDURE TAR_TEST$TAR(NUMBER VARCHAR(62),
ID_TAR_HEAD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_reserv_detail integer;
begin
  id_tar_calc = -1 * :id_tar_head;
  delete from TAR_CALC_OUTPUT$TMP where id_tar_calc = :id_tar_calc;
  delete from TAR_CALC_INPUT$TMP  where id_tar_calc = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP  where id_tar_calc = :id_tar_calc;

  err_code = 0;

  id_reserv_detail = null;
  select RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.NUMBER = :number
         and rd.IS_ANUL = 0
  into   :id_reserv_detail;

  if (:id_reserv_detail is null) then begin
    select first 1 RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.NUMBER_2 = :number
           and rd.IS_ANUL = 0
    into   :id_reserv_detail;
  end

  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NEW_ROOM', :ID_TAR_HEAD);

  execute procedure TAR_CALC_EVAL_ALL$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;
end
^

/* Alter (TEST_RATING) */
ALTER PROCEDURE TEST_RATING RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
declare variable from_date date;
 declare variable to_date date;
 declare variable hotels varchar(255);
begin
  from_date = '01.01.2010';
  to_date = '08.01.2010';
  hotels = '2';

  execute procedure AVAILABILITY_OCCUPANCY$INT (:from_date,  :from_date + 30, 1, 0, 1, 1, 0, 0, 0, :hotels);

  execute procedure AVAILABILITY_OCCUPANCY_OPT$INT (0, 0, 1, 1, 0, 0, 0);

  execute procedure AVAILABILITY_RATING$AVL (null, :from_date, :to_date, 2,
          2, 0, '33,31,55,30,32,54,62,59,71,72', '2301,2210,2347,1633,2300,2342,2353,2362', '6,0,8,7,22,21,23', :hotels)
  returning_values (:ID_OCCUPANCY_SESSION);

end
^

/* Restore proc. body: ACCOUNT_POST_MODIFY$PMS */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
declare variable id_account integer;
  declare variable id_service integer;
  declare variable date_post date;
  declare variable is_owner_income smallint;
  declare variable is_account_post_item smallint;
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable no_use_id_acc_post integer;
  declare variable ap_dbkey char(8);
begin
  -- da se wika samo ot GUI
  if ( (:ID_ACCOUNT_POST is null) and (:ID_ACCOUNT_POST_PMS is null) ) then begin
    exception WRONG_PARAM_VALUE;
    exit;
  end

  is_account_post_item = iif(:id_account_post is not null, 1, 0);

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'mod, anul');

  if (:operation in ('mod', 'anul')) then begin
    -- prowerka: ot GUI-to mogat da se anulirat samo nedokumentirani i neanulirani nachisleniq
    if (:is_account_post_item = 1) then begin
      if ( (:ID_PMS_EVENT > 0) and
           not exists ( select *
                        from   PMS_EVENT_POST PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      select ap.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  ap.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
      into   :ap_dbkey;

      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_dbkey, 'PMS GUI VOID');

      update PMS_EVENT_POST PP
      set    PP.LINE_STATUS = 22
      where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST;

    end else if (:ID_ACCOUNT_POST_PMS is not null) then begin
      if ( not exists ( select *
                        from   ACCOUNT_POST$PMS PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      execute procedure ACCOUNT_POST_PMS_ANUL$INT(:ID_PMS_EVENT, :ID_ACCOUNT_POST_PMS);
    end

    if (:operation = 'mod') then begin
      id_account = null;
      if (:is_account_post_item = 1) then begin
        select AP.ID_ACCOUNT, AP.ID_SERVICE, AP.DATE_POST, PP.ID_OWNER, 0, ap.id_room
        from   ACCOUNT_POST AP
               join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and PP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :id_owner, :is_owner_income, :id_room;
      end else begin
        select AP.ID_ACCOUNT_PMS, AP.ID_SERVICE, AP.DATE_POST, AP.IS_OWNER_INCOME, AP.ID_OWNER
        from   ACCOUNT_POST$PMS AP
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
               and AP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :is_owner_income, :id_owner;
      end
      if (:id_account is null) then exit;

      execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_account, :id_service, :id_owner, :date_post,
              :in_curr_orig, :in_value_orig, 1 - :is_account_post_item, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* Restore proc. body: ACCOUNT_POSTING_TRANSFER$ACC */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
declare variable ap_dbkey char(8);
  declare variable transfer_value double precision;
  declare variable post_value double precision;
  declare variable id_account integer;
  declare variable tmp_id_account integer;
  declare variable curr_post varchar(3);
  declare variable acc_name varchar(50);
  declare variable action_text varchar(255);
  declare variable is_pms_account integer;
  declare variable dest_acc_name varchar(50);
begin

  id_account = null;
  transfer_value = 0;

  select ACC.ACCOUNT_NAME, acc.IS_PMS_ACCOUNT
  from   ACCOUNT ACC
  where  ACC.ID_ACCOUNT = :ID_DEST_ACCOUNT
  into   :dest_acc_name, is_pms_account;

  if (:is_pms_account = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('PMS_TRANSFER_POSTINGS');
  end

  for
    select AP.RDB$DB_KEY, AP.ID_ACCOUNT, ap.PRICE_POST * ap.QTY_POST
    from   ACCOUNT_POST AP
    where  AP.DOC_SELECTED = :DOC_SELECTED
           and AP.ID_ACCOUNT = coalesce(:ID_SRC_ACCOUNT, AP.ID_ACCOUNT)
           and AP.ID_ACCOUNT is distinct from :ID_DEST_ACCOUNT
    order by AP.ID_ACCOUNT asc
    into   :ap_dbkey, :tmp_id_account, :post_value
  do begin
    execute procedure ACCOUNT_POSTING_TRANSFER$INT (:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:id_account is null) then id_account = :tmp_id_account;

    /* update from/to pms account */
    execute procedure ACCOUNT_POST_EVENT_REROUTE$INT(:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:tmp_id_account is distinct from :id_account) then begin
      select A.ACCOUNT_NAME, A.ACCOUNT_CURR
      from   ACCOUNT A
      where  A.ID_ACCOUNT = :id_account
      into   :acc_name, :curr_post;

      action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                    f_character(28) || :id_account || '/' || :acc_name ||
                    f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
      execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
      id_account = :tmp_id_account;
      transfer_value = 0;
    end
    transfer_value = :transfer_value + :post_value;
  end

  if (:id_account is not null) then begin
    select A.ACCOUNT_NAME, A.ACCOUNT_CURR
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :acc_name, :curr_post;
  
    action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                  f_character(28) || :id_account || '/' || :acc_name ||
                  f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
  end
end
^

/* Restore proc. body: BLOCK_ANNUL$BLK */
ALTER PROCEDURE BLOCK_ANNUL$BLK(ID_BLOCK_ROOM INTEGER,
OPERATION VARCHAR(30))
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable share_err_text varchar(255);
  declare variable system_date date;
  declare variable cancel_date date;
  declare variable from_date date;
  declare variable b_dbkey char(8);
  declare variable new_id_block_room integer;
  declare variable id_room integer;
  declare variable block_grp integer;
  declare variable reason varchar(50);
  declare variable note varchar(255);
  declare variable action_text varchar(255);
  declare variable room_name varchar(10);
  declare variable id_hotel integer;
  declare variable mark_dirty_expired_block integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION (:operation, 'cancel, annul');

  select BR.FROM_DATE, BR.RDB$DB_KEY, R.ID_HOTEL
  from   BLOCK_ROOM BR
         join ROOMS R on R.ID_ROOM = BR.ID_ROOM
  where  BR.ID_BLOCK_ROOM = :id_block_room
  into   :from_date, :b_dbkey, :id_hotel;

  if (:operation = 'annul') then begin
    update BLOCK_ROOM BR
    set    BR.IS_ANNUL = 1
    where  BR.RDB$DB_KEY = :b_dbkey;
  
    execute procedure BLOCK_MODIFY_CONTROL$INT(:b_dbkey, :from_date);
    execute procedure ROOM_MAGIC_CLEAR(:id_block_room);
    action_text = '';
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :id_block_room, 'ANNUL_BLOCK', :action_text);
  end else begin
    select BR.ID_ROOM, BR.BLOCK_GRP, BR.REASON, BR.NOTE, R.ROOM_NAME
    from   BLOCK_ROOM BR
           join ROOMS R on R.ID_ROOM = BR.ID_ROOM
    where  BR.RDB$DB_KEY = :b_dbkey
    into   :id_room, :block_grp, :reason, :note, :room_name;

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :system_date;
    cancel_date = :system_date - 1;

    execute procedure BLOCK_MODIFY$INT(:id_block_room, :id_room, :from_date, :cancel_date, :block_grp, :reason,
                      :note, 'mod')
    returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :share_err_text, :warn_code;
    --ignore possible entering into share

    execute procedure SETTING_GET_VALUE('MARK_DIRTY_EXPIRED_BLOCK', :id_hotel)
    returning_values  :mark_dirty_expired_block;
    if (:mark_dirty_expired_block = '1') then begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'BLOCK_STOP', 'set_dirty');
    end

    action_text = f_character(29) || :room_name || f_character(28) || formatdate(:cancel_date, 'D;dd.mm.yyyy');
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :new_id_block_room, 'CANCEL_BLOCK', :action_text);
  end
end
^

/* Restore proc. body: BLOCK_CREATE$BLK */
ALTER PROCEDURE BLOCK_CREATE$BLK(ROOM_NAMES TYPE OF TDESCRIPTION_LONG,
ID_HOTEL TYPE OF ID,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
BLOCK_GRP TYPE OF TRANGE,
REASON TYPE OF TREASON,
NOTE TYPE OF TDESCRIPTION_LONG,
IS_FULL_FROM TYPE OF TRANGE,
IS_FULL_TO TYPE OF TRANGE)
 RETURNS(NEW_ID_BLOCK_ROOM TYPE OF ID,
SHARE_TRANSACTION_ID TYPE OF ID,
SHARE_ERR_CODE TYPE OF ID,
ERR_TEXT VARCHAR(255),
WARN_CODE TYPE OF ID,
NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable room_name varchar(50);
  declare variable id_room integer;
  declare variable action_text varchar(255);
  declare variable block_name varchar(30);
begin
  id_room = null;
  warn_code = null;
  SHARE_ERR_CODE = 0;

  for
    select ITEM
    from   SYSTEM_STRING_PARSER(:room_names, ',')
    into   :room_name
  do begin
    id_room = null;
    select R.ID_ROOM
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ROOM_NAME = :room_name
           and RT.ID_HOTEL = :id_hotel
    into   :id_room;

    if (:id_room is null) then exception BLOCK_EXCEPTION '-5' || f_character(31) || :room_name;

    execute procedure BLOCK_MODIFY$INT(null, :id_room, :from_date, :to_date, :block_grp,
                      :reason, :note, 'add')
    returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :err_text, :warn_code;

    block_name = iif(:block_grp = 18, 'OUT OF ORDER', 'OUT OF INVENTORY');
    action_text = f_character(29) || :room_name
                  || f_character(28) || formatdate(:from_date, 'D;dd.mm.yyyy') || '-' || formatdate(:to_date, 'D;dd.mm.yyyy')
                  || f_character(28) || :block_name;
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :new_id_block_room, 'BLOCK_ROOM', :action_text);

  end

  select cast('31.12.1899' as date) + count(b.ID_BLOCK_ROOM)
  from   BLOCK_ROOM b
  where  b.ID_ROOM is not null
  into   :NEW_FROM_DATE;
end
^

/* Restore proc. body: BLOCK_MODIFY$BLK */
ALTER PROCEDURE BLOCK_MODIFY$BLK(ID_BLOCK_ROOM INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
BLOCK_GRP INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
IS_FULL_FROM INTEGER,
IS_FULL_TO INTEGER)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable new_id_block_room integer;
  declare variable action_text varchar(255);
  declare variable old_from_date date;
  declare variable old_to_date date;
  declare variable old_group integer;
  declare variable room_name varchar(10);
  declare variable block_name varchar(30);
begin
  --  IS_FULL_FROM  - deprecated
  --  IS_FULL_TO  - deprecated

  select BR.FROM_DATE, BR.TO_DATE, BR.BLOCK_GRP, R.ROOM_NAME
  from   BLOCK_ROOM BR
         join ROOMS R on R.ID_ROOM = BR.ID_ROOM
  where  BR.ID_BLOCK_ROOM = :ID_BLOCK_ROOM              
  into   :old_from_date, :old_to_date, :old_group, :room_name;

  execute procedure BLOCK_MODIFY$INT(:id_block_room, :id_room, :from_date, :to_date, :block_grp,
                    :reason, :note, 'mod')
  returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :err_text, :warn_code;

  if ( (:old_from_date <> :FROM_DATE) or (:old_to_date <> :TO_DATE) or (:old_group <> :BLOCK_GRP) ) then begin
    block_name = iif(:block_grp = 18, 'OUT OF ORDER', 'OUT OF INVENTORY');
    action_text = f_character(29) || :room_name
                  || f_character(28) || formatdate(:FROM_DATE, 'D;dd.mm.yyyy') || '-' || formatdate(:TO_DATE, 'D;dd.mm.yyyy')
                  || f_character(28) || :block_name;
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :NEW_ID_BLOCK_ROOM, 'EDIT_BLOCK', :action_text);
  end
end
^

/* Restore proc. body: CONTRACT_EXPENSE_POST$INT */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT TYPE OF ID,
ID_HOTEL INTEGER,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
ID_OWNER TYPE OF ID,
OWNERSHIP_PERCENT TYPE OF TPERCENT,
ID_RENTAL_POOL TYPE OF ID_REF,
VALUE_ORIG TYPE OF TPRICE,
CURR_ORIG TYPE OF TCURRENCY,
POST_DATE TYPE OF TDATE,
STAY TYPE OF TCOUNT,
MAX_GUEST_CNT TYPE OF TCOUNT,
BED_NIGHT_CNT TYPE OF TCOUNT,
RESERVS TYPE OF TCOUNT)
 AS
declare variable service_price numeric(15,4);
  declare variable id_currency varchar(3);
  declare variable contract_expense_type varchar(50);
  declare variable id_account integer;
  declare variable post_value numeric(15,4);
  declare variable post_currency varchar(3);
  declare variable id_service integer;
  declare variable is_owner_income smallint;
  declare variable is_client_acc_post smallint;
  declare variable multiplier_type varchar(50);
  declare variable multiplier integer;
  declare variable id_room integer;
  declare variable use_shadow_account integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
begin
  is_owner_income = 0;
  use_shadow_account = iif(:SUB_CONTRACT = 'SHADOW_ACC', 1, 0);

  select r.ID_HOTEL
  from   PMS_EVENT$PMS p
         join ROOMS R on r.ID_ROOM = p.ID_ROOM
  where  p.ID_PMS_EVENT = :ID_PMS_EVENT
  into   :id_hotel;
-- CONTRACT_EXPENSE_TYPE in ( 'PERCENT', 'RUNNING_TOTAL_PERCENT', 'CURR_VALUE' )
-- MULTIPLIER_TYPE in ('RESERVATION', 'STAY', 'GUESTS', 'BED_NIGHTS')
  for
    select C.SERVICE_PRICE, C.ID_CURRENCY, C.CONTRACT_EXPENSE_TYPE, C.IS_ACC_POST_ITEM,
           C.ID_SERVICE, C.MULTIPLIER_TYPE
    from   CONTRACT_EXPENSE$PMS C
    where  C.ID_CONTRACT = :id_contract
           and c.SUB_CONTRACT = :SUB_CONTRACT
    order by C.ORDER_TAG asc
    into   :service_price, :id_currency, :contract_expense_type, :is_client_acc_post,
           :ID_SERVICE, :multiplier_type
  do begin

    execute procedure OWNER_ACCOUNT_GET$INT (coalesce(:ID_RENTAL_POOL,:ID_OWNER),
            :id_hotel, :use_shadow_account, :is_client_acc_post)
    returning_values (:id_account, :is_account$pms);

    multiplier = case
                   when :multiplier_type = 'RESERVATION' then iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'STAY' then :STAY
                   when :multiplier_type = 'GUESTS' then :MAX_GUEST_CNT * iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'BED_NIGHTS' then :BED_NIGHT_CNT
                   else null
                 end;

    if (:multiplier is not null) then begin
      if (:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE') then begin
        post_value = cast(:service_price as double precision) * :ownership_percent / 100 * :multiplier;
        post_currency = :id_currency;
      end else if (:CONTRACT_EXPENSE_TYPE = 'PERCENT') then begin
        post_value = :VALUE_ORIG * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end else if (:CONTRACT_EXPENSE_TYPE = 'RUNNING_TOTAL_PERCENT') then begin
        execute procedure PMS_RUNNING_TOTAL_GET(:ID_PMS_EVENT, coalesce(:ID_RENTAL_POOL,:ID_OWNER), :ID_HOTEL, :POST_DATE, :CURR_ORIG)
        returning_values :post_value;
        if (:post_value < 0) then post_value = 0;
    
        post_value = :post_value * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end

      select pe.ID_ROOM
      from   PMS_EVENT$PMS PE
      where  pe.ID_PMS_EVENT = :ID_PMS_EVENT
      into   :id_room;

      select c.ROUND_TO
      from   CURRS C
      where  c.CURR = :post_currency
      into   :round_to;

      execute procedure PMS_POSTING_CREATE$INT(:ID_PMS_EVENT, :id_account, :id_service, :ID_OWNER,
              :POST_DATE, :post_currency, round_f(:post_value, :round_to), :is_account$pms, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* Restore proc. body: EAI_EXT_POST_TO_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable ID_HOTEL integer;
begin
  if (singular(select HS.ID_HOTEL
               from HOTEL_S HS
               where HS.IS_USE = 1)) then
    select H.ID_HOTEL
    from   HOTEL_S H
    where H.IS_USE = 1
    into   :id_hotel;
  else begin
    err_code = -1044;
    exit;
  end

  execute procedure EAI_EXT_POST_TO_MH_FRONT_ONLINE(:ID_HOTEL, :ROOM_NAME,
    :SERVICE_CODE, :CODE_TYPE, :QTY_POST, :PRICE_POST, :CURR_POST, :POST_TEXT)
  returning_values (:ERR_CODE, :ERR_TEXT, :ID_ROOM, :ID_GUEST, :GUEST_NAME1,
    :ID_ACCOUNT, :ID_ACCOUNT_POST, :ID_SERVICE);

end
^

/* Restore proc. body: EAI_IMPORT_ALOYALTY_CLIENT */
ALTER PROCEDURE EAI_IMPORT_ALOYALTY_CLIENT(CLIENT_UUID VARCHAR(40),
CLIENT_NAME VARCHAR(100),
CARD_CODE VARCHAR(50),
IS_ARHIVE SMALLINT,
DATE_OF_BIRTH DATE)
 AS
declare variable PROFILE_ID integer;
  declare variable IMPORT_TIME timestamp;
begin
  execute procedure IMPORT_PERSON_PROFILE$EXC(:CLIENT_UUID, :CLIENT_NAME, null, :DATE_OF_BIRTH, null, null,
    null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null,
    :IS_ARHIVE, :CARD_CODE, null, null, null, null, null, null, null, null, null, null, 'null-uuid')
  returning_values :PROFILE_ID, :IMPORT_TIME;
end
^

/* Restore proc. body: EAI_POS_POSTING_ADD */
ALTER PROCEDURE EAI_POS_POSTING_ADD(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
begin
  -- used external inteface - for compatability with Front 2008
  execute procedure EAI_POS_POSTING_ADD$P2E (:IN_ON_GUEST, :IN_ID_ACCOUNT, :IN_ID_GUEST, :IN_DATE_SMETKA,
          :IN_PRICE, :IN_DATETIME, :IN_OBJ_NAME, :IN_TABLE, :IN_SITE, :IN_SMETKA_NUM, :IN_POS_USER,
          :IN_ID_SMETKA, :IN_SERVICE_TAG, :IN_SERVICE_NAME)
  returning_values (:ERR_CODE, :ERR_TEXT, :OUT_ID_ACCOUNT);

end
^

/* Restore proc. body: GUEST_ADDRESSCARD_SET$RSV */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$RSV(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
EGN VARCHAR(30),
COUNTRY VARCHAR(10),
ID_STAY_REASON INTEGER,
IS_REGISTRED INTEGER,
PASS_PLACE VARCHAR(20),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_PLACE VARCHAR(30),
SEX CHAR,
MASK VARCHAR(10),
IS_CHILD INTEGER,
CAR VARCHAR(30),
KPP INTEGER,
KPP_DATE DATE,
PASS_EXP_DATE DATE,
AGE INTEGER,
BIRTH_DAY DATE,
VISA TDESCRIPTION_SHORT,
RATING_AGE INTEGER = null,
TITLE VARCHAR(10) = null,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable gd_dbkey char(8);
  declare variable pd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable rd_dbkey char(8);
  declare variable old_is_registred integer;
  declare variable old_guest_name1 varchar(250);
  declare variable old_guest_name2 varchar(250);
  declare variable old_id_pass_type integer;
  declare variable old_pass_num varchar(20);
  declare variable old_pass_date date;
  declare variable old_egn varchar(30);
  declare variable old_country varchar(20);
  declare variable old_id_stay_reason integer;
  declare variable old_kpp integer;
  declare variable old_kpp_date date;
  declare variable old_pass_exp_date date;
  declare variable old_birth_day date;
  declare variable old_pass_place varchar(20);
  declare variable old_city varchar(100);
  declare variable old_address varchar(100);
  declare variable old_visa TDESCRIPTION_SHORT;
  declare variable old_birth_place varchar(30);
  declare variable old_sex char(1);
  declare variable action_text varchar(250);
  declare variable tt_reg_number integer;
  declare variable id_hotel integer;
  declare variable id_tt_numerator integer;
  declare variable domestic_nation varchar(10);
  declare variable no_use varchar(255);
  declare variable is_anul smallint;
  declare variable acc_routing varchar(20);
begin
  err_code = 0;
  err_text = '';

  select G.RDB$DB_KEY, GD.RDB$DB_KEY, PD.RDB$DB_KEY,
         GD.IS_REGISTRED, PD.PERSON_NAME, PD.PERSON_NAME2, PD.ID_PASSPORT_TYPE, PD.PASS_NUM, PD.PASS_DATE,
         PD.EGN, PD.COUNTRY_CODE, GD.ID_STAY_REASON, GD.KPP, GD.KPP_DATE, PD.PASS_EXP_DATE,
         PD.BIRTH_DAY, PD.PASS_PLACE, PD.CITY, PD.ADDRESS, PD.BIRTH_PLACE, PD.SEX, rd.RDB$DB_KEY,
         g.TT_REG_NUMBER, rd.ID_HOTEL, rd.IS_ANUL, rd.ACC_ROUTING, GD.VISA
  from   GUEST G
         join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
         join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
         join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
  where  G.ID_GUEST = :id_guest
  into   :g_dbkey, :gd_dbkey, :pd_dbkey,
         :old_is_registred, :old_guest_name1, :old_guest_name2, :old_id_pass_type, :old_pass_num, :old_pass_date,
         :old_egn, :old_country, :old_id_stay_reason, :old_kpp, :old_kpp_date, :old_pass_exp_date,
         :old_birth_day, :old_pass_place, :old_city, :old_address, :old_birth_place, :old_sex, :rd_dbkey,
         :tt_reg_number, :id_hotel, :is_anul, :acc_routing, :old_visa;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, :birth_place, :egn, :id_passport_type, :pass_num, :pass_date, :pass_place,
          :pass_exp_date, :city, :address, :sex, :mask);

  update  GUEST_DATA GD
  set     GD.KPP_DATE = :kpp_date,
          GD.KPP = :kpp,
          GD.VISA = :visa,
          GD.ID_STAY_REASON = :id_stay_reason,
          GD.IS_REGISTRED = :is_registred,
          GD.USER_REGISTRED = iif(:IS_REGISTRED = 1, coalesce(GD.USER_REGISTRED, current_user), null),
          GD.CAR = :car,
          GD.RATING_AGE = :RATING_AGE
  where   GD.RDB$DB_KEY = :gd_dbkey;

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name1, :guest_name2, :country,
          :is_child, :age, :birth_day, :TITLE);

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -1);

  /*  */
  if (:IS_REGISTRED = 1 and :tt_reg_number is null and :is_anul = 0 and :acc_routing is distinct from 'OWNER') then begin
    execute procedure SETTING_GET_VALUE ('NATIVE_NATION', :id_hotel)
    returning_values :domestic_nation;

    select iif(:COUNTRY not in (:domestic_nation, '') and h.USE_DIFFERENT_TT_NUMERATORS = 1,
               h.ID_TT_NUMERATOR_2,
               h.ID_TT_NUMERATOR_1)
    from   HOTEL H
    where  h.ID_HOTEL = :id_hotel
    into   :id_tt_numerator;

    if (:id_tt_numerator is not null) then begin
      execute procedure SYSTEM_GEN_NUM('GUEST_NUM', :id_tt_numerator)
      returning_values :tt_reg_number, :no_use;
  
      update GUEST G
      set    g.TT_REG_NUMBER = :tt_reg_number
      where  G.RDB$DB_KEY = :g_dbkey;
    end
  end else if (:IS_REGISTRED is distinct from 1 and :tt_reg_number is not null) then begin
    update GUEST G
    set    g.TT_REG_NUMBER = null
    where  G.RDB$DB_KEY = :g_dbkey;
  end
  /*  */
  if ((:old_is_registred = 0) and (:is_registred = 1)) then begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'REGISTRED', '');
  end

  if ((:old_is_registred = 1) and (:old_guest_name1 <> :guest_name1)) then begin
    action_text = f_character(29)||:old_guest_name1||f_character(28)||:guest_name1;
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'CHANGE_CARD', :action_text);
  end

  if ((:old_IS_REGISTRED = 1)
      and
      ((:old_guest_name1 <> :guest_name1)
        or (:old_guest_name2 <> :guest_name2)
        or (:old_egn <> :egn)
        or (:old_id_pass_type <> :id_passport_type)
        or (:old_pass_num <> :pass_num)
        or (:old_pass_date <> :pass_date)
        or (:old_pass_exp_date <> :pass_exp_date)
        or (:old_pass_place <> :pass_place)
        or (:old_country <> :country)
        or (:old_city <> :city)
        or (:old_address <> :address)
        or (:old_visa <> :visa)
        or (:old_birth_day <> :birth_day)
        or (:old_birth_place <> :birth_place)
        or (:old_sex  <> :sex)
        or (:old_kpp <> :kpp)
        or (coalesce(:old_id_stay_reason,0) <> coalesce(:id_stay_reason,0))
        or (:old_kpp_date <> :kpp_date)
      )) then
  begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'PREREGISTRED', '');
  end

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
    returning_values  :warn_code;

  end

end
^

/* Restore proc. body: IMPORT_AGENT_PROFILE$EXC */
ALTER PROCEDURE IMPORT_AGENT_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
AGENT_GROUP VARCHAR(50),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
WBE_PASSWORD VARCHAR(20),
IATA_NUMBER VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
DEF_CONTRAGENT_NAME VARCHAR(100),
THRESHOLD_NOTE VARCHAR(255),
THRESHOLD_AMOUNT NUMERIC(15,4),
THRESHOLD_CURR CHAR(3),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
declare variable op varchar(10);
  declare variable market_segment_id integer;
  declare variable agent_group_old varchar(50);
  declare variable id_bonuspoint_scheme integer;
  declare variable id_def_contragent integer;
  declare variable is_exclusive_debt_ownership smallint;
  declare variable country_code_old varchar(10);
  declare variable profile_receiver_id integer;
  declare variable discount_id integer;
begin
  profile_id = null;
  import_time = null;

  execute procedure import_mark_transaction$exc;

  execute procedure sys_dbg('exc IMPORT_AGENT_PROFILE$EXC(:profile_uuid=>' || coalesce(:profile_uuid, cast('<null>' as varchar(40)) ) || ')');
  profile_id = null;
  if (:PROFILE_UUID is null) then begin
    execute procedure sys_dbg('exc IMPORT_AGENT_PROFILE$EXC <null> :profile_uuid - exit;');
    exit;
  end

  select p.profile_id, p.profile_name, p.phone, p.fax, p.email, p.city,
         p.address, p.market_segment, p.note, p.is_archive, p.id_bonuspoint_scheme,
         p.id_def_contragent, pa.agent_group, p.wbe_password,
         p.msg, p.account_no, p.is_exclusive_debt_ownership, pa.country_code
  from   IMPORT_COMMON_PROFILE$EXC(:PROFILE_UUID, 1, :PROFILE_NAME,
         :PHONE, :FAX, :EMAIL, :CITY, :ADDRESS, :MARKET_SEGMENT, :NOTE, :IS_ARCHIVE, :WBE_PASSWORD, :ACCOUNT_NO, :MSG,  'AGENT_PROFILE', :HOTEL_UUID_LIST) p
         left outer join profile_agent pa on pa.id_profile = p.profile_id
  into   :profile_id, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :id_bonuspoint_scheme,
         :id_def_contragent, :agent_group_old, :wbe_password,
         :msg, :account_no, :is_exclusive_debt_ownership, :country_code_old;

  if (:profile_id is null) then begin
    op = 'add';
  end else if (:hotel_uuid_list is null) then begin
    profile_id = null;
    exit;
  end else begin
    op = 'mod';
    if (:hotel_uuid_list is not null) then begin
      for
        select d.id_sale_discount
        from   sale_discount d
               join hotel h on h.id_hotel = d.id_hotel
        where  :hotel_uuid_list containing h.uuid
        into   :discount_id
      do begin
        delete from PROFILE_DISCOUNT pd
        where  pd.ID_PROFILE = :profile_id
               and pd.id_sale_discount = :discount_id;
      end
    end

    delete from PROFILE_BONUSPOINT_SCHEME bs
    where  bs.ID_PROFILE = :profile_id;
  end

  AGENT_GROUP=coalesce(:AGENT_GROUP, :AGENT_GROUP_OLD);
  country_code=coalesce(:country_code, :country_code_old);

  execute procedure LOOKUP_MARKET_SEGMENT$EXC(:profile_name, 'AGENT_PROFILE', :market_segment)
  returning_values :market_segment_id;

  if ((def_contragent_name is not null) and (def_contragent_name <> '')) then begin
    execute procedure LOOKUP_CONTRAGENT$EXC(:profile_name, 'AGENT_PROFILE', :def_contragent_name)
    returning_values :id_def_contragent;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:profile_name, 'AGENT_PROFILE');

  execute procedure sys_dbg('exc IMPORT_AGENT_PROFILE$EXC - profile_agent_modify$profile(:profile_uuid=>' || coalesce(:profile_uuid,cast('<null>' as varchar(40)))
    || ', :operation=>' || coalesce(:op, cast('<null>' as varchar(10)) )
    || ', :market_segment_id=>' || coalesce(cast(:market_segment_id as varchar(10)) , cast('<null>' as varchar(10)) )
    || ')');

  if (:hotel_uuid_list is null) then begin
    -- in "non authoritive" mode (i.e. embeded mode transfer only profile key fields )
    --profile_name = null;
    phone = null;
    fax = null;
    email = null;
    country_code = null;
    city = null;
    address = null;
    note = null;
    msg = null;
    --is_archive = null;
    agent_group = null;
    id_def_contragent = null;
    market_segment_id = null;
    id_bonuspoint_scheme = null;
    wbe_password = null;
    account_no = null;
    --iata_number = null;
    is_exclusive_debt_ownership = null;
  end

  execute procedure profile_agent_modify$profile(
    :profile_id, :profile_name, :phone, :fax, :email,
    :country_code, :city, :address, :note, :msg, :is_archive, :agent_group, :id_def_contragent, :market_segment_id,
    :wbe_password, :op, :account_no, :iata_number, :is_exclusive_debt_ownership,
    :threshold_note, :threshold_amount, :threshold_curr)
  returning_values :profile_id;

  /*assign UUID to the new profiles*/
  if ('add' = :op) then begin
    update profile
    set    uuid = :profile_uuid
    where  id_profile = :profile_id;
  end

  select record_timestamp
  from   profile
  where  id_profile = :profile_id
  into   :import_time;

  if (:MERGE_TARGET_UUID is not null) then begin
    select p.ID_PROFILE
    from   PROFILE P
    where  P.UUID = :MERGE_TARGET_UUID
    into   :profile_receiver_id;

    execute procedure PROFILE_MERGE$PROFILE (:PROFILE_ID, :profile_receiver_id, 'merge');

  end
end
^

/* Restore proc. body: IMPORT_RATE_RECORD_RELINK$EXC */
ALTER PROCEDURE IMPORT_RATE_RECORD_RELINK$EXC(ID_RATE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ID_COLUMN integer;
declare variable ID_NEW_MASTER_RECORD integer;

declare variable PERIOD_DEPEND_ON_CHECKIN INTEGER;
declare variable CNT_DAYS_PRICE_BP INTEGER;
declare variable CNT_DAYS_PRICE_BOARD INTEGER;
declare variable BASE_BOARDS_LIST VARCHAR(255);
declare variable BOARD_TYPE VARCHAR(10);
begin
  execute procedure import_mark_transaction$exc;

  ERR_CODE = 0;
  ERR_TEXT = '';
  for
    select c.ID_TAR_DEFINE_COLUMN, im.ID_NEW
    from   TAR_UI_DEFINE_COLUMNS c
           join IDS_MAP$TMP im on c.ID_DIM2 = im.ID_OLD
    where  c.ID_TAR_HEAD = :ID_RATE
    into   :ID_COLUMN, :ID_NEW_MASTER_RECORD
  do begin
    update TAR_UI_DEFINE_COLUMNS c
    set    c.ID_DIM2 = :ID_NEW_MASTER_RECORD
    where  c.ID_TAR_DEFINE_COLUMN = :ID_COLUMN;
  end

  delete from IDS_MAP$TMP;


  select
        th.PERIOD_DEPEND_ON_CHECKIN,
        th.CNT_DAYS_PRICE_BP,
        th.CNT_DAYS_PRICE_BOARD,
        th.BASE_BOARDS_LIST,
        th.BOARD_TYPE
  from  TAR_HEAD th
  where th.ID_TAR_HEAD = :ID_RATE
  into  :PERIOD_DEPEND_ON_CHECKIN, :CNT_DAYS_PRICE_BP, :CNT_DAYS_PRICE_BOARD, :BASE_BOARDS_LIST, :BOARD_TYPE;

  for
    select ERR_CODE, ERR_TEXT
    from   TAR_SAVE(:ID_RATE, :PERIOD_DEPEND_ON_CHECKIN, :CNT_DAYS_PRICE_BP, :CNT_DAYS_PRICE_BOARD, :BASE_BOARDS_LIST, :BOARD_TYPE)
    into   :err_code, :err_text
  do begin
    if (0 <> :err_code) then begin
      exit;
    end
  end
end
^

/* Restore proc. body: MONITOR_ROOM_GANT$HM */
ALTER PROCEDURE MONITOR_ROOM_GANT$HM(FROM_DATE DATE,
TO_DATE DATE,
IN_ROOM_NAME VARCHAR(10),
IN_ID_ROOM_TYPE INTEGER,
IN_FLOOR INTEGER,
ID_HOTEL INTEGER)
 RETURNS(ID_ROOM INTEGER,
ROOM_NAME VARCHAR(20),
GANT_FROM_DATE DATE,
GANT_TO_DATE DATE,
BUSY_GRP INTEGER)
 AS
declare variable id_occupant integer;
begin
  for
    select R.ID_ROOM, R.ROOM_NAME
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  RT.ID_HOTEL = :id_hotel
           and ((R.ID_ROOM_TYPE = :in_id_room_type) or (:in_id_room_type = -1))
           and ((:in_room_name = '') or (r.room_name like :in_room_name))
           and ((:in_floor = -1) or (R.FLOOR = :in_floor))
    order by R.ROOM_NAME
    into :id_room, :room_name
  do begin
    gant_from_date = null;
    gant_to_date = null;
    busy_grp = null;
    suspend;

    for
      select distinct
             RM.ID_RESERV_DETAIL, RM.BUSY_GROUP_TYPE
      from   ROOM_MAGIC RM
      where  RM.BUSY_DATE between :from_date and :to_date
             and RM.ID_ROOM = :id_room
      into   :id_occupant, :busy_grp
    do begin
      select O.FROM_DATE, O.TO_DATE
      from   OCCUPANT_GET_INFO(:id_occupant, :busy_grp) O
      into   :gant_from_date, :gant_to_date;

      suspend;
    end
  end
end
^

/* Restore proc. body: PMS_EXPENSE_POSTS_CREATE$INT */
ALTER PROCEDURE PMS_EXPENSE_POSTS_CREATE$INT(ID_ROOM TYPE OF ID,
ID_OWNER TYPE OF ID,
ID_RENTAL_POOL TYPE OF ID_REF,
ID_SERVICE TYPE OF ID,
ID_CURRENCY TYPE OF TCURRENCY,
POST_VALUE TYPE OF TPRICE,
IS_CLIENT_ACC_POST TYPE OF TLOGICAL,
MANUAL_POST_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
IS_POST_PER_POOL TYPE OF TLOGICAL)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF,
NEW_ID_ACCOUNT_POST$PMS ID_REF)
 AS
declare variable event_type varchar(30);
  declare variable id_room_contract integer;
  declare variable new_id_pms_event integer;
  declare variable round_to_orig numeric(15,6);
  declare variable ownership_percent numeric(15,4);
  declare variable curr_contract_owner integer;
  declare variable curr_total_ownership numeric(15,4);
  declare variable curr_total_value numeric(15,4);
  declare variable percent_value numeric(15,4);
  declare variable id_account integer;
  declare variable id_hotel integer;
  declare variable is_account$pms integer;
  declare variable id_acc_post integer;
BEGIN
  event_type = 'MANUAL_EXPENSE';
  curr_total_value = 0;
  curr_total_ownership = 0;

  select RC.ID_ROOM_CONTRACT, r.ID_HOTEL
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS P on RC.ID_ROOM_PERIOD = P.ID_ROOM_PERIOD
         join ROOMS R on R.ID_ROOM = p.ID_ROOM
  where  :MANUAL_POST_DATE between P.FROM_DATE and P.TO_DATE
         and P.ID_ROOM = :ID_ROOM
         and P.STATUS in ('PRIVATE','CONTRACT')
  into   :id_room_contract, :id_hotel;

  if (:ID_ROOM_CONTRACT is null) then exception PMS_EXCEPTION '-615';

  execute procedure PMS_EVENT_CREATE$INT(:EVENT_TYPE, :ID_ROOM, :ID_OWNER, :DESCRIPTION,
          :MANUAL_POST_DATE, null, null, null, null, :POST_VALUE, :POST_VALUE, :ID_CURRENCY, null, :id_room_contract)
  returning_values :new_id_pms_event;

  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :ID_CURRENCY
  into   :round_to_orig;

  for
    select iif(:ID_OWNER is null, O.OWNERSHIP_PERCENT, 100), O.ID_OWNER
    from   ROOM_CONTRACT$PMS RC
           join ROOM_OWNER$PMS O on O.ID_ROOM_CONTRACT = RC.ID_ROOM_CONTRACT
    where  RC.ID_ROOM_CONTRACT = :id_room_contract
           and ((:ID_OWNER is null) or (O.ID_OWNER = :ID_OWNER))
    into   :ownership_percent, :curr_contract_owner
  do begin
    curr_total_ownership = :curr_total_ownership + :ownership_percent;
    if (:curr_total_ownership = 100) then begin
      percent_value = :post_value - :curr_total_value;
    end else
      percent_value = round_f(:post_value * :ownership_percent / 100, :round_to_orig);

    curr_total_value = :curr_total_value + :percent_value;

    execute procedure OWNER_ACCOUNT_GET$INT (iif(:is_post_per_pool = 1, :id_rental_pool, :curr_contract_owner),
            :id_hotel, 0, :IS_CLIENT_ACC_POST)
    returning_values (:id_account, :is_account$pms);

    execute procedure PMS_POSTING_CREATE$INT(:new_id_pms_event, :ID_ACCOUNT, :ID_SERVICE,
            :curr_contract_owner, :MANUAL_POST_DATE, :ID_CURRENCY, :PERCENT_VALUE, :is_account$pms, 0, :ID_ROOM)
    returning_values :id_acc_post;

    new_id_account_post = null;
    new_id_account_post$pms = null;

    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 1)) then new_id_account_post$pms = :id_acc_post;
    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 0)) then new_id_account_post = :id_acc_post;
    suspend;
  end

  execute procedure PMS_EVENT_SET_ACTIVE$INT(:new_id_pms_event);
END
^

/* Restore proc. body: PMS_POOL_DISTRIBUTION_SUB */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
declare variable cnt_room smallint;
  declare variable curr_total_posted numeric(15,4);
  declare variable cnt integer;
  declare variable value_to_post numeric(15,4);
  declare variable value_to_post_per_owner numeric(15,4);
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable id_room_contract integer;
  declare variable id_owner_account integer;
  declare variable id_pms_event integer;
  declare variable id_hotel integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
begin
  select c.ROUND_TO
  from   CURRS c
  where  c.CURR = :CURR
  into   :round_to;

  cnt_room = 0;
  select count(distinct RP.ID_ROOM)
  from   ROOM_PERIOD$PMS RP
         join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
  where  RC.ID_RENTAL_POOL = :id_rental_pool
         and RP.STATUS in ('PRIVATE','CONTRACT')
         and RP.FROM_DATE <= :FOR_DATE
         and RP.TO_DATE >= :FOR_DATE
  into   :cnt_room;

  if (:cnt_room = 0) then exception PMS_EXCEPTION 'The pool has not assigned room contracts for selected date (' || :FOR_DATE || ') !';

  if (:is_room_pool = 1) then begin
    curr_total_posted = 0;
    cnt = 0;
    id_pms_event = null;
    id_hotel = null;
    for
      select distinct RP.ID_ROOM, RC.ID_ROOM_CONTRACT, R.ID_HOTEL
      from   ROOM_PERIOD$PMS RP
             join ROOMS R on R.ID_ROOM = RP.ID_ROOM
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.FROM_DATE <= :FOR_DATE
             and RP.TO_DATE >= :FOR_DATE
      into   :id_room, :id_room_contract, :id_hotel
    do begin
      id_pms_event = null;

      select E.ID_PMS_EVENT
      from   PMS_EVENT$PMS E
      where  E.ID_ROOM = :id_room
             and E.ID_SESSION = current_transaction
      into   :ID_PMS_EVENT;

      if (:ID_PMS_EVENT is null) then begin
        execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, :id_room_contract)
        returning_values :id_pms_event;
        -- FIXME nakraq da se update total_event_value
      end
      if (:cnt_room - :cnt = 1) then begin
        value_to_post = :TOTAL_VALUE_PER_SERVICE - :curr_total_posted;
      end else begin
        value_to_post = round_f(:TOTAL_VALUE_PER_SERVICE / :cnt_room, :round_to);
      end

      curr_total_posted = :curr_total_posted + :value_to_post;
      cnt = :cnt + 1;

      /* ...i se razpredelq mejdu sobstwenicite na staqta */
      value_to_post = abs(:value_to_post);
      for
        select R.ID_OWNER, R.OUT_VALUE
        from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
        into   :id_owner, :value_to_post_per_owner
      do begin
        /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_pool_account,
                :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                1, :IS_OWNER_INCOME, :id_room)
        returning_values :no_use_id_acc_post;
        /* ... i se nachislqwa po sobswtenik */
        execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
        returning_values (:id_owner_account, :is_account$pms);

        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                :is_account$pms, :is_owner_income, :id_room)
        returning_values :no_use_id_acc_post;
      end
    end
  end else begin
    /* distribution by room_param */
    insert into TMP_SELECT$PMS(ID_SESSION, ID_ROOM, ID_OWNER)
    select distinct current_transaction, RP.ID_ROOM, null
    from   ROOM_PERIOD$PMS RP
           join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
    where  RC.ID_RENTAL_POOL = :ID_RENTAL_POOL
           and RP.STATUS in ('PRIVATE','CONTRACT')
           and RP.FROM_DATE <= :FOR_DATE
           and RP.TO_DATE >= :FOR_DATE;

    id_hotel = null;
    for
      select P.OUT_VALUE, P.OUT_ID_ROOM, R.ID_HOTEL
      from   PMS_CALC_VALUE_BY_PARAM(:ID_ROOM_PARAM, :TOTAL_VALUE_PER_SERVICE, :round_to) P
             join ROOMS R on R.ID_ROOM = P.OUT_ID_ROOM
      into   :value_to_post, :id_room, :id_hotel
    do begin
      id_pms_event = null;
      id_room_contract = null;
      -- room contract must be only one for this period
      select RC.ID_ROOM_CONTRACT
      from   ROOM_PERIOD$PMS RP
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.ID_ROOM = :id_room
             and :for_date between RP.FROM_DATE and RP.TO_DATE
      into   :id_room_contract;

      if (:id_room_contract is not null) then begin
        select E.ID_PMS_EVENT
        from   PMS_EVENT$PMS E
        where  E.ID_ROOM = :id_room
               and E.ID_SESSION = current_transaction
        into   :ID_PMS_EVENT;
  
        if (:ID_PMS_EVENT is null) then begin
          execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                  'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, id_room_contract)
          returning_values :id_pms_event;
          -- FIXME nakraq da se update total_event_value
        end
  
        /* ...i se razpredelq mejdu sobstwenicite na staqta */
        for
          select R.ID_OWNER, R.OUT_VALUE
          from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
          into   :id_owner, :value_to_post_per_owner
        do begin
          /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :ID_POOL_ACCOUNT,
                  :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                  1, :IS_OWNER_INCOME, :id_room)
          returning_values :no_use_id_acc_post;
  
          /* ... i se nachislqwa po sobswtenik */
          execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
          returning_values (:id_owner_account, :is_account$pms);

          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                  :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                  :is_account$pms, :is_owner_income, :id_room)
          returning_values :no_use_id_acc_post;
        end
      end
    end

    delete from TMP_SELECT$PMS T
    where  T.ID_SESSION = current_transaction;
  end
end
^

/* Restore proc. body: RES_ANUL_DETAIL$INT */
ALTER PROCEDURE RES_ANUL_DETAIL$INT(RD_DBKEY CHAR(8),
REASON VARCHAR(50),
CANCELATION_NUMBER TYPE OF NAME_20 = null)
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable id_reserv_detail integer;
  declare variable is_anul integer;
  declare variable id_log_event integer;
  declare variable id_guest integer;
  declare variable id_group integer;
  declare variable g_dbkey char(8);
  declare variable no_use varchar(255);
  declare variable tmp_extra_posts_left smallint;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:reason, 'NOSHOW, CANCELED, USERERROR, TRANSFER', 'Annul reason');

  select RD.IS_ANUL, RD.ID_RESERV_DETAIL, rd.ID_GROUP
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :is_anul, :id_reserv_detail, :id_group;

  if (:is_anul = 1) then begin
    exception BOOKING_EXCEPTION '-1021';
    -- Reservation is already annuled or checkedin !
  end

  if (:reason = 'NOSHOW') then begin
    execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    returning_values  :no_use, :no_use;
  end

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_ANUL', f_character(29) || :reason);

  id_log_event = RDB$GET_CONTEXT('USER_TRANSACTION', 'ACTION_LOG_ID');

  update RESERV_DETAIL RDU
  set    RDU.IS_ANUL = 1,
         RDU.REASON_OF_ANUL = :reason,
         RDU.ID_LOG_EVENT_ANNUL = :id_log_event,
         RDU.CANCELATION_NUMBER = coalesce(:CANCELATION_NUMBER, strhash_large(rdu.NUMBER || 'CANCELATION'))
  where  RDU.RDB$DB_KEY = :rd_dbkey;

  EXTRA_POSTS_LEFT = 0;
  for
    select g.ID_GUEST, G.RDB$DB_KEY
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_guest, :g_dbkey
  do begin
    execute procedure GUEST_DEL_POSTINGS$INT(:id_guest)
    returning_values  :tmp_extra_posts_left;
    EXTRA_POSTS_LEFT = iif(:EXTRA_POSTS_LEFT = 1, 1, :tmp_extra_posts_left);

    update GUEST G
    set    G.UUID = null
    where  g.RDB$DB_KEY = :g_dbkey;
  end

  execute procedure RES_FINALIZE$INT (:RD_DBKEY, 0)
  returning_values (:warn_code);

  execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

  if (:id_group is not null) then
    execute procedure RESGRP_GUESTDATA_INVALIDATE$INT(:id_group);

end
^

/* Restore proc. body: RES_DELETE$INT */
ALTER PROCEDURE RES_DELETE$INT(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable rd_dbkey char(8);
  declare variable id_guest integer;
  declare variable action_text varchar(255);
  declare variable from_date date;
  declare variable to_date date;
  declare variable room_type varchar(20);
  declare variable number varchar(62);
  declare variable tmp_extra_posts_left integer;
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_DELETE');

  select RD.RDB$DB_KEY, RD.FROM_DATE, rd.TO_DATE, RT.TYPE_ROOM, rd.NUMBER
  from   RESERV_DETAIL RD
         left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = RD.ID_ROOM_TYPE
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey, :from_date, :to_date, :room_type, :number;

  update RESERV_DETAIL R
  set    r.ID_TITULAR = null
  where  r.RDB$DB_KEY = :rd_dbkey;

  EXTRA_POSTS_LEFT = 0;
  for
    select G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_guest
  do begin
    execute procedure RES_GUEST_DEL$INT(:id_guest, :id_reserv_detail, :REASON)
    returning_values  :tmp_extra_posts_left;
    EXTRA_POSTS_LEFT = iif(:EXTRA_POSTS_LEFT = 1, 1, :tmp_extra_posts_left);
  end

  execute procedure RES_FINALIZE$INT (:RD_DBKEY, 1)
  returning_values (:warn_code);


  execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

  action_text = f_character(29) || coalesce(:number, '')
                || f_character(28) || coalesce(:room_type, '')
                || f_character(28) || :from_date
                || f_character(28) || :to_date
                || f_character(28) || :reason;
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'DELETE', :action_text);

  delete from RESERV_DETAIL RDD
  where  RDD.RDB$DB_KEY = :rd_dbkey;

  delete from XML_MESSAGE$EXC xml
  where  xml.OBJECT_TYPE = 'BOOKING'
         and xml.OBJECT_ID = :number;

end
^

/* Restore proc. body: RES_EARLY_DEPARTURE_SET$RSV */
ALTER PROCEDURE RES_EARLY_DEPARTURE_SET$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND INTEGER)
 RETURNS(RECALC_MARKER_LIST VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable sys_date date;
  declare variable stay integer;
  declare variable rd_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable id_hotel integer;
  declare variable hotels_cnt integer;
  declare variable arrival_date date;
  declare variable is_late_departure smallint;
  declare variable comming_kind smallint;
  declare variable dep_date date;
begin
  /* CHECK_OUT_kind =
  || 1 - DO NOT MODIFY GUEST
  || 2 - SHRINK PERIOD AND OCCUPANCY
  || 3 - DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
  */
  execute procedure RIGHTS_CHECK_GRANTED$INT('CHECK_OUT_EARLY');

  select min(RD.ID_HOTEL), count(distinct RD.ID_HOTEL)
  from   RESERV_DETAIL RD
  where  RD.SELECTION_ID = :SELECTION_ID
  into   :id_hotel, :hotels_cnt;

  if (:hotels_cnt > 1) then exception RESERV_CHECK_OUT_EXCEPTION '-1020';

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values  :sys_date;

  RECALC_MARKER_LIST = null;
  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL, rd.FROM_DATE, rd.TO_DATE, RD.LEAVING_KIND - 1, rd.COMMING_KIND
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :rd_dbkey, :id_reserv_detail, :arrival_date, :dep_date, :is_late_departure, :comming_kind
  do begin
    if ((:check_out_kind = 2) and (:dep_date > :sys_date)) then begin
      -- SHRINK PERIOD AND OCCUPANCY
      execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :sys_date, :is_late_departure, :comming_kind);
    
      execute procedure RES_FINALIZE$INT(:rd_dbkey)
      returning_values  :warn_code;
    end else if ((:check_out_kind = 1) and (:dep_date > :sys_date)) then begin
      /* KEEP BOOKING STAY PERIOD AND ROOM OCCUPANCY */
      for
        select G.TO_DATE - :sys_date
        from   GUEST G
        where  G.ID_RESERV_DETAIL = :id_reserv_detail
        into   :stay
      do begin
  --      if (:check_out_kind = 1) then begin
        if (:stay > 1) then begin
            --THE DEPARTURE DATE IS LATER THAN NEXT DATE. STAY SHOULD BE CHANGED MANUALY.;
            exception RESERV_CHECK_OUT_EXCEPTION '-323';
        end
      end
    end
  end
end
^

/* Restore proc. body: RES_GET_DEPOSIT$INT */
ALTER PROCEDURE RES_GET_DEPOSIT$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(DEPOSIT_VALUE NUMERIC(15,4),
DEPOSIT_CURRENCY CHAR(3))
 AS
declare variable rd_dbkey char(8);
declare variable dummy varchar(255);
begin
  select RD.RDB$DB_KEY, RD.GUARANTEE_DEPOSIT, rd.GUARANTEE_CURRENCY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :deposit_value, :deposit_currency;

  if (:DEPOSIT_VALUE is not null) then begin
    EXIT;
  end else begin
    execute procedure RES_GET_PRICE$INT(:rd_dbkey, 'SECURITY, FORCED')
    returning_values  :dummy, :dummy, :dummy, :deposit_value, :deposit_currency;
  end

end
^

/* Restore proc. body: RES_GUEST_CHANGE$RSV */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable id_guest integer;
  declare variable check_status integer;
  declare variable id_person_data integer;
  declare variable old_person_profile integer;
  declare variable old_profile_name varchar(100);
  declare variable new_profile_name varchar(100);
begin
  select r.RDB$DB_KEY, r.ID_TITULAR, r.CHECK_STATUS, r.ID_PERSON_PROFILE, p.PROFILE_NAME
  from   RESERV_DETAIL R
         join PROFILE P on P.ID_PROFILE = r.ID_PERSON_PROFILE
  where  R.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey, :id_guest, :check_status, :old_person_profile, :old_profile_name;

  if (:old_person_profile = :ID_PERSON_PROFILE) then exit; -- NO CHANGES!

  id_person_data = null;
  select pp.ID_PERSON_DATA, p.PROFILE_NAME
  from   PROFILE_PERSON PP
         join PROFILE P on P.ID_PROFILE = pp.ID_PROFILE
  where  pp.ID_PROFILE = :ID_PERSON_PROFILE
  into   :id_person_data, :new_profile_name;

  if (:id_person_data is null) then exception BOOKING_EXCEPTION '-1039';

  update RESERV_DETAIL RD
  set    rd.ID_PERSON_PROFILE = :ID_PERSON_PROFILE
  where  rd.RDB$DB_KEY = :rd_dbkey;

  if (:check_status = 1) then begin
    execute procedure PERSON_DATA_COPY$INT (:id_person_data)
    returning_values (:id_person_data);
  end

  update GUEST_DATA GD
  set    gd.ID_PERSON_DATA = :id_person_data
  where  gd.ID_GUEST = :id_guest;

  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey);

  if (exists (select ap.ID_ACCOUNT_POST
              from   ACCOUNT_POST AP
                     join ACCOUNT A on A.ID_ACCOUNT = ap.ID_ACCOUNT
              where  a.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                     and a.ID_PROFILE = :old_person_profile
                     and ap.IS_ANUL = 0)) then
    exception BOOKING_EXCEPTION '-1038';

  if (exists (select d.ID_DEPOSIT
              from   DEPOSITS D
                     join ACCOUNT A on A.ID_ACCOUNT = d.ID_ACCOUNT
              where  a.ID_PROFILE = :old_person_profile
                     and coalesce(d.ID_RESERV_DETAIL, a.ID_RESERV_DETAIL) = :ID_RESERV_DETAIL
                     and d.RECEIVED_AMOUNT > 0)) then
    exception BOOKING_EXCEPTION '-1040';

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'TITULAR_CHANGED',
          f_character(29) || :old_profile_name || f_character(28) || :new_profile_name, null);

end
^

/* Restore proc. body: RES_SAVE_ACCOUNTING$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
declare variable old_id_agent_profile integer;
  declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable action_text varchar(255);
  declare variable old_account_routing varchar(30);
  declare variable id_acc_profile integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:acc_routing, 'GUEST, AGENT, MIXED, OWNER, FULL_COMPLIMENTARY, PART_COMPLIMENTARY', 'Account routing');

  if (exists (select *
              from   PROFILE_HOUSE PH
              where  PH.ID_PROFILE = :id_agent_profile)) then
  begin
    exception BOOKING_EXCEPTION '-1016';
  end

  execute procedure RESERV_TRACK_CHANGES$INT(:rd_dbkey);

  select RD.ID_AGENT_PROFILE, RD.ID_RESERV_DETAIL, RD.ACC_ROUTING
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_agent_profile, :id_reserv_detail, :old_account_routing;

  if (:ACC_ROUTING in ('AGENT','MIXED') and :ID_AGENT_ACCOUNT is not null) then begin
    select A.ID_PROFILE
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :ID_AGENT_ACCOUNT
    into   :id_acc_profile;
    -- check up agent account ownership
    if (:id_acc_profile is distinct from :ID_AGENT_PROFILE) then ID_AGENT_ACCOUNT = null;
  end

  update RESERV_DETAIL RD
  set    RD.ID_AGENT_ACCOUNT_RULE = :ID_AGENT_ACCOUNT,
         RD.ACC_ROUTING = :ACC_ROUTING,
         RD.ID_AGENT_PROFILE = :ID_AGENT_PROFILE,
         RD.ID_AGENT_PAYMENT = :ID_AGENT_PAYMENT,
         RD.ID_PERSON_PAYMENT = coalesce(:ID_PERSON_PAYMENT, RD.ID_PERSON_PAYMENT),
         RD.ID_GROUP = :ID_GROUP
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_id_agent_profile is distinct from :id_agent_profile) then begin
    execute procedure RES_SET_EDIT_STATUS$INT(:RD_DBKEY, 'AGENT', 'add');

    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :g_dbkey
    do begin
      execute procedure GUEST_AGENT_SET$INT(:g_dbkey, :id_agent_profile);
    end

    select f_character(29)||coalesce(old_A.PROFILE_NAME, '')||f_character(28)||coalesce(new_A.PROFILE_NAME, '')
    from   PROFILE old_A, PROFILE new_A
    where  old_A.ID_PROFILE = :old_id_agent_profile
           and new_A.ID_PROFILE = :ID_AGENT_PROFILE
    into   :action_text;

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_AGENT', :action_text);
  end

  if (:ACC_ROUTING <> :old_account_routing) then begin
    action_text = f_character(29) || coalesce(:old_account_routing, '')
                  || f_character(28) || coalesce(:acc_routing, '');

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_ACC_ROUTING', :action_text);
  end

  execute procedure RES_SAVE_ACCOUNTS$INT (:RD_DBKEY);
end
^

/* Restore proc. body: SAFE_CHECK_OUT */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE TYPE OF ID)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
WARN_CODE TYPE OF ID_REF)
 AS
declare variable to_dt timestamp;
  declare variable is_occupied integer;
  declare variable expire_tollerance integer;
  declare variable occupant_name varchar(100);
  declare variable id_resource_reservation integer;
  declare variable check_out_datetime timestamp;
begin
  DOC_SELECTED = null;
  select s.IS_OCCUPIED, od.TO_DATETIME,
         st.EXPIRE_TOLLERANCE, rr.OCCUPANT_NAME, rr.ID_RESOURCE_RESERVATION
  from   SAFE s
         join RESOURCE$INT r on r.ID_RESOURCE = s.ID_SAFE
         join SAFE_TYPES st on st.ID_SAFE_TYPE = r.ID_RESOURCE_TYPE
         join RESOURCE_RESERVATION rr on rr.ID_RESOURCE_RESERVATION = s.ID_CURRENT_OCCUPANCY
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join RESOURCE_OCCUPANCY ro on ro.ID_RESOURCE_OCCUPANCY_DATA = od.ID_RESOURCE_OCCUPANCY_DATA
  where  s.ID_SAFE = :ID_SAFE
  into   :is_occupied, :to_dt, :expire_tollerance, :occupant_name, :id_resource_reservation;

  if (:is_occupied = 0) then exit;

  expire_tollerance = coalesce(:expire_tollerance, 0);
  check_out_datetime = current_timestamp;

  execute procedure SAFE_OCCUPANCY_MODIFY (:id_safe, current_timestamp, :occupant_name)
  returning_values  :DOC_SELECTED;

  if (:check_out_datetime > (:to_dt + cast(:expire_tollerance as double precision) / 60 / 24)) then begin
    execute procedure SYSTEM_WARNING_ADD (-1066, f_character(29) || :expire_tollerance || f_character(28) || formatdate(:to_dt + cast(:expire_tollerance as double precision) / 60 / 24, 'D;dd/mm/yyyy HH:MM'))
    returning_values (:WARN_CODE);
  end

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = null
  where  s.ID_SAFE = :ID_SAFE;

  update RESOURCE_RESERVATION rr
  set    rr.STATUS = 'CHECKED_OUT'
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_CHECKED_OUT', :occupant_name);
end
^

/* Restore proc. body: TAR_CALC_INPUT_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_PARAMS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_input integer;
  declare variable id_guest integer;
  declare variable for_date date;
  declare variable id_calc_tariff integer;
  declare variable td_dbkey char(8);
  declare variable date_independent_param_values varchar(2000);
  declare variable date_dep_param_values varchar(2000);
  declare variable prev_id_guest integer;
  declare variable prev_id_tariff integer;
begin
  prev_id_guest = null;
  prev_id_tariff = null;
  for
    select Td.RDB$DB_KEY, TI.ID_TAR_INPUT, ti.ID_GUEST, td.FOR_DATE, td.ID_TAR_HEAD
    from   TAR_CALC_INPUT$TMP TI
           join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
    where  TI.ID_TAR_CALC = :id_tar_calc
    order by ti.ID_GUEST asc, td.FOR_DATE asc
    into   :td_dbkey, :id_tar_input, :id_guest, :for_date, :id_calc_tariff
  do begin
    if ((:id_guest is distinct from :prev_id_guest)
        or (:id_calc_tariff is distinct from :prev_id_tariff)) then
    begin
      /* get date independent params */
      execute procedure TAR_CALC_PARAMS$INT (:id_calc_tariff, :id_tar_input, :ID_TAR_CALC, null, null)
      returning_values (:ERR_CODE, :date_independent_param_values);
      if (:ERR_CODE < 0) then exit;
      prev_id_guest = :id_guest;
      prev_id_tariff = :id_calc_tariff;
    end

    execute procedure TAR_CALC_PARAMS$INT (:id_calc_tariff, :id_tar_input, :ID_TAR_CALC, :for_date, null)
    returning_values (:ERR_CODE, :date_dep_param_values);
    if (:ERR_CODE < 0) then exit;

    update TAR_CALC_INPUT_DETAIL$TMP d
    set    d.PARAM_VALUES = coalesce(:date_independent_param_values, '') || ';'
                            || coalesce(:date_dep_param_values, '')
    where  d.RDB$DB_KEY = :td_dbkey;
  end
end
^

SET TERM ; ^

ALTER TABLE PERSON_DATA ALTER COLUMN ID_PERSON_DATA POSITION 1;

ALTER TABLE PERSON_DATA ALTER COLUMN FIRST_NAME POSITION 2;

ALTER TABLE PERSON_DATA ALTER COLUMN SURNAME POSITION 3;

ALTER TABLE PERSON_DATA ALTER COLUMN FAMILY_NAME POSITION 4;

ALTER TABLE PERSON_DATA ALTER COLUMN PERSON_NAME POSITION 5;

ALTER TABLE PERSON_DATA ALTER COLUMN PERSON_NAME2 POSITION 6;

ALTER TABLE PERSON_DATA ALTER COLUMN GUEST_CODE POSITION 7;

ALTER TABLE PERSON_DATA ALTER COLUMN COUNTRY_CODE POSITION 8;

ALTER TABLE PERSON_DATA ALTER COLUMN BIRTH_DAY POSITION 9;

ALTER TABLE PERSON_DATA ALTER COLUMN BIRTH_PLACE POSITION 10;

ALTER TABLE PERSON_DATA ALTER COLUMN BIRTHDAY_INTERNAL POSITION 11;

ALTER TABLE PERSON_DATA ALTER COLUMN EGN POSITION 12;

ALTER TABLE PERSON_DATA ALTER COLUMN PASS_NUM POSITION 13;

ALTER TABLE PERSON_DATA ALTER COLUMN PASS_DATE POSITION 14;

ALTER TABLE PERSON_DATA ALTER COLUMN PASS_EXP_DATE POSITION 15;

ALTER TABLE PERSON_DATA ALTER COLUMN PASS_PLACE POSITION 16;

ALTER TABLE PERSON_DATA ALTER COLUMN CITY POSITION 17;

ALTER TABLE PERSON_DATA ALTER COLUMN ADDRESS POSITION 18;

ALTER TABLE PERSON_DATA ALTER COLUMN SEX POSITION 19;

ALTER TABLE PERSON_DATA ALTER COLUMN MASK POSITION 20;

ALTER TABLE PERSON_DATA ALTER COLUMN ID_PASSPORT_TYPE POSITION 21;

ALTER TABLE PERSON_DATA ALTER COLUMN TITLE POSITION 22;

ALTER TABLE PERSON_DATA ALTER COLUMN FIRST_NAME_UTF POSITION 23;

ALTER TABLE PERSON_DATA ALTER COLUMN SURNAME_UTF POSITION 24;

ALTER TABLE PERSON_DATA ALTER COLUMN FAMILY_NAME_UTF POSITION 25;

ALTER TABLE PERSON_DATA ALTER COLUMN PERSON_NAME_UTF POSITION 26;

