/* Server version: WI-V6.3.7.18553 Firebird 2.1 
   SQLDialect: 3. ODS: 11.1. Forced writes: On. Sweep inteval: 20000.
   Page size: 8192. Cache pages: 2048 (16384 Kb). Read-only: False. */
SET NAMES NONE;

SET SQL DIALECT 3;

UPDATE RDB$RELATION_FIELDS SET RDB$FIELD_SOURCE='TTEXT_EXTENDED' WHERE RDB$FIELD_NAME='MSG' AND RDB$RELATION_NAME='PROFILE';

DROP VIEW ACCOUNT_PREVIEW;

/* Create view: ACCOUNT_PREVIEW */
CREATE VIEW ACCOUNT_PREVIEW(
ID_ACCOUNT,
ACCOUNT_NAME,
ID_PROFILE,
PROFILE_NAME,
PROFILE_TYPE,
ROOM_NAME,
ACCOUNT_CURR,
IS_CREDIT_ACCOUNT,
IS_BLOCKED,
IS_ARCHIVE,
ID_HOTEL,
NOTE)
 AS 
select A.ID_ACCOUNT,
       A.ACCOUNT_NAME,
       P.ID_PROFILE,
       P.PROFILE_NAME,
       P.PROFILE_TYPE,
       R.ROOM_NAME,
       A.ACCOUNT_CURR,
       A.IS_CREDIT_ACCOUNT,
       A.IS_BLOCKED,
       A.IS_ARCHIVE,
       A.ID_HOTEL,
       A.NOTE
from   ACCOUNT_S A
       join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
       left outer join RESERV_DETAIL RD ON RD.ID_RESERV_DETAIL = A.ID_RESERV_DETAIL
       left outer join ROOMS R on R.ID_ROOM = RD.ID_ROOM
;

DROP VIEW ENA_ACCOUNT;

/* Create view: ENA_ACCOUNT */
CREATE VIEW ENA_ACCOUNT(
ID_HOTEL,
ID_ACCOUNT,
ACCOUNT_NAME,
ACCOUNT_EXT_CODE,
PROFILE_ID,
PROFILE_NAME,
PROFILE_ACCOUNT_NO,
PROFILE_TYPE,
PROFILE_HOUSE_TYPE)
 AS 
select A.ID_HOTEL,
       a.ID_ACCOUNT,
       a.ACCOUNT_NAME,
       a.EXT_CODE,
       p.ID_PROFILE,
       p.PROFILE_NAME,
       p.ACCOUNT_NO,
       p.PROFILE_TYPE,
       (select ph.HOUSE_TYPE from PROFILE_HOUSE ph where ph.ID_PROFILE = p.ID_PROFILE)
from  ACCOUNT a
    join PROFILE p on p.ID_PROFILE = a.ID_PROFILE
;

COMMENT ON COLUMN ENA_ACCOUNT.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_ACCOUNT.ID_ACCOUNT IS
'  . .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_NAME IS
'   .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_EXT_CODE IS
'             .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ID IS
'         . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_NAME IS
'    .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ACCOUNT_NO IS
'             .  -    .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_TYPE IS
'       .  : AGENT -  , PERSON -  , HOUSE -    . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_HOUSE_TYPE IS
'      (PROFILE_TYPE = ''HOUSE''),    -.  : hptExternalClient -          ( ,      ); hptExternalRevenue -                (,   ..); hptComplimentary -           ,  ,        . .';

DROP VIEW ENA_RESERV_DETAIL;

/* Create view: ENA_RESERV_DETAIL */
CREATE VIEW ENA_RESERV_DETAIL(
ID_HOTEL,
ID_RESERV_DETAIL,
NUMBER,
ID_GUEST_MAIN,
GUEST_MAIN_NAME,
GUEST_MAIN_NAME2,
TITLE,
FROM_DATE,
TO_DATE,
NIGHTS,
ADULT_COUNT,
CHILD_COUNT,
ID_EATING_OBJECT,
CHECK_STATUS,
IS_ANUL,
ARRANGER_PROFILE_ID,
ARRANGER_PROFILE_NAME,
ARRANGER_PROFILE_TYPE,
ARRANGER_PROFILE_ACCOUNT_NO,
MARKET_SEGMENT_CODE,
MARKET_SOURCE_CODE,
MARKET_CHANNEL_CODE,
MARKET_HEAR_CODE,
MARKET_COME_CODE,
ROOM_TYPE,
ROOM_NAME,
RATE_NAME,
RESERV_PRICE,
PRICE_CURRENCY,
BOARD,
EMAIL,
NATIONALITY,
NOTE)
 AS 
select
rd.ID_HOTEL,
rd.ID_RESERV_DETAIL,
rd.NUMBER,
rd.ID_TITULAR,
pd.PERSON_NAME,
pd.PERSON_NAME2,
pd.TITLE,
rd.FROM_DATE,
rd.TO_DATE,
rd.TO_DATE - rd.FROM_DATE,
rd.ADULT_COUNT,
rd.CHILD_COUNT,
rd.ID_EATING_OBJECT,
rd.CHECK_STATUS,
rd.IS_ANUL,
rd.ID_AGENT_PROFILE,
(select p1.PROFILE_NAME from PROFILE p1 where p1.ID_PROFILE = rd.ID_AGENT_PROFILE),
(select p2.PROFILE_TYPE from PROFILE p2 where p2.ID_PROFILE = rd.ID_AGENT_PROFILE),
(select p3.ACCOUNT_NO from PROFILE p3 where p3.ID_PROFILE = rd.ID_AGENT_PROFILE),
(select M1.MARKET_CODE from NOM_MARKET_SEGMENTS M1 where m1.ID_NOM_MARKET_SEGMENT = rd.ID_NOM_MARKET_SEGMENT),
(select M2.SOURCE_CODE from NOM_SOURCE_CODES M2 where m2.ID_NOM_SOURCE_CODE = rd.ID_NOM_SOURCE_CODE),
(select M3.CHANNEL_CODE from NOM_CHANNEL_CODES M3 where m3.ID_NOM_CHANNEL_CODE = rd.ID_NOM_CHANNEL_CODE),
(select M4.HEAR_REASON_CODE from NOM_HEAR_REASONS M4 where m4.ID_NOM_HEAR_REASON = rd.ID_NOM_HEAR_REASON),
(select M5.COME_REASON_CODE from NOM_COME_REASONS M5 where m5.ID_NOM_COME_REASON = rd.ID_NOM_COME_REASON),
coalesce((select rrt.TYPE_ROOM from ROOM_TYPES rrt join ROOMS r on r.ID_ROOM_TYPE = rrt.ID_ROOM_TYPE where r.ID_ROOM = rd.ID_ROOM),
         (select rrt.TYPE_ROOM from ROOM_TYPES rrt join ROOM_MAP$EXC rmp on rmp.ID_ROOM_TYPE = rrt.ID_ROOM_TYPE where rmp.ID_ROOM = rd.ID_ROOM),
         (select rrt.TYPE_ROOM from ROOM_TYPES rrt where rrt.ID_ROOM_TYPE = rd.ID_ROOM_TYPE)),
(select r.room_name from rooms r where r.ID_ROOM = rd.ID_ROOM),
t.TARIFA_NAME,
rd.ROOM_PRICE,
rd.ROOM_CURRENCY,
M.NAME,
(select p.EMAIL
 from   PROFILE P
 where  p.ID_PROFILE = rd.ID_PERSON_PROFILE) as EMAIL,
rd.COUNTRY,
rd.NOTE
from RESERV_DETAIL rd
    join GUEST g on g.ID_GUEST = rd.ID_TITULAR
    join GUEST_DATA gd on gd.ID_GUEST = g.ID_GUEST
    join PERSON_DATA pd on pd.ID_PERSON_DATA = gd.ID_PERSON_DATA
    join TARIFA T on t.ID_TARIFA = rd.ID_RATE
    join MEALS M on M.ID_BOARD = rd.ID_BOARD
;

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_RESERV_DETAIL IS
'   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NUMBER IS
'  .    (   ). .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_GUEST_MAIN IS
'      .      .  -     .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME IS
'    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME2 IS
'       . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.FROM_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.TO_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NIGHTS IS
'. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ADULT_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHILD_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_EATING_OBJECT IS
'          . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHECK_STATUS IS
'  . -3 =  ; -2 =   ; -1 =  ; 0 =  ; 1 =  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.IS_ANUL IS
'   . 0 - , 1 - .  -       0  1.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ID IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_NAME IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_TYPE IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ACCOUNT_NO IS
'             .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SEGMENT_CODE IS
'   ''segment''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SOURCE_CODE IS
'   ''source''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_CHANNEL_CODE IS
'   ''channel''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_HEAR_CODE IS
'   ''hear reason''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_COME_CODE IS
'   ''come reason''.   . .';

/* Create Views... */
/* Create view: CHECK_STATUS_GRANTED */
CREATE VIEW CHECK_STATUS_GRANTED(
CHECK_STATUS)
 AS 
select first 1 cast(-3 as smallint) as granted_status
from   USER_RIGHTS ur
where  ur.RIGHT_CODE = 'WAITING_RESERV_PREVIEW'
union
select -2 from RDB$DATABASE
union
select -1 from RDB$DATABASE
union
select 0 from RDB$DATABASE
union
select first 1 cast(1 as smallint)
from   USER_RIGHTS ur
where  ur.RIGHT_CODE = 'CHECKEDOUT_RESERV_PREVIEW'
;


COMMENT ON COLUMN ENA_ACCOUNT.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_ACCOUNT.ID_ACCOUNT IS
'  . .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_NAME IS
'   .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_EXT_CODE IS
'             .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ID IS
'         . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_NAME IS
'    .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ACCOUNT_NO IS
'             .  -    .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_TYPE IS
'       .  : AGENT -  , PERSON -  , HOUSE -    . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_HOUSE_TYPE IS
'      (PROFILE_TYPE = ''HOUSE''),    -.  : hptExternalClient -          ( ,      ); hptExternalRevenue -                (,   ..); hptComplimentary -           ,  ,        . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_HOTEL IS
'       .  ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_ACCOUNT_POST_HISTORY IS
'   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_ACCOUNT IS
'      .  ENA_ACCOUNT.ID_ACCOUNT. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_SERVICE IS
'   .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_SALE_TAXATION IS
'         .       . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.SYSTEM_DATE IS
'    / . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_DATE IS
'        (). .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_CURR IS
'  . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_AMOUNT IS
'    (   )    . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.NAT_NET_VALUE IS
'    ( )   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.NAT_GROSS_VALUE IS
'    ( )   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_TYPE IS
'  . BASE -  ; ADD_INS -  - ,    ; EXTRA -     ,     ; TAX -            ,     .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_GUEST IS
'       .  ENA_GUEST.ID_GUEST.        : 1.    "  "; 2.           ; 3.        ,      . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_GROUP IS
'       .    : ''ROOMS'', ''Food and Beverage'', ''Other Operated Departments'', ''Rentals and Other Income''. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_ACCOUNT IS
' -      .    . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_SUB_ACCOUNT IS
' --      . ,     -. .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.ID_HOTEL IS
'   ,    . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.ID_DOC_HEAD IS
'        .  ENA_DOC_HEAD_ADVANCE.ID_DOC. .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.SYSTEM_DATE IS
'      . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAYMENT_DATE IS
'     . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.SRC_ID_ACCOUNT IS
'   . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.DEST_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAY_AMOUNT IS
' .        . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAY_CURRENCY IS
' . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.USER_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.DATETIME_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_HOTEL IS
'   ,    . .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_DEPOSIT_PAYMENT IS
'  .         . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_DATE IS
'        .            . .';

COMMENT ON COLUMN ENA_DEPOSIT.SYSTEM_DATE IS
'   .         PAYMENT_DATE.        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_NUM IS
'           .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_DIRECTION IS
'0 -   , 1 -   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_TYPE_NAME IS
'       .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_ACCOUNT IS
'        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_AMOUNT IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DEPOSIT.IS_ANUL IS
'   . 0 - , 1 - .           /    .     IS_ANUL = 0,    1.           ID_DEPOSIT.  .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_CREATED IS
'     .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_CREATED IS
'       . .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_ANNUL IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_ANNUL IS
'     .  .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.ID_HOTEL IS
'       .  .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.ID_DEPOSIT_PAYMENT IS
'   ,   .  ENA_DEPOSIT.ID_DEPOSIT_PAYMENT. .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SYSTEM_DATE IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAYMENT_DATE IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SRC_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DEST_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAY_AMOUNT IS
' .        . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAY_CURRENCY IS
' . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.USER_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DATETIME_CREATED IS
'     . .';

COMMENT ON VIEW ENA_DOC_DEPOSIT_CONSUMPTION IS
' !!!!!!    ID_DOC_TYPE - za mapowe.';


COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.DOC_TYPE_NAME IS
'       . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_NUM IS
'         .  .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_DATE IS
'      .          . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_VALUE IS
'         . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_DOC_RATE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.EQUAL_DOC_VALUE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.NAT_VALUE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.ID_DEPOSIT_PAYMENT IS
'      (  ENA_DEPOSIT.ID_DEPOSIT_PAYMENT ). .';

COMMENT ON VIEW ENA_DOC_HEAD_ADVANCE IS
'!      ';


COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC IS
'  .             .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_ADVANCE.ID_DOC.  .     - , ..       ,      - .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SUB_TYPE IS
'   . ,  : 0 - / , 1 -  ,  , 2 -  ,  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_NAME IS
'    . ,       .              .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_DESCRIPTION IS
'   .         .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_NUM IS
'   ,        .      . ,     ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DATE IS
'        . .    SYSTEM_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.IS_ANUL IS
'        . . 0 - , 1 - .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TOTAL_VALUE IS
' (, )       . .      .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ONE_LINE_TEXT IS
' ,         .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURR_RATE IS
'   ()    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_POST_ADDRESS IS
'    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_ZIP_CODE IS
'     ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_MOL IS
'    ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_RECIPIENT_NAME IS
'     ()';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BANK_NAME IS
'  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BIC IS
'BIC  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IBAN IS
'IBAN  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_EMAIL IS
'email  .        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SUPPLIER_SEND_NAME IS
'     .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ACCOUNT_ID IS
'        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC IS
'  .             .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_SERVICE.ID_DOC.     - , ..       ,      - .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC_TYPE IS
'    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SUB_TYPE IS
'   .  : 0 - / , 1 -  ,  , 2 -  ,  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_NAME IS
'    .              .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_DESCRIPTION IS
'   .         .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_NUM IS
'   ,        .      .  -       ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DATE IS
'        .    SYSTEM_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.IS_ANUL IS
'        . 0 - , 1 - .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_CURRENCY IS
'  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TOTAL_VALUE IS
' (, )       .      .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ONE_LINE_TEXT IS
' ,         .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURR_RATE IS
'   ()    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_DATE IS
'   ,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_NUM IS
'  -,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_POST_ADDRESS IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_ZIP_CODE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_MOL IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_RECIPIENT_NAME IS
'     (). .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BANK_NAME IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BIC IS
'BIC  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IBAN IS
'IBAN  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_EMAIL IS
'email  .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SUPPLIER_SEND_NAME IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ACCOUNT_ID IS
'        .    ENA_ACCOUNT.ID_ACCOUNT. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_SERVICE IS
'     .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.DATE_POST IS
'    . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_SERVICE IS
'      .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_SERVICE IS
'   .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.IS_CORRECT IS
'            .      1,        . 0 -   ; 1 -      0. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_GUEST IS
'   ,        .    null,       ''  ''     .    ENA_GUEST.ID_GUEST. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.DATE_POST IS
'        .    ,    . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ROOM_NAME IS
'       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ACCOUNT_PRICE IS
'         /.             /. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_SERVICE IS
'    (, , , ,  ).  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_SALE_TAXATION IS
'         .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON VIEW ENA_DOC_PAYMENT IS
'   ,     .';


COMMENT ON COLUMN ENA_DOC_PAYMENT.ID_DOC_HEAD IS
'  ( ENA_DOC_HEAD.ID_DOC)      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DOC_TYPE_NAME IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_NUM IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_DATE IS
'     .        ,                 . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_CURRENCY IS
'  .        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DUE_DATE IS
'       .          ,      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_VALUE IS
'           . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_DOC_RATE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.EQUAL_DOC_VALUE IS
'      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.NAT_VALUE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.ID_DOC_HEAD IS
'         . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNT_VALUE IS
'      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNTABLE_VALUE IS
'  .       . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.IS_PERCENT_DISCOUNT IS
'  .         . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.FIXED_DISCOUNT_CURRENCY IS
'  .       -     . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNT_PERCENT_OR_AMOUNT IS
'  .       . .';

COMMENT ON COLUMN ENA_DOC_TAX.ID_DOC_HEAD IS
'         ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_TAX.ID_SALE_TAX IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.NONTAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_VALUE IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_NAME IS
'  .  -        .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_PERCENT IS
'   ().  .';

COMMENT ON COLUMN ENA_DOC_TAX.FISCAL_CODE IS
' .        .  -      .';

COMMENT ON COLUMN ENA_DOC_TAX.ACCOUNT_NAME IS
' .              . .';

COMMENT ON VIEW ENA_GUEST IS
'!!! .    (    )';


COMMENT ON COLUMN ENA_GUEST.ID_GUEST IS
'   ( )   . .';

COMMENT ON COLUMN ENA_GUEST.ID_RESERV_DETAIL IS
'        ( ENA_RESERV_DETAIL.ID_RESERV_DETAIL). .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME2 IS
'      . .';

COMMENT ON COLUMN ENA_GUEST.IS_CHILD IS
'   . 0 - ; 1 - . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE IS
'    . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_TEXT IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.RATING_AGE IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.COUNTRY_CODE IS
'    .        ISO. .';

COMMENT ON COLUMN ENA_GUEST.MASK IS
'  .         . .';

COMMENT ON COLUMN ENA_HOTEL.ID_HOTEL IS
'  . .';

COMMENT ON COLUMN ENA_HOTEL.HOTEL_NAME IS
'  . .';

COMMENT ON COLUMN ENA_HOTEL.CODE IS
'   . .';

COMMENT ON COLUMN ENA_HOTEL.SYSTEM_DATE IS
'     .                  ENA.                . .';

COMMENT ON COLUMN ENA_HOTEL.IS_USE IS
'    (  ). 0 -   , 1 -  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_RESERV_DETAIL IS
'   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NUMBER IS
'  .    (   ). .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_GUEST_MAIN IS
'      .      .  -     .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME IS
'    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME2 IS
'       . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.FROM_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.TO_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NIGHTS IS
'. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ADULT_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHILD_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_EATING_OBJECT IS
'          . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHECK_STATUS IS
'  . -3 =  ; -2 =   ; -1 =  ; 0 =  ; 1 =  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.IS_ANUL IS
'   . 0 - , 1 - .  -       0  1.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ID IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_NAME IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_TYPE IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ACCOUNT_NO IS
'             .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SEGMENT_CODE IS
'   ''segment''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SOURCE_CODE IS
'   ''source''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_CHANNEL_CODE IS
'   ''channel''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_HEAR_CODE IS
'   ''hear reason''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_COME_CODE IS
'   ''come reason''.   . .';

COMMENT ON COLUMN ENA_SERVICES.ID_HOTEL IS
'       . .';

COMMENT ON COLUMN ENA_SERVICES.ID_SERVICE IS
'   . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_NAME IS
'  . .';

COMMENT ON COLUMN ENA_SERVICES.GROUP_NAME IS
'    .            a       . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_TYPE IS
'  .  : ''BASE'',''EXTRA'',''COMMISSION'',''MEAL''. ''BASE'' -    ,     ,''EXTRA'' -  , ''MEAL'' - , ''COMMISSION'' - ,        (  ). .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_GROUP IS
'       .  : ''ROOMS'', ''Food and Beverage'', ''Other Operated Departments'', ''Rentals and Other Income''. .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_ACCOUNT IS
' -      . .';

COMMENT ON COLUMN ENA_SERVICES.ACCOUNT_NAME IS
'      (. ),      .          . .';

COMMENT ON COLUMN ENA_SERVICES.EXT_CODE IS
'         . .';

COMMENT ON COLUMN ENA_SERVICES.IS_BREAKFAST IS
'   . 0 - , 1 - .    1,   SERVICE_TYPE e ''BASE''  ''MEAL''.  -          .';

COMMENT ON COLUMN ENA_SERVICES.IS_LUNCH IS
'   .   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_DINNER IS
'   .   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_EXTRAFOOD1 IS
'     1.   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_EXTRAFOOD2 IS
'     2.   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.ID_ROOM_TYPE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ). .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  -             .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM_EXT_CODE IS
'    ( )     ,      .  -        .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_STAY_CODE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  : ''ALONE'' -      , ''BED'' -            , ''EXTRA_BED'' -      . .';

COMMENT ON COLUMN OWNER_POST.POST_STATUS IS
'11  
22  ';

/*  Empty ALLOTMENT_AGENT_GET for ALLOTMENT_GET$INT(param list change)  */
SET TERM ^ ;

ALTER PROCEDURE ALLOTMENT_AGENT_GET(FROM_DATE DATE,
TO_DATE DATE,
IN_ID_ROOM_TYPE INTEGER,
IN_ID_AGENT INTEGER,
INFO_TYPE VARCHAR(40),
MIND_RELEASE_DATES SMALLINT)
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ROOM_TYPE VARCHAR(50),
CNT_ROOMS INTEGER,
IS_DEFINED INTEGER,
IS_RELEASED INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty ALLOTMENT_GET for ALLOTMENT_GET$INT(param list change)  */
ALTER PROCEDURE ALLOTMENT_GET(ID_ALLOTMENT INTEGER,
ID_HOTEL INTEGER)
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ROOM_TYPE VARCHAR(30),
CNT_DEFINED INTEGER,
CNT_BOOKED INTEGER,
ACTIVE_FRAME_BEGIN INTEGER,
IS_DEFINED INTEGER,
IS_RELEASED INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty ALLOTMENT_GET$INT for ALLOTMENT_GET$INT(param list change)  */
ALTER PROCEDURE ALLOTMENT_GET$INT(ID_ALLOTMENT INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ROOM_TYPE_FILTER INTEGER,
OPTIONS VARCHAR(255),
HOTELS VARCHAR(20) = '')
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ROOM_TYPE VARCHAR(30),
ID_HOTEL INTEGER,
CNT_DEFINED INTEGER,
CNT_BOOKED INTEGER,
ACTIVE_FRAME_BEGIN INTEGER,
IS_DEFINED INTEGER,
GRP_TAG INTEGER,
IS_RELEASED INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty ALLOTMENT_OVERBOOK_GET for ALLOTMENT_GET$INT(param list change)  */
ALTER PROCEDURE ALLOTMENT_OVERBOOK_GET(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER)
 RETURNS(FOR_DATE DATE,
ROOM_TYPE VARCHAR(30),
ROOM_TYPE2 VARCHAR(30),
QTY_ALLOW INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty AVAILABILITY_OCCUPANCY$INT for ALLOTMENT_GET$INT(param list change)  */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$INT(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
 BEGIN EXIT; END
^

/*  Empty SUMMARY_OCCUPANCY_STATISTIC$INT for ALLOTMENT_GET$INT(param list change)  */
ALTER PROCEDURE SUMMARY_OCCUPANCY_STATISTIC$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
 BEGIN EXIT; END
^

/*  Empty AVAILABILITY_OCCUP_PREPARE$AVL for AVAILABILITY_OCCUPANCY_OPT$AVL(param list change)  */
ALTER PROCEDURE AVAILABILITY_OCCUP_PREPARE$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS INTEGER,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
 BEGIN EXIT; END
^

/*  Empty AVAILABILITY_OCCUPANCY_OPT$AVL for AVAILABILITY_OCCUPANCY_OPT$INT(param list change)  */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY_OPT$AVL(ID_OCCUPANCY_SESSION INTEGER,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER)
 AS
 BEGIN EXIT; END
^

/*  Empty AVAILABILITY_OCCUPANCY_PREPARE for AVAILABILITY_OCCUPANCY_OPT$INT(param list change)  */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY_PREPARE(FROM_DATE DATE,
TO_DATE DATE,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty IMPORT_AGENT_PROFILE$EXC for IMPORT_COMMON_PROFILE$EXC(param list change)  */
ALTER PROCEDURE IMPORT_AGENT_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
AGENT_GROUP VARCHAR(50),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
WBE_PASSWORD VARCHAR(20),
IATA_NUMBER VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
DEF_CONTRAGENT_NAME VARCHAR(100),
THRESHOLD_NOTE VARCHAR(255),
THRESHOLD_AMOUNT NUMERIC(15,4),
THRESHOLD_CURR CHAR(3),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
 BEGIN SUSPEND; END
^

/*  Empty IMPORT_PERSON_PROFILE$EXC for IMPORT_COMMON_PROFILE$EXC(param list change)  */
ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(255),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
 BEGIN SUSPEND; END
^

/*  Empty CREATE_BOOKING$WBE for IMPORT_PERSON_PROFILE$EXC(param list change)  */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
 BEGIN SUSPEND; END
^

/*  Empty CREATE_SESSION_BOOKINGS$WBE for IMPORT_PERSON_PROFILE$EXC(param list change)  */
ALTER PROCEDURE CREATE_SESSION_BOOKINGS$WBE(WBE_SESSION_ID BIGINT,
ARANGER_ID INTEGER,
LANG_CODE VARCHAR(3))
 RETURNS(SELECTION_ID VARCHAR(20),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/*  Empty EAI_IMPORT_ALOYALTY_CLIENT for IMPORT_PERSON_PROFILE$EXC(param list change)  */
ALTER PROCEDURE EAI_IMPORT_ALOYALTY_CLIENT(CLIENT_UUID VARCHAR(40),
CLIENT_NAME VARCHAR(100),
CARD_CODE VARCHAR(50),
IS_ARHIVE SMALLINT,
DATE_OF_BIRTH DATE)
 AS
 BEGIN EXIT; END
^

/*  Empty PROFILE_AGENT_MODIFY$PROFILE for PROFILE_COMMON_MODIFY$INT(param list change)  */
ALTER PROCEDURE PROFILE_AGENT_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
IS_ARCHIVE INTEGER,
AGENT_GROUP VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IATA_NUMBER VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null,
THRESHOLD_NOTE VARCHAR(255) = null,
THRESHOLD_AMOUNT NUMERIC(15,4) = null,
THRESHOLD_CURR CHAR(3) = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty PROFILE_HOUSE_MODIFY$PROFILE for PROFILE_COMMON_MODIFY$INT(param list change)  */
ALTER PROCEDURE PROFILE_HOUSE_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(20),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
IS_ARCHIVE INTEGER,
HOUSE_TYPE VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty PROFILE_PERSON_MODIFY$PROFILE for PROFILE_COMMON_MODIFY$INT(param list change)  */
ALTER PROCEDURE PROFILE_PERSON_MODIFY$PROFILE(ID_PROFILE INTEGER,
ID_GUEST_TYPE INTEGER,
PROFILE_NAME VARCHAR(100),
PERSON_NAME2 VARCHAR(100),
SEX CHAR,
BIRTH_DAY DATE,
BIRTH_PLACE VARCHAR(30),
EGN VARCHAR(30),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
COUNTRY_CODE VARCHAR(20),
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
MASK VARCHAR(10),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(255),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
IS_ARCHIVE INTEGER,
ID_PHOTO INTEGER,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
TITLE VARCHAR(10) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure ALLOTMENT_GET$INT with new param-list */
ALTER PROCEDURE ALLOTMENT_GET$INT(ID_ALLOTMENT INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ROOM_TYPE_FILTER INTEGER,
OPTIONS VARCHAR(255),
HOTELS VARCHAR(255) = '')
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ROOM_TYPE VARCHAR(30),
ID_HOTEL INTEGER,
CNT_DEFINED INTEGER,
CNT_BOOKED INTEGER,
ACTIVE_FRAME_BEGIN INTEGER,
IS_DEFINED INTEGER,
GRP_TAG INTEGER,
IS_RELEASED INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure AVAILABILITY_OCCUPANCY_OPT$AVL with new param-list */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY_OPT$AVL(ID_OCCUPANCY_SESSION INTEGER,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
GENERALIZE_CONT_REMAINS SMALLINT = 0)
 AS
 BEGIN EXIT; END
^

/* Alter empty procedure AVAILABILITY_OCCUPANCY_OPT$INT with new param-list */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY_OPT$INT(RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
GENERALIZE_CONT_REMAINS SMALLINT = 0)
 AS
 BEGIN EXIT; END
^

/* Alter empty procedure IMPORT_COMMON_PROFILE$EXC with new param-list */
ALTER PROCEDURE IMPORT_COMMON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
LOOKUP_BY_NAME SMALLINT,
PROFILE_NAME_NEW VARCHAR(100),
PHONE_NEW VARCHAR(50),
FAX_NEW VARCHAR(50),
EMAIL_NEW VARCHAR(50),
CITY_NEW VARCHAR(100),
ADDRESS_NEW VARCHAR(100),
MARKET_SEGMENT_NEW VARCHAR(30),
NOTE_NEW VARCHAR(255),
IS_ARCHIVE_NEW SMALLINT,
WBE_PASSWORD_NEW VARCHAR(20),
ACCOUNT_NO_NEW VARCHAR(20),
MSG_NEW VARCHAR(2000),
PROFILE_TYPE VARCHAR(50),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
ID_BONUSPOINT_SCHEME INTEGER,
ID_DEF_CONTRAGENT INTEGER,
WBE_PASSWORD VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(2000),
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure IMPORT_PERSON_PROFILE$EXC with new param-list */
ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(2000),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure PROFILE_AGENT_MODIFY$PROFILE with new param-list */
ALTER PROCEDURE PROFILE_AGENT_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
IS_ARCHIVE INTEGER,
AGENT_GROUP VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IATA_NUMBER VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null,
THRESHOLD_NOTE VARCHAR(255) = null,
THRESHOLD_AMOUNT NUMERIC(15,4) = null,
THRESHOLD_CURR CHAR(3) = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure PROFILE_COMMON_MODIFY$INT with new param-list */
ALTER PROCEDURE PROFILE_COMMON_MODIFY$INT(ID_PROFILE INTEGER,
PROFILE_TYPE VARCHAR(20),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
IS_ARCHIVE INTEGER,
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure PROFILE_PERSON_MODIFY$PROFILE with new param-list */
ALTER PROCEDURE PROFILE_PERSON_MODIFY$PROFILE(ID_PROFILE INTEGER,
ID_GUEST_TYPE INTEGER,
PROFILE_NAME VARCHAR(100),
PERSON_NAME2 VARCHAR(100),
SEX CHAR,
BIRTH_DAY DATE,
BIRTH_PLACE VARCHAR(30),
EGN VARCHAR(30),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
COUNTRY_CODE VARCHAR(20),
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
MASK VARCHAR(10),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
IS_ARCHIVE INTEGER,
ID_PHOTO INTEGER,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
TITLE VARCHAR(10) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_ADD$INT for: ACCOUNT_CHECK_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_POSTING_ADD$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_GUEST /* TYPE OF ID_REF */ INTEGER,
ID_SECQUENCE /* TYPE OF ID_REF */ INTEGER,
DATE_POST /* TYPE OF TDATE */ DATE,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_TARIFF /* TYPE OF ID_REF */ INTEGER,
ID_ROOM /* TYPE OF ID_REF */ INTEGER,
IS_BASE /* TYPE OF TLOGICAL */ SMALLINT,
QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
ORIG_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
RATE /* TYPE OF TRATE */ NUMERIC(15,6),
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
CHANGED_TEXT /* TYPE OF TTEXT_SHORT */ VARCHAR(30),
ID_MASTER_ADDINS_ACC_POST /* TYPE OF ID_REF */ INTEGER,
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
NEW_ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE$INT for: ACCOUNT_CHECK_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE$INT(AP_DBKEY /* TYPE OF TDB_KEY */ CHAR(8),
ID_SERVICE /* TYPE OF ID_REF */ INTEGER,
ID_TARIFF /* TYPE OF ID_REF */ INTEGER,
ID_ROOM /* TYPE OF ID_REF */ INTEGER,
QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
QTY_FREE /* TYPE OF TQTY */ NUMERIC(15,2),
PRICE /* TYPE OF TVALUE */ DOUBLE PRECISION,
CURR /* TYPE OF TCURRENCY */ CHAR(3),
RATE /* TYPE OF TRATE */ NUMERIC(15,6),
CHANGED_TEXT VARCHAR(40),
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
IS_CONSEQUENTIAL_UPDATE /* TYPE OF TBOOLEAN */ SMALLINT = 0,
RE_ROUTE_ACCOUNT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(OUT_QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
OUT_PRICE_POST /* TYPE OF TVALUE */ DOUBLE PRECISION,
OUT_AC VARCHAR(2))
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_CHECK_CREDIT_STATUS$INT) */
ALTER PROCEDURE ACCOUNT_CHECK_CREDIT_STATUS$INT(ID_ACCOUNT TYPE OF ID_REF,
POST_VALUE TYPE OF TPRICE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_credit_account integer;
  declare variable id_reserv_detail integer;
  declare variable credit_limit tprice;
  declare variable b_post_sum tprice;
  declare variable b_pay_sum tprice;
  declare variable difference_value tprice;
  declare variable no_use varchar(255);
  declare variable account_currency tcurrency;
  declare variable round_to numeric(15,4);
begin
  if (:POST_VALUE = 0) then exit;

  select a.IS_CREDIT_ACCOUNT, a.CREDIT_LIMIT, a.ID_RESERV_DETAIL
  from   ACCOUNT A
  where  a.ID_ACCOUNT = :ID_ACCOUNT
  into   :is_credit_account, :credit_limit, :id_reserv_detail;

  if (:is_credit_account = 0
      and exists (select rd.ID_RESERV_DETAIL
                  from   RESERV_DETAIL rd
                  where  rd.ID_RESERV_DETAIL = :id_reserv_detail
                         and rd.CHECK_STATUS = 1)) then
  begin
    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, :credit_limit, 1);
  end

  if (coalesce(:credit_limit, 0) > 0) then begin
    /* FIND BALANCE OF ACCOUNT */
    execute procedure ACCOUNT_BALANCE$INT(:id_account)
    returning_values  :account_currency, :round_to, :no_use, :b_post_sum, :b_pay_sum, :no_use, :no_use;
    b_post_sum = coalesce(:b_post_sum, 0);
    b_pay_sum  = coalesce(:b_pay_sum, 0);

    /* IS THIS POST IS IN LIMIT */
    if ((:b_post_sum + :POST_VALUE) > :credit_limit) then begin
      err_code = -13; /*  */
      difference_value = :b_post_sum + :POST_VALUE - :credit_limit;
      err_text = f_character(29)||FormatFloat(:credit_limit, :round_to)||' '||:account_currency||
                 f_character(28)||FormatFloat(:difference_value, :round_to);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_ACCOUNT$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
QTY /* TYPE OF TQTY */ NUMERIC(15,2),
ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
DATE_POST /* TYPE OF TDATE */ DATE,
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ROOM /* TYPE OF ID */ INTEGER = null,
POST_DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_GUEST$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ACCOUNT_ROUTING /* TYPE OF TSHORT_CODE */ VARCHAR(10),
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_TAR_CALC_REPOST$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE RES_TAR_CALC_REPOST$INT(ID_TAR_CALC /* TYPE OF ID_REF */ INTEGER,
ID_RESERV_DETAIL /* TYPE OF ID_REF */ INTEGER,
RECALC_MARKER VARCHAR(40))
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_ADD$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_ADD$INT(ID_ACCOUNT TYPE OF ID,
ID_GUEST TYPE OF ID_REF,
ID_SECQUENCE TYPE OF ID_REF,
DATE_POST TYPE OF TDATE,
ID_SERVICE TYPE OF ID,
ID_TARIFF TYPE OF ID_REF,
ID_ROOM TYPE OF ID_REF,
IS_BASE TYPE OF TLOGICAL,
QTY_POST TYPE OF TQTY,
PRICE TYPE OF TPRICE,
ORIG_CURRENCY TYPE OF TCURRENCY,
RATE TYPE OF TRATE,
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
POST_TEXT TYPE OF TDESCRIPTION_SHORT,
RESOURCE_TEXT TYPE OF TREASON,
CHANGED_TEXT TYPE OF TTEXT_SHORT,
ID_MASTER_ADDINS_ACC_POST TYPE OF ID_REF,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
NEW_ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable price_post double precision;
  declare variable post_rate numeric (15, 6);
  declare variable curr_post char(3);
  declare variable account_currency char(3);
  declare variable id_pack_service integer;
  declare variable id_room_type integer;
  declare variable room_name varchar(30);
  declare variable is_archive integer;
  declare variable id_tax_policy integer;
  declare variable id_sale_taxation integer;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable check_option varchar(255);
  declare variable id_hotel integer;
  declare variable id_srv_hotel integer;
  declare variable service_name varchar(30);
  declare variable account_name varchar(50);
begin
  ID_GUEST = nullif(:ID_GUEST, -1);

  execute procedure POST_PRICE_CHECK$INT (:QTY_POST, :PRICE, :ORIG_CURRENCY);

  if ( (:IS_BASE = 1) or (:ID_MASTER_ADDINS_ACC_POST > 0) ) then
    check_option = 'IS_BASE;ALLOW_POSTING';
  else
    check_option = 'IS_EXTRA;ALLOW_POSTING';

  execute procedure ACCOUNT_VALIDATE$INT(:id_account, :check_option)
  returning_values  (:err_code, :err_text, :account_currency, :id_tax_policy, :id_hotel, :account_name);
  if (:err_code < 0) then EXIT; --  exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;

  select s.ID_HOTEL, s.SERVICE_NAME
  from   SERVICES S
  where  s.ID_SERVICE = :ID_SERVICE
  into   :id_srv_hotel, :service_name;

  if (:id_srv_hotel is distinct from :id_hotel) then
    exception POSTING_EXCEPTION '-1056' || f_character(31) || f_character(29) || :service_name || f_character(28) || :account_name;

  if (:rate is null) then begin
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :orig_currency, :date_post, :id_guest)
    returning_values  :rate;
  end

  curr_post  = :account_currency;
  if (:orig_currency = :account_currency) then begin
    post_rate  = :rate;
  end else begin
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :account_currency, :date_post, :id_guest)
    returning_values  :post_rate;
  end

  execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :id_tax_policy, :ID_TARIFF, :DATE_POST - :FROM_DATE)
  returning_values (:id_sale_taxation);

  execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:QTY_POST, :PRICE,
                    :RATE, :post_rate, :id_sale_taxation)
  returning_values  :price_post, :post_net_value, :post_gross_value;

  execute procedure ACCOUNT_CHECK_CREDIT_STATUS$INT (:ID_ACCOUNT, :price_post * :QTY_POST)
  returning_values (:ERR_CODE, :ERR_TEXT);
  if (:ERR_CODE <> 0) then exit;

  --
  new_id_account_post = gen_id (id_account_post_gen, 1);

  if (:post_text starting with 'PACK') then begin
    id_pack_service = substring(:post_text from 6 for 20);
    post_text = '';
  end else begin
    id_pack_service = -1;
  end
  if (:is_base = 1) then id_master_addins_acc_post = :new_id_account_post;

  select R.ROOM_NAME, R.ID_ROOM_TYPE
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :room_name, :id_room_type;

  if (:id_guest is null) then begin
    is_archive = 1;
  end else begin
    select iif(G.CHECK_STATUS = 1, 1, 0)
    from   GUEST G
    where  G.ID_GUEST = :id_guest
    into   :is_archive;
  end

  insert into ACCOUNT_POST (
    ID_ACCOUNT_POST, ID_ACCOUNT, ID_GUEST, ID_SERVICE, ID_TARIFF, ID_ROOM,
    IS_BASE, DATE_POST, QTY_POST, QTY_FREE, PRICE_POST, POST_NET_VALUE, POST_GROSS_VALUE, CURR_POST, RATE_POST,
    PRICE_ORIG, CURR_ORIG, RATE_ORIG, IS_LOCKED_FOR_UPDATE, TO_DATE, FROM_DATE, ID_SEQUENCE,
    SHORT_CODE, CHANGED_TEXT, ID_MASTER_ADDINS_ACC_POST, ID_PACK_SERVICE, ROOM_NAME, ID_ROOM_TYPE,
    ID_SALE_TAXATION, AC, IS_ARCHIVE, IN_DOC_QTY, IN_DOC_VALUE, DESCRIPTION)
  values (
    :new_id_account_post, :id_account, :id_guest, :id_service, :id_tariff, coalesce(:id_room, -1),
    :is_base, :date_post, :qty_post, 0, :price_post, :post_net_value, :post_gross_value, :curr_post, :post_rate,
    :price, :orig_currency, :rate, 0, :TO_DATE, :FROM_DATE, :id_secquence,
    :short_code, :changed_text, :id_master_addins_acc_post, :id_pack_service, :room_name, :id_room_type,
    :id_sale_taxation, '00', :is_archive, 0, 0, :DESCRIPTION);

  if ((coalesce(:post_text, '') <> '') or (coalesce(:resource_text, '') <> '')) then begin
    insert into ACCOUNT_POSTING_DET (ID_ACCOUNT_POST, POST_TEXT, QTY, FROM_DATETIME, TO_DATETIME, RESOURCE_TEXT)
    values (:new_id_account_post, :post_text, :qty_post, :FROM_DATE, :TO_DATE, :resource_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_TRANSFER$INT for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER,
IS_MANUAL_TRANSFER /* TYPE OF TLOGICAL */ SMALLINT = 1)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE_PERC for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_PERC(IN_ID_ACCOUNT_POST VARCHAR(4000),
IN_PERC NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(30))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_POSTING$INT for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_POSTING$INT(ID_RESOURCE_RESERVATION /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
PRICE_DESCRIPTION /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
ID_RESERV_DETAIL /* TYPE OF ID */ INTEGER,
ID_EXTERNAL_CLIENT_ACCCOUNT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(DOC_SELECTED /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_POSTING_UPDATE$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE$INT(AP_DBKEY TYPE OF TDB_KEY,
ID_SERVICE TYPE OF ID_REF,
ID_TARIFF TYPE OF ID_REF,
ID_ROOM TYPE OF ID_REF,
QTY_POST TYPE OF TQTY,
QTY_FREE TYPE OF TQTY,
PRICE TYPE OF TVALUE,
CURR TYPE OF TCURRENCY,
RATE TYPE OF TRATE,
CHANGED_TEXT VARCHAR(40),
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
IS_CONSEQUENTIAL_UPDATE TYPE OF TBOOLEAN = 0,
RE_ROUTE_ACCOUNT TYPE OF ID_REF = null)
 RETURNS(OUT_QTY_POST TYPE OF TQTY,
OUT_PRICE_POST TYPE OF TVALUE,
OUT_AC VARCHAR(2))
 AS
declare variable date_post date;
  declare variable orig_is_base integer;
  declare variable orig_id_service integer;
  declare variable orig_id_room integer;
  declare variable orig_short_code varchar(255);
  declare variable orig_qty_post integer;
  declare variable orig_ac varchar(2);
  declare variable is_locked_for_update integer;
  declare variable orig_locked_for_update integer;
  declare variable orig_id_tariff integer;
  declare variable orig_id_guest integer;
  declare variable id_type_stay integer;
  declare variable id_room_type integer;
  declare variable id_board integer;
  declare variable id_pack_service integer;
  declare variable new_id_pack_service integer;
  declare variable post_currency char(3);
  declare variable room_name varchar(30);
  declare variable original_post varchar(30);
  declare variable new_ac varchar(2);
  declare variable orig_in_doc_qty numeric(15,2);
  declare variable orig_in_doc_value double precision;
  declare variable rate_post numeric(15,6);
  declare variable id_base_doc integer;
  declare variable id_tax_policy integer;
  declare variable price_post double precision;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable id_sale_taxation integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable orig_price_post tprice;
  declare variable round_to numeric(15,4);
  declare variable account_name tobject_name;
  declare variable err_code integer;
  declare variable err_text varchar(100);
  declare variable id_account integer;
  declare variable orig_id_master_addins_acc_post integer;
  declare variable check_options varchar(255);
begin
  /* GET DATA */
  original_post = '';
  new_id_pack_service = null;

  select AP.DATE_POST, AP.IS_BASE, AP.ID_SERVICE, AP.ID_BASE_DOC,
         AP.SHORT_CODE, AP.QTY_POST, ap.PRICE_POST, AP.IS_LOCKED_FOR_UPDATE,
         AP.AC, AP.ID_TARIFF, AP.ID_GUEST, AP.ID_ROOM,
         AP.ID_PACK_SERVICE, AP.ID_ROOM_TYPE,
         AP.IN_DOC_QTY, AP.IN_DOC_VALUE, AP.RATE_POST, ap.ID_SALE_TAXATION,
         ap.ID_ACCOUNT, ap.ID_ACCOUNT_POST, ap.ID_MASTER_ADDINS_ACC_POST
  from   ACCOUNT_POST AP
  where  AP.rdb$db_key = :AP_DBKEY
  into   :date_post, :orig_is_base, :orig_id_service, :id_base_doc,
         :orig_short_code, :orig_qty_post, :orig_price_post, :orig_locked_for_update,
         :orig_ac, :orig_id_tariff, :orig_id_guest, :orig_id_room,
         :id_pack_service, :id_room_type,
         :orig_in_doc_qty, :orig_in_doc_value, :rate_post, :id_sale_taxation,
         :id_account, :id_account_post, :orig_id_master_addins_acc_post;

  check_options = 'ALLOW_POSTING;';
  if (:RE_ROUTE_ACCOUNT is not null and :id_base_doc is null and :id_account <> :RE_ROUTE_ACCOUNT) then begin
    -- IMPORTANT !!! Re-routing is possible only in this case!
    id_account = :RE_ROUTE_ACCOUNT;
    if ( (:orig_is_base = 1) or (:orig_id_master_addins_acc_post > 0) ) then
      check_options = :check_options || 'IS_BASE;';
    else
      check_options = :check_options || 'IS_EXTRA;';
  end
  is_locked_for_update = :orig_locked_for_update; /* to initialize and preserve from null */

  if (:IS_CONSEQUENTIAL_UPDATE is distinct from 1) then begin
    -- direct post update - manual edition restrictions check
    if (:QTY_POST = -1) then QTY_POST = :orig_qty_post;   -- preserve current qty

    if (:QTY_POST <> :orig_qty_post) then exception POSTING_EXCEPTION '-379';

    if ((:orig_is_base = 1) and ((:QTY_POST <> 1) or (:ID_SERVICE <> :orig_id_service))) then
      exception POSTING_EXCEPTION '-223';

    if (:orig_ac = '01') then execute procedure RIGHTS_CHECK_GRANTED$INT('BALANCES_EDIT_CLOSED');

    short_code = :orig_short_code;
    id_tariff  = :orig_id_tariff;
    id_room    = :orig_id_room;
    is_locked_for_update = 1;  /* manual corrections must lock the postings  */

  end else begin
    /* post changes is a result from some user operation, indirect update ('NORMAL', 'FORCED', safes recalc, etc....) */
    is_locked_for_update = iif(:CHANGED_TEXT = 'TRANSFER_POSTING', :orig_locked_for_update, 0);

    if (:orig_is_base = 1) then begin
      /* PREPARING THE PACKET SERVICE */
      select Sp.ID_TYPE_STAY, Sp.ID_ROOM_TYPE, s.ID_HOTEL
      from   SERVICE_PACKET Sp
             join SERVICES s on s.ID_SERVICE = sp.ID_SERVICE
      where  s.ID_SERVICE = :id_service
      into   :id_type_stay, :id_room_type, :id_hotel;

      select GS.ID_BOARD
      from   GUEST_STAY GS
      where  GS.ID_GUEST = :orig_id_guest
             and GS.FOR_DATE = :date_post
      into   :id_board;

      execute procedure TAR_GET_BASE_SERVICE$INT(:id_type_stay, :id_room_type, :id_board, :id_hotel)
      returning_values  :id_pack_service;
      /* detecting change of STAY_TYPE or ROOM_TYPE */
      if (exists(
        select *
        from   SERVICE_PACKET S
        where  S.ID_SERVICE = :orig_id_service
               and ((S.ID_TYPE_STAY is distinct from :id_type_stay) or (S.ID_ROOM_TYPE is distinct from :id_room_type))
      )) then original_post = 'CHANGED';
    end
  end

  select R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :room_name;

  if (:orig_locked_for_update = 1
      and :changed_text starting with 'NORMALRECALC'
      and :id_service = :orig_id_service
      --and :orig_is_anul = 0
      and :id_tariff = :orig_id_tariff) then
  begin
    -- price is locked for update
    update ACCOUNT_POST AP
    set    AP.ID_ROOM      = :ID_ROOM,
           AP.ROOM_NAME    = :room_name,
           Ap.FROM_DATE    = :FROM_DATE,
           Ap.TO_DATE      = :TO_DATE,
           AP.ID_PACK_SERVICE  = :id_pack_service,
           AP.CHANGED_TEXT     = :CHANGED_TEXT,
           AP.USER_CHANGED     = current_user,
           AP.DATETIME_CHANGED = current_timestamp,
           AP.SHORT_CODE       = :SHORT_CODE
    where  AP.rdb$db_key   = :AP_DBKEY;
    OUT_QTY_POST = :orig_qty_post;
    OUT_PRICE_POST = :orig_price_post;
    OUT_AC = :orig_ac;
  end else begin
    -- fully update
    execute procedure ACCOUNT_VALIDATE$INT(:id_account, :check_options)
    returning_values  (:err_code, :err_text, :post_currency, :id_tax_policy, :id_hotel, :account_name);
    if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;
  
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :curr, :date_post, :orig_id_guest)
    returning_values  :rate;
  
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :post_currency, :date_post, :orig_id_guest)
    returning_values  :rate_post;
  
    if (:id_base_doc is null) then begin
      execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :id_tax_policy, :ID_TARIFF, :date_post - :from_date)
      returning_values (:id_sale_taxation);
    end

    execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:QTY_POST, :PRICE,
                      :RATE, :rate_post, :id_sale_taxation)
    returning_values  :price_post, :post_net_value, :post_gross_value;

    select c.ROUND_TO
    from   CURRS c
    where  c.CURR = :post_currency
    into   :round_to;

    if ( (:id_base_doc is not null)
         and (:qty_post = :orig_in_doc_qty)
         and (round_f(:price_post * :qty_post - :orig_in_doc_value * :orig_in_doc_qty, :round_to) = 0))
    then new_ac = '01';
    else new_ac = '00';                   
  
    if (:new_ac = '00') then begin
      execute procedure ACCOUNT_CHECK_CREDIT_STATUS$INT (:id_account, :price_post * :QTY_POST - :orig_price_post * :orig_qty_post)
      returning_values (:err_code, :err_text);
      if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;
    end

    update ACCOUNT_POST AP
    set    AP.ID_ACCOUNT           = :id_account,
           AP.ID_SERVICE           = :id_service,
  
           AP.QTY_POST             = :qty_post,
           AP.QTY_FREE             = :qty_free,
           AP.PRICE_POST           = :price_post,
           AP.CURR_POST            = :post_currency,
           AP.RATE_POST            = :rate_post,
           AP.RATE_ORIG            = :rate,
           AP.PRICE_ORIG           = :price,
           AP.CURR_ORIG            = :curr,
           AP.POST_NET_VALUE       = :post_net_value,
           AP.POST_GROSS_VALUE     = :post_gross_value,
  
           AP.AC                   = :new_ac,
           AP.IS_ANUL              = 0,
           AP.ANUL_REASON          = '',
           AP.IS_LOCKED_FOR_UPDATE = :is_locked_for_update,
           AP.ID_TARIFF            = :id_tariff,
           AP.ID_PACK_SERVICE      = :id_pack_service,
           AP.ID_ROOM              = :id_room,
           AP.ID_ROOM_TYPE         = :id_room_type,
           AP.ROOM_NAME            = :room_name,
           AP.ID_SALE_TAXATION     = :id_sale_taxation,
           AP.ORIGINAL_POST        = :original_post,
           AP.SHORT_CODE           = :short_code,
           AP.CHANGED_TEXT         = :changed_text,
           AP.USER_CHANGED         = current_user,
           AP.DATETIME_CHANGED     = current_timestamp,
           Ap.FROM_DATE            = :from_date,
           Ap.TO_DATE              = :to_date
    where  AP.rdb$db_key = :AP_DBKEY
    returning new.id_account_post, new.id_pack_service
    into   :id_account_post, :new_id_pack_service;
  
    if (:new_ac = '01') then begin
      update ACCOUNT_POST_CORRECTION APC
      set    APC.IS_OPEN = 0
      where  APC.ID_ACCOUNT_POST = :id_account_post
             and APC.IS_OPEN = 1;
    end

    if (:orig_is_base = 1 and :new_id_pack_service <> :id_pack_service) then begin
      -- update add_inses with new pack service
      update ACCOUNT_POST AP
      set    ap.ID_PACK_SERVICE = :new_id_pack_service
      where  ap.ID_MASTER_ADDINS_ACC_POST = :id_account_post
             and ap.IS_BASE = 0;
    end

    OUT_QTY_POST = :qty_post;
    OUT_PRICE_POST = :price_post;
    OUT_AC = :new_ac;
  end
end
^

/* Alter (ACCOUNT_POSTING_UPDATE_PERC) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_PERC(IN_ID_ACCOUNT_POST VARCHAR(4000),
IN_PERC NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(30))
 AS
declare variable id_account_post integer;
  declare variable ap_dbkey char(8);
  declare variable id_service integer;
  declare variable id_tariff integer;
  declare variable id_room integer;
  declare variable qty_post numeric (15,4);
  declare variable qty_free numeric (15,4);
  declare variable short_code varchar(255);
  declare variable orig_currency char(3);
  declare variable orig_rate numeric (15,4);
  declare variable orig_price numeric (15,4);
  declare variable new_orig_price double precision;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  for
    select item
    from   SYSTEM_STRING_PARSER(:in_id_account_post, ',')
    into   :id_account_post
  do begin
    select AP.rdb$db_key, AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST,
           AP.QTY_FREE, AP.SHORT_CODE, AP.CURR_ORIG, AP.RATE_ORIG, AP.PRICE_ORIG,
           ap.FROM_DATE, ap.TO_DATE
    from   ACCOUNT_POST AP
    where  AP.ID_ACCOUNT_POST = :id_account_post
    into   :ap_dbkey, :id_service, :id_tariff, :id_room, :qty_post,
           :qty_free, :short_code, :orig_currency, :orig_rate, :orig_price,
           :from_date, :to_date;

    new_orig_price = :orig_price + :orig_price * :in_perc;

    execute procedure ACCOUNT_POSTING_UPDATE$INT(:ap_dbkey,
            :id_service, :id_tariff, :id_room,
            :qty_post, :qty_free, :new_orig_price, :orig_currency, :orig_rate,
            :in_changed_text, :short_code, :from_date, :to_date)
    returning_values  :no_use, :no_use, :no_use;
  end
end
^

/* empty dependent procedure body */
/* Clear: SPR_OCC_KONT_AGENT_ROOMTYPE_DAY for: ALLOTMENT_AGENT_GET */
ALTER PROCEDURE SPR_OCC_KONT_AGENT_ROOMTYPE_DAY(FOR_DATE DATE,
ID_AGENT INTEGER,
ID_ROOM_TYPE INTEGER,
KIND SMALLINT,
AGE_KIND SMALLINT,
ALL_KINDS SMALLINT)
 RETURNS(KONTINGENT INTEGER,
DATA INTEGER,
OUT_KIND VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE ALLOTMENT_GET$INT(ID_ALLOTMENT INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ROOM_TYPE_FILTER INTEGER,
OPTIONS VARCHAR(255),
HOTELS VARCHAR(255) = '')
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ROOM_TYPE VARCHAR(30),
ID_HOTEL INTEGER,
CNT_DEFINED INTEGER,
CNT_BOOKED INTEGER,
ACTIVE_FRAME_BEGIN INTEGER,
IS_DEFINED INTEGER,
GRP_TAG INTEGER,
IS_RELEASED INTEGER)
 AS
declare variable sys_date date;
  declare variable prev_date date;
  declare variable ifrom_date date;
  declare variable ito_date date;
  declare variable icnt_defined integer;
  declare variable cnt_bp_define integer;
  declare variable cnt_bp_nonbooked integer;
  declare variable id_agent integer;
  declare variable id_booking_position integer;
  declare variable prev_frame_begin integer;
begin
  /*
  || MIND_RELEASE_DATES HAS MEANING ONLY FOR THE CONTINGENT.
  !!!!! not as you may expect: IS_RELEASED = 0 means RELEASED, =1 means NOT RELEASED
  */
  IS_DEFINED = 1;
  grp_tag = 1;
  for
    select MAXDATE(AD.FROM_DATE, :FROM_DATE), MINDATE(AD.TO_DATE, :TO_DATE),
           AD.CNT_ROOMS,
           AD.ID_ROOM_TYPE, RT.ID_HOTEL, RT.TYPE_ROOM
    from   ALLOTMENT A
           join ALLOTMENT_DETAIL AD on AD.ID_ALLOTMENT = A.ID_ALLOTMENT
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = AD.ID_ROOM_TYPE
           join HOTEL_S H on H.ID_HOTEL = RT.ID_HOTEL
    where  A.ID_ALLOTMENT = :ID_ALLOTMENT
           and ((:room_type_filter is null) or (AD.ID_ROOM_TYPE = :room_type_filter))
           and AD.FROM_DATE <= :to_date
           and AD.TO_DATE   >= :from_date
           and ((:hotels = '') or (','||:hotels||',' containing ','||H.ID_HOTEL||','))
    order by AD.TO_DATE asc
    into   :ifrom_date, :ito_date,
           :icnt_defined,
           :id_room_type, :id_hotel, :room_type
  do begin
    execute procedure sys_dbg('occ ALLOTMENT_GET$INT :ID_ALLOTMENT, :ifrom_date, :ito_date, :icnt_defined, :id_room_type, :id_hotel = ' || :ID_ALLOTMENT ||','|| :ifrom_date ||','|| :ito_date||','|| :icnt_defined||','|| :id_room_type||','|| :id_hotel);
    grp_tag = :grp_tag + 1;
    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :sys_date;
    prev_frame_begin = 0;
    for
      select SLP.OUT_DATE
      from   SYSTEM_LOOP_PERIOD(:ifrom_date, :ito_date) SLP
      into   :for_date
    do begin
      active_frame_begin = null;
      select first 1 AR.DAYS_BEFORE
      from   ALLOTMENT_RELEASE AR
      where  AR.ID_ALLOTMENT = :id_allotment
             and AR.ID_ROOM_TYPE = :id_room_type
             and :for_date between AR.FROM_DATE and AR.TO_DATE
      into   :active_frame_begin;
      execute procedure sys_dbg('occ ALLOTMENT_GET$INT :for_date, :id_room_type, :active_frame_begin = ' || :for_date ||','|| :id_room_type ||','|| coalesce(:active_frame_begin, '') );
      --TODO for optimisation days_before may be moved as for select breaking the room_count period into smaller ones
      active_frame_begin = coalesce (active_frame_begin, 0); --if no defined release days - 0 is defaulting.
      if ((:for_date-:sys_date) < :active_frame_begin) then is_released = 0; else is_released = 1; --!!! att. is_released = 0 mean NOT RELEASED
      if ((:options containing 'RELEASES') and (:options not containing 'EDIT') and (:is_released = 0)) then cnt_defined = 0;
      else cnt_defined = :icnt_defined;
      execute procedure sys_dbg('occ ALLOTMENT_GET$INT :for_date, :id_room_type, :is_released = ' || :for_date ||','|| :id_room_type ||','|| :is_released );
      if ((:for_date <> :prev_date + 1)
         or (:active_frame_begin <> :prev_frame_begin)
      )  then grp_tag = :grp_tag + 1;
      suspend;
      prev_frame_begin = :active_frame_begin;
      prev_date = :for_date;
    end
  end

  IS_DEFINED = 0;
  IS_RELEASED = 1;
  if (:OPTIONS containing 'CONTINGENT_PERIOD') then begin
    select  PA.ID_AGENT, PA.ID_BOOKING_POSITION
    from    PROFILE_AGENT PA
    where   PA.ID_CONTINGENT = :ID_ALLOTMENT
    into    :ID_AGENT, :ID_BOOKING_POSITION;

    for
      select RT.ID_ROOM_TYPE, RT.TYPE_ROOM, RT.ID_HOTEL
      from   ROOM_TYPES RT
             join HOTEL_S H on H.ID_HOTEL = RT.ID_HOTEL
      where  ((:ROOM_TYPE_FILTER is null) or (RT.ID_ROOM_TYPE = :ROOM_TYPE_FILTER))
             and ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
      into   :ID_ROOM_TYPE, :ROOM_TYPE, :ID_HOTEL
    do begin
      CNT_BOOKED = 0;
      for
        select SLP.OUT_DATE, 0
        from   SYSTEM_LOOP_PERIOD(:FROM_DATE, :TO_DATE) SLP
        into   :FOR_DATE, :CNT_DEFINED
      do begin
        if (:OPTIONS containing 'BOOKED') then begin
          select count(distinct RM.ID_ROOM)
          from   ROOM_MAGIC RM
                 join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = rm.ID_RESERV_DETAIL
          where  RM.BUSY_DATE = :FOR_DATE
                 and RD.ID_ROOM_TYPE = :ID_ROOM_TYPE
                 and RM.ID_AGENT = :ID_AGENT /* OCCUPANCY GAN BE GET ONLY FOR PARTICULAR AGENT, NOT FOR ALL */
                 and RM.DAY_ACTION not containing 'CHECK_OUT'
          into   :CNT_BOOKED;

          select ACD.CNT_DEFINED
          from   ALLOTMENT_GET$INT(:ID_BOOKING_POSITION, :FOR_DATE, :FOR_DATE, :ID_ROOM_TYPE, '', :HOTELS) ACD
          into   :CNT_BP_DEFINE;
          CNT_BP_NONBOOKED = (:CNT_BP_DEFINE - :CNT_BOOKED);
          if (:CNT_BP_NONBOOKED < 0) then CNT_BP_NONBOOKED = 0;
          CNT_BOOKED = (:CNT_BOOKED + :CNT_BP_NONBOOKED);
        end
        suspend;
      end
    end
  end

  if (:OPTIONS containing 'PLAIN_PERIOD') then begin
    for
      select RT.ID_ROOM_TYPE, RT.TYPE_ROOM, RT.ID_HOTEL
      from   ROOM_TYPES RT
             join HOTEL_S H on H.ID_HOTEL = RT.ID_HOTEL
      where  ((:ROOM_TYPE_FILTER is null) or (RT.ID_ROOM_TYPE = :ROOM_TYPE_FILTER))
             and ((:HOTELS = '') or (','||:HOTELS||',' containing ','||H.ID_HOTEL||','))
      into   :ID_ROOM_TYPE, :ROOM_TYPE, :ID_HOTEL
    do begin
      for
        select SLP.OUT_DATE, 0
        from   SYSTEM_LOOP_PERIOD(:FROM_DATE, :TO_DATE) SLP
        into   :FOR_DATE, :CNT_DEFINED
      do suspend;
    end
  end
end
^

/* Alter (ALLOTMENT_AGENT_GET) */
ALTER PROCEDURE ALLOTMENT_AGENT_GET(FROM_DATE DATE,
TO_DATE DATE,
IN_ID_ROOM_TYPE INTEGER,
IN_ID_AGENT INTEGER,
INFO_TYPE VARCHAR(40),
MIND_RELEASE_DATES SMALLINT)
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ROOM_TYPE VARCHAR(50),
CNT_ROOMS INTEGER,
IS_DEFINED INTEGER,
IS_RELEASED INTEGER)
 AS
declare variable id_allotment integer;
  declare variable allotment_options varchar(255);
  declare variable cnt_booked integer;
  declare variable cnt_defined integer;
begin
  /*  Description:
  || INFO_TYPE = 'CONTINGENT_DEFINE', 'CONTINGENT_BOOKED', 'BOOKING_DEFINE', 'BOOKING_BOOKED',
  ||              +EDIT, NONBOOKED
  */
  allotment_options = '';
  id_allotment = null;
  select iif(:info_type starting with 'CONTINGENT', PA.ID_CONTINGENT, PA.ID_BOOKING_POSITION)
  from   PROFILE_AGENT PA
  where  PA.ID_AGENT = :in_id_agent
  into   :id_allotment;

  if (:mind_release_dates = 1) then allotment_options = :allotment_options||',RELEASES';
  if (:info_type like '%BOOKED%') then allotment_options = :allotment_options||',BOOKED';
  if (:info_type like '%EDIT') then allotment_options = :allotment_options||',CONTINGENT_PERIOD,EDIT';
  else if (:info_type like '%RPT') then allotment_options = :allotment_options||',PLAIN_PERIOD';

  for
    select ACG.FOR_DATE, ACG.ID_ROOM_TYPE, ACG.ROOM_TYPE,
           sum(ACG.CNT_DEFINED), sum(ACG.CNT_BOOKED), sum(ACG.IS_DEFINED), min(ACG.IS_RELEASED)
    from   ALLOTMENT_GET$INT(:id_allotment, :from_date, :to_date, :in_id_room_type, :allotment_options) ACG
    group by 1, 2, 3
    into   :for_date, :id_room_type, :room_type,
           :cnt_defined, :cnt_booked, :is_defined, :is_released
  do begin
    if (:info_type like '%BOOKED%') then begin
      if (:info_type like '%NONBOOKED%') then cnt_rooms = (:cnt_defined - :cnt_booked);
      else cnt_rooms = :cnt_booked;
    end else cnt_rooms = :cnt_defined;                  
    suspend;
  end
end
^

/* Alter (ALLOTMENT_GET) */
ALTER PROCEDURE ALLOTMENT_GET(ID_ALLOTMENT INTEGER,
ID_HOTEL INTEGER)
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ROOM_TYPE VARCHAR(30),
CNT_DEFINED INTEGER,
CNT_BOOKED INTEGER,
ACTIVE_FRAME_BEGIN INTEGER,
IS_DEFINED INTEGER,
IS_RELEASED INTEGER)
 AS
begin
  for
    select a.FOR_DATE, a.ID_ROOM_TYPE, a.ROOM_TYPE, a.CNT_DEFINED, a.CNT_BOOKED,
           a.ACTIVE_FRAME_BEGIN, a.IS_DEFINED, a.IS_RELEASED
    from   ALLOTMENT_GET$INT(:ID_ALLOTMENT, '01.01.2001', '31.12.2099', null, '', :id_hotel) a
    into   :FOR_DATE, :ID_ROOM_TYPE, :ROOM_TYPE, :CNT_DEFINED, :CNT_BOOKED,
           :ACTIVE_FRAME_BEGIN, :IS_DEFINED, :IS_RELEASED
  do suspend;
end
^

/* Alter (ALLOTMENT_OVERBOOK_GET) */
ALTER PROCEDURE ALLOTMENT_OVERBOOK_GET(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER)
 RETURNS(FOR_DATE DATE,
ROOM_TYPE VARCHAR(30),
ROOM_TYPE2 VARCHAR(30),
QTY_ALLOW INTEGER)
 AS
declare variable id_room_type integer;
begin
  for
    select ACG.FOR_DATE, ACG.ID_ROOM_TYPE, ACG.ROOM_TYPE, ACG.CNT_DEFINED
    from   HOTEL H
           left outer join ALLOTMENT_GET$INT(H.ID_OVERBOOK_ALLOTMENT, :from_date, :to_date, null, 'PLAIN_PERIOD', :id_hotel) ACG on 0=0
    where  H.ID_HOTEL = :id_hotel
    into   :for_date, :id_room_type, :room_type, :qty_allow
  do begin
    room_type2 = :room_type;
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUPANCY$RPT for: AVAILABILITY_OCCUP_PREPARE$AVL */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$RPT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
RELEASE_DATES INTEGER = 0,
OVERBOOK INTEGER = 0,
RES_CONFIRMED INTEGER = 1,
RES_NOTCONFIRMED INTEGER = 1,
RES_WAITING INTEGER = 0,
BOOKING_POSITIONS INTEGER = 0,
CONTINGENT INTEGER = 0)
 RETURNS(ID_ROOM_TYPE INTEGER,
FOR_DATE DATE,
ID_PROFILE INTEGER,
ROOMS_CAPACITY SMALLINT,
ROOMS_OOI SMALLINT,
ROOMS_OOO SMALLINT,
ROOMS_SOLD SMALLINT,
ROOMS_CONFIRMED SMALLINT,
ROOMS_NOTCONFIRMED SMALLINT,
ROOMS_WAITING SMALLINT,
ROOMS_TOTAL_SOLD SMALLINT,
ROOMS_OCCUPIED SMALLINT,
ROOMS_AVAILABLE SMALLINT,
ROOMS_SOLD_MULTIPLE_GST SMALLINT,
ROOMS_ARRIVAL SMALLINT,
ROOMS_DEPARTURE SMALLINT,
GUESTS_IN_HOUSE BIGINT,
GUESTS_ARRIVAL BIGINT,
GUESTS_DEPARTURE BIGINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: OCCUPANCY_RTI_BP$RPT for: AVAILABILITY_OCCUP_PREPARE$AVL */
ALTER PROCEDURE OCCUPANCY_RTI_BP$RPT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ROOM_TYPES VARCHAR(255))
 RETURNS(OUT_DATE DATE,
CATEGORY VARCHAR(50),
AGENT_NAME VARCHAR(50),
ROOM_CNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SUMMARY_FORECAST$INT for: AVAILABILITY_OCCUP_PREPARE$AVL */
ALTER PROCEDURE SUMMARY_FORECAST$INT(ID_HOTEL INTEGER,
SUMMARY_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: TEST_AVAILABILITY for: AVAILABILITY_OCCUP_PREPARE$AVL */
ALTER PROCEDURE TEST_AVAILABILITY(FROM_DATE DATE,
TO_DATE DATE,
HOTELS VARCHAR(255))
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_AGENT INTEGER,
AGENT_NAME VARCHAR(100),
SOLD INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
CONT_BP_REMAIN INTEGER,
RES_WAITING INTEGER,
CONT_PLAIN INTEGER,
CONT_BP INTEGER,
CONT_BP_PLAIN INTEGER,
CONT_PLAIN_REMAIN INTEGER,
RES_TOTAL INTEGER,
ROOM_TYPE_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TEST_RATING for: AVAILABILITY_OCCUP_PREPARE$AVL */
ALTER PROCEDURE TEST_RATING RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE AVAILABILITY_OCCUPANCY_OPT$AVL(ID_OCCUPANCY_SESSION INTEGER,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
GENERALIZE_CONT_REMAINS SMALLINT = 0)
 AS
begin

  execute procedure AVAILABILITY_OCCUPANCY_OPT$INT (:RELEASE_DATES, :OVERBOOK,
          :RES_CONFIRMED, :RES_NOTCONFIRMED, :RES_WAITING, :BOOKING_POSITIONS, :CONTINGENT, :GENERALIZE_CONT_REMAINS);
end
^

/* Alter (AVAILABILITY_OCCUP_PREPARE$AVL) */
ALTER PROCEDURE AVAILABILITY_OCCUP_PREPARE$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS INTEGER,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
declare variable occupancy_session integer;
begin

  execute procedure AVAILABILITY_OCCUPANCY$AVL (:FROM_DATE, :TO_DATE, :FETCH_TOTALS, :HOTELS)
  returning_values :occupancy_session;
   
  execute procedure AVAILABILITY_OCCUPANCY_OPT$AVL (:occupancy_session, :RELEASE_DATES, :OVERBOOK,
          :RES_CONFIRMED, :RES_NOTCONFIRMED, :RES_WAITING, :BOOKING_POSITIONS, :CONTINGENT);

end
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUPANCY$AVL for: AVAILABILITY_OCCUPANCY$INT */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (AVAILABILITY_OCCUPANCY$INT) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$INT(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 AS
declare variable id_global_agent integer;
  declare variable for_date date;
  declare variable id_agent integer;
  declare variable id_room_type integer;
  declare variable g_capacity integer;
  declare variable bp_defined integer;
  declare variable c_defined integer;
  declare variable fdata integer;
  declare variable bp_is_released integer;
  declare variable c_is_released integer;
  declare variable gsts_in_house integer;
  declare variable gsts_come integer;
  declare variable gsts_gone integer;
  declare variable rooms_come integer;
  declare variable rooms_gone integer;
  declare variable id_hotel integer;
  declare variable id_b_allotment integer;
  declare variable id_c_allotment integer;
  declare variable ooo_rooms integer;
  declare variable ooi_rooms integer;
  declare variable sold_rooms integer;
  declare variable res_room_conf integer;
  declare variable res_room_notconf integer;
  declare variable res_room_wait integer;
  declare variable id_booked_room_type integer;
begin
  /*  Description:   */
  ID_GLOBAL_AGENT = -100; /* HOLDS DATA GLOBAL FOR THE HOTEL */

  if (coalesce(:HOTELS, '') = '') then begin
    select list (h.ID_HOTEL)
    from   HOTEL_S H
    into   :HOTELS;
  end

  delete from SMART_OCCUP$TMP;

  for
    select RC.ID_ROOM_TYPE, RC.ID_HOTEL, RC.FOR_DATE, sum(RC.CNT_DEFINED)
    from   HOTEL_S H
           left outer join ALLOTMENT_GET$INT(H.ID_INVENTORY_ALLOTMENT, :FROM_DATE, :TO_DATE, null, 'PLAIN_PERIOD', :HOTELS) RC on 0=0
    where  (','||:HOTELS||',' containing ','||H.ID_HOTEL||',')
           and rc.ID_ROOM_TYPE is not null
    group by 1, 2, 3
    into   :ID_ROOM_TYPE, :ID_HOTEL, :FOR_DATE, :G_CAPACITY
  do begin
    execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_global_agent, :id_room_type, :id_hotel, :g_capacity);
  end

  for
    select   RM.BUSY_DATE, RM.ID_ROOM_TYPE, rd.ID_ROOM_TYPE, RM.ID_HOTEL,
             iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) in (18,20),
                 :ID_GLOBAL_AGENT,
                 iif(RS.ID_ROOM_SHARE is not null, rs.ID_AGENT, RM.ID_AGENT)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 18, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 20, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 24, RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_CONFIRMED', RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_NOTCONFIRMED', RM.ID_ROOM, null)),
             count(distinct iif(coalesce(RS.BUSY_GROUP_TYPE, RM.BUSY_GROUP_TYPE) = 1 and coalesce(RS.BUSY_TYPE, RM.BUSY_TYPE) = 'VALUE_RESERVS', RM.ID_ROOM, null))
    from     SYSTEM_STRING_PARSER(:HOTELS) sp
             left join ROOM_MAGIC RM on rm.ID_HOTEL = sp.ITEM
             left outer join ROOMS_SHARE RS on RS.ID_ROOM_SHARE = RM.ID_ROOM_MAGIC
             left outer join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = coalesce(rs.ID_RESERV_STATISTICS, rm.ID_RESERV_DETAIL)
    where    RM.BUSY_DATE between :from_date and :to_date
             and RM.DAY_ACTION not containing 'CHECK_OUT'
             and rm.ROOM_STATUS is distinct from 'PRIVATE'
             and ((not (:RES_CONFIRMED = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_CONFIRMED'))
                  or (not (:RES_NOTCONFIRMED = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_NOTCONFIRMED'))
                  or (not (:RES_WAITING = 0 and coalesce(rs.BUSY_TYPE, rm.BUSY_TYPE) = 'VALUE_RESERVS')))
    group by 1, 2, 3, 4, 5
    into     :for_date, :id_room_type, :id_booked_room_type, :id_hotel, :id_agent,
             :ooo_rooms, :ooi_rooms, :sold_rooms, :res_room_conf, :res_room_notconf, :res_room_wait
  do begin
    execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
            null, :ooo_rooms, :ooi_rooms, null, :sold_rooms, :res_room_conf, :res_room_notconf, :res_room_wait);
    if (:id_agent > 0 and :id_booked_room_type is not null) then
      execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, -:id_booked_room_type, :id_hotel,
              null, :ooo_rooms, :ooi_rooms, null, :sold_rooms, :res_room_conf, :res_room_notconf, :res_room_wait);
  end

  if (:BOOKING_POSITIONS + :CONTINGENT > 0) then begin
    for
      select PA.ID_AGENT, PA.ID_BOOKING_POSITION, pa.ID_CONTINGENT
      from   PROFILE_AGENT PA
      where  (pa.ID_CONTINGENT is not null) or (pa.ID_BOOKING_POSITION is not null)
      into   :id_agent, :id_b_allotment, :id_c_allotment
    do begin
      for
        select al.for_date, al.id_room_type, al.id_hotel,
               sum(al.b_defined), max(al.b_is_released), sum(al.c_defined), max(al.c_is_released)
        from   (select ABP.FOR_DATE, ABP.ID_ROOM_TYPE, ABP.ID_HOTEL,
                       ABP.CNT_DEFINED as b_defined, ABP.IS_RELEASED as b_is_released, null as c_defined, null as c_is_released
                from   ALLOTMENT BA
                       left join ALLOTMENT_GET$INT(ba.ID_ALLOTMENT, :from_date, :to_date, null, 'RELEASES', :hotels) ABP on 1=1
                where  :BOOKING_POSITIONS = 1 and ba.ID_ALLOTMENT = :id_b_allotment
                union all
                select ACG.FOR_DATE, ACG.ID_ROOM_TYPE, ACG.ID_HOTEL, null, null, ACG.CNT_DEFINED, ACG.IS_RELEASED
                from   ALLOTMENT CA
                       left join ALLOTMENT_GET$INT(ca.ID_ALLOTMENT, :from_date, :to_date, null, '', :hotels) ACG on 1=1
                where  :CONTINGENT = 1 and CA.ID_ALLOTMENT = :id_c_allotment
               ) al
        where  al.for_date is not null
        group by 1, 2, 3
        into   :for_date, :id_room_type, :id_hotel,
               :bp_defined, :bp_is_released, :c_defined, :c_is_released
      do begin
        execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, -:id_room_type, :id_hotel,
                null, null, null, null, null, null, null, null, :c_defined, :c_is_released, :bp_defined, :bp_is_released);
      end
    end
  end

  if (:OVERBOOK = 1) then begin
    for
      select ACG.FOR_DATE, ACG.ID_ROOM_TYPE, ACG.ID_HOTEL, ACG.CNT_DEFINED
      from   HOTEL_S H
             left outer join ALLOTMENT_GET$INT(H.ID_OVERBOOK_ALLOTMENT, :FROM_DATE, :TO_DATE, null, '', :HOTELS) ACG on 0=0
      where  ACG.FOR_DATE is not null
             and (','||:HOTELS||',' containing ','||H.ID_HOTEL||',')
      into   :for_date, :id_room_type, :id_hotel, :fdata
    do begin
      execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
              null, null, null, :fdata);
    end
  end

  if (:FETCH_TOTALS = 1) then begin
    for
      select RM.BUSY_DATE, RM.ID_ROOM_TYPE, RM.ID_HOTEL, RM.ID_AGENT,
             sum(RM.STAYOVER_ADULTS + RM.STAYOVER_CHILDREN + RM.ARRIVAL_ADULTS + RM.ARRIVAL_CHILDREN),
             sum(RM.ARRIVAL_ADULTS + RM.ARRIVAL_CHILDREN),
             sum(RM.DEPARTURE_ADULTS + RM.DEPARTURE_CHILDREN),
             sum(rm.ARRIVAL_ROOM),
             sum(rm.DEPARTURE_ROOM)
      from   SYSTEM_STRING_PARSER(:HOTELS) sp
             left join HOTEL_ROOM_OCCUPANCY RM on rm.ID_HOTEL = sp.ITEM
      where  RM.BUSY_DATE between :from_date and :to_date
             and rm.BUSY_GROUP_TYPE in (1, 24)
             and RM.BUSY_TYPE not in ('VALUE_RESERVS')
      group by 1, 2, 3, 4
      into   :for_date, :id_room_type, :id_hotel, :id_agent,
               :gsts_in_house, :gsts_come, :gsts_gone, :rooms_come, :rooms_gone
    do begin
      execute procedure SMART_OCCUPANCY_FILL$INT (:for_date, :id_agent, :id_room_type, :id_hotel,
              null, null, null, null, null, null, null, null, null, null, null, null,
              :gsts_in_house, :gsts_come, :gsts_gone, :rooms_come, :rooms_gone);
    end
  end
end
^

/* Alter (AVAILABILITY_OCCUPANCY$RPT) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$RPT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
RELEASE_DATES INTEGER = 0,
OVERBOOK INTEGER = 0,
RES_CONFIRMED INTEGER = 1,
RES_NOTCONFIRMED INTEGER = 1,
RES_WAITING INTEGER = 0,
BOOKING_POSITIONS INTEGER = 0,
CONTINGENT INTEGER = 0)
 RETURNS(ID_ROOM_TYPE INTEGER,
FOR_DATE DATE,
ID_PROFILE INTEGER,
ROOMS_CAPACITY SMALLINT,
ROOMS_OOI SMALLINT,
ROOMS_OOO SMALLINT,
ROOMS_SOLD SMALLINT,
ROOMS_CONFIRMED SMALLINT,
ROOMS_NOTCONFIRMED SMALLINT,
ROOMS_WAITING SMALLINT,
ROOMS_TOTAL_SOLD SMALLINT,
ROOMS_OCCUPIED SMALLINT,
ROOMS_AVAILABLE SMALLINT,
ROOMS_SOLD_MULTIPLE_GST SMALLINT,
ROOMS_ARRIVAL SMALLINT,
ROOMS_DEPARTURE SMALLINT,
GUESTS_IN_HOUSE BIGINT,
GUESTS_ARRIVAL BIGINT,
GUESTS_DEPARTURE BIGINT)
 AS
begin

  execute procedure AVAILABILITY_OCCUP_PREPARE$AVL (
          :FROM_DATE,
          :TO_DATE,
          1,
          coalesce(:RELEASE_DATES, 0),
          coalesce(:OVERBOOK, 0),
          coalesce(:RES_CONFIRMED, 1),
          coalesce(:RES_NOTCONFIRMED, 1),
          coalesce(:RES_WAITING, 0),
          coalesce(:BOOKING_POSITIONS, 0),
          coalesce(:CONTINGENT, 0),
          :ID_HOTEL);

  for
    select SO.ID_ROOM_TYPE,
           SO.FOR_DATE,
           pa.id_profile,
           sum(SO.G_CAPACITY),
           sum(so.G_OOI),
           sum(so.G_OOO),
           sum(so.SOLD),
           sum(so.RES_CONFIRMED),
           sum(so.RES_NOTCONFIRMED),
           sum(so.RES_WAITING),
           sum(so.OCCUPIED),
           sum(so.AVAILABLE),
           sum(iif(so.GUESTS_INHOUSE > 1, so.SOLD, 0)),
           sum(so.ROOMS_COME),
           sum(so.ROOMS_GONE),
           sum(so.GUESTS_INHOUSE),
           sum(so.GUESTS_COME),
           sum(so.GUESTS_GONE)
    from   SMART_OCCUP$TMP SO
           left outer join PROFILE_AGENT pa on pa.id_agent = so.id_agent
    group by 1, 2, 3
    into   :ID_ROOM_TYPE, :FOR_DATE, :id_profile, :ROOMS_CAPACITY, :ROOMS_OOI, :ROOMS_OOO,
           :ROOMS_SOLD, :ROOMS_CONFIRMED, :ROOMS_NOTCONFIRMED, :ROOMS_WAITING, :ROOMS_OCCUPIED, :ROOMS_AVAILABLE,
           :ROOMS_SOLD_MULTIPLE_GST, :ROOMS_ARRIVAL, :ROOMS_DEPARTURE,
           :GUESTS_IN_HOUSE, :GUESTS_ARRIVAL, :GUESTS_DEPARTURE
  do begin
    ROOMS_TOTAL_SOLD = :ROOMS_SOLD + :ROOMS_CONFIRMED + :ROOMS_NOTCONFIRMED + :ROOMS_WAITING;
    suspend;
  end
end
^

/* Alter (AVAILABILITY_OCCUPANCY_OPT$INT) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY_OPT$INT(RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
GENERALIZE_CONT_REMAINS SMALLINT = 0)
 AS
declare variable so_dbkey char(8);
  declare variable id_agent integer;

  declare variable res_cnt integer;
  declare variable sold_cnt integer;
  declare variable cont_bp_remain integer;
  declare variable cont_plain_remain integer;
  declare variable cont_bp integer;
  declare variable cont_plain integer;
  declare variable block_total integer;
  declare variable capacity integer;
  declare variable overbook_allowed integer;
  declare variable available integer;
  declare variable occupied integer;
  declare variable available_agent integer;
  declare variable confirmed_cnt integer;
  declare variable notconfirmed_cnt integer;
  declare variable waiting_cnt integer;
  declare variable cont_plain_release integer;
  declare variable cont_bp_release integer;
  declare variable cont_plain_over integer;
  declare variable cont_bp_over integer;
  declare variable id_room_type integer;
  declare variable id_hotel integer;
  declare variable for_date date;
begin

  for
    select SO.RDB$DB_KEY, SO.ID_AGENT, so.ID_ROOM_TYPE, so.FOR_DATE, so.ID_HOTEL,
           SO.SOLD, SO.RES_CONFIRMED, SO.RES_NOTCONFIRMED, SO.RES_WAITING,
           SO.CONT_BP, SO.CONT_PLAIN, SO.CONT_PLAIN_RELEASE, so.CONT_BP_RELEASE
    from   SMART_OCCUP$TMP SO
    where  so.ID_ROOM_TYPE < 0
    into   :so_dbkey, :id_agent, :id_room_type, :for_date, :id_hotel,
           :sold_cnt, :confirmed_cnt, :notconfirmed_cnt, :waiting_cnt,
           :cont_bp, :cont_plain, :cont_plain_release, :cont_bp_release
  do begin
    cont_bp_over = 0;
    cont_bp_remain = 0;
    cont_plain_over = 0;
    cont_plain_remain = 0;

    res_cnt = :sold_cnt
              + iif(:res_confirmed = 1, :confirmed_cnt, 0)
              + iif(:res_notconfirmed = 1, :notconfirmed_cnt, 0)
              + iif(:res_waiting = 1, :waiting_cnt, 0);

    if (:cont_bp > 0) then begin
      cont_bp_remain = :cont_bp - :res_cnt;
      if (:cont_bp_remain < 0) then begin
        cont_bp_over = -:cont_bp_remain;
        cont_bp_remain = 0;
      end
    end

    if ((:cont_plain > 0) or (:GENERALIZE_CONT_REMAINS is not distinct from 1)) then begin
      cont_plain_remain =
        :cont_plain * iif(:release_dates = 1, :cont_plain_release, 1)
        - (:res_cnt + iif(:booking_positions = 1, :cont_bp_remain, 0));
      if (:cont_plain_remain < 0) then begin
        cont_plain_over = -:cont_plain_remain;
        cont_plain_remain = 0;
      end
    end

    update or insert into SMART_OCCUP$TMP (ID_ROOM_TYPE, ID_AGENT, ID_HOTEL, FOR_DATE,
           CONT_PLAIN, CONT_PLAIN_RELEASE, CONT_PLAIN_REMAIN, CONT_PLAIN_OVER,
           CONT_BP, CONT_BP_RELEASE, CONT_BP_REMAIN, CONT_BP_OVER)
    values (abs(:id_room_type), :id_agent, :id_hotel, :for_date,
           :cont_plain, :cont_plain_release, :cont_plain_remain, :cont_plain_over,
           :cont_bp, :cont_bp_release, :cont_bp_remain, :cont_bp_over)
    matching (ID_ROOM_TYPE, ID_AGENT, ID_HOTEL, FOR_DATE);
  end

  delete from SMART_OCCUP$TMP O where O.ID_ROOM_TYPE < 0;

  for
    select SO.RDB$DB_KEY, SO.ID_AGENT, so.ID_ROOM_TYPE, so.FOR_DATE, so.ID_HOTEL,
           SO.G_OOI, SO.SOLD, SO.RES_CONFIRMED, SO.RES_NOTCONFIRMED, SO.RES_WAITING,
           SO.G_CAPACITY, SO.CONT_BP, SO.CONT_PLAIN, SO.G_OVERBOOK_ALLOWED,
           SO.CONT_PLAIN_RELEASE, so.CONT_BP_RELEASE, so.CONT_PLAIN_REMAIN, so.CONT_BP_REMAIN
    from   SMART_OCCUP$TMP SO
    into   :so_dbkey, :id_agent, :id_room_type, :for_date, :id_hotel,
           :block_total, :sold_cnt, :confirmed_cnt, :notconfirmed_cnt, :waiting_cnt,
           :capacity, :cont_bp, :cont_plain, :overbook_allowed,
           :cont_plain_release, :cont_bp_release, :cont_plain_remain, :cont_bp_remain
  do begin
    res_cnt = :sold_cnt
              + iif(:res_confirmed = 1, :confirmed_cnt, 0)
              + iif(:res_notconfirmed = 1, :notconfirmed_cnt, 0)
              + iif(:res_waiting = 1, :waiting_cnt, 0);

    if (coalesce(:id_agent, 0) > 0) then begin
      available_agent = (:cont_plain - (:res_cnt + iif(:booking_positions = 1, :cont_bp_remain, 0)));
    end else begin
      cont_bp_remain = 0;
      cont_plain_remain = 0;
      available_agent = 0;
    end
  
    occupied = :block_total
               + :res_cnt
               + iif(:booking_positions = 1, :cont_bp_remain, 0)
               + iif(:contingent = 1, coalesce(:cont_plain_remain, 0), 0);
    available = :capacity
                + iif(:overbook = 1, :overbook_allowed, 0)
                - iif(:occupied > 0, :occupied, 0);
    -- shouldn't reduce available rooms with negative occupancy - this is occupied rooms correction only !!!

    update SMART_OCCUP$TMP SO
    set    SO.AVAILABLE = :available,
           SO.OCCUPIED = :occupied,
           SO.AVAILABLE_AGENT = :available_agent
    where  SO.RDB$DB_KEY = :so_dbkey;
  end
end
^

/* Alter (AVAILABILITY_OCCUPANCY_PREPARE) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY_PREPARE(FROM_DATE DATE,
TO_DATE DATE,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
begin
  -- used from some reports - generate occupancy for selection
  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, 1, :OVERBOOK,
          :RES_CONFIRMED, :RES_NOTCONFIRMED, :RES_WAITING, :BOOKING_POSITIONS, :CONTINGENT, :HOTELS);
   
  execute procedure AVAILABILITY_OCCUPANCY_OPT$INT (:RELEASE_DATES, :OVERBOOK,
          :RES_CONFIRMED, :RES_NOTCONFIRMED, :RES_WAITING, :BOOKING_POSITIONS, :CONTINGENT);

  ID_OCCUPANCY_SESSION = current_transaction;
  suspend;
end
^

ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(2000),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
declare variable op varchar(10);
  declare variable market_segment_id integer;
  declare variable sex_old char(1);
  declare variable birth_date_old date;
  declare variable birth_place_old varchar(30);
  declare variable personal_number_old varchar(30);
  declare variable pass_num_old varchar(20);
  declare variable pass_date_old date;
  declare variable pass_place_old varchar(20);
  declare variable pass_exp_date_old date;
  declare variable pass_city_old varchar(100);
  declare variable pass_address_old varchar(100);
  declare variable country_old varchar(10);
  declare variable mask_old varchar(10);
  declare variable title_old varchar(10);
  declare variable id_photo integer;
  declare variable id_def_contragent integer;
  declare variable id_passport_type integer;
  declare variable account_no_old varchar(20);
  declare variable msg_old varchar(2000);
  declare variable id_guest_type integer;
  declare variable id_guest_type_old integer;
  declare variable card_code_old varchar(50);
  declare variable is_exclusive_debt_ownership smallint;
  declare variable profile_receiver_id integer;
begin
  profile_id = null;
  import_time = null;

  execute procedure import_mark_transaction$exc;

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC(:profile_uuid=>' || coalesce(:profile_uuid, '<null>')
                          || ', email=>' || coalesce(:email, '<null>') || ')');

  profile_id = null;
  if (profile_uuid is null) then begin
    execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC <null> :profile_uuid - exit;');
    exit;
  end

  select p.profile_id, p.profile_name, p.phone, p.fax, p.email, p.city,
         p.address, p.market_segment, p.note, p.is_archive, pp.card_code,
         pd.sex, pd.birthday_internal, pd.birth_place, pd.egn, pd.pass_num,
         pd.pass_date, pd.pass_place, pd.pass_exp_date, pd.city, pd.address, pd.country_code,
         pd.mask, p.id_def_contragent, p.wbe_password,
         pd.title, p.account_no, p.msg, pp.id_guest_type, pp.id_photo, pd.id_passport_type,
         p.is_exclusive_debt_ownership
  from   import_common_profile$exc(:profile_uuid, 0, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :wbe_password, :ACCOUNT_NO, :MSG, 'PERSON_PROFILE', :HOTEL_UUID_LIST) p
         left outer join profile_person pp on pp.id_profile = p.profile_id
         left outer join person_data pd on pd.id_person_data=pp.id_person_data
  into   :profile_id, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :card_code_old,
         :sex_old, :birth_date_old, :birth_place_old, :personal_number_old, :pass_num_old,
         :pass_date_old, :pass_place_old, :pass_exp_date_old, :pass_city_old, :pass_address_old, :country_old,
         :mask_old, :id_def_contragent, :wbe_password, :title_old,
         :account_no_old, :msg_old, :id_guest_type_old, :id_photo, :id_passport_type, :is_exclusive_debt_ownership;

  if (:profile_id is null) then begin
    op = 'add';
  end else if (:hotel_uuid_list is null) then begin
    profile_id = null;
    exit;
  end else begin
    op = 'mod';
    delete from PROFILE_BONUSPOINT_SCHEME bs
      where bs.ID_PROFILE = :profile_id;
  end

  sex=coalesce(:sex, :sex_old);
  birth_date=coalesce(:birth_date, :birth_date_old);
  birth_place=coalesce(:birth_place, :birth_place_old);
  personal_number=coalesce(:personal_number, :personal_number_old);
  pass_num=coalesce(:pass_num, :pass_num_old);
  pass_date=coalesce(:pass_date, :pass_date_old);
  pass_place=coalesce(:pass_place, :pass_place_old);
  pass_exp_date=coalesce(:pass_exp_date, :pass_exp_date_old);
  pass_city=coalesce(:pass_city, :pass_city_old);
  pass_address=coalesce(:pass_address, :pass_address_old);
  country=upper(coalesce(:country, :country_old));
  mask=coalesce(:mask, :mask_old);
  title=coalesce(:title, :title_old);
  account_no=coalesce(:account_no, :account_no_old);
  msg=coalesce(:msg, :msg_old);
  card_code=coalesce(:card_code, :card_code_old);

  execute procedure IMPORT_PASSPORT_TYPE$EXC(:pass_type_name, :pass_type_external_code)
  returning_values :id_passport_type;

  execute procedure lookup_market_segment$exc(:profile_name, 'PERSON_PROFILE', :market_segment)
  returning_values :market_segment_id;

  if (guest_type_name is not null) then begin
    execute procedure lookup_guest_type$exc(:profile_name, 'PERSON_PROFILE', :guest_type_name)
    returning_values :id_guest_type;
  end

  if ((def_contragent_name is not null) and (def_contragent_name <> '')) then begin
    execute procedure LOOKUP_CONTRAGENT$EXC(:profile_name, 'PERSON_PROFILE', :def_contragent_name)
    returning_values :id_def_contragent;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:profile_name, 'PERSON_PROFILE');

  id_guest_type=coalesce(:id_guest_type, :id_guest_type_old);

  if (id_photo is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, null, null, null, 'del')
    returning_values :id_photo;
  end
  id_photo = null;
  if (picture is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, :picture, :picture_type, :picture_layout, 'add')
    returning_values :id_photo;
  end

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC - profile_person_modify$profile(:profile_uuid=>'
    || coalesce(:profile_uuid, '<null>')
    || ', :operation=>' || coalesce(:op, '<null>')
    || ', :email=>' || coalesce(:email, '<null>')
    || ', :birth_date=>' || coalesce(:birth_date, '<null>')
  || ')');
  execute procedure profile_person_modify$profile(
    :profile_id,
    :id_guest_type,
    :profile_name,
    null,
    :sex,
    :birth_date,
    :birth_place,
    :personal_number,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :pass_place,
    :pass_exp_date,
    :country,
    :pass_city,
    :pass_address,
    :mask,
    :phone,
    :fax,
    :email,
    :city,
    :address,
    :note,
    :msg,
    :id_def_contragent,
    :market_segment_id,
    :is_archive,
    :id_photo,
    :card_code,
    :wbe_password,
    :op,
    :account_no,
    :title,
    :is_exclusive_debt_ownership
  ) returning_values
    :profile_id;

  /*assign uuid to the new profiles*/
  if ('add' = :op) then begin
    update profile set uuid=:profile_uuid where id_profile=:profile_id;
  end

  select record_timestamp from profile where id_profile=:profile_id
  into :import_time;

  if (:MERGE_TARGET_UUID is not null) then begin
    select p.ID_PROFILE
    from   PROFILE P
    where  P.UUID = :MERGE_TARGET_UUID
    into   :profile_receiver_id;

    execute procedure PROFILE_MERGE$PROFILE (:PROFILE_ID, :profile_receiver_id, 'merge');

  end

end
^

/* Alter (CREATE_BOOKING$WBE) */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
declare variable rate varchar(50);
declare variable room_type varchar(20);
declare variable arrival date;
declare variable departure date;
declare variable adults integer;
declare variable children integer;
declare variable profile_name varchar(100);
declare variable aranger_name varchar(100);
declare variable guest_profile_uuid varchar(40);
declare variable aranger_profile_uuid varchar(40);
declare variable hotel_name varchar(50);
declare variable wbe_session_id bigint;
declare variable main_guest_profile_id integer;
declare variable board varchar(50);
declare variable hotel_id integer;
declare variable guarantee_policy_name varchar(50);
declare variable guarantee_deposit_percent numeric(15,4);
declare variable guarantee_deposit_nights integer;
declare variable guarantee_due_days_bef_arrival integer;
declare variable guarantee_due_days_after_create integer;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable profile_type varchar(20);
declare variable profile_import_time timestamp;
declare variable b_count integer;
declare variable age integer;
declare variable is_child smallint;
declare variable guest_id integer;
declare variable special_treatment varchar(250);
declare variable maintenance varchar(30);
declare variable routing varchar(20);
declare variable arranger_paymeny_type varchar(20);
declare variable market_segment varchar(30);
declare variable market_source varchar(30);
declare variable market_channel varchar(30);
declare variable market_hear_reason varchar(30);
declare variable market_come_reason varchar(30);
declare variable first_food varchar(30);
declare variable bnote varchar(2000);
begin
  -- get wbe product selection
  select  PA.rate_name,PA.room_name, AQ.first_date, AQ.first_date+AQ.day_count,
          PS.adults, PS.children, PS.person_name, H.hotel_name, H.id_hotel,
          WS.id, PA.board_name, GP.name, GP.deposit_totalsum_part, GP.deposit_nights_count, GP.due_days_before_arrival, GP.due_days_after_create,
          PS.bnote
   from   PRODUCT_SELECTION$WBE PS
          join WBE_SESSION$WBE WS on WS.id = PS.wbe_session_id
          join PRODUCT_AVAILABILITY$WBE PA on pa.id = PS.product_availability_id
          join AVAILABILITY_QUERY$WBE AQ on aq.id = WS.product_query_id
          join HOTEL H on H.id_hotel = WS.hotel_id
          join GUARANTEE_POLICY GP on GP.id_guarantee_policy = PS.guarantee_policy_id
   where  PS.id = :product_selection_id
   into   :rate, :room_type, :arrival, :departure,
          :adults,  :children, :profile_name, :hotel_name, :hotel_id,
          :wbe_session_id, :board, :guarantee_policy_name,
          :guarantee_deposit_percent, :guarantee_deposit_nights,
          :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create,
          :bnote;

  select PA.uuid , PA.profile_name, PA.profile_type
  from   PROFILE PA
  where  PA.id_profile = :aranger_profile_id
  into   :aranger_profile_uuid,:aranger_name,  :profile_type;

  if (:aranger_name = :profile_name and :profile_type = 'PERSON') then begin
    -- aranger is main guest
    select count(*)
    from   PRODUCT_SELECTION$WBE PSC
    where  PSC.wbe_session_id = :wbe_session_id
    into   :b_count;
       -- only if single reservation bugfix 2228
    if (1 = :b_count) then begin
     guest_profile_uuid =  aranger_profile_uuid;
     aranger_profile_uuid = null;
    end
  end else begin
    -- create profile for main guest
    execute procedure IMPORT_PERSON_PROFILE$EXC(
      uuid_create(),:profile_name,null,null,null,null,null,null,null,null,null,null, null,
      null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
      null,null,null,null,null, null, null)
    returning_values :main_guest_profile_id, :profile_import_time;

    select P.uuid
    from   PROFILE P
    where  P.id_profile = :main_guest_profile_id
    into   :guest_profile_uuid;
  end

    -- apply default map + forced arranger
    special_treatment = null;
    maintenance = null;
    routing = null;
    arranger_paymeny_type = null;
    market_segment = null;
    market_source = null;
    market_channel = null;
    market_hear_reason = null;
    market_come_reason = null;


  select hc.special_treatment, hk.plan_name, hc.routing,
         pt.payment_type, ms.segment_name, sc.description, cc.description,
         hr.description, cr.description, hc.first_food
  from   HOTEL_PRODUCT_CFG$WBE hc
         left join HK_PLAN hk on hk.id_plan = hc.id_hk_plan
         left join PAYMENT_TYPE pt on pt.id_payment_type = hc.arranger_id_payment_type
         left join NOM_MARKET_SEGMENTS ms on ms.id_nom_market_segment = hc.id_m_segment
         left join NOM_SOURCE_CODES sc on sc.id_nom_source_code = hc.id_m_source
         left join NOM_CHANNEL_CODES cc on cc.id_nom_channel_code = hc.id_m_channel
         left join NOM_HEAR_REASONS hr on hr.id_nom_hear_reason = hc.id_m_hear_reason
         left join NOM_COME_REASONS cr on cr.id_nom_come_reason = hc.id_m_come_reason
  where  hc.hotel_id = :hotel_id
  into   :special_treatment,:maintenance,:routing,:arranger_paymeny_type,
         :market_segment,:market_source,:market_channel,:market_hear_reason,:market_come_reason,:first_food;
  -- create reseravation
  execute procedure IMPORT_BOOKING$EXC(
     :hotel_name, :number, null, null, 0,
     :arrival, null, :departure, null, null, null, null, null, :room_type, :board, null,
     :special_treatment, :maintenance, :routing, :rate, null, null, null, null, :arranger_paymeny_type, null, null, null, null,
     :market_segment, :market_source,:market_channel, :market_hear_reason, :market_come_reason,
     :bnote, null, :first_food, :adults, :children, :aranger_profile_uuid, null, :guest_profile_uuid,
     0, 0, null, :guarantee_policy_name, null, :guarantee_deposit_percent, :guarantee_deposit_nights,
     :guarantee_due_days_bef_arrival,  :guarantee_due_days_after_create, null, null, null, null,  null, null, null, null, null, null, null, null)
  returning_values
     :hotel_id, :booking_id, :err_code, err_text;
  if (0 <> :err_code) then exception WRONG_VALUE ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');

  -- import guests
  for
    select psg.guest_name, psg.is_child, psg.age
    from   PRODUCT_SELECTION_GUESTS$WBE psg
    where  psg.product_selection_id = :product_selection_id
    into   :profile_name,:is_child,:age
  do begin
    execute procedure IMPORT_GUEST$EXC(:booking_id, null, null, :profile_name, :is_child, :age, null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null)
    returning_values :guest_id, :err_code,:err_text;
    if (0 <> :err_code) then exception WRONG_VALUE ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');
  end
  ----------------

  select RD.number_2
  from   RESERV_DETAIL RD
  where  RD.id_reserv_detail = :booking_id
  into   :number_2;

  update PRODUCT_SELECTION$WBE uPS
  set    uPS.booking_id = :booking_id, uPS.selection_id = :number_2
  where  uPS.id = :product_selection_id;
end
^

/* Alter (CREATE_SESSION_BOOKINGS$WBE) */
ALTER PROCEDURE CREATE_SESSION_BOOKINGS$WBE(WBE_SESSION_ID BIGINT,
ARANGER_ID INTEGER,
LANG_CODE VARCHAR(3))
 RETURNS(SELECTION_ID VARCHAR(20),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable product_selection_id bigint;
declare variable next_num integer;
declare variable sel_cnt integer;
declare variable aranger_name varchar(100);
declare variable aranger_email varchar(50);
declare variable aranger_phone varchar(50);
declare variable booking_id integer;
declare variable record_timestamp timestamp;
declare variable new_res_number varchar(62);
declare variable room_types_src varchar(255) = '';
declare variable rates_src varchar(255) = '';
declare variable hotel_id integer;
declare variable profile_id integer;
declare variable from_date date;
declare variable to_date date;
declare variable day_count integer;
declare variable room_type_id integer;
declare variable rate_id integer;
declare variable query_id_tmp integer;
declare variable rooms_required integer;
declare variable rooms_available integer;
declare variable profile_import_time timestamp;
begin
  execute procedure EXPORT_LOG_FORCE$EXC(1);
  /* test overbook (multiuser) */
   for select ws.hotel_id,ws.profile,aq.first_date,(aq.first_date+aq.day_count)-1,pa.room_type_id,pa.rate_id,aq.day_count
    from   PRODUCT_availability$WBE PA
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    join availability_query$wbe aq on aq.id = pa.query_id
   where ws.id = :wbe_session_id and coalesce(pa.room_count,0) > 0
   into  :hotel_id, :profile_id, :from_date, :to_date, :room_type_id, :rate_id , :day_count
   do begin
       room_types_src = :room_types_src||','||cast(:room_type_id as varchar(10));
       rates_src = :rates_src||','||cast(rate_id as varchar(10));
   end

   query_id_tmp = GEN_ID(AVAILABILITY_QUERY$WBE_SEQ,1);
   insert into availability_query$wbe(ID, WBE_SESSION_ID, FIRST_DATE, DAY_COUNT)    -- prevent FK exception
    values (:query_id_tmp,:wbe_session_id,:from_date,:day_count) ;

   execute procedure availability_occup_small$wbe(:from_date,:to_date,:hotel_id,:query_id_tmp,1,:rates_src,:room_types_src) ;

   --  check minimum available rooms for every day
   err_code = null;
   err_text = '';
   for select pa.room_type_id,pa.room_count,
    (select coalesce(min(art.available_rooms),0) from availability_room_type$wbe art
      where art.query_id = :query_id_tmp and art.room_type_id = pa.room_type_id)
    from product_availability$wbe pa
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    where ws.id = :wbe_session_id
    and coalesce(pa.room_count,0) > 0   into :room_type_id,:rooms_required,:rooms_available
   do begin
       if (rooms_required > rooms_available) then
       begin
        err_code = 1;
        ERR_TEXT = coalesce(ERR_TEXT,'')||:room_type_id||';';
       end
   end
   delete from availability_query$wbe aqt where aqt.id = :query_id_tmp;       -- remove temp query
   if (err_code is not null) then exit;

  /* create profile if not exist and reservations > 1*/
  if (aranger_id is NULL) then
  begin
    select WS.person_name,WS.address,WS.phone
    from   WBE_SESSION$WBE WS
    where  WS.id = :wbe_session_id
    into   :aranger_name,:aranger_email,:aranger_phone;

    execute procedure IMPORT_PERSON_PROFILE$EXC(
       uuid_create(),:aranger_name,null,null,null,null,null,null,null,null,null,null,
       null,null,null,null,:aranger_phone,null,:aranger_email,null,null,null,null,null,null,
       STRHASH_LARGE(substring(uuid_create() from 1 for 4)),null,null,null,null,null,null,null,null, null, null)
    returning_values :aranger_id, :profile_import_time;

    update WBE_SESSION$WBE uWS
    set    uWS.profile = :aranger_id
    where  uWS.id = :wbe_session_id;
  end else begin
    -- da podmeni email, phone ako !!
  end
  /* create reservations */
  for
    select PS.id
    from   PRODUCT_SELECTION$WBE PS
    where  PS.wbe_session_id = :wbe_session_id
           and PS.booking_id is null
           and coalesce(PS.is_deleted,0) <> 1
    into   :product_selection_id
  do begin
     if (next_num = 1) then begin      -- increment first reservation number_3
      execute procedure res_number_suffix_gen(:booking_id) returning_values :new_res_number;
      next_num = next_num + 1;
     end
     execute procedure CREATE_BOOKING$WBE(:product_selection_id,:aranger_id,'WBE.'||:selection_id||'.'||:next_num) returning_values :booking_id,:selection_id;
     execute procedure IMPORT_BOOKING_FINALIZE$EXC(:booking_id) returning_values  record_timestamp,:err_code,:err_text;
     insert into SCHEDULER$WBE(booking_id,status,last_action_time,lang_code,guarantee_passed) values (:booking_id, NULL, current_timestamp, :lang_code,0);

     if (next_num is NULL) then begin
      next_num = 1;
     end else begin
      next_num = next_num + 1;
     end
  end
end
^

/* Alter (EAI_IMPORT_ALOYALTY_CLIENT) */
ALTER PROCEDURE EAI_IMPORT_ALOYALTY_CLIENT(CLIENT_UUID VARCHAR(40),
CLIENT_NAME VARCHAR(100),
CARD_CODE VARCHAR(50),
IS_ARHIVE SMALLINT,
DATE_OF_BIRTH DATE)
 AS
declare variable PROFILE_ID integer;
  declare variable IMPORT_TIME timestamp;
begin
  execute procedure IMPORT_PERSON_PROFILE$EXC(:CLIENT_UUID, :CLIENT_NAME, null, :DATE_OF_BIRTH, null, null,
    null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null,
    :IS_ARHIVE, :CARD_CODE, null, null, null, null, null, null, null, null, null, null, 'null-uuid')
  returning_values :PROFILE_ID, :IMPORT_TIME;
end
^

/* Alter (EAI_POS_CHECK_CARD$P2E) */
ALTER PROCEDURE EAI_POS_CHECK_CARD$P2E(IN_CARD_NUMBER VARCHAR(50),
ID_HOTEL INTEGER)
 RETURNS(ID_GUEST INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100),
GUEST_NAME VARCHAR(100),
ROOM_NAME VARCHAR(20),
BOARD_NAME VARCHAR(30))
 AS
declare variable id_guest_check integer;
  declare variable check_status integer;
  declare variable to_date date;
  declare variable check_date date;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  if (coalesce(:IN_CARD_NUMBER, '') = '') then begin
     ERR_CODE = -401;
     ERR_TEXT = '';
     suspend;
     exit ;
  end

  select max(GD.ID_GUEST), min(GD.ID_GUEST)
  from   GUEST_DATA GD
         join GUEST G on G.ID_GUEST = GD.ID_GUEST
         join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
  where  GD.GUEST_CODE = :IN_CARD_NUMBER
         and RD.ID_HOTEL = :ID_HOTEL
         and rd.IS_ANUL = 0
         and rd.CHECK_STATUS >= 0
  into   :ID_GUEST, :ID_GUEST_CHECK;

  if (:ID_GUEST is null) then begin
     ERR_CODE = -402;
     ERR_TEXT = '';
     suspend;
     exit;
  end

  if (:ID_GUEST <> :ID_GUEST_CHECK) then begin
     ERR_CODE = -403;
     ERR_TEXT = '';
     suspend;
     exit;
  end
  /*FIND SYSTEM DATE - check to today, not to system date - for security*/

  select  TO_DATE, G.CHECK_STATUS
  from    GUEST G
  where   ID_GUEST = :ID_GUEST
  into    :TO_DATE, :CHECK_STATUS;

  if ((:TO_DATE < current_date) or (:CHECK_STATUS = 1)) then  begin
     ERR_CODE = -404;
     ERR_TEXT = '';
     suspend;
     exit;
  end

  check_date = iif(current_date = :to_date, current_date - 1, current_date);

  select GC.GUEST_NAME1, R.ROOM_NAME,
         (select m.NAME
          from   GUEST_STAY gs
                 join MEALS M on m.ID_BOARD = gs.ID_BOARD
          where  gs.ID_GUEST = g.ID_GUEST
                 and gs.FOR_DATE = :check_date)
  from   GUEST_CARD GC
         join GUEST G on G.ID_GUEST = GC.ID_GUEST
         join ROOMS R on G.ID_ROOM = R.ID_ROOM
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME, :ROOM_NAME, :BOARD_NAME;

  suspend;
end
^

/* Alter (EAI_POS_GET_GUESTS$P2E) */
ALTER PROCEDURE EAI_POS_GET_GUESTS$P2E(IN_ROOM_NAME VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(OUT_ID_GUEST INTEGER,
OUT_GUEST_NAME VARCHAR(100),
OUT_FROM_DATE DATE,
OUT_TO_DATE DATE,
OUT_OK_FOR_POST INTEGER,
OUT_COUNTRY VARCHAR(30),
OUT_TEXT VARCHAR(100),
OUT_BOARD_NAME VARCHAR(30),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100))
 AS
declare variable id_room integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  OUT_GUEST_NAME = null;

  /*FIND ROOM*/
  select R.ID_ROOM
  from   ROOMS R
         join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
  where  R.ROOM_NAME = :IN_ROOM_NAME
         and RT.ID_HOTEL = :ID_HOTEL
  into   :ID_ROOM;
  if ((:ID_ROOM is null) or (:ID_ROOM <= 0) ) then begin
    ERR_CODE = -5;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Room number not found!    ! ';
    suspend;
    exit;
  end

  /*FIND GUESTS*/
  for
    select G.ID_GUEST, GC.GUEST_NAME1, G.FROM_DATE, G.TO_DATE, C.COUNTRY_NAME,
           (select m.NAME
            from   GUEST_STAY gs
                   join MEALS M on m.ID_BOARD = gs.ID_BOARD
            where  gs.ID_GUEST = g.ID_GUEST
                   and gs.FOR_DATE = iif(current_date = g.to_date, current_date - 1, current_date))
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
           left outer join GUEST_CARD GC on G.ID_GUEST = GC.ID_GUEST
           left outer join COUNTRY C on C.COUNTRY_CODE = GC.COUNTRY
    where  G.ID_ROOM = :ID_ROOM
           and G.CHECK_STATUS = 0
           and rd.IS_ANUL = 0
    into   :OUT_ID_GUEST, :OUT_GUEST_NAME, :OUT_FROM_DATE,  :OUT_TO_DATE, :OUT_COUNTRY, :OUT_BOARD_NAME
  do begin
    OUT_OK_FOR_POST = iif(:OUT_TO_DATE < current_date, 0, 1) ;
    suspend;
  end

  if (:OUT_GUEST_NAME is null) then begin
    ERR_CODE = -1;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Guests not found!     !';
    suspend;
  end
end
^

ALTER PROCEDURE IMPORT_COMMON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
LOOKUP_BY_NAME SMALLINT,
PROFILE_NAME_NEW VARCHAR(100),
PHONE_NEW VARCHAR(50),
FAX_NEW VARCHAR(50),
EMAIL_NEW VARCHAR(50),
CITY_NEW VARCHAR(100),
ADDRESS_NEW VARCHAR(100),
MARKET_SEGMENT_NEW VARCHAR(30),
NOTE_NEW VARCHAR(255),
IS_ARCHIVE_NEW SMALLINT,
WBE_PASSWORD_NEW VARCHAR(20),
ACCOUNT_NO_NEW VARCHAR(20),
MSG_NEW VARCHAR(2000),
PROFILE_TYPE VARCHAR(50),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
ID_BONUSPOINT_SCHEME INTEGER,
ID_DEF_CONTRAGENT INTEGER,
WBE_PASSWORD VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(2000),
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT)
 AS
declare variable profile_dbkey char(8);
declare variable hotel_id integer;
begin
  execute procedure import_mark_transaction$exc;

  execute procedure sys_dbg('exc IMPORT_COMMON_PROFILE$EXC(:profile_uuid=>' || coalesce(:profile_uuid, '<null>') || ')');
  profile_id = null;
  PROFILE_NAME = :PROFILE_NAME_NEW;
  PHONE = :PHONE_NEW;
  FAX = :FAX_NEW;
  EMAIL = :EMAIL_NEW;
  CITY = :CITY_NEW;
  ADDRESS = :ADDRESS_NEW;
  MARKET_SEGMENT = :MARKET_SEGMENT_NEW;
  NOTE = :NOTE_NEW;
  IS_ARCHIVE = :IS_ARCHIVE_NEW;
  ID_BONUSPOINT_SCHEME = null;
  WBE_PASSWORD = :WBE_PASSWORD_NEW;
  ACCOUNT_NO = :ACCOUNT_NO_NEW;
  MSG = :MSG_NEW;

  if (:PROFILE_UUID is null) then begin
    execute procedure sys_dbg('exc IMPORT_COMMON_PROFILE$EXC <null> :profile_uuid - exit;');
    exit;
  end
  /*
  execute procedure lookup_guarantee_policy$exc(:PROFILE_NAME, :PROFILE_TYPE, :guarantee_policy_new)
  returning_values :id_guarantee_policy_new;
  */
  if (1 = :lookup_by_name) then begin
    execute procedure LOOKUP_PROFILE$EXC(:profile_uuid, :profile_name_new)
    returning_values :profile_dbkey, :profile_id;
  end else begin
    execute procedure LOOKUP_PROFILE$EXC(:profile_uuid, null)
    returning_values :profile_dbkey, :profile_id;
  end

  if (:profile_dbkey is not null) then begin
    select  p.id_profile,
            p.PROFILE_NAME,
            p.PHONE,
            p.FAX,
            p.EMAIL,
            p.CITY,
            p.ADDRESS,
            ms.segment_name,
            p.NOTE,
            p.IS_ARCHIVE,
            p.ID_DEF_CONTRAGENT,
            p.wbe_password,
            P.ACCOUNT_NO,
            P.MSG,
            P.IS_EXCLUSIVE_DEBT_OWNERSHIP
    from    profile p
            left outer join nom_market_segments ms on ms.id_nom_market_segment=p.id_nom_market_segment
    where p.rdb$db_key = :profile_dbkey
    into    :profile_id,
            :profile_name,
            :phone,
            :fax,
            :email,
            :city,
            :address,
            :market_segment,
            :note,
            :is_archive,
            :ID_DEF_CONTRAGENT,
            :WBE_PASSWORD,
            :ACCOUNT_NO,
            :MSG,
            :is_exclusive_debt_ownership;

    if (:hotel_uuid_list is not null) then begin
      for select h.id_hotel
      from hotel h
      where :hotel_uuid_list containing h.uuid
      into :hotel_id do begin
        delete from PROFILE_HOTEL_RATE phr where phr.ID_PROFILE = :profile_id and phr.id_hotel = :hotel_id;
      end
    end
  end

  PROFILE_NAME = coalesce(:PROFILE_NAME_NEW, :PROFILE_NAME);
  PHONE = coalesce(:PHONE_NEW, :PHONE);
  FAX = coalesce(:FAX_NEW, :FAX);
  EMAIL = coalesce(:EMAIL_NEW, :EMAIL);
  CITY = coalesce(:CITY_NEW, :CITY);
  ADDRESS = coalesce(:ADDRESS_NEW, :ADDRESS);
  MARKET_SEGMENT = coalesce(:MARKET_SEGMENT_NEW, :MARKET_SEGMENT);
  NOTE = coalesce(:NOTE_NEW, :NOTE);
  IS_ARCHIVE = coalesce(:IS_ARCHIVE_NEW, :IS_ARCHIVE, 0);
  WBE_PASSWORD = coalesce(:WBE_PASSWORD_NEW, :WBE_PASSWORD);
  ACCOUNT_NO = coalesce(:ACCOUNT_NO_NEW, :ACCOUNT_NO);
  MSG = coalesce(:MSG_NEW, :MSG);
  suspend;
end
^

ALTER PROCEDURE PROFILE_AGENT_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
IS_ARCHIVE INTEGER,
AGENT_GROUP VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IATA_NUMBER VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null,
THRESHOLD_NOTE VARCHAR(255) = null,
THRESHOLD_AMOUNT NUMERIC(15,4) = null,
THRESHOLD_CURR CHAR(3) = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable id_agent integer;
  declare variable action_text varchar(255);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  AGENT_GROUP = nullif(trim(:AGENT_GROUP), '');

  if (:operation in ('add', 'mod')) then begin
    execute procedure PROFILE_COMMON_MODIFY$INT(:id_profile, 'AGENT', :profile_name,
            :phone, :fax, :email, :contact_city, :contact_address,
            :note, :msg, :is_archive, :id_def_contragent, :id_nom_market_segment,
            :wbe_password, :account_no, :is_exclusive_debt_ownership)
    returning_values (:NEW_ID_PROFILE);

    if (:new_id_profile is distinct from :id_profile) then begin
      id_agent = gen_id(G_AUTO_INC_AGENT,1);
      insert into AGENT (ID_AGENT, AGENT_NAME, IS_USE)
      values (:id_agent, :profile_name, 1-:is_archive);
  
      insert into PROFILE_AGENT(ID_PROFILE, ID_AGENT, AGENT_GROUP, COUNTRY_CODE, IATA_NUMBER, THRESHOLD_NOTE, THRESHOLD_AMOUNT, THRESHOLD_CURR)
      values (:new_id_profile, :id_agent, :agent_group, :country_code, :iata_number, :threshold_note, :threshold_amount, :threshold_curr);
  
      action_text = f_character(29) || :profile_name;
      execute procedure SYSTEM_LOG_ADD ('PROFILE', :new_id_profile, 'CREATE_AGENT_PROFILE', :action_text);
    end else begin
      select PA.ID_AGENT
      from   PROFILE_AGENT PA
      where  PA.ID_PROFILE = :NEW_ID_PROFILE
      into   :id_agent;

      update PROFILE_AGENT PA
      set    PA.IATA_NUMBER = :IATA_NUMBER,
             PA.COUNTRY_CODE = :COUNTRY_CODE,
             PA.AGENT_GROUP = :AGENT_GROUP,
             PA.THRESHOLD_NOTE = :THRESHOLD_NOTE,
             PA.THRESHOLD_AMOUNT = :THRESHOLD_AMOUNT,
             PA.THRESHOLD_CURR = :THRESHOLD_CURR
      where  PA.ID_PROFILE = :NEW_ID_PROFILE;

      update AGENT A
      set    A.AGENT_NAME = :profile_name,
             A.IS_USE = 1 - :is_archive
      where  A.ID_AGENT = :id_agent;
    end
  end else if (:operation = 'del') then  begin
    execute procedure PROFILE_DELETE$INT(:id_profile);

    new_id_profile = null;
  end
end
^

/* Alter (IMPORT_AGENT_PROFILE$EXC) */
ALTER PROCEDURE IMPORT_AGENT_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
AGENT_GROUP VARCHAR(50),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
WBE_PASSWORD VARCHAR(20),
IATA_NUMBER VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(2000),
DEF_CONTRAGENT_NAME VARCHAR(100),
THRESHOLD_NOTE VARCHAR(255),
THRESHOLD_AMOUNT NUMERIC(15,4),
THRESHOLD_CURR CHAR(3),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
declare variable op varchar(10);
  declare variable market_segment_id integer;
  declare variable agent_group_old varchar(50);
  declare variable id_bonuspoint_scheme integer;
  declare variable id_def_contragent integer;
  declare variable is_exclusive_debt_ownership smallint;
  declare variable country_code_old varchar(10);
  declare variable profile_receiver_id integer;
  declare variable discount_id integer;
begin
  profile_id = null;
  import_time = null;

  execute procedure import_mark_transaction$exc;

  execute procedure sys_dbg('exc IMPORT_AGENT_PROFILE$EXC(:profile_uuid=>' || coalesce(:profile_uuid, cast('<null>' as varchar(40)) ) || ')');
  profile_id = null;
  if (:PROFILE_UUID is null) then begin
    execute procedure sys_dbg('exc IMPORT_AGENT_PROFILE$EXC <null> :profile_uuid - exit;');
    exit;
  end

  select p.profile_id, p.profile_name, p.phone, p.fax, p.email, p.city,
         p.address, p.market_segment, p.note, p.is_archive, p.id_bonuspoint_scheme,
         p.id_def_contragent, pa.agent_group, p.wbe_password,
         p.msg, p.account_no, p.is_exclusive_debt_ownership, pa.country_code
  from   IMPORT_COMMON_PROFILE$EXC(:PROFILE_UUID, 1, :PROFILE_NAME,
         :PHONE, :FAX, :EMAIL, :CITY, :ADDRESS, :MARKET_SEGMENT, :NOTE, :IS_ARCHIVE, :WBE_PASSWORD, :ACCOUNT_NO, :MSG,  'AGENT_PROFILE', :HOTEL_UUID_LIST) p
         left outer join profile_agent pa on pa.id_profile = p.profile_id
  into   :profile_id, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :id_bonuspoint_scheme,
         :id_def_contragent, :agent_group_old, :wbe_password,
         :msg, :account_no, :is_exclusive_debt_ownership, :country_code_old;

  if (:profile_id is null) then begin
    op = 'add';
  end else if (:hotel_uuid_list is null) then begin
    profile_id = null;
    exit;
  end else begin
    op = 'mod';
    if (:hotel_uuid_list is not null) then begin
      for
        select d.id_sale_discount
        from   sale_discount d
               join hotel h on h.id_hotel = d.id_hotel
        where  :hotel_uuid_list containing h.uuid
        into   :discount_id
      do begin
        delete from PROFILE_DISCOUNT pd
        where  pd.ID_PROFILE = :profile_id
               and pd.id_sale_discount = :discount_id;
      end
    end

    delete from PROFILE_BONUSPOINT_SCHEME bs
    where  bs.ID_PROFILE = :profile_id;
  end

  AGENT_GROUP=coalesce(:AGENT_GROUP, :AGENT_GROUP_OLD);
  country_code=coalesce(:country_code, :country_code_old);

  execute procedure LOOKUP_MARKET_SEGMENT$EXC(:profile_name, 'AGENT_PROFILE', :market_segment)
  returning_values :market_segment_id;

  if ((def_contragent_name is not null) and (def_contragent_name <> '')) then begin
    execute procedure LOOKUP_CONTRAGENT$EXC(:profile_name, 'AGENT_PROFILE', :def_contragent_name)
    returning_values :id_def_contragent;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:profile_name, 'AGENT_PROFILE');

  execute procedure sys_dbg('exc IMPORT_AGENT_PROFILE$EXC - profile_agent_modify$profile(:profile_uuid=>' || coalesce(:profile_uuid,cast('<null>' as varchar(40)))
    || ', :operation=>' || coalesce(:op, cast('<null>' as varchar(10)) )
    || ', :market_segment_id=>' || coalesce(cast(:market_segment_id as varchar(10)) , cast('<null>' as varchar(10)) )
    || ')');

  if (:hotel_uuid_list is null) then begin
    -- in "non authoritive" mode (i.e. embeded mode transfer only profile key fields )
    --profile_name = null;
    phone = null;
    fax = null;
    email = null;
    country_code = null;
    city = null;
    address = null;
    note = null;
    msg = null;
    --is_archive = null;
    agent_group = null;
    id_def_contragent = null;
    market_segment_id = null;
    id_bonuspoint_scheme = null;
    wbe_password = null;
    account_no = null;
    --iata_number = null;
    is_exclusive_debt_ownership = null;
  end

  execute procedure profile_agent_modify$profile(
    :profile_id, :profile_name, :phone, :fax, :email,
    :country_code, :city, :address, :note, :msg, :is_archive, :agent_group, :id_def_contragent, :market_segment_id,
    :wbe_password, :op, :account_no, :iata_number, :is_exclusive_debt_ownership,
    :threshold_note, :threshold_amount, :threshold_curr)
  returning_values :profile_id;

  /*assign UUID to the new profiles*/
  if ('add' = :op) then begin
    update profile
    set    uuid = :profile_uuid
    where  id_profile = :profile_id;
  end

  select record_timestamp
  from   profile
  where  id_profile = :profile_id
  into   :import_time;

  if (:MERGE_TARGET_UUID is not null) then begin
    select p.ID_PROFILE
    from   PROFILE P
    where  P.UUID = :MERGE_TARGET_UUID
    into   :profile_receiver_id;

    execute procedure PROFILE_MERGE$PROFILE (:PROFILE_ID, :profile_receiver_id, 'merge');

  end
end
^

/* Alter (OCCUPANCY_RTI_BP$RPT) */
ALTER PROCEDURE OCCUPANCY_RTI_BP$RPT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ROOM_TYPES VARCHAR(255))
 RETURNS(OUT_DATE DATE,
CATEGORY VARCHAR(50),
AGENT_NAME VARCHAR(50),
ROOM_CNT INTEGER)
 AS
declare variable capacity integer;
declare variable ooi integer;
declare variable busy integer;
declare variable res_conf integer;
declare variable res_notconf integer;
declare variable bp_total integer;
declare variable sold_total integer;
declare variable total_bp_remains integer;
begin
  execute procedure AVAILABILITY_OCCUP_PREPARE$AVL (:FROM_DATE, :TO_DATE, 1, 1, 0, 1, 1, 0, 1, 0, :ID_HOTEL);

  for
    select t.FOR_DATE,
           sum(t.G_CAPACITY),
           sum(t.G_OOI),
           sum(t.SOLD),
           sum(t.RES_CONFIRMED),
           sum(t.RES_NOTCONFIRMED)
    from   SMART_OCCUP$TMP T
           join ROOM_TYPES rt on rt.ID_ROOM_TYPE = t.ID_ROOM_TYPE
    where  ','||:room_types||',' containing ','||rt.type_room||','
    group by 1
    into  :OUT_DATE, :capacity, :ooi, :busy, :res_conf, :res_notconf
  do begin
    CATEGORY = '1.Capacity';
    AGENT_NAME = '';
    ROOM_CNT = :capacity;
    suspend;
    CATEGORY = '2.OOI';
    AGENT_NAME = '';
    ROOM_CNT = :ooi;
    suspend;
    CATEGORY = '3.Available';
    AGENT_NAME = '';
    ROOM_CNT = :capacity - :ooi;
    suspend;
    CATEGORY = '4.Check in';
    AGENT_NAME = '';
    ROOM_CNT = :busy;
    suspend;
    CATEGORY = '5.Confirmed';
    AGENT_NAME = '';
    ROOM_CNT = :res_conf;
    suspend;
    CATEGORY = '6.Tentative';
    AGENT_NAME = '';
    ROOM_CNT = :res_notconf;
    suspend;
    CATEGORY = '7.Total sold';
    AGENT_NAME = '';
    ROOM_CNT = :busy + :res_conf + :res_notconf;
    suspend;
    CATEGORY = '8.Free';
    AGENT_NAME = '';
    ROOM_CNT = :capacity - :ooi - :busy - :res_conf - :res_notconf;
    suspend;

    CATEGORY = '9.RTI-BP';
    total_bp_remains = 0;
    for
      select '9.'||P.PROFILE_NAME as agent_name, sum(AO.CONT_BP), sum(ao.SOLD + ao.RES_CONFIRMED + ao.RES_NOTCONFIRMED)
      from   SMART_OCCUP$TMP AO
             join ROOM_TYPES rt on rt.id_room_type = ao.id_room_type
             left outer join PROFILE_AGENT PA on PA.ID_AGENT = AO.ID_AGENT
             left outer join PROFILE P on P.ID_PROFILE = pa.ID_PROFILE
      where  AO.FOR_DATE = :OUT_DATE
             and ','||:room_types||',' containing ','||rt.type_room||','
      group by 1
      having (sum(AO.CONT_BP) > 0) or (sum(ao.SOLD + ao.RES_CONFIRMED + ao.RES_NOTCONFIRMED) > 0)
      into   :CATEGORY/*:AGENT_NAME*/, :bp_total, :sold_total
    do begin
      AGENT_NAME = 'Total BP';
      ROOM_CNT = :bp_total;
      suspend;

      AGENT_NAME = 'Sold rooms';
      ROOM_CNT = :sold_total;
      suspend;

      AGENT_NAME = 'BP-remain';
      if (:bp_total < :sold_total) then ROOM_CNT = 0;
      else ROOM_CNT = :bp_total - :sold_total;
      suspend;

      total_bp_remains = :total_bp_remains + :ROOM_CNT;
    end 

    CATEGORY = 'Occupancy %';
    AGENT_NAME = '';
    ROOM_CNT =  iif((:capacity - :ooi) = 0, 0, cast(:busy + :res_conf + :res_notconf + :total_bp_remains as double precision) / (:capacity - :ooi)) * 100;
    suspend;

    CATEGORY = 'Remain';
    AGENT_NAME = '';
    ROOM_CNT = :capacity - :ooi - :busy - :res_conf - :res_notconf - :total_bp_remains;
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: EAI_POS_POSTING_ADD$P2E for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PMS_POSTING_CREATE$INT for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
POST_DATE /* TYPE OF TDATE */ DATE,
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
POST_ON_PMS_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT,
IS_OWNER_INCOME /* TYPE OF TLOGICAL */ SMALLINT,
ID_ROOM /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_ACCOUNT_POST /* ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_FINALIZE$POST for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_TELECOUNT_CALL$INT for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_ACCOUNT$INT) */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
QTY TYPE OF TQTY,
ID_SECQUENCE TYPE OF ID,
IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
POST_TEXT TYPE OF TDESCRIPTION_SHORT,
RESOURCE_TEXT TYPE OF TREASON,
DATE_POST TYPE OF TDATE,
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ID_ROOM TYPE OF ID = null,
POST_DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable action_text varchar(255);
begin
  if (:date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :date_post;
  end
/* NO AUTO PRICE !!!!!!
  if (:in_is_manual_price = 0) then begin

    select P.ID_EXTRA_TARIFF
    from   ACCOUNT A
           join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
    where  A.ID_ACCOUNT = :in_id_account
    into   :id_extra_tarifa;
    if ((:id_extra_tarifa is null) or (:id_extra_tarifa < 0)) then begin
      err_code = -14;
      exit;
    end
    execute procedure TAR_RECALC_EXTRASRV(:id_extra_tarifa, :in_id_service, :in_date_post)
    returning_values  :err_code, :err_text, :post_price, :post_currency;
    if (:err_code < 0) then exit;
  end else begin
    --MANUAL PRICE
    post_currency = :manual_curr ;
    post_price = :manual_price ;
  end
*/

  post_currency = :manual_curr ;
  post_price = :manual_price ;
  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, -1, :id_secquence, :date_post, :id_service, -1, :id_room, 0, :qty, :post_price,
    :post_currency, null, :short_code, :from_date, :to_date, :post_text, :resource_text, '', -1, :POST_DESCRIPTION)
  returning_values :err_code, :err_text, :id_account_post;
  if (:err_code <> 0) then exit;

  select S.SERVICE_NAME
  from   SERVICES S
  where  S.ID_SERVICE = :ID_SERVICE
  into   :action_text;
   
  action_text = f_character(29) || coalesce(:action_text, '')
                || f_character(28) || formatdate(:DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || coalesce(:post_currency, '');
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_RESERVATION$INT for: POST_SERVICE_ON_GUEST$INT */
ALTER PROCEDURE POST_SERVICE_ON_RESERVATION$INT(ID_RESERV_DETAIL /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_ROOM for: POST_SERVICE_ON_GUEST$INT */
ALTER PROCEDURE POST_SERVICE_ON_ROOM(IN_ID_ROOM /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255))
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_GUEST /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_GUEST$INT) */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TDESCRIPTION_SHORT,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ACCOUNT_ROUTING TYPE OF TSHORT_CODE,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable id_room integer;
  declare variable no_use varchar(255);
  declare variable action_text varchar(255);
  declare variable is_guest_check_in smallint;
  declare variable service_name varchar(50);
begin
  err_code = 0;
  err_text = '';

  select g.check_status
  from   guest g
  where  g.id_guest = :in_id_guest
  into   :is_guest_check_in;

  if (:is_guest_check_in < 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
  end

  execute procedure GUEST_GET_POSTING_ACCOUNT$INT (:in_id_guest, :account_routing)
  returning_values  :id_account, :id_room;

  if (:in_date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :in_date_post;
  end

  if (:in_is_manual_price = 0) then begin
    execute procedure SERVICE_GET_POSTING_DETAILS(:in_id_service, :IN_DATE_POST)
    returning_values  :no_use, :no_use, :service_name, :post_price, :post_currency;
  end else begin
    /* MANUAL PRICE */
    post_currency = :manual_curr;
    post_price = :manual_price;
    select s.SERVICE_NAME
    from   SERVICES s
    where  s.ID_SERVICE = :IN_ID_SERVICE
    into   :service_name;
  end

  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, :in_id_guest, :in_id_secquence, :in_date_post, :in_id_service, -1, :id_room, 0, :in_qty,
    :post_price, :post_currency, null, :in_short_code, :in_from_datetime, :in_to_datetime, :in_post_text,
    :in_resource_text, '', -1, :DESCRIPTION)
  returning_values  :err_code, :err_text, :id_account_post;

  action_text = f_character(29) || coalesce(:service_name, '')
                || f_character(28) || formatdate(:IN_DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:IN_QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || coalesce(:post_currency, '');
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: RESOURCE_RESERVATION_CHECK_IN for: POST_SERVICE_ON_RESERVATION$INT */
ALTER PROCEDURE RESOURCE_RESERVATION_CHECK_IN(ID_RESOURCE_RESERVATION INTEGER,
SERVICE_PRICE NUMERIC(15,2),
SERVICE_CURR VARCHAR(3))
 RETURNS(OUT_ID_ACCOUNT INTEGER,
OUT_ID_ACCOUNT_POST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_RESERVATION$INT) */
ALTER PROCEDURE POST_SERVICE_ON_RESERVATION$INT(ID_RESERV_DETAIL TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TREASON,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable id_guest integer;
begin
  err_code = 0;
  err_text = '';

  id_guest = null;
  select RD.ID_TITULAR
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :id_guest;

  execute procedure POST_SERVICE_ON_GUEST$INT(:id_guest, :in_id_service, :in_qty, :in_id_secquence,
                    :in_is_manual_price, :manual_price, :manual_curr, :in_from_datetime, :in_to_datetime,
                    :in_post_text, :in_resource_text, :in_date_post, :in_short_code, '', :DESCRIPTION)
  returning_values  :err_code, :err_text, :id_account, :id_account_post;
end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_POST_TO_MH_FRONT_ONLINE for: POST_SERVICE_ON_ROOM */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_SERVICE_POST for: POST_SERVICE_ON_ROOM */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_ROOM) */
ALTER PROCEDURE POST_SERVICE_ON_ROOM(IN_ID_ROOM TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TREASON,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_GUEST TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
begin
  err_code = 0;
  err_text = '';

  id_guest = null;
  select first 1 G.ID_GUEST
  from   GUEST G
  where  G.ID_ROOM = :in_id_room
         and G.CHECK_STATUS = 0
  order by G.FROM_DATE desc, G.ID_GUEST asc
        /************************************************/
        /* DESCENDANT ORDER IS VERY IMPORTANT!!         */
        /* IF TWO GUESTS HAVE:                          */
        /* TO_DATE OF THE 1'ST = FROM_DATE OF THE 2'ND, */
        /* THEN PHONACALLS SHOULD GO TO THE 2'ND        */         
        /************************************************/
  into   :id_guest;

  if (:id_guest is null) then begin
    err_code = -24;   /* NO GUESTS ARE CHECKED_IN INTO THE REQUESTED ROOM! */
    exit;
  end

  execute procedure POST_SERVICE_ON_GUEST$INT(:id_guest, :in_id_service, :in_qty, :in_id_secquence, :in_is_manual_price,
    :manual_price, :manual_curr, :in_from_datetime, :in_to_datetime, :in_post_text, :in_resource_text,
    :in_date_post, :in_short_code, '')
  returning_values  :err_code, :err_text, :id_account, :id_account_post;
end
^

/* empty dependent procedure body */
/* Clear: EAI_TELECOUNT_TRANSFER for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALL_POST$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL /* ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALLS_POST_TO_ACCOUNT$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_TELECOUNT_TRANSFER$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_TELECOUNT_CALL$INT) */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ext_ifc_name varchar(20);
  declare variable room_name varchar(30);
  declare variable datetime_call timestamp;
  declare variable price numeric(15,2);
  declare variable dial_number varchar(50);
  declare variable units integer;
  declare variable pc_id_service integer;
  declare variable def_manual_curr char(3);
  declare variable post_text varchar(50);
  declare variable id_account_post integer;
  declare variable is_archive integer;
  declare variable id_account integer;
  declare variable new_id_account_post integer;
  declare variable pc_tag varchar(30);
  declare variable number_zone varchar(50);
  declare variable id_hotel integer;
  declare variable id_phonecall integer;
  declare variable no_use varchar(255);
begin
  /* Description:
  || POST_TO_TYPE = 0 - ACCOUNT, 1 - GUEST, 2 - RESERV_DETAIL, 3 - JUST PREPARE, FOR EXTERNAL CLIENT
  */
  err_code = 0;
  err_text = '';
  ext_ifc_name = 'TELECOUNT';

  select PC.ID_PHONECALL, PC.ROOM_NAME, PC.DATETIME_CALL, PC.PRICE, PC.DIAL_NUMBER, PC.UNITS,
         PC.ID_ACCOUNT_POST, PC.IS_ARCHIVE, PC.TAG, substring(PC.NUMBER_ZONE from 1 for 30), pc.ID_HOTEL
  from   PHONECALLS PC 
  where  PC.rdb$db_key = :ph_dbkey
  into   :id_phonecall, :room_name, :datetime_call, :price, :dial_number, :units,
         :id_account_post, :is_archive, :pc_tag, :number_zone, :id_hotel;

  if ((:is_archive = 1) or (coalesce(:id_account_post, 0) > 0)) then exit;

  if ((:pc_tag is null) or (:pc_tag = '')) then pc_tag = 'TELECOUNT_DEFAULT';
  else pc_tag = 'TELECOUNT_' || :pc_tag;

  execute procedure EAI_MAP_SERVICE(:pc_tag, :number_zone, :ext_ifc_name, :id_hotel)
  returning_values  :err_code, :err_text, :pc_id_service;
  if (:err_code < 0) then exit;

  post_text = substring(:dial_number || ', impulses ' || :units from 1 for 50);

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :def_manual_curr;

  new_id_account_post = null;
  if (:post_to_type = 0) then begin
    id_account = :post_to_id;
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name)
    returning_values :err_code, :err_text, :new_id_account_post;
  end else if (:post_to_type = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:post_to_id, :pc_id_service, 1, -1, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name, '')
    returning_values :err_code, :err_text, :id_account, :new_id_account_post;
  end else if (:post_to_type = 2) then begin
    execute procedure POST_SERVICE_ON_RESERVATION$INT(:post_to_id, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name)
    returning_values :err_code, :err_text, :id_account, :new_id_account_post;
  end else if (:post_to_type = 3) then begin
    execute procedure POST_PREPARE_ON_ACCOUNT$POST (:post_to_id, :pc_id_service,
      1, :ID_SEQUENCE, :price, :def_manual_curr, :post_text, null, null, :ID_PHONECALL)
    returning_values :no_use;
  end
  if (:err_code < 0) then exit;

  if (:new_id_account_post is not null) then begin
    update PHONECALLS PC
    set    PC.ID_ACCOUNT_POST = :new_id_account_post,
           pc.POSTING_ERROR = null
    where  PC.rdb$db_key = :ph_dbkey;

    insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
    values (:new_id_account_post, :ext_ifc_name, null, :datetime_call);
  end

end
^

/* Alter (POST_TELECOUNT_TRANSFER$TC) */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ph_dbkey char(8);
  declare variable id_account_post integer;
  declare variable account_name varchar(50);
begin
  err_code = 0;
  err_text = '';

  for
    select PC.RDB$DB_KEY, PC.ID_ACCOUNT_POST
    from   PHONECALLS PC
    where  PC.SELECTION_ID = :selection_id
    into   :ph_dbkey, :id_account_post
  do begin
    if ((:id_account_post is not null) and (:id_account_post <> -1)) then begin
      err_code = -117;
      select A.ACCOUNT_NAME
      from   ACCOUNT_POST AP
             join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
      where  AP.ID_ACCOUNT_POST = :id_account_post
      into   :account_name;
      err_text = f_character(29) || :account_name;
      exit;
    end

    execute procedure POST_TELECOUNT_CALL$INT(2, :id_reserv_detail, :ph_dbkey, 0)
    returning_values :err_code, :err_text;
    if (:err_code < 0) then exit;
  end
end
^

/* Alter (PROFILE_COMMON_MODIFY$INT) */
ALTER PROCEDURE PROFILE_COMMON_MODIFY$INT(ID_PROFILE INTEGER,
PROFILE_TYPE VARCHAR(20),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
IS_ARCHIVE INTEGER,
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable action_text varchar(255);
  declare variable old_profile_name varchar(100);
  declare variable old_is_archive integer;
  declare variable p_dbkey char(8);
begin
  p_dbkey = null;
  select P.RDB$DB_KEY, P.PROFILE_NAME, P.IS_ARCHIVE
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :p_dbkey, :old_profile_name, :old_is_archive;
   
  is_exclusive_debt_ownership = coalesce(:is_exclusive_debt_ownership, 0);
  new_id_profile = :id_profile;
  if (:p_dbkey is null) then begin
    execute procedure SYSTEM_CHECK_OPERATION (:PROFILE_TYPE, 'PERSON,AGENT,HOUSE', 'Profile type');

    new_id_profile = gen_id(gen_profile_id, 1);
    insert into PROFILE (ID_PROFILE, PROFILE_NAME, PROFILE_TYPE,
           PHONE, FAX, EMAIL, CITY, ADDRESS, NOTE, MSG,
           ID_DEF_CONTRAGENT, ID_NOM_MARKET_SEGMENT, IS_ARCHIVE, ACCOUNT_NO,
           WBE_PASSWORD, IS_EXCLUSIVE_DEBT_OWNERSHIP)
    values (:new_id_profile, :profile_name, :profile_type,
           :phone, :fax, :email, :contact_city, :contact_address, :note, :msg,
           :id_def_contragent, :id_nom_market_segment, 0, :account_no,
           nullif(:wbe_password, ''), :is_exclusive_debt_ownership)
    returning RDB$DB_KEY into :p_dbkey;
  end else begin
    update PROFILE PU
    set    PU.PROFILE_NAME = :profile_name,
           PU.PHONE = :phone,
           PU.FAX = :fax,
           PU.EMAIL = :email,
           PU.CITY = :contact_city,
           PU.ADDRESS = :contact_address,
           PU.NOTE = :note,
           PU.MSG = :msg,
           PU.ID_DEF_CONTRAGENT = :id_def_contragent,
           PU.ID_NOM_MARKET_SEGMENT = :id_nom_market_segment,
           PU.ACCOUNT_NO = :ACCOUNT_NO,
           PU.WBE_PASSWORD = iif(PU.WBE_PASSWORD is null and :wbe_password = '', null, :wbe_password),
           -- empty ('') new password should not relpace NULLs,
           -- empty password indicate for 'deleted real password'
           PU.IS_EXCLUSIVE_DEBT_OWNERSHIP = :IS_EXCLUSIVE_DEBT_OWNERSHIP
    where  PU.RDB$DB_KEY = :p_dbkey;
  
    if (:old_profile_name <> :profile_name) then begin
      action_text = f_character(29) || :old_profile_name || f_character(28) || :profile_name;
      execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'EDIT_NAME', :action_text);
    end
  
    if (:is_archive is distinct from :old_is_archive) then
      execute procedure PROFILE_SET_ARCHIVE$INT (:P_DBKEY, :IS_ARCHIVE);

  end
end
^

/* Alter (PROFILE_HOUSE_MODIFY$PROFILE) */
ALTER PROCEDURE PROFILE_HOUSE_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(20),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
IS_ARCHIVE INTEGER,
HOUSE_TYPE VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable action_text varchar(255);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    execute procedure PROFILE_COMMON_MODIFY$INT(:id_profile, 'HOUSE', :profile_name,
            :phone, :fax, :email, :contact_city, :contact_address,
            :note, :msg, :is_archive, :id_def_contragent, :id_nom_market_segment,
            :wbe_password, :account_no, :is_exclusive_debt_ownership)
    returning_values (:new_id_profile);

    if (:operation = 'add') then begin
      insert into PROFILE_HOUSE(ID_PROFILE, HOUSE_TYPE)
      values (:new_id_profile, :house_type);

      action_text = f_character(29) || :PROFILE_NAME;
      execute procedure SYSTEM_LOG_ADD ('PROFILE', :new_id_profile, 'CREATE_HOUSE_PROFILE', :action_text);
    end
  end else if (:operation = 'del') then  begin
    execute procedure PROFILE_DELETE$INT(:id_profile);

    new_id_profile = null;
  end
end
^

/* Alter (PROFILE_PERSON_MODIFY$PROFILE) */
ALTER PROCEDURE PROFILE_PERSON_MODIFY$PROFILE(ID_PROFILE INTEGER,
ID_GUEST_TYPE INTEGER,
PROFILE_NAME VARCHAR(100),
PERSON_NAME2 VARCHAR(100),
SEX CHAR,
BIRTH_DAY DATE,
BIRTH_PLACE VARCHAR(30),
EGN VARCHAR(30),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
COUNTRY_CODE VARCHAR(20),
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
MASK VARCHAR(10),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
IS_ARCHIVE INTEGER,
ID_PHOTO INTEGER,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
TITLE VARCHAR(10) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable p_dbkey char(8);
  declare variable pd_dbkey char(8);
  declare variable old_birth_day date;
  declare variable id_picture integer;
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    new_id_profile = :id_profile;

    if (:operation = 'add') then begin
      execute procedure PROFILE_PERSON_CREATEQ$PROFILE(:profile_name, :phone,
              :id_passport_type, :pass_num, :egn, :country_code, :card_code, null, :TITLE, null)
      returning_values  :new_id_profile, :p_dbkey, :pd_dbkey;

      if (:MASK is null) then begin
        -- keep the default mask if input mask is <null> - undefined
        -- empty mask is '' - passed by GUI, but <null> is passed from booking import, etc.
        select PD.MASK
        from   PERSON_DATA PD
        where  PD.RDB$DB_KEY = :pd_dbkey
        into   :mask;
      end
    end

    select P.RDB$DB_KEY, PD.RDB$DB_KEY, pd.BIRTH_DAY
    from   PROFILE P
           join PROFILE_PERSON PP on PP.ID_PROFILE = P.ID_PROFILE
           join PERSON_DATA PD on PD.ID_PERSON_DATA = PP.ID_PERSON_DATA
    where  P.ID_PROFILE = :new_id_profile
    into   :p_dbkey, :pd_dbkey, :old_birth_day;

    execute procedure PROFILE_COMMON_MODIFY$INT(:new_id_profile, 'PERSON', :profile_name,
            :phone, :fax, :email, :contact_city, :contact_address,
            :note, :msg, :is_archive, :id_def_contragent, :id_nom_market_segment,
            :wbe_password, :account_no, :is_exclusive_debt_ownership)
    returning_values (:new_id_profile);

    execute procedure PERSON_DATA_SET$INT(:p_dbkey, :pd_dbkey, :profile_name, :person_name2, :country_code,
            :old_birth_day, :birth_day, :TITLE);

    execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, :birth_place, :egn, :id_passport_type, :pass_num, :pass_date, :pass_place,
            :pass_exp_date, :pass_city, :pass_address, :sex, :mask);

    update PROFILE_PERSON PP
    set    PP.ID_GUEST_TYPE = :id_guest_type,
           PP.ID_PHOTO = :id_photo,
           PP.CARD_CODE = :card_code
    where  PP.ID_PROFILE = :new_id_profile;

  end else if (:operation = 'del') then begin
    id_picture = null;

    select PP.ID_PHOTO
    from   PROFILE_PERSON PP
    where  PP.ID_PROFILE = :id_profile
    into   :id_picture;

    execute procedure PICTURE_MODIFY (:id_picture, null, null, null, 'del')
    returning_values :id_picture;

    execute procedure PROFILE_DELETE$INT(:id_profile);
    new_id_profile = null;
  end
end
^

/* Alter (RATE_GET_AVAILABILITY$CHM) */
ALTER PROCEDURE RATE_GET_AVAILABILITY$CHM(ID_RATE INTEGER,
FOR_DATE DATE)
 RETURNS(ACTIVE_STATUS INTEGER,
MIN_LOS INTEGER,
MAX_LOS INTEGER)
 AS
declare variable date_from date;
  declare variable date_to date;
  declare variable RATE_capacity integer;
  declare variable to_sell integer;
begin
  --ACTIVE_STATUS 0 - closed
  --ACTIVE_STATUS 1 - closed fro arrival
  --ACTIVE_STATUS 2 - opened
  --opala ID_HOTEL
--  date_from = null;
--  ACTIVE_STATUS -  autoclose, t.e. AUTO_PERCENT






/*  select min(FOR_DATE), max(FOR_DATE)
  from RATE_ALLOTMENT
  where ID_RATE = :id_RATE
  into :date_from, :date_to;
  if (date_from is null) then exit;

  for select distinct ID_ROOM_TYPE
      from RATE_ALLOTMENT
      where ID_RATE = :id_RATE
        and FOR_DATE between :date_from and :date_to
      into :id_room_type
  do begin
    for select RTR.FOR_DATE,
               CA.STATUS,
               CA.AUTO_FREE_ROOMS, CA.ROOM_COUNT, RTR.AVAILABLE as FREE_ROOMS
        from ROOM_TYPE_GET_FREE$CHM(:date_from, :date_to, :id_room_type) RTR
             join RATE_ALLOTMENT CA on CA.ID_ROOM_TYPE = :id_room_type
                                      and CA.ID_RATE = :id_RATE
                                      and CA.FOR_DATE = RTR.FOR_DATE
    into :for_date, :status,
         :auto_free_rooms, :RATE_capacity, :free_rooms
    do begin
      if (:auto_free_rooms is not null) then
        if (coalesce(:free_rooms,0) >= :auto_free_rooms) then
          is_active = 1;
        else is_active = 0;
      else if (:status = 0) then
             is_active = 1;
           else is_active = 0;

      to_sell = coalesce(:free_rooms,0) - coalesce(:auto_free_rooms,0);
      if (to_sell < 0) then to_sell = 0;

      room_count = :to_sell;
      if (:RATE_capacity is not null) then
        if (RATE_capacity < room_count) then
          room_count = :RATE_capacity;

      suspend;
    end
  end*/
end
^

/* empty dependent procedure body */
/* Clear: RES_TAR_CALC_FINALIZE$INT for: RES_TAR_CALC_REPOST$INT */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(ID_TAR_CALC INTEGER,
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_TAR_CALC_REPOST$INT) */
ALTER PROCEDURE RES_TAR_CALC_REPOST$INT(ID_TAR_CALC TYPE OF ID_REF,
ID_RESERV_DETAIL TYPE OF ID_REF,
RECALC_MARKER VARCHAR(40))
 AS
declare variable id_guest type of id_ref;
  declare variable id_service type of id_ref;
  declare variable id_tariff type of id_ref;
  declare variable date_post type of tdate;
  declare variable qty_post type of tqty;
  declare variable price_orig type of tprice;
  declare variable curr_orig type of tcurrency;
  declare variable id_room type of id_ref;
  declare variable is_base type of tlogical;
  declare variable short_code type of tdescription_long;
  declare variable id_account type of id_ref;
  declare variable gfrom_date type of tdate;
  declare variable gto_date type of tdate;
  declare variable ap_db_key char(8);
  declare variable id_pack_service type of id_ref;
  declare variable err_code type of id_ref;
  declare variable err_text type of tdescription_long;
  declare variable id_master_account_post type of id_ref;
  declare variable id_acc_post type of id_ref;
  declare variable is_base_account type of id_ref;
  declare variable id_extra_account type of id_ref;
  declare variable no_use varchar(255);
begin
  for
    select   TCP.ID_GUEST, TCP.ID_SERVICE, TCP.ID_TARIFF, TCP.DATE_POST, TCP.QTY_POST,
             round_f(TCP.PRICE_ORIG, c.ROUND_TO), TCP.CURR_ORIG, TCP.ID_ROOM, TCP.IS_BASE,
             TCP.SHORT_CODE, iif(coalesce(AGP.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'NONE', 0, 1),
             G.ID_BASE_ACCOUNT, G.FROM_DATE, G.TO_DATE, G.ID_ACCOUNT
    from     TAR_CALC_POST$TMP TCP
             join GUEST G on G.ID_GUEST = TCP.ID_GUEST
             join SERVICES S on S.ID_SERVICE = TCP.ID_SERVICE
             join CURRS c on c.CURR = tcp.CURR_ORIG
             left outer join AGENT_PACKET AGP on AGP.ID_SERVICE = S.ID_SERVICE and AGP.ID_AGENT = G.ID_AGENT
    where    TCP.ID_TAR_CALC = :id_tar_calc
             and tcp.ID_RESERV = :ID_RESERV_DETAIL
                  --or (coalesce(RD.IS_POSTING_STOPPED, 0) = 0 and RD.POSTING_TRANSACTION_UUID is not null))
    order by TCP.ID_GUEST asc, TCP.DATE_POST asc, TCP.IS_BASE desc
    into     :id_guest, :id_service, :id_tariff, :date_post, :qty_post,
             :price_orig, :curr_orig, :id_room, :is_base, :short_code, :is_base_account,
             :id_account, :gfrom_date, :gto_date, :id_extra_account
  do begin
    ap_db_key = null;
    if (:is_base = 1) then begin
      select AP.RDB$DB_KEY, AP.ID_MASTER_ADDINS_ACC_POST, AP.ID_PACK_SERVICE
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.DATE_POST = :date_post
             and AP.IS_BASE = 1
      into   :ap_db_key, :id_master_account_post, :id_pack_service;

      --execute procedure sys_dbg('tar TAR_CALC_REPOST$INT price_orig = '||coalesce(:price_orig, 'null'));
      --execute procedure sys_dbg('tar TAR_CALC_REPOST$INT ap_db_key = '||coalesce(:ap_db_key, 'null'));

      if (:ap_db_key is null) then begin
        id_master_account_post = -1;
        execute procedure GUEST_POST_GET_PACK_SERVICE(:id_service, :id_guest, :date_post)
        returning_values  :id_pack_service;
      end
    end else begin
      -- short_code = '';
      select first 1 APU.rdb$db_key
      from   ACCOUNT_POST APU
      where  APU.ID_MASTER_ADDINS_ACC_POST = :id_master_account_post
             and APU.ID_SERVICE = :id_service
             and APU.CHANGED_TEXT is distinct from :recalc_marker
      order by apu.IS_ANUL asc, apu.ID_ACCOUNT_POST asc
      into   :ap_db_key;

      if ((:is_base_account <> 1)) then id_account = :id_extra_account;
    end

    if (:ap_db_key is null) then begin
      execute procedure ACCOUNT_POSTING_ADD$INT(
        :id_account, :id_guest, -1, :date_post, :id_service, :id_tariff, :id_room, :is_base, :qty_post,
        :price_orig, :curr_orig, null, :short_code, :gfrom_date, :gto_date, 'PACK='||:id_pack_service, '',
        :recalc_marker, :id_master_account_post)
      returning_values  :err_code, :err_text, :id_acc_post;
      if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

      if (:is_base = 1) then id_master_account_post = :id_acc_post;

    end else begin
      execute procedure ACCOUNT_POSTING_UPDATE$INT(
        :ap_db_key, :id_service, :id_tariff, :id_room, :qty_post, 0, :price_orig, :curr_orig, null,
        :recalc_marker, :short_code, :gfrom_date, :gto_date, 1, :id_account)
      returning_values  :no_use, :no_use, :no_use;
    end

  end

  ap_db_key = null;
  id_guest = null;
  for
    select distinct TCP.ID_GUEST
    from   TAR_CALC_POST$TMP TCP
    where  tcp.ID_TAR_CALC = :ID_TAR_CALC
           and tcp.ID_RESERV = :ID_RESERV_DETAIL
    into   :id_guest
  do begin
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.CHANGED_TEXT is distinct from :recalc_marker
             and AP.ID_MASTER_ADDINS_ACC_POST > 0
             and AP.IS_ANUL = 0
      into   :ap_db_key
    do begin
      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_db_key, :recalc_marker);
    end
  end

  delete from RESERV_PREPOST RP where RP.ID_RESERV_DETAIL = :id_reserv_detail;
  execute procedure RES_TAKE_POSTING_RESPONSIBILITY (:ID_RESERV_DETAIL);
end
^

/* Alter (RESOURCE_RESERVATION_CHECK_IN) */
ALTER PROCEDURE RESOURCE_RESERVATION_CHECK_IN(ID_RESOURCE_RESERVATION INTEGER,
SERVICE_PRICE NUMERIC(15,2),
SERVICE_CURR VARCHAR(3))
 RETURNS(OUT_ID_ACCOUNT INTEGER,
OUT_ID_ACCOUNT_POST INTEGER)
 AS
declare variable old_status varchar(20);
  declare variable new_status varchar(20);
  declare variable dbkey char(8);
  declare variable id_service id_ref;
  declare variable price_post tprice;
  declare variable curr_post TCURRENCY;
  declare variable is_manual_price TLOGICAL;
  declare variable is_details tlogical;
  declare variable post_description tobject_text;
  declare variable id_reserv_detail integer;
  declare variable post_date tdate;
  declare variable from_datetime tdatetime;
  declare variable to_datetime tdatetime;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  new_status = 'CHECKED_IN';

  select r.RDB$DB_KEY, R.STATUS, rd.ID_RESERV_DETAIL
  from   RESOURCE_RESERVATION R
         left outer join RESERV_DETAIL rd on rd.NUMBER = r.BOOKING_NUMBER
                                             and rd.IS_ANUL = 0
                                             and rd.SUBSCRIBER_ID is not distinct from r.SUBSCRIBER_ID
  where  R.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION
  into   :dbkey, :old_status, :id_reserv_detail;

  if (:old_status = :NEW_STATUS) then exit;
 
  if (:old_status is distinct from 'RESERVED') then exception ASSERT '-511';

  if (exists (select RP.ID_RESOURCE_RESERVATION
              from   RESOURCE_RESERV_POST RP
                     join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = RP.ID_ACCOUNNT_POST
              where  RP.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION)) then
  begin
    exception ASSERT '-505';
  end

  if (:id_reserv_detail is not null) then begin
    execute procedure RESOURCE_RESERV_SERVICE_GET (:ID_RESOURCE_RESERVATION)
    returning_values (:id_service, :price_post, :curr_post, :is_manual_price, :is_details, :post_description,
                     :post_date, :from_datetime, :to_datetime);
  
    if (:is_manual_price = 1) then begin
      price_post = :SERVICE_PRICE;
      curr_post = :SERVICE_CURR;
    end

    if (:price_post is null) then exception ASSERT 'Unspecified service price!';
    if (:curr_post is null) then exception ASSERT 'Unspecified price currency!';
  
    execute procedure POST_SERVICE_ON_RESERVATION$INT (:id_reserv_detail, :id_service, 1, 0,
            1, :price_post, :curr_post, :from_datetime, :to_datetime,
            '', '', :post_date, 'RESOURCE', :post_description)
    returning_values (:ERR_CODE, :ERR_TEXT, :OUT_ID_ACCOUNT, :OUT_ID_ACCOUNT_POST);
    if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
  
    insert into RESOURCE_RESERV_POST(ID_RESOURCE_RESERVATION, ID_ACCOUNNT_POST)
    values (:ID_RESOURCE_RESERVATION, :OUT_ID_ACCOUNT_POST);
  end

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = :NEW_STATUS
  where  RR.RDB$DB_KEY = :dbkey;

end
^

/* Alter (RIGHTS_GROUP_USER_MODIFY) */
ALTER PROCEDURE RIGHTS_GROUP_USER_MODIFY(USER_NAME VARCHAR(30),
ID_RIGHT_GROUP INTEGER,
OPERATION VARCHAR(50))
 AS
declare variable right_group varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add,del');

  if (:USER_NAME = 'SYSDBA') then exit;

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS RG
  where  RG.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'add') then begin
    insert into RIGHTS_USER_GROUPS (USER_NAME, ID_RIGHT_GROUP)
    values (:user_name, :id_right_group);

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_ADDED',
            f_character(29) || :USER_NAME  || f_character(28) || :right_group);

  end else begin
    delete from RIGHTS_USER_GROUPS
    where USER_NAME = :user_name
          and ID_RIGHT_GROUP = :id_right_group;

    if (row_count > 0) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_REMOVED',
              f_character(29) || :USER_NAME || f_character(28) || :right_group);

  end

  when sqlcode -803 do begin
    /* ERR_TEXT = '       ! ' ;*/
    exit;
  end
end
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_MODIFY for: SAFE_OCCUPANCY_POSTING$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE /* TYPE OF ID */ INTEGER,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100))
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_NEW for: SAFE_OCCUPANCY_POSTING$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE /* TYPE OF ID */ INTEGER,
FROM_DATETIME /* TDATETIME */ TIMESTAMP,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100),
BOOKING_NUMBER /* TYPE OF TRES_NUMBER */ VARCHAR(62),
ID_EXTERNAL_CLIENT_ACCCOUNT /* TYPE OF ID_REF */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER,
ID_RESOURCE_RESERVATION /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SAFE_OCCUPANCY_POSTING$INT) */
ALTER PROCEDURE SAFE_OCCUPANCY_POSTING$INT(ID_RESOURCE_RESERVATION TYPE OF ID,
ID_SERVICE TYPE OF ID,
PRICE TYPE OF TPRICE,
CURRENCY TYPE OF TCURRENCY,
PRICE_DESCRIPTION TYPE OF TDESCRIPTION_SHORT,
ID_RESERV_DETAIL TYPE OF ID,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF = null)
 RETURNS(DOC_SELECTED TYPE OF TRANGE)
 AS
declare variable from_datetime timestamp;
  declare variable to_datetime timestamp;
  declare variable ap_dbkey TDB_KEY;
  declare variable id_account_post integer;
  declare variable safe_name TOBJECT_NAME;
  declare variable no_use varchar(255);
  declare variable new_ac varchar(2);
  declare variable err_code integer;
  declare variable err_text varchar(255) ;
  declare variable occupant_name tperson_name;
  declare variable id_room integer;
  declare variable id_tariff integer;
begin
  DOC_SELECTED = null;
  select od.FROM_DATETIME, od.TO_DATETIME, ap.RDB$DB_KEY, ap.ID_ACCOUNT_POST,
         s.SAFE_NAME, rr.OCCUPANT_NAME, ap.ID_ROOM, ap.ID_TARIFF
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join SAFES s on s.ID_SAFE = od.ID_RESOURCE
         left outer join RESOURCE_RESERV_POST rrp on rrp.ID_RESOURCE_RESERVATION = rr.ID_RESOURCE_RESERVATION
         left outer join ACCOUNT_POST ap on ap.ID_ACCOUNT_POST = rrp.ID_ACCOUNNT_POST
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :from_datetime, :to_datetime, :ap_dbkey, :id_account_post,
         :safe_name, :occupant_name, :id_room, :id_tariff;

  new_ac = null;
  if (:id_account_post is not null) then begin
    execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
            :id_tariff, :id_room, 1, 0, :price, :currency, null, null, 'RESOURCE', :from_datetime, :TO_DATETIME, 1)
    returning_values :no_use, :no_use, :new_ac;
  end else begin
    if (:id_reserv_detail is not null) then begin
      execute procedure POST_SERVICE_ON_RESERVATION$INT (:id_reserv_detail, :id_service, 1, 0,
              1, :price, :currency, :from_datetime, :to_datetime,
              '', '', cast(:from_datetime as date), 'RESOURCE', null)
      returning_values (:ERR_CODE, :ERR_TEXT, :no_use, :id_account_post);
      if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      new_ac = '00';
    end else if (:ID_EXTERNAL_CLIENT_ACCCOUNT is not null) then begin
      execute procedure POST_SERVICE_ON_ACCOUNT$INT (:ID_EXTERNAL_CLIENT_ACCCOUNT, :id_service,
              1, 0, 1, :price, :currency, :from_datetime, :TO_DATETIME, '', '',
              cast(:from_datetime as date), 'RESOURCE', null, null)
      returning_values (:err_code, :err_text, :id_account_post);
      if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      new_ac = '00';
    end
  end

  if (:new_ac is null) then
    exception ASSERT '-1067' || f_character(31) || f_character(29) || :safe_name || f_character(28) || :occupant_name;

  if (:new_ac = '00') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);
    update ACCOUNT_POST AP
    set    ap.DOC_SELECTED = :DOC_SELECTED
    where  ap.ID_ACCOUNT_POST = :id_account_post;
  end

  update or insert into ACCOUNT_POSTING_DET (ID_ACCOUNT_POST, POST_TEXT, QTY,
         FROM_DATETIME, TO_DATETIME, RESOURCE_TEXT)
  values (:id_account_post, :safe_name ||' / '||formatdate(:from_datetime, 'D;dd.mm.yy(hh:mm)')||' - '||formatdate(:to_datetime, 'D;dd.mm.yy(hh:mm)')||' / '
          ||substring(replace(:price_description, F_CRLF(), ';') from 1 for 100), 1, :from_datetime, :to_datetime, :safe_name);

  if (not exists (select rp.ID_ACCOUNNT_POST
                  from   RESOURCE_RESERV_POST rp
                  where  rp.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION
                         and rp.ID_ACCOUNNT_POST = :id_account_post)) then
  begin
    insert into RESOURCE_RESERV_POST (ID_RESOURCE_RESERVATION, ID_ACCOUNNT_POST)
    values (:id_resource_reservation, :id_account_post);
  end
end
^

/* empty dependent procedure body */
/* Clear: SPR_OCC_KONT_AGENT for: SPR_OCC_KONT_AGENT_ROOMTYPE_DAY */
ALTER PROCEDURE SPR_OCC_KONT_AGENT(FROM_DATE DATE,
TO_DATE DATE,
ID_AGENT INTEGER,
KIND SMALLINT,
AGE_KIND SMALLINT,
ALL_KINDS SMALLINT,
ID_HOTEL INTEGER)
 RETURNS(TYPE_ROOM VARCHAR(20),
TYPE_ROOM2 VARCHAR(20),
FOR_DATE DATE,
KONTINGENT INTEGER,
DATA INTEGER,
OUT_KIND VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* Alter (SPR_OCC_KONT_AGENT_ROOMTYPE_DAY) */
ALTER PROCEDURE SPR_OCC_KONT_AGENT_ROOMTYPE_DAY(FOR_DATE DATE,
ID_AGENT INTEGER,
ID_ROOM_TYPE INTEGER,
KIND SMALLINT,
AGE_KIND SMALLINT,
ALL_KINDS SMALLINT)
 RETURNS(KONTINGENT INTEGER,
DATA INTEGER,
OUT_KIND VARCHAR(20))
 AS
declare variable kont_rooms integer;
  declare variable kont_beds integer;
  declare variable kont_adds integer;
  declare variable data_rooms integer;
  declare variable data_adult_beds integer;
  declare variable data_children_beds integer;
  declare variable data_adult_adds integer;
  declare variable data_children_adds integer;
begin
  /* KIND:  1 - ROOMS
            2 - BEDS
            3 - ADD BEDS
            else - BEDS + ADD BEDS
     AGE_KIND:  1 - ADULTS
                2 - CHILDREN
                else - ALL*/
  kontingent = 0;
  data = 0;

  for
    select ACR.CNT_ROOMS
    from   ALLOTMENT_AGENT_GET(:for_date, :for_date, :id_room_type, :id_agent, 'CONTINGENT_DEFINE', 0) ACR
    into   :kont_rooms
  do if ((:all_kinds = 1) or (:kind > 2)) then begin
    select max(:kont_rooms * RT.BEDS),
           round_f(max(RM.EXTRA_BEDS)/max(AD.CNT_ROOMS) * :kont_rooms, 1)
    from   (select max(r.ID_HOTEL) as id_hotel, sum(R.EXTRA_BEDS) as EXTRA_BEDS
            from   ROOMS R
            where  r.ID_ROOM_TYPE = :ID_ROOM_TYPE) RM
           join HOTEL H on H.ID_HOTEL = RM.ID_HOTEL
           join ALLOTMENT_DETAIL AD on AD.ID_ALLOTMENT = H.ID_INVENTORY_ALLOTMENT
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = ad.ID_ROOM_TYPE
    where  AD.ID_ROOM_TYPE = :id_room_type
           and AD.FROM_DATE <= :for_date
           and AD.TO_DATE >= :for_date
    into   :kont_beds, :kont_adds;
  end

  select count(distinct RM.ID_ROOM),
         sum(RM.GST_AD_IN + RM.GST_AD_STAY),
         sum(RM.GST_CH_IN + RM.GST_CH_STAY)
  from   ROOM_MAGIC RM
  where  RM.ID_ROOM_TYPE = :id_room_type
         and RM.BUSY_DATE = :for_date
         and RM.BUSY_GROUP_TYPE in (1,24)
         and upper(RM.BUSY_TYPE) is distinct from 'VALUE_RESERVS'
         and RM.DAY_ACTION not containing 'CHECK_OUT'
         and RM.ID_AGENT = :id_agent
  into   :data_rooms, :data_adult_beds, :data_children_beds;

  if (not ((:kind = 1) and (:all_kinds = 0))) then begin
    /*select sum(RM.GST_AD_IN + RM.GST_AD_STAY),
           sum(RM.GST_CH_IN + RM.GST_CH_STAY)
    from   ROOM_MAGIC RM
           join GUEST G on G.ID_RESERV_DETAIL = RM.ID_RESERV_DETAIL
           join ACCOUNT_POST AP on AP.ID_GUEST = G.ID_GUEST
                and AP.DATE_POST = RM.BUSY_DATE
                and AP.IS_BASE = 1 and AP.IS_ANUL = 0
           join SERVICES S on S.ID_SERVICE = AP.ID_SERVICE
           join TYPE_STAY TS on TS.ID_TYPE_STAY = S.ID_TYPE_STAY and TS.TYPE_STAY_CODE = 'EXTRA_BED'
    where  RM.ID_ROOM_TYPE = :id_room_type
           and RM.BUSY_DATE = :for_date
           and RM.BUSY_GROUP_TYPE = 24
           and RM.ID_AGENT = :id_agent
    into   :data_adult_adds, :data_children_adds;*/

    select count(iif(g.IS_CHILD = 0, gs.ID_GUEST, null)),
           count(iif(g.IS_CHILD = 1, gs.ID_GUEST, null))
    from   GUEST_STAY GS     
           join ROOMS R on R.ID_ROOM = gs.ID_ROOM
           join TYPE_STAY TS on TS.ID_TYPE_STAY = GS.ID_TYPE_STAY
           left join GUEST G on G.ID_GUEST = gs.ID_GUEST
           left join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  gs.FOR_DATE = :for_date
           and r.ID_ROOM_TYPE = :id_room_type
           and rd.CHECK_STATUS >= -1
           and upper(rd.res_status) is distinct from 'WAITING'
           and rd.IS_ANUL = 0
           and g.ID_AGENT = :id_agent
           and TS.TYPE_STAY_CODE = 'EXTRA_BED'
    into   :data_adult_adds, :data_children_adds;
  end

  kont_adds = coalesce(:kont_adds, 0);
  kont_beds = coalesce(:kont_beds, 0);
  kont_rooms = coalesce(:kont_rooms, 0);
  data_rooms = coalesce(:data_rooms, 0);
  data_adult_beds = coalesce(:data_adult_beds, 0);
  data_children_beds = coalesce(:data_children_beds, 0);
  data_adult_adds = coalesce(:data_adult_adds, 0);
  data_children_adds = coalesce(:data_children_adds, 0);

  data_adult_beds = :data_adult_beds - :data_adult_adds;
  data_children_beds = :data_children_beds - :data_children_adds;
  if (:ALL_KINDS <> 1) then begin
    if (:KIND = 1) then KONTINGENT = :kont_rooms;
    else if (:KIND = 2) then KONTINGENT = :kont_beds;
    else if (:KIND = 3) then KONTINGENT = :kont_adds;
    else KONTINGENT = :kont_beds + :kont_adds;

    if (:KIND = 1) then
      DATA = :data_rooms;
    else if (:KIND = 2) then
      if (:AGE_KIND = 1) then DATA = :data_adult_beds;
      else if (:AGE_KIND = 2) then DATA = :data_children_beds;
      else DATA = :data_adult_beds + :data_children_beds;
    else if (:KIND = 3) then
      if (:AGE_KIND = 1) then DATA = :data_adult_adds;
      else if (:AGE_KIND = 2) then DATA = :data_children_adds;
      else DATA = :data_adult_adds + :data_children_adds;
    else
      if (:AGE_KIND = 1) then DATA = :data_adult_adds + :data_adult_beds;
      else if (:AGE_KIND = 2) then DATA = :data_children_adds + :data_children_beds;
      else DATA = :data_adult_adds + :data_children_adds + :data_adult_beds + :data_children_beds;

    if (:DATA is null) then DATA = 0;
    if (:KONTINGENT is null) then KONTINGENT = 0;
    OUT_KIND = 'DEFINED;DEFINED';
    suspend;
  end else begin
  /* KIND:  1 - ROOMS
            2 - BEDS
            3 - ADD BEDS
            else - BEDS + ADD BEDS
     AGE_KIND:  1 - ADULTS
                2 - CHILDREN
                else - ALL*/
    OUT_KIND = 'ADDS;ADULTS';
    KONTINGENT = :kont_adds;
    DATA = :data_adult_adds;
    suspend;
    OUT_KIND = 'ADDS;CHILDREN';
    KONTINGENT = :kont_adds;
    DATA = :data_children_adds;
    suspend;
    OUT_KIND = 'ADDS;ALL';
    KONTINGENT = :kont_adds;
    DATA = :data_children_adds + :data_adult_adds;
    suspend;
    OUT_KIND = 'ALL_BEDS;ADULTS';
    KONTINGENT = :kont_adds + :kont_beds;
    DATA = :data_adult_adds + :data_adult_beds;
    suspend;
    OUT_KIND = 'ALL_BEDS;CHILDREN';
    KONTINGENT = :kont_adds + :kont_beds;
    DATA = :data_children_adds + :data_children_beds;
    suspend;
    OUT_KIND = 'ALL_BEDS;ALL';
    KONTINGENT = :kont_adds + :kont_beds;
    DATA = :data_children_adds + :data_adult_adds + :data_children_beds + :data_adult_beds;
    suspend;
    OUT_KIND = 'BEDS;ADULTS';
    KONTINGENT = :kont_beds;
    DATA = :data_adult_beds;
    suspend;
    OUT_KIND = 'BEDS;CHILDREN';
    KONTINGENT = :kont_beds;
    DATA = :data_children_beds;
    suspend;
    OUT_KIND = 'BEDS;ALL';
    KONTINGENT = :kont_beds;
    DATA = :data_children_beds + :data_adult_beds;
    suspend;
    OUT_KIND = 'ROOMS;ALL';
    KONTINGENT = :kont_rooms;
    DATA = :data_rooms;
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: END_WORK for: SUMMARY_FORECAST$INT */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (SUMMARY_FORECAST$INT) */
ALTER PROCEDURE SUMMARY_FORECAST$INT(ID_HOTEL INTEGER,
SUMMARY_DATE DATE)
 AS
declare variable max_busy_date date;
declare variable to_date date;
begin
  select max(rm.busy_date)
  from   ROOM_MAGIC rm
  where  rm.id_hotel = :id_hotel
  into   :max_busy_date;
  to_date = maxdate(mindate(:max_busy_date, :SUMMARY_DATE + 2*365 + 1), :SUMMARY_DATE + 1);

  execute procedure AVAILABILITY_OCCUP_PREPARE$AVL (:SUMMARY_DATE + 1, :TO_DATE, 1, 1, 0, 1, 1, 1, 1, 1, :ID_HOTEL);

  insert into SUMMARY_FORECAST (
         summary_date, forecast_date, id_room_type, id_hotel,
         rooms_capacity, rooms_ooi, res_confirmed, res_notconfirmed, res_waiting,
         res_checked_in, cont_remain, bp_remain)
  select :summary_date, tso.for_date, tso.id_room_type, tso.ID_HOTEL,
         sum(tso.g_capacity), sum(tso.g_ooi), sum(tso.res_confirmed), sum(tso.res_notconfirmed), sum(tso.res_waiting),
         sum(tso.sold), sum(tso.cont_plain_remain), sum(tso.cont_bp_remain)
  from   SMART_OCCUP$TMP tso
  where  tso.ID_HOTEL = :ID_HOTEL
  group by 2, 3, 4;

  delete
  from   SUMMARY_FORECAST sf
  where  sf.summary_date = sf.forecast_date
         and sf.ID_HOTEL = :ID_HOTEL;

  insert into SUMMARY_FORECAST (
         summary_date, forecast_date, id_room_type, id_hotel,
         rooms_capacity, rooms_ooi, res_confirmed, res_notconfirmed, res_waiting,
         res_checked_in, cont_remain, bp_remain)
  select so.for_date, so.for_date, so.id_room_type, so.id_hotel,
         sum(so.rooms_available), sum(so.rooms_ooi), 0, 0, 0,
         sum(so.rooms_sold), 0, 0
  from   SUMMARY_OCCUPANCY so
  where  so.ID_HOTEL = :ID_HOTEL
         and so.for_date <= :summary_date
  group by 1, 2, 3, 4;

end
^

/* empty dependent procedure body */
/* Clear: OCCUPANCY_SUMMARY_REMAKE$SYS for: SUMMARY_OCCUPANCY_STATISTIC$INT */
ALTER PROCEDURE OCCUPANCY_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SUMMARY_STATISTIC_REBUILD$EW for: SUMMARY_OCCUPANCY_STATISTIC$INT */
ALTER PROCEDURE SUMMARY_STATISTIC_REBUILD$EW(ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (SUMMARY_OCCUPANCY_STATISTIC$INT) */
ALTER PROCEDURE SUMMARY_OCCUPANCY_STATISTIC$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
declare variable busy_date date;
  declare variable id_room_type integer;
  declare variable id_profile_agent integer;
  declare variable country_code varchar(20);
  declare variable market_segment_code varchar(3);
  declare variable source_code varchar(3);
  declare variable channel_code varchar(3);
  declare variable hear_reason_code varchar(3);
  declare variable come_reason_code varchar(3);
  declare variable rooms_noshow smallint;
  declare variable rooms_canceled smallint;

  declare variable rooms_ooi smallint;
  declare variable rooms_ooo smallint;

  declare variable rooms_sold smallint;
  declare variable rooms_sold_multiple_gst smallint;
  declare variable rooms_arrival smallint;
  declare variable rooms_departure smallint;
  declare variable ad_in_house smallint;
  declare variable ad_arrival smallint;
  declare variable ad_departure smallint;
  declare variable ch_in_house smallint;
  declare variable ch_arrival smallint;
  declare variable ch_departure smallint;
  declare variable guests_noshow smallint;
  declare variable guests_day_use smallint;
begin
  -- REBUILD THE "NO SLICE"
  delete from SUMMARY_OCCUPANCY D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY (ID_ROOM_TYPE, FOR_DATE, ROOMS_AVAILABLE, ID_HOTEL)
  select RC.ID_ROOM_TYPE, RC.FOR_DATE, sum(RC.CNT_DEFINED), :id_hotel
  from   HOTEL H
         left outer join ALLOTMENT_GET$INT(H.ID_INVENTORY_ALLOTMENT, :from_date, :to_date, null, 'PLAIN_PERIOD', H.ID_HOTEL) RC on 0=0
  where  H.ID_HOTEL = :id_hotel
         and RC.ID_ROOM_TYPE is not null
  group by 1, 2;

  for
    select RO.ID_ROOM_TYPE, RO.BUSY_DATE,
           sum(RO.OOI_ROOM), sum(RO.OOO_ROOM),
           sum(RO.ARRIVAL_ROOM + ro.STAYOVER_ROOM) as sold_rooms,
           sum(RO.MULTIPLE_GUEST_ROOM),
           sum(RO.ARRIVAL_ROOM),
           sum(RO.DEPARTURE_ROOM),
           sum(RO.ARRIVAL_ADULTS + ro.STAYOVER_ADULTS - ro.DAY_USE_ADULTS) as AD_IN_HOUSE,
           sum(RO.ARRIVAL_ADULTS),
           sum(RO.DEPARTURE_ADULTS),
           sum(RO.ARRIVAL_CHILDREN + ro.STAYOVER_CHILDREN - ro.DAY_USE_CHILDREN) as CH_IN_HOUSE,
           sum(RO.ARRIVAL_CHILDREN),
           sum(RO.DEPARTURE_CHILDREN),
           sum(RO.DAY_USE_ADULTS + ro.DAY_USE_CHILDREN)
    from   HOTEL_ROOM_OCCUPANCY ro
    where  ro.ID_HOTEL = :id_hotel
           and ro.BUSY_DATE between :from_date and :to_date
           and ro.BUSY_GROUP_TYPE > 1 -- excludes expected bookings
    group by RO.ID_ROOM_TYPE, RO.BUSY_DATE
    into   :id_room_type, :busy_date,
           :rooms_ooi, :rooms_ooo,
           :rooms_sold, :rooms_sold_multiple_gst, :rooms_arrival, :rooms_departure,
           :ad_in_house, :ad_arrival, :ad_departure,
           :ch_in_house, :ch_arrival, :ch_departure, :guests_day_use
  do begin
    update or insert into SUMMARY_OCCUPANCY (ID_ROOM_TYPE, FOR_DATE, ROOMS_OOI, ROOMS_OOO, ROOMS_SOLD, ROOMS_SOLD_MULTIPLE_GST,
           ROOMS_ARRIVAL, ROOMS_DEPARTURE, GST_AD_IN_HOUSE, GST_AD_ARRIVAL, GST_AD_DEPARTURE,
           GST_CH_IN_HOUSE, GST_CH_ARRIVAL, GST_CH_DEPARTURE, GUESTS_DAY_USE)
    values (:id_room_type, :busy_date, :rooms_ooi, :rooms_ooo, :rooms_sold, :rooms_sold_multiple_gst,
           :rooms_arrival, :rooms_departure, :ad_in_house, :ad_arrival, :ad_departure,
           :ch_in_house, :ch_arrival, :ch_departure, :guests_day_use)
    matching (ID_ROOM_TYPE, FOR_DATE);
  end

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, 
           sum(M.ROOMS_NOSHOW), sum(M.ROOMS_CANCELED), sum(M.GUESTS_NOSHOW)
    from   RESERV_STATISTIC_CANCELED$INT(:id_hotel, :from_date, :to_date) M
    group by M.ID_ROOM_TYPE, M.BUSY_DATE
    into   :id_room_type, :busy_date, 
           :rooms_noshow, :rooms_canceled, :guests_noshow
  do begin
    update SUMMARY_OCCUPANCY SO
    set    SO.ROOMS_NOSHOW = :rooms_noshow,
           SO.ROOMS_CANCELED = :rooms_canceled,
           SO.GUESTS_NOSHOW = :guests_noshow
    where  SO.FOR_DATE = :busy_date
           and SO.ID_ROOM_TYPE = :id_room_type;

  end

  -- REBUILD THE "MARKET SLICE"
  delete from SUMMARY_OCCUPANCY_MARKET D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY_MARKET (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL,
         MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
         ROOMS_SOLD, ROOMS_SOLD_MULTIPLE_GST, ROOMS_ARRIVAL, ROOMS_DEPARTURE,
         ROOMS_NOSHOW, ROOMS_CANCELED, GUESTS_IN_HOUSE,
         GUESTS_ARRIVAL, GUESTS_DEPARTURE, GUESTS_DAY_USE)
  select M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL,
         S.MARKET_SEGMENT_CODE, S.SOURCE_CODE, S.CHANNEL_CODE, S.HEAR_REASON_CODE, S.COME_REASON_CODE,
         sum(m.ARRIVAL_ROOM + m.STAYOVER_ROOM), sum(M.MULTIPLE_GUEST_ROOM), sum(M.ARRIVAL_ROOM), sum(M.DEPARTURE_ROOM),
         0, 0, sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN + m.STAYOVER_ADULTS + m.STAYOVER_CHILDREN - m.DAY_USE_ADULTS - m.DAY_USE_CHILDREN),
         sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN), sum(M.DEPARTURE_ADULTS + m.DEPARTURE_CHILDREN), sum(M.DAY_USE_ADULTS + m.DAY_USE_CHILDREN)
  from   HOTEL_ROOM_OCCUPANCY M
         left outer join RESERV_STATISTIC_SLICE$INT (m.ID_RESERV_STATISTICS) s on 1=1
  where  m.ID_HOTEL = :id_hotel
         and m.BUSY_DATE between :from_date and :to_date
         and m.BUSY_GROUP_TYPE > 1 -- excludes expected bookings
  group by M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL,
         S.MARKET_SEGMENT_CODE, S.SOURCE_CODE, S.CHANNEL_CODE, S.HEAR_REASON_CODE, S.COME_REASON_CODE;

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, 
           M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE,
           sum(M.ROOMS_NOSHOW), sum(M.ROOMS_CANCELED)
    from   RESERV_STATISTIC_CANCELED$INT(:id_hotel, :from_date, :to_date) M
    group by M.ID_ROOM_TYPE, M.BUSY_DATE, M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE
    into   :id_room_type, :busy_date,
           :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
           :rooms_noshow, :rooms_canceled
  do begin
    update SUMMARY_OCCUPANCY_MARKET MA
    set    MA.ROOMS_NOSHOW = :rooms_noshow,
           MA.ROOMS_CANCELED = :rooms_canceled
    where  MA.FOR_DATE = :busy_date
           and MA.ID_ROOM_TYPE = :id_room_type
           and MA.MARKET_SEGMENT_CODE = :market_segment_code
           and MA.SOURCE_CODE = :source_code
           and MA.CHANNEL_CODE = :channel_code
           and MA.HEAR_REASON_CODE = :hear_reason_code
           and MA.COME_REASON_CODE = :come_reason_code;
    if (row_count = 0) then begin
      insert into SUMMARY_OCCUPANCY_MARKET (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL,
             MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
             ROOMS_NOSHOW, ROOMS_CANCELED)
      values (:id_room_type, :busy_date, :id_hotel,
             :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
             :rooms_noshow, :rooms_canceled);
    end
  end

  -- REBUILD THE "PROFILE/COUNTRY SLICE"
  delete from SUMMARY_OCCUPANCY_OTHER D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY_OTHER (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL, ID_PROFILE_AGENT, COUNTRY_CODE,
         ROOMS_SOLD, ROOMS_SOLD_MULTIPLE_GST, ROOMS_ARRIVAL, ROOMS_DEPARTURE,
         ROOMS_NOSHOW, ROOMS_CANCELED, GUESTS_IN_HOUSE, GUESTS_ARRIVAL, GUESTS_DEPARTURE, GUESTS_DAY_USE)
  select M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL, S.ID_PROFILE_AGENT, S.COUNTRY_CODE,
         sum(m.ARRIVAL_ROOM + m.STAYOVER_ROOM), sum(M.MULTIPLE_GUEST_ROOM), sum(M.ARRIVAL_ROOM), sum(M.DEPARTURE_ROOM),
         0, 0, sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN + m.STAYOVER_ADULTS + m.STAYOVER_CHILDREN - m.DAY_USE_ADULTS - m.DAY_USE_CHILDREN),
         sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN), sum(M.DEPARTURE_ADULTS + m.DEPARTURE_CHILDREN), sum(M.DAY_USE_ADULTS + m.DAY_USE_CHILDREN)
  from   HOTEL_ROOM_OCCUPANCY M
         left outer join RESERV_STATISTIC_SLICE$INT (m.ID_RESERV_STATISTICS) s on 1=1
  where  m.ID_HOTEL = :id_hotel
         and m.BUSY_DATE between :from_date and :to_date
         and m.BUSY_GROUP_TYPE > 1 -- excludes expected bookings
  group by M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL, S.ID_PROFILE_AGENT, S.COUNTRY_CODE;

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, M.ID_PROFILE_AGENT, M.COUNTRY_CODE,
           sum(M.ROOMS_NOSHOW), sum(M.ROOMS_CANCELED)
    from   RESERV_STATISTIC_CANCELED$INT(:id_hotel, :from_date, :to_date) M
    group by M.ID_ROOM_TYPE, M.BUSY_DATE, M.ID_PROFILE_AGENT, M.COUNTRY_CODE
    into   :id_room_type, :busy_date, :id_profile_agent, :country_code,
           :rooms_noshow, :rooms_canceled
  do begin

    update SUMMARY_OCCUPANCY_OTHER MA
    set    MA.ROOMS_NOSHOW = :rooms_noshow,
           MA.ROOMS_CANCELED = :rooms_canceled
    where  MA.FOR_DATE = :busy_date
           and MA.ID_ROOM_TYPE = :id_room_type
           and MA.ID_PROFILE_AGENT = :id_profile_agent
           and MA.COUNTRY_CODE = :country_code;
    if (row_count = 0) then begin
      insert into SUMMARY_OCCUPANCY_OTHER (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL,
             ID_PROFILE_AGENT, COUNTRY_CODE, ROOMS_NOSHOW, ROOMS_CANCELED)
      values (:id_room_type, :busy_date, :id_hotel,
             :id_profile_agent, :country_code, :rooms_noshow, :rooms_canceled);
    end
  end

  -- REBUILD THE "PROFILE/MARKETING SLICE"
  delete from SUMMARY_OCCUPANCY_PROFILE_MRKT D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY_PROFILE_MRKT (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL, ID_PROFILE_AGENT,
         MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
         ROOMS_SOLD, ROOMS_SOLD_MULTIPLE_GST, ROOMS_ARRIVAL, ROOMS_DEPARTURE,
         ROOMS_NOSHOW, ROOMS_CANCELED, GUESTS_IN_HOUSE, GUESTS_ARRIVAL, GUESTS_DEPARTURE, GUESTS_DAY_USE)
  select M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL, S.ID_PROFILE_AGENT,
         S.MARKET_SEGMENT_CODE, S.SOURCE_CODE, S.CHANNEL_CODE, S.HEAR_REASON_CODE, S.COME_REASON_CODE,
         sum(m.ARRIVAL_ROOM + m.STAYOVER_ROOM), sum(M.MULTIPLE_GUEST_ROOM), sum(M.ARRIVAL_ROOM), sum(M.DEPARTURE_ROOM),
         0, 0, sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN + m.STAYOVER_ADULTS + m.STAYOVER_CHILDREN - m.DAY_USE_ADULTS - m.DAY_USE_CHILDREN),
         sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN), sum(M.DEPARTURE_ADULTS + m.DEPARTURE_CHILDREN), sum(M.DAY_USE_ADULTS + m.DAY_USE_CHILDREN)
  from   HOTEL_ROOM_OCCUPANCY M
         left outer join RESERV_STATISTIC_SLICE$INT (m.ID_RESERV_STATISTICS) s on 1=1
  where  m.ID_HOTEL = :id_hotel
         and m.BUSY_DATE between :from_date and :to_date
         and m.BUSY_GROUP_TYPE > 1 -- excludes expected bookings
  group by M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL, s.ID_PROFILE_AGENT,
         S.MARKET_SEGMENT_CODE, S.SOURCE_CODE, S.CHANNEL_CODE, S.HEAR_REASON_CODE, S.COME_REASON_CODE;

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, M.ID_PROFILE_AGENT,
           M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE,
           sum(M.ROOMS_NOSHOW), sum(M.ROOMS_CANCELED)
    from   RESERV_STATISTIC_CANCELED$INT(:id_hotel, :from_date, :to_date) M
    group by M.ID_ROOM_TYPE, M.BUSY_DATE, M.ID_PROFILE_AGENT,
           M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE
    into   :id_room_type, :busy_date,  :id_profile_agent,
           :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
           :rooms_noshow, :rooms_canceled
  do begin

    update SUMMARY_OCCUPANCY_PROFILE_MRKT MA
    set    MA.ROOMS_NOSHOW = :rooms_noshow,
           MA.ROOMS_CANCELED = :rooms_canceled
    where  MA.FOR_DATE = :busy_date
           and MA.ID_ROOM_TYPE = :id_room_type
           and MA.ID_PROFILE_AGENT = :id_profile_agent
           and MA.MARKET_SEGMENT_CODE = :market_segment_code
           and MA.SOURCE_CODE = :source_code
           and MA.CHANNEL_CODE = :channel_code
           and MA.HEAR_REASON_CODE = :hear_reason_code
           and MA.COME_REASON_CODE = :come_reason_code;
    if (row_count = 0) then begin
      insert into SUMMARY_OCCUPANCY_PROFILE_MRKT (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL, ID_PROFILE_AGENT,
             MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
             ROOMS_NOSHOW, ROOMS_CANCELED)
      values (:id_room_type, :busy_date, :id_hotel, :id_profile_agent,
             :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
             :rooms_noshow, :rooms_canceled);
    end
  end
end
^

/* Alter (SUMMARY_STATISTIC_REBUILD$EW) */
ALTER PROCEDURE SUMMARY_STATISTIC_REBUILD$EW(ID_HOTEL INTEGER)
 AS
declare variable id_end_work integer;
  declare variable summary_date date;
  declare variable system_date date;
  declare variable reservs_count integer;
begin
  execute procedure SYSTEM_DATE_GET (:ID_HOTEL)
  returning_values :system_date;

  for
    select d.REBUILD_DATE, count(rd.ID_RESERV_DETAIL)
    from   SUMMARY_REBUILD_DATE d
           left outer join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = d.ID_RESERV
    where  d.ID_HOTEL = :ID_HOTEL
           and d.REBUILD_DATE < :system_date --!!! rebuild old ew dates only
    group by d.REBUILD_DATE
    into   :summary_date, :reservs_count
  do begin
    execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:id_hotel, :summary_date, :summary_date);

    if (:reservs_count > 0) then begin
      id_end_work = null;
      select first 1 ew.ID_END_WORK
      from   END_WORKS ew
      where  ew.PREV_DATE = :summary_date
             and ew.NEXT_DATE > :summary_date
             and ew.END_WORK_KIND = '3'
             and ew.ID_HOTEL = :ID_HOTEL
      into   :id_end_work;

      if (:id_end_work is not null) then
         execute procedure REVENUE_EW_SUMMARIZE$INT (:id_end_work, 'statistic');
    end
  end

  delete from SUMMARY_REBUILD_DATE rd where rd.ID_HOTEL = :ID_HOTEL;
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_PARAMS$INT for: TARIFA_GET_PARAM */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TARIFA_GET_PARAM) */
ALTER PROCEDURE TARIFA_GET_PARAM(ID_PARAM INTEGER,
FOR_DATE DATE,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER)
 RETURNS(OUT_VALUE VARCHAR(255))
 AS
declare variable is_interface integer;
  declare variable param_code varchar(30);
  declare variable is_value integer;
  declare variable int1 integer;
  declare variable data_type varchar(10);
  declare variable pvalue varchar(20);
  declare variable from_ date;
  declare variable to_ date;
begin
  select TP.IS_INTERFACE, TP.PARAM_CODE, TP.IS_VALUE, TP.DATA_TYPE, TP.PVALUE
  from   TARIFA_PARAMS TP
  where  ID_TARIFA_PARAM = :ID_PARAM 
  into   :is_interface, :param_code, :is_value, :data_type, :pvalue;
  /*get interface params*/
  if (:PARAM_CODE = 'NATION2') then
    PARAM_CODE = 'NATION'; /* !!!!!!!!!! */

  /*get value params*/
  if (:IS_VALUE = 1) then
    OUT_VALUE = :pvalue;

  /*get internal params*/
  OUT_VALUE = null;
  if (:IS_INTERFACE = 0) then begin
    if (:PARAM_CODE = 'TODAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE, 'D;dd/mm/yyyy');

    end else if (:PARAM_CODE = 'WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE, 'DW;MON');

    end else if (:PARAM_CODE = 'NEXT_DATE_WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE + 1, 'DW;MON');

    end else if (:PARAM_CODE = 'PREV_DATE_WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE - 1, 'DW;MON');

    end else if (:PARAM_CODE = 'REQUIRED_WEEK_DAYS') then begin
      select ti.FROM_DATE, ti.TO_DATE - 1
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :from_, :to_;
      
      select list(formatdate(RLP.OUT_DATE, 'DW;MON'))
      from   SYSTEM_LOOP_PERIOD(:from_, :to_) RLP
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'ARRIVAL_WEEK_DAYS') then begin
      select formatdate(ti.FROM_DATE, 'DW;MON')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'PRESTOI') then begin
      select cast(ti.TO_DATE - ti.FROM_DATE as integer)
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'FROM_DATE') then begin
      select formatdate(ti.FROM_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TO_DATE') then begin
      select formatdate(ti.TO_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'FIRST_NIGHT') then begin
      select formatdate(ti.FROM_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'LAST_NIGHT') then begin
      select formatdate(ti.TO_DATE - 1, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'DAYS_PASSED') then begin
       /* 01  03 -  01-1, 02-2   (        )*/   
       select cast((:FOR_DATE - G.FROM_DATE + 1) as integer)
       from   TAR_CALC_INPUT$TMP G
       where  G.ID_TAR_INPUT = :ID_TAR_INPUT
       into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'DAYS_TO_STAY') then begin
       /* 01  03 -  01-2, 02-1    (  )*/
       select cast((G.TO_DATE - :FOR_DATE - 1) as integer)
       from   TAR_CALC_INPUT$TMP G
       where  G.ID_TAR_INPUT = :ID_TAR_INPUT
       into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_GUESTS') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_CHILDREN') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.IS_CHILD = 1
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_ADULTS') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.IS_CHILD is distinct from 1
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_GUESTS_BY_ACCOUNT') then begin
      select (select count(*)
              from   GUEST G
                     join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
              where  G.ID_BASE_ACCOUNT = ti.ID_BASE_ACCOUNT
                     and G.FROM_DATE <= :FOR_DATE
                     and G.TO_DATE > :FOR_DATE
                     and RD.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP ti
      where  ti.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TYPE_ROOM') then begin
      select trim(rt.TYPE_ROOM)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join ROOM_TYPES RT on RT.ID_ROOM_TYPE = tid.ID_ROOM_TYPE
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
      into   :OUT_VALUE;
      /* TO PRESEVE COMPATIBILITY WITH OLD TARIFF VERSIONS */
      /* WE HAVE TO RETURN THE NAME NOT THE ID !           */

    end else if (:PARAM_CODE = 'TYPE_STAY') then begin
      select trim(ts.TYPE_STAY)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join TYPE_STAY TS on ts.ID_TYPE_STAY = tid.ID_TYPE_STAY
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TYPE_HRANA') then  begin
      select trim(m.NAME)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join MEALS m on m.ID_BOARD = tid.ID_BOARD
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;
      OUT_VALUE = trim(coalesce(:OUT_VALUE, ''));

    end else if (:PARAM_CODE = 'PACK_ITEMS') then begin
      OUT_VALUE = null;
      select TID.PACKET_ITEMS
      from   TAR_CALC_INPUT$TMP TID
      where  TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;
      OUT_VALUE = coalesce(:OUT_VALUE, '~~');
      -- strfloateval('POS("~2~", :PACK_ITEMS)>0', ';:PACK_ITEMS,STRING,~2~3~D~')

    end else if (:PARAM_CODE = 'AGE') then begin
      select ti.GUEST_AGE
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_SEX') then begin
      select G.GUEST_SEX
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE ;
      if ((:OUT_VALUE is null) or (:OUT_VALUE = '')) then OUT_VALUE = '-' ;

    end else if (:PARAM_CODE = 'NATION') then begin
      select tid.COUNTRY_CODE
      from   TAR_CALC_INPUT$TMP TID
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_FIRST_DATE') then begin
      select cast(iif(G.FROM_DATE = :FOR_DATE, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_LAST_DATE') then begin
      select cast(iif(G.TO_DATE -1 = :FOR_DATE, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_LATE_CHECKOUT') then begin
      select g.IS_LATE_CHECKOUT
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_FIRST_GUEST_IN_ROOM') then begin
      select (select count(ti.ID_TAR_INPUT)
              from   TAR_CALC_INPUT$TMP ti
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and ti.ID_GUEST < t.ID_GUEST)
      from   TAR_CALC_INPUT$TMP t
      where  t.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :int1;

      if (:int1 = 0) then OUT_VALUE = 1; else OUT_VALUE = 0;
      
    end else if (:PARAM_CODE = 'IS_DIFER_NATIONS') then begin
      select (select cast(iif(count(distinct ti.COUNTRY_CODE) > 1, 1, 0) as integer)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_GROUP') then begin
      select cast(iif(g.ID_GROUP is not null, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_NIGHTS_BY_ACCOUNT') then begin
      /*          . */
      select (select cast(sum (G_IN_R.TO_DATE - G_IN_R.FROM_DATE) as integer)
              from   GUEST G_IN_R
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_R.ID_RESERV_DETAIL
              where  G_IN_R.ID_BASE_ACCOUNT = G.ID_BASE_ACCOUNT
                     and G_IN_R.CHECK_STATUS = 0
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_INTURN_BYACCOUNT') then begin
      select (select cast(count(G.ID_GUEST) as integer)
              from   GUEST G
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL and rd.IS_ANUL = 0
              where  G.ID_BASE_ACCOUNT = t.ID_BASE_ACCOUNT
                     and G.ID_GUEST <= t.ID_GUEST)
      from   TAR_CALC_INPUT$TMP t
      where  t.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'PAX_PRICE_WO_ADDINS') then begin
      /*             */
      /* PRICE_ORIG          */
      -- ?????    ???
      /*select  max(AP.PRICE_ORIG)
      from    ACCOUNT_POST AP 
      where   AP.ID_GUEST = :ID_GUEST
              and AP.DATE_POST = :FOR_DATE
              and AP.IS_BASE = 1
      plan    (AP index (ACCOUNT_POST_IDX6))
      into    :OUT_VALUE;
      */
      OUT_VALUE = null;

    end else if (:PARAM_CODE = 'ROOM_FEATURES') then begin
      select substring(R.FEATURES from 1 for 255)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join ROOMS R on r.ID_ROOM = tid.ID_ROOM
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_NIGHTS') then begin
      select (select cast(sum (G_IN_V.TO_DATE - G_IN_V.FROM_DATE) as integer)
              from   GUEST G_IN_V
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_V.ID_RESERV_DETAIL
              where  rd.ID_AGENT_PROFILE is not distinct from G.ID_AGENT_PROFILE
                     and G_IN_V.VAUCHER_NUM = G.VOUCHER_NUM
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE ;

    end else if (:PARAM_CODE = 'VAUCHER_GUESTS') then begin
      select (select count (G_IN_V.ID_GUEST)
              from   GUEST G_IN_V
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_V.ID_RESERV_DETAIL and rd.IS_ANUL = 0
              where  rd.ID_AGENT_PROFILE is not distinct from G.ID_AGENT_PROFILE
                     and G_IN_V.VAUCHER_NUM = G.VOUCHER_NUM
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_DATE') then begin
      select formatdate(G.VOUCHER_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_TEXT') then begin
      select G.VOUCHER_TEXT
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_INTURN_BYROOM') then begin
      select (select count(*) + 1
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ((t.IS_CHILD = 0 and ti.IS_CHILD = 0 and td.CHECKIN_ORDER < tid.CHECKIN_ORDER)
                          or (t.IS_CHILD = 1 and ((ti.IS_CHILD = 0) or (ti.GUEST_AGE > t.GUEST_AGE) or (ti.GUEST_AGE = t.GUEST_AGE and td.CHECKIN_ORDER < tid.CHECKIN_ORDER) )))
              )
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'ADULT_INTURN_BYROOM') then begin
      OUT_VALUE = 0;
      select (select count(*) + 1
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and td.CHECKIN_ORDER < tid.CHECKIN_ORDER
                     and ti.IS_CHILD = 0)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
             and t.IS_CHILD = 0
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'CHILD_INTURN_BYROOM') then begin
      OUT_VALUE = 0;
      select (select count(*) + 1
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ( (ti.GUEST_AGE > t.GUEST_AGE) or (ti.GUEST_AGE = t.GUEST_AGE and td.CHECKIN_ORDER < tid.CHECKIN_ORDER) )
                     and ti.IS_CHILD = 1)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
             and t.IS_CHILD = 1
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_TYPE') then begin
      select G.ID_GUEST_TYPE
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TO_AGENT') then begin
      select G.ID_AGENT_PROFILE
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else begin
      exception RATING_EXCEPTION 'Unsupported param - '||:PARAM_CODE;
    end

  end /*PART OF INTERNAL PARAMS*/


  /**********************************************/
  begin
    /* the source of the next check is gone with the wind
    /* but we must distinguish different data types */
    if ((:OUT_VALUE is null) or (:OUT_VALUE = '')) then begin
      /*not allow nulls*/
      if (:DATA_TYPE = 'DATE') then OUT_VALUE = '01/01/1899';
      else OUT_VALUE = '-1';  -- Unspecified
    end else if (:DATA_TYPE = 'INTEGER') then begin
      OUT_VALUE = cast(:OUT_VALUE as integer);
      /* to prevent errors like OUT_VALUE = '00001' */
    end

    when any do exception RATING_EXCEPTION 'Unsupported param value: ' || :param_code || ' = "' || coalesce(:OUT_VALUE, '<null>') || '"';
  end
  /**********************************************/
end
^

/* Alter (TEST_AVAILABILITY) */
ALTER PROCEDURE TEST_AVAILABILITY(FROM_DATE DATE,
TO_DATE DATE,
HOTELS VARCHAR(255))
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_AGENT INTEGER,
AGENT_NAME VARCHAR(100),
SOLD INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
CONT_BP_REMAIN INTEGER,
RES_WAITING INTEGER,
CONT_PLAIN INTEGER,
CONT_BP INTEGER,
CONT_BP_PLAIN INTEGER,
CONT_PLAIN_REMAIN INTEGER,
RES_TOTAL INTEGER,
ROOM_TYPE_NAME VARCHAR(20))
 AS
declare variable id_occupancy_session integer;
begin
  execute procedure AVAILABILITY_OCCUP_PREPARE$AVL (:FROM_DATE, :TO_DATE, 0, 0, 0, 1, 1, 0, 0, 0, :HOTELS);

  for
    SELECT
        FOR_DATE,
        SOT.ID_ROOM_TYPE,
        SOT.ID_AGENT,
        RT.TYPE_ROOM as ROOM_TYPE_NAME,
        P.PROFILE_NAME as AGENT_NAME,
        sum(SOT.SOLD) as SOLD,
        sum(SOT.RES_CONFIRMED) as RES_CONFIRMED,
        sum(SOT.RES_NOTCONFIRMED) as RES_NOTCONFIRMED,
        sum(SOT.RES_WAITING) as RES_WAITING,
        sum(SOT.CONT_PLAIN  ) as CONT_PLAIN,
        sum(SOT.CONT_BP) as CONT_BP,
        sum(SOT.CONT_BP_REMAIN) as CONT_BP_REMAIN,
        sum(SOT.CONT_PLAIN_REMAIN  ) as CONT_PLAIN_REMAIN,
        sum(0 + (SOT.RES_CONFIRMED+SOT.RES_NOTCONFIRMED) ) as RES_TOTAL
    from SYSTEM_STRING_PARSER(:hotels) sp
         join SMART_OCCUP$TMP SOT on sot.ID_HOTEL = sp.ITEM
         left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = SOT.ID_ROOM_TYPE
         left outer join PROFILE_AGENT PA on SOT.ID_AGENT = PA.ID_AGENT
         left outer join PROFILE P on PA.ID_PROFILE = P.ID_PROFILE
    where SOT.ID_AGENT > -100
    group by 1,2,3,4,5
    order by 5,3,1,2
    into  :for_date, :id_room_type, :id_agent, :room_type_name, :agent_name, :sold,
          :res_confirmed, :res_notconfirmed, :res_waiting, :cont_plain, :cont_bp,
          :cont_bp_remain, :cont_plain_remain, :res_total
  do suspend;

end
^

/* Alter (TEST_RATING) */
ALTER PROCEDURE TEST_RATING RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
declare variable from_date date;
 declare variable to_date date;
 declare variable hotels varchar(255);
begin
  from_date = '01.01.2010';
  to_date = '08.01.2010';
  hotels = '2';

  execute procedure AVAILABILITY_OCCUP_PREPARE$AVL (:from_date, :from_date + 30, 1, 0, 0, 1, 1, 0, 0, 0, :hotels);

  execute procedure AVAILABILITY_RATING$AVL (null, :from_date, :to_date, 2,
          2, 0, '33,31,55,30,32,54,62,59,71,72', '2301,2210,2347,1633,2300,2342,2353,2362', '6,0,8,7,22,21,23', :hotels)
  returning_values (:ID_OCCUPANCY_SESSION);

end
^

/* Restore proc. body: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER,
IS_MANUAL_TRANSFER TYPE OF TLOGICAL = 1)
 AS
declare variable id_current_account integer;
  declare variable id_service integer;
  declare variable is_anul integer;
  declare variable id_tariff integer;
  declare variable qty_post numeric(15,2);
  declare variable qty_free numeric(15,2);
  declare variable price_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable id_room integer;
  declare variable id_base_doc integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  if ((:AP_DBKEY is null) or (:id_target_account is null) or (:id_target_account < 0)) then
     exception POSTING_TRANSFER_EXCEPTION '-31';

  select AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST, AP.QTY_FREE,
         AP.PRICE_ORIG, AP.CURR_ORIG, AP.RATE_ORIG, ap.from_date, ap.to_date,
         AP.IS_ANUL, AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_BASE_DOC, A.ID_HOTEL
  from   ACCOUNT_POST AP
         left join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :id_service, :id_tariff, :id_room, :qty_post, :qty_free,
         :price_orig, :curr_orig, :rate_orig, :from_date, :to_date,
         :is_anul, :id_account_post, :id_current_account, :id_base_doc, :id_hotel;

  if (:id_current_account = :id_target_account) then EXIT;

  if (:is_anul = 1 ) then exception POSTING_TRANSFER_EXCEPTION '-33';

  if (:id_base_doc is not null) then exception POSTING_TRANSFER_EXCEPTION '-32';

  if (not exists(select A.ID_ACCOUNT
                 from   ACCOUNT A
                 where  A.ID_ACCOUNT = :ID_TARGET_ACCOUNT
                        and A.ID_HOTEL = :id_hotel)) then exception POSTING_TRANSFER_EXCEPTION '-376';

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
                    :id_tariff, :id_room, :qty_post, :qty_free, :price_orig, :curr_orig,
                    :rate_orig, 'TRANSFER_POSTING', null, :from_date, :to_date,
                    iif(:IS_MANUAL_TRANSFER is distinct from 1, 1, 0), :id_target_account)
  returning_values  :no_use, :no_use, :no_use;

  insert into ACCOUNT_TRANSFER_HISTORY(ID_ACCOUNT_POST, FROM_ID_ACCOUNT, TO_ID_ACCOUNT)
  values (:id_account_post, :id_current_account, :id_target_account);
end
^

/* Restore proc. body: ACCOUNT_POSTING_UPDATE */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable in_db_key char(8);
begin
  /* GUI facade for manual update */
  select AP.ID_ACCOUNT, AP.ID_GUEST, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :id_guest, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date)
  returning_values  (:new_qty_post, :new_price_post, :new_ac);

  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    if (coalesce(:id_guest, 0) > 0) then begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || :id_account
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || replace(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'POST_UPDATE', :action_text);
    end else begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || replace(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
    end
  end

end
^

/* Restore proc. body: AVAILABILITY_OCCUPANCY$AVL */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
begin

  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, :FETCH_TOTALS, 1, 1, 1, 1, 1, 1, :HOTELS);

  ID_OCCUPANCY_SESSION = current_transaction;
end
^

/* Restore proc. body: EAI_EXT_POST_TO_MH_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  if (:CODE_TYPE = 'EXT_CODE') then begin
    execute procedure EAI_MAP_SERVICE(:SERVICE_CODE, :SERVICE_CODE, 'UNKNOWN', :id_hotel)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_SERVICE;
    if (:ERR_CODE < 0) then exit;
  end else begin
    select S.ID_SERVICE
    from   SERVICES S
    where  S.ID_SERVICE = :SERVICE_CODE
           and s.ID_HOTEL = :ID_HOTEL
    into   :ID_SERVICE;
    if (:ID_SERVICE is null) then begin
      ERR_CODE = -85;   /* Wrong value! */
      exit;
    end
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:ID_ACCOUNT_POST, :SERVICE_CODE, null, null);

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Restore proc. body: EAI_EXT_SERVICE_POST */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable max_id_service integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_ROOM  = null;
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  select min(S.ID_SERVICE) as id_service, max(s.id_service) as max_id_service
  from   SERVICES S
  where  S.EXT_CODE = :SERVICE_EXT_CODE
         and s.IS_BASE = 0
         and s.IS_DELETED = 0
  into   :ID_SERVICE, :max_id_service;
  if (:ID_SERVICE is null) then begin
      ERR_CODE = -388;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end else if (:ID_SERVICE <> :max_id_service) then begin
      ERR_CODE = -389;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_EXT_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:ID_ACCOUNT_POST, :SERVICE_EXT_CODE, null, null);

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Restore proc. body: EAI_POS_POSTING_ADD$P2E */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
declare variable id_service integer;
  declare variable my_post_text varchar(255);
  declare variable my_resource_text varchar(255);
  declare variable nation_curr varchar(3);
  declare variable post_short_code varchar(10);
  declare variable id_hotel integer;
  declare variable id_account_post integer;
begin
  /* in_on_guest = 0 (account), 1 (guest), -1 (ew)
  */
  if (:IN_ON_GUEST = 1) then begin
    select rd.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :IN_ID_GUEST
    into   :id_hotel;
  end else begin
    select a.ID_HOTEL
    from   account a
    where  a.ID_ACCOUNT = :in_id_account
    into   :id_hotel;
  end

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :nation_curr;

  if ('END_WORK' = :in_smetka_num) then begin
    post_short_code='POS_EW';
  end else begin
    post_short_code='POS';
  end

  /* FIND SERVICE */
  execute procedure EAI_MAP_SERVICE(:in_service_tag, :in_service_name, 'POS', :id_hotel)
  returning_values  :err_code, :err_text, :id_service;
  if (:err_code < 0) then exit;

  my_post_text = 'date:'|| formatdate(:in_date_smetka, 'D;dd.mm.yyyy') ||
                 ' num:'|| :in_smetka_num ||
                 ' obj:'|| :in_obj_name ||
                 ' tbl:'|| :in_table ||
                 ' site:'|| :in_site;

  my_resource_text = 'POS_ID_SMETKA:'||:in_id_smetka;
  my_post_text = substring(:my_post_text from 1 for 100);
  my_resource_text = substring(:my_resource_text from 1 for 49);

  if (:in_on_guest = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:in_id_guest, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code, '')
    returning_values  :err_code, :err_text, :out_id_account, :id_account_post;
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:in_id_account, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code)
    returning_values  :err_code, :err_text, :id_account_post;
    out_id_account = :in_id_account;
  end
  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:id_account_post, :post_short_code, :IN_POS_USER, :IN_DATETIME);
end
^

/* Restore proc. body: EAI_TELECOUNT_TRANSFER */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* Restore proc. body: END_WORK */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable system_date date;
  declare variable id_end_work integer;
  declare variable last_closed_date date;
  declare variable lock_id integer;
  declare variable dbkey char(8);
begin
  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date >= :in_next_date) then exception END_WORK_EXCEPTION '-43';
  if (:IN_NEXT_DATE > current_date + 1) then exception END_WORK_EXCEPTION '-60';

  last_closed_date = :in_next_date - 1;

  /* LOCK THE CURRENT FINANCIAL (SYSTEM) DATE  */
  lock_id = null;
  while (:lock_id is null) do begin
    lock_id = strhash_large(:system_date || :id_hotel);
    execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'lock');
  
    when any do begin
      exception END_WORK_EXCEPTION '-337' || f_character(31) || f_character(29) || FormatDate(:system_date, 'D;dd.mm.yyyy');
    end
  end

  /* RIGHT IS REQUIRED TO CHANGE THE FINANCIAL DATE IF THERE ARE GUESTS WITH OVERDUE CHECK OUT */
  if (exists(
    select *
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
    where  G.TO_DATE <= :last_closed_date
           and G.CHECK_STATUS < 1
           and RD.ID_HOTEL = :id_hotel
           and rd.IS_ANUL = 0
  )) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('EW_OVERDUE_CHECKOUT');
  end

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', 'EW');
  -- Suppress eventual right checks into next procedures - all is permitted. Is this needed(?!?)

  for
    select p.RDB$DB_KEY
    from   ACCOUNT_POST p
           join ACCOUNT a on a.ID_ACCOUNT = p.ID_ACCOUNT
    where  p.DATE_POST between :system_date and :last_closed_date
           and p.ID_GUEST > 0
           and a.ID_HOTEL = :ID_HOTEL
    into   :dbkey
  do begin
    update ACCOUNT_POST AP
    set    ap.ROOM_NAME = (select R.ROOM_NAME
                           from   GUEST G
                                  join ROOMS R on R.ID_ROOM = G.ID_ROOM
                           where  G.ID_GUEST = ap.ID_GUEST)
    where  ap.RDB$DB_KEY = :dbkey;
  end

  /* CHANGE SYSTEM DATE */
  execute procedure SYSTEM_DATE_SET(:id_hotel, :system_date, :in_next_date)
  returning_values :id_end_work;

  /* AUTO EXPIRATION OF ROOM NUMBERS, ROOMS AND BOOKING POSITIONS */
  execute procedure RESERVS_EXPIRE$INT(:last_closed_date, :id_hotel);

  execute procedure AGENT_CONTINGENT_EXPIRE(:system_date, :last_closed_date, null, 0, 1, :id_hotel);

  /* DELETE PERSON PROFILES WITH EXPIRATION DATE */
  execute procedure PROFILE_PERSON_EXPIRE (:in_next_date);

  execute procedure HOUSEKEEPING_MARK_ROOMS$EW(:id_end_work);

  /* Summary statistic */
  if (:in_next_date > :system_date) then begin
    execute procedure SUMMARY_FINANCE_STATISTIC$EW(:id_end_work);

    execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:ID_HOTEL, :system_date, :last_closed_date);

    execute procedure SUMMARY_STATISTIC_REBUILD$EW(:ID_HOTEL);

    execute procedure SUMMARY_FORECAST$INT(:ID_HOTEL, :system_date);
  end

  /* Delete pseudo-temporal tables */
  delete from RESERV_ERROR;
  /*  */

--  execute procedure CACHES_RESOLVE;

  execute procedure SYSTEM_LOG_ADD('SYSTEM', :id_end_work, 'DAY_EW', f_character(29) || :system_date || f_character(28) || :IN_NEXT_DATE);

  execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'release');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', null);

  execute procedure SYSTEM_CACHE_APPLY('end_work');
end
^

/* Restore proc. body: OCCUPANCY_SUMMARY_REMAKE$SYS */
ALTER PROCEDURE OCCUPANCY_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
begin
  if (not exists (select h.ID_HOTEL
                  from   HOTEL H
                  where  h.ID_HOTEL = :ID_HOTEL)) then exception WRONG_VALUE 'Non-existing hotel!';

  select mindate(sd.SYSTEM_DATE - 1, :TO_DATE)
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :TO_DATE;

  if (:FROM_DATE > :TO_DATE) then exit;

  execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:id_hotel, :FROM_DATE, :TO_DATE);

  execute procedure SYSTEM_LOG_ADD ('HOTEL', :id_hotel, 'OCCUPANCY_REGENERATE',
                                    f_character(29) || formatdate(:from_date, 'D;dd/mm/yyyy') || f_character(28) || formatdate(:to_date, 'D;dd/mm/yyyy'));
end
^

/* Restore proc. body: PHONECALL_POST$TC */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Restore proc. body: PHONECALLS_POST_TO_ACCOUNT$TC */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* Restore proc. body: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_OWNER TYPE OF ID,
POST_DATE TYPE OF TDATE,
CURR_ORIG TYPE OF TCURRENCY,
VALUE_ORIG TYPE OF TPRICE,
POST_ON_PMS_ACCOUNT TYPE OF TLOGICAL,
IS_OWNER_INCOME TYPE OF TLOGICAL,
ID_ROOM TYPE OF ID_REF = null)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  if (:POST_ON_PMS_ACCOUNT = 1) then begin
    execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account, :id_owner,
            :CURR_ORIG, :VALUE_ORIG, :id_service, :is_owner_income, :POST_DATE)
    returning_values  (:new_id_account_post);
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :ID_SERVICE, 1, 0, 1,
            :VALUE_ORIG, :CURR_ORIG, current_date, current_date,
            '', '', :POST_DATE, 'PMS', :ID_ROOM)
    returning_values  :err_code, :err_text, :new_id_account_post;
    if (:err_code <> 0) then exception PMS_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

    insert into PMS_EVENT_POST (ID_PMS_EVENT, ID_ACCOUNT_POST, ID_OWNER, LINE_STATUS)
    values (:ID_PMS_EVENT, :NEW_ID_ACCOUNT_POST, :ID_OWNER, 11);
  end
end
^

/* Restore proc. body: POST_SERVICE_FINALIZE$POST */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
  declare variable id_acc_post integer;
  declare variable id_service integer;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable date_post date;
  declare variable price_post numeric(15,4);
  declare variable qty_post numeric(15,2);
  declare variable post_text varchar(100);
  declare variable curr_post varchar(3);
  declare variable id_phonecall integer;
  declare variable p_dbkey char(8);
begin

  if (:OPERATION = 'clear') then begin
    delete from TMP_SERVICE_POST T
    where  T.ID_SEQUENCE = :ID_SEQUENCE;

  end else if (:OPERATION = 'store') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);

    for
      select TS.RDB$DB_KEY, TS.ID_SERVICE, TS.ID_ACCOUNT, TS.ID_GUEST, TS.DATE_POST,
             TS.PRICE_POST, TS.QTY_POST, TS.CURR_POST, TS.POST_TEXT, TS.ID_PHONECALL
      from   TMP_SERVICE_POST TS
      where  TS.ID_SEQUENCE = :ID_SEQUENCE
      into   :p_dbkey, :id_service, :id_account, :id_guest, :date_post,
             :price_post, :qty_post, :curr_post, :post_text, :id_phonecall
    do begin
      id_acc_post = null;
      if (:id_guest is not null) then begin
        execute procedure POST_SERVICE_ON_GUEST$INT (:id_guest, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :CURR_POST,
                :date_post, :date_post, :post_text, '', :date_post, '', '')
        returning_values  (:err_code, :err_text, :no_use, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end else begin
        execute procedure POST_SERVICE_ON_ACCOUNT$INT (:id_account, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :curr_post, :date_post, :date_post, :post_text,
                '', :date_post, '')
        returning_values  (:err_code, :err_text, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end

      update TMP_SERVICE_POST
      set ID_ACCOUNT_POST = :id_acc_post
      where RDB$DB_KEY = :p_dbkey;

      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :DOC_SELECTED,
             AP.SHORT_CODE = case
                               when :id_phonecall is not null then 'TELECOUNT'
                               else null
                             end
      where  AP.ID_ACCOUNT_POST = :id_acc_post;

      if (:id_phonecall is not null) then begin
        update PHONECALLS P
        set    P.ID_ACCOUNT_POST = :id_acc_post
        where  P.ID_PHONECALL = :id_phonecall;
      end
    end
  end
end
^

/* Restore proc. body: RES_TAR_CALC_FINALIZE$INT */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(ID_TAR_CALC INTEGER,
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
  declare variable reserv_posting_disabled smallint;
  declare variable postings_disabled smallint;
  declare variable warn_code integer;
begin
  --  Razpiswa cenata na staia, kakto i price_detailite.

  execute procedure TAR_CALC_EVAL_ALL$INT(:ID_TAR_CALC)
  returning_values  :ERR_CODE, :ERR_TEXT;

  if (:ERR_CODE = 0) then execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

  select iif(si.INFO_VALUE = '1', 1, null)
  from   SYSTEM_INFO_GET('RESERV_POSTINGS_DISABLED') si
  into   :postings_disabled;

  for
    select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, coalesce(:postings_disabled, rd.IS_POSTING_STOPPED),
           coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
           coalesce(max((select first 1 AP.IS_BASE
                         from   GUEST G
                                join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                         where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (it`s possible)
    from   TAR_CALC_INPUT$TMP TI
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
           join TARIFA t on t.ID_TARIFA = rd.ID_RATE
    where  ti.ID_TAR_CALC = :ID_TAR_CALC
    group by 1, 2, 3, 4, 5, 6
    into   :id_reserv_detail, :check_status, :is_posting_stopped,
           :room_currency, :id_hotel, :is_anul, :has_postings
  do begin
    reserv_posting_disabled = iif(:is_posting_stopped = 1 and :has_postings = 0, 1, 0);

    if (:ERR_CODE <> 0) then begin
      -- price calculation error handling  !!!!!
      if (:reserv_posting_disabled = 1) then begin
        -- set price to null, posting is disabled
        update RESERV_DETAIL RD
        set    RD.ROOM_PRICE = null,
               RD.ROOM_CURRENCY = null,
               RD.ROOM_PRICE_DETAILS = null,
               RD.LAST_ID_TAR_CALC = null
        where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
      end else begin
        -- exit on error in price calculation - cannot make valid posts
        EXIT;
      end
    end else begin
      room_price = 0;
      room_price_details = '';
    
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);
  
      if (:reserv_posting_disabled = 0 and ((coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1))) then begin
        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);
      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;
  
        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end
  
      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end

  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;

  if (:ERR_CODE <> 0) then begin
    execute procedure SYSTEM_WARNING_ADD(:ERR_CODE, :ERR_TEXT)
    returning_values :warn_code;
    ERR_CODE = 0;
    ERR_TEXT='';
  end
end
^

/* Restore proc. body: SAFE_OCCUPANCY_MODIFY */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE TYPE OF ID,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable old_booking_number tres_number;
  declare variable id_resource_reservation id_ref;
  declare variable from_datetime tdatetime;
  declare variable action_text tdescription_long;
  declare variable old_occupant varchar(100);
  declare variable old_to_dt timestamp;
  declare variable id_reserv_detail integer;
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation;

  select rr.BOOKING_NUMBER, od.FROM_DATETIME,
         RR.OCCUPANT_NAME, od.TO_DATETIME, rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESERV_DETAIL rd on rd.NUMBER = rr.BOOKING_NUMBER and rd.IS_ANUL = 0
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :old_booking_number, :from_datetime,
         :old_occupant, :old_to_dt, :id_reserv_detail, :id_agent_profile;

  --if (:old_booking_number <> :BOOKING_NUMBER) then exception ASSERT 'Can not change booking number!';
  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  update SAFE_RESOURCE_RESERV rr
  set    rr.PRICE_DESCRIPTION = :price_description,
         rr.ID_RATE_PRICE_PROFILE = :id_agent_profile,
         rr.RATING_UNITS = :rating_units,
         rr.RATE_PRICE = :price,
         rr.RATE_CURR = :currency
  where  rr.ID_RESOURCE_RESERV = :id_resource_reservation;

  execute procedure RESOURCE_RESERVATION_MODIFY (:id_resource_reservation, :ID_SAFE, :from_datetime,
          :TO_DATETIME, :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :old_booking_number, 'mod')
  returning_values :id_resource_reservation, :no_use;

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail)
  returning_values (:DOC_SELECTED);

  /* Log changes */
  if ((:old_occupant <> :OCCUPANT_NAME) or (:old_to_dt <> :TO_DATETIME)) then begin
    action_text = f_character(29) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                  || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                  || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');
  
    execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_CHANGED', :action_text);
  end
end
^

/* Restore proc. body: SAFE_OCCUPANCY_NEW */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE TYPE OF ID,
FROM_DATETIME TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME,
BOOKING_NUMBER TYPE OF TRES_NUMBER,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
ID_RESOURCE_RESERVATION TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable action_text tdescription_long;
  declare variable id_reserv_detail integer;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, s.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  if (:id_resource_reservation is not null) then exception ASSERT '-1064'|| f_character(31) || f_character(29) || :safe_name;

  select rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESERV_DETAIL rd
  where  rd.NUMBER = :BOOKING_NUMBER
         and rd.IS_ANUL = 0
  into   :id_reserv_detail, :id_agent_profile;

  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  execute procedure  RESOURCE_RESERVATION_MODIFY (null, :ID_SAFE, :FROM_DATETIME, :TO_DATETIME,
          :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :BOOKING_NUMBER, 'add')
  returning_values (:id_resource_reservation, :no_use) ;

  insert into SAFE_RESOURCE_RESERV (ID_RESOURCE_RESERV, PRICE_DESCRIPTION, ID_RATE_PRICE_PROFILE,
         RATING_UNITS, RATE_PRICE, RATE_CURR)
  values (:id_resource_reservation, :price_description, :id_agent_profile,
         :rating_units, :price, :currency);

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail, :ID_EXTERNAL_CLIENT_ACCCOUNT)
  returning_values (:DOC_SELECTED);

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = 'CHECKED_IN'
  where  RR.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = :id_resource_reservation
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                || f_character(28) || coalesce(:BOOKING_NUMBER, '')
                || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUPIED', :action_text);
end
^

/* Restore proc. body: SPR_OCC_KONT_AGENT */
ALTER PROCEDURE SPR_OCC_KONT_AGENT(FROM_DATE DATE,
TO_DATE DATE,
ID_AGENT INTEGER,
KIND SMALLINT,
AGE_KIND SMALLINT,
ALL_KINDS SMALLINT,
ID_HOTEL INTEGER)
 RETURNS(TYPE_ROOM VARCHAR(20),
TYPE_ROOM2 VARCHAR(20),
FOR_DATE DATE,
KONTINGENT INTEGER,
DATA INTEGER,
OUT_KIND VARCHAR(20))
 AS
declare variable id_room_type integer;
begin
  /* KIND:  1 - ROOMS
            2 - BEDS
            3 - ADD BEDS
            else - BEDS + ADD BEDS
     AGE_KIND:  1 - ADULTS
                2 - CHILDREN
                else - ALL*/
  kontingent = 0;
  data = 0;
  for
    select distinct AD.ID_ROOM_TYPE
    from   PROFILE_AGENT PA
           join ALLOTMENT_DETAIL AD on AD.ID_ALLOTMENT = PA.ID_CONTINGENT
    where  PA.ID_AGENT = :id_agent
           and AD.FROM_DATE <= :to_date
           and AD.TO_DATE >= :from_date
    into   :id_room_type
  do begin
    select RT.TYPE_ROOM, RT.TYPE_ROOM
    from   ROOM_TYPES RT
    where  RT.ID_ROOM_TYPE = :id_room_type
           and RT.ID_HOTEL = :id_hotel
    into   :type_room, :type_room2;

    for
      select SLP.OUT_DATE
      from   SYSTEM_LOOP_PERIOD(:from_date, :to_date) SLP
      into   :for_date
    do begin
      for
        select KONTINGENT, DATA, OUT_KIND
        from   SPR_OCC_KONT_AGENT_ROOMTYPE_DAY(:for_date,:id_agent,:id_room_type,:kind,:age_kind, :all_kinds)
        into   :kontingent, :data, :out_kind
      do suspend;
    end
  end
end
^

/* Restore proc. body: TAR_CALC_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
declare variable param_code varchar(40);
  declare variable id_param integer;
  declare variable param_value varchar(255);
  declare variable data_type  varchar(30);
  declare variable rate_list varchar(2000);
begin
  err_code = 0;
  param_values = '';

  if (coalesce(:rate_list_replace, '') = '') then rate_list = ',' || :id_rate || ',';
  else rate_list = :rate_list_replace;

  for
    select distinct TBP.PARAM_NAME
    from   SYSTEM_STRING_PARSER (:rate_list, ',') sp
           left join TAR_BO_PARAMS TBP on TBP.ID_TAR_HEAD = sp.ITEM
    where  (TBP.PARAM_TYPE <> 'DATE_DEPENDANT' and :for_date is null)
           or (TBP.PARAM_TYPE = 'DATE_DEPENDANT' and :for_date is not null)
    into   :param_code
  do begin
    if (:param_code is not null) then begin
      id_param = null;
      select TP.ID_TARIFA_PARAM, TP.DATA_TYPE
      from   TARIFA_PARAMS TP
      where  TP.PARAM_CODE = :param_code
             and tp.IS_USE = 1
      into   :id_param, :data_type;
  
      if (:id_param is null) then begin
        err_code = -202;
        execute procedure sys_dbg ('tar calc params err_code: ' || :err_code || F_CRLF() || 'PARAM_CODE = ' || :param_code);
        exit;
      end
  
      execute procedure TARIFA_GET_PARAM (:id_param, :for_date, :id_tar_input, :id_tar_calc)
      returning_values (:param_value);
  
      param_code = ':'||param_code;
  
      if ((:param_code is not null) and (:param_code is not null) and (:data_type is not null)) then
         param_values = :param_values||';'||:param_code||','||:data_type||','||:param_value;
    end
  end
end
^

/* Create Views... */

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_TRANSFER$ACC for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: GUEST_REROUTE_POSTINGS$INT for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE GUEST_REROUTE_POSTINGS$INT(ID_GUEST INTEGER,
ID_BASE_ACCOUNT INTEGER,
ID_EXTRA_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_TRANSFER$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER,
IS_MANUAL_TRANSFER TYPE OF TLOGICAL = 1)
 AS
declare variable id_current_account integer;
  declare variable id_service integer;
  declare variable is_anul integer;
  declare variable id_tariff integer;
  declare variable qty_post numeric(15,2);
  declare variable qty_free numeric(15,2);
  declare variable price_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable id_room integer;
  declare variable id_base_doc integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  if ((:AP_DBKEY is null) or (:id_target_account is null) or (:id_target_account < 0)) then
     exception POSTING_TRANSFER_EXCEPTION '-31';

  select AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST, AP.QTY_FREE,
         AP.PRICE_ORIG, AP.CURR_ORIG, AP.RATE_ORIG, ap.from_date, ap.to_date,
         AP.IS_ANUL, AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_BASE_DOC, A.ID_HOTEL
  from   ACCOUNT_POST AP
         left join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :id_service, :id_tariff, :id_room, :qty_post, :qty_free,
         :price_orig, :curr_orig, :rate_orig, :from_date, :to_date,
         :is_anul, :id_account_post, :id_current_account, :id_base_doc, :id_hotel;

  if (:id_current_account = :id_target_account) then EXIT;

  if (:is_anul = 1 ) then exception POSTING_TRANSFER_EXCEPTION '-33';

  if (:id_base_doc is not null) then exception POSTING_TRANSFER_EXCEPTION '-32';

  if (not exists(select A.ID_ACCOUNT
                 from   ACCOUNT A
                 where  A.ID_ACCOUNT = :ID_TARGET_ACCOUNT
                        and A.ID_HOTEL = :id_hotel)) then exception POSTING_TRANSFER_EXCEPTION '-376';

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
                    :id_tariff, :id_room, :qty_post, :qty_free, :price_orig, :curr_orig,
                    :rate_orig, 'TRANSFER_POSTING', null, :from_date, :to_date,
                    iif(:IS_MANUAL_TRANSFER is distinct from 1, 1, 0), :id_target_account)
  returning_values  :no_use, :no_use, :no_use;

  insert into ACCOUNT_TRANSFER_HISTORY(ID_ACCOUNT_POST, FROM_ID_ACCOUNT, TO_ID_ACCOUNT)
  values (:id_account_post, :id_current_account, :id_target_account);
end
^

/* Alter (ACCOUNT_POSTING_UPDATE) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable in_db_key char(8);
begin
  /* GUI facade for manual update */
  select AP.ID_ACCOUNT, AP.ID_GUEST, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :id_guest, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date)
  returning_values  (:new_qty_post, :new_price_post, :new_ac);

  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    if (coalesce(:id_guest, 0) > 0) then begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || :id_account
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || replace(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'POST_UPDATE', :action_text);
    end else begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || replace(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
    end
  end

end
^

/* Alter (AVAILABILITY_OCCUPANCY$AVL) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$AVL(FROM_DATE DATE,
TO_DATE DATE,
FETCH_TOTALS SMALLINT,
HOTELS VARCHAR(255) = '')
 RETURNS(ID_OCCUPANCY_SESSION INTEGER)
 AS
begin

  execute procedure AVAILABILITY_OCCUPANCY$INT (:FROM_DATE, :TO_DATE, :FETCH_TOTALS, 1, 1, 1, 1, 1, 1, :HOTELS);

  ID_OCCUPANCY_SESSION = current_transaction;
end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_POST_TO_FRONT_ONLINE for: EAI_EXT_POST_TO_MH_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_EXT_POST_TO_MH_FRONT_ONLINE) */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  if (:CODE_TYPE = 'EXT_CODE') then begin
    execute procedure EAI_MAP_SERVICE(:SERVICE_CODE, :SERVICE_CODE, 'UNKNOWN', :id_hotel)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_SERVICE;
    if (:ERR_CODE < 0) then exit;
  end else begin
    select S.ID_SERVICE
    from   SERVICES S
    where  S.ID_SERVICE = :SERVICE_CODE
           and s.ID_HOTEL = :ID_HOTEL
    into   :ID_SERVICE;
    if (:ID_SERVICE is null) then begin
      ERR_CODE = -85;   /* Wrong value! */
      exit;
    end
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:ID_ACCOUNT_POST, :SERVICE_CODE, null, null);

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Alter (EAI_EXT_SERVICE_POST) */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable max_id_service integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_ROOM  = null;
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  select min(S.ID_SERVICE) as id_service, max(s.id_service) as max_id_service
  from   SERVICES S
  where  S.EXT_CODE = :SERVICE_EXT_CODE
         and s.IS_BASE = 0
         and s.IS_DELETED = 0
  into   :ID_SERVICE, :max_id_service;
  if (:ID_SERVICE is null) then begin
      ERR_CODE = -388;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end else if (:ID_SERVICE <> :max_id_service) then begin
      ERR_CODE = -389;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_EXT_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:ID_ACCOUNT_POST, :SERVICE_EXT_CODE, null, null);

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* empty dependent procedure body */
/* Clear: EAI_POS_POSTING_ADD for: EAI_POS_POSTING_ADD$P2E */
ALTER PROCEDURE EAI_POS_POSTING_ADD(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_POS_POSTING_ADD$P2E) */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
declare variable id_service integer;
  declare variable my_post_text varchar(255);
  declare variable my_resource_text varchar(255);
  declare variable nation_curr varchar(3);
  declare variable post_short_code varchar(10);
  declare variable id_hotel integer;
  declare variable id_account_post integer;
begin
  /* in_on_guest = 0 (account), 1 (guest), -1 (ew)
  */
  if (:IN_ON_GUEST = 1) then begin
    select rd.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :IN_ID_GUEST
    into   :id_hotel;
  end else begin
    select a.ID_HOTEL
    from   account a
    where  a.ID_ACCOUNT = :in_id_account
    into   :id_hotel;
  end

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :nation_curr;

  if ('END_WORK' = :in_smetka_num) then begin
    post_short_code='POS_EW';
  end else begin
    post_short_code='POS';
  end

  /* FIND SERVICE */
  execute procedure EAI_MAP_SERVICE(:in_service_tag, :in_service_name, 'POS', :id_hotel)
  returning_values  :err_code, :err_text, :id_service;
  if (:err_code < 0) then exit;

  my_post_text = 'date:'|| formatdate(:in_date_smetka, 'D;dd.mm.yyyy') ||
                 ' num:'|| :in_smetka_num ||
                 ' obj:'|| :in_obj_name ||
                 ' tbl:'|| :in_table ||
                 ' site:'|| :in_site;

  my_resource_text = 'POS_ID_SMETKA:'||:in_id_smetka;
  my_post_text = substring(:my_post_text from 1 for 100);
  my_resource_text = substring(:my_resource_text from 1 for 49);

  if (:in_on_guest = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:in_id_guest, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code, '')
    returning_values  :err_code, :err_text, :out_id_account, :id_account_post;
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:in_id_account, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code)
    returning_values  :err_code, :err_text, :id_account_post;
    out_id_account = :in_id_account;
  end
  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:id_account_post, :post_short_code, :IN_POS_USER, :IN_DATETIME);
end
^

/* Alter (EAI_TELECOUNT_TRANSFER) */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* Alter (END_WORK) */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable system_date date;
  declare variable id_end_work integer;
  declare variable last_closed_date date;
  declare variable lock_id integer;
  declare variable dbkey char(8);
begin
  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date >= :in_next_date) then exception END_WORK_EXCEPTION '-43';
  if (:IN_NEXT_DATE > current_date + 1) then exception END_WORK_EXCEPTION '-60';

  last_closed_date = :in_next_date - 1;

  /* LOCK THE CURRENT FINANCIAL (SYSTEM) DATE  */
  lock_id = null;
  while (:lock_id is null) do begin
    lock_id = strhash_large(:system_date || :id_hotel);
    execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'lock');
  
    when any do begin
      exception END_WORK_EXCEPTION '-337' || f_character(31) || f_character(29) || FormatDate(:system_date, 'D;dd.mm.yyyy');
    end
  end

  /* RIGHT IS REQUIRED TO CHANGE THE FINANCIAL DATE IF THERE ARE GUESTS WITH OVERDUE CHECK OUT */
  if (exists(
    select *
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
    where  G.TO_DATE <= :last_closed_date
           and G.CHECK_STATUS < 1
           and RD.ID_HOTEL = :id_hotel
           and rd.IS_ANUL = 0
  )) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('EW_OVERDUE_CHECKOUT');
  end

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', 'EW');
  -- Suppress eventual right checks into next procedures - all is permitted. Is this needed(?!?)

  for
    select p.RDB$DB_KEY
    from   ACCOUNT_POST p
           join ACCOUNT a on a.ID_ACCOUNT = p.ID_ACCOUNT
    where  p.DATE_POST between :system_date and :last_closed_date
           and p.ID_GUEST > 0
           and a.ID_HOTEL = :ID_HOTEL
    into   :dbkey
  do begin
    update ACCOUNT_POST AP
    set    ap.ROOM_NAME = (select R.ROOM_NAME
                           from   GUEST G
                                  join ROOMS R on R.ID_ROOM = G.ID_ROOM
                           where  G.ID_GUEST = ap.ID_GUEST)
    where  ap.RDB$DB_KEY = :dbkey;
  end

  /* CHANGE SYSTEM DATE */
  execute procedure SYSTEM_DATE_SET(:id_hotel, :system_date, :in_next_date)
  returning_values :id_end_work;

  /* AUTO EXPIRATION OF ROOM NUMBERS, ROOMS AND BOOKING POSITIONS */
  execute procedure RESERVS_EXPIRE$INT(:last_closed_date, :id_hotel);

  execute procedure AGENT_CONTINGENT_EXPIRE(:system_date, :last_closed_date, null, 0, 1, :id_hotel);

  /* DELETE PERSON PROFILES WITH EXPIRATION DATE */
  execute procedure PROFILE_PERSON_EXPIRE (:in_next_date);

  execute procedure HOUSEKEEPING_MARK_ROOMS$EW(:id_end_work);

  /* Summary statistic */
  if (:in_next_date > :system_date) then begin
    execute procedure SUMMARY_FINANCE_STATISTIC$EW(:id_end_work);

    execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:ID_HOTEL, :system_date, :last_closed_date);

    execute procedure SUMMARY_STATISTIC_REBUILD$EW(:ID_HOTEL);

    execute procedure SUMMARY_FORECAST$INT(:ID_HOTEL, :system_date);
  end

  /* Delete pseudo-temporal tables */
  delete from RESERV_ERROR;
  /*  */

--  execute procedure CACHES_RESOLVE;

  execute procedure SYSTEM_LOG_ADD('SYSTEM', :id_end_work, 'DAY_EW', f_character(29) || :system_date || f_character(28) || :IN_NEXT_DATE);

  execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'release');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', null);

  execute procedure SYSTEM_CACHE_APPLY('end_work');
end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTS$INT for: GUEST_REROUTE_POSTINGS$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTS$INT(RD_DBKEY CHAR(8))
 AS
 BEGIN EXIT; END
^

/* Alter (GUEST_REROUTE_POSTINGS$INT) */
ALTER PROCEDURE GUEST_REROUTE_POSTINGS$INT(ID_GUEST INTEGER,
ID_BASE_ACCOUNT INTEGER,
ID_EXTRA_ACCOUNT INTEGER)
 AS
declare variable ap_dbkey char(8);
  declare variable is_packet_post integer;
  declare variable packet_option varchar(50);
  declare variable id_target_account integer;
  declare variable id_current_account integer;
begin
  update GUEST G
  set    G.ID_BASE_ACCOUNT = :ID_BASE_ACCOUNT,
         G.ID_ACCOUNT = :ID_EXTRA_ACCOUNT
  where  G.ID_GUEST = :ID_GUEST;

  for
    select AP.RDB$DB_KEY, iif(AP.ID_MASTER_ADDINS_ACC_POST > 0, 1, 0), S.VAUCHER_PACKET,
           ap.ID_ACCOUNT
    from   ACCOUNT_POST AP
           join SERVICES S on S.ID_SERVICE = AP.ID_SERVICE
    where  AP.ID_GUEST = :ID_GUEST
           and AP.AC = '00'
           and AP.ID_BASE_DOC is null
    into   :ap_dbkey, :is_packet_post, :packet_option, :id_current_account
  do begin
    if ((:is_packet_post = 1) and (:packet_option <> 'NONE')) then id_target_account = :id_base_account;
    else id_target_account = :id_extra_account;

    if (:id_current_account <> :id_target_account) then begin
      execute procedure ACCOUNT_POSTING_TRANSFER$INT(:ap_dbkey, :id_target_account, 0);
    end
  end

end
^

/* Alter (OCCUPANCY_SUMMARY_REMAKE$SYS) */
ALTER PROCEDURE OCCUPANCY_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
begin
  if (not exists (select h.ID_HOTEL
                  from   HOTEL H
                  where  h.ID_HOTEL = :ID_HOTEL)) then exception WRONG_VALUE 'Non-existing hotel!';

  select mindate(sd.SYSTEM_DATE - 1, :TO_DATE)
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :TO_DATE;

  if (:FROM_DATE > :TO_DATE) then exit;

  execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:id_hotel, :FROM_DATE, :TO_DATE);

  execute procedure SYSTEM_LOG_ADD ('HOTEL', :id_hotel, 'OCCUPANCY_REGENERATE',
                                    f_character(29) || formatdate(:from_date, 'D;dd/mm/yyyy') || f_character(28) || formatdate(:to_date, 'D;dd/mm/yyyy'));
end
^

/* Alter (PHONECALL_POST$TC) */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Alter (PHONECALLS_POST_TO_ACCOUNT$TC) */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POST_MODIFY$PMS for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: CONTRACT_EXPENSE_POST$INT for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_HOTEL INTEGER,
ID_CONTRACT /* TYPE OF ID */ INTEGER,
SUB_CONTRACT /* TYPE OF TSUB_CONTRACT */ VARCHAR(10),
ID_OWNER /* TYPE OF ID */ INTEGER,
OWNERSHIP_PERCENT /* TYPE OF TPERCENT */ NUMERIC(15,4),
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
POST_DATE /* TYPE OF TDATE */ DATE,
STAY /* TYPE OF TCOUNT */ INTEGER,
MAX_GUEST_CNT /* TYPE OF TCOUNT */ INTEGER,
BED_NIGHT_CNT /* TYPE OF TCOUNT */ INTEGER,
RESERVS /* TYPE OF TCOUNT */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PMS_EXPENSE_POSTS_CREATE$INT for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_EXPENSE_POSTS_CREATE$INT(ID_ROOM /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
POST_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
IS_CLIENT_ACC_POST /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_POST_DATE /* TYPE OF TDATE */ DATE,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IS_POST_PER_POOL /* TYPE OF TLOGICAL */ SMALLINT)
 RETURNS(NEW_ID_ACCOUNT_POST /* ID_REF */ INTEGER,
NEW_ID_ACCOUNT_POST$PMS /* ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PMS_POOL_DISTRIBUTION_SUB for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_POSTING_CREATE$INT) */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_OWNER TYPE OF ID,
POST_DATE TYPE OF TDATE,
CURR_ORIG TYPE OF TCURRENCY,
VALUE_ORIG TYPE OF TPRICE,
POST_ON_PMS_ACCOUNT TYPE OF TLOGICAL,
IS_OWNER_INCOME TYPE OF TLOGICAL,
ID_ROOM TYPE OF ID_REF = null)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  if (:POST_ON_PMS_ACCOUNT = 1) then begin
    execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account, :id_owner,
            :CURR_ORIG, :VALUE_ORIG, :id_service, :is_owner_income, :POST_DATE)
    returning_values  (:new_id_account_post);
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :ID_SERVICE, 1, 0, 1,
            :VALUE_ORIG, :CURR_ORIG, current_date, current_date,
            '', '', :POST_DATE, 'PMS', :ID_ROOM)
    returning_values  :err_code, :err_text, :new_id_account_post;
    if (:err_code <> 0) then exception PMS_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

    insert into PMS_EVENT_POST (ID_PMS_EVENT, ID_ACCOUNT_POST, ID_OWNER, LINE_STATUS)
    values (:ID_PMS_EVENT, :NEW_ID_ACCOUNT_POST, :ID_OWNER, 11);
  end
end
^

/* Alter (POST_SERVICE_FINALIZE$POST) */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
  declare variable id_acc_post integer;
  declare variable id_service integer;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable date_post date;
  declare variable price_post numeric(15,4);
  declare variable qty_post numeric(15,2);
  declare variable post_text varchar(100);
  declare variable curr_post varchar(3);
  declare variable id_phonecall integer;
  declare variable p_dbkey char(8);
begin

  if (:OPERATION = 'clear') then begin
    delete from TMP_SERVICE_POST T
    where  T.ID_SEQUENCE = :ID_SEQUENCE;

  end else if (:OPERATION = 'store') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);

    for
      select TS.RDB$DB_KEY, TS.ID_SERVICE, TS.ID_ACCOUNT, TS.ID_GUEST, TS.DATE_POST,
             TS.PRICE_POST, TS.QTY_POST, TS.CURR_POST, TS.POST_TEXT, TS.ID_PHONECALL
      from   TMP_SERVICE_POST TS
      where  TS.ID_SEQUENCE = :ID_SEQUENCE
      into   :p_dbkey, :id_service, :id_account, :id_guest, :date_post,
             :price_post, :qty_post, :curr_post, :post_text, :id_phonecall
    do begin
      id_acc_post = null;
      if (:id_guest is not null) then begin
        execute procedure POST_SERVICE_ON_GUEST$INT (:id_guest, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :CURR_POST,
                :date_post, :date_post, :post_text, '', :date_post, '', '')
        returning_values  (:err_code, :err_text, :no_use, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end else begin
        execute procedure POST_SERVICE_ON_ACCOUNT$INT (:id_account, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :curr_post, :date_post, :date_post, :post_text,
                '', :date_post, '')
        returning_values  (:err_code, :err_text, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end

      update TMP_SERVICE_POST
      set ID_ACCOUNT_POST = :id_acc_post
      where RDB$DB_KEY = :p_dbkey;

      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :DOC_SELECTED,
             AP.SHORT_CODE = case
                               when :id_phonecall is not null then 'TELECOUNT'
                               else null
                             end
      where  AP.ID_ACCOUNT_POST = :id_acc_post;

      if (:id_phonecall is not null) then begin
        update PHONECALLS P
        set    P.ID_ACCOUNT_POST = :id_acc_post
        where  P.ID_PHONECALL = :id_phonecall;
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_CHANGE$RSV for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTING$INT for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_GUESTCOUNT$RSV for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT$RSV for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_ACCOUNTS$INT) */
ALTER PROCEDURE RES_SAVE_ACCOUNTS$INT(RD_DBKEY CHAR(8))
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_base_account integer;
  declare variable old_id_extra_account integer;
  declare variable new_id_base_account integer;
  declare variable new_id_extra_account integer;
  declare variable acc_routing varchar(30);
  declare variable is_sep_accounts integer;
  declare variable id_base_account_profile integer;
  declare variable id_extra_account_profile integer;
  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable id_agent_account_rule integer;
  declare variable id_acc_template_person integer;
  declare variable id_guest integer;
  declare variable id_hotel integer;
begin

  select RD.ID_RESERV_DETAIL, RD.ID_PERSON_PROFILE, RD.ID_ACC_TEMPLATE_PERSON,
         RD.ACC_ROUTING, RD.ID_BASE_ACCOUNT, RD.ID_EXTRA_ACCOUNT,
         RD.ID_AGENT_PROFILE, RD.ID_AGENT_ACCOUNT_RULE, rd.id_hotel
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :RD_DBKEY
  into   :id_reserv_detail, :id_person_profile, :id_acc_template_person,
         :acc_routing, :old_id_base_account, :old_id_extra_account,
         :id_agent_profile, :id_agent_account_rule, :id_hotel;

  id_agent_account_rule = nullif(:id_agent_account_rule, -1);
  /* --- new */
  execute procedure SETTING_GET_VALUE ('SEPARATE_ACCOUNTS_PER_PAYER', :id_hotel)
  returning_values (:IS_SEP_ACCOUNTS);

  NEW_ID_BASE_ACCOUNT = null; --:old_id_base_account;
  NEW_ID_EXTRA_ACCOUNT = null; --:old_id_extra_account;

  /* identify profiles for base and extra account */
  if (:ACC_ROUTING in ('MIXED')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else if (:ACC_ROUTING in ('AGENT')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
  end else if (:ACC_ROUTING in ('FULL_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = null;
    IS_SEP_ACCOUNTS = 0;  -- never
  end else if (:ACC_ROUTING in ('PART_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else begin -- if (:acc_routing in ('GUEST', 'OWNER'))
    ID_BASE_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_AGENT_ACCOUNT_RULE = null;
  end

  execute procedure RES_ACCOUNTS_RECIEVE$INT (:ID_RESERV_DETAIL, :old_id_base_account, :old_id_extra_account,
          :id_agent_account_rule, :id_base_account_profile, :id_extra_account_profile, :id_person_profile,
          :id_acc_template_person, :is_sep_accounts)
  returning_values (:new_id_base_account, :new_id_extra_account);

--  if (:new_id_base_account is null) then exception WRONG_VALUE 'Invalid base account!';
--  if (:new_id_extra_account is null) then exception WRONG_VALUE 'Invalid extra account!';
  if ((:old_id_base_account is distinct from :new_id_base_account)
       or (:old_id_extra_account is distinct from :new_id_extra_account)) then
  begin
    update RESERV_DETAIL RD
    set    RD.ID_BASE_ACCOUNT = :new_id_base_account,
           RD.ID_EXTRA_ACCOUNT = :new_id_extra_account
    where  RD.RDB$DB_KEY = :RD_DBKEY;
    /* end --- */
    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
             --and G.CHECK_STATUS < 1
      into   :id_guest
    do begin
      execute procedure GUEST_REROUTE_POSTINGS$INT(:id_guest, :new_id_base_account, :new_id_extra_account);
    end

    -- Log account changes
    execute procedure RES_SAVE_ACCOUNTS_FINALIZE$INT(:id_reserv_detail, :old_id_base_account, :old_id_extra_account,
            :new_id_base_account, :new_id_extra_account);
  end

end
^

/* Alter (RES_SAVE_GUESTCOUNT$RSV) */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select rd.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  rd.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SAVE_GUESTCOUNT$INT(:rd_dbkey, :adult_count, :child_count);

  execute procedure RES_SAVE_ACCOUNTS$INT (:rd_dbkey);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 0)
  returning_values  :warn_code;

end
^

/* empty dependent procedure body */
/* Clear: RES_CHECKIN_MULTI$RSV for: RES_SPLIT$RSV */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT_MULTI$RSV for: RES_SPLIT$RSV */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SPLIT$RSV) */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
declare variable rd_dbkey_old char(8);
  declare variable rd_dbkey_new char(8);
  declare variable id_guest integer;
  declare variable warn_code integer;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;

  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable check_status integer;
  declare variable arrival_date date;
  declare variable departure_date date;
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable id_room_type integer;
  declare variable id_room integer;
  declare variable id_board integer;
  declare variable id_tariff integer;
  declare variable custom_price numeric(15,4);
  declare variable custom_currency char(3);
  declare variable voucher_num varchar(30);
  declare variable voucher_date date;
  declare variable voucher_text varchar(30);
  declare variable voucher2_num varchar(30);
  declare variable voucher2_date date;
  declare variable transfer_in_time time;
  declare variable transfer_in_note varchar(255);
  declare variable transfer_out_time time;
  declare variable transfer_out_note varchar(255);
  declare variable comming_kind integer;
  declare variable is_late_departure integer;
  declare variable is_vip integer;
  declare variable country_code varchar(20);
  declare variable code_first_food tfood_code;
  declare variable i_special_treatment varchar(255);
  declare variable id_nom_market_segment integer;
  declare variable id_nom_source_code integer;
  declare variable id_nom_channel_code integer;
  declare variable id_nom_hear_reason integer;
  declare variable id_nom_come_reason integer;
  declare variable id_agent_account integer;
  declare variable acc_routing varchar(50);
  declare variable id_person_payment integer;
  declare variable id_agent_payment integer;
  declare variable room_features blob sub_type 1 segment size 80;
  declare variable id_hk_plan integer;
  declare variable id_group integer;
  declare variable id_hotel integer;
  declare variable note varchar(2000);
  declare variable note_reminders varchar(50);
  declare variable guarantee_deposit numeric(15,4);
  declare variable guarantee_currency char(3);
  declare variable id_titular integer;
  declare variable id_profile_data integer;
  declare variable id_acc_template_person integer;
  declare variable number_1 varchar(20);
  declare variable number_2 varchar(20);
  declare variable new_res_number varchar(62);
  declare variable g_dbkey char(8);
  declare variable is_child integer;
  declare variable id_guarantee_policy integer;
  declare variable block_cc varchar(255);
  declare variable virtual_room varchar(10);
  declare variable err_text varchar(255);
  declare variable is_posting_stopped integer;
  declare variable id_eating_object integer;
begin
  select RD.RDB$DB_KEY, RD.ID_AGENT_PROFILE, RD.CHECK_STATUS, RD.FROM_DATE, RD.TO_DATE,
         RD.ADULT_COUNT, RD.CHILD_COUNT, RD.ID_ROOM_TYPE, RD.ID_ROOM, RD.ID_BOARD, RD.ID_RATE,
         RD.CUSTOM_PRICE, RD.CUSTOM_CURRENCY, RD.VAUCHER_NUM, RD.VAUCHER_DATE, RD.VAUCHER_TEXT, RD.VAUCHER_NUM2,
         RD.VAUCHER_DATE2, RD.TRANSFER_IN_TIME, RD.TRANSFER_IN_NOTE, RD.TRANSFER_OUT_TIME, RD.TRANSFER_OUT_NOTE,
         RD.COMMING_KIND, RD.LEAVING_KIND - 1, RD.IS_VIP, RD.COUNTRY, RD.CODE_FIRST_FOOD, RD.I_SPECIAL_TREATMENT,
         RD.ID_NOM_MARKET_SEGMENT, RD.ID_NOM_SOURCE_CODE, RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_HEAR_REASON,
         RD.ID_NOM_COME_REASON, RD.ID_AGENT_ACCOUNT_RULE, RD.ACC_ROUTING, RD.ID_PERSON_PAYMENT, RD.ID_AGENT_PAYMENT,
         RD.ROOM_FEATURES, RD.ID_HK_PLAN, RD.ID_GROUP, RD.ID_HOTEL, RD.NOTE, RD.NOTE_REMINDERS,
         RD.GUARANTEE_DEPOSIT, RD.GUARANTEE_CURRENCY, RD.ID_ACC_TEMPLATE_PERSON,
         RD.NUMBER_1, rd.NUMBER_2, rd.ID_GUARANTEE_POLICY, rd.BLOCK_CC, rd.IS_POSTING_STOPPED, rd.ID_EATING_OBJECT
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail_source
  into   :rd_dbkey_old, :id_agent_profile, :check_status, :arrival_date, :departure_date,
         :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff,
         :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
         :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
         :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
         :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
         :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
         :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
         :guarantee_deposit, :guarantee_currency, :id_acc_template_person,
         :number_1, :number_2,:id_guarantee_policy, :block_cc, :is_posting_stopped, :id_eating_object;

  select first 1 sp.ITEM
  from   SYSTEM_STRING_PARSER(:guest_ids, ',') sp
  into   :id_titular;

  select min(g.FROM_DATE), max(g.TO_DATE)
  from   GUEST G
  where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL_SOURCE
         and ','||:GUEST_IDS||',' containing ','||g.ID_GUEST||','
  into   :arrival_date, :departure_date;

  if (exists (select *
              from   RESERV_DETAIL RD
              where  RD.ID_TITULAR = :id_titular
                     and RD.ID_RESERV_DETAIL = :id_reserv_detail_source))
  then exception BOOKING_EXCEPTION 'Titular can not be splited in new reservation';

  execute procedure RES_GET_PERSON_PROFILE$INT(:id_titular)
  returning_values  :id_person_profile, :id_profile_data;

  new_res_number = iif(coalesce(:number_1,'')='','.',:number_1||'.')
                   || coalesce(:number_2, '')
                   || '.0';  -- fictive suffix, needed for unique constraint limitation, that will be replaced with real one


  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, :check_status, :arrival_date, :departure_date,
                    0, 0, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
                    :guarantee_deposit, :guarantee_currency, 0, null, :new_res_number, :id_acc_template_person,
                    :id_guarantee_policy, :block_cc, :id_eating_object)
  returning_values  :rd_dbkey_new, :new_id_reserv_detail, :warn_code;

  execute procedure RES_NUMBER_SUFFIX_GEN (:NEW_ID_RESERV_DETAIL)
  returning_values  (:new_res_number);  -- add suffix to new (splited) booking number (empty on create)

  update RESERV_DETAIL NR
  set    nr.IS_POSTING_STOPPED = :is_posting_stopped
  where  nr.RDB$DB_KEY = :rd_dbkey_new;

  -- there is no need guests deleting, because new splited reservation is created with 0 guests
  adult_count = 0; child_count = 0;
  for
    select G.ID_GUEST, G.RDB$DB_KEY, G.IS_CHILD
    from   SYSTEM_STRING_PARSER(:guest_ids, ',') SP
           join GUEST G on G.ID_GUEST = SP.ITEM
    into   :id_guest, :g_dbkey, :is_child
  do begin
    execute procedure GUEST_SET_EDIT_STATUS$INT (:g_dbkey, 'REBUILD', 'add');

    update GUEST G
    set    G.ID_RESERV_DETAIL = :new_id_reserv_detail
    where  G.ID_GUEST = :id_guest;

    adult_count = :adult_count + (1-:is_child);
    child_count = :child_count + :is_child;

    if (:id_guest = :id_titular) then begin
      update RESERV_DETAIL RD
      set    RD.ID_TITULAR = :id_titular
      where  RD.RDB$DB_KEY = :rd_dbkey_new;

      update GUEST_DATA GD
      set    GD.ID_PERSON_DATA = :id_profile_data
      where  GD.ID_GUEST = :id_titular;
    end
  end

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL_SOURCE, 'RES_SPLIT',
          f_character(29) || :new_res_number || f_character(28) || :adult_count || ' + ' || :child_count);

  -- calling RES_SAVE_PROFILING$INT is unnecessary, it is called into RES_CREATE_SET$INT with same params
  -- here is needed to set reserv accounts per splited guests and reroute posting only (accomplished in next procedure)
  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey_new);

  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_old);
  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_new);

  update RESERV_DETAIL ORD
  set    ord.ROOM_PRICE = null
  where  ord.RDB$DB_KEY = :rd_dbkey_old;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_old, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_new, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  if (:id_room < 0) then begin
    virtual_room = gen_id(GEN_VIRTUAL_ROOM, 1);
    update RESERV_DETAIL RD
    set    rd.VIRTUAL_ROOM = '<'||:virtual_room||'>'
    where  rd.ID_ROOM = :id_room;
  end
end
^

/* Alter (RES_SPLIT_MULTI$RSV) */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
begin
  for
    select RD.ID_RESERV_DETAIL, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :id_reserv_detail, :id_titular
  do begin
    for
      select G.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.ID_GUEST <> :id_titular
      into   :id_guest
    do begin
      execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
      returning_values  :id_splited_reservation;

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_RECALC$INT for: RES_TAR_CALC_FINALIZE$INT */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_TAR_CALC_FINALIZE$INT) */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(ID_TAR_CALC INTEGER,
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
  declare variable reserv_posting_disabled smallint;
  declare variable postings_disabled smallint;
  declare variable warn_code integer;
begin
  --  Razpiswa cenata na staia, kakto i price_detailite.

  execute procedure TAR_CALC_EVAL_ALL$INT(:ID_TAR_CALC)
  returning_values  :ERR_CODE, :ERR_TEXT;

  if (:ERR_CODE = 0) then execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

  select iif(si.INFO_VALUE = '1', 1, null)
  from   SYSTEM_INFO_GET('RESERV_POSTINGS_DISABLED') si
  into   :postings_disabled;

  for
    select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, coalesce(:postings_disabled, rd.IS_POSTING_STOPPED),
           coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
           coalesce(max((select first 1 AP.IS_BASE
                         from   GUEST G
                                join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                         where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (it`s possible)
    from   TAR_CALC_INPUT$TMP TI
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
           join TARIFA t on t.ID_TARIFA = rd.ID_RATE
    where  ti.ID_TAR_CALC = :ID_TAR_CALC
    group by 1, 2, 3, 4, 5, 6
    into   :id_reserv_detail, :check_status, :is_posting_stopped,
           :room_currency, :id_hotel, :is_anul, :has_postings
  do begin
    reserv_posting_disabled = iif(:is_posting_stopped = 1 and :has_postings = 0, 1, 0);

    if (:ERR_CODE <> 0) then begin
      -- price calculation error handling  !!!!!
      if (:reserv_posting_disabled = 1) then begin
        -- set price to null, posting is disabled
        update RESERV_DETAIL RD
        set    RD.ROOM_PRICE = null,
               RD.ROOM_CURRENCY = null,
               RD.ROOM_PRICE_DETAILS = null,
               RD.LAST_ID_TAR_CALC = null
        where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
      end else begin
        -- exit on error in price calculation - cannot make valid posts
        EXIT;
      end
    end else begin
      room_price = 0;
      room_price_details = '';
    
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);
  
      if (:reserv_posting_disabled = 0 and ((coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1))) then begin
        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);
      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;
  
        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end
  
      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end

  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;

  if (:ERR_CODE <> 0) then begin
    execute procedure SYSTEM_WARNING_ADD(:ERR_CODE, :ERR_TEXT)
    returning_values :warn_code;
    ERR_CODE = 0;
    ERR_TEXT='';
  end
end
^

/* empty dependent procedure body */
/* Clear: SAFE_CHECK_OUT for: SAFE_OCCUPANCY_MODIFY */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE /* TYPE OF ID */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER,
WARN_CODE /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SAFE_OCCUPANCY_MODIFY) */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE TYPE OF ID,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable old_booking_number tres_number;
  declare variable id_resource_reservation id_ref;
  declare variable from_datetime tdatetime;
  declare variable action_text tdescription_long;
  declare variable old_occupant varchar(100);
  declare variable old_to_dt timestamp;
  declare variable id_reserv_detail integer;
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation;

  select rr.BOOKING_NUMBER, od.FROM_DATETIME,
         RR.OCCUPANT_NAME, od.TO_DATETIME, rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESERV_DETAIL rd on rd.NUMBER = rr.BOOKING_NUMBER and rd.IS_ANUL = 0
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :old_booking_number, :from_datetime,
         :old_occupant, :old_to_dt, :id_reserv_detail, :id_agent_profile;

  --if (:old_booking_number <> :BOOKING_NUMBER) then exception ASSERT 'Can not change booking number!';
  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  update SAFE_RESOURCE_RESERV rr
  set    rr.PRICE_DESCRIPTION = :price_description,
         rr.ID_RATE_PRICE_PROFILE = :id_agent_profile,
         rr.RATING_UNITS = :rating_units,
         rr.RATE_PRICE = :price,
         rr.RATE_CURR = :currency
  where  rr.ID_RESOURCE_RESERV = :id_resource_reservation;

  execute procedure RESOURCE_RESERVATION_MODIFY (:id_resource_reservation, :ID_SAFE, :from_datetime,
          :TO_DATETIME, :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :old_booking_number, 'mod')
  returning_values :id_resource_reservation, :no_use;

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail)
  returning_values (:DOC_SELECTED);

  /* Log changes */
  if ((:old_occupant <> :OCCUPANT_NAME) or (:old_to_dt <> :TO_DATETIME)) then begin
    action_text = f_character(29) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                  || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                  || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');
  
    execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_CHANGED', :action_text);
  end
end
^

/* Alter (SAFE_OCCUPANCY_NEW) */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE TYPE OF ID,
FROM_DATETIME TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME,
BOOKING_NUMBER TYPE OF TRES_NUMBER,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
ID_RESOURCE_RESERVATION TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable action_text tdescription_long;
  declare variable id_reserv_detail integer;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, s.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  if (:id_resource_reservation is not null) then exception ASSERT '-1064'|| f_character(31) || f_character(29) || :safe_name;

  select rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESERV_DETAIL rd
  where  rd.NUMBER = :BOOKING_NUMBER
         and rd.IS_ANUL = 0
  into   :id_reserv_detail, :id_agent_profile;

  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  execute procedure  RESOURCE_RESERVATION_MODIFY (null, :ID_SAFE, :FROM_DATETIME, :TO_DATETIME,
          :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :BOOKING_NUMBER, 'add')
  returning_values (:id_resource_reservation, :no_use) ;

  insert into SAFE_RESOURCE_RESERV (ID_RESOURCE_RESERV, PRICE_DESCRIPTION, ID_RATE_PRICE_PROFILE,
         RATING_UNITS, RATE_PRICE, RATE_CURR)
  values (:id_resource_reservation, :price_description, :id_agent_profile,
         :rating_units, :price, :currency);

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail, :ID_EXTERNAL_CLIENT_ACCCOUNT)
  returning_values (:DOC_SELECTED);

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = 'CHECKED_IN'
  where  RR.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = :id_resource_reservation
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                || f_character(28) || coalesce(:BOOKING_NUMBER, '')
                || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUPIED', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: SPR_OCC_KONT_YES for: SPR_OCC_KONT_AGENT */
ALTER PROCEDURE SPR_OCC_KONT_YES(FROM_DATE DATE,
TO_DATE DATE,
IDS_AGENTS VARCHAR(5000),
KIND SMALLINT,
AGE_KIND SMALLINT,
ALL_KINDS SMALLINT,
ID_HOTEL INTEGER)
 RETURNS(AGENT_NAME VARCHAR(100),
TYPE_ROOM VARCHAR(20),
FOR_DATE DATE,
KONTINGENT INTEGER,
DATA INTEGER,
OUT_KIND VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* Alter (SPR_OCC_KONT_AGENT) */
ALTER PROCEDURE SPR_OCC_KONT_AGENT(FROM_DATE DATE,
TO_DATE DATE,
ID_AGENT INTEGER,
KIND SMALLINT,
AGE_KIND SMALLINT,
ALL_KINDS SMALLINT,
ID_HOTEL INTEGER)
 RETURNS(TYPE_ROOM VARCHAR(20),
TYPE_ROOM2 VARCHAR(20),
FOR_DATE DATE,
KONTINGENT INTEGER,
DATA INTEGER,
OUT_KIND VARCHAR(20))
 AS
declare variable id_room_type integer;
begin
  /* KIND:  1 - ROOMS
            2 - BEDS
            3 - ADD BEDS
            else - BEDS + ADD BEDS
     AGE_KIND:  1 - ADULTS
                2 - CHILDREN
                else - ALL*/
  kontingent = 0;
  data = 0;
  for
    select distinct AD.ID_ROOM_TYPE
    from   PROFILE_AGENT PA
           join ALLOTMENT_DETAIL AD on AD.ID_ALLOTMENT = PA.ID_CONTINGENT
    where  PA.ID_AGENT = :id_agent
           and AD.FROM_DATE <= :to_date
           and AD.TO_DATE >= :from_date
    into   :id_room_type
  do begin
    select RT.TYPE_ROOM, RT.TYPE_ROOM
    from   ROOM_TYPES RT
    where  RT.ID_ROOM_TYPE = :id_room_type
           and RT.ID_HOTEL = :id_hotel
    into   :type_room, :type_room2;

    for
      select SLP.OUT_DATE
      from   SYSTEM_LOOP_PERIOD(:from_date, :to_date) SLP
      into   :for_date
    do begin
      for
        select KONTINGENT, DATA, OUT_KIND
        from   SPR_OCC_KONT_AGENT_ROOMTYPE_DAY(:for_date,:id_agent,:id_room_type,:kind,:age_kind, :all_kinds)
        into   :kontingent, :data, :out_kind
      do suspend;
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: SPR_OCC_KONT for: SPR_OCC_KONT_YES */
ALTER PROCEDURE SPR_OCC_KONT(FROM_DATE DATE,
TO_DATE DATE,
IDS_AGENTS VARCHAR(5000),
KIND SMALLINT,
AGE_KIND SMALLINT,
ALL_KINDS SMALLINT,
ID_HOTEL INTEGER)
 RETURNS(AGENT_NAME VARCHAR(50),
TYPE_ROOM VARCHAR(20),
FOR_DATE DATE,
KONTINGENT INTEGER,
DATA INTEGER,
OUT_KIND VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* Alter (SPR_OCC_KONT_YES) */
ALTER PROCEDURE SPR_OCC_KONT_YES(FROM_DATE DATE,
TO_DATE DATE,
IDS_AGENTS VARCHAR(5000),
KIND SMALLINT,
AGE_KIND SMALLINT,
ALL_KINDS SMALLINT,
ID_HOTEL INTEGER)
 RETURNS(AGENT_NAME VARCHAR(100),
TYPE_ROOM VARCHAR(20),
FOR_DATE DATE,
KONTINGENT INTEGER,
DATA INTEGER,
OUT_KIND VARCHAR(20))
 AS
declare variable id_agent integer;
begin
  /* KIND:  1 - ROOMS
            2 - BEDS
            3 - ADD BEDS
            else - BEDS + ADD BEDS
     AGE_KIND:  1 - ADULTS
                2 - CHILDREN
                else - ALL*/
  if (coalesce(:ids_agents, '') = '') then begin
    for
      select distinct PA.ID_AGENT, cast(PA.ID_AGENT as varchar(10)) || '=' || P.PROFILE_NAME
      from   PROFILE_AGENT PA
             join PROFILE P on P.ID_PROFILE = PA.ID_PROFILE
      where  P.IS_ARCHIVE = 0
      into   :id_agent, :agent_name
    do begin
      for
        select TYPE_ROOM, FOR_DATE, KONTINGENT, DATA, OUT_KIND
        from   SPR_OCC_KONT_AGENT(:from_date, :to_date, :id_agent, :kind ,:age_kind, :all_kinds, :id_hotel)
        into   :type_room, :for_date, :kontingent, :data, :out_kind
      do suspend;
    end
  end else begin
    if (:ids_agents containing 'GROUP-') then begin
      ids_agents = substring(:IDS_AGENTS from char_length('GROUP-')+1 for char_length(:ids_agents) - char_length('GROUP-'));
      for 
        select distinct PA.ID_AGENT, cast(PA.ID_AGENT as varchar(10)) || '=' || P.PROFILE_NAME
        from   PROFILE_AGENT PA
               join PROFILE P on P.ID_PROFILE = PA.ID_PROFILE
        where  P.IS_ARCHIVE = 0
               and PA.AGENT_GROUP = :ids_agents
        into   :id_agent, :agent_name
      do begin
        for
          select TYPE_ROOM, FOR_DATE, KONTINGENT, DATA, OUT_KIND
          from   SPR_OCC_KONT_AGENT(:from_date, :to_date, :id_agent, :kind ,:age_kind,:all_kinds, :id_hotel)
          into   :type_room, :for_date, :kontingent, :data, :out_kind
        do suspend;
      end
    end else begin
      for
        select ITEM
        from   SYSTEM_STRING_PARSER(:ids_agents, 'x')
        into   :id_agent
      do begin
        for
          select cast(PA.ID_AGENT as varchar(10)) || '=' || P.PROFILE_NAME
          from   PROFILE_AGENT PA
                 join PROFILE P on P.ID_PROFILE = PA.ID_PROFILE
          where  PA.ID_AGENT = :id_agent
           into :agent_name
        do begin
          for
            select TYPE_ROOM, FOR_DATE, KONTINGENT, DATA, OUT_KIND
            from   SPR_OCC_KONT_AGENT(:from_date, :to_date, :id_agent, :kind ,:age_kind, :all_kinds, :id_hotel)
            into   :type_room, :for_date, :kontingent, :data, :out_kind
          do suspend;
        end
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_INPUT_PARAMS$INT for: TAR_CALC_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_PARAMS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_PARAMS$INT) */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
declare variable param_code varchar(40);
  declare variable id_param integer;
  declare variable param_value varchar(255);
  declare variable data_type  varchar(30);
  declare variable rate_list varchar(2000);
begin
  err_code = 0;
  param_values = '';

  if (coalesce(:rate_list_replace, '') = '') then rate_list = ',' || :id_rate || ',';
  else rate_list = :rate_list_replace;

  for
    select distinct TBP.PARAM_NAME
    from   SYSTEM_STRING_PARSER (:rate_list, ',') sp
           left join TAR_BO_PARAMS TBP on TBP.ID_TAR_HEAD = sp.ITEM
    where  (TBP.PARAM_TYPE <> 'DATE_DEPENDANT' and :for_date is null)
           or (TBP.PARAM_TYPE = 'DATE_DEPENDANT' and :for_date is not null)
    into   :param_code
  do begin
    if (:param_code is not null) then begin
      id_param = null;
      select TP.ID_TARIFA_PARAM, TP.DATA_TYPE
      from   TARIFA_PARAMS TP
      where  TP.PARAM_CODE = :param_code
             and tp.IS_USE = 1
      into   :id_param, :data_type;
  
      if (:id_param is null) then begin
        err_code = -202;
        execute procedure sys_dbg ('tar calc params err_code: ' || :err_code || F_CRLF() || 'PARAM_CODE = ' || :param_code);
        exit;
      end
  
      execute procedure TARIFA_GET_PARAM (:id_param, :for_date, :id_tar_input, :id_tar_calc)
      returning_values (:param_value);
  
      param_code = ':'||param_code;
  
      if ((:param_code is not null) and (:param_code is not null) and (:data_type is not null)) then
         param_values = :param_values||';'||:param_code||','||:data_type||','||:param_value;
    end
  end
end
^

/* Restore proc. body: ACCOUNT_POST_MODIFY$PMS */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
declare variable id_account integer;
  declare variable id_service integer;
  declare variable date_post date;
  declare variable is_owner_income smallint;
  declare variable is_account_post_item smallint;
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable no_use_id_acc_post integer;
  declare variable ap_dbkey char(8);
begin
  -- da se wika samo ot GUI
  if ( (:ID_ACCOUNT_POST is null) and (:ID_ACCOUNT_POST_PMS is null) ) then begin
    exception WRONG_PARAM_VALUE;
    exit;
  end

  is_account_post_item = iif(:id_account_post is not null, 1, 0);

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'mod, anul');

  if (:operation in ('mod', 'anul')) then begin
    -- prowerka: ot GUI-to mogat da se anulirat samo nedokumentirani i neanulirani nachisleniq
    if (:is_account_post_item = 1) then begin
      if ( (:ID_PMS_EVENT > 0) and
           not exists ( select *
                        from   PMS_EVENT_POST PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      select ap.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  ap.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
      into   :ap_dbkey;

      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_dbkey, 'PMS GUI VOID');

      update PMS_EVENT_POST PP
      set    PP.LINE_STATUS = 22
      where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST;

    end else if (:ID_ACCOUNT_POST_PMS is not null) then begin
      if ( not exists ( select *
                        from   ACCOUNT_POST$PMS PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      execute procedure ACCOUNT_POST_PMS_ANUL$INT(:ID_PMS_EVENT, :ID_ACCOUNT_POST_PMS);
    end

    if (:operation = 'mod') then begin
      id_account = null;
      if (:is_account_post_item = 1) then begin
        select AP.ID_ACCOUNT, AP.ID_SERVICE, AP.DATE_POST, PP.ID_OWNER, 0, ap.id_room
        from   ACCOUNT_POST AP
               join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and PP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :id_owner, :is_owner_income, :id_room;
      end else begin
        select AP.ID_ACCOUNT_PMS, AP.ID_SERVICE, AP.DATE_POST, AP.IS_OWNER_INCOME, AP.ID_OWNER
        from   ACCOUNT_POST$PMS AP
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
               and AP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :is_owner_income, :id_owner;
      end
      if (:id_account is null) then exit;

      execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_account, :id_service, :id_owner, :date_post,
              :in_curr_orig, :in_value_orig, 1 - :is_account_post_item, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* Restore proc. body: ACCOUNT_POSTING_TRANSFER$ACC */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
declare variable ap_dbkey char(8);
  declare variable transfer_value double precision;
  declare variable post_value double precision;
  declare variable id_account integer;
  declare variable tmp_id_account integer;
  declare variable curr_post varchar(3);
  declare variable acc_name varchar(50);
  declare variable action_text varchar(255);
  declare variable is_pms_account integer;
  declare variable dest_acc_name varchar(50);
begin

  id_account = null;
  transfer_value = 0;

  select ACC.ACCOUNT_NAME, acc.IS_PMS_ACCOUNT
  from   ACCOUNT ACC
  where  ACC.ID_ACCOUNT = :ID_DEST_ACCOUNT
  into   :dest_acc_name, is_pms_account;

  if (:is_pms_account = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('PMS_TRANSFER_POSTINGS');
  end

  for
    select AP.RDB$DB_KEY, AP.ID_ACCOUNT, ap.PRICE_POST * ap.QTY_POST
    from   ACCOUNT_POST AP
    where  AP.DOC_SELECTED = :DOC_SELECTED
           and AP.ID_ACCOUNT = coalesce(:ID_SRC_ACCOUNT, AP.ID_ACCOUNT)
           and AP.ID_ACCOUNT is distinct from :ID_DEST_ACCOUNT
    order by AP.ID_ACCOUNT asc
    into   :ap_dbkey, :tmp_id_account, :post_value
  do begin
    execute procedure ACCOUNT_POSTING_TRANSFER$INT (:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:id_account is null) then id_account = :tmp_id_account;

    /* update from/to pms account */
    execute procedure ACCOUNT_POST_EVENT_REROUTE$INT(:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:tmp_id_account is distinct from :id_account) then begin
      select A.ACCOUNT_NAME, A.ACCOUNT_CURR
      from   ACCOUNT A
      where  A.ID_ACCOUNT = :id_account
      into   :acc_name, :curr_post;

      action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                    f_character(28) || :id_account || '/' || :acc_name ||
                    f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
      execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
      id_account = :tmp_id_account;
      transfer_value = 0;
    end
    transfer_value = :transfer_value + :post_value;
  end

  if (:id_account is not null) then begin
    select A.ACCOUNT_NAME, A.ACCOUNT_CURR
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :acc_name, :curr_post;
  
    action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                  f_character(28) || :id_account || '/' || :acc_name ||
                  f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
  end
end
^

/* Restore proc. body: CONTRACT_EXPENSE_POST$INT */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT TYPE OF ID,
ID_HOTEL INTEGER,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
ID_OWNER TYPE OF ID,
OWNERSHIP_PERCENT TYPE OF TPERCENT,
ID_RENTAL_POOL TYPE OF ID_REF,
VALUE_ORIG TYPE OF TPRICE,
CURR_ORIG TYPE OF TCURRENCY,
POST_DATE TYPE OF TDATE,
STAY TYPE OF TCOUNT,
MAX_GUEST_CNT TYPE OF TCOUNT,
BED_NIGHT_CNT TYPE OF TCOUNT,
RESERVS TYPE OF TCOUNT)
 AS
declare variable service_price numeric(15,4);
  declare variable id_currency varchar(3);
  declare variable contract_expense_type varchar(50);
  declare variable id_account integer;
  declare variable post_value numeric(15,4);
  declare variable post_currency varchar(3);
  declare variable id_service integer;
  declare variable is_owner_income smallint;
  declare variable is_client_acc_post smallint;
  declare variable multiplier_type varchar(50);
  declare variable multiplier integer;
  declare variable id_room integer;
  declare variable use_shadow_account integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
begin
  is_owner_income = 0;
  use_shadow_account = iif(:SUB_CONTRACT = 'SHADOW_ACC', 1, 0);

  select r.ID_HOTEL
  from   PMS_EVENT$PMS p
         join ROOMS R on r.ID_ROOM = p.ID_ROOM
  where  p.ID_PMS_EVENT = :ID_PMS_EVENT
  into   :id_hotel;
-- CONTRACT_EXPENSE_TYPE in ( 'PERCENT', 'RUNNING_TOTAL_PERCENT', 'CURR_VALUE' )
-- MULTIPLIER_TYPE in ('RESERVATION', 'STAY', 'GUESTS', 'BED_NIGHTS')
  for
    select C.SERVICE_PRICE, C.ID_CURRENCY, C.CONTRACT_EXPENSE_TYPE, C.IS_ACC_POST_ITEM,
           C.ID_SERVICE, C.MULTIPLIER_TYPE
    from   CONTRACT_EXPENSE$PMS C
    where  C.ID_CONTRACT = :id_contract
           and c.SUB_CONTRACT = :SUB_CONTRACT
    order by C.ORDER_TAG asc
    into   :service_price, :id_currency, :contract_expense_type, :is_client_acc_post,
           :ID_SERVICE, :multiplier_type
  do begin

    execute procedure OWNER_ACCOUNT_GET$INT (coalesce(:ID_RENTAL_POOL,:ID_OWNER),
            :id_hotel, :use_shadow_account, :is_client_acc_post)
    returning_values (:id_account, :is_account$pms);

    multiplier = case
                   when :multiplier_type = 'RESERVATION' then iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'STAY' then :STAY
                   when :multiplier_type = 'GUESTS' then :MAX_GUEST_CNT * iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'BED_NIGHTS' then :BED_NIGHT_CNT
                   else null
                 end;

    if (:multiplier is not null) then begin
      if (:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE') then begin
        post_value = cast(:service_price as double precision) * :ownership_percent / 100 * :multiplier;
        post_currency = :id_currency;
      end else if (:CONTRACT_EXPENSE_TYPE = 'PERCENT') then begin
        post_value = :VALUE_ORIG * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end else if (:CONTRACT_EXPENSE_TYPE = 'RUNNING_TOTAL_PERCENT') then begin
        execute procedure PMS_RUNNING_TOTAL_GET(:ID_PMS_EVENT, coalesce(:ID_RENTAL_POOL,:ID_OWNER), :ID_HOTEL, :POST_DATE, :CURR_ORIG)
        returning_values :post_value;
        if (:post_value < 0) then post_value = 0;
    
        post_value = :post_value * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end

      select pe.ID_ROOM
      from   PMS_EVENT$PMS PE
      where  pe.ID_PMS_EVENT = :ID_PMS_EVENT
      into   :id_room;

      select c.ROUND_TO
      from   CURRS C
      where  c.CURR = :post_currency
      into   :round_to;

      execute procedure PMS_POSTING_CREATE$INT(:ID_PMS_EVENT, :id_account, :id_service, :ID_OWNER,
              :POST_DATE, :post_currency, round_f(:post_value, :round_to), :is_account$pms, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* Restore proc. body: EAI_EXT_POST_TO_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable ID_HOTEL integer;
begin
  if (singular(select HS.ID_HOTEL
               from HOTEL_S HS
               where HS.IS_USE = 1)) then
    select H.ID_HOTEL
    from   HOTEL_S H
    where H.IS_USE = 1
    into   :id_hotel;
  else begin
    err_code = -1044;
    exit;
  end

  execute procedure EAI_EXT_POST_TO_MH_FRONT_ONLINE(:ID_HOTEL, :ROOM_NAME,
    :SERVICE_CODE, :CODE_TYPE, :QTY_POST, :PRICE_POST, :CURR_POST, :POST_TEXT)
  returning_values (:ERR_CODE, :ERR_TEXT, :ID_ROOM, :ID_GUEST, :GUEST_NAME1,
    :ID_ACCOUNT, :ID_ACCOUNT_POST, :ID_SERVICE);

end
^

/* Restore proc. body: EAI_POS_POSTING_ADD */
ALTER PROCEDURE EAI_POS_POSTING_ADD(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
begin
  -- used external inteface - for compatability with Front 2008
  execute procedure EAI_POS_POSTING_ADD$P2E (:IN_ON_GUEST, :IN_ID_ACCOUNT, :IN_ID_GUEST, :IN_DATE_SMETKA,
          :IN_PRICE, :IN_DATETIME, :IN_OBJ_NAME, :IN_TABLE, :IN_SITE, :IN_SMETKA_NUM, :IN_POS_USER,
          :IN_ID_SMETKA, :IN_SERVICE_TAG, :IN_SERVICE_NAME)
  returning_values (:ERR_CODE, :ERR_TEXT, :OUT_ID_ACCOUNT);

end
^

/* Restore proc. body: PMS_EXPENSE_POSTS_CREATE$INT */
ALTER PROCEDURE PMS_EXPENSE_POSTS_CREATE$INT(ID_ROOM TYPE OF ID,
ID_OWNER TYPE OF ID,
ID_RENTAL_POOL TYPE OF ID_REF,
ID_SERVICE TYPE OF ID,
ID_CURRENCY TYPE OF TCURRENCY,
POST_VALUE TYPE OF TPRICE,
IS_CLIENT_ACC_POST TYPE OF TLOGICAL,
MANUAL_POST_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
IS_POST_PER_POOL TYPE OF TLOGICAL)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF,
NEW_ID_ACCOUNT_POST$PMS ID_REF)
 AS
declare variable event_type varchar(30);
  declare variable id_room_contract integer;
  declare variable new_id_pms_event integer;
  declare variable round_to_orig numeric(15,6);
  declare variable ownership_percent numeric(15,4);
  declare variable curr_contract_owner integer;
  declare variable curr_total_ownership numeric(15,4);
  declare variable curr_total_value numeric(15,4);
  declare variable percent_value numeric(15,4);
  declare variable id_account integer;
  declare variable id_hotel integer;
  declare variable is_account$pms integer;
  declare variable id_acc_post integer;
BEGIN
  event_type = 'MANUAL_EXPENSE';
  curr_total_value = 0;
  curr_total_ownership = 0;

  select RC.ID_ROOM_CONTRACT, r.ID_HOTEL
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS P on RC.ID_ROOM_PERIOD = P.ID_ROOM_PERIOD
         join ROOMS R on R.ID_ROOM = p.ID_ROOM
  where  :MANUAL_POST_DATE between P.FROM_DATE and P.TO_DATE
         and P.ID_ROOM = :ID_ROOM
         and P.STATUS in ('PRIVATE','CONTRACT')
  into   :id_room_contract, :id_hotel;

  if (:ID_ROOM_CONTRACT is null) then exception PMS_EXCEPTION '-615';

  execute procedure PMS_EVENT_CREATE$INT(:EVENT_TYPE, :ID_ROOM, :ID_OWNER, :DESCRIPTION,
          :MANUAL_POST_DATE, null, null, null, null, :POST_VALUE, :POST_VALUE, :ID_CURRENCY, null, :id_room_contract)
  returning_values :new_id_pms_event;

  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :ID_CURRENCY
  into   :round_to_orig;

  for
    select iif(:ID_OWNER is null, O.OWNERSHIP_PERCENT, 100), O.ID_OWNER
    from   ROOM_CONTRACT$PMS RC
           join ROOM_OWNER$PMS O on O.ID_ROOM_CONTRACT = RC.ID_ROOM_CONTRACT
    where  RC.ID_ROOM_CONTRACT = :id_room_contract
           and ((:ID_OWNER is null) or (O.ID_OWNER = :ID_OWNER))
    into   :ownership_percent, :curr_contract_owner
  do begin
    curr_total_ownership = :curr_total_ownership + :ownership_percent;
    if (:curr_total_ownership = 100) then begin
      percent_value = :post_value - :curr_total_value;
    end else
      percent_value = round_f(:post_value * :ownership_percent / 100, :round_to_orig);

    curr_total_value = :curr_total_value + :percent_value;

    execute procedure OWNER_ACCOUNT_GET$INT (iif(:is_post_per_pool = 1, :id_rental_pool, :curr_contract_owner),
            :id_hotel, 0, :IS_CLIENT_ACC_POST)
    returning_values (:id_account, :is_account$pms);

    execute procedure PMS_POSTING_CREATE$INT(:new_id_pms_event, :ID_ACCOUNT, :ID_SERVICE,
            :curr_contract_owner, :MANUAL_POST_DATE, :ID_CURRENCY, :PERCENT_VALUE, :is_account$pms, 0, :ID_ROOM)
    returning_values :id_acc_post;

    new_id_account_post = null;
    new_id_account_post$pms = null;

    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 1)) then new_id_account_post$pms = :id_acc_post;
    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 0)) then new_id_account_post = :id_acc_post;
    suspend;
  end

  execute procedure PMS_EVENT_SET_ACTIVE$INT(:new_id_pms_event);
END
^

/* Restore proc. body: PMS_POOL_DISTRIBUTION_SUB */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
declare variable cnt_room smallint;
  declare variable curr_total_posted numeric(15,4);
  declare variable cnt integer;
  declare variable value_to_post numeric(15,4);
  declare variable value_to_post_per_owner numeric(15,4);
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable id_room_contract integer;
  declare variable id_owner_account integer;
  declare variable id_pms_event integer;
  declare variable id_hotel integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
begin
  select c.ROUND_TO
  from   CURRS c
  where  c.CURR = :CURR
  into   :round_to;

  cnt_room = 0;
  select count(distinct RP.ID_ROOM)
  from   ROOM_PERIOD$PMS RP
         join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
  where  RC.ID_RENTAL_POOL = :id_rental_pool
         and RP.STATUS in ('PRIVATE','CONTRACT')
         and RP.FROM_DATE <= :FOR_DATE
         and RP.TO_DATE >= :FOR_DATE
  into   :cnt_room;

  if (:cnt_room = 0) then exception PMS_EXCEPTION 'The pool has not assigned room contracts for selected date (' || :FOR_DATE || ') !';

  if (:is_room_pool = 1) then begin
    curr_total_posted = 0;
    cnt = 0;
    id_pms_event = null;
    id_hotel = null;
    for
      select distinct RP.ID_ROOM, RC.ID_ROOM_CONTRACT, R.ID_HOTEL
      from   ROOM_PERIOD$PMS RP
             join ROOMS R on R.ID_ROOM = RP.ID_ROOM
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.FROM_DATE <= :FOR_DATE
             and RP.TO_DATE >= :FOR_DATE
      into   :id_room, :id_room_contract, :id_hotel
    do begin
      id_pms_event = null;

      select E.ID_PMS_EVENT
      from   PMS_EVENT$PMS E
      where  E.ID_ROOM = :id_room
             and E.ID_SESSION = current_transaction
      into   :ID_PMS_EVENT;

      if (:ID_PMS_EVENT is null) then begin
        execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, :id_room_contract)
        returning_values :id_pms_event;
        -- FIXME nakraq da se update total_event_value
      end
      if (:cnt_room - :cnt = 1) then begin
        value_to_post = :TOTAL_VALUE_PER_SERVICE - :curr_total_posted;
      end else begin
        value_to_post = round_f(:TOTAL_VALUE_PER_SERVICE / :cnt_room, :round_to);
      end

      curr_total_posted = :curr_total_posted + :value_to_post;
      cnt = :cnt + 1;

      /* ...i se razpredelq mejdu sobstwenicite na staqta */
      value_to_post = abs(:value_to_post);
      for
        select R.ID_OWNER, R.OUT_VALUE
        from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
        into   :id_owner, :value_to_post_per_owner
      do begin
        /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_pool_account,
                :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                1, :IS_OWNER_INCOME, :id_room)
        returning_values :no_use_id_acc_post;
        /* ... i se nachislqwa po sobswtenik */
        execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
        returning_values (:id_owner_account, :is_account$pms);

        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                :is_account$pms, :is_owner_income, :id_room)
        returning_values :no_use_id_acc_post;
      end
    end
  end else begin
    /* distribution by room_param */
    insert into TMP_SELECT$PMS(ID_SESSION, ID_ROOM, ID_OWNER)
    select distinct current_transaction, RP.ID_ROOM, null
    from   ROOM_PERIOD$PMS RP
           join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
    where  RC.ID_RENTAL_POOL = :ID_RENTAL_POOL
           and RP.STATUS in ('PRIVATE','CONTRACT')
           and RP.FROM_DATE <= :FOR_DATE
           and RP.TO_DATE >= :FOR_DATE;

    id_hotel = null;
    for
      select P.OUT_VALUE, P.OUT_ID_ROOM, R.ID_HOTEL
      from   PMS_CALC_VALUE_BY_PARAM(:ID_ROOM_PARAM, :TOTAL_VALUE_PER_SERVICE, :round_to) P
             join ROOMS R on R.ID_ROOM = P.OUT_ID_ROOM
      into   :value_to_post, :id_room, :id_hotel
    do begin
      id_pms_event = null;
      id_room_contract = null;
      -- room contract must be only one for this period
      select RC.ID_ROOM_CONTRACT
      from   ROOM_PERIOD$PMS RP
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.ID_ROOM = :id_room
             and :for_date between RP.FROM_DATE and RP.TO_DATE
      into   :id_room_contract;

      if (:id_room_contract is not null) then begin
        select E.ID_PMS_EVENT
        from   PMS_EVENT$PMS E
        where  E.ID_ROOM = :id_room
               and E.ID_SESSION = current_transaction
        into   :ID_PMS_EVENT;
  
        if (:ID_PMS_EVENT is null) then begin
          execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                  'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, id_room_contract)
          returning_values :id_pms_event;
          -- FIXME nakraq da se update total_event_value
        end
  
        /* ...i se razpredelq mejdu sobstwenicite na staqta */
        for
          select R.ID_OWNER, R.OUT_VALUE
          from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
          into   :id_owner, :value_to_post_per_owner
        do begin
          /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :ID_POOL_ACCOUNT,
                  :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                  1, :IS_OWNER_INCOME, :id_room)
          returning_values :no_use_id_acc_post;
  
          /* ... i se nachislqwa po sobswtenik */
          execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
          returning_values (:id_owner_account, :is_account$pms);

          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                  :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                  :is_account$pms, :is_owner_income, :id_room)
          returning_values :no_use_id_acc_post;
        end
      end
    end

    delete from TMP_SELECT$PMS T
    where  T.ID_SESSION = current_transaction;
  end
end
^

/* Restore proc. body: RES_CHECKIN_MULTI$RSV */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable checkin_count integer;
  declare variable split_on_checkin integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
  declare variable tmp_warn_code integer;
begin
  checkin_count = 0;
  warn_code = null;
  for
    select RD.ID_RESERV_DETAIL, RD.CHECK_STATUS, RD.SPLIT_ON_CHECKIN, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :SELECTION_ID
    into   :id_reserv_detail, :check_status, :split_on_checkin, :id_titular
  do begin
    if (:check_status >= 0) then begin
      checkin_count = :checkin_count + 1;
    end else begin
      if (:split_on_checkin = 1) then begin
        for
          select G.ID_GUEST
          from   GUEST G
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and G.ID_GUEST <> :id_titular
          into   :id_guest
        do begin
          execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
          returning_values  :id_splited_reservation;

          execute procedure RES_CHECKIN$RSV (:id_splited_reservation)
          returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

          update RESERV_DETAIL RD
          set    RD.SELECTION_ID = :selection_id
          where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
        end
      end

      execute procedure RES_CHECKIN$RSV (:id_reserv_detail)
      returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
      WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end

  if (:checkin_count > 0) then begin
    execute procedure SYSTEM_WARNING_ADD(-1011, f_character(29)||:checkin_count)
    returning_values  :warn_code;
  end
end
^

/* Restore proc. body: RES_GUEST_CHANGE$RSV */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable id_guest integer;
  declare variable check_status integer;
  declare variable id_person_data integer;
  declare variable old_person_profile integer;
  declare variable old_profile_name varchar(100);
  declare variable new_profile_name varchar(100);
begin
  select r.RDB$DB_KEY, r.ID_TITULAR, r.CHECK_STATUS, r.ID_PERSON_PROFILE, p.PROFILE_NAME
  from   RESERV_DETAIL R
         join PROFILE P on P.ID_PROFILE = r.ID_PERSON_PROFILE
  where  R.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey, :id_guest, :check_status, :old_person_profile, :old_profile_name;

  if (:old_person_profile = :ID_PERSON_PROFILE) then exit; -- NO CHANGES!

  id_person_data = null;
  select pp.ID_PERSON_DATA, p.PROFILE_NAME
  from   PROFILE_PERSON PP
         join PROFILE P on P.ID_PROFILE = pp.ID_PROFILE
  where  pp.ID_PROFILE = :ID_PERSON_PROFILE
  into   :id_person_data, :new_profile_name;

  if (:id_person_data is null) then exception BOOKING_EXCEPTION '-1039';

  update RESERV_DETAIL RD
  set    rd.ID_PERSON_PROFILE = :ID_PERSON_PROFILE
  where  rd.RDB$DB_KEY = :rd_dbkey;

  if (:check_status = 1) then begin
    execute procedure PERSON_DATA_COPY$INT (:id_person_data)
    returning_values (:id_person_data);
  end

  update GUEST_DATA GD
  set    gd.ID_PERSON_DATA = :id_person_data
  where  gd.ID_GUEST = :id_guest;

  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey);

  if (exists (select ap.ID_ACCOUNT_POST
              from   ACCOUNT_POST AP
                     join ACCOUNT A on A.ID_ACCOUNT = ap.ID_ACCOUNT
              where  a.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                     and a.ID_PROFILE = :old_person_profile
                     and ap.IS_ANUL = 0)) then
    exception BOOKING_EXCEPTION '-1038';

  if (exists (select d.ID_DEPOSIT
              from   DEPOSITS D
                     join ACCOUNT A on A.ID_ACCOUNT = d.ID_ACCOUNT
              where  a.ID_PROFILE = :old_person_profile
                     and coalesce(d.ID_RESERV_DETAIL, a.ID_RESERV_DETAIL) = :ID_RESERV_DETAIL
                     and d.RECEIVED_AMOUNT > 0)) then
    exception BOOKING_EXCEPTION '-1040';

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'TITULAR_CHANGED',
          f_character(29) || :old_profile_name || f_character(28) || :new_profile_name, null);

end
^

/* Restore proc. body: RES_RECALC$INT */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable num_prefix varchar(20);
  declare variable number_1 varchar(20);
begin
  /* CALLER_KIND = {NORMAL, FORCED} */
  err_code = 0;
  /* 1. GET DATA */
  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL, rd.NUMBER_1
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :check_status, :id_reserv_detail, :number_1;

  if (:check_status = 1) then begin
    -- CHECKED OUT
    select sn.LEADING_PART
    from   SYSTEM_NUMERATOR SN
    where  sn.ID_NUMERATOR = 0
    into   :num_prefix;

    if (trim('.' from coalesce(:num_prefix, '')) = coalesce(:number_1, '')) then
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_MINE');
    else
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_ELSE');

    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :id_guest
    do begin
      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'MANUAL_EDIT_DATA', '');
    end
  end
  /* 2. FIND DEPENDANT GUESTS AND THEIR TARIFFS */
  --execute procedure sys_dbg('calc RES_RECALC$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

  ID_TAR_CALC = gen_id(gen_id_tar_calc, 1);
  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NONE');

  -- 3. UPDATE ROOM PRICE and REPOST ALL AFFECTED BOOKINGS
  execute procedure RES_TAR_CALC_FINALIZE$INT (:ID_TAR_CALC, :CALLER_KIND, :FORCE_POSTING)
  returning_values (:ERR_CODE, :ERR_TEXT);
end
^

/* Restore proc. body: RES_SAVE_ACCOUNTING$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
declare variable old_id_agent_profile integer;
  declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable action_text varchar(255);
  declare variable old_account_routing varchar(30);
  declare variable id_acc_profile integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:acc_routing, 'GUEST, AGENT, MIXED, OWNER, FULL_COMPLIMENTARY, PART_COMPLIMENTARY', 'Account routing');

  if (exists (select *
              from   PROFILE_HOUSE PH
              where  PH.ID_PROFILE = :id_agent_profile)) then
  begin
    exception BOOKING_EXCEPTION '-1016';
  end

  --execute procedure RESERV_TRACK_CHANGES$INT(:rd_dbkey);

  select RD.ID_AGENT_PROFILE, RD.ID_RESERV_DETAIL, RD.ACC_ROUTING
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_agent_profile, :id_reserv_detail, :old_account_routing;

  if (:ACC_ROUTING in ('AGENT','MIXED') and :ID_AGENT_ACCOUNT is not null) then begin
    select A.ID_PROFILE
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :ID_AGENT_ACCOUNT
    into   :id_acc_profile;
    -- check up agent account ownership
    if (:id_acc_profile is distinct from :ID_AGENT_PROFILE) then ID_AGENT_ACCOUNT = null;
  end

  update RESERV_DETAIL RD
  set    RD.ID_AGENT_ACCOUNT_RULE = :ID_AGENT_ACCOUNT,
         RD.ACC_ROUTING = :ACC_ROUTING,
         RD.ID_AGENT_PROFILE = :ID_AGENT_PROFILE,
         RD.ID_AGENT_PAYMENT = :ID_AGENT_PAYMENT,
         RD.ID_PERSON_PAYMENT = coalesce(:ID_PERSON_PAYMENT, RD.ID_PERSON_PAYMENT),
         RD.ID_GROUP = :ID_GROUP
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_id_agent_profile is distinct from :id_agent_profile) then begin
    execute procedure RES_SET_EDIT_STATUS$INT(:RD_DBKEY, 'AGENT', 'add');

    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :g_dbkey
    do begin
      execute procedure GUEST_AGENT_SET$INT(:g_dbkey, :id_agent_profile);
    end

    select f_character(29)||coalesce(old_A.PROFILE_NAME, '')||f_character(28)||coalesce(new_A.PROFILE_NAME, '')
    from   PROFILE old_A, PROFILE new_A
    where  old_A.ID_PROFILE = :old_id_agent_profile
           and new_A.ID_PROFILE = :ID_AGENT_PROFILE
    into   :action_text;

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_AGENT', :action_text);
  end

  if (:ACC_ROUTING <> :old_account_routing) then begin
    action_text = f_character(29) || coalesce(:old_account_routing, '')
                  || f_character(28) || coalesce(:acc_routing, '');

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_ACC_ROUTING', :action_text);
  end

  execute procedure RES_SAVE_ACCOUNTS$INT (:RD_DBKEY);
end
^

/* Restore proc. body: SAFE_CHECK_OUT */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE TYPE OF ID)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
WARN_CODE TYPE OF ID_REF)
 AS
declare variable to_dt timestamp;
  declare variable is_occupied integer;
  declare variable expire_tollerance integer;
  declare variable occupant_name varchar(100);
  declare variable id_resource_reservation integer;
  declare variable check_out_datetime timestamp;
begin
  DOC_SELECTED = null;
  select s.IS_OCCUPIED, od.TO_DATETIME,
         st.EXPIRE_TOLLERANCE, rr.OCCUPANT_NAME, rr.ID_RESOURCE_RESERVATION
  from   SAFE s
         join RESOURCE$INT r on r.ID_RESOURCE = s.ID_SAFE
         join SAFE_TYPES st on st.ID_SAFE_TYPE = r.ID_RESOURCE_TYPE
         join RESOURCE_RESERVATION rr on rr.ID_RESOURCE_RESERVATION = s.ID_CURRENT_OCCUPANCY
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join RESOURCE_OCCUPANCY ro on ro.ID_RESOURCE_OCCUPANCY_DATA = od.ID_RESOURCE_OCCUPANCY_DATA
  where  s.ID_SAFE = :ID_SAFE
  into   :is_occupied, :to_dt, :expire_tollerance, :occupant_name, :id_resource_reservation;

  if (:is_occupied = 0) then exit;

  expire_tollerance = coalesce(:expire_tollerance, 0);
  check_out_datetime = current_timestamp;

  execute procedure SAFE_OCCUPANCY_MODIFY (:id_safe, current_timestamp, :occupant_name)
  returning_values  :DOC_SELECTED;

  if (:check_out_datetime > (:to_dt + cast(:expire_tollerance as double precision) / 60 / 24)) then begin
    execute procedure SYSTEM_WARNING_ADD (-1066, f_character(29) || :expire_tollerance || f_character(28) || formatdate(:to_dt + cast(:expire_tollerance as double precision) / 60 / 24, 'D;dd/mm/yyyy HH:MM'))
    returning_values (:WARN_CODE);
  end

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = null
  where  s.ID_SAFE = :ID_SAFE;

  update RESOURCE_RESERVATION rr
  set    rr.STATUS = 'CHECKED_OUT'
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_CHECKED_OUT', :occupant_name);
end
^

/* Restore proc. body: SPR_OCC_KONT */
ALTER PROCEDURE SPR_OCC_KONT(FROM_DATE DATE,
TO_DATE DATE,
IDS_AGENTS VARCHAR(5000),
KIND SMALLINT,
AGE_KIND SMALLINT,
ALL_KINDS SMALLINT,
ID_HOTEL INTEGER)
 RETURNS(AGENT_NAME VARCHAR(50),
TYPE_ROOM VARCHAR(20),
FOR_DATE DATE,
KONTINGENT INTEGER,
DATA INTEGER,
OUT_KIND VARCHAR(20))
 AS
begin
  /* KIND:  1 - ROOMS
            2 - BEDS
            3 - ADD BEDS
            else - BEDS + ADD BEDS
     AGE_KIND:  1 - ADULTS
                2 - CHILDREN
                else - ALL*/
  for
    select AGENT_NAME, TYPE_ROOM, FOR_DATE, KONTINGENT, DATA, OUT_KIND
    from   SPR_OCC_KONT_YES(:from_date, :to_date, :ids_agents, :kind, :age_kind, :all_kinds, :id_hotel)
    into   :agent_name, :type_room, :for_date, :kontingent, :data, :out_kind
  do begin
    suspend;
  end

  agent_name = '=@{caption.total}';

  for
    select TYPE_ROOM, FOR_DATE, sum(KONTINGENT), sum(DATA), OUT_KIND
    from   SPR_OCC_KONT_YES(:from_date, :to_date, :ids_agents/*''*/, :kind,:age_kind, :all_kinds, :id_hotel)
    group by TYPE_ROOM, FOR_DATE, OUT_KIND
    into   :type_room, :for_date, :kontingent, :data, :out_kind
  do begin
    suspend;
  end
end
^

/* Restore proc. body: TAR_CALC_INPUT_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_PARAMS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_input integer;
  declare variable id_guest integer;
  declare variable for_date date;
  declare variable id_calc_tariff integer;
  declare variable td_dbkey char(8);
  declare variable date_independent_param_values varchar(2000);
  declare variable date_dep_param_values varchar(2000);
  declare variable prev_id_guest integer;
  declare variable prev_id_tariff integer;
begin
  prev_id_guest = null;
  prev_id_tariff = null;
  for
    select Td.RDB$DB_KEY, TI.ID_TAR_INPUT, ti.ID_GUEST, td.FOR_DATE, td.ID_TAR_HEAD
    from   TAR_CALC_INPUT$TMP TI
           join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
    where  TI.ID_TAR_CALC = :id_tar_calc
    order by ti.ID_GUEST asc, td.FOR_DATE asc
    into   :td_dbkey, :id_tar_input, :id_guest, :for_date, :id_calc_tariff
  do begin
    if ((:id_guest is distinct from :prev_id_guest)
        or (:id_calc_tariff is distinct from :prev_id_tariff)) then
    begin
      /* get date independent params */
      execute procedure TAR_CALC_PARAMS$INT (:id_calc_tariff, :id_tar_input, :ID_TAR_CALC, null, null)
      returning_values (:ERR_CODE, :date_independent_param_values);
      if (:ERR_CODE < 0) then exit;
      prev_id_guest = :id_guest;
      prev_id_tariff = :id_calc_tariff;
    end

    execute procedure TAR_CALC_PARAMS$INT (:id_calc_tariff, :id_tar_input, :ID_TAR_CALC, :for_date, null)
    returning_values (:ERR_CODE, :date_dep_param_values);
    if (:ERR_CODE < 0) then exit;

    update TAR_CALC_INPUT_DETAIL$TMP d
    set    d.PARAM_VALUES = coalesce(:date_independent_param_values, '') || ';'
                            || coalesce(:date_dep_param_values, '')
    where  d.RDB$DB_KEY = :td_dbkey;
  end
end
^

SET TERM ; ^

