/* Server version: WI-V6.3.7.18553 Firebird 2.1 
   SQLDialect: 3. ODS: 11.1. Forced writes: On. Sweep inteval: 20000.
   Page size: 8192. Cache pages: 2048 (16384 Kb). Read-only: False. */
SET NAMES NONE;

SET SQL DIALECT 3;

/* Create Table... */
CREATE TABLE EXT_ROOM_CLOUD_HOTEL_MAP(ID_HOTEL ID_REF NOT NULL,
ROOM_CLOUD_HOTEL TSHORT_CODE NOT NULL,
USER_NAME TUSER_NAME NOT NULL,
"PASSWORD" TPASSWORD NOT NULL,
IS_ACTIVE TLOGICAL NOT NULL,
IS_SCHEDULED TLOGICAL NOT NULL,
ENDPOINT TURL NOT NULL);


CREATE TABLE EXT_ROOM_CLOUD_PORTAL_MAP(ID_ROOM_CLOUD_PORTAL_MAP ID NOT NULL,
ID_HOTEL ID_REF NOT NULL,
ID_PROFILE ID_REF,
POSTING_ROUTING TSHORT_CODE NOT NULL,
BOOKING_PREFIX TSHORT_CODE NOT NULL,
ROOM_CLOUD_PORTAL_ID TSHORT_CODE NOT NULL,
ROOM_CLOUD_PORTAL_NAME TDESCRIPTION_SHORT);


CREATE TABLE EXT_ROOM_CLOUD_RATE_MAP(ID_ROOM_CLOUD_RATE_MAP ID NOT NULL,
ID_RATE ID_REF,
ID_BOARD ID_REF,
ROOM_CLOUD_RATE_ID TSHORT_CODE NOT NULL,
ROOM_CLOUD_RATE_NAME TDESCRIPTION_SHORT,
ID_ROOM_CLOUD_ROOM_MAP ID_REF NOT NULL);


CREATE TABLE EXT_ROOM_CLOUD_ROOM_MAP(ID_ROOM_CLOUD_ROOM_MAP ID NOT NULL,
ID_HOTEL ID_REF NOT NULL,
ID_ROOM_TYPE ID_REF,
ROOM_CLOUD_ROOM_ID TSHORT_CODE NOT NULL,
ROOM_CLOUD_ROOM_NAME TDESCRIPTION_SHORT);



ALTER TABLE EXT_PMS_HOTEL_MAP ADD EXPORT_RELEASE_DATES TLOGICAL;

ALTER TABLE EXT_PMS_HOTEL_MAP ADD EXPORT_OVERBOOK TLOGICAL;

ALTER TABLE EXT_PMS_HOTEL_MAP ADD EXPORT_RES_CONFIRMED TLOGICAL;

ALTER TABLE EXT_PMS_HOTEL_MAP ADD EXPORT_RES_NOTCONFIRMED TLOGICAL;

ALTER TABLE EXT_PMS_HOTEL_MAP ADD EXPORT_RES_WAITING TLOGICAL;

ALTER TABLE EXT_PMS_HOTEL_MAP ADD EXPORT_BOOKING_POSITIONS TLOGICAL;

ALTER TABLE EXT_PMS_HOTEL_MAP ADD EXPORT_CONTINGENT TLOGICAL;

ALTER TABLE RESERV_DETAIL ADD ROOM_PRICE_LAST$INT TPRICE;

ALTER TABLE RESERV_DETAIL ADD ROOM_CURRENCY_LAST$INT TCURRENCY;

/* Create Procedure... */
SET TERM ^ ;

CREATE PROCEDURE AVAILABILITY_OCCUPANCY$EXC(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER)
 RETURNS(ID_ROOM_TYPE INTEGER,
OUT_FROM_DATE DATE,
OUT_TO_DATE DATE,
ROOMS_AVAILABLE INTEGER)
 AS
 BEGIN SUSPEND; END
^

CREATE PROCEDURE EXT_RC_PORTAL_MAP_MODIFY(ID_ROOM_CLOUD_PORTAL_MAP INTEGER,
ID_HOTEL INTEGER,
ID_PROFILE INTEGER,
POSTING_ROUTING VARCHAR(10),
BOOKING_PREFIX VARCHAR(10),
ROOM_CLOUD_PORTAL_ID VARCHAR(10),
ROOM_CLOUD_PORTAL_NAME VARCHAR(100),
OPERATION VARCHAR(5))
 RETURNS(NEW_ID_ROOM_CLOUD_PORTAL_MAP INTEGER)
 AS
 BEGIN SUSPEND; END
^

CREATE PROCEDURE EXT_ROOM_CL_PORTAL_MAP_MODIFY(ID_ROOM_CLOUD_PORTAL_MAP INTEGER,
ID_HOTEL INTEGER,
ID_PROFILE INTEGER,
POSTING_ROUTING VARCHAR(10),
BOOKING_PREFIX VARCHAR(10),
ROOM_CLOUD_PORTAL_ID VARCHAR(10),
ROOM_CLOUD_PORTAL_NAME VARCHAR(100),
OPERATION VARCHAR(5))
 AS
 BEGIN EXIT; END
^

CREATE PROCEDURE EXT_ROOM_CLOUD_HOTEL_MAP_MODIFY(ID_HOTEL INTEGER,
ROOM_CLOUD_HOTEL VARCHAR(10),
ENDPOINT VARCHAR(200),
USER_NAME VARCHAR(30),
"PASSWORD" VARCHAR(50),
IS_ACTIVE SMALLINT,
IS_SCHEDULED SMALLINT,
OPERATION VARCHAR(10))
 AS
 BEGIN EXIT; END
^

CREATE PROCEDURE EXT_ROOM_CLOUD_RATE_MAP_MODIFY(ID_ROOM_CLOUD_RATE_MAP INTEGER,
ID_ROOM_CLOUD_ROOM_MAP INTEGER,
ID_RATE INTEGER,
ID_BOARD INTEGER,
ROOM_CLOUD_RATE_ID VARCHAR(10),
ROOM_CLOUD_RATE_NAME VARCHAR(100),
OPERATION VARCHAR(5))
 AS
 BEGIN EXIT; END
^

CREATE PROCEDURE EXT_ROOM_CLOUD_ROOM_MAP_MODIFY(ID_ROOM_CLOUD_ROOM_MAP INTEGER,
ID_HOTEL INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_CLOUD_ROOM_ID VARCHAR(10),
ROOM_CLOUD_ROOM_NAME VARCHAR(100),
OPERATION VARCHAR(5))
 RETURNS(NEW_ID_ROOM_CLOUD_ROOM_MAP INTEGER)
 AS
 BEGIN SUSPEND; END
^


SET TERM ; ^

COMMENT ON COLUMN ENA_ACCOUNT.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_ACCOUNT.ID_ACCOUNT IS
'  . .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_NAME IS
'   .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_EXT_CODE IS
'             .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ID IS
'         . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_NAME IS
'    .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ACCOUNT_NO IS
'             .  -    .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_TYPE IS
'       .  : AGENT -  , PERSON -  , HOUSE -    . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_HOUSE_TYPE IS
'      (PROFILE_TYPE = ''HOUSE''),    -.  : hptExternalClient -          ( ,      ); hptExternalRevenue -                (,   ..); hptComplimentary -           ,  ,        . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_HOTEL IS
'       .  ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_ACCOUNT_POST_HISTORY IS
'   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_ACCOUNT IS
'      .  ENA_ACCOUNT.ID_ACCOUNT. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_SERVICE IS
'   .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_SALE_TAXATION IS
'         .       . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.SYSTEM_DATE IS
'    / . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_DATE IS
'        (). .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_CURR IS
'  . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_AMOUNT IS
'    (   )    . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.NAT_NET_VALUE IS
'    ( )   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.NAT_GROSS_VALUE IS
'    ( )   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_TYPE IS
'  . BASE -  ; ADD_INS -  - ,    ; EXTRA -     ,     ; TAX -            ,     .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_GUEST IS
'       .  ENA_GUEST.ID_GUEST.        : 1.    "  "; 2.           ; 3.        ,      . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_GROUP IS
'       .    : ''ROOMS'', ''Food and Beverage'', ''Other Operated Departments'', ''Rentals and Other Income''. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_ACCOUNT IS
' -      .    . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_SUB_ACCOUNT IS
' --      . ,     -. .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.ID_HOTEL IS
'   ,    . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.ID_DOC_HEAD IS
'        .  ENA_DOC_HEAD_ADVANCE.ID_DOC. .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.SYSTEM_DATE IS
'      . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAYMENT_DATE IS
'     . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.SRC_ID_ACCOUNT IS
'   . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.DEST_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAY_AMOUNT IS
' .        . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAY_CURRENCY IS
' . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.USER_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.DATETIME_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_HOTEL IS
'   ,    . .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_DEPOSIT_PAYMENT IS
'  .         . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_DATE IS
'        .            . .';

COMMENT ON COLUMN ENA_DEPOSIT.SYSTEM_DATE IS
'   .         PAYMENT_DATE.        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_NUM IS
'           .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_DIRECTION IS
'0 -   , 1 -   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_TYPE_NAME IS
'       .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_ACCOUNT IS
'        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_AMOUNT IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DEPOSIT.IS_ANUL IS
'   . 0 - , 1 - .           /    .     IS_ANUL = 0,    1.           ID_DEPOSIT.  .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_CREATED IS
'     .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_CREATED IS
'       . .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_ANNUL IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_ANNUL IS
'     .  .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.ID_HOTEL IS
'       .  .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.ID_DEPOSIT_PAYMENT IS
'   ,   .  ENA_DEPOSIT.ID_DEPOSIT_PAYMENT. .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SYSTEM_DATE IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAYMENT_DATE IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SRC_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DEST_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAY_AMOUNT IS
' .        . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAY_CURRENCY IS
' . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.USER_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DATETIME_CREATED IS
'     . .';

COMMENT ON VIEW ENA_DOC_DEPOSIT_CONSUMPTION IS
' !!!!!!    ID_DOC_TYPE - za mapowe.';


COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.DOC_TYPE_NAME IS
'       . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_NUM IS
'         .  .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_DATE IS
'      .          . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_VALUE IS
'         . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_DOC_RATE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.EQUAL_DOC_VALUE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.NAT_VALUE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.ID_DEPOSIT_PAYMENT IS
'      (  ENA_DEPOSIT.ID_DEPOSIT_PAYMENT ). .';

COMMENT ON VIEW ENA_DOC_HEAD_ADVANCE IS
'!      ';


COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC IS
'  .             .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_ADVANCE.ID_DOC.  .     - , ..       ,      - .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SUB_TYPE IS
'   . ,  : 0 - / , 1 -  ,  , 2 -  ,  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_NAME IS
'    . ,       .              .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_DESCRIPTION IS
'   .         .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_NUM IS
'   ,        .      . ,     ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DATE IS
'        . .    SYSTEM_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.IS_ANUL IS
'        . . 0 - , 1 - .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TOTAL_VALUE IS
' (, )       . .      .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ONE_LINE_TEXT IS
' ,         .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURR_RATE IS
'   ()    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_POST_ADDRESS IS
'    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_ZIP_CODE IS
'     ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_MOL IS
'    ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_RECIPIENT_NAME IS
'     ()';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BANK_NAME IS
'  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BIC IS
'BIC  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IBAN IS
'IBAN  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_EMAIL IS
'email  .        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SUPPLIER_SEND_NAME IS
'     .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ACCOUNT_ID IS
'        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC IS
'  .             .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_SERVICE.ID_DOC.     - , ..       ,      - .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC_TYPE IS
'    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SUB_TYPE IS
'   .  : 0 - / , 1 -  ,  , 2 -  ,  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_NAME IS
'    .              .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_DESCRIPTION IS
'   .         .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_NUM IS
'   ,        .      .  -       ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DATE IS
'        .    SYSTEM_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.IS_ANUL IS
'        . 0 - , 1 - .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_CURRENCY IS
'  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TOTAL_VALUE IS
' (, )       .      .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ONE_LINE_TEXT IS
' ,         .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURR_RATE IS
'   ()    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_DATE IS
'   ,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_NUM IS
'  -,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_POST_ADDRESS IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_ZIP_CODE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_MOL IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_RECIPIENT_NAME IS
'     (). .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BANK_NAME IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BIC IS
'BIC  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IBAN IS
'IBAN  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_EMAIL IS
'email  .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SUPPLIER_SEND_NAME IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ACCOUNT_ID IS
'        .    ENA_ACCOUNT.ID_ACCOUNT. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_SERVICE IS
'     .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.DATE_POST IS
'    . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_SERVICE IS
'      .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_SERVICE IS
'   .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.IS_CORRECT IS
'            .      1,        . 0 -   ; 1 -      0. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_GUEST IS
'   ,        .    null,       ''  ''     .    ENA_GUEST.ID_GUEST. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.DATE_POST IS
'        .    ,    . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ROOM_NAME IS
'       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ACCOUNT_PRICE IS
'         /.             /. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_SERVICE IS
'    (, , , ,  ).  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_SALE_TAXATION IS
'         .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON VIEW ENA_DOC_PAYMENT IS
'   ,     .';


COMMENT ON COLUMN ENA_DOC_PAYMENT.ID_DOC_HEAD IS
'  ( ENA_DOC_HEAD.ID_DOC)      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DOC_TYPE_NAME IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_NUM IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_DATE IS
'     .        ,                 . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_CURRENCY IS
'  .        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DUE_DATE IS
'       .          ,      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_VALUE IS
'           . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_DOC_RATE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.EQUAL_DOC_VALUE IS
'      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.NAT_VALUE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.ID_DOC_HEAD IS
'         . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNT_VALUE IS
'      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNTABLE_VALUE IS
'  .       . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.IS_PERCENT_DISCOUNT IS
'  .         . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.FIXED_DISCOUNT_CURRENCY IS
'  .       -     . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNT_PERCENT_OR_AMOUNT IS
'  .       . .';

COMMENT ON COLUMN ENA_DOC_TAX.ID_DOC_HEAD IS
'         ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_TAX.ID_SALE_TAX IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.NONTAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_VALUE IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_NAME IS
'  .  -        .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_PERCENT IS
'   ().  .';

COMMENT ON COLUMN ENA_DOC_TAX.FISCAL_CODE IS
' .        .  -      .';

COMMENT ON COLUMN ENA_DOC_TAX.ACCOUNT_NAME IS
' .              . .';

/* Alter View (Drop, Create)... */
/* Drop altered view: ENA_GUEST */
DROP VIEW ENA_GUEST;

/* Create altered view: ENA_GUEST */
/* Create view: ENA_GUEST */
CREATE VIEW ENA_GUEST(
ID_GUEST,
ID_RESERV_DETAIL,
PERSON_NAME,
PERSON_NAME2,
IS_CHILD,
VAUCHER_DATE,
VAUCHER_NUM,
VAUCHER_TEXT,
VAUCHER_NUM2,
VAUCHER_DATE2,
RATING_AGE,
AGE,
COUNTRY_CODE,
MASK)
 AS 
select
G.ID_GUEST,
G.ID_RESERV_DETAIL,
PD.PERSON_NAME,
PD.PERSON_NAME2,
G.IS_CHILD,
G.VAUCHER_DATE,
G.VAUCHER_NUM,
G.VAUCHER_TEXT,
G.VAUCHER_NUM2,
G.VAUCHER_DATE2,
GD.RATING_AGE,
(select ga.AGE_INYEARS from SYSTEM_CALC_AGE_INYEARS(pd.BIRTH_DAY, g.FROM_DATE) ga) as AGE,
PD.COUNTRY_CODE,
PD.MASK
from GUEST g
    join GUEST_DATA gd on gd.ID_GUEST = g.ID_GUEST
    join PERSON_DATA pd on pd.ID_PERSON_DATA = gd.ID_PERSON_DATA
;

COMMENT ON VIEW ENA_GUEST IS
'!!! .    (    )';

COMMENT ON COLUMN ENA_GUEST.ID_GUEST IS
'   ( )   . .';

COMMENT ON COLUMN ENA_GUEST.ID_RESERV_DETAIL IS
'        ( ENA_RESERV_DETAIL.ID_RESERV_DETAIL). .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME2 IS
'      . .';

COMMENT ON COLUMN ENA_GUEST.IS_CHILD IS
'   . 0 - ; 1 - . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE IS
'    . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_TEXT IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.RATING_AGE IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.COUNTRY_CODE IS
'    .        ISO. .';

COMMENT ON COLUMN ENA_GUEST.MASK IS
'  .         . .';

COMMENT ON COLUMN ENA_HOTEL.ID_HOTEL IS
'  . .';

COMMENT ON COLUMN ENA_HOTEL.HOTEL_NAME IS
'  . .';

COMMENT ON COLUMN ENA_HOTEL.CODE IS
'   . .';

COMMENT ON COLUMN ENA_HOTEL.SYSTEM_DATE IS
'     .                  ENA.                . .';

COMMENT ON COLUMN ENA_HOTEL.IS_USE IS
'    (  ). 0 -   , 1 -  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_RESERV_DETAIL IS
'   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NUMBER IS
'  .    (   ). .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_GUEST_MAIN IS
'      .      .  -     .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME IS
'    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME2 IS
'       . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.FROM_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.TO_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NIGHTS IS
'. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ADULT_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHILD_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_EATING_OBJECT IS
'          . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHECK_STATUS IS
'  . -3 =  ; -2 =   ; -1 =  ; 0 =  ; 1 =  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.IS_ANUL IS
'   . 0 - , 1 - .  -       0  1.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ID IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_NAME IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_TYPE IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ACCOUNT_NO IS
'             .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SEGMENT_CODE IS
'   ''segment''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SOURCE_CODE IS
'   ''source''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_CHANNEL_CODE IS
'   ''channel''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_HEAR_CODE IS
'   ''hear reason''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_COME_CODE IS
'   ''come reason''.   . .';

COMMENT ON COLUMN ENA_SERVICES.ID_HOTEL IS
'       . .';

COMMENT ON COLUMN ENA_SERVICES.ID_SERVICE IS
'   . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_NAME IS
'  . .';

COMMENT ON COLUMN ENA_SERVICES.GROUP_NAME IS
'    .            a       . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_TYPE IS
'  .  : ''BASE'',''EXTRA'',''COMMISSION'',''MEAL''. ''BASE'' -    ,     ,''EXTRA'' -  , ''MEAL'' - , ''COMMISSION'' - ,        (  ). .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_GROUP IS
'       .  : ''ROOMS'', ''Food and Beverage'', ''Other Operated Departments'', ''Rentals and Other Income''. .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_ACCOUNT IS
' -      . .';

COMMENT ON COLUMN ENA_SERVICES.ACCOUNT_NAME IS
'      (. ),      .          . .';

COMMENT ON COLUMN ENA_SERVICES.EXT_CODE IS
'         . .';

COMMENT ON COLUMN ENA_SERVICES.IS_BREAKFAST IS
'   . 0 - , 1 - .    1,   SERVICE_TYPE e ''BASE''  ''MEAL''.  -          .';

COMMENT ON COLUMN ENA_SERVICES.IS_LUNCH IS
'   .   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_DINNER IS
'   .   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_EXTRAFOOD1 IS
'     1.   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_EXTRAFOOD2 IS
'     2.   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.ID_ROOM_TYPE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ). .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  -             .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM_EXT_CODE IS
'    ( )     ,      .  -        .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_STAY_CODE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  : ''ALONE'' -      , ''BED'' -            , ''EXTRA_BED'' -      . .';

COMMENT ON COLUMN OWNER_POST.POST_STATUS IS
'11  
22  ';

/* Create index... */
CREATE UNIQUE INDEX EXT_RC_PORTAL_MAP_PORTAL_IDX ON EXT_ROOM_CLOUD_PORTAL_MAP(ID_HOTEL, ROOM_CLOUD_PORTAL_ID);


/* Create generator... */
CREATE GENERATOR GEN_ID_ROOM_CLOUD_PORTAL_MAP;

CREATE GENERATOR GEN_ID_ROOM_CLOUD_RATE_MAP;

CREATE GENERATOR GEN_ID_ROOM_CLOUD_ROOM_MAP;


/* Create Primary Key... */
ALTER TABLE EXT_ROOM_CLOUD_HOTEL_MAP ADD CONSTRAINT PK_EXT_ROOM_CLOUD_HOTEL_MAP PRIMARY KEY (ID_HOTEL);

ALTER TABLE EXT_ROOM_CLOUD_PORTAL_MAP ADD CONSTRAINT PK_EXT_ROOM_CLOUD_PORTAL_MAP PRIMARY KEY (ID_ROOM_CLOUD_PORTAL_MAP);

ALTER TABLE EXT_ROOM_CLOUD_RATE_MAP ADD CONSTRAINT PK_EXT_ROOM_CLOUD_RATE_MAP PRIMARY KEY (ID_ROOM_CLOUD_RATE_MAP);

ALTER TABLE EXT_ROOM_CLOUD_ROOM_MAP ADD CONSTRAINT PK_EXT_ROOM_CLOUD_ROOM_MAP PRIMARY KEY (ID_ROOM_CLOUD_ROOM_MAP);

/* Create Unique... */
ALTER TABLE EXT_ROOM_CLOUD_RATE_MAP ADD CONSTRAINT UNQ_EXT_ROOM_CLOUD_RATE_MAP UNIQUE (ID_ROOM_CLOUD_ROOM_MAP, ROOM_CLOUD_RATE_ID);

ALTER TABLE EXT_ROOM_CLOUD_ROOM_MAP ADD CONSTRAINT UNQ_EXT_ROOM_CLOUD_ROOM_MAP UNIQUE (ID_HOTEL, ROOM_CLOUD_ROOM_ID);

/* Create Foreign Key... */
RECONNECT;

ALTER TABLE EXT_ROOM_CLOUD_HOTEL_MAP ADD CONSTRAINT FK_EXT_RC_HOTEL_MAP_HOTEL FOREIGN KEY (ID_HOTEL) REFERENCES HOTEL (ID_HOTEL);

ALTER TABLE EXT_ROOM_CLOUD_PORTAL_MAP ADD CONSTRAINT FK_EXT_RC_PORTAL_MAP_HOTEL FOREIGN KEY (ID_HOTEL) REFERENCES HOTEL (ID_HOTEL);

ALTER TABLE EXT_ROOM_CLOUD_PORTAL_MAP ADD CONSTRAINT FK_EXT_RC_PORTAL_MAP_PROFILE FOREIGN KEY (ID_PROFILE) REFERENCES PROFILE (ID_PROFILE);

ALTER TABLE EXT_ROOM_CLOUD_RATE_MAP ADD CONSTRAINT FK_EXT_RC_RATE_MAP_BOARD FOREIGN KEY (ID_BOARD) REFERENCES SERVICE_MEALS (ID_SERVICE);

ALTER TABLE EXT_ROOM_CLOUD_RATE_MAP ADD CONSTRAINT FK_EXT_RC_RATE_MAP_RATE FOREIGN KEY (ID_RATE) REFERENCES TARIFA (ID_TARIFA);

ALTER TABLE EXT_ROOM_CLOUD_RATE_MAP ADD CONSTRAINT FK_EXT_RC_RATE_MAP_RC_ROOM FOREIGN KEY (ID_ROOM_CLOUD_ROOM_MAP) REFERENCES EXT_ROOM_CLOUD_ROOM_MAP (ID_ROOM_CLOUD_ROOM_MAP) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE EXT_ROOM_CLOUD_ROOM_MAP ADD CONSTRAINT FK_EXT_RC_ROOM_MAP_HOTEL FOREIGN KEY (ID_HOTEL) REFERENCES HOTEL (ID_HOTEL);

ALTER TABLE EXT_ROOM_CLOUD_ROOM_MAP ADD CONSTRAINT FK_EXT_RC_ROOM_MAP_ROOM_TYPE FOREIGN KEY (ID_ROOM_TYPE) REFERENCES ROOM_TYPES (ID_ROOM_TYPE);

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_ADD$INT for: ACCOUNT_CHECK_CREDIT_STATUS$INT */
SET TERM ^ ;

ALTER PROCEDURE ACCOUNT_POSTING_ADD$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_GUEST /* TYPE OF ID_REF */ INTEGER,
ID_SECQUENCE /* TYPE OF ID_REF */ INTEGER,
DATE_POST /* TYPE OF TDATE */ DATE,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_TARIFF /* TYPE OF ID_REF */ INTEGER,
ID_ROOM /* TYPE OF ID_REF */ INTEGER,
IS_BASE /* TYPE OF TLOGICAL */ SMALLINT,
QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
ORIG_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
RATE /* TYPE OF TRATE */ NUMERIC(15,6),
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
CHANGED_TEXT /* TYPE OF TTEXT_SHORT */ VARCHAR(30),
ID_MASTER_ADDINS_ACC_POST /* TYPE OF ID_REF */ INTEGER,
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
NEW_ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE$INT for: ACCOUNT_CHECK_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE$INT(AP_DBKEY /* TYPE OF TDB_KEY */ CHAR(8),
ID_SERVICE /* TYPE OF ID_REF */ INTEGER,
ID_TARIFF /* TYPE OF ID_REF */ INTEGER,
ID_ROOM /* TYPE OF ID_REF */ INTEGER,
QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
QTY_FREE /* TYPE OF TQTY */ NUMERIC(15,2),
PRICE /* TYPE OF TVALUE */ DOUBLE PRECISION,
CURR /* TYPE OF TCURRENCY */ CHAR(3),
RATE /* TYPE OF TRATE */ NUMERIC(15,6),
CHANGED_TEXT VARCHAR(40),
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
IS_CONSEQUENTIAL_UPDATE /* TYPE OF TBOOLEAN */ SMALLINT = 0,
RE_ROUTE_ACCOUNT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(OUT_QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
OUT_PRICE_POST /* TYPE OF TVALUE */ DOUBLE PRECISION,
OUT_AC VARCHAR(2))
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_CHECK_CREDIT_STATUS$INT) */
ALTER PROCEDURE ACCOUNT_CHECK_CREDIT_STATUS$INT(ID_ACCOUNT TYPE OF ID_REF,
POST_VALUE TYPE OF TPRICE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_credit_account integer;
  declare variable id_reserv_detail integer;
  declare variable credit_limit tprice;
  declare variable b_post_sum tprice;
  declare variable b_pay_sum tprice;
  declare variable difference_value tprice;
  declare variable no_use varchar(255);
  declare variable account_currency tcurrency;
  declare variable round_to numeric(15,4);
begin
  if (:POST_VALUE = 0) then exit;

  select a.IS_CREDIT_ACCOUNT, a.CREDIT_LIMIT, a.ID_RESERV_DETAIL
  from   ACCOUNT A
  where  a.ID_ACCOUNT = :ID_ACCOUNT
  into   :is_credit_account, :credit_limit, :id_reserv_detail;

  if (:is_credit_account = 0
      and exists (select rd.ID_RESERV_DETAIL
                  from   RESERV_DETAIL rd
                  where  rd.ID_RESERV_DETAIL = :id_reserv_detail
                         and rd.CHECK_STATUS = 1)) then
  begin
    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, :credit_limit, 1);
  end

  if (coalesce(:credit_limit, 0) > 0) then begin
    /* FIND BALANCE OF ACCOUNT */
    execute procedure ACCOUNT_BALANCE$INT(:id_account)
    returning_values  :account_currency, :round_to, :no_use, :b_post_sum, :b_pay_sum, :no_use, :no_use;
    b_post_sum = coalesce(:b_post_sum, 0);
    b_pay_sum  = coalesce(:b_pay_sum, 0);

    /* IS THIS POST IS IN LIMIT */
    if ((:b_post_sum + :POST_VALUE) > :credit_limit) then begin
      err_code = -13; /*  */
      difference_value = :b_post_sum + :POST_VALUE - :credit_limit;
      err_text = f_character(29)||FormatFloat(:credit_limit, :round_to)||' '||:account_currency||
                 f_character(28)||FormatFloat(:difference_value, :round_to);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_ACCOUNT$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
QTY /* TYPE OF TQTY */ NUMERIC(15,2),
ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
DATE_POST /* TYPE OF TDATE */ DATE,
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ROOM /* TYPE OF ID */ INTEGER = null,
POST_DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_GUEST$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ACCOUNT_ROUTING /* TYPE OF TSHORT_CODE */ VARCHAR(10),
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_TAR_CALC_REPOST$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE RES_TAR_CALC_REPOST$INT(ID_TAR_CALC /* TYPE OF ID_REF */ INTEGER,
ID_RESERV_DETAIL /* TYPE OF ID_REF */ INTEGER,
RECALC_MARKER VARCHAR(40))
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_ADD$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_ADD$INT(ID_ACCOUNT TYPE OF ID,
ID_GUEST TYPE OF ID_REF,
ID_SECQUENCE TYPE OF ID_REF,
DATE_POST TYPE OF TDATE,
ID_SERVICE TYPE OF ID,
ID_TARIFF TYPE OF ID_REF,
ID_ROOM TYPE OF ID_REF,
IS_BASE TYPE OF TLOGICAL,
QTY_POST TYPE OF TQTY,
PRICE TYPE OF TPRICE,
ORIG_CURRENCY TYPE OF TCURRENCY,
RATE TYPE OF TRATE,
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
POST_TEXT TYPE OF TDESCRIPTION_SHORT,
RESOURCE_TEXT TYPE OF TREASON,
CHANGED_TEXT TYPE OF TTEXT_SHORT,
ID_MASTER_ADDINS_ACC_POST TYPE OF ID_REF,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
NEW_ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable price_post double precision;
  declare variable post_rate numeric (15, 6);
  declare variable curr_post char(3);
  declare variable account_currency char(3);
  declare variable id_pack_service integer;
  declare variable id_room_type integer;
  declare variable room_name varchar(30);
  declare variable is_archive integer;
  declare variable id_tax_policy integer;
  declare variable id_sale_taxation integer;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable check_option varchar(255);
  declare variable id_hotel integer;
  declare variable id_srv_hotel integer;
  declare variable service_name varchar(30);
  declare variable account_name varchar(50);
begin
  ID_GUEST = nullif(:ID_GUEST, -1);

  execute procedure POST_PRICE_CHECK$INT (:QTY_POST, :PRICE, :ORIG_CURRENCY);

  if ( (:IS_BASE = 1) or (:ID_MASTER_ADDINS_ACC_POST > 0) ) then
    check_option = 'IS_BASE;ALLOW_POSTING';
  else
    check_option = 'IS_EXTRA;ALLOW_POSTING';

  execute procedure ACCOUNT_VALIDATE$INT(:id_account, :check_option)
  returning_values  (:err_code, :err_text, :account_currency, :id_tax_policy, :id_hotel, :account_name);
  if (:err_code < 0) then EXIT; --  exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;

  select s.ID_HOTEL, s.SERVICE_NAME
  from   SERVICES S
  where  s.ID_SERVICE = :ID_SERVICE
  into   :id_srv_hotel, :service_name;

  if (:id_srv_hotel is distinct from :id_hotel) then
    exception POSTING_EXCEPTION '-1056' || f_character(31) || f_character(29) || :service_name || f_character(28) || :account_name;

  if (:rate is null) then begin
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :orig_currency, :date_post, :id_guest)
    returning_values  :rate;
  end

  curr_post  = :account_currency;
  if (:orig_currency = :account_currency) then begin
    post_rate  = :rate;
  end else begin
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :account_currency, :date_post, :id_guest)
    returning_values  :post_rate;
  end

  execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :id_tax_policy, :ID_TARIFF, :DATE_POST - :FROM_DATE)
  returning_values (:id_sale_taxation);

  execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:QTY_POST, :PRICE,
                    :RATE, :post_rate, :id_sale_taxation)
  returning_values  :price_post, :post_net_value, :post_gross_value;

  execute procedure ACCOUNT_CHECK_CREDIT_STATUS$INT (:ID_ACCOUNT, :price_post * :QTY_POST)
  returning_values (:ERR_CODE, :ERR_TEXT);
  if (:ERR_CODE <> 0) then exit;

  --
  new_id_account_post = gen_id (id_account_post_gen, 1);

  if (:post_text starting with 'PACK') then begin
    id_pack_service = substring(:post_text from 6 for 20);
    post_text = '';
  end else begin
    id_pack_service = -1;
  end
  if (:is_base = 1) then id_master_addins_acc_post = :new_id_account_post;

  select R.ROOM_NAME, R.ID_ROOM_TYPE
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :room_name, :id_room_type;

  if (:id_guest is null) then begin
    is_archive = 1;
  end else begin
    select iif(G.CHECK_STATUS = 1, 1, 0)
    from   GUEST G
    where  G.ID_GUEST = :id_guest
    into   :is_archive;
  end

  insert into ACCOUNT_POST (
    ID_ACCOUNT_POST, ID_ACCOUNT, ID_GUEST, ID_SERVICE, ID_TARIFF, ID_ROOM,
    IS_BASE, DATE_POST, QTY_POST, QTY_FREE, PRICE_POST, POST_NET_VALUE, POST_GROSS_VALUE, CURR_POST, RATE_POST,
    PRICE_ORIG, CURR_ORIG, RATE_ORIG, IS_LOCKED_FOR_UPDATE, TO_DATE, FROM_DATE, ID_SEQUENCE,
    SHORT_CODE, CHANGED_TEXT, ID_MASTER_ADDINS_ACC_POST, ID_PACK_SERVICE, ROOM_NAME, ID_ROOM_TYPE,
    ID_SALE_TAXATION, AC, IS_ARCHIVE, IN_DOC_QTY, IN_DOC_VALUE, DESCRIPTION)
  values (
    :new_id_account_post, :id_account, :id_guest, :id_service, :id_tariff, coalesce(:id_room, -1),
    :is_base, :date_post, :qty_post, 0, :price_post, :post_net_value, :post_gross_value, :curr_post, :post_rate,
    :price, :orig_currency, :rate, 0, :TO_DATE, :FROM_DATE, :id_secquence,
    :short_code, :changed_text, :id_master_addins_acc_post, :id_pack_service, :room_name, :id_room_type,
    :id_sale_taxation, '00', :is_archive, 0, 0, :DESCRIPTION);

  if ((coalesce(:post_text, '') <> '') or (coalesce(:resource_text, '') <> '')) then begin
    insert into ACCOUNT_POSTING_DET (ID_ACCOUNT_POST, POST_TEXT, QTY, FROM_DATETIME, TO_DATETIME, RESOURCE_TEXT)
    values (:new_id_account_post, :post_text, :qty_post, :FROM_DATE, :TO_DATE, :resource_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_TRANSFER$INT for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER,
IS_MANUAL_TRANSFER /* TYPE OF TLOGICAL */ SMALLINT = 1)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE_PERC for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_PERC(IN_ID_ACCOUNT_POST VARCHAR(4000),
IN_PERC NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(30))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_POSTING$INT for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_POSTING$INT(ID_RESOURCE_RESERVATION /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
PRICE_DESCRIPTION /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
ID_RESERV_DETAIL /* TYPE OF ID */ INTEGER,
ID_EXTERNAL_CLIENT_ACCCOUNT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(DOC_SELECTED /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_POSTING_UPDATE$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE$INT(AP_DBKEY TYPE OF TDB_KEY,
ID_SERVICE TYPE OF ID_REF,
ID_TARIFF TYPE OF ID_REF,
ID_ROOM TYPE OF ID_REF,
QTY_POST TYPE OF TQTY,
QTY_FREE TYPE OF TQTY,
PRICE TYPE OF TVALUE,
CURR TYPE OF TCURRENCY,
RATE TYPE OF TRATE,
CHANGED_TEXT VARCHAR(40),
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
IS_CONSEQUENTIAL_UPDATE TYPE OF TBOOLEAN = 0,
RE_ROUTE_ACCOUNT TYPE OF ID_REF = null)
 RETURNS(OUT_QTY_POST TYPE OF TQTY,
OUT_PRICE_POST TYPE OF TVALUE,
OUT_AC VARCHAR(2))
 AS
declare variable date_post date;
  declare variable orig_is_base integer;
  declare variable orig_id_service integer;
  declare variable orig_id_room integer;
  declare variable orig_short_code varchar(255);
  declare variable orig_qty_post integer;
  declare variable orig_ac varchar(2);
  declare variable is_locked_for_update integer;
  declare variable orig_locked_for_update integer;
  declare variable orig_id_tariff integer;
  declare variable orig_id_guest integer;
  declare variable id_type_stay integer;
  declare variable id_room_type integer;
  declare variable id_board integer;
  declare variable id_pack_service integer;
  declare variable new_id_pack_service integer;
  declare variable post_currency char(3);
  declare variable room_name varchar(30);
  declare variable original_post varchar(30);
  declare variable new_ac varchar(2);
  declare variable orig_in_doc_qty numeric(15,2);
  declare variable orig_in_doc_value double precision;
  declare variable rate_post numeric(15,6);
  declare variable id_base_doc integer;
  declare variable id_tax_policy integer;
  declare variable price_post double precision;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable id_sale_taxation integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable orig_price_post tprice;
  declare variable round_to numeric(15,4);
  declare variable account_name tobject_name;
  declare variable err_code integer;
  declare variable err_text varchar(100);
  declare variable id_account integer;
  declare variable orig_id_master_addins_acc_post integer;
  declare variable check_options varchar(255);
begin
  /* GET DATA */
  original_post = '';
  new_id_pack_service = null;

  select AP.DATE_POST, AP.IS_BASE, AP.ID_SERVICE, AP.ID_BASE_DOC,
         AP.SHORT_CODE, AP.QTY_POST, ap.PRICE_POST, AP.IS_LOCKED_FOR_UPDATE,
         AP.AC, AP.ID_TARIFF, AP.ID_GUEST, AP.ID_ROOM,
         AP.ID_PACK_SERVICE, AP.ID_ROOM_TYPE,
         AP.IN_DOC_QTY, AP.IN_DOC_VALUE, AP.RATE_POST, ap.ID_SALE_TAXATION,
         ap.ID_ACCOUNT, ap.ID_ACCOUNT_POST, ap.ID_MASTER_ADDINS_ACC_POST
  from   ACCOUNT_POST AP
  where  AP.rdb$db_key = :AP_DBKEY
  into   :date_post, :orig_is_base, :orig_id_service, :id_base_doc,
         :orig_short_code, :orig_qty_post, :orig_price_post, :orig_locked_for_update,
         :orig_ac, :orig_id_tariff, :orig_id_guest, :orig_id_room,
         :id_pack_service, :id_room_type,
         :orig_in_doc_qty, :orig_in_doc_value, :rate_post, :id_sale_taxation,
         :id_account, :id_account_post, :orig_id_master_addins_acc_post;

  check_options = 'ALLOW_POSTING;';
  if (:RE_ROUTE_ACCOUNT is not null and :id_base_doc is null and :id_account <> :RE_ROUTE_ACCOUNT) then begin
    -- IMPORTANT !!! Re-routing is possible only in this case!
    id_account = :RE_ROUTE_ACCOUNT;
    if ( (:orig_is_base = 1) or (:orig_id_master_addins_acc_post > 0) ) then
      check_options = :check_options || 'IS_BASE;';
    else
      check_options = :check_options || 'IS_EXTRA;';
  end
  is_locked_for_update = :orig_locked_for_update; /* to initialize and preserve from null */

  if (:IS_CONSEQUENTIAL_UPDATE is distinct from 1) then begin
    -- direct post update - manual edition restrictions check
    if (:QTY_POST = -1) then QTY_POST = :orig_qty_post;   -- preserve current qty

    if (:QTY_POST <> :orig_qty_post) then exception POSTING_EXCEPTION '-379';

    if ((:orig_is_base = 1) and ((:QTY_POST <> 1) or (:ID_SERVICE <> :orig_id_service))) then
      exception POSTING_EXCEPTION '-223';

    if (:orig_ac = '01') then execute procedure RIGHTS_CHECK_GRANTED$INT('BALANCES_EDIT_CLOSED');

    short_code = :orig_short_code;
    id_tariff  = :orig_id_tariff;
    id_room    = :orig_id_room;
    is_locked_for_update = 1;  /* manual corrections must lock the postings  */

  end else begin
    /* post changes is a result from some user operation, indirect update ('NORMAL', 'FORCED', safes recalc, etc....) */
    is_locked_for_update = iif(:CHANGED_TEXT = 'TRANSFER_POSTING', :orig_locked_for_update, 0);

    if (:orig_is_base = 1) then begin
      /* PREPARING THE PACKET SERVICE */
      select Sp.ID_TYPE_STAY, Sp.ID_ROOM_TYPE, s.ID_HOTEL
      from   SERVICE_PACKET Sp
             join SERVICES s on s.ID_SERVICE = sp.ID_SERVICE
      where  s.ID_SERVICE = :id_service
      into   :id_type_stay, :id_room_type, :id_hotel;

      select GS.ID_BOARD
      from   GUEST_STAY GS
      where  GS.ID_GUEST = :orig_id_guest
             and GS.FOR_DATE = :date_post
      into   :id_board;

      execute procedure TAR_GET_BASE_SERVICE$INT(:id_type_stay, :id_room_type, :id_board, :id_hotel)
      returning_values  :id_pack_service;
      /* detecting change of STAY_TYPE or ROOM_TYPE */
      if (exists(
        select *
        from   SERVICE_PACKET S
        where  S.ID_SERVICE = :orig_id_service
               and ((S.ID_TYPE_STAY is distinct from :id_type_stay) or (S.ID_ROOM_TYPE is distinct from :id_room_type))
      )) then original_post = 'CHANGED';
    end
  end

  select R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :room_name;

  if (:orig_locked_for_update = 1
      and :changed_text starting with 'NORMALRECALC'
      and :id_service = :orig_id_service
      --and :orig_is_anul = 0
      and :id_tariff = :orig_id_tariff) then
  begin
    -- price is locked for update
    update ACCOUNT_POST AP
    set    AP.ID_ROOM      = :ID_ROOM,
           AP.ROOM_NAME    = :room_name,
           Ap.FROM_DATE    = :FROM_DATE,
           Ap.TO_DATE      = :TO_DATE,
           AP.ID_PACK_SERVICE  = :id_pack_service,
           AP.CHANGED_TEXT     = :CHANGED_TEXT,
           AP.USER_CHANGED     = current_user,
           AP.DATETIME_CHANGED = current_timestamp,
           AP.SHORT_CODE       = :SHORT_CODE
    where  AP.rdb$db_key   = :AP_DBKEY;
    OUT_QTY_POST = :orig_qty_post;
    OUT_PRICE_POST = :orig_price_post;
    OUT_AC = :orig_ac;
  end else begin
    -- fully update
    execute procedure ACCOUNT_VALIDATE$INT(:id_account, :check_options)
    returning_values  (:err_code, :err_text, :post_currency, :id_tax_policy, :id_hotel, :account_name);
    if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;
  
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :curr, :date_post, :orig_id_guest)
    returning_values  :rate;
  
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :post_currency, :date_post, :orig_id_guest)
    returning_values  :rate_post;
  
    if (:id_base_doc is null) then begin
      execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :id_tax_policy, :ID_TARIFF, :date_post - :from_date)
      returning_values (:id_sale_taxation);
    end

    execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:QTY_POST, :PRICE,
                      :RATE, :rate_post, :id_sale_taxation)
    returning_values  :price_post, :post_net_value, :post_gross_value;

    select c.ROUND_TO
    from   CURRS c
    where  c.CURR = :post_currency
    into   :round_to;

    if ( (:id_base_doc is not null)
         and (:qty_post = :orig_in_doc_qty)
         and (round_f(:price_post * :qty_post - :orig_in_doc_value * :orig_in_doc_qty, :round_to) = 0))
    then new_ac = '01';
    else new_ac = '00';                   
  
    if (:new_ac = '00') then begin
      execute procedure ACCOUNT_CHECK_CREDIT_STATUS$INT (:id_account, :price_post * :QTY_POST - :orig_price_post * :orig_qty_post)
      returning_values (:err_code, :err_text);
      if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;
    end

    update ACCOUNT_POST AP
    set    AP.ID_ACCOUNT           = :id_account,
           AP.ID_SERVICE           = :id_service,
  
           AP.QTY_POST             = :qty_post,
           AP.QTY_FREE             = :qty_free,
           AP.PRICE_POST           = :price_post,
           AP.CURR_POST            = :post_currency,
           AP.RATE_POST            = :rate_post,
           AP.RATE_ORIG            = :rate,
           AP.PRICE_ORIG           = :price,
           AP.CURR_ORIG            = :curr,
           AP.POST_NET_VALUE       = :post_net_value,
           AP.POST_GROSS_VALUE     = :post_gross_value,
  
           AP.AC                   = :new_ac,
           AP.IS_ANUL              = 0,
           AP.ANUL_REASON          = '',
           AP.IS_LOCKED_FOR_UPDATE = :is_locked_for_update,
           AP.ID_TARIFF            = :id_tariff,
           AP.ID_PACK_SERVICE      = :id_pack_service,
           AP.ID_ROOM              = :id_room,
           AP.ID_ROOM_TYPE         = :id_room_type,
           AP.ROOM_NAME            = :room_name,
           AP.ID_SALE_TAXATION     = :id_sale_taxation,
           AP.ORIGINAL_POST        = :original_post,
           AP.SHORT_CODE           = :short_code,
           AP.CHANGED_TEXT         = :changed_text,
           AP.USER_CHANGED         = current_user,
           AP.DATETIME_CHANGED     = current_timestamp,
           Ap.FROM_DATE            = :from_date,
           Ap.TO_DATE              = :to_date
    where  AP.rdb$db_key = :AP_DBKEY
    returning new.id_account_post, new.id_pack_service
    into   :id_account_post, :new_id_pack_service;
  
    if (:new_ac = '01') then begin
      update ACCOUNT_POST_CORRECTION APC
      set    APC.IS_OPEN = 0
      where  APC.ID_ACCOUNT_POST = :id_account_post
             and APC.IS_OPEN = 1;
    end

    if (:orig_is_base = 1 and :new_id_pack_service <> :id_pack_service) then begin
      -- update add_inses with new pack service
      update ACCOUNT_POST AP
      set    ap.ID_PACK_SERVICE = :new_id_pack_service
      where  ap.ID_MASTER_ADDINS_ACC_POST = :id_account_post
             and ap.IS_BASE = 0;
    end

    OUT_QTY_POST = :qty_post;
    OUT_PRICE_POST = :price_post;
    OUT_AC = :new_ac;
  end
end
^

/* Alter (ACCOUNT_POSTING_UPDATE_PERC) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_PERC(IN_ID_ACCOUNT_POST VARCHAR(4000),
IN_PERC NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(30))
 AS
declare variable id_account_post integer;
  declare variable ap_dbkey char(8);
  declare variable id_service integer;
  declare variable id_tariff integer;
  declare variable id_room integer;
  declare variable qty_post numeric (15,4);
  declare variable qty_free numeric (15,4);
  declare variable short_code varchar(255);
  declare variable orig_currency char(3);
  declare variable orig_rate numeric (15,4);
  declare variable orig_price numeric (15,4);
  declare variable new_orig_price double precision;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  for
    select item
    from   SYSTEM_STRING_PARSER(:in_id_account_post, ',')
    into   :id_account_post
  do begin
    select AP.rdb$db_key, AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST,
           AP.QTY_FREE, AP.SHORT_CODE, AP.CURR_ORIG, AP.RATE_ORIG, AP.PRICE_ORIG,
           ap.FROM_DATE, ap.TO_DATE
    from   ACCOUNT_POST AP
    where  AP.ID_ACCOUNT_POST = :id_account_post
    into   :ap_dbkey, :id_service, :id_tariff, :id_room, :qty_post,
           :qty_free, :short_code, :orig_currency, :orig_rate, :orig_price,
           :from_date, :to_date;

    new_orig_price = :orig_price + :orig_price * :in_perc;

    execute procedure ACCOUNT_POSTING_UPDATE$INT(:ap_dbkey,
            :id_service, :id_tariff, :id_room,
            :qty_post, :qty_free, :new_orig_price, :orig_currency, :orig_rate,
            :in_changed_text, :short_code, :from_date, :to_date)
    returning_values  :no_use, :no_use, :no_use;
  end
end
^

/* Alter (EAI_POS_GET_GUESTS$P2E) */
ALTER PROCEDURE EAI_POS_GET_GUESTS$P2E(IN_ROOM_NAME VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(OUT_ID_GUEST INTEGER,
OUT_GUEST_NAME VARCHAR(100),
OUT_FROM_DATE DATE,
OUT_TO_DATE DATE,
OUT_OK_FOR_POST INTEGER,
OUT_COUNTRY VARCHAR(30),
OUT_TEXT VARCHAR(100),
OUT_BOARD_NAME VARCHAR(30),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100))
 AS
declare variable id_room integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  OUT_GUEST_NAME = null;

  /*FIND ROOM*/
  select R.ID_ROOM
  from   ROOMS R
         join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
  where  R.ROOM_NAME = :IN_ROOM_NAME
         and RT.ID_HOTEL = :ID_HOTEL
  into   :ID_ROOM;
  if ((:ID_ROOM is null) or (:ID_ROOM <= 0) ) then begin
    ERR_CODE = -5;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Room number not found!    ! ';
    suspend;
    exit;
  end

  /*FIND GUESTS*/
  for
    select G.ID_GUEST, GC.GUEST_NAME1, G.FROM_DATE, G.TO_DATE, C.COUNTRY_NAME,
           (select m.NAME
            from   GUEST_STAY gs
                   join MEALS M on m.ID_BOARD = gs.ID_BOARD
            where  gs.ID_GUEST = g.ID_GUEST
                   and gs.FOR_DATE = iif(current_date = g.to_date, current_date - 1, current_date))
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
           left outer join GUEST_CARD GC on G.ID_GUEST = GC.ID_GUEST
           left outer join COUNTRY C on C.COUNTRY_CODE = GC.COUNTRY
    where  G.ID_ROOM = :ID_ROOM
           and G.CHECK_STATUS = 0
           and rd.IS_ANUL = 0
    into   :OUT_ID_GUEST, :OUT_GUEST_NAME, :OUT_FROM_DATE,  :OUT_TO_DATE, :OUT_COUNTRY, :OUT_BOARD_NAME
  do begin
    OUT_OK_FOR_POST = iif(:OUT_TO_DATE < current_date, 0, 1) ;
    suspend;
  end

  if (:OUT_GUEST_NAME is null) then begin
    ERR_CODE = -1;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Guests not found!     !';
    suspend;
  end
end
^

/* Alter (EXT_PMS_HOTEL_MAP_MODIFY) */
ALTER PROCEDURE EXT_PMS_HOTEL_MAP_MODIFY(ID_HOTEL INTEGER,
PMS_USER_NAME VARCHAR(30),
PMS_API_KEY VARCHAR(40),
PMS_URL VARCHAR(200),
IS_ACTIVE SMALLINT,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
EXPORT_RELEASE_DATES SMALLINT,
EXPORT_OVERBOOK SMALLINT,
EXPORT_RES_CONFIRMED SMALLINT,
EXPORT_RES_NOTCONFIRMED SMALLINT,
EXPORT_RES_WAITING SMALLINT,
EXPORT_BOOKING_POSITIONS SMALLINT,
EXPORT_CONTINGENT SMALLINT,
OPERATION VARCHAR(12))
 AS
begin
  if (OPERATION = 'set') then begin
    update or insert into EXT_PMS_HOTEL_MAP (ID_HOTEL, PMS_USER_NAME, PMS_API_KEY, PMS_URL, IS_ACTIVE)
    values (:ID_HOTEL, :PMS_USER_NAME, :PMS_API_KEY, :PMS_URL, :IS_ACTIVE) matching (ID_HOTEL);
  end else if (OPERATION = 'set_extra') then begin
    update EXT_PMS_HOTEL_MAP map
      set map.ID_NOM_MARKET_SEGMENT = :ID_NOM_MARKET_SEGMENT,
          map.ID_NOM_SOURCE_CODE = :ID_NOM_SOURCE_CODE,
          map.ID_NOM_CHANNEL_CODE = :ID_NOM_CHANNEL_CODE,
          map.ID_NOM_HEAR_REASON = :ID_NOM_HEAR_REASON,
          map.ID_NOM_COME_REASON = :ID_NOM_COME_REASON,
          map.EXPORT_RELEASE_DATES = :EXPORT_RELEASE_DATES,
          map.EXPORT_OVERBOOK = :EXPORT_OVERBOOK,
          map.EXPORT_RES_CONFIRMED = :EXPORT_RES_CONFIRMED,
          map.EXPORT_RES_NOTCONFIRMED = :EXPORT_RES_NOTCONFIRMED,
          map.EXPORT_RES_WAITING = :EXPORT_RES_WAITING,
          map.EXPORT_BOOKING_POSITIONS = :EXPORT_BOOKING_POSITIONS,
          map.EXPORT_CONTINGENT = :EXPORT_CONTINGENT
    where ID_HOTEL = :ID_HOTEL;
  end else if (OPERATION = 'del') then begin
    delete from EXT_PMS_HOTEL_MAP
    where ID_HOTEL = :ID_HOTEL;
  end
end
^

/* Alter (IMPORT_BOOKING_CUSTOM_PRICE$EXC) */
ALTER PROCEDURE IMPORT_BOOKING_CUSTOM_PRICE$EXC(ID_RESERV_DETAIL INTEGER,
FOR_DATE DATE,
PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3))
 AS
begin
  execute procedure RES_SAVE_PRICE$RSV(:ID_RESERV_DETAIL, :FOR_DATE, :PRICE, :PRICE_CURRENCY);

  /*Maintain the flag in RD - HAS_DIFFERENT_PRICE*/
  if (exists (select * from RESERV_CUSTOM_PRICE rmp where rmp.id_reserv_detail = :id_reserv_detail)) then
    update RESERV_DETAIL set has_different_price = 1 where id_reserv_detail = :id_reserv_detail;
  else
    update RESERV_DETAIL set has_different_price = 0 where id_reserv_detail = :id_reserv_detail;

end
^

/* empty dependent procedure body */
/* Clear: EAI_POS_POSTING_ADD$P2E for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PMS_POSTING_CREATE$INT for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
POST_DATE /* TYPE OF TDATE */ DATE,
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
POST_ON_PMS_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT,
IS_OWNER_INCOME /* TYPE OF TLOGICAL */ SMALLINT,
ID_ROOM /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_ACCOUNT_POST /* ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_FINALIZE$POST for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_TELECOUNT_CALL$INT for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_ACCOUNT$INT) */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
QTY TYPE OF TQTY,
ID_SECQUENCE TYPE OF ID,
IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
POST_TEXT TYPE OF TDESCRIPTION_SHORT,
RESOURCE_TEXT TYPE OF TREASON,
DATE_POST TYPE OF TDATE,
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ID_ROOM TYPE OF ID = null,
POST_DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable action_text varchar(255);
begin
  if (:date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :date_post;
  end
/* NO AUTO PRICE !!!!!!
  if (:in_is_manual_price = 0) then begin

    select P.ID_EXTRA_TARIFF
    from   ACCOUNT A
           join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
    where  A.ID_ACCOUNT = :in_id_account
    into   :id_extra_tarifa;
    if ((:id_extra_tarifa is null) or (:id_extra_tarifa < 0)) then begin
      err_code = -14;
      exit;
    end
    execute procedure TAR_RECALC_EXTRASRV(:id_extra_tarifa, :in_id_service, :in_date_post)
    returning_values  :err_code, :err_text, :post_price, :post_currency;
    if (:err_code < 0) then exit;
  end else begin
    --MANUAL PRICE
    post_currency = :manual_curr ;
    post_price = :manual_price ;
  end
*/

  post_currency = :manual_curr ;
  post_price = :manual_price ;
  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, -1, :id_secquence, :date_post, :id_service, -1, :id_room, 0, :qty, :post_price,
    :post_currency, null, :short_code, :from_date, :to_date, :post_text, :resource_text, '', -1, :POST_DESCRIPTION)
  returning_values :err_code, :err_text, :id_account_post;
  if (:err_code <> 0) then exit;

  select S.SERVICE_NAME
  from   SERVICES S
  where  S.ID_SERVICE = :ID_SERVICE
  into   :action_text;
   
  action_text = f_character(29) || coalesce(:action_text, '')
                || f_character(28) || formatdate(:DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || coalesce(:post_currency, '');
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_RESERVATION$INT for: POST_SERVICE_ON_GUEST$INT */
ALTER PROCEDURE POST_SERVICE_ON_RESERVATION$INT(ID_RESERV_DETAIL /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_ROOM for: POST_SERVICE_ON_GUEST$INT */
ALTER PROCEDURE POST_SERVICE_ON_ROOM(IN_ID_ROOM /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255))
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_GUEST /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_GUEST$INT) */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TDESCRIPTION_SHORT,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ACCOUNT_ROUTING TYPE OF TSHORT_CODE,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable id_room integer;
  declare variable no_use varchar(255);
  declare variable action_text varchar(255);
  declare variable is_guest_check_in smallint;
  declare variable service_name varchar(50);
begin
  err_code = 0;
  err_text = '';

  select g.check_status
  from   guest g
  where  g.id_guest = :in_id_guest
  into   :is_guest_check_in;

  if (:is_guest_check_in < 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
  end

  execute procedure GUEST_GET_POSTING_ACCOUNT$INT (:in_id_guest, :account_routing)
  returning_values  :id_account, :id_room;

  if (:in_date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :in_date_post;
  end

  if (:in_is_manual_price = 0) then begin
    execute procedure SERVICE_GET_POSTING_DETAILS(:in_id_service, :IN_DATE_POST)
    returning_values  :no_use, :no_use, :service_name, :post_price, :post_currency;
  end else begin
    /* MANUAL PRICE */
    post_currency = :manual_curr;
    post_price = :manual_price;
    select s.SERVICE_NAME
    from   SERVICES s
    where  s.ID_SERVICE = :IN_ID_SERVICE
    into   :service_name;
  end

  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, :in_id_guest, :in_id_secquence, :in_date_post, :in_id_service, -1, :id_room, 0, :in_qty,
    :post_price, :post_currency, null, :in_short_code, :in_from_datetime, :in_to_datetime, :in_post_text,
    :in_resource_text, '', -1, :DESCRIPTION)
  returning_values  :err_code, :err_text, :id_account_post;

  action_text = f_character(29) || coalesce(:service_name, '')
                || f_character(28) || formatdate(:IN_DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:IN_QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || coalesce(:post_currency, '');
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: RESOURCE_RESERVATION_CHECK_IN for: POST_SERVICE_ON_RESERVATION$INT */
ALTER PROCEDURE RESOURCE_RESERVATION_CHECK_IN(ID_RESOURCE_RESERVATION INTEGER,
SERVICE_PRICE NUMERIC(15,2),
SERVICE_CURR VARCHAR(3))
 RETURNS(OUT_ID_ACCOUNT INTEGER,
OUT_ID_ACCOUNT_POST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_RESERVATION$INT) */
ALTER PROCEDURE POST_SERVICE_ON_RESERVATION$INT(ID_RESERV_DETAIL TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TREASON,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable id_guest integer;
begin
  err_code = 0;
  err_text = '';

  id_guest = null;
  select RD.ID_TITULAR
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :id_guest;

  execute procedure POST_SERVICE_ON_GUEST$INT(:id_guest, :in_id_service, :in_qty, :in_id_secquence,
                    :in_is_manual_price, :manual_price, :manual_curr, :in_from_datetime, :in_to_datetime,
                    :in_post_text, :in_resource_text, :in_date_post, :in_short_code, '', :DESCRIPTION)
  returning_values  :err_code, :err_text, :id_account, :id_account_post;
end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_POST_TO_MH_FRONT_ONLINE for: POST_SERVICE_ON_ROOM */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_SERVICE_POST for: POST_SERVICE_ON_ROOM */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_ROOM) */
ALTER PROCEDURE POST_SERVICE_ON_ROOM(IN_ID_ROOM TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TREASON,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_GUEST TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
begin
  err_code = 0;
  err_text = '';

  id_guest = null;
  select first 1 G.ID_GUEST
  from   GUEST G
  where  G.ID_ROOM = :in_id_room
         and G.CHECK_STATUS = 0
  order by G.FROM_DATE desc, G.ID_GUEST asc
        /************************************************/
        /* DESCENDANT ORDER IS VERY IMPORTANT!!         */
        /* IF TWO GUESTS HAVE:                          */
        /* TO_DATE OF THE 1'ST = FROM_DATE OF THE 2'ND, */
        /* THEN PHONACALLS SHOULD GO TO THE 2'ND        */         
        /************************************************/
  into   :id_guest;

  if (:id_guest is null) then begin
    err_code = -24;   /* NO GUESTS ARE CHECKED_IN INTO THE REQUESTED ROOM! */
    exit;
  end

  execute procedure POST_SERVICE_ON_GUEST$INT(:id_guest, :in_id_service, :in_qty, :in_id_secquence, :in_is_manual_price,
    :manual_price, :manual_curr, :in_from_datetime, :in_to_datetime, :in_post_text, :in_resource_text,
    :in_date_post, :in_short_code, '')
  returning_values  :err_code, :err_text, :id_account, :id_account_post;
end
^

/* empty dependent procedure body */
/* Clear: EAI_TELECOUNT_TRANSFER for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALL_POST$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL /* ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALLS_POST_TO_ACCOUNT$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_TELECOUNT_TRANSFER$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_TELECOUNT_CALL$INT) */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ext_ifc_name varchar(20);
  declare variable room_name varchar(30);
  declare variable datetime_call timestamp;
  declare variable price numeric(15,2);
  declare variable dial_number varchar(50);
  declare variable units integer;
  declare variable pc_id_service integer;
  declare variable def_manual_curr char(3);
  declare variable post_text varchar(50);
  declare variable id_account_post integer;
  declare variable is_archive integer;
  declare variable id_account integer;
  declare variable new_id_account_post integer;
  declare variable pc_tag varchar(30);
  declare variable number_zone varchar(50);
  declare variable id_hotel integer;
  declare variable id_phonecall integer;
  declare variable no_use varchar(255);
begin
  /* Description:
  || POST_TO_TYPE = 0 - ACCOUNT, 1 - GUEST, 2 - RESERV_DETAIL, 3 - JUST PREPARE, FOR EXTERNAL CLIENT
  */
  err_code = 0;
  err_text = '';
  ext_ifc_name = 'TELECOUNT';

  select PC.ID_PHONECALL, PC.ROOM_NAME, PC.DATETIME_CALL, PC.PRICE, PC.DIAL_NUMBER, PC.UNITS,
         PC.ID_ACCOUNT_POST, PC.IS_ARCHIVE, PC.TAG, substring(PC.NUMBER_ZONE from 1 for 30), pc.ID_HOTEL
  from   PHONECALLS PC 
  where  PC.rdb$db_key = :ph_dbkey
  into   :id_phonecall, :room_name, :datetime_call, :price, :dial_number, :units,
         :id_account_post, :is_archive, :pc_tag, :number_zone, :id_hotel;

  if ((:is_archive = 1) or (coalesce(:id_account_post, 0) > 0)) then exit;

  if ((:pc_tag is null) or (:pc_tag = '')) then pc_tag = 'TELECOUNT_DEFAULT';
  else pc_tag = 'TELECOUNT_' || :pc_tag;

  execute procedure EAI_MAP_SERVICE(:pc_tag, :number_zone, :ext_ifc_name, :id_hotel)
  returning_values  :err_code, :err_text, :pc_id_service;
  if (:err_code < 0) then exit;

  post_text = substring(:dial_number || ', impulses ' || :units from 1 for 50);

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :def_manual_curr;

  new_id_account_post = null;
  if (:post_to_type = 0) then begin
    id_account = :post_to_id;
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name)
    returning_values :err_code, :err_text, :new_id_account_post;
  end else if (:post_to_type = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:post_to_id, :pc_id_service, 1, -1, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name, '')
    returning_values :err_code, :err_text, :id_account, :new_id_account_post;
  end else if (:post_to_type = 2) then begin
    execute procedure POST_SERVICE_ON_RESERVATION$INT(:post_to_id, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name)
    returning_values :err_code, :err_text, :id_account, :new_id_account_post;
  end else if (:post_to_type = 3) then begin
    execute procedure POST_PREPARE_ON_ACCOUNT$POST (:post_to_id, :pc_id_service,
      1, :ID_SEQUENCE, :price, :def_manual_curr, :post_text, null, null, :ID_PHONECALL)
    returning_values :no_use;
  end
  if (:err_code < 0) then exit;

  if (:new_id_account_post is not null) then begin
    update PHONECALLS PC
    set    PC.ID_ACCOUNT_POST = :new_id_account_post,
           pc.POSTING_ERROR = null
    where  PC.rdb$db_key = :ph_dbkey;

    insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
    values (:new_id_account_post, :ext_ifc_name, null, :datetime_call);
  end

end
^

/* Alter (POST_TELECOUNT_TRANSFER$TC) */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ph_dbkey char(8);
  declare variable id_account_post integer;
  declare variable account_name varchar(50);
begin
  err_code = 0;
  err_text = '';

  for
    select PC.RDB$DB_KEY, PC.ID_ACCOUNT_POST
    from   PHONECALLS PC
    where  PC.SELECTION_ID = :selection_id
    into   :ph_dbkey, :id_account_post
  do begin
    if ((:id_account_post is not null) and (:id_account_post <> -1)) then begin
      err_code = -117;
      select A.ACCOUNT_NAME
      from   ACCOUNT_POST AP
             join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
      where  AP.ID_ACCOUNT_POST = :id_account_post
      into   :account_name;
      err_text = f_character(29) || :account_name;
      exit;
    end

    execute procedure POST_TELECOUNT_CALL$INT(2, :id_reserv_detail, :ph_dbkey, 0)
    returning_values :err_code, :err_text;
    if (:err_code < 0) then exit;
  end
end
^

/* Alter (RATE_GET_AVAILABILITY$CHM) */
ALTER PROCEDURE RATE_GET_AVAILABILITY$CHM(ID_RATE INTEGER,
FOR_DATE DATE)
 RETURNS(ACTIVE_STATUS INTEGER,
MIN_LOS INTEGER,
MAX_LOS INTEGER)
 AS
declare variable date_from date;
  declare variable date_to date;
  declare variable RATE_capacity integer;
  declare variable to_sell integer;
begin
  --ACTIVE_STATUS 0 - closed
  --ACTIVE_STATUS 1 - closed fro arrival
  --ACTIVE_STATUS 2 - opened
  --opala ID_HOTEL
--  date_from = null;
--  ACTIVE_STATUS -  autoclose, t.e. AUTO_PERCENT






/*  select min(FOR_DATE), max(FOR_DATE)
  from RATE_ALLOTMENT
  where ID_RATE = :id_RATE
  into :date_from, :date_to;
  if (date_from is null) then exit;

  for select distinct ID_ROOM_TYPE
      from RATE_ALLOTMENT
      where ID_RATE = :id_RATE
        and FOR_DATE between :date_from and :date_to
      into :id_room_type
  do begin
    for select RTR.FOR_DATE,
               CA.STATUS,
               CA.AUTO_FREE_ROOMS, CA.ROOM_COUNT, RTR.AVAILABLE as FREE_ROOMS
        from ROOM_TYPE_GET_FREE$CHM(:date_from, :date_to, :id_room_type) RTR
             join RATE_ALLOTMENT CA on CA.ID_ROOM_TYPE = :id_room_type
                                      and CA.ID_RATE = :id_RATE
                                      and CA.FOR_DATE = RTR.FOR_DATE
    into :for_date, :status,
         :auto_free_rooms, :RATE_capacity, :free_rooms
    do begin
      if (:auto_free_rooms is not null) then
        if (coalesce(:free_rooms,0) >= :auto_free_rooms) then
          is_active = 1;
        else is_active = 0;
      else if (:status = 0) then
             is_active = 1;
           else is_active = 0;

      to_sell = coalesce(:free_rooms,0) - coalesce(:auto_free_rooms,0);
      if (to_sell < 0) then to_sell = 0;

      room_count = :to_sell;
      if (:RATE_capacity is not null) then
        if (RATE_capacity < room_count) then
          room_count = :RATE_capacity;

      suspend;
    end
  end*/
end
^

/* Alter (RES_SAVE_PRICE$RSV) */
ALTER PROCEDURE RES_SAVE_PRICE$RSV(ID_RESERV_DETAIL INTEGER,
FOR_DATE DATE,
PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3))
 AS
declare variable old_price numeric(14,4);
  declare variable old_price_currency char(3);
  declare variable action_text varchar(255);
begin
  select cp.PRICE, cp.PRICE_CURRENCY
  from   RESERV_CUSTOM_PRICE cp
  where  cp.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
         and cp.FOR_DATE = :FOR_DATE
  into   :old_price, :old_price_currency;

  if ((:old_price is distinct from :price) or (:old_price_currency is distinct from :price_currency) ) then begin
    execute procedure RES_SAVE_CUSTOM_PRICE$INT(:ID_RESERV_DETAIL, :FOR_DATE, :PRICE, :PRICE_CURRENCY);

    action_text = f_character(29) || formatfloat(:price, 'F;0.00') || ' ' || :price_currency || f_character(28) || formatdate(:for_date, 'D;dd.mm.yyyy') ;
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_MANUAL_PRICE', :action_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: UPDATE_BOOKING$EXC for: RES_SAVE_RATE$RSV */
ALTER PROCEDURE UPDATE_BOOKING$EXC(BOOKING_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE INTEGER,
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA_ID INTEGER,
POSTING_ROUTING VARCHAR(20),
ID_AGENT_ACCOUNT INTEGER,
RATE_ID INTEGER,
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD_CODE /* TFOOD_CODE */ VARCHAR(20),
ARRANGER_PROFILE_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_RATE$RSV) */
ALTER PROCEDURE RES_SAVE_RATE$RSV(ID_RESERV_DETAIL INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
IS_DIFFERENT_TARIFF INTEGER,
IS_DIFFERENT_PRICE INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 AS
declare variable rd_dbkey char(8);
  declare variable old_price numeric(14,4);
  declare variable old_price_currency char(3);
  declare variable old_is_different_price integer;
  declare variable action_text varchar(255);
  declare variable err_code integer;
  declare variable err_text varchar(255) ;
  declare variable id_tar_calc integer;
  declare variable recalc_type varchar(20);
  declare variable old_tariff integer;
begin

  select RD.RDB$DB_KEY, RD.custom_price, rd.custom_currency, rd.HAS_DIFFERENT_PRICE, rd.ID_RATE
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_price, :old_price_currency, :old_is_different_price, :old_tariff;

  if (:is_different_tariff = 0) then begin
    execute procedure RES_SAVE_RATE$INT(:rd_dbkey, :id_tariff);
  end else begin
    execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey);
  end

  if (:IS_DIFFERENT_PRICE = 0) then begin
    delete from RESERV_CUSTOM_PRICE
    where  ID_RESERV_DETAIL  = :ID_RESERV_DETAIL;

    update RESERV_DETAIL RD
    set    RD.CUSTOM_PRICE = :custom_price,
           RD.CUSTOM_CURRENCY = :custom_currency,
           RD.HAS_DIFFERENT_PRICE = :IS_DIFFERENT_PRICE
    where  RD.RDB$DB_KEY = :rd_dbkey;
  end else begin
    if (not exists (select * from RESERV_CUSTOM_PRICE rmp where rmp.id_reserv_detail = :id_reserv_detail)) then IS_DIFFERENT_PRICE = 0;
    update RESERV_DETAIL RD
    set    RD.CUSTOM_PRICE = null,
           RD.CUSTOM_CURRENCY = null,
           RD.HAS_DIFFERENT_PRICE = :IS_DIFFERENT_PRICE
    where  RD.RDB$DB_KEY = :rd_dbkey;
  end


  /*Maintain the flag in RD - HAS_DIFFERENT_PRICE*/
/*  if (exists (select * from RESERV_CUSTOM_PRICE rmp where rmp.id_reserv_detail = :id_reserv_detail)) then
    update RESERV_DETAIL set has_different_price = 1 where id_reserv_detail = :id_reserv_detail;
  else
    update RESERV_DETAIL set has_different_price = 0 where id_reserv_detail = :id_reserv_detail;
*/
  /*Log modifications in custom price if here is diferent values*/
  if ((:old_price is distinct from :custom_price) or (:old_price_currency is distinct from :custom_currency) ) then begin
    action_text = f_character(29) || formatfloat(:custom_price, 'F;0.00') || '' || :custom_currency || f_character(28);
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_MANUAL_PRICE', :action_text);
  end

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    if ((:ID_TARIFF is distinct from :old_tariff)
        or (:IS_DIFFERENT_PRICE is distinct from :old_is_different_price)
        or (:CUSTOM_PRICE is distinct from :old_price)
        or (:CUSTOM_CURRENCY is distinct from :old_price_currency) ) then
      recalc_type = 'FORCED';
    else
      recalc_type = 'NORMAL';

    execute procedure RES_RECALC$INT(:rd_dbkey, :recalc_type, 0)
    returning_values  :err_code, :err_text, :id_tar_calc;
    --execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    --returning_values  :err_code, :err_text;
    if (:err_code < 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_RECALC$INT for: RES_TAR_CALC_FINALIZE$INT */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_TAR_CALC_FINALIZE$INT) */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(ID_TAR_CALC INTEGER,
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
declare variable old_room_price numeric(15,4);
  declare variable old_room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
  declare variable reserv_posting_disabled smallint;
  declare variable postings_disabled smallint;
  declare variable warn_code integer;
  declare variable action_text varchar(255);
begin
  --  Razpiswa cenata na staia, kakto i price_detailite.

  execute procedure TAR_CALC_EVAL_ALL$INT(:ID_TAR_CALC)
  returning_values  :ERR_CODE, :ERR_TEXT;

  if (:ERR_CODE = 0) then execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

  select iif(si.INFO_VALUE = '1', 1, null)
  from   SYSTEM_INFO_GET('RESERV_POSTINGS_DISABLED') si
  into   :postings_disabled;

  for
    select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, coalesce(:postings_disabled, rd.IS_POSTING_STOPPED),
           coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
           coalesce(max((select first 1 AP.IS_BASE
                         from   GUEST G
                                join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                         where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (it`s possible)
    from   TAR_CALC_INPUT$TMP TI
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
           join TARIFA t on t.ID_TARIFA = rd.ID_RATE
    where  ti.ID_TAR_CALC = :ID_TAR_CALC
    group by 1, 2, 3, 4, 5, 6
    into   :id_reserv_detail, :check_status, :is_posting_stopped,
           :room_currency, :id_hotel, :is_anul, :has_postings
  do begin
    reserv_posting_disabled = iif(:is_posting_stopped = 1 and :has_postings = 0, 1, 0);

    if (:ERR_CODE <> 0) then begin
      -- price calculation error handling  !!!!!
      if (:reserv_posting_disabled = 1) then begin
        -- set price to null, posting is disabled
        update RESERV_DETAIL RD
        set    RD.ROOM_PRICE = null,
               RD.ROOM_CURRENCY = null,
               RD.ROOM_PRICE_DETAILS = null,
               RD.LAST_ID_TAR_CALC = null
        where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
      end else begin
        -- exit on error in price calculation - cannot make valid posts
        EXIT;
      end
    end else begin
      room_price = 0;
      room_price_details = '';
    
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);
  
      if (:reserv_posting_disabled = 0 and ((coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1))) then begin
        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);
      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;
  
        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end
  
      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc,
             rd.ROOM_PRICE_LAST$INT = null,
             rd.ROOM_CURRENCY_LAST$INT = null
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail
      returning old.ROOM_PRICE_LAST$INT, old.ROOM_CURRENCY_LAST$INT
      into :old_room_price, :old_room_currency;

      if ((:old_room_price is distinct from :room_price)
          or (:old_room_currency is distinct from :room_currency) ) then
      begin
        action_text = f_character(29) || formatfloat(:old_room_price, 'F;0.00') || ' ' || coalesce(:old_room_currency, '') || f_character(28) || formatfloat(:room_price, 'F;0.00') || ' ' || coalesce(:room_currency, '');
        execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_PRICE_RECALC', :action_text);
      end
    end
  end

  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;

  if (:ERR_CODE <> 0) then begin
    execute procedure SYSTEM_WARNING_ADD(:ERR_CODE, :ERR_TEXT)
    returning_values :warn_code;
    ERR_CODE = 0;
    ERR_TEXT='';
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_TAR_CALC_FINALIZE$INT for: RES_TAR_CALC_REPOST$INT */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(ID_TAR_CALC INTEGER,
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_TAR_CALC_REPOST$INT) */
ALTER PROCEDURE RES_TAR_CALC_REPOST$INT(ID_TAR_CALC TYPE OF ID_REF,
ID_RESERV_DETAIL TYPE OF ID_REF,
RECALC_MARKER VARCHAR(40))
 AS
declare variable id_guest type of id_ref;
  declare variable id_service type of id_ref;
  declare variable id_tariff type of id_ref;
  declare variable date_post type of tdate;
  declare variable qty_post type of tqty;
  declare variable price_orig type of tprice;
  declare variable curr_orig type of tcurrency;
  declare variable id_room type of id_ref;
  declare variable is_base type of tlogical;
  declare variable short_code type of tdescription_long;
  declare variable id_account type of id_ref;
  declare variable gfrom_date type of tdate;
  declare variable gto_date type of tdate;
  declare variable ap_db_key char(8);
  declare variable id_pack_service type of id_ref;
  declare variable err_code type of id_ref;
  declare variable err_text type of tdescription_long;
  declare variable id_master_account_post type of id_ref;
  declare variable id_acc_post type of id_ref;
  declare variable is_base_account type of id_ref;
  declare variable id_extra_account type of id_ref;
  declare variable no_use varchar(255);
begin
  for
    select   TCP.ID_GUEST, TCP.ID_SERVICE, TCP.ID_TARIFF, TCP.DATE_POST, TCP.QTY_POST,
             round_f(TCP.PRICE_ORIG, c.ROUND_TO), TCP.CURR_ORIG, TCP.ID_ROOM, TCP.IS_BASE,
             TCP.SHORT_CODE, iif(coalesce(AGP.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'NONE', 0, 1),
             G.ID_BASE_ACCOUNT, G.FROM_DATE, G.TO_DATE, G.ID_ACCOUNT
    from     TAR_CALC_POST$TMP TCP
             join GUEST G on G.ID_GUEST = TCP.ID_GUEST
             join SERVICES S on S.ID_SERVICE = TCP.ID_SERVICE
             join CURRS c on c.CURR = tcp.CURR_ORIG
             left outer join AGENT_PACKET AGP on AGP.ID_SERVICE = S.ID_SERVICE and AGP.ID_AGENT = G.ID_AGENT
    where    TCP.ID_TAR_CALC = :id_tar_calc
             and tcp.ID_RESERV = :ID_RESERV_DETAIL
                  --or (coalesce(RD.IS_POSTING_STOPPED, 0) = 0 and RD.POSTING_TRANSACTION_UUID is not null))
    order by TCP.ID_GUEST asc, TCP.DATE_POST asc, TCP.IS_BASE desc
    into     :id_guest, :id_service, :id_tariff, :date_post, :qty_post,
             :price_orig, :curr_orig, :id_room, :is_base, :short_code, :is_base_account,
             :id_account, :gfrom_date, :gto_date, :id_extra_account
  do begin
    ap_db_key = null;
    if (:is_base = 1) then begin
      select AP.RDB$DB_KEY, AP.ID_MASTER_ADDINS_ACC_POST, AP.ID_PACK_SERVICE
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.DATE_POST = :date_post
             and AP.IS_BASE = 1
      into   :ap_db_key, :id_master_account_post, :id_pack_service;

      --execute procedure sys_dbg('tar TAR_CALC_REPOST$INT price_orig = '||coalesce(:price_orig, 'null'));
      --execute procedure sys_dbg('tar TAR_CALC_REPOST$INT ap_db_key = '||coalesce(:ap_db_key, 'null'));

      if (:ap_db_key is null) then begin
        id_master_account_post = -1;
        execute procedure GUEST_POST_GET_PACK_SERVICE(:id_service, :id_guest, :date_post)
        returning_values  :id_pack_service;
      end
    end else begin
      -- short_code = '';
      select first 1 APU.rdb$db_key
      from   ACCOUNT_POST APU
      where  APU.ID_MASTER_ADDINS_ACC_POST = :id_master_account_post
             and APU.ID_SERVICE = :id_service
             and APU.CHANGED_TEXT is distinct from :recalc_marker
      order by apu.IS_ANUL asc, apu.ID_ACCOUNT_POST asc
      into   :ap_db_key;

      if ((:is_base_account <> 1)) then id_account = :id_extra_account;
    end

    if (:ap_db_key is null) then begin
      execute procedure ACCOUNT_POSTING_ADD$INT(
        :id_account, :id_guest, -1, :date_post, :id_service, :id_tariff, :id_room, :is_base, :qty_post,
        :price_orig, :curr_orig, null, :short_code, :gfrom_date, :gto_date, 'PACK='||:id_pack_service, '',
        :recalc_marker, :id_master_account_post)
      returning_values  :err_code, :err_text, :id_acc_post;
      if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

      if (:is_base = 1) then id_master_account_post = :id_acc_post;

    end else begin
      execute procedure ACCOUNT_POSTING_UPDATE$INT(
        :ap_db_key, :id_service, :id_tariff, :id_room, :qty_post, 0, :price_orig, :curr_orig, null,
        :recalc_marker, :short_code, :gfrom_date, :gto_date, 1, :id_account)
      returning_values  :no_use, :no_use, :no_use;
    end

  end

  ap_db_key = null;
  id_guest = null;
  for
    select distinct TCP.ID_GUEST
    from   TAR_CALC_POST$TMP TCP
    where  tcp.ID_TAR_CALC = :ID_TAR_CALC
           and tcp.ID_RESERV = :ID_RESERV_DETAIL
    into   :id_guest
  do begin
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.CHANGED_TEXT is distinct from :recalc_marker
             and AP.ID_MASTER_ADDINS_ACC_POST > 0
             and AP.IS_ANUL = 0
      into   :ap_db_key
    do begin
      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_db_key, :recalc_marker);
    end
  end

  delete from RESERV_PREPOST RP where RP.ID_RESERV_DETAIL = :id_reserv_detail;
  execute procedure RES_TAKE_POSTING_RESPONSIBILITY (:ID_RESERV_DETAIL);
end
^

/* Alter (RESMULTI_COMMON_MODIFY$RSV) */
ALTER PROCEDURE RESMULTI_COMMON_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
CHECK_STATUS SMALLINT,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
NOTE VARCHAR(2000),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(30),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
NOTE_REMINDERS VARCHAR(50),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(WARN_CODE TYPE OF TRANGE)
 AS
declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable old_id_room_type integer;
  declare variable old_status integer;
begin
  select RD.RDB$DB_KEY, RD.ID_ROOM, RD.ID_ROOM_TYPE, rd.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_id_room, :old_id_room_type, :old_status;

  execute procedure RES_SAVE_GUESTCOUNT$INT(:rd_dbkey, :adult_count, :children_count);

  execute procedure RES_SAVE_NOTE$RSV(:id_reserv_detail, :note, null);

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, :id_room_type, 'nrttAsIs')
  returning_values (:WARN_CODE);

  execute procedure RES_SAVE_ROOM_LOG$INT(:rd_dbkey, :old_id_room, :old_id_room_type);

  execute procedure RES_SAVE_ACCOUNTING$INT(:rd_dbkey, :id_agent_profile, :id_agent_account, :acc_routing,
                    :id_person_payment, :id_agent_payment, :id_group);

  update RESERV_DETAIL RD
  set    RD.CUSTOM_PRICE = :CUSTOM_PRICE,
         RD.CUSTOM_CURRENCY = :CUSTOM_CURRENCY,
         RD.SPLIT_ON_CHECKIN = :SPLIT_ON_CHECKIN,
         RD.NOTE_REMINDERS = :NOTE_REMINDERS,
         rd.ID_HK_PLAN = :ID_HK_PLAN
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_status <> :CHECK_STATUS) then begin
    if (:CHECK_STATUS >= 0) then exception BOOKING_EXCEPTION 'Can not set status ''CHECKED IN'' or ''CHECKED OUT'' manually!';
  
    execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, :check_status);
  end
  --
end
^

/* Alter (RESOURCE_RESERVATION_CHECK_IN) */
ALTER PROCEDURE RESOURCE_RESERVATION_CHECK_IN(ID_RESOURCE_RESERVATION INTEGER,
SERVICE_PRICE NUMERIC(15,2),
SERVICE_CURR VARCHAR(3))
 RETURNS(OUT_ID_ACCOUNT INTEGER,
OUT_ID_ACCOUNT_POST INTEGER)
 AS
declare variable old_status varchar(20);
  declare variable new_status varchar(20);
  declare variable dbkey char(8);
  declare variable id_service id_ref;
  declare variable price_post tprice;
  declare variable curr_post TCURRENCY;
  declare variable is_manual_price TLOGICAL;
  declare variable is_details tlogical;
  declare variable post_description tobject_text;
  declare variable id_reserv_detail integer;
  declare variable post_date tdate;
  declare variable from_datetime tdatetime;
  declare variable to_datetime tdatetime;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  new_status = 'CHECKED_IN';

  select r.RDB$DB_KEY, R.STATUS, rd.ID_RESERV_DETAIL
  from   RESOURCE_RESERVATION R
         left outer join RESERV_DETAIL rd on rd.NUMBER = r.BOOKING_NUMBER
                                             and rd.IS_ANUL = 0
                                             and rd.SUBSCRIBER_ID is not distinct from r.SUBSCRIBER_ID
  where  R.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION
  into   :dbkey, :old_status, :id_reserv_detail;

  if (:old_status = :NEW_STATUS) then exit;
 
  if (:old_status is distinct from 'RESERVED') then exception ASSERT '-511';

  if (exists (select RP.ID_RESOURCE_RESERVATION
              from   RESOURCE_RESERV_POST RP
                     join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = RP.ID_ACCOUNNT_POST
              where  RP.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION)) then
  begin
    exception ASSERT '-505';
  end

  if (:id_reserv_detail is not null) then begin
    execute procedure RESOURCE_RESERV_SERVICE_GET (:ID_RESOURCE_RESERVATION)
    returning_values (:id_service, :price_post, :curr_post, :is_manual_price, :is_details, :post_description,
                     :post_date, :from_datetime, :to_datetime);
  
    if (:is_manual_price = 1) then begin
      price_post = :SERVICE_PRICE;
      curr_post = :SERVICE_CURR;
    end

    if (:price_post is null) then exception ASSERT 'Unspecified service price!';
    if (:curr_post is null) then exception ASSERT 'Unspecified price currency!';
  
    execute procedure POST_SERVICE_ON_RESERVATION$INT (:id_reserv_detail, :id_service, 1, 0,
            1, :price_post, :curr_post, :from_datetime, :to_datetime,
            '', '', :post_date, 'RESOURCE', :post_description)
    returning_values (:ERR_CODE, :ERR_TEXT, :OUT_ID_ACCOUNT, :OUT_ID_ACCOUNT_POST);
    if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
  
    insert into RESOURCE_RESERV_POST(ID_RESOURCE_RESERVATION, ID_ACCOUNNT_POST)
    values (:ID_RESOURCE_RESERVATION, :OUT_ID_ACCOUNT_POST);
  end

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = :NEW_STATUS
  where  RR.RDB$DB_KEY = :dbkey;

end
^

/* Alter (RIGHTS_GROUP_USER_MODIFY) */
ALTER PROCEDURE RIGHTS_GROUP_USER_MODIFY(USER_NAME VARCHAR(30),
ID_RIGHT_GROUP INTEGER,
OPERATION VARCHAR(50))
 AS
declare variable right_group varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add,del');

  if (:USER_NAME = 'SYSDBA') then exit;

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS RG
  where  RG.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'add') then begin
    insert into RIGHTS_USER_GROUPS (USER_NAME, ID_RIGHT_GROUP)
    values (:user_name, :id_right_group);

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_ADDED',
            f_character(29) || :USER_NAME  || f_character(28) || :right_group);

  end else begin
    delete from RIGHTS_USER_GROUPS
    where USER_NAME = :user_name
          and ID_RIGHT_GROUP = :id_right_group;

    if (row_count > 0) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_REMOVED',
              f_character(29) || :USER_NAME || f_character(28) || :right_group);

  end

  when sqlcode -803 do begin
    /* ERR_TEXT = '       ! ' ;*/
    exit;
  end
end
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_MODIFY for: SAFE_OCCUPANCY_POSTING$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE /* TYPE OF ID */ INTEGER,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100))
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_NEW for: SAFE_OCCUPANCY_POSTING$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE /* TYPE OF ID */ INTEGER,
FROM_DATETIME /* TDATETIME */ TIMESTAMP,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100),
BOOKING_NUMBER /* TYPE OF TRES_NUMBER */ VARCHAR(62),
ID_EXTERNAL_CLIENT_ACCCOUNT /* TYPE OF ID_REF */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER,
ID_RESOURCE_RESERVATION /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SAFE_OCCUPANCY_POSTING$INT) */
ALTER PROCEDURE SAFE_OCCUPANCY_POSTING$INT(ID_RESOURCE_RESERVATION TYPE OF ID,
ID_SERVICE TYPE OF ID,
PRICE TYPE OF TPRICE,
CURRENCY TYPE OF TCURRENCY,
PRICE_DESCRIPTION TYPE OF TDESCRIPTION_SHORT,
ID_RESERV_DETAIL TYPE OF ID,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF = null)
 RETURNS(DOC_SELECTED TYPE OF TRANGE)
 AS
declare variable from_datetime timestamp;
  declare variable to_datetime timestamp;
  declare variable ap_dbkey TDB_KEY;
  declare variable id_account_post integer;
  declare variable safe_name TOBJECT_NAME;
  declare variable no_use varchar(255);
  declare variable new_ac varchar(2);
  declare variable err_code integer;
  declare variable err_text varchar(255) ;
  declare variable occupant_name tperson_name;
  declare variable id_room integer;
  declare variable id_tariff integer;
begin
  DOC_SELECTED = null;
  select od.FROM_DATETIME, od.TO_DATETIME, ap.RDB$DB_KEY, ap.ID_ACCOUNT_POST,
         s.SAFE_NAME, rr.OCCUPANT_NAME, ap.ID_ROOM, ap.ID_TARIFF
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join SAFES s on s.ID_SAFE = od.ID_RESOURCE
         left outer join RESOURCE_RESERV_POST rrp on rrp.ID_RESOURCE_RESERVATION = rr.ID_RESOURCE_RESERVATION
         left outer join ACCOUNT_POST ap on ap.ID_ACCOUNT_POST = rrp.ID_ACCOUNNT_POST
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :from_datetime, :to_datetime, :ap_dbkey, :id_account_post,
         :safe_name, :occupant_name, :id_room, :id_tariff;

  new_ac = null;
  if (:id_account_post is not null) then begin
    execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
            :id_tariff, :id_room, 1, 0, :price, :currency, null, null, 'RESOURCE', :from_datetime, :TO_DATETIME, 1)
    returning_values :no_use, :no_use, :new_ac;
  end else begin
    if (:id_reserv_detail is not null) then begin
      execute procedure POST_SERVICE_ON_RESERVATION$INT (:id_reserv_detail, :id_service, 1, 0,
              1, :price, :currency, :from_datetime, :to_datetime,
              '', '', cast(:from_datetime as date), 'RESOURCE', null)
      returning_values (:ERR_CODE, :ERR_TEXT, :no_use, :id_account_post);
      if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      new_ac = '00';
    end else if (:ID_EXTERNAL_CLIENT_ACCCOUNT is not null) then begin
      execute procedure POST_SERVICE_ON_ACCOUNT$INT (:ID_EXTERNAL_CLIENT_ACCCOUNT, :id_service,
              1, 0, 1, :price, :currency, :from_datetime, :TO_DATETIME, '', '',
              cast(:from_datetime as date), 'RESOURCE', null, null)
      returning_values (:err_code, :err_text, :id_account_post);
      if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      new_ac = '00';
    end
  end

  if (:new_ac is null) then
    exception ASSERT '-1067' || f_character(31) || f_character(29) || :safe_name || f_character(28) || :occupant_name;

  if (:new_ac = '00') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);
    update ACCOUNT_POST AP
    set    ap.DOC_SELECTED = :DOC_SELECTED
    where  ap.ID_ACCOUNT_POST = :id_account_post;
  end

  update or insert into ACCOUNT_POSTING_DET (ID_ACCOUNT_POST, POST_TEXT, QTY,
         FROM_DATETIME, TO_DATETIME, RESOURCE_TEXT)
  values (:id_account_post, :safe_name ||' / '||formatdate(:from_datetime, 'D;dd.mm.yy(hh:mm)')||' - '||formatdate(:to_datetime, 'D;dd.mm.yy(hh:mm)')||' / '
          ||substring(replace(:price_description, F_CRLF(), ';') from 1 for 100), 1, :from_datetime, :to_datetime, :safe_name);

  if (not exists (select rp.ID_ACCOUNNT_POST
                  from   RESOURCE_RESERV_POST rp
                  where  rp.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION
                         and rp.ID_ACCOUNNT_POST = :id_account_post)) then
  begin
    insert into RESOURCE_RESERV_POST (ID_RESOURCE_RESERVATION, ID_ACCOUNNT_POST)
    values (:id_resource_reservation, :id_account_post);
  end
end
^

/* empty dependent procedure body */
/* Clear: SYSTEM_EVENT_LOG$INT for: SYSTEM_LOG_OBJECT_INFO_GET */
ALTER PROCEDURE SYSTEM_EVENT_LOG$INT(OBJECT_CLASS VARCHAR(30),
OBJECT_ID INTEGER,
EVENT_CODE VARCHAR(50),
EVENT_TEXT VARCHAR(255),
EXTRA_DATA VARCHAR(255) = null)
 RETURNS(NEW_ID_SYSTEM_LOG INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SYSTEM_LOG_OBJECT_INFO_GET) */
ALTER PROCEDURE SYSTEM_LOG_OBJECT_INFO_GET(OBJECT_CLASS VARCHAR(30),
OBJECT_ID INTEGER)
 RETURNS(OBJECT_DESCRIPTION VARCHAR(100),
HOTEL_CODE VARCHAR(10))
 AS
declare variable id_hotel integer;
begin
  object_description = null;
  id_hotel = null;
  hotel_code = null;

  if (:OBJECT_CLASS = 'RES_DETAIL') then begin
    select substring(RD.NUMBER || ', '
           || coalesce(rt.TYPE_ROOM, '') || ', '
           || formatdate(rd.FROM_DATE, 'D;dd/mm') || '-'
           || formatdate(rd.TO_DATE, 'D;dd/mm/yy') || ', '
           || coalesce(P.PROFILE_NAME, '') from 1 for 100), RD.ID_HOTEL
    from   RESERV_DETAIL RD
           join PROFILE P on P.ID_PROFILE = RD.ID_PERSON_PROFILE
           left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = rd.ID_ROOM_TYPE
    where  RD.ID_RESERV_DETAIL = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'GUEST') then begin
    select pd.PERSON_NAME, rd.ID_HOTEL
    from   GUEST G
           join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
           join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  G.ID_GUEST = :OBJECT_ID
    into   :OBJECT_DESCRIPTION, :id_hotel;
  end else if (:OBJECT_CLASS = 'DOCUMENT') then begin
    select substring(d.DOC_TYPE_NAME || ' ' || D.DOC_NUM || '/' || formatdate(D.DOC_DATE, 'D;dd.mm.yyyy') from 1 for 100), A.ID_HOTEL
    from   DOC_HEAD D
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  D.ID_DOC = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'DEPOSIT') then begin
    select substring(D.DESCRIPTION || ', ' || P.DOC_TYPE_NAME || ' ' || P.PAYMENT_NUM || '/' || formatdate(P.PAYMENT_DATE, 'D;dd.mm.yyyy') from 1 for 100), A.ID_HOTEL
    from   DEPOSIT D
           join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  D.ID_DEPOSIT = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'ACCOUNT') then begin
    select A.ACCOUNT_NAME, A.ID_HOTEL
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'ACC_TEMPLATE') then begin
    select A.TEMPLATE_NAME, A.ID_HOTEL
    from   ACC_TEMPLATE A
    where  A.ID_ACC_TEMPLATE = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'TAX_POLICY') then begin
    select t.POLICY_NAME, t.ID_HOTEL
    from   TAX_POLICY t
    where  t.ID_TAX_POLICY = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'SALE_TAX') then begin
    select st.TAX_NAME, st.ID_HOTEL
    from   SALE_TAXES st
    where  st.ID_SALE_TAX = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'PROFILE') then begin
    select P.PROFILE_NAME, null
    from   PROFILE P
    where  P.ID_PROFILE = :OBJECT_ID
    into   :OBJECT_DESCRIPTION, :id_hotel;
  end else if (:OBJECT_CLASS = 'ACCOUNT_RECIEVABLE') then begin
    select P.PROFILE_NAME, null
    from   PROFILE P
    where  P.ID_PROFILE = :OBJECT_ID
    into   :OBJECT_DESCRIPTION, :id_hotel;
  end else if (:OBJECT_CLASS = 'BLOCK') then begin
    select substring(R.ROOM_NAME || ' (' || H.CODE || ')' from 1 for 100), H.ID_HOTEL
    from   BLOCK_ROOM BR     
           join ROOMS R on R.ID_ROOM = BR.ID_ROOM
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
           join HOTEL H on H.ID_HOTEL = R.ID_HOTEL
    where  BR.ID_BLOCK_ROOM = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'PAYMENT') then begin
    select substring(p.DOC_TYPE_NAME || ' ' || P.PAYMENT_NUM || '/' || formatdate(P.PAYMENT_DATE, 'D;dd.mm.yyyy') from 1 for 100), A.ID_HOTEL
    from   PAYMENT_HEAD P
           join ACCOUNT A on A.ID_ACCOUNT = P.ID_ACCOUNT
    where  P.ID_PAYMENT_HEAD = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'ROOM') then begin
    select r.ROOM_NAME, r.ID_HOTEL
    from   ROOMS R
    where  R.ID_ROOM = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'CONTRACT') then begin
    select substring(r.ROOM_NAME || ' {' || formatdate(rp.FROM_DATE, 'D;dd.mm.yyyy') || '-' || iif(extract(year from rp.TO_DATE) = 2500, '~', formatdate(rp.TO_DATE, 'dd.mm.yyyy')) || '}' from 1 for 255), r.ID_HOTEL
    from   ROOM_CONTRACT$PMS RC
           join ROOM_PERIOD$PMS rp on rp.ID_ROOM_PERIOD = rc.ID_ROOM_PERIOD
           join ROOMS R on r.ID_ROOM = rp.ID_ROOM
    where  Rc.ID_ROOM_CONTRACT = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'CURRENCY') then begin
    select c.CURR, c.ID_HOTEL
    from   CURR_RATES c
    where  c.ID_CURR_RATE = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'HOTEL') then begin
    select H.HOTEL_NAME, H.ID_HOTEL
    from   HOTEL H
    where  H.ID_HOTEL = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'SAFE') then begin
    select c.SAFE_NAME, c.ID_HOTEL
    from   SAFES c
    where  c.ID_SAFE = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'ACTIVITY_OFFER') then begin
    select ao.id_activity_offer, ao.id_hotel
    from   ACTIVITY_OFFER AO
    where  AO.ID_ACTIVITY_OFFER = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'RATE') then begin
    select t.TARIFA_NAME, t.ID_HOTEL
    from   TARIFA T
    where  T.ID_TARIFA = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'PHONE_LINES') then begin
    select pl.LINE, pl.ID_HOTEL
    from   PHONE_LINE_CONVERT PL
    where  PL.ID = :OBJECT_ID
    into   :object_description, :id_hotel;
  end else if (:OBJECT_CLASS = 'DAY_END_WORK') then begin
    select ew.ID_END_WORK, ew.ID_HOTEL
    from END_WORKS ew
    where ew.ID_END_WORK = :OBJECT_ID
    into   :object_description, :id_hotel;
  end

  if (:OBJECT_DESCRIPTION is null) then begin
    select SLD.DESCRIPTION, sld.HOTEL_CODE
    from   SYSTEM_LOG_DELETED SLD
    where  SLD.LOG_OBJECT_CLASS = :OBJECT_CLASS
           and SLD.LOG_OBJECT_ID = :OBJECT_ID
    into   :OBJECT_DESCRIPTION, :HOTEL_CODE;
  end

  if (:id_hotel is not null) then
    select H.CODE
    from   HOTEL H
    where  H.ID_HOTEL = :id_hotel
    into   :hotel_code;

  suspend;
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_PARAMS$INT for: TARIFA_GET_PARAM */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TARIFA_GET_PARAM) */
ALTER PROCEDURE TARIFA_GET_PARAM(ID_PARAM INTEGER,
FOR_DATE DATE,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER)
 RETURNS(OUT_VALUE VARCHAR(255))
 AS
declare variable is_interface integer;
  declare variable param_code varchar(30);
  declare variable is_value integer;
  declare variable int1 integer;
  declare variable data_type varchar(10);
  declare variable pvalue varchar(20);
  declare variable from_ date;
  declare variable to_ date;
begin
  select TP.IS_INTERFACE, TP.PARAM_CODE, TP.IS_VALUE, TP.DATA_TYPE, TP.PVALUE
  from   TARIFA_PARAMS TP
  where  ID_TARIFA_PARAM = :ID_PARAM 
  into   :is_interface, :param_code, :is_value, :data_type, :pvalue;
  /*get interface params*/
  if (:PARAM_CODE = 'NATION2') then
    PARAM_CODE = 'NATION'; /* !!!!!!!!!! */

  /*get value params*/
  if (:IS_VALUE = 1) then
    OUT_VALUE = :pvalue;

  /*get internal params*/
  OUT_VALUE = null;
  if (:IS_INTERFACE = 0) then begin
    if (:PARAM_CODE = 'TODAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE, 'D;dd/mm/yyyy');

    end else if (:PARAM_CODE = 'WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE, 'DW;MON');

    end else if (:PARAM_CODE = 'NEXT_DATE_WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE + 1, 'DW;MON');

    end else if (:PARAM_CODE = 'PREV_DATE_WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE - 1, 'DW;MON');

    end else if (:PARAM_CODE = 'REQUIRED_WEEK_DAYS') then begin
      select ti.FROM_DATE, ti.TO_DATE - 1
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :from_, :to_;
      
      select list(formatdate(RLP.OUT_DATE, 'DW;MON'))
      from   SYSTEM_LOOP_PERIOD(:from_, :to_) RLP
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'ARRIVAL_WEEK_DAYS') then begin
      select formatdate(ti.FROM_DATE, 'DW;MON')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'PRESTOI') then begin
      select cast(ti.TO_DATE - ti.FROM_DATE as integer)
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'FROM_DATE') then begin
      select formatdate(ti.FROM_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TO_DATE') then begin
      select formatdate(ti.TO_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'FIRST_NIGHT') then begin
      select formatdate(ti.FROM_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'LAST_NIGHT') then begin
      select formatdate(ti.TO_DATE - 1, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'DAYS_PASSED') then begin
       /* 01  03 -  01-1, 02-2   (        )*/   
       select cast((:FOR_DATE - G.FROM_DATE + 1) as integer)
       from   TAR_CALC_INPUT$TMP G
       where  G.ID_TAR_INPUT = :ID_TAR_INPUT
       into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'DAYS_TO_STAY') then begin
       /* 01  03 -  01-2, 02-1    (  )*/
       select cast((G.TO_DATE - :FOR_DATE - 1) as integer)
       from   TAR_CALC_INPUT$TMP G
       where  G.ID_TAR_INPUT = :ID_TAR_INPUT
       into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_GUESTS') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_CHILDREN') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.IS_CHILD = 1
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_ADULTS') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.IS_CHILD is distinct from 1
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_GUESTS_BY_ACCOUNT') then begin
      select (select count(*)
              from   GUEST G
                     join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
              where  G.ID_BASE_ACCOUNT = ti.ID_BASE_ACCOUNT
                     and G.FROM_DATE <= :FOR_DATE
                     and G.TO_DATE > :FOR_DATE
                     and RD.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP ti
      where  ti.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TYPE_ROOM') then begin
      select trim(rt.TYPE_ROOM)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join ROOM_TYPES RT on RT.ID_ROOM_TYPE = tid.ID_ROOM_TYPE
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
      into   :OUT_VALUE;
      /* TO PRESEVE COMPATIBILITY WITH OLD TARIFF VERSIONS */
      /* WE HAVE TO RETURN THE NAME NOT THE ID !           */

    end else if (:PARAM_CODE = 'TYPE_STAY') then begin
      select trim(ts.TYPE_STAY)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join TYPE_STAY TS on ts.ID_TYPE_STAY = tid.ID_TYPE_STAY
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TYPE_HRANA') then  begin
      select trim(m.NAME)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join MEALS m on m.ID_BOARD = tid.ID_BOARD
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;
      OUT_VALUE = trim(coalesce(:OUT_VALUE, ''));

    end else if (:PARAM_CODE = 'PACK_ITEMS') then begin
      OUT_VALUE = null;
      select TID.PACKET_ITEMS
      from   TAR_CALC_INPUT$TMP TID
      where  TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;
      OUT_VALUE = coalesce(:OUT_VALUE, '~~');
      -- strfloateval('POS("~2~", :PACK_ITEMS)>0', ';:PACK_ITEMS,STRING,~2~3~D~')

    end else if (:PARAM_CODE = 'AGE') then begin
      select ti.GUEST_AGE
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_SEX') then begin
      select G.GUEST_SEX
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE ;
      if ((:OUT_VALUE is null) or (:OUT_VALUE = '')) then OUT_VALUE = '-' ;

    end else if (:PARAM_CODE = 'NATION') then begin
      select tid.COUNTRY_CODE
      from   TAR_CALC_INPUT$TMP TID
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_FIRST_DATE') then begin
      select cast(iif(G.FROM_DATE = :FOR_DATE, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_LAST_DATE') then begin
      select cast(iif(G.TO_DATE -1 = :FOR_DATE, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_LATE_CHECKOUT') then begin
      select g.IS_LATE_CHECKOUT
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_FIRST_GUEST_IN_ROOM') then begin
      select (select count(ti.ID_TAR_INPUT)
              from   TAR_CALC_INPUT$TMP ti
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and ti.ID_GUEST < t.ID_GUEST)
      from   TAR_CALC_INPUT$TMP t
      where  t.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :int1;

      if (:int1 = 0) then OUT_VALUE = 1; else OUT_VALUE = 0;
      
    end else if (:PARAM_CODE = 'IS_DIFER_NATIONS') then begin
      select (select cast(iif(count(distinct ti.COUNTRY_CODE) > 1, 1, 0) as integer)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_GROUP') then begin
      select cast(iif(g.ID_GROUP is not null, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_NIGHTS_BY_ACCOUNT') then begin
      /*          . */
      select (select cast(sum (G_IN_R.TO_DATE - G_IN_R.FROM_DATE) as integer)
              from   GUEST G_IN_R
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_R.ID_RESERV_DETAIL
              where  G_IN_R.ID_BASE_ACCOUNT = G.ID_BASE_ACCOUNT
                     and G_IN_R.CHECK_STATUS = 0
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_INTURN_BYACCOUNT') then begin
      select (select cast(count(G.ID_GUEST) as integer)
              from   GUEST G
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL and rd.IS_ANUL = 0
              where  G.ID_BASE_ACCOUNT = t.ID_BASE_ACCOUNT
                     and G.ID_GUEST <= t.ID_GUEST)
      from   TAR_CALC_INPUT$TMP t
      where  t.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'PAX_PRICE_WO_ADDINS') then begin
      /*             */
      /* PRICE_ORIG          */
      -- ?????    ???
      /*select  max(AP.PRICE_ORIG)
      from    ACCOUNT_POST AP 
      where   AP.ID_GUEST = :ID_GUEST
              and AP.DATE_POST = :FOR_DATE
              and AP.IS_BASE = 1
      plan    (AP index (ACCOUNT_POST_IDX6))
      into    :OUT_VALUE;
      */
      OUT_VALUE = null;

    end else if (:PARAM_CODE = 'ROOM_FEATURES') then begin
      select substring(R.FEATURES from 1 for 255)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join ROOMS R on r.ID_ROOM = tid.ID_ROOM
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_NIGHTS') then begin
      select (select cast(sum (G_IN_V.TO_DATE - G_IN_V.FROM_DATE) as integer)
              from   GUEST G_IN_V
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_V.ID_RESERV_DETAIL
              where  rd.ID_AGENT_PROFILE is not distinct from G.ID_AGENT_PROFILE
                     and G_IN_V.VAUCHER_NUM = G.VOUCHER_NUM
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE ;

    end else if (:PARAM_CODE = 'VAUCHER_GUESTS') then begin
      select (select count (G_IN_V.ID_GUEST)
              from   GUEST G_IN_V
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_V.ID_RESERV_DETAIL and rd.IS_ANUL = 0
              where  rd.ID_AGENT_PROFILE is not distinct from G.ID_AGENT_PROFILE
                     and G_IN_V.VAUCHER_NUM = G.VOUCHER_NUM
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_DATE') then begin
      select formatdate(G.VOUCHER_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_TEXT') then begin
      select G.VOUCHER_TEXT
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_INTURN_BYROOM') then begin
      select (select count(*) + 1
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ((t.IS_CHILD = 0 and ti.IS_CHILD = 0 and td.CHECKIN_ORDER < tid.CHECKIN_ORDER)
                          or (t.IS_CHILD = 1 and ((ti.IS_CHILD = 0) or (ti.GUEST_AGE > t.GUEST_AGE) or (ti.GUEST_AGE = t.GUEST_AGE and td.CHECKIN_ORDER < tid.CHECKIN_ORDER) )))
              )
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'ADULT_INTURN_BYROOM') then begin
      OUT_VALUE = 0;
      select (select count(*) + 1
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and td.CHECKIN_ORDER < tid.CHECKIN_ORDER
                     and ti.IS_CHILD = 0)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
             and t.IS_CHILD = 0
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'CHILD_INTURN_BYROOM') then begin
      OUT_VALUE = 0;
      select (select count(*) + 1
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ( (ti.GUEST_AGE > t.GUEST_AGE) or (ti.GUEST_AGE = t.GUEST_AGE and td.CHECKIN_ORDER < tid.CHECKIN_ORDER) )
                     and ti.IS_CHILD = 1)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
             and t.IS_CHILD = 1
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_TYPE') then begin
      select G.ID_GUEST_TYPE
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TO_AGENT') then begin
      select G.ID_AGENT_PROFILE
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else begin
      exception RATING_EXCEPTION 'Unsupported param - '||:PARAM_CODE;
    end

  end /*PART OF INTERNAL PARAMS*/


  /**********************************************/
  begin
    /* the source of the next check is gone with the wind
    /* but we must distinguish different data types */
    if ((:OUT_VALUE is null) or (:OUT_VALUE = '')) then begin
      /*not allow nulls*/
      if (:DATA_TYPE = 'DATE') then OUT_VALUE = '01/01/1899';
      else OUT_VALUE = '-1';  -- Unspecified
    end else if (:DATA_TYPE = 'INTEGER') then begin
      OUT_VALUE = cast(:OUT_VALUE as integer);
      /* to prevent errors like OUT_VALUE = '00001' */
    end

    when any do exception RATING_EXCEPTION 'Unsupported param value: ' || :param_code || ' = "' || coalesce(:OUT_VALUE, '<null>') || '"';
  end
  /**********************************************/
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_BOOKING$EXC for: UPDATE_BOOKING$EXC */
ALTER PROCEDURE IMPORT_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(250),
MAINTANCE_SHEMA VARCHAR(30),
POSTING_ROUTING VARCHAR(20),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
COMPLIMENTARY_ACCOUNT VARCHAR(50),
EATING_OBJECT VARCHAR(50),
CREATE_DATETIME TIMESTAMP,
CHECK_OUT_KIND SMALLINT,
EARLYCHECKOUT_DATE DATE)
 RETURNS(HOTEL_ID INTEGER,
BOOKING_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (UPDATE_BOOKING$EXC) */
ALTER PROCEDURE UPDATE_BOOKING$EXC(BOOKING_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE INTEGER,
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA_ID INTEGER,
POSTING_ROUTING VARCHAR(20),
ID_AGENT_ACCOUNT INTEGER,
RATE_ID INTEGER,
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD_CODE TFOOD_CODE,
ARRANGER_PROFILE_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable hotel_id integer;
  declare variable warn_code integer;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable rd_dbkey char(8);
  declare variable current_status_code smallint;
BEGIN
  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => START(' || :booking_id || ')');

  select RD.RDB$DB_KEY, RD.ID_HOTEL, RD.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :booking_id
  into  :rd_dbkey, :hotel_id, :current_status_code;

  execute procedure update_posting_transaction$exc(:rd_dbkey, :posting_transaction_uuid, 0);

  /* lock all guests */
  update guest set ORPHANED_IMPORT$EXC=1 where id_reserv_detail=:booking_id;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_GUARANTEE$RSV');
  execute procedure RES_SAVE_GUARANTEE$RSV(
    :booking_id, :is_vip, :current_status_code, :id_guarantee_policy,
    :deposit_required, :deposit_required_currency, :block_cc,
    :guarantee_deposit_percent, :guarantee_deposit_nights, :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_STAY$RSV');
  execute procedure RES_SAVE_STAY$RSV(
    :booking_id, :arrival, :departure, :is_late_departure,
    :arrival_type, 0
  ) returning_values :share_err_code, :err_text, :share_transaction_id, :warn_code;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_BOARD$INT');
  execute procedure RES_SAVE_BOARD$INT(
    :rd_dbkey, :board_id
  ) ;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_OTHER$RSV');
  execute procedure RES_SAVE_OTHER$RSV(
    :booking_id, :transfer_in_time, :transfer_in_note,
    :transfer_out_time, transfer_out_note, :first_food_code
  ) ;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_ROOM$EXC(room_type_id=>' || coalesce(:room_type_id, '<null>') || ')');
  execute procedure RES_SAVE_ROOM$EXC(
    :rd_dbkey, :room_type_id, :maintance_shema_id, :room_preferences, :special_treatment, :split_on_checkin
  ) returning_values :err_text, :warn_code, :share_transaction_id, :share_err_code;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_MARKETING$RSV');
  execute procedure RES_SAVE_MARKETING$RSV(
    :booking_id, :marketing1_id, :marketing2_id, :marketing3_id, :marketing4_id, :marketing5_id
  ) returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_RATE$RSV(:rate_id=>'
  || coalesce(:rate_id, '<null>')
  || ', :booking_id=>' || coalesce(:booking_id, '<null>')
  || ', :manual_price=>' || coalesce(:manual_price, '<null>')
  || ', :manual_price_currency=>' || coalesce(:manual_price_currency, '<null>')
  || ', :is_different_rate=>' || coalesce(:is_different_rate, '<null>')
  || ')');
  execute procedure RES_SAVE_RATE$RSV(
    :booking_id, :rate_id, :manual_price, :manual_price_currency,
    :is_different_rate, :is_different_price, 0
  );

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_VOUCHER$RSV');
  execute procedure RES_SAVE_VOUCHER$RSV(
    :booking_id, :voucher, :voucher_date, :voucher_text, null,  null
  );

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_NOTE$RSV');
  execute procedure RES_SAVE_NOTE$RSV(
    :booking_id, :note, :note_reminders);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_ACCOUNTING$RSV(arranger_profile_id=>'
    || coalesce(:arranger_profile_id, '<null>')
    || ', posting_routing=>' || coalesce(:posting_routing, '<null>')
    || ', id_agent_account=>' || coalesce(:id_agent_account, '<null>')
    || ')');
  execute procedure RES_SAVE_ACCOUNTING$INT(
    :rd_dbkey, :arranger_profile_id,
    :id_agent_account,
    :posting_routing,
    :guest_payment_type_id,
    :arranger_payment_type_id,
    :reserv_group_id
  ) ;

  /*execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_PACKET$RSV');
  execute procedure RES_SAVE_PACKET$RSV(
    :booking_id, :packet_id, 0
  );
  */
  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_EATING_OBJECT$RSV');
  execute procedure RES_SAVE_EATING_OBJECT$RSV(:booking_id, :id_eating_object);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => END(' || :booking_id || ')');
END
^

/* Restore proc. body: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER,
IS_MANUAL_TRANSFER TYPE OF TLOGICAL = 1)
 AS
declare variable id_current_account integer;
  declare variable id_service integer;
  declare variable is_anul integer;
  declare variable id_tariff integer;
  declare variable qty_post numeric(15,2);
  declare variable qty_free numeric(15,2);
  declare variable price_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable id_room integer;
  declare variable id_base_doc integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  if ((:AP_DBKEY is null) or (:id_target_account is null) or (:id_target_account < 0)) then
     exception POSTING_TRANSFER_EXCEPTION '-31';

  select AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST, AP.QTY_FREE,
         AP.PRICE_ORIG, AP.CURR_ORIG, AP.RATE_ORIG, ap.from_date, ap.to_date,
         AP.IS_ANUL, AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_BASE_DOC, A.ID_HOTEL
  from   ACCOUNT_POST AP
         left join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :id_service, :id_tariff, :id_room, :qty_post, :qty_free,
         :price_orig, :curr_orig, :rate_orig, :from_date, :to_date,
         :is_anul, :id_account_post, :id_current_account, :id_base_doc, :id_hotel;

  if (:id_current_account = :id_target_account) then EXIT;

  if (:is_anul = 1 ) then exception POSTING_TRANSFER_EXCEPTION '-33';

  if (:id_base_doc is not null) then exception POSTING_TRANSFER_EXCEPTION '-32';

  if (not exists(select A.ID_ACCOUNT
                 from   ACCOUNT A
                 where  A.ID_ACCOUNT = :ID_TARGET_ACCOUNT
                        and A.ID_HOTEL = :id_hotel)) then exception POSTING_TRANSFER_EXCEPTION '-376';

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
                    :id_tariff, :id_room, :qty_post, :qty_free, :price_orig, :curr_orig,
                    :rate_orig, 'TRANSFER_POSTING', null, :from_date, :to_date,
                    iif(:IS_MANUAL_TRANSFER is distinct from 1, 1, 0), :id_target_account)
  returning_values  :no_use, :no_use, :no_use;

  insert into ACCOUNT_TRANSFER_HISTORY(ID_ACCOUNT_POST, FROM_ID_ACCOUNT, TO_ID_ACCOUNT)
  values (:id_account_post, :id_current_account, :id_target_account);
end
^

/* Restore proc. body: ACCOUNT_POSTING_UPDATE */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable in_db_key char(8);
begin
  /* GUI facade for manual update */
  select AP.ID_ACCOUNT, AP.ID_GUEST, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :id_guest, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date)
  returning_values  (:new_qty_post, :new_price_post, :new_ac);

  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    if (coalesce(:id_guest, 0) > 0) then begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || :id_account
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || replace(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'POST_UPDATE', :action_text);
    end else begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || replace(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
    end
  end

end
^

/* Restore proc. body: AVAILABILITY_OCCUPANCY$EXC */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$EXC(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
RELEASE_DATES INTEGER,
OVERBOOK INTEGER,
RES_CONFIRMED INTEGER,
RES_NOTCONFIRMED INTEGER,
RES_WAITING INTEGER,
BOOKING_POSITIONS INTEGER,
CONTINGENT INTEGER)
 RETURNS(ID_ROOM_TYPE INTEGER,
OUT_FROM_DATE DATE,
OUT_TO_DATE DATE,
ROOMS_AVAILABLE INTEGER)
 AS
declare variable tmp_date date;
  declare variable tmp_room_type integer;
  declare variable tmp_rooms_available integer;
begin
  execute procedure AVAILABILITY_OCCUP_PREPARE$AVL (
          :FROM_DATE,
          :TO_DATE,
          0,
          :RELEASE_DATES,
          :OVERBOOK,
          :RES_CONFIRMED,
          :RES_NOTCONFIRMED,
          :RES_WAITING,
          :BOOKING_POSITIONS,
          :CONTINGENT,
          :ID_HOTEL);

  ID_ROOM_TYPE = null;
  OUT_FROM_DATE = null;
  OUT_TO_DATE = null;
  for
    select SO.ID_ROOM_TYPE,
           SO.FOR_DATE,
           sum(so.AVAILABLE)
    from   SMART_OCCUP$TMP SO
    group by 1, 2
    into   :tmp_room_type, :tmp_date, :tmp_rooms_available
  do begin
    if (:ID_ROOM_TYPE is null) then begin -- first record
      ID_ROOM_TYPE = :tmp_room_type;
      ROOMS_AVAILABLE = :tmp_rooms_available;
      OUT_FROM_DATE = :tmp_date;
      OUT_TO_DATE = :tmp_date;
    end

    if ((:tmp_room_type <> :ID_ROOM_TYPE) or (:tmp_rooms_available <> :ROOMS_AVAILABLE) ) then begin
      suspend;
      ID_ROOM_TYPE = :tmp_room_type;
      OUT_FROM_DATE = :tmp_date;
      OUT_TO_DATE = :tmp_date;
      ROOMS_AVAILABLE = :tmp_rooms_available;
    end else begin
      OUT_TO_DATE = :tmp_date;
    end
  end
  if (:ID_ROOM_TYPE is not null) then suspend;
end
^

/* Restore proc. body: EAI_EXT_POST_TO_MH_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  if (:CODE_TYPE = 'EXT_CODE') then begin
    execute procedure EAI_MAP_SERVICE(:SERVICE_CODE, :SERVICE_CODE, 'UNKNOWN', :id_hotel)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_SERVICE;
    if (:ERR_CODE < 0) then exit;
  end else begin
    select S.ID_SERVICE
    from   SERVICES S
    where  S.ID_SERVICE = :SERVICE_CODE
           and s.ID_HOTEL = :ID_HOTEL
    into   :ID_SERVICE;
    if (:ID_SERVICE is null) then begin
      ERR_CODE = -85;   /* Wrong value! */
      exit;
    end
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:ID_ACCOUNT_POST, :SERVICE_CODE, null, null);

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Restore proc. body: EAI_EXT_SERVICE_POST */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable max_id_service integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_ROOM  = null;
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  select min(S.ID_SERVICE) as id_service, max(s.id_service) as max_id_service
  from   SERVICES S
  where  S.EXT_CODE = :SERVICE_EXT_CODE
         and s.IS_BASE = 0
         and s.IS_DELETED = 0
  into   :ID_SERVICE, :max_id_service;
  if (:ID_SERVICE is null) then begin
      ERR_CODE = -388;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end else if (:ID_SERVICE <> :max_id_service) then begin
      ERR_CODE = -389;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_EXT_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:ID_ACCOUNT_POST, :SERVICE_EXT_CODE, null, null);

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Restore proc. body: EAI_POS_POSTING_ADD$P2E */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
declare variable id_service integer;
  declare variable my_post_text varchar(255);
  declare variable my_resource_text varchar(255);
  declare variable nation_curr varchar(3);
  declare variable post_short_code varchar(10);
  declare variable id_hotel integer;
  declare variable id_account_post integer;
begin
  /* in_on_guest = 0 (account), 1 (guest), -1 (ew)
  */
  if (:IN_ON_GUEST = 1) then begin
    select rd.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :IN_ID_GUEST
    into   :id_hotel;
  end else begin
    select a.ID_HOTEL
    from   account a
    where  a.ID_ACCOUNT = :in_id_account
    into   :id_hotel;
  end

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :nation_curr;

  if ('END_WORK' = :in_smetka_num) then begin
    post_short_code='POS_EW';
  end else begin
    post_short_code='POS';
  end

  /* FIND SERVICE */
  execute procedure EAI_MAP_SERVICE(:in_service_tag, :in_service_name, 'POS', :id_hotel)
  returning_values  :err_code, :err_text, :id_service;
  if (:err_code < 0) then exit;

  my_post_text = 'date:'|| formatdate(:in_date_smetka, 'D;dd.mm.yyyy') ||
                 ' num:'|| :in_smetka_num ||
                 ' obj:'|| :in_obj_name ||
                 ' tbl:'|| :in_table ||
                 ' site:'|| :in_site;

  my_resource_text = 'POS_ID_SMETKA:'||:in_id_smetka;
  my_post_text = substring(:my_post_text from 1 for 100);
  my_resource_text = substring(:my_resource_text from 1 for 49);

  if (:in_on_guest = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:in_id_guest, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code, '')
    returning_values  :err_code, :err_text, :out_id_account, :id_account_post;
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:in_id_account, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code)
    returning_values  :err_code, :err_text, :id_account_post;
    out_id_account = :in_id_account;
  end
  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:id_account_post, :post_short_code, :IN_POS_USER, :IN_DATETIME);
end
^

/* Restore proc. body: EAI_TELECOUNT_TRANSFER */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* Restore proc. body: EXT_RC_PORTAL_MAP_MODIFY */
ALTER PROCEDURE EXT_RC_PORTAL_MAP_MODIFY(ID_ROOM_CLOUD_PORTAL_MAP INTEGER,
ID_HOTEL INTEGER,
ID_PROFILE INTEGER,
POSTING_ROUTING VARCHAR(10),
BOOKING_PREFIX VARCHAR(10),
ROOM_CLOUD_PORTAL_ID VARCHAR(10),
ROOM_CLOUD_PORTAL_NAME VARCHAR(100),
OPERATION VARCHAR(5))
 RETURNS(NEW_ID_ROOM_CLOUD_PORTAL_MAP INTEGER)
 AS
begin
  NEW_ID_ROOM_CLOUD_PORTAL_MAP = null;
  if (OPERATION = 'set') then begin
    NEW_ID_ROOM_CLOUD_PORTAL_MAP = ID_ROOM_CLOUD_PORTAL_MAP;
    if (NEW_ID_ROOM_CLOUD_PORTAL_MAP is null) then begin
      NEW_ID_ROOM_CLOUD_PORTAL_MAP = gen_id(GEN_ID_ROOM_CLOUD_PORTAL_MAP, 1);
      insert into EXT_ROOM_CLOUD_PORTAL_MAP(ID_ROOM_CLOUD_PORTAL_MAP, ID_HOTEL, ID_PROFILE, POSTING_ROUTING, BOOKING_PREFIX, ROOM_CLOUD_PORTAL_ID, ROOM_CLOUD_PORTAL_NAME)
      values (:NEW_ID_ROOM_CLOUD_PORTAL_MAP, :ID_HOTEL, :ID_PROFILE, :POSTING_ROUTING, :BOOKING_PREFIX, :ROOM_CLOUD_PORTAL_ID, :ROOM_CLOUD_PORTAL_NAME);
    end else begin
      update EXT_ROOM_CLOUD_PORTAL_MAP map
      set map.ID_PROFILE = :ID_PROFILE,
          map.POSTING_ROUTING = :POSTING_ROUTING,
          map.BOOKING_PREFIX = :BOOKING_PREFIX,
          map.ROOM_CLOUD_PORTAL_ID = :ROOM_CLOUD_PORTAL_ID,
          map.ROOM_CLOUD_PORTAL_NAME = :ROOM_CLOUD_PORTAL_NAME
      where map.ID_ROOM_CLOUD_PORTAL_MAP = :ID_ROOM_CLOUD_PORTAL_MAP;
    end
  end else if (OPERATION = 'del') then begin
    delete from EXT_ROOM_CLOUD_PORTAL_MAP map
    where map.ID_ROOM_CLOUD_PORTAL_MAP = :ID_ROOM_CLOUD_PORTAL_MAP;
  end else if (OPERATION = 'clear') then begin
    delete from EXT_ROOM_CLOUD_PORTAL_MAP map
    where map.ID_HOTEL = :ID_HOTEL;
  end
  suspend;
end
^

/* Restore proc. body: EXT_ROOM_CL_PORTAL_MAP_MODIFY */
ALTER PROCEDURE EXT_ROOM_CL_PORTAL_MAP_MODIFY(ID_ROOM_CLOUD_PORTAL_MAP INTEGER,
ID_HOTEL INTEGER,
ID_PROFILE INTEGER,
POSTING_ROUTING VARCHAR(10),
BOOKING_PREFIX VARCHAR(10),
ROOM_CLOUD_PORTAL_ID VARCHAR(10),
ROOM_CLOUD_PORTAL_NAME VARCHAR(100),
OPERATION VARCHAR(5))
 AS
begin
  if (OPERATION = 'set') then begin
    if (ID_ROOM_CLOUD_PORTAL_MAP is null) then begin
      insert into EXT_ROOM_CLOUD_PORTAL_MAP(ID_HOTEL, ID_PROFILE, POSTING_ROUTING, BOOKING_PREFIX, ROOM_CLOUD_PORTAL_ID, ROOM_CLOUD_PORTAL_NAME)
      values (:ID_HOTEL, :ID_PROFILE, :POSTING_ROUTING, :BOOKING_PREFIX, :ROOM_CLOUD_PORTAL_ID, :ROOM_CLOUD_PORTAL_NAME);
    end else begin
      update EXT_ROOM_CLOUD_PORTAL_MAP map
      set map.ID_PROFILE = :ID_PROFILE,
          map.POSTING_ROUTING = :POSTING_ROUTING,
          map.BOOKING_PREFIX = :BOOKING_PREFIX,
          map.ROOM_CLOUD_PORTAL_ID = :ROOM_CLOUD_PORTAL_ID,
          map.ROOM_CLOUD_PORTAL_NAME = :ROOM_CLOUD_PORTAL_NAME
      where map.ID_ROOM_CLOUD_PORTAL_MAP = :ID_ROOM_CLOUD_PORTAL_MAP;
    end
  end else if (OPERATION = 'del') then begin
    if (ID_ROOM_CLOUD_PORTAL_MAP is not null) then begin
      delete from EXT_ROOM_CLOUD_PORTAL_MAP map
      where map.ID_ROOM_CLOUD_PORTAL_MAP = :ID_ROOM_CLOUD_PORTAL_MAP;
    end
  end else if (OPERATION = 'clear') then begin
    delete from EXT_ROOM_CLOUD_PORTAL_MAP map
    where map.ID_HOTEL = :ID_HOTEL;
  end
end
^

/* Restore proc. body: EXT_ROOM_CLOUD_HOTEL_MAP_MODIFY */
ALTER PROCEDURE EXT_ROOM_CLOUD_HOTEL_MAP_MODIFY(ID_HOTEL INTEGER,
ROOM_CLOUD_HOTEL VARCHAR(10),
ENDPOINT VARCHAR(200),
USER_NAME VARCHAR(30),
"PASSWORD" VARCHAR(50),
IS_ACTIVE SMALLINT,
IS_SCHEDULED SMALLINT,
OPERATION VARCHAR(10))
 AS
declare variable ID_ROOM_CLOUD_ROOM_MAP integer;
begin
  if (OPERATION = 'set') then begin
    update or insert into EXT_ROOM_CLOUD_HOTEL_MAP (ID_HOTEL, ENDPOINT, ROOM_CLOUD_HOTEL, USER_NAME, "PASSWORD", IS_ACTIVE, IS_SCHEDULED)
    values (:ID_HOTEL, :ENDPOINT, :ROOM_CLOUD_HOTEL, :USER_NAME, :"PASSWORD", :IS_ACTIVE, :IS_SCHEDULED) matching (ID_HOTEL);
  end else if (OPERATION = 'del') then begin
    delete from EXT_ROOM_CLOUD_HOTEL_MAP
      where ID_HOTEL = :ID_HOTEL;
    execute procedure EXT_ROOM_CLOUD_ROOM_MAP_MODIFY(null, :ID_HOTEL, null, null, null, 'clear')
      returning_values :ID_ROOM_CLOUD_ROOM_MAP;
    execute procedure EXT_ROOM_CL_PORTAL_MAP_MODIFY(null, :ID_HOTEL, null, null, null, null, null, 'clear');
  end
end
^

/* Restore proc. body: EXT_ROOM_CLOUD_RATE_MAP_MODIFY */
ALTER PROCEDURE EXT_ROOM_CLOUD_RATE_MAP_MODIFY(ID_ROOM_CLOUD_RATE_MAP INTEGER,
ID_ROOM_CLOUD_ROOM_MAP INTEGER,
ID_RATE INTEGER,
ID_BOARD INTEGER,
ROOM_CLOUD_RATE_ID VARCHAR(10),
ROOM_CLOUD_RATE_NAME VARCHAR(100),
OPERATION VARCHAR(5))
 AS
begin
  if (OPERATION = 'set') then begin
    if (ID_ROOM_CLOUD_RATE_MAP is null) then begin
      insert into EXT_ROOM_CLOUD_RATE_MAP(ID_ROOM_CLOUD_ROOM_MAP, ID_RATE, ID_BOARD,
        ROOM_CLOUD_RATE_ID, ROOM_CLOUD_RATE_NAME)
      values (:ID_ROOM_CLOUD_ROOM_MAP, :ID_RATE, :ID_BOARD,
        :ROOM_CLOUD_RATE_ID, :ROOM_CLOUD_RATE_NAME);
    end else begin
      update EXT_ROOM_CLOUD_RATE_MAP map
      set map.ID_ROOM_CLOUD_ROOM_MAP = :ID_ROOM_CLOUD_ROOM_MAP,
          map.ID_RATE = :ID_RATE,
          map.ID_BOARD = :ID_BOARD,
          map.ROOM_CLOUD_RATE_ID = :ROOM_CLOUD_RATE_ID,
          map.ROOM_CLOUD_RATE_NAME = :ROOM_CLOUD_RATE_NAME
      where map.ID_ROOM_CLOUD_RATE_MAP = :ID_ROOM_CLOUD_RATE_MAP;
    end
  end else if (OPERATION = 'del') then begin
    if (ID_ROOM_CLOUD_RATE_MAP is not null) then begin
      delete from EXT_ROOM_CLOUD_RATE_MAP map
      where map.ID_ROOM_CLOUD_RATE_MAP = :ID_ROOM_CLOUD_RATE_MAP;
    end
  end
end
^

/* Restore proc. body: EXT_ROOM_CLOUD_ROOM_MAP_MODIFY */
ALTER PROCEDURE EXT_ROOM_CLOUD_ROOM_MAP_MODIFY(ID_ROOM_CLOUD_ROOM_MAP INTEGER,
ID_HOTEL INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_CLOUD_ROOM_ID VARCHAR(10),
ROOM_CLOUD_ROOM_NAME VARCHAR(100),
OPERATION VARCHAR(5))
 RETURNS(NEW_ID_ROOM_CLOUD_ROOM_MAP INTEGER)
 AS
begin
  if (OPERATION = 'set') then begin
    NEW_ID_ROOM_CLOUD_ROOM_MAP = ID_ROOM_CLOUD_ROOM_MAP;
    if (ID_ROOM_CLOUD_ROOM_MAP is null) then begin
      NEW_ID_ROOM_CLOUD_ROOM_MAP = gen_id(GEN_ID_ROOM_CLOUD_ROOM_MAP, 1);
      insert into EXT_ROOM_CLOUD_ROOM_MAP(ID_ROOM_CLOUD_ROOM_MAP, ID_HOTEL, ID_ROOM_TYPE, ROOM_CLOUD_ROOM_ID, ROOM_CLOUD_ROOM_NAME)
      values (:NEW_ID_ROOM_CLOUD_ROOM_MAP, :ID_HOTEL, :ID_ROOM_TYPE, :ROOM_CLOUD_ROOM_ID, :ROOM_CLOUD_ROOM_NAME);
    end else begin
      update EXT_ROOM_CLOUD_ROOM_MAP map
      set map.ID_ROOM_TYPE = :ID_ROOM_TYPE,
          map.ROOM_CLOUD_ROOM_ID = :ROOM_CLOUD_ROOM_ID,
          map.ROOM_CLOUD_ROOM_NAME = :ROOM_CLOUD_ROOM_NAME
      where map.ID_ROOM_CLOUD_ROOM_MAP = :ID_ROOM_CLOUD_ROOM_MAP;
    end
  end else if (OPERATION = 'del') then begin
    if (ID_ROOM_CLOUD_ROOM_MAP is not null) then begin
      delete from EXT_ROOM_CLOUD_ROOM_MAP map
      where map.ID_ROOM_CLOUD_ROOM_MAP = :ID_ROOM_CLOUD_ROOM_MAP;
    end
  end else if (OPERATION = 'clear') then begin
    delete from EXT_ROOM_CLOUD_ROOM_MAP map
    where map.ID_HOTEL = :ID_HOTEL;
  end
  suspend;
end
^

/* Restore proc. body: IMPORT_BOOKING$EXC */
ALTER PROCEDURE IMPORT_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(250),
MAINTANCE_SHEMA VARCHAR(30),
POSTING_ROUTING VARCHAR(20),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
COMPLIMENTARY_ACCOUNT VARCHAR(50),
EATING_OBJECT VARCHAR(50),
CREATE_DATETIME TIMESTAMP,
CHECK_OUT_KIND SMALLINT,
EARLYCHECKOUT_DATE DATE)
 RETURNS(HOTEL_ID INTEGER,
BOOKING_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable current_hotel_id integer;
declare variable booking_update_id integer;
declare variable warn_code integer;
declare variable share_transaction_id integer;
declare variable share_err_code integer;
declare variable arranger_profile_id integer;
declare variable main_guest_profile_id integer;
declare variable rate_id integer;
declare variable room_type_id integer;
declare variable board_id integer;
declare variable maintance_shema_id integer;
declare variable arranger_payment_type_id integer;
declare variable guest_payment_type_id integer;
declare variable marketing_segment_id integer;
declare variable marketing_source_code_id integer;
declare variable marketing_channel_code_id integer;
declare variable marketing_hear_reason_id integer;
declare variable marketing_come_reason_id integer;
declare variable arranger_account_id integer;
declare variable packet_id integer;
declare variable id_guarantee_policy integer;
declare variable first_food_code tfood_code;
declare variable arrival_type_code smallint;
declare variable booking_dbkey char(8);
declare variable reserv_group_id integer;
declare variable id_complimentary_account integer;
declare variable id_eating_object integer;
declare variable default_guest_mask varchar(10);
declare variable id_person_data integer;
begin
  /*execute procedure sys_dbg('exc IMPORT_BOOKING$EXC('
  || 'hotel => ' || coalesce(:hotel, '<null>')
  || ', booking_number => ' || coalesce(:number, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  ||')');
  */
  execute procedure import_mark_transaction$exc;

  /* init */
  err_code = 0;
  err_text = '';
  booking_update_id = null;
  booking_dbkey = null;
  current_hotel_id = null;
  if (:voucher_date is not null) then begin
    voucher_date = striptime(:voucher_date);
  end
  posting_routing = upper(:posting_routing);

  /* detect inser/update mode */
  select b.id_reserv_detail, b.rdb$db_key, b.id_hotel
  from   reserv_detail b
  where  b.number=:number
         and b.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and b.id_log_event_annul is null
  into   :booking_update_id, :booking_dbkey, :current_hotel_id;

  if (:booking_update_id is null) then begin
    booking_id = gen_id (id_reserv_detail_gen, 1);
  end else begin
    booking_id = :booking_update_id;
  end

  /* text to id map */
  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => MAP_BOOKING_RELATIONS$EXC');
  execute procedure MAP_BOOKING_RELATIONS$EXC(
    :booking_id,
    :hotel,
    :room_type,
    :board,
    :maintance_shema,
    :rate,
    :arranger_payment_type,
    :guest_payment_type,
    :marketing_segment,
    :marketing_source_code,
    :marketing_channel_code,
    :marketing_hear_reason,
    :marketing_come_reason,
    :first_food,
    :arranger_profile_uuid,
    :arranger_profile_name,
    :main_guest_profile_uuid,
    :arrival_type,
    :guarantee_policy,
    :eating_object
  ) returning_values
    :arranger_profile_id,
    :main_guest_profile_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :hotel_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :first_food_code,
    :arrival_type_code,
    :id_guarantee_policy,
    :id_eating_object;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* hotel change test */
  if (coalesce(:current_hotel_id, :hotel_id) <> :hotel_id) then begin
    execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', null, :hotel, 'booking hotel changed');
  end

  id_complimentary_account = null;
  if (complimentary_account is not null) then begin
    execute procedure lookup_account$exc(:hotel_id, :complimentary_account, 'booking', :booking_id)
    returning_values :id_complimentary_account;
  end

  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => CREATE_PACK_INSTANCE$EXC');
  packet_id = null;
  /*execute procedure CREATE_PACK_INSTANCE$EXC(
    :hotel_id, :booking_id, :package
  )
  returning_values :packet_id, :err_code, :err_text;
  if (0 <> :err_code) then exit;
  */
  /* merge input and default/persistent database values */
  execute procedure DEFAULT_BOOKING_VALUES$EXC(
    :booking_dbkey, :hotel_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :group_name,
    :group_uuid,
    :is_late_departure,
    :id_eating_object
  ) returning_values
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :arranger_account_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :reserv_group_id,
    :is_late_departure,
    :id_eating_object,
    :default_guest_mask;

  if ('' = :board) then board_id = null; /* preserve "empty board" state and discard default value */

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC DEFAULTED => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* if the booking is complimentary use complimentary account */
  arranger_account_id = coalesce(:id_complimentary_account, :arranger_account_id);

  /* CREATE or UPDATE */
  if (:booking_update_id is not null) then begin
    /* UPDATE booking */
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => UPDATE_BOOKING$EXC');
    execute procedure UPDATE_BOOKING$EXC(
      :booking_id,
      :reserv_group_id,
      :is_vip,
      :arrival,
      :arrival_type_code,
      :departure,
      :is_late_departure,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :room_type_id,
      :board_id,
      :room_preferences,
      :special_treatment,
      :maintance_shema_id,
      :posting_routing,
      :arranger_account_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :deposit_required,
      :deposit_required_currency,
      :arranger_payment_type_id,
      :guest_payment_type_id,
      :voucher,
      :voucher_date,
      :voucher_text,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :note,
      :note_reminders,
      :first_food_code,
      :arranger_profile_id,
      :main_guest_profile_id,
      :is_different_rate,
      :is_different_price,
      :split_on_checkin,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object
    ) returning_values :err_code, :err_text;
    if (0 <> :err_code) then begin
      exit;
    end
  end else begin
    /* CREATE booking */
    if (:default_guest_mask is not null
        and :main_guest_profile_id is not null
        and not exists (select rd.ID_RESERV_DETAIL from reserv_detail rd where rd.ID_PERSON_PROFILE = :main_guest_profile_id)) then
    begin
      -- fill the mask with a default value if its is empty
      select p.id_person_data
      from   PROFILE_PERSON p
      where  p.ID_PROFILE = :main_guest_profile_id
      into   :id_person_data;

      update PERSON_DATA pd
      set    pd.MASK = :default_guest_mask
      where  pd.ID_PERSON_DATA = :id_person_data
             and pd.MASK is null;
    end
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => RES_CREATE_SET$EXC');
    execute procedure RES_CREATE_SET$EXC (
      :booking_id,
      :number,
      :arranger_profile_id,
      :main_guest_profile_id,
      :arrival,
      :departure,
      :adult_count,
      :children_count,
      :room_type_id,
      null,
      :board_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :voucher,
      :voucher_date,
      :voucher_text,
      null,
      null,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :arrival_type_code,
      :is_late_departure,
      :is_vip,
      :first_food_code,
      :special_treatment,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :arranger_account_id,
      :posting_routing,
      :guest_payment_type_id,
      :arranger_payment_type_id,
      null,
      :room_preferences,
      :maintance_shema_id,
      :note,
      :note_reminders,
      :deposit_required,
      :deposit_required_currency,
      :hotel_id,
      :reserv_group_id,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object,
      :create_datetime
      )
    returning_values :err_code, :err_text, :warn_code, :booking_id, :share_transaction_id, :share_err_code;
  end

  update reserv_detail rd
  set    rd.CHECK_OUT_KIND = :CHECK_OUT_KIND,
         rd.EARLYCHECKOUT_DATE = :EARLYCHECKOUT_DATE
  where  rd.ID_RESERV_DETAIL = :BOOKING_ID;

  execute procedure GUEST_STAY_INITIALIZE$INT (:booking_id);
  /* final error check */
  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;

  delete from PENDING_DEPOSIT d
  where  d.ID_RESERV_DETAIL = :BOOKING_ID;
end
^

/* Restore proc. body: PHONECALL_POST$TC */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Restore proc. body: PHONECALLS_POST_TO_ACCOUNT$TC */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* Restore proc. body: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_OWNER TYPE OF ID,
POST_DATE TYPE OF TDATE,
CURR_ORIG TYPE OF TCURRENCY,
VALUE_ORIG TYPE OF TPRICE,
POST_ON_PMS_ACCOUNT TYPE OF TLOGICAL,
IS_OWNER_INCOME TYPE OF TLOGICAL,
ID_ROOM TYPE OF ID_REF = null)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  if (:POST_ON_PMS_ACCOUNT = 1) then begin
    execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account, :id_owner,
            :CURR_ORIG, :VALUE_ORIG, :id_service, :is_owner_income, :POST_DATE)
    returning_values  (:new_id_account_post);
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :ID_SERVICE, 1, 0, 1,
            :VALUE_ORIG, :CURR_ORIG, current_date, current_date,
            '', '', :POST_DATE, 'PMS', :ID_ROOM)
    returning_values  :err_code, :err_text, :new_id_account_post;
    if (:err_code <> 0) then exception PMS_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

    insert into PMS_EVENT_POST (ID_PMS_EVENT, ID_ACCOUNT_POST, ID_OWNER, LINE_STATUS)
    values (:ID_PMS_EVENT, :NEW_ID_ACCOUNT_POST, :ID_OWNER, 11);
  end
end
^

/* Restore proc. body: POST_SERVICE_FINALIZE$POST */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
  declare variable id_acc_post integer;
  declare variable id_service integer;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable date_post date;
  declare variable price_post numeric(15,4);
  declare variable qty_post numeric(15,2);
  declare variable post_text varchar(100);
  declare variable curr_post varchar(3);
  declare variable id_phonecall integer;
  declare variable p_dbkey char(8);
begin

  if (:OPERATION = 'clear') then begin
    delete from TMP_SERVICE_POST T
    where  T.ID_SEQUENCE = :ID_SEQUENCE;

  end else if (:OPERATION = 'store') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);

    for
      select TS.RDB$DB_KEY, TS.ID_SERVICE, TS.ID_ACCOUNT, TS.ID_GUEST, TS.DATE_POST,
             TS.PRICE_POST, TS.QTY_POST, TS.CURR_POST, TS.POST_TEXT, TS.ID_PHONECALL
      from   TMP_SERVICE_POST TS
      where  TS.ID_SEQUENCE = :ID_SEQUENCE
      into   :p_dbkey, :id_service, :id_account, :id_guest, :date_post,
             :price_post, :qty_post, :curr_post, :post_text, :id_phonecall
    do begin
      id_acc_post = null;
      if (:id_guest is not null) then begin
        execute procedure POST_SERVICE_ON_GUEST$INT (:id_guest, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :CURR_POST,
                :date_post, :date_post, :post_text, '', :date_post, '', '')
        returning_values  (:err_code, :err_text, :no_use, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end else begin
        execute procedure POST_SERVICE_ON_ACCOUNT$INT (:id_account, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :curr_post, :date_post, :date_post, :post_text,
                '', :date_post, '')
        returning_values  (:err_code, :err_text, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end

      update TMP_SERVICE_POST
      set ID_ACCOUNT_POST = :id_acc_post
      where RDB$DB_KEY = :p_dbkey;

      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :DOC_SELECTED,
             AP.SHORT_CODE = case
                               when :id_phonecall is not null then 'TELECOUNT'
                               else null
                             end
      where  AP.ID_ACCOUNT_POST = :id_acc_post;

      if (:id_phonecall is not null) then begin
        update PHONECALLS P
        set    P.ID_ACCOUNT_POST = :id_acc_post
        where  P.ID_PHONECALL = :id_phonecall;
      end
    end
  end
end
^

/* Restore proc. body: RES_RECALC$INT */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable num_prefix varchar(20);
  declare variable number_1 varchar(20);
begin
  /* CALLER_KIND = {NORMAL, FORCED} */
  err_code = 0;
  /* 1. GET DATA */
  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL, rd.NUMBER_1
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :check_status, :id_reserv_detail, :number_1;

  if (:check_status = 1) then begin
    -- CHECKED OUT
    select sn.LEADING_PART
    from   SYSTEM_NUMERATOR SN
    where  sn.ID_NUMERATOR = 0
    into   :num_prefix;

    if (trim('.' from coalesce(:num_prefix, '')) = coalesce(:number_1, '')) then
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_MINE');
    else
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_ELSE');

    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :id_guest
    do begin
      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'MANUAL_EDIT_DATA', '');
    end
  end
  /* 2. FIND DEPENDANT GUESTS AND THEIR TARIFFS */
  --execute procedure sys_dbg('calc RES_RECALC$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

  ID_TAR_CALC = gen_id(gen_id_tar_calc, 1);
  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NONE');

  -- 3. UPDATE ROOM PRICE and REPOST ALL AFFECTED BOOKINGS
  execute procedure RES_TAR_CALC_FINALIZE$INT (:ID_TAR_CALC, :CALLER_KIND, :FORCE_POSTING)
  returning_values (:ERR_CODE, :ERR_TEXT);
end
^

/* Restore proc. body: RES_TAR_CALC_FINALIZE$INT */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(ID_TAR_CALC INTEGER,
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
declare variable old_room_price numeric(15,4);
  declare variable old_room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
  declare variable reserv_posting_disabled smallint;
  declare variable postings_disabled smallint;
  declare variable warn_code integer;
  declare variable action_text varchar(255);
begin
  --  Razpiswa cenata na staia, kakto i price_detailite.

  execute procedure TAR_CALC_EVAL_ALL$INT(:ID_TAR_CALC)
  returning_values  :ERR_CODE, :ERR_TEXT;

  if (:ERR_CODE = 0) then execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

  select iif(si.INFO_VALUE = '1', 1, null)
  from   SYSTEM_INFO_GET('RESERV_POSTINGS_DISABLED') si
  into   :postings_disabled;

  for
    select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, coalesce(:postings_disabled, rd.IS_POSTING_STOPPED),
           coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
           coalesce(max((select first 1 AP.IS_BASE
                         from   GUEST G
                                join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                         where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (it`s possible)
    from   TAR_CALC_INPUT$TMP TI
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
           join TARIFA t on t.ID_TARIFA = rd.ID_RATE
    where  ti.ID_TAR_CALC = :ID_TAR_CALC
    group by 1, 2, 3, 4, 5, 6
    into   :id_reserv_detail, :check_status, :is_posting_stopped,
           :room_currency, :id_hotel, :is_anul, :has_postings
  do begin
    reserv_posting_disabled = iif(:is_posting_stopped = 1 and :has_postings = 0, 1, 0);

    if (:ERR_CODE <> 0) then begin
      -- price calculation error handling  !!!!!
      if (:reserv_posting_disabled = 1) then begin
        -- set price to null, posting is disabled
        update RESERV_DETAIL RD
        set    RD.ROOM_PRICE = null,
               RD.ROOM_CURRENCY = null,
               RD.ROOM_PRICE_DETAILS = null,
               RD.LAST_ID_TAR_CALC = null
        where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
      end else begin
        -- exit on error in price calculation - cannot make valid posts
        EXIT;
      end
    end else begin
      room_price = 0;
      room_price_details = '';
    
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);
  
      if (:reserv_posting_disabled = 0 and ((coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1))) then begin
        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);
      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;
  
        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end
  
      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc,
             rd.ROOM_PRICE_LAST$INT = null,
             rd.ROOM_CURRENCY_LAST$INT = null
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail
      returning old.ROOM_PRICE_LAST$INT, old.ROOM_CURRENCY_LAST$INT
      into :old_room_price, :old_room_currency;

      if ((:old_room_price is distinct from :room_price)
          or (:old_room_currency is distinct from :room_currency) ) then
      begin
        action_text = f_character(29) || formatfloat(:old_room_price, 'F;0.00') || ' ' || coalesce(:old_room_currency, '') || f_character(28) || formatfloat(:room_price, 'F;0.00') || ' ' || coalesce(:room_currency, '');
        execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_PRICE_RECALC', :action_text);
      end
    end
  end

  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;

  if (:ERR_CODE <> 0) then begin
    execute procedure SYSTEM_WARNING_ADD(:ERR_CODE, :ERR_TEXT)
    returning_values :warn_code;
    ERR_CODE = 0;
    ERR_TEXT='';
  end
end
^

/* Restore proc. body: SAFE_OCCUPANCY_MODIFY */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE TYPE OF ID,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable old_booking_number tres_number;
  declare variable id_resource_reservation id_ref;
  declare variable from_datetime tdatetime;
  declare variable action_text tdescription_long;
  declare variable old_occupant varchar(100);
  declare variable old_to_dt timestamp;
  declare variable id_reserv_detail integer;
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation;

  select rr.BOOKING_NUMBER, od.FROM_DATETIME,
         RR.OCCUPANT_NAME, od.TO_DATETIME, rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESERV_DETAIL rd on rd.NUMBER = rr.BOOKING_NUMBER and rd.IS_ANUL = 0
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :old_booking_number, :from_datetime,
         :old_occupant, :old_to_dt, :id_reserv_detail, :id_agent_profile;

  --if (:old_booking_number <> :BOOKING_NUMBER) then exception ASSERT 'Can not change booking number!';
  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  update SAFE_RESOURCE_RESERV rr
  set    rr.PRICE_DESCRIPTION = :price_description,
         rr.ID_RATE_PRICE_PROFILE = :id_agent_profile,
         rr.RATING_UNITS = :rating_units,
         rr.RATE_PRICE = :price,
         rr.RATE_CURR = :currency
  where  rr.ID_RESOURCE_RESERV = :id_resource_reservation;

  execute procedure RESOURCE_RESERVATION_MODIFY (:id_resource_reservation, :ID_SAFE, :from_datetime,
          :TO_DATETIME, :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :old_booking_number, 'mod')
  returning_values :id_resource_reservation, :no_use;

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail)
  returning_values (:DOC_SELECTED);

  /* Log changes */
  if ((:old_occupant <> :OCCUPANT_NAME) or (:old_to_dt <> :TO_DATETIME)) then begin
    action_text = f_character(29) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                  || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                  || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');
  
    execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_CHANGED', :action_text);
  end
end
^

/* Restore proc. body: SAFE_OCCUPANCY_NEW */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE TYPE OF ID,
FROM_DATETIME TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME,
BOOKING_NUMBER TYPE OF TRES_NUMBER,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
ID_RESOURCE_RESERVATION TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable action_text tdescription_long;
  declare variable id_reserv_detail integer;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, s.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  if (:id_resource_reservation is not null) then exception ASSERT '-1064'|| f_character(31) || f_character(29) || :safe_name;

  select rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESERV_DETAIL rd
  where  rd.NUMBER = :BOOKING_NUMBER
         and rd.IS_ANUL = 0
  into   :id_reserv_detail, :id_agent_profile;

  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  execute procedure  RESOURCE_RESERVATION_MODIFY (null, :ID_SAFE, :FROM_DATETIME, :TO_DATETIME,
          :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :BOOKING_NUMBER, 'add')
  returning_values (:id_resource_reservation, :no_use) ;

  insert into SAFE_RESOURCE_RESERV (ID_RESOURCE_RESERV, PRICE_DESCRIPTION, ID_RATE_PRICE_PROFILE,
         RATING_UNITS, RATE_PRICE, RATE_CURR)
  values (:id_resource_reservation, :price_description, :id_agent_profile,
         :rating_units, :price, :currency);

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail, :ID_EXTERNAL_CLIENT_ACCCOUNT)
  returning_values (:DOC_SELECTED);

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = 'CHECKED_IN'
  where  RR.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = :id_resource_reservation
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                || f_character(28) || coalesce(:BOOKING_NUMBER, '')
                || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUPIED', :action_text);
end
^

/* Restore proc. body: SYSTEM_EVENT_LOG$INT */
ALTER PROCEDURE SYSTEM_EVENT_LOG$INT(OBJECT_CLASS VARCHAR(30),
OBJECT_ID INTEGER,
EVENT_CODE VARCHAR(50),
EVENT_TEXT VARCHAR(255),
EXTRA_DATA VARCHAR(255) = null)
 RETURNS(NEW_ID_SYSTEM_LOG INTEGER)
 AS
declare variable machine_name varchar(30);
  declare variable log_object_class varchar(30);
  declare variable log_object_id integer;
  declare variable action_ctx varchar(50);
begin
  if (RDB$GET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE') = 'disable') then EXIT;

  action_ctx = RDB$GET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX');

  execute procedure SYSTEM_SESSION_GET('MACHINE_NAME')
  returning_values  :machine_name;

  object_id = coalesce(object_id,0);
  log_object_class = :object_class;
  log_object_id = :object_id;


  new_id_system_log = gen_id(gen_system_log_id, 1);

  insert into SYSTEM_LOG_EVENT (ID_SYSTEM_LOG, LOG_OBJECT_CLASS, LOG_OBJECT_ID, ACTION_CODE,
         ACTION_DATETIME, ACTION_USER, MACHINE_NAME, ACTION_TEXT, ACTION_CTX)
  values (:new_id_system_log, :log_object_class, :log_object_id, :event_code,
         current_timestamp, current_user, :machine_name, :event_text, :action_ctx);

  -- get related bookings
  if (:OBJECT_CLASS = 'RES_DETAIL') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    values (:OBJECT_ID, :new_id_system_log);
  end else if (:OBJECT_CLASS = 'GUEST') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select G.ID_RESERV_DETAIL, :new_id_system_log
    from   GUEST G
    where  G.ID_GUEST = :OBJECT_ID;
  end else if (:OBJECT_CLASS = 'DOCUMENT') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select A.ID_RESERV_DETAIL, :new_id_system_log
    from   DOC_HEAD D
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  D.ID_DOC = :OBJECT_ID
           and A.ID_RESERV_DETAIL is not null;
  end else if (:OBJECT_CLASS = 'DEPOSIT') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select A.ID_RESERV_DETAIL, :new_id_system_log
    from   DEPOSIT D
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  D.ID_DEPOSIT = :OBJECT_ID
           and A.ID_RESERV_DETAIL is not null;
  end else if (:OBJECT_CLASS = 'PAYMENT') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select distinct A.ID_RESERV_DETAIL, :new_id_system_log
    from   PAYMENT_HEAD P
           join DEPOSIT D on D.ID_PAYMENT_HEAD = P.ID_PAYMENT_HEAD
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  P.ID_PAYMENT_HEAD = :OBJECT_ID
           and A.ID_RESERV_DETAIL is not null;
  end else if (:OBJECT_CLASS = 'ACCOUNT') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select A.ID_RESERV_DETAIL, :new_id_system_log
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :OBJECT_ID
           and A.ID_RESERV_DETAIL is not null;
  end

  if (:EVENT_CODE = 'DELETE') then begin
    insert into SYSTEM_LOG_DELETED (LOG_OBJECT_CLASS, LOG_OBJECT_ID, DESCRIPTION, HOTEL_CODE)
    select :log_object_class, :log_object_id, SL.OBJECT_DESCRIPTION, SL.HOTEL_CODE
    from   SYSTEM_LOG_OBJECT_INFO_GET (:OBJECT_CLASS, :OBJECT_ID) SL;
  end

  if (:EXTRA_DATA is not null) then begin
    insert into SYSTEM_LOG_EXTRA (ID_SYSTEM_LOG, EXTRA_DATA)
    values (:new_id_system_log, :EXTRA_DATA);
  end

  if (exists(
    select *
    from   EAI_EVENTQ_PUBLISH P
    where  P.ACTION_CODE = :EVENT_CODE
  )) then post_event 'EAI_EVENTQ';

end
^

/* Restore proc. body: TAR_CALC_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
declare variable param_code varchar(40);
  declare variable id_param integer;
  declare variable param_value varchar(255);
  declare variable data_type  varchar(30);
  declare variable rate_list varchar(2000);
begin
  err_code = 0;
  param_values = '';

  if (coalesce(:rate_list_replace, '') = '') then rate_list = ',' || :id_rate || ',';
  else rate_list = :rate_list_replace;

  for
    select distinct TBP.PARAM_NAME
    from   SYSTEM_STRING_PARSER (:rate_list, ',') sp
           left join TAR_BO_PARAMS TBP on TBP.ID_TAR_HEAD = sp.ITEM
    where  (TBP.PARAM_TYPE <> 'DATE_DEPENDANT' and :for_date is null)
           or (TBP.PARAM_TYPE = 'DATE_DEPENDANT' and :for_date is not null)
    into   :param_code
  do begin
    if (:param_code is not null) then begin
      id_param = null;
      select TP.ID_TARIFA_PARAM, TP.DATA_TYPE
      from   TARIFA_PARAMS TP
      where  TP.PARAM_CODE = :param_code
             and tp.IS_USE = 1
      into   :id_param, :data_type;
  
      if (:id_param is null) then begin
        err_code = -202;
        execute procedure sys_dbg ('tar calc params err_code: ' || :err_code || F_CRLF() || 'PARAM_CODE = ' || :param_code);
        exit;
      end
  
      execute procedure TARIFA_GET_PARAM (:id_param, :for_date, :id_tar_input, :id_tar_calc)
      returning_values (:param_value);
  
      param_code = ':'||param_code;
  
      if ((:param_code is not null) and (:param_code is not null) and (:data_type is not null)) then
         param_values = :param_values||';'||:param_code||','||:data_type||','||:param_value;
    end
  end
end
^

/* Creating trigger... */
CREATE TRIGGER EXT_ROOM_CLOUD_PORTAL_MAP_BI0 FOR EXT_ROOM_CLOUD_PORTAL_MAP
ACTIVE BEFORE INSERT POSITION 0 
AS
begin
  new.ID_ROOM_CLOUD_PORTAL_MAP = gen_id(GEN_ID_ROOM_CLOUD_PORTAL_MAP, 1);
end
^

CREATE TRIGGER EXT_ROOM_CLOUD_RATE_MAP_BI0 FOR EXT_ROOM_CLOUD_RATE_MAP
ACTIVE BEFORE INSERT POSITION 0 
AS
begin
  new.ID_ROOM_CLOUD_RATE_MAP = gen_id(GEN_ID_ROOM_CLOUD_RATE_MAP, 1);
end
^


/* Altering existing trigger... */
ALTER TRIGGER RESERV_DETAIL_BIU
as
  declare variable log_state varchar(50);
begin
  if (RDB$GET_CONTEXT('USER_TRANSACTION', 'EXC_TRANSACTION') is null) then begin
    execute procedure EXPORT_LOG_ENABLED$EXC returning_values :log_state;
    if ('enable' = :log_state) then begin
      new.exc_local_version = coalesce(old.exc_local_version, 0) + 1;
    end
  end

  new.change_time = current_timestamp;
  new.COUNTRY = upper(coalesce(new.COUNTRY, ''));

  if (updating
      and old.ROOM_PRICE_LAST$INT is null
      and old.ROOM_PRICE is not null
     ) then begin
    new.ROOM_PRICE_LAST$INT = old.ROOM_PRICE;
    new.ROOM_CURRENCY_LAST$INT = old.ROOM_CURRENCY;
  end
end
^

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_TRANSFER$ACC for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: GUEST_REROUTE_POSTINGS$INT for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE GUEST_REROUTE_POSTINGS$INT(ID_GUEST INTEGER,
ID_BASE_ACCOUNT INTEGER,
ID_EXTRA_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_TRANSFER$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER,
IS_MANUAL_TRANSFER TYPE OF TLOGICAL = 1)
 AS
declare variable id_current_account integer;
  declare variable id_service integer;
  declare variable is_anul integer;
  declare variable id_tariff integer;
  declare variable qty_post numeric(15,2);
  declare variable qty_free numeric(15,2);
  declare variable price_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable id_room integer;
  declare variable id_base_doc integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  if ((:AP_DBKEY is null) or (:id_target_account is null) or (:id_target_account < 0)) then
     exception POSTING_TRANSFER_EXCEPTION '-31';

  select AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST, AP.QTY_FREE,
         AP.PRICE_ORIG, AP.CURR_ORIG, AP.RATE_ORIG, ap.from_date, ap.to_date,
         AP.IS_ANUL, AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_BASE_DOC, A.ID_HOTEL
  from   ACCOUNT_POST AP
         left join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :id_service, :id_tariff, :id_room, :qty_post, :qty_free,
         :price_orig, :curr_orig, :rate_orig, :from_date, :to_date,
         :is_anul, :id_account_post, :id_current_account, :id_base_doc, :id_hotel;

  if (:id_current_account = :id_target_account) then EXIT;

  if (:is_anul = 1 ) then exception POSTING_TRANSFER_EXCEPTION '-33';

  if (:id_base_doc is not null) then exception POSTING_TRANSFER_EXCEPTION '-32';

  if (not exists(select A.ID_ACCOUNT
                 from   ACCOUNT A
                 where  A.ID_ACCOUNT = :ID_TARGET_ACCOUNT
                        and A.ID_HOTEL = :id_hotel)) then exception POSTING_TRANSFER_EXCEPTION '-376';

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
                    :id_tariff, :id_room, :qty_post, :qty_free, :price_orig, :curr_orig,
                    :rate_orig, 'TRANSFER_POSTING', null, :from_date, :to_date,
                    iif(:IS_MANUAL_TRANSFER is distinct from 1, 1, 0), :id_target_account)
  returning_values  :no_use, :no_use, :no_use;

  insert into ACCOUNT_TRANSFER_HISTORY(ID_ACCOUNT_POST, FROM_ID_ACCOUNT, TO_ID_ACCOUNT)
  values (:id_account_post, :id_current_account, :id_target_account);
end
^

/* Alter (ACCOUNT_POSTING_UPDATE) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable in_db_key char(8);
begin
  /* GUI facade for manual update */
  select AP.ID_ACCOUNT, AP.ID_GUEST, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :id_guest, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date)
  returning_values  (:new_qty_post, :new_price_post, :new_ac);

  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    if (coalesce(:id_guest, 0) > 0) then begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || :id_account
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || replace(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'POST_UPDATE', :action_text);
    end else begin
      action_text = f_character(29) || :action_text
                    || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                    || f_character(28) || :log_old_value
                    || f_character(28) || :log_new_value
                    || f_character(28) || replace(:IN_CHANGED_TEXT, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
    end
  end

end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_POST_TO_FRONT_ONLINE for: EAI_EXT_POST_TO_MH_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_EXT_POST_TO_MH_FRONT_ONLINE) */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  if (:CODE_TYPE = 'EXT_CODE') then begin
    execute procedure EAI_MAP_SERVICE(:SERVICE_CODE, :SERVICE_CODE, 'UNKNOWN', :id_hotel)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_SERVICE;
    if (:ERR_CODE < 0) then exit;
  end else begin
    select S.ID_SERVICE
    from   SERVICES S
    where  S.ID_SERVICE = :SERVICE_CODE
           and s.ID_HOTEL = :ID_HOTEL
    into   :ID_SERVICE;
    if (:ID_SERVICE is null) then begin
      ERR_CODE = -85;   /* Wrong value! */
      exit;
    end
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:ID_ACCOUNT_POST, :SERVICE_CODE, null, null);

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Alter (EAI_EXT_SERVICE_POST) */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable max_id_service integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_ROOM  = null;
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  select min(S.ID_SERVICE) as id_service, max(s.id_service) as max_id_service
  from   SERVICES S
  where  S.EXT_CODE = :SERVICE_EXT_CODE
         and s.IS_BASE = 0
         and s.IS_DELETED = 0
  into   :ID_SERVICE, :max_id_service;
  if (:ID_SERVICE is null) then begin
      ERR_CODE = -388;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end else if (:ID_SERVICE <> :max_id_service) then begin
      ERR_CODE = -389;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_EXT_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:ID_ACCOUNT_POST, :SERVICE_EXT_CODE, null, null);

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* empty dependent procedure body */
/* Clear: EAI_POS_POSTING_ADD for: EAI_POS_POSTING_ADD$P2E */
ALTER PROCEDURE EAI_POS_POSTING_ADD(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_POS_POSTING_ADD$P2E) */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
declare variable id_service integer;
  declare variable my_post_text varchar(255);
  declare variable my_resource_text varchar(255);
  declare variable nation_curr varchar(3);
  declare variable post_short_code varchar(10);
  declare variable id_hotel integer;
  declare variable id_account_post integer;
begin
  /* in_on_guest = 0 (account), 1 (guest), -1 (ew)
  */
  if (:IN_ON_GUEST = 1) then begin
    select rd.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :IN_ID_GUEST
    into   :id_hotel;
  end else begin
    select a.ID_HOTEL
    from   account a
    where  a.ID_ACCOUNT = :in_id_account
    into   :id_hotel;
  end

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :nation_curr;

  if ('END_WORK' = :in_smetka_num) then begin
    post_short_code='POS_EW';
  end else begin
    post_short_code='POS';
  end

  /* FIND SERVICE */
  execute procedure EAI_MAP_SERVICE(:in_service_tag, :in_service_name, 'POS', :id_hotel)
  returning_values  :err_code, :err_text, :id_service;
  if (:err_code < 0) then exit;

  my_post_text = 'date:'|| formatdate(:in_date_smetka, 'D;dd.mm.yyyy') ||
                 ' num:'|| :in_smetka_num ||
                 ' obj:'|| :in_obj_name ||
                 ' tbl:'|| :in_table ||
                 ' site:'|| :in_site;

  my_resource_text = 'POS_ID_SMETKA:'||:in_id_smetka;
  my_post_text = substring(:my_post_text from 1 for 100);
  my_resource_text = substring(:my_resource_text from 1 for 49);

  if (:in_on_guest = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:in_id_guest, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code, '')
    returning_values  :err_code, :err_text, :out_id_account, :id_account_post;
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:in_id_account, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code)
    returning_values  :err_code, :err_text, :id_account_post;
    out_id_account = :in_id_account;
  end
  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:id_account_post, :post_short_code, :IN_POS_USER, :IN_DATETIME);
end
^

/* Alter (EAI_TELECOUNT_TRANSFER) */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTS$INT for: GUEST_REROUTE_POSTINGS$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTS$INT(RD_DBKEY CHAR(8))
 AS
 BEGIN EXIT; END
^

/* Alter (GUEST_REROUTE_POSTINGS$INT) */
ALTER PROCEDURE GUEST_REROUTE_POSTINGS$INT(ID_GUEST INTEGER,
ID_BASE_ACCOUNT INTEGER,
ID_EXTRA_ACCOUNT INTEGER)
 AS
declare variable ap_dbkey char(8);
  declare variable is_packet_post integer;
  declare variable packet_option varchar(50);
  declare variable id_target_account integer;
  declare variable id_current_account integer;
begin
  update GUEST G
  set    G.ID_BASE_ACCOUNT = :ID_BASE_ACCOUNT,
         G.ID_ACCOUNT = :ID_EXTRA_ACCOUNT
  where  G.ID_GUEST = :ID_GUEST;

  for
    select AP.RDB$DB_KEY, iif(AP.ID_MASTER_ADDINS_ACC_POST > 0, 1, 0), S.VAUCHER_PACKET,
           ap.ID_ACCOUNT
    from   ACCOUNT_POST AP
           join SERVICES S on S.ID_SERVICE = AP.ID_SERVICE
    where  AP.ID_GUEST = :ID_GUEST
           and AP.AC = '00'
           and AP.ID_BASE_DOC is null
    into   :ap_dbkey, :is_packet_post, :packet_option, :id_current_account
  do begin
    if ((:is_packet_post = 1) and (:packet_option <> 'NONE')) then id_target_account = :id_base_account;
    else id_target_account = :id_extra_account;

    if (:id_current_account <> :id_target_account) then begin
      execute procedure ACCOUNT_POSTING_TRANSFER$INT(:ap_dbkey, :id_target_account, 0);
    end
  end

end
^

/* empty dependent procedure body */
/* Clear: CREATE_BOOKING$WBE for: IMPORT_BOOKING$EXC */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TEST_BOOKING_IMPORT for: IMPORT_BOOKING$EXC */
ALTER PROCEDURE TEST_BOOKING_IMPORT AS
 BEGIN EXIT; END
^

/* Alter (IMPORT_BOOKING$EXC) */
ALTER PROCEDURE IMPORT_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(250),
MAINTANCE_SHEMA VARCHAR(30),
POSTING_ROUTING VARCHAR(20),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
COMPLIMENTARY_ACCOUNT VARCHAR(50),
EATING_OBJECT VARCHAR(50),
CREATE_DATETIME TIMESTAMP,
CHECK_OUT_KIND SMALLINT,
EARLYCHECKOUT_DATE DATE)
 RETURNS(HOTEL_ID INTEGER,
BOOKING_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable current_hotel_id integer;
declare variable booking_update_id integer;
declare variable warn_code integer;
declare variable share_transaction_id integer;
declare variable share_err_code integer;
declare variable arranger_profile_id integer;
declare variable main_guest_profile_id integer;
declare variable rate_id integer;
declare variable room_type_id integer;
declare variable board_id integer;
declare variable maintance_shema_id integer;
declare variable arranger_payment_type_id integer;
declare variable guest_payment_type_id integer;
declare variable marketing_segment_id integer;
declare variable marketing_source_code_id integer;
declare variable marketing_channel_code_id integer;
declare variable marketing_hear_reason_id integer;
declare variable marketing_come_reason_id integer;
declare variable arranger_account_id integer;
declare variable packet_id integer;
declare variable id_guarantee_policy integer;
declare variable first_food_code tfood_code;
declare variable arrival_type_code smallint;
declare variable booking_dbkey char(8);
declare variable reserv_group_id integer;
declare variable id_complimentary_account integer;
declare variable id_eating_object integer;
declare variable default_guest_mask varchar(10);
declare variable id_person_data integer;
begin
  /*execute procedure sys_dbg('exc IMPORT_BOOKING$EXC('
  || 'hotel => ' || coalesce(:hotel, '<null>')
  || ', booking_number => ' || coalesce(:number, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  ||')');
  */
  execute procedure import_mark_transaction$exc;

  /* init */
  err_code = 0;
  err_text = '';
  booking_update_id = null;
  booking_dbkey = null;
  current_hotel_id = null;
  if (:voucher_date is not null) then begin
    voucher_date = striptime(:voucher_date);
  end
  posting_routing = upper(:posting_routing);

  /* detect inser/update mode */
  select b.id_reserv_detail, b.rdb$db_key, b.id_hotel
  from   reserv_detail b
  where  b.number=:number
         and b.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and b.id_log_event_annul is null
  into   :booking_update_id, :booking_dbkey, :current_hotel_id;

  if (:booking_update_id is null) then begin
    booking_id = gen_id (id_reserv_detail_gen, 1);
  end else begin
    booking_id = :booking_update_id;
  end

  /* text to id map */
  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => MAP_BOOKING_RELATIONS$EXC');
  execute procedure MAP_BOOKING_RELATIONS$EXC(
    :booking_id,
    :hotel,
    :room_type,
    :board,
    :maintance_shema,
    :rate,
    :arranger_payment_type,
    :guest_payment_type,
    :marketing_segment,
    :marketing_source_code,
    :marketing_channel_code,
    :marketing_hear_reason,
    :marketing_come_reason,
    :first_food,
    :arranger_profile_uuid,
    :arranger_profile_name,
    :main_guest_profile_uuid,
    :arrival_type,
    :guarantee_policy,
    :eating_object
  ) returning_values
    :arranger_profile_id,
    :main_guest_profile_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :hotel_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :first_food_code,
    :arrival_type_code,
    :id_guarantee_policy,
    :id_eating_object;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* hotel change test */
  if (coalesce(:current_hotel_id, :hotel_id) <> :hotel_id) then begin
    execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', null, :hotel, 'booking hotel changed');
  end

  id_complimentary_account = null;
  if (complimentary_account is not null) then begin
    execute procedure lookup_account$exc(:hotel_id, :complimentary_account, 'booking', :booking_id)
    returning_values :id_complimentary_account;
  end

  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => CREATE_PACK_INSTANCE$EXC');
  packet_id = null;
  /*execute procedure CREATE_PACK_INSTANCE$EXC(
    :hotel_id, :booking_id, :package
  )
  returning_values :packet_id, :err_code, :err_text;
  if (0 <> :err_code) then exit;
  */
  /* merge input and default/persistent database values */
  execute procedure DEFAULT_BOOKING_VALUES$EXC(
    :booking_dbkey, :hotel_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :group_name,
    :group_uuid,
    :is_late_departure,
    :id_eating_object
  ) returning_values
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :arranger_account_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :reserv_group_id,
    :is_late_departure,
    :id_eating_object,
    :default_guest_mask;

  if ('' = :board) then board_id = null; /* preserve "empty board" state and discard default value */

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC DEFAULTED => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* if the booking is complimentary use complimentary account */
  arranger_account_id = coalesce(:id_complimentary_account, :arranger_account_id);

  /* CREATE or UPDATE */
  if (:booking_update_id is not null) then begin
    /* UPDATE booking */
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => UPDATE_BOOKING$EXC');
    execute procedure UPDATE_BOOKING$EXC(
      :booking_id,
      :reserv_group_id,
      :is_vip,
      :arrival,
      :arrival_type_code,
      :departure,
      :is_late_departure,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :room_type_id,
      :board_id,
      :room_preferences,
      :special_treatment,
      :maintance_shema_id,
      :posting_routing,
      :arranger_account_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :deposit_required,
      :deposit_required_currency,
      :arranger_payment_type_id,
      :guest_payment_type_id,
      :voucher,
      :voucher_date,
      :voucher_text,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :note,
      :note_reminders,
      :first_food_code,
      :arranger_profile_id,
      :main_guest_profile_id,
      :is_different_rate,
      :is_different_price,
      :split_on_checkin,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object
    ) returning_values :err_code, :err_text;
    if (0 <> :err_code) then begin
      exit;
    end
  end else begin
    /* CREATE booking */
    if (:default_guest_mask is not null
        and :main_guest_profile_id is not null
        and not exists (select rd.ID_RESERV_DETAIL from reserv_detail rd where rd.ID_PERSON_PROFILE = :main_guest_profile_id)) then
    begin
      -- fill the mask with a default value if its is empty
      select p.id_person_data
      from   PROFILE_PERSON p
      where  p.ID_PROFILE = :main_guest_profile_id
      into   :id_person_data;

      update PERSON_DATA pd
      set    pd.MASK = :default_guest_mask
      where  pd.ID_PERSON_DATA = :id_person_data
             and pd.MASK is null;
    end
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => RES_CREATE_SET$EXC');
    execute procedure RES_CREATE_SET$EXC (
      :booking_id,
      :number,
      :arranger_profile_id,
      :main_guest_profile_id,
      :arrival,
      :departure,
      :adult_count,
      :children_count,
      :room_type_id,
      null,
      :board_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :voucher,
      :voucher_date,
      :voucher_text,
      null,
      null,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :arrival_type_code,
      :is_late_departure,
      :is_vip,
      :first_food_code,
      :special_treatment,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :arranger_account_id,
      :posting_routing,
      :guest_payment_type_id,
      :arranger_payment_type_id,
      null,
      :room_preferences,
      :maintance_shema_id,
      :note,
      :note_reminders,
      :deposit_required,
      :deposit_required_currency,
      :hotel_id,
      :reserv_group_id,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object,
      :create_datetime
      )
    returning_values :err_code, :err_text, :warn_code, :booking_id, :share_transaction_id, :share_err_code;
  end

  update reserv_detail rd
  set    rd.CHECK_OUT_KIND = :CHECK_OUT_KIND,
         rd.EARLYCHECKOUT_DATE = :EARLYCHECKOUT_DATE
  where  rd.ID_RESERV_DETAIL = :BOOKING_ID;

  execute procedure GUEST_STAY_INITIALIZE$INT (:booking_id);
  /* final error check */
  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;

  delete from PENDING_DEPOSIT d
  where  d.ID_RESERV_DETAIL = :BOOKING_ID;
end
^

/* Alter (PHONECALL_POST$TC) */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Alter (PHONECALLS_POST_TO_ACCOUNT$TC) */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POST_MODIFY$PMS for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: CONTRACT_EXPENSE_POST$INT for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_HOTEL INTEGER,
ID_CONTRACT /* TYPE OF ID */ INTEGER,
SUB_CONTRACT /* TYPE OF TSUB_CONTRACT */ VARCHAR(10),
ID_OWNER /* TYPE OF ID */ INTEGER,
OWNERSHIP_PERCENT /* TYPE OF TPERCENT */ NUMERIC(15,4),
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
POST_DATE /* TYPE OF TDATE */ DATE,
STAY /* TYPE OF TCOUNT */ INTEGER,
MAX_GUEST_CNT /* TYPE OF TCOUNT */ INTEGER,
BED_NIGHT_CNT /* TYPE OF TCOUNT */ INTEGER,
RESERVS /* TYPE OF TCOUNT */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PMS_EXPENSE_POSTS_CREATE$INT for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_EXPENSE_POSTS_CREATE$INT(ID_ROOM /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
POST_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
IS_CLIENT_ACC_POST /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_POST_DATE /* TYPE OF TDATE */ DATE,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IS_POST_PER_POOL /* TYPE OF TLOGICAL */ SMALLINT)
 RETURNS(NEW_ID_ACCOUNT_POST /* ID_REF */ INTEGER,
NEW_ID_ACCOUNT_POST$PMS /* ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PMS_POOL_DISTRIBUTION_SUB for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_POSTING_CREATE$INT) */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_OWNER TYPE OF ID,
POST_DATE TYPE OF TDATE,
CURR_ORIG TYPE OF TCURRENCY,
VALUE_ORIG TYPE OF TPRICE,
POST_ON_PMS_ACCOUNT TYPE OF TLOGICAL,
IS_OWNER_INCOME TYPE OF TLOGICAL,
ID_ROOM TYPE OF ID_REF = null)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  if (:POST_ON_PMS_ACCOUNT = 1) then begin
    execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account, :id_owner,
            :CURR_ORIG, :VALUE_ORIG, :id_service, :is_owner_income, :POST_DATE)
    returning_values  (:new_id_account_post);
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :ID_SERVICE, 1, 0, 1,
            :VALUE_ORIG, :CURR_ORIG, current_date, current_date,
            '', '', :POST_DATE, 'PMS', :ID_ROOM)
    returning_values  :err_code, :err_text, :new_id_account_post;
    if (:err_code <> 0) then exception PMS_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

    insert into PMS_EVENT_POST (ID_PMS_EVENT, ID_ACCOUNT_POST, ID_OWNER, LINE_STATUS)
    values (:ID_PMS_EVENT, :NEW_ID_ACCOUNT_POST, :ID_OWNER, 11);
  end
end
^

/* Alter (POST_SERVICE_FINALIZE$POST) */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
  declare variable id_acc_post integer;
  declare variable id_service integer;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable date_post date;
  declare variable price_post numeric(15,4);
  declare variable qty_post numeric(15,2);
  declare variable post_text varchar(100);
  declare variable curr_post varchar(3);
  declare variable id_phonecall integer;
  declare variable p_dbkey char(8);
begin

  if (:OPERATION = 'clear') then begin
    delete from TMP_SERVICE_POST T
    where  T.ID_SEQUENCE = :ID_SEQUENCE;

  end else if (:OPERATION = 'store') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);

    for
      select TS.RDB$DB_KEY, TS.ID_SERVICE, TS.ID_ACCOUNT, TS.ID_GUEST, TS.DATE_POST,
             TS.PRICE_POST, TS.QTY_POST, TS.CURR_POST, TS.POST_TEXT, TS.ID_PHONECALL
      from   TMP_SERVICE_POST TS
      where  TS.ID_SEQUENCE = :ID_SEQUENCE
      into   :p_dbkey, :id_service, :id_account, :id_guest, :date_post,
             :price_post, :qty_post, :curr_post, :post_text, :id_phonecall
    do begin
      id_acc_post = null;
      if (:id_guest is not null) then begin
        execute procedure POST_SERVICE_ON_GUEST$INT (:id_guest, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :CURR_POST,
                :date_post, :date_post, :post_text, '', :date_post, '', '')
        returning_values  (:err_code, :err_text, :no_use, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end else begin
        execute procedure POST_SERVICE_ON_ACCOUNT$INT (:id_account, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :curr_post, :date_post, :date_post, :post_text,
                '', :date_post, '')
        returning_values  (:err_code, :err_text, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end

      update TMP_SERVICE_POST
      set ID_ACCOUNT_POST = :id_acc_post
      where RDB$DB_KEY = :p_dbkey;

      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :DOC_SELECTED,
             AP.SHORT_CODE = case
                               when :id_phonecall is not null then 'TELECOUNT'
                               else null
                             end
      where  AP.ID_ACCOUNT_POST = :id_acc_post;

      if (:id_phonecall is not null) then begin
        update PHONECALLS P
        set    P.ID_ACCOUNT_POST = :id_acc_post
        where  P.ID_PHONECALL = :id_phonecall;
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE_RECALC$INT for: RES_RECALC$INT */
ALTER PROCEDURE RES_FINALIZE_RECALC$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_RECALC$RSV for: RES_RECALC$INT */
ALTER PROCEDURE RES_RECALC$RSV(ID_RESERV_DETAIL INTEGER,
FORCE_POSTING SMALLINT = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_RATE$RSV for: RES_RECALC$INT */
ALTER PROCEDURE RES_SAVE_RATE$RSV(ID_RESERV_DETAIL INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
IS_DIFFERENT_TARIFF INTEGER,
IS_DIFFERENT_PRICE INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_RECALC$INT) */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable num_prefix varchar(20);
  declare variable number_1 varchar(20);
begin
  /* CALLER_KIND = {NORMAL, FORCED} */
  err_code = 0;
  /* 1. GET DATA */
  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL, rd.NUMBER_1
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :check_status, :id_reserv_detail, :number_1;

  if (:check_status = 1) then begin
    -- CHECKED OUT
    select sn.LEADING_PART
    from   SYSTEM_NUMERATOR SN
    where  sn.ID_NUMERATOR = 0
    into   :num_prefix;

    if (trim('.' from coalesce(:num_prefix, '')) = coalesce(:number_1, '')) then
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_MINE');
    else
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_ELSE');

    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :id_guest
    do begin
      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'MANUAL_EDIT_DATA', '');
    end
  end
  /* 2. FIND DEPENDANT GUESTS AND THEIR TARIFFS */
  --execute procedure sys_dbg('calc RES_RECALC$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

  ID_TAR_CALC = gen_id(gen_id_tar_calc, 1);
  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NONE');

  -- 3. UPDATE ROOM PRICE and REPOST ALL AFFECTED BOOKINGS
  execute procedure RES_TAR_CALC_FINALIZE$INT (:ID_TAR_CALC, :CALLER_KIND, :FORCE_POSTING)
  returning_values (:ERR_CODE, :ERR_TEXT);
end
^

/* Alter (RES_RECALC$RSV) */
ALTER PROCEDURE RES_RECALC$RSV(ID_RESERV_DETAIL INTEGER,
FORCE_POSTING SMALLINT = null)
 AS
declare variable id_tar_calc integer;
declare variable err_text varchar(255);
  declare variable err_code integer;
  declare variable rd_dbkey char(8);
begin
  -- FORCED, user activated recalculation
  execute procedure RIGHTS_CHECK_GRANTED$INT ('GUEST_RECALC_POST');

  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_RECALC$INT(:rd_dbkey, 'FORCED', :FORCE_POSTING)
  returning_values  :err_code, :err_text, :id_tar_calc;
  if (:err_code < 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'FORCED_RECALC', null);

end
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_CHANGE$RSV for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTING$INT for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_GUESTCOUNT$RSV for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT$RSV for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_ACCOUNTS$INT) */
ALTER PROCEDURE RES_SAVE_ACCOUNTS$INT(RD_DBKEY CHAR(8))
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_base_account integer;
  declare variable old_id_extra_account integer;
  declare variable new_id_base_account integer;
  declare variable new_id_extra_account integer;
  declare variable acc_routing varchar(30);
  declare variable is_sep_accounts integer;
  declare variable id_base_account_profile integer;
  declare variable id_extra_account_profile integer;
  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable id_agent_account_rule integer;
  declare variable id_acc_template_person integer;
  declare variable id_guest integer;
  declare variable id_hotel integer;
begin

  select RD.ID_RESERV_DETAIL, RD.ID_PERSON_PROFILE, RD.ID_ACC_TEMPLATE_PERSON,
         RD.ACC_ROUTING, RD.ID_BASE_ACCOUNT, RD.ID_EXTRA_ACCOUNT,
         RD.ID_AGENT_PROFILE, RD.ID_AGENT_ACCOUNT_RULE, rd.id_hotel
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :RD_DBKEY
  into   :id_reserv_detail, :id_person_profile, :id_acc_template_person,
         :acc_routing, :old_id_base_account, :old_id_extra_account,
         :id_agent_profile, :id_agent_account_rule, :id_hotel;

  id_agent_account_rule = nullif(:id_agent_account_rule, -1);
  /* --- new */
  execute procedure SETTING_GET_VALUE ('SEPARATE_ACCOUNTS_PER_PAYER', :id_hotel)
  returning_values (:IS_SEP_ACCOUNTS);

  NEW_ID_BASE_ACCOUNT = null; --:old_id_base_account;
  NEW_ID_EXTRA_ACCOUNT = null; --:old_id_extra_account;

  /* identify profiles for base and extra account */
  if (:ACC_ROUTING in ('MIXED')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else if (:ACC_ROUTING in ('AGENT')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
  end else if (:ACC_ROUTING in ('FULL_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = null;
    IS_SEP_ACCOUNTS = 0;  -- never
  end else if (:ACC_ROUTING in ('PART_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else begin -- if (:acc_routing in ('GUEST', 'OWNER'))
    ID_BASE_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_AGENT_ACCOUNT_RULE = null;
  end

  execute procedure RES_ACCOUNTS_RECIEVE$INT (:ID_RESERV_DETAIL, :old_id_base_account, :old_id_extra_account,
          :id_agent_account_rule, :id_base_account_profile, :id_extra_account_profile, :id_person_profile,
          :id_acc_template_person, :is_sep_accounts)
  returning_values (:new_id_base_account, :new_id_extra_account);

--  if (:new_id_base_account is null) then exception WRONG_VALUE 'Invalid base account!';
--  if (:new_id_extra_account is null) then exception WRONG_VALUE 'Invalid extra account!';
  if ((:old_id_base_account is distinct from :new_id_base_account)
       or (:old_id_extra_account is distinct from :new_id_extra_account)) then
  begin
    update RESERV_DETAIL RD
    set    RD.ID_BASE_ACCOUNT = :new_id_base_account,
           RD.ID_EXTRA_ACCOUNT = :new_id_extra_account
    where  RD.RDB$DB_KEY = :RD_DBKEY;
    /* end --- */
    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
             --and G.CHECK_STATUS < 1
      into   :id_guest
    do begin
      execute procedure GUEST_REROUTE_POSTINGS$INT(:id_guest, :new_id_base_account, :new_id_extra_account);
    end

    -- Log account changes
    execute procedure RES_SAVE_ACCOUNTS_FINALIZE$INT(:id_reserv_detail, :old_id_base_account, :old_id_extra_account,
            :new_id_base_account, :new_id_extra_account);
  end

end
^

/* Alter (RES_SAVE_GUESTCOUNT$RSV) */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select rd.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  rd.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SAVE_GUESTCOUNT$INT(:rd_dbkey, :adult_count, :child_count);

  execute procedure RES_SAVE_ACCOUNTS$INT (:rd_dbkey);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 0)
  returning_values  :warn_code;

end
^

/* Alter (RES_SAVE_RATE$RSV) */
ALTER PROCEDURE RES_SAVE_RATE$RSV(ID_RESERV_DETAIL INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
IS_DIFFERENT_TARIFF INTEGER,
IS_DIFFERENT_PRICE INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 AS
declare variable rd_dbkey char(8);
  declare variable old_price numeric(14,4);
  declare variable old_price_currency char(3);
  declare variable old_is_different_price integer;
  declare variable action_text varchar(255);
  declare variable err_code integer;
  declare variable err_text varchar(255) ;
  declare variable id_tar_calc integer;
  declare variable recalc_type varchar(20);
  declare variable old_tariff integer;
begin

  select RD.RDB$DB_KEY, RD.custom_price, rd.custom_currency, rd.HAS_DIFFERENT_PRICE, rd.ID_RATE
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_price, :old_price_currency, :old_is_different_price, :old_tariff;

  if (:is_different_tariff = 0) then begin
    execute procedure RES_SAVE_RATE$INT(:rd_dbkey, :id_tariff);
  end else begin
    execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey);
  end

  if (:IS_DIFFERENT_PRICE = 0) then begin
    delete from RESERV_CUSTOM_PRICE
    where  ID_RESERV_DETAIL  = :ID_RESERV_DETAIL;

    update RESERV_DETAIL RD
    set    RD.CUSTOM_PRICE = :custom_price,
           RD.CUSTOM_CURRENCY = :custom_currency,
           RD.HAS_DIFFERENT_PRICE = :IS_DIFFERENT_PRICE
    where  RD.RDB$DB_KEY = :rd_dbkey;
  end else begin
    if (not exists (select * from RESERV_CUSTOM_PRICE rmp where rmp.id_reserv_detail = :id_reserv_detail)) then IS_DIFFERENT_PRICE = 0;
    update RESERV_DETAIL RD
    set    RD.CUSTOM_PRICE = null,
           RD.CUSTOM_CURRENCY = null,
           RD.HAS_DIFFERENT_PRICE = :IS_DIFFERENT_PRICE
    where  RD.RDB$DB_KEY = :rd_dbkey;
  end


  /*Maintain the flag in RD - HAS_DIFFERENT_PRICE*/
/*  if (exists (select * from RESERV_CUSTOM_PRICE rmp where rmp.id_reserv_detail = :id_reserv_detail)) then
    update RESERV_DETAIL set has_different_price = 1 where id_reserv_detail = :id_reserv_detail;
  else
    update RESERV_DETAIL set has_different_price = 0 where id_reserv_detail = :id_reserv_detail;
*/
  /*Log modifications in custom price if here is diferent values*/
  if ((:old_price is distinct from :custom_price) or (:old_price_currency is distinct from :custom_currency) ) then begin
    action_text = f_character(29) || formatfloat(:custom_price, 'F;0.00') || '' || :custom_currency || f_character(28);
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_MANUAL_PRICE', :action_text);
  end

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    if ((:ID_TARIFF is distinct from :old_tariff)
        or (:IS_DIFFERENT_PRICE is distinct from :old_is_different_price)
        or (:CUSTOM_PRICE is distinct from :old_price)
        or (:CUSTOM_CURRENCY is distinct from :old_price_currency) ) then
      recalc_type = 'FORCED';
    else
      recalc_type = 'NORMAL';

    execute procedure RES_RECALC$INT(:rd_dbkey, :recalc_type, 0)
    returning_values  :err_code, :err_text, :id_tar_calc;
    --execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    --returning_values  :err_code, :err_text;
    if (:err_code < 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_CHECKIN_MULTI$RSV for: RES_SPLIT$RSV */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT_MULTI$RSV for: RES_SPLIT$RSV */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SPLIT$RSV) */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
declare variable rd_dbkey_old char(8);
  declare variable rd_dbkey_new char(8);
  declare variable id_guest integer;
  declare variable warn_code integer;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;

  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable check_status integer;
  declare variable arrival_date date;
  declare variable departure_date date;
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable id_room_type integer;
  declare variable id_room integer;
  declare variable id_board integer;
  declare variable id_tariff integer;
  declare variable custom_price numeric(15,4);
  declare variable custom_currency char(3);
  declare variable voucher_num varchar(30);
  declare variable voucher_date date;
  declare variable voucher_text varchar(30);
  declare variable voucher2_num varchar(30);
  declare variable voucher2_date date;
  declare variable transfer_in_time time;
  declare variable transfer_in_note varchar(255);
  declare variable transfer_out_time time;
  declare variable transfer_out_note varchar(255);
  declare variable comming_kind integer;
  declare variable is_late_departure integer;
  declare variable is_vip integer;
  declare variable country_code varchar(20);
  declare variable code_first_food tfood_code;
  declare variable i_special_treatment varchar(255);
  declare variable id_nom_market_segment integer;
  declare variable id_nom_source_code integer;
  declare variable id_nom_channel_code integer;
  declare variable id_nom_hear_reason integer;
  declare variable id_nom_come_reason integer;
  declare variable id_agent_account integer;
  declare variable acc_routing varchar(50);
  declare variable id_person_payment integer;
  declare variable id_agent_payment integer;
  declare variable room_features blob sub_type 1 segment size 80;
  declare variable id_hk_plan integer;
  declare variable id_group integer;
  declare variable id_hotel integer;
  declare variable note varchar(2000);
  declare variable note_reminders varchar(50);
  declare variable guarantee_deposit numeric(15,4);
  declare variable guarantee_currency char(3);
  declare variable id_titular integer;
  declare variable id_profile_data integer;
  declare variable id_acc_template_person integer;
  declare variable number_1 varchar(20);
  declare variable number_2 varchar(20);
  declare variable new_res_number varchar(62);
  declare variable g_dbkey char(8);
  declare variable is_child integer;
  declare variable id_guarantee_policy integer;
  declare variable block_cc varchar(255);
  declare variable virtual_room varchar(10);
  declare variable err_text varchar(255);
  declare variable is_posting_stopped integer;
  declare variable id_eating_object integer;
begin
  select RD.RDB$DB_KEY, RD.ID_AGENT_PROFILE, RD.CHECK_STATUS, RD.FROM_DATE, RD.TO_DATE,
         RD.ADULT_COUNT, RD.CHILD_COUNT, RD.ID_ROOM_TYPE, RD.ID_ROOM, RD.ID_BOARD, RD.ID_RATE,
         RD.CUSTOM_PRICE, RD.CUSTOM_CURRENCY, RD.VAUCHER_NUM, RD.VAUCHER_DATE, RD.VAUCHER_TEXT, RD.VAUCHER_NUM2,
         RD.VAUCHER_DATE2, RD.TRANSFER_IN_TIME, RD.TRANSFER_IN_NOTE, RD.TRANSFER_OUT_TIME, RD.TRANSFER_OUT_NOTE,
         RD.COMMING_KIND, RD.LEAVING_KIND - 1, RD.IS_VIP, RD.COUNTRY, RD.CODE_FIRST_FOOD, RD.I_SPECIAL_TREATMENT,
         RD.ID_NOM_MARKET_SEGMENT, RD.ID_NOM_SOURCE_CODE, RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_HEAR_REASON,
         RD.ID_NOM_COME_REASON, RD.ID_AGENT_ACCOUNT_RULE, RD.ACC_ROUTING, RD.ID_PERSON_PAYMENT, RD.ID_AGENT_PAYMENT,
         RD.ROOM_FEATURES, RD.ID_HK_PLAN, RD.ID_GROUP, RD.ID_HOTEL, RD.NOTE, RD.NOTE_REMINDERS,
         RD.GUARANTEE_DEPOSIT, RD.GUARANTEE_CURRENCY, RD.ID_ACC_TEMPLATE_PERSON,
         RD.NUMBER_1, rd.NUMBER_2, rd.ID_GUARANTEE_POLICY, rd.BLOCK_CC, rd.IS_POSTING_STOPPED, rd.ID_EATING_OBJECT
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail_source
  into   :rd_dbkey_old, :id_agent_profile, :check_status, :arrival_date, :departure_date,
         :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff,
         :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
         :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
         :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
         :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
         :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
         :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
         :guarantee_deposit, :guarantee_currency, :id_acc_template_person,
         :number_1, :number_2,:id_guarantee_policy, :block_cc, :is_posting_stopped, :id_eating_object;

  select first 1 sp.ITEM
  from   SYSTEM_STRING_PARSER(:guest_ids, ',') sp
  into   :id_titular;

  select min(g.FROM_DATE), max(g.TO_DATE)
  from   GUEST G
  where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL_SOURCE
         and ','||:GUEST_IDS||',' containing ','||g.ID_GUEST||','
  into   :arrival_date, :departure_date;

  if (exists (select *
              from   RESERV_DETAIL RD
              where  RD.ID_TITULAR = :id_titular
                     and RD.ID_RESERV_DETAIL = :id_reserv_detail_source))
  then exception BOOKING_EXCEPTION 'Titular can not be splited in new reservation';

  execute procedure RES_GET_PERSON_PROFILE$INT(:id_titular)
  returning_values  :id_person_profile, :id_profile_data;

  new_res_number = iif(coalesce(:number_1,'')='','.',:number_1||'.')
                   || coalesce(:number_2, '')
                   || '.0';  -- fictive suffix, needed for unique constraint limitation, that will be replaced with real one


  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, :check_status, :arrival_date, :departure_date,
                    0, 0, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
                    :guarantee_deposit, :guarantee_currency, 0, null, :new_res_number, :id_acc_template_person,
                    :id_guarantee_policy, :block_cc, :id_eating_object)
  returning_values  :rd_dbkey_new, :new_id_reserv_detail, :warn_code;

  execute procedure RES_NUMBER_SUFFIX_GEN (:NEW_ID_RESERV_DETAIL)
  returning_values  (:new_res_number);  -- add suffix to new (splited) booking number (empty on create)

  update RESERV_DETAIL NR
  set    nr.IS_POSTING_STOPPED = :is_posting_stopped
  where  nr.RDB$DB_KEY = :rd_dbkey_new;

  -- there is no need guests deleting, because new splited reservation is created with 0 guests
  adult_count = 0; child_count = 0;
  for
    select G.ID_GUEST, G.RDB$DB_KEY, G.IS_CHILD
    from   SYSTEM_STRING_PARSER(:guest_ids, ',') SP
           join GUEST G on G.ID_GUEST = SP.ITEM
    into   :id_guest, :g_dbkey, :is_child
  do begin
    execute procedure GUEST_SET_EDIT_STATUS$INT (:g_dbkey, 'REBUILD', 'add');

    update GUEST G
    set    G.ID_RESERV_DETAIL = :new_id_reserv_detail
    where  G.ID_GUEST = :id_guest;

    adult_count = :adult_count + (1-:is_child);
    child_count = :child_count + :is_child;

    if (:id_guest = :id_titular) then begin
      update RESERV_DETAIL RD
      set    RD.ID_TITULAR = :id_titular
      where  RD.RDB$DB_KEY = :rd_dbkey_new;

      update GUEST_DATA GD
      set    GD.ID_PERSON_DATA = :id_profile_data
      where  GD.ID_GUEST = :id_titular;
    end
  end

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL_SOURCE, 'RES_SPLIT',
          f_character(29) || :new_res_number || f_character(28) || :adult_count || ' + ' || :child_count);

  -- calling RES_SAVE_PROFILING$INT is unnecessary, it is called into RES_CREATE_SET$INT with same params
  -- here is needed to set reserv accounts per splited guests and reroute posting only (accomplished in next procedure)
  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey_new);

  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_old);
  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_new);

  update RESERV_DETAIL ORD
  set    ord.ROOM_PRICE = null
  where  ord.RDB$DB_KEY = :rd_dbkey_old;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_old, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_new, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  if (:id_room < 0) then begin
    virtual_room = gen_id(GEN_VIRTUAL_ROOM, 1);
    update RESERV_DETAIL RD
    set    rd.VIRTUAL_ROOM = '<'||:virtual_room||'>'
    where  rd.ID_ROOM = :id_room;
  end
end
^

/* Alter (RES_SPLIT_MULTI$RSV) */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
begin
  for
    select RD.ID_RESERV_DETAIL, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :id_reserv_detail, :id_titular
  do begin
    for
      select G.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.ID_GUEST <> :id_titular
      into   :id_guest
    do begin
      execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
      returning_values  :id_splited_reservation;

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
    end
  end
end
^

/* Alter (RES_TAR_CALC_FINALIZE$INT) */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(ID_TAR_CALC INTEGER,
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
declare variable old_room_price numeric(15,4);
  declare variable old_room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
  declare variable reserv_posting_disabled smallint;
  declare variable postings_disabled smallint;
  declare variable warn_code integer;
  declare variable action_text varchar(255);
begin
  --  Razpiswa cenata na staia, kakto i price_detailite.

  execute procedure TAR_CALC_EVAL_ALL$INT(:ID_TAR_CALC)
  returning_values  :ERR_CODE, :ERR_TEXT;

  if (:ERR_CODE = 0) then execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

  select iif(si.INFO_VALUE = '1', 1, null)
  from   SYSTEM_INFO_GET('RESERV_POSTINGS_DISABLED') si
  into   :postings_disabled;

  for
    select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, coalesce(:postings_disabled, rd.IS_POSTING_STOPPED),
           coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
           coalesce(max((select first 1 AP.IS_BASE
                         from   GUEST G
                                join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                         where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (it`s possible)
    from   TAR_CALC_INPUT$TMP TI
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
           join TARIFA t on t.ID_TARIFA = rd.ID_RATE
    where  ti.ID_TAR_CALC = :ID_TAR_CALC
    group by 1, 2, 3, 4, 5, 6
    into   :id_reserv_detail, :check_status, :is_posting_stopped,
           :room_currency, :id_hotel, :is_anul, :has_postings
  do begin
    reserv_posting_disabled = iif(:is_posting_stopped = 1 and :has_postings = 0, 1, 0);

    if (:ERR_CODE <> 0) then begin
      -- price calculation error handling  !!!!!
      if (:reserv_posting_disabled = 1) then begin
        -- set price to null, posting is disabled
        update RESERV_DETAIL RD
        set    RD.ROOM_PRICE = null,
               RD.ROOM_CURRENCY = null,
               RD.ROOM_PRICE_DETAILS = null,
               RD.LAST_ID_TAR_CALC = null
        where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
      end else begin
        -- exit on error in price calculation - cannot make valid posts
        EXIT;
      end
    end else begin
      room_price = 0;
      room_price_details = '';
    
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);
  
      if (:reserv_posting_disabled = 0 and ((coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1))) then begin
        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);
      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;
  
        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end
  
      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc,
             rd.ROOM_PRICE_LAST$INT = null,
             rd.ROOM_CURRENCY_LAST$INT = null
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail
      returning old.ROOM_PRICE_LAST$INT, old.ROOM_CURRENCY_LAST$INT
      into :old_room_price, :old_room_currency;

      if ((:old_room_price is distinct from :room_price)
          or (:old_room_currency is distinct from :room_currency) ) then
      begin
        action_text = f_character(29) || formatfloat(:old_room_price, 'F;0.00') || ' ' || coalesce(:old_room_currency, '') || f_character(28) || formatfloat(:room_price, 'F;0.00') || ' ' || coalesce(:room_currency, '');
        execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_PRICE_RECALC', :action_text);
      end
    end
  end

  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;

  if (:ERR_CODE <> 0) then begin
    execute procedure SYSTEM_WARNING_ADD(:ERR_CODE, :ERR_TEXT)
    returning_values :warn_code;
    ERR_CODE = 0;
    ERR_TEXT='';
  end
end
^

/* empty dependent procedure body */
/* Clear: SAFE_CHECK_OUT for: SAFE_OCCUPANCY_MODIFY */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE /* TYPE OF ID */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER,
WARN_CODE /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SAFE_OCCUPANCY_MODIFY) */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE TYPE OF ID,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable old_booking_number tres_number;
  declare variable id_resource_reservation id_ref;
  declare variable from_datetime tdatetime;
  declare variable action_text tdescription_long;
  declare variable old_occupant varchar(100);
  declare variable old_to_dt timestamp;
  declare variable id_reserv_detail integer;
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation;

  select rr.BOOKING_NUMBER, od.FROM_DATETIME,
         RR.OCCUPANT_NAME, od.TO_DATETIME, rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESERV_DETAIL rd on rd.NUMBER = rr.BOOKING_NUMBER and rd.IS_ANUL = 0
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :old_booking_number, :from_datetime,
         :old_occupant, :old_to_dt, :id_reserv_detail, :id_agent_profile;

  --if (:old_booking_number <> :BOOKING_NUMBER) then exception ASSERT 'Can not change booking number!';
  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  update SAFE_RESOURCE_RESERV rr
  set    rr.PRICE_DESCRIPTION = :price_description,
         rr.ID_RATE_PRICE_PROFILE = :id_agent_profile,
         rr.RATING_UNITS = :rating_units,
         rr.RATE_PRICE = :price,
         rr.RATE_CURR = :currency
  where  rr.ID_RESOURCE_RESERV = :id_resource_reservation;

  execute procedure RESOURCE_RESERVATION_MODIFY (:id_resource_reservation, :ID_SAFE, :from_datetime,
          :TO_DATETIME, :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :old_booking_number, 'mod')
  returning_values :id_resource_reservation, :no_use;

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail)
  returning_values (:DOC_SELECTED);

  /* Log changes */
  if ((:old_occupant <> :OCCUPANT_NAME) or (:old_to_dt <> :TO_DATETIME)) then begin
    action_text = f_character(29) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                  || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                  || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');
  
    execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_CHANGED', :action_text);
  end
end
^

/* Alter (SAFE_OCCUPANCY_NEW) */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE TYPE OF ID,
FROM_DATETIME TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME,
BOOKING_NUMBER TYPE OF TRES_NUMBER,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
ID_RESOURCE_RESERVATION TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable action_text tdescription_long;
  declare variable id_reserv_detail integer;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, s.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  if (:id_resource_reservation is not null) then exception ASSERT '-1064'|| f_character(31) || f_character(29) || :safe_name;

  select rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESERV_DETAIL rd
  where  rd.NUMBER = :BOOKING_NUMBER
         and rd.IS_ANUL = 0
  into   :id_reserv_detail, :id_agent_profile;

  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  execute procedure  RESOURCE_RESERVATION_MODIFY (null, :ID_SAFE, :FROM_DATETIME, :TO_DATETIME,
          :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :BOOKING_NUMBER, 'add')
  returning_values (:id_resource_reservation, :no_use) ;

  insert into SAFE_RESOURCE_RESERV (ID_RESOURCE_RESERV, PRICE_DESCRIPTION, ID_RATE_PRICE_PROFILE,
         RATING_UNITS, RATE_PRICE, RATE_CURR)
  values (:id_resource_reservation, :price_description, :id_agent_profile,
         :rating_units, :price, :currency);

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail, :ID_EXTERNAL_CLIENT_ACCCOUNT)
  returning_values (:DOC_SELECTED);

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = 'CHECKED_IN'
  where  RR.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = :id_resource_reservation
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                || f_character(28) || coalesce(:BOOKING_NUMBER, '')
                || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUPIED', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_TRANSFER$INT for: SYSTEM_EVENT_LOG$INT */
ALTER PROCEDURE DEPOSIT_TRANSFER$INT(ID_DEPOSIT /* TYPE OF ID */ INTEGER,
ID_DEST_ACCOUNT /* TYPE OF ID */ INTEGER,
SPLIT_AMOUNT /* TYPE OF TPRICE */ NUMERIC(15,4),
DEPOSIT_DESCRIPTION /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
TRANSFER_REASON /* TYPE OF TREASON */ VARCHAR(50) = null)
 RETURNS(NEW_ID_DEPOSIT /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ANUL$DOC for: SYSTEM_EVENT_LOG$INT */
ALTER PROCEDURE DOCUMENT_ANUL$DOC(ID_DOC_HEAD INTEGER,
ANUL_REASON VARCHAR(100),
MAKE_ANNUL_REPORT SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PAYMENT_ANUL$INT for: SYSTEM_EVENT_LOG$INT */
ALTER PROCEDURE PAYMENT_ANUL$INT(ID_PAYMENT_HEAD INTEGER,
ANUL_REASON VARCHAR(100))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_ANUL_DETAIL$INT for: SYSTEM_EVENT_LOG$INT */
ALTER PROCEDURE RES_ANUL_DETAIL$INT(RD_DBKEY CHAR(8),
REASON VARCHAR(50),
CANCELATION_NUMBER /* TYPE OF NAME_20 */ VARCHAR(20) = null)
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_LOG$INT for: SYSTEM_EVENT_LOG$INT */
ALTER PROCEDURE RES_CREATE_LOG$INT(RD_DBKEY CHAR(8))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SALE_TAXATION_MODIFY$CFG for: SYSTEM_EVENT_LOG$INT */
ALTER PROCEDURE SALE_TAXATION_MODIFY$CFG(ID_SALE_TAXATION /* TYPE OF ID */ INTEGER,
NAME /* TYPE OF TOBJECT_NAME */ VARCHAR(50),
TAXES VARCHAR(250),
ACCOUNT_NAME /* TYPE OF TOBJECT_NAME */ VARCHAR(50),
OPERATION VARCHAR(10),
ID_HOTEL /* TYPE OF ID */ INTEGER)
 RETURNS(NEW_ID_SALE_TAXATION INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SYSTEM_LOG_ADD for: SYSTEM_EVENT_LOG$INT */
ALTER PROCEDURE SYSTEM_LOG_ADD(OBJECT_CLASS VARCHAR(30),
OBJECT_ID INTEGER,
ACTION_CODE VARCHAR(50),
ACTION_TEXT VARCHAR(255),
EXTRA_DATA VARCHAR(255) = null)
 AS
 BEGIN EXIT; END
^

/* Alter (SYSTEM_EVENT_LOG$INT) */
ALTER PROCEDURE SYSTEM_EVENT_LOG$INT(OBJECT_CLASS VARCHAR(30),
OBJECT_ID INTEGER,
EVENT_CODE VARCHAR(50),
EVENT_TEXT VARCHAR(255),
EXTRA_DATA VARCHAR(255) = null)
 RETURNS(NEW_ID_SYSTEM_LOG INTEGER)
 AS
declare variable machine_name varchar(30);
  declare variable log_object_class varchar(30);
  declare variable log_object_id integer;
  declare variable action_ctx varchar(50);
begin
  if (RDB$GET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE') = 'disable') then EXIT;

  action_ctx = RDB$GET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX');

  execute procedure SYSTEM_SESSION_GET('MACHINE_NAME')
  returning_values  :machine_name;

  object_id = coalesce(object_id,0);
  log_object_class = :object_class;
  log_object_id = :object_id;


  new_id_system_log = gen_id(gen_system_log_id, 1);

  insert into SYSTEM_LOG_EVENT (ID_SYSTEM_LOG, LOG_OBJECT_CLASS, LOG_OBJECT_ID, ACTION_CODE,
         ACTION_DATETIME, ACTION_USER, MACHINE_NAME, ACTION_TEXT, ACTION_CTX)
  values (:new_id_system_log, :log_object_class, :log_object_id, :event_code,
         current_timestamp, current_user, :machine_name, :event_text, :action_ctx);

  -- get related bookings
  if (:OBJECT_CLASS = 'RES_DETAIL') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    values (:OBJECT_ID, :new_id_system_log);
  end else if (:OBJECT_CLASS = 'GUEST') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select G.ID_RESERV_DETAIL, :new_id_system_log
    from   GUEST G
    where  G.ID_GUEST = :OBJECT_ID;
  end else if (:OBJECT_CLASS = 'DOCUMENT') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select A.ID_RESERV_DETAIL, :new_id_system_log
    from   DOC_HEAD D
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  D.ID_DOC = :OBJECT_ID
           and A.ID_RESERV_DETAIL is not null;
  end else if (:OBJECT_CLASS = 'DEPOSIT') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select A.ID_RESERV_DETAIL, :new_id_system_log
    from   DEPOSIT D
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  D.ID_DEPOSIT = :OBJECT_ID
           and A.ID_RESERV_DETAIL is not null;
  end else if (:OBJECT_CLASS = 'PAYMENT') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select distinct A.ID_RESERV_DETAIL, :new_id_system_log
    from   PAYMENT_HEAD P
           join DEPOSIT D on D.ID_PAYMENT_HEAD = P.ID_PAYMENT_HEAD
           join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
    where  P.ID_PAYMENT_HEAD = :OBJECT_ID
           and A.ID_RESERV_DETAIL is not null;
  end else if (:OBJECT_CLASS = 'ACCOUNT') then begin
    insert into SYSTEM_LOG_RESERV (ID_RESERV_DETAIL, ID_SYSTEM_LOG)
    select A.ID_RESERV_DETAIL, :new_id_system_log
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :OBJECT_ID
           and A.ID_RESERV_DETAIL is not null;
  end

  if (:EVENT_CODE = 'DELETE') then begin
    insert into SYSTEM_LOG_DELETED (LOG_OBJECT_CLASS, LOG_OBJECT_ID, DESCRIPTION, HOTEL_CODE)
    select :log_object_class, :log_object_id, SL.OBJECT_DESCRIPTION, SL.HOTEL_CODE
    from   SYSTEM_LOG_OBJECT_INFO_GET (:OBJECT_CLASS, :OBJECT_ID) SL;
  end

  if (:EXTRA_DATA is not null) then begin
    insert into SYSTEM_LOG_EXTRA (ID_SYSTEM_LOG, EXTRA_DATA)
    values (:new_id_system_log, :EXTRA_DATA);
  end

  if (exists(
    select *
    from   EAI_EVENTQ_PUBLISH P
    where  P.ACTION_CODE = :EVENT_CODE
  )) then post_event 'EAI_EVENTQ';

end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_MODIFY$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACCOUNT_MODIFY$INT(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL /* TYPE OF ID_REF */ INTEGER,
IS_PMS_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_MODIFY_TEMPLATE$PROFILE for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACCOUNT_MODIFY_TEMPLATE$PROFILE(ID_ACC_TEMPLATE INTEGER,
TEMPLATE_NAME VARCHAR(40),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,4),
SECURITY_LEVEL INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
ID_TAX_POLICY INTEGER,
IS_ARCHIVE INTEGER,
OPERATION VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(NEW_ID_ACC_TEMPLATE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_ANUL for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACCOUNT_POSTING_ANUL(IN_ID_ACCOUNT_POST INTEGER,
IN_ANUL_REASON VARCHAR(70))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_DOC_UPDATE$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACCOUNT_POSTING_DOC_UPDATE$INT(DH_DBKEY /* TYPE OF TDB_KEY */ CHAR(8))
 RETURNS(WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_MULTIANUL for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACCOUNT_POSTING_MULTIANUL(AP_LIST VARCHAR(4096),
ANUL_REASON VARCHAR(70))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_SET_ARCHIVE_STATUS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACCOUNT_SET_ARCHIVE_STATUS(ID_ACCOUNT INTEGER,
IS_ARCHIVE SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_SET_CREDIT_STATUS$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACCOUNT_SET_CREDIT_STATUS$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
IS_CREDIT_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT,
CREDIT_LIMIT /* TYPE OF TPRICE */ NUMERIC(15,4),
SET_UNCONDITIONAL /* TYPE OF TLOGICAL */ SMALLINT = 0)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_SET_CURRENCY$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACCOUNT_SET_CURRENCY$INT(A_DBKEY CHAR(8),
NEW_CURR CHAR(3))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACTIVITY_OFFER_COPY for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ACTIVITY_OFFER_COPY(ID_ACTIVITY_OFFER /* TYPE OF ID */ INTEGER)
 RETURNS(NEW_ID_ACTIVITY_OFFER /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: AR_OWING_ADD$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE AR_OWING_ADD$INT(ID_PROFILE /* TYPE OF ID */ INTEGER,
SUM_OWING /* TYPE OF TPRICE */ NUMERIC(15,4),
CURR_OWING /* TYPE OF TCURRENCY */ CHAR(3),
ID_DOC_HEAD /* TYPE OF ID_REF */ INTEGER,
DUE_DATE /* TYPE OF TDATE */ DATE,
SYSTEM_DATE /* TYPE OF TDATE */ DATE,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_AR_TYPE /* TYPE OF ID */ INTEGER,
ID_HOTEL /* TYPE OF ID */ INTEGER)
 RETURNS(NEW_ID_AR_OWING /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: AR_OWING_ANUL$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE AR_OWING_ANUL$INT(ID_AR_OWING /* TYPE OF ID */ INTEGER,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IS_MANUAL_ANUL /* TYPE OF TLOGICAL */ SMALLINT = 1)
 RETURNS(NEW_ID_AR_OWING /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: AR_OWING_PAYMENT_ADD$AR for: SYSTEM_LOG_ADD */
ALTER PROCEDURE AR_OWING_PAYMENT_ADD$AR(ID_AR_OWING INTEGER,
ID_AR_PAYMENT INTEGER,
SUM_OWING NUMERIC(15,4),
SUM_PAYMENT NUMERIC(15,4),
PAYMENT_RATE_TO_BGN NUMERIC(15,6),
OWING_RATE_TO_BGN NUMERIC(15,6),
DESCRIPTION VARCHAR(255))
 RETURNS(NEW_ID_AR_OWING_PAYMENT_POST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: AR_OWING_PAYMENT_ANUL$AR for: SYSTEM_LOG_ADD */
ALTER PROCEDURE AR_OWING_PAYMENT_ANUL$AR(ID_AR_OWING_PAYMENT_POST INTEGER,
DESCRIPTION VARCHAR(255))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: AR_PAYMENT_ADD$AR for: SYSTEM_LOG_ADD */
ALTER PROCEDURE AR_PAYMENT_ADD$AR(ID_PROFILE /* TYPE OF ID */ INTEGER,
ID_AR_PAYMENT_TYPE /* TYPE OF ID_REF */ INTEGER,
ACCOUNT_NAME /* TYPE OF TNAME_SHORT */ VARCHAR(30),
SUM_PAYMENT /* TYPE OF TPRICE */ NUMERIC(15,4),
CURR_PAYMENT /* TYPE OF TCURRENCY */ CHAR(3),
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
DATE_PAYMENT /* TYPE OF TDATE */ DATE)
 RETURNS(NEW_ID_AR_PAYMENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: AR_PAYMENT_ANUL$AR for: SYSTEM_LOG_ADD */
ALTER PROCEDURE AR_PAYMENT_ANUL$AR(ID_AR_PAYMENT INTEGER,
DESCRIPTION VARCHAR(255))
 RETURNS(NEW_ID_AR_PAYMENT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: BLOCK_ANNUL$BLK for: SYSTEM_LOG_ADD */
ALTER PROCEDURE BLOCK_ANNUL$BLK(ID_BLOCK_ROOM INTEGER,
OPERATION VARCHAR(30))
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: BLOCK_CREATE$BLK for: SYSTEM_LOG_ADD */
ALTER PROCEDURE BLOCK_CREATE$BLK(ROOM_NAMES /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_HOTEL /* TYPE OF ID */ INTEGER,
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
BLOCK_GRP /* TYPE OF TRANGE */ INTEGER,
REASON /* TYPE OF TREASON */ VARCHAR(50),
NOTE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IS_FULL_FROM /* TYPE OF TRANGE */ INTEGER,
IS_FULL_TO /* TYPE OF TRANGE */ INTEGER)
 RETURNS(NEW_ID_BLOCK_ROOM /* TYPE OF ID */ INTEGER,
SHARE_TRANSACTION_ID /* TYPE OF ID */ INTEGER,
SHARE_ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE /* TYPE OF ID */ INTEGER,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: BLOCK_MODIFY$BLK for: SYSTEM_LOG_ADD */
ALTER PROCEDURE BLOCK_MODIFY$BLK(ID_BLOCK_ROOM INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
BLOCK_GRP INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
IS_FULL_FROM INTEGER,
IS_FULL_TO INTEGER)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: CONTRACT_CALENDAR_MODIFY$PMS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE CONTRACT_CALENDAR_MODIFY$PMS(ID_CONTRACT_CALENDAR_POST /* TYPE OF ID */ INTEGER,
ID_ROOM_CONTRACT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
IS_INCOME /* TYPE OF TLOGICAL */ SMALLINT,
SERVICE_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
ID_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
IS_ACC_POST_ITEM /* TYPE OF TLOGICAL */ SMALLINT,
POSTING_DATE_LIST /* TYPE OF TTEXT_EXTENDED */ VARCHAR(2000),
POSTING_PERIOD_DURATION /* TYPE OF TCOUNT */ INTEGER,
MONTH_NEXT_DATE /* TYPE OF TDATE */ DATE,
IS_FIXED_DATE /* TYPE OF TLOGICAL */ SMALLINT,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_CALENDAR_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: CONTRACT_EXPENSE_MODIFY$PMS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE CONTRACT_EXPENSE_MODIFY$PMS(ID_CONTRACT_EXPENSE /* TYPE OF ID */ INTEGER,
ID_CONTRACT /* TYPE OF ID */ INTEGER,
SUB_CONTRACT /* TYPE OF TSUB_CONTRACT */ VARCHAR(10),
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
SERVICE_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
CONTRACT_EXPENSE_TYPE VARCHAR(50),
MULTIPLIER_TYPE VARCHAR(50),
ORDER_TAG /* TYPE OF TCOUNT */ INTEGER,
IS_ACC_POST_ITEM /* TYPE OF TLOGICAL */ SMALLINT,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_EXPENSE /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: CONTRACT_MANAGEMENT_MODIFY$PMS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE CONTRACT_MANAGEMENT_MODIFY$PMS(ID_CONTRACT_MANAGEMENT /* TYPE OF ID */ INTEGER,
ID_CONTRACT /* TYPE OF ID */ INTEGER,
SUB_CONTRACT /* TYPE OF TSUB_CONTRACT */ VARCHAR(10),
ID_SERVICE /* TYPE OF ID */ INTEGER,
MIN_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
MIN_VALUE_CURR /* TYPE OF TCURRENCY */ CHAR(3),
MAX_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
MAX_VALUE_CURR /* TYPE OF TCURRENCY */ CHAR(3),
NIGHT_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
NIGHT_PRICE_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IS_NETO /* TYPE OF TLOGICAL */ SMALLINT,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_MANAGEMENT /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: CURR_RATE_MODIFY for: SYSTEM_LOG_ADD */
ALTER PROCEDURE CURR_RATE_MODIFY(CURR CHAR(3),
ID_HOTEL INTEGER,
RATE NUMERIC(15,6),
FOR_DATE DATE = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_ANUL$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE DEPOSIT_ANUL$INT(ID_DEPOSIT INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_PAYMENT_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_NEW$DOC for: SYSTEM_LOG_ADD */
ALTER PROCEDURE DEPOSIT_NEW$DOC(ID_ACCOUNT INTEGER,
ID_DOC_TYPE INTEGER,
PAY_VALUE NUMERIC(15,4),
PAY_CURRENCY VARCHAR(3),
DESCRIPTION VARCHAR(100),
ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_DEPOSIT INTEGER,
ID_PAYMENT_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_REFUND$DOC for: SYSTEM_LOG_ADD */
ALTER PROCEDURE DEPOSIT_REFUND$DOC(ID_DEPOSIT INTEGER,
REFUND_AMOUNT NUMERIC(15,4),
REFUND_CURRENCY VARCHAR(3),
ID_PAY_DOC_TYPE INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_REFUND_PAYMENT INTEGER,
ID_STORNO_DOC INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_REFUND_PAY_ANNUL$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE DEPOSIT_REFUND_PAY_ANNUL$INT(ID_REFUND_PAYMENT INTEGER,
ANNUL_REASON VARCHAR(255) = '')
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_DELETE$DOC for: SYSTEM_LOG_ADD */
ALTER PROCEDURE DOCUMENT_DELETE$DOC(ID_DOC_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_PRENUMERATE$DOC for: SYSTEM_LOG_ADD */
ALTER PROCEDURE DOCUMENT_PRENUMERATE$DOC(SELECTION_ID INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_STORNO$DOC for: SYSTEM_LOG_ADD */
ALTER PROCEDURE DOCUMENT_STORNO$DOC(ID_DOC_HEAD INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_STORNO_DOC INTEGER,
ID_HOTEL INTEGER,
ID_ACCOUNT INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_VALIDATE$DOC for: SYSTEM_LOG_ADD */
ALTER PROCEDURE DOCUMENT_VALIDATE$DOC(ID_DOC_HEAD /* TYPE OF ID_REF */ INTEGER)
 RETURNS(FIRM_DATA /* TYPE OF TNOTE_BLOB */ BLOB SUB_TYPE 1,
WARN_CODE /* TYPE OF TRANGE */ INTEGER,
NEW_DOC_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: EAI_AIRCONDITION_SMARTSTART for: SYSTEM_LOG_ADD */
ALTER PROCEDURE EAI_AIRCONDITION_SMARTSTART AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: EAI_EVENTQ_ADD for: SYSTEM_LOG_ADD */
ALTER PROCEDURE EAI_EVENTQ_ADD(EAI_IFC VARCHAR(50),
EVENT_CODE VARCHAR(50),
OBJECT_ID INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: END_WORK for: SYSTEM_LOG_ADD */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: FISCALIZE_MARK_DOC$FISC for: SYSTEM_LOG_ADD */
ALTER PROCEDURE FISCALIZE_MARK_DOC$FISC(ID_DOC_HEAD INTEGER,
IS_MANUAL INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: GUEST_ADDRESSCARD_SET$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$RSV(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
EGN VARCHAR(30),
COUNTRY VARCHAR(10),
ID_STAY_REASON INTEGER,
IS_REGISTRED INTEGER,
PASS_PLACE VARCHAR(20),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_PLACE VARCHAR(30),
SEX CHAR,
MASK VARCHAR(10),
IS_CHILD INTEGER,
CAR VARCHAR(30),
KPP INTEGER,
KPP_DATE DATE,
PASS_EXP_DATE DATE,
AGE INTEGER,
BIRTH_DAY DATE,
VISA /* TDESCRIPTION_SHORT */ VARCHAR(100),
RATING_AGE INTEGER = null,
TITLE VARCHAR(10) = null,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: OCCUPANCY_SUMMARY_REMAKE$SYS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE OCCUPANCY_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PERSON_DATA_SET$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE PERSON_DATA_SET$INT(P_DBKEY CHAR(8),
PD_DBKEY CHAR(8),
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
COUNTRY VARCHAR(10),
BIRTH_DAY DATE,
BIRTHDAY_INTERNAL DATE,
TITLE VARCHAR(10) = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONE_LINE_CONVERT_MODIFY$CFG for: SYSTEM_LOG_ADD */
ALTER PROCEDURE PHONE_LINE_CONVERT_MODIFY$CFG(ID INTEGER,
LINE VARCHAR(30),
ROOM_NAME VARCHAR(30),
IS_TAXABLE SMALLINT,
IS_ARCHIVE SMALLINT,
PRICE_INDEX NUMERIC(15,4),
ID_HOTEL INTEGER,
ID_ACCOUNT INTEGER,
OPERATION VARCHAR(10))
 RETURNS(NEW_ID INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_AGENT_MODIFY$PROFILE for: SYSTEM_LOG_ADD */
ALTER PROCEDURE PROFILE_AGENT_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
IS_ARCHIVE INTEGER,
AGENT_GROUP VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IATA_NUMBER VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null,
THRESHOLD_NOTE VARCHAR(255) = null,
THRESHOLD_AMOUNT NUMERIC(15,4) = null,
THRESHOLD_CURR CHAR(3) = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_COMMON_MODIFY$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE PROFILE_COMMON_MODIFY$INT(ID_PROFILE INTEGER,
PROFILE_TYPE VARCHAR(20),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
IS_ARCHIVE INTEGER,
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_DELETE$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE PROFILE_DELETE$INT(ID_PROFILE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_HOUSE_MODIFY$PROFILE for: SYSTEM_LOG_ADD */
ALTER PROCEDURE PROFILE_HOUSE_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(20),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
IS_ARCHIVE INTEGER,
HOUSE_TYPE VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_MERGE$PROFILE for: SYSTEM_LOG_ADD */
ALTER PROCEDURE PROFILE_MERGE$PROFILE(ID_SOURCE INTEGER,
ID_TARGET INTEGER,
OPERATION VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_PERSON_CREATEQ$PROFILE for: SYSTEM_LOG_ADD */
ALTER PROCEDURE PROFILE_PERSON_CREATEQ$PROFILE(PROFILE_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100),
PHONE /* TYPE OF TPHONE */ VARCHAR(50),
ID_PASSPORT_TYPE /* TYPE OF ID */ INTEGER,
PASS_NUM /* TYPE OF NAME_20 */ VARCHAR(20),
EGN /* TYPE OF TTEXT_SHORT */ VARCHAR(30),
COUNTRY_CODE /* TYPE OF TSHORT_CODE */ VARCHAR(10),
CARD_CODE /* TYPE OF TCARD_CODE */ VARCHAR(50),
ID_PERSON_DATA /* TYPE OF ID_REF */ INTEGER = null,
TITLE /* TYPE OF TSHORT_CODE */ VARCHAR(10) = null,
ID_HOTEL /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_PROFILE /* TYPE OF ID */ INTEGER,
P_DBKEY /* TYPE OF TDB_KEY */ CHAR(8),
PD_DBKEY /* TYPE OF TDB_KEY */ CHAR(8))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_CHECK_OUT_GUESTS$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_CHECK_OUT_GUESTS$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND SMALLINT = 0,
EARLYCHECKOUT_DATE DATE = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_CHECKIN$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_DELETE$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_DELETE$INT(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_ADD$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_GUEST_ADD$INT(RD_DBKEY CHAR(8),
IS_CHILD INTEGER,
INITIALIZE_BOOKING /* TYPE OF TLOGICAL */ SMALLINT = 0)
 RETURNS(NEW_ID_GUEST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_DEL$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_GUEST_DEL$INT(ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50) = null)
 RETURNS(EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_SAVE_BOARD$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_GUEST_SAVE_BOARD$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_BOARD INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_SAVE_OTHER$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_GUEST_SAVE_OTHER$RSV(ID_GUEST INTEGER,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_SAVE_RATE$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_GUEST_SAVE_RATE$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TARIFF INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_SAVE_ROOMTYPE$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_GUEST_SAVE_ROOMTYPE$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TAR_ROOM_TYPE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_SAVE_STAY$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_GUEST_SAVE_STAY$RSV(ID_GUEST INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_SAVE_TYPESTAY$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_GUEST_SAVE_TYPESTAY$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TYPE_STAY INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTS_FINALIZE$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_ACCOUNTS_FINALIZE$INT(ID_RESERV_DETAIL INTEGER,
OLD_ID_BASE_ACCOUNT INTEGER,
OLD_ID_EXTRA_ACCOUNT INTEGER,
NEW_ID_BASE_ACCOUNT INTEGER,
NEW_ID_EXTRA_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_BOARD$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_BOARD$INT(RD_DBKEY CHAR(8),
ID_BOARD INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_GUARANTEE$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_GUARANTEE$RSV(ID_RESERV_DETAIL INTEGER,
IS_VIP SMALLINT,
CHECK_STATUS INTEGER,
ID_GUARANTEE_POLICY INTEGER,
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_MARKETING$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_MARKETING$RSV(ID_RESERV_DETAIL INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_PRICE$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_PRICE$RSV(ID_RESERV_DETAIL INTEGER,
FOR_DATE DATE,
PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_RATE$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_RATE$INT(RD_DBKEY CHAR(8),
ID_RATE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ROOM_LOG$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_ROOM_LOG$INT(RD_DBKEY CHAR(8),
OLD_ID_ROOM INTEGER,
OLD_ID_RES_ROOM_TYPE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_STATUS$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_STATUS$INT(RD_DBKEY CHAR(8),
CHECK_STATUS INTEGER,
CONFIRMATION_NUMBER /* TYPE OF NAME_20 */ VARCHAR(20) = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_STAY$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_STAY$INT(RD_DBKEY CHAR(8),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_VOUCHER$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SAVE_VOUCHER$INT(RD_DBKEY CHAR(8),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_MULTI$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RES_SET_ROOM_MULTI$RSV(OPERATION VARCHAR(20),
FROM_ROOM VARCHAR(20),
SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESERV_DETAIL_EXTERNAL_MOD$RSV for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RESERV_DETAIL_EXTERNAL_MOD$RSV(ID_RESERV_DETAIL INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
LOCATOR VARCHAR(100))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RESERVS_EXPIRE$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RESERVS_EXPIRE$INT(CLEAR_TODATE DATE,
ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RESGRP_SAVE_OTHER$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RESGRP_SAVE_OTHER$INT(RD_DBKEY CHAR(8),
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: REVENUE_SUMMARY_REMAKE$SYS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE REVENUE_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
STATISTIC_ONLY SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RIGHTS_GROUP_MODIFY for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RIGHTS_GROUP_MODIFY(ID_RIGHT_GROUP INTEGER,
GROUP_NAME VARCHAR(20),
GROUP_DESCRIPTION VARCHAR(100),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_RIGHT_GROUP INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RIGHTS_GROUP_REPORTS_MODIFY for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RIGHTS_GROUP_REPORTS_MODIFY(ID_RIGHT_GROUP INTEGER,
REPORT_NAME VARCHAR(200),
OPERATION VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RIGHTS_GROUP_RIGHTS_MODIFY for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RIGHTS_GROUP_RIGHTS_MODIFY(ID_RIGHT_GROUP INTEGER,
RIGHT_CODE VARCHAR(30),
VALUE_CODE INTEGER,
OPERATION VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RIGHTS_GROUP_USER_MODIFY for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RIGHTS_GROUP_USER_MODIFY(USER_NAME VARCHAR(30),
ID_RIGHT_GROUP INTEGER,
OPERATION VARCHAR(50))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RIGHTS_MODIFY_USER for: SYSTEM_LOG_ADD */
ALTER PROCEDURE RIGHTS_MODIFY_USER(IN_USER_NAME VARCHAR(30),
IN_USER_NAME_LONG VARCHAR(30),
IN_NEW_PASSWORD VARCHAR(8),
LANG_UI VARCHAR(10),
FISCAL_ID INTEGER,
IS_ACTIVE INTEGER,
OPERATION VARCHAR(20),
CODE VARCHAR(50))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ROOM_CONTRACT_MODIFY$PMS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ROOM_CONTRACT_MODIFY$PMS(ID_ROOM_CONTRACT INTEGER,
ID_ROOM_PERIOD INTEGER,
CONTRACT_TYPE VARCHAR(50),
PMS_MARKERS BLOB SUB_TYPE 1 SEGMENT SIZE 100,
IMPORT_INCOME_WITH_VAT SMALLINT,
ID_RENTAL_POOL INTEGER,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_CONTRACT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_MODIFY$PMS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ROOM_MODIFY$PMS(ID_ROOM INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
BEDS INTEGER,
EXTRA_BEDS INTEGER,
SECTOR INTEGER,
SORT_ORDER INTEGER,
FEATURES BLOB SUB_TYPE 1 SEGMENT SIZE 100,
EXTERNAL_NAME VARCHAR(20),
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER,
OPERATION VARCHAR(20))
 RETURNS(OVERRULE_NEED SMALLINT,
OVERRULE_CONTEXT VARCHAR(255),
NEW_ID_ROOM INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_OWNER_MODIFY$PMS for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ROOM_OWNER_MODIFY$PMS(ID_ROOM_OWNER INTEGER,
ID_ROOM_CONTRACT INTEGER,
ID_OWNER INTEGER,
OWNERSHIP_PERCENT NUMERIC(15,4),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_OWNER INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_PERIOD_ADD$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ROOM_PERIOD_ADD$INT(ID_ROOM_PERIOD INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
STATUS VARCHAR(30))
 RETURNS(NEW_ID_ROOM_PERIOD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ROOM_PERIOD_DEL$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ROOM_PERIOD_DEL$INT(ID_ROOM_PERIOD INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ROOM_PERIOD_MODIFY$INT for: SYSTEM_LOG_ADD */
ALTER PROCEDURE ROOM_PERIOD_MODIFY$INT(ID_ROOM_PERIOD INTEGER,
FROM_DATE DATE,
STATUS VARCHAR(30))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_ANNUL for: SYSTEM_LOG_ADD */
ALTER PROCEDURE SAFE_OCCUPANCY_ANNUL(ID_SAFE /* TYPE OF ID */ INTEGER,
REASON /* TYPE OF TREASON */ VARCHAR(50))
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SALE_TAX_MODIFY$CFG for: SYSTEM_LOG_ADD */
ALTER PROCEDURE SALE_TAX_MODIFY$CFG(ID_SALE_TAX INTEGER,
TAX_NAME VARCHAR(50),
TAX_PERCENT NUMERIC(15,4),
TAXABLE_BASE_PERCENT NUMERIC(15,4),
TAX_VALUE NUMERIC(15,4),
REVENUE_DEDUCTION_TAX SMALLINT,
REPORT_IN_DOCUMENT SMALLINT,
FISCAL_CODE VARCHAR(30),
ACCOUNT_NAME VARCHAR(50),
OPERATION VARCHAR(10),
ID_HOTEL /* TYPE OF ID */ INTEGER,
TAXATION_REASON /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255))
 RETURNS(NEW_ID_SALE_TAX INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SERVICE_TAXATION_MODIFY$CFG for: SYSTEM_LOG_ADD */
ALTER PROCEDURE SERVICE_TAXATION_MODIFY$CFG(ID_TAX_POLICY /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_SALE_TAXATION /* TYPE OF ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SETTINGS_MODIFY_VALUE for: SYSTEM_LOG_ADD */
ALTER PROCEDURE SETTINGS_MODIFY_VALUE(SETTING_CODE /* TYPE OF TSEARCH_CODE */ VARCHAR(30),
SETTING_VALUE /* TYPE OF TOBJECT_TEXT */ VARCHAR(50),
ID_HOTEL /* TYPE OF ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SYSTEM_LOGON_USER for: SYSTEM_LOG_ADD */
ALTER PROCEDURE SYSTEM_LOGON_USER(OPERATION VARCHAR(20),
MACHINE_NAME VARCHAR(50))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: TAR_SAVE for: SYSTEM_LOG_ADD */
ALTER PROCEDURE TAR_SAVE(ID_TAR_HEAD INTEGER,
PERIOD_DEPEND_ON_CHECKIN INTEGER,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BASE_BOARDS_LIST VARCHAR(255),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
BO_TYPE VARCHAR(20),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TASK_MODIFY for: SYSTEM_LOG_ADD */
ALTER PROCEDURE TASK_MODIFY(ID_TASK INTEGER,
DESCRIPTION VARCHAR(255),
DT_ACTIVATE TIMESTAMP,
STATUS SMALLINT,
TYPE_ SMALLINT,
PRIORITY SMALLINT,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_TASK INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAX_POLICY_MODIFY$CFG for: SYSTEM_LOG_ADD */
ALTER PROCEDURE TAX_POLICY_MODIFY$CFG(ID_TAX_POLICY /* TYPE OF ID */ INTEGER,
POLICY_NAME /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
IS_ARCHIVE /* TYPE OF TLOGICAL */ SMALLINT,
OPERATION VARCHAR(10),
ID_HOTEL /* TYPE OF ID */ INTEGER)
 RETURNS(NEW_ID_TAX_POLICY INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SYSTEM_LOG_ADD) */
ALTER PROCEDURE SYSTEM_LOG_ADD(OBJECT_CLASS VARCHAR(30),
OBJECT_ID INTEGER,
ACTION_CODE VARCHAR(50),
ACTION_TEXT VARCHAR(255),
EXTRA_DATA VARCHAR(255) = null)
 AS
declare variable new_id_system_log integer;
begin
  -- Description: fasade without output parameter (id)
  execute procedure SYSTEM_EVENT_LOG$INT(:OBJECT_CLASS, :OBJECT_ID, :ACTION_CODE, :ACTION_TEXT, :EXTRA_DATA)
  returning_values  :new_id_system_log;
end
^

/* Alter (SYSTEM_LOGON_USER) */
ALTER PROCEDURE SYSTEM_LOGON_USER(OPERATION VARCHAR(20),
MACHINE_NAME VARCHAR(50))
 AS
begin

  if (:operation = 'log_on') then begin
    execute procedure SYSTEM_SESSION_SET('MACHINE_NAME', :MACHINE_NAME);
    execute procedure SYSTEM_LOG_ADD ('SYSTEM', 0, 'APP_LOG_ON', '');

    execute procedure SYSTEM_SESSION_SET('LOGON_ID', gen_id(gen_system_log_id, 1));

  end else if (:operation = 'log_off') then begin
    execute procedure SYSTEM_LOG_ADD ('SYSTEM', 0, 'APP_LOG_OFF', '');

  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_INPUT_PARAMS$INT for: TAR_CALC_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_PARAMS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_PARAMS$INT) */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
declare variable param_code varchar(40);
  declare variable id_param integer;
  declare variable param_value varchar(255);
  declare variable data_type  varchar(30);
  declare variable rate_list varchar(2000);
begin
  err_code = 0;
  param_values = '';

  if (coalesce(:rate_list_replace, '') = '') then rate_list = ',' || :id_rate || ',';
  else rate_list = :rate_list_replace;

  for
    select distinct TBP.PARAM_NAME
    from   SYSTEM_STRING_PARSER (:rate_list, ',') sp
           left join TAR_BO_PARAMS TBP on TBP.ID_TAR_HEAD = sp.ITEM
    where  (TBP.PARAM_TYPE <> 'DATE_DEPENDANT' and :for_date is null)
           or (TBP.PARAM_TYPE = 'DATE_DEPENDANT' and :for_date is not null)
    into   :param_code
  do begin
    if (:param_code is not null) then begin
      id_param = null;
      select TP.ID_TARIFA_PARAM, TP.DATA_TYPE
      from   TARIFA_PARAMS TP
      where  TP.PARAM_CODE = :param_code
             and tp.IS_USE = 1
      into   :id_param, :data_type;
  
      if (:id_param is null) then begin
        err_code = -202;
        execute procedure sys_dbg ('tar calc params err_code: ' || :err_code || F_CRLF() || 'PARAM_CODE = ' || :param_code);
        exit;
      end
  
      execute procedure TARIFA_GET_PARAM (:id_param, :for_date, :id_tar_input, :id_tar_calc)
      returning_values (:param_value);
  
      param_code = ':'||param_code;
  
      if ((:param_code is not null) and (:param_code is not null) and (:data_type is not null)) then
         param_values = :param_values||';'||:param_code||','||:data_type||','||:param_value;
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_RATE_RECORD_RELINK$EXC for: TAR_SAVE */
ALTER PROCEDURE IMPORT_RATE_RECORD_RELINK$EXC(ID_RATE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_SAVE) */
ALTER PROCEDURE TAR_SAVE(ID_TAR_HEAD INTEGER,
PERIOD_DEPEND_ON_CHECKIN INTEGER,
CNT_DAYS_PRICE_BP INTEGER,
CNT_DAYS_PRICE_BOARD INTEGER,
BASE_BOARDS_LIST VARCHAR(255),
BOARD_TYPE VARCHAR(10))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
BO_TYPE VARCHAR(20),
ROW_ID INTEGER,
COL_ID INTEGER,
PARAM_NAME VARCHAR(20))
 AS
declare variable delim integer;
  declare variable id_hotel integer;
  declare variable action_text varchar(255);
begin
  if (:base_boards_list is null) then base_boards_list = '';
  if (:board_type not in ('BOARD', 'HRANI')) then begin
    if (:board_type = '0') then board_type = 'BOARD';
    else board_type = 'HRANI';
  end
  err_code = 0;
  err_text = '';
  execute procedure SETTING_GET_VALUE('RANGE_DATA_DELIMETER', null)
  returning_values  :delim;

  -- TAR_BO_PRICES are never cleared
  delete from TAR_BO_SEASON
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_BASE_POSITION
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_BOARD
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_EXTRA_GUEST
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_DISCOUNT
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_PACK
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_PARAMS
  where  ID_TAR_HEAD = :id_tar_head;
  delete from TAR_BO_DISCOUNT_STAY
  where  ID_TAR_HEAD = :id_tar_head;
  update TAR_HEAD TH
  set    PERIOD_DEPEND_ON_CHECKIN = :period_depend_on_checkin,
         CNT_DAYS_PRICE_BP        = :cnt_days_price_bp,
         CNT_DAYS_PRICE_BOARD     = :cnt_days_price_board,
         BASE_BOARDS_LIST         = coalesce(f_character(:delim)|| (select list(p.item, f_character(:delim)) from SYSTEM_STRING_PARSER(:base_boards_list, f_character(:delim)) p) || f_character(:delim), ''),
         BOARD_TYPE               = :board_type,
         LOCK_STAMP               = current_timestamp
  where  TH.ID_TAR_HEAD = :id_tar_head;
  update TARIFA T
  set    T.IS_BASE = 1
  where  T.ID_TARIFA = :id_tar_head;
  bo_type = 'SEASON';
  execute procedure TAR_SAVE_BO_SEASON(:id_tar_head)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'BASE';
  execute procedure TAR_SAVE_BO_BP(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'BOARD';
  execute procedure TAR_SAVE_BO_BOARD(:id_tar_head, :bo_type, :board_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'EXTRA_GUEST';
  execute procedure TAR_SAVE_BO_EG(:id_tar_head, :bo_type, :board_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'PACK';
  execute procedure TAR_SAVE_BO_PACK(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'DISCOUNT';
  execute procedure TAR_SAVE_BO_DISC(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end
  bo_type = 'DISCOUNT_PERIOD';
  execute procedure TAR_SAVE_BO_DISC_PERIOD(:id_tar_head, :bo_type)
  returning_values  :err_code, :err_text, :row_id, :col_id, :param_name;
  if (:err_code < 0) then begin suspend; exit; end

  select f_character(29) || T.TARIFA_NAME, T.id_hotel
  from   TARIFA T
  where  T.ID_TARIFA = :ID_TAR_HEAD
  into   :action_text, :id_hotel;

  execute procedure EXPORT_LOG_INSERT$EXC ('RATE_BASE', :id_tar_head, :id_hotel, 0);

  execute procedure SYSTEM_LOG_ADD ('RATE', :ID_TAR_HEAD, 'RATE_CHANGED', :action_text);

  when any do begin
    err_code = -200;
    err_text = 'OBJECT='||'NONE'||', '||:err_text;
    exception;
  end
end
^

/* Alter (TASK_MODIFY) */
ALTER PROCEDURE TASK_MODIFY(ID_TASK INTEGER,
DESCRIPTION VARCHAR(255),
DT_ACTIVATE TIMESTAMP,
STATUS SMALLINT,
TYPE_ SMALLINT,
PRIORITY SMALLINT,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_TASK INTEGER)
 AS
declare variable oldStatus smallint;
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del, undel, complete, snooze');

  if ((:id_task is null) or (:id_task <= 0)) then
    new_id_task = gen_id(GEN_TASK_ID, 1);
  else new_id_task = :id_task;
                              
  if (:operation = 'add') then begin
    insert into TASK (ID_TASK, DESCRIPTION, DT_ACTIVATE, DT_CREATE, USER_CREATE, STATUS, PRIORITY, IS_DELETED, TYPE_)
    values (:new_id_task, :description, :dt_activate, current_timestamp, current_user, :status, :priority, 0, :type_);
  end else if (:operation = 'mod') then begin
    select STATUS
    from  TASK
    where  ID_TASK = :id_task
    into :oldStatus;

    update TASK
    set    DESCRIPTION = :description,
           DT_ACTIVATE = :dt_activate,
           STATUS = :status,
           PRIORITY = :priority,
           TYPE_ = :type_
    where  ID_TASK = :id_task;

    if (:oldStatus <> :status) then
      if (status = 1) then begin
        execute procedure TASK_MODIFY (:id_task, :description, :dt_activate, :status, :type_, priority, 'complete')
        returning_values :new_id_task;
      end
  end else if (:operation = 'del') then begin
    update TASK
    set    IS_DELETED = 1,
           USER_DELETED = current_user,
           DT_DELETED = current_timestamp
    where  ID_TASK = :id_task;
  end else if (:operation = 'undel') then begin
    update TASK
    set    IS_DELETED = 0
    where  ID_TASK = :id_task;
  end else if (:operation = 'complete') then begin
    update TASK
    set    STATUS = 1,
           USER_COMPLETED = current_user,
           DT_COMPLETED = current_timestamp
    where  ID_TASK = :id_task;
  end else if (:operation = 'snooze') then begin
    update TASK
    set    STATUS = 0,
           DT_ACTIVATE = ADDMINUTE(current_timestamp,extract(minute from :dt_activate)+extract(hour from :dt_activate)*60)
    where  ID_TASK = :id_task;
  end
  execute procedure SYSTEM_CACHE_APPLY('task');
  execute procedure SYSTEM_CACHE_APPLY('task_lm');

  execute procedure SYSTEM_LOG_ADD('SYSTEM', :new_id_task, 'TASK_CHANGED', '');
end
^

/* empty dependent procedure body */
/* Clear: HOTEL_AUTO_IMPORT$WBE for: TAX_POLICY_MODIFY$CFG */
ALTER PROCEDURE HOTEL_AUTO_IMPORT$WBE(NAME VARCHAR(50),
UUID VARCHAR(40))
 RETURNS(ID_HOTEL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAX_POLICY_MODIFY$CFG) */
ALTER PROCEDURE TAX_POLICY_MODIFY$CFG(ID_TAX_POLICY TYPE OF ID,
POLICY_NAME TYPE OF TDESCRIPTION_SHORT,
IS_ARCHIVE TYPE OF TLOGICAL,
OPERATION VARCHAR(10),
ID_HOTEL TYPE OF ID)
 RETURNS(NEW_ID_TAX_POLICY INTEGER)
 AS
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation = 'add') then begin
    insert into TAX_POLICY (ID_TAX_POLICY, POLICY_NAME, IS_ARCHIVE, ID_HOTEL)
    values (nullif(:ID_TAX_POLICY, -1), :POLICY_NAME, :IS_ARCHIVE, :ID_HOTEL)
    returning ID_TAX_POLICY
    into      :NEW_ID_TAX_POLICY;

  end else if (:operation = 'mod') then begin
    update TAX_POLICY TP
    set    TP.POLICY_NAME = :POLICY_NAME,
           TP.IS_ARCHIVE = :is_archive
    where  TP.ID_TAX_POLICY = :ID_TAX_POLICY;

    NEW_ID_TAX_POLICY = :ID_TAX_POLICY;
  end else if (:operation = 'del') then begin
    execute procedure SYSTEM_LOG_ADD ('TAX_POLICY', :ID_TAX_POLICY, 'DELETE', '');
    delete from TAX_POLICY TP
    where  TP.ID_TAX_POLICY = :ID_TAX_POLICY;

    NEW_ID_TAX_POLICY = null;
  end

  execute procedure SYSTEM_CACHE_APPLY('TAX_POLICY');
end
^

/* Alter (TEST_BOOKING_IMPORT) */
ALTER PROCEDURE TEST_BOOKING_IMPORT AS
declare variable dbg varchar(255);
  declare variable booking_id integer;
begin
  dbg = null;
  EXECUTE PROCEDURE IMPORT_BOOKING$EXC ('SOL NESSEBAR BAY', 'EXP.3', null, null, 0,
  cast('17.11.2008' as date), null, cast('19.11.2008' as date),
  null, null, null, null, null, 'LARGE_ROOM', 'BB', null, null, '????????', 'MIXED', 'EXPEDIA-BAY',
  null, null, null, null, '?????? ??????', null, null, null, null, 'Business - Corporate',
  'Companies (FIR)', 'E-Mail (EMA)', 'Advert (ANZ)', 'Activities (ANI)', 'A room with a view.(4)',
  null, null, 2, 2, 'e43a4cc0-7d73-47cc-bd07-a98c18c714a3', null, '0D074F966A187B2A9912B5F0E213FEB4',
  0, 0, 0, null, null, null, null, null, null, null, null, null, null,  null, null, null, null, null, null, null, null)
  returning_values (:dbg, :booking_id, :dbg, :dbg);
  dbg = null;
end
^

/* Restore proc. body: ACCOUNT_MODIFY$INT */
ALTER PROCEDURE ACCOUNT_MODIFY$INT(ID_ACCOUNT INTEGER,
ID_PROFILE INTEGER,
ACCOUNT_CURR VARCHAR(3),
ACCOUNT_NAME VARCHAR(50),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,2),
ID_TYPE_PAYMENT INTEGER,
NOTE VARCHAR(255),
IS_BLOCKED INTEGER,
BLOCK_TEXT VARCHAR(50),
SECURITY_LEVEL INTEGER,
IS_BASE INTEGER,
IS_EXTRA INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
POS_INTERFACE_NOTE VARCHAR(255),
EXT_CODE VARCHAR(30),
ID_TAX_POLICY INTEGER,
IS_DEFAULT SMALLINT,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL TYPE OF ID_REF,
IS_PMS_ACCOUNT TYPE OF TLOGICAL,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ACCOUNT INTEGER)
 AS
declare variable a_dbkey char(8);
  declare variable old_sec_level integer;
  declare variable action_text varchar(255);
  declare variable old_acc_name varchar(50);
  declare variable old_acc_curr varchar(3);
  declare variable old_tax_policy integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, archive');

  new_id_account = :id_account;
  if (:operation = 'add') then begin
    if ((:new_id_account is null) or (:new_id_account <= 0)) then new_id_account = gen_id(ID_ACCOUNT_GEN, 1);

    insert into ACCOUNT(ID_ACCOUNT, ACCOUNT_CURR, ACCOUNT_NAME, IS_CREDIT_ACCOUNT, CREDIT_LIMIT,
           ID_TYPE_PAYMENT, NOTE, IS_BLOCKED, BLOCK_TEXT, SECURITY_LEVEL, IS_BASE, IS_EXTRA,
           IS_ALOWED_POS_INTERFACE, POS_INTERFACE_NOTE, EXT_CODE, ID_TAX_POLICY, ID_PROFILE,
           ID_HOTEL, IS_DEFAULT, IS_PMS_ACCOUNT, ID_RESERV_DETAIL)
    values (:new_id_account, :account_curr, :account_name, 0, null,
           :id_type_payment, :note, :is_blocked, :block_text, :security_level, :is_base, :is_extra,
           :is_alowed_pos_interface, :pos_interface_note, :ext_code, :id_tax_policy, :id_profile,
           :id_hotel, :is_default, coalesce(:IS_PMS_ACCOUNT, 0), :ID_RESERV_DETAIL)
    returning RDB$DB_KEY
    into   :a_dbkey;

    action_text = f_character(29) || :new_id_account || '/' || :account_name;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'ADD_ACCOUNT', :action_text);

    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:NEW_ID_ACCOUNT, :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT);
    -- check special right and log event

  end else begin
    ID_RESERV_DETAIL = null;
    select A.RDB$DB_KEY, A.ID_RESERV_DETAIL, A.SECURITY_LEVEL,
           A.ACCOUNT_NAME, A.ACCOUNT_CURR, A.ID_TAX_POLICY
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :a_dbkey, :id_reserv_detail, :old_sec_level,
           :old_acc_name, :old_acc_curr, :old_tax_policy;
    if (:operation = 'mod') then begin
  
      update ACCOUNT A
      set    A.ACCOUNT_NAME = :account_name,
             A.ID_TYPE_PAYMENT = :id_type_payment,
             A.NOTE = :note,
             A.IS_BLOCKED = :is_blocked,
             A.BLOCK_TEXT = :block_text,
             A.SECURITY_LEVEL = :security_level,
             A.IS_BASE = :is_base,
             A.IS_EXTRA = :is_extra,
             A.IS_ALOWED_POS_INTERFACE = :is_alowed_pos_interface,
             A.POS_INTERFACE_NOTE = :pos_interface_note,
             A.EXT_CODE = :ext_code,
             A.ID_TAX_POLICY = :id_tax_policy,
             A.IS_DEFAULT = :is_default
      where  A.RDB$DB_KEY = :a_dbkey;
  
      execute procedure ACCOUNT_SET_CURRENCY$INT (:a_dbkey, :account_curr);
  
      if (:old_acc_name <> :account_name) then begin
        action_text = f_character(29 ) || :ID_ACCOUNT || '/' || :old_acc_name || ', ' || :old_acc_curr
                      || f_character(28) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME || ', ' || :ACCOUNT_CURR;
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'EDIT_ACCOUNT', :action_text);
      end
  
      if (:old_sec_level <> :SECURITY_LEVEL) then begin
        action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME
                      || f_character(28) || :SECURITY_LEVEL;
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'SET_ACC_SEC_LEVEL', :action_text);
      end
  
      if (:old_tax_policy <> :id_tax_policy) then begin
        execute procedure ACCOUNT_TAXATION_RECALC$INT (:ID_ACCOUNT, :ID_TAX_POLICY);
  
        action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME;                        
  
        select :action_text || f_character(28) || OTP.POLICY_NAME
        from   TAX_POLICY OTP
        where  OTP.ID_TAX_POLICY = :old_tax_policy
        into   :action_text;
        select :action_text || f_character(28) || NTP.POLICY_NAME
        from   TAX_POLICY NTP
        where  NTP.ID_TAX_POLICY = :ID_TAX_POLICY
        into   :action_text;
         
        execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'VAT_POLICY_CHNG', :action_text);
      end
  
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:ID_ACCOUNT, :IS_CREDIT_ACCOUNT, :CREDIT_LIMIT); -- check special right and log event
  
    end else if (:operation = 'archive') then begin
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:id_account, 1);

    end
  end

  if ((:id_reserv_detail is null) and (:IS_CREDIT_ACCOUNT = 0)) then begin
    exception ACCOUNT_EXCEPTION '-1010';
    -- The account must have active credit status
    exit;
  end

  if (:is_default = 1) then begin
    update ACCOUNT A
    set    A.IS_DEFAULT = 0
    where  A.ID_HOTEL = :id_hotel
           and A.ID_PROFILE = :id_profile
           and A.ID_ACCOUNT <> :new_id_account;
  end
end
^

/* Restore proc. body: ACCOUNT_MODIFY_TEMPLATE$PROFILE */
ALTER PROCEDURE ACCOUNT_MODIFY_TEMPLATE$PROFILE(ID_ACC_TEMPLATE INTEGER,
TEMPLATE_NAME VARCHAR(40),
IS_CREDIT_ACCOUNT INTEGER,
CREDIT_LIMIT NUMERIC(15,4),
SECURITY_LEVEL INTEGER,
IS_ALOWED_POS_INTERFACE INTEGER,
ID_TAX_POLICY INTEGER,
IS_ARCHIVE INTEGER,
OPERATION VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(NEW_ID_ACC_TEMPLATE INTEGER)
 AS
declare variable action_text varchar(255);
declare variable tax_policy_name varchar(100);
declare variable old_template_name varchar(50);
declare variable old_security_level integer;
declare variable old_is_credit_account smallint;
declare variable old_credit_limit numeric(15,4);
declare variable old_is_alowed_pos_interface smallint;
declare variable old_id_tax_policy integer;
declare variable old_is_archive integer;
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  new_id_acc_template = :id_acc_template;
  if (:operation = 'add') then begin
    if ((:new_id_acc_template is null) or (:new_id_acc_template <= 0)) then new_id_acc_template = gen_id(ID_ACCOUNT_GEN, 1);

    insert into ACC_TEMPLATE (ID_ACC_TEMPLATE, TEMPLATE_NAME, SECURITY_LEVEL, IS_CREDIT_ACCOUNT, CREDIT_LIMIT,
           IS_ALOWED_POS_INTERFACE, ID_TAX_POLICY, IS_ARCHIVE, ID_HOTEL)
    values (:new_id_acc_template, :template_name, :security_level, :is_credit_account, :credit_limit,
           :is_alowed_pos_interface, :id_tax_policy, 0, :ID_HOTEL);

    action_text = f_character(29) || :template_name;
    execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACCOUNT_TEMPLATE_CREATE', :action_text);

  end else if (:operation = 'mod') then begin
    select act.template_name,
           act.security_level,
           act.is_credit_account,
           act.credit_limit,
           act.is_alowed_pos_interface,
           act.id_tax_policy,
           act.is_archive
    from   ACC_TEMPLATE act
    where  act.id_acc_template = :id_acc_template
    into   :old_template_name, :old_security_level, :old_is_credit_account, :old_credit_limit, :old_is_alowed_pos_interface,
           :old_id_tax_policy, :old_is_archive;
    if (:template_name <> :old_template_name) then begin
      action_text = f_character(29) || :old_template_name || f_character(28) || :template_name;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_NAME_CHANGED', :action_text);
    end
    if (:security_level <> :old_security_level) then begin
      action_text = f_character(29) || :old_security_level || f_character(28) || :security_level;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_SEC_LEVEL_CHANGED', :action_text);
    end
    if (:is_credit_account <> :old_is_credit_account) then begin
      action_text = f_character(29) || :old_is_credit_account || f_character(28) || :is_credit_account;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_CR_ACC_CHANGED', :action_text);
    end
    if (coalesce(:credit_limit, 0) <> coalesce(:old_credit_limit, 0)) then begin
      action_text = f_character(29) || formatfloat(:old_credit_limit, '0.00') || f_character(28) || formatfloat(:credit_limit, '0.00');
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_CR_LIM_CHANGED', :action_text);
    end
    if (:is_alowed_pos_interface <> :old_is_alowed_pos_interface) then begin
      action_text = f_character(29) || :old_is_alowed_pos_interface || f_character(28) || :is_alowed_pos_interface;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_POS_CHANGED', :action_text);
    end
    if (:id_tax_policy <> :old_id_tax_policy) then begin
      select f_character(29) || policy_name
      from tax_policy
      where id_tax_policy = :old_id_tax_policy
      into :action_text;
      select f_character(28) || policy_name
      from tax_policy
      where id_tax_policy = :id_tax_policy
      into :tax_policy_name;
      action_text = :action_text || :tax_policy_name;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_TAX_POL_CHANGED', :action_text);
    end
    if (:is_archive <> :old_is_archive) then begin
      action_text = f_character(29) || :old_is_archive|| f_character(28) || :is_archive;
      execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_IS_ARCH_CHANGED', :action_text);
    end
    update ACC_TEMPLATE
    set    TEMPLATE_NAME = :template_name,
           SECURITY_LEVEL = :security_level,
           IS_CREDIT_ACCOUNT = :is_credit_account,
           CREDIT_LIMIT = :credit_limit,
           IS_ALOWED_POS_INTERFACE = :is_alowed_pos_interface,
           ID_TAX_POLICY = :id_tax_policy,
           IS_ARCHIVE = :is_archive
    where  ID_ACC_TEMPLATE = :id_acc_template;
  end else if (:operation = 'del') then begin
    select template_name
    from   ACC_TEMPLATE
    where  ID_ACC_TEMPLATE = :id_acc_template
    into   :old_template_name;

    execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'DELETE', '');

    delete from ACC_TEMPLATE
    where  ID_ACC_TEMPLATE = :id_acc_template;

  --  action_text = f_character(29) || :old_template_name;
  --  execute procedure SYSTEM_LOG_ADD ('ACC_TEMPLATE', :NEW_ID_ACC_TEMPLATE, 'ACC_TEMPL_DELETED', :action_text);
  end

end
^

/* Restore proc. body: ACCOUNT_POST_MODIFY$PMS */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
declare variable id_account integer;
  declare variable id_service integer;
  declare variable date_post date;
  declare variable is_owner_income smallint;
  declare variable is_account_post_item smallint;
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable no_use_id_acc_post integer;
  declare variable ap_dbkey char(8);
begin
  -- da se wika samo ot GUI
  if ( (:ID_ACCOUNT_POST is null) and (:ID_ACCOUNT_POST_PMS is null) ) then begin
    exception WRONG_PARAM_VALUE;
    exit;
  end

  is_account_post_item = iif(:id_account_post is not null, 1, 0);

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'mod, anul');

  if (:operation in ('mod', 'anul')) then begin
    -- prowerka: ot GUI-to mogat da se anulirat samo nedokumentirani i neanulirani nachisleniq
    if (:is_account_post_item = 1) then begin
      if ( (:ID_PMS_EVENT > 0) and
           not exists ( select *
                        from   PMS_EVENT_POST PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      select ap.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  ap.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
      into   :ap_dbkey;

      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_dbkey, 'PMS GUI VOID');

      update PMS_EVENT_POST PP
      set    PP.LINE_STATUS = 22
      where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST;

    end else if (:ID_ACCOUNT_POST_PMS is not null) then begin
      if ( not exists ( select *
                        from   ACCOUNT_POST$PMS PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      execute procedure ACCOUNT_POST_PMS_ANUL$INT(:ID_PMS_EVENT, :ID_ACCOUNT_POST_PMS);
    end

    if (:operation = 'mod') then begin
      id_account = null;
      if (:is_account_post_item = 1) then begin
        select AP.ID_ACCOUNT, AP.ID_SERVICE, AP.DATE_POST, PP.ID_OWNER, 0, ap.id_room
        from   ACCOUNT_POST AP
               join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and PP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :id_owner, :is_owner_income, :id_room;
      end else begin
        select AP.ID_ACCOUNT_PMS, AP.ID_SERVICE, AP.DATE_POST, AP.IS_OWNER_INCOME, AP.ID_OWNER
        from   ACCOUNT_POST$PMS AP
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
               and AP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :is_owner_income, :id_owner;
      end
      if (:id_account is null) then exit;

      execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_account, :id_service, :id_owner, :date_post,
              :in_curr_orig, :in_value_orig, 1 - :is_account_post_item, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* Restore proc. body: ACCOUNT_POSTING_ANUL */
ALTER PROCEDURE ACCOUNT_POSTING_ANUL(IN_ID_ACCOUNT_POST INTEGER,
IN_ANUL_REASON VARCHAR(70))
 AS
declare variable action_text varchar(255);
  declare variable id_account integer;
  declare variable qty_post numeric(15,2);
  declare variable price_post double precision;
  declare variable date_post date;
  declare variable id_service integer;
  declare variable curr_post varchar(3);
  declare variable ap_dbkey char(8);
begin
  /* called only from GUI - manual anullment */
  select AP.RDB$DB_KEY, AP.ID_ACCOUNT, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST
  from   ACCOUNT_POST AP
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :ap_dbkey, :id_account, :qty_post, :price_post,
         :date_post, :id_service, :curr_post;

  execute procedure ACCOUNT_POSTING_ANUL$INT (:ap_dbkey, :IN_ANUL_REASON);

  select S.SERVICE_NAME
  from   SERVICES S
  where  S.ID_SERVICE = :id_service
  into   :action_text;

  action_text = f_character(29) || :action_text
                || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:qty_post * :price_post, 'F;0.00') || ' ' || :curr_post
                || f_character(28) || replace(:IN_ANUL_REASON, 'MANUAL', '');
  execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_ANUL', :action_text);
end
^

/* Restore proc. body: ACCOUNT_POSTING_DOC_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_DOC_UPDATE$INT(DH_DBKEY TYPE OF TDB_KEY)
 RETURNS(WARN_CODE TYPE OF TRANGE)
 AS
declare variable date_post date;
  declare variable old_date_post date;
  declare variable curr_post varchar(3);
  declare variable old_curr_post varchar(3);
  declare variable rate_post numeric(15,6);
  declare variable curr_orig varchar(3);
  declare variable old_curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable dbkey char(8);
  declare variable id_account_post integer;
  declare variable doc_date date;
  declare variable doc_release_ap integer;
  declare variable qty_post numeric(15,2);
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable price_orig numeric(15,4);
  declare variable price_post double precision;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable id_sale_taxation integer;
  declare variable id_base_doc integer;
  declare variable doc_operation varchar(10);
  declare variable is_anul_doc integer;
  declare variable is_storno integer;
  declare variable id_doc_head integer;
  declare variable posts_value double precision;
  declare variable line_value double precision ;
  declare variable action_text varchar(255);
  declare variable action_code varchar(30);
  declare variable account_curr varchar(3);
  declare variable id_ap_base_doc integer;
  declare variable new_is_anul integer;
  declare variable new_is_closed integer;
  declare variable doc_qty numeric(15,2);
  declare variable doc_price double precision;
  declare variable id_hotel integer;
  declare variable round_to numeric(15,4);
  declare variable proforma_dt_created timestamp;
  declare variable new_ac varchar(2);
  declare variable id_tax_policy integer;
  declare variable id_service integer;
  declare variable nat_round_to numeric(15,4);
begin

  select D.ID_DOC_HEAD, iif(D.IS_ANUL = 0, D.DOC_DATE, DA.ANNULMENT_DATE),
         D.ID_BASE_DOC, D.IS_ANUL, D.IS_STORNO, a.ID_TAX_POLICY, c.ROUND_TO,
         A.ID_ACCOUNT, A.ACCOUNT_CURR, a.id_hotel, pd.DATETIME_CREATED
  from   DOC_HEAD$INT D
         join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join HOTEL h on h.ID_HOTEL = a.ID_HOTEL
         join CURRS c on c.CURR = h.NATION_CURR
         left outer join DOC_ANNULMENT DA on DA.ID_DOC_HEAD = D.ID_DOC_HEAD
         left outer join DOC_HEAD$INT pd on pd.ID_DOC_HEAD = dc.ID_DOC_PROFORMA
  where  D.RDB$DB_KEY = :DH_DBKEY
  into   :id_doc_head, :doc_date, :id_base_doc, :is_anul_doc, :is_storno, :id_tax_policy, :nat_round_to,
         :id_account, :account_curr, :id_hotel, :proforma_dt_created;

  if (:id_doc_head is null) then exit;

  doc_operation = case when :is_anul_doc = 1 then 'anul'
                       when :is_storno   = 1 then 'storno'
                       else 'new'
                  end;

  doc_release_ap = -gen_id(DOC_SELECTED_GEN, 1);
  /*   */
  posts_value = 0;
  if (:doc_operation = 'new') then begin
    for
      select AP.RDB$DB_KEY, AP.ID_ACCOUNT_POST, DL.QTY_POST, PV.ACCOUNT_PRICE,
             ap.QTY_POST, ap.PRICE_POST, c.ROUND_TO
      from   ACCOUNT_POST AP
             join DOC_LINE_POST_VALUES PV on PV.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
             join DOC_LINE DL on DL.ID_DOC_LINE = PV.ID_DOC_LINE
             join CURRS C on c.CURR = ap.CURR_POST
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
      into   :dbkey, :id_account_post, :doc_qty, :doc_price,
             :qty_post, :price_post, :round_to
    do begin
      /*  if (:is_anul = 1) - annul corrective document, else - new valid document */
      /* annulment/storno of base document is in other case - operation "anul"  */
      if (:proforma_dt_created is not null) then begin
        new_is_anul = 0;
        new_is_closed = iif(cast(round_f(:qty_post - :doc_qty, :round_to) as numeric(15,2)) = 0
                            and cast(round_f(:price_post - :doc_price, :round_to) as numeric(15,2)) = 0,
                            1,
                            0);
      end else begin
        new_is_anul = 0;
        new_is_closed = 1;
        doc_qty = :qty_post;
        doc_price = :price_post;
      end

      update ACCOUNT_POST AP
      set    AP.ID_BASE_DOC   = :id_base_doc,
             AP.IN_DOC_QTY    = :doc_qty,
             AP.IN_DOC_VALUE  = :doc_price,
             AP.IS_ANUL       = :new_is_anul,
             AP.AC            = :new_is_anul || :new_is_closed,
             AP.DOC_SELECTED  = :doc_release_ap,
             AP.DATETIME_CHANGED = current_timestamp
      where  AP.RDB$DB_KEY = :DBKEY
      returning ap.ac into :new_ac;
      if (:new_ac = '00') then begin
        execute procedure SYSTEM_WARNING_ADD (-1061, '')
        returning_values (:warn_code);
      end

      update ACCOUNT_POST_CORRECTION APCU
      set    APCU.ID_DOC_HEAD  = iif(apcu.DATETIME_CREATED < coalesce(:proforma_dt_created, current_timestamp), :ID_DOC_HEAD, -1),
             APCU.IS_OPEN      = iif(apcu.DATETIME_CREATED < coalesce(:proforma_dt_created, current_timestamp), 0, 1)
      where  APCU.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
             and coalesce(APCU.ID_DOC_HEAD, -1) = -1;

      posts_value = :posts_value + :doc_price * :doc_qty;
    end

    action_text = f_character(29) || formatfloat(abs(:posts_value), 'F;0.00') || ' ' || :account_curr;
    action_code = 'CLOSE_POSTINGS';
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, :action_code, :action_text);

  end else if (:doc_operation in ('anul', 'storno')) then begin
    /* annulment/storno of base document - release all postings */
    /*   */
    old_date_post = '01.01.1900';
    old_curr_post = '';
    old_curr_orig = '';
    posts_value = 0;
    /*   */
    for
      select distinct AP.RDB$DB_KEY, AP.ID_ACCOUNT, AP.ID_GUEST, AP.ID_SALE_TAXATION, AP.ID_BASE_DOC,
             AP.QTY_POST, AP.PRICE_POST, AP.DATE_POST, AP.CURR_POST, AP.CURR_ORIG, AP.PRICE_ORIG,
             AP.ID_ACCOUNT_POST, AP.POST_NET_VALUE, AP.POST_GROSS_VALUE, AP.RATE_POST, AP.RATE_ORIG,
             PV.ACCOUNT_PRICE * DL.QTY_POST, c.ROUND_TO, ap.ID_SERVICE
      from   ACCOUNT_POST AP
             join DOC_LINE_POST_VALUES PV on PV.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
             join DOC_LINE DL on DL.ID_DOC_LINE = PV.ID_DOC_LINE
             join CURRS C on c.CURR = ap.CURR_POST
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
      order by AP.DATE_POST, AP.CURR_POST, AP.CURR_ORIG
      into   :dbkey, :id_account, :id_guest, :id_sale_taxation, :id_ap_base_doc,
             :qty_post, :price_post, :date_post, :curr_post, :curr_orig, :price_orig,
             :id_account_post, :post_net_value, :post_gross_value, :rate_post, :rate_orig,
             :line_value, :round_to, :id_service
    do begin
      if (:id_ap_base_doc is not null and :id_ap_base_doc is distinct from :id_base_doc) then
        exception DOCUMENT_EXCEPTION '-365';

      doc_qty = null;
      doc_price = 0;
      if (:DOC_OPERATION = 'anul') then begin
        select sum(DL.QTY_POST * (1 - DL.IS_CORRECT)) as DOC_QTY,
               sum(DLP.ACCOUNT_PRICE * DL.QTY_POST) /* / sum(DL.QTY_POST * (1 - DL.IS_CORRECT))*/ as DOC_VALUE
        from   DOC_HEAD DH
               join DOC_LINE DL on DL.ID_DOC_HEAD = DH.ID_DOC
               join DOC_LINE_POST_VALUES DLP on dlp.ID_DOC_LINE = dl.ID_DOC_LINE
        where  DH.IS_ANUL = 0
               and DLP.ID_ACCOUNT_POST = :id_account_post
               and DH.ID_BASE_DOC = :id_base_doc
        into   :doc_qty, :doc_price;
        if (:doc_qty = 0) then doc_price = 0;
        else doc_price = :doc_price / :doc_qty;
      end

      if (:doc_qty is null) then begin
        -- update prices only for released posting
        select tp.ID_SALE_TAXATION
        from   SERVICE_TAXATION tp
        where  tp.ID_TAX_POLICY = :id_tax_policy
               and tp.ID_SERVICE = :id_service
        into   :id_sale_taxation;  -- get actual taxation

        if (:date_post >= :doc_date) then begin
          /* update rates for prepaid postings (date_post >= doc_date) if base doc is annul */
          if ((:old_date_post <> :date_post) or (:old_curr_post <> :curr_post) ) then begin
            execute procedure ACCOUNT_POSTING_RATE_GET (:id_hotel, :curr_post, :date_post, :id_guest)
            returning_values  :RATE_POST;
          end
    
          if ((:OLD_DATE_POST <> :DATE_POST) or (:OLD_CURR_ORIG <> :CURR_ORIG) ) then begin
            execute procedure ACCOUNT_POSTING_RATE_GET (:id_hotel, :curr_orig, :date_post, :id_guest)
            returning_values  :rate_orig;
          end
  
          execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:qty_post, :price_orig,
                            :rate_orig, :rate_post, :id_sale_taxation)
          returning_values  :price_post, :post_net_value, :post_gross_value;
        end else begin
          -- recalc only nat net value with actual taxation
          select tv.VALUE_WOT_TAX
          from   TAX_VALUE_DEDUCT (:qty_post * :price_post * :rate_post, :nat_round_to, :id_sale_taxation) tv
          into   :post_net_value;
        end
      end

      new_is_anul = iif(:qty_post = 0 and :doc_qty is null, 1, 0);
      new_is_closed = iif(:doc_qty is not null
                          and cast(round_f(:qty_post - :doc_qty, :round_to) as numeric(15,2)) = 0
                          and cast(round_f(:price_post - :doc_price, :round_to)  as numeric(15,2)) = 0,
                          1,
                          0);

      update ACCOUNT_POST AP
      set    AP.IN_DOC_VALUE  = iif(:doc_qty is null, 0, :doc_price),
             AP.IN_DOC_QTY    = iif(:doc_qty is null, 0, :doc_qty),
             AP.RATE_ORIG     = :rate_orig,
             AP.RATE_POST     = :rate_post,
             AP.PRICE_POST    = :price_post,
             AP.POST_NET_VALUE = :post_net_value,
             AP.POST_GROSS_VALUE = :post_gross_value,
             AP.ID_SALE_TAXATION  = :id_sale_taxation,
             AP.ID_BASE_DOC   = iif(:doc_qty is null, null, :ID_BASE_DOC),
             AP.IS_ANUL       = :new_is_anul,
             AP.AC            = :new_is_anul || :new_is_closed,
             AP.ANUL_DATETIME = iif(:new_is_anul = 1, current_timestamp, ap.anul_datetime),
             AP.DATETIME_CHANGED = current_timestamp
      where  AP.RDB$DB_KEY = :DBKEY;

      if (:doc_operation = 'anul') then begin
        update ACCOUNT_POST_CORRECTION APCU
        set    APCU.ID_DOC_HEAD  = -1,
               APCU.IS_OPEN      = iif(:DOC_QTY is not null, 1, apcu.IS_OPEN)
        where  APCU.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and APCU.ID_DOC_HEAD = :ID_DOC_HEAD;
      end else begin  -- 'storno'
        update ACCOUNT_POST_CORRECTION APCU
        set    APCU.ID_DOC_HEAD  = -1,
               APCU.IS_OPEN      = iif(:DOC_QTY is not null, 1, apcu.IS_OPEN)
        where  APCU.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and APCU.ID_DOC_HEAD in (select d.ID_DOC from DOC_HEAD d where d.ID_BASE_DOC = :id_base_doc);
      end

      old_curr_post = :curr_post;
      old_curr_orig = :curr_orig;

      posts_value = :posts_value + :line_value;
    end  /* for select ... do begin  */

    action_text = f_character(29) || formatfloat(abs(:posts_value), 'F;0.00') || ' ' || :account_curr;
    action_code = 'OPEN_POSTINGS';
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, :action_code, :action_text);
  end  /* call type in (STORNO, ANUL)  */
end
^

/* Restore proc. body: ACCOUNT_POSTING_MULTIANUL */
ALTER PROCEDURE ACCOUNT_POSTING_MULTIANUL(AP_LIST VARCHAR(4096),
ANUL_REASON VARCHAR(70))
 AS
declare variable ap_dbkey char(8);
  declare variable id_account integer;
  declare variable prev_id_account integer;
  declare variable curr_post varchar(3);
  declare variable post_value double precision;
  declare variable log_curr varchar(3);
  declare variable log_value double precision;
  declare variable action_text varchar(255);
begin
  prev_id_account = null;
  log_value = 0;
  for
    select AP.RDB$DB_KEY, AP.ID_ACCOUNT, AP.CURR_POST, AP.QTY_POST * AP.PRICE_POST
    from   SYSTEM_STRING_PARSER(:ap_list, ',') SP
           left outer join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = SP.ITEM
    order by AP.ID_ACCOUNT asc
    into   :ap_dbkey, :id_account, :curr_post, :post_value
  do begin
    execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_dbkey,  :anul_reason);

    if (:prev_id_account is not null and :prev_id_account <> :id_account) then begin
      action_text = f_character(29) || formatfloat(:log_value, 'F;0.00') || ' ' || :log_curr
                    || f_character(28) || replace(:ANUL_REASON, 'MANUAL', '');
      execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_MULTIANUL', :action_text);
    end
    log_value = :log_value + :post_value;
    log_curr = :curr_post;
    prev_id_account = :id_account;
  end

  if (:id_account is not null) then begin
    action_text = f_character(29) || formatfloat(:log_value, 'F;0.00') || ' ' || :log_curr
                  || f_character(28) || replace(:ANUL_REASON, 'MANUAL', '');
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_MULTIANUL', :action_text);
 end
end
^

/* Restore proc. body: ACCOUNT_POSTING_TRANSFER$ACC */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
declare variable ap_dbkey char(8);
  declare variable transfer_value double precision;
  declare variable post_value double precision;
  declare variable id_account integer;
  declare variable tmp_id_account integer;
  declare variable curr_post varchar(3);
  declare variable acc_name varchar(50);
  declare variable action_text varchar(255);
  declare variable is_pms_account integer;
  declare variable dest_acc_name varchar(50);
begin

  id_account = null;
  transfer_value = 0;

  select ACC.ACCOUNT_NAME, acc.IS_PMS_ACCOUNT
  from   ACCOUNT ACC
  where  ACC.ID_ACCOUNT = :ID_DEST_ACCOUNT
  into   :dest_acc_name, is_pms_account;

  if (:is_pms_account = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('PMS_TRANSFER_POSTINGS');
  end

  for
    select AP.RDB$DB_KEY, AP.ID_ACCOUNT, ap.PRICE_POST * ap.QTY_POST
    from   ACCOUNT_POST AP
    where  AP.DOC_SELECTED = :DOC_SELECTED
           and AP.ID_ACCOUNT = coalesce(:ID_SRC_ACCOUNT, AP.ID_ACCOUNT)
           and AP.ID_ACCOUNT is distinct from :ID_DEST_ACCOUNT
    order by AP.ID_ACCOUNT asc
    into   :ap_dbkey, :tmp_id_account, :post_value
  do begin
    execute procedure ACCOUNT_POSTING_TRANSFER$INT (:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:id_account is null) then id_account = :tmp_id_account;

    /* update from/to pms account */
    execute procedure ACCOUNT_POST_EVENT_REROUTE$INT(:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:tmp_id_account is distinct from :id_account) then begin
      select A.ACCOUNT_NAME, A.ACCOUNT_CURR
      from   ACCOUNT A
      where  A.ID_ACCOUNT = :id_account
      into   :acc_name, :curr_post;

      action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                    f_character(28) || :id_account || '/' || :acc_name ||
                    f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
      execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
      id_account = :tmp_id_account;
      transfer_value = 0;
    end
    transfer_value = :transfer_value + :post_value;
  end

  if (:id_account is not null) then begin
    select A.ACCOUNT_NAME, A.ACCOUNT_CURR
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :acc_name, :curr_post;
  
    action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                  f_character(28) || :id_account || '/' || :acc_name ||
                  f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
  end
end
^

/* Restore proc. body: ACCOUNT_SET_ARCHIVE_STATUS */
ALTER PROCEDURE ACCOUNT_SET_ARCHIVE_STATUS(ID_ACCOUNT INTEGER,
IS_ARCHIVE SMALLINT)
 AS
declare variable post_sum numeric (15,2);
  declare variable dep_sum numeric (15,2);
  declare variable open_charges integer;
  declare variable old_is_archive integer;
  declare variable id_profile integer;
  declare variable id_hotel integer;
  declare variable p_dbkey char(8);
  declare variable acc_dbkey char(8);
  declare variable archived_date date;
  declare variable is_used integer;
  declare variable action_text varchar(255);
  declare variable account_name varchar(50);
begin

  select A.RDB$DB_KEY, A.IS_ARCHIVE, A.ID_PROFILE, A.ID_HOTEL, A.ACCOUNT_NAME
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :acc_dbkey, :old_is_archive, :id_profile, :id_hotel, :account_name;
  /* --------------------------------------- */
  if (:old_is_archive = :IS_ARCHIVE) then exit;
  /* --------------------------------------- */
  if (:IS_ARCHIVE = 0) then begin
    -- unarchive
    update ACCOUNT A
    set    A.IS_ARCHIVE = 0
    where  A.RDB$DB_KEY = :acc_dbkey;

    p_dbkey = null;
    select P.RDB$DB_KEY
    from   PROFILE P
    where  P.ID_PROFILE = :id_profile
           and p.IS_ARCHIVE = 1
    into   :p_dbkey;

    if (:p_dbkey is not null) then begin
      /* restore profile active status */
      execute procedure PROFILE_SET_ARCHIVE$INT (:p_dbkey, 0);
    end

  end else begin
    execute procedure ACCOUNT_USE_CHECK$INT (:ID_ACCOUNT)
    returning_values (:is_used);

    if (:is_used = 1) then begin
      select AB.POST_VALUE, AB.DEP_VALUE, AB.OPEN_CHARGES
      from   ACCOUNT_BALANCE$INT(:id_account) AB
      into   :post_sum, :dep_sum, :open_charges;
  
      if ((:post_sum <> 0) or (:open_charges = 1)) then
        exception ACCOUNT_EXCEPTION '-44' || f_character(31) || :ID_ACCOUNT;

      if (:dep_sum <> 0) then
        exception ACCOUNT_EXCEPTION '-40' || f_character(31) || :ID_ACCOUNT;
    
      execute procedure SYSTEM_DATE_GET (:id_hotel)
      returning_values (:archived_date);
    end else begin
      archived_date = null;  /* mark account as unused */
    end

    update ACCOUNT A
    set    A.IS_ARCHIVE = 1,
           A.ARCHIVED_DATE = :archived_date
    where  A.RDB$DB_KEY = :acc_dbkey;

    action_text = f_character(29) || :ID_ACCOUNT || '/' || :ACCOUNT_NAME;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'ARCHIVE_ACCOUNT', :action_text);
  end
end
^

/* Restore proc. body: ACCOUNT_SET_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_SET_CREDIT_STATUS$INT(ID_ACCOUNT TYPE OF ID,
IS_CREDIT_ACCOUNT TYPE OF TLOGICAL,
CREDIT_LIMIT TYPE OF TPRICE,
SET_UNCONDITIONAL TYPE OF TLOGICAL = 0)
 AS
declare variable account_name varchar(50);
  declare variable old_is_credit_account smallint;
  declare variable action_code varchar(50);
  declare variable action_text varchar(255);
  declare variable id_profile integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable a_dbkey char(8);
  declare variable old_credit_limit tprice;
begin

  select A.IS_CREDIT_ACCOUNT, a.CREDIT_LIMIT, A.ID_ACCOUNT, A.ACCOUNT_NAME,
         A.ID_PROFILE, A.ID_RESERV_DETAIL, a.RDB$DB_KEY
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :old_is_credit_account, :old_credit_limit, :id_account, :account_name,
         :id_profile, :id_reserv_detail, :a_dbkey;
  /* --------------------------------------- */
  if (:IS_CREDIT_ACCOUNT is not distinct from :old_is_credit_account
      and :CREDIT_LIMIT is not distinct from :old_credit_limit) then exit;
  /* --------------------------------------- */
  if (:is_credit_account > :old_is_credit_account and :set_unconditional = 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('ACC_SET_CREDIT');

  end else if (:is_credit_account < :old_is_credit_account and :id_reserv_detail is not null) then begin
    select RD.CHECK_STATUS
    from   RESERV_DETAIL RD
    where  RD.ID_RESERV_DETAIL = :id_reserv_detail
    into   :check_status;

    if (:check_status = 1) then exception ACCOUNT_EXCEPTION '-1017';
  end

  update ACCOUNT A
  set    A.IS_CREDIT_ACCOUNT = :is_credit_account,
         A.CREDIT_LIMIT = :credit_limit
  where  A.RDB$DB_KEY = :a_dbkey;

  if (:old_is_credit_account <> :is_credit_account) then begin
    action_code = iif(:is_credit_account = 1, 'SET_CREDIT_ACCOUNT', 'RESET_CREDIT_ACCOUNT');
    action_text = f_character(29) || :id_account || '/' || :account_name;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, :action_code, :action_text);
  end
end
^

/* Restore proc. body: ACCOUNT_SET_CURRENCY$INT */
ALTER PROCEDURE ACCOUNT_SET_CURRENCY$INT(A_DBKEY CHAR(8),
NEW_CURR CHAR(3))
 AS
declare variable id_account integer;
  declare variable old_acc_curr char(3);
  declare variable account_name varchar(50);
  declare variable id_profile integer;
  declare variable is_used integer;
  declare variable action_text varchar(255);
begin
  select A.ID_ACCOUNT, A.ACCOUNT_NAME, A.ACCOUNT_CURR, A.ID_PROFILE
  from   ACCOUNT A
  where  A.RDB$DB_KEY = :a_dbkey
  into   :id_account, :account_name, :old_acc_curr, :id_profile;

  if (:old_acc_curr <> :new_curr) then begin
    execute procedure ACCOUNT_USE_CHECK$INT (:id_account)
    returning_values  :is_used;
    if (:is_used = 1) then exception ACCOUNT_EXCEPTION '-41';
    action_text = f_character(29 ) || :id_account || '/' || :account_name
                  || f_character(28) || :old_acc_curr
                  || f_character(28) || :new_curr;
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'EDIT_ACCOUNT_CURR', :action_text);

    update ACCOUNT A
    set    A.ACCOUNT_CURR = :new_curr
    where  A.RDB$DB_KEY = :a_dbkey;
  end

end
^

/* Restore proc. body: ACTIVITY_OFFER_COPY */
ALTER PROCEDURE ACTIVITY_OFFER_COPY(ID_ACTIVITY_OFFER TYPE OF ID)
 RETURNS(NEW_ID_ACTIVITY_OFFER TYPE OF ID)
 AS
declare variable activity_date type of TDATE;
declare variable status type of TENUM_SMALL;
declare variable offer_currency type of TCURRENCY;
declare variable recipient type of TPERSON_NAME;
declare variable recipient_comment type of TDESCRIPTION_LONG;
declare variable person_name type of TPERSON_NAME;
declare variable phone_num type of TPHONE;
declare variable fax type of TPHONE;
declare variable e_mail type of TEMAIL;
declare variable accomodation_note type of TNOTE_BLOB;
declare variable events_note type of TNOTE_BLOB;
declare variable fb_note type of TNOTE_BLOB;
declare variable addition_note type of TNOTE_BLOB;
declare variable extra_note type of TNOTE_BLOB;
declare variable offer_header type of TNOTE_BLOB;
declare variable offer_footer type of TNOTE_BLOB;
declare variable discount_note type of TNOTE_BLOB;
declare variable id_reserv_group type of ID_REF;
declare variable id_hotel type of ID;
declare variable id_agent_profile type of ID_REF;
declare variable id_activity_event type of ID;
declare variable id_activity_fb type of ID;
declare variable no_use type of ID_REF;
declare variable ad_additional_date type of TDATE;
declare variable ad_from_time type of TTIME;
declare variable ad_to_time type of TTIME;
declare variable ad_description type of TOBJECT_TEXT;
declare variable ad_speciality type of TDESCRIPTION_LONG;
declare variable ad_addition_price type of TPRICE;
declare variable ad_note type of TDESCRIPTION_LONG;
declare variable act_description type of TDESCRIPTION_SHORT;
declare variable discount_price type of TPRICE;
declare variable user_attached TUSER_NAME;
begin
  select AO.ACTIVITY_DATE, AO.STATUS, AO.OFFER_CURRENCY, AO.RECIPIENT, AO.RECIPIENT_COMMENT, AO.PERSON_NAME,
         AO.PHONE_NUM, AO.FAX, AO.E_MAIL, AO.ACCOMODATION_NOTE, AO.EVENTS_NOTE, AO.FB_NOTE, AO.ADDITION_NOTE,
         AO.EXTRA_NOTE, AO.OFFER_HEADER, AO.OFFER_FOOTER, AO.DISCOUNT_NOTE, AO.ID_RESERV_GROUP,
         AO.ID_HOTEL, AO.ID_AGENT_PROFILE, USER_ATTACHED
  from   ACTIVITY_OFFER AO
  where  AO.ID_ACTIVITY_OFFER = :id_activity_offer
  into   :activity_date, :status, :offer_currency, :recipient, :recipient_comment, :person_name,
         :phone_num, :fax, :e_mail, :accomodation_note, :events_note, :fb_note, :addition_note,
         :extra_note, :offer_header, :offer_footer, :discount_note, :id_reserv_group,
         :id_hotel, :id_agent_profile, :user_attached;

  execute procedure ACTIVITY_OFFER_MODIFY$RESERV(null, :activity_date, :status, :offer_currency, :recipient, :recipient_comment,
          :person_name, :phone_num, :fax, :e_mail, events_note, :fb_note, :addition_note, :accomodation_note, :offer_header, :offer_footer,
          :extra_note, :discount_note, :id_reserv_group, :id_hotel, :id_agent_profile, :user_attached, 'add')
  returning_values :new_id_activity_offer;

  for
    select AE.ID_ACTIVITY_EVENT
    from   ACTIVITY_EVENT AE
    where  AE.ID_ACTIVITY_OFFER = :id_activity_offer
    into   :id_activity_event
  do begin
    execute procedure ACTIVITY_EVENT_COPY(:id_activity_event, :new_id_activity_offer)
    returning_values  :no_use;
  end

  for
    select AF.ID_ACTIVITY_FB
    from   ACTIVITY_FB AF
    where  AF.ID_ACTIVITY_OFFER = :id_activity_offer
    into   :id_activity_fb
  do begin
    execute procedure ACTIVITY_FB_COPY(:id_activity_fb, :new_id_activity_offer)
    returning_values  :no_use;
  end

  for
    select AD.ADDITION_DATE, AD.FROM_TIME, AD.TO_TIME, AD.DESCRIPTION, AD.SPECIALITY, AD.ADDITION_PRICE,
           AD.NOTE
    from   ACTIVITY_ADDITION AD
    where  AD.ID_ACTIVITY_OFFER = :id_activity_offer
    into   :ad_additional_date, :ad_from_time, :ad_to_time, :ad_description, :ad_speciality, :ad_addition_price,
           :ad_note
  do begin
    execute procedure ACTIVITY_ADDITION_MODIFY$RESERV(null, :new_id_activity_offer, :ad_additional_date, :ad_from_time,
            :ad_to_time, :ad_description, :ad_speciality, :ad_addition_price, :ad_note, 'add')
    returning_values :no_use;
  end

  for
    select ACT.DESCRIPTION, ACT.DISCOUNT_PRICE
    from   ACTIVITY_DISCOUNT ACT
    where  ACT.ID_ACTIVITY_OFFER = :id_activity_offer
    into   :act_description, :discount_price
  do begin
    execute procedure ACTIVITY_DISCOUNT_MODIFY$RESERV(null, :new_id_activity_offer, :act_description, :discount_price, 'add')
    returning_values  :no_use;
  end

  execute procedure SYSTEM_LOG_ADD ('ACTIVITY_OFFER', :id_activity_offer, 'ACTIVITY_OFFER_COPY', f_character(29) || :new_id_activity_offer);
end
^

/* Restore proc. body: AR_OWING_ADD$INT */
ALTER PROCEDURE AR_OWING_ADD$INT(ID_PROFILE TYPE OF ID,
SUM_OWING TYPE OF TPRICE,
CURR_OWING TYPE OF TCURRENCY,
ID_DOC_HEAD TYPE OF ID_REF,
DUE_DATE TYPE OF TDATE,
SYSTEM_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
ID_AR_TYPE TYPE OF ID,
ID_HOTEL TYPE OF ID)
 RETURNS(NEW_ID_AR_OWING TYPE OF ID)
 AS
declare variable round_to numeric(15,4);
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
begin

  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :CURR_OWING
  into   :round_to;

  select P.PROFILE_NAME
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :profile_name;

  new_id_ar_owing = gen_id(GEN_AR_OWING_ID, 1);
  sum_owing = ROUND_F(:sum_owing, :round_to);

  insert into AR_OWING (ID_AR_OWING, ID_PROFILE, SUM_OWING, CURR_OWING,
         USER_CREATED, DATETIME_CREATED, ID_DOC, SYSTEM_DATE,
         ID_AR_OWING_BASE, DESCRIPTION, DUE_DATE, ID_AR_TYPE, ID_HOTEL,
         REST_OWING, OWING_STATUS)
  values (:new_id_ar_owing, :ID_PROFILE, :SUM_OWING, :CURR_OWING,
         user, current_timestamp, :ID_DOC_HEAD, :system_date,
         null, :description, STRIPTIME(:due_date), :ID_AR_TYPE, :ID_HOTEL,
         :SUM_OWING, 11);

  action_text = substring(f_character(29) || :profile_name
                          || f_character(28) || formatfloat(:SUM_OWING, 'F;0.00') || ' ' || :CURR_OWING
                          || f_character(28) || :description from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'OWING_CREATE', :action_text);

end
^

/* Restore proc. body: AR_OWING_ANUL$INT */
ALTER PROCEDURE AR_OWING_ANUL$INT(ID_AR_OWING TYPE OF ID,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
IS_MANUAL_ANUL TYPE OF TLOGICAL = 1)
 RETURNS(NEW_ID_AR_OWING TYPE OF ID)
 AS
declare variable system_date type of TDATE;
  declare variable curr_id integer;
  declare variable owing_status smallint;
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable id_doc_head integer;
  declare variable sum_owing numeric(15,4) ;
  declare variable curr_owing char(3);
  declare variable id_profile integer;
begin

    select O.OWING_STATUS, O.ID_DOC, SDG.SYSTEM_DATE, o.SUM_OWING, o.CURR_OWING, o.ID_PROFILE
    from   AR_OWING O
           left outer join SYSTEM_DATE_GET(O.ID_HOTEL) SDG on 1=1
    where  O.ID_AR_OWING = :ID_AR_OWING
    into   :owing_status, :id_doc_head, :system_date, :sum_owing, :curr_owing, :id_profile;

    if (:OWING_STATUS = 22) then
      exception ACCOUNT_RECEIVABLE_EXCEPTION '-606' ;
    if (:IS_MANUAL_ANUL = 1 and :id_doc_head is not null) then
      exception ACCOUNT_RECEIVABLE_EXCEPTION '-609' ;

    update AR_OWING A  -- lock for update
    set    A.ID_AR_OWING = A.ID_AR_OWING,
           A.OWING_STATUS = 22,
           A.REST_OWING = :sum_owing
    where  A.ID_AR_OWING = :ID_AR_OWING;

    new_id_ar_owing = gen_id(GEN_AR_OWING_ID, 1);

    insert into AR_OWING (ID_AR_OWING, ID_PROFILE, SUM_OWING, CURR_OWING,
           USER_CREATED, DATETIME_CREATED, ID_DOC, SYSTEM_DATE,
           ID_AR_OWING_BASE, DESCRIPTION, DUE_DATE, ID_AR_TYPE, ID_HOTEL,
           REST_OWING, OWING_STATUS)
    select :new_id_ar_owing, A.ID_PROFILE, -A.SUM_OWING, A.CURR_OWING,
           user, current_timestamp, A.ID_DOC, :system_date,
           :ID_AR_OWING, :description, A.DUE_DATE, A.ID_AR_TYPE, a.ID_HOTEL,
           -A.SUM_OWING, 22
    from   AR_OWING A
    where  A.ID_AR_OWING = :ID_AR_OWING;

    for
      select A.ID_AR_OWING_PAYMENT_POST
      from   AR_OWING_PAYMENT_POST A
      where  A.ID_AR_OWING = :ID_AR_OWING
             and A.IS_ANUL = 0
      into   :curr_id
    do begin
      execute procedure AR_OWING_PAYMENT_ANUL$AR(:curr_id, :DESCRIPTION);
    end
    -- transaction finalize
    execute procedure AR_POST_FINALIZE(iif(:IS_MANUAL_ANUL = 1, 'anul_owing', 'anul_link'));

    select P.PROFILE_NAME
    from   PROFILE P
    where  P.ID_PROFILE = :id_profile
    into   :profile_name;

    action_text = substring(f_character(29) || :profile_name
                            || f_character(28) || formatfloat(:sum_owing, 'F;0.00') || ' ' || :CURR_OWING
                            || f_character(28) || :description from 1 for 255);
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :id_profile, 'OWING_ANNUL', :action_text);

end
^

/* Restore proc. body: AR_OWING_PAYMENT_ADD$AR */
ALTER PROCEDURE AR_OWING_PAYMENT_ADD$AR(ID_AR_OWING INTEGER,
ID_AR_PAYMENT INTEGER,
SUM_OWING NUMERIC(15,4),
SUM_PAYMENT NUMERIC(15,4),
PAYMENT_RATE_TO_BGN NUMERIC(15,6),
OWING_RATE_TO_BGN NUMERIC(15,6),
DESCRIPTION VARCHAR(255))
 RETURNS(NEW_ID_AR_OWING_PAYMENT_POST INTEGER)
 AS
declare variable curr_payment varchar(3);
  declare variable curr_owing varchar(3);
  declare variable owing_status smallint;
  declare variable payment_status smallint;
  declare variable system_date date;
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable payment_type varchar(20);
  declare variable id_profile integer;
  declare variable id_hotel integer;
  declare variable payment_round_to numeric(15,4);
  declare variable owing_round_to numeric(15,4);
begin
  select A.CURR_PAYMENT, A.PAYMENT_STATUS, pt.PAYMENT_TYPE, c.ROUND_TO
  from   AR_PAYMENT A
         join AR_PAYMENT_TYPE PT on PT.ID_AR_PAYMENT_TYPE = a.ID_AR_PAYMENT_TYPE
         join CURRS c on c.CURR = a.CURR_PAYMENT
  where  A.ID_AR_PAYMENT = :ID_AR_PAYMENT
  into   :curr_payment, :PAYMENT_STATUS, :payment_type, :payment_round_to;

  select A.CURR_OWING, A.OWING_STATUS, P.PROFILE_NAME, p.ID_PROFILE, a.ID_HOTEL, c.ROUND_TO
  from   AR_OWING A
         join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
         join CURRS c on c.CURR = a.CURR_OWING
  where  A.ID_AR_OWING = :id_ar_owing
  into   :curr_owing, :owing_status, :profile_name, :id_profile, :id_hotel, :owing_round_to;

  if ( (:OWING_STATUS = 22) or (:PAYMENT_STATUS = 22) ) then
    exception ACCOUNT_RECEIVABLE_EXCEPTION '-604';

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  (:system_date);

  /* lock records for update */
  select P.ID_AR_PAYMENT
  from   AR_PAYMENT P
  where  P.ID_AR_PAYMENT = :ID_AR_PAYMENT
  with lock  -- lock for update
  into   :ID_AR_PAYMENT;

  select O.ID_AR_OWING
  from   AR_OWING O
  where  O.ID_AR_OWING = :ID_AR_OWING
  with lock  -- lock for update
  into   :ID_AR_OWING;

  if (:SUM_OWING = 0.00) then exception ACCOUNT_RECEIVABLE_EXCEPTION '-602';

  SUM_OWING = round_f(:SUM_OWING, :owing_round_to);
  SUM_PAYMENT = round_f(:SUM_PAYMENT, :payment_round_to);

  insert into AR_OWING_PAYMENT_POST(ID_AR_OWING, ID_AR_PAYMENT, ID_PROFILE,
         SUM_OWING, CURR_OWING, SUM_PAYMENT, CURR_PAYMENT, IS_ANUL,
         PAYMENT_RATE_TO_BGN, OWING_RATE_TO_BGN, ID_TRANSACTION, SYSTEM_DATE,
         ID_AR_OWING_PAYMENT_BASE, DESCRIPTION, USER_CREATED, DATETIME_CREATED)
  values (:ID_AR_OWING, :ID_AR_PAYMENT, :id_profile,
         :SUM_OWING, :curr_owing, :SUM_PAYMENT, :curr_payment, 0,
         :payment_rate_to_bgn, :owing_rate_to_bgn, current_transaction, :system_date,
         null, :DESCRIPTION, user, current_timestamp)
  returning ID_AR_OWING_PAYMENT_POST
  into   :new_id_ar_owing_payment_post;

  action_text = substring(f_character(29) || :profile_name
                          || f_character(28) || formatfloat(:SUM_OWING, 'F;0.00') || ' ' || :CURR_OWING
                          || f_character(28) || :payment_type
                          || f_character(28) || formatfloat(:SUM_PAYMENT, 'F;0.00') || ' ' || :CURR_PAYMENT
                          || f_character(28) || :description
                          from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'OWING_PAY', :action_text);

end
^

/* Restore proc. body: AR_OWING_PAYMENT_ANUL$AR */
ALTER PROCEDURE AR_OWING_PAYMENT_ANUL$AR(ID_AR_OWING_PAYMENT_POST INTEGER,
DESCRIPTION VARCHAR(255))
 AS
declare variable curr_payment varchar(3);
  declare variable curr_owing varchar(3);
  declare variable is_anul smallint;
  declare variable system_date date;
  declare variable type_code varchar(10);
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable payment_type varchar(20);
  declare variable id_profile integer;
  declare variable id_hotel integer;
  declare variable sum_owing numeric(15,4);
  declare variable sum_payment numeric(15,4);
  declare variable id_ar_owing integer;
  declare variable id_ar_payment integer;
  declare variable payment_rate_to_bgn numeric(15,6);
  declare variable owing_rate_to_bgn numeric(15,6);
begin
  if (:ID_AR_OWING_PAYMENT_POST is null) then
    exception ACCOUNT_RECEIVABLE_EXCEPTION '-85' || f_character(31) || 'ID_AR_OWING_PAYMENT_POST is null';

  /* lock record for update */
  select p.ID_AR_OWING, p.ID_AR_PAYMENT, p.IS_ANUL
  from   AR_OWING_PAYMENT_POST P
  where  P.ID_AR_OWING_PAYMENT_POST = :id_ar_owing_payment_post
  with lock  -- lock for update
  into   :id_ar_owing, :id_ar_payment, :is_anul;

  if (:is_anul = 1) then exception ACCOUNT_RECEIVABLE_EXCEPTION '-605';

  select A.CURR_PAYMENT, pt.PAYMENT_TYPE
  from   AR_PAYMENT A
         join AR_PAYMENT_TYPE PT on PT.ID_AR_PAYMENT_TYPE = a.ID_AR_PAYMENT_TYPE
  where  A.ID_AR_PAYMENT = :ID_AR_PAYMENT
  into   :curr_payment, :payment_type;

  select A.CURR_OWING, P.PROFILE_NAME, p.ID_PROFILE, t.TYPE_CODE, A.ID_HOTEL
  from   AR_OWING A
         join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
         join AR_TYPE T on a.ID_AR_TYPE = T.ID_AR_TYPE
  where  A.ID_AR_OWING = :id_ar_owing
  into   :curr_owing, :profile_name, :id_profile, :type_code, :id_hotel;

  if (:type_code = 'DEPOSIT') then
    exception ACCOUNT_RECEIVABLE_EXCEPTION 'Operation (type_code=DEPOSIT) is not supported!';

  /* lock records for update */
  select P.ID_AR_PAYMENT
  from   AR_PAYMENT P
  where  P.ID_AR_PAYMENT = :ID_AR_PAYMENT
  with lock  -- lock for update
  into   :ID_AR_PAYMENT;

  select O.ID_AR_OWING
  from   AR_OWING O
  where  O.ID_AR_OWING = :ID_AR_OWING
  with lock  -- lock for update
  into   :ID_AR_OWING;

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  (:system_date);

  update AR_OWING_PAYMENT_POST A
  set    A.IS_ANUL = 1
  where  A.ID_AR_OWING_PAYMENT_POST = :ID_AR_OWING_PAYMENT_POST;

  select -P.SUM_OWING, -P.SUM_PAYMENT, P.ID_AR_OWING, P.ID_AR_PAYMENT, p.ID_PROFILE,
         P.PAYMENT_RATE_TO_BGN, P.OWING_RATE_TO_BGN, P.CURR_OWING, P.CURR_PAYMENT
  from   AR_OWING_PAYMENT_POST P
  where  P.ID_AR_OWING_PAYMENT_POST = :ID_AR_OWING_PAYMENT_POST
  into   :SUM_OWING, :SUM_PAYMENT, :ID_AR_OWING, :ID_AR_PAYMENT, :id_profile,
         :PAYMENT_RATE_TO_BGN, :OWING_RATE_TO_BGN, :CURR_OWING, :CURR_PAYMENT;

  insert into AR_OWING_PAYMENT_POST(ID_AR_OWING, ID_AR_PAYMENT, ID_PROFILE,
         SUM_OWING, CURR_OWING, SUM_PAYMENT, CURR_PAYMENT, IS_ANUL,
         PAYMENT_RATE_TO_BGN, OWING_RATE_TO_BGN, ID_TRANSACTION, SYSTEM_DATE,
         ID_AR_OWING_PAYMENT_BASE, DESCRIPTION, USER_CREATED, DATETIME_CREATED)
  values (:id_ar_owing, :id_ar_payment, :id_profile,
         :sum_owing, :curr_owing, :sum_payment, :curr_payment, 1,
         :payment_rate_to_bgn, :owing_rate_to_bgn, current_transaction, :system_date,
         :id_ar_owing_payment_post, :DESCRIPTION, user, current_timestamp);

  action_text = substring(f_character(29) || :profile_name
                          || f_character(28) || formatfloat(:sum_owing, 'F;0.00') || ' ' || :curr_owing
                          || f_character(28) || :payment_type
                          || f_character(28) || formatfloat(:sum_payment, 'F;0.00') || ' ' || :curr_payment
                          || f_character(28) || :DESCRIPTION
                          from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'OWING_PAY_ANNUL', :action_text);

end
^

/* Restore proc. body: AR_PAYMENT_ADD$AR */
ALTER PROCEDURE AR_PAYMENT_ADD$AR(ID_PROFILE TYPE OF ID,
ID_AR_PAYMENT_TYPE TYPE OF ID_REF,
ACCOUNT_NAME TYPE OF TNAME_SHORT,
SUM_PAYMENT TYPE OF TPRICE,
CURR_PAYMENT TYPE OF TCURRENCY,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
DATE_PAYMENT TYPE OF TDATE)
 RETURNS(NEW_ID_AR_PAYMENT INTEGER)
 AS
declare variable payment_status smallint;
  declare variable round_to numeric(15,6);
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable payment_type varchar(20);
begin
  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :CURR_PAYMENT
  into   :round_to;

  select p.PROFILE_NAME
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :profile_name;

  select P.PAYMENT_TYPE
  from   AR_PAYMENT_TYPE P
  where  P.ID_AR_PAYMENT_TYPE = :ID_AR_PAYMENT_TYPE
  into   :payment_type;

  payment_status = 11;
  SUM_PAYMENT = round_f(:SUM_PAYMENT, :round_to);

  new_id_ar_payment = gen_id(GEN_AR_PAYMENT_ID, 1);
  insert into AR_PAYMENT(ID_AR_PAYMENT, ID_PROFILE, SUM_PAYMENT, CURR_PAYMENT,
         USER_CREATED, DATETIME_CREATED, DESCRIPTION,
         ID_AR_PAYMENT_BASE, ID_AR_PAYMENT_TYPE, ACCOUNT_NAME,
         DATE_PAYMENT, REST_PAYMENT, PAYMENT_STATUS)
  values (:new_id_ar_payment, :ID_PROFILE, :SUM_PAYMENT, :CURR_PAYMENT,
         user, current_timestamp, :DESCRIPTION,
         null, :ID_AR_PAYMENT_TYPE, :ACCOUNT_NAME,
         :DATE_PAYMENT, :SUM_PAYMENT, :PAYMENT_STATUS);

  action_text = substring(f_character(29) || :payment_type
                          || f_character(28) || :profile_name
                          || f_character(28) || formatfloat(:SUM_PAYMENT, 'F;0.00') || ' ' || :CURR_PAYMENT from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'PAYMENT_CREATE', :action_text);

end
^

/* Restore proc. body: AR_PAYMENT_ANUL$AR */
ALTER PROCEDURE AR_PAYMENT_ANUL$AR(ID_AR_PAYMENT INTEGER,
DESCRIPTION VARCHAR(255))
 RETURNS(NEW_ID_AR_PAYMENT INTEGER)
 AS
declare variable curr_id integer;
  declare variable payment_status smallint;
  declare variable action_text varchar(255);
  declare variable profile_name varchar(100);
  declare variable payment_type varchar(20);
  declare variable curr_payment char(3);
  declare variable id_profile integer;
  declare variable id_payment_type integer;
  declare variable sum_payment numeric(15,4);
begin
  if (:ID_AR_PAYMENT is null) then exit;

  select p.CURR_PAYMENT, p.ID_PROFILE, p.ID_AR_PAYMENT_TYPE, p.SUM_PAYMENT, p.PAYMENT_STATUS
  from   AR_PAYMENT P
  where  P.ID_AR_PAYMENT = :ID_AR_PAYMENT
  into   :CURR_PAYMENT, :id_profile, :id_payment_type, :sum_payment, :payment_status;

  if (:payment_status = 22) then exception ACCOUNT_RECEIVABLE_EXCEPTION '-606';

  payment_status = 22;

  update AR_PAYMENT A
  set    A.PAYMENT_STATUS = :payment_status
  where  A.ID_AR_PAYMENT = :ID_AR_PAYMENT;

  new_id_ar_payment = gen_id(GEN_AR_PAYMENT_ID, 1);

  insert into AR_PAYMENT(ID_AR_PAYMENT, ID_PROFILE, SUM_PAYMENT, CURR_PAYMENT,
         USER_CREATED, DATETIME_CREATED, DESCRIPTION,
         ID_AR_PAYMENT_BASE, ID_AR_PAYMENT_TYPE, ACCOUNT_NAME,
         DATE_PAYMENT, REST_PAYMENT, PAYMENT_STATUS)
  select :new_id_ar_payment, A.ID_PROFILE, -A.SUM_PAYMENT, A.CURR_PAYMENT,
         user, current_timestamp, :DESCRIPTION,
         :ID_AR_PAYMENT, A.ID_AR_PAYMENT_TYPE, A.ACCOUNT_NAME,
         A.DATE_PAYMENT, -A.SUM_PAYMENT, :payment_status
  from   AR_PAYMENT A
  where  A.ID_AR_PAYMENT = :id_ar_payment;

  -- storno links
  for
    select A.ID_AR_OWING_PAYMENT_POST
    from   AR_OWING_PAYMENT_POST A
    where  A.ID_AR_PAYMENT = :ID_AR_PAYMENT
           and A.IS_ANUL = 0
    into   :curr_id
  do begin
    execute procedure AR_OWING_PAYMENT_ANUL$AR(:curr_id, :DESCRIPTION);
  end
  -- transaction finalize
  execute procedure AR_POST_FINALIZE('anul_pay');

  select p.PROFILE_NAME
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :profile_name;

  select P.PAYMENT_TYPE
  from   AR_PAYMENT_TYPE P
  where  P.ID_AR_PAYMENT_TYPE = :id_payment_type
  into   :payment_type;

  action_text = substring(f_character(29) || :payment_type
                          || f_character(28) || :profile_name
                          || f_character(28) || formatfloat(:SUM_PAYMENT, 'F;0.00') || ' ' || :CURR_PAYMENT from 1 for 255);
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT_RECIEVABLE', :ID_PROFILE, 'PAYMENT_ANNUL', :action_text);
end
^

/* Restore proc. body: BLOCK_ANNUL$BLK */
ALTER PROCEDURE BLOCK_ANNUL$BLK(ID_BLOCK_ROOM INTEGER,
OPERATION VARCHAR(30))
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable share_err_text varchar(255);
  declare variable system_date date;
  declare variable cancel_date date;
  declare variable from_date date;
  declare variable b_dbkey char(8);
  declare variable new_id_block_room integer;
  declare variable id_room integer;
  declare variable block_grp integer;
  declare variable reason varchar(50);
  declare variable note varchar(255);
  declare variable action_text varchar(255);
  declare variable room_name varchar(10);
  declare variable id_hotel integer;
  declare variable mark_dirty_expired_block integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION (:operation, 'cancel, annul');

  select BR.FROM_DATE, BR.RDB$DB_KEY, R.ID_HOTEL
  from   BLOCK_ROOM BR
         join ROOMS R on R.ID_ROOM = BR.ID_ROOM
  where  BR.ID_BLOCK_ROOM = :id_block_room
  into   :from_date, :b_dbkey, :id_hotel;

  if (:operation = 'annul') then begin
    update BLOCK_ROOM BR
    set    BR.IS_ANNUL = 1
    where  BR.RDB$DB_KEY = :b_dbkey;
  
    execute procedure BLOCK_MODIFY_CONTROL$INT(:b_dbkey, :from_date);
    execute procedure ROOM_MAGIC_CLEAR(:id_block_room);
    action_text = '';
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :id_block_room, 'ANNUL_BLOCK', :action_text);
  end else begin
    select BR.ID_ROOM, BR.BLOCK_GRP, BR.REASON, BR.NOTE, R.ROOM_NAME
    from   BLOCK_ROOM BR
           join ROOMS R on R.ID_ROOM = BR.ID_ROOM
    where  BR.RDB$DB_KEY = :b_dbkey
    into   :id_room, :block_grp, :reason, :note, :room_name;

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :system_date;
    cancel_date = :system_date - 1;

    execute procedure BLOCK_MODIFY$INT(:id_block_room, :id_room, :from_date, :cancel_date, :block_grp, :reason,
                      :note, 'mod')
    returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :share_err_text, :warn_code;
    --ignore possible entering into share

    execute procedure SETTING_GET_VALUE('MARK_DIRTY_EXPIRED_BLOCK', :id_hotel)
    returning_values  :mark_dirty_expired_block;
    if (:mark_dirty_expired_block = '1') then begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'BLOCK_STOP', 'set_dirty');
    end

    action_text = f_character(29) || :room_name || f_character(28) || formatdate(:cancel_date, 'D;dd.mm.yyyy');
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :new_id_block_room, 'CANCEL_BLOCK', :action_text);
  end
end
^

/* Restore proc. body: BLOCK_CREATE$BLK */
ALTER PROCEDURE BLOCK_CREATE$BLK(ROOM_NAMES TYPE OF TDESCRIPTION_LONG,
ID_HOTEL TYPE OF ID,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
BLOCK_GRP TYPE OF TRANGE,
REASON TYPE OF TREASON,
NOTE TYPE OF TDESCRIPTION_LONG,
IS_FULL_FROM TYPE OF TRANGE,
IS_FULL_TO TYPE OF TRANGE)
 RETURNS(NEW_ID_BLOCK_ROOM TYPE OF ID,
SHARE_TRANSACTION_ID TYPE OF ID,
SHARE_ERR_CODE TYPE OF ID,
ERR_TEXT VARCHAR(255),
WARN_CODE TYPE OF ID,
NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable room_name varchar(50);
  declare variable id_room integer;
  declare variable action_text varchar(255);
  declare variable block_name varchar(30);
begin
  id_room = null;
  warn_code = null;
  SHARE_ERR_CODE = 0;

  for
    select ITEM
    from   SYSTEM_STRING_PARSER(:room_names, ',')
    into   :room_name
  do begin
    id_room = null;
    select R.ID_ROOM
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ROOM_NAME = :room_name
           and RT.ID_HOTEL = :id_hotel
    into   :id_room;

    if (:id_room is null) then exception BLOCK_EXCEPTION '-5' || f_character(31) || :room_name;

    execute procedure BLOCK_MODIFY$INT(null, :id_room, :from_date, :to_date, :block_grp,
                      :reason, :note, 'add')
    returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :err_text, :warn_code;

    block_name = iif(:block_grp = 18, 'OUT OF ORDER', 'OUT OF INVENTORY');
    action_text = f_character(29) || :room_name
                  || f_character(28) || formatdate(:from_date, 'D;dd.mm.yyyy') || '-' || formatdate(:to_date, 'D;dd.mm.yyyy')
                  || f_character(28) || :block_name;
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :new_id_block_room, 'BLOCK_ROOM', :action_text);

  end

  select cast('31.12.1899' as date) + count(b.ID_BLOCK_ROOM)
  from   BLOCK_ROOM b
  where  b.ID_ROOM is not null
  into   :NEW_FROM_DATE;
end
^

/* Restore proc. body: BLOCK_MODIFY$BLK */
ALTER PROCEDURE BLOCK_MODIFY$BLK(ID_BLOCK_ROOM INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
BLOCK_GRP INTEGER,
REASON VARCHAR(50),
NOTE VARCHAR(255),
IS_FULL_FROM INTEGER,
IS_FULL_TO INTEGER)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable new_id_block_room integer;
  declare variable action_text varchar(255);
  declare variable old_from_date date;
  declare variable old_to_date date;
  declare variable old_group integer;
  declare variable room_name varchar(10);
  declare variable block_name varchar(30);
begin
  --  IS_FULL_FROM  - deprecated
  --  IS_FULL_TO  - deprecated

  select BR.FROM_DATE, BR.TO_DATE, BR.BLOCK_GRP, R.ROOM_NAME
  from   BLOCK_ROOM BR
         join ROOMS R on R.ID_ROOM = BR.ID_ROOM
  where  BR.ID_BLOCK_ROOM = :ID_BLOCK_ROOM              
  into   :old_from_date, :old_to_date, :old_group, :room_name;

  execute procedure BLOCK_MODIFY$INT(:id_block_room, :id_room, :from_date, :to_date, :block_grp,
                    :reason, :note, 'mod')
  returning_values  :new_id_block_room, :share_transaction_id, :share_err_code, :err_text, :warn_code;

  if ( (:old_from_date <> :FROM_DATE) or (:old_to_date <> :TO_DATE) or (:old_group <> :BLOCK_GRP) ) then begin
    block_name = iif(:block_grp = 18, 'OUT OF ORDER', 'OUT OF INVENTORY');
    action_text = f_character(29) || :room_name
                  || f_character(28) || formatdate(:FROM_DATE, 'D;dd.mm.yyyy') || '-' || formatdate(:TO_DATE, 'D;dd.mm.yyyy')
                  || f_character(28) || :block_name;
    execute procedure SYSTEM_LOG_ADD ('BLOCK', :NEW_ID_BLOCK_ROOM, 'EDIT_BLOCK', :action_text);
  end
end
^

/* Restore proc. body: CONTRACT_CALENDAR_MODIFY$PMS */
ALTER PROCEDURE CONTRACT_CALENDAR_MODIFY$PMS(ID_CONTRACT_CALENDAR_POST TYPE OF ID,
ID_ROOM_CONTRACT TYPE OF ID,
ID_SERVICE TYPE OF ID,
IS_INCOME TYPE OF TLOGICAL,
SERVICE_PRICE TYPE OF TPRICE,
ID_CURRENCY TYPE OF TCURRENCY,
IS_ACC_POST_ITEM TYPE OF TLOGICAL,
POSTING_DATE_LIST TYPE OF TTEXT_EXTENDED,
POSTING_PERIOD_DURATION TYPE OF TCOUNT,
MONTH_NEXT_DATE TYPE OF TDATE,
IS_FIXED_DATE TYPE OF TLOGICAL,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_CALENDAR_POST TYPE OF ID)
 AS
declare variable post_date date;
  declare variable post_next_date date;
  declare variable service_name varchar(30);
  declare variable old_service_name varchar(30);
  declare variable old_post_next_date date;
  declare variable old_is_income smallint;
  declare variable old_service_price numeric(15,4);
  declare variable old_id_currency varchar(3);
  declare variable old_is_acc_post_item smallint;
  declare variable old_posting_period_duration integer;
  declare variable old_posting_date_list varchar(2000);
  declare variable old_id_service integer;
  declare variable old_is_fixed_date smallint;
  declare variable old_id_room_contract integer;
  declare variable action_text varchar(255);
begin

  /* POSTING_DATE_LIST - list ot dates(dd.mm.yyyy) comma separated;
     POSTING_PERIOD_DURATION must be in months,
     operation in ('add','mod','del') */

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del,mod_next_date');

  post_date = null;
  post_next_date = null;
  if (:OPERATION in ('add','mod')) then begin
    if (:is_fixed_date = 0) then begin
      post_date = :month_next_date;
      if (:posting_period_duration is not null and :post_date is not null) then begin
        post_next_date = addmonth(:post_date, :posting_period_duration);
      end
    end else begin
      select first 1 S.ITEM
      from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') S
      order by cast(S.ITEM as date)
      into :post_date;

      select first 1 SSP.ITEM
      from SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') SSP
      where cast(SSP.ITEM as date) > :post_date
      order by cast(SSP.ITEM as date)
      into :post_next_date;
    end

 --   select first 1 S.ITEM
 --   from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') S
 --   order by S.INTURN
 --   into   :post_date;

 --   if (:posting_period_duration is not null and :post_date is not null) then begin
 --     execute procedure ADD_MONTH(:post_date, :posting_period_duration)
 --     returning_values (:post_next_date);
 --   end else if (:posting_date_list is not null) then begin
 --     select S.ITEM
 --     from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') S
 --     where  S.INTURN = 2
 --     into   :post_next_date;
 --   end
  end

  select SE.SERVICE_NAME
  from SERVICES SE
  where SE.ID_SERVICE = :ID_SERVICE
  into :service_name;

  if (:operation = 'add') then begin
    if (coalesce(:ID_CONTRACT_CALENDAR_POST, -1) > 0) then
      NEW_ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST;
    else
      NEW_ID_CONTRACT_CALENDAR_POST = gen_id(GEN_CONTRACT_CAL_POST$PMS_ID, 1);

    insert into CONTRACT_CALENDAR_POST$PMS (
           ID_CONTRACT_CALENDAR_POST, ID_ROOM_CONTRACT, ID_SERVICE, IS_INCOME,
           SERVICE_PRICE, ID_CURRENCY, IS_ACC_POST_ITEM, POST_DATE, POST_NEXT_DATE, POSTING_PERIOD_DURATION, IS_FIXED_DATE)
    values (:NEW_ID_CONTRACT_CALENDAR_POST, :ID_ROOM_CONTRACT, :ID_SERVICE, :IS_INCOME,
            :SERVICE_PRICE, :ID_CURRENCY, :IS_ACC_POST_ITEM, :POST_DATE, :POST_NEXT_DATE, :POSTING_PERIOD_DURATION, :IS_FIXED_DATE);
    ID_CONTRACT_CALENDAR_POST = :NEW_ID_CONTRACT_CALENDAR_POST;

    if ((:is_fixed_date = 0) and (:month_next_date is not null)) then
      insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
      values (:ID_CONTRACT_CALENDAR_POST, :MONTH_NEXT_DATE);
    else if ((:is_fixed_date = 1) and (:posting_date_list is not null)) then begin
      for
        select SY.ITEM
        from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') SY
        into   :post_date
      do begin
        insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
        values (:ID_CONTRACT_CALENDAR_POST, :POST_DATE);
      end
    end

 --   for
 --     select S.ITEM
 --     from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') S
 --     into   :post_date
 --   do begin
 --     insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
 --     values (:ID_CONTRACT_CALENDAR_POST, :POST_DATE);
 --   end

    action_text = substring(f_character(29) || '@{pms.contract.is_income.' || :is_income || '}' || ', ' || :service_name ||
                  f_character(28) || '@{pms.is_acc_post_item.' || :is_acc_post_item || '}' ||
                  ', ' || formatfloat(:service_price, '0.00') ||
                  ', ' || :id_currency ||
                  ', ' || iif(:is_fixed_date = 0, '@{pms.montly_plannig_scheme}' || ', ' || coalesce(:posting_period_duration, ' ') || ', ' ||
                                                  iif(:month_next_date is not null, formatdate(:month_next_date, 'D;dd.mm.yyyy'), ' '),
                                                             '@{pms.fixed_plannig_scheme}' || ', ' ||coalesce(:posting_date_list, ' ')) from 1 for 255);

    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_CALEN_ADD', :ACTION_TEXT);
  end else begin
    select S.SERVICE_NAME, CCP.IS_INCOME, CCP.SERVICE_PRICE, CCP.ID_CURRENCY, CCP.IS_ACC_POST_ITEM,
           CCP.POSTING_PERIOD_DURATION, CCP.POST_NEXT_DATE, CCP.ID_SERVICE, CCP.IS_FIXED_DATE, CCP.ID_ROOM_CONTRACT
    from CONTRACT_CALENDAR_POST$PMS CCP
      join SERVICES S on S.ID_SERVICE = CCP.ID_SERVICE
    where CCP.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST
    into :old_service_name, old_is_income, :old_service_price, :old_id_currency, :old_is_acc_post_item,
         :old_posting_period_duration, :old_post_next_date, :old_id_service, :old_is_fixed_date, :old_id_room_contract;

    select list(formatdate(CCS.POST_DATE, 'D;dd.mm.yyyy'), ',')
    from CONTRACT_CALENDAR_SCHEME$PMS CCS
    where CCS.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST
    into :old_posting_date_list;

    if (:operation = 'mod') then begin
      if ((:old_is_income <> :is_income) or (:old_id_service <> :id_service)) then begin
        execute procedure CONTRACT_CALENDAR_MODIFY$PMS(:ID_CONTRACT_CALENDAR_POST, :ID_ROOM_CONTRACT, :ID_SERVICE, :IS_INCOME, :SERVICE_PRICE,
                                                       :ID_CURRENCY, :IS_ACC_POST_ITEM, :POSTING_DATE_LIST, :POSTING_PERIOD_DURATION,
                                                       :MONTH_NEXT_DATE, :IS_FIXED_DATE, 'del')
        returning_values :new_id_contract_calendar_post;
        execute procedure CONTRACT_CALENDAR_MODIFY$PMS(:ID_CONTRACT_CALENDAR_POST, :ID_ROOM_CONTRACT, :ID_SERVICE, :IS_INCOME, :SERVICE_PRICE,
                                                       :ID_CURRENCY, :IS_ACC_POST_ITEM, :POSTING_DATE_LIST, :POSTING_PERIOD_DURATION,
                                                       :MONTH_NEXT_DATE, :IS_FIXED_DATE, 'add')
        returning_values :new_id_contract_calendar_post;
      end else begin
        update CONTRACT_CALENDAR_POST$PMS C
        set    C.SERVICE_PRICE = :SERVICE_PRICE,
               C.ID_CURRENCY = :ID_CURRENCY,
               C.IS_ACC_POST_ITEM = :IS_ACC_POST_ITEM,
               C.POST_DATE = :POST_DATE,
               C.POST_NEXT_DATE = :POST_NEXT_DATE,
               C.POSTING_PERIOD_DURATION = :POSTING_PERIOD_DURATION,
               C.IS_FIXED_DATE = :IS_FIXED_DATE
        where C.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST;

        delete from CONTRACT_CALENDAR_SCHEME$PMS
        where (ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST);

        if ((:is_fixed_date = 0) and (:month_next_date is not null)) then
          insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
          values (:ID_CONTRACT_CALENDAR_POST, :MONTH_NEXT_DATE);
        else if ((:is_fixed_date = 1) and (:posting_date_list is not null)) then begin
          for
            select SY.ITEM
            from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') SY
            into   :post_date
          do begin
            insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
            values (:ID_CONTRACT_CALENDAR_POST, :POST_DATE);
          end
        end

 --       for
 --         select S.ITEM
 --         from   SYSTEM_STRING_PARSER(:POSTING_DATE_LIST, ',') S
 --         into   :post_date
 --       do begin
 --         insert into CONTRACT_CALENDAR_SCHEME$PMS (ID_CONTRACT_CALENDAR_POST, POST_DATE)
 --         values (:ID_CONTRACT_CALENDAR_POST, :POST_DATE);
 --       end

        if ((:old_is_acc_post_item <> :is_acc_post_item) or (:old_service_price <> :service_price) or (:old_id_currency <> :id_currency)) then begin
          action_text = substring(f_character(29) || '@{pms.contract.is_income.' || :is_income || '}' ||
                        ', ' || :service_name ||
                        f_character(28) || '@{pms.is_acc_post_item.' || :old_is_acc_post_item || '}' || ', '
                        || formatfloat(:old_service_price, '0.00') || ', ' ||
                        :old_id_currency ||
                        f_character(28) || '@{pms.is_acc_post_item.' || :is_acc_post_item || '}' || ', ' ||
                        formatfloat(:service_price, '0.00') || ', ' || :id_currency from 1 for 255);
          execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_CALEN_MOD', :ACTION_TEXT);
        end

        if ((coalesce(:old_posting_period_duration, 0) <> coalesce(:posting_period_duration, 0)) or
            (coalesce(:old_posting_date_list, ' ') <> coalesce(:posting_date_list, formatdate(:month_next_date, 'D;dd.mm.yyyy')))) then begin
          action_text = substring(f_character(29) || '@{pms.contract.is_income.' || :is_income || '}' ||
                        ', ' || :service_name || ', ' || f_character(28) ||
                        iif(:old_is_fixed_date = 0, '@{pms.montly_plannig_scheme}' || ', ' || coalesce(:old_posting_period_duration, ' ') || ', ' ||
                                                    coalesce(:old_posting_date_list, ' '),
                                                    '@{pms.fixed_plannig_scheme}' || ', ' ||coalesce(:old_posting_date_list, ' ')) ||
                        f_character(28) || iif(:is_fixed_date = 0, '@{pms.montly_plannig_scheme}' || ', ' || coalesce(:posting_period_duration, ' ')
                                                                   || ', ' || /*coalesce(:posting_date_list, ' ')*/iif(:month_next_date is not null, formatdate(:month_next_date, 'D;dd.mm.yyyy'), ' '),
                                                                   '@{pms.fixed_plannig_scheme}' || ', ' || coalesce(:posting_date_list, ' ')) from 1 for 255);
          execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_CALEN_MOD_SCHM', :ACTION_TEXT);
        end
      end
    end
    if (:operation = 'mod_next_date') then begin
      select C.POST_NEXT_DATE, C.POSTING_PERIOD_DURATION, C.IS_FIXED_DATE
      from   CONTRACT_CALENDAR_POST$PMS C
      where  C.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST
      into   :post_date, :posting_period_duration, :is_fixed_date;

      if ((:is_fixed_date = 0) and (:posting_period_duration is not null) and (:post_date is not null)) then begin
        POST_NEXT_DATE = addmonth(:POST_DATE, :POSTING_PERIOD_DURATION);
      end else begin
        select first 1 skip 1 S.POST_DATE
        from   CONTRACT_CALENDAR_SCHEME$PMS S
        where  S.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST
        order by S.POST_DATE
        into   :POST_NEXT_DATE;
      end

      update CONTRACT_CALENDAR_POST$PMS C
      set    C.POST_DATE = :POST_DATE,
             C.POST_NEXT_DATE = :POST_NEXT_DATE
      where  C.ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST;
    end
    if (:operation = 'del') then begin
      action_text = f_character(29) || '@{pms.contract.is_income.' || :old_is_income || '}' || f_character(28) || :old_service_name ||
                    f_character(28) || '@{pms.is_acc_post_item.' || :old_is_acc_post_item || '}' ||
                    ', ' || formatfloat(:old_service_price, '0.00') ||
                    ', ' || :old_id_currency ||
                    ', ' || iif(:old_is_fixed_date = 0, '@{pms.montly_plannig_scheme}' || ', ' || coalesce(:old_posting_period_duration, ' ') ||
                                                        ', ' || coalesce(:old_post_next_date, ' '),
                                                        '@{pms.fixed_plannig_scheme}' || ', ' || coalesce(:old_posting_date_list, ' '));
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :OLD_ID_ROOM_CONTRACT, 'ROOM_CONTR_CALEN_DEL', substring(:ACTION_TEXT from 1 for 255));
      delete from CONTRACT_CALENDAR_POST$PMS
      where (ID_CONTRACT_CALENDAR_POST = :ID_CONTRACT_CALENDAR_POST);
    end
  end
end
^

/* Restore proc. body: CONTRACT_EXPENSE_MODIFY$PMS */
ALTER PROCEDURE CONTRACT_EXPENSE_MODIFY$PMS(ID_CONTRACT_EXPENSE TYPE OF ID,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
ID_SERVICE TYPE OF ID,
ID_CURRENCY TYPE OF TCURRENCY,
SERVICE_PRICE TYPE OF TPRICE,
CONTRACT_EXPENSE_TYPE VARCHAR(50),
MULTIPLIER_TYPE VARCHAR(50),
ORDER_TAG TYPE OF TCOUNT,
IS_ACC_POST_ITEM TYPE OF TLOGICAL,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_EXPENSE TYPE OF ID)
 AS
declare variable is_use smallint;
  declare variable formula varchar(100);
  declare variable service_name varchar(30);
  declare variable id_room_contract integer;
  declare variable old_service_name varchar(30);
  declare variable old_is_acc_post_item smallint;
  declare variable old_multiplier_type varchar(50);
  declare variable old_contract_expense_type varchar(50);
  declare variable old_order_tag integer;
  declare variable old_id_currency char(3);
  declare variable old_service_price numeric(15,4);
  declare variable old_id_service integer;
  declare variable contract_acc varchar(50);
  declare variable action_text varchar(255);
  declare variable id_hotel_contract integer;
  declare variable id_hotel_service integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');
  if ( :CONTRACT_EXPENSE_TYPE not in ('PERCENT', 'RUNNING_TOTAL_PERCENT', 'CURR_VALUE') ) then
    exception WRONG_PARAM_VALUE;

  if ( :MULTIPLIER_TYPE not in ('RESERVATION', 'STAY', 'GUESTS', 'BED_NIGHTS') ) then
    exception WRONG_PARAM_VALUE;

  if (:ORDER_TAG is null) then ORDER_TAG = 0;
  formula = '';
  is_use = 1;

  select SE.SERVICE_NAME, SE.id_hotel
  from   SERVICES SE
  where  SE.ID_SERVICE = :ID_SERVICE
  into   :service_name, :id_hotel_service;

  select R.ID_HOTEL
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS RP on RP.ID_ROOM_PERIOD = RC.ID_ROOM_PERIOD
         join ROOMS R on R.ID_ROOM = RP.ID_ROOM
  where  RC.ID_ROOM_CONTRACT = :ID_CONTRACT
  into   :id_hotel_contract;

  if (:id_hotel_contract is distinct from :id_hotel_service) then exception PMS_EXCEPTION '-626';

  if (:OPERATION = 'add') then begin
    /*select case
              when :ID_CONTRACT = RCP.ID_CONTRACT_GUEST then '@{pms.contract_base_account}'
              when :ID_CONTRACT = RCP.ID_CONTRACT_OWNER then '@{pms.contract_owner_use}'
              else '@{pms.contract_shadow_account}'
           end as CONTRACT_ACC,
           RCP.ID_ROOM_CONTRACT
    from ROOM_CONTRACT$PMS RCP
    where :ID_CONTRACT in (RCP.ID_CONTRACT_GUEST, RCP.ID_CONTRACT_OWNER, RCP.ID_CONTRACT_SHADOW)
    into :contract_acc, :id_room_contract;                      */
    id_room_contract = :ID_CONTRACT;
    contract_acc = case
                     when :SUB_CONTRACT = 'GUEST_USE' then '@{pms.contract_base_account}'
                     when :SUB_CONTRACT = 'OWNER_USE' then '@{pms.contract_owner_use}'
                     when :SUB_CONTRACT = 'SHADOW_ACC' then '@{pms.contract_shadow_account}'
                     else 'N/A'
                   end;

    NEW_ID_CONTRACT_EXPENSE = gen_id(GEN_CONTRACT_EXPENSE$PMS_ID, 1);
    insert into CONTRACT_EXPENSE$PMS (ID_CONTRACT_EXPENSE, ID_CONTRACT, SUB_CONTRACT, ID_SERVICE, ORDER_TAG,
           FORMULA, ID_CURRENCY, SERVICE_PRICE, CONTRACT_EXPENSE_TYPE, IS_ACC_POST_ITEM, MULTIPLIER_TYPE)
    values (:NEW_ID_CONTRACT_EXPENSE, :ID_CONTRACT, :SUB_CONTRACT, :ID_SERVICE, :ORDER_TAG,
           :FORMULA, :ID_CURRENCY, :SERVICE_PRICE, :CONTRACT_EXPENSE_TYPE, :IS_ACC_POST_ITEM, :MULTIPLIER_TYPE);

    action_text = substring(f_character(29) || :contract_acc || f_character(28) || :order_tag || f_character(28) || :service_name ||
                  f_character(28) || '@{pms.is_acc_post_item.' || :is_acc_post_item || '}' ||
                  f_character(28) || '@{pms.multiplier_type.' || :multiplier_type || '}' ||
                  f_character(28) || coalesce(:id_currency, '@{pms.contract_expense_type.' || :contract_expense_type || '}') ||
                  f_character(28) || formatfloat(:service_price, '0.00') from 1 for 255);
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_SERV_ADD', :ACTION_TEXT);
  end else begin
    select S.SERVICE_NAME, CEP.IS_ACC_POST_ITEM, CEP.MULTIPLIER_TYPE, CEP.CONTRACT_EXPENSE_TYPE, CEP.ORDER_TAG,
           CEP.ID_CURRENCY, CEP.SERVICE_PRICE, CEP.ID_SERVICE,
           case
             when CEP.SUB_CONTRACT = 'GUEST_USE' then '@{pms.contract_base_account}'
             when CEP.SUB_CONTRACT = 'OWNER_USE' then '@{pms.contract_owner_use}'
             when CEP.SUB_CONTRACT = 'SHADOW_ACC' then '@{pms.contract_shadow_account}'
             else 'N/A'
           end,
           CEP.ID_CONTRACT
    from   CONTRACT_EXPENSE$PMS CEP
           join SERVICES S on S.ID_SERVICE = CEP.ID_SERVICE
    where  CEP.ID_CONTRACT_EXPENSE = :ID_CONTRACT_EXPENSE
    into   :old_service_name, :old_is_acc_post_item, :old_multiplier_type, :old_contract_expense_type, :old_order_tag,
           :old_id_currency, :old_service_price, :old_id_service, :contract_acc, :id_room_contract;

    if (:OPERATION = 'mod') then begin
      if (:old_id_service <> :id_service) then begin
        execute procedure CONTRACT_EXPENSE_MODIFY$PMS(:ID_CONTRACT_EXPENSE, :ID_CONTRACT, :SUB_CONTRACT, :ID_SERVICE, :ID_CURRENCY, :SERVICE_PRICE,
                                                      :CONTRACT_EXPENSE_TYPE, :MULTIPLIER_TYPE, :ORDER_TAG, :IS_ACC_POST_ITEM, 'del')
        returning_values :new_id_contract_expense;
        execute procedure CONTRACT_EXPENSE_MODIFY$PMS(:ID_CONTRACT_EXPENSE, :ID_CONTRACT, :SUB_CONTRACT, :ID_SERVICE, :ID_CURRENCY, :SERVICE_PRICE,
                                                      :CONTRACT_EXPENSE_TYPE, :MULTIPLIER_TYPE, :ORDER_TAG, :IS_ACC_POST_ITEM, 'add')
        returning_values :new_id_contract_expense;
      end else begin
        update CONTRACT_EXPENSE$PMS
        set    -- ID_CONTRACT = :ID_CONTRACT,
               FORMULA = :FORMULA,
               ID_CURRENCY = :ID_CURRENCY,
               SERVICE_PRICE = :SERVICE_PRICE,
               CONTRACT_EXPENSE_TYPE = :CONTRACT_EXPENSE_TYPE,
               IS_ACC_POST_ITEM = :IS_ACC_POST_ITEM,
               MULTIPLIER_TYPE = :MULTIPLIER_TYPE,
               ORDER_TAG = :ORDER_TAG
        where  ID_CONTRACT_EXPENSE = :ID_CONTRACT_EXPENSE;

        if ((:old_is_acc_post_item <> :is_acc_post_item) or (:old_multiplier_type <> :multiplier_type) or
                   (coalesce(:old_id_currency, :old_contract_expense_type) <> coalesce(:id_currency, :contract_expense_type)) or
                   (:old_service_price <> :service_price)) then begin
          action_text = substring(f_character(29) || :old_service_name || f_character(28) || :contract_acc ||
                        f_character(28) || '@{pms.is_acc_post_item.' || :old_is_acc_post_item || '}' ||
                        f_character(28) || '@{pms.multiplier_type.' || :old_multiplier_type || '}' ||
                        f_character(28) || coalesce(:old_id_currency, '@{pms.contract_expense_type.' || :old_contract_expense_type || '}') ||
                        f_character(28) || formatfloat(:old_service_price, '0.00') ||
                        f_character(28) || '@{pms.is_acc_post_item.' || :is_acc_post_item || '}' ||
                        f_character(28) || '@{pms.multiplier_type.' || :multiplier_type || '}' ||
                        f_character(28) || coalesce(:id_currency, '@{pms.contract_expense_type.' || :contract_expense_type || '}') ||
                        f_character(28) || formatfloat(:service_price, '0.00') from 1 for 255);
          execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_SERV_CHANG', :ACTION_TEXT);
        end
      end
    end else if (:OPERATION = 'del') then begin
      action_text = substring(f_character(29) || :contract_acc || f_character(28) || :old_order_tag || f_character(28) || :old_service_name ||
                      f_character(28) || '@{pms.is_acc_post_item.' || :old_is_acc_post_item || '}' ||
                      f_character(28) || '@{pms.multiplier_type.' || :old_multiplier_type || '}' ||
                      f_character(28) || coalesce(:old_id_currency, '@{pms.contract_expense_type.' || :old_contract_expense_type || '}') ||
                      f_character(28) || formatfloat(:old_service_price, '0.00') from 1 for 255);
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_SERV_DEL', :ACTION_TEXT);

      delete from CONTRACT_EXPENSE$PMS
      where (ID_CONTRACT_EXPENSE = :ID_CONTRACT_EXPENSE);
    end
  end
end
^

/* Restore proc. body: CONTRACT_EXPENSE_POST$INT */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT TYPE OF ID,
ID_HOTEL INTEGER,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
ID_OWNER TYPE OF ID,
OWNERSHIP_PERCENT TYPE OF TPERCENT,
ID_RENTAL_POOL TYPE OF ID_REF,
VALUE_ORIG TYPE OF TPRICE,
CURR_ORIG TYPE OF TCURRENCY,
POST_DATE TYPE OF TDATE,
STAY TYPE OF TCOUNT,
MAX_GUEST_CNT TYPE OF TCOUNT,
BED_NIGHT_CNT TYPE OF TCOUNT,
RESERVS TYPE OF TCOUNT)
 AS
declare variable service_price numeric(15,4);
  declare variable id_currency varchar(3);
  declare variable contract_expense_type varchar(50);
  declare variable id_account integer;
  declare variable post_value numeric(15,4);
  declare variable post_currency varchar(3);
  declare variable id_service integer;
  declare variable is_owner_income smallint;
  declare variable is_client_acc_post smallint;
  declare variable multiplier_type varchar(50);
  declare variable multiplier integer;
  declare variable id_room integer;
  declare variable use_shadow_account integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
begin
  is_owner_income = 0;
  use_shadow_account = iif(:SUB_CONTRACT = 'SHADOW_ACC', 1, 0);

  select r.ID_HOTEL
  from   PMS_EVENT$PMS p
         join ROOMS R on r.ID_ROOM = p.ID_ROOM
  where  p.ID_PMS_EVENT = :ID_PMS_EVENT
  into   :id_hotel;
-- CONTRACT_EXPENSE_TYPE in ( 'PERCENT', 'RUNNING_TOTAL_PERCENT', 'CURR_VALUE' )
-- MULTIPLIER_TYPE in ('RESERVATION', 'STAY', 'GUESTS', 'BED_NIGHTS')
  for
    select C.SERVICE_PRICE, C.ID_CURRENCY, C.CONTRACT_EXPENSE_TYPE, C.IS_ACC_POST_ITEM,
           C.ID_SERVICE, C.MULTIPLIER_TYPE
    from   CONTRACT_EXPENSE$PMS C
    where  C.ID_CONTRACT = :id_contract
           and c.SUB_CONTRACT = :SUB_CONTRACT
    order by C.ORDER_TAG asc
    into   :service_price, :id_currency, :contract_expense_type, :is_client_acc_post,
           :ID_SERVICE, :multiplier_type
  do begin

    execute procedure OWNER_ACCOUNT_GET$INT (coalesce(:ID_RENTAL_POOL,:ID_OWNER),
            :id_hotel, :use_shadow_account, :is_client_acc_post)
    returning_values (:id_account, :is_account$pms);

    multiplier = case
                   when :multiplier_type = 'RESERVATION' then iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'STAY' then :STAY
                   when :multiplier_type = 'GUESTS' then :MAX_GUEST_CNT * iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'BED_NIGHTS' then :BED_NIGHT_CNT
                   else null
                 end;

    if (:multiplier is not null) then begin
      if (:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE') then begin
        post_value = cast(:service_price as double precision) * :ownership_percent / 100 * :multiplier;
        post_currency = :id_currency;
      end else if (:CONTRACT_EXPENSE_TYPE = 'PERCENT') then begin
        post_value = :VALUE_ORIG * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end else if (:CONTRACT_EXPENSE_TYPE = 'RUNNING_TOTAL_PERCENT') then begin
        execute procedure PMS_RUNNING_TOTAL_GET(:ID_PMS_EVENT, coalesce(:ID_RENTAL_POOL,:ID_OWNER), :ID_HOTEL, :POST_DATE, :CURR_ORIG)
        returning_values :post_value;
        if (:post_value < 0) then post_value = 0;
    
        post_value = :post_value * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end

      select pe.ID_ROOM
      from   PMS_EVENT$PMS PE
      where  pe.ID_PMS_EVENT = :ID_PMS_EVENT
      into   :id_room;

      select c.ROUND_TO
      from   CURRS C
      where  c.CURR = :post_currency
      into   :round_to;

      execute procedure PMS_POSTING_CREATE$INT(:ID_PMS_EVENT, :id_account, :id_service, :ID_OWNER,
              :POST_DATE, :post_currency, round_f(:post_value, :round_to), :is_account$pms, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* Restore proc. body: CONTRACT_MANAGEMENT_MODIFY$PMS */
ALTER PROCEDURE CONTRACT_MANAGEMENT_MODIFY$PMS(ID_CONTRACT_MANAGEMENT TYPE OF ID,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
ID_SERVICE TYPE OF ID,
MIN_VALUE TYPE OF TPRICE,
MIN_VALUE_CURR TYPE OF TCURRENCY,
MAX_VALUE TYPE OF TPRICE,
MAX_VALUE_CURR TYPE OF TCURRENCY,
NIGHT_PRICE TYPE OF TPRICE,
NIGHT_PRICE_CURR TYPE OF TCURRENCY,
IS_NETO TYPE OF TLOGICAL,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_MANAGEMENT TYPE OF ID)
 AS
declare variable is_use smallint;
  declare variable formula varchar(100);
  declare variable contract_acc varchar(50);
  declare variable id_room_contract integer;
  declare variable service_name varchar(30);
  declare variable old_id_contract integer;
  declare variable old_service_name varchar(30);
  declare variable old_min_value numeric(15,4);
  declare variable old_min_value_curr varchar(3);
  declare variable old_max_value numeric(15,4);
  declare variable old_max_value_curr varchar(3);
  declare variable old_night_price numeric(15,4);
  declare variable old_night_price_curr varchar(3);
  declare variable is_commision_service smallint;
  declare variable old_is_commision_service smallint;
  declare variable action_text varchar(255);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  formula = '';
  is_use = 1;

  select SE.SERVICE_NAME, iif(se.SERVICE_TYPE = 'COMMISSION', 0, 1) --SE.IS_ACC_POST_ITEM
  from   SERVICES SE
  where  SE.ID_SERVICE = :ID_SERVICE
  into   :service_name, :is_commision_service;

  if (:OPERATION = 'add') then begin
    /*select case
              when :ID_CONTRACT = RCP.ID_CONTRACT_GUEST then '@{pms.contract_base_account}'
              when :ID_CONTRACT = RCP.ID_CONTRACT_OWNER then '@{pms.contract_owner_use}'
              else  '@{pms.contract_shadow_account}'
           end as CONTRACT_ACC,
           RCP.ID_ROOM_CONTRACT
    from   ROOM_CONTRACT$PMS RCP
    where  :ID_CONTRACT in (RCP.ID_CONTRACT_GUEST, RCP.ID_CONTRACT_OWNER, RCP.ID_CONTRACT_SHADOW)
    into   :contract_acc, :id_room_contract; */
    id_room_contract = :ID_CONTRACT;
    contract_acc = case
                     when :SUB_CONTRACT = 'GUEST_USE' then '@{pms.contract_base_account}'
                     when :SUB_CONTRACT = 'OWNER_USE' then '@{pms.contract_owner_use}'
                     when :SUB_CONTRACT = 'SHADOW_ACC' then '@{pms.contract_shadow_account}'
                     else 'N/A'
                   end;

    new_id_contract_management = gen_id(GEN_CONTRACT_MANAGEMENT$PMS_ID, 1);
    insert into CONTRACT_MANAGEMENT$PMS (ID_CONTRACT_MANAGEMENT, ID_CONTRACT, SUB_CONTRACT,
           MIN_VALUE, MIN_VALUE_CURR, MAX_VALUE, MAX_VALUE_CURR,
           NIGHT_PRICE, NIGHT_PRICE_CURR, FORMULA, IS_NETO, IS_USE, ID_SERVICE)
    values (:new_id_contract_management, :ID_CONTRACT, :SUB_CONTRACT,
           :MIN_VALUE, :MIN_VALUE_CURR, :MAX_VALUE, :MAX_VALUE_CURR,
           :NIGHT_PRICE, :NIGHT_PRICE_CURR, :FORMULA, :IS_NETO, :IS_USE, :ID_SERVICE);

    action_text = f_character(29) || :contract_acc || f_character(28) ||
                  iif(:is_commision_service = 0, '@{word.commission}' || ' ' ||'@{word.the_service}' || ' ' || :service_name, :service_name) || f_character(28) ||
                  iif(:min_value is null, '', formatfloat(min_value, '0.00')) ||
                  iif(:max_value is null, '', formatfloat(max_value, '0.00')) ||
                  iif(:night_price is null, '', formatfloat(night_price, '0.00')) || f_character(28) ||
                  coalesce(min_value_curr, '') ||
                  coalesce(max_value_curr, '') || coalesce(night_price_curr, '');
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_KOM_SERV_ADD', :ACTION_TEXT);

  end else begin
    /*select CMP.ID_CONTRACT, CMP.MIN_VALUE, CMP.MIN_VALUE_CURR, CMP.MAX_VALUE, CMP.MAX_VALUE_CURR,
           CMP.NIGHT_PRICE, CMP.NIGHT_PRICE_CURR, SE.SERVICE_NAME, SE.IS_ACC_POST_ITEM,
           case
              when CMP.ID_CONTRACT = RCP.ID_CONTRACT_GUEST then '@{pms.contract_base_account}'
              when CMP.ID_CONTRACT = RCP.ID_CONTRACT_OWNER then '@{pms.contract_owner_use}'
              else  '@{pms.contract_shadow_account}'
           end as CONTRACT_ACC,
           RCP.ID_ROOM_CONTRACT
    from   CONTRACT_MANAGEMENT$PMS CMP
           join SERVICES SE on SE.ID_SERVICE = CMP.ID_SERVICE
           join ROOM_CONTRACT$PMS RCP on CMP.ID_CONTRACT in (RCP.ID_CONTRACT_GUEST, RCP.ID_CONTRACT_OWNER, RCP.ID_CONTRACT_SHADOW)
    where  CMP.ID_CONTRACT_MANAGEMENT = :ID_CONTRACT_MANAGEMENT
    into   :old_id_contract, :old_min_value, :old_min_value_curr, :old_max_value, :old_max_value_curr,
           :old_night_price, :old_night_price_curr, :old_service_name, :old_is_commision_service, :contract_acc, :id_room_contract;*/
    select CMP.ID_CONTRACT, CMP.MIN_VALUE, CMP.MIN_VALUE_CURR, CMP.MAX_VALUE, CMP.MAX_VALUE_CURR,
           CMP.NIGHT_PRICE, CMP.NIGHT_PRICE_CURR, SE.SERVICE_NAME, iif(se.SERVICE_TYPE = 'COMMISSION', 0, 1), --SE.IS_ACC_POST_ITEM,
           case
             when CMP.SUB_CONTRACT = 'GUEST_USE' then '@{pms.contract_base_account}'
             when CMP.SUB_CONTRACT = 'OWNER_USE' then '@{pms.contract_owner_use}'
             when CMP.SUB_CONTRACT = 'SHADOW_ACC' then '@{pms.contract_shadow_account}'
             else 'N/A'
           end as CONTRACT_ACC,
           CMP.ID_CONTRACT
    from   CONTRACT_MANAGEMENT$PMS CMP
           join SERVICES SE on SE.ID_SERVICE = CMP.ID_SERVICE
    where  CMP.ID_CONTRACT_MANAGEMENT = :ID_CONTRACT_MANAGEMENT
    into   :old_id_contract, :old_min_value, :old_min_value_curr, :old_max_value, :old_max_value_curr,
           :old_night_price, :old_night_price_curr, :old_service_name, :old_is_commision_service, :contract_acc, :id_room_contract;

    if (:OPERATION = 'mod') then begin
      update CONTRACT_MANAGEMENT$PMS
      set    -- ID_CONTRACT = :ID_CONTRACT,
             MIN_VALUE = :MIN_VALUE,
             MIN_VALUE_CURR = :MIN_VALUE_CURR,
             MAX_VALUE = :MAX_VALUE,
             MAX_VALUE_CURR = :MAX_VALUE_CURR,
             NIGHT_PRICE = :NIGHT_PRICE,
             NIGHT_PRICE_CURR = :NIGHT_PRICE_CURR,
             FORMULA = :FORMULA,
             IS_NETO = :IS_NETO,
             IS_USE = :IS_USE,
             ID_SERVICE = :ID_SERVICE
      where (ID_CONTRACT_MANAGEMENT = :ID_CONTRACT_MANAGEMENT);

      if ((:old_id_contract <> :id_contract) or (coalesce(:old_min_value, 0) <> coalesce(:min_value, 0)) or
          (coalesce(:old_min_value_curr, ' ') <> coalesce(:min_value_curr, ' ')) or
          (coalesce(:old_max_value, 0) <> coalesce(:max_value, 0)) or
          (coalesce(:old_max_value_curr, ' ') <> coalesce(:max_value_curr, ' ')) or
          (coalesce(:old_night_price, 0) <> coalesce(:night_price, 0)) or
          (coalesce(:old_night_price_curr, ' ') <> coalesce(:night_price_curr, ' ')) or
          (:is_commision_service <> :old_is_commision_service) or
          (coalesce(:service_name, ' ') <> coalesce(:old_service_name, ' '))) then begin
        action_text = f_character(29) || :contract_acc || f_character(28) ||
                      iif(:old_is_commision_service = 0, '@{word.commission}' || ' ' ||'@{word.the_service}' || ' ' || :old_service_name, :old_service_name) || f_character(28) ||
                      iif(:old_min_value is null, '', formatfloat(:old_min_value, '0.00')) ||
                      iif(:old_max_value is null, '', formatfloat(:old_max_value, '0.00')) ||
                      iif(:old_night_price is null, '', formatfloat(:old_night_price, '0.00')) || f_character(28) ||
                      coalesce(old_min_value_curr, '') ||
                      coalesce(old_max_value_curr, '') || coalesce(old_night_price_curr, '') ||
                      f_character(28) ||
                      iif(:is_commision_service = 0, '@{word.commission}' || ' ' ||'@{word.the_service}' || ' ' || :service_name, :service_name) || f_character(28) ||
                      iif(:min_value is null, '', formatfloat(:min_value, '0.00')) ||
                      iif(:max_value is null, '', formatfloat(:max_value, '0.00')) ||
                      iif(:night_price is null, '', formatfloat(:night_price, '0.00')) || f_character(28) || coalesce(min_value_curr, '') ||
                      coalesce(max_value_curr, '') || coalesce(night_price_curr, '');
        execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_KOM_SERV_CHANG', :ACTION_TEXT);
      end
    end else if (:OPERATION = 'del') then begin
      action_text = f_character(29) || coalesce(:contract_acc, '') || f_character(28) ||
                    iif(:old_is_commision_service = 0, '@{word.commission}' || ' ' ||'@{word.the_service}' || ' ' || :old_service_name, :old_service_name) || f_character(28) ||
                    iif(:old_min_value is null, '', formatfloat(:old_min_value, '0.00')) ||
                    iif(:old_max_value is null, '', formatfloat(:old_max_value, '0.00')) ||
                    iif(:old_night_price is null, '', formatfloat(:old_night_price, '0.00')) || f_character(28) || coalesce(old_min_value_curr, '') ||
                    coalesce(old_max_value_curr, '') || coalesce(old_night_price_curr, '');
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_KOM_SERV_DEL', :ACTION_TEXT);

      delete from CONTRACT_MANAGEMENT$PMS
      where (ID_CONTRACT_MANAGEMENT = :ID_CONTRACT_MANAGEMENT);
    end
  end
end
^

/* Restore proc. body: CREATE_BOOKING$WBE */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
declare variable rate varchar(50);
declare variable room_type varchar(20);
declare variable arrival date;
declare variable departure date;
declare variable adults integer;
declare variable children integer;
declare variable profile_name varchar(100);
declare variable aranger_name varchar(100);
declare variable guest_profile_uuid varchar(40);
declare variable aranger_profile_uuid varchar(40);
declare variable hotel_name varchar(50);
declare variable wbe_session_id bigint;
declare variable main_guest_profile_id integer;
declare variable board varchar(50);
declare variable hotel_id integer;
declare variable guarantee_policy_name varchar(50);
declare variable guarantee_deposit_percent numeric(15,4);
declare variable guarantee_deposit_nights integer;
declare variable guarantee_due_days_bef_arrival integer;
declare variable guarantee_due_days_after_create integer;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable profile_type varchar(20);
declare variable profile_import_time timestamp;
declare variable b_count integer;
declare variable age integer;
declare variable is_child smallint;
declare variable guest_id integer;
declare variable special_treatment varchar(250);
declare variable maintenance varchar(30);
declare variable routing varchar(20);
declare variable arranger_paymeny_type varchar(20);
declare variable market_segment varchar(30);
declare variable market_source varchar(30);
declare variable market_channel varchar(30);
declare variable market_hear_reason varchar(30);
declare variable market_come_reason varchar(30);
declare variable first_food varchar(30);
declare variable bnote varchar(2000);
begin
  -- get wbe product selection
  select  PA.rate_name,PA.room_name, AQ.first_date, AQ.first_date+AQ.day_count,
          PS.adults, PS.children, PS.person_name, H.hotel_name, H.id_hotel,
          WS.id, PA.board_name, GP.name, GP.deposit_totalsum_part, GP.deposit_nights_count, GP.due_days_before_arrival, GP.due_days_after_create,
          PS.bnote
   from   PRODUCT_SELECTION$WBE PS
          join WBE_SESSION$WBE WS on WS.id = PS.wbe_session_id
          join PRODUCT_AVAILABILITY$WBE PA on pa.id = PS.product_availability_id
          join AVAILABILITY_QUERY$WBE AQ on aq.id = WS.product_query_id
          join HOTEL H on H.id_hotel = WS.hotel_id
          join GUARANTEE_POLICY GP on GP.id_guarantee_policy = PS.guarantee_policy_id
   where  PS.id = :product_selection_id
   into   :rate, :room_type, :arrival, :departure,
          :adults,  :children, :profile_name, :hotel_name, :hotel_id,
          :wbe_session_id, :board, :guarantee_policy_name,
          :guarantee_deposit_percent, :guarantee_deposit_nights,
          :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create,
          :bnote;

  select PA.uuid , PA.profile_name, PA.profile_type
  from   PROFILE PA
  where  PA.id_profile = :aranger_profile_id
  into   :aranger_profile_uuid,:aranger_name,  :profile_type;

  if (:aranger_name = :profile_name and :profile_type = 'PERSON') then begin
    -- aranger is main guest
    select count(*)
    from   PRODUCT_SELECTION$WBE PSC
    where  PSC.wbe_session_id = :wbe_session_id
    into   :b_count;
       -- only if single reservation bugfix 2228
    if (1 = :b_count) then begin
     guest_profile_uuid =  aranger_profile_uuid;
     aranger_profile_uuid = null;
    end
  end else begin
    -- create profile for main guest
    execute procedure IMPORT_PERSON_PROFILE$EXC(
      uuid_create(),:profile_name,null,null,null,null,null,null,null,null,null,null, null,
      null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
      null,null,null,null,null, null, null)
    returning_values :main_guest_profile_id, :profile_import_time;

    select P.uuid
    from   PROFILE P
    where  P.id_profile = :main_guest_profile_id
    into   :guest_profile_uuid;
  end

    -- apply default map + forced arranger
    special_treatment = null;
    maintenance = null;
    routing = null;
    arranger_paymeny_type = null;
    market_segment = null;
    market_source = null;
    market_channel = null;
    market_hear_reason = null;
    market_come_reason = null;


  select hc.special_treatment, hk.plan_name, hc.routing,
         pt.payment_type, ms.segment_name, sc.description, cc.description,
         hr.description, cr.description, hc.first_food
  from   HOTEL_PRODUCT_CFG$WBE hc
         left join HK_PLAN hk on hk.id_plan = hc.id_hk_plan
         left join PAYMENT_TYPE pt on pt.id_payment_type = hc.arranger_id_payment_type
         left join NOM_MARKET_SEGMENTS ms on ms.id_nom_market_segment = hc.id_m_segment
         left join NOM_SOURCE_CODES sc on sc.id_nom_source_code = hc.id_m_source
         left join NOM_CHANNEL_CODES cc on cc.id_nom_channel_code = hc.id_m_channel
         left join NOM_HEAR_REASONS hr on hr.id_nom_hear_reason = hc.id_m_hear_reason
         left join NOM_COME_REASONS cr on cr.id_nom_come_reason = hc.id_m_come_reason
  where  hc.hotel_id = :hotel_id
  into   :special_treatment,:maintenance,:routing,:arranger_paymeny_type,
         :market_segment,:market_source,:market_channel,:market_hear_reason,:market_come_reason,:first_food;
  -- create reseravation
  execute procedure IMPORT_BOOKING$EXC(
     :hotel_name, :number, null, null, 0,
     :arrival, null, :departure, null, null, null, null, null, :room_type, :board, null,
     :special_treatment, :maintenance, :routing, :rate, null, null, null, null, :arranger_paymeny_type, null, null, null, null,
     :market_segment, :market_source,:market_channel, :market_hear_reason, :market_come_reason,
     :bnote, null, :first_food, :adults, :children, :aranger_profile_uuid, null, :guest_profile_uuid,
     0, 0, null, :guarantee_policy_name, null, :guarantee_deposit_percent, :guarantee_deposit_nights,
     :guarantee_due_days_bef_arrival,  :guarantee_due_days_after_create, null, null, null, null,  null, null, null, null, null, null, null, null)
  returning_values
     :hotel_id, :booking_id, :err_code, err_text;
  if (0 <> :err_code) then exception WRONG_VALUE ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');

  -- import guests
  for
    select psg.guest_name, psg.is_child, psg.age
    from   PRODUCT_SELECTION_GUESTS$WBE psg
    where  psg.product_selection_id = :product_selection_id
    into   :profile_name,:is_child,:age
  do begin
    execute procedure IMPORT_GUEST$EXC(:booking_id, null, null, :profile_name, :is_child, :age, null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null)
    returning_values :guest_id, :err_code,:err_text;
    if (0 <> :err_code) then exception WRONG_VALUE ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');
  end
  ----------------

  select RD.number_2
  from   RESERV_DETAIL RD
  where  RD.id_reserv_detail = :booking_id
  into   :number_2;

  update PRODUCT_SELECTION$WBE uPS
  set    uPS.booking_id = :booking_id, uPS.selection_id = :number_2
  where  uPS.id = :product_selection_id;
end
^

/* Restore proc. body: CURR_RATE_MODIFY */
ALTER PROCEDURE CURR_RATE_MODIFY(CURR CHAR(3),
ID_HOTEL INTEGER,
RATE NUMERIC(15,6),
FOR_DATE DATE = null)
 AS
declare variable ap_dbkey char(8);
  declare variable guest_posting_rate varchar(20);
  declare variable from_date date;
  declare variable cr_dbkey char(8);
  declare variable old_rate numeric(15,6);
  declare variable id_curr_rate integer;
  declare variable hotel_name varchar(50);
  declare variable action_text varchar(255);
  declare variable nation_curr tcurrency;
begin
  for_date = coalesce(:FOR_DATE, current_date);

  select h.HOTEL_NAME, h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :ID_HOTEL
  into   :hotel_name, :nation_curr;

  if (:nation_curr = :CURR and :RATE <> 1) then exception ASSERT '-35';

  select cr.RDB$DB_KEY, cr.CURR_RATE
  from   CURR_RATES CR
  where  CR.CURR = :CURR
         and cr.ID_HOTEL = :ID_HOTEL
         and cr.DATE_ = :FOR_DATE
  into   :cr_dbkey, :old_rate;

  if (:old_rate is null) then begin
    insert into CURR_RATES (CURR, ID_HOTEL, DATE_, CURR_RATE)
    values (:CURR, :ID_HOTEL, :FOR_DATE, :RATE)
    returning ID_CURR_RATE into :id_curr_rate;

    select first 1 r.CURR_RATE
    from   CURR_RATES r
    where  r.ID_HOTEL = :ID_HOTEL
           and r.CURR = :CURR
           and r.DATE_ < :FOR_DATE
    order by r.DATE_ desc
    into   :old_rate;

  end else if (:old_rate <> :RATE) then begin
    update CURR_RATES r
    set    r.CURR_RATE = :RATE
    where  r.RDB$DB_KEY = :cr_dbkey;
  end else begin
    exit;
  end

  action_text = f_character(29) || :hotel_name || f_character(28)
                || formatdate(:FOR_DATE, 'D;dd.mm.yyyy') || f_character(28)
                || coalesce(:old_rate, 'N/A') || f_character(28)
                || coalesce(:RATE, 'N/A');

  execute procedure SYSTEM_LOG_ADD ('CURRENCY', :id_curr_rate, 'RATE_CHANGED', :action_text, :RATE);

  if (:old_rate is not null) then begin   -- this is not first, initial rate
    /* CHANGE THE CURRENR_RATE OF THE OPEN POSTINGS */
    execute procedure SETTING_GET_VALUE('GUEST_POSTING_RATE', :ID_HOTEL)
    returning_values  :guest_posting_rate;
  
    for
      select AP.rdb$db_key, G.FROM_DATE
      from   ACCOUNT_POST AP
             join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
             left outer join GUEST G on G.ID_GUEST = AP.ID_GUEST
      where  ((AP.CURR_POST = :CURR) or (AP.CURR_ORIG = :CURR))
             and AP.AC = '00'
             and AP.ID_BASE_DOC is null
             and AP.DATE_POST >= current_date
             and A.ID_HOTEL = :ID_HOTEL
      into   :ap_dbkey, :from_date
    do begin
      if (:guest_posting_rate = 'CHECKIN_DATE' and :from_date < current_date) then begin
        /* Do nothing. Theese postings are by guest check_in date rate,
        || which is not changing now
        */
      end else begin
        execute procedure ACCOUNT_POSTING_UPDATE_RATE$INT (:ap_dbkey, :CURR, :RATE);
      end
    end
  end
end
^

/* Restore proc. body: DEPOSIT_ANUL$INT */
ALTER PROCEDURE DEPOSIT_ANUL$INT(ID_DEPOSIT INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_PAYMENT_HEAD INTEGER)
 AS
declare variable id_doc_head integer;
  declare variable id_account integer;
  declare variable deposit_init_amount numeric(15,4);
  declare variable avail_value numeric(15,4);
  declare variable pay_currency varchar(3);
  declare variable payment_date date;
  declare variable dep_current_value numeric(15,4);
  declare variable sys_date date;
  declare variable id_hotel integer;
begin
  select D.ID_PAYMENT_HEAD, D.ID_ACCOUNT, P.PAY_VALUE_A, P.PAYMENT_DATE,
         D.RECEIVED_AMOUNT - d.DEDUCTED_AMOUNT as AVAIL_VALUE, D.ID_DOC_HEAD,
         D.PAY_CURRENCY, D.RECEIVED_AMOUNT
  from   DEPOSITS D
         join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_payment_head, :id_account, :deposit_init_amount, :payment_date,
         :avail_value, :id_doc_head, :pay_currency, :dep_current_value;

  if ((:dep_current_value is null) or (:dep_current_value < :deposit_init_amount)) then
    exception PAYMENT_ANNUL_EXCEPTION '-369';
    --'Part of deposit is refunded or transfered';

  if ((:avail_value is null) or (:avail_value < :deposit_init_amount)) then
    exception PAYMENT_ANNUL_EXCEPTION '-350';
    --'Part of deposit is used into document.';

  if (:id_doc_head is not null) then
    exception PAYMENT_ANNUL_EXCEPTION '-351';
    --'Can not storno deposit, because has invoice for it. First - storno invoice.';

  select A.ID_HOTEL
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :id_account
  into   :id_hotel;

  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) SD
  into   :SYS_DATE;

  if (:sys_date > :payment_date) then
    exception PAYMENT_ANNUL_EXCEPTION '-349';
    -- Can not void deposit payment for previous date ! May refund it! It's very important for payments control!!!

  execute procedure PAYMENT_ANUL$INT (:ID_PAYMENT_HEAD, :DESCRIPTION);

  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'ANNUL', f_character(29) || formatfloat(:deposit_init_amount, 'F;0.00') || ' ' || :PAY_CURRENCY || f_character(28) || :DESCRIPTION);

end
^

/* Restore proc. body: DEPOSIT_NEW$DOC */
ALTER PROCEDURE DEPOSIT_NEW$DOC(ID_ACCOUNT INTEGER,
ID_DOC_TYPE INTEGER,
PAY_VALUE NUMERIC(15,4),
PAY_CURRENCY VARCHAR(3),
DESCRIPTION VARCHAR(100),
ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_DEPOSIT INTEGER,
ID_PAYMENT_HEAD INTEGER)
 AS
declare variable pay_rate numeric(15,6);
  declare variable payment_date date;
  declare variable is_taxable smallint;
  declare variable id_profile integer;
  declare variable dbkey char(8);
  declare variable acc_curr varchar(3);
  declare variable acc_rate numeric(15,6);
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable id_account_payment integer;
  declare variable is_posting_stopped integer;
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_NEW');

  select r.IS_POSTING_STOPPED
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :is_posting_stopped;

  if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';

  select A.ID_PROFILE, A.ACCOUNT_CURR, A.ID_HOTEL
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_ACCOUNT
  into   :id_profile, :acc_curr, :id_hotel;

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values  (:payment_date);

  execute procedure CURR_RATE_GET (:acc_curr, :payment_date, :id_hotel)
  returning_values  (:acc_rate);

  execute procedure CURR_RATE_GET (:PAY_CURRENCY, :payment_date, :id_hotel)
  returning_values  (:pay_rate);

  execute procedure PAYMENT_CREATE$INT (:ID_DOC_TYPE, :ID_ACCOUNT, :payment_date,
                    :PAY_VALUE, :PAY_CURRENCY, :pay_rate,
                    :acc_curr, :acc_rate, :DESCRIPTION)
  returning_values  :id_payment_head, :id_account_payment, :is_taxable;

  ID_DEPOSIT = gen_id(GEN_DEPOSITS_ID, 1);
  insert into DEPOSIT (ID_DEPOSIT, DESCRIPTION, ID_ACCOUNT, ID_PAYMENT_HEAD, ID_PROFILE, ID_RESERV_DETAIL)
  values (:ID_DEPOSIT, :DESCRIPTION, :ID_ACCOUNT, :ID_PAYMENT_HEAD, :id_profile, :id_reserv_detail);

  select PH.RDB$DB_KEY
  from   PAYMENT_HEAD PH
  where  PH.ID_PAYMENT_HEAD = :id_payment_head
  into   :dbkey;

  update PAYMENT_HEAD P
  set    p.ID_DEPOSIT = :ID_DEPOSIT
  where  p.RDB$DB_KEY = :dbkey;

  update ACCOUNT_PAYMENTS AP
  set    AP.ID_DEPOSIT = :ID_DEPOSIT
  where  ap.ID_ACCOUNT_PAYMENT = :id_account_payment;

  execute procedure PAYMENT_SET_NUMBER$INT(:dbkey);

  action_text = f_character(29) || formatfloat(:PAY_VALUE, 'F;0.00') || ' ' || :PAY_CURRENCY;
  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'CREATE', :action_text);

end
^

/* Restore proc. body: DEPOSIT_REFUND$DOC */
ALTER PROCEDURE DEPOSIT_REFUND$DOC(ID_DEPOSIT INTEGER,
REFUND_AMOUNT NUMERIC(15,4),
REFUND_CURRENCY VARCHAR(3),
ID_PAY_DOC_TYPE INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_REFUND_PAYMENT INTEGER,
ID_STORNO_DOC INTEGER,
WARN_CODE INTEGER)
 AS
declare variable no_use varchar(2000);
  declare variable id_account integer;
  declare variable avail_value numeric(15,4);
  declare variable id_doc_head integer;
  declare variable pay_currency varchar(3);
  declare variable pay_rate numeric(15,6);
  declare variable sys_date date;
  declare variable round_to numeric(15,4);
  declare variable p_dbkey char(8);
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable id_account_payment integer;
  declare variable id_doc_type integer;
  declare variable account_curr varchar(3);
  declare variable account_rate numeric(15,6);
  declare variable id_reserv_detail integer;
  declare variable is_posting_stopped integer;
  declare variable firm_data type of tnote_blob;
begin
  WARN_CODE = null;
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_REFUND');

  select D.ID_ACCOUNT, DH.ID_DOC, dh.ID_DOC_TYPE, c.ROUND_TO, d.ID_RESERV_DETAIL,
         D.AVAIL_VALUE, D.PAY_CURRENCY, D.PAY_RATE, A.ID_HOTEL, A.ACCOUNT_CURR
  from   DEPOSIT_AVAILABLE D
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join CURRS C on c.CURR = d.PAY_CURRENCY
         left outer join DOC_HEAD DH on DH.ID_DOC = D.ID_DOC_HEAD
                                        and DH.IS_STORNED = 0
                                        and DH.IS_ANUL = 0
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_account, :id_doc_head, :id_doc_type, :round_to, :id_reserv_detail,
         :avail_value, :pay_currency, :pay_rate, :id_hotel, :account_curr;

  if (:pay_currency is distinct from :refund_currency) then exception PAYMENT_EXCEPTION 'Currency mismatch!';

  if (round_f(:avail_value - :REFUND_AMOUNT, :round_to) < 0) then exception PAYMENT_EXCEPTION '-305';
  --'Issued value is more than available deposit amount.';

  select r.IS_POSTING_STOPPED
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :is_posting_stopped;

  if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';

  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET(:id_hotel) SD
  into   :sys_date;

  select first 1 ap.ACC_RATE
  from   ACCOUNT_PAYMENTS ap
  where  ap.ID_DEPOSIT = :ID_DEPOSIT
  order by ap.ID_ACCOUNT_PAYMENT asc
  into   :account_rate;

  execute procedure PAYMENT_CREATE$INT (:ID_PAY_DOC_TYPE, :ID_ACCOUNT, :SYS_DATE,
          -:REFUND_AMOUNT, :PAY_CURRENCY, :PAY_RATE, :account_curr, :account_rate, :DESCRIPTION)
  returning_values  (:id_refund_payment, :id_account_payment, :no_use);

  insert into DEPOSIT_REFUND (ID_DEPOSIT, ID_PAYMENT_HEAD, DESCRIPTION)
  values (:ID_DEPOSIT, :ID_REFUND_PAYMENT, :DESCRIPTION);

  update ACCOUNT_PAYMENTS AP
  set    AP.ID_DEPOSIT = :ID_DEPOSIT
  where  ap.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT;

  if (:ID_DOC_HEAD is not null) then begin
    execute procedure DOC_TYPE_EVALUATE$INT (:id_doc_type, :id_hotel, 0, :ID_REFUND_PAYMENT);

    execute procedure DOCUMENT_ADVANCE_STORNO$INT (:ID_DEPOSIT, :REFUND_AMOUNT, :DESCRIPTION)
    returning_values  (:ID_STORNO_DOC, :WARN_CODE);

    execute procedure DOCUMENT_ATTACH_PAYMENT$INT (:ID_STORNO_DOC, :id_account_payment, :pay_rate, null)
    returning_values :no_use;
     
    update  PAYMENT_HEAD P
    set     P.ID_DOC_HEAD = :ID_STORNO_DOC
    where   P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT;

    execute procedure DOCUMENT_VALIDATE$DOC (:ID_STORNO_DOC)
    returning_values (:firm_data, :no_use, :no_use);
  end else begin
    select P.RDB$DB_KEY
    from   PAYMENT_HEAD P
    where  P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT
    into   :P_DBKEY;
     
    execute procedure PAYMENT_SET_NUMBER$INT (:P_DBKEY);
  end

  action_text = F_CHARACTER(29) || :REFUND_AMOUNT || ' ' || :PAY_CURRENCY;
  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'REFUND', :ACTION_TEXT);
end
^

/* Restore proc. body: DEPOSIT_REFUND_PAY_ANNUL$INT */
ALTER PROCEDURE DEPOSIT_REFUND_PAY_ANNUL$INT(ID_REFUND_PAYMENT INTEGER,
ANNUL_REASON VARCHAR(255) = '')
 AS
declare variable id_deposit integer;
  declare variable pay_value numeric(15,4);
  declare variable pay_curr varchar(3);
  declare variable id_hotel integer;
  declare variable sys_date date;
  declare variable payment_date date;
begin
  select ap.ID_DEPOSIT, P.PAY_CURRENCY, a.ID_HOTEL, p.PAYMENT_DATE, coalesce(sum(aP.PAY_AMOUNT), 0)
  from   PAYMENT_HEAD P
         join ACCOUNT A on a.ID_ACCOUNT = p.ID_ACCOUNT
         join ACCOUNT_PAYMENTS ap on ap.ID_PAYMENT_HEAD = p.ID_PAYMENT_HEAD
  where  P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT
  group by P.ID_PAYMENT_HEAD, ap.ID_DEPOSIT, P.PAY_CURRENCY, a.ID_HOTEL, p.PAYMENT_DATE
  into   :id_deposit, :pay_curr, :id_hotel, :payment_date, :pay_value;
  /* !!! - check if is real deposit refund */
  if (:id_deposit is null) then EXIT;

  if (:pay_value = 0) then exception PAYMENT_EXCEPTION 'Zero payment amount!';
  /*  */
  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) SD
  into   :sys_date;

  if (:sys_date > :payment_date) then
    exception PAYMENT_ANNUL_EXCEPTION '-349';
    -- Can not void deposit payment for previous date ! May refund it! It's very important for payments control!!!

  execute procedure PAYMENT_ANUL$INT(:ID_REFUND_PAYMENT, :ANNUL_REASON);

  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'REFUND_ANNUL', f_character(29) || formatfloat(:pay_value, 'F;0.00') || ' ' || :pay_curr || f_character(28) || :ANNUL_REASON);

end
^

/* Restore proc. body: DEPOSIT_TRANSFER$INT */
ALTER PROCEDURE DEPOSIT_TRANSFER$INT(ID_DEPOSIT TYPE OF ID,
ID_DEST_ACCOUNT TYPE OF ID,
SPLIT_AMOUNT TYPE OF TPRICE,
DEPOSIT_DESCRIPTION TYPE OF TDESCRIPTION_SHORT,
TRANSFER_REASON TYPE OF TREASON = null)
 RETURNS(NEW_ID_DEPOSIT TYPE OF ID)
 AS
declare variable id_source_account integer;
  declare variable id_payment_head integer;
  declare variable doc_selected integer;
  declare variable id_profile integer;
  declare variable orig_descr varchar(100);
  declare variable action_text varchar(255);
  declare variable pay_currency varchar(3);
  declare variable curr_dest varchar(3);
  declare variable curr_src varchar(3);
  declare variable pay_date date;
  declare variable dest_acc_rate numeric(15,6);
  declare variable src_acc_rate numeric(15,6);
  declare variable is_anul integer;
  declare variable sys_date date;
  declare variable id_reserv_detail integer;
  declare variable id_hotel integer;
  declare variable pay_rate numeric(15,6);
  declare variable id_account_payment_src integer;
  declare variable id_account_payment_dest integer;
  declare variable is_posting_stopped integer;
  declare variable id_system_log integer;
  declare variable id_billing_service integer;
begin

  select D.ID_ACCOUNT, D.ID_PAYMENT_HEAD, D.DOC_SELECTED, D.ID_PROFILE, D.DESCRIPTION,
         P.PAY_CURRENCY, P.IS_ANUL, P.PAYMENT_DATE, D.ID_RESERV_DETAIL, A.ID_HOTEL,
         p.PAY_RATE, d.ID_BILLING_SERVICE, a.ACCOUNT_CURR
  from   DEPOSIT D
         join PAYMENT_HEAD P on P.ID_PAYMENT_HEAD = D.ID_PAYMENT_HEAD
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_source_account, :id_payment_head, :doc_selected, :id_profile, :orig_descr,
         :pay_currency, :is_anul, :pay_date, :id_reserv_detail, :id_hotel,
         :pay_rate, :id_billing_service, :curr_src;

  if (:is_anul = 1) then
    exception PAYMENT_EXCEPTION '-355'; -- payment is annul

  select r.IS_POSTING_STOPPED
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :is_posting_stopped;

  if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';

  if (not exists (select A.ID_ACCOUNT
                  from   ACCOUNT A
                  where  A.ID_ACCOUNT = :ID_DEST_ACCOUNT
                         and A.ID_HOTEL = :id_hotel)) then exception ACCOUNT_EXCEPTION '-376';

  if (coalesce(:DEPOSIT_DESCRIPTION, '') = '') then DEPOSIT_DESCRIPTION = :orig_descr;

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values :sys_date;

  select first 1 ap.ACC_RATE
  from   ACCOUNT_PAYMENTS ap
  where  ap.ID_PAYMENT_HEAD = :id_payment_head
         and ap.ID_ACCOUNT = :id_source_account
  order by ap.ID_ACCOUNT_PAYMENT asc
  into   :src_acc_rate;

  insert into ACCOUNT_PAYMENTS (ID_ACCOUNT, ID_PAYMENT_HEAD, PAY_AMOUNT, PAY_RATE,
         ACC_AMOUNT, ACC_RATE, TRANSACTION_DATE, ID_DEPOSIT)
  values (:id_source_account, :id_payment_head, -:SPLIT_AMOUNT, :pay_rate,
         -:SPLIT_AMOUNT * cast(:pay_rate / :src_acc_rate as double precision), :src_acc_rate,
         :sys_date, :ID_DEPOSIT)
  returning id_account_payment into :id_account_payment_src;

  NEW_ID_DEPOSIT = gen_id(GEN_DEPOSITS_ID, 1);
  insert into DEPOSIT (ID_DEPOSIT, DESCRIPTION, ID_ACCOUNT, ID_PAYMENT_HEAD, DOC_SELECTED, ID_PROFILE, ID_RESERV_DETAIL, ID_BILLING_SERVICE)
  values (:NEW_ID_DEPOSIT, :DEPOSIT_DESCRIPTION, :ID_DEST_ACCOUNT, :id_payment_head, :doc_selected, :id_profile, :id_reserv_detail, :id_billing_service);

  select A.ACCOUNT_CURR
  from   ACCOUNT A
  where  A.ID_ACCOUNT = :ID_DEST_ACCOUNT
  into   :curr_dest;
   
  if (:curr_dest is distinct from :curr_src) then begin
    execute procedure CURR_RATE_GET(:curr_dest, :pay_date, :id_hotel)
    returning_values  :dest_acc_rate;
  end else begin
    dest_acc_rate = :src_acc_rate;
  end

  insert into ACCOUNT_PAYMENTS (ID_ACCOUNT, ID_PAYMENT_HEAD, PAY_AMOUNT, PAY_RATE,
         ACC_AMOUNT, ACC_RATE, TRANSACTION_DATE, ID_DEPOSIT)
  values (:ID_DEST_ACCOUNT, :id_payment_head, :SPLIT_AMOUNT, :pay_rate,
         :SPLIT_AMOUNT * cast(:pay_rate / :dest_acc_rate as double precision), :dest_acc_rate,
         :sys_date, :NEW_ID_DEPOSIT)
  returning id_account_payment into :id_account_payment_dest;

  action_text = f_character(29) || :id_source_account ||
                f_character(28) || :id_dest_account ||
                f_character(28) || formatfloat(:split_amount, '0.00') || ' ' || :pay_currency ||
                f_character(28) || coalesce(:TRANSFER_REASON, '');
  execute procedure SYSTEM_EVENT_LOG$INT ('DEPOSIT', :ID_DEPOSIT, 'TRANSFER', :ACTION_TEXT)
  returning_values :id_system_log;

  insert into ACCOUNT_PAYMENT_TRANSFER (ID_ACCOUNT_PAYMENT_SOURCE, ID_ACCOUNT_PAYMENT_DEST, ID_SYSTEM_LOG)
  values (:id_account_payment_src, :id_account_payment_dest, :id_system_log);

end
^

/* Restore proc. body: DOCUMENT_ANUL$DOC */
ALTER PROCEDURE DOCUMENT_ANUL$DOC(ID_DOC_HEAD INTEGER,
ANUL_REASON VARCHAR(100),
MAKE_ANNUL_REPORT SMALLINT)
 AS
/**/
  declare variable id_account  integer;
  declare variable id_payment_head integer;
  declare variable for_deposit integer;
  declare variable id_base_doc integer;
  declare variable is_anul integer;
  declare variable dh_dbkey char(8);
  declare variable id_annul_protocol_num integer;
  declare variable num integer;
  declare variable doc_num varchar(20);
  declare variable system_date date;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable doc_date date;
  declare variable id_system_log integer;
  declare variable id_hotel integer;
  declare variable is_storno_doc integer;
  declare variable no_use integer;
begin

  select H.RDB$DB_KEY, H.ID_ACCOUNT, H.FOR_DEPOSIT, H.ID_BASE_DOC, H.IS_ANUL, A.ID_HOTEL,
         A.ID_RESERV_DETAIL, T.ID_ANNUL_DOC_NUM, h.DOC_DATE, H.IS_STORNO
  from   DOC_HEAD$INT H
         join DOC_COMPLETION dc on dc.ID_DOC_HEAD = h.ID_DOC_HEAD
         join DOC_TYPE T on H.ID_DOC_TYPE = T.ID_DOC_TYPE
         join DOC_TYPE_INV DTI on DTI.ID_DOC_TYPE = T.ID_DOC_TYPE
         join ACCOUNT A on A.ID_ACCOUNT = H.ID_ACCOUNT
  where  H.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :dh_dbkey, :id_account, :for_deposit, :id_base_doc, :is_anul, :id_hotel,
         :id_reserv_detail, :id_annul_protocol_num, :doc_date, :is_storno_doc;

  if (:is_anul = 1) then
    exception DOCUMENT_ANNUL_EXCEPTION '-352'; --'Document is already annul';

  if (exists (select D.ID_DOC
              from   DOC_HEAD D
              where  D.ID_BASE_DOC = :ID_BASE_DOC
                     and D.ID_DOC > :ID_DOC_HEAD
                     and D.IS_ANUL = 0))
  then exception DOCUMENT_ANNUL_EXCEPTION '-314';

  if (exists (select D.ID_DEPOSIT
              from   DEPOSIT_DEDUCT DD
                     join DEPOSITS d on d.ID_DEPOSIT = dd.ID_DEPOSIT
              where  DD.ID_DOC_USED = :ID_DOC_HEAD
                     and D.RECEIVED_AMOUNT = 0))
  then exception DOCUMENT_ANNUL_EXCEPTION '-315';

  execute procedure SYSTEM_DATE_GET(:ID_HOTEL)
  returning_values  :system_date;

  if (:DOC_DATE < :SYSTEM_DATE) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_PREV_DATE');
  end
  /* unarchive account and set as credit account, for shecked out bookings only */
  execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:ID_ACCOUNT, 0);

  if (:ID_RESERV_DETAIL is not null) then begin
    select RD.CHECK_STATUS
    from   RESERV_DETAIL RD
    where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :check_status;

    if (:check_status = 1) then begin
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, null, 1);
    end
  end
  /* MARK THE DOCUMENT AS ANUL - before posting and payment updates */
  update DOC_HEAD$INT DH
  set    DH.IS_ANUL = 1
  where  DH.RDB$DB_KEY = :dh_dbkey;

  update DOC_COMPLETION Dc
  set    Dc.IS_EFAKTURA_EXPORTED = 0
  where  Dc.ID_DOC_HEAD = :ID_DOC_HEAD;


  if (:is_storno_doc = 1) then begin
    /* annul storno doc */
    update DOC_HEAD$INT BD
    set    BD.IS_STORNED = 0
    where  BD.ID_DOC_HEAD = :id_base_doc
           and BD.IS_STORNED = 1;
  end
  /* RELEASE ACCOUNT_POSTS */
  if (:for_deposit = 0) then
    execute procedure ACCOUNT_POSTING_DOC_UPDATE$INT (:DH_DBKEY)
    returning_values (:no_use);

  /* PAYMENTS REFLECTION */
  for
    select PH.ID_PAYMENT_HEAD
    from   PAYMENT_HEAD PH
           join DOC_TYPE_PAY dt on dt.ID_DOC_TYPE = ph.ID_DOC_TYPE
    where  PH.ID_DOC_HEAD = :ID_DOC_HEAD
           and PH.IS_STORNED = 0
    into   :ID_PAYMENT_HEAD
  do begin

    execute procedure PAYMENT_ANUL$INT (:ID_PAYMENT_HEAD, :ANUL_REASON);
  end

  /* ANNUL_PROTOCOL creating section */
  NUM = null;
  DOC_NUM = null;
  if (:MAKE_ANNUL_REPORT = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_WITH_PROT');

    if (:ID_ANNUL_PROTOCOL_NUM is null) then exception DOCUMENT_ANNUL_EXCEPTION '-345';

    execute procedure SYSTEM_GEN_NUM ('ANNUL_PROT', :ID_ANNUL_PROTOCOL_NUM)
    returning_values  (:num, :doc_num);
  end
  /* log annul event */
  execute procedure SYSTEM_EVENT_LOG$INT ('DOCUMENT', :ID_DOC_HEAD, 'ANNUL', f_character(29)||:ANUL_REASON)
  returning_values  :id_system_log;

  insert into DOC_ANNULMENT (ID_DOC_HEAD, ANNULMENT_DATE, ID_PROT_DOC_NUM, PROT_NUM, PROT_DOC_NUM, ID_LOG_EVENT)
  values (:ID_DOC_HEAD, :SYSTEM_DATE, :ID_ANNUL_PROTOCOL_NUM, :NUM, :DOC_NUM, :ID_SYSTEM_LOG);
  /* reflect annul date on doc release dates */
  if (:DOC_DATE < :SYSTEM_DATE) then begin
    insert into DOC_RELEASE_DATE (ID_DOC_HEAD, RELEASE_DATE, VALUE_CORR_INDEX)
    values (:ID_DOC_HEAD, :SYSTEM_DATE, -1);
  end else begin
    update DOC_RELEASE_DATE RD
    set    RD.VALUE_CORR_INDEX = 0
    where  RD.ID_DOC_HEAD = :ID_DOC_HEAD
           and RD.RELEASE_DATE = :DOC_DATE;
  end
  /* reflect on AR module */
  execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT (:DH_DBKEY, :ANUL_REASON);
  /* reflect on client loyalty module */
  execute procedure DOCUMENT_BONUSPOINTS_VOID$CL (:ID_DOC_HEAD);

end
^

/* Restore proc. body: DOCUMENT_DELETE$DOC */
ALTER PROCEDURE DOCUMENT_DELETE$DOC(ID_DOC_HEAD INTEGER)
 AS
declare variable id_account_post integer;
  declare variable id_doc integer;
  declare variable doc_num varchar(20);
  declare variable doc_type_name varchar(50);
  declare variable doc_date date;
  declare variable action_text varchar(255);
  declare variable id_base_doc integer;
  declare variable id_doc_num integer;
  declare variable num_dbkey char(8);
  declare variable doc_dbkey char(8);
  declare variable last_num integer;
  declare variable num integer;
  declare variable id_doc_line integer;
  declare variable for_deposit smallint;
  declare variable is_anul smallint;
begin

  select DH.ID_BASE_DOC, dh.IS_ANUL
  from   DOC_HEAD$INT DH
  where  DH.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :id_base_doc, :is_anul;

  if (:id_base_doc is distinct from :ID_DOC_HEAD and :is_anul = 0) then
    exception DOCUMENT_EXCEPTION '-342'; /* base doc is not selected to delete */

  for
    select D.ID_DOC_NUM, D.ID_DOC_HEAD, D.DOC_NUM, D.NUM, D.DOC_TYPE_NAME, D.DOC_DATE, d.FOR_DEPOSIT, D.RDB$DB_KEY
    from   DOC_HEAD$INT D
    where  (D.ID_BASE_DOC = :ID_DOC_HEAD and :is_anul = 0)
           or (d.ID_DOC_HEAD = :ID_DOC_HEAD and :is_anul = 1)
    order by D.ID_DOC_NUM asc, D.ID_DOC_HEAD desc
    into   :id_doc_num, :id_doc, :doc_num, :num, :doc_type_name, :doc_date, :for_deposit, :doc_dbkey
  do begin
    if (:is_anul = 0) then begin
      for
        select PV.ID_ACCOUNT_POST
        from   DOC_LINE dl
               join DOC_LINE_POST_VALUES pv on PV.ID_DOC_LINE = dl.ID_DOC_LINE
        where  DL.ID_DOC_HEAD = :id_doc
        order by Dl.ID_DOC_LINE desc
        into   :id_account_post
      do begin
        update ACCOUNT_POST AP
        set    AP.IN_DOC_QTY = 0,
               AP.IN_DOC_VALUE = 0,
               AP.AC = iif(AP.QTY_POST = 0, '10', '00'),
               AP.IS_ANUL = iif(AP.QTY_POST = 0, 1, 0),
               AP.ID_BASE_DOC = null
        where  AP.ID_ACCOUNT_POST = :id_account_post
               and AP.ID_BASE_DOC = :ID_DOC_HEAD;
      end
    end
    /*   */
    action_text = f_character(29) || :doc_type_name || ' ' || :doc_num || '/' || formatdate(:doc_date, 'D;dd.mm.yyyy');
    execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :id_doc, 'DELETE', :action_text);

    if (:is_anul = 0 and exists (select p.ID_PAYMENT_HEAD
                                 from   PAYMENT_HEAD P
                                        join PAYMENT_TYPE pt on pt.ID_PAYMENT_TYPE = p.ID_PAYMENT_TYPE and pt.IS_AR_DEBT = 1
                                 where  p.ID_DOC_HEAD = :id_doc)) then begin
      /* Account recievables check*/
      update DOC_HEAD$INT DH
      set    dh.IS_ANUL = 1
      where  DH.RDB$DB_KEY = :doc_dbkey;
  
      execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT(:doc_dbkey);
    end

    if (:for_deposit = 1) then begin
      for
        select dl.ID_DOC_LINE
        from   DOC_LINE dl
        where  dl.ID_DOC_HEAD = :id_doc
        into   :id_doc_line
      do begin
        delete from DOC_LINE_DEP_VALUES dv
        where  dv.ID_DOC_LINE = :id_doc_line;
      end 
    end

    delete from PAYMENT_HEAD P
    where  P.ID_DOC_HEAD = :id_doc;

    delete from DOC_HEAD$INT dh
    where  dh.ID_DOC_HEAD = :id_doc;

    -- reset numerator if deleted document is the last
    select coalesce(max(d.NUM), 0)
    from   DOC_HEAD$INT D
    where  D.ID_DOC_NUM = :id_doc_num
    into   :last_num;

    if (:last_num < :num) then begin
      select SN.RDB$DB_KEY
      from   SYSTEM_NUMERATOR SN
      where  SN.ID_NUMERATOR = :id_doc_num
      into   :num_dbkey;
  
      execute procedure SYSTEM_GEN_NUM$INT (:num_dbkey, :last_num)
      returning_values  (:last_num);
    end

  end
end
^

/* Restore proc. body: DOCUMENT_PRENUMERATE$DOC */
ALTER PROCEDURE DOCUMENT_PRENUMERATE$DOC(SELECTION_ID INTEGER)
 AS
declare variable id_doc_num integer;
  declare variable last_num integer;
  declare variable old_doc_num varchar(20);
  declare variable doc_num varchar(20);
  declare variable tmp_id_doc integer;
  declare variable action_text varchar(255);
  declare variable num_dbkey char(8);
begin
  for
    select SN.ID_NUMERATOR, SN.RDB$DB_KEY, min(DH.NUM)
    from   DOC_HEAD DH
           join SYSTEM_NUMERATOR SN on SN.ID_NUMERATOR = DH.ID_DOC_NUM
    where  DH.SELECTION_ID = :SELECTION_ID
    group by SN.ID_NUMERATOR, SN.RDB$DB_KEY
    into   :id_doc_num, :num_dbkey, :last_num
  do begin
    execute procedure SYSTEM_GEN_NUM$INT (:num_dbkey, :last_num)
    returning_values  (:last_num);
    if (:last_num is null) then exception NUMERATOR_EXCEPTION 'Numerator is locked!';

    for
      select DH.DOC_NUM, DH.ID_DOC
      from   DOC_HEAD DH
      where  dh.ID_DOC_NUM = :id_doc_num
             and dh.NUM > :last_num
      order by DH.NUM asc
      into   :old_doc_num, :tmp_id_doc
    do begin
      execute procedure SYSTEM_GEN_NUM ('DOCUMENT', :id_doc_num)
      returning_values  (:last_num, :doc_num);

      update DOC_HEAD$INT D
      set    D.NUM = :last_num,
             D.DOC_NUM = :doc_num
      where  D.ID_DOC_HEAD = :tmp_id_doc;

      action_text = f_character(29)||:old_doc_num||f_character(28)||:doc_num;
      execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :tmp_id_doc, 'DOC_NUM_REGEN', :action_text);
    end
  end
end
^

/* Restore proc. body: DOCUMENT_STORNO$DOC */
ALTER PROCEDURE DOCUMENT_STORNO$DOC(ID_DOC_HEAD INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_STORNO_DOC INTEGER,
ID_HOTEL INTEGER,
ID_ACCOUNT INTEGER,
WARN_CODE INTEGER)
 AS
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_STORN_WITHP');

  execute procedure DOCUMENT_STORNO$INT (:ID_DOC_HEAD, :DESCRIPTION, 1)
  returning_values  (:ID_STORNO_DOC, :ID_HOTEL, :WARN_CODE);

  select D.ID_ACCOUNT
  from   DOC_HEAD D
  where  D.ID_DOC = :id_storno_doc
  into   :id_account;

  execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :ID_DOC_HEAD, 'STORNO', f_character(29)||:DESCRIPTION);

end
^

/* Restore proc. body: DOCUMENT_VALIDATE$DOC */
ALTER PROCEDURE DOCUMENT_VALIDATE$DOC(ID_DOC_HEAD TYPE OF ID_REF)
 RETURNS(FIRM_DATA TYPE OF TNOTE_BLOB,
WARN_CODE TYPE OF TRANGE,
NEW_DOC_DATE TYPE OF TDATE)
 AS
declare variable no_use varchar(255);
  declare variable doc_value numeric(15,4);
  declare variable rest_value numeric(15,4);
  declare variable lines_value numeric(15,4);
  declare variable lines_wot_vat numeric(15,4);
  declare variable tax_value numeric(15,4);
  declare variable taxable_value numeric(15,4);
  declare variable round_to numeric(15,4);
  declare variable id_doc_contragent integer;
  declare variable id_doc_supplier integer;
  declare variable for_deposit integer;
  declare variable id_profile integer;
  declare variable dbkey char(8);
  declare variable id_contragent integer;
  declare variable ident_no varchar(30) ;
  declare variable action_text varchar(255);
  declare variable doc_currency varchar(3);
  declare variable is_juridical_person smallint;
  declare variable vat_ident_no varchar(30);
  declare variable id_doc_type integer;
  declare variable doc_sub_type integer;
  declare variable required_ident_no smallint;
  declare variable required_vat_no smallint;
  declare variable required_egn smallint;
  declare variable required_recipient_name smallint;
  declare variable lines_count integer;
  declare variable recipient_name varchar(100);
  declare variable id_doc_completed integer;
  declare variable action_code varchar(50);
begin

  select D.RDB$DB_KEY, D.DOC_VALUE_A, C.ROUND_TO,
         D.ID_DOC_CONTRAGENT, D.ID_DOC_SUPPLIER, D.FOR_DEPOSIT,
         A.ID_PROFILE, D.DOC_CURRENCY, D.TAXABLE_VALUE, d.ID_DOC_TYPE, d.DOC_SUB_TYPE,
         dc.ID_DOC_HEAD, ds.FIRM_DATA
  from   DOC_HEAD$INT D
         join CURRS C on C.CURR = D.DOC_CURRENCY
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         left outer join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
         left outer join DOC_SUPPLIER ds on ds.ID_DOC_SUPPLIER = d.ID_DOC_SUPPLIER
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :dbkey, :doc_value, :round_to,
         :id_doc_contragent, :id_doc_supplier, :for_deposit,
         :id_profile, :doc_currency, :taxable_value, :id_doc_type, :doc_sub_type,
         :id_doc_completed, :FIRM_DATA;

  if (:id_doc_contragent is null) then
    exception DOCUMENT_EXCEPTION '-356'; --'Contragent is not set!';

  if (:id_doc_supplier is null) then
    exception DOCUMENT_EXCEPTION '-357'; --'Supplier is not set!';

  select sum(DT.TAX_VALUE)
  from   DOC_TAXES DT
  where  DT.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :tax_value;

  /*if (round_f(:doc_value - :total_value, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Total value is not correct!';
  */
  select round_f(sum(DL.SINGLE_VALUE * DL.QTY_POST), :round_to),
         round_f(sum(DL.WOT_VAT), :round_to),
         count(*)
  from   DOC_LINE DL
  where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :lines_value, :lines_wot_vat, :lines_count;
 
  if (:lines_count = 0) then
    exception INTERNAL_DOC_EXCEPTION 'Document is empty! Not exists sale lines!';

  if (round_f(:doc_value - :lines_value, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines total value is not correct!' || :doc_value ||  ' / ' || :lines_value || ' ; '|| (:doc_value - :tax_value) ||  ' / ' || :lines_wot_vat;

  if (round_f(:doc_value - :tax_value - :lines_wot_vat, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines wot tax value is not correct!';

  if (round_f(abs(:lines_wot_vat) - abs(:taxable_value), :round_to) < 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines wot tax value is less than total taxable value!';

  if (:id_doc_completed is not null) then begin
    select DV.PAYABLE_VALUE
    from   DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, null) DV
    into   :rest_value;
  
    if (round_f(:rest_value, :round_to) <> 0) then
      exception DOCUMENT_EXCEPTION '-371'; --'Insufficient amount of payments !';
  end

  /* Validate contragent data */
  select dt.REQUIRED_IDENT_NO, dt.REQUIRED_VAT_NO, dt.REQUIRED_EGN, dt.REQUIRED_RECIPIENT_NAME
  from   DOC_TYPE_INV DT
  where  dt.ID_DOC_TYPE = :id_doc_type
  into   :required_ident_no, :required_vat_no, :required_egn, :required_recipient_name;

  select dc.ID_CONTRAGENT, dc.IS_JURIDICAL_PERSON,
         trim(coalesce(dc.IDENT_NO, '')), trim(coalesce(dc.VAT_REG_NUM, '')),
         trim(coalesce(dc.RECIPIENT_NAME, ''))
  from   DOC_CONTRAGENT dc
  where  dc.ID_DOC_CONTRAGENT = :id_doc_contragent
  into   :id_contragent, :is_juridical_person, :ident_no, :vat_ident_no, :recipient_name;

  if (:doc_sub_type = 0 and :required_ident_no = 1 and :is_juridical_person = 1 and :ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-324'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_egn = 1 and :is_juridical_person = 0 and :ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-324'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_vat_no = 1 and :is_juridical_person = 1 and :vat_ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-326'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_recipient_name = 1 and :recipient_name = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-327'; --'Recipient_name is empty.';
  /*if (:post_address = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-325'; --'Contragent address is empty.';
  /* save contragent link for profile */
  if (:id_contragent is not null) then begin
    update PROFILE P
    set    P.ID_DEF_CONTRAGENT = :id_contragent
    where  P.ID_PROFILE = :id_profile
           and P.ID_DEF_CONTRAGENT is null;
  end

  /*  */
  execute procedure DOC_CHECK_FISCAL$INT(:dbkey);
  /*  */
  execute procedure DOCUMENT_SET_NUMBER$INT (:dbkey)
  returning_values (:no_use, :no_use);
  /*  */
  if (:id_doc_completed is not null) then begin
    if (:for_deposit = 0) then begin
      /* update account posts */
      execute procedure ACCOUNT_POSTING_DOC_UPDATE$INT (:dbkey)
      returning_values :WARN_CODE;
    end

    execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT (:dbkey);
    /* ... */
    execute procedure DOCUMENT_BONUSPOINTS_APPLY$CL (:ID_DOC_HEAD);
    /* ... */
  end
  /*  */
  action_text = f_character(29) || formatfloat(:doc_value, 'F;0.00') || ' ' || :doc_currency;
  action_code = iif(:id_doc_completed is null,  'PROFORMA_CREATE', 'CREATE');
  execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :ID_DOC_HEAD, :action_code, :action_text);

  select cast('31.12.1899' as date) + count(d.ID_DOC_HEAD)
  from   DOC_HEAD$INT d
  where  d.DOC_DATE is not null
  into   :NEW_DOC_DATE;

end
^

/* Restore proc. body: EAI_AIRCONDITION_SMARTSTART */
ALTER PROCEDURE EAI_AIRCONDITION_SMARTSTART AS
declare variable id_reserv_detail integer;
begin
  for
    select RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.FROM_DATE = current_date
           and RD.IS_ANUL = 0
           and RD.CHECK_STATUS < 0
           and RD.ID_ROOM > 0
    into   :id_reserv_detail
  do begin
    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'AC.SMARTSTART', '');
  end
end
^

/* Restore proc. body: EAI_EVENTQ_ADD */
ALTER PROCEDURE EAI_EVENTQ_ADD(EAI_IFC VARCHAR(50),
EVENT_CODE VARCHAR(50),
OBJECT_ID INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_first_pushedback integer;
  declare variable m_dbkey char(8);
begin

  execute procedure SYSTEM_LOG_ADD ('EAI_EVENTQ', :object_id, :event_code, :eai_ifc);
end
^

/* Restore proc. body: EAI_EXT_POST_TO_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable ID_HOTEL integer;
begin
  if (singular(select HS.ID_HOTEL
               from HOTEL_S HS
               where HS.IS_USE = 1)) then
    select H.ID_HOTEL
    from   HOTEL_S H
    where H.IS_USE = 1
    into   :id_hotel;
  else begin
    err_code = -1044;
    exit;
  end

  execute procedure EAI_EXT_POST_TO_MH_FRONT_ONLINE(:ID_HOTEL, :ROOM_NAME,
    :SERVICE_CODE, :CODE_TYPE, :QTY_POST, :PRICE_POST, :CURR_POST, :POST_TEXT)
  returning_values (:ERR_CODE, :ERR_TEXT, :ID_ROOM, :ID_GUEST, :GUEST_NAME1,
    :ID_ACCOUNT, :ID_ACCOUNT_POST, :ID_SERVICE);

end
^

/* Restore proc. body: EAI_POS_POSTING_ADD */
ALTER PROCEDURE EAI_POS_POSTING_ADD(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
begin
  -- used external inteface - for compatability with Front 2008
  execute procedure EAI_POS_POSTING_ADD$P2E (:IN_ON_GUEST, :IN_ID_ACCOUNT, :IN_ID_GUEST, :IN_DATE_SMETKA,
          :IN_PRICE, :IN_DATETIME, :IN_OBJ_NAME, :IN_TABLE, :IN_SITE, :IN_SMETKA_NUM, :IN_POS_USER,
          :IN_ID_SMETKA, :IN_SERVICE_TAG, :IN_SERVICE_NAME)
  returning_values (:ERR_CODE, :ERR_TEXT, :OUT_ID_ACCOUNT);

end
^

/* Restore proc. body: END_WORK */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable system_date date;
  declare variable id_end_work integer;
  declare variable last_closed_date date;
  declare variable lock_id integer;
  declare variable dbkey char(8);
begin
  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date >= :in_next_date) then exception END_WORK_EXCEPTION '-43';
  if (:IN_NEXT_DATE > current_date + 1) then exception END_WORK_EXCEPTION '-60';

  last_closed_date = :in_next_date - 1;

  /* LOCK THE CURRENT FINANCIAL (SYSTEM) DATE  */
  lock_id = null;
  while (:lock_id is null) do begin
    lock_id = strhash_large(:system_date || :id_hotel);
    execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'lock');
  
    when any do begin
      exception END_WORK_EXCEPTION '-337' || f_character(31) || f_character(29) || FormatDate(:system_date, 'D;dd.mm.yyyy');
    end
  end

  /* RIGHT IS REQUIRED TO CHANGE THE FINANCIAL DATE IF THERE ARE GUESTS WITH OVERDUE CHECK OUT */
  if (exists(
    select *
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
    where  G.TO_DATE <= :last_closed_date
           and G.CHECK_STATUS < 1
           and RD.ID_HOTEL = :id_hotel
           and rd.IS_ANUL = 0
  )) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('EW_OVERDUE_CHECKOUT');
  end

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', 'EW');
  -- Suppress eventual right checks into next procedures - all is permitted. Is this needed(?!?)

  for
    select p.RDB$DB_KEY
    from   ACCOUNT_POST p
           join ACCOUNT a on a.ID_ACCOUNT = p.ID_ACCOUNT
    where  p.DATE_POST between :system_date and :last_closed_date
           and p.ID_GUEST > 0
           and a.ID_HOTEL = :ID_HOTEL
    into   :dbkey
  do begin
    update ACCOUNT_POST AP
    set    ap.ROOM_NAME = (select R.ROOM_NAME
                           from   GUEST G
                                  join ROOMS R on R.ID_ROOM = G.ID_ROOM
                           where  G.ID_GUEST = ap.ID_GUEST)
    where  ap.RDB$DB_KEY = :dbkey;
  end

  /* CHANGE SYSTEM DATE */
  execute procedure SYSTEM_DATE_SET(:id_hotel, :system_date, :in_next_date)
  returning_values :id_end_work;

  /* AUTO EXPIRATION OF ROOM NUMBERS, ROOMS AND BOOKING POSITIONS */
  execute procedure RESERVS_EXPIRE$INT(:last_closed_date, :id_hotel);

  execute procedure AGENT_CONTINGENT_EXPIRE(:system_date, :last_closed_date, null, 0, 1, :id_hotel);

  /* DELETE PERSON PROFILES WITH EXPIRATION DATE */
  execute procedure PROFILE_PERSON_EXPIRE (:in_next_date);

  execute procedure HOUSEKEEPING_MARK_ROOMS$EW(:id_end_work);

  /* Summary statistic */
  if (:in_next_date > :system_date) then begin
    execute procedure SUMMARY_FINANCE_STATISTIC$EW(:id_end_work);

    execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:ID_HOTEL, :system_date, :last_closed_date);

    execute procedure SUMMARY_STATISTIC_REBUILD$EW(:ID_HOTEL);

    execute procedure SUMMARY_FORECAST$INT(:ID_HOTEL, :system_date);
  end

  /* Delete pseudo-temporal tables */
  delete from RESERV_ERROR;
  /*  */

--  execute procedure CACHES_RESOLVE;

  execute procedure SYSTEM_LOG_ADD('SYSTEM', :id_end_work, 'DAY_EW', f_character(29) || :system_date || f_character(28) || :IN_NEXT_DATE);

  execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'release');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', null);

  execute procedure SYSTEM_CACHE_APPLY('end_work');
end
^

/* Restore proc. body: FISCALIZE_MARK_DOC$FISC */
ALTER PROCEDURE FISCALIZE_MARK_DOC$FISC(ID_DOC_HEAD INTEGER,
IS_MANUAL INTEGER)
 AS
declare variable fisc_status integer;
begin
  fisc_status = null;
  select DH.FISC_STATUS
  from   DOC_HEAD DH
  where  DH.ID_DOC = :id_doc_head
  into   :fisc_status;
  if (:fisc_status is null) then begin
    exception INTERNAL_DOC_EXCEPTION 'The document does not exists! id='||:id_doc_head;
  end else if (:fisc_status = 0) then begin
    exit;
  end else if (:fisc_status = 2) then begin
    exception INTERNAL_DOC_EXCEPTION 'The document is already fiscalized. id='||:id_doc_head;
  end

  update DOC_COMPLETION Dc
  set    Dc.FISC_STATUS = 2,
         dc.DATETIME_FISCALIZED = current_timestamp
  where  Dc.ID_DOC_HEAD = :id_doc_head;

  execute procedure SYSTEM_LOG_ADD('DOCUMENT', :ID_DOC_HEAD, 'FISCALIZE', '');
end
^

/* Restore proc. body: GUEST_ADDRESSCARD_SET$RSV */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$RSV(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
EGN VARCHAR(30),
COUNTRY VARCHAR(10),
ID_STAY_REASON INTEGER,
IS_REGISTRED INTEGER,
PASS_PLACE VARCHAR(20),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_PLACE VARCHAR(30),
SEX CHAR,
MASK VARCHAR(10),
IS_CHILD INTEGER,
CAR VARCHAR(30),
KPP INTEGER,
KPP_DATE DATE,
PASS_EXP_DATE DATE,
AGE INTEGER,
BIRTH_DAY DATE,
VISA TDESCRIPTION_SHORT,
RATING_AGE INTEGER = null,
TITLE VARCHAR(10) = null,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable gd_dbkey char(8);
  declare variable pd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable rd_dbkey char(8);
  declare variable old_is_registred integer;
  declare variable old_guest_name1 varchar(250);
  declare variable old_guest_name2 varchar(250);
  declare variable old_id_pass_type integer;
  declare variable old_pass_num varchar(20);
  declare variable old_pass_date date;
  declare variable old_egn varchar(30);
  declare variable old_country varchar(20);
  declare variable old_id_stay_reason integer;
  declare variable old_kpp integer;
  declare variable old_kpp_date date;
  declare variable old_pass_exp_date date;
  declare variable old_birth_day date;
  declare variable old_pass_place varchar(20);
  declare variable old_city varchar(100);
  declare variable old_address varchar(100);
  declare variable old_visa TDESCRIPTION_SHORT;
  declare variable old_birth_place varchar(30);
  declare variable old_sex char(1);
  declare variable action_text varchar(250);
  declare variable tt_reg_number integer;
  declare variable id_hotel integer;
  declare variable id_tt_numerator integer;
  declare variable domestic_nation varchar(10);
  declare variable no_use varchar(255);
  declare variable is_anul smallint;
  declare variable acc_routing varchar(20);
begin
  err_code = 0;
  err_text = '';

  select G.RDB$DB_KEY, GD.RDB$DB_KEY, PD.RDB$DB_KEY,
         GD.IS_REGISTRED, PD.PERSON_NAME, PD.PERSON_NAME2, PD.ID_PASSPORT_TYPE, PD.PASS_NUM, PD.PASS_DATE,
         PD.EGN, PD.COUNTRY_CODE, GD.ID_STAY_REASON, GD.KPP, GD.KPP_DATE, PD.PASS_EXP_DATE,
         PD.BIRTH_DAY, PD.PASS_PLACE, PD.CITY, PD.ADDRESS, PD.BIRTH_PLACE, PD.SEX, rd.RDB$DB_KEY,
         g.TT_REG_NUMBER, rd.ID_HOTEL, rd.IS_ANUL, rd.ACC_ROUTING, GD.VISA
  from   GUEST G
         join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
         join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
         join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
  where  G.ID_GUEST = :id_guest
  into   :g_dbkey, :gd_dbkey, :pd_dbkey,
         :old_is_registred, :old_guest_name1, :old_guest_name2, :old_id_pass_type, :old_pass_num, :old_pass_date,
         :old_egn, :old_country, :old_id_stay_reason, :old_kpp, :old_kpp_date, :old_pass_exp_date,
         :old_birth_day, :old_pass_place, :old_city, :old_address, :old_birth_place, :old_sex, :rd_dbkey,
         :tt_reg_number, :id_hotel, :is_anul, :acc_routing, :old_visa;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, :birth_place, :egn, :id_passport_type, :pass_num, :pass_date, :pass_place,
          :pass_exp_date, :city, :address, :sex, :mask);

  update  GUEST_DATA GD
  set     GD.KPP_DATE = :kpp_date,
          GD.KPP = :kpp,
          GD.VISA = :visa,
          GD.ID_STAY_REASON = :id_stay_reason,
          GD.IS_REGISTRED = :is_registred,
          GD.USER_REGISTRED = iif(:IS_REGISTRED = 1, coalesce(GD.USER_REGISTRED, current_user), null),
          GD.CAR = :car,
          GD.RATING_AGE = :RATING_AGE
  where   GD.RDB$DB_KEY = :gd_dbkey;

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name1, :guest_name2, :country,
          :is_child, :age, :birth_day, :TITLE);

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -1);

  /*  */
  if (:IS_REGISTRED = 1 and :tt_reg_number is null and :is_anul = 0 and :acc_routing is distinct from 'OWNER') then begin
    execute procedure SETTING_GET_VALUE ('NATIVE_NATION', :id_hotel)
    returning_values :domestic_nation;

    select iif(:COUNTRY not in (:domestic_nation, '') and h.USE_DIFFERENT_TT_NUMERATORS = 1,
               h.ID_TT_NUMERATOR_2,
               h.ID_TT_NUMERATOR_1)
    from   HOTEL H
    where  h.ID_HOTEL = :id_hotel
    into   :id_tt_numerator;

    if (:id_tt_numerator is not null) then begin
      execute procedure SYSTEM_GEN_NUM('GUEST_NUM', :id_tt_numerator)
      returning_values :tt_reg_number, :no_use;
  
      update GUEST G
      set    g.TT_REG_NUMBER = :tt_reg_number
      where  G.RDB$DB_KEY = :g_dbkey;
    end
  end else if (:IS_REGISTRED is distinct from 1 and :tt_reg_number is not null) then begin
    update GUEST G
    set    g.TT_REG_NUMBER = null
    where  G.RDB$DB_KEY = :g_dbkey;
  end
  /*  */
  if ((:old_is_registred = 0) and (:is_registred = 1)) then begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'REGISTRED', '');
  end

  if ((:old_is_registred = 1) and (:old_guest_name1 <> :guest_name1)) then begin
    action_text = f_character(29)||:old_guest_name1||f_character(28)||:guest_name1;
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'CHANGE_CARD', :action_text);
  end

  if ((:old_IS_REGISTRED = 1)
      and
      ((:old_guest_name1 <> :guest_name1)
        or (:old_guest_name2 <> :guest_name2)
        or (:old_egn <> :egn)
        or (:old_id_pass_type <> :id_passport_type)
        or (:old_pass_num <> :pass_num)
        or (:old_pass_date <> :pass_date)
        or (:old_pass_exp_date <> :pass_exp_date)
        or (:old_pass_place <> :pass_place)
        or (:old_country <> :country)
        or (:old_city <> :city)
        or (:old_address <> :address)
        or (:old_visa <> :visa)
        or (:old_birth_day <> :birth_day)
        or (:old_birth_place <> :birth_place)
        or (:old_sex  <> :sex)
        or (:old_kpp <> :kpp)
        or (coalesce(:old_id_stay_reason,0) <> coalesce(:id_stay_reason,0))
        or (:old_kpp_date <> :kpp_date)
      )) then
  begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'PREREGISTRED', '');
  end

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
    returning_values  :warn_code;

  end

end
^

/* Restore proc. body: HOTEL_AUTO_IMPORT$WBE */
ALTER PROCEDURE HOTEL_AUTO_IMPORT$WBE(NAME VARCHAR(50),
UUID VARCHAR(40))
 RETURNS(ID_HOTEL INTEGER)
 AS
declare variable tmp_id integer;
declare variable nation_curr tcurrency;
declare variable id_sale_tax integer;
declare variable id_sale_taxation integer;
declare variable id_tax_policy integer;
declare variable id_acc_template integer;
begin
  select id_hotel
  from   hotel
  where  uuid = :uuid
         and subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  into   :id_hotel;

  execute procedure sys_dbg('wbe HOTEL_AUTO_IMPORT$WBE('
  || 'name => ' || coalesce(:name, '<null>')
  || ', uuid => ' || coalesce(:uuid, '<null>')
  ||') => {:id_hotel => ' || coalesce(:id_hotel, '<null>')
  || '}');

  if (:id_hotel is null) then begin
    execute procedure PICTURE_MODIFY (null, null, 'ptEmpty', 'plAsIs', 'add')
    returning_values :tmp_id;

    nation_curr = 'BGN';

    execute procedure HOTEL_MODIFY$CFG(null, :uuid, 1, null, null, null, null, :tmp_id, null, null, null, null, null, null, 'add', :nation_curr, null)
    returning_values  :id_hotel;

    update hotel
    set    uuid=:uuid
    where  id_hotel=:id_hotel;

    execute procedure SALE_TAX_MODIFY$CFG(null, 'WBE default', 0, 0, null, 0, 0, 'A', null, 'add', :id_hotel, '')
    returning_values :id_sale_tax;

    execute procedure SALE_TAXATION_MODIFY$CFG(null, 'WBE default',
            :id_sale_tax, null, 'add', :id_hotel)
    returning_values :id_sale_taxation;

    execute procedure TAX_POLICY_MODIFY$CFG(null, 'WBE default', 0, 'add', :id_hotel)
    returning_values :id_tax_policy;

    execute procedure SETTINGS_MODIFY_VALUE ('DEF_SERVICE_TAXATION', :id_sale_taxation, :id_hotel);

    execute procedure ACCOUNT_MODIFY_TEMPLATE$PROFILE(null,
        :ID_HOTEL || ' - WBE default', 0, null, 0, 1, :id_tax_policy, 0, 'add', :id_hotel)
    returning_values :id_acc_template;

    execute procedure SETTINGS_MODIFY_VALUE ('DEF_ACC_TEMPLATE', :id_acc_template, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('DEF_OWNER_ACC_TEMPLATE', :id_acc_template, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('NATIVE_NATION', 'BG', :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('DEF_COUNTRY', 'BG', :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('ROOMTYPE_ON_CHANGE_ROOM', 'ASK', :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('ROOMS_PREFERD_SORT_ORDER', 2, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('GUEST_POSTING_RATE', 'OCCUR_DATE', :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('MARK_DIRTY_EXPIRED_BLOCK', 0, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('MARK_DIRTY_OCC_ROOM', 0, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('DAY_KEEP_TYPES', 1, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('DAY_KEEP_NUMBERS', 0, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('CLEANING_RESTRICTION', 0, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('DEF_GUEST_MASK', '', :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('DEFAULT_DEPOSIT_DESCRIPTION', 'Booking deposit', :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('REPORT_LEAVING', 'AS_LEAVING', :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('CHECK_OVERBOOK', 1, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('RESTRICT_VATS_IN_DOC', 1, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('NEGATIVE_POSTINGS', 0, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('REVENUE_ACCOUNT_METHOD', 0, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('ACCOUNT_TO_DOC_RATE', 'CURRENT_RATE', :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('CHILDREN_MAX_AGE', 18, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('FEMALE_2ND_GROUP_MIN_AGE', 55, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('MALE_2ND_GROUP_MIN_AGE', 60, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('MARKETING_SEGMENT_REQUIRED', 0, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('VIEW_STORNO_SUMS_IN_DOCUMENTS', 'AS_POSITIVE', :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('STORNO_PAYMENTS_RESTRICT', 1, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('CHECK_OUT_HOUR', 12, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('CHECK_IN_HOUR', 14, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('SEPARATE_ACCOUNTS_PER_PAYER', 0, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('IFC_USE_FOLIO_NO', 1, :id_hotel);
    
    execute procedure SETTINGS_MODIFY_VALUE ('IFC_AUTO_ATTACH_FOLIO_NUM', 0, :id_hotel);

    execute procedure SETTINGS_MODIFY_VALUE ('ACTIVITY_OFFER_COPY', 0, :id_hotel);

  end
end
^

/* Restore proc. body: IMPORT_RATE_RECORD_RELINK$EXC */
ALTER PROCEDURE IMPORT_RATE_RECORD_RELINK$EXC(ID_RATE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ID_COLUMN integer;
declare variable ID_NEW_MASTER_RECORD integer;

declare variable PERIOD_DEPEND_ON_CHECKIN INTEGER;
declare variable CNT_DAYS_PRICE_BP INTEGER;
declare variable CNT_DAYS_PRICE_BOARD INTEGER;
declare variable BASE_BOARDS_LIST VARCHAR(255);
declare variable BOARD_TYPE VARCHAR(10);
begin
  execute procedure import_mark_transaction$exc;

  ERR_CODE = 0;
  ERR_TEXT = '';
  for
    select c.ID_TAR_DEFINE_COLUMN, im.ID_NEW
    from   TAR_UI_DEFINE_COLUMNS c
           join IDS_MAP$TMP im on c.ID_DIM2 = im.ID_OLD
    where  c.ID_TAR_HEAD = :ID_RATE
    into   :ID_COLUMN, :ID_NEW_MASTER_RECORD
  do begin
    update TAR_UI_DEFINE_COLUMNS c
    set    c.ID_DIM2 = :ID_NEW_MASTER_RECORD
    where  c.ID_TAR_DEFINE_COLUMN = :ID_COLUMN;
  end

  delete from IDS_MAP$TMP;


  select
        th.PERIOD_DEPEND_ON_CHECKIN,
        th.CNT_DAYS_PRICE_BP,
        th.CNT_DAYS_PRICE_BOARD,
        th.BASE_BOARDS_LIST,
        th.BOARD_TYPE
  from  TAR_HEAD th
  where th.ID_TAR_HEAD = :ID_RATE
  into  :PERIOD_DEPEND_ON_CHECKIN, :CNT_DAYS_PRICE_BP, :CNT_DAYS_PRICE_BOARD, :BASE_BOARDS_LIST, :BOARD_TYPE;

  for
    select ERR_CODE, ERR_TEXT
    from   TAR_SAVE(:ID_RATE, :PERIOD_DEPEND_ON_CHECKIN, :CNT_DAYS_PRICE_BP, :CNT_DAYS_PRICE_BOARD, :BASE_BOARDS_LIST, :BOARD_TYPE)
    into   :err_code, :err_text
  do begin
    if (0 <> :err_code) then begin
      exit;
    end
  end
end
^

/* Restore proc. body: OCCUPANCY_SUMMARY_REMAKE$SYS */
ALTER PROCEDURE OCCUPANCY_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
begin
  if (not exists (select h.ID_HOTEL
                  from   HOTEL H
                  where  h.ID_HOTEL = :ID_HOTEL)) then exception WRONG_VALUE 'Non-existing hotel!';

  select mindate(sd.SYSTEM_DATE - 1, :TO_DATE)
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :TO_DATE;

  if (:FROM_DATE > :TO_DATE) then exit;

  execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:id_hotel, :FROM_DATE, :TO_DATE);

  execute procedure SYSTEM_LOG_ADD ('HOTEL', :id_hotel, 'OCCUPANCY_REGENERATE',
                                    f_character(29) || formatdate(:from_date, 'D;dd/mm/yyyy') || f_character(28) || formatdate(:to_date, 'D;dd/mm/yyyy'));
end
^

/* Restore proc. body: PAYMENT_ANUL$INT */
ALTER PROCEDURE PAYMENT_ANUL$INT(ID_PAYMENT_HEAD INTEGER,
ANUL_REASON VARCHAR(100))
 AS
declare variable p_dbkey char(8);
  declare variable id_ar_payment integer;
  declare variable id_payment_storned integer;
  declare variable payment_amount numeric(15,4);
  declare variable pay_currency varchar(3);
  declare variable system_date date;
  declare variable id_hotel integer;
  declare variable id_system_log integer;
  declare variable id_deposit integer;
  declare variable is_posting_stopped integer;
  declare variable round_to numeric(15,4);
begin 
  execute procedure PAYMENT_VOID_CHECK$INT (:ID_PAYMENT_HEAD, :ANUL_REASON);

  select P.RDB$DB_KEY, p.ID_PAYMENT_STORNED, P.PAY_VALUE_A, P.PAY_CURRENCY,
         P.ID_AR_PAYMENT, a.ID_HOTEL, p.ID_DEPOSIT, c.ROUND_TO
  from   PAYMENT_HEAD P
         join ACCOUNT A on A.ID_ACCOUNT = p.ID_ACCOUNT
         join CURRS c on c.CURR = p.PAY_CURRENCY
  where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  into   :p_dbkey, :id_payment_storned, :payment_amount, :pay_currency,
         :id_ar_payment, :id_hotel, :id_deposit, :round_to;

  if (:id_ar_payment is not null) then
    exception PAYMENT_ANNUL_EXCEPTION '-353';
    --'Payment is created from AR module.';

  if (:id_deposit is not null) then begin
    select r.IS_POSTING_STOPPED
    from   DEPOSIT d
           join RESERV_DETAIL r on r.ID_RESERV_DETAIL = d.ID_RESERV_DETAIL
    where  d.ID_DEPOSIT = :id_deposit
    into   :is_posting_stopped;

    if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';
  end

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :system_date;

  insert into ACCOUNT_PAYMENTS (ID_ACCOUNT, ID_PAYMENT_HEAD, PAY_AMOUNT, PAY_RATE,
         ACC_AMOUNT, ACC_RATE, TRANSACTION_DATE, ID_DEPOSIT)
  select AP.ID_ACCOUNT, AP.ID_PAYMENT_HEAD, -sum(AP.PAY_AMOUNT), AP.PAY_RATE,
         -sum(AP.ACC_AMOUNT), AP.ACC_RATE, :system_date, AP.ID_DEPOSIT
  from   ACCOUNT_PAYMENTS AP
  where  AP.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD
  group by AP.ID_ACCOUNT, AP.ID_PAYMENT_HEAD, AP.PAY_RATE, AP.ACC_RATE, AP.ID_DEPOSIT
  having round_f(sum(AP.PAY_AMOUNT), :round_to) <> 0;
                            
  if (:id_payment_storned is not null) then begin
    update PAYMENT_HEAD SP
    set    sp.IS_STORNED = 0
    where  sp.ID_PAYMENT_HEAD = :id_payment_storned;
  end

  execute procedure SYSTEM_EVENT_LOG$INT ('PAYMENT', :ID_PAYMENT_HEAD, 'ANNUL', f_character(29) || formatfloat(:payment_amount, 'F;0.00') || ' ' || :pay_currency || f_character(28) || :ANUL_REASON)
  returning_values  :id_system_log;

  update PAYMENT_HEAD PA
  set    PA.IS_ANUL = 1,
         pa.ANNUL_DATE = :system_date,
         pa.ID_LOG_EVENT_ANNUL = :id_system_log
  where  PA.RDB$DB_KEY = :p_dbkey;

end
^

/* Restore proc. body: PERSON_DATA_SET$INT */
ALTER PROCEDURE PERSON_DATA_SET$INT(P_DBKEY CHAR(8),
PD_DBKEY CHAR(8),
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
COUNTRY VARCHAR(10),
BIRTH_DAY DATE,
BIRTHDAY_INTERNAL DATE,
TITLE VARCHAR(10) = null)
 AS
declare variable id_profile integer;
  declare variable id_guest integer;
  declare variable old_name varchar(100);
  declare variable old_country varchar(10);
  declare variable country_name varchar(50);
  declare variable action_text varchar(255);
  declare variable age integer;
  declare variable old_birthday date;
  declare variable id_person_data integer;
begin

  select coalesce(:country, PD.COUNTRY_CODE), PD.BIRTH_DAY, PD.PERSON_NAME, PD.COUNTRY_CODE, pd.ID_PERSON_DATA
  from   PERSON_DATA PD
  where  PD.RDB$DB_KEY = :pd_dbkey
  into   :country, :old_birthday, :old_name, :old_country, :id_person_data;

  update  PERSON_DATA PD
  set     PD.PERSON_NAME = :GUEST_NAME1,
          PD.PERSON_NAME2 = coalesce(:guest_name2, iif(PD.PERSON_NAME = PD.PERSON_NAME2, :guest_name1, PD.PERSON_NAME2)),
          PD.COUNTRY_CODE = :country,
          PD.BIRTH_DAY = coalesce(:birthday_internal, :birth_day), -- this is relative date, calculated by input age or equal to real birth day (if exists)
          PD.BIRTHDAY_INTERNAL = :birthday_internal, -- this is real person birth day (can be null)
          PD.TITLE = :TITLE
  where   PD.RDB$DB_KEY = :pd_dbkey;

  if ((:old_name is distinct from :GUEST_NAME1)
      or (:OLD_BIRTHDAY is distinct from :birth_day)
      or (:old_country is distinct from :COUNTRY)) then
  begin
    -- update all related checked in and not checked out guest's cards
    for
      select GD.ID_GUEST
      from   GUEST_DATA GD
             join GUEST G on g.ID_GUEST = gd.ID_GUEST
      where  GD.ID_PERSON_DATA = :id_person_data
             and g.ID_RESERV_DETAIL is not null
             and g.IS_CHECK_IN = 1
             and g.IS_CHECK_OUT = 0
      into   :id_guest
    do begin
      select C.COUNTRY_NAME
      from   COUNTRY C
      where  C.COUNTRY_CODE = :COUNTRY
      into   :country_name;
  
      select CA.AGE_INYEARS
      from   SYSTEM_CALC_AGE_INYEARS (:birth_day, current_timestamp) CA
      into   :age;
  
      action_text = f_character(29) || '"' || :guest_name1 || '", ' || coalesce(:age, '') || ', ' || coalesce(:country_name, '');
      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'GUEST_IDENT_CHNG', :action_text);
    end
  end

  if (ascii_val(nullif(trim(:TITLE), '')) > 64) then  -- starting with letter strings only
    execute procedure LIST_ITEM_MODIFY('person_title', null, :TITLE, 'add');

  if (:p_dbkey is not null) then begin
    update PROFILE P
    set    P.PROFILE_NAME = :guest_name1
    where  P.RDB$DB_KEY = :p_dbkey
    returning new.id_profile
    into   :id_profile;

    -- force reserv changes tracking!
    update RESERV_DETAIL rd
    set    rd.ID_PERSON_PROFILE = :id_profile
    where  rd.ID_PERSON_PROFILE = :id_profile;
  end
end
^

/* Restore proc. body: PHONE_LINE_CONVERT_MODIFY$CFG */
ALTER PROCEDURE PHONE_LINE_CONVERT_MODIFY$CFG(ID INTEGER,
LINE VARCHAR(30),
ROOM_NAME VARCHAR(30),
IS_TAXABLE SMALLINT,
IS_ARCHIVE SMALLINT,
PRICE_INDEX NUMERIC(15,4),
ID_HOTEL INTEGER,
ID_ACCOUNT INTEGER,
OPERATION VARCHAR(10))
 RETURNS(NEW_ID INTEGER)
 AS
declare variable action_text varchar(255);
declare variable account_name varchar(50);
declare variable hotel_name varchar(50);
declare variable old_line varchar(30);
declare variable old_room_name varchar(30);
declare variable old_is_taxable smallint;
declare variable old_is_archive smallint;
declare variable old_price_index numeric(15,4);
declare variable old_account_name varchar(50);
declare variable old_hotel_name varchar(50);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:OPERATION = 'add') then ID = null;

  if (:OPERATION in ('add', 'mod')) then begin

    update or insert into PHONE_LINE_CONVERT (ID, LINE, ROOM_NAME, IS_TAXABLE, IS_ARCHIVE, PRICE_INDEX, ID_HOTEL, ID_ACCOUNT)
    values      (:ID, :line, :room_name, :is_taxable, :is_archive, :price_index, :id_hotel, :ID_ACCOUNT)
    matching    (ID)
    returning   ID
    into        :new_id;
  
    select coalesce(ACC.ACCOUNT_NAME, '')
    from   ACCOUNT ACC
    where  ACC.ID_ACCOUNT = :ID_ACCOUNT
    into   :account_name;
  
    select H.HOTEL_NAME
    from   HOTEL H
    where  H.ID_HOTEL = :ID_HOTEL
    into   :hotel_name;
  
    action_text = f_character(29) || :line || f_character(28) || :room_name ||
                  f_character(28) || :is_taxable || f_character(28) || :is_archive ||
                  f_character(28) || formatfloat(:price_index, '0.00') || f_character(28) || :hotel_name ||
                  f_character(28) || coalesce(:account_name, '');
    execute procedure SYSTEM_LOG_ADD ('PHONE_LINES', :NEW_ID, 'PHONE_LINE_MODIFY', :ACTION_TEXT);

  end else if (:operation = 'del') then begin
    select PLC.LINE, PLC.ROOM_NAME, PLC.IS_TAXABLE, PLC.IS_ARCHIVE, PLC.PRICE_INDEX,
           A.ACCOUNT_NAME, HO.HOTEL_NAME
    from   PHONE_LINE_CONVERT PLC
           join HOTEL HO on HO.ID_HOTEL = PLC.ID_HOTEL
           left outer join ACCOUNT A on A.ID_ACCOUNT = PLC.ID_ACCOUNT
    where  PLC.ID = :ID
    into   :old_line, :old_room_name, :old_is_taxable, :old_is_archive, :old_price_index,
           :old_account_name, :old_hotel_name;

    action_text = f_character(29) || :old_line || f_character(28) || :old_room_name ||
                  f_character(28) || :old_is_taxable || f_character(28) || :old_is_archive ||
                  f_character(28) || formatfloat(:old_price_index, '0.00') ||
                  f_character(28) || :old_hotel_name ||
                  f_character(28) || coalesce(:old_account_name, '');
    execute procedure SYSTEM_LOG_ADD ('PHONE_LINES', :ID, 'DELETE', :ACTION_TEXT);

    delete from PHONE_LINE_CONVERT
    where  ID = :id;
  end
end
^

/* Restore proc. body: PMS_EXPENSE_POSTS_CREATE$INT */
ALTER PROCEDURE PMS_EXPENSE_POSTS_CREATE$INT(ID_ROOM TYPE OF ID,
ID_OWNER TYPE OF ID,
ID_RENTAL_POOL TYPE OF ID_REF,
ID_SERVICE TYPE OF ID,
ID_CURRENCY TYPE OF TCURRENCY,
POST_VALUE TYPE OF TPRICE,
IS_CLIENT_ACC_POST TYPE OF TLOGICAL,
MANUAL_POST_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
IS_POST_PER_POOL TYPE OF TLOGICAL)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF,
NEW_ID_ACCOUNT_POST$PMS ID_REF)
 AS
declare variable event_type varchar(30);
  declare variable id_room_contract integer;
  declare variable new_id_pms_event integer;
  declare variable round_to_orig numeric(15,6);
  declare variable ownership_percent numeric(15,4);
  declare variable curr_contract_owner integer;
  declare variable curr_total_ownership numeric(15,4);
  declare variable curr_total_value numeric(15,4);
  declare variable percent_value numeric(15,4);
  declare variable id_account integer;
  declare variable id_hotel integer;
  declare variable is_account$pms integer;
  declare variable id_acc_post integer;
BEGIN
  event_type = 'MANUAL_EXPENSE';
  curr_total_value = 0;
  curr_total_ownership = 0;

  select RC.ID_ROOM_CONTRACT, r.ID_HOTEL
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS P on RC.ID_ROOM_PERIOD = P.ID_ROOM_PERIOD
         join ROOMS R on R.ID_ROOM = p.ID_ROOM
  where  :MANUAL_POST_DATE between P.FROM_DATE and P.TO_DATE
         and P.ID_ROOM = :ID_ROOM
         and P.STATUS in ('PRIVATE','CONTRACT')
  into   :id_room_contract, :id_hotel;

  if (:ID_ROOM_CONTRACT is null) then exception PMS_EXCEPTION '-615';

  execute procedure PMS_EVENT_CREATE$INT(:EVENT_TYPE, :ID_ROOM, :ID_OWNER, :DESCRIPTION,
          :MANUAL_POST_DATE, null, null, null, null, :POST_VALUE, :POST_VALUE, :ID_CURRENCY, null, :id_room_contract)
  returning_values :new_id_pms_event;

  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :ID_CURRENCY
  into   :round_to_orig;

  for
    select iif(:ID_OWNER is null, O.OWNERSHIP_PERCENT, 100), O.ID_OWNER
    from   ROOM_CONTRACT$PMS RC
           join ROOM_OWNER$PMS O on O.ID_ROOM_CONTRACT = RC.ID_ROOM_CONTRACT
    where  RC.ID_ROOM_CONTRACT = :id_room_contract
           and ((:ID_OWNER is null) or (O.ID_OWNER = :ID_OWNER))
    into   :ownership_percent, :curr_contract_owner
  do begin
    curr_total_ownership = :curr_total_ownership + :ownership_percent;
    if (:curr_total_ownership = 100) then begin
      percent_value = :post_value - :curr_total_value;
    end else
      percent_value = round_f(:post_value * :ownership_percent / 100, :round_to_orig);

    curr_total_value = :curr_total_value + :percent_value;

    execute procedure OWNER_ACCOUNT_GET$INT (iif(:is_post_per_pool = 1, :id_rental_pool, :curr_contract_owner),
            :id_hotel, 0, :IS_CLIENT_ACC_POST)
    returning_values (:id_account, :is_account$pms);

    execute procedure PMS_POSTING_CREATE$INT(:new_id_pms_event, :ID_ACCOUNT, :ID_SERVICE,
            :curr_contract_owner, :MANUAL_POST_DATE, :ID_CURRENCY, :PERCENT_VALUE, :is_account$pms, 0, :ID_ROOM)
    returning_values :id_acc_post;

    new_id_account_post = null;
    new_id_account_post$pms = null;

    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 1)) then new_id_account_post$pms = :id_acc_post;
    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 0)) then new_id_account_post = :id_acc_post;
    suspend;
  end

  execute procedure PMS_EVENT_SET_ACTIVE$INT(:new_id_pms_event);
END
^

/* Restore proc. body: PMS_POOL_DISTRIBUTION_SUB */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
declare variable cnt_room smallint;
  declare variable curr_total_posted numeric(15,4);
  declare variable cnt integer;
  declare variable value_to_post numeric(15,4);
  declare variable value_to_post_per_owner numeric(15,4);
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable id_room_contract integer;
  declare variable id_owner_account integer;
  declare variable id_pms_event integer;
  declare variable id_hotel integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
begin
  select c.ROUND_TO
  from   CURRS c
  where  c.CURR = :CURR
  into   :round_to;

  cnt_room = 0;
  select count(distinct RP.ID_ROOM)
  from   ROOM_PERIOD$PMS RP
         join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
  where  RC.ID_RENTAL_POOL = :id_rental_pool
         and RP.STATUS in ('PRIVATE','CONTRACT')
         and RP.FROM_DATE <= :FOR_DATE
         and RP.TO_DATE >= :FOR_DATE
  into   :cnt_room;

  if (:cnt_room = 0) then exception PMS_EXCEPTION 'The pool has not assigned room contracts for selected date (' || :FOR_DATE || ') !';

  if (:is_room_pool = 1) then begin
    curr_total_posted = 0;
    cnt = 0;
    id_pms_event = null;
    id_hotel = null;
    for
      select distinct RP.ID_ROOM, RC.ID_ROOM_CONTRACT, R.ID_HOTEL
      from   ROOM_PERIOD$PMS RP
             join ROOMS R on R.ID_ROOM = RP.ID_ROOM
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.FROM_DATE <= :FOR_DATE
             and RP.TO_DATE >= :FOR_DATE
      into   :id_room, :id_room_contract, :id_hotel
    do begin
      id_pms_event = null;

      select E.ID_PMS_EVENT
      from   PMS_EVENT$PMS E
      where  E.ID_ROOM = :id_room
             and E.ID_SESSION = current_transaction
      into   :ID_PMS_EVENT;

      if (:ID_PMS_EVENT is null) then begin
        execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, :id_room_contract)
        returning_values :id_pms_event;
        -- FIXME nakraq da se update total_event_value
      end
      if (:cnt_room - :cnt = 1) then begin
        value_to_post = :TOTAL_VALUE_PER_SERVICE - :curr_total_posted;
      end else begin
        value_to_post = round_f(:TOTAL_VALUE_PER_SERVICE / :cnt_room, :round_to);
      end

      curr_total_posted = :curr_total_posted + :value_to_post;
      cnt = :cnt + 1;

      /* ...i se razpredelq mejdu sobstwenicite na staqta */
      value_to_post = abs(:value_to_post);
      for
        select R.ID_OWNER, R.OUT_VALUE
        from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
        into   :id_owner, :value_to_post_per_owner
      do begin
        /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_pool_account,
                :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                1, :IS_OWNER_INCOME, :id_room)
        returning_values :no_use_id_acc_post;
        /* ... i se nachislqwa po sobswtenik */
        execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
        returning_values (:id_owner_account, :is_account$pms);

        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                :is_account$pms, :is_owner_income, :id_room)
        returning_values :no_use_id_acc_post;
      end
    end
  end else begin
    /* distribution by room_param */
    insert into TMP_SELECT$PMS(ID_SESSION, ID_ROOM, ID_OWNER)
    select distinct current_transaction, RP.ID_ROOM, null
    from   ROOM_PERIOD$PMS RP
           join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
    where  RC.ID_RENTAL_POOL = :ID_RENTAL_POOL
           and RP.STATUS in ('PRIVATE','CONTRACT')
           and RP.FROM_DATE <= :FOR_DATE
           and RP.TO_DATE >= :FOR_DATE;

    id_hotel = null;
    for
      select P.OUT_VALUE, P.OUT_ID_ROOM, R.ID_HOTEL
      from   PMS_CALC_VALUE_BY_PARAM(:ID_ROOM_PARAM, :TOTAL_VALUE_PER_SERVICE, :round_to) P
             join ROOMS R on R.ID_ROOM = P.OUT_ID_ROOM
      into   :value_to_post, :id_room, :id_hotel
    do begin
      id_pms_event = null;
      id_room_contract = null;
      -- room contract must be only one for this period
      select RC.ID_ROOM_CONTRACT
      from   ROOM_PERIOD$PMS RP
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.ID_ROOM = :id_room
             and :for_date between RP.FROM_DATE and RP.TO_DATE
      into   :id_room_contract;

      if (:id_room_contract is not null) then begin
        select E.ID_PMS_EVENT
        from   PMS_EVENT$PMS E
        where  E.ID_ROOM = :id_room
               and E.ID_SESSION = current_transaction
        into   :ID_PMS_EVENT;
  
        if (:ID_PMS_EVENT is null) then begin
          execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                  'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, id_room_contract)
          returning_values :id_pms_event;
          -- FIXME nakraq da se update total_event_value
        end
  
        /* ...i se razpredelq mejdu sobstwenicite na staqta */
        for
          select R.ID_OWNER, R.OUT_VALUE
          from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
          into   :id_owner, :value_to_post_per_owner
        do begin
          /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :ID_POOL_ACCOUNT,
                  :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                  1, :IS_OWNER_INCOME, :id_room)
          returning_values :no_use_id_acc_post;
  
          /* ... i se nachislqwa po sobswtenik */
          execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
          returning_values (:id_owner_account, :is_account$pms);

          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                  :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                  :is_account$pms, :is_owner_income, :id_room)
          returning_values :no_use_id_acc_post;
        end
      end
    end

    delete from TMP_SELECT$PMS T
    where  T.ID_SESSION = current_transaction;
  end
end
^

/* Restore proc. body: PROFILE_AGENT_MODIFY$PROFILE */
ALTER PROCEDURE PROFILE_AGENT_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
IS_ARCHIVE INTEGER,
AGENT_GROUP VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IATA_NUMBER VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null,
THRESHOLD_NOTE VARCHAR(255) = null,
THRESHOLD_AMOUNT NUMERIC(15,4) = null,
THRESHOLD_CURR CHAR(3) = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable id_agent integer;
  declare variable action_text varchar(255);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  AGENT_GROUP = nullif(trim(:AGENT_GROUP), '');

  if (:operation in ('add', 'mod')) then begin
    execute procedure PROFILE_COMMON_MODIFY$INT(:id_profile, 'AGENT', :profile_name,
            :phone, :fax, :email, :contact_city, :contact_address,
            :note, :msg, :is_archive, :id_def_contragent, :id_nom_market_segment,
            :wbe_password, :account_no, :is_exclusive_debt_ownership)
    returning_values (:NEW_ID_PROFILE);

    if (:new_id_profile is distinct from :id_profile) then begin
      id_agent = gen_id(G_AUTO_INC_AGENT,1);
      insert into AGENT (ID_AGENT, AGENT_NAME, IS_USE)
      values (:id_agent, :profile_name, 1-:is_archive);
  
      insert into PROFILE_AGENT(ID_PROFILE, ID_AGENT, AGENT_GROUP, COUNTRY_CODE, IATA_NUMBER, THRESHOLD_NOTE, THRESHOLD_AMOUNT, THRESHOLD_CURR)
      values (:new_id_profile, :id_agent, :agent_group, :country_code, :iata_number, :threshold_note, :threshold_amount, :threshold_curr);
  
      action_text = f_character(29) || :profile_name;
      execute procedure SYSTEM_LOG_ADD ('PROFILE', :new_id_profile, 'CREATE_AGENT_PROFILE', :action_text);
    end else begin
      select PA.ID_AGENT
      from   PROFILE_AGENT PA
      where  PA.ID_PROFILE = :NEW_ID_PROFILE
      into   :id_agent;

      update PROFILE_AGENT PA
      set    PA.IATA_NUMBER = :IATA_NUMBER,
             PA.COUNTRY_CODE = :COUNTRY_CODE,
             PA.AGENT_GROUP = :AGENT_GROUP,
             PA.THRESHOLD_NOTE = :THRESHOLD_NOTE,
             PA.THRESHOLD_AMOUNT = :THRESHOLD_AMOUNT,
             PA.THRESHOLD_CURR = :THRESHOLD_CURR
      where  PA.ID_PROFILE = :NEW_ID_PROFILE;

      update AGENT A
      set    A.AGENT_NAME = :profile_name,
             A.IS_USE = 1 - :is_archive
      where  A.ID_AGENT = :id_agent;
    end
  end else if (:operation = 'del') then  begin
    execute procedure PROFILE_DELETE$INT(:id_profile);

    new_id_profile = null;
  end
end
^

/* Restore proc. body: PROFILE_COMMON_MODIFY$INT */
ALTER PROCEDURE PROFILE_COMMON_MODIFY$INT(ID_PROFILE INTEGER,
PROFILE_TYPE VARCHAR(20),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
IS_ARCHIVE INTEGER,
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable action_text varchar(255);
  declare variable old_profile_name varchar(100);
  declare variable old_is_archive integer;
  declare variable p_dbkey char(8);
begin
  p_dbkey = null;
  select P.RDB$DB_KEY, P.PROFILE_NAME, P.IS_ARCHIVE
  from   PROFILE P
  where  P.ID_PROFILE = :ID_PROFILE
  into   :p_dbkey, :old_profile_name, :old_is_archive;
   
  is_exclusive_debt_ownership = coalesce(:is_exclusive_debt_ownership, 0);
  new_id_profile = :id_profile;
  if (:p_dbkey is null) then begin
    execute procedure SYSTEM_CHECK_OPERATION (:PROFILE_TYPE, 'PERSON,AGENT,HOUSE', 'Profile type');

    new_id_profile = gen_id(gen_profile_id, 1);
    insert into PROFILE (ID_PROFILE, PROFILE_NAME, PROFILE_TYPE,
           PHONE, FAX, EMAIL, CITY, ADDRESS, NOTE, MSG,
           ID_DEF_CONTRAGENT, ID_NOM_MARKET_SEGMENT, IS_ARCHIVE, ACCOUNT_NO,
           WBE_PASSWORD, IS_EXCLUSIVE_DEBT_OWNERSHIP)
    values (:new_id_profile, :profile_name, :profile_type,
           :phone, :fax, :email, :contact_city, :contact_address, :note, :msg,
           :id_def_contragent, :id_nom_market_segment, 0, :account_no,
           nullif(:wbe_password, ''), :is_exclusive_debt_ownership)
    returning RDB$DB_KEY into :p_dbkey;
  end else begin
    update PROFILE PU
    set    PU.PROFILE_NAME = :profile_name,
           PU.PHONE = :phone,
           PU.FAX = :fax,
           PU.EMAIL = :email,
           PU.CITY = :contact_city,
           PU.ADDRESS = :contact_address,
           PU.NOTE = :note,
           PU.MSG = :msg,
           PU.ID_DEF_CONTRAGENT = :id_def_contragent,
           PU.ID_NOM_MARKET_SEGMENT = :id_nom_market_segment,
           PU.ACCOUNT_NO = :ACCOUNT_NO,
           PU.WBE_PASSWORD = iif(PU.WBE_PASSWORD is null and :wbe_password = '', null, :wbe_password),
           -- empty ('') new password should not relpace NULLs,
           -- empty password indicate for 'deleted real password'
           PU.IS_EXCLUSIVE_DEBT_OWNERSHIP = :IS_EXCLUSIVE_DEBT_OWNERSHIP
    where  PU.RDB$DB_KEY = :p_dbkey;
  
    if (:old_profile_name <> :profile_name) then begin
      action_text = f_character(29) || :old_profile_name || f_character(28) || :profile_name;
      execute procedure SYSTEM_LOG_ADD ('PROFILE', :id_profile, 'EDIT_NAME', :action_text);
    end
  
    if (:is_archive is distinct from :old_is_archive) then
      execute procedure PROFILE_SET_ARCHIVE$INT (:P_DBKEY, :IS_ARCHIVE);

  end
end
^

/* Restore proc. body: PROFILE_DELETE$INT */
ALTER PROCEDURE PROFILE_DELETE$INT(ID_PROFILE INTEGER)
 AS
declare variable action_text varchar(255);
declare variable id_agent integer;
begin
  id_agent = null;
  select pa.ID_AGENT
  from   PROFILE_AGENT pa
  where  pa.ID_PROFILE = :ID_PROFILE
  into   :id_agent;

  delete from PROFILE P
  where  P.ID_PROFILE = :id_profile;

  if (:id_agent is not null) then
    delete from AGENT A where a.ID_AGENT = :id_agent;

  action_text = '';
  execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_PROFILE, 'DELETE', :action_text);

end
^

/* Restore proc. body: PROFILE_HOUSE_MODIFY$PROFILE */
ALTER PROCEDURE PROFILE_HOUSE_MODIFY$PROFILE(ID_PROFILE INTEGER,
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(20),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
IS_ARCHIVE INTEGER,
HOUSE_TYPE VARCHAR(50),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable action_text varchar(255);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    execute procedure PROFILE_COMMON_MODIFY$INT(:id_profile, 'HOUSE', :profile_name,
            :phone, :fax, :email, :contact_city, :contact_address,
            :note, :msg, :is_archive, :id_def_contragent, :id_nom_market_segment,
            :wbe_password, :account_no, :is_exclusive_debt_ownership)
    returning_values (:new_id_profile);

    if (:operation = 'add') then begin
      insert into PROFILE_HOUSE(ID_PROFILE, HOUSE_TYPE)
      values (:new_id_profile, :house_type);

      action_text = f_character(29) || :PROFILE_NAME;
      execute procedure SYSTEM_LOG_ADD ('PROFILE', :new_id_profile, 'CREATE_HOUSE_PROFILE', :action_text);
    end
  end else if (:operation = 'del') then  begin
    execute procedure PROFILE_DELETE$INT(:id_profile);

    new_id_profile = null;
  end
end
^

/* Restore proc. body: PROFILE_MERGE$PROFILE */
ALTER PROCEDURE PROFILE_MERGE$PROFILE(ID_SOURCE INTEGER,
ID_TARGET INTEGER,
OPERATION VARCHAR(20))
 AS
declare variable source_p_type varchar(30);
  declare variable target_p_type varchar(30);
  declare variable total_points_gained integer;
  declare variable total_points_consumed integer;
  declare variable source_p_name varchar(100);
  declare variable target_p_name varchar(100);
  declare variable id_hotel integer;
  declare variable id_bps integer;
  declare variable target_id_p_data integer;
  declare variable rd_dbkey char(8);
  declare variable gd_dbkey char(8);
  declare variable check_status smallint;
  declare variable id_reserv_detail integer;
  declare variable is_archive integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'merge, notequals');

  if ((:ID_SOURCE is null) or (:ID_TARGET is null)) then exception PROFILE_EXCEPTION '<NULL> profile id is passed!';

  if (:operation = 'notequals') then begin
    insert into PROFILE_DISSIMILAR (ID_PROFILE1, ID_PROFILE2)
    values (iif(:id_source < :id_target, :id_source, :id_target),
            iif(:id_source > :id_target, :id_source, :id_target));

    when any do exit;

  end else if (:operation = 'merge') then begin
    if (exists (select o.ID_OWNER from OWNER$PMS O where O.ID_OWNER in (:ID_SOURCE, :ID_TARGET))) then
      exception PROFILE_EXCEPTION '-1047';

    select p.PROFILE_TYPE, p.PROFILE_NAME
    from   PROFILE P
    where  P.ID_PROFILE = :ID_SOURCE
    into   :source_p_type, :source_p_name;

    select p.PROFILE_TYPE, p.PROFILE_NAME, PP.ID_PERSON_DATA, p.IS_ARCHIVE
    from   PROFILE P
           left outer join PROFILE_PERSON PP on PP.ID_PROFILE = P.ID_PROFILE 
    where  P.ID_PROFILE = :ID_TARGET
    into   :target_p_type, :target_p_name, :target_id_p_data, :is_archive;

    if (:is_archive = 1) then exception PROFILE_EXCEPTION '-1055';
    if (:source_p_type <> :target_p_type) then exception PROFILE_EXCEPTION 'Profile types are incompatible!';

    update RESERV_DETAIL RD
    set    rd.ID_AGENT_PROFILE = :ID_TARGET
    where  rd.ID_AGENT_PROFILE = :ID_SOURCE;

    update ACCOUNT A
    set    a.ID_PROFILE = :ID_TARGET
    where  a.ID_PROFILE = :ID_SOURCE;

    update AR_OWING AO
    set    ao.ID_PROFILE = :ID_TARGET
    where  ao.ID_PROFILE = :ID_SOURCE;

    update AR_PAYMENT ARP
    set    arp.ID_PROFILE = :ID_TARGET
    where  arp.ID_PROFILE = :ID_SOURCE;

    update AR_OWING_PAYMENT_POST AROP
    set    arop.ID_PROFILE = :ID_TARGET
    where  arop.ID_PROFILE = :ID_SOURCE;

    update DEPOSIT D
    set    d.ID_PROFILE = :ID_TARGET
    where  d.ID_PROFILE = :ID_SOURCE;

    update PROFILE_CREDIT_CARD pcc
    set    pcc.ID_PROFILE = :ID_TARGET
    where  pcc.ID_PROFILE = :ID_SOURCE
           and not exists (select spc.CARD_CODE
                           from   PROFILE_CREDIT_CARD spc
                           where  spc.ID_PROFILE = :ID_TARGET
                                  and spc.CARD_CODE = pcc.CARD_CODE);

    update PROFILE_DISCOUNT pd
    set    pd.ID_PROFILE = :ID_TARGET
    where  pd.ID_PROFILE = :ID_SOURCE
           and not exists (select spd.ID_SALE_DISCOUNT
                           from   PROFILE_DISCOUNT spd
                           where  spd.ID_PROFILE = :ID_TARGET
                                  and spd.ID_SALE_DISCOUNT = pd.ID_SALE_DISCOUNT);

    update PROFILE_HOTEL_RATE phr
    set    phr.ID_PROFILE = :ID_TARGET
    where  phr.ID_PROFILE = :ID_SOURCE
           and not exists (select tphr.ID_PROFILE
                           from   PROFILE_HOTEL_RATE tphr
                           where  tphr.ID_PROFILE = :ID_TARGET
                                  and tphr.ID_TARIFF = phr.ID_TARIFF
                                  and tphr.ID_HOTEL = phr.ID_HOTEL);

    update PROFILE_FILE pf
    set    pf.ID_PROFILE = :ID_TARGET
    where  pf.ID_PROFILE = :ID_SOURCE;

    for
      select sbs.ID_HOTEL, sbs.ID_BONUSPOINT_SCHEME
      from   PROFILE_BONUSPOINT_SCHEME sbs
      where  sbs.ID_PROFILE = :ID_SOURCE
      into   :id_hotel, :id_bps
    do begin
      if (not exists (select tbs.ID_BONUSPOINT_SCHEME
                      from   PROFILE_BONUSPOINT_SCHEME tbs
                      where  tbs.ID_PROFILE = :ID_TARGET
                             and tbs.ID_HOTEL = :id_hotel)) then
      begin
        insert into PROFILE_BONUSPOINT_SCHEME (ID_PROFILE, ID_HOTEL, ID_BONUSPOINT_SCHEME)
        values (:ID_TARGET, :id_hotel, :id_bps);
      end

    end

    update PROFILE_WALLET_POINTS pwp
    set    pwp.ID_PROFILE = :ID_TARGET
    where  pwp.ID_PROFILE = :ID_SOURCE;

    select pw.TOTAL_POINTS_GAINED, pw.TOTAL_POINTS_CONSUMED
    from   PROFILE_WALLET pw
    where  pw.ID_PROFILE = :ID_TARGET
    into   :total_points_gained, :total_points_consumed;

    update PROFILE p
    set    p.BONUSPOINT_GAINED = :total_points_gained,
           p.BONUSPOINT_CONSUMED = :total_points_consumed
    where  p.ID_PROFILE = :ID_TARGET;

    if (:source_p_type = 'PERSON') then begin
      for
        select RD.RDB$DB_KEY, GD.RDB$DB_KEY, RD.CHECK_STATUS, RD.ID_RESERV_DETAIL
        from   RESERV_DETAIL RD
               join GUEST_DATA GD on GD.ID_GUEST = RD.ID_TITULAR
        where  rd.ID_PERSON_PROFILE = :id_source
        into   :rd_dbkey, :gd_dbkey, :check_status, :id_reserv_detail
      do begin
        update RESERV_DETAIL RD
        set    RD.ID_PERSON_PROFILE = :id_target
        where  RD.RDB$DB_KEY = :rd_dbkey;

        if (:check_status < 1) then begin
          update GUEST_DATA GD
          set    GD.ID_PERSON_DATA = :target_id_p_data
          where  GD.RDB$DB_KEY = :gd_dbkey;

          execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL,  'TITULAR_CHAN_PROF_MERGE',
                                            f_character(29) || :source_p_name || f_character(28) || :target_p_name);
        end
      end

    end else if (:source_p_type = 'AGENT') then begin
      update SUMMARY_PROFILES$REV spr
      set    spr.ID_PROFILE = :ID_TARGET
      where  spr.ID_PROFILE = :ID_SOURCE;

      update SUMMARY_OCCUPANCY_PROFILE_MRKT sopm
      set    sopm.ID_PROFILE_AGENT = :ID_TARGET
      where  sopm.ID_PROFILE_AGENT = :ID_SOURCE;

      update SUMMARY_OCCUPANCY_OTHER soo
      set    soo.ID_PROFILE_AGENT = :ID_TARGET
      where  soo.ID_PROFILE_AGENT = :ID_SOURCE;
  
      update RES_TEMPLATE rt
      set    rt.ID_AGENT_PROFILE = :ID_TARGET
      where  rt.ID_AGENT_PROFILE = :ID_SOURCE;

      -- PROFILE_HOTEL_ALLOTMENT - keep target's allotments only 
    end

    /* delete or archivate */
    update PROFILE P
    set    p.IS_ARCHIVE = 1,
           p.ID_MERGE_PROFILE = :ID_TARGET
    where  p.ID_PROFILE = :ID_SOURCE;

    -- ficticious update - to force export only
    update PROFILE P
    set    p.UUID = p.UUID
    where  p.ID_PROFILE = :ID_TARGET;
    -- log
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_SOURCE, 'MERGE_TO', f_character(29) || :target_p_name);
    execute procedure SYSTEM_LOG_ADD ('PROFILE', :ID_TARGET, 'CONSOLIDATE_WITH', f_character(29) || :source_p_name);
  end
end
^

/* Restore proc. body: PROFILE_PERSON_CREATEQ$PROFILE */
ALTER PROCEDURE PROFILE_PERSON_CREATEQ$PROFILE(PROFILE_NAME TYPE OF TPERSON_NAME,
PHONE TYPE OF TPHONE,
ID_PASSPORT_TYPE TYPE OF ID,
PASS_NUM TYPE OF NAME_20,
EGN TYPE OF TTEXT_SHORT,
COUNTRY_CODE TYPE OF TSHORT_CODE,
CARD_CODE TYPE OF TCARD_CODE,
ID_PERSON_DATA TYPE OF ID_REF = null,
TITLE TYPE OF TSHORT_CODE = null,
ID_HOTEL TYPE OF ID_REF = null)
 RETURNS(NEW_ID_PROFILE TYPE OF ID,
P_DBKEY TYPE OF TDB_KEY,
PD_DBKEY TYPE OF TDB_KEY)
 AS
declare variable action_text varchar(255);
  declare variable mask varchar(10);
  declare variable merge_ident_num tname_unicode;
  declare variable merge_ident_num_alt tname_unicode;
begin
  select trim(ss.UNICODE_STRING) from SYSTEM_STRING_TO_UNICODE(:EGN) ss into :merge_ident_num;
  select trim(ss.UNICODE_STRING) from SYSTEM_STRING_TO_UNICODE(:PASS_NUM) ss into :merge_ident_num_alt;

  new_id_profile = gen_id(gen_profile_id, 1);
  insert into PROFILE (ID_PROFILE, PROFILE_NAME, PROFILE_TYPE, PHONE, IS_ARCHIVE, MERGE_IDENT_NUM, MERGE_IDENT_NUM_ALT)
  values (:new_id_profile, :profile_name, 'PERSON', :phone, 0, :merge_ident_num, :merge_ident_num_alt)
  returning RDB$DB_KEY into :p_dbkey;

  PD_DBKEY = null;
  if (:id_person_data is null) then begin
    id_person_data = gen_id(gen_person_data_id, 1);

    insert into PERSON_DATA(ID_PERSON_DATA)
    values (:id_person_data)
    returning RDB$DB_KEY into :pd_dbkey;
    -- !!! Search sensitive fields must be filled after the profile link creation (below) !!!
  end

  insert into PROFILE_PERSON (ID_PROFILE, ID_PERSON_DATA, CARD_CODE)
  values (:new_id_profile, :id_person_data, :card_code);

  if (:PD_DBKEY is not null) then begin
    if (:ID_HOTEL is not null) then begin
      execute procedure SETTING_GET_VALUE ('DEF_GUEST_MASK', :ID_HOTEL)
      returning_values  :mask;
    end

    execute procedure PERSON_DATA_SET$INT(:p_dbkey, :pd_dbkey, :profile_name, :profile_name, :country_code,
            null, null, :TITLE);

    execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, null, :EGN, :ID_PASSPORT_TYPE, :PASS_NUM, null, null,
            null, null, null, null, :mask);
  end

  action_text = f_character(29) || :profile_name;
  execute procedure SYSTEM_LOG_ADD ('PROFILE', :new_id_profile, 'CREATE_PERS_PROFILE', :action_text);
end
^

/* Restore proc. body: RES_ANUL_DETAIL$INT */
ALTER PROCEDURE RES_ANUL_DETAIL$INT(RD_DBKEY CHAR(8),
REASON VARCHAR(50),
CANCELATION_NUMBER TYPE OF NAME_20 = null)
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable id_reserv_detail integer;
  declare variable is_anul integer;
  declare variable id_log_event integer;
  declare variable id_guest integer;
  declare variable id_group integer;
  declare variable g_dbkey char(8);
  declare variable no_use varchar(255);
  declare variable tmp_extra_posts_left smallint;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:reason, 'NOSHOW, CANCELED, USERERROR, TRANSFER', 'Annul reason');

  select RD.IS_ANUL, RD.ID_RESERV_DETAIL, rd.ID_GROUP
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :is_anul, :id_reserv_detail, :id_group;

  if (:is_anul = 1) then begin
    exception BOOKING_EXCEPTION '-1021';
    -- Reservation is already annuled or checkedin !
  end

  if (:reason = 'NOSHOW') then begin
    execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    returning_values  :no_use, :no_use;
  end

  execute procedure SYSTEM_EVENT_LOG$INT ('RES_DETAIL', :id_reserv_detail, 'RES_ANUL', f_character(29) || :reason)
  returning_values :id_log_event;

  update RESERV_DETAIL RDU
  set    RDU.IS_ANUL = 1,
         RDU.REASON_OF_ANUL = :reason,
         RDU.ID_LOG_EVENT_ANNUL = :id_log_event,
         RDU.CANCELATION_NUMBER = coalesce(:CANCELATION_NUMBER, strhash_large(rdu.NUMBER || 'CANCELATION'))
  where  RDU.RDB$DB_KEY = :rd_dbkey;

  EXTRA_POSTS_LEFT = 0;
  for
    select g.ID_GUEST, G.RDB$DB_KEY
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_guest, :g_dbkey
  do begin
    execute procedure GUEST_DEL_POSTINGS$INT(:id_guest)
    returning_values  :tmp_extra_posts_left;
    EXTRA_POSTS_LEFT = iif(:EXTRA_POSTS_LEFT = 1, 1, :tmp_extra_posts_left);

    update GUEST G
    set    G.UUID = null
    where  g.RDB$DB_KEY = :g_dbkey;
  end

  execute procedure RES_FINALIZE$INT (:RD_DBKEY, 0)
  returning_values (:warn_code);

  execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

  if (:id_group is not null) then
    execute procedure RESGRP_GUESTDATA_INVALIDATE$INT(:id_group);

end
^

/* Restore proc. body: RES_CHECK_OUT_GUESTS$RSV */
ALTER PROCEDURE RES_CHECK_OUT_GUESTS$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND SMALLINT = 0,
EARLYCHECKOUT_DATE DATE = null)
 AS
declare variable action_code varchar(100);
  declare variable cleaning_restriction varchar(10);
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable id_reserv_detail integer;
  declare variable id_guest integer;
  declare variable id_room integer;
  declare variable rd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable checkout_status integer;
  declare variable sys_date date;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
begin
  checkout_status = 1;
  action_code = case when :check_out_kind = 0 then 'CHECK_OUT'
                     when :check_out_kind = 1 then 'CHECK_OUT_EARLY1'
                     when :check_out_kind = 2 then 'CHECK_OUT_EARLY2'
                     when :check_out_kind = 3 then 'CHECK_OUT_EARLY3'
                end;

  for
    select RD.ID_RESERV_DETAIL, RD.ID_ROOM, RD.RDB$DB_KEY, rd.ID_HOTEL,
           (select sd.SYSTEM_DATE
            from   SYSTEM_DATE_GET (rd.ID_HOTEL) sd)
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :id_reserv_detail, :id_room, :rd_dbkey, :id_hotel, :sys_date
  do begin

    for
      select G.ID_GUEST, G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.CHECK_STATUS = 0 /* checked in */
      into   :id_guest, :g_dbkey
    do begin
      if (:CHECK_OUT_KIND = 3) then begin
        -- DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
        update GUEST G
        set    G.EARLYCHECKOUT_DATE = coalesce(:EARLYCHECKOUT_DATE, :sys_date)
        where  g.RDB$DB_KEY = :g_dbkey;

        execute procedure GUEST_SET_MANUAL_STAY$INT(:rd_dbkey, :id_guest, coalesce(:EARLYCHECKOUT_DATE, :sys_date))
        returning_values  :err_code, :err_text;
        if (:err_code < 0) then exception RESERV_CHECK_OUT_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
      end

      update ACCOUNT_POST AP
      set    AP.IS_ARCHIVE = 1
      where  AP.ID_GUEST = :id_guest;
    
      execute procedure GUEST_SET_STATUS$INT (:g_dbkey, :checkout_status);

      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, :action_code, '');
    end

    if (:CHECK_OUT_KIND = 3) then begin
      -- DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
      execute procedure OCCUPANCY_RESERV$INT(:rd_dbkey);

      execute procedure OCCUPANCY_SHARES_COMPLETE$INT (:id_reserv_detail)
      returning_values (:no_use, :no_use);
    end

    execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

    execute procedure SETTING_GET_VALUE('CLEANING_RESTRICTION', :id_hotel)
    returning_values  :cleaning_restriction;
  
    if (:cleaning_restriction <> '0' and :id_room > 0) then begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'CHECK_OUT', 'set_dirty');
    end

    execute procedure RES_SAVE_STATUS$INT (:rd_dbkey, :checkout_status);

    update RESERV_DETAIL rd
    set    rd.CHECK_OUT_KIND = :CHECK_OUT_KIND,
           rd.EARLYCHECKOUT_DATE = iif(:check_out_kind > 0, coalesce(:EARLYCHECKOUT_DATE, :sys_date), null)
    where  rd.RDB$DB_KEY = :rd_dbkey;

    execute procedure RES_BONUSPOINTS_APPLY$CL (:id_reserv_detail);
  end

end
^

/* Restore proc. body: RES_CHECKIN$RSV */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable old_check_status integer;
  declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable is_anul integer;
  declare variable arrival_date date;
  declare variable system_date date;
begin
  /*  Description:
  ||
  */
  select RD.CHECK_STATUS, RD.RDB$DB_KEY, RD.FROM_DATE, RD.ID_HOTEL,
         RD.ID_ROOM, RD.IS_ANUL
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_check_status, :rd_dbkey, :arrival_date, :id_hotel,
         :old_id_room, :is_anul;

  if (:is_anul = 1) then exception BOOKING_EXCEPTION '-2';

  if (:old_check_status >= 0) then exception BOOKING_EXCEPTION '-1003';

  if (:old_id_room < 0 and coalesce(:ID_ROOM, 0) <= 0) then exception BOOKING_EXCEPTION '-1018';

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date < :arrival_date) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CHECK_IN_FUTURE');
  end
  /*----*/
  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'lock');

  execute procedure sys_dbg('occ RES_CHECKIN$RSV id_room = '||coalesce(:id_room, 'null'));
  execute procedure sys_dbg('occ RES_CHECKIN$RSV old_id_room = '||coalesce(:old_id_room, 'null'));

  if (:id_room is not null) then begin
    if (:old_check_status = -3) then begin
      execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, -2);
    end

    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option)
    returning_values (:WARN_CODE);
  end

  execute procedure RES_SET_CHECKIN$INT (:rd_dbkey)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'release');
  /*----*/
  select f_character(29) || R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = coalesce(:ID_ROOM, :old_id_room)
  into   :action_text;
   
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'CHECK_IN', :action_text);

end
^

/* Restore proc. body: RES_CHECKIN_MULTI$RSV */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable checkin_count integer;
  declare variable split_on_checkin integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
  declare variable tmp_warn_code integer;
begin
  checkin_count = 0;
  warn_code = null;
  for
    select RD.ID_RESERV_DETAIL, RD.CHECK_STATUS, RD.SPLIT_ON_CHECKIN, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :SELECTION_ID
    into   :id_reserv_detail, :check_status, :split_on_checkin, :id_titular
  do begin
    if (:check_status >= 0) then begin
      checkin_count = :checkin_count + 1;
    end else begin
      if (:split_on_checkin = 1) then begin
        for
          select G.ID_GUEST
          from   GUEST G
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and G.ID_GUEST <> :id_titular
          into   :id_guest
        do begin
          execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
          returning_values  :id_splited_reservation;

          execute procedure RES_CHECKIN$RSV (:id_splited_reservation)
          returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

          update RESERV_DETAIL RD
          set    RD.SELECTION_ID = :selection_id
          where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
        end
      end

      execute procedure RES_CHECKIN$RSV (:id_reserv_detail)
      returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
      WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end

  if (:checkin_count > 0) then begin
    execute procedure SYSTEM_WARNING_ADD(-1011, f_character(29)||:checkin_count)
    returning_values  :warn_code;
  end
end
^

/* Restore proc. body: RES_CREATE_LOG$INT */
ALTER PROCEDURE RES_CREATE_LOG$INT(RD_DBKEY CHAR(8))
 AS
declare variable action_text varchar(255);
  declare variable room_name varchar(30);
  declare variable agent_profile varchar(100);
  declare variable tarifa_name varchar(50);
  declare variable type_hrana varchar(30);
  declare variable id_reserv_detail integer;
  declare variable number varchar(62);
  declare variable arrival_date date;
  declare variable departure_date date;
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable custom_price numeric(15,4);
  declare variable custom_currency varchar(3);
  declare variable id_event_log integer;
begin
  select rd.ID_RESERV_DETAIL, rd.NUMBER, rd.FROM_DATE, rd.TO_DATE, rd.ADULT_COUNT, rd.CHILD_COUNT,
         rt.TYPE_ROOM || ' ' || coalesce (R.ROOM_NAME, ''),
         P.PROFILE_NAME, T.TARIFA_NAME, TH.NAME, rd.CUSTOM_PRICE, rd.CUSTOM_CURRENCY
  from   RESERV_DETAIL RD
         left outer join ROOM_TYPES RT on rt.ID_ROOM_TYPE = rd.ID_ROOM_TYPE
         left outer join ROOMS R on R.ID_ROOM_TYPE = RT.ID_ROOM_TYPE and R.ID_ROOM = rd.ID_ROOM
         left outer join PROFILE P on P.ID_PROFILE = rd.ID_AGENT_PROFILE
         left outer join TARIFA T on T.ID_TARIFA = RD.ID_RATE
         left outer join MEALS TH on TH.ID_BOARD = rd.ID_BOARD
  where  RD.RDB$DB_KEY = :RD_DBKEY
  into   :id_reserv_detail, :number, :arrival_date, :departure_date, :adult_count, :child_count,
         :room_name,
         :agent_profile, :tarifa_name, :type_hrana, :custom_price, :custom_currency;

  action_text = substring(f_character(29) || :number
                || f_character(28) || formatdate(:arrival_date, 'D;dd.mm.yyyy') || '-' || formatdate(:departure_date, 'D;dd.mm.yyyy')
                || f_character(28) || :room_name
                || f_character(28) || :ADULT_COUNT || '+' || :CHILD_COUNT
                || f_character(28) || coalesce(:type_hrana, '')
                || f_character(28) || coalesce(substring(:agent_profile from 1 for 50), '')
                || f_character(28) || :tarifa_name
                || f_character(28) || coalesce(formatfloat(:custom_price, '0.00') || ' ' || :custom_currency, '')
                from 1 for 255);

  execute procedure SYSTEM_EVENT_LOG$INT ('RES_DETAIL', :id_reserv_detail, 'RES_CREATE', :action_text)
  returning_values :id_event_log;

  if (:id_event_log is not null) then
    update RESERV_DETAIL R
    set    r.ID_LOG_EVENT_CREATE = :id_event_log
    where  r.RDB$DB_KEY = :RD_DBKEY;
end
^

/* Restore proc. body: RES_DELETE$INT */
ALTER PROCEDURE RES_DELETE$INT(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable rd_dbkey char(8);
  declare variable id_guest integer;
  declare variable action_text varchar(255);
  declare variable from_date date;
  declare variable to_date date;
  declare variable room_type varchar(20);
  declare variable number varchar(62);
  declare variable tmp_extra_posts_left integer;
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_DELETE');

  select RD.RDB$DB_KEY, RD.FROM_DATE, rd.TO_DATE, RT.TYPE_ROOM, rd.NUMBER
  from   RESERV_DETAIL RD
         left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = RD.ID_ROOM_TYPE
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey, :from_date, :to_date, :room_type, :number;

  update RESERV_DETAIL R
  set    r.ID_TITULAR = null
  where  r.RDB$DB_KEY = :rd_dbkey;

  EXTRA_POSTS_LEFT = 0;
  for
    select G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_guest
  do begin
    execute procedure RES_GUEST_DEL$INT(:id_guest, :id_reserv_detail, :REASON)
    returning_values  :tmp_extra_posts_left;
    EXTRA_POSTS_LEFT = iif(:EXTRA_POSTS_LEFT = 1, 1, :tmp_extra_posts_left);
  end

  execute procedure RES_FINALIZE$INT (:RD_DBKEY, 1)
  returning_values (:warn_code);


  execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

  action_text = f_character(29) || coalesce(:number, '')
                || f_character(28) || coalesce(:room_type, '')
                || f_character(28) || :from_date
                || f_character(28) || :to_date
                || f_character(28) || :reason;
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'DELETE', :action_text);

  delete from RESERV_DETAIL RDD
  where  RDD.RDB$DB_KEY = :rd_dbkey;

  delete from XML_MESSAGE$EXC xml
  where  xml.OBJECT_TYPE = 'BOOKING'
         and xml.OBJECT_ID = :number;

end
^

/* Restore proc. body: RES_FINALIZE_RECALC$INT */
ALTER PROCEDURE RES_FINALIZE_RECALC$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_calc integer;
begin
  -- NORMAL recalculation processing
  execute procedure RES_RECALC$INT(:rd_dbkey, 'NORMAL', 0)
  returning_values  :err_code, :err_text, :id_tar_calc;
  if (:err_code < 0) then exit;

end
^

/* Restore proc. body: RES_GUEST_ADD$INT */
ALTER PROCEDURE RES_GUEST_ADD$INT(RD_DBKEY CHAR(8),
IS_CHILD INTEGER,
INITIALIZE_BOOKING TYPE OF TLOGICAL = 0)
 RETURNS(NEW_ID_GUEST INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable pd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable check_status integer;

  declare variable from_date date;
  declare variable to_date date;
  declare variable id_room integer;
  declare variable id_agent integer;
  declare variable id_tarrif integer;
  declare variable guest_name varchar(100);
  declare variable country_code varchar(10);
  declare variable guest_status varchar(50);
  declare variable default_mask varchar(50);
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable id_titular integer;
  declare variable id_profile_data integer;
  declare variable id_person_data integer;
  declare variable id_base_account integer;
  declare variable id_extra_account integer;
  declare variable id_hotel integer;
  declare variable action_text varchar(255);
begin
  select RD.FROM_DATE, RD.TO_DATE, RD.ID_ROOM, PA.ID_AGENT, RD.ID_RATE,
         RD.ID_RESERV_DETAIL, RD.ID_TITULAR, PP.ID_PERSON_DATA,
         RD.CHECK_STATUS, RD.ADULT_COUNT, RD.CHILD_COUNT, RD.COUNTRY,
         rd.ID_BASE_ACCOUNT, rd.ID_EXTRA_ACCOUNT, rd.ID_HOTEL
  from   RESERV_DETAIL RD
         left outer join PROFILE_PERSON PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
         left outer join PROFILE_AGENT PA on PA.ID_PROFILE = RD.ID_AGENT_PROFILE
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :from_date, :to_date, :id_room, :id_agent, :id_tarrif,
         :id_reserv_detail, :id_titular, :id_profile_data,
         :check_status, :adult_count, :child_count, :country_code,
         :id_base_account, :id_extra_account, :id_hotel;

  if (:check_status < 0) then begin
    guest_status = '';
    check_status = -2;
  end else if (:check_status = 0) then begin
    guest_status = 'CHECKING_IN';
  end else begin  /* checked out */
    exception BOOKING_EXCEPTION '-1032';
  end


  new_id_guest = gen_id (id_guest_gen, 1);
  insert into GUEST (ID_GUEST, ID_BASE_ACCOUNT, ID_ACCOUNT, FROM_DATE, TO_DATE, ID_ROOM, ID_AGENT, ID_TARIFA,
         ID_RESERV_DETAIL, IS_CHILD, CHECK_STATUS, GUEST_EDIT_STATUS)
  values (:new_id_guest,  :id_base_account, :id_extra_account, :from_date, :to_date, :id_room, :id_agent, :id_tarrif,
         :id_reserv_detail, :is_child, -2, :guest_status)
  returning RDB$DB_KEY into :g_dbkey;

  execute procedure sys_dbg('res RES_GUEST_ADD$INT new_id_guest = '||coalesce(:new_id_guest, 'null'));

  insert into GUEST_CHANGE_STATUS (ID_GUEST, FROM_DATE_ORIG, TO_DATE_ORIG)
  values (:new_id_guest, :from_date, :to_date);

  if (:is_child = 1) then begin
    child_count = :child_count + 1;
    guest_name = '-';
  end else begin
    adult_count = :adult_count + 1;
    guest_name = '-';
  end

  if (:id_titular is null) then begin
    id_titular = :new_id_guest;
    id_person_data = :id_profile_data;
  end else begin
    execute procedure SETTING_GET_VALUE('DEF_GUEST_MASK', :id_hotel)
    returning_values  :default_mask;

    id_person_data = gen_id(GEN_PERSON_DATA_ID, 1);
    insert into PERSON_DATA (ID_PERSON_DATA, MASK)
    values (:id_person_data, :default_mask)
    returning RDB$DB_KEY into :pd_dbkey;

  end

  insert into GUEST_DATA (ID_GUEST, ID_PERSON_DATA)
  values (:new_id_guest, :id_person_data);

  if (:INITIALIZE_BOOKING is distinct from 1) then begin
    action_text = F_CHARACTER(29) || '"' || :guest_name || '" (' || :NEW_ID_GUEST || ')';
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_GUEST_ADD', :action_text);
  end

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name, :guest_name, coalesce(:country_code, ''),
          :is_child, null, null, null);

  execute procedure RES_GUEST_AUTO$INT(:g_dbkey, :rd_dbkey, 1);

  update RESERV_DETAIL RD
  set    RD.ADULT_COUNT = :adult_count,
         RD.CHILD_COUNT = :child_count,
         RD.ID_TITULAR = :id_titular
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SET_EDIT_STATUS$INT (:RD_DBKEY, 'ADDGUEST', 'add');

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, :check_status);

end
^

/* Restore proc. body: RES_GUEST_CHANGE$RSV */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable id_guest integer;
  declare variable check_status integer;
  declare variable id_person_data integer;
  declare variable old_person_profile integer;
  declare variable old_profile_name varchar(100);
  declare variable new_profile_name varchar(100);
begin
  select r.RDB$DB_KEY, r.ID_TITULAR, r.CHECK_STATUS, r.ID_PERSON_PROFILE, p.PROFILE_NAME
  from   RESERV_DETAIL R
         join PROFILE P on P.ID_PROFILE = r.ID_PERSON_PROFILE
  where  R.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey, :id_guest, :check_status, :old_person_profile, :old_profile_name;

  if (:old_person_profile = :ID_PERSON_PROFILE) then exit; -- NO CHANGES!

  id_person_data = null;
  select pp.ID_PERSON_DATA, p.PROFILE_NAME
  from   PROFILE_PERSON PP
         join PROFILE P on P.ID_PROFILE = pp.ID_PROFILE
  where  pp.ID_PROFILE = :ID_PERSON_PROFILE
  into   :id_person_data, :new_profile_name;

  if (:id_person_data is null) then exception BOOKING_EXCEPTION '-1039';

  update RESERV_DETAIL RD
  set    rd.ID_PERSON_PROFILE = :ID_PERSON_PROFILE
  where  rd.RDB$DB_KEY = :rd_dbkey;

  if (:check_status = 1) then begin
    execute procedure PERSON_DATA_COPY$INT (:id_person_data)
    returning_values (:id_person_data);
  end

  update GUEST_DATA GD
  set    gd.ID_PERSON_DATA = :id_person_data
  where  gd.ID_GUEST = :id_guest;

  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey);

  if (exists (select ap.ID_ACCOUNT_POST
              from   ACCOUNT_POST AP
                     join ACCOUNT A on A.ID_ACCOUNT = ap.ID_ACCOUNT
              where  a.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                     and a.ID_PROFILE = :old_person_profile
                     and ap.IS_ANUL = 0)) then
    exception BOOKING_EXCEPTION '-1038';

  if (exists (select d.ID_DEPOSIT
              from   DEPOSITS D
                     join ACCOUNT A on A.ID_ACCOUNT = d.ID_ACCOUNT
              where  a.ID_PROFILE = :old_person_profile
                     and coalesce(d.ID_RESERV_DETAIL, a.ID_RESERV_DETAIL) = :ID_RESERV_DETAIL
                     and d.RECEIVED_AMOUNT > 0)) then
    exception BOOKING_EXCEPTION '-1040';

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'TITULAR_CHANGED',
          f_character(29) || :old_profile_name || f_character(28) || :new_profile_name, null);

end
^

/* Restore proc. body: RES_GUEST_DEL$INT */
ALTER PROCEDURE RES_GUEST_DEL$INT(ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50) = null)
 RETURNS(EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable action_text varchar(255);
  declare variable guest_name varchar(100);
  declare variable is_child smallint;
  declare variable id_titular integer;
BEGIN

  select pd.PERSON_NAME, G.IS_CHILD, red.ID_TITULAR
  from   GUEST g
         join GUEST_DATA GD on gd.ID_GUEST = g.ID_GUEST
         join PERSON_DATA PD on PD.ID_PERSON_DATA = gd.ID_PERSON_DATA
         join RESERV_DETAIL RED on RED.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
         left outer join PROFILE_PERSON PP on PP.ID_PERSON_DATA = GD.ID_PERSON_DATA
  where  G.ID_GUEST = :ID_GUEST
  into   :guest_name, :is_child, :id_titular;

  if (:ID_GUEST = :id_titular) then exception BOOKING_EXCEPTION '-1007';

  execute procedure GUEST_DEL_POSTINGS$INT(:id_guest)
  returning_values :EXTRA_POSTS_LEFT;

  update GUEST G
  set    G.ID_RESERV_DETAIL = null,
         g.ID_BASE_ACCOUNT = null,
         g.ID_ACCOUNT = null
  where  G.ID_GUEST = :id_guest;

  update RESERV_DETAIL RD
  set    RD.ADULT_COUNT = RD.ADULT_COUNT - (1 - :is_child),
         RD.CHILD_COUNT = RD.CHILD_COUNT - :is_child
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL;

  action_text = f_character(29) || '"' || :guest_name || '" (' || :id_guest || ')' || f_character(28) || coalesce(:REASON, '');
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_GUEST_DEL', :action_text);

END
^

/* Restore proc. body: RES_GUEST_SAVE_BOARD$RSV */
ALTER PROCEDURE RES_GUEST_SAVE_BOARD$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_BOARD INTEGER)
 AS
declare variable id_reserv_detail integer;
declare variable old_id_board integer;
  declare variable action_text varchar(255);
  declare variable guest_name varchar(50);
  declare variable old_board_name varchar(50);
  declare variable new_board_name varchar(50);
begin
  ID_BOARD = :ID_BOARD;
  if (:ID_BOARD = -1) then begin
    -- default to booking board
    select rd.ID_BOARD
    from   GUEST g
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :ID_GUEST
    into   :ID_BOARD;
  end

  update GUEST_STAY GS
  set    gs.ID_BOARD = :ID_BOARD
  where  gs.ID_GUEST = :ID_GUEST
         and gs.FOR_DATE = :FOR_DATE
  returning old.id_board
  into      :old_id_board;

  if (:old_id_board is distinct from :ID_BOARD) then begin
    select g.ID_RESERV_DETAIL, gc.GUEST_NAME1
    from   GUEST G
           left join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
    where  g.ID_GUEST = :ID_GUEST
    into   :id_reserv_detail, :guest_name;

    select M.NAME
    from   MEALS M
    where  M.ID_BOARD = :old_id_board
    into   :old_board_name;

    select M.NAME
    from   MEALS M
    where  M.ID_BOARD = :ID_BOARD
    into   :new_board_name;

    action_text = f_character(29) || :guest_name
                  || f_character(28) || formatdate(:for_date, 'd;dd.mm.yyyy')
                  || f_character(28) || coalesce(:new_board_name, '')
                  || f_character(28) || coalesce(:old_board_name, '');
    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'GUEST_DIFF_BOARD', :action_text);
  end
end
^

/* Restore proc. body: RES_GUEST_SAVE_OTHER$RSV */
ALTER PROCEDURE RES_GUEST_SAVE_OTHER$RSV(ID_GUEST INTEGER,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE)
 AS
declare variable g_dbkey char(8);
  declare variable old_code_first_food tfood_code;
  declare variable old_text_first_food varchar(50);
  declare variable text_first_food varchar(50);
  declare variable action_text varchar(255);
begin
  select G.RDB$DB_KEY, G.CODE_FIRST_FOOD
  from   GUEST G
  where  G.ID_GUEST = :id_guest
  into   :g_dbkey, :old_code_first_food;

  execute procedure RES_GUEST_SAVE_OTHER$INT(:g_dbkey, :transfer_in_time, :transfer_in_note,
          :transfer_out_time, :transfer_out_note, :code_first_food);

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -1);

  if (coalesce(:old_code_first_food, 0) <> coalesce(:code_first_food, 0)) then begin
    old_text_first_food = case
                              when :old_code_first_food = 'breakfast' then 'caption.breakfast'
                              when :old_code_first_food = 'lunch' then 'caption.launch'
                              when :old_code_first_food = 'dinner' then 'caption.dinner'
                              when :old_code_first_food = 'extrafood1' then 'caption.extrafood1'
                              when :old_code_first_food = 'extrafood2' then 'caption.extrafood2'
                              when :old_code_first_food = 'none' then 'caption.no_first_food'
                          end;
    text_first_food = case
                              when :code_first_food = 'breakfast' then 'caption.breakfast'
                              when :code_first_food = 'lunch' then 'caption.launch'
                              when :code_first_food = 'dinner' then 'caption.dinner'
                              when :code_first_food = 'extrafood1' then 'caption.extrafood1'
                              when :code_first_food = 'extrafood2' then 'caption.extrafood2'
                              when :code_first_food = 'none' then 'caption.no_first_food'
                      end;
    action_text = f_character(29) || coalesce('@{' || :old_text_first_food || '}', '') ||
                  f_character(28) || coalesce('@{' || :text_first_food || '}', '');
    execute procedure SYSTEM_LOG_ADD ('GUEST', :ID_GUEST, 'FIRST_FOOD_CHANGED', :ACTION_TEXT);
  end
end
^

/* Restore proc. body: RES_GUEST_SAVE_RATE$RSV */
ALTER PROCEDURE RES_GUEST_SAVE_RATE$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TARIFF INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_tariff integer;
  declare variable guest_name varchar(50);
  declare variable action_text varchar(255);
  declare variable old_rate varchar(50);
  declare variable new_rate varchar(50);
begin

  if (:ID_TARIFF = -1) then begin
    -- default to booking board
    select rd.ID_RATE
    from   GUEST g
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :ID_GUEST
    into   :ID_TARIFF;
  end

  update GUEST_STAY GS
  set    gs.ID_TARIFF = :ID_TARIFF
  where  gs.ID_GUEST = :ID_GUEST
         and gs.FOR_DATE = :FOR_DATE
  returning old.id_tariff
  into      :old_id_tariff;
  --

  if (:OLD_ID_TARIFF <> :ID_TARIFF) then begin
    select g.ID_RESERV_DETAIL, gc.GUEST_NAME1
    from   GUEST G
           left join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
    where  g.ID_GUEST = :ID_GUEST
    into   :id_reserv_detail, :guest_name;

    select T.TARIFA_NAME
    from   TARIFA T
    where  T.ID_TARIFA = :old_id_tariff
    into   :old_rate;
     
    select T.TARIFA_NAME
    from   TARIFA T
    where  T.ID_TARIFA = :ID_TARIFF
    into   :new_rate;
     
    action_text = f_character(29) || :guest_name
                  || f_character(28) || formatdate(:for_date, 'D;dd.mm.yyyy')
                  || f_character(28) || :new_rate
                  || f_character(28) || :old_rate;
    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :ID_RESERV_DETAIL, 'GUEST_DIFF_TARIFF', :ACTION_TEXT);
  end
end
^

/* Restore proc. body: RES_GUEST_SAVE_ROOMTYPE$RSV */
ALTER PROCEDURE RES_GUEST_SAVE_ROOMTYPE$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TAR_ROOM_TYPE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_room_type integer;
  declare variable action_text varchar(255);
  declare variable guest_name varchar(50);
  declare variable old_room_type varchar(50);
  declare variable new_room_type varchar(50);
begin
 /* select G.TO_DATE - 1, G.ID_RESERV_DETAIL, GC.GUEST_NAME1
  from   GUEST G
         left outer join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
  where  G.ID_GUEST = :ID_GUEST
  into   :to_date, :id_reserv_detail, :guest_name;
  is_departure = iif(:to_date = :for_date, 1, 0);

  select GS.ID_TARIFF, GS.ID_BOARD, GS.ID_TYPE_STAY, GS.ID_ROOM_TYPE
  from   GUEST_STAY GS
  where  GS.ID_GUEST = :ID_GUEST
         and GS.FOR_DATE = :FOR_DATE
  into   :id_tariff, :id_board, :id_type_stay, :old_id_room_type;

  execute procedure RES_GUEST_DYNAMICPARAMS_SAVE(:id_reserv_detail, :id_guest, :for_date,
          :id_tar_room_type, :id_board, :id_type_stay, :id_tariff, :is_departure);
  */
  --
  update GUEST_STAY GS
  set    gs.ID_ROOM_TYPE = :ID_TAR_ROOM_TYPE
  where  gs.ID_GUEST = :ID_GUEST
         and gs.FOR_DATE = :FOR_DATE
  returning old.ID_ROOM_TYPE
  into      :old_id_room_type;

  if (:OLD_ID_ROOM_TYPE <> :ID_TAR_ROOM_TYPE) then begin
    select g.ID_RESERV_DETAIL, gc.GUEST_NAME1
    from   GUEST G
           left join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
    where  g.ID_GUEST = :ID_GUEST
    into   :id_reserv_detail, :guest_name;

    if (:old_id_room_type = -1) then begin
      old_room_type = '@{other.AUTO_TYPE_STAY}';
    end else begin
      select RT.TYPE_ROOM
      from   ROOM_TYPES RT
      where  RT.ID_ROOM_TYPE = :old_id_room_type
      into   :old_room_type;
    end

    if (:ID_TAR_ROOM_TYPE = -1) then begin
      new_room_type = '@{other.AUTO_TYPE_STAY}';
    end else begin
      select RT.TYPE_ROOM
      from   ROOM_TYPES RT
      where  RT.ID_ROOM_TYPE = :ID_TAR_ROOM_TYPE
      into   :new_room_type;
    end

    action_text = f_character(29) || :guest_name
                  || f_character(28) || formatdate(:for_date, 'd;dd.mm.yyyy')
                  || f_character(28) || :new_room_type
                  || f_character(28) || :old_room_type;
    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'GUEST_DIFF_ROOM_TYPE', :action_text);
  end
end
^

/* Restore proc. body: RES_GUEST_SAVE_STAY$RSV */
ALTER PROCEDURE RES_GUEST_SAVE_STAY$RSV(ID_GUEST INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable g_dbkey char(8);
declare variable id_hotel integer;
  declare variable old_arrival date;
  declare variable old_departure date;
  declare variable action_text varchar(255);
begin
  err_code = 0;
  warn_code = 0;
  select G.RDB$DB_KEY, RD.ID_HOTEL, G.FROM_DATE, G.TO_DATE
  from   GUEST G
         join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
  where  G.ID_GUEST = :id_guest
  into   :g_dbkey, :id_hotel, :old_arrival, old_departure;

  execute procedure RES_GUEST_SAVE_STAY$INT(:g_dbkey, :arrival_date, :departure_date, :id_hotel);

  if ((:old_arrival <> :arrival_date) or (:old_departure <> :departure_date) ) then begin
    action_text = f_character(29) || '{' || formatdate(:old_arrival, 'D;dd.mm.yyyy') || '-' || formatdate(:old_departure, 'D;dd.mm.yyyy') || '}'
                  || f_character(28) || '{' || formatdate(:arrival_date, 'D;dd.mm.yyyy') || '-' || formatdate(:departure_date, 'D;dd.mm.yyyy') || '}';
    execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'GUEST_MOD_PERIOD', :action_text);
  end
end
^

/* Restore proc. body: RES_GUEST_SAVE_TYPESTAY$RSV */
ALTER PROCEDURE RES_GUEST_SAVE_TYPESTAY$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TYPE_STAY INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_type_stay integer;
  declare variable action_text varchar(255);
  declare variable guest_name varchar(50);
  declare variable old_type_stay varchar(50);
  declare variable new_type_stay varchar(50);
begin
/*  select G.TO_DATE - 1, G.ID_RESERV_DETAIL, GC.GUEST_NAME1
  from   GUEST G
         left outer join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
  where  G.ID_GUEST = :ID_GUEST
  into   :to_date, :id_reserv_detail, :guest_name;
  is_departure = iif(:TO_DATE = :FOR_DATE, 1, 0);

  select GS.ID_ROOM_TYPE, GS.ID_TARIFF, GS.ID_BOARD, GS.ID_TYPE_STAY
  from   GUEST_STAY GS
  where  GS.ID_GUEST = :ID_GUEST
         and GS.FOR_DATE = :FOR_DATE
  into   :id_tar_room_type, :id_tariff, :id_board, :old_id_type_stay;

  execute procedure RES_GUEST_DYNAMICPARAMS_SAVE(:id_reserv_detail, :id_guest, :for_date,
          :id_tar_room_type, :id_board, :id_type_stay, :id_tariff, :is_departure);
  */
  --
  update GUEST_STAY GS
  set    gs.ID_TYPE_STAY = :ID_TYPE_STAY
  where  gs.ID_GUEST = :ID_GUEST
         and gs.FOR_DATE = :FOR_DATE
  returning old.ID_TYPE_STAY
  into      :old_id_type_stay;

  if (:old_id_type_stay <> :id_type_stay) then begin
    select g.ID_RESERV_DETAIL, gc.GUEST_NAME1
    from   GUEST G
           left join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
    where  g.ID_GUEST = :ID_GUEST
    into   :id_reserv_detail, :guest_name;

    if (:old_id_type_stay = -1) then begin
      old_type_stay = '@{other.AUTO_TYPE_STAY}';
    end else begin
      select TS.TYPE_STAY
      from   TYPE_STAY TS
      where  TS.ID_TYPE_STAY = :old_id_type_stay
      into   :old_type_stay;
    end
    if (:ID_TYPE_STAY = -1) then begin
      new_type_stay = '@{other.AUTO_TYPE_STAY}';
    end else begin
      select TS.TYPE_STAY
      from   TYPE_STAY TS
      where  TS.ID_TYPE_STAY = :id_type_stay
      into   :new_type_stay;
    end
     
    action_text = f_character(29) || :guest_name
                  || f_character(28) || formatdate(:for_date, 'd;dd.mm.yyyy')
                  || f_character(28) || :new_type_stay
                  || f_character(28) || :old_type_stay;
    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'GUEST_DIFF_TYPESTAY', :action_text);
  end
end
^

/* Restore proc. body: RES_SAVE_ACCOUNTING$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
declare variable old_id_agent_profile integer;
  declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable action_text varchar(255);
  declare variable old_account_routing varchar(30);
  declare variable id_acc_profile integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:acc_routing, 'GUEST, AGENT, MIXED, OWNER, FULL_COMPLIMENTARY, PART_COMPLIMENTARY', 'Account routing');

  if (exists (select *
              from   PROFILE_HOUSE PH
              where  PH.ID_PROFILE = :id_agent_profile)) then
  begin
    exception BOOKING_EXCEPTION '-1016';
  end

  --execute procedure RESERV_TRACK_CHANGES$INT(:rd_dbkey);

  select RD.ID_AGENT_PROFILE, RD.ID_RESERV_DETAIL, RD.ACC_ROUTING
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_agent_profile, :id_reserv_detail, :old_account_routing;

  if (:ACC_ROUTING in ('AGENT','MIXED') and :ID_AGENT_ACCOUNT is not null) then begin
    select A.ID_PROFILE
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :ID_AGENT_ACCOUNT
    into   :id_acc_profile;
    -- check up agent account ownership
    if (:id_acc_profile is distinct from :ID_AGENT_PROFILE) then ID_AGENT_ACCOUNT = null;
  end

  update RESERV_DETAIL RD
  set    RD.ID_AGENT_ACCOUNT_RULE = :ID_AGENT_ACCOUNT,
         RD.ACC_ROUTING = :ACC_ROUTING,
         RD.ID_AGENT_PROFILE = :ID_AGENT_PROFILE,
         RD.ID_AGENT_PAYMENT = :ID_AGENT_PAYMENT,
         RD.ID_PERSON_PAYMENT = coalesce(:ID_PERSON_PAYMENT, RD.ID_PERSON_PAYMENT),
         RD.ID_GROUP = :ID_GROUP
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_id_agent_profile is distinct from :id_agent_profile) then begin
    execute procedure RES_SET_EDIT_STATUS$INT(:RD_DBKEY, 'AGENT', 'add');

    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :g_dbkey
    do begin
      execute procedure GUEST_AGENT_SET$INT(:g_dbkey, :id_agent_profile);
    end

    select f_character(29)||coalesce(old_A.PROFILE_NAME, '')||f_character(28)||coalesce(new_A.PROFILE_NAME, '')
    from   PROFILE old_A, PROFILE new_A
    where  old_A.ID_PROFILE = :old_id_agent_profile
           and new_A.ID_PROFILE = :ID_AGENT_PROFILE
    into   :action_text;

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_AGENT', :action_text);
  end

  if (:ACC_ROUTING <> :old_account_routing) then begin
    action_text = f_character(29) || coalesce(:old_account_routing, '')
                  || f_character(28) || coalesce(:acc_routing, '');

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_ACC_ROUTING', :action_text);
  end

  execute procedure RES_SAVE_ACCOUNTS$INT (:RD_DBKEY);
end
^

/* Restore proc. body: RES_SAVE_ACCOUNTS_FINALIZE$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTS_FINALIZE$INT(ID_RESERV_DETAIL INTEGER,
OLD_ID_BASE_ACCOUNT INTEGER,
OLD_ID_EXTRA_ACCOUNT INTEGER,
NEW_ID_BASE_ACCOUNT INTEGER,
NEW_ID_EXTRA_ACCOUNT INTEGER)
 AS
declare variable id_old_account integer;
  declare variable action_text varchar(255);
  declare variable acc_name varchar(50);
  declare variable is_used integer;
begin
  if (:NEW_ID_BASE_ACCOUNT is distinct from :OLD_ID_BASE_ACCOUNT) then begin
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :OLD_ID_BASE_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = F_CHARACTER(29) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:OLD_ID_BASE_ACCOUNT, '')  || ')';
    ACC_NAME = null;
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :NEW_ID_BASE_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = :ACTION_TEXT || F_CHARACTER(28) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:NEW_ID_BASE_ACCOUNT, '')  || ')';

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_MOD_BASE_ACCOUNT', :ACTION_TEXT);
  end

  ACTION_TEXT = '';
  ACC_NAME = null;
  if (:NEW_ID_EXTRA_ACCOUNT is distinct from :OLD_ID_EXTRA_ACCOUNT) then begin
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :OLD_ID_EXTRA_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = F_CHARACTER(29) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:OLD_ID_EXTRA_ACCOUNT, '')  || ')';
    ACC_NAME = null;
    select A.ACCOUNT_NAME
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :NEW_ID_EXTRA_ACCOUNT
    into   :ACC_NAME;
    ACTION_TEXT = :ACTION_TEXT || F_CHARACTER(28) || coalesce(:ACC_NAME, '') || ' (' || coalesce(:NEW_ID_EXTRA_ACCOUNT, '')  || ')';

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_MOD_EXTRA_ACCOUNT', :ACTION_TEXT);
  end

  -- Archivate old unused accounts
  for
    select A.ID_ACCOUNT
    from   ACCOUNT_S A
    where  A.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
           and A.IS_ARCHIVE = 0
           and A.ID_ACCOUNT <> :NEW_ID_BASE_ACCOUNT
           and A.ID_ACCOUNT <> :NEW_ID_EXTRA_ACCOUNT
           and A.IS_CREDIT_ACCOUNT = 0
           and not exists(select G.ID_GUEST
                          from   GUEST G
                          where  (G.ID_BASE_ACCOUNT = A.ID_ACCOUNT)
                                 or (G.ID_ACCOUNT = A.ID_ACCOUNT))
    into   :ID_OLD_ACCOUNT
  do begin
    select auc.is_used
    from   ACCOUNT_USE_CHECK$INT(:id_old_account) auc
    into   :is_used;

    if (:is_used = 0) then begin
      delete from ACCOUNT A
      where  a.ID_ACCOUNT = :id_old_account;
    end else if (not exists(select ap.ID_ACCOUNT_POST from account_post ap where ap.ID_ACCOUNT = :id_old_account and ap.IS_ANUL = 0)) then  begin
      -- archive only used accounts without valid postings
      execute procedure ACCOUNT_SET_ARCHIVE_STATUS (:ID_OLD_ACCOUNT, 1);
  
      when exception ACCOUNT_EXCEPTION do post_event 'dummy';
    end
  end 
end
^

/* Restore proc. body: RES_SAVE_BOARD$INT */
ALTER PROCEDURE RES_SAVE_BOARD$INT(RD_DBKEY CHAR(8),
ID_BOARD INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_guest integer;
  declare variable old_id_board integer;
  declare variable action_text varchar(255);
  declare variable old_board varchar(30);
  declare variable new_board varchar(30);
begin
  id_board = :ID_BOARD;
  select RD.ID_RESERV_DETAIL, RD.ID_BOARD, TH.NAME
  from   RESERV_DETAIL RD
         left outer join MEALS TH on TH.ID_BOARD = RD.ID_BOARD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail, :old_id_board, :old_board;

  update RESERV_DETAIL RD
  set    RD.ID_BOARD = :id_board,
         RD.HAS_DIFFERENT_BOARD = 0
  where  RD.RDB$DB_KEY = :rd_dbkey;

  for
    select G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_guest
  do begin
    update GUEST_STAY GS
    set    GS.ID_BOARD = :id_board
    where  GS.ID_GUEST = :id_guest;
  end

  execute procedure RES_GUESTDATA_INVALIDATE$INT(:rd_dbkey);

  if (:old_id_board is distinct from :id_board) then begin
    select TH.NAME
    from   MEALS TH
    where  TH.ID_BOARD = :id_board
    into   :new_board;

    action_text = f_character(29) || coalesce(:old_board, '') || f_character(28) || coalesce(:new_board, '');
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'BOARD_CHANGED', :action_text);
  end
end
^

/* Restore proc. body: RES_SAVE_GUARANTEE$RSV */
ALTER PROCEDURE RES_SAVE_GUARANTEE$RSV(ID_RESERV_DETAIL INTEGER,
IS_VIP SMALLINT,
CHECK_STATUS INTEGER,
ID_GUARANTEE_POLICY INTEGER,
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER)
 AS
declare variable old_check_status integer;
declare variable warn_code integer;
declare variable rd_dbkey char(8);
declare variable action_text varchar(255);
begin
  /*  Description:
  ||  GUI facade
  */
  select RD.RDB$DB_KEY, rd.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_check_status;

  update RESERV_DETAIL RDU
  set    RDU.IS_VIP = coalesce(:is_vip, RDU.IS_VIP),
         RDU.ID_GUARANTEE_POLICY = :id_guarantee_policy,
         RDU.GUARANTEE_DEPOSIT = :guarantee_deposit,
         RDU.GUARANTEE_CURRENCY = :guarantee_currency,
         RDU.BLOCK_CC = :BLOCK_CC,
         GUARANTEE_DEPOSIT_PERCENT = :GUARANTEE_DEPOSIT_PERCENT,
         GUARANTEE_DEPOSIT_NIGHTS = :GUARANTEE_DEPOSIT_NIGHTS,
         GUARANTEE_DUE_DAYS_BEF_ARRIVAL = :GUARANTEE_DUE_DAYS_BEF_ARRIVAL,
         GUARANTEE_DUE_DAYS_AFTER_CREATE = :GUARANTEE_DUE_DAYS_AFTER_CREATE
  where  RDU.RDB$DB_KEY = :rd_dbkey;

  action_text = '';
  if (:GUARANTEE_DEPOSIT_PERCENT is not null) then begin
    action_text = f_character(29) || '@{caption.guaranteetype.percent} ' || formatfloat(:GUARANTEE_DEPOSIT_PERCENT, '0.00') || f_character(28)
                  || '[' || coalesce(:GUARANTEE_DUE_DAYS_AFTER_CREATE, ' ') || ']'
                  || f_character(28) || '[' || coalesce(:GUARANTEE_DUE_DAYS_BEF_ARRIVAL, ' ') || ']';
  end
  else if (:GUARANTEE_DEPOSIT_NIGHTS is not null) then begin
    action_text = f_character(29) || '@{caption.guaranteetype.nights} ' || :GUARANTEE_DEPOSIT_NIGHTS || f_character(28)
                  || '[' || coalesce(:GUARANTEE_DUE_DAYS_AFTER_CREATE, ' ') || ']'
                  || f_character(28) || '[' || coalesce(:GUARANTEE_DUE_DAYS_BEF_ARRIVAL, ' ') || ']';
  end
  else if (:GUARANTEE_DEPOSIT is not null) then begin
    action_text = f_character(29) || '@{caption.guaranteetype.fixed} ' || formatfloat(:GUARANTEE_DEPOSIT, '0.00') || ' ' || :GUARANTEE_CURRENCY || f_character(28)
                  || '[' || coalesce(:GUARANTEE_DUE_DAYS_AFTER_CREATE, ' ') || ']'
                  || f_character(28) || '[' || coalesce(:GUARANTEE_DUE_DAYS_BEF_ARRIVAL, ' ') || ']';
  end

  if (:action_text <> '') then begin
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'RES_GUARANTEE_CHANGED', :action_text);
  end

  CHECK_STATUS = coalesce(:CHECK_STATUS, :old_check_status);
  if (:CHECK_STATUS <> :old_check_status) then begin

    if (:CHECK_STATUS >= 0) then exception BOOKING_EXCEPTION 'Can not set status ''CHECKED IN'' or ''CHECKED OUT'' manually!';

    execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, :check_status);

    execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
    returning_values  :warn_code;
  end
end
^

/* Restore proc. body: RES_SAVE_MARKETING$RSV */
ALTER PROCEDURE RES_SAVE_MARKETING$RSV(ID_RESERV_DETAIL INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable rd_dbkey char(8);
declare variable old_mrkt_profile varchar(255);
declare variable new_mrkt_profile varchar(255);
begin
  err_code = 0;
  err_text = '';
  rd_dbkey = null;
  select RD.RDB$DB_KEY, MP.MARKETING_PROFILE
  from   RESERV_DETAIL RD
         left outer join MARKETING_PROFILE_GET (RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_COME_REASON,
              RD.ID_NOM_HEAR_REASON, RD.ID_NOM_SOURCE_CODE, RD.ID_NOM_MARKET_SEGMENT) MP on 1=1
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_mrkt_profile;

  execute procedure RES_SAVE_MARKETING$INT(:rd_dbkey, :id_nom_market_segment,
          :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason);

  select MP.MARKETING_PROFILE
  from   MARKETING_PROFILE_GET (:ID_NOM_CHANNEL_CODE, :ID_NOM_COME_REASON,
              :ID_NOM_HEAR_REASON, :ID_NOM_SOURCE_CODE, :ID_NOM_MARKET_SEGMENT) MP
  into   :new_mrkt_profile;

  if (:new_mrkt_profile is distinct from :old_mrkt_profile) then begin
    --execute procedure RESERV_TRACK_CHANGES$INT (:rd_dbkey);

    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'MARKETING_CHANGE',
            f_character(29) || :old_mrkt_profile || f_character(28) || :new_mrkt_profile);
  end
end
^

/* Restore proc. body: RES_SAVE_PRICE$RSV */
ALTER PROCEDURE RES_SAVE_PRICE$RSV(ID_RESERV_DETAIL INTEGER,
FOR_DATE DATE,
PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3))
 AS
declare variable old_price numeric(14,4);
  declare variable old_price_currency char(3);
  declare variable action_text varchar(255);
begin
  select cp.PRICE, cp.PRICE_CURRENCY
  from   RESERV_CUSTOM_PRICE cp
  where  cp.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
         and cp.FOR_DATE = :FOR_DATE
  into   :old_price, :old_price_currency;

  if ((:old_price is distinct from :price) or (:old_price_currency is distinct from :price_currency) ) then begin
    execute procedure RES_SAVE_CUSTOM_PRICE$INT(:ID_RESERV_DETAIL, :FOR_DATE, :PRICE, :PRICE_CURRENCY);

    action_text = f_character(29) || formatfloat(:price, 'F;0.00') || ' ' || :price_currency || f_character(28) || formatdate(:for_date, 'D;dd.mm.yyyy') ;
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_MANUAL_PRICE', :action_text);
  end
end
^

/* Restore proc. body: RES_SAVE_RATE$INT */
ALTER PROCEDURE RES_SAVE_RATE$INT(RD_DBKEY CHAR(8),
ID_RATE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable g_dbkey char(8);
  declare variable id_guest integer;
  declare variable id_old_rate integer;
  declare variable action_text varchar(255);
begin
  select RD.ID_RESERV_DETAIL, rd.ID_RATE
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail, :id_old_rate;

  update RESERV_DETAIL RD
  set    RD.ID_RATE = :id_rate,
         RD.HAS_DIFFERENT_TARIFF = 0
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:ID_RATE is distinct from :id_old_rate) then begin
    select f_character(29) || t.TARIFA_NAME
    from   TARIFA T
    where  t.ID_TARIFA = :id_old_rate
    into   :action_text;

    select :action_text || f_character(28) || t.TARIFA_NAME
    from   TARIFA T
    where  t.ID_TARIFA = :ID_RATE
    into   :action_text;

    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_RATE_CHANGED', :action_text);
  end

  for
    select G.RDB$DB_KEY, G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :g_dbkey, :id_guest
  do begin
    update GUEST GU
    set    GU.ID_TARIFA = :id_rate
    where  GU.RDB$DB_KEY = :g_dbkey;

    update GUEST_STAY GS
    set    GS.ID_TARIFF = :id_rate
    where  GS.ID_GUEST = :id_guest;

    execute procedure RES_GUESTDATA_INVALIDATE$INT(:rd_dbkey);
  end
end
^

/* Restore proc. body: RES_SAVE_ROOM_LOG$INT */
ALTER PROCEDURE RES_SAVE_ROOM_LOG$INT(RD_DBKEY CHAR(8),
OLD_ID_ROOM INTEGER,
OLD_ID_RES_ROOM_TYPE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_res_room_type integer;
  declare variable id_room integer;
  declare variable check_status integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable system_date date;
begin

  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL, RD.ID_ROOM_TYPE, RD.ID_ROOM, RD.ID_HOTEL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :check_status, :id_reserv_detail, :id_res_room_type, :id_room, :id_hotel;

  /* LOG SECTION */
  action_text = f_character(29);
  if (:old_ID_RES_ROOM_TYPE is distinct from :ID_RES_ROOM_TYPE) then begin
    select :action_text || '<' || coalesce(rt.TYPE_ROOM, '') || '>'
    from   ROOM_TYPES rt
    where  rt.ID_ROOM_TYPE = :old_id_res_room_type
    into   :action_text;
    action_text = :action_text || f_character(28);
    select :action_text || '<' || coalesce(rt.TYPE_ROOM, '') || '>'
    from   ROOM_TYPES rt
    where  rt.ID_ROOM_TYPE = :ID_RES_ROOM_TYPE
    into   :action_text;
    action_text = :action_text || f_character(28);

    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_ROOM_TYPE_CHANGED', :action_text);
  end

  action_text = f_character(29);
  if (:old_id_room is distinct from :ID_ROOM) then begin
    select :action_text || '<' || coalesce(rt.TYPE_ROOM, '') || ' ' || coalesce (R.ROOM_NAME, '') || '>'
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :old_id_room
    into   :action_text;
    action_text = :action_text || f_character(28);

    select :action_text || '<' || coalesce(rt.TYPE_ROOM, '') || ' ' || coalesce (R.ROOM_NAME, '') || '>'
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :id_room
    into   :action_text;
    action_text = :action_text || f_character(28);

    if (:check_status >= 0) then begin
      execute procedure SYSTEM_DATE_GET (:id_hotel)
      returning_values :system_date;
      action_text = :action_text || f_character(28) || :system_date;
      execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'ROOM_MOVED', :action_text, :old_id_room);
    end else
      execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'ROOM_CHANGED', :action_text);
  end
  /*****/
end
^

/* Restore proc. body: RES_SAVE_STATUS$INT */
ALTER PROCEDURE RES_SAVE_STATUS$INT(RD_DBKEY CHAR(8),
CHECK_STATUS INTEGER,
CONFIRMATION_NUMBER TYPE OF NAME_20 = null)
 AS
declare variable old_check_status integer;
  declare variable id_reserv_detail integer;
  declare variable action_text varchar(255);
begin

  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_check_status, :id_reserv_detail;

  if (:old_check_status <> :check_status) then begin
    if (:old_check_status >= 0 and :CHECK_STATUS < :old_check_status) then begin
      exception BOOKING_EXCEPTION 'Can not downgrade status for checked in booking!';
    end

    if (:old_check_status < 0 and :CHECK_STATUS = 1) then begin
      exception BOOKING_EXCEPTION '-1006';
    end

    update RESERV_DETAIL RDU
    set    RDU.CHECK_STATUS = :check_status,
           RDU.CONFIRMATION_NUMBER = iif (:CHECK_STATUS = -1, strhash_large(rdu.NUMBER || 'CONFIRMATION'), rdu.CONFIRMATION_NUMBER)
    where  RDU.RDB$DB_KEY = :rd_dbkey;

    update ROOM_MAGIC RM
    set    rm.BUSY_TYPE = case when :CHECK_STATUS = '1' then 'CHECK_OUT'
                               when :CHECK_STATUS = '0' then 'CHECK_IN'
                               when :CHECK_STATUS = '-1' then 'VALUE_CONFIRMED'
                               when :CHECK_STATUS = '-2' then 'VALUE_NOTCONFIRMED'
                               when :CHECK_STATUS = '-3' then 'VALUE_RESERVS'
                               else rm.BUSY_TYPE
                          end
    where  rm.ID_RESERV_DETAIL = :id_reserv_detail;

    update ROOMS_SHARE Rs
    set    rs.BUSY_TYPE = case when :CHECK_STATUS = '1' then 'CHECK_OUT'
                               when :CHECK_STATUS = '0' then 'CHECK_IN'
                               when :CHECK_STATUS = '-1' then 'VALUE_CONFIRMED'
                               when :CHECK_STATUS = '-2' then 'VALUE_NOTCONFIRMED'
                               when :CHECK_STATUS = '-3' then 'VALUE_RESERVS'
                               else rs.BUSY_TYPE
                          end
    where  rs.ID_RESERV_STATISTICS = :id_reserv_detail;

    execute procedure RES_SET_EDIT_STATUS$INT (:rd_dbkey, 'STATUS', 'add');

    if (:CHECK_STATUS < 0) then begin
      action_text = f_character(29) || '@{booking.status.' || :old_check_status || '}'
                    || f_character(28) || '@{booking.status.' || :CHECK_STATUS || '}';
      execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_MOD_STATUS', :action_text);
    end
  end

  if (:CHECK_STATUS = -1 and :CONFIRMATION_NUMBER is not null) then begin
    -- override with incoming confirmation number
    update RESERV_DETAIL rd
    set    rd.CONFIRMATION_NUMBER = :CONFIRMATION_NUMBER
    where  rd.RDB$DB_KEY = :RD_DBKEY;
  end
end
^

/* Restore proc. body: RES_SAVE_STAY$INT */
ALTER PROCEDURE RES_SAVE_STAY$INT(RD_DBKEY CHAR(8),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER)
 AS
declare variable day_keep_types integer;
  declare variable exp_date date;
  declare variable leaving_kind integer;
  declare variable old_arrival date;
  declare variable old_departure date;
  declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable old_comming_kind integer;
  declare variable old_leaving_kind integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable is_stay_changed integer;
begin
  -- TODO exp_date must become input parameter, because the user may change it! or add exp_scheme!

  select RD.FROM_DATE, RD.TO_DATE, RD.COMMING_KIND, RD.LEAVING_KIND, RD.ID_HOTEL,
         rd.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_arrival, :old_departure, :old_comming_kind, :old_leaving_kind, :id_hotel,
         :id_reserv_detail;

  if (:DEPARTURE_DATE <= :ARRIVAL_DATE) then exception BOOKING_EXCEPTION '-53';

  execute procedure SETTING_GET_VALUE('DAY_KEEP_TYPES', :id_hotel)
  returning_values  :day_keep_types;

  exp_date = :arrival_date + :day_keep_types;
  leaving_kind = coalesce(:is_late_departure + 1, :old_leaving_kind);
  comming_kind = coalesce(:comming_kind, :old_comming_kind);
  /*
  if ((:arrival_date <> :old_arrival) or (:departure_date <> :old_departure)) then begin
    execute procedure RESERV_TRACK_CHANGES$INT (:RD_DBKEY);
  end
  */
  if ((:arrival_date <> :old_arrival)
      or (:departure_date <> :old_departure)
      or (:comming_kind <> :old_comming_kind)
      or (:leaving_kind <> :old_leaving_kind)) then is_stay_changed = 1;
  else is_stay_changed = 0;

  update RESERV_DETAIL RD
  set    RD.COMMING_KIND = :comming_kind,
         RD.LEAVING_KIND = :leaving_kind,
         RD.EXP_DATE = :exp_date,
         RD.FROM_DATE = :arrival_date,
         RD.TO_DATE = :departure_date,
         rd.ROOM_PRICE = iif(:is_stay_changed = 1, null, rd.ROOM_PRICE) -- force recalculation
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:is_stay_changed = 1) then begin
    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :g_dbkey
    do begin
      execute procedure RES_GUEST_SAVE_STAY$INT(:g_dbkey, :arrival_date, :departure_date, :id_hotel);
    end

    execute procedure RES_SET_EDIT_STATUS$INT (:RD_DBKEY, 'DATE_CHANGED');

    --Remove manual prices (if any) outer new period--/
    if (:old_arrival < :arrival_date) then
      delete from RESERV_CUSTOM_PRICE rcp
      where  rcp.id_reserv_detail = :id_reserv_detail
             and rcp.FOR_DATE < :arrival_date;

    if (:old_departure > :departure_date) then
      delete from RESERV_CUSTOM_PRICE rcp
      where  rcp.id_reserv_detail = :id_reserv_detail
             and RCP.FOR_DATE >= :departure_date;

    if (not exists (select * from RESERV_CUSTOM_PRICE rmp where rmp.id_reserv_detail = :id_reserv_detail)) then
        update RESERV_DETAIL set  has_different_price = 0 where id_reserv_detail = :id_reserv_detail;
    ----
  end

  if ((:old_arrival <> :arrival_date) or (:old_departure <> :departure_date) ) then begin
    action_text = f_character(29) || '{' || formatdate(:old_arrival, 'D;dd.mm.yyyy') || '-' || formatdate(:old_departure, 'D;dd.mm.yyyy') || '}'
                  || f_character(28) || '{' || formatdate(:arrival_date, 'D;dd.mm.yyyy') || '-' || formatdate(:departure_date, 'D;dd.mm.yyyy') || '}';
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_MOD_PERIOD', :action_text);
  end
end
^

/* Restore proc. body: RES_SAVE_VOUCHER$INT */
ALTER PROCEDURE RES_SAVE_VOUCHER$INT(RD_DBKEY CHAR(8),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE)
 AS
declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable action_text varchar(255);
begin

  update RESERV_DETAIL RD
  set    RD.VAUCHER_NUM = :voucher_num,
         RD.VAUCHER_DATE = :voucher_date,
         RD.VAUCHER_TEXT = :voucher_text,
         RD.VAUCHER_NUM2 = :voucher2_num,
         RD.VAUCHER_DATE2 = :voucher2_date,
         RD.HAS_DIFFERENT_VOUCHERS = 0
  where  RD.RDB$DB_KEY = :rd_dbkey
         and
         ((RD.VAUCHER_NUM is distinct from :voucher_num)
          or (RD.VAUCHER_DATE is distinct from :voucher_date)
          or (RD.VAUCHER_TEXT is distinct from :voucher_text)
          or (RD.VAUCHER_NUM2 is distinct from :voucher2_num)
          or (RD.VAUCHER_DATE2 is distinct from :voucher2_date)
          or (RD.HAS_DIFFERENT_VOUCHERS is distinct from 0)
         );

  if (row_count > 0) then begin
    select RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.RDB$DB_KEY = :rd_dbkey
    into   :id_reserv_detail;
  
    action_text = f_character(29)
                  || coalesce(:VOUCHER_NUM, '')
                  || iif(:VOUCHER_DATE is not null, '/' || formatdate(:VOUCHER_DATE, 'D;dd.mm.yyyy'), '')
                  || ' (2: ' || coalesce(:VOUCHER2_NUM, '')
                  || iif(:VOUCHER2_DATE is not null, '/' || formatdate(:VOUCHER2_DATE, 'D;dd.mm.yyyy'), '')
                  || ')';
  
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'VOUCHER_SET', :action_text);
  
    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :g_dbkey
    do begin
      execute procedure RES_GUEST_SAVE_VOUCHER$INT(:rd_dbkey, :g_dbkey, :voucher_num, :voucher_date,
              :voucher_text, :voucher2_num, :voucher2_date);
    end
  
    execute procedure RES_GUESTDATA_INVALIDATE$INT(:rd_dbkey);
  end
end
^

/* Restore proc. body: RES_SET_ROOM_MULTI$RSV */
ALTER PROCEDURE RES_SET_ROOM_MULTI$RSV(OPERATION VARCHAR(20),
FROM_ROOM VARCHAR(20),
SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable cnt_requested integer;
  declare variable cnt_old_room integer;
  declare variable cnt_found integer;
  declare variable is_already_planned integer;
  declare variable is_satisfied integer;
  declare variable new_id_room integer;
  declare variable current_id_room integer;
  declare variable id_res_room_type integer;
  declare variable room_requirements blob sub_type 1 segment size 100;
  declare variable from_date date;
  declare variable to_date date;
  declare variable action_text varchar(255);
  declare variable is_early_arrival smallint;
  declare variable is_late_departure smallint;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable id_reserv_detail integer;
  declare variable tmp_warn_code integer;
  declare variable min_beds integer;
  declare variable virtual_room varchar(10);
  declare variable share_err_text varchar(255);
begin
  /* offer_method :
  ||     0 - NUMBER desc,
  ||     1 - NUMBER asc,
  ||     2 - DAYS FREE(MAX OCCUPANCY),
  ||     3 - FILING FACTOR(EQUAL ROOM USAGE)
  */
  warn_code = null;

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'set_number_asc, set_number_desc, set_max_occupancy, set_max_usage');

  cnt_requested = 0;
  cnt_old_room = 0;
  cnt_found = 0;
  for
    select RD.RDB$DB_KEY, rd.ID_RESERV_DETAIL, rd.ID_ROOM, rd.VIRTUAL_ROOM, RD.ID_ROOM_TYPE, RD.ROOM_FEATURES,
           RD.FROM_DATE, RD.TO_DATE, iif(rd.COMMING_KIND = 0, 1, 0), iif(rd.LEAVING_KIND = 2, 1, 0),
           rd.ADULT_COUNT + rd.CHILD_COUNT
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
           and RD.IS_ANUL = 0
    into   :rd_dbkey, :id_reserv_detail, :current_id_room, :virtual_room, :id_res_room_type, :room_requirements,
           :from_date, :to_date, :is_early_arrival, :is_late_departure, :min_beds
  do begin
    cnt_requested = :cnt_requested + 1;
    new_id_room = null;
    if (:current_id_room < 0) then begin
      if (:virtual_room is not null) then begin
        -- has related bookings with shared virtual room
        -- get cumulative stay for all shared bookings
        select min(vrd.FROM_DATE), min(vrd.FROM_DATE) - min(vrd.FROM_DATE - iif(vrd.COMMING_KIND = 0, 1, 0)),
               max(vrd.TO_DATE), max(vrd.TO_DATE + iif(vrd.LEAVING_KIND = 2, 1, 0)) - max(vrd.TO_DATE),
               sum(vrd.ADULT_COUNT + vrd.CHILD_COUNT)
        from   RESERV_DETAIL VRD
        where  vrd.ID_ROOM = :current_id_room
               and vrd.IS_ANUL = 0
        into   :from_date, :is_early_arrival, :to_date, :is_late_departure, :min_beds;
      end
      -- from_date and to_date are arrival and departure date of reservation,
      -- not first and last accomodation dates !!! this is need to check early arrivals and late departures
      execute procedure ROOM_PICKUP$INT(:id_res_room_type, :from_date, :to_date,
              :is_early_arrival, :is_late_departure,:operation, :from_room, :room_requirements, :min_beds)
      returning_values  :new_id_room;  -- offered room

      if (:new_id_room is not null) then begin
        is_satisfied = 1;
        select R.ROOM_NAME
        from   ROOMS R
        where  r.ID_ROOM = :new_id_room
        into   :action_text;

        execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'ROOM_SET_AUTO', :action_text);

        execute procedure RES_SET_ROOM$INT (:rd_dbkey, :new_id_room, 'nrttAsIs')
        returning_values (:tmp_warn_code, :share_transaction_id, :share_err_code, :share_err_text);
        if (:share_err_code < 0) then exception BOOKING_EXCEPTION 'Unallowable share!!!';
        WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

        if (:virtual_room is not null) then begin
          -- distribute the same room to shared bookings
          execute procedure RES_SET_ROOM_CO_RENTERS$INT (:current_id_room, :new_id_room, :id_reserv_detail, 'nrttAsIs')
          returning_values (:tmp_warn_code, :share_transaction_id, :share_err_code, :share_err_text);
          if (:share_err_code < 0) then exception BOOKING_EXCEPTION 'Unallowable share!!!';
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
        end
      end

    end else begin
      is_already_planned = 1;
    end

    cnt_old_room = :cnt_old_room + :is_already_planned;
    cnt_found = :cnt_found + :is_satisfied;

    when exception BOOKING_EXCEPTION do begin
      -- nothing, skip this booking
    end
  end

  if ((:cnt_found + :cnt_old_room) < :cnt_requested) then begin
    execute procedure SYSTEM_WARNING_ADD(-3, f_character(29)||:cnt_found||f_character(28)||:cnt_requested)
    returning_values  :warn_code;
  end
end
^

/* Restore proc. body: RESERV_DETAIL_EXTERNAL_MOD$RSV */
ALTER PROCEDURE RESERV_DETAIL_EXTERNAL_MOD$RSV(ID_RESERV_DETAIL INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
LOCATOR VARCHAR(100))
 AS
BEGIN
  update RESERV_DETAIL_EXTERNAL
  set    MINIBAR_RIGHTS = :minibar_rights,
         PAYTV_RIGHTS = :paytv_rights,
         VIDEO_RIGHTS = :video_rights,
         NOPOST_PMS = :nopost_pms,
         PHONE_RIGHTS = :phone_rights,
         SEMINAR_CAHNNEL_RIGHTS = :seminar_cahnnel_rights,
         LOCATOR = :locator
  where  ID_RESERV_DETAIL = :id_reserv_detail;

  if (row_count = 0) then begin
    insert into RESERV_DETAIL_EXTERNAL (
        ID_RESERV_DETAIL,
        MINIBAR_RIGHTS,
        PAYTV_RIGHTS,
        VIDEO_RIGHTS,
        NOPOST_PMS,
        PHONE_RIGHTS,
        SEMINAR_CAHNNEL_RIGHTS,
        LOCATOR)
    values (
        :id_reserv_detail,
        :minibar_rights,
        :paytv_rights,
        :video_rights,
        :nopost_pms,
        :phone_rights,
        :seminar_cahnnel_rights,
        :locator);
  end

  execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RSV_EXT_DETAIL_CHNG', '');

END
^

/* Restore proc. body: RESERVS_EXPIRE$INT */
ALTER PROCEDURE RESERVS_EXPIRE$INT(CLEAR_TODATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable day_keep_number integer;
  declare variable rd_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable nouse integer;
  declare variable day_keep_types integer;
begin
  /*AA NA IONEA I?AAE I?EEE??AAIA -BF END WORK-*/
  execute procedure SETTING_GET_VALUE('DAY_KEEP_NUMBERS', :ID_HOTEL)
  returning_values  :day_keep_number;
  /*************************************************************/
  /*    REMOVE ROOM NUMBERS FROM EXPIRED RESERV DETAILS        */
  /*************************************************************/
  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.IS_ANUL = 0
           and RD.CHECK_STATUS < 0
           and RD.IS_VIP = 0
           and RD.ID_ROOM > 0
           and (RD.FROM_DATE <=  cast(:clear_todate - :day_keep_number as date))
    into   :rd_dbkey, :id_reserv_detail
  do begin
    execute procedure RES_ROOM_REMOVE$INT(:rd_dbkey)
    returning_values  :nouse;

    when any do begin
      -- nothing
    end
  end
  /*************************************************************/
  /*    EXPIRED NON VIP or VIP TYPES                           */
  /*************************************************************/
  execute procedure SETTING_GET_VALUE('DAY_KEEP_TYPES', :ID_HOTEL)
  returning_values  :day_keep_types;

  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.CHECK_STATUS < 0
           and RD.IS_ANUL = 0
           and RD.FROM_DATE <= cast(:clear_todate - :day_keep_types as date)
           and RD.IS_VIP = 0
    union
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.CHECK_STATUS < 0
           and RD.IS_ANUL = 0
           and RD.TO_DATE < :clear_todate
           and RD.IS_VIP = 1
    into   :rd_dbkey, :id_reserv_detail
  do begin
    execute procedure sys_dbg('res RESERVS_EXPIRE: id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

    execute procedure RES_ANUL_NOSHOW$INT(:rd_dbkey)
    returning_values  :nouse;

    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_NOSHOW', '');

    when any do begin
      -- nothing
    end
  end
end
^

/* Restore proc. body: RESGRP_SAVE_OTHER$INT */
ALTER PROCEDURE RESGRP_SAVE_OTHER$INT(RD_DBKEY CHAR(8),
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
ID_EATING_OBJECT TYPE OF ID_REF)
 AS
declare variable id_reserv_detail integer;
  declare variable g_dbkey char(8);
  declare variable old_code_first_food type of tfood_code;
  declare variable old_text_first_food varchar(50);
  declare variable text_first_food varchar(50);
  declare variable action_text varchar(255);
begin
  select RD.ID_RESERV_DETAIL, RD.CODE_FIRST_FOOD
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail, :old_code_first_food;

  update RESERV_DETAIL RD
  set    RD.HAS_DIFFERENT_OTHER = 0,
         RD.TRANSFER_IN_TIME = :transfer_in_time,
         RD.TRANSFER_IN_NOTE = :transfer_in_note,
         RD.TRANSFER_OUT_TIME = :transfer_out_time,
         RD.TRANSFER_OUT_NOTE = :transfer_out_note,
         RD.CODE_FIRST_FOOD = :code_first_food,
         rd.ID_EATING_OBJECT = :ID_EATING_OBJECT
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_code_first_food is distinct from :code_first_food) then begin
    old_text_first_food = cast(case
                              when :old_code_first_food = 'breakfast' then 'caption.breakfast'
                              when :old_code_first_food = 'lunch' then 'caption.launch'
                              when :old_code_first_food = 'dinner' then 'caption.dinner'
                              when :old_code_first_food = 'extrafood1' then 'caption.extrafood1'
                              when :old_code_first_food = 'extrafood2' then 'caption.extrafood2'
                              when :old_code_first_food = 'none' then 'caption.no_first_food'
                          end as varchar(50));
    text_first_food = cast(case
                              when :code_first_food = 'breakfast' then 'caption.breakfast'
                              when :code_first_food = 'lunch' then 'caption.launch'
                              when :code_first_food = 'dinner' then 'caption.dinner'
                              when :code_first_food = 'extrafood1' then 'caption.extrafood1'
                              when :code_first_food = 'extrafood2' then 'caption.extrafood2'
                              when :code_first_food = 'none' then 'caption.no_first_food'
                           end as varchar(50));
    action_text = f_character(29) || coalesce('@{' || :old_text_first_food || '}', '') ||
                  f_character(28) || coalesce('@{' || :text_first_food || '}', '');
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'FIRST_FOOD_CHANGED', :ACTION_TEXT);
  end

  for
    select G.RDB$DB_KEY
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :g_dbkey
  do begin
    execute procedure RES_GUEST_SAVE_OTHER$INT(:g_dbkey, :transfer_in_time, :transfer_in_note,
            :transfer_out_time, :transfer_out_note, :code_first_food);
  end
end
^

/* Restore proc. body: REVENUE_SUMMARY_REMAKE$SYS */
ALTER PROCEDURE REVENUE_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
STATISTIC_ONLY SMALLINT)
 AS
declare variable id_end_work integer;
declare variable ad_dbkey char(8);
declare variable id_service integer;
declare variable id_guest integer;
declare variable id_account integer;
declare variable revenue_group varchar(50);
declare variable revenue_account varchar(50);
declare variable revenue_sub_account varchar(50);
begin
  if (not exists (select h.ID_HOTEL
                  from   HOTEL H
                  where  h.ID_HOTEL = :ID_HOTEL)) then exception WRONG_VALUE 'Non-existing hotel!';

  if (:STATISTIC_ONLY = 1) then begin

    execute procedure REVENUE_STATISTIC_REMAKE$SYS (:ID_HOTEL, :FROM_DATE, :TO_DATE);

    execute procedure SYSTEM_LOG_ADD ('HOTEL', :id_hotel, 'REV_REGEN_PART',
                                      f_character(29) || formatdate(:from_date, 'D;dd/mm/yyyy') ||
                                      f_character(28) || formatdate(:to_date, 'D;dd/mm/yyyy'));
  end else begin
    for
      select ad.RDB$DB_KEY, ad.ID_SERVICE, ad.ID_GUEST, ad.ID_ACCOUNT
      from   ACCOUNT_DEBT AD
      where  AD.ID_HOTEL = :id_hotel
             and ad.DEBT_DATE between :FROM_DATE and :TO_DATE
      order by ad.DEBT_DATE asc, ad.ID_ACCOUNT_POST asc
      into   :ad_dbkey, :id_service, :id_guest, :id_account
    do begin
      select  S.REVENUE_GROUP, RA.REVENUE_ACCOUNT, RA.REVENUE_SUB_ACCOUNT
      from    ACCOUNT A
              left outer join SERVICES S on s.ID_SERVICE = :id_service
              left outer join GUEST G on G.ID_GUEST = :id_guest
              left outer join PROFILE_HOUSE PH on PH.ID_PROFILE = A.ID_PROFILE
              left outer join REVENUE_ACCOUNT_PARSE$INT (S.REVENUE_ACCOUNT, coalesce(G.ID_RESERV_DETAIL, A.ID_RESERV_DETAIL)) RA on 1=1
      where   a.ID_ACCOUNT = :id_account
              and PH.HOUSE_TYPE is distinct from 'hptComplimentary'
      into    :revenue_group, :revenue_account, :revenue_sub_account;
  
      update ACCOUNT_DEBT d
      set    d.REVENUE_GROUP = :revenue_group,
             d.REVENUE_ACCOUNT = :revenue_account,
             d.REVENUE_SUB_ACCOUNT = :revenue_sub_account
             -- TODO - revenue deduction tax recalc ???
      where  d.RDB$DB_KEY = :ad_dbkey;
    end
  
  
    for
      select se.ID_END_WORK
      from   SUMMARY_END_WORK SE
      where  se.ID_HOTEL = :ID_HOTEL
             and se.SUMMARY_DATE between :FROM_DATE and :TO_DATE
      order by se.ID_END_WORK
      into   :id_end_work
    do begin
  
      update SUMMARY_END_WORK s
      set    s.REVENUE_AMOUNT = 0,
             s.CORRECTION_AMOUNT = 0,
             s.VAT_AMOUNT = 0
      where  s.ID_END_WORK = :id_end_work;
  
      execute procedure REVENUE_EW_SUMMARIZE$INT (:id_end_work, 'full');
    end

    execute procedure SYSTEM_LOG_ADD ('HOTEL', :id_hotel, 'REV_REGEN_FULL',
                                      f_character(29) || formatdate(:from_date, 'D;dd/mm/yyyy') || f_character(28) ||
                                      formatdate(:to_date, 'D;dd/mm/yyyy'));
  end
end
^

/* Restore proc. body: RIGHTS_GROUP_MODIFY */
ALTER PROCEDURE RIGHTS_GROUP_MODIFY(ID_RIGHT_GROUP INTEGER,
GROUP_NAME VARCHAR(20),
GROUP_DESCRIPTION VARCHAR(100),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_RIGHT_GROUP INTEGER)
 AS
declare variable old_name varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation = 'add') then begin
    if ((:id_right_group is null) or (:id_right_group <= -1))  then
      new_id_right_group = gen_id(ID_RIGHT_GROUP_GEN, 1);
    else new_id_right_group = :id_right_group;

    insert into RIGHTS_GROUPS (ID_RIGHT_GROUP, GROUP_NAME, GROUP_DESCRIPTION)
    values (:new_id_right_group, :group_name , :group_description);
  end else if (:operation = 'mod') then begin
    select G.GROUP_NAME
    from   RIGHTS_GROUPS G
    where  G.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
    into   :old_name;

    update RIGHTS_GROUPS UG
    set    UG.GROUP_NAME  = :group_name,
           UG.GROUP_DESCRIPTION = :group_description
    where  UG.ID_RIGHT_GROUP = :id_right_group;

    if (:old_name <> :GROUP_NAME) then begin
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'GROUP_EDIT',
              f_character(29) || :old_name || f_character(28) || :GROUP_NAME);
    end
  end else if (:operation = 'del') then begin
    delete from RIGHTS_GROUPS
    where ID_RIGHT_GROUP = :id_right_group;
    delete from RIGHTS_USER_GROUPS
    where ID_RIGHT_GROUP = :id_right_group;
  end
end
^

/* Restore proc. body: RIGHTS_GROUP_REPORTS_MODIFY */
ALTER PROCEDURE RIGHTS_GROUP_REPORTS_MODIFY(ID_RIGHT_GROUP INTEGER,
REPORT_NAME VARCHAR(200),
OPERATION VARCHAR(20))
 AS
declare variable right_group varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'grant, revoke');

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS rg
  where  rg.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'grant') then begin
    if (not exists (
      select *
      from   RIGHTS_GROUPS_REPORTS RGR
      where  RGR.ID_RIGHT_GROUP = :id_right_group
             and RGR.REPORT_NAME = :report_name)
    ) then begin
      insert into RIGHTS_GROUPS_REPORTS (ID_RIGHT_GROUP, REPORT_NAME)
      values (:id_right_group, :report_name);

      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'RIGHT_GRANT',
              f_character(29) || :REPORT_NAME || f_character(28) || :right_group);

    end
  end else if (:operation = 'revoke') then begin
    delete from RIGHTS_GROUPS_REPORTS RGR
    where  RGR.ID_RIGHT_GROUP = :id_right_group
           and  RGR.REPORT_NAME = :report_name;

    if (row_count = 1) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'RIGHT_REVOKE',
              f_character(29) || :REPORT_NAME || f_character(28) || :right_group);
  end
end
^

/* Restore proc. body: RIGHTS_GROUP_RIGHTS_MODIFY */
ALTER PROCEDURE RIGHTS_GROUP_RIGHTS_MODIFY(ID_RIGHT_GROUP INTEGER,
RIGHT_CODE VARCHAR(30),
VALUE_CODE INTEGER,
OPERATION VARCHAR(20))
 AS
declare variable right_descr varchar(255);
declare variable right_group varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'grant, revoke');

  right_descr = '@{right.name.' || :right_code || '}';

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS RG
  where  RG.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'grant') then begin
    --if (:value_code <> 0) then exception WRONG_VALUE 'rightType is rtPlain but value_code <> 0';

    if (not exists (select *
                    from   RIGHTS_GROUPS_LINES RGL
                    where  RGL.ID_RIGHT_GROUP = :id_right_group
                           and RGL.RIGHT_CODE = :right_code)) then
    begin
      insert into RIGHTS_GROUPS_LINES (ID_RIGHT_GROUP, RIGHT_CODE)
      values (:id_right_group, :right_code);

      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'RIGHT_GRANT',
              f_character(29) || :right_descr || f_character(28) || :right_group);
    end

  end else if (:operation = 'revoke') then begin
    delete from RIGHTS_GROUPS_LINES RGL
    where  RGL.ID_RIGHT_GROUP = :id_right_group
           and RGL.RIGHT_CODE = :right_code;

    if (row_count > 0) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'RIGHT_REVOKE',
              f_character(29) || :right_descr || f_character(28) || :right_group);
  end
end
^

/* Restore proc. body: RIGHTS_GROUP_USER_MODIFY */
ALTER PROCEDURE RIGHTS_GROUP_USER_MODIFY(USER_NAME VARCHAR(30),
ID_RIGHT_GROUP INTEGER,
OPERATION VARCHAR(50))
 AS
declare variable right_group varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add,del');

  if (:USER_NAME = 'SYSDBA') then exit;

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS RG
  where  RG.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'add') then begin
    insert into RIGHTS_USER_GROUPS (USER_NAME, ID_RIGHT_GROUP)
    values (:user_name, :id_right_group);

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_ADDED',
            f_character(29) || :USER_NAME  || f_character(28) || :right_group);

  end else begin
    delete from RIGHTS_USER_GROUPS
    where USER_NAME = :user_name
          and ID_RIGHT_GROUP = :id_right_group;

    if (row_count > 0) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_REMOVED',
              f_character(29) || :USER_NAME || f_character(28) || :right_group);

  end

  when sqlcode -803 do begin
    /* ERR_TEXT = '       ! ' ;*/
    exit;
  end
end
^

/* Restore proc. body: RIGHTS_MODIFY_USER */
ALTER PROCEDURE RIGHTS_MODIFY_USER(IN_USER_NAME VARCHAR(30),
IN_USER_NAME_LONG VARCHAR(30),
IN_NEW_PASSWORD VARCHAR(8),
LANG_UI VARCHAR(10),
FISCAL_ID INTEGER,
IS_ACTIVE INTEGER,
OPERATION VARCHAR(20),
CODE VARCHAR(50))
 AS
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod');

  if (:operation = 'add') then begin
    insert into RIGHTS_USERS (USER_NAME, USER_NAME_LONG, USER_PASSWORD, FISCAL_ID, LANG_UI, IS_ACTIVE, CODE)
    values (:in_user_name, :in_user_name_long, :in_new_password, :fiscal_id, :lang_ui, :is_active, :code);

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_NEW', f_character(29) || :IN_USER_NAME);
  end else if (:operation = 'mod') then begin
    update RIGHTS_USERS U
    set    U.USER_PASSWORD  = :in_new_password,
           U.USER_NAME_LONG = :in_user_name_long,
           U.LANG_UI = :lang_ui,
           U.IS_ACTIVE = :is_active,
           U.FISCAL_ID = :fiscal_id,
           U.code = :code
    where  U.USER_NAME = :in_user_name;

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_MODIFY', f_character(29) || :IN_USER_NAME);
  end/* else if (:operation = 'del') then begin

    delete from RIGHTS_USERS
    where USER_NAME = :in_user_name;

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_DEL', f_character(29) || :IN_USER_NAME);
  end*/ -- deletion is restricted

  when sqlcode -803 do begin
    exception ASSERT '-87';
  end
end
^

/* Restore proc. body: ROOM_CONTRACT_MODIFY$PMS */
ALTER PROCEDURE ROOM_CONTRACT_MODIFY$PMS(ID_ROOM_CONTRACT INTEGER,
ID_ROOM_PERIOD INTEGER,
CONTRACT_TYPE VARCHAR(50),
PMS_MARKERS BLOB SUB_TYPE 1 SEGMENT SIZE 100,
IMPORT_INCOME_WITH_VAT SMALLINT,
ID_RENTAL_POOL INTEGER,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_CONTRACT INTEGER)
 AS
declare variable permissible_value_list varchar(255);
  declare variable from_date date;
  declare variable rental_pool_unit_name varchar(100);
  declare variable room_name varchar(10);
  declare variable old_contract_type varchar(50);
  declare variable old_import_income_with_vat smallint;
  declare variable old_from_date date;
  declare variable old_rental_pool_unit_name varchar(100);
  declare variable old_room_name varchar(10);
  declare variable old_id_room_period integer;
  declare variable id_room integer;
  declare variable action_text varchar(255);
  declare variable no_use varchar(255);
begin

  permissible_value_list = '';
  select list(trim(S.KEY_))
  from   SYSTEM_ENUM S
  where  S.GROUP_ = 'pms.contract_type'
  into   :permissible_value_list;

  if (:operation in ('add', 'mod')) then begin
    execute procedure SYSTEM_CHECK_OPERATION(:contract_type, :permissible_value_list, 'contract type');

    select PRO.PROFILE_NAME
    from   PROFILE PRO
    where  PRO.ID_PROFILE = :ID_RENTAL_POOL
    into   :rental_pool_unit_name;

    select ROO.ROOM_NAME, RPP.FROM_DATE
    from   ROOM_PERIOD$PMS RPP
           join ROOMS ROO on ROO.ID_ROOM = RPP.ID_ROOM
    where  RPP.ID_ROOM_PERIOD = :ID_ROOM_PERIOD
    into   :room_name, :from_date;
  end

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');
  NEW_ID_ROOM_CONTRACT = :id_room_contract;

  if (:operation = 'add') then begin
    if (coalesce(:ID_ROOM_CONTRACT, -1) < 0) then begin
      NEW_ID_ROOM_CONTRACT = gen_id(GEN_ROOM_CONTRACT$PMS_ID, 1);
      ID_ROOM_CONTRACT = :NEW_ID_ROOM_CONTRACT;
    end
    else
      NEW_ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT;

    insert into ROOM_CONTRACT$PMS (ID_ROOM_CONTRACT, ID_ROOM_PERIOD,
           CONTRACT_TYPE, PMS_MARKERS, IMPORT_INCOME_WITH_VAT, ID_RENTAL_POOL)
    values (:NEW_ID_ROOM_CONTRACT, :ID_ROOM_PERIOD,
           :CONTRACT_TYPE, :PMS_MARKERS, :IMPORT_INCOME_WITH_VAT, :ID_RENTAL_POOL);

    action_text = substring(f_character(29) || '@{pms.contract_type.' || :contract_type || '}' || f_character(28) ||
                  formatdate(:from_date, 'D;dd.mm.yyyy') ||
                  f_character(28) || :room_name || f_character(28) || coalesce(:rental_pool_unit_name, ' ') || f_character(28)
                  || coalesce(:import_income_with_vat, 0) from 1 for 255);
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_ADDED', :ACTION_TEXT);

  end else begin
    select RC.CONTRACT_TYPE, RC.IMPORT_INCOME_WITH_VAT,
           RO.ROOM_NAME, PR.PROFILE_NAME, RP.FROM_DATE, RC.ID_ROOM_PERIOD, RP.ID_ROOM
    from   ROOM_CONTRACT$PMS RC
           join ROOM_PERIOD$PMS RP on RP.ID_ROOM_PERIOD = RC.ID_ROOM_PERIOD
           join ROOMS RO on RO.ID_ROOM = RP.ID_ROOM
           left outer join PROFILE PR on PR.ID_PROFILE = RC.ID_RENTAL_POOL
    where  RC.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
    into   :old_contract_type, :old_import_income_with_vat,
           :old_room_name, :old_rental_pool_unit_name, :old_from_date, :old_id_room_period, :id_room;

    if (:operation = 'mod') then begin
      update ROOM_CONTRACT$PMS
      set    CONTRACT_TYPE = :CONTRACT_TYPE,
             PMS_MARKERS = :PMS_MARKERS,
             IMPORT_INCOME_WITH_VAT = :IMPORT_INCOME_WITH_VAT,
             ID_RENTAL_POOL = :ID_RENTAL_POOL
      where (ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT);

      if ((:contract_type <> :old_contract_type) or (:import_income_with_vat <> :old_import_income_with_vat) or
         (coalesce(:rental_pool_unit_name, ' ') <> coalesce(:old_rental_pool_unit_name, ' ')) or
         (:from_date <> :old_from_date) or (:room_name <> :old_room_name)) then begin
        action_text = substring(f_character(29) || '@{pms.contract_type.' || :old_contract_type || '}' || f_character(28) ||
                      formatdate(:old_from_date, 'D;dd.mm.yyyy') ||
                      f_character(28) || :old_room_name ||
                      f_character(28) || coalesce(:old_rental_pool_unit_name, ' ') || f_character(28) || coalesce(:old_import_income_with_vat, 0) ||
                      f_character(28) || '@{pms.contract_type.' || :contract_type || '}' || f_character(28) || formatdate(:from_date, 'D;dd.mm.yyyy') ||
                      f_character(28) || :room_name || f_character(28) || coalesce(:rental_pool_unit_name, ' ') || f_character(28)
                      || coalesce(:import_income_with_vat, 0) from 1 for 255);
        execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_CHANGED', :ACTION_TEXT);
      end

    end

    if (:operation = 'del') then begin
      action_text = substring(f_character(29) || '@{pms.contract_type.' || :old_contract_type || '}' || f_character(28) ||
                    formatdate(:old_from_date, 'D;dd.mm.yyyy') ||
                    f_character(28) || :old_room_name || f_character(28) || coalesce(:old_rental_pool_unit_name, ' ') || f_character(28)
                    || coalesce(:old_import_income_with_vat, 0) from 1 for 255);
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTRACT_REMOVED', :ACTION_TEXT);

      delete from ROOM_CONTRACT$PMS where (ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT);

      execute procedure ROOM_PERIOD_MODIFY$PMS (:OLD_ID_ROOM_PERIOD, :id_room,  :old_from_date,
              iif(:contract_type in ('PRIVATE_USE'), 'PRIVATE', 'CONTRACT'),  'del')
      returning_values :no_use;
    end
  end
end
^

/* Restore proc. body: ROOM_MODIFY$PMS */
ALTER PROCEDURE ROOM_MODIFY$PMS(ID_ROOM INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_NAME VARCHAR(10),
FLOOR INTEGER,
BEDS INTEGER,
EXTRA_BEDS INTEGER,
SECTOR INTEGER,
SORT_ORDER INTEGER,
FEATURES BLOB SUB_TYPE 1 SEGMENT SIZE 100,
EXTERNAL_NAME VARCHAR(20),
ID_EATING_OBJECT TYPE OF ID_REF,
OPERATION VARCHAR(20))
 RETURNS(OVERRULE_NEED SMALLINT,
OVERRULE_CONTEXT VARCHAR(255),
NEW_ID_ROOM INTEGER)
 AS
declare variable old_id_room_type integer;
  declare variable old_room_name varchar(10);
  declare variable rebuild_id_hotel integer;
  declare variable rebuild_id_room_type integer;
  declare variable no_use varchar(20);
  declare variable old_capacity integer;
  declare variable sys_date date;
  declare variable action_text varchar(255);
  declare variable old_floor integer;
  declare variable old_sector integer;
  declare variable old_extra_beds integer;
  declare variable id_hotel integer;
begin
  overrule_need = 0;
  overrule_context = '';
  new_id_room = null;
  --if OVERRULE_NEED = 1 then OVERRULE_CONTEXT = ERR_TEXT like ERR_CODE = -9
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    if (coalesce(:room_name, '') = '') then
      exception ASSERT '-119';

    if ((:room_name containing '<') or (:room_name containing '>') or (:room_name starting with 'i')) then
      exception ASSERT '-120';
  end

  room_name = upper(:room_name);

  if (:operation='mod') then begin
    select R.ROOM_NAME, R.ID_ROOM_TYPE, R.BEDS+R.EXTRA_BEDS, r.floor, r.sector, r.extra_beds
    from   ROOMS R
           join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
    where  R.ID_ROOM = :id_room
    into   :old_room_name, :old_id_room_type, :old_capacity, :old_floor, :old_sector, :old_extra_beds;

    if (:id_room_type <> :old_id_room_type) then begin
      exception OCCUPANCY_EXCEPTION '-65';
    end

    new_id_room = :id_room;
    execute procedure ROOM_CAPACITY_CHECK$INT(:NEW_ID_ROOM, :ROOM_NAME, :old_capacity, :BEDS + :EXTRA_BEDS)
    returning_values (:OVERRULE_NEED, :OVERRULE_CONTEXT);

    update ROOMS RU
    set    RU.ID_ROOM_TYPE = :id_room_type,
           RU.ROOM_NAME = :room_name,
           RU.FLOOR = :floor,
           RU.BEDS = :beds,
           RU.EXTRA_BEDS = :extra_beds,
           RU.SECTOR = :sector,
           RU.FEATURES = :features,
           RU.SORT_ORDER = :sort_order,
           RU.EXTERNAL_NAME = :external_name,
           RU.ID_EATING_OBJECT = :ID_EATING_OBJECT
    where  RU.ID_ROOM = :id_room;

    if ((:room_name <> :old_room_name)
        or (:floor <> :old_floor)
        or (:sector <> :old_sector)
        or (:extra_beds <> :old_extra_beds)) then
    begin
      action_text = f_character(29) || '(' || :old_room_name || '/' || :old_floor || '/' || :old_sector || '/'
                    || :old_extra_beds || ')' || f_character(28) || '(' || :room_name || '/' || :floor || '/'
                    || :sector || '/' || :extra_beds || ')';
      execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_PARAMS_CHANGED', :action_text);
    end

    if (:room_name <> :old_room_name) then begin
      update ACCOUNT_POST AP
      set    AP.ROOM_NAME = :room_name
      where  AP.ROOM_NAME = :old_room_name;
    end

  end else if (:operation = 'add') then begin
    select rt.ID_HOTEL
    from   ROOM_TYPES RT
    where  rt.ID_ROOM_TYPE = :ID_ROOM_TYPE
    into   :id_hotel;

    insert into ROOMS (
      ID_ROOM, ID_ROOM_TYPE, ROOM_NAME, FLOOR, BEDS, EXTRA_BEDS, SECTOR,
      FEATURES, SORT_ORDER, ID_HOTEL, EXTERNAL_NAME, ID_EATING_OBJECT)
    values (gen_id(ID_ROOM_GEN, 1), :id_room_type, :room_name, :floor, :beds, :extra_beds, :sector,
      :features, :sort_order, :id_hotel, :external_name, :ID_EATING_OBJECT)
    returning ID_ROOM into :NEW_ID_ROOM;

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :sys_date;

    execute procedure ROOM_PERIOD_MODIFY$PMS(null, :new_id_room, :sys_date, 'HOTEL', 'add')
    returning_values  :no_use;

    insert into ROOMS_ADD (ID_ROOM, PMS_MARKERS, ADDRESS)
    values (:new_id_room, null, null);
  end else if (:operation = 'del') then begin
    -- Booked rooms are preserved with FK constraint on room_magic
    execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'DELETE', '');

    select RT.ID_ROOM_TYPE, RT.ID_HOTEL
    from   ROOM_TYPES RT
    where  RT.ID_ROOM_TYPE = :id_room_type
    into   :rebuild_id_room_type, :rebuild_id_hotel;

    delete from ROOMS where ID_ROOM = :id_room;

    execute procedure ALLOTMENT_PHYS_REBUILD$INT(:rebuild_id_hotel, :rebuild_id_room_type);

    when sqlcode -530 do begin
      -- Violation of FOREIGN KEY constraint "%s" on table "%s"
      exception ASSERT '-34';
    end
  end
end
^

/* Restore proc. body: ROOM_OWNER_MODIFY$PMS */
ALTER PROCEDURE ROOM_OWNER_MODIFY$PMS(ID_ROOM_OWNER INTEGER,
ID_ROOM_CONTRACT INTEGER,
ID_OWNER INTEGER,
OWNERSHIP_PERCENT NUMERIC(15,4),
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_ROOM_OWNER INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_hotel integer;
  declare variable id_acc_template_pms integer;
  declare variable id_currency varchar(3);
  declare variable owner_name varchar(100);
  declare variable old_owner_name varchar(100);
  declare variable old_ownership_percent NUMERIC(15,4);
  declare variable old_id_room_contract integer;
  declare variable action_text varchar(255);
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');
  new_id_room_owner = :id_room_owner;

  if ( (:operation in ('add', 'mod')) and (not exists ( select * from OWNER$PMS P where P.ID_OWNER = :ID_OWNER ) )) then begin
    exception PMS_EXCEPTION '-610';
    exit;
  end

  select RT.ID_HOTEL
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS RP on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
         join ROOMS R on RP.ID_ROOM = R.ID_ROOM
         join ROOM_TYPES RT on R.ID_ROOM_TYPE = RT.ID_ROOM_TYPE
  where  RC.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
  into   :id_hotel;

  if (:operation not in ('add')) then begin
    select coalesce(PR.PROFILE_NAME, ' '), RO.OWNERSHIP_PERCENT, RO.ID_ROOM_CONTRACT
    from ROOM_OWNER$PMS RO
      left outer join PROFILE PR ON PR.ID_PROFILE = RO.ID_OWNER
    where RO.ID_ROOM_OWNER = :ID_ROOM_OWNER
    into :old_owner_name, :old_ownership_percent, :old_id_room_contract;
  end

  select PRO.PROFILE_NAME
  from PROFILE PRO
    where PRO.ID_PROFILE = :ID_OWNER
  into :owner_name;

  if (:operation in ('add', 'mod')) then begin
    if (coalesce(:OWNERSHIP_PERCENT, 0) <= 0) then begin
      exception PMS_EXCEPTION '-611';
      exit;
    end
  end

  if (:operation = 'add') then begin
    if (coalesce(:ID_ROOM_OWNER, -1) < 0) then
         NEW_ID_ROOM_OWNER = gen_id(GEN_ROOM_OWNER$PMS_ID, 1);
    else NEW_ID_ROOM_OWNER = :ID_ROOM_OWNER;

    insert into ROOM_OWNER$PMS (ID_ROOM_OWNER, ID_ROOM_CONTRACT, ID_OWNER, OWNERSHIP_PERCENT)
    values (:NEW_ID_ROOM_OWNER, :ID_ROOM_CONTRACT, :ID_OWNER, :OWNERSHIP_PERCENT);

    action_text = f_character(29) || :owner_name || f_character(28) || formatfloat(:ownership_percent, '0.00');
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_OWNER_ADDED', :ACTION_TEXT);

    if (not exists ( select *
                     from   ACCOUNT A
                     where  A.IS_PMS_ACCOUNT = 1
                            and A.ID_HOTEL = :id_hotel
                            and A.ID_PROFILE = :ID_OWNER ))
    then begin
      select O.ID_ACC_TEMPLATE_PMS, O.ID_CURRENCY
      from   OWNER$PMS O
      where  O.ID_OWNER = :ID_OWNER
      into   :id_acc_template_pms, :id_currency;

      execute procedure ACCOUNT_CREATE_PMS$PMS(:ID_OWNER, :ID_ACC_TEMPLATE_PMS,
              :ID_CURRENCY, :ID_HOTEL)
      returning_values (:dbg);
    end

    when sqlcode -803 do begin
      exception PMS_EXCEPTION '-1057';
      exit;
    end

  end else if (:operation = 'mod') then begin
    if (not exists ( select *
                     from   ROOM_OWNER$PMS R
                     where  R.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
                            and R.ID_OWNER = :ID_OWNER ))
    then begin /* smenen e sobstwenik */
      if (not exists ( select *
                       from   ACCOUNT A
                       where  A.IS_PMS_ACCOUNT = 1
                              and A.ID_HOTEL = :id_hotel
                              and A.ID_PROFILE = :ID_OWNER ))
      then begin
        select O.ID_ACC_TEMPLATE_PMS, O.ID_CURRENCY
        from   OWNER$PMS O
        where  O.ID_OWNER = :ID_OWNER
        into   :id_acc_template_pms, :id_currency;
  
        execute procedure ACCOUNT_CREATE_PMS$PMS(:ID_OWNER, :ID_ACC_TEMPLATE_PMS,
                :ID_CURRENCY, :ID_HOTEL)
        returning_values (:dbg);
      end
    end

    update ROOM_OWNER$PMS
    set ID_OWNER = :ID_OWNER,
        OWNERSHIP_PERCENT = :OWNERSHIP_PERCENT
    where (ID_ROOM_OWNER = :ID_ROOM_OWNER);

    if ((:old_owner_name <> :owner_name) or (:old_ownership_percent <> :ownership_percent)) then begin
      action_text = f_character(29) || :old_owner_name || f_character(28) || formatfloat(:old_ownership_percent, '0.00') ||
                    f_character(28) || :owner_name || f_character(28) || formatfloat(:ownership_percent, '0.00');
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_OWNER_CHANGED', :ACTION_TEXT);
    end
  end else if (:operation = 'del') then begin
    action_text = f_character(29) || :old_owner_name || f_character(28) || formatfloat(:old_ownership_percent, '0.00');
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :OLD_ID_ROOM_CONTRACT, 'ROOM_OWNER_REMOVED', :ACTION_TEXT);

    delete from ROOM_OWNER$PMS
    where (ID_ROOM_OWNER = :ID_ROOM_OWNER);
  end
end
^

/* Restore proc. body: ROOM_PERIOD_ADD$INT */
ALTER PROCEDURE ROOM_PERIOD_ADD$INT(ID_ROOM_PERIOD INTEGER,
ID_ROOM INTEGER,
FROM_DATE DATE,
STATUS VARCHAR(30))
 RETURNS(NEW_ID_ROOM_PERIOD INTEGER)
 AS
declare variable action_text varchar(255);
  declare variable to_date date;
  declare variable prev_period_status varchar(30);
begin
  new_id_room_period = :id_room_period;

  if (exists (select *
              from   ROOM_PERIOD$PMS R
              where  R.ID_ROOM = :ID_ROOM
                     and R.FROM_DATE = :FROM_DATE)) then exception PMS_EXCEPTION '-612';

  if (coalesce(:id_room_period, 0) <= 0) then new_id_room_period = gen_id(GEN_ROOM_PERIOD$PMS_ID,1);
  else new_id_room_period = :id_room_period;

  select first 1 rpm.status, rpm.TO_DATE
  from   ROOM_PERIOD$PMS rpm
  where  rpm.id_room = :id_room
         and rpm.from_date < :from_date
  order by rpm.from_date desc
  into   :prev_period_status, :to_date;

  execute procedure ROOM_STATUS_CHECK$INT (:ID_ROOM, :FROM_DATE, :to_date, :prev_period_status, :status);

  insert into ROOM_PERIOD$PMS (ID_ROOM_PERIOD, ID_ROOM, FROM_DATE, STATUS)
  values (:new_id_room_period, :id_room, :from_date, :status);

  execute procedure ROOM_PERIOD_TODATE$INT(:id_room);

  action_text = f_character(29) || '@{period_room_status.'||:status||'}' || f_character(28) || formatdate(:from_date, 'dd.mm.yyyy')
                || f_character(28) || iif(extract(year from :to_date) = 2500, '~', formatdate(:to_date, 'dd.mm.yyyy'));
  execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_STATUS_ADDED', :action_text);

end
^

/* Restore proc. body: ROOM_PERIOD_DEL$INT */
ALTER PROCEDURE ROOM_PERIOD_DEL$INT(ID_ROOM_PERIOD INTEGER)
 AS
declare variable id_room integer;
  declare variable status varchar(30);
  declare variable from_date date;
  declare variable id_account_post integer;
  declare variable id_pms_event integer;
  declare variable action_text varchar(255);
  declare variable to_date date;
  declare variable prev_period_status varchar(30);
begin
  select R.STATUS, R.FROM_DATE, R.ID_ROOM, R.TO_DATE
  from   ROOM_PERIOD$PMS R
  where  R.ID_ROOM_PERIOD = :id_room_period
  into   :status, :from_date, :id_room, :to_date;

  if (singular (select *
                from   ROOM_PERIOD$PMS R
                where  R.ID_ROOM = :id_room)) then exception PMS_EXCEPTION '-622';

  select first 1 rpm.status
  from   ROOM_PERIOD$PMS rpm
  where  rpm.id_room = :id_room
         and rpm.from_date < :from_date
  order by rpm.from_date desc
  into   :prev_period_status;

  execute procedure ROOM_STATUS_CHECK$INT (:ID_ROOM, :from_date, :to_date, :status, :prev_period_status);

  for
    select AP1.ID_ACCOUNT_POST, AP1.ID_PMS_EVENT
    from   ACCOUNT_POST$PMS AP1
           join ACCOUNT$PMS A1 on A1.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS
           join PMS_EVENT$PMS E1 on E1.ID_PMS_EVENT = AP1.ID_PMS_EVENT
    where  AP1.DATE_POST between :from_date and :to_date
           and E1.ID_ROOM = :id_room
           and A1.IS_SHADOW = 1
           and AP1.LINE_STATUS = 11 /*  anulirat se samo aktiwnite nachisleniq. Ako ima dokumentirani?! ili anulirani, ne se pipat  */
    into   :id_account_post, :id_pms_event
  do begin
    execute procedure ACCOUNT_POST_PMS_ANUL$INT(:id_pms_event, :id_account_post);
  end

  delete from ROOM_PERIOD$PMS
  where  ID_ROOM_PERIOD = :id_room_period;

  execute procedure ROOM_PERIOD_TODATE$INT(:id_room);

  action_text = f_character(29) || '@{period_room_status.'||:status||'}'
              || f_character(28) || iif(extract(year from :from_date) = 2500, '~', formatdate(:from_date, 'dd.mm.yyyy'))
              || f_character(28) || iif(extract(year from :to_date) = 2500, '~', formatdate(:to_date, 'dd.mm.yyyy'))
              || f_character(28) || '@{period_room_status.'||:prev_period_status||'}' ;
  execute procedure SYSTEM_LOG_ADD ('ROOM', :id_room, 'ROOM_STATUS_DELETED', :action_text);
end
^

/* Restore proc. body: ROOM_PERIOD_MODIFY$INT */
ALTER PROCEDURE ROOM_PERIOD_MODIFY$INT(ID_ROOM_PERIOD INTEGER,
FROM_DATE DATE,
STATUS VARCHAR(30))
 AS
declare variable id_room integer;
  declare variable old_status varchar(30);
  declare variable old_from_date date;
  declare variable id_account_post integer;
  declare variable id_pms_event integer;
  declare variable action_text varchar(255);
  declare variable to_date date;
  declare variable prev_period_status varchar(30);
  declare variable old_id_room_contract integer;
begin
  select R.STATUS, R.FROM_DATE, r.TO_DATE, r.ID_ROOM
  from   ROOM_PERIOD$PMS R
  where  R.ID_ROOM_PERIOD = :id_room_period
  into   :old_status, :old_from_date, :to_date, :id_room;

  select first 1 rpm.status
  from   ROOM_PERIOD$PMS rpm
  where  rpm.id_room = :id_room
         and rpm.from_date < :old_from_date
  order by rpm.from_date desc
  into   :prev_period_status;

  if (:STATUS <> :old_status) then begin
    execute procedure ROOM_STATUS_CHECK$INT (:ID_ROOM, :from_date, :to_date, :old_status, :STATUS);
  end

  if (:old_from_date < :FROM_DATE) then begin
    execute procedure ROOM_STATUS_CHECK$INT (:ID_ROOM, :old_from_date, :from_date, :old_status, :prev_period_status);
  end else if (:old_from_date > :FROM_DATE) then begin
    execute procedure ROOM_STATUS_CHECK$INT (:ID_ROOM, :from_date, :old_from_date, :prev_period_status, :STATUS);
  end

  if ((:old_from_date <> :FROM_DATE) or (:STATUS <> :old_status)) then begin
    for
      select AP1.ID_ACCOUNT_POST, AP1.ID_PMS_EVENT
      from   ACCOUNT_POST$PMS AP1
             join ACCOUNT$PMS A1 on A1.ID_ACCOUNT = AP1.ID_ACCOUNT_PMS
             join PMS_EVENT$PMS E1 on E1.ID_PMS_EVENT = AP1.ID_PMS_EVENT
      where  AP1.DATE_POST between :old_from_date and :to_date
             and E1.ID_ROOM = :id_room
             and A1.IS_SHADOW = 1
             and AP1.LINE_STATUS = 11 /*  anulirat se samo aktiwnite nachisleniq. Ako ima dokumentirani?! ili anulirani, ne se pipat  */
      into   :id_account_post, :id_pms_event
    do begin
      execute procedure ACCOUNT_POST_PMS_ANUL$INT(:id_pms_event, :id_account_post);
    end
  end
  
  update ROOM_PERIOD$PMS p
  set    p.FROM_DATE = :from_date,
         p.STATUS = :status
  where  p.ID_ROOM_PERIOD = :id_room_period;

  execute procedure ROOM_PERIOD_TODATE$INT(:id_room);

  action_text = f_character(29) || '@{period_room_status.'||:old_status||'}'
                || f_character(28) || iif(extract(year from :old_from_date) = 2500, '~', formatdate(:old_from_date, 'dd.mm.yyyy'))
                || f_character(28) || iif(extract(year from :to_date) = 2500, '~', formatdate(:to_date, 'dd.mm.yyyy'))
                || f_character(28) || '@{period_room_status.'||:status||'}'
                || f_character(28) || iif(extract(year from :from_date) = 2500, '~', formatdate(:from_date, 'dd.mm.yyyy'))
                || f_character(28) || iif(extract(year from :to_date) = 2500, '~', formatdate(:to_date, 'dd.mm.yyyy'));

  execute procedure SYSTEM_LOG_ADD ('ROOM', :ID_ROOM, 'ROOM_STATUS_CHANGED', :action_text);

  if((:status in ('PRIVATE', 'CONTRACT')) and (:from_date <> :old_from_date)) then begin
    select first 1 rcp.id_room_contract
    from   ROOM_CONTRACT$PMS rcp
    where  rcp.id_room_period = :id_room_period
    into   :old_id_room_contract;

    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :OLD_ID_ROOM_CONTRACT, 'ROOM_STATUS_CHANGED', :action_text);
  end

end
^

/* Restore proc. body: SAFE_CHECK_OUT */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE TYPE OF ID)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
WARN_CODE TYPE OF ID_REF)
 AS
declare variable to_dt timestamp;
  declare variable is_occupied integer;
  declare variable expire_tollerance integer;
  declare variable occupant_name varchar(100);
  declare variable id_resource_reservation integer;
  declare variable check_out_datetime timestamp;
begin
  DOC_SELECTED = null;
  select s.IS_OCCUPIED, od.TO_DATETIME,
         st.EXPIRE_TOLLERANCE, rr.OCCUPANT_NAME, rr.ID_RESOURCE_RESERVATION
  from   SAFE s
         join RESOURCE$INT r on r.ID_RESOURCE = s.ID_SAFE
         join SAFE_TYPES st on st.ID_SAFE_TYPE = r.ID_RESOURCE_TYPE
         join RESOURCE_RESERVATION rr on rr.ID_RESOURCE_RESERVATION = s.ID_CURRENT_OCCUPANCY
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join RESOURCE_OCCUPANCY ro on ro.ID_RESOURCE_OCCUPANCY_DATA = od.ID_RESOURCE_OCCUPANCY_DATA
  where  s.ID_SAFE = :ID_SAFE
  into   :is_occupied, :to_dt, :expire_tollerance, :occupant_name, :id_resource_reservation;

  if (:is_occupied = 0) then exit;

  expire_tollerance = coalesce(:expire_tollerance, 0);
  check_out_datetime = current_timestamp;

  execute procedure SAFE_OCCUPANCY_MODIFY (:id_safe, current_timestamp, :occupant_name)
  returning_values  :DOC_SELECTED;

  if (:check_out_datetime > (:to_dt + cast(:expire_tollerance as double precision) / 60 / 24)) then begin
    execute procedure SYSTEM_WARNING_ADD (-1066, f_character(29) || :expire_tollerance || f_character(28) || formatdate(:to_dt + cast(:expire_tollerance as double precision) / 60 / 24, 'D;dd/mm/yyyy HH:MM'))
    returning_values (:WARN_CODE);
  end

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = null
  where  s.ID_SAFE = :ID_SAFE;

  update RESOURCE_RESERVATION rr
  set    rr.STATUS = 'CHECKED_OUT'
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_CHECKED_OUT', :occupant_name);
end
^

/* Restore proc. body: SAFE_OCCUPANCY_ANNUL */
ALTER PROCEDURE SAFE_OCCUPANCY_ANNUL(ID_SAFE TYPE OF ID,
REASON TYPE OF TREASON)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_resource_reservation integer;
  declare variable from_datetime timestamp;
  declare variable to_datetime timestamp;
  declare variable action_text varchar(255);
  declare variable id_account_post integer;
begin
  select s.ID_CURRENT_OCCUPANCY, od.FROM_DATETIME, od.TO_DATETIME, rp.ID_ACCOUNNT_POST
  from   SAFE S
         join RESOURCE_RESERVATION rr on rr.ID_RESOURCE_RESERVATION = s.ID_CURRENT_OCCUPANCY
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESOURCE_RESERV_POST rp on rp.ID_RESOURCE_RESERVATION = rr.ID_RESOURCE_RESERVATION
  where  s.ID_SAFE = :ID_SAFE
  into   :id_resource_reservation, :from_datetime, :to_datetime, :id_account_post;

  execute procedure RESOURCE_RESERVATION_CANCEL (:id_resource_reservation, :REASON);

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = null
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:REASON, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_ANNUL', :action_text);

  execute procedure ACCOUNT_POSTING_ANUL (:id_account_post, :REASON);

  DOC_SELECTED = null;
  update ACCOUNT_POST AP
  set    ap.DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1)
  where  ap.ID_ACCOUNT_POST = :id_account_post
         and ap.ac = '00'
  returning new.doc_selected
  into   :DOC_SELECTED;

end
^

/* Restore proc. body: SALE_TAX_MODIFY$CFG */
ALTER PROCEDURE SALE_TAX_MODIFY$CFG(ID_SALE_TAX INTEGER,
TAX_NAME VARCHAR(50),
TAX_PERCENT NUMERIC(15,4),
TAXABLE_BASE_PERCENT NUMERIC(15,4),
TAX_VALUE NUMERIC(15,4),
REVENUE_DEDUCTION_TAX SMALLINT,
REPORT_IN_DOCUMENT SMALLINT,
FISCAL_CODE VARCHAR(30),
ACCOUNT_NAME VARCHAR(50),
OPERATION VARCHAR(10),
ID_HOTEL TYPE OF ID,
TAXATION_REASON TYPE OF TDESCRIPTION_LONG)
 RETURNS(NEW_ID_SALE_TAX INTEGER)
 AS
declare variable id_sale_taxation integer;
declare variable old_tax_percent numeric(15,4);
declare variable old_taxable_base_percent numeric(15,4);
declare variable taxation_name varchar(50);
declare variable old_tax_name varchar(50);
declare variable old_fiscal_code varchar(30);
declare variable old_is_percent smallint;
declare variable new_is_percent smallint;
declare variable old_rev_deduction_tax integer;
declare variable old_tax_value tprice;
declare variable old_taxation_reason type of TDESCRIPTION_LONG;
begin
  execute procedure SYSTEM_CHECK_OPERATION (:OPERATION, 'add, mod, del');

  if (:TAX_VALUE is not null and :TAX_PERCENT is not null) then exception ASSERT '-701';

  fiscal_code = nullif(trim(:FISCAL_CODE), '');
  if (:OPERATION = 'add') then begin
    insert into SALE_TAXES (ID_SALE_TAX, TAX_NAME, TAX_PERCENT, TAXABLE_BASE_PERCENT,
           FISCAL_CODE, ACCOUNT_NAME, ID_HOTEL, TAX_VALUE, REVENUE_DEDUCTION_TAX, REPORT_IN_DOCUMENT, TAXATION_REASON)
    values (nullif(:ID_SALE_TAX, -1), :TAX_NAME, :TAX_PERCENT, coalesce(:TAXABLE_BASE_PERCENT, 100),
           :FISCAL_CODE, :ACCOUNT_NAME, :id_hotel, :TAX_VALUE, :REVENUE_DEDUCTION_TAX, :REPORT_IN_DOCUMENT, :TAXATION_REASON)
    returning ID_SALE_TAX
    into   :NEW_ID_SALE_TAX;

  end else if (:OPERATION = 'mod') then begin
    select st.TAX_PERCENT, st.TAXABLE_BASE_PERCENT, st.tax_name, st.fiscal_code, st.IS_PERCENT_TAX,
           st.REVENUE_DEDUCTION_TAX, st.TAX_VALUE, ST.TAXATION_REASON
    from   SALE_TAXES st
    where  st.ID_SALE_TAX = :ID_SALE_TAX
    into   :old_tax_percent, :old_taxable_base_percent, :old_tax_name, :old_fiscal_code, :old_is_percent,
           :old_rev_deduction_tax, :old_tax_value, :old_taxation_reason;

    if (coalesce(:old_rev_deduction_tax, 0) <> coalesce(:REVENUE_DEDUCTION_TAX, 0)) then
      exception SALE_TAX_EXCEPTION '-702';

    if ((:TAX_PERCENT is distinct from :old_tax_percent)
        or (:TAXABLE_BASE_PERCENT is distinct from :old_taxable_base_percent)
        or (:TAX_VALUE is distinct from :old_tax_value)) then begin
      for
        select distinct stt.ID_SALE_TAXATION, t.NAME
        from   SALE_TAXATION_TAX STT
               join SALE_TAXATION t on t.ID_SALE_TAXATION = stt.ID_SALE_TAXATION
        where  stt.ID_SALE_TAX = :ID_SALE_TAX
        into   :id_sale_taxation, :taxation_name
      do begin

        /* check if sale tax is used in postings */
        delete from SALE_TAXATION STT where stt.ID_SALE_TAXATION = :id_sale_taxation;
  
        insert into SALE_TAXATION (ID_SALE_TAXATION, NAME, ID_HOTEL)
        values (:id_sale_taxation, :taxation_name, :id_hotel);
  
        when sqlcode -530 do begin
          exception SALE_TAX_EXCEPTION '-338';
        end
      end 

      execute procedure SYSTEM_LOG_ADD('SALE_TAX', :ID_SALE_TAX, 'TAX_CHANGED',
              f_character(29) || :old_tax_percent  || '%'  || f_character(28) || :old_taxable_base_percent || '%'
              || f_character(28) || :TAX_PERCENT  || '%'  || f_character(28) || :TAXABLE_BASE_PERCENT || '%');
    end

    update SALE_TAXES T
    set    t.TAX_PERCENT = :TAX_PERCENT,
           t.TAXABLE_BASE_PERCENT = :TAXABLE_BASE_PERCENT,
           T.TAX_NAME = :TAX_NAME,
           t.FISCAL_CODE = :FISCAL_CODE,
           t.ACCOUNT_NAME = :ACCOUNT_NAME,
           t.TAX_VALUE = :TAX_VALUE,
           --t.REVENUE_DEDUCTION_TAX = :REVENUE_DEDUCTION_TAX,
           t.REPORT_IN_DOCUMENT = :REPORT_IN_DOCUMENT,
           T.TAXATION_REASON = :TAXATION_REASON
    where  T.ID_SALE_TAX = :ID_SALE_TAX
    returning new.IS_PERCENT_TAX
    into   :new_is_percent;
    NEW_ID_SALE_TAX = :ID_SALE_TAX;

    if (:new_is_percent <> :old_is_percent) then exception ASSERT '-703';

    if ((:old_tax_name <> :tax_name) or (:old_fiscal_code <> :fiscal_code)) then begin
      execute procedure SYSTEM_LOG_ADD('SALE_TAX', :ID_SALE_TAX, 'TAX_NAME_CHANGED',
              f_character(29) || :old_tax_name || f_character(28) || :old_fiscal_code ||
              f_character(28) || :tax_name || f_character(28) || :fiscal_code);
    end

    if (:old_taxation_reason is distinct from :taxation_reason) then begin
      execute procedure SYSTEM_LOG_ADD('SALE_TAX', :ID_SALE_TAX, 'TAX_REASON_CHANGED',
              f_character(29) || :old_taxation_reason || f_character(28) || :taxation_reason);
    end

  end else if (:OPERATION = 'del') then begin
    execute procedure SYSTEM_LOG_ADD ('SALE_TAX', :ID_SALE_TAX, 'DELETE', '');

    delete from SALE_TAXES ST
    where  ST.ID_SALE_TAX = :ID_SALE_TAX;

    NEW_ID_SALE_TAX = null;

    when sqlcode -530 do begin
      exception REF_INTEGRITY_DELETE;
    end
  end
end
^

/* Restore proc. body: SALE_TAXATION_MODIFY$CFG */
ALTER PROCEDURE SALE_TAXATION_MODIFY$CFG(ID_SALE_TAXATION TYPE OF ID,
NAME TYPE OF TOBJECT_NAME,
TAXES VARCHAR(250),
ACCOUNT_NAME TYPE OF TOBJECT_NAME,
OPERATION VARCHAR(10),
ID_HOTEL TYPE OF ID)
 RETURNS(NEW_ID_SALE_TAXATION INTEGER)
 AS
declare variable id_sale_tax integer;
  declare variable old_taxes varchar(250);
  declare variable no_use varchar(255);
begin
  execute procedure SYSTEM_CHECK_OPERATION (:OPERATION, 'add, mod, del');

  if (:OPERATION = 'add') then begin
    insert into SALE_TAXATION (NAME, ACCOUNT_NAME, ID_HOTEL)
    values (:NAME, :ACCOUNT_NAME, :ID_HOTEL)
    returning ID_SALE_TAXATION
    into      :NEW_ID_SALE_TAXATION;

    for
      select T.ITEM
      from   SYSTEM_STRING_PARSER (:TAXES, ',') T
      into   :id_sale_tax
    do begin
      if (not exists (select stt.ID_SALE_TAX
                      from   SALE_TAXATION_TAX STT
                      where  stt.ID_SALE_TAXATION = :NEW_ID_SALE_TAXATION
                             and stt.ID_SALE_TAX = :id_sale_tax)) then
      begin
        insert into SALE_TAXATION_TAX (ID_SALE_TAXATION, ID_SALE_TAX)
        values (:NEW_ID_SALE_TAXATION, :id_sale_tax);

        execute procedure SYSTEM_EVENT_LOG$INT ('SALE_TAX', :id_sale_tax, 'SALE_TAX_ADDED', f_character(29) || :NAME)
        returning_values (:no_use);
      end
    end
  end else if (:OPERATION = 'mod') then begin
    select coalesce(list(distinct(cast(t.ITEM as integer))), '')   -- select new taxes, ordered by ID asc
    from   SYSTEM_STRING_PARSER (:TAXES, ',') T
    into   :TAXES;

    select coalesce(list(distinct(stt.ID_SALE_TAX)), '')           -- select old taxes, ordered by ID asc
    from   SALE_TAXATION_TAX STT
    where  stt.ID_SALE_TAXATION = :ID_SALE_TAXATION
    into   :old_taxes;

    if (:taxes = :old_taxes) then begin
      -- tax contents is not changed
      update SALE_TAXATION ST
      set    ST.NAME = :NAME,
             st.ACCOUNT_NAME = :ACCOUNT_NAME
      where  ST.ID_SALE_TAXATION = :id_sale_taxation;
      NEW_ID_SALE_TAXATION = :ID_SALE_TAXATION;
    end else begin
      -- create new taxation package
      update SALE_TAXATION st
      set    st.NAME = '$$$' || st.NAME || '$$$'
      where  st.ID_SALE_TAXATION = :ID_SALE_TAXATION;

      execute procedure SALE_TAXATION_MODIFY$CFG (null, :name, :taxes, :ACCOUNT_NAME, 'add', :id_hotel)
      returning_values (:NEW_ID_SALE_TAXATION);

      update SERVICE_TAXATION pt
      set    pt.ID_SALE_TAXATION = :NEW_ID_SALE_TAXATION
      where  pt.ID_SALE_TAXATION = :ID_SALE_TAXATION;

      update SETTING_HOTEL_VALUE s
      set    s.SETTING_VALUE = :NEW_ID_SALE_TAXATION
      where  s.SETTING_CODE = 'DEF_SERVICE_TAXATION'
             and s.SETTING_VALUE = :ID_SALE_TAXATION
             and s.ID_HOTEL = :ID_HOTEL;

      -- and delete old, if possible ... else BOOOM! - unallowable changes !
      execute procedure SALE_TAXATION_MODIFY$CFG (:ID_SALE_TAXATION, :name, :taxes, :ACCOUNT_NAME, 'del', :id_hotel)
      returning_values (:ID_SALE_TAXATION);

      when any do begin
        exception SALE_TAX_EXCEPTION '-704';
      end
    end

  end else if (:OPERATION = 'del') then begin
    delete from SALE_TAXATION
    where  ID_SALE_TAXATION = :id_sale_taxation;

    delete from SALE_TAXATION_TAX STT
    where  stt.ID_SALE_TAXATION = :ID_SALE_TAXATION;

    new_id_sale_taxation = null;
  end

  execute procedure SYSTEM_CACHE_APPLY('SALE_TAXATION');
end
^

/* Restore proc. body: SERVICE_TAXATION_MODIFY$CFG */
ALTER PROCEDURE SERVICE_TAXATION_MODIFY$CFG(ID_TAX_POLICY TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_SALE_TAXATION TYPE OF ID)
 AS
declare variable dbkey char(8);
  declare variable nat_round_to numeric(15,4);
  declare variable action_text varchar(255);
  declare variable old_sale_taxation_name varchar(50);
  declare variable service_name varchar(30);
  declare variable id_rate integer;
  declare variable passed_nights integer;
  declare variable id_posting_sale_taxation integer;
begin
  if (:ID_SALE_TAXATION is null) then begin
    delete from SERVICE_TAXATION T
    where  t.ID_TAX_POLICY = :ID_TAX_POLICY
           and t.ID_SERVICE = :ID_SERVICE;

    select f_character(29) || se.service_name
    from   SERVICES se
    where  se.id_service = :id_service
    into   :action_text;
    execute procedure SYSTEM_LOG_ADD ('TAX_POLICY', :id_tax_policy, 'TAX_POLICY_SERVICE_DELETED', :action_text);
  end else begin
    select sta.name
    from   SERVICE_TAXATION TPT
           join SALE_TAXATION sta on sta.id_sale_taxation = tpt.id_sale_taxation
    where  TPT.ID_TAX_POLICY = :ID_TAX_POLICY
           and TPT.ID_SERVICE = :ID_SERVICE
    into   :old_sale_taxation_name;

    select s.SERVICE_NAME, c.ROUND_TO
    from   SERVICES s
           join HOTEL h on h.ID_HOTEL = s.ID_HOTEL
           join CURRS c on c.CURR = h.NATION_CURR
    where  s.ID_SERVICE = :ID_SERVICE
    into   :service_name, :nat_round_to;

    update SERVICE_TAXATION T
    set    T.ID_SALE_TAXATION = :ID_SALE_TAXATION
    where  T.ID_TAX_POLICY = :ID_TAX_POLICY
           and T.ID_SERVICE = :ID_SERVICE;

    if (row_count > 0) then begin
      select st.name
      from   SALE_TAXATION st
      where  st.id_sale_taxation = :id_sale_taxation
      into   :action_text;
      action_text = f_character(29) || :service_name || f_character(28) || coalesce(:old_sale_taxation_name, '') || f_character(28) || :action_text;
      execute procedure SYSTEM_LOG_ADD ('TAX_POLICY', :id_tax_policy, 'TAX_POLICY_SERVICE_UPDATED', :action_text);
    end else begin
      insert into SERVICE_TAXATION (ID_TAX_POLICY, ID_SERVICE, ID_SALE_TAXATION)
      values (:ID_TAX_POLICY, :ID_SERVICE, :ID_SALE_TAXATION);
    end
  
    for
      select AP.RDB$DB_KEY, ap.ID_TARIFF, ap.DATE_POST - ap.FROM_DATE
      from   ACCOUNT A
             join ACCOUNT_POST AP on AP.ID_ACCOUNT = A.ID_ACCOUNT
      where  A.ID_TAX_POLICY = :ID_TAX_POLICY
             and A.IS_ARCHIVE = 0
             and AP.ID_SERVICE = :ID_SERVICE
             and AP.ID_BASE_DOC is null
             and AP.ID_SALE_TAXATION is distinct from :ID_SALE_TAXATION
             and ap.IS_ANUL = 0
      into   :dbkey, :id_rate, :passed_nights
    do begin
      execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :ID_TAX_POLICY, :id_rate, :passed_nights)
      returning_values (:id_posting_sale_taxation);

      if (:id_posting_sale_taxation = :ID_SALE_TAXATION) then begin
        execute procedure ACCOUNT_POSTING_UPDATE_TAX$INT (:dbkey, :ID_SALE_TAXATION, :nat_round_to, 'SERVICE VAT CHANGED');
      end

    end
  end
end
^

/* Restore proc. body: SETTINGS_MODIFY_VALUE */
ALTER PROCEDURE SETTINGS_MODIFY_VALUE(SETTING_CODE TYPE OF TSEARCH_CODE,
SETTING_VALUE TYPE OF TOBJECT_TEXT,
ID_HOTEL TYPE OF ID)
 AS
declare variable old_setting_value varchar(100);
declare variable tmp_setting_value varchar(100);
  declare variable action_text varchar(255);
  declare variable setting_name varchar(255);
  declare variable id_setting_grp integer;
  declare variable settingClass varchar(20);
  declare variable dbkey char(8);
begin
  dbkey = null;
  select SV.SETTING_VALUE, S.ID_SETTING_GRP, S.CONTROL_CLASS, sv.RDB$DB_KEY
  from   SETTING s
         join SETTING_HOTEL_VALUE SV on sv.SETTING_CODE = s.SETTING_CODE
  where  SV.SETTING_CODE = :setting_code
         and sv.ID_HOTEL = :ID_HOTEL
  into   :old_setting_value, :id_setting_grp, :settingClass, :dbkey;

  if (:dbkey is not null) then begin
    update SETTING_HOTEL_VALUE SV
    set    SV.SETTING_VALUE = :setting_value
    where  SV.RDB$DB_KEY = :dbkey;
  end else begin
    insert into SETTING_HOTEL_VALUE (SETTING_CODE, ID_HOTEL, SETTING_VALUE)
    values (:SETTING_CODE, :ID_HOTEL, :SETTING_VALUE);
  end

  RDB$SET_CONTEXT('USER_SESSION', 'setting.'||:setting_code||'.'||:id_hotel, :setting_value);

  if ((:id_setting_grp is not null) and (:setting_value is distinct from :old_setting_value)) then begin
    /* FOR THE FEATURE THIS KIND OF LOGING MUST BE BASED
    || ON MACROS WICH ARE EXECUTED AT DISPLAY TIME.
    || FOR NOW WE ARE HARDCODED TO THE BASE LANG.
    */
    setting_name = '@{set_name.'||:setting_code||'}';
    action_text = f_character(29)||:setting_name;

    if (:settingClass = 'COMBO') then begin
      old_setting_value = '@{set_item.'||:setting_code||'.'||:old_setting_value||'}';
      tmp_setting_value = '@{set_item.'||:setting_code||'.'||:setting_value||'}';
    end else begin
      tmp_setting_value = :setting_value;
    end

    action_text = :action_text
                  || f_character(28) || coalesce(:old_setting_value, '')
                  || f_character(28) || :tmp_setting_value;
    execute procedure SYSTEM_LOG_ADD ('SYSTEM', 0, 'SETTING_CHANGED', :action_text);
  end

  execute procedure SYSTEM_CACHE_APPLY('HOTEL');
end
^

/* Restore proc. body: TAR_CALC_INPUT_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_PARAMS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_input integer;
  declare variable id_guest integer;
  declare variable for_date date;
  declare variable id_calc_tariff integer;
  declare variable td_dbkey char(8);
  declare variable date_independent_param_values varchar(2000);
  declare variable date_dep_param_values varchar(2000);
  declare variable prev_id_guest integer;
  declare variable prev_id_tariff integer;
begin
  prev_id_guest = null;
  prev_id_tariff = null;
  for
    select Td.RDB$DB_KEY, TI.ID_TAR_INPUT, ti.ID_GUEST, td.FOR_DATE, td.ID_TAR_HEAD
    from   TAR_CALC_INPUT$TMP TI
           join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
    where  TI.ID_TAR_CALC = :id_tar_calc
    order by ti.ID_GUEST asc, td.FOR_DATE asc
    into   :td_dbkey, :id_tar_input, :id_guest, :for_date, :id_calc_tariff
  do begin
    if ((:id_guest is distinct from :prev_id_guest)
        or (:id_calc_tariff is distinct from :prev_id_tariff)) then
    begin
      /* get date independent params */
      execute procedure TAR_CALC_PARAMS$INT (:id_calc_tariff, :id_tar_input, :ID_TAR_CALC, null, null)
      returning_values (:ERR_CODE, :date_independent_param_values);
      if (:ERR_CODE < 0) then exit;
      prev_id_guest = :id_guest;
      prev_id_tariff = :id_calc_tariff;
    end

    execute procedure TAR_CALC_PARAMS$INT (:id_calc_tariff, :id_tar_input, :ID_TAR_CALC, :for_date, null)
    returning_values (:ERR_CODE, :date_dep_param_values);
    if (:ERR_CODE < 0) then exit;

    update TAR_CALC_INPUT_DETAIL$TMP d
    set    d.PARAM_VALUES = coalesce(:date_independent_param_values, '') || ';'
                            || coalesce(:date_dep_param_values, '')
    where  d.RDB$DB_KEY = :td_dbkey;
  end
end
^

SET TERM ; ^

ALTER TABLE EXT_PMS_HOTEL_MAP ALTER COLUMN ID_HOTEL POSITION 1;

ALTER TABLE EXT_PMS_HOTEL_MAP ALTER COLUMN PMS_USER_NAME POSITION 2;

ALTER TABLE EXT_PMS_HOTEL_MAP ALTER COLUMN PMS_API_KEY POSITION 3;

ALTER TABLE EXT_PMS_HOTEL_MAP ALTER COLUMN PMS_URL POSITION 4;

ALTER TABLE EXT_PMS_HOTEL_MAP ALTER COLUMN IS_ACTIVE POSITION 5;

ALTER TABLE EXT_PMS_HOTEL_MAP ALTER COLUMN LAST_BOOKING_FETCH POSITION 6;

ALTER TABLE EXT_PMS_HOTEL_MAP ALTER COLUMN ID_NOM_MARKET_SEGMENT POSITION 7;

ALTER TABLE EXT_PMS_HOTEL_MAP ALTER COLUMN ID_NOM_SOURCE_CODE POSITION 8;

ALTER TABLE EXT_PMS_HOTEL_MAP ALTER COLUMN ID_NOM_CHANNEL_CODE POSITION 9;

ALTER TABLE EXT_PMS_HOTEL_MAP ALTER COLUMN ID_NOM_HEAR_REASON POSITION 10;

ALTER TABLE EXT_PMS_HOTEL_MAP ALTER COLUMN ID_NOM_COME_REASON POSITION 11;

ALTER TABLE EXT_PMS_HOTEL_MAP ALTER COLUMN EXPORT_RELEASE_DATES POSITION 12;

ALTER TABLE EXT_PMS_HOTEL_MAP ALTER COLUMN EXPORT_OVERBOOK POSITION 13;

ALTER TABLE EXT_PMS_HOTEL_MAP ALTER COLUMN EXPORT_RES_CONFIRMED POSITION 14;

ALTER TABLE EXT_PMS_HOTEL_MAP ALTER COLUMN EXPORT_RES_NOTCONFIRMED POSITION 15;

ALTER TABLE EXT_PMS_HOTEL_MAP ALTER COLUMN EXPORT_RES_WAITING POSITION 16;

ALTER TABLE EXT_PMS_HOTEL_MAP ALTER COLUMN EXPORT_BOOKING_POSITIONS POSITION 17;

ALTER TABLE EXT_PMS_HOTEL_MAP ALTER COLUMN EXPORT_CONTINGENT POSITION 18;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_RESERV_DETAIL POSITION 1;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_HOTEL POSITION 2;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_ROOM_TYPE POSITION 3;

ALTER TABLE RESERV_DETAIL ALTER COLUMN FROM_DATE POSITION 4;

ALTER TABLE RESERV_DETAIL ALTER COLUMN TO_DATE POSITION 5;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ADULT_COUNT POSITION 6;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CHILD_COUNT POSITION 7;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CHECK_STATUS POSITION 8;

ALTER TABLE RESERV_DETAIL ALTER COLUMN IS_ANUL POSITION 9;

ALTER TABLE RESERV_DETAIL ALTER COLUMN REASON_OF_ANUL POSITION 10;

ALTER TABLE RESERV_DETAIL ALTER COLUMN RES_STATUS POSITION 11;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_ROOM POSITION 12;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ROOM_FEATURES POSITION 13;

ALTER TABLE RESERV_DETAIL ALTER COLUMN VIRTUAL_ROOM POSITION 14;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_BOARD POSITION 15;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CODE_FIRST_FOOD POSITION 16;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_GROUP POSITION 17;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_AGENT_PROFILE POSITION 18;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_AGENT_PAYMENT POSITION 19;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_AGENT_ACCOUNT_RULE POSITION 20;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ACC_ROUTING POSITION 21;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_BASE_ACCOUNT POSITION 22;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_EXTRA_ACCOUNT POSITION 23;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_AGENT_ACCOUNT POSITION 24;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_PERSON_PROFILE POSITION 25;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_ACC_TEMPLATE_PERSON POSITION 26;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_PERSON_PAYMENT POSITION 27;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_TITULAR POSITION 28;

ALTER TABLE RESERV_DETAIL ALTER COLUMN COUNTRY POSITION 29;

ALTER TABLE RESERV_DETAIL ALTER COLUMN VAUCHER_NUM POSITION 30;

ALTER TABLE RESERV_DETAIL ALTER COLUMN VAUCHER_DATE POSITION 31;

ALTER TABLE RESERV_DETAIL ALTER COLUMN VAUCHER_NUM2 POSITION 32;

ALTER TABLE RESERV_DETAIL ALTER COLUMN VAUCHER_DATE2 POSITION 33;

ALTER TABLE RESERV_DETAIL ALTER COLUMN VAUCHER_TEXT POSITION 34;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_RATE POSITION 35;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ROOM_PRICE POSITION 36;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ROOM_CURRENCY POSITION 37;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ROOM_PRICE_DETAILS POSITION 38;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CUSTOM_PRICE POSITION 39;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CUSTOM_CURRENCY POSITION 40;

ALTER TABLE RESERV_DETAIL ALTER COLUMN HAS_DIFFERENT_VOUCHERS POSITION 41;

ALTER TABLE RESERV_DETAIL ALTER COLUMN HAS_DIFFERENT_ROOM_TYPE POSITION 42;

ALTER TABLE RESERV_DETAIL ALTER COLUMN HAS_DIFFERENT_BOARD POSITION 43;

ALTER TABLE RESERV_DETAIL ALTER COLUMN HAS_DIFFERENT_TYPE_STAY POSITION 44;

ALTER TABLE RESERV_DETAIL ALTER COLUMN HAS_DIFFERENT_TARIFF POSITION 45;

ALTER TABLE RESERV_DETAIL ALTER COLUMN HAS_DIFFERENT_OTHER POSITION 46;

ALTER TABLE RESERV_DETAIL ALTER COLUMN HAS_DIFFERENT_PRICE POSITION 47;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_HK_PLAN POSITION 48;

ALTER TABLE RESERV_DETAIL ALTER COLUMN IS_VIP POSITION 49;

ALTER TABLE RESERV_DETAIL ALTER COLUMN I_SPECIAL_TREATMENT POSITION 50;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_NOM_MARKET_SEGMENT POSITION 51;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_NOM_SOURCE_CODE POSITION 52;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_NOM_CHANNEL_CODE POSITION 53;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_NOM_HEAR_REASON POSITION 54;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_NOM_COME_REASON POSITION 55;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CREATE_DATETIME POSITION 56;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CHANGE_TIME POSITION 57;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_LOG_EVENT_CREATE POSITION 58;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_LOG_EVENT_ANNUL POSITION 59;

ALTER TABLE RESERV_DETAIL ALTER COLUMN RES_EDIT_STATUS POSITION 60;

ALTER TABLE RESERV_DETAIL ALTER COLUMN NOTE POSITION 61;

ALTER TABLE RESERV_DETAIL ALTER COLUMN NOTE_REMINDERS POSITION 62;

ALTER TABLE RESERV_DETAIL ALTER COLUMN SPLIT_ON_CHECKIN POSITION 63;

ALTER TABLE RESERV_DETAIL ALTER COLUMN EXP_DATE POSITION 64;

ALTER TABLE RESERV_DETAIL ALTER COLUMN COMMING_KIND POSITION 65;

ALTER TABLE RESERV_DETAIL ALTER COLUMN LEAVING_KIND POSITION 66;

ALTER TABLE RESERV_DETAIL ALTER COLUMN TRANSFER_IN_TIME POSITION 67;

ALTER TABLE RESERV_DETAIL ALTER COLUMN TRANSFER_IN_NOTE POSITION 68;

ALTER TABLE RESERV_DETAIL ALTER COLUMN TRANSFER_OUT_TIME POSITION 69;

ALTER TABLE RESERV_DETAIL ALTER COLUMN TRANSFER_OUT_NOTE POSITION 70;

ALTER TABLE RESERV_DETAIL ALTER COLUMN SELECTION_ID POSITION 71;

ALTER TABLE RESERV_DETAIL ALTER COLUMN SUBSCRIBER_ID POSITION 72;

ALTER TABLE RESERV_DETAIL ALTER COLUMN NUMBER_1 POSITION 73;

ALTER TABLE RESERV_DETAIL ALTER COLUMN NUMBER_2 POSITION 74;

ALTER TABLE RESERV_DETAIL ALTER COLUMN NUMBER_3 POSITION 75;

ALTER TABLE RESERV_DETAIL ALTER COLUMN NUMBER POSITION 76;

ALTER TABLE RESERV_DETAIL ALTER COLUMN BLOCK_CC POSITION 77;

ALTER TABLE RESERV_DETAIL ALTER COLUMN GUARANTEE_DEPOSIT POSITION 78;

ALTER TABLE RESERV_DETAIL ALTER COLUMN GUARANTEE_CURRENCY POSITION 79;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_GUARANTEE_POLICY POSITION 80;

ALTER TABLE RESERV_DETAIL ALTER COLUMN GUARANTEE_DEPOSIT_PERCENT POSITION 81;

ALTER TABLE RESERV_DETAIL ALTER COLUMN GUARANTEE_DEPOSIT_NIGHTS POSITION 82;

ALTER TABLE RESERV_DETAIL ALTER COLUMN GUARANTEE_DUE_DAYS_BEF_ARRIVAL POSITION 83;

ALTER TABLE RESERV_DETAIL ALTER COLUMN GUARANTEE_DUE_DAYS_AFTER_CREATE POSITION 84;

ALTER TABLE RESERV_DETAIL ALTER COLUMN GUARANTEE_EXPIRE_DATE POSITION 85;

ALTER TABLE RESERV_DETAIL ALTER COLUMN IS_POSTING_STOPPED POSITION 86;

ALTER TABLE RESERV_DETAIL ALTER COLUMN POSTING_TRANSACTION_UUID POSITION 87;

ALTER TABLE RESERV_DETAIL ALTER COLUMN EXC_LOCAL_VERSION POSITION 88;

ALTER TABLE RESERV_DETAIL ALTER COLUMN EXC_REMOTE_VERSION POSITION 89;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CONFIRMATION_NUMBER POSITION 90;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CANCELATION_NUMBER POSITION 91;

ALTER TABLE RESERV_DETAIL ALTER COLUMN TMP$ORIG_BOARD POSITION 92;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ID_EATING_OBJECT POSITION 93;

ALTER TABLE RESERV_DETAIL ALTER COLUMN LAST_ID_TAR_CALC POSITION 94;

ALTER TABLE RESERV_DETAIL ALTER COLUMN CHECK_OUT_KIND POSITION 95;

ALTER TABLE RESERV_DETAIL ALTER COLUMN EARLYCHECKOUT_DATE POSITION 96;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ROOM_PRICE_LAST$INT POSITION 97;

ALTER TABLE RESERV_DETAIL ALTER COLUMN ROOM_CURRENCY_LAST$INT POSITION 98;

