/* Server version: WI-V6.3.7.18553 Firebird 2.1 
   SQLDialect: 3. ODS: 11.1. Forced writes: On. Sweep inteval: 20000.
   Page size: 8192. Cache pages: 2048 (16384 Kb). Read-only: False. */
SET NAMES NONE;

SET SQL DIALECT 3;

/* Declare UDF */
DECLARE EXTERNAL FUNCTION KMS_DECRYPT
CSTRING(1000), CSTRING(1000)
RETURNS CSTRING(1000) FREE_IT
ENTRY_POINT 'kms_decrypt' MODULE_NAME 'sdl_util';

DECLARE EXTERNAL FUNCTION KMS_DECRYPT_KEYS
CSTRING(1000)
RETURNS CSTRING(1000) FREE_IT
ENTRY_POINT 'kms_decrypt_keys' MODULE_NAME 'sdl_util';

DECLARE EXTERNAL FUNCTION KMS_ENCRYPT
CSTRING(1000), CSTRING(1000), INTEGER
RETURNS CSTRING(1000) FREE_IT
ENTRY_POINT 'kms_encrypt' MODULE_NAME 'sdl_util';


/* Create Table... */
CREATE TABLE PRODUCT_AVAILABILITY_OPTIONS(ID_HOTEL ID,
RELEASE_DATES TBOOLEAN,
OVERBOOK TBOOLEAN,
RES_CONFIRMED TBOOLEAN,
RES_NOTCONFIRMED TBOOLEAN,
RES_WAITING TBOOLEAN,
BOOKING_POSITIONS TBOOLEAN,
CONTINGENT TBOOLEAN);



ALTER TABLE CONTRACT_EXPENSE$PMS ADD ID_AGENT_PROFILE ID_REF;

/* Create Procedure... */
SET TERM ^ ;

CREATE PROCEDURE AVAILABILITY_OCCUPANCY$CHM(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ID_ROOM_TYPE INTEGER,
FOR_DATE DATE,
ROOMS_OCCUPIED INTEGER,
ROOMS_AVAILABLE INTEGER)
 AS
 BEGIN SUSPEND; END
^


SET TERM ; ^

COMMENT ON COLUMN ENA_ACCOUNT.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_ACCOUNT.ID_ACCOUNT IS
'  . .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_NAME IS
'   .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.ACCOUNT_EXT_CODE IS
'             .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ID IS
'         . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_NAME IS
'    .  -        .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_ACCOUNT_NO IS
'             .  -    .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_TYPE IS
'       .  : AGENT -  , PERSON -  , HOUSE -    . .';

COMMENT ON COLUMN ENA_ACCOUNT.PROFILE_HOUSE_TYPE IS
'      (PROFILE_TYPE = ''HOUSE''),    -.  : hptExternalClient -          ( ,      ); hptExternalRevenue -                (,   ..); hptComplimentary -           ,  ,        . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_HOTEL IS
'       .  ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_ACCOUNT_POST_HISTORY IS
'   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_ACCOUNT IS
'      .  ENA_ACCOUNT.ID_ACCOUNT. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_SERVICE IS
'   .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_SALE_TAXATION IS
'         .       . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.SYSTEM_DATE IS
'    / . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_DATE IS
'        (). .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_CURR IS
'  . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_AMOUNT IS
'    (   )    . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.NAT_NET_VALUE IS
'    ( )   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.NAT_GROSS_VALUE IS
'    ( )   . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.POST_TYPE IS
'  . BASE -  ; ADD_INS -  - ,    ; EXTRA -     ,     ; TAX -            ,     .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.ID_GUEST IS
'       .  ENA_GUEST.ID_GUEST.        : 1.    "  "; 2.           ; 3.        ,      . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_GROUP IS
'       .    : ''ROOMS'', ''Food and Beverage'', ''Other Operated Departments'', ''Rentals and Other Income''. .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_ACCOUNT IS
' -      .    . .';

COMMENT ON COLUMN ENA_ACCOUNT_POST_HISTORY.REVENUE_SUB_ACCOUNT IS
' --      . ,     -. .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.ID_HOTEL IS
'   ,    . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.ID_DOC_HEAD IS
'        .  ENA_DOC_HEAD_ADVANCE.ID_DOC. .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.SYSTEM_DATE IS
'      . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAYMENT_DATE IS
'     . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.SRC_ID_ACCOUNT IS
'   . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.DEST_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAY_AMOUNT IS
' .        . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.PAY_CURRENCY IS
' . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.USER_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_ADVANCE_TRANSFER.DATETIME_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_HOTEL IS
'   ,    . .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_DEPOSIT_PAYMENT IS
'  .         . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_DATE IS
'        .            . .';

COMMENT ON COLUMN ENA_DEPOSIT.SYSTEM_DATE IS
'   .         PAYMENT_DATE.        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAYMENT_NUM IS
'           .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_DIRECTION IS
'0 -   , 1 -   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DOC_TYPE_NAME IS
'       .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DEPOSIT.ID_ACCOUNT IS
'        .  .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_AMOUNT IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT.PAY_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DEPOSIT.IS_ANUL IS
'   . 0 - , 1 - .           /    .     IS_ANUL = 0,    1.           ID_DEPOSIT.  .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_CREATED IS
'     .  .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_CREATED IS
'       . .';

COMMENT ON COLUMN ENA_DEPOSIT.USER_ANNUL IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT.DATETIME_ANNUL IS
'     .  .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.ID_HOTEL IS
'       .  .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.ID_DEPOSIT_PAYMENT IS
'   ,   .  ENA_DEPOSIT.ID_DEPOSIT_PAYMENT. .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SYSTEM_DATE IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAYMENT_DATE IS
'      . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.SRC_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DEST_ID_ACCOUNT IS
' .    . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAY_AMOUNT IS
' .        . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.PAY_CURRENCY IS
' . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.USER_CREATED IS
'     . .';

COMMENT ON COLUMN ENA_DEPOSIT_TRANSFER.DATETIME_CREATED IS
'     . .';

COMMENT ON VIEW ENA_DOC_DEPOSIT_CONSUMPTION IS
' !!!!!!    ID_DOC_TYPE - za mapowe.';


COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.DOC_TYPE_NAME IS
'       . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_NUM IS
'         .  .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAYMENT_DATE IS
'      .          . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_VALUE IS
'         . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.PAY_DOC_RATE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.EQUAL_DOC_VALUE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.NAT_VALUE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_DEPOSIT_CONSUMPTION.ID_DEPOSIT_PAYMENT IS
'      (  ENA_DEPOSIT.ID_DEPOSIT_PAYMENT ). .';

COMMENT ON VIEW ENA_DOC_HEAD_ADVANCE IS
'!      ';


COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC IS
'  .             .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_ADVANCE.ID_DOC.  .     - , ..       ,      - .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ID_DOC_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SUB_TYPE IS
'   . ,  : 0 - / , 1 -  ,  , 2 -  ,  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_NAME IS
'    . ,       .              .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TYPE_DESCRIPTION IS
'   .         .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_NUM IS
'   ,        .      . ,     ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DATE IS
'        . .    SYSTEM_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.IS_ANUL IS
'        . . 0 - , 1 - .    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_CURRENCY IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_TOTAL_VALUE IS
' (, )       . .      .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ONE_LINE_TEXT IS
' ,         .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.DOC_SECOND_CURR_RATE IS
'   ()    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_POST_ADDRESS IS
'    .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_ZIP_CODE IS
'     ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_MOL IS
'    ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_RECIPIENT_NAME IS
'     ()';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BANK_NAME IS
'  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_BIC IS
'BIC  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_IBAN IS
'IBAN  ';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.CLIENT_EMAIL IS
'email  .        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.SUPPLIER_SEND_NAME IS
'     .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ACCOUNT_ID IS
'        .';

COMMENT ON COLUMN ENA_DOC_HEAD_ADVANCE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_HOTEL IS
'       .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC IS
'  .             .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_BASE_DOC IS
'  / .    ENA_DOC_HEAD_SERVICE.ID_DOC.     - , ..       ,      - .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ID_DOC_TYPE IS
'    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SUB_TYPE IS
'   .  : 0 - / , 1 -  ,  , 2 -  ,  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_NAME IS
'    .              .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_EXPORT_TAG IS
'    .       ,      .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TYPE_DESCRIPTION IS
'   .         .  -       .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_NUM IS
'   ,        .      .  -       ""    .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DATE IS
'        .    SYSTEM_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SYSTEM_DATE IS
'   .      DOC_DATE.                  DOC_DATE.  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.IS_ANUL IS
'        . 0 - , 1 - .    .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_FISC_STATUS IS
'      . 0 -    , 1 -   , 2 - .  -  1     2.';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_CURRENCY IS
'  .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_TOTAL_VALUE IS
' (, )       .      .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_ACC_RATE IS
'      /    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.TAX_EVENT_DATE IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ONE_LINE_TEXT IS
' ,         .  .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DIFF_VAT_REASON IS
'    ''    ''. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURRENCY IS
' ()   . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_SECOND_CURR_RATE IS
'   ()    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_DATE IS
'   ,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.DOC_PROFORMA_NUM IS
'  -,        -. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IS_LEGAL_ENTITY IS
'      . 0 - , 1 - . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_NAME IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IDENT_NO IS
'     .       ,             . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_TAX_REG_NUM IS
'      . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_COUNTRY_CODE IS
'    ISO    .        2  3  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_POST_ADDRESS IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_ZIP_CODE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_MOL IS
'    . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_RECIPIENT_NAME IS
'     (). .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BANK_NAME IS
'  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_BIC IS
'BIC  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_IBAN IS
'IBAN  . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.CLIENT_EMAIL IS
'email  .  -        .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.SUPPLIER_SEND_NAME IS
'     . .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ACCOUNT_ID IS
'        .    ENA_ACCOUNT.ID_ACCOUNT. .';

COMMENT ON COLUMN ENA_DOC_HEAD_SERVICE.ANNUL_PROT_NUM IS
'        ,      ,  o DOC_NUM     . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_SERVICE IS
'     .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.DATE_POST IS
'    . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_ADVANCE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_SERVICE IS
'      .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_AGENT_DISCOUNT.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_SERVICE IS
'   .  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_SALE_TAXATION IS
'          .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.IS_CORRECT IS
'            .      1,        . 0 -   ; 1 -      0. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ID_GUEST IS
'   ,        .    null,       ''  ''     .    ENA_GUEST.ID_GUEST. .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.DATE_POST IS
'        .    ,    . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ROOM_NAME IS
'       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SERVICE.ACCOUNT_PRICE IS
'         /.             /. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_DOC_HEAD IS
'   ,     ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_SERVICE IS
'    (, , , ,  ).  ENA_SERVICES.ID_SERVICE. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.ID_SALE_TAXATION IS
'         .       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.TAXATION_NAME IS
'   .  -         .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.TAXATION_ACCOUNT_NAME IS
'    .          .  -       .       .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.VAT_PERCENT IS
' %   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.QTY_POST IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SINGLE_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SINGLE_WOT_VAT IS
' ( )      .  .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.WOT_VAT IS
' ( )       . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.LINE_NAME IS
'. .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.NAT_NET_VALUE IS
' ( )      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.NAT_GROSS_VALUE IS
' ()      . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SEC_CURR_NET_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ( )   . .';

COMMENT ON COLUMN ENA_DOC_LINE_SURGARGE.SEC_CURR_GROSS_VALUE IS
'    ()    (ENA_DOC_HEAD.DOC_SECOND_CURRENCY) -  ()   . .';

COMMENT ON VIEW ENA_DOC_PAYMENT IS
'   ,     .';


COMMENT ON COLUMN ENA_DOC_PAYMENT.ID_DOC_HEAD IS
'  ( ENA_DOC_HEAD.ID_DOC)      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DOC_TYPE_NAME IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_NUM IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_TYPE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAYMENT_DATE IS
'     .        ,                 . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_CURRENCY IS
'  .        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DESCRIPTION IS
'   .  .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.DUE_DATE IS
'       .          ,      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_VALUE IS
'           . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_RATE IS
'       . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.PAY_DOC_RATE IS
'        . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.EQUAL_DOC_VALUE IS
'      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT.NAT_VALUE IS
'     . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.ID_DOC_HEAD IS
'         . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DESCRIPTION IS
'   . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNT_VALUE IS
'      . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNTABLE_VALUE IS
'  .       . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.IS_PERCENT_DISCOUNT IS
'  .         . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.FIXED_DISCOUNT_CURRENCY IS
'  .       -     . .';

COMMENT ON COLUMN ENA_DOC_PAYMENT_DISCOUNT.DISCOUNT_PERCENT_OR_AMOUNT IS
'  .       . .';

COMMENT ON COLUMN ENA_DOC_TAX.ID_DOC_HEAD IS
'         ( ENA_DOC_HEAD.ID_DOC). .';

COMMENT ON COLUMN ENA_DOC_TAX.ID_SALE_TAX IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.NONTAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAXABLE_VALUE IS
'    . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_VALUE IS
'  . .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_NAME IS
'  .  -        .';

COMMENT ON COLUMN ENA_DOC_TAX.TAX_PERCENT IS
'   ().  .';

COMMENT ON COLUMN ENA_DOC_TAX.FISCAL_CODE IS
' .        .  -      .';

COMMENT ON COLUMN ENA_DOC_TAX.ACCOUNT_NAME IS
' .              . .';

COMMENT ON VIEW ENA_GUEST IS
'!!! .    (    )';


COMMENT ON COLUMN ENA_GUEST.ID_GUEST IS
'   ( )   . .';

COMMENT ON COLUMN ENA_GUEST.ID_RESERV_DETAIL IS
'        ( ENA_RESERV_DETAIL.ID_RESERV_DETAIL). .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME2 IS
'      . .';

COMMENT ON COLUMN ENA_GUEST.IS_CHILD IS
'   . 0 - ; 1 - . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE IS
'    . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_TEXT IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE2 IS
'   . .';

COMMENT ON COLUMN ENA_GUEST.RATING_AGE IS
'  . .';

COMMENT ON COLUMN ENA_GUEST.COUNTRY_CODE IS
'    .        ISO. .';

COMMENT ON COLUMN ENA_GUEST.MASK IS
'  .         . .';

COMMENT ON COLUMN ENA_HOTEL.ID_HOTEL IS
'  . .';

COMMENT ON COLUMN ENA_HOTEL.HOTEL_NAME IS
'  . .';

COMMENT ON COLUMN ENA_HOTEL.CODE IS
'   . .';

COMMENT ON COLUMN ENA_HOTEL.SYSTEM_DATE IS
'     .                  ENA.                . .';

COMMENT ON COLUMN ENA_HOTEL.IS_USE IS
'    (  ). 0 -   , 1 -  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_HOTEL IS
'      .    ENA_HOTEL.ID_HOTEL. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_RESERV_DETAIL IS
'   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NUMBER IS
'  .    (   ). .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_GUEST_MAIN IS
'      .      .  -     .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME IS
'    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME2 IS
'       . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.FROM_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.TO_DATE IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NIGHTS IS
'. .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ADULT_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHILD_COUNT IS
'  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_EATING_OBJECT IS
'          . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHECK_STATUS IS
'  . -3 =  ; -2 =   ; -1 =  ; 0 =  ; 1 =  . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.IS_ANUL IS
'   . 0 - , 1 - .  -       0  1.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ID IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_NAME IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_TYPE IS
'      .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ACCOUNT_NO IS
'             .    . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SEGMENT_CODE IS
'   ''segment''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SOURCE_CODE IS
'   ''source''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_CHANNEL_CODE IS
'   ''channel''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_HEAR_CODE IS
'   ''hear reason''.   . .';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_COME_CODE IS
'   ''come reason''.   . .';

COMMENT ON COLUMN ENA_SERVICES.ID_HOTEL IS
'       . .';

COMMENT ON COLUMN ENA_SERVICES.ID_SERVICE IS
'   . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_NAME IS
'  . .';

COMMENT ON COLUMN ENA_SERVICES.GROUP_NAME IS
'    .            a       . .';

COMMENT ON COLUMN ENA_SERVICES.SERVICE_TYPE IS
'  .  : ''BASE'',''EXTRA'',''COMMISSION'',''MEAL''. ''BASE'' -    ,     ,''EXTRA'' -  , ''MEAL'' - , ''COMMISSION'' - ,        (  ). .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_GROUP IS
'       .  : ''ROOMS'', ''Food and Beverage'', ''Other Operated Departments'', ''Rentals and Other Income''. .';

COMMENT ON COLUMN ENA_SERVICES.REVENUE_ACCOUNT IS
' -      . .';

COMMENT ON COLUMN ENA_SERVICES.ACCOUNT_NAME IS
'      (. ),      .          . .';

COMMENT ON COLUMN ENA_SERVICES.EXT_CODE IS
'         . .';

COMMENT ON COLUMN ENA_SERVICES.IS_BREAKFAST IS
'   . 0 - , 1 - .    1,   SERVICE_TYPE e ''BASE''  ''MEAL''.  -          .';

COMMENT ON COLUMN ENA_SERVICES.IS_LUNCH IS
'   .   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_DINNER IS
'   .   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_EXTRAFOOD1 IS
'     1.   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.IS_EXTRAFOOD2 IS
'     2.   IS_BREAKFAST.';

COMMENT ON COLUMN ENA_SERVICES.ID_ROOM_TYPE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ). .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  -             .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_ROOM_EXT_CODE IS
'    ( )     ,      .  -        .';

COMMENT ON COLUMN ENA_SERVICES.TYPE_STAY_CODE IS
'    ,     ( SERVICE_TYPE = ''BASE'' ).  : ''ALONE'' -      , ''BED'' -            , ''EXTRA_BED'' -      . .';

COMMENT ON COLUMN OWNER_POST.POST_STATUS IS
'11  
22  ';

/* Create index... */
CREATE INDEX CEXPENSE_AGENT_IDX ON CONTRACT_EXPENSE$PMS(ID_AGENT_PROFILE);


/* Create Primary Key... */
ALTER TABLE PRODUCT_AVAILABILITY_OPTIONS ADD CONSTRAINT PK_PRODUCT_AVAILABILITY_OPTIONS PRIMARY KEY (ID_HOTEL);

/* Create Foreign Key... */
RECONNECT;

ALTER TABLE PRODUCT_AVAILABILITY_OPTIONS ADD CONSTRAINT FK_PAO_HOTEL FOREIGN KEY (ID_HOTEL) REFERENCES HOTEL (ID_HOTEL) ON UPDATE CASCADE ON DELETE CASCADE;

/*  Empty CONTRACT_EXPENSE_MODIFY$PMS for CONTRACT_EXPENSE_MODIFY$PMS(param list change)  */
SET TERM ^ ;

ALTER PROCEDURE CONTRACT_EXPENSE_MODIFY$PMS(ID_CONTRACT_EXPENSE /* TYPE OF ID */ INTEGER,
ID_CONTRACT /* TYPE OF ID */ INTEGER,
SUB_CONTRACT /* TYPE OF TSUB_CONTRACT */ VARCHAR(10),
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
SERVICE_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
CONTRACT_EXPENSE_TYPE VARCHAR(50),
MULTIPLIER_TYPE VARCHAR(50),
ORDER_TAG /* TYPE OF TCOUNT */ INTEGER,
IS_ACC_POST_ITEM /* TYPE OF TLOGICAL */ SMALLINT,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_EXPENSE /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/*  Empty CONTRACT_EXPENSE_POST$INT for PMS_RUNNING_TOTAL_GET(param list change)  */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_HOTEL INTEGER,
ID_CONTRACT /* TYPE OF ID */ INTEGER,
SUB_CONTRACT /* TYPE OF TSUB_CONTRACT */ VARCHAR(10),
ID_OWNER /* TYPE OF ID */ INTEGER,
OWNERSHIP_PERCENT /* TYPE OF TPERCENT */ NUMERIC(15,4),
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
POST_DATE /* TYPE OF TDATE */ DATE,
STAY /* TYPE OF TCOUNT */ INTEGER,
MAX_GUEST_CNT /* TYPE OF TCOUNT */ INTEGER,
BED_NIGHT_CNT /* TYPE OF TCOUNT */ INTEGER,
RESERVS /* TYPE OF TCOUNT */ INTEGER)
 AS
 BEGIN EXIT; END
^

/*  Empty IMPORT_GUEST$EXC for RES_GUEST_SAVE$RSV(param list change)  */
ALTER PROCEDURE IMPORT_GUEST$EXC(BOOKING_ID INTEGER,
PROFILE_UUID VARCHAR(40),
GUEST_UUID VARCHAR(40),
GUEST_NAME VARCHAR(100),
IS_CHILD SMALLINT,
AGE INTEGER,
IS_DIFFERENT_ARRANGER SMALLINT,
ARRIVAL DATE,
DEPARTURE DATE,
VOUCHER VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
RATING_AGE INTEGER,
KPP VARCHAR(50),
KPP_DATE DATE,
STAY_REASON VARCHAR(255),
CAR VARCHAR(30),
IS_REGISTRED SMALLINT,
PERSONAL_NUMBER VARCHAR(30),
TITLE VARCHAR(10),
PT_NAME VARCHAR(100),
PT_EXTCODE VARCHAR(50),
PASS_NUM VARCHAR(20),
PASS_PLACE VARCHAR(20),
PASS_DATE DATE,
PASS_EXP_DATE DATE,
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_DATE DATE,
SEX CHAR,
BIRTH_PLACE VARCHAR(30),
MASK VARCHAR(10),
PACKAGE VARCHAR(255),
VISA /* TDESCRIPTION_SHORT */ VARCHAR(100))
 RETURNS(GUEST_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure CONTRACT_EXPENSE_MODIFY$PMS with new param-list */
ALTER PROCEDURE CONTRACT_EXPENSE_MODIFY$PMS(ID_CONTRACT_EXPENSE TYPE OF ID,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
ID_SERVICE TYPE OF ID,
ID_CURRENCY TYPE OF TCURRENCY,
SERVICE_PRICE TYPE OF TPRICE,
CONTRACT_EXPENSE_TYPE VARCHAR(50),
MULTIPLIER_TYPE VARCHAR(50),
ORDER_TAG TYPE OF TCOUNT,
IS_ACC_POST_ITEM TYPE OF TLOGICAL,
ID_AGENT_PROFILE TYPE OF ID_REF,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_EXPENSE TYPE OF ID)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure PMS_RUNNING_TOTAL_GET with new param-list */
ALTER PROCEDURE PMS_RUNNING_TOTAL_GET(ID_PMS_EVENT TYPE OF ID_REF,
ID_OWNER TYPE OF ID_REF,
ID_HOTEL TYPE OF ID_REF,
ID_ACCOUNT TYPE OF ID_REF,
ID_ACCOUNT$PMS TYPE OF ID_REF,
POST_DATE TYPE OF TDATE,
TARGET_CURR TYPE OF TCURRENCY)
 RETURNS(RUNNING_TOTAL TYPE OF TPRICE)
 AS
 BEGIN SUSPEND; END
^

/* Alter empty procedure RES_GUEST_SAVE$RSV with new param-list */
ALTER PROCEDURE RES_GUEST_SAVE$RSV(ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
GUEST_NAME1 VARCHAR(100),
AGE INTEGER,
BIRTH_DAY DATE,
IS_CHILD INTEGER,
MASK VARCHAR(10) = null)
 RETURNS(NEW_ID_GUEST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_ADD$INT for: ACCOUNT_CHECK_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_POSTING_ADD$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_GUEST /* TYPE OF ID_REF */ INTEGER,
ID_SECQUENCE /* TYPE OF ID_REF */ INTEGER,
DATE_POST /* TYPE OF TDATE */ DATE,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_TARIFF /* TYPE OF ID_REF */ INTEGER,
ID_ROOM /* TYPE OF ID_REF */ INTEGER,
IS_BASE /* TYPE OF TLOGICAL */ SMALLINT,
QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
ORIG_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
RATE /* TYPE OF TRATE */ NUMERIC(15,6),
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
CHANGED_TEXT /* TYPE OF TTEXT_SHORT */ VARCHAR(30),
ID_MASTER_ADDINS_ACC_POST /* TYPE OF ID_REF */ INTEGER,
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
NEW_ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE$INT for: ACCOUNT_CHECK_CREDIT_STATUS$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE$INT(AP_DBKEY /* TYPE OF TDB_KEY */ CHAR(8),
ID_SERVICE /* TYPE OF ID_REF */ INTEGER,
ID_TARIFF /* TYPE OF ID_REF */ INTEGER,
ID_ROOM /* TYPE OF ID_REF */ INTEGER,
QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
QTY_FREE /* TYPE OF TQTY */ NUMERIC(15,2),
PRICE /* TYPE OF TVALUE */ DOUBLE PRECISION,
CURR /* TYPE OF TCURRENCY */ CHAR(3),
RATE /* TYPE OF TRATE */ NUMERIC(15,6),
CHANGED_TEXT VARCHAR(40),
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
IS_CONSEQUENTIAL_UPDATE /* TYPE OF TBOOLEAN */ SMALLINT = 0,
RE_ROUTE_ACCOUNT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(OUT_QTY_POST /* TYPE OF TQTY */ NUMERIC(15,2),
OUT_PRICE_POST /* TYPE OF TVALUE */ DOUBLE PRECISION,
OUT_AC VARCHAR(2))
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_CHECK_CREDIT_STATUS$INT) */
ALTER PROCEDURE ACCOUNT_CHECK_CREDIT_STATUS$INT(ID_ACCOUNT TYPE OF ID_REF,
POST_VALUE TYPE OF TPRICE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable is_credit_account integer;
  declare variable id_reserv_detail integer;
  declare variable credit_limit tprice;
  declare variable b_post_sum tprice;
  declare variable b_pay_sum tprice;
  declare variable difference_value tprice;
  declare variable no_use varchar(255);
  declare variable account_currency tcurrency;
  declare variable round_to numeric(15,4);
begin
  if (:POST_VALUE = 0) then exit;

  select a.IS_CREDIT_ACCOUNT, a.CREDIT_LIMIT, a.ID_RESERV_DETAIL
  from   ACCOUNT A
  where  a.ID_ACCOUNT = :ID_ACCOUNT
  into   :is_credit_account, :credit_limit, :id_reserv_detail;

  if (:is_credit_account = 0
      and exists (select rd.ID_RESERV_DETAIL
                  from   RESERV_DETAIL rd
                  where  rd.ID_RESERV_DETAIL = :id_reserv_detail
                         and rd.CHECK_STATUS = 1)) then
  begin
    execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, :credit_limit, 1);
  end

  if (coalesce(:credit_limit, 0) > 0) then begin
    /* FIND BALANCE OF ACCOUNT */
    execute procedure ACCOUNT_BALANCE$INT(:id_account)
    returning_values  :account_currency, :round_to, :no_use, :b_post_sum, :b_pay_sum, :no_use, :no_use;
    b_post_sum = coalesce(:b_post_sum, 0);
    b_pay_sum  = coalesce(:b_pay_sum, 0);

    /* IS THIS POST IS IN LIMIT */
    if ((:b_post_sum + :POST_VALUE) > :credit_limit) then begin
      err_code = -13; /*  */
      difference_value = :b_post_sum + :POST_VALUE - :credit_limit;
      err_text = f_character(29)||FormatFloat(:credit_limit, :round_to)||' '||:account_currency||
                 f_character(28)||FormatFloat(:difference_value, :round_to);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_ACCOUNT$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
QTY /* TYPE OF TQTY */ NUMERIC(15,2),
ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
FROM_DATE /* TYPE OF TDATE */ DATE,
TO_DATE /* TYPE OF TDATE */ DATE,
POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
DATE_POST /* TYPE OF TDATE */ DATE,
SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ROOM /* TYPE OF ID */ INTEGER = null,
POST_DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_GUEST$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ACCOUNT_ROUTING /* TYPE OF TSHORT_CODE */ VARCHAR(10),
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_TAR_CALC_REPOST$INT for: ACCOUNT_POSTING_ADD$INT */
ALTER PROCEDURE RES_TAR_CALC_REPOST$INT(ID_TAR_CALC /* TYPE OF ID_REF */ INTEGER,
ID_RESERV_DETAIL /* TYPE OF ID_REF */ INTEGER,
RECALC_MARKER VARCHAR(40))
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_ADD$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_ADD$INT(ID_ACCOUNT TYPE OF ID,
ID_GUEST TYPE OF ID_REF,
ID_SECQUENCE TYPE OF ID_REF,
DATE_POST TYPE OF TDATE,
ID_SERVICE TYPE OF ID,
ID_TARIFF TYPE OF ID_REF,
ID_ROOM TYPE OF ID_REF,
IS_BASE TYPE OF TLOGICAL,
QTY_POST TYPE OF TQTY,
PRICE TYPE OF TPRICE,
ORIG_CURRENCY TYPE OF TCURRENCY,
RATE TYPE OF TRATE,
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
POST_TEXT TYPE OF TDESCRIPTION_SHORT,
RESOURCE_TEXT TYPE OF TREASON,
CHANGED_TEXT TYPE OF TTEXT_SHORT,
ID_MASTER_ADDINS_ACC_POST TYPE OF ID_REF,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
NEW_ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable price_post double precision;
  declare variable post_rate numeric (15, 6);
  declare variable curr_post char(3);
  declare variable account_currency char(3);
  declare variable id_pack_service integer;
  declare variable id_room_type integer;
  declare variable room_name varchar(30);
  declare variable is_archive integer;
  declare variable id_tax_policy integer;
  declare variable id_sale_taxation integer;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable check_option varchar(255);
  declare variable id_hotel integer;
  declare variable id_srv_hotel integer;
  declare variable service_name varchar(30);
  declare variable account_name varchar(50);
begin
  ID_GUEST = nullif(:ID_GUEST, -1);

  execute procedure POST_PRICE_CHECK$INT (:QTY_POST, :PRICE, :ORIG_CURRENCY);

  if ( (:IS_BASE = 1) or (:ID_MASTER_ADDINS_ACC_POST > 0) ) then
    check_option = 'IS_BASE;ALLOW_POSTING';
  else
    check_option = 'IS_EXTRA;ALLOW_POSTING';

  execute procedure ACCOUNT_VALIDATE$INT(:id_account, :check_option)
  returning_values  (:err_code, :err_text, :account_currency, :id_tax_policy, :id_hotel, :account_name);
  if (:err_code < 0) then EXIT; --  exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;

  select s.ID_HOTEL, s.SERVICE_NAME
  from   SERVICES S
  where  s.ID_SERVICE = :ID_SERVICE
  into   :id_srv_hotel, :service_name;

  if (:id_srv_hotel is distinct from :id_hotel) then
    exception POSTING_EXCEPTION '-1056' || f_character(31) || f_character(29) || :service_name || f_character(28) || :account_name;

  if (:rate is null) then begin
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :orig_currency, :date_post, :id_guest)
    returning_values  :rate;
  end

  curr_post  = :account_currency;
  if (:orig_currency = :account_currency) then begin
    post_rate  = :rate;
  end else begin
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :account_currency, :date_post, :id_guest)
    returning_values  :post_rate;
  end

  execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :id_tax_policy, :ID_TARIFF, :DATE_POST - :FROM_DATE)
  returning_values (:id_sale_taxation);

  execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:QTY_POST, :PRICE,
                    :RATE, :post_rate, :id_sale_taxation)
  returning_values  :price_post, :post_net_value, :post_gross_value;

  execute procedure ACCOUNT_CHECK_CREDIT_STATUS$INT (:ID_ACCOUNT, :price_post * :QTY_POST)
  returning_values (:ERR_CODE, :ERR_TEXT);
  if (:ERR_CODE <> 0) then exit;

  --
  new_id_account_post = gen_id (id_account_post_gen, 1);

  if (:post_text starting with 'PACK') then begin
    id_pack_service = substring(:post_text from 6 for 20);
    post_text = '';
  end else begin
    id_pack_service = -1;
  end
  if (:is_base = 1) then id_master_addins_acc_post = :new_id_account_post;

  select R.ROOM_NAME, R.ID_ROOM_TYPE
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :room_name, :id_room_type;

  if (:id_guest is null) then begin
    is_archive = 1;
  end else begin
    select iif(G.CHECK_STATUS = 1, 1, 0)
    from   GUEST G
    where  G.ID_GUEST = :id_guest
    into   :is_archive;
  end

  insert into ACCOUNT_POST (
    ID_ACCOUNT_POST, ID_ACCOUNT, ID_GUEST, ID_SERVICE, ID_TARIFF, ID_ROOM,
    IS_BASE, DATE_POST, QTY_POST, QTY_FREE, PRICE_POST, POST_NET_VALUE, POST_GROSS_VALUE, CURR_POST, RATE_POST,
    PRICE_ORIG, CURR_ORIG, RATE_ORIG, IS_LOCKED_FOR_UPDATE, TO_DATE, FROM_DATE, ID_SEQUENCE,
    SHORT_CODE, CHANGED_TEXT, ID_MASTER_ADDINS_ACC_POST, ID_PACK_SERVICE, ROOM_NAME, ID_ROOM_TYPE,
    ID_SALE_TAXATION, AC, IS_ARCHIVE, IN_DOC_QTY, IN_DOC_VALUE, DESCRIPTION)
  values (
    :new_id_account_post, :id_account, :id_guest, :id_service, :id_tariff, coalesce(:id_room, -1),
    :is_base, :date_post, :qty_post, 0, :price_post, :post_net_value, :post_gross_value, :curr_post, :post_rate,
    :price, :orig_currency, :rate, 0, :TO_DATE, :FROM_DATE, :id_secquence,
    :short_code, :changed_text, :id_master_addins_acc_post, :id_pack_service, :room_name, :id_room_type,
    :id_sale_taxation, '00', :is_archive, 0, 0, :DESCRIPTION);

  if ((coalesce(:post_text, '') <> '') or (coalesce(:resource_text, '') <> '')) then begin
    insert into ACCOUNT_POSTING_DET (ID_ACCOUNT_POST, POST_TEXT, QTY, FROM_DATETIME, TO_DATETIME, RESOURCE_TEXT)
    values (:new_id_account_post, :post_text, :qty_post, :FROM_DATE, :TO_DATE, :resource_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_ANUL$DOC for: ACCOUNT_POSTING_DOC_UPDATE$INT */
ALTER PROCEDURE DOCUMENT_ANUL$DOC(ID_DOC_HEAD INTEGER,
ANUL_REASON VARCHAR(100),
MAKE_ANNUL_REPORT SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: DOCUMENT_VALIDATE$DOC for: ACCOUNT_POSTING_DOC_UPDATE$INT */
ALTER PROCEDURE DOCUMENT_VALIDATE$DOC(ID_DOC_HEAD /* TYPE OF ID_REF */ INTEGER)
 RETURNS(FIRM_DATA /* TYPE OF TNOTE_BLOB */ BLOB SUB_TYPE 1,
WARN_CODE /* TYPE OF TRANGE */ INTEGER,
NEW_DOC_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_POSTING_DOC_UPDATE$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_DOC_UPDATE$INT(DH_DBKEY TYPE OF TDB_KEY)
 RETURNS(WARN_CODE TYPE OF TRANGE)
 AS
declare variable date_post date;
  declare variable old_date_post date;
  declare variable curr_post varchar(3);
  declare variable old_curr_post varchar(3);
  declare variable rate_post numeric(15,6);
  declare variable curr_orig varchar(3);
  declare variable old_curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable dbkey char(8);
  declare variable id_account_post integer;
  declare variable doc_date date;
  declare variable doc_release_ap integer;
  declare variable qty_post numeric(15,2);
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable price_orig numeric(15,4);
  declare variable price_post double precision;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable id_sale_taxation integer;
  declare variable id_base_doc integer;
  declare variable doc_operation varchar(10);
  declare variable is_anul_doc integer;
  declare variable is_storno integer;
  declare variable id_doc_head integer;
  declare variable posts_value double precision;
  declare variable line_value double precision ;
  declare variable action_text varchar(255);
  declare variable action_code varchar(30);
  declare variable account_curr varchar(3);
  declare variable id_ap_base_doc integer;
  declare variable new_is_anul integer;
  declare variable new_is_closed integer;
  declare variable doc_qty numeric(15,2);
  declare variable doc_price double precision;
  declare variable id_hotel integer;
  declare variable round_to numeric(15,4);
  declare variable proforma_dt_created timestamp;
  declare variable new_ac varchar(2);
  declare variable id_tax_policy integer;
  declare variable id_service integer;
  declare variable nat_round_to numeric(15,4);
begin

  select D.ID_DOC_HEAD, iif(D.IS_ANUL = 0, D.DOC_DATE, DA.ANNULMENT_DATE),
         D.ID_BASE_DOC, D.IS_ANUL, D.IS_STORNO, a.ID_TAX_POLICY, c.ROUND_TO,
         A.ID_ACCOUNT, A.ACCOUNT_CURR, a.id_hotel, pd.DATETIME_CREATED
  from   DOC_HEAD$INT D
         join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join HOTEL h on h.ID_HOTEL = a.ID_HOTEL
         join CURRS c on c.CURR = h.NATION_CURR
         left outer join DOC_ANNULMENT DA on DA.ID_DOC_HEAD = D.ID_DOC_HEAD
         left outer join DOC_HEAD$INT pd on pd.ID_DOC_HEAD = dc.ID_DOC_PROFORMA
  where  D.RDB$DB_KEY = :DH_DBKEY
  into   :id_doc_head, :doc_date, :id_base_doc, :is_anul_doc, :is_storno, :id_tax_policy, :nat_round_to,
         :id_account, :account_curr, :id_hotel, :proforma_dt_created;

  if (:id_doc_head is null) then exit;

  doc_operation = case when :is_anul_doc = 1 then 'anul'
                       when :is_storno   = 1 then 'storno'
                       else 'new'
                  end;

  doc_release_ap = -gen_id(DOC_SELECTED_GEN, 1);
  /*   */
  posts_value = 0;
  if (:doc_operation = 'new') then begin
    for
      select AP.RDB$DB_KEY, AP.ID_ACCOUNT_POST, DL.QTY_POST, PV.ACCOUNT_PRICE,
             ap.QTY_POST, ap.PRICE_POST, c.ROUND_TO
      from   ACCOUNT_POST AP
             join DOC_LINE_POST_VALUES PV on PV.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
             join DOC_LINE DL on DL.ID_DOC_LINE = PV.ID_DOC_LINE
             join CURRS C on c.CURR = ap.CURR_POST
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
      into   :dbkey, :id_account_post, :doc_qty, :doc_price,
             :qty_post, :price_post, :round_to
    do begin
      posts_value = :posts_value + :doc_price * :doc_qty;  -- logable value accumulation
      /*  if (:is_anul = 1) - annul corrective document, else - new valid document */
      /* annulment/storno of base document is in other case - operation "anul"  */
      if (:proforma_dt_created is not null) then begin
        new_is_anul = 0;
        new_is_closed = iif(cast(round_f(:qty_post - :doc_qty, :round_to) as numeric(15,2)) = 0
                            and cast(round_f(:price_post - :doc_price, :round_to) as numeric(15,2)) = 0,
                            1,
                            0);
      end else begin
        new_is_anul = 0;
        new_is_closed = 1;
        doc_qty = :qty_post;
        doc_price = :price_post;
      end

      update ACCOUNT_POST AP
      set    AP.ID_BASE_DOC   = :id_base_doc,
             AP.IN_DOC_QTY    = :doc_qty,
             AP.IN_DOC_VALUE  = :doc_price,
             AP.IS_ANUL       = :new_is_anul,
             AP.AC            = :new_is_anul || :new_is_closed,
             AP.DOC_SELECTED  = :doc_release_ap,
             AP.DATETIME_CHANGED = current_timestamp
      where  AP.RDB$DB_KEY = :DBKEY
      returning ap.ac into :new_ac;
      if (:new_ac = '00') then begin
        execute procedure SYSTEM_WARNING_ADD (-1061, '')
        returning_values (:warn_code);
      end

      update ACCOUNT_POST_CORRECTION APCU
      set    APCU.ID_DOC_HEAD  = iif(apcu.DATETIME_CREATED < coalesce(:proforma_dt_created, current_timestamp), :ID_DOC_HEAD, -1),
             APCU.IS_OPEN      = iif(apcu.DATETIME_CREATED < coalesce(:proforma_dt_created, current_timestamp), 0, 1)
      where  APCU.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
             and coalesce(APCU.ID_DOC_HEAD, -1) = -1;
    end

    action_text = f_character(29) || formatfloat(abs(:posts_value), 'F;0.00') || ' ' || :account_curr;
    action_code = 'CLOSE_POSTINGS';
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, :action_code, :action_text);

  end else if (:doc_operation in ('anul', 'storno')) then begin
    /* annulment/storno of base document - release all postings */
    /*   */
    old_date_post = '01.01.1900';
    old_curr_post = '';
    old_curr_orig = '';
    posts_value = 0;
    /*   */
    for
      select distinct AP.RDB$DB_KEY, AP.ID_ACCOUNT, AP.ID_GUEST, AP.ID_SALE_TAXATION, AP.ID_BASE_DOC,
             AP.QTY_POST, AP.PRICE_POST, AP.DATE_POST, AP.CURR_POST, AP.CURR_ORIG, AP.PRICE_ORIG,
             AP.ID_ACCOUNT_POST, AP.POST_NET_VALUE, AP.POST_GROSS_VALUE, AP.RATE_POST, AP.RATE_ORIG,
             PV.ACCOUNT_PRICE * DL.QTY_POST, c.ROUND_TO, ap.ID_SERVICE
      from   ACCOUNT_POST AP
             join DOC_LINE_POST_VALUES PV on PV.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
             join DOC_LINE DL on DL.ID_DOC_LINE = PV.ID_DOC_LINE
             join CURRS C on c.CURR = ap.CURR_POST
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
      order by AP.DATE_POST, AP.CURR_POST, AP.CURR_ORIG
      into   :dbkey, :id_account, :id_guest, :id_sale_taxation, :id_ap_base_doc,
             :qty_post, :price_post, :date_post, :curr_post, :curr_orig, :price_orig,
             :id_account_post, :post_net_value, :post_gross_value, :rate_post, :rate_orig,
             :line_value, :round_to, :id_service
    do begin
      if (:id_ap_base_doc is not null and :id_ap_base_doc is distinct from :id_base_doc) then
        exception DOCUMENT_EXCEPTION '-365';

      doc_qty = null;
      doc_price = 0;
      if (:DOC_OPERATION = 'anul') then begin
        select sum(DL.QTY_POST * (1 - DL.IS_CORRECT)) as DOC_QTY,
               sum(DLP.ACCOUNT_PRICE * DL.QTY_POST) /* / sum(DL.QTY_POST * (1 - DL.IS_CORRECT))*/ as DOC_VALUE
        from   DOC_HEAD DH
               join DOC_LINE DL on DL.ID_DOC_HEAD = DH.ID_DOC
               join DOC_LINE_POST_VALUES DLP on dlp.ID_DOC_LINE = dl.ID_DOC_LINE
        where  DH.IS_ANUL = 0
               and DLP.ID_ACCOUNT_POST = :id_account_post
               and DH.ID_BASE_DOC = :id_base_doc
        into   :doc_qty, :doc_price;
        if (:doc_qty = 0) then doc_price = 0;
        else doc_price = :doc_price / :doc_qty;
      end

      if (:doc_qty is null) then begin
        -- update prices only for released posting
        select tp.ID_SALE_TAXATION
        from   SERVICE_TAXATION tp
        where  tp.ID_TAX_POLICY = :id_tax_policy
               and tp.ID_SERVICE = :id_service
        into   :id_sale_taxation;  -- get actual taxation

        if (:date_post >= :doc_date) then begin
          /* update rates for prepaid postings (date_post >= doc_date) if base doc is annul */
          if ((:old_date_post <> :date_post) or (:old_curr_post <> :curr_post) ) then begin
            execute procedure ACCOUNT_POSTING_RATE_GET (:id_hotel, :curr_post, :date_post, :id_guest)
            returning_values  :RATE_POST;
          end
    
          if ((:OLD_DATE_POST <> :DATE_POST) or (:OLD_CURR_ORIG <> :CURR_ORIG) ) then begin
            execute procedure ACCOUNT_POSTING_RATE_GET (:id_hotel, :curr_orig, :date_post, :id_guest)
            returning_values  :rate_orig;
          end
  
          execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:qty_post, :price_orig,
                            :rate_orig, :rate_post, :id_sale_taxation)
          returning_values  :price_post, :post_net_value, :post_gross_value;
        end else begin
          -- recalc only nat net value with actual taxation
          select tv.VALUE_WOT_TAX
          from   TAX_VALUE_DEDUCT (:qty_post * :price_post * :rate_post, :nat_round_to, :id_sale_taxation) tv
          into   :post_net_value;
        end
      end

      new_is_anul = iif(:qty_post = 0 and :doc_qty is null, 1, 0);
      new_is_closed = iif(:doc_qty is not null
                          and cast(round_f(:qty_post - :doc_qty, :round_to) as numeric(15,2)) = 0
                          and cast(round_f(:price_post - :doc_price, :round_to)  as numeric(15,2)) = 0,
                          1,
                          0);

      update ACCOUNT_POST AP
      set    AP.IN_DOC_VALUE  = iif(:doc_qty is null, 0, :doc_price),
             AP.IN_DOC_QTY    = iif(:doc_qty is null, 0, :doc_qty),
             AP.RATE_ORIG     = :rate_orig,
             AP.RATE_POST     = :rate_post,
             AP.PRICE_POST    = :price_post,
             AP.POST_NET_VALUE = :post_net_value,
             AP.POST_GROSS_VALUE = :post_gross_value,
             AP.ID_SALE_TAXATION  = :id_sale_taxation,
             AP.ID_BASE_DOC   = iif(:doc_qty is null, null, :ID_BASE_DOC),
             AP.IS_ANUL       = :new_is_anul,
             AP.AC            = :new_is_anul || :new_is_closed,
             AP.ANUL_DATETIME = iif(:new_is_anul = 1, current_timestamp, ap.anul_datetime),
             AP.DATETIME_CHANGED = current_timestamp
      where  AP.RDB$DB_KEY = :DBKEY;

      if (:doc_operation = 'anul') then begin
        update ACCOUNT_POST_CORRECTION APCU
        set    APCU.ID_DOC_HEAD  = -1,
               APCU.IS_OPEN      = iif(:DOC_QTY is not null, 1, apcu.IS_OPEN)
        where  APCU.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and APCU.ID_DOC_HEAD = :ID_DOC_HEAD;
      end else begin  -- 'storno'
        update ACCOUNT_POST_CORRECTION APCU
        set    APCU.ID_DOC_HEAD  = -1,
               APCU.IS_OPEN      = iif(:DOC_QTY is not null, 1, apcu.IS_OPEN)
        where  APCU.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and APCU.ID_DOC_HEAD in (select d.ID_DOC from DOC_HEAD d where d.ID_BASE_DOC = :id_base_doc);
      end

      old_curr_post = :curr_post;
      old_curr_orig = :curr_orig;

      posts_value = :posts_value + :line_value;
    end  /* for select ... do begin  */

    action_text = f_character(29) || formatfloat(abs(:posts_value), 'F;0.00') || ' ' || :account_curr;
    action_code = 'OPEN_POSTINGS';
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, :action_code, :action_text);
  end  /* call type in (STORNO, ANUL)  */
end
^

/* Alter (ACCOUNT_POSTING_UPDATE) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable in_db_key char(8);
begin
  /* GUI facade for manual update */
  select AP.ID_ACCOUNT, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date)
  returning_values  (:new_qty_post, :new_price_post, :new_ac);

  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    action_text = f_character(29) || :action_text
                  || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                  || f_character(28) || :log_old_value
                  || f_character(28) || :log_new_value
                  || f_character(28) || replace(:IN_CHANGED_TEXT, 'MANUAL', '');
    execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
  end

end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_TRANSFER$INT for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER,
IS_MANUAL_TRANSFER /* TYPE OF TLOGICAL */ SMALLINT = 1)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_UPDATE_PERC for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_PERC(IN_ID_ACCOUNT_POST VARCHAR(4000),
IN_PERC NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(30))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_POSTING$INT for: ACCOUNT_POSTING_UPDATE$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_POSTING$INT(ID_RESOURCE_RESERVATION /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
PRICE_DESCRIPTION /* TYPE OF TDESCRIPTION_SHORT */ VARCHAR(100),
ID_RESERV_DETAIL /* TYPE OF ID */ INTEGER,
ID_EXTERNAL_CLIENT_ACCCOUNT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(DOC_SELECTED /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ACCOUNT_POSTING_UPDATE$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE$INT(AP_DBKEY TYPE OF TDB_KEY,
ID_SERVICE TYPE OF ID_REF,
ID_TARIFF TYPE OF ID_REF,
ID_ROOM TYPE OF ID_REF,
QTY_POST TYPE OF TQTY,
QTY_FREE TYPE OF TQTY,
PRICE TYPE OF TVALUE,
CURR TYPE OF TCURRENCY,
RATE TYPE OF TRATE,
CHANGED_TEXT VARCHAR(40),
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
IS_CONSEQUENTIAL_UPDATE TYPE OF TBOOLEAN = 0,
RE_ROUTE_ACCOUNT TYPE OF ID_REF = null)
 RETURNS(OUT_QTY_POST TYPE OF TQTY,
OUT_PRICE_POST TYPE OF TVALUE,
OUT_AC VARCHAR(2))
 AS
declare variable date_post date;
  declare variable orig_is_base integer;
  declare variable orig_id_service integer;
  declare variable orig_id_room integer;
  declare variable orig_short_code varchar(255);
  declare variable orig_qty_post integer;
  declare variable orig_ac varchar(2);
  declare variable is_locked_for_update integer;
  declare variable orig_locked_for_update integer;
  declare variable orig_id_tariff integer;
  declare variable orig_id_guest integer;
  declare variable id_type_stay integer;
  declare variable id_room_type integer;
  declare variable id_board integer;
  declare variable id_pack_service integer;
  declare variable new_id_pack_service integer;
  declare variable post_currency char(3);
  declare variable room_name varchar(30);
  declare variable original_post varchar(30);
  declare variable new_ac varchar(2);
  declare variable orig_in_doc_qty numeric(15,2);
  declare variable orig_in_doc_value double precision;
  declare variable rate_post numeric(15,6);
  declare variable id_base_doc integer;
  declare variable id_tax_policy integer;
  declare variable price_post double precision;
  declare variable post_net_value numeric(15,4);
  declare variable post_gross_value numeric(15,4);
  declare variable id_sale_taxation integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable orig_price_post tprice;
  declare variable round_to numeric(15,4);
  declare variable account_name tobject_name;
  declare variable err_code integer;
  declare variable err_text varchar(100);
  declare variable id_account integer;
  declare variable orig_id_master_addins_acc_post integer;
  declare variable check_options varchar(255);
begin
  /* GET DATA */
  original_post = '';
  new_id_pack_service = null;

  select AP.DATE_POST, AP.IS_BASE, AP.ID_SERVICE, AP.ID_BASE_DOC,
         AP.SHORT_CODE, AP.QTY_POST, ap.PRICE_POST, AP.IS_LOCKED_FOR_UPDATE,
         AP.AC, AP.ID_TARIFF, AP.ID_GUEST, AP.ID_ROOM,
         AP.ID_PACK_SERVICE, AP.ID_ROOM_TYPE,
         AP.IN_DOC_QTY, AP.IN_DOC_VALUE, AP.RATE_POST, ap.ID_SALE_TAXATION,
         ap.ID_ACCOUNT, ap.ID_ACCOUNT_POST, ap.ID_MASTER_ADDINS_ACC_POST
  from   ACCOUNT_POST AP
  where  AP.rdb$db_key = :AP_DBKEY
  into   :date_post, :orig_is_base, :orig_id_service, :id_base_doc,
         :orig_short_code, :orig_qty_post, :orig_price_post, :orig_locked_for_update,
         :orig_ac, :orig_id_tariff, :orig_id_guest, :orig_id_room,
         :id_pack_service, :id_room_type,
         :orig_in_doc_qty, :orig_in_doc_value, :rate_post, :id_sale_taxation,
         :id_account, :id_account_post, :orig_id_master_addins_acc_post;

  check_options = 'ALLOW_POSTING;';
  if (:RE_ROUTE_ACCOUNT is not null and :id_base_doc is null and :id_account <> :RE_ROUTE_ACCOUNT) then begin
    -- IMPORTANT !!! Re-routing is possible only in this case!
    id_account = :RE_ROUTE_ACCOUNT;
    if ( (:orig_is_base = 1) or (:orig_id_master_addins_acc_post > 0) ) then
      check_options = :check_options || 'IS_BASE;';
    else
      check_options = :check_options || 'IS_EXTRA;';
  end
  is_locked_for_update = :orig_locked_for_update; /* to initialize and preserve from null */

  if (:IS_CONSEQUENTIAL_UPDATE is distinct from 1) then begin
    -- direct post update - manual edition restrictions check
    if (:QTY_POST = -1) then QTY_POST = :orig_qty_post;   -- preserve current qty

    if (:QTY_POST <> :orig_qty_post) then exception POSTING_EXCEPTION '-379';

    if ((:orig_is_base = 1) and ((:QTY_POST <> 1) or (:ID_SERVICE <> :orig_id_service))) then
      exception POSTING_EXCEPTION '-223';

    if (:orig_ac = '01') then execute procedure RIGHTS_CHECK_GRANTED$INT('BALANCES_EDIT_CLOSED');

    short_code = :orig_short_code;
    id_tariff  = :orig_id_tariff;
    id_room    = :orig_id_room;
    is_locked_for_update = 1;  /* manual corrections must lock the postings  */

  end else begin
    /* post changes is a result from some user operation, indirect update ('NORMAL', 'FORCED', safes recalc, etc....) */
    is_locked_for_update = iif(:CHANGED_TEXT = 'TRANSFER_POSTING', :orig_locked_for_update, 0);

    if (:orig_is_base = 1) then begin
      /* PREPARING THE PACKET SERVICE */
      select Sp.ID_TYPE_STAY, Sp.ID_ROOM_TYPE, s.ID_HOTEL
      from   SERVICE_PACKET Sp
             join SERVICES s on s.ID_SERVICE = sp.ID_SERVICE
      where  s.ID_SERVICE = :id_service
      into   :id_type_stay, :id_room_type, :id_hotel;

      select GS.ID_BOARD
      from   GUEST_STAY GS
      where  GS.ID_GUEST = :orig_id_guest
             and GS.FOR_DATE = :date_post
      into   :id_board;

      execute procedure TAR_GET_BASE_SERVICE$INT(:id_type_stay, :id_room_type, :id_board, :id_hotel)
      returning_values  :id_pack_service;
      /* detecting change of STAY_TYPE or ROOM_TYPE */
      if (exists(
        select *
        from   SERVICE_PACKET S
        where  S.ID_SERVICE = :orig_id_service
               and ((S.ID_TYPE_STAY is distinct from :id_type_stay) or (S.ID_ROOM_TYPE is distinct from :id_room_type))
      )) then original_post = 'CHANGED';
    end
  end

  select R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = :id_room
  into   :room_name;

  if (:orig_locked_for_update = 1
      and :changed_text starting with 'NORMALRECALC'
      and :id_service = :orig_id_service
      --and :orig_is_anul = 0
      and :id_tariff = :orig_id_tariff) then
  begin
    -- price is locked for update
    update ACCOUNT_POST AP
    set    AP.ID_ROOM      = :ID_ROOM,
           AP.ROOM_NAME    = :room_name,
           Ap.FROM_DATE    = :FROM_DATE,
           Ap.TO_DATE      = :TO_DATE,
           AP.ID_PACK_SERVICE  = :id_pack_service,
           AP.CHANGED_TEXT     = :CHANGED_TEXT,
           AP.USER_CHANGED     = current_user,
           AP.DATETIME_CHANGED = current_timestamp,
           AP.SHORT_CODE       = :SHORT_CODE
    where  AP.rdb$db_key   = :AP_DBKEY;
    OUT_QTY_POST = :orig_qty_post;
    OUT_PRICE_POST = :orig_price_post;
    OUT_AC = :orig_ac;
  end else begin
    -- fully update
    execute procedure ACCOUNT_VALIDATE$INT(:id_account, :check_options)
    returning_values  (:err_code, :err_text, :post_currency, :id_tax_policy, :id_hotel, :account_name);
    if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;
  
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :curr, :date_post, :orig_id_guest)
    returning_values  :rate;
  
    execute procedure ACCOUNT_POSTING_RATE_GET(:id_hotel, :post_currency, :date_post, :orig_id_guest)
    returning_values  :rate_post;
  
    if (:id_base_doc is null) then begin
      execute procedure ACCOUNT_POSTING_TAXATION_GET (:ID_SERVICE, :id_tax_policy, :ID_TARIFF, :date_post - :from_date)
      returning_values (:id_sale_taxation);
    end

    execute procedure ACCOUNT_POSTING_PRICE_CALC$INT (:QTY_POST, :PRICE,
                      :RATE, :rate_post, :id_sale_taxation)
    returning_values  :price_post, :post_net_value, :post_gross_value;

    select c.ROUND_TO
    from   CURRS c
    where  c.CURR = :post_currency
    into   :round_to;

    if ( (:id_base_doc is not null)
         and (:qty_post = :orig_in_doc_qty)
         and (round_f(:price_post * :qty_post - :orig_in_doc_value * :orig_in_doc_qty, :round_to) = 0))
    then new_ac = '01';
    else new_ac = '00';                   
  
    if (:new_ac = '00') then begin
      execute procedure ACCOUNT_CHECK_CREDIT_STATUS$INT (:id_account, :price_post * :QTY_POST - :orig_price_post * :orig_qty_post)
      returning_values (:err_code, :err_text);
      if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text;
    end

    update ACCOUNT_POST AP
    set    AP.ID_ACCOUNT           = :id_account,
           AP.ID_SERVICE           = :id_service,
  
           AP.QTY_POST             = :qty_post,
           AP.QTY_FREE             = :qty_free,
           AP.PRICE_POST           = :price_post,
           AP.CURR_POST            = :post_currency,
           AP.RATE_POST            = :rate_post,
           AP.RATE_ORIG            = :rate,
           AP.PRICE_ORIG           = :price,
           AP.CURR_ORIG            = :curr,
           AP.POST_NET_VALUE       = :post_net_value,
           AP.POST_GROSS_VALUE     = :post_gross_value,
  
           AP.AC                   = :new_ac,
           AP.IS_ANUL              = 0,
           AP.ANUL_REASON          = '',
           AP.IS_LOCKED_FOR_UPDATE = :is_locked_for_update,
           AP.ID_TARIFF            = :id_tariff,
           AP.ID_PACK_SERVICE      = :id_pack_service,
           AP.ID_ROOM              = :id_room,
           AP.ID_ROOM_TYPE         = :id_room_type,
           AP.ROOM_NAME            = :room_name,
           AP.ID_SALE_TAXATION     = :id_sale_taxation,
           AP.ORIGINAL_POST        = :original_post,
           AP.SHORT_CODE           = :short_code,
           AP.CHANGED_TEXT         = :changed_text,
           AP.USER_CHANGED         = current_user,
           AP.DATETIME_CHANGED     = current_timestamp,
           Ap.FROM_DATE            = :from_date,
           Ap.TO_DATE              = :to_date
    where  AP.rdb$db_key = :AP_DBKEY
    returning new.id_account_post, new.id_pack_service
    into   :id_account_post, :new_id_pack_service;
  
    if (:new_ac = '01') then begin
      update ACCOUNT_POST_CORRECTION APC
      set    APC.IS_OPEN = 0
      where  APC.ID_ACCOUNT_POST = :id_account_post
             and APC.IS_OPEN = 1;
    end

    if (:orig_is_base = 1 and :new_id_pack_service <> :id_pack_service) then begin
      -- update add_inses with new pack service
      update ACCOUNT_POST AP
      set    ap.ID_PACK_SERVICE = :new_id_pack_service
      where  ap.ID_MASTER_ADDINS_ACC_POST = :id_account_post
             and ap.IS_BASE = 0;
    end

    OUT_QTY_POST = :qty_post;
    OUT_PRICE_POST = :price_post;
    OUT_AC = :new_ac;
  end
end
^

/* Alter (ACCOUNT_POSTING_UPDATE_PERC) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE_PERC(IN_ID_ACCOUNT_POST VARCHAR(4000),
IN_PERC NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(30))
 AS
declare variable id_account_post integer;
  declare variable ap_dbkey char(8);
  declare variable id_service integer;
  declare variable id_tariff integer;
  declare variable id_room integer;
  declare variable id_account integer;
  declare variable qty_post numeric (15,4);
  declare variable qty_free numeric (15,4);
  declare variable short_code varchar(255);
  declare variable curr_post char(3);
  declare variable price_post numeric (15,4);
  declare variable new_qty_post numeric (15,4);
  declare variable new_price_post numeric (15,4);
  declare variable orig_currency char(3);
  declare variable orig_rate numeric (15,4);
  declare variable orig_price numeric (15,4);
  declare variable new_orig_price double precision;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
  declare variable date_post date;
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
begin
  for
    select item
    from   SYSTEM_STRING_PARSER(:in_id_account_post, ',')
    into   :id_account_post
  do begin
    select AP.rdb$db_key, AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, ap.ID_ACCOUNT,
           AP.QTY_POST, ap.PRICE_POST, ap.CURR_POST, ap.DATE_POST,
           AP.QTY_FREE, AP.SHORT_CODE, AP.CURR_ORIG, AP.RATE_ORIG, AP.PRICE_ORIG,
           ap.FROM_DATE, ap.TO_DATE
    from   ACCOUNT_POST AP
    where  AP.ID_ACCOUNT_POST = :id_account_post
    into   :ap_dbkey, :id_service, :id_tariff, :id_room, :id_account,
           :qty_post, :price_post, :curr_post,:date_post,
           :qty_free, :short_code, :orig_currency, :orig_rate, :orig_price,
           :from_date, :to_date;

    new_orig_price = :orig_price + :orig_price * :in_perc;

    execute procedure ACCOUNT_POSTING_UPDATE$INT(:ap_dbkey,
            :id_service, :id_tariff, :id_room,
            :qty_post, :qty_free, :new_orig_price, :orig_currency, :orig_rate,
            :in_changed_text, :short_code, :from_date, :to_date)
    returning_values  :new_qty_post, :new_price_post, :no_use;

    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :id_service
    into   :action_text;

    log_old_value = formatfloat(:qty_post * :price_post, 'F;0.00') || ' ' || :curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :curr_post;
    action_text = f_character(29) || :action_text
                  || f_character(28) || formatfloat(:IN_PERC*100, 'F;0.0') || '%'
                  || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                  || f_character(28) || :log_old_value
                  || f_character(28) || :log_new_value
                  || f_character(28) || replace(:IN_CHANGED_TEXT, 'MANUAL', '');
    execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_PERC_UPDATE', :action_text);
  end
end
^

/* Alter (AVAILABILITY_OCCUPANCY$RPT) */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$RPT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
RELEASE_DATES INTEGER = 0,
OVERBOOK INTEGER = 0,
RES_CONFIRMED INTEGER = 1,
RES_NOTCONFIRMED INTEGER = 1,
RES_WAITING INTEGER = 0,
BOOKING_POSITIONS INTEGER = 0,
CONTINGENT INTEGER = 0)
 RETURNS(ID_ROOM_TYPE INTEGER,
FOR_DATE DATE,
ID_PROFILE INTEGER,
ROOMS_CAPACITY SMALLINT,
ROOMS_OOI SMALLINT,
ROOMS_OOO SMALLINT,
ROOMS_SOLD SMALLINT,
ROOMS_CONFIRMED SMALLINT,
ROOMS_NOTCONFIRMED SMALLINT,
ROOMS_WAITING SMALLINT,
ROOMS_TOTAL_SOLD SMALLINT,
ROOMS_OCCUPIED SMALLINT,
ROOMS_AVAILABLE SMALLINT,
ROOMS_SOLD_MULTIPLE_GST SMALLINT,
ROOMS_ARRIVAL SMALLINT,
ROOMS_DEPARTURE SMALLINT,
GUESTS_IN_HOUSE BIGINT,
GUESTS_ARRIVAL BIGINT,
GUESTS_DEPARTURE BIGINT)
 AS
begin

  execute procedure AVAILABILITY_OCCUP_PREPARE$AVL (
          :FROM_DATE,
          :TO_DATE,
          1,
          coalesce(:RELEASE_DATES, 0),
          coalesce(:OVERBOOK, 0),
          coalesce(:RES_CONFIRMED, 1),
          coalesce(:RES_NOTCONFIRMED, 1),
          coalesce(:RES_WAITING, 0),
          coalesce(:BOOKING_POSITIONS, 0),
          coalesce(:CONTINGENT, 0),
          :ID_HOTEL);

  for
    select SO.ID_ROOM_TYPE,
           SO.FOR_DATE,
           pa.id_profile,
           sum(SO.G_CAPACITY),
           sum(so.G_OOI),
           sum(so.G_OOO),
           sum(so.SOLD),
           sum(so.RES_CONFIRMED),
           sum(so.RES_NOTCONFIRMED),
           sum(so.RES_WAITING),
           sum(so.OCCUPIED),
           sum(so.AVAILABLE),
           sum(iif(so.GUESTS_INHOUSE > 1, so.SOLD, 0)),
           sum(so.ROOMS_COME),
           sum(so.ROOMS_GONE),
           sum(so.GUESTS_INHOUSE),
           sum(so.GUESTS_COME),
           sum(so.GUESTS_GONE)
    from   SMART_OCCUP$TMP SO
           left outer join PROFILE_AGENT pa on pa.id_agent = so.id_agent
    group by 1, 2, 3
    into   :ID_ROOM_TYPE, :FOR_DATE, :id_profile, :ROOMS_CAPACITY, :ROOMS_OOI, :ROOMS_OOO,
           :ROOMS_SOLD, :ROOMS_CONFIRMED, :ROOMS_NOTCONFIRMED, :ROOMS_WAITING, :ROOMS_OCCUPIED, :ROOMS_AVAILABLE,
           :ROOMS_SOLD_MULTIPLE_GST, :ROOMS_ARRIVAL, :ROOMS_DEPARTURE,
           :GUESTS_IN_HOUSE, :GUESTS_ARRIVAL, :GUESTS_DEPARTURE
  do begin
    ROOMS_TOTAL_SOLD = :ROOMS_SOLD
                       + iif(:RES_CONFIRMED = 1, :ROOMS_CONFIRMED, 0)
                       + iif(:RES_NOTCONFIRMED = 1, :ROOMS_NOTCONFIRMED, 0)
                       + iif(:RES_WAITING = 1, :ROOMS_WAITING, 0);
    suspend;
  end
end
^

/* Alter (CHANNEL_IDSGDS_AVAILABILITY$EXC) */
ALTER PROCEDURE CHANNEL_IDSGDS_AVAILABILITY$EXC(CHANNEL_NAME VARCHAR(30),
ID_HOTEL INTEGER)
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_SIMPLE_RATE INTEGER,
ID_BOARD INTEGER,
ROOM_STATUS INTEGER,
RATE_STATUS INTEGER,
PRODUCT_STATUS INTEGER,
AVAILABLE_ROOMS INTEGER,
MIN_LOS INTEGER,
MAX_LOS INTEGER,
SINGLE_PRICE NUMERIC(15,4),
DOUBLE_PRICE NUMERIC(15,4),
GUEST3_PRICE NUMERIC(15,4),
GUEST4PLUS_PRICE NUMERIC(15,4),
CHILD1_W_ADULT1_PRICE NUMERIC(15,4),
CHILD1_W_ADULT2PLUS_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT1_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT2PLUS_PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3))
 AS
declare variable date_from date;
declare variable date_to date;
declare variable id_channel integer;
declare variable rate_found integer;
begin
  --product_status 0 - closed
  --product_status 1 - closed for arrival
  --product_status 2 - opened

  select min(CA.FOR_DATE), max(CA.FOR_DATE), min(C.ID_CHANNEL)
  from   CHANNEL_ALLOTMENT CA
         join CHANNEL C on C.ID_CHANNEL = CA.ID_CHANNEL
         join ROOM_TYPES RT on RT.ID_ROOM_TYPE = CA.ID_ROOM_TYPE
  where  C.NAME = :channel_name
         and CA.FOR_DATE >= current_date
         and RT.ID_HOTEL = :id_hotel
  into   :date_from, :date_to, :id_channel;
  if (:date_from is null) then exit;

  for
    select PA.FOR_DATE, PA.ID_ROOM_TYPE, PA.ID_TAR_HEAD,
           PA.ROOM_STATUS, PA.RATE_STATUS, PA.PRODUCT_STATUS,
           PA.AVAILABLE_ROOMS, PA.MIN_LOS, PA.MAX_LOS, T.CURR
    from   PRODUCT_AVAILABILITY$AVL(:id_channel, :id_hotel, :date_from, :date_to, '', '') PA
           left outer join TARIFA T on T.ID_TARIFA = PA.ID_TAR_HEAD
           left outer join TAR_SIMPLE TS on TS.ID_TAR_HEAD = PA.ID_TAR_HEAD
    where  ((PA.ID_TAR_HEAD is null) or (TS.ID_TAR_SIMPLE is not null))
    into   :for_date, :id_room_type, :id_simple_rate,
           :room_status, :rate_status, :product_status,
           :available_rooms, :min_los, :max_los, :price_currency
  do begin
    rate_found = 0;
    single_price = null;
    double_price = null;
    guest3_price = null;
    guest4plus_price = null;
    child1_w_adult1_price = null;
    child1_w_adult2plus_price = null;
    child2plus_w_adult1_price = null;
    child2plus_w_adult2plus_price = null;
    for
      select TSP.SINGLE_PRICE, TSP.DOUBLE_PRICE, TSP.GUEST3_PRICE, TSP.GUEST4PLUS_PRICE,
             TSP.CHILD1_W_ADULT1_PRICE, TSP.CHILD1_W_ADULT2PLUS_PRICE, TSP.CHILD2PLUS_W_ADULT1_PRICE, TSP.CHILD2PLUS_W_ADULT2PLUS_PRICE,
             TSP.ID_BOARD
      from   TAR_SIMPLE TS
             join TAR_SIMPLE_SEASON TSS on TS.ID_TAR_SIMPLE = TSS.ID_TAR_SIMPLE
             join TAR_SIMPLE_SEASON_PERIODS TSSP on TSS.ID_TAR_SIMPLE_SEASON = TSSP.ID_TAR_SIMPLE_SEASON
             join TAR_SIMPLE_PRICE TSP on TSSP.ID_TAR_SIMPLE_SEASON = TSP.ID_TAR_SIMPLE_SEASON
      where  TS.ID_TAR_HEAD = :id_simple_rate
             and :for_date between TSSP.FROM_DATE and TSSP.TO_DATE
             and TSP.ID_ROOM_TYPE = :id_room_type
             and ((tsp.IS_BASE_DAYS_PRICE = 0 and coalesce(tss.SPECIAL_DAYS_OF_WEEK, '') containing extract (weekday from cast(:for_date as date)))
                  or (tsp.IS_BASE_DAYS_PRICE = 1 and coalesce(tss.SPECIAL_DAYS_OF_WEEK, '') not containing extract (weekday from cast(:for_date as date))))
             -- and TSP.days_of_week containing extract (weekday from :for_date )
      into   :single_price, :double_price, :guest3_price, :guest4plus_price,
             :child1_w_adult1_price, :child1_w_adult2plus_price, :child2plus_w_adult1_price, :child2plus_w_adult2plus_price,
             :id_board
    do begin
      rate_found = 1;
      suspend;
    end

    if (:rate_found = 0) then begin
      rate_status = 0;
      product_status = 0;
      suspend;
    end
  end
end
^

ALTER PROCEDURE CONTRACT_EXPENSE_MODIFY$PMS(ID_CONTRACT_EXPENSE TYPE OF ID,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
ID_SERVICE TYPE OF ID,
ID_CURRENCY TYPE OF TCURRENCY,
SERVICE_PRICE TYPE OF TPRICE,
CONTRACT_EXPENSE_TYPE VARCHAR(50),
MULTIPLIER_TYPE VARCHAR(50),
ORDER_TAG TYPE OF TCOUNT,
IS_ACC_POST_ITEM TYPE OF TLOGICAL,
ID_AGENT_PROFILE TYPE OF ID_REF,
OPERATION VARCHAR(20))
 RETURNS(NEW_ID_CONTRACT_EXPENSE TYPE OF ID)
 AS
declare variable is_use smallint;
  declare variable formula varchar(100);
  declare variable service_name varchar(30);
  declare variable id_room_contract integer;
  declare variable old_service_name varchar(30);
  declare variable old_is_acc_post_item smallint;
  declare variable old_multiplier_type varchar(50);
  declare variable old_contract_expense_type varchar(50);
  declare variable old_order_tag integer;
  declare variable old_id_currency char(3);
  declare variable old_service_price numeric(15,4);
  declare variable old_id_service integer;
  declare variable contract_acc varchar(50);
  declare variable action_text varchar(255);
  declare variable id_hotel_contract integer;
  declare variable id_hotel_service integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');
  if ( :CONTRACT_EXPENSE_TYPE not in ('PERCENT', 'RUNNING_TOTAL_PERCENT', 'CURR_VALUE') ) then
    exception WRONG_PARAM_VALUE;

  if ( :MULTIPLIER_TYPE not in ('RESERVATION', 'STAY', 'GUESTS', 'BED_NIGHTS') ) then
    exception WRONG_PARAM_VALUE;

  if (:ORDER_TAG is null) then ORDER_TAG = 0;
  formula = '';
  is_use = 1;

  select SE.SERVICE_NAME, SE.id_hotel
  from   SERVICES SE
  where  SE.ID_SERVICE = :ID_SERVICE
  into   :service_name, :id_hotel_service;

  select R.ID_HOTEL
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS RP on RP.ID_ROOM_PERIOD = RC.ID_ROOM_PERIOD
         join ROOMS R on R.ID_ROOM = RP.ID_ROOM
  where  RC.ID_ROOM_CONTRACT = :ID_CONTRACT
  into   :id_hotel_contract;

  if (:id_hotel_contract is distinct from :id_hotel_service) then exception PMS_EXCEPTION '-626';

  if (:OPERATION = 'add') then begin
    id_room_contract = :ID_CONTRACT;
    contract_acc = case
                     when :SUB_CONTRACT = 'GUEST_USE' then '@{pms.contract_base_account}'
                     when :SUB_CONTRACT = 'OWNER_USE' then '@{pms.contract_owner_use}'
                     when :SUB_CONTRACT = 'SHADOW_ACC' then '@{pms.contract_shadow_account}'
                     else 'N/A'
                   end;

    NEW_ID_CONTRACT_EXPENSE = gen_id(GEN_CONTRACT_EXPENSE$PMS_ID, 1);
    insert into CONTRACT_EXPENSE$PMS (ID_CONTRACT_EXPENSE, ID_CONTRACT, SUB_CONTRACT, ID_SERVICE, ORDER_TAG,
           FORMULA, ID_CURRENCY, SERVICE_PRICE, CONTRACT_EXPENSE_TYPE, IS_ACC_POST_ITEM, MULTIPLIER_TYPE, ID_AGENT_PROFILE)
    values (:NEW_ID_CONTRACT_EXPENSE, :ID_CONTRACT, :SUB_CONTRACT, :ID_SERVICE, :ORDER_TAG,
           :FORMULA, :ID_CURRENCY, :SERVICE_PRICE, :CONTRACT_EXPENSE_TYPE, :IS_ACC_POST_ITEM, :MULTIPLIER_TYPE, :ID_AGENT_PROFILE);

    action_text = substring(f_character(29) || :contract_acc || f_character(28) || :order_tag || f_character(28) || :service_name ||
                  f_character(28) || '@{pms.is_acc_post_item.' || :is_acc_post_item || '}' ||
                  f_character(28) || '@{pms.multiplier_type.' || :multiplier_type || '}' ||
                  f_character(28) || coalesce(:id_currency, '@{pms.contract_expense_type.' || :contract_expense_type || '}') ||
                  f_character(28) || formatfloat(:service_price, '0.00') from 1 for 255);
    execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_SERV_ADD', :ACTION_TEXT);
  end else begin
    select S.SERVICE_NAME, CEP.IS_ACC_POST_ITEM, CEP.MULTIPLIER_TYPE, CEP.CONTRACT_EXPENSE_TYPE, CEP.ORDER_TAG,
           CEP.ID_CURRENCY, CEP.SERVICE_PRICE, CEP.ID_SERVICE,
           case
             when CEP.SUB_CONTRACT = 'GUEST_USE' then '@{pms.contract_base_account}'
             when CEP.SUB_CONTRACT = 'OWNER_USE' then '@{pms.contract_owner_use}'
             when CEP.SUB_CONTRACT = 'SHADOW_ACC' then '@{pms.contract_shadow_account}'
             else 'N/A'
           end,
           CEP.ID_CONTRACT
    from   CONTRACT_EXPENSE$PMS CEP
           join SERVICES S on S.ID_SERVICE = CEP.ID_SERVICE
    where  CEP.ID_CONTRACT_EXPENSE = :ID_CONTRACT_EXPENSE
    into   :old_service_name, :old_is_acc_post_item, :old_multiplier_type, :old_contract_expense_type, :old_order_tag,
           :old_id_currency, :old_service_price, :old_id_service, :contract_acc, :id_room_contract;

    if (:OPERATION = 'mod') then begin
      if (:old_id_service <> :id_service) then begin
        execute procedure CONTRACT_EXPENSE_MODIFY$PMS(:ID_CONTRACT_EXPENSE, :ID_CONTRACT, :SUB_CONTRACT, :ID_SERVICE, :ID_CURRENCY, :SERVICE_PRICE,
                                                      :CONTRACT_EXPENSE_TYPE, :MULTIPLIER_TYPE, :ORDER_TAG, :IS_ACC_POST_ITEM, :ID_AGENT_PROFILE, 'del')
        returning_values :new_id_contract_expense;
        execute procedure CONTRACT_EXPENSE_MODIFY$PMS(:ID_CONTRACT_EXPENSE, :ID_CONTRACT, :SUB_CONTRACT, :ID_SERVICE, :ID_CURRENCY, :SERVICE_PRICE,
                                                      :CONTRACT_EXPENSE_TYPE, :MULTIPLIER_TYPE, :ORDER_TAG, :IS_ACC_POST_ITEM, :ID_AGENT_PROFILE, 'add')
        returning_values :new_id_contract_expense;
      end else begin
        update CONTRACT_EXPENSE$PMS
        set    FORMULA = :FORMULA,
               ID_CURRENCY = :ID_CURRENCY,
               SERVICE_PRICE = :SERVICE_PRICE,
               CONTRACT_EXPENSE_TYPE = :CONTRACT_EXPENSE_TYPE,
               IS_ACC_POST_ITEM = :IS_ACC_POST_ITEM,
               MULTIPLIER_TYPE = :MULTIPLIER_TYPE,
               ORDER_TAG = :ORDER_TAG,
               ID_AGENT_PROFILE = :ID_AGENT_PROFILE
        where  ID_CONTRACT_EXPENSE = :ID_CONTRACT_EXPENSE;

        if ((:old_is_acc_post_item <> :is_acc_post_item) or (:old_multiplier_type <> :multiplier_type) or
                   (coalesce(:old_id_currency, :old_contract_expense_type) <> coalesce(:id_currency, :contract_expense_type)) or
                   (:old_service_price <> :service_price)) then begin
          action_text = substring(f_character(29) || :old_service_name || f_character(28) || :contract_acc ||
                        f_character(28) || '@{pms.is_acc_post_item.' || :old_is_acc_post_item || '}' ||
                        f_character(28) || '@{pms.multiplier_type.' || :old_multiplier_type || '}' ||
                        f_character(28) || coalesce(:old_id_currency, '@{pms.contract_expense_type.' || :old_contract_expense_type || '}') ||
                        f_character(28) || formatfloat(:old_service_price, '0.00') ||
                        f_character(28) || '@{pms.is_acc_post_item.' || :is_acc_post_item || '}' ||
                        f_character(28) || '@{pms.multiplier_type.' || :multiplier_type || '}' ||
                        f_character(28) || coalesce(:id_currency, '@{pms.contract_expense_type.' || :contract_expense_type || '}') ||
                        f_character(28) || formatfloat(:service_price, '0.00') from 1 for 255);
          execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_SERV_CHANG', :ACTION_TEXT);
        end
      end
    end else if (:OPERATION = 'del') then begin
      action_text = substring(f_character(29) || :contract_acc || f_character(28) || :old_order_tag || f_character(28) || :old_service_name ||
                      f_character(28) || '@{pms.is_acc_post_item.' || :old_is_acc_post_item || '}' ||
                      f_character(28) || '@{pms.multiplier_type.' || :old_multiplier_type || '}' ||
                      f_character(28) || coalesce(:old_id_currency, '@{pms.contract_expense_type.' || :old_contract_expense_type || '}') ||
                      f_character(28) || formatfloat(:old_service_price, '0.00') from 1 for 255);
      execute procedure SYSTEM_LOG_ADD ('CONTRACT', :ID_ROOM_CONTRACT, 'ROOM_CONTR_SERV_DEL', :ACTION_TEXT);

      delete from CONTRACT_EXPENSE$PMS
      where (ID_CONTRACT_EXPENSE = :ID_CONTRACT_EXPENSE);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: PMS_EVENT_POST$INT for: CONTRACT_EXPENSE_POST$INT */
ALTER PROCEDURE PMS_EVENT_POST$INT(ID_PMS_EVENT INTEGER,
ID_ROOM_CONTRACT INTEGER,
ID_RENTAL_POOL INTEGER,
POST_DATE DATE,
PRICE_WITH_VAT NUMERIC(15,4),
PRICE_WO_VAT NUMERIC(15,4),
CURR VARCHAR(3),
MAX_ADULT_CNT INTEGER,
STAY INTEGER,
BED_NIGHT_CNT INTEGER,
BOOKING_CNT INTEGER,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE PMS_RUNNING_TOTAL_GET(ID_PMS_EVENT TYPE OF ID_REF,
ID_OWNER TYPE OF ID_REF,
ID_HOTEL TYPE OF ID_REF,
ID_ACCOUNT TYPE OF ID_REF,
ID_ACCOUNT$PMS TYPE OF ID_REF,
POST_DATE TYPE OF TDATE,
TARGET_CURR TYPE OF TCURRENCY)
 RETURNS(RUNNING_TOTAL TYPE OF TPRICE)
 AS
declare variable running_value numeric(15,4);
  declare variable running_curr varchar(3);
  declare variable round_to_ numeric(15,6);
  declare variable rate_ double precision;
begin

  running_total = 0;

  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :TARGET_CURR
  into   :round_to_;

  for
    select sum( AP.VALUE_ORIG * iif(AP.IS_OWNER_INCOME = 1, 1, -1) ), AP.CURR_ORIG
    from   ACCOUNT_POST$PMS AP
           join ACCOUNT$PMS ACC on ACC.ID_ACCOUNT = AP.ID_ACCOUNT_PMS
    where  AP.ID_PMS_EVENT = :ID_PMS_EVENT
           and ((:ID_OWNER is null) or (ACC.ID_OWNER = :ID_OWNER))
           and acc.ID_ACCOUNT = :ID_ACCOUNT$PMS
    group by 2
    into   :running_value, :running_curr
  do begin
    select RATE
    from   CURR_CROSS_RATE_GET(:RUNNING_CURR, :TARGET_CURR, :POST_DATE, :ID_HOTEL)
    into   :rate_;
  
    if (:RUNNING_CURR <> :TARGET_CURR) then
      running_total = :running_total + round_f(:running_value * :rate_, :round_to_);
    else
      running_total = :running_total + :running_value;
  end

  for
    select sum( AP.PRICE_ORIG * (-1) ), AP.CURR_ORIG
    from   PMS_EVENT$PMS E
           join PMS_EVENT_POST PEP on E.ID_PMS_EVENT = PEP.ID_PMS_EVENT
           join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = PEP.ID_ACCOUNT_POST
           join ACCOUNT ACC on ACC.ID_ACCOUNT = AP.ID_ACCOUNT
    where  E.ID_PMS_EVENT = :ID_PMS_EVENT
           and AP.IS_ANUL = 0
           and acc.ID_ACCOUNT = :ID_ACCOUNT
           and ((:ID_OWNER is null) or (ACC.ID_PROFILE = :ID_OWNER))
    group by 2
    into   :running_value, :running_curr
  do begin
    select RATE
    from   CURR_CROSS_RATE_GET(:RUNNING_CURR, :TARGET_CURR, :POST_DATE, :ID_HOTEL)
    into   :rate_;
  
    if (:RUNNING_CURR <> :TARGET_CURR) then
      running_total = :running_total + round_f(:running_value * :rate_, :round_to_);
    else
      running_total = :running_total + :running_value;
  end

  suspend;
end
^

/* Alter (CONTRACT_EXPENSE_POST$INT) */
ALTER PROCEDURE CONTRACT_EXPENSE_POST$INT(ID_PMS_EVENT TYPE OF ID,
ID_HOTEL INTEGER,
ID_CONTRACT TYPE OF ID,
SUB_CONTRACT TYPE OF TSUB_CONTRACT,
ID_OWNER TYPE OF ID,
OWNERSHIP_PERCENT TYPE OF TPERCENT,
ID_RENTAL_POOL TYPE OF ID_REF,
VALUE_ORIG TYPE OF TPRICE,
CURR_ORIG TYPE OF TCURRENCY,
POST_DATE TYPE OF TDATE,
STAY TYPE OF TCOUNT,
MAX_GUEST_CNT TYPE OF TCOUNT,
BED_NIGHT_CNT TYPE OF TCOUNT,
RESERVS TYPE OF TCOUNT)
 AS
declare variable service_price numeric(15,4);
  declare variable id_currency varchar(3);
  declare variable contract_expense_type varchar(50);
  declare variable id_account integer;
  declare variable post_value numeric(15,4);
  declare variable post_currency varchar(3);
  declare variable id_service integer;
  declare variable is_owner_income smallint;
  declare variable is_client_acc_post smallint;
  declare variable multiplier_type varchar(50);
  declare variable multiplier integer;
  declare variable id_room integer;
  declare variable use_shadow_account integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
  declare variable id_agent_profile integer;
begin
  is_owner_income = 0;
  use_shadow_account = iif(:SUB_CONTRACT = 'SHADOW_ACC', 1, 0);

  select r.ID_HOTEL, rd.ID_AGENT_PROFILE
  from   PMS_EVENT$PMS p
         join ROOMS R on r.ID_ROOM = p.ID_ROOM
         left outer join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = p.ID_RESERV_DETAIL
  where  p.ID_PMS_EVENT = :ID_PMS_EVENT
  into   :id_hotel, :id_agent_profile;
-- CONTRACT_EXPENSE_TYPE in ( 'PERCENT', 'RUNNING_TOTAL_PERCENT', 'CURR_VALUE' )
-- MULTIPLIER_TYPE in ('RESERVATION', 'STAY', 'GUESTS', 'BED_NIGHTS')
  for
    select C.SERVICE_PRICE, C.ID_CURRENCY, C.CONTRACT_EXPENSE_TYPE, C.IS_ACC_POST_ITEM,
           C.ID_SERVICE, C.MULTIPLIER_TYPE
    from   CONTRACT_EXPENSE$PMS C
    where  C.ID_CONTRACT = :id_contract
           and c.SUB_CONTRACT = :SUB_CONTRACT
           and ((c.id_agent_profile is null) or (c.ID_AGENT_PROFILE = :id_agent_profile))
    order by C.ORDER_TAG asc
    into   :service_price, :id_currency, :contract_expense_type, :is_client_acc_post,
           :ID_SERVICE, :multiplier_type
  do begin

    execute procedure OWNER_ACCOUNT_GET$INT (coalesce(:ID_RENTAL_POOL,:ID_OWNER),
            :id_hotel, :use_shadow_account, :is_client_acc_post)
    returning_values (:id_account, :is_account$pms);

    multiplier = case
                   when :multiplier_type = 'RESERVATION' then iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'STAY' then :STAY
                   when :multiplier_type = 'GUESTS' then :MAX_GUEST_CNT * iif(:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE', :RESERVS, 1)
                   when :multiplier_type = 'BED_NIGHTS' then :BED_NIGHT_CNT
                   else null
                 end;

    if (:multiplier is not null) then begin
      if (:CONTRACT_EXPENSE_TYPE = 'CURR_VALUE') then begin
        post_value = cast(:service_price as double precision) * :ownership_percent / 100 * :multiplier;
        post_currency = :id_currency;
      end else if (:CONTRACT_EXPENSE_TYPE = 'PERCENT') then begin
        post_value = :VALUE_ORIG * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end else if (:CONTRACT_EXPENSE_TYPE = 'RUNNING_TOTAL_PERCENT') then begin
        execute procedure PMS_RUNNING_TOTAL_GET(:ID_PMS_EVENT, coalesce(:ID_RENTAL_POOL,:ID_OWNER), :ID_HOTEL,
                iif(:is_account$pms = 0, :id_account, null), iif(:is_account$pms = 1, :id_account, null), :POST_DATE, :CURR_ORIG)
        returning_values :post_value;
        if (:post_value < 0) then post_value = 0;
    
        post_value = :post_value * :service_price / 100 * abs(:multiplier);
        post_currency = :CURR_ORIG;
      end

      select pe.ID_ROOM
      from   PMS_EVENT$PMS PE
      where  pe.ID_PMS_EVENT = :ID_PMS_EVENT
      into   :id_room;

      select c.ROUND_TO
      from   CURRS C
      where  c.CURR = :post_currency
      into   :round_to;

      execute procedure PMS_POSTING_CREATE$INT(:ID_PMS_EVENT, :id_account, :id_service, :ID_OWNER,
              :POST_DATE, :post_currency, round_f(:post_value, :round_to), :is_account$pms, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: ACC_STATEMENT_INVOICES_GET$PMS for: DOC_LINES_SUSPEND */
ALTER PROCEDURE ACC_STATEMENT_INVOICES_GET$PMS(ID_BILL INTEGER)
 RETURNS(ID_DOC INTEGER,
ID_SERVICE INTEGER,
DATE_POST DATE,
ROOM_NAME VARCHAR(100),
LINE_DESC VARCHAR(100),
OUTGO_VALUE NUMERIC(15,4),
CURR_POST VARCHAR(3),
IS_ANUL SMALLINT,
INV_DESCRIPTION VARCHAR(100))
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOC_LINES_SUSPEND) */
ALTER PROCEDURE DOC_LINES_SUSPEND(ID_DOC_HEAD INTEGER,
CORRECTION_INDEX INTEGER,
SUBSTITUTE_PACK_NAME VARCHAR(50),
REPORT_TYPE VARCHAR(20),
RPT_CURR VARCHAR(10),
RPT_VAT VARCHAR(20),
EXTRA_DATA_SUSPEND SMALLINT)
 RETURNS(ID_DOC_LINE INTEGER,
LINE_NAME VARCHAR(100),
ID_GUEST INTEGER,
ROOM_NAME VARCHAR(10),
FROM_DATE DATE,
TO_DATE DATE,
DATE_POST DATE,
IS_BASE SMALLINT,
IS_CORRECT SMALLINT,
IS_FOR_PAY SMALLINT,
GROUP_TAG INTEGER,
TAX_STATUS INTEGER,
ID_SERVICE INTEGER,
ID_SERVICE_GROUP INTEGER,
GROUP_NAME VARCHAR(30),
IS_PACKET_POST SMALLINT,
ID_PACK_SERVICE INTEGER,
PACK_SERVICE_NAME VARCHAR(50),
QTY_POST NUMERIC(15,4),
PACK_QTY NUMERIC(15,4),
SINGLE_PRICE NUMERIC(15,4),
LINE_VALUE NUMERIC(15,4),
VAT_VALUE NUMERIC(15,4),
PACK_PRICE NUMERIC(15,4),
PACK_PRICE_WOT_DIFF DOUBLE PRECISION,
POST_PRICE_WOT_DIFF DOUBLE PRECISION,
SEC_CURR_LINE_VALUE NUMERIC(15,4),
SEC_CURR_GROSS_VALUE NUMERIC(15,4),
ID_SALE_TAXATION INTEGER)
 AS
declare variable prev_id_service integer;
  declare variable prev_id_guest integer;
  declare variable prev_price numeric(15,4);
  declare variable prev_date date;
  declare variable no_use varchar(255);
  declare variable dbg varchar(1000);
  declare variable round_to numeric(15,4);
begin
  /* PACK_PRICE_WOT_DIFF and POST_PRICE_WOT_DIFF are only for grouping */
  /* Params: REPORT_TYPE, EXTRA_DATA_SUSPEND - for future use */
  dbg = null;
  correction_index = coalesce(:correction_index, 1);
  if (:report_type is null) then report_type = '';
  if (:extra_data_suspend is null) then extra_data_suspend = 0;
  prev_id_guest   = null;
  prev_id_service = null;
  prev_date       = null;
  prev_price      = 0;
  group_tag       = 0;
  select C.ROUND_TO
  from   DOC_HEAD$INT D
         join CURRS C on C.CURR = D.DOC_CURRENCY
  where  D.ID_DOC_HEAD = :id_doc_head
  into   :round_to;

  if (:report_type = 'services') then begin
    /* SERVICE GROUPING */
    for
      select cast(DLS.SINGLE_WOT_DIFF/:round_to as numeric(18,0)),
             ID_DOC_LINE, LINE_NAME, ID_GUEST, ROOM_NAME, FROM_DATE,
             TO_DATE, DATE_POST, IS_BASE, IS_CORRECT, IS_FOR_PAY, GROUP_TAG, TAX_STATUS,
             ID_SERVICE, ID_SERVICE_GROUP, GROUP_NAME, IS_PACKET_POST, ID_PACK_SERVICE,
             PACK_SERVICE_NAME, QTY_POST, PACK_QTY,
             SINGLE_PRICE, LINE_VALUE, VAT_VALUE, PACK_PRICE,
             round_f(PACK_PRICE_WOT_DIFF, :round_to), round_f(SINGLE_WOT_DIFF, :round_to),
             DLS.SEC_CURR_LINE_VALUE, DLS.SEC_CURR_GROSS_VALUE, DLS.ID_SALE_TAXATION
      from   DOC_LINES_SUSPEND_SUB (:id_doc_head, :correction_index, :substitute_pack_name, :rpt_vat, :rpt_curr, 'NONE') DLS
      order by DLS.IS_BASE desc, DLS.IS_CORRECT asc, DLS.ID_SERVICE asc, /*DLS.POST_PRICE_WOT_DIFF*/ 1 asc, DLS.DATE_POST asc
      into   :no_use, :id_doc_line, :line_name, :id_guest, :room_name, :from_date,
             :to_date, :date_post, :is_base, :is_correct, :is_for_pay, :no_use, :tax_status,
             :id_service, :id_service_group, :group_name, :is_packet_post, :id_pack_service,
             :pack_service_name, :qty_post, :pack_qty,
             :single_price, :line_value, :VAT_VALUE, :pack_price,
             :pack_price_wot_diff, :post_price_wot_diff,
             :SEC_CURR_LINE_VALUE, :SEC_CURR_GROSS_VALUE, :id_sale_taxation
    do begin
      if ((:prev_id_service is null) /*or (:prev_id_service <> :id_service)*/) then begin
        prev_id_service = :id_service;
        prev_price = :post_price_wot_diff;
        prev_date = :date_post;
      end
      if ((:prev_id_service <> :id_service)
          or (:prev_price <> :post_price_wot_diff)
          or (:date_post - :prev_date > 1 and :is_base = 1)
      ) then begin
        group_tag = :group_tag + 1;
        prev_id_service = :id_service;
        prev_price = :post_price_wot_diff;
      end
      prev_date = :date_post;
      suspend;
    end
  end else if (:report_type = 'packages') then begin
    /* PACKAGE GROUPING */
    for
      select cast(DLS.PACK_PRICE_WOT_DIFF/:round_to as numeric(18,0)),
             ID_DOC_LINE, LINE_NAME, ID_GUEST, ROOM_NAME, FROM_DATE,
             TO_DATE, DATE_POST, IS_BASE, IS_CORRECT, IS_FOR_PAY, GROUP_TAG, TAX_STATUS,
             ID_SERVICE , ID_SERVICE_GROUP, GROUP_NAME, IS_PACKET_POST, ID_PACK_SERVICE,
             PACK_SERVICE_NAME, QTY_POST, PACK_QTY,
             SINGLE_PRICE, LINE_VALUE, VAT_VALUE, PACK_PRICE,
             round_f(PACK_PRICE_WOT_DIFF, :round_to), round_f(SINGLE_WOT_DIFF, :round_to),
             DLS.SEC_CURR_LINE_VALUE, DLS.SEC_CURR_GROSS_VALUE, DLS.ID_SALE_TAXATION
      from   DOC_LINES_SUSPEND_SUB (:id_doc_head, :correction_index, :substitute_pack_name, :rpt_vat, :rpt_curr, 'ALL') DLS
      order by /*DLS.IS_BASE desc,*/ DLS.IS_PACKET_POST desc, DLS.IS_CORRECT asc,
             DLS.ID_PACK_SERVICE asc, /*DLS.PACK_PRICE_WOT_DIFF*/ 1 asc, DLS.DATE_POST asc
      into   :no_use, :id_doc_line, :line_name, :id_guest, :room_name, :from_date,
             :to_date, :date_post, :is_base, :is_correct, :is_for_pay, :no_use, :tax_status,
             :id_service , :id_service_group, :group_name, :is_packet_post, :id_pack_service,
             :pack_service_name, :qty_post, :pack_qty,
             :single_price, :line_value, :VAT_VALUE ,:pack_price,
             :pack_price_wot_diff, :post_price_wot_diff,
             :SEC_CURR_LINE_VALUE, :SEC_CURR_GROSS_VALUE, :id_sale_taxation
    do begin
      if ((:prev_id_service is null) /*or (:prev_id_service <> :id_pack_service)*/) then begin
        prev_id_service = :id_pack_service;
        prev_price = :pack_price_wot_diff;
        prev_date = :date_post;
      end
      if ((:prev_id_service <> :id_pack_service)
          or (:prev_price <> :pack_price_wot_diff)
          or (:date_post - :prev_date > 1 and :is_base = 1)
      ) then begin
        group_tag = :group_tag + 1;
        prev_id_service = :id_pack_service;
        prev_price = :pack_price_wot_diff;
      end
      prev_date = :date_post;
      suspend;
    end
  end else if (:report_type = 'groups') then begin
    /* SERVICE_GROUP GROUPING  */
    for
      select cast(DLS.SINGLE_WOT_DIFF/:round_to as numeric(18,0)),
             ID_DOC_LINE, LINE_NAME, ID_GUEST, ROOM_NAME, FROM_DATE,
             TO_DATE, DATE_POST, IS_BASE, IS_CORRECT, IS_FOR_PAY, GROUP_TAG, TAX_STATUS,
             ID_SERVICE , ID_SERVICE_GROUP, GROUP_NAME, IS_PACKET_POST, ID_PACK_SERVICE,
             PACK_SERVICE_NAME, QTY_POST, PACK_QTY,
             SINGLE_PRICE, LINE_VALUE, VAT_VALUE, PACK_PRICE,
             round_f(PACK_PRICE_WOT_DIFF, :round_to), round_f(SINGLE_WOT_DIFF, :round_to),
             DLS.SEC_CURR_LINE_VALUE, DLS.SEC_CURR_GROSS_VALUE, DLS.ID_SALE_TAXATION
      from   DOC_LINES_SUSPEND_SUB (:id_doc_head, :correction_index, :substitute_pack_name, :rpt_vat, :rpt_curr, 'NONE') DLS
      order by DLS.IS_BASE desc, DLS.IS_CORRECT asc, DLS.ID_SERVICE_GROUP asc, /*DLS.POST_PRICE_WOT_DIFF*/ 1 asc, DLS.DATE_POST asc
      into   :no_use, :id_doc_line, :line_name, :id_guest, :room_name, :from_date,
             :to_date, :date_post, :is_base, :is_correct, :is_for_pay, :no_use, :tax_status,
             :id_service , :id_service_group, :group_name, :is_packet_post, :id_pack_service,
             :pack_service_name, :qty_post, :pack_qty,
             :single_price, :line_value, :VAT_VALUE, :pack_price,
             :pack_price_wot_diff, :post_price_wot_diff,
             :SEC_CURR_LINE_VALUE, :SEC_CURR_GROSS_VALUE, :id_sale_taxation
    do begin
      if ((:prev_id_service is null) /*or (:prev_id_service <> :ID_SERVICE_GROUP)*/) then begin
        prev_id_service = :id_service_group;
        prev_price = :post_price_wot_diff;
        prev_date = :date_post;
      end
      if ((:prev_id_service <> :id_service_group)
         or (:prev_price <> :post_price_wot_diff)
         or (:date_post - :prev_date > 1 and :is_base = 1)
      ) then begin
        group_tag = :group_tag + 1;
        prev_id_service = :id_service_group;
        prev_price = :post_price_wot_diff;
      end
      prev_date = :date_post;
      suspend;
    end
  end else begin
    /* DETAIL GROUPING - BY DEFAULT */
    for
      select ID_DOC_LINE, LINE_NAME, ID_GUEST, ROOM_NAME, FROM_DATE,
             TO_DATE, DATE_POST, IS_BASE, IS_CORRECT, IS_FOR_PAY, GROUP_TAG, TAX_STATUS,
             ID_SERVICE , ID_SERVICE_GROUP, GROUP_NAME, IS_PACKET_POST, ID_PACK_SERVICE,
             PACK_SERVICE_NAME, QTY_POST, PACK_QTY,
             SINGLE_PRICE, LINE_VALUE, VAT_VALUE, PACK_PRICE,
             round_f(PACK_PRICE_WOT_DIFF, :round_to), round_f(SINGLE_WOT_DIFF, :round_to),
             DLS.SEC_CURR_LINE_VALUE, DLS.SEC_CURR_GROSS_VALUE, DLS.ID_SALE_TAXATION
      from   DOC_LINES_SUSPEND_SUB (:id_doc_head, :correction_index, :substitute_pack_name, :rpt_vat, :rpt_curr, 'NONE') DLS
      order by DLS.IS_BASE desc, DLS.IS_CORRECT asc, DLS.ID_GUEST asc, DLS.ID_SERVICE asc, /*DLS.POST_PRICE_WOT_DIFF asc,*/ DLS.DATE_POST asc
      into   :id_doc_line, :line_name, :id_guest, :room_name, :from_date,
             :to_date, :date_post, :is_base, :is_correct, :is_for_pay, :no_use, :tax_status,
             :id_service , :id_service_group, :group_name, :is_packet_post, :id_pack_service,
             :pack_service_name, :qty_post, :pack_qty,
             :single_price, :line_value, :VAT_VALUE, :pack_price,
             :pack_price_wot_diff, :post_price_wot_diff,
             :SEC_CURR_LINE_VALUE, :SEC_CURR_GROSS_VALUE, :id_sale_taxation
    do begin
      if ((:prev_id_guest is null) /*or (:prev_id_guest <> :id_guest)*/) then begin
        prev_id_guest = :id_guest;
        prev_id_service = :id_service;
        prev_price = :post_price_wot_diff;
        prev_date = :date_post;
      end
      if ((:prev_id_guest <> :id_guest)
         or (:prev_id_service <> :id_service)
         or (:prev_price <> :post_price_wot_diff)
         or (:date_post - :prev_date > 1 and :is_base = 1)
      ) then begin
        group_tag = :group_tag + 1;
        prev_id_guest = :id_guest;
        prev_id_service = :id_service;
        prev_price = :post_price_wot_diff;
      end
      prev_date = :date_post;
      suspend;
    end
  end
end
^

/* Alter (DOCUMENT_ANUL$DOC) */
ALTER PROCEDURE DOCUMENT_ANUL$DOC(ID_DOC_HEAD INTEGER,
ANUL_REASON VARCHAR(100),
MAKE_ANNUL_REPORT SMALLINT)
 AS
/**/
  declare variable id_account  integer;
  declare variable id_payment_head integer;
  declare variable for_deposit integer;
  declare variable id_base_doc integer;
  declare variable is_anul integer;
  declare variable dh_dbkey char(8);
  declare variable id_annul_protocol_num integer;
  declare variable num integer;
  declare variable doc_num varchar(20);
  declare variable system_date date;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable doc_date date;
  declare variable id_system_log integer;
  declare variable id_hotel integer;
  declare variable is_storno_doc integer;
  declare variable no_use integer;
begin

  select H.RDB$DB_KEY, H.ID_ACCOUNT, H.FOR_DEPOSIT, H.ID_BASE_DOC, H.IS_ANUL, A.ID_HOTEL,
         A.ID_RESERV_DETAIL, T.ID_ANNUL_DOC_NUM, h.DOC_DATE, H.IS_STORNO
  from   DOC_HEAD$INT H
         join DOC_COMPLETION dc on dc.ID_DOC_HEAD = h.ID_DOC_HEAD
         join DOC_TYPE T on H.ID_DOC_TYPE = T.ID_DOC_TYPE
         join DOC_TYPE_INV DTI on DTI.ID_DOC_TYPE = T.ID_DOC_TYPE
         join ACCOUNT A on A.ID_ACCOUNT = H.ID_ACCOUNT
  where  H.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :dh_dbkey, :id_account, :for_deposit, :id_base_doc, :is_anul, :id_hotel,
         :id_reserv_detail, :id_annul_protocol_num, :doc_date, :is_storno_doc;

  if (:is_anul = 1) then
    exception DOCUMENT_ANNUL_EXCEPTION '-352'; --'Document is already annul';

  if (exists (select D.ID_DOC
              from   DOC_HEAD D
              where  D.ID_BASE_DOC = :ID_BASE_DOC
                     and D.ID_DOC > :ID_DOC_HEAD
                     and D.IS_ANUL = 0))
  then exception DOCUMENT_ANNUL_EXCEPTION '-314';

  if (exists (select D.ID_DEPOSIT
              from   DEPOSIT_DEDUCT DD
                     join DEPOSITS d on d.ID_DEPOSIT = dd.ID_DEPOSIT
              where  DD.ID_DOC_USED = :ID_DOC_HEAD
                     and D.RECEIVED_AMOUNT = 0))
  then exception DOCUMENT_ANNUL_EXCEPTION '-315';

  execute procedure SYSTEM_DATE_GET(:ID_HOTEL)
  returning_values  :system_date;

  if (:DOC_DATE < :SYSTEM_DATE) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_PREV_DATE');
  end
  /* unarchive account and set as credit account, for shecked out bookings only */
  execute procedure ACCOUNT_SET_ARCHIVE_STATUS(:ID_ACCOUNT, 0);

  if (:ID_RESERV_DETAIL is not null) then begin
    select RD.CHECK_STATUS
    from   RESERV_DETAIL RD
    where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :check_status;

    if (:check_status = 1) then begin
      execute procedure ACCOUNT_SET_CREDIT_STATUS$INT (:id_account, 1, null, 1);
    end
  end
  /* MARK THE DOCUMENT AS ANUL - before posting and payment updates */
  update DOC_HEAD$INT DH
  set    DH.IS_ANUL = 1
  where  DH.RDB$DB_KEY = :dh_dbkey;

  update DOC_COMPLETION Dc
  set    Dc.IS_EFAKTURA_EXPORTED = 0
  where  Dc.ID_DOC_HEAD = :ID_DOC_HEAD;


  if (:is_storno_doc = 1) then begin
    /* annul storno doc */
    update DOC_HEAD$INT BD
    set    BD.IS_STORNED = 0
    where  BD.ID_DOC_HEAD = :id_base_doc
           and BD.IS_STORNED = 1;
  end
  /* RELEASE ACCOUNT_POSTS */
  if (:for_deposit = 0) then
    execute procedure ACCOUNT_POSTING_DOC_UPDATE$INT (:DH_DBKEY)
    returning_values (:no_use);

  /* PAYMENTS REFLECTION */
  for
    select PH.ID_PAYMENT_HEAD
    from   PAYMENT_HEAD PH
           join DOC_TYPE_PAY dt on dt.ID_DOC_TYPE = ph.ID_DOC_TYPE
    where  PH.ID_DOC_HEAD = :ID_DOC_HEAD
           and PH.IS_STORNED = 0
    into   :ID_PAYMENT_HEAD
  do begin

    execute procedure PAYMENT_ANUL$INT (:ID_PAYMENT_HEAD, :ANUL_REASON);
  end

  /* ANNUL_PROTOCOL creating section */
  NUM = null;
  DOC_NUM = null;
  if (:MAKE_ANNUL_REPORT = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('DOC_ANNUL_WITH_PROT');

    if (:ID_ANNUL_PROTOCOL_NUM is null) then exception DOCUMENT_ANNUL_EXCEPTION '-345';

    execute procedure SYSTEM_GEN_NUM ('ANNUL_PROT', :ID_ANNUL_PROTOCOL_NUM)
    returning_values  (:num, :doc_num);
  end
  /* log annul event */
  execute procedure SYSTEM_EVENT_LOG$INT ('DOCUMENT', :ID_DOC_HEAD, 'ANNUL', f_character(29)||:ANUL_REASON)
  returning_values  :id_system_log;

  insert into DOC_ANNULMENT (ID_DOC_HEAD, ANNULMENT_DATE, ID_PROT_DOC_NUM, PROT_NUM, PROT_DOC_NUM, ID_LOG_EVENT)
  values (:ID_DOC_HEAD, :SYSTEM_DATE, :ID_ANNUL_PROTOCOL_NUM, :NUM, :DOC_NUM, :ID_SYSTEM_LOG);
  /* reflect annul date on doc release dates */
  if (:DOC_DATE < :SYSTEM_DATE) then begin
    insert into DOC_RELEASE_DATE (ID_DOC_HEAD, RELEASE_DATE, VALUE_CORR_INDEX)
    values (:ID_DOC_HEAD, :SYSTEM_DATE, -1);
  end else begin
    update DOC_RELEASE_DATE RD
    set    RD.VALUE_CORR_INDEX = 0
    where  RD.ID_DOC_HEAD = :ID_DOC_HEAD
           and RD.RELEASE_DATE = :DOC_DATE;
  end
  /* reflect on AR module */
  execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT (:DH_DBKEY, :ANUL_REASON);
  /* reflect on client loyalty module */
  execute procedure DOCUMENT_BONUSPOINTS_VOID$CL (:ID_DOC_HEAD);

end
^

/* empty dependent procedure body */
/* Clear: DEPOSIT_REFUND$DOC for: DOCUMENT_VALIDATE$DOC */
ALTER PROCEDURE DEPOSIT_REFUND$DOC(ID_DEPOSIT INTEGER,
REFUND_AMOUNT NUMERIC(15,4),
REFUND_CURRENCY VARCHAR(3),
ID_PAY_DOC_TYPE INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_REFUND_PAYMENT INTEGER,
ID_STORNO_DOC INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TEST_DOC for: DOCUMENT_VALIDATE$DOC */
ALTER PROCEDURE TEST_DOC(ID_ACCOUNT INTEGER,
DOC_SELECTED INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (DOCUMENT_VALIDATE$DOC) */
ALTER PROCEDURE DOCUMENT_VALIDATE$DOC(ID_DOC_HEAD TYPE OF ID_REF)
 RETURNS(FIRM_DATA TYPE OF TNOTE_BLOB,
WARN_CODE TYPE OF TRANGE,
NEW_DOC_DATE TYPE OF TDATE)
 AS
declare variable no_use varchar(255);
  declare variable doc_value numeric(15,4);
  declare variable rest_value numeric(15,4);
  declare variable lines_value numeric(15,4);
  declare variable lines_wot_vat numeric(15,4);
  declare variable tax_value numeric(15,4);
  declare variable taxable_value numeric(15,4);
  declare variable round_to numeric(15,4);
  declare variable id_doc_contragent integer;
  declare variable id_doc_supplier integer;
  declare variable for_deposit integer;
  declare variable id_profile integer;
  declare variable dbkey char(8);
  declare variable id_contragent integer;
  declare variable ident_no varchar(30) ;
  declare variable action_text varchar(255);
  declare variable doc_currency varchar(3);
  declare variable is_juridical_person smallint;
  declare variable vat_ident_no varchar(30);
  declare variable id_doc_type integer;
  declare variable doc_sub_type integer;
  declare variable required_ident_no smallint;
  declare variable required_vat_no smallint;
  declare variable required_egn smallint;
  declare variable required_recipient_name smallint;
  declare variable lines_count integer;
  declare variable recipient_name varchar(100);
  declare variable id_doc_completed integer;
  declare variable action_code varchar(50);
begin

  select D.RDB$DB_KEY, D.DOC_VALUE_A, C.ROUND_TO,
         D.ID_DOC_CONTRAGENT, D.ID_DOC_SUPPLIER, D.FOR_DEPOSIT,
         A.ID_PROFILE, D.DOC_CURRENCY, D.TAXABLE_VALUE, d.ID_DOC_TYPE, d.DOC_SUB_TYPE,
         dc.ID_DOC_HEAD, ds.FIRM_DATA
  from   DOC_HEAD$INT D
         join CURRS C on C.CURR = D.DOC_CURRENCY
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         left outer join DOC_COMPLETION dc on dc.ID_DOC_HEAD = d.ID_DOC_HEAD
         left outer join DOC_SUPPLIER ds on ds.ID_DOC_SUPPLIER = d.ID_DOC_SUPPLIER
  where  D.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :dbkey, :doc_value, :round_to,
         :id_doc_contragent, :id_doc_supplier, :for_deposit,
         :id_profile, :doc_currency, :taxable_value, :id_doc_type, :doc_sub_type,
         :id_doc_completed, :FIRM_DATA;

  if (:id_doc_contragent is null) then
    exception DOCUMENT_EXCEPTION '-356'; --'Contragent is not set!';

  if (:id_doc_supplier is null) then
    exception DOCUMENT_EXCEPTION '-357'; --'Supplier is not set!';

  select sum(DT.TAX_VALUE)
  from   DOC_TAXES DT
  where  DT.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :tax_value;

  /*if (round_f(:doc_value - :total_value, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Total value is not correct!';
  */
  select round_f(sum(DL.SINGLE_VALUE * DL.QTY_POST), :round_to),
         round_f(sum(DL.WOT_VAT), :round_to),
         count(*)
  from   DOC_LINE DL
  where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :lines_value, :lines_wot_vat, :lines_count;
 
  if (:lines_count = 0) then
    exception INTERNAL_DOC_EXCEPTION 'Document is empty! Not exists sale lines!';

  if (round_f(:doc_value - :lines_value, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines total value is not correct!' || :doc_value ||  ' / ' || :lines_value || ' ; '|| (:doc_value - :tax_value) ||  ' / ' || :lines_wot_vat;

  if (round_f(:doc_value - :tax_value - :lines_wot_vat, :round_to) <> 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines wot tax value is not correct!';

  if (round_f(abs(:lines_wot_vat) - abs(:taxable_value), :round_to) < 0) then
    exception INTERNAL_DOC_EXCEPTION 'Lines wot tax value is less than total taxable value!';

  if (:id_doc_completed is not null) then begin
    select DV.PAYABLE_VALUE
    from   DOCUMENT_GET_VALUE$INT (:ID_DOC_HEAD, null) DV
    into   :rest_value;
  
    if (round_f(:rest_value, :round_to) <> 0) then
      exception DOCUMENT_EXCEPTION '-371'; --'Insufficient amount of payments !';
  end

  /* Validate contragent data */
  select dt.REQUIRED_IDENT_NO, dt.REQUIRED_VAT_NO, dt.REQUIRED_EGN, dt.REQUIRED_RECIPIENT_NAME
  from   DOC_TYPE_INV DT
  where  dt.ID_DOC_TYPE = :id_doc_type
  into   :required_ident_no, :required_vat_no, :required_egn, :required_recipient_name;

  select dc.ID_CONTRAGENT, dc.IS_JURIDICAL_PERSON,
         trim(coalesce(dc.IDENT_NO, '')), trim(coalesce(dc.VAT_REG_NUM, '')),
         trim(coalesce(dc.RECIPIENT_NAME, ''))
  from   DOC_CONTRAGENT dc
  where  dc.ID_DOC_CONTRAGENT = :id_doc_contragent
  into   :id_contragent, :is_juridical_person, :ident_no, :vat_ident_no, :recipient_name;

  if (:doc_sub_type = 0 and :required_ident_no = 1 and :is_juridical_person = 1 and :ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-324'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_egn = 1 and :is_juridical_person = 0 and :ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-324'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_vat_no = 1 and :is_juridical_person = 1 and :vat_ident_no = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-326'; --'Identification number is empty.';
  if (:doc_sub_type = 0 and :required_recipient_name = 1 and :recipient_name = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-327'; --'Recipient_name is empty.';
  /*if (:post_address = '') then
    exception CONTRAGENT_VALIDATION_ERROR '-325'; --'Contragent address is empty.';
  /* save contragent link for profile */
  if (:id_contragent is not null) then begin
    update PROFILE P
    set    P.ID_DEF_CONTRAGENT = :id_contragent
    where  P.ID_PROFILE = :id_profile
           and P.ID_DEF_CONTRAGENT is null;
  end

  /*  */
  execute procedure DOC_CHECK_FISCAL$INT(:dbkey);
  /*  */
  execute procedure DOCUMENT_SET_NUMBER$INT (:dbkey)
  returning_values (:no_use, :no_use);
  /*  */
  if (:id_doc_completed is not null) then begin
    if (:for_deposit = 0) then begin
      /* update account posts */
      execute procedure ACCOUNT_POSTING_DOC_UPDATE$INT (:dbkey)
      returning_values :WARN_CODE;
    end

    execute procedure DOCUMENT_AR_PAYMENTS_APPLY$INT (:dbkey);
    /* ... */
    execute procedure DOCUMENT_BONUSPOINTS_APPLY$CL (:ID_DOC_HEAD);
    /* ... */
  end
  /*  */
  action_text = f_character(29) || formatfloat(:doc_value, 'F;0.00') || ' ' || :doc_currency;
  action_code = iif(:id_doc_completed is null,  'PROFORMA_CREATE', 'CREATE');
  execute procedure SYSTEM_LOG_ADD ('DOCUMENT', :ID_DOC_HEAD, :action_code, :action_text);

  select cast('31.12.1899' as date) + count(d.ID_DOC_HEAD)
  from   DOC_HEAD$INT d
  where  d.DOC_DATE is not null
  into   :NEW_DOC_DATE;

end
^

/* Alter (EAI_POS_GET_GUESTS$P2E) */
ALTER PROCEDURE EAI_POS_GET_GUESTS$P2E(IN_ROOM_NAME VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(OUT_ID_GUEST INTEGER,
OUT_GUEST_NAME VARCHAR(100),
OUT_FROM_DATE DATE,
OUT_TO_DATE DATE,
OUT_OK_FOR_POST INTEGER,
OUT_COUNTRY VARCHAR(30),
OUT_TEXT VARCHAR(100),
OUT_BOARD_NAME VARCHAR(30),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100))
 AS
declare variable id_room integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  OUT_GUEST_NAME = null;

  /*FIND ROOM*/
  select R.ID_ROOM
  from   ROOMS R
         join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
  where  R.ROOM_NAME = :IN_ROOM_NAME
         and RT.ID_HOTEL = :ID_HOTEL
  into   :ID_ROOM;
  if ((:ID_ROOM is null) or (:ID_ROOM <= 0) ) then begin
    ERR_CODE = -5;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Room number not found!    ! ';
    suspend;
    exit;
  end

  /*FIND GUESTS*/
  for
    select G.ID_GUEST, GC.GUEST_NAME1, G.FROM_DATE, G.TO_DATE, C.COUNTRY_NAME,
           (select m.NAME
            from   GUEST_STAY gs
                   join MEALS M on m.ID_BOARD = gs.ID_BOARD
            where  gs.ID_GUEST = g.ID_GUEST
                   and gs.FOR_DATE = iif(current_date = g.to_date, current_date - 1, current_date))
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
           left outer join GUEST_CARD GC on G.ID_GUEST = GC.ID_GUEST
           left outer join COUNTRY C on C.COUNTRY_CODE = GC.COUNTRY
    where  G.ID_ROOM = :ID_ROOM
           and G.CHECK_STATUS = 0
           and rd.IS_ANUL = 0
    into   :OUT_ID_GUEST, :OUT_GUEST_NAME, :OUT_FROM_DATE,  :OUT_TO_DATE, :OUT_COUNTRY, :OUT_BOARD_NAME
  do begin
    OUT_OK_FOR_POST = iif(:OUT_TO_DATE < current_date, 0, 1) ;
    suspend;
  end

  if (:OUT_GUEST_NAME is null) then begin
    ERR_CODE = -1;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Guests not found!     !';
    suspend;
  end
end
^

/* Alter (END_WORK) */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable system_date date;
  declare variable id_end_work integer;
  declare variable last_closed_date date;
  declare variable lock_id integer;
  declare variable dbkey char(8);
begin
  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date >= :in_next_date) then exception END_WORK_EXCEPTION '-43';
  if (:IN_NEXT_DATE > current_date + 1) then exception END_WORK_EXCEPTION '-60';

  last_closed_date = :in_next_date - 1;

  /* LOCK THE CURRENT FINANCIAL (SYSTEM) DATE  */
  lock_id = null;
  while (:lock_id is null) do begin
    lock_id = strhash_large(:system_date || :id_hotel);
    execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'lock');
  
    when any do begin
      exception END_WORK_EXCEPTION '-337' || f_character(31) || f_character(29) || FormatDate(:system_date, 'D;dd.mm.yyyy');
    end
  end

  /* RIGHT IS REQUIRED TO CHANGE THE FINANCIAL DATE IF THERE ARE GUESTS WITH OVERDUE CHECK OUT */
  if (exists(
    select *
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
    where  G.TO_DATE <= :last_closed_date
           and G.CHECK_STATUS < 1
           and RD.ID_HOTEL = :id_hotel
           and rd.IS_ANUL = 0
  )) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('EW_OVERDUE_CHECKOUT');
  end

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', 'EW');
  -- Suppress eventual right checks into next procedures - all is permitted. Is this needed(?!?)

  for
    select p.RDB$DB_KEY
    from   ACCOUNT_POST p
           join ACCOUNT a on a.ID_ACCOUNT = p.ID_ACCOUNT
    where  p.DATE_POST between :system_date and :last_closed_date
           and p.ID_GUEST > 0
           and a.ID_HOTEL = :ID_HOTEL
    into   :dbkey
  do begin
    update ACCOUNT_POST AP
    set    ap.ROOM_NAME = (select R.ROOM_NAME
                           from   GUEST G
                                  join ROOMS R on R.ID_ROOM = G.ID_ROOM
                           where  G.ID_GUEST = ap.ID_GUEST)
    where  ap.RDB$DB_KEY = :dbkey;
  end

  /* CHANGE SYSTEM DATE */
  execute procedure SYSTEM_DATE_SET(:id_hotel, :system_date, :in_next_date)
  returning_values :id_end_work;

  /* AUTO EXPIRATION OF ROOM NUMBERS, ROOMS AND BOOKING POSITIONS */
  execute procedure RESERVS_EXPIRE$INT(:last_closed_date, :id_hotel);

  execute procedure AGENT_CONTINGENT_EXPIRE(:system_date, :last_closed_date, null, 0, 1, :id_hotel);

  /* DELETE PERSON PROFILES WITH EXPIRATION DATE */
  execute procedure PROFILE_PERSON_EXPIRE (:in_next_date);

  execute procedure HOUSEKEEPING_MARK_ROOMS$EW(:id_end_work);

  /* Summary statistic */
  if (:in_next_date > :system_date) then begin
    execute procedure SUMMARY_FINANCE_STATISTIC$EW(:id_end_work);

    execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:ID_HOTEL, :system_date, :last_closed_date);

    execute procedure SUMMARY_STATISTIC_REBUILD$EW(:ID_HOTEL);

    execute procedure SUMMARY_FORECAST$INT(:ID_HOTEL, :system_date);
  end

  /* Delete pseudo-temporal tables */
  delete from RESERV_ERROR;
  /*  */

--  execute procedure CACHES_RESOLVE;

  execute procedure SYSTEM_LOG_ADD('DAY_END_WORK', :id_end_work, 'DAY_EW', f_character(29) || :system_date || f_character(28) || :IN_NEXT_DATE);

  execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'release');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', null);

  execute procedure SYSTEM_CACHE_APPLY('end_work');
end
^

/* Alter (HOTEL_GET_FREE$CHM) */
ALTER PROCEDURE HOTEL_GET_FREE$CHM(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER)
 RETURNS(FOR_DATE DATE,
AVAILABLE INTEGER,
OCCUPIED INTEGER)
 AS
begin
  for
    select aos.for_date, sum(aos.rooms_available), sum(aos.rooms_occupied)
    from   AVAILABILITY_OCCUPANCY$CHM (:ID_HOTEL, :FROM_DATE, :TO_DATE) aos
    group by 1
    into   :for_date, :available, :occupied
  do suspend;
end
^

/* Alter (IMPORT_AGENT_PROFILE$EXC) */
ALTER PROCEDURE IMPORT_AGENT_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
COUNTRY_CODE VARCHAR(10),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
AGENT_GROUP VARCHAR(50),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
WBE_PASSWORD VARCHAR(20),
IATA_NUMBER VARCHAR(20),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(2000),
DEF_CONTRAGENT_NAME VARCHAR(100),
THRESHOLD_NOTE VARCHAR(255),
THRESHOLD_AMOUNT NUMERIC(15,4),
THRESHOLD_CURR CHAR(3),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
declare variable op varchar(10);
  declare variable market_segment_id integer;
  declare variable agent_group_old varchar(50);
  declare variable id_bonuspoint_scheme integer;
  declare variable id_def_contragent integer;
  declare variable is_exclusive_debt_ownership smallint;
  declare variable country_code_old varchar(10);
  declare variable profile_receiver_id integer;
  declare variable discount_id integer;
begin
  profile_id = null;
  import_time = null;

  execute procedure import_mark_transaction$exc;

  execute procedure sys_dbg('exc IMPORT_AGENT_PROFILE$EXC(:profile_uuid=>' || coalesce(:profile_uuid, cast('<null>' as varchar(40)) ) || ')');
  profile_id = null;
  if (:PROFILE_UUID is null) then begin
    execute procedure sys_dbg('exc IMPORT_AGENT_PROFILE$EXC <null> :profile_uuid - exit;');
    exit;
  end

  select p.profile_id, p.profile_name, p.phone, p.fax, p.email, p.city,
         p.address, p.market_segment, p.note, p.is_archive, p.id_bonuspoint_scheme,
         p.id_def_contragent, pa.agent_group, p.wbe_password,
         p.msg, p.account_no, p.is_exclusive_debt_ownership, pa.country_code
  from   IMPORT_COMMON_PROFILE$EXC(:PROFILE_UUID, 1, :PROFILE_NAME,
         :PHONE, :FAX, :EMAIL, :CITY, :ADDRESS, :MARKET_SEGMENT, :NOTE, :IS_ARCHIVE, :WBE_PASSWORD, :ACCOUNT_NO, :MSG,  'AGENT_PROFILE', :HOTEL_UUID_LIST) p
         left outer join PROFILE_AGENT pa on pa.id_profile = p.profile_id
  into   :profile_id, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :id_bonuspoint_scheme,
         :id_def_contragent, :agent_group_old, :wbe_password,
         :msg, :account_no, :is_exclusive_debt_ownership, :country_code_old;

  if (:profile_id is null) then begin
    op = 'add';
  end else if (:hotel_uuid_list is null) then begin
    profile_id = null;
    exit;
  end else begin
    op = 'mod';
    if (:hotel_uuid_list is not null) then begin
      for
        select d.id_sale_discount
        from   SALE_DISCOUNT d
               join HOTEL h on h.id_hotel = d.id_hotel
        where  :hotel_uuid_list containing h.uuid
        into   :discount_id
      do begin
        delete from PROFILE_DISCOUNT pd
        where  pd.ID_PROFILE = :profile_id
               and pd.id_sale_discount = :discount_id;
      end
    end

    delete from PROFILE_BONUSPOINT_SCHEME bs
    where  bs.ID_PROFILE = :profile_id;
  end

  AGENT_GROUP=coalesce(:AGENT_GROUP, :AGENT_GROUP_OLD);
  country_code=coalesce(:country_code, :country_code_old);

  execute procedure LOOKUP_MARKET_SEGMENT$EXC(:profile_name, 'AGENT_PROFILE', :market_segment)
  returning_values :market_segment_id;

  if ((def_contragent_name is not null) and (def_contragent_name <> '')) then begin
    execute procedure LOOKUP_CONTRAGENT$EXC(:profile_name, 'AGENT_PROFILE', :def_contragent_name)
    returning_values :id_def_contragent;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:profile_name, 'AGENT_PROFILE');

  execute procedure sys_dbg('exc IMPORT_AGENT_PROFILE$EXC - profile_agent_modify$profile(:profile_uuid=>' || coalesce(:profile_uuid,cast('<null>' as varchar(40)))
    || ', :operation=>' || coalesce(:op, cast('<null>' as varchar(10)) )
    || ', :market_segment_id=>' || coalesce(cast(:market_segment_id as varchar(10)) , cast('<null>' as varchar(10)) )
    || ')');

  if (:hotel_uuid_list is null) then begin
    -- in "non authoritive" mode (i.e. embeded mode transfer only profile key fields )
    --profile_name = null;
    phone = null;
    fax = null;
    email = null;
    country_code = null;
    city = null;
    address = null;
    note = null;
    msg = null;
    --is_archive = null;
    agent_group = null;
    id_def_contragent = null;
    market_segment_id = null;
    id_bonuspoint_scheme = null;
    wbe_password = null;
    account_no = null;
    --iata_number = null;
    is_exclusive_debt_ownership = null;
  end

  execute procedure profile_agent_modify$profile(
    :profile_id, :profile_name, :phone, :fax, :email,
    :country_code, :city, :address, :note, :msg, :is_archive, :agent_group, :id_def_contragent, :market_segment_id,
    :wbe_password, :op, :account_no, :iata_number, :is_exclusive_debt_ownership,
    :threshold_note, :threshold_amount, :threshold_curr)
  returning_values :profile_id;

  /*assign UUID to the new profiles*/
  if ('add' = :op) then begin
    update profile
    set    uuid = :profile_uuid
    where  id_profile = :profile_id;
  end

  select record_timestamp
  from   profile
  where  id_profile = :profile_id
  into   :import_time;

  if (:MERGE_TARGET_UUID is not null) then begin
    select p.ID_PROFILE
    from   PROFILE P
    where  P.UUID = :MERGE_TARGET_UUID
    into   :profile_receiver_id;

    execute procedure PROFILE_MERGE$PROFILE (:PROFILE_ID, :profile_receiver_id, 'merge');

  end
end
^

/* empty dependent procedure body */
/* Clear: CREATE_BOOKING$WBE for: IMPORT_GUEST$EXC */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE RES_GUEST_SAVE$RSV(ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
GUEST_NAME1 VARCHAR(100),
AGE INTEGER,
BIRTH_DAY DATE,
IS_CHILD INTEGER,
MASK VARCHAR(10) = null)
 RETURNS(NEW_ID_GUEST INTEGER)
 AS
declare variable g_dbkey char(8);
  declare variable pd_dbkey char(8);
  declare variable country_code varchar(10);
  declare variable id_person_data integer;
begin
  /*  Description:
  ||
  */
  if (:id_guest is null) then begin
    -- get first anonymous guest (check_status = -2  ?!)
    select first 1 PD.RDB$DB_KEY, G.RDB$DB_KEY, PD.COUNTRY_CODE,
           G.ID_GUEST, pd.ID_PERSON_DATA
    from   GUEST G
           join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
           join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
           and G.CHECK_STATUS = -2
           and G.IS_CHILD = :IS_CHILD
    order by G.ID_GUEST asc
    into   :pd_dbkey, :g_dbkey, :country_code,
           :new_id_guest, :id_person_data;
  end else begin
    new_id_guest = :id_guest;
    select G.RDB$DB_KEY, PD.RDB$DB_KEY, PD.COUNTRY_CODE, pd.ID_PERSON_DATA
    from   GUEST G
           join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
           join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
    where  G.ID_GUEST = :id_guest
    into   :g_dbkey, :pd_dbkey, :country_code, :id_person_data;
  end

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name1, null,
          :country_code, :is_child, :age, :birth_day, null);

  if (:MASK is not null) then begin
    update PERSON_DATA d
    set    d.MASK = :MASK
    where  d.ID_PERSON_DATA = :id_person_data;
  end

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -1);

end
^

/* Alter (IMPORT_GUEST$EXC) */
ALTER PROCEDURE IMPORT_GUEST$EXC(BOOKING_ID INTEGER,
PROFILE_UUID VARCHAR(40),
GUEST_UUID VARCHAR(40),
GUEST_NAME VARCHAR(100),
IS_CHILD SMALLINT,
AGE INTEGER,
IS_DIFFERENT_ARRANGER SMALLINT,
ARRIVAL DATE,
DEPARTURE DATE,
VOUCHER VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
RATING_AGE INTEGER,
KPP VARCHAR(50),
KPP_DATE DATE,
STAY_REASON VARCHAR(255),
CAR VARCHAR(30),
IS_REGISTRED SMALLINT,
PERSONAL_NUMBER VARCHAR(30),
TITLE VARCHAR(10),
PT_NAME VARCHAR(100),
PT_EXTCODE VARCHAR(50),
PASS_NUM VARCHAR(20),
PASS_PLACE VARCHAR(20),
PASS_DATE DATE,
PASS_EXP_DATE DATE,
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_DATE DATE,
SEX CHAR,
BIRTH_PLACE VARCHAR(30),
MASK VARCHAR(10),
PACKAGE VARCHAR(255),
VISA TDESCRIPTION_SHORT)
 RETURNS(GUEST_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable warn_code integer;

declare variable birth_date_old date;
declare variable title_old varchar(10);
declare variable id_passport_type_old integer;
declare variable pass_num_old varchar(20);
declare variable pass_date_old date;
declare variable personal_number_old varchar(30);
declare variable id_stay_reason_old integer;
declare variable is_registred_old integer;
declare variable pass_place_old varchar(20);
declare variable city_old varchar(100);
declare variable address_old varchar(100);
declare variable birth_place_old varchar(30);
declare variable sex_old char(1);
declare variable mask_old varchar(10);
declare variable car_old varchar(30);
declare variable kpp_id_old integer;
declare variable kpp_date_old date;
declare variable pass_exp_date_old date;
declare variable rating_age_old integer;
declare variable visa_old tdescription_short;

declare variable guest_name_old varchar(100);
declare variable is_child_old integer;
declare variable arrival_old date;
declare variable departure_old date;
declare variable voucher_old varchar(30);
declare variable voucher_date_old date;
declare variable voucher_text_old varchar(30);
declare variable country_code_old varchar(10);

declare variable id_passport_type integer;
declare variable kpp_id integer;
declare variable id_stay_reason integer;
begin
  execute procedure import_mark_transaction$exc;

  guest_name = substring(:guest_name from 1 for 50);

  execute procedure sys_dbg('exc IMPORT_GUEST$EXC(:guest_uuid=>' || coalesce(:guest_uuid, '<null>') || ')');
  guest_id = null;

  select pd.person_name, --g.is_different_organizer,
         g.id_guest, g.from_date, g.to_date,
         pd.birthday_internal, pd.title, pd.id_passport_type,
         pd.pass_num, pd.pass_date, pd.egn, gd.id_stay_reason,
         gd.is_registred, pd.pass_place, pd.city, pd.address, pd.birth_place,
         pd.sex, pd.mask, g.is_child, gd.car, gd.kpp, gd.kpp_date,
         pd.pass_exp_date, gd.rating_age, g.vaucher_num, g.vaucher_date, g.vaucher_text, pd.country_code,
         gd.id_stay_reason, gd.visa
  from   GUEST g
         join guest_data gd on gd.id_guest=g.id_guest
         join person_data pd on pd.id_person_data=gd.id_person_data
  where  g.uuid=:guest_uuid
         and g.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and g.id_reserv_detail=:booking_id
  into   :guest_name_old, --:is_different_arranger_old,
         :guest_id, :arrival_old, :departure_old, :birth_date_old,
         :title_old, :id_passport_type_old,
         :pass_num_old, :pass_date_old, :personal_number_old, :id_stay_reason_old,
         :is_registred_old, :pass_place_old, :city_old, :address_old, :birth_place_old,
         :sex_old, :mask_old, :is_child_old, :car_old, :kpp_id_old, :kpp_date_old,
         :pass_exp_date_old, :rating_age_old, :voucher_old, :voucher_date_old,
         :voucher_text_old, :country_code_old, :id_stay_reason_old, :visa_old;

  execute procedure import_passport_type$exc(:pt_name, pt_extcode)
  returning_values :id_passport_type;

  execute procedure import_kpp$exc(:kpp, null)
  returning_values :kpp_id;

  execute procedure import_stay_reason$exc(:stay_reason, null)
  returning_values :id_stay_reason;

  guest_name = coalesce(:guest_name, :guest_name_old);
--  DISABLE age/is_child merge (RIU rating cases)
--  is_child = coalesce(:is_child, :is_child_old);
--  is_different_arranger = coalesce(:is_different_arranger, :is_different_arranger_old);
  arrival = coalesce(:arrival, :arrival_old);
  departure = coalesce(:departure, :departure_old);
  voucher = coalesce(:voucher, :voucher_old);
  voucher_date = coalesce(:voucher_date, :voucher_date_old);
  voucher_text = coalesce(:voucher_text, :voucher_text_old);
  country_code = coalesce(:country_code, :country_code_old);

--  DISABLE age/is_child merge (RIU rating cases)
--  rating_age = coalesce(:rating_age, :rating_age_old);
  kpp_id = coalesce(:kpp_id, :kpp_id_old);
  kpp_date = coalesce(:kpp_date, :kpp_date_old);
  id_stay_reason = coalesce(:id_stay_reason, :id_stay_reason_old);
  car = coalesce(:car, :car_old);
  is_registred = coalesce(:is_registred, 0);
  if (1 = :is_registred_old) then begin --one way update
    is_registred = 1;
  end
  personal_number = coalesce(:personal_number, :personal_number_old);
  title = coalesce(:title, :title_old);
  id_passport_type = coalesce(:id_passport_type, :id_passport_type_old);
  pass_num = coalesce(:pass_num, :pass_num_old);
  pass_place = coalesce(:pass_place, :pass_place_old);
  pass_date = coalesce(:pass_date, :pass_date_old);
  pass_exp_date = coalesce(:pass_exp_date, :pass_exp_date_old);
  city = coalesce(:city, :city_old);
  address = coalesce(:address, :address_old);
  birth_date = coalesce(:birth_date, :birth_date_old);
  sex = coalesce(:sex, :sex_old);
  birth_place = coalesce(:birth_place, :birth_place_old);
  mask = coalesce(:mask, :mask_old);
  visa = coalesce(:visa, :visa_old);

  if (:guest_id is null) then begin
    execute procedure RES_GUEST_SAVE$RSV(null, :booking_id, :guest_name, null, null, :is_child)
    returning_values :guest_id;

    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - get_next_auto_guest = :guest_id=>' || coalesce(:guest_id, '<null>'));
    if (:guest_id is null) then begin 
      execute procedure sys_dbg('exc IMPORT_GUEST$EXC - exhausted auto guests list - create new guest');
      execute procedure RES_GUEST_ADD$RSV(:booking_id, :is_child)
      returning_values :err_code, :err_text, :warn_code, :guest_id;
      if (0 <> :err_code) then exit;
    end

    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - update_new_guest_uuid(:guest_id=>' || coalesce(:guest_id, '<null>') || ', :uuid=>' || coalesce(:guest_uuid, '<null>') || ')');
    update GUEST
    set    uuid = :guest_uuid
    where  id_guest=:guest_id;

    /* preserve default mask */
    if (:mask is null) then begin
      select pd.mask
      from   guest_data gd
             join person_data pd on pd.id_person_data=gd.id_person_data
      where  gd.id_guest=:guest_id
      into   :mask;
    end          
  end else begin
    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - update_guest(:update_guest_id=>' || coalesce(:guest_id, '<null>') || ')');

--    DISABLE age/is_child merge (RIU rating cases) 
--    if (:age is null) then begin
--      select age from GUEST_AGE_CALC(:guest_id)
--      into :age;
--    end
  end

  /*
  execute procedure sys_dbg('exc IMPORT_GUEST$EXC->GUEST_ADDRESSCARD_SET$RSV('
  || 'update_guest_id => ' || coalesce(:update_guest_id, '<null>')
  || ', guest_name => ' || coalesce(:guest_name, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  || ', :id_passport_type => ' || coalesce(:id_passport_type, '<null>')
  || ', :pass_num => ' || coalesce(:pass_num, '<null>')
  || ', :pass_date => ' || coalesce(:pass_date, '<null>')
  || ', :egn => ' || coalesce(:egn_old, '<null>')
  || ', :country => ' || coalesce(:country_old, '<null>')
  || ', :id_stay_reason => ' || coalesce(:id_stay_reason, '<null>')
  || ', :is_registred => ' || coalesce(:is_registred, '<null>')
  || ', :pass_place => ' || coalesce(:pass_place, '<null>')
  || ', :city => ' || coalesce(:city, '<null>')
  || ', :address => ' || coalesce(:address, '<null>')
  || ', :birth_place => ' || coalesce(:birth_place, '<null>')
  || ', :sex => ' || coalesce(:sex, '<null>')
  || ', :mask => ' || coalesce(:mask, '<null>')
  || ', :is_child => ' || coalesce(:is_child, '<null>')
  || ', :car => ' || coalesce(:car, '<null>')
  || ', :kpp => ' || coalesce(:kpp_old, '<null>')
  || ', :kpp_date => ' || coalesce(:kpp_date, '<null>')
  || ', :pass_exp_date => ' || coalesce(:pass_exp_date, '<null>')
  || ', :age => ' || coalesce(:age, '<null>')
  || ', :birth_date => ' || coalesce(:birth_date, '<null>')
  || ', :rating_age => ' || coalesce(:rating_age, '<null>')
  || ', :title => ' || coalesce(:title, '<null>')
  ||')');
  */
  execute procedure GUEST_ADDRESSCARD_SET$RSV(
    :guest_id,
    :guest_name,
    null,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :personal_number,
    :country_code,
    :id_stay_reason,
    :is_registred,
    :pass_place,
    :city,
    :address,
    :birth_place,
    :sex,
    :mask,
    :is_child,
    :car,
    :kpp_id,
    :kpp_date,
    :pass_exp_date,
    :age,
    :birth_date,
    :visa,
    :rating_age,
    :title,
    0
  )
  returning_values :err_code, :err_text, :warn_code;
  if (0 <> :err_code) then exit;

  --execute procedure RES_GUEST_SAVE_ORGANIZER$RSV(:guest_id, :is_different_arranger);

  if ((:arrival is not null) and (:departure is not null)) then begin
    execute procedure RES_GUEST_SAVE_STAY$RSV(:guest_id, :arrival, :departure)
    returning_values :err_code, :err_text, :warn_code;
    if (0 <> :err_code) then exit;
  end

  if (:voucher is not null) then begin
    execute procedure RES_GUEST_SAVE_VOUCHER$RSV(:guest_id, :voucher,
            :voucher_date, :voucher_text, null, null);
  end

  execute procedure IMPORT_GUEST_PACK$EXC(:guest_id, :package);

  update GUEST
  set    ORPHANED_IMPORT$EXC = null
  where  id_guest=:guest_id;
end
^

/* Alter (PAYMENT_DUE_DATE_SET$DOC) */
ALTER PROCEDURE PAYMENT_DUE_DATE_SET$DOC(ID_PAYMENT_HEAD INTEGER,
DUE_DATE DATE)
 AS
begin
  update PAYMENT_HEAD P
  set    P.DUE_DATE = :DUE_DATE
  where  P.ID_PAYMENT_HEAD = :ID_PAYMENT_HEAD;
end
^

/* empty dependent procedure body */
/* Clear: PMS_IMPORT$INT for: PMS_EVENT_POST$INT */
ALTER PROCEDURE PMS_IMPORT$INT(ID_EXPORT_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_EVENT_POST$INT) */
ALTER PROCEDURE PMS_EVENT_POST$INT(ID_PMS_EVENT INTEGER,
ID_ROOM_CONTRACT INTEGER,
ID_RENTAL_POOL INTEGER,
POST_DATE DATE,
PRICE_WITH_VAT NUMERIC(15,4),
PRICE_WO_VAT NUMERIC(15,4),
CURR VARCHAR(3),
MAX_ADULT_CNT INTEGER,
STAY INTEGER,
BED_NIGHT_CNT INTEGER,
BOOKING_CNT INTEGER,
ID_HOTEL INTEGER,
ID_RESERV_DETAIL INTEGER)
 AS
declare variable ownership_percent numeric(15,4);
  declare variable id_owner integer;
  declare variable contract_type varchar(50);
  declare variable posted_orig_value numeric(15,4);
  declare variable posted_orig_curr varchar(3);
  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable owner_use smallint;
  declare variable price_to_post numeric(15,4);
  declare variable id_owner_post_to integer;
  declare variable reserv_no varchar(62);
  declare variable sub_contract varchar(10);
begin
  id_owner_post_to = null;
  owner_use = 0;

  select RD.ID_AGENT_PROFILE, RD.ID_PERSON_PROFILE, iif(RD.ACC_ROUTING = 'OWNER', 1, 0), rd.NUMBER
  from   RESERV_DETAIL RD                      
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :id_agent_profile, :id_person_profile, :owner_use, :reserv_no;

  /* if RESERV_DETAIL.ACC_ROUTING = 'OWNER', ediniqt profil w reserv. e garantirano owner
     pyrwo se prowerqwa dali id_agent_profile e owner, ako ne e se wzema person_profile */

  if (:owner_use = 1) then begin
    /* ako reserv. e owner-ska, ne se generirat prihodi, a razhodite otiwat po smetkata na gosta, a ne na sobstwenicite
     gosta se tyrsi w posledowatelnost ID_AGENT_PROFILE, ID_PERSON_PROFILE*/
    if ( exists ( select p.ID_ROOM
                  from   ROOM_PERIOD$PMS P
                         join ROOM_CONTRACT$PMS C on C.ID_ROOM_PERIOD = P.ID_ROOM_PERIOD
                         join ROOM_OWNER$PMS O on O.ID_ROOM_CONTRACT = C.ID_ROOM_CONTRACT
                  where  O.ID_OWNER = :id_agent_profile
                         and :POST_DATE between P.FROM_DATE and P.TO_DATE  ) ) then
    begin
      --prowerka dali kym momenta(post_date) ima aktiwen dogowor
      id_owner_post_to = :id_agent_profile;
    end else if ( exists ( select p.ID_ROOM
                      from   ROOM_PERIOD$PMS P
                             join ROOM_CONTRACT$PMS C on C.ID_ROOM_PERIOD = P.ID_ROOM_PERIOD
                             join ROOM_OWNER$PMS O on O.ID_ROOM_CONTRACT = C.ID_ROOM_CONTRACT
                      where  O.ID_OWNER = :id_person_profile
                             and :POST_DATE between P.FROM_DATE and P.TO_DATE  ) ) then
    begin
      id_owner_post_to = :id_person_profile;
    end

    if (:id_owner_post_to is null) then begin
      exception PMS_EXCEPTION '-616' || f_character(31) || f_character(29) ||:POST_DATE|| f_character(28) ||:reserv_no;
    end
  end

  for
    select RO.OWNERSHIP_PERCENT,
           RO.ID_OWNER,
           iif(RC.IMPORT_INCOME_WITH_VAT = 1, :price_with_vat, :price_wo_vat),
           RC.CONTRACT_TYPE
    from   ROOM_CONTRACT$PMS RC
           join ROOM_OWNER$PMS RO on RO.ID_ROOM_CONTRACT = RC.ID_ROOM_CONTRACT
    where  RC.ID_ROOM_CONTRACT = :ID_ROOM_CONTRACT
    into   :ownership_percent,
           :id_owner,
           :price_to_post,
           :contract_type
  do begin
    if (:owner_use = 1) then begin
      /*    za sobstwenik ne se poddyrjat prihodi!    */
      sub_contract = 'OWNER_USE';
      posted_orig_value = :price_to_post;
      posted_orig_curr = :curr;
      execute procedure CONTRACT_EXPENSE_POST$INT(:ID_PMS_EVENT, :ID_HOTEL, :ID_ROOM_CONTRACT, :sub_contract,
              :id_owner_post_to, :ownership_percent, null, :posted_orig_value, :posted_orig_curr, :POST_DATE,
              :stay, :max_adult_cnt, :BED_NIGHT_CNT, :BOOKING_CNT);
    end else begin
      sub_contract = 'GUEST_USE';
      execute procedure CONTRACT_MANAGEMENT_POST$INT(:ID_PMS_EVENT, :ID_ROOM_CONTRACT, :sub_contract,
              :contract_type, :ID_OWNER, :ID_RENTAL_POOL, :price_to_post, :curr, :POST_DATE, :stay, :ownership_percent)
      returning_values  (:posted_orig_value, :posted_orig_curr);
      if (:posted_orig_curr is null) then begin
        posted_orig_value = :price_to_post;
        posted_orig_curr = :curr;
      end
      execute procedure CONTRACT_EXPENSE_POST$INT(:ID_PMS_EVENT, :ID_HOTEL, :ID_ROOM_CONTRACT, :sub_contract,
              :ID_OWNER, :ownership_percent, :ID_RENTAL_POOL, :posted_orig_value, :posted_orig_curr, :POST_DATE,
              :stay, :max_adult_cnt, :BED_NIGHT_CNT, :BOOKING_CNT);
    end


    begin -- SHADOW ACCOUNT POSTING
      sub_contract = 'SHADOW_ACC';
      /* da ne se nachislqwa, ako e USE_OWNER_CONTRACT = 1 */
      if (:owner_use = 0) then begin
        execute procedure CONTRACT_MANAGEMENT_POST$INT(:ID_PMS_EVENT, :ID_ROOM_CONTRACT, :sub_contract,
                :contract_type, :ID_OWNER, :ID_RENTAL_POOL, :price_to_post, :curr, :POST_DATE, :stay, :ownership_percent)
        returning_values  (:posted_orig_value, :posted_orig_curr);
        if (:posted_orig_curr is null) then begin
          posted_orig_value = :price_to_post;
          posted_orig_curr = :curr;
        end
      end else begin
        posted_orig_value = :price_to_post;
        posted_orig_curr = :curr;
      end
  
      execute procedure CONTRACT_EXPENSE_POST$INT(:ID_PMS_EVENT, :ID_HOTEL, :ID_ROOM_CONTRACT, :sub_contract,
              iif(:owner_use = 0, :ID_OWNER, :ID_OWNER_POST_TO), :ownership_percent,
              iif(:owner_use = 0, :ID_RENTAL_POOL, null), :posted_orig_value, :posted_orig_curr, :POST_DATE,
              :stay, :max_adult_cnt, :BED_NIGHT_CNT, :BOOKING_CNT);
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: PMS_IMPORT for: PMS_IMPORT$INT */
ALTER PROCEDURE PMS_IMPORT(ID_EXPORT_HEAD INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_IMPORT$INT) */
ALTER PROCEDURE PMS_IMPORT$INT(ID_EXPORT_HEAD INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_room_contract integer;
  declare variable id_pms_event integer;
  declare variable imp_period_from date;
  declare variable event_price_with_vat numeric(15,4);
  declare variable event_price_wo_vat numeric(15,4);
  declare variable curr varchar(3);
  declare variable adult_count integer;
  declare variable id_rental_pool integer;
  declare variable reservs integer;
  declare variable stay integer;
  declare variable bednights integer;
  declare variable id_hotel integer;
begin
  for
    select E.ID_PMS_EVENT, E.ID_RESERV_DETAIL, E.IMP_PERIOD_FROM,
           E.CURR, r.ID_HOTEL, e.PRICE_WO_VAT, e.PRICE_WITH_VAT,
           e.RESERVS, e.STAY, e.BEDNIGHTS, rc.ID_ROOM_CONTRACT, rc.ID_RENTAL_POOL
    from   PMS_EVENT$PMS E
           join ROOMS R on R.ID_ROOM = e.ID_ROOM
           join ROOM_CONTRACT$PMS rc on rc.ID_ROOM_CONTRACT = e.ID_ROOM_CONTRACT
    where  E.ID_EXPORT_HEAD = :ID_EXPORT_HEAD
           and E.EVENT_STATUS = 11
    order by 1
    into   :id_pms_event, :id_reserv_detail, :imp_period_from,
           :curr, :id_hotel, :event_price_wo_vat, :event_price_with_vat,
           :reservs, :stay, :bednights, :id_room_contract, :id_rental_pool
  do begin
/* */
    select r.ADULT_COUNT
    from   RESERV_DETAIL r
    where  r.ID_RESERV_DETAIL = :id_reserv_detail
    into   :adult_count;

    execute procedure PMS_EVENT_POST$INT (:id_pms_event, :id_room_contract, :id_rental_pool,
            :imp_period_from, :event_price_with_vat, :event_price_wo_vat, :curr,
            :adult_count, :stay, :bednights, :reservs, :id_hotel, :id_reserv_detail);

    execute procedure PMS_EVENT_SET_ACTIVE$INT(:id_pms_event);

  end
end
^

/* empty dependent procedure body */
/* Clear: EAI_POS_POSTING_ADD$P2E for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PMS_POSTING_CREATE$INT for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
POST_DATE /* TYPE OF TDATE */ DATE,
CURR_ORIG /* TYPE OF TCURRENCY */ CHAR(3),
VALUE_ORIG /* TYPE OF TPRICE */ NUMERIC(15,4),
POST_ON_PMS_ACCOUNT /* TYPE OF TLOGICAL */ SMALLINT,
IS_OWNER_INCOME /* TYPE OF TLOGICAL */ SMALLINT,
ID_ROOM /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_ACCOUNT_POST /* ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_FINALIZE$POST for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_TELECOUNT_CALL$INT for: POST_SERVICE_ON_ACCOUNT$INT */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_ACCOUNT$INT) */
ALTER PROCEDURE POST_SERVICE_ON_ACCOUNT$INT(ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
QTY TYPE OF TQTY,
ID_SECQUENCE TYPE OF ID,
IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
FROM_DATE TYPE OF TDATE,
TO_DATE TYPE OF TDATE,
POST_TEXT TYPE OF TDESCRIPTION_SHORT,
RESOURCE_TEXT TYPE OF TREASON,
DATE_POST TYPE OF TDATE,
SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ID_ROOM TYPE OF ID = null,
POST_DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable action_text varchar(255);
begin
  if (:date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :date_post;
  end
/* NO AUTO PRICE !!!!!!
  if (:in_is_manual_price = 0) then begin

    select P.ID_EXTRA_TARIFF
    from   ACCOUNT A
           join PROFILE P on P.ID_PROFILE = A.ID_PROFILE
    where  A.ID_ACCOUNT = :in_id_account
    into   :id_extra_tarifa;
    if ((:id_extra_tarifa is null) or (:id_extra_tarifa < 0)) then begin
      err_code = -14;
      exit;
    end
    execute procedure TAR_RECALC_EXTRASRV(:id_extra_tarifa, :in_id_service, :in_date_post)
    returning_values  :err_code, :err_text, :post_price, :post_currency;
    if (:err_code < 0) then exit;
  end else begin
    --MANUAL PRICE
    post_currency = :manual_curr ;
    post_price = :manual_price ;
  end
*/

  post_currency = :manual_curr ;
  post_price = :manual_price ;
  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, -1, :id_secquence, :date_post, :id_service, -1, :id_room, 0, :qty, :post_price,
    :post_currency, null, :short_code, :from_date, :to_date, :post_text, :resource_text, '', -1, :POST_DESCRIPTION)
  returning_values :err_code, :err_text, :id_account_post;
  if (:err_code <> 0) then exit;

  select S.SERVICE_NAME
  from   SERVICES S
  where  S.ID_SERVICE = :ID_SERVICE
  into   :action_text;
   
  action_text = f_character(29) || coalesce(:action_text, '')
                || f_character(28) || formatdate(:DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || coalesce(:post_currency, '');
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_RESERVATION$INT for: POST_SERVICE_ON_GUEST$INT */
ALTER PROCEDURE POST_SERVICE_ON_RESERVATION$INT(ID_RESERV_DETAIL /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
DESCRIPTION /* TYPE OF TOBJECT_TEXT */ VARCHAR(50) = null)
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_SERVICE_ON_ROOM for: POST_SERVICE_ON_GUEST$INT */
ALTER PROCEDURE POST_SERVICE_ON_ROOM(IN_ID_ROOM /* TYPE OF ID */ INTEGER,
IN_ID_SERVICE /* TYPE OF ID */ INTEGER,
IN_QTY /* TYPE OF TQTY */ NUMERIC(15,2),
IN_ID_SECQUENCE /* TYPE OF ID */ INTEGER,
IN_IS_MANUAL_PRICE /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_PRICE /* TYPE OF TPRICE */ NUMERIC(15,4),
MANUAL_CURR /* TYPE OF TCURRENCY */ CHAR(3),
IN_FROM_DATETIME /* TYPE OF TDATE */ DATE,
IN_TO_DATETIME /* TYPE OF TDATE */ DATE,
IN_POST_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_RESOURCE_TEXT /* TYPE OF TREASON */ VARCHAR(50),
IN_DATE_POST /* TYPE OF TDATE */ DATE,
IN_SHORT_CODE /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255))
 RETURNS(ERR_CODE /* TYPE OF ID */ INTEGER,
ERR_TEXT /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
ID_GUEST /* TYPE OF ID */ INTEGER,
ID_ACCOUNT /* TYPE OF ID */ INTEGER,
ID_ACCOUNT_POST /* TYPE OF ID */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_GUEST$INT) */
ALTER PROCEDURE POST_SERVICE_ON_GUEST$INT(IN_ID_GUEST TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TDESCRIPTION_SHORT,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
ACCOUNT_ROUTING TYPE OF TSHORT_CODE,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable post_price numeric(15,4);
  declare variable post_currency varchar (3);
  declare variable id_room integer;
  declare variable no_use varchar(255);
  declare variable action_text varchar(255);
  declare variable is_guest_check_in smallint;
  declare variable service_name varchar(50);
begin
  err_code = 0;
  err_text = '';

  select g.check_status
  from   guest g
  where  g.id_guest = :in_id_guest
  into   :is_guest_check_in;

  if (:is_guest_check_in < 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
  end

  execute procedure GUEST_GET_POSTING_ACCOUNT$INT (:in_id_guest, :account_routing)
  returning_values  :id_account, :id_room;

  if (:in_date_post is null) then begin
    select D.SYSTEM_DATE
    from   ACCOUNT A
           left outer join SYSTEM_DATE_GET(A.ID_HOTEL) D on 0=0
    where  A.ID_ACCOUNT = :id_account
    into   :in_date_post;
  end

  if (:in_is_manual_price = 0) then begin
    execute procedure SERVICE_GET_POSTING_DETAILS(:in_id_service, :IN_DATE_POST)
    returning_values  :no_use, :no_use, :service_name, :post_price, :post_currency;
  end else begin
    /* MANUAL PRICE */
    post_currency = :manual_curr;
    post_price = :manual_price;
    select s.SERVICE_NAME
    from   SERVICES s
    where  s.ID_SERVICE = :IN_ID_SERVICE
    into   :service_name;
  end

  execute procedure ACCOUNT_POSTING_ADD$INT(
    :id_account, :in_id_guest, :in_id_secquence, :in_date_post, :in_id_service, -1, :id_room, 0, :in_qty,
    :post_price, :post_currency, null, :in_short_code, :in_from_datetime, :in_to_datetime, :in_post_text,
    :in_resource_text, '', -1, :DESCRIPTION)
  returning_values  :err_code, :err_text, :id_account_post;

  action_text = f_character(29) || coalesce(:service_name, '')
                || f_character(28) || formatdate(:IN_DATE_POST, 'D;dd.mm.yyyy')
                || f_character(28) || formatfloat(:IN_QTY, 'F;0') || ' * ' || formatfloat(:post_price, 'F;0.00') || ' ' || coalesce(:post_currency, '');
  execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :ID_ACCOUNT, 'SERVICE_POST', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: RESOURCE_RESERVATION_CHECK_IN for: POST_SERVICE_ON_RESERVATION$INT */
ALTER PROCEDURE RESOURCE_RESERVATION_CHECK_IN(ID_RESOURCE_RESERVATION INTEGER,
SERVICE_PRICE NUMERIC(15,2),
SERVICE_CURR VARCHAR(3))
 RETURNS(OUT_ID_ACCOUNT INTEGER,
OUT_ID_ACCOUNT_POST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_RESERVATION$INT) */
ALTER PROCEDURE POST_SERVICE_ON_RESERVATION$INT(ID_RESERV_DETAIL TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TREASON,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG,
DESCRIPTION TYPE OF TOBJECT_TEXT = null)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
declare variable id_guest integer;
begin
  err_code = 0;
  err_text = '';

  id_guest = null;
  select RD.ID_TITULAR
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :id_guest;

  execute procedure POST_SERVICE_ON_GUEST$INT(:id_guest, :in_id_service, :in_qty, :in_id_secquence,
                    :in_is_manual_price, :manual_price, :manual_curr, :in_from_datetime, :in_to_datetime,
                    :in_post_text, :in_resource_text, :in_date_post, :in_short_code, '', :DESCRIPTION)
  returning_values  :err_code, :err_text, :id_account, :id_account_post;
end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_POST_TO_MH_FRONT_ONLINE for: POST_SERVICE_ON_ROOM */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_SERVICE_POST for: POST_SERVICE_ON_ROOM */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_SERVICE_ON_ROOM) */
ALTER PROCEDURE POST_SERVICE_ON_ROOM(IN_ID_ROOM TYPE OF ID,
IN_ID_SERVICE TYPE OF ID,
IN_QTY TYPE OF TQTY,
IN_ID_SECQUENCE TYPE OF ID,
IN_IS_MANUAL_PRICE TYPE OF TLOGICAL,
MANUAL_PRICE TYPE OF TPRICE,
MANUAL_CURR TYPE OF TCURRENCY,
IN_FROM_DATETIME TYPE OF TDATE,
IN_TO_DATETIME TYPE OF TDATE,
IN_POST_TEXT TYPE OF TREASON,
IN_RESOURCE_TEXT TYPE OF TREASON,
IN_DATE_POST TYPE OF TDATE,
IN_SHORT_CODE TYPE OF TDESCRIPTION_LONG)
 RETURNS(ERR_CODE TYPE OF ID,
ERR_TEXT TYPE OF TDESCRIPTION_LONG,
ID_GUEST TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_ACCOUNT_POST TYPE OF ID)
 AS
begin
  err_code = 0;
  err_text = '';

  id_guest = null;
  select first 1 G.ID_GUEST
  from   GUEST G
  where  G.ID_ROOM = :in_id_room
         and G.CHECK_STATUS = 0
  order by G.FROM_DATE desc, G.ID_GUEST asc
        /************************************************/
        /* DESCENDANT ORDER IS VERY IMPORTANT!!         */
        /* IF TWO GUESTS HAVE:                          */
        /* TO_DATE OF THE 1'ST = FROM_DATE OF THE 2'ND, */
        /* THEN PHONACALLS SHOULD GO TO THE 2'ND        */         
        /************************************************/
  into   :id_guest;

  if (:id_guest is null) then begin
    err_code = -24;   /* NO GUESTS ARE CHECKED_IN INTO THE REQUESTED ROOM! */
    exit;
  end

  execute procedure POST_SERVICE_ON_GUEST$INT(:id_guest, :in_id_service, :in_qty, :in_id_secquence, :in_is_manual_price,
    :manual_price, :manual_curr, :in_from_datetime, :in_to_datetime, :in_post_text, :in_resource_text,
    :in_date_post, :in_short_code, '')
  returning_values  :err_code, :err_text, :id_account, :id_account_post;
end
^

/* empty dependent procedure body */
/* Clear: EAI_TELECOUNT_TRANSFER for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALL_POST$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL /* ID */ INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PHONECALLS_POST_TO_ACCOUNT$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: POST_TELECOUNT_TRANSFER$TC for: POST_TELECOUNT_CALL$INT */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (POST_TELECOUNT_CALL$INT) */
ALTER PROCEDURE POST_TELECOUNT_CALL$INT(POST_TO_TYPE INTEGER,
POST_TO_ID INTEGER,
PH_DBKEY CHAR(8),
ID_SEQUENCE INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ext_ifc_name varchar(20);
  declare variable room_name varchar(30);
  declare variable datetime_call timestamp;
  declare variable price numeric(15,2);
  declare variable dial_number varchar(50);
  declare variable units integer;
  declare variable pc_id_service integer;
  declare variable def_manual_curr char(3);
  declare variable post_text varchar(50);
  declare variable id_account_post integer;
  declare variable is_archive integer;
  declare variable id_account integer;
  declare variable new_id_account_post integer;
  declare variable pc_tag varchar(30);
  declare variable number_zone varchar(50);
  declare variable id_hotel integer;
  declare variable id_phonecall integer;
  declare variable no_use varchar(255);
begin
  /* Description:
  || POST_TO_TYPE = 0 - ACCOUNT, 1 - GUEST, 2 - RESERV_DETAIL, 3 - JUST PREPARE, FOR EXTERNAL CLIENT
  */
  err_code = 0;
  err_text = '';
  ext_ifc_name = 'TELECOUNT';

  select PC.ID_PHONECALL, PC.ROOM_NAME, PC.DATETIME_CALL, PC.PRICE, PC.DIAL_NUMBER, PC.UNITS,
         PC.ID_ACCOUNT_POST, PC.IS_ARCHIVE, PC.TAG, substring(PC.NUMBER_ZONE from 1 for 30), pc.ID_HOTEL
  from   PHONECALLS PC 
  where  PC.rdb$db_key = :ph_dbkey
  into   :id_phonecall, :room_name, :datetime_call, :price, :dial_number, :units,
         :id_account_post, :is_archive, :pc_tag, :number_zone, :id_hotel;

  if ((:is_archive = 1) or (coalesce(:id_account_post, 0) > 0)) then exit;

  if ((:pc_tag is null) or (:pc_tag = '')) then pc_tag = 'TELECOUNT_DEFAULT';
  else pc_tag = 'TELECOUNT_' || :pc_tag;

  execute procedure EAI_MAP_SERVICE(:pc_tag, :number_zone, :ext_ifc_name, :id_hotel)
  returning_values  :err_code, :err_text, :pc_id_service;
  if (:err_code < 0) then exit;

  post_text = substring(:dial_number || ', impulses ' || :units from 1 for 50);

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :def_manual_curr;

  new_id_account_post = null;
  if (:post_to_type = 0) then begin
    id_account = :post_to_id;
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name)
    returning_values :err_code, :err_text, :new_id_account_post;
  end else if (:post_to_type = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:post_to_id, :pc_id_service, 1, -1, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name, '')
    returning_values :err_code, :err_text, :id_account, :new_id_account_post;
  end else if (:post_to_type = 2) then begin
    execute procedure POST_SERVICE_ON_RESERVATION$INT(:post_to_id, :pc_id_service, 1, :id_sequence, 1,
      :price, :def_manual_curr, :datetime_call, current_timestamp, :post_text, :room_name, null, :ext_ifc_name)
    returning_values :err_code, :err_text, :id_account, :new_id_account_post;
  end else if (:post_to_type = 3) then begin
    execute procedure POST_PREPARE_ON_ACCOUNT$POST (:post_to_id, :pc_id_service,
      1, :ID_SEQUENCE, :price, :def_manual_curr, :post_text, null, null, :ID_PHONECALL)
    returning_values :no_use;
  end
  if (:err_code < 0) then exit;

  if (:new_id_account_post is not null) then begin
    update PHONECALLS PC
    set    PC.ID_ACCOUNT_POST = :new_id_account_post,
           pc.POSTING_ERROR = null
    where  PC.rdb$db_key = :ph_dbkey;

    insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
    values (:new_id_account_post, :ext_ifc_name, null, :datetime_call);
  end

end
^

/* Alter (POST_TELECOUNT_TRANSFER$TC) */
ALTER PROCEDURE POST_TELECOUNT_TRANSFER$TC(SELECTION_ID INTEGER,
ID_RESERV_DETAIL INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable ph_dbkey char(8);
  declare variable id_account_post integer;
  declare variable account_name varchar(50);
begin
  err_code = 0;
  err_text = '';

  for
    select PC.RDB$DB_KEY, PC.ID_ACCOUNT_POST
    from   PHONECALLS PC
    where  PC.SELECTION_ID = :selection_id
    into   :ph_dbkey, :id_account_post
  do begin
    if ((:id_account_post is not null) and (:id_account_post <> -1)) then begin
      err_code = -117;
      select A.ACCOUNT_NAME
      from   ACCOUNT_POST AP
             join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
      where  AP.ID_ACCOUNT_POST = :id_account_post
      into   :account_name;
      err_text = f_character(29) || :account_name;
      exit;
    end

    execute procedure POST_TELECOUNT_CALL$INT(2, :id_reserv_detail, :ph_dbkey, 0)
    returning_values :err_code, :err_text;
    if (:err_code < 0) then exit;
  end
end
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_OCCUP_SMALL$WBE for: PRODUCT_AVAILABILITY$AVL */
ALTER PROCEDURE AVAILABILITY_OCCUP_SMALL$WBE(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER,
QUERY_ID INTEGER,
ROOMS INTEGER,
RATES VARCHAR(255) = '',
ROOMTYPES VARCHAR(255) = '')
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: CHANNEL_IDSGDS_AVAILABILITY$EXC for: PRODUCT_AVAILABILITY$AVL */
ALTER PROCEDURE CHANNEL_IDSGDS_AVAILABILITY$EXC(CHANNEL_NAME VARCHAR(30),
ID_HOTEL INTEGER,
ADD_BOOKINGS_WITH_PREFIX VARCHAR(10))
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_SIMPLE_RATE INTEGER,
ID_BOARD INTEGER,
ROOM_STATUS INTEGER,
RATE_STATUS INTEGER,
PRODUCT_STATUS INTEGER,
AVAILABLE_ROOMS INTEGER,
MIN_LOS INTEGER,
MAX_LOS INTEGER,
SINGLE_PRICE NUMERIC(15,4),
DOUBLE_PRICE NUMERIC(15,4),
GUEST3_PRICE NUMERIC(15,4),
GUEST4PLUS_PRICE NUMERIC(15,4),
CHILD1_W_ADULT1_PRICE NUMERIC(15,4),
CHILD1_W_ADULT2PLUS_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT1_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT2PLUS_PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: CHANNEL_PRODUCT_AVAIL_REQ$INT for: PRODUCT_AVAILABILITY$AVL */
ALTER PROCEDURE CHANNEL_PRODUCT_AVAIL_REQ$INT(ID_CHANNEL INTEGER,
ID_HOTEL INTEGER,
ARRIVAL DATE,
DEPARTURE DATE,
ROOMS INTEGER)
 RETURNS(ID_ROOM_TYPE INTEGER,
ID_TAR_HEAD INTEGER,
IS_PRODUCT_AVAIALABLE INTEGER,
ROOM_STATUS INTEGER,
RATE_STATUS INTEGER,
RATE_MIN_LOS INTEGER,
RATE_MAX_LOS INTEGER,
AVAILABLE_ROOMS INTEGER,
IS_PUBLIC SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PRODUCT_AVAILABILITY$AVL) */
ALTER PROCEDURE PRODUCT_AVAILABILITY$AVL(ID_CHANNEL INTEGER,
ID_HOTEL INTEGER,
DATE_FROM DATE,
DATE_TO DATE,
RATES VARCHAR(255),
ROOMTYPES VARCHAR(255))
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_TAR_HEAD INTEGER,
ROOM_STATUS INTEGER,
RATE_STATUS INTEGER,
PRODUCT_STATUS INTEGER,
AVAILABLE_ROOMS INTEGER,
MIN_LOS INTEGER,
MAX_LOS INTEGER,
IS_PUBLIC SMALLINT)
 AS
declare variable current_status integer;
declare variable auto_free_rooms integer;
declare variable channel_capacity integer;
declare variable free_rooms integer;
declare variable to_sell integer;
declare variable rate_found smallint;
declare variable auto_percent numeric(15,4);
declare variable conditions varchar(100);
declare variable part varchar(10);
declare variable subpart varchar(10);
declare variable day_capacity numeric(15,4);
declare variable day_occupied numeric(15,4);
begin
  --product_status 0 - closed
  --product_status 1 - closed for arrival
  --product_status 2 - opened

  for
     select AO.ID_ROOM_TYPE, AO.FOR_DATE,
            CA.STATUS, CA.AUTO_FREE_ROOMS, CA.ROOM_COUNT,
            sum(AO.ROOMS_AVAILABLE)
     from   AVAILABILITY_OCCUPANCY$CHM(:ID_HOTEL, :date_from, :date_to) ao
            left join CHANNEL_ALLOTMENT CA on CA.ID_ROOM_TYPE = AO.ID_ROOM_TYPE
                                  and CA.FOR_DATE = Ao.FOR_DATE
      where CA.ID_CHANNEL = :id_channel
            and ((coalesce(cast(:roomtypes as varchar(1000)),'') = '') or (','||cast(:roomtypes as varchar(1000)) ||',' containing ','||AO.ID_ROOM_TYPE||','))
      group by AO.ID_ROOM_TYPE, AO.FOR_DATE,
            CA.STATUS, CA.AUTO_FREE_ROOMS, CA.ROOM_COUNT
      into  :id_room_type, :for_date,
            :current_status, :auto_free_rooms, :channel_capacity,
            :free_rooms
  do begin
    available_rooms = :channel_capacity;
    if (:auto_free_rooms is not null) then begin
      if (coalesce(:free_rooms,0) > :auto_free_rooms) then
        room_status = 2;
      else
        room_status = 0;

      to_sell = coalesce(:free_rooms,0) - coalesce(:auto_free_rooms,0);
      if (:to_sell < 0) then to_sell = 0;
  
      available_rooms = :to_sell;
      if (:channel_capacity is not null and :channel_capacity < :available_rooms) then
        available_rooms = :channel_capacity;

    end else if (:current_status = 0) /*csSell*/ then begin
      /*This situation currently is not supported - if is OPEN always :auto_free_rooms exists*/
      room_status = 2;
      available_rooms = :channel_capacity;
    end else begin /*csStop*/
      room_status = 0;
      available_rooms = 0;
    end

    min_los = null;
    max_los = null;
    rate_status = null;
    id_tar_head = null;
    rate_found = 0;

    for
      select TH.ID_TAR_HEAD, RA.STATUS, RA.AUTO_PERCENT, RA.CONDITIONS, CMR.IS_PUBLIC
      from   RATE_AVAILABILITY RA
             join TAR_HEAD TH on TH.ID_TAR_HEAD = RA.ID_TAR_HEAD
             join TARIFA T on T.ID_TARIFA = TH.ID_TAR_HEAD
             join CHANNEL_MAPPED_RATES cmr on  cmr.id_tar_head = t.id_tarifa
      where  RA.FOR_DATE = :for_date
             and T.ID_HOTEL = :id_hotel
             and cmr.id_channel = :id_channel
             and ((coalesce(:rates,'') = '') or (','||:rates||',' containing ','||T.ID_TARIFA||','))
             and exists (select trt.id_room_type
                         from   TARIFA_ROOM_TYPES_SUPPORTED (th.id_tar_head) trt
                         where  trt.id_room_type = :ID_ROOM_TYPE)
      into   :id_tar_head, :current_status, :auto_percent, :conditions, :is_public
    do begin
      /* Waprosnata tarifa ot rate mng - poddarja li waob6te tozi room-type*/
      if (:auto_percent is not null) then begin
        select sum(tso.G_CAPACITY), sum(tso.OCCUPIED)
        from   SMART_OCCUP$TMP tso
        where  tso.FOR_DATE = :for_date
        into   :day_capacity, :day_occupied;

        if ((:day_capacity <> 0) and ( :day_occupied  / :day_capacity * 100 < :auto_percent)) then begin
            --execute procedure sys_dbg ('AVL  occ' || :day_occupied || '--cap' || :day_capacity || '--%' || :day_percent || '--aut%' || :auto_percent ||'--date' ||:for_date );
          rate_status = 2;
        end else begin
          rate_status = 0;
        end
      end else if (:current_status = 0) then /*rsSell*/
        rate_status = 2;
      else if (:current_status = 1) /*rsStop*/ then
        rate_status = 0;
      else
        rate_status = 1; /*rsNoArrival*/

      min_los = null;
      max_los = null;

      for
        select ITEM
        from   SYSTEM_STRING_PARSER(:conditions,';')
        into   :part
      do begin
        subpart = null;
        select lower(ITEM)
        from   SYSTEM_STRING_PARSER(:part,':')
        where  inturn = 1
        into   :subpart;

        if (:subpart is not null) then begin
          if (:subpart in ('min','equal')) then
            select ITEM
            from   SYSTEM_STRING_PARSER(:part,':')
            where  inturn = 2
            into   :min_los;
          if (:subpart in ('max','equal')) then
            select ITEM
            from   SYSTEM_STRING_PARSER(:part,':')
            where  inturn = 2
            into   :max_los;
        end
      end

      rate_found = 1;

      if (:room_status = 0) then
        product_status = 0;
      else
        product_status = coalesce(:rate_status,0);

      suspend;
    end

    if (:rate_found = 0) then begin
      if (:room_status = 0) then
        product_status = 0;
      else
        product_status = coalesce(:rate_status,0);

      suspend;
    end
  end
end
^

/* Alter (RATE_GET_AVAILABILITY$CHM) */
ALTER PROCEDURE RATE_GET_AVAILABILITY$CHM(ID_RATE INTEGER,
FOR_DATE DATE)
 RETURNS(ACTIVE_STATUS INTEGER,
MIN_LOS INTEGER,
MAX_LOS INTEGER)
 AS
declare variable date_from date;
  declare variable date_to date;
  declare variable RATE_capacity integer;
  declare variable to_sell integer;
begin
  --ACTIVE_STATUS 0 - closed
  --ACTIVE_STATUS 1 - closed fro arrival
  --ACTIVE_STATUS 2 - opened
  --opala ID_HOTEL
--  date_from = null;
--  ACTIVE_STATUS -  autoclose, t.e. AUTO_PERCENT






/*  select min(FOR_DATE), max(FOR_DATE)
  from RATE_ALLOTMENT
  where ID_RATE = :id_RATE
  into :date_from, :date_to;
  if (date_from is null) then exit;

  for select distinct ID_ROOM_TYPE
      from RATE_ALLOTMENT
      where ID_RATE = :id_RATE
        and FOR_DATE between :date_from and :date_to
      into :id_room_type
  do begin
    for select RTR.FOR_DATE,
               CA.STATUS,
               CA.AUTO_FREE_ROOMS, CA.ROOM_COUNT, RTR.AVAILABLE as FREE_ROOMS
        from ROOM_TYPE_GET_FREE$CHM(:date_from, :date_to, :id_room_type) RTR
             join RATE_ALLOTMENT CA on CA.ID_ROOM_TYPE = :id_room_type
                                      and CA.ID_RATE = :id_RATE
                                      and CA.FOR_DATE = RTR.FOR_DATE
    into :for_date, :status,
         :auto_free_rooms, :RATE_capacity, :free_rooms
    do begin
      if (:auto_free_rooms is not null) then
        if (coalesce(:free_rooms,0) >= :auto_free_rooms) then
          is_active = 1;
        else is_active = 0;
      else if (:status = 0) then
             is_active = 1;
           else is_active = 0;

      to_sell = coalesce(:free_rooms,0) - coalesce(:auto_free_rooms,0);
      if (to_sell < 0) then to_sell = 0;

      room_count = :to_sell;
      if (:RATE_capacity is not null) then
        if (RATE_capacity < room_count) then
          room_count = :RATE_capacity;

      suspend;
    end
  end*/
end
^

/* empty dependent procedure body */
/* Clear: RES_TAR_CALC_FINALIZE$INT for: RES_TAR_CALC_REPOST$INT */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(ID_TAR_CALC INTEGER,
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_TAR_CALC_REPOST$INT) */
ALTER PROCEDURE RES_TAR_CALC_REPOST$INT(ID_TAR_CALC TYPE OF ID_REF,
ID_RESERV_DETAIL TYPE OF ID_REF,
RECALC_MARKER VARCHAR(40))
 AS
declare variable id_guest type of id_ref;
  declare variable id_service type of id_ref;
  declare variable id_tariff type of id_ref;
  declare variable date_post type of tdate;
  declare variable qty_post type of tqty;
  declare variable price_orig type of tprice;
  declare variable curr_orig type of tcurrency;
  declare variable id_room type of id_ref;
  declare variable is_base type of tlogical;
  declare variable short_code type of tdescription_long;
  declare variable id_account type of id_ref;
  declare variable gfrom_date type of tdate;
  declare variable gto_date type of tdate;
  declare variable ap_db_key char(8);
  declare variable id_pack_service type of id_ref;
  declare variable err_code type of id_ref;
  declare variable err_text type of tdescription_long;
  declare variable id_master_account_post type of id_ref;
  declare variable id_acc_post type of id_ref;
  declare variable is_base_account type of id_ref;
  declare variable id_extra_account type of id_ref;
  declare variable no_use varchar(255);
begin
  for
    select   TCP.ID_GUEST, TCP.ID_SERVICE, TCP.ID_TARIFF, TCP.DATE_POST, TCP.QTY_POST,
             round_f(TCP.PRICE_ORIG, c.ROUND_TO), TCP.CURR_ORIG, TCP.ID_ROOM, TCP.IS_BASE,
             TCP.SHORT_CODE, iif(coalesce(AGP.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'NONE', 0, 1),
             G.ID_BASE_ACCOUNT, G.FROM_DATE, G.TO_DATE, G.ID_ACCOUNT
    from     TAR_CALC_POST$TMP TCP
             join GUEST G on G.ID_GUEST = TCP.ID_GUEST
             join SERVICES S on S.ID_SERVICE = TCP.ID_SERVICE
             join CURRS c on c.CURR = tcp.CURR_ORIG
             left outer join AGENT_PACKET AGP on AGP.ID_SERVICE = S.ID_SERVICE and AGP.ID_AGENT = G.ID_AGENT
    where    TCP.ID_TAR_CALC = :id_tar_calc
             and tcp.ID_RESERV = :ID_RESERV_DETAIL
                  --or (coalesce(RD.IS_POSTING_STOPPED, 0) = 0 and RD.POSTING_TRANSACTION_UUID is not null))
    order by TCP.ID_GUEST asc, TCP.DATE_POST asc, TCP.IS_BASE desc
    into     :id_guest, :id_service, :id_tariff, :date_post, :qty_post,
             :price_orig, :curr_orig, :id_room, :is_base, :short_code, :is_base_account,
             :id_account, :gfrom_date, :gto_date, :id_extra_account
  do begin
    ap_db_key = null;
    if (:is_base = 1) then begin
      select AP.RDB$DB_KEY, AP.ID_MASTER_ADDINS_ACC_POST, AP.ID_PACK_SERVICE
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.DATE_POST = :date_post
             and AP.IS_BASE = 1
      into   :ap_db_key, :id_master_account_post, :id_pack_service;

      --execute procedure sys_dbg('tar TAR_CALC_REPOST$INT price_orig = '||coalesce(:price_orig, 'null'));
      --execute procedure sys_dbg('tar TAR_CALC_REPOST$INT ap_db_key = '||coalesce(:ap_db_key, 'null'));

      if (:ap_db_key is null) then begin
        id_master_account_post = -1;
        execute procedure GUEST_POST_GET_PACK_SERVICE(:id_service, :id_guest, :date_post)
        returning_values  :id_pack_service;
      end
    end else begin
      -- short_code = '';
      select first 1 APU.rdb$db_key
      from   ACCOUNT_POST APU
      where  APU.ID_MASTER_ADDINS_ACC_POST = :id_master_account_post
             and APU.ID_SERVICE = :id_service
             and APU.CHANGED_TEXT is distinct from :recalc_marker
      order by apu.IS_ANUL asc, apu.ID_ACCOUNT_POST asc
      into   :ap_db_key;

      if ((:is_base_account <> 1)) then id_account = :id_extra_account;
    end

    if (:ap_db_key is null) then begin
      execute procedure ACCOUNT_POSTING_ADD$INT(
        :id_account, :id_guest, -1, :date_post, :id_service, :id_tariff, :id_room, :is_base, :qty_post,
        :price_orig, :curr_orig, null, :short_code, :gfrom_date, :gto_date, 'PACK='||:id_pack_service, '',
        :recalc_marker, :id_master_account_post)
      returning_values  :err_code, :err_text, :id_acc_post;
      if (:err_code <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

      if (:is_base = 1) then id_master_account_post = :id_acc_post;

    end else begin
      execute procedure ACCOUNT_POSTING_UPDATE$INT(
        :ap_db_key, :id_service, :id_tariff, :id_room, :qty_post, 0, :price_orig, :curr_orig, null,
        :recalc_marker, :short_code, :gfrom_date, :gto_date, 1, :id_account)
      returning_values  :no_use, :no_use, :no_use;
    end

  end

  ap_db_key = null;
  id_guest = null;
  for
    select distinct TCP.ID_GUEST
    from   TAR_CALC_POST$TMP TCP
    where  tcp.ID_TAR_CALC = :ID_TAR_CALC
           and tcp.ID_RESERV = :ID_RESERV_DETAIL
    into   :id_guest
  do begin
    for
      select AP.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  AP.ID_GUEST = :id_guest
             and AP.CHANGED_TEXT is distinct from :recalc_marker
             and AP.ID_MASTER_ADDINS_ACC_POST > 0
             and AP.IS_ANUL = 0
      into   :ap_db_key
    do begin
      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_db_key, :recalc_marker);
    end
  end

  delete from RESERV_PREPOST RP where RP.ID_RESERV_DETAIL = :id_reserv_detail;
  execute procedure RES_TAKE_POSTING_RESPONSIBILITY (:ID_RESERV_DETAIL);
end
^

/* Alter (RESOURCE_RESERVATION_CHECK_IN) */
ALTER PROCEDURE RESOURCE_RESERVATION_CHECK_IN(ID_RESOURCE_RESERVATION INTEGER,
SERVICE_PRICE NUMERIC(15,2),
SERVICE_CURR VARCHAR(3))
 RETURNS(OUT_ID_ACCOUNT INTEGER,
OUT_ID_ACCOUNT_POST INTEGER)
 AS
declare variable old_status varchar(20);
  declare variable new_status varchar(20);
  declare variable dbkey char(8);
  declare variable id_service id_ref;
  declare variable price_post tprice;
  declare variable curr_post TCURRENCY;
  declare variable is_manual_price TLOGICAL;
  declare variable is_details tlogical;
  declare variable post_description tobject_text;
  declare variable id_reserv_detail integer;
  declare variable post_date tdate;
  declare variable from_datetime tdatetime;
  declare variable to_datetime tdatetime;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  new_status = 'CHECKED_IN';

  select r.RDB$DB_KEY, R.STATUS, rd.ID_RESERV_DETAIL
  from   RESOURCE_RESERVATION R
         left outer join RESERV_DETAIL rd on rd.NUMBER = r.BOOKING_NUMBER
                                             and rd.IS_ANUL = 0
                                             and rd.SUBSCRIBER_ID is not distinct from r.SUBSCRIBER_ID
  where  R.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION
  into   :dbkey, :old_status, :id_reserv_detail;

  if (:old_status = :NEW_STATUS) then exit;
 
  if (:old_status is distinct from 'RESERVED') then exception ASSERT '-511';

  if (exists (select RP.ID_RESOURCE_RESERVATION
              from   RESOURCE_RESERV_POST RP
                     join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = RP.ID_ACCOUNNT_POST
              where  RP.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION)) then
  begin
    exception ASSERT '-505';
  end

  if (:id_reserv_detail is not null) then begin
    execute procedure RESOURCE_RESERV_SERVICE_GET (:ID_RESOURCE_RESERVATION)
    returning_values (:id_service, :price_post, :curr_post, :is_manual_price, :is_details, :post_description,
                     :post_date, :from_datetime, :to_datetime);
  
    if (:is_manual_price = 1) then begin
      price_post = :SERVICE_PRICE;
      curr_post = :SERVICE_CURR;
    end

    if (:price_post is null) then exception ASSERT 'Unspecified service price!';
    if (:curr_post is null) then exception ASSERT 'Unspecified price currency!';
  
    execute procedure POST_SERVICE_ON_RESERVATION$INT (:id_reserv_detail, :id_service, 1, 0,
            1, :price_post, :curr_post, :from_datetime, :to_datetime,
            '', '', :post_date, 'RESOURCE', :post_description)
    returning_values (:ERR_CODE, :ERR_TEXT, :OUT_ID_ACCOUNT, :OUT_ID_ACCOUNT_POST);
    if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
  
    insert into RESOURCE_RESERV_POST(ID_RESOURCE_RESERVATION, ID_ACCOUNNT_POST)
    values (:ID_RESOURCE_RESERVATION, :OUT_ID_ACCOUNT_POST);
  end

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = :NEW_STATUS
  where  RR.RDB$DB_KEY = :dbkey;

end
^

/* Alter (RIGHTS_GROUP_USER_MODIFY) */
ALTER PROCEDURE RIGHTS_GROUP_USER_MODIFY(USER_NAME VARCHAR(30),
ID_RIGHT_GROUP INTEGER,
OPERATION VARCHAR(50))
 AS
declare variable right_group varchar(30);
begin
  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add,del');

  if (:USER_NAME = 'SYSDBA') then exit;

  select rg.GROUP_NAME
  from   RIGHTS_GROUPS RG
  where  RG.ID_RIGHT_GROUP = :ID_RIGHT_GROUP
  into   :right_group;

  if (:operation = 'add') then begin
    insert into RIGHTS_USER_GROUPS (USER_NAME, ID_RIGHT_GROUP)
    values (:user_name, :id_right_group);

    execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_ADDED',
            f_character(29) || :USER_NAME  || f_character(28) || :right_group);

  end else begin
    delete from RIGHTS_USER_GROUPS
    where USER_NAME = :user_name
          and ID_RIGHT_GROUP = :id_right_group;

    if (row_count > 0) then
      execute procedure SYSTEM_LOG_ADD('USER_RIGHT', null, 'USER_REMOVED',
              f_character(29) || :USER_NAME || f_character(28) || :right_group);

  end

  when sqlcode -803 do begin
    /* ERR_TEXT = '       ! ' ;*/
    exit;
  end
end
^

/* empty dependent procedure body */
/* Clear: CHANNEL_GET_WHOLEALLOTMENT$CHM for: ROOM_TYPE_GET_FREE$CHM */
ALTER PROCEDURE CHANNEL_GET_WHOLEALLOTMENT$CHM(ID_CHANNEL INTEGER)
 RETURNS(ID_ROOM_TYPE INTEGER,
FOR_DATE DATE,
IS_ACTIVE INTEGER,
AUTO_FREE_ROOMS INTEGER,
ROOM_COUNT INTEGER,
FREE_ROOMS INTEGER,
STATUS INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (ROOM_TYPE_GET_FREE$CHM) */
ALTER PROCEDURE ROOM_TYPE_GET_FREE$CHM(FROM_DATE DATE,
TO_DATE DATE,
ID_ROOM_TYPE INTEGER)
 RETURNS(FOR_DATE DATE,
AVAILABLE INTEGER,
OCCUPIED INTEGER)
 AS
declare variable id_hotel integer;
begin

  select RT.ID_HOTEL
  from   ROOM_TYPES RT
  where  RT.ID_ROOM_TYPE = :id_room_type
  into   :id_hotel;

  /*!!!! moje da se optimizira - ako se sloji id_room_type whoden parametar na availability_occup_small$int*/
  for
    select aos.for_date, aos.rooms_available, aos.rooms_occupied
    from   AVAILABILITY_OCCUPANCY$CHM (:ID_HOTEL, :FROM_DATE, :TO_DATE) aos
    where  aos.id_room_type = :id_room_type
    into   :for_date, :available, :occupied
  do suspend;

end
^

/* Alter (ROOM_TYPE_GET_FREE_ALL$CHM) */
ALTER PROCEDURE ROOM_TYPE_GET_FREE_ALL$CHM(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER)
 RETURNS(FOR_DATE DATE,
AVAILABLE INTEGER,
OCCUPIED INTEGER,
ID_ROOM_TYPE INTEGER)
 AS
begin

  /*!!!! moje da se optimizira - ako se sloji id_room_type whoden parametar na availability_occup_small$int*/
  for
    select AOS.FOR_DATE, AOS.ROOMS_AVAILABLE, AOS.ROOMS_OCCUPIED, AOS.ID_ROOM_TYPE
    from   AVAILABILITY_OCCUPANCY$CHM (:ID_HOTEL, :FROM_DATE, :TO_DATE) AOS
    into   :for_date, :available, :occupied, id_room_type
  do suspend;

end
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_MODIFY for: SAFE_OCCUPANCY_POSTING$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE /* TYPE OF ID */ INTEGER,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100))
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SAFE_OCCUPANCY_NEW for: SAFE_OCCUPANCY_POSTING$INT */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE /* TYPE OF ID */ INTEGER,
FROM_DATETIME /* TDATETIME */ TIMESTAMP,
TO_DATETIME /* TYPE OF TDATETIME */ TIMESTAMP,
OCCUPANT_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100),
BOOKING_NUMBER /* TYPE OF TRES_NUMBER */ VARCHAR(62),
ID_EXTERNAL_CLIENT_ACCCOUNT /* TYPE OF ID_REF */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER,
ID_RESOURCE_RESERVATION /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SAFE_OCCUPANCY_POSTING$INT) */
ALTER PROCEDURE SAFE_OCCUPANCY_POSTING$INT(ID_RESOURCE_RESERVATION TYPE OF ID,
ID_SERVICE TYPE OF ID,
PRICE TYPE OF TPRICE,
CURRENCY TYPE OF TCURRENCY,
PRICE_DESCRIPTION TYPE OF TDESCRIPTION_SHORT,
ID_RESERV_DETAIL TYPE OF ID,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF = null)
 RETURNS(DOC_SELECTED TYPE OF TRANGE)
 AS
declare variable from_datetime timestamp;
  declare variable to_datetime timestamp;
  declare variable ap_dbkey TDB_KEY;
  declare variable id_account_post integer;
  declare variable safe_name TOBJECT_NAME;
  declare variable no_use varchar(255);
  declare variable new_ac varchar(2);
  declare variable err_code integer;
  declare variable err_text varchar(255) ;
  declare variable occupant_name tperson_name;
  declare variable id_room integer;
  declare variable id_tariff integer;
begin
  DOC_SELECTED = null;
  select od.FROM_DATETIME, od.TO_DATETIME, ap.RDB$DB_KEY, ap.ID_ACCOUNT_POST,
         s.SAFE_NAME, rr.OCCUPANT_NAME, ap.ID_ROOM, ap.ID_TARIFF
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join SAFES s on s.ID_SAFE = od.ID_RESOURCE
         left outer join RESOURCE_RESERV_POST rrp on rrp.ID_RESOURCE_RESERVATION = rr.ID_RESOURCE_RESERVATION
         left outer join ACCOUNT_POST ap on ap.ID_ACCOUNT_POST = rrp.ID_ACCOUNNT_POST
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :from_datetime, :to_datetime, :ap_dbkey, :id_account_post,
         :safe_name, :occupant_name, :id_room, :id_tariff;

  new_ac = null;
  if (:id_account_post is not null) then begin
    execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
            :id_tariff, :id_room, 1, 0, :price, :currency, null, null, 'RESOURCE', :from_datetime, :TO_DATETIME, 1)
    returning_values :no_use, :no_use, :new_ac;
  end else begin
    if (:id_reserv_detail is not null) then begin
      execute procedure POST_SERVICE_ON_RESERVATION$INT (:id_reserv_detail, :id_service, 1, 0,
              1, :price, :currency, :from_datetime, :to_datetime,
              '', '', cast(:from_datetime as date), 'RESOURCE', null)
      returning_values (:ERR_CODE, :ERR_TEXT, :no_use, :id_account_post);
      if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      new_ac = '00';
    end else if (:ID_EXTERNAL_CLIENT_ACCCOUNT is not null) then begin
      execute procedure POST_SERVICE_ON_ACCOUNT$INT (:ID_EXTERNAL_CLIENT_ACCCOUNT, :id_service,
              1, 0, 1, :price, :currency, :from_datetime, :TO_DATETIME, '', '',
              cast(:from_datetime as date), 'RESOURCE', null, null)
      returning_values (:err_code, :err_text, :id_account_post);
      if (:err_code < 0) then exception ASSERT :err_code || f_character(31) || coalesce(:err_text, '');
      new_ac = '00';
    end
  end

  if (:new_ac is null) then
    exception ASSERT '-1067' || f_character(31) || f_character(29) || :safe_name || f_character(28) || :occupant_name;

  if (:new_ac = '00') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);
    update ACCOUNT_POST AP
    set    ap.DOC_SELECTED = :DOC_SELECTED
    where  ap.ID_ACCOUNT_POST = :id_account_post;
  end

  update or insert into ACCOUNT_POSTING_DET (ID_ACCOUNT_POST, POST_TEXT, QTY,
         FROM_DATETIME, TO_DATETIME, RESOURCE_TEXT)
  values (:id_account_post, :safe_name ||' / '||formatdate(:from_datetime, 'D;dd.mm.yy(hh:mm)')||' - '||formatdate(:to_datetime, 'D;dd.mm.yy(hh:mm)')||' / '
          ||substring(replace(:price_description, F_CRLF(), ';') from 1 for 100), 1, :from_datetime, :to_datetime, :safe_name);

  if (not exists (select rp.ID_ACCOUNNT_POST
                  from   RESOURCE_RESERV_POST rp
                  where  rp.ID_RESOURCE_RESERVATION = :ID_RESOURCE_RESERVATION
                         and rp.ID_ACCOUNNT_POST = :id_account_post)) then
  begin
    insert into RESOURCE_RESERV_POST (ID_RESOURCE_RESERVATION, ID_ACCOUNNT_POST)
    values (:id_resource_reservation, :id_account_post);
  end
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_PARAMS$INT for: TARIFA_GET_PARAM */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TARIFA_GET_PARAM) */
ALTER PROCEDURE TARIFA_GET_PARAM(ID_PARAM INTEGER,
FOR_DATE DATE,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER)
 RETURNS(OUT_VALUE VARCHAR(255))
 AS
declare variable is_interface integer;
  declare variable param_code varchar(30);
  declare variable is_value integer;
  declare variable int1 integer;
  declare variable data_type varchar(10);
  declare variable pvalue varchar(20);
  declare variable from_ date;
  declare variable to_ date;
begin
  select TP.IS_INTERFACE, TP.PARAM_CODE, TP.IS_VALUE, TP.DATA_TYPE, TP.PVALUE
  from   TARIFA_PARAMS TP
  where  ID_TARIFA_PARAM = :ID_PARAM 
  into   :is_interface, :param_code, :is_value, :data_type, :pvalue;
  /*get interface params*/
  if (:PARAM_CODE = 'NATION2') then
    PARAM_CODE = 'NATION'; /* !!!!!!!!!! */

  /*get value params*/
  if (:IS_VALUE = 1) then
    OUT_VALUE = :pvalue;

  /*get internal params*/
  OUT_VALUE = null;
  if (:IS_INTERFACE = 0) then begin
    if (:PARAM_CODE = 'TODAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE, 'D;dd/mm/yyyy');

    end else if (:PARAM_CODE = 'WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE, 'DW;MON');

    end else if (:PARAM_CODE = 'NEXT_DATE_WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE + 1, 'DW;MON');

    end else if (:PARAM_CODE = 'PREV_DATE_WEEK_DAY') then begin
      OUT_VALUE = formatdate(:FOR_DATE - 1, 'DW;MON');

    end else if (:PARAM_CODE = 'REQUIRED_WEEK_DAYS') then begin
      select ti.FROM_DATE, ti.TO_DATE - 1
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :from_, :to_;
      
      select list(formatdate(RLP.OUT_DATE, 'DW;MON'))
      from   SYSTEM_LOOP_PERIOD(:from_, :to_) RLP
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'ARRIVAL_WEEK_DAYS') then begin
      select formatdate(ti.FROM_DATE, 'DW;MON')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'PRESTOI') then begin
      select cast(ti.TO_DATE - ti.FROM_DATE as integer)
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'FROM_DATE') then begin
      select formatdate(ti.FROM_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TO_DATE') then begin
      select formatdate(ti.TO_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'FIRST_NIGHT') then begin
      select formatdate(ti.FROM_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'LAST_NIGHT') then begin
      select formatdate(ti.TO_DATE - 1, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'DAYS_PASSED') then begin
       /* 01  03 -  01-1, 02-2   (        )*/   
       select cast((:FOR_DATE - G.FROM_DATE + 1) as integer)
       from   TAR_CALC_INPUT$TMP G
       where  G.ID_TAR_INPUT = :ID_TAR_INPUT
       into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'DAYS_TO_STAY') then begin
       /* 01  03 -  01-2, 02-1    (  )*/
       select cast((G.TO_DATE - :FOR_DATE - 1) as integer)
       from   TAR_CALC_INPUT$TMP G
       where  G.ID_TAR_INPUT = :ID_TAR_INPUT
       into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_GUESTS') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_CHILDREN') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.IS_CHILD = 1
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_ADULTS') then begin
      select (select count(*)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.IS_CHILD is distinct from 1
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_GUESTS_BY_ACCOUNT') then begin
      select (select count(*)
              from   GUEST G
                     join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
              where  G.ID_BASE_ACCOUNT = ti.ID_BASE_ACCOUNT
                     and G.FROM_DATE <= :FOR_DATE
                     and G.TO_DATE > :FOR_DATE
                     and RD.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP ti
      where  ti.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TYPE_ROOM') then begin
      select trim(rt.TYPE_ROOM)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join ROOM_TYPES RT on RT.ID_ROOM_TYPE = tid.ID_ROOM_TYPE
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
      into   :OUT_VALUE;
      /* TO PRESEVE COMPATIBILITY WITH OLD TARIFF VERSIONS */
      /* WE HAVE TO RETURN THE NAME NOT THE ID !           */

    end else if (:PARAM_CODE = 'TYPE_STAY') then begin
      select trim(ts.TYPE_STAY)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join TYPE_STAY TS on ts.ID_TYPE_STAY = tid.ID_TYPE_STAY
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TYPE_HRANA') then  begin
      select trim(m.NAME)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join MEALS m on m.ID_BOARD = tid.ID_BOARD
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;
      OUT_VALUE = trim(coalesce(:OUT_VALUE, ''));

    end else if (:PARAM_CODE = 'PACK_ITEMS') then begin
      OUT_VALUE = null;
      select TID.PACKET_ITEMS
      from   TAR_CALC_INPUT$TMP TID
      where  TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;
      OUT_VALUE = coalesce(:OUT_VALUE, '~~');
      -- strfloateval('POS("~2~", :PACK_ITEMS)>0', ';:PACK_ITEMS,STRING,~2~3~D~')

    end else if (:PARAM_CODE = 'AGE') then begin
      select ti.GUEST_AGE
      from   TAR_CALC_INPUT$TMP TI
      where  TI.ID_TAR_INPUT = :ID_TAR_INPUT
             --and ti.ID_GUEST = :ID_GUEST
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_SEX') then begin
      select G.GUEST_SEX
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE ;
      if ((:OUT_VALUE is null) or (:OUT_VALUE = '')) then OUT_VALUE = '-' ;

    end else if (:PARAM_CODE = 'NATION') then begin
      select tid.COUNTRY_CODE
      from   TAR_CALC_INPUT$TMP TID
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_FIRST_DATE') then begin
      select cast(iif(G.FROM_DATE = :FOR_DATE, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_LAST_DATE') then begin
      select cast(iif(G.TO_DATE -1 = :FOR_DATE, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_LATE_CHECKOUT') then begin
      select g.IS_LATE_CHECKOUT
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_FIRST_GUEST_IN_ROOM') then begin
      select (select count(ti.ID_TAR_INPUT)
              from   TAR_CALC_INPUT$TMP ti
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and ti.ID_GUEST < t.ID_GUEST)
      from   TAR_CALC_INPUT$TMP t
      where  t.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :int1;

      if (:int1 = 0) then OUT_VALUE = 1; else OUT_VALUE = 0;
      
    end else if (:PARAM_CODE = 'IS_DIFER_NATIONS') then begin
      select (select cast(iif(count(distinct ti.COUNTRY_CODE) > 1, 1, 0) as integer)
              from   TAR_CALC_INPUT_DETAIL$TMP td
                     join TAR_CALC_INPUT$TMP TI on ti.ID_TAR_INPUT = td.ID_TAR_INPUT
              where  td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ti.ID_TAR_CALC = :ID_TAR_CALC)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
      where  TID.FOR_DATE = :FOR_DATE
             and TID.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'IS_GROUP') then begin
      select cast(iif(g.ID_GROUP is not null, 1, 0) as integer)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'COUNT_NIGHTS_BY_ACCOUNT') then begin
      /*          . */
      select (select cast(sum (G_IN_R.TO_DATE - G_IN_R.FROM_DATE) as integer)
              from   GUEST G_IN_R
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_R.ID_RESERV_DETAIL
              where  G_IN_R.ID_BASE_ACCOUNT = G.ID_BASE_ACCOUNT
                     and G_IN_R.CHECK_STATUS = 0
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_INTURN_BYACCOUNT') then begin
      select (select cast(count(G.ID_GUEST) as integer)
              from   GUEST G
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL and rd.IS_ANUL = 0
              where  G.ID_BASE_ACCOUNT = t.ID_BASE_ACCOUNT
                     and G.ID_GUEST <= t.ID_GUEST)
      from   TAR_CALC_INPUT$TMP t
      where  t.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'PAX_PRICE_WO_ADDINS') then begin
      /*             */
      /* PRICE_ORIG          */
      -- ?????    ???
      /*select  max(AP.PRICE_ORIG)
      from    ACCOUNT_POST AP 
      where   AP.ID_GUEST = :ID_GUEST
              and AP.DATE_POST = :FOR_DATE
              and AP.IS_BASE = 1
      plan    (AP index (ACCOUNT_POST_IDX6))
      into    :OUT_VALUE;
      */
      OUT_VALUE = null;

    end else if (:PARAM_CODE = 'ROOM_FEATURES') then begin
      select substring(R.FEATURES from 1 for 255)
      from   TAR_CALC_INPUT_DETAIL$TMP TID
             join ROOMS R on r.ID_ROOM = tid.ID_ROOM
      where  tid.FOR_DATE = :FOR_DATE
             and tid.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_NIGHTS') then begin
      select (select cast(sum (G_IN_V.TO_DATE - G_IN_V.FROM_DATE) as integer)
              from   GUEST G_IN_V
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_V.ID_RESERV_DETAIL
              where  rd.ID_AGENT_PROFILE is not distinct from G.ID_AGENT_PROFILE
                     and G_IN_V.VAUCHER_NUM = G.VOUCHER_NUM
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE ;

    end else if (:PARAM_CODE = 'VAUCHER_GUESTS') then begin
      select (select count (G_IN_V.ID_GUEST)
              from   GUEST G_IN_V
                     join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = G_IN_V.ID_RESERV_DETAIL and rd.IS_ANUL = 0
              where  rd.ID_AGENT_PROFILE is not distinct from G.ID_AGENT_PROFILE
                     and G_IN_V.VAUCHER_NUM = G.VOUCHER_NUM
                     and rd.IS_ANUL = 0)
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_DATE') then begin
      select formatdate(G.VOUCHER_DATE, 'D;dd/mm/yyyy')
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
             and trim(G.VOUCHER_NUM) <> ''
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'VAUCHER_TEXT') then begin
      select G.VOUCHER_TEXT
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_INTURN_BYROOM') then begin
      select (select count(*) + 1
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ((t.IS_CHILD = 0 and ti.IS_CHILD = 0 and td.CHECKIN_ORDER < tid.CHECKIN_ORDER)
                          or (t.IS_CHILD = 1 and ((ti.IS_CHILD = 0) or (ti.GUEST_AGE > t.GUEST_AGE) or (ti.GUEST_AGE = t.GUEST_AGE and td.CHECKIN_ORDER < tid.CHECKIN_ORDER) )))
              )
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'ADULT_INTURN_BYROOM') then begin
      OUT_VALUE = 0;
      select (select count(*) + 1
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and td.CHECKIN_ORDER < tid.CHECKIN_ORDER
                     and ti.IS_CHILD = 0)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
             and t.IS_CHILD = 0
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'CHILD_INTURN_BYROOM') then begin
      OUT_VALUE = 0;
      select (select count(*) + 1
              from   TAR_CALC_INPUT$TMP ti
                     join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
              where  ti.ID_TAR_CALC = t.ID_TAR_CALC
                     and td.FOR_DATE = tid.FOR_DATE
                     and td.ID_ROOM = tid.ID_ROOM
                     and ( (ti.GUEST_AGE > t.GUEST_AGE) or (ti.GUEST_AGE = t.GUEST_AGE and td.CHECKIN_ORDER < tid.CHECKIN_ORDER) )
                     and ti.IS_CHILD = 1)
      from   TAR_CALC_INPUT_DETAIL$TMP tid
             join TAR_CALC_INPUT$TMP t on t.ID_TAR_INPUT = tid.ID_TAR_INPUT
      where  tid.ID_TAR_INPUT = :ID_TAR_INPUT
             and tid.FOR_DATE = :FOR_DATE
             and t.IS_CHILD = 1
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'GUEST_TYPE') then begin
      select G.ID_GUEST_TYPE
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else if (:PARAM_CODE = 'TO_AGENT') then begin
      select G.ID_AGENT_PROFILE
      from   TAR_CALC_INPUT$TMP G
      where  G.ID_TAR_INPUT = :ID_TAR_INPUT
      into   :OUT_VALUE;

    end else begin
      exception RATING_EXCEPTION 'Unsupported param - '||:PARAM_CODE;
    end

  end /*PART OF INTERNAL PARAMS*/


  /**********************************************/
  begin
    /* the source of the next check is gone with the wind
    /* but we must distinguish different data types */
    if ((:OUT_VALUE is null) or (:OUT_VALUE = '')) then begin
      /*not allow nulls*/
      if (:DATA_TYPE = 'DATE') then OUT_VALUE = '01/01/1899';
      else OUT_VALUE = '-1';  -- Unspecified
    end else if (:DATA_TYPE = 'INTEGER') then begin
      OUT_VALUE = cast(:OUT_VALUE as integer);
      /* to prevent errors like OUT_VALUE = '00001' */
    end

    when any do exception RATING_EXCEPTION 'Unsupported param value: ' || :param_code || ' = "' || coalesce(:OUT_VALUE, '<null>') || '"';
  end
  /**********************************************/
end
^

/* Alter (TEST_DOC) */
ALTER PROCEDURE TEST_DOC(ID_ACCOUNT INTEGER,
DOC_SELECTED INTEGER)
 RETURNS(ID_DOC_HEAD INTEGER)
 AS
declare variable is_dep_doc integer;
  declare variable id_hotel integer;
  declare variable dummy varchar(255);
begin
  is_dep_doc = 0;

  execute procedure DOCUMENT_INITIALIZE$DOC (:id_account, :doc_selected, null)
  returning_values (:id_doc_head, :id_hotel, :dummy);

  execute procedure DOCUMENT_ADD_DEF_PAYMENT$DOC (:id_doc_head, null);

  execute procedure DOCUMENT_VALIDATE$DOC (:id_doc_head)
  returning_values :dummy, :dummy, :dummy;
  suspend;
end
^

/* Restore proc. body: ACC_STATEMENT_INVOICES_GET$PMS */
ALTER PROCEDURE ACC_STATEMENT_INVOICES_GET$PMS(ID_BILL INTEGER)
 RETURNS(ID_DOC INTEGER,
ID_SERVICE INTEGER,
DATE_POST DATE,
ROOM_NAME VARCHAR(100),
LINE_DESC VARCHAR(100),
OUTGO_VALUE NUMERIC(15,4),
CURR_POST VARCHAR(3),
IS_ANUL SMALLINT,
INV_DESCRIPTION VARCHAR(100))
 AS
declare variable id_hotel integer;
  declare variable sign_ smallint;
  declare variable doc_sub_type smallint;
begin

  for
    select distinct DL.ID_DOC_HEAD, DH.DOC_SUB_TYPE, O.ID_CURRENCY,
           DT.DOC_TYPE_NAME || ' ' || DH.DOC_NUM || ', ' || formatdate(DH.DOC_DATE,'D;dd/mm/yyyy'),
           DH.IS_ANUL, B.ID_SERVICE, a.ID_HOTEL
    from   OWNER_BILL_ROW$PMS B
           join OWNER_BILL$PMS BH on BH.ID_OWNER_BILL = B.ID_OWNER_BILL
           join OWNER$PMS O on O.ID_OWNER = BH.ID_OWNER
           join DOC_LINE_POST_VALUES PV on B.ID_ACCOUNT_POST = PV.ID_ACCOUNT_POST
           join DOC_LINE DL on PV.ID_DOC_LINE = DL.ID_DOC_LINE
           join DOC_HEAD DH on DH.ID_DOC = DL.ID_DOC_HEAD
           join ACCOUNT A on A.ID_ACCOUNT = dh.ID_ACCOUNT
           join DOC_TYPE DT on DT.ID_DOC_TYPE = DH.ID_DOC_TYPE
    where  B.ID_OWNER_BILL = :ID_BILL
           and B.ID_ACCOUNT_POST is not null
    into   :id_doc, :doc_sub_type, :CURR_POST, :INV_DESCRIPTION, :IS_ANUL, :ID_SERVICE, :id_hotel
  do begin
    select case when SGV.SETTING_VALUE = 'AS_POSITIVE' and :DOC_SUB_TYPE = 2 then -1 else 1 end
    from   SETTING_GET_VALUE('VIEW_STORNO_SUMS_IN_DOCUMENTS', :id_hotel) SGV
    into   :sign_;

    for
      select
        DL.LINE_NAME,
        DL.ROOM_NAME,
        DL.DATE_POST,
        DL.LINE_VALUE as line_sum
      from
        DOC_LINES_SUSPEND (:ID_DOC, :sign_, '', 'details', 'acc', 'as_doc', 0) DL
      order by
        DL.IS_FOR_PAY asc, DL.DATE_POST, DL.IS_BASE desc, DL.ROOM_NAME, DL.LINE_NAME asc
      into :LINE_DESC,
           :ROOM_NAME,
           :DATE_POST,
           :OUTGO_VALUE
    do begin
      suspend;
    end
  end

end
^

/* Restore proc. body: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER,
IS_MANUAL_TRANSFER TYPE OF TLOGICAL = 1)
 AS
declare variable id_current_account integer;
  declare variable id_service integer;
  declare variable is_anul integer;
  declare variable id_tariff integer;
  declare variable qty_post numeric(15,2);
  declare variable qty_free numeric(15,2);
  declare variable price_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable id_room integer;
  declare variable id_base_doc integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  if ((:AP_DBKEY is null) or (:id_target_account is null) or (:id_target_account < 0)) then
     exception POSTING_TRANSFER_EXCEPTION '-31';

  select AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST, AP.QTY_FREE,
         AP.PRICE_ORIG, AP.CURR_ORIG, AP.RATE_ORIG, ap.from_date, ap.to_date,
         AP.IS_ANUL, AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_BASE_DOC, A.ID_HOTEL
  from   ACCOUNT_POST AP
         left join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :id_service, :id_tariff, :id_room, :qty_post, :qty_free,
         :price_orig, :curr_orig, :rate_orig, :from_date, :to_date,
         :is_anul, :id_account_post, :id_current_account, :id_base_doc, :id_hotel;

  if (:id_current_account = :id_target_account) then EXIT;

  if (:is_anul = 1 ) then exception POSTING_TRANSFER_EXCEPTION '-33';

  if (:id_base_doc is not null) then exception POSTING_TRANSFER_EXCEPTION '-32';

  if (not exists(select A.ID_ACCOUNT
                 from   ACCOUNT A
                 where  A.ID_ACCOUNT = :ID_TARGET_ACCOUNT
                        and A.ID_HOTEL = :id_hotel)) then exception POSTING_TRANSFER_EXCEPTION '-376';

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
                    :id_tariff, :id_room, :qty_post, :qty_free, :price_orig, :curr_orig,
                    :rate_orig, 'TRANSFER_POSTING', null, :from_date, :to_date,
                    iif(:IS_MANUAL_TRANSFER is distinct from 1, 1, 0), :id_target_account)
  returning_values  :no_use, :no_use, :no_use;

  insert into ACCOUNT_TRANSFER_HISTORY(ID_ACCOUNT_POST, FROM_ID_ACCOUNT, TO_ID_ACCOUNT)
  values (:id_account_post, :id_current_account, :id_target_account);
end
^

/* Restore proc. body: ACCOUNT_POSTING_UPDATE */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable in_db_key char(8);
begin
  /* GUI facade for manual update */
  select AP.ID_ACCOUNT, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date)
  returning_values  (:new_qty_post, :new_price_post, :new_ac);

  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    action_text = f_character(29) || :action_text
                  || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                  || f_character(28) || :log_old_value
                  || f_character(28) || :log_new_value
                  || f_character(28) || replace(:IN_CHANGED_TEXT, 'MANUAL', '');
    execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
  end

end
^

/* Restore proc. body: AVAILABILITY_OCCUP_SMALL$WBE */
ALTER PROCEDURE AVAILABILITY_OCCUP_SMALL$WBE(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER,
QUERY_ID INTEGER,
ROOMS INTEGER,
RATES VARCHAR(255) = '',
ROOMTYPES VARCHAR(255) = '')
 AS
declare variable id_channel integer;
declare variable error_check integer;
declare variable room_type_id integer;
declare variable availability_date date;
declare variable available_rooms integer;
declare variable is_available integer;
begin
  /*Leave data in table availability_room_type$wbe */
  /*In WBE database, look directly to WBE channel settings */

  /*empty WBE specific table*/
  delete from AVAILABILITY_ROOM_TYPE$WBE
  where QUERY_ID = :QUERY_ID;

  select max(c.id_channel), count(c.id_channel)
  from   CHANNEL c
  where  c.name = 'WBE'
  into   :id_channel, :error_check;
  if (not (:error_check = 1)) then  exception WRONG_VALUE 'Missing channel WBE or dublicated definition!';

  /*Fill WBE specific table*/
  /*polzwa se MAX, za6toto ako pone edna tarifa e pozwolena, zna4i ima stai*/
  /*!!!!! PROBLEM - channel management-a moje da puska stai i tarifi, no towa wse o6te ne ozna4awa 4e et mogat da minat prez tarifata i da polu4at cena*/
  for
    select  PA.id_room_type, PA.for_date,  max(PA.available_rooms),  max(PA.product_status)
    from    PRODUCT_AVAILABILITY$AVL(:id_channel, :id_hotel, :from_date, :to_date, :rates, :roomtypes) PA
    group by 1, 2
    into    :room_type_id, :availability_date, :available_rooms, :is_available
  do begin
    if ((:rooms > :available_rooms) or (:is_available = 0)) then begin
      available_rooms = 0;
      is_available = 0;
    end else begin
      is_available = 1;
    end

    insert into AVAILABILITY_ROOM_TYPE$WBE (room_type_id, availability_date, available_rooms, is_available, query_id)
    values (:room_type_id, :availability_date, :available_rooms, :is_available, :query_id);
  end

end
^

/* Restore proc. body: AVAILABILITY_OCCUPANCY$CHM */
ALTER PROCEDURE AVAILABILITY_OCCUPANCY$CHM(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(ID_ROOM_TYPE INTEGER,
FOR_DATE DATE,
ROOMS_OCCUPIED INTEGER,
ROOMS_AVAILABLE INTEGER)
 AS
declare variable release_dates smallint;
  declare variable overbook smallint;
  declare variable res_confirmed smallint;
  declare variable res_notconfirmed smallint;
  declare variable res_waiting smallint;
  declare variable booking_positions smallint;
  declare variable contingent smallint;
begin
  select coalesce(pao.release_dates, 0), coalesce(pao.overbook, 0),
         coalesce(pao.res_confirmed, 1), coalesce(pao.res_notconfirmed, 1), coalesce(pao.res_waiting, 0),
         coalesce(pao.booking_positions, 0), coalesce(pao.contingent, 0)
  from   PRODUCT_AVAILABILITY_OPTIONS pao
  where  pao.ID_HOTEL = :ID_HOTEL
  into   :release_dates, :overbook, :res_confirmed, :res_notconfirmed, :res_waiting, :booking_positions, :contingent;

  execute procedure AVAILABILITY_OCCUP_PREPARE$AVL (
          :FROM_DATE,
          :TO_DATE,
          0,
          :RELEASE_DATES,
          :OVERBOOK,
          :RES_CONFIRMED,
          :RES_NOTCONFIRMED,
          :RES_WAITING,
          :BOOKING_POSITIONS,
          :CONTINGENT,
          :ID_HOTEL);

  for
    select SO.ID_ROOM_TYPE,
           SO.FOR_DATE,
           sum(so.OCCUPIED),
           sum(so.AVAILABLE)
    from   SMART_OCCUP$TMP SO
    group by 1, 2
    into   :ID_ROOM_TYPE, :FOR_DATE, :ROOMS_OCCUPIED, :ROOMS_AVAILABLE
  do begin
    suspend;
  end
end
^

/* Restore proc. body: CHANNEL_GET_WHOLEALLOTMENT$CHM */
ALTER PROCEDURE CHANNEL_GET_WHOLEALLOTMENT$CHM(ID_CHANNEL INTEGER)
 RETURNS(ID_ROOM_TYPE INTEGER,
FOR_DATE DATE,
IS_ACTIVE INTEGER,
AUTO_FREE_ROOMS INTEGER,
ROOM_COUNT INTEGER,
FREE_ROOMS INTEGER,
STATUS INTEGER)
 AS
declare variable date_from date;
  declare variable date_to date;
  declare variable channel_capacity integer;
  declare variable to_sell integer;
begin
  date_from = null;
  select min(FOR_DATE), max(FOR_DATE)
  from CHANNEL_ALLOTMENT
  where ID_CHANNEL = :id_channel
  into :date_from, :date_to;
  if (date_from is null) then exit;

  for select distinct ID_ROOM_TYPE
      from CHANNEL_ALLOTMENT
      where ID_CHANNEL = :id_channel
        and FOR_DATE between :date_from and :date_to
      into :id_room_type
  do begin
    for select RTR.FOR_DATE,
               CA.STATUS,
               CA.AUTO_FREE_ROOMS, CA.ROOM_COUNT, RTR.AVAILABLE as FREE_ROOMS
        from ROOM_TYPE_GET_FREE$CHM(:date_from, :date_to, :id_room_type) RTR
             join CHANNEL_ALLOTMENT CA on CA.ID_ROOM_TYPE = :id_room_type
                                      and CA.ID_CHANNEL = :id_channel
                                      and CA.FOR_DATE = RTR.FOR_DATE
    into :for_date, :status,
         :auto_free_rooms, :channel_capacity, :free_rooms
    do begin
      if (:auto_free_rooms is not null) then
        if (coalesce(:free_rooms,0) >= :auto_free_rooms) then
          is_active = 1;
        else is_active = 0;
      else if (:status = 0) then
             is_active = 1;
           else is_active = 0;

      to_sell = coalesce(:free_rooms,0) - coalesce(:auto_free_rooms,0);
      if (to_sell < 0) then to_sell = 0;

      room_count = :to_sell;
      if (:channel_capacity is not null) then
        if (channel_capacity < room_count) then
          room_count = :channel_capacity;

      suspend;
    end
  end
end
^

/* Restore proc. body: CHANNEL_IDSGDS_AVAILABILITY$EXC */
ALTER PROCEDURE CHANNEL_IDSGDS_AVAILABILITY$EXC(CHANNEL_NAME VARCHAR(30),
ID_HOTEL INTEGER)
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_SIMPLE_RATE INTEGER,
ID_BOARD INTEGER,
ROOM_STATUS INTEGER,
RATE_STATUS INTEGER,
PRODUCT_STATUS INTEGER,
AVAILABLE_ROOMS INTEGER,
MIN_LOS INTEGER,
MAX_LOS INTEGER,
SINGLE_PRICE NUMERIC(15,4),
DOUBLE_PRICE NUMERIC(15,4),
GUEST3_PRICE NUMERIC(15,4),
GUEST4PLUS_PRICE NUMERIC(15,4),
CHILD1_W_ADULT1_PRICE NUMERIC(15,4),
CHILD1_W_ADULT2PLUS_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT1_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT2PLUS_PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3))
 AS
declare variable date_from date;
declare variable date_to date;
declare variable id_channel integer;
declare variable rate_found integer;
begin
  --product_status 0 - closed
  --product_status 1 - closed for arrival
  --product_status 2 - opened

  select min(CA.FOR_DATE), max(CA.FOR_DATE), min(C.ID_CHANNEL)
  from   CHANNEL_ALLOTMENT CA
         join CHANNEL C on C.ID_CHANNEL = CA.ID_CHANNEL
         join ROOM_TYPES RT on RT.ID_ROOM_TYPE = CA.ID_ROOM_TYPE
  where  C.NAME = :channel_name
         and CA.FOR_DATE >= current_date
         and RT.ID_HOTEL = :id_hotel
  into   :date_from, :date_to, :id_channel;
  if (:date_from is null) then exit;

  for
    select PA.FOR_DATE, PA.ID_ROOM_TYPE, PA.ID_TAR_HEAD,
           PA.ROOM_STATUS, PA.RATE_STATUS, PA.PRODUCT_STATUS,
           PA.AVAILABLE_ROOMS, PA.MIN_LOS, PA.MAX_LOS, T.CURR
    from   PRODUCT_AVAILABILITY$AVL(:id_channel, :id_hotel, :date_from, :date_to, '', '') PA
           left outer join TARIFA T on T.ID_TARIFA = PA.ID_TAR_HEAD
           left outer join TAR_SIMPLE TS on TS.ID_TAR_HEAD = PA.ID_TAR_HEAD
    where  ((PA.ID_TAR_HEAD is null) or (TS.ID_TAR_SIMPLE is not null))
    into   :for_date, :id_room_type, :id_simple_rate,
           :room_status, :rate_status, :product_status,
           :available_rooms, :min_los, :max_los, :price_currency
  do begin
    rate_found = 0;
    single_price = null;
    double_price = null;
    guest3_price = null;
    guest4plus_price = null;
    child1_w_adult1_price = null;
    child1_w_adult2plus_price = null;
    child2plus_w_adult1_price = null;
    child2plus_w_adult2plus_price = null;
    for
      select TSP.SINGLE_PRICE, TSP.DOUBLE_PRICE, TSP.GUEST3_PRICE, TSP.GUEST4PLUS_PRICE,
             TSP.CHILD1_W_ADULT1_PRICE, TSP.CHILD1_W_ADULT2PLUS_PRICE, TSP.CHILD2PLUS_W_ADULT1_PRICE, TSP.CHILD2PLUS_W_ADULT2PLUS_PRICE,
             TSP.ID_BOARD
      from   TAR_SIMPLE TS
             join TAR_SIMPLE_SEASON TSS on TS.ID_TAR_SIMPLE = TSS.ID_TAR_SIMPLE
             join TAR_SIMPLE_SEASON_PERIODS TSSP on TSS.ID_TAR_SIMPLE_SEASON = TSSP.ID_TAR_SIMPLE_SEASON
             join TAR_SIMPLE_PRICE TSP on TSSP.ID_TAR_SIMPLE_SEASON = TSP.ID_TAR_SIMPLE_SEASON
      where  TS.ID_TAR_HEAD = :id_simple_rate
             and :for_date between TSSP.FROM_DATE and TSSP.TO_DATE
             and TSP.ID_ROOM_TYPE = :id_room_type
             and ((tsp.IS_BASE_DAYS_PRICE = 0 and coalesce(tss.SPECIAL_DAYS_OF_WEEK, '') containing extract (weekday from cast(:for_date as date)))
                  or (tsp.IS_BASE_DAYS_PRICE = 1 and coalesce(tss.SPECIAL_DAYS_OF_WEEK, '') not containing extract (weekday from cast(:for_date as date))))
             -- and TSP.days_of_week containing extract (weekday from :for_date )
      into   :single_price, :double_price, :guest3_price, :guest4plus_price,
             :child1_w_adult1_price, :child1_w_adult2plus_price, :child2plus_w_adult1_price, :child2plus_w_adult2plus_price,
             :id_board
    do begin
      rate_found = 1;
      suspend;
    end

    if (:rate_found = 0) then begin
      rate_status = 0;
      product_status = 0;
      suspend;
    end
  end
end
^

/* Restore proc. body: CHANNEL_PRODUCT_AVAIL_REQ$INT */
ALTER PROCEDURE CHANNEL_PRODUCT_AVAIL_REQ$INT(ID_CHANNEL INTEGER,
ID_HOTEL INTEGER,
ARRIVAL DATE,
DEPARTURE DATE,
ROOMS INTEGER)
 RETURNS(ID_ROOM_TYPE INTEGER,
ID_TAR_HEAD INTEGER,
IS_PRODUCT_AVAIALABLE INTEGER,
ROOM_STATUS INTEGER,
RATE_STATUS INTEGER,
RATE_MIN_LOS INTEGER,
RATE_MAX_LOS INTEGER,
AVAILABLE_ROOMS INTEGER,
IS_PUBLIC SMALLINT)
 AS
declare variable los integer;
begin
    /*TODO Proc will check all room types in channel management and rates in rate restrictions and
           will return all available and nonavailable combinations (products). For each product :
       - is_product_avaialable = 0/1 - general decision for product - can or cannot be sold
       - room_status 0-closed, 2-open - can be used for extra info if product is closed
       - rate_status 0-closed, 1-closed for arrival, 2-open - can be used for extra info if rate is closed
       - rate_min_los and rate_max_los integer - null or > 0 - extra info*/


  los = :departure - :arrival;

  for select PA.ID_ROOM_TYPE, PA.ID_TAR_HEAD,
             min(PA.ROOM_STATUS),
             /*za wsi4ki dni oswen arriaval-a close for arrival = open*/
             min( iif((pa.for_date <> :arrival) and (PA.RATE_STATUS = 1), 2, PA.RATE_STATUS)),
             /*min i max los se gledat samo na datata na pristigane*/
             max( iif((pa.for_date = :arrival), PA.MIN_LOS , null)),
             max( iif((pa.for_date = :arrival), PA.MAX_LOS , null)),
             min(PA.AVAILABLE_ROOMS),
             min(pa.is_public)
  from PRODUCT_AVAILABILITY$AVL(:id_channel, :id_hotel, :arrival, :departure-1, '', '') PA
  where PA.ID_TAR_HEAD is not null
  group by 1, 2
  /*ako kanala ne warne wsi4ki dati ot prestoia - zna4i producta niama definicia tam i ne se predlaga waob6te*/
  having count (pa.for_date) = :los
  into :id_room_type, :id_tar_head,
        :room_status,
        :rate_status,
        :rate_min_los,
        :rate_max_los,
        :available_rooms,
        :is_public
  do begin
    is_product_avaialable = 0;
    if (
        (:available_rooms >= :rooms)
        and (:room_status = 2)
        and (:rate_status = 2)
        and ((:rate_min_los is null) or (:los >= :rate_min_los)  )
        and ((:rate_max_los is null) or (:los <= :rate_max_los)  )
        )
    then is_product_avaialable = 1;
    suspend;
  end
end
^

/* Restore proc. body: CREATE_BOOKING$WBE */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
declare variable rate varchar(50);
declare variable room_type varchar(20);
declare variable arrival date;
declare variable departure date;
declare variable adults integer;
declare variable children integer;
declare variable profile_name varchar(100);
declare variable aranger_name varchar(100);
declare variable guest_profile_uuid varchar(40);
declare variable aranger_profile_uuid varchar(40);
declare variable hotel_name varchar(50);
declare variable wbe_session_id bigint;
declare variable main_guest_profile_id integer;
declare variable board varchar(50);
declare variable hotel_id integer;
declare variable guarantee_policy_name varchar(50);
declare variable guarantee_deposit_percent numeric(15,4);
declare variable guarantee_deposit_nights integer;
declare variable guarantee_due_days_bef_arrival integer;
declare variable guarantee_due_days_after_create integer;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable profile_type varchar(20);
declare variable profile_import_time timestamp;
declare variable b_count integer;
declare variable age integer;
declare variable is_child smallint;
declare variable guest_id integer;
declare variable special_treatment varchar(250);
declare variable maintenance varchar(30);
declare variable routing varchar(20);
declare variable arranger_paymeny_type varchar(20);
declare variable market_segment varchar(30);
declare variable market_source varchar(30);
declare variable market_channel varchar(30);
declare variable market_hear_reason varchar(30);
declare variable market_come_reason varchar(30);
declare variable first_food varchar(30);
declare variable bnote varchar(2000);
begin
  -- get wbe product selection
  select  PA.rate_name,PA.room_name, AQ.first_date, AQ.first_date+AQ.day_count,
          PS.adults, PS.children, PS.person_name, H.hotel_name, H.id_hotel,
          WS.id, PA.board_name, GP.name, GP.deposit_totalsum_part, GP.deposit_nights_count, GP.due_days_before_arrival, GP.due_days_after_create,
          PS.bnote
   from   PRODUCT_SELECTION$WBE PS
          join WBE_SESSION$WBE WS on WS.id = PS.wbe_session_id
          join PRODUCT_AVAILABILITY$WBE PA on pa.id = PS.product_availability_id
          join AVAILABILITY_QUERY$WBE AQ on aq.id = WS.product_query_id
          join HOTEL H on H.id_hotel = WS.hotel_id
          join GUARANTEE_POLICY GP on GP.id_guarantee_policy = PS.guarantee_policy_id
   where  PS.id = :product_selection_id
   into   :rate, :room_type, :arrival, :departure,
          :adults,  :children, :profile_name, :hotel_name, :hotel_id,
          :wbe_session_id, :board, :guarantee_policy_name,
          :guarantee_deposit_percent, :guarantee_deposit_nights,
          :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create,
          :bnote;

  select PA.uuid , PA.profile_name, PA.profile_type
  from   PROFILE PA
  where  PA.id_profile = :aranger_profile_id
  into   :aranger_profile_uuid,:aranger_name,  :profile_type;

  if (:aranger_name = :profile_name and :profile_type = 'PERSON') then begin
    -- aranger is main guest
    select count(*)
    from   PRODUCT_SELECTION$WBE PSC
    where  PSC.wbe_session_id = :wbe_session_id
    into   :b_count;
       -- only if single reservation bugfix 2228
    if (1 = :b_count) then begin
     guest_profile_uuid =  aranger_profile_uuid;
     aranger_profile_uuid = null;
    end
  end else begin
    -- create profile for main guest
    execute procedure IMPORT_PERSON_PROFILE$EXC(
      uuid_create(),:profile_name,null,null,null,null,null,null,null,null,null,null, null,
      null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
      null,null,null,null,null, null, null)
    returning_values :main_guest_profile_id, :profile_import_time;

    select P.uuid
    from   PROFILE P
    where  P.id_profile = :main_guest_profile_id
    into   :guest_profile_uuid;
  end

    -- apply default map + forced arranger
    special_treatment = null;
    maintenance = null;
    routing = null;
    arranger_paymeny_type = null;
    market_segment = null;
    market_source = null;
    market_channel = null;
    market_hear_reason = null;
    market_come_reason = null;


  select hc.special_treatment, hk.plan_name, hc.routing,
         pt.payment_type, ms.segment_name, sc.description, cc.description,
         hr.description, cr.description, hc.first_food
  from   HOTEL_PRODUCT_CFG$WBE hc
         left join HK_PLAN hk on hk.id_plan = hc.id_hk_plan
         left join PAYMENT_TYPE pt on pt.id_payment_type = hc.arranger_id_payment_type
         left join NOM_MARKET_SEGMENTS ms on ms.id_nom_market_segment = hc.id_m_segment
         left join NOM_SOURCE_CODES sc on sc.id_nom_source_code = hc.id_m_source
         left join NOM_CHANNEL_CODES cc on cc.id_nom_channel_code = hc.id_m_channel
         left join NOM_HEAR_REASONS hr on hr.id_nom_hear_reason = hc.id_m_hear_reason
         left join NOM_COME_REASONS cr on cr.id_nom_come_reason = hc.id_m_come_reason
  where  hc.hotel_id = :hotel_id
  into   :special_treatment,:maintenance,:routing,:arranger_paymeny_type,
         :market_segment,:market_source,:market_channel,:market_hear_reason,:market_come_reason,:first_food;
  -- create reseravation
  execute procedure IMPORT_BOOKING$EXC(
     :hotel_name, :number, null, null, 0,
     :arrival, null, :departure, null, null, null, null, null, :room_type, :board, null,
     :special_treatment, :maintenance, :routing, :rate, null, null, null, null, :arranger_paymeny_type, null, null, null, null,
     :market_segment, :market_source,:market_channel, :market_hear_reason, :market_come_reason,
     :bnote, null, :first_food, :adults, :children, :aranger_profile_uuid, null, :guest_profile_uuid,
     0, 0, null, :guarantee_policy_name, null, :guarantee_deposit_percent, :guarantee_deposit_nights,
     :guarantee_due_days_bef_arrival,  :guarantee_due_days_after_create, null, null, null, null,  null, null, null, null, null, null, null, null)
  returning_values
     :hotel_id, :booking_id, :err_code, err_text;
  if (0 <> :err_code) then exception WRONG_VALUE ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');

  -- import guests
  for
    select psg.guest_name, psg.is_child, psg.age
    from   PRODUCT_SELECTION_GUESTS$WBE psg
    where  psg.product_selection_id = :product_selection_id
    into   :profile_name,:is_child,:age
  do begin
    execute procedure IMPORT_GUEST$EXC(:booking_id, null, null, :profile_name, :is_child, :age, null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null)
    returning_values :guest_id, :err_code,:err_text;
    if (0 <> :err_code) then exception WRONG_VALUE ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');
  end
  ----------------

  select RD.number_2
  from   RESERV_DETAIL RD
  where  RD.id_reserv_detail = :booking_id
  into   :number_2;

  update PRODUCT_SELECTION$WBE uPS
  set    uPS.booking_id = :booking_id, uPS.selection_id = :number_2
  where  uPS.id = :product_selection_id;
end
^

/* Restore proc. body: DEPOSIT_REFUND$DOC */
ALTER PROCEDURE DEPOSIT_REFUND$DOC(ID_DEPOSIT INTEGER,
REFUND_AMOUNT NUMERIC(15,4),
REFUND_CURRENCY VARCHAR(3),
ID_PAY_DOC_TYPE INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_REFUND_PAYMENT INTEGER,
ID_STORNO_DOC INTEGER,
WARN_CODE INTEGER)
 AS
declare variable no_use varchar(2000);
  declare variable id_account integer;
  declare variable avail_value numeric(15,4);
  declare variable id_doc_head integer;
  declare variable pay_currency varchar(3);
  declare variable pay_rate numeric(15,6);
  declare variable sys_date date;
  declare variable round_to numeric(15,4);
  declare variable p_dbkey char(8);
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable id_account_payment integer;
  declare variable id_doc_type integer;
  declare variable account_curr varchar(3);
  declare variable account_rate numeric(15,6);
  declare variable id_reserv_detail integer;
  declare variable is_posting_stopped integer;
  declare variable firm_data type of tnote_blob;
begin
  WARN_CODE = null;
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_REFUND');

  select D.ID_ACCOUNT, DH.ID_DOC, dh.ID_DOC_TYPE, c.ROUND_TO, d.ID_RESERV_DETAIL,
         D.AVAIL_VALUE, D.PAY_CURRENCY, D.PAY_RATE, A.ID_HOTEL, A.ACCOUNT_CURR
  from   DEPOSIT_AVAILABLE D
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join CURRS C on c.CURR = d.PAY_CURRENCY
         left outer join DOC_HEAD DH on DH.ID_DOC = D.ID_DOC_HEAD
                                        and DH.IS_STORNED = 0
                                        and DH.IS_ANUL = 0
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_account, :id_doc_head, :id_doc_type, :round_to, :id_reserv_detail,
         :avail_value, :pay_currency, :pay_rate, :id_hotel, :account_curr;

  if (:pay_currency is distinct from :refund_currency) then exception PAYMENT_EXCEPTION 'Currency mismatch!';

  if (round_f(:avail_value - :REFUND_AMOUNT, :round_to) < 0) then exception PAYMENT_EXCEPTION '-305';
  --'Issued value is more than available deposit amount.';

  select r.IS_POSTING_STOPPED
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :is_posting_stopped;

  if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';

  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET(:id_hotel) SD
  into   :sys_date;

  select first 1 ap.ACC_RATE
  from   ACCOUNT_PAYMENTS ap
  where  ap.ID_DEPOSIT = :ID_DEPOSIT
  order by ap.ID_ACCOUNT_PAYMENT asc
  into   :account_rate;

  execute procedure PAYMENT_CREATE$INT (:ID_PAY_DOC_TYPE, :ID_ACCOUNT, :SYS_DATE,
          -:REFUND_AMOUNT, :PAY_CURRENCY, :PAY_RATE, :account_curr, :account_rate, :DESCRIPTION)
  returning_values  (:id_refund_payment, :id_account_payment, :no_use);

  insert into DEPOSIT_REFUND (ID_DEPOSIT, ID_PAYMENT_HEAD, DESCRIPTION)
  values (:ID_DEPOSIT, :ID_REFUND_PAYMENT, :DESCRIPTION);

  update ACCOUNT_PAYMENTS AP
  set    AP.ID_DEPOSIT = :ID_DEPOSIT
  where  ap.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT;

  if (:ID_DOC_HEAD is not null) then begin
    execute procedure DOC_TYPE_EVALUATE$INT (:id_doc_type, :id_hotel, 0, :ID_REFUND_PAYMENT);

    execute procedure DOCUMENT_ADVANCE_STORNO$INT (:ID_DEPOSIT, :REFUND_AMOUNT, :DESCRIPTION)
    returning_values  (:ID_STORNO_DOC, :WARN_CODE);

    execute procedure DOCUMENT_ATTACH_PAYMENT$INT (:ID_STORNO_DOC, :id_account_payment, :pay_rate, null)
    returning_values :no_use;
     
    update  PAYMENT_HEAD P
    set     P.ID_DOC_HEAD = :ID_STORNO_DOC
    where   P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT;

    execute procedure DOCUMENT_VALIDATE$DOC (:ID_STORNO_DOC)
    returning_values (:firm_data, :no_use, :no_use);
  end else begin
    select P.RDB$DB_KEY
    from   PAYMENT_HEAD P
    where  P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT
    into   :P_DBKEY;
     
    execute procedure PAYMENT_SET_NUMBER$INT (:P_DBKEY);
  end

  action_text = F_CHARACTER(29) || :REFUND_AMOUNT || ' ' || :PAY_CURRENCY;
  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'REFUND', :ACTION_TEXT);
end
^

/* Restore proc. body: EAI_EXT_POST_TO_MH_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  if (:CODE_TYPE = 'EXT_CODE') then begin
    execute procedure EAI_MAP_SERVICE(:SERVICE_CODE, :SERVICE_CODE, 'UNKNOWN', :id_hotel)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_SERVICE;
    if (:ERR_CODE < 0) then exit;
  end else begin
    select S.ID_SERVICE
    from   SERVICES S
    where  S.ID_SERVICE = :SERVICE_CODE
           and s.ID_HOTEL = :ID_HOTEL
    into   :ID_SERVICE;
    if (:ID_SERVICE is null) then begin
      ERR_CODE = -85;   /* Wrong value! */
      exit;
    end
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:ID_ACCOUNT_POST, :SERVICE_CODE, null, null);

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Restore proc. body: EAI_EXT_SERVICE_POST */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable max_id_service integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_ROOM  = null;
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  select min(S.ID_SERVICE) as id_service, max(s.id_service) as max_id_service
  from   SERVICES S
  where  S.EXT_CODE = :SERVICE_EXT_CODE
         and s.IS_BASE = 0
         and s.IS_DELETED = 0
  into   :ID_SERVICE, :max_id_service;
  if (:ID_SERVICE is null) then begin
      ERR_CODE = -388;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end else if (:ID_SERVICE <> :max_id_service) then begin
      ERR_CODE = -389;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_EXT_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:ID_ACCOUNT_POST, :SERVICE_EXT_CODE, null, null);

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Restore proc. body: EAI_POS_POSTING_ADD$P2E */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
declare variable id_service integer;
  declare variable my_post_text varchar(255);
  declare variable my_resource_text varchar(255);
  declare variable nation_curr varchar(3);
  declare variable post_short_code varchar(10);
  declare variable id_hotel integer;
  declare variable id_account_post integer;
begin
  /* in_on_guest = 0 (account), 1 (guest), -1 (ew)
  */
  if (:IN_ON_GUEST = 1) then begin
    select rd.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :IN_ID_GUEST
    into   :id_hotel;
  end else begin
    select a.ID_HOTEL
    from   account a
    where  a.ID_ACCOUNT = :in_id_account
    into   :id_hotel;
  end

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :nation_curr;

  if ('END_WORK' = :in_smetka_num) then begin
    post_short_code='POS_EW';
  end else begin
    post_short_code='POS';
  end

  /* FIND SERVICE */
  execute procedure EAI_MAP_SERVICE(:in_service_tag, :in_service_name, 'POS', :id_hotel)
  returning_values  :err_code, :err_text, :id_service;
  if (:err_code < 0) then exit;

  my_post_text = 'date:'|| formatdate(:in_date_smetka, 'D;dd.mm.yyyy') ||
                 ' num:'|| :in_smetka_num ||
                 ' obj:'|| :in_obj_name ||
                 ' tbl:'|| :in_table ||
                 ' site:'|| :in_site;

  my_resource_text = 'POS_ID_SMETKA:'||:in_id_smetka;
  my_post_text = substring(:my_post_text from 1 for 100);
  my_resource_text = substring(:my_resource_text from 1 for 49);

  if (:in_on_guest = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:in_id_guest, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code, '')
    returning_values  :err_code, :err_text, :out_id_account, :id_account_post;
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:in_id_account, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code)
    returning_values  :err_code, :err_text, :id_account_post;
    out_id_account = :in_id_account;
  end
  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:id_account_post, :post_short_code, :IN_POS_USER, :IN_DATETIME);
end
^

/* Restore proc. body: EAI_TELECOUNT_TRANSFER */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* Restore proc. body: PHONECALL_POST$TC */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Restore proc. body: PHONECALLS_POST_TO_ACCOUNT$TC */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* Restore proc. body: PMS_IMPORT */
ALTER PROCEDURE PMS_IMPORT(ID_EXPORT_HEAD INTEGER)
 AS
begin

  execute procedure PMS_IMPORT$INT(:ID_EXPORT_HEAD);

end
^

/* Restore proc. body: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_OWNER TYPE OF ID,
POST_DATE TYPE OF TDATE,
CURR_ORIG TYPE OF TCURRENCY,
VALUE_ORIG TYPE OF TPRICE,
POST_ON_PMS_ACCOUNT TYPE OF TLOGICAL,
IS_OWNER_INCOME TYPE OF TLOGICAL,
ID_ROOM TYPE OF ID_REF = null)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  if (:POST_ON_PMS_ACCOUNT = 1) then begin
    execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account, :id_owner,
            :CURR_ORIG, :VALUE_ORIG, :id_service, :is_owner_income, :POST_DATE)
    returning_values  (:new_id_account_post);
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :ID_SERVICE, 1, 0, 1,
            :VALUE_ORIG, :CURR_ORIG, current_date, current_date,
            '', '', :POST_DATE, 'PMS', :ID_ROOM)
    returning_values  :err_code, :err_text, :new_id_account_post;
    if (:err_code <> 0) then exception PMS_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

    insert into PMS_EVENT_POST (ID_PMS_EVENT, ID_ACCOUNT_POST, ID_OWNER, LINE_STATUS)
    values (:ID_PMS_EVENT, :NEW_ID_ACCOUNT_POST, :ID_OWNER, 11);
  end
end
^

/* Restore proc. body: POST_SERVICE_FINALIZE$POST */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
  declare variable id_acc_post integer;
  declare variable id_service integer;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable date_post date;
  declare variable price_post numeric(15,4);
  declare variable qty_post numeric(15,2);
  declare variable post_text varchar(100);
  declare variable curr_post varchar(3);
  declare variable id_phonecall integer;
  declare variable p_dbkey char(8);
begin

  if (:OPERATION = 'clear') then begin
    delete from TMP_SERVICE_POST T
    where  T.ID_SEQUENCE = :ID_SEQUENCE;

  end else if (:OPERATION = 'store') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);

    for
      select TS.RDB$DB_KEY, TS.ID_SERVICE, TS.ID_ACCOUNT, TS.ID_GUEST, TS.DATE_POST,
             TS.PRICE_POST, TS.QTY_POST, TS.CURR_POST, TS.POST_TEXT, TS.ID_PHONECALL
      from   TMP_SERVICE_POST TS
      where  TS.ID_SEQUENCE = :ID_SEQUENCE
      into   :p_dbkey, :id_service, :id_account, :id_guest, :date_post,
             :price_post, :qty_post, :curr_post, :post_text, :id_phonecall
    do begin
      id_acc_post = null;
      if (:id_guest is not null) then begin
        execute procedure POST_SERVICE_ON_GUEST$INT (:id_guest, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :CURR_POST,
                :date_post, :date_post, :post_text, '', :date_post, '', '')
        returning_values  (:err_code, :err_text, :no_use, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end else begin
        execute procedure POST_SERVICE_ON_ACCOUNT$INT (:id_account, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :curr_post, :date_post, :date_post, :post_text,
                '', :date_post, '')
        returning_values  (:err_code, :err_text, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end

      update TMP_SERVICE_POST
      set ID_ACCOUNT_POST = :id_acc_post
      where RDB$DB_KEY = :p_dbkey;

      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :DOC_SELECTED,
             AP.SHORT_CODE = case
                               when :id_phonecall is not null then 'TELECOUNT'
                               else null
                             end
      where  AP.ID_ACCOUNT_POST = :id_acc_post;

      if (:id_phonecall is not null) then begin
        update PHONECALLS P
        set    P.ID_ACCOUNT_POST = :id_acc_post
        where  P.ID_PHONECALL = :id_phonecall;
      end
    end
  end
end
^

/* Restore proc. body: RES_TAR_CALC_FINALIZE$INT */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(ID_TAR_CALC INTEGER,
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
declare variable old_room_price numeric(15,4);
  declare variable old_room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
  declare variable reserv_posting_disabled smallint;
  declare variable postings_disabled smallint;
  declare variable warn_code integer;
  declare variable action_text varchar(255);
begin
  --  Razpiswa cenata na staia, kakto i price_detailite.

  execute procedure TAR_CALC_EVAL_ALL$INT(:ID_TAR_CALC)
  returning_values  :ERR_CODE, :ERR_TEXT;

  if (:ERR_CODE = 0) then execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

  select iif(si.INFO_VALUE = '1', 1, null)
  from   SYSTEM_INFO_GET('RESERV_POSTINGS_DISABLED') si
  into   :postings_disabled;

  for
    select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, coalesce(:postings_disabled, rd.IS_POSTING_STOPPED),
           coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
           coalesce(max((select first 1 AP.IS_BASE
                         from   GUEST G
                                join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                         where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (it`s possible)
    from   TAR_CALC_INPUT$TMP TI
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
           join TARIFA t on t.ID_TARIFA = rd.ID_RATE
    where  ti.ID_TAR_CALC = :ID_TAR_CALC
    group by 1, 2, 3, 4, 5, 6
    into   :id_reserv_detail, :check_status, :is_posting_stopped,
           :room_currency, :id_hotel, :is_anul, :has_postings
  do begin
    reserv_posting_disabled = iif(:is_posting_stopped = 1 and :has_postings = 0, 1, 0);

    if (:ERR_CODE <> 0) then begin
      -- price calculation error handling  !!!!!
      if (:reserv_posting_disabled = 1) then begin
        -- set price to null, posting is disabled
        update RESERV_DETAIL RD
        set    RD.ROOM_PRICE = null,
               RD.ROOM_CURRENCY = null,
               RD.ROOM_PRICE_DETAILS = null,
               RD.LAST_ID_TAR_CALC = null
        where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
      end else begin
        -- exit on error in price calculation - cannot make valid posts
        EXIT;
      end
    end else begin
      room_price = 0;
      room_price_details = '';
    
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);
  
      if (:reserv_posting_disabled = 0 and ((coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1))) then begin
        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);
      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;
  
        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end
  
      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc,
             rd.ROOM_PRICE_LAST$INT = null,
             rd.ROOM_CURRENCY_LAST$INT = null
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail
      returning old.ROOM_PRICE_LAST$INT, old.ROOM_CURRENCY_LAST$INT
      into :old_room_price, :old_room_currency;

      if ((:old_room_price is distinct from :room_price)
          or (:old_room_currency is distinct from :room_currency) ) then
      begin
        action_text = f_character(29) || formatfloat(:old_room_price, 'F;0.00') || ' ' || coalesce(:old_room_currency, '') || f_character(28) || formatfloat(:room_price, 'F;0.00') || ' ' || coalesce(:room_currency, '');
        execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_PRICE_RECALC', :action_text);
      end
    end
  end

  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;

  if (:ERR_CODE <> 0) then begin
    execute procedure SYSTEM_WARNING_ADD(:ERR_CODE, :ERR_TEXT)
    returning_values :warn_code;
    ERR_CODE = 0;
    ERR_TEXT='';
  end
end
^

/* Restore proc. body: SAFE_OCCUPANCY_MODIFY */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE TYPE OF ID,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable old_booking_number tres_number;
  declare variable id_resource_reservation id_ref;
  declare variable from_datetime tdatetime;
  declare variable action_text tdescription_long;
  declare variable old_occupant varchar(100);
  declare variable old_to_dt timestamp;
  declare variable id_reserv_detail integer;
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation;

  select rr.BOOKING_NUMBER, od.FROM_DATETIME,
         RR.OCCUPANT_NAME, od.TO_DATETIME, rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESERV_DETAIL rd on rd.NUMBER = rr.BOOKING_NUMBER and rd.IS_ANUL = 0
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :old_booking_number, :from_datetime,
         :old_occupant, :old_to_dt, :id_reserv_detail, :id_agent_profile;

  --if (:old_booking_number <> :BOOKING_NUMBER) then exception ASSERT 'Can not change booking number!';
  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  update SAFE_RESOURCE_RESERV rr
  set    rr.PRICE_DESCRIPTION = :price_description,
         rr.ID_RATE_PRICE_PROFILE = :id_agent_profile,
         rr.RATING_UNITS = :rating_units,
         rr.RATE_PRICE = :price,
         rr.RATE_CURR = :currency
  where  rr.ID_RESOURCE_RESERV = :id_resource_reservation;

  execute procedure RESOURCE_RESERVATION_MODIFY (:id_resource_reservation, :ID_SAFE, :from_datetime,
          :TO_DATETIME, :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :old_booking_number, 'mod')
  returning_values :id_resource_reservation, :no_use;

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail)
  returning_values (:DOC_SELECTED);

  /* Log changes */
  if ((:old_occupant <> :OCCUPANT_NAME) or (:old_to_dt <> :TO_DATETIME)) then begin
    action_text = f_character(29) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                  || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                  || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');
  
    execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_CHANGED', :action_text);
  end
end
^

/* Restore proc. body: SAFE_OCCUPANCY_NEW */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE TYPE OF ID,
FROM_DATETIME TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME,
BOOKING_NUMBER TYPE OF TRES_NUMBER,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
ID_RESOURCE_RESERVATION TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable action_text tdescription_long;
  declare variable id_reserv_detail integer;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, s.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  if (:id_resource_reservation is not null) then exception ASSERT '-1064'|| f_character(31) || f_character(29) || :safe_name;

  select rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESERV_DETAIL rd
  where  rd.NUMBER = :BOOKING_NUMBER
         and rd.IS_ANUL = 0
  into   :id_reserv_detail, :id_agent_profile;

  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  execute procedure  RESOURCE_RESERVATION_MODIFY (null, :ID_SAFE, :FROM_DATETIME, :TO_DATETIME,
          :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :BOOKING_NUMBER, 'add')
  returning_values (:id_resource_reservation, :no_use) ;

  insert into SAFE_RESOURCE_RESERV (ID_RESOURCE_RESERV, PRICE_DESCRIPTION, ID_RATE_PRICE_PROFILE,
         RATING_UNITS, RATE_PRICE, RATE_CURR)
  values (:id_resource_reservation, :price_description, :id_agent_profile,
         :rating_units, :price, :currency);

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail, :ID_EXTERNAL_CLIENT_ACCCOUNT)
  returning_values (:DOC_SELECTED);

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = 'CHECKED_IN'
  where  RR.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = :id_resource_reservation
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                || f_character(28) || coalesce(:BOOKING_NUMBER, '')
                || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUPIED', :action_text);
end
^

/* Restore proc. body: TAR_CALC_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
declare variable param_code varchar(40);
  declare variable id_param integer;
  declare variable param_value varchar(255);
  declare variable data_type  varchar(30);
  declare variable rate_list varchar(2000);
begin
  err_code = 0;
  param_values = '';

  if (coalesce(:rate_list_replace, '') = '') then rate_list = ',' || :id_rate || ',';
  else rate_list = :rate_list_replace;

  for
    select distinct TBP.PARAM_NAME
    from   SYSTEM_STRING_PARSER (:rate_list, ',') sp
           left join TAR_BO_PARAMS TBP on TBP.ID_TAR_HEAD = sp.ITEM
    where  (TBP.PARAM_TYPE <> 'DATE_DEPENDANT' and :for_date is null)
           or (TBP.PARAM_TYPE = 'DATE_DEPENDANT' and :for_date is not null)
    into   :param_code
  do begin
    if (:param_code is not null) then begin
      id_param = null;
      select TP.ID_TARIFA_PARAM, TP.DATA_TYPE
      from   TARIFA_PARAMS TP
      where  TP.PARAM_CODE = :param_code
             and tp.IS_USE = 1
      into   :id_param, :data_type;
  
      if (:id_param is null) then begin
        err_code = -202;
        execute procedure sys_dbg ('tar calc params err_code: ' || :err_code || F_CRLF() || 'PARAM_CODE = ' || :param_code);
        exit;
      end
  
      execute procedure TARIFA_GET_PARAM (:id_param, :for_date, :id_tar_input, :id_tar_calc)
      returning_values (:param_value);
  
      param_code = ':'||param_code;
  
      if ((:param_code is not null) and (:param_code is not null) and (:data_type is not null)) then
         param_values = :param_values||';'||:param_code||','||:data_type||','||:param_value;
    end
  end
end
^

/* Alter Procedure... */
/* Alter (ACC_STATEMENT_INVOICES_GET$PMS) */
ALTER PROCEDURE ACC_STATEMENT_INVOICES_GET$PMS(ID_BILL INTEGER)
 RETURNS(ID_DOC INTEGER,
ID_SERVICE INTEGER,
DATE_POST DATE,
ROOM_NAME VARCHAR(100),
LINE_DESC VARCHAR(100),
OUTGO_VALUE NUMERIC(15,4),
CURR_POST VARCHAR(3),
IS_ANUL SMALLINT,
INV_DESCRIPTION VARCHAR(100))
 AS
declare variable id_hotel integer;
  declare variable sign_ smallint;
  declare variable doc_sub_type smallint;
begin

  for
    select distinct DL.ID_DOC_HEAD, DH.DOC_SUB_TYPE, O.ID_CURRENCY,
           DT.DOC_TYPE_NAME || ' ' || DH.DOC_NUM || ', ' || formatdate(DH.DOC_DATE,'D;dd/mm/yyyy'),
           DH.IS_ANUL, B.ID_SERVICE, a.ID_HOTEL
    from   OWNER_BILL_ROW$PMS B
           join OWNER_BILL$PMS BH on BH.ID_OWNER_BILL = B.ID_OWNER_BILL
           join OWNER$PMS O on O.ID_OWNER = BH.ID_OWNER
           join DOC_LINE_POST_VALUES PV on B.ID_ACCOUNT_POST = PV.ID_ACCOUNT_POST
           join DOC_LINE DL on PV.ID_DOC_LINE = DL.ID_DOC_LINE
           join DOC_HEAD DH on DH.ID_DOC = DL.ID_DOC_HEAD
           join ACCOUNT A on A.ID_ACCOUNT = dh.ID_ACCOUNT
           join DOC_TYPE DT on DT.ID_DOC_TYPE = DH.ID_DOC_TYPE
    where  B.ID_OWNER_BILL = :ID_BILL
           and B.ID_ACCOUNT_POST is not null
    into   :id_doc, :doc_sub_type, :CURR_POST, :INV_DESCRIPTION, :IS_ANUL, :ID_SERVICE, :id_hotel
  do begin
    select case when SGV.SETTING_VALUE = 'AS_POSITIVE' and :DOC_SUB_TYPE = 2 then -1 else 1 end
    from   SETTING_GET_VALUE('VIEW_STORNO_SUMS_IN_DOCUMENTS', :id_hotel) SGV
    into   :sign_;

    for
      select
        DL.LINE_NAME,
        DL.ROOM_NAME,
        DL.DATE_POST,
        DL.LINE_VALUE as line_sum
      from
        DOC_LINES_SUSPEND (:ID_DOC, :sign_, '', 'details', 'acc', 'as_doc', 0) DL
      order by
        DL.IS_FOR_PAY asc, DL.DATE_POST, DL.IS_BASE desc, DL.ROOM_NAME, DL.LINE_NAME asc
      into :LINE_DESC,
           :ROOM_NAME,
           :DATE_POST,
           :OUTGO_VALUE
    do begin
      suspend;
    end
  end

end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POSTING_TRANSFER$ACC for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: GUEST_REROUTE_POSTINGS$INT for: ACCOUNT_POSTING_TRANSFER$INT */
ALTER PROCEDURE GUEST_REROUTE_POSTINGS$INT(ID_GUEST INTEGER,
ID_BASE_ACCOUNT INTEGER,
ID_EXTRA_ACCOUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (ACCOUNT_POSTING_TRANSFER$INT) */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$INT(AP_DBKEY CHAR(8),
ID_TARGET_ACCOUNT INTEGER,
IS_MANUAL_TRANSFER TYPE OF TLOGICAL = 1)
 AS
declare variable id_current_account integer;
  declare variable id_service integer;
  declare variable is_anul integer;
  declare variable id_tariff integer;
  declare variable qty_post numeric(15,2);
  declare variable qty_free numeric(15,2);
  declare variable price_orig numeric(15,4);
  declare variable curr_orig varchar(3);
  declare variable rate_orig numeric(15,6);
  declare variable id_room integer;
  declare variable id_base_doc integer;
  declare variable id_account_post integer;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
  declare variable from_date date;
  declare variable to_date date;
begin
  if ((:AP_DBKEY is null) or (:id_target_account is null) or (:id_target_account < 0)) then
     exception POSTING_TRANSFER_EXCEPTION '-31';

  select AP.ID_SERVICE, AP.ID_TARIFF, AP.ID_ROOM, AP.QTY_POST, AP.QTY_FREE,
         AP.PRICE_ORIG, AP.CURR_ORIG, AP.RATE_ORIG, ap.from_date, ap.to_date,
         AP.IS_ANUL, AP.ID_ACCOUNT_POST, AP.ID_ACCOUNT, AP.ID_BASE_DOC, A.ID_HOTEL
  from   ACCOUNT_POST AP
         left join ACCOUNT A on A.ID_ACCOUNT = AP.ID_ACCOUNT
  where  AP.RDB$DB_KEY = :AP_DBKEY
  into   :id_service, :id_tariff, :id_room, :qty_post, :qty_free,
         :price_orig, :curr_orig, :rate_orig, :from_date, :to_date,
         :is_anul, :id_account_post, :id_current_account, :id_base_doc, :id_hotel;

  if (:id_current_account = :id_target_account) then EXIT;

  if (:is_anul = 1 ) then exception POSTING_TRANSFER_EXCEPTION '-33';

  if (:id_base_doc is not null) then exception POSTING_TRANSFER_EXCEPTION '-32';

  if (not exists(select A.ID_ACCOUNT
                 from   ACCOUNT A
                 where  A.ID_ACCOUNT = :ID_TARGET_ACCOUNT
                        and A.ID_HOTEL = :id_hotel)) then exception POSTING_TRANSFER_EXCEPTION '-376';

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:ap_dbkey, :id_service,
                    :id_tariff, :id_room, :qty_post, :qty_free, :price_orig, :curr_orig,
                    :rate_orig, 'TRANSFER_POSTING', null, :from_date, :to_date,
                    iif(:IS_MANUAL_TRANSFER is distinct from 1, 1, 0), :id_target_account)
  returning_values  :no_use, :no_use, :no_use;

  insert into ACCOUNT_TRANSFER_HISTORY(ID_ACCOUNT_POST, FROM_ID_ACCOUNT, TO_ID_ACCOUNT)
  values (:id_account_post, :id_current_account, :id_target_account);
end
^

/* Alter (ACCOUNT_POSTING_UPDATE) */
ALTER PROCEDURE ACCOUNT_POSTING_UPDATE(IN_ID_ACCOUNT_POST INTEGER,
IN_ID_SERVICE INTEGER,
IN_ID_TARIFF INTEGER,
IN_ID_ROOM INTEGER,
IN_QTY_POST INTEGER,
IN_QTY_FREE INTEGER,
IN_PRICE NUMERIC(15,4),
IN_CURR VARCHAR(3),
IN_RATE NUMERIC(15,6),
IN_CHANGED_TEXT VARCHAR(40),
IN_SHORT_CODE VARCHAR(255))
 AS
declare variable date_post date;
  declare variable id_account integer;
  declare variable old_qty_post numeric(15,2);
  declare variable old_price_post double precision;
  declare variable old_id_service integer;
  declare variable old_curr_post varchar(3);
  declare variable new_qty_post numeric(15,2);
  declare variable new_price_post double precision;
  declare variable new_ac varchar(2);
  declare variable action_text varchar(255);
  declare variable log_old_value varchar(50);
  declare variable log_new_value varchar(50);
  declare variable round_to numeric(15,4);
  declare variable from_date date;
  declare variable to_date date;
  declare variable in_db_key char(8);
begin
  /* GUI facade for manual update */
  select AP.ID_ACCOUNT, AP.QTY_POST, AP.PRICE_POST,
         AP.DATE_POST, AP.ID_SERVICE, AP.CURR_POST, c.ROUND_TO, ap.FROM_DATE, ap.TO_DATE, AP.RDB$DB_KEY
  from   ACCOUNT_POST AP
         join CURRS C on c.CURR = ap.CURR_POST
  where  AP.ID_ACCOUNT_POST = :IN_ID_ACCOUNT_POST
  into   :id_account, :old_qty_post, :old_price_post,
         :date_post, :old_id_service, :old_curr_post, :round_to, :from_date, :to_date, :in_db_key;

  execute procedure ACCOUNT_POSTING_UPDATE$INT (:IN_DB_KEY, :IN_ID_SERVICE, :IN_ID_TARIFF,
          :IN_ID_ROOM, :IN_QTY_POST, :IN_QTY_FREE, :IN_PRICE, :IN_CURR, :IN_RATE,
          :IN_CHANGED_TEXT, :IN_SHORT_CODE, :from_date, :to_date)
  returning_values  (:new_qty_post, :new_price_post, :new_ac);

  if ( (round_f(:new_qty_post - :old_qty_post, :round_to) <> 0)
     or (round_f(:new_price_post - :old_price_post, :round_to) <> 0)) then
  begin
    select S.SERVICE_NAME
    from   SERVICES S
    where  S.ID_SERVICE = :old_id_service
    into   :action_text;

    log_old_value = formatfloat(:old_qty_post * :old_price_post, 'F;0.00') || ' ' || :old_curr_post;
    log_new_value = formatfloat(:new_qty_post * :new_price_post, 'F;0.00') || ' ' || :IN_CURR;
    action_text = f_character(29) || :action_text
                  || f_character(28) || FormatDate(:date_post, 'D;dd.mm.yyyy')
                  || f_character(28) || :log_old_value
                  || f_character(28) || :log_new_value
                  || f_character(28) || replace(:IN_CHANGED_TEXT, 'MANUAL', '');
    execute procedure SYSTEM_LOG_ADD('ACCOUNT', :id_account, 'POST_UPDATE', :action_text);
  end

end
^

/* empty dependent procedure body */
/* Clear: CREATE_SESSION_BOOKINGS$WBE for: AVAILABILITY_OCCUP_SMALL$WBE */
ALTER PROCEDURE CREATE_SESSION_BOOKINGS$WBE(WBE_SESSION_ID BIGINT,
ARANGER_ID INTEGER,
LANG_CODE VARCHAR(3))
 RETURNS(SELECTION_ID VARCHAR(20),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (AVAILABILITY_OCCUP_SMALL$WBE) */
ALTER PROCEDURE AVAILABILITY_OCCUP_SMALL$WBE(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER,
QUERY_ID INTEGER,
ROOMS INTEGER,
RATES VARCHAR(255) = '',
ROOMTYPES VARCHAR(255) = '')
 AS
declare variable id_channel integer;
declare variable error_check integer;
declare variable room_type_id integer;
declare variable availability_date date;
declare variable available_rooms integer;
declare variable is_available integer;
begin
  /*Leave data in table availability_room_type$wbe */
  /*In WBE database, look directly to WBE channel settings */

  /*empty WBE specific table*/
  delete from AVAILABILITY_ROOM_TYPE$WBE
  where QUERY_ID = :QUERY_ID;

  select max(c.id_channel), count(c.id_channel)
  from   CHANNEL c
  where  c.name = 'WBE'
  into   :id_channel, :error_check;
  if (not (:error_check = 1)) then  exception WRONG_VALUE 'Missing channel WBE or dublicated definition!';

  /*Fill WBE specific table*/
  /*polzwa se MAX, za6toto ako pone edna tarifa e pozwolena, zna4i ima stai*/
  /*!!!!! PROBLEM - channel management-a moje da puska stai i tarifi, no towa wse o6te ne ozna4awa 4e et mogat da minat prez tarifata i da polu4at cena*/
  for
    select  PA.id_room_type, PA.for_date,  max(PA.available_rooms),  max(PA.product_status)
    from    PRODUCT_AVAILABILITY$AVL(:id_channel, :id_hotel, :from_date, :to_date, :rates, :roomtypes) PA
    group by 1, 2
    into    :room_type_id, :availability_date, :available_rooms, :is_available
  do begin
    if ((:rooms > :available_rooms) or (:is_available = 0)) then begin
      available_rooms = 0;
      is_available = 0;
    end else begin
      is_available = 1;
    end

    insert into AVAILABILITY_ROOM_TYPE$WBE (room_type_id, availability_date, available_rooms, is_available, query_id)
    values (:room_type_id, :availability_date, :available_rooms, :is_available, :query_id);
  end

end
^

/* Alter (CHANNEL_GET_WHOLEALLOTMENT$CHM) */
ALTER PROCEDURE CHANNEL_GET_WHOLEALLOTMENT$CHM(ID_CHANNEL INTEGER)
 RETURNS(ID_ROOM_TYPE INTEGER,
FOR_DATE DATE,
IS_ACTIVE INTEGER,
AUTO_FREE_ROOMS INTEGER,
ROOM_COUNT INTEGER,
FREE_ROOMS INTEGER,
STATUS INTEGER)
 AS
declare variable date_from date;
  declare variable date_to date;
  declare variable channel_capacity integer;
  declare variable to_sell integer;
begin
  date_from = null;
  select min(FOR_DATE), max(FOR_DATE)
  from CHANNEL_ALLOTMENT
  where ID_CHANNEL = :id_channel
  into :date_from, :date_to;
  if (date_from is null) then exit;

  for select distinct ID_ROOM_TYPE
      from CHANNEL_ALLOTMENT
      where ID_CHANNEL = :id_channel
        and FOR_DATE between :date_from and :date_to
      into :id_room_type
  do begin
    for select RTR.FOR_DATE,
               CA.STATUS,
               CA.AUTO_FREE_ROOMS, CA.ROOM_COUNT, RTR.AVAILABLE as FREE_ROOMS
        from ROOM_TYPE_GET_FREE$CHM(:date_from, :date_to, :id_room_type) RTR
             join CHANNEL_ALLOTMENT CA on CA.ID_ROOM_TYPE = :id_room_type
                                      and CA.ID_CHANNEL = :id_channel
                                      and CA.FOR_DATE = RTR.FOR_DATE
    into :for_date, :status,
         :auto_free_rooms, :channel_capacity, :free_rooms
    do begin
      if (:auto_free_rooms is not null) then
        if (coalesce(:free_rooms,0) >= :auto_free_rooms) then
          is_active = 1;
        else is_active = 0;
      else if (:status = 0) then
             is_active = 1;
           else is_active = 0;

      to_sell = coalesce(:free_rooms,0) - coalesce(:auto_free_rooms,0);
      if (to_sell < 0) then to_sell = 0;

      room_count = :to_sell;
      if (:channel_capacity is not null) then
        if (channel_capacity < room_count) then
          room_count = :channel_capacity;

      suspend;
    end
  end
end
^

/* Alter (CHANNEL_IDSGDS_AVAILABILITY$EXC) */
ALTER PROCEDURE CHANNEL_IDSGDS_AVAILABILITY$EXC(CHANNEL_NAME VARCHAR(30),
ID_HOTEL INTEGER)
 RETURNS(FOR_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_SIMPLE_RATE INTEGER,
ID_BOARD INTEGER,
ROOM_STATUS INTEGER,
RATE_STATUS INTEGER,
PRODUCT_STATUS INTEGER,
AVAILABLE_ROOMS INTEGER,
MIN_LOS INTEGER,
MAX_LOS INTEGER,
SINGLE_PRICE NUMERIC(15,4),
DOUBLE_PRICE NUMERIC(15,4),
GUEST3_PRICE NUMERIC(15,4),
GUEST4PLUS_PRICE NUMERIC(15,4),
CHILD1_W_ADULT1_PRICE NUMERIC(15,4),
CHILD1_W_ADULT2PLUS_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT1_PRICE NUMERIC(15,4),
CHILD2PLUS_W_ADULT2PLUS_PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3))
 AS
declare variable date_from date;
declare variable date_to date;
declare variable id_channel integer;
declare variable rate_found integer;
begin
  --product_status 0 - closed
  --product_status 1 - closed for arrival
  --product_status 2 - opened

  select min(CA.FOR_DATE), max(CA.FOR_DATE), min(C.ID_CHANNEL)
  from   CHANNEL_ALLOTMENT CA
         join CHANNEL C on C.ID_CHANNEL = CA.ID_CHANNEL
         join ROOM_TYPES RT on RT.ID_ROOM_TYPE = CA.ID_ROOM_TYPE
  where  C.NAME = :channel_name
         and CA.FOR_DATE >= current_date
         and RT.ID_HOTEL = :id_hotel
  into   :date_from, :date_to, :id_channel;
  if (:date_from is null) then exit;

  for
    select PA.FOR_DATE, PA.ID_ROOM_TYPE, PA.ID_TAR_HEAD,
           PA.ROOM_STATUS, PA.RATE_STATUS, PA.PRODUCT_STATUS,
           PA.AVAILABLE_ROOMS, PA.MIN_LOS, PA.MAX_LOS, T.CURR
    from   PRODUCT_AVAILABILITY$AVL(:id_channel, :id_hotel, :date_from, :date_to, '', '') PA
           left outer join TARIFA T on T.ID_TARIFA = PA.ID_TAR_HEAD
           left outer join TAR_SIMPLE TS on TS.ID_TAR_HEAD = PA.ID_TAR_HEAD
    where  ((PA.ID_TAR_HEAD is null) or (TS.ID_TAR_SIMPLE is not null))
    into   :for_date, :id_room_type, :id_simple_rate,
           :room_status, :rate_status, :product_status,
           :available_rooms, :min_los, :max_los, :price_currency
  do begin
    rate_found = 0;
    single_price = null;
    double_price = null;
    guest3_price = null;
    guest4plus_price = null;
    child1_w_adult1_price = null;
    child1_w_adult2plus_price = null;
    child2plus_w_adult1_price = null;
    child2plus_w_adult2plus_price = null;
    for
      select TSP.SINGLE_PRICE, TSP.DOUBLE_PRICE, TSP.GUEST3_PRICE, TSP.GUEST4PLUS_PRICE,
             TSP.CHILD1_W_ADULT1_PRICE, TSP.CHILD1_W_ADULT2PLUS_PRICE, TSP.CHILD2PLUS_W_ADULT1_PRICE, TSP.CHILD2PLUS_W_ADULT2PLUS_PRICE,
             TSP.ID_BOARD
      from   TAR_SIMPLE TS
             join TAR_SIMPLE_SEASON TSS on TS.ID_TAR_SIMPLE = TSS.ID_TAR_SIMPLE
             join TAR_SIMPLE_SEASON_PERIODS TSSP on TSS.ID_TAR_SIMPLE_SEASON = TSSP.ID_TAR_SIMPLE_SEASON
             join TAR_SIMPLE_PRICE TSP on TSSP.ID_TAR_SIMPLE_SEASON = TSP.ID_TAR_SIMPLE_SEASON
      where  TS.ID_TAR_HEAD = :id_simple_rate
             and :for_date between TSSP.FROM_DATE and TSSP.TO_DATE
             and TSP.ID_ROOM_TYPE = :id_room_type
             and ((tsp.IS_BASE_DAYS_PRICE = 0 and coalesce(tss.SPECIAL_DAYS_OF_WEEK, '') containing extract (weekday from cast(:for_date as date)))
                  or (tsp.IS_BASE_DAYS_PRICE = 1 and coalesce(tss.SPECIAL_DAYS_OF_WEEK, '') not containing extract (weekday from cast(:for_date as date))))
             -- and TSP.days_of_week containing extract (weekday from :for_date )
      into   :single_price, :double_price, :guest3_price, :guest4plus_price,
             :child1_w_adult1_price, :child1_w_adult2plus_price, :child2plus_w_adult1_price, :child2plus_w_adult2plus_price,
             :id_board
    do begin
      rate_found = 1;
      suspend;
    end

    if (:rate_found = 0) then begin
      rate_status = 0;
      product_status = 0;
      suspend;
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: AVAILABILITY_RATE_SMALL$WBE for: CHANNEL_PRODUCT_AVAIL_REQ$INT */
ALTER PROCEDURE AVAILABILITY_RATE_SMALL$WBE(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER,
ROOMS INTEGER,
ADULTS INTEGER,
CHILDREN INTEGER,
QUERY_ID INTEGER,
PROFILE_ID INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (CHANNEL_PRODUCT_AVAIL_REQ$INT) */
ALTER PROCEDURE CHANNEL_PRODUCT_AVAIL_REQ$INT(ID_CHANNEL INTEGER,
ID_HOTEL INTEGER,
ARRIVAL DATE,
DEPARTURE DATE,
ROOMS INTEGER)
 RETURNS(ID_ROOM_TYPE INTEGER,
ID_TAR_HEAD INTEGER,
IS_PRODUCT_AVAIALABLE INTEGER,
ROOM_STATUS INTEGER,
RATE_STATUS INTEGER,
RATE_MIN_LOS INTEGER,
RATE_MAX_LOS INTEGER,
AVAILABLE_ROOMS INTEGER,
IS_PUBLIC SMALLINT)
 AS
declare variable los integer;
begin
    /*TODO Proc will check all room types in channel management and rates in rate restrictions and
           will return all available and nonavailable combinations (products). For each product :
       - is_product_avaialable = 0/1 - general decision for product - can or cannot be sold
       - room_status 0-closed, 2-open - can be used for extra info if product is closed
       - rate_status 0-closed, 1-closed for arrival, 2-open - can be used for extra info if rate is closed
       - rate_min_los and rate_max_los integer - null or > 0 - extra info*/


  los = :departure - :arrival;

  for select PA.ID_ROOM_TYPE, PA.ID_TAR_HEAD,
             min(PA.ROOM_STATUS),
             /*za wsi4ki dni oswen arriaval-a close for arrival = open*/
             min( iif((pa.for_date <> :arrival) and (PA.RATE_STATUS = 1), 2, PA.RATE_STATUS)),
             /*min i max los se gledat samo na datata na pristigane*/
             max( iif((pa.for_date = :arrival), PA.MIN_LOS , null)),
             max( iif((pa.for_date = :arrival), PA.MAX_LOS , null)),
             min(PA.AVAILABLE_ROOMS),
             min(pa.is_public)
  from PRODUCT_AVAILABILITY$AVL(:id_channel, :id_hotel, :arrival, :departure-1, '', '') PA
  where PA.ID_TAR_HEAD is not null
  group by 1, 2
  /*ako kanala ne warne wsi4ki dati ot prestoia - zna4i producta niama definicia tam i ne se predlaga waob6te*/
  having count (pa.for_date) = :los
  into :id_room_type, :id_tar_head,
        :room_status,
        :rate_status,
        :rate_min_los,
        :rate_max_los,
        :available_rooms,
        :is_public
  do begin
    is_product_avaialable = 0;
    if (
        (:available_rooms >= :rooms)
        and (:room_status = 2)
        and (:rate_status = 2)
        and ((:rate_min_los is null) or (:los >= :rate_min_los)  )
        and ((:rate_max_los is null) or (:los <= :rate_max_los)  )
        )
    then is_product_avaialable = 1;
    suspend;
  end
end
^

/* Alter (CREATE_BOOKING$WBE) */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
declare variable rate varchar(50);
declare variable room_type varchar(20);
declare variable arrival date;
declare variable departure date;
declare variable adults integer;
declare variable children integer;
declare variable profile_name varchar(100);
declare variable aranger_name varchar(100);
declare variable guest_profile_uuid varchar(40);
declare variable aranger_profile_uuid varchar(40);
declare variable hotel_name varchar(50);
declare variable wbe_session_id bigint;
declare variable main_guest_profile_id integer;
declare variable board varchar(50);
declare variable hotel_id integer;
declare variable guarantee_policy_name varchar(50);
declare variable guarantee_deposit_percent numeric(15,4);
declare variable guarantee_deposit_nights integer;
declare variable guarantee_due_days_bef_arrival integer;
declare variable guarantee_due_days_after_create integer;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable profile_type varchar(20);
declare variable profile_import_time timestamp;
declare variable b_count integer;
declare variable age integer;
declare variable is_child smallint;
declare variable guest_id integer;
declare variable special_treatment varchar(250);
declare variable maintenance varchar(30);
declare variable routing varchar(20);
declare variable arranger_paymeny_type varchar(20);
declare variable market_segment varchar(30);
declare variable market_source varchar(30);
declare variable market_channel varchar(30);
declare variable market_hear_reason varchar(30);
declare variable market_come_reason varchar(30);
declare variable first_food varchar(30);
declare variable bnote varchar(2000);
begin
  -- get wbe product selection
  select  PA.rate_name,PA.room_name, AQ.first_date, AQ.first_date+AQ.day_count,
          PS.adults, PS.children, PS.person_name, H.hotel_name, H.id_hotel,
          WS.id, PA.board_name, GP.name, GP.deposit_totalsum_part, GP.deposit_nights_count, GP.due_days_before_arrival, GP.due_days_after_create,
          PS.bnote
   from   PRODUCT_SELECTION$WBE PS
          join WBE_SESSION$WBE WS on WS.id = PS.wbe_session_id
          join PRODUCT_AVAILABILITY$WBE PA on pa.id = PS.product_availability_id
          join AVAILABILITY_QUERY$WBE AQ on aq.id = WS.product_query_id
          join HOTEL H on H.id_hotel = WS.hotel_id
          join GUARANTEE_POLICY GP on GP.id_guarantee_policy = PS.guarantee_policy_id
   where  PS.id = :product_selection_id
   into   :rate, :room_type, :arrival, :departure,
          :adults,  :children, :profile_name, :hotel_name, :hotel_id,
          :wbe_session_id, :board, :guarantee_policy_name,
          :guarantee_deposit_percent, :guarantee_deposit_nights,
          :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create,
          :bnote;

  select PA.uuid , PA.profile_name, PA.profile_type
  from   PROFILE PA
  where  PA.id_profile = :aranger_profile_id
  into   :aranger_profile_uuid,:aranger_name,  :profile_type;

  if (:aranger_name = :profile_name and :profile_type = 'PERSON') then begin
    -- aranger is main guest
    select count(*)
    from   PRODUCT_SELECTION$WBE PSC
    where  PSC.wbe_session_id = :wbe_session_id
    into   :b_count;
       -- only if single reservation bugfix 2228
    if (1 = :b_count) then begin
     guest_profile_uuid =  aranger_profile_uuid;
     aranger_profile_uuid = null;
    end
  end else begin
    -- create profile for main guest
    execute procedure IMPORT_PERSON_PROFILE$EXC(
      uuid_create(),:profile_name,null,null,null,null,null,null,null,null,null,null, null,
      null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
      null,null,null,null,null, null, null)
    returning_values :main_guest_profile_id, :profile_import_time;

    select P.uuid
    from   PROFILE P
    where  P.id_profile = :main_guest_profile_id
    into   :guest_profile_uuid;
  end

    -- apply default map + forced arranger
    special_treatment = null;
    maintenance = null;
    routing = null;
    arranger_paymeny_type = null;
    market_segment = null;
    market_source = null;
    market_channel = null;
    market_hear_reason = null;
    market_come_reason = null;


  select hc.special_treatment, hk.plan_name, hc.routing,
         pt.payment_type, ms.segment_name, sc.description, cc.description,
         hr.description, cr.description, hc.first_food
  from   HOTEL_PRODUCT_CFG$WBE hc
         left join HK_PLAN hk on hk.id_plan = hc.id_hk_plan
         left join PAYMENT_TYPE pt on pt.id_payment_type = hc.arranger_id_payment_type
         left join NOM_MARKET_SEGMENTS ms on ms.id_nom_market_segment = hc.id_m_segment
         left join NOM_SOURCE_CODES sc on sc.id_nom_source_code = hc.id_m_source
         left join NOM_CHANNEL_CODES cc on cc.id_nom_channel_code = hc.id_m_channel
         left join NOM_HEAR_REASONS hr on hr.id_nom_hear_reason = hc.id_m_hear_reason
         left join NOM_COME_REASONS cr on cr.id_nom_come_reason = hc.id_m_come_reason
  where  hc.hotel_id = :hotel_id
  into   :special_treatment,:maintenance,:routing,:arranger_paymeny_type,
         :market_segment,:market_source,:market_channel,:market_hear_reason,:market_come_reason,:first_food;
  -- create reseravation
  execute procedure IMPORT_BOOKING$EXC(
     :hotel_name, :number, null, null, 0,
     :arrival, null, :departure, null, null, null, null, null, :room_type, :board, null,
     :special_treatment, :maintenance, :routing, :rate, null, null, null, null, :arranger_paymeny_type, null, null, null, null,
     :market_segment, :market_source,:market_channel, :market_hear_reason, :market_come_reason,
     :bnote, null, :first_food, :adults, :children, :aranger_profile_uuid, null, :guest_profile_uuid,
     0, 0, null, :guarantee_policy_name, null, :guarantee_deposit_percent, :guarantee_deposit_nights,
     :guarantee_due_days_bef_arrival,  :guarantee_due_days_after_create, null, null, null, null,  null, null, null, null, null, null, null, null)
  returning_values
     :hotel_id, :booking_id, :err_code, err_text;
  if (0 <> :err_code) then exception WRONG_VALUE ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');

  -- import guests
  for
    select psg.guest_name, psg.is_child, psg.age
    from   PRODUCT_SELECTION_GUESTS$WBE psg
    where  psg.product_selection_id = :product_selection_id
    into   :profile_name,:is_child,:age
  do begin
    execute procedure IMPORT_GUEST$EXC(:booking_id, null, null, :profile_name, :is_child, :age, null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null)
    returning_values :guest_id, :err_code,:err_text;
    if (0 <> :err_code) then exception WRONG_VALUE ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');
  end
  ----------------

  select RD.number_2
  from   RESERV_DETAIL RD
  where  RD.id_reserv_detail = :booking_id
  into   :number_2;

  update PRODUCT_SELECTION$WBE uPS
  set    uPS.booking_id = :booking_id, uPS.selection_id = :number_2
  where  uPS.id = :product_selection_id;
end
^

/* Alter (CREATE_SESSION_BOOKINGS$WBE) */
ALTER PROCEDURE CREATE_SESSION_BOOKINGS$WBE(WBE_SESSION_ID BIGINT,
ARANGER_ID INTEGER,
LANG_CODE VARCHAR(3))
 RETURNS(SELECTION_ID VARCHAR(20),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable product_selection_id bigint;
declare variable next_num integer;
declare variable sel_cnt integer;
declare variable aranger_name varchar(100);
declare variable aranger_email varchar(50);
declare variable aranger_phone varchar(50);
declare variable booking_id integer;
declare variable record_timestamp timestamp;
declare variable new_res_number varchar(62);
declare variable room_types_src varchar(255) = '';
declare variable rates_src varchar(255) = '';
declare variable hotel_id integer;
declare variable profile_id integer;
declare variable from_date date;
declare variable to_date date;
declare variable day_count integer;
declare variable room_type_id integer;
declare variable rate_id integer;
declare variable query_id_tmp integer;
declare variable rooms_required integer;
declare variable rooms_available integer;
declare variable profile_import_time timestamp;
begin
  execute procedure EXPORT_LOG_FORCE$EXC(1);
  /* test overbook (multiuser) */
   for select ws.hotel_id,ws.profile,aq.first_date,(aq.first_date+aq.day_count)-1,pa.room_type_id,pa.rate_id,aq.day_count
    from   PRODUCT_availability$WBE PA
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    join availability_query$wbe aq on aq.id = pa.query_id
   where ws.id = :wbe_session_id and coalesce(pa.room_count,0) > 0
   into  :hotel_id, :profile_id, :from_date, :to_date, :room_type_id, :rate_id , :day_count
   do begin
       room_types_src = :room_types_src||','||cast(:room_type_id as varchar(10));
       rates_src = :rates_src||','||cast(rate_id as varchar(10));
   end

   query_id_tmp = GEN_ID(AVAILABILITY_QUERY$WBE_SEQ,1);
   insert into availability_query$wbe(ID, WBE_SESSION_ID, FIRST_DATE, DAY_COUNT)    -- prevent FK exception
    values (:query_id_tmp,:wbe_session_id,:from_date,:day_count) ;

   execute procedure availability_occup_small$wbe(:from_date,:to_date,:hotel_id,:query_id_tmp,1,:rates_src,:room_types_src) ;

   --  check minimum available rooms for every day
   err_code = null;
   err_text = '';
   for select pa.room_type_id,pa.room_count,
    (select coalesce(min(art.available_rooms),0) from availability_room_type$wbe art
      where art.query_id = :query_id_tmp and art.room_type_id = pa.room_type_id)
    from product_availability$wbe pa
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    where ws.id = :wbe_session_id
    and coalesce(pa.room_count,0) > 0   into :room_type_id,:rooms_required,:rooms_available
   do begin
       if (rooms_required > rooms_available) then
       begin
        err_code = 1;
        ERR_TEXT = coalesce(ERR_TEXT,'')||:room_type_id||';';
       end
   end
   delete from availability_query$wbe aqt where aqt.id = :query_id_tmp;       -- remove temp query
   if (err_code is not null) then exit;

  /* create profile if not exist and reservations > 1*/
  if (aranger_id is NULL) then
  begin
    select WS.person_name,WS.address,WS.phone
    from   WBE_SESSION$WBE WS
    where  WS.id = :wbe_session_id
    into   :aranger_name,:aranger_email,:aranger_phone;

    execute procedure IMPORT_PERSON_PROFILE$EXC(
       uuid_create(),:aranger_name,null,null,null,null,null,null,null,null,null,null,
       null,null,null,null,:aranger_phone,null,:aranger_email,null,null,null,null,null,null,
       STRHASH_LARGE(substring(uuid_create() from 1 for 4)),null,null,null,null,null,null,null,null, null, null)
    returning_values :aranger_id, :profile_import_time;

    update WBE_SESSION$WBE uWS
    set    uWS.profile = :aranger_id
    where  uWS.id = :wbe_session_id;
  end else begin
    -- da podmeni email, phone ako !!
  end
  /* create reservations */
  for
    select PS.id
    from   PRODUCT_SELECTION$WBE PS
    where  PS.wbe_session_id = :wbe_session_id
           and PS.booking_id is null
           and coalesce(PS.is_deleted,0) <> 1
    into   :product_selection_id
  do begin
     if (next_num = 1) then begin      -- increment first reservation number_3
      execute procedure res_number_suffix_gen(:booking_id) returning_values :new_res_number;
      next_num = next_num + 1;
     end
     execute procedure CREATE_BOOKING$WBE(:product_selection_id,:aranger_id,'WBE.'||:selection_id||'.'||:next_num) returning_values :booking_id,:selection_id;
     execute procedure IMPORT_BOOKING_FINALIZE$EXC(:booking_id) returning_values  record_timestamp,:err_code,:err_text;
     insert into SCHEDULER$WBE(booking_id,status,last_action_time,lang_code,guarantee_passed) values (:booking_id, NULL, current_timestamp, :lang_code,0);

     if (next_num is NULL) then begin
      next_num = 1;
     end else begin
      next_num = next_num + 1;
     end
  end
end
^

/* Alter (DEPOSIT_REFUND$DOC) */
ALTER PROCEDURE DEPOSIT_REFUND$DOC(ID_DEPOSIT INTEGER,
REFUND_AMOUNT NUMERIC(15,4),
REFUND_CURRENCY VARCHAR(3),
ID_PAY_DOC_TYPE INTEGER,
DESCRIPTION VARCHAR(100))
 RETURNS(ID_REFUND_PAYMENT INTEGER,
ID_STORNO_DOC INTEGER,
WARN_CODE INTEGER)
 AS
declare variable no_use varchar(2000);
  declare variable id_account integer;
  declare variable avail_value numeric(15,4);
  declare variable id_doc_head integer;
  declare variable pay_currency varchar(3);
  declare variable pay_rate numeric(15,6);
  declare variable sys_date date;
  declare variable round_to numeric(15,4);
  declare variable p_dbkey char(8);
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable id_account_payment integer;
  declare variable id_doc_type integer;
  declare variable account_curr varchar(3);
  declare variable account_rate numeric(15,6);
  declare variable id_reserv_detail integer;
  declare variable is_posting_stopped integer;
  declare variable firm_data type of tnote_blob;
begin
  WARN_CODE = null;
  execute procedure RIGHTS_CHECK_GRANTED$INT ('DEPOSIT_REFUND');

  select D.ID_ACCOUNT, DH.ID_DOC, dh.ID_DOC_TYPE, c.ROUND_TO, d.ID_RESERV_DETAIL,
         D.AVAIL_VALUE, D.PAY_CURRENCY, D.PAY_RATE, A.ID_HOTEL, A.ACCOUNT_CURR
  from   DEPOSIT_AVAILABLE D
         join ACCOUNT A on A.ID_ACCOUNT = D.ID_ACCOUNT
         join CURRS C on c.CURR = d.PAY_CURRENCY
         left outer join DOC_HEAD DH on DH.ID_DOC = D.ID_DOC_HEAD
                                        and DH.IS_STORNED = 0
                                        and DH.IS_ANUL = 0
  where  D.ID_DEPOSIT = :ID_DEPOSIT
  into   :id_account, :id_doc_head, :id_doc_type, :round_to, :id_reserv_detail,
         :avail_value, :pay_currency, :pay_rate, :id_hotel, :account_curr;

  if (:pay_currency is distinct from :refund_currency) then exception PAYMENT_EXCEPTION 'Currency mismatch!';

  if (round_f(:avail_value - :REFUND_AMOUNT, :round_to) < 0) then exception PAYMENT_EXCEPTION '-305';
  --'Issued value is more than available deposit amount.';

  select r.IS_POSTING_STOPPED
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :is_posting_stopped;

  if (:is_posting_stopped = 1) then exception BOOKING_EXCEPTION '-391';

  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET(:id_hotel) SD
  into   :sys_date;

  select first 1 ap.ACC_RATE
  from   ACCOUNT_PAYMENTS ap
  where  ap.ID_DEPOSIT = :ID_DEPOSIT
  order by ap.ID_ACCOUNT_PAYMENT asc
  into   :account_rate;

  execute procedure PAYMENT_CREATE$INT (:ID_PAY_DOC_TYPE, :ID_ACCOUNT, :SYS_DATE,
          -:REFUND_AMOUNT, :PAY_CURRENCY, :PAY_RATE, :account_curr, :account_rate, :DESCRIPTION)
  returning_values  (:id_refund_payment, :id_account_payment, :no_use);

  insert into DEPOSIT_REFUND (ID_DEPOSIT, ID_PAYMENT_HEAD, DESCRIPTION)
  values (:ID_DEPOSIT, :ID_REFUND_PAYMENT, :DESCRIPTION);

  update ACCOUNT_PAYMENTS AP
  set    AP.ID_DEPOSIT = :ID_DEPOSIT
  where  ap.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT;

  if (:ID_DOC_HEAD is not null) then begin
    execute procedure DOC_TYPE_EVALUATE$INT (:id_doc_type, :id_hotel, 0, :ID_REFUND_PAYMENT);

    execute procedure DOCUMENT_ADVANCE_STORNO$INT (:ID_DEPOSIT, :REFUND_AMOUNT, :DESCRIPTION)
    returning_values  (:ID_STORNO_DOC, :WARN_CODE);

    execute procedure DOCUMENT_ATTACH_PAYMENT$INT (:ID_STORNO_DOC, :id_account_payment, :pay_rate, null)
    returning_values :no_use;
     
    update  PAYMENT_HEAD P
    set     P.ID_DOC_HEAD = :ID_STORNO_DOC
    where   P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT;

    execute procedure DOCUMENT_VALIDATE$DOC (:ID_STORNO_DOC)
    returning_values (:firm_data, :no_use, :no_use);
  end else begin
    select P.RDB$DB_KEY
    from   PAYMENT_HEAD P
    where  P.ID_PAYMENT_HEAD = :ID_REFUND_PAYMENT
    into   :P_DBKEY;
     
    execute procedure PAYMENT_SET_NUMBER$INT (:P_DBKEY);
  end

  action_text = F_CHARACTER(29) || :REFUND_AMOUNT || ' ' || :PAY_CURRENCY;
  execute procedure SYSTEM_LOG_ADD ('DEPOSIT', :ID_DEPOSIT, 'REFUND', :ACTION_TEXT);
end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_POST_TO_FRONT_ONLINE for: EAI_EXT_POST_TO_MH_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_EXT_POST_TO_MH_FRONT_ONLINE) */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  if (:CODE_TYPE = 'EXT_CODE') then begin
    execute procedure EAI_MAP_SERVICE(:SERVICE_CODE, :SERVICE_CODE, 'UNKNOWN', :id_hotel)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_SERVICE;
    if (:ERR_CODE < 0) then exit;
  end else begin
    select S.ID_SERVICE
    from   SERVICES S
    where  S.ID_SERVICE = :SERVICE_CODE
           and s.ID_HOTEL = :ID_HOTEL
    into   :ID_SERVICE;
    if (:ID_SERVICE is null) then begin
      ERR_CODE = -85;   /* Wrong value! */
      exit;
    end
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:ID_ACCOUNT_POST, :SERVICE_CODE, null, null);

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Alter (EAI_EXT_SERVICE_POST) */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable max_id_service integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_ROOM  = null;
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  select min(S.ID_SERVICE) as id_service, max(s.id_service) as max_id_service
  from   SERVICES S
  where  S.EXT_CODE = :SERVICE_EXT_CODE
         and s.IS_BASE = 0
         and s.IS_DELETED = 0
  into   :ID_SERVICE, :max_id_service;
  if (:ID_SERVICE is null) then begin
      ERR_CODE = -388;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end else if (:ID_SERVICE <> :max_id_service) then begin
      ERR_CODE = -389;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_EXT_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:ID_ACCOUNT_POST, :SERVICE_EXT_CODE, null, null);

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* empty dependent procedure body */
/* Clear: EAI_POS_POSTING_ADD for: EAI_POS_POSTING_ADD$P2E */
ALTER PROCEDURE EAI_POS_POSTING_ADD(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_POS_POSTING_ADD$P2E) */
ALTER PROCEDURE EAI_POS_POSTING_ADD$P2E(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
declare variable id_service integer;
  declare variable my_post_text varchar(255);
  declare variable my_resource_text varchar(255);
  declare variable nation_curr varchar(3);
  declare variable post_short_code varchar(10);
  declare variable id_hotel integer;
  declare variable id_account_post integer;
begin
  /* in_on_guest = 0 (account), 1 (guest), -1 (ew)
  */
  if (:IN_ON_GUEST = 1) then begin
    select rd.ID_HOTEL
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :IN_ID_GUEST
    into   :id_hotel;
  end else begin
    select a.ID_HOTEL
    from   account a
    where  a.ID_ACCOUNT = :in_id_account
    into   :id_hotel;
  end

  select h.NATION_CURR
  from   HOTEL H
  where  h.ID_HOTEL = :id_hotel
  into   :nation_curr;

  if ('END_WORK' = :in_smetka_num) then begin
    post_short_code='POS_EW';
  end else begin
    post_short_code='POS';
  end

  /* FIND SERVICE */
  execute procedure EAI_MAP_SERVICE(:in_service_tag, :in_service_name, 'POS', :id_hotel)
  returning_values  :err_code, :err_text, :id_service;
  if (:err_code < 0) then exit;

  my_post_text = 'date:'|| formatdate(:in_date_smetka, 'D;dd.mm.yyyy') ||
                 ' num:'|| :in_smetka_num ||
                 ' obj:'|| :in_obj_name ||
                 ' tbl:'|| :in_table ||
                 ' site:'|| :in_site;

  my_resource_text = 'POS_ID_SMETKA:'||:in_id_smetka;
  my_post_text = substring(:my_post_text from 1 for 100);
  my_resource_text = substring(:my_resource_text from 1 for 49);

  if (:in_on_guest = 1) then begin
    execute procedure POST_SERVICE_ON_GUEST$INT(:in_id_guest, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code, '')
    returning_values  :err_code, :err_text, :out_id_account, :id_account_post;
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:in_id_account, :id_service, 1, 0, 1, :in_price, :nation_curr,
      current_timestamp, current_timestamp, :my_post_text, :my_resource_text, null, :post_short_code)
    returning_values  :err_code, :err_text, :id_account_post;
    out_id_account = :in_id_account;
  end
  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:id_account_post, :post_short_code, :IN_POS_USER, :IN_DATETIME);
end
^

/* Alter (EAI_TELECOUNT_TRANSFER) */
ALTER PROCEDURE EAI_TELECOUNT_TRANSFER AS
declare variable ph_dbkey char(8);
declare variable id_account integer;
declare variable id_room integer;
declare variable post_to_id integer;
declare variable post_to_type smallint;
declare variable datetime_call timestamp;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable posting_error varchar(255);
begin

  for
    select pc.RDB$DB_KEY, pc.ID_ACCOUNT, pc.ID_ROOM, pc.DATETIME_CALL, pc.POSTING_ERROR
    from   PHONECALLS PC
    where  iif(ATA = '01' and PC.IS_LOGICLESS_RECORD = 0 and coalesce(pc.id_room, pc.id_account) is not null, pc.id_phonecall, 0) > 0
    into   :ph_dbkey, :id_account, :id_room, :datetime_call, :posting_error
  do begin
    execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
    returning_values (:post_to_id, :post_to_type);

    if (:post_to_id is not null) then begin
      execute procedure POST_TELECOUNT_CALL$INT (:post_to_type, :post_to_id, :ph_dbkey, 0)
      returning_values (:ERR_CODE, :ERR_TEXT);
  
      if (:err_code <> 0) then begin
        update PHONECALLS p
        set    p.POSTING_ERROR = :err_code || f_character(31) || coalesce(:err_text, '')
        where  p.RDB$DB_KEY = :ph_dbkey;
      end
    end else if (:posting_error is not null) then begin
      update PHONECALLS p
      set    p.POSTING_ERROR = null
      where  p.RDB$DB_KEY = :ph_dbkey;
    end

    when any do begin
      update PHONECALLS p
      set    p.POSTING_ERROR = 'Phonecall posting error!'
      where  p.RDB$DB_KEY = :ph_dbkey;
    end
  end

end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTS$INT for: GUEST_REROUTE_POSTINGS$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTS$INT(RD_DBKEY CHAR(8))
 AS
 BEGIN EXIT; END
^

/* Alter (GUEST_REROUTE_POSTINGS$INT) */
ALTER PROCEDURE GUEST_REROUTE_POSTINGS$INT(ID_GUEST INTEGER,
ID_BASE_ACCOUNT INTEGER,
ID_EXTRA_ACCOUNT INTEGER)
 AS
declare variable ap_dbkey char(8);
  declare variable is_packet_post integer;
  declare variable packet_option varchar(50);
  declare variable id_target_account integer;
  declare variable id_current_account integer;
begin
  update GUEST G
  set    G.ID_BASE_ACCOUNT = :ID_BASE_ACCOUNT,
         G.ID_ACCOUNT = :ID_EXTRA_ACCOUNT
  where  G.ID_GUEST = :ID_GUEST;

  for
    select AP.RDB$DB_KEY, iif(AP.ID_MASTER_ADDINS_ACC_POST > 0, 1, 0), S.VAUCHER_PACKET,
           ap.ID_ACCOUNT
    from   ACCOUNT_POST AP
           join SERVICES S on S.ID_SERVICE = AP.ID_SERVICE
    where  AP.ID_GUEST = :ID_GUEST
           and AP.AC = '00'
           and AP.ID_BASE_DOC is null
    into   :ap_dbkey, :is_packet_post, :packet_option, :id_current_account
  do begin
    if ((:is_packet_post = 1) and (:packet_option <> 'NONE')) then id_target_account = :id_base_account;
    else id_target_account = :id_extra_account;

    if (:id_current_account <> :id_target_account) then begin
      execute procedure ACCOUNT_POSTING_TRANSFER$INT(:ap_dbkey, :id_target_account, 0);
    end
  end

end
^

/* Alter (PHONECALL_POST$TC) */
ALTER PROCEDURE PHONECALL_POST$TC(ID_PHONECALL ID)
 AS
declare variable id_room integer;
  declare variable id_account integer;
  declare variable pc_dbkey char(8);
  declare variable datetime_call timestamp;
  declare variable post_to_id integer;
  declare variable post_to_type integer;
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  select p.RDB$DB_KEY, p.id_room, p.ID_ACCOUNT, p.DATETIME_CALL
  from   PHONECALLS p
  where  p.ID_PHONECALL = :ID_PHONECALL
  into   :pc_dbkey, :id_room, :id_account, :datetime_call;

  execute procedure PHONECALL_GET_HOLDER$INT (:id_room, :id_account, :datetime_call)
  returning_values (:post_to_id, :post_to_type);

  if (:post_to_id is not null) then begin
    execute procedure POST_TELECOUNT_CALL$INT(:post_to_type, :post_to_id, :pc_dbkey, 0)
    returning_values :ERR_CODE, :ERR_TEXT;
    if (:err_code < 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end else begin
    -- clear previous posting error
    update PHONECALLS p
    set    p.POSTING_ERROR = null
    where  p.RDB$DB_KEY = :pc_dbkey;
  end
end
^

/* Alter (PHONECALLS_POST_TO_ACCOUNT$TC) */
ALTER PROCEDURE PHONECALLS_POST_TO_ACCOUNT$TC(SELECTION_ID INTEGER,
ID_ACCOUNT INTEGER)
 RETURNS(ID_SEQUENCE INTEGER)
 AS
declare variable ph_dbkey char(8);
  declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  ID_SEQUENCE = gen_id(ID_SEQUENCE_GEN, 1);

  for
    select PC.rdb$db_key
    from   PHONECALLS PC 
    where  PC.SELECTION_ID = :SELECTION_ID
           and coalesce (PC.ID_ACCOUNT_POST, -1) < 0
    into   :ph_dbkey
  do begin
    /* prepare for real posting  */
    execute procedure POST_TELECOUNT_CALL$INT(3, :id_account, :ph_dbkey, :ID_SEQUENCE)
    returning_values :err_code, :err_text;
    if (:ERR_CODE <> 0) then
      exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

  end

end
^

/* Alter (PMS_IMPORT) */
ALTER PROCEDURE PMS_IMPORT(ID_EXPORT_HEAD INTEGER)
 AS
begin

  execute procedure PMS_IMPORT$INT(:ID_EXPORT_HEAD);

end
^

/* empty dependent procedure body */
/* Clear: ACCOUNT_POST_MODIFY$PMS for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PMS_EXPENSE_POSTS_CREATE$INT for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_EXPENSE_POSTS_CREATE$INT(ID_ROOM /* TYPE OF ID */ INTEGER,
ID_OWNER /* TYPE OF ID */ INTEGER,
ID_RENTAL_POOL /* TYPE OF ID_REF */ INTEGER,
ID_SERVICE /* TYPE OF ID */ INTEGER,
ID_CURRENCY /* TYPE OF TCURRENCY */ CHAR(3),
POST_VALUE /* TYPE OF TPRICE */ NUMERIC(15,4),
IS_CLIENT_ACC_POST /* TYPE OF TLOGICAL */ SMALLINT,
MANUAL_POST_DATE /* TYPE OF TDATE */ DATE,
DESCRIPTION /* TYPE OF TDESCRIPTION_LONG */ VARCHAR(255),
IS_POST_PER_POOL /* TYPE OF TLOGICAL */ SMALLINT)
 RETURNS(NEW_ID_ACCOUNT_POST /* ID_REF */ INTEGER,
NEW_ID_ACCOUNT_POST$PMS /* ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PMS_POOL_DISTRIBUTION_SUB for: PMS_POSTING_CREATE$INT */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
 BEGIN EXIT; END
^

/* Alter (PMS_POSTING_CREATE$INT) */
ALTER PROCEDURE PMS_POSTING_CREATE$INT(ID_PMS_EVENT TYPE OF ID,
ID_ACCOUNT TYPE OF ID,
ID_SERVICE TYPE OF ID,
ID_OWNER TYPE OF ID,
POST_DATE TYPE OF TDATE,
CURR_ORIG TYPE OF TCURRENCY,
VALUE_ORIG TYPE OF TPRICE,
POST_ON_PMS_ACCOUNT TYPE OF TLOGICAL,
IS_OWNER_INCOME TYPE OF TLOGICAL,
ID_ROOM TYPE OF ID_REF = null)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
begin
  if (:POST_ON_PMS_ACCOUNT = 1) then begin
    execute procedure ACCOUNT_POST_PMS_ADD$INT(:id_pms_event, :id_account, :id_owner,
            :CURR_ORIG, :VALUE_ORIG, :id_service, :is_owner_income, :POST_DATE)
    returning_values  (:new_id_account_post);
  end else begin
    execute procedure POST_SERVICE_ON_ACCOUNT$INT(:id_account, :ID_SERVICE, 1, 0, 1,
            :VALUE_ORIG, :CURR_ORIG, current_date, current_date,
            '', '', :POST_DATE, 'PMS', :ID_ROOM)
    returning_values  :err_code, :err_text, :new_id_account_post;
    if (:err_code <> 0) then exception PMS_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);

    insert into PMS_EVENT_POST (ID_PMS_EVENT, ID_ACCOUNT_POST, ID_OWNER, LINE_STATUS)
    values (:ID_PMS_EVENT, :NEW_ID_ACCOUNT_POST, :ID_OWNER, 11);
  end
end
^

/* Alter (POST_SERVICE_FINALIZE$POST) */
ALTER PROCEDURE POST_SERVICE_FINALIZE$POST(ID_SEQUENCE INTEGER,
OPERATION VARCHAR(20))
 RETURNS(DOC_SELECTED INTEGER)
 AS
declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable no_use varchar(255);
  declare variable id_acc_post integer;
  declare variable id_service integer;
  declare variable id_account integer;
  declare variable id_guest integer;
  declare variable date_post date;
  declare variable price_post numeric(15,4);
  declare variable qty_post numeric(15,2);
  declare variable post_text varchar(100);
  declare variable curr_post varchar(3);
  declare variable id_phonecall integer;
  declare variable p_dbkey char(8);
begin

  if (:OPERATION = 'clear') then begin
    delete from TMP_SERVICE_POST T
    where  T.ID_SEQUENCE = :ID_SEQUENCE;

  end else if (:OPERATION = 'store') then begin
    DOC_SELECTED = gen_id(DOC_SELECTED_GEN, 1);

    for
      select TS.RDB$DB_KEY, TS.ID_SERVICE, TS.ID_ACCOUNT, TS.ID_GUEST, TS.DATE_POST,
             TS.PRICE_POST, TS.QTY_POST, TS.CURR_POST, TS.POST_TEXT, TS.ID_PHONECALL
      from   TMP_SERVICE_POST TS
      where  TS.ID_SEQUENCE = :ID_SEQUENCE
      into   :p_dbkey, :id_service, :id_account, :id_guest, :date_post,
             :price_post, :qty_post, :curr_post, :post_text, :id_phonecall
    do begin
      id_acc_post = null;
      if (:id_guest is not null) then begin
        execute procedure POST_SERVICE_ON_GUEST$INT (:id_guest, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :CURR_POST,
                :date_post, :date_post, :post_text, '', :date_post, '', '')
        returning_values  (:err_code, :err_text, :no_use, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end else begin
        execute procedure POST_SERVICE_ON_ACCOUNT$INT (:id_account, :id_service, :qty_post,
                :ID_SEQUENCE, 1, :price_post, :curr_post, :date_post, :date_post, :post_text,
                '', :date_post, '')
        returning_values  (:err_code, :err_text, :id_acc_post);
        if (:ERR_CODE <> 0) then exception POSTING_EXCEPTION :err_code || f_character(31) || :err_text || f_character(29);
      end

      update TMP_SERVICE_POST
      set ID_ACCOUNT_POST = :id_acc_post
      where RDB$DB_KEY = :p_dbkey;

      update ACCOUNT_POST AP
      set    AP.DOC_SELECTED = :DOC_SELECTED,
             AP.SHORT_CODE = case
                               when :id_phonecall is not null then 'TELECOUNT'
                               else null
                             end
      where  AP.ID_ACCOUNT_POST = :id_acc_post;

      if (:id_phonecall is not null) then begin
        update PHONECALLS P
        set    P.ID_ACCOUNT_POST = :id_acc_post
        where  P.ID_PHONECALL = :id_phonecall;
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_CHANGE$RSV for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTING$INT for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_GUESTCOUNT$RSV for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT$RSV for: RES_SAVE_ACCOUNTS$INT */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_ACCOUNTS$INT) */
ALTER PROCEDURE RES_SAVE_ACCOUNTS$INT(RD_DBKEY CHAR(8))
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_base_account integer;
  declare variable old_id_extra_account integer;
  declare variable new_id_base_account integer;
  declare variable new_id_extra_account integer;
  declare variable acc_routing varchar(30);
  declare variable is_sep_accounts integer;
  declare variable id_base_account_profile integer;
  declare variable id_extra_account_profile integer;
  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable id_agent_account_rule integer;
  declare variable id_acc_template_person integer;
  declare variable id_guest integer;
  declare variable id_hotel integer;
begin

  select RD.ID_RESERV_DETAIL, RD.ID_PERSON_PROFILE, RD.ID_ACC_TEMPLATE_PERSON,
         RD.ACC_ROUTING, RD.ID_BASE_ACCOUNT, RD.ID_EXTRA_ACCOUNT,
         RD.ID_AGENT_PROFILE, RD.ID_AGENT_ACCOUNT_RULE, rd.id_hotel
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :RD_DBKEY
  into   :id_reserv_detail, :id_person_profile, :id_acc_template_person,
         :acc_routing, :old_id_base_account, :old_id_extra_account,
         :id_agent_profile, :id_agent_account_rule, :id_hotel;

  id_agent_account_rule = nullif(:id_agent_account_rule, -1);
  /* --- new */
  execute procedure SETTING_GET_VALUE ('SEPARATE_ACCOUNTS_PER_PAYER', :id_hotel)
  returning_values (:IS_SEP_ACCOUNTS);

  NEW_ID_BASE_ACCOUNT = null; --:old_id_base_account;
  NEW_ID_EXTRA_ACCOUNT = null; --:old_id_extra_account;

  /* identify profiles for base and extra account */
  if (:ACC_ROUTING in ('MIXED')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else if (:ACC_ROUTING in ('AGENT')) then begin
    ID_BASE_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_AGENT_PROFILE;
  end else if (:ACC_ROUTING in ('FULL_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = null;
    IS_SEP_ACCOUNTS = 0;  -- never
  end else if (:ACC_ROUTING in ('PART_COMPLIMENTARY')) then begin
    if (:ID_AGENT_ACCOUNT_RULE is null) then
        exception BOOKING_EXCEPTION 'Complimentary is set but AGENT account is ' || coalesce(:ID_AGENT_ACCOUNT_RULE, 'null');
    ID_BASE_ACCOUNT_PROFILE = null;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    IS_SEP_ACCOUNTS = 1;  -- ever
  end else begin -- if (:acc_routing in ('GUEST', 'OWNER'))
    ID_BASE_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_EXTRA_ACCOUNT_PROFILE = :ID_PERSON_PROFILE;
    ID_AGENT_ACCOUNT_RULE = null;
  end

  execute procedure RES_ACCOUNTS_RECIEVE$INT (:ID_RESERV_DETAIL, :old_id_base_account, :old_id_extra_account,
          :id_agent_account_rule, :id_base_account_profile, :id_extra_account_profile, :id_person_profile,
          :id_acc_template_person, :is_sep_accounts)
  returning_values (:new_id_base_account, :new_id_extra_account);

--  if (:new_id_base_account is null) then exception WRONG_VALUE 'Invalid base account!';
--  if (:new_id_extra_account is null) then exception WRONG_VALUE 'Invalid extra account!';
  if ((:old_id_base_account is distinct from :new_id_base_account)
       or (:old_id_extra_account is distinct from :new_id_extra_account)) then
  begin
    update RESERV_DETAIL RD
    set    RD.ID_BASE_ACCOUNT = :new_id_base_account,
           RD.ID_EXTRA_ACCOUNT = :new_id_extra_account
    where  RD.RDB$DB_KEY = :RD_DBKEY;
    /* end --- */
    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
             --and G.CHECK_STATUS < 1
      into   :id_guest
    do begin
      execute procedure GUEST_REROUTE_POSTINGS$INT(:id_guest, :new_id_base_account, :new_id_extra_account);
    end

    -- Log account changes
    execute procedure RES_SAVE_ACCOUNTS_FINALIZE$INT(:id_reserv_detail, :old_id_base_account, :old_id_extra_account,
            :new_id_base_account, :new_id_extra_account);
  end

end
^

/* Alter (RES_SAVE_GUESTCOUNT$RSV) */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select rd.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  rd.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SAVE_GUESTCOUNT$INT(:rd_dbkey, :adult_count, :child_count);

  execute procedure RES_SAVE_ACCOUNTS$INT (:rd_dbkey);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 0)
  returning_values  :warn_code;

end
^

/* empty dependent procedure body */
/* Clear: RES_CHECKIN_MULTI$RSV for: RES_SPLIT$RSV */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT_MULTI$RSV for: RES_SPLIT$RSV */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SPLIT$RSV) */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
declare variable rd_dbkey_old char(8);
  declare variable rd_dbkey_new char(8);
  declare variable id_guest integer;
  declare variable warn_code integer;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;

  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable check_status integer;
  declare variable arrival_date date;
  declare variable departure_date date;
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable id_room_type integer;
  declare variable id_room integer;
  declare variable id_board integer;
  declare variable id_tariff integer;
  declare variable custom_price numeric(15,4);
  declare variable custom_currency char(3);
  declare variable voucher_num varchar(30);
  declare variable voucher_date date;
  declare variable voucher_text varchar(30);
  declare variable voucher2_num varchar(30);
  declare variable voucher2_date date;
  declare variable transfer_in_time time;
  declare variable transfer_in_note varchar(255);
  declare variable transfer_out_time time;
  declare variable transfer_out_note varchar(255);
  declare variable comming_kind integer;
  declare variable is_late_departure integer;
  declare variable is_vip integer;
  declare variable country_code varchar(20);
  declare variable code_first_food tfood_code;
  declare variable i_special_treatment varchar(255);
  declare variable id_nom_market_segment integer;
  declare variable id_nom_source_code integer;
  declare variable id_nom_channel_code integer;
  declare variable id_nom_hear_reason integer;
  declare variable id_nom_come_reason integer;
  declare variable id_agent_account integer;
  declare variable acc_routing varchar(50);
  declare variable id_person_payment integer;
  declare variable id_agent_payment integer;
  declare variable room_features blob sub_type 1 segment size 80;
  declare variable id_hk_plan integer;
  declare variable id_group integer;
  declare variable id_hotel integer;
  declare variable note varchar(2000);
  declare variable note_reminders varchar(50);
  declare variable guarantee_deposit numeric(15,4);
  declare variable guarantee_currency char(3);
  declare variable id_titular integer;
  declare variable id_profile_data integer;
  declare variable id_acc_template_person integer;
  declare variable number_1 varchar(20);
  declare variable number_2 varchar(20);
  declare variable new_res_number varchar(62);
  declare variable g_dbkey char(8);
  declare variable is_child integer;
  declare variable id_guarantee_policy integer;
  declare variable block_cc varchar(255);
  declare variable virtual_room varchar(10);
  declare variable err_text varchar(255);
  declare variable is_posting_stopped integer;
  declare variable id_eating_object integer;
begin
  select RD.RDB$DB_KEY, RD.ID_AGENT_PROFILE, RD.CHECK_STATUS, RD.FROM_DATE, RD.TO_DATE,
         RD.ADULT_COUNT, RD.CHILD_COUNT, RD.ID_ROOM_TYPE, RD.ID_ROOM, RD.ID_BOARD, RD.ID_RATE,
         RD.CUSTOM_PRICE, RD.CUSTOM_CURRENCY, RD.VAUCHER_NUM, RD.VAUCHER_DATE, RD.VAUCHER_TEXT, RD.VAUCHER_NUM2,
         RD.VAUCHER_DATE2, RD.TRANSFER_IN_TIME, RD.TRANSFER_IN_NOTE, RD.TRANSFER_OUT_TIME, RD.TRANSFER_OUT_NOTE,
         RD.COMMING_KIND, RD.LEAVING_KIND - 1, RD.IS_VIP, RD.COUNTRY, RD.CODE_FIRST_FOOD, RD.I_SPECIAL_TREATMENT,
         RD.ID_NOM_MARKET_SEGMENT, RD.ID_NOM_SOURCE_CODE, RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_HEAR_REASON,
         RD.ID_NOM_COME_REASON, RD.ID_AGENT_ACCOUNT_RULE, RD.ACC_ROUTING, RD.ID_PERSON_PAYMENT, RD.ID_AGENT_PAYMENT,
         RD.ROOM_FEATURES, RD.ID_HK_PLAN, RD.ID_GROUP, RD.ID_HOTEL, RD.NOTE, RD.NOTE_REMINDERS,
         RD.GUARANTEE_DEPOSIT, RD.GUARANTEE_CURRENCY, RD.ID_ACC_TEMPLATE_PERSON,
         RD.NUMBER_1, rd.NUMBER_2, rd.ID_GUARANTEE_POLICY, rd.BLOCK_CC, rd.IS_POSTING_STOPPED, rd.ID_EATING_OBJECT
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail_source
  into   :rd_dbkey_old, :id_agent_profile, :check_status, :arrival_date, :departure_date,
         :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff,
         :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
         :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
         :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
         :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
         :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
         :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
         :guarantee_deposit, :guarantee_currency, :id_acc_template_person,
         :number_1, :number_2,:id_guarantee_policy, :block_cc, :is_posting_stopped, :id_eating_object;

  select first 1 sp.ITEM
  from   SYSTEM_STRING_PARSER(:guest_ids, ',') sp
  into   :id_titular;

  select min(g.FROM_DATE), max(g.TO_DATE)
  from   GUEST G
  where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL_SOURCE
         and ','||:GUEST_IDS||',' containing ','||g.ID_GUEST||','
  into   :arrival_date, :departure_date;

  if (exists (select *
              from   RESERV_DETAIL RD
              where  RD.ID_TITULAR = :id_titular
                     and RD.ID_RESERV_DETAIL = :id_reserv_detail_source))
  then exception BOOKING_EXCEPTION 'Titular can not be splited in new reservation';

  execute procedure RES_GET_PERSON_PROFILE$INT(:id_titular)
  returning_values  :id_person_profile, :id_profile_data;

  new_res_number = iif(coalesce(:number_1,'')='','.',:number_1||'.')
                   || coalesce(:number_2, '')
                   || '.0';  -- fictive suffix, needed for unique constraint limitation, that will be replaced with real one


  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, :check_status, :arrival_date, :departure_date,
                    0, 0, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
                    :guarantee_deposit, :guarantee_currency, 0, null, :new_res_number, :id_acc_template_person,
                    :id_guarantee_policy, :block_cc, :id_eating_object)
  returning_values  :rd_dbkey_new, :new_id_reserv_detail, :warn_code;

  execute procedure RES_NUMBER_SUFFIX_GEN (:NEW_ID_RESERV_DETAIL)
  returning_values  (:new_res_number);  -- add suffix to new (splited) booking number (empty on create)

  update RESERV_DETAIL NR
  set    nr.IS_POSTING_STOPPED = :is_posting_stopped
  where  nr.RDB$DB_KEY = :rd_dbkey_new;

  -- there is no need guests deleting, because new splited reservation is created with 0 guests
  adult_count = 0; child_count = 0;
  for
    select G.ID_GUEST, G.RDB$DB_KEY, G.IS_CHILD
    from   SYSTEM_STRING_PARSER(:guest_ids, ',') SP
           join GUEST G on G.ID_GUEST = SP.ITEM
    into   :id_guest, :g_dbkey, :is_child
  do begin
    execute procedure GUEST_SET_EDIT_STATUS$INT (:g_dbkey, 'REBUILD', 'add');

    update GUEST G
    set    G.ID_RESERV_DETAIL = :new_id_reserv_detail
    where  G.ID_GUEST = :id_guest;

    adult_count = :adult_count + (1-:is_child);
    child_count = :child_count + :is_child;

    if (:id_guest = :id_titular) then begin
      update RESERV_DETAIL RD
      set    RD.ID_TITULAR = :id_titular
      where  RD.RDB$DB_KEY = :rd_dbkey_new;

      update GUEST_DATA GD
      set    GD.ID_PERSON_DATA = :id_profile_data
      where  GD.ID_GUEST = :id_titular;
    end
  end

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL_SOURCE, 'RES_SPLIT',
          f_character(29) || :new_res_number || f_character(28) || :adult_count || ' + ' || :child_count);

  -- calling RES_SAVE_PROFILING$INT is unnecessary, it is called into RES_CREATE_SET$INT with same params
  -- here is needed to set reserv accounts per splited guests and reroute posting only (accomplished in next procedure)
  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey_new);

  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_old);
  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_new);

  update RESERV_DETAIL ORD
  set    ord.ROOM_PRICE = null
  where  ord.RDB$DB_KEY = :rd_dbkey_old;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_old, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_new, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  if (:id_room < 0) then begin
    virtual_room = gen_id(GEN_VIRTUAL_ROOM, 1);
    update RESERV_DETAIL RD
    set    rd.VIRTUAL_ROOM = '<'||:virtual_room||'>'
    where  rd.ID_ROOM = :id_room;
  end
end
^

/* Alter (RES_SPLIT_MULTI$RSV) */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
begin
  for
    select RD.ID_RESERV_DETAIL, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :id_reserv_detail, :id_titular
  do begin
    for
      select G.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.ID_GUEST <> :id_titular
      into   :id_guest
    do begin
      execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
      returning_values  :id_splited_reservation;

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_RECALC$INT for: RES_TAR_CALC_FINALIZE$INT */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_TAR_CALC_FINALIZE$INT) */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(ID_TAR_CALC INTEGER,
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
declare variable old_room_price numeric(15,4);
  declare variable old_room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
  declare variable reserv_posting_disabled smallint;
  declare variable postings_disabled smallint;
  declare variable warn_code integer;
  declare variable action_text varchar(255);
begin
  --  Razpiswa cenata na staia, kakto i price_detailite.

  execute procedure TAR_CALC_EVAL_ALL$INT(:ID_TAR_CALC)
  returning_values  :ERR_CODE, :ERR_TEXT;

  if (:ERR_CODE = 0) then execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

  select iif(si.INFO_VALUE = '1', 1, null)
  from   SYSTEM_INFO_GET('RESERV_POSTINGS_DISABLED') si
  into   :postings_disabled;

  for
    select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, coalesce(:postings_disabled, rd.IS_POSTING_STOPPED),
           coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
           coalesce(max((select first 1 AP.IS_BASE
                         from   GUEST G
                                join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                         where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (it`s possible)
    from   TAR_CALC_INPUT$TMP TI
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
           join TARIFA t on t.ID_TARIFA = rd.ID_RATE
    where  ti.ID_TAR_CALC = :ID_TAR_CALC
    group by 1, 2, 3, 4, 5, 6
    into   :id_reserv_detail, :check_status, :is_posting_stopped,
           :room_currency, :id_hotel, :is_anul, :has_postings
  do begin
    reserv_posting_disabled = iif(:is_posting_stopped = 1 and :has_postings = 0, 1, 0);

    if (:ERR_CODE <> 0) then begin
      -- price calculation error handling  !!!!!
      if (:reserv_posting_disabled = 1) then begin
        -- set price to null, posting is disabled
        update RESERV_DETAIL RD
        set    RD.ROOM_PRICE = null,
               RD.ROOM_CURRENCY = null,
               RD.ROOM_PRICE_DETAILS = null,
               RD.LAST_ID_TAR_CALC = null
        where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
      end else begin
        -- exit on error in price calculation - cannot make valid posts
        EXIT;
      end
    end else begin
      room_price = 0;
      room_price_details = '';
    
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);
  
      if (:reserv_posting_disabled = 0 and ((coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1))) then begin
        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);
      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;
  
        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end
  
      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc,
             rd.ROOM_PRICE_LAST$INT = null,
             rd.ROOM_CURRENCY_LAST$INT = null
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail
      returning old.ROOM_PRICE_LAST$INT, old.ROOM_CURRENCY_LAST$INT
      into :old_room_price, :old_room_currency;

      if ((:old_room_price is distinct from :room_price)
          or (:old_room_currency is distinct from :room_currency) ) then
      begin
        action_text = f_character(29) || formatfloat(:old_room_price, 'F;0.00') || ' ' || coalesce(:old_room_currency, '') || f_character(28) || formatfloat(:room_price, 'F;0.00') || ' ' || coalesce(:room_currency, '');
        execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_PRICE_RECALC', :action_text);
      end
    end
  end

  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;

  if (:ERR_CODE <> 0) then begin
    execute procedure SYSTEM_WARNING_ADD(:ERR_CODE, :ERR_TEXT)
    returning_values :warn_code;
    ERR_CODE = 0;
    ERR_TEXT='';
  end
end
^

/* empty dependent procedure body */
/* Clear: SAFE_CHECK_OUT for: SAFE_OCCUPANCY_MODIFY */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE /* TYPE OF ID */ INTEGER)
 RETURNS(DOC_SELECTED /* TYPE OF ID_REF */ INTEGER,
WARN_CODE /* TYPE OF ID_REF */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (SAFE_OCCUPANCY_MODIFY) */
ALTER PROCEDURE SAFE_OCCUPANCY_MODIFY(ID_SAFE TYPE OF ID,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME)
 RETURNS(DOC_SELECTED TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable old_booking_number tres_number;
  declare variable id_resource_reservation id_ref;
  declare variable from_datetime tdatetime;
  declare variable action_text tdescription_long;
  declare variable old_occupant varchar(100);
  declare variable old_to_dt timestamp;
  declare variable id_reserv_detail integer;
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation;

  select rr.BOOKING_NUMBER, od.FROM_DATETIME,
         RR.OCCUPANT_NAME, od.TO_DATETIME, rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESOURCE_RESERVATION rr
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         left outer join RESERV_DETAIL rd on rd.NUMBER = rr.BOOKING_NUMBER and rd.IS_ANUL = 0
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation
  into   :old_booking_number, :from_datetime,
         :old_occupant, :old_to_dt, :id_reserv_detail, :id_agent_profile;

  --if (:old_booking_number <> :BOOKING_NUMBER) then exception ASSERT 'Can not change booking number!';
  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  update SAFE_RESOURCE_RESERV rr
  set    rr.PRICE_DESCRIPTION = :price_description,
         rr.ID_RATE_PRICE_PROFILE = :id_agent_profile,
         rr.RATING_UNITS = :rating_units,
         rr.RATE_PRICE = :price,
         rr.RATE_CURR = :currency
  where  rr.ID_RESOURCE_RESERV = :id_resource_reservation;

  execute procedure RESOURCE_RESERVATION_MODIFY (:id_resource_reservation, :ID_SAFE, :from_datetime,
          :TO_DATETIME, :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :old_booking_number, 'mod')
  returning_values :id_resource_reservation, :no_use;

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail)
  returning_values (:DOC_SELECTED);

  /* Log changes */
  if ((:old_occupant <> :OCCUPANT_NAME) or (:old_to_dt <> :TO_DATETIME)) then begin
    action_text = f_character(29) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                  || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                  || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');
  
    execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUP_CHANGED', :action_text);
  end
end
^

/* Alter (SAFE_OCCUPANCY_NEW) */
ALTER PROCEDURE SAFE_OCCUPANCY_NEW(ID_SAFE TYPE OF ID,
FROM_DATETIME TDATETIME,
TO_DATETIME TYPE OF TDATETIME,
OCCUPANT_NAME TYPE OF TPERSON_NAME,
BOOKING_NUMBER TYPE OF TRES_NUMBER,
ID_EXTERNAL_CLIENT_ACCCOUNT TYPE OF ID_REF)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
ID_RESOURCE_RESERVATION TYPE OF ID_REF)
 AS
declare variable id_service id_ref;
  declare variable id_save_type id_ref;
  declare variable no_use varchar(255);
  declare variable id_agent_profile id_ref;
  declare variable price_description tdescription_long;
  declare variable price tprice;
  declare variable currency tcurrency;
  declare variable rating_units tqty;
  declare variable action_text tdescription_long;
  declare variable id_reserv_detail integer;
  declare variable safe_name varchar(50);
begin
  if (:TO_DATETIME < current_timestamp) then exception ASSERT '-1065';

  select s.ID_SAFE_TYPE, s.ID_CURRENT_OCCUPANCY, s.SAFE_NAME
  from   SAFES S
  where  s.ID_SAFE = :ID_SAFE
  into   :id_save_type, :id_resource_reservation, :safe_name;

  if (:id_resource_reservation is not null) then exception ASSERT '-1064'|| f_character(31) || f_character(29) || :safe_name;

  select rd.ID_RESERV_DETAIL,
         (select pa.ID_PROFILE from PROFILE_AGENT pa where pa.ID_PROFILE = rd.ID_AGENT_PROFILE)
  from   RESERV_DETAIL rd
  where  rd.NUMBER = :BOOKING_NUMBER
         and rd.IS_ANUL = 0
  into   :id_reserv_detail, :id_agent_profile;

  execute procedure SAFE_USAGE_RATING (:id_save_type, :from_datetime, :TO_DATETIME, :id_agent_profile)
  returning_values (:id_service, :price, :currency, :rating_units, :price_description);

  execute procedure  RESOURCE_RESERVATION_MODIFY (null, :ID_SAFE, :FROM_DATETIME, :TO_DATETIME,
          :OCCUPANT_NAME, :id_service, null, 0, null, 0, 0, :BOOKING_NUMBER, 'add')
  returning_values (:id_resource_reservation, :no_use) ;

  insert into SAFE_RESOURCE_RESERV (ID_RESOURCE_RESERV, PRICE_DESCRIPTION, ID_RATE_PRICE_PROFILE,
         RATING_UNITS, RATE_PRICE, RATE_CURR)
  values (:id_resource_reservation, :price_description, :id_agent_profile,
         :rating_units, :price, :currency);

  execute procedure SAFE_OCCUPANCY_POSTING$INT (:id_resource_reservation, :id_service, :price, :currency,
          :price_description, :id_reserv_detail, :ID_EXTERNAL_CLIENT_ACCCOUNT)
  returning_values (:DOC_SELECTED);

  update RESOURCE_RESERVATION RR
  set    RR.STATUS = 'CHECKED_IN'
  where  RR.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = :id_resource_reservation
  where  s.ID_SAFE = :ID_SAFE;

  action_text = f_character(29) || formatdate(:from_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || formatdate(:to_datetime, 'D;dd/mm/yyyy hh:mm')
                || f_character(28) || coalesce(:OCCUPANT_NAME, '')
                || f_character(28) || coalesce(:BOOKING_NUMBER, '')
                || f_character(28) || coalesce(formatfloat(:price, 'F;0.00') || ' ' || :currency, '');

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_OCCUPIED', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_INPUT_PARAMS$INT for: TAR_CALC_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_PARAMS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_PARAMS$INT) */
ALTER PROCEDURE TAR_CALC_PARAMS$INT(ID_RATE INTEGER,
ID_TAR_INPUT INTEGER,
ID_TAR_CALC INTEGER,
FOR_DATE DATE,
RATE_LIST_REPLACE VARCHAR(2000) = '')
 RETURNS(ERR_CODE INTEGER,
PARAM_VALUES VARCHAR(2000))
 AS
declare variable param_code varchar(40);
  declare variable id_param integer;
  declare variable param_value varchar(255);
  declare variable data_type  varchar(30);
  declare variable rate_list varchar(2000);
begin
  err_code = 0;
  param_values = '';

  if (coalesce(:rate_list_replace, '') = '') then rate_list = ',' || :id_rate || ',';
  else rate_list = :rate_list_replace;

  for
    select distinct TBP.PARAM_NAME
    from   SYSTEM_STRING_PARSER (:rate_list, ',') sp
           left join TAR_BO_PARAMS TBP on TBP.ID_TAR_HEAD = sp.ITEM
    where  (TBP.PARAM_TYPE <> 'DATE_DEPENDANT' and :for_date is null)
           or (TBP.PARAM_TYPE = 'DATE_DEPENDANT' and :for_date is not null)
    into   :param_code
  do begin
    if (:param_code is not null) then begin
      id_param = null;
      select TP.ID_TARIFA_PARAM, TP.DATA_TYPE
      from   TARIFA_PARAMS TP
      where  TP.PARAM_CODE = :param_code
             and tp.IS_USE = 1
      into   :id_param, :data_type;
  
      if (:id_param is null) then begin
        err_code = -202;
        execute procedure sys_dbg ('tar calc params err_code: ' || :err_code || F_CRLF() || 'PARAM_CODE = ' || :param_code);
        exit;
      end
  
      execute procedure TARIFA_GET_PARAM (:id_param, :for_date, :id_tar_input, :id_tar_calc)
      returning_values (:param_value);
  
      param_code = ':'||param_code;
  
      if ((:param_code is not null) and (:param_code is not null) and (:data_type is not null)) then
         param_values = :param_values||';'||:param_code||','||:data_type||','||:param_value;
    end
  end
end
^

/* Restore proc. body: ACCOUNT_POST_MODIFY$PMS */
ALTER PROCEDURE ACCOUNT_POST_MODIFY$PMS(ID_PMS_EVENT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_ACCOUNT_POST_PMS INTEGER,
IN_VALUE_ORIG NUMERIC(15,4),
IN_CURR_ORIG VARCHAR(3),
OPERATION VARCHAR(20))
 AS
declare variable id_account integer;
  declare variable id_service integer;
  declare variable date_post date;
  declare variable is_owner_income smallint;
  declare variable is_account_post_item smallint;
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable no_use_id_acc_post integer;
  declare variable ap_dbkey char(8);
begin
  -- da se wika samo ot GUI
  if ( (:ID_ACCOUNT_POST is null) and (:ID_ACCOUNT_POST_PMS is null) ) then begin
    exception WRONG_PARAM_VALUE;
    exit;
  end

  is_account_post_item = iif(:id_account_post is not null, 1, 0);

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'mod, anul');

  if (:operation in ('mod', 'anul')) then begin
    -- prowerka: ot GUI-to mogat da se anulirat samo nedokumentirani i neanulirani nachisleniq
    if (:is_account_post_item = 1) then begin
      if ( (:ID_PMS_EVENT > 0) and
           not exists ( select *
                        from   PMS_EVENT_POST PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      select ap.RDB$DB_KEY
      from   ACCOUNT_POST AP
      where  ap.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
      into   :ap_dbkey;

      execute procedure ACCOUNT_POSTING_ANUL$INT(:ap_dbkey, 'PMS GUI VOID');

      update PMS_EVENT_POST PP
      set    PP.LINE_STATUS = 22
      where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST;

    end else if (:ID_ACCOUNT_POST_PMS is not null) then begin
      if ( not exists ( select *
                        from   ACCOUNT_POST$PMS PP
                        where  PP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
                          and PP.LINE_STATUS = 11
                      ) ) then
      begin
        exception PMS_EXCEPTION '-620';
      end
      execute procedure ACCOUNT_POST_PMS_ANUL$INT(:ID_PMS_EVENT, :ID_ACCOUNT_POST_PMS);
    end

    if (:operation = 'mod') then begin
      id_account = null;
      if (:is_account_post_item = 1) then begin
        select AP.ID_ACCOUNT, AP.ID_SERVICE, AP.DATE_POST, PP.ID_OWNER, 0, ap.id_room
        from   ACCOUNT_POST AP
               join PMS_EVENT_POST PP on PP.ID_ACCOUNT_POST = AP.ID_ACCOUNT_POST
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST
               and PP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :id_owner, :is_owner_income, :id_room;
      end else begin
        select AP.ID_ACCOUNT_PMS, AP.ID_SERVICE, AP.DATE_POST, AP.IS_OWNER_INCOME, AP.ID_OWNER
        from   ACCOUNT_POST$PMS AP
        where  AP.ID_ACCOUNT_POST = :ID_ACCOUNT_POST_PMS
               and AP.LINE_STATUS = 22 -- predi towa anuliraneto trqbwa da e minalo uspeshno!
        into   :id_account, :id_service, :date_post, :is_owner_income, :id_owner;
      end
      if (:id_account is null) then exit;

      execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_account, :id_service, :id_owner, :date_post,
              :in_curr_orig, :in_value_orig, 1 - :is_account_post_item, :is_owner_income, :id_room)
      returning_values :no_use_id_acc_post;
    end
  end
end
^

/* Restore proc. body: ACCOUNT_POSTING_TRANSFER$ACC */
ALTER PROCEDURE ACCOUNT_POSTING_TRANSFER$ACC(DOC_SELECTED INTEGER,
ID_DEST_ACCOUNT INTEGER,
ID_SRC_ACCOUNT INTEGER = null)
 AS
declare variable ap_dbkey char(8);
  declare variable transfer_value double precision;
  declare variable post_value double precision;
  declare variable id_account integer;
  declare variable tmp_id_account integer;
  declare variable curr_post varchar(3);
  declare variable acc_name varchar(50);
  declare variable action_text varchar(255);
  declare variable is_pms_account integer;
  declare variable dest_acc_name varchar(50);
begin

  id_account = null;
  transfer_value = 0;

  select ACC.ACCOUNT_NAME, acc.IS_PMS_ACCOUNT
  from   ACCOUNT ACC
  where  ACC.ID_ACCOUNT = :ID_DEST_ACCOUNT
  into   :dest_acc_name, is_pms_account;

  if (:is_pms_account = 1) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('PMS_TRANSFER_POSTINGS');
  end

  for
    select AP.RDB$DB_KEY, AP.ID_ACCOUNT, ap.PRICE_POST * ap.QTY_POST
    from   ACCOUNT_POST AP
    where  AP.DOC_SELECTED = :DOC_SELECTED
           and AP.ID_ACCOUNT = coalesce(:ID_SRC_ACCOUNT, AP.ID_ACCOUNT)
           and AP.ID_ACCOUNT is distinct from :ID_DEST_ACCOUNT
    order by AP.ID_ACCOUNT asc
    into   :ap_dbkey, :tmp_id_account, :post_value
  do begin
    execute procedure ACCOUNT_POSTING_TRANSFER$INT (:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:id_account is null) then id_account = :tmp_id_account;

    /* update from/to pms account */
    execute procedure ACCOUNT_POST_EVENT_REROUTE$INT(:ap_dbkey, :ID_DEST_ACCOUNT);

    if (:tmp_id_account is distinct from :id_account) then begin
      select A.ACCOUNT_NAME, A.ACCOUNT_CURR
      from   ACCOUNT A
      where  A.ID_ACCOUNT = :id_account
      into   :acc_name, :curr_post;

      action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                    f_character(28) || :id_account || '/' || :acc_name ||
                    f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
      execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
      id_account = :tmp_id_account;
      transfer_value = 0;
    end
    transfer_value = :transfer_value + :post_value;
  end

  if (:id_account is not null) then begin
    select A.ACCOUNT_NAME, A.ACCOUNT_CURR
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :id_account
    into   :acc_name, :curr_post;
  
    action_text = f_character(29) || formatfloat(:transfer_value, 'F;0.00') || :curr_post ||
                  f_character(28) || :id_account || '/' || :acc_name ||
                  f_character(28) || :ID_DEST_ACCOUNT || '/' || :dest_acc_name;
    execute procedure SYSTEM_LOG_ADD ('ACCOUNT', :id_account, 'POST_TRANSFER', :action_text);
  end
end
^

/* Restore proc. body: AVAILABILITY_RATE_SMALL$WBE */
ALTER PROCEDURE AVAILABILITY_RATE_SMALL$WBE(FROM_DATE DATE,
TO_DATE DATE,
ID_HOTEL INTEGER,
ROOMS INTEGER,
ADULTS INTEGER,
CHILDREN INTEGER,
QUERY_ID INTEGER,
PROFILE_ID INTEGER)
 AS
declare variable id_room_type integer;
declare variable nonavaialbility_note varchar(255);
declare variable is_available smallint;
declare variable id_rate integer;
declare variable id_board integer;
declare variable roomtype_list varchar(2000);
declare variable rate_list varchar(2000);
declare variable board_list varchar(2000);
declare variable hotels varchar(255);
declare variable room_status integer;
declare variable rate_status integer;
declare variable rate_min_los integer;
declare variable rate_max_los integer;
declare variable id_channel integer;
declare variable helper_session_id integer;
declare variable error_check integer;
declare variable available_roomtype_list varchar(2000);
declare variable special_rate_list varchar(2000);
declare variable available_rooms integer;
declare variable is_public smallint;
begin
    
  /*Produces data in result table availabiliti_rate$wbe.
   Get availability as AVAILABILITY_OCCUP_SMALL$WBE see there for notes */

  /*empty WBE specific table*/
  delete from product_availability$wbe p
  where p.query_id = :query_id;

  /* find id_channel for wbe*/
  select max(c.id_channel), count(c.id_channel)  from channel c where c.name = 'WBE'
  into :id_channel, :error_check;
  if (not (:error_check = 1)) then  exception WRONG_VALUE 'Missing channel WBE or dublicated definition!';

  /*First check chennel management - find rates, room type for sale and restrictions*/
  special_rate_list = ',';
  available_roomtype_list = ',';
  helper_session_id =  gen_id(SELECTION_GEN, 1);
  for
    select c.id_room_type, c.id_tar_head, c.is_product_avaialable, c.room_status, c.rate_status,
           c.rate_min_los, c.rate_max_los, c.available_rooms, c.is_public
    from   channel_product_avail_req$int (:id_channel, :id_hotel, :from_date, :to_date, :rooms) c
    into   :id_room_type, :id_rate, :is_available, :room_status, :rate_status,
           :rate_min_los, :rate_max_los, :available_rooms, :is_public
  do begin
      /*make a list of available roomt types - needed for special rate product building*/
      if ((:room_status = 2) and (','|| :available_roomtype_list ||',' not containing ','|| :id_room_type ||',')) then
        available_roomtype_list = :available_roomtype_list || :id_room_type ||',';

      /*set nonavaialbility_note*/
      nonavaialbility_note = '';
      if (:is_available = 0) then begin
        if ((:room_status = 0) or (:room_status is null) ) then nonavaialbility_note = '@{No rooms available.} ';
        else begin
            if (:rate_status = 0) then nonavaialbility_note = nonavaialbility_note || '@{Rate is closed.} ';
            if (:rate_status = 1) then nonavaialbility_note = nonavaialbility_note || '@{Rate is closed for arrival.} ';
            if (:rate_status = 2 and :rate_min_los = :rate_max_los) then nonavaialbility_note = nonavaialbility_note || '@{Required stay} ' || rate_min_los || ' @{days.} ';
            if ((:rate_status = 2) and (:rate_min_los > 0) and (:rate_min_los is distinct from :rate_max_los)) then  nonavaialbility_note = nonavaialbility_note || '@{Minimum stay} ' || rate_min_los || ' @{days.} ';
            if ((:rate_status = 2) and (:rate_max_los > 0) and (:rate_min_los is distinct from :rate_max_los)) then  nonavaialbility_note = nonavaialbility_note || '@{Maximum stay} ' || rate_max_los || ' @{days.} ';
        end
      end

      /*insert status and note in int table for this product IF RATE IS PUBLIC or If it is Private but allowed in current profile. Supress 'closed' rate, but show closed for arrival, min los, etc.*/
      /* !! new behaviour - SPECIAL/PRIVATE rates must be managed from CHANNEL MANAGEMENT too */
      if (:rate_status <> 0) then begin
        if (:is_public = 1) then begin
          insert into product_availability$int (session_id, room_type_id, rate_id, is_available, nonavaialbility_note, available_rooms)
          values (:helper_session_id, :id_room_type, :id_rate, :is_available, :nonavaialbility_note, :available_rooms);
        end else begin /* If it is PRIVATE */
          if (exists ( select phr.id_tariff
                        from profile_hotel_rate phr
                        where phr.id_profile = :profile_id
                          and phr.id_hotel = :id_hotel
                          and phr.id_tariff = :id_rate )) then
          begin
              insert into product_availability$int (session_id, room_type_id, rate_id, is_available, nonavaialbility_note, available_rooms)
              values (:helper_session_id, :id_room_type, :id_rate, :is_available, :nonavaialbility_note, :available_rooms);
              /*Making special rate list for indicating in WBE GUI. Rate will be indicated as special if they are private */
              special_rate_list = :special_rate_list || :id_rate ||',';
          end
        end
      end

  end


  /* for available rates - make a rate list. */
  rate_list = ',';
  for
    select distinct pa.rate_id
    from   product_availability$int pa
    where  pa.session_id = :helper_session_id
      /*$$IBEC$$   and pa.is_available = 1 $$IBEC$$*/
    into :id_rate
  do begin
    rate_list = :rate_list || :id_rate || ',';
  end

  /* make a room type list from prepared int table*/
  ROOMTYPE_LIST = ',';
  for
    select distinct pa.room_type_id
    from product_availability$int pa
    where pa.session_id = :helper_session_id
       /*$$IBEC$$  and pa.is_available = 1 $$IBEC$$*/
    into :id_room_type
  do begin
    roomtype_list = :roomtype_list || :id_room_type || ',';
  end

  /* make a list of all boards. Rating will remove non used boards */
  --BOARD_LIST = ',0,'; -- without board
  BOARD_LIST = ',';
  for
    select th.ID_BOARD
    from   MEALS th
    where  th.IS_ARCHIVE = 0
           and th.IS_BOARD = 1
           and th.ID_HOTEL = :ID_HOTEL
           --and th.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
    into   :id_board
  do begin
    BOARD_LIST = :BOARD_LIST || coalesce(:id_board, 0) || ',';
  end

  hotels = ',' || :id_hotel ||',';

  execute procedure sys_dbg('wbe PARAMS FOR  availability_raiting_sub$int :');
  execute procedure sys_dbg('wbe -:helper_session_id = '|| :helper_session_id);
  execute procedure sys_dbg('wbe -:from_date = '|| :from_date);
  execute procedure sys_dbg('wbe -:to_date = '|| :to_date);
  execute procedure sys_dbg('wbe -:rooms = '|| :rooms);
  execute procedure sys_dbg('wbe -:adults = '|| :adults);
  execute procedure sys_dbg('wbe -:children = '|| :children);
  execute procedure sys_dbg('wbe -:roomtype_list = '|| :roomtype_list);
  execute procedure sys_dbg('wbe -:rate_list = '|| :rate_list);
  execute procedure sys_dbg('wbe -:board_list = '|| :board_list);
  execute procedure sys_dbg('wbe -:hotels = '|| :hotels  );
  execute procedure sys_dbg('wbe -:available_roomtype_list = '|| :available_roomtype_list );

  /*calc prices for request in TMP_AVAILABILITY */
  execute procedure AVAILABILITY_RATING_LOOP$INT (:helper_session_id,  :from_date, :to_date,
                    :rooms, :adults, :children, :roomtype_list, :rate_list, :board_list, :hotels);

  /*Copy data to WBE specific table*/
  insert into PRODUCT_AVAILABILITY$WBE
       (query_id, room_type_id, room_name, rate_id, rate_name, board_id, board_name,
       price_night, price_total, currency, is_available, nonavailability_note,
       is_special_rate, available_rooms)
  select :query_id, pa.room_type_id, rt.type_room, pa.rate_id, t.tarifa_name, ta.id_board, th.NAME,
        ta.price, ta.total_price, ta.currency, coalesce( pa.is_available, 0), pa.nonavaialbility_note,
        iif( ','|| :special_rate_list ||',' containing ','|| pa.rate_id ||',', 1, 0), pa.available_rooms
  from  PRODUCT_AVAILABILITY$INT pa /*left outer join*/
        join TMP_AVAILABILITY ta on pa.room_type_id = ta.id_room_type
                                    and pa.rate_id = ta.id_rate
                                    and pa.session_id = ta.ID_SESSION
        join ROOM_TYPES rt on rt.id_room_type =  ta.id_room_type
        join TARIFA t on t.id_tarifa = ta.id_rate
        join MEALS th on th.ID_BOARD = ta.id_board
  where pa.session_id = :helper_session_id;
        --and ta.id_board is not null; -- ???

/*Empty tmp_availability*/
  delete from TMP_AVAILABILITY ta
  where  ta.ID_SESSION = :helper_session_id;

  /*Empty helper in table product_availability$int*/
  delete from  PRODUCT_AVAILABILITY$INT p
  where p.session_id = :helper_session_id;

end
^

/* Restore proc. body: EAI_EXT_POST_TO_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable ID_HOTEL integer;
begin
  if (singular(select HS.ID_HOTEL
               from HOTEL_S HS
               where HS.IS_USE = 1)) then
    select H.ID_HOTEL
    from   HOTEL_S H
    where H.IS_USE = 1
    into   :id_hotel;
  else begin
    err_code = -1044;
    exit;
  end

  execute procedure EAI_EXT_POST_TO_MH_FRONT_ONLINE(:ID_HOTEL, :ROOM_NAME,
    :SERVICE_CODE, :CODE_TYPE, :QTY_POST, :PRICE_POST, :CURR_POST, :POST_TEXT)
  returning_values (:ERR_CODE, :ERR_TEXT, :ID_ROOM, :ID_GUEST, :GUEST_NAME1,
    :ID_ACCOUNT, :ID_ACCOUNT_POST, :ID_SERVICE);

end
^

/* Restore proc. body: EAI_POS_POSTING_ADD */
ALTER PROCEDURE EAI_POS_POSTING_ADD(IN_ON_GUEST INTEGER,
IN_ID_ACCOUNT INTEGER,
IN_ID_GUEST INTEGER,
IN_DATE_SMETKA TIMESTAMP,
IN_PRICE NUMERIC(15,2),
IN_DATETIME TIMESTAMP,
IN_OBJ_NAME VARCHAR(30),
IN_TABLE VARCHAR(5),
IN_SITE VARCHAR(5),
IN_SMETKA_NUM VARCHAR(20),
IN_POS_USER VARCHAR(50),
IN_ID_SMETKA VARCHAR(50),
IN_SERVICE_TAG VARCHAR(30),
IN_SERVICE_NAME VARCHAR(30))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
OUT_ID_ACCOUNT INTEGER)
 AS
begin
  -- used external inteface - for compatability with Front 2008
  execute procedure EAI_POS_POSTING_ADD$P2E (:IN_ON_GUEST, :IN_ID_ACCOUNT, :IN_ID_GUEST, :IN_DATE_SMETKA,
          :IN_PRICE, :IN_DATETIME, :IN_OBJ_NAME, :IN_TABLE, :IN_SITE, :IN_SMETKA_NUM, :IN_POS_USER,
          :IN_ID_SMETKA, :IN_SERVICE_TAG, :IN_SERVICE_NAME)
  returning_values (:ERR_CODE, :ERR_TEXT, :OUT_ID_ACCOUNT);

end
^

/* Restore proc. body: PMS_EXPENSE_POSTS_CREATE$INT */
ALTER PROCEDURE PMS_EXPENSE_POSTS_CREATE$INT(ID_ROOM TYPE OF ID,
ID_OWNER TYPE OF ID,
ID_RENTAL_POOL TYPE OF ID_REF,
ID_SERVICE TYPE OF ID,
ID_CURRENCY TYPE OF TCURRENCY,
POST_VALUE TYPE OF TPRICE,
IS_CLIENT_ACC_POST TYPE OF TLOGICAL,
MANUAL_POST_DATE TYPE OF TDATE,
DESCRIPTION TYPE OF TDESCRIPTION_LONG,
IS_POST_PER_POOL TYPE OF TLOGICAL)
 RETURNS(NEW_ID_ACCOUNT_POST ID_REF,
NEW_ID_ACCOUNT_POST$PMS ID_REF)
 AS
declare variable event_type varchar(30);
  declare variable id_room_contract integer;
  declare variable new_id_pms_event integer;
  declare variable round_to_orig numeric(15,6);
  declare variable ownership_percent numeric(15,4);
  declare variable curr_contract_owner integer;
  declare variable curr_total_ownership numeric(15,4);
  declare variable curr_total_value numeric(15,4);
  declare variable percent_value numeric(15,4);
  declare variable id_account integer;
  declare variable id_hotel integer;
  declare variable is_account$pms integer;
  declare variable id_acc_post integer;
BEGIN
  event_type = 'MANUAL_EXPENSE';
  curr_total_value = 0;
  curr_total_ownership = 0;

  select RC.ID_ROOM_CONTRACT, r.ID_HOTEL
  from   ROOM_CONTRACT$PMS RC
         join ROOM_PERIOD$PMS P on RC.ID_ROOM_PERIOD = P.ID_ROOM_PERIOD
         join ROOMS R on R.ID_ROOM = p.ID_ROOM
  where  :MANUAL_POST_DATE between P.FROM_DATE and P.TO_DATE
         and P.ID_ROOM = :ID_ROOM
         and P.STATUS in ('PRIVATE','CONTRACT')
  into   :id_room_contract, :id_hotel;

  if (:ID_ROOM_CONTRACT is null) then exception PMS_EXCEPTION '-615';

  execute procedure PMS_EVENT_CREATE$INT(:EVENT_TYPE, :ID_ROOM, :ID_OWNER, :DESCRIPTION,
          :MANUAL_POST_DATE, null, null, null, null, :POST_VALUE, :POST_VALUE, :ID_CURRENCY, null, :id_room_contract)
  returning_values :new_id_pms_event;

  select C.ROUND_TO
  from   CURRS C
  where  C.CURR = :ID_CURRENCY
  into   :round_to_orig;

  for
    select iif(:ID_OWNER is null, O.OWNERSHIP_PERCENT, 100), O.ID_OWNER
    from   ROOM_CONTRACT$PMS RC
           join ROOM_OWNER$PMS O on O.ID_ROOM_CONTRACT = RC.ID_ROOM_CONTRACT
    where  RC.ID_ROOM_CONTRACT = :id_room_contract
           and ((:ID_OWNER is null) or (O.ID_OWNER = :ID_OWNER))
    into   :ownership_percent, :curr_contract_owner
  do begin
    curr_total_ownership = :curr_total_ownership + :ownership_percent;
    if (:curr_total_ownership = 100) then begin
      percent_value = :post_value - :curr_total_value;
    end else
      percent_value = round_f(:post_value * :ownership_percent / 100, :round_to_orig);

    curr_total_value = :curr_total_value + :percent_value;

    execute procedure OWNER_ACCOUNT_GET$INT (iif(:is_post_per_pool = 1, :id_rental_pool, :curr_contract_owner),
            :id_hotel, 0, :IS_CLIENT_ACC_POST)
    returning_values (:id_account, :is_account$pms);

    execute procedure PMS_POSTING_CREATE$INT(:new_id_pms_event, :ID_ACCOUNT, :ID_SERVICE,
            :curr_contract_owner, :MANUAL_POST_DATE, :ID_CURRENCY, :PERCENT_VALUE, :is_account$pms, 0, :ID_ROOM)
    returning_values :id_acc_post;

    new_id_account_post = null;
    new_id_account_post$pms = null;

    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 1)) then new_id_account_post$pms = :id_acc_post;
    if ((coalesce(:id_account, '') <> '') and (coalesce(:is_account$pms, -1) = 0)) then new_id_account_post = :id_acc_post;
    suspend;
  end

  execute procedure PMS_EVENT_SET_ACTIVE$INT(:new_id_pms_event);
END
^

/* Restore proc. body: PMS_POOL_DISTRIBUTION_SUB */
ALTER PROCEDURE PMS_POOL_DISTRIBUTION_SUB(ID_RENTAL_POOL INTEGER,
ID_POOL_ACCOUNT INTEGER,
IS_ROOM_POOL SMALLINT,
ID_ROOM_PARAM INTEGER,
TOTAL_VALUE_PER_SERVICE NUMERIC(15,4),
ID_SERVICE INTEGER,
CURR VARCHAR(3),
IS_OWNER_INCOME SMALLINT,
FOR_DATE DATE,
IS_ACC_POST_ITEM SMALLINT)
 AS
declare variable cnt_room smallint;
  declare variable curr_total_posted numeric(15,4);
  declare variable cnt integer;
  declare variable value_to_post numeric(15,4);
  declare variable value_to_post_per_owner numeric(15,4);
  declare variable id_owner integer;
  declare variable id_room integer;
  declare variable id_room_contract integer;
  declare variable id_owner_account integer;
  declare variable id_pms_event integer;
  declare variable id_hotel integer;
  declare variable is_account$pms smallint;
  declare variable no_use_id_acc_post integer;
  declare variable round_to numeric(15,4);
begin
  select c.ROUND_TO
  from   CURRS c
  where  c.CURR = :CURR
  into   :round_to;

  cnt_room = 0;
  select count(distinct RP.ID_ROOM)
  from   ROOM_PERIOD$PMS RP
         join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
  where  RC.ID_RENTAL_POOL = :id_rental_pool
         and RP.STATUS in ('PRIVATE','CONTRACT')
         and RP.FROM_DATE <= :FOR_DATE
         and RP.TO_DATE >= :FOR_DATE
  into   :cnt_room;

  if (:cnt_room = 0) then exception PMS_EXCEPTION 'The pool has not assigned room contracts for selected date (' || :FOR_DATE || ') !';

  if (:is_room_pool = 1) then begin
    curr_total_posted = 0;
    cnt = 0;
    id_pms_event = null;
    id_hotel = null;
    for
      select distinct RP.ID_ROOM, RC.ID_ROOM_CONTRACT, R.ID_HOTEL
      from   ROOM_PERIOD$PMS RP
             join ROOMS R on R.ID_ROOM = RP.ID_ROOM
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.FROM_DATE <= :FOR_DATE
             and RP.TO_DATE >= :FOR_DATE
      into   :id_room, :id_room_contract, :id_hotel
    do begin
      id_pms_event = null;

      select E.ID_PMS_EVENT
      from   PMS_EVENT$PMS E
      where  E.ID_ROOM = :id_room
             and E.ID_SESSION = current_transaction
      into   :ID_PMS_EVENT;

      if (:ID_PMS_EVENT is null) then begin
        execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, :id_room_contract)
        returning_values :id_pms_event;
        -- FIXME nakraq da se update total_event_value
      end
      if (:cnt_room - :cnt = 1) then begin
        value_to_post = :TOTAL_VALUE_PER_SERVICE - :curr_total_posted;
      end else begin
        value_to_post = round_f(:TOTAL_VALUE_PER_SERVICE / :cnt_room, :round_to);
      end

      curr_total_posted = :curr_total_posted + :value_to_post;
      cnt = :cnt + 1;

      /* ...i se razpredelq mejdu sobstwenicite na staqta */
      value_to_post = abs(:value_to_post);
      for
        select R.ID_OWNER, R.OUT_VALUE
        from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
        into   :id_owner, :value_to_post_per_owner
      do begin
        /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_pool_account,
                :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                1, :IS_OWNER_INCOME, :id_room)
        returning_values :no_use_id_acc_post;
        /* ... i se nachislqwa po sobswtenik */
        execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
        returning_values (:id_owner_account, :is_account$pms);

        execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                :is_account$pms, :is_owner_income, :id_room)
        returning_values :no_use_id_acc_post;
      end
    end
  end else begin
    /* distribution by room_param */
    insert into TMP_SELECT$PMS(ID_SESSION, ID_ROOM, ID_OWNER)
    select distinct current_transaction, RP.ID_ROOM, null
    from   ROOM_PERIOD$PMS RP
           join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
    where  RC.ID_RENTAL_POOL = :ID_RENTAL_POOL
           and RP.STATUS in ('PRIVATE','CONTRACT')
           and RP.FROM_DATE <= :FOR_DATE
           and RP.TO_DATE >= :FOR_DATE;

    id_hotel = null;
    for
      select P.OUT_VALUE, P.OUT_ID_ROOM, R.ID_HOTEL
      from   PMS_CALC_VALUE_BY_PARAM(:ID_ROOM_PARAM, :TOTAL_VALUE_PER_SERVICE, :round_to) P
             join ROOMS R on R.ID_ROOM = P.OUT_ID_ROOM
      into   :value_to_post, :id_room, :id_hotel
    do begin
      id_pms_event = null;
      id_room_contract = null;
      -- room contract must be only one for this period
      select RC.ID_ROOM_CONTRACT
      from   ROOM_PERIOD$PMS RP
             join ROOM_CONTRACT$PMS RC on RC.ID_ROOM_PERIOD = RP.ID_ROOM_PERIOD
      where  RC.ID_RENTAL_POOL = :id_rental_pool
             and RP.STATUS in ('PRIVATE','CONTRACT')
             and RP.ID_ROOM = :id_room
             and :for_date between RP.FROM_DATE and RP.TO_DATE
      into   :id_room_contract;

      if (:id_room_contract is not null) then begin
        select E.ID_PMS_EVENT
        from   PMS_EVENT$PMS E
        where  E.ID_ROOM = :id_room
               and E.ID_SESSION = current_transaction
        into   :ID_PMS_EVENT;
  
        if (:ID_PMS_EVENT is null) then begin
          execute procedure PMS_EVENT_CREATE$INT('POOL_DISTRIBUTION', :id_room, :ID_RENTAL_POOL,
                  'POOL DISTRIBUTION', :FOR_DATE, null, null, null, null, 0, 0, :CURR, null, id_room_contract)
          returning_values :id_pms_event;
          -- FIXME nakraq da se update total_event_value
        end
  
        /* ...i se razpredelq mejdu sobstwenicite na staqta */
        for
          select R.ID_OWNER, R.OUT_VALUE
          from   ROOM_OWNERS_VALUE_DISTRIBUTE(:id_room_contract, :value_to_post, :round_to) R
          into   :id_owner, :value_to_post_per_owner
        do begin
          /* stojnostta na service-a za razpredelenie se maha ot smetkata na pool-a... */
          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :ID_POOL_ACCOUNT,
                  :id_service, :id_rental_pool, :FOR_DATE, :CURR, (-1)*:value_to_post_per_owner,
                  1, :IS_OWNER_INCOME, :id_room)
          returning_values :no_use_id_acc_post;
  
          /* ... i se nachislqwa po sobswtenik */
          execute procedure OWNER_ACCOUNT_GET$INT (:id_owner, :id_hotel, 0, :IS_ACC_POST_ITEM)
          returning_values (:id_owner_account, :is_account$pms);

          execute procedure PMS_POSTING_CREATE$INT(:id_pms_event, :id_owner_account,
                  :id_service, :id_owner, :FOR_DATE, :CURR, :value_to_post_per_owner,
                  :is_account$pms, :is_owner_income, :id_room)
          returning_values :no_use_id_acc_post;
        end
      end
    end

    delete from TMP_SELECT$PMS T
    where  T.ID_SESSION = current_transaction;
  end
end
^

/* Restore proc. body: RES_CHECKIN_MULTI$RSV */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable checkin_count integer;
  declare variable split_on_checkin integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
  declare variable tmp_warn_code integer;
begin
  checkin_count = 0;
  warn_code = null;
  for
    select RD.ID_RESERV_DETAIL, RD.CHECK_STATUS, RD.SPLIT_ON_CHECKIN, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :SELECTION_ID
    into   :id_reserv_detail, :check_status, :split_on_checkin, :id_titular
  do begin
    if (:check_status >= 0) then begin
      checkin_count = :checkin_count + 1;
    end else begin
      if (:split_on_checkin = 1) then begin
        for
          select G.ID_GUEST
          from   GUEST G
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and G.ID_GUEST <> :id_titular
          into   :id_guest
        do begin
          execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
          returning_values  :id_splited_reservation;

          execute procedure RES_CHECKIN$RSV (:id_splited_reservation)
          returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

          update RESERV_DETAIL RD
          set    RD.SELECTION_ID = :selection_id
          where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
        end
      end

      execute procedure RES_CHECKIN$RSV (:id_reserv_detail)
      returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
      WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end

  if (:checkin_count > 0) then begin
    execute procedure SYSTEM_WARNING_ADD(-1011, f_character(29)||:checkin_count)
    returning_values  :warn_code;
  end
end
^

/* Restore proc. body: RES_GUEST_CHANGE$RSV */
ALTER PROCEDURE RES_GUEST_CHANGE$RSV(ID_RESERV_DETAIL INTEGER,
ID_PERSON_PROFILE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable id_guest integer;
  declare variable check_status integer;
  declare variable id_person_data integer;
  declare variable old_person_profile integer;
  declare variable old_profile_name varchar(100);
  declare variable new_profile_name varchar(100);
begin
  select r.RDB$DB_KEY, r.ID_TITULAR, r.CHECK_STATUS, r.ID_PERSON_PROFILE, p.PROFILE_NAME
  from   RESERV_DETAIL R
         join PROFILE P on P.ID_PROFILE = r.ID_PERSON_PROFILE
  where  R.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey, :id_guest, :check_status, :old_person_profile, :old_profile_name;

  if (:old_person_profile = :ID_PERSON_PROFILE) then exit; -- NO CHANGES!

  id_person_data = null;
  select pp.ID_PERSON_DATA, p.PROFILE_NAME
  from   PROFILE_PERSON PP
         join PROFILE P on P.ID_PROFILE = pp.ID_PROFILE
  where  pp.ID_PROFILE = :ID_PERSON_PROFILE
  into   :id_person_data, :new_profile_name;

  if (:id_person_data is null) then exception BOOKING_EXCEPTION '-1039';

  update RESERV_DETAIL RD
  set    rd.ID_PERSON_PROFILE = :ID_PERSON_PROFILE
  where  rd.RDB$DB_KEY = :rd_dbkey;

  if (:check_status = 1) then begin
    execute procedure PERSON_DATA_COPY$INT (:id_person_data)
    returning_values (:id_person_data);
  end

  update GUEST_DATA GD
  set    gd.ID_PERSON_DATA = :id_person_data
  where  gd.ID_GUEST = :id_guest;

  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey);

  if (exists (select ap.ID_ACCOUNT_POST
              from   ACCOUNT_POST AP
                     join ACCOUNT A on A.ID_ACCOUNT = ap.ID_ACCOUNT
              where  a.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
                     and a.ID_PROFILE = :old_person_profile
                     and ap.IS_ANUL = 0)) then
    exception BOOKING_EXCEPTION '-1038';

  if (exists (select d.ID_DEPOSIT
              from   DEPOSITS D
                     join ACCOUNT A on A.ID_ACCOUNT = d.ID_ACCOUNT
              where  a.ID_PROFILE = :old_person_profile
                     and coalesce(d.ID_RESERV_DETAIL, a.ID_RESERV_DETAIL) = :ID_RESERV_DETAIL
                     and d.RECEIVED_AMOUNT > 0)) then
    exception BOOKING_EXCEPTION '-1040';

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'TITULAR_CHANGED',
          f_character(29) || :old_profile_name || f_character(28) || :new_profile_name, null);

end
^

/* Restore proc. body: RES_RECALC$INT */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable num_prefix varchar(20);
  declare variable number_1 varchar(20);
begin
  /* CALLER_KIND = {NORMAL, FORCED} */
  err_code = 0;
  /* 1. GET DATA */
  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL, rd.NUMBER_1
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :check_status, :id_reserv_detail, :number_1;

  if (:check_status = 1) then begin
    -- CHECKED OUT
    select sn.LEADING_PART
    from   SYSTEM_NUMERATOR SN
    where  sn.ID_NUMERATOR = 0
    into   :num_prefix;

    if (trim('.' from coalesce(:num_prefix, '')) = coalesce(:number_1, '')) then
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_MINE');
    else
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_ELSE');

    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :id_guest
    do begin
      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'MANUAL_EDIT_DATA', '');
    end
  end
  /* 2. FIND DEPENDANT GUESTS AND THEIR TARIFFS */
  --execute procedure sys_dbg('calc RES_RECALC$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

  ID_TAR_CALC = gen_id(gen_id_tar_calc, 1);
  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NONE');

  -- 3. UPDATE ROOM PRICE and REPOST ALL AFFECTED BOOKINGS
  execute procedure RES_TAR_CALC_FINALIZE$INT (:ID_TAR_CALC, :CALLER_KIND, :FORCE_POSTING)
  returning_values (:ERR_CODE, :ERR_TEXT);
end
^

/* Restore proc. body: RES_SAVE_ACCOUNTING$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
declare variable old_id_agent_profile integer;
  declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable action_text varchar(255);
  declare variable old_account_routing varchar(30);
  declare variable id_acc_profile integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:acc_routing, 'GUEST, AGENT, MIXED, OWNER, FULL_COMPLIMENTARY, PART_COMPLIMENTARY', 'Account routing');

  if (exists (select *
              from   PROFILE_HOUSE PH
              where  PH.ID_PROFILE = :id_agent_profile)) then
  begin
    exception BOOKING_EXCEPTION '-1016';
  end

  --execute procedure RESERV_TRACK_CHANGES$INT(:rd_dbkey);

  select RD.ID_AGENT_PROFILE, RD.ID_RESERV_DETAIL, RD.ACC_ROUTING
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_agent_profile, :id_reserv_detail, :old_account_routing;

  if (:ACC_ROUTING in ('AGENT','MIXED') and :ID_AGENT_ACCOUNT is not null) then begin
    select A.ID_PROFILE
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :ID_AGENT_ACCOUNT
    into   :id_acc_profile;
    -- check up agent account ownership
    if (:id_acc_profile is distinct from :ID_AGENT_PROFILE) then ID_AGENT_ACCOUNT = null;
  end

  update RESERV_DETAIL RD
  set    RD.ID_AGENT_ACCOUNT_RULE = :ID_AGENT_ACCOUNT,
         RD.ACC_ROUTING = :ACC_ROUTING,
         RD.ID_AGENT_PROFILE = :ID_AGENT_PROFILE,
         RD.ID_AGENT_PAYMENT = :ID_AGENT_PAYMENT,
         RD.ID_PERSON_PAYMENT = coalesce(:ID_PERSON_PAYMENT, RD.ID_PERSON_PAYMENT),
         RD.ID_GROUP = :ID_GROUP
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_id_agent_profile is distinct from :id_agent_profile) then begin
    execute procedure RES_SET_EDIT_STATUS$INT(:RD_DBKEY, 'AGENT', 'add');

    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :g_dbkey
    do begin
      execute procedure GUEST_AGENT_SET$INT(:g_dbkey, :id_agent_profile);
    end

    select f_character(29)||coalesce(old_A.PROFILE_NAME, '')||f_character(28)||coalesce(new_A.PROFILE_NAME, '')
    from   PROFILE old_A, PROFILE new_A
    where  old_A.ID_PROFILE = :old_id_agent_profile
           and new_A.ID_PROFILE = :ID_AGENT_PROFILE
    into   :action_text;

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_AGENT', :action_text);
  end

  if (:ACC_ROUTING <> :old_account_routing) then begin
    action_text = f_character(29) || coalesce(:old_account_routing, '')
                  || f_character(28) || coalesce(:acc_routing, '');

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_ACC_ROUTING', :action_text);
  end

  execute procedure RES_SAVE_ACCOUNTS$INT (:RD_DBKEY);
end
^

/* Restore proc. body: SAFE_CHECK_OUT */
ALTER PROCEDURE SAFE_CHECK_OUT(ID_SAFE TYPE OF ID)
 RETURNS(DOC_SELECTED TYPE OF ID_REF,
WARN_CODE TYPE OF ID_REF)
 AS
declare variable to_dt timestamp;
  declare variable is_occupied integer;
  declare variable expire_tollerance integer;
  declare variable occupant_name varchar(100);
  declare variable id_resource_reservation integer;
  declare variable check_out_datetime timestamp;
begin
  DOC_SELECTED = null;
  select s.IS_OCCUPIED, od.TO_DATETIME,
         st.EXPIRE_TOLLERANCE, rr.OCCUPANT_NAME, rr.ID_RESOURCE_RESERVATION
  from   SAFE s
         join RESOURCE$INT r on r.ID_RESOURCE = s.ID_SAFE
         join SAFE_TYPES st on st.ID_SAFE_TYPE = r.ID_RESOURCE_TYPE
         join RESOURCE_RESERVATION rr on rr.ID_RESOURCE_RESERVATION = s.ID_CURRENT_OCCUPANCY
         join RESOURCE_OCCUPANCY_DATA od on od.ID_RESOURCE_OCCUPANCY_DATA = rr.ID_RESOURCE_OCCUPANCY_DATA
         join RESOURCE_OCCUPANCY ro on ro.ID_RESOURCE_OCCUPANCY_DATA = od.ID_RESOURCE_OCCUPANCY_DATA
  where  s.ID_SAFE = :ID_SAFE
  into   :is_occupied, :to_dt, :expire_tollerance, :occupant_name, :id_resource_reservation;

  if (:is_occupied = 0) then exit;

  expire_tollerance = coalesce(:expire_tollerance, 0);
  check_out_datetime = current_timestamp;

  execute procedure SAFE_OCCUPANCY_MODIFY (:id_safe, current_timestamp, :occupant_name)
  returning_values  :DOC_SELECTED;

  if (:check_out_datetime > (:to_dt + cast(:expire_tollerance as double precision) / 60 / 24)) then begin
    execute procedure SYSTEM_WARNING_ADD (-1066, f_character(29) || :expire_tollerance || f_character(28) || formatdate(:to_dt + cast(:expire_tollerance as double precision) / 60 / 24, 'D;dd/mm/yyyy HH:MM'))
    returning_values (:WARN_CODE);
  end

  update SAFE s
  set    s.ID_CURRENT_OCCUPANCY = null
  where  s.ID_SAFE = :ID_SAFE;

  update RESOURCE_RESERVATION rr
  set    rr.STATUS = 'CHECKED_OUT'
  where  rr.ID_RESOURCE_RESERVATION = :id_resource_reservation;

  execute procedure SYSTEM_LOG_ADD ('SAFE', :ID_SAFE, 'SAFE_CHECKED_OUT', :occupant_name);
end
^

/* Restore proc. body: TAR_CALC_INPUT_PARAMS$INT */
ALTER PROCEDURE TAR_CALC_INPUT_PARAMS$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_input integer;
  declare variable id_guest integer;
  declare variable for_date date;
  declare variable id_calc_tariff integer;
  declare variable td_dbkey char(8);
  declare variable date_independent_param_values varchar(2000);
  declare variable date_dep_param_values varchar(2000);
  declare variable prev_id_guest integer;
  declare variable prev_id_tariff integer;
begin
  prev_id_guest = null;
  prev_id_tariff = null;
  for
    select Td.RDB$DB_KEY, TI.ID_TAR_INPUT, ti.ID_GUEST, td.FOR_DATE, td.ID_TAR_HEAD
    from   TAR_CALC_INPUT$TMP TI
           join TAR_CALC_INPUT_DETAIL$TMP td on td.ID_TAR_INPUT = ti.ID_TAR_INPUT
    where  TI.ID_TAR_CALC = :id_tar_calc
    order by ti.ID_GUEST asc, td.FOR_DATE asc
    into   :td_dbkey, :id_tar_input, :id_guest, :for_date, :id_calc_tariff
  do begin
    if ((:id_guest is distinct from :prev_id_guest)
        or (:id_calc_tariff is distinct from :prev_id_tariff)) then
    begin
      /* get date independent params */
      execute procedure TAR_CALC_PARAMS$INT (:id_calc_tariff, :id_tar_input, :ID_TAR_CALC, null, null)
      returning_values (:ERR_CODE, :date_independent_param_values);
      if (:ERR_CODE < 0) then exit;
      prev_id_guest = :id_guest;
      prev_id_tariff = :id_calc_tariff;
    end

    execute procedure TAR_CALC_PARAMS$INT (:id_calc_tariff, :id_tar_input, :ID_TAR_CALC, :for_date, null)
    returning_values (:ERR_CODE, :date_dep_param_values);
    if (:ERR_CODE < 0) then exit;

    update TAR_CALC_INPUT_DETAIL$TMP d
    set    d.PARAM_VALUES = coalesce(:date_independent_param_values, '') || ';'
                            || coalesce(:date_dep_param_values, '')
    where  d.RDB$DB_KEY = :td_dbkey;
  end
end
^

SET TERM ; ^

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN ID_CONTRACT_EXPENSE POSITION 1;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN ID_CONTRACT POSITION 2;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN SUB_CONTRACT POSITION 3;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN ID_SERVICE POSITION 4;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN ID_CURRENCY POSITION 5;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN FORMULA POSITION 6;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN SERVICE_PRICE POSITION 7;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN IS_ACC_POST_ITEM POSITION 8;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN CONTRACT_EXPENSE_TYPE POSITION 9;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN MULTIPLIER_TYPE POSITION 10;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN ID_AGENT_PROFILE POSITION 11;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN ORDER_TAG POSITION 12;

ALTER TABLE CONTRACT_EXPENSE$PMS ALTER COLUMN TMP$ORIG_CONTRACT POSITION 13;

