/* Server version: WI-V6.3.7.18553 Firebird 2.1 
   SQLDialect: 3. ODS: 11.1. Forced writes: On. Sweep inteval: 20000.
   Page size: 8192. Cache pages: 75 (600 Kb). Read-only: False. */
SET NAMES NONE;

SET SQL DIALECT 3;

/* Create Table... */
CREATE TABLE EXT_ESTI_CONFIG(CFG_KEY TDESCRIPTION_LONG NOT NULL,
CFG_VALUE TDESCRIPTION_LONG);



ALTER TABLE GUEST ADD ID_HOTEL ID_REF;

ALTER TABLE GUEST ADD CHECKED_IN_AT TDATETIME;

ALTER TABLE GUEST_DATA ADD REGISTRATION_UPDATED_AT TDATETIME;

UPDATE RDB$RELATION_FIELDS SET RDB$Collation_ID = Null
  WHERE RDB$FIELD_NAME='PERSON_NAME' AND RDB$RELATION_NAME='PERSON_DATA';

/* Create Procedure... */
SET TERM ^ ;

CREATE PROCEDURE GUEST_REGISTRATION_UPDATE(ID_GUEST TYPE OF ID)
 AS
 BEGIN EXIT; END
^


SET TERM ; ^

DROP VIEW ENA_GUEST;

/* Create view: ENA_GUEST */
CREATE VIEW ENA_GUEST(
ID_GUEST,
ID_RESERV_DETAIL,
PERSON_NAME,
PERSON_NAME2,
IS_CHILD,
VAUCHER_DATE,
VAUCHER_NUM,
VAUCHER_TEXT,
VAUCHER_NUM2,
VAUCHER_DATE2,
RATING_AGE,
AGE,
COUNTRY_CODE,
MASK)
 AS 
select
G.ID_GUEST,
G.ID_RESERV_DETAIL,
PD.PERSON_NAME,
PD.PERSON_NAME2,
G.IS_CHILD,
G.VAUCHER_DATE,
G.VAUCHER_NUM,
G.VAUCHER_TEXT,
G.VAUCHER_NUM2,
G.VAUCHER_DATE2,
GD.RATING_AGE,
(select ga.AGE_INYEARS from SYSTEM_CALC_AGE_INYEARS(pd.BIRTH_DAY, g.FROM_DATE) ga) as AGE,
PD.COUNTRY_CODE,
PD.MASK
from GUEST g
    join GUEST_DATA gd on gd.ID_GUEST = g.ID_GUEST
    join PERSON_DATA pd on pd.ID_PERSON_DATA = gd.ID_PERSON_DATA
;

COMMENT ON VIEW ENA_GUEST IS
'!!! Доп.пакета да се добави (той е избор от няколко)';

COMMENT ON COLUMN ENA_GUEST.ID_GUEST IS
'Идентификатор на госта (адресната карта) свързана със резервацията. Статично.';

COMMENT ON COLUMN ENA_GUEST.ID_RESERV_DETAIL IS
'Външен ключ на резервацията към която е госта (към ENA_RESERV_DETAIL.ID_RESERV_DETAIL). Статично.';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME IS
'Оригиналните имена на госта. Динамично.';

COMMENT ON COLUMN ENA_GUEST.PERSON_NAME2 IS
'Имената на госта попълнени на местния език. Динамично.';

COMMENT ON COLUMN ENA_GUEST.IS_CHILD IS
'Дали госта е дете. 0 - възрастен; 1 - дете. Динамично.';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE IS
'Дата на ваучера на госта. Динамично.';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM IS
'Номер на ваучера. Динамично.';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_TEXT IS
'Допълнителен текст към ваучера. Динамично.';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_NUM2 IS
'Номер на втория ваучер. Динамично.';

COMMENT ON COLUMN ENA_GUEST.VAUCHER_DATE2 IS
'Дата на втория ваучер. Динамично.';

COMMENT ON COLUMN ENA_GUEST.RATING_AGE IS
'Възраст на госта. Динамично.';

COMMENT ON COLUMN ENA_GUEST.COUNTRY_CODE IS
'Код на националността на госта. Дву буквен или три буквен код по ISO. Динамично.';

COMMENT ON COLUMN ENA_GUEST.MASK IS
'Маска на госта. Поле за свободно ползване във адресната карта на госта. Динамично.';

DROP VIEW ENA_RESERV_DETAIL;

/* Create view: ENA_RESERV_DETAIL */
CREATE VIEW ENA_RESERV_DETAIL(
ID_HOTEL,
ID_RESERV_DETAIL,
NUMBER,
ID_GUEST_MAIN,
GUEST_MAIN_NAME,
GUEST_MAIN_NAME2,
TITLE,
FROM_DATE,
TO_DATE,
NIGHTS,
ADULT_COUNT,
CHILD_COUNT,
ID_EATING_OBJECT,
CHECK_STATUS,
IS_ANUL,
ARRANGER_PROFILE_ID,
ARRANGER_PROFILE_NAME,
ARRANGER_PROFILE_TYPE,
ARRANGER_PROFILE_ACCOUNT_NO,
MARKET_SEGMENT_CODE,
MARKET_SOURCE_CODE,
MARKET_CHANNEL_CODE,
MARKET_HEAR_CODE,
MARKET_COME_CODE,
ROOM_TYPE,
ROOM_NAME,
RATE_NAME,
RESERV_PRICE,
PRICE_CURRENCY,
BOARD,
EMAIL,
NATIONALITY,
NOTE)
 AS 
select
rd.ID_HOTEL,
rd.ID_RESERV_DETAIL,
rd.NUMBER,
rd.ID_TITULAR,
pd.PERSON_NAME,
pd.PERSON_NAME2,
pd.TITLE,
rd.FROM_DATE,
rd.TO_DATE,
rd.TO_DATE - rd.FROM_DATE,
rd.ADULT_COUNT,
rd.CHILD_COUNT,
rd.ID_EATING_OBJECT,
rd.CHECK_STATUS,
rd.IS_ANUL,
rd.ID_AGENT_PROFILE,
(select p1.PROFILE_NAME from PROFILE p1 where p1.ID_PROFILE = rd.ID_AGENT_PROFILE),
(select p2.PROFILE_TYPE from PROFILE p2 where p2.ID_PROFILE = rd.ID_AGENT_PROFILE),
(select p3.ACCOUNT_NO from PROFILE p3 where p3.ID_PROFILE = rd.ID_AGENT_PROFILE),
(select M1.MARKET_CODE from NOM_MARKET_SEGMENTS M1 where m1.ID_NOM_MARKET_SEGMENT = rd.ID_NOM_MARKET_SEGMENT),
(select M2.SOURCE_CODE from NOM_SOURCE_CODES M2 where m2.ID_NOM_SOURCE_CODE = rd.ID_NOM_SOURCE_CODE),
(select M3.CHANNEL_CODE from NOM_CHANNEL_CODES M3 where m3.ID_NOM_CHANNEL_CODE = rd.ID_NOM_CHANNEL_CODE),
(select M4.HEAR_REASON_CODE from NOM_HEAR_REASONS M4 where m4.ID_NOM_HEAR_REASON = rd.ID_NOM_HEAR_REASON),
(select M5.COME_REASON_CODE from NOM_COME_REASONS M5 where m5.ID_NOM_COME_REASON = rd.ID_NOM_COME_REASON),
coalesce((select rrt.TYPE_ROOM from ROOM_TYPES rrt join ROOMS r on r.ID_ROOM_TYPE = rrt.ID_ROOM_TYPE where r.ID_ROOM = rd.ID_ROOM),
         (select rrt.TYPE_ROOM from ROOM_TYPES rrt join ROOM_MAP$EXC rmp on rmp.ID_ROOM_TYPE = rrt.ID_ROOM_TYPE where rmp.ID_ROOM = rd.ID_ROOM),
         (select rrt.TYPE_ROOM from ROOM_TYPES rrt where rrt.ID_ROOM_TYPE = rd.ID_ROOM_TYPE)),
(select r.room_name from rooms r where r.ID_ROOM = rd.ID_ROOM),
t.TARIFA_NAME,
rd.ROOM_PRICE,
rd.ROOM_CURRENCY,
M.NAME,
(select p.EMAIL
 from   PROFILE P
 where  p.ID_PROFILE = rd.ID_PERSON_PROFILE) as EMAIL,
rd.COUNTRY,
rd.NOTE
from RESERV_DETAIL rd
    join GUEST g on g.ID_GUEST = rd.ID_TITULAR
    join GUEST_DATA gd on gd.ID_GUEST = g.ID_GUEST
    join PERSON_DATA pd on pd.ID_PERSON_DATA = gd.ID_PERSON_DATA
    join TARIFA T on t.ID_TARIFA = rd.ID_RATE
    join MEALS M on M.ID_BOARD = rd.ID_BOARD
;

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_HOTEL IS
'Идентификатор на хотела за който е резервацията. Външен ключ към ENA_HOTEL.ID_HOTEL. Статично.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_RESERV_DETAIL IS
'Уникален идентификатор на резервацията. Статично.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NUMBER IS
'Номер на резервацията. Уникален за валидните ( не анулираните ). Статично.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_GUEST_MAIN IS
'Външен ключ към основния гост на резервацията. Всяка резервация има задължително основен гост. Динамично - титуляра може да се сменя.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME IS
'Оригиналните имена на основния гост. Динамично.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.GUEST_MAIN_NAME2 IS
'Имената на основния гост попълнени на местния език. Динамично.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.FROM_DATE IS
'Дата на настаняване. Динамично.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.TO_DATE IS
'Дата на напускане. Динамично.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.NIGHTS IS
'Нощувки. Динамично.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ADULT_COUNT IS
'Брой на възрастните. Динамично.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHILD_COUNT IS
'Брой на децата. Динамично.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ID_EATING_OBJECT IS
'Идентификатор на ресторанта в който госта е разпределен да се храни. Динамично.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.CHECK_STATUS IS
'Статус на резервацията. -3 = Чакаща резервация; -2 = Не потвърдена резервация; -1 = Потвърдена резервация; 0 = Настанена резервация; 1 = Изпратена резервация. Динамично.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.IS_ANUL IS
'Анулирана ли е резервацията. 0 - валидна, 1 - анулирана. Динамично - може да се променя само от 0 към 1.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ID IS
'Идентификатор на профила на организатора на резервацията. Може да няма организатор. Динамично.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_NAME IS
'Име на профила на организатора на резервацията. Може да няма организатор. Динамично.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_TYPE IS
'Тип на профила на организатора на резервацията. Може да няма организатор. Динамично.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.ARRANGER_PROFILE_ACCOUNT_NO IS
'Свободно за ползване поле във профила на организатора предназначено за връзка със външни системи. Може да няма организатор. Динамично.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SEGMENT_CODE IS
'Кратък маркетинг код ''segment''. Може да няма. Динамично.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_SOURCE_CODE IS
'Кратък маркетинг код ''source''. Може да няма. Динамично.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_CHANNEL_CODE IS
'Кратък маркетинг код ''channel''. Може да няма. Динамично.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_HEAR_CODE IS
'Кратък маркетинг код ''hear reason''. Може да няма. Динамично.';

COMMENT ON COLUMN ENA_RESERV_DETAIL.MARKET_COME_CODE IS
'Кратък маркетинг код ''come reason''. Може да няма. Динамично.';

SET TERM ^ ;

ALTER PROCEDURE ACCOUNT_MANIP_VIEW(IN_IS_CLOSED SMALLINT,
IN_ID_ACCOUNTS VARCHAR(5000),
IN_IS_ANUL SMALLINT,
IN_INCLUDE SMALLINT,
IN_ID_DOC_HEAD INTEGER)
 RETURNS(OUT_ID_SERVICE INTEGER,
OUT_SERVICE_NAME VARCHAR(100),
OUT_IS_BASE INTEGER,
OUT_ID_ACCOUNT_POST INTEGER,
OUT_ID_CORRECT_POST INTEGER,
OUT_ID_ACCOUNT INTEGER,
OUT_ROOM_NAME VARCHAR(10),
OUT_GUEST_NAME VARCHAR(50),
OUT_QTY_POST NUMERIC(15,4),
OUT_QTY_FREE NUMERIC(15,4),
OUT_PRICE_POST NUMERIC(15,4),
OUT_SUM_PRICE NUMERIC(15,4),
OUT_QTY_POST_ORIG NUMERIC(15,4),
OUT_QTY_FREE_ORIG NUMERIC(15,4),
OUT_PRICE_POST_ORIG NUMERIC(15,4),
OUT_SUM_PRICE_ORIG NUMERIC(15,4),
OUT_DATE_POST DATE,
OUT_CURR_POST VARCHAR(3),
OUT_IS_ANUL INTEGER,
OUT_IS_CORRECT SMALLINT,
OUT_ID_SERVICE_GROUP INTEGER,
OUT_SRV_GROUP_NAME VARCHAR(100),
OUT_ID_ROOM INTEGER,
OUT_ID_GUEST INTEGER,
OUT_USER_CHANGED VARCHAR(30),
OUT_DATETIME_CHANGED TIMESTAMP,
OUT_CHANGE_TEXT VARCHAR(20),
OUT_PREV_POST VARCHAR(30),
OUT_DATE_CAME DATE)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE AGENT_AGES_MODIFY$PROFILE(ID_AGENT_AGES INTEGER,
ID_AGENT INTEGER,
AGE_START INTEGER,
AGE_END INTEGER,
AGES_NAME VARCHAR(50),
IS_CHILD SMALLINT,
OPERATION VARCHAR(10))
 RETURNS(NEW_ID_AGENT_AGES INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE DOC_LINES_SUSPEND_INVOICE(ID_DOC_HEAD INTEGER,
CORRECTION_INDEX INTEGER,
RPT_TYPE VARCHAR(20),
RPT_CURR VARCHAR(10),
RPT_VAT VARCHAR(20),
IN_VAUCHER_NUM VARCHAR(20))
 RETURNS(TAX_STATUS INTEGER,
ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
VAUCHER_NUM VARCHAR(20),
GUEST_NAME VARCHAR(100),
IS_CHILD INTEGER,
AGES_NAME VARCHAR(50),
GFROM_DATE DATE,
GTO_DATE DATE,
PACKET_NAME VARCHAR(50),
LINE_NAME VARCHAR(100),
ID_SERVICE INTEGER,
DATE_POST DATE,
QTY_POST NUMERIC(15,2),
SINGLE_PRICE NUMERIC(15,4),
LINE_VALUE NUMERIC(15,4),
PACKET_PRICE NUMERIC(15,4),
PACKET_PRICE_WOT_DIFF DOUBLE PRECISION,
ID_TARIFA INTEGER,
BIRTH_DATE DATE,
NIGHTS INTEGER,
IS_BASE INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE EAI_EXT_ROOM_GUESTS(IN_ROOM_NAME VARCHAR(10),
ID_HOTEL INTEGER = null)
 RETURNS(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ROOM_NAME VARCHAR(10),
FROM_DATE DATE,
TO_DATE DATE,
COUNTRY VARCHAR(30),
AGE INTEGER,
ID_AGENT INTEGER,
ID_GROUP INTEGER,
SEX CHAR,
GUEST_CODE VARCHAR(50))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE EAI_POS_CHECK_CARD$P2E(IN_CARD_NUMBER VARCHAR(50),
ID_HOTEL INTEGER)
 RETURNS(ID_GUEST INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100),
GUEST_NAME VARCHAR(100),
ROOM_NAME VARCHAR(20),
BOARD_NAME VARCHAR(30))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE EAI_POS_GET_GUESTS$P2E(IN_ROOM_NAME VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(OUT_ID_GUEST INTEGER,
OUT_GUEST_NAME VARCHAR(100),
OUT_FROM_DATE DATE,
OUT_TO_DATE DATE,
OUT_OK_FOR_POST INTEGER,
OUT_COUNTRY VARCHAR(30),
OUT_TEXT VARCHAR(100),
OUT_BOARD_NAME VARCHAR(30),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE GUEST_AGENT_SET$INT(G_DBKEY CHAR(8),
NEW_ID_AGENT_PROFILE INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE RES_GUEST_LOAD(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_GUEST INTEGER,
STATUS INTEGER,
GUEST_NAME1 VARCHAR(255),
GUEST_NAME2 VARCHAR(255),
IS_CHILD INTEGER,
AGE INTEGER,
BIRTH_DAY DATE,
BIRTHDAY_INTERNAL DATE,
COUNTRY_CODE VARCHAR(10),
FROM_DATE DATE,
TO_DATE DATE)
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE RES_GUEST_SAVE_BOARD$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_BOARD INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE RES_GUEST_SAVE_RATE$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TARIFF INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE RES_GUEST_SAVE_ROOMTYPE$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TAR_ROOM_TYPE INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE RES_GUEST_SAVE_TYPESTAY$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TYPE_STAY INTEGER)
 AS
 BEGIN EXIT; END
^

ALTER PROCEDURE RESERV_STATISTIC_SLICE$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_PROFILE_AGENT INTEGER,
COUNTRY_CODE VARCHAR(20),
MARKET_SEGMENT_CODE VARCHAR(3),
SOURCE_CODE VARCHAR(3),
CHANNEL_CODE VARCHAR(3),
HEAR_REASON_CODE VARCHAR(3),
COME_REASON_CODE VARCHAR(3))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE SPR_HOTEL_REGISTER(IN_FROM DATE,
IN_TO DATE,
IN_FROM_GUEST INTEGER,
IN_TO_GUEST INTEGER,
IN_MASK VARCHAR(10),
ID_HOTEL INTEGER = null)
 RETURNS(ID_GUEST INTEGER,
GUEST_NAME VARCHAR(50),
ROOM_NAME VARCHAR(10),
CITIZENSHIP_EGN VARCHAR(65),
PERIOD_FROM DATE,
PERIOD_TO DATE,
NIGHTS INTEGER,
RESERVATION VARCHAR(100),
ID_ACCOUNT_NIGHTS VARCHAR(30),
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
ADDRESS_BULGARIAN VARCHAR(100),
PASSPORT VARCHAR(40),
NOTE VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

ALTER PROCEDURE TAR_CALC_EVAL_DATE$INT(ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
FOR_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

SET TERM ; ^

DROP VIEW GUEST_CARD;

/* Create view: GUEST_CARD */
CREATE VIEW GUEST_CARD(
ID_GUEST,
GUEST_CODE,
GUEST_NAME1,
GUEST_NAME2,
EGN,
PASS_NUM,
PASS_DATE,
PASS_PLACE,
PASS_EXP_DATE,
COUNTRY,
SITY,
ADDRESS,
BIRTH_DAY,
BIRTH_PLACE,
SEX,
MASK,
STAY_NOTE,
ID_STAY_REASON,
STAY_REASON,
KPP_DATE,
IS_REGISTRED,
USER_REGISTRED,
USER_CHANGE_REGISTRED,
CAR,
KPP,
ID_NOM_MARKET_SEGMENT,
ID_NOM_SOURCE_CODE,
ID_NOM_CHANNEL_CODE,
ID_NOM_HEAR_REASON,
ID_NOM_COME_REASON,
EXTERNAL_DATA_LINK,
BIRTHDAY_INTERNAL)
 AS 
select
    GD.ID_GUEST,
    GD.GUEST_CODE,
    PD.PERSON_NAME,
    PD.PERSON_NAME2,
    PD.EGN,
    PD.PASS_NUM,
    PD.PASS_DATE,
    PD.PASS_PLACE,
    PD.PASS_EXP_DATE,
    PD.COUNTRY_CODE,
    PD.CITY,
    PD.ADDRESS,
    PD.BIRTH_DAY,
    PD.BIRTH_PLACE,
    PD.SEX,
    PD.MASK,
    GD.STAY_NOTE,
    GD.ID_STAY_REASON,
    SR.NAME as STAY_REASON,
    GD.KPP_DATE,
    GD.IS_REGISTRED,
    GD.USER_REGISTRED,
    GD.USER_CHANGE_REGISTRED,
    GD.CAR,
    GD.KPP,
    GD.ID_NOM_MARKET_SEGMENT,
    GD.ID_NOM_SOURCE_CODE,
    GD.ID_NOM_CHANNEL_CODE,
    GD.ID_NOM_HEAR_REASON,
    GD.ID_NOM_COME_REASON,
    GD.EXTERNAL_DATA_LINK,
    PD.BIRTHDAY_INTERNAL
from GUEST_DATA GD
     join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
     left outer join STAY_REASON SR on SR.ID_STAY_REASON = GD.ID_STAY_REASON
;

/* Create index... */
CREATE INDEX GUEST_DATA_IDX1 ON GUEST_DATA COMPUTED BY(cast(REGISTRATION_UPDATED_AT as date));

CREATE INDEX GUEST_HOTEL_IDX ON GUEST(ID_HOTEL);


/* Create Primary Key... */
ALTER TABLE EXT_ESTI_CONFIG ADD CONSTRAINT PK_EXT_ESTI_CONFIG PRIMARY KEY (CFG_KEY);

/* Alter Procedure... */
/* Alter (ACCOUNT_MANIP_VIEW) */
SET TERM ^ ;

ALTER PROCEDURE ACCOUNT_MANIP_VIEW(IN_IS_CLOSED SMALLINT,
IN_ID_ACCOUNTS VARCHAR(5000),
IN_IS_ANUL SMALLINT,
IN_INCLUDE SMALLINT,
IN_ID_DOC_HEAD INTEGER)
 RETURNS(OUT_ID_SERVICE INTEGER,
OUT_SERVICE_NAME VARCHAR(100),
OUT_IS_BASE INTEGER,
OUT_ID_ACCOUNT_POST INTEGER,
OUT_ID_CORRECT_POST INTEGER,
OUT_ID_ACCOUNT INTEGER,
OUT_ROOM_NAME VARCHAR(10),
OUT_GUEST_NAME VARCHAR(50),
OUT_QTY_POST NUMERIC(15,4),
OUT_QTY_FREE NUMERIC(15,4),
OUT_PRICE_POST NUMERIC(15,4),
OUT_SUM_PRICE NUMERIC(15,4),
OUT_QTY_POST_ORIG NUMERIC(15,4),
OUT_QTY_FREE_ORIG NUMERIC(15,4),
OUT_PRICE_POST_ORIG NUMERIC(15,4),
OUT_SUM_PRICE_ORIG NUMERIC(15,4),
OUT_DATE_POST DATE,
OUT_CURR_POST VARCHAR(3),
OUT_IS_ANUL INTEGER,
OUT_IS_CORRECT SMALLINT,
OUT_ID_SERVICE_GROUP INTEGER,
OUT_SRV_GROUP_NAME VARCHAR(100),
OUT_ID_ROOM INTEGER,
OUT_ID_GUEST INTEGER,
OUT_USER_CHANGED VARCHAR(30),
OUT_DATETIME_CHANGED TIMESTAMP,
OUT_CHANGE_TEXT VARCHAR(20),
OUT_PREV_POST VARCHAR(30),
OUT_DATE_CAME DATE)
 AS
declare variable QTY_CORRECT numeric(15,4);
  declare variable EXTRA_CORRECT numeric(15,4);
  declare variable PRICE_CORRECT numeric(15,4);
  declare variable MY_ID_ACCOUNT integer;
  declare variable STRCORRECTION varchar(50);
  declare variable STRCORR varchar(50);
  declare variable STR1 varchar(4);
  declare variable OLD_ID_GUEST integer;
  declare variable OLD_ID_SERVICE integer;
  declare variable IS_POSITIVE integer;
  declare variable round_to numeric(15,4);
begin
  if (:IN_IS_CLOSED = -1) then STR1 = cast(:IN_IS_ANUL as char(1)) || '%';
  else STR1 = cast(:IN_IS_ANUL as char(1)) || cast(:IN_IS_CLOSED as char(1));

  STRCORRECTION = '@{rep.acc.correction}';

  for
    select cast(ITEM as integer)
    from   SYSTEM_STRING_PARSER(:IN_ID_ACCOUNTS, 'x')
    into   :MY_ID_ACCOUNT
  do begin
    select c.ROUND_TO
    from   ACCOUNT A
           join CURRS C on c.CURR = a.ACCOUNT_CURR
    where  a.ID_ACCOUNT = :MY_ID_ACCOUNT
    into   :round_to;

    if (:IN_INCLUDE in (0, 2)) then begin
      OLD_ID_GUEST =  null ;
      OLD_ID_SERVICE = null;
      if (:IN_ID_DOC_HEAD = -1) then begin
        for
          select  AP.ID_ACCOUNT_POST, -1, AP.ID_ACCOUNT, AP.ID_SERVICE, AP.IS_BASE,
                  AP.DATE_POST, AP.USER_CHANGED, AP.DATETIME_CHANGED, substring(AP.CHANGED_TEXT from 1 for 20), AP.ORIGINAL_POST,
                  AP.QTY_POST, AP.QTY_FREE, round_f(AP.PRICE_POST, :round_to),round_f((AP.QTY_POST - AP.QTY_FREE)*AP.PRICE_POST, :round_to),
                  AP.CURR_POST, AP.IS_ANUL, 0, AP.ID_GUEST, AP.ROOM_NAME
          from    ACCOUNT_POST AP
          where   AP.ID_ACCOUNT = :MY_ID_ACCOUNT
                  and AP.AC like :STR1
          order by AP.ID_GUEST asc nulls last, AP.ID_SERVICE asc
          into    :OUT_ID_ACCOUNT_POST, :OUT_ID_CORRECT_POST, :OUT_ID_ACCOUNT, :OUT_ID_SERVICE,  :OUT_IS_BASE,
                  :OUT_DATE_POST, :OUT_USER_CHANGED, :OUT_DATETIME_CHANGED, :OUT_CHANGE_TEXT, :OUT_PREV_POST,
                  :OUT_QTY_POST, :OUT_QTY_FREE, :OUT_PRICE_POST, :OUT_SUM_PRICE,
                  :OUT_CURR_POST, :OUT_IS_ANUL, :OUT_IS_CORRECT, :OUT_ID_GUEST, :OUT_ROOM_NAME
        do begin
          /* EXTRA DATA */
          if (:OLD_ID_GUEST is distinct from :OUT_ID_GUEST) then begin
             OUT_DATE_CAME = null;
             OUT_ID_ROOM = null;
             OUT_GUEST_NAME = null;
             select G.FROM_DATE , G.ID_ROOM, GC.GUEST_NAME1
             from   GUEST G
                    left outer join GUEST_CARD GC on G.ID_GUEST = GC.ID_GUEST
             where  G.ID_GUEST = :OUT_ID_GUEST
             into   :OUT_DATE_CAME, :OUT_ID_ROOM, :OUT_GUEST_NAME;
          end
          if ((:OLD_ID_SERVICE is null) or (:OUT_ID_SERVICE <> :OLD_ID_SERVICE)) then  begin
            select S.SERVICE_NAME, S.ID_SERVICE_GROUP, SG.GROUP_NAME
            from   SERVICES S
                   left outer join SERVICE_GROUPS SG on S.ID_SERVICE_GROUP = SG.ID_SERVICE_GROUP
            where  S.ID_SERVICE = :OUT_ID_SERVICE
            into   :OUT_SERVICE_NAME, :OUT_ID_SERVICE_GROUP, :OUT_SRV_GROUP_NAME;
          end
          OLD_ID_GUEST =  :OUT_ID_GUEST ;
          OLD_ID_SERVICE = :OUT_ID_SERVICE;
          if (:IN_IS_CLOSED = 1)  then begin
             select sum(APC.IS_QTY_CORRECT * (APC.IS_POSITIVE * 2-1) * APC.QTY_CORRECT),
                    sum(APC.IS_QTY_CORRECT * APC.EXTRA_QTY_CORRECT),
                    round_f(sum(APC.IS_PRICE_CORRECT * (APC.IS_POSITIVE * 2-1) * APC.PRICE_CORRECT), :round_to)
             from   ACCOUNT_POST_CORRECTION APC
             where  APC.ID_ACCOUNT_POST = :OUT_ID_ACCOUNT_POST
                    and ((APC.IS_OPEN) = 1 or (APC.ID_DOC_HEAD > 0))
             into   :QTY_CORRECT, :EXTRA_CORRECT, :PRICE_CORRECT;
             if (:QTY_CORRECT <> 0) then OUT_QTY_POST_ORIG = :OUT_QTY_POST - :QTY_CORRECT;
              else OUT_QTY_POST_ORIG = null;
             if (:EXTRA_CORRECT <> 0) then OUT_QTY_FREE_ORIG = :OUT_QTY_FREE - :EXTRA_CORRECT ;
              else OUT_QTY_FREE_ORIG = null;
             if (:PRICE_CORRECT <> 0) then OUT_PRICE_POST_ORIG = round_f(:OUT_PRICE_POST - :PRICE_CORRECT, :round_to);
              else OUT_PRICE_POST_ORIG = null;
             if (:QTY_CORRECT <> 0 or :EXTRA_CORRECT <> 0 or :PRICE_CORRECT <> 0) then OUT_SUM_PRICE_ORIG = round_f((:OUT_QTY_POST - :OUT_QTY_FREE) * :OUT_PRICE_POST, :round_to);
              else OUT_SUM_PRICE_ORIG = null;
          end
          if (:IN_IS_CLOSED = -1)  then begin
             select sum(APC.IS_QTY_CORRECT * (APC.IS_POSITIVE * 2 - 1) * APC.QTY_CORRECT),
                    sum(APC.IS_QTY_CORRECT * APC.EXTRA_QTY_CORRECT),
                    round_f(sum(APC.IS_PRICE_CORRECT * (APC.IS_POSITIVE * 2 - 1) * APC.PRICE_CORRECT), :round_to)
             from   ACCOUNT_POST_CORRECTION APC
             where  APC.ID_ACCOUNT_POST = :OUT_ID_ACCOUNT_POST
                    and ((APC.IS_OPEN) = 1 or (APC.ID_DOC_HEAD > 0))
             into   :QTY_CORRECT, :EXTRA_CORRECT, :PRICE_CORRECT;
             if (:QTY_CORRECT <> 0) then OUT_QTY_POST = :OUT_QTY_POST - :QTY_CORRECT;
             if (:EXTRA_CORRECT <> 0) then OUT_QTY_FREE = :OUT_QTY_FREE - :EXTRA_CORRECT;
             if (:PRICE_CORRECT <> 0) then OUT_PRICE_POST = round_f(:OUT_PRICE_POST - :PRICE_CORRECT, :round_to);
             if (:QTY_CORRECT <> 0 or :EXTRA_CORRECT <> 0 or :PRICE_CORRECT <> 0) then OUT_SUM_PRICE = round_f((:OUT_QTY_POST - :OUT_QTY_FREE) * :OUT_PRICE_POST, :round_to);
          end
          suspend;
        end
      end else begin
        /* JOIN TO DOCUMENT */
        for
          select  AP.ID_ACCOUNT_POST, -1, AP.ID_ACCOUNT, AP.ID_SERVICE,  AP.IS_BASE,
                  AP.DATE_POST, AP.USER_CHANGED, AP.DATETIME_CHANGED, substring(AP.CHANGED_TEXT from 1 for 20), AP.ORIGINAL_POST,
                  AP.QTY_POST, AP.QTY_FREE, round_f(AP.PRICE_POST, :round_to),round_f((AP.QTY_POST - AP.QTY_FREE)*AP.PRICE_POST, :round_to),
                  AP.CURR_POST, AP.IS_ANUL, 0, AP.ID_GUEST, AP.ROOM_NAME
          from    ACCOUNT_POST AP /* left outer join DOC_LINES DL on ap.ID_ACCOUNT_POST = dl.ID_ACCOUNT_POST*/
          where   AP.ID_BASE_DOC = :IN_ID_DOC_HEAD
                  and AP.ID_ACCOUNT = :MY_ID_ACCOUNT
                  and AP.AC like :STR1
                  /*and DL.IS_CORRECT = 0
                  and DL.ID_DOC_HEAD = :IN_ID_DOC_HEAD */
          order by AP.ID_GUEST asc nulls last, AP.ID_SERVICE asc
          into    :OUT_ID_ACCOUNT_POST, :OUT_ID_CORRECT_POST, :OUT_ID_ACCOUNT, :OUT_ID_SERVICE,  :OUT_IS_BASE,
                  :OUT_DATE_POST, :OUT_USER_CHANGED, :OUT_DATETIME_CHANGED, :OUT_CHANGE_TEXT, :OUT_PREV_POST,
                  :OUT_QTY_POST, :OUT_QTY_FREE, :OUT_PRICE_POST, :OUT_SUM_PRICE,
                  :OUT_CURR_POST, :OUT_IS_ANUL, :OUT_IS_CORRECT, :OUT_ID_GUEST, :OUT_ROOM_NAME
        do begin
          /* EXTRA DATA */
          if (:OLD_ID_GUEST is distinct from :OUT_ID_GUEST) then begin
             OUT_DATE_CAME = null;
             OUT_ID_ROOM = null;
             OUT_GUEST_NAME = null;
             select G.FROM_DATE , G.ID_ROOM, GC.GUEST_NAME1
             from   GUEST G
                    left outer join GUEST_CARD GC on G.ID_GUEST = GC.ID_GUEST
             where  G.ID_GUEST = :OUT_ID_GUEST
             into  :OUT_DATE_CAME, :OUT_ID_ROOM, :OUT_GUEST_NAME;
          end
          if ((:OLD_ID_SERVICE is null) or (:OUT_ID_SERVICE <> :OLD_ID_SERVICE)) then  begin
            select S.SERVICE_NAME, S.ID_SERVICE_GROUP, SG.GROUP_NAME
            from   SERVICES S
                   left outer join SERVICE_GROUPS SG on S.ID_SERVICE_GROUP = SG.ID_SERVICE_GROUP
            where  S.ID_SERVICE = :OUT_ID_SERVICE
            into   :OUT_SERVICE_NAME, :OUT_ID_SERVICE_GROUP, :OUT_SRV_GROUP_NAME;
          end
          OLD_ID_GUEST =  :OUT_ID_GUEST ;
          OLD_ID_SERVICE = :OUT_ID_SERVICE;

          if (:IN_IS_CLOSED = 1)  then begin
             select sum(APC.IS_QTY_CORRECT * (APC.IS_POSITIVE * 2 - 1) * APC.QTY_CORRECT),
                    sum(APC.IS_QTY_CORRECT * APC.EXTRA_QTY_CORRECT),
                    round_f(sum(APC.IS_PRICE_CORRECT * (APC.IS_POSITIVE * 2 - 1) * APC.PRICE_CORRECT), :round_to)
             from   ACCOUNT_POST_CORRECTION APC
             where  APC.ID_ACCOUNT_POST = :OUT_ID_ACCOUNT_POST
                    and ((APC.IS_OPEN) = 1 or (APC.ID_DOC_HEAD > 0))
             into   :QTY_CORRECT, :EXTRA_CORRECT, :PRICE_CORRECT;
             if (:QTY_CORRECT <> 0) then OUT_QTY_POST_ORIG = :OUT_QTY_POST - :QTY_CORRECT;
              else OUT_QTY_POST_ORIG = null;
             if (:EXTRA_CORRECT <> 0) then OUT_QTY_FREE_ORIG = :OUT_QTY_FREE - :EXTRA_CORRECT;
              else OUT_QTY_FREE_ORIG = null;
             if (:PRICE_CORRECT <> 0) then OUT_PRICE_POST_ORIG = round_f(:OUT_PRICE_POST - :PRICE_CORRECT, :round_to);
              else OUT_PRICE_POST_ORIG = null;
             if (:QTY_CORRECT <> 0 or :EXTRA_CORRECT <> 0 or :PRICE_CORRECT <> 0) then OUT_SUM_PRICE_ORIG = round_f((:OUT_QTY_POST - :OUT_QTY_FREE) * :OUT_PRICE_POST, :round_to);
              else OUT_SUM_PRICE_ORIG = null;
          end
          if (:IN_IS_CLOSED = -1)  then begin
             select sum(APC.IS_QTY_CORRECT * (APC.IS_POSITIVE * 2 - 1) * APC.QTY_CORRECT),
                    sum(APC.IS_QTY_CORRECT * APC.EXTRA_QTY_CORRECT),
                    round_f(sum(APC.IS_PRICE_CORRECT * (APC.IS_POSITIVE * 2 - 1) * APC.PRICE_CORRECT), :round_to)
             from   ACCOUNT_POST_CORRECTION APC
             where  APC.ID_ACCOUNT_POST = :OUT_ID_ACCOUNT_POST
                    and ((APC.IS_OPEN) = 1 or (APC.ID_DOC_HEAD > 0))
             into   :QTY_CORRECT, :EXTRA_CORRECT, :PRICE_CORRECT;
             if (:QTY_CORRECT <> 0) then OUT_QTY_POST = :OUT_QTY_POST - :QTY_CORRECT;
             if (:EXTRA_CORRECT <> 0) then OUT_QTY_FREE = :OUT_QTY_FREE - :EXTRA_CORRECT;
             if (:PRICE_CORRECT <> 0) then OUT_PRICE_POST = round_f(:OUT_PRICE_POST - :PRICE_CORRECT, :round_to);
             if (:QTY_CORRECT <> 0 or :EXTRA_CORRECT <> 0 or :PRICE_CORRECT <> 0) then OUT_SUM_PRICE = round_f((:OUT_QTY_POST - :OUT_QTY_FREE) * :OUT_PRICE_POST, :round_to);
          end
          suspend;
        end
      end
    end
    /* ACCOUNT POST CORRECTIONS  */
    if (:IN_INCLUDE in (1, 2)) then begin
      OUT_QTY_POST_ORIG = null;
      OUT_QTY_FREE_ORIG = null;
      OUT_PRICE_POST_ORIG = null;
      OUT_SUM_PRICE_ORIG = null;
      OLD_ID_GUEST =  null ;
      OLD_ID_SERVICE = null;
      if (:IN_ID_DOC_HEAD = -1) then begin
        for
          select APC.ID_ACCOUNT_POST, APC.ID_ACC_POST_CORRECT, APC.ID_ACCOUNT, APC.ID_SERVICE,  0, APC.IS_POSITIVE,
                 APC.CORRECTION_DATE, APC.USER_CORRECT, APC.CORRECTION_DATE, substring(APC.REASON_OF_CORRECT from 1 for 20), null,
                 round_f((APC.QTY_CORRECT*APC.IS_QTY_CORRECT + APC.NEW_QTY*APC.IS_PRICE_CORRECT)*(1 + APC.IS_QTY_CORRECT*(APC.IS_POSITIVE - 1)*2), :round_to) SUM_QTY,
                 round_f(APC.EXTRA_QTY_CORRECT, :round_to) SUM_EXTRA_QTY,
                 round_f((APC.PRICE_CORRECT*APC.IS_PRICE_CORRECT + APC.NEW_PRICE*APC.IS_QTY_CORRECT)*(1 + APC.IS_PRICE_CORRECT*(APC.IS_POSITIVE - 1)*2), :round_to) PRICE,
                 round_f((APC.QTY_CORRECT*APC.NEW_PRICE + APC.NEW_QTY*APC.PRICE_CORRECT)*(APC.IS_POSITIVE*2 - 1), :round_to) SUM_QTY_PRICE,
                 APC.NEW_CURR_POST, 0, 1 + APC.IS_PRICE_CORRECT, APC.ID_GUEST, AP.ROOM_NAME
          from   ACCOUNT_POST_CORRECTION APC
                 join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = APC.ID_ACCOUNT_POST
          where   APC.ID_ACCOUNT = :MY_ID_ACCOUNT
                 and ((APC.IS_OPEN = (1 - :IN_IS_CLOSED)) or (:IN_IS_CLOSED = -1))
                 and (APC.ID_DOC_HEAD + APC.IS_OPEN) > -1
                 and :IN_IS_ANUL = 0
          into   :OUT_ID_ACCOUNT_POST, :OUT_ID_CORRECT_POST, :OUT_ID_ACCOUNT, :OUT_ID_SERVICE, :OUT_IS_BASE, :IS_POSITIVE,
                 :OUT_DATE_POST, :OUT_USER_CHANGED, :OUT_DATETIME_CHANGED, :OUT_CHANGE_TEXT, :OUT_PREV_POST,
                 :OUT_QTY_POST, :OUT_QTY_FREE, :OUT_PRICE_POST, :OUT_SUM_PRICE,
                 :OUT_CURR_POST, :OUT_IS_ANUL, :OUT_IS_CORRECT, :OUT_ID_GUEST, :OUT_ROOM_NAME
        do begin
          if (:OLD_ID_GUEST is distinct from :OUT_ID_GUEST) then begin
            OUT_DATE_CAME = null;
            OUT_ID_ROOM = null;
            OUT_GUEST_NAME = null;
            select G.FROM_DATE, G.ID_ROOM, GC.GUEST_NAME1
            from   GUEST G
                   left outer join GUEST_CARD GC on G.ID_GUEST = GC.ID_GUEST
            where  G.ID_GUEST = :OUT_ID_GUEST
            into  :OUT_DATE_CAME, :OUT_ID_ROOM, :OUT_GUEST_NAME;
          end
          if ((:OLD_ID_SERVICE is null) or (:OUT_ID_SERVICE <> :OLD_ID_SERVICE)) then  begin
            select S.SERVICE_NAME, S.ID_SERVICE_GROUP, SG.GROUP_NAME
            from   SERVICES S
                   left outer join SERVICE_GROUPS SG on S.ID_SERVICE_GROUP = SG.ID_SERVICE_GROUP
            where  S.ID_SERVICE = :OUT_ID_SERVICE
            into   :OUT_SERVICE_NAME, :OUT_ID_SERVICE_GROUP, :OUT_SRV_GROUP_NAME;
            if (:IS_POSITIVE = 1) then STRCORR = ' + '||:STRCORRECTION||':';
            else STRCORR = ' - '||:STRCORRECTION||':';
            OUT_SRV_GROUP_NAME  = :STRCORR||:OUT_SRV_GROUP_NAME;
            OUT_SERVICE_NAME    = :STRCORR||:OUT_SERVICE_NAME;
          end
          OLD_ID_GUEST =  :OUT_ID_GUEST ;
          OLD_ID_SERVICE = :OUT_ID_SERVICE;
          suspend;
        end
      end else begin
        /* JOIN TO DOCUMENT */
        for
          select APC.ID_ACCOUNT_POST, APC.ID_ACC_POST_CORRECT, APC.ID_ACCOUNT, APC.ID_SERVICE,  0, APC.IS_POSITIVE,
                 APC.CORRECTION_DATE, APC.USER_CORRECT, APC.CORRECTION_DATE, substring(APC.REASON_OF_CORRECT from 1 for 20), null,
                 round_f((APC.QTY_CORRECT*APC.IS_QTY_CORRECT + APC.NEW_QTY*APC.IS_PRICE_CORRECT)*(1 + APC.IS_QTY_CORRECT*(APC.IS_POSITIVE - 1)*2), :round_to) SUM_QTY,
                 round_f(APC.EXTRA_QTY_CORRECT, :round_to) SUM_EXTRA_QTY,
                 round_f((APC.PRICE_CORRECT*APC.IS_PRICE_CORRECT + APC.NEW_PRICE*APC.IS_QTY_CORRECT)*(1 + APC.IS_PRICE_CORRECT*(APC.IS_POSITIVE - 1)*2), :round_to) PRICE,
                 round_f((APC.QTY_CORRECT*APC.NEW_PRICE + APC.NEW_QTY*APC.PRICE_CORRECT)*(APC.IS_POSITIVE*2 - 1), :round_to) SUM_QTY_PRICE,
                 APC.NEW_CURR_POST, 0, 1 + APC.IS_PRICE_CORRECT, APC.ID_GUEST, AP.ROOM_NAME
          from   ACCOUNT_POST_CORRECTION APC
                 join ACCOUNT_POST AP on AP.ID_ACCOUNT_POST = APC.ID_ACCOUNT_POST
          where  APC.ID_ACCOUNT = :MY_ID_ACCOUNT
                 and ((:IN_IS_CLOSED = -1) or (APC.IS_OPEN = (1 - :IN_IS_CLOSED)))
                 and (APC.ID_DOC_HEAD + APC.IS_OPEN) > -1
                 and AP.ID_BASE_DOC = :IN_ID_DOC_HEAD /*((APC.ID_DOC_HEAD = :IN_ID_DOC_HEAD) or
                     (DL.IS_CORRECT = 0 and DL.ID_DOC_HEAD = :IN_ID_DOC_HEAD))*/
                 and :IN_IS_ANUL = 0
          into   :OUT_ID_ACCOUNT_POST, :OUT_ID_CORRECT_POST, :OUT_ID_ACCOUNT, :OUT_ID_SERVICE, :OUT_IS_BASE, :IS_POSITIVE,
                 :OUT_DATE_POST, :OUT_USER_CHANGED, :OUT_DATETIME_CHANGED, :OUT_CHANGE_TEXT, :OUT_PREV_POST,
                 :OUT_QTY_POST, :OUT_QTY_FREE, :OUT_PRICE_POST, :OUT_SUM_PRICE,
                 :OUT_CURR_POST, :OUT_IS_ANUL, :OUT_IS_CORRECT, :OUT_ID_GUEST, :OUT_ROOM_NAME
        do begin
          if (:OLD_ID_GUEST is distinct from :OUT_ID_GUEST) then begin
            OUT_DATE_CAME = null;
            OUT_ID_ROOM = null;
            OUT_GUEST_NAME = null;
            select G.FROM_DATE, G.ID_ROOM, GC.GUEST_NAME1
            from   GUEST G
                   left outer join GUEST_CARD GC on G.ID_GUEST = GC.ID_GUEST
            where  G.ID_GUEST = :OUT_ID_GUEST
            into   :OUT_DATE_CAME, :OUT_ID_ROOM, :OUT_GUEST_NAME;
          end
          if ((:OLD_ID_SERVICE is null) or (:OUT_ID_SERVICE <> :OLD_ID_SERVICE)) then  begin
            select S.SERVICE_NAME, S.ID_SERVICE_GROUP, SG.GROUP_NAME
            from   SERVICES S
                   left outer join SERVICE_GROUPS SG on S.ID_SERVICE_GROUP = SG.ID_SERVICE_GROUP
            where  S.ID_SERVICE = :OUT_ID_SERVICE
            into   :OUT_SERVICE_NAME, :OUT_ID_SERVICE_GROUP, :OUT_SRV_GROUP_NAME;
            if (:IS_POSITIVE = 1) then STRCORR = ' + '||:STRCORRECTION||':';
            else STRCORR = ' - '||:STRCORRECTION||':';
            OUT_SRV_GROUP_NAME  = :STRCORR||:OUT_SRV_GROUP_NAME;
            OUT_SERVICE_NAME    = :STRCORR||:OUT_SERVICE_NAME;
          end
          OLD_ID_GUEST =  :OUT_ID_GUEST ;
          OLD_ID_SERVICE = :OUT_ID_SERVICE;
          suspend;
        end
      end
    end
  end
end
^

/* Alter (AGENT_AGES_MODIFY$PROFILE) */
ALTER PROCEDURE AGENT_AGES_MODIFY$PROFILE(ID_AGENT_AGES INTEGER,
ID_AGENT INTEGER,
AGE_START INTEGER,
AGE_END INTEGER,
AGES_NAME VARCHAR(50),
IS_CHILD SMALLINT,
OPERATION VARCHAR(10))
 RETURNS(NEW_ID_AGENT_AGES INTEGER)
 AS
declare variable birth_day date;
declare variable from_date date;
declare variable g_dbkey char(8);
begin
  /* Procedure Text */
  execute procedure SYSTEM_CHECK_OPERATION (:OPERATION, 'add,mod,del');

  if (:operation = 'add') then begin
    insert into AGENT_AGES (ID_AGENT, AGE_START, AGE_END, AGES_NAME, IS_CHILD)
    values (:ID_AGENT, :AGE_START, :AGE_END, :AGES_NAME, :IS_CHILD)
    returning ID_AGENT_AGES
    into      :NEW_ID_AGENT_AGES;

  end else if (:operation = 'mod') then begin
    update AGENT_AGES
    set    ID_AGENT = :ID_AGENT,
           AGE_START = :AGE_START,
           AGE_END = :AGE_END,
           AGES_NAME = :AGES_NAME,
           IS_CHILD = :IS_CHILD
    where  ID_AGENT_AGES = :ID_AGENT_AGES;

    NEW_ID_AGENT_AGES = :ID_AGENT_AGES;

    for
      select gc.BIRTH_DAY, g.FROM_DATE, g.RDB$DB_KEY
      from   GUEST G
             left join GUEST_CARD GC on gc.ID_GUEST = g.ID_GUEST
      where  G.ID_AGENT = :ID_AGENT
             and gc.BIRTH_DAY is not null
      into   :birth_day, :from_date, :g_dbkey
    do begin
      execute procedure GUEST_GET_AGENT_AGES(:ID_AGENT, :birth_day, :from_date)
      returning_values  :id_agent_ages;

      update GUEST G
      set    g.ID_AGENT_AGES = :ID_AGENT_AGES
      where  g.RDB$DB_KEY = :g_dbkey;
    end 
  end else if (:operation = 'del') then begin
    delete from  AGENT_AGES AA
    where  AA.ID_AGENT_AGES = :ID_AGENT_AGES;

    NEW_ID_AGENT_AGES = null;
  end
end
^

/* Alter (DOC_LINES_SUSPEND_INVOICE) */
ALTER PROCEDURE DOC_LINES_SUSPEND_INVOICE(ID_DOC_HEAD INTEGER,
CORRECTION_INDEX INTEGER,
RPT_TYPE VARCHAR(20),
RPT_CURR VARCHAR(10),
RPT_VAT VARCHAR(20),
IN_VAUCHER_NUM VARCHAR(20))
 RETURNS(TAX_STATUS INTEGER,
ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
VAUCHER_NUM VARCHAR(20),
GUEST_NAME VARCHAR(100),
IS_CHILD INTEGER,
AGES_NAME VARCHAR(50),
GFROM_DATE DATE,
GTO_DATE DATE,
PACKET_NAME VARCHAR(50),
LINE_NAME VARCHAR(100),
ID_SERVICE INTEGER,
DATE_POST DATE,
QTY_POST NUMERIC(15,2),
SINGLE_PRICE NUMERIC(15,4),
LINE_VALUE NUMERIC(15,4),
PACKET_PRICE NUMERIC(15,4),
PACKET_PRICE_WOT_DIFF DOUBLE PRECISION,
ID_TARIFA INTEGER,
BIRTH_DATE DATE,
NIGHTS INTEGER,
IS_BASE INTEGER)
 AS
declare variable doc_vat_status integer;
  declare variable dl_dbkey char(8);
  declare variable no_use varchar(255);
begin
  /*  Description:
  ||  RPT_TYPE - PACKETS, OTHER, TAX_STATUS, TAXES
  */
  select DT.IS_VAT
  from   DOC_HEAD$INT DH
         join DOC_TYPE DT on DT.ID_DOC_TYPE = DH.ID_DOC_TYPE
  where  DH.ID_DOC_HEAD = :ID_DOC_HEAD
  into   :DOC_VAT_STATUS;

  if (:RPT_TYPE = 'PACKETS') then begin
    for
      select DL.RDB$DB_KEY, DL.TAX_STATUS, DL.ID_GUEST, DL.DATE_POST, G.ID_TARIFA, PV.IS_BASE,
             GC.GUEST_NAME1, G.IS_CHILD, AG.AGES_NAME, G.FROM_DATE, G.TO_DATE, G.ID_RESERV_DETAIL,
             case when coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'SECONDARY' then G.VAUCHER_NUM2 else G.VAUCHER_NUM end,
             GC.BIRTH_DAY, S.ID_SERVICE
      from   DOC_LINE DL
             join SERVICES S on S.ID_SERVICE = DL.ID_SERVICE
             left outer join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE
             left outer join GUEST G on G.ID_GUEST = DL.ID_GUEST
             left outer join AGENT_PACKET APA on APA.ID_AGENT = G.ID_AGENT and APA.ID_SERVICE = DL.ID_SERVICE
             left outer join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
             left outer join AGENT_AGES AG on AG.ID_AGENT_AGES = G.ID_AGENT_AGES
             left outer join AGENT_TYPE_STAY ATS on ATS.ID_AGENT = G.ID_AGENT and ATS.ID_SERVICE = case when coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'BASE' then PV.ID_PACK_SERVICE else DL.ID_SERVICE end
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
             and ((PV.IS_BASE = 1) or (coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) in ('SECONDARY', 'PARALLEL')))
             and ((:IN_VAUCHER_NUM = '') or (case when coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'SECONDARY' then G.VAUCHER_NUM2 else G.VAUCHER_NUM end = :IN_VAUCHER_NUM))
      into   :DL_DBKEY, :TAX_STATUS, :ID_GUEST, :DATE_POST, :ID_TARIFA, :IS_BASE,
             :GUEST_NAME, :IS_CHILD, :AGES_NAME, :GFROM_DATE, :GTO_DATE, :ID_RESERV_DETAIL,
             :VAUCHER_NUM, :BIRTH_DATE, :ID_SERVICE
    do begin
      if (:IS_BASE = 0) then begin
        execute procedure DOC_LINES_SUSPEND_LINE(:DL_DBKEY, :RPT_CURR, :RPT_VAT, 'NONE', :DOC_VAT_STATUS, :CORRECTION_INDEX)
        returning_values :NO_USE, :PACKET_NAME, :PACKET_PRICE, :PACKET_PRICE_WOT_DIFF, :SINGLE_PRICE, :LINE_VALUE,
                         :NO_USE, :NO_USE, :QTY_POST, :QTY_POST, :NO_USE, :NO_USE, :NO_USE;

        PACKET_PRICE = :LINE_VALUE;
        NIGHTS = 0;
      end else begin
        execute procedure DOC_LINES_SUSPEND_LINE(:DL_DBKEY, :RPT_CURR, :RPT_VAT, 'IN_PACKET', :DOC_VAT_STATUS, :CORRECTION_INDEX)
        returning_values :ID_SERVICE, :PACKET_NAME, :PACKET_PRICE, :PACKET_PRICE_WOT_DIFF, :NO_USE, :NO_USE,
                         :NO_USE, :NO_USE, :QTY_POST, :QTY_POST, :NO_USE, :NO_USE, :NO_USE;                                      

        NIGHTS = 1;
      end
      suspend;
    end
  end if (:RPT_TYPE = 'OTHER') then begin
    for
      select DL.RDB$DB_KEY, DL.LINE_NAME, G.ID_GUEST, G.ID_RESERV_DETAIL, DL.ID_SERVICE
      from   DOC_LINE DL
             join SERVICES S on S.ID_SERVICE = DL.ID_SERVICE
             left outer join DOC_LINE_POST_VALUES PV on PV.ID_DOC_LINE = DL.ID_DOC_LINE
             left outer join GUEST G on G.ID_GUEST = DL.ID_GUEST
             left outer join AGENT_PACKET APA on APA.ID_AGENT = G.ID_AGENT and APA.ID_SERVICE = DL.ID_SERVICE
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
             and DL.TAX_STATUS in (0, 1)
             and coalesce(PV.IS_BASE, 0) = 0
             and (/*(coalesce(PV.ID_MASTER_ADDINS, -1) = -1)
                  or*/ (coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) = 'OTHER')
                  or ((coalesce(APA.VAUCHER_PACKET, S.VAUCHER_PACKET) not in ('SECONDARY', 'PARALLEL'))
                       and not exists (select DML.ID_DOC_LINE
                                  from   DOC_LINE DML
                                         join DOC_LINE_POST_VALUES DPV on DPV.ID_DOC_LINE = DML.ID_DOC_LINE
                                  where  DML.ID_DOC_HEAD = DL.ID_DOC_HEAD
                                         and DPV.ID_ACCOUNT_POST = PV.ID_MASTER_ADDINS)) )
      into   :DL_DBKEY, :LINE_NAME, :ID_GUEST, :ID_RESERV_DETAIL, :ID_SERVICE
    do begin
      execute procedure DOC_LINES_SUSPEND_LINE(:DL_DBKEY, :RPT_CURR, :RPT_VAT, 'NONE',
        :DOC_VAT_STATUS, :CORRECTION_INDEX)
      returning_values (:NO_USE, :NO_USE, :PACKET_PRICE,
        :PACKET_PRICE_WOT_DIFF, :SINGLE_PRICE, :LINE_VALUE, :NO_USE, :NO_USE,
        :QTY_POST, :QTY_POST, :NO_USE, :NO_USE, :NO_USE);
      suspend;
    end
  end if (:RPT_TYPE = 'TAXES') then begin
    for
      select DL.RDB$DB_KEY, DL.LINE_NAME, DL.ID_SERVICE
      from   DOC_LINE DL
      where  DL.ID_DOC_HEAD = :ID_DOC_HEAD
             and DL.TAX_STATUS > 1
      into   :DL_DBKEY, :LINE_NAME, :ID_SERVICE
    do begin
      execute procedure DOC_LINES_SUSPEND_LINE(:DL_DBKEY, :RPT_CURR, :RPT_VAT, 'NONE',
        :DOC_VAT_STATUS, :CORRECTION_INDEX)
      returning_values (:NO_USE, :NO_USE, :PACKET_PRICE,
        :PACKET_PRICE_WOT_DIFF, :SINGLE_PRICE, :LINE_VALUE, :NO_USE, :NO_USE,
        :QTY_POST, :QTY_POST, :NO_USE, :NO_USE, :NO_USE);
      suspend;
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_POST_TO_FRONT_ONLINE for: EAI_EXT_POST_TO_MH_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_EXT_POST_TO_MH_FRONT_ONLINE) */
ALTER PROCEDURE EAI_EXT_POST_TO_MH_FRONT_ONLINE(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  if (:CODE_TYPE = 'EXT_CODE') then begin
    execute procedure EAI_MAP_SERVICE(:SERVICE_CODE, :SERVICE_CODE, 'UNKNOWN', :id_hotel)
    returning_values  :ERR_CODE, :ERR_TEXT, :ID_SERVICE;
    if (:ERR_CODE < 0) then exit;
  end else begin
    select S.ID_SERVICE
    from   SERVICES S
    where  S.ID_SERVICE = :SERVICE_CODE
           and s.ID_HOTEL = :ID_HOTEL
    into   :ID_SERVICE;
    if (:ID_SERVICE is null) then begin
      ERR_CODE = -85;   /* Wrong value! */
      exit;
    end
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:ID_ACCOUNT_POST, :SERVICE_CODE, null, null);

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* empty dependent procedure body */
/* Clear: EAI_EXT_ROOM_STATUS for: EAI_EXT_ROOM_GUESTS */
ALTER PROCEDURE EAI_EXT_ROOM_STATUS(ROOMS_FILTER VARCHAR(512) = '',
ID_HOTEL INTEGER = null)
 RETURNS(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
GUEST_NAME2 VARCHAR(50),
ROOM_NAME VARCHAR(10),
FROM_DATE DATE,
TO_DATE DATE,
COUNTRY VARCHAR(30),
AGE INTEGER,
ID_AGENT INTEGER,
ID_GROUP INTEGER,
SEX CHAR,
GUEST_CODE VARCHAR(50),
GUESTS_IN_ROOM INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (EAI_EXT_ROOM_GUESTS) */
ALTER PROCEDURE EAI_EXT_ROOM_GUESTS(IN_ROOM_NAME VARCHAR(10),
ID_HOTEL INTEGER = null)
 RETURNS(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ROOM_NAME VARCHAR(10),
FROM_DATE DATE,
TO_DATE DATE,
COUNTRY VARCHAR(30),
AGE INTEGER,
ID_AGENT INTEGER,
ID_GROUP INTEGER,
SEX CHAR,
GUEST_CODE VARCHAR(50))
 AS
declare variable birth_day date;
  declare variable sys_date date;
begin
  IN_ROOM_NAME = trim(:IN_ROOM_NAME);

  if (:ID_HOTEL is null) then begin
    if (singular(select RO.ID_ROOM
                 from ROOMS RO
                    join HOTEL_S HO on HO.ID_HOTEL = RO.ID_HOTEL
                 where RO.ROOM_NAME = :in_room_name
                       and HO.IS_USE = 1)) then
      select HS.ID_HOTEL
      from   ROOMS ROO
        join HOTEL_S HS on HS.ID_HOTEL = ROO.ID_HOTEL
      where ROO.ROOM_NAME = :in_room_name
            and HS.IS_USE = 1
      into :id_hotel;
    else
      exception assert '-1044';
  end

  select SYSTEM_DATE
  from   SYSTEM_DATE_GET (:ID_HOTEL)
  into   :SYS_DATE;

  for
    select G.ID_GUEST, GC.GUEST_NAME1, GC.GUEST_NAME2,
           G.FROM_DATE, G.TO_DATE, R.ROOM_NAME,
           GC.COUNTRY, G.ID_AGENT,
           GC.BIRTH_DAY, GC.SEX, GC.GUEST_CODE
    from   GUEST G
           join ROOMS R on R.ID_ROOM = G.ID_ROOM
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
           left join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
    where  G.FROM_DATE <= :SYS_DATE
           and G.TO_DATE >= :SYS_DATE
           and G.CHECK_STATUS < 1
           and rd.IS_ANUL = 0
           and ((R.ROOM_NAME  = :IN_ROOM_NAME)
                or
                (:IN_ROOM_NAME = ''))
    order by R.ROOM_NAME asc, G.ID_GUEST asc
    into   :ID_GUEST, :GUEST_NAME1, :GUEST_NAME2,
           :FROM_DATE, :TO_DATE, :ROOM_NAME,
           :COUNTRY, :ID_AGENT,
           :BIRTH_DAY, :SEX, :GUEST_CODE
  do begin
    select CA.AGE_INYEARS
    from   SYSTEM_CALC_AGE_INYEARS (:BIRTH_DAY, :FROM_DATE) CA
    into   :AGE;

    suspend;
  end
end
^

/* Alter (EAI_EXT_ROOM_STATUS) */
ALTER PROCEDURE EAI_EXT_ROOM_STATUS(ROOMS_FILTER VARCHAR(512) = '',
ID_HOTEL INTEGER = null)
 RETURNS(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
GUEST_NAME2 VARCHAR(50),
ROOM_NAME VARCHAR(10),
FROM_DATE DATE,
TO_DATE DATE,
COUNTRY VARCHAR(30),
AGE INTEGER,
ID_AGENT INTEGER,
ID_GROUP INTEGER,
SEX CHAR,
GUEST_CODE VARCHAR(50),
GUESTS_IN_ROOM INTEGER)
 AS
declare variable sys_date date;
  declare variable is_free integer;
begin
  if (:ID_HOTEL is null) then begin
    if (singular(select HS.ID_HOTEL
                 from HOTEL_S HS
                 where HS.IS_USE = 1)) then
      select H.ID_HOTEL
      from   HOTEL_S H
      where  H.IS_USE = 1
      into   :id_hotel;
    else
      exception assert '-1044';
  end

  select SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel)
  into   :SYS_DATE;

  for
    select R.ROOM_NAME,
           sum(Ro.ARRIVAL_ADULTS + ro.ARRIVAL_CHILDREN + ro.STAYOVER_ADULTS + ro.STAYOVER_CHILDREN),
           iif(sum(ro.ARRIVAL_ROOM + ro.STAYOVER_ROOM + ro.OOI_ROOM) > 0, 0, 1)
    from   ROOMS r
           join ROOM_PERIOD$PMS rp on rp.ID_ROOM = r.ID_ROOM
           left outer join HOTEL_ROOM_OCCUPANCY ro on ro.ID_ROOM = r.ID_ROOM
                                                      and ro.BUSY_DATE = :sys_date
                                                      and ro.ID_HOTEL = :ID_HOTEL
    where  r.ID_HOTEL = :ID_HOTEL
           and rp.FROM_DATE <= :sys_date
           and rp.TO_DATE >= :sys_date
           and rp.STATUS in ('HOTEL', 'CONTRACT')
    group by 1
    into   :room_name, :guests_in_room, :is_free
  do begin
    if (:is_free = 1) then begin
      id_guest = null;
      guest_name1 = null;
      guest_name2 = null;
      from_date = null;
      to_date = null;
      country = null;
      id_agent = null;
      id_group = null;
      sex = null;
      guests_in_room = 0;
      guest_code = null;
      suspend;
    end else begin
      for
        select RG.ID_GUEST, RG.GUEST_NAME1, RG.GUEST_NAME2, RG.FROM_DATE, RG.TO_DATE,
               RG.COUNTRY, RG.ID_AGENT, RG.ID_GROUP, RG.SEX, RG.GUEST_CODE, rg.AGE
        from   EAI_EXT_ROOM_GUESTS(:room_name) RG
        into   :id_guest, :guest_name1, :guest_name2, :from_date, :to_date,
               :country, :id_agent, :id_group, :sex, :guest_code, :AGE
      do suspend;
    end
  end
end
^

/* Alter (EAI_EXT_SERVICE_POST) */
ALTER PROCEDURE EAI_EXT_SERVICE_POST(ID_HOTEL INTEGER,
ROOM_NAME VARCHAR(10),
SERVICE_EXT_CODE VARCHAR(30),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable max_id_service integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  ID_ROOM  = null;
  ID_SERVICE  = null;

  execute procedure ROOM_GET_BY_NAME (:ROOM_NAME, :ID_HOTEL)
  returning_values (:ID_ROOM);

  /* PARAM CODE_TYPE SHOULD BE 'ID' OR 'EXT_CODE' */
  select min(S.ID_SERVICE) as id_service, max(s.id_service) as max_id_service
  from   SERVICES S
  where  S.EXT_CODE = :SERVICE_EXT_CODE
         and s.IS_BASE = 0
         and s.IS_DELETED = 0
  into   :ID_SERVICE, :max_id_service;
  if (:ID_SERVICE is null) then begin
      ERR_CODE = -388;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end else if (:ID_SERVICE <> :max_id_service) then begin
      ERR_CODE = -389;   /* Wrong value! */
      err_text = f_character(29) || :service_ext_code || f_character(28);
      exit;
  end

  /* CHECK QTY, PRICE AND CURRENCY  */
  if (:PRICE_POST is not null and not exists (select * from CURRS C where C.CURR = :CURR_POST)) then begin
    ERR_CODE = -218;  /* Invalid currency! */
    exit;
  end
  if ((:QTY_POST <= 0) or (:PRICE_POST < 0)) then begin
    ERR_CODE = -85;   /* Wrong value! */
    exit;
  end

  /* POST SERVICE */
  execute procedure POST_SERVICE_ON_ROOM(:ID_ROOM, :ID_SERVICE, :QTY_POST, 0, iif(:PRICE_POST is not null, 1, 0),
    :PRICE_POST, :CURR_POST, current_timestamp, current_timestamp, :POST_TEXT, :ROOM_NAME, null, :SERVICE_EXT_CODE)
  returning_values :ERR_CODE, :ERR_TEXT, :ID_GUEST, :ID_ACCOUNT, :ID_ACCOUNT_POST;
  if (:ERR_CODE <> 0) then exit;

  insert into ACCOUNT_POST_EXTERNAL (ID_ACCOUNT_POST, EXT_CODE, EXT_USER_CREATED, EXT_DT_CREATED)
  values (:ID_ACCOUNT_POST, :SERVICE_EXT_CODE, null, null);

  select GC.GUEST_NAME1
  from   GUEST_CARD GC
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME1;
end
^

/* Alter (EAI_POS_CHECK_CARD$P2E) */
ALTER PROCEDURE EAI_POS_CHECK_CARD$P2E(IN_CARD_NUMBER VARCHAR(50),
ID_HOTEL INTEGER)
 RETURNS(ID_GUEST INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100),
GUEST_NAME VARCHAR(100),
ROOM_NAME VARCHAR(20),
BOARD_NAME VARCHAR(30))
 AS
declare variable id_guest_check integer;
  declare variable check_status integer;
  declare variable to_date date;
  declare variable check_date date;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';

  if (coalesce(:IN_CARD_NUMBER, '') = '') then begin
     ERR_CODE = -401;
     ERR_TEXT = '';
     suspend;
     exit ;
  end

  select max(GD.ID_GUEST), min(GD.ID_GUEST)
  from   GUEST_DATA GD
         join GUEST G on G.ID_GUEST = GD.ID_GUEST
         join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
  where  GD.GUEST_CODE = :IN_CARD_NUMBER
         and RD.ID_HOTEL = :ID_HOTEL
         and rd.IS_ANUL = 0
         and rd.CHECK_STATUS >= 0
  into   :ID_GUEST, :ID_GUEST_CHECK;

  if (:ID_GUEST is null) then begin
     ERR_CODE = -402;
     ERR_TEXT = '';
     suspend;
     exit;
  end

  if (:ID_GUEST <> :ID_GUEST_CHECK) then begin
     ERR_CODE = -403;
     ERR_TEXT = '';
     suspend;
     exit;
  end
  /*FIND SYSTEM DATE - check to today, not to system date - for security*/

  select  TO_DATE, G.CHECK_STATUS
  from    GUEST G
  where   ID_GUEST = :ID_GUEST
  into    :TO_DATE, :CHECK_STATUS;

  if ((:TO_DATE < current_date) or (:CHECK_STATUS = 1)) then  begin
     ERR_CODE = -404;
     ERR_TEXT = '';
     suspend;
     exit;
  end

  check_date = iif(current_date = :to_date, current_date - 1, current_date);

  select GC.GUEST_NAME1, R.ROOM_NAME,
         (select m.NAME
          from   GUEST_STAY gs
                 join MEALS M on m.ID_BOARD = gs.ID_BOARD
          where  gs.ID_GUEST = g.ID_GUEST
                 and gs.FOR_DATE = :check_date)
  from   GUEST_CARD GC
         join GUEST G on G.ID_GUEST = GC.ID_GUEST
         join ROOMS R on G.ID_ROOM = R.ID_ROOM
  where  GC.ID_GUEST = :ID_GUEST
  into   :GUEST_NAME, :ROOM_NAME, :BOARD_NAME;

  suspend;
end
^

/* Alter (EAI_POS_GET_GUESTS$P2E) */
ALTER PROCEDURE EAI_POS_GET_GUESTS$P2E(IN_ROOM_NAME VARCHAR(20),
ID_HOTEL INTEGER)
 RETURNS(OUT_ID_GUEST INTEGER,
OUT_GUEST_NAME VARCHAR(100),
OUT_FROM_DATE DATE,
OUT_TO_DATE DATE,
OUT_OK_FOR_POST INTEGER,
OUT_COUNTRY VARCHAR(30),
OUT_TEXT VARCHAR(100),
OUT_BOARD_NAME VARCHAR(30),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(100))
 AS
declare variable id_room integer;
begin
  ERR_CODE = 0;
  ERR_TEXT = '';
  OUT_GUEST_NAME = null;

  /*FIND ROOM*/
  select R.ID_ROOM
  from   ROOMS R
         join ROOM_TYPES RT on RT.ID_ROOM_TYPE = R.ID_ROOM_TYPE
  where  R.ROOM_NAME = :IN_ROOM_NAME
         and RT.ID_HOTEL = :ID_HOTEL
  into   :ID_ROOM;
  if ((:ID_ROOM is null) or (:ID_ROOM <= 0) ) then begin
    ERR_CODE = -5;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Room number not found! Няма такъв номер стая! ';
    suspend;
    exit;
  end

  /*FIND GUESTS*/
  for
    select G.ID_GUEST, GC.GUEST_NAME1, G.FROM_DATE, G.TO_DATE, C.COUNTRY_NAME,
           (select m.NAME
            from   GUEST_STAY gs
                   join MEALS M on m.ID_BOARD = gs.ID_BOARD
            where  gs.ID_GUEST = g.ID_GUEST
                   and gs.FOR_DATE = iif(current_date = g.to_date, current_date - 1, current_date))
    from   GUEST G
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
           left outer join GUEST_CARD GC on G.ID_GUEST = GC.ID_GUEST
           left outer join COUNTRY C on C.COUNTRY_CODE = GC.COUNTRY
    where  G.ID_ROOM = :ID_ROOM
           and G.CHECK_STATUS = 0
           and rd.IS_ANUL = 0
    into   :OUT_ID_GUEST, :OUT_GUEST_NAME, :OUT_FROM_DATE,  :OUT_TO_DATE, :OUT_COUNTRY, :OUT_BOARD_NAME
  do begin
    OUT_OK_FOR_POST = iif(:OUT_TO_DATE < current_date, 0, 1) ;
    suspend;
  end

  if (:OUT_GUEST_NAME is null) then begin
    ERR_CODE = -1;
    OUT_OK_FOR_POST = 0;
    OUT_GUEST_NAME = 'Guests not found! Няма гости в тази стая!';
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTING$INT for: GUEST_AGENT_SET$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (GUEST_AGENT_SET$INT) */
ALTER PROCEDURE GUEST_AGENT_SET$INT(G_DBKEY CHAR(8),
NEW_ID_AGENT_PROFILE INTEGER)
 AS
declare variable id_guest integer;
  declare variable old_id_agent integer;
  declare variable new_id_agent integer;
  declare variable from_date date;
  declare variable birth_day date;
  declare variable id_agent_ages integer;
  declare variable is_check_in smallint;
begin

  new_id_agent = null;
  select PA.ID_AGENT
  from   PROFILE_AGENT PA
  where  PA.ID_PROFILE = :new_id_agent_profile
  into   :new_id_agent;

  select G.ID_AGENT, G.ID_GUEST, g.FROM_DATE, g.IS_CHECK_IN
  from   GUEST G
  where  G.RDB$DB_KEY = :g_dbkey
  into   :old_id_agent, :id_guest, :from_date, :is_check_in;

  -- new_id_agent = iif(:is_different_organizer = 1, null, :new_id_agent);
  -- different arranged guests can be walkins only

  if (:new_id_agent is distinct from :old_id_agent) then begin
    update GUEST G
    set    G.ID_AGENT = :new_id_agent
    where  G.RDB$DB_KEY = :g_dbkey;

    if (:is_check_in = 1) then begin
      execute procedure GUEST_REGISTRATION_UPDATE(:id_guest);
    end
  end

  if (:new_id_agent is distinct from :old_id_agent) then begin
    select gc.BIRTH_DAY
    from   GUEST_CARD GC
    where  gc.ID_GUEST = :id_guest
    into   :birth_day;

    execute procedure GUEST_GET_AGENT_AGES(:new_id_agent, :birth_day, :from_date)
    returning_values  :id_agent_ages;

    update GUEST G
    set    g.ID_AGENT_AGES = :id_agent_ages
    where  g.RDB$DB_KEY = :G_DBKEY;
  end
end
^

/* empty dependent procedure body */
/* Clear: GUEST_ADDRESSCARD_SET$RSV for: GUEST_SET_STATUS$INT */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$RSV(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
EGN VARCHAR(30),
COUNTRY VARCHAR(10),
ID_STAY_REASON INTEGER,
IS_REGISTRED INTEGER,
PASS_PLACE VARCHAR(20),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_PLACE VARCHAR(30),
SEX CHAR,
MASK VARCHAR(10),
IS_CHILD INTEGER,
CAR VARCHAR(30),
KPP INTEGER,
KPP_DATE DATE,
PASS_EXP_DATE DATE,
AGE INTEGER,
BIRTH_DAY DATE,
VISA /* TDESCRIPTION_SHORT */ VARCHAR(100),
RATING_AGE INTEGER = null,
TITLE VARCHAR(10) = null,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_CHECK_OUT_GUESTS$RSV for: GUEST_SET_STATUS$INT */
ALTER PROCEDURE RES_CHECK_OUT_GUESTS$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND SMALLINT = 0,
EARLYCHECKOUT_DATE DATE = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_ADD$INT for: GUEST_SET_STATUS$INT */
ALTER PROCEDURE RES_GUEST_ADD$INT(RD_DBKEY CHAR(8),
IS_CHILD INTEGER,
INITIALIZE_BOOKING /* TYPE OF TLOGICAL */ SMALLINT = 0)
 RETURNS(NEW_ID_GUEST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_AUTO$INT for: GUEST_SET_STATUS$INT */
ALTER PROCEDURE RES_GUEST_AUTO$INT(G_DBKEY CHAR(8),
RD_DBKEY CHAR(8),
IS_NEW_GUEST SMALLINT)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_SAVE$RSV for: GUEST_SET_STATUS$INT */
ALTER PROCEDURE RES_GUEST_SAVE$RSV(ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
GUEST_NAME1 VARCHAR(100),
AGE INTEGER,
BIRTH_DAY DATE,
IS_CHILD INTEGER,
MASK VARCHAR(10) = null)
 RETURNS(NEW_ID_GUEST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_SAVE_DIFF$INT for: GUEST_SET_STATUS$INT */
ALTER PROCEDURE RES_GUEST_SAVE_DIFF$INT(RD_DBKEY CHAR(8))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_SAVE_OTHER$RSV for: GUEST_SET_STATUS$INT */
ALTER PROCEDURE RES_GUEST_SAVE_OTHER$RSV(ID_GUEST INTEGER,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_CHECKIN$INT for: GUEST_SET_STATUS$INT */
ALTER PROCEDURE RES_SET_CHECKIN$INT(RD_DBKEY CHAR(8))
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (GUEST_SET_STATUS$INT) */
ALTER PROCEDURE GUEST_SET_STATUS$INT(G_DBKEY CHAR(8),
CHECK_STATUS INTEGER)
 AS
declare variable old_check_status integer;
declare variable from_date date;
declare variable to_date date;
declare variable id_guest integer;
declare variable id_person_data_copy integer;
declare variable gd_dbkey char(8);
declare variable id_person_data integer;
declare variable id_guest_numerator integer;
declare variable guest_reg_number integer;
declare variable guest_reg_text varchar(20);

begin
  /*  Description:
  ||
  */
  select G.CHECK_STATUS, G.FROM_DATE, G.TO_DATE, G.ID_GUEST
  from   GUEST G
  where  G.RDB$DB_KEY = :g_dbkey
  into   :old_check_status, :from_date, :to_date, :id_guest;

  if (:check_status = -2) then begin
    /* MARKING THE GUEST AS AUTOMATIC,NEXT IS A PARANOID CHECK - MUST NEVER HAPPEN */
    if (:old_check_status >= 0) then begin
      exception WRONG_VALUE 'Only not arrived guests may be automatic ';
    end

    update GUEST G
    set    G.CHECK_STATUS = -2
    where  G.RDB$DB_KEY = :g_dbkey;
  end else if (:check_status = -1) then begin
    /* MARKING THE GUEST AS MANUAL */
    update GUEST G
    set    G.CHECK_STATUS = iif(G.CHECK_STATUS = -2, -1, G.CHECK_STATUS)
    where  G.RDB$DB_KEY = :g_dbkey;
  end else if (:check_status = 0) then begin
    select h.id_guest_numerator
    from guest g
        join reserv_detail rd on rd.id_reserv_detail = g.id_reserv_detail
        join hotel h on h.id_hotel = rd.id_hotel
    where  G.RDB$DB_KEY = :g_dbkey
    into :id_guest_numerator;

    execute procedure system_gen_num('GUEST_NUM', :id_guest_numerator)
    returning_values :guest_reg_number, :guest_reg_text;

    update GUEST G
    set    G.CHECK_STATUS = 0,
           g.CHECKED_IN_AT = current_timestamp,
           g.reg_number = :guest_reg_number
    where  G.RDB$DB_KEY = :g_dbkey;

    execute procedure GUEST_SET_EDIT_STATUS$INT (:G_DBKEY, 'CHECKING_IN', 'add');

    update GUEST_CHANGE_STATUS GC
    set    GC.FROM_DATE_ORIG = :from_date,
           GC.TO_DATE_ORIG = :to_date
    where  GC.ID_GUEST = :id_guest;
     
  end else if (:check_status = 1) then begin
    /* CHECK OUT */
    if (:old_check_status < 0) then exception BOOKING_EXCEPTION '-1006';

    select GD.RDB$DB_KEY, GD.ID_PERSON_DATA
    from   GUEST_DATA GD
    where  GD.ID_GUEST = :id_guest
    into   :gd_dbkey, :id_person_data;

    update GUEST G
    set    G.CHECK_STATUS = 1
    where  G.RDB$DB_KEY = :g_dbkey;

    execute procedure GUEST_SET_EDIT_STATUS$INT (:G_DBKEY, 'CHECKING_OUT', 'add');

    execute procedure PERSON_DATA_COPY$INT(:id_person_data)
    returning_values  :id_person_data_copy;

    update GUEST_DATA GD
    set    GD.ID_PERSON_DATA = :id_person_data_copy
    where  GD.RDB$DB_KEY = :gd_dbkey;
  end
end
^

/* empty dependent procedure body */
/* Clear: GUEST_ADDRESSCARD_SET$INT for: PERSON_DATA_SET$INT */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$INT(PD_DBKEY CHAR(8),
G_DBKEY CHAR(8),
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
COUNTRY_CODE VARCHAR(10),
IS_CHILD INTEGER,
AGE INTEGER,
BIRTH_DAY DATE,
TITLE VARCHAR(10))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_PERSON_CREATEQ$PROFILE for: PERSON_DATA_SET$INT */
ALTER PROCEDURE PROFILE_PERSON_CREATEQ$PROFILE(PROFILE_NAME /* TYPE OF TPERSON_NAME */ VARCHAR(100),
PHONE /* TYPE OF TPHONE */ VARCHAR(50),
ID_PASSPORT_TYPE /* TYPE OF ID */ INTEGER,
PASS_NUM /* TYPE OF NAME_20 */ VARCHAR(20),
EGN /* TYPE OF TTEXT_SHORT */ VARCHAR(30),
COUNTRY_CODE /* TYPE OF TSHORT_CODE */ VARCHAR(10),
CARD_CODE /* TYPE OF TCARD_CODE */ VARCHAR(50),
ID_PERSON_DATA /* TYPE OF ID_REF */ INTEGER = null,
TITLE /* TYPE OF TSHORT_CODE */ VARCHAR(10) = null,
ID_HOTEL /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_PROFILE /* TYPE OF ID */ INTEGER,
P_DBKEY /* TYPE OF TDB_KEY */ CHAR(8),
PD_DBKEY /* TYPE OF TDB_KEY */ CHAR(8))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: PROFILE_PERSON_MODIFY$PROFILE for: PERSON_DATA_SET$INT */
ALTER PROCEDURE PROFILE_PERSON_MODIFY$PROFILE(ID_PROFILE INTEGER,
ID_GUEST_TYPE INTEGER,
PROFILE_NAME VARCHAR(100),
PERSON_NAME2 VARCHAR(100),
SEX CHAR,
BIRTH_DAY DATE,
BIRTH_PLACE VARCHAR(30),
EGN VARCHAR(30),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
COUNTRY_CODE VARCHAR(20),
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
MASK VARCHAR(10),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
IS_ARCHIVE INTEGER,
ID_PHOTO INTEGER,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
TITLE VARCHAR(10) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PERSON_DATA_SET$INT) */
ALTER PROCEDURE PERSON_DATA_SET$INT(P_DBKEY CHAR(8),
PD_DBKEY CHAR(8),
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
COUNTRY VARCHAR(10),
BIRTH_DAY DATE,
BIRTHDAY_INTERNAL DATE,
TITLE VARCHAR(10) = null)
 AS
declare variable id_profile integer;
  declare variable id_guest integer;
  declare variable old_name varchar(100);
  declare variable old_country varchar(10);
  declare variable country_name varchar(50);
  declare variable action_text varchar(255);
  declare variable age integer;
  declare variable old_birthday date;
  declare variable id_person_data integer;
  declare variable old_title varchar(10);
begin

  select coalesce(:country, PD.COUNTRY_CODE), PD.BIRTH_DAY, PD.PERSON_NAME, PD.COUNTRY_CODE,
         pd.ID_PERSON_DATA, pd.TITLE
  from   PERSON_DATA PD
  where  PD.RDB$DB_KEY = :pd_dbkey
  into   :country, :old_birthday, :old_name, :old_country,
         :id_person_data, :old_title;

  update  PERSON_DATA PD
  set     PD.PERSON_NAME = :GUEST_NAME1,
          PD.PERSON_NAME2 = coalesce(:guest_name2, iif(PD.PERSON_NAME = PD.PERSON_NAME2, :guest_name1, PD.PERSON_NAME2)),
          PD.COUNTRY_CODE = :country,
          PD.BIRTH_DAY = coalesce(:birthday_internal, :birth_day), -- this is relative date, calculated by input age or equal to real birth day (if exists)
          PD.BIRTHDAY_INTERNAL = :birthday_internal, -- this is real person birth day (can be null)
          PD.TITLE = :TITLE
  where   PD.RDB$DB_KEY = :pd_dbkey;

  if ((:old_name is distinct from :GUEST_NAME1)
      or (:old_birthday is distinct from :BIRTH_DAY)
      or (:old_title is distinct from :TITLE)
      or (:old_country is distinct from :COUNTRY)) then
  begin
    -- update all related checked in and not checked out guest's cards
    for
      select GD.ID_GUEST
      from   GUEST_DATA GD
             join GUEST G on g.ID_GUEST = gd.ID_GUEST
      where  GD.ID_PERSON_DATA = :id_person_data
             and g.ID_RESERV_DETAIL is not null
             and g.IS_CHECK_IN = 1
             -- and g.IS_CHECK_OUT = 0
      into   :id_guest
    do begin
      select C.COUNTRY_NAME
      from   COUNTRY C
      where  C.COUNTRY_CODE = :COUNTRY
      into   :country_name;
  
      select CA.AGE_INYEARS
      from   SYSTEM_CALC_AGE_INYEARS (:birth_day, current_timestamp) CA
      into   :age;
  
      action_text = f_character(29) || '"' || :guest_name1 || '", ' || coalesce(:age, '') || ', ' || coalesce(:country_name, '');
      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'GUEST_IDENT_CHNG', :action_text);

      execute procedure GUEST_REGISTRATION_UPDATE(:id_guest);
    end
  end

  if (ascii_val(nullif(trim(:TITLE), '')) > 64) then  -- starting with letter strings only
    execute procedure LIST_ITEM_MODIFY('person_title', null, :TITLE, 'add');

  if (:p_dbkey is not null) then begin
    update PROFILE P
    set    P.PROFILE_NAME = :guest_name1
    where  P.RDB$DB_KEY = :p_dbkey
    returning new.id_profile
    into   :id_profile;

    -- force reserv changes tracking!
    update RESERV_DETAIL rd
    set    rd.ID_PERSON_PROFILE = :id_profile
    where  rd.ID_PERSON_PROFILE = :id_profile;
  end
end
^

/* Alter (PERSON_PASS_DATA_SET$INT) */
ALTER PROCEDURE PERSON_PASS_DATA_SET$INT(PD_DBKEY CHAR(8),
BIRTH_PLACE VARCHAR(30),
EGN VARCHAR(30),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
SEX CHAR,
MASK VARCHAR(10))
 AS
declare variable id_profile integer;
  declare variable id_guest integer;
  declare variable id_person_data integer;
begin
  update PERSON_DATA PDU
  set    PDU.BIRTH_PLACE = :birth_place,
         PDU.EGN = :egn,
         PDU.ID_PASSPORT_TYPE = :ID_PASSPORT_TYPE,
         PDU.PASS_NUM = :pass_num,
         PDU.PASS_DATE = :pass_date,
         PDU.PASS_EXP_DATE = :pass_exp_date,
         PDU.PASS_PLACE = :pass_place,
         PDU.CITY = :city,
         PDU.ADDRESS = :address,
         PDU.SEX = :sex,
         PDU.MASK = :mask
  where  PDU.RDB$DB_KEY = :pd_dbkey
  returning pdu.ID_PERSON_DATA
  into :id_person_data;

  for
    select pp.ID_PROFILE
    from   PERSON_DATA pd
           join PROFILE_PERSON pp on pp.ID_PERSON_DATA = pd.ID_PERSON_DATA
    where  PD.RDB$DB_KEY = :pd_dbkey
    into   :id_profile
  do begin
    update PROFILE p
    set    p.MERGE_IDENT_NUM = (select trim(ss.UNICODE_STRING) from SYSTEM_STRING_TO_UNICODE(:EGN) ss),
           p.MERGE_IDENT_NUM_ALT = (select trim(ss.UNICODE_STRING) from SYSTEM_STRING_TO_UNICODE(:PASS_NUM) ss)
    where  p.ID_PROFILE = :id_profile;
  end 

  for
    select GD.ID_GUEST
    from   GUEST_DATA GD
           join GUEST G on g.ID_GUEST = gd.ID_GUEST
    where  GD.ID_PERSON_DATA = :id_person_data
           and g.ID_RESERV_DETAIL is not null
           and g.IS_CHECK_IN = 1
    into   :id_guest
  do begin
    execute procedure GUEST_REGISTRATION_UPDATE(:id_guest);
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_ROOM$INT for: PROFILE_PERSON_CREATEQ$PROFILE */
ALTER PROCEDURE RES_CREATE_ROOM$INT(CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_COUNT INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_AGENT_PROFILE INTEGER,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_PERSON_PROFILE INTEGER,
ACC_ROUTING VARCHAR(50),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ID_GROUP INTEGER = null,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_GUARANTEE_POLICY INTEGER = null,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
RD_DBKEY CHAR(8),
NEW_ID_PERSON_PROFILE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GET_PERSON_PROFILE$INT for: PROFILE_PERSON_CREATEQ$PROFILE */
ALTER PROCEDURE RES_GET_PERSON_PROFILE$INT(ID_GUEST INTEGER)
 RETURNS(ID_PERSON_PROFILE INTEGER,
ID_PERSON_DATA INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PROFILE_PERSON_CREATEQ$PROFILE) */
ALTER PROCEDURE PROFILE_PERSON_CREATEQ$PROFILE(PROFILE_NAME TYPE OF TPERSON_NAME,
PHONE TYPE OF TPHONE,
ID_PASSPORT_TYPE TYPE OF ID,
PASS_NUM TYPE OF NAME_20,
EGN TYPE OF TTEXT_SHORT,
COUNTRY_CODE TYPE OF TSHORT_CODE,
CARD_CODE TYPE OF TCARD_CODE,
ID_PERSON_DATA TYPE OF ID_REF = null,
TITLE TYPE OF TSHORT_CODE = null,
ID_HOTEL TYPE OF ID_REF = null)
 RETURNS(NEW_ID_PROFILE TYPE OF ID,
P_DBKEY TYPE OF TDB_KEY,
PD_DBKEY TYPE OF TDB_KEY)
 AS
declare variable action_text varchar(255);
  declare variable mask varchar(10);
  declare variable merge_ident_num tname_unicode;
  declare variable merge_ident_num_alt tname_unicode;
begin
  select trim(ss.UNICODE_STRING) from SYSTEM_STRING_TO_UNICODE(:EGN) ss into :merge_ident_num;
  select trim(ss.UNICODE_STRING) from SYSTEM_STRING_TO_UNICODE(:PASS_NUM) ss into :merge_ident_num_alt;

  new_id_profile = gen_id(gen_profile_id, 1);
  insert into PROFILE (ID_PROFILE, PROFILE_NAME, PROFILE_TYPE, PHONE, IS_ARCHIVE, MERGE_IDENT_NUM, MERGE_IDENT_NUM_ALT)
  values (:new_id_profile, :profile_name, 'PERSON', :phone, 0, :merge_ident_num, :merge_ident_num_alt)
  returning RDB$DB_KEY into :p_dbkey;

  PD_DBKEY = null;
  if (:id_person_data is null) then begin
    id_person_data = gen_id(gen_person_data_id, 1);

    insert into PERSON_DATA(ID_PERSON_DATA)
    values (:id_person_data)
    returning RDB$DB_KEY into :pd_dbkey;
    -- !!! Search sensitive fields must be filled after the profile link creation (below) !!!
  end

  insert into PROFILE_PERSON (ID_PROFILE, ID_PERSON_DATA, CARD_CODE)
  values (:new_id_profile, :id_person_data, :card_code);

  if (:PD_DBKEY is not null) then begin
    if (:ID_HOTEL is not null) then begin
      execute procedure SETTING_GET_VALUE ('DEF_GUEST_MASK', :ID_HOTEL)
      returning_values  :mask;
    end

    execute procedure PERSON_DATA_SET$INT(:p_dbkey, :pd_dbkey, :profile_name, :profile_name, :country_code,
            null, null, :TITLE);

    execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, null, :EGN, :ID_PASSPORT_TYPE, :PASS_NUM, null, null,
            null, null, null, null, :mask);
  end

  action_text = f_character(29) || :profile_name;
  execute procedure SYSTEM_LOG_ADD ('PROFILE', :new_id_profile, 'CREATE_PERS_PROFILE', :action_text);
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_PERSON_PROFILE$EXC for: PROFILE_PERSON_MODIFY$PROFILE */
ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(2000),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
 BEGIN SUSPEND; END
^

/* Alter (PROFILE_PERSON_MODIFY$PROFILE) */
ALTER PROCEDURE PROFILE_PERSON_MODIFY$PROFILE(ID_PROFILE INTEGER,
ID_GUEST_TYPE INTEGER,
PROFILE_NAME VARCHAR(100),
PERSON_NAME2 VARCHAR(100),
SEX CHAR,
BIRTH_DAY DATE,
BIRTH_PLACE VARCHAR(30),
EGN VARCHAR(30),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
COUNTRY_CODE VARCHAR(20),
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
MASK VARCHAR(10),
PHONE VARCHAR(100),
FAX VARCHAR(20),
EMAIL VARCHAR(50),
CONTACT_CITY VARCHAR(100),
CONTACT_ADDRESS VARCHAR(100),
NOTE VARCHAR(255),
MSG VARCHAR(2000),
ID_DEF_CONTRAGENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
IS_ARCHIVE INTEGER,
ID_PHOTO INTEGER,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
OPERATION VARCHAR(10),
ACCOUNT_NO VARCHAR(20) = null,
TITLE VARCHAR(10) = null,
IS_EXCLUSIVE_DEBT_OWNERSHIP SMALLINT = null)
 RETURNS(NEW_ID_PROFILE INTEGER)
 AS
declare variable p_dbkey char(8);
  declare variable pd_dbkey char(8);
  declare variable old_birth_day date;
  declare variable id_picture integer;
begin

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'add, mod, del');

  if (:operation in ('add', 'mod')) then begin
    new_id_profile = :id_profile;

    if (:operation = 'add') then begin
      execute procedure PROFILE_PERSON_CREATEQ$PROFILE(:profile_name, :phone,
              :id_passport_type, :pass_num, :egn, :country_code, :card_code, null, :TITLE, null)
      returning_values  :new_id_profile, :p_dbkey, :pd_dbkey;

      if (:MASK is null) then begin
        -- keep the default mask if input mask is <null> - undefined
        -- empty mask is '' - passed by GUI, but <null> is passed from booking import, etc.
        select PD.MASK
        from   PERSON_DATA PD
        where  PD.RDB$DB_KEY = :pd_dbkey
        into   :mask;
      end
    end

    select P.RDB$DB_KEY, PD.RDB$DB_KEY, pd.BIRTH_DAY
    from   PROFILE P
           join PROFILE_PERSON PP on PP.ID_PROFILE = P.ID_PROFILE
           join PERSON_DATA PD on PD.ID_PERSON_DATA = PP.ID_PERSON_DATA
    where  P.ID_PROFILE = :new_id_profile
    into   :p_dbkey, :pd_dbkey, :old_birth_day;

    execute procedure PROFILE_COMMON_MODIFY$INT(:new_id_profile, 'PERSON', :profile_name,
            :phone, :fax, :email, :contact_city, :contact_address,
            :note, :msg, :is_archive, :id_def_contragent, :id_nom_market_segment,
            :wbe_password, :account_no, :is_exclusive_debt_ownership)
    returning_values (:new_id_profile);

    execute procedure PERSON_DATA_SET$INT(:p_dbkey, :pd_dbkey, :profile_name, :person_name2, :country_code,
            :old_birth_day, :birth_day, :TITLE);

    execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, :birth_place, :egn, :id_passport_type, :pass_num, :pass_date, :pass_place,
            :pass_exp_date, :pass_city, :pass_address, :sex, :mask);

    update PROFILE_PERSON PP
    set    PP.ID_GUEST_TYPE = :id_guest_type,
           PP.ID_PHOTO = :id_photo,
           PP.CARD_CODE = :card_code
    where  PP.ID_PROFILE = :new_id_profile;

  end else if (:operation = 'del') then begin
    id_picture = null;

    select PP.ID_PHOTO
    from   PROFILE_PERSON PP
    where  PP.ID_PROFILE = :id_profile
    into   :id_picture;

    execute procedure PICTURE_MODIFY (:id_picture, null, null, null, 'del')
    returning_values :id_picture;

    execute procedure PROFILE_DELETE$INT(:id_profile);
    new_id_profile = null;
  end
end
^

/* empty dependent procedure body */
/* Clear: APPLY_BOOKING_STATUS$EXC for: RES_ANUL_DETAIL$INT */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20))
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_ANUL_DETAIL$RSV for: RES_ANUL_DETAIL$INT */
ALTER PROCEDURE RES_ANUL_DETAIL$RSV(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_ANUL_DETAIL$WBE for: RES_ANUL_DETAIL$INT */
ALTER PROCEDURE RES_ANUL_DETAIL$WBE(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_ANUL_NOSHOW$INT for: RES_ANUL_DETAIL$INT */
ALTER PROCEDURE RES_ANUL_NOSHOW$INT(RD_DBKEY CHAR(8))
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_ANUL_DETAIL$INT) */
ALTER PROCEDURE RES_ANUL_DETAIL$INT(RD_DBKEY CHAR(8),
REASON VARCHAR(50),
CANCELATION_NUMBER TYPE OF NAME_20 = null)
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable id_reserv_detail integer;
  declare variable is_anul integer;
  declare variable id_log_event integer;
  declare variable id_guest integer;
  declare variable id_group integer;
  declare variable g_dbkey char(8);
  declare variable no_use varchar(255);
  declare variable tmp_extra_posts_left smallint;
  declare variable is_check_in smallint;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:reason, 'NOSHOW, CANCELED, USERERROR, TRANSFER', 'Annul reason');

  select RD.IS_ANUL, RD.ID_RESERV_DETAIL, rd.ID_GROUP
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :is_anul, :id_reserv_detail, :id_group;

  if (:is_anul = 1) then begin
    exception BOOKING_EXCEPTION '-1021';
    -- Reservation is already annuled or checkedin !
  end

  if (:reason = 'NOSHOW') then begin
    execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    returning_values  :no_use, :no_use;
  end

  execute procedure SYSTEM_EVENT_LOG$INT ('RES_DETAIL', :id_reserv_detail, 'RES_ANUL', f_character(29) || :reason)
  returning_values :id_log_event;

  update RESERV_DETAIL RDU
  set    RDU.IS_ANUL = 1,
         RDU.REASON_OF_ANUL = :reason,
         RDU.ID_LOG_EVENT_ANNUL = :id_log_event,
         RDU.CANCELATION_NUMBER = coalesce(:CANCELATION_NUMBER, strhash_large(rdu.NUMBER || 'CANCELATION'))
  where  RDU.RDB$DB_KEY = :rd_dbkey;

  EXTRA_POSTS_LEFT = 0;
  for
    select g.ID_GUEST, G.RDB$DB_KEY, g.IS_CHECK_IN
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_guest, :g_dbkey, :is_check_in
  do begin
    execute procedure GUEST_DEL_POSTINGS$INT(:id_guest)
    returning_values  :tmp_extra_posts_left;
    EXTRA_POSTS_LEFT = iif(:EXTRA_POSTS_LEFT = 1, 1, :tmp_extra_posts_left);

    update GUEST G
    set    G.UUID = null
    where  g.RDB$DB_KEY = :g_dbkey;

    if (:is_check_in = 1) then begin
      execute procedure GUEST_REGISTRATION_UPDATE(:id_guest);
    end
  end

  execute procedure RES_FINALIZE$INT (:RD_DBKEY, 0)
  returning_values (:warn_code);

  execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

  if (:id_group is not null) then
    execute procedure RESGRP_GUESTDATA_INVALIDATE$INT(:id_group);

end
^

/* empty dependent procedure body */
/* Clear: RES_TRANSFER_FINALIZE$RSV for: RES_ANUL_DETAIL$RSV */
ALTER PROCEDURE RES_TRANSFER_FINALIZE$RSV(ID_RESERV_DETAIL_NEW INTEGER,
ID_RESERV_DETAIL_OLD INTEGER)
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_ANUL_DETAIL$RSV) */
ALTER PROCEDURE RES_ANUL_DETAIL$RSV(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable rd_dbkey char(8);
declare variable check_status integer;
begin

  select RD.RDB$DB_KEY, rd.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :check_status;

  if (:check_status < 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('RESERV_ANNUL');
  end else begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('RESERV_CHECKED_IN_ANNUL');
  end

  execute procedure RES_ANUL_DETAIL$INT(:rd_dbkey, :reason)
  returning_values :WARN_CODE, :EXTRA_POSTS_LEFT;

end
^

/* Alter (RES_ANUL_DETAIL$WBE) */
ALTER PROCEDURE RES_ANUL_DETAIL$WBE(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable no_use varchar(255);
declare variable rd_dbkey char(8);
begin
  rd_dbkey = null;
  select rd.rdb$db_key
  from   reserv_detail rd
  where  rd.id_reserv_detail = :ID_RESERV_DETAIL
  into   :rd_dbkey;

  if (:rd_dbkey is null) then
    exception assert 'Reservation not found - RESERV_DETAIL_ID=' || coalesce(:ID_RESERV_DETAIL, '<null>');

  execute procedure EXPORT_LOG_FORCE$EXC(1);

  execute procedure RES_ANUL_DETAIL$INT (:rd_dbkey, coalesce(:REASON, 'CANCELED'))
  returning_values  :no_use, :no_use;
end
^

/* empty dependent procedure body */
/* Clear: RESERVS_EXPIRE$INT for: RES_ANUL_NOSHOW$INT */
ALTER PROCEDURE RESERVS_EXPIRE$INT(CLEAR_TODATE DATE,
ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_ANUL_NOSHOW$INT) */
ALTER PROCEDURE RES_ANUL_NOSHOW$INT(RD_DBKEY CHAR(8))
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable extra_posts_left smallint;
begin
  execute procedure RES_ANUL_DETAIL$INT(:rd_dbkey, 'NOSHOW')
  returning_values  :warn_code, :extra_posts_left;
  if (:extra_posts_left = 1) then exception ACCOUNT_EXCEPTION '-1042';

  when exception ACCOUNT_EXCEPTION do begin
    -- continue;
    execute procedure sys_dbg('res RES_ANUL_NOSHOW$INT exception ACCOUNT_EXCEPTION');
  end
end
^

/* empty dependent procedure body */
/* Clear: EAI_RES_CHECK_OUT_FAST for: RES_CHECK_OUT_GUESTS$RSV */
ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_CHECK_OUT_GUESTS$RSV) */
ALTER PROCEDURE RES_CHECK_OUT_GUESTS$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND SMALLINT = 0,
EARLYCHECKOUT_DATE DATE = null)
 AS
declare variable action_code varchar(100);
  declare variable cleaning_restriction varchar(10);
  declare variable err_code integer;
  declare variable err_text varchar(255);
  declare variable id_reserv_detail integer;
  declare variable id_guest integer;
  declare variable id_room integer;
  declare variable rd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable checkout_status integer;
  declare variable sys_date date;
  declare variable id_hotel integer;
  declare variable no_use varchar(255);
begin
  checkout_status = 1;
  action_code = case when :check_out_kind = 0 then 'CHECK_OUT'
                     when :check_out_kind = 1 then 'CHECK_OUT_EARLY1'
                     when :check_out_kind = 2 then 'CHECK_OUT_EARLY2'
                     when :check_out_kind = 3 then 'CHECK_OUT_EARLY3'
                end;

  for
    select RD.ID_RESERV_DETAIL, RD.ID_ROOM, RD.RDB$DB_KEY, rd.ID_HOTEL,
           (select sd.SYSTEM_DATE
            from   SYSTEM_DATE_GET (rd.ID_HOTEL) sd)
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :id_reserv_detail, :id_room, :rd_dbkey, :id_hotel, :sys_date
  do begin

    for
      select G.ID_GUEST, G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.CHECK_STATUS = 0 /* checked in */
      into   :id_guest, :g_dbkey
    do begin
      if (:CHECK_OUT_KIND = 3) then begin
        -- DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
        update GUEST G
        set    G.EARLYCHECKOUT_DATE = coalesce(:EARLYCHECKOUT_DATE, :sys_date)
        where  g.RDB$DB_KEY = :g_dbkey;

        execute procedure GUEST_SET_MANUAL_STAY$INT(:rd_dbkey, :id_guest, coalesce(:EARLYCHECKOUT_DATE, :sys_date))
        returning_values  :err_code, :err_text;
        if (:err_code < 0) then exception RESERV_CHECK_OUT_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
      end

      update ACCOUNT_POST AP
      set    AP.IS_ARCHIVE = 1
      where  AP.ID_GUEST = :id_guest;
    
      execute procedure GUEST_SET_STATUS$INT (:g_dbkey, :checkout_status);

      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, :action_code, '');
    end

    if (:CHECK_OUT_KIND = 3) then begin
      -- DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
      execute procedure OCCUPANCY_RESERV$INT(:rd_dbkey);

      execute procedure OCCUPANCY_SHARES_COMPLETE$INT (:id_reserv_detail)
      returning_values (:no_use, :no_use);
    end

    execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

    execute procedure SETTING_GET_VALUE('CLEANING_RESTRICTION', :id_hotel)
    returning_values  :cleaning_restriction;
  
    if (:cleaning_restriction <> '0' and :id_room > 0) then begin
      execute procedure ROOM_HOUSEKEEPING(:id_room, 'CHECK_OUT', 'set_dirty');
    end

    execute procedure RES_SAVE_STATUS$INT (:rd_dbkey, :checkout_status);

    update RESERV_DETAIL rd
    set    rd.CHECK_OUT_KIND = :CHECK_OUT_KIND,
           rd.EARLYCHECKOUT_DATE = iif(:check_out_kind > 0, coalesce(:EARLYCHECKOUT_DATE, :sys_date), null)
    where  rd.RDB$DB_KEY = :rd_dbkey;

    execute procedure RES_BONUSPOINTS_APPLY$CL (:id_reserv_detail);
  end

end
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_SET$INT for: RES_CREATE_ROOM$INT */
ALTER PROCEDURE RES_CREATE_SET$INT(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_HOTEL INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
SPLIT_ON_CHECKIN SMALLINT,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_ACC_TEMPLATE_PERSON INTEGER = null,
ID_GUARANTEE_POLICY INTEGER = null,
BLOCK_CC VARCHAR(255) = null,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(RD_DBKEY CHAR(8),
NEW_ID_RESERV_DETAIL INTEGER,
WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_CREATE_ROOM$INT) */
ALTER PROCEDURE RES_CREATE_ROOM$INT(CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ROOM_COUNT INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
I_SPECIAL_TREATMENT VARCHAR(255),
ID_AGENT_PROFILE INTEGER,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_PERSON_PROFILE INTEGER,
ACC_ROUTING VARCHAR(50),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ID_GROUP INTEGER = null,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_GUARANTEE_POLICY INTEGER = null,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
RD_DBKEY CHAR(8),
NEW_ID_PERSON_PROFILE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable day_keep_types integer;
  declare variable exp_date date;
  declare variable leaving_kind integer;
  declare variable cnt_processed integer;
begin
  execute procedure SETTING_GET_VALUE('DAY_KEEP_TYPES', :ID_HOTEL)
  returning_values  :day_keep_types;
  exp_date = :arrival_date + :day_keep_types;
  leaving_kind = coalesce(:is_late_departure, 0) + 1;
  comming_kind = coalesce(:comming_kind, 1);

  cnt_processed = 0;
  while (:room_count > :cnt_processed) do begin
    if (:res_number is null) then begin
      execute procedure SYSTEM_GEN_NUM('BOOKING', 0)
      returning_values  :dbg, :res_number;
    end
    
    if (:id_person_profile is null) then begin
      execute procedure PROFILE_PERSON_CREATEQ$PROFILE(:res_number, '', null, null, null,
              :country_code, null, null, null, :ID_HOTEL)
      returning_values  :new_id_person_profile, :dbg, :dbg;
      execute procedure sys_dbg('res RES_CREATE_ROOM$INT autocreate id_person_profile = '||coalesce(:id_person_profile, 'null'));
    end else begin
      new_id_person_profile = :id_person_profile;
    end

    execute procedure RES_CREATE_DETAIL$INT(:id_reserv_detail, :id_agent_profile, :res_number, :check_status,
                      :arrival_date, :departure_date, :code_first_food, :exp_date, :comming_kind, :leaving_kind,
                      :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                      0, 0, :note, :i_special_treatment, :id_board, -1, :id_rate,
                      :id_room_type, :country_code, '30.12.1899', null, null, '30.12.1899', null, null, null,
                      :room_features, :id_hk_plan, :new_id_person_profile, :id_hotel, :acc_routing, :id_acc_template_person,
                      :id_group, :id_agent_account, :id_guarantee_policy, :ID_EATING_OBJECT)
    returning_values  :new_id_reserv_detail, :rd_dbkey;
    res_number = null;

    execute procedure RES_GUESTCOUNT_ADD$INT(:rd_dbkey, :adult_count, :child_count, 1);

    cnt_processed = :cnt_processed + 1;
    suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_SET$EXC for: RES_CREATE_SET$INT */
ALTER PROCEDURE RES_CREATE_SET$EXC(ID_RESERV_DETAIL INTEGER,
RES_NUMBER VARCHAR(62),
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER,
CREATE_DATETIME TIMESTAMP)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_RESERV_DETAIL INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_CREATE_SET$RSV for: RES_CREATE_SET$INT */
ALTER PROCEDURE RES_CREATE_SET$RSV(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
SUPPRESS_WARNINGS INTEGER,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT$RSV for: RES_CREATE_SET$INT */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_CREATE$RSV for: RES_CREATE_SET$INT */
ALTER PROCEDURE RESMULTI_CREATE$RSV(ID_HOTEL INTEGER,
ID_ROOM_TYPE INTEGER,
TRANSFER_OUT_TIME TIME,
TRANSFER_IN_TIME TIME,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
TRANSFER_OUT_NOTE VARCHAR(50),
TRANSFER_IN_NOTE VARCHAR(50),
NOTE VARCHAR(255),
ID_BOARD INTEGER,
VOUCHER_DATE DATE,
VOUCHER_NUMBER VARCHAR(20),
VOUCHER_TEXT VARCHAR(30),
CHECK_STATUS INTEGER,
ID_TARIFF INTEGER,
COUNTRY_CODE VARCHAR(20),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
CODE_FIRST_FOOD /* TYPE OF TFOOD_CODE */ VARCHAR(20),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
NOTE_REMINDERS VARCHAR(50),
TITULAR_NAME VARCHAR(100),
SPLIT_ON_CHECKIN INTEGER,
ID_EATING_OBJECT /* TYPE OF ID_REF */ INTEGER = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
NUMBER VARCHAR(62),
NEW_ID_TITULAR INTEGER,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE,
WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_CREATE_SET$INT) */
ALTER PROCEDURE RES_CREATE_SET$INT(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(255),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_HOTEL INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
SPLIT_ON_CHECKIN SMALLINT,
ID_RESERV_DETAIL INTEGER = null,
RES_NUMBER VARCHAR(62) = null,
ID_ACC_TEMPLATE_PERSON INTEGER = null,
ID_GUARANTEE_POLICY INTEGER = null,
BLOCK_CC VARCHAR(255) = null,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(RD_DBKEY CHAR(8),
NEW_ID_RESERV_DETAIL INTEGER,
WARN_CODE TYPE OF TRANGE)
 AS
declare variable guarantee_deposit_percent numeric(15,4);
  declare variable guarantee_deposit_nights integer;
  declare variable guarantee_due_days_bef_arrival integer;
  declare variable guarantee_due_days_after_create integer;
  declare variable gp_check_status integer;
  declare variable log_suppressed integer;
  declare variable id_guest integer;
  declare variable minibar_rights varchar(50);
  declare variable video_rights varchar(50);
  declare variable nopost_pms varchar(50);
  declare variable phone_rights varchar(50);
  declare variable paytv_rights varchar(50);
  declare variable is_profile_exclusive_debt_ownership integer;
  declare variable id_base_account integer;
begin
  execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CREATE');

  select GP.DEPOSIT_NIGHTS_COUNT, GP.DEPOSIT_TOTALSUM_PART,
         GP.DUE_DAYS_BEFORE_ARRIVAL, GP.DUE_DAYS_AFTER_CREATE, gp.CHECK_STATUS
  from   GUARANTEE_POLICY GP
  where  GP.ID_GUARANTEE_POLICY = :ID_GUARANTEE_POLICY
         and gp.ID_HOTEL = :ID_HOTEL
  into   :guarantee_deposit_nights, :guarantee_deposit_percent,
         :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create, :gp_check_status;

  CHECK_STATUS = coalesce(:CHECK_STATUS, :gp_check_status, -2);

  execute procedure RES_CREATE_ROOM$INT(:check_status, :arrival_date, :departure_date, :adult_count, :child_count,
                    :id_room_type, 1, :id_board, :id_tariff, comming_kind, :is_late_departure, :country_code, :code_first_food,
                    :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note, :i_special_treatment, :id_agent_profile,
                    :id_hk_plan, '', :room_features, :id_person_profile, :acc_routing, :id_acc_template_person, :id_hotel, :id_agent_account,
                    :id_group, :id_reserv_detail, :res_number, :id_guarantee_policy, :id_eating_object)
  returning_values  :new_id_reserv_detail, :rd_dbkey, :id_person_profile;

  if (RDB$GET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE') is not distinct from 'disable') then begin
    log_suppressed = 1;
  end else begin
    log_suppressed = 0;
    RDB$SET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE', 'disable');
    -- disable only for intermediate changes
  end

  execute procedure RES_SAVE_ACCOUNTING$INT (:rd_dbkey, :id_agent_profile, :id_agent_account, :acc_routing,
          :id_person_payment, :id_agent_payment, :id_group);

  execute procedure RES_SAVE_MARKETING$INT(:rd_dbkey, :id_nom_market_segment,
                    :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason);

  execute procedure sys_dbg('res RES_CREATE_SET$INT id_room = '||coalesce(:id_room, 'null'));
  if (:id_room is not null) then begin
    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, :id_room_type, 'nrttRoom')
    returning_values (:WARN_CODE);
  end

  execute procedure RES_SAVE_VOUCHER$INT(:RD_DBKEY, :voucher_num, :voucher_date, :voucher_text, :voucher2_num, :voucher2_date);

  execute procedure RES_SAVE_NOTE$RSV(:new_id_reserv_detail, :note, :note_reminders);

  for
    select  g.ID_GUEST
    from    GUEST G
    where   G.ID_RESERV_DETAIL = :NEW_ID_RESERV_DETAIL
    into    :id_guest
  do begin
    execute procedure RES_GUEST_SAVE_PACKET$RSV (:id_guest, :PACKET_ITEM_IDS);
  end 

  update RESERV_DETAIL RD
  set    RD.CUSTOM_PRICE = :CUSTOM_PRICE,
         RD.CUSTOM_CURRENCY = :CUSTOM_CURRENCY,
         RD.SPLIT_ON_CHECKIN = :SPLIT_ON_CHECKIN,
         RD.IS_VIP = coalesce(:IS_VIP, RD.IS_VIP),
         RD.ID_GUARANTEE_POLICY = :ID_GUARANTEE_POLICY,
         RD.GUARANTEE_DEPOSIT = :GUARANTEE_DEPOSIT,
         RD.GUARANTEE_CURRENCY = :GUARANTEE_CURRENCY,
         RD.BLOCK_CC = :BLOCK_CC,
         RD.GUARANTEE_DEPOSIT_PERCENT = :guarantee_deposit_percent,
         RD.GUARANTEE_DEPOSIT_NIGHTS = :guarantee_deposit_nights,
         RD.GUARANTEE_DUE_DAYS_BEF_ARRIVAL = :guarantee_due_days_bef_arrival,
         RD.GUARANTEE_DUE_DAYS_AFTER_CREATE = :guarantee_due_days_after_create
         /*rd.POSTING_TRANSACTION_UUID =  (select iif(p.IS_EXCLUSIVE_DEBT_OWNERSHIP = 1, uuid_create(), null)
                                         from   ACCOUNT A
                                                join PROFILE P on P.ID_PROFILE = a.ID_PROFILE
                                         where  a.ID_ACCOUNT = rd.ID_BASE_ACCOUNT)*/
  where  RD.RDB$DB_KEY = :rd_dbkey
  returning new.ID_BASE_ACCOUNT
  into      :id_base_account;

  select p.IS_EXCLUSIVE_DEBT_OWNERSHIP
  from   ACCOUNT A
         join PROFILE P on P.ID_PROFILE = a.ID_PROFILE
  where  a.ID_ACCOUNT = :id_base_account
  into   :is_profile_exclusive_debt_ownership;

  if (:is_profile_exclusive_debt_ownership = 1) then begin
    execute procedure RES_TAKE_POSTING_RESPONSIBILITY (:NEW_ID_RESERV_DETAIL);
  end

  select rt.MINIBAR_RIGHTS, rt.VIDEO_RIGHTS, rt.NOPOST_PMS, rt.PHONE_RIGHTS, rt.PAYTV_RIGHTS
  from   RES_TEMPLATE RT
  where  rt.ID_HOTEL = :ID_HOTEL
  into   :minibar_rights, :video_rights, :nopost_pms, :phone_rights, :paytv_rights;

  execute procedure RESERV_DETAIL_EXTERNAL_MOD$RSV (:NEW_ID_RESERV_DETAIL,
          :minibar_rights, :paytv_rights, :video_rights, :nopost_pms, :phone_rights, null, null);

  if (:log_suppressed = 0) then RDB$SET_CONTEXT ('USER_TRANSACTION', 'SYSTEM_LOG_STATE', 'enable');

  execute procedure RES_CREATE_LOG$INT (:RD_DBKEY);

end
^

/* Alter (RES_CREATE_SET$RSV) */
ALTER PROCEDURE RES_CREATE_SET$RSV(ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
CHECK_STATUS INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
PACKET_ITEM_IDS VARCHAR(255),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
COUNTRY_CODE VARCHAR(20),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_ACC_TEMPLATE_PERSON INTEGER,
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
SUPPRESS_WARNINGS INTEGER,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER,
NEW_FROM_DATE TYPE OF TDATE)
 AS
declare variable rd_dbkey char(8);
declare variable tmp_warn_code integer;
begin
  WARN_CODE = null;
  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, :check_status, :arrival_date, :departure_date,
                    :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff, :PACKET_ITEM_IDS,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
                    :guarantee_deposit, :guarantee_currency, :split_on_checkin, null, null, :ID_ACC_TEMPLATE_PERSON,
                    :ID_GUARANTEE_POLICY, null, :ID_EATING_OBJECT)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :WARN_CODE;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :ERR_TEXT, :share_transaction_id, :tmp_warn_code;
  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

  if (:suppress_warnings = 1) then begin
    delete from SYSTEM_WARNINGS W
    where W.ID_TRANSACTION = :warn_code;
    warn_code = null;
  end

  update RESERV_DETAIL RD
  set    RD.NOTE_REMINDERS = :note_reminders
  where  RD.RDB$DB_KEY = :rd_dbkey;

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;

end
^

/* Alter (RES_GET_PERSON_PROFILE$INT) */
ALTER PROCEDURE RES_GET_PERSON_PROFILE$INT(ID_GUEST INTEGER)
 RETURNS(ID_PERSON_PROFILE INTEGER,
ID_PERSON_DATA INTEGER)
 AS
declare variable p_dbkey char(8);
  declare variable profile_name varchar(100);
  declare variable pd_dbkey char(8);
  declare variable id_hotel integer;
  declare variable title varchar(10);
begin
  select PD.ID_PERSON_DATA, PD.PERSON_NAME, PP.ID_PROFILE, rd.ID_HOTEL, pd.TITLE
  from   GUEST G
         join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
         join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
         join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
         left outer join PROFILE_PERSON PP on PP.ID_PERSON_DATA = GD.ID_PERSON_DATA
  where  G.ID_GUEST = :id_guest
  into   :id_person_data, :profile_name, :id_person_profile, :id_hotel, :title;

  if (:id_person_profile is null) then begin
    execute procedure PROFILE_PERSON_CREATEQ$PROFILE(:profile_name, '', null, null, null, null, null, :id_person_data, :title, :id_hotel)
    returning_values  :id_person_profile, :p_dbkey, :pd_dbkey;
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_ADD$RSV for: RES_GUEST_ADD$INT */
ALTER PROCEDURE RES_GUEST_ADD$RSV(ID_RESERV_DETAIL INTEGER,
IS_CHILD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_GUEST INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUESTCOUNT_ADD$INT for: RES_GUEST_ADD$INT */
ALTER PROCEDURE RES_GUESTCOUNT_ADD$INT(RD_DBKEY CHAR(8),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
INITIALIZE_BOOKING /* TYPE OF TLOGICAL */ SMALLINT = 0)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_GUEST_ADD$INT) */
ALTER PROCEDURE RES_GUEST_ADD$INT(RD_DBKEY CHAR(8),
IS_CHILD INTEGER,
INITIALIZE_BOOKING TYPE OF TLOGICAL = 0)
 RETURNS(NEW_ID_GUEST INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable pd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable check_status integer;

  declare variable from_date date;
  declare variable to_date date;
  declare variable id_room integer;
  declare variable id_agent integer;
  declare variable id_tarrif integer;
  declare variable guest_name varchar(100);
  declare variable country_code varchar(10);
  declare variable guest_status varchar(50);
  declare variable default_mask varchar(50);
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable id_titular integer;
  declare variable id_profile_data integer;
  declare variable id_person_data integer;
  declare variable id_base_account integer;
  declare variable id_extra_account integer;
  declare variable id_hotel integer;
  declare variable action_text varchar(255);
begin
  select RD.FROM_DATE, RD.TO_DATE, RD.ID_ROOM, PA.ID_AGENT, RD.ID_RATE,
         RD.ID_RESERV_DETAIL, RD.ID_TITULAR, PP.ID_PERSON_DATA,
         RD.CHECK_STATUS, RD.ADULT_COUNT, RD.CHILD_COUNT, RD.COUNTRY,
         rd.ID_BASE_ACCOUNT, rd.ID_EXTRA_ACCOUNT, rd.ID_HOTEL
  from   RESERV_DETAIL RD
         left outer join PROFILE_PERSON PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
         left outer join PROFILE_AGENT PA on PA.ID_PROFILE = RD.ID_AGENT_PROFILE
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :from_date, :to_date, :id_room, :id_agent, :id_tarrif,
         :id_reserv_detail, :id_titular, :id_profile_data,
         :check_status, :adult_count, :child_count, :country_code,
         :id_base_account, :id_extra_account, :id_hotel;

  if (:check_status < 0) then begin
    guest_status = '';
    check_status = -2;
  end else if (:check_status = 0) then begin
    guest_status = 'CHECKING_IN';
  end else begin  /* checked out */
    exception BOOKING_EXCEPTION '-1032';
  end


  new_id_guest = gen_id (id_guest_gen, 1);
  insert into GUEST (ID_GUEST, ID_BASE_ACCOUNT, ID_ACCOUNT, FROM_DATE, TO_DATE, ID_ROOM, ID_AGENT, ID_TARIFA,
         ID_RESERV_DETAIL, IS_CHILD, CHECK_STATUS, GUEST_EDIT_STATUS, ID_HOTEL)
  values (:new_id_guest,  :id_base_account, :id_extra_account, :from_date, :to_date, :id_room, :id_agent, :id_tarrif,
         :id_reserv_detail, :is_child, -2, :guest_status, :id_hotel)
  returning RDB$DB_KEY into :g_dbkey;

  execute procedure sys_dbg('res RES_GUEST_ADD$INT new_id_guest = '||coalesce(:new_id_guest, 'null'));

  insert into GUEST_CHANGE_STATUS (ID_GUEST, FROM_DATE_ORIG, TO_DATE_ORIG)
  values (:new_id_guest, :from_date, :to_date);

  if (:is_child = 1) then begin
    child_count = :child_count + 1;
    guest_name = '-';
  end else begin
    adult_count = :adult_count + 1;
    guest_name = '-';
  end

  if (:id_titular is null) then begin
    id_titular = :new_id_guest;
    id_person_data = :id_profile_data;
  end else begin
    execute procedure SETTING_GET_VALUE('DEF_GUEST_MASK', :id_hotel)
    returning_values  :default_mask;

    id_person_data = gen_id(GEN_PERSON_DATA_ID, 1);
    insert into PERSON_DATA (ID_PERSON_DATA, MASK)
    values (:id_person_data, :default_mask)
    returning RDB$DB_KEY into :pd_dbkey;

  end

  insert into GUEST_DATA (ID_GUEST, ID_PERSON_DATA)
  values (:new_id_guest, :id_person_data);

  if (:INITIALIZE_BOOKING is distinct from 1) then begin
    action_text = F_CHARACTER(29) || '"' || :guest_name || '" (' || :NEW_ID_GUEST || ')';
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_GUEST_ADD', :action_text);
  end

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name, :guest_name, coalesce(:country_code, ''),
          :is_child, null, null, null);

  execute procedure RES_GUEST_AUTO$INT(:g_dbkey, :rd_dbkey, 1);

  update RESERV_DETAIL RD
  set    RD.ADULT_COUNT = :adult_count,
         RD.CHILD_COUNT = :child_count,
         RD.ID_TITULAR = :id_titular
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SET_EDIT_STATUS$INT (:RD_DBKEY, 'ADDGUEST', 'add');

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, :check_status);

end
^

/* empty dependent procedure body */
/* Clear: IMPORT_GUEST$EXC for: RES_GUEST_ADD$RSV */
ALTER PROCEDURE IMPORT_GUEST$EXC(BOOKING_ID INTEGER,
PROFILE_UUID VARCHAR(40),
GUEST_UUID VARCHAR(40),
GUEST_NAME VARCHAR(100),
IS_CHILD SMALLINT,
AGE INTEGER,
IS_DIFFERENT_ARRANGER SMALLINT,
ARRIVAL DATE,
DEPARTURE DATE,
VOUCHER VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
RATING_AGE INTEGER,
KPP VARCHAR(50),
KPP_DATE DATE,
STAY_REASON VARCHAR(255),
CAR VARCHAR(30),
IS_REGISTRED SMALLINT,
PERSONAL_NUMBER VARCHAR(30),
TITLE VARCHAR(10),
PT_NAME VARCHAR(100),
PT_EXTCODE VARCHAR(50),
PASS_NUM VARCHAR(20),
PASS_PLACE VARCHAR(20),
PASS_DATE DATE,
PASS_EXP_DATE DATE,
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_DATE DATE,
SEX CHAR,
BIRTH_PLACE VARCHAR(30),
MASK VARCHAR(10),
PACKAGE VARCHAR(255),
VISA /* TDESCRIPTION_SHORT */ VARCHAR(100))
 RETURNS(GUEST_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GUEST_ADD$RSV) */
ALTER PROCEDURE RES_GUEST_ADD$RSV(ID_RESERV_DETAIL INTEGER,
IS_CHILD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_GUEST INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  warn_code = 0;
  err_code = 0;
  err_text = '';

  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey;

  execute procedure RES_GUEST_ADD$INT(:rd_dbkey, :IS_CHILD)
  returning_values  :NEW_ID_GUEST;
end
^

/* empty dependent procedure body */
/* Clear: RES_GUESTLIST_REMOVE$RSV for: RES_GUEST_AUTO$INT */
ALTER PROCEDURE RES_GUESTLIST_REMOVE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GUEST_AUTO$INT) */
ALTER PROCEDURE RES_GUEST_AUTO$INT(G_DBKEY CHAR(8),
RD_DBKEY CHAR(8),
IS_NEW_GUEST SMALLINT)
 AS
declare variable id_guest integer;
  declare variable id_reserv_detail integer;
  declare variable for_date date;
  declare variable id_nom_market_segment integer;
  declare variable id_nom_source_code integer;
  declare variable id_nom_channel_code integer;
  declare variable id_nom_hear_reason integer;
  declare variable id_nom_come_reason integer;
  declare variable from_date date;
  declare variable to_date date;
  declare variable id_room integer;
  declare variable res_id_room integer;
  declare variable id_board integer;
  declare variable id_tarrif integer;
  declare variable voucher_num varchar(30);
  declare variable voucher_date date;
  declare variable voucher_text varchar(30);
  declare variable voucher2_num varchar(30);
  declare variable voucher2_date date;
  declare variable transfer_in_time timestamp;
  declare variable transfer_in_note varchar(255);
  declare variable transfer_out_time timestamp;
  declare variable transfer_out_note varchar(255);
  declare variable code_first_food type of tfood_code;
  declare variable id_hotel integer;
  declare variable id_titular integer;
  declare variable sys_date date;
begin

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -2);

  select G.ID_GUEST
  from   GUEST G
  where  G.RDB$DB_KEY = :g_dbkey
  into   :id_guest;

  select RD.FROM_DATE, RD.TO_DATE, RD.ID_ROOM, RD.ID_BOARD,
         RD.ID_RATE, RD.ID_NOM_MARKET_SEGMENT, RD.ID_NOM_SOURCE_CODE,
         RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_HEAR_REASON, RD.ID_NOM_COME_REASON,
         RD.VAUCHER_NUM, RD.VAUCHER_DATE, RD.VAUCHER_TEXT,
         RD.VAUCHER_NUM2, RD.VAUCHER_DATE2, RD.ID_RESERV_DETAIL,
         RD.TRANSFER_IN_TIME, RD.TRANSFER_IN_NOTE, RD.TRANSFER_OUT_TIME, RD.TRANSFER_OUT_NOTE, RD.CODE_FIRST_FOOD,
         RD.ID_HOTEL, rd.ID_TITULAR
  from   RESERV_DETAIL RD
         left outer join PROFILE_PERSON PP on PP.ID_PROFILE = RD.ID_PERSON_PROFILE
         left outer join PROFILE_AGENT PA on PA.ID_PROFILE = RD.ID_AGENT_PROFILE
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :from_date, :to_date, :res_id_room, :id_board,
         :id_tarrif, :id_nom_market_segment, :id_nom_source_code,
         :id_nom_channel_code, :id_nom_hear_reason, :id_nom_come_reason,
         :voucher_num, :voucher_date, :voucher_text,
         :voucher2_num, :voucher2_date, :id_reserv_detail,
         :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note, :code_first_food,
         :id_hotel, :id_titular;

  execute procedure RES_GUEST_SAVE_STAY$INT(:g_dbkey, :from_date, :to_date, :id_hotel);

  execute procedure RES_GUEST_SAVE_VOUCHER$INT(:rd_dbkey, :g_dbkey, :voucher_num, :voucher_date,
          :voucher_text, :voucher2_num, :voucher2_date);

  execute procedure RES_GUEST_SAVE_OTHER$INT(:g_dbkey, :transfer_in_time, :transfer_in_note,
          :transfer_out_time, :transfer_out_note, :code_first_food);

  execute procedure RES_GUEST_SAVE_MARKETING$INT(:id_guest, :id_nom_market_segment, :id_nom_source_code,
          :id_nom_channel_code,:id_nom_hear_reason, :id_nom_come_reason);

  if (:IS_NEW_GUEST = 0) then begin
    delete from GUEST_STAY GS
    where  GS.ID_GUEST = :id_guest;

    delete from GUEST_PACKET GP
    where  GP.ID_GUEST = :id_guest;
  end
  --execute procedure sys_dbg('res RES_GUEST_AUTO$INT id_room = '||coalesce(:res_id_room, 'null'));

  select SD.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) SD
  into   :sys_date;

  for
    select RLP.OUT_DATE
    from   SYSTEM_LOOP_PERIOD(:from_date, :to_date - 1) RLP
    into   :for_date
  do begin
    id_room = :res_id_room;
    if (:for_date < :sys_date) then begin
      -- get initial room from first checked-in guest for reservation, because may be different from current
      select first 1 GS.ID_ROOM
      from   GUEST G
             join GUEST_STAY GS on GS.ID_GUEST = G.ID_GUEST
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and GS.FOR_DATE = :for_date
      order by g.ID_GUEST asc
      into   :id_room;
    end

    insert into GUEST_STAY (ID_GUEST, FOR_DATE, ID_ROOM_TYPE, ID_BOARD, ID_TYPE_STAY, ID_TARIFF, /*ID_PACKET, */ID_ROOM)
    values (:id_guest, :for_date, -1, :id_board, -1, :id_tarrif, /*:id_packet,*/ :id_room);
  end

  insert into GUEST_PACKET (ID_GUEST, ID_PACKET_ITEM)
  select :id_guest, gp.ID_PACKET_ITEM
  from   GUEST_PACKET GP
  where  GP.ID_GUEST = :id_titular;

  execute procedure RES_GUESTDATA_INVALIDATE$INT(:rd_dbkey);
  --
end
^

/* empty dependent procedure body */
/* Clear: RES_DELETE$INT for: RES_GUEST_DEL$INT */
ALTER PROCEDURE RES_DELETE$INT(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_DEL$RSV for: RES_GUEST_DEL$INT */
ALTER PROCEDURE RES_GUEST_DEL$RSV(ID_GUEST INTEGER,
REASON VARCHAR(50) = null)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: RES_GUESTCOUNT_DEL$INT for: RES_GUEST_DEL$INT */
ALTER PROCEDURE RES_GUESTCOUNT_DEL$INT(RD_DBKEY CHAR(8),
DEL_ADULT_COUNT INTEGER,
DEL_CHILD_COUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_GUEST_DEL$INT) */
ALTER PROCEDURE RES_GUEST_DEL$INT(ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50) = null)
 RETURNS(EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable action_text varchar(255);
  declare variable guest_name varchar(100);
  declare variable is_child smallint;
  declare variable is_check_in smallint;
  declare variable id_titular integer;
BEGIN

  select pd.PERSON_NAME, G.IS_CHILD, red.ID_TITULAR, g.IS_CHECK_IN
  from   GUEST g
         join GUEST_DATA GD on gd.ID_GUEST = g.ID_GUEST
         join PERSON_DATA PD on PD.ID_PERSON_DATA = gd.ID_PERSON_DATA
         join RESERV_DETAIL RED on RED.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
         left outer join PROFILE_PERSON PP on PP.ID_PERSON_DATA = GD.ID_PERSON_DATA
  where  G.ID_GUEST = :ID_GUEST
  into   :guest_name, :is_child, :id_titular, :is_check_in;

  if (:ID_GUEST = :id_titular) then exception BOOKING_EXCEPTION '-1007';

  execute procedure GUEST_DEL_POSTINGS$INT(:id_guest)
  returning_values :EXTRA_POSTS_LEFT;

  update GUEST G
  set    G.ID_RESERV_DETAIL = null,
         g.ID_BASE_ACCOUNT = null,
         g.ID_ACCOUNT = null
  where  G.ID_GUEST = :id_guest;

  update RESERV_DETAIL RD
  set    RD.ADULT_COUNT = RD.ADULT_COUNT - (1 - :is_child),
         RD.CHILD_COUNT = RD.CHILD_COUNT - :is_child
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL;

  if (:is_check_in = 1) then begin
    execute procedure GUEST_REGISTRATION_UPDATE(:id_guest);
  end

  action_text = f_character(29) || '"' || :guest_name || '" (' || :id_guest || ')' || f_character(28) || coalesce(:REASON, '');
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_GUEST_DEL', :action_text);

END
^

/* empty dependent procedure body */
/* Clear: CLEAR_ORPHAN_GUESTS$EXC for: RES_GUEST_DEL$RSV */
ALTER PROCEDURE CLEAR_ORPHAN_GUESTS$EXC(BOOKING_ID INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_GUEST_DEL$RSV) */
ALTER PROCEDURE RES_GUEST_DEL$RSV(ID_GUEST INTEGER,
REASON VARCHAR(50) = null)
 AS
declare variable rd_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable extra_posts_left integer;
begin
  select G.RDB$DB_KEY, RD.ID_RESERV_DETAIL, RD.CHECK_STATUS
  from   GUEST G
         join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
  where  G.ID_GUEST = :id_guest
  into   :rd_dbkey, :id_reserv_detail, :check_status;

  if (:check_status >= 0) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT ('RESERV_GUEST_DELETE');
  end

  execute procedure RES_GUEST_DEL$INT(:ID_GUEST, :id_reserv_detail, :REASON)
  returning_values :extra_posts_left;

  execute procedure OCCUPANCY_RESERV$INT(:rd_dbkey);
  --
end
^

/* Alter (RES_GUEST_LOAD) */
ALTER PROCEDURE RES_GUEST_LOAD(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_GUEST INTEGER,
STATUS INTEGER,
GUEST_NAME1 VARCHAR(255),
GUEST_NAME2 VARCHAR(255),
IS_CHILD INTEGER,
AGE INTEGER,
BIRTH_DAY DATE,
BIRTHDAY_INTERNAL DATE,
COUNTRY_CODE VARCHAR(10),
FROM_DATE DATE,
TO_DATE DATE)
 AS
begin
  /*  Description:
  ||
  */

  for
    select G.ID_GUEST, GC.GUEST_NAME1, GC.GUEST_NAME2, G.FROM_DATE, G.TO_DATE, GC.BIRTHDAY_INTERNAL, GC.BIRTH_DAY,
           GC.COUNTRY, G.CHECK_STATUS, G.IS_CHILD
    from   GUEST G
           left join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
    where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    order by G.IS_CHILD, G.ID_GUEST
    into   :ID_GUEST, :GUEST_NAME1, :GUEST_NAME2, :FROM_DATE, :TO_DATE, :BIRTHDAY_INTERNAL, :BIRTH_DAY,
           :COUNTRY_CODE, :STATUS, :IS_CHILD
  do begin
    select sca.AGE_INYEARS
    from   SYSTEM_CALC_AGE_INYEARS(:BIRTH_DAY, :FROM_DATE) SCA
    into   :AGE;

    suspend;
  end
end
^

/* Alter (RES_GUEST_SAVE$RSV) */
ALTER PROCEDURE RES_GUEST_SAVE$RSV(ID_GUEST INTEGER,
ID_RESERV_DETAIL INTEGER,
GUEST_NAME1 VARCHAR(100),
AGE INTEGER,
BIRTH_DAY DATE,
IS_CHILD INTEGER,
MASK VARCHAR(10) = null)
 RETURNS(NEW_ID_GUEST INTEGER)
 AS
declare variable g_dbkey char(8);
  declare variable pd_dbkey char(8);
  declare variable country_code varchar(10);
  declare variable id_person_data integer;
begin
  /*  Description:
  ||
  */
  if (:id_guest is null) then begin
    -- get first anonymous guest (check_status = -2  ?!)
    select first 1 PD.RDB$DB_KEY, G.RDB$DB_KEY, PD.COUNTRY_CODE,
           G.ID_GUEST, pd.ID_PERSON_DATA
    from   GUEST G
           join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
           join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
           and G.CHECK_STATUS = -2
           and G.IS_CHILD = :IS_CHILD
    order by G.ID_GUEST asc
    into   :pd_dbkey, :g_dbkey, :country_code,
           :new_id_guest, :id_person_data;
  end else begin
    new_id_guest = :id_guest;
    select G.RDB$DB_KEY, PD.RDB$DB_KEY, PD.COUNTRY_CODE, pd.ID_PERSON_DATA
    from   GUEST G
           join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
           join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
    where  G.ID_GUEST = :id_guest
    into   :g_dbkey, :pd_dbkey, :country_code, :id_person_data;
  end

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name1, null,
          :country_code, :is_child, :age, :birth_day, null);

  if (:MASK is not null) then begin
    update PERSON_DATA d
    set    d.MASK = :MASK
    where  d.ID_PERSON_DATA = :id_person_data;
  end

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -1);

end
^

/* Alter (RES_GUEST_SAVE_BOARD$RSV) */
ALTER PROCEDURE RES_GUEST_SAVE_BOARD$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_BOARD INTEGER)
 AS
declare variable id_reserv_detail integer;
declare variable old_id_board integer;
  declare variable action_text varchar(255);
  declare variable guest_name varchar(50);
  declare variable old_board_name varchar(50);
  declare variable new_board_name varchar(50);
begin
  ID_BOARD = :ID_BOARD;
  if (:ID_BOARD = -1) then begin
    -- default to booking board
    select rd.ID_BOARD
    from   GUEST g
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :ID_GUEST
    into   :ID_BOARD;
  end

  update GUEST_STAY GS
  set    gs.ID_BOARD = :ID_BOARD
  where  gs.ID_GUEST = :ID_GUEST
         and gs.FOR_DATE = :FOR_DATE
  returning old.id_board
  into      :old_id_board;

  if (:old_id_board is distinct from :ID_BOARD) then begin
    select g.ID_RESERV_DETAIL, gc.GUEST_NAME1
    from   GUEST G
           left join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
    where  g.ID_GUEST = :ID_GUEST
    into   :id_reserv_detail, :guest_name;

    select M.NAME
    from   MEALS M
    where  M.ID_BOARD = :old_id_board
    into   :old_board_name;

    select M.NAME
    from   MEALS M
    where  M.ID_BOARD = :ID_BOARD
    into   :new_board_name;

    action_text = f_character(29) || :guest_name
                  || f_character(28) || formatdate(:for_date, 'd;dd.mm.yyyy')
                  || f_character(28) || coalesce(:new_board_name, '')
                  || f_character(28) || coalesce(:old_board_name, '');
    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'GUEST_DIFF_BOARD', :action_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_BOOKING_FINALIZE$EXC for: RES_GUEST_SAVE_DIFF$INT */
ALTER PROCEDURE IMPORT_BOOKING_FINALIZE$EXC(BOOKING_ID INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1,
STATUS VARCHAR(50) = null,
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20) = null,
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20) = null)
 RETURNS(RECORD_TIMESTAMP TIMESTAMP,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_FINALIZE$RSV for: RES_GUEST_SAVE_DIFF$INT */
ALTER PROCEDURE RES_GUEST_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER,
ALL_ERRORS_ARE_INSTANT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_RATE$RSV for: RES_GUEST_SAVE_DIFF$INT */
ALTER PROCEDURE RES_SAVE_RATE$RSV(ID_RESERV_DETAIL INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
IS_DIFFERENT_TARIFF INTEGER,
IS_DIFFERENT_PRICE INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_GUEST_SAVE_DIFF$INT) */
ALTER PROCEDURE RES_GUEST_SAVE_DIFF$INT(RD_DBKEY CHAR(8))
 AS
declare variable id_reserv_detail integer;

  declare variable voucher_num varchar(30);
  declare variable voucher_date date;
  declare variable voucher_text varchar(30);
  declare variable voucher2_num varchar(30);
  declare variable voucher2_date date;
  declare variable transfer_in_time time;
  declare variable transfer_in_note varchar(255);
  declare variable transfer_out_time time;
  declare variable transfer_out_note varchar(255);
  declare variable code_first_food varchar(20) ;
  declare variable id_tar_room_type integer;
  declare variable id_type_stay integer;

  declare variable is_different_voucher integer;
  declare variable is_different_other integer;
  declare variable has_different_room_type integer;
  declare variable has_different_board integer;
  declare variable has_different_type_stay integer;
  declare variable has_different_tariff integer;

  declare variable auto_voucher_num varchar(30);
  declare variable auto_voucher_date date;
  declare variable auto_voucher_text varchar(30);
  declare variable auto_voucher2_num varchar(30);
  declare variable auto_voucher2_date date;
  declare variable auto_transfer_in_time time;
  declare variable auto_transfer_in_note varchar(255);
  declare variable auto_transfer_out_time time;
  declare variable auto_transfer_out_note varchar(255);
  declare variable auto_code_first_food varchar(20) ;
  declare variable g_dbkey char(8);
  declare variable adult_count integer;
  declare variable children_count integer;
  declare variable min_board integer;
  declare variable max_board integer;
  declare variable min_rate integer;
  declare variable max_rate integer;
begin
  /*  Description:
  ||
  */
  select RD.VAUCHER_NUM, RD.VAUCHER_DATE,
         RD.VAUCHER_TEXT, RD.VAUCHER_NUM2, RD.VAUCHER_DATE2, RD.TRANSFER_IN_TIME,
         RD.TRANSFER_IN_NOTE, RD.TRANSFER_OUT_TIME, RD.TRANSFER_OUT_NOTE,
         RD.CODE_FIRST_FOOD, RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
         left outer join PROFILE_AGENT PA on PA.ID_PROFILE = RD.ID_AGENT_PROFILE
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :auto_voucher_num, :auto_voucher_date,
         :auto_voucher_text, :auto_voucher2_num, :auto_voucher2_date, :auto_transfer_in_time,
         :auto_transfer_in_note, :auto_transfer_out_time, :auto_transfer_out_note,
         :auto_code_first_food, :id_reserv_detail;

  select max(GS.ID_ROOM_TYPE), max(GS.ID_TYPE_STAY),
         max(coalesce(GS.ID_BOARD, 0)),
         min(coalesce(GS.ID_BOARD, 0)),
         max(GS.ID_TARIFF),
         min(GS.ID_TARIFF),
         count(distinct iif(G.IS_CHILD=0, G.ID_GUEST, null)), count(distinct iif(G.IS_CHILD=1, G.ID_GUEST, null))
  from   GUEST_STAY GS
         join GUEST G on G.ID_GUEST = GS.ID_GUEST
  where  G.ID_RESERV_DETAIL = :id_reserv_detail
  into   :id_tar_room_type, :id_type_stay,
         :min_board, :max_board,
         :min_rate, :max_rate,
         --:chk_board, :chk_tariff,
         :adult_count, :children_count;

  has_different_room_type = iif(:id_tar_room_type > 0, 1, 0);
  has_different_type_stay = iif(:id_type_stay > 0, 1, 0);

  has_different_board     = iif(:min_board <> :max_board, 1, 0);
  has_different_tariff    = iif(:min_rate <> :max_rate, 1, 0);

  is_different_voucher = 0;
  is_different_other = 0;
  for
    select G.RDB$DB_KEY, G.VAUCHER_NUM, G.VAUCHER_DATE, G.VAUCHER_TEXT,
           G.VAUCHER_NUM2, G.VAUCHER_DATE2, G.TRANSFER_IN_TIME, G.TRANSFER_IN_NOTE, G.TRANSFER_OUT_TIME,
           G.TRANSFER_OUT_NOTE, G.CODE_FIRST_FOOD
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :g_dbkey, :voucher_num, :voucher_date, :voucher_text,
           :voucher2_num, :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time,
           :transfer_out_note, :code_first_food
  do begin
    if ((:voucher_num is distinct from :auto_voucher_num)
       or (:voucher_date is distinct from :auto_voucher_date)
       or (:voucher_text is distinct from :auto_voucher_text)
       or (:voucher2_num is distinct from :auto_voucher2_num)
       or (:voucher2_date is distinct from :auto_voucher2_date)
    ) then is_different_voucher = 1;

    if ((:transfer_in_time is distinct from :auto_transfer_in_time)
       or (:transfer_in_note is distinct from :auto_transfer_in_note)
       or (:transfer_out_time is distinct from :auto_transfer_out_time)
       or (:transfer_out_note is distinct from :auto_transfer_out_note)
       or (:code_first_food is distinct from :auto_code_first_food)
    ) then is_different_other  = 1;

    execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -1);
  end

  update RESERV_DETAIL RD
  set    RD.HAS_DIFFERENT_ROOM_TYPE = :has_different_room_type,
         RD.HAS_DIFFERENT_BOARD = :has_different_board,
         RD.HAS_DIFFERENT_TYPE_STAY = :has_different_type_stay,
         RD.HAS_DIFFERENT_TARIFF = :has_different_tariff,
         RD.HAS_DIFFERENT_VOUCHERS = :is_different_voucher,
         RD.HAS_DIFFERENT_OTHER = :is_different_other,
         RD.ADULT_COUNT = :adult_count,
         RD.CHILD_COUNT = :children_count,
         rd.ID_BOARD = iif(:min_board = :max_board, :min_board, rd.ID_BOARD),
         rd.ID_RATE = iif(:min_rate = :max_rate, :min_rate, rd.ID_RATE)
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_GUESTDATA_INVALIDATE$INT(:rd_dbkey);
end
^

/* Alter (RES_GUEST_SAVE_OTHER$RSV) */
ALTER PROCEDURE RES_GUEST_SAVE_OTHER$RSV(ID_GUEST INTEGER,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(30),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(30),
CODE_FIRST_FOOD TYPE OF TFOOD_CODE)
 AS
declare variable g_dbkey char(8);
  declare variable old_code_first_food tfood_code;
  declare variable old_text_first_food varchar(50);
  declare variable text_first_food varchar(50);
  declare variable action_text varchar(255);
begin
  select G.RDB$DB_KEY, G.CODE_FIRST_FOOD
  from   GUEST G
  where  G.ID_GUEST = :id_guest
  into   :g_dbkey, :old_code_first_food;

  execute procedure RES_GUEST_SAVE_OTHER$INT(:g_dbkey, :transfer_in_time, :transfer_in_note,
          :transfer_out_time, :transfer_out_note, :code_first_food);

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -1);

  if (coalesce(:old_code_first_food, 0) <> coalesce(:code_first_food, 0)) then begin
    old_text_first_food = case
                              when :old_code_first_food = 'breakfast' then 'caption.breakfast'
                              when :old_code_first_food = 'lunch' then 'caption.launch'
                              when :old_code_first_food = 'dinner' then 'caption.dinner'
                              when :old_code_first_food = 'extrafood1' then 'caption.extrafood1'
                              when :old_code_first_food = 'extrafood2' then 'caption.extrafood2'
                              when :old_code_first_food = 'none' then 'caption.no_first_food'
                          end;
    text_first_food = case
                              when :code_first_food = 'breakfast' then 'caption.breakfast'
                              when :code_first_food = 'lunch' then 'caption.launch'
                              when :code_first_food = 'dinner' then 'caption.dinner'
                              when :code_first_food = 'extrafood1' then 'caption.extrafood1'
                              when :code_first_food = 'extrafood2' then 'caption.extrafood2'
                              when :code_first_food = 'none' then 'caption.no_first_food'
                      end;
    action_text = f_character(29) || coalesce('@{' || :old_text_first_food || '}', '') ||
                  f_character(28) || coalesce('@{' || :text_first_food || '}', '');
    execute procedure SYSTEM_LOG_ADD ('GUEST', :ID_GUEST, 'FIRST_FOOD_CHANGED', :ACTION_TEXT);
  end
end
^

/* Alter (RES_GUEST_SAVE_RATE$RSV) */
ALTER PROCEDURE RES_GUEST_SAVE_RATE$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TARIFF INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_tariff integer;
  declare variable guest_name varchar(50);
  declare variable action_text varchar(255);
  declare variable old_rate varchar(50);
  declare variable new_rate varchar(50);
begin

  if (:ID_TARIFF = -1) then begin
    -- default to booking board
    select rd.ID_RATE
    from   GUEST g
           join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
    where  g.ID_GUEST = :ID_GUEST
    into   :ID_TARIFF;
  end

  update GUEST_STAY GS
  set    gs.ID_TARIFF = :ID_TARIFF
  where  gs.ID_GUEST = :ID_GUEST
         and gs.FOR_DATE = :FOR_DATE
  returning old.id_tariff
  into      :old_id_tariff;
  --

  if (:OLD_ID_TARIFF <> :ID_TARIFF) then begin
    select g.ID_RESERV_DETAIL, gc.GUEST_NAME1
    from   GUEST G
           left join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
    where  g.ID_GUEST = :ID_GUEST
    into   :id_reserv_detail, :guest_name;

    select T.TARIFA_NAME
    from   TARIFA T
    where  T.ID_TARIFA = :old_id_tariff
    into   :old_rate;
     
    select T.TARIFA_NAME
    from   TARIFA T
    where  T.ID_TARIFA = :ID_TARIFF
    into   :new_rate;
     
    action_text = f_character(29) || :guest_name
                  || f_character(28) || formatdate(:for_date, 'D;dd.mm.yyyy')
                  || f_character(28) || :new_rate
                  || f_character(28) || :old_rate;
    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :ID_RESERV_DETAIL, 'GUEST_DIFF_TARIFF', :ACTION_TEXT);
  end
end
^

/* Alter (RES_GUEST_SAVE_ROOMTYPE$RSV) */
ALTER PROCEDURE RES_GUEST_SAVE_ROOMTYPE$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TAR_ROOM_TYPE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_room_type integer;
  declare variable action_text varchar(255);
  declare variable guest_name varchar(50);
  declare variable old_room_type varchar(50);
  declare variable new_room_type varchar(50);
begin
 /* select G.TO_DATE - 1, G.ID_RESERV_DETAIL, GC.GUEST_NAME1
  from   GUEST G
         left outer join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
  where  G.ID_GUEST = :ID_GUEST
  into   :to_date, :id_reserv_detail, :guest_name;
  is_departure = iif(:to_date = :for_date, 1, 0);

  select GS.ID_TARIFF, GS.ID_BOARD, GS.ID_TYPE_STAY, GS.ID_ROOM_TYPE
  from   GUEST_STAY GS
  where  GS.ID_GUEST = :ID_GUEST
         and GS.FOR_DATE = :FOR_DATE
  into   :id_tariff, :id_board, :id_type_stay, :old_id_room_type;

  execute procedure RES_GUEST_DYNAMICPARAMS_SAVE(:id_reserv_detail, :id_guest, :for_date,
          :id_tar_room_type, :id_board, :id_type_stay, :id_tariff, :is_departure);
  */
  --
  update GUEST_STAY GS
  set    gs.ID_ROOM_TYPE = :ID_TAR_ROOM_TYPE
  where  gs.ID_GUEST = :ID_GUEST
         and gs.FOR_DATE = :FOR_DATE
  returning old.ID_ROOM_TYPE
  into      :old_id_room_type;

  if (:OLD_ID_ROOM_TYPE <> :ID_TAR_ROOM_TYPE) then begin
    select g.ID_RESERV_DETAIL, gc.GUEST_NAME1
    from   GUEST G
           left join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
    where  g.ID_GUEST = :ID_GUEST
    into   :id_reserv_detail, :guest_name;

    if (:old_id_room_type = -1) then begin
      old_room_type = '@{other.AUTO_TYPE_STAY}';
    end else begin
      select RT.TYPE_ROOM
      from   ROOM_TYPES RT
      where  RT.ID_ROOM_TYPE = :old_id_room_type
      into   :old_room_type;
    end

    if (:ID_TAR_ROOM_TYPE = -1) then begin
      new_room_type = '@{other.AUTO_TYPE_STAY}';
    end else begin
      select RT.TYPE_ROOM
      from   ROOM_TYPES RT
      where  RT.ID_ROOM_TYPE = :ID_TAR_ROOM_TYPE
      into   :new_room_type;
    end

    action_text = f_character(29) || :guest_name
                  || f_character(28) || formatdate(:for_date, 'd;dd.mm.yyyy')
                  || f_character(28) || :new_room_type
                  || f_character(28) || :old_room_type;
    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'GUEST_DIFF_ROOM_TYPE', :action_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_GUEST_SAVE_STAY$RSV for: RES_GUEST_SAVE_STAY$INT */
ALTER PROCEDURE RES_GUEST_SAVE_STAY$RSV(ID_GUEST INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_STAY$INT for: RES_GUEST_SAVE_STAY$INT */
ALTER PROCEDURE RES_SAVE_STAY$INT(RD_DBKEY CHAR(8),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_GUEST_SAVE_STAY$INT) */
ALTER PROCEDURE RES_GUEST_SAVE_STAY$INT(G_DBKEY CHAR(8),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable guest_status varchar(250);
  declare variable old_arrival_date date;
  declare variable old_departure_date date;
  declare variable system_date date;
  declare variable id_guest integer;
  declare variable is_check_in smallint;
begin

  if (:arrival_date >= :departure_date) then exception BOOKING_EXCEPTION '-53';

  guest_status = '';
  select G.FROM_DATE, G.TO_DATE, G.IS_CHECK_IN
  from   GUEST G
  where  G.RDB$DB_KEY = :g_dbkey
  into   :old_arrival_date, :old_departure_date, :is_check_in;

  if (:arrival_date <> :old_arrival_date) then guest_status = 'FROM_DATE_CHANGED';
  if (:departure_date <> :old_departure_date) then guest_status = 'TO_DATE_CHANGED';

  if (:guest_status containing 'DATE_CHANGED') then begin
    update GUEST G
    set    G.OLD_FROM_DATE = iif(G.OLD_FROM_DATE is null, :old_arrival_date, cast(minDate(:old_arrival_date, G.OLD_FROM_DATE) as date)),
           G.OLD_TO_DATE = iif(G.OLD_TO_DATE is null, :old_departure_date, cast(maxDate(:old_departure_date, G.OLD_TO_DATE) as date)),
           G.FROM_DATE = :arrival_date,
           G.TO_DATE = :departure_date
    where  G.RDB$DB_KEY = :g_dbkey
    returning g.ID_GUEST
    into      :id_guest;

    execute procedure GUEST_SET_EDIT_STATUS$INT (:G_DBKEY, :guest_status, 'add');

    execute procedure SYSTEM_DATE_GET(:id_hotel)
    returning_values  :system_date;

    -- if past dates are conserned
    if ( (:old_arrival_date is not null
          and :old_arrival_date <> :arrival_date
          and MinDate(:arrival_date, :old_arrival_date) < :system_date
         )
         or
         (:old_departure_date is not null
          and :old_departure_date <> :departure_date
          and MinDate(:departure_date, :old_departure_date) < :system_date
         )
       ) then
    begin
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MODIFY_PAST_STAY');
    end

    execute procedure GUEST_ADJUST_GUESTSTAY$INT(:g_dbkey);

    if (:is_check_in = 1) then begin
      execute procedure GUEST_REGISTRATION_UPDATE(:id_guest);
    end
  end

end
^

/* Alter (RES_GUEST_SAVE_STAY$RSV) */
ALTER PROCEDURE RES_GUEST_SAVE_STAY$RSV(ID_GUEST INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable g_dbkey char(8);
declare variable id_hotel integer;
  declare variable old_arrival date;
  declare variable old_departure date;
  declare variable action_text varchar(255);
begin
  err_code = 0;
  warn_code = 0;
  select G.RDB$DB_KEY, RD.ID_HOTEL, G.FROM_DATE, G.TO_DATE
  from   GUEST G
         join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
  where  G.ID_GUEST = :id_guest
  into   :g_dbkey, :id_hotel, :old_arrival, old_departure;

  execute procedure RES_GUEST_SAVE_STAY$INT(:g_dbkey, :arrival_date, :departure_date, :id_hotel);

  if ((:old_arrival <> :arrival_date) or (:old_departure <> :departure_date) ) then begin
    action_text = f_character(29) || '{' || formatdate(:old_arrival, 'D;dd.mm.yyyy') || '-' || formatdate(:old_departure, 'D;dd.mm.yyyy') || '}'
                  || f_character(28) || '{' || formatdate(:arrival_date, 'D;dd.mm.yyyy') || '-' || formatdate(:departure_date, 'D;dd.mm.yyyy') || '}';
    execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'GUEST_MOD_PERIOD', :action_text);
  end
end
^

/* Alter (RES_GUEST_SAVE_TYPESTAY$RSV) */
ALTER PROCEDURE RES_GUEST_SAVE_TYPESTAY$RSV(ID_GUEST INTEGER,
FOR_DATE DATE,
ID_TYPE_STAY INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_type_stay integer;
  declare variable action_text varchar(255);
  declare variable guest_name varchar(50);
  declare variable old_type_stay varchar(50);
  declare variable new_type_stay varchar(50);
begin
/*  select G.TO_DATE - 1, G.ID_RESERV_DETAIL, GC.GUEST_NAME1
  from   GUEST G
         left outer join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
  where  G.ID_GUEST = :ID_GUEST
  into   :to_date, :id_reserv_detail, :guest_name;
  is_departure = iif(:TO_DATE = :FOR_DATE, 1, 0);

  select GS.ID_ROOM_TYPE, GS.ID_TARIFF, GS.ID_BOARD, GS.ID_TYPE_STAY
  from   GUEST_STAY GS
  where  GS.ID_GUEST = :ID_GUEST
         and GS.FOR_DATE = :FOR_DATE
  into   :id_tar_room_type, :id_tariff, :id_board, :old_id_type_stay;

  execute procedure RES_GUEST_DYNAMICPARAMS_SAVE(:id_reserv_detail, :id_guest, :for_date,
          :id_tar_room_type, :id_board, :id_type_stay, :id_tariff, :is_departure);
  */
  --
  update GUEST_STAY GS
  set    gs.ID_TYPE_STAY = :ID_TYPE_STAY
  where  gs.ID_GUEST = :ID_GUEST
         and gs.FOR_DATE = :FOR_DATE
  returning old.ID_TYPE_STAY
  into      :old_id_type_stay;

  if (:old_id_type_stay <> :id_type_stay) then begin
    select g.ID_RESERV_DETAIL, gc.GUEST_NAME1
    from   GUEST G
           left join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
    where  g.ID_GUEST = :ID_GUEST
    into   :id_reserv_detail, :guest_name;

    if (:old_id_type_stay = -1) then begin
      old_type_stay = '@{other.AUTO_TYPE_STAY}';
    end else begin
      select TS.TYPE_STAY
      from   TYPE_STAY TS
      where  TS.ID_TYPE_STAY = :old_id_type_stay
      into   :old_type_stay;
    end
    if (:ID_TYPE_STAY = -1) then begin
      new_type_stay = '@{other.AUTO_TYPE_STAY}';
    end else begin
      select TS.TYPE_STAY
      from   TYPE_STAY TS
      where  TS.ID_TYPE_STAY = :id_type_stay
      into   :new_type_stay;
    end
     
    action_text = f_character(29) || :guest_name
                  || f_character(28) || formatdate(:for_date, 'd;dd.mm.yyyy')
                  || f_character(28) || :new_type_stay
                  || f_character(28) || :old_type_stay;
    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'GUEST_DIFF_TYPESTAY', :action_text);
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_GUESTCOUNT$INT for: RES_GUESTCOUNT_ADD$INT */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$INT(RD_DBKEY CHAR(8),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_GUESTCOUNT_ADD$INT) */
ALTER PROCEDURE RES_GUESTCOUNT_ADD$INT(RD_DBKEY CHAR(8),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
INITIALIZE_BOOKING TYPE OF TLOGICAL = 0)
 AS
declare variable i integer;
  declare variable is_child integer;
  declare variable new_id_guest integer;
begin
  i = 1;
  while (:i <= (coalesce(:adult_count, 0) + coalesce(:child_count, 0))) do begin
    if (:i <= :adult_count) then is_child = 0;
    else is_child = 1;

    execute procedure RES_GUEST_ADD$INT(:rd_dbkey, :is_child, :INITIALIZE_BOOKING)
    returning_values  :new_id_guest;
    i = :i + 1;

  end
end
^

/* Alter (RES_GUESTCOUNT_DEL$INT) */
ALTER PROCEDURE RES_GUESTCOUNT_DEL$INT(RD_DBKEY CHAR(8),
DEL_ADULT_COUNT INTEGER,
DEL_CHILD_COUNT INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable del_count integer;
  declare variable id_guest integer;
  declare variable extra_posts_left integer;
begin
  /*  Description:
  ||
  */
  select RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail;

  del_count = 0;
  if (:del_adult_count > 0) then begin
    for
      select first (:DEL_ADULT_COUNT) g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.IS_CHILD = 0
             and G.CHECK_STATUS = -2
      order by G.ID_GUEST desc
      into   :id_guest
    do begin
      execute procedure RES_GUEST_DEL$INT(:id_guest, :id_reserv_detail)
      returning_values  :extra_posts_left;
      del_count = :del_count + 1;
    end
    if (:del_count < :DEL_ADULT_COUNT) then exception BOOKING_EXCEPTION '-1002';
  end

  del_count = 0;
  if (:del_child_count > 0) then begin
    for
      select first (:DEL_CHILD_COUNT) g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.IS_CHILD = 1
             and G.CHECK_STATUS = -2
      order by G.ID_GUEST desc
      into   :id_guest
    do begin
      execute procedure RES_GUEST_DEL$INT(:id_guest, :id_reserv_detail)
      returning_values  :extra_posts_left;
      del_count = :del_count + 1;
    end
    if (:del_count < :DEL_CHILD_COUNT) then exception BOOKING_EXCEPTION '-1002';
  end

end
^

/* Alter (RES_GUESTLIST_REMOVE$RSV) */
ALTER PROCEDURE RES_GUESTLIST_REMOVE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable g_dbkey char(8);
  declare variable rd_dbkey char(8);
begin
  /*  Description:
  ||
  */

  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  for
    select G.RDB$DB_KEY
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :g_dbkey
  do begin
    execute procedure RES_GUEST_AUTO$INT(:g_dbkey, :rd_dbkey, 0);
  end

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
  returning_values  :WARN_CODE;

end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ACCOUNTING$RSV for: RES_SAVE_ACCOUNTING$INT */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$RSV(ID_RESERV_DETAIL INTEGER,
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER,
ID_CREDIT_CARD INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_COMMON_MODIFY$RSV for: RES_SAVE_ACCOUNTING$INT */
ALTER PROCEDURE RESMULTI_COMMON_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
CHECK_STATUS SMALLINT,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
NOTE VARCHAR(2000),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(30),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
NOTE_REMINDERS VARCHAR(50),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(WARN_CODE /* TYPE OF TRANGE */ INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: UPDATE_BOOKING$EXC for: RES_SAVE_ACCOUNTING$INT */
ALTER PROCEDURE UPDATE_BOOKING$EXC(BOOKING_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE INTEGER,
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA_ID INTEGER,
POSTING_ROUTING VARCHAR(20),
ID_AGENT_ACCOUNT INTEGER,
RATE_ID INTEGER,
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD_CODE /* TFOOD_CODE */ VARCHAR(20),
ARRANGER_PROFILE_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_ACCOUNTING$INT) */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$INT(RD_DBKEY CHAR(8),
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER)
 AS
declare variable old_id_agent_profile integer;
  declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable action_text varchar(255);
  declare variable old_account_routing varchar(30);
  declare variable id_acc_profile integer;
begin
  execute procedure SYSTEM_CHECK_OPERATION(:acc_routing, 'GUEST, AGENT, MIXED, OWNER, FULL_COMPLIMENTARY, PART_COMPLIMENTARY', 'Account routing');

  if (exists (select *
              from   PROFILE_HOUSE PH
              where  PH.ID_PROFILE = :id_agent_profile)) then
  begin
    exception BOOKING_EXCEPTION '-1016';
  end

  --execute procedure RESERV_TRACK_CHANGES$INT(:rd_dbkey);

  select RD.ID_AGENT_PROFILE, RD.ID_RESERV_DETAIL, RD.ACC_ROUTING
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_agent_profile, :id_reserv_detail, :old_account_routing;

  if (:ACC_ROUTING in ('AGENT','MIXED') and :ID_AGENT_ACCOUNT is not null) then begin
    select A.ID_PROFILE
    from   ACCOUNT A
    where  A.ID_ACCOUNT = :ID_AGENT_ACCOUNT
    into   :id_acc_profile;
    -- check up agent account ownership
    if (:id_acc_profile is distinct from :ID_AGENT_PROFILE) then ID_AGENT_ACCOUNT = null;
  end

  update RESERV_DETAIL RD
  set    RD.ID_AGENT_ACCOUNT_RULE = :ID_AGENT_ACCOUNT,
         RD.ACC_ROUTING = :ACC_ROUTING,
         RD.ID_AGENT_PROFILE = :ID_AGENT_PROFILE,
         RD.ID_AGENT_PAYMENT = :ID_AGENT_PAYMENT,
         RD.ID_PERSON_PAYMENT = coalesce(:ID_PERSON_PAYMENT, RD.ID_PERSON_PAYMENT),
         RD.ID_GROUP = :ID_GROUP
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_id_agent_profile is distinct from :id_agent_profile) then begin
    execute procedure RES_SET_EDIT_STATUS$INT(:RD_DBKEY, 'AGENT', 'add');

    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :g_dbkey
    do begin
      execute procedure GUEST_AGENT_SET$INT(:g_dbkey, :id_agent_profile);
    end

    select f_character(29)||coalesce(old_A.PROFILE_NAME, '')||f_character(28)||coalesce(new_A.PROFILE_NAME, '')
    from   PROFILE old_A, PROFILE new_A
    where  old_A.ID_PROFILE = :old_id_agent_profile
           and new_A.ID_PROFILE = :ID_AGENT_PROFILE
    into   :action_text;

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_AGENT', :action_text);
  end

  if (:ACC_ROUTING <> :old_account_routing) then begin
    action_text = f_character(29) || coalesce(:old_account_routing, '')
                  || f_character(28) || coalesce(:acc_routing, '');

    execute procedure SYSTEM_LOG_ADD('RES_DETAIL', :id_reserv_detail, 'RES_MOD_ACC_ROUTING', :action_text);
  end

  execute procedure RES_SAVE_ACCOUNTS$INT (:RD_DBKEY);
end
^

/* Alter (RES_SAVE_ACCOUNTING$RSV) */
ALTER PROCEDURE RES_SAVE_ACCOUNTING$RSV(ID_RESERV_DETAIL INTEGER,
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_GROUP INTEGER,
ID_CREDIT_CARD INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);


begin
  /* Description : ACC_ROUTING = {GUEST, AGENT, MIXED, OWNER,  }
  ||
  */
  select rd.RDB$DB_KEY
  from   RESERV_DETAIL rd
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SAVE_ACCOUNTING$INT(:rd_dbkey, :id_agent_profile, :id_agent_account, :acc_routing,
                    :id_person_payment, :id_agent_payment, :id_group);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
  returning_values  :warn_code;

  --
end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_GUESTCOUNT$RSV for: RES_SAVE_GUESTCOUNT$INT */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_GUESTCOUNT$INT) */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$INT(RD_DBKEY CHAR(8),
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 AS
declare variable old_adult_count integer;
  declare variable old_child_count integer;
  declare variable add_adult_count integer;
  declare variable add_child_count integer;
  declare variable del_adult_count integer;
  declare variable del_child_count integer;
begin

  if (((:adult_count + :child_count) <= 0) or (:adult_count < 0) or (:child_count < 0)) then begin
    exception BOOKING_EXCEPTION '-1005' || f_character(31) || f_character(29) || :adult_count || f_character(28) || :child_count;
  end

  select RD.ADULT_COUNT, RD.CHILD_COUNT
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_adult_count, :old_child_count;
  add_adult_count = 0;
  add_child_count = 0;
  del_adult_count = 0;
  del_child_count = 0;
  if (:old_adult_count < :adult_count) then add_adult_count = adult_count - :old_adult_count;
  else del_adult_count = :old_adult_count - :adult_count;
  if (:old_child_count < :child_count) then add_child_count = child_count - :old_child_count;
  else del_child_count = :old_child_count - :child_count;

  execute procedure RES_GUESTCOUNT_ADD$INT(:rd_dbkey, :add_adult_count, :add_child_count);

  execute procedure RES_GUESTCOUNT_DEL$INT(:rd_dbkey, :del_adult_count, :del_child_count);
end
^

/* Alter (RES_SAVE_GUESTCOUNT$RSV) */
ALTER PROCEDURE RES_SAVE_GUESTCOUNT$RSV(ID_RESERV_DETAIL INTEGER,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select rd.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  rd.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_SAVE_GUESTCOUNT$INT(:rd_dbkey, :adult_count, :child_count);

  execute procedure RES_SAVE_ACCOUNTS$INT (:rd_dbkey);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 0)
  returning_values  :warn_code;

end
^

/* Alter (RES_SAVE_RATE$RSV) */
ALTER PROCEDURE RES_SAVE_RATE$RSV(ID_RESERV_DETAIL INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
IS_DIFFERENT_TARIFF INTEGER,
IS_DIFFERENT_PRICE INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 AS
declare variable rd_dbkey char(8);
  declare variable old_price numeric(14,4);
  declare variable old_price_currency char(3);
  declare variable old_is_different_price integer;
  declare variable action_text varchar(255);
  declare variable err_code integer;
  declare variable err_text varchar(255) ;
  declare variable id_tar_calc integer;
  declare variable recalc_type varchar(20);
  declare variable old_tariff integer;
begin

  select RD.RDB$DB_KEY, RD.custom_price, rd.custom_currency, rd.HAS_DIFFERENT_PRICE, rd.ID_RATE
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_price, :old_price_currency, :old_is_different_price, :old_tariff;

  if (:is_different_tariff = 0) then begin
    execute procedure RES_SAVE_RATE$INT(:rd_dbkey, :id_tariff);
  end else begin
    execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey);
  end

  if (:IS_DIFFERENT_PRICE = 0) then begin
    delete from RESERV_CUSTOM_PRICE
    where  ID_RESERV_DETAIL  = :ID_RESERV_DETAIL;

    update RESERV_DETAIL RD
    set    RD.CUSTOM_PRICE = :custom_price,
           RD.CUSTOM_CURRENCY = :custom_currency,
           RD.HAS_DIFFERENT_PRICE = :IS_DIFFERENT_PRICE
    where  RD.RDB$DB_KEY = :rd_dbkey;
  end else begin
    if (not exists (select * from RESERV_CUSTOM_PRICE rmp where rmp.id_reserv_detail = :id_reserv_detail)) then IS_DIFFERENT_PRICE = 0;
    update RESERV_DETAIL RD
    set    RD.CUSTOM_PRICE = null,
           RD.CUSTOM_CURRENCY = null,
           RD.HAS_DIFFERENT_PRICE = :IS_DIFFERENT_PRICE
    where  RD.RDB$DB_KEY = :rd_dbkey;
  end


  /*Maintain the flag in RD - HAS_DIFFERENT_PRICE*/
/*  if (exists (select * from RESERV_CUSTOM_PRICE rmp where rmp.id_reserv_detail = :id_reserv_detail)) then
    update RESERV_DETAIL set has_different_price = 1 where id_reserv_detail = :id_reserv_detail;
  else
    update RESERV_DETAIL set has_different_price = 0 where id_reserv_detail = :id_reserv_detail;
*/
  /*Log modifications in custom price if here is diferent values*/
  if ((:old_price is distinct from :custom_price) or (:old_price_currency is distinct from :custom_currency) ) then begin
    action_text = f_character(29) || formatfloat(:custom_price, 'F;0.00') || '' || :custom_currency || f_character(28);
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_MANUAL_PRICE', :action_text);
  end

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    if ((:ID_TARIFF is distinct from :old_tariff)
        or (:IS_DIFFERENT_PRICE is distinct from :old_is_different_price)
        or (:CUSTOM_PRICE is distinct from :old_price)
        or (:CUSTOM_CURRENCY is distinct from :old_price_currency) ) then
      recalc_type = 'FORCED';
    else
      recalc_type = 'NORMAL';

    execute procedure RES_RECALC$INT(:rd_dbkey, :recalc_type, 0)
    returning_values  :err_code, :err_text, :id_tar_calc;
    --execute procedure RES_FINALIZE_RECALC$INT(:rd_dbkey)
    --returning_values  :err_code, :err_text;
    if (:err_code < 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_CHECKIN$RSV for: RES_SAVE_ROOM$INT */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_ROOM_REMOVE$INT for: RES_SAVE_ROOM$INT */
ALTER PROCEDURE RES_ROOM_REMOVE$INT(RD_DBKEY CHAR(8))
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ROOM$RSV for: RES_SAVE_ROOM$INT */
ALTER PROCEDURE RES_SAVE_ROOM$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
ID_RES_ROOM_TYPE INTEGER,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(255),
SPLIT_ON_CHECKIN SMALLINT,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM$INT for: RES_SAVE_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM$INT(RD_DBKEY CHAR(8),
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_ROOM$INT) */
ALTER PROCEDURE RES_SAVE_ROOM$INT(RD_DBKEY TYPE OF TDB_KEY,
ID_ROOM TYPE OF ID,
ID_RES_ROOM_TYPE TYPE OF ID,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE TYPE OF TLOGICAL = null)
 RETURNS(WARN_CODE TYPE OF TRANGE)
 AS
declare variable id_reserv_detail integer;
  declare variable id_tar_room_type integer;
  declare variable old_id_room_type integer;
  declare variable old_id_room integer;
  declare variable departure_date date;
  declare variable arrival_date date;
  declare variable id_guest integer;
  declare variable g_dbkey char(8);
  declare variable system_date date;
  declare variable system_date_for_room date;
  declare variable check_status integer;
  declare variable cleaning_restriction varchar(50);
  declare variable guest_status varchar(50) default '';
  declare variable id_hotel integer;
  declare variable has_different_room_type integer;
  declare variable acc_routing varchar(30);
  declare variable res_number varchar(62);
  declare variable is_check_in smallint;
begin
  select RD.ID_ROOM_TYPE, RD.CHECK_STATUS, RD.ID_ROOM, rd.FROM_DATE, RD.TO_DATE, RD.ID_RESERV_DETAIL, RD.ID_HOTEL, rd.ACC_ROUTING, rd.NUMBER
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_room_type, :check_status, :old_id_room, :arrival_date, :departure_date, :id_reserv_detail, :id_hotel, :acc_routing, :res_number;

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date_for_room;
  /**/
  system_date = null;
  /*  */
  if (:check_status >= 0 and :old_id_room > 0 and coalesce(:id_room, 0) <= 0) then
    exception BOOKING_EXCEPTION '-111';

  if ((:old_id_room > 0) and (:id_room is distinct from :old_id_room)) then begin
    guest_status = 'ROOM_CHANGED';
    if ((:old_id_room > 0) and (:id_room > 0)) then begin
      execute procedure SYSTEM_DATE_GET(:id_hotel)
      returning_values  :system_date;
      execute procedure sys_dbg('res RES_SAVE_ROOM$INT old_id_room = '||coalesce(:old_id_room, 'null'));
      execute procedure sys_dbg('res RES_SAVE_ROOM$INT check_status = '||coalesce(:check_status, 'null'));

      if ((:departure_date <= :system_date) and (:check_status >= 0)) then exception BOOKING_EXCEPTION '-51';
    end
  end

  if (:id_room is null and :old_id_room < 0) then id_room = :old_id_room; -- preserve old fictious ID, because of mapped rooms

  if (coalesce(:id_room, 0) <= 0) then begin
    delete from ROOM_MAP$EXC m
    where  m.id_room = :id_room
           and m.ID_SRC_ROOM < 0;  -- delete wrong mappings (bug 2827)

    select ro.ID_ROOM
    from   RES_OCCUPANCY_ROOM$INT (:id_reserv_detail, :system_date_for_room, :id_room, :ID_RES_ROOM_TYPE) RO
    into   :id_room;

  end else begin
    -- real room is
    id_res_room_type = :old_id_room_type;
    if (:acc_routing <> 'OWNER'
        and :id_room is distinct from :old_id_room
        and exists (select rp.ID_ROOM_PERIOD
                    from   ROOM_PERIOD$PMS rp
                    where  rp.ID_ROOM = :ID_ROOM
                           and rp.FROM_DATE <= maxdate(:system_date_for_room, :arrival_date)
                           and rp.TO_DATE >= maxdate(:system_date_for_room, :arrival_date)
                           and rp.STATUS = 'PRIVATE')) then
    begin
      execute procedure SYSTEM_WARNING_ADD (-61, f_character(29) || :res_number)
      returning_values  :WARN_CODE;
    end
  end
  id_res_room_type = coalesce(:id_res_room_type, :old_id_room_type);
  -- null is permissible for id_res_room_type, treat of "keep the same"

  /* tar_option : nrttAsIs, nrttRoom, nrttReserv */
  id_tar_room_type = null;
  has_different_room_type = null;
  if (:tar_option = 'nrttAsIs') then begin
    id_tar_room_type = null;
    has_different_room_type = null;
  end else if (:tar_option = 'nrttRoom') then begin
    --id_tar_room_type = iif(coalesce(:id_room, 0) <= 0 and :room_id_room_type <> :ID_RES_ROOM_TYPE, :room_id_room_type, -1);
    id_tar_room_type = iif (:ID_ROOM > 0, -1, null); -- if not room - like a AsIs
    has_different_room_type = iif(:id_tar_room_type = -1, 0, null);
    -- preserve tar_room_type from mapped(unexisted) room
  end else begin /* nrttReserv */
    id_tar_room_type = :id_res_room_type;
    has_different_room_type = 1;
  end

  update RESERV_DETAIL RD
  set    RD.ID_ROOM = :id_room,
         rd.ROOM_PRICE = case
                           when rd.CHECK_STATUS >= 0 then null
                           -- 'checked in' bookings - force recalculation always
                           when rd.CHECK_STATUS < 0
                                and ((rd.ID_ROOM_TYPE <> :id_res_room_type) or (:id_room is distinct from :old_id_room)) then null
                           -- not 'checked in', but room/room type changed - force too
                           else rd.ROOM_PRICE
                         end,   -- <null> room_price will be force booking recalculation !!!
         RD.ID_ROOM_TYPE = :id_res_room_type,  -- this field update must be after room_price update
         rd.HAS_DIFFERENT_ROOM_TYPE = coalesce(:has_different_room_type, rd.HAS_DIFFERENT_ROOM_TYPE) --iif(coalesce(:id_tar_room_type, 0) > 0, 1, rd.HAS_DIFFERENT_ROOM_TYPE)
  where  RD.RDB$DB_KEY = :rd_dbkey;

  for
    select G.RDB$DB_KEY, G.ID_GUEST, g.IS_CHECK_IN
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :g_dbkey, :id_guest, :is_check_in
  do begin
    update GUEST GU
    set    GU.OLD_ID_ROOM = GU.ID_ROOM,
           GU.ID_ROOM = :id_room
    where  GU.RDB$DB_KEY = :g_dbkey;

    execute procedure GUEST_SET_EDIT_STATUS$INT (:g_dbkey, :guest_status, 'add');
   
    /*Old code if (:system_date is null) update room_type and type stay*/
    update GUEST_STAY GS
    set    GS.ID_ROOM_TYPE = iif(:id_tar_room_type is null, GS.ID_ROOM_TYPE, :id_tar_room_type),
           GS.ID_TYPE_STAY = iif(:is_auto_staytype = 1, -1, GS.ID_TYPE_STAY)
    where  GS.ID_GUEST = :id_guest
           and ((:system_date is null) or (GS.FOR_DATE >= :system_date));

    /*New part - Room number never be updated in past - important for shares and calulations*/
    /* will be updated in pass only if there was no room assigned*/
    update GUEST_STAY GS
    set    GS.ID_ROOM = :id_room
    where  GS.ID_GUEST = :id_guest
           and ((GS.FOR_DATE >= :system_date_for_room)
                 or (:check_status < 0) -- new - always change id_room from begining, for non checked in reservs
               ) ;

    if (:is_check_in = 1 and :ID_ROOM is distinct from :old_id_room) then begin
      execute procedure GUEST_REGISTRATION_UPDATE(:id_guest);
    end
  end

  if ((:check_status = 0) and (:guest_status = 'ROOM_CHANGED') and (:old_id_room > 0)) then begin
    /* IF THE CLEANING RESTRICTION IS ACTIVATED AND THE OLD
    || GUEST'S ROOM IS VACANT THEN IT MUST BE MARKED DIRTY.
    */
    execute procedure SETTING_GET_VALUE('CLEANING_RESTRICTION', :id_hotel)
    returning_values  :cleaning_restriction;
    if ((:cleaning_restriction <> '0') and (not exists (
      select *
      from   GUEST G
             join GUEST_STAY GS on GS.ID_GUEST = G.ID_GUEST
      where  GS.FOR_DATE >= :system_date
             and G.CHECK_STATUS = 0
             and GS.ID_ROOM = :old_id_room
             and G.ID_RESERV_DETAIL <> :id_reserv_detail
    ))) then begin
      execute procedure ROOM_HOUSEKEEPING(:old_id_room, 'GST_MOVED', 'set_dirty');
    end
  end

  execute procedure RES_SAVE_ROOM_LOG$INT(:RD_DBKEY, :old_id_room, :old_id_room_type);

end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_ROOM$EXC for: RES_SAVE_ROOM$RSV */
ALTER PROCEDURE RES_SAVE_ROOM$EXC(RD_DBKEY CHAR(8),
ID_RES_ROOM_TYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(250),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SAVE_ROOM$RSV) */
ALTER PROCEDURE RES_SAVE_ROOM$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
ID_RES_ROOM_TYPE INTEGER,
TAR_OPTION VARCHAR(50),
IS_AUTO_STAYTYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(255),
SPLIT_ON_CHECKIN SMALLINT,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
declare variable tmp_warn_code integer;
begin
  WARN_CODE = null;
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, :id_res_room_type, :TAR_OPTION, :is_auto_staytype)
  returning_values (:WARN_CODE);

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 1)
    returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :tmp_warn_code;
  end
  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

  update RESERV_DETAIL R
  set    r.SPLIT_ON_CHECKIN = :split_on_checkin,
         r.ID_HK_PLAN = :ID_HK_PLAN,
         r.I_SPECIAL_TREATMENT = :I_SPECIAL_TREATMENT,
         r.ROOM_FEATURES = :ROOM_FEATURES
  where  r.ID_RESERV_DETAIL = :id_reserv_detail;
end
^

/* empty dependent procedure body */
/* Clear: RES_EARLY_DEPARTURE_SET$RSV for: RES_SAVE_STAY$INT */
ALTER PROCEDURE RES_EARLY_DEPARTURE_SET$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND INTEGER)
 RETURNS(RECALC_MARKER_LIST VARCHAR(255),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_STAY$RSV for: RES_SAVE_STAY$INT */
ALTER PROCEDURE RES_SAVE_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_STAY$RSV for: RES_SAVE_STAY$INT */
ALTER PROCEDURE RES_SET_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESMULTI_STAY_MODIFY$RSV for: RES_SAVE_STAY$INT */
ALTER PROCEDURE RESMULTI_STAY_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SAVE_STAY$INT) */
ALTER PROCEDURE RES_SAVE_STAY$INT(RD_DBKEY CHAR(8),
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER)
 AS
declare variable day_keep_types integer;
  declare variable exp_date date;
  declare variable leaving_kind integer;
  declare variable old_arrival date;
  declare variable old_departure date;
  declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable old_comming_kind integer;
  declare variable old_leaving_kind integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable is_stay_changed integer;
begin
  -- TODO exp_date must become input parameter, because the user may change it! or add exp_scheme!

  select RD.FROM_DATE, RD.TO_DATE, RD.COMMING_KIND, RD.LEAVING_KIND, RD.ID_HOTEL,
         rd.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_arrival, :old_departure, :old_comming_kind, :old_leaving_kind, :id_hotel,
         :id_reserv_detail;

  if (:DEPARTURE_DATE <= :ARRIVAL_DATE) then exception BOOKING_EXCEPTION '-53';

  execute procedure SETTING_GET_VALUE('DAY_KEEP_TYPES', :id_hotel)
  returning_values  :day_keep_types;

  exp_date = :arrival_date + :day_keep_types;
  leaving_kind = coalesce(:is_late_departure + 1, :old_leaving_kind);
  comming_kind = coalesce(:comming_kind, :old_comming_kind);
  /*
  if ((:arrival_date <> :old_arrival) or (:departure_date <> :old_departure)) then begin
    execute procedure RESERV_TRACK_CHANGES$INT (:RD_DBKEY);
  end
  */
  if ((:arrival_date <> :old_arrival)
      or (:departure_date <> :old_departure)
      or (:comming_kind <> :old_comming_kind)
      or (:leaving_kind <> :old_leaving_kind)) then is_stay_changed = 1;
  else is_stay_changed = 0;

  update RESERV_DETAIL RD
  set    RD.COMMING_KIND = :comming_kind,
         RD.LEAVING_KIND = :leaving_kind,
         RD.EXP_DATE = :exp_date,
         RD.FROM_DATE = :arrival_date,
         RD.TO_DATE = :departure_date,
         rd.ROOM_PRICE = iif(:is_stay_changed = 1, null, rd.ROOM_PRICE) -- force recalculation
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:is_stay_changed = 1) then begin
    for
      select G.RDB$DB_KEY
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :g_dbkey
    do begin
      execute procedure RES_GUEST_SAVE_STAY$INT(:g_dbkey, :arrival_date, :departure_date, :id_hotel);
    end

    execute procedure RES_SET_EDIT_STATUS$INT (:RD_DBKEY, 'DATE_CHANGED');

    --Remove manual prices (if any) outer new period--/
    if (:old_arrival < :arrival_date) then
      delete from RESERV_CUSTOM_PRICE rcp
      where  rcp.id_reserv_detail = :id_reserv_detail
             and rcp.FOR_DATE < :arrival_date;

    if (:old_departure > :departure_date) then
      delete from RESERV_CUSTOM_PRICE rcp
      where  rcp.id_reserv_detail = :id_reserv_detail
             and RCP.FOR_DATE >= :departure_date;

    if (not exists (select * from RESERV_CUSTOM_PRICE rmp where rmp.id_reserv_detail = :id_reserv_detail)) then
        update RESERV_DETAIL set  has_different_price = 0 where id_reserv_detail = :id_reserv_detail;
    ----
  end

  if ((:old_arrival <> :arrival_date) or (:old_departure <> :departure_date) ) then begin
    action_text = f_character(29) || '{' || formatdate(:old_arrival, 'D;dd.mm.yyyy') || '-' || formatdate(:old_departure, 'D;dd.mm.yyyy') || '}'
                  || f_character(28) || '{' || formatdate(:arrival_date, 'D;dd.mm.yyyy') || '-' || formatdate(:departure_date, 'D;dd.mm.yyyy') || '}';
    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_MOD_PERIOD', :action_text);
  end
end
^

/* Alter (RES_SAVE_STAY$RSV) */
ALTER PROCEDURE RES_SAVE_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
IS_LATE_DEPARTURE INTEGER,
COMMING_KIND INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure sys_dbg('res RES_SAVE_STAY$RSV comming_kind = '||coalesce(:comming_kind, 'null'));
  execute procedure sys_dbg('res RES_SAVE_STAY$RSV is_late_departure = '||coalesce(:is_late_departure, 'null'));

  execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :departure_date, :is_late_departure, :comming_kind);

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 1)
    returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;
    execute procedure sys_dbg('res RES_SAVE_STAY$RSV share_err_code = '||coalesce(:share_err_code, 'null'));
  end
  --
end
^

/* Alter (RES_SET_CHECKIN$INT) */
ALTER PROCEDURE RES_SET_CHECKIN$INT(RD_DBKEY CHAR(8))
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable g_dbkey char(8);
  declare variable id_reserv_detail integer;
begin
  select r.ID_RESERV_DETAIL
  from   RESERV_DETAIL R
  where  r.RDB$DB_KEY = :rd_dbkey
  into   :id_reserv_detail;

  execute procedure ROOM_MAGIC_CLEAR(:id_reserv_detail);   -- ?!?

  execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, 0);

  for
    select G.RDB$DB_KEY
    from   GUEST G
    where  g.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
    into   :g_dbkey
  do begin
    execute procedure GUEST_SET_STATUS$INT(:g_dbkey, 0);
  end

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;
end
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_CO_RENTERS$INT for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_CO_RENTERS$INT(VIRTUAL_ID_ROOM INTEGER,
NEW_ID_ROOM INTEGER,
INIT_ID_RES_DETAIL INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_FAST$RSV for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_FAST$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_MULTI$RSV for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_MULTI$RSV(OPERATION VARCHAR(20),
FROM_ROOM VARCHAR(20),
SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SET_ROOM_SHARED$RSV for: RES_SET_ROOM$INT */
ALTER PROCEDURE RES_SET_ROOM_SHARED$RSV(SELECTION_ID INTEGER,
ROOM_NAME VARCHAR(10))
 RETURNS(VIRTUAL_ROOM VARCHAR(10),
WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_SET_ROOM$INT) */
ALTER PROCEDURE RES_SET_ROOM$INT(RD_DBKEY CHAR(8),
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
declare variable tmp_warn_code integer;
begin
  WARN_CODE = null;
  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option)
  returning_values (:WARN_CODE);

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 0)
  returning_values  :SHARE_ERR_CODE, :SHARE_ERR_TEXT, :share_transaction_id, :tmp_warn_code;

  WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
end
^

/* Alter (RES_SET_ROOM_CO_RENTERS$INT) */
ALTER PROCEDURE RES_SET_ROOM_CO_RENTERS$INT(VIRTUAL_ID_ROOM INTEGER,
NEW_ID_ROOM INTEGER,
INIT_ID_RES_DETAIL INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
SHARE_ERR_TEXT VARCHAR(255))
 AS
declare variable shared_rd_dbkey char(8);
declare variable shared_booking_ids varchar(255);
declare variable id_reserv_detail integer;
declare variable tmp_share_err_code integer;
declare variable tmp_share_err_text varchar(255);
begin
  -- distribute the same room to shared bookings

  if (coalesce(:NEW_ID_ROOM, 0) < 0) then exit; -- only for real rooms!1
  SHARE_ERR_CODE = 0;
  shared_booking_ids = ',' || :INIT_ID_RES_DETAIL || ',';
  for
    select vrd.RDB$DB_KEY, vrd.ID_RESERV_DETAIL
    from   RESERV_DETAIL VRD
    where  vrd.ID_ROOM = :VIRTUAL_ID_ROOM
           and vrd.IS_ANUL = 0
           and vrd.ID_RESERV_DETAIL is distinct from :INIT_ID_RES_DETAIL
    into   :shared_rd_dbkey, :id_reserv_detail
  do begin
    shared_booking_ids = :shared_booking_ids || :id_reserv_detail || ',';

    execute procedure RES_SET_ROOM$INT (:shared_rd_dbkey, :NEW_ID_ROOM, :TAR_OPTION)
    returning_values  :WARN_CODE, :share_transaction_id, :tmp_share_err_code, :tmp_share_err_text;

    if (:SHARE_ERR_CODE = 0 and :tmp_share_err_code < 0) then begin
      -- check for share with other bookings
      if (exists (select rs.ID_RESERV_DETAIL
                      from   ROOMS_SHARE rs
                      where  rs.MARK_TRANSACTION = :SHARE_TRANSACTION_ID
                             and :shared_booking_ids not containing ','||rs.ID_RESERV_DETAIL||','
                             and rs.IS_EX_SHARE = 0)) then
      begin
        SHARE_ERR_CODE = :tmp_share_err_code;
        SHARE_ERR_TEXT = :tmp_share_err_text;
      end
    end
  end 
end
^

/* Alter (RES_SET_ROOM_FAST$RSV) */
ALTER PROCEDURE RES_SET_ROOM_FAST$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER,
TAR_OPTION VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable old_id_room integer;
  declare variable virtual_room varchar(10);
  declare variable rd_dbkey char(8);
  declare variable tmp_warn_code integer;
  declare variable tmp_share_err_code integer;
  declare variable tmp_share_err_text varchar(255);
begin

  select RD.ID_ROOM, rd.VIRTUAL_ROOM, rd.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_id_room, :virtual_room, :rd_dbkey;

  execute procedure RES_SET_ROOM$INT (:rd_dbkey, :ID_ROOM, :TAR_OPTION)
  returning_values (:warn_code, :share_transaction_id, :share_err_code, :ERR_TEXT);

  if (:virtual_room is not null and :old_id_room < 0) then begin
    execute procedure RES_SET_ROOM_CO_RENTERS$INT (:old_id_room, :ID_ROOM, :ID_RESERV_DETAIL, :TAR_OPTION)
    returning_values (:tmp_warn_code, :share_transaction_id, :tmp_share_err_code, :tmp_share_err_text);
    WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
    SHARE_ERR_CODE = coalesce(:SHARE_ERR_CODE, :tmp_share_err_code);
    ERR_TEXT = coalesce(:ERR_TEXT, :tmp_share_err_text);
  end
end
^

/* Alter (RES_SET_ROOM_MULTI$RSV) */
ALTER PROCEDURE RES_SET_ROOM_MULTI$RSV(OPERATION VARCHAR(20),
FROM_ROOM VARCHAR(20),
SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable cnt_requested integer;
  declare variable cnt_old_room integer;
  declare variable cnt_found integer;
  declare variable is_already_planned integer;
  declare variable is_satisfied integer;
  declare variable new_id_room integer;
  declare variable current_id_room integer;
  declare variable id_res_room_type integer;
  declare variable room_requirements blob sub_type 1 segment size 100;
  declare variable from_date date;
  declare variable to_date date;
  declare variable action_text varchar(255);
  declare variable is_early_arrival smallint;
  declare variable is_late_departure smallint;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable id_reserv_detail integer;
  declare variable tmp_warn_code integer;
  declare variable min_beds integer;
  declare variable virtual_room varchar(10);
  declare variable share_err_text varchar(255);
begin
  /* offer_method :
  ||     0 - NUMBER desc,
  ||     1 - NUMBER asc,
  ||     2 - DAYS FREE(MAX OCCUPANCY),
  ||     3 - FILING FACTOR(EQUAL ROOM USAGE)
  */
  warn_code = null;

  execute procedure SYSTEM_CHECK_OPERATION(:operation, 'set_number_asc, set_number_desc, set_max_occupancy, set_max_usage');

  cnt_requested = 0;
  cnt_old_room = 0;
  cnt_found = 0;
  for
    select RD.RDB$DB_KEY, rd.ID_RESERV_DETAIL, rd.ID_ROOM, rd.VIRTUAL_ROOM, RD.ID_ROOM_TYPE, RD.ROOM_FEATURES,
           RD.FROM_DATE, RD.TO_DATE, iif(rd.COMMING_KIND = 0, 1, 0), iif(rd.LEAVING_KIND = 2, 1, 0),
           rd.ADULT_COUNT + rd.CHILD_COUNT
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
           and RD.IS_ANUL = 0
    into   :rd_dbkey, :id_reserv_detail, :current_id_room, :virtual_room, :id_res_room_type, :room_requirements,
           :from_date, :to_date, :is_early_arrival, :is_late_departure, :min_beds
  do begin
    cnt_requested = :cnt_requested + 1;
    new_id_room = null;
    if (:current_id_room < 0) then begin
      if (:virtual_room is not null) then begin
        -- has related bookings with shared virtual room
        -- get cumulative stay for all shared bookings
        select min(vrd.FROM_DATE), min(vrd.FROM_DATE) - min(vrd.FROM_DATE - iif(vrd.COMMING_KIND = 0, 1, 0)),
               max(vrd.TO_DATE), max(vrd.TO_DATE + iif(vrd.LEAVING_KIND = 2, 1, 0)) - max(vrd.TO_DATE),
               sum(vrd.ADULT_COUNT + vrd.CHILD_COUNT)
        from   RESERV_DETAIL VRD
        where  vrd.ID_ROOM = :current_id_room
               and vrd.IS_ANUL = 0
        into   :from_date, :is_early_arrival, :to_date, :is_late_departure, :min_beds;
      end
      -- from_date and to_date are arrival and departure date of reservation,
      -- not first and last accomodation dates !!! this is need to check early arrivals and late departures
      execute procedure ROOM_PICKUP$INT(:id_res_room_type, :from_date, :to_date,
              :is_early_arrival, :is_late_departure,:operation, :from_room, :room_requirements, :min_beds)
      returning_values  :new_id_room;  -- offered room

      if (:new_id_room is not null) then begin
        is_satisfied = 1;
        select R.ROOM_NAME
        from   ROOMS R
        where  r.ID_ROOM = :new_id_room
        into   :action_text;

        execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'ROOM_SET_AUTO', :action_text);

        execute procedure RES_SET_ROOM$INT (:rd_dbkey, :new_id_room, 'nrttAsIs')
        returning_values (:tmp_warn_code, :share_transaction_id, :share_err_code, :share_err_text);
        if (:share_err_code < 0) then exception BOOKING_EXCEPTION 'Unallowable share!!!';
        WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

        if (:virtual_room is not null) then begin
          -- distribute the same room to shared bookings
          execute procedure RES_SET_ROOM_CO_RENTERS$INT (:current_id_room, :new_id_room, :id_reserv_detail, 'nrttAsIs')
          returning_values (:tmp_warn_code, :share_transaction_id, :share_err_code, :share_err_text);
          if (:share_err_code < 0) then exception BOOKING_EXCEPTION 'Unallowable share!!!';
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
        end
      end

    end else begin
      is_already_planned = 1;
    end

    cnt_old_room = :cnt_old_room + :is_already_planned;
    cnt_found = :cnt_found + :is_satisfied;

    when exception BOOKING_EXCEPTION do begin
      -- nothing, skip this booking
    end
  end

  if ((:cnt_found + :cnt_old_room) < :cnt_requested) then begin
    execute procedure SYSTEM_WARNING_ADD(-3, f_character(29)||:cnt_found||f_character(28)||:cnt_requested)
    returning_values  :warn_code;
  end
end
^

/* Alter (RES_SET_ROOM_SHARED$RSV) */
ALTER PROCEDURE RES_SET_ROOM_SHARED$RSV(SELECTION_ID INTEGER,
ROOM_NAME VARCHAR(10))
 RETURNS(VIRTUAL_ROOM VARCHAR(10),
WARN_CODE INTEGER)
 AS
declare variable r_dbkey char(8);
  declare variable is_anul integer;
  declare variable shared_id_room integer;
  declare variable current_id_room integer;
  declare variable tmp_warn_code integer;
  declare variable share_trans integer;
  declare variable share_err_code integer;
  declare variable id_hotel integer;
  declare variable cnt_hotels integer;
  declare variable id_room integer;
  declare variable res_counter integer;
  declare variable min_departure date;
  declare variable max_arrival date;
  declare variable share_err_text varchar(255);
begin
  VIRTUAL_ROOM = null;
  select min(r.ID_HOTEL), count(distinct r.ID_HOTEL),
         min(r.TO_DATE), max(r.FROM_DATE)
  from   RESERV_DETAIL R
  where  R.SELECTION_ID = :SELECTION_ID
  into   :id_hotel, :cnt_hotels, :min_departure, :max_arrival;

  if (:cnt_hotels > 1) then exception BOOKING_EXCEPTION '-1035';
  if (:min_departure <= :max_arrival) then exception BOOKING_EXCEPTION '-1037';

  if (:ROOM_NAME is not null) then begin
    execute procedure ROOM_GET_BY_NAME(:ROOM_NAME, :id_hotel)
    returning_values (:id_room);
    shared_id_room = :ID_ROOM;
  end else begin
    id_room = null;
    shared_id_room = gen_id(DETAIL_WITHOUT_ROOMING_LIST, -1);
    VIRTUAL_ROOM = gen_id(GEN_VIRTUAL_ROOM, 1);
  end

  res_counter = 0;
  for
    select r.RDB$DB_KEY, r.IS_ANUL, r.ID_ROOM
    from   RESERV_DETAIL R
    where  R.SELECTION_ID = :SELECTION_ID
    into   :r_dbkey, :is_anul, :current_id_room
  do begin
    res_counter = :res_counter + 1;
    if (:is_anul = 1) then
      exception BOOKING_EXCEPTION '-1036';

    if (:current_id_room > 0 and :ID_ROOM is null) then
      exception BOOKING_EXCEPTION '-1034';

    execute procedure RES_SET_ROOM$INT(:r_dbkey, :shared_id_room, 'nrttAsIs')
    returning_values  :tmp_warn_code, :share_trans, :share_err_code, :share_err_text;
    WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
  end

  if (:VIRTUAL_ROOM is not null and :share_trans is not null) then begin
    update RESERV_DETAIL RD
    set    rd.VIRTUAL_ROOM = '<'||:VIRTUAL_ROOM||'>'
    where  rd.ID_ROOM = :shared_id_room;
  end
end
^

/* Alter (RES_SET_STAY$RSV) */
ALTER PROCEDURE RES_SET_STAY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable is_late_departure integer;
  declare variable comming_kind integer;
begin
  select RD.COMMING_KIND, RD.LEAVING_KIND - 1, RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :comming_kind, :is_late_departure, :rd_dbkey;

  execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :departure_date, :is_late_departure, :comming_kind);

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey, 1)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

end
^

/* empty dependent procedure body */
/* Clear: RES_CHECKIN_MULTI$RSV for: RES_SPLIT$RSV */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_SPLIT_MULTI$RSV for: RES_SPLIT$RSV */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_SPLIT$RSV) */
ALTER PROCEDURE RES_SPLIT$RSV(ID_RESERV_DETAIL_SOURCE INTEGER,
GUEST_IDS VARCHAR(200))
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER)
 AS
declare variable rd_dbkey_old char(8);
  declare variable rd_dbkey_new char(8);
  declare variable id_guest integer;
  declare variable warn_code integer;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;

  declare variable id_agent_profile integer;
  declare variable id_person_profile integer;
  declare variable check_status integer;
  declare variable arrival_date date;
  declare variable departure_date date;
  declare variable adult_count integer;
  declare variable child_count integer;
  declare variable id_room_type integer;
  declare variable id_room integer;
  declare variable id_board integer;
  declare variable id_tariff integer;
  declare variable custom_price numeric(15,4);
  declare variable custom_currency char(3);
  declare variable voucher_num varchar(30);
  declare variable voucher_date date;
  declare variable voucher_text varchar(30);
  declare variable voucher2_num varchar(30);
  declare variable voucher2_date date;
  declare variable transfer_in_time time;
  declare variable transfer_in_note varchar(255);
  declare variable transfer_out_time time;
  declare variable transfer_out_note varchar(255);
  declare variable comming_kind integer;
  declare variable is_late_departure integer;
  declare variable is_vip integer;
  declare variable country_code varchar(20);
  declare variable code_first_food tfood_code;
  declare variable i_special_treatment varchar(255);
  declare variable id_nom_market_segment integer;
  declare variable id_nom_source_code integer;
  declare variable id_nom_channel_code integer;
  declare variable id_nom_hear_reason integer;
  declare variable id_nom_come_reason integer;
  declare variable id_agent_account integer;
  declare variable acc_routing varchar(50);
  declare variable id_person_payment integer;
  declare variable id_agent_payment integer;
  declare variable room_features blob sub_type 1 segment size 80;
  declare variable id_hk_plan integer;
  declare variable id_group integer;
  declare variable id_hotel integer;
  declare variable note varchar(2000);
  declare variable note_reminders varchar(50);
  declare variable guarantee_deposit numeric(15,4);
  declare variable guarantee_currency char(3);
  declare variable id_titular integer;
  declare variable id_profile_data integer;
  declare variable id_acc_template_person integer;
  declare variable number_1 varchar(20);
  declare variable number_2 varchar(20);
  declare variable new_res_number varchar(62);
  declare variable g_dbkey char(8);
  declare variable is_child integer;
  declare variable id_guarantee_policy integer;
  declare variable block_cc varchar(255);
  declare variable virtual_room varchar(10);
  declare variable err_text varchar(255);
  declare variable is_posting_stopped integer;
  declare variable id_eating_object integer;
begin
  select RD.RDB$DB_KEY, RD.ID_AGENT_PROFILE, RD.CHECK_STATUS, RD.FROM_DATE, RD.TO_DATE,
         RD.ADULT_COUNT, RD.CHILD_COUNT, RD.ID_ROOM_TYPE, RD.ID_ROOM, RD.ID_BOARD, RD.ID_RATE,
         RD.CUSTOM_PRICE, RD.CUSTOM_CURRENCY, RD.VAUCHER_NUM, RD.VAUCHER_DATE, RD.VAUCHER_TEXT, RD.VAUCHER_NUM2,
         RD.VAUCHER_DATE2, RD.TRANSFER_IN_TIME, RD.TRANSFER_IN_NOTE, RD.TRANSFER_OUT_TIME, RD.TRANSFER_OUT_NOTE,
         RD.COMMING_KIND, RD.LEAVING_KIND - 1, RD.IS_VIP, RD.COUNTRY, RD.CODE_FIRST_FOOD, RD.I_SPECIAL_TREATMENT,
         RD.ID_NOM_MARKET_SEGMENT, RD.ID_NOM_SOURCE_CODE, RD.ID_NOM_CHANNEL_CODE, RD.ID_NOM_HEAR_REASON,
         RD.ID_NOM_COME_REASON, RD.ID_AGENT_ACCOUNT_RULE, RD.ACC_ROUTING, RD.ID_PERSON_PAYMENT, RD.ID_AGENT_PAYMENT,
         RD.ROOM_FEATURES, RD.ID_HK_PLAN, RD.ID_GROUP, RD.ID_HOTEL, RD.NOTE, RD.NOTE_REMINDERS,
         RD.GUARANTEE_DEPOSIT, RD.GUARANTEE_CURRENCY, RD.ID_ACC_TEMPLATE_PERSON,
         RD.NUMBER_1, rd.NUMBER_2, rd.ID_GUARANTEE_POLICY, rd.BLOCK_CC, rd.IS_POSTING_STOPPED, rd.ID_EATING_OBJECT
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail_source
  into   :rd_dbkey_old, :id_agent_profile, :check_status, :arrival_date, :departure_date,
         :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff,
         :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
         :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
         :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
         :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
         :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
         :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
         :guarantee_deposit, :guarantee_currency, :id_acc_template_person,
         :number_1, :number_2,:id_guarantee_policy, :block_cc, :is_posting_stopped, :id_eating_object;

  select first 1 sp.ITEM
  from   SYSTEM_STRING_PARSER(:guest_ids, ',') sp
  into   :id_titular;

  select min(g.FROM_DATE), max(g.TO_DATE)
  from   GUEST G
  where  G.ID_RESERV_DETAIL = :ID_RESERV_DETAIL_SOURCE
         and ','||:GUEST_IDS||',' containing ','||g.ID_GUEST||','
  into   :arrival_date, :departure_date;

  if (exists (select *
              from   RESERV_DETAIL RD
              where  RD.ID_TITULAR = :id_titular
                     and RD.ID_RESERV_DETAIL = :id_reserv_detail_source))
  then exception BOOKING_EXCEPTION 'Titular can not be splited in new reservation';

  execute procedure RES_GET_PERSON_PROFILE$INT(:id_titular)
  returning_values  :id_person_profile, :id_profile_data;

  new_res_number = iif(coalesce(:number_1,'')='','.',:number_1||'.')
                   || coalesce(:number_2, '')
                   || '.0';  -- fictive suffix, needed for unique constraint limitation, that will be replaced with real one


  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, :check_status, :arrival_date, :departure_date,
                    0, 0, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, :country_code, :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders,
                    :guarantee_deposit, :guarantee_currency, 0, null, :new_res_number, :id_acc_template_person,
                    :id_guarantee_policy, :block_cc, :id_eating_object)
  returning_values  :rd_dbkey_new, :new_id_reserv_detail, :warn_code;

  execute procedure RES_NUMBER_SUFFIX_GEN (:NEW_ID_RESERV_DETAIL)
  returning_values  (:new_res_number);  -- add suffix to new (splited) booking number (empty on create)

  update RESERV_DETAIL NR
  set    nr.IS_POSTING_STOPPED = :is_posting_stopped
  where  nr.RDB$DB_KEY = :rd_dbkey_new;

  -- there is no need guests deleting, because new splited reservation is created with 0 guests
  adult_count = 0; child_count = 0;
  for
    select G.ID_GUEST, G.RDB$DB_KEY, G.IS_CHILD
    from   SYSTEM_STRING_PARSER(:guest_ids, ',') SP
           join GUEST G on G.ID_GUEST = SP.ITEM
    into   :id_guest, :g_dbkey, :is_child
  do begin
    execute procedure GUEST_SET_EDIT_STATUS$INT (:g_dbkey, 'REBUILD', 'add');

    update GUEST G
    set    G.ID_RESERV_DETAIL = :new_id_reserv_detail
    where  G.ID_GUEST = :id_guest;

    adult_count = :adult_count + (1-:is_child);
    child_count = :child_count + :is_child;

    if (:id_guest = :id_titular) then begin
      update RESERV_DETAIL RD
      set    RD.ID_TITULAR = :id_titular
      where  RD.RDB$DB_KEY = :rd_dbkey_new;

      update GUEST_DATA GD
      set    GD.ID_PERSON_DATA = :id_profile_data
      where  GD.ID_GUEST = :id_titular;
    end
  end

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL_SOURCE, 'RES_SPLIT',
          f_character(29) || :new_res_number || f_character(28) || :adult_count || ' + ' || :child_count);

  -- calling RES_SAVE_PROFILING$INT is unnecessary, it is called into RES_CREATE_SET$INT with same params
  -- here is needed to set reserv accounts per splited guests and reroute posting only (accomplished in next procedure)
  execute procedure RES_SAVE_ACCOUNTS$INT(:rd_dbkey_new);

  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_old);
  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey_new);

  update RESERV_DETAIL ORD
  set    ord.ROOM_PRICE = null
  where  ord.RDB$DB_KEY = :rd_dbkey_old;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_old, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  execute procedure RES_FINALIZE_SHAREOPTION$INT(:rd_dbkey_new, 0)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :warn_code;

  if (:id_room < 0) then begin
    virtual_room = gen_id(GEN_VIRTUAL_ROOM, 1);
    update RESERV_DETAIL RD
    set    rd.VIRTUAL_ROOM = '<'||:virtual_room||'>'
    where  rd.ID_ROOM = :id_room;
  end
end
^

/* Alter (RES_SPLIT_MULTI$RSV) */
ALTER PROCEDURE RES_SPLIT_MULTI$RSV(SELECTION_ID INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
begin
  for
    select RD.ID_RESERV_DETAIL, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :id_reserv_detail, :id_titular
  do begin
    for
      select G.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
             and G.ID_GUEST <> :id_titular
      into   :id_guest
    do begin
      execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
      returning_values  :id_splited_reservation;

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_RECALC$INT for: RES_TAR_CALC_FINALIZE$INT */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_TAR_CALC_FINALIZE$INT) */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(ID_TAR_CALC INTEGER,
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
declare variable old_room_price numeric(15,4);
  declare variable old_room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
  declare variable reserv_posting_disabled smallint;
  declare variable postings_disabled smallint;
  declare variable warn_code integer;
  declare variable action_text varchar(255);
  declare variable id_guest integer;
begin
  --  Razpiswa cenata na staia, kakto i price_detailite.

  execute procedure TAR_CALC_EVAL_ALL$INT(:ID_TAR_CALC)
  returning_values  :ERR_CODE, :ERR_TEXT;

  if (:ERR_CODE = 0) then execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

  select iif(si.INFO_VALUE = '1', 1, null)
  from   SYSTEM_INFO_GET('RESERV_POSTINGS_DISABLED') si
  into   :postings_disabled;

  for
    select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, coalesce(:postings_disabled, rd.IS_POSTING_STOPPED),
           coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
           coalesce(max((select first 1 AP.IS_BASE
                         from   GUEST G
                                join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                         where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (it`s possible)
    from   TAR_CALC_INPUT$TMP TI
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
           join TARIFA t on t.ID_TARIFA = rd.ID_RATE
    where  ti.ID_TAR_CALC = :ID_TAR_CALC
    group by 1, 2, 3, 4, 5, 6
    into   :id_reserv_detail, :check_status, :is_posting_stopped,
           :room_currency, :id_hotel, :is_anul, :has_postings
  do begin
    reserv_posting_disabled = iif(:is_posting_stopped = 1 and :has_postings = 0, 1, 0);

    if (:ERR_CODE <> 0) then begin
      -- price calculation error handling  !!!!!
      if (:reserv_posting_disabled = 1) then begin
        -- set price to null, posting is disabled
        update RESERV_DETAIL RD
        set    RD.ROOM_PRICE = null,
               RD.ROOM_CURRENCY = null,
               RD.ROOM_PRICE_DETAILS = null,
               RD.LAST_ID_TAR_CALC = null
        where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
      end else begin
        -- exit on error in price calculation - cannot make valid posts
        EXIT;
      end
    end else begin
      room_price = 0;
      room_price_details = '';
    
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);
  
      if (:reserv_posting_disabled = 0 and ((coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1))) then begin
        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);
      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;
  
        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end
  
      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc,
             rd.ROOM_PRICE_LAST$INT = null,
             rd.ROOM_CURRENCY_LAST$INT = null
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail
      returning old.ROOM_PRICE_LAST$INT, old.ROOM_CURRENCY_LAST$INT
      into :old_room_price, :old_room_currency;

      if ((:old_room_price is distinct from :room_price)
          or (:old_room_currency is distinct from :room_currency) ) then
      begin
        action_text = f_character(29) || formatfloat(:old_room_price, 'F;0.00') || ' ' || coalesce(:old_room_currency, '') || f_character(28) || formatfloat(:room_price, 'F;0.00') || ' ' || coalesce(:room_currency, '');
        execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_PRICE_RECALC', :action_text);

        if (:check_status >= 0) then begin
          for
            select g.ID_GUEST
            from   GUEST G
            where  g.ID_RESERV_DETAIL = :id_reserv_detail
            into   :id_guest
          do begin
            execute procedure GUEST_REGISTRATION_UPDATE(:id_guest);
          end
        end
      end
    end
  end

  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;

  if (:ERR_CODE <> 0) then begin
    execute procedure SYSTEM_WARNING_ADD(:ERR_CODE, :ERR_TEXT)
    returning_values :warn_code;
    ERR_CODE = 0;
    ERR_TEXT='';
  end
end
^

/* Alter (RES_TRANSFER_FINALIZE$RSV) */
ALTER PROCEDURE RES_TRANSFER_FINALIZE$RSV(ID_RESERV_DETAIL_NEW INTEGER,
ID_RESERV_DETAIL_OLD INTEGER)
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
begin
  execute procedure RES_ANUL_DETAIL$RSV(:id_reserv_detail_old, 'TRANSFER')
  returning_values  :WARN_CODE, :EXTRA_POSTS_LEFT;
end
^

/* empty dependent procedure body */
/* Clear: RESERV_STATISTIC_CANCELED$INT for: RESERV_STATISTIC_SLICE$INT */
ALTER PROCEDURE RESERV_STATISTIC_CANCELED$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(BUSY_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_PROFILE_AGENT INTEGER,
COUNTRY_CODE VARCHAR(20),
MARKET_SEGMENT_CODE VARCHAR(3),
SOURCE_CODE VARCHAR(3),
CHANNEL_CODE VARCHAR(3),
HEAR_REASON_CODE VARCHAR(3),
COME_REASON_CODE VARCHAR(3),
ROOMS_NOSHOW SMALLINT,
GUESTS_NOSHOW SMALLINT,
ROOMS_CANCELED SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: SUMMARY_OCCUPANCY_STATISTIC$INT for: RESERV_STATISTIC_SLICE$INT */
ALTER PROCEDURE SUMMARY_OCCUPANCY_STATISTIC$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* Alter (RESERV_STATISTIC_SLICE$INT) */
ALTER PROCEDURE RESERV_STATISTIC_SLICE$INT(ID_RESERV_DETAIL INTEGER)
 RETURNS(ID_PROFILE_AGENT INTEGER,
COUNTRY_CODE VARCHAR(20),
MARKET_SEGMENT_CODE VARCHAR(3),
SOURCE_CODE VARCHAR(3),
CHANNEL_CODE VARCHAR(3),
HEAR_REASON_CODE VARCHAR(3),
COME_REASON_CODE VARCHAR(3))
 AS
begin
  select iif(PA.ID_AGENT > 0, PA.ID_PROFILE, null), GC.COUNTRY,
         MS.MARKET_CODE, SC.SOURCE_CODE, CC.CHANNEL_CODE, HR.HEAR_REASON_CODE, CR.COME_REASON_CODE
  from   RESERV_DETAIL RD
         left outer join GUEST_CARD GC on GC.ID_GUEST = RD.ID_TITULAR
         left outer join PROFILE_AGENT PA on PA.ID_PROFILE = RD.ID_AGENT_PROFILE
         left outer join NOM_CHANNEL_CODES CC on CC.ID_NOM_CHANNEL_CODE = RD.ID_NOM_CHANNEL_CODE
         left outer join NOM_COME_REASONS CR on CR.ID_NOM_COME_REASON = RD.ID_NOM_COME_REASON
         left outer join NOM_HEAR_REASONS HR on HR.ID_NOM_HEAR_REASON = RD.ID_NOM_HEAR_REASON
         left outer join NOM_SOURCE_CODES SC on SC.ID_NOM_SOURCE_CODE = RD.ID_NOM_SOURCE_CODE
         left outer join NOM_MARKET_SEGMENTS MS on MS.ID_NOM_MARKET_SEGMENT = RD.ID_NOM_MARKET_SEGMENT
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :ID_PROFILE_AGENT, :COUNTRY_CODE,
         :MARKET_SEGMENT_CODE, :SOURCE_CODE, :CHANNEL_CODE, :HEAR_REASON_CODE, :COME_REASON_CODE;

  COUNTRY_CODE = coalesce(:COUNTRY_CODE, '');

  suspend;
end
^

/* empty dependent procedure body */
/* Clear: END_WORK for: RESERVS_EXPIRE$INT */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (RESERVS_EXPIRE$INT) */
ALTER PROCEDURE RESERVS_EXPIRE$INT(CLEAR_TODATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable day_keep_number integer;
  declare variable rd_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable nouse integer;
  declare variable day_keep_types integer;
begin
  /*AA NA IONEA I?AAE I?EEE??AAIA -BF END WORK-*/
  execute procedure SETTING_GET_VALUE('DAY_KEEP_NUMBERS', :ID_HOTEL)
  returning_values  :day_keep_number;
  /*************************************************************/
  /*    REMOVE ROOM NUMBERS FROM EXPIRED RESERV DETAILS        */
  /*************************************************************/
  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.IS_ANUL = 0
           and RD.CHECK_STATUS < 0
           and RD.IS_VIP = 0
           and RD.ID_ROOM > 0
           and (RD.FROM_DATE <=  cast(:clear_todate - :day_keep_number as date))
    into   :rd_dbkey, :id_reserv_detail
  do begin
    execute procedure RES_ROOM_REMOVE$INT(:rd_dbkey)
    returning_values  :nouse;

    when any do begin
      -- nothing
    end
  end
  /*************************************************************/
  /*    EXPIRED NON VIP or VIP TYPES                           */
  /*************************************************************/
  execute procedure SETTING_GET_VALUE('DAY_KEEP_TYPES', :ID_HOTEL)
  returning_values  :day_keep_types;

  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.CHECK_STATUS < 0
           and RD.IS_ANUL = 0
           and RD.FROM_DATE <= cast(:clear_todate - :day_keep_types as date)
           and RD.IS_VIP = 0
    union
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.ID_HOTEL = :id_hotel
           and RD.CHECK_STATUS < 0
           and RD.IS_ANUL = 0
           and RD.TO_DATE < :clear_todate
           and RD.IS_VIP = 1
    into   :rd_dbkey, :id_reserv_detail
  do begin
    execute procedure sys_dbg('res RESERVS_EXPIRE: id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

    execute procedure RES_ANUL_NOSHOW$INT(:rd_dbkey)
    returning_values  :nouse;

    execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_NOSHOW', '');

    when any do begin
      -- nothing
    end
  end
end
^

/* Alter (RESMULTI_COMMON_MODIFY$RSV) */
ALTER PROCEDURE RESMULTI_COMMON_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
CHECK_STATUS SMALLINT,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
NOTE VARCHAR(2000),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(30),
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
NOTE_REMINDERS VARCHAR(50),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(WARN_CODE TYPE OF TRANGE)
 AS
declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable old_id_room_type integer;
  declare variable old_status integer;
begin
  select RD.RDB$DB_KEY, RD.ID_ROOM, RD.ID_ROOM_TYPE, rd.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :old_id_room, :old_id_room_type, :old_status;

  execute procedure RES_SAVE_GUESTCOUNT$INT(:rd_dbkey, :adult_count, :children_count);

  execute procedure RES_SAVE_NOTE$RSV(:id_reserv_detail, :note, null);

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, :id_room_type, 'nrttAsIs')
  returning_values (:WARN_CODE);

  execute procedure RES_SAVE_ROOM_LOG$INT(:rd_dbkey, :old_id_room, :old_id_room_type);

  execute procedure RES_SAVE_ACCOUNTING$INT(:rd_dbkey, :id_agent_profile, :id_agent_account, :acc_routing,
                    :id_person_payment, :id_agent_payment, :id_group);

  update RESERV_DETAIL RD
  set    RD.CUSTOM_PRICE = :CUSTOM_PRICE,
         RD.CUSTOM_CURRENCY = :CUSTOM_CURRENCY,
         RD.SPLIT_ON_CHECKIN = :SPLIT_ON_CHECKIN,
         RD.NOTE_REMINDERS = :NOTE_REMINDERS,
         rd.ID_HK_PLAN = :ID_HK_PLAN
  where  RD.RDB$DB_KEY = :rd_dbkey;

  if (:old_status <> :CHECK_STATUS) then begin
    if (:CHECK_STATUS >= 0) then exception BOOKING_EXCEPTION 'Can not set status ''CHECKED IN'' or ''CHECKED OUT'' manually!';
  
    execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, :check_status);
  end
  --
end
^

/* Alter (RESMULTI_CREATE$RSV) */
ALTER PROCEDURE RESMULTI_CREATE$RSV(ID_HOTEL INTEGER,
ID_ROOM_TYPE INTEGER,
TRANSFER_OUT_TIME TIME,
TRANSFER_IN_TIME TIME,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
TRANSFER_OUT_NOTE VARCHAR(50),
TRANSFER_IN_NOTE VARCHAR(50),
NOTE VARCHAR(255),
ID_BOARD INTEGER,
VOUCHER_DATE DATE,
VOUCHER_NUMBER VARCHAR(20),
VOUCHER_TEXT VARCHAR(30),
CHECK_STATUS INTEGER,
ID_TARIFF INTEGER,
COUNTRY_CODE VARCHAR(20),
ID_HK_PLAN INTEGER,
ID_GROUP INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
ID_AGENT_PROFILE INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
NOTE_REMINDERS VARCHAR(50),
TITULAR_NAME VARCHAR(100),
SPLIT_ON_CHECKIN INTEGER,
ID_EATING_OBJECT TYPE OF ID_REF = null)
 RETURNS(NEW_ID_RESERV_DETAIL INTEGER,
NUMBER VARCHAR(62),
NEW_ID_TITULAR INTEGER,
NEW_FROM_DATE TYPE OF TDATE,
WARN_CODE TYPE OF TRANGE)
 AS
declare variable rd_dbkey char(8);
  declare variable id_person_profile integer;
  declare variable pd_dbkey char(8);
  declare variable id_acc_template_person integer;
begin

  select sv.SETTING_VALUE
  from   SETTING_GET_VALUE ('DEF_ACC_TEMPLATE', :ID_HOTEL) sv
  into   :id_acc_template_person;

  execute procedure RES_CREATE_SET$INT(:id_agent_profile, null, :check_status, :arrival_date, :departure_date,
                    :adult_count, :children_count, :id_room_type, null, :id_board, :id_tariff, null,
                    null, null, :voucher_number, :voucher_date, :voucher_text, '',
                    null, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    1, 0, 0, :country_code, :code_first_food, '',
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    '', :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders, null, null,
                    :split_on_checkin, null, null, :id_acc_template_person, null, null, :ID_EATING_OBJECT)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :WARN_CODE;

  select RD.NUMBER, RD.ID_PERSON_PROFILE, RD.ID_TITULAR
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :number, :id_person_profile, :new_id_titular;

  if (:titular_name <> '') then begin
    select PD.RDB$DB_KEY
    from   PROFILE P
           join PROFILE_PERSON PP on PP.ID_PROFILE = P.ID_PROFILE
           join PERSON_DATA PD on PD.ID_PERSON_DATA = PP.ID_PERSON_DATA
    where  P.ID_PROFILE = :id_person_profile
    into   :pd_dbkey;

    update PERSON_DATA PD
    set    PD.PERSON_NAME = :titular_name,
           PD.PERSON_NAME2 = :titular_name
    where  PD.RDB$DB_KEY = :pd_dbkey;
  end

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;
end
^

/* Alter (RESMULTI_STAY_MODIFY$RSV) */
ALTER PROCEDURE RESMULTI_STAY_MODIFY$RSV(ID_RESERV_DETAIL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE)
 AS
declare variable rd_dbkey char(8);
  declare variable is_late_departure integer;
  declare variable comming_kind integer;
begin

  select RD.RDB$DB_KEY, RD.COMMING_KIND, RD.LEAVING_KIND - 1
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :comming_kind, :is_late_departure;

  execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :departure_date, :is_late_departure, :comming_kind);
end
^

/* Alter (SPR_HOTEL_REGISTER) */
ALTER PROCEDURE SPR_HOTEL_REGISTER(IN_FROM DATE,
IN_TO DATE,
IN_FROM_GUEST INTEGER,
IN_TO_GUEST INTEGER,
IN_MASK VARCHAR(10),
ID_HOTEL INTEGER = null)
 RETURNS(ID_GUEST INTEGER,
GUEST_NAME VARCHAR(50),
ROOM_NAME VARCHAR(10),
CITIZENSHIP_EGN VARCHAR(65),
PERIOD_FROM DATE,
PERIOD_TO DATE,
NIGHTS INTEGER,
RESERVATION VARCHAR(100),
ID_ACCOUNT_NIGHTS VARCHAR(30),
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
ADDRESS_BULGARIAN VARCHAR(100),
PASSPORT VARCHAR(40),
NOTE VARCHAR(255))
 AS
declare variable egn varchar(50);
  declare variable country_code varchar(20);
  declare variable country varchar(50);
  declare variable id_account integer;
  declare variable address varchar(100);
  declare variable city varchar(100);
  declare variable pass_num varchar(20);
  declare variable pass_date date;
  declare variable mask varchar(10);
begin
  select  coalesce((select first 1 cast(:in_mask as varchar(10))
                   from   USER_RIGHTS R
                   where  R.RIGHT_CODE = 'MASK_DIFF_FROM_DEF'),
                  (select iif(coalesce(nullif(cast(:in_mask as varchar(10)), ''), SGV.SETTING_VALUE) is distinct from SGV.SETTING_VALUE, 'unknown', SGV.SETTING_VALUE)
                   from   SETTING_GET_VALUE('DEF_GUEST_MASK', :id_hotel) SGV))
  from    dummy
  into    :in_mask;
  
  for
    select G.ID_GUEST, GC.GUEST_NAME1, R.ROOM_NAME, GC.COUNTRY, CN.COUNTRY_NAME,
           GC.EGN, G.FROM_DATE, G.TO_DATE, G.ID_ACCOUNT, GC.BIRTH_DAY, GC.BIRTH_PLACE,
           GC.ADDRESS, gc.SITY, GC.PASS_NUM, GC.PASS_DATE, GC.MASK, RD.NUMBER
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
           left outer join GUEST_CARD GC on GC.ID_GUEST = G.ID_GUEST
           left outer join ROOMS R on G.ID_ROOM = R.ID_ROOM
           left outer join COUNTRY CN on CN.COUNTRY_CODE = GC.COUNTRY
    where  G.FROM_DATE between :IN_FROM and :IN_TO
           and rd.IS_ANUL = 0
           and RD.CHECK_STATUS >= 0
           and ((RD.ID_HOTEL = :id_hotel) or (:id_hotel is null))
    into   :ID_GUEST, :GUEST_NAME, :ROOM_NAME, :COUNTRY_CODE, :COUNTRY,
           :EGN, :PERIOD_FROM, :PERIOD_TO, :ID_ACCOUNT, :BIRTH_DATE, :BIRTH_PLACE,
           :ADDRESS, :city, :PASS_NUM, :PASS_DATE, :MASK, :RESERVATION
  do begin
    CITIZENSHIP_EGN = :COUNTRY;

    if ((:EGN is not null) and (EGN <> '')) then
      CITIZENSHIP_EGN = :CITIZENSHIP_EGN || ' (' || :EGN || ')';

    if (upper(:COUNTRY_CODE) = 'BG') then begin
      ADDRESS_BULGARIAN = substring(iif(trim(coalesce(:city, '')) <> '', :city || ' ' || :address, :address) from 1 for 100);
    end else begin
      ADDRESS_BULGARIAN = '';
    end

    if (:PASS_NUM is null) then PASS_NUM = '';
    PASSPORT = :PASS_NUM;
    if (:PASS_DATE is not null and :PASS_DATE <> '30.12.1899') then
      PASSPORT = trim(:PASSPORT || FORMATDATE(:PASS_DATE,'D; dd/mm/yyyy'));

    NIGHTS = :PERIOD_TO - :PERIOD_FROM;
    ID_ACCOUNT_NIGHTS = ''|| :ID_ACCOUNT || ' (' || :NIGHTS || ')';
    NOTE = '';
    if (((:IN_FROM_GUEST is null) or (:ID_GUEST >= :IN_FROM_GUEST))
        and ((:IN_TO_GUEST is null) or (:ID_GUEST <= IN_TO_GUEST))
        and ((:IN_MASK is null) or (:IN_MASK = '') or (:MASK like '%' || :IN_MASK||'%'))) then
      suspend;
  end
end
^

/* empty dependent procedure body */
/* Clear: OCCUPANCY_SUMMARY_REMAKE$SYS for: SUMMARY_OCCUPANCY_STATISTIC$INT */
ALTER PROCEDURE OCCUPANCY_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
 BEGIN EXIT; END
^

/* empty dependent procedure body */
/* Clear: SUMMARY_STATISTIC_REBUILD$EW for: SUMMARY_OCCUPANCY_STATISTIC$INT */
ALTER PROCEDURE SUMMARY_STATISTIC_REBUILD$EW(ID_HOTEL INTEGER)
 AS
 BEGIN EXIT; END
^

/* Alter (SUMMARY_OCCUPANCY_STATISTIC$INT) */
ALTER PROCEDURE SUMMARY_OCCUPANCY_STATISTIC$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
declare variable busy_date date;
  declare variable id_room_type integer;
  declare variable id_profile_agent integer;
  declare variable country_code varchar(20);
  declare variable market_segment_code varchar(3);
  declare variable source_code varchar(3);
  declare variable channel_code varchar(3);
  declare variable hear_reason_code varchar(3);
  declare variable come_reason_code varchar(3);
  declare variable rooms_noshow smallint;
  declare variable rooms_canceled smallint;

  declare variable rooms_ooi smallint;
  declare variable rooms_ooo smallint;

  declare variable rooms_sold smallint;
  declare variable rooms_sold_multiple_gst smallint;
  declare variable rooms_arrival smallint;
  declare variable rooms_departure smallint;
  declare variable ad_in_house smallint;
  declare variable ad_arrival smallint;
  declare variable ad_departure smallint;
  declare variable ch_in_house smallint;
  declare variable ch_arrival smallint;
  declare variable ch_departure smallint;
  declare variable guests_noshow smallint;
  declare variable guests_day_use smallint;
begin
  -- REBUILD THE "NO SLICE"
  delete from SUMMARY_OCCUPANCY D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY (ID_ROOM_TYPE, FOR_DATE, ROOMS_AVAILABLE, ID_HOTEL)
  select RC.ID_ROOM_TYPE, RC.FOR_DATE, sum(RC.CNT_DEFINED), :id_hotel
  from   HOTEL H
         left outer join ALLOTMENT_GET$INT(H.ID_INVENTORY_ALLOTMENT, :from_date, :to_date, null, 'PLAIN_PERIOD', H.ID_HOTEL) RC on 0=0
  where  H.ID_HOTEL = :id_hotel
         and RC.ID_ROOM_TYPE is not null
  group by 1, 2;

  for
    select RO.ID_ROOM_TYPE, RO.BUSY_DATE,
           sum(RO.OOI_ROOM), sum(RO.OOO_ROOM),
           sum(RO.ARRIVAL_ROOM + ro.STAYOVER_ROOM) as sold_rooms,
           sum(RO.MULTIPLE_GUEST_ROOM),
           sum(RO.ARRIVAL_ROOM),
           sum(RO.DEPARTURE_ROOM),
           sum(RO.ARRIVAL_ADULTS + ro.STAYOVER_ADULTS - ro.DAY_USE_ADULTS) as AD_IN_HOUSE,
           sum(RO.ARRIVAL_ADULTS),
           sum(RO.DEPARTURE_ADULTS),
           sum(RO.ARRIVAL_CHILDREN + ro.STAYOVER_CHILDREN - ro.DAY_USE_CHILDREN) as CH_IN_HOUSE,
           sum(RO.ARRIVAL_CHILDREN),
           sum(RO.DEPARTURE_CHILDREN),
           sum(RO.DAY_USE_ADULTS + ro.DAY_USE_CHILDREN)
    from   HOTEL_ROOM_OCCUPANCY ro
    where  ro.ID_HOTEL = :id_hotel
           and ro.BUSY_DATE between :from_date and :to_date
           and ro.BUSY_GROUP_TYPE > 1 -- excludes expected bookings
    group by RO.ID_ROOM_TYPE, RO.BUSY_DATE
    into   :id_room_type, :busy_date,
           :rooms_ooi, :rooms_ooo,
           :rooms_sold, :rooms_sold_multiple_gst, :rooms_arrival, :rooms_departure,
           :ad_in_house, :ad_arrival, :ad_departure,
           :ch_in_house, :ch_arrival, :ch_departure, :guests_day_use
  do begin
    update or insert into SUMMARY_OCCUPANCY (ID_ROOM_TYPE, FOR_DATE, ROOMS_OOI, ROOMS_OOO, ROOMS_SOLD, ROOMS_SOLD_MULTIPLE_GST,
           ROOMS_ARRIVAL, ROOMS_DEPARTURE, GST_AD_IN_HOUSE, GST_AD_ARRIVAL, GST_AD_DEPARTURE,
           GST_CH_IN_HOUSE, GST_CH_ARRIVAL, GST_CH_DEPARTURE, GUESTS_DAY_USE)
    values (:id_room_type, :busy_date, :rooms_ooi, :rooms_ooo, :rooms_sold, :rooms_sold_multiple_gst,
           :rooms_arrival, :rooms_departure, :ad_in_house, :ad_arrival, :ad_departure,
           :ch_in_house, :ch_arrival, :ch_departure, :guests_day_use)
    matching (ID_ROOM_TYPE, FOR_DATE);
  end

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, 
           sum(M.ROOMS_NOSHOW), sum(M.ROOMS_CANCELED), sum(M.GUESTS_NOSHOW)
    from   RESERV_STATISTIC_CANCELED$INT(:id_hotel, :from_date, :to_date) M
    group by M.ID_ROOM_TYPE, M.BUSY_DATE
    into   :id_room_type, :busy_date, 
           :rooms_noshow, :rooms_canceled, :guests_noshow
  do begin
    update SUMMARY_OCCUPANCY SO
    set    SO.ROOMS_NOSHOW = :rooms_noshow,
           SO.ROOMS_CANCELED = :rooms_canceled,
           SO.GUESTS_NOSHOW = :guests_noshow
    where  SO.FOR_DATE = :busy_date
           and SO.ID_ROOM_TYPE = :id_room_type;

  end

  -- REBUILD THE "MARKET SLICE"
  delete from SUMMARY_OCCUPANCY_MARKET D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY_MARKET (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL,
         MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
         ROOMS_SOLD, ROOMS_SOLD_MULTIPLE_GST, ROOMS_ARRIVAL, ROOMS_DEPARTURE,
         ROOMS_NOSHOW, ROOMS_CANCELED, GUESTS_IN_HOUSE,
         GUESTS_ARRIVAL, GUESTS_DEPARTURE, GUESTS_DAY_USE)
  select M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL,
         S.MARKET_SEGMENT_CODE, S.SOURCE_CODE, S.CHANNEL_CODE, S.HEAR_REASON_CODE, S.COME_REASON_CODE,
         sum(m.ARRIVAL_ROOM + m.STAYOVER_ROOM), sum(M.MULTIPLE_GUEST_ROOM), sum(M.ARRIVAL_ROOM), sum(M.DEPARTURE_ROOM),
         0, 0, sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN + m.STAYOVER_ADULTS + m.STAYOVER_CHILDREN - m.DAY_USE_ADULTS - m.DAY_USE_CHILDREN),
         sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN), sum(M.DEPARTURE_ADULTS + m.DEPARTURE_CHILDREN), sum(M.DAY_USE_ADULTS + m.DAY_USE_CHILDREN)
  from   HOTEL_ROOM_OCCUPANCY M
         left outer join RESERV_STATISTIC_SLICE$INT (m.ID_RESERV_STATISTICS) s on 1=1
  where  m.ID_HOTEL = :id_hotel
         and m.BUSY_DATE between :from_date and :to_date
         and m.BUSY_GROUP_TYPE > 1 -- excludes expected bookings
  group by M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL,
         S.MARKET_SEGMENT_CODE, S.SOURCE_CODE, S.CHANNEL_CODE, S.HEAR_REASON_CODE, S.COME_REASON_CODE;

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, 
           M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE,
           sum(M.ROOMS_NOSHOW), sum(M.ROOMS_CANCELED)
    from   RESERV_STATISTIC_CANCELED$INT(:id_hotel, :from_date, :to_date) M
    group by M.ID_ROOM_TYPE, M.BUSY_DATE, M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE
    into   :id_room_type, :busy_date,
           :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
           :rooms_noshow, :rooms_canceled
  do begin
    update SUMMARY_OCCUPANCY_MARKET MA
    set    MA.ROOMS_NOSHOW = :rooms_noshow,
           MA.ROOMS_CANCELED = :rooms_canceled
    where  MA.FOR_DATE = :busy_date
           and MA.ID_ROOM_TYPE = :id_room_type
           and MA.MARKET_SEGMENT_CODE = :market_segment_code
           and MA.SOURCE_CODE = :source_code
           and MA.CHANNEL_CODE = :channel_code
           and MA.HEAR_REASON_CODE = :hear_reason_code
           and MA.COME_REASON_CODE = :come_reason_code;
    if (row_count = 0) then begin
      insert into SUMMARY_OCCUPANCY_MARKET (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL,
             MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
             ROOMS_NOSHOW, ROOMS_CANCELED)
      values (:id_room_type, :busy_date, :id_hotel,
             :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
             :rooms_noshow, :rooms_canceled);
    end
  end

  -- REBUILD THE "PROFILE/COUNTRY SLICE"
  delete from SUMMARY_OCCUPANCY_OTHER D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY_OTHER (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL, ID_PROFILE_AGENT, COUNTRY_CODE,
         ROOMS_SOLD, ROOMS_SOLD_MULTIPLE_GST, ROOMS_ARRIVAL, ROOMS_DEPARTURE,
         ROOMS_NOSHOW, ROOMS_CANCELED, GUESTS_IN_HOUSE, GUESTS_ARRIVAL, GUESTS_DEPARTURE, GUESTS_DAY_USE)
  select M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL, S.ID_PROFILE_AGENT, S.COUNTRY_CODE,
         sum(m.ARRIVAL_ROOM + m.STAYOVER_ROOM), sum(M.MULTIPLE_GUEST_ROOM), sum(M.ARRIVAL_ROOM), sum(M.DEPARTURE_ROOM),
         0, 0, sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN + m.STAYOVER_ADULTS + m.STAYOVER_CHILDREN - m.DAY_USE_ADULTS - m.DAY_USE_CHILDREN),
         sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN), sum(M.DEPARTURE_ADULTS + m.DEPARTURE_CHILDREN), sum(M.DAY_USE_ADULTS + m.DAY_USE_CHILDREN)
  from   HOTEL_ROOM_OCCUPANCY M
         left outer join RESERV_STATISTIC_SLICE$INT (m.ID_RESERV_STATISTICS) s on 1=1
  where  m.ID_HOTEL = :id_hotel
         and m.BUSY_DATE between :from_date and :to_date
         and m.BUSY_GROUP_TYPE > 1 -- excludes expected bookings
  group by M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL, S.ID_PROFILE_AGENT, S.COUNTRY_CODE;

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, M.ID_PROFILE_AGENT, M.COUNTRY_CODE,
           sum(M.ROOMS_NOSHOW), sum(M.ROOMS_CANCELED)
    from   RESERV_STATISTIC_CANCELED$INT(:id_hotel, :from_date, :to_date) M
    group by M.ID_ROOM_TYPE, M.BUSY_DATE, M.ID_PROFILE_AGENT, M.COUNTRY_CODE
    into   :id_room_type, :busy_date, :id_profile_agent, :country_code,
           :rooms_noshow, :rooms_canceled
  do begin

    update SUMMARY_OCCUPANCY_OTHER MA
    set    MA.ROOMS_NOSHOW = :rooms_noshow,
           MA.ROOMS_CANCELED = :rooms_canceled
    where  MA.FOR_DATE = :busy_date
           and MA.ID_ROOM_TYPE = :id_room_type
           and MA.ID_PROFILE_AGENT = :id_profile_agent
           and MA.COUNTRY_CODE = :country_code;
    if (row_count = 0) then begin
      insert into SUMMARY_OCCUPANCY_OTHER (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL,
             ID_PROFILE_AGENT, COUNTRY_CODE, ROOMS_NOSHOW, ROOMS_CANCELED)
      values (:id_room_type, :busy_date, :id_hotel,
             :id_profile_agent, :country_code, :rooms_noshow, :rooms_canceled);
    end
  end

  -- REBUILD THE "PROFILE/MARKETING SLICE"
  delete from SUMMARY_OCCUPANCY_PROFILE_MRKT D
  where  D.ID_HOTEL = :id_hotel
         and D.FOR_DATE between :from_date and :to_date;

  insert into SUMMARY_OCCUPANCY_PROFILE_MRKT (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL, ID_PROFILE_AGENT,
         MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
         ROOMS_SOLD, ROOMS_SOLD_MULTIPLE_GST, ROOMS_ARRIVAL, ROOMS_DEPARTURE,
         ROOMS_NOSHOW, ROOMS_CANCELED, GUESTS_IN_HOUSE, GUESTS_ARRIVAL, GUESTS_DEPARTURE, GUESTS_DAY_USE)
  select M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL, S.ID_PROFILE_AGENT,
         S.MARKET_SEGMENT_CODE, S.SOURCE_CODE, S.CHANNEL_CODE, S.HEAR_REASON_CODE, S.COME_REASON_CODE,
         sum(m.ARRIVAL_ROOM + m.STAYOVER_ROOM), sum(M.MULTIPLE_GUEST_ROOM), sum(M.ARRIVAL_ROOM), sum(M.DEPARTURE_ROOM),
         0, 0, sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN + m.STAYOVER_ADULTS + m.STAYOVER_CHILDREN - m.DAY_USE_ADULTS - m.DAY_USE_CHILDREN),
         sum(M.ARRIVAL_ADULTS + m.ARRIVAL_CHILDREN), sum(M.DEPARTURE_ADULTS + m.DEPARTURE_CHILDREN), sum(M.DAY_USE_ADULTS + m.DAY_USE_CHILDREN)
  from   HOTEL_ROOM_OCCUPANCY M
         left outer join RESERV_STATISTIC_SLICE$INT (m.ID_RESERV_STATISTICS) s on 1=1
  where  m.ID_HOTEL = :id_hotel
         and m.BUSY_DATE between :from_date and :to_date
         and m.BUSY_GROUP_TYPE > 1 -- excludes expected bookings
  group by M.ID_ROOM_TYPE, M.BUSY_DATE, m.ID_HOTEL, s.ID_PROFILE_AGENT,
         S.MARKET_SEGMENT_CODE, S.SOURCE_CODE, S.CHANNEL_CODE, S.HEAR_REASON_CODE, S.COME_REASON_CODE;

  for
    select M.ID_ROOM_TYPE, M.BUSY_DATE, M.ID_PROFILE_AGENT,
           M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE,
           sum(M.ROOMS_NOSHOW), sum(M.ROOMS_CANCELED)
    from   RESERV_STATISTIC_CANCELED$INT(:id_hotel, :from_date, :to_date) M
    group by M.ID_ROOM_TYPE, M.BUSY_DATE, M.ID_PROFILE_AGENT,
           M.MARKET_SEGMENT_CODE, M.SOURCE_CODE, M.CHANNEL_CODE, M.HEAR_REASON_CODE, M.COME_REASON_CODE
    into   :id_room_type, :busy_date,  :id_profile_agent,
           :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
           :rooms_noshow, :rooms_canceled
  do begin

    update SUMMARY_OCCUPANCY_PROFILE_MRKT MA
    set    MA.ROOMS_NOSHOW = :rooms_noshow,
           MA.ROOMS_CANCELED = :rooms_canceled
    where  MA.FOR_DATE = :busy_date
           and MA.ID_ROOM_TYPE = :id_room_type
           and MA.ID_PROFILE_AGENT = :id_profile_agent
           and MA.MARKET_SEGMENT_CODE = :market_segment_code
           and MA.SOURCE_CODE = :source_code
           and MA.CHANNEL_CODE = :channel_code
           and MA.HEAR_REASON_CODE = :hear_reason_code
           and MA.COME_REASON_CODE = :come_reason_code;
    if (row_count = 0) then begin
      insert into SUMMARY_OCCUPANCY_PROFILE_MRKT (ID_ROOM_TYPE, FOR_DATE, ID_HOTEL, ID_PROFILE_AGENT,
             MARKET_SEGMENT_CODE, SOURCE_CODE, CHANNEL_CODE, HEAR_REASON_CODE, COME_REASON_CODE,
             ROOMS_NOSHOW, ROOMS_CANCELED)
      values (:id_room_type, :busy_date, :id_hotel, :id_profile_agent,
             :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
             :rooms_noshow, :rooms_canceled);
    end
  end
end
^

/* Alter (SUMMARY_STATISTIC_REBUILD$EW) */
ALTER PROCEDURE SUMMARY_STATISTIC_REBUILD$EW(ID_HOTEL INTEGER)
 AS
declare variable id_end_work integer;
  declare variable summary_date date;
  declare variable system_date date;
  declare variable reservs_count integer;
begin
  execute procedure SYSTEM_DATE_GET (:ID_HOTEL)
  returning_values :system_date;

  for
    select d.REBUILD_DATE, count(rd.ID_RESERV_DETAIL)
    from   SUMMARY_REBUILD_DATE d
           left outer join RESERV_DETAIL rd on rd.ID_RESERV_DETAIL = d.ID_RESERV
    where  d.ID_HOTEL = :ID_HOTEL
           and d.REBUILD_DATE < :system_date --!!! rebuild old ew dates only
    group by d.REBUILD_DATE
    into   :summary_date, :reservs_count
  do begin
    execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:id_hotel, :summary_date, :summary_date);

    if (:reservs_count > 0) then begin
      id_end_work = null;
      select first 1 ew.ID_END_WORK
      from   END_WORKS ew
      where  ew.PREV_DATE = :summary_date
             and ew.NEXT_DATE > :summary_date
             and ew.END_WORK_KIND = '3'
             and ew.ID_HOTEL = :ID_HOTEL
      into   :id_end_work;

      if (:id_end_work is not null) then
         execute procedure REVENUE_EW_SUMMARIZE$INT (:id_end_work, 'statistic');
    end
  end

  delete from SUMMARY_REBUILD_DATE rd where rd.ID_HOTEL = :ID_HOTEL;
end
^

/* empty dependent procedure body */
/* Clear: TAR_CALC_EVAL_ALL$INT for: TAR_CALC_EVAL_DATE$INT */
ALTER PROCEDURE TAR_CALC_EVAL_ALL$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_EVAL_DATE$INT) */
ALTER PROCEDURE TAR_CALC_EVAL_DATE$INT(ID_TAR_CALC INTEGER,
ROOM_STATUS VARCHAR(20),
FOR_DATE DATE)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_input integer;
declare variable checkin_date date;
declare variable day_of_stay integer;
declare variable real_recalc integer;
declare variable id_guest integer;
declare variable input_detail_dbkey char(8);
declare variable id_room_type integer;
declare variable id_board integer;
declare variable id_tar_head integer;
declare variable id_type_stay integer;
declare variable id_hotel integer;
declare variable period_depend_on_checkin integer;
declare variable cnt_days_board integer;
declare variable cnt_days_bp integer;
declare variable tariff_curr char(3);
declare variable board_type_find varchar(10);
declare variable id_room integer;
declare variable custom_price numeric(15,4);
declare variable custom_currency char(3);
declare variable id_tar_input_detail integer;
declare variable is_simple integer;
declare variable guest_age integer;
declare variable tar_name varchar(50);
declare variable guest_name varchar(50);
declare variable total_guests integer;
declare variable old_id_room integer;
declare variable beds integer;
declare variable payors integer;
declare variable minors integer;
declare variable int_err_text varchar(255);
declare variable is_manual_type_stay smallint;
declare variable seq_num integer;
declare variable current_child_num integer;
declare variable current_adult_num integer;
begin
  ERR_CODE = 0;
  OLD_ID_ROOM = NULL;
  for
    select   TCI.ID_TAR_INPUT, TCI.FROM_DATE, (:FOR_DATE - TCI.FROM_DATE + 1),
             TCI.REAL_RECALC, TCI.ID_GUEST, TCID.RDB$DB_KEY, TCID.ID_ROOM_TYPE,
             TCID.ID_BOARD, TCID.ID_TAR_HEAD, TCID.ID_TYPE_STAY, TCID.IS_MANUAL_TYPE_STAY, T.ID_HOTEL,
             TH.PERIOD_DEPEND_ON_CHECKIN, TH.CNT_DAYS_PRICE_BOARD, TH.CNT_DAYS_PRICE_BP, T.CURR, TH.BOARD_TYPE,
             TCID.ID_ROOM, TCID.CUSTOM_PRICE, TCID.CUSTOM_CURRENCY,
             TCID.ID_TAR_INPUT_DETAIL, TH.IS_SIMPLE, TCI.GUEST_AGE
    from     TAR_CALC_INPUT_DETAIL$TMP TCID
             join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
             join TAR_HEAD TH on TH.ID_TAR_HEAD = TCID.ID_TAR_HEAD
             join TARIFA T on T.ID_TARIFA = TH.ID_TAR_HEAD
    where    TCI.ID_TAR_CALC = :ID_TAR_CALC
             and TCI.ROOM_STATUS = :ROOM_STATUS
             and TCID.FOR_DATE = :FOR_DATE
    order by TCID.ID_ROOM asc,
             iif(TCI.IS_CHILD = 1, TCI.GUEST_AGE, 999) desc,
             --iif(TCI.GUEST_AGE > 16, 999, TCI.GUEST_AGE) desc,
             TCID.CHECKIN_ORDER asc,
             TCI.ID_GUEST asc
             /* ADULTS MUST BE HANDLED FIRST, THEN BY CHECKIN ORDER and ID_GUEST because of shares */
    into     :id_tar_input, :checkin_date, :day_of_stay,
             :real_recalc, :id_guest, :input_detail_dbkey, :id_room_type,
             :id_board, :id_tar_head, :id_type_stay, :is_manual_type_stay, :id_hotel,
             :period_depend_on_checkin, :cnt_days_board, :cnt_days_bp, :tariff_curr, :board_type_find,
             :id_room, :custom_price, :custom_currency,
             :id_tar_input_detail, :is_simple, :guest_age

  do begin
    if (coalesce(:id_room_type, -1) < 0) then exception RATING_EXCEPTION 'Unspecified room type!';
    if (coalesce(:id_type_stay, -1) < 0) then exception RATING_EXCEPTION 'Unspecified type stay!';
    --if (coalesce(:id_board, -1) < 0) then exception ASSERT 'Unspecified board!';
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    /* - - - - - PART 1 - For Both Simple and Complex Rates - */
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    select count(*)
    from   TAR_CALC_INPUT_DETAIL$TMP TCID
           join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
    where  TCI.ID_TAR_CALC = :ID_TAR_CALC
           and TCID.FOR_DATE = :FOR_DATE
           and TCID.ID_ROOM = :ID_ROOM
    into   :TOTAL_GUESTS;

    if (:TOTAL_GUESTS = 0) then exit;
  
    select RT.BEDS
    from   ROOM_TYPES RT
    where  RT.ID_ROOM_TYPE = :ID_ROOM_TYPE
    into   :BEDS;

    if (:IS_SIMPLE = 1) then begin
      /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
      /* - - - - - - - PART 2 - Simple Rates - - - - - - - - -  */
      /* - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
      if (:old_id_room is distinct from :id_room) then begin
        current_adult_num = 0;
        current_child_num = 0;
        old_id_room = :id_room;
      end

      execute procedure TAR_CALC_EVAL_SIMPLE_RATE$INT (:id_tar_input_detail, :id_tar_input, :ID_TAR_CALC,
              :FOR_DATE, :id_tar_head, :beds, :guest_age, :id_type_stay, :is_manual_type_stay, :id_board, :id_room_type,
              :custom_price, :custom_currency, :id_hotel, :total_guests, :current_adult_num, :current_child_num)
      returning_values (:ERR_CODE, :int_err_text, :current_adult_num, :current_child_num);
      if (:ERR_CODE < 0) then exception INTERNAL_RATING_EXCEPTION;

    end else begin
      /* - - -  - - - - - - - - - - - -  - - - - - - - - */
      /* - - -  - PART 3 - Complex Rates - - - - - - - - */
      /* - - -  - - - - - - - - - - - -  - - - - - - - - */
      if (:old_id_room is distinct from :id_room) then begin
        payors  = 0;
        minors  = 0;
        old_id_room = :id_room;
        seq_num = 0;
      end
      seq_num = :seq_num + 1;

      execute procedure TAR_CALC_EVAL_COMPLEX_RATE$INT (:input_detail_dbkey, :id_tar_input, :ID_TAR_CALC,
              :FOR_DATE, :beds, :id_type_stay, :is_manual_type_stay, :id_board, :id_room_type, :custom_price, :custom_currency,
              :checkin_date, :day_of_stay, :payors, :minors, :period_depend_on_checkin, :cnt_days_bp, :cnt_days_board,
              :board_type_find, :total_guests, :seq_num, :tariff_curr, :real_recalc)
      returning_values (:ERR_CODE, :int_err_text, :payors, :minors);
      if (:ERR_CODE < 0) then exception INTERNAL_RATING_EXCEPTION;
    end
  /* - --- - END PART 3 - complex Rates*/
  end

  when exception INTERNAL_RATING_EXCEPTION do begin
    if (coalesce(:ERR_CODE, 0) = 0) then ERR_CODE = -211;
    select TH.TARIFA_NAME
    from   TARIFA TH
    where  TH.ID_TARIFA = :ID_TAR_HEAD
    into   :TAR_NAME;

    select GC.GUEST_NAME1
    from   GUEST_CARD GC
    where  GC.ID_GUEST = :ID_GUEST
    into   :GUEST_NAME;
    ERR_TEXT = substring('GUEST='||cast(:ID_GUEST as varchar(20))||'-'||:GUEST_NAME||f_crlf()
                         || 'DATE='||:FOR_DATE||f_crlf()
                         || 'TARIFF='||:TAR_NAME||f_crlf()
                         || :int_err_text
                        from 1 for 255);

    exit;
  end
end
^

/* empty dependent procedure body */
/* Clear: IMPORT_BOOKING$EXC for: UPDATE_BOOKING$EXC */
ALTER PROCEDURE IMPORT_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(250),
MAINTANCE_SHEMA VARCHAR(30),
POSTING_ROUTING VARCHAR(20),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
COMPLIMENTARY_ACCOUNT VARCHAR(50),
EATING_OBJECT VARCHAR(50),
CREATE_DATETIME TIMESTAMP,
CHECK_OUT_KIND SMALLINT,
EARLYCHECKOUT_DATE DATE)
 RETURNS(HOTEL_ID INTEGER,
BOOKING_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (UPDATE_BOOKING$EXC) */
ALTER PROCEDURE UPDATE_BOOKING$EXC(BOOKING_ID INTEGER,
RESERV_GROUP_ID INTEGER,
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE INTEGER,
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE_ID INTEGER,
BOARD_ID INTEGER,
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(255),
MAINTANCE_SHEMA_ID INTEGER,
POSTING_ROUTING VARCHAR(20),
ID_AGENT_ACCOUNT INTEGER,
RATE_ID INTEGER,
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE_ID INTEGER,
GUEST_PAYMENT_TYPE_ID INTEGER,
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING1_ID INTEGER,
MARKETING2_ID INTEGER,
MARKETING3_ID INTEGER,
MARKETING4_ID INTEGER,
MARKETING5_ID INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD_CODE TFOOD_CODE,
ARRANGER_PROFILE_ID INTEGER,
MAIN_GUEST_PROFILE_ID INTEGER,
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable hotel_id integer;
  declare variable warn_code integer;
  declare variable share_transaction_id integer;
  declare variable share_err_code integer;
  declare variable rd_dbkey char(8);
  declare variable current_status_code smallint;
BEGIN
  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => START(' || :booking_id || ')');

  select RD.RDB$DB_KEY, RD.ID_HOTEL, RD.CHECK_STATUS
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :booking_id
  into  :rd_dbkey, :hotel_id, :current_status_code;

  execute procedure update_posting_transaction$exc(:rd_dbkey, :posting_transaction_uuid, 0);

  /* lock all guests */
  update guest set ORPHANED_IMPORT$EXC=1 where id_reserv_detail=:booking_id;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_GUARANTEE$RSV');
  execute procedure RES_SAVE_GUARANTEE$RSV(
    :booking_id, :is_vip, :current_status_code, :id_guarantee_policy,
    :deposit_required, :deposit_required_currency, :block_cc,
    :guarantee_deposit_percent, :guarantee_deposit_nights, :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_STAY$RSV');
  execute procedure RES_SAVE_STAY$RSV(
    :booking_id, :arrival, :departure, :is_late_departure,
    :arrival_type, 0
  ) returning_values :share_err_code, :err_text, :share_transaction_id, :warn_code;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_BOARD$INT');
  execute procedure RES_SAVE_BOARD$INT(
    :rd_dbkey, :board_id
  ) ;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_OTHER$RSV');
  execute procedure RES_SAVE_OTHER$RSV(
    :booking_id, :transfer_in_time, :transfer_in_note,
    :transfer_out_time, transfer_out_note, :first_food_code
  ) ;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_ROOM$EXC(room_type_id=>' || coalesce(:room_type_id, '<null>') || ')');
  execute procedure RES_SAVE_ROOM$EXC(
    :rd_dbkey, :room_type_id, :maintance_shema_id, :room_preferences, :special_treatment, :split_on_checkin
  ) returning_values :err_text, :warn_code, :share_transaction_id, :share_err_code;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_MARKETING$RSV');
  execute procedure RES_SAVE_MARKETING$RSV(
    :booking_id, :marketing1_id, :marketing2_id, :marketing3_id, :marketing4_id, :marketing5_id
  ) returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_RATE$RSV(:rate_id=>'
  || coalesce(:rate_id, '<null>')
  || ', :booking_id=>' || coalesce(:booking_id, '<null>')
  || ', :manual_price=>' || coalesce(:manual_price, '<null>')
  || ', :manual_price_currency=>' || coalesce(:manual_price_currency, '<null>')
  || ', :is_different_rate=>' || coalesce(:is_different_rate, '<null>')
  || ')');
  execute procedure RES_SAVE_RATE$RSV(
    :booking_id, :rate_id, :manual_price, :manual_price_currency,
    :is_different_rate, :is_different_price, 0
  );

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_VOUCHER$RSV');
  execute procedure RES_SAVE_VOUCHER$RSV(
    :booking_id, :voucher, :voucher_date, :voucher_text, null,  null
  );

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_NOTE$RSV');
  execute procedure RES_SAVE_NOTE$RSV(
    :booking_id, :note, :note_reminders);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_ACCOUNTING$RSV(arranger_profile_id=>'
    || coalesce(:arranger_profile_id, '<null>')
    || ', posting_routing=>' || coalesce(:posting_routing, '<null>')
    || ', id_agent_account=>' || coalesce(:id_agent_account, '<null>')
    || ')');
  execute procedure RES_SAVE_ACCOUNTING$INT(
    :rd_dbkey, :arranger_profile_id,
    :id_agent_account,
    :posting_routing,
    :guest_payment_type_id,
    :arranger_payment_type_id,
    :reserv_group_id
  ) ;

  /*execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_PACKET$RSV');
  execute procedure RES_SAVE_PACKET$RSV(
    :booking_id, :packet_id, 0
  );
  */
  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => RES_SAVE_EATING_OBJECT$RSV');
  execute procedure RES_SAVE_EATING_OBJECT$RSV(:booking_id, :id_eating_object);

  execute procedure sys_dbg('exc UPDATE_BOOKING$EXC => END(' || :booking_id || ')');
END
^

/* Restore proc. body: APPLY_BOOKING_STATUS$EXC */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20)
 AS
declare variable err_text varchar(255);
declare variable dummy_int integer;
declare variable anul_reason varchar(30);
declare variable selection_id integer;

declare variable status_code smallint;
declare variable current_anul_code smallint;
declare variable current_status_code smallint;
declare variable current_status_text varchar(50);
declare variable new_status_text varchar(50);
declare variable extra_posts_left integer;
declare variable check_out_kind smallint;
declare variable earlycheckout_date date;
begin
  if (:booking_db_key is null) then begin
    select rd.RDB$DB_KEY, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.ID_RESERV_DETAIL = :BOOKING_ID
    into   :booking_db_key, :current_status_code, :current_anul_code;
  end else begin
    select rd.id_reserv_detail, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.rdb$db_key = :booking_db_key
    into   :booking_id, :current_status_code, :current_anul_code;
  end

  execute procedure IMPORT_BOOKING_STATUS$EXC(:status, -2)
  returning_values :status_code;

  execute procedure EXPORT_BOOKING_STATUS$EXC(:current_status_code, :current_anul_code)
  returning_values :current_status_text;
  execute procedure IMPORT_BOOKING_STATUS$EXC(:current_status_text, :current_status_code)
  returning_values :current_status_code;

  /* nop - exit */
  if (:current_status_code = :status_code) then exit;

  /* validate status transition */
  if (
     /* terminal status values - void booking */
    (:current_status_code in (1004/*no show*/, 1005/*canceled*/))

    /* void over checkin */
    or ((:current_status_code >= 0) and (:status_code in (1004/*no show*/, 1005/*canceled*/)))

    /* positive status downgrade */
    or ((:current_status_code > 0) and (:current_status_code > :status_code))
  )  then begin
    execute procedure PRINT_BOOKING_STATUS$EXC(:current_status_code) returning_values :current_status_text;
    execute procedure PRINT_BOOKING_STATUS$EXC(:status_code) returning_values :new_status_text;

    exception VALIDATE_EXCEPTION '-1022' || f_character(31) || '@{invalid_status_transition} ' || :current_status_text || ' -> ' || :new_status_text;
  end

  anul_reason = null;
  if (1004 = :status_code) then begin
    anul_reason = 'NOSHOW';
  end else if (1005 = :status_code) then begin
    anul_reason = 'CANCELED';
  end

  if (:anul_reason is null) then begin
    if (0 > :status_code) then begin
      execute procedure RES_SAVE_STATUS$INT(:booking_db_key, :status_code, :CONFIRMATION_NUMBER);
    end else begin
      if (:status_code in (0, 1) and 0 > :current_status_code) then begin
        -- checkin
        execute procedure RES_SET_CHECKIN$INT (:booking_db_key)
        returning_values (:dummy_int, :err_text, :dummy_int, :dummy_int);
      end
      if (1 = :status_code and 1 > :current_status_code) then begin
        -- checkout
        selection_id = gen_id(SELECTION_GEN, 1);
        update RESERV_DETAIL
        set    selection_id=:selection_id
        where  rdb$db_key=:booking_db_key
        returning new.CHECK_OUT_KIND, new.EARLYCHECKOUT_DATE
        into   :check_out_kind, :earlycheckout_date;
    
        execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id, :check_out_kind, :earlycheckout_date);
      end
    end
  end else begin
    -- void
    execute procedure RES_ANUL_DETAIL$INT(:booking_db_key, :anul_reason, :CANCELATION_NUMBER)
    returning_values  :dummy_int, :extra_posts_left;
    if (:extra_posts_left = 1) then exception BOOKING_EXCEPTION '-1042';

  end
end
^

/* Restore proc. body: CLEAR_ORPHAN_GUESTS$EXC */
ALTER PROCEDURE CLEAR_ORPHAN_GUESTS$EXC(BOOKING_ID INTEGER)
 AS
declare variable guest_id integer;
  declare variable guest_uuid varchar(50);
begin

  for
    select g.id_guest, g.uuid
    from guest g
    where g.id_reserv_detail=:booking_id and g.orphaned_import$exc=1
    into :guest_id, :guest_uuid do
  begin
    execute procedure sys_dbg('exc CLEAR_ORPHAN_GUESTS$EXC - RES_GUEST_DEL$RSV(:guest_id=>' || coalesce(:guest_id, '<null>') || ', :guest_uuid=>' || coalesce(:guest_uuid, '<null>') || ')');

    execute procedure RES_GUEST_DEL$RSV(:guest_id);
  end
end
^

/* Restore proc. body: EAI_EXT_POST_TO_FRONT_ONLINE */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable ID_HOTEL integer;
begin
  if (singular(select HS.ID_HOTEL
               from HOTEL_S HS
               where HS.IS_USE = 1)) then
    select H.ID_HOTEL
    from   HOTEL_S H
    where H.IS_USE = 1
    into   :id_hotel;
  else begin
    err_code = -1044;
    exit;
  end

  execute procedure EAI_EXT_POST_TO_MH_FRONT_ONLINE(:ID_HOTEL, :ROOM_NAME,
    :SERVICE_CODE, :CODE_TYPE, :QTY_POST, :PRICE_POST, :CURR_POST, :POST_TEXT)
  returning_values (:ERR_CODE, :ERR_TEXT, :ID_ROOM, :ID_GUEST, :GUEST_NAME1,
    :ID_ACCOUNT, :ID_ACCOUNT_POST, :ID_SERVICE);

end
^

/* Restore proc. body: EAI_RES_CHECK_OUT_FAST */
ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
declare variable selection_id integer;
  declare variable is_early_check_out smallint;
  declare variable early_check_out_dep_date date;
  declare variable check_out_date date;
begin
  selection_id = gen_id(selection_gen, 1);

  update RESERV_DETAIL RD
  set RD.SELECTION_ID = :SELECTION_ID
  where RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL;

  execute procedure RES_CHECK_OUT_CHECK$RSV(:selection_id)
  returning_values :is_early_check_out, :early_check_out_dep_date, :check_out_date;

  if (:is_early_check_out = 1) then
    exception BOOKING_EXCEPTION '-1043';

  execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id, 0);
end
^

/* Restore proc. body: END_WORK */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable system_date date;
  declare variable id_end_work integer;
  declare variable last_closed_date date;
  declare variable lock_id integer;
  declare variable dbkey char(8);
begin
  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date >= :in_next_date) then exception END_WORK_EXCEPTION '-43';
  if (:IN_NEXT_DATE > current_date + 1) then exception END_WORK_EXCEPTION '-60';

  last_closed_date = :in_next_date - 1;

  /* LOCK THE CURRENT FINANCIAL (SYSTEM) DATE  */
  lock_id = null;
  while (:lock_id is null) do begin
    lock_id = strhash_large(:system_date || :id_hotel);
    execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'lock');
  
    when any do begin
      exception END_WORK_EXCEPTION '-337' || f_character(31) || f_character(29) || FormatDate(:system_date, 'D;dd.mm.yyyy');
    end
  end

  /* RIGHT IS REQUIRED TO CHANGE THE FINANCIAL DATE IF THERE ARE GUESTS WITH OVERDUE CHECK OUT */
  if (exists(
    select *
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
    where  G.TO_DATE <= :last_closed_date
           and G.CHECK_STATUS < 1
           and RD.ID_HOTEL = :id_hotel
           and rd.IS_ANUL = 0
  )) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('EW_OVERDUE_CHECKOUT');
  end

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', 'EW');
  -- Suppress eventual right checks into next procedures - all is permitted. Is this needed(?!?)

  for
    select p.RDB$DB_KEY
    from   ACCOUNT_POST p
           join ACCOUNT a on a.ID_ACCOUNT = p.ID_ACCOUNT
    where  p.DATE_POST between :system_date and :last_closed_date
           and p.ID_GUEST > 0
           and a.ID_HOTEL = :ID_HOTEL
    into   :dbkey
  do begin
    update ACCOUNT_POST AP
    set    ap.ROOM_NAME = (select R.ROOM_NAME
                           from   GUEST G
                                  join ROOMS R on R.ID_ROOM = G.ID_ROOM
                           where  G.ID_GUEST = ap.ID_GUEST)
    where  ap.RDB$DB_KEY = :dbkey;
  end

  /* CHANGE SYSTEM DATE */
  execute procedure SYSTEM_DATE_SET(:id_hotel, :system_date, :in_next_date)
  returning_values :id_end_work;

  /* AUTO EXPIRATION OF ROOM NUMBERS, ROOMS AND BOOKING POSITIONS */
  execute procedure RESERVS_EXPIRE$INT(:last_closed_date, :id_hotel);

  execute procedure AGENT_CONTINGENT_EXPIRE(:system_date, :last_closed_date, null, 0, 1, :id_hotel);

  /* DELETE PERSON PROFILES WITH EXPIRATION DATE */
  execute procedure PROFILE_PERSON_EXPIRE (:in_next_date);

  execute procedure HOUSEKEEPING_MARK_ROOMS$EW(:id_end_work);

  /* Summary statistic */
  if (:in_next_date > :system_date) then begin
    execute procedure SUMMARY_FINANCE_STATISTIC$EW(:id_end_work);

    execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:ID_HOTEL, :system_date, :last_closed_date);

    execute procedure SUMMARY_STATISTIC_REBUILD$EW(:ID_HOTEL);

    execute procedure SUMMARY_FORECAST$INT(:ID_HOTEL, :system_date);
  end

  /* Delete pseudo-temporal tables */
  delete from RESERV_ERROR;
  /*  */

--  execute procedure CACHES_RESOLVE;

  execute procedure SYSTEM_LOG_ADD('DAY_END_WORK', :id_end_work, 'DAY_EW', f_character(29) || :system_date || f_character(28) || :IN_NEXT_DATE);

  execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'release');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', null);

  execute procedure SYSTEM_CACHE_APPLY('end_work');
end
^

/* Restore proc. body: GUEST_ADDRESSCARD_SET$INT */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$INT(PD_DBKEY CHAR(8),
G_DBKEY CHAR(8),
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
COUNTRY_CODE VARCHAR(10),
IS_CHILD INTEGER,
AGE INTEGER,
BIRTH_DAY DATE,
TITLE VARCHAR(10))
 AS
declare variable rd_dbkey char(8);
  declare variable old_is_child integer;
  declare variable old_birthday date;
  declare variable p_dbkey char(8);
  declare variable old_country_code varchar(10);
  declare variable from_date date;
  declare variable birthday_internal date;
begin

  select G.IS_CHILD, coalesce(:is_child, G.IS_CHILD), RD.RDB$DB_KEY, G.FROM_DATE
  from   GUEST G
         left join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
  where  G.RDB$DB_KEY = :g_dbkey
  into   :old_is_child, :is_child, :rd_dbkey, :from_date;

  select PD.COUNTRY_CODE, PD.BIRTH_DAY, P.RDB$DB_KEY
  from   PERSON_DATA PD
         left outer join PROFILE_PERSON PP on PP.ID_PERSON_DATA = PD.ID_PERSON_DATA
         left outer join PROFILE P on P.ID_PROFILE = PP.ID_PROFILE
  where  PD.RDB$DB_KEY = :pd_dbkey
  into   :old_country_code, :old_birthday, :p_dbkey;

  country_code = coalesce(:country_code, '');

  execute procedure sys_dbg('res GUEST_ADDRESSCARD_SET$INT birth_day = '||coalesce(:birth_day, 'null'));
  execute procedure sys_dbg('res GUEST_ADDRESSCARD_SET$INT old_birthday = '||coalesce(:old_birthday, 'null'));
  execute procedure sys_dbg('res GUEST_ADDRESSCARD_SET$INT age = '||coalesce(:age, 'null'));

  execute procedure GUEST_BIRTHDAY$INT(:birth_day, :age, :old_birthday, :from_date)
  returning_values  :birthday_internal, :birth_day;

  execute procedure PERSON_DATA_SET$INT(:p_dbkey, :pd_dbkey, :guest_name1, :guest_name2,
          :country_code, :birth_day, :birthday_internal, :TITLE);

  if (:old_is_child <> :is_child) then begin
    update RESERV_DETAIL RD
    set    RD.ADULT_COUNT = RD.ADULT_COUNT + (2*:old_is_child - 1),
           RD.CHILD_COUNT = RD.CHILD_COUNT - (2*:old_is_child - 1)
    where  RD.RDB$DB_KEY = :rd_dbkey;

    update GUEST G
    set    G.IS_CHILD = :is_child
    where  G.RDB$DB_KEY = :g_dbkey;
  end

  if (:old_country_code is distinct from :country_code) then begin
    update RESERV_DETAIL RD
    set    RD.COUNTRY = :country_code
    where  RD.RDB$DB_KEY = :rd_dbkey;
  end
end
^

/* Restore proc. body: GUEST_ADDRESSCARD_SET$RSV */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$RSV(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
EGN VARCHAR(30),
COUNTRY VARCHAR(10),
ID_STAY_REASON INTEGER,
IS_REGISTRED INTEGER,
PASS_PLACE VARCHAR(20),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_PLACE VARCHAR(30),
SEX CHAR,
MASK VARCHAR(10),
IS_CHILD INTEGER,
CAR VARCHAR(30),
KPP INTEGER,
KPP_DATE DATE,
PASS_EXP_DATE DATE,
AGE INTEGER,
BIRTH_DAY DATE,
VISA TDESCRIPTION_SHORT,
RATING_AGE INTEGER = null,
TITLE VARCHAR(10) = null,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable gd_dbkey char(8);
  declare variable pd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable rd_dbkey char(8);
  declare variable old_is_registred integer;
  declare variable old_guest_name1 varchar(250);
  declare variable old_guest_name2 varchar(250);
  declare variable old_id_pass_type integer;
  declare variable old_pass_num varchar(20);
  declare variable old_pass_date date;
  declare variable old_egn varchar(30);
  declare variable old_country varchar(20);
  declare variable old_id_stay_reason integer;
  declare variable old_kpp integer;
  declare variable old_kpp_date date;
  declare variable old_pass_exp_date date;
  declare variable old_birth_day date;
  declare variable old_pass_place varchar(20);
  declare variable old_city varchar(100);
  declare variable old_address varchar(100);
  declare variable old_visa TDESCRIPTION_SHORT;
  declare variable old_birth_place varchar(30);
  declare variable old_sex char(1);
  declare variable action_text varchar(250);
  declare variable tt_reg_number integer;
  declare variable id_hotel integer;
  declare variable id_tt_numerator integer;
  declare variable domestic_nation varchar(10);
  declare variable no_use varchar(255);
  declare variable is_anul smallint;
  declare variable acc_routing varchar(20);
begin
  err_code = 0;
  err_text = '';

  select G.RDB$DB_KEY, GD.RDB$DB_KEY, PD.RDB$DB_KEY,
         GD.IS_REGISTRED, PD.PERSON_NAME, PD.PERSON_NAME2, PD.ID_PASSPORT_TYPE, PD.PASS_NUM, PD.PASS_DATE,
         PD.EGN, PD.COUNTRY_CODE, GD.ID_STAY_REASON, GD.KPP, GD.KPP_DATE, PD.PASS_EXP_DATE,
         PD.BIRTH_DAY, PD.PASS_PLACE, PD.CITY, PD.ADDRESS, PD.BIRTH_PLACE, PD.SEX, rd.RDB$DB_KEY,
         g.TT_REG_NUMBER, rd.ID_HOTEL, rd.IS_ANUL, rd.ACC_ROUTING, GD.VISA
  from   GUEST G
         join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
         join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
         join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
  where  G.ID_GUEST = :id_guest
  into   :g_dbkey, :gd_dbkey, :pd_dbkey,
         :old_is_registred, :old_guest_name1, :old_guest_name2, :old_id_pass_type, :old_pass_num, :old_pass_date,
         :old_egn, :old_country, :old_id_stay_reason, :old_kpp, :old_kpp_date, :old_pass_exp_date,
         :old_birth_day, :old_pass_place, :old_city, :old_address, :old_birth_place, :old_sex, :rd_dbkey,
         :tt_reg_number, :id_hotel, :is_anul, :acc_routing, :old_visa;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, :birth_place, :egn, :id_passport_type, :pass_num, :pass_date, :pass_place,
          :pass_exp_date, :city, :address, :sex, :mask);

  update  GUEST_DATA GD
  set     GD.KPP_DATE = :kpp_date,
          GD.KPP = :kpp,
          GD.VISA = :visa,
          GD.ID_STAY_REASON = :id_stay_reason,
          GD.IS_REGISTRED = :is_registred,
          GD.USER_REGISTRED = iif(:IS_REGISTRED = 1, coalesce(GD.USER_REGISTRED, current_user), null),
          GD.CAR = :car,
          GD.RATING_AGE = :RATING_AGE
  where   GD.RDB$DB_KEY = :gd_dbkey;

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name1, :guest_name2, :country,
          :is_child, :age, :birth_day, :TITLE);

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -1);

  /*  */
  if (:IS_REGISTRED = 1 and :tt_reg_number is null and :is_anul = 0 and :acc_routing is distinct from 'OWNER') then begin
    execute procedure SETTING_GET_VALUE ('NATIVE_NATION', :id_hotel)
    returning_values :domestic_nation;

    select iif(:COUNTRY not in (:domestic_nation, '') and h.USE_DIFFERENT_TT_NUMERATORS = 1,
               h.ID_TT_NUMERATOR_2,
               h.ID_TT_NUMERATOR_1)
    from   HOTEL H
    where  h.ID_HOTEL = :id_hotel
    into   :id_tt_numerator;

    if (:id_tt_numerator is not null) then begin
      execute procedure SYSTEM_GEN_NUM('GUEST_NUM', :id_tt_numerator)
      returning_values :tt_reg_number, :no_use;
  
      update GUEST G
      set    g.TT_REG_NUMBER = :tt_reg_number
      where  G.RDB$DB_KEY = :g_dbkey;
    end
  end else if (:IS_REGISTRED is distinct from 1 and :tt_reg_number is not null) then begin
    update GUEST G
    set    g.TT_REG_NUMBER = null
    where  G.RDB$DB_KEY = :g_dbkey;
  end
  /*  */
  if ((:old_is_registred = 0) and (:is_registred = 1)) then begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'REGISTRED', '');
  end

  if ((:old_is_registred = 1) and (:old_guest_name1 <> :guest_name1)) then begin
    action_text = f_character(29)||:old_guest_name1||f_character(28)||:guest_name1;
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'CHANGE_CARD', :action_text);
  end

  if ((:old_IS_REGISTRED = 1)
      and
      ((:old_guest_name1 <> :guest_name1)
        or (:old_guest_name2 <> :guest_name2)
        or (:old_egn <> :egn)
        or (:old_id_pass_type <> :id_passport_type)
        or (:old_pass_num <> :pass_num)
        or (:old_pass_date <> :pass_date)
        or (:old_pass_exp_date <> :pass_exp_date)
        or (:old_pass_place <> :pass_place)
        or (:old_country <> :country)
        or (:old_city <> :city)
        or (:old_address <> :address)
        or (:old_visa <> :visa)
        or (:old_birth_day <> :birth_day)
        or (:old_birth_place <> :birth_place)
        or (:old_sex  <> :sex)
        or (:old_kpp <> :kpp)
        or (coalesce(:old_id_stay_reason,0) <> coalesce(:id_stay_reason,0))
        or (:old_kpp_date <> :kpp_date)
      )) then
  begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'PREREGISTRED', '');
  end

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
    returning_values  :warn_code;

  end

end
^

/* Restore proc. body: GUEST_REGISTRATION_UPDATE */
ALTER PROCEDURE GUEST_REGISTRATION_UPDATE(ID_GUEST TYPE OF ID)
 AS
begin
  update GUEST_DATA gd
  set    gd.REGISTRATION_UPDATED_AT = current_timestamp
  where  gd.ID_GUEST = :ID_GUEST;

  when any do exit;
end
^

/* Restore proc. body: IMPORT_BOOKING$EXC */
ALTER PROCEDURE IMPORT_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(250),
MAINTANCE_SHEMA VARCHAR(30),
POSTING_ROUTING VARCHAR(20),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
COMPLIMENTARY_ACCOUNT VARCHAR(50),
EATING_OBJECT VARCHAR(50),
CREATE_DATETIME TIMESTAMP,
CHECK_OUT_KIND SMALLINT,
EARLYCHECKOUT_DATE DATE)
 RETURNS(HOTEL_ID INTEGER,
BOOKING_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable current_hotel_id integer;
declare variable booking_update_id integer;
declare variable warn_code integer;
declare variable share_transaction_id integer;
declare variable share_err_code integer;
declare variable arranger_profile_id integer;
declare variable main_guest_profile_id integer;
declare variable rate_id integer;
declare variable room_type_id integer;
declare variable board_id integer;
declare variable maintance_shema_id integer;
declare variable arranger_payment_type_id integer;
declare variable guest_payment_type_id integer;
declare variable marketing_segment_id integer;
declare variable marketing_source_code_id integer;
declare variable marketing_channel_code_id integer;
declare variable marketing_hear_reason_id integer;
declare variable marketing_come_reason_id integer;
declare variable arranger_account_id integer;
declare variable packet_id integer;
declare variable id_guarantee_policy integer;
declare variable first_food_code tfood_code;
declare variable arrival_type_code smallint;
declare variable booking_dbkey char(8);
declare variable reserv_group_id integer;
declare variable id_complimentary_account integer;
declare variable id_eating_object integer;
declare variable default_guest_mask varchar(10);
declare variable id_person_data integer;
begin
  /*execute procedure sys_dbg('exc IMPORT_BOOKING$EXC('
  || 'hotel => ' || coalesce(:hotel, '<null>')
  || ', booking_number => ' || coalesce(:number, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  ||')');
  */
  execute procedure import_mark_transaction$exc;

  /* init */
  err_code = 0;
  err_text = '';
  booking_update_id = null;
  booking_dbkey = null;
  current_hotel_id = null;
  if (:voucher_date is not null) then begin
    voucher_date = striptime(:voucher_date);
  end
  posting_routing = upper(:posting_routing);

  /* detect inser/update mode */
  select b.id_reserv_detail, b.rdb$db_key, b.id_hotel
  from   reserv_detail b
  where  b.number=:number
         and b.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and b.id_log_event_annul is null
  into   :booking_update_id, :booking_dbkey, :current_hotel_id;

  if (:booking_update_id is null) then begin
    booking_id = gen_id (id_reserv_detail_gen, 1);
  end else begin
    booking_id = :booking_update_id;
  end

  /* text to id map */
  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => MAP_BOOKING_RELATIONS$EXC');
  execute procedure MAP_BOOKING_RELATIONS$EXC(
    :booking_id,
    :hotel,
    :room_type,
    :board,
    :maintance_shema,
    :rate,
    :arranger_payment_type,
    :guest_payment_type,
    :marketing_segment,
    :marketing_source_code,
    :marketing_channel_code,
    :marketing_hear_reason,
    :marketing_come_reason,
    :first_food,
    :arranger_profile_uuid,
    :arranger_profile_name,
    :main_guest_profile_uuid,
    :arrival_type,
    :guarantee_policy,
    :eating_object
  ) returning_values
    :arranger_profile_id,
    :main_guest_profile_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :hotel_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :first_food_code,
    :arrival_type_code,
    :id_guarantee_policy,
    :id_eating_object;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* hotel change test */
  if (coalesce(:current_hotel_id, :hotel_id) <> :hotel_id) then begin
    execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', null, :hotel, 'booking hotel changed');
  end

  id_complimentary_account = null;
  if (complimentary_account is not null) then begin
    execute procedure lookup_account$exc(:hotel_id, :complimentary_account, 'booking', :booking_id)
    returning_values :id_complimentary_account;
  end

  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => CREATE_PACK_INSTANCE$EXC');
  packet_id = null;
  /*execute procedure CREATE_PACK_INSTANCE$EXC(
    :hotel_id, :booking_id, :package
  )
  returning_values :packet_id, :err_code, :err_text;
  if (0 <> :err_code) then exit;
  */
  /* merge input and default/persistent database values */
  execute procedure DEFAULT_BOOKING_VALUES$EXC(
    :booking_dbkey, :hotel_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :group_name,
    :group_uuid,
    :is_late_departure,
    :id_eating_object
  ) returning_values
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :arranger_account_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :reserv_group_id,
    :is_late_departure,
    :id_eating_object,
    :default_guest_mask;

  if ('' = :board) then board_id = null; /* preserve "empty board" state and discard default value */

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC DEFAULTED => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* if the booking is complimentary use complimentary account */
  arranger_account_id = coalesce(:id_complimentary_account, :arranger_account_id);

  /* CREATE or UPDATE */
  if (:booking_update_id is not null) then begin
    /* UPDATE booking */
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => UPDATE_BOOKING$EXC');
    execute procedure UPDATE_BOOKING$EXC(
      :booking_id,
      :reserv_group_id,
      :is_vip,
      :arrival,
      :arrival_type_code,
      :departure,
      :is_late_departure,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :room_type_id,
      :board_id,
      :room_preferences,
      :special_treatment,
      :maintance_shema_id,
      :posting_routing,
      :arranger_account_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :deposit_required,
      :deposit_required_currency,
      :arranger_payment_type_id,
      :guest_payment_type_id,
      :voucher,
      :voucher_date,
      :voucher_text,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :note,
      :note_reminders,
      :first_food_code,
      :arranger_profile_id,
      :main_guest_profile_id,
      :is_different_rate,
      :is_different_price,
      :split_on_checkin,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object
    ) returning_values :err_code, :err_text;
    if (0 <> :err_code) then begin
      exit;
    end
  end else begin
    /* CREATE booking */
    if (:default_guest_mask is not null
        and :main_guest_profile_id is not null
        and not exists (select rd.ID_RESERV_DETAIL from reserv_detail rd where rd.ID_PERSON_PROFILE = :main_guest_profile_id)) then
    begin
      -- fill the mask with a default value if its is empty
      select p.id_person_data
      from   PROFILE_PERSON p
      where  p.ID_PROFILE = :main_guest_profile_id
      into   :id_person_data;

      update PERSON_DATA pd
      set    pd.MASK = :default_guest_mask
      where  pd.ID_PERSON_DATA = :id_person_data
             and pd.MASK is null;
    end
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => RES_CREATE_SET$EXC');
    execute procedure RES_CREATE_SET$EXC (
      :booking_id,
      :number,
      :arranger_profile_id,
      :main_guest_profile_id,
      :arrival,
      :departure,
      :adult_count,
      :children_count,
      :room_type_id,
      null,
      :board_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :voucher,
      :voucher_date,
      :voucher_text,
      null,
      null,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :arrival_type_code,
      :is_late_departure,
      :is_vip,
      :first_food_code,
      :special_treatment,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :arranger_account_id,
      :posting_routing,
      :guest_payment_type_id,
      :arranger_payment_type_id,
      null,
      :room_preferences,
      :maintance_shema_id,
      :note,
      :note_reminders,
      :deposit_required,
      :deposit_required_currency,
      :hotel_id,
      :reserv_group_id,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object,
      :create_datetime
      )
    returning_values :err_code, :err_text, :warn_code, :booking_id, :share_transaction_id, :share_err_code;
  end

  update reserv_detail rd
  set    rd.CHECK_OUT_KIND = :CHECK_OUT_KIND,
         rd.EARLYCHECKOUT_DATE = :EARLYCHECKOUT_DATE
  where  rd.ID_RESERV_DETAIL = :BOOKING_ID;

  execute procedure GUEST_STAY_INITIALIZE$INT (:booking_id);
  /* final error check */
  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;

  delete from PENDING_DEPOSIT d
  where  d.ID_RESERV_DETAIL = :BOOKING_ID;
end
^

/* Restore proc. body: IMPORT_BOOKING_FINALIZE$EXC */
ALTER PROCEDURE IMPORT_BOOKING_FINALIZE$EXC(BOOKING_ID INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1,
STATUS VARCHAR(50) = null,
CONFIRMATION_NUMBER NAME_20 = null,
CANCELATION_NUMBER NAME_20 = null)
 RETURNS(RECORD_TIMESTAMP TIMESTAMP,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable booking_db_key char(8);
  declare variable dummy_int integer;
  declare variable dummy_text varchar(255) ;
  declare variable res_id_room integer;
  declare variable id_room integer;
  declare variable id_room_type integer;
  declare variable system_date date;
  declare variable from_date date;
  declare variable to_date date;
  declare variable gs_dbkey char(8);
begin
  ERR_CODE=0;
  ERR_TEXT=null;
  id_room = null;
  force_res_finalize = coalesce(:force_res_finalize, 1);

  execute procedure sys_dbg('exc IMPORT_BOOKING_FINALIZE$EXC => CLEAR_ORPHAN_GUESTS$EXC');
  execute procedure CLEAR_ORPHAN_GUESTS$EXC(:booking_id);

  select b.rdb$db_key, b.ID_ROOM, b.ID_ROOM_TYPE, b.FROM_DATE, b.TO_DATE
  from   reserv_detail b
  where  b.id_reserv_detail = :booking_id
  into   :booking_db_key, :res_id_room, :id_room_type, :from_date, :to_date;

  execute procedure RES_GUEST_SAVE_DIFF$INT(:booking_db_key);

  if (:res_id_room < 0) then begin
    --id_room = :res_id_room;
    for
      select lp.OUT_DATE
      from   SYSTEM_LOOP_PERIOD (:from_date, :to_date-1) lp
      into   :system_date
    do begin
      select ro.ID_ROOM, ro.ID_ROOM_TYPE
      from   RES_OCCUPANCY_ROOM$INT (:BOOKING_ID, :system_date, :id_room, :id_room_type) ro
      into   :id_room, :id_room_type;
  
      if (:id_room <> :res_id_room) then begin
        for
          select gs.RDB$DB_KEY
          from   GUEST_STAY GS
                 join GUEST G on g.ID_GUEST = gs.ID_GUEST
          where  g.ID_RESERV_DETAIL = :BOOKING_ID
                 and gs.FOR_DATE = :system_date
                 and gs.ID_ROOM <> :id_room
          into   :gs_dbkey
        do begin
          update GUEST_STAY gsu
          set    gsu.ID_ROOM = :id_room
                 --gsu.ID_ROOM_TYPE = iif (gsu.ID_ROOM_TYPE = -1, :id_room_type, gsu.ID_ROOM_TYPE)
          where  gsu.RDB$DB_KEY = :gs_dbkey;
        end
      end
    end
    update GUEST G
    set    G.ID_ROOM = coalesce(:id_room, :res_id_room)
    where  g.ID_RESERV_DETAIL = :BOOKING_ID;
  end

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null,   --force recalculation
         rd.ID_ROOM = coalesce(:id_room, :res_id_room)
         --rd.HAS_DIFFERENT_ROOM_TYPE = coalesce(:has_different_room_type,  rd.HAS_DIFFERENT_ROOM_TYPE)
  where  rd.RDB$DB_KEY = :booking_db_key;

  if (1 = :force_res_finalize) then begin
    execute procedure sys_dbg('exc IMPORT_BOOKING_FINALIZE$EXC => RES_FINALIZE_SHAREOPTION$INT');
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:booking_db_key, 0)
    returning_values  :dummy_int, :dummy_text, :dummy_int, :dummy_int;
  end

  execute procedure APPLY_BOOKING_STATUS$EXC(
    null, :booking_db_key, :status, :confirmation_number, :cancelation_number
  );

  select b.change_time
  from   reserv_detail b
  where  b.rdb$db_key =:booking_db_key
  into   :record_timestamp;
end
^

/* Restore proc. body: IMPORT_GUEST$EXC */
ALTER PROCEDURE IMPORT_GUEST$EXC(BOOKING_ID INTEGER,
PROFILE_UUID VARCHAR(40),
GUEST_UUID VARCHAR(40),
GUEST_NAME VARCHAR(100),
IS_CHILD SMALLINT,
AGE INTEGER,
IS_DIFFERENT_ARRANGER SMALLINT,
ARRIVAL DATE,
DEPARTURE DATE,
VOUCHER VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
RATING_AGE INTEGER,
KPP VARCHAR(50),
KPP_DATE DATE,
STAY_REASON VARCHAR(255),
CAR VARCHAR(30),
IS_REGISTRED SMALLINT,
PERSONAL_NUMBER VARCHAR(30),
TITLE VARCHAR(10),
PT_NAME VARCHAR(100),
PT_EXTCODE VARCHAR(50),
PASS_NUM VARCHAR(20),
PASS_PLACE VARCHAR(20),
PASS_DATE DATE,
PASS_EXP_DATE DATE,
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_DATE DATE,
SEX CHAR,
BIRTH_PLACE VARCHAR(30),
MASK VARCHAR(10),
PACKAGE VARCHAR(255),
VISA TDESCRIPTION_SHORT)
 RETURNS(GUEST_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable warn_code integer;

declare variable birth_date_old date;
declare variable title_old varchar(10);
declare variable id_passport_type_old integer;
declare variable pass_num_old varchar(20);
declare variable pass_date_old date;
declare variable personal_number_old varchar(30);
declare variable id_stay_reason_old integer;
declare variable is_registred_old integer;
declare variable pass_place_old varchar(20);
declare variable city_old varchar(100);
declare variable address_old varchar(100);
declare variable birth_place_old varchar(30);
declare variable sex_old char(1);
declare variable mask_old varchar(10);
declare variable car_old varchar(30);
declare variable kpp_id_old integer;
declare variable kpp_date_old date;
declare variable pass_exp_date_old date;
declare variable rating_age_old integer;
declare variable visa_old tdescription_short;

declare variable guest_name_old varchar(100);
declare variable is_child_old integer;
declare variable arrival_old date;
declare variable departure_old date;
declare variable voucher_old varchar(30);
declare variable voucher_date_old date;
declare variable voucher_text_old varchar(30);
declare variable country_code_old varchar(10);

declare variable id_passport_type integer;
declare variable kpp_id integer;
declare variable id_stay_reason integer;
begin
  execute procedure import_mark_transaction$exc;

  guest_name = substring(:guest_name from 1 for 50);

  execute procedure sys_dbg('exc IMPORT_GUEST$EXC(:guest_uuid=>' || coalesce(:guest_uuid, '<null>') || ')');
  guest_id = null;

  select pd.person_name, --g.is_different_organizer,
         g.id_guest, g.from_date, g.to_date,
         pd.birthday_internal, pd.title, pd.id_passport_type,
         pd.pass_num, pd.pass_date, pd.egn, gd.id_stay_reason,
         gd.is_registred, pd.pass_place, pd.city, pd.address, pd.birth_place,
         pd.sex, pd.mask, g.is_child, gd.car, gd.kpp, gd.kpp_date,
         pd.pass_exp_date, gd.rating_age, g.vaucher_num, g.vaucher_date, g.vaucher_text, pd.country_code,
         gd.id_stay_reason, gd.visa
  from   GUEST g
         join guest_data gd on gd.id_guest=g.id_guest
         join person_data pd on pd.id_person_data=gd.id_person_data
  where  g.uuid=:guest_uuid
         and g.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and g.id_reserv_detail=:booking_id
  into   :guest_name_old, --:is_different_arranger_old,
         :guest_id, :arrival_old, :departure_old, :birth_date_old,
         :title_old, :id_passport_type_old,
         :pass_num_old, :pass_date_old, :personal_number_old, :id_stay_reason_old,
         :is_registred_old, :pass_place_old, :city_old, :address_old, :birth_place_old,
         :sex_old, :mask_old, :is_child_old, :car_old, :kpp_id_old, :kpp_date_old,
         :pass_exp_date_old, :rating_age_old, :voucher_old, :voucher_date_old,
         :voucher_text_old, :country_code_old, :id_stay_reason_old, :visa_old;

  execute procedure import_passport_type$exc(:pt_name, pt_extcode)
  returning_values :id_passport_type;

  execute procedure import_kpp$exc(:kpp, null)
  returning_values :kpp_id;

  execute procedure import_stay_reason$exc(:stay_reason, null)
  returning_values :id_stay_reason;

  guest_name = coalesce(:guest_name, :guest_name_old);
--  DISABLE age/is_child merge (RIU rating cases)
--  is_child = coalesce(:is_child, :is_child_old);
--  is_different_arranger = coalesce(:is_different_arranger, :is_different_arranger_old);
  arrival = coalesce(:arrival, :arrival_old);
  departure = coalesce(:departure, :departure_old);
  voucher = coalesce(:voucher, :voucher_old);
  voucher_date = coalesce(:voucher_date, :voucher_date_old);
  voucher_text = coalesce(:voucher_text, :voucher_text_old);
  country_code = coalesce(:country_code, :country_code_old);

--  DISABLE age/is_child merge (RIU rating cases)
--  rating_age = coalesce(:rating_age, :rating_age_old);
  kpp_id = coalesce(:kpp_id, :kpp_id_old);
  kpp_date = coalesce(:kpp_date, :kpp_date_old);
  id_stay_reason = coalesce(:id_stay_reason, :id_stay_reason_old);
  car = coalesce(:car, :car_old);
  is_registred = coalesce(:is_registred, 0);
  if (1 = :is_registred_old) then begin --one way update
    is_registred = 1;
  end
  personal_number = coalesce(:personal_number, :personal_number_old);
  title = coalesce(:title, :title_old);
  id_passport_type = coalesce(:id_passport_type, :id_passport_type_old);
  pass_num = coalesce(:pass_num, :pass_num_old);
  pass_place = coalesce(:pass_place, :pass_place_old);
  pass_date = coalesce(:pass_date, :pass_date_old);
  pass_exp_date = coalesce(:pass_exp_date, :pass_exp_date_old);
  city = coalesce(:city, :city_old);
  address = coalesce(:address, :address_old);
  birth_date = coalesce(:birth_date, :birth_date_old);
  sex = coalesce(:sex, :sex_old);
  birth_place = coalesce(:birth_place, :birth_place_old);
  mask = coalesce(:mask, :mask_old);
  visa = coalesce(:visa, :visa_old);

  if (:guest_id is null) then begin
    execute procedure RES_GUEST_SAVE$RSV(null, :booking_id, :guest_name, null, null, :is_child)
    returning_values :guest_id;

    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - get_next_auto_guest = :guest_id=>' || coalesce(:guest_id, '<null>'));
    if (:guest_id is null) then begin 
      execute procedure sys_dbg('exc IMPORT_GUEST$EXC - exhausted auto guests list - create new guest');
      execute procedure RES_GUEST_ADD$RSV(:booking_id, :is_child)
      returning_values :err_code, :err_text, :warn_code, :guest_id;
      if (0 <> :err_code) then exit;
    end

    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - update_new_guest_uuid(:guest_id=>' || coalesce(:guest_id, '<null>') || ', :uuid=>' || coalesce(:guest_uuid, '<null>') || ')');
    update GUEST
    set    uuid = :guest_uuid
    where  id_guest=:guest_id;

    /* preserve default mask */
    if (:mask is null) then begin
      select pd.mask
      from   guest_data gd
             join person_data pd on pd.id_person_data=gd.id_person_data
      where  gd.id_guest=:guest_id
      into   :mask;
    end          
  end else begin
    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - update_guest(:update_guest_id=>' || coalesce(:guest_id, '<null>') || ')');

--    DISABLE age/is_child merge (RIU rating cases) 
--    if (:age is null) then begin
--      select age from GUEST_AGE_CALC(:guest_id)
--      into :age;
--    end
  end

  /*
  execute procedure sys_dbg('exc IMPORT_GUEST$EXC->GUEST_ADDRESSCARD_SET$RSV('
  || 'update_guest_id => ' || coalesce(:update_guest_id, '<null>')
  || ', guest_name => ' || coalesce(:guest_name, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  || ', :id_passport_type => ' || coalesce(:id_passport_type, '<null>')
  || ', :pass_num => ' || coalesce(:pass_num, '<null>')
  || ', :pass_date => ' || coalesce(:pass_date, '<null>')
  || ', :egn => ' || coalesce(:egn_old, '<null>')
  || ', :country => ' || coalesce(:country_old, '<null>')
  || ', :id_stay_reason => ' || coalesce(:id_stay_reason, '<null>')
  || ', :is_registred => ' || coalesce(:is_registred, '<null>')
  || ', :pass_place => ' || coalesce(:pass_place, '<null>')
  || ', :city => ' || coalesce(:city, '<null>')
  || ', :address => ' || coalesce(:address, '<null>')
  || ', :birth_place => ' || coalesce(:birth_place, '<null>')
  || ', :sex => ' || coalesce(:sex, '<null>')
  || ', :mask => ' || coalesce(:mask, '<null>')
  || ', :is_child => ' || coalesce(:is_child, '<null>')
  || ', :car => ' || coalesce(:car, '<null>')
  || ', :kpp => ' || coalesce(:kpp_old, '<null>')
  || ', :kpp_date => ' || coalesce(:kpp_date, '<null>')
  || ', :pass_exp_date => ' || coalesce(:pass_exp_date, '<null>')
  || ', :age => ' || coalesce(:age, '<null>')
  || ', :birth_date => ' || coalesce(:birth_date, '<null>')
  || ', :rating_age => ' || coalesce(:rating_age, '<null>')
  || ', :title => ' || coalesce(:title, '<null>')
  ||')');
  */
  execute procedure GUEST_ADDRESSCARD_SET$RSV(
    :guest_id,
    :guest_name,
    null,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :personal_number,
    :country_code,
    :id_stay_reason,
    :is_registred,
    :pass_place,
    :city,
    :address,
    :birth_place,
    :sex,
    :mask,
    :is_child,
    :car,
    :kpp_id,
    :kpp_date,
    :pass_exp_date,
    :age,
    :birth_date,
    :visa,
    :rating_age,
    :title,
    0
  )
  returning_values :err_code, :err_text, :warn_code;
  if (0 <> :err_code) then exit;

  --execute procedure RES_GUEST_SAVE_ORGANIZER$RSV(:guest_id, :is_different_arranger);

  if ((:arrival is not null) and (:departure is not null)) then begin
    execute procedure RES_GUEST_SAVE_STAY$RSV(:guest_id, :arrival, :departure)
    returning_values :err_code, :err_text, :warn_code;
    if (0 <> :err_code) then exit;
  end

  if (:voucher is not null) then begin
    execute procedure RES_GUEST_SAVE_VOUCHER$RSV(:guest_id, :voucher,
            :voucher_date, :voucher_text, null, null);
  end

  execute procedure IMPORT_GUEST_PACK$EXC(:guest_id, :package);

  update GUEST
  set    ORPHANED_IMPORT$EXC = null
  where  id_guest=:guest_id;
end
^

/* Restore proc. body: IMPORT_PERSON_PROFILE$EXC */
ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(2000),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
declare variable op varchar(10);
  declare variable market_segment_id integer;
  declare variable sex_old char(1);
  declare variable birth_date_old date;
  declare variable birth_place_old varchar(30);
  declare variable personal_number_old varchar(30);
  declare variable pass_num_old varchar(20);
  declare variable pass_date_old date;
  declare variable pass_place_old varchar(20);
  declare variable pass_exp_date_old date;
  declare variable pass_city_old varchar(100);
  declare variable pass_address_old varchar(100);
  declare variable country_old varchar(10);
  declare variable mask_old varchar(10);
  declare variable title_old varchar(10);
  declare variable id_photo integer;
  declare variable id_def_contragent integer;
  declare variable id_passport_type integer;
  declare variable account_no_old varchar(20);
  declare variable msg_old varchar(2000);
  declare variable id_guest_type integer;
  declare variable id_guest_type_old integer;
  declare variable card_code_old varchar(50);
  declare variable is_exclusive_debt_ownership smallint;
  declare variable profile_receiver_id integer;
begin
  profile_id = null;
  import_time = null;

  execute procedure import_mark_transaction$exc;

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC(:profile_uuid=>' || coalesce(:profile_uuid, '<null>')
                          || ', email=>' || coalesce(:email, '<null>') || ')');

  profile_id = null;
  if (profile_uuid is null) then begin
    execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC <null> :profile_uuid - exit;');
    exit;
  end

  select p.profile_id, p.profile_name, p.phone, p.fax, p.email, p.city,
         p.address, p.market_segment, p.note, p.is_archive, pp.card_code,
         pd.sex, pd.birthday_internal, pd.birth_place, pd.egn, pd.pass_num,
         pd.pass_date, pd.pass_place, pd.pass_exp_date, pd.city, pd.address, pd.country_code,
         pd.mask, p.id_def_contragent, p.wbe_password,
         pd.title, p.account_no, p.msg, pp.id_guest_type, pp.id_photo, pd.id_passport_type,
         p.is_exclusive_debt_ownership
  from   import_common_profile$exc(:profile_uuid, 0, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :wbe_password, :ACCOUNT_NO, :MSG, 'PERSON_PROFILE', :HOTEL_UUID_LIST) p
         left outer join profile_person pp on pp.id_profile = p.profile_id
         left outer join person_data pd on pd.id_person_data=pp.id_person_data
  into   :profile_id, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :card_code_old,
         :sex_old, :birth_date_old, :birth_place_old, :personal_number_old, :pass_num_old,
         :pass_date_old, :pass_place_old, :pass_exp_date_old, :pass_city_old, :pass_address_old, :country_old,
         :mask_old, :id_def_contragent, :wbe_password, :title_old,
         :account_no_old, :msg_old, :id_guest_type_old, :id_photo, :id_passport_type, :is_exclusive_debt_ownership;

  if (:profile_id is null) then begin
    op = 'add';
  end else if (:hotel_uuid_list is null) then begin
    profile_id = null;
    exit;
  end else begin
    op = 'mod';
    delete from PROFILE_BONUSPOINT_SCHEME bs
      where bs.ID_PROFILE = :profile_id;
  end

  sex=coalesce(:sex, :sex_old);
  birth_date=coalesce(:birth_date, :birth_date_old);
  birth_place=coalesce(:birth_place, :birth_place_old);
  personal_number=coalesce(:personal_number, :personal_number_old);
  pass_num=coalesce(:pass_num, :pass_num_old);
  pass_date=coalesce(:pass_date, :pass_date_old);
  pass_place=coalesce(:pass_place, :pass_place_old);
  pass_exp_date=coalesce(:pass_exp_date, :pass_exp_date_old);
  pass_city=coalesce(:pass_city, :pass_city_old);
  pass_address=coalesce(:pass_address, :pass_address_old);
  country=upper(coalesce(:country, :country_old));
  mask=coalesce(:mask, :mask_old);
  title=coalesce(:title, :title_old);
  account_no=coalesce(:account_no, :account_no_old);
  msg=coalesce(:msg, :msg_old);
  card_code=coalesce(:card_code, :card_code_old);

  execute procedure IMPORT_PASSPORT_TYPE$EXC(:pass_type_name, :pass_type_external_code)
  returning_values :id_passport_type;

  execute procedure lookup_market_segment$exc(:profile_name, 'PERSON_PROFILE', :market_segment)
  returning_values :market_segment_id;

  if (guest_type_name is not null) then begin
    execute procedure lookup_guest_type$exc(:profile_name, 'PERSON_PROFILE', :guest_type_name)
    returning_values :id_guest_type;
  end

  if ((def_contragent_name is not null) and (def_contragent_name <> '')) then begin
    execute procedure LOOKUP_CONTRAGENT$EXC(:profile_name, 'PERSON_PROFILE', :def_contragent_name)
    returning_values :id_def_contragent;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:profile_name, 'PERSON_PROFILE');

  id_guest_type=coalesce(:id_guest_type, :id_guest_type_old);

  if (id_photo is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, null, null, null, 'del')
    returning_values :id_photo;
  end
  id_photo = null;
  if (picture is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, :picture, :picture_type, :picture_layout, 'add')
    returning_values :id_photo;
  end

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC - profile_person_modify$profile(:profile_uuid=>'
    || coalesce(:profile_uuid, '<null>')
    || ', :operation=>' || coalesce(:op, '<null>')
    || ', :email=>' || coalesce(:email, '<null>')
    || ', :birth_date=>' || coalesce(:birth_date, '<null>')
  || ')');
  execute procedure profile_person_modify$profile(
    :profile_id,
    :id_guest_type,
    :profile_name,
    null,
    :sex,
    :birth_date,
    :birth_place,
    :personal_number,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :pass_place,
    :pass_exp_date,
    :country,
    :pass_city,
    :pass_address,
    :mask,
    :phone,
    :fax,
    :email,
    :city,
    :address,
    :note,
    :msg,
    :id_def_contragent,
    :market_segment_id,
    :is_archive,
    :id_photo,
    :card_code,
    :wbe_password,
    :op,
    :account_no,
    :title,
    :is_exclusive_debt_ownership
  ) returning_values
    :profile_id;

  /*assign uuid to the new profiles*/
  if ('add' = :op) then begin
    update profile set uuid=:profile_uuid where id_profile=:profile_id;
  end

  select record_timestamp from profile where id_profile=:profile_id
  into :import_time;

  if (:MERGE_TARGET_UUID is not null) then begin
    select p.ID_PROFILE
    from   PROFILE P
    where  P.UUID = :MERGE_TARGET_UUID
    into   :profile_receiver_id;

    execute procedure PROFILE_MERGE$PROFILE (:PROFILE_ID, :profile_receiver_id, 'merge');

  end

end
^

/* Restore proc. body: OCCUPANCY_SUMMARY_REMAKE$SYS */
ALTER PROCEDURE OCCUPANCY_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
begin
  if (not exists (select h.ID_HOTEL
                  from   HOTEL H
                  where  h.ID_HOTEL = :ID_HOTEL)) then exception WRONG_VALUE 'Non-existing hotel!';

  select mindate(sd.SYSTEM_DATE - 1, :TO_DATE)
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :TO_DATE;

  if (:FROM_DATE > :TO_DATE) then exit;

  execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:id_hotel, :FROM_DATE, :TO_DATE);

  execute procedure SYSTEM_LOG_ADD ('HOTEL', :id_hotel, 'OCCUPANCY_REGENERATE',
                                    f_character(29) || formatdate(:from_date, 'D;dd/mm/yyyy') || f_character(28) || formatdate(:to_date, 'D;dd/mm/yyyy'));
end
^

/* Restore proc. body: RES_CHECKIN$RSV */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable old_check_status integer;
  declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable is_anul integer;
  declare variable arrival_date date;
  declare variable system_date date;
begin
  /*  Description:
  ||
  */
  select RD.CHECK_STATUS, RD.RDB$DB_KEY, RD.FROM_DATE, RD.ID_HOTEL,
         RD.ID_ROOM, RD.IS_ANUL
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_check_status, :rd_dbkey, :arrival_date, :id_hotel,
         :old_id_room, :is_anul;

  if (:is_anul = 1) then exception BOOKING_EXCEPTION '-2';

  if (:old_check_status >= 0) then exception BOOKING_EXCEPTION '-1003';

  if (:old_id_room < 0 and coalesce(:ID_ROOM, 0) <= 0) then exception BOOKING_EXCEPTION '-1018';

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date < :arrival_date) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CHECK_IN_FUTURE');
  end
  /*----*/
  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'lock');

  execute procedure sys_dbg('occ RES_CHECKIN$RSV id_room = '||coalesce(:id_room, 'null'));
  execute procedure sys_dbg('occ RES_CHECKIN$RSV old_id_room = '||coalesce(:old_id_room, 'null'));

  if (:id_room is not null) then begin
    if (:old_check_status = -3) then begin
      execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, -2);
    end

    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option)
    returning_values (:WARN_CODE);
  end

  execute procedure RES_SET_CHECKIN$INT (:rd_dbkey)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'release');
  /*----*/
  select f_character(29) || R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = coalesce(:ID_ROOM, :old_id_room)
  into   :action_text;
   
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'CHECK_IN', :action_text);

end
^

/* Restore proc. body: RES_CHECKIN_MULTI$RSV */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable checkin_count integer;
  declare variable split_on_checkin integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
  declare variable tmp_warn_code integer;
begin
  checkin_count = 0;
  warn_code = null;
  for
    select RD.ID_RESERV_DETAIL, RD.CHECK_STATUS, RD.SPLIT_ON_CHECKIN, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :SELECTION_ID
    into   :id_reserv_detail, :check_status, :split_on_checkin, :id_titular
  do begin
    if (:check_status >= 0) then begin
      checkin_count = :checkin_count + 1;
    end else begin
      if (:split_on_checkin = 1) then begin
        for
          select G.ID_GUEST
          from   GUEST G
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and G.ID_GUEST <> :id_titular
          into   :id_guest
        do begin
          execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
          returning_values  :id_splited_reservation;

          execute procedure RES_CHECKIN$RSV (:id_splited_reservation)
          returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

          update RESERV_DETAIL RD
          set    RD.SELECTION_ID = :selection_id
          where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
        end
      end

      execute procedure RES_CHECKIN$RSV (:id_reserv_detail)
      returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
      WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end

  if (:checkin_count > 0) then begin
    execute procedure SYSTEM_WARNING_ADD(-1011, f_character(29)||:checkin_count)
    returning_values  :warn_code;
  end
end
^

/* Restore proc. body: RES_CREATE_SET$EXC */
ALTER PROCEDURE RES_CREATE_SET$EXC(ID_RESERV_DETAIL INTEGER,
RES_NUMBER VARCHAR(62),
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER,
CREATE_DATETIME TIMESTAMP)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_RESERV_DETAIL INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  WARN_CODE = 0;
  SHARE_TRANSACTION_ID = 0;
  SHARE_ERR_CODE = 0;

  execute procedure sys_dbg('exc RES_CREATE_SET$EXC => RES_CREATE_SET$INT('
  || 'code_first_food=>' || coalesce(:code_first_food, '<null>')
  || ', id_person_payment=>' || coalesce(:id_person_payment, '<null>')
  || ')');

  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, null, :arrival_date, :departure_date,
                    :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, '', :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders, :guarantee_deposit,
                    :guarantee_currency, 0, :id_reserv_detail, :res_number, null,  :id_guarantee_policy, :block_cc,
                    :id_eating_object)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :warn_code;

  execute procedure UPDATE_POSTING_TRANSACTION$EXC(:rd_dbkey, :posting_transaction_uuid, 1);

  execute procedure RES_SAVE_GUARANTEE$RSV(:id_reserv_detail, :is_vip, null,
    :id_guarantee_policy, :guarantee_deposit, :guarantee_currency, :block_cc, :guarantee_deposit_percent,
    :guarantee_deposit_nights, :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create
  );

  execute procedure RESERV_DETAIL_EXTERNAL_MOD$RSV(:id_reserv_detail,
    :minibar_rights, :paytv_rights, :video_rights, :nopost_pms, :phone_rights,
    :seminar_cahnnel_rights, null
  );

  if (:create_datetime is not null) then begin
    update reserv_detail set create_datetime = :create_datetime where rdb$db_key = :rd_dbkey;
  end
end
^

/* Restore proc. body: RES_DELETE$INT */
ALTER PROCEDURE RES_DELETE$INT(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable rd_dbkey char(8);
  declare variable id_guest integer;
  declare variable action_text varchar(255);
  declare variable from_date date;
  declare variable to_date date;
  declare variable room_type varchar(20);
  declare variable number varchar(62);
  declare variable tmp_extra_posts_left integer;
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_DELETE');

  select RD.RDB$DB_KEY, RD.FROM_DATE, rd.TO_DATE, RT.TYPE_ROOM, rd.NUMBER
  from   RESERV_DETAIL RD
         left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = RD.ID_ROOM_TYPE
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey, :from_date, :to_date, :room_type, :number;

  update RESERV_DETAIL R
  set    r.ID_TITULAR = null
  where  r.RDB$DB_KEY = :rd_dbkey;

  EXTRA_POSTS_LEFT = 0;
  for
    select G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_guest
  do begin
    execute procedure RES_GUEST_DEL$INT(:id_guest, :id_reserv_detail, :REASON)
    returning_values  :tmp_extra_posts_left;
    EXTRA_POSTS_LEFT = iif(:EXTRA_POSTS_LEFT = 1, 1, :tmp_extra_posts_left);
  end

  execute procedure RES_FINALIZE$INT (:RD_DBKEY, 1)
  returning_values (:warn_code);


  execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

  action_text = f_character(29) || coalesce(:number, '')
                || f_character(28) || coalesce(:room_type, '')
                || f_character(28) || :from_date
                || f_character(28) || :to_date
                || f_character(28) || :reason;
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'DELETE', :action_text);

  delete from RESERV_DETAIL RDD
  where  RDD.RDB$DB_KEY = :rd_dbkey;

  delete from XML_MESSAGE$EXC xml
  where  xml.OBJECT_TYPE = 'BOOKING'
         and xml.OBJECT_ID = :number;

end
^

/* Restore proc. body: RES_EARLY_DEPARTURE_SET$RSV */
ALTER PROCEDURE RES_EARLY_DEPARTURE_SET$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND INTEGER)
 RETURNS(RECALC_MARKER_LIST VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable sys_date date;
  declare variable stay integer;
  declare variable rd_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable id_hotel integer;
  declare variable hotels_cnt integer;
  declare variable arrival_date date;
  declare variable is_late_departure smallint;
  declare variable comming_kind smallint;
  declare variable dep_date date;
begin
  /* CHECK_OUT_kind =
  || 1 - DO NOT MODIFY GUEST
  || 2 - SHRINK PERIOD AND OCCUPANCY
  || 3 - DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
  */
  execute procedure RIGHTS_CHECK_GRANTED$INT('CHECK_OUT_EARLY');

  select min(RD.ID_HOTEL), count(distinct RD.ID_HOTEL)
  from   RESERV_DETAIL RD
  where  RD.SELECTION_ID = :SELECTION_ID
  into   :id_hotel, :hotels_cnt;

  if (:hotels_cnt > 1) then exception RESERV_CHECK_OUT_EXCEPTION '-1020';

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values  :sys_date;

  RECALC_MARKER_LIST = null;
  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL, rd.FROM_DATE, rd.TO_DATE, RD.LEAVING_KIND - 1, rd.COMMING_KIND
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :rd_dbkey, :id_reserv_detail, :arrival_date, :dep_date, :is_late_departure, :comming_kind
  do begin
    if ((:check_out_kind = 2) and (:dep_date > :sys_date)) then begin
      -- SHRINK PERIOD AND OCCUPANCY
      execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :sys_date, :is_late_departure, :comming_kind);
    
      execute procedure RES_FINALIZE$INT(:rd_dbkey)
      returning_values  :warn_code;
    end else if ((:check_out_kind = 1) and (:dep_date > :sys_date)) then begin
      /* KEEP BOOKING STAY PERIOD AND ROOM OCCUPANCY */
      for
        select G.TO_DATE - :sys_date
        from   GUEST G
        where  G.ID_RESERV_DETAIL = :id_reserv_detail
        into   :stay
      do begin
  --      if (:check_out_kind = 1) then begin
        if (:stay > 1) then begin
            --THE DEPARTURE DATE IS LATER THAN NEXT DATE. STAY SHOULD BE CHANGED MANUALY.;
            exception RESERV_CHECK_OUT_EXCEPTION '-323';
        end
      end
    end
  end
end
^

/* Restore proc. body: RES_GUEST_FINALIZE$RSV */
ALTER PROCEDURE RES_GUEST_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER,
ALL_ERRORS_ARE_INSTANT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, iif (:all_errors_are_instant = 1, 0, 1))
  returning_values  :warn_code;

end
^

/* Restore proc. body: RES_RECALC$INT */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable num_prefix varchar(20);
  declare variable number_1 varchar(20);
begin
  /* CALLER_KIND = {NORMAL, FORCED} */
  err_code = 0;
  /* 1. GET DATA */
  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL, rd.NUMBER_1
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :check_status, :id_reserv_detail, :number_1;

  if (:check_status = 1) then begin
    -- CHECKED OUT
    select sn.LEADING_PART
    from   SYSTEM_NUMERATOR SN
    where  sn.ID_NUMERATOR = 0
    into   :num_prefix;

    if (trim('.' from coalesce(:num_prefix, '')) = coalesce(:number_1, '')) then
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_MINE');
    else
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_ELSE');

    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :id_guest
    do begin
      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'MANUAL_EDIT_DATA', '');
    end
  end
  /* 2. FIND DEPENDANT GUESTS AND THEIR TARIFFS */
  --execute procedure sys_dbg('calc RES_RECALC$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

  ID_TAR_CALC = gen_id(gen_id_tar_calc, 1);
  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NONE');

  -- 3. UPDATE ROOM PRICE and REPOST ALL AFFECTED BOOKINGS
  execute procedure RES_TAR_CALC_FINALIZE$INT (:ID_TAR_CALC, :CALLER_KIND, :FORCE_POSTING)
  returning_values (:ERR_CODE, :ERR_TEXT);
end
^

/* Restore proc. body: RES_ROOM_REMOVE$INT */
ALTER PROCEDURE RES_ROOM_REMOVE$INT(RD_DBKEY CHAR(8))
 RETURNS(WARN_CODE INTEGER)
 AS
begin

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, gen_id(DETAIL_WITHOUT_ROOMING_LIST, -1), null, 'nrttAsIs')
  returning_values (:WARN_CODE);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 0)
  returning_values  :WARN_CODE;

end
^

/* Restore proc. body: RES_SAVE_ROOM$EXC */
ALTER PROCEDURE RES_SAVE_ROOM$EXC(RD_DBKEY CHAR(8),
ID_RES_ROOM_TYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(250),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_room integer;
begin
  select RD.ID_ROOM, RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_room, :id_reserv_detail;

  execute procedure RES_SAVE_ROOM$RSV(
    :id_reserv_detail,
    :old_id_room,
    :id_res_room_type,
    'nrttAsIs',
    1,
    :id_hk_plan,
    :room_features,
    :i_special_treatment,
    :split_on_checkin,
    0
  ) returning_values :share_err_code, :err_text, :share_transaction_id, :warn_code;
end
^

/* Restore proc. body: RESERV_STATISTIC_CANCELED$INT */
ALTER PROCEDURE RESERV_STATISTIC_CANCELED$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(BUSY_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_PROFILE_AGENT INTEGER,
COUNTRY_CODE VARCHAR(20),
MARKET_SEGMENT_CODE VARCHAR(3),
SOURCE_CODE VARCHAR(3),
CHANNEL_CODE VARCHAR(3),
HEAR_REASON_CODE VARCHAR(3),
COME_REASON_CODE VARCHAR(3),
ROOMS_NOSHOW SMALLINT,
GUESTS_NOSHOW SMALLINT,
ROOMS_CANCELED SMALLINT)
 AS
begin
  -- {NOSHOW, CANCELED, USERERROR}
  for
    select P.OUT_DATE, RD.ID_ROOM_TYPE, S.ID_PROFILE_AGENT, coalesce(RD.COUNTRY, ''),
           S.MARKET_SEGMENT_CODE, S.SOURCE_CODE, S.CHANNEL_CODE, S.HEAR_REASON_CODE, S.COME_REASON_CODE,
           count(distinct iif(RD.REASON_OF_ANUL = 'NOSHOW', RD.ID_ROOM, null)),
           sum(iif(RD.REASON_OF_ANUL = 'NOSHOW', RD.ADULT_COUNT + RD.CHILD_COUNT, 0)),
           count(distinct iif(RD.REASON_OF_ANUL = 'CANCELED', RD.ID_ROOM, null))
    from   RESERV_DETAIL RD
           left outer join RESERV_STATISTIC_SLICE$INT(RD.ID_RESERV_DETAIL) S on 0=0
           left outer join SYSTEM_LOOP_PERIOD(maxdate(:from_date, RD.FROM_DATE), mindate(:to_date, RD.TO_DATE-1)) P on 0=0
    where  RD.ID_HOTEL = :id_hotel
           and RD.FROM_DATE <= :to_date
           and RD.TO_DATE > :from_date
           and RD.IS_ANUL = 1
           and RD.REASON_OF_ANUL in ('NOSHOW', 'CANCELED')
    group by 1, 2, 3, 4, 5, 6, 7, 8, 9
    into   :busy_date, :id_room_type, :id_profile_agent, :country_code,
           :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
           :rooms_noshow,
           :guests_noshow,
           :rooms_canceled
  do begin
    suspend;
  end
end
^

/* Restore proc. body: TAR_CALC_EVAL_ALL$INT */
ALTER PROCEDURE TAR_CALC_EVAL_ALL$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable room_status varchar(20);
  declare variable from_date date;
  declare variable to_date date;
  declare variable idate date;
  declare variable is_static integer;
  declare variable id_tar_input integer;
  declare variable id_type_stay integer;
  declare variable separate_board integer;
  declare variable id_board_include integer;
  declare variable id_tar_head integer;
  declare variable is_manual_type_stay smallint;
  declare variable seasson_name varchar(50);
begin
  err_code = 0;

  delete from TAR_CALC_OUTPUT$TMP TCO where TCO.ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP TCV where TCV.ID_TAR_CALC = :id_tar_calc;

  execute procedure TAR_CALC_INIT_VARS$INT(:id_tar_calc);

  for
    select TCI.ROOM_STATUS, min(TCI.FROM_DATE_CALC), max(TCI.TO_DATE_CALC), min(TCI.IS_STATIC)
    from   TAR_CALC_INPUT$TMP TCI
    where  TCI.ID_TAR_CALC = :id_tar_calc
    group by TCI.ROOM_STATUS
    into   :room_status, :from_date, :to_date, :is_static
  do begin
    for
      select RLP.OUT_DATE
      from   SYSTEM_LOOP_PERIOD(:from_date, :to_date) RLP
      into   :idate
    do begin
      if ((:is_static = 1) and (:idate > :from_date)) then begin
        insert into TAR_CALC_OUTPUT$TMP (ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
               FOR_DATE, PRICE, CURRENCY, PRICE_TARIFF, CURRENCY_TARIFF, PRICE_NOTE, QTY_POST,
               PTEXT, DISC_TAG, ID_DISCOUNT_SERVICE, REQUIRED_ID_PACKET_ITEM)
        select tco.ID_TAR_INPUT, tco.ID_TAR_CALC, tco.ID_SERVICE, tco.SERVICE_TYPE,
               :idate, PRICE, tco.CURRENCY, tco.PRICE_TARIFF, tco.CURRENCY_TARIFF, tco.PRICE_NOTE, tco.QTY_POST,
               tco.PTEXT, tco.DISC_TAG, tco.ID_DISCOUNT_SERVICE, tco.REQUIRED_ID_PACKET_ITEM
        from   TAR_CALC_OUTPUT$TMP TCO
        where  TCO.FOR_DATE = :from_date
               and TCO.ID_TAR_CALC = :id_tar_calc;
        for
          select TCID.ID_TAR_INPUT, TCID.ID_TYPE_STAY, TCID.SEPARATE_BOARD, TCID.ID_BOARD_INCLUDE,
                 TCID.IS_MANUAL_TYPE_STAY, TCID.ID_TAR_HEAD
          from   TAR_CALC_INPUT_DETAIL$TMP TCID
                 join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
          where  TCID.FOR_DATE = :from_date
                 and TCI.ID_TAR_CALC = :id_tar_calc
          into   :id_tar_input, :id_type_stay, :separate_board, :id_board_include,
                 :is_manual_type_stay, :id_tar_head
        do begin
          seasson_name = null;
          select tp.SEASON_NAME
          from   TARIFA_GET_PERIOD_FOR_DATE (:id_tar_head, :idate) tp
          into   :seasson_name;
          if (:seasson_name is null) then begin
            ERR_CODE = -231;
            ERR_TEXT = '';
            exit;
          end

          update TAR_CALC_INPUT_DETAIL$TMP TCID
          set    TCID.ID_TYPE_STAY = :id_type_stay,
                 TCID.IS_MANUAL_TYPE_STAY = :is_manual_type_stay,
                 TCID.SEPARATE_BOARD = :separate_board,
                 TCID.ID_BOARD_INCLUDE = :id_board_include
          where  TCID.ID_TAR_INPUT = :id_tar_input;
        end
      end else begin
        execute procedure TAR_CALC_EVAL_DATE$INT(:id_tar_calc, :room_status, :idate)
        returning_values  :err_code, :err_text;
        if (:err_code < 0) then exit;
      end
    end
  end

  execute procedure TAR_CALC_EVAL_ZERO$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  if (:err_code is null) then begin
    err_code = -230; /*WRONG INPUT PARAMS - MISSING GUESTS*/
    err_text = 'Missing input data for calculation';
    exit;
  end

  execute procedure TAR_CALC_EVAL_PERIOD$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  execute procedure TAR_CALC_CHECK_PACKETS$INT (:ID_TAR_CALC)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;
end
^

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: CANCEL_BOOKING$EXC for: APPLY_BOOKING_STATUS$EXC */
ALTER PROCEDURE CANCEL_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER /* NAME_20 */ VARCHAR(20),
CANCELATION_NUMBER /* NAME_20 */ VARCHAR(20),
STATUS VARCHAR(20))
 RETURNS(BOOKING_ID INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (APPLY_BOOKING_STATUS$EXC) */
ALTER PROCEDURE APPLY_BOOKING_STATUS$EXC(BOOKING_ID INTEGER,
BOOKING_DB_KEY CHAR(8),
STATUS VARCHAR(50),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20)
 AS
declare variable err_text varchar(255);
declare variable dummy_int integer;
declare variable anul_reason varchar(30);
declare variable selection_id integer;

declare variable status_code smallint;
declare variable current_anul_code smallint;
declare variable current_status_code smallint;
declare variable current_status_text varchar(50);
declare variable new_status_text varchar(50);
declare variable extra_posts_left integer;
declare variable check_out_kind smallint;
declare variable earlycheckout_date date;
begin
  if (:booking_db_key is null) then begin
    select rd.RDB$DB_KEY, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.ID_RESERV_DETAIL = :BOOKING_ID
    into   :booking_db_key, :current_status_code, :current_anul_code;
  end else begin
    select rd.id_reserv_detail, rd.check_status, rd.IS_ANUL
    from   RESERV_DETAIL RD
    where  rd.rdb$db_key = :booking_db_key
    into   :booking_id, :current_status_code, :current_anul_code;
  end

  execute procedure IMPORT_BOOKING_STATUS$EXC(:status, -2)
  returning_values :status_code;

  execute procedure EXPORT_BOOKING_STATUS$EXC(:current_status_code, :current_anul_code)
  returning_values :current_status_text;
  execute procedure IMPORT_BOOKING_STATUS$EXC(:current_status_text, :current_status_code)
  returning_values :current_status_code;

  /* nop - exit */
  if (:current_status_code = :status_code) then exit;

  /* validate status transition */
  if (
     /* terminal status values - void booking */
    (:current_status_code in (1004/*no show*/, 1005/*canceled*/))

    /* void over checkin */
    or ((:current_status_code >= 0) and (:status_code in (1004/*no show*/, 1005/*canceled*/)))

    /* positive status downgrade */
    or ((:current_status_code > 0) and (:current_status_code > :status_code))
  )  then begin
    execute procedure PRINT_BOOKING_STATUS$EXC(:current_status_code) returning_values :current_status_text;
    execute procedure PRINT_BOOKING_STATUS$EXC(:status_code) returning_values :new_status_text;

    exception VALIDATE_EXCEPTION '-1022' || f_character(31) || '@{invalid_status_transition} ' || :current_status_text || ' -> ' || :new_status_text;
  end

  anul_reason = null;
  if (1004 = :status_code) then begin
    anul_reason = 'NOSHOW';
  end else if (1005 = :status_code) then begin
    anul_reason = 'CANCELED';
  end

  if (:anul_reason is null) then begin
    if (0 > :status_code) then begin
      execute procedure RES_SAVE_STATUS$INT(:booking_db_key, :status_code, :CONFIRMATION_NUMBER);
    end else begin
      if (:status_code in (0, 1) and 0 > :current_status_code) then begin
        -- checkin
        execute procedure RES_SET_CHECKIN$INT (:booking_db_key)
        returning_values (:dummy_int, :err_text, :dummy_int, :dummy_int);
      end
      if (1 = :status_code and 1 > :current_status_code) then begin
        -- checkout
        selection_id = gen_id(SELECTION_GEN, 1);
        update RESERV_DETAIL
        set    selection_id=:selection_id
        where  rdb$db_key=:booking_db_key
        returning new.CHECK_OUT_KIND, new.EARLYCHECKOUT_DATE
        into   :check_out_kind, :earlycheckout_date;
    
        execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id, :check_out_kind, :earlycheckout_date);
      end
    end
  end else begin
    -- void
    execute procedure RES_ANUL_DETAIL$INT(:booking_db_key, :anul_reason, :CANCELATION_NUMBER)
    returning_values  :dummy_int, :extra_posts_left;
    if (:extra_posts_left = 1) then exception BOOKING_EXCEPTION '-1042';

  end
end
^

/* Alter (CANCEL_BOOKING$EXC) */
ALTER PROCEDURE CANCEL_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
CONFIRMATION_NUMBER NAME_20,
CANCELATION_NUMBER NAME_20,
STATUS VARCHAR(20))
 RETURNS(BOOKING_ID INTEGER,
FROM_DATE DATE,
TO_DATE DATE,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable hotel_id integer;
declare variable cancel_event_log_id integer;
begin
  /* init */
  err_code = 0;
  err_text = '';

  execute procedure import_mark_transaction$exc;

  select first 1 b.id_reserv_detail, b.id_log_event_annul, b.from_date, b.to_date
  from   reserv_detail b
  where  b.number=:number
         and b.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
  order by id_log_event_annul nulls first
  into   :booking_id, cancel_event_log_id, :from_date, :to_date;

  if ((:booking_id is null) or (:cancel_event_log_id is not null)) then begin
    /* not found or found but already in void status - ignore and exit */
    exit;
  end

  /* verify hotel */
  execute procedure lookup_hotel$exc(:hotel, 'BOOKING', :booking_id)
  returning_values :hotel_id;

  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  execute procedure APPLY_BOOKING_STATUS$EXC(
    :booking_id, null, :status, :confirmation_number, :cancelation_number
  );
end
^

/* Alter (CLEAR_ORPHAN_GUESTS$EXC) */
ALTER PROCEDURE CLEAR_ORPHAN_GUESTS$EXC(BOOKING_ID INTEGER)
 AS
declare variable guest_id integer;
  declare variable guest_uuid varchar(50);
begin

  for
    select g.id_guest, g.uuid
    from guest g
    where g.id_reserv_detail=:booking_id and g.orphaned_import$exc=1
    into :guest_id, :guest_uuid do
  begin
    execute procedure sys_dbg('exc CLEAR_ORPHAN_GUESTS$EXC - RES_GUEST_DEL$RSV(:guest_id=>' || coalesce(:guest_id, '<null>') || ', :guest_uuid=>' || coalesce(:guest_uuid, '<null>') || ')');

    execute procedure RES_GUEST_DEL$RSV(:guest_id);
  end
end
^

/* Alter (EAI_EXT_POST_TO_FRONT_ONLINE) */
ALTER PROCEDURE EAI_EXT_POST_TO_FRONT_ONLINE(ROOM_NAME VARCHAR(10),
SERVICE_CODE VARCHAR(30),
CODE_TYPE VARCHAR(20),
QTY_POST NUMERIC(15,2),
PRICE_POST NUMERIC(15,2),
CURR_POST VARCHAR(3),
POST_TEXT VARCHAR(50))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_ROOM INTEGER,
ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(50),
ID_ACCOUNT INTEGER,
ID_ACCOUNT_POST INTEGER,
ID_SERVICE INTEGER)
 AS
declare variable ID_HOTEL integer;
begin
  if (singular(select HS.ID_HOTEL
               from HOTEL_S HS
               where HS.IS_USE = 1)) then
    select H.ID_HOTEL
    from   HOTEL_S H
    where H.IS_USE = 1
    into   :id_hotel;
  else begin
    err_code = -1044;
    exit;
  end

  execute procedure EAI_EXT_POST_TO_MH_FRONT_ONLINE(:ID_HOTEL, :ROOM_NAME,
    :SERVICE_CODE, :CODE_TYPE, :QTY_POST, :PRICE_POST, :CURR_POST, :POST_TEXT)
  returning_values (:ERR_CODE, :ERR_TEXT, :ID_ROOM, :ID_GUEST, :GUEST_NAME1,
    :ID_ACCOUNT, :ID_ACCOUNT_POST, :ID_SERVICE);

end
^

/* Alter (EAI_RES_CHECK_OUT_FAST) */
ALTER PROCEDURE EAI_RES_CHECK_OUT_FAST(ID_RESERV_DETAIL INTEGER)
 AS
declare variable selection_id integer;
  declare variable is_early_check_out smallint;
  declare variable early_check_out_dep_date date;
  declare variable check_out_date date;
begin
  selection_id = gen_id(selection_gen, 1);

  update RESERV_DETAIL RD
  set RD.SELECTION_ID = :SELECTION_ID
  where RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL;

  execute procedure RES_CHECK_OUT_CHECK$RSV(:selection_id)
  returning_values :is_early_check_out, :early_check_out_dep_date, :check_out_date;

  if (:is_early_check_out = 1) then
    exception BOOKING_EXCEPTION '-1043';

  execute procedure RES_CHECK_OUT_GUESTS$RSV(:selection_id, 0);
end
^

/* Alter (END_WORK) */
ALTER PROCEDURE END_WORK(IN_NEXT_DATE DATE,
ID_HOTEL INTEGER)
 AS
declare variable system_date date;
  declare variable id_end_work integer;
  declare variable last_closed_date date;
  declare variable lock_id integer;
  declare variable dbkey char(8);
begin
  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date >= :in_next_date) then exception END_WORK_EXCEPTION '-43';
  if (:IN_NEXT_DATE > current_date + 1) then exception END_WORK_EXCEPTION '-60';

  last_closed_date = :in_next_date - 1;

  /* LOCK THE CURRENT FINANCIAL (SYSTEM) DATE  */
  lock_id = null;
  while (:lock_id is null) do begin
    lock_id = strhash_large(:system_date || :id_hotel);
    execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'lock');
  
    when any do begin
      exception END_WORK_EXCEPTION '-337' || f_character(31) || f_character(29) || FormatDate(:system_date, 'D;dd.mm.yyyy');
    end
  end

  /* RIGHT IS REQUIRED TO CHANGE THE FINANCIAL DATE IF THERE ARE GUESTS WITH OVERDUE CHECK OUT */
  if (exists(
    select *
    from   GUEST G
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
    where  G.TO_DATE <= :last_closed_date
           and G.CHECK_STATUS < 1
           and RD.ID_HOTEL = :id_hotel
           and rd.IS_ANUL = 0
  )) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('EW_OVERDUE_CHECKOUT');
  end

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', 'EW');
  -- Suppress eventual right checks into next procedures - all is permitted. Is this needed(?!?)

  for
    select p.RDB$DB_KEY
    from   ACCOUNT_POST p
           join ACCOUNT a on a.ID_ACCOUNT = p.ID_ACCOUNT
    where  p.DATE_POST between :system_date and :last_closed_date
           and p.ID_GUEST > 0
           and a.ID_HOTEL = :ID_HOTEL
    into   :dbkey
  do begin
    update ACCOUNT_POST AP
    set    ap.ROOM_NAME = (select R.ROOM_NAME
                           from   GUEST G
                                  join ROOMS R on R.ID_ROOM = G.ID_ROOM
                           where  G.ID_GUEST = ap.ID_GUEST)
    where  ap.RDB$DB_KEY = :dbkey;
  end

  /* CHANGE SYSTEM DATE */
  execute procedure SYSTEM_DATE_SET(:id_hotel, :system_date, :in_next_date)
  returning_values :id_end_work;

  /* AUTO EXPIRATION OF ROOM NUMBERS, ROOMS AND BOOKING POSITIONS */
  execute procedure RESERVS_EXPIRE$INT(:last_closed_date, :id_hotel);

  execute procedure AGENT_CONTINGENT_EXPIRE(:system_date, :last_closed_date, null, 0, 1, :id_hotel);

  /* DELETE PERSON PROFILES WITH EXPIRATION DATE */
  execute procedure PROFILE_PERSON_EXPIRE (:in_next_date);

  execute procedure HOUSEKEEPING_MARK_ROOMS$EW(:id_end_work);

  /* Summary statistic */
  if (:in_next_date > :system_date) then begin
    execute procedure SUMMARY_FINANCE_STATISTIC$EW(:id_end_work);

    execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:ID_HOTEL, :system_date, :last_closed_date);

    execute procedure SUMMARY_STATISTIC_REBUILD$EW(:ID_HOTEL);

    execute procedure SUMMARY_FORECAST$INT(:ID_HOTEL, :system_date);
  end

  /* Delete pseudo-temporal tables */
  delete from RESERV_ERROR;
  /*  */

--  execute procedure CACHES_RESOLVE;

  execute procedure SYSTEM_LOG_ADD('DAY_END_WORK', :id_end_work, 'DAY_EW', f_character(29) || :system_date || f_character(28) || :IN_NEXT_DATE);

  execute procedure SYSTEM_LOCK_OBJECT (:lock_id, 'END_WORK', 'END_WORK_PROCESS', 'release');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'ACTION_CTX', null);

  execute procedure SYSTEM_CACHE_APPLY('end_work');
end
^

/* Alter (GUEST_ADDRESSCARD_SET$INT) */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$INT(PD_DBKEY CHAR(8),
G_DBKEY CHAR(8),
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
COUNTRY_CODE VARCHAR(10),
IS_CHILD INTEGER,
AGE INTEGER,
BIRTH_DAY DATE,
TITLE VARCHAR(10))
 AS
declare variable rd_dbkey char(8);
  declare variable old_is_child integer;
  declare variable old_birthday date;
  declare variable p_dbkey char(8);
  declare variable old_country_code varchar(10);
  declare variable from_date date;
  declare variable birthday_internal date;
begin

  select G.IS_CHILD, coalesce(:is_child, G.IS_CHILD), RD.RDB$DB_KEY, G.FROM_DATE
  from   GUEST G
         left join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = G.ID_RESERV_DETAIL
  where  G.RDB$DB_KEY = :g_dbkey
  into   :old_is_child, :is_child, :rd_dbkey, :from_date;

  select PD.COUNTRY_CODE, PD.BIRTH_DAY, P.RDB$DB_KEY
  from   PERSON_DATA PD
         left outer join PROFILE_PERSON PP on PP.ID_PERSON_DATA = PD.ID_PERSON_DATA
         left outer join PROFILE P on P.ID_PROFILE = PP.ID_PROFILE
  where  PD.RDB$DB_KEY = :pd_dbkey
  into   :old_country_code, :old_birthday, :p_dbkey;

  country_code = coalesce(:country_code, '');

  execute procedure sys_dbg('res GUEST_ADDRESSCARD_SET$INT birth_day = '||coalesce(:birth_day, 'null'));
  execute procedure sys_dbg('res GUEST_ADDRESSCARD_SET$INT old_birthday = '||coalesce(:old_birthday, 'null'));
  execute procedure sys_dbg('res GUEST_ADDRESSCARD_SET$INT age = '||coalesce(:age, 'null'));

  execute procedure GUEST_BIRTHDAY$INT(:birth_day, :age, :old_birthday, :from_date)
  returning_values  :birthday_internal, :birth_day;

  execute procedure PERSON_DATA_SET$INT(:p_dbkey, :pd_dbkey, :guest_name1, :guest_name2,
          :country_code, :birth_day, :birthday_internal, :TITLE);

  if (:old_is_child <> :is_child) then begin
    update RESERV_DETAIL RD
    set    RD.ADULT_COUNT = RD.ADULT_COUNT + (2*:old_is_child - 1),
           RD.CHILD_COUNT = RD.CHILD_COUNT - (2*:old_is_child - 1)
    where  RD.RDB$DB_KEY = :rd_dbkey;

    update GUEST G
    set    G.IS_CHILD = :is_child
    where  G.RDB$DB_KEY = :g_dbkey;
  end

  if (:old_country_code is distinct from :country_code) then begin
    update RESERV_DETAIL RD
    set    RD.COUNTRY = :country_code
    where  RD.RDB$DB_KEY = :rd_dbkey;
  end
end
^

/* Alter (GUEST_ADDRESSCARD_SET$RSV) */
ALTER PROCEDURE GUEST_ADDRESSCARD_SET$RSV(ID_GUEST INTEGER,
GUEST_NAME1 VARCHAR(100),
GUEST_NAME2 VARCHAR(100),
ID_PASSPORT_TYPE INTEGER,
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
EGN VARCHAR(30),
COUNTRY VARCHAR(10),
ID_STAY_REASON INTEGER,
IS_REGISTRED INTEGER,
PASS_PLACE VARCHAR(20),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_PLACE VARCHAR(30),
SEX CHAR,
MASK VARCHAR(10),
IS_CHILD INTEGER,
CAR VARCHAR(30),
KPP INTEGER,
KPP_DATE DATE,
PASS_EXP_DATE DATE,
AGE INTEGER,
BIRTH_DAY DATE,
VISA TDESCRIPTION_SHORT,
RATING_AGE INTEGER = null,
TITLE VARCHAR(10) = null,
FORCE_RES_FINALIZE SMALLINT = 1)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable gd_dbkey char(8);
  declare variable pd_dbkey char(8);
  declare variable g_dbkey char(8);
  declare variable rd_dbkey char(8);
  declare variable old_is_registred integer;
  declare variable old_guest_name1 varchar(250);
  declare variable old_guest_name2 varchar(250);
  declare variable old_id_pass_type integer;
  declare variable old_pass_num varchar(20);
  declare variable old_pass_date date;
  declare variable old_egn varchar(30);
  declare variable old_country varchar(20);
  declare variable old_id_stay_reason integer;
  declare variable old_kpp integer;
  declare variable old_kpp_date date;
  declare variable old_pass_exp_date date;
  declare variable old_birth_day date;
  declare variable old_pass_place varchar(20);
  declare variable old_city varchar(100);
  declare variable old_address varchar(100);
  declare variable old_visa TDESCRIPTION_SHORT;
  declare variable old_birth_place varchar(30);
  declare variable old_sex char(1);
  declare variable action_text varchar(250);
  declare variable tt_reg_number integer;
  declare variable id_hotel integer;
  declare variable id_tt_numerator integer;
  declare variable domestic_nation varchar(10);
  declare variable no_use varchar(255);
  declare variable is_anul smallint;
  declare variable acc_routing varchar(20);
begin
  err_code = 0;
  err_text = '';

  select G.RDB$DB_KEY, GD.RDB$DB_KEY, PD.RDB$DB_KEY,
         GD.IS_REGISTRED, PD.PERSON_NAME, PD.PERSON_NAME2, PD.ID_PASSPORT_TYPE, PD.PASS_NUM, PD.PASS_DATE,
         PD.EGN, PD.COUNTRY_CODE, GD.ID_STAY_REASON, GD.KPP, GD.KPP_DATE, PD.PASS_EXP_DATE,
         PD.BIRTH_DAY, PD.PASS_PLACE, PD.CITY, PD.ADDRESS, PD.BIRTH_PLACE, PD.SEX, rd.RDB$DB_KEY,
         g.TT_REG_NUMBER, rd.ID_HOTEL, rd.IS_ANUL, rd.ACC_ROUTING, GD.VISA
  from   GUEST G
         join GUEST_DATA GD on GD.ID_GUEST = G.ID_GUEST
         join PERSON_DATA PD on PD.ID_PERSON_DATA = GD.ID_PERSON_DATA
         join RESERV_DETAIL RD on rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL
  where  G.ID_GUEST = :id_guest
  into   :g_dbkey, :gd_dbkey, :pd_dbkey,
         :old_is_registred, :old_guest_name1, :old_guest_name2, :old_id_pass_type, :old_pass_num, :old_pass_date,
         :old_egn, :old_country, :old_id_stay_reason, :old_kpp, :old_kpp_date, :old_pass_exp_date,
         :old_birth_day, :old_pass_place, :old_city, :old_address, :old_birth_place, :old_sex, :rd_dbkey,
         :tt_reg_number, :id_hotel, :is_anul, :acc_routing, :old_visa;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure PERSON_PASS_DATA_SET$INT(:pd_dbkey, :birth_place, :egn, :id_passport_type, :pass_num, :pass_date, :pass_place,
          :pass_exp_date, :city, :address, :sex, :mask);

  update  GUEST_DATA GD
  set     GD.KPP_DATE = :kpp_date,
          GD.KPP = :kpp,
          GD.VISA = :visa,
          GD.ID_STAY_REASON = :id_stay_reason,
          GD.IS_REGISTRED = :is_registred,
          GD.USER_REGISTRED = iif(:IS_REGISTRED = 1, coalesce(GD.USER_REGISTRED, current_user), null),
          GD.CAR = :car,
          GD.RATING_AGE = :RATING_AGE
  where   GD.RDB$DB_KEY = :gd_dbkey;

  execute procedure GUEST_ADDRESSCARD_SET$INT(:pd_dbkey, :g_dbkey, :guest_name1, :guest_name2, :country,
          :is_child, :age, :birth_day, :TITLE);

  execute procedure GUEST_SET_STATUS$INT(:g_dbkey, -1);

  /*  */
  if (:IS_REGISTRED = 1 and :tt_reg_number is null and :is_anul = 0 and :acc_routing is distinct from 'OWNER') then begin
    execute procedure SETTING_GET_VALUE ('NATIVE_NATION', :id_hotel)
    returning_values :domestic_nation;

    select iif(:COUNTRY not in (:domestic_nation, '') and h.USE_DIFFERENT_TT_NUMERATORS = 1,
               h.ID_TT_NUMERATOR_2,
               h.ID_TT_NUMERATOR_1)
    from   HOTEL H
    where  h.ID_HOTEL = :id_hotel
    into   :id_tt_numerator;

    if (:id_tt_numerator is not null) then begin
      execute procedure SYSTEM_GEN_NUM('GUEST_NUM', :id_tt_numerator)
      returning_values :tt_reg_number, :no_use;
  
      update GUEST G
      set    g.TT_REG_NUMBER = :tt_reg_number
      where  G.RDB$DB_KEY = :g_dbkey;
    end
  end else if (:IS_REGISTRED is distinct from 1 and :tt_reg_number is not null) then begin
    update GUEST G
    set    g.TT_REG_NUMBER = null
    where  G.RDB$DB_KEY = :g_dbkey;
  end
  /*  */
  if ((:old_is_registred = 0) and (:is_registred = 1)) then begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'REGISTRED', '');
  end

  if ((:old_is_registred = 1) and (:old_guest_name1 <> :guest_name1)) then begin
    action_text = f_character(29)||:old_guest_name1||f_character(28)||:guest_name1;
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'CHANGE_CARD', :action_text);
  end

  if ((:old_IS_REGISTRED = 1)
      and
      ((:old_guest_name1 <> :guest_name1)
        or (:old_guest_name2 <> :guest_name2)
        or (:old_egn <> :egn)
        or (:old_id_pass_type <> :id_passport_type)
        or (:old_pass_num <> :pass_num)
        or (:old_pass_date <> :pass_date)
        or (:old_pass_exp_date <> :pass_exp_date)
        or (:old_pass_place <> :pass_place)
        or (:old_country <> :country)
        or (:old_city <> :city)
        or (:old_address <> :address)
        or (:old_visa <> :visa)
        or (:old_birth_day <> :birth_day)
        or (:old_birth_place <> :birth_place)
        or (:old_sex  <> :sex)
        or (:old_kpp <> :kpp)
        or (coalesce(:old_id_stay_reason,0) <> coalesce(:id_stay_reason,0))
        or (:old_kpp_date <> :kpp_date)
      )) then
  begin
    execute procedure SYSTEM_LOG_ADD('GUEST', :id_guest, 'PREREGISTRED', '');
  end

  if (coalesce(:FORCE_RES_FINALIZE, 1) = 1) then begin
    execute procedure RES_FINALIZE$INT(:rd_dbkey, 1)
    returning_values  :warn_code;

  end

end
^

/* empty dependent procedure body */
/* Clear: CREATE_BOOKING$WBE for: IMPORT_BOOKING$EXC */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TEST_BOOKING_IMPORT for: IMPORT_BOOKING$EXC */
ALTER PROCEDURE TEST_BOOKING_IMPORT AS
 BEGIN EXIT; END
^

/* Alter (IMPORT_BOOKING$EXC) */
ALTER PROCEDURE IMPORT_BOOKING$EXC(HOTEL VARCHAR(50),
NUMBER VARCHAR(62),
GROUP_NAME VARCHAR(50),
GROUP_UUID VARCHAR(40),
IS_VIP SMALLINT,
ARRIVAL DATE,
ARRIVAL_TYPE VARCHAR(20),
DEPARTURE DATE,
IS_LATE_DEPARTURE SMALLINT,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
ROOM_TYPE VARCHAR(20),
BOARD VARCHAR(30),
ROOM_PREFERENCES VARCHAR(255),
SPECIAL_TREATMENT VARCHAR(250),
MAINTANCE_SHEMA VARCHAR(30),
POSTING_ROUTING VARCHAR(20),
RATE VARCHAR(50),
MANUAL_PRICE NUMERIC(15,4),
MANUAL_PRICE_CURRENCY CHAR(3),
DEPOSIT_REQUIRED NUMERIC(15,4),
DEPOSIT_REQUIRED_CURRENCY CHAR(3),
ARRANGER_PAYMENT_TYPE VARCHAR(20),
GUEST_PAYMENT_TYPE VARCHAR(20),
VOUCHER VARCHAR(20),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
MARKETING_SEGMENT VARCHAR(30),
MARKETING_SOURCE_CODE VARCHAR(30),
MARKETING_CHANNEL_CODE VARCHAR(30),
MARKETING_HEAR_REASON VARCHAR(30),
MARKETING_COME_REASON VARCHAR(30),
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
FIRST_FOOD VARCHAR(30),
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ARRANGER_PROFILE_UUID VARCHAR(40),
ARRANGER_PROFILE_NAME VARCHAR(100),
MAIN_GUEST_PROFILE_UUID VARCHAR(40),
IS_DIFFERENT_RATE SMALLINT,
IS_DIFFERENT_PRICE SMALLINT,
SPLIT_ON_CHECKIN SMALLINT,
GUARANTEE_POLICY VARCHAR(50),
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
COMPLIMENTARY_ACCOUNT VARCHAR(50),
EATING_OBJECT VARCHAR(50),
CREATE_DATETIME TIMESTAMP,
CHECK_OUT_KIND SMALLINT,
EARLYCHECKOUT_DATE DATE)
 RETURNS(HOTEL_ID INTEGER,
BOOKING_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable current_hotel_id integer;
declare variable booking_update_id integer;
declare variable warn_code integer;
declare variable share_transaction_id integer;
declare variable share_err_code integer;
declare variable arranger_profile_id integer;
declare variable main_guest_profile_id integer;
declare variable rate_id integer;
declare variable room_type_id integer;
declare variable board_id integer;
declare variable maintance_shema_id integer;
declare variable arranger_payment_type_id integer;
declare variable guest_payment_type_id integer;
declare variable marketing_segment_id integer;
declare variable marketing_source_code_id integer;
declare variable marketing_channel_code_id integer;
declare variable marketing_hear_reason_id integer;
declare variable marketing_come_reason_id integer;
declare variable arranger_account_id integer;
declare variable packet_id integer;
declare variable id_guarantee_policy integer;
declare variable first_food_code tfood_code;
declare variable arrival_type_code smallint;
declare variable booking_dbkey char(8);
declare variable reserv_group_id integer;
declare variable id_complimentary_account integer;
declare variable id_eating_object integer;
declare variable default_guest_mask varchar(10);
declare variable id_person_data integer;
begin
  /*execute procedure sys_dbg('exc IMPORT_BOOKING$EXC('
  || 'hotel => ' || coalesce(:hotel, '<null>')
  || ', booking_number => ' || coalesce(:number, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  ||')');
  */
  execute procedure import_mark_transaction$exc;

  /* init */
  err_code = 0;
  err_text = '';
  booking_update_id = null;
  booking_dbkey = null;
  current_hotel_id = null;
  if (:voucher_date is not null) then begin
    voucher_date = striptime(:voucher_date);
  end
  posting_routing = upper(:posting_routing);

  /* detect inser/update mode */
  select b.id_reserv_detail, b.rdb$db_key, b.id_hotel
  from   reserv_detail b
  where  b.number=:number
         and b.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and b.id_log_event_annul is null
  into   :booking_update_id, :booking_dbkey, :current_hotel_id;

  if (:booking_update_id is null) then begin
    booking_id = gen_id (id_reserv_detail_gen, 1);
  end else begin
    booking_id = :booking_update_id;
  end

  /* text to id map */
  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => MAP_BOOKING_RELATIONS$EXC');
  execute procedure MAP_BOOKING_RELATIONS$EXC(
    :booking_id,
    :hotel,
    :room_type,
    :board,
    :maintance_shema,
    :rate,
    :arranger_payment_type,
    :guest_payment_type,
    :marketing_segment,
    :marketing_source_code,
    :marketing_channel_code,
    :marketing_hear_reason,
    :marketing_come_reason,
    :first_food,
    :arranger_profile_uuid,
    :arranger_profile_name,
    :main_guest_profile_uuid,
    :arrival_type,
    :guarantee_policy,
    :eating_object
  ) returning_values
    :arranger_profile_id,
    :main_guest_profile_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :hotel_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :first_food_code,
    :arrival_type_code,
    :id_guarantee_policy,
    :id_eating_object;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* hotel change test */
  if (coalesce(:current_hotel_id, :hotel_id) <> :hotel_id) then begin
    execute procedure log_id_lookup_error$exc(:booking_id, 'BOOKING', null, :hotel, 'booking hotel changed');
  end

  id_complimentary_account = null;
  if (complimentary_account is not null) then begin
    execute procedure lookup_account$exc(:hotel_id, :complimentary_account, 'booking', :booking_id)
    returning_values :id_complimentary_account;
  end

  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;
  if (0 <> :err_code) then exit;

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => CREATE_PACK_INSTANCE$EXC');
  packet_id = null;
  /*execute procedure CREATE_PACK_INSTANCE$EXC(
    :hotel_id, :booking_id, :package
  )
  returning_values :packet_id, :err_code, :err_text;
  if (0 <> :err_code) then exit;
  */
  /* merge input and default/persistent database values */
  execute procedure DEFAULT_BOOKING_VALUES$EXC(
    :booking_dbkey, :hotel_id,
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :group_name,
    :group_uuid,
    :is_late_departure,
    :id_eating_object
  ) returning_values
    :rate_id,
    :room_type_id,
    :board_id,
    :maintance_shema_id,
    :arranger_payment_type_id,
    :guest_payment_type_id,
    :marketing_segment_id,
    :marketing_source_code_id,
    :marketing_channel_code_id,
    :marketing_hear_reason_id,
    :marketing_come_reason_id,
    :arranger_profile_id,
    :arranger_account_id,
    :main_guest_profile_id,
    :posting_routing,
    :first_food_code,
    :id_guarantee_policy,
    :reserv_group_id,
    :is_late_departure,
    :id_eating_object,
    :default_guest_mask;

  if ('' = :board) then board_id = null; /* preserve "empty board" state and discard default value */

  --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC DEFAULTED => :rate=>' || coalesce(:rate, '<null>') || ' -> :rate_id=>' || coalesce(:rate_id, '<null>'));

  /* if the booking is complimentary use complimentary account */
  arranger_account_id = coalesce(:id_complimentary_account, :arranger_account_id);

  /* CREATE or UPDATE */
  if (:booking_update_id is not null) then begin
    /* UPDATE booking */
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => UPDATE_BOOKING$EXC');
    execute procedure UPDATE_BOOKING$EXC(
      :booking_id,
      :reserv_group_id,
      :is_vip,
      :arrival,
      :arrival_type_code,
      :departure,
      :is_late_departure,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :room_type_id,
      :board_id,
      :room_preferences,
      :special_treatment,
      :maintance_shema_id,
      :posting_routing,
      :arranger_account_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :deposit_required,
      :deposit_required_currency,
      :arranger_payment_type_id,
      :guest_payment_type_id,
      :voucher,
      :voucher_date,
      :voucher_text,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :note,
      :note_reminders,
      :first_food_code,
      :arranger_profile_id,
      :main_guest_profile_id,
      :is_different_rate,
      :is_different_price,
      :split_on_checkin,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object
    ) returning_values :err_code, :err_text;
    if (0 <> :err_code) then begin
      exit;
    end
  end else begin
    /* CREATE booking */
    if (:default_guest_mask is not null
        and :main_guest_profile_id is not null
        and not exists (select rd.ID_RESERV_DETAIL from reserv_detail rd where rd.ID_PERSON_PROFILE = :main_guest_profile_id)) then
    begin
      -- fill the mask with a default value if its is empty
      select p.id_person_data
      from   PROFILE_PERSON p
      where  p.ID_PROFILE = :main_guest_profile_id
      into   :id_person_data;

      update PERSON_DATA pd
      set    pd.MASK = :default_guest_mask
      where  pd.ID_PERSON_DATA = :id_person_data
             and pd.MASK is null;
    end
    --execute procedure sys_dbg('exc IMPORT_BOOKING$EXC => RES_CREATE_SET$EXC');
    execute procedure RES_CREATE_SET$EXC (
      :booking_id,
      :number,
      :arranger_profile_id,
      :main_guest_profile_id,
      :arrival,
      :departure,
      :adult_count,
      :children_count,
      :room_type_id,
      null,
      :board_id,
      :rate_id,
      :manual_price,
      :manual_price_currency,
      :voucher,
      :voucher_date,
      :voucher_text,
      null,
      null,
      :transfer_in_time,
      :transfer_in_note,
      :transfer_out_time,
      :transfer_out_note,
      :arrival_type_code,
      :is_late_departure,
      :is_vip,
      :first_food_code,
      :special_treatment,
      :marketing_segment_id,
      :marketing_source_code_id,
      :marketing_channel_code_id,
      :marketing_hear_reason_id,
      :marketing_come_reason_id,
      :arranger_account_id,
      :posting_routing,
      :guest_payment_type_id,
      :arranger_payment_type_id,
      null,
      :room_preferences,
      :maintance_shema_id,
      :note,
      :note_reminders,
      :deposit_required,
      :deposit_required_currency,
      :hotel_id,
      :reserv_group_id,
      :id_guarantee_policy,
      :block_cc,
      :guarantee_deposit_percent,
      :guarantee_deposit_nights,
      :guarantee_due_days_bef_arrival,
      :guarantee_due_days_after_create,
      :minibar_rights,
      :paytv_rights,
      :video_rights,
      :nopost_pms,
      :phone_rights,
      :seminar_cahnnel_rights,
      :posting_transaction_uuid,
      :id_eating_object,
      :create_datetime
      )
    returning_values :err_code, :err_text, :warn_code, :booking_id, :share_transaction_id, :share_err_code;
  end

  update reserv_detail rd
  set    rd.CHECK_OUT_KIND = :CHECK_OUT_KIND,
         rd.EARLYCHECKOUT_DATE = :EARLYCHECKOUT_DATE
  where  rd.ID_RESERV_DETAIL = :BOOKING_ID;

  execute procedure GUEST_STAY_INITIALIZE$INT (:booking_id);
  /* final error check */
  execute procedure CHECK_MAPPING_ERRORS$EXC(:booking_id, :number)
  returning_values :err_code, :err_text;

  delete from PENDING_DEPOSIT d
  where  d.ID_RESERV_DETAIL = :BOOKING_ID;
end
^

/* empty dependent procedure body */
/* Clear: CREATE_SESSION_BOOKINGS$WBE for: IMPORT_BOOKING_FINALIZE$EXC */
ALTER PROCEDURE CREATE_SESSION_BOOKINGS$WBE(WBE_SESSION_ID BIGINT,
ARANGER_ID INTEGER,
LANG_CODE VARCHAR(3))
 RETURNS(SELECTION_ID VARCHAR(20),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* Alter (IMPORT_BOOKING_FINALIZE$EXC) */
ALTER PROCEDURE IMPORT_BOOKING_FINALIZE$EXC(BOOKING_ID INTEGER,
FORCE_RES_FINALIZE SMALLINT = 1,
STATUS VARCHAR(50) = null,
CONFIRMATION_NUMBER NAME_20 = null,
CANCELATION_NUMBER NAME_20 = null)
 RETURNS(RECORD_TIMESTAMP TIMESTAMP,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable booking_db_key char(8);
  declare variable dummy_int integer;
  declare variable dummy_text varchar(255) ;
  declare variable res_id_room integer;
  declare variable id_room integer;
  declare variable id_room_type integer;
  declare variable system_date date;
  declare variable from_date date;
  declare variable to_date date;
  declare variable gs_dbkey char(8);
begin
  ERR_CODE=0;
  ERR_TEXT=null;
  id_room = null;
  force_res_finalize = coalesce(:force_res_finalize, 1);

  execute procedure sys_dbg('exc IMPORT_BOOKING_FINALIZE$EXC => CLEAR_ORPHAN_GUESTS$EXC');
  execute procedure CLEAR_ORPHAN_GUESTS$EXC(:booking_id);

  select b.rdb$db_key, b.ID_ROOM, b.ID_ROOM_TYPE, b.FROM_DATE, b.TO_DATE
  from   reserv_detail b
  where  b.id_reserv_detail = :booking_id
  into   :booking_db_key, :res_id_room, :id_room_type, :from_date, :to_date;

  execute procedure RES_GUEST_SAVE_DIFF$INT(:booking_db_key);

  if (:res_id_room < 0) then begin
    --id_room = :res_id_room;
    for
      select lp.OUT_DATE
      from   SYSTEM_LOOP_PERIOD (:from_date, :to_date-1) lp
      into   :system_date
    do begin
      select ro.ID_ROOM, ro.ID_ROOM_TYPE
      from   RES_OCCUPANCY_ROOM$INT (:BOOKING_ID, :system_date, :id_room, :id_room_type) ro
      into   :id_room, :id_room_type;
  
      if (:id_room <> :res_id_room) then begin
        for
          select gs.RDB$DB_KEY
          from   GUEST_STAY GS
                 join GUEST G on g.ID_GUEST = gs.ID_GUEST
          where  g.ID_RESERV_DETAIL = :BOOKING_ID
                 and gs.FOR_DATE = :system_date
                 and gs.ID_ROOM <> :id_room
          into   :gs_dbkey
        do begin
          update GUEST_STAY gsu
          set    gsu.ID_ROOM = :id_room
                 --gsu.ID_ROOM_TYPE = iif (gsu.ID_ROOM_TYPE = -1, :id_room_type, gsu.ID_ROOM_TYPE)
          where  gsu.RDB$DB_KEY = :gs_dbkey;
        end
      end
    end
    update GUEST G
    set    G.ID_ROOM = coalesce(:id_room, :res_id_room)
    where  g.ID_RESERV_DETAIL = :BOOKING_ID;
  end

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null,   --force recalculation
         rd.ID_ROOM = coalesce(:id_room, :res_id_room)
         --rd.HAS_DIFFERENT_ROOM_TYPE = coalesce(:has_different_room_type,  rd.HAS_DIFFERENT_ROOM_TYPE)
  where  rd.RDB$DB_KEY = :booking_db_key;

  if (1 = :force_res_finalize) then begin
    execute procedure sys_dbg('exc IMPORT_BOOKING_FINALIZE$EXC => RES_FINALIZE_SHAREOPTION$INT');
    execute procedure RES_FINALIZE_SHAREOPTION$INT(:booking_db_key, 0)
    returning_values  :dummy_int, :dummy_text, :dummy_int, :dummy_int;
  end

  execute procedure APPLY_BOOKING_STATUS$EXC(
    null, :booking_db_key, :status, :confirmation_number, :cancelation_number
  );

  select b.change_time
  from   reserv_detail b
  where  b.rdb$db_key =:booking_db_key
  into   :record_timestamp;
end
^

/* Alter (IMPORT_GUEST$EXC) */
ALTER PROCEDURE IMPORT_GUEST$EXC(BOOKING_ID INTEGER,
PROFILE_UUID VARCHAR(40),
GUEST_UUID VARCHAR(40),
GUEST_NAME VARCHAR(100),
IS_CHILD SMALLINT,
AGE INTEGER,
IS_DIFFERENT_ARRANGER SMALLINT,
ARRIVAL DATE,
DEPARTURE DATE,
VOUCHER VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
COUNTRY_CODE VARCHAR(10),
RATING_AGE INTEGER,
KPP VARCHAR(50),
KPP_DATE DATE,
STAY_REASON VARCHAR(255),
CAR VARCHAR(30),
IS_REGISTRED SMALLINT,
PERSONAL_NUMBER VARCHAR(30),
TITLE VARCHAR(10),
PT_NAME VARCHAR(100),
PT_EXTCODE VARCHAR(50),
PASS_NUM VARCHAR(20),
PASS_PLACE VARCHAR(20),
PASS_DATE DATE,
PASS_EXP_DATE DATE,
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
BIRTH_DATE DATE,
SEX CHAR,
BIRTH_PLACE VARCHAR(30),
MASK VARCHAR(10),
PACKAGE VARCHAR(255),
VISA TDESCRIPTION_SHORT)
 RETURNS(GUEST_ID INTEGER,
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable warn_code integer;

declare variable birth_date_old date;
declare variable title_old varchar(10);
declare variable id_passport_type_old integer;
declare variable pass_num_old varchar(20);
declare variable pass_date_old date;
declare variable personal_number_old varchar(30);
declare variable id_stay_reason_old integer;
declare variable is_registred_old integer;
declare variable pass_place_old varchar(20);
declare variable city_old varchar(100);
declare variable address_old varchar(100);
declare variable birth_place_old varchar(30);
declare variable sex_old char(1);
declare variable mask_old varchar(10);
declare variable car_old varchar(30);
declare variable kpp_id_old integer;
declare variable kpp_date_old date;
declare variable pass_exp_date_old date;
declare variable rating_age_old integer;
declare variable visa_old tdescription_short;

declare variable guest_name_old varchar(100);
declare variable is_child_old integer;
declare variable arrival_old date;
declare variable departure_old date;
declare variable voucher_old varchar(30);
declare variable voucher_date_old date;
declare variable voucher_text_old varchar(30);
declare variable country_code_old varchar(10);

declare variable id_passport_type integer;
declare variable kpp_id integer;
declare variable id_stay_reason integer;
begin
  execute procedure import_mark_transaction$exc;

  guest_name = substring(:guest_name from 1 for 50);

  execute procedure sys_dbg('exc IMPORT_GUEST$EXC(:guest_uuid=>' || coalesce(:guest_uuid, '<null>') || ')');
  guest_id = null;

  select pd.person_name, --g.is_different_organizer,
         g.id_guest, g.from_date, g.to_date,
         pd.birthday_internal, pd.title, pd.id_passport_type,
         pd.pass_num, pd.pass_date, pd.egn, gd.id_stay_reason,
         gd.is_registred, pd.pass_place, pd.city, pd.address, pd.birth_place,
         pd.sex, pd.mask, g.is_child, gd.car, gd.kpp, gd.kpp_date,
         pd.pass_exp_date, gd.rating_age, g.vaucher_num, g.vaucher_date, g.vaucher_text, pd.country_code,
         gd.id_stay_reason, gd.visa
  from   GUEST g
         join guest_data gd on gd.id_guest=g.id_guest
         join person_data pd on pd.id_person_data=gd.id_person_data
  where  g.uuid=:guest_uuid
         and g.subscriber_id is not distinct from RDB$GET_CONTEXT('USER_SESSION', 'SUBSCRIBER_ID')
         and g.id_reserv_detail=:booking_id
  into   :guest_name_old, --:is_different_arranger_old,
         :guest_id, :arrival_old, :departure_old, :birth_date_old,
         :title_old, :id_passport_type_old,
         :pass_num_old, :pass_date_old, :personal_number_old, :id_stay_reason_old,
         :is_registred_old, :pass_place_old, :city_old, :address_old, :birth_place_old,
         :sex_old, :mask_old, :is_child_old, :car_old, :kpp_id_old, :kpp_date_old,
         :pass_exp_date_old, :rating_age_old, :voucher_old, :voucher_date_old,
         :voucher_text_old, :country_code_old, :id_stay_reason_old, :visa_old;

  execute procedure import_passport_type$exc(:pt_name, pt_extcode)
  returning_values :id_passport_type;

  execute procedure import_kpp$exc(:kpp, null)
  returning_values :kpp_id;

  execute procedure import_stay_reason$exc(:stay_reason, null)
  returning_values :id_stay_reason;

  guest_name = coalesce(:guest_name, :guest_name_old);
--  DISABLE age/is_child merge (RIU rating cases)
--  is_child = coalesce(:is_child, :is_child_old);
--  is_different_arranger = coalesce(:is_different_arranger, :is_different_arranger_old);
  arrival = coalesce(:arrival, :arrival_old);
  departure = coalesce(:departure, :departure_old);
  voucher = coalesce(:voucher, :voucher_old);
  voucher_date = coalesce(:voucher_date, :voucher_date_old);
  voucher_text = coalesce(:voucher_text, :voucher_text_old);
  country_code = coalesce(:country_code, :country_code_old);

--  DISABLE age/is_child merge (RIU rating cases)
--  rating_age = coalesce(:rating_age, :rating_age_old);
  kpp_id = coalesce(:kpp_id, :kpp_id_old);
  kpp_date = coalesce(:kpp_date, :kpp_date_old);
  id_stay_reason = coalesce(:id_stay_reason, :id_stay_reason_old);
  car = coalesce(:car, :car_old);
  is_registred = coalesce(:is_registred, 0);
  if (1 = :is_registred_old) then begin --one way update
    is_registred = 1;
  end
  personal_number = coalesce(:personal_number, :personal_number_old);
  title = coalesce(:title, :title_old);
  id_passport_type = coalesce(:id_passport_type, :id_passport_type_old);
  pass_num = coalesce(:pass_num, :pass_num_old);
  pass_place = coalesce(:pass_place, :pass_place_old);
  pass_date = coalesce(:pass_date, :pass_date_old);
  pass_exp_date = coalesce(:pass_exp_date, :pass_exp_date_old);
  city = coalesce(:city, :city_old);
  address = coalesce(:address, :address_old);
  birth_date = coalesce(:birth_date, :birth_date_old);
  sex = coalesce(:sex, :sex_old);
  birth_place = coalesce(:birth_place, :birth_place_old);
  mask = coalesce(:mask, :mask_old);
  visa = coalesce(:visa, :visa_old);

  if (:guest_id is null) then begin
    execute procedure RES_GUEST_SAVE$RSV(null, :booking_id, :guest_name, null, null, :is_child)
    returning_values :guest_id;

    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - get_next_auto_guest = :guest_id=>' || coalesce(:guest_id, '<null>'));
    if (:guest_id is null) then begin 
      execute procedure sys_dbg('exc IMPORT_GUEST$EXC - exhausted auto guests list - create new guest');
      execute procedure RES_GUEST_ADD$RSV(:booking_id, :is_child)
      returning_values :err_code, :err_text, :warn_code, :guest_id;
      if (0 <> :err_code) then exit;
    end

    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - update_new_guest_uuid(:guest_id=>' || coalesce(:guest_id, '<null>') || ', :uuid=>' || coalesce(:guest_uuid, '<null>') || ')');
    update GUEST
    set    uuid = :guest_uuid
    where  id_guest=:guest_id;

    /* preserve default mask */
    if (:mask is null) then begin
      select pd.mask
      from   guest_data gd
             join person_data pd on pd.id_person_data=gd.id_person_data
      where  gd.id_guest=:guest_id
      into   :mask;
    end          
  end else begin
    execute procedure sys_dbg('exc IMPORT_GUEST$EXC - update_guest(:update_guest_id=>' || coalesce(:guest_id, '<null>') || ')');

--    DISABLE age/is_child merge (RIU rating cases) 
--    if (:age is null) then begin
--      select age from GUEST_AGE_CALC(:guest_id)
--      into :age;
--    end
  end

  /*
  execute procedure sys_dbg('exc IMPORT_GUEST$EXC->GUEST_ADDRESSCARD_SET$RSV('
  || 'update_guest_id => ' || coalesce(:update_guest_id, '<null>')
  || ', guest_name => ' || coalesce(:guest_name, '<null>')
  || ', arrival => ' || coalesce(:arrival, '<null>')
  || ', departure => ' || coalesce(:departure, '<null>')
  || ', voucher_date => ' || coalesce(:voucher_date, '<null>')
  || ', :id_passport_type => ' || coalesce(:id_passport_type, '<null>')
  || ', :pass_num => ' || coalesce(:pass_num, '<null>')
  || ', :pass_date => ' || coalesce(:pass_date, '<null>')
  || ', :egn => ' || coalesce(:egn_old, '<null>')
  || ', :country => ' || coalesce(:country_old, '<null>')
  || ', :id_stay_reason => ' || coalesce(:id_stay_reason, '<null>')
  || ', :is_registred => ' || coalesce(:is_registred, '<null>')
  || ', :pass_place => ' || coalesce(:pass_place, '<null>')
  || ', :city => ' || coalesce(:city, '<null>')
  || ', :address => ' || coalesce(:address, '<null>')
  || ', :birth_place => ' || coalesce(:birth_place, '<null>')
  || ', :sex => ' || coalesce(:sex, '<null>')
  || ', :mask => ' || coalesce(:mask, '<null>')
  || ', :is_child => ' || coalesce(:is_child, '<null>')
  || ', :car => ' || coalesce(:car, '<null>')
  || ', :kpp => ' || coalesce(:kpp_old, '<null>')
  || ', :kpp_date => ' || coalesce(:kpp_date, '<null>')
  || ', :pass_exp_date => ' || coalesce(:pass_exp_date, '<null>')
  || ', :age => ' || coalesce(:age, '<null>')
  || ', :birth_date => ' || coalesce(:birth_date, '<null>')
  || ', :rating_age => ' || coalesce(:rating_age, '<null>')
  || ', :title => ' || coalesce(:title, '<null>')
  ||')');
  */
  execute procedure GUEST_ADDRESSCARD_SET$RSV(
    :guest_id,
    :guest_name,
    null,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :personal_number,
    :country_code,
    :id_stay_reason,
    :is_registred,
    :pass_place,
    :city,
    :address,
    :birth_place,
    :sex,
    :mask,
    :is_child,
    :car,
    :kpp_id,
    :kpp_date,
    :pass_exp_date,
    :age,
    :birth_date,
    :visa,
    :rating_age,
    :title,
    0
  )
  returning_values :err_code, :err_text, :warn_code;
  if (0 <> :err_code) then exit;

  --execute procedure RES_GUEST_SAVE_ORGANIZER$RSV(:guest_id, :is_different_arranger);

  if ((:arrival is not null) and (:departure is not null)) then begin
    execute procedure RES_GUEST_SAVE_STAY$RSV(:guest_id, :arrival, :departure)
    returning_values :err_code, :err_text, :warn_code;
    if (0 <> :err_code) then exit;
  end

  if (:voucher is not null) then begin
    execute procedure RES_GUEST_SAVE_VOUCHER$RSV(:guest_id, :voucher,
            :voucher_date, :voucher_text, null, null);
  end

  execute procedure IMPORT_GUEST_PACK$EXC(:guest_id, :package);

  update GUEST
  set    ORPHANED_IMPORT$EXC = null
  where  id_guest=:guest_id;
end
^

/* empty dependent procedure body */
/* Clear: EAI_IMPORT_ALOYALTY_CLIENT for: IMPORT_PERSON_PROFILE$EXC */
ALTER PROCEDURE EAI_IMPORT_ALOYALTY_CLIENT(CLIENT_UUID VARCHAR(40),
CLIENT_NAME VARCHAR(100),
CARD_CODE VARCHAR(50),
IS_ARHIVE SMALLINT,
DATE_OF_BIRTH DATE)
 AS
 BEGIN EXIT; END
^

/* Alter (IMPORT_PERSON_PROFILE$EXC) */
ALTER PROCEDURE IMPORT_PERSON_PROFILE$EXC(PROFILE_UUID VARCHAR(40),
PROFILE_NAME VARCHAR(100),
SEX CHAR,
BIRTH_DATE DATE,
BIRTH_PLACE VARCHAR(30),
PERSONAL_NUMBER VARCHAR(30),
PASS_NUM VARCHAR(20),
PASS_DATE DATE,
PASS_PLACE VARCHAR(20),
PASS_EXP_DATE DATE,
PASS_CITY VARCHAR(100),
PASS_ADDRESS VARCHAR(100),
PASS_TYPE_NAME VARCHAR(100),
PASS_TYPE_EXTERNAL_CODE VARCHAR(50),
COUNTRY VARCHAR(10),
MASK VARCHAR(10),
PHONE VARCHAR(50),
FAX VARCHAR(50),
EMAIL VARCHAR(50),
CITY VARCHAR(100),
ADDRESS VARCHAR(100),
MARKET_SEGMENT VARCHAR(30),
NOTE VARCHAR(255),
IS_ARCHIVE SMALLINT,
CARD_CODE VARCHAR(50),
WBE_PASSWORD VARCHAR(20),
TITLE VARCHAR(10),
ACCOUNT_NO VARCHAR(20),
MSG VARCHAR(2000),
GUEST_TYPE_NAME VARCHAR(30),
PICTURE BLOB,
PICTURE_TYPE VARCHAR(50),
PICTURE_LAYOUT VARCHAR(50),
DEF_CONTRAGENT_NAME VARCHAR(100),
MERGE_TARGET_UUID VARCHAR(40),
HOTEL_UUID_LIST VARCHAR(1000))
 RETURNS(PROFILE_ID INTEGER,
IMPORT_TIME TIMESTAMP)
 AS
declare variable op varchar(10);
  declare variable market_segment_id integer;
  declare variable sex_old char(1);
  declare variable birth_date_old date;
  declare variable birth_place_old varchar(30);
  declare variable personal_number_old varchar(30);
  declare variable pass_num_old varchar(20);
  declare variable pass_date_old date;
  declare variable pass_place_old varchar(20);
  declare variable pass_exp_date_old date;
  declare variable pass_city_old varchar(100);
  declare variable pass_address_old varchar(100);
  declare variable country_old varchar(10);
  declare variable mask_old varchar(10);
  declare variable title_old varchar(10);
  declare variable id_photo integer;
  declare variable id_def_contragent integer;
  declare variable id_passport_type integer;
  declare variable account_no_old varchar(20);
  declare variable msg_old varchar(2000);
  declare variable id_guest_type integer;
  declare variable id_guest_type_old integer;
  declare variable card_code_old varchar(50);
  declare variable is_exclusive_debt_ownership smallint;
  declare variable profile_receiver_id integer;
begin
  profile_id = null;
  import_time = null;

  execute procedure import_mark_transaction$exc;

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC(:profile_uuid=>' || coalesce(:profile_uuid, '<null>')
                          || ', email=>' || coalesce(:email, '<null>') || ')');

  profile_id = null;
  if (profile_uuid is null) then begin
    execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC <null> :profile_uuid - exit;');
    exit;
  end

  select p.profile_id, p.profile_name, p.phone, p.fax, p.email, p.city,
         p.address, p.market_segment, p.note, p.is_archive, pp.card_code,
         pd.sex, pd.birthday_internal, pd.birth_place, pd.egn, pd.pass_num,
         pd.pass_date, pd.pass_place, pd.pass_exp_date, pd.city, pd.address, pd.country_code,
         pd.mask, p.id_def_contragent, p.wbe_password,
         pd.title, p.account_no, p.msg, pp.id_guest_type, pp.id_photo, pd.id_passport_type,
         p.is_exclusive_debt_ownership
  from   import_common_profile$exc(:profile_uuid, 0, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :wbe_password, :ACCOUNT_NO, :MSG, 'PERSON_PROFILE', :HOTEL_UUID_LIST) p
         left outer join profile_person pp on pp.id_profile = p.profile_id
         left outer join person_data pd on pd.id_person_data=pp.id_person_data
  into   :profile_id, :profile_name, :phone, :fax, :email, :city,
         :address, :market_segment, :note, :is_archive, :card_code_old,
         :sex_old, :birth_date_old, :birth_place_old, :personal_number_old, :pass_num_old,
         :pass_date_old, :pass_place_old, :pass_exp_date_old, :pass_city_old, :pass_address_old, :country_old,
         :mask_old, :id_def_contragent, :wbe_password, :title_old,
         :account_no_old, :msg_old, :id_guest_type_old, :id_photo, :id_passport_type, :is_exclusive_debt_ownership;

  if (:profile_id is null) then begin
    op = 'add';
  end else if (:hotel_uuid_list is null) then begin
    profile_id = null;
    exit;
  end else begin
    op = 'mod';
    delete from PROFILE_BONUSPOINT_SCHEME bs
      where bs.ID_PROFILE = :profile_id;
  end

  sex=coalesce(:sex, :sex_old);
  birth_date=coalesce(:birth_date, :birth_date_old);
  birth_place=coalesce(:birth_place, :birth_place_old);
  personal_number=coalesce(:personal_number, :personal_number_old);
  pass_num=coalesce(:pass_num, :pass_num_old);
  pass_date=coalesce(:pass_date, :pass_date_old);
  pass_place=coalesce(:pass_place, :pass_place_old);
  pass_exp_date=coalesce(:pass_exp_date, :pass_exp_date_old);
  pass_city=coalesce(:pass_city, :pass_city_old);
  pass_address=coalesce(:pass_address, :pass_address_old);
  country=upper(coalesce(:country, :country_old));
  mask=coalesce(:mask, :mask_old);
  title=coalesce(:title, :title_old);
  account_no=coalesce(:account_no, :account_no_old);
  msg=coalesce(:msg, :msg_old);
  card_code=coalesce(:card_code, :card_code_old);

  execute procedure IMPORT_PASSPORT_TYPE$EXC(:pass_type_name, :pass_type_external_code)
  returning_values :id_passport_type;

  execute procedure lookup_market_segment$exc(:profile_name, 'PERSON_PROFILE', :market_segment)
  returning_values :market_segment_id;

  if (guest_type_name is not null) then begin
    execute procedure lookup_guest_type$exc(:profile_name, 'PERSON_PROFILE', :guest_type_name)
    returning_values :id_guest_type;
  end

  if ((def_contragent_name is not null) and (def_contragent_name <> '')) then begin
    execute procedure LOOKUP_CONTRAGENT$EXC(:profile_name, 'PERSON_PROFILE', :def_contragent_name)
    returning_values :id_def_contragent;
  end

  execute procedure CHECK_LOOKUP_ERRORS$EXC(:profile_name, 'PERSON_PROFILE');

  id_guest_type=coalesce(:id_guest_type, :id_guest_type_old);

  if (id_photo is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, null, null, null, 'del')
    returning_values :id_photo;
  end
  id_photo = null;
  if (picture is not null) then begin
    execute procedure PICTURE_MODIFY (:id_photo, :picture, :picture_type, :picture_layout, 'add')
    returning_values :id_photo;
  end

  execute procedure sys_dbg('exc IMPORT_PERSON_PROFILE$EXC - profile_person_modify$profile(:profile_uuid=>'
    || coalesce(:profile_uuid, '<null>')
    || ', :operation=>' || coalesce(:op, '<null>')
    || ', :email=>' || coalesce(:email, '<null>')
    || ', :birth_date=>' || coalesce(:birth_date, '<null>')
  || ')');
  execute procedure profile_person_modify$profile(
    :profile_id,
    :id_guest_type,
    :profile_name,
    null,
    :sex,
    :birth_date,
    :birth_place,
    :personal_number,
    :id_passport_type,
    :pass_num,
    :pass_date,
    :pass_place,
    :pass_exp_date,
    :country,
    :pass_city,
    :pass_address,
    :mask,
    :phone,
    :fax,
    :email,
    :city,
    :address,
    :note,
    :msg,
    :id_def_contragent,
    :market_segment_id,
    :is_archive,
    :id_photo,
    :card_code,
    :wbe_password,
    :op,
    :account_no,
    :title,
    :is_exclusive_debt_ownership
  ) returning_values
    :profile_id;

  /*assign uuid to the new profiles*/
  if ('add' = :op) then begin
    update profile set uuid=:profile_uuid where id_profile=:profile_id;
  end

  select record_timestamp from profile where id_profile=:profile_id
  into :import_time;

  if (:MERGE_TARGET_UUID is not null) then begin
    select p.ID_PROFILE
    from   PROFILE P
    where  P.UUID = :MERGE_TARGET_UUID
    into   :profile_receiver_id;

    execute procedure PROFILE_MERGE$PROFILE (:PROFILE_ID, :profile_receiver_id, 'merge');

  end

end
^

/* Alter (OCCUPANCY_SUMMARY_REMAKE$SYS) */
ALTER PROCEDURE OCCUPANCY_SUMMARY_REMAKE$SYS(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 AS
begin
  if (not exists (select h.ID_HOTEL
                  from   HOTEL H
                  where  h.ID_HOTEL = :ID_HOTEL)) then exception WRONG_VALUE 'Non-existing hotel!';

  select mindate(sd.SYSTEM_DATE - 1, :TO_DATE)
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :TO_DATE;

  if (:FROM_DATE > :TO_DATE) then exit;

  execute procedure SUMMARY_OCCUPANCY_STATISTIC$INT(:id_hotel, :FROM_DATE, :TO_DATE);

  execute procedure SYSTEM_LOG_ADD ('HOTEL', :id_hotel, 'OCCUPANCY_REGENERATE',
                                    f_character(29) || formatdate(:from_date, 'D;dd/mm/yyyy') || f_character(28) || formatdate(:to_date, 'D;dd/mm/yyyy'));
end
^

/* Alter (RES_CHECKIN$RSV) */
ALTER PROCEDURE RES_CHECKIN$RSV(ID_RESERV_DETAIL INTEGER,
ID_ROOM INTEGER = null,
TAR_OPTION VARCHAR(50) = null)
 RETURNS(SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
SHARE_TRANSACTION_ID INTEGER,
WARN_CODE INTEGER)
 AS
declare variable old_check_status integer;
  declare variable rd_dbkey char(8);
  declare variable old_id_room integer;
  declare variable action_text varchar(255);
  declare variable id_hotel integer;
  declare variable is_anul integer;
  declare variable arrival_date date;
  declare variable system_date date;
begin
  /*  Description:
  ||
  */
  select RD.CHECK_STATUS, RD.RDB$DB_KEY, RD.FROM_DATE, RD.ID_HOTEL,
         RD.ID_ROOM, RD.IS_ANUL
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :old_check_status, :rd_dbkey, :arrival_date, :id_hotel,
         :old_id_room, :is_anul;

  if (:is_anul = 1) then exception BOOKING_EXCEPTION '-2';

  if (:old_check_status >= 0) then exception BOOKING_EXCEPTION '-1003';

  if (:old_id_room < 0 and coalesce(:ID_ROOM, 0) <= 0) then exception BOOKING_EXCEPTION '-1018';

  execute procedure SYSTEM_DATE_GET(:id_hotel)
  returning_values  :system_date;

  if (:system_date < :arrival_date) then begin
    execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_CHECK_IN_FUTURE');
  end
  /*----*/
  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'lock');

  execute procedure sys_dbg('occ RES_CHECKIN$RSV id_room = '||coalesce(:id_room, 'null'));
  execute procedure sys_dbg('occ RES_CHECKIN$RSV old_id_room = '||coalesce(:old_id_room, 'null'));

  if (:id_room is not null) then begin
    if (:old_check_status = -3) then begin
      execute procedure RES_SAVE_STATUS$INT(:rd_dbkey, -2);
    end

    execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, :id_room, null, :tar_option)
    returning_values (:WARN_CODE);
  end

  execute procedure RES_SET_CHECKIN$INT (:rd_dbkey)
  returning_values  :SHARE_ERR_CODE, :err_text, :share_transaction_id, :warn_code;

  execute procedure SYSTEM_LOCK_OBJECT(:id_reserv_detail, 'RESERV', 'checkin', 'release');
  /*----*/
  select f_character(29) || R.ROOM_NAME
  from   ROOMS R
  where  R.ID_ROOM = coalesce(:ID_ROOM, :old_id_room)
  into   :action_text;
   
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'CHECK_IN', :action_text);

end
^

/* Alter (RES_CHECKIN_MULTI$RSV) */
ALTER PROCEDURE RES_CHECKIN_MULTI$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable dbg varchar(2000);
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable checkin_count integer;
  declare variable split_on_checkin integer;
  declare variable id_titular integer;
  declare variable id_splited_reservation integer;
  declare variable id_guest integer;
  declare variable tmp_warn_code integer;
begin
  checkin_count = 0;
  warn_code = null;
  for
    select RD.ID_RESERV_DETAIL, RD.CHECK_STATUS, RD.SPLIT_ON_CHECKIN, RD.ID_TITULAR
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :SELECTION_ID
    into   :id_reserv_detail, :check_status, :split_on_checkin, :id_titular
  do begin
    if (:check_status >= 0) then begin
      checkin_count = :checkin_count + 1;
    end else begin
      if (:split_on_checkin = 1) then begin
        for
          select G.ID_GUEST
          from   GUEST G
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and G.ID_GUEST <> :id_titular
          into   :id_guest
        do begin
          execute procedure RES_SPLIT$RSV(:id_reserv_detail, :id_guest)
          returning_values  :id_splited_reservation;

          execute procedure RES_CHECKIN$RSV (:id_splited_reservation)
          returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
          WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

          update RESERV_DETAIL RD
          set    RD.SELECTION_ID = :selection_id
          where  RD.ID_RESERV_DETAIL = :id_splited_reservation;
        end
      end

      execute procedure RES_CHECKIN$RSV (:id_reserv_detail)
      returning_values  :dbg, :dbg, :dbg, :tmp_warn_code;
      WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);

      update RESERV_DETAIL RD
      set    RD.SELECTION_ID = :selection_id
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
    end
  end

  if (:checkin_count > 0) then begin
    execute procedure SYSTEM_WARNING_ADD(-1011, f_character(29)||:checkin_count)
    returning_values  :warn_code;
  end
end
^

/* Alter (RES_CREATE_SET$EXC) */
ALTER PROCEDURE RES_CREATE_SET$EXC(ID_RESERV_DETAIL INTEGER,
RES_NUMBER VARCHAR(62),
ID_AGENT_PROFILE INTEGER,
ID_PERSON_PROFILE INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILD_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_ROOM INTEGER,
ID_BOARD INTEGER,
ID_TARIFF INTEGER,
CUSTOM_PRICE NUMERIC(15,4),
CUSTOM_CURRENCY CHAR(3),
VOUCHER_NUM VARCHAR(30),
VOUCHER_DATE DATE,
VOUCHER_TEXT VARCHAR(30),
VOUCHER2_NUM VARCHAR(30),
VOUCHER2_DATE DATE,
TRANSFER_IN_TIME TIME,
TRANSFER_IN_NOTE VARCHAR(255),
TRANSFER_OUT_TIME TIME,
TRANSFER_OUT_NOTE VARCHAR(255),
COMMING_KIND INTEGER,
IS_LATE_DEPARTURE INTEGER,
IS_VIP INTEGER,
CODE_FIRST_FOOD TYPE OF TFOOD_CODE,
I_SPECIAL_TREATMENT VARCHAR(250),
ID_NOM_MARKET_SEGMENT INTEGER,
ID_NOM_SOURCE_CODE INTEGER,
ID_NOM_CHANNEL_CODE INTEGER,
ID_NOM_HEAR_REASON INTEGER,
ID_NOM_COME_REASON INTEGER,
ID_AGENT_ACCOUNT INTEGER,
ACC_ROUTING VARCHAR(50),
ID_PERSON_PAYMENT INTEGER,
ID_AGENT_PAYMENT INTEGER,
ID_CREDIT_CARD INTEGER,
ROOM_FEATURES BLOB SUB_TYPE 1,
ID_HK_PLAN INTEGER,
NOTE VARCHAR(2000),
NOTE_REMINDERS VARCHAR(50),
GUARANTEE_DEPOSIT NUMERIC(15,4),
GUARANTEE_CURRENCY CHAR(3),
ID_HOTEL INTEGER,
ID_GROUP INTEGER,
ID_GUARANTEE_POLICY INTEGER,
BLOCK_CC VARCHAR(255),
GUARANTEE_DEPOSIT_PERCENT NUMERIC(15,4),
GUARANTEE_DEPOSIT_NIGHTS INTEGER,
GUARANTEE_DUE_DAYS_BEF_ARRIVAL INTEGER,
GUARANTEE_DUE_DAYS_AFTER_CREATE INTEGER,
MINIBAR_RIGHTS VARCHAR(50),
PAYTV_RIGHTS VARCHAR(50),
VIDEO_RIGHTS VARCHAR(50),
NOPOST_PMS VARCHAR(50),
PHONE_RIGHTS VARCHAR(50),
SEMINAR_CAHNNEL_RIGHTS VARCHAR(50),
POSTING_TRANSACTION_UUID VARCHAR(40),
ID_EATING_OBJECT INTEGER,
CREATE_DATETIME TIMESTAMP)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_ID_RESERV_DETAIL INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  WARN_CODE = 0;
  SHARE_TRANSACTION_ID = 0;
  SHARE_ERR_CODE = 0;

  execute procedure sys_dbg('exc RES_CREATE_SET$EXC => RES_CREATE_SET$INT('
  || 'code_first_food=>' || coalesce(:code_first_food, '<null>')
  || ', id_person_payment=>' || coalesce(:id_person_payment, '<null>')
  || ')');

  execute procedure RES_CREATE_SET$INT(:id_agent_profile, :id_person_profile, null, :arrival_date, :departure_date,
                    :adult_count, :child_count, :id_room_type, :id_room, :id_board, :id_tariff, null,
                    :custom_price, :custom_currency, :voucher_num, :voucher_date, :voucher_text, :voucher2_num,
                    :voucher2_date, :transfer_in_time, :transfer_in_note, :transfer_out_time, :transfer_out_note,
                    :comming_kind, :is_late_departure, :is_vip, '', :code_first_food, :i_special_treatment,
                    :id_nom_market_segment, :id_nom_source_code, :id_nom_channel_code, :id_nom_hear_reason,
                    :id_nom_come_reason, :id_agent_account, :acc_routing, :id_person_payment, :id_agent_payment,
                    :room_features, :id_hk_plan, :id_group, :id_hotel, :note, :note_reminders, :guarantee_deposit,
                    :guarantee_currency, 0, :id_reserv_detail, :res_number, null,  :id_guarantee_policy, :block_cc,
                    :id_eating_object)
  returning_values  :rd_dbkey, :new_id_reserv_detail, :warn_code;

  execute procedure UPDATE_POSTING_TRANSACTION$EXC(:rd_dbkey, :posting_transaction_uuid, 1);

  execute procedure RES_SAVE_GUARANTEE$RSV(:id_reserv_detail, :is_vip, null,
    :id_guarantee_policy, :guarantee_deposit, :guarantee_currency, :block_cc, :guarantee_deposit_percent,
    :guarantee_deposit_nights, :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create
  );

  execute procedure RESERV_DETAIL_EXTERNAL_MOD$RSV(:id_reserv_detail,
    :minibar_rights, :paytv_rights, :video_rights, :nopost_pms, :phone_rights,
    :seminar_cahnnel_rights, null
  );

  if (:create_datetime is not null) then begin
    update reserv_detail set create_datetime = :create_datetime where rdb$db_key = :rd_dbkey;
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_DELETE$RSV for: RES_DELETE$INT */
ALTER PROCEDURE RES_DELETE$RSV(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT,
NEW_FROM_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RESGRP_DELETE$RSV for: RES_DELETE$INT */
ALTER PROCEDURE RESGRP_DELETE$RSV(ID_GROUP INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_DELETE$INT) */
ALTER PROCEDURE RES_DELETE$INT(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable rd_dbkey char(8);
  declare variable id_guest integer;
  declare variable action_text varchar(255);
  declare variable from_date date;
  declare variable to_date date;
  declare variable room_type varchar(20);
  declare variable number varchar(62);
  declare variable tmp_extra_posts_left integer;
begin

  execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_DELETE');

  select RD.RDB$DB_KEY, RD.FROM_DATE, rd.TO_DATE, RT.TYPE_ROOM, rd.NUMBER
  from   RESERV_DETAIL RD
         left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = RD.ID_ROOM_TYPE
  where  RD.ID_RESERV_DETAIL = :ID_RESERV_DETAIL
  into   :rd_dbkey, :from_date, :to_date, :room_type, :number;

  update RESERV_DETAIL R
  set    r.ID_TITULAR = null
  where  r.RDB$DB_KEY = :rd_dbkey;

  EXTRA_POSTS_LEFT = 0;
  for
    select G.ID_GUEST
    from   GUEST G
    where  G.ID_RESERV_DETAIL = :id_reserv_detail
    into   :id_guest
  do begin
    execute procedure RES_GUEST_DEL$INT(:id_guest, :id_reserv_detail, :REASON)
    returning_values  :tmp_extra_posts_left;
    EXTRA_POSTS_LEFT = iif(:EXTRA_POSTS_LEFT = 1, 1, :tmp_extra_posts_left);
  end

  execute procedure RES_FINALIZE$INT (:RD_DBKEY, 1)
  returning_values (:warn_code);


  execute procedure RES_ARCHIVATE_ACCOUNTS$INT(:id_reserv_detail);

  action_text = f_character(29) || coalesce(:number, '')
                || f_character(28) || coalesce(:room_type, '')
                || f_character(28) || :from_date
                || f_character(28) || :to_date
                || f_character(28) || :reason;
  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'DELETE', :action_text);

  delete from RESERV_DETAIL RDD
  where  RDD.RDB$DB_KEY = :rd_dbkey;

  delete from XML_MESSAGE$EXC xml
  where  xml.OBJECT_TYPE = 'BOOKING'
         and xml.OBJECT_ID = :number;

end
^

/* Alter (RES_DELETE$RSV) */
ALTER PROCEDURE RES_DELETE$RSV(ID_RESERV_DETAIL INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT,
NEW_FROM_DATE TYPE OF TDATE)
 AS
begin

  execute procedure RES_DELETE$INT(:ID_RESERV_DETAIL, :REASON)
  returning_values :WARN_CODE, :EXTRA_POSTS_LEFT;

  select cast('31.12.1899' as date) + count(r.ID_RESERV_DETAIL)
  from   RESERV_DETAIL r
  where  r.ID_RESERV_DETAIL is not null
  into   :NEW_FROM_DATE;
end
^

/* Alter (RES_EARLY_DEPARTURE_SET$RSV) */
ALTER PROCEDURE RES_EARLY_DEPARTURE_SET$RSV(SELECTION_ID INTEGER,
CHECK_OUT_KIND INTEGER)
 RETURNS(RECALC_MARKER_LIST VARCHAR(255),
WARN_CODE INTEGER)
 AS
declare variable sys_date date;
  declare variable stay integer;
  declare variable rd_dbkey char(8);
  declare variable id_reserv_detail integer;
  declare variable id_hotel integer;
  declare variable hotels_cnt integer;
  declare variable arrival_date date;
  declare variable is_late_departure smallint;
  declare variable comming_kind smallint;
  declare variable dep_date date;
begin
  /* CHECK_OUT_kind =
  || 1 - DO NOT MODIFY GUEST
  || 2 - SHRINK PERIOD AND OCCUPANCY
  || 3 - DO NOT MODIFY GUEST PERIOD BUT FREE OCCUPANCY
  */
  execute procedure RIGHTS_CHECK_GRANTED$INT('CHECK_OUT_EARLY');

  select min(RD.ID_HOTEL), count(distinct RD.ID_HOTEL)
  from   RESERV_DETAIL RD
  where  RD.SELECTION_ID = :SELECTION_ID
  into   :id_hotel, :hotels_cnt;

  if (:hotels_cnt > 1) then exception RESERV_CHECK_OUT_EXCEPTION '-1020';

  execute procedure SYSTEM_DATE_GET (:id_hotel)
  returning_values  :sys_date;

  RECALC_MARKER_LIST = null;
  for
    select RD.RDB$DB_KEY, RD.ID_RESERV_DETAIL, rd.FROM_DATE, rd.TO_DATE, RD.LEAVING_KIND - 1, rd.COMMING_KIND
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
    into   :rd_dbkey, :id_reserv_detail, :arrival_date, :dep_date, :is_late_departure, :comming_kind
  do begin
    if ((:check_out_kind = 2) and (:dep_date > :sys_date)) then begin
      -- SHRINK PERIOD AND OCCUPANCY
      execute procedure RES_SAVE_STAY$INT(:rd_dbkey, :arrival_date, :sys_date, :is_late_departure, :comming_kind);
    
      execute procedure RES_FINALIZE$INT(:rd_dbkey)
      returning_values  :warn_code;
    end else if ((:check_out_kind = 1) and (:dep_date > :sys_date)) then begin
      /* KEEP BOOKING STAY PERIOD AND ROOM OCCUPANCY */
      for
        select G.TO_DATE - :sys_date
        from   GUEST G
        where  G.ID_RESERV_DETAIL = :id_reserv_detail
        into   :stay
      do begin
  --      if (:check_out_kind = 1) then begin
        if (:stay > 1) then begin
            --THE DEPARTURE DATE IS LATER THAN NEXT DATE. STAY SHOULD BE CHANGED MANUALY.;
            exception RESERV_CHECK_OUT_EXCEPTION '-323';
        end
      end
    end
  end
end
^

/* empty dependent procedure body */
/* Clear: RES_SAVE_FINALIZE$RSV for: RES_GUEST_FINALIZE$RSV */
ALTER PROCEDURE RES_SAVE_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_RESERV_DATE /* TYPE OF TDATE */ DATE)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_GUEST_FINALIZE$RSV) */
ALTER PROCEDURE RES_GUEST_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER,
ALL_ERRORS_ARE_INSTANT INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
begin
  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  update RESERV_DETAIL RD
  set    rd.ROOM_PRICE = null
  where  RD.RDB$DB_KEY = :rd_dbkey;

  execute procedure RES_GUEST_SAVE_DIFF$INT(:rd_dbkey);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, iif (:all_errors_are_instant = 1, 0, 1))
  returning_values  :warn_code;

end
^

/* empty dependent procedure body */
/* Clear: RES_FINALIZE_RECALC$INT for: RES_RECALC$INT */
ALTER PROCEDURE RES_FINALIZE_RECALC$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_RECALC$RSV for: RES_RECALC$INT */
ALTER PROCEDURE RES_RECALC$RSV(ID_RESERV_DETAIL INTEGER,
FORCE_POSTING SMALLINT = null)
 AS
 BEGIN EXIT; END
^

/* Alter (RES_RECALC$INT) */
ALTER PROCEDURE RES_RECALC$INT(RD_DBKEY CHAR(8),
CALLER_KIND VARCHAR(20),
FORCE_POSTING SMALLINT = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_guest integer;
declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable num_prefix varchar(20);
  declare variable number_1 varchar(20);
begin
  /* CALLER_KIND = {NORMAL, FORCED} */
  err_code = 0;
  /* 1. GET DATA */
  select RD.CHECK_STATUS, RD.ID_RESERV_DETAIL, rd.NUMBER_1
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :check_status, :id_reserv_detail, :number_1;

  if (:check_status = 1) then begin
    -- CHECKED OUT
    select sn.LEADING_PART
    from   SYSTEM_NUMERATOR SN
    where  sn.ID_NUMERATOR = 0
    into   :num_prefix;

    if (trim('.' from coalesce(:num_prefix, '')) = coalesce(:number_1, '')) then
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_MINE');
    else
      execute procedure RIGHTS_CHECK_GRANTED$INT('RESERV_MOD_CHECKEDOUT_ELSE');

    for
      select g.ID_GUEST
      from   GUEST G
      where  G.ID_RESERV_DETAIL = :id_reserv_detail
      into   :id_guest
    do begin
      execute procedure SYSTEM_LOG_ADD ('GUEST', :id_guest, 'MANUAL_EDIT_DATA', '');
    end
  end
  /* 2. FIND DEPENDANT GUESTS AND THEIR TARIFFS */
  --execute procedure sys_dbg('calc RES_RECALC$INT id_reserv_detail = '||coalesce(:id_reserv_detail, 'null'));

  ID_TAR_CALC = gen_id(gen_id_tar_calc, 1);
  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NONE');

  -- 3. UPDATE ROOM PRICE and REPOST ALL AFFECTED BOOKINGS
  execute procedure RES_TAR_CALC_FINALIZE$INT (:ID_TAR_CALC, :CALLER_KIND, :FORCE_POSTING)
  returning_values (:ERR_CODE, :ERR_TEXT);
end
^

/* Alter (RES_RECALC$RSV) */
ALTER PROCEDURE RES_RECALC$RSV(ID_RESERV_DETAIL INTEGER,
FORCE_POSTING SMALLINT = null)
 AS
declare variable id_tar_calc integer;
declare variable err_text varchar(255);
  declare variable err_code integer;
  declare variable rd_dbkey char(8);
begin
  -- FORCED, user activated recalculation
  execute procedure RIGHTS_CHECK_GRANTED$INT ('GUEST_RECALC_POST');

  select RD.RDB$DB_KEY
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey;

  execute procedure RES_RECALC$INT(:rd_dbkey, 'FORCED', :FORCE_POSTING)
  returning_values  :err_code, :err_text, :id_tar_calc;
  if (:err_code < 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || coalesce(:err_text, '');

  execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :ID_RESERV_DETAIL, 'FORCED_RECALC', null);

end
^

/* empty dependent procedure body */
/* Clear: RES_ROOM_REMOVE$RSV for: RES_ROOM_REMOVE$INT */
ALTER PROCEDURE RES_ROOM_REMOVE$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (RES_ROOM_REMOVE$INT) */
ALTER PROCEDURE RES_ROOM_REMOVE$INT(RD_DBKEY CHAR(8))
 RETURNS(WARN_CODE INTEGER)
 AS
begin

  execute procedure RES_SAVE_ROOM$INT(:rd_dbkey, gen_id(DETAIL_WITHOUT_ROOMING_LIST, -1), null, 'nrttAsIs')
  returning_values (:WARN_CODE);

  execute procedure RES_FINALIZE$INT(:rd_dbkey, 0)
  returning_values  :WARN_CODE;

end
^

/* Alter (RES_ROOM_REMOVE$RSV) */
ALTER PROCEDURE RES_ROOM_REMOVE$RSV(SELECTION_ID INTEGER)
 RETURNS(WARN_CODE INTEGER)
 AS
declare variable rd_dbkey char(8);
  declare variable tmp_warn_code integer;
begin

  warn_code = null;

  for
    select RD.RDB$DB_KEY
    from   RESERV_DETAIL RD
    where  RD.SELECTION_ID = :selection_id
           and RD.IS_ANUL = 0
    into   :rd_dbkey
  do begin
    execute procedure RES_ROOM_REMOVE$INT (:rd_dbkey)
    returning_values (:tmp_warn_code);
    WARN_CODE = coalesce(:WARN_CODE, :tmp_warn_code);
  end

end
^

/* Alter (RES_SAVE_FINALIZE$RSV) */
ALTER PROCEDURE RES_SAVE_FINALIZE$RSV(ID_RESERV_DETAIL INTEGER)
 RETURNS(SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
NEW_RESERV_DATE TYPE OF TDATE)
 AS
declare variable rd_dbkey char(8);
  declare variable busy_group_source integer;
  declare variable res_edit_status varchar(255);
  declare variable err_code integer;
  declare variable tmp_err_text varchar(255);
  declare variable id_hotel integer;
begin
  execute procedure sys_dbg('occ RES_SAVE_FINALIZE$RSV enter');

  select RD.RDB$DB_KEY, iif(RD.CHECK_STATUS = 1, 24, 1), rd.RES_EDIT_STATUS, rd.ID_HOTEL
  from   RESERV_DETAIL RD
  where  RD.ID_RESERV_DETAIL = :id_reserv_detail
  into   :rd_dbkey, :busy_group_source, :res_edit_status, :id_hotel;

  if (:res_edit_status containing 'ADDGUEST') then begin
    execute procedure RES_GUEST_FINALIZE$RSV (:ID_RESERV_DETAIL, 0)
    returning_values (:warn_code);
  end

  execute procedure OCCUPANCY_ROOMS_CHECK$INT(:rd_dbkey, :busy_group_source)
  returning_values  :share_err_code, :err_text, :share_transaction_id, :WARN_CODE;
  --if (:share_err_code <> 0) then err_code = 0;      -- offer share entering
  --if (:share_err_code = 1) then share_err_code = 0; -- all shares are known

  execute procedure sys_dbg('occup RES_SAVE_FINALIZE$RSV share_err_code = '||coalesce(:share_err_code, 'null'));

  execute procedure RES_FINALIZE_CLEAR$INT(:rd_dbkey, :id_reserv_detail);

  delete from RESERV_STAY$TMP t
  where  t.id_session = RDB$GET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION');

  RDB$SET_CONTEXT('USER_TRANSACTION', 'OCCUPANCY_CHANGE_TRANSACTION', null);  -- Excplicitly set to null !!!

  err_code = 0;
  select first 1 RE.ERR_CODE, RE.ERR_TEXT
  from   RESERV_ERROR RE
  where  RE.ID_RESERV_DETAIL = :id_reserv_detail
  into   :err_code, :tmp_err_text;

  if (:err_code <> 0) then exception BOOKING_EXCEPTION :err_code || f_character(31) || :tmp_err_text;

  select sd.SYSTEM_DATE
  from   SYSTEM_DATE_GET (:id_hotel) sd
  into   :NEW_RESERV_DATE;
end
^

/* Alter (RES_SAVE_ROOM$EXC) */
ALTER PROCEDURE RES_SAVE_ROOM$EXC(RD_DBKEY CHAR(8),
ID_RES_ROOM_TYPE INTEGER,
ID_HK_PLAN INTEGER,
ROOM_FEATURES BLOB,
I_SPECIAL_TREATMENT VARCHAR(250),
SPLIT_ON_CHECKIN SMALLINT)
 RETURNS(ERR_TEXT VARCHAR(255),
WARN_CODE INTEGER,
SHARE_TRANSACTION_ID INTEGER,
SHARE_ERR_CODE INTEGER)
 AS
declare variable id_reserv_detail integer;
  declare variable old_id_room integer;
begin
  select RD.ID_ROOM, RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.RDB$DB_KEY = :rd_dbkey
  into   :old_id_room, :id_reserv_detail;

  execute procedure RES_SAVE_ROOM$RSV(
    :id_reserv_detail,
    :old_id_room,
    :id_res_room_type,
    'nrttAsIs',
    1,
    :id_hk_plan,
    :room_features,
    :i_special_treatment,
    :split_on_checkin,
    0
  ) returning_values :share_err_code, :err_text, :share_transaction_id, :warn_code;
end
^

/* Alter (RESERV_STATISTIC_CANCELED$INT) */
ALTER PROCEDURE RESERV_STATISTIC_CANCELED$INT(ID_HOTEL INTEGER,
FROM_DATE DATE,
TO_DATE DATE)
 RETURNS(BUSY_DATE DATE,
ID_ROOM_TYPE INTEGER,
ID_PROFILE_AGENT INTEGER,
COUNTRY_CODE VARCHAR(20),
MARKET_SEGMENT_CODE VARCHAR(3),
SOURCE_CODE VARCHAR(3),
CHANNEL_CODE VARCHAR(3),
HEAR_REASON_CODE VARCHAR(3),
COME_REASON_CODE VARCHAR(3),
ROOMS_NOSHOW SMALLINT,
GUESTS_NOSHOW SMALLINT,
ROOMS_CANCELED SMALLINT)
 AS
begin
  -- {NOSHOW, CANCELED, USERERROR}
  for
    select P.OUT_DATE, RD.ID_ROOM_TYPE, S.ID_PROFILE_AGENT, coalesce(RD.COUNTRY, ''),
           S.MARKET_SEGMENT_CODE, S.SOURCE_CODE, S.CHANNEL_CODE, S.HEAR_REASON_CODE, S.COME_REASON_CODE,
           count(distinct iif(RD.REASON_OF_ANUL = 'NOSHOW', RD.ID_ROOM, null)),
           sum(iif(RD.REASON_OF_ANUL = 'NOSHOW', RD.ADULT_COUNT + RD.CHILD_COUNT, 0)),
           count(distinct iif(RD.REASON_OF_ANUL = 'CANCELED', RD.ID_ROOM, null))
    from   RESERV_DETAIL RD
           left outer join RESERV_STATISTIC_SLICE$INT(RD.ID_RESERV_DETAIL) S on 0=0
           left outer join SYSTEM_LOOP_PERIOD(maxdate(:from_date, RD.FROM_DATE), mindate(:to_date, RD.TO_DATE-1)) P on 0=0
    where  RD.ID_HOTEL = :id_hotel
           and RD.FROM_DATE <= :to_date
           and RD.TO_DATE > :from_date
           and RD.IS_ANUL = 1
           and RD.REASON_OF_ANUL in ('NOSHOW', 'CANCELED')
    group by 1, 2, 3, 4, 5, 6, 7, 8, 9
    into   :busy_date, :id_room_type, :id_profile_agent, :country_code,
           :market_segment_code, :source_code, :channel_code, :hear_reason_code, :come_reason_code,
           :rooms_noshow,
           :guests_noshow,
           :rooms_canceled
  do begin
    suspend;
  end
end
^

/* Alter (RESGRP_DELETE$RSV) */
ALTER PROCEDURE RESGRP_DELETE$RSV(ID_GROUP INTEGER,
REASON VARCHAR(50))
 RETURNS(WARN_CODE INTEGER,
EXTRA_POSTS_LEFT SMALLINT)
 AS
declare variable id_reserv_detail integer;
  declare variable tmp_warn_code integer;
begin

  for
    select RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
           left outer join ROOM_TYPES RT on RT.ID_ROOM_TYPE = rd.ID_ROOM_TYPE
    where  RD.ID_GROUP = :id_group
    into   :id_reserv_detail
  do begin
    execute procedure RES_DELETE$INT(:id_reserv_detail, :REASON)
    returning_values :tmp_warn_code, :extra_posts_left;
    if (:warn_code is null) then WARN_CODE = :tmp_warn_code;
  end
end
^

/* empty dependent procedure body */
/* Clear: PRODUCT_RATING$INT for: TAR_CALC_EVAL_ALL$INT */
ALTER PROCEDURE PRODUCT_RATING$INT(ID_HOTEL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
ADULT_AGES VARCHAR(100) = null,
CHILD_AGES VARCHAR(100) = null,
ID_TAR_CALC_COMMON INTEGER = null)
 RETURNS(ROOM_PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: RES_TAR_CALC_FINALIZE$INT for: TAR_CALC_EVAL_ALL$INT */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(ID_TAR_CALC INTEGER,
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
 BEGIN SUSPEND; END
^

/* empty dependent procedure body */
/* Clear: TAR_TEST$TAR for: TAR_CALC_EVAL_ALL$INT */
ALTER PROCEDURE TAR_TEST$TAR(NUMBER VARCHAR(62),
ID_TAR_HEAD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
 BEGIN SUSPEND; END
^

/* Alter (TAR_CALC_EVAL_ALL$INT) */
ALTER PROCEDURE TAR_CALC_EVAL_ALL$INT(ID_TAR_CALC INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable room_status varchar(20);
  declare variable from_date date;
  declare variable to_date date;
  declare variable idate date;
  declare variable is_static integer;
  declare variable id_tar_input integer;
  declare variable id_type_stay integer;
  declare variable separate_board integer;
  declare variable id_board_include integer;
  declare variable id_tar_head integer;
  declare variable is_manual_type_stay smallint;
  declare variable seasson_name varchar(50);
begin
  err_code = 0;

  delete from TAR_CALC_OUTPUT$TMP TCO where TCO.ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP TCV where TCV.ID_TAR_CALC = :id_tar_calc;

  execute procedure TAR_CALC_INIT_VARS$INT(:id_tar_calc);

  for
    select TCI.ROOM_STATUS, min(TCI.FROM_DATE_CALC), max(TCI.TO_DATE_CALC), min(TCI.IS_STATIC)
    from   TAR_CALC_INPUT$TMP TCI
    where  TCI.ID_TAR_CALC = :id_tar_calc
    group by TCI.ROOM_STATUS
    into   :room_status, :from_date, :to_date, :is_static
  do begin
    for
      select RLP.OUT_DATE
      from   SYSTEM_LOOP_PERIOD(:from_date, :to_date) RLP
      into   :idate
    do begin
      if ((:is_static = 1) and (:idate > :from_date)) then begin
        insert into TAR_CALC_OUTPUT$TMP (ID_TAR_INPUT, ID_TAR_CALC, ID_SERVICE, SERVICE_TYPE,
               FOR_DATE, PRICE, CURRENCY, PRICE_TARIFF, CURRENCY_TARIFF, PRICE_NOTE, QTY_POST,
               PTEXT, DISC_TAG, ID_DISCOUNT_SERVICE, REQUIRED_ID_PACKET_ITEM)
        select tco.ID_TAR_INPUT, tco.ID_TAR_CALC, tco.ID_SERVICE, tco.SERVICE_TYPE,
               :idate, PRICE, tco.CURRENCY, tco.PRICE_TARIFF, tco.CURRENCY_TARIFF, tco.PRICE_NOTE, tco.QTY_POST,
               tco.PTEXT, tco.DISC_TAG, tco.ID_DISCOUNT_SERVICE, tco.REQUIRED_ID_PACKET_ITEM
        from   TAR_CALC_OUTPUT$TMP TCO
        where  TCO.FOR_DATE = :from_date
               and TCO.ID_TAR_CALC = :id_tar_calc;
        for
          select TCID.ID_TAR_INPUT, TCID.ID_TYPE_STAY, TCID.SEPARATE_BOARD, TCID.ID_BOARD_INCLUDE,
                 TCID.IS_MANUAL_TYPE_STAY, TCID.ID_TAR_HEAD
          from   TAR_CALC_INPUT_DETAIL$TMP TCID
                 join TAR_CALC_INPUT$TMP TCI on TCI.ID_TAR_INPUT = TCID.ID_TAR_INPUT
          where  TCID.FOR_DATE = :from_date
                 and TCI.ID_TAR_CALC = :id_tar_calc
          into   :id_tar_input, :id_type_stay, :separate_board, :id_board_include,
                 :is_manual_type_stay, :id_tar_head
        do begin
          seasson_name = null;
          select tp.SEASON_NAME
          from   TARIFA_GET_PERIOD_FOR_DATE (:id_tar_head, :idate) tp
          into   :seasson_name;
          if (:seasson_name is null) then begin
            ERR_CODE = -231;
            ERR_TEXT = '';
            exit;
          end

          update TAR_CALC_INPUT_DETAIL$TMP TCID
          set    TCID.ID_TYPE_STAY = :id_type_stay,
                 TCID.IS_MANUAL_TYPE_STAY = :is_manual_type_stay,
                 TCID.SEPARATE_BOARD = :separate_board,
                 TCID.ID_BOARD_INCLUDE = :id_board_include
          where  TCID.ID_TAR_INPUT = :id_tar_input;
        end
      end else begin
        execute procedure TAR_CALC_EVAL_DATE$INT(:id_tar_calc, :room_status, :idate)
        returning_values  :err_code, :err_text;
        if (:err_code < 0) then exit;
      end
    end
  end

  execute procedure TAR_CALC_EVAL_ZERO$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  if (:err_code is null) then begin
    err_code = -230; /*WRONG INPUT PARAMS - MISSING GUESTS*/
    err_text = 'Missing input data for calculation';
    exit;
  end

  execute procedure TAR_CALC_EVAL_PERIOD$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;

  execute procedure TAR_CALC_CHECK_PACKETS$INT (:ID_TAR_CALC)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;
end
^

/* Alter (TAR_TEST$TAR) */
ALTER PROCEDURE TAR_TEST$TAR(NUMBER VARCHAR(62),
ID_TAR_HEAD INTEGER)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255),
ID_TAR_CALC INTEGER)
 AS
declare variable id_reserv_detail integer;
begin
  id_tar_calc = -1 * :id_tar_head;
  delete from TAR_CALC_OUTPUT$TMP where id_tar_calc = :id_tar_calc;
  delete from TAR_CALC_INPUT$TMP  where id_tar_calc = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP  where id_tar_calc = :id_tar_calc;

  err_code = 0;

  id_reserv_detail = null;
  select RD.ID_RESERV_DETAIL
  from   RESERV_DETAIL RD
  where  RD.NUMBER = :number
         and rd.IS_ANUL = 0
  into   :id_reserv_detail;

  if (:id_reserv_detail is null) then begin
    select first 1 RD.ID_RESERV_DETAIL
    from   RESERV_DETAIL RD
    where  RD.NUMBER_2 = :number
           and rd.IS_ANUL = 0
    into   :id_reserv_detail;
  end

  execute procedure TAR_CALC_INPUT_RESERV$INT (:id_reserv_detail, :ID_TAR_CALC, 'NEW_ROOM', :ID_TAR_HEAD);

  execute procedure TAR_CALC_EVAL_ALL$INT(:id_tar_calc)
  returning_values  :err_code, :err_text;
  if (:err_code < 0) then exit;
end
^

/* Alter (TEST_BOOKING_IMPORT) */
ALTER PROCEDURE TEST_BOOKING_IMPORT AS
declare variable dbg varchar(255);
  declare variable booking_id integer;
begin
  dbg = null;
  EXECUTE PROCEDURE IMPORT_BOOKING$EXC ('SOL NESSEBAR BAY', 'EXP.3', null, null, 0,
  cast('17.11.2008' as date), null, cast('19.11.2008' as date),
  null, null, null, null, null, 'LARGE_ROOM', 'BB', null, null, '????????', 'MIXED', 'EXPEDIA-BAY',
  null, null, null, null, '?????? ??????', null, null, null, null, 'Business - Corporate',
  'Companies (FIR)', 'E-Mail (EMA)', 'Advert (ANZ)', 'Activities (ANI)', 'A room with a view.(4)',
  null, null, 2, 2, 'e43a4cc0-7d73-47cc-bd07-a98c18c714a3', null, '0D074F966A187B2A9912B5F0E213FEB4',
  0, 0, 0, null, null, null, null, null, null, null, null, null, null,  null, null, null, null, null, null, null, null)
  returning_values (:dbg, :booking_id, :dbg, :dbg);
  dbg = null;
end
^

/* Restore proc. body: CREATE_BOOKING$WBE */
ALTER PROCEDURE CREATE_BOOKING$WBE(PRODUCT_SELECTION_ID BIGINT,
ARANGER_PROFILE_ID INTEGER,
NUMBER VARCHAR(62))
 RETURNS(BOOKING_ID INTEGER,
NUMBER_2 VARCHAR(62))
 AS
declare variable rate varchar(50);
declare variable room_type varchar(20);
declare variable arrival date;
declare variable departure date;
declare variable adults integer;
declare variable children integer;
declare variable profile_name varchar(100);
declare variable aranger_name varchar(100);
declare variable guest_profile_uuid varchar(40);
declare variable aranger_profile_uuid varchar(40);
declare variable hotel_name varchar(50);
declare variable wbe_session_id bigint;
declare variable main_guest_profile_id integer;
declare variable board varchar(50);
declare variable hotel_id integer;
declare variable guarantee_policy_name varchar(50);
declare variable guarantee_deposit_percent numeric(15,4);
declare variable guarantee_deposit_nights integer;
declare variable guarantee_due_days_bef_arrival integer;
declare variable guarantee_due_days_after_create integer;
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable profile_type varchar(20);
declare variable profile_import_time timestamp;
declare variable b_count integer;
declare variable age integer;
declare variable is_child smallint;
declare variable guest_id integer;
declare variable special_treatment varchar(250);
declare variable maintenance varchar(30);
declare variable routing varchar(20);
declare variable arranger_paymeny_type varchar(20);
declare variable market_segment varchar(30);
declare variable market_source varchar(30);
declare variable market_channel varchar(30);
declare variable market_hear_reason varchar(30);
declare variable market_come_reason varchar(30);
declare variable first_food varchar(30);
declare variable bnote varchar(2000);
begin
  -- get wbe product selection
  select  PA.rate_name,PA.room_name, AQ.first_date, AQ.first_date+AQ.day_count,
          PS.adults, PS.children, PS.person_name, H.hotel_name, H.id_hotel,
          WS.id, PA.board_name, GP.name, GP.deposit_totalsum_part, GP.deposit_nights_count, GP.due_days_before_arrival, GP.due_days_after_create,
          PS.bnote
   from   PRODUCT_SELECTION$WBE PS
          join WBE_SESSION$WBE WS on WS.id = PS.wbe_session_id
          join PRODUCT_AVAILABILITY$WBE PA on pa.id = PS.product_availability_id
          join AVAILABILITY_QUERY$WBE AQ on aq.id = WS.product_query_id
          join HOTEL H on H.id_hotel = WS.hotel_id
          join GUARANTEE_POLICY GP on GP.id_guarantee_policy = PS.guarantee_policy_id
   where  PS.id = :product_selection_id
   into   :rate, :room_type, :arrival, :departure,
          :adults,  :children, :profile_name, :hotel_name, :hotel_id,
          :wbe_session_id, :board, :guarantee_policy_name,
          :guarantee_deposit_percent, :guarantee_deposit_nights,
          :guarantee_due_days_bef_arrival, :guarantee_due_days_after_create,
          :bnote;

  select PA.uuid , PA.profile_name, PA.profile_type
  from   PROFILE PA
  where  PA.id_profile = :aranger_profile_id
  into   :aranger_profile_uuid,:aranger_name,  :profile_type;

  if (:aranger_name = :profile_name and :profile_type = 'PERSON') then begin
    -- aranger is main guest
    select count(*)
    from   PRODUCT_SELECTION$WBE PSC
    where  PSC.wbe_session_id = :wbe_session_id
    into   :b_count;
       -- only if single reservation bugfix 2228
    if (1 = :b_count) then begin
     guest_profile_uuid =  aranger_profile_uuid;
     aranger_profile_uuid = null;
    end
  end else begin
    -- create profile for main guest
    execute procedure IMPORT_PERSON_PROFILE$EXC(
      uuid_create(),:profile_name,null,null,null,null,null,null,null,null,null,null, null,
      null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
      null,null,null,null,null, null, null)
    returning_values :main_guest_profile_id, :profile_import_time;

    select P.uuid
    from   PROFILE P
    where  P.id_profile = :main_guest_profile_id
    into   :guest_profile_uuid;
  end

    -- apply default map + forced arranger
    special_treatment = null;
    maintenance = null;
    routing = null;
    arranger_paymeny_type = null;
    market_segment = null;
    market_source = null;
    market_channel = null;
    market_hear_reason = null;
    market_come_reason = null;


  select hc.special_treatment, hk.plan_name, hc.routing,
         pt.payment_type, ms.segment_name, sc.description, cc.description,
         hr.description, cr.description, hc.first_food
  from   HOTEL_PRODUCT_CFG$WBE hc
         left join HK_PLAN hk on hk.id_plan = hc.id_hk_plan
         left join PAYMENT_TYPE pt on pt.id_payment_type = hc.arranger_id_payment_type
         left join NOM_MARKET_SEGMENTS ms on ms.id_nom_market_segment = hc.id_m_segment
         left join NOM_SOURCE_CODES sc on sc.id_nom_source_code = hc.id_m_source
         left join NOM_CHANNEL_CODES cc on cc.id_nom_channel_code = hc.id_m_channel
         left join NOM_HEAR_REASONS hr on hr.id_nom_hear_reason = hc.id_m_hear_reason
         left join NOM_COME_REASONS cr on cr.id_nom_come_reason = hc.id_m_come_reason
  where  hc.hotel_id = :hotel_id
  into   :special_treatment,:maintenance,:routing,:arranger_paymeny_type,
         :market_segment,:market_source,:market_channel,:market_hear_reason,:market_come_reason,:first_food;
  -- create reseravation
  execute procedure IMPORT_BOOKING$EXC(
     :hotel_name, :number, null, null, 0,
     :arrival, null, :departure, null, null, null, null, null, :room_type, :board, null,
     :special_treatment, :maintenance, :routing, :rate, null, null, null, null, :arranger_paymeny_type, null, null, null, null,
     :market_segment, :market_source,:market_channel, :market_hear_reason, :market_come_reason,
     :bnote, null, :first_food, :adults, :children, :aranger_profile_uuid, null, :guest_profile_uuid,
     0, 0, null, :guarantee_policy_name, null, :guarantee_deposit_percent, :guarantee_deposit_nights,
     :guarantee_due_days_bef_arrival,  :guarantee_due_days_after_create, null, null, null, null,  null, null, null, null, null, null, null, null)
  returning_values
     :hotel_id, :booking_id, :err_code, err_text;
  if (0 <> :err_code) then exception WRONG_VALUE ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');

  -- import guests
  for
    select psg.guest_name, psg.is_child, psg.age
    from   PRODUCT_SELECTION_GUESTS$WBE psg
    where  psg.product_selection_id = :product_selection_id
    into   :profile_name,:is_child,:age
  do begin
    execute procedure IMPORT_GUEST$EXC(:booking_id, null, null, :profile_name, :is_child, :age, null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null)
    returning_values :guest_id, :err_code,:err_text;
    if (0 <> :err_code) then exception WRONG_VALUE ':err_code=>' || coalesce(:err_code, '<null>') || ', :err_text=>' || coalesce(:err_text, '<null>');
  end
  ----------------

  select RD.number_2
  from   RESERV_DETAIL RD
  where  RD.id_reserv_detail = :booking_id
  into   :number_2;

  update PRODUCT_SELECTION$WBE uPS
  set    uPS.booking_id = :booking_id, uPS.selection_id = :number_2
  where  uPS.id = :product_selection_id;
end
^

/* Restore proc. body: CREATE_SESSION_BOOKINGS$WBE */
ALTER PROCEDURE CREATE_SESSION_BOOKINGS$WBE(WBE_SESSION_ID BIGINT,
ARANGER_ID INTEGER,
LANG_CODE VARCHAR(3))
 RETURNS(SELECTION_ID VARCHAR(20),
ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable product_selection_id bigint;
declare variable next_num integer;
declare variable sel_cnt integer;
declare variable aranger_name varchar(100);
declare variable aranger_email varchar(50);
declare variable aranger_phone varchar(50);
declare variable booking_id integer;
declare variable record_timestamp timestamp;
declare variable new_res_number varchar(62);
declare variable room_types_src varchar(255) = '';
declare variable rates_src varchar(255) = '';
declare variable hotel_id integer;
declare variable profile_id integer;
declare variable from_date date;
declare variable to_date date;
declare variable day_count integer;
declare variable room_type_id integer;
declare variable rate_id integer;
declare variable query_id_tmp integer;
declare variable rooms_required integer;
declare variable rooms_available integer;
declare variable profile_import_time timestamp;
begin
  execute procedure EXPORT_LOG_FORCE$EXC(1);
  /* test overbook (multiuser) */
   for select ws.hotel_id,ws.profile,aq.first_date,(aq.first_date+aq.day_count)-1,pa.room_type_id,pa.rate_id,aq.day_count
    from   PRODUCT_availability$WBE PA
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    join availability_query$wbe aq on aq.id = pa.query_id
   where ws.id = :wbe_session_id and coalesce(pa.room_count,0) > 0
   into  :hotel_id, :profile_id, :from_date, :to_date, :room_type_id, :rate_id , :day_count
   do begin
       room_types_src = :room_types_src||','||cast(:room_type_id as varchar(10));
       rates_src = :rates_src||','||cast(rate_id as varchar(10));
   end

   query_id_tmp = GEN_ID(AVAILABILITY_QUERY$WBE_SEQ,1);
   insert into availability_query$wbe(ID, WBE_SESSION_ID, FIRST_DATE, DAY_COUNT)    -- prevent FK exception
    values (:query_id_tmp,:wbe_session_id,:from_date,:day_count) ;

   execute procedure availability_occup_small$wbe(:from_date,:to_date,:hotel_id,:query_id_tmp,1,:rates_src,:room_types_src) ;

   --  check minimum available rooms for every day
   err_code = null;
   err_text = '';
   for select pa.room_type_id,pa.room_count,
    (select coalesce(min(art.available_rooms),0) from availability_room_type$wbe art
      where art.query_id = :query_id_tmp and art.room_type_id = pa.room_type_id)
    from product_availability$wbe pa
    join wbe_session$wbe ws on ws.product_query_id = pa.query_id
    where ws.id = :wbe_session_id
    and coalesce(pa.room_count,0) > 0   into :room_type_id,:rooms_required,:rooms_available
   do begin
       if (rooms_required > rooms_available) then
       begin
        err_code = 1;
        ERR_TEXT = coalesce(ERR_TEXT,'')||:room_type_id||';';
       end
   end
   delete from availability_query$wbe aqt where aqt.id = :query_id_tmp;       -- remove temp query
   if (err_code is not null) then exit;

  /* create profile if not exist and reservations > 1*/
  if (aranger_id is NULL) then
  begin
    select WS.person_name,WS.address,WS.phone
    from   WBE_SESSION$WBE WS
    where  WS.id = :wbe_session_id
    into   :aranger_name,:aranger_email,:aranger_phone;

    execute procedure IMPORT_PERSON_PROFILE$EXC(
       uuid_create(),:aranger_name,null,null,null,null,null,null,null,null,null,null,
       null,null,null,null,:aranger_phone,null,:aranger_email,null,null,null,null,null,null,
       STRHASH_LARGE(substring(uuid_create() from 1 for 4)),null,null,null,null,null,null,null,null, null, null)
    returning_values :aranger_id, :profile_import_time;

    update WBE_SESSION$WBE uWS
    set    uWS.profile = :aranger_id
    where  uWS.id = :wbe_session_id;
  end else begin
    -- da podmeni email, phone ako !!
  end
  /* create reservations */
  for
    select PS.id
    from   PRODUCT_SELECTION$WBE PS
    where  PS.wbe_session_id = :wbe_session_id
           and PS.booking_id is null
           and coalesce(PS.is_deleted,0) <> 1
    into   :product_selection_id
  do begin
     if (next_num = 1) then begin      -- increment first reservation number_3
      execute procedure res_number_suffix_gen(:booking_id) returning_values :new_res_number;
      next_num = next_num + 1;
     end
     execute procedure CREATE_BOOKING$WBE(:product_selection_id,:aranger_id,'WBE.'||:selection_id||'.'||:next_num) returning_values :booking_id,:selection_id;
     execute procedure IMPORT_BOOKING_FINALIZE$EXC(:booking_id) returning_values  record_timestamp,:err_code,:err_text;
     insert into SCHEDULER$WBE(booking_id,status,last_action_time,lang_code,guarantee_passed) values (:booking_id, NULL, current_timestamp, :lang_code,0);

     if (next_num is NULL) then begin
      next_num = 1;
     end else begin
      next_num = next_num + 1;
     end
  end
end
^

/* Restore proc. body: EAI_IMPORT_ALOYALTY_CLIENT */
ALTER PROCEDURE EAI_IMPORT_ALOYALTY_CLIENT(CLIENT_UUID VARCHAR(40),
CLIENT_NAME VARCHAR(100),
CARD_CODE VARCHAR(50),
IS_ARHIVE SMALLINT,
DATE_OF_BIRTH DATE)
 AS
declare variable PROFILE_ID integer;
  declare variable IMPORT_TIME timestamp;
begin
  execute procedure IMPORT_PERSON_PROFILE$EXC(:CLIENT_UUID, :CLIENT_NAME, null, :DATE_OF_BIRTH, null, null,
    null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null,
    :IS_ARHIVE, :CARD_CODE, null, null, null, null, null, null, null, null, null, null, 'null-uuid')
  returning_values :PROFILE_ID, :IMPORT_TIME;
end
^

/* Restore proc. body: PRODUCT_RATING$INT */
ALTER PROCEDURE PRODUCT_RATING$INT(ID_HOTEL INTEGER,
ARRIVAL_DATE DATE,
DEPARTURE_DATE DATE,
ADULT_COUNT INTEGER,
CHILDREN_COUNT INTEGER,
ID_ROOM_TYPE INTEGER,
ID_BOARD INTEGER,
ID_RATE INTEGER,
ADULT_AGES VARCHAR(100) = null,
CHILD_AGES VARCHAR(100) = null,
ID_TAR_CALC_COMMON INTEGER = null)
 RETURNS(ROOM_PRICE NUMERIC(15,4),
PRICE_CURRENCY CHAR(3),
ROOM_PRICE_DETAILS VARCHAR(100))
 AS
declare variable err_code integer;
declare variable err_text varchar(255);
declare variable id_reserv integer;
declare variable id_tar_calc integer;
declare variable rate_currency char(3);
begin
  id_tar_calc = null;
  select T.CURR
  from   TARIFA T
  where  t.ID_TARIFA = :ID_RATE
  into   :rate_currency;

  execute procedure TAR_CALC_INPUT_PLAIN$INT (:adult_count, :children_count,
          :id_room_type, :id_board, :arrival_date, :departure_date,
          '', '', null, '', null, null, :id_rate, :adult_ages, :child_ages, :ID_TAR_CALC_COMMON)
  returning_values (:id_tar_calc, :id_reserv, :err_code, :err_text);
  --if (:err_code < 0) then exit;

  if (:err_code = 0) then begin
    execute procedure TAR_CALC_EVAL_ALL$INT(:id_tar_calc)
    returning_values  :err_code, :err_text;
    /*savedbg('-----------------------------');
    savedbg('id_rate: ' || :id_rate);
    savedbg('id_board: ' || :id_board);
    savedbg('id_room_type: ' || :id_room_type);
    savedbg('id_tar_calc: ' || :id_tar_calc);
    savedbg('err_code: ' || :ERR_CODE);
    savedbg('err_text: ' || :ERR_TEXT);
    */
    if (:err_code = 0) then begin
      execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

      price_currency = :rate_currency;
      execute procedure TAR_CALC_GET_PRICE$INT (:id_tar_calc, :id_hotel, :id_reserv, :price_currency)
      returning_values  :room_price, :room_price_details;
    end
  end
end
^

/* Restore proc. body: RES_FINALIZE_RECALC$INT */
ALTER PROCEDURE RES_FINALIZE_RECALC$INT(RD_DBKEY CHAR(8))
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable id_tar_calc integer;
begin
  -- NORMAL recalculation processing
  execute procedure RES_RECALC$INT(:rd_dbkey, 'NORMAL', 0)
  returning_values  :err_code, :err_text, :id_tar_calc;
  if (:err_code < 0) then exit;

end
^

/* Restore proc. body: RES_TAR_CALC_FINALIZE$INT */
ALTER PROCEDURE RES_TAR_CALC_FINALIZE$INT(ID_TAR_CALC INTEGER,
CALLER_KIND VARCHAR(20),
FORCE_POSTING INTEGER = null)
 RETURNS(ERR_CODE INTEGER,
ERR_TEXT VARCHAR(255))
 AS
declare variable room_price numeric(15,4);
  declare variable room_currency char(3);
declare variable old_room_price numeric(15,4);
  declare variable old_room_currency char(3);
  declare variable room_price_details varchar(100);
  declare variable id_hotel integer;
  declare variable id_reserv_detail integer;
  declare variable check_status integer;
  declare variable is_posting_stopped smallint;
  declare variable has_postings smallint;
  declare variable is_anul smallint;
  declare variable reserv_posting_disabled smallint;
  declare variable postings_disabled smallint;
  declare variable warn_code integer;
  declare variable action_text varchar(255);
  declare variable id_guest integer;
begin
  --  Razpiswa cenata na staia, kakto i price_detailite.

  execute procedure TAR_CALC_EVAL_ALL$INT(:ID_TAR_CALC)
  returning_values  :ERR_CODE, :ERR_TEXT;

  if (:ERR_CODE = 0) then execute procedure TAR_CALC_POST_PREPARE$INT(:id_tar_calc);

  select iif(si.INFO_VALUE = '1', 1, null)
  from   SYSTEM_INFO_GET('RESERV_POSTINGS_DISABLED') si
  into   :postings_disabled;

  for
    select rd.ID_RESERV_DETAIL, rd.CHECK_STATUS, coalesce(:postings_disabled, rd.IS_POSTING_STOPPED),
           coalesce(RD.CUSTOM_CURRENCY, T.CURR), RD.ID_HOTEL, rd.IS_ANUL,
           coalesce(max((select first 1 AP.IS_BASE
                         from   GUEST G
                                join ACCOUNT_POST AP on ap.ID_GUEST = g.ID_GUEST
                         where  g.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                and ap.IS_BASE = 1)), 0)   -- booking is not checked in, but postings already exists (it`s possible)
    from   TAR_CALC_INPUT$TMP TI
           join RESERV_DETAIL RD on RD.ID_RESERV_DETAIL = ti.ID_RESERV
           join TARIFA t on t.ID_TARIFA = rd.ID_RATE
    where  ti.ID_TAR_CALC = :ID_TAR_CALC
    group by 1, 2, 3, 4, 5, 6
    into   :id_reserv_detail, :check_status, :is_posting_stopped,
           :room_currency, :id_hotel, :is_anul, :has_postings
  do begin
    reserv_posting_disabled = iif(:is_posting_stopped = 1 and :has_postings = 0, 1, 0);

    if (:ERR_CODE <> 0) then begin
      -- price calculation error handling  !!!!!
      if (:reserv_posting_disabled = 1) then begin
        -- set price to null, posting is disabled
        update RESERV_DETAIL RD
        set    RD.ROOM_PRICE = null,
               RD.ROOM_CURRENCY = null,
               RD.ROOM_PRICE_DETAILS = null,
               RD.LAST_ID_TAR_CALC = null
        where  RD.ID_RESERV_DETAIL = :id_reserv_detail;
      end else begin
        -- exit on error in price calculation - cannot make valid posts
        EXIT;
      end
    end else begin
      room_price = 0;
      room_price_details = '';
    
      execute procedure TAR_CALC_GET_PRICE$INT (:ID_TAR_CALC, :id_hotel, :id_reserv_detail, :room_currency)
      returning_values (:room_price, :room_price_details);
  
      if (:reserv_posting_disabled = 0 and ((coalesce(:FORCE_POSTING, 0) = 1) or (:check_status >= 0) or (:has_postings = 1))) then begin
        if (:check_status < 0 and :has_postings = 0) then begin
          execute procedure RIGHTS_CHECK_GRANTED$INT('POST_ON_EXPECTED_BOOKING');
        end
    
        execute procedure RES_TAR_CALC_REPOST$INT(:id_tar_calc, :id_reserv_detail, :caller_kind||'RECALC_'||:id_tar_calc);
      end else begin
        delete from RESERV_PREPOST
        where  ID_RESERV_DETAIL = :id_reserv_detail;
  
        if (:is_anul = 0) then begin
          insert into RESERV_PREPOST(ID_RESERV_DETAIL, ID_GUEST, DATE_POST, QTY_POST,
                 PRICE_ORIG, CURR_ORIG, ID_SERVICE, IS_BASE, ID_TAR_CALC)
          select g.id_reserv_detail, g.id_guest, tcp.date_post, tcp.qty_post,
                 tcp.price_orig, tcp.curr_orig, tcp.id_service, tcp.is_base, tcp.id_tar_calc
          from   TAR_CALC_POST$TMP TCP
                 join GUEST G on G.ID_GUEST = TCP.ID_GUEST
          where  G.ID_RESERV_DETAIL = :id_reserv_detail
                 and tcp.ID_TAR_CALC = :ID_TAR_CALC;
        end
      end
  
      update RESERV_DETAIL RD
      set    RD.ROOM_PRICE = :room_price,
             RD.ROOM_CURRENCY = :room_currency,
             RD.ROOM_PRICE_DETAILS = :room_price_details,
             RD.LAST_ID_TAR_CALC = :id_tar_calc,
             rd.ROOM_PRICE_LAST$INT = null,
             rd.ROOM_CURRENCY_LAST$INT = null
      where  RD.ID_RESERV_DETAIL = :id_reserv_detail
      returning old.ROOM_PRICE_LAST$INT, old.ROOM_CURRENCY_LAST$INT
      into :old_room_price, :old_room_currency;

      if ((:old_room_price is distinct from :room_price)
          or (:old_room_currency is distinct from :room_currency) ) then
      begin
        action_text = f_character(29) || formatfloat(:old_room_price, 'F;0.00') || ' ' || coalesce(:old_room_currency, '') || f_character(28) || formatfloat(:room_price, 'F;0.00') || ' ' || coalesce(:room_currency, '');
        execute procedure SYSTEM_LOG_ADD ('RES_DETAIL', :id_reserv_detail, 'RES_PRICE_RECALC', :action_text);

        if (:check_status >= 0) then begin
          for
            select g.ID_GUEST
            from   GUEST G
            where  g.ID_RESERV_DETAIL = :id_reserv_detail
            into   :id_guest
          do begin
            execute procedure GUEST_REGISTRATION_UPDATE(:id_guest);
          end
        end
      end
    end
  end

  delete from TAR_CALC_INPUT$TMP where ID_TAR_CALC = :id_tar_calc;
  delete from TAR_CALC_VAR$TMP where ID_TAR_CALC = :id_tar_calc;

  if (:ERR_CODE <> 0) then begin
    execute procedure SYSTEM_WARNING_ADD(:ERR_CODE, :ERR_TEXT)
    returning_values :warn_code;
    ERR_CODE = 0;
    ERR_TEXT='';
  end
end
^

SET TERM ; ^

ALTER TABLE GUEST ALTER COLUMN ID_GUEST POSITION 1;

ALTER TABLE GUEST ALTER COLUMN ID_RESERV_DETAIL POSITION 2;

ALTER TABLE GUEST ALTER COLUMN ID_BASE_ACCOUNT POSITION 3;

ALTER TABLE GUEST ALTER COLUMN ID_ACCOUNT POSITION 4;

ALTER TABLE GUEST ALTER COLUMN FROM_DATE POSITION 5;

ALTER TABLE GUEST ALTER COLUMN TO_DATE POSITION 6;

ALTER TABLE GUEST ALTER COLUMN ID_ROOM POSITION 7;

ALTER TABLE GUEST ALTER COLUMN ID_AGENT POSITION 8;

ALTER TABLE GUEST ALTER COLUMN ID_AGENT_AGES POSITION 9;

ALTER TABLE GUEST ALTER COLUMN IS_DIFFERENT_ORGANIZER POSITION 10;

ALTER TABLE GUEST ALTER COLUMN ID_TARIFA POSITION 11;

ALTER TABLE GUEST ALTER COLUMN FROM_TIME POSITION 12;

ALTER TABLE GUEST ALTER COLUMN TO_TIME POSITION 13;

ALTER TABLE GUEST ALTER COLUMN CODE_FIRST_FOOD POSITION 14;

ALTER TABLE GUEST ALTER COLUMN FIRST_FOOD_ORDER POSITION 15;

ALTER TABLE GUEST ALTER COLUMN IS_CHILD POSITION 16;

ALTER TABLE GUEST ALTER COLUMN OLD_FROM_DATE POSITION 17;

ALTER TABLE GUEST ALTER COLUMN OLD_TO_DATE POSITION 18;

ALTER TABLE GUEST ALTER COLUMN OLD_ID_ROOM POSITION 19;

ALTER TABLE GUEST ALTER COLUMN VAUCHER_DATE POSITION 20;

ALTER TABLE GUEST ALTER COLUMN VAUCHER_NUM POSITION 21;

ALTER TABLE GUEST ALTER COLUMN VAUCHER_TEXT POSITION 22;

ALTER TABLE GUEST ALTER COLUMN VAUCHER_NUM2 POSITION 23;

ALTER TABLE GUEST ALTER COLUMN VAUCHER_DATE2 POSITION 24;

ALTER TABLE GUEST ALTER COLUMN CHECK_STATUS POSITION 25;

ALTER TABLE GUEST ALTER COLUMN REG_NUMBER POSITION 26;

ALTER TABLE GUEST ALTER COLUMN TT_REG_NUMBER POSITION 27;

ALTER TABLE GUEST ALTER COLUMN IS_CHECK_IN POSITION 28;

ALTER TABLE GUEST ALTER COLUMN TRANSFER_IN_TIME POSITION 29;

ALTER TABLE GUEST ALTER COLUMN TRANSFER_IN_NOTE POSITION 30;

ALTER TABLE GUEST ALTER COLUMN IS_CHECK_OUT POSITION 31;

ALTER TABLE GUEST ALTER COLUMN TRANSFER_OUT_TIME POSITION 32;

ALTER TABLE GUEST ALTER COLUMN TRANSFER_OUT_NOTE POSITION 33;

ALTER TABLE GUEST ALTER COLUMN EARLYCHECKOUT_DATE POSITION 34;

ALTER TABLE GUEST ALTER COLUMN GUEST_EDIT_STATUS POSITION 35;

ALTER TABLE GUEST ALTER COLUMN UUID POSITION 36;

ALTER TABLE GUEST ALTER COLUMN SUBSCRIBER_ID POSITION 37;

ALTER TABLE GUEST ALTER COLUMN ORPHANED_IMPORT$EXC POSITION 38;

ALTER TABLE GUEST ALTER COLUMN IS_ANONYMOUS POSITION 39;

ALTER TABLE GUEST ALTER COLUMN ID_HOTEL POSITION 40;

ALTER TABLE GUEST ALTER COLUMN CHECKED_IN_AT POSITION 41;

ALTER TABLE GUEST_DATA ALTER COLUMN ID_GUEST POSITION 1;

ALTER TABLE GUEST_DATA ALTER COLUMN ID_PERSON_DATA POSITION 2;

ALTER TABLE GUEST_DATA ALTER COLUMN GUEST_CODE POSITION 3;

ALTER TABLE GUEST_DATA ALTER COLUMN STAY_NOTE POSITION 4;

ALTER TABLE GUEST_DATA ALTER COLUMN KPP POSITION 5;

ALTER TABLE GUEST_DATA ALTER COLUMN KPP_DATE POSITION 6;

ALTER TABLE GUEST_DATA ALTER COLUMN IS_REGISTRED POSITION 7;

ALTER TABLE GUEST_DATA ALTER COLUMN USER_REGISTRED POSITION 8;

ALTER TABLE GUEST_DATA ALTER COLUMN USER_CHANGE_REGISTRED POSITION 9;

ALTER TABLE GUEST_DATA ALTER COLUMN CAR POSITION 10;

ALTER TABLE GUEST_DATA ALTER COLUMN ID_NOM_MARKET_SEGMENT POSITION 11;

ALTER TABLE GUEST_DATA ALTER COLUMN ID_NOM_SOURCE_CODE POSITION 12;

ALTER TABLE GUEST_DATA ALTER COLUMN ID_NOM_CHANNEL_CODE POSITION 13;

ALTER TABLE GUEST_DATA ALTER COLUMN ID_NOM_HEAR_REASON POSITION 14;

ALTER TABLE GUEST_DATA ALTER COLUMN ID_NOM_COME_REASON POSITION 15;

ALTER TABLE GUEST_DATA ALTER COLUMN EXTERNAL_DATA_LINK POSITION 16;

ALTER TABLE GUEST_DATA ALTER COLUMN RATING_AGE POSITION 17;

ALTER TABLE GUEST_DATA ALTER COLUMN ID_STAY_REASON POSITION 18;

ALTER TABLE GUEST_DATA ALTER COLUMN VISA POSITION 19;

ALTER TABLE GUEST_DATA ALTER COLUMN REGISTRATION_UPDATED_AT POSITION 20;

